/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 89;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 64,
  Feature_HasStdExtZicondBit = 65,
  Feature_HasStdExtZimopBit = 63,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZmmulBit = 22,
  Feature_HasStdExtMBit = 23,
  Feature_HasStdExtABit = 25,
  Feature_HasStdExtZtsoBit = 27,
  Feature_NotHasStdExtZtsoBit = 26,
  Feature_HasStdExtZabhaBit = 30,
  Feature_HasStdExtZacasBit = 29,
  Feature_NoStdExtZacasBit = 28,
  Feature_HasStdExtZalasrBit = 31,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 32,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtCOrZcaBit = 20,
  Feature_HasStdExtZbaBit = 38,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 35,
  Feature_NoStdExtZbbBit = 37,
  Feature_HasStdExtZbcBit = 40,
  Feature_HasStdExtZbsBit = 34,
  Feature_HasStdExtZbkbBit = 36,
  Feature_NoStdExtZbkbBit = 86,
  Feature_HasStdExtZbkxBit = 41,
  Feature_HasStdExtZbbOrZbkbBit = 33,
  Feature_HasStdExtZbcOrZbkcBit = 39,
  Feature_HasStdExtZkndBit = 42,
  Feature_HasStdExtZkneBit = 44,
  Feature_HasStdExtZkndOrZkneBit = 43,
  Feature_HasStdExtZknhBit = 45,
  Feature_HasStdExtZksedBit = 46,
  Feature_HasStdExtZkshBit = 47,
  Feature_HasStdExtZvkbBit = 55,
  Feature_HasStdExtZvbbBit = 54,
  Feature_HasStdExtZvbcBit = 59,
  Feature_HasStdExtZvkgBit = 56,
  Feature_HasStdExtZvknedBit = 57,
  Feature_HasStdExtZvknhaBit = 60,
  Feature_HasStdExtZvknhbBit = 61,
  Feature_HasStdExtZvksedBit = 62,
  Feature_HasStdExtZvkshBit = 58,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 50,
  Feature_HasVInstructionsAnyFBit = 49,
  Feature_HasVInstructionsF16MinimalBit = 52,
  Feature_HasVInstructionsF16Bit = 48,
  Feature_HasVInstructionsF64Bit = 53,
  Feature_HasVInstructionsFullMultiplyBit = 51,
  Feature_HasVendorXVentanaCondOpsBit = 66,
  Feature_HasVendorXTHeadBaBit = 67,
  Feature_HasVendorXTHeadBbBit = 68,
  Feature_HasVendorXTHeadBsBit = 69,
  Feature_HasVendorXTHeadCondMovBit = 70,
  Feature_HasVendorXTHeadFMemIdxBit = 75,
  Feature_HasVendorXTHeadMacBit = 71,
  Feature_HasVendorXTHeadMemIdxBit = 74,
  Feature_HasVendorXTHeadMemPairBit = 73,
  Feature_HasVendorXTHeadVdotBit = 72,
  Feature_HasVendorXSfvcpBit = 76,
  Feature_HasVendorXSfvqmaccdodBit = 77,
  Feature_HasVendorXSfvqmaccqoqBit = 78,
  Feature_HasVendorXSfvfnrclipxfqfBit = 79,
  Feature_HasVendorXCVbitmanipBit = 81,
  Feature_HasVendorXCVmacBit = 84,
  Feature_HasVendorXCVmemBit = 80,
  Feature_HasVendorXCValuBit = 82,
  Feature_HasVendorXCVbiBit = 83,
  Feature_UseCCMovInsnBit = 85,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 24,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 88,
  Feature_HwMode0Bit = 87,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtCOrZca())
    Features.set(Feature_HasStdExtCOrZcaBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9599,
  GICXXPred_MI_Predicate_anonymous_9601,
  GICXXPred_MI_Predicate_anonymous_9689,
  GICXXPred_MI_Predicate_anonymous_9703,
  GICXXPred_MI_Predicate_anonymous_9707,
  GICXXPred_MI_Predicate_anonymous_9709,
  GICXXPred_MI_Predicate_anonymous_9711,
  GICXXPred_MI_Predicate_anonymous_9713,
  GICXXPred_MI_Predicate_anonymous_9716,
  GICXXPred_MI_Predicate_anonymous_9718,
  GICXXPred_MI_Predicate_anonymous_9730,
  GICXXPred_MI_Predicate_anonymous_9741,
  GICXXPred_MI_Predicate_anonymous_10863,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9599: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9601: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9689: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9703: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9707: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9709: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9711: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9713: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9716: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9718: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_9730: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9741: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10863: {
     return hasAllHUsers(MI); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm9_lsb0,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb0,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(329), /*)*//*default:*//*Label 121*/ GIMT_Encode4(2331540),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1114),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(9751),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(12707),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15611),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(18345),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(21079),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(23858), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(26592),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(35876),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48413), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(63208), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(63269), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(63330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(63421), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(63788),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(63986),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(64184),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(64764),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(64974),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(65172),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(65211),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(65250),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(73712),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(74007), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(74302), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(81100),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(85986),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(88896), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(91806),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(94716),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(95628),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(98538),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(101448),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(104358),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(107268),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(110178), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     286 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(113088), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     306 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(113306),
     /*     310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2098693), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     322 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2100209), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     346 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2103330),
     /*     350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2106805),
     /*     354 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2107354),
     /*     358 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2111041),
     /*     362 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2114177),
     /*     366 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2117208), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     378 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2120147),
     /*     382 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2123087),
     /*     386 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2125997),
     /*     390 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2152660), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2160122), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2164514),
     /*     450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2167248),
     /*     454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2169982),
     /*     458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2172768),
     /*     462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2175554),
     /*     466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2178340), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(2181126),
     /*     514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(2183554),
     /*     518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(2185982),
     /*     522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(2188410), GIMT_Encode4(0),
     /*     530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(2205055), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(2207483),
     /*     582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(2209454),
     /*     586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(2209907),
     /*     590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(2211443),
     /*     594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(2216329),
     /*     598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(2221215),
     /*     602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(2226501), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     614 */ /*TargetOpcode::G_FABS*//*Label 69*/ GIMT_Encode4(2231787),
     /*     618 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 70*/ GIMT_Encode4(2233758), GIMT_Encode4(0),
     /*     626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 71*/ GIMT_Encode4(2239820),
     /*     630 */ /*TargetOpcode::G_FMINNUM*//*Label 72*/ GIMT_Encode4(2240010),
     /*     634 */ /*TargetOpcode::G_FMAXNUM*//*Label 73*/ GIMT_Encode4(2242095), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     646 */ /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(2244180),
     /*     650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(2244306), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     686 */ /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(2244432),
     /*     690 */ /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(2247208),
     /*     694 */ /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(2249984),
     /*     698 */ /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(2252760),
     /*     702 */ /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(2255536),
     /*     706 */ /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(2255694),
     /*     710 */ /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(2256274),
     /*     714 */ /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(2256484), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     758 */ /*TargetOpcode::G_CTTZ*//*Label 84*/ GIMT_Encode4(2256500), GIMT_Encode4(0),
     /*     766 */ /*TargetOpcode::G_CTLZ*//*Label 85*/ GIMT_Encode4(2259020), GIMT_Encode4(0),
     /*     774 */ /*TargetOpcode::G_CTPOP*//*Label 86*/ GIMT_Encode4(2261678),
     /*     778 */ /*TargetOpcode::G_BSWAP*//*Label 87*/ GIMT_Encode4(2264229),
     /*     782 */ /*TargetOpcode::G_BITREVERSE*//*Label 88*/ GIMT_Encode4(2266764),
     /*     786 */ /*TargetOpcode::G_FCEIL*//*Label 89*/ GIMT_Encode4(2269258), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     834 */ /*TargetOpcode::G_FSQRT*//*Label 90*/ GIMT_Encode4(2269456),
     /*     838 */ /*TargetOpcode::G_FFLOOR*//*Label 91*/ GIMT_Encode4(2271632),
     /*     842 */ /*TargetOpcode::G_FRINT*//*Label 92*/ GIMT_Encode4(2271830),
     /*     846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 93*/ GIMT_Encode4(2272028), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 94*/ GIMT_Encode4(2272226),
     /*     878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 95*/ GIMT_Encode4(2274654),
     /*     882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 96*/ GIMT_Encode4(2277082),
     /*     886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 97*/ GIMT_Encode4(2279510), GIMT_Encode4(0),
     /*     894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 98*/ GIMT_Encode4(2281938),
     /*     898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 99*/ GIMT_Encode4(2298583), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     934 */ /*TargetOpcode::G_TRAP*//*Label 100*/ GIMT_Encode4(2300759),
     /*     938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 101*/ GIMT_Encode4(2300772), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1034 */ /*RISCV::G_CLZW*//*Label 102*/ GIMT_Encode4(2300785),
     /*    1038 */ /*RISCV::G_CTZW*//*Label 103*/ GIMT_Encode4(2300880),
     /*    1042 */ /*RISCV::G_DIVUW*//*Label 104*/ GIMT_Encode4(2300910),
     /*    1046 */ /*RISCV::G_DIVW*//*Label 105*/ GIMT_Encode4(2300947),
     /*    1050 */ /*RISCV::G_FCLASS*//*Label 106*/ GIMT_Encode4(2300984),
     /*    1054 */ /*RISCV::G_FCVT_WU_RV64*//*Label 107*/ GIMT_Encode4(2301344),
     /*    1058 */ /*RISCV::G_FCVT_W_RV64*//*Label 108*/ GIMT_Encode4(2301542),
     /*    1062 */ /*RISCV::G_READ_VLENB*//*Label 109*/ GIMT_Encode4(2301740),
     /*    1066 */ /*RISCV::G_REMUW*//*Label 110*/ GIMT_Encode4(2301800),
     /*    1070 */ /*RISCV::G_ROLW*//*Label 111*/ GIMT_Encode4(2301837),
     /*    1074 */ /*RISCV::G_RORW*//*Label 112*/ GIMT_Encode4(2301962),
     /*    1078 */ /*RISCV::G_SLLW*//*Label 113*/ GIMT_Encode4(2302083), GIMT_Encode4(0),
     /*    1086 */ /*RISCV::G_SRAW*//*Label 114*/ GIMT_Encode4(2302130),
     /*    1090 */ /*RISCV::G_SRLW*//*Label 115*/ GIMT_Encode4(2302177),
     /*    1094 */ /*RISCV::G_VMCLR_VL*//*Label 116*/ GIMT_Encode4(2302224),
     /*    1098 */ /*RISCV::G_VMSET_VL*//*Label 117*/ GIMT_Encode4(2302873),
     /*    1102 */ /*RISCV::G_VMV_V_V_VL*//*Label 118*/ GIMT_Encode4(2303522),
     /*    1106 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 119*/ GIMT_Encode4(2307780),
     /*    1110 */ /*RISCV::G_VSLIDEUP_VL*//*Label 120*/ GIMT_Encode4(2319660),
     /*    1114 */ // Label 0: @1114
     /*    1114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 146*/ GIMT_Encode4(9750),
     /*    1125 */ /*GILLT_s32*//*Label 122*/ GIMT_Encode4(1249),
     /*    1129 */ /*GILLT_s64*//*Label 123*/ GIMT_Encode4(2734), GIMT_Encode4(0),
     /*    1137 */ /*GILLT_nxv1s8*//*Label 124*/ GIMT_Encode4(7220),
     /*    1141 */ /*GILLT_nxv1s16*//*Label 125*/ GIMT_Encode4(7335),
     /*    1145 */ /*GILLT_nxv1s32*//*Label 126*/ GIMT_Encode4(7450),
     /*    1149 */ /*GILLT_nxv1s64*//*Label 127*/ GIMT_Encode4(7565), GIMT_Encode4(0),
     /*    1157 */ /*GILLT_nxv2s8*//*Label 128*/ GIMT_Encode4(7680),
     /*    1161 */ /*GILLT_nxv2s16*//*Label 129*/ GIMT_Encode4(7795),
     /*    1165 */ /*GILLT_nxv2s32*//*Label 130*/ GIMT_Encode4(7910),
     /*    1169 */ /*GILLT_nxv2s64*//*Label 131*/ GIMT_Encode4(8025), GIMT_Encode4(0),
     /*    1177 */ /*GILLT_nxv4s8*//*Label 132*/ GIMT_Encode4(8140),
     /*    1181 */ /*GILLT_nxv4s16*//*Label 133*/ GIMT_Encode4(8255),
     /*    1185 */ /*GILLT_nxv4s32*//*Label 134*/ GIMT_Encode4(8370),
     /*    1189 */ /*GILLT_nxv4s64*//*Label 135*/ GIMT_Encode4(8485), GIMT_Encode4(0),
     /*    1197 */ /*GILLT_nxv8s8*//*Label 136*/ GIMT_Encode4(8600),
     /*    1201 */ /*GILLT_nxv8s16*//*Label 137*/ GIMT_Encode4(8715),
     /*    1205 */ /*GILLT_nxv8s32*//*Label 138*/ GIMT_Encode4(8830),
     /*    1209 */ /*GILLT_nxv8s64*//*Label 139*/ GIMT_Encode4(8945), GIMT_Encode4(0),
     /*    1217 */ /*GILLT_nxv16s8*//*Label 140*/ GIMT_Encode4(9060),
     /*    1221 */ /*GILLT_nxv16s16*//*Label 141*/ GIMT_Encode4(9175),
     /*    1225 */ /*GILLT_nxv16s32*//*Label 142*/ GIMT_Encode4(9290), GIMT_Encode4(0),
     /*    1233 */ /*GILLT_nxv32s8*//*Label 143*/ GIMT_Encode4(9405),
     /*    1237 */ /*GILLT_nxv32s16*//*Label 144*/ GIMT_Encode4(9520), GIMT_Encode4(0),
     /*    1245 */ /*GILLT_nxv64s8*//*Label 145*/ GIMT_Encode4(9635),
     /*    1249 */ // Label 122: @1249
     /*    1249 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2733),
     /*    1254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1260 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1308), // Rule ID 2428 //
     /*    1265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1272 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1276 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1295 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1306 */     GIR_RootConstrainSelectedInstOperands,
     /*    1307 */     // GIR_Coverage, 2428,
     /*    1307 */     GIR_EraseRootFromParent_Done,
     /*    1308 */   // Label 148: @1308
     /*    1308 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1356), // Rule ID 2438 //
     /*    1313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1320 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1324 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1343 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1354 */     GIR_RootConstrainSelectedInstOperands,
     /*    1355 */     // GIR_Coverage, 2438,
     /*    1355 */     GIR_EraseRootFromParent_Done,
     /*    1356 */   // Label 149: @1356
     /*    1356 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(1404), // Rule ID 2448 //
     /*    1361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1368 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1372 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1391 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1402 */     GIR_RootConstrainSelectedInstOperands,
     /*    1403 */     // GIR_Coverage, 2448,
     /*    1403 */     GIR_EraseRootFromParent_Done,
     /*    1404 */   // Label 150: @1404
     /*    1404 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(1455), // Rule ID 61843 //
     /*    1409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1416 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1439 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1453 */     GIR_RootConstrainSelectedInstOperands,
     /*    1454 */     // GIR_Coverage, 61843,
     /*    1454 */     GIR_EraseRootFromParent_Done,
     /*    1455 */   // Label 151: @1455
     /*    1455 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1506), // Rule ID 61847 //
     /*    1460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1467 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1471 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1490 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1504 */     GIR_RootConstrainSelectedInstOperands,
     /*    1505 */     // GIR_Coverage, 61847,
     /*    1505 */     GIR_EraseRootFromParent_Done,
     /*    1506 */   // Label 152: @1506
     /*    1506 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1557), // Rule ID 61851 //
     /*    1511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1518 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1522 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1541 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1548 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1555 */     GIR_RootConstrainSelectedInstOperands,
     /*    1556 */     // GIR_Coverage, 61851,
     /*    1556 */     GIR_EraseRootFromParent_Done,
     /*    1557 */   // Label 153: @1557
     /*    1557 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1605), // Rule ID 64100 //
     /*    1562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1569 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1577 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1592 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1603 */     GIR_RootConstrainSelectedInstOperands,
     /*    1604 */     // GIR_Coverage, 64100,
     /*    1604 */     GIR_EraseRootFromParent_Done,
     /*    1605 */   // Label 154: @1605
     /*    1605 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1653), // Rule ID 64108 //
     /*    1610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1617 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1625 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1640 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1651 */     GIR_RootConstrainSelectedInstOperands,
     /*    1652 */     // GIR_Coverage, 64108,
     /*    1652 */     GIR_EraseRootFromParent_Done,
     /*    1653 */   // Label 155: @1653
     /*    1653 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1701), // Rule ID 64116 //
     /*    1658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1665 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1673 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1688 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1699 */     GIR_RootConstrainSelectedInstOperands,
     /*    1700 */     // GIR_Coverage, 64116,
     /*    1700 */     GIR_EraseRootFromParent_Done,
     /*    1701 */   // Label 156: @1701
     /*    1701 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1752), // Rule ID 72654 //
     /*    1706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1713 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1721 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1736 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1750 */     GIR_RootConstrainSelectedInstOperands,
     /*    1751 */     // GIR_Coverage, 72654,
     /*    1751 */     GIR_EraseRootFromParent_Done,
     /*    1752 */   // Label 157: @1752
     /*    1752 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1803), // Rule ID 72658 //
     /*    1757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1764 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1772 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1787 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1801 */     GIR_RootConstrainSelectedInstOperands,
     /*    1802 */     // GIR_Coverage, 72658,
     /*    1802 */     GIR_EraseRootFromParent_Done,
     /*    1803 */   // Label 158: @1803
     /*    1803 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1854), // Rule ID 72662 //
     /*    1808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1838 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1852 */     GIR_RootConstrainSelectedInstOperands,
     /*    1853 */     // GIR_Coverage, 72662,
     /*    1853 */     GIR_EraseRootFromParent_Done,
     /*    1854 */   // Label 159: @1854
     /*    1854 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1922), // Rule ID 2422 //
     /*    1859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1866 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    1870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    1874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    1878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    1882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    1886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    1895 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    1899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    1909 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    1918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1920 */     GIR_RootConstrainSelectedInstOperands,
     /*    1921 */     // GIR_Coverage, 2422,
     /*    1921 */     GIR_EraseRootFromParent_Done,
     /*    1922 */   // Label 160: @1922
     /*    1922 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1990), // Rule ID 2432 //
     /*    1927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1934 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    1938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    1942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    1946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    1950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    1954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1959 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    1963 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    1967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    1977 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    1986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1988 */     GIR_RootConstrainSelectedInstOperands,
     /*    1989 */     // GIR_Coverage, 2432,
     /*    1989 */     GIR_EraseRootFromParent_Done,
     /*    1990 */   // Label 161: @1990
     /*    1990 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2058), // Rule ID 2442 //
     /*    1995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2031 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2045 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2056 */     GIR_RootConstrainSelectedInstOperands,
     /*    2057 */     // GIR_Coverage, 2442,
     /*    2057 */     GIR_EraseRootFromParent_Done,
     /*    2058 */   // Label 162: @2058
     /*    2058 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2126), // Rule ID 64096 //
     /*    2063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2070 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2078 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2103 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2113 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2124 */     GIR_RootConstrainSelectedInstOperands,
     /*    2125 */     // GIR_Coverage, 64096,
     /*    2125 */     GIR_EraseRootFromParent_Done,
     /*    2126 */   // Label 163: @2126
     /*    2126 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2194), // Rule ID 64104 //
     /*    2131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2138 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2146 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2171 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2175 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2181 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2192 */     GIR_RootConstrainSelectedInstOperands,
     /*    2193 */     // GIR_Coverage, 64104,
     /*    2193 */     GIR_EraseRootFromParent_Done,
     /*    2194 */   // Label 164: @2194
     /*    2194 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2262), // Rule ID 64112 //
     /*    2199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2206 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2214 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2239 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2249 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2260 */     GIR_RootConstrainSelectedInstOperands,
     /*    2261 */     // GIR_Coverage, 64112,
     /*    2261 */     GIR_EraseRootFromParent_Done,
     /*    2262 */   // Label 165: @2262
     /*    2262 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2341), // Rule ID 61837 //
     /*    2267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2274 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    2278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    2303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    2311 */     // MIs[2] Operand 1
     /*    2311 */     // No operand predicates
     /*    2311 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    2315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2325 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    2325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    2332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    2336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    2339 */     GIR_RootConstrainSelectedInstOperands,
     /*    2340 */     // GIR_Coverage, 61837,
     /*    2340 */     GIR_EraseRootFromParent_Done,
     /*    2341 */   // Label 166: @2341
     /*    2341 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2420), // Rule ID 72650 //
     /*    2346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2353 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    2357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2361 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    2365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    2390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    2398 */     // MIs[2] Operand 1
     /*    2398 */     // No operand predicates
     /*    2398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2404 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    2404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    2415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    2418 */     GIR_RootConstrainSelectedInstOperands,
     /*    2419 */     // GIR_Coverage, 72650,
     /*    2419 */     GIR_EraseRootFromParent_Done,
     /*    2420 */   // Label 167: @2420
     /*    2420 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2469), // Rule ID 115 //
     /*    2425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    2440 */     // MIs[1] Operand 1
     /*    2440 */     // No operand predicates
     /*    2440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    2444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    2452 */     // MIs[2] Operand 1
     /*    2452 */     // No operand predicates
     /*    2452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2454 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    2454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2459 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    2464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    2467 */     GIR_RootConstrainSelectedInstOperands,
     /*    2468 */     // GIR_Coverage, 115,
     /*    2468 */     GIR_EraseRootFromParent_Done,
     /*    2469 */   // Label 168: @2469
     /*    2469 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2511), // Rule ID 75 //
     /*    2474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    2497 */     // MIs[1] Operand 1
     /*    2497 */     // No operand predicates
     /*    2497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2499 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    2499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    2509 */     GIR_RootConstrainSelectedInstOperands,
     /*    2510 */     // GIR_Coverage, 75,
     /*    2510 */     GIR_EraseRootFromParent_Done,
     /*    2511 */   // Label 169: @2511
     /*    2511 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2583), // Rule ID 285 //
     /*    2516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    2539 */     // MIs[1] Operand 1
     /*    2539 */     // No operand predicates
     /*    2539 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9730),
     /*    2543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2545 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_9730>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    2545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    2548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    2557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    2561 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    2566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    2568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    2576 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    2581 */     GIR_RootConstrainSelectedInstOperands,
     /*    2582 */     // GIR_Coverage, 285,
     /*    2582 */     GIR_EraseRootFromParent_Done,
     /*    2583 */   // Label 170: @2583
     /*    2583 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2644), // Rule ID 72664 //
     /*    2588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    2591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    2603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2627 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    2630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    2632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    2634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    2642 */     GIR_RootConstrainSelectedInstOperands,
     /*    2643 */     // GIR_Coverage, 72664,
     /*    2643 */     GIR_EraseRootFromParent_Done,
     /*    2644 */   // Label 171: @2644
     /*    2644 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2705), // Rule ID 61905 //
     /*    2649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    2652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    2668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2688 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    2691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    2693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    2695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    2703 */     GIR_RootConstrainSelectedInstOperands,
     /*    2704 */     // GIR_Coverage, 61905,
     /*    2704 */     GIR_EraseRootFromParent_Done,
     /*    2705 */   // Label 172: @2705
     /*    2705 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2732), // Rule ID 73 //
     /*    2710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2725 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    2730 */     GIR_RootConstrainSelectedInstOperands,
     /*    2731 */     // GIR_Coverage, 73,
     /*    2731 */     GIR_Done,
     /*    2732 */   // Label 173: @2732
     /*    2732 */   GIM_Reject,
     /*    2733 */ // Label 147: @2733
     /*    2733 */ GIM_Reject,
     /*    2734 */ // Label 123: @2734
     /*    2734 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7219),
     /*    2739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    2742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    2745 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2840), // Rule ID 2472 //
     /*    2750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    2753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2757 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    2761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    2769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    2773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    2777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    2781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    2789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    2793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2798 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    2802 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    2813 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    2817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2827 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    2827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    2830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    2836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2838 */     GIR_RootConstrainSelectedInstOperands,
     /*    2839 */     // GIR_Coverage, 2472,
     /*    2839 */     GIR_EraseRootFromParent_Done,
     /*    2840 */   // Label 175: @2840
     /*    2840 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2935), // Rule ID 2474 //
     /*    2845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    2848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2852 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    2856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    2864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    2868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    2872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    2876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    2884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    2888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2893 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    2897 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    2908 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    2912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2922 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    2922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    2925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    2931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2933 */     GIR_RootConstrainSelectedInstOperands,
     /*    2934 */     // GIR_Coverage, 2474,
     /*    2934 */     GIR_EraseRootFromParent_Done,
     /*    2935 */   // Label 176: @2935
     /*    2935 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(3030), // Rule ID 2476 //
     /*    2940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    2943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2947 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    2951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    2959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    2963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    2967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    2971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    2979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    2983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
     /*    2992 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
     /*    3003 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    3007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3017 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3028 */     GIR_RootConstrainSelectedInstOperands,
     /*    3029 */     // GIR_Coverage, 2476,
     /*    3029 */     GIR_EraseRootFromParent_Done,
     /*    3030 */   // Label 177: @3030
     /*    3030 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(3125), // Rule ID 2463 //
     /*    3035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3042 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3083 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3094 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3098 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    3102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3112 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3123 */     GIR_RootConstrainSelectedInstOperands,
     /*    3124 */     // GIR_Coverage, 2463,
     /*    3124 */     GIR_EraseRootFromParent_Done,
     /*    3125 */   // Label 178: @3125
     /*    3125 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(3220), // Rule ID 2466 //
     /*    3130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3137 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    3141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3178 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3189 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    3193 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    3197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3207 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3218 */     GIR_RootConstrainSelectedInstOperands,
     /*    3219 */     // GIR_Coverage, 2466,
     /*    3219 */     GIR_EraseRootFromParent_Done,
     /*    3220 */   // Label 179: @3220
     /*    3220 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(3315), // Rule ID 2469 //
     /*    3225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3232 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3273 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    3288 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3302 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3313 */     GIR_RootConstrainSelectedInstOperands,
     /*    3314 */     // GIR_Coverage, 2469,
     /*    3314 */     GIR_EraseRootFromParent_Done,
     /*    3315 */   // Label 180: @3315
     /*    3315 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(3410), // Rule ID 64126 //
     /*    3320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3327 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    3331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3335 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    3339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3376 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3380 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3397 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3408 */     GIR_RootConstrainSelectedInstOperands,
     /*    3409 */     // GIR_Coverage, 64126,
     /*    3409 */     GIR_EraseRootFromParent_Done,
     /*    3410 */   // Label 181: @3410
     /*    3410 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3505), // Rule ID 64128 //
     /*    3415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3422 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    3426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3430 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    3434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3471 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3475 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3492 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3503 */     GIR_RootConstrainSelectedInstOperands,
     /*    3504 */     // GIR_Coverage, 64128,
     /*    3504 */     GIR_EraseRootFromParent_Done,
     /*    3505 */   // Label 182: @3505
     /*    3505 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3600), // Rule ID 64130 //
     /*    3510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3517 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    3521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3525 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    3529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
     /*    3570 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
     /*    3581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3587 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3598 */     GIR_RootConstrainSelectedInstOperands,
     /*    3599 */     // GIR_Coverage, 64130,
     /*    3599 */     GIR_EraseRootFromParent_Done,
     /*    3600 */   // Label 183: @3600
     /*    3600 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3695), // Rule ID 64120 //
     /*    3605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3612 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    3616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3620 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    3624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3661 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3682 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3693 */     GIR_RootConstrainSelectedInstOperands,
     /*    3694 */     // GIR_Coverage, 64120,
     /*    3694 */     GIR_EraseRootFromParent_Done,
     /*    3695 */   // Label 184: @3695
     /*    3695 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3790), // Rule ID 64122 //
     /*    3700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3707 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    3711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3715 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    3719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3756 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3767 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    3771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3777 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3788 */     GIR_RootConstrainSelectedInstOperands,
     /*    3789 */     // GIR_Coverage, 64122,
     /*    3789 */     GIR_EraseRootFromParent_Done,
     /*    3790 */   // Label 185: @3790
     /*    3790 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3885), // Rule ID 64124 //
     /*    3795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3802 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    3806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3810 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    3814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3851 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    3866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3872 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3883 */     GIR_RootConstrainSelectedInstOperands,
     /*    3884 */     // GIR_Coverage, 64124,
     /*    3884 */     GIR_EraseRootFromParent_Done,
     /*    3885 */   // Label 186: @3885
     /*    3885 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3933), // Rule ID 2427 //
     /*    3890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    3893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3897 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    3901 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    3920 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    3923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    3929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3931 */     GIR_RootConstrainSelectedInstOperands,
     /*    3932 */     // GIR_Coverage, 2427,
     /*    3932 */     GIR_EraseRootFromParent_Done,
     /*    3933 */   // Label 187: @3933
     /*    3933 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3981), // Rule ID 2437 //
     /*    3938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    3941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3945 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    3949 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    3953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    3968 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    3971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    3977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3979 */     GIR_RootConstrainSelectedInstOperands,
     /*    3980 */     // GIR_Coverage, 2437,
     /*    3980 */     GIR_EraseRootFromParent_Done,
     /*    3981 */   // Label 188: @3981
     /*    3981 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4029), // Rule ID 2447 //
     /*    3986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    3989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3993 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    3997 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    4001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4016 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    4019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4027 */     GIR_RootConstrainSelectedInstOperands,
     /*    4028 */     // GIR_Coverage, 2447,
     /*    4028 */     GIR_EraseRootFromParent_Done,
     /*    4029 */   // Label 189: @4029
     /*    4029 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(4077), // Rule ID 2478 //
     /*    4034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4041 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    4045 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    4049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    4064 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4075 */     GIR_RootConstrainSelectedInstOperands,
     /*    4076 */     // GIR_Coverage, 2478,
     /*    4076 */     GIR_EraseRootFromParent_Done,
     /*    4077 */   // Label 190: @4077
     /*    4077 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(4125), // Rule ID 2480 //
     /*    4082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    4093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    4097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    4112 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4123 */     GIR_RootConstrainSelectedInstOperands,
     /*    4124 */     // GIR_Coverage, 2480,
     /*    4124 */     GIR_EraseRootFromParent_Done,
     /*    4125 */   // Label 191: @4125
     /*    4125 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(4173), // Rule ID 2482 //
     /*    4130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4137 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4141 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    4160 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4171 */     GIR_RootConstrainSelectedInstOperands,
     /*    4172 */     // GIR_Coverage, 2482,
     /*    4172 */     GIR_EraseRootFromParent_Done,
     /*    4173 */   // Label 192: @4173
     /*    4173 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(4224), // Rule ID 61842 //
     /*    4178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4185 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    4189 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    4193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4208 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    4208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    4222 */     GIR_RootConstrainSelectedInstOperands,
     /*    4223 */     // GIR_Coverage, 61842,
     /*    4223 */     GIR_EraseRootFromParent_Done,
     /*    4224 */   // Label 193: @4224
     /*    4224 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(4275), // Rule ID 61846 //
     /*    4229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4236 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    4240 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    4244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4259 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    4259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    4273 */     GIR_RootConstrainSelectedInstOperands,
     /*    4274 */     // GIR_Coverage, 61846,
     /*    4274 */     GIR_EraseRootFromParent_Done,
     /*    4275 */   // Label 194: @4275
     /*    4275 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(4326), // Rule ID 61850 //
     /*    4280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4287 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    4291 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    4295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4310 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    4310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    4324 */     GIR_RootConstrainSelectedInstOperands,
     /*    4325 */     // GIR_Coverage, 61850,
     /*    4325 */     GIR_EraseRootFromParent_Done,
     /*    4326 */   // Label 195: @4326
     /*    4326 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(4374), // Rule ID 64099 //
     /*    4331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4338 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    4342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4346 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    4350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4361 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    4364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4372 */     GIR_RootConstrainSelectedInstOperands,
     /*    4373 */     // GIR_Coverage, 64099,
     /*    4373 */     GIR_EraseRootFromParent_Done,
     /*    4374 */   // Label 196: @4374
     /*    4374 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4422), // Rule ID 64107 //
     /*    4379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4386 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    4390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4394 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    4398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4409 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    4412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4420 */     GIR_RootConstrainSelectedInstOperands,
     /*    4421 */     // GIR_Coverage, 64107,
     /*    4421 */     GIR_EraseRootFromParent_Done,
     /*    4422 */   // Label 197: @4422
     /*    4422 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4470), // Rule ID 64115 //
     /*    4427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4434 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    4438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4442 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    4446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4457 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    4460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4468 */     GIR_RootConstrainSelectedInstOperands,
     /*    4469 */     // GIR_Coverage, 64115,
     /*    4469 */     GIR_EraseRootFromParent_Done,
     /*    4470 */   // Label 198: @4470
     /*    4470 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4518), // Rule ID 64132 //
     /*    4475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4482 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    4486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4490 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    4494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    4505 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4516 */     GIR_RootConstrainSelectedInstOperands,
     /*    4517 */     // GIR_Coverage, 64132,
     /*    4517 */     GIR_EraseRootFromParent_Done,
     /*    4518 */   // Label 199: @4518
     /*    4518 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4566), // Rule ID 64134 //
     /*    4523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4530 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    4534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    4542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    4553 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4564 */     GIR_RootConstrainSelectedInstOperands,
     /*    4565 */     // GIR_Coverage, 64134,
     /*    4565 */     GIR_EraseRootFromParent_Done,
     /*    4566 */   // Label 200: @4566
     /*    4566 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4614), // Rule ID 64136 //
     /*    4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4578 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4586 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    4590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    4601 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4612 */     GIR_RootConstrainSelectedInstOperands,
     /*    4613 */     // GIR_Coverage, 64136,
     /*    4613 */     GIR_EraseRootFromParent_Done,
     /*    4614 */   // Label 201: @4614
     /*    4614 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4665), // Rule ID 72653 //
     /*    4619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4626 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    4630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4634 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    4638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4649 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    4649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    4663 */     GIR_RootConstrainSelectedInstOperands,
     /*    4664 */     // GIR_Coverage, 72653,
     /*    4664 */     GIR_EraseRootFromParent_Done,
     /*    4665 */   // Label 202: @4665
     /*    4665 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4716), // Rule ID 72657 //
     /*    4670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4677 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    4681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4685 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    4689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4700 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    4700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    4714 */     GIR_RootConstrainSelectedInstOperands,
     /*    4715 */     // GIR_Coverage, 72657,
     /*    4715 */     GIR_EraseRootFromParent_Done,
     /*    4716 */   // Label 203: @4716
     /*    4716 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4767), // Rule ID 72661 //
     /*    4721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4728 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    4732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4736 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    4740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4751 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    4751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    4765 */     GIR_RootConstrainSelectedInstOperands,
     /*    4766 */     // GIR_Coverage, 72661,
     /*    4766 */     GIR_EraseRootFromParent_Done,
     /*    4767 */   // Label 204: @4767
     /*    4767 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4842), // Rule ID 2460 //
     /*    4772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4779 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    4783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4804 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    4819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    4829 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    4838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4840 */     GIR_RootConstrainSelectedInstOperands,
     /*    4841 */     // GIR_Coverage, 2460,
     /*    4841 */     GIR_EraseRootFromParent_Done,
     /*    4842 */   // Label 205: @4842
     /*    4842 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4937), // Rule ID 2484 //
     /*    4847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4854 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    4858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4879 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    4890 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    4894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    4904 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    4904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    4907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    4911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    4916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    4920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    4923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    4925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    4928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    4933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4935 */     GIR_RootConstrainSelectedInstOperands,
     /*    4936 */     // GIR_Coverage, 2484,
     /*    4936 */     GIR_EraseRootFromParent_Done,
     /*    4937 */   // Label 206: @4937
     /*    4937 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5032), // Rule ID 2486 //
     /*    4942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4949 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4974 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    4985 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    4999 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    4999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5030 */     GIR_RootConstrainSelectedInstOperands,
     /*    5031 */     // GIR_Coverage, 2486,
     /*    5031 */     GIR_EraseRootFromParent_Done,
     /*    5032 */   // Label 207: @5032
     /*    5032 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5127), // Rule ID 2488 //
     /*    5037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5044 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5069 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    5080 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5094 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    5113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5125 */     GIR_RootConstrainSelectedInstOperands,
     /*    5126 */     // GIR_Coverage, 2488,
     /*    5126 */     GIR_EraseRootFromParent_Done,
     /*    5127 */   // Label 208: @5127
     /*    5127 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5222), // Rule ID 2490 //
     /*    5132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5139 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    5143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5164 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    5175 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    5179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5189 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    5208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5220 */     GIR_RootConstrainSelectedInstOperands,
     /*    5221 */     // GIR_Coverage, 2490,
     /*    5221 */     GIR_EraseRootFromParent_Done,
     /*    5222 */   // Label 209: @5222
     /*    5222 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5317), // Rule ID 2492 //
     /*    5227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5234 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    5238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5259 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    5270 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    5274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5284 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5315 */     GIR_RootConstrainSelectedInstOperands,
     /*    5316 */     // GIR_Coverage, 2492,
     /*    5316 */     GIR_EraseRootFromParent_Done,
     /*    5317 */   // Label 210: @5317
     /*    5317 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5412), // Rule ID 2494 //
     /*    5322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5329 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    5333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5354 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    5365 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    5369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5379 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    5398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5410 */     GIR_RootConstrainSelectedInstOperands,
     /*    5411 */     // GIR_Coverage, 2494,
     /*    5411 */     GIR_EraseRootFromParent_Done,
     /*    5412 */   // Label 211: @5412
     /*    5412 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5480), // Rule ID 2421 //
     /*    5417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5424 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    5428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5453 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    5457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5467 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5478 */     GIR_RootConstrainSelectedInstOperands,
     /*    5479 */     // GIR_Coverage, 2421,
     /*    5479 */     GIR_EraseRootFromParent_Done,
     /*    5480 */   // Label 212: @5480
     /*    5480 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5548), // Rule ID 2431 //
     /*    5485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5492 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    5496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5517 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5521 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    5525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5535 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5546 */     GIR_RootConstrainSelectedInstOperands,
     /*    5547 */     // GIR_Coverage, 2431,
     /*    5547 */     GIR_EraseRootFromParent_Done,
     /*    5548 */   // Label 213: @5548
     /*    5548 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5616), // Rule ID 2441 //
     /*    5553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5560 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    5564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5585 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5589 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    5593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5603 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5614 */     GIR_RootConstrainSelectedInstOperands,
     /*    5615 */     // GIR_Coverage, 2441,
     /*    5615 */     GIR_EraseRootFromParent_Done,
     /*    5616 */   // Label 214: @5616
     /*    5616 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5691), // Rule ID 64118 //
     /*    5621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5628 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    5632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5636 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    5640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5661 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5678 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    5681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5689 */     GIR_RootConstrainSelectedInstOperands,
     /*    5690 */     // GIR_Coverage, 64118,
     /*    5690 */     GIR_EraseRootFromParent_Done,
     /*    5691 */   // Label 215: @5691
     /*    5691 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5786), // Rule ID 64138 //
     /*    5696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5703 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    5707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5711 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    5715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5736 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    5747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5753 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    5772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5784 */     GIR_RootConstrainSelectedInstOperands,
     /*    5785 */     // GIR_Coverage, 64138,
     /*    5785 */     GIR_EraseRootFromParent_Done,
     /*    5786 */   // Label 216: @5786
     /*    5786 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5881), // Rule ID 64140 //
     /*    5791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5798 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5806 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5831 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    5842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5848 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5879 */     GIR_RootConstrainSelectedInstOperands,
     /*    5880 */     // GIR_Coverage, 64140,
     /*    5880 */     GIR_EraseRootFromParent_Done,
     /*    5881 */   // Label 217: @5881
     /*    5881 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5976), // Rule ID 64142 //
     /*    5886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5893 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    5897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5901 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    5905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5926 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    5937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5943 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    5962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5974 */     GIR_RootConstrainSelectedInstOperands,
     /*    5975 */     // GIR_Coverage, 64142,
     /*    5975 */     GIR_EraseRootFromParent_Done,
     /*    5976 */   // Label 218: @5976
     /*    5976 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6071), // Rule ID 64144 //
     /*    5981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5988 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    5992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5996 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    6000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6021 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    6032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6038 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    6057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6069 */     GIR_RootConstrainSelectedInstOperands,
     /*    6070 */     // GIR_Coverage, 64144,
     /*    6070 */     GIR_EraseRootFromParent_Done,
     /*    6071 */   // Label 219: @6071
     /*    6071 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6166), // Rule ID 64146 //
     /*    6076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6083 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    6087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6091 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    6095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6116 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    6127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6133 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    6152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6164 */     GIR_RootConstrainSelectedInstOperands,
     /*    6165 */     // GIR_Coverage, 64146,
     /*    6165 */     GIR_EraseRootFromParent_Done,
     /*    6166 */   // Label 220: @6166
     /*    6166 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6261), // Rule ID 64148 //
     /*    6171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6178 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    6182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6186 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    6190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    6222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6228 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    6247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6259 */     GIR_RootConstrainSelectedInstOperands,
     /*    6260 */     // GIR_Coverage, 64148,
     /*    6260 */     GIR_EraseRootFromParent_Done,
     /*    6261 */   // Label 221: @6261
     /*    6261 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6329), // Rule ID 64095 //
     /*    6266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6273 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    6277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6281 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    6285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6306 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    6310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6316 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6327 */     GIR_RootConstrainSelectedInstOperands,
     /*    6328 */     // GIR_Coverage, 64095,
     /*    6328 */     GIR_EraseRootFromParent_Done,
     /*    6329 */   // Label 222: @6329
     /*    6329 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6397), // Rule ID 64103 //
     /*    6334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6341 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    6345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6349 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    6353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    6378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6384 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6395 */     GIR_RootConstrainSelectedInstOperands,
     /*    6396 */     // GIR_Coverage, 64103,
     /*    6396 */     GIR_EraseRootFromParent_Done,
     /*    6397 */   // Label 223: @6397
     /*    6397 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6465), // Rule ID 64111 //
     /*    6402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6409 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    6413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6417 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    6421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    6446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6452 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6463 */     GIR_RootConstrainSelectedInstOperands,
     /*    6464 */     // GIR_Coverage, 64111,
     /*    6464 */     GIR_EraseRootFromParent_Done,
     /*    6465 */   // Label 224: @6465
     /*    6465 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6544), // Rule ID 61836 //
     /*    6470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6477 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    6481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    6506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    6514 */     // MIs[2] Operand 1
     /*    6514 */     // No operand predicates
     /*    6514 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    6518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6528 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*    6528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    6539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    6542 */     GIR_RootConstrainSelectedInstOperands,
     /*    6543 */     // GIR_Coverage, 61836,
     /*    6543 */     GIR_EraseRootFromParent_Done,
     /*    6544 */   // Label 225: @6544
     /*    6544 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6623), // Rule ID 72649 //
     /*    6549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    6560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6564 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    6568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    6593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    6601 */     // MIs[2] Operand 1
     /*    6601 */     // No operand predicates
     /*    6601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6607 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*    6607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    6618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    6621 */     GIR_RootConstrainSelectedInstOperands,
     /*    6622 */     // GIR_Coverage, 72649,
     /*    6622 */     GIR_EraseRootFromParent_Done,
     /*    6623 */   // Label 226: @6623
     /*    6623 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6672), // Rule ID 114 //
     /*    6628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    6631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    6643 */     // MIs[1] Operand 1
     /*    6643 */     // No operand predicates
     /*    6643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    6647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6651 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    6655 */     // MIs[2] Operand 1
     /*    6655 */     // No operand predicates
     /*    6655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6657 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*    6657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    6660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6662 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    6667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    6670 */     GIR_RootConstrainSelectedInstOperands,
     /*    6671 */     // GIR_Coverage, 114,
     /*    6671 */     GIR_EraseRootFromParent_Done,
     /*    6672 */   // Label 227: @6672
     /*    6672 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6718), // Rule ID 265 //
     /*    6677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    6680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    6700 */     // MIs[1] Operand 1
     /*    6700 */     // No operand predicates
     /*    6700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9703),
     /*    6704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6706 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_9703>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*    6706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    6716 */     GIR_RootConstrainSelectedInstOperands,
     /*    6717 */     // GIR_Coverage, 265,
     /*    6717 */     GIR_EraseRootFromParent_Done,
     /*    6718 */   // Label 228: @6718
     /*    6718 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6794), // Rule ID 286 //
     /*    6723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    6726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    6746 */     // MIs[1] Operand 1
     /*    6746 */     // No operand predicates
     /*    6746 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9730),
     /*    6750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9703),
     /*    6754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6756 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_9730>>:$rs2)<<P:Predicate_anonymous_9703>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*    6756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    6772 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    6777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6787 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    6792 */     GIR_RootConstrainSelectedInstOperands,
     /*    6793 */     // GIR_Coverage, 286,
     /*    6793 */     GIR_EraseRootFromParent_Done,
     /*    6794 */   // Label 229: @6794
     /*    6794 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6859), // Rule ID 72665 //
     /*    6799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*    6802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    6814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9703),
     /*    6840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6842 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_9703>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*    6845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    6847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    6849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    6857 */     GIR_RootConstrainSelectedInstOperands,
     /*    6858 */     // GIR_Coverage, 72665,
     /*    6858 */     GIR_EraseRootFromParent_Done,
     /*    6859 */   // Label 230: @6859
     /*    6859 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6924), // Rule ID 61908 //
     /*    6864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*    6867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    6883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9703),
     /*    6905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6907 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_9703>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*    6910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    6912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    6914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    6922 */     GIR_RootConstrainSelectedInstOperands,
     /*    6923 */     // GIR_Coverage, 61908,
     /*    6923 */     GIR_EraseRootFromParent_Done,
     /*    6924 */   // Label 231: @6924
     /*    6924 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6966), // Rule ID 74 //
     /*    6929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    6932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    6952 */     // MIs[1] Operand 1
     /*    6952 */     // No operand predicates
     /*    6952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6954 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*    6954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    6957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    6964 */     GIR_RootConstrainSelectedInstOperands,
     /*    6965 */     // GIR_Coverage, 74,
     /*    6965 */     GIR_EraseRootFromParent_Done,
     /*    6966 */   // Label 232: @6966
     /*    6966 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7038), // Rule ID 284 //
     /*    6971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    6974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    6994 */     // MIs[1] Operand 1
     /*    6994 */     // No operand predicates
     /*    6994 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9730),
     /*    6998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7000 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_9730>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*    7000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    7007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    7016 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    7021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    7026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7031 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    7036 */     GIR_RootConstrainSelectedInstOperands,
     /*    7037 */     // GIR_Coverage, 284,
     /*    7037 */     GIR_EraseRootFromParent_Done,
     /*    7038 */   // Label 233: @7038
     /*    7038 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7099), // Rule ID 72663 //
     /*    7043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*    7046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7082 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    7085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    7087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    7089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    7097 */     GIR_RootConstrainSelectedInstOperands,
     /*    7098 */     // GIR_Coverage, 72663,
     /*    7098 */     GIR_EraseRootFromParent_Done,
     /*    7099 */   // Label 234: @7099
     /*    7099 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7160), // Rule ID 61904 //
     /*    7104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*    7107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7143 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    7146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    7148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    7150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    7158 */     GIR_RootConstrainSelectedInstOperands,
     /*    7159 */     // GIR_Coverage, 61904,
     /*    7159 */     GIR_EraseRootFromParent_Done,
     /*    7160 */   // Label 235: @7160
     /*    7160 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7191), // Rule ID 264 //
     /*    7165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    7168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9703),
     /*    7184 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_9703>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*    7189 */     GIR_RootConstrainSelectedInstOperands,
     /*    7190 */     // GIR_Coverage, 264,
     /*    7190 */     GIR_Done,
     /*    7191 */   // Label 236: @7191
     /*    7191 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7218), // Rule ID 72 //
     /*    7196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    7199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7211 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    7216 */     GIR_RootConstrainSelectedInstOperands,
     /*    7217 */     // GIR_Coverage, 72,
     /*    7217 */     GIR_Done,
     /*    7218 */   // Label 237: @7218
     /*    7218 */   GIM_Reject,
     /*    7219 */ // Label 174: @7219
     /*    7219 */ GIM_Reject,
     /*    7220 */ // Label 124: @7220
     /*    7220 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7334),
     /*    7225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7243 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7288), // Rule ID 45428 //
     /*    7248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7251 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    7251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*    7254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*    7268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7286 */     GIR_RootConstrainSelectedInstOperands,
     /*    7287 */     // GIR_Coverage, 45428,
     /*    7287 */     GIR_EraseRootFromParent_Done,
     /*    7288 */   // Label 239: @7288
     /*    7288 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7333), // Rule ID 45429 //
     /*    7293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7296 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    7296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*    7299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*    7313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7331 */     GIR_RootConstrainSelectedInstOperands,
     /*    7332 */     // GIR_Coverage, 45429,
     /*    7332 */     GIR_EraseRootFromParent_Done,
     /*    7333 */   // Label 240: @7333
     /*    7333 */   GIM_Reject,
     /*    7334 */ // Label 238: @7334
     /*    7334 */ GIM_Reject,
     /*    7335 */ // Label 125: @7335
     /*    7335 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7449),
     /*    7340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    7343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    7346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7358 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(7403), // Rule ID 45784 //
     /*    7363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7366 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    7366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    7369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*    7383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    7398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7401 */     GIR_RootConstrainSelectedInstOperands,
     /*    7402 */     // GIR_Coverage, 45784,
     /*    7402 */     GIR_EraseRootFromParent_Done,
     /*    7403 */   // Label 242: @7403
     /*    7403 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(7448), // Rule ID 45785 //
     /*    7408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7411 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    7411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    7414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*    7428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    7443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7446 */     GIR_RootConstrainSelectedInstOperands,
     /*    7447 */     // GIR_Coverage, 45785,
     /*    7447 */     GIR_EraseRootFromParent_Done,
     /*    7448 */   // Label 243: @7448
     /*    7448 */   GIM_Reject,
     /*    7449 */ // Label 241: @7449
     /*    7449 */ GIM_Reject,
     /*    7450 */ // Label 126: @7450
     /*    7450 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7564),
     /*    7455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*    7458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*    7461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7473 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7518), // Rule ID 45792 //
     /*    7478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7481 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*    7481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*    7484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    7513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7516 */     GIR_RootConstrainSelectedInstOperands,
     /*    7517 */     // GIR_Coverage, 45792,
     /*    7517 */     GIR_EraseRootFromParent_Done,
     /*    7518 */   // Label 245: @7518
     /*    7518 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7563), // Rule ID 45793 //
     /*    7523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7526 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*    7526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*    7529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    7543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    7558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7561 */     GIR_RootConstrainSelectedInstOperands,
     /*    7562 */     // GIR_Coverage, 45793,
     /*    7562 */     GIR_EraseRootFromParent_Done,
     /*    7563 */   // Label 246: @7563
     /*    7563 */   GIM_Reject,
     /*    7564 */ // Label 244: @7564
     /*    7564 */ GIM_Reject,
     /*    7565 */ // Label 127: @7565
     /*    7565 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7679),
     /*    7570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*    7573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*    7576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7588 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7633), // Rule ID 45808 //
     /*    7593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*    7596 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*    7596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*    7599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    7613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    7628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7631 */     GIR_RootConstrainSelectedInstOperands,
     /*    7632 */     // GIR_Coverage, 45808,
     /*    7632 */     GIR_EraseRootFromParent_Done,
     /*    7633 */   // Label 248: @7633
     /*    7633 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7678), // Rule ID 45809 //
     /*    7638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*    7641 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*    7641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*    7644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    7658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    7673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7676 */     GIR_RootConstrainSelectedInstOperands,
     /*    7677 */     // GIR_Coverage, 45809,
     /*    7677 */     GIR_EraseRootFromParent_Done,
     /*    7678 */   // Label 249: @7678
     /*    7678 */   GIM_Reject,
     /*    7679 */ // Label 247: @7679
     /*    7679 */ GIM_Reject,
     /*    7680 */ // Label 128: @7680
     /*    7680 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7794),
     /*    7685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*    7688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*    7691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7703 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7748), // Rule ID 45776 //
     /*    7708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7711 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    7711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*    7714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*    7728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7746 */     GIR_RootConstrainSelectedInstOperands,
     /*    7747 */     // GIR_Coverage, 45776,
     /*    7747 */     GIR_EraseRootFromParent_Done,
     /*    7748 */   // Label 251: @7748
     /*    7748 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7793), // Rule ID 45777 //
     /*    7753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7756 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    7756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*    7759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*    7773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7791 */     GIR_RootConstrainSelectedInstOperands,
     /*    7792 */     // GIR_Coverage, 45777,
     /*    7792 */     GIR_EraseRootFromParent_Done,
     /*    7793 */   // Label 252: @7793
     /*    7793 */   GIM_Reject,
     /*    7794 */ // Label 250: @7794
     /*    7794 */ GIM_Reject,
     /*    7795 */ // Label 129: @7795
     /*    7795 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7909),
     /*    7800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*    7803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*    7806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7818 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7863), // Rule ID 45788 //
     /*    7823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7826 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    7826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*    7829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    7843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    7858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7861 */     GIR_RootConstrainSelectedInstOperands,
     /*    7862 */     // GIR_Coverage, 45788,
     /*    7862 */     GIR_EraseRootFromParent_Done,
     /*    7863 */   // Label 254: @7863
     /*    7863 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(7908), // Rule ID 45789 //
     /*    7868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7871 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    7871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*    7874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    7888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    7903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7906 */     GIR_RootConstrainSelectedInstOperands,
     /*    7907 */     // GIR_Coverage, 45789,
     /*    7907 */     GIR_EraseRootFromParent_Done,
     /*    7908 */   // Label 255: @7908
     /*    7908 */   GIM_Reject,
     /*    7909 */ // Label 253: @7909
     /*    7909 */ GIM_Reject,
     /*    7910 */ // Label 130: @7910
     /*    7910 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8024),
     /*    7915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*    7918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*    7921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7933 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(7978), // Rule ID 45804 //
     /*    7938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7941 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*    7941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*    7944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    7958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    7973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7976 */     GIR_RootConstrainSelectedInstOperands,
     /*    7977 */     // GIR_Coverage, 45804,
     /*    7977 */     GIR_EraseRootFromParent_Done,
     /*    7978 */   // Label 257: @7978
     /*    7978 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8023), // Rule ID 45805 //
     /*    7983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7986 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*    7986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*    7989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    8003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    8018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8021 */     GIR_RootConstrainSelectedInstOperands,
     /*    8022 */     // GIR_Coverage, 45805,
     /*    8022 */     GIR_EraseRootFromParent_Done,
     /*    8023 */   // Label 258: @8023
     /*    8023 */   GIM_Reject,
     /*    8024 */ // Label 256: @8024
     /*    8024 */ GIM_Reject,
     /*    8025 */ // Label 131: @8025
     /*    8025 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8139),
     /*    8030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*    8033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*    8036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8048 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8093), // Rule ID 45848 //
     /*    8053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*    8056 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*    8056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*    8059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    8088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8091 */     GIR_RootConstrainSelectedInstOperands,
     /*    8092 */     // GIR_Coverage, 45848,
     /*    8092 */     GIR_EraseRootFromParent_Done,
     /*    8093 */   // Label 260: @8093
     /*    8093 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8138), // Rule ID 45849 //
     /*    8098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*    8101 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*    8101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*    8104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    8133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8136 */     GIR_RootConstrainSelectedInstOperands,
     /*    8137 */     // GIR_Coverage, 45849,
     /*    8137 */     GIR_EraseRootFromParent_Done,
     /*    8138 */   // Label 261: @8138
     /*    8138 */   GIM_Reject,
     /*    8139 */ // Label 259: @8139
     /*    8139 */ GIM_Reject,
     /*    8140 */ // Label 132: @8140
     /*    8140 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8254),
     /*    8145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*    8148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*    8151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8163 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8208), // Rule ID 45780 //
     /*    8168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8171 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    8171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*    8174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    8188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8206 */     GIR_RootConstrainSelectedInstOperands,
     /*    8207 */     // GIR_Coverage, 45780,
     /*    8207 */     GIR_EraseRootFromParent_Done,
     /*    8208 */   // Label 263: @8208
     /*    8208 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8253), // Rule ID 45781 //
     /*    8213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8216 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    8216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*    8219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*    8233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8251 */     GIR_RootConstrainSelectedInstOperands,
     /*    8252 */     // GIR_Coverage, 45781,
     /*    8252 */     GIR_EraseRootFromParent_Done,
     /*    8253 */   // Label 264: @8253
     /*    8253 */   GIM_Reject,
     /*    8254 */ // Label 262: @8254
     /*    8254 */ GIM_Reject,
     /*    8255 */ // Label 133: @8255
     /*    8255 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8369),
     /*    8260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*    8263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*    8266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8278 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8323), // Rule ID 45800 //
     /*    8283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8286 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    8286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*    8289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    8303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    8318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8321 */     GIR_RootConstrainSelectedInstOperands,
     /*    8322 */     // GIR_Coverage, 45800,
     /*    8322 */     GIR_EraseRootFromParent_Done,
     /*    8323 */   // Label 266: @8323
     /*    8323 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(8368), // Rule ID 45801 //
     /*    8328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8331 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    8331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*    8334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    8348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    8363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8366 */     GIR_RootConstrainSelectedInstOperands,
     /*    8367 */     // GIR_Coverage, 45801,
     /*    8367 */     GIR_EraseRootFromParent_Done,
     /*    8368 */   // Label 267: @8368
     /*    8368 */   GIM_Reject,
     /*    8369 */ // Label 265: @8369
     /*    8369 */ GIM_Reject,
     /*    8370 */ // Label 134: @8370
     /*    8370 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(8484),
     /*    8375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*    8378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*    8381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8393 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(8438), // Rule ID 45836 //
     /*    8398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8401 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*    8401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*    8404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    8433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8436 */     GIR_RootConstrainSelectedInstOperands,
     /*    8437 */     // GIR_Coverage, 45836,
     /*    8437 */     GIR_EraseRootFromParent_Done,
     /*    8438 */   // Label 269: @8438
     /*    8438 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(8483), // Rule ID 45837 //
     /*    8443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8446 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*    8446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*    8449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    8478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8481 */     GIR_RootConstrainSelectedInstOperands,
     /*    8482 */     // GIR_Coverage, 45837,
     /*    8482 */     GIR_EraseRootFromParent_Done,
     /*    8483 */   // Label 270: @8483
     /*    8483 */   GIM_Reject,
     /*    8484 */ // Label 268: @8484
     /*    8484 */ GIM_Reject,
     /*    8485 */ // Label 135: @8485
     /*    8485 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(8599),
     /*    8490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*    8493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*    8496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8508 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(8553), // Rule ID 45852 //
     /*    8513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*    8516 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*    8516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*    8519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    8533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    8548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8551 */     GIR_RootConstrainSelectedInstOperands,
     /*    8552 */     // GIR_Coverage, 45852,
     /*    8552 */     GIR_EraseRootFromParent_Done,
     /*    8553 */   // Label 272: @8553
     /*    8553 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(8598), // Rule ID 45853 //
     /*    8558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*    8561 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*    8561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*    8564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    8578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    8593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8596 */     GIR_RootConstrainSelectedInstOperands,
     /*    8597 */     // GIR_Coverage, 45853,
     /*    8597 */     GIR_EraseRootFromParent_Done,
     /*    8598 */   // Label 273: @8598
     /*    8598 */   GIM_Reject,
     /*    8599 */ // Label 271: @8599
     /*    8599 */ GIM_Reject,
     /*    8600 */ // Label 136: @8600
     /*    8600 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(8714),
     /*    8605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*    8608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*    8611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8623 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8668), // Rule ID 45796 //
     /*    8628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8631 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    8631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*    8634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    8648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8666 */     GIR_RootConstrainSelectedInstOperands,
     /*    8667 */     // GIR_Coverage, 45796,
     /*    8667 */     GIR_EraseRootFromParent_Done,
     /*    8668 */   // Label 275: @8668
     /*    8668 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8713), // Rule ID 45797 //
     /*    8673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8676 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    8676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*    8679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*    8693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8711 */     GIR_RootConstrainSelectedInstOperands,
     /*    8712 */     // GIR_Coverage, 45797,
     /*    8712 */     GIR_EraseRootFromParent_Done,
     /*    8713 */   // Label 276: @8713
     /*    8713 */   GIM_Reject,
     /*    8714 */ // Label 274: @8714
     /*    8714 */ GIM_Reject,
     /*    8715 */ // Label 137: @8715
     /*    8715 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8829),
     /*    8720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*    8723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*    8726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    8738 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8783), // Rule ID 45824 //
     /*    8743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8746 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    8746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*    8749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    8778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8781 */     GIR_RootConstrainSelectedInstOperands,
     /*    8782 */     // GIR_Coverage, 45824,
     /*    8782 */     GIR_EraseRootFromParent_Done,
     /*    8783 */   // Label 278: @8783
     /*    8783 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8828), // Rule ID 45825 //
     /*    8788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8791 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    8791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*    8794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    8808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    8823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8826 */     GIR_RootConstrainSelectedInstOperands,
     /*    8827 */     // GIR_Coverage, 45825,
     /*    8827 */     GIR_EraseRootFromParent_Done,
     /*    8828 */   // Label 279: @8828
     /*    8828 */   GIM_Reject,
     /*    8829 */ // Label 277: @8829
     /*    8829 */ GIM_Reject,
     /*    8830 */ // Label 138: @8830
     /*    8830 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8944),
     /*    8835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*    8838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*    8841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    8853 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8898), // Rule ID 45840 //
     /*    8858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8861 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*    8861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*    8864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    8878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    8893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8896 */     GIR_RootConstrainSelectedInstOperands,
     /*    8897 */     // GIR_Coverage, 45840,
     /*    8897 */     GIR_EraseRootFromParent_Done,
     /*    8898 */   // Label 281: @8898
     /*    8898 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8943), // Rule ID 45841 //
     /*    8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8906 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*    8906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*    8909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    8923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    8930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    8938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8941 */     GIR_RootConstrainSelectedInstOperands,
     /*    8942 */     // GIR_Coverage, 45841,
     /*    8942 */     GIR_EraseRootFromParent_Done,
     /*    8943 */   // Label 282: @8943
     /*    8943 */   GIM_Reject,
     /*    8944 */ // Label 280: @8944
     /*    8944 */ GIM_Reject,
     /*    8945 */ // Label 139: @8945
     /*    8945 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(9059),
     /*    8950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*    8953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*    8956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    8960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    8964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    8968 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(9013), // Rule ID 45856 //
     /*    8973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*    8976 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*    8976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*    8979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    8983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    8993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    9008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9011 */     GIR_RootConstrainSelectedInstOperands,
     /*    9012 */     // GIR_Coverage, 45856,
     /*    9012 */     GIR_EraseRootFromParent_Done,
     /*    9013 */   // Label 284: @9013
     /*    9013 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(9058), // Rule ID 45857 //
     /*    9018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*    9021 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*    9021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*    9024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*    9053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9056 */     GIR_RootConstrainSelectedInstOperands,
     /*    9057 */     // GIR_Coverage, 45857,
     /*    9057 */     GIR_EraseRootFromParent_Done,
     /*    9058 */   // Label 285: @9058
     /*    9058 */   GIM_Reject,
     /*    9059 */ // Label 283: @9059
     /*    9059 */ GIM_Reject,
     /*    9060 */ // Label 140: @9060
     /*    9060 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(9174),
     /*    9065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*    9068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*    9071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    9075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    9079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*    9083 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(9128), // Rule ID 45812 //
     /*    9088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9091 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*    9094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    9108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9126 */     GIR_RootConstrainSelectedInstOperands,
     /*    9127 */     // GIR_Coverage, 45812,
     /*    9127 */     GIR_EraseRootFromParent_Done,
     /*    9128 */   // Label 287: @9128
     /*    9128 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(9173), // Rule ID 45813 //
     /*    9133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9136 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*    9139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*    9153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9171 */     GIR_RootConstrainSelectedInstOperands,
     /*    9172 */     // GIR_Coverage, 45813,
     /*    9172 */     GIR_EraseRootFromParent_Done,
     /*    9173 */   // Label 288: @9173
     /*    9173 */   GIM_Reject,
     /*    9174 */ // Label 286: @9174
     /*    9174 */ GIM_Reject,
     /*    9175 */ // Label 141: @9175
     /*    9175 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9289),
     /*    9180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*    9183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*    9186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9198 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9243), // Rule ID 45828 //
     /*    9203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9206 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    9206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*    9209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    9223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9241 */     GIR_RootConstrainSelectedInstOperands,
     /*    9242 */     // GIR_Coverage, 45828,
     /*    9242 */     GIR_EraseRootFromParent_Done,
     /*    9243 */   // Label 290: @9243
     /*    9243 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9288), // Rule ID 45829 //
     /*    9248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9251 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    9251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*    9254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    9268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9286 */     GIR_RootConstrainSelectedInstOperands,
     /*    9287 */     // GIR_Coverage, 45829,
     /*    9287 */     GIR_EraseRootFromParent_Done,
     /*    9288 */   // Label 291: @9288
     /*    9288 */   GIM_Reject,
     /*    9289 */ // Label 289: @9289
     /*    9289 */ GIM_Reject,
     /*    9290 */ // Label 142: @9290
     /*    9290 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9404),
     /*    9295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*    9298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*    9301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9313 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9358), // Rule ID 45844 //
     /*    9318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9321 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*    9321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*    9324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    9353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9356 */     GIR_RootConstrainSelectedInstOperands,
     /*    9357 */     // GIR_Coverage, 45844,
     /*    9357 */     GIR_EraseRootFromParent_Done,
     /*    9358 */   // Label 293: @9358
     /*    9358 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9403), // Rule ID 45845 //
     /*    9363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9366 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*    9366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*    9369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*    9398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9401 */     GIR_RootConstrainSelectedInstOperands,
     /*    9402 */     // GIR_Coverage, 45845,
     /*    9402 */     GIR_EraseRootFromParent_Done,
     /*    9403 */   // Label 294: @9403
     /*    9403 */   GIM_Reject,
     /*    9404 */ // Label 292: @9404
     /*    9404 */ GIM_Reject,
     /*    9405 */ // Label 143: @9405
     /*    9405 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9519),
     /*    9410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*    9413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*    9416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*    9428 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(9473), // Rule ID 45816 //
     /*    9433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9436 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*    9439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    9453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9471 */     GIR_RootConstrainSelectedInstOperands,
     /*    9472 */     // GIR_Coverage, 45816,
     /*    9472 */     GIR_EraseRootFromParent_Done,
     /*    9473 */   // Label 296: @9473
     /*    9473 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(9518), // Rule ID 45817 //
     /*    9478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9481 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*    9484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*    9498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9516 */     GIR_RootConstrainSelectedInstOperands,
     /*    9517 */     // GIR_Coverage, 45817,
     /*    9517 */     GIR_EraseRootFromParent_Done,
     /*    9518 */   // Label 297: @9518
     /*    9518 */   GIM_Reject,
     /*    9519 */ // Label 295: @9519
     /*    9519 */ GIM_Reject,
     /*    9520 */ // Label 144: @9520
     /*    9520 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(9634),
     /*    9525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*    9528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*    9531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9543 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(9588), // Rule ID 45832 //
     /*    9548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9551 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*    9551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*    9554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9586 */     GIR_RootConstrainSelectedInstOperands,
     /*    9587 */     // GIR_Coverage, 45832,
     /*    9587 */     GIR_EraseRootFromParent_Done,
     /*    9588 */   // Label 299: @9588
     /*    9588 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(9633), // Rule ID 45833 //
     /*    9593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9596 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*    9596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*    9599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9631 */     GIR_RootConstrainSelectedInstOperands,
     /*    9632 */     // GIR_Coverage, 45833,
     /*    9632 */     GIR_EraseRootFromParent_Done,
     /*    9633 */   // Label 300: @9633
     /*    9633 */   GIM_Reject,
     /*    9634 */ // Label 298: @9634
     /*    9634 */ GIM_Reject,
     /*    9635 */ // Label 145: @9635
     /*    9635 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(9749),
     /*    9640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*    9643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*    9646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*    9658 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9703), // Rule ID 45820 //
     /*    9663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9666 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*    9669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9701 */     GIR_RootConstrainSelectedInstOperands,
     /*    9702 */     // GIR_Coverage, 45820,
     /*    9702 */     GIR_EraseRootFromParent_Done,
     /*    9703 */   // Label 302: @9703
     /*    9703 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9748), // Rule ID 45821 //
     /*    9708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9711 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*    9714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*    9728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    9735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9746 */     GIR_RootConstrainSelectedInstOperands,
     /*    9747 */     // GIR_Coverage, 45821,
     /*    9747 */     GIR_EraseRootFromParent_Done,
     /*    9748 */   // Label 303: @9748
     /*    9748 */   GIM_Reject,
     /*    9749 */ // Label 301: @9749
     /*    9749 */ GIM_Reject,
     /*    9750 */ // Label 146: @9750
     /*    9750 */ GIM_Reject,
     /*    9751 */ // Label 1: @9751
     /*    9751 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 328*/ GIMT_Encode4(12706),
     /*    9762 */ /*GILLT_s32*//*Label 304*/ GIMT_Encode4(9886),
     /*    9766 */ /*GILLT_s64*//*Label 305*/ GIMT_Encode4(9979), GIMT_Encode4(0),
     /*    9774 */ /*GILLT_nxv1s8*//*Label 306*/ GIMT_Encode4(10176),
     /*    9778 */ /*GILLT_nxv1s16*//*Label 307*/ GIMT_Encode4(10291),
     /*    9782 */ /*GILLT_nxv1s32*//*Label 308*/ GIMT_Encode4(10406),
     /*    9786 */ /*GILLT_nxv1s64*//*Label 309*/ GIMT_Encode4(10521), GIMT_Encode4(0),
     /*    9794 */ /*GILLT_nxv2s8*//*Label 310*/ GIMT_Encode4(10636),
     /*    9798 */ /*GILLT_nxv2s16*//*Label 311*/ GIMT_Encode4(10751),
     /*    9802 */ /*GILLT_nxv2s32*//*Label 312*/ GIMT_Encode4(10866),
     /*    9806 */ /*GILLT_nxv2s64*//*Label 313*/ GIMT_Encode4(10981), GIMT_Encode4(0),
     /*    9814 */ /*GILLT_nxv4s8*//*Label 314*/ GIMT_Encode4(11096),
     /*    9818 */ /*GILLT_nxv4s16*//*Label 315*/ GIMT_Encode4(11211),
     /*    9822 */ /*GILLT_nxv4s32*//*Label 316*/ GIMT_Encode4(11326),
     /*    9826 */ /*GILLT_nxv4s64*//*Label 317*/ GIMT_Encode4(11441), GIMT_Encode4(0),
     /*    9834 */ /*GILLT_nxv8s8*//*Label 318*/ GIMT_Encode4(11556),
     /*    9838 */ /*GILLT_nxv8s16*//*Label 319*/ GIMT_Encode4(11671),
     /*    9842 */ /*GILLT_nxv8s32*//*Label 320*/ GIMT_Encode4(11786),
     /*    9846 */ /*GILLT_nxv8s64*//*Label 321*/ GIMT_Encode4(11901), GIMT_Encode4(0),
     /*    9854 */ /*GILLT_nxv16s8*//*Label 322*/ GIMT_Encode4(12016),
     /*    9858 */ /*GILLT_nxv16s16*//*Label 323*/ GIMT_Encode4(12131),
     /*    9862 */ /*GILLT_nxv16s32*//*Label 324*/ GIMT_Encode4(12246), GIMT_Encode4(0),
     /*    9870 */ /*GILLT_nxv32s8*//*Label 325*/ GIMT_Encode4(12361),
     /*    9874 */ /*GILLT_nxv32s16*//*Label 326*/ GIMT_Encode4(12476), GIMT_Encode4(0),
     /*    9882 */ /*GILLT_nxv64s8*//*Label 327*/ GIMT_Encode4(12591),
     /*    9886 */ // Label 304: @9886
     /*    9886 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(9978),
     /*    9891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    9894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    9897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9905 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(9958), // Rule ID 61907 //
     /*    9910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    9913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    9921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    9925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    9929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9941 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    9941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*    9944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    9946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    9948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    9956 */     GIR_RootConstrainSelectedInstOperands,
     /*    9957 */     // GIR_Coverage, 61907,
     /*    9957 */     GIR_EraseRootFromParent_Done,
     /*    9958 */   // Label 330: @9958
     /*    9958 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(9977), // Rule ID 77 //
     /*    9963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    9966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9970 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    9970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*    9975 */     GIR_RootConstrainSelectedInstOperands,
     /*    9976 */     // GIR_Coverage, 77,
     /*    9976 */     GIR_Done,
     /*    9977 */   // Label 331: @9977
     /*    9977 */   GIM_Reject,
     /*    9978 */ // Label 329: @9978
     /*    9978 */ GIM_Reject,
     /*    9979 */ // Label 305: @9979
     /*    9979 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10175),
     /*    9984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    9987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    9990 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10055), // Rule ID 61909 //
     /*    9995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*    9998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9707),
     /*   10036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10038 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_9707>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   10041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   10043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   10045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   10053 */     GIR_RootConstrainSelectedInstOperands,
     /*   10054 */     // GIR_Coverage, 61909,
     /*   10054 */     GIR_EraseRootFromParent_Done,
     /*   10055 */   // Label 333: @10055
     /*   10055 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10116), // Rule ID 61906 //
     /*   10060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   10063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10099 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   10102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   10104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   10106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   10114 */     GIR_RootConstrainSelectedInstOperands,
     /*   10115 */     // GIR_Coverage, 61906,
     /*   10115 */     GIR_EraseRootFromParent_Done,
     /*   10116 */   // Label 334: @10116
     /*   10116 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10147), // Rule ID 267 //
     /*   10121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9707),
     /*   10140 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_9707>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   10145 */     GIR_RootConstrainSelectedInstOperands,
     /*   10146 */     // GIR_Coverage, 267,
     /*   10146 */     GIR_Done,
     /*   10147 */   // Label 335: @10147
     /*   10147 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10174), // Rule ID 76 //
     /*   10152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   10155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10167 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   10172 */     GIR_RootConstrainSelectedInstOperands,
     /*   10173 */     // GIR_Coverage, 76,
     /*   10173 */     GIR_Done,
     /*   10174 */   // Label 336: @10174
     /*   10174 */   GIM_Reject,
     /*   10175 */ // Label 332: @10175
     /*   10175 */ GIM_Reject,
     /*   10176 */ // Label 306: @10176
     /*   10176 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10290),
     /*   10181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   10187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10199 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10244), // Rule ID 45902 //
     /*   10204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10207 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   10207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   10210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   10224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10242 */     GIR_RootConstrainSelectedInstOperands,
     /*   10243 */     // GIR_Coverage, 45902,
     /*   10243 */     GIR_EraseRootFromParent_Done,
     /*   10244 */   // Label 338: @10244
     /*   10244 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10289), // Rule ID 45903 //
     /*   10249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10252 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   10252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   10255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   10269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10287 */     GIR_RootConstrainSelectedInstOperands,
     /*   10288 */     // GIR_Coverage, 45903,
     /*   10288 */     GIR_EraseRootFromParent_Done,
     /*   10289 */   // Label 339: @10289
     /*   10289 */   GIM_Reject,
     /*   10290 */ // Label 337: @10290
     /*   10290 */ GIM_Reject,
     /*   10291 */ // Label 307: @10291
     /*   10291 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10405),
     /*   10296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   10302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10314 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10359), // Rule ID 45914 //
     /*   10319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10322 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   10322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   10325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   10339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10357 */     GIR_RootConstrainSelectedInstOperands,
     /*   10358 */     // GIR_Coverage, 45914,
     /*   10358 */     GIR_EraseRootFromParent_Done,
     /*   10359 */   // Label 341: @10359
     /*   10359 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10404), // Rule ID 45915 //
     /*   10364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10367 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   10367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   10370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   10384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10402 */     GIR_RootConstrainSelectedInstOperands,
     /*   10403 */     // GIR_Coverage, 45915,
     /*   10403 */     GIR_EraseRootFromParent_Done,
     /*   10404 */   // Label 342: @10404
     /*   10404 */   GIM_Reject,
     /*   10405 */ // Label 340: @10405
     /*   10405 */ GIM_Reject,
     /*   10406 */ // Label 308: @10406
     /*   10406 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10520),
     /*   10411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   10414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   10417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10429 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10474), // Rule ID 45922 //
     /*   10434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10437 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   10437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   10440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   10454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   10469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10472 */     GIR_RootConstrainSelectedInstOperands,
     /*   10473 */     // GIR_Coverage, 45922,
     /*   10473 */     GIR_EraseRootFromParent_Done,
     /*   10474 */   // Label 344: @10474
     /*   10474 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10519), // Rule ID 45923 //
     /*   10479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10482 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   10482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   10485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   10499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   10514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10517 */     GIR_RootConstrainSelectedInstOperands,
     /*   10518 */     // GIR_Coverage, 45923,
     /*   10518 */     GIR_EraseRootFromParent_Done,
     /*   10519 */   // Label 345: @10519
     /*   10519 */   GIM_Reject,
     /*   10520 */ // Label 343: @10520
     /*   10520 */ GIM_Reject,
     /*   10521 */ // Label 309: @10521
     /*   10521 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10635),
     /*   10526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   10529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   10532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10544 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10589), // Rule ID 45938 //
     /*   10549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   10552 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   10552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   10555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   10569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   10584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10587 */     GIR_RootConstrainSelectedInstOperands,
     /*   10588 */     // GIR_Coverage, 45938,
     /*   10588 */     GIR_EraseRootFromParent_Done,
     /*   10589 */   // Label 347: @10589
     /*   10589 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10634), // Rule ID 45939 //
     /*   10594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   10597 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   10597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   10600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   10614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   10629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10632 */     GIR_RootConstrainSelectedInstOperands,
     /*   10633 */     // GIR_Coverage, 45939,
     /*   10633 */     GIR_EraseRootFromParent_Done,
     /*   10634 */   // Label 348: @10634
     /*   10634 */   GIM_Reject,
     /*   10635 */ // Label 346: @10635
     /*   10635 */ GIM_Reject,
     /*   10636 */ // Label 310: @10636
     /*   10636 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10750),
     /*   10641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   10644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   10647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10659 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10704), // Rule ID 45906 //
     /*   10664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10667 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   10667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   10670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   10684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10702 */     GIR_RootConstrainSelectedInstOperands,
     /*   10703 */     // GIR_Coverage, 45906,
     /*   10703 */     GIR_EraseRootFromParent_Done,
     /*   10704 */   // Label 350: @10704
     /*   10704 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10749), // Rule ID 45907 //
     /*   10709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10712 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   10712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   10715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   10729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10747 */     GIR_RootConstrainSelectedInstOperands,
     /*   10748 */     // GIR_Coverage, 45907,
     /*   10748 */     GIR_EraseRootFromParent_Done,
     /*   10749 */   // Label 351: @10749
     /*   10749 */   GIM_Reject,
     /*   10750 */ // Label 349: @10750
     /*   10750 */ GIM_Reject,
     /*   10751 */ // Label 311: @10751
     /*   10751 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(10865),
     /*   10756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   10759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   10762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10774 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(10819), // Rule ID 45918 //
     /*   10779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10782 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   10782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   10785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   10799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10817 */     GIR_RootConstrainSelectedInstOperands,
     /*   10818 */     // GIR_Coverage, 45918,
     /*   10818 */     GIR_EraseRootFromParent_Done,
     /*   10819 */   // Label 353: @10819
     /*   10819 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(10864), // Rule ID 45919 //
     /*   10824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10827 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   10827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   10830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   10844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10862 */     GIR_RootConstrainSelectedInstOperands,
     /*   10863 */     // GIR_Coverage, 45919,
     /*   10863 */     GIR_EraseRootFromParent_Done,
     /*   10864 */   // Label 354: @10864
     /*   10864 */   GIM_Reject,
     /*   10865 */ // Label 352: @10865
     /*   10865 */ GIM_Reject,
     /*   10866 */ // Label 312: @10866
     /*   10866 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(10980),
     /*   10871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   10874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   10877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10889 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(10934), // Rule ID 45934 //
     /*   10894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10897 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   10897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   10900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   10914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   10929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10932 */     GIR_RootConstrainSelectedInstOperands,
     /*   10933 */     // GIR_Coverage, 45934,
     /*   10933 */     GIR_EraseRootFromParent_Done,
     /*   10934 */   // Label 356: @10934
     /*   10934 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(10979), // Rule ID 45935 //
     /*   10939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10942 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   10942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   10945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   10959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   10974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10977 */     GIR_RootConstrainSelectedInstOperands,
     /*   10978 */     // GIR_Coverage, 45935,
     /*   10978 */     GIR_EraseRootFromParent_Done,
     /*   10979 */   // Label 357: @10979
     /*   10979 */   GIM_Reject,
     /*   10980 */ // Label 355: @10980
     /*   10980 */ GIM_Reject,
     /*   10981 */ // Label 313: @10981
     /*   10981 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(11095),
     /*   10986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   10989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   10992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   10996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11004 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(11049), // Rule ID 45978 //
     /*   11009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   11012 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   11012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   11015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   11044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11047 */     GIR_RootConstrainSelectedInstOperands,
     /*   11048 */     // GIR_Coverage, 45978,
     /*   11048 */     GIR_EraseRootFromParent_Done,
     /*   11049 */   // Label 359: @11049
     /*   11049 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(11094), // Rule ID 45979 //
     /*   11054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   11057 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   11057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   11060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   11089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11092 */     GIR_RootConstrainSelectedInstOperands,
     /*   11093 */     // GIR_Coverage, 45979,
     /*   11093 */     GIR_EraseRootFromParent_Done,
     /*   11094 */   // Label 360: @11094
     /*   11094 */   GIM_Reject,
     /*   11095 */ // Label 358: @11095
     /*   11095 */ GIM_Reject,
     /*   11096 */ // Label 314: @11096
     /*   11096 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(11210),
     /*   11101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   11104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   11107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11119 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(11164), // Rule ID 45910 //
     /*   11124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11127 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   11130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   11144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11162 */     GIR_RootConstrainSelectedInstOperands,
     /*   11163 */     // GIR_Coverage, 45910,
     /*   11163 */     GIR_EraseRootFromParent_Done,
     /*   11164 */   // Label 362: @11164
     /*   11164 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(11209), // Rule ID 45911 //
     /*   11169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11172 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   11175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   11189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11207 */     GIR_RootConstrainSelectedInstOperands,
     /*   11208 */     // GIR_Coverage, 45911,
     /*   11208 */     GIR_EraseRootFromParent_Done,
     /*   11209 */   // Label 363: @11209
     /*   11209 */   GIM_Reject,
     /*   11210 */ // Label 361: @11210
     /*   11210 */ GIM_Reject,
     /*   11211 */ // Label 315: @11211
     /*   11211 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(11325),
     /*   11216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   11219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   11222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11234 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(11279), // Rule ID 45930 //
     /*   11239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11242 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   11242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   11245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   11259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11277 */     GIR_RootConstrainSelectedInstOperands,
     /*   11278 */     // GIR_Coverage, 45930,
     /*   11278 */     GIR_EraseRootFromParent_Done,
     /*   11279 */   // Label 365: @11279
     /*   11279 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(11324), // Rule ID 45931 //
     /*   11284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11287 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   11287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   11290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   11304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11322 */     GIR_RootConstrainSelectedInstOperands,
     /*   11323 */     // GIR_Coverage, 45931,
     /*   11323 */     GIR_EraseRootFromParent_Done,
     /*   11324 */   // Label 366: @11324
     /*   11324 */   GIM_Reject,
     /*   11325 */ // Label 364: @11325
     /*   11325 */ GIM_Reject,
     /*   11326 */ // Label 316: @11326
     /*   11326 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(11440),
     /*   11331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   11334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   11337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11349 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11394), // Rule ID 45966 //
     /*   11354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11357 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   11357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   11360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   11389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11392 */     GIR_RootConstrainSelectedInstOperands,
     /*   11393 */     // GIR_Coverage, 45966,
     /*   11393 */     GIR_EraseRootFromParent_Done,
     /*   11394 */   // Label 368: @11394
     /*   11394 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11439), // Rule ID 45967 //
     /*   11399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11402 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   11402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   11405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   11434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11437 */     GIR_RootConstrainSelectedInstOperands,
     /*   11438 */     // GIR_Coverage, 45967,
     /*   11438 */     GIR_EraseRootFromParent_Done,
     /*   11439 */   // Label 369: @11439
     /*   11439 */   GIM_Reject,
     /*   11440 */ // Label 367: @11440
     /*   11440 */ GIM_Reject,
     /*   11441 */ // Label 317: @11441
     /*   11441 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11555),
     /*   11446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   11449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   11452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11464 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11509), // Rule ID 45982 //
     /*   11469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   11472 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   11472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   11475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   11489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   11504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11507 */     GIR_RootConstrainSelectedInstOperands,
     /*   11508 */     // GIR_Coverage, 45982,
     /*   11508 */     GIR_EraseRootFromParent_Done,
     /*   11509 */   // Label 371: @11509
     /*   11509 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11554), // Rule ID 45983 //
     /*   11514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   11517 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   11517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   11520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   11534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   11549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11552 */     GIR_RootConstrainSelectedInstOperands,
     /*   11553 */     // GIR_Coverage, 45983,
     /*   11553 */     GIR_EraseRootFromParent_Done,
     /*   11554 */   // Label 372: @11554
     /*   11554 */   GIM_Reject,
     /*   11555 */ // Label 370: @11555
     /*   11555 */ GIM_Reject,
     /*   11556 */ // Label 318: @11556
     /*   11556 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11670),
     /*   11561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   11564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   11567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11579 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11624), // Rule ID 45926 //
     /*   11584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11587 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   11590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   11604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11622 */     GIR_RootConstrainSelectedInstOperands,
     /*   11623 */     // GIR_Coverage, 45926,
     /*   11623 */     GIR_EraseRootFromParent_Done,
     /*   11624 */   // Label 374: @11624
     /*   11624 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11669), // Rule ID 45927 //
     /*   11629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11632 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   11635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   11649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11667 */     GIR_RootConstrainSelectedInstOperands,
     /*   11668 */     // GIR_Coverage, 45927,
     /*   11668 */     GIR_EraseRootFromParent_Done,
     /*   11669 */   // Label 375: @11669
     /*   11669 */   GIM_Reject,
     /*   11670 */ // Label 373: @11670
     /*   11670 */ GIM_Reject,
     /*   11671 */ // Label 319: @11671
     /*   11671 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11785),
     /*   11676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   11679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   11682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   11694 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11739), // Rule ID 45954 //
     /*   11699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11702 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   11702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   11705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11737 */     GIR_RootConstrainSelectedInstOperands,
     /*   11738 */     // GIR_Coverage, 45954,
     /*   11738 */     GIR_EraseRootFromParent_Done,
     /*   11739 */   // Label 377: @11739
     /*   11739 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11784), // Rule ID 45955 //
     /*   11744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11747 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   11747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   11750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   11764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11782 */     GIR_RootConstrainSelectedInstOperands,
     /*   11783 */     // GIR_Coverage, 45955,
     /*   11783 */     GIR_EraseRootFromParent_Done,
     /*   11784 */   // Label 378: @11784
     /*   11784 */   GIM_Reject,
     /*   11785 */ // Label 376: @11785
     /*   11785 */ GIM_Reject,
     /*   11786 */ // Label 320: @11786
     /*   11786 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11900),
     /*   11791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   11794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   11797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   11809 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11854), // Rule ID 45970 //
     /*   11814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11817 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   11817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   11820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   11834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   11849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11852 */     GIR_RootConstrainSelectedInstOperands,
     /*   11853 */     // GIR_Coverage, 45970,
     /*   11853 */     GIR_EraseRootFromParent_Done,
     /*   11854 */   // Label 380: @11854
     /*   11854 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11899), // Rule ID 45971 //
     /*   11859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11862 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   11862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   11865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   11879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   11894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11897 */     GIR_RootConstrainSelectedInstOperands,
     /*   11898 */     // GIR_Coverage, 45971,
     /*   11898 */     GIR_EraseRootFromParent_Done,
     /*   11899 */   // Label 381: @11899
     /*   11899 */   GIM_Reject,
     /*   11900 */ // Label 379: @11900
     /*   11900 */ GIM_Reject,
     /*   11901 */ // Label 321: @11901
     /*   11901 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(12015),
     /*   11906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   11909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   11912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   11916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   11920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   11924 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(11969), // Rule ID 45986 //
     /*   11929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   11932 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   11932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   11935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   11949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   11964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11967 */     GIR_RootConstrainSelectedInstOperands,
     /*   11968 */     // GIR_Coverage, 45986,
     /*   11968 */     GIR_EraseRootFromParent_Done,
     /*   11969 */   // Label 383: @11969
     /*   11969 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(12014), // Rule ID 45987 //
     /*   11974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   11977 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   11977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   11980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   11994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   12009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12012 */     GIR_RootConstrainSelectedInstOperands,
     /*   12013 */     // GIR_Coverage, 45987,
     /*   12013 */     GIR_EraseRootFromParent_Done,
     /*   12014 */   // Label 384: @12014
     /*   12014 */   GIM_Reject,
     /*   12015 */ // Label 382: @12015
     /*   12015 */ GIM_Reject,
     /*   12016 */ // Label 322: @12016
     /*   12016 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(12130),
     /*   12021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   12024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   12027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   12031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   12035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   12039 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(12084), // Rule ID 45942 //
     /*   12044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12047 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   12047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   12050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   12064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12082 */     GIR_RootConstrainSelectedInstOperands,
     /*   12083 */     // GIR_Coverage, 45942,
     /*   12083 */     GIR_EraseRootFromParent_Done,
     /*   12084 */   // Label 386: @12084
     /*   12084 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(12129), // Rule ID 45943 //
     /*   12089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12092 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   12092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   12095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   12109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12127 */     GIR_RootConstrainSelectedInstOperands,
     /*   12128 */     // GIR_Coverage, 45943,
     /*   12128 */     GIR_EraseRootFromParent_Done,
     /*   12129 */   // Label 387: @12129
     /*   12129 */   GIM_Reject,
     /*   12130 */ // Label 385: @12130
     /*   12130 */ GIM_Reject,
     /*   12131 */ // Label 323: @12131
     /*   12131 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(12245),
     /*   12136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   12139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   12142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12154 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12199), // Rule ID 45958 //
     /*   12159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12162 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   12162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   12165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   12179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12197 */     GIR_RootConstrainSelectedInstOperands,
     /*   12198 */     // GIR_Coverage, 45958,
     /*   12198 */     GIR_EraseRootFromParent_Done,
     /*   12199 */   // Label 389: @12199
     /*   12199 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12244), // Rule ID 45959 //
     /*   12204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12207 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   12207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   12210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   12224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12242 */     GIR_RootConstrainSelectedInstOperands,
     /*   12243 */     // GIR_Coverage, 45959,
     /*   12243 */     GIR_EraseRootFromParent_Done,
     /*   12244 */   // Label 390: @12244
     /*   12244 */   GIM_Reject,
     /*   12245 */ // Label 388: @12245
     /*   12245 */ GIM_Reject,
     /*   12246 */ // Label 324: @12246
     /*   12246 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12360),
     /*   12251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   12254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   12257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12269 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12314), // Rule ID 45974 //
     /*   12274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12277 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   12277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   12280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   12309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12312 */     GIR_RootConstrainSelectedInstOperands,
     /*   12313 */     // GIR_Coverage, 45974,
     /*   12313 */     GIR_EraseRootFromParent_Done,
     /*   12314 */   // Label 392: @12314
     /*   12314 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12359), // Rule ID 45975 //
     /*   12319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12322 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   12322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   12325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   12354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12357 */     GIR_RootConstrainSelectedInstOperands,
     /*   12358 */     // GIR_Coverage, 45975,
     /*   12358 */     GIR_EraseRootFromParent_Done,
     /*   12359 */   // Label 393: @12359
     /*   12359 */   GIM_Reject,
     /*   12360 */ // Label 391: @12360
     /*   12360 */ GIM_Reject,
     /*   12361 */ // Label 325: @12361
     /*   12361 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12475),
     /*   12366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   12369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   12372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   12384 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12429), // Rule ID 45946 //
     /*   12389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12392 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   12392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   12395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   12409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12427 */     GIR_RootConstrainSelectedInstOperands,
     /*   12428 */     // GIR_Coverage, 45946,
     /*   12428 */     GIR_EraseRootFromParent_Done,
     /*   12429 */   // Label 395: @12429
     /*   12429 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12474), // Rule ID 45947 //
     /*   12434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12437 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   12437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   12440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   12454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12472 */     GIR_RootConstrainSelectedInstOperands,
     /*   12473 */     // GIR_Coverage, 45947,
     /*   12473 */     GIR_EraseRootFromParent_Done,
     /*   12474 */   // Label 396: @12474
     /*   12474 */   GIM_Reject,
     /*   12475 */ // Label 394: @12475
     /*   12475 */ GIM_Reject,
     /*   12476 */ // Label 326: @12476
     /*   12476 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12590),
     /*   12481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   12484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   12487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12499 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12544), // Rule ID 45962 //
     /*   12504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12507 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   12507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   12510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12542 */     GIR_RootConstrainSelectedInstOperands,
     /*   12543 */     // GIR_Coverage, 45962,
     /*   12543 */     GIR_EraseRootFromParent_Done,
     /*   12544 */   // Label 398: @12544
     /*   12544 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12589), // Rule ID 45963 //
     /*   12549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12552 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   12552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   12555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12587 */     GIR_RootConstrainSelectedInstOperands,
     /*   12588 */     // GIR_Coverage, 45963,
     /*   12588 */     GIR_EraseRootFromParent_Done,
     /*   12589 */   // Label 399: @12589
     /*   12589 */   GIM_Reject,
     /*   12590 */ // Label 397: @12590
     /*   12590 */ GIM_Reject,
     /*   12591 */ // Label 327: @12591
     /*   12591 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12705),
     /*   12596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   12599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   12602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   12614 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12659), // Rule ID 45950 //
     /*   12619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12622 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   12622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   12625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12657 */     GIR_RootConstrainSelectedInstOperands,
     /*   12658 */     // GIR_Coverage, 45950,
     /*   12658 */     GIR_EraseRootFromParent_Done,
     /*   12659 */   // Label 401: @12659
     /*   12659 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12704), // Rule ID 45951 //
     /*   12664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12667 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   12667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   12670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   12684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12702 */     GIR_RootConstrainSelectedInstOperands,
     /*   12703 */     // GIR_Coverage, 45951,
     /*   12703 */     GIR_EraseRootFromParent_Done,
     /*   12704 */   // Label 402: @12704
     /*   12704 */   GIM_Reject,
     /*   12705 */ // Label 400: @12705
     /*   12705 */ GIM_Reject,
     /*   12706 */ // Label 328: @12706
     /*   12706 */ GIM_Reject,
     /*   12707 */ // Label 2: @12707
     /*   12707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 427*/ GIMT_Encode4(15610),
     /*   12718 */ /*GILLT_s32*//*Label 403*/ GIMT_Encode4(12842),
     /*   12722 */ /*GILLT_s64*//*Label 404*/ GIMT_Encode4(12876), GIMT_Encode4(0),
     /*   12730 */ /*GILLT_nxv1s8*//*Label 405*/ GIMT_Encode4(13080),
     /*   12734 */ /*GILLT_nxv1s16*//*Label 406*/ GIMT_Encode4(13195),
     /*   12738 */ /*GILLT_nxv1s32*//*Label 407*/ GIMT_Encode4(13310),
     /*   12742 */ /*GILLT_nxv1s64*//*Label 408*/ GIMT_Encode4(13425), GIMT_Encode4(0),
     /*   12750 */ /*GILLT_nxv2s8*//*Label 409*/ GIMT_Encode4(13540),
     /*   12754 */ /*GILLT_nxv2s16*//*Label 410*/ GIMT_Encode4(13655),
     /*   12758 */ /*GILLT_nxv2s32*//*Label 411*/ GIMT_Encode4(13770),
     /*   12762 */ /*GILLT_nxv2s64*//*Label 412*/ GIMT_Encode4(13885), GIMT_Encode4(0),
     /*   12770 */ /*GILLT_nxv4s8*//*Label 413*/ GIMT_Encode4(14000),
     /*   12774 */ /*GILLT_nxv4s16*//*Label 414*/ GIMT_Encode4(14115),
     /*   12778 */ /*GILLT_nxv4s32*//*Label 415*/ GIMT_Encode4(14230),
     /*   12782 */ /*GILLT_nxv4s64*//*Label 416*/ GIMT_Encode4(14345), GIMT_Encode4(0),
     /*   12790 */ /*GILLT_nxv8s8*//*Label 417*/ GIMT_Encode4(14460),
     /*   12794 */ /*GILLT_nxv8s16*//*Label 418*/ GIMT_Encode4(14575),
     /*   12798 */ /*GILLT_nxv8s32*//*Label 419*/ GIMT_Encode4(14690),
     /*   12802 */ /*GILLT_nxv8s64*//*Label 420*/ GIMT_Encode4(14805), GIMT_Encode4(0),
     /*   12810 */ /*GILLT_nxv16s8*//*Label 421*/ GIMT_Encode4(14920),
     /*   12814 */ /*GILLT_nxv16s16*//*Label 422*/ GIMT_Encode4(15035),
     /*   12818 */ /*GILLT_nxv16s32*//*Label 423*/ GIMT_Encode4(15150), GIMT_Encode4(0),
     /*   12826 */ /*GILLT_nxv32s8*//*Label 424*/ GIMT_Encode4(15265),
     /*   12830 */ /*GILLT_nxv32s16*//*Label 425*/ GIMT_Encode4(15380), GIMT_Encode4(0),
     /*   12838 */ /*GILLT_nxv64s8*//*Label 426*/ GIMT_Encode4(15495),
     /*   12842 */ // Label 403: @12842
     /*   12842 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(12875), // Rule ID 288 //
     /*   12847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   12850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   12853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   12856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12868 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   12868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   12873 */   GIR_RootConstrainSelectedInstOperands,
     /*   12874 */   // GIR_Coverage, 288,
     /*   12874 */   GIR_Done,
     /*   12875 */ // Label 428: @12875
     /*   12875 */ GIM_Reject,
     /*   12876 */ // Label 404: @12876
     /*   12876 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(13079),
     /*   12881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   12884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   12887 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(13020), // Rule ID 310 //
     /*   12892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   12895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   12907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   12911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   12915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12920 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   12931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   12939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   12943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   12947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   12952 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   12963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12965 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   12965 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   12968 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   12972 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12977 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12981 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   12986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   12989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   12993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13002 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   13005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   13010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   13018 */     GIR_RootConstrainSelectedInstOperands,
     /*   13019 */     // GIR_Coverage, 310,
     /*   13019 */     GIR_EraseRootFromParent_Done,
     /*   13020 */   // Label 430: @13020
     /*   13020 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(13051), // Rule ID 303 //
     /*   13025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   13028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9741),
     /*   13044 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_9741>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   13044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   13049 */     GIR_RootConstrainSelectedInstOperands,
     /*   13050 */     // GIR_Coverage, 303,
     /*   13050 */     GIR_Done,
     /*   13051 */   // Label 431: @13051
     /*   13051 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(13078), // Rule ID 287 //
     /*   13056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   13059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   13071 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   13071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   13076 */     GIR_RootConstrainSelectedInstOperands,
     /*   13077 */     // GIR_Coverage, 287,
     /*   13077 */     GIR_Done,
     /*   13078 */   // Label 432: @13078
     /*   13078 */   GIM_Reject,
     /*   13079 */ // Label 429: @13079
     /*   13079 */ GIM_Reject,
     /*   13080 */ // Label 405: @13080
     /*   13080 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(13194),
     /*   13085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   13091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13103 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(13148), // Rule ID 50310 //
     /*   13108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13111 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   13114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   13128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13146 */     GIR_RootConstrainSelectedInstOperands,
     /*   13147 */     // GIR_Coverage, 50310,
     /*   13147 */     GIR_EraseRootFromParent_Done,
     /*   13148 */   // Label 434: @13148
     /*   13148 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(13193), // Rule ID 50311 //
     /*   13153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13156 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   13159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   13173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13191 */     GIR_RootConstrainSelectedInstOperands,
     /*   13192 */     // GIR_Coverage, 50311,
     /*   13192 */     GIR_EraseRootFromParent_Done,
     /*   13193 */   // Label 435: @13193
     /*   13193 */   GIM_Reject,
     /*   13194 */ // Label 433: @13194
     /*   13194 */ GIM_Reject,
     /*   13195 */ // Label 406: @13195
     /*   13195 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(13309),
     /*   13200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13218 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(13263), // Rule ID 50322 //
     /*   13223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13226 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   13226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   13243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13261 */     GIR_RootConstrainSelectedInstOperands,
     /*   13262 */     // GIR_Coverage, 50322,
     /*   13262 */     GIR_EraseRootFromParent_Done,
     /*   13263 */   // Label 437: @13263
     /*   13263 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(13308), // Rule ID 50323 //
     /*   13268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13271 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   13271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   13288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13306 */     GIR_RootConstrainSelectedInstOperands,
     /*   13307 */     // GIR_Coverage, 50323,
     /*   13307 */     GIR_EraseRootFromParent_Done,
     /*   13308 */   // Label 438: @13308
     /*   13308 */   GIM_Reject,
     /*   13309 */ // Label 436: @13309
     /*   13309 */ GIM_Reject,
     /*   13310 */ // Label 407: @13310
     /*   13310 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(13424),
     /*   13315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   13318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   13321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13333 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(13378), // Rule ID 50330 //
     /*   13338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13341 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   13341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   13344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   13358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13376 */     GIR_RootConstrainSelectedInstOperands,
     /*   13377 */     // GIR_Coverage, 50330,
     /*   13377 */     GIR_EraseRootFromParent_Done,
     /*   13378 */   // Label 440: @13378
     /*   13378 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(13423), // Rule ID 50331 //
     /*   13383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13386 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   13386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   13389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   13403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13421 */     GIR_RootConstrainSelectedInstOperands,
     /*   13422 */     // GIR_Coverage, 50331,
     /*   13422 */     GIR_EraseRootFromParent_Done,
     /*   13423 */   // Label 441: @13423
     /*   13423 */   GIM_Reject,
     /*   13424 */ // Label 439: @13424
     /*   13424 */ GIM_Reject,
     /*   13425 */ // Label 408: @13425
     /*   13425 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(13539),
     /*   13430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   13433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   13436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13448 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(13493), // Rule ID 50346 //
     /*   13453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   13456 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   13456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   13459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   13473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   13488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13491 */     GIR_RootConstrainSelectedInstOperands,
     /*   13492 */     // GIR_Coverage, 50346,
     /*   13492 */     GIR_EraseRootFromParent_Done,
     /*   13493 */   // Label 443: @13493
     /*   13493 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(13538), // Rule ID 50347 //
     /*   13498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   13501 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   13501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   13504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   13518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   13533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13536 */     GIR_RootConstrainSelectedInstOperands,
     /*   13537 */     // GIR_Coverage, 50347,
     /*   13537 */     GIR_EraseRootFromParent_Done,
     /*   13538 */   // Label 444: @13538
     /*   13538 */   GIM_Reject,
     /*   13539 */ // Label 442: @13539
     /*   13539 */ GIM_Reject,
     /*   13540 */ // Label 409: @13540
     /*   13540 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(13654),
     /*   13545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   13548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   13551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13563 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(13608), // Rule ID 50314 //
     /*   13568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13571 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   13574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   13588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13606 */     GIR_RootConstrainSelectedInstOperands,
     /*   13607 */     // GIR_Coverage, 50314,
     /*   13607 */     GIR_EraseRootFromParent_Done,
     /*   13608 */   // Label 446: @13608
     /*   13608 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(13653), // Rule ID 50315 //
     /*   13613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13616 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   13619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   13633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13651 */     GIR_RootConstrainSelectedInstOperands,
     /*   13652 */     // GIR_Coverage, 50315,
     /*   13652 */     GIR_EraseRootFromParent_Done,
     /*   13653 */   // Label 447: @13653
     /*   13653 */   GIM_Reject,
     /*   13654 */ // Label 445: @13654
     /*   13654 */ GIM_Reject,
     /*   13655 */ // Label 410: @13655
     /*   13655 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(13769),
     /*   13660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   13663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   13666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13678 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(13723), // Rule ID 50326 //
     /*   13683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13686 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   13686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   13689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   13703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13721 */     GIR_RootConstrainSelectedInstOperands,
     /*   13722 */     // GIR_Coverage, 50326,
     /*   13722 */     GIR_EraseRootFromParent_Done,
     /*   13723 */   // Label 449: @13723
     /*   13723 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(13768), // Rule ID 50327 //
     /*   13728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13731 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   13731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   13734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   13748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13766 */     GIR_RootConstrainSelectedInstOperands,
     /*   13767 */     // GIR_Coverage, 50327,
     /*   13767 */     GIR_EraseRootFromParent_Done,
     /*   13768 */   // Label 450: @13768
     /*   13768 */   GIM_Reject,
     /*   13769 */ // Label 448: @13769
     /*   13769 */ GIM_Reject,
     /*   13770 */ // Label 411: @13770
     /*   13770 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(13884),
     /*   13775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   13778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   13781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13793 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(13838), // Rule ID 50342 //
     /*   13798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13801 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   13801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   13804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   13818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13836 */     GIR_RootConstrainSelectedInstOperands,
     /*   13837 */     // GIR_Coverage, 50342,
     /*   13837 */     GIR_EraseRootFromParent_Done,
     /*   13838 */   // Label 452: @13838
     /*   13838 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(13883), // Rule ID 50343 //
     /*   13843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13846 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   13846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   13849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   13863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13881 */     GIR_RootConstrainSelectedInstOperands,
     /*   13882 */     // GIR_Coverage, 50343,
     /*   13882 */     GIR_EraseRootFromParent_Done,
     /*   13883 */   // Label 453: @13883
     /*   13883 */   GIM_Reject,
     /*   13884 */ // Label 451: @13884
     /*   13884 */ GIM_Reject,
     /*   13885 */ // Label 412: @13885
     /*   13885 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(13999),
     /*   13890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   13893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   13896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   13900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   13904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   13908 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(13953), // Rule ID 50386 //
     /*   13913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   13916 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   13916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   13919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   13933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   13948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13951 */     GIR_RootConstrainSelectedInstOperands,
     /*   13952 */     // GIR_Coverage, 50386,
     /*   13952 */     GIR_EraseRootFromParent_Done,
     /*   13953 */   // Label 455: @13953
     /*   13953 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(13998), // Rule ID 50387 //
     /*   13958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   13961 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   13961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   13964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   13978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   13993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13996 */     GIR_RootConstrainSelectedInstOperands,
     /*   13997 */     // GIR_Coverage, 50387,
     /*   13997 */     GIR_EraseRootFromParent_Done,
     /*   13998 */   // Label 456: @13998
     /*   13998 */   GIM_Reject,
     /*   13999 */ // Label 454: @13999
     /*   13999 */ GIM_Reject,
     /*   14000 */ // Label 413: @14000
     /*   14000 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(14114),
     /*   14005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   14008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   14011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14023 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(14068), // Rule ID 50318 //
     /*   14028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14031 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   14034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   14048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14066 */     GIR_RootConstrainSelectedInstOperands,
     /*   14067 */     // GIR_Coverage, 50318,
     /*   14067 */     GIR_EraseRootFromParent_Done,
     /*   14068 */   // Label 458: @14068
     /*   14068 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(14113), // Rule ID 50319 //
     /*   14073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14076 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   14079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   14093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14111 */     GIR_RootConstrainSelectedInstOperands,
     /*   14112 */     // GIR_Coverage, 50319,
     /*   14112 */     GIR_EraseRootFromParent_Done,
     /*   14113 */   // Label 459: @14113
     /*   14113 */   GIM_Reject,
     /*   14114 */ // Label 457: @14114
     /*   14114 */ GIM_Reject,
     /*   14115 */ // Label 414: @14115
     /*   14115 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(14229),
     /*   14120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   14123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   14126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14138 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(14183), // Rule ID 50338 //
     /*   14143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14146 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   14149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   14163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14181 */     GIR_RootConstrainSelectedInstOperands,
     /*   14182 */     // GIR_Coverage, 50338,
     /*   14182 */     GIR_EraseRootFromParent_Done,
     /*   14183 */   // Label 461: @14183
     /*   14183 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(14228), // Rule ID 50339 //
     /*   14188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14191 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   14208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14226 */     GIR_RootConstrainSelectedInstOperands,
     /*   14227 */     // GIR_Coverage, 50339,
     /*   14227 */     GIR_EraseRootFromParent_Done,
     /*   14228 */   // Label 462: @14228
     /*   14228 */   GIM_Reject,
     /*   14229 */ // Label 460: @14229
     /*   14229 */ GIM_Reject,
     /*   14230 */ // Label 415: @14230
     /*   14230 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(14344),
     /*   14235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   14238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   14241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14253 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(14298), // Rule ID 50374 //
     /*   14258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14261 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   14261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   14264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   14278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14296 */     GIR_RootConstrainSelectedInstOperands,
     /*   14297 */     // GIR_Coverage, 50374,
     /*   14297 */     GIR_EraseRootFromParent_Done,
     /*   14298 */   // Label 464: @14298
     /*   14298 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(14343), // Rule ID 50375 //
     /*   14303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14306 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   14306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   14309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   14323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14341 */     GIR_RootConstrainSelectedInstOperands,
     /*   14342 */     // GIR_Coverage, 50375,
     /*   14342 */     GIR_EraseRootFromParent_Done,
     /*   14343 */   // Label 465: @14343
     /*   14343 */   GIM_Reject,
     /*   14344 */ // Label 463: @14344
     /*   14344 */ GIM_Reject,
     /*   14345 */ // Label 416: @14345
     /*   14345 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(14459),
     /*   14350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   14353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   14356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14368 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(14413), // Rule ID 50390 //
     /*   14373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   14376 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   14376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   14379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   14393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   14408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14411 */     GIR_RootConstrainSelectedInstOperands,
     /*   14412 */     // GIR_Coverage, 50390,
     /*   14412 */     GIR_EraseRootFromParent_Done,
     /*   14413 */   // Label 467: @14413
     /*   14413 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(14458), // Rule ID 50391 //
     /*   14418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   14421 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   14421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   14424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   14438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   14453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14456 */     GIR_RootConstrainSelectedInstOperands,
     /*   14457 */     // GIR_Coverage, 50391,
     /*   14457 */     GIR_EraseRootFromParent_Done,
     /*   14458 */   // Label 468: @14458
     /*   14458 */   GIM_Reject,
     /*   14459 */ // Label 466: @14459
     /*   14459 */ GIM_Reject,
     /*   14460 */ // Label 417: @14460
     /*   14460 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(14574),
     /*   14465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   14468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   14471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14483 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(14528), // Rule ID 50334 //
     /*   14488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14491 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   14494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   14508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14526 */     GIR_RootConstrainSelectedInstOperands,
     /*   14527 */     // GIR_Coverage, 50334,
     /*   14527 */     GIR_EraseRootFromParent_Done,
     /*   14528 */   // Label 470: @14528
     /*   14528 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14573), // Rule ID 50335 //
     /*   14533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14536 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   14539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   14553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14571 */     GIR_RootConstrainSelectedInstOperands,
     /*   14572 */     // GIR_Coverage, 50335,
     /*   14572 */     GIR_EraseRootFromParent_Done,
     /*   14573 */   // Label 471: @14573
     /*   14573 */   GIM_Reject,
     /*   14574 */ // Label 469: @14574
     /*   14574 */ GIM_Reject,
     /*   14575 */ // Label 418: @14575
     /*   14575 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(14689),
     /*   14580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   14583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   14586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14598 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(14643), // Rule ID 50362 //
     /*   14603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14606 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   14609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   14623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14641 */     GIR_RootConstrainSelectedInstOperands,
     /*   14642 */     // GIR_Coverage, 50362,
     /*   14642 */     GIR_EraseRootFromParent_Done,
     /*   14643 */   // Label 473: @14643
     /*   14643 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(14688), // Rule ID 50363 //
     /*   14648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14651 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   14654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   14668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14686 */     GIR_RootConstrainSelectedInstOperands,
     /*   14687 */     // GIR_Coverage, 50363,
     /*   14687 */     GIR_EraseRootFromParent_Done,
     /*   14688 */   // Label 474: @14688
     /*   14688 */   GIM_Reject,
     /*   14689 */ // Label 472: @14689
     /*   14689 */ GIM_Reject,
     /*   14690 */ // Label 419: @14690
     /*   14690 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(14804),
     /*   14695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   14698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   14701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   14713 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(14758), // Rule ID 50378 //
     /*   14718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14721 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   14721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   14724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   14738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14756 */     GIR_RootConstrainSelectedInstOperands,
     /*   14757 */     // GIR_Coverage, 50378,
     /*   14757 */     GIR_EraseRootFromParent_Done,
     /*   14758 */   // Label 476: @14758
     /*   14758 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(14803), // Rule ID 50379 //
     /*   14763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14766 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   14783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14801 */     GIR_RootConstrainSelectedInstOperands,
     /*   14802 */     // GIR_Coverage, 50379,
     /*   14802 */     GIR_EraseRootFromParent_Done,
     /*   14803 */   // Label 477: @14803
     /*   14803 */   GIM_Reject,
     /*   14804 */ // Label 475: @14804
     /*   14804 */ GIM_Reject,
     /*   14805 */ // Label 420: @14805
     /*   14805 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(14919),
     /*   14810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   14813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   14816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   14820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   14824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   14828 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(14873), // Rule ID 50394 //
     /*   14833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   14836 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   14836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   14839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   14853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   14868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14871 */     GIR_RootConstrainSelectedInstOperands,
     /*   14872 */     // GIR_Coverage, 50394,
     /*   14872 */     GIR_EraseRootFromParent_Done,
     /*   14873 */   // Label 479: @14873
     /*   14873 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(14918), // Rule ID 50395 //
     /*   14878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   14881 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   14881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   14884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   14898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   14913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14916 */     GIR_RootConstrainSelectedInstOperands,
     /*   14917 */     // GIR_Coverage, 50395,
     /*   14917 */     GIR_EraseRootFromParent_Done,
     /*   14918 */   // Label 480: @14918
     /*   14918 */   GIM_Reject,
     /*   14919 */ // Label 478: @14919
     /*   14919 */ GIM_Reject,
     /*   14920 */ // Label 421: @14920
     /*   14920 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(15034),
     /*   14925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   14928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   14931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   14943 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(14988), // Rule ID 50350 //
     /*   14948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14951 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   14954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   14968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14986 */     GIR_RootConstrainSelectedInstOperands,
     /*   14987 */     // GIR_Coverage, 50350,
     /*   14987 */     GIR_EraseRootFromParent_Done,
     /*   14988 */   // Label 482: @14988
     /*   14988 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(15033), // Rule ID 50351 //
     /*   14993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14996 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   14999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15031 */     GIR_RootConstrainSelectedInstOperands,
     /*   15032 */     // GIR_Coverage, 50351,
     /*   15032 */     GIR_EraseRootFromParent_Done,
     /*   15033 */   // Label 483: @15033
     /*   15033 */   GIM_Reject,
     /*   15034 */ // Label 481: @15034
     /*   15034 */ GIM_Reject,
     /*   15035 */ // Label 422: @15035
     /*   15035 */ GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15149),
     /*   15040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   15043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   15046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15058 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15103), // Rule ID 50366 //
     /*   15063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15066 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   15066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   15069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   15083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15101 */     GIR_RootConstrainSelectedInstOperands,
     /*   15102 */     // GIR_Coverage, 50366,
     /*   15102 */     GIR_EraseRootFromParent_Done,
     /*   15103 */   // Label 485: @15103
     /*   15103 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15148), // Rule ID 50367 //
     /*   15108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15111 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   15111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   15114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   15128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15146 */     GIR_RootConstrainSelectedInstOperands,
     /*   15147 */     // GIR_Coverage, 50367,
     /*   15147 */     GIR_EraseRootFromParent_Done,
     /*   15148 */   // Label 486: @15148
     /*   15148 */   GIM_Reject,
     /*   15149 */ // Label 484: @15149
     /*   15149 */ GIM_Reject,
     /*   15150 */ // Label 423: @15150
     /*   15150 */ GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15264),
     /*   15155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   15158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   15161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15173 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15218), // Rule ID 50382 //
     /*   15178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15181 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   15181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   15184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15216 */     GIR_RootConstrainSelectedInstOperands,
     /*   15217 */     // GIR_Coverage, 50382,
     /*   15217 */     GIR_EraseRootFromParent_Done,
     /*   15218 */   // Label 488: @15218
     /*   15218 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15263), // Rule ID 50383 //
     /*   15223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15226 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   15226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   15229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15261 */     GIR_RootConstrainSelectedInstOperands,
     /*   15262 */     // GIR_Coverage, 50383,
     /*   15262 */     GIR_EraseRootFromParent_Done,
     /*   15263 */   // Label 489: @15263
     /*   15263 */   GIM_Reject,
     /*   15264 */ // Label 487: @15264
     /*   15264 */ GIM_Reject,
     /*   15265 */ // Label 424: @15265
     /*   15265 */ GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(15379),
     /*   15270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   15273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   15276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   15288 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(15333), // Rule ID 50354 //
     /*   15293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15296 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   15296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   15299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   15313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15331 */     GIR_RootConstrainSelectedInstOperands,
     /*   15332 */     // GIR_Coverage, 50354,
     /*   15332 */     GIR_EraseRootFromParent_Done,
     /*   15333 */   // Label 491: @15333
     /*   15333 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(15378), // Rule ID 50355 //
     /*   15338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15341 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   15341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   15344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   15358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15376 */     GIR_RootConstrainSelectedInstOperands,
     /*   15377 */     // GIR_Coverage, 50355,
     /*   15377 */     GIR_EraseRootFromParent_Done,
     /*   15378 */   // Label 492: @15378
     /*   15378 */   GIM_Reject,
     /*   15379 */ // Label 490: @15379
     /*   15379 */ GIM_Reject,
     /*   15380 */ // Label 425: @15380
     /*   15380 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(15494),
     /*   15385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   15388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   15391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15403 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(15448), // Rule ID 50370 //
     /*   15408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15411 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   15411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   15414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15446 */     GIR_RootConstrainSelectedInstOperands,
     /*   15447 */     // GIR_Coverage, 50370,
     /*   15447 */     GIR_EraseRootFromParent_Done,
     /*   15448 */   // Label 494: @15448
     /*   15448 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(15493), // Rule ID 50371 //
     /*   15453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15456 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   15456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   15459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15491 */     GIR_RootConstrainSelectedInstOperands,
     /*   15492 */     // GIR_Coverage, 50371,
     /*   15492 */     GIR_EraseRootFromParent_Done,
     /*   15493 */   // Label 495: @15493
     /*   15493 */   GIM_Reject,
     /*   15494 */ // Label 493: @15494
     /*   15494 */ GIM_Reject,
     /*   15495 */ // Label 426: @15495
     /*   15495 */ GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(15609),
     /*   15500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   15503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   15506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   15518 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(15563), // Rule ID 50358 //
     /*   15523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15526 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   15526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   15529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15561 */     GIR_RootConstrainSelectedInstOperands,
     /*   15562 */     // GIR_Coverage, 50358,
     /*   15562 */     GIR_EraseRootFromParent_Done,
     /*   15563 */   // Label 497: @15563
     /*   15563 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(15608), // Rule ID 50359 //
     /*   15568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15571 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   15571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   15574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   15588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15606 */     GIR_RootConstrainSelectedInstOperands,
     /*   15607 */     // GIR_Coverage, 50359,
     /*   15607 */     GIR_EraseRootFromParent_Done,
     /*   15608 */   // Label 498: @15608
     /*   15608 */   GIM_Reject,
     /*   15609 */ // Label 496: @15609
     /*   15609 */ GIM_Reject,
     /*   15610 */ // Label 427: @15610
     /*   15610 */ GIM_Reject,
     /*   15611 */ // Label 3: @15611
     /*   15611 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 523*/ GIMT_Encode4(18344),
     /*   15622 */ /*GILLT_s32*//*Label 499*/ GIMT_Encode4(15746),
     /*   15626 */ /*GILLT_s64*//*Label 500*/ GIMT_Encode4(15780), GIMT_Encode4(0),
     /*   15634 */ /*GILLT_nxv1s8*//*Label 501*/ GIMT_Encode4(15814),
     /*   15638 */ /*GILLT_nxv1s16*//*Label 502*/ GIMT_Encode4(15929),
     /*   15642 */ /*GILLT_nxv1s32*//*Label 503*/ GIMT_Encode4(16044),
     /*   15646 */ /*GILLT_nxv1s64*//*Label 504*/ GIMT_Encode4(16159), GIMT_Encode4(0),
     /*   15654 */ /*GILLT_nxv2s8*//*Label 505*/ GIMT_Encode4(16274),
     /*   15658 */ /*GILLT_nxv2s16*//*Label 506*/ GIMT_Encode4(16389),
     /*   15662 */ /*GILLT_nxv2s32*//*Label 507*/ GIMT_Encode4(16504),
     /*   15666 */ /*GILLT_nxv2s64*//*Label 508*/ GIMT_Encode4(16619), GIMT_Encode4(0),
     /*   15674 */ /*GILLT_nxv4s8*//*Label 509*/ GIMT_Encode4(16734),
     /*   15678 */ /*GILLT_nxv4s16*//*Label 510*/ GIMT_Encode4(16849),
     /*   15682 */ /*GILLT_nxv4s32*//*Label 511*/ GIMT_Encode4(16964),
     /*   15686 */ /*GILLT_nxv4s64*//*Label 512*/ GIMT_Encode4(17079), GIMT_Encode4(0),
     /*   15694 */ /*GILLT_nxv8s8*//*Label 513*/ GIMT_Encode4(17194),
     /*   15698 */ /*GILLT_nxv8s16*//*Label 514*/ GIMT_Encode4(17309),
     /*   15702 */ /*GILLT_nxv8s32*//*Label 515*/ GIMT_Encode4(17424),
     /*   15706 */ /*GILLT_nxv8s64*//*Label 516*/ GIMT_Encode4(17539), GIMT_Encode4(0),
     /*   15714 */ /*GILLT_nxv16s8*//*Label 517*/ GIMT_Encode4(17654),
     /*   15718 */ /*GILLT_nxv16s16*//*Label 518*/ GIMT_Encode4(17769),
     /*   15722 */ /*GILLT_nxv16s32*//*Label 519*/ GIMT_Encode4(17884), GIMT_Encode4(0),
     /*   15730 */ /*GILLT_nxv32s8*//*Label 520*/ GIMT_Encode4(17999),
     /*   15734 */ /*GILLT_nxv32s16*//*Label 521*/ GIMT_Encode4(18114), GIMT_Encode4(0),
     /*   15742 */ /*GILLT_nxv64s8*//*Label 522*/ GIMT_Encode4(18229),
     /*   15746 */ // Label 499: @15746
     /*   15746 */ GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(15779), // Rule ID 296 //
     /*   15751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*   15754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   15757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   15760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15772 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   15772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*   15777 */   GIR_RootConstrainSelectedInstOperands,
     /*   15778 */   // GIR_Coverage, 296,
     /*   15778 */   GIR_Done,
     /*   15779 */ // Label 524: @15779
     /*   15779 */ GIM_Reject,
     /*   15780 */ // Label 500: @15780
     /*   15780 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(15813), // Rule ID 295 //
     /*   15785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*   15788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   15791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   15794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   15806 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   15806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*   15811 */   GIR_RootConstrainSelectedInstOperands,
     /*   15812 */   // GIR_Coverage, 295,
     /*   15812 */   GIR_Done,
     /*   15813 */ // Label 525: @15813
     /*   15813 */ GIM_Reject,
     /*   15814 */ // Label 501: @15814
     /*   15814 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(15928),
     /*   15819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   15825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15837 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(15882), // Rule ID 50662 //
     /*   15842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15845 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   15845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   15848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*   15862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15880 */     GIR_RootConstrainSelectedInstOperands,
     /*   15881 */     // GIR_Coverage, 50662,
     /*   15881 */     GIR_EraseRootFromParent_Done,
     /*   15882 */   // Label 527: @15882
     /*   15882 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(15927), // Rule ID 50663 //
     /*   15887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15890 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   15890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   15893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*   15907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15925 */     GIR_RootConstrainSelectedInstOperands,
     /*   15926 */     // GIR_Coverage, 50663,
     /*   15926 */     GIR_EraseRootFromParent_Done,
     /*   15927 */   // Label 528: @15927
     /*   15927 */   GIM_Reject,
     /*   15928 */ // Label 526: @15928
     /*   15928 */ GIM_Reject,
     /*   15929 */ // Label 502: @15929
     /*   15929 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(16043),
     /*   15934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   15940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15952 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(15997), // Rule ID 50674 //
     /*   15957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15960 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   15960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   15963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*   15977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15995 */     GIR_RootConstrainSelectedInstOperands,
     /*   15996 */     // GIR_Coverage, 50674,
     /*   15996 */     GIR_EraseRootFromParent_Done,
     /*   15997 */   // Label 530: @15997
     /*   15997 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(16042), // Rule ID 50675 //
     /*   16002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16005 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   16008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*   16022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16040 */     GIR_RootConstrainSelectedInstOperands,
     /*   16041 */     // GIR_Coverage, 50675,
     /*   16041 */     GIR_EraseRootFromParent_Done,
     /*   16042 */   // Label 531: @16042
     /*   16042 */   GIM_Reject,
     /*   16043 */ // Label 529: @16043
     /*   16043 */ GIM_Reject,
     /*   16044 */ // Label 503: @16044
     /*   16044 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(16158),
     /*   16049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16067 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(16112), // Rule ID 50682 //
     /*   16072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16075 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   16075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*   16092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16110 */     GIR_RootConstrainSelectedInstOperands,
     /*   16111 */     // GIR_Coverage, 50682,
     /*   16111 */     GIR_EraseRootFromParent_Done,
     /*   16112 */   // Label 533: @16112
     /*   16112 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(16157), // Rule ID 50683 //
     /*   16117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16120 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   16120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*   16137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16155 */     GIR_RootConstrainSelectedInstOperands,
     /*   16156 */     // GIR_Coverage, 50683,
     /*   16156 */     GIR_EraseRootFromParent_Done,
     /*   16157 */   // Label 534: @16157
     /*   16157 */   GIM_Reject,
     /*   16158 */ // Label 532: @16158
     /*   16158 */ GIM_Reject,
     /*   16159 */ // Label 504: @16159
     /*   16159 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(16273),
     /*   16164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   16167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   16170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16182 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(16227), // Rule ID 50698 //
     /*   16187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   16190 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   16190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   16193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*   16207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16225 */     GIR_RootConstrainSelectedInstOperands,
     /*   16226 */     // GIR_Coverage, 50698,
     /*   16226 */     GIR_EraseRootFromParent_Done,
     /*   16227 */   // Label 536: @16227
     /*   16227 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(16272), // Rule ID 50699 //
     /*   16232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   16235 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   16235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   16238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*   16252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16270 */     GIR_RootConstrainSelectedInstOperands,
     /*   16271 */     // GIR_Coverage, 50699,
     /*   16271 */     GIR_EraseRootFromParent_Done,
     /*   16272 */   // Label 537: @16272
     /*   16272 */   GIM_Reject,
     /*   16273 */ // Label 535: @16273
     /*   16273 */ GIM_Reject,
     /*   16274 */ // Label 505: @16274
     /*   16274 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(16388),
     /*   16279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   16282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   16285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16297 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(16342), // Rule ID 50666 //
     /*   16302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16305 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   16305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   16308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*   16322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16340 */     GIR_RootConstrainSelectedInstOperands,
     /*   16341 */     // GIR_Coverage, 50666,
     /*   16341 */     GIR_EraseRootFromParent_Done,
     /*   16342 */   // Label 539: @16342
     /*   16342 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(16387), // Rule ID 50667 //
     /*   16347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16350 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   16350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   16353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*   16367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16385 */     GIR_RootConstrainSelectedInstOperands,
     /*   16386 */     // GIR_Coverage, 50667,
     /*   16386 */     GIR_EraseRootFromParent_Done,
     /*   16387 */   // Label 540: @16387
     /*   16387 */   GIM_Reject,
     /*   16388 */ // Label 538: @16388
     /*   16388 */ GIM_Reject,
     /*   16389 */ // Label 506: @16389
     /*   16389 */ GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(16503),
     /*   16394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   16397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   16400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16412 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(16457), // Rule ID 50678 //
     /*   16417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16420 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   16423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*   16437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16455 */     GIR_RootConstrainSelectedInstOperands,
     /*   16456 */     // GIR_Coverage, 50678,
     /*   16456 */     GIR_EraseRootFromParent_Done,
     /*   16457 */   // Label 542: @16457
     /*   16457 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(16502), // Rule ID 50679 //
     /*   16462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16465 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   16468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*   16482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16500 */     GIR_RootConstrainSelectedInstOperands,
     /*   16501 */     // GIR_Coverage, 50679,
     /*   16501 */     GIR_EraseRootFromParent_Done,
     /*   16502 */   // Label 543: @16502
     /*   16502 */   GIM_Reject,
     /*   16503 */ // Label 541: @16503
     /*   16503 */ GIM_Reject,
     /*   16504 */ // Label 507: @16504
     /*   16504 */ GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(16618),
     /*   16509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   16512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   16515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16527 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(16572), // Rule ID 50694 //
     /*   16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16535 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   16535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   16538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*   16552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16570 */     GIR_RootConstrainSelectedInstOperands,
     /*   16571 */     // GIR_Coverage, 50694,
     /*   16571 */     GIR_EraseRootFromParent_Done,
     /*   16572 */   // Label 545: @16572
     /*   16572 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(16617), // Rule ID 50695 //
     /*   16577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16580 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   16580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   16583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*   16597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16615 */     GIR_RootConstrainSelectedInstOperands,
     /*   16616 */     // GIR_Coverage, 50695,
     /*   16616 */     GIR_EraseRootFromParent_Done,
     /*   16617 */   // Label 546: @16617
     /*   16617 */   GIM_Reject,
     /*   16618 */ // Label 544: @16618
     /*   16618 */ GIM_Reject,
     /*   16619 */ // Label 508: @16619
     /*   16619 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(16733),
     /*   16624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   16627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   16630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16642 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(16687), // Rule ID 50738 //
     /*   16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   16650 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   16650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   16653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*   16667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16685 */     GIR_RootConstrainSelectedInstOperands,
     /*   16686 */     // GIR_Coverage, 50738,
     /*   16686 */     GIR_EraseRootFromParent_Done,
     /*   16687 */   // Label 548: @16687
     /*   16687 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(16732), // Rule ID 50739 //
     /*   16692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   16695 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   16695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   16698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*   16712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16730 */     GIR_RootConstrainSelectedInstOperands,
     /*   16731 */     // GIR_Coverage, 50739,
     /*   16731 */     GIR_EraseRootFromParent_Done,
     /*   16732 */   // Label 549: @16732
     /*   16732 */   GIM_Reject,
     /*   16733 */ // Label 547: @16733
     /*   16733 */ GIM_Reject,
     /*   16734 */ // Label 509: @16734
     /*   16734 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(16848),
     /*   16739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   16742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   16745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16757 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(16802), // Rule ID 50670 //
     /*   16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16765 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   16765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   16768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*   16782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16800 */     GIR_RootConstrainSelectedInstOperands,
     /*   16801 */     // GIR_Coverage, 50670,
     /*   16801 */     GIR_EraseRootFromParent_Done,
     /*   16802 */   // Label 551: @16802
     /*   16802 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(16847), // Rule ID 50671 //
     /*   16807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16810 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   16810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   16813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*   16827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16845 */     GIR_RootConstrainSelectedInstOperands,
     /*   16846 */     // GIR_Coverage, 50671,
     /*   16846 */     GIR_EraseRootFromParent_Done,
     /*   16847 */   // Label 552: @16847
     /*   16847 */   GIM_Reject,
     /*   16848 */ // Label 550: @16848
     /*   16848 */ GIM_Reject,
     /*   16849 */ // Label 510: @16849
     /*   16849 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(16963),
     /*   16854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   16857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   16860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16872 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(16917), // Rule ID 50690 //
     /*   16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16880 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   16883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*   16897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16915 */     GIR_RootConstrainSelectedInstOperands,
     /*   16916 */     // GIR_Coverage, 50690,
     /*   16916 */     GIR_EraseRootFromParent_Done,
     /*   16917 */   // Label 554: @16917
     /*   16917 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(16962), // Rule ID 50691 //
     /*   16922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16925 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   16928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*   16942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   16949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16960 */     GIR_RootConstrainSelectedInstOperands,
     /*   16961 */     // GIR_Coverage, 50691,
     /*   16961 */     GIR_EraseRootFromParent_Done,
     /*   16962 */   // Label 555: @16962
     /*   16962 */   GIM_Reject,
     /*   16963 */ // Label 553: @16963
     /*   16963 */ GIM_Reject,
     /*   16964 */ // Label 511: @16964
     /*   16964 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(17078),
     /*   16969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   16972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   16975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   16987 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(17032), // Rule ID 50726 //
     /*   16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16995 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   16995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   16998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*   17012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17030 */     GIR_RootConstrainSelectedInstOperands,
     /*   17031 */     // GIR_Coverage, 50726,
     /*   17031 */     GIR_EraseRootFromParent_Done,
     /*   17032 */   // Label 557: @17032
     /*   17032 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(17077), // Rule ID 50727 //
     /*   17037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17040 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   17040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   17043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*   17057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17075 */     GIR_RootConstrainSelectedInstOperands,
     /*   17076 */     // GIR_Coverage, 50727,
     /*   17076 */     GIR_EraseRootFromParent_Done,
     /*   17077 */   // Label 558: @17077
     /*   17077 */   GIM_Reject,
     /*   17078 */ // Label 556: @17078
     /*   17078 */ GIM_Reject,
     /*   17079 */ // Label 512: @17079
     /*   17079 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(17193),
     /*   17084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   17087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   17090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17102 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(17147), // Rule ID 50742 //
     /*   17107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   17110 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   17110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   17113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*   17127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17145 */     GIR_RootConstrainSelectedInstOperands,
     /*   17146 */     // GIR_Coverage, 50742,
     /*   17146 */     GIR_EraseRootFromParent_Done,
     /*   17147 */   // Label 560: @17147
     /*   17147 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(17192), // Rule ID 50743 //
     /*   17152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   17155 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   17155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   17158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*   17172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17190 */     GIR_RootConstrainSelectedInstOperands,
     /*   17191 */     // GIR_Coverage, 50743,
     /*   17191 */     GIR_EraseRootFromParent_Done,
     /*   17192 */   // Label 561: @17192
     /*   17192 */   GIM_Reject,
     /*   17193 */ // Label 559: @17193
     /*   17193 */ GIM_Reject,
     /*   17194 */ // Label 513: @17194
     /*   17194 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(17308),
     /*   17199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   17202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   17205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17217 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(17262), // Rule ID 50686 //
     /*   17222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17225 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   17225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   17228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*   17242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17260 */     GIR_RootConstrainSelectedInstOperands,
     /*   17261 */     // GIR_Coverage, 50686,
     /*   17261 */     GIR_EraseRootFromParent_Done,
     /*   17262 */   // Label 563: @17262
     /*   17262 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(17307), // Rule ID 50687 //
     /*   17267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17270 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   17270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   17273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*   17287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17305 */     GIR_RootConstrainSelectedInstOperands,
     /*   17306 */     // GIR_Coverage, 50687,
     /*   17306 */     GIR_EraseRootFromParent_Done,
     /*   17307 */   // Label 564: @17307
     /*   17307 */   GIM_Reject,
     /*   17308 */ // Label 562: @17308
     /*   17308 */ GIM_Reject,
     /*   17309 */ // Label 514: @17309
     /*   17309 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(17423),
     /*   17314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   17317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   17320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17332 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(17377), // Rule ID 50714 //
     /*   17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17340 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   17343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*   17357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17375 */     GIR_RootConstrainSelectedInstOperands,
     /*   17376 */     // GIR_Coverage, 50714,
     /*   17376 */     GIR_EraseRootFromParent_Done,
     /*   17377 */   // Label 566: @17377
     /*   17377 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(17422), // Rule ID 50715 //
     /*   17382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17385 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   17388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*   17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17420 */     GIR_RootConstrainSelectedInstOperands,
     /*   17421 */     // GIR_Coverage, 50715,
     /*   17421 */     GIR_EraseRootFromParent_Done,
     /*   17422 */   // Label 567: @17422
     /*   17422 */   GIM_Reject,
     /*   17423 */ // Label 565: @17423
     /*   17423 */ GIM_Reject,
     /*   17424 */ // Label 515: @17424
     /*   17424 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(17538),
     /*   17429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   17432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   17435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17447 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(17492), // Rule ID 50730 //
     /*   17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17455 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   17458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*   17472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17490 */     GIR_RootConstrainSelectedInstOperands,
     /*   17491 */     // GIR_Coverage, 50730,
     /*   17491 */     GIR_EraseRootFromParent_Done,
     /*   17492 */   // Label 569: @17492
     /*   17492 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(17537), // Rule ID 50731 //
     /*   17497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17500 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   17500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   17503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*   17517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17535 */     GIR_RootConstrainSelectedInstOperands,
     /*   17536 */     // GIR_Coverage, 50731,
     /*   17536 */     GIR_EraseRootFromParent_Done,
     /*   17537 */   // Label 570: @17537
     /*   17537 */   GIM_Reject,
     /*   17538 */ // Label 568: @17538
     /*   17538 */ GIM_Reject,
     /*   17539 */ // Label 516: @17539
     /*   17539 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(17653),
     /*   17544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   17547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   17550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17562 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(17607), // Rule ID 50746 //
     /*   17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   17570 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   17570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   17573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*   17587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17605 */     GIR_RootConstrainSelectedInstOperands,
     /*   17606 */     // GIR_Coverage, 50746,
     /*   17606 */     GIR_EraseRootFromParent_Done,
     /*   17607 */   // Label 572: @17607
     /*   17607 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(17652), // Rule ID 50747 //
     /*   17612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   17615 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   17615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   17618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*   17632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17650 */     GIR_RootConstrainSelectedInstOperands,
     /*   17651 */     // GIR_Coverage, 50747,
     /*   17651 */     GIR_EraseRootFromParent_Done,
     /*   17652 */   // Label 573: @17652
     /*   17652 */   GIM_Reject,
     /*   17653 */ // Label 571: @17653
     /*   17653 */ GIM_Reject,
     /*   17654 */ // Label 517: @17654
     /*   17654 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17768),
     /*   17659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   17662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   17665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   17677 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17722), // Rule ID 50702 //
     /*   17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17685 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   17685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   17688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*   17702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17720 */     GIR_RootConstrainSelectedInstOperands,
     /*   17721 */     // GIR_Coverage, 50702,
     /*   17721 */     GIR_EraseRootFromParent_Done,
     /*   17722 */   // Label 575: @17722
     /*   17722 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17767), // Rule ID 50703 //
     /*   17727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17730 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   17730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   17733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*   17747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17765 */     GIR_RootConstrainSelectedInstOperands,
     /*   17766 */     // GIR_Coverage, 50703,
     /*   17766 */     GIR_EraseRootFromParent_Done,
     /*   17767 */   // Label 576: @17767
     /*   17767 */   GIM_Reject,
     /*   17768 */ // Label 574: @17768
     /*   17768 */ GIM_Reject,
     /*   17769 */ // Label 518: @17769
     /*   17769 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17883),
     /*   17774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   17777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   17780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   17792 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17837), // Rule ID 50718 //
     /*   17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17800 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   17803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*   17817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17835 */     GIR_RootConstrainSelectedInstOperands,
     /*   17836 */     // GIR_Coverage, 50718,
     /*   17836 */     GIR_EraseRootFromParent_Done,
     /*   17837 */   // Label 578: @17837
     /*   17837 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17882), // Rule ID 50719 //
     /*   17842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17845 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   17848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*   17862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17880 */     GIR_RootConstrainSelectedInstOperands,
     /*   17881 */     // GIR_Coverage, 50719,
     /*   17881 */     GIR_EraseRootFromParent_Done,
     /*   17882 */   // Label 579: @17882
     /*   17882 */   GIM_Reject,
     /*   17883 */ // Label 577: @17883
     /*   17883 */ GIM_Reject,
     /*   17884 */ // Label 519: @17884
     /*   17884 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17998),
     /*   17889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   17892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   17895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   17907 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17952), // Rule ID 50734 //
     /*   17912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17915 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   17918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*   17932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17950 */     GIR_RootConstrainSelectedInstOperands,
     /*   17951 */     // GIR_Coverage, 50734,
     /*   17951 */     GIR_EraseRootFromParent_Done,
     /*   17952 */   // Label 581: @17952
     /*   17952 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17997), // Rule ID 50735 //
     /*   17957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17960 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   17960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   17963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*   17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17995 */     GIR_RootConstrainSelectedInstOperands,
     /*   17996 */     // GIR_Coverage, 50735,
     /*   17996 */     GIR_EraseRootFromParent_Done,
     /*   17997 */   // Label 582: @17997
     /*   17997 */   GIM_Reject,
     /*   17998 */ // Label 580: @17998
     /*   17998 */ GIM_Reject,
     /*   17999 */ // Label 520: @17999
     /*   17999 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(18113),
     /*   18004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   18007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   18010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   18014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   18018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   18022 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(18067), // Rule ID 50706 //
     /*   18027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18030 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   18030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   18033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*   18047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18065 */     GIR_RootConstrainSelectedInstOperands,
     /*   18066 */     // GIR_Coverage, 50706,
     /*   18066 */     GIR_EraseRootFromParent_Done,
     /*   18067 */   // Label 584: @18067
     /*   18067 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(18112), // Rule ID 50707 //
     /*   18072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18075 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   18075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   18078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*   18092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18110 */     GIR_RootConstrainSelectedInstOperands,
     /*   18111 */     // GIR_Coverage, 50707,
     /*   18111 */     GIR_EraseRootFromParent_Done,
     /*   18112 */   // Label 585: @18112
     /*   18112 */   GIM_Reject,
     /*   18113 */ // Label 583: @18113
     /*   18113 */ GIM_Reject,
     /*   18114 */ // Label 521: @18114
     /*   18114 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(18228),
     /*   18119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   18122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   18125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18137 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(18182), // Rule ID 50722 //
     /*   18142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18145 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   18145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   18148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*   18162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18180 */     GIR_RootConstrainSelectedInstOperands,
     /*   18181 */     // GIR_Coverage, 50722,
     /*   18181 */     GIR_EraseRootFromParent_Done,
     /*   18182 */   // Label 587: @18182
     /*   18182 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(18227), // Rule ID 50723 //
     /*   18187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18190 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   18190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   18193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*   18207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18225 */     GIR_RootConstrainSelectedInstOperands,
     /*   18226 */     // GIR_Coverage, 50723,
     /*   18226 */     GIR_EraseRootFromParent_Done,
     /*   18227 */   // Label 588: @18227
     /*   18227 */   GIM_Reject,
     /*   18228 */ // Label 586: @18228
     /*   18228 */ GIM_Reject,
     /*   18229 */ // Label 522: @18229
     /*   18229 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(18343),
     /*   18234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   18237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   18240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   18252 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(18297), // Rule ID 50710 //
     /*   18257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18260 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   18260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   18263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*   18277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18295 */     GIR_RootConstrainSelectedInstOperands,
     /*   18296 */     // GIR_Coverage, 50710,
     /*   18296 */     GIR_EraseRootFromParent_Done,
     /*   18297 */   // Label 590: @18297
     /*   18297 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(18342), // Rule ID 50711 //
     /*   18302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18305 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   18305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   18308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*   18322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18340 */     GIR_RootConstrainSelectedInstOperands,
     /*   18341 */     // GIR_Coverage, 50711,
     /*   18341 */     GIR_EraseRootFromParent_Done,
     /*   18342 */   // Label 591: @18342
     /*   18342 */   GIM_Reject,
     /*   18343 */ // Label 589: @18343
     /*   18343 */ GIM_Reject,
     /*   18344 */ // Label 523: @18344
     /*   18344 */ GIM_Reject,
     /*   18345 */ // Label 4: @18345
     /*   18345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 616*/ GIMT_Encode4(21078),
     /*   18356 */ /*GILLT_s32*//*Label 592*/ GIMT_Encode4(18480),
     /*   18360 */ /*GILLT_s64*//*Label 593*/ GIMT_Encode4(18514), GIMT_Encode4(0),
     /*   18368 */ /*GILLT_nxv1s8*//*Label 594*/ GIMT_Encode4(18548),
     /*   18372 */ /*GILLT_nxv1s16*//*Label 595*/ GIMT_Encode4(18663),
     /*   18376 */ /*GILLT_nxv1s32*//*Label 596*/ GIMT_Encode4(18778),
     /*   18380 */ /*GILLT_nxv1s64*//*Label 597*/ GIMT_Encode4(18893), GIMT_Encode4(0),
     /*   18388 */ /*GILLT_nxv2s8*//*Label 598*/ GIMT_Encode4(19008),
     /*   18392 */ /*GILLT_nxv2s16*//*Label 599*/ GIMT_Encode4(19123),
     /*   18396 */ /*GILLT_nxv2s32*//*Label 600*/ GIMT_Encode4(19238),
     /*   18400 */ /*GILLT_nxv2s64*//*Label 601*/ GIMT_Encode4(19353), GIMT_Encode4(0),
     /*   18408 */ /*GILLT_nxv4s8*//*Label 602*/ GIMT_Encode4(19468),
     /*   18412 */ /*GILLT_nxv4s16*//*Label 603*/ GIMT_Encode4(19583),
     /*   18416 */ /*GILLT_nxv4s32*//*Label 604*/ GIMT_Encode4(19698),
     /*   18420 */ /*GILLT_nxv4s64*//*Label 605*/ GIMT_Encode4(19813), GIMT_Encode4(0),
     /*   18428 */ /*GILLT_nxv8s8*//*Label 606*/ GIMT_Encode4(19928),
     /*   18432 */ /*GILLT_nxv8s16*//*Label 607*/ GIMT_Encode4(20043),
     /*   18436 */ /*GILLT_nxv8s32*//*Label 608*/ GIMT_Encode4(20158),
     /*   18440 */ /*GILLT_nxv8s64*//*Label 609*/ GIMT_Encode4(20273), GIMT_Encode4(0),
     /*   18448 */ /*GILLT_nxv16s8*//*Label 610*/ GIMT_Encode4(20388),
     /*   18452 */ /*GILLT_nxv16s16*//*Label 611*/ GIMT_Encode4(20503),
     /*   18456 */ /*GILLT_nxv16s32*//*Label 612*/ GIMT_Encode4(20618), GIMT_Encode4(0),
     /*   18464 */ /*GILLT_nxv32s8*//*Label 613*/ GIMT_Encode4(20733),
     /*   18468 */ /*GILLT_nxv32s16*//*Label 614*/ GIMT_Encode4(20848), GIMT_Encode4(0),
     /*   18476 */ /*GILLT_nxv64s8*//*Label 615*/ GIMT_Encode4(20963),
     /*   18480 */ // Label 592: @18480
     /*   18480 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(18513), // Rule ID 298 //
     /*   18485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*   18488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   18491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   18494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18506 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   18506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*   18511 */   GIR_RootConstrainSelectedInstOperands,
     /*   18512 */   // GIR_Coverage, 298,
     /*   18512 */   GIR_Done,
     /*   18513 */ // Label 617: @18513
     /*   18513 */ GIM_Reject,
     /*   18514 */ // Label 593: @18514
     /*   18514 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(18547), // Rule ID 297 //
     /*   18519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*   18522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   18525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   18528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   18540 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   18540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*   18545 */   GIR_RootConstrainSelectedInstOperands,
     /*   18546 */   // GIR_Coverage, 297,
     /*   18546 */   GIR_Done,
     /*   18547 */ // Label 618: @18547
     /*   18547 */ GIM_Reject,
     /*   18548 */ // Label 594: @18548
     /*   18548 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(18662),
     /*   18553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   18556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   18559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18571 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(18616), // Rule ID 50574 //
     /*   18576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18579 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   18579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   18582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*   18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18614 */     GIR_RootConstrainSelectedInstOperands,
     /*   18615 */     // GIR_Coverage, 50574,
     /*   18615 */     GIR_EraseRootFromParent_Done,
     /*   18616 */   // Label 620: @18616
     /*   18616 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(18661), // Rule ID 50575 //
     /*   18621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18624 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   18624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   18627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*   18641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18659 */     GIR_RootConstrainSelectedInstOperands,
     /*   18660 */     // GIR_Coverage, 50575,
     /*   18660 */     GIR_EraseRootFromParent_Done,
     /*   18661 */   // Label 621: @18661
     /*   18661 */   GIM_Reject,
     /*   18662 */ // Label 619: @18662
     /*   18662 */ GIM_Reject,
     /*   18663 */ // Label 595: @18663
     /*   18663 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(18777),
     /*   18668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   18674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18686 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(18731), // Rule ID 50586 //
     /*   18691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18694 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   18694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   18697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*   18711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18729 */     GIR_RootConstrainSelectedInstOperands,
     /*   18730 */     // GIR_Coverage, 50586,
     /*   18730 */     GIR_EraseRootFromParent_Done,
     /*   18731 */   // Label 623: @18731
     /*   18731 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(18776), // Rule ID 50587 //
     /*   18736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18739 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   18739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   18742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*   18756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18774 */     GIR_RootConstrainSelectedInstOperands,
     /*   18775 */     // GIR_Coverage, 50587,
     /*   18775 */     GIR_EraseRootFromParent_Done,
     /*   18776 */   // Label 624: @18776
     /*   18776 */   GIM_Reject,
     /*   18777 */ // Label 622: @18777
     /*   18777 */ GIM_Reject,
     /*   18778 */ // Label 596: @18778
     /*   18778 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(18892),
     /*   18783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   18789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18801 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(18846), // Rule ID 50594 //
     /*   18806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18809 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   18809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*   18826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18844 */     GIR_RootConstrainSelectedInstOperands,
     /*   18845 */     // GIR_Coverage, 50594,
     /*   18845 */     GIR_EraseRootFromParent_Done,
     /*   18846 */   // Label 626: @18846
     /*   18846 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(18891), // Rule ID 50595 //
     /*   18851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18854 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*   18871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18889 */     GIR_RootConstrainSelectedInstOperands,
     /*   18890 */     // GIR_Coverage, 50595,
     /*   18890 */     GIR_EraseRootFromParent_Done,
     /*   18891 */   // Label 627: @18891
     /*   18891 */   GIM_Reject,
     /*   18892 */ // Label 625: @18892
     /*   18892 */ GIM_Reject,
     /*   18893 */ // Label 597: @18893
     /*   18893 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19007),
     /*   18898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18916 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(18961), // Rule ID 50610 //
     /*   18921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   18924 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   18924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   18927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*   18941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   18956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18959 */     GIR_RootConstrainSelectedInstOperands,
     /*   18960 */     // GIR_Coverage, 50610,
     /*   18960 */     GIR_EraseRootFromParent_Done,
     /*   18961 */   // Label 629: @18961
     /*   18961 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19006), // Rule ID 50611 //
     /*   18966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   18969 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   18969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   18972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*   18986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   19001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19004 */     GIR_RootConstrainSelectedInstOperands,
     /*   19005 */     // GIR_Coverage, 50611,
     /*   19005 */     GIR_EraseRootFromParent_Done,
     /*   19006 */   // Label 630: @19006
     /*   19006 */   GIM_Reject,
     /*   19007 */ // Label 628: @19007
     /*   19007 */ GIM_Reject,
     /*   19008 */ // Label 598: @19008
     /*   19008 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19122),
     /*   19013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   19019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19031 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19076), // Rule ID 50578 //
     /*   19036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19039 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   19042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*   19056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19074 */     GIR_RootConstrainSelectedInstOperands,
     /*   19075 */     // GIR_Coverage, 50578,
     /*   19075 */     GIR_EraseRootFromParent_Done,
     /*   19076 */   // Label 632: @19076
     /*   19076 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19121), // Rule ID 50579 //
     /*   19081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19084 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   19084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   19087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*   19101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19119 */     GIR_RootConstrainSelectedInstOperands,
     /*   19120 */     // GIR_Coverage, 50579,
     /*   19120 */     GIR_EraseRootFromParent_Done,
     /*   19121 */   // Label 633: @19121
     /*   19121 */   GIM_Reject,
     /*   19122 */ // Label 631: @19122
     /*   19122 */ GIM_Reject,
     /*   19123 */ // Label 599: @19123
     /*   19123 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19237),
     /*   19128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   19131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   19134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19146 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19191), // Rule ID 50590 //
     /*   19151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19154 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   19154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*   19171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19189 */     GIR_RootConstrainSelectedInstOperands,
     /*   19190 */     // GIR_Coverage, 50590,
     /*   19190 */     GIR_EraseRootFromParent_Done,
     /*   19191 */   // Label 635: @19191
     /*   19191 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19236), // Rule ID 50591 //
     /*   19196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19199 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   19199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*   19216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19234 */     GIR_RootConstrainSelectedInstOperands,
     /*   19235 */     // GIR_Coverage, 50591,
     /*   19235 */     GIR_EraseRootFromParent_Done,
     /*   19236 */   // Label 636: @19236
     /*   19236 */   GIM_Reject,
     /*   19237 */ // Label 634: @19237
     /*   19237 */ GIM_Reject,
     /*   19238 */ // Label 600: @19238
     /*   19238 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19352),
     /*   19243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   19246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   19249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19261 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19306), // Rule ID 50606 //
     /*   19266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19269 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   19272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*   19286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19304 */     GIR_RootConstrainSelectedInstOperands,
     /*   19305 */     // GIR_Coverage, 50606,
     /*   19305 */     GIR_EraseRootFromParent_Done,
     /*   19306 */   // Label 638: @19306
     /*   19306 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19351), // Rule ID 50607 //
     /*   19311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19314 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   19317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*   19331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19349 */     GIR_RootConstrainSelectedInstOperands,
     /*   19350 */     // GIR_Coverage, 50607,
     /*   19350 */     GIR_EraseRootFromParent_Done,
     /*   19351 */   // Label 639: @19351
     /*   19351 */   GIM_Reject,
     /*   19352 */ // Label 637: @19352
     /*   19352 */ GIM_Reject,
     /*   19353 */ // Label 601: @19353
     /*   19353 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19467),
     /*   19358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   19361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   19364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19376 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19421), // Rule ID 50650 //
     /*   19381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   19384 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   19384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   19387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*   19401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   19416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19419 */     GIR_RootConstrainSelectedInstOperands,
     /*   19420 */     // GIR_Coverage, 50650,
     /*   19420 */     GIR_EraseRootFromParent_Done,
     /*   19421 */   // Label 641: @19421
     /*   19421 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19466), // Rule ID 50651 //
     /*   19426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   19429 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   19429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   19432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*   19446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   19461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19464 */     GIR_RootConstrainSelectedInstOperands,
     /*   19465 */     // GIR_Coverage, 50651,
     /*   19465 */     GIR_EraseRootFromParent_Done,
     /*   19466 */   // Label 642: @19466
     /*   19466 */   GIM_Reject,
     /*   19467 */ // Label 640: @19467
     /*   19467 */ GIM_Reject,
     /*   19468 */ // Label 602: @19468
     /*   19468 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(19582),
     /*   19473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   19476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   19479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19491 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(19536), // Rule ID 50582 //
     /*   19496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19499 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   19502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*   19516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19534 */     GIR_RootConstrainSelectedInstOperands,
     /*   19535 */     // GIR_Coverage, 50582,
     /*   19535 */     GIR_EraseRootFromParent_Done,
     /*   19536 */   // Label 644: @19536
     /*   19536 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(19581), // Rule ID 50583 //
     /*   19541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19544 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   19544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   19547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*   19561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19579 */     GIR_RootConstrainSelectedInstOperands,
     /*   19580 */     // GIR_Coverage, 50583,
     /*   19580 */     GIR_EraseRootFromParent_Done,
     /*   19581 */   // Label 645: @19581
     /*   19581 */   GIM_Reject,
     /*   19582 */ // Label 643: @19582
     /*   19582 */ GIM_Reject,
     /*   19583 */ // Label 603: @19583
     /*   19583 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(19697),
     /*   19588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   19591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   19594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19606 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(19651), // Rule ID 50602 //
     /*   19611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19614 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   19614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   19617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*   19631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19649 */     GIR_RootConstrainSelectedInstOperands,
     /*   19650 */     // GIR_Coverage, 50602,
     /*   19650 */     GIR_EraseRootFromParent_Done,
     /*   19651 */   // Label 647: @19651
     /*   19651 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(19696), // Rule ID 50603 //
     /*   19656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19659 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   19659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   19662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*   19676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19694 */     GIR_RootConstrainSelectedInstOperands,
     /*   19695 */     // GIR_Coverage, 50603,
     /*   19695 */     GIR_EraseRootFromParent_Done,
     /*   19696 */   // Label 648: @19696
     /*   19696 */   GIM_Reject,
     /*   19697 */ // Label 646: @19697
     /*   19697 */ GIM_Reject,
     /*   19698 */ // Label 604: @19698
     /*   19698 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(19812),
     /*   19703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   19706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   19709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   19721 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(19766), // Rule ID 50638 //
     /*   19726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19729 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   19732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*   19746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19764 */     GIR_RootConstrainSelectedInstOperands,
     /*   19765 */     // GIR_Coverage, 50638,
     /*   19765 */     GIR_EraseRootFromParent_Done,
     /*   19766 */   // Label 650: @19766
     /*   19766 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(19811), // Rule ID 50639 //
     /*   19771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19774 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   19777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*   19791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19809 */     GIR_RootConstrainSelectedInstOperands,
     /*   19810 */     // GIR_Coverage, 50639,
     /*   19810 */     GIR_EraseRootFromParent_Done,
     /*   19811 */   // Label 651: @19811
     /*   19811 */   GIM_Reject,
     /*   19812 */ // Label 649: @19812
     /*   19812 */ GIM_Reject,
     /*   19813 */ // Label 605: @19813
     /*   19813 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(19927),
     /*   19818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   19821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   19824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   19828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   19832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   19836 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(19881), // Rule ID 50654 //
     /*   19841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   19844 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   19844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   19847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*   19861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   19876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19879 */     GIR_RootConstrainSelectedInstOperands,
     /*   19880 */     // GIR_Coverage, 50654,
     /*   19880 */     GIR_EraseRootFromParent_Done,
     /*   19881 */   // Label 653: @19881
     /*   19881 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(19926), // Rule ID 50655 //
     /*   19886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   19889 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   19889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   19892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*   19906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19924 */     GIR_RootConstrainSelectedInstOperands,
     /*   19925 */     // GIR_Coverage, 50655,
     /*   19925 */     GIR_EraseRootFromParent_Done,
     /*   19926 */   // Label 654: @19926
     /*   19926 */   GIM_Reject,
     /*   19927 */ // Label 652: @19927
     /*   19927 */ GIM_Reject,
     /*   19928 */ // Label 606: @19928
     /*   19928 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(20042),
     /*   19933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   19936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   19939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19951 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(19996), // Rule ID 50598 //
     /*   19956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19959 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   19962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*   19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   19983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19994 */     GIR_RootConstrainSelectedInstOperands,
     /*   19995 */     // GIR_Coverage, 50598,
     /*   19995 */     GIR_EraseRootFromParent_Done,
     /*   19996 */   // Label 656: @19996
     /*   19996 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(20041), // Rule ID 50599 //
     /*   20001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20004 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   20004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   20007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*   20021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20039 */     GIR_RootConstrainSelectedInstOperands,
     /*   20040 */     // GIR_Coverage, 50599,
     /*   20040 */     GIR_EraseRootFromParent_Done,
     /*   20041 */   // Label 657: @20041
     /*   20041 */   GIM_Reject,
     /*   20042 */ // Label 655: @20042
     /*   20042 */ GIM_Reject,
     /*   20043 */ // Label 607: @20043
     /*   20043 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(20157),
     /*   20048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   20051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   20054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20066 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20111), // Rule ID 50626 //
     /*   20071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20074 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   20074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   20077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*   20091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20109 */     GIR_RootConstrainSelectedInstOperands,
     /*   20110 */     // GIR_Coverage, 50626,
     /*   20110 */     GIR_EraseRootFromParent_Done,
     /*   20111 */   // Label 659: @20111
     /*   20111 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20156), // Rule ID 50627 //
     /*   20116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20119 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   20119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   20122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*   20136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20154 */     GIR_RootConstrainSelectedInstOperands,
     /*   20155 */     // GIR_Coverage, 50627,
     /*   20155 */     GIR_EraseRootFromParent_Done,
     /*   20156 */   // Label 660: @20156
     /*   20156 */   GIM_Reject,
     /*   20157 */ // Label 658: @20157
     /*   20157 */ GIM_Reject,
     /*   20158 */ // Label 608: @20158
     /*   20158 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20272),
     /*   20163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   20166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   20169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20181 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20226), // Rule ID 50642 //
     /*   20186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20189 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   20192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*   20206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20224 */     GIR_RootConstrainSelectedInstOperands,
     /*   20225 */     // GIR_Coverage, 50642,
     /*   20225 */     GIR_EraseRootFromParent_Done,
     /*   20226 */   // Label 662: @20226
     /*   20226 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20271), // Rule ID 50643 //
     /*   20231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20234 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   20237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*   20251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20269 */     GIR_RootConstrainSelectedInstOperands,
     /*   20270 */     // GIR_Coverage, 50643,
     /*   20270 */     GIR_EraseRootFromParent_Done,
     /*   20271 */   // Label 663: @20271
     /*   20271 */   GIM_Reject,
     /*   20272 */ // Label 661: @20272
     /*   20272 */ GIM_Reject,
     /*   20273 */ // Label 609: @20273
     /*   20273 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20387),
     /*   20278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   20281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   20284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20296 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(20341), // Rule ID 50658 //
     /*   20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20304 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   20304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   20307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*   20321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20339 */     GIR_RootConstrainSelectedInstOperands,
     /*   20340 */     // GIR_Coverage, 50658,
     /*   20340 */     GIR_EraseRootFromParent_Done,
     /*   20341 */   // Label 665: @20341
     /*   20341 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(20386), // Rule ID 50659 //
     /*   20346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20349 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   20349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   20352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*   20366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20384 */     GIR_RootConstrainSelectedInstOperands,
     /*   20385 */     // GIR_Coverage, 50659,
     /*   20385 */     GIR_EraseRootFromParent_Done,
     /*   20386 */   // Label 666: @20386
     /*   20386 */   GIM_Reject,
     /*   20387 */ // Label 664: @20387
     /*   20387 */ GIM_Reject,
     /*   20388 */ // Label 610: @20388
     /*   20388 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(20502),
     /*   20393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   20396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   20399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   20411 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(20456), // Rule ID 50614 //
     /*   20416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20419 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   20419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   20422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*   20436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20454 */     GIR_RootConstrainSelectedInstOperands,
     /*   20455 */     // GIR_Coverage, 50614,
     /*   20455 */     GIR_EraseRootFromParent_Done,
     /*   20456 */   // Label 668: @20456
     /*   20456 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(20501), // Rule ID 50615 //
     /*   20461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20464 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   20464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   20467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*   20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20499 */     GIR_RootConstrainSelectedInstOperands,
     /*   20500 */     // GIR_Coverage, 50615,
     /*   20500 */     GIR_EraseRootFromParent_Done,
     /*   20501 */   // Label 669: @20501
     /*   20501 */   GIM_Reject,
     /*   20502 */ // Label 667: @20502
     /*   20502 */ GIM_Reject,
     /*   20503 */ // Label 611: @20503
     /*   20503 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(20617),
     /*   20508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   20511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   20514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20526 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(20571), // Rule ID 50630 //
     /*   20531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20534 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   20534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   20537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*   20551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20569 */     GIR_RootConstrainSelectedInstOperands,
     /*   20570 */     // GIR_Coverage, 50630,
     /*   20570 */     GIR_EraseRootFromParent_Done,
     /*   20571 */   // Label 671: @20571
     /*   20571 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(20616), // Rule ID 50631 //
     /*   20576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20579 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   20579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   20582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*   20596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20614 */     GIR_RootConstrainSelectedInstOperands,
     /*   20615 */     // GIR_Coverage, 50631,
     /*   20615 */     GIR_EraseRootFromParent_Done,
     /*   20616 */   // Label 672: @20616
     /*   20616 */   GIM_Reject,
     /*   20617 */ // Label 670: @20617
     /*   20617 */ GIM_Reject,
     /*   20618 */ // Label 612: @20618
     /*   20618 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(20732),
     /*   20623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   20626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   20629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20641 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(20686), // Rule ID 50646 //
     /*   20646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20649 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   20652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*   20666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20684 */     GIR_RootConstrainSelectedInstOperands,
     /*   20685 */     // GIR_Coverage, 50646,
     /*   20685 */     GIR_EraseRootFromParent_Done,
     /*   20686 */   // Label 674: @20686
     /*   20686 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(20731), // Rule ID 50647 //
     /*   20691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20694 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   20697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*   20711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20729 */     GIR_RootConstrainSelectedInstOperands,
     /*   20730 */     // GIR_Coverage, 50647,
     /*   20730 */     GIR_EraseRootFromParent_Done,
     /*   20731 */   // Label 675: @20731
     /*   20731 */   GIM_Reject,
     /*   20732 */ // Label 673: @20732
     /*   20732 */ GIM_Reject,
     /*   20733 */ // Label 613: @20733
     /*   20733 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(20847),
     /*   20738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   20741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   20744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   20756 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(20801), // Rule ID 50618 //
     /*   20761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20764 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   20764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   20767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*   20781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20799 */     GIR_RootConstrainSelectedInstOperands,
     /*   20800 */     // GIR_Coverage, 50618,
     /*   20800 */     GIR_EraseRootFromParent_Done,
     /*   20801 */   // Label 677: @20801
     /*   20801 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(20846), // Rule ID 50619 //
     /*   20806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20809 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   20809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   20812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*   20826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20844 */     GIR_RootConstrainSelectedInstOperands,
     /*   20845 */     // GIR_Coverage, 50619,
     /*   20845 */     GIR_EraseRootFromParent_Done,
     /*   20846 */   // Label 678: @20846
     /*   20846 */   GIM_Reject,
     /*   20847 */ // Label 676: @20847
     /*   20847 */ GIM_Reject,
     /*   20848 */ // Label 614: @20848
     /*   20848 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(20962),
     /*   20853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   20856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   20859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20871 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(20916), // Rule ID 50634 //
     /*   20876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20879 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   20879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   20882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*   20896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20914 */     GIR_RootConstrainSelectedInstOperands,
     /*   20915 */     // GIR_Coverage, 50634,
     /*   20915 */     GIR_EraseRootFromParent_Done,
     /*   20916 */   // Label 680: @20916
     /*   20916 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(20961), // Rule ID 50635 //
     /*   20921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20924 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   20924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   20927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*   20941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20959 */     GIR_RootConstrainSelectedInstOperands,
     /*   20960 */     // GIR_Coverage, 50635,
     /*   20960 */     GIR_EraseRootFromParent_Done,
     /*   20961 */   // Label 681: @20961
     /*   20961 */   GIM_Reject,
     /*   20962 */ // Label 679: @20962
     /*   20962 */ GIM_Reject,
     /*   20963 */ // Label 615: @20963
     /*   20963 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(21077),
     /*   20968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   20971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   20974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   20986 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(21031), // Rule ID 50622 //
     /*   20991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20994 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   20994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   20997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*   21011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21029 */     GIR_RootConstrainSelectedInstOperands,
     /*   21030 */     // GIR_Coverage, 50622,
     /*   21030 */     GIR_EraseRootFromParent_Done,
     /*   21031 */   // Label 683: @21031
     /*   21031 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(21076), // Rule ID 50623 //
     /*   21036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21039 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   21042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*   21056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21074 */     GIR_RootConstrainSelectedInstOperands,
     /*   21075 */     // GIR_Coverage, 50623,
     /*   21075 */     GIR_EraseRootFromParent_Done,
     /*   21076 */   // Label 684: @21076
     /*   21076 */   GIM_Reject,
     /*   21077 */ // Label 682: @21077
     /*   21077 */ GIM_Reject,
     /*   21078 */ // Label 616: @21078
     /*   21078 */ GIM_Reject,
     /*   21079 */ // Label 5: @21079
     /*   21079 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 709*/ GIMT_Encode4(23857),
     /*   21090 */ /*GILLT_s32*//*Label 685*/ GIMT_Encode4(21214),
     /*   21094 */ /*GILLT_s64*//*Label 686*/ GIMT_Encode4(21248), GIMT_Encode4(0),
     /*   21102 */ /*GILLT_nxv1s8*//*Label 687*/ GIMT_Encode4(21327),
     /*   21106 */ /*GILLT_nxv1s16*//*Label 688*/ GIMT_Encode4(21442),
     /*   21110 */ /*GILLT_nxv1s32*//*Label 689*/ GIMT_Encode4(21557),
     /*   21114 */ /*GILLT_nxv1s64*//*Label 690*/ GIMT_Encode4(21672), GIMT_Encode4(0),
     /*   21122 */ /*GILLT_nxv2s8*//*Label 691*/ GIMT_Encode4(21787),
     /*   21126 */ /*GILLT_nxv2s16*//*Label 692*/ GIMT_Encode4(21902),
     /*   21130 */ /*GILLT_nxv2s32*//*Label 693*/ GIMT_Encode4(22017),
     /*   21134 */ /*GILLT_nxv2s64*//*Label 694*/ GIMT_Encode4(22132), GIMT_Encode4(0),
     /*   21142 */ /*GILLT_nxv4s8*//*Label 695*/ GIMT_Encode4(22247),
     /*   21146 */ /*GILLT_nxv4s16*//*Label 696*/ GIMT_Encode4(22362),
     /*   21150 */ /*GILLT_nxv4s32*//*Label 697*/ GIMT_Encode4(22477),
     /*   21154 */ /*GILLT_nxv4s64*//*Label 698*/ GIMT_Encode4(22592), GIMT_Encode4(0),
     /*   21162 */ /*GILLT_nxv8s8*//*Label 699*/ GIMT_Encode4(22707),
     /*   21166 */ /*GILLT_nxv8s16*//*Label 700*/ GIMT_Encode4(22822),
     /*   21170 */ /*GILLT_nxv8s32*//*Label 701*/ GIMT_Encode4(22937),
     /*   21174 */ /*GILLT_nxv8s64*//*Label 702*/ GIMT_Encode4(23052), GIMT_Encode4(0),
     /*   21182 */ /*GILLT_nxv16s8*//*Label 703*/ GIMT_Encode4(23167),
     /*   21186 */ /*GILLT_nxv16s16*//*Label 704*/ GIMT_Encode4(23282),
     /*   21190 */ /*GILLT_nxv16s32*//*Label 705*/ GIMT_Encode4(23397), GIMT_Encode4(0),
     /*   21198 */ /*GILLT_nxv32s8*//*Label 706*/ GIMT_Encode4(23512),
     /*   21202 */ /*GILLT_nxv32s16*//*Label 707*/ GIMT_Encode4(23627), GIMT_Encode4(0),
     /*   21210 */ /*GILLT_nxv64s8*//*Label 708*/ GIMT_Encode4(23742),
     /*   21214 */ // Label 685: @21214
     /*   21214 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(21247), // Rule ID 300 //
     /*   21219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*   21222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   21225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   21228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21240 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   21240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*   21245 */   GIR_RootConstrainSelectedInstOperands,
     /*   21246 */   // GIR_Coverage, 300,
     /*   21246 */   GIR_Done,
     /*   21247 */ // Label 710: @21247
     /*   21247 */ GIM_Reject,
     /*   21248 */ // Label 686: @21248
     /*   21248 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(21326),
     /*   21253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   21256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   21259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21263 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(21302), // Rule ID 309 //
     /*   21268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*   21271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*   21278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*   21285 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   21285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*   21288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   21295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*   21300 */     GIR_RootConstrainSelectedInstOperands,
     /*   21301 */     // GIR_Coverage, 309,
     /*   21301 */     GIR_EraseRootFromParent_Done,
     /*   21302 */   // Label 712: @21302
     /*   21302 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(21325), // Rule ID 299 //
     /*   21307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*   21310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   21318 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   21318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*   21323 */     GIR_RootConstrainSelectedInstOperands,
     /*   21324 */     // GIR_Coverage, 299,
     /*   21324 */     GIR_Done,
     /*   21325 */   // Label 713: @21325
     /*   21325 */   GIM_Reject,
     /*   21326 */ // Label 711: @21326
     /*   21326 */ GIM_Reject,
     /*   21327 */ // Label 687: @21327
     /*   21327 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(21441),
     /*   21332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   21335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   21338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21350 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(21395), // Rule ID 50838 //
     /*   21355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21358 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   21361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*   21375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21393 */     GIR_RootConstrainSelectedInstOperands,
     /*   21394 */     // GIR_Coverage, 50838,
     /*   21394 */     GIR_EraseRootFromParent_Done,
     /*   21395 */   // Label 715: @21395
     /*   21395 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(21440), // Rule ID 50839 //
     /*   21400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21403 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   21406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*   21420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21438 */     GIR_RootConstrainSelectedInstOperands,
     /*   21439 */     // GIR_Coverage, 50839,
     /*   21439 */     GIR_EraseRootFromParent_Done,
     /*   21440 */   // Label 716: @21440
     /*   21440 */   GIM_Reject,
     /*   21441 */ // Label 714: @21441
     /*   21441 */ GIM_Reject,
     /*   21442 */ // Label 688: @21442
     /*   21442 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(21556),
     /*   21447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   21450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   21453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21465 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(21510), // Rule ID 50850 //
     /*   21470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21473 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   21473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   21476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*   21490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21508 */     GIR_RootConstrainSelectedInstOperands,
     /*   21509 */     // GIR_Coverage, 50850,
     /*   21509 */     GIR_EraseRootFromParent_Done,
     /*   21510 */   // Label 718: @21510
     /*   21510 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(21555), // Rule ID 50851 //
     /*   21515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21518 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   21518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   21521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*   21535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21553 */     GIR_RootConstrainSelectedInstOperands,
     /*   21554 */     // GIR_Coverage, 50851,
     /*   21554 */     GIR_EraseRootFromParent_Done,
     /*   21555 */   // Label 719: @21555
     /*   21555 */   GIM_Reject,
     /*   21556 */ // Label 717: @21556
     /*   21556 */ GIM_Reject,
     /*   21557 */ // Label 689: @21557
     /*   21557 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(21671),
     /*   21562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   21568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21580 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(21625), // Rule ID 50858 //
     /*   21585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21588 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   21588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   21591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*   21605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21623 */     GIR_RootConstrainSelectedInstOperands,
     /*   21624 */     // GIR_Coverage, 50858,
     /*   21624 */     GIR_EraseRootFromParent_Done,
     /*   21625 */   // Label 721: @21625
     /*   21625 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(21670), // Rule ID 50859 //
     /*   21630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21633 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   21633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   21636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*   21650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21668 */     GIR_RootConstrainSelectedInstOperands,
     /*   21669 */     // GIR_Coverage, 50859,
     /*   21669 */     GIR_EraseRootFromParent_Done,
     /*   21670 */   // Label 722: @21670
     /*   21670 */   GIM_Reject,
     /*   21671 */ // Label 720: @21671
     /*   21671 */ GIM_Reject,
     /*   21672 */ // Label 690: @21672
     /*   21672 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(21786),
     /*   21677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   21680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   21683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21695 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(21740), // Rule ID 50874 //
     /*   21700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21703 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*   21720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21738 */     GIR_RootConstrainSelectedInstOperands,
     /*   21739 */     // GIR_Coverage, 50874,
     /*   21739 */     GIR_EraseRootFromParent_Done,
     /*   21740 */   // Label 724: @21740
     /*   21740 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(21785), // Rule ID 50875 //
     /*   21745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21748 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*   21765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21783 */     GIR_RootConstrainSelectedInstOperands,
     /*   21784 */     // GIR_Coverage, 50875,
     /*   21784 */     GIR_EraseRootFromParent_Done,
     /*   21785 */   // Label 725: @21785
     /*   21785 */   GIM_Reject,
     /*   21786 */ // Label 723: @21786
     /*   21786 */ GIM_Reject,
     /*   21787 */ // Label 691: @21787
     /*   21787 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(21901),
     /*   21792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21810 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(21855), // Rule ID 50842 //
     /*   21815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21818 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*   21835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21853 */     GIR_RootConstrainSelectedInstOperands,
     /*   21854 */     // GIR_Coverage, 50842,
     /*   21854 */     GIR_EraseRootFromParent_Done,
     /*   21855 */   // Label 727: @21855
     /*   21855 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(21900), // Rule ID 50843 //
     /*   21860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21863 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*   21880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21898 */     GIR_RootConstrainSelectedInstOperands,
     /*   21899 */     // GIR_Coverage, 50843,
     /*   21899 */     GIR_EraseRootFromParent_Done,
     /*   21900 */   // Label 728: @21900
     /*   21900 */   GIM_Reject,
     /*   21901 */ // Label 726: @21901
     /*   21901 */ GIM_Reject,
     /*   21902 */ // Label 692: @21902
     /*   21902 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(22016),
     /*   21907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21925 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(21970), // Rule ID 50854 //
     /*   21930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21933 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   21933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   21936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*   21950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21968 */     GIR_RootConstrainSelectedInstOperands,
     /*   21969 */     // GIR_Coverage, 50854,
     /*   21969 */     GIR_EraseRootFromParent_Done,
     /*   21970 */   // Label 730: @21970
     /*   21970 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(22015), // Rule ID 50855 //
     /*   21975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21978 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   21978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   21981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*   21995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22013 */     GIR_RootConstrainSelectedInstOperands,
     /*   22014 */     // GIR_Coverage, 50855,
     /*   22014 */     GIR_EraseRootFromParent_Done,
     /*   22015 */   // Label 731: @22015
     /*   22015 */   GIM_Reject,
     /*   22016 */ // Label 729: @22016
     /*   22016 */ GIM_Reject,
     /*   22017 */ // Label 693: @22017
     /*   22017 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(22131),
     /*   22022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   22025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   22028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22040 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(22085), // Rule ID 50870 //
     /*   22045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22048 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   22048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*   22065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22083 */     GIR_RootConstrainSelectedInstOperands,
     /*   22084 */     // GIR_Coverage, 50870,
     /*   22084 */     GIR_EraseRootFromParent_Done,
     /*   22085 */   // Label 733: @22085
     /*   22085 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(22130), // Rule ID 50871 //
     /*   22090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22093 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   22093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*   22110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22128 */     GIR_RootConstrainSelectedInstOperands,
     /*   22129 */     // GIR_Coverage, 50871,
     /*   22129 */     GIR_EraseRootFromParent_Done,
     /*   22130 */   // Label 734: @22130
     /*   22130 */   GIM_Reject,
     /*   22131 */ // Label 732: @22131
     /*   22131 */ GIM_Reject,
     /*   22132 */ // Label 694: @22132
     /*   22132 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(22246),
     /*   22137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   22140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   22143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22155 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(22200), // Rule ID 50914 //
     /*   22160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   22163 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   22163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   22166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*   22180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   22195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22198 */     GIR_RootConstrainSelectedInstOperands,
     /*   22199 */     // GIR_Coverage, 50914,
     /*   22199 */     GIR_EraseRootFromParent_Done,
     /*   22200 */   // Label 736: @22200
     /*   22200 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(22245), // Rule ID 50915 //
     /*   22205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   22208 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   22208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   22211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*   22225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   22240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22243 */     GIR_RootConstrainSelectedInstOperands,
     /*   22244 */     // GIR_Coverage, 50915,
     /*   22244 */     GIR_EraseRootFromParent_Done,
     /*   22245 */   // Label 737: @22245
     /*   22245 */   GIM_Reject,
     /*   22246 */ // Label 735: @22246
     /*   22246 */ GIM_Reject,
     /*   22247 */ // Label 695: @22247
     /*   22247 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(22361),
     /*   22252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   22255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   22258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22270 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(22315), // Rule ID 50846 //
     /*   22275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22278 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   22278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   22281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*   22295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22313 */     GIR_RootConstrainSelectedInstOperands,
     /*   22314 */     // GIR_Coverage, 50846,
     /*   22314 */     GIR_EraseRootFromParent_Done,
     /*   22315 */   // Label 739: @22315
     /*   22315 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(22360), // Rule ID 50847 //
     /*   22320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22323 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   22323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   22326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*   22340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22358 */     GIR_RootConstrainSelectedInstOperands,
     /*   22359 */     // GIR_Coverage, 50847,
     /*   22359 */     GIR_EraseRootFromParent_Done,
     /*   22360 */   // Label 740: @22360
     /*   22360 */   GIM_Reject,
     /*   22361 */ // Label 738: @22361
     /*   22361 */ GIM_Reject,
     /*   22362 */ // Label 696: @22362
     /*   22362 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(22476),
     /*   22367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   22370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   22373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22385 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(22430), // Rule ID 50866 //
     /*   22390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22393 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   22393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   22396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*   22410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22428 */     GIR_RootConstrainSelectedInstOperands,
     /*   22429 */     // GIR_Coverage, 50866,
     /*   22429 */     GIR_EraseRootFromParent_Done,
     /*   22430 */   // Label 742: @22430
     /*   22430 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(22475), // Rule ID 50867 //
     /*   22435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22438 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   22438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   22441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*   22455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22473 */     GIR_RootConstrainSelectedInstOperands,
     /*   22474 */     // GIR_Coverage, 50867,
     /*   22474 */     GIR_EraseRootFromParent_Done,
     /*   22475 */   // Label 743: @22475
     /*   22475 */   GIM_Reject,
     /*   22476 */ // Label 741: @22476
     /*   22476 */ GIM_Reject,
     /*   22477 */ // Label 697: @22477
     /*   22477 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(22591),
     /*   22482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   22485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   22488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22500 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(22545), // Rule ID 50902 //
     /*   22505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22508 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   22508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   22511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*   22525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22543 */     GIR_RootConstrainSelectedInstOperands,
     /*   22544 */     // GIR_Coverage, 50902,
     /*   22544 */     GIR_EraseRootFromParent_Done,
     /*   22545 */   // Label 745: @22545
     /*   22545 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(22590), // Rule ID 50903 //
     /*   22550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22553 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   22553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   22556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*   22570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22588 */     GIR_RootConstrainSelectedInstOperands,
     /*   22589 */     // GIR_Coverage, 50903,
     /*   22589 */     GIR_EraseRootFromParent_Done,
     /*   22590 */   // Label 746: @22590
     /*   22590 */   GIM_Reject,
     /*   22591 */ // Label 744: @22591
     /*   22591 */ GIM_Reject,
     /*   22592 */ // Label 698: @22592
     /*   22592 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(22706),
     /*   22597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   22600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   22603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22615 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(22660), // Rule ID 50918 //
     /*   22620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   22623 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   22623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   22626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*   22640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   22655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22658 */     GIR_RootConstrainSelectedInstOperands,
     /*   22659 */     // GIR_Coverage, 50918,
     /*   22659 */     GIR_EraseRootFromParent_Done,
     /*   22660 */   // Label 748: @22660
     /*   22660 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(22705), // Rule ID 50919 //
     /*   22665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   22668 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   22668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   22671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*   22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   22700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22703 */     GIR_RootConstrainSelectedInstOperands,
     /*   22704 */     // GIR_Coverage, 50919,
     /*   22704 */     GIR_EraseRootFromParent_Done,
     /*   22705 */   // Label 749: @22705
     /*   22705 */   GIM_Reject,
     /*   22706 */ // Label 747: @22706
     /*   22706 */ GIM_Reject,
     /*   22707 */ // Label 699: @22707
     /*   22707 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(22821),
     /*   22712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   22715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   22718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22730 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(22775), // Rule ID 50862 //
     /*   22735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22738 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   22738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   22741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*   22755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22773 */     GIR_RootConstrainSelectedInstOperands,
     /*   22774 */     // GIR_Coverage, 50862,
     /*   22774 */     GIR_EraseRootFromParent_Done,
     /*   22775 */   // Label 751: @22775
     /*   22775 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(22820), // Rule ID 50863 //
     /*   22780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22783 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   22783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   22786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*   22800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22818 */     GIR_RootConstrainSelectedInstOperands,
     /*   22819 */     // GIR_Coverage, 50863,
     /*   22819 */     GIR_EraseRootFromParent_Done,
     /*   22820 */   // Label 752: @22820
     /*   22820 */   GIM_Reject,
     /*   22821 */ // Label 750: @22821
     /*   22821 */ GIM_Reject,
     /*   22822 */ // Label 700: @22822
     /*   22822 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(22936),
     /*   22827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   22830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   22833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   22845 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(22890), // Rule ID 50890 //
     /*   22850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22853 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   22853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   22856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*   22870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22888 */     GIR_RootConstrainSelectedInstOperands,
     /*   22889 */     // GIR_Coverage, 50890,
     /*   22889 */     GIR_EraseRootFromParent_Done,
     /*   22890 */   // Label 754: @22890
     /*   22890 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(22935), // Rule ID 50891 //
     /*   22895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22898 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   22898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   22901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*   22915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22933 */     GIR_RootConstrainSelectedInstOperands,
     /*   22934 */     // GIR_Coverage, 50891,
     /*   22934 */     GIR_EraseRootFromParent_Done,
     /*   22935 */   // Label 755: @22935
     /*   22935 */   GIM_Reject,
     /*   22936 */ // Label 753: @22936
     /*   22936 */ GIM_Reject,
     /*   22937 */ // Label 701: @22937
     /*   22937 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(23051),
     /*   22942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   22945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   22948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   22960 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(23005), // Rule ID 50906 //
     /*   22965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22968 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   22968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   22971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*   22985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23003 */     GIR_RootConstrainSelectedInstOperands,
     /*   23004 */     // GIR_Coverage, 50906,
     /*   23004 */     GIR_EraseRootFromParent_Done,
     /*   23005 */   // Label 757: @23005
     /*   23005 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(23050), // Rule ID 50907 //
     /*   23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23013 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   23013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   23016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*   23030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23048 */     GIR_RootConstrainSelectedInstOperands,
     /*   23049 */     // GIR_Coverage, 50907,
     /*   23049 */     GIR_EraseRootFromParent_Done,
     /*   23050 */   // Label 758: @23050
     /*   23050 */   GIM_Reject,
     /*   23051 */ // Label 756: @23051
     /*   23051 */ GIM_Reject,
     /*   23052 */ // Label 702: @23052
     /*   23052 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(23166),
     /*   23057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   23060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   23063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23075 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(23120), // Rule ID 50922 //
     /*   23080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   23083 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   23083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   23086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*   23100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   23115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23118 */     GIR_RootConstrainSelectedInstOperands,
     /*   23119 */     // GIR_Coverage, 50922,
     /*   23119 */     GIR_EraseRootFromParent_Done,
     /*   23120 */   // Label 760: @23120
     /*   23120 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(23165), // Rule ID 50923 //
     /*   23125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   23128 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   23128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   23131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*   23145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   23160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23163 */     GIR_RootConstrainSelectedInstOperands,
     /*   23164 */     // GIR_Coverage, 50923,
     /*   23164 */     GIR_EraseRootFromParent_Done,
     /*   23165 */   // Label 761: @23165
     /*   23165 */   GIM_Reject,
     /*   23166 */ // Label 759: @23166
     /*   23166 */ GIM_Reject,
     /*   23167 */ // Label 703: @23167
     /*   23167 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(23281),
     /*   23172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   23175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   23178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23190 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(23235), // Rule ID 50878 //
     /*   23195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23198 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   23201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*   23215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23233 */     GIR_RootConstrainSelectedInstOperands,
     /*   23234 */     // GIR_Coverage, 50878,
     /*   23234 */     GIR_EraseRootFromParent_Done,
     /*   23235 */   // Label 763: @23235
     /*   23235 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(23280), // Rule ID 50879 //
     /*   23240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23243 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   23246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*   23260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23278 */     GIR_RootConstrainSelectedInstOperands,
     /*   23279 */     // GIR_Coverage, 50879,
     /*   23279 */     GIR_EraseRootFromParent_Done,
     /*   23280 */   // Label 764: @23280
     /*   23280 */   GIM_Reject,
     /*   23281 */ // Label 762: @23281
     /*   23281 */ GIM_Reject,
     /*   23282 */ // Label 704: @23282
     /*   23282 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(23396),
     /*   23287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   23290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   23293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23305 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(23350), // Rule ID 50894 //
     /*   23310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23313 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   23313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   23316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*   23330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23348 */     GIR_RootConstrainSelectedInstOperands,
     /*   23349 */     // GIR_Coverage, 50894,
     /*   23349 */     GIR_EraseRootFromParent_Done,
     /*   23350 */   // Label 766: @23350
     /*   23350 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(23395), // Rule ID 50895 //
     /*   23355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23358 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   23358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   23361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*   23375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23393 */     GIR_RootConstrainSelectedInstOperands,
     /*   23394 */     // GIR_Coverage, 50895,
     /*   23394 */     GIR_EraseRootFromParent_Done,
     /*   23395 */   // Label 767: @23395
     /*   23395 */   GIM_Reject,
     /*   23396 */ // Label 765: @23396
     /*   23396 */ GIM_Reject,
     /*   23397 */ // Label 705: @23397
     /*   23397 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(23511),
     /*   23402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   23405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   23408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23420 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(23465), // Rule ID 50910 //
     /*   23425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23428 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   23428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   23431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*   23445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23463 */     GIR_RootConstrainSelectedInstOperands,
     /*   23464 */     // GIR_Coverage, 50910,
     /*   23464 */     GIR_EraseRootFromParent_Done,
     /*   23465 */   // Label 769: @23465
     /*   23465 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(23510), // Rule ID 50911 //
     /*   23470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23473 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   23473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   23476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*   23490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23508 */     GIR_RootConstrainSelectedInstOperands,
     /*   23509 */     // GIR_Coverage, 50911,
     /*   23509 */     GIR_EraseRootFromParent_Done,
     /*   23510 */   // Label 770: @23510
     /*   23510 */   GIM_Reject,
     /*   23511 */ // Label 768: @23511
     /*   23511 */ GIM_Reject,
     /*   23512 */ // Label 706: @23512
     /*   23512 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(23626),
     /*   23517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   23520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   23523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   23535 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(23580), // Rule ID 50882 //
     /*   23540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23543 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   23546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*   23560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23578 */     GIR_RootConstrainSelectedInstOperands,
     /*   23579 */     // GIR_Coverage, 50882,
     /*   23579 */     GIR_EraseRootFromParent_Done,
     /*   23580 */   // Label 772: @23580
     /*   23580 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(23625), // Rule ID 50883 //
     /*   23585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23588 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   23591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*   23605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23623 */     GIR_RootConstrainSelectedInstOperands,
     /*   23624 */     // GIR_Coverage, 50883,
     /*   23624 */     GIR_EraseRootFromParent_Done,
     /*   23625 */   // Label 773: @23625
     /*   23625 */   GIM_Reject,
     /*   23626 */ // Label 771: @23626
     /*   23626 */ GIM_Reject,
     /*   23627 */ // Label 707: @23627
     /*   23627 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(23741),
     /*   23632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   23635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   23638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23650 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(23695), // Rule ID 50898 //
     /*   23655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23658 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   23658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   23661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*   23675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23693 */     GIR_RootConstrainSelectedInstOperands,
     /*   23694 */     // GIR_Coverage, 50898,
     /*   23694 */     GIR_EraseRootFromParent_Done,
     /*   23695 */   // Label 775: @23695
     /*   23695 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(23740), // Rule ID 50899 //
     /*   23700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23703 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   23703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   23706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*   23720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23738 */     GIR_RootConstrainSelectedInstOperands,
     /*   23739 */     // GIR_Coverage, 50899,
     /*   23739 */     GIR_EraseRootFromParent_Done,
     /*   23740 */   // Label 776: @23740
     /*   23740 */   GIM_Reject,
     /*   23741 */ // Label 774: @23741
     /*   23741 */ GIM_Reject,
     /*   23742 */ // Label 708: @23742
     /*   23742 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(23856),
     /*   23747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   23750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   23753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   23765 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(23810), // Rule ID 50886 //
     /*   23770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23773 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   23776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*   23790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23808 */     GIR_RootConstrainSelectedInstOperands,
     /*   23809 */     // GIR_Coverage, 50886,
     /*   23809 */     GIR_EraseRootFromParent_Done,
     /*   23810 */   // Label 778: @23810
     /*   23810 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(23855), // Rule ID 50887 //
     /*   23815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23818 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   23821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*   23835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23853 */     GIR_RootConstrainSelectedInstOperands,
     /*   23854 */     // GIR_Coverage, 50887,
     /*   23854 */     GIR_EraseRootFromParent_Done,
     /*   23855 */   // Label 779: @23855
     /*   23855 */   GIM_Reject,
     /*   23856 */ // Label 777: @23856
     /*   23856 */ GIM_Reject,
     /*   23857 */ // Label 709: @23857
     /*   23857 */ GIM_Reject,
     /*   23858 */ // Label 6: @23858
     /*   23858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 804*/ GIMT_Encode4(26591),
     /*   23869 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(23993),
     /*   23873 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(24027), GIMT_Encode4(0),
     /*   23881 */ /*GILLT_nxv1s8*//*Label 782*/ GIMT_Encode4(24061),
     /*   23885 */ /*GILLT_nxv1s16*//*Label 783*/ GIMT_Encode4(24176),
     /*   23889 */ /*GILLT_nxv1s32*//*Label 784*/ GIMT_Encode4(24291),
     /*   23893 */ /*GILLT_nxv1s64*//*Label 785*/ GIMT_Encode4(24406), GIMT_Encode4(0),
     /*   23901 */ /*GILLT_nxv2s8*//*Label 786*/ GIMT_Encode4(24521),
     /*   23905 */ /*GILLT_nxv2s16*//*Label 787*/ GIMT_Encode4(24636),
     /*   23909 */ /*GILLT_nxv2s32*//*Label 788*/ GIMT_Encode4(24751),
     /*   23913 */ /*GILLT_nxv2s64*//*Label 789*/ GIMT_Encode4(24866), GIMT_Encode4(0),
     /*   23921 */ /*GILLT_nxv4s8*//*Label 790*/ GIMT_Encode4(24981),
     /*   23925 */ /*GILLT_nxv4s16*//*Label 791*/ GIMT_Encode4(25096),
     /*   23929 */ /*GILLT_nxv4s32*//*Label 792*/ GIMT_Encode4(25211),
     /*   23933 */ /*GILLT_nxv4s64*//*Label 793*/ GIMT_Encode4(25326), GIMT_Encode4(0),
     /*   23941 */ /*GILLT_nxv8s8*//*Label 794*/ GIMT_Encode4(25441),
     /*   23945 */ /*GILLT_nxv8s16*//*Label 795*/ GIMT_Encode4(25556),
     /*   23949 */ /*GILLT_nxv8s32*//*Label 796*/ GIMT_Encode4(25671),
     /*   23953 */ /*GILLT_nxv8s64*//*Label 797*/ GIMT_Encode4(25786), GIMT_Encode4(0),
     /*   23961 */ /*GILLT_nxv16s8*//*Label 798*/ GIMT_Encode4(25901),
     /*   23965 */ /*GILLT_nxv16s16*//*Label 799*/ GIMT_Encode4(26016),
     /*   23969 */ /*GILLT_nxv16s32*//*Label 800*/ GIMT_Encode4(26131), GIMT_Encode4(0),
     /*   23977 */ /*GILLT_nxv32s8*//*Label 801*/ GIMT_Encode4(26246),
     /*   23981 */ /*GILLT_nxv32s16*//*Label 802*/ GIMT_Encode4(26361), GIMT_Encode4(0),
     /*   23989 */ /*GILLT_nxv64s8*//*Label 803*/ GIMT_Encode4(26476),
     /*   23993 */ // Label 780: @23993
     /*   23993 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(24026), // Rule ID 302 //
     /*   23998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*   24001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   24004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   24007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24019 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   24019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*   24024 */   GIR_RootConstrainSelectedInstOperands,
     /*   24025 */   // GIR_Coverage, 302,
     /*   24025 */   GIR_Done,
     /*   24026 */ // Label 805: @24026
     /*   24026 */ GIM_Reject,
     /*   24027 */ // Label 781: @24027
     /*   24027 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(24060), // Rule ID 301 //
     /*   24032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*   24035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   24038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   24041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   24053 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   24053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*   24058 */   GIR_RootConstrainSelectedInstOperands,
     /*   24059 */   // GIR_Coverage, 301,
     /*   24059 */   GIR_Done,
     /*   24060 */ // Label 806: @24060
     /*   24060 */ GIM_Reject,
     /*   24061 */ // Label 782: @24061
     /*   24061 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(24175),
     /*   24066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   24069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   24072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24084 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(24129), // Rule ID 50750 //
     /*   24089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24092 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   24092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   24095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*   24109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24127 */     GIR_RootConstrainSelectedInstOperands,
     /*   24128 */     // GIR_Coverage, 50750,
     /*   24128 */     GIR_EraseRootFromParent_Done,
     /*   24129 */   // Label 808: @24129
     /*   24129 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(24174), // Rule ID 50751 //
     /*   24134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24137 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   24137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   24140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*   24154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24172 */     GIR_RootConstrainSelectedInstOperands,
     /*   24173 */     // GIR_Coverage, 50751,
     /*   24173 */     GIR_EraseRootFromParent_Done,
     /*   24174 */   // Label 809: @24174
     /*   24174 */   GIM_Reject,
     /*   24175 */ // Label 807: @24175
     /*   24175 */ GIM_Reject,
     /*   24176 */ // Label 783: @24176
     /*   24176 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(24290),
     /*   24181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   24184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   24187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24199 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(24244), // Rule ID 50762 //
     /*   24204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24207 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   24210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*   24224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24242 */     GIR_RootConstrainSelectedInstOperands,
     /*   24243 */     // GIR_Coverage, 50762,
     /*   24243 */     GIR_EraseRootFromParent_Done,
     /*   24244 */   // Label 811: @24244
     /*   24244 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(24289), // Rule ID 50763 //
     /*   24249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24252 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   24255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*   24269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24287 */     GIR_RootConstrainSelectedInstOperands,
     /*   24288 */     // GIR_Coverage, 50763,
     /*   24288 */     GIR_EraseRootFromParent_Done,
     /*   24289 */   // Label 812: @24289
     /*   24289 */   GIM_Reject,
     /*   24290 */ // Label 810: @24290
     /*   24290 */ GIM_Reject,
     /*   24291 */ // Label 784: @24291
     /*   24291 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(24405),
     /*   24296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   24299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   24302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24314 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(24359), // Rule ID 50770 //
     /*   24319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24322 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   24322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   24325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*   24339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24357 */     GIR_RootConstrainSelectedInstOperands,
     /*   24358 */     // GIR_Coverage, 50770,
     /*   24358 */     GIR_EraseRootFromParent_Done,
     /*   24359 */   // Label 814: @24359
     /*   24359 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(24404), // Rule ID 50771 //
     /*   24364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24367 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   24367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   24370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*   24384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24402 */     GIR_RootConstrainSelectedInstOperands,
     /*   24403 */     // GIR_Coverage, 50771,
     /*   24403 */     GIR_EraseRootFromParent_Done,
     /*   24404 */   // Label 815: @24404
     /*   24404 */   GIM_Reject,
     /*   24405 */ // Label 813: @24405
     /*   24405 */ GIM_Reject,
     /*   24406 */ // Label 785: @24406
     /*   24406 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(24520),
     /*   24411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   24414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   24417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24429 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(24474), // Rule ID 50786 //
     /*   24434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   24437 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   24437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   24440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*   24454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   24469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24472 */     GIR_RootConstrainSelectedInstOperands,
     /*   24473 */     // GIR_Coverage, 50786,
     /*   24473 */     GIR_EraseRootFromParent_Done,
     /*   24474 */   // Label 817: @24474
     /*   24474 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(24519), // Rule ID 50787 //
     /*   24479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   24482 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   24482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   24485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*   24499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   24514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24517 */     GIR_RootConstrainSelectedInstOperands,
     /*   24518 */     // GIR_Coverage, 50787,
     /*   24518 */     GIR_EraseRootFromParent_Done,
     /*   24519 */   // Label 818: @24519
     /*   24519 */   GIM_Reject,
     /*   24520 */ // Label 816: @24520
     /*   24520 */ GIM_Reject,
     /*   24521 */ // Label 786: @24521
     /*   24521 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(24635),
     /*   24526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   24532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24544 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(24589), // Rule ID 50754 //
     /*   24549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24552 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   24552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   24555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*   24569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24587 */     GIR_RootConstrainSelectedInstOperands,
     /*   24588 */     // GIR_Coverage, 50754,
     /*   24588 */     GIR_EraseRootFromParent_Done,
     /*   24589 */   // Label 820: @24589
     /*   24589 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(24634), // Rule ID 50755 //
     /*   24594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24597 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   24597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   24600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*   24614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24632 */     GIR_RootConstrainSelectedInstOperands,
     /*   24633 */     // GIR_Coverage, 50755,
     /*   24633 */     GIR_EraseRootFromParent_Done,
     /*   24634 */   // Label 821: @24634
     /*   24634 */   GIM_Reject,
     /*   24635 */ // Label 819: @24635
     /*   24635 */ GIM_Reject,
     /*   24636 */ // Label 787: @24636
     /*   24636 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(24750),
     /*   24641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24659 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(24704), // Rule ID 50766 //
     /*   24664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24667 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*   24684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24702 */     GIR_RootConstrainSelectedInstOperands,
     /*   24703 */     // GIR_Coverage, 50766,
     /*   24703 */     GIR_EraseRootFromParent_Done,
     /*   24704 */   // Label 823: @24704
     /*   24704 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(24749), // Rule ID 50767 //
     /*   24709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24712 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*   24729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24747 */     GIR_RootConstrainSelectedInstOperands,
     /*   24748 */     // GIR_Coverage, 50767,
     /*   24748 */     GIR_EraseRootFromParent_Done,
     /*   24749 */   // Label 824: @24749
     /*   24749 */   GIM_Reject,
     /*   24750 */ // Label 822: @24750
     /*   24750 */ GIM_Reject,
     /*   24751 */ // Label 788: @24751
     /*   24751 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(24865),
     /*   24756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24774 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(24819), // Rule ID 50782 //
     /*   24779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24782 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   24782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   24785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*   24799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24817 */     GIR_RootConstrainSelectedInstOperands,
     /*   24818 */     // GIR_Coverage, 50782,
     /*   24818 */     GIR_EraseRootFromParent_Done,
     /*   24819 */   // Label 826: @24819
     /*   24819 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(24864), // Rule ID 50783 //
     /*   24824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24827 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   24827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   24830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*   24844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24862 */     GIR_RootConstrainSelectedInstOperands,
     /*   24863 */     // GIR_Coverage, 50783,
     /*   24863 */     GIR_EraseRootFromParent_Done,
     /*   24864 */   // Label 827: @24864
     /*   24864 */   GIM_Reject,
     /*   24865 */ // Label 825: @24865
     /*   24865 */ GIM_Reject,
     /*   24866 */ // Label 789: @24866
     /*   24866 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(24980),
     /*   24871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24889 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(24934), // Rule ID 50826 //
     /*   24894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   24897 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   24897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   24900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*   24914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   24929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24932 */     GIR_RootConstrainSelectedInstOperands,
     /*   24933 */     // GIR_Coverage, 50826,
     /*   24933 */     GIR_EraseRootFromParent_Done,
     /*   24934 */   // Label 829: @24934
     /*   24934 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(24979), // Rule ID 50827 //
     /*   24939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   24942 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   24942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   24945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*   24959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   24974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24977 */     GIR_RootConstrainSelectedInstOperands,
     /*   24978 */     // GIR_Coverage, 50827,
     /*   24978 */     GIR_EraseRootFromParent_Done,
     /*   24979 */   // Label 830: @24979
     /*   24979 */   GIM_Reject,
     /*   24980 */ // Label 828: @24980
     /*   24980 */ GIM_Reject,
     /*   24981 */ // Label 790: @24981
     /*   24981 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(25095),
     /*   24986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   24989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   24992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25004 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(25049), // Rule ID 50758 //
     /*   25009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25012 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   25012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   25015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*   25029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25047 */     GIR_RootConstrainSelectedInstOperands,
     /*   25048 */     // GIR_Coverage, 50758,
     /*   25048 */     GIR_EraseRootFromParent_Done,
     /*   25049 */   // Label 832: @25049
     /*   25049 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(25094), // Rule ID 50759 //
     /*   25054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25057 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   25057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   25060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*   25074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25092 */     GIR_RootConstrainSelectedInstOperands,
     /*   25093 */     // GIR_Coverage, 50759,
     /*   25093 */     GIR_EraseRootFromParent_Done,
     /*   25094 */   // Label 833: @25094
     /*   25094 */   GIM_Reject,
     /*   25095 */ // Label 831: @25095
     /*   25095 */ GIM_Reject,
     /*   25096 */ // Label 791: @25096
     /*   25096 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(25210),
     /*   25101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   25104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   25107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25119 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(25164), // Rule ID 50778 //
     /*   25124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25127 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   25127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   25130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*   25144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25162 */     GIR_RootConstrainSelectedInstOperands,
     /*   25163 */     // GIR_Coverage, 50778,
     /*   25163 */     GIR_EraseRootFromParent_Done,
     /*   25164 */   // Label 835: @25164
     /*   25164 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(25209), // Rule ID 50779 //
     /*   25169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25172 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   25172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   25175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*   25189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25207 */     GIR_RootConstrainSelectedInstOperands,
     /*   25208 */     // GIR_Coverage, 50779,
     /*   25208 */     GIR_EraseRootFromParent_Done,
     /*   25209 */   // Label 836: @25209
     /*   25209 */   GIM_Reject,
     /*   25210 */ // Label 834: @25210
     /*   25210 */ GIM_Reject,
     /*   25211 */ // Label 792: @25211
     /*   25211 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(25325),
     /*   25216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   25219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   25222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25234 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(25279), // Rule ID 50814 //
     /*   25239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25242 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   25242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   25245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*   25259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25277 */     GIR_RootConstrainSelectedInstOperands,
     /*   25278 */     // GIR_Coverage, 50814,
     /*   25278 */     GIR_EraseRootFromParent_Done,
     /*   25279 */   // Label 838: @25279
     /*   25279 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(25324), // Rule ID 50815 //
     /*   25284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25287 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   25287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   25290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*   25304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25322 */     GIR_RootConstrainSelectedInstOperands,
     /*   25323 */     // GIR_Coverage, 50815,
     /*   25323 */     GIR_EraseRootFromParent_Done,
     /*   25324 */   // Label 839: @25324
     /*   25324 */   GIM_Reject,
     /*   25325 */ // Label 837: @25325
     /*   25325 */ GIM_Reject,
     /*   25326 */ // Label 793: @25326
     /*   25326 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(25440),
     /*   25331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   25334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   25337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25349 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(25394), // Rule ID 50830 //
     /*   25354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   25357 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   25357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   25360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*   25374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25392 */     GIR_RootConstrainSelectedInstOperands,
     /*   25393 */     // GIR_Coverage, 50830,
     /*   25393 */     GIR_EraseRootFromParent_Done,
     /*   25394 */   // Label 841: @25394
     /*   25394 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(25439), // Rule ID 50831 //
     /*   25399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   25402 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   25402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   25405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*   25419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25437 */     GIR_RootConstrainSelectedInstOperands,
     /*   25438 */     // GIR_Coverage, 50831,
     /*   25438 */     GIR_EraseRootFromParent_Done,
     /*   25439 */   // Label 842: @25439
     /*   25439 */   GIM_Reject,
     /*   25440 */ // Label 840: @25440
     /*   25440 */ GIM_Reject,
     /*   25441 */ // Label 794: @25441
     /*   25441 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(25555),
     /*   25446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   25449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   25452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25464 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(25509), // Rule ID 50774 //
     /*   25469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25472 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   25472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   25475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*   25489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25507 */     GIR_RootConstrainSelectedInstOperands,
     /*   25508 */     // GIR_Coverage, 50774,
     /*   25508 */     GIR_EraseRootFromParent_Done,
     /*   25509 */   // Label 844: @25509
     /*   25509 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(25554), // Rule ID 50775 //
     /*   25514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25517 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   25517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   25520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*   25534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25552 */     GIR_RootConstrainSelectedInstOperands,
     /*   25553 */     // GIR_Coverage, 50775,
     /*   25553 */     GIR_EraseRootFromParent_Done,
     /*   25554 */   // Label 845: @25554
     /*   25554 */   GIM_Reject,
     /*   25555 */ // Label 843: @25555
     /*   25555 */ GIM_Reject,
     /*   25556 */ // Label 795: @25556
     /*   25556 */ GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(25670),
     /*   25561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   25564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   25567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25579 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(25624), // Rule ID 50802 //
     /*   25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25587 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   25587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   25590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*   25604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25622 */     GIR_RootConstrainSelectedInstOperands,
     /*   25623 */     // GIR_Coverage, 50802,
     /*   25623 */     GIR_EraseRootFromParent_Done,
     /*   25624 */   // Label 847: @25624
     /*   25624 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(25669), // Rule ID 50803 //
     /*   25629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25632 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   25632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   25635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*   25649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25667 */     GIR_RootConstrainSelectedInstOperands,
     /*   25668 */     // GIR_Coverage, 50803,
     /*   25668 */     GIR_EraseRootFromParent_Done,
     /*   25669 */   // Label 848: @25669
     /*   25669 */   GIM_Reject,
     /*   25670 */ // Label 846: @25670
     /*   25670 */ GIM_Reject,
     /*   25671 */ // Label 796: @25671
     /*   25671 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(25785),
     /*   25676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   25679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   25682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   25694 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(25739), // Rule ID 50818 //
     /*   25699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25702 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   25702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   25705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*   25719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25737 */     GIR_RootConstrainSelectedInstOperands,
     /*   25738 */     // GIR_Coverage, 50818,
     /*   25738 */     GIR_EraseRootFromParent_Done,
     /*   25739 */   // Label 850: @25739
     /*   25739 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(25784), // Rule ID 50819 //
     /*   25744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25747 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   25747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   25750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*   25764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25782 */     GIR_RootConstrainSelectedInstOperands,
     /*   25783 */     // GIR_Coverage, 50819,
     /*   25783 */     GIR_EraseRootFromParent_Done,
     /*   25784 */   // Label 851: @25784
     /*   25784 */   GIM_Reject,
     /*   25785 */ // Label 849: @25785
     /*   25785 */ GIM_Reject,
     /*   25786 */ // Label 797: @25786
     /*   25786 */ GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(25900),
     /*   25791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   25794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   25797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   25801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   25805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   25809 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(25854), // Rule ID 50834 //
     /*   25814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   25817 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   25817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   25820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*   25834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25852 */     GIR_RootConstrainSelectedInstOperands,
     /*   25853 */     // GIR_Coverage, 50834,
     /*   25853 */     GIR_EraseRootFromParent_Done,
     /*   25854 */   // Label 853: @25854
     /*   25854 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(25899), // Rule ID 50835 //
     /*   25859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   25862 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   25862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   25865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*   25879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25897 */     GIR_RootConstrainSelectedInstOperands,
     /*   25898 */     // GIR_Coverage, 50835,
     /*   25898 */     GIR_EraseRootFromParent_Done,
     /*   25899 */   // Label 854: @25899
     /*   25899 */   GIM_Reject,
     /*   25900 */ // Label 852: @25900
     /*   25900 */ GIM_Reject,
     /*   25901 */ // Label 798: @25901
     /*   25901 */ GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(26015),
     /*   25906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   25909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   25912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25924 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(25969), // Rule ID 50790 //
     /*   25929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25932 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   25932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   25935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*   25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25967 */     GIR_RootConstrainSelectedInstOperands,
     /*   25968 */     // GIR_Coverage, 50790,
     /*   25968 */     GIR_EraseRootFromParent_Done,
     /*   25969 */   // Label 856: @25969
     /*   25969 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(26014), // Rule ID 50791 //
     /*   25974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25977 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   25977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   25980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*   25994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26012 */     GIR_RootConstrainSelectedInstOperands,
     /*   26013 */     // GIR_Coverage, 50791,
     /*   26013 */     GIR_EraseRootFromParent_Done,
     /*   26014 */   // Label 857: @26014
     /*   26014 */   GIM_Reject,
     /*   26015 */ // Label 855: @26015
     /*   26015 */ GIM_Reject,
     /*   26016 */ // Label 799: @26016
     /*   26016 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(26130),
     /*   26021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   26024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   26027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26039 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(26084), // Rule ID 50806 //
     /*   26044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26047 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   26050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*   26064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26082 */     GIR_RootConstrainSelectedInstOperands,
     /*   26083 */     // GIR_Coverage, 50806,
     /*   26083 */     GIR_EraseRootFromParent_Done,
     /*   26084 */   // Label 859: @26084
     /*   26084 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(26129), // Rule ID 50807 //
     /*   26089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26092 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   26095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*   26109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26127 */     GIR_RootConstrainSelectedInstOperands,
     /*   26128 */     // GIR_Coverage, 50807,
     /*   26128 */     GIR_EraseRootFromParent_Done,
     /*   26129 */   // Label 860: @26129
     /*   26129 */   GIM_Reject,
     /*   26130 */ // Label 858: @26130
     /*   26130 */ GIM_Reject,
     /*   26131 */ // Label 800: @26131
     /*   26131 */ GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(26245),
     /*   26136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   26139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   26142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26154 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(26199), // Rule ID 50822 //
     /*   26159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26162 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   26162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   26165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*   26179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26197 */     GIR_RootConstrainSelectedInstOperands,
     /*   26198 */     // GIR_Coverage, 50822,
     /*   26198 */     GIR_EraseRootFromParent_Done,
     /*   26199 */   // Label 862: @26199
     /*   26199 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(26244), // Rule ID 50823 //
     /*   26204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26207 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   26207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   26210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*   26224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26242 */     GIR_RootConstrainSelectedInstOperands,
     /*   26243 */     // GIR_Coverage, 50823,
     /*   26243 */     GIR_EraseRootFromParent_Done,
     /*   26244 */   // Label 863: @26244
     /*   26244 */   GIM_Reject,
     /*   26245 */ // Label 861: @26245
     /*   26245 */ GIM_Reject,
     /*   26246 */ // Label 801: @26246
     /*   26246 */ GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(26360),
     /*   26251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   26254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   26257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   26269 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(26314), // Rule ID 50794 //
     /*   26274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26277 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   26277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   26280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*   26294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26312 */     GIR_RootConstrainSelectedInstOperands,
     /*   26313 */     // GIR_Coverage, 50794,
     /*   26313 */     GIR_EraseRootFromParent_Done,
     /*   26314 */   // Label 865: @26314
     /*   26314 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(26359), // Rule ID 50795 //
     /*   26319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26322 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   26322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   26325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*   26339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26357 */     GIR_RootConstrainSelectedInstOperands,
     /*   26358 */     // GIR_Coverage, 50795,
     /*   26358 */     GIR_EraseRootFromParent_Done,
     /*   26359 */   // Label 866: @26359
     /*   26359 */   GIM_Reject,
     /*   26360 */ // Label 864: @26360
     /*   26360 */ GIM_Reject,
     /*   26361 */ // Label 802: @26361
     /*   26361 */ GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(26475),
     /*   26366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   26369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   26372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26384 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(26429), // Rule ID 50810 //
     /*   26389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26392 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   26395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*   26409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26427 */     GIR_RootConstrainSelectedInstOperands,
     /*   26428 */     // GIR_Coverage, 50810,
     /*   26428 */     GIR_EraseRootFromParent_Done,
     /*   26429 */   // Label 868: @26429
     /*   26429 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(26474), // Rule ID 50811 //
     /*   26434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26437 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   26440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*   26454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26472 */     GIR_RootConstrainSelectedInstOperands,
     /*   26473 */     // GIR_Coverage, 50811,
     /*   26473 */     GIR_EraseRootFromParent_Done,
     /*   26474 */   // Label 869: @26474
     /*   26474 */   GIM_Reject,
     /*   26475 */ // Label 867: @26475
     /*   26475 */ GIM_Reject,
     /*   26476 */ // Label 803: @26476
     /*   26476 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(26590),
     /*   26481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   26484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   26487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   26499 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(26544), // Rule ID 50798 //
     /*   26504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26507 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   26507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   26510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*   26524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26542 */     GIR_RootConstrainSelectedInstOperands,
     /*   26543 */     // GIR_Coverage, 50798,
     /*   26543 */     GIR_EraseRootFromParent_Done,
     /*   26544 */   // Label 871: @26544
     /*   26544 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(26589), // Rule ID 50799 //
     /*   26549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26552 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   26552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   26555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*   26569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26587 */     GIR_RootConstrainSelectedInstOperands,
     /*   26588 */     // GIR_Coverage, 50799,
     /*   26588 */     GIR_EraseRootFromParent_Done,
     /*   26589 */   // Label 872: @26589
     /*   26589 */   GIM_Reject,
     /*   26590 */ // Label 870: @26590
     /*   26590 */ GIM_Reject,
     /*   26591 */ // Label 804: @26591
     /*   26591 */ GIM_Reject,
     /*   26592 */ // Label 7: @26592
     /*   26592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 904*/ GIMT_Encode4(35875),
     /*   26603 */ /*GILLT_s32*//*Label 873*/ GIMT_Encode4(26727),
     /*   26607 */ /*GILLT_s64*//*Label 874*/ GIMT_Encode4(27785),
     /*   26611 */ /*GILLT_nxv1s1*//*Label 875*/ GIMT_Encode4(29068),
     /*   26615 */ /*GILLT_nxv1s8*//*Label 876*/ GIMT_Encode4(29679),
     /*   26619 */ /*GILLT_nxv1s16*//*Label 877*/ GIMT_Encode4(29794),
     /*   26623 */ /*GILLT_nxv1s32*//*Label 878*/ GIMT_Encode4(29909),
     /*   26627 */ /*GILLT_nxv1s64*//*Label 879*/ GIMT_Encode4(30024),
     /*   26631 */ /*GILLT_nxv2s1*//*Label 880*/ GIMT_Encode4(30139),
     /*   26635 */ /*GILLT_nxv2s8*//*Label 881*/ GIMT_Encode4(30750),
     /*   26639 */ /*GILLT_nxv2s16*//*Label 882*/ GIMT_Encode4(30865),
     /*   26643 */ /*GILLT_nxv2s32*//*Label 883*/ GIMT_Encode4(30980),
     /*   26647 */ /*GILLT_nxv2s64*//*Label 884*/ GIMT_Encode4(31095),
     /*   26651 */ /*GILLT_nxv4s1*//*Label 885*/ GIMT_Encode4(31210),
     /*   26655 */ /*GILLT_nxv4s8*//*Label 886*/ GIMT_Encode4(31821),
     /*   26659 */ /*GILLT_nxv4s16*//*Label 887*/ GIMT_Encode4(31936),
     /*   26663 */ /*GILLT_nxv4s32*//*Label 888*/ GIMT_Encode4(32051),
     /*   26667 */ /*GILLT_nxv4s64*//*Label 889*/ GIMT_Encode4(32166),
     /*   26671 */ /*GILLT_nxv8s1*//*Label 890*/ GIMT_Encode4(32281),
     /*   26675 */ /*GILLT_nxv8s8*//*Label 891*/ GIMT_Encode4(32892),
     /*   26679 */ /*GILLT_nxv8s16*//*Label 892*/ GIMT_Encode4(33007),
     /*   26683 */ /*GILLT_nxv8s32*//*Label 893*/ GIMT_Encode4(33122),
     /*   26687 */ /*GILLT_nxv8s64*//*Label 894*/ GIMT_Encode4(33237),
     /*   26691 */ /*GILLT_nxv16s1*//*Label 895*/ GIMT_Encode4(33352),
     /*   26695 */ /*GILLT_nxv16s8*//*Label 896*/ GIMT_Encode4(33963),
     /*   26699 */ /*GILLT_nxv16s16*//*Label 897*/ GIMT_Encode4(34078),
     /*   26703 */ /*GILLT_nxv16s32*//*Label 898*/ GIMT_Encode4(34193),
     /*   26707 */ /*GILLT_nxv32s1*//*Label 899*/ GIMT_Encode4(34308),
     /*   26711 */ /*GILLT_nxv32s8*//*Label 900*/ GIMT_Encode4(34919),
     /*   26715 */ /*GILLT_nxv32s16*//*Label 901*/ GIMT_Encode4(35034),
     /*   26719 */ /*GILLT_nxv64s1*//*Label 902*/ GIMT_Encode4(35149),
     /*   26723 */ /*GILLT_nxv64s8*//*Label 903*/ GIMT_Encode4(35760),
     /*   26727 */ // Label 873: @26727
     /*   26727 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(27784),
     /*   26732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   26735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   26738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   26742 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(26827), // Rule ID 64070 //
     /*   26747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   26750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   26758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   26762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   26766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   26770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   26774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   26778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   26782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   26787 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   26791 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   26802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   26811 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   26811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   26814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   26821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26825 */     GIR_RootConstrainSelectedInstOperands,
     /*   26826 */     // GIR_Coverage, 64070,
     /*   26826 */     GIR_EraseRootFromParent_Done,
     /*   26827 */   // Label 906: @26827
     /*   26827 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(26912), // Rule ID 2402 //
     /*   26832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   26835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   26843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   26847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   26851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   26859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   26863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   26867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   26872 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   26876 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   26887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   26896 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   26896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   26899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   26906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26910 */     GIR_RootConstrainSelectedInstOperands,
     /*   26911 */     // GIR_Coverage, 2402,
     /*   26911 */     GIR_EraseRootFromParent_Done,
     /*   26912 */   // Label 907: @26912
     /*   26912 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(26987), // Rule ID 2329 //
     /*   26917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   26920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   26928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   26932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   26936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   26944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   26948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   26952 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*   26956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   26960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   26964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   26973 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   26973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   26976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   26980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   26985 */     GIR_RootConstrainSelectedInstOperands,
     /*   26986 */     // GIR_Coverage, 2329,
     /*   26986 */     GIR_EraseRootFromParent_Done,
     /*   26987 */   // Label 908: @26987
     /*   26987 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(27062), // Rule ID 64058 //
     /*   26992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   26995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   26999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   27007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   27023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   27027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   27031 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*   27035 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   27039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   27048 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   27051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   27060 */     GIR_RootConstrainSelectedInstOperands,
     /*   27061 */     // GIR_Coverage, 64058,
     /*   27061 */     GIR_EraseRootFromParent_Done,
     /*   27062 */   // Label 909: @27062
     /*   27062 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(27123), // Rule ID 2349 //
     /*   27067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   27070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   27078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   27095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   27099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*   27103 */     // MIs[2] Operand 1
     /*   27103 */     // No operand predicates
     /*   27103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   27107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27109 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*   27109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*   27112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*   27121 */     GIR_RootConstrainSelectedInstOperands,
     /*   27122 */     // GIR_Coverage, 2349,
     /*   27122 */     GIR_EraseRootFromParent_Done,
     /*   27123 */   // Label 910: @27123
     /*   27123 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(27184), // Rule ID 61883 //
     /*   27128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*   27131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   27139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   27156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   27160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*   27164 */     // MIs[2] Operand 1
     /*   27164 */     // No operand predicates
     /*   27164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   27168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27170 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*   27170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*   27173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*   27182 */     GIR_RootConstrainSelectedInstOperands,
     /*   27183 */     // GIR_Coverage, 61883,
     /*   27183 */     GIR_EraseRootFromParent_Done,
     /*   27184 */   // Label 911: @27184
     /*   27184 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(27242), // Rule ID 2337 //
     /*   27189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   27192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   27200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   27217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   27226 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*   27229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   27240 */     GIR_RootConstrainSelectedInstOperands,
     /*   27241 */     // GIR_Coverage, 2337,
     /*   27241 */     GIR_EraseRootFromParent_Done,
     /*   27242 */   // Label 912: @27242
     /*   27242 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(27294), // Rule ID 2331 //
     /*   27247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   27250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*   27258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27266 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*   27270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27281 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   27284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   27288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   27292 */     GIR_RootConstrainSelectedInstOperands,
     /*   27293 */     // GIR_Coverage, 2331,
     /*   27293 */     GIR_EraseRootFromParent_Done,
     /*   27294 */   // Label 913: @27294
     /*   27294 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(27346), // Rule ID 64044 //
     /*   27299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   27302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   27310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   27327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27333 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*   27336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   27340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27344 */     GIR_RootConstrainSelectedInstOperands,
     /*   27345 */     // GIR_Coverage, 64044,
     /*   27345 */     GIR_EraseRootFromParent_Done,
     /*   27346 */   // Label 914: @27346
     /*   27346 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(27398), // Rule ID 64060 //
     /*   27351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   27354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*   27366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*   27378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27385 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   27388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   27396 */     GIR_RootConstrainSelectedInstOperands,
     /*   27397 */     // GIR_Coverage, 64060,
     /*   27397 */     GIR_EraseRootFromParent_Done,
     /*   27398 */   // Label 915: @27398
     /*   27398 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(27450), // Rule ID 2305 //
     /*   27403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   27406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   27418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   27422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   27426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   27435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27437 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*   27440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27448 */     GIR_RootConstrainSelectedInstOperands,
     /*   27449 */     // GIR_Coverage, 2305,
     /*   27449 */     GIR_EraseRootFromParent_Done,
     /*   27450 */   // Label 916: @27450
     /*   27450 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(27482), // Rule ID 63787 //
     /*   27455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*   27458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27462 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27473 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*   27473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*   27476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27480 */     GIR_RootConstrainSelectedInstOperands,
     /*   27481 */     // GIR_Coverage, 63787,
     /*   27481 */     GIR_EraseRootFromParent_Done,
     /*   27482 */   // Label 917: @27482
     /*   27482 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(27514), // Rule ID 63789 //
     /*   27487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*   27490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27494 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*   27505 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*   27505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*   27508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27512 */     GIR_RootConstrainSelectedInstOperands,
     /*   27513 */     // GIR_Coverage, 63789,
     /*   27513 */     GIR_EraseRootFromParent_Done,
     /*   27514 */   // Label 918: @27514
     /*   27514 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(27546), // Rule ID 2413 //
     /*   27519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*   27522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27526 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27537 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*   27537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*   27540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   27544 */     GIR_RootConstrainSelectedInstOperands,
     /*   27545 */     // GIR_Coverage, 2413,
     /*   27545 */     GIR_EraseRootFromParent_Done,
     /*   27546 */   // Label 919: @27546
     /*   27546 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(27578), // Rule ID 2414 //
     /*   27551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*   27554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27558 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27569 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*   27569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*   27572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   27576 */     GIR_RootConstrainSelectedInstOperands,
     /*   27577 */     // GIR_Coverage, 2414,
     /*   27577 */     GIR_EraseRootFromParent_Done,
     /*   27578 */   // Label 920: @27578
     /*   27578 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(27616), // Rule ID 2416 //
     /*   27583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*   27586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27590 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27601 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*   27601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   27604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   27608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   27614 */     GIR_RootConstrainSelectedInstOperands,
     /*   27615 */     // GIR_Coverage, 2416,
     /*   27615 */     GIR_EraseRootFromParent_Done,
     /*   27616 */   // Label 921: @27616
     /*   27616 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(27654), // Rule ID 2417 //
     /*   27621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*   27624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27628 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27639 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*   27639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   27642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   27646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   27652 */     GIR_RootConstrainSelectedInstOperands,
     /*   27653 */     // GIR_Coverage, 2417,
     /*   27653 */     GIR_EraseRootFromParent_Done,
     /*   27654 */   // Label 922: @27654
     /*   27654 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(27692), // Rule ID 85 //
     /*   27659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   27662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   27674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   27678 */     // MIs[1] Operand 1
     /*   27678 */     // No operand predicates
     /*   27678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27680 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*   27680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*   27683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   27690 */     GIR_RootConstrainSelectedInstOperands,
     /*   27691 */     // GIR_Coverage, 85,
     /*   27691 */     GIR_EraseRootFromParent_Done,
     /*   27692 */   // Label 923: @27692
     /*   27692 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(27760), // Rule ID 103 //
     /*   27697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   27700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   27712 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*   27716 */     // MIs[1] Operand 1
     /*   27716 */     // No operand predicates
     /*   27716 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9601),
     /*   27720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27722 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9601>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*   27722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   27725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   27729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*   27738 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*   27743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   27748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27753 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*   27758 */     GIR_RootConstrainSelectedInstOperands,
     /*   27759 */     // GIR_Coverage, 103,
     /*   27759 */     GIR_EraseRootFromParent_Done,
     /*   27760 */   // Label 924: @27760
     /*   27760 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(27783), // Rule ID 83 //
     /*   27765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   27768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27776 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   27776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*   27781 */     GIR_RootConstrainSelectedInstOperands,
     /*   27782 */     // GIR_Coverage, 83,
     /*   27782 */     GIR_Done,
     /*   27783 */   // Label 925: @27783
     /*   27783 */   GIM_Reject,
     /*   27784 */ // Label 905: @27784
     /*   27784 */ GIM_Reject,
     /*   27785 */ // Label 874: @27785
     /*   27785 */ GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(29067),
     /*   27790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   27793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   27796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27800 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(27885), // Rule ID 64069 //
     /*   27805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   27808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   27816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   27820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   27824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   27828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   27832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   27836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   27840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27845 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   27849 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   27869 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   27869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   27872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   27879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   27883 */     GIR_RootConstrainSelectedInstOperands,
     /*   27884 */     // GIR_Coverage, 64069,
     /*   27884 */     GIR_EraseRootFromParent_Done,
     /*   27885 */   // Label 927: @27885
     /*   27885 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(27970), // Rule ID 2401 //
     /*   27890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   27893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   27901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   27905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   27930 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   27934 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   27945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   27954 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   27954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   27957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   27964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   27968 */     GIR_RootConstrainSelectedInstOperands,
     /*   27969 */     // GIR_Coverage, 2401,
     /*   27969 */     GIR_EraseRootFromParent_Done,
     /*   27970 */   // Label 928: @27970
     /*   27970 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(28045), // Rule ID 2328 //
     /*   27975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   27978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   27986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   27990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   27994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   28002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   28006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   28010 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*   28014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   28018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   28031 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   28034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   28038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   28043 */     GIR_RootConstrainSelectedInstOperands,
     /*   28044 */     // GIR_Coverage, 2328,
     /*   28044 */     GIR_EraseRootFromParent_Done,
     /*   28045 */   // Label 929: @28045
     /*   28045 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(28120), // Rule ID 64057 //
     /*   28050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   28053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   28065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   28081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   28085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   28089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*   28093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   28097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   28106 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   28109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   28118 */     GIR_RootConstrainSelectedInstOperands,
     /*   28119 */     // GIR_Coverage, 64057,
     /*   28119 */     GIR_EraseRootFromParent_Done,
     /*   28120 */   // Label 930: @28120
     /*   28120 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(28181), // Rule ID 2348 //
     /*   28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   28128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   28136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   28153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28157 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*   28161 */     // MIs[2] Operand 1
     /*   28161 */     // No operand predicates
     /*   28161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   28165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28167 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*   28167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*   28170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*   28179 */     GIR_RootConstrainSelectedInstOperands,
     /*   28180 */     // GIR_Coverage, 2348,
     /*   28180 */     GIR_EraseRootFromParent_Done,
     /*   28181 */   // Label 931: @28181
     /*   28181 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(28242), // Rule ID 61882 //
     /*   28186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*   28189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   28197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   28214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*   28222 */     // MIs[2] Operand 1
     /*   28222 */     // No operand predicates
     /*   28222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   28226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28228 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*   28228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*   28231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*   28240 */     GIR_RootConstrainSelectedInstOperands,
     /*   28241 */     // GIR_Coverage, 61882,
     /*   28241 */     GIR_EraseRootFromParent_Done,
     /*   28242 */   // Label 932: @28242
     /*   28242 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(28300), // Rule ID 2336 //
     /*   28247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   28250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   28258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   28275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   28284 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*   28287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   28298 */     GIR_RootConstrainSelectedInstOperands,
     /*   28299 */     // GIR_Coverage, 2336,
     /*   28299 */     GIR_EraseRootFromParent_Done,
     /*   28300 */   // Label 933: @28300
     /*   28300 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(28352), // Rule ID 2330 //
     /*   28305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   28308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*   28316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*   28328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28339 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   28342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   28346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   28350 */     GIR_RootConstrainSelectedInstOperands,
     /*   28351 */     // GIR_Coverage, 2330,
     /*   28351 */     GIR_EraseRootFromParent_Done,
     /*   28352 */   // Label 934: @28352
     /*   28352 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(28404), // Rule ID 64043 //
     /*   28357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   28360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   28368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   28385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28391 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*   28394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   28398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   28402 */     GIR_RootConstrainSelectedInstOperands,
     /*   28403 */     // GIR_Coverage, 64043,
     /*   28403 */     GIR_EraseRootFromParent_Done,
     /*   28404 */   // Label 935: @28404
     /*   28404 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(28456), // Rule ID 64059 //
     /*   28409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   28412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*   28424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*   28436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28443 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*   28446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   28454 */     GIR_RootConstrainSelectedInstOperands,
     /*   28455 */     // GIR_Coverage, 64059,
     /*   28455 */     GIR_EraseRootFromParent_Done,
     /*   28456 */   // Label 936: @28456
     /*   28456 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(28508), // Rule ID 2304 //
     /*   28461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   28464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   28476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   28480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   28484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   28493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28495 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   28495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*   28498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   28506 */     GIR_RootConstrainSelectedInstOperands,
     /*   28507 */     // GIR_Coverage, 2304,
     /*   28507 */     GIR_EraseRootFromParent_Done,
     /*   28508 */   // Label 937: @28508
     /*   28508 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(28540), // Rule ID 63786 //
     /*   28513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*   28516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28520 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   28531 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*   28531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*   28534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28538 */     GIR_RootConstrainSelectedInstOperands,
     /*   28539 */     // GIR_Coverage, 63786,
     /*   28539 */     GIR_EraseRootFromParent_Done,
     /*   28540 */   // Label 938: @28540
     /*   28540 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(28572), // Rule ID 63788 //
     /*   28545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*   28548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28552 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*   28563 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*   28563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*   28566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28570 */     GIR_RootConstrainSelectedInstOperands,
     /*   28571 */     // GIR_Coverage, 63788,
     /*   28571 */     GIR_EraseRootFromParent_Done,
     /*   28572 */   // Label 939: @28572
     /*   28572 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(28629), // Rule ID 252 //
     /*   28577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*   28580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28584 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*   28595 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*   28595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   28598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   28602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   28611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   28614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   28619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*   28627 */     GIR_RootConstrainSelectedInstOperands,
     /*   28628 */     // GIR_Coverage, 252,
     /*   28628 */     GIR_EraseRootFromParent_Done,
     /*   28629 */   // Label 940: @28629
     /*   28629 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(28661), // Rule ID 2415 //
     /*   28634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*   28637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28641 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   28652 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*   28652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*   28655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   28659 */     GIR_RootConstrainSelectedInstOperands,
     /*   28660 */     // GIR_Coverage, 2415,
     /*   28660 */     GIR_EraseRootFromParent_Done,
     /*   28661 */   // Label 941: @28661
     /*   28661 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(28699), // Rule ID 2418 //
     /*   28666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*   28669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28673 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*   28684 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*   28684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*   28687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   28691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   28697 */     GIR_RootConstrainSelectedInstOperands,
     /*   28698 */     // GIR_Coverage, 2418,
     /*   28698 */     GIR_EraseRootFromParent_Done,
     /*   28699 */   // Label 942: @28699
     /*   28699 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(28737), // Rule ID 2461 //
     /*   28704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*   28707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28711 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*   28722 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*   28722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*   28725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   28729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   28735 */     GIR_RootConstrainSelectedInstOperands,
     /*   28736 */     // GIR_Coverage, 2461,
     /*   28736 */     GIR_EraseRootFromParent_Done,
     /*   28737 */   // Label 943: @28737
     /*   28737 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(28775), // Rule ID 84 //
     /*   28742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   28745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   28761 */     // MIs[1] Operand 1
     /*   28761 */     // No operand predicates
     /*   28761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28763 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   28763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*   28766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   28773 */     GIR_RootConstrainSelectedInstOperands,
     /*   28774 */     // GIR_Coverage, 84,
     /*   28774 */     GIR_EraseRootFromParent_Done,
     /*   28775 */   // Label 944: @28775
     /*   28775 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(28843), // Rule ID 101 //
     /*   28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   28783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*   28799 */     // MIs[1] Operand 1
     /*   28799 */     // No operand predicates
     /*   28799 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9599),
     /*   28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28805 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9599>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*   28805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   28808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   28812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*   28821 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   28826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   28831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28836 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   28841 */     GIR_RootConstrainSelectedInstOperands,
     /*   28842 */     // GIR_Coverage, 101,
     /*   28842 */     GIR_EraseRootFromParent_Done,
     /*   28843 */   // Label 945: @28843
     /*   28843 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(28911), // Rule ID 102 //
     /*   28848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   28851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28863 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*   28867 */     // MIs[1] Operand 1
     /*   28867 */     // No operand predicates
     /*   28867 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9601),
     /*   28871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28873 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9601>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*   28873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   28876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   28880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*   28889 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*   28894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   28899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28904 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*   28909 */     GIR_RootConstrainSelectedInstOperands,
     /*   28910 */     // GIR_Coverage, 102,
     /*   28910 */     GIR_EraseRootFromParent_Done,
     /*   28911 */   // Label 946: @28911
     /*   28911 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(28979), // Rule ID 254 //
     /*   28916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   28919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*   28935 */     // MIs[1] Operand 1
     /*   28935 */     // No operand predicates
     /*   28935 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9689),
     /*   28939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28941 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_9689>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*   28941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   28944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   28948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*   28957 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   28962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   28967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28972 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   28977 */     GIR_RootConstrainSelectedInstOperands,
     /*   28978 */     // GIR_Coverage, 254,
     /*   28978 */     GIR_EraseRootFromParent_Done,
     /*   28979 */   // Label 947: @28979
     /*   28979 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(29043), // Rule ID 2458 //
     /*   28984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*   28987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   28991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   28999 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*   29003 */     // MIs[1] Operand 1
     /*   29003 */     // No operand predicates
     /*   29003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29005 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*   29005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   29008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   29012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   29021 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   29026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*   29031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29036 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*   29041 */     GIR_RootConstrainSelectedInstOperands,
     /*   29042 */     // GIR_Coverage, 2458,
     /*   29042 */     GIR_EraseRootFromParent_Done,
     /*   29043 */   // Label 948: @29043
     /*   29043 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(29066), // Rule ID 82 //
     /*   29048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   29051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   29055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   29059 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   29059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*   29064 */     GIR_RootConstrainSelectedInstOperands,
     /*   29065 */     // GIR_Coverage, 82,
     /*   29065 */     GIR_Done,
     /*   29066 */   // Label 949: @29066
     /*   29066 */   GIM_Reject,
     /*   29067 */ // Label 926: @29067
     /*   29067 */ GIM_Reject,
     /*   29068 */ // Label 875: @29068
     /*   29068 */ GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(29678),
     /*   29073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29083 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(29149), // Rule ID 70109 //
     /*   29088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   29119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29130 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   29130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   29137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   29141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29147 */     GIR_RootConstrainSelectedInstOperands,
     /*   29148 */     // GIR_Coverage, 70109,
     /*   29148 */     GIR_EraseRootFromParent_Done,
     /*   29149 */   // Label 951: @29149
     /*   29149 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(29215), // Rule ID 70110 //
     /*   29154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   29185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29196 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   29196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   29203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   29207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29213 */     GIR_RootConstrainSelectedInstOperands,
     /*   29214 */     // GIR_Coverage, 70110,
     /*   29214 */     GIR_EraseRootFromParent_Done,
     /*   29215 */   // Label 952: @29215
     /*   29215 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(29281), // Rule ID 70107 //
     /*   29220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   29248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   29256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29262 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29279 */     GIR_RootConstrainSelectedInstOperands,
     /*   29280 */     // GIR_Coverage, 70107,
     /*   29280 */     GIR_EraseRootFromParent_Done,
     /*   29281 */   // Label 953: @29281
     /*   29281 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(29347), // Rule ID 70108 //
     /*   29286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   29314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   29322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29328 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   29328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   29335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29345 */     GIR_RootConstrainSelectedInstOperands,
     /*   29346 */     // GIR_Coverage, 70108,
     /*   29346 */     GIR_EraseRootFromParent_Done,
     /*   29347 */   // Label 954: @29347
     /*   29347 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(29413), // Rule ID 70105 //
     /*   29352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   29387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29394 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   29394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   29405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29411 */     GIR_RootConstrainSelectedInstOperands,
     /*   29412 */     // GIR_Coverage, 70105,
     /*   29412 */     GIR_EraseRootFromParent_Done,
     /*   29413 */   // Label 955: @29413
     /*   29413 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(29479), // Rule ID 70106 //
     /*   29418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   29453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29460 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   29460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   29471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29477 */     GIR_RootConstrainSelectedInstOperands,
     /*   29478 */     // GIR_Coverage, 70106,
     /*   29478 */     GIR_EraseRootFromParent_Done,
     /*   29479 */   // Label 956: @29479
     /*   29479 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(29545), // Rule ID 52626 //
     /*   29484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   29516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   29524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29526 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   29526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29543 */     GIR_RootConstrainSelectedInstOperands,
     /*   29544 */     // GIR_Coverage, 52626,
     /*   29544 */     GIR_EraseRootFromParent_Done,
     /*   29545 */   // Label 957: @29545
     /*   29545 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(29611), // Rule ID 52627 //
     /*   29550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   29565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   29569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   29573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   29582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   29586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   29590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29592 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   29592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*   29595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29609 */     GIR_RootConstrainSelectedInstOperands,
     /*   29610 */     // GIR_Coverage, 52627,
     /*   29610 */     GIR_EraseRootFromParent_Done,
     /*   29611 */   // Label 958: @29611
     /*   29611 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(29644), // Rule ID 52614 //
     /*   29616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29627 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   29627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*   29630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29642 */     GIR_RootConstrainSelectedInstOperands,
     /*   29643 */     // GIR_Coverage, 52614,
     /*   29643 */     GIR_EraseRootFromParent_Done,
     /*   29644 */   // Label 959: @29644
     /*   29644 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(29677), // Rule ID 52615 //
     /*   29649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29660 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   29660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*   29663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   29675 */     GIR_RootConstrainSelectedInstOperands,
     /*   29676 */     // GIR_Coverage, 52615,
     /*   29676 */     GIR_EraseRootFromParent_Done,
     /*   29677 */   // Label 960: @29677
     /*   29677 */   GIM_Reject,
     /*   29678 */ // Label 950: @29678
     /*   29678 */ GIM_Reject,
     /*   29679 */ // Label 876: @29679
     /*   29679 */ GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(29793),
     /*   29684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   29687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   29690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29702 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(29747), // Rule ID 47106 //
     /*   29707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29710 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   29710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   29713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*   29727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29745 */     GIR_RootConstrainSelectedInstOperands,
     /*   29746 */     // GIR_Coverage, 47106,
     /*   29746 */     GIR_EraseRootFromParent_Done,
     /*   29747 */   // Label 962: @29747
     /*   29747 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(29792), // Rule ID 47107 //
     /*   29752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29755 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   29755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   29758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*   29772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29790 */     GIR_RootConstrainSelectedInstOperands,
     /*   29791 */     // GIR_Coverage, 47107,
     /*   29791 */     GIR_EraseRootFromParent_Done,
     /*   29792 */   // Label 963: @29792
     /*   29792 */   GIM_Reject,
     /*   29793 */ // Label 961: @29793
     /*   29793 */ GIM_Reject,
     /*   29794 */ // Label 877: @29794
     /*   29794 */ GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(29908),
     /*   29799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   29802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   29805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29817 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(29862), // Rule ID 47118 //
     /*   29822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29825 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   29825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   29828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*   29842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29860 */     GIR_RootConstrainSelectedInstOperands,
     /*   29861 */     // GIR_Coverage, 47118,
     /*   29861 */     GIR_EraseRootFromParent_Done,
     /*   29862 */   // Label 965: @29862
     /*   29862 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(29907), // Rule ID 47119 //
     /*   29867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29870 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   29870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   29873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*   29887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29905 */     GIR_RootConstrainSelectedInstOperands,
     /*   29906 */     // GIR_Coverage, 47119,
     /*   29906 */     GIR_EraseRootFromParent_Done,
     /*   29907 */   // Label 966: @29907
     /*   29907 */   GIM_Reject,
     /*   29908 */ // Label 964: @29908
     /*   29908 */ GIM_Reject,
     /*   29909 */ // Label 878: @29909
     /*   29909 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(30023),
     /*   29914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   29917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   29920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29932 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(29977), // Rule ID 47126 //
     /*   29937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29940 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   29943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   29957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   29964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29975 */     GIR_RootConstrainSelectedInstOperands,
     /*   29976 */     // GIR_Coverage, 47126,
     /*   29976 */     GIR_EraseRootFromParent_Done,
     /*   29977 */   // Label 968: @29977
     /*   29977 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(30022), // Rule ID 47127 //
     /*   29982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29985 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   29988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   30002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30020 */     GIR_RootConstrainSelectedInstOperands,
     /*   30021 */     // GIR_Coverage, 47127,
     /*   30021 */     GIR_EraseRootFromParent_Done,
     /*   30022 */   // Label 969: @30022
     /*   30022 */   GIM_Reject,
     /*   30023 */ // Label 967: @30023
     /*   30023 */ GIM_Reject,
     /*   30024 */ // Label 879: @30024
     /*   30024 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(30138),
     /*   30029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   30032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   30035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30047 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(30092), // Rule ID 47142 //
     /*   30052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30055 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   30055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   30058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   30072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30090 */     GIR_RootConstrainSelectedInstOperands,
     /*   30091 */     // GIR_Coverage, 47142,
     /*   30091 */     GIR_EraseRootFromParent_Done,
     /*   30092 */   // Label 971: @30092
     /*   30092 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(30137), // Rule ID 47143 //
     /*   30097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30100 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   30100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   30103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   30117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30135 */     GIR_RootConstrainSelectedInstOperands,
     /*   30136 */     // GIR_Coverage, 47143,
     /*   30136 */     GIR_EraseRootFromParent_Done,
     /*   30137 */   // Label 972: @30137
     /*   30137 */   GIM_Reject,
     /*   30138 */ // Label 970: @30138
     /*   30138 */ GIM_Reject,
     /*   30139 */ // Label 880: @30139
     /*   30139 */ GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(30749),
     /*   30144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30154 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(30220), // Rule ID 70137 //
     /*   30159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   30190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30201 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   30201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   30208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   30212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30218 */     GIR_RootConstrainSelectedInstOperands,
     /*   30219 */     // GIR_Coverage, 70137,
     /*   30219 */     GIR_EraseRootFromParent_Done,
     /*   30220 */   // Label 974: @30220
     /*   30220 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(30286), // Rule ID 70138 //
     /*   30225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   30256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30267 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   30267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   30274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   30278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30284 */     GIR_RootConstrainSelectedInstOperands,
     /*   30285 */     // GIR_Coverage, 70138,
     /*   30285 */     GIR_EraseRootFromParent_Done,
     /*   30286 */   // Label 975: @30286
     /*   30286 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(30352), // Rule ID 70135 //
     /*   30291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   30319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   30327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30333 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   30333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   30340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30350 */     GIR_RootConstrainSelectedInstOperands,
     /*   30351 */     // GIR_Coverage, 70135,
     /*   30351 */     GIR_EraseRootFromParent_Done,
     /*   30352 */   // Label 976: @30352
     /*   30352 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(30418), // Rule ID 70136 //
     /*   30357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   30385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   30393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30399 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   30399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   30406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30416 */     GIR_RootConstrainSelectedInstOperands,
     /*   30417 */     // GIR_Coverage, 70136,
     /*   30417 */     GIR_EraseRootFromParent_Done,
     /*   30418 */   // Label 977: @30418
     /*   30418 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(30484), // Rule ID 70133 //
     /*   30423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   30458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30465 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   30465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   30476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30482 */     GIR_RootConstrainSelectedInstOperands,
     /*   30483 */     // GIR_Coverage, 70133,
     /*   30483 */     GIR_EraseRootFromParent_Done,
     /*   30484 */   // Label 978: @30484
     /*   30484 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(30550), // Rule ID 70134 //
     /*   30489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   30524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30531 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   30531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   30542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30548 */     GIR_RootConstrainSelectedInstOperands,
     /*   30549 */     // GIR_Coverage, 70134,
     /*   30549 */     GIR_EraseRootFromParent_Done,
     /*   30550 */   // Label 979: @30550
     /*   30550 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(30616), // Rule ID 52644 //
     /*   30555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   30587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   30595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30597 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   30597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30614 */     GIR_RootConstrainSelectedInstOperands,
     /*   30615 */     // GIR_Coverage, 52644,
     /*   30615 */     GIR_EraseRootFromParent_Done,
     /*   30616 */   // Label 980: @30616
     /*   30616 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(30682), // Rule ID 52645 //
     /*   30621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   30636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   30640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   30644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   30653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   30657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   30661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30663 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   30663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*   30666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30680 */     GIR_RootConstrainSelectedInstOperands,
     /*   30681 */     // GIR_Coverage, 52645,
     /*   30681 */     GIR_EraseRootFromParent_Done,
     /*   30682 */   // Label 981: @30682
     /*   30682 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(30715), // Rule ID 52632 //
     /*   30687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30698 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   30698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*   30701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30713 */     GIR_RootConstrainSelectedInstOperands,
     /*   30714 */     // GIR_Coverage, 52632,
     /*   30714 */     GIR_EraseRootFromParent_Done,
     /*   30715 */   // Label 982: @30715
     /*   30715 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(30748), // Rule ID 52633 //
     /*   30720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30731 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   30731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*   30734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   30746 */     GIR_RootConstrainSelectedInstOperands,
     /*   30747 */     // GIR_Coverage, 52633,
     /*   30747 */     GIR_EraseRootFromParent_Done,
     /*   30748 */   // Label 983: @30748
     /*   30748 */   GIM_Reject,
     /*   30749 */ // Label 973: @30749
     /*   30749 */ GIM_Reject,
     /*   30750 */ // Label 881: @30750
     /*   30750 */ GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(30864),
     /*   30755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   30758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   30761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30773 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(30818), // Rule ID 47110 //
     /*   30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30781 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   30781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   30784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*   30798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30816 */     GIR_RootConstrainSelectedInstOperands,
     /*   30817 */     // GIR_Coverage, 47110,
     /*   30817 */     GIR_EraseRootFromParent_Done,
     /*   30818 */   // Label 985: @30818
     /*   30818 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(30863), // Rule ID 47111 //
     /*   30823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30826 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   30826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   30829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*   30843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30861 */     GIR_RootConstrainSelectedInstOperands,
     /*   30862 */     // GIR_Coverage, 47111,
     /*   30862 */     GIR_EraseRootFromParent_Done,
     /*   30863 */   // Label 986: @30863
     /*   30863 */   GIM_Reject,
     /*   30864 */ // Label 984: @30864
     /*   30864 */ GIM_Reject,
     /*   30865 */ // Label 882: @30865
     /*   30865 */ GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(30979),
     /*   30870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   30873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   30876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30888 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(30933), // Rule ID 47122 //
     /*   30893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30896 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   30896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   30899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   30913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30931 */     GIR_RootConstrainSelectedInstOperands,
     /*   30932 */     // GIR_Coverage, 47122,
     /*   30932 */     GIR_EraseRootFromParent_Done,
     /*   30933 */   // Label 988: @30933
     /*   30933 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(30978), // Rule ID 47123 //
     /*   30938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30941 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   30941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   30944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   30958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30976 */     GIR_RootConstrainSelectedInstOperands,
     /*   30977 */     // GIR_Coverage, 47123,
     /*   30977 */     GIR_EraseRootFromParent_Done,
     /*   30978 */   // Label 989: @30978
     /*   30978 */   GIM_Reject,
     /*   30979 */ // Label 987: @30979
     /*   30979 */ GIM_Reject,
     /*   30980 */ // Label 883: @30980
     /*   30980 */ GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(31094),
     /*   30985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   30991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31003 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(31048), // Rule ID 47138 //
     /*   31008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31011 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   31011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   31014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   31028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31046 */     GIR_RootConstrainSelectedInstOperands,
     /*   31047 */     // GIR_Coverage, 47138,
     /*   31047 */     GIR_EraseRootFromParent_Done,
     /*   31048 */   // Label 991: @31048
     /*   31048 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(31093), // Rule ID 47139 //
     /*   31053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31056 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   31056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   31059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   31073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31091 */     GIR_RootConstrainSelectedInstOperands,
     /*   31092 */     // GIR_Coverage, 47139,
     /*   31092 */     GIR_EraseRootFromParent_Done,
     /*   31093 */   // Label 992: @31093
     /*   31093 */   GIM_Reject,
     /*   31094 */ // Label 990: @31094
     /*   31094 */ GIM_Reject,
     /*   31095 */ // Label 884: @31095
     /*   31095 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(31209),
     /*   31100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   31103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   31106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31118 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(31163), // Rule ID 47182 //
     /*   31123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   31126 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   31126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   31143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31161 */     GIR_RootConstrainSelectedInstOperands,
     /*   31162 */     // GIR_Coverage, 47182,
     /*   31162 */     GIR_EraseRootFromParent_Done,
     /*   31163 */   // Label 994: @31163
     /*   31163 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(31208), // Rule ID 47183 //
     /*   31168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   31171 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   31171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   31188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31206 */     GIR_RootConstrainSelectedInstOperands,
     /*   31207 */     // GIR_Coverage, 47183,
     /*   31207 */     GIR_EraseRootFromParent_Done,
     /*   31208 */   // Label 995: @31208
     /*   31208 */   GIM_Reject,
     /*   31209 */ // Label 993: @31209
     /*   31209 */ GIM_Reject,
     /*   31210 */ // Label 885: @31210
     /*   31210 */ GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(31820),
     /*   31215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31225 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(31291), // Rule ID 70165 //
     /*   31230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   31261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31272 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   31272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   31279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   31283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31289 */     GIR_RootConstrainSelectedInstOperands,
     /*   31290 */     // GIR_Coverage, 70165,
     /*   31290 */     GIR_EraseRootFromParent_Done,
     /*   31291 */   // Label 997: @31291
     /*   31291 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(31357), // Rule ID 70166 //
     /*   31296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   31327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31338 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   31338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   31345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   31349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31355 */     GIR_RootConstrainSelectedInstOperands,
     /*   31356 */     // GIR_Coverage, 70166,
     /*   31356 */     GIR_EraseRootFromParent_Done,
     /*   31357 */   // Label 998: @31357
     /*   31357 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(31423), // Rule ID 70163 //
     /*   31362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   31390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   31398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31404 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   31404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   31411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   31415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31421 */     GIR_RootConstrainSelectedInstOperands,
     /*   31422 */     // GIR_Coverage, 70163,
     /*   31422 */     GIR_EraseRootFromParent_Done,
     /*   31423 */   // Label 999: @31423
     /*   31423 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(31489), // Rule ID 70164 //
     /*   31428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   31456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   31464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31470 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   31470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   31477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   31481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31487 */     GIR_RootConstrainSelectedInstOperands,
     /*   31488 */     // GIR_Coverage, 70164,
     /*   31488 */     GIR_EraseRootFromParent_Done,
     /*   31489 */   // Label 1000: @31489
     /*   31489 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(31555), // Rule ID 70161 //
     /*   31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   31529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31536 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   31536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   31547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31553 */     GIR_RootConstrainSelectedInstOperands,
     /*   31554 */     // GIR_Coverage, 70161,
     /*   31554 */     GIR_EraseRootFromParent_Done,
     /*   31555 */   // Label 1001: @31555
     /*   31555 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(31621), // Rule ID 70162 //
     /*   31560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   31595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31602 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   31602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   31613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31619 */     GIR_RootConstrainSelectedInstOperands,
     /*   31620 */     // GIR_Coverage, 70162,
     /*   31620 */     GIR_EraseRootFromParent_Done,
     /*   31621 */   // Label 1002: @31621
     /*   31621 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(31687), // Rule ID 52662 //
     /*   31626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   31658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   31666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31668 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   31668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   31679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31685 */     GIR_RootConstrainSelectedInstOperands,
     /*   31686 */     // GIR_Coverage, 52662,
     /*   31686 */     GIR_EraseRootFromParent_Done,
     /*   31687 */   // Label 1003: @31687
     /*   31687 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(31753), // Rule ID 52663 //
     /*   31692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   31707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   31711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   31715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   31724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   31728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   31732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31734 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   31734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*   31737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   31745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31751 */     GIR_RootConstrainSelectedInstOperands,
     /*   31752 */     // GIR_Coverage, 52663,
     /*   31752 */     GIR_EraseRootFromParent_Done,
     /*   31753 */   // Label 1004: @31753
     /*   31753 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(31786), // Rule ID 52650 //
     /*   31758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31769 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   31769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*   31772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31784 */     GIR_RootConstrainSelectedInstOperands,
     /*   31785 */     // GIR_Coverage, 52650,
     /*   31785 */     GIR_EraseRootFromParent_Done,
     /*   31786 */   // Label 1005: @31786
     /*   31786 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(31819), // Rule ID 52651 //
     /*   31791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31802 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   31802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*   31805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   31817 */     GIR_RootConstrainSelectedInstOperands,
     /*   31818 */     // GIR_Coverage, 52651,
     /*   31818 */     GIR_EraseRootFromParent_Done,
     /*   31819 */   // Label 1006: @31819
     /*   31819 */   GIM_Reject,
     /*   31820 */ // Label 996: @31820
     /*   31820 */ GIM_Reject,
     /*   31821 */ // Label 886: @31821
     /*   31821 */ GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(31935),
     /*   31826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31844 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(31889), // Rule ID 47114 //
     /*   31849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31852 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   31869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31887 */     GIR_RootConstrainSelectedInstOperands,
     /*   31888 */     // GIR_Coverage, 47114,
     /*   31888 */     GIR_EraseRootFromParent_Done,
     /*   31889 */   // Label 1008: @31889
     /*   31889 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(31934), // Rule ID 47115 //
     /*   31894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31897 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*   31914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31932 */     GIR_RootConstrainSelectedInstOperands,
     /*   31933 */     // GIR_Coverage, 47115,
     /*   31933 */     GIR_EraseRootFromParent_Done,
     /*   31934 */   // Label 1009: @31934
     /*   31934 */   GIM_Reject,
     /*   31935 */ // Label 1007: @31935
     /*   31935 */ GIM_Reject,
     /*   31936 */ // Label 887: @31936
     /*   31936 */ GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(32050),
     /*   31941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31959 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(32004), // Rule ID 47134 //
     /*   31964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31967 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   31967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   31970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   31984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32002 */     GIR_RootConstrainSelectedInstOperands,
     /*   32003 */     // GIR_Coverage, 47134,
     /*   32003 */     GIR_EraseRootFromParent_Done,
     /*   32004 */   // Label 1011: @32004
     /*   32004 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(32049), // Rule ID 47135 //
     /*   32009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32012 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   32012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   32015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   32029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32047 */     GIR_RootConstrainSelectedInstOperands,
     /*   32048 */     // GIR_Coverage, 47135,
     /*   32048 */     GIR_EraseRootFromParent_Done,
     /*   32049 */   // Label 1012: @32049
     /*   32049 */   GIM_Reject,
     /*   32050 */ // Label 1010: @32050
     /*   32050 */ GIM_Reject,
     /*   32051 */ // Label 888: @32051
     /*   32051 */ GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(32165),
     /*   32056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   32059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   32062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32074 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(32119), // Rule ID 47170 //
     /*   32079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32082 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   32082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   32099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   32114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32117 */     GIR_RootConstrainSelectedInstOperands,
     /*   32118 */     // GIR_Coverage, 47170,
     /*   32118 */     GIR_EraseRootFromParent_Done,
     /*   32119 */   // Label 1014: @32119
     /*   32119 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(32164), // Rule ID 47171 //
     /*   32124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32127 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   32127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   32144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   32159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32162 */     GIR_RootConstrainSelectedInstOperands,
     /*   32163 */     // GIR_Coverage, 47171,
     /*   32163 */     GIR_EraseRootFromParent_Done,
     /*   32164 */   // Label 1015: @32164
     /*   32164 */   GIM_Reject,
     /*   32165 */ // Label 1013: @32165
     /*   32165 */ GIM_Reject,
     /*   32166 */ // Label 889: @32166
     /*   32166 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(32280),
     /*   32171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   32174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   32177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   32181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   32185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   32189 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(32234), // Rule ID 47186 //
     /*   32194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   32197 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   32197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   32200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   32214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   32229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32232 */     GIR_RootConstrainSelectedInstOperands,
     /*   32233 */     // GIR_Coverage, 47186,
     /*   32233 */     GIR_EraseRootFromParent_Done,
     /*   32234 */   // Label 1017: @32234
     /*   32234 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(32279), // Rule ID 47187 //
     /*   32239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   32242 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   32242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   32245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   32259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   32274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32277 */     GIR_RootConstrainSelectedInstOperands,
     /*   32278 */     // GIR_Coverage, 47187,
     /*   32278 */     GIR_EraseRootFromParent_Done,
     /*   32279 */   // Label 1018: @32279
     /*   32279 */   GIM_Reject,
     /*   32280 */ // Label 1016: @32280
     /*   32280 */ GIM_Reject,
     /*   32281 */ // Label 890: @32281
     /*   32281 */ GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(32891),
     /*   32286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32296 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(32362), // Rule ID 70193 //
     /*   32301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   32332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32343 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   32350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   32354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32360 */     GIR_RootConstrainSelectedInstOperands,
     /*   32361 */     // GIR_Coverage, 70193,
     /*   32361 */     GIR_EraseRootFromParent_Done,
     /*   32362 */   // Label 1020: @32362
     /*   32362 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(32428), // Rule ID 70194 //
     /*   32367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   32398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32409 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   32409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   32416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   32420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32426 */     GIR_RootConstrainSelectedInstOperands,
     /*   32427 */     // GIR_Coverage, 70194,
     /*   32427 */     GIR_EraseRootFromParent_Done,
     /*   32428 */   // Label 1021: @32428
     /*   32428 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(32494), // Rule ID 70191 //
     /*   32433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   32461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   32469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32475 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   32475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   32482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32492 */     GIR_RootConstrainSelectedInstOperands,
     /*   32493 */     // GIR_Coverage, 70191,
     /*   32493 */     GIR_EraseRootFromParent_Done,
     /*   32494 */   // Label 1022: @32494
     /*   32494 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(32560), // Rule ID 70192 //
     /*   32499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   32527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   32535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32541 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   32541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   32548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32558 */     GIR_RootConstrainSelectedInstOperands,
     /*   32559 */     // GIR_Coverage, 70192,
     /*   32559 */     GIR_EraseRootFromParent_Done,
     /*   32560 */   // Label 1023: @32560
     /*   32560 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(32626), // Rule ID 70189 //
     /*   32565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   32600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32607 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   32607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   32618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32624 */     GIR_RootConstrainSelectedInstOperands,
     /*   32625 */     // GIR_Coverage, 70189,
     /*   32625 */     GIR_EraseRootFromParent_Done,
     /*   32626 */   // Label 1024: @32626
     /*   32626 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(32692), // Rule ID 70190 //
     /*   32631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   32666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32673 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   32673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   32684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32690 */     GIR_RootConstrainSelectedInstOperands,
     /*   32691 */     // GIR_Coverage, 70190,
     /*   32691 */     GIR_EraseRootFromParent_Done,
     /*   32692 */   // Label 1025: @32692
     /*   32692 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(32758), // Rule ID 52680 //
     /*   32697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   32729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   32737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32739 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   32739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32756 */     GIR_RootConstrainSelectedInstOperands,
     /*   32757 */     // GIR_Coverage, 52680,
     /*   32757 */     GIR_EraseRootFromParent_Done,
     /*   32758 */   // Label 1026: @32758
     /*   32758 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(32824), // Rule ID 52681 //
     /*   32763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   32778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   32782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   32786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   32795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   32799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   32803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32805 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   32805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*   32808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32822 */     GIR_RootConstrainSelectedInstOperands,
     /*   32823 */     // GIR_Coverage, 52681,
     /*   32823 */     GIR_EraseRootFromParent_Done,
     /*   32824 */   // Label 1027: @32824
     /*   32824 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(32857), // Rule ID 52668 //
     /*   32829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32840 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   32840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*   32843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32855 */     GIR_RootConstrainSelectedInstOperands,
     /*   32856 */     // GIR_Coverage, 52668,
     /*   32856 */     GIR_EraseRootFromParent_Done,
     /*   32857 */   // Label 1028: @32857
     /*   32857 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(32890), // Rule ID 52669 //
     /*   32862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32873 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   32873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*   32876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   32888 */     GIR_RootConstrainSelectedInstOperands,
     /*   32889 */     // GIR_Coverage, 52669,
     /*   32889 */     GIR_EraseRootFromParent_Done,
     /*   32890 */   // Label 1029: @32890
     /*   32890 */   GIM_Reject,
     /*   32891 */ // Label 1019: @32891
     /*   32891 */ GIM_Reject,
     /*   32892 */ // Label 891: @32892
     /*   32892 */ GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(33006),
     /*   32897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   32900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   32903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32915 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(32960), // Rule ID 47130 //
     /*   32920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32923 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   32923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   32926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   32940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32958 */     GIR_RootConstrainSelectedInstOperands,
     /*   32959 */     // GIR_Coverage, 47130,
     /*   32959 */     GIR_EraseRootFromParent_Done,
     /*   32960 */   // Label 1031: @32960
     /*   32960 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(33005), // Rule ID 47131 //
     /*   32965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32968 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   32968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   32971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*   32985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   32992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33003 */     GIR_RootConstrainSelectedInstOperands,
     /*   33004 */     // GIR_Coverage, 47131,
     /*   33004 */     GIR_EraseRootFromParent_Done,
     /*   33005 */   // Label 1032: @33005
     /*   33005 */   GIM_Reject,
     /*   33006 */ // Label 1030: @33006
     /*   33006 */ GIM_Reject,
     /*   33007 */ // Label 892: @33007
     /*   33007 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(33121),
     /*   33012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   33015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   33018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33030 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(33075), // Rule ID 47158 //
     /*   33035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33038 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   33038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   33041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   33055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33073 */     GIR_RootConstrainSelectedInstOperands,
     /*   33074 */     // GIR_Coverage, 47158,
     /*   33074 */     GIR_EraseRootFromParent_Done,
     /*   33075 */   // Label 1034: @33075
     /*   33075 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(33120), // Rule ID 47159 //
     /*   33080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33083 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   33083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   33086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   33100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33118 */     GIR_RootConstrainSelectedInstOperands,
     /*   33119 */     // GIR_Coverage, 47159,
     /*   33119 */     GIR_EraseRootFromParent_Done,
     /*   33120 */   // Label 1035: @33120
     /*   33120 */   GIM_Reject,
     /*   33121 */ // Label 1033: @33121
     /*   33121 */ GIM_Reject,
     /*   33122 */ // Label 893: @33122
     /*   33122 */ GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(33236),
     /*   33127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   33130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   33133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33145 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(33190), // Rule ID 47174 //
     /*   33150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33153 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   33153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   33156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   33170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33188 */     GIR_RootConstrainSelectedInstOperands,
     /*   33189 */     // GIR_Coverage, 47174,
     /*   33189 */     GIR_EraseRootFromParent_Done,
     /*   33190 */   // Label 1037: @33190
     /*   33190 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(33235), // Rule ID 47175 //
     /*   33195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33198 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   33198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   33201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   33215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33233 */     GIR_RootConstrainSelectedInstOperands,
     /*   33234 */     // GIR_Coverage, 47175,
     /*   33234 */     GIR_EraseRootFromParent_Done,
     /*   33235 */   // Label 1038: @33235
     /*   33235 */   GIM_Reject,
     /*   33236 */ // Label 1036: @33236
     /*   33236 */ GIM_Reject,
     /*   33237 */ // Label 894: @33237
     /*   33237 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(33351),
     /*   33242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   33245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   33248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   33252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   33256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   33260 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(33305), // Rule ID 47190 //
     /*   33265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   33268 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   33268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   33271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   33285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   33300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33303 */     GIR_RootConstrainSelectedInstOperands,
     /*   33304 */     // GIR_Coverage, 47190,
     /*   33304 */     GIR_EraseRootFromParent_Done,
     /*   33305 */   // Label 1040: @33305
     /*   33305 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(33350), // Rule ID 47191 //
     /*   33310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   33313 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   33313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   33316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   33330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   33345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33348 */     GIR_RootConstrainSelectedInstOperands,
     /*   33349 */     // GIR_Coverage, 47191,
     /*   33349 */     GIR_EraseRootFromParent_Done,
     /*   33350 */   // Label 1041: @33350
     /*   33350 */   GIM_Reject,
     /*   33351 */ // Label 1039: @33351
     /*   33351 */ GIM_Reject,
     /*   33352 */ // Label 895: @33352
     /*   33352 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(33962),
     /*   33357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33367 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(33433), // Rule ID 70221 //
     /*   33372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   33403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33414 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   33414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   33421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   33425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33431 */     GIR_RootConstrainSelectedInstOperands,
     /*   33432 */     // GIR_Coverage, 70221,
     /*   33432 */     GIR_EraseRootFromParent_Done,
     /*   33433 */   // Label 1043: @33433
     /*   33433 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(33499), // Rule ID 70222 //
     /*   33438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   33469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33480 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   33480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   33487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   33491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33497 */     GIR_RootConstrainSelectedInstOperands,
     /*   33498 */     // GIR_Coverage, 70222,
     /*   33498 */     GIR_EraseRootFromParent_Done,
     /*   33499 */   // Label 1044: @33499
     /*   33499 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(33565), // Rule ID 70219 //
     /*   33504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   33532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   33540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33546 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   33546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   33553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33563 */     GIR_RootConstrainSelectedInstOperands,
     /*   33564 */     // GIR_Coverage, 70219,
     /*   33564 */     GIR_EraseRootFromParent_Done,
     /*   33565 */   // Label 1045: @33565
     /*   33565 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(33631), // Rule ID 70220 //
     /*   33570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   33598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   33606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33612 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   33612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   33619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33629 */     GIR_RootConstrainSelectedInstOperands,
     /*   33630 */     // GIR_Coverage, 70220,
     /*   33630 */     GIR_EraseRootFromParent_Done,
     /*   33631 */   // Label 1046: @33631
     /*   33631 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(33697), // Rule ID 70217 //
     /*   33636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   33671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33678 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   33678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   33689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33695 */     GIR_RootConstrainSelectedInstOperands,
     /*   33696 */     // GIR_Coverage, 70217,
     /*   33696 */     GIR_EraseRootFromParent_Done,
     /*   33697 */   // Label 1047: @33697
     /*   33697 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(33763), // Rule ID 70218 //
     /*   33702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   33737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33744 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   33744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   33755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33761 */     GIR_RootConstrainSelectedInstOperands,
     /*   33762 */     // GIR_Coverage, 70218,
     /*   33762 */     GIR_EraseRootFromParent_Done,
     /*   33763 */   // Label 1048: @33763
     /*   33763 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(33829), // Rule ID 52698 //
     /*   33768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   33800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   33808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33810 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   33810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33827 */     GIR_RootConstrainSelectedInstOperands,
     /*   33828 */     // GIR_Coverage, 52698,
     /*   33828 */     GIR_EraseRootFromParent_Done,
     /*   33829 */   // Label 1049: @33829
     /*   33829 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(33895), // Rule ID 52699 //
     /*   33834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   33849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   33853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   33857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   33866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   33870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   33874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33876 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   33876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*   33879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33893 */     GIR_RootConstrainSelectedInstOperands,
     /*   33894 */     // GIR_Coverage, 52699,
     /*   33894 */     GIR_EraseRootFromParent_Done,
     /*   33895 */   // Label 1050: @33895
     /*   33895 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(33928), // Rule ID 52686 //
     /*   33900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33911 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   33911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*   33914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33926 */     GIR_RootConstrainSelectedInstOperands,
     /*   33927 */     // GIR_Coverage, 52686,
     /*   33927 */     GIR_EraseRootFromParent_Done,
     /*   33928 */   // Label 1051: @33928
     /*   33928 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(33961), // Rule ID 52687 //
     /*   33933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33944 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   33944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*   33947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   33959 */     GIR_RootConstrainSelectedInstOperands,
     /*   33960 */     // GIR_Coverage, 52687,
     /*   33960 */     GIR_EraseRootFromParent_Done,
     /*   33961 */   // Label 1052: @33961
     /*   33961 */   GIM_Reject,
     /*   33962 */ // Label 1042: @33962
     /*   33962 */ GIM_Reject,
     /*   33963 */ // Label 896: @33963
     /*   33963 */ GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(34077),
     /*   33968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   33971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   33974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33986 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(34031), // Rule ID 47146 //
     /*   33991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33994 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   33997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   34011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34029 */     GIR_RootConstrainSelectedInstOperands,
     /*   34030 */     // GIR_Coverage, 47146,
     /*   34030 */     GIR_EraseRootFromParent_Done,
     /*   34031 */   // Label 1054: @34031
     /*   34031 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(34076), // Rule ID 47147 //
     /*   34036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34039 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   34039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   34042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*   34056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34074 */     GIR_RootConstrainSelectedInstOperands,
     /*   34075 */     // GIR_Coverage, 47147,
     /*   34075 */     GIR_EraseRootFromParent_Done,
     /*   34076 */   // Label 1055: @34076
     /*   34076 */   GIM_Reject,
     /*   34077 */ // Label 1053: @34077
     /*   34077 */ GIM_Reject,
     /*   34078 */ // Label 897: @34078
     /*   34078 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(34192),
     /*   34083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   34086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   34089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34101 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(34146), // Rule ID 47162 //
     /*   34106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34109 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   34112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   34126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34144 */     GIR_RootConstrainSelectedInstOperands,
     /*   34145 */     // GIR_Coverage, 47162,
     /*   34145 */     GIR_EraseRootFromParent_Done,
     /*   34146 */   // Label 1057: @34146
     /*   34146 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(34191), // Rule ID 47163 //
     /*   34151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34154 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   34157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   34171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34189 */     GIR_RootConstrainSelectedInstOperands,
     /*   34190 */     // GIR_Coverage, 47163,
     /*   34190 */     GIR_EraseRootFromParent_Done,
     /*   34191 */   // Label 1058: @34191
     /*   34191 */   GIM_Reject,
     /*   34192 */ // Label 1056: @34192
     /*   34192 */ GIM_Reject,
     /*   34193 */ // Label 898: @34193
     /*   34193 */ GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(34307),
     /*   34198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   34201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   34204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   34208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   34212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   34216 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(34261), // Rule ID 47178 //
     /*   34221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34224 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   34224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   34227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   34241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34259 */     GIR_RootConstrainSelectedInstOperands,
     /*   34260 */     // GIR_Coverage, 47178,
     /*   34260 */     GIR_EraseRootFromParent_Done,
     /*   34261 */   // Label 1060: @34261
     /*   34261 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(34306), // Rule ID 47179 //
     /*   34266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34269 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   34269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   34272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   34286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34304 */     GIR_RootConstrainSelectedInstOperands,
     /*   34305 */     // GIR_Coverage, 47179,
     /*   34305 */     GIR_EraseRootFromParent_Done,
     /*   34306 */   // Label 1061: @34306
     /*   34306 */   GIM_Reject,
     /*   34307 */ // Label 1059: @34307
     /*   34307 */ GIM_Reject,
     /*   34308 */ // Label 899: @34308
     /*   34308 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(34918),
     /*   34313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34323 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(34389), // Rule ID 70249 //
     /*   34328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34370 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   34370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   34377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   34381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34387 */     GIR_RootConstrainSelectedInstOperands,
     /*   34388 */     // GIR_Coverage, 70249,
     /*   34388 */     GIR_EraseRootFromParent_Done,
     /*   34389 */   // Label 1063: @34389
     /*   34389 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(34455), // Rule ID 70250 //
     /*   34394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   34425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34436 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   34436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   34443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   34447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34453 */     GIR_RootConstrainSelectedInstOperands,
     /*   34454 */     // GIR_Coverage, 70250,
     /*   34454 */     GIR_EraseRootFromParent_Done,
     /*   34455 */   // Label 1064: @34455
     /*   34455 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(34521), // Rule ID 70247 //
     /*   34460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   34488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   34496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34502 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   34502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   34509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   34513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34519 */     GIR_RootConstrainSelectedInstOperands,
     /*   34520 */     // GIR_Coverage, 70247,
     /*   34520 */     GIR_EraseRootFromParent_Done,
     /*   34521 */   // Label 1065: @34521
     /*   34521 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(34587), // Rule ID 70248 //
     /*   34526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   34554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   34562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34568 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   34568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   34575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   34579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34585 */     GIR_RootConstrainSelectedInstOperands,
     /*   34586 */     // GIR_Coverage, 70248,
     /*   34586 */     GIR_EraseRootFromParent_Done,
     /*   34587 */   // Label 1066: @34587
     /*   34587 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(34653), // Rule ID 70245 //
     /*   34592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   34627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34634 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   34645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34651 */     GIR_RootConstrainSelectedInstOperands,
     /*   34652 */     // GIR_Coverage, 70245,
     /*   34652 */     GIR_EraseRootFromParent_Done,
     /*   34653 */   // Label 1067: @34653
     /*   34653 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(34719), // Rule ID 70246 //
     /*   34658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   34693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34700 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   34700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   34711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34717 */     GIR_RootConstrainSelectedInstOperands,
     /*   34718 */     // GIR_Coverage, 70246,
     /*   34718 */     GIR_EraseRootFromParent_Done,
     /*   34719 */   // Label 1068: @34719
     /*   34719 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(34785), // Rule ID 52716 //
     /*   34724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   34756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   34764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34766 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   34766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   34777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34783 */     GIR_RootConstrainSelectedInstOperands,
     /*   34784 */     // GIR_Coverage, 52716,
     /*   34784 */     GIR_EraseRootFromParent_Done,
     /*   34785 */   // Label 1069: @34785
     /*   34785 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(34851), // Rule ID 52717 //
     /*   34790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   34805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   34809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   34813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   34822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   34826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   34830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   34832 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   34832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*   34835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   34843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34849 */     GIR_RootConstrainSelectedInstOperands,
     /*   34850 */     // GIR_Coverage, 52717,
     /*   34850 */     GIR_EraseRootFromParent_Done,
     /*   34851 */   // Label 1070: @34851
     /*   34851 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(34884), // Rule ID 52704 //
     /*   34856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34867 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   34867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*   34870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34882 */     GIR_RootConstrainSelectedInstOperands,
     /*   34883 */     // GIR_Coverage, 52704,
     /*   34883 */     GIR_EraseRootFromParent_Done,
     /*   34884 */   // Label 1071: @34884
     /*   34884 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(34917), // Rule ID 52705 //
     /*   34889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34900 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   34900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*   34903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   34915 */     GIR_RootConstrainSelectedInstOperands,
     /*   34916 */     // GIR_Coverage, 52705,
     /*   34916 */     GIR_EraseRootFromParent_Done,
     /*   34917 */   // Label 1072: @34917
     /*   34917 */   GIM_Reject,
     /*   34918 */ // Label 1062: @34918
     /*   34918 */ GIM_Reject,
     /*   34919 */ // Label 900: @34919
     /*   34919 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(35033),
     /*   34924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   34927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   34930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34942 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(34987), // Rule ID 47150 //
     /*   34947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34950 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   34950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   34953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   34967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34985 */     GIR_RootConstrainSelectedInstOperands,
     /*   34986 */     // GIR_Coverage, 47150,
     /*   34986 */     GIR_EraseRootFromParent_Done,
     /*   34987 */   // Label 1074: @34987
     /*   34987 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(35032), // Rule ID 47151 //
     /*   34992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34995 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   34995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   34998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*   35012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35030 */     GIR_RootConstrainSelectedInstOperands,
     /*   35031 */     // GIR_Coverage, 47151,
     /*   35031 */     GIR_EraseRootFromParent_Done,
     /*   35032 */   // Label 1075: @35032
     /*   35032 */   GIM_Reject,
     /*   35033 */ // Label 1073: @35033
     /*   35033 */ GIM_Reject,
     /*   35034 */ // Label 901: @35034
     /*   35034 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(35148),
     /*   35039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   35042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   35045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35057 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(35102), // Rule ID 47166 //
     /*   35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35065 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   35065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   35068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   35082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35100 */     GIR_RootConstrainSelectedInstOperands,
     /*   35101 */     // GIR_Coverage, 47166,
     /*   35101 */     GIR_EraseRootFromParent_Done,
     /*   35102 */   // Label 1077: @35102
     /*   35102 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(35147), // Rule ID 47167 //
     /*   35107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35110 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   35110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   35113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   35127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35145 */     GIR_RootConstrainSelectedInstOperands,
     /*   35146 */     // GIR_Coverage, 47167,
     /*   35146 */     GIR_EraseRootFromParent_Done,
     /*   35147 */   // Label 1078: @35147
     /*   35147 */   GIM_Reject,
     /*   35148 */ // Label 1076: @35148
     /*   35148 */ GIM_Reject,
     /*   35149 */ // Label 902: @35149
     /*   35149 */ GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(35759),
     /*   35154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35164 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(35230), // Rule ID 70277 //
     /*   35169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   35200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35211 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   35211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   35218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   35222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35228 */     GIR_RootConstrainSelectedInstOperands,
     /*   35229 */     // GIR_Coverage, 70277,
     /*   35229 */     GIR_EraseRootFromParent_Done,
     /*   35230 */   // Label 1080: @35230
     /*   35230 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(35296), // Rule ID 70278 //
     /*   35235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   35266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35277 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   35277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   35284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   35288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35294 */     GIR_RootConstrainSelectedInstOperands,
     /*   35295 */     // GIR_Coverage, 70278,
     /*   35295 */     GIR_EraseRootFromParent_Done,
     /*   35296 */   // Label 1081: @35296
     /*   35296 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(35362), // Rule ID 70275 //
     /*   35301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   35329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   35337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35343 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   35343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   35350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35360 */     GIR_RootConstrainSelectedInstOperands,
     /*   35361 */     // GIR_Coverage, 70275,
     /*   35361 */     GIR_EraseRootFromParent_Done,
     /*   35362 */   // Label 1082: @35362
     /*   35362 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(35428), // Rule ID 70276 //
     /*   35367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   35395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   35403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35409 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   35409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   35416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35426 */     GIR_RootConstrainSelectedInstOperands,
     /*   35427 */     // GIR_Coverage, 70276,
     /*   35427 */     GIR_EraseRootFromParent_Done,
     /*   35428 */   // Label 1083: @35428
     /*   35428 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(35494), // Rule ID 70273 //
     /*   35433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   35468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35475 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   35475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   35486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35492 */     GIR_RootConstrainSelectedInstOperands,
     /*   35493 */     // GIR_Coverage, 70273,
     /*   35493 */     GIR_EraseRootFromParent_Done,
     /*   35494 */   // Label 1084: @35494
     /*   35494 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(35560), // Rule ID 70274 //
     /*   35499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   35534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35541 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   35541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   35552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35558 */     GIR_RootConstrainSelectedInstOperands,
     /*   35559 */     // GIR_Coverage, 70274,
     /*   35559 */     GIR_EraseRootFromParent_Done,
     /*   35560 */   // Label 1085: @35560
     /*   35560 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(35626), // Rule ID 52734 //
     /*   35565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   35597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   35605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35607 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   35607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35624 */     GIR_RootConstrainSelectedInstOperands,
     /*   35625 */     // GIR_Coverage, 52734,
     /*   35625 */     GIR_EraseRootFromParent_Done,
     /*   35626 */   // Label 1086: @35626
     /*   35626 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(35692), // Rule ID 52735 //
     /*   35631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   35646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   35650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   35654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   35663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   35667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   35671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35673 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   35673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*   35676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35690 */     GIR_RootConstrainSelectedInstOperands,
     /*   35691 */     // GIR_Coverage, 52735,
     /*   35691 */     GIR_EraseRootFromParent_Done,
     /*   35692 */   // Label 1087: @35692
     /*   35692 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(35725), // Rule ID 52722 //
     /*   35697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35708 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   35708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*   35711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35723 */     GIR_RootConstrainSelectedInstOperands,
     /*   35724 */     // GIR_Coverage, 52722,
     /*   35724 */     GIR_EraseRootFromParent_Done,
     /*   35725 */   // Label 1088: @35725
     /*   35725 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(35758), // Rule ID 52723 //
     /*   35730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35741 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   35741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*   35744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   35756 */     GIR_RootConstrainSelectedInstOperands,
     /*   35757 */     // GIR_Coverage, 52723,
     /*   35757 */     GIR_EraseRootFromParent_Done,
     /*   35758 */   // Label 1089: @35758
     /*   35758 */   GIM_Reject,
     /*   35759 */ // Label 1079: @35759
     /*   35759 */ GIM_Reject,
     /*   35760 */ // Label 903: @35760
     /*   35760 */ GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(35874),
     /*   35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   35768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   35771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   35783 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(35828), // Rule ID 47154 //
     /*   35788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35791 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   35791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   35794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   35808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35826 */     GIR_RootConstrainSelectedInstOperands,
     /*   35827 */     // GIR_Coverage, 47154,
     /*   35827 */     GIR_EraseRootFromParent_Done,
     /*   35828 */   // Label 1091: @35828
     /*   35828 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(35873), // Rule ID 47155 //
     /*   35833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35836 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   35836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   35839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*   35853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   35860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35871 */     GIR_RootConstrainSelectedInstOperands,
     /*   35872 */     // GIR_Coverage, 47155,
     /*   35872 */     GIR_EraseRootFromParent_Done,
     /*   35873 */   // Label 1092: @35873
     /*   35873 */   GIM_Reject,
     /*   35874 */ // Label 1090: @35874
     /*   35874 */ GIM_Reject,
     /*   35875 */ // Label 904: @35875
     /*   35875 */ GIM_Reject,
     /*   35876 */ // Label 8: @35876
     /*   35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1124*/ GIMT_Encode4(48412),
     /*   35887 */ /*GILLT_s32*//*Label 1093*/ GIMT_Encode4(36011),
     /*   35891 */ /*GILLT_s64*//*Label 1094*/ GIMT_Encode4(38657),
     /*   35895 */ /*GILLT_nxv1s1*//*Label 1095*/ GIMT_Encode4(41605),
     /*   35899 */ /*GILLT_nxv1s8*//*Label 1096*/ GIMT_Encode4(42216),
     /*   35903 */ /*GILLT_nxv1s16*//*Label 1097*/ GIMT_Encode4(42331),
     /*   35907 */ /*GILLT_nxv1s32*//*Label 1098*/ GIMT_Encode4(42446),
     /*   35911 */ /*GILLT_nxv1s64*//*Label 1099*/ GIMT_Encode4(42561),
     /*   35915 */ /*GILLT_nxv2s1*//*Label 1100*/ GIMT_Encode4(42676),
     /*   35919 */ /*GILLT_nxv2s8*//*Label 1101*/ GIMT_Encode4(43287),
     /*   35923 */ /*GILLT_nxv2s16*//*Label 1102*/ GIMT_Encode4(43402),
     /*   35927 */ /*GILLT_nxv2s32*//*Label 1103*/ GIMT_Encode4(43517),
     /*   35931 */ /*GILLT_nxv2s64*//*Label 1104*/ GIMT_Encode4(43632),
     /*   35935 */ /*GILLT_nxv4s1*//*Label 1105*/ GIMT_Encode4(43747),
     /*   35939 */ /*GILLT_nxv4s8*//*Label 1106*/ GIMT_Encode4(44358),
     /*   35943 */ /*GILLT_nxv4s16*//*Label 1107*/ GIMT_Encode4(44473),
     /*   35947 */ /*GILLT_nxv4s32*//*Label 1108*/ GIMT_Encode4(44588),
     /*   35951 */ /*GILLT_nxv4s64*//*Label 1109*/ GIMT_Encode4(44703),
     /*   35955 */ /*GILLT_nxv8s1*//*Label 1110*/ GIMT_Encode4(44818),
     /*   35959 */ /*GILLT_nxv8s8*//*Label 1111*/ GIMT_Encode4(45429),
     /*   35963 */ /*GILLT_nxv8s16*//*Label 1112*/ GIMT_Encode4(45544),
     /*   35967 */ /*GILLT_nxv8s32*//*Label 1113*/ GIMT_Encode4(45659),
     /*   35971 */ /*GILLT_nxv8s64*//*Label 1114*/ GIMT_Encode4(45774),
     /*   35975 */ /*GILLT_nxv16s1*//*Label 1115*/ GIMT_Encode4(45889),
     /*   35979 */ /*GILLT_nxv16s8*//*Label 1116*/ GIMT_Encode4(46500),
     /*   35983 */ /*GILLT_nxv16s16*//*Label 1117*/ GIMT_Encode4(46615),
     /*   35987 */ /*GILLT_nxv16s32*//*Label 1118*/ GIMT_Encode4(46730),
     /*   35991 */ /*GILLT_nxv32s1*//*Label 1119*/ GIMT_Encode4(46845),
     /*   35995 */ /*GILLT_nxv32s8*//*Label 1120*/ GIMT_Encode4(47456),
     /*   35999 */ /*GILLT_nxv32s16*//*Label 1121*/ GIMT_Encode4(47571),
     /*   36003 */ /*GILLT_nxv64s1*//*Label 1122*/ GIMT_Encode4(47686),
     /*   36007 */ /*GILLT_nxv64s8*//*Label 1123*/ GIMT_Encode4(48297),
     /*   36011 */ // Label 1093: @36011
     /*   36011 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(38656),
     /*   36016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   36019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   36022 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(36217), // Rule ID 64087 //
     /*   36027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   36030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   36034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   36046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   36050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   36054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   36062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   36066 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   36070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   36074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   36082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   36086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   36090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36094 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   36098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   36102 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   36106 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   36110 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36114 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   36118 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   36122 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*   36126 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   36128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   36135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   36142 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   36149 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   36156 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   36156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   36159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*   36173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*   36178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   36180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   36183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*   36197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*   36202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   36215 */     GIR_RootConstrainSelectedInstOperands,
     /*   36216 */     // GIR_Coverage, 64087,
     /*   36216 */     GIR_EraseRootFromParent_Done,
     /*   36217 */   // Label 1126: @36217
     /*   36217 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(36412), // Rule ID 64089 //
     /*   36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   36225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   36229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   36241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   36245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   36249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   36257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   36261 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   36265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   36269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   36277 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   36281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   36285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36289 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   36293 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   36297 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*   36301 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   36305 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36309 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   36313 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   36317 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*   36321 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   36323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   36330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   36337 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   36344 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   36351 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   36351 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   36354 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36358 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*   36368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*   36373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   36375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   36378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*   36392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*   36397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   36402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   36410 */     GIR_RootConstrainSelectedInstOperands,
     /*   36411 */     // GIR_Coverage, 64089,
     /*   36411 */     GIR_EraseRootFromParent_Done,
     /*   36412 */   // Label 1127: @36412
     /*   36412 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(36607), // Rule ID 64083 //
     /*   36417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   36420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   36424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   36436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   36440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   36452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   36456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   36460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   36464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   36472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   36476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   36480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36484 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   36488 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   36492 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   36496 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   36500 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36504 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   36508 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   36512 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*   36516 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   36518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   36525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   36532 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   36539 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   36546 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   36546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   36549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*   36563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*   36568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   36570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   36573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*   36587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*   36592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   36597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   36605 */     GIR_RootConstrainSelectedInstOperands,
     /*   36606 */     // GIR_Coverage, 64083,
     /*   36606 */     GIR_EraseRootFromParent_Done,
     /*   36607 */   // Label 1128: @36607
     /*   36607 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(36802), // Rule ID 64085 //
     /*   36612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   36615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   36619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   36631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   36635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   36647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   36651 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   36655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   36659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   36667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   36671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   36675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   36683 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   36687 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*   36691 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   36695 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36699 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   36703 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   36707 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*   36711 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   36713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   36720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   36727 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   36734 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   36741 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   36741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   36744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*   36758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*   36763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   36765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   36768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*   36782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*   36787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   36792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   36800 */     GIR_RootConstrainSelectedInstOperands,
     /*   36801 */     // GIR_Coverage, 64085,
     /*   36801 */     GIR_EraseRootFromParent_Done,
     /*   36802 */   // Label 1129: @36802
     /*   36802 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(36997), // Rule ID 64077 //
     /*   36807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   36810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   36814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   36826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   36830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   36842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   36846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   36850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   36862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   36866 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   36870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   36874 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   36878 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   36882 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   36886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*   36890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   36894 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   36898 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   36902 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   36906 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   36908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   36915 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   36922 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   36929 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   36936 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   36936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   36939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*   36953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*   36958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   36960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   36963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   36967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*   36977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*   36982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   36987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   36995 */     GIR_RootConstrainSelectedInstOperands,
     /*   36996 */     // GIR_Coverage, 64077,
     /*   36996 */     GIR_EraseRootFromParent_Done,
     /*   36997 */   // Label 1130: @36997
     /*   36997 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(37192), // Rule ID 64081 //
     /*   37002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   37005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37041 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   37045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   37057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   37061 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   37065 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   37069 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37073 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   37077 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   37081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*   37085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37089 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   37093 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   37097 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   37101 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   37103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37110 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   37117 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   37124 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   37131 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   37131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   37134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*   37148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*   37153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   37155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   37158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*   37172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*   37177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   37182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   37190 */     GIR_RootConstrainSelectedInstOperands,
     /*   37191 */     // GIR_Coverage, 64081,
     /*   37191 */     GIR_EraseRootFromParent_Done,
     /*   37192 */   // Label 1131: @37192
     /*   37192 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(37387), // Rule ID 2409 //
     /*   37197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   37200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37236 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   37240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   37252 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   37256 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   37260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   37264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37268 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   37272 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   37276 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   37280 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37284 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   37288 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   37292 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   37296 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   37298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37305 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   37312 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   37319 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   37326 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   37326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   37329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*   37343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*   37348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   37350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   37353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*   37367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*   37372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   37377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   37385 */     GIR_RootConstrainSelectedInstOperands,
     /*   37386 */     // GIR_Coverage, 2409,
     /*   37386 */     GIR_EraseRootFromParent_Done,
     /*   37387 */   // Label 1132: @37387
     /*   37387 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(37582), // Rule ID 64079 //
     /*   37392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   37395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37431 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   37435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37443 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   37447 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   37451 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   37455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   37459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   37463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*   37467 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   37471 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   37475 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37479 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*   37483 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*   37487 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   37491 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   37493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37500 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   37507 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   37514 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   37521 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*   37521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   37524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*   37538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*   37543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   37545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   37548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*   37562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*   37567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   37572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   37580 */     GIR_RootConstrainSelectedInstOperands,
     /*   37581 */     // GIR_Coverage, 64079,
     /*   37581 */     GIR_EraseRootFromParent_Done,
     /*   37582 */   // Label 1133: @37582
     /*   37582 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(37687), // Rule ID 2404 //
     /*   37587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   37590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37610 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*   37614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   37618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37630 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   37634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   37650 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*   37650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   37653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*   37667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   37672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   37677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   37685 */     GIR_RootConstrainSelectedInstOperands,
     /*   37686 */     // GIR_Coverage, 2404,
     /*   37686 */     GIR_EraseRootFromParent_Done,
     /*   37687 */   // Label 1134: @37687
     /*   37687 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(37792), // Rule ID 64072 //
     /*   37692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   37695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   37719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   37723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   37739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   37755 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*   37755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   37758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   37772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*   37777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   37782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   37790 */     GIR_RootConstrainSelectedInstOperands,
     /*   37791 */     // GIR_Coverage, 64072,
     /*   37791 */     GIR_EraseRootFromParent_Done,
     /*   37792 */   // Label 1135: @37792
     /*   37792 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(37881), // Rule ID 64066 //
     /*   37797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   37800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   37812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37841 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   37845 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   37856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37865 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   37865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   37875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   37879 */     GIR_RootConstrainSelectedInstOperands,
     /*   37880 */     // GIR_Coverage, 64066,
     /*   37880 */     GIR_EraseRootFromParent_Done,
     /*   37881 */   // Label 1136: @37881
     /*   37881 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(37970), // Rule ID 2398 //
     /*   37886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   37889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   37901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   37921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   37925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37930 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   37934 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   37945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   37954 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   37954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   37957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   37964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   37968 */     GIR_RootConstrainSelectedInstOperands,
     /*   37969 */     // GIR_Coverage, 2398,
     /*   37969 */     GIR_EraseRootFromParent_Done,
     /*   37970 */   // Label 1137: @37970
     /*   37970 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(38035), // Rule ID 64068 //
     /*   37975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   37978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   37982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   37990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   37994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   37998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   38002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   38018 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   38028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*   38033 */     GIR_RootConstrainSelectedInstOperands,
     /*   38034 */     // GIR_Coverage, 64068,
     /*   38034 */     GIR_EraseRootFromParent_Done,
     /*   38035 */   // Label 1138: @38035
     /*   38035 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(38100), // Rule ID 2400 //
     /*   38040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   38043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38063 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   38067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   38076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38083 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*   38093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   38098 */     GIR_RootConstrainSelectedInstOperands,
     /*   38099 */     // GIR_Coverage, 2400,
     /*   38099 */     GIR_EraseRootFromParent_Done,
     /*   38100 */   // Label 1139: @38100
     /*   38100 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(38166), // Rule ID 64074 //
     /*   38105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   38108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   38137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10863),
     /*   38141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38150 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_10863>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   38160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38164 */     GIR_RootConstrainSelectedInstOperands,
     /*   38165 */     // GIR_Coverage, 64074,
     /*   38165 */     GIR_EraseRootFromParent_Done,
     /*   38166 */   // Label 1140: @38166
     /*   38166 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(38232), // Rule ID 2406 //
     /*   38171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*   38174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   38203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10863),
     /*   38207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38216 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_10863>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   38226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38230 */     GIR_RootConstrainSelectedInstOperands,
     /*   38231 */     // GIR_Coverage, 2406,
     /*   38231 */     GIR_EraseRootFromParent_Done,
     /*   38232 */   // Label 1141: @38232
     /*   38232 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(38294), // Rule ID 2407 //
     /*   38237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   38240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38265 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   38269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   38278 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   38281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   38288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38292 */     GIR_RootConstrainSelectedInstOperands,
     /*   38293 */     // GIR_Coverage, 2407,
     /*   38293 */     GIR_EraseRootFromParent_Done,
     /*   38294 */   // Label 1142: @38294
     /*   38294 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(38356), // Rule ID 64075 //
     /*   38299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*   38302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38327 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   38331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   38340 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   38343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   38350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38354 */     GIR_RootConstrainSelectedInstOperands,
     /*   38355 */     // GIR_Coverage, 64075,
     /*   38355 */     GIR_EraseRootFromParent_Done,
     /*   38356 */   // Label 1143: @38356
     /*   38356 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(38415), // Rule ID 2333 //
     /*   38361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   38364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   38388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   38401 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   38404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   38408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   38413 */     GIR_RootConstrainSelectedInstOperands,
     /*   38414 */     // GIR_Coverage, 2333,
     /*   38414 */     GIR_EraseRootFromParent_Done,
     /*   38415 */   // Label 1144: @38415
     /*   38415 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(38474), // Rule ID 64062 //
     /*   38420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   38423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38447 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   38451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   38460 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   38463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   38472 */     GIR_RootConstrainSelectedInstOperands,
     /*   38473 */     // GIR_Coverage, 64062,
     /*   38473 */     GIR_EraseRootFromParent_Done,
     /*   38474 */   // Label 1145: @38474
     /*   38474 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(38530), // Rule ID 64046 //
     /*   38479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   38482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   38494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   38511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38517 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*   38520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   38524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38528 */     GIR_RootConstrainSelectedInstOperands,
     /*   38529 */     // GIR_Coverage, 64046,
     /*   38529 */     GIR_EraseRootFromParent_Done,
     /*   38530 */   // Label 1146: @38530
     /*   38530 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(38586), // Rule ID 2307 //
     /*   38535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   38538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   38554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   38558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   38562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   38571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38573 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*   38576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38584 */     GIR_RootConstrainSelectedInstOperands,
     /*   38585 */     // GIR_Coverage, 2307,
     /*   38585 */     GIR_EraseRootFromParent_Done,
     /*   38586 */   // Label 1147: @38586
     /*   38586 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(38628), // Rule ID 81 //
     /*   38591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   38594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   38610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   38614 */     // MIs[1] Operand 1
     /*   38614 */     // No operand predicates
     /*   38614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   38616 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*   38616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*   38619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   38626 */     GIR_RootConstrainSelectedInstOperands,
     /*   38627 */     // GIR_Coverage, 81,
     /*   38627 */     GIR_EraseRootFromParent_Done,
     /*   38628 */   // Label 1148: @38628
     /*   38628 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(38655), // Rule ID 79 //
     /*   38633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   38636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38648 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   38648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*   38653 */     GIR_RootConstrainSelectedInstOperands,
     /*   38654 */     // GIR_Coverage, 79,
     /*   38654 */     GIR_Done,
     /*   38655 */   // Label 1149: @38655
     /*   38655 */   GIM_Reject,
     /*   38656 */ // Label 1125: @38656
     /*   38656 */ GIM_Reject,
     /*   38657 */ // Label 1094: @38657
     /*   38657 */ GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(41604),
     /*   38662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   38665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   38668 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(38863), // Rule ID 64086 //
     /*   38673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   38676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   38688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   38692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   38696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   38700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   38708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   38712 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   38716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   38720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   38724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   38728 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   38732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   38736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38740 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   38744 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   38748 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   38752 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   38756 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38760 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   38764 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   38768 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*   38772 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   38774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   38788 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   38795 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   38802 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   38802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   38805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*   38819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*   38824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   38826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   38829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   38833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*   38843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*   38848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   38853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   38861 */     GIR_RootConstrainSelectedInstOperands,
     /*   38862 */     // GIR_Coverage, 64086,
     /*   38862 */     GIR_EraseRootFromParent_Done,
     /*   38863 */   // Label 1151: @38863
     /*   38863 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(39058), // Rule ID 64088 //
     /*   38868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   38871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   38875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   38883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   38887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   38891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   38895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   38903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   38907 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   38911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   38915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   38919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   38923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   38927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   38931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   38939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   38943 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*   38947 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   38951 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   38955 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   38959 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   38963 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*   38967 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   38969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   38976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   38983 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   38990 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   38997 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   38997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*   39014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*   39019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*   39038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*   39043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   39048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   39056 */     GIR_RootConstrainSelectedInstOperands,
     /*   39057 */     // GIR_Coverage, 64088,
     /*   39057 */     GIR_EraseRootFromParent_Done,
     /*   39058 */   // Label 1152: @39058
     /*   39058 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(39253), // Rule ID 64082 //
     /*   39063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   39066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   39070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   39082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   39086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   39098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   39102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   39106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   39110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   39118 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   39122 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   39126 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39130 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   39134 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   39138 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   39142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   39146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   39154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   39158 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*   39162 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   39164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   39171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   39178 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   39185 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   39192 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   39192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*   39209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*   39214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*   39233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*   39238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   39243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   39251 */     GIR_RootConstrainSelectedInstOperands,
     /*   39252 */     // GIR_Coverage, 64082,
     /*   39252 */     GIR_EraseRootFromParent_Done,
     /*   39253 */   // Label 1153: @39253
     /*   39253 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(39448), // Rule ID 64084 //
     /*   39258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   39261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   39265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   39277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   39281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   39293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   39297 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   39301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   39305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   39313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   39317 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   39321 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39325 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   39329 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   39333 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*   39337 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*   39341 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39345 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   39349 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   39353 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*   39357 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   39359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   39366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   39373 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   39380 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   39387 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   39387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*   39404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*   39409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*   39428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*   39433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   39438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   39446 */     GIR_RootConstrainSelectedInstOperands,
     /*   39447 */     // GIR_Coverage, 64084,
     /*   39447 */     GIR_EraseRootFromParent_Done,
     /*   39448 */   // Label 1154: @39448
     /*   39448 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(39643), // Rule ID 64076 //
     /*   39453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   39456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   39460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   39472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   39476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   39488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   39492 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   39496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   39508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   39512 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   39516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   39520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39524 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   39528 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   39532 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*   39536 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39540 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   39544 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   39548 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   39552 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   39554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   39561 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   39568 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   39575 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   39582 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   39582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*   39599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*   39604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*   39623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*   39628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   39633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   39641 */     GIR_RootConstrainSelectedInstOperands,
     /*   39642 */     // GIR_Coverage, 64076,
     /*   39642 */     GIR_EraseRootFromParent_Done,
     /*   39643 */   // Label 1155: @39643
     /*   39643 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(39838), // Rule ID 64080 //
     /*   39648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   39651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   39655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   39667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   39671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   39683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   39687 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   39691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   39703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   39707 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   39711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   39715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   39723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   39727 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*   39731 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39735 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   39739 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   39743 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   39747 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   39749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   39756 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   39763 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   39770 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   39777 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   39777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*   39794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*   39799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*   39818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*   39823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   39828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   39836 */     GIR_RootConstrainSelectedInstOperands,
     /*   39837 */     // GIR_Coverage, 64080,
     /*   39837 */     GIR_EraseRootFromParent_Done,
     /*   39838 */   // Label 1156: @39838
     /*   39838 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(40033), // Rule ID 2408 //
     /*   39843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   39846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   39850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   39862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   39866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   39878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   39882 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   39886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   39898 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   39902 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   39906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   39910 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   39914 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   39918 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   39922 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   39926 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   39930 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   39934 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   39938 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   39942 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   39944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   39951 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   39958 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   39965 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   39972 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   39972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   39975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   39979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*   39989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*   39994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   39996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   39999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*   40013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*   40018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   40023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   40031 */     GIR_RootConstrainSelectedInstOperands,
     /*   40032 */     // GIR_Coverage, 2408,
     /*   40032 */     GIR_EraseRootFromParent_Done,
     /*   40033 */   // Label 1157: @40033
     /*   40033 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(40228), // Rule ID 64078 //
     /*   40038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*   40041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   40053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40077 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   40081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*   40093 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*   40097 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   40101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   40105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   40109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*   40113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*   40117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   40121 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40125 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*   40129 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*   40133 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*   40137 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*   40139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40146 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   40153 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*   40160 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*   40167 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*   40167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   40170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*   40184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*   40189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   40191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   40194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*   40208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*   40213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   40218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   40226 */     GIR_RootConstrainSelectedInstOperands,
     /*   40227 */     // GIR_Coverage, 64078,
     /*   40227 */     GIR_EraseRootFromParent_Done,
     /*   40228 */   // Label 1158: @40228
     /*   40228 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(40333), // Rule ID 2403 //
     /*   40233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*   40260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   40280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   40296 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*   40296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   40299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*   40313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   40318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   40323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   40331 */     GIR_RootConstrainSelectedInstOperands,
     /*   40332 */     // GIR_Coverage, 2403,
     /*   40332 */     GIR_EraseRootFromParent_Done,
     /*   40333 */   // Label 1159: @40333
     /*   40333 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(40438), // Rule ID 64071 //
     /*   40338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   40365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40381 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   40385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   40401 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*   40401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   40404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*   40423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   40428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   40436 */     GIR_RootConstrainSelectedInstOperands,
     /*   40437 */     // GIR_Coverage, 64071,
     /*   40437 */     GIR_EraseRootFromParent_Done,
     /*   40438 */   // Label 1160: @40438
     /*   40438 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(40527), // Rule ID 64065 //
     /*   40443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   40458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   40491 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   40502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40511 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40525 */     GIR_RootConstrainSelectedInstOperands,
     /*   40526 */     // GIR_Coverage, 64065,
     /*   40526 */     GIR_EraseRootFromParent_Done,
     /*   40527 */   // Label 1161: @40527
     /*   40527 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(40616), // Rule ID 2397 //
     /*   40532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   40547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40576 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*   40580 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   40591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40600 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40614 */     GIR_RootConstrainSelectedInstOperands,
     /*   40615 */     // GIR_Coverage, 2397,
     /*   40615 */     GIR_EraseRootFromParent_Done,
     /*   40616 */   // Label 1162: @40616
     /*   40616 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(40681), // Rule ID 64067 //
     /*   40621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   40648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   40664 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*   40679 */     GIR_RootConstrainSelectedInstOperands,
     /*   40680 */     // GIR_Coverage, 64067,
     /*   40680 */     GIR_EraseRootFromParent_Done,
     /*   40681 */   // Label 1163: @40681
     /*   40681 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(40746), // Rule ID 2399 //
     /*   40686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40709 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   40713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*   40722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40729 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*   40739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   40744 */     GIR_RootConstrainSelectedInstOperands,
     /*   40745 */     // GIR_Coverage, 2399,
     /*   40745 */     GIR_EraseRootFromParent_Done,
     /*   40746 */   // Label 1164: @40746
     /*   40746 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(40831), // Rule ID 64092 //
     /*   40751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   40754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   40766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   40795 */     // MIs[1] Operand 2
     /*   40795 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*   40806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   40815 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*   40818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40829 */     GIR_RootConstrainSelectedInstOperands,
     /*   40830 */     // GIR_Coverage, 64092,
     /*   40830 */     GIR_EraseRootFromParent_Done,
     /*   40831 */   // Label 1165: @40831
     /*   40831 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(40916), // Rule ID 2412 //
     /*   40836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   40839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   40851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   40867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   40871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40876 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   40880 */     // MIs[1] Operand 2
     /*   40880 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*   40891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   40900 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*   40903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40914 */     GIR_RootConstrainSelectedInstOperands,
     /*   40915 */     // GIR_Coverage, 2412,
     /*   40915 */     GIR_EraseRootFromParent_Done,
     /*   40916 */   // Label 1166: @40916
     /*   40916 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(40982), // Rule ID 64073 //
     /*   40921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   40924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   40936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   40940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   40944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   40953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10863),
     /*   40957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   40966 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_10863>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   40966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   40969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   40976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   40980 */     GIR_RootConstrainSelectedInstOperands,
     /*   40981 */     // GIR_Coverage, 64073,
     /*   40981 */     GIR_EraseRootFromParent_Done,
     /*   40982 */   // Label 1167: @40982
     /*   40982 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(41048), // Rule ID 64091 //
     /*   40987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   40990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   40994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   41019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9716),
     /*   41023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   41032 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_9716>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*   41035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   41042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41046 */     GIR_RootConstrainSelectedInstOperands,
     /*   41047 */     // GIR_Coverage, 64091,
     /*   41047 */     GIR_EraseRootFromParent_Done,
     /*   41048 */   // Label 1168: @41048
     /*   41048 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(41114), // Rule ID 2405 //
     /*   41053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*   41056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*   41085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10863),
     /*   41089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*   41098 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10863>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*   41101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   41108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41112 */     GIR_RootConstrainSelectedInstOperands,
     /*   41113 */     // GIR_Coverage, 2405,
     /*   41113 */     GIR_EraseRootFromParent_Done,
     /*   41114 */   // Label 1169: @41114
     /*   41114 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(41180), // Rule ID 2411 //
     /*   41119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   41122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*   41151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9716),
     /*   41155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*   41164 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_9716>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*   41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   41174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41178 */     GIR_RootConstrainSelectedInstOperands,
     /*   41179 */     // GIR_Coverage, 2411,
     /*   41179 */     GIR_EraseRootFromParent_Done,
     /*   41180 */   // Label 1170: @41180
     /*   41180 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(41242), // Rule ID 2410 //
     /*   41185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   41188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*   41217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*   41226 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   41229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   41236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41240 */     GIR_RootConstrainSelectedInstOperands,
     /*   41241 */     // GIR_Coverage, 2410,
     /*   41241 */     GIR_EraseRootFromParent_Done,
     /*   41242 */   // Label 1171: @41242
     /*   41242 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(41304), // Rule ID 64090 //
     /*   41247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*   41250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*   41279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*   41288 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*   41291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   41298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41302 */     GIR_RootConstrainSelectedInstOperands,
     /*   41303 */     // GIR_Coverage, 64090,
     /*   41303 */     GIR_EraseRootFromParent_Done,
     /*   41304 */   // Label 1172: @41304
     /*   41304 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(41363), // Rule ID 2332 //
     /*   41309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   41312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41332 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   41336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   41349 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   41352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   41361 */     GIR_RootConstrainSelectedInstOperands,
     /*   41362 */     // GIR_Coverage, 2332,
     /*   41362 */     GIR_EraseRootFromParent_Done,
     /*   41363 */   // Label 1173: @41363
     /*   41363 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(41422), // Rule ID 64061 //
     /*   41368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   41371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   41387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41395 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   41399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   41408 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   41411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   41420 */     GIR_RootConstrainSelectedInstOperands,
     /*   41421 */     // GIR_Coverage, 64061,
     /*   41421 */     GIR_EraseRootFromParent_Done,
     /*   41422 */   // Label 1174: @41422
     /*   41422 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(41478), // Rule ID 64045 //
     /*   41427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   41430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   41459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41465 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*   41468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41476 */     GIR_RootConstrainSelectedInstOperands,
     /*   41477 */     // GIR_Coverage, 64045,
     /*   41477 */     GIR_EraseRootFromParent_Done,
     /*   41478 */   // Label 1175: @41478
     /*   41478 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(41534), // Rule ID 2306 //
     /*   41483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   41486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   41506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   41510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   41519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41521 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*   41524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41532 */     GIR_RootConstrainSelectedInstOperands,
     /*   41533 */     // GIR_Coverage, 2306,
     /*   41533 */     GIR_EraseRootFromParent_Done,
     /*   41534 */   // Label 1176: @41534
     /*   41534 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(41576), // Rule ID 80 //
     /*   41539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   41542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   41558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   41562 */     // MIs[1] Operand 1
     /*   41562 */     // No operand predicates
     /*   41562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41564 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   41564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*   41567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   41574 */     GIR_RootConstrainSelectedInstOperands,
     /*   41575 */     // GIR_Coverage, 80,
     /*   41575 */     GIR_EraseRootFromParent_Done,
     /*   41576 */   // Label 1177: @41576
     /*   41576 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(41603), // Rule ID 78 //
     /*   41581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   41584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   41596 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   41596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*   41601 */     GIR_RootConstrainSelectedInstOperands,
     /*   41602 */     // GIR_Coverage, 78,
     /*   41602 */     GIR_Done,
     /*   41603 */   // Label 1178: @41603
     /*   41603 */   GIM_Reject,
     /*   41604 */ // Label 1150: @41604
     /*   41604 */ GIM_Reject,
     /*   41605 */ // Label 1095: @41605
     /*   41605 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(42215),
     /*   41610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41620 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(41686), // Rule ID 70115 //
     /*   41625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   41656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41667 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   41667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   41670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   41678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   41684 */     GIR_RootConstrainSelectedInstOperands,
     /*   41685 */     // GIR_Coverage, 70115,
     /*   41685 */     GIR_EraseRootFromParent_Done,
     /*   41686 */   // Label 1180: @41686
     /*   41686 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(41752), // Rule ID 70116 //
     /*   41691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   41722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41733 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   41733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   41736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   41744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   41750 */     GIR_RootConstrainSelectedInstOperands,
     /*   41751 */     // GIR_Coverage, 70116,
     /*   41751 */     GIR_EraseRootFromParent_Done,
     /*   41752 */   // Label 1181: @41752
     /*   41752 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(41818), // Rule ID 70113 //
     /*   41757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   41785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   41793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41799 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   41799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   41802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   41816 */     GIR_RootConstrainSelectedInstOperands,
     /*   41817 */     // GIR_Coverage, 70113,
     /*   41817 */     GIR_EraseRootFromParent_Done,
     /*   41818 */   // Label 1182: @41818
     /*   41818 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(41884), // Rule ID 70114 //
     /*   41823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   41851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   41859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41865 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   41865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   41868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   41872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   41882 */     GIR_RootConstrainSelectedInstOperands,
     /*   41883 */     // GIR_Coverage, 70114,
     /*   41883 */     GIR_EraseRootFromParent_Done,
     /*   41884 */   // Label 1183: @41884
     /*   41884 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(41950), // Rule ID 70111 //
     /*   41889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   41924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41931 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   41931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   41934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   41942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   41948 */     GIR_RootConstrainSelectedInstOperands,
     /*   41949 */     // GIR_Coverage, 70111,
     /*   41949 */     GIR_EraseRootFromParent_Done,
     /*   41950 */   // Label 1184: @41950
     /*   41950 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(42016), // Rule ID 70112 //
     /*   41955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   41970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   41974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   41978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   41986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   41990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41997 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   41997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   42000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   42008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42014 */     GIR_RootConstrainSelectedInstOperands,
     /*   42015 */     // GIR_Coverage, 70112,
     /*   42015 */     GIR_EraseRootFromParent_Done,
     /*   42016 */   // Label 1185: @42016
     /*   42016 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(42082), // Rule ID 52628 //
     /*   42021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   42040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   42044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   42053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   42061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42063 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   42063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   42066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42080 */     GIR_RootConstrainSelectedInstOperands,
     /*   42081 */     // GIR_Coverage, 52628,
     /*   42081 */     GIR_EraseRootFromParent_Done,
     /*   42082 */   // Label 1186: @42082
     /*   42082 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(42148), // Rule ID 52629 //
     /*   42087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   42106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   42110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   42119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   42127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42129 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   42129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*   42132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42146 */     GIR_RootConstrainSelectedInstOperands,
     /*   42147 */     // GIR_Coverage, 52629,
     /*   42147 */     GIR_EraseRootFromParent_Done,
     /*   42148 */   // Label 1187: @42148
     /*   42148 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(42181), // Rule ID 52616 //
     /*   42153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42164 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   42164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*   42167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42179 */     GIR_RootConstrainSelectedInstOperands,
     /*   42180 */     // GIR_Coverage, 52616,
     /*   42180 */     GIR_EraseRootFromParent_Done,
     /*   42181 */   // Label 1188: @42181
     /*   42181 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(42214), // Rule ID 52617 //
     /*   42186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42197 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   42197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*   42200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42212 */     GIR_RootConstrainSelectedInstOperands,
     /*   42213 */     // GIR_Coverage, 52617,
     /*   42213 */     GIR_EraseRootFromParent_Done,
     /*   42214 */   // Label 1189: @42214
     /*   42214 */   GIM_Reject,
     /*   42215 */ // Label 1179: @42215
     /*   42215 */ GIM_Reject,
     /*   42216 */ // Label 1096: @42216
     /*   42216 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(42330),
     /*   42221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   42224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   42227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42239 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(42284), // Rule ID 47238 //
     /*   42244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42247 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   42250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*   42264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42282 */     GIR_RootConstrainSelectedInstOperands,
     /*   42283 */     // GIR_Coverage, 47238,
     /*   42283 */     GIR_EraseRootFromParent_Done,
     /*   42284 */   // Label 1191: @42284
     /*   42284 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(42329), // Rule ID 47239 //
     /*   42289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42292 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   42292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   42295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*   42309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42327 */     GIR_RootConstrainSelectedInstOperands,
     /*   42328 */     // GIR_Coverage, 47239,
     /*   42328 */     GIR_EraseRootFromParent_Done,
     /*   42329 */   // Label 1192: @42329
     /*   42329 */   GIM_Reject,
     /*   42330 */ // Label 1190: @42330
     /*   42330 */ GIM_Reject,
     /*   42331 */ // Label 1097: @42331
     /*   42331 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(42445),
     /*   42336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   42339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   42342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42354 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(42399), // Rule ID 47250 //
     /*   42359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42362 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   42362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   42365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*   42379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42397 */     GIR_RootConstrainSelectedInstOperands,
     /*   42398 */     // GIR_Coverage, 47250,
     /*   42398 */     GIR_EraseRootFromParent_Done,
     /*   42399 */   // Label 1194: @42399
     /*   42399 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(42444), // Rule ID 47251 //
     /*   42404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42407 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   42407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   42410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*   42424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42442 */     GIR_RootConstrainSelectedInstOperands,
     /*   42443 */     // GIR_Coverage, 47251,
     /*   42443 */     GIR_EraseRootFromParent_Done,
     /*   42444 */   // Label 1195: @42444
     /*   42444 */   GIM_Reject,
     /*   42445 */ // Label 1193: @42445
     /*   42445 */ GIM_Reject,
     /*   42446 */ // Label 1098: @42446
     /*   42446 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(42560),
     /*   42451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   42454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   42457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42469 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(42514), // Rule ID 47258 //
     /*   42474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42477 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   42477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   42480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   42494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42512 */     GIR_RootConstrainSelectedInstOperands,
     /*   42513 */     // GIR_Coverage, 47258,
     /*   42513 */     GIR_EraseRootFromParent_Done,
     /*   42514 */   // Label 1197: @42514
     /*   42514 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(42559), // Rule ID 47259 //
     /*   42519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42522 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   42522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   42525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   42539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42557 */     GIR_RootConstrainSelectedInstOperands,
     /*   42558 */     // GIR_Coverage, 47259,
     /*   42558 */     GIR_EraseRootFromParent_Done,
     /*   42559 */   // Label 1198: @42559
     /*   42559 */   GIM_Reject,
     /*   42560 */ // Label 1196: @42560
     /*   42560 */ GIM_Reject,
     /*   42561 */ // Label 1099: @42561
     /*   42561 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(42675),
     /*   42566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   42569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   42572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42584 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(42629), // Rule ID 47274 //
     /*   42589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   42592 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   42592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   42595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   42609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   42624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42627 */     GIR_RootConstrainSelectedInstOperands,
     /*   42628 */     // GIR_Coverage, 47274,
     /*   42628 */     GIR_EraseRootFromParent_Done,
     /*   42629 */   // Label 1200: @42629
     /*   42629 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(42674), // Rule ID 47275 //
     /*   42634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   42637 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   42637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   42640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   42654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   42661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   42669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42672 */     GIR_RootConstrainSelectedInstOperands,
     /*   42673 */     // GIR_Coverage, 47275,
     /*   42673 */     GIR_EraseRootFromParent_Done,
     /*   42674 */   // Label 1201: @42674
     /*   42674 */   GIM_Reject,
     /*   42675 */ // Label 1199: @42675
     /*   42675 */ GIM_Reject,
     /*   42676 */ // Label 1100: @42676
     /*   42676 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(43286),
     /*   42681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42691 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(42757), // Rule ID 70143 //
     /*   42696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   42727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42738 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   42738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   42741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   42745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   42749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42755 */     GIR_RootConstrainSelectedInstOperands,
     /*   42756 */     // GIR_Coverage, 70143,
     /*   42756 */     GIR_EraseRootFromParent_Done,
     /*   42757 */   // Label 1203: @42757
     /*   42757 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(42823), // Rule ID 70144 //
     /*   42762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   42793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42804 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   42804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   42807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   42811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   42815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42821 */     GIR_RootConstrainSelectedInstOperands,
     /*   42822 */     // GIR_Coverage, 70144,
     /*   42822 */     GIR_EraseRootFromParent_Done,
     /*   42823 */   // Label 1204: @42823
     /*   42823 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(42889), // Rule ID 70141 //
     /*   42828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   42856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   42864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42870 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   42870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   42873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   42877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42887 */     GIR_RootConstrainSelectedInstOperands,
     /*   42888 */     // GIR_Coverage, 70141,
     /*   42888 */     GIR_EraseRootFromParent_Done,
     /*   42889 */   // Label 1205: @42889
     /*   42889 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(42955), // Rule ID 70142 //
     /*   42894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   42922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   42930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42936 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   42936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   42939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   42943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   42953 */     GIR_RootConstrainSelectedInstOperands,
     /*   42954 */     // GIR_Coverage, 70142,
     /*   42954 */     GIR_EraseRootFromParent_Done,
     /*   42955 */   // Label 1206: @42955
     /*   42955 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(43021), // Rule ID 70139 //
     /*   42960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   42975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   42979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   42983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   42991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   42995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43002 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   43002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   43005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   43013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43019 */     GIR_RootConstrainSelectedInstOperands,
     /*   43020 */     // GIR_Coverage, 70139,
     /*   43020 */     GIR_EraseRootFromParent_Done,
     /*   43021 */   // Label 1207: @43021
     /*   43021 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(43087), // Rule ID 70140 //
     /*   43026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   43045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   43049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   43061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43068 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   43068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   43071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   43079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43085 */     GIR_RootConstrainSelectedInstOperands,
     /*   43086 */     // GIR_Coverage, 70140,
     /*   43086 */     GIR_EraseRootFromParent_Done,
     /*   43087 */   // Label 1208: @43087
     /*   43087 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(43153), // Rule ID 52646 //
     /*   43092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   43111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   43115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   43124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   43132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43134 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   43134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   43137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43151 */     GIR_RootConstrainSelectedInstOperands,
     /*   43152 */     // GIR_Coverage, 52646,
     /*   43152 */     GIR_EraseRootFromParent_Done,
     /*   43153 */   // Label 1209: @43153
     /*   43153 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(43219), // Rule ID 52647 //
     /*   43158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   43177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   43181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   43190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   43198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43200 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   43200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*   43203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43217 */     GIR_RootConstrainSelectedInstOperands,
     /*   43218 */     // GIR_Coverage, 52647,
     /*   43218 */     GIR_EraseRootFromParent_Done,
     /*   43219 */   // Label 1210: @43219
     /*   43219 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(43252), // Rule ID 52634 //
     /*   43224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43235 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   43235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*   43238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43250 */     GIR_RootConstrainSelectedInstOperands,
     /*   43251 */     // GIR_Coverage, 52634,
     /*   43251 */     GIR_EraseRootFromParent_Done,
     /*   43252 */   // Label 1211: @43252
     /*   43252 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(43285), // Rule ID 52635 //
     /*   43257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43268 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   43268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*   43271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43283 */     GIR_RootConstrainSelectedInstOperands,
     /*   43284 */     // GIR_Coverage, 52635,
     /*   43284 */     GIR_EraseRootFromParent_Done,
     /*   43285 */   // Label 1212: @43285
     /*   43285 */   GIM_Reject,
     /*   43286 */ // Label 1202: @43286
     /*   43286 */ GIM_Reject,
     /*   43287 */ // Label 1101: @43287
     /*   43287 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(43401),
     /*   43292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   43295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   43298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43310 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(43355), // Rule ID 47242 //
     /*   43315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43318 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   43321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*   43335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43353 */     GIR_RootConstrainSelectedInstOperands,
     /*   43354 */     // GIR_Coverage, 47242,
     /*   43354 */     GIR_EraseRootFromParent_Done,
     /*   43355 */   // Label 1214: @43355
     /*   43355 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(43400), // Rule ID 47243 //
     /*   43360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43363 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   43366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*   43380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43398 */     GIR_RootConstrainSelectedInstOperands,
     /*   43399 */     // GIR_Coverage, 47243,
     /*   43399 */     GIR_EraseRootFromParent_Done,
     /*   43400 */   // Label 1215: @43400
     /*   43400 */   GIM_Reject,
     /*   43401 */ // Label 1213: @43401
     /*   43401 */ GIM_Reject,
     /*   43402 */ // Label 1102: @43402
     /*   43402 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(43516),
     /*   43407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   43410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   43413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43425 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(43470), // Rule ID 47254 //
     /*   43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43433 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   43433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   43436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   43450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43468 */     GIR_RootConstrainSelectedInstOperands,
     /*   43469 */     // GIR_Coverage, 47254,
     /*   43469 */     GIR_EraseRootFromParent_Done,
     /*   43470 */   // Label 1217: @43470
     /*   43470 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(43515), // Rule ID 47255 //
     /*   43475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43478 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   43478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   43481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   43495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43513 */     GIR_RootConstrainSelectedInstOperands,
     /*   43514 */     // GIR_Coverage, 47255,
     /*   43514 */     GIR_EraseRootFromParent_Done,
     /*   43515 */   // Label 1218: @43515
     /*   43515 */   GIM_Reject,
     /*   43516 */ // Label 1216: @43516
     /*   43516 */ GIM_Reject,
     /*   43517 */ // Label 1103: @43517
     /*   43517 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(43631),
     /*   43522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   43525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   43528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43540 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(43585), // Rule ID 47270 //
     /*   43545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43548 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   43548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   43551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   43565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43583 */     GIR_RootConstrainSelectedInstOperands,
     /*   43584 */     // GIR_Coverage, 47270,
     /*   43584 */     GIR_EraseRootFromParent_Done,
     /*   43585 */   // Label 1220: @43585
     /*   43585 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(43630), // Rule ID 47271 //
     /*   43590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43593 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   43593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   43596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   43610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43628 */     GIR_RootConstrainSelectedInstOperands,
     /*   43629 */     // GIR_Coverage, 47271,
     /*   43629 */     GIR_EraseRootFromParent_Done,
     /*   43630 */   // Label 1221: @43630
     /*   43630 */   GIM_Reject,
     /*   43631 */ // Label 1219: @43631
     /*   43631 */ GIM_Reject,
     /*   43632 */ // Label 1104: @43632
     /*   43632 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(43746),
     /*   43637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   43640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   43643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43655 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(43700), // Rule ID 47314 //
     /*   43660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   43663 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   43663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   43666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   43680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   43695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43698 */     GIR_RootConstrainSelectedInstOperands,
     /*   43699 */     // GIR_Coverage, 47314,
     /*   43699 */     GIR_EraseRootFromParent_Done,
     /*   43700 */   // Label 1223: @43700
     /*   43700 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(43745), // Rule ID 47315 //
     /*   43705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   43708 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   43708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   43711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   43725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   43740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43743 */     GIR_RootConstrainSelectedInstOperands,
     /*   43744 */     // GIR_Coverage, 47315,
     /*   43744 */     GIR_EraseRootFromParent_Done,
     /*   43745 */   // Label 1224: @43745
     /*   43745 */   GIM_Reject,
     /*   43746 */ // Label 1222: @43746
     /*   43746 */ GIM_Reject,
     /*   43747 */ // Label 1105: @43747
     /*   43747 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(44357),
     /*   43752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   43755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   43758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43762 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(43828), // Rule ID 70171 //
     /*   43767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   43782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   43786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   43798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43809 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   43809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   43812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   43816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   43820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43826 */     GIR_RootConstrainSelectedInstOperands,
     /*   43827 */     // GIR_Coverage, 70171,
     /*   43827 */     GIR_EraseRootFromParent_Done,
     /*   43828 */   // Label 1226: @43828
     /*   43828 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(43894), // Rule ID 70172 //
     /*   43833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   43848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   43852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   43864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43875 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   43875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   43878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   43882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   43886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43892 */     GIR_RootConstrainSelectedInstOperands,
     /*   43893 */     // GIR_Coverage, 70172,
     /*   43893 */     GIR_EraseRootFromParent_Done,
     /*   43894 */   // Label 1227: @43894
     /*   43894 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(43960), // Rule ID 70169 //
     /*   43899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   43914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   43918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   43927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   43935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43941 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   43941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   43944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   43948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   43958 */     GIR_RootConstrainSelectedInstOperands,
     /*   43959 */     // GIR_Coverage, 70169,
     /*   43959 */     GIR_EraseRootFromParent_Done,
     /*   43960 */   // Label 1228: @43960
     /*   43960 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(44026), // Rule ID 70170 //
     /*   43965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   43976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   43980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   43984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   43993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   43997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   44001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44007 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   44007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   44010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   44014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   44018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44024 */     GIR_RootConstrainSelectedInstOperands,
     /*   44025 */     // GIR_Coverage, 70170,
     /*   44025 */     GIR_EraseRootFromParent_Done,
     /*   44026 */   // Label 1229: @44026
     /*   44026 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(44092), // Rule ID 70167 //
     /*   44031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   44050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   44054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   44066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44073 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   44073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   44076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   44084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44090 */     GIR_RootConstrainSelectedInstOperands,
     /*   44091 */     // GIR_Coverage, 70167,
     /*   44091 */     GIR_EraseRootFromParent_Done,
     /*   44092 */   // Label 1230: @44092
     /*   44092 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(44158), // Rule ID 70168 //
     /*   44097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   44116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   44120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   44132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44139 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   44139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   44142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   44150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44156 */     GIR_RootConstrainSelectedInstOperands,
     /*   44157 */     // GIR_Coverage, 70168,
     /*   44157 */     GIR_EraseRootFromParent_Done,
     /*   44158 */   // Label 1231: @44158
     /*   44158 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(44224), // Rule ID 52664 //
     /*   44163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   44182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   44195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   44203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44205 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   44205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   44208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   44216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44222 */     GIR_RootConstrainSelectedInstOperands,
     /*   44223 */     // GIR_Coverage, 52664,
     /*   44223 */     GIR_EraseRootFromParent_Done,
     /*   44224 */   // Label 1232: @44224
     /*   44224 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(44290), // Rule ID 52665 //
     /*   44229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   44248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   44252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   44261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   44269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44271 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   44271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*   44274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   44282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44288 */     GIR_RootConstrainSelectedInstOperands,
     /*   44289 */     // GIR_Coverage, 52665,
     /*   44289 */     GIR_EraseRootFromParent_Done,
     /*   44290 */   // Label 1233: @44290
     /*   44290 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(44323), // Rule ID 52652 //
     /*   44295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44306 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   44306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*   44309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44321 */     GIR_RootConstrainSelectedInstOperands,
     /*   44322 */     // GIR_Coverage, 52652,
     /*   44322 */     GIR_EraseRootFromParent_Done,
     /*   44323 */   // Label 1234: @44323
     /*   44323 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(44356), // Rule ID 52653 //
     /*   44328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44339 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   44339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*   44342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44354 */     GIR_RootConstrainSelectedInstOperands,
     /*   44355 */     // GIR_Coverage, 52653,
     /*   44355 */     GIR_EraseRootFromParent_Done,
     /*   44356 */   // Label 1235: @44356
     /*   44356 */   GIM_Reject,
     /*   44357 */ // Label 1225: @44357
     /*   44357 */ GIM_Reject,
     /*   44358 */ // Label 1106: @44358
     /*   44358 */ GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(44472),
     /*   44363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   44366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   44369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44381 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(44426), // Rule ID 47246 //
     /*   44386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44389 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   44389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   44392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   44406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44424 */     GIR_RootConstrainSelectedInstOperands,
     /*   44425 */     // GIR_Coverage, 47246,
     /*   44425 */     GIR_EraseRootFromParent_Done,
     /*   44426 */   // Label 1237: @44426
     /*   44426 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(44471), // Rule ID 47247 //
     /*   44431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44434 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   44434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   44437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*   44451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44469 */     GIR_RootConstrainSelectedInstOperands,
     /*   44470 */     // GIR_Coverage, 47247,
     /*   44470 */     GIR_EraseRootFromParent_Done,
     /*   44471 */   // Label 1238: @44471
     /*   44471 */   GIM_Reject,
     /*   44472 */ // Label 1236: @44472
     /*   44472 */ GIM_Reject,
     /*   44473 */ // Label 1107: @44473
     /*   44473 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(44587),
     /*   44478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   44481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   44484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44496 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(44541), // Rule ID 47266 //
     /*   44501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44504 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   44507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   44521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44539 */     GIR_RootConstrainSelectedInstOperands,
     /*   44540 */     // GIR_Coverage, 47266,
     /*   44540 */     GIR_EraseRootFromParent_Done,
     /*   44541 */   // Label 1240: @44541
     /*   44541 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(44586), // Rule ID 47267 //
     /*   44546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44549 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   44552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   44566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44584 */     GIR_RootConstrainSelectedInstOperands,
     /*   44585 */     // GIR_Coverage, 47267,
     /*   44585 */     GIR_EraseRootFromParent_Done,
     /*   44586 */   // Label 1241: @44586
     /*   44586 */   GIM_Reject,
     /*   44587 */ // Label 1239: @44587
     /*   44587 */ GIM_Reject,
     /*   44588 */ // Label 1108: @44588
     /*   44588 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(44702),
     /*   44593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   44596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   44599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44611 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(44656), // Rule ID 47302 //
     /*   44616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44619 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   44619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   44622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   44636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44654 */     GIR_RootConstrainSelectedInstOperands,
     /*   44655 */     // GIR_Coverage, 47302,
     /*   44655 */     GIR_EraseRootFromParent_Done,
     /*   44656 */   // Label 1243: @44656
     /*   44656 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(44701), // Rule ID 47303 //
     /*   44661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44664 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   44664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   44667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   44681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44699 */     GIR_RootConstrainSelectedInstOperands,
     /*   44700 */     // GIR_Coverage, 47303,
     /*   44700 */     GIR_EraseRootFromParent_Done,
     /*   44701 */   // Label 1244: @44701
     /*   44701 */   GIM_Reject,
     /*   44702 */ // Label 1242: @44702
     /*   44702 */ GIM_Reject,
     /*   44703 */ // Label 1109: @44703
     /*   44703 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(44817),
     /*   44708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   44711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   44714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44726 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(44771), // Rule ID 47318 //
     /*   44731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   44734 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   44734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   44737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   44751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   44766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44769 */     GIR_RootConstrainSelectedInstOperands,
     /*   44770 */     // GIR_Coverage, 47318,
     /*   44770 */     GIR_EraseRootFromParent_Done,
     /*   44771 */   // Label 1246: @44771
     /*   44771 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(44816), // Rule ID 47319 //
     /*   44776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   44779 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   44779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   44782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   44796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   44811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44814 */     GIR_RootConstrainSelectedInstOperands,
     /*   44815 */     // GIR_Coverage, 47319,
     /*   44815 */     GIR_EraseRootFromParent_Done,
     /*   44816 */   // Label 1247: @44816
     /*   44816 */   GIM_Reject,
     /*   44817 */ // Label 1245: @44817
     /*   44817 */ GIM_Reject,
     /*   44818 */ // Label 1110: @44818
     /*   44818 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(45428),
     /*   44823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   44826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   44829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44833 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(44899), // Rule ID 70199 //
     /*   44838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   44853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   44857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   44869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44880 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   44880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   44883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   44887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   44891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44897 */     GIR_RootConstrainSelectedInstOperands,
     /*   44898 */     // GIR_Coverage, 70199,
     /*   44898 */     GIR_EraseRootFromParent_Done,
     /*   44899 */   // Label 1249: @44899
     /*   44899 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(44965), // Rule ID 70200 //
     /*   44904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   44919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   44923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   44931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   44935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44946 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   44946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   44949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   44953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   44957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   44963 */     GIR_RootConstrainSelectedInstOperands,
     /*   44964 */     // GIR_Coverage, 70200,
     /*   44964 */     GIR_EraseRootFromParent_Done,
     /*   44965 */   // Label 1250: @44965
     /*   44965 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(45031), // Rule ID 70197 //
     /*   44970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   44981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   44985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   44989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   44998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   45006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45012 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   45012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   45019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45029 */     GIR_RootConstrainSelectedInstOperands,
     /*   45030 */     // GIR_Coverage, 70197,
     /*   45030 */     GIR_EraseRootFromParent_Done,
     /*   45031 */   // Label 1251: @45031
     /*   45031 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(45097), // Rule ID 70198 //
     /*   45036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   45051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   45055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   45064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   45072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45078 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   45078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   45085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45095 */     GIR_RootConstrainSelectedInstOperands,
     /*   45096 */     // GIR_Coverage, 70198,
     /*   45096 */     GIR_EraseRootFromParent_Done,
     /*   45097 */   // Label 1252: @45097
     /*   45097 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(45163), // Rule ID 70195 //
     /*   45102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   45121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   45125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   45137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45144 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   45144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   45155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45161 */     GIR_RootConstrainSelectedInstOperands,
     /*   45162 */     // GIR_Coverage, 70195,
     /*   45162 */     GIR_EraseRootFromParent_Done,
     /*   45163 */   // Label 1253: @45163
     /*   45163 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(45229), // Rule ID 70196 //
     /*   45168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   45187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   45191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   45203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45210 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   45210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   45221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45227 */     GIR_RootConstrainSelectedInstOperands,
     /*   45228 */     // GIR_Coverage, 70196,
     /*   45228 */     GIR_EraseRootFromParent_Done,
     /*   45229 */   // Label 1254: @45229
     /*   45229 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(45295), // Rule ID 52682 //
     /*   45234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   45253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   45257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   45266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   45274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45276 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   45276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45293 */     GIR_RootConstrainSelectedInstOperands,
     /*   45294 */     // GIR_Coverage, 52682,
     /*   45294 */     GIR_EraseRootFromParent_Done,
     /*   45295 */   // Label 1255: @45295
     /*   45295 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(45361), // Rule ID 52683 //
     /*   45300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   45319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   45323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   45332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   45340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45342 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   45342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*   45345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45359 */     GIR_RootConstrainSelectedInstOperands,
     /*   45360 */     // GIR_Coverage, 52683,
     /*   45360 */     GIR_EraseRootFromParent_Done,
     /*   45361 */   // Label 1256: @45361
     /*   45361 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(45394), // Rule ID 52670 //
     /*   45366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45377 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   45377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*   45380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45392 */     GIR_RootConstrainSelectedInstOperands,
     /*   45393 */     // GIR_Coverage, 52670,
     /*   45393 */     GIR_EraseRootFromParent_Done,
     /*   45394 */   // Label 1257: @45394
     /*   45394 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(45427), // Rule ID 52671 //
     /*   45399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45410 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   45410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*   45413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45425 */     GIR_RootConstrainSelectedInstOperands,
     /*   45426 */     // GIR_Coverage, 52671,
     /*   45426 */     GIR_EraseRootFromParent_Done,
     /*   45427 */   // Label 1258: @45427
     /*   45427 */   GIM_Reject,
     /*   45428 */ // Label 1248: @45428
     /*   45428 */ GIM_Reject,
     /*   45429 */ // Label 1111: @45429
     /*   45429 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(45543),
     /*   45434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   45437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   45440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45452 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(45497), // Rule ID 47262 //
     /*   45457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45460 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   45460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   45463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   45477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45495 */     GIR_RootConstrainSelectedInstOperands,
     /*   45496 */     // GIR_Coverage, 47262,
     /*   45496 */     GIR_EraseRootFromParent_Done,
     /*   45497 */   // Label 1260: @45497
     /*   45497 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(45542), // Rule ID 47263 //
     /*   45502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45505 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   45505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   45508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*   45522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45540 */     GIR_RootConstrainSelectedInstOperands,
     /*   45541 */     // GIR_Coverage, 47263,
     /*   45541 */     GIR_EraseRootFromParent_Done,
     /*   45542 */   // Label 1261: @45542
     /*   45542 */   GIM_Reject,
     /*   45543 */ // Label 1259: @45543
     /*   45543 */ GIM_Reject,
     /*   45544 */ // Label 1112: @45544
     /*   45544 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(45658),
     /*   45549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   45555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45567 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(45612), // Rule ID 47290 //
     /*   45572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45575 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   45575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   45578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   45592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45610 */     GIR_RootConstrainSelectedInstOperands,
     /*   45611 */     // GIR_Coverage, 47290,
     /*   45611 */     GIR_EraseRootFromParent_Done,
     /*   45612 */   // Label 1263: @45612
     /*   45612 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(45657), // Rule ID 47291 //
     /*   45617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45620 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   45620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   45623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   45637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45655 */     GIR_RootConstrainSelectedInstOperands,
     /*   45656 */     // GIR_Coverage, 47291,
     /*   45656 */     GIR_EraseRootFromParent_Done,
     /*   45657 */   // Label 1264: @45657
     /*   45657 */   GIM_Reject,
     /*   45658 */ // Label 1262: @45658
     /*   45658 */ GIM_Reject,
     /*   45659 */ // Label 1113: @45659
     /*   45659 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(45773),
     /*   45664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45682 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(45727), // Rule ID 47306 //
     /*   45687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45690 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   45690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   45707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45725 */     GIR_RootConstrainSelectedInstOperands,
     /*   45726 */     // GIR_Coverage, 47306,
     /*   45726 */     GIR_EraseRootFromParent_Done,
     /*   45727 */   // Label 1266: @45727
     /*   45727 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(45772), // Rule ID 47307 //
     /*   45732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45735 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   45735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   45752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45770 */     GIR_RootConstrainSelectedInstOperands,
     /*   45771 */     // GIR_Coverage, 47307,
     /*   45771 */     GIR_EraseRootFromParent_Done,
     /*   45772 */   // Label 1267: @45772
     /*   45772 */   GIM_Reject,
     /*   45773 */ // Label 1265: @45773
     /*   45773 */ GIM_Reject,
     /*   45774 */ // Label 1114: @45774
     /*   45774 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(45888),
     /*   45779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   45782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   45785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45797 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(45842), // Rule ID 47322 //
     /*   45802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   45805 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   45805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   45822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45840 */     GIR_RootConstrainSelectedInstOperands,
     /*   45841 */     // GIR_Coverage, 47322,
     /*   45841 */     GIR_EraseRootFromParent_Done,
     /*   45842 */   // Label 1269: @45842
     /*   45842 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(45887), // Rule ID 47323 //
     /*   45847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   45850 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   45850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   45867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   45874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45885 */     GIR_RootConstrainSelectedInstOperands,
     /*   45886 */     // GIR_Coverage, 47323,
     /*   45886 */     GIR_EraseRootFromParent_Done,
     /*   45887 */   // Label 1270: @45887
     /*   45887 */   GIM_Reject,
     /*   45888 */ // Label 1268: @45888
     /*   45888 */ GIM_Reject,
     /*   45889 */ // Label 1115: @45889
     /*   45889 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(46499),
     /*   45894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   45897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   45900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45904 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(45970), // Rule ID 70227 //
     /*   45909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   45924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   45928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   45936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   45940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   45949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45951 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   45951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   45954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   45958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   45962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   45968 */     GIR_RootConstrainSelectedInstOperands,
     /*   45969 */     // GIR_Coverage, 70227,
     /*   45969 */     GIR_EraseRootFromParent_Done,
     /*   45970 */   // Label 1272: @45970
     /*   45970 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(46036), // Rule ID 70228 //
     /*   45975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   45986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   45990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   45994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   46006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46017 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   46024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   46028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46034 */     GIR_RootConstrainSelectedInstOperands,
     /*   46035 */     // GIR_Coverage, 70228,
     /*   46035 */     GIR_EraseRootFromParent_Done,
     /*   46036 */   // Label 1273: @46036
     /*   46036 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(46102), // Rule ID 70225 //
     /*   46041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   46069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   46077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46083 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   46083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   46090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46100 */     GIR_RootConstrainSelectedInstOperands,
     /*   46101 */     // GIR_Coverage, 70225,
     /*   46101 */     GIR_EraseRootFromParent_Done,
     /*   46102 */   // Label 1274: @46102
     /*   46102 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(46168), // Rule ID 70226 //
     /*   46107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   46135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   46143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46149 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   46156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46166 */     GIR_RootConstrainSelectedInstOperands,
     /*   46167 */     // GIR_Coverage, 70226,
     /*   46167 */     GIR_EraseRootFromParent_Done,
     /*   46168 */   // Label 1275: @46168
     /*   46168 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(46234), // Rule ID 70223 //
     /*   46173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   46208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46215 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   46215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   46226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46232 */     GIR_RootConstrainSelectedInstOperands,
     /*   46233 */     // GIR_Coverage, 70223,
     /*   46233 */     GIR_EraseRootFromParent_Done,
     /*   46234 */   // Label 1276: @46234
     /*   46234 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(46300), // Rule ID 70224 //
     /*   46239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   46274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46281 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   46292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46298 */     GIR_RootConstrainSelectedInstOperands,
     /*   46299 */     // GIR_Coverage, 70224,
     /*   46299 */     GIR_EraseRootFromParent_Done,
     /*   46300 */   // Label 1277: @46300
     /*   46300 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(46366), // Rule ID 52700 //
     /*   46305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   46337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   46345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46347 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   46347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46364 */     GIR_RootConstrainSelectedInstOperands,
     /*   46365 */     // GIR_Coverage, 52700,
     /*   46365 */     GIR_EraseRootFromParent_Done,
     /*   46366 */   // Label 1278: @46366
     /*   46366 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(46432), // Rule ID 52701 //
     /*   46371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   46390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   46394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   46403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   46411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46413 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*   46416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46430 */     GIR_RootConstrainSelectedInstOperands,
     /*   46431 */     // GIR_Coverage, 52701,
     /*   46431 */     GIR_EraseRootFromParent_Done,
     /*   46432 */   // Label 1279: @46432
     /*   46432 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(46465), // Rule ID 52688 //
     /*   46437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46448 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   46448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*   46451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46463 */     GIR_RootConstrainSelectedInstOperands,
     /*   46464 */     // GIR_Coverage, 52688,
     /*   46464 */     GIR_EraseRootFromParent_Done,
     /*   46465 */   // Label 1280: @46465
     /*   46465 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(46498), // Rule ID 52689 //
     /*   46470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46481 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*   46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46496 */     GIR_RootConstrainSelectedInstOperands,
     /*   46497 */     // GIR_Coverage, 52689,
     /*   46497 */     GIR_EraseRootFromParent_Done,
     /*   46498 */   // Label 1281: @46498
     /*   46498 */   GIM_Reject,
     /*   46499 */ // Label 1271: @46499
     /*   46499 */ GIM_Reject,
     /*   46500 */ // Label 1116: @46500
     /*   46500 */ GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(46614),
     /*   46505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46523 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(46568), // Rule ID 47278 //
     /*   46528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46531 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   46531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   46534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   46548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46566 */     GIR_RootConstrainSelectedInstOperands,
     /*   46567 */     // GIR_Coverage, 47278,
     /*   46567 */     GIR_EraseRootFromParent_Done,
     /*   46568 */   // Label 1283: @46568
     /*   46568 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(46613), // Rule ID 47279 //
     /*   46573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46576 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   46576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   46579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*   46593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46611 */     GIR_RootConstrainSelectedInstOperands,
     /*   46612 */     // GIR_Coverage, 47279,
     /*   46612 */     GIR_EraseRootFromParent_Done,
     /*   46613 */   // Label 1284: @46613
     /*   46613 */   GIM_Reject,
     /*   46614 */ // Label 1282: @46614
     /*   46614 */ GIM_Reject,
     /*   46615 */ // Label 1117: @46615
     /*   46615 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(46729),
     /*   46620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   46623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   46626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46638 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(46683), // Rule ID 47294 //
     /*   46643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46646 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   46649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   46663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46681 */     GIR_RootConstrainSelectedInstOperands,
     /*   46682 */     // GIR_Coverage, 47294,
     /*   46682 */     GIR_EraseRootFromParent_Done,
     /*   46683 */   // Label 1286: @46683
     /*   46683 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(46728), // Rule ID 47295 //
     /*   46688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46691 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   46694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   46708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46726 */     GIR_RootConstrainSelectedInstOperands,
     /*   46727 */     // GIR_Coverage, 47295,
     /*   46727 */     GIR_EraseRootFromParent_Done,
     /*   46728 */   // Label 1287: @46728
     /*   46728 */   GIM_Reject,
     /*   46729 */ // Label 1285: @46729
     /*   46729 */ GIM_Reject,
     /*   46730 */ // Label 1118: @46730
     /*   46730 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(46844),
     /*   46735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   46738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   46741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46753 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(46798), // Rule ID 47310 //
     /*   46758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46761 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   46761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   46764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   46778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46796 */     GIR_RootConstrainSelectedInstOperands,
     /*   46797 */     // GIR_Coverage, 47310,
     /*   46797 */     GIR_EraseRootFromParent_Done,
     /*   46798 */   // Label 1289: @46798
     /*   46798 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(46843), // Rule ID 47311 //
     /*   46803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46806 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   46806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   46809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   46823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46841 */     GIR_RootConstrainSelectedInstOperands,
     /*   46842 */     // GIR_Coverage, 47311,
     /*   46842 */     GIR_EraseRootFromParent_Done,
     /*   46843 */   // Label 1290: @46843
     /*   46843 */   GIM_Reject,
     /*   46844 */ // Label 1288: @46844
     /*   46844 */ GIM_Reject,
     /*   46845 */ // Label 1119: @46845
     /*   46845 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(47455),
     /*   46850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   46853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   46856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46860 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(46926), // Rule ID 70255 //
     /*   46865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   46880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   46884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   46896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46907 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   46907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   46910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   46914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   46918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46924 */     GIR_RootConstrainSelectedInstOperands,
     /*   46925 */     // GIR_Coverage, 70255,
     /*   46925 */     GIR_EraseRootFromParent_Done,
     /*   46926 */   // Label 1292: @46926
     /*   46926 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(46992), // Rule ID 70256 //
     /*   46931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   46942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   46946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   46950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   46958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   46962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   46971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46973 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   46973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   46976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   46980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   46984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   46990 */     GIR_RootConstrainSelectedInstOperands,
     /*   46991 */     // GIR_Coverage, 70256,
     /*   46991 */     GIR_EraseRootFromParent_Done,
     /*   46992 */   // Label 1293: @46992
     /*   46992 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(47058), // Rule ID 70253 //
     /*   46997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   47033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47039 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47056 */     GIR_RootConstrainSelectedInstOperands,
     /*   47057 */     // GIR_Coverage, 70253,
     /*   47057 */     GIR_EraseRootFromParent_Done,
     /*   47058 */   // Label 1294: @47058
     /*   47058 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(47124), // Rule ID 70254 //
     /*   47063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   47099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47105 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47122 */     GIR_RootConstrainSelectedInstOperands,
     /*   47123 */     // GIR_Coverage, 70254,
     /*   47123 */     GIR_EraseRootFromParent_Done,
     /*   47124 */   // Label 1295: @47124
     /*   47124 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(47190), // Rule ID 70251 //
     /*   47129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   47164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47171 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   47182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47188 */     GIR_RootConstrainSelectedInstOperands,
     /*   47189 */     // GIR_Coverage, 70251,
     /*   47189 */     GIR_EraseRootFromParent_Done,
     /*   47190 */   // Label 1296: @47190
     /*   47190 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(47256), // Rule ID 70252 //
     /*   47195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   47230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47237 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   47248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47254 */     GIR_RootConstrainSelectedInstOperands,
     /*   47255 */     // GIR_Coverage, 70252,
     /*   47255 */     GIR_EraseRootFromParent_Done,
     /*   47256 */   // Label 1297: @47256
     /*   47256 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(47322), // Rule ID 52718 //
     /*   47261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   47301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47303 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47320 */     GIR_RootConstrainSelectedInstOperands,
     /*   47321 */     // GIR_Coverage, 52718,
     /*   47321 */     GIR_EraseRootFromParent_Done,
     /*   47322 */   // Label 1298: @47322
     /*   47322 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(47388), // Rule ID 52719 //
     /*   47327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   47346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   47350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   47367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47369 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*   47372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47386 */     GIR_RootConstrainSelectedInstOperands,
     /*   47387 */     // GIR_Coverage, 52719,
     /*   47387 */     GIR_EraseRootFromParent_Done,
     /*   47388 */   // Label 1299: @47388
     /*   47388 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(47421), // Rule ID 52706 //
     /*   47393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47404 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*   47407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47419 */     GIR_RootConstrainSelectedInstOperands,
     /*   47420 */     // GIR_Coverage, 52706,
     /*   47420 */     GIR_EraseRootFromParent_Done,
     /*   47421 */   // Label 1300: @47421
     /*   47421 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(47454), // Rule ID 52707 //
     /*   47426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47437 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*   47440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47452 */     GIR_RootConstrainSelectedInstOperands,
     /*   47453 */     // GIR_Coverage, 52707,
     /*   47453 */     GIR_EraseRootFromParent_Done,
     /*   47454 */   // Label 1301: @47454
     /*   47454 */   GIM_Reject,
     /*   47455 */ // Label 1291: @47455
     /*   47455 */ GIM_Reject,
     /*   47456 */ // Label 1120: @47456
     /*   47456 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(47570),
     /*   47461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   47464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   47467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47479 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(47524), // Rule ID 47282 //
     /*   47484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47487 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   47487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   47490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   47504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47522 */     GIR_RootConstrainSelectedInstOperands,
     /*   47523 */     // GIR_Coverage, 47282,
     /*   47523 */     GIR_EraseRootFromParent_Done,
     /*   47524 */   // Label 1303: @47524
     /*   47524 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(47569), // Rule ID 47283 //
     /*   47529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47532 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   47532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   47535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*   47549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47567 */     GIR_RootConstrainSelectedInstOperands,
     /*   47568 */     // GIR_Coverage, 47283,
     /*   47568 */     GIR_EraseRootFromParent_Done,
     /*   47569 */   // Label 1304: @47569
     /*   47569 */   GIM_Reject,
     /*   47570 */ // Label 1302: @47570
     /*   47570 */ GIM_Reject,
     /*   47571 */ // Label 1121: @47571
     /*   47571 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(47685),
     /*   47576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   47579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   47582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47594 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(47639), // Rule ID 47298 //
     /*   47599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47602 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   47602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   47605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   47619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47637 */     GIR_RootConstrainSelectedInstOperands,
     /*   47638 */     // GIR_Coverage, 47298,
     /*   47638 */     GIR_EraseRootFromParent_Done,
     /*   47639 */   // Label 1306: @47639
     /*   47639 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(47684), // Rule ID 47299 //
     /*   47644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47647 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   47647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   47650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   47664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47682 */     GIR_RootConstrainSelectedInstOperands,
     /*   47683 */     // GIR_Coverage, 47299,
     /*   47683 */     GIR_EraseRootFromParent_Done,
     /*   47684 */   // Label 1307: @47684
     /*   47684 */   GIM_Reject,
     /*   47685 */ // Label 1305: @47685
     /*   47685 */ GIM_Reject,
     /*   47686 */ // Label 1122: @47686
     /*   47686 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(48296),
     /*   47691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47701 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(47767), // Rule ID 70283 //
     /*   47706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   47737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47748 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   47751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   47759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47765 */     GIR_RootConstrainSelectedInstOperands,
     /*   47766 */     // GIR_Coverage, 70283,
     /*   47766 */     GIR_EraseRootFromParent_Done,
     /*   47767 */   // Label 1309: @47767
     /*   47767 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(47833), // Rule ID 70284 //
     /*   47772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   47803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47814 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   47817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   47825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47831 */     GIR_RootConstrainSelectedInstOperands,
     /*   47832 */     // GIR_Coverage, 70284,
     /*   47832 */     GIR_EraseRootFromParent_Done,
     /*   47833 */   // Label 1310: @47833
     /*   47833 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(47899), // Rule ID 70281 //
     /*   47838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   47874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47880 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   47880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   47883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47897 */     GIR_RootConstrainSelectedInstOperands,
     /*   47898 */     // GIR_Coverage, 70281,
     /*   47898 */     GIR_EraseRootFromParent_Done,
     /*   47899 */   // Label 1311: @47899
     /*   47899 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(47965), // Rule ID 70282 //
     /*   47904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   47932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   47936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   47940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   47946 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   47946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   47949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   47953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   47957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   47963 */     GIR_RootConstrainSelectedInstOperands,
     /*   47964 */     // GIR_Coverage, 70282,
     /*   47964 */     GIR_EraseRootFromParent_Done,
     /*   47965 */   // Label 1312: @47965
     /*   47965 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(48031), // Rule ID 70279 //
     /*   47970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   47977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   47985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   47989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   47993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   48001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   48005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48012 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   48012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   48015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   48023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48029 */     GIR_RootConstrainSelectedInstOperands,
     /*   48030 */     // GIR_Coverage, 70279,
     /*   48030 */     GIR_EraseRootFromParent_Done,
     /*   48031 */   // Label 1313: @48031
     /*   48031 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(48097), // Rule ID 70280 //
     /*   48036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   48055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   48059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   48067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   48071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48078 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   48078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   48081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   48089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48095 */     GIR_RootConstrainSelectedInstOperands,
     /*   48096 */     // GIR_Coverage, 70280,
     /*   48096 */     GIR_EraseRootFromParent_Done,
     /*   48097 */   // Label 1314: @48097
     /*   48097 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(48163), // Rule ID 52736 //
     /*   48102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   48121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   48125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   48134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   48138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48144 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48161 */     GIR_RootConstrainSelectedInstOperands,
     /*   48162 */     // GIR_Coverage, 52736,
     /*   48162 */     GIR_EraseRootFromParent_Done,
     /*   48163 */   // Label 1315: @48163
     /*   48163 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(48229), // Rule ID 52737 //
     /*   48168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   48187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   48191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   48200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   48204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   48208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48210 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   48210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*   48213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48227 */     GIR_RootConstrainSelectedInstOperands,
     /*   48228 */     // GIR_Coverage, 52737,
     /*   48228 */     GIR_EraseRootFromParent_Done,
     /*   48229 */   // Label 1316: @48229
     /*   48229 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(48262), // Rule ID 52724 //
     /*   48234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48245 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   48245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*   48248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48260 */     GIR_RootConstrainSelectedInstOperands,
     /*   48261 */     // GIR_Coverage, 52724,
     /*   48261 */     GIR_EraseRootFromParent_Done,
     /*   48262 */   // Label 1317: @48262
     /*   48262 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(48295), // Rule ID 52725 //
     /*   48267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   48278 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   48278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*   48281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   48293 */     GIR_RootConstrainSelectedInstOperands,
     /*   48294 */     // GIR_Coverage, 52725,
     /*   48294 */     GIR_EraseRootFromParent_Done,
     /*   48295 */   // Label 1318: @48295
     /*   48295 */   GIM_Reject,
     /*   48296 */ // Label 1308: @48296
     /*   48296 */ GIM_Reject,
     /*   48297 */ // Label 1123: @48297
     /*   48297 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(48411),
     /*   48302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   48305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   48308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48320 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(48365), // Rule ID 47286 //
     /*   48325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48328 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   48328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   48331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   48345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48363 */     GIR_RootConstrainSelectedInstOperands,
     /*   48364 */     // GIR_Coverage, 47286,
     /*   48364 */     GIR_EraseRootFromParent_Done,
     /*   48365 */   // Label 1320: @48365
     /*   48365 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(48410), // Rule ID 47287 //
     /*   48370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48373 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   48373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   48376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*   48390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48408 */     GIR_RootConstrainSelectedInstOperands,
     /*   48409 */     // GIR_Coverage, 47287,
     /*   48409 */     GIR_EraseRootFromParent_Done,
     /*   48410 */   // Label 1321: @48410
     /*   48410 */   GIM_Reject,
     /*   48411 */ // Label 1319: @48411
     /*   48411 */ GIM_Reject,
     /*   48412 */ // Label 1124: @48412
     /*   48412 */ GIM_Reject,
     /*   48413 */ // Label 9: @48413
     /*   48413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1353*/ GIMT_Encode4(63207),
     /*   48424 */ /*GILLT_s32*//*Label 1322*/ GIMT_Encode4(48548),
     /*   48428 */ /*GILLT_s64*//*Label 1323*/ GIMT_Encode4(48974),
     /*   48432 */ /*GILLT_nxv1s1*//*Label 1324*/ GIMT_Encode4(49400),
     /*   48436 */ /*GILLT_nxv1s8*//*Label 1325*/ GIMT_Encode4(51011),
     /*   48440 */ /*GILLT_nxv1s16*//*Label 1326*/ GIMT_Encode4(51126),
     /*   48444 */ /*GILLT_nxv1s32*//*Label 1327*/ GIMT_Encode4(51241),
     /*   48448 */ /*GILLT_nxv1s64*//*Label 1328*/ GIMT_Encode4(51356),
     /*   48452 */ /*GILLT_nxv2s1*//*Label 1329*/ GIMT_Encode4(51471),
     /*   48456 */ /*GILLT_nxv2s8*//*Label 1330*/ GIMT_Encode4(53082),
     /*   48460 */ /*GILLT_nxv2s16*//*Label 1331*/ GIMT_Encode4(53197),
     /*   48464 */ /*GILLT_nxv2s32*//*Label 1332*/ GIMT_Encode4(53312),
     /*   48468 */ /*GILLT_nxv2s64*//*Label 1333*/ GIMT_Encode4(53427),
     /*   48472 */ /*GILLT_nxv4s1*//*Label 1334*/ GIMT_Encode4(53542),
     /*   48476 */ /*GILLT_nxv4s8*//*Label 1335*/ GIMT_Encode4(55153),
     /*   48480 */ /*GILLT_nxv4s16*//*Label 1336*/ GIMT_Encode4(55268),
     /*   48484 */ /*GILLT_nxv4s32*//*Label 1337*/ GIMT_Encode4(55383),
     /*   48488 */ /*GILLT_nxv4s64*//*Label 1338*/ GIMT_Encode4(55498),
     /*   48492 */ /*GILLT_nxv8s1*//*Label 1339*/ GIMT_Encode4(55613),
     /*   48496 */ /*GILLT_nxv8s8*//*Label 1340*/ GIMT_Encode4(57224),
     /*   48500 */ /*GILLT_nxv8s16*//*Label 1341*/ GIMT_Encode4(57339),
     /*   48504 */ /*GILLT_nxv8s32*//*Label 1342*/ GIMT_Encode4(57454),
     /*   48508 */ /*GILLT_nxv8s64*//*Label 1343*/ GIMT_Encode4(57569),
     /*   48512 */ /*GILLT_nxv16s1*//*Label 1344*/ GIMT_Encode4(57684),
     /*   48516 */ /*GILLT_nxv16s8*//*Label 1345*/ GIMT_Encode4(59295),
     /*   48520 */ /*GILLT_nxv16s16*//*Label 1346*/ GIMT_Encode4(59410),
     /*   48524 */ /*GILLT_nxv16s32*//*Label 1347*/ GIMT_Encode4(59525),
     /*   48528 */ /*GILLT_nxv32s1*//*Label 1348*/ GIMT_Encode4(59640),
     /*   48532 */ /*GILLT_nxv32s8*//*Label 1349*/ GIMT_Encode4(61251),
     /*   48536 */ /*GILLT_nxv32s16*//*Label 1350*/ GIMT_Encode4(61366),
     /*   48540 */ /*GILLT_nxv64s1*//*Label 1351*/ GIMT_Encode4(61481),
     /*   48544 */ /*GILLT_nxv64s8*//*Label 1352*/ GIMT_Encode4(63092),
     /*   48548 */ // Label 1322: @48548
     /*   48548 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(48973),
     /*   48553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   48556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   48559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48563 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(48642), // Rule ID 2341 //
     /*   48568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   48571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   48579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48587 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*   48591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   48595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   48604 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*   48604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   48607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   48611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48616 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   48622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   48627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   48632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48640 */     GIR_RootConstrainSelectedInstOperands,
     /*   48641 */     // GIR_Coverage, 2341,
     /*   48641 */     GIR_EraseRootFromParent_Done,
     /*   48642 */   // Label 1355: @48642
     /*   48642 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(48697), // Rule ID 2335 //
     /*   48647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   48650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   48658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48666 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   48670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   48683 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*   48686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   48690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   48695 */     GIR_RootConstrainSelectedInstOperands,
     /*   48696 */     // GIR_Coverage, 2335,
     /*   48696 */     GIR_EraseRootFromParent_Done,
     /*   48697 */   // Label 1356: @48697
     /*   48697 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(48752), // Rule ID 64064 //
     /*   48702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*   48705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   48717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   48738 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*   48741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   48750 */     GIR_RootConstrainSelectedInstOperands,
     /*   48751 */     // GIR_Coverage, 64064,
     /*   48751 */     GIR_EraseRootFromParent_Done,
     /*   48752 */   // Label 1357: @48752
     /*   48752 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(48804), // Rule ID 64050 //
     /*   48757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   48760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   48785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48791 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   48794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   48800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48802 */     GIR_RootConstrainSelectedInstOperands,
     /*   48803 */     // GIR_Coverage, 64050,
     /*   48803 */     GIR_EraseRootFromParent_Done,
     /*   48804 */   // Label 1358: @48804
     /*   48804 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(48859), // Rule ID 64048 //
     /*   48809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   48812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   48842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48844 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   48847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   48853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   48857 */     GIR_RootConstrainSelectedInstOperands,
     /*   48858 */     // GIR_Coverage, 64048,
     /*   48858 */     GIR_EraseRootFromParent_Done,
     /*   48859 */   // Label 1359: @48859
     /*   48859 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(48911), // Rule ID 2309 //
     /*   48864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*   48867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   48879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   48883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   48887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   48896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48898 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   48901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48909 */     GIR_RootConstrainSelectedInstOperands,
     /*   48910 */     // GIR_Coverage, 2309,
     /*   48910 */     GIR_EraseRootFromParent_Done,
     /*   48911 */   // Label 1360: @48911
     /*   48911 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(48949), // Rule ID 89 //
     /*   48916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   48919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   48931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   48935 */     // MIs[1] Operand 1
     /*   48935 */     // No operand predicates
     /*   48935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48937 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*   48937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*   48940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   48944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   48947 */     GIR_RootConstrainSelectedInstOperands,
     /*   48948 */     // GIR_Coverage, 89,
     /*   48948 */     GIR_EraseRootFromParent_Done,
     /*   48949 */   // Label 1361: @48949
     /*   48949 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(48972), // Rule ID 87 //
     /*   48954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   48957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48965 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   48965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*   48970 */     GIR_RootConstrainSelectedInstOperands,
     /*   48971 */     // GIR_Coverage, 87,
     /*   48971 */     GIR_Done,
     /*   48972 */   // Label 1362: @48972
     /*   48972 */   GIM_Reject,
     /*   48973 */ // Label 1354: @48973
     /*   48973 */ GIM_Reject,
     /*   48974 */ // Label 1323: @48974
     /*   48974 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(49399),
     /*   48979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   48982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   48985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   48989 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(49068), // Rule ID 2340 //
     /*   48994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   48997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   49005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*   49017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   49021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   49030 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*   49030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   49033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*   49037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   49048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   49053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   49058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49066 */     GIR_RootConstrainSelectedInstOperands,
     /*   49067 */     // GIR_Coverage, 2340,
     /*   49067 */     GIR_EraseRootFromParent_Done,
     /*   49068 */   // Label 1364: @49068
     /*   49068 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(49123), // Rule ID 2334 //
     /*   49073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   49076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   49084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49092 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   49096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   49109 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*   49112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   49116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   49121 */     GIR_RootConstrainSelectedInstOperands,
     /*   49122 */     // GIR_Coverage, 2334,
     /*   49122 */     GIR_EraseRootFromParent_Done,
     /*   49123 */   // Label 1365: @49123
     /*   49123 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(49178), // Rule ID 64063 //
     /*   49128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*   49131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   49143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49151 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*   49155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*   49164 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*   49167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   49171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*   49176 */     GIR_RootConstrainSelectedInstOperands,
     /*   49177 */     // GIR_Coverage, 64063,
     /*   49177 */     GIR_EraseRootFromParent_Done,
     /*   49178 */   // Label 1366: @49178
     /*   49178 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(49230), // Rule ID 64049 //
     /*   49183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   49186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   49211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49217 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   49220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49228 */     GIR_RootConstrainSelectedInstOperands,
     /*   49229 */     // GIR_Coverage, 64049,
     /*   49229 */     GIR_EraseRootFromParent_Done,
     /*   49230 */   // Label 1367: @49230
     /*   49230 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(49285), // Rule ID 64047 //
     /*   49235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   49238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   49268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49270 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   49273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   49283 */     GIR_RootConstrainSelectedInstOperands,
     /*   49284 */     // GIR_Coverage, 64047,
     /*   49284 */     GIR_EraseRootFromParent_Done,
     /*   49285 */   // Label 1368: @49285
     /*   49285 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(49337), // Rule ID 2308 //
     /*   49290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*   49293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   49309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   49313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49318 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   49322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49324 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*   49327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   49331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49335 */     GIR_RootConstrainSelectedInstOperands,
     /*   49336 */     // GIR_Coverage, 2308,
     /*   49336 */     GIR_EraseRootFromParent_Done,
     /*   49337 */   // Label 1369: @49337
     /*   49337 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(49375), // Rule ID 88 //
     /*   49342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   49345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   49357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   49361 */     // MIs[1] Operand 1
     /*   49361 */     // No operand predicates
     /*   49361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49363 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   49363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*   49366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   49370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   49373 */     GIR_RootConstrainSelectedInstOperands,
     /*   49374 */     // GIR_Coverage, 88,
     /*   49374 */     GIR_EraseRootFromParent_Done,
     /*   49375 */   // Label 1370: @49375
     /*   49375 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(49398), // Rule ID 86 //
     /*   49380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   49383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   49391 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   49391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*   49396 */     GIR_RootConstrainSelectedInstOperands,
     /*   49397 */     // GIR_Coverage, 86,
     /*   49397 */     GIR_Done,
     /*   49398 */   // Label 1371: @49398
     /*   49398 */   GIM_Reject,
     /*   49399 */ // Label 1363: @49399
     /*   49399 */ GIM_Reject,
     /*   49400 */ // Label 1324: @49400
     /*   49400 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(51010),
     /*   49405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49415 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(49484), // Rule ID 52620 //
     /*   49420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   49431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   49461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49463 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   49463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   49466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   49476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49482 */     GIR_RootConstrainSelectedInstOperands,
     /*   49483 */     // GIR_Coverage, 52620,
     /*   49483 */     GIR_EraseRootFromParent_Done,
     /*   49484 */   // Label 1373: @49484
     /*   49484 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(49553), // Rule ID 52621 //
     /*   49489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   49500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   49530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49532 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   49532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   49535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   49545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49551 */     GIR_RootConstrainSelectedInstOperands,
     /*   49552 */     // GIR_Coverage, 52621,
     /*   49552 */     GIR_EraseRootFromParent_Done,
     /*   49553 */   // Label 1374: @49553
     /*   49553 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(49622), // Rule ID 52622 //
     /*   49558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   49569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   49599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49601 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   49601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*   49604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   49614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49620 */     GIR_RootConstrainSelectedInstOperands,
     /*   49621 */     // GIR_Coverage, 52622,
     /*   49621 */     GIR_EraseRootFromParent_Done,
     /*   49622 */   // Label 1375: @49622
     /*   49622 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(49691), // Rule ID 52623 //
     /*   49627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   49638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   49668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49670 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   49670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*   49673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   49683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49689 */     GIR_RootConstrainSelectedInstOperands,
     /*   49690 */     // GIR_Coverage, 52623,
     /*   49690 */     GIR_EraseRootFromParent_Done,
     /*   49691 */   // Label 1376: @49691
     /*   49691 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(49757), // Rule ID 70097 //
     /*   49696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   49727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49738 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   49738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   49741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   49747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49755 */     GIR_RootConstrainSelectedInstOperands,
     /*   49756 */     // GIR_Coverage, 70097,
     /*   49756 */     GIR_EraseRootFromParent_Done,
     /*   49757 */   // Label 1377: @49757
     /*   49757 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(49823), // Rule ID 70098 //
     /*   49762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   49793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49804 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   49804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   49807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   49813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49821 */     GIR_RootConstrainSelectedInstOperands,
     /*   49822 */     // GIR_Coverage, 70098,
     /*   49822 */     GIR_EraseRootFromParent_Done,
     /*   49823 */   // Label 1378: @49823
     /*   49823 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(49889), // Rule ID 70095 //
     /*   49828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   49856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   49864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49870 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   49870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   49873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49887 */     GIR_RootConstrainSelectedInstOperands,
     /*   49888 */     // GIR_Coverage, 70095,
     /*   49888 */     GIR_EraseRootFromParent_Done,
     /*   49889 */   // Label 1379: @49889
     /*   49889 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(49955), // Rule ID 70096 //
     /*   49894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   49922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   49930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49936 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   49936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   49939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   49953 */     GIR_RootConstrainSelectedInstOperands,
     /*   49954 */     // GIR_Coverage, 70096,
     /*   49954 */     GIR_EraseRootFromParent_Done,
     /*   49955 */   // Label 1380: @49955
     /*   49955 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(50024), // Rule ID 52624 //
     /*   49960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   49971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   49975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   49979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   49989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   49997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   50001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50003 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   50016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50022 */     GIR_RootConstrainSelectedInstOperands,
     /*   50023 */     // GIR_Coverage, 52624,
     /*   50023 */     GIR_EraseRootFromParent_Done,
     /*   50024 */   // Label 1381: @50024
     /*   50024 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(50093), // Rule ID 52625 //
     /*   50029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   50070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50072 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   50085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50091 */     GIR_RootConstrainSelectedInstOperands,
     /*   50092 */     // GIR_Coverage, 52625,
     /*   50092 */     GIR_EraseRootFromParent_Done,
     /*   50093 */   // Label 1382: @50093
     /*   50093 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(50162), // Rule ID 70091 //
     /*   50098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50141 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50160 */     GIR_RootConstrainSelectedInstOperands,
     /*   50161 */     // GIR_Coverage, 70091,
     /*   50161 */     GIR_EraseRootFromParent_Done,
     /*   50162 */   // Label 1383: @50162
     /*   50162 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(50231), // Rule ID 70092 //
     /*   50167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   50182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   50190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50210 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50229 */     GIR_RootConstrainSelectedInstOperands,
     /*   50230 */     // GIR_Coverage, 70092,
     /*   50230 */     GIR_EraseRootFromParent_Done,
     /*   50231 */   // Label 1384: @50231
     /*   50231 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(50300), // Rule ID 70093 //
     /*   50236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   50251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   50259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50279 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*   50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50298 */     GIR_RootConstrainSelectedInstOperands,
     /*   50299 */     // GIR_Coverage, 70093,
     /*   50299 */     GIR_EraseRootFromParent_Done,
     /*   50300 */   // Label 1385: @50300
     /*   50300 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(50369), // Rule ID 70094 //
     /*   50305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   50320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   50328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50348 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*   50351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50367 */     GIR_RootConstrainSelectedInstOperands,
     /*   50368 */     // GIR_Coverage, 70094,
     /*   50368 */     GIR_EraseRootFromParent_Done,
     /*   50369 */   // Label 1386: @50369
     /*   50369 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(50438), // Rule ID 70099 //
     /*   50374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   50389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50417 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50436 */     GIR_RootConstrainSelectedInstOperands,
     /*   50437 */     // GIR_Coverage, 70099,
     /*   50437 */     GIR_EraseRootFromParent_Done,
     /*   50438 */   // Label 1387: @50438
     /*   50438 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(50507), // Rule ID 70100 //
     /*   50443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   50458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   50462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50486 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   50499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50505 */     GIR_RootConstrainSelectedInstOperands,
     /*   50506 */     // GIR_Coverage, 70100,
     /*   50506 */     GIR_EraseRootFromParent_Done,
     /*   50507 */   // Label 1388: @50507
     /*   50507 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(50573), // Rule ID 70103 //
     /*   50512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   50547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50554 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   50563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50571 */     GIR_RootConstrainSelectedInstOperands,
     /*   50572 */     // GIR_Coverage, 70103,
     /*   50572 */     GIR_EraseRootFromParent_Done,
     /*   50573 */   // Label 1389: @50573
     /*   50573 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(50639), // Rule ID 70104 //
     /*   50578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   50613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50620 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   50629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50637 */     GIR_RootConstrainSelectedInstOperands,
     /*   50638 */     // GIR_Coverage, 70104,
     /*   50638 */     GIR_EraseRootFromParent_Done,
     /*   50639 */   // Label 1390: @50639
     /*   50639 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(50705), // Rule ID 70101 //
     /*   50644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   50676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   50684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50686 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50703 */     GIR_RootConstrainSelectedInstOperands,
     /*   50704 */     // GIR_Coverage, 70101,
     /*   50704 */     GIR_EraseRootFromParent_Done,
     /*   50705 */   // Label 1391: @50705
     /*   50705 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(50771), // Rule ID 70102 //
     /*   50710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   50725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*   50729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*   50733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   50742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   50750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   50752 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*   50755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50769 */     GIR_RootConstrainSelectedInstOperands,
     /*   50770 */     // GIR_Coverage, 70102,
     /*   50770 */     GIR_EraseRootFromParent_Done,
     /*   50771 */   // Label 1392: @50771
     /*   50771 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(50814), // Rule ID 70117 //
     /*   50776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   50791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50797 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   50804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   50806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50812 */     GIR_RootConstrainSelectedInstOperands,
     /*   50813 */     // GIR_Coverage, 70117,
     /*   50813 */     GIR_EraseRootFromParent_Done,
     /*   50814 */   // Label 1393: @50814
     /*   50814 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(50857), // Rule ID 70118 //
     /*   50819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   50834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50840 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   50847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   50849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50855 */     GIR_RootConstrainSelectedInstOperands,
     /*   50856 */     // GIR_Coverage, 70118,
     /*   50856 */     GIR_EraseRootFromParent_Done,
     /*   50857 */   // Label 1394: @50857
     /*   50857 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(50900), // Rule ID 52630 //
     /*   50862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   50881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50883 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   50890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   50892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50898 */     GIR_RootConstrainSelectedInstOperands,
     /*   50899 */     // GIR_Coverage, 52630,
     /*   50899 */     GIR_EraseRootFromParent_Done,
     /*   50900 */   // Label 1395: @50900
     /*   50900 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(50943), // Rule ID 52631 //
     /*   50905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   50920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   50924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50926 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*   50929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   50933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   50935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50941 */     GIR_RootConstrainSelectedInstOperands,
     /*   50942 */     // GIR_Coverage, 52631,
     /*   50942 */     GIR_EraseRootFromParent_Done,
     /*   50943 */   // Label 1396: @50943
     /*   50943 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(50976), // Rule ID 52618 //
     /*   50948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50959 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   50959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*   50962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   50974 */     GIR_RootConstrainSelectedInstOperands,
     /*   50975 */     // GIR_Coverage, 52618,
     /*   50975 */     GIR_EraseRootFromParent_Done,
     /*   50976 */   // Label 1397: @50976
     /*   50976 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(51009), // Rule ID 52619 //
     /*   50981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   50992 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   50992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*   50995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51007 */     GIR_RootConstrainSelectedInstOperands,
     /*   51008 */     // GIR_Coverage, 52619,
     /*   51008 */     GIR_EraseRootFromParent_Done,
     /*   51009 */   // Label 1398: @51009
     /*   51009 */   GIM_Reject,
     /*   51010 */ // Label 1372: @51010
     /*   51010 */ GIM_Reject,
     /*   51011 */ // Label 1325: @51011
     /*   51011 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(51125),
     /*   51016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   51019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   51022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51034 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(51079), // Rule ID 47370 //
     /*   51039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51042 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   51042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   51045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*   51059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51077 */     GIR_RootConstrainSelectedInstOperands,
     /*   51078 */     // GIR_Coverage, 47370,
     /*   51078 */     GIR_EraseRootFromParent_Done,
     /*   51079 */   // Label 1400: @51079
     /*   51079 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(51124), // Rule ID 47371 //
     /*   51084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51087 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   51087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   51090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*   51104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51122 */     GIR_RootConstrainSelectedInstOperands,
     /*   51123 */     // GIR_Coverage, 47371,
     /*   51123 */     GIR_EraseRootFromParent_Done,
     /*   51124 */   // Label 1401: @51124
     /*   51124 */   GIM_Reject,
     /*   51125 */ // Label 1399: @51125
     /*   51125 */ GIM_Reject,
     /*   51126 */ // Label 1326: @51126
     /*   51126 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(51240),
     /*   51131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   51134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   51137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51149 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(51194), // Rule ID 47382 //
     /*   51154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51157 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   51157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   51160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*   51174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51192 */     GIR_RootConstrainSelectedInstOperands,
     /*   51193 */     // GIR_Coverage, 47382,
     /*   51193 */     GIR_EraseRootFromParent_Done,
     /*   51194 */   // Label 1403: @51194
     /*   51194 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(51239), // Rule ID 47383 //
     /*   51199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51202 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   51202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   51205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*   51219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51237 */     GIR_RootConstrainSelectedInstOperands,
     /*   51238 */     // GIR_Coverage, 47383,
     /*   51238 */     GIR_EraseRootFromParent_Done,
     /*   51239 */   // Label 1404: @51239
     /*   51239 */   GIM_Reject,
     /*   51240 */ // Label 1402: @51240
     /*   51240 */ GIM_Reject,
     /*   51241 */ // Label 1327: @51241
     /*   51241 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(51355),
     /*   51246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   51249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   51252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51264 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(51309), // Rule ID 47390 //
     /*   51269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51272 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   51272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   51275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   51289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   51304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51307 */     GIR_RootConstrainSelectedInstOperands,
     /*   51308 */     // GIR_Coverage, 47390,
     /*   51308 */     GIR_EraseRootFromParent_Done,
     /*   51309 */   // Label 1406: @51309
     /*   51309 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(51354), // Rule ID 47391 //
     /*   51314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51317 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   51317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   51320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   51334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   51349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51352 */     GIR_RootConstrainSelectedInstOperands,
     /*   51353 */     // GIR_Coverage, 47391,
     /*   51353 */     GIR_EraseRootFromParent_Done,
     /*   51354 */   // Label 1407: @51354
     /*   51354 */   GIM_Reject,
     /*   51355 */ // Label 1405: @51355
     /*   51355 */ GIM_Reject,
     /*   51356 */ // Label 1328: @51356
     /*   51356 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(51470),
     /*   51361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   51364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   51367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51379 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(51424), // Rule ID 47406 //
     /*   51384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   51387 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   51387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   51390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   51404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   51419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51422 */     GIR_RootConstrainSelectedInstOperands,
     /*   51423 */     // GIR_Coverage, 47406,
     /*   51423 */     GIR_EraseRootFromParent_Done,
     /*   51424 */   // Label 1409: @51424
     /*   51424 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(51469), // Rule ID 47407 //
     /*   51429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   51432 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   51432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   51435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   51449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   51464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51467 */     GIR_RootConstrainSelectedInstOperands,
     /*   51468 */     // GIR_Coverage, 47407,
     /*   51468 */     GIR_EraseRootFromParent_Done,
     /*   51469 */   // Label 1410: @51469
     /*   51469 */   GIM_Reject,
     /*   51470 */ // Label 1408: @51470
     /*   51470 */ GIM_Reject,
     /*   51471 */ // Label 1329: @51471
     /*   51471 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(53081),
     /*   51476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51486 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(51555), // Rule ID 52638 //
     /*   51491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   51502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   51532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51534 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   51534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   51537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   51547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51553 */     GIR_RootConstrainSelectedInstOperands,
     /*   51554 */     // GIR_Coverage, 52638,
     /*   51554 */     GIR_EraseRootFromParent_Done,
     /*   51555 */   // Label 1412: @51555
     /*   51555 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(51624), // Rule ID 52639 //
     /*   51560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   51571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   51601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51603 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   51603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   51606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   51616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51622 */     GIR_RootConstrainSelectedInstOperands,
     /*   51623 */     // GIR_Coverage, 52639,
     /*   51623 */     GIR_EraseRootFromParent_Done,
     /*   51624 */   // Label 1413: @51624
     /*   51624 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(51693), // Rule ID 52640 //
     /*   51629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   51640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   51670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51672 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   51672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*   51675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   51685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51691 */     GIR_RootConstrainSelectedInstOperands,
     /*   51692 */     // GIR_Coverage, 52640,
     /*   51692 */     GIR_EraseRootFromParent_Done,
     /*   51693 */   // Label 1414: @51693
     /*   51693 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(51762), // Rule ID 52641 //
     /*   51698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   51709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   51739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51741 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   51741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*   51744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   51754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51760 */     GIR_RootConstrainSelectedInstOperands,
     /*   51761 */     // GIR_Coverage, 52641,
     /*   51761 */     GIR_EraseRootFromParent_Done,
     /*   51762 */   // Label 1415: @51762
     /*   51762 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(51828), // Rule ID 70125 //
     /*   51767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   51778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   51798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51809 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   51809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   51812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   51818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51826 */     GIR_RootConstrainSelectedInstOperands,
     /*   51827 */     // GIR_Coverage, 70125,
     /*   51827 */     GIR_EraseRootFromParent_Done,
     /*   51828 */   // Label 1416: @51828
     /*   51828 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(51894), // Rule ID 70126 //
     /*   51833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   51844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   51864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51875 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   51875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   51878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   51884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51892 */     GIR_RootConstrainSelectedInstOperands,
     /*   51893 */     // GIR_Coverage, 70126,
     /*   51893 */     GIR_EraseRootFromParent_Done,
     /*   51894 */   // Label 1417: @51894
     /*   51894 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(51960), // Rule ID 70123 //
     /*   51899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   51910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   51927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   51935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51941 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   51941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   51944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   51958 */     GIR_RootConstrainSelectedInstOperands,
     /*   51959 */     // GIR_Coverage, 70123,
     /*   51959 */     GIR_EraseRootFromParent_Done,
     /*   51960 */   // Label 1418: @51960
     /*   51960 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(52026), // Rule ID 70124 //
     /*   51965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   51976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   51980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   51984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   51989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   51993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   51997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   52001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52007 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52024 */     GIR_RootConstrainSelectedInstOperands,
     /*   52025 */     // GIR_Coverage, 70124,
     /*   52025 */     GIR_EraseRootFromParent_Done,
     /*   52026 */   // Label 1419: @52026
     /*   52026 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(52095), // Rule ID 52642 //
     /*   52031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   52072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52074 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   52087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52093 */     GIR_RootConstrainSelectedInstOperands,
     /*   52094 */     // GIR_Coverage, 52642,
     /*   52094 */     GIR_EraseRootFromParent_Done,
     /*   52095 */   // Label 1420: @52095
     /*   52095 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(52164), // Rule ID 52643 //
     /*   52100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   52141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52143 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   52156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52162 */     GIR_RootConstrainSelectedInstOperands,
     /*   52163 */     // GIR_Coverage, 52643,
     /*   52163 */     GIR_EraseRootFromParent_Done,
     /*   52164 */   // Label 1421: @52164
     /*   52164 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(52233), // Rule ID 70119 //
     /*   52169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   52184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   52192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52212 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   52215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52231 */     GIR_RootConstrainSelectedInstOperands,
     /*   52232 */     // GIR_Coverage, 70119,
     /*   52232 */     GIR_EraseRootFromParent_Done,
     /*   52233 */   // Label 1422: @52233
     /*   52233 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(52302), // Rule ID 70120 //
     /*   52238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   52253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   52261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52281 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   52284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52300 */     GIR_RootConstrainSelectedInstOperands,
     /*   52301 */     // GIR_Coverage, 70120,
     /*   52301 */     GIR_EraseRootFromParent_Done,
     /*   52302 */   // Label 1423: @52302
     /*   52302 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(52371), // Rule ID 70121 //
     /*   52307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   52322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   52330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52350 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*   52353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52369 */     GIR_RootConstrainSelectedInstOperands,
     /*   52370 */     // GIR_Coverage, 70121,
     /*   52370 */     GIR_EraseRootFromParent_Done,
     /*   52371 */   // Label 1424: @52371
     /*   52371 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(52440), // Rule ID 70122 //
     /*   52376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   52391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   52399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52419 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*   52422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52438 */     GIR_RootConstrainSelectedInstOperands,
     /*   52439 */     // GIR_Coverage, 70122,
     /*   52439 */     GIR_EraseRootFromParent_Done,
     /*   52440 */   // Label 1425: @52440
     /*   52440 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(52509), // Rule ID 70127 //
     /*   52445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   52460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52488 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52507 */     GIR_RootConstrainSelectedInstOperands,
     /*   52508 */     // GIR_Coverage, 70127,
     /*   52508 */     GIR_EraseRootFromParent_Done,
     /*   52509 */   // Label 1426: @52509
     /*   52509 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(52578), // Rule ID 70128 //
     /*   52514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   52529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52557 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   52570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52576 */     GIR_RootConstrainSelectedInstOperands,
     /*   52577 */     // GIR_Coverage, 70128,
     /*   52577 */     GIR_EraseRootFromParent_Done,
     /*   52578 */   // Label 1427: @52578
     /*   52578 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(52644), // Rule ID 70131 //
     /*   52583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   52618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52625 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   52634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52642 */     GIR_RootConstrainSelectedInstOperands,
     /*   52643 */     // GIR_Coverage, 70131,
     /*   52643 */     GIR_EraseRootFromParent_Done,
     /*   52644 */   // Label 1428: @52644
     /*   52644 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(52710), // Rule ID 70132 //
     /*   52649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   52684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52691 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   52700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52708 */     GIR_RootConstrainSelectedInstOperands,
     /*   52709 */     // GIR_Coverage, 70132,
     /*   52709 */     GIR_EraseRootFromParent_Done,
     /*   52710 */   // Label 1429: @52710
     /*   52710 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(52776), // Rule ID 70129 //
     /*   52715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   52747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   52755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52757 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52774 */     GIR_RootConstrainSelectedInstOperands,
     /*   52775 */     // GIR_Coverage, 70129,
     /*   52775 */     GIR_EraseRootFromParent_Done,
     /*   52776 */   // Label 1430: @52776
     /*   52776 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(52842), // Rule ID 70130 //
     /*   52781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   52796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*   52800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   52804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   52813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   52821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52823 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*   52826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52840 */     GIR_RootConstrainSelectedInstOperands,
     /*   52841 */     // GIR_Coverage, 70130,
     /*   52841 */     GIR_EraseRootFromParent_Done,
     /*   52842 */   // Label 1431: @52842
     /*   52842 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(52885), // Rule ID 70145 //
     /*   52847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   52862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52868 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   52871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   52875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   52877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52883 */     GIR_RootConstrainSelectedInstOperands,
     /*   52884 */     // GIR_Coverage, 70145,
     /*   52884 */     GIR_EraseRootFromParent_Done,
     /*   52885 */   // Label 1432: @52885
     /*   52885 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(52928), // Rule ID 70146 //
     /*   52890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   52905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52911 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   52914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   52918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   52920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52926 */     GIR_RootConstrainSelectedInstOperands,
     /*   52927 */     // GIR_Coverage, 70146,
     /*   52927 */     GIR_EraseRootFromParent_Done,
     /*   52928 */   // Label 1433: @52928
     /*   52928 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(52971), // Rule ID 52648 //
     /*   52933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   52952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52954 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   52954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   52957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   52961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   52963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   52969 */     GIR_RootConstrainSelectedInstOperands,
     /*   52970 */     // GIR_Coverage, 52648,
     /*   52970 */     GIR_EraseRootFromParent_Done,
     /*   52971 */   // Label 1434: @52971
     /*   52971 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(53014), // Rule ID 52649 //
     /*   52976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   52983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   52991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   52995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52997 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   52997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*   53000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   53004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   53006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53012 */     GIR_RootConstrainSelectedInstOperands,
     /*   53013 */     // GIR_Coverage, 52649,
     /*   53013 */     GIR_EraseRootFromParent_Done,
     /*   53014 */   // Label 1435: @53014
     /*   53014 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(53047), // Rule ID 52636 //
     /*   53019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53030 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   53030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*   53033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53045 */     GIR_RootConstrainSelectedInstOperands,
     /*   53046 */     // GIR_Coverage, 52636,
     /*   53046 */     GIR_EraseRootFromParent_Done,
     /*   53047 */   // Label 1436: @53047
     /*   53047 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(53080), // Rule ID 52637 //
     /*   53052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53063 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   53063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*   53066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53078 */     GIR_RootConstrainSelectedInstOperands,
     /*   53079 */     // GIR_Coverage, 52637,
     /*   53079 */     GIR_EraseRootFromParent_Done,
     /*   53080 */   // Label 1437: @53080
     /*   53080 */   GIM_Reject,
     /*   53081 */ // Label 1411: @53081
     /*   53081 */ GIM_Reject,
     /*   53082 */ // Label 1330: @53082
     /*   53082 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(53196),
     /*   53087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   53090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   53093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53105 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(53150), // Rule ID 47374 //
     /*   53110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53113 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   53116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*   53130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53148 */     GIR_RootConstrainSelectedInstOperands,
     /*   53149 */     // GIR_Coverage, 47374,
     /*   53149 */     GIR_EraseRootFromParent_Done,
     /*   53150 */   // Label 1439: @53150
     /*   53150 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(53195), // Rule ID 47375 //
     /*   53155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53158 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   53161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*   53175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53193 */     GIR_RootConstrainSelectedInstOperands,
     /*   53194 */     // GIR_Coverage, 47375,
     /*   53194 */     GIR_EraseRootFromParent_Done,
     /*   53195 */   // Label 1440: @53195
     /*   53195 */   GIM_Reject,
     /*   53196 */ // Label 1438: @53196
     /*   53196 */ GIM_Reject,
     /*   53197 */ // Label 1331: @53197
     /*   53197 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(53311),
     /*   53202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   53205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   53208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53220 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(53265), // Rule ID 47386 //
     /*   53225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53228 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   53228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   53231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   53245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53263 */     GIR_RootConstrainSelectedInstOperands,
     /*   53264 */     // GIR_Coverage, 47386,
     /*   53264 */     GIR_EraseRootFromParent_Done,
     /*   53265 */   // Label 1442: @53265
     /*   53265 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(53310), // Rule ID 47387 //
     /*   53270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53273 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   53273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   53276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   53290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53308 */     GIR_RootConstrainSelectedInstOperands,
     /*   53309 */     // GIR_Coverage, 47387,
     /*   53309 */     GIR_EraseRootFromParent_Done,
     /*   53310 */   // Label 1443: @53310
     /*   53310 */   GIM_Reject,
     /*   53311 */ // Label 1441: @53311
     /*   53311 */ GIM_Reject,
     /*   53312 */ // Label 1332: @53312
     /*   53312 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(53426),
     /*   53317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   53320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   53323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53335 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(53380), // Rule ID 47402 //
     /*   53340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53343 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   53343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   53346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   53360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   53375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53378 */     GIR_RootConstrainSelectedInstOperands,
     /*   53379 */     // GIR_Coverage, 47402,
     /*   53379 */     GIR_EraseRootFromParent_Done,
     /*   53380 */   // Label 1445: @53380
     /*   53380 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(53425), // Rule ID 47403 //
     /*   53385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53388 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   53388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   53391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   53405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   53420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53423 */     GIR_RootConstrainSelectedInstOperands,
     /*   53424 */     // GIR_Coverage, 47403,
     /*   53424 */     GIR_EraseRootFromParent_Done,
     /*   53425 */   // Label 1446: @53425
     /*   53425 */   GIM_Reject,
     /*   53426 */ // Label 1444: @53426
     /*   53426 */ GIM_Reject,
     /*   53427 */ // Label 1333: @53427
     /*   53427 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(53541),
     /*   53432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   53435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   53438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53450 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(53495), // Rule ID 47446 //
     /*   53455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   53458 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   53458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   53461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   53475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   53490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53493 */     GIR_RootConstrainSelectedInstOperands,
     /*   53494 */     // GIR_Coverage, 47446,
     /*   53494 */     GIR_EraseRootFromParent_Done,
     /*   53495 */   // Label 1448: @53495
     /*   53495 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(53540), // Rule ID 47447 //
     /*   53500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   53503 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   53503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   53506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   53520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   53535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53538 */     GIR_RootConstrainSelectedInstOperands,
     /*   53539 */     // GIR_Coverage, 47447,
     /*   53539 */     GIR_EraseRootFromParent_Done,
     /*   53540 */   // Label 1449: @53540
     /*   53540 */   GIM_Reject,
     /*   53541 */ // Label 1447: @53541
     /*   53541 */ GIM_Reject,
     /*   53542 */ // Label 1334: @53542
     /*   53542 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(55152),
     /*   53547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53557 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(53626), // Rule ID 52656 //
     /*   53562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   53573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   53603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53605 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   53605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   53608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   53618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53624 */     GIR_RootConstrainSelectedInstOperands,
     /*   53625 */     // GIR_Coverage, 52656,
     /*   53625 */     GIR_EraseRootFromParent_Done,
     /*   53626 */   // Label 1451: @53626
     /*   53626 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(53695), // Rule ID 52657 //
     /*   53631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   53642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   53672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53674 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   53674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   53677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   53687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53693 */     GIR_RootConstrainSelectedInstOperands,
     /*   53694 */     // GIR_Coverage, 52657,
     /*   53694 */     GIR_EraseRootFromParent_Done,
     /*   53695 */   // Label 1452: @53695
     /*   53695 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(53764), // Rule ID 52658 //
     /*   53700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   53711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   53741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53743 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   53743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*   53746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   53756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53762 */     GIR_RootConstrainSelectedInstOperands,
     /*   53763 */     // GIR_Coverage, 52658,
     /*   53763 */     GIR_EraseRootFromParent_Done,
     /*   53764 */   // Label 1453: @53764
     /*   53764 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(53833), // Rule ID 52659 //
     /*   53769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   53780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   53810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53812 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   53812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*   53815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   53825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53831 */     GIR_RootConstrainSelectedInstOperands,
     /*   53832 */     // GIR_Coverage, 52659,
     /*   53832 */     GIR_EraseRootFromParent_Done,
     /*   53833 */   // Label 1454: @53833
     /*   53833 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(53899), // Rule ID 70153 //
     /*   53838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   53849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   53869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53880 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   53880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   53883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   53889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53897 */     GIR_RootConstrainSelectedInstOperands,
     /*   53898 */     // GIR_Coverage, 70153,
     /*   53898 */     GIR_EraseRootFromParent_Done,
     /*   53899 */   // Label 1455: @53899
     /*   53899 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(53965), // Rule ID 70154 //
     /*   53904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   53915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   53931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   53935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53946 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   53946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   53949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   53955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   53963 */     GIR_RootConstrainSelectedInstOperands,
     /*   53964 */     // GIR_Coverage, 70154,
     /*   53964 */     GIR_EraseRootFromParent_Done,
     /*   53965 */   // Label 1456: @53965
     /*   53965 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(54031), // Rule ID 70151 //
     /*   53970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   53981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   53985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   53989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   53994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   53998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   54006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54012 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54029 */     GIR_RootConstrainSelectedInstOperands,
     /*   54030 */     // GIR_Coverage, 70151,
     /*   54030 */     GIR_EraseRootFromParent_Done,
     /*   54031 */   // Label 1457: @54031
     /*   54031 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(54097), // Rule ID 70152 //
     /*   54036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   54064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   54072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54078 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54095 */     GIR_RootConstrainSelectedInstOperands,
     /*   54096 */     // GIR_Coverage, 70152,
     /*   54096 */     GIR_EraseRootFromParent_Done,
     /*   54097 */   // Label 1458: @54097
     /*   54097 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(54166), // Rule ID 52660 //
     /*   54102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   54143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54145 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   54158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54164 */     GIR_RootConstrainSelectedInstOperands,
     /*   54165 */     // GIR_Coverage, 52660,
     /*   54165 */     GIR_EraseRootFromParent_Done,
     /*   54166 */   // Label 1459: @54166
     /*   54166 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(54235), // Rule ID 52661 //
     /*   54171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   54212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54214 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   54227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54233 */     GIR_RootConstrainSelectedInstOperands,
     /*   54234 */     // GIR_Coverage, 52661,
     /*   54234 */     GIR_EraseRootFromParent_Done,
     /*   54235 */   // Label 1460: @54235
     /*   54235 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(54304), // Rule ID 70147 //
     /*   54240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   54255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   54263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54283 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   54286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54302 */     GIR_RootConstrainSelectedInstOperands,
     /*   54303 */     // GIR_Coverage, 70147,
     /*   54303 */     GIR_EraseRootFromParent_Done,
     /*   54304 */   // Label 1461: @54304
     /*   54304 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(54373), // Rule ID 70148 //
     /*   54309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   54324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   54332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54352 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   54355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54371 */     GIR_RootConstrainSelectedInstOperands,
     /*   54372 */     // GIR_Coverage, 70148,
     /*   54372 */     GIR_EraseRootFromParent_Done,
     /*   54373 */   // Label 1462: @54373
     /*   54373 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(54442), // Rule ID 70149 //
     /*   54378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   54393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   54401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54421 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*   54424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54440 */     GIR_RootConstrainSelectedInstOperands,
     /*   54441 */     // GIR_Coverage, 70149,
     /*   54441 */     GIR_EraseRootFromParent_Done,
     /*   54442 */   // Label 1463: @54442
     /*   54442 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(54511), // Rule ID 70150 //
     /*   54447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   54462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   54470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54490 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*   54493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54509 */     GIR_RootConstrainSelectedInstOperands,
     /*   54510 */     // GIR_Coverage, 70150,
     /*   54510 */     GIR_EraseRootFromParent_Done,
     /*   54511 */   // Label 1464: @54511
     /*   54511 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(54580), // Rule ID 70155 //
     /*   54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   54531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54559 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54578 */     GIR_RootConstrainSelectedInstOperands,
     /*   54579 */     // GIR_Coverage, 70155,
     /*   54579 */     GIR_EraseRootFromParent_Done,
     /*   54580 */   // Label 1465: @54580
     /*   54580 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(54649), // Rule ID 70156 //
     /*   54585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   54600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   54604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54628 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   54641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54647 */     GIR_RootConstrainSelectedInstOperands,
     /*   54648 */     // GIR_Coverage, 70156,
     /*   54648 */     GIR_EraseRootFromParent_Done,
     /*   54649 */   // Label 1466: @54649
     /*   54649 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(54715), // Rule ID 70159 //
     /*   54654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   54689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54696 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   54705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54713 */     GIR_RootConstrainSelectedInstOperands,
     /*   54714 */     // GIR_Coverage, 70159,
     /*   54714 */     GIR_EraseRootFromParent_Done,
     /*   54715 */   // Label 1467: @54715
     /*   54715 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(54781), // Rule ID 70160 //
     /*   54720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   54755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54762 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   54771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54779 */     GIR_RootConstrainSelectedInstOperands,
     /*   54780 */     // GIR_Coverage, 70160,
     /*   54780 */     GIR_EraseRootFromParent_Done,
     /*   54781 */   // Label 1468: @54781
     /*   54781 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(54847), // Rule ID 70157 //
     /*   54786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   54818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   54826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54828 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54845 */     GIR_RootConstrainSelectedInstOperands,
     /*   54846 */     // GIR_Coverage, 70157,
     /*   54846 */     GIR_EraseRootFromParent_Done,
     /*   54847 */   // Label 1469: @54847
     /*   54847 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(54913), // Rule ID 70158 //
     /*   54852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   54867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*   54871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   54875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   54884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   54892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   54894 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*   54897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54911 */     GIR_RootConstrainSelectedInstOperands,
     /*   54912 */     // GIR_Coverage, 70158,
     /*   54912 */     GIR_EraseRootFromParent_Done,
     /*   54913 */   // Label 1470: @54913
     /*   54913 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(54956), // Rule ID 70173 //
     /*   54918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   54933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54939 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   54939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   54942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   54946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   54948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54954 */     GIR_RootConstrainSelectedInstOperands,
     /*   54955 */     // GIR_Coverage, 70173,
     /*   54955 */     GIR_EraseRootFromParent_Done,
     /*   54956 */   // Label 1471: @54956
     /*   54956 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(54999), // Rule ID 70174 //
     /*   54961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   54972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   54976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   54980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54982 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   54982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   54985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   54989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   54991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   54997 */     GIR_RootConstrainSelectedInstOperands,
     /*   54998 */     // GIR_Coverage, 70174,
     /*   54998 */     GIR_EraseRootFromParent_Done,
     /*   54999 */   // Label 1472: @54999
     /*   54999 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(55042), // Rule ID 52666 //
     /*   55004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   55023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55025 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   55025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   55028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   55032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   55034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55040 */     GIR_RootConstrainSelectedInstOperands,
     /*   55041 */     // GIR_Coverage, 52666,
     /*   55041 */     GIR_EraseRootFromParent_Done,
     /*   55042 */   // Label 1473: @55042
     /*   55042 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(55085), // Rule ID 52667 //
     /*   55047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   55066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55068 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   55068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*   55071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   55075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   55077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55083 */     GIR_RootConstrainSelectedInstOperands,
     /*   55084 */     // GIR_Coverage, 52667,
     /*   55084 */     GIR_EraseRootFromParent_Done,
     /*   55085 */   // Label 1474: @55085
     /*   55085 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(55118), // Rule ID 52654 //
     /*   55090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55101 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   55101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*   55104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55116 */     GIR_RootConstrainSelectedInstOperands,
     /*   55117 */     // GIR_Coverage, 52654,
     /*   55117 */     GIR_EraseRootFromParent_Done,
     /*   55118 */   // Label 1475: @55118
     /*   55118 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(55151), // Rule ID 52655 //
     /*   55123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55134 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   55134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*   55137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55149 */     GIR_RootConstrainSelectedInstOperands,
     /*   55150 */     // GIR_Coverage, 52655,
     /*   55150 */     GIR_EraseRootFromParent_Done,
     /*   55151 */   // Label 1476: @55151
     /*   55151 */   GIM_Reject,
     /*   55152 */ // Label 1450: @55152
     /*   55152 */ GIM_Reject,
     /*   55153 */ // Label 1335: @55153
     /*   55153 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(55267),
     /*   55158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   55161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   55164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55176 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(55221), // Rule ID 47378 //
     /*   55181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55184 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   55184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   55187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   55201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55219 */     GIR_RootConstrainSelectedInstOperands,
     /*   55220 */     // GIR_Coverage, 47378,
     /*   55220 */     GIR_EraseRootFromParent_Done,
     /*   55221 */   // Label 1478: @55221
     /*   55221 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(55266), // Rule ID 47379 //
     /*   55226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55229 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   55229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   55232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*   55246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55264 */     GIR_RootConstrainSelectedInstOperands,
     /*   55265 */     // GIR_Coverage, 47379,
     /*   55265 */     GIR_EraseRootFromParent_Done,
     /*   55266 */   // Label 1479: @55266
     /*   55266 */   GIM_Reject,
     /*   55267 */ // Label 1477: @55267
     /*   55267 */ GIM_Reject,
     /*   55268 */ // Label 1336: @55268
     /*   55268 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(55382),
     /*   55273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   55276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   55279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55291 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(55336), // Rule ID 47398 //
     /*   55296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55299 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   55302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   55316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55334 */     GIR_RootConstrainSelectedInstOperands,
     /*   55335 */     // GIR_Coverage, 47398,
     /*   55335 */     GIR_EraseRootFromParent_Done,
     /*   55336 */   // Label 1481: @55336
     /*   55336 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(55381), // Rule ID 47399 //
     /*   55341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55344 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   55347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   55361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55379 */     GIR_RootConstrainSelectedInstOperands,
     /*   55380 */     // GIR_Coverage, 47399,
     /*   55380 */     GIR_EraseRootFromParent_Done,
     /*   55381 */   // Label 1482: @55381
     /*   55381 */   GIM_Reject,
     /*   55382 */ // Label 1480: @55382
     /*   55382 */ GIM_Reject,
     /*   55383 */ // Label 1337: @55383
     /*   55383 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(55497),
     /*   55388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   55391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   55394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   55398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   55402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   55406 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(55451), // Rule ID 47434 //
     /*   55411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55414 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   55414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   55417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   55431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   55446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55449 */     GIR_RootConstrainSelectedInstOperands,
     /*   55450 */     // GIR_Coverage, 47434,
     /*   55450 */     GIR_EraseRootFromParent_Done,
     /*   55451 */   // Label 1484: @55451
     /*   55451 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(55496), // Rule ID 47435 //
     /*   55456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55459 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   55459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   55462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   55476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   55491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55494 */     GIR_RootConstrainSelectedInstOperands,
     /*   55495 */     // GIR_Coverage, 47435,
     /*   55495 */     GIR_EraseRootFromParent_Done,
     /*   55496 */   // Label 1485: @55496
     /*   55496 */   GIM_Reject,
     /*   55497 */ // Label 1483: @55497
     /*   55497 */ GIM_Reject,
     /*   55498 */ // Label 1338: @55498
     /*   55498 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(55612),
     /*   55503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   55506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   55509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55521 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(55566), // Rule ID 47450 //
     /*   55526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   55529 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   55529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   55532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   55546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   55561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55564 */     GIR_RootConstrainSelectedInstOperands,
     /*   55565 */     // GIR_Coverage, 47450,
     /*   55565 */     GIR_EraseRootFromParent_Done,
     /*   55566 */   // Label 1487: @55566
     /*   55566 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(55611), // Rule ID 47451 //
     /*   55571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   55574 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   55574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   55577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   55591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   55598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   55606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55609 */     GIR_RootConstrainSelectedInstOperands,
     /*   55610 */     // GIR_Coverage, 47451,
     /*   55610 */     GIR_EraseRootFromParent_Done,
     /*   55611 */   // Label 1488: @55611
     /*   55611 */   GIM_Reject,
     /*   55612 */ // Label 1486: @55612
     /*   55612 */ GIM_Reject,
     /*   55613 */ // Label 1339: @55613
     /*   55613 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(57223),
     /*   55618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55628 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(55697), // Rule ID 52674 //
     /*   55633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   55644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   55674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55676 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   55676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   55679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   55689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55695 */     GIR_RootConstrainSelectedInstOperands,
     /*   55696 */     // GIR_Coverage, 52674,
     /*   55696 */     GIR_EraseRootFromParent_Done,
     /*   55697 */   // Label 1490: @55697
     /*   55697 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(55766), // Rule ID 52675 //
     /*   55702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   55713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   55743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55745 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   55745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   55748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   55758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55764 */     GIR_RootConstrainSelectedInstOperands,
     /*   55765 */     // GIR_Coverage, 52675,
     /*   55765 */     GIR_EraseRootFromParent_Done,
     /*   55766 */   // Label 1491: @55766
     /*   55766 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(55835), // Rule ID 52676 //
     /*   55771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   55782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   55812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55814 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   55814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*   55817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   55827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55833 */     GIR_RootConstrainSelectedInstOperands,
     /*   55834 */     // GIR_Coverage, 52676,
     /*   55834 */     GIR_EraseRootFromParent_Done,
     /*   55835 */   // Label 1492: @55835
     /*   55835 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(55904), // Rule ID 52677 //
     /*   55840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   55851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   55881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55883 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   55883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*   55886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   55896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55902 */     GIR_RootConstrainSelectedInstOperands,
     /*   55903 */     // GIR_Coverage, 52677,
     /*   55903 */     GIR_EraseRootFromParent_Done,
     /*   55904 */   // Label 1493: @55904
     /*   55904 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(55970), // Rule ID 70181 //
     /*   55909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   55920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   55936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   55940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   55949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55951 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   55951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   55954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   55960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   55968 */     GIR_RootConstrainSelectedInstOperands,
     /*   55969 */     // GIR_Coverage, 70181,
     /*   55969 */     GIR_EraseRootFromParent_Done,
     /*   55970 */   // Label 1494: @55970
     /*   55970 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(56036), // Rule ID 70182 //
     /*   55975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   55986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   55990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   55994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   56006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56017 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   56026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56034 */     GIR_RootConstrainSelectedInstOperands,
     /*   56035 */     // GIR_Coverage, 70182,
     /*   56035 */     GIR_EraseRootFromParent_Done,
     /*   56036 */   // Label 1495: @56036
     /*   56036 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(56102), // Rule ID 70179 //
     /*   56041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   56069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   56077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56083 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56100 */     GIR_RootConstrainSelectedInstOperands,
     /*   56101 */     // GIR_Coverage, 70179,
     /*   56101 */     GIR_EraseRootFromParent_Done,
     /*   56102 */   // Label 1496: @56102
     /*   56102 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(56168), // Rule ID 70180 //
     /*   56107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   56135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   56143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56149 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56166 */     GIR_RootConstrainSelectedInstOperands,
     /*   56167 */     // GIR_Coverage, 70180,
     /*   56167 */     GIR_EraseRootFromParent_Done,
     /*   56168 */   // Label 1497: @56168
     /*   56168 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(56237), // Rule ID 52678 //
     /*   56173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   56214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56216 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   56229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56235 */     GIR_RootConstrainSelectedInstOperands,
     /*   56236 */     // GIR_Coverage, 52678,
     /*   56236 */     GIR_EraseRootFromParent_Done,
     /*   56237 */   // Label 1498: @56237
     /*   56237 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(56306), // Rule ID 52679 //
     /*   56242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   56283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56285 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   56298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56304 */     GIR_RootConstrainSelectedInstOperands,
     /*   56305 */     // GIR_Coverage, 52679,
     /*   56305 */     GIR_EraseRootFromParent_Done,
     /*   56306 */   // Label 1499: @56306
     /*   56306 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(56375), // Rule ID 70175 //
     /*   56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   56326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   56334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56354 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   56357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56373 */     GIR_RootConstrainSelectedInstOperands,
     /*   56374 */     // GIR_Coverage, 70175,
     /*   56374 */     GIR_EraseRootFromParent_Done,
     /*   56375 */   // Label 1500: @56375
     /*   56375 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(56444), // Rule ID 70176 //
     /*   56380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   56395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   56403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56423 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   56426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56442 */     GIR_RootConstrainSelectedInstOperands,
     /*   56443 */     // GIR_Coverage, 70176,
     /*   56443 */     GIR_EraseRootFromParent_Done,
     /*   56444 */   // Label 1501: @56444
     /*   56444 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(56513), // Rule ID 70177 //
     /*   56449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   56464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   56472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56492 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*   56495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56511 */     GIR_RootConstrainSelectedInstOperands,
     /*   56512 */     // GIR_Coverage, 70177,
     /*   56512 */     GIR_EraseRootFromParent_Done,
     /*   56513 */   // Label 1502: @56513
     /*   56513 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(56582), // Rule ID 70178 //
     /*   56518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   56533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   56541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56561 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*   56564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56580 */     GIR_RootConstrainSelectedInstOperands,
     /*   56581 */     // GIR_Coverage, 70178,
     /*   56581 */     GIR_EraseRootFromParent_Done,
     /*   56582 */   // Label 1503: @56582
     /*   56582 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(56651), // Rule ID 70183 //
     /*   56587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   56602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56630 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56649 */     GIR_RootConstrainSelectedInstOperands,
     /*   56650 */     // GIR_Coverage, 70183,
     /*   56650 */     GIR_EraseRootFromParent_Done,
     /*   56651 */   // Label 1504: @56651
     /*   56651 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(56720), // Rule ID 70184 //
     /*   56656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   56671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56699 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   56712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56718 */     GIR_RootConstrainSelectedInstOperands,
     /*   56719 */     // GIR_Coverage, 70184,
     /*   56719 */     GIR_EraseRootFromParent_Done,
     /*   56720 */   // Label 1505: @56720
     /*   56720 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(56786), // Rule ID 70187 //
     /*   56725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   56752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   56760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56767 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   56776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56784 */     GIR_RootConstrainSelectedInstOperands,
     /*   56785 */     // GIR_Coverage, 70187,
     /*   56785 */     GIR_EraseRootFromParent_Done,
     /*   56786 */   // Label 1506: @56786
     /*   56786 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(56852), // Rule ID 70188 //
     /*   56791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   56818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   56826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56833 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   56842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56850 */     GIR_RootConstrainSelectedInstOperands,
     /*   56851 */     // GIR_Coverage, 70188,
     /*   56851 */     GIR_EraseRootFromParent_Done,
     /*   56852 */   // Label 1507: @56852
     /*   56852 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(56918), // Rule ID 70185 //
     /*   56857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   56889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   56897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56899 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   56899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56916 */     GIR_RootConstrainSelectedInstOperands,
     /*   56917 */     // GIR_Coverage, 70185,
     /*   56917 */     GIR_EraseRootFromParent_Done,
     /*   56918 */   // Label 1508: @56918
     /*   56918 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(56984), // Rule ID 70186 //
     /*   56923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   56938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*   56942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   56946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   56951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   56955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   56959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   56963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56965 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   56965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*   56968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   56982 */     GIR_RootConstrainSelectedInstOperands,
     /*   56983 */     // GIR_Coverage, 70186,
     /*   56983 */     GIR_EraseRootFromParent_Done,
     /*   56984 */   // Label 1509: @56984
     /*   56984 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(57027), // Rule ID 70201 //
     /*   56989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   57004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57010 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   57010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   57013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   57017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   57019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57025 */     GIR_RootConstrainSelectedInstOperands,
     /*   57026 */     // GIR_Coverage, 70201,
     /*   57026 */     GIR_EraseRootFromParent_Done,
     /*   57027 */   // Label 1510: @57027
     /*   57027 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(57070), // Rule ID 70202 //
     /*   57032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   57047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57053 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   57053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   57056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   57060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   57062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57068 */     GIR_RootConstrainSelectedInstOperands,
     /*   57069 */     // GIR_Coverage, 70202,
     /*   57069 */     GIR_EraseRootFromParent_Done,
     /*   57070 */   // Label 1511: @57070
     /*   57070 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(57113), // Rule ID 52684 //
     /*   57075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   57094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57096 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   57096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   57099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   57103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   57105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57111 */     GIR_RootConstrainSelectedInstOperands,
     /*   57112 */     // GIR_Coverage, 52684,
     /*   57112 */     GIR_EraseRootFromParent_Done,
     /*   57113 */   // Label 1512: @57113
     /*   57113 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(57156), // Rule ID 52685 //
     /*   57118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   57137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57139 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   57139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*   57142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   57146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   57148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57154 */     GIR_RootConstrainSelectedInstOperands,
     /*   57155 */     // GIR_Coverage, 52685,
     /*   57155 */     GIR_EraseRootFromParent_Done,
     /*   57156 */   // Label 1513: @57156
     /*   57156 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(57189), // Rule ID 52672 //
     /*   57161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57172 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   57172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*   57175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57187 */     GIR_RootConstrainSelectedInstOperands,
     /*   57188 */     // GIR_Coverage, 52672,
     /*   57188 */     GIR_EraseRootFromParent_Done,
     /*   57189 */   // Label 1514: @57189
     /*   57189 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(57222), // Rule ID 52673 //
     /*   57194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57205 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   57205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*   57208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57220 */     GIR_RootConstrainSelectedInstOperands,
     /*   57221 */     // GIR_Coverage, 52673,
     /*   57221 */     GIR_EraseRootFromParent_Done,
     /*   57222 */   // Label 1515: @57222
     /*   57222 */   GIM_Reject,
     /*   57223 */ // Label 1489: @57223
     /*   57223 */ GIM_Reject,
     /*   57224 */ // Label 1340: @57224
     /*   57224 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(57338),
     /*   57229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   57232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   57235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57247 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(57292), // Rule ID 47394 //
     /*   57252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57255 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   57258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   57272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57290 */     GIR_RootConstrainSelectedInstOperands,
     /*   57291 */     // GIR_Coverage, 47394,
     /*   57291 */     GIR_EraseRootFromParent_Done,
     /*   57292 */   // Label 1517: @57292
     /*   57292 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(57337), // Rule ID 47395 //
     /*   57297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57300 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   57303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*   57317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57335 */     GIR_RootConstrainSelectedInstOperands,
     /*   57336 */     // GIR_Coverage, 47395,
     /*   57336 */     GIR_EraseRootFromParent_Done,
     /*   57337 */   // Label 1518: @57337
     /*   57337 */   GIM_Reject,
     /*   57338 */ // Label 1516: @57338
     /*   57338 */ GIM_Reject,
     /*   57339 */ // Label 1341: @57339
     /*   57339 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(57453),
     /*   57344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   57347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   57350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   57354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   57358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   57362 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(57407), // Rule ID 47422 //
     /*   57367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57370 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   57370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   57373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   57387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57405 */     GIR_RootConstrainSelectedInstOperands,
     /*   57406 */     // GIR_Coverage, 47422,
     /*   57406 */     GIR_EraseRootFromParent_Done,
     /*   57407 */   // Label 1520: @57407
     /*   57407 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(57452), // Rule ID 47423 //
     /*   57412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57415 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   57415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   57418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   57432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57450 */     GIR_RootConstrainSelectedInstOperands,
     /*   57451 */     // GIR_Coverage, 47423,
     /*   57451 */     GIR_EraseRootFromParent_Done,
     /*   57452 */   // Label 1521: @57452
     /*   57452 */   GIM_Reject,
     /*   57453 */ // Label 1519: @57453
     /*   57453 */ GIM_Reject,
     /*   57454 */ // Label 1342: @57454
     /*   57454 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(57568),
     /*   57459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   57462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   57465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57477 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(57522), // Rule ID 47438 //
     /*   57482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57485 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   57488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   57502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57520 */     GIR_RootConstrainSelectedInstOperands,
     /*   57521 */     // GIR_Coverage, 47438,
     /*   57521 */     GIR_EraseRootFromParent_Done,
     /*   57522 */   // Label 1523: @57522
     /*   57522 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(57567), // Rule ID 47439 //
     /*   57527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57530 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   57533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   57547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57565 */     GIR_RootConstrainSelectedInstOperands,
     /*   57566 */     // GIR_Coverage, 47439,
     /*   57566 */     GIR_EraseRootFromParent_Done,
     /*   57567 */   // Label 1524: @57567
     /*   57567 */   GIM_Reject,
     /*   57568 */ // Label 1522: @57568
     /*   57568 */ GIM_Reject,
     /*   57569 */ // Label 1343: @57569
     /*   57569 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(57683),
     /*   57574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   57577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   57580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57592 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(57637), // Rule ID 47454 //
     /*   57597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   57600 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   57600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   57603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   57617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   57632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57635 */     GIR_RootConstrainSelectedInstOperands,
     /*   57636 */     // GIR_Coverage, 47454,
     /*   57636 */     GIR_EraseRootFromParent_Done,
     /*   57637 */   // Label 1526: @57637
     /*   57637 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(57682), // Rule ID 47455 //
     /*   57642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   57645 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   57645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   57648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   57662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   57677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57680 */     GIR_RootConstrainSelectedInstOperands,
     /*   57681 */     // GIR_Coverage, 47455,
     /*   57681 */     GIR_EraseRootFromParent_Done,
     /*   57682 */   // Label 1527: @57682
     /*   57682 */   GIM_Reject,
     /*   57683 */ // Label 1525: @57683
     /*   57683 */ GIM_Reject,
     /*   57684 */ // Label 1344: @57684
     /*   57684 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(59294),
     /*   57689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57699 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(57768), // Rule ID 52692 //
     /*   57704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   57715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   57737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   57745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   57747 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   57747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   57750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57766 */     GIR_RootConstrainSelectedInstOperands,
     /*   57767 */     // GIR_Coverage, 52692,
     /*   57767 */     GIR_EraseRootFromParent_Done,
     /*   57768 */   // Label 1529: @57768
     /*   57768 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(57837), // Rule ID 52693 //
     /*   57773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   57784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   57806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   57814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   57816 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   57816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   57819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57835 */     GIR_RootConstrainSelectedInstOperands,
     /*   57836 */     // GIR_Coverage, 52693,
     /*   57836 */     GIR_EraseRootFromParent_Done,
     /*   57837 */   // Label 1530: @57837
     /*   57837 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(57906), // Rule ID 52694 //
     /*   57842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   57853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   57875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   57883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   57885 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   57885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*   57888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57904 */     GIR_RootConstrainSelectedInstOperands,
     /*   57905 */     // GIR_Coverage, 52694,
     /*   57905 */     GIR_EraseRootFromParent_Done,
     /*   57906 */   // Label 1531: @57906
     /*   57906 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(57975), // Rule ID 52695 //
     /*   57911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   57922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   57944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   57948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   57952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   57954 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   57954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*   57957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   57973 */     GIR_RootConstrainSelectedInstOperands,
     /*   57974 */     // GIR_Coverage, 52695,
     /*   57974 */     GIR_EraseRootFromParent_Done,
     /*   57975 */   // Label 1532: @57975
     /*   57975 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(58041), // Rule ID 70209 //
     /*   57980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   57991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   57995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   57999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   58011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58022 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   58031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58039 */     GIR_RootConstrainSelectedInstOperands,
     /*   58040 */     // GIR_Coverage, 70209,
     /*   58040 */     GIR_EraseRootFromParent_Done,
     /*   58041 */   // Label 1533: @58041
     /*   58041 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(58107), // Rule ID 70210 //
     /*   58046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   58077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58088 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   58097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58105 */     GIR_RootConstrainSelectedInstOperands,
     /*   58106 */     // GIR_Coverage, 70210,
     /*   58106 */     GIR_EraseRootFromParent_Done,
     /*   58107 */   // Label 1534: @58107
     /*   58107 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(58173), // Rule ID 70207 //
     /*   58112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   58140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   58148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58154 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58171 */     GIR_RootConstrainSelectedInstOperands,
     /*   58172 */     // GIR_Coverage, 70207,
     /*   58172 */     GIR_EraseRootFromParent_Done,
     /*   58173 */   // Label 1535: @58173
     /*   58173 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(58239), // Rule ID 70208 //
     /*   58178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   58206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   58214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58220 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58237 */     GIR_RootConstrainSelectedInstOperands,
     /*   58238 */     // GIR_Coverage, 70208,
     /*   58238 */     GIR_EraseRootFromParent_Done,
     /*   58239 */   // Label 1536: @58239
     /*   58239 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(58308), // Rule ID 52696 //
     /*   58244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   58285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58287 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   58300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58306 */     GIR_RootConstrainSelectedInstOperands,
     /*   58307 */     // GIR_Coverage, 52696,
     /*   58307 */     GIR_EraseRootFromParent_Done,
     /*   58308 */   // Label 1537: @58308
     /*   58308 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(58377), // Rule ID 52697 //
     /*   58313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   58354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58356 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   58369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58375 */     GIR_RootConstrainSelectedInstOperands,
     /*   58376 */     // GIR_Coverage, 52697,
     /*   58376 */     GIR_EraseRootFromParent_Done,
     /*   58377 */   // Label 1538: @58377
     /*   58377 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(58446), // Rule ID 70203 //
     /*   58382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   58397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   58405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58425 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   58428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58444 */     GIR_RootConstrainSelectedInstOperands,
     /*   58445 */     // GIR_Coverage, 70203,
     /*   58445 */     GIR_EraseRootFromParent_Done,
     /*   58446 */   // Label 1539: @58446
     /*   58446 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(58515), // Rule ID 70204 //
     /*   58451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   58466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   58474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58494 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   58497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58513 */     GIR_RootConstrainSelectedInstOperands,
     /*   58514 */     // GIR_Coverage, 70204,
     /*   58514 */     GIR_EraseRootFromParent_Done,
     /*   58515 */   // Label 1540: @58515
     /*   58515 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(58584), // Rule ID 70205 //
     /*   58520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   58535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   58543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58563 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*   58566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58582 */     GIR_RootConstrainSelectedInstOperands,
     /*   58583 */     // GIR_Coverage, 70205,
     /*   58583 */     GIR_EraseRootFromParent_Done,
     /*   58584 */   // Label 1541: @58584
     /*   58584 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(58653), // Rule ID 70206 //
     /*   58589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58632 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*   58635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58651 */     GIR_RootConstrainSelectedInstOperands,
     /*   58652 */     // GIR_Coverage, 70206,
     /*   58652 */     GIR_EraseRootFromParent_Done,
     /*   58653 */   // Label 1542: @58653
     /*   58653 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(58722), // Rule ID 70211 //
     /*   58658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   58673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58701 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58720 */     GIR_RootConstrainSelectedInstOperands,
     /*   58721 */     // GIR_Coverage, 70211,
     /*   58721 */     GIR_EraseRootFromParent_Done,
     /*   58722 */   // Label 1543: @58722
     /*   58722 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(58791), // Rule ID 70212 //
     /*   58727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   58742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58770 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   58783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58789 */     GIR_RootConstrainSelectedInstOperands,
     /*   58790 */     // GIR_Coverage, 70212,
     /*   58790 */     GIR_EraseRootFromParent_Done,
     /*   58791 */   // Label 1544: @58791
     /*   58791 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(58857), // Rule ID 70215 //
     /*   58796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   58831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58838 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58855 */     GIR_RootConstrainSelectedInstOperands,
     /*   58856 */     // GIR_Coverage, 70215,
     /*   58856 */     GIR_EraseRootFromParent_Done,
     /*   58857 */   // Label 1545: @58857
     /*   58857 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(58923), // Rule ID 70216 //
     /*   58862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   58897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58904 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   58904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   58913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58921 */     GIR_RootConstrainSelectedInstOperands,
     /*   58922 */     // GIR_Coverage, 70216,
     /*   58922 */     GIR_EraseRootFromParent_Done,
     /*   58923 */   // Label 1546: @58923
     /*   58923 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(58989), // Rule ID 70213 //
     /*   58928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   58943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   58947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   58951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   58960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   58964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   58968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58970 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   58970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   58973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   58987 */     GIR_RootConstrainSelectedInstOperands,
     /*   58988 */     // GIR_Coverage, 70213,
     /*   58988 */     GIR_EraseRootFromParent_Done,
     /*   58989 */   // Label 1547: @58989
     /*   58989 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(59055), // Rule ID 70214 //
     /*   58994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   59009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*   59013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   59017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   59026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   59034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59036 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*   59039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59053 */     GIR_RootConstrainSelectedInstOperands,
     /*   59054 */     // GIR_Coverage, 70214,
     /*   59054 */     GIR_EraseRootFromParent_Done,
     /*   59055 */   // Label 1548: @59055
     /*   59055 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(59098), // Rule ID 70229 //
     /*   59060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   59075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59081 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   59084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   59088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   59090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59096 */     GIR_RootConstrainSelectedInstOperands,
     /*   59097 */     // GIR_Coverage, 70229,
     /*   59097 */     GIR_EraseRootFromParent_Done,
     /*   59098 */   // Label 1549: @59098
     /*   59098 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(59141), // Rule ID 70230 //
     /*   59103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   59118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59124 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   59127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   59131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   59133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59139 */     GIR_RootConstrainSelectedInstOperands,
     /*   59140 */     // GIR_Coverage, 70230,
     /*   59140 */     GIR_EraseRootFromParent_Done,
     /*   59141 */   // Label 1550: @59141
     /*   59141 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(59184), // Rule ID 52702 //
     /*   59146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   59165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59167 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   59170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   59174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   59176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59182 */     GIR_RootConstrainSelectedInstOperands,
     /*   59183 */     // GIR_Coverage, 52702,
     /*   59183 */     GIR_EraseRootFromParent_Done,
     /*   59184 */   // Label 1551: @59184
     /*   59184 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(59227), // Rule ID 52703 //
     /*   59189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   59208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59210 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*   59213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   59217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   59219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59225 */     GIR_RootConstrainSelectedInstOperands,
     /*   59226 */     // GIR_Coverage, 52703,
     /*   59226 */     GIR_EraseRootFromParent_Done,
     /*   59227 */   // Label 1552: @59227
     /*   59227 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(59260), // Rule ID 52690 //
     /*   59232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59243 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*   59246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59258 */     GIR_RootConstrainSelectedInstOperands,
     /*   59259 */     // GIR_Coverage, 52690,
     /*   59259 */     GIR_EraseRootFromParent_Done,
     /*   59260 */   // Label 1553: @59260
     /*   59260 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(59293), // Rule ID 52691 //
     /*   59265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59276 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*   59279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59291 */     GIR_RootConstrainSelectedInstOperands,
     /*   59292 */     // GIR_Coverage, 52691,
     /*   59292 */     GIR_EraseRootFromParent_Done,
     /*   59293 */   // Label 1554: @59293
     /*   59293 */   GIM_Reject,
     /*   59294 */ // Label 1528: @59294
     /*   59294 */ GIM_Reject,
     /*   59295 */ // Label 1345: @59295
     /*   59295 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(59409),
     /*   59300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   59303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   59306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   59310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   59314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   59318 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(59363), // Rule ID 47410 //
     /*   59323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59326 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   59329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   59343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59361 */     GIR_RootConstrainSelectedInstOperands,
     /*   59362 */     // GIR_Coverage, 47410,
     /*   59362 */     GIR_EraseRootFromParent_Done,
     /*   59363 */   // Label 1556: @59363
     /*   59363 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(59408), // Rule ID 47411 //
     /*   59368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59371 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   59374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*   59388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59406 */     GIR_RootConstrainSelectedInstOperands,
     /*   59407 */     // GIR_Coverage, 47411,
     /*   59407 */     GIR_EraseRootFromParent_Done,
     /*   59408 */   // Label 1557: @59408
     /*   59408 */   GIM_Reject,
     /*   59409 */ // Label 1555: @59409
     /*   59409 */ GIM_Reject,
     /*   59410 */ // Label 1346: @59410
     /*   59410 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(59524),
     /*   59415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   59418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   59421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59433 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(59478), // Rule ID 47426 //
     /*   59438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59441 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   59441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   59444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   59458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59476 */     GIR_RootConstrainSelectedInstOperands,
     /*   59477 */     // GIR_Coverage, 47426,
     /*   59477 */     GIR_EraseRootFromParent_Done,
     /*   59478 */   // Label 1559: @59478
     /*   59478 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(59523), // Rule ID 47427 //
     /*   59483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59486 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   59486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   59489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   59503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59521 */     GIR_RootConstrainSelectedInstOperands,
     /*   59522 */     // GIR_Coverage, 47427,
     /*   59522 */     GIR_EraseRootFromParent_Done,
     /*   59523 */   // Label 1560: @59523
     /*   59523 */   GIM_Reject,
     /*   59524 */ // Label 1558: @59524
     /*   59524 */ GIM_Reject,
     /*   59525 */ // Label 1347: @59525
     /*   59525 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(59639),
     /*   59530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   59533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   59536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59548 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(59593), // Rule ID 47442 //
     /*   59553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59556 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   59556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   59559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   59573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   59588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59591 */     GIR_RootConstrainSelectedInstOperands,
     /*   59592 */     // GIR_Coverage, 47442,
     /*   59592 */     GIR_EraseRootFromParent_Done,
     /*   59593 */   // Label 1562: @59593
     /*   59593 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(59638), // Rule ID 47443 //
     /*   59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59601 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   59601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   59604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   59618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   59625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   59633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59636 */     GIR_RootConstrainSelectedInstOperands,
     /*   59637 */     // GIR_Coverage, 47443,
     /*   59637 */     GIR_EraseRootFromParent_Done,
     /*   59638 */   // Label 1563: @59638
     /*   59638 */   GIM_Reject,
     /*   59639 */ // Label 1561: @59639
     /*   59639 */ GIM_Reject,
     /*   59640 */ // Label 1348: @59640
     /*   59640 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(61250),
     /*   59645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59655 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(59724), // Rule ID 52710 //
     /*   59660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   59671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   59701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59703 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   59706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   59716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59722 */     GIR_RootConstrainSelectedInstOperands,
     /*   59723 */     // GIR_Coverage, 52710,
     /*   59723 */     GIR_EraseRootFromParent_Done,
     /*   59724 */   // Label 1565: @59724
     /*   59724 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(59793), // Rule ID 52711 //
     /*   59729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   59740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   59770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59772 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   59775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   59785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59791 */     GIR_RootConstrainSelectedInstOperands,
     /*   59792 */     // GIR_Coverage, 52711,
     /*   59792 */     GIR_EraseRootFromParent_Done,
     /*   59793 */   // Label 1566: @59793
     /*   59793 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(59862), // Rule ID 52712 //
     /*   59798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   59809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   59839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59841 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*   59844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   59854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59860 */     GIR_RootConstrainSelectedInstOperands,
     /*   59861 */     // GIR_Coverage, 52712,
     /*   59861 */     GIR_EraseRootFromParent_Done,
     /*   59862 */   // Label 1567: @59862
     /*   59862 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(59931), // Rule ID 52713 //
     /*   59867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   59878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59910 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*   59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   59923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59929 */     GIR_RootConstrainSelectedInstOperands,
     /*   59930 */     // GIR_Coverage, 52713,
     /*   59930 */     GIR_EraseRootFromParent_Done,
     /*   59931 */   // Label 1568: @59931
     /*   59931 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(59997), // Rule ID 70237 //
     /*   59936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   59947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   59951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   59955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   59963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   59967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59978 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   59978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   59981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   59987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   59995 */     GIR_RootConstrainSelectedInstOperands,
     /*   59996 */     // GIR_Coverage, 70237,
     /*   59996 */     GIR_EraseRootFromParent_Done,
     /*   59997 */   // Label 1569: @59997
     /*   59997 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(60063), // Rule ID 70238 //
     /*   60002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   60025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   60033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60044 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   60053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60061 */     GIR_RootConstrainSelectedInstOperands,
     /*   60062 */     // GIR_Coverage, 70238,
     /*   60062 */     GIR_EraseRootFromParent_Done,
     /*   60063 */   // Label 1570: @60063
     /*   60063 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(60129), // Rule ID 70235 //
     /*   60068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   60096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   60104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60110 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60127 */     GIR_RootConstrainSelectedInstOperands,
     /*   60128 */     // GIR_Coverage, 70235,
     /*   60128 */     GIR_EraseRootFromParent_Done,
     /*   60129 */   // Label 1571: @60129
     /*   60129 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(60195), // Rule ID 70236 //
     /*   60134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   60162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   60170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60176 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60193 */     GIR_RootConstrainSelectedInstOperands,
     /*   60194 */     // GIR_Coverage, 70236,
     /*   60194 */     GIR_EraseRootFromParent_Done,
     /*   60195 */   // Label 1572: @60195
     /*   60195 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(60264), // Rule ID 52714 //
     /*   60200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   60241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60243 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   60256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60262 */     GIR_RootConstrainSelectedInstOperands,
     /*   60263 */     // GIR_Coverage, 52714,
     /*   60263 */     GIR_EraseRootFromParent_Done,
     /*   60264 */   // Label 1573: @60264
     /*   60264 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(60333), // Rule ID 52715 //
     /*   60269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   60310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60312 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   60325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60331 */     GIR_RootConstrainSelectedInstOperands,
     /*   60332 */     // GIR_Coverage, 52715,
     /*   60332 */     GIR_EraseRootFromParent_Done,
     /*   60333 */   // Label 1574: @60333
     /*   60333 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(60402), // Rule ID 70231 //
     /*   60338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   60353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   60361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60381 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   60384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60400 */     GIR_RootConstrainSelectedInstOperands,
     /*   60401 */     // GIR_Coverage, 70231,
     /*   60401 */     GIR_EraseRootFromParent_Done,
     /*   60402 */   // Label 1575: @60402
     /*   60402 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(60471), // Rule ID 70232 //
     /*   60407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   60422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   60430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60450 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   60453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60469 */     GIR_RootConstrainSelectedInstOperands,
     /*   60470 */     // GIR_Coverage, 70232,
     /*   60470 */     GIR_EraseRootFromParent_Done,
     /*   60471 */   // Label 1576: @60471
     /*   60471 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(60540), // Rule ID 70233 //
     /*   60476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   60491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   60499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60519 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*   60522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60538 */     GIR_RootConstrainSelectedInstOperands,
     /*   60539 */     // GIR_Coverage, 70233,
     /*   60539 */     GIR_EraseRootFromParent_Done,
     /*   60540 */   // Label 1577: @60540
     /*   60540 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(60609), // Rule ID 70234 //
     /*   60545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   60560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   60568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60588 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*   60591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60607 */     GIR_RootConstrainSelectedInstOperands,
     /*   60608 */     // GIR_Coverage, 70234,
     /*   60608 */     GIR_EraseRootFromParent_Done,
     /*   60609 */   // Label 1578: @60609
     /*   60609 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(60678), // Rule ID 70239 //
     /*   60614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   60629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60657 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60676 */     GIR_RootConstrainSelectedInstOperands,
     /*   60677 */     // GIR_Coverage, 70239,
     /*   60677 */     GIR_EraseRootFromParent_Done,
     /*   60678 */   // Label 1579: @60678
     /*   60678 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(60747), // Rule ID 70240 //
     /*   60683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   60698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60726 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   60739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60745 */     GIR_RootConstrainSelectedInstOperands,
     /*   60746 */     // GIR_Coverage, 70240,
     /*   60746 */     GIR_EraseRootFromParent_Done,
     /*   60747 */   // Label 1580: @60747
     /*   60747 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(60813), // Rule ID 70243 //
     /*   60752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   60779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   60787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60794 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   60803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60811 */     GIR_RootConstrainSelectedInstOperands,
     /*   60812 */     // GIR_Coverage, 70243,
     /*   60812 */     GIR_EraseRootFromParent_Done,
     /*   60813 */   // Label 1581: @60813
     /*   60813 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(60879), // Rule ID 70244 //
     /*   60818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   60845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   60853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60860 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   60869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60877 */     GIR_RootConstrainSelectedInstOperands,
     /*   60878 */     // GIR_Coverage, 70244,
     /*   60878 */     GIR_EraseRootFromParent_Done,
     /*   60879 */   // Label 1582: @60879
     /*   60879 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(60945), // Rule ID 70241 //
     /*   60884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   60916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   60924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60926 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   60926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   60943 */     GIR_RootConstrainSelectedInstOperands,
     /*   60944 */     // GIR_Coverage, 70241,
     /*   60944 */     GIR_EraseRootFromParent_Done,
     /*   60945 */   // Label 1583: @60945
     /*   60945 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(61011), // Rule ID 70242 //
     /*   60950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   60965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*   60969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*   60973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   60982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   60986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   60990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60992 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   60992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*   60995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61009 */     GIR_RootConstrainSelectedInstOperands,
     /*   61010 */     // GIR_Coverage, 70242,
     /*   61010 */     GIR_EraseRootFromParent_Done,
     /*   61011 */   // Label 1584: @61011
     /*   61011 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(61054), // Rule ID 70257 //
     /*   61016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61037 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   61040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   61044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   61046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61052 */     GIR_RootConstrainSelectedInstOperands,
     /*   61053 */     // GIR_Coverage, 70257,
     /*   61053 */     GIR_EraseRootFromParent_Done,
     /*   61054 */   // Label 1585: @61054
     /*   61054 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(61097), // Rule ID 70258 //
     /*   61059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61080 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   61083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   61087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   61089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61095 */     GIR_RootConstrainSelectedInstOperands,
     /*   61096 */     // GIR_Coverage, 70258,
     /*   61096 */     GIR_EraseRootFromParent_Done,
     /*   61097 */   // Label 1586: @61097
     /*   61097 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(61140), // Rule ID 52720 //
     /*   61102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61123 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   61126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   61130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   61132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61138 */     GIR_RootConstrainSelectedInstOperands,
     /*   61139 */     // GIR_Coverage, 52720,
     /*   61139 */     GIR_EraseRootFromParent_Done,
     /*   61140 */   // Label 1587: @61140
     /*   61140 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(61183), // Rule ID 52721 //
     /*   61145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61166 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*   61169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   61173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   61175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61181 */     GIR_RootConstrainSelectedInstOperands,
     /*   61182 */     // GIR_Coverage, 52721,
     /*   61182 */     GIR_EraseRootFromParent_Done,
     /*   61183 */   // Label 1588: @61183
     /*   61183 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(61216), // Rule ID 52708 //
     /*   61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61199 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*   61202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61214 */     GIR_RootConstrainSelectedInstOperands,
     /*   61215 */     // GIR_Coverage, 52708,
     /*   61215 */     GIR_EraseRootFromParent_Done,
     /*   61216 */   // Label 1589: @61216
     /*   61216 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(61249), // Rule ID 52709 //
     /*   61221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61232 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*   61235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61247 */     GIR_RootConstrainSelectedInstOperands,
     /*   61248 */     // GIR_Coverage, 52709,
     /*   61248 */     GIR_EraseRootFromParent_Done,
     /*   61249 */   // Label 1590: @61249
     /*   61249 */   GIM_Reject,
     /*   61250 */ // Label 1564: @61250
     /*   61250 */ GIM_Reject,
     /*   61251 */ // Label 1349: @61251
     /*   61251 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(61365),
     /*   61256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   61259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   61262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   61266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   61270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   61274 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(61319), // Rule ID 47414 //
     /*   61279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61282 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   61285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   61299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61317 */     GIR_RootConstrainSelectedInstOperands,
     /*   61318 */     // GIR_Coverage, 47414,
     /*   61318 */     GIR_EraseRootFromParent_Done,
     /*   61319 */   // Label 1592: @61319
     /*   61319 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(61364), // Rule ID 47415 //
     /*   61324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61327 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   61330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*   61344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61362 */     GIR_RootConstrainSelectedInstOperands,
     /*   61363 */     // GIR_Coverage, 47415,
     /*   61363 */     GIR_EraseRootFromParent_Done,
     /*   61364 */   // Label 1593: @61364
     /*   61364 */   GIM_Reject,
     /*   61365 */ // Label 1591: @61365
     /*   61365 */ GIM_Reject,
     /*   61366 */ // Label 1350: @61366
     /*   61366 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(61480),
     /*   61371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   61374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   61377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61389 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(61434), // Rule ID 47430 //
     /*   61394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61397 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   61397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61432 */     GIR_RootConstrainSelectedInstOperands,
     /*   61433 */     // GIR_Coverage, 47430,
     /*   61433 */     GIR_EraseRootFromParent_Done,
     /*   61434 */   // Label 1595: @61434
     /*   61434 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(61479), // Rule ID 47431 //
     /*   61439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61442 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   61442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   61459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61477 */     GIR_RootConstrainSelectedInstOperands,
     /*   61478 */     // GIR_Coverage, 47431,
     /*   61478 */     GIR_EraseRootFromParent_Done,
     /*   61479 */   // Label 1596: @61479
     /*   61479 */   GIM_Reject,
     /*   61480 */ // Label 1594: @61480
     /*   61480 */ GIM_Reject,
     /*   61481 */ // Label 1351: @61481
     /*   61481 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(63091),
     /*   61486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61496 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(61565), // Rule ID 52728 //
     /*   61501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   61542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61544 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   61547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61563 */     GIR_RootConstrainSelectedInstOperands,
     /*   61564 */     // GIR_Coverage, 52728,
     /*   61564 */     GIR_EraseRootFromParent_Done,
     /*   61565 */   // Label 1598: @61565
     /*   61565 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(61634), // Rule ID 52729 //
     /*   61570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   61611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61613 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   61616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61632 */     GIR_RootConstrainSelectedInstOperands,
     /*   61633 */     // GIR_Coverage, 52729,
     /*   61633 */     GIR_EraseRootFromParent_Done,
     /*   61634 */   // Label 1599: @61634
     /*   61634 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(61703), // Rule ID 52730 //
     /*   61639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   61650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   61680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61682 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*   61685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61701 */     GIR_RootConstrainSelectedInstOperands,
     /*   61702 */     // GIR_Coverage, 52730,
     /*   61702 */     GIR_EraseRootFromParent_Done,
     /*   61703 */   // Label 1600: @61703
     /*   61703 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(61772), // Rule ID 52731 //
     /*   61708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   61719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   61749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61751 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*   61754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61770 */     GIR_RootConstrainSelectedInstOperands,
     /*   61771 */     // GIR_Coverage, 52731,
     /*   61771 */     GIR_EraseRootFromParent_Done,
     /*   61772 */   // Label 1601: @61772
     /*   61772 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(61838), // Rule ID 70265 //
     /*   61777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   61788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   61800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   61808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61819 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   61822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   61828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61836 */     GIR_RootConstrainSelectedInstOperands,
     /*   61837 */     // GIR_Coverage, 70265,
     /*   61837 */     GIR_EraseRootFromParent_Done,
     /*   61838 */   // Label 1602: @61838
     /*   61838 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(61904), // Rule ID 70266 //
     /*   61843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   61866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   61874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61885 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   61885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   61888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   61894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61902 */     GIR_RootConstrainSelectedInstOperands,
     /*   61903 */     // GIR_Coverage, 70266,
     /*   61903 */     GIR_EraseRootFromParent_Done,
     /*   61904 */   // Label 1603: @61904
     /*   61904 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(61970), // Rule ID 70263 //
     /*   61909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   61920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   61937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   61941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   61945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61951 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   61951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   61954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   61968 */     GIR_RootConstrainSelectedInstOperands,
     /*   61969 */     // GIR_Coverage, 70263,
     /*   61969 */     GIR_EraseRootFromParent_Done,
     /*   61970 */   // Label 1604: @61970
     /*   61970 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(62036), // Rule ID 70264 //
     /*   61975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   61986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   61990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   61994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   62003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   62011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62017 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62034 */     GIR_RootConstrainSelectedInstOperands,
     /*   62035 */     // GIR_Coverage, 70264,
     /*   62035 */     GIR_EraseRootFromParent_Done,
     /*   62036 */   // Label 1605: @62036
     /*   62036 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(62105), // Rule ID 52732 //
     /*   62041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   62082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62084 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62103 */     GIR_RootConstrainSelectedInstOperands,
     /*   62104 */     // GIR_Coverage, 52732,
     /*   62104 */     GIR_EraseRootFromParent_Done,
     /*   62105 */   // Label 1606: @62105
     /*   62105 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(62174), // Rule ID 52733 //
     /*   62110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   62151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62153 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62172 */     GIR_RootConstrainSelectedInstOperands,
     /*   62173 */     // GIR_Coverage, 52733,
     /*   62173 */     GIR_EraseRootFromParent_Done,
     /*   62174 */   // Label 1607: @62174
     /*   62174 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(62243), // Rule ID 70259 //
     /*   62179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   62202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62222 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   62225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62241 */     GIR_RootConstrainSelectedInstOperands,
     /*   62242 */     // GIR_Coverage, 70259,
     /*   62242 */     GIR_EraseRootFromParent_Done,
     /*   62243 */   // Label 1608: @62243
     /*   62243 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(62312), // Rule ID 70260 //
     /*   62248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   62263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   62271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62291 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   62294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62310 */     GIR_RootConstrainSelectedInstOperands,
     /*   62311 */     // GIR_Coverage, 70260,
     /*   62311 */     GIR_EraseRootFromParent_Done,
     /*   62312 */   // Label 1609: @62312
     /*   62312 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(62381), // Rule ID 70261 //
     /*   62317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   62340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62360 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*   62363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62379 */     GIR_RootConstrainSelectedInstOperands,
     /*   62380 */     // GIR_Coverage, 70261,
     /*   62380 */     GIR_EraseRootFromParent_Done,
     /*   62381 */   // Label 1610: @62381
     /*   62381 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(62450), // Rule ID 70262 //
     /*   62386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   62401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   62409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62429 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*   62432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62448 */     GIR_RootConstrainSelectedInstOperands,
     /*   62449 */     // GIR_Coverage, 70262,
     /*   62449 */     GIR_EraseRootFromParent_Done,
     /*   62450 */   // Label 1611: @62450
     /*   62450 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(62519), // Rule ID 70267 //
     /*   62455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62498 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62517 */     GIR_RootConstrainSelectedInstOperands,
     /*   62518 */     // GIR_Coverage, 70267,
     /*   62518 */     GIR_EraseRootFromParent_Done,
     /*   62519 */   // Label 1612: @62519
     /*   62519 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(62588), // Rule ID 70268 //
     /*   62524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   62539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62567 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*   62580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62586 */     GIR_RootConstrainSelectedInstOperands,
     /*   62587 */     // GIR_Coverage, 70268,
     /*   62587 */     GIR_EraseRootFromParent_Done,
     /*   62588 */   // Label 1613: @62588
     /*   62588 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(62654), // Rule ID 70271 //
     /*   62593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   62620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   62628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62635 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   62644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62652 */     GIR_RootConstrainSelectedInstOperands,
     /*   62653 */     // GIR_Coverage, 70271,
     /*   62653 */     GIR_EraseRootFromParent_Done,
     /*   62654 */   // Label 1614: @62654
     /*   62654 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(62720), // Rule ID 70272 //
     /*   62659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   62686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   62694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62701 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*   62710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62718 */     GIR_RootConstrainSelectedInstOperands,
     /*   62719 */     // GIR_Coverage, 70272,
     /*   62719 */     GIR_EraseRootFromParent_Done,
     /*   62720 */   // Label 1615: @62720
     /*   62720 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(62786), // Rule ID 70269 //
     /*   62725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   62757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   62765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62767 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62784 */     GIR_RootConstrainSelectedInstOperands,
     /*   62785 */     // GIR_Coverage, 70269,
     /*   62785 */     GIR_EraseRootFromParent_Done,
     /*   62786 */   // Label 1616: @62786
     /*   62786 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(62852), // Rule ID 70270 //
     /*   62791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   62806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*   62810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*   62814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   62823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   62831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62833 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*   62836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62850 */     GIR_RootConstrainSelectedInstOperands,
     /*   62851 */     // GIR_Coverage, 70270,
     /*   62851 */     GIR_EraseRootFromParent_Done,
     /*   62852 */   // Label 1617: @62852
     /*   62852 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(62895), // Rule ID 70285 //
     /*   62857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62878 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   62881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   62885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   62887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62893 */     GIR_RootConstrainSelectedInstOperands,
     /*   62894 */     // GIR_Coverage, 70285,
     /*   62894 */     GIR_EraseRootFromParent_Done,
     /*   62895 */   // Label 1618: @62895
     /*   62895 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(62938), // Rule ID 70286 //
     /*   62900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   62915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62921 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   62921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   62924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   62928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*   62930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62936 */     GIR_RootConstrainSelectedInstOperands,
     /*   62937 */     // GIR_Coverage, 70286,
     /*   62937 */     GIR_EraseRootFromParent_Done,
     /*   62938 */   // Label 1619: @62938
     /*   62938 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(62981), // Rule ID 52738 //
     /*   62943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   62958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62964 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   62964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   62967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   62971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   62973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   62979 */     GIR_RootConstrainSelectedInstOperands,
     /*   62980 */     // GIR_Coverage, 52738,
     /*   62980 */     GIR_EraseRootFromParent_Done,
     /*   62981 */   // Label 1620: @62981
     /*   62981 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(63024), // Rule ID 52739 //
     /*   62986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*   63001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   63005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63007 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   63007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*   63010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   63014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*   63016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   63022 */     GIR_RootConstrainSelectedInstOperands,
     /*   63023 */     // GIR_Coverage, 52739,
     /*   63023 */     GIR_EraseRootFromParent_Done,
     /*   63024 */   // Label 1621: @63024
     /*   63024 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(63057), // Rule ID 52726 //
     /*   63029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63040 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   63040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*   63043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   63055 */     GIR_RootConstrainSelectedInstOperands,
     /*   63056 */     // GIR_Coverage, 52726,
     /*   63056 */     GIR_EraseRootFromParent_Done,
     /*   63057 */   // Label 1622: @63057
     /*   63057 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(63090), // Rule ID 52727 //
     /*   63062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63073 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   63073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*   63076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   63088 */     GIR_RootConstrainSelectedInstOperands,
     /*   63089 */     // GIR_Coverage, 52727,
     /*   63089 */     GIR_EraseRootFromParent_Done,
     /*   63090 */   // Label 1623: @63090
     /*   63090 */   GIM_Reject,
     /*   63091 */ // Label 1597: @63091
     /*   63091 */ GIM_Reject,
     /*   63092 */ // Label 1352: @63092
     /*   63092 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(63206),
     /*   63097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   63100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   63103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   63107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   63111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   63115 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(63160), // Rule ID 47418 //
     /*   63120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63123 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   63123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   63126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   63140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63158 */     GIR_RootConstrainSelectedInstOperands,
     /*   63159 */     // GIR_Coverage, 47418,
     /*   63159 */     GIR_EraseRootFromParent_Done,
     /*   63160 */   // Label 1625: @63160
     /*   63160 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(63205), // Rule ID 47419 //
     /*   63165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63168 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   63168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   63171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*   63185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63203 */     GIR_RootConstrainSelectedInstOperands,
     /*   63204 */     // GIR_Coverage, 47419,
     /*   63204 */     GIR_EraseRootFromParent_Done,
     /*   63205 */   // Label 1626: @63205
     /*   63205 */   GIM_Reject,
     /*   63206 */ // Label 1624: @63206
     /*   63206 */ GIM_Reject,
     /*   63207 */ // Label 1353: @63207
     /*   63207 */ GIM_Reject,
     /*   63208 */ // Label 10: @63208
     /*   63208 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(63268),
     /*   63213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*   63217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63221 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(63244), // Rule ID 110 //
     /*   63226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   63229 */     // MIs[0] Operand 1
     /*   63229 */     // No operand predicates
     /*   63229 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*   63229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   63232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63234 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   63239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   63242 */     GIR_RootConstrainSelectedInstOperands,
     /*   63243 */     // GIR_Coverage, 110,
     /*   63243 */     GIR_EraseRootFromParent_Done,
     /*   63244 */   // Label 1628: @63244
     /*   63244 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(63267), // Rule ID 111 //
     /*   63249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   63252 */     // MIs[0] Operand 1
     /*   63252 */     // No operand predicates
     /*   63252 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*   63252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   63255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63257 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   63262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   63265 */     GIR_RootConstrainSelectedInstOperands,
     /*   63266 */     // GIR_Coverage, 111,
     /*   63266 */     GIR_EraseRootFromParent_Done,
     /*   63267 */   // Label 1629: @63267
     /*   63267 */   GIM_Reject,
     /*   63268 */ // Label 1627: @63268
     /*   63268 */ GIM_Reject,
     /*   63269 */ // Label 11: @63269
     /*   63269 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(63329),
     /*   63274 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*   63277 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*   63280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   63283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   63286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63298 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(63313), // Rule ID 50 //
     /*   63303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*   63306 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*   63306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*   63311 */     GIR_RootConstrainSelectedInstOperands,
     /*   63312 */     // GIR_Coverage, 50,
     /*   63312 */     GIR_Done,
     /*   63313 */   // Label 1631: @63313
     /*   63313 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(63328), // Rule ID 51 //
     /*   63318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*   63321 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*   63321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*   63326 */     GIR_RootConstrainSelectedInstOperands,
     /*   63327 */     // GIR_Coverage, 51,
     /*   63327 */     GIR_Done,
     /*   63328 */   // Label 1632: @63328
     /*   63328 */   GIM_Reject,
     /*   63329 */ // Label 1630: @63329
     /*   63329 */ GIM_Reject,
     /*   63330 */ // Label 12: @63330
     /*   63330 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(63420),
     /*   63335 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*   63338 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*   63341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   63344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   63347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63359 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(63374), // Rule ID 48 //
     /*   63364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*   63367 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*   63367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*   63372 */     GIR_RootConstrainSelectedInstOperands,
     /*   63373 */     // GIR_Coverage, 48,
     /*   63373 */     GIR_Done,
     /*   63374 */   // Label 1634: @63374
     /*   63374 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(63389), // Rule ID 49 //
     /*   63379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*   63382 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*   63382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*   63387 */     GIR_RootConstrainSelectedInstOperands,
     /*   63388 */     // GIR_Coverage, 49,
     /*   63388 */     GIR_Done,
     /*   63389 */   // Label 1635: @63389
     /*   63389 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(63404), // Rule ID 2262 //
     /*   63394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*   63397 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   63397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*   63402 */     GIR_RootConstrainSelectedInstOperands,
     /*   63403 */     // GIR_Coverage, 2262,
     /*   63403 */     GIR_Done,
     /*   63404 */   // Label 1636: @63404
     /*   63404 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(63419), // Rule ID 2263 //
     /*   63409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*   63412 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   63412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*   63417 */     GIR_RootConstrainSelectedInstOperands,
     /*   63418 */     // GIR_Coverage, 2263,
     /*   63418 */     GIR_Done,
     /*   63419 */   // Label 1637: @63419
     /*   63419 */   GIM_Reject,
     /*   63420 */ // Label 1633: @63420
     /*   63420 */ GIM_Reject,
     /*   63421 */ // Label 13: @63421
     /*   63421 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1640*/ GIMT_Encode4(63787),
     /*   63432 */ /*GILLT_s32*//*Label 1638*/ GIMT_Encode4(63440),
     /*   63436 */ /*GILLT_s64*//*Label 1639*/ GIMT_Encode4(63677),
     /*   63440 */ // Label 1638: @63440
     /*   63440 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(63676),
     /*   63445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   63448 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(63471), // Rule ID 1305 //
     /*   63453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*   63456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63464 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*   63464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*   63469 */     GIR_RootConstrainSelectedInstOperands,
     /*   63470 */     // GIR_Coverage, 1305,
     /*   63470 */     GIR_Done,
     /*   63471 */   // Label 1642: @63471
     /*   63471 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(63494), // Rule ID 1306 //
     /*   63476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*   63479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63487 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*   63487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*   63492 */     GIR_RootConstrainSelectedInstOperands,
     /*   63493 */     // GIR_Coverage, 1306,
     /*   63493 */     GIR_Done,
     /*   63494 */   // Label 1643: @63494
     /*   63494 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(63517), // Rule ID 1307 //
     /*   63499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*   63502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63510 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*   63510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*   63515 */     GIR_RootConstrainSelectedInstOperands,
     /*   63516 */     // GIR_Coverage, 1307,
     /*   63516 */     GIR_Done,
     /*   63517 */   // Label 1644: @63517
     /*   63517 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(63540), // Rule ID 1308 //
     /*   63522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*   63525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63533 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*   63533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*   63538 */     GIR_RootConstrainSelectedInstOperands,
     /*   63539 */     // GIR_Coverage, 1308,
     /*   63539 */     GIR_Done,
     /*   63540 */   // Label 1645: @63540
     /*   63540 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(63578), // Rule ID 1309 //
     /*   63545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*   63548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63556 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*   63556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   63559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   63561 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*   63567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63577 */     // GIR_Coverage, 1309,
     /*   63577 */     GIR_EraseRootFromParent_Done,
     /*   63578 */   // Label 1646: @63578
     /*   63578 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(63616), // Rule ID 1310 //
     /*   63583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*   63586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63594 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*   63594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   63597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   63599 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*   63605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63615 */     // GIR_Coverage, 1310,
     /*   63615 */     GIR_EraseRootFromParent_Done,
     /*   63616 */   // Label 1647: @63616
     /*   63616 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(63675), // Rule ID 1311 //
     /*   63621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*   63624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63632 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*   63632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   63635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   63649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   63651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   63659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   63674 */     // GIR_Coverage, 1311,
     /*   63674 */     GIR_EraseRootFromParent_Done,
     /*   63675 */   // Label 1648: @63675
     /*   63675 */   GIM_Reject,
     /*   63676 */ // Label 1641: @63676
     /*   63676 */ GIM_Reject,
     /*   63677 */ // Label 1639: @63677
     /*   63677 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(63786),
     /*   63682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   63685 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(63708), // Rule ID 1758 //
     /*   63690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*   63693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63701 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*   63701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*   63706 */     GIR_RootConstrainSelectedInstOperands,
     /*   63707 */     // GIR_Coverage, 1758,
     /*   63707 */     GIR_Done,
     /*   63708 */   // Label 1650: @63708
     /*   63708 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(63731), // Rule ID 1759 //
     /*   63713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*   63716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63724 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*   63724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*   63729 */     GIR_RootConstrainSelectedInstOperands,
     /*   63730 */     // GIR_Coverage, 1759,
     /*   63730 */     GIR_Done,
     /*   63731 */   // Label 1651: @63731
     /*   63731 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(63758), // Rule ID 1786 //
     /*   63736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   63739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63747 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*   63747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   63752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63757 */     // GIR_Coverage, 1786,
     /*   63757 */     GIR_Done,
     /*   63758 */   // Label 1652: @63758
     /*   63758 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(63785), // Rule ID 1787 //
     /*   63763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   63766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63774 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*   63774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   63779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*   63784 */     // GIR_Coverage, 1787,
     /*   63784 */     GIR_Done,
     /*   63785 */   // Label 1653: @63785
     /*   63785 */   GIM_Reject,
     /*   63786 */ // Label 1649: @63786
     /*   63786 */ GIM_Reject,
     /*   63787 */ // Label 1640: @63787
     /*   63787 */ GIM_Reject,
     /*   63788 */ // Label 14: @63788
     /*   63788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1657*/ GIMT_Encode4(63985),
     /*   63799 */ /*GILLT_s16*//*Label 1654*/ GIMT_Encode4(63811),
     /*   63803 */ /*GILLT_s32*//*Label 1655*/ GIMT_Encode4(63869),
     /*   63807 */ /*GILLT_s64*//*Label 1656*/ GIMT_Encode4(63927),
     /*   63811 */ // Label 1654: @63811
     /*   63811 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(63868),
     /*   63816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   63819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   63823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   63827 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(63847), // Rule ID 2294 //
     /*   63832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*   63835 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*   63835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   63838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63845 */     GIR_RootConstrainSelectedInstOperands,
     /*   63846 */     // GIR_Coverage, 2294,
     /*   63846 */     GIR_EraseRootFromParent_Done,
     /*   63847 */   // Label 1659: @63847
     /*   63847 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(63867), // Rule ID 2295 //
     /*   63852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*   63855 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*   63855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   63858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63865 */     GIR_RootConstrainSelectedInstOperands,
     /*   63866 */     // GIR_Coverage, 2295,
     /*   63866 */     GIR_EraseRootFromParent_Done,
     /*   63867 */   // Label 1660: @63867
     /*   63867 */   GIM_Reject,
     /*   63868 */ // Label 1658: @63868
     /*   63868 */ GIM_Reject,
     /*   63869 */ // Label 1655: @63869
     /*   63869 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(63926),
     /*   63874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   63877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   63885 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(63905), // Rule ID 2212 //
     /*   63890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*   63893 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*   63893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   63896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63903 */     GIR_RootConstrainSelectedInstOperands,
     /*   63904 */     // GIR_Coverage, 2212,
     /*   63904 */     GIR_EraseRootFromParent_Done,
     /*   63905 */   // Label 1662: @63905
     /*   63905 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(63925), // Rule ID 2213 //
     /*   63910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*   63913 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*   63913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   63916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63923 */     GIR_RootConstrainSelectedInstOperands,
     /*   63924 */     // GIR_Coverage, 2213,
     /*   63924 */     GIR_EraseRootFromParent_Done,
     /*   63925 */   // Label 1663: @63925
     /*   63925 */   GIM_Reject,
     /*   63926 */ // Label 1661: @63926
     /*   63926 */ GIM_Reject,
     /*   63927 */ // Label 1656: @63927
     /*   63927 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(63984),
     /*   63932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   63935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   63943 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(63963), // Rule ID 2252 //
     /*   63948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*   63951 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*   63951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   63954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63961 */     GIR_RootConstrainSelectedInstOperands,
     /*   63962 */     // GIR_Coverage, 2252,
     /*   63962 */     GIR_EraseRootFromParent_Done,
     /*   63963 */   // Label 1665: @63963
     /*   63963 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(63983), // Rule ID 2253 //
     /*   63968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*   63971 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*   63971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   63974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63981 */     GIR_RootConstrainSelectedInstOperands,
     /*   63982 */     // GIR_Coverage, 2253,
     /*   63982 */     GIR_EraseRootFromParent_Done,
     /*   63983 */   // Label 1666: @63983
     /*   63983 */   GIM_Reject,
     /*   63984 */ // Label 1664: @63984
     /*   63984 */ GIM_Reject,
     /*   63985 */ // Label 1657: @63985
     /*   63985 */ GIM_Reject,
     /*   63986 */ // Label 15: @63986
     /*   63986 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1670*/ GIMT_Encode4(64183),
     /*   63997 */ /*GILLT_s16*//*Label 1667*/ GIMT_Encode4(64009),
     /*   64001 */ /*GILLT_s32*//*Label 1668*/ GIMT_Encode4(64067),
     /*   64005 */ /*GILLT_s64*//*Label 1669*/ GIMT_Encode4(64125),
     /*   64009 */ // Label 1667: @64009
     /*   64009 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(64066),
     /*   64014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64025 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(64045), // Rule ID 2278 //
     /*   64030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*   64033 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*   64033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   64036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64043 */     GIR_RootConstrainSelectedInstOperands,
     /*   64044 */     // GIR_Coverage, 2278,
     /*   64044 */     GIR_EraseRootFromParent_Done,
     /*   64045 */   // Label 1672: @64045
     /*   64045 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(64065), // Rule ID 2279 //
     /*   64050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*   64053 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*   64053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   64056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64063 */     GIR_RootConstrainSelectedInstOperands,
     /*   64064 */     // GIR_Coverage, 2279,
     /*   64064 */     GIR_EraseRootFromParent_Done,
     /*   64065 */   // Label 1673: @64065
     /*   64065 */   GIM_Reject,
     /*   64066 */ // Label 1671: @64066
     /*   64066 */ GIM_Reject,
     /*   64067 */ // Label 1668: @64067
     /*   64067 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(64124),
     /*   64072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64083 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(64103), // Rule ID 2196 //
     /*   64088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*   64091 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*   64091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   64094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64101 */     GIR_RootConstrainSelectedInstOperands,
     /*   64102 */     // GIR_Coverage, 2196,
     /*   64102 */     GIR_EraseRootFromParent_Done,
     /*   64103 */   // Label 1675: @64103
     /*   64103 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(64123), // Rule ID 2197 //
     /*   64108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*   64111 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*   64111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   64114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64121 */     GIR_RootConstrainSelectedInstOperands,
     /*   64122 */     // GIR_Coverage, 2197,
     /*   64122 */     GIR_EraseRootFromParent_Done,
     /*   64123 */   // Label 1676: @64123
     /*   64123 */   GIM_Reject,
     /*   64124 */ // Label 1674: @64124
     /*   64124 */ GIM_Reject,
     /*   64125 */ // Label 1669: @64125
     /*   64125 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(64182),
     /*   64130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64141 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(64161), // Rule ID 2236 //
     /*   64146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*   64149 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*   64149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   64152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64159 */     GIR_RootConstrainSelectedInstOperands,
     /*   64160 */     // GIR_Coverage, 2236,
     /*   64160 */     GIR_EraseRootFromParent_Done,
     /*   64161 */   // Label 1678: @64161
     /*   64161 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(64181), // Rule ID 2237 //
     /*   64166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*   64169 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*   64169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   64172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64179 */     GIR_RootConstrainSelectedInstOperands,
     /*   64180 */     // GIR_Coverage, 2237,
     /*   64180 */     GIR_EraseRootFromParent_Done,
     /*   64181 */   // Label 1679: @64181
     /*   64181 */   GIM_Reject,
     /*   64182 */ // Label 1677: @64182
     /*   64182 */ GIM_Reject,
     /*   64183 */ // Label 1670: @64183
     /*   64183 */ GIM_Reject,
     /*   64184 */ // Label 16: @64184
     /*   64184 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1682*/ GIMT_Encode4(64763),
     /*   64195 */ /*GILLT_s32*//*Label 1680*/ GIMT_Encode4(64203),
     /*   64199 */ /*GILLT_s64*//*Label 1681*/ GIMT_Encode4(64576),
     /*   64203 */ // Label 1680: @64203
     /*   64203 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(64234), // Rule ID 1324 //
     /*   64208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*   64211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64222 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*   64225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64227 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64232 */   GIR_RootConstrainSelectedInstOperands,
     /*   64233 */   // GIR_Coverage, 1324,
     /*   64233 */   GIR_EraseRootFromParent_Done,
     /*   64234 */ // Label 1683: @64234
     /*   64234 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(64265), // Rule ID 1325 //
     /*   64239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*   64242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64253 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*   64253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*   64256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64258 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64263 */   GIR_RootConstrainSelectedInstOperands,
     /*   64264 */   // GIR_Coverage, 1325,
     /*   64264 */   GIR_EraseRootFromParent_Done,
     /*   64265 */ // Label 1684: @64265
     /*   64265 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(64296), // Rule ID 1350 //
     /*   64270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*   64273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   64284 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*   64287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64289 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64294 */   GIR_RootConstrainSelectedInstOperands,
     /*   64295 */   // GIR_Coverage, 1350,
     /*   64295 */   GIR_EraseRootFromParent_Done,
     /*   64296 */ // Label 1685: @64296
     /*   64296 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(64327), // Rule ID 1351 //
     /*   64301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*   64304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   64315 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*   64315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*   64318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64325 */   GIR_RootConstrainSelectedInstOperands,
     /*   64326 */   // GIR_Coverage, 1351,
     /*   64326 */   GIR_EraseRootFromParent_Done,
     /*   64327 */ // Label 1686: @64327
     /*   64327 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(64358), // Rule ID 1718 //
     /*   64332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*   64335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64346 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*   64349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64351 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64356 */   GIR_RootConstrainSelectedInstOperands,
     /*   64357 */   // GIR_Coverage, 1718,
     /*   64357 */   GIR_EraseRootFromParent_Done,
     /*   64358 */ // Label 1687: @64358
     /*   64358 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(64389), // Rule ID 1719 //
     /*   64363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*   64366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64377 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*   64377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*   64380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64387 */   GIR_RootConstrainSelectedInstOperands,
     /*   64388 */   // GIR_Coverage, 1719,
     /*   64388 */   GIR_EraseRootFromParent_Done,
     /*   64389 */ // Label 1688: @64389
     /*   64389 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(64420), // Rule ID 1744 //
     /*   64394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*   64397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*   64408 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*   64411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64413 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64418 */   GIR_RootConstrainSelectedInstOperands,
     /*   64419 */   // GIR_Coverage, 1744,
     /*   64419 */   GIR_EraseRootFromParent_Done,
     /*   64420 */ // Label 1689: @64420
     /*   64420 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(64451), // Rule ID 1745 //
     /*   64425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*   64428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*   64439 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*   64439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*   64442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64444 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64449 */   GIR_RootConstrainSelectedInstOperands,
     /*   64450 */   // GIR_Coverage, 1745,
     /*   64450 */   GIR_EraseRootFromParent_Done,
     /*   64451 */ // Label 1690: @64451
     /*   64451 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(64482), // Rule ID 2060 //
     /*   64456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*   64459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64470 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*   64473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64475 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64480 */   GIR_RootConstrainSelectedInstOperands,
     /*   64481 */   // GIR_Coverage, 2060,
     /*   64481 */   GIR_EraseRootFromParent_Done,
     /*   64482 */ // Label 1691: @64482
     /*   64482 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(64513), // Rule ID 2061 //
     /*   64487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*   64490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64501 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*   64501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*   64504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64506 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64511 */   GIR_RootConstrainSelectedInstOperands,
     /*   64512 */   // GIR_Coverage, 2061,
     /*   64512 */   GIR_EraseRootFromParent_Done,
     /*   64513 */ // Label 1692: @64513
     /*   64513 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(64544), // Rule ID 2086 //
     /*   64518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*   64521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   64532 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*   64535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64537 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64542 */   GIR_RootConstrainSelectedInstOperands,
     /*   64543 */   // GIR_Coverage, 2086,
     /*   64543 */   GIR_EraseRootFromParent_Done,
     /*   64544 */ // Label 1693: @64544
     /*   64544 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(64575), // Rule ID 2087 //
     /*   64549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*   64552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   64563 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*   64563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*   64566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64573 */   GIR_RootConstrainSelectedInstOperands,
     /*   64574 */   // GIR_Coverage, 2087,
     /*   64574 */   GIR_EraseRootFromParent_Done,
     /*   64575 */ // Label 1694: @64575
     /*   64575 */ GIM_Reject,
     /*   64576 */ // Label 1681: @64576
     /*   64576 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(64607), // Rule ID 1377 //
     /*   64581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*   64584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64595 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*   64598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64600 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64605 */   GIR_RootConstrainSelectedInstOperands,
     /*   64606 */   // GIR_Coverage, 1377,
     /*   64606 */   GIR_EraseRootFromParent_Done,
     /*   64607 */ // Label 1695: @64607
     /*   64607 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(64638), // Rule ID 1405 //
     /*   64612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*   64615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   64618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   64626 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*   64629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64631 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64636 */   GIR_RootConstrainSelectedInstOperands,
     /*   64637 */   // GIR_Coverage, 1405,
     /*   64637 */   GIR_EraseRootFromParent_Done,
     /*   64638 */ // Label 1696: @64638
     /*   64638 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(64669), // Rule ID 1775 //
     /*   64643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*   64646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64657 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*   64660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64662 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64667 */   GIR_RootConstrainSelectedInstOperands,
     /*   64668 */   // GIR_Coverage, 1775,
     /*   64668 */   GIR_EraseRootFromParent_Done,
     /*   64669 */ // Label 1697: @64669
     /*   64669 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(64700), // Rule ID 1803 //
     /*   64674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   64677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   64680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64688 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*   64691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64693 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64698 */   GIR_RootConstrainSelectedInstOperands,
     /*   64699 */   // GIR_Coverage, 1803,
     /*   64699 */   GIR_EraseRootFromParent_Done,
     /*   64700 */ // Label 1698: @64700
     /*   64700 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(64731), // Rule ID 2111 //
     /*   64705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*   64708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64719 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*   64722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64724 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64729 */   GIR_RootConstrainSelectedInstOperands,
     /*   64730 */   // GIR_Coverage, 2111,
     /*   64730 */   GIR_EraseRootFromParent_Done,
     /*   64731 */ // Label 1699: @64731
     /*   64731 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(64762), // Rule ID 2137 //
     /*   64736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*   64739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   64742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   64750 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*   64753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64755 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64760 */   GIR_RootConstrainSelectedInstOperands,
     /*   64761 */   // GIR_Coverage, 2137,
     /*   64761 */   GIR_EraseRootFromParent_Done,
     /*   64762 */ // Label 1700: @64762
     /*   64762 */ GIM_Reject,
     /*   64763 */ // Label 1682: @64763
     /*   64763 */ GIM_Reject,
     /*   64764 */ // Label 17: @64764
     /*   64764 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(64973),
     /*   64769 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*   64772 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1705*/ GIMT_Encode4(64972),
     /*   64783 */   /*GILLT_s16*//*Label 1702*/ GIMT_Encode4(64795),
     /*   64787 */   /*GILLT_s32*//*Label 1703*/ GIMT_Encode4(64854),
     /*   64791 */   /*GILLT_s64*//*Label 1704*/ GIMT_Encode4(64913),
     /*   64795 */   // Label 1702: @64795
     /*   64795 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(64853),
     /*   64800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64804 */     GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(64828), // Rule ID 2113 //
     /*   64809 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*   64812 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   64816 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*   64819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64821 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64826 */       GIR_RootConstrainSelectedInstOperands,
     /*   64827 */       // GIR_Coverage, 2113,
     /*   64827 */       GIR_EraseRootFromParent_Done,
     /*   64828 */     // Label 1707: @64828
     /*   64828 */     GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(64852), // Rule ID 2139 //
     /*   64833 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*   64836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   64840 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*   64840 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*   64843 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64845 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64847 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64850 */       GIR_RootConstrainSelectedInstOperands,
     /*   64851 */       // GIR_Coverage, 2139,
     /*   64851 */       GIR_EraseRootFromParent_Done,
     /*   64852 */     // Label 1708: @64852
     /*   64852 */     GIM_Reject,
     /*   64853 */   // Label 1706: @64853
     /*   64853 */   GIM_Reject,
     /*   64854 */   // Label 1703: @64854
     /*   64854 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(64912),
     /*   64859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64863 */     GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(64887), // Rule ID 1379 //
     /*   64868 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*   64871 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   64875 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64875 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*   64878 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64880 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64882 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64885 */       GIR_RootConstrainSelectedInstOperands,
     /*   64886 */       // GIR_Coverage, 1379,
     /*   64886 */       GIR_EraseRootFromParent_Done,
     /*   64887 */     // Label 1710: @64887
     /*   64887 */     GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(64911), // Rule ID 1407 //
     /*   64892 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*   64895 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   64899 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*   64899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*   64902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64904 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64906 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64909 */       GIR_RootConstrainSelectedInstOperands,
     /*   64910 */       // GIR_Coverage, 1407,
     /*   64910 */       GIR_EraseRootFromParent_Done,
     /*   64911 */     // Label 1711: @64911
     /*   64911 */     GIM_Reject,
     /*   64912 */   // Label 1709: @64912
     /*   64912 */   GIM_Reject,
     /*   64913 */   // Label 1704: @64913
     /*   64913 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(64971),
     /*   64918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64922 */     GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(64946), // Rule ID 1777 //
     /*   64927 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*   64930 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   64934 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64934 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*   64937 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64939 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64941 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64944 */       GIR_RootConstrainSelectedInstOperands,
     /*   64945 */       // GIR_Coverage, 1777,
     /*   64945 */       GIR_EraseRootFromParent_Done,
     /*   64946 */     // Label 1713: @64946
     /*   64946 */     GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(64970), // Rule ID 1805 //
     /*   64951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   64954 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   64958 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*   64958 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*   64961 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64963 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64965 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   64968 */       GIR_RootConstrainSelectedInstOperands,
     /*   64969 */       // GIR_Coverage, 1805,
     /*   64969 */       GIR_EraseRootFromParent_Done,
     /*   64970 */     // Label 1714: @64970
     /*   64970 */     GIM_Reject,
     /*   64971 */   // Label 1712: @64971
     /*   64971 */   GIM_Reject,
     /*   64972 */   // Label 1705: @64972
     /*   64972 */   GIM_Reject,
     /*   64973 */ // Label 1701: @64973
     /*   64973 */ GIM_Reject,
     /*   64974 */ // Label 18: @64974
     /*   64974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1718*/ GIMT_Encode4(65171),
     /*   64985 */ /*GILLT_s16*//*Label 1715*/ GIMT_Encode4(64997),
     /*   64989 */ /*GILLT_s32*//*Label 1716*/ GIMT_Encode4(65055),
     /*   64993 */ /*GILLT_s64*//*Label 1717*/ GIMT_Encode4(65113),
     /*   64997 */ // Label 1715: @64997
     /*   64997 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(65054),
     /*   65002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   65005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   65009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   65013 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(65033), // Rule ID 2282 //
     /*   65018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*   65021 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*   65021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   65024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65031 */     GIR_RootConstrainSelectedInstOperands,
     /*   65032 */     // GIR_Coverage, 2282,
     /*   65032 */     GIR_EraseRootFromParent_Done,
     /*   65033 */   // Label 1720: @65033
     /*   65033 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(65053), // Rule ID 2283 //
     /*   65038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*   65041 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*   65041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*   65044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65051 */     GIR_RootConstrainSelectedInstOperands,
     /*   65052 */     // GIR_Coverage, 2283,
     /*   65052 */     GIR_EraseRootFromParent_Done,
     /*   65053 */   // Label 1721: @65053
     /*   65053 */   GIM_Reject,
     /*   65054 */ // Label 1719: @65054
     /*   65054 */ GIM_Reject,
     /*   65055 */ // Label 1716: @65055
     /*   65055 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(65112),
     /*   65060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   65063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   65067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   65071 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(65091), // Rule ID 2200 //
     /*   65076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*   65079 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*   65079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   65082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65089 */     GIR_RootConstrainSelectedInstOperands,
     /*   65090 */     // GIR_Coverage, 2200,
     /*   65090 */     GIR_EraseRootFromParent_Done,
     /*   65091 */   // Label 1723: @65091
     /*   65091 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(65111), // Rule ID 2201 //
     /*   65096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*   65099 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*   65099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*   65102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65109 */     GIR_RootConstrainSelectedInstOperands,
     /*   65110 */     // GIR_Coverage, 2201,
     /*   65110 */     GIR_EraseRootFromParent_Done,
     /*   65111 */   // Label 1724: @65111
     /*   65111 */   GIM_Reject,
     /*   65112 */ // Label 1722: @65112
     /*   65112 */ GIM_Reject,
     /*   65113 */ // Label 1717: @65113
     /*   65113 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(65170),
     /*   65118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   65121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   65125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   65129 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(65149), // Rule ID 2240 //
     /*   65134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*   65137 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*   65137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   65140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65147 */     GIR_RootConstrainSelectedInstOperands,
     /*   65148 */     // GIR_Coverage, 2240,
     /*   65148 */     GIR_EraseRootFromParent_Done,
     /*   65149 */   // Label 1726: @65149
     /*   65149 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(65169), // Rule ID 2241 //
     /*   65154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*   65157 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*   65157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*   65160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   65167 */     GIR_RootConstrainSelectedInstOperands,
     /*   65168 */     // GIR_Coverage, 2241,
     /*   65168 */     GIR_EraseRootFromParent_Done,
     /*   65169 */   // Label 1727: @65169
     /*   65169 */   GIM_Reject,
     /*   65170 */ // Label 1725: @65170
     /*   65170 */ GIM_Reject,
     /*   65171 */ // Label 1718: @65171
     /*   65171 */ GIM_Reject,
     /*   65172 */ // Label 19: @65172
     /*   65172 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(65210), // Rule ID 280 //
     /*   65177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   65180 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*   65183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65187 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*   65187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*   65190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65192 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*   65202 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   65208 */   GIR_RootConstrainSelectedInstOperands,
     /*   65209 */   // GIR_Coverage, 280,
     /*   65209 */   GIR_EraseRootFromParent_Done,
     /*   65210 */ // Label 1728: @65210
     /*   65210 */ GIM_Reject,
     /*   65211 */ // Label 20: @65211
     /*   65211 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(65249), // Rule ID 281 //
     /*   65216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   65219 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*   65222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65226 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*   65226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*   65229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65231 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*   65241 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   65247 */   GIR_RootConstrainSelectedInstOperands,
     /*   65248 */   // GIR_Coverage, 281,
     /*   65248 */   GIR_EraseRootFromParent_Done,
     /*   65249 */ // Label 1729: @65249
     /*   65249 */ GIM_Reject,
     /*   65250 */ // Label 21: @65250
     /*   65250 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 1764*/ GIMT_Encode4(73711),
     /*   65261 */ /*GILLT_p0s32*//*Label 1730*/ GIMT_Encode4(65397),
     /*   65265 */ /*GILLT_p0s64*//*Label 1731*/ GIMT_Encode4(65491),
     /*   65269 */ /*GILLT_s16*//*Label 1732*/ GIMT_Encode4(65585),
     /*   65273 */ /*GILLT_s32*//*Label 1733*/ GIMT_Encode4(66224),
     /*   65277 */ /*GILLT_s64*//*Label 1734*/ GIMT_Encode4(67478),
     /*   65281 */ /*GILLT_nxv1s1*//*Label 1735*/ GIMT_Encode4(68405),
     /*   65285 */ /*GILLT_nxv1s8*//*Label 1736*/ GIMT_Encode4(68525),
     /*   65289 */ /*GILLT_nxv1s16*//*Label 1737*/ GIMT_Encode4(68653),
     /*   65293 */ /*GILLT_nxv1s32*//*Label 1738*/ GIMT_Encode4(68891),
     /*   65297 */ /*GILLT_nxv1s64*//*Label 1739*/ GIMT_Encode4(69129),
     /*   65301 */ /*GILLT_nxv2s1*//*Label 1740*/ GIMT_Encode4(69367),
     /*   65305 */ /*GILLT_nxv2s8*//*Label 1741*/ GIMT_Encode4(69487),
     /*   65309 */ /*GILLT_nxv2s16*//*Label 1742*/ GIMT_Encode4(69615),
     /*   65313 */ /*GILLT_nxv2s32*//*Label 1743*/ GIMT_Encode4(69853),
     /*   65317 */ /*GILLT_nxv2s64*//*Label 1744*/ GIMT_Encode4(70091),
     /*   65321 */ /*GILLT_nxv4s1*//*Label 1745*/ GIMT_Encode4(70329),
     /*   65325 */ /*GILLT_nxv4s8*//*Label 1746*/ GIMT_Encode4(70449),
     /*   65329 */ /*GILLT_nxv4s16*//*Label 1747*/ GIMT_Encode4(70577),
     /*   65333 */ /*GILLT_nxv4s32*//*Label 1748*/ GIMT_Encode4(70815),
     /*   65337 */ /*GILLT_nxv4s64*//*Label 1749*/ GIMT_Encode4(71053),
     /*   65341 */ /*GILLT_nxv8s1*//*Label 1750*/ GIMT_Encode4(71291),
     /*   65345 */ /*GILLT_nxv8s8*//*Label 1751*/ GIMT_Encode4(71411),
     /*   65349 */ /*GILLT_nxv8s16*//*Label 1752*/ GIMT_Encode4(71539),
     /*   65353 */ /*GILLT_nxv8s32*//*Label 1753*/ GIMT_Encode4(71777),
     /*   65357 */ /*GILLT_nxv8s64*//*Label 1754*/ GIMT_Encode4(72015),
     /*   65361 */ /*GILLT_nxv16s1*//*Label 1755*/ GIMT_Encode4(72253),
     /*   65365 */ /*GILLT_nxv16s8*//*Label 1756*/ GIMT_Encode4(72373),
     /*   65369 */ /*GILLT_nxv16s16*//*Label 1757*/ GIMT_Encode4(72501),
     /*   65373 */ /*GILLT_nxv16s32*//*Label 1758*/ GIMT_Encode4(72739),
     /*   65377 */ /*GILLT_nxv32s1*//*Label 1759*/ GIMT_Encode4(72977),
     /*   65381 */ /*GILLT_nxv32s8*//*Label 1760*/ GIMT_Encode4(73097),
     /*   65385 */ /*GILLT_nxv32s16*//*Label 1761*/ GIMT_Encode4(73225),
     /*   65389 */ /*GILLT_nxv64s1*//*Label 1762*/ GIMT_Encode4(73463),
     /*   65393 */ /*GILLT_nxv64s8*//*Label 1763*/ GIMT_Encode4(73583),
     /*   65397 */ // Label 1730: @65397
     /*   65397 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(65490),
     /*   65402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65417 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(65453), // Rule ID 63926 //
     /*   65422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   65425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65432 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   65435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65451 */     GIR_RootConstrainSelectedInstOperands,
     /*   65452 */     // GIR_Coverage, 63926,
     /*   65452 */     GIR_EraseRootFromParent_Done,
     /*   65453 */   // Label 1766: @65453
     /*   65453 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(65489), // Rule ID 63930 //
     /*   65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   65461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65468 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*   65471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65487 */     GIR_RootConstrainSelectedInstOperands,
     /*   65488 */     // GIR_Coverage, 63930,
     /*   65488 */     GIR_EraseRootFromParent_Done,
     /*   65489 */   // Label 1767: @65489
     /*   65489 */   GIM_Reject,
     /*   65490 */ // Label 1765: @65490
     /*   65490 */ GIM_Reject,
     /*   65491 */ // Label 1731: @65491
     /*   65491 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(65584),
     /*   65496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65511 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(65547), // Rule ID 63925 //
     /*   65516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   65519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65526 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   65529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65545 */     GIR_RootConstrainSelectedInstOperands,
     /*   65546 */     // GIR_Coverage, 63925,
     /*   65546 */     GIR_EraseRootFromParent_Done,
     /*   65547 */   // Label 1769: @65547
     /*   65547 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(65583), // Rule ID 63929 //
     /*   65552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   65555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65562 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*   65565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65581 */     GIR_RootConstrainSelectedInstOperands,
     /*   65582 */     // GIR_Coverage, 63929,
     /*   65582 */     GIR_EraseRootFromParent_Done,
     /*   65583 */   // Label 1770: @65583
     /*   65583 */   GIM_Reject,
     /*   65584 */ // Label 1768: @65584
     /*   65584 */ GIM_Reject,
     /*   65585 */ // Label 1732: @65585
     /*   65585 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(65639), // Rule ID 63941 //
     /*   65590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   65593 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   65596 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   65603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65618 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>>  =>  (LB:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   65621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65637 */   GIR_RootConstrainSelectedInstOperands,
     /*   65638 */   // GIR_Coverage, 63941,
     /*   65638 */   GIR_EraseRootFromParent_Done,
     /*   65639 */ // Label 1771: @65639
     /*   65639 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(65693), // Rule ID 63942 //
     /*   65644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   65647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   65650 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   65657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65672 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>>  =>  (LB:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   65675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65691 */   GIR_RootConstrainSelectedInstOperands,
     /*   65692 */   // GIR_Coverage, 63942,
     /*   65692 */   GIR_EraseRootFromParent_Done,
     /*   65693 */ // Label 1772: @65693
     /*   65693 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(65747), // Rule ID 63943 //
     /*   65698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   65701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   65704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   65711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65715 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65726 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>>  =>  (LH:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   65729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65745 */   GIR_RootConstrainSelectedInstOperands,
     /*   65746 */   // GIR_Coverage, 63943,
     /*   65746 */   GIR_EraseRootFromParent_Done,
     /*   65747 */ // Label 1773: @65747
     /*   65747 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(65801), // Rule ID 63944 //
     /*   65752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   65755 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   65758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   65765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   65769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65780 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>>  =>  (LH:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   65783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65799 */   GIR_RootConstrainSelectedInstOperands,
     /*   65800 */   // GIR_Coverage, 63944,
     /*   65800 */   GIR_EraseRootFromParent_Done,
     /*   65801 */ // Label 1774: @65801
     /*   65801 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(65852), // Rule ID 2008 //
     /*   65806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*   65809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   65820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65831 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*   65834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65850 */   GIR_RootConstrainSelectedInstOperands,
     /*   65851 */   // GIR_Coverage, 2008,
     /*   65851 */   GIR_EraseRootFromParent_Done,
     /*   65852 */ // Label 1775: @65852
     /*   65852 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(65903), // Rule ID 2009 //
     /*   65857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*   65860 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65863 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   65871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65882 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*   65885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65901 */   GIR_RootConstrainSelectedInstOperands,
     /*   65902 */   // GIR_Coverage, 2009,
     /*   65902 */   GIR_EraseRootFromParent_Done,
     /*   65903 */ // Label 1776: @65903
     /*   65903 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(65954), // Rule ID 2014 //
     /*   65908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*   65911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   65922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65933 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   65933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*   65936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   65952 */   GIR_RootConstrainSelectedInstOperands,
     /*   65953 */   // GIR_Coverage, 2014,
     /*   65953 */   GIR_EraseRootFromParent_Done,
     /*   65954 */ // Label 1777: @65954
     /*   65954 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(66005), // Rule ID 2015 //
     /*   65959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*   65962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   65965 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   65969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   65973 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   65977 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   65984 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   65984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*   65987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   65994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   65999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66003 */   GIR_RootConstrainSelectedInstOperands,
     /*   66004 */   // GIR_Coverage, 2015,
     /*   66004 */   GIR_EraseRootFromParent_Done,
     /*   66005 */ // Label 1778: @66005
     /*   66005 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(66056), // Rule ID 63933 //
     /*   66010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   66013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66028 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66035 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   66038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66054 */   GIR_RootConstrainSelectedInstOperands,
     /*   66055 */   // GIR_Coverage, 63933,
     /*   66055 */   GIR_EraseRootFromParent_Done,
     /*   66056 */ // Label 1779: @66056
     /*   66056 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(66107), // Rule ID 63934 //
     /*   66061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   66064 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66067 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66075 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66079 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66086 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   66089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66105 */   GIR_RootConstrainSelectedInstOperands,
     /*   66106 */   // GIR_Coverage, 63934,
     /*   66106 */   GIR_EraseRootFromParent_Done,
     /*   66107 */ // Label 1780: @66107
     /*   66107 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(66165), // Rule ID 63937 //
     /*   66112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   66115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   66129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66137 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66144 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   66147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66163 */   GIR_RootConstrainSelectedInstOperands,
     /*   66164 */   // GIR_Coverage, 63937,
     /*   66164 */   GIR_EraseRootFromParent_Done,
     /*   66165 */ // Label 1781: @66165
     /*   66165 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(66223), // Rule ID 63938 //
     /*   66170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   66173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66176 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66180 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   66187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66202 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   66205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66221 */   GIR_RootConstrainSelectedInstOperands,
     /*   66222 */   // GIR_Coverage, 63938,
     /*   66222 */   GIR_EraseRootFromParent_Done,
     /*   66223 */ // Label 1782: @66223
     /*   66223 */ GIM_Reject,
     /*   66224 */ // Label 1733: @66224
     /*   66224 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(66281), // Rule ID 312 //
     /*   66229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   66232 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   66235 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   66242 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   66245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66260 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_9750>>  =>  (LB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   66263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66279 */   GIR_RootConstrainSelectedInstOperands,
     /*   66280 */   // GIR_Coverage, 312,
     /*   66280 */   GIR_EraseRootFromParent_Done,
     /*   66281 */ // Label 1783: @66281
     /*   66281 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(66338), // Rule ID 314 //
     /*   66286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   66289 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   66292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   66299 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   66302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66310 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66317 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_9752>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   66320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66336 */   GIR_RootConstrainSelectedInstOperands,
     /*   66337 */   // GIR_Coverage, 314,
     /*   66337 */   GIR_EraseRootFromParent_Done,
     /*   66338 */ // Label 1784: @66338
     /*   66338 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(66395), // Rule ID 316 //
     /*   66343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   66346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   66349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   66356 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   66359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66367 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66374 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_9754>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   66377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66393 */   GIR_RootConstrainSelectedInstOperands,
     /*   66394 */   // GIR_Coverage, 316,
     /*   66394 */   GIR_EraseRootFromParent_Done,
     /*   66395 */ // Label 1785: @66395
     /*   66395 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(66449), // Rule ID 63949 //
     /*   66400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*   66403 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   66406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   66413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66428 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>>  =>  (LW:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   66431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66447 */   GIR_RootConstrainSelectedInstOperands,
     /*   66448 */   // GIR_Coverage, 63949,
     /*   66448 */   GIR_EraseRootFromParent_Done,
     /*   66449 */ // Label 1786: @66449
     /*   66449 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(66503), // Rule ID 63950 //
     /*   66454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*   66457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   66460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   66467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66482 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   66485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66501 */   GIR_RootConstrainSelectedInstOperands,
     /*   66502 */   // GIR_Coverage, 63950,
     /*   66502 */   GIR_EraseRootFromParent_Done,
     /*   66503 */ // Label 1787: @66503
     /*   66503 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(66561), // Rule ID 227 //
     /*   66508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   66511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66514 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   66525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66533 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66540 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   66543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66559 */   GIR_RootConstrainSelectedInstOperands,
     /*   66560 */   // GIR_Coverage, 227,
     /*   66560 */   GIR_EraseRootFromParent_Done,
     /*   66561 */ // Label 1788: @66561
     /*   66561 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(66619), // Rule ID 231 //
     /*   66566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   66569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66572 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   66583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66598 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   66601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66617 */   GIR_RootConstrainSelectedInstOperands,
     /*   66618 */   // GIR_Coverage, 231,
     /*   66618 */   GIR_EraseRootFromParent_Done,
     /*   66619 */ // Label 1789: @66619
     /*   66619 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(66670), // Rule ID 232 //
     /*   66624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   66627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66649 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   66652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66668 */   GIR_RootConstrainSelectedInstOperands,
     /*   66669 */   // GIR_Coverage, 232,
     /*   66669 */   GIR_EraseRootFromParent_Done,
     /*   66670 */ // Label 1790: @66670
     /*   66670 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(66721), // Rule ID 233 //
     /*   66675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   66678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66700 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   66703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66719 */   GIR_RootConstrainSelectedInstOperands,
     /*   66720 */   // GIR_Coverage, 233,
     /*   66720 */   GIR_EraseRootFromParent_Done,
     /*   66721 */ // Label 1791: @66721
     /*   66721 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(66772), // Rule ID 1295 //
     /*   66726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*   66729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   66740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66751 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*   66754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66770 */   GIR_RootConstrainSelectedInstOperands,
     /*   66771 */   // GIR_Coverage, 1295,
     /*   66771 */   GIR_EraseRootFromParent_Done,
     /*   66772 */ // Label 1792: @66772
     /*   66772 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(66823), // Rule ID 1296 //
     /*   66777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*   66780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   66791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66802 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*   66805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66821 */   GIR_RootConstrainSelectedInstOperands,
     /*   66822 */   // GIR_Coverage, 1296,
     /*   66822 */   GIR_EraseRootFromParent_Done,
     /*   66823 */ // Label 1793: @66823
     /*   66823 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(66874), // Rule ID 1301 //
     /*   66828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*   66831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   66842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66853 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*   66856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66872 */   GIR_RootConstrainSelectedInstOperands,
     /*   66873 */   // GIR_Coverage, 1301,
     /*   66873 */   GIR_EraseRootFromParent_Done,
     /*   66874 */ // Label 1794: @66874
     /*   66874 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(66925), // Rule ID 1302 //
     /*   66879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*   66882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   66893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66904 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   66904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*   66907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66923 */   GIR_RootConstrainSelectedInstOperands,
     /*   66924 */   // GIR_Coverage, 1302,
     /*   66924 */   GIR_EraseRootFromParent_Done,
     /*   66925 */ // Label 1795: @66925
     /*   66925 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(66983), // Rule ID 63953 //
     /*   66930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   66933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   66947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   66951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   66955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   66962 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   66962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   66965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   66972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   66977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   66981 */   GIR_RootConstrainSelectedInstOperands,
     /*   66982 */   // GIR_Coverage, 63953,
     /*   66982 */   GIR_EraseRootFromParent_Done,
     /*   66983 */ // Label 1796: @66983
     /*   66983 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(67041), // Rule ID 63954 //
     /*   66988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   66991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   66994 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   66998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   67005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67020 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   67020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   67023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67039 */   GIR_RootConstrainSelectedInstOperands,
     /*   67040 */   // GIR_Coverage, 63954,
     /*   67040 */   GIR_EraseRootFromParent_Done,
     /*   67041 */ // Label 1797: @67041
     /*   67041 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(67099), // Rule ID 63955 //
     /*   67046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   67049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67052 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67078 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   67081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67097 */   GIR_RootConstrainSelectedInstOperands,
     /*   67098 */   // GIR_Coverage, 63955,
     /*   67098 */   GIR_EraseRootFromParent_Done,
     /*   67099 */ // Label 1798: @67099
     /*   67099 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(67157), // Rule ID 63956 //
     /*   67104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   67107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67110 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67136 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   67136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   67139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67155 */   GIR_RootConstrainSelectedInstOperands,
     /*   67156 */   // GIR_Coverage, 63956,
     /*   67156 */   GIR_EraseRootFromParent_Done,
     /*   67157 */ // Label 1799: @67157
     /*   67157 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(67197), // Rule ID 1074 //
     /*   67162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   67175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67182 */   // MIs[0] rs1
     /*   67182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67190 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10246>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*   67195 */   GIR_RootConstrainSelectedInstOperands,
     /*   67196 */   // GIR_Coverage, 1074,
     /*   67196 */   GIR_Done,
     /*   67197 */ // Label 1800: @67197
     /*   67197 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(67237), // Rule ID 1076 //
     /*   67202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67205 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   67215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   67218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67222 */   // MIs[0] rs1
     /*   67222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67230 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10248>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*   67235 */   GIR_RootConstrainSelectedInstOperands,
     /*   67236 */   // GIR_Coverage, 1076,
     /*   67236 */   GIR_Done,
     /*   67237 */ // Label 1801: @67237
     /*   67237 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(67277), // Rule ID 1078 //
     /*   67242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67262 */   // MIs[0] rs1
     /*   67262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67270 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10250>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*   67275 */   GIR_RootConstrainSelectedInstOperands,
     /*   67276 */   // GIR_Coverage, 1078,
     /*   67276 */   GIR_Done,
     /*   67277 */ // Label 1802: @67277
     /*   67277 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(67317), // Rule ID 1080 //
     /*   67282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   67298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67302 */   // MIs[0] rs1
     /*   67302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67310 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10252>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*   67315 */   GIR_RootConstrainSelectedInstOperands,
     /*   67316 */   // GIR_Coverage, 1080,
     /*   67316 */   GIR_Done,
     /*   67317 */ // Label 1803: @67317
     /*   67317 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(67357), // Rule ID 1082 //
     /*   67322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67325 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   67335 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67342 */   // MIs[0] rs1
     /*   67342 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67350 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10254>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*   67355 */   GIR_RootConstrainSelectedInstOperands,
     /*   67356 */   // GIR_Coverage, 1082,
     /*   67356 */   GIR_Done,
     /*   67357 */ // Label 1804: @67357
     /*   67357 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(67397), // Rule ID 1084 //
     /*   67362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   67365 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   67375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   67378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67382 */   // MIs[0] rs1
     /*   67382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67390 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10256>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*   67395 */   GIR_RootConstrainSelectedInstOperands,
     /*   67396 */   // GIR_Coverage, 1084,
     /*   67396 */   GIR_Done,
     /*   67397 */ // Label 1805: @67397
     /*   67397 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(67437), // Rule ID 1098 //
     /*   67402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*   67405 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   67415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67422 */   // MIs[0] rs1
     /*   67422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67430 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10270>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*   67435 */   GIR_RootConstrainSelectedInstOperands,
     /*   67436 */   // GIR_Coverage, 1098,
     /*   67436 */   GIR_Done,
     /*   67437 */ // Label 1806: @67437
     /*   67437 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(67477), // Rule ID 1100 //
     /*   67442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*   67445 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67448 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   67455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   67458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67462 */   // MIs[0] rs1
     /*   67462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   67466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67470 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10272>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*   67470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*   67475 */   GIR_RootConstrainSelectedInstOperands,
     /*   67476 */   // GIR_Coverage, 1100,
     /*   67476 */   GIR_Done,
     /*   67477 */ // Label 1807: @67477
     /*   67477 */ GIM_Reject,
     /*   67478 */ // Label 1734: @67478
     /*   67478 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(67535), // Rule ID 311 //
     /*   67483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   67486 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   67496 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67514 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_9750>>  =>  (LB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   67517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67533 */   GIR_RootConstrainSelectedInstOperands,
     /*   67534 */   // GIR_Coverage, 311,
     /*   67534 */   GIR_EraseRootFromParent_Done,
     /*   67535 */ // Label 1808: @67535
     /*   67535 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(67592), // Rule ID 313 //
     /*   67540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   67543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67553 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67571 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_9752>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   67574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67590 */   GIR_RootConstrainSelectedInstOperands,
     /*   67591 */   // GIR_Coverage, 313,
     /*   67591 */   GIR_EraseRootFromParent_Done,
     /*   67592 */ // Label 1809: @67592
     /*   67592 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(67649), // Rule ID 315 //
     /*   67597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   67600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   67610 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67628 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_9754>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   67631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67647 */   GIR_RootConstrainSelectedInstOperands,
     /*   67648 */   // GIR_Coverage, 315,
     /*   67648 */   GIR_EraseRootFromParent_Done,
     /*   67649 */ // Label 1810: @67649
     /*   67649 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(67706), // Rule ID 323 //
     /*   67654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*   67657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   67660 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   67667 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   67670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67685 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_9762>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*   67688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67704 */   GIR_RootConstrainSelectedInstOperands,
     /*   67705 */   // GIR_Coverage, 323,
     /*   67705 */   GIR_EraseRootFromParent_Done,
     /*   67706 */ // Label 1811: @67706
     /*   67706 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(67764), // Rule ID 226 //
     /*   67711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   67714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67717 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   67728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67743 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   67746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67762 */   GIR_RootConstrainSelectedInstOperands,
     /*   67763 */   // GIR_Coverage, 226,
     /*   67763 */   GIR_EraseRootFromParent_Done,
     /*   67764 */ // Label 1812: @67764
     /*   67764 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(67822), // Rule ID 230 //
     /*   67769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   67772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67775 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   67786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67801 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   67804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67820 */   GIR_RootConstrainSelectedInstOperands,
     /*   67821 */   // GIR_Coverage, 230,
     /*   67821 */   GIR_EraseRootFromParent_Done,
     /*   67822 */ // Label 1813: @67822
     /*   67822 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(67880), // Rule ID 275 //
     /*   67827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   67830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   67844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67859 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   67862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67878 */   GIR_RootConstrainSelectedInstOperands,
     /*   67879 */   // GIR_Coverage, 275,
     /*   67879 */   GIR_EraseRootFromParent_Done,
     /*   67880 */ // Label 1814: @67880
     /*   67880 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(67931), // Rule ID 277 //
     /*   67885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   67888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   67899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67910 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*   67913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67929 */   GIR_RootConstrainSelectedInstOperands,
     /*   67930 */   // GIR_Coverage, 277,
     /*   67930 */   GIR_EraseRootFromParent_Done,
     /*   67931 */ // Label 1815: @67931
     /*   67931 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(67982), // Rule ID 1693 //
     /*   67936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*   67939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   67950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   67954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   67961 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   67961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*   67964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   67971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   67976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   67980 */   GIR_RootConstrainSelectedInstOperands,
     /*   67981 */   // GIR_Coverage, 1693,
     /*   67981 */   GIR_EraseRootFromParent_Done,
     /*   67982 */ // Label 1816: @67982
     /*   67982 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(68033), // Rule ID 1694 //
     /*   67987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*   67990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   67993 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   67997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   68001 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   68005 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   68012 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   68012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*   68015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   68022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   68027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68031 */   GIR_RootConstrainSelectedInstOperands,
     /*   68032 */   // GIR_Coverage, 1694,
     /*   68032 */   GIR_EraseRootFromParent_Done,
     /*   68033 */ // Label 1817: @68033
     /*   68033 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(68084), // Rule ID 1698 //
     /*   68038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   68041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   68044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   68048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   68056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   68063 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   68063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*   68066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   68073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   68078 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68082 */   GIR_RootConstrainSelectedInstOperands,
     /*   68083 */   // GIR_Coverage, 1698,
     /*   68083 */   GIR_EraseRootFromParent_Done,
     /*   68084 */ // Label 1818: @68084
     /*   68084 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(68124), // Rule ID 1073 //
     /*   68089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68092 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68095 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   68102 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   68105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68109 */   // MIs[0] rs1
     /*   68109 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68117 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10246>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*   68122 */   GIR_RootConstrainSelectedInstOperands,
     /*   68123 */   // GIR_Coverage, 1073,
     /*   68123 */   GIR_Done,
     /*   68124 */ // Label 1819: @68124
     /*   68124 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(68164), // Rule ID 1075 //
     /*   68129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68132 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68135 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   68142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   68145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68149 */   // MIs[0] rs1
     /*   68149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68157 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10248>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*   68162 */   GIR_RootConstrainSelectedInstOperands,
     /*   68163 */   // GIR_Coverage, 1075,
     /*   68163 */   GIR_Done,
     /*   68164 */ // Label 1820: @68164
     /*   68164 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(68204), // Rule ID 1077 //
     /*   68169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68172 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68175 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   68182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   68185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68189 */   // MIs[0] rs1
     /*   68189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68197 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10250>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*   68202 */   GIR_RootConstrainSelectedInstOperands,
     /*   68203 */   // GIR_Coverage, 1077,
     /*   68203 */   GIR_Done,
     /*   68204 */ // Label 1821: @68204
     /*   68204 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(68244), // Rule ID 1079 //
     /*   68209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68212 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   68222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   68225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68229 */   // MIs[0] rs1
     /*   68229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68237 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10252>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*   68242 */   GIR_RootConstrainSelectedInstOperands,
     /*   68243 */   // GIR_Coverage, 1079,
     /*   68243 */   GIR_Done,
     /*   68244 */ // Label 1822: @68244
     /*   68244 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(68284), // Rule ID 1081 //
     /*   68249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68252 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   68262 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   68265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68269 */   // MIs[0] rs1
     /*   68269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68277 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10254>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*   68282 */   GIR_RootConstrainSelectedInstOperands,
     /*   68283 */   // GIR_Coverage, 1081,
     /*   68283 */   GIR_Done,
     /*   68284 */ // Label 1823: @68284
     /*   68284 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(68324), // Rule ID 1083 //
     /*   68289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   68292 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   68302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   68305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68309 */   // MIs[0] rs1
     /*   68309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68317 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10256>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*   68322 */   GIR_RootConstrainSelectedInstOperands,
     /*   68323 */   // GIR_Coverage, 1083,
     /*   68323 */   GIR_Done,
     /*   68324 */ // Label 1824: @68324
     /*   68324 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(68364), // Rule ID 1097 //
     /*   68329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*   68332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   68342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   68345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68349 */   // MIs[0] rs1
     /*   68349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68357 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10270>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*   68362 */   GIR_RootConstrainSelectedInstOperands,
     /*   68363 */   // GIR_Coverage, 1097,
     /*   68363 */   GIR_Done,
     /*   68364 */ // Label 1825: @68364
     /*   68364 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(68404), // Rule ID 1099 //
     /*   68369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*   68372 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   68375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   68382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   68385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68389 */   // MIs[0] rs1
     /*   68389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68397 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10272>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*   68397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*   68402 */   GIR_RootConstrainSelectedInstOperands,
     /*   68403 */   // GIR_Coverage, 1099,
     /*   68403 */   GIR_Done,
     /*   68404 */ // Label 1826: @68404
     /*   68404 */ GIM_Reject,
     /*   68405 */ // Label 1735: @68405
     /*   68405 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(68524),
     /*   68410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   68413 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   68417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68421 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   68425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68429 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(68476), // Rule ID 45424 //
     /*   68434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68437 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   68437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*   68440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*   68454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   68467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68474 */     GIR_RootConstrainSelectedInstOperands,
     /*   68475 */     // GIR_Coverage, 45424,
     /*   68475 */     GIR_EraseRootFromParent_Done,
     /*   68476 */   // Label 1828: @68476
     /*   68476 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(68523), // Rule ID 45425 //
     /*   68481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68484 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   68484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*   68487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*   68501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   68514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68521 */     GIR_RootConstrainSelectedInstOperands,
     /*   68522 */     // GIR_Coverage, 45425,
     /*   68522 */     GIR_EraseRootFromParent_Done,
     /*   68523 */   // Label 1829: @68523
     /*   68523 */   GIM_Reject,
     /*   68524 */ // Label 1827: @68524
     /*   68524 */ GIM_Reject,
     /*   68525 */ // Label 1736: @68525
     /*   68525 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(68652),
     /*   68530 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   68533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   68537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68541 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(68596), // Rule ID 45420 //
     /*   68546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68549 */     // MIs[0] rs1
     /*   68549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68557 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   68557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   68560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*   68574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68594 */     GIR_RootConstrainSelectedInstOperands,
     /*   68595 */     // GIR_Coverage, 45420,
     /*   68595 */     GIR_EraseRootFromParent_Done,
     /*   68596 */   // Label 1831: @68596
     /*   68596 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(68651), // Rule ID 45421 //
     /*   68601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68604 */     // MIs[0] rs1
     /*   68604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   68608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68612 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   68612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   68615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*   68629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68649 */     GIR_RootConstrainSelectedInstOperands,
     /*   68650 */     // GIR_Coverage, 45421,
     /*   68650 */     GIR_EraseRootFromParent_Done,
     /*   68651 */   // Label 1832: @68651
     /*   68651 */   GIM_Reject,
     /*   68652 */ // Label 1830: @68652
     /*   68652 */ GIM_Reject,
     /*   68653 */ // Label 1737: @68653
     /*   68653 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(68890),
     /*   68658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   68661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   68665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68669 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(68724), // Rule ID 45616 //
     /*   68674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68677 */     // MIs[0] rs1
     /*   68677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68685 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   68685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   68688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*   68702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68722 */     GIR_RootConstrainSelectedInstOperands,
     /*   68723 */     // GIR_Coverage, 45616,
     /*   68723 */     GIR_EraseRootFromParent_Done,
     /*   68724 */   // Label 1834: @68724
     /*   68724 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(68779), // Rule ID 45617 //
     /*   68729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68732 */     // MIs[0] rs1
     /*   68732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   68736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68740 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   68740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   68743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*   68757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68777 */     GIR_RootConstrainSelectedInstOperands,
     /*   68778 */     // GIR_Coverage, 45617,
     /*   68778 */     GIR_EraseRootFromParent_Done,
     /*   68779 */   // Label 1835: @68779
     /*   68779 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(68834), // Rule ID 45692 //
     /*   68784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   68787 */     // MIs[0] rs1
     /*   68787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68795 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   68795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   68798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*   68812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68832 */     GIR_RootConstrainSelectedInstOperands,
     /*   68833 */     // GIR_Coverage, 45692,
     /*   68833 */     GIR_EraseRootFromParent_Done,
     /*   68834 */   // Label 1836: @68834
     /*   68834 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(68889), // Rule ID 45693 //
     /*   68839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   68842 */     // MIs[0] rs1
     /*   68842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   68846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68850 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   68850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   68853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*   68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68887 */     GIR_RootConstrainSelectedInstOperands,
     /*   68888 */     // GIR_Coverage, 45693,
     /*   68888 */     GIR_EraseRootFromParent_Done,
     /*   68889 */   // Label 1837: @68889
     /*   68889 */   GIM_Reject,
     /*   68890 */ // Label 1833: @68890
     /*   68890 */ GIM_Reject,
     /*   68891 */ // Label 1738: @68891
     /*   68891 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(69128),
     /*   68896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   68899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   68903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68907 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(68962), // Rule ID 45624 //
     /*   68912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68915 */     // MIs[0] rs1
     /*   68915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   68919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68923 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   68926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*   68940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   68960 */     GIR_RootConstrainSelectedInstOperands,
     /*   68961 */     // GIR_Coverage, 45624,
     /*   68961 */     GIR_EraseRootFromParent_Done,
     /*   68962 */   // Label 1839: @68962
     /*   68962 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(69017), // Rule ID 45625 //
     /*   68967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68970 */     // MIs[0] rs1
     /*   68970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   68974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   68978 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   68981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*   68995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69015 */     GIR_RootConstrainSelectedInstOperands,
     /*   69016 */     // GIR_Coverage, 45625,
     /*   69016 */     GIR_EraseRootFromParent_Done,
     /*   69017 */   // Label 1840: @69017
     /*   69017 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(69072), // Rule ID 45700 //
     /*   69022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   69025 */     // MIs[0] rs1
     /*   69025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69033 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   69033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   69036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*   69050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69070 */     GIR_RootConstrainSelectedInstOperands,
     /*   69071 */     // GIR_Coverage, 45700,
     /*   69071 */     GIR_EraseRootFromParent_Done,
     /*   69072 */   // Label 1841: @69072
     /*   69072 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(69127), // Rule ID 45701 //
     /*   69077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   69080 */     // MIs[0] rs1
     /*   69080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69088 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   69088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   69091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*   69105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69125 */     GIR_RootConstrainSelectedInstOperands,
     /*   69126 */     // GIR_Coverage, 45701,
     /*   69126 */     GIR_EraseRootFromParent_Done,
     /*   69127 */   // Label 1842: @69127
     /*   69127 */   GIM_Reject,
     /*   69128 */ // Label 1838: @69128
     /*   69128 */ GIM_Reject,
     /*   69129 */ // Label 1739: @69129
     /*   69129 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(69366),
     /*   69134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   69137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   69141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69145 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(69200), // Rule ID 45640 //
     /*   69150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   69153 */     // MIs[0] rs1
     /*   69153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69161 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   69161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   69164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*   69178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69198 */     GIR_RootConstrainSelectedInstOperands,
     /*   69199 */     // GIR_Coverage, 45640,
     /*   69199 */     GIR_EraseRootFromParent_Done,
     /*   69200 */   // Label 1844: @69200
     /*   69200 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(69255), // Rule ID 45641 //
     /*   69205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   69208 */     // MIs[0] rs1
     /*   69208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69216 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   69216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   69219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*   69233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69253 */     GIR_RootConstrainSelectedInstOperands,
     /*   69254 */     // GIR_Coverage, 45641,
     /*   69254 */     GIR_EraseRootFromParent_Done,
     /*   69255 */   // Label 1845: @69255
     /*   69255 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(69310), // Rule ID 45712 //
     /*   69260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   69263 */     // MIs[0] rs1
     /*   69263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69271 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   69271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   69274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*   69288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69308 */     GIR_RootConstrainSelectedInstOperands,
     /*   69309 */     // GIR_Coverage, 45712,
     /*   69309 */     GIR_EraseRootFromParent_Done,
     /*   69310 */   // Label 1846: @69310
     /*   69310 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(69365), // Rule ID 45713 //
     /*   69315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   69318 */     // MIs[0] rs1
     /*   69318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69326 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   69326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   69329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*   69343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69363 */     GIR_RootConstrainSelectedInstOperands,
     /*   69364 */     // GIR_Coverage, 45713,
     /*   69364 */     GIR_EraseRootFromParent_Done,
     /*   69365 */   // Label 1847: @69365
     /*   69365 */   GIM_Reject,
     /*   69366 */ // Label 1843: @69366
     /*   69366 */ GIM_Reject,
     /*   69367 */ // Label 1740: @69367
     /*   69367 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(69486),
     /*   69372 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   69375 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   69379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   69387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69391 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(69438), // Rule ID 45752 //
     /*   69396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69399 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   69399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*   69402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*   69416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   69429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69436 */     GIR_RootConstrainSelectedInstOperands,
     /*   69437 */     // GIR_Coverage, 45752,
     /*   69437 */     GIR_EraseRootFromParent_Done,
     /*   69438 */   // Label 1849: @69438
     /*   69438 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(69485), // Rule ID 45753 //
     /*   69443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69446 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   69446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*   69449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*   69463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   69476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69483 */     GIR_RootConstrainSelectedInstOperands,
     /*   69484 */     // GIR_Coverage, 45753,
     /*   69484 */     GIR_EraseRootFromParent_Done,
     /*   69485 */   // Label 1850: @69485
     /*   69485 */   GIM_Reject,
     /*   69486 */ // Label 1848: @69486
     /*   69486 */ GIM_Reject,
     /*   69487 */ // Label 1741: @69487
     /*   69487 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(69614),
     /*   69492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   69495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   69499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69503 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(69558), // Rule ID 45608 //
     /*   69508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69511 */     // MIs[0] rs1
     /*   69511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69519 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   69522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*   69536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69556 */     GIR_RootConstrainSelectedInstOperands,
     /*   69557 */     // GIR_Coverage, 45608,
     /*   69557 */     GIR_EraseRootFromParent_Done,
     /*   69558 */   // Label 1852: @69558
     /*   69558 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(69613), // Rule ID 45609 //
     /*   69563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69566 */     // MIs[0] rs1
     /*   69566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69574 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   69577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*   69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69611 */     GIR_RootConstrainSelectedInstOperands,
     /*   69612 */     // GIR_Coverage, 45609,
     /*   69612 */     GIR_EraseRootFromParent_Done,
     /*   69613 */   // Label 1853: @69613
     /*   69613 */   GIM_Reject,
     /*   69614 */ // Label 1851: @69614
     /*   69614 */ GIM_Reject,
     /*   69615 */ // Label 1742: @69615
     /*   69615 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(69852),
     /*   69620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   69623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   69627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69631 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(69686), // Rule ID 45620 //
     /*   69636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69639 */     // MIs[0] rs1
     /*   69639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69647 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   69647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   69650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*   69664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69684 */     GIR_RootConstrainSelectedInstOperands,
     /*   69685 */     // GIR_Coverage, 45620,
     /*   69685 */     GIR_EraseRootFromParent_Done,
     /*   69686 */   // Label 1855: @69686
     /*   69686 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(69741), // Rule ID 45621 //
     /*   69691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69694 */     // MIs[0] rs1
     /*   69694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69702 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   69702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   69705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*   69719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69739 */     GIR_RootConstrainSelectedInstOperands,
     /*   69740 */     // GIR_Coverage, 45621,
     /*   69740 */     GIR_EraseRootFromParent_Done,
     /*   69741 */   // Label 1856: @69741
     /*   69741 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(69796), // Rule ID 45696 //
     /*   69746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   69749 */     // MIs[0] rs1
     /*   69749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69757 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   69757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   69760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*   69774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69794 */     GIR_RootConstrainSelectedInstOperands,
     /*   69795 */     // GIR_Coverage, 45696,
     /*   69795 */     GIR_EraseRootFromParent_Done,
     /*   69796 */   // Label 1857: @69796
     /*   69796 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(69851), // Rule ID 45697 //
     /*   69801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   69804 */     // MIs[0] rs1
     /*   69804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69812 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   69812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   69815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*   69829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69849 */     GIR_RootConstrainSelectedInstOperands,
     /*   69850 */     // GIR_Coverage, 45697,
     /*   69850 */     GIR_EraseRootFromParent_Done,
     /*   69851 */   // Label 1858: @69851
     /*   69851 */   GIM_Reject,
     /*   69852 */ // Label 1854: @69852
     /*   69852 */ GIM_Reject,
     /*   69853 */ // Label 1743: @69853
     /*   69853 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(70090),
     /*   69858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   69861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   69865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69869 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(69924), // Rule ID 45636 //
     /*   69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69877 */     // MIs[0] rs1
     /*   69877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69885 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   69885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   69888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*   69902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69922 */     GIR_RootConstrainSelectedInstOperands,
     /*   69923 */     // GIR_Coverage, 45636,
     /*   69923 */     GIR_EraseRootFromParent_Done,
     /*   69924 */   // Label 1860: @69924
     /*   69924 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(69979), // Rule ID 45637 //
     /*   69929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69932 */     // MIs[0] rs1
     /*   69932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   69936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69940 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   69940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   69943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*   69957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   69977 */     GIR_RootConstrainSelectedInstOperands,
     /*   69978 */     // GIR_Coverage, 45637,
     /*   69978 */     GIR_EraseRootFromParent_Done,
     /*   69979 */   // Label 1861: @69979
     /*   69979 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(70034), // Rule ID 45708 //
     /*   69984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   69987 */     // MIs[0] rs1
     /*   69987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   69991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   69995 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   69995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   69998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*   70012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70032 */     GIR_RootConstrainSelectedInstOperands,
     /*   70033 */     // GIR_Coverage, 45708,
     /*   70033 */     GIR_EraseRootFromParent_Done,
     /*   70034 */   // Label 1862: @70034
     /*   70034 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(70089), // Rule ID 45709 //
     /*   70039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   70042 */     // MIs[0] rs1
     /*   70042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70050 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   70050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   70053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*   70067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70087 */     GIR_RootConstrainSelectedInstOperands,
     /*   70088 */     // GIR_Coverage, 45709,
     /*   70088 */     GIR_EraseRootFromParent_Done,
     /*   70089 */   // Label 1863: @70089
     /*   70089 */   GIM_Reject,
     /*   70090 */ // Label 1859: @70090
     /*   70090 */ GIM_Reject,
     /*   70091 */ // Label 1744: @70091
     /*   70091 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(70328),
     /*   70096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   70099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   70103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70107 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(70162), // Rule ID 45680 //
     /*   70112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   70115 */     // MIs[0] rs1
     /*   70115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70123 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   70123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   70126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*   70140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   70153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70160 */     GIR_RootConstrainSelectedInstOperands,
     /*   70161 */     // GIR_Coverage, 45680,
     /*   70161 */     GIR_EraseRootFromParent_Done,
     /*   70162 */   // Label 1865: @70162
     /*   70162 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(70217), // Rule ID 45681 //
     /*   70167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   70170 */     // MIs[0] rs1
     /*   70170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70178 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   70178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   70181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*   70195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   70208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70215 */     GIR_RootConstrainSelectedInstOperands,
     /*   70216 */     // GIR_Coverage, 45681,
     /*   70216 */     GIR_EraseRootFromParent_Done,
     /*   70217 */   // Label 1866: @70217
     /*   70217 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(70272), // Rule ID 45740 //
     /*   70222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   70225 */     // MIs[0] rs1
     /*   70225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70233 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   70233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   70236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*   70250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   70263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70270 */     GIR_RootConstrainSelectedInstOperands,
     /*   70271 */     // GIR_Coverage, 45740,
     /*   70271 */     GIR_EraseRootFromParent_Done,
     /*   70272 */   // Label 1867: @70272
     /*   70272 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(70327), // Rule ID 45741 //
     /*   70277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   70280 */     // MIs[0] rs1
     /*   70280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70288 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   70288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   70291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*   70305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   70318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70325 */     GIR_RootConstrainSelectedInstOperands,
     /*   70326 */     // GIR_Coverage, 45741,
     /*   70326 */     GIR_EraseRootFromParent_Done,
     /*   70327 */   // Label 1868: @70327
     /*   70327 */   GIM_Reject,
     /*   70328 */ // Label 1864: @70328
     /*   70328 */ GIM_Reject,
     /*   70329 */ // Label 1745: @70329
     /*   70329 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(70448),
     /*   70334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   70337 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   70341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70345 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   70349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70353 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(70400), // Rule ID 45756 //
     /*   70358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70361 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   70361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*   70364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*   70378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   70391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70398 */     GIR_RootConstrainSelectedInstOperands,
     /*   70399 */     // GIR_Coverage, 45756,
     /*   70399 */     GIR_EraseRootFromParent_Done,
     /*   70400 */   // Label 1870: @70400
     /*   70400 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(70447), // Rule ID 45757 //
     /*   70405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70408 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   70408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*   70411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*   70425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   70438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70445 */     GIR_RootConstrainSelectedInstOperands,
     /*   70446 */     // GIR_Coverage, 45757,
     /*   70446 */     GIR_EraseRootFromParent_Done,
     /*   70447 */   // Label 1871: @70447
     /*   70447 */   GIM_Reject,
     /*   70448 */ // Label 1869: @70448
     /*   70448 */ GIM_Reject,
     /*   70449 */ // Label 1746: @70449
     /*   70449 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(70576),
     /*   70454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   70457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   70461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70465 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(70520), // Rule ID 45612 //
     /*   70470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70473 */     // MIs[0] rs1
     /*   70473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70481 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   70481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   70484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*   70498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70518 */     GIR_RootConstrainSelectedInstOperands,
     /*   70519 */     // GIR_Coverage, 45612,
     /*   70519 */     GIR_EraseRootFromParent_Done,
     /*   70520 */   // Label 1873: @70520
     /*   70520 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(70575), // Rule ID 45613 //
     /*   70525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70528 */     // MIs[0] rs1
     /*   70528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70536 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   70536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   70539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*   70553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70573 */     GIR_RootConstrainSelectedInstOperands,
     /*   70574 */     // GIR_Coverage, 45613,
     /*   70574 */     GIR_EraseRootFromParent_Done,
     /*   70575 */   // Label 1874: @70575
     /*   70575 */   GIM_Reject,
     /*   70576 */ // Label 1872: @70576
     /*   70576 */ GIM_Reject,
     /*   70577 */ // Label 1747: @70577
     /*   70577 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(70814),
     /*   70582 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   70585 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   70589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70593 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(70648), // Rule ID 45632 //
     /*   70598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70601 */     // MIs[0] rs1
     /*   70601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70609 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*   70626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70646 */     GIR_RootConstrainSelectedInstOperands,
     /*   70647 */     // GIR_Coverage, 45632,
     /*   70647 */     GIR_EraseRootFromParent_Done,
     /*   70648 */   // Label 1876: @70648
     /*   70648 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(70703), // Rule ID 45633 //
     /*   70653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70656 */     // MIs[0] rs1
     /*   70656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70664 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*   70681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70701 */     GIR_RootConstrainSelectedInstOperands,
     /*   70702 */     // GIR_Coverage, 45633,
     /*   70702 */     GIR_EraseRootFromParent_Done,
     /*   70703 */   // Label 1877: @70703
     /*   70703 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(70758), // Rule ID 45704 //
     /*   70708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   70711 */     // MIs[0] rs1
     /*   70711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70719 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*   70736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70756 */     GIR_RootConstrainSelectedInstOperands,
     /*   70757 */     // GIR_Coverage, 45704,
     /*   70757 */     GIR_EraseRootFromParent_Done,
     /*   70758 */   // Label 1878: @70758
     /*   70758 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(70813), // Rule ID 45705 //
     /*   70763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   70766 */     // MIs[0] rs1
     /*   70766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70774 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*   70791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70811 */     GIR_RootConstrainSelectedInstOperands,
     /*   70812 */     // GIR_Coverage, 45705,
     /*   70812 */     GIR_EraseRootFromParent_Done,
     /*   70813 */   // Label 1879: @70813
     /*   70813 */   GIM_Reject,
     /*   70814 */ // Label 1875: @70814
     /*   70814 */ GIM_Reject,
     /*   70815 */ // Label 1748: @70815
     /*   70815 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(71052),
     /*   70820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   70823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   70827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70831 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(70886), // Rule ID 45668 //
     /*   70836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70839 */     // MIs[0] rs1
     /*   70839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70847 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   70847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*   70864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70884 */     GIR_RootConstrainSelectedInstOperands,
     /*   70885 */     // GIR_Coverage, 45668,
     /*   70885 */     GIR_EraseRootFromParent_Done,
     /*   70886 */   // Label 1881: @70886
     /*   70886 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(70941), // Rule ID 45669 //
     /*   70891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70894 */     // MIs[0] rs1
     /*   70894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   70898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70902 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   70902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*   70919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70939 */     GIR_RootConstrainSelectedInstOperands,
     /*   70940 */     // GIR_Coverage, 45669,
     /*   70940 */     GIR_EraseRootFromParent_Done,
     /*   70941 */   // Label 1882: @70941
     /*   70941 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(70996), // Rule ID 45728 //
     /*   70946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   70949 */     // MIs[0] rs1
     /*   70949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   70953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   70957 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   70957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*   70974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   70994 */     GIR_RootConstrainSelectedInstOperands,
     /*   70995 */     // GIR_Coverage, 45728,
     /*   70995 */     GIR_EraseRootFromParent_Done,
     /*   70996 */   // Label 1883: @70996
     /*   70996 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(71051), // Rule ID 45729 //
     /*   71001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   71004 */     // MIs[0] rs1
     /*   71004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71012 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*   71029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71049 */     GIR_RootConstrainSelectedInstOperands,
     /*   71050 */     // GIR_Coverage, 45729,
     /*   71050 */     GIR_EraseRootFromParent_Done,
     /*   71051 */   // Label 1884: @71051
     /*   71051 */   GIM_Reject,
     /*   71052 */ // Label 1880: @71052
     /*   71052 */ GIM_Reject,
     /*   71053 */ // Label 1749: @71053
     /*   71053 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(71290),
     /*   71058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   71061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   71065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71069 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(71124), // Rule ID 45684 //
     /*   71074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   71077 */     // MIs[0] rs1
     /*   71077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71085 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   71085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*   71102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71122 */     GIR_RootConstrainSelectedInstOperands,
     /*   71123 */     // GIR_Coverage, 45684,
     /*   71123 */     GIR_EraseRootFromParent_Done,
     /*   71124 */   // Label 1886: @71124
     /*   71124 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(71179), // Rule ID 45685 //
     /*   71129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   71132 */     // MIs[0] rs1
     /*   71132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71140 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   71140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*   71157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71177 */     GIR_RootConstrainSelectedInstOperands,
     /*   71178 */     // GIR_Coverage, 45685,
     /*   71178 */     GIR_EraseRootFromParent_Done,
     /*   71179 */   // Label 1887: @71179
     /*   71179 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(71234), // Rule ID 45744 //
     /*   71184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   71187 */     // MIs[0] rs1
     /*   71187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71195 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   71195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*   71212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71232 */     GIR_RootConstrainSelectedInstOperands,
     /*   71233 */     // GIR_Coverage, 45744,
     /*   71233 */     GIR_EraseRootFromParent_Done,
     /*   71234 */   // Label 1888: @71234
     /*   71234 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(71289), // Rule ID 45745 //
     /*   71239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   71242 */     // MIs[0] rs1
     /*   71242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71250 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   71250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*   71267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71287 */     GIR_RootConstrainSelectedInstOperands,
     /*   71288 */     // GIR_Coverage, 45745,
     /*   71288 */     GIR_EraseRootFromParent_Done,
     /*   71289 */   // Label 1889: @71289
     /*   71289 */   GIM_Reject,
     /*   71290 */ // Label 1885: @71290
     /*   71290 */ GIM_Reject,
     /*   71291 */ // Label 1750: @71291
     /*   71291 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(71410),
     /*   71296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   71299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   71303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   71311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71315 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(71362), // Rule ID 45760 //
     /*   71320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71323 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   71323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*   71326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*   71340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   71353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71360 */     GIR_RootConstrainSelectedInstOperands,
     /*   71361 */     // GIR_Coverage, 45760,
     /*   71361 */     GIR_EraseRootFromParent_Done,
     /*   71362 */   // Label 1891: @71362
     /*   71362 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(71409), // Rule ID 45761 //
     /*   71367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71370 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   71370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*   71373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*   71387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   71400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71407 */     GIR_RootConstrainSelectedInstOperands,
     /*   71408 */     // GIR_Coverage, 45761,
     /*   71408 */     GIR_EraseRootFromParent_Done,
     /*   71409 */   // Label 1892: @71409
     /*   71409 */   GIM_Reject,
     /*   71410 */ // Label 1890: @71410
     /*   71410 */ GIM_Reject,
     /*   71411 */ // Label 1751: @71411
     /*   71411 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(71538),
     /*   71416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   71419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   71423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71427 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(71482), // Rule ID 45628 //
     /*   71432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71435 */     // MIs[0] rs1
     /*   71435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71443 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   71443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   71446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*   71460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71480 */     GIR_RootConstrainSelectedInstOperands,
     /*   71481 */     // GIR_Coverage, 45628,
     /*   71481 */     GIR_EraseRootFromParent_Done,
     /*   71482 */   // Label 1894: @71482
     /*   71482 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(71537), // Rule ID 45629 //
     /*   71487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71490 */     // MIs[0] rs1
     /*   71490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71498 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   71498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   71501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*   71515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71535 */     GIR_RootConstrainSelectedInstOperands,
     /*   71536 */     // GIR_Coverage, 45629,
     /*   71536 */     GIR_EraseRootFromParent_Done,
     /*   71537 */   // Label 1895: @71537
     /*   71537 */   GIM_Reject,
     /*   71538 */ // Label 1893: @71538
     /*   71538 */ GIM_Reject,
     /*   71539 */ // Label 1752: @71539
     /*   71539 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(71776),
     /*   71544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   71547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   71551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71555 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(71610), // Rule ID 45656 //
     /*   71560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71563 */     // MIs[0] rs1
     /*   71563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71571 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   71574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*   71588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71608 */     GIR_RootConstrainSelectedInstOperands,
     /*   71609 */     // GIR_Coverage, 45656,
     /*   71609 */     GIR_EraseRootFromParent_Done,
     /*   71610 */   // Label 1897: @71610
     /*   71610 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(71665), // Rule ID 45657 //
     /*   71615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71618 */     // MIs[0] rs1
     /*   71618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71626 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   71629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*   71643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71663 */     GIR_RootConstrainSelectedInstOperands,
     /*   71664 */     // GIR_Coverage, 45657,
     /*   71664 */     GIR_EraseRootFromParent_Done,
     /*   71665 */   // Label 1898: @71665
     /*   71665 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(71720), // Rule ID 45716 //
     /*   71670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   71673 */     // MIs[0] rs1
     /*   71673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71681 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   71684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*   71698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71718 */     GIR_RootConstrainSelectedInstOperands,
     /*   71719 */     // GIR_Coverage, 45716,
     /*   71719 */     GIR_EraseRootFromParent_Done,
     /*   71720 */   // Label 1899: @71720
     /*   71720 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(71775), // Rule ID 45717 //
     /*   71725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   71728 */     // MIs[0] rs1
     /*   71728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71736 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   71739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*   71753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71773 */     GIR_RootConstrainSelectedInstOperands,
     /*   71774 */     // GIR_Coverage, 45717,
     /*   71774 */     GIR_EraseRootFromParent_Done,
     /*   71775 */   // Label 1900: @71775
     /*   71775 */   GIM_Reject,
     /*   71776 */ // Label 1896: @71776
     /*   71776 */ GIM_Reject,
     /*   71777 */ // Label 1753: @71777
     /*   71777 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(72014),
     /*   71782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   71785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   71789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71793 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(71848), // Rule ID 45672 //
     /*   71798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71801 */     // MIs[0] rs1
     /*   71801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71809 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   71812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*   71826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71846 */     GIR_RootConstrainSelectedInstOperands,
     /*   71847 */     // GIR_Coverage, 45672,
     /*   71847 */     GIR_EraseRootFromParent_Done,
     /*   71848 */   // Label 1902: @71848
     /*   71848 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(71903), // Rule ID 45673 //
     /*   71853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71856 */     // MIs[0] rs1
     /*   71856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71864 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   71867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*   71881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71901 */     GIR_RootConstrainSelectedInstOperands,
     /*   71902 */     // GIR_Coverage, 45673,
     /*   71902 */     GIR_EraseRootFromParent_Done,
     /*   71903 */   // Label 1903: @71903
     /*   71903 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(71958), // Rule ID 45732 //
     /*   71908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   71911 */     // MIs[0] rs1
     /*   71911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   71915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71919 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   71922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*   71936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   71956 */     GIR_RootConstrainSelectedInstOperands,
     /*   71957 */     // GIR_Coverage, 45732,
     /*   71957 */     GIR_EraseRootFromParent_Done,
     /*   71958 */   // Label 1904: @71958
     /*   71958 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(72013), // Rule ID 45733 //
     /*   71963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   71966 */     // MIs[0] rs1
     /*   71966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   71970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   71974 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   71977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*   71991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72011 */     GIR_RootConstrainSelectedInstOperands,
     /*   72012 */     // GIR_Coverage, 45733,
     /*   72012 */     GIR_EraseRootFromParent_Done,
     /*   72013 */   // Label 1905: @72013
     /*   72013 */   GIM_Reject,
     /*   72014 */ // Label 1901: @72014
     /*   72014 */ GIM_Reject,
     /*   72015 */ // Label 1754: @72015
     /*   72015 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(72252),
     /*   72020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   72031 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(72086), // Rule ID 45688 //
     /*   72036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72039 */     // MIs[0] rs1
     /*   72039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72047 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   72050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*   72064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72084 */     GIR_RootConstrainSelectedInstOperands,
     /*   72085 */     // GIR_Coverage, 45688,
     /*   72085 */     GIR_EraseRootFromParent_Done,
     /*   72086 */   // Label 1907: @72086
     /*   72086 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(72141), // Rule ID 45689 //
     /*   72091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72094 */     // MIs[0] rs1
     /*   72094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72102 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   72105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*   72119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72139 */     GIR_RootConstrainSelectedInstOperands,
     /*   72140 */     // GIR_Coverage, 45689,
     /*   72140 */     GIR_EraseRootFromParent_Done,
     /*   72141 */   // Label 1908: @72141
     /*   72141 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(72196), // Rule ID 45748 //
     /*   72146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   72149 */     // MIs[0] rs1
     /*   72149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72157 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   72160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*   72174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72194 */     GIR_RootConstrainSelectedInstOperands,
     /*   72195 */     // GIR_Coverage, 45748,
     /*   72195 */     GIR_EraseRootFromParent_Done,
     /*   72196 */   // Label 1909: @72196
     /*   72196 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(72251), // Rule ID 45749 //
     /*   72201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   72204 */     // MIs[0] rs1
     /*   72204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72212 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   72215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*   72229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72249 */     GIR_RootConstrainSelectedInstOperands,
     /*   72250 */     // GIR_Coverage, 45749,
     /*   72250 */     GIR_EraseRootFromParent_Done,
     /*   72251 */   // Label 1910: @72251
     /*   72251 */   GIM_Reject,
     /*   72252 */ // Label 1906: @72252
     /*   72252 */ GIM_Reject,
     /*   72253 */ // Label 1755: @72253
     /*   72253 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(72372),
     /*   72258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72261 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   72273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72277 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(72324), // Rule ID 45764 //
     /*   72282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72285 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   72285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*   72288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*   72302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   72315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72322 */     GIR_RootConstrainSelectedInstOperands,
     /*   72323 */     // GIR_Coverage, 45764,
     /*   72323 */     GIR_EraseRootFromParent_Done,
     /*   72324 */   // Label 1912: @72324
     /*   72324 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(72371), // Rule ID 45765 //
     /*   72329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72332 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   72332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*   72335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*   72349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   72362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72369 */     GIR_RootConstrainSelectedInstOperands,
     /*   72370 */     // GIR_Coverage, 45765,
     /*   72370 */     GIR_EraseRootFromParent_Done,
     /*   72371 */   // Label 1913: @72371
     /*   72371 */   GIM_Reject,
     /*   72372 */ // Label 1911: @72372
     /*   72372 */ GIM_Reject,
     /*   72373 */ // Label 1756: @72373
     /*   72373 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(72500),
     /*   72378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72389 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(72444), // Rule ID 45644 //
     /*   72394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72397 */     // MIs[0] rs1
     /*   72397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72405 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   72408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*   72422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72442 */     GIR_RootConstrainSelectedInstOperands,
     /*   72443 */     // GIR_Coverage, 45644,
     /*   72443 */     GIR_EraseRootFromParent_Done,
     /*   72444 */   // Label 1915: @72444
     /*   72444 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(72499), // Rule ID 45645 //
     /*   72449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72452 */     // MIs[0] rs1
     /*   72452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72460 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   72463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*   72477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72497 */     GIR_RootConstrainSelectedInstOperands,
     /*   72498 */     // GIR_Coverage, 45645,
     /*   72498 */     GIR_EraseRootFromParent_Done,
     /*   72499 */   // Label 1916: @72499
     /*   72499 */   GIM_Reject,
     /*   72500 */ // Label 1914: @72500
     /*   72500 */ GIM_Reject,
     /*   72501 */ // Label 1757: @72501
     /*   72501 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(72738),
     /*   72506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72517 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(72572), // Rule ID 45660 //
     /*   72522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72525 */     // MIs[0] rs1
     /*   72525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72533 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   72533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*   72550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   72563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72570 */     GIR_RootConstrainSelectedInstOperands,
     /*   72571 */     // GIR_Coverage, 45660,
     /*   72571 */     GIR_EraseRootFromParent_Done,
     /*   72572 */   // Label 1918: @72572
     /*   72572 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(72627), // Rule ID 45661 //
     /*   72577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72580 */     // MIs[0] rs1
     /*   72580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72588 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   72588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*   72605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   72618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72625 */     GIR_RootConstrainSelectedInstOperands,
     /*   72626 */     // GIR_Coverage, 45661,
     /*   72626 */     GIR_EraseRootFromParent_Done,
     /*   72627 */   // Label 1919: @72627
     /*   72627 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(72682), // Rule ID 45720 //
     /*   72632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   72635 */     // MIs[0] rs1
     /*   72635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72643 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   72643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*   72660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   72673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72680 */     GIR_RootConstrainSelectedInstOperands,
     /*   72681 */     // GIR_Coverage, 45720,
     /*   72681 */     GIR_EraseRootFromParent_Done,
     /*   72682 */   // Label 1920: @72682
     /*   72682 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(72737), // Rule ID 45721 //
     /*   72687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   72690 */     // MIs[0] rs1
     /*   72690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72698 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   72698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*   72715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   72728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72735 */     GIR_RootConstrainSelectedInstOperands,
     /*   72736 */     // GIR_Coverage, 45721,
     /*   72736 */     GIR_EraseRootFromParent_Done,
     /*   72737 */   // Label 1921: @72737
     /*   72737 */   GIM_Reject,
     /*   72738 */ // Label 1917: @72738
     /*   72738 */ GIM_Reject,
     /*   72739 */ // Label 1758: @72739
     /*   72739 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(72976),
     /*   72744 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   72755 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(72810), // Rule ID 45676 //
     /*   72760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72763 */     // MIs[0] rs1
     /*   72763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72771 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   72774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*   72788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72808 */     GIR_RootConstrainSelectedInstOperands,
     /*   72809 */     // GIR_Coverage, 45676,
     /*   72809 */     GIR_EraseRootFromParent_Done,
     /*   72810 */   // Label 1923: @72810
     /*   72810 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(72865), // Rule ID 45677 //
     /*   72815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72818 */     // MIs[0] rs1
     /*   72818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72826 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   72829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*   72843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72863 */     GIR_RootConstrainSelectedInstOperands,
     /*   72864 */     // GIR_Coverage, 45677,
     /*   72864 */     GIR_EraseRootFromParent_Done,
     /*   72865 */   // Label 1924: @72865
     /*   72865 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(72920), // Rule ID 45736 //
     /*   72870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   72873 */     // MIs[0] rs1
     /*   72873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   72877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72881 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   72884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*   72898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72918 */     GIR_RootConstrainSelectedInstOperands,
     /*   72919 */     // GIR_Coverage, 45736,
     /*   72919 */     GIR_EraseRootFromParent_Done,
     /*   72920 */   // Label 1925: @72920
     /*   72920 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(72975), // Rule ID 45737 //
     /*   72925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   72928 */     // MIs[0] rs1
     /*   72928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   72932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   72936 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   72939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*   72953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   72973 */     GIR_RootConstrainSelectedInstOperands,
     /*   72974 */     // GIR_Coverage, 45737,
     /*   72974 */     GIR_EraseRootFromParent_Done,
     /*   72975 */   // Label 1926: @72975
     /*   72975 */   GIM_Reject,
     /*   72976 */ // Label 1922: @72976
     /*   72976 */ GIM_Reject,
     /*   72977 */ // Label 1759: @72977
     /*   72977 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(73096),
     /*   72982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   72985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   72989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   72997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73001 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(73048), // Rule ID 45768 //
     /*   73006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73009 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   73009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*   73012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*   73026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   73039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73046 */     GIR_RootConstrainSelectedInstOperands,
     /*   73047 */     // GIR_Coverage, 45768,
     /*   73047 */     GIR_EraseRootFromParent_Done,
     /*   73048 */   // Label 1928: @73048
     /*   73048 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(73095), // Rule ID 45769 //
     /*   73053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73056 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   73056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*   73059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*   73073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   73086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73093 */     GIR_RootConstrainSelectedInstOperands,
     /*   73094 */     // GIR_Coverage, 45769,
     /*   73094 */     GIR_EraseRootFromParent_Done,
     /*   73095 */   // Label 1929: @73095
     /*   73095 */   GIM_Reject,
     /*   73096 */ // Label 1927: @73096
     /*   73096 */ GIM_Reject,
     /*   73097 */ // Label 1760: @73097
     /*   73097 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(73224),
     /*   73102 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73105 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   73109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73113 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(73168), // Rule ID 45648 //
     /*   73118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73121 */     // MIs[0] rs1
     /*   73121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   73125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73129 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   73132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*   73146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73166 */     GIR_RootConstrainSelectedInstOperands,
     /*   73167 */     // GIR_Coverage, 45648,
     /*   73167 */     GIR_EraseRootFromParent_Done,
     /*   73168 */   // Label 1931: @73168
     /*   73168 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(73223), // Rule ID 45649 //
     /*   73173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73176 */     // MIs[0] rs1
     /*   73176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   73180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73184 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   73187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*   73201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73221 */     GIR_RootConstrainSelectedInstOperands,
     /*   73222 */     // GIR_Coverage, 45649,
     /*   73222 */     GIR_EraseRootFromParent_Done,
     /*   73223 */   // Label 1932: @73223
     /*   73223 */   GIM_Reject,
     /*   73224 */ // Label 1930: @73224
     /*   73224 */ GIM_Reject,
     /*   73225 */ // Label 1761: @73225
     /*   73225 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(73462),
     /*   73230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   73237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   73241 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(73296), // Rule ID 45664 //
     /*   73246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73249 */     // MIs[0] rs1
     /*   73249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   73253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73257 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   73260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*   73274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73294 */     GIR_RootConstrainSelectedInstOperands,
     /*   73295 */     // GIR_Coverage, 45664,
     /*   73295 */     GIR_EraseRootFromParent_Done,
     /*   73296 */   // Label 1934: @73296
     /*   73296 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(73351), // Rule ID 45665 //
     /*   73301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73304 */     // MIs[0] rs1
     /*   73304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   73308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73312 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   73315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*   73329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73349 */     GIR_RootConstrainSelectedInstOperands,
     /*   73350 */     // GIR_Coverage, 45665,
     /*   73350 */     GIR_EraseRootFromParent_Done,
     /*   73351 */   // Label 1935: @73351
     /*   73351 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(73406), // Rule ID 45724 //
     /*   73356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   73359 */     // MIs[0] rs1
     /*   73359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   73363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73367 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   73370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*   73384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73404 */     GIR_RootConstrainSelectedInstOperands,
     /*   73405 */     // GIR_Coverage, 45724,
     /*   73405 */     GIR_EraseRootFromParent_Done,
     /*   73406 */   // Label 1936: @73406
     /*   73406 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(73461), // Rule ID 45725 //
     /*   73411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   73414 */     // MIs[0] rs1
     /*   73414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   73418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73422 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   73425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*   73439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73459 */     GIR_RootConstrainSelectedInstOperands,
     /*   73460 */     // GIR_Coverage, 45725,
     /*   73460 */     GIR_EraseRootFromParent_Done,
     /*   73461 */   // Label 1937: @73461
     /*   73461 */   GIM_Reject,
     /*   73462 */ // Label 1933: @73462
     /*   73462 */ GIM_Reject,
     /*   73463 */ // Label 1762: @73463
     /*   73463 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(73582),
     /*   73468 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73471 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   73475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73487 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(73534), // Rule ID 45772 //
     /*   73492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73495 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*   73495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*   73498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*   73512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   73525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73532 */     GIR_RootConstrainSelectedInstOperands,
     /*   73533 */     // GIR_Coverage, 45772,
     /*   73533 */     GIR_EraseRootFromParent_Done,
     /*   73534 */   // Label 1939: @73534
     /*   73534 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(73581), // Rule ID 45773 //
     /*   73539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73542 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*   73542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*   73545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*   73559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   73572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73579 */     GIR_RootConstrainSelectedInstOperands,
     /*   73580 */     // GIR_Coverage, 45773,
     /*   73580 */     GIR_EraseRootFromParent_Done,
     /*   73581 */   // Label 1940: @73581
     /*   73581 */   GIM_Reject,
     /*   73582 */ // Label 1938: @73582
     /*   73582 */ GIM_Reject,
     /*   73583 */ // Label 1763: @73583
     /*   73583 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(73710),
     /*   73588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   73595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   73599 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(73654), // Rule ID 45652 //
     /*   73604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73607 */     // MIs[0] rs1
     /*   73607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   73611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73615 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   73618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*   73632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73652 */     GIR_RootConstrainSelectedInstOperands,
     /*   73653 */     // GIR_Coverage, 45652,
     /*   73653 */     GIR_EraseRootFromParent_Done,
     /*   73654 */   // Label 1942: @73654
     /*   73654 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(73709), // Rule ID 45653 //
     /*   73659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73662 */     // MIs[0] rs1
     /*   73662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   73666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73670 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   73673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*   73687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73707 */     GIR_RootConstrainSelectedInstOperands,
     /*   73708 */     // GIR_Coverage, 45653,
     /*   73708 */     GIR_EraseRootFromParent_Done,
     /*   73709 */   // Label 1943: @73709
     /*   73709 */   GIM_Reject,
     /*   73710 */ // Label 1941: @73710
     /*   73710 */ GIM_Reject,
     /*   73711 */ // Label 1764: @73711
     /*   73711 */ GIM_Reject,
     /*   73712 */ // Label 22: @73712
     /*   73712 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1946*/ GIMT_Encode4(74006),
     /*   73723 */ /*GILLT_s32*//*Label 1944*/ GIMT_Encode4(73731),
     /*   73727 */ /*GILLT_s64*//*Label 1945*/ GIMT_Encode4(73843),
     /*   73731 */ // Label 1944: @73731
     /*   73731 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(73842),
     /*   73736 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73739 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(73790), // Rule ID 225 //
     /*   73744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   73747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   73754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   73769 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   73769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   73772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   73779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   73784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73788 */     GIR_RootConstrainSelectedInstOperands,
     /*   73789 */     // GIR_Coverage, 225,
     /*   73789 */     GIR_EraseRootFromParent_Done,
     /*   73790 */   // Label 1948: @73790
     /*   73790 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(73841), // Rule ID 229 //
     /*   73795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   73798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   73805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   73820 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   73820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   73823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   73830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   73835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73839 */     GIR_RootConstrainSelectedInstOperands,
     /*   73840 */     // GIR_Coverage, 229,
     /*   73840 */     GIR_EraseRootFromParent_Done,
     /*   73841 */   // Label 1949: @73841
     /*   73841 */   GIM_Reject,
     /*   73842 */ // Label 1947: @73842
     /*   73842 */ GIM_Reject,
     /*   73843 */ // Label 1945: @73843
     /*   73843 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(74005),
     /*   73848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   73851 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(73902), // Rule ID 224 //
     /*   73856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   73859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   73866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   73881 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   73881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*   73884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   73891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   73896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73900 */     GIR_RootConstrainSelectedInstOperands,
     /*   73901 */     // GIR_Coverage, 224,
     /*   73901 */     GIR_EraseRootFromParent_Done,
     /*   73902 */   // Label 1951: @73902
     /*   73902 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(73953), // Rule ID 228 //
     /*   73907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   73910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   73917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   73932 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   73932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*   73935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   73942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   73947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   73951 */     GIR_RootConstrainSelectedInstOperands,
     /*   73952 */     // GIR_Coverage, 228,
     /*   73952 */     GIR_EraseRootFromParent_Done,
     /*   73953 */   // Label 1952: @73953
     /*   73953 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(74004), // Rule ID 274 //
     /*   73958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   73961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   73968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   73972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   73976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   73983 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   73983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*   73986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   73993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   73998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74002 */     GIR_RootConstrainSelectedInstOperands,
     /*   74003 */     // GIR_Coverage, 274,
     /*   74003 */     GIR_EraseRootFromParent_Done,
     /*   74004 */   // Label 1953: @74004
     /*   74004 */   GIM_Reject,
     /*   74005 */ // Label 1950: @74005
     /*   74005 */ GIM_Reject,
     /*   74006 */ // Label 1946: @74006
     /*   74006 */ GIM_Reject,
     /*   74007 */ // Label 23: @74007
     /*   74007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1956*/ GIMT_Encode4(74301),
     /*   74018 */ /*GILLT_s32*//*Label 1954*/ GIMT_Encode4(74026),
     /*   74022 */ /*GILLT_s64*//*Label 1955*/ GIMT_Encode4(74138),
     /*   74026 */ // Label 1954: @74026
     /*   74026 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(74137),
     /*   74031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74034 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(74085), // Rule ID 235 //
     /*   74039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   74042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   74049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74064 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   74067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74083 */     GIR_RootConstrainSelectedInstOperands,
     /*   74084 */     // GIR_Coverage, 235,
     /*   74084 */     GIR_EraseRootFromParent_Done,
     /*   74085 */   // Label 1958: @74085
     /*   74085 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(74136), // Rule ID 237 //
     /*   74090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   74093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   74100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74115 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*   74118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74134 */     GIR_RootConstrainSelectedInstOperands,
     /*   74135 */     // GIR_Coverage, 237,
     /*   74135 */     GIR_EraseRootFromParent_Done,
     /*   74136 */   // Label 1959: @74136
     /*   74136 */   GIM_Reject,
     /*   74137 */ // Label 1957: @74137
     /*   74137 */ GIM_Reject,
     /*   74138 */ // Label 1955: @74138
     /*   74138 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(74300),
     /*   74143 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74146 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(74197), // Rule ID 234 //
     /*   74151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   74154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   74161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74176 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*   74179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74195 */     GIR_RootConstrainSelectedInstOperands,
     /*   74196 */     // GIR_Coverage, 234,
     /*   74196 */     GIR_EraseRootFromParent_Done,
     /*   74197 */   // Label 1961: @74197
     /*   74197 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(74248), // Rule ID 236 //
     /*   74202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   74205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   74212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74227 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*   74230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74246 */     GIR_RootConstrainSelectedInstOperands,
     /*   74247 */     // GIR_Coverage, 236,
     /*   74247 */     GIR_EraseRootFromParent_Done,
     /*   74248 */   // Label 1962: @74248
     /*   74248 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(74299), // Rule ID 276 //
     /*   74253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   74256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   74263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74278 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*   74281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74297 */     GIR_RootConstrainSelectedInstOperands,
     /*   74298 */     // GIR_Coverage, 276,
     /*   74298 */     GIR_EraseRootFromParent_Done,
     /*   74299 */   // Label 1963: @74299
     /*   74299 */   GIM_Reject,
     /*   74300 */ // Label 1960: @74300
     /*   74300 */ GIM_Reject,
     /*   74301 */ // Label 1956: @74301
     /*   74301 */ GIM_Reject,
     /*   74302 */ // Label 24: @74302
     /*   74302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 1998*/ GIMT_Encode4(81099),
     /*   74313 */ /*GILLT_p0s32*//*Label 1964*/ GIMT_Encode4(74449),
     /*   74317 */ /*GILLT_p0s64*//*Label 1965*/ GIMT_Encode4(74543),
     /*   74321 */ /*GILLT_s16*//*Label 1966*/ GIMT_Encode4(74637),
     /*   74325 */ /*GILLT_s32*//*Label 1967*/ GIMT_Encode4(75276),
     /*   74329 */ /*GILLT_s64*//*Label 1968*/ GIMT_Encode4(76578),
     /*   74333 */ /*GILLT_nxv1s1*//*Label 1969*/ GIMT_Encode4(77553),
     /*   74337 */ /*GILLT_nxv1s8*//*Label 1970*/ GIMT_Encode4(77633),
     /*   74341 */ /*GILLT_nxv1s16*//*Label 1971*/ GIMT_Encode4(77721),
     /*   74345 */ /*GILLT_nxv1s32*//*Label 1972*/ GIMT_Encode4(77879),
     /*   74349 */ /*GILLT_nxv1s64*//*Label 1973*/ GIMT_Encode4(78037),
     /*   74353 */ /*GILLT_nxv2s1*//*Label 1974*/ GIMT_Encode4(78195),
     /*   74357 */ /*GILLT_nxv2s8*//*Label 1975*/ GIMT_Encode4(78275),
     /*   74361 */ /*GILLT_nxv2s16*//*Label 1976*/ GIMT_Encode4(78363),
     /*   74365 */ /*GILLT_nxv2s32*//*Label 1977*/ GIMT_Encode4(78521),
     /*   74369 */ /*GILLT_nxv2s64*//*Label 1978*/ GIMT_Encode4(78679),
     /*   74373 */ /*GILLT_nxv4s1*//*Label 1979*/ GIMT_Encode4(78837),
     /*   74377 */ /*GILLT_nxv4s8*//*Label 1980*/ GIMT_Encode4(78917),
     /*   74381 */ /*GILLT_nxv4s16*//*Label 1981*/ GIMT_Encode4(79005),
     /*   74385 */ /*GILLT_nxv4s32*//*Label 1982*/ GIMT_Encode4(79163),
     /*   74389 */ /*GILLT_nxv4s64*//*Label 1983*/ GIMT_Encode4(79321),
     /*   74393 */ /*GILLT_nxv8s1*//*Label 1984*/ GIMT_Encode4(79479),
     /*   74397 */ /*GILLT_nxv8s8*//*Label 1985*/ GIMT_Encode4(79559),
     /*   74401 */ /*GILLT_nxv8s16*//*Label 1986*/ GIMT_Encode4(79647),
     /*   74405 */ /*GILLT_nxv8s32*//*Label 1987*/ GIMT_Encode4(79805),
     /*   74409 */ /*GILLT_nxv8s64*//*Label 1988*/ GIMT_Encode4(79963),
     /*   74413 */ /*GILLT_nxv16s1*//*Label 1989*/ GIMT_Encode4(80121),
     /*   74417 */ /*GILLT_nxv16s8*//*Label 1990*/ GIMT_Encode4(80201),
     /*   74421 */ /*GILLT_nxv16s16*//*Label 1991*/ GIMT_Encode4(80289),
     /*   74425 */ /*GILLT_nxv16s32*//*Label 1992*/ GIMT_Encode4(80447),
     /*   74429 */ /*GILLT_nxv32s1*//*Label 1993*/ GIMT_Encode4(80605),
     /*   74433 */ /*GILLT_nxv32s8*//*Label 1994*/ GIMT_Encode4(80685),
     /*   74437 */ /*GILLT_nxv32s16*//*Label 1995*/ GIMT_Encode4(80773),
     /*   74441 */ /*GILLT_nxv64s1*//*Label 1996*/ GIMT_Encode4(80931),
     /*   74445 */ /*GILLT_nxv64s8*//*Label 1997*/ GIMT_Encode4(81011),
     /*   74449 */ // Label 1964: @74449
     /*   74449 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(74542),
     /*   74454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   74461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74469 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(74505), // Rule ID 63928 //
     /*   74474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   74477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74484 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   74487 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74503 */     GIR_RootConstrainSelectedInstOperands,
     /*   74504 */     // GIR_Coverage, 63928,
     /*   74504 */     GIR_EraseRootFromParent_Done,
     /*   74505 */   // Label 2000: @74505
     /*   74505 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(74541), // Rule ID 63932 //
     /*   74510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   74513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74520 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*   74523 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74539 */     GIR_RootConstrainSelectedInstOperands,
     /*   74540 */     // GIR_Coverage, 63932,
     /*   74540 */     GIR_EraseRootFromParent_Done,
     /*   74541 */   // Label 2001: @74541
     /*   74541 */   GIM_Reject,
     /*   74542 */ // Label 1999: @74542
     /*   74542 */ GIM_Reject,
     /*   74543 */ // Label 1965: @74543
     /*   74543 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(74636),
     /*   74548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   74555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74563 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(74599), // Rule ID 63927 //
     /*   74568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   74571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74578 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   74581 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74597 */     GIR_RootConstrainSelectedInstOperands,
     /*   74598 */     // GIR_Coverage, 63927,
     /*   74598 */     GIR_EraseRootFromParent_Done,
     /*   74599 */   // Label 2003: @74599
     /*   74599 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(74635), // Rule ID 63931 //
     /*   74604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   74607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74614 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*   74617 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74633 */     GIR_RootConstrainSelectedInstOperands,
     /*   74634 */     // GIR_Coverage, 63931,
     /*   74634 */     GIR_EraseRootFromParent_Done,
     /*   74635 */   // Label 2004: @74635
     /*   74635 */   GIM_Reject,
     /*   74636 */ // Label 2002: @74636
     /*   74636 */ GIM_Reject,
     /*   74637 */ // Label 1966: @74637
     /*   74637 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(74691), // Rule ID 63945 //
     /*   74642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   74645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   74648 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   74655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74670 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   74673 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74689 */   GIR_RootConstrainSelectedInstOperands,
     /*   74690 */   // GIR_Coverage, 63945,
     /*   74690 */   GIR_EraseRootFromParent_Done,
     /*   74691 */ // Label 2005: @74691
     /*   74691 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(74745), // Rule ID 63946 //
     /*   74696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   74699 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   74702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   74709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74717 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74724 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   74727 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74743 */   GIR_RootConstrainSelectedInstOperands,
     /*   74744 */   // GIR_Coverage, 63946,
     /*   74744 */   GIR_EraseRootFromParent_Done,
     /*   74745 */ // Label 2006: @74745
     /*   74745 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(74799), // Rule ID 63947 //
     /*   74750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   74753 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   74756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   74763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74767 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74778 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   74781 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74797 */   GIR_RootConstrainSelectedInstOperands,
     /*   74798 */   // GIR_Coverage, 63947,
     /*   74798 */   GIR_EraseRootFromParent_Done,
     /*   74799 */ // Label 2007: @74799
     /*   74799 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(74853), // Rule ID 63948 //
     /*   74804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   74807 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   74810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   74817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   74821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74832 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   74835 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74851 */   GIR_RootConstrainSelectedInstOperands,
     /*   74852 */   // GIR_Coverage, 63948,
     /*   74852 */   GIR_EraseRootFromParent_Done,
     /*   74853 */ // Label 2008: @74853
     /*   74853 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(74904), // Rule ID 2010 //
     /*   74858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*   74861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74864 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   74868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   74872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74883 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*   74886 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74902 */   GIR_RootConstrainSelectedInstOperands,
     /*   74903 */   // GIR_Coverage, 2010,
     /*   74903 */   GIR_EraseRootFromParent_Done,
     /*   74904 */ // Label 2009: @74904
     /*   74904 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(74955), // Rule ID 2011 //
     /*   74909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*   74912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   74919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*   74923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74934 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   74934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*   74937 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   74949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   74953 */   GIR_RootConstrainSelectedInstOperands,
     /*   74954 */   // GIR_Coverage, 2011,
     /*   74954 */   GIR_EraseRootFromParent_Done,
     /*   74955 */ // Label 2010: @74955
     /*   74955 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(75006), // Rule ID 2016 //
     /*   74960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*   74963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   74966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   74970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   74974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   74978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   74985 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   74985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*   74988 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   74990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   74995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75004 */   GIR_RootConstrainSelectedInstOperands,
     /*   75005 */   // GIR_Coverage, 2016,
     /*   75005 */   GIR_EraseRootFromParent_Done,
     /*   75006 */ // Label 2011: @75006
     /*   75006 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(75057), // Rule ID 2017 //
     /*   75011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*   75014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*   75025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75036 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*   75039 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75055 */   GIR_RootConstrainSelectedInstOperands,
     /*   75056 */   // GIR_Coverage, 2017,
     /*   75056 */   GIR_EraseRootFromParent_Done,
     /*   75057 */ // Label 2012: @75057
     /*   75057 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(75108), // Rule ID 63935 //
     /*   75062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   75065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75087 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   75090 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75106 */   GIR_RootConstrainSelectedInstOperands,
     /*   75107 */   // GIR_Coverage, 63935,
     /*   75107 */   GIR_EraseRootFromParent_Done,
     /*   75108 */ // Label 2013: @75108
     /*   75108 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(75159), // Rule ID 63936 //
     /*   75113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   75116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75138 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   75141 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75157 */   GIR_RootConstrainSelectedInstOperands,
     /*   75158 */   // GIR_Coverage, 63936,
     /*   75158 */   GIR_EraseRootFromParent_Done,
     /*   75159 */ // Label 2014: @75159
     /*   75159 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(75217), // Rule ID 63939 //
     /*   75164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   75167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75170 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   75181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75196 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   75199 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75215 */   GIR_RootConstrainSelectedInstOperands,
     /*   75216 */   // GIR_Coverage, 63939,
     /*   75216 */   GIR_EraseRootFromParent_Done,
     /*   75217 */ // Label 2015: @75217
     /*   75217 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(75275), // Rule ID 63940 //
     /*   75222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   75225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   75239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75254 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   75257 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75273 */   GIR_RootConstrainSelectedInstOperands,
     /*   75274 */   // GIR_Coverage, 63940,
     /*   75274 */   GIR_EraseRootFromParent_Done,
     /*   75275 */ // Label 2016: @75275
     /*   75275 */ GIM_Reject,
     /*   75276 */ // Label 1967: @75276
     /*   75276 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(75333), // Rule ID 318 //
     /*   75281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   75284 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   75287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   75294 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   75297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75312 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_9756>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   75315 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75331 */   GIR_RootConstrainSelectedInstOperands,
     /*   75332 */   // GIR_Coverage, 318,
     /*   75332 */   GIR_EraseRootFromParent_Done,
     /*   75333 */ // Label 2017: @75333
     /*   75333 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(75390), // Rule ID 320 //
     /*   75338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   75341 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   75344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   75351 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   75354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75369 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_9758>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   75372 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75388 */   GIR_RootConstrainSelectedInstOperands,
     /*   75389 */   // GIR_Coverage, 320,
     /*   75389 */   GIR_EraseRootFromParent_Done,
     /*   75390 */ // Label 2018: @75390
     /*   75390 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(75447), // Rule ID 322 //
     /*   75395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*   75398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   75401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   75408 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   75411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75426 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_9760>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   75429 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75445 */   GIR_RootConstrainSelectedInstOperands,
     /*   75446 */   // GIR_Coverage, 322,
     /*   75446 */   GIR_EraseRootFromParent_Done,
     /*   75447 */ // Label 2019: @75447
     /*   75447 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(75501), // Rule ID 63951 //
     /*   75452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*   75455 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   75458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   75465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75480 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   75483 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75499 */   GIR_RootConstrainSelectedInstOperands,
     /*   75500 */   // GIR_Coverage, 63951,
     /*   75500 */   GIR_EraseRootFromParent_Done,
     /*   75501 */ // Label 2020: @75501
     /*   75501 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(75555), // Rule ID 63952 //
     /*   75506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*   75509 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   75512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   75519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75534 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   75537 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75553 */   GIR_RootConstrainSelectedInstOperands,
     /*   75554 */   // GIR_Coverage, 63952,
     /*   75554 */   GIR_EraseRootFromParent_Done,
     /*   75555 */ // Label 2021: @75555
     /*   75555 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(75613), // Rule ID 239 //
     /*   75560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   75563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75566 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   75577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75592 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   75595 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75611 */   GIR_RootConstrainSelectedInstOperands,
     /*   75612 */   // GIR_Coverage, 239,
     /*   75612 */   GIR_EraseRootFromParent_Done,
     /*   75613 */ // Label 2022: @75613
     /*   75613 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(75671), // Rule ID 241 //
     /*   75618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   75621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75624 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   75635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75650 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   75653 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75669 */   GIR_RootConstrainSelectedInstOperands,
     /*   75670 */   // GIR_Coverage, 241,
     /*   75670 */   GIR_EraseRootFromParent_Done,
     /*   75671 */ // Label 2023: @75671
     /*   75671 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(75722), // Rule ID 242 //
     /*   75676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   75679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75701 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   75704 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75720 */   GIR_RootConstrainSelectedInstOperands,
     /*   75721 */   // GIR_Coverage, 242,
     /*   75721 */   GIR_EraseRootFromParent_Done,
     /*   75722 */ // Label 2024: @75722
     /*   75722 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(75773), // Rule ID 243 //
     /*   75727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   75730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   75741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75752 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   75755 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75771 */   GIR_RootConstrainSelectedInstOperands,
     /*   75772 */   // GIR_Coverage, 243,
     /*   75772 */   GIR_EraseRootFromParent_Done,
     /*   75773 */ // Label 2025: @75773
     /*   75773 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(75824), // Rule ID 1297 //
     /*   75778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*   75781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   75792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75803 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*   75806 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75822 */   GIR_RootConstrainSelectedInstOperands,
     /*   75823 */   // GIR_Coverage, 1297,
     /*   75823 */   GIR_EraseRootFromParent_Done,
     /*   75824 */ // Label 2026: @75824
     /*   75824 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(75875), // Rule ID 1298 //
     /*   75829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*   75832 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75835 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*   75843 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75847 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75854 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*   75857 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75873 */   GIR_RootConstrainSelectedInstOperands,
     /*   75874 */   // GIR_Coverage, 1298,
     /*   75874 */   GIR_EraseRootFromParent_Done,
     /*   75875 */ // Label 2027: @75875
     /*   75875 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(75926), // Rule ID 1303 //
     /*   75880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*   75883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   75894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75905 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   75905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*   75908 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75924 */   GIR_RootConstrainSelectedInstOperands,
     /*   75925 */   // GIR_Coverage, 1303,
     /*   75925 */   GIR_EraseRootFromParent_Done,
     /*   75926 */ // Label 2028: @75926
     /*   75926 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(75977), // Rule ID 1304 //
     /*   75931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*   75934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75937 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*   75945 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   75949 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   75956 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   75956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*   75959 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   75961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   75966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   75971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   75975 */   GIR_RootConstrainSelectedInstOperands,
     /*   75976 */   // GIR_Coverage, 1304,
     /*   75976 */   GIR_EraseRootFromParent_Done,
     /*   75977 */ // Label 2029: @75977
     /*   75977 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(76035), // Rule ID 63957 //
     /*   75982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   75985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   75988 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   75992 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   75999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76003 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76014 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   76017 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76029 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76033 */   GIR_RootConstrainSelectedInstOperands,
     /*   76034 */   // GIR_Coverage, 63957,
     /*   76034 */   GIR_EraseRootFromParent_Done,
     /*   76035 */ // Label 2030: @76035
     /*   76035 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(76093), // Rule ID 63958 //
     /*   76040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   76043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76046 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   76057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76072 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   76072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   76075 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76091 */   GIR_RootConstrainSelectedInstOperands,
     /*   76092 */   // GIR_Coverage, 63958,
     /*   76092 */   GIR_EraseRootFromParent_Done,
     /*   76093 */ // Label 2031: @76093
     /*   76093 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(76151), // Rule ID 63959 //
     /*   76098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   76101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76104 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76130 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   76133 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76149 */   GIR_RootConstrainSelectedInstOperands,
     /*   76150 */   // GIR_Coverage, 63959,
     /*   76150 */   GIR_EraseRootFromParent_Done,
     /*   76151 */ // Label 2032: @76151
     /*   76151 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(76209), // Rule ID 63960 //
     /*   76156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*   76159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76188 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   76188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   76191 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76207 */   GIR_RootConstrainSelectedInstOperands,
     /*   76208 */   // GIR_Coverage, 63960,
     /*   76208 */   GIR_EraseRootFromParent_Done,
     /*   76209 */ // Label 2033: @76209
     /*   76209 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(76255), // Rule ID 1086 //
     /*   76214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76217 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76220 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   76227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76234 */   // MIs[0] rs1
     /*   76234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76242 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10258>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*   76245 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76247 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76253 */   GIR_RootConstrainSelectedInstOperands,
     /*   76254 */   // GIR_Coverage, 1086,
     /*   76254 */   GIR_EraseRootFromParent_Done,
     /*   76255 */ // Label 2034: @76255
     /*   76255 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(76301), // Rule ID 1088 //
     /*   76260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76263 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76266 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   76273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   76276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76280 */   // MIs[0] rs1
     /*   76280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76288 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10260>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*   76291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76293 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76299 */   GIR_RootConstrainSelectedInstOperands,
     /*   76300 */   // GIR_Coverage, 1088,
     /*   76300 */   GIR_EraseRootFromParent_Done,
     /*   76301 */ // Label 2035: @76301
     /*   76301 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(76347), // Rule ID 1090 //
     /*   76306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76309 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76312 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76326 */   // MIs[0] rs1
     /*   76326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76334 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10262>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*   76337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76339 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76345 */   GIR_RootConstrainSelectedInstOperands,
     /*   76346 */   // GIR_Coverage, 1090,
     /*   76346 */   GIR_EraseRootFromParent_Done,
     /*   76347 */ // Label 2036: @76347
     /*   76347 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(76393), // Rule ID 1092 //
     /*   76352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76355 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   76368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76372 */   // MIs[0] rs1
     /*   76372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76380 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10264>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*   76383 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76385 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76391 */   GIR_RootConstrainSelectedInstOperands,
     /*   76392 */   // GIR_Coverage, 1092,
     /*   76392 */   GIR_EraseRootFromParent_Done,
     /*   76393 */ // Label 2037: @76393
     /*   76393 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(76439), // Rule ID 1094 //
     /*   76398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76401 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   76411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76418 */   // MIs[0] rs1
     /*   76418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76426 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10266>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*   76429 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76431 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76437 */   GIR_RootConstrainSelectedInstOperands,
     /*   76438 */   // GIR_Coverage, 1094,
     /*   76438 */   GIR_EraseRootFromParent_Done,
     /*   76439 */ // Label 2038: @76439
     /*   76439 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(76485), // Rule ID 1096 //
     /*   76444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*   76447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   76457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   76460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76464 */   // MIs[0] rs1
     /*   76464 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76472 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10268>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*   76475 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76477 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76483 */   GIR_RootConstrainSelectedInstOperands,
     /*   76484 */   // GIR_Coverage, 1096,
     /*   76484 */   GIR_EraseRootFromParent_Done,
     /*   76485 */ // Label 2039: @76485
     /*   76485 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(76531), // Rule ID 1102 //
     /*   76490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*   76493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   76503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76510 */   // MIs[0] rs1
     /*   76510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76518 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10274>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*   76521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76523 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76529 */   GIR_RootConstrainSelectedInstOperands,
     /*   76530 */   // GIR_Coverage, 1102,
     /*   76530 */   GIR_EraseRootFromParent_Done,
     /*   76531 */ // Label 2040: @76531
     /*   76531 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(76577), // Rule ID 1104 //
     /*   76536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*   76539 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   76549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   76552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76556 */   // MIs[0] rs1
     /*   76556 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   76560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76564 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10276>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*   76567 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76569 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76575 */   GIR_RootConstrainSelectedInstOperands,
     /*   76576 */   // GIR_Coverage, 1104,
     /*   76576 */   GIR_EraseRootFromParent_Done,
     /*   76577 */ // Label 2041: @76577
     /*   76577 */ GIM_Reject,
     /*   76578 */ // Label 1968: @76578
     /*   76578 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(76635), // Rule ID 317 //
     /*   76583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   76586 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   76596 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76603 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76607 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76614 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_9756>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   76617 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76633 */   GIR_RootConstrainSelectedInstOperands,
     /*   76634 */   // GIR_Coverage, 317,
     /*   76634 */   GIR_EraseRootFromParent_Done,
     /*   76635 */ // Label 2042: @76635
     /*   76635 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(76692), // Rule ID 319 //
     /*   76640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   76643 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76653 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76671 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_9758>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   76674 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76690 */   GIR_RootConstrainSelectedInstOperands,
     /*   76691 */   // GIR_Coverage, 319,
     /*   76691 */   GIR_EraseRootFromParent_Done,
     /*   76692 */ // Label 2043: @76692
     /*   76692 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(76749), // Rule ID 321 //
     /*   76697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*   76700 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76703 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   76710 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76728 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_9760>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   76731 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76747 */   GIR_RootConstrainSelectedInstOperands,
     /*   76748 */   // GIR_Coverage, 321,
     /*   76748 */   GIR_EraseRootFromParent_Done,
     /*   76749 */ // Label 2044: @76749
     /*   76749 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(76806), // Rule ID 324 //
     /*   76754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*   76757 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   76760 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   76767 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   76770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76785 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_9764>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*   76788 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76804 */   GIR_RootConstrainSelectedInstOperands,
     /*   76805 */   // GIR_Coverage, 324,
     /*   76805 */   GIR_EraseRootFromParent_Done,
     /*   76806 */ // Label 2045: @76806
     /*   76806 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(76864), // Rule ID 238 //
     /*   76811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   76814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76817 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   76828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76843 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*   76846 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76862 */   GIR_RootConstrainSelectedInstOperands,
     /*   76863 */   // GIR_Coverage, 238,
     /*   76863 */   GIR_EraseRootFromParent_Done,
     /*   76864 */ // Label 2046: @76864
     /*   76864 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(76922), // Rule ID 240 //
     /*   76869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   76872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   76886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76901 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*   76904 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76920 */   GIR_RootConstrainSelectedInstOperands,
     /*   76921 */   // GIR_Coverage, 240,
     /*   76921 */   GIR_EraseRootFromParent_Done,
     /*   76922 */ // Label 2047: @76922
     /*   76922 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(76980), // Rule ID 278 //
     /*   76927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   76930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76933 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   76944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   76952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   76959 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   76959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*   76962 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   76964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   76969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   76974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   76978 */   GIR_RootConstrainSelectedInstOperands,
     /*   76979 */   // GIR_Coverage, 278,
     /*   76979 */   GIR_EraseRootFromParent_Done,
     /*   76980 */ // Label 2048: @76980
     /*   76980 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(77031), // Rule ID 279 //
     /*   76985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   76988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   76991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   76995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   77003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   77010 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   77010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*   77013 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   77020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   77025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77029 */   GIR_RootConstrainSelectedInstOperands,
     /*   77030 */   // GIR_Coverage, 279,
     /*   77030 */   GIR_EraseRootFromParent_Done,
     /*   77031 */ // Label 2049: @77031
     /*   77031 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(77082), // Rule ID 1695 //
     /*   77036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*   77039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   77050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   77054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   77061 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   77061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*   77064 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   77071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   77076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77080 */   GIR_RootConstrainSelectedInstOperands,
     /*   77081 */   // GIR_Coverage, 1695,
     /*   77081 */   GIR_EraseRootFromParent_Done,
     /*   77082 */ // Label 2050: @77082
     /*   77082 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(77133), // Rule ID 1696 //
     /*   77087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*   77090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*   77101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   77105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   77112 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*   77112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*   77115 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   77122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   77127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77131 */   GIR_RootConstrainSelectedInstOperands,
     /*   77132 */   // GIR_Coverage, 1696,
     /*   77132 */   GIR_EraseRootFromParent_Done,
     /*   77133 */ // Label 2051: @77133
     /*   77133 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(77184), // Rule ID 1699 //
     /*   77138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*   77141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77152 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   77156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*   77163 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*   77163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*   77166 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*   77173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*   77178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77182 */   GIR_RootConstrainSelectedInstOperands,
     /*   77183 */   // GIR_Coverage, 1699,
     /*   77183 */   GIR_EraseRootFromParent_Done,
     /*   77184 */ // Label 2052: @77184
     /*   77184 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(77230), // Rule ID 1085 //
     /*   77189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77192 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77195 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   77202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   77205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77209 */   // MIs[0] rs1
     /*   77209 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77217 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10258>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*   77220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77222 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77228 */   GIR_RootConstrainSelectedInstOperands,
     /*   77229 */   // GIR_Coverage, 1085,
     /*   77229 */   GIR_EraseRootFromParent_Done,
     /*   77230 */ // Label 2053: @77230
     /*   77230 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(77276), // Rule ID 1087 //
     /*   77235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77238 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   77248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   77251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77255 */   // MIs[0] rs1
     /*   77255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77263 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10260>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*   77266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77268 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77274 */   GIR_RootConstrainSelectedInstOperands,
     /*   77275 */   // GIR_Coverage, 1087,
     /*   77275 */   GIR_EraseRootFromParent_Done,
     /*   77276 */ // Label 2054: @77276
     /*   77276 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(77322), // Rule ID 1089 //
     /*   77281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77284 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   77294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   77297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77301 */   // MIs[0] rs1
     /*   77301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77309 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10262>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*   77312 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77314 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77320 */   GIR_RootConstrainSelectedInstOperands,
     /*   77321 */   // GIR_Coverage, 1089,
     /*   77321 */   GIR_EraseRootFromParent_Done,
     /*   77322 */ // Label 2055: @77322
     /*   77322 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(77368), // Rule ID 1091 //
     /*   77327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   77340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   77343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77347 */   // MIs[0] rs1
     /*   77347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77355 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10264>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*   77358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77360 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77366 */   GIR_RootConstrainSelectedInstOperands,
     /*   77367 */   // GIR_Coverage, 1091,
     /*   77367 */   GIR_EraseRootFromParent_Done,
     /*   77368 */ // Label 2056: @77368
     /*   77368 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(77414), // Rule ID 1093 //
     /*   77373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77376 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77379 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   77386 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   77389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77393 */   // MIs[0] rs1
     /*   77393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77401 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10266>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*   77404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77406 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77412 */   GIR_RootConstrainSelectedInstOperands,
     /*   77413 */   // GIR_Coverage, 1093,
     /*   77413 */   GIR_EraseRootFromParent_Done,
     /*   77414 */ // Label 2057: @77414
     /*   77414 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(77460), // Rule ID 1095 //
     /*   77419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*   77422 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77425 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   77432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   77435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77439 */   // MIs[0] rs1
     /*   77439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77447 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10268>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*   77450 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77452 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77458 */   GIR_RootConstrainSelectedInstOperands,
     /*   77459 */   // GIR_Coverage, 1095,
     /*   77459 */   GIR_EraseRootFromParent_Done,
     /*   77460 */ // Label 2058: @77460
     /*   77460 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(77506), // Rule ID 1101 //
     /*   77465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*   77468 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77471 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   77478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   77481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77485 */   // MIs[0] rs1
     /*   77485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77493 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10274>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*   77496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77498 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77504 */   GIR_RootConstrainSelectedInstOperands,
     /*   77505 */   // GIR_Coverage, 1101,
     /*   77505 */   GIR_EraseRootFromParent_Done,
     /*   77506 */ // Label 2059: @77506
     /*   77506 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(77552), // Rule ID 1103 //
     /*   77511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*   77514 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*   77517 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   77524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   77527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77531 */   // MIs[0] rs1
     /*   77531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77539 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10276>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   77539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*   77542 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77544 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77550 */   GIR_RootConstrainSelectedInstOperands,
     /*   77551 */   // GIR_Coverage, 1103,
     /*   77551 */   GIR_EraseRootFromParent_Done,
     /*   77552 */ // Label 2060: @77552
     /*   77552 */ GIM_Reject,
     /*   77553 */ // Label 1969: @77553
     /*   77553 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(77632),
     /*   77558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   77573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77577 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(77604), // Rule ID 45426 //
     /*   77582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77585 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   77585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*   77588 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   77598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77602 */     GIR_RootConstrainSelectedInstOperands,
     /*   77603 */     // GIR_Coverage, 45426,
     /*   77603 */     GIR_EraseRootFromParent_Done,
     /*   77604 */   // Label 2062: @77604
     /*   77604 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(77631), // Rule ID 45427 //
     /*   77609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77612 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   77612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*   77615 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   77625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77629 */     GIR_RootConstrainSelectedInstOperands,
     /*   77630 */     // GIR_Coverage, 45427,
     /*   77630 */     GIR_EraseRootFromParent_Done,
     /*   77631 */   // Label 2063: @77631
     /*   77631 */   GIM_Reject,
     /*   77632 */ // Label 2061: @77632
     /*   77632 */ GIM_Reject,
     /*   77633 */ // Label 1970: @77633
     /*   77633 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(77720),
     /*   77638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77649 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(77684), // Rule ID 45422 //
     /*   77654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77657 */     // MIs[0] rs1
     /*   77657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77665 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   77665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*   77668 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77682 */     GIR_RootConstrainSelectedInstOperands,
     /*   77683 */     // GIR_Coverage, 45422,
     /*   77683 */     GIR_EraseRootFromParent_Done,
     /*   77684 */   // Label 2065: @77684
     /*   77684 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(77719), // Rule ID 45423 //
     /*   77689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77692 */     // MIs[0] rs1
     /*   77692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   77696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77700 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   77700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*   77703 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77717 */     GIR_RootConstrainSelectedInstOperands,
     /*   77718 */     // GIR_Coverage, 45423,
     /*   77718 */     GIR_EraseRootFromParent_Done,
     /*   77719 */   // Label 2066: @77719
     /*   77719 */   GIM_Reject,
     /*   77720 */ // Label 2064: @77720
     /*   77720 */ GIM_Reject,
     /*   77721 */ // Label 1971: @77721
     /*   77721 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(77878),
     /*   77726 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77729 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77737 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(77772), // Rule ID 45618 //
     /*   77742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77745 */     // MIs[0] rs1
     /*   77745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77753 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   77753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*   77756 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77770 */     GIR_RootConstrainSelectedInstOperands,
     /*   77771 */     // GIR_Coverage, 45618,
     /*   77771 */     GIR_EraseRootFromParent_Done,
     /*   77772 */   // Label 2068: @77772
     /*   77772 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(77807), // Rule ID 45619 //
     /*   77777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77780 */     // MIs[0] rs1
     /*   77780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   77784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77788 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   77788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*   77791 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77805 */     GIR_RootConstrainSelectedInstOperands,
     /*   77806 */     // GIR_Coverage, 45619,
     /*   77806 */     GIR_EraseRootFromParent_Done,
     /*   77807 */   // Label 2069: @77807
     /*   77807 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(77842), // Rule ID 45694 //
     /*   77812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   77815 */     // MIs[0] rs1
     /*   77815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77823 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   77823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*   77826 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77840 */     GIR_RootConstrainSelectedInstOperands,
     /*   77841 */     // GIR_Coverage, 45694,
     /*   77841 */     GIR_EraseRootFromParent_Done,
     /*   77842 */   // Label 2070: @77842
     /*   77842 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(77877), // Rule ID 45695 //
     /*   77847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   77850 */     // MIs[0] rs1
     /*   77850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   77854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77858 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   77858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*   77861 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77875 */     GIR_RootConstrainSelectedInstOperands,
     /*   77876 */     // GIR_Coverage, 45695,
     /*   77876 */     GIR_EraseRootFromParent_Done,
     /*   77877 */   // Label 2071: @77877
     /*   77877 */   GIM_Reject,
     /*   77878 */ // Label 2067: @77878
     /*   77878 */ GIM_Reject,
     /*   77879 */ // Label 1972: @77879
     /*   77879 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(78036),
     /*   77884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   77887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   77891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77895 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(77930), // Rule ID 45626 //
     /*   77900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77903 */     // MIs[0] rs1
     /*   77903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77911 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   77911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*   77914 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   77924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77928 */     GIR_RootConstrainSelectedInstOperands,
     /*   77929 */     // GIR_Coverage, 45626,
     /*   77929 */     GIR_EraseRootFromParent_Done,
     /*   77930 */   // Label 2073: @77930
     /*   77930 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(77965), // Rule ID 45627 //
     /*   77935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77938 */     // MIs[0] rs1
     /*   77938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   77942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77946 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   77946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*   77949 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   77959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77963 */     GIR_RootConstrainSelectedInstOperands,
     /*   77964 */     // GIR_Coverage, 45627,
     /*   77964 */     GIR_EraseRootFromParent_Done,
     /*   77965 */   // Label 2074: @77965
     /*   77965 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(78000), // Rule ID 45702 //
     /*   77970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   77973 */     // MIs[0] rs1
     /*   77973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   77977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   77981 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   77981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*   77984 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   77986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   77994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   77998 */     GIR_RootConstrainSelectedInstOperands,
     /*   77999 */     // GIR_Coverage, 45702,
     /*   77999 */     GIR_EraseRootFromParent_Done,
     /*   78000 */   // Label 2075: @78000
     /*   78000 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(78035), // Rule ID 45703 //
     /*   78005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   78008 */     // MIs[0] rs1
     /*   78008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78016 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   78016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*   78019 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78033 */     GIR_RootConstrainSelectedInstOperands,
     /*   78034 */     // GIR_Coverage, 45703,
     /*   78034 */     GIR_EraseRootFromParent_Done,
     /*   78035 */   // Label 2076: @78035
     /*   78035 */   GIM_Reject,
     /*   78036 */ // Label 2072: @78036
     /*   78036 */ GIM_Reject,
     /*   78037 */ // Label 1973: @78037
     /*   78037 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(78194),
     /*   78042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78053 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(78088), // Rule ID 45642 //
     /*   78058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   78061 */     // MIs[0] rs1
     /*   78061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78069 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   78069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*   78072 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78086 */     GIR_RootConstrainSelectedInstOperands,
     /*   78087 */     // GIR_Coverage, 45642,
     /*   78087 */     GIR_EraseRootFromParent_Done,
     /*   78088 */   // Label 2078: @78088
     /*   78088 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(78123), // Rule ID 45643 //
     /*   78093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   78096 */     // MIs[0] rs1
     /*   78096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78104 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   78104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*   78107 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78121 */     GIR_RootConstrainSelectedInstOperands,
     /*   78122 */     // GIR_Coverage, 45643,
     /*   78122 */     GIR_EraseRootFromParent_Done,
     /*   78123 */   // Label 2079: @78123
     /*   78123 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(78158), // Rule ID 45714 //
     /*   78128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   78131 */     // MIs[0] rs1
     /*   78131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78139 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   78139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*   78142 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78156 */     GIR_RootConstrainSelectedInstOperands,
     /*   78157 */     // GIR_Coverage, 45714,
     /*   78157 */     GIR_EraseRootFromParent_Done,
     /*   78158 */   // Label 2080: @78158
     /*   78158 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(78193), // Rule ID 45715 //
     /*   78163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   78166 */     // MIs[0] rs1
     /*   78166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78174 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   78174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*   78177 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78191 */     GIR_RootConstrainSelectedInstOperands,
     /*   78192 */     // GIR_Coverage, 45715,
     /*   78192 */     GIR_EraseRootFromParent_Done,
     /*   78193 */   // Label 2081: @78193
     /*   78193 */   GIM_Reject,
     /*   78194 */ // Label 2077: @78194
     /*   78194 */ GIM_Reject,
     /*   78195 */ // Label 1974: @78195
     /*   78195 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(78274),
     /*   78200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78203 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   78215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78219 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(78246), // Rule ID 45754 //
     /*   78224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78227 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   78227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*   78230 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   78240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78244 */     GIR_RootConstrainSelectedInstOperands,
     /*   78245 */     // GIR_Coverage, 45754,
     /*   78245 */     GIR_EraseRootFromParent_Done,
     /*   78246 */   // Label 2083: @78246
     /*   78246 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(78273), // Rule ID 45755 //
     /*   78251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78254 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   78254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*   78257 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   78267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78271 */     GIR_RootConstrainSelectedInstOperands,
     /*   78272 */     // GIR_Coverage, 45755,
     /*   78272 */     GIR_EraseRootFromParent_Done,
     /*   78273 */   // Label 2084: @78273
     /*   78273 */   GIM_Reject,
     /*   78274 */ // Label 2082: @78274
     /*   78274 */ GIM_Reject,
     /*   78275 */ // Label 1975: @78275
     /*   78275 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(78362),
     /*   78280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78291 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(78326), // Rule ID 45610 //
     /*   78296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78299 */     // MIs[0] rs1
     /*   78299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78307 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   78307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*   78310 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78324 */     GIR_RootConstrainSelectedInstOperands,
     /*   78325 */     // GIR_Coverage, 45610,
     /*   78325 */     GIR_EraseRootFromParent_Done,
     /*   78326 */   // Label 2086: @78326
     /*   78326 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(78361), // Rule ID 45611 //
     /*   78331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78334 */     // MIs[0] rs1
     /*   78334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78342 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   78342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*   78345 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78359 */     GIR_RootConstrainSelectedInstOperands,
     /*   78360 */     // GIR_Coverage, 45611,
     /*   78360 */     GIR_EraseRootFromParent_Done,
     /*   78361 */   // Label 2087: @78361
     /*   78361 */   GIM_Reject,
     /*   78362 */ // Label 2085: @78362
     /*   78362 */ GIM_Reject,
     /*   78363 */ // Label 1976: @78363
     /*   78363 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(78520),
     /*   78368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78379 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(78414), // Rule ID 45622 //
     /*   78384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78387 */     // MIs[0] rs1
     /*   78387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78395 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   78395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*   78398 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78412 */     GIR_RootConstrainSelectedInstOperands,
     /*   78413 */     // GIR_Coverage, 45622,
     /*   78413 */     GIR_EraseRootFromParent_Done,
     /*   78414 */   // Label 2089: @78414
     /*   78414 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(78449), // Rule ID 45623 //
     /*   78419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78422 */     // MIs[0] rs1
     /*   78422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78430 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   78430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*   78433 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78447 */     GIR_RootConstrainSelectedInstOperands,
     /*   78448 */     // GIR_Coverage, 45623,
     /*   78448 */     GIR_EraseRootFromParent_Done,
     /*   78449 */   // Label 2090: @78449
     /*   78449 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(78484), // Rule ID 45698 //
     /*   78454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   78457 */     // MIs[0] rs1
     /*   78457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78465 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   78465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*   78468 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78482 */     GIR_RootConstrainSelectedInstOperands,
     /*   78483 */     // GIR_Coverage, 45698,
     /*   78483 */     GIR_EraseRootFromParent_Done,
     /*   78484 */   // Label 2091: @78484
     /*   78484 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(78519), // Rule ID 45699 //
     /*   78489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   78492 */     // MIs[0] rs1
     /*   78492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78500 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   78500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*   78503 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78517 */     GIR_RootConstrainSelectedInstOperands,
     /*   78518 */     // GIR_Coverage, 45699,
     /*   78518 */     GIR_EraseRootFromParent_Done,
     /*   78519 */   // Label 2092: @78519
     /*   78519 */   GIM_Reject,
     /*   78520 */ // Label 2088: @78520
     /*   78520 */ GIM_Reject,
     /*   78521 */ // Label 1977: @78521
     /*   78521 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(78678),
     /*   78526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78537 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(78572), // Rule ID 45638 //
     /*   78542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78545 */     // MIs[0] rs1
     /*   78545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78553 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   78553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*   78556 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78570 */     GIR_RootConstrainSelectedInstOperands,
     /*   78571 */     // GIR_Coverage, 45638,
     /*   78571 */     GIR_EraseRootFromParent_Done,
     /*   78572 */   // Label 2094: @78572
     /*   78572 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(78607), // Rule ID 45639 //
     /*   78577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78580 */     // MIs[0] rs1
     /*   78580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78588 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   78588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*   78591 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78605 */     GIR_RootConstrainSelectedInstOperands,
     /*   78606 */     // GIR_Coverage, 45639,
     /*   78606 */     GIR_EraseRootFromParent_Done,
     /*   78607 */   // Label 2095: @78607
     /*   78607 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(78642), // Rule ID 45710 //
     /*   78612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   78615 */     // MIs[0] rs1
     /*   78615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78623 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   78623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*   78626 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78640 */     GIR_RootConstrainSelectedInstOperands,
     /*   78641 */     // GIR_Coverage, 45710,
     /*   78641 */     GIR_EraseRootFromParent_Done,
     /*   78642 */   // Label 2096: @78642
     /*   78642 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(78677), // Rule ID 45711 //
     /*   78647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   78650 */     // MIs[0] rs1
     /*   78650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78658 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   78658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*   78661 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78675 */     GIR_RootConstrainSelectedInstOperands,
     /*   78676 */     // GIR_Coverage, 45711,
     /*   78676 */     GIR_EraseRootFromParent_Done,
     /*   78677 */   // Label 2097: @78677
     /*   78677 */   GIM_Reject,
     /*   78678 */ // Label 2093: @78678
     /*   78678 */ GIM_Reject,
     /*   78679 */ // Label 1978: @78679
     /*   78679 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(78836),
     /*   78684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   78695 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(78730), // Rule ID 45682 //
     /*   78700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   78703 */     // MIs[0] rs1
     /*   78703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78711 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   78711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*   78714 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78728 */     GIR_RootConstrainSelectedInstOperands,
     /*   78729 */     // GIR_Coverage, 45682,
     /*   78729 */     GIR_EraseRootFromParent_Done,
     /*   78730 */   // Label 2099: @78730
     /*   78730 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(78765), // Rule ID 45683 //
     /*   78735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   78738 */     // MIs[0] rs1
     /*   78738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78746 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   78746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*   78749 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78763 */     GIR_RootConstrainSelectedInstOperands,
     /*   78764 */     // GIR_Coverage, 45683,
     /*   78764 */     GIR_EraseRootFromParent_Done,
     /*   78765 */   // Label 2100: @78765
     /*   78765 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(78800), // Rule ID 45742 //
     /*   78770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   78773 */     // MIs[0] rs1
     /*   78773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78781 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   78781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*   78784 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78798 */     GIR_RootConstrainSelectedInstOperands,
     /*   78799 */     // GIR_Coverage, 45742,
     /*   78799 */     GIR_EraseRootFromParent_Done,
     /*   78800 */   // Label 2101: @78800
     /*   78800 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(78835), // Rule ID 45743 //
     /*   78805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   78808 */     // MIs[0] rs1
     /*   78808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78816 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   78816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*   78819 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   78829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78833 */     GIR_RootConstrainSelectedInstOperands,
     /*   78834 */     // GIR_Coverage, 45743,
     /*   78834 */     GIR_EraseRootFromParent_Done,
     /*   78835 */   // Label 2102: @78835
     /*   78835 */   GIM_Reject,
     /*   78836 */ // Label 2098: @78836
     /*   78836 */ GIM_Reject,
     /*   78837 */ // Label 1979: @78837
     /*   78837 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(78916),
     /*   78842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   78857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78861 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(78888), // Rule ID 45758 //
     /*   78866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78869 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   78869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*   78872 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   78882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78886 */     GIR_RootConstrainSelectedInstOperands,
     /*   78887 */     // GIR_Coverage, 45758,
     /*   78887 */     GIR_EraseRootFromParent_Done,
     /*   78888 */   // Label 2104: @78888
     /*   78888 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(78915), // Rule ID 45759 //
     /*   78893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78896 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   78896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*   78899 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   78909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78913 */     GIR_RootConstrainSelectedInstOperands,
     /*   78914 */     // GIR_Coverage, 45759,
     /*   78914 */     GIR_EraseRootFromParent_Done,
     /*   78915 */   // Label 2105: @78915
     /*   78915 */   GIM_Reject,
     /*   78916 */ // Label 2103: @78916
     /*   78916 */ GIM_Reject,
     /*   78917 */ // Label 1980: @78917
     /*   78917 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(79004),
     /*   78922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   78925 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   78929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78933 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(78968), // Rule ID 45614 //
     /*   78938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78941 */     // MIs[0] rs1
     /*   78941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   78945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78949 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   78949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*   78952 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   78966 */     GIR_RootConstrainSelectedInstOperands,
     /*   78967 */     // GIR_Coverage, 45614,
     /*   78967 */     GIR_EraseRootFromParent_Done,
     /*   78968 */   // Label 2107: @78968
     /*   78968 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(79003), // Rule ID 45615 //
     /*   78973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78976 */     // MIs[0] rs1
     /*   78976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   78980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   78984 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   78984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*   78987 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   78989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79001 */     GIR_RootConstrainSelectedInstOperands,
     /*   79002 */     // GIR_Coverage, 45615,
     /*   79002 */     GIR_EraseRootFromParent_Done,
     /*   79003 */   // Label 2108: @79003
     /*   79003 */   GIM_Reject,
     /*   79004 */ // Label 2106: @79004
     /*   79004 */ GIM_Reject,
     /*   79005 */ // Label 1981: @79005
     /*   79005 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(79162),
     /*   79010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79021 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(79056), // Rule ID 45634 //
     /*   79026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79029 */     // MIs[0] rs1
     /*   79029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79037 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   79037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*   79040 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79054 */     GIR_RootConstrainSelectedInstOperands,
     /*   79055 */     // GIR_Coverage, 45634,
     /*   79055 */     GIR_EraseRootFromParent_Done,
     /*   79056 */   // Label 2110: @79056
     /*   79056 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(79091), // Rule ID 45635 //
     /*   79061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79064 */     // MIs[0] rs1
     /*   79064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79072 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   79072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*   79075 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79089 */     GIR_RootConstrainSelectedInstOperands,
     /*   79090 */     // GIR_Coverage, 45635,
     /*   79090 */     GIR_EraseRootFromParent_Done,
     /*   79091 */   // Label 2111: @79091
     /*   79091 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(79126), // Rule ID 45706 //
     /*   79096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   79099 */     // MIs[0] rs1
     /*   79099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79107 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   79107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*   79110 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79124 */     GIR_RootConstrainSelectedInstOperands,
     /*   79125 */     // GIR_Coverage, 45706,
     /*   79125 */     GIR_EraseRootFromParent_Done,
     /*   79126 */   // Label 2112: @79126
     /*   79126 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(79161), // Rule ID 45707 //
     /*   79131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   79134 */     // MIs[0] rs1
     /*   79134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79142 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   79142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*   79145 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79159 */     GIR_RootConstrainSelectedInstOperands,
     /*   79160 */     // GIR_Coverage, 45707,
     /*   79160 */     GIR_EraseRootFromParent_Done,
     /*   79161 */   // Label 2113: @79161
     /*   79161 */   GIM_Reject,
     /*   79162 */ // Label 2109: @79162
     /*   79162 */ GIM_Reject,
     /*   79163 */ // Label 1982: @79163
     /*   79163 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(79320),
     /*   79168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79171 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   79179 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(79214), // Rule ID 45670 //
     /*   79184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79187 */     // MIs[0] rs1
     /*   79187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79195 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   79195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*   79198 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79212 */     GIR_RootConstrainSelectedInstOperands,
     /*   79213 */     // GIR_Coverage, 45670,
     /*   79213 */     GIR_EraseRootFromParent_Done,
     /*   79214 */   // Label 2115: @79214
     /*   79214 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(79249), // Rule ID 45671 //
     /*   79219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79222 */     // MIs[0] rs1
     /*   79222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79230 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   79230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*   79233 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79247 */     GIR_RootConstrainSelectedInstOperands,
     /*   79248 */     // GIR_Coverage, 45671,
     /*   79248 */     GIR_EraseRootFromParent_Done,
     /*   79249 */   // Label 2116: @79249
     /*   79249 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(79284), // Rule ID 45730 //
     /*   79254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   79257 */     // MIs[0] rs1
     /*   79257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79265 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   79265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*   79268 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79282 */     GIR_RootConstrainSelectedInstOperands,
     /*   79283 */     // GIR_Coverage, 45730,
     /*   79283 */     GIR_EraseRootFromParent_Done,
     /*   79284 */   // Label 2117: @79284
     /*   79284 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(79319), // Rule ID 45731 //
     /*   79289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   79292 */     // MIs[0] rs1
     /*   79292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79300 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   79300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*   79303 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79317 */     GIR_RootConstrainSelectedInstOperands,
     /*   79318 */     // GIR_Coverage, 45731,
     /*   79318 */     GIR_EraseRootFromParent_Done,
     /*   79319 */   // Label 2118: @79319
     /*   79319 */   GIM_Reject,
     /*   79320 */ // Label 2114: @79320
     /*   79320 */ GIM_Reject,
     /*   79321 */ // Label 1983: @79321
     /*   79321 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(79478),
     /*   79326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79337 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(79372), // Rule ID 45686 //
     /*   79342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   79345 */     // MIs[0] rs1
     /*   79345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79353 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   79353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*   79356 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   79366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79370 */     GIR_RootConstrainSelectedInstOperands,
     /*   79371 */     // GIR_Coverage, 45686,
     /*   79371 */     GIR_EraseRootFromParent_Done,
     /*   79372 */   // Label 2120: @79372
     /*   79372 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(79407), // Rule ID 45687 //
     /*   79377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   79380 */     // MIs[0] rs1
     /*   79380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79388 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   79388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*   79391 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   79401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79405 */     GIR_RootConstrainSelectedInstOperands,
     /*   79406 */     // GIR_Coverage, 45687,
     /*   79406 */     GIR_EraseRootFromParent_Done,
     /*   79407 */   // Label 2121: @79407
     /*   79407 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(79442), // Rule ID 45746 //
     /*   79412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   79415 */     // MIs[0] rs1
     /*   79415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79423 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   79423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*   79426 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   79436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79440 */     GIR_RootConstrainSelectedInstOperands,
     /*   79441 */     // GIR_Coverage, 45746,
     /*   79441 */     GIR_EraseRootFromParent_Done,
     /*   79442 */   // Label 2122: @79442
     /*   79442 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(79477), // Rule ID 45747 //
     /*   79447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   79450 */     // MIs[0] rs1
     /*   79450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79458 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   79458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*   79461 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   79471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79475 */     GIR_RootConstrainSelectedInstOperands,
     /*   79476 */     // GIR_Coverage, 45747,
     /*   79476 */     GIR_EraseRootFromParent_Done,
     /*   79477 */   // Label 2123: @79477
     /*   79477 */   GIM_Reject,
     /*   79478 */ // Label 2119: @79478
     /*   79478 */ GIM_Reject,
     /*   79479 */ // Label 1984: @79479
     /*   79479 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(79558),
     /*   79484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   79499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79503 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(79530), // Rule ID 45762 //
     /*   79508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79511 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   79511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*   79514 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   79524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79528 */     GIR_RootConstrainSelectedInstOperands,
     /*   79529 */     // GIR_Coverage, 45762,
     /*   79529 */     GIR_EraseRootFromParent_Done,
     /*   79530 */   // Label 2125: @79530
     /*   79530 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(79557), // Rule ID 45763 //
     /*   79535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79538 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   79538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*   79541 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   79551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79555 */     GIR_RootConstrainSelectedInstOperands,
     /*   79556 */     // GIR_Coverage, 45763,
     /*   79556 */     GIR_EraseRootFromParent_Done,
     /*   79557 */   // Label 2126: @79557
     /*   79557 */   GIM_Reject,
     /*   79558 */ // Label 2124: @79558
     /*   79558 */ GIM_Reject,
     /*   79559 */ // Label 1985: @79559
     /*   79559 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(79646),
     /*   79564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79575 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(79610), // Rule ID 45630 //
     /*   79580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79583 */     // MIs[0] rs1
     /*   79583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79591 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   79591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*   79594 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79608 */     GIR_RootConstrainSelectedInstOperands,
     /*   79609 */     // GIR_Coverage, 45630,
     /*   79609 */     GIR_EraseRootFromParent_Done,
     /*   79610 */   // Label 2128: @79610
     /*   79610 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(79645), // Rule ID 45631 //
     /*   79615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79618 */     // MIs[0] rs1
     /*   79618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79626 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   79626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*   79629 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79643 */     GIR_RootConstrainSelectedInstOperands,
     /*   79644 */     // GIR_Coverage, 45631,
     /*   79644 */     GIR_EraseRootFromParent_Done,
     /*   79645 */   // Label 2129: @79645
     /*   79645 */   GIM_Reject,
     /*   79646 */ // Label 2127: @79646
     /*   79646 */ GIM_Reject,
     /*   79647 */ // Label 1986: @79647
     /*   79647 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(79804),
     /*   79652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   79663 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(79698), // Rule ID 45658 //
     /*   79668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79671 */     // MIs[0] rs1
     /*   79671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79679 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   79679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*   79682 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79696 */     GIR_RootConstrainSelectedInstOperands,
     /*   79697 */     // GIR_Coverage, 45658,
     /*   79697 */     GIR_EraseRootFromParent_Done,
     /*   79698 */   // Label 2131: @79698
     /*   79698 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(79733), // Rule ID 45659 //
     /*   79703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79706 */     // MIs[0] rs1
     /*   79706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79714 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   79714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*   79717 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79731 */     GIR_RootConstrainSelectedInstOperands,
     /*   79732 */     // GIR_Coverage, 45659,
     /*   79732 */     GIR_EraseRootFromParent_Done,
     /*   79733 */   // Label 2132: @79733
     /*   79733 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(79768), // Rule ID 45718 //
     /*   79738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   79741 */     // MIs[0] rs1
     /*   79741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79749 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   79749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*   79752 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79766 */     GIR_RootConstrainSelectedInstOperands,
     /*   79767 */     // GIR_Coverage, 45718,
     /*   79767 */     GIR_EraseRootFromParent_Done,
     /*   79768 */   // Label 2133: @79768
     /*   79768 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(79803), // Rule ID 45719 //
     /*   79773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   79776 */     // MIs[0] rs1
     /*   79776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79784 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   79784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*   79787 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79801 */     GIR_RootConstrainSelectedInstOperands,
     /*   79802 */     // GIR_Coverage, 45719,
     /*   79802 */     GIR_EraseRootFromParent_Done,
     /*   79803 */   // Label 2134: @79803
     /*   79803 */   GIM_Reject,
     /*   79804 */ // Label 2130: @79804
     /*   79804 */ GIM_Reject,
     /*   79805 */ // Label 1987: @79805
     /*   79805 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(79962),
     /*   79810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79813 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79821 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(79856), // Rule ID 45674 //
     /*   79826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79829 */     // MIs[0] rs1
     /*   79829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79837 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   79837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*   79840 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79854 */     GIR_RootConstrainSelectedInstOperands,
     /*   79855 */     // GIR_Coverage, 45674,
     /*   79855 */     GIR_EraseRootFromParent_Done,
     /*   79856 */   // Label 2136: @79856
     /*   79856 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(79891), // Rule ID 45675 //
     /*   79861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79864 */     // MIs[0] rs1
     /*   79864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79872 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   79872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*   79875 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79889 */     GIR_RootConstrainSelectedInstOperands,
     /*   79890 */     // GIR_Coverage, 45675,
     /*   79890 */     GIR_EraseRootFromParent_Done,
     /*   79891 */   // Label 2137: @79891
     /*   79891 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(79926), // Rule ID 45734 //
     /*   79896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   79899 */     // MIs[0] rs1
     /*   79899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79907 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   79907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*   79910 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79924 */     GIR_RootConstrainSelectedInstOperands,
     /*   79925 */     // GIR_Coverage, 45734,
     /*   79925 */     GIR_EraseRootFromParent_Done,
     /*   79926 */   // Label 2138: @79926
     /*   79926 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(79961), // Rule ID 45735 //
     /*   79931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   79934 */     // MIs[0] rs1
     /*   79934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   79938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79942 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   79942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*   79945 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   79947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   79959 */     GIR_RootConstrainSelectedInstOperands,
     /*   79960 */     // GIR_Coverage, 45735,
     /*   79960 */     GIR_EraseRootFromParent_Done,
     /*   79961 */   // Label 2139: @79961
     /*   79961 */   GIM_Reject,
     /*   79962 */ // Label 2135: @79962
     /*   79962 */ GIM_Reject,
     /*   79963 */ // Label 1988: @79963
     /*   79963 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(80120),
     /*   79968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   79971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   79975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79979 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(80014), // Rule ID 45690 //
     /*   79984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   79987 */     // MIs[0] rs1
     /*   79987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   79991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   79995 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   79995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*   79998 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   80008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80012 */     GIR_RootConstrainSelectedInstOperands,
     /*   80013 */     // GIR_Coverage, 45690,
     /*   80013 */     GIR_EraseRootFromParent_Done,
     /*   80014 */   // Label 2141: @80014
     /*   80014 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(80049), // Rule ID 45691 //
     /*   80019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   80022 */     // MIs[0] rs1
     /*   80022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80030 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   80030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*   80033 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   80043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80047 */     GIR_RootConstrainSelectedInstOperands,
     /*   80048 */     // GIR_Coverage, 45691,
     /*   80048 */     GIR_EraseRootFromParent_Done,
     /*   80049 */   // Label 2142: @80049
     /*   80049 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(80084), // Rule ID 45750 //
     /*   80054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*   80057 */     // MIs[0] rs1
     /*   80057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80065 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*   80065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*   80068 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   80078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80082 */     GIR_RootConstrainSelectedInstOperands,
     /*   80083 */     // GIR_Coverage, 45750,
     /*   80083 */     GIR_EraseRootFromParent_Done,
     /*   80084 */   // Label 2143: @80084
     /*   80084 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(80119), // Rule ID 45751 //
     /*   80089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*   80092 */     // MIs[0] rs1
     /*   80092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80100 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*   80100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*   80103 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   80113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80117 */     GIR_RootConstrainSelectedInstOperands,
     /*   80118 */     // GIR_Coverage, 45751,
     /*   80118 */     GIR_EraseRootFromParent_Done,
     /*   80119 */   // Label 2144: @80119
     /*   80119 */   GIM_Reject,
     /*   80120 */ // Label 2140: @80120
     /*   80120 */ GIM_Reject,
     /*   80121 */ // Label 1989: @80121
     /*   80121 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(80200),
     /*   80126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   80141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80145 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(80172), // Rule ID 45766 //
     /*   80150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80153 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   80153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*   80156 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   80166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80170 */     GIR_RootConstrainSelectedInstOperands,
     /*   80171 */     // GIR_Coverage, 45766,
     /*   80171 */     GIR_EraseRootFromParent_Done,
     /*   80172 */   // Label 2146: @80172
     /*   80172 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(80199), // Rule ID 45767 //
     /*   80177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80180 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   80180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*   80183 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   80193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80197 */     GIR_RootConstrainSelectedInstOperands,
     /*   80198 */     // GIR_Coverage, 45767,
     /*   80198 */     GIR_EraseRootFromParent_Done,
     /*   80199 */   // Label 2147: @80199
     /*   80199 */   GIM_Reject,
     /*   80200 */ // Label 2145: @80200
     /*   80200 */ GIM_Reject,
     /*   80201 */ // Label 1990: @80201
     /*   80201 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(80288),
     /*   80206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   80217 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(80252), // Rule ID 45646 //
     /*   80222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80225 */     // MIs[0] rs1
     /*   80225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80233 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   80233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*   80236 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80250 */     GIR_RootConstrainSelectedInstOperands,
     /*   80251 */     // GIR_Coverage, 45646,
     /*   80251 */     GIR_EraseRootFromParent_Done,
     /*   80252 */   // Label 2149: @80252
     /*   80252 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(80287), // Rule ID 45647 //
     /*   80257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80260 */     // MIs[0] rs1
     /*   80260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80268 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   80268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*   80271 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80285 */     GIR_RootConstrainSelectedInstOperands,
     /*   80286 */     // GIR_Coverage, 45647,
     /*   80286 */     GIR_EraseRootFromParent_Done,
     /*   80287 */   // Label 2150: @80287
     /*   80287 */   GIM_Reject,
     /*   80288 */ // Label 2148: @80288
     /*   80288 */ GIM_Reject,
     /*   80289 */ // Label 1991: @80289
     /*   80289 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(80446),
     /*   80294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80305 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(80340), // Rule ID 45662 //
     /*   80310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80313 */     // MIs[0] rs1
     /*   80313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80321 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   80321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*   80324 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80338 */     GIR_RootConstrainSelectedInstOperands,
     /*   80339 */     // GIR_Coverage, 45662,
     /*   80339 */     GIR_EraseRootFromParent_Done,
     /*   80340 */   // Label 2152: @80340
     /*   80340 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(80375), // Rule ID 45663 //
     /*   80345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80348 */     // MIs[0] rs1
     /*   80348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80356 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   80356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*   80359 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80373 */     GIR_RootConstrainSelectedInstOperands,
     /*   80374 */     // GIR_Coverage, 45663,
     /*   80374 */     GIR_EraseRootFromParent_Done,
     /*   80375 */   // Label 2153: @80375
     /*   80375 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(80410), // Rule ID 45722 //
     /*   80380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   80383 */     // MIs[0] rs1
     /*   80383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80391 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   80391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*   80394 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80408 */     GIR_RootConstrainSelectedInstOperands,
     /*   80409 */     // GIR_Coverage, 45722,
     /*   80409 */     GIR_EraseRootFromParent_Done,
     /*   80410 */   // Label 2154: @80410
     /*   80410 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(80445), // Rule ID 45723 //
     /*   80415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   80418 */     // MIs[0] rs1
     /*   80418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80426 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   80426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*   80429 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80443 */     GIR_RootConstrainSelectedInstOperands,
     /*   80444 */     // GIR_Coverage, 45723,
     /*   80444 */     GIR_EraseRootFromParent_Done,
     /*   80445 */   // Label 2155: @80445
     /*   80445 */   GIM_Reject,
     /*   80446 */ // Label 2151: @80446
     /*   80446 */ GIM_Reject,
     /*   80447 */ // Label 1992: @80447
     /*   80447 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(80604),
     /*   80452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80463 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(80498), // Rule ID 45678 //
     /*   80468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80471 */     // MIs[0] rs1
     /*   80471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80479 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   80479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*   80482 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80496 */     GIR_RootConstrainSelectedInstOperands,
     /*   80497 */     // GIR_Coverage, 45678,
     /*   80497 */     GIR_EraseRootFromParent_Done,
     /*   80498 */   // Label 2157: @80498
     /*   80498 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(80533), // Rule ID 45679 //
     /*   80503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80506 */     // MIs[0] rs1
     /*   80506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80514 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   80514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*   80517 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80531 */     GIR_RootConstrainSelectedInstOperands,
     /*   80532 */     // GIR_Coverage, 45679,
     /*   80532 */     GIR_EraseRootFromParent_Done,
     /*   80533 */   // Label 2158: @80533
     /*   80533 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(80568), // Rule ID 45738 //
     /*   80538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*   80541 */     // MIs[0] rs1
     /*   80541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80549 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*   80549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*   80552 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80566 */     GIR_RootConstrainSelectedInstOperands,
     /*   80567 */     // GIR_Coverage, 45738,
     /*   80567 */     GIR_EraseRootFromParent_Done,
     /*   80568 */   // Label 2159: @80568
     /*   80568 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(80603), // Rule ID 45739 //
     /*   80573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*   80576 */     // MIs[0] rs1
     /*   80576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80584 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*   80584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*   80587 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80601 */     GIR_RootConstrainSelectedInstOperands,
     /*   80602 */     // GIR_Coverage, 45739,
     /*   80602 */     GIR_EraseRootFromParent_Done,
     /*   80603 */   // Label 2160: @80603
     /*   80603 */   GIM_Reject,
     /*   80604 */ // Label 2156: @80604
     /*   80604 */ GIM_Reject,
     /*   80605 */ // Label 1993: @80605
     /*   80605 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(80684),
     /*   80610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80613 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   80625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80629 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(80656), // Rule ID 45770 //
     /*   80634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80637 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   80637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*   80640 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   80650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80654 */     GIR_RootConstrainSelectedInstOperands,
     /*   80655 */     // GIR_Coverage, 45770,
     /*   80655 */     GIR_EraseRootFromParent_Done,
     /*   80656 */   // Label 2162: @80656
     /*   80656 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(80683), // Rule ID 45771 //
     /*   80661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80664 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   80664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*   80667 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   80677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80681 */     GIR_RootConstrainSelectedInstOperands,
     /*   80682 */     // GIR_Coverage, 45771,
     /*   80682 */     GIR_EraseRootFromParent_Done,
     /*   80683 */   // Label 2163: @80683
     /*   80683 */   GIM_Reject,
     /*   80684 */ // Label 2161: @80684
     /*   80684 */ GIM_Reject,
     /*   80685 */ // Label 1994: @80685
     /*   80685 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(80772),
     /*   80690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80701 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(80736), // Rule ID 45650 //
     /*   80706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80709 */     // MIs[0] rs1
     /*   80709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80717 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   80717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*   80720 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80734 */     GIR_RootConstrainSelectedInstOperands,
     /*   80735 */     // GIR_Coverage, 45650,
     /*   80735 */     GIR_EraseRootFromParent_Done,
     /*   80736 */   // Label 2165: @80736
     /*   80736 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(80771), // Rule ID 45651 //
     /*   80741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80744 */     // MIs[0] rs1
     /*   80744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80752 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   80752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*   80755 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80769 */     GIR_RootConstrainSelectedInstOperands,
     /*   80770 */     // GIR_Coverage, 45651,
     /*   80770 */     GIR_EraseRootFromParent_Done,
     /*   80771 */   // Label 2166: @80771
     /*   80771 */   GIM_Reject,
     /*   80772 */ // Label 2164: @80772
     /*   80772 */ GIM_Reject,
     /*   80773 */ // Label 1995: @80773
     /*   80773 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(80930),
     /*   80778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80781 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80789 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(80824), // Rule ID 45666 //
     /*   80794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80797 */     // MIs[0] rs1
     /*   80797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80805 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   80805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*   80808 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80822 */     GIR_RootConstrainSelectedInstOperands,
     /*   80823 */     // GIR_Coverage, 45666,
     /*   80823 */     GIR_EraseRootFromParent_Done,
     /*   80824 */   // Label 2168: @80824
     /*   80824 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(80859), // Rule ID 45667 //
     /*   80829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80832 */     // MIs[0] rs1
     /*   80832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80840 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   80840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*   80843 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80857 */     GIR_RootConstrainSelectedInstOperands,
     /*   80858 */     // GIR_Coverage, 45667,
     /*   80858 */     GIR_EraseRootFromParent_Done,
     /*   80859 */   // Label 2169: @80859
     /*   80859 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(80894), // Rule ID 45726 //
     /*   80864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*   80867 */     // MIs[0] rs1
     /*   80867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   80871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80875 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*   80875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*   80878 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80892 */     GIR_RootConstrainSelectedInstOperands,
     /*   80893 */     // GIR_Coverage, 45726,
     /*   80893 */     GIR_EraseRootFromParent_Done,
     /*   80894 */   // Label 2170: @80894
     /*   80894 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(80929), // Rule ID 45727 //
     /*   80899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*   80902 */     // MIs[0] rs1
     /*   80902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   80906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80910 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*   80910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*   80913 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80927 */     GIR_RootConstrainSelectedInstOperands,
     /*   80928 */     // GIR_Coverage, 45727,
     /*   80928 */     GIR_EraseRootFromParent_Done,
     /*   80929 */   // Label 2171: @80929
     /*   80929 */   GIM_Reject,
     /*   80930 */ // Label 2167: @80930
     /*   80930 */ GIM_Reject,
     /*   80931 */ // Label 1996: @80931
     /*   80931 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(81010),
     /*   80936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   80939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   80943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   80951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80955 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(80982), // Rule ID 45774 //
     /*   80960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80963 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*   80963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*   80966 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   80976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   80980 */     GIR_RootConstrainSelectedInstOperands,
     /*   80981 */     // GIR_Coverage, 45774,
     /*   80981 */     GIR_EraseRootFromParent_Done,
     /*   80982 */   // Label 2173: @80982
     /*   80982 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(81009), // Rule ID 45775 //
     /*   80987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80990 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*   80990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*   80993 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   80995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   81003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81007 */     GIR_RootConstrainSelectedInstOperands,
     /*   81008 */     // GIR_Coverage, 45775,
     /*   81008 */     GIR_EraseRootFromParent_Done,
     /*   81009 */   // Label 2174: @81009
     /*   81009 */   GIM_Reject,
     /*   81010 */ // Label 2172: @81010
     /*   81010 */ GIM_Reject,
     /*   81011 */ // Label 1997: @81011
     /*   81011 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(81098),
     /*   81016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   81019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*   81023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   81027 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(81062), // Rule ID 45654 //
     /*   81032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81035 */     // MIs[0] rs1
     /*   81035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   81039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81043 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*   81043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*   81046 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   81048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81060 */     GIR_RootConstrainSelectedInstOperands,
     /*   81061 */     // GIR_Coverage, 45654,
     /*   81061 */     GIR_EraseRootFromParent_Done,
     /*   81062 */   // Label 2176: @81062
     /*   81062 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(81097), // Rule ID 45655 //
     /*   81067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81070 */     // MIs[0] rs1
     /*   81070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81078 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*   81078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*   81081 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*   81083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81095 */     GIR_RootConstrainSelectedInstOperands,
     /*   81096 */     // GIR_Coverage, 45655,
     /*   81096 */     GIR_EraseRootFromParent_Done,
     /*   81097 */   // Label 2177: @81097
     /*   81097 */   GIM_Reject,
     /*   81098 */ // Label 2175: @81098
     /*   81098 */ GIM_Reject,
     /*   81099 */ // Label 1998: @81099
     /*   81099 */ GIM_Reject,
     /*   81100 */ // Label 25: @81100
     /*   81100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2180*/ GIMT_Encode4(85985),
     /*   81111 */ /*GILLT_s32*//*Label 2178*/ GIMT_Encode4(81119),
     /*   81115 */ /*GILLT_s64*//*Label 2179*/ GIMT_Encode4(83112),
     /*   81119 */ // Label 2178: @81119
     /*   81119 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(83111),
     /*   81124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   81127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*   81130 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(81196), // Rule ID 627 //
     /*   81135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*   81138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   81148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81152 */     // MIs[0] addr
     /*   81152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   81156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81168 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*   81168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   81171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   81174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   81176 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   81181 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81183 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81185 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   81190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81194 */     GIR_RootConstrainSelectedInstOperands,
     /*   81195 */     // GIR_Coverage, 627,
     /*   81195 */     GIR_EraseRootFromParent_Done,
     /*   81196 */   // Label 2182: @81196
     /*   81196 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(81262), // Rule ID 629 //
     /*   81201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*   81204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   81214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81218 */     // MIs[0] addr
     /*   81218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   81222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81234 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*   81234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   81237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   81240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   81242 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   81247 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81249 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81251 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   81256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81260 */     GIR_RootConstrainSelectedInstOperands,
     /*   81261 */     // GIR_Coverage, 629,
     /*   81261 */     GIR_EraseRootFromParent_Done,
     /*   81262 */   // Label 2183: @81262
     /*   81262 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(81328), // Rule ID 631 //
     /*   81267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*   81270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   81280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81284 */     // MIs[0] addr
     /*   81284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   81288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81300 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*   81300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   81303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   81306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   81308 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   81313 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81315 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81317 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81326 */     GIR_RootConstrainSelectedInstOperands,
     /*   81327 */     // GIR_Coverage, 631,
     /*   81327 */     GIR_EraseRootFromParent_Done,
     /*   81328 */   // Label 2184: @81328
     /*   81328 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(81394), // Rule ID 633 //
     /*   81333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*   81336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   81346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81350 */     // MIs[0] addr
     /*   81350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   81354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81366 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*   81366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   81369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   81372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   81374 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   81379 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81381 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81383 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   81388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81392 */     GIR_RootConstrainSelectedInstOperands,
     /*   81393 */     // GIR_Coverage, 633,
     /*   81393 */     GIR_EraseRootFromParent_Done,
     /*   81394 */   // Label 2185: @81394
     /*   81394 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(81460), // Rule ID 635 //
     /*   81399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*   81402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   81412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81416 */     // MIs[0] addr
     /*   81416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   81420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81432 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*   81432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   81435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   81438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   81440 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   81445 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81447 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81449 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   81454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81458 */     GIR_RootConstrainSelectedInstOperands,
     /*   81459 */     // GIR_Coverage, 635,
     /*   81459 */     GIR_EraseRootFromParent_Done,
     /*   81460 */   // Label 2186: @81460
     /*   81460 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(81515), // Rule ID 644 //
     /*   81465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   81468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   81478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81482 */     // MIs[0] addr
     /*   81482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81498 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81503 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81505 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81507 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81513 */     GIR_RootConstrainSelectedInstOperands,
     /*   81514 */     // GIR_Coverage, 644,
     /*   81514 */     GIR_EraseRootFromParent_Done,
     /*   81515 */   // Label 2187: @81515
     /*   81515 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(81570), // Rule ID 646 //
     /*   81520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   81523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   81533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81537 */     // MIs[0] addr
     /*   81537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81553 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*   81556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81558 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81560 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81562 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81568 */     GIR_RootConstrainSelectedInstOperands,
     /*   81569 */     // GIR_Coverage, 646,
     /*   81569 */     GIR_EraseRootFromParent_Done,
     /*   81570 */   // Label 2188: @81570
     /*   81570 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(81625), // Rule ID 648 //
     /*   81575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   81578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   81588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81592 */     // MIs[0] addr
     /*   81592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81608 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*   81611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81613 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81615 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81617 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81623 */     GIR_RootConstrainSelectedInstOperands,
     /*   81624 */     // GIR_Coverage, 648,
     /*   81624 */     GIR_EraseRootFromParent_Done,
     /*   81625 */   // Label 2189: @81625
     /*   81625 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(81680), // Rule ID 650 //
     /*   81630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   81633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   81643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81647 */     // MIs[0] addr
     /*   81647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81663 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*   81666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81668 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81670 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81672 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81678 */     GIR_RootConstrainSelectedInstOperands,
     /*   81679 */     // GIR_Coverage, 650,
     /*   81679 */     GIR_EraseRootFromParent_Done,
     /*   81680 */   // Label 2190: @81680
     /*   81680 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(81735), // Rule ID 652 //
     /*   81685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   81688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   81698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81702 */     // MIs[0] addr
     /*   81702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81718 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*   81721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81723 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81725 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81727 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81733 */     GIR_RootConstrainSelectedInstOperands,
     /*   81734 */     // GIR_Coverage, 652,
     /*   81734 */     GIR_EraseRootFromParent_Done,
     /*   81735 */   // Label 2191: @81735
     /*   81735 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(81790), // Rule ID 654 //
     /*   81740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   81743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   81753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81757 */     // MIs[0] addr
     /*   81757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81773 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81778 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81780 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81782 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81788 */     GIR_RootConstrainSelectedInstOperands,
     /*   81789 */     // GIR_Coverage, 654,
     /*   81789 */     GIR_EraseRootFromParent_Done,
     /*   81790 */   // Label 2192: @81790
     /*   81790 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(81845), // Rule ID 656 //
     /*   81795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   81798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   81808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81812 */     // MIs[0] addr
     /*   81812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81828 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81833 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81835 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81837 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81843 */     GIR_RootConstrainSelectedInstOperands,
     /*   81844 */     // GIR_Coverage, 656,
     /*   81844 */     GIR_EraseRootFromParent_Done,
     /*   81845 */   // Label 2193: @81845
     /*   81845 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(81900), // Rule ID 658 //
     /*   81850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   81853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   81863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81867 */     // MIs[0] addr
     /*   81867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81883 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81888 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81890 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81892 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81898 */     GIR_RootConstrainSelectedInstOperands,
     /*   81899 */     // GIR_Coverage, 658,
     /*   81899 */     GIR_EraseRootFromParent_Done,
     /*   81900 */   // Label 2194: @81900
     /*   81900 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(81955), // Rule ID 660 //
     /*   81905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   81908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   81918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81922 */     // MIs[0] addr
     /*   81922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81938 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81943 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   81945 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   81947 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   81949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   81953 */     GIR_RootConstrainSelectedInstOperands,
     /*   81954 */     // GIR_Coverage, 660,
     /*   81954 */     GIR_EraseRootFromParent_Done,
     /*   81955 */   // Label 2195: @81955
     /*   81955 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(82010), // Rule ID 662 //
     /*   81960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   81963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   81970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   81973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81977 */     // MIs[0] addr
     /*   81977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   81981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81993 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   81993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   81996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   81998 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82000 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82002 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82008 */     GIR_RootConstrainSelectedInstOperands,
     /*   82009 */     // GIR_Coverage, 662,
     /*   82009 */     GIR_EraseRootFromParent_Done,
     /*   82010 */   // Label 2196: @82010
     /*   82010 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(82065), // Rule ID 1034 //
     /*   82015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   82028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82032 */     // MIs[0] addr
     /*   82032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82048 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82053 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82055 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82057 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82063 */     GIR_RootConstrainSelectedInstOperands,
     /*   82064 */     // GIR_Coverage, 1034,
     /*   82064 */     GIR_EraseRootFromParent_Done,
     /*   82065 */   // Label 2197: @82065
     /*   82065 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(82120), // Rule ID 1036 //
     /*   82070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   82083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82087 */     // MIs[0] addr
     /*   82087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82103 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*   82106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82108 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82110 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82112 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82118 */     GIR_RootConstrainSelectedInstOperands,
     /*   82119 */     // GIR_Coverage, 1036,
     /*   82119 */     GIR_EraseRootFromParent_Done,
     /*   82120 */   // Label 2198: @82120
     /*   82120 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(82175), // Rule ID 1038 //
     /*   82125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   82138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82142 */     // MIs[0] addr
     /*   82142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82158 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*   82161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82163 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82165 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82167 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82173 */     GIR_RootConstrainSelectedInstOperands,
     /*   82174 */     // GIR_Coverage, 1038,
     /*   82174 */     GIR_EraseRootFromParent_Done,
     /*   82175 */   // Label 2199: @82175
     /*   82175 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(82230), // Rule ID 1040 //
     /*   82180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   82193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82197 */     // MIs[0] addr
     /*   82197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82213 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*   82216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82218 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82220 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82222 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82228 */     GIR_RootConstrainSelectedInstOperands,
     /*   82229 */     // GIR_Coverage, 1040,
     /*   82229 */     GIR_EraseRootFromParent_Done,
     /*   82230 */   // Label 2200: @82230
     /*   82230 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(82285), // Rule ID 1042 //
     /*   82235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   82248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82252 */     // MIs[0] addr
     /*   82252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82268 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*   82271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82273 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82275 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82277 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82283 */     GIR_RootConstrainSelectedInstOperands,
     /*   82284 */     // GIR_Coverage, 1042,
     /*   82284 */     GIR_EraseRootFromParent_Done,
     /*   82285 */   // Label 2201: @82285
     /*   82285 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(82340), // Rule ID 1044 //
     /*   82290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   82303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82307 */     // MIs[0] addr
     /*   82307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82323 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82328 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82330 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82332 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82338 */     GIR_RootConstrainSelectedInstOperands,
     /*   82339 */     // GIR_Coverage, 1044,
     /*   82339 */     GIR_EraseRootFromParent_Done,
     /*   82340 */   // Label 2202: @82340
     /*   82340 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(82395), // Rule ID 1046 //
     /*   82345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   82358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82362 */     // MIs[0] addr
     /*   82362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82378 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82383 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82385 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82387 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82393 */     GIR_RootConstrainSelectedInstOperands,
     /*   82394 */     // GIR_Coverage, 1046,
     /*   82394 */     GIR_EraseRootFromParent_Done,
     /*   82395 */   // Label 2203: @82395
     /*   82395 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(82450), // Rule ID 1048 //
     /*   82400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   82413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82417 */     // MIs[0] addr
     /*   82417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82433 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82438 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82440 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82442 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82448 */     GIR_RootConstrainSelectedInstOperands,
     /*   82449 */     // GIR_Coverage, 1048,
     /*   82449 */     GIR_EraseRootFromParent_Done,
     /*   82450 */   // Label 2204: @82450
     /*   82450 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(82505), // Rule ID 1050 //
     /*   82455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   82468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82472 */     // MIs[0] addr
     /*   82472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82488 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82493 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82495 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82497 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82503 */     GIR_RootConstrainSelectedInstOperands,
     /*   82504 */     // GIR_Coverage, 1050,
     /*   82504 */     GIR_EraseRootFromParent_Done,
     /*   82505 */   // Label 2205: @82505
     /*   82505 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(82560), // Rule ID 1052 //
     /*   82510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   82520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   82523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82527 */     // MIs[0] addr
     /*   82527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82543 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   82546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82548 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82550 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82552 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82558 */     GIR_RootConstrainSelectedInstOperands,
     /*   82559 */     // GIR_Coverage, 1052,
     /*   82559 */     GIR_EraseRootFromParent_Done,
     /*   82560 */   // Label 2206: @82560
     /*   82560 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(82615), // Rule ID 1054 //
     /*   82565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   82578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82582 */     // MIs[0] addr
     /*   82582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82598 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   82601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82603 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82605 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82607 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82613 */     GIR_RootConstrainSelectedInstOperands,
     /*   82614 */     // GIR_Coverage, 1054,
     /*   82614 */     GIR_EraseRootFromParent_Done,
     /*   82615 */   // Label 2207: @82615
     /*   82615 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(82670), // Rule ID 1056 //
     /*   82620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   82633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82637 */     // MIs[0] addr
     /*   82637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82653 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*   82656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82658 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82660 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82662 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82668 */     GIR_RootConstrainSelectedInstOperands,
     /*   82669 */     // GIR_Coverage, 1056,
     /*   82669 */     GIR_EraseRootFromParent_Done,
     /*   82670 */   // Label 2208: @82670
     /*   82670 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(82725), // Rule ID 1058 //
     /*   82675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   82688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82692 */     // MIs[0] addr
     /*   82692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82708 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*   82711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82713 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82715 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82717 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82723 */     GIR_RootConstrainSelectedInstOperands,
     /*   82724 */     // GIR_Coverage, 1058,
     /*   82724 */     GIR_EraseRootFromParent_Done,
     /*   82725 */   // Label 2209: @82725
     /*   82725 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(82780), // Rule ID 1060 //
     /*   82730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   82743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82747 */     // MIs[0] addr
     /*   82747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82763 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*   82766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82768 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82770 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82772 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82778 */     GIR_RootConstrainSelectedInstOperands,
     /*   82779 */     // GIR_Coverage, 1060,
     /*   82779 */     GIR_EraseRootFromParent_Done,
     /*   82780 */   // Label 2210: @82780
     /*   82780 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(82835), // Rule ID 1062 //
     /*   82785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*   82788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   82798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82802 */     // MIs[0] addr
     /*   82802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82818 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*   82821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82823 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82825 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82827 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82833 */     GIR_RootConstrainSelectedInstOperands,
     /*   82834 */     // GIR_Coverage, 1062,
     /*   82834 */     GIR_EraseRootFromParent_Done,
     /*   82835 */   // Label 2211: @82835
     /*   82835 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(82890), // Rule ID 1064 //
     /*   82840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   82853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82857 */     // MIs[0] addr
     /*   82857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82873 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   82876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82878 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82880 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82882 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82888 */     GIR_RootConstrainSelectedInstOperands,
     /*   82889 */     // GIR_Coverage, 1064,
     /*   82889 */     GIR_EraseRootFromParent_Done,
     /*   82890 */   // Label 2212: @82890
     /*   82890 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(82945), // Rule ID 1066 //
     /*   82895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   82908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82912 */     // MIs[0] addr
     /*   82912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82928 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   82931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82933 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82935 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82937 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82943 */     GIR_RootConstrainSelectedInstOperands,
     /*   82944 */     // GIR_Coverage, 1066,
     /*   82944 */     GIR_EraseRootFromParent_Done,
     /*   82945 */   // Label 2213: @82945
     /*   82945 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(83000), // Rule ID 1068 //
     /*   82950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   82953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   82960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   82963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82967 */     // MIs[0] addr
     /*   82967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   82971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   82983 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   82983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   82986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   82988 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   82990 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   82992 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   82994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   82998 */     GIR_RootConstrainSelectedInstOperands,
     /*   82999 */     // GIR_Coverage, 1068,
     /*   82999 */     GIR_EraseRootFromParent_Done,
     /*   83000 */   // Label 2214: @83000
     /*   83000 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(83055), // Rule ID 1070 //
     /*   83005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   83008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   83015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   83018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83022 */     // MIs[0] addr
     /*   83022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   83026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83038 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   83038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   83041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83043 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83045 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83047 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83053 */     GIR_RootConstrainSelectedInstOperands,
     /*   83054 */     // GIR_Coverage, 1070,
     /*   83054 */     GIR_EraseRootFromParent_Done,
     /*   83055 */   // Label 2215: @83055
     /*   83055 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(83110), // Rule ID 1072 //
     /*   83060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*   83063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   83070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   83073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83077 */     // MIs[0] addr
     /*   83077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   83081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83093 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*   83093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   83096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83098 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83100 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83102 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83108 */     GIR_RootConstrainSelectedInstOperands,
     /*   83109 */     // GIR_Coverage, 1072,
     /*   83109 */     GIR_EraseRootFromParent_Done,
     /*   83110 */   // Label 2216: @83110
     /*   83110 */   GIM_Reject,
     /*   83111 */ // Label 2181: @83111
     /*   83111 */ GIM_Reject,
     /*   83112 */ // Label 2179: @83112
     /*   83112 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(85984),
     /*   83117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   83120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*   83123 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(83189), // Rule ID 626 //
     /*   83128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*   83131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   83141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83145 */     // MIs[0] addr
     /*   83145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83161 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*   83161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   83167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83169 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83174 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83176 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83178 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   83183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83187 */     GIR_RootConstrainSelectedInstOperands,
     /*   83188 */     // GIR_Coverage, 626,
     /*   83188 */     GIR_EraseRootFromParent_Done,
     /*   83189 */   // Label 2218: @83189
     /*   83189 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(83255), // Rule ID 628 //
     /*   83194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*   83197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   83207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83211 */     // MIs[0] addr
     /*   83211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83227 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*   83227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   83233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83235 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83240 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83242 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83244 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83253 */     GIR_RootConstrainSelectedInstOperands,
     /*   83254 */     // GIR_Coverage, 628,
     /*   83254 */     GIR_EraseRootFromParent_Done,
     /*   83255 */   // Label 2219: @83255
     /*   83255 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(83321), // Rule ID 630 //
     /*   83260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*   83263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   83273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83277 */     // MIs[0] addr
     /*   83277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83293 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*   83293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   83299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83301 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83306 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83308 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83310 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   83315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83319 */     GIR_RootConstrainSelectedInstOperands,
     /*   83320 */     // GIR_Coverage, 630,
     /*   83320 */     GIR_EraseRootFromParent_Done,
     /*   83321 */   // Label 2220: @83321
     /*   83321 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(83387), // Rule ID 632 //
     /*   83326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*   83329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   83339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83343 */     // MIs[0] addr
     /*   83343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83359 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*   83359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   83365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83367 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83372 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83374 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83376 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   83381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83385 */     GIR_RootConstrainSelectedInstOperands,
     /*   83386 */     // GIR_Coverage, 632,
     /*   83386 */     GIR_EraseRootFromParent_Done,
     /*   83387 */   // Label 2221: @83387
     /*   83387 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(83453), // Rule ID 634 //
     /*   83392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*   83395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   83405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83409 */     // MIs[0] addr
     /*   83409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83425 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*   83425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*   83431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83433 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83438 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83440 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83442 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   83447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83451 */     GIR_RootConstrainSelectedInstOperands,
     /*   83452 */     // GIR_Coverage, 634,
     /*   83452 */     GIR_EraseRootFromParent_Done,
     /*   83453 */   // Label 2222: @83453
     /*   83453 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(83519), // Rule ID 636 //
     /*   83458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*   83461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   83468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   83471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83475 */     // MIs[0] addr
     /*   83475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83491 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*   83491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*   83497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83499 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83504 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83506 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83508 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   83513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83517 */     GIR_RootConstrainSelectedInstOperands,
     /*   83518 */     // GIR_Coverage, 636,
     /*   83518 */     GIR_EraseRootFromParent_Done,
     /*   83519 */   // Label 2223: @83519
     /*   83519 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(83585), // Rule ID 637 //
     /*   83524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*   83527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   83534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   83537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83541 */     // MIs[0] addr
     /*   83541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83557 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*   83557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*   83563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83565 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83570 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83572 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83574 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83583 */     GIR_RootConstrainSelectedInstOperands,
     /*   83584 */     // GIR_Coverage, 637,
     /*   83584 */     GIR_EraseRootFromParent_Done,
     /*   83585 */   // Label 2224: @83585
     /*   83585 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(83651), // Rule ID 638 //
     /*   83590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*   83593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   83600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   83603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83607 */     // MIs[0] addr
     /*   83607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83623 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*   83623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*   83629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83631 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83636 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83638 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83640 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   83645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83649 */     GIR_RootConstrainSelectedInstOperands,
     /*   83650 */     // GIR_Coverage, 638,
     /*   83650 */     GIR_EraseRootFromParent_Done,
     /*   83651 */   // Label 2225: @83651
     /*   83651 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(83717), // Rule ID 639 //
     /*   83656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*   83659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   83666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   83669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83673 */     // MIs[0] addr
     /*   83673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83689 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*   83689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*   83695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83697 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83702 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83704 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83706 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   83711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83715 */     GIR_RootConstrainSelectedInstOperands,
     /*   83716 */     // GIR_Coverage, 639,
     /*   83716 */     GIR_EraseRootFromParent_Done,
     /*   83717 */   // Label 2226: @83717
     /*   83717 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(83783), // Rule ID 640 //
     /*   83722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*   83725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   83732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   83735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83739 */     // MIs[0] addr
     /*   83739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   83743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83755 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*   83755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*   83761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   83763 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   83768 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83770 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83772 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   83777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83781 */     GIR_RootConstrainSelectedInstOperands,
     /*   83782 */     // GIR_Coverage, 640,
     /*   83782 */     GIR_EraseRootFromParent_Done,
     /*   83783 */   // Label 2227: @83783
     /*   83783 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(83838), // Rule ID 643 //
     /*   83788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   83791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   83801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83805 */     // MIs[0] addr
     /*   83805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   83809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83821 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   83821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   83824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83826 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83828 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83830 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83836 */     GIR_RootConstrainSelectedInstOperands,
     /*   83837 */     // GIR_Coverage, 643,
     /*   83837 */     GIR_EraseRootFromParent_Done,
     /*   83838 */   // Label 2228: @83838
     /*   83838 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(83893), // Rule ID 645 //
     /*   83843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   83846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   83856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83860 */     // MIs[0] addr
     /*   83860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   83864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83876 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*   83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83881 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83883 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83885 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83891 */     GIR_RootConstrainSelectedInstOperands,
     /*   83892 */     // GIR_Coverage, 645,
     /*   83892 */     GIR_EraseRootFromParent_Done,
     /*   83893 */   // Label 2229: @83893
     /*   83893 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(83948), // Rule ID 647 //
     /*   83898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   83901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   83911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83915 */     // MIs[0] addr
     /*   83915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   83919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83931 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   83931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*   83934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83936 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83938 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83940 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   83946 */     GIR_RootConstrainSelectedInstOperands,
     /*   83947 */     // GIR_Coverage, 647,
     /*   83947 */     GIR_EraseRootFromParent_Done,
     /*   83948 */   // Label 2230: @83948
     /*   83948 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(84003), // Rule ID 649 //
     /*   83953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   83956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   83963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   83966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83970 */     // MIs[0] addr
     /*   83970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   83974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   83986 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   83986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*   83989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   83991 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   83993 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   83995 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   83997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84001 */     GIR_RootConstrainSelectedInstOperands,
     /*   84002 */     // GIR_Coverage, 649,
     /*   84002 */     GIR_EraseRootFromParent_Done,
     /*   84003 */   // Label 2231: @84003
     /*   84003 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(84058), // Rule ID 651 //
     /*   84008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   84011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   84021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84025 */     // MIs[0] addr
     /*   84025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84041 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*   84044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84046 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84048 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84050 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84056 */     GIR_RootConstrainSelectedInstOperands,
     /*   84057 */     // GIR_Coverage, 651,
     /*   84057 */     GIR_EraseRootFromParent_Done,
     /*   84058 */   // Label 2232: @84058
     /*   84058 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(84113), // Rule ID 653 //
     /*   84063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   84066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   84076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84080 */     // MIs[0] addr
     /*   84080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84096 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   84099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84101 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84103 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84105 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84111 */     GIR_RootConstrainSelectedInstOperands,
     /*   84112 */     // GIR_Coverage, 653,
     /*   84112 */     GIR_EraseRootFromParent_Done,
     /*   84113 */   // Label 2233: @84113
     /*   84113 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(84168), // Rule ID 655 //
     /*   84118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   84121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   84131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84135 */     // MIs[0] addr
     /*   84135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84151 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   84154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84156 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84158 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84160 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84166 */     GIR_RootConstrainSelectedInstOperands,
     /*   84167 */     // GIR_Coverage, 655,
     /*   84167 */     GIR_EraseRootFromParent_Done,
     /*   84168 */   // Label 2234: @84168
     /*   84168 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(84223), // Rule ID 657 //
     /*   84173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   84176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   84186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84190 */     // MIs[0] addr
     /*   84190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84206 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   84209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84211 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84213 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84215 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84221 */     GIR_RootConstrainSelectedInstOperands,
     /*   84222 */     // GIR_Coverage, 657,
     /*   84222 */     GIR_EraseRootFromParent_Done,
     /*   84223 */   // Label 2235: @84223
     /*   84223 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(84278), // Rule ID 659 //
     /*   84228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   84231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   84241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84245 */     // MIs[0] addr
     /*   84245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84261 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   84264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84266 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84268 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84270 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84276 */     GIR_RootConstrainSelectedInstOperands,
     /*   84277 */     // GIR_Coverage, 659,
     /*   84277 */     GIR_EraseRootFromParent_Done,
     /*   84278 */   // Label 2236: @84278
     /*   84278 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(84333), // Rule ID 661 //
     /*   84283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   84286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   84293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   84296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84300 */     // MIs[0] addr
     /*   84300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84316 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*   84319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84321 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84323 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84325 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84331 */     GIR_RootConstrainSelectedInstOperands,
     /*   84332 */     // GIR_Coverage, 661,
     /*   84332 */     GIR_EraseRootFromParent_Done,
     /*   84333 */   // Label 2237: @84333
     /*   84333 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(84388), // Rule ID 663 //
     /*   84338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   84341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   84351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84355 */     // MIs[0] addr
     /*   84355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84371 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84376 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84378 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84380 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84386 */     GIR_RootConstrainSelectedInstOperands,
     /*   84387 */     // GIR_Coverage, 663,
     /*   84387 */     GIR_EraseRootFromParent_Done,
     /*   84388 */   // Label 2238: @84388
     /*   84388 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(84443), // Rule ID 664 //
     /*   84393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   84396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   84406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84410 */     // MIs[0] addr
     /*   84410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84426 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*   84429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84431 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84433 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84435 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84441 */     GIR_RootConstrainSelectedInstOperands,
     /*   84442 */     // GIR_Coverage, 664,
     /*   84442 */     GIR_EraseRootFromParent_Done,
     /*   84443 */   // Label 2239: @84443
     /*   84443 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(84498), // Rule ID 665 //
     /*   84448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   84451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   84461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84465 */     // MIs[0] addr
     /*   84465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84481 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*   84484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84486 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84488 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84490 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84496 */     GIR_RootConstrainSelectedInstOperands,
     /*   84497 */     // GIR_Coverage, 665,
     /*   84497 */     GIR_EraseRootFromParent_Done,
     /*   84498 */   // Label 2240: @84498
     /*   84498 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(84553), // Rule ID 666 //
     /*   84503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   84506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   84516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84520 */     // MIs[0] addr
     /*   84520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84536 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*   84539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84541 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84543 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84545 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84551 */     GIR_RootConstrainSelectedInstOperands,
     /*   84552 */     // GIR_Coverage, 666,
     /*   84552 */     GIR_EraseRootFromParent_Done,
     /*   84553 */   // Label 2241: @84553
     /*   84553 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(84608), // Rule ID 667 //
     /*   84558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   84561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84568 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   84571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84575 */     // MIs[0] addr
     /*   84575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84591 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*   84594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84596 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84598 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84600 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84606 */     GIR_RootConstrainSelectedInstOperands,
     /*   84607 */     // GIR_Coverage, 667,
     /*   84607 */     GIR_EraseRootFromParent_Done,
     /*   84608 */   // Label 2242: @84608
     /*   84608 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(84663), // Rule ID 668 //
     /*   84613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*   84616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   84626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84630 */     // MIs[0] addr
     /*   84630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84646 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84651 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84653 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84655 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84661 */     GIR_RootConstrainSelectedInstOperands,
     /*   84662 */     // GIR_Coverage, 668,
     /*   84662 */     GIR_EraseRootFromParent_Done,
     /*   84663 */   // Label 2243: @84663
     /*   84663 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(84718), // Rule ID 669 //
     /*   84668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*   84671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   84681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84685 */     // MIs[0] addr
     /*   84685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84701 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84706 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84708 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84710 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84716 */     GIR_RootConstrainSelectedInstOperands,
     /*   84717 */     // GIR_Coverage, 669,
     /*   84717 */     GIR_EraseRootFromParent_Done,
     /*   84718 */   // Label 2244: @84718
     /*   84718 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(84773), // Rule ID 670 //
     /*   84723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*   84726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   84736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84740 */     // MIs[0] addr
     /*   84740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84756 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84761 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84763 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84765 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84771 */     GIR_RootConstrainSelectedInstOperands,
     /*   84772 */     // GIR_Coverage, 670,
     /*   84772 */     GIR_EraseRootFromParent_Done,
     /*   84773 */   // Label 2245: @84773
     /*   84773 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(84828), // Rule ID 671 //
     /*   84778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*   84781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   84791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84795 */     // MIs[0] addr
     /*   84795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84811 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84816 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84818 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84820 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84826 */     GIR_RootConstrainSelectedInstOperands,
     /*   84827 */     // GIR_Coverage, 671,
     /*   84827 */     GIR_EraseRootFromParent_Done,
     /*   84828 */   // Label 2246: @84828
     /*   84828 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(84883), // Rule ID 672 //
     /*   84833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*   84836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   84843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   84846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84850 */     // MIs[0] addr
     /*   84850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84866 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*   84869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84871 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84873 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84875 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84881 */     GIR_RootConstrainSelectedInstOperands,
     /*   84882 */     // GIR_Coverage, 672,
     /*   84882 */     GIR_EraseRootFromParent_Done,
     /*   84883 */   // Label 2247: @84883
     /*   84883 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(84938), // Rule ID 1033 //
     /*   84888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   84891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   84898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   84901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84905 */     // MIs[0] addr
     /*   84905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84921 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   84924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84926 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84928 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84930 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84936 */     GIR_RootConstrainSelectedInstOperands,
     /*   84937 */     // GIR_Coverage, 1033,
     /*   84937 */     GIR_EraseRootFromParent_Done,
     /*   84938 */   // Label 2248: @84938
     /*   84938 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(84993), // Rule ID 1035 //
     /*   84943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   84946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   84953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   84956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84960 */     // MIs[0] addr
     /*   84960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   84964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   84976 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   84976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*   84979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   84981 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   84983 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   84985 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   84987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   84991 */     GIR_RootConstrainSelectedInstOperands,
     /*   84992 */     // GIR_Coverage, 1035,
     /*   84992 */     GIR_EraseRootFromParent_Done,
     /*   84993 */   // Label 2249: @84993
     /*   84993 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(85048), // Rule ID 1037 //
     /*   84998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   85011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85015 */     // MIs[0] addr
     /*   85015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85031 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*   85034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85036 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85038 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85040 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85046 */     GIR_RootConstrainSelectedInstOperands,
     /*   85047 */     // GIR_Coverage, 1037,
     /*   85047 */     GIR_EraseRootFromParent_Done,
     /*   85048 */   // Label 2250: @85048
     /*   85048 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(85103), // Rule ID 1039 //
     /*   85053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   85066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85070 */     // MIs[0] addr
     /*   85070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85086 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*   85089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85091 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85093 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85095 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85101 */     GIR_RootConstrainSelectedInstOperands,
     /*   85102 */     // GIR_Coverage, 1039,
     /*   85102 */     GIR_EraseRootFromParent_Done,
     /*   85103 */   // Label 2251: @85103
     /*   85103 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(85158), // Rule ID 1041 //
     /*   85108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   85121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85125 */     // MIs[0] addr
     /*   85125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85141 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*   85144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85146 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85148 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85150 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85156 */     GIR_RootConstrainSelectedInstOperands,
     /*   85157 */     // GIR_Coverage, 1041,
     /*   85157 */     GIR_EraseRootFromParent_Done,
     /*   85158 */   // Label 2252: @85158
     /*   85158 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(85213), // Rule ID 1043 //
     /*   85163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   85176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85180 */     // MIs[0] addr
     /*   85180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85196 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   85199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85201 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85203 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85205 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85211 */     GIR_RootConstrainSelectedInstOperands,
     /*   85212 */     // GIR_Coverage, 1043,
     /*   85212 */     GIR_EraseRootFromParent_Done,
     /*   85213 */   // Label 2253: @85213
     /*   85213 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(85268), // Rule ID 1045 //
     /*   85218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   85231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85235 */     // MIs[0] addr
     /*   85235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85251 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   85254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85256 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85258 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85260 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85266 */     GIR_RootConstrainSelectedInstOperands,
     /*   85267 */     // GIR_Coverage, 1045,
     /*   85267 */     GIR_EraseRootFromParent_Done,
     /*   85268 */   // Label 2254: @85268
     /*   85268 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(85323), // Rule ID 1047 //
     /*   85273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   85286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85290 */     // MIs[0] addr
     /*   85290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85306 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   85309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85311 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85313 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85315 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85321 */     GIR_RootConstrainSelectedInstOperands,
     /*   85322 */     // GIR_Coverage, 1047,
     /*   85322 */     GIR_EraseRootFromParent_Done,
     /*   85323 */   // Label 2255: @85323
     /*   85323 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(85378), // Rule ID 1049 //
     /*   85328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   85341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85345 */     // MIs[0] addr
     /*   85345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85361 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   85364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85366 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85368 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85370 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85376 */     GIR_RootConstrainSelectedInstOperands,
     /*   85377 */     // GIR_Coverage, 1049,
     /*   85377 */     GIR_EraseRootFromParent_Done,
     /*   85378 */   // Label 2256: @85378
     /*   85378 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(85433), // Rule ID 1051 //
     /*   85383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   85393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   85396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85400 */     // MIs[0] addr
     /*   85400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85416 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*   85419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85421 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85423 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85425 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85431 */     GIR_RootConstrainSelectedInstOperands,
     /*   85432 */     // GIR_Coverage, 1051,
     /*   85432 */     GIR_EraseRootFromParent_Done,
     /*   85433 */   // Label 2257: @85433
     /*   85433 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(85488), // Rule ID 1053 //
     /*   85438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   85451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85455 */     // MIs[0] addr
     /*   85455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85471 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85476 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85478 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85480 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85486 */     GIR_RootConstrainSelectedInstOperands,
     /*   85487 */     // GIR_Coverage, 1053,
     /*   85487 */     GIR_EraseRootFromParent_Done,
     /*   85488 */   // Label 2258: @85488
     /*   85488 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(85543), // Rule ID 1055 //
     /*   85493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   85506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85510 */     // MIs[0] addr
     /*   85510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85526 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*   85529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85531 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85533 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85535 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85541 */     GIR_RootConstrainSelectedInstOperands,
     /*   85542 */     // GIR_Coverage, 1055,
     /*   85542 */     GIR_EraseRootFromParent_Done,
     /*   85543 */   // Label 2259: @85543
     /*   85543 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(85598), // Rule ID 1057 //
     /*   85548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   85561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85565 */     // MIs[0] addr
     /*   85565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85581 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*   85584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85586 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85588 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85590 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85596 */     GIR_RootConstrainSelectedInstOperands,
     /*   85597 */     // GIR_Coverage, 1057,
     /*   85597 */     GIR_EraseRootFromParent_Done,
     /*   85598 */   // Label 2260: @85598
     /*   85598 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(85653), // Rule ID 1059 //
     /*   85603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   85616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85620 */     // MIs[0] addr
     /*   85620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85636 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*   85639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85641 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85643 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85645 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85651 */     GIR_RootConstrainSelectedInstOperands,
     /*   85652 */     // GIR_Coverage, 1059,
     /*   85652 */     GIR_EraseRootFromParent_Done,
     /*   85653 */   // Label 2261: @85653
     /*   85653 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(85708), // Rule ID 1061 //
     /*   85658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*   85661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   85671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85675 */     // MIs[0] addr
     /*   85675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85691 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*   85694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85696 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85698 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85700 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85706 */     GIR_RootConstrainSelectedInstOperands,
     /*   85707 */     // GIR_Coverage, 1061,
     /*   85707 */     GIR_EraseRootFromParent_Done,
     /*   85708 */   // Label 2262: @85708
     /*   85708 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(85763), // Rule ID 1063 //
     /*   85713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   85726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85730 */     // MIs[0] addr
     /*   85730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85746 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85751 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85753 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85755 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85761 */     GIR_RootConstrainSelectedInstOperands,
     /*   85762 */     // GIR_Coverage, 1063,
     /*   85762 */     GIR_EraseRootFromParent_Done,
     /*   85763 */   // Label 2263: @85763
     /*   85763 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(85818), // Rule ID 1065 //
     /*   85768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   85781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85785 */     // MIs[0] addr
     /*   85785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85801 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85806 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85808 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85810 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85816 */     GIR_RootConstrainSelectedInstOperands,
     /*   85817 */     // GIR_Coverage, 1065,
     /*   85817 */     GIR_EraseRootFromParent_Done,
     /*   85818 */   // Label 2264: @85818
     /*   85818 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(85873), // Rule ID 1067 //
     /*   85823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   85836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85840 */     // MIs[0] addr
     /*   85840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85856 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85861 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85863 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85865 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85871 */     GIR_RootConstrainSelectedInstOperands,
     /*   85872 */     // GIR_Coverage, 1067,
     /*   85872 */     GIR_EraseRootFromParent_Done,
     /*   85873 */   // Label 2265: @85873
     /*   85873 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(85928), // Rule ID 1069 //
     /*   85878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85881 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85888 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   85891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85895 */     // MIs[0] addr
     /*   85895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85911 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85916 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85918 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85920 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85926 */     GIR_RootConstrainSelectedInstOperands,
     /*   85927 */     // GIR_Coverage, 1069,
     /*   85927 */     GIR_EraseRootFromParent_Done,
     /*   85928 */   // Label 2266: @85928
     /*   85928 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(85983), // Rule ID 1071 //
     /*   85933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*   85936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   85943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   85946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85950 */     // MIs[0] addr
     /*   85950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   85954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   85966 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*   85966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*   85969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   85971 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*   85973 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   85975 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*   85977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   85981 */     GIR_RootConstrainSelectedInstOperands,
     /*   85982 */     // GIR_Coverage, 1071,
     /*   85982 */     GIR_EraseRootFromParent_Done,
     /*   85983 */   // Label 2267: @85983
     /*   85983 */   GIM_Reject,
     /*   85984 */ // Label 2217: @85984
     /*   85984 */ GIM_Reject,
     /*   85985 */ // Label 2180: @85985
     /*   85985 */ GIM_Reject,
     /*   85986 */ // Label 26: @85986
     /*   85986 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2270*/ GIMT_Encode4(88895),
     /*   85997 */ /*GILLT_s32*//*Label 2268*/ GIMT_Encode4(86005),
     /*   86001 */ /*GILLT_s64*//*Label 2269*/ GIMT_Encode4(87245),
     /*   86005 */ // Label 2268: @86005
     /*   86005 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(87244),
     /*   86010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   86013 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(86054), // Rule ID 326 //
     /*   86018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   86021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   86031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86035 */     // MIs[0] rs1
     /*   86035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86047 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86052 */     GIR_RootConstrainSelectedInstOperands,
     /*   86053 */     // GIR_Coverage, 326,
     /*   86053 */     GIR_Done,
     /*   86054 */   // Label 2272: @86054
     /*   86054 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(86095), // Rule ID 328 //
     /*   86059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   86062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   86072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86076 */     // MIs[0] rs1
     /*   86076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86088 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*   86093 */     GIR_RootConstrainSelectedInstOperands,
     /*   86094 */     // GIR_Coverage, 328,
     /*   86094 */     GIR_Done,
     /*   86095 */   // Label 2273: @86095
     /*   86095 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(86136), // Rule ID 330 //
     /*   86100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   86103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   86113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86117 */     // MIs[0] rs1
     /*   86117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86129 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*   86134 */     GIR_RootConstrainSelectedInstOperands,
     /*   86135 */     // GIR_Coverage, 330,
     /*   86135 */     GIR_Done,
     /*   86136 */   // Label 2274: @86136
     /*   86136 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(86177), // Rule ID 332 //
     /*   86141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   86144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   86154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86158 */     // MIs[0] rs1
     /*   86158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86170 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*   86175 */     GIR_RootConstrainSelectedInstOperands,
     /*   86176 */     // GIR_Coverage, 332,
     /*   86176 */     GIR_Done,
     /*   86177 */   // Label 2275: @86177
     /*   86177 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(86218), // Rule ID 334 //
     /*   86182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   86185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   86195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86199 */     // MIs[0] rs1
     /*   86199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86211 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*   86216 */     GIR_RootConstrainSelectedInstOperands,
     /*   86217 */     // GIR_Coverage, 334,
     /*   86217 */     GIR_Done,
     /*   86218 */   // Label 2276: @86218
     /*   86218 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(86259), // Rule ID 336 //
     /*   86223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   86226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   86236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86240 */     // MIs[0] rs1
     /*   86240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86252 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86257 */     GIR_RootConstrainSelectedInstOperands,
     /*   86258 */     // GIR_Coverage, 336,
     /*   86258 */     GIR_Done,
     /*   86259 */   // Label 2277: @86259
     /*   86259 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(86300), // Rule ID 338 //
     /*   86264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   86267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   86277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86281 */     // MIs[0] rs1
     /*   86281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86293 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86298 */     GIR_RootConstrainSelectedInstOperands,
     /*   86299 */     // GIR_Coverage, 338,
     /*   86299 */     GIR_Done,
     /*   86300 */   // Label 2278: @86300
     /*   86300 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(86341), // Rule ID 340 //
     /*   86305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   86308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   86318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86322 */     // MIs[0] rs1
     /*   86322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86334 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86339 */     GIR_RootConstrainSelectedInstOperands,
     /*   86340 */     // GIR_Coverage, 340,
     /*   86340 */     GIR_Done,
     /*   86341 */   // Label 2279: @86341
     /*   86341 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(86382), // Rule ID 342 //
     /*   86346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   86349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   86359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86363 */     // MIs[0] rs1
     /*   86363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86375 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86380 */     GIR_RootConstrainSelectedInstOperands,
     /*   86381 */     // GIR_Coverage, 342,
     /*   86381 */     GIR_Done,
     /*   86382 */   // Label 2280: @86382
     /*   86382 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(86423), // Rule ID 344 //
     /*   86387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   86390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   86397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   86400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86404 */     // MIs[0] rs1
     /*   86404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86416 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   86421 */     GIR_RootConstrainSelectedInstOperands,
     /*   86422 */     // GIR_Coverage, 344,
     /*   86422 */     GIR_Done,
     /*   86423 */   // Label 2281: @86423
     /*   86423 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(86464), // Rule ID 674 //
     /*   86428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86438 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   86441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86445 */     // MIs[0] rs1
     /*   86445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86457 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86462 */     GIR_RootConstrainSelectedInstOperands,
     /*   86463 */     // GIR_Coverage, 674,
     /*   86463 */     GIR_Done,
     /*   86464 */   // Label 2282: @86464
     /*   86464 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(86505), // Rule ID 676 //
     /*   86469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   86482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86486 */     // MIs[0] rs1
     /*   86486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86498 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*   86503 */     GIR_RootConstrainSelectedInstOperands,
     /*   86504 */     // GIR_Coverage, 676,
     /*   86504 */     GIR_Done,
     /*   86505 */   // Label 2283: @86505
     /*   86505 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(86546), // Rule ID 678 //
     /*   86510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   86523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86527 */     // MIs[0] rs1
     /*   86527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86539 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*   86544 */     GIR_RootConstrainSelectedInstOperands,
     /*   86545 */     // GIR_Coverage, 678,
     /*   86545 */     GIR_Done,
     /*   86546 */   // Label 2284: @86546
     /*   86546 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(86587), // Rule ID 680 //
     /*   86551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   86564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86568 */     // MIs[0] rs1
     /*   86568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86580 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*   86585 */     GIR_RootConstrainSelectedInstOperands,
     /*   86586 */     // GIR_Coverage, 680,
     /*   86586 */     GIR_Done,
     /*   86587 */   // Label 2285: @86587
     /*   86587 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(86628), // Rule ID 682 //
     /*   86592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   86605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86609 */     // MIs[0] rs1
     /*   86609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86621 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*   86626 */     GIR_RootConstrainSelectedInstOperands,
     /*   86627 */     // GIR_Coverage, 682,
     /*   86627 */     GIR_Done,
     /*   86628 */   // Label 2286: @86628
     /*   86628 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(86669), // Rule ID 684 //
     /*   86633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   86636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   86646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86650 */     // MIs[0] rs1
     /*   86650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86662 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86667 */     GIR_RootConstrainSelectedInstOperands,
     /*   86668 */     // GIR_Coverage, 684,
     /*   86668 */     GIR_Done,
     /*   86669 */   // Label 2287: @86669
     /*   86669 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(86710), // Rule ID 686 //
     /*   86674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   86677 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86684 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   86687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86691 */     // MIs[0] rs1
     /*   86691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86703 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86708 */     GIR_RootConstrainSelectedInstOperands,
     /*   86709 */     // GIR_Coverage, 686,
     /*   86709 */     GIR_Done,
     /*   86710 */   // Label 2288: @86710
     /*   86710 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(86751), // Rule ID 688 //
     /*   86715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   86718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   86728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86732 */     // MIs[0] rs1
     /*   86732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86744 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86749 */     GIR_RootConstrainSelectedInstOperands,
     /*   86750 */     // GIR_Coverage, 688,
     /*   86750 */     GIR_Done,
     /*   86751 */   // Label 2289: @86751
     /*   86751 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(86792), // Rule ID 690 //
     /*   86756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   86759 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86766 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   86769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86773 */     // MIs[0] rs1
     /*   86773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86785 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86790 */     GIR_RootConstrainSelectedInstOperands,
     /*   86791 */     // GIR_Coverage, 690,
     /*   86791 */     GIR_Done,
     /*   86792 */   // Label 2290: @86792
     /*   86792 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(86833), // Rule ID 692 //
     /*   86797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   86800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   86807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   86810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86814 */     // MIs[0] rs1
     /*   86814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86826 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   86831 */     GIR_RootConstrainSelectedInstOperands,
     /*   86832 */     // GIR_Coverage, 692,
     /*   86832 */     GIR_Done,
     /*   86833 */   // Label 2291: @86833
     /*   86833 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(86874), // Rule ID 854 //
     /*   86838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   86848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   86851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86855 */     // MIs[0] rs1
     /*   86855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86867 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   86872 */     GIR_RootConstrainSelectedInstOperands,
     /*   86873 */     // GIR_Coverage, 854,
     /*   86873 */     GIR_Done,
     /*   86874 */   // Label 2292: @86874
     /*   86874 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(86915), // Rule ID 856 //
     /*   86879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   86889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   86892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86896 */     // MIs[0] rs1
     /*   86896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86908 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*   86913 */     GIR_RootConstrainSelectedInstOperands,
     /*   86914 */     // GIR_Coverage, 856,
     /*   86914 */     GIR_Done,
     /*   86915 */   // Label 2293: @86915
     /*   86915 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(86956), // Rule ID 858 //
     /*   86920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   86930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   86933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86937 */     // MIs[0] rs1
     /*   86937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86949 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*   86954 */     GIR_RootConstrainSelectedInstOperands,
     /*   86955 */     // GIR_Coverage, 858,
     /*   86955 */     GIR_Done,
     /*   86956 */   // Label 2294: @86956
     /*   86956 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(86997), // Rule ID 860 //
     /*   86961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   86964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   86971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86978 */     // MIs[0] rs1
     /*   86978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   86982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   86990 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   86990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*   86995 */     GIR_RootConstrainSelectedInstOperands,
     /*   86996 */     // GIR_Coverage, 860,
     /*   86996 */     GIR_Done,
     /*   86997 */   // Label 2295: @86997
     /*   86997 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(87038), // Rule ID 862 //
     /*   87002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   87005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   87015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87019 */     // MIs[0] rs1
     /*   87019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87031 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*   87036 */     GIR_RootConstrainSelectedInstOperands,
     /*   87037 */     // GIR_Coverage, 862,
     /*   87037 */     GIR_Done,
     /*   87038 */   // Label 2296: @87038
     /*   87038 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(87079), // Rule ID 864 //
     /*   87043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   87046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   87056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87060 */     // MIs[0] rs1
     /*   87060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87072 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   87077 */     GIR_RootConstrainSelectedInstOperands,
     /*   87078 */     // GIR_Coverage, 864,
     /*   87078 */     GIR_Done,
     /*   87079 */   // Label 2297: @87079
     /*   87079 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(87120), // Rule ID 866 //
     /*   87084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   87087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   87097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87101 */     // MIs[0] rs1
     /*   87101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87113 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   87118 */     GIR_RootConstrainSelectedInstOperands,
     /*   87119 */     // GIR_Coverage, 866,
     /*   87119 */     GIR_Done,
     /*   87120 */   // Label 2298: @87120
     /*   87120 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(87161), // Rule ID 868 //
     /*   87125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   87128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   87138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87142 */     // MIs[0] rs1
     /*   87142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87154 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   87159 */     GIR_RootConstrainSelectedInstOperands,
     /*   87160 */     // GIR_Coverage, 868,
     /*   87160 */     GIR_Done,
     /*   87161 */   // Label 2299: @87161
     /*   87161 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(87202), // Rule ID 870 //
     /*   87166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   87169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   87179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87183 */     // MIs[0] rs1
     /*   87183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87195 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   87200 */     GIR_RootConstrainSelectedInstOperands,
     /*   87201 */     // GIR_Coverage, 870,
     /*   87201 */     GIR_Done,
     /*   87202 */   // Label 2300: @87202
     /*   87202 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(87243), // Rule ID 872 //
     /*   87207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   87210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   87217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   87220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87224 */     // MIs[0] rs1
     /*   87224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   87228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87236 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   87236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   87241 */     GIR_RootConstrainSelectedInstOperands,
     /*   87242 */     // GIR_Coverage, 872,
     /*   87242 */     GIR_Done,
     /*   87243 */   // Label 2301: @87243
     /*   87243 */   GIM_Reject,
     /*   87244 */ // Label 2271: @87244
     /*   87244 */ GIM_Reject,
     /*   87245 */ // Label 2269: @87245
     /*   87245 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(88894),
     /*   87250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   87253 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(87294), // Rule ID 325 //
     /*   87258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   87261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   87271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87275 */     // MIs[0] rs1
     /*   87275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87287 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87292 */     GIR_RootConstrainSelectedInstOperands,
     /*   87293 */     // GIR_Coverage, 325,
     /*   87293 */     GIR_Done,
     /*   87294 */   // Label 2303: @87294
     /*   87294 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(87335), // Rule ID 327 //
     /*   87299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   87302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   87312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87316 */     // MIs[0] rs1
     /*   87316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87328 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*   87333 */     GIR_RootConstrainSelectedInstOperands,
     /*   87334 */     // GIR_Coverage, 327,
     /*   87334 */     GIR_Done,
     /*   87335 */   // Label 2304: @87335
     /*   87335 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(87376), // Rule ID 329 //
     /*   87340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   87343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   87353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87357 */     // MIs[0] rs1
     /*   87357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87369 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*   87374 */     GIR_RootConstrainSelectedInstOperands,
     /*   87375 */     // GIR_Coverage, 329,
     /*   87375 */     GIR_Done,
     /*   87376 */   // Label 2305: @87376
     /*   87376 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(87417), // Rule ID 331 //
     /*   87381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   87384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   87394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87398 */     // MIs[0] rs1
     /*   87398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87410 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*   87415 */     GIR_RootConstrainSelectedInstOperands,
     /*   87416 */     // GIR_Coverage, 331,
     /*   87416 */     GIR_Done,
     /*   87417 */   // Label 2306: @87417
     /*   87417 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(87458), // Rule ID 333 //
     /*   87422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   87425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   87435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87439 */     // MIs[0] rs1
     /*   87439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87451 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*   87456 */     GIR_RootConstrainSelectedInstOperands,
     /*   87457 */     // GIR_Coverage, 333,
     /*   87457 */     GIR_Done,
     /*   87458 */   // Label 2307: @87458
     /*   87458 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(87499), // Rule ID 335 //
     /*   87463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   87466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   87476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87480 */     // MIs[0] rs1
     /*   87480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87492 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87497 */     GIR_RootConstrainSelectedInstOperands,
     /*   87498 */     // GIR_Coverage, 335,
     /*   87498 */     GIR_Done,
     /*   87499 */   // Label 2308: @87499
     /*   87499 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(87540), // Rule ID 337 //
     /*   87504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   87507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   87517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87521 */     // MIs[0] rs1
     /*   87521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87533 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87538 */     GIR_RootConstrainSelectedInstOperands,
     /*   87539 */     // GIR_Coverage, 337,
     /*   87539 */     GIR_Done,
     /*   87540 */   // Label 2309: @87540
     /*   87540 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(87581), // Rule ID 339 //
     /*   87545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   87548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   87558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87562 */     // MIs[0] rs1
     /*   87562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87574 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87579 */     GIR_RootConstrainSelectedInstOperands,
     /*   87580 */     // GIR_Coverage, 339,
     /*   87580 */     GIR_Done,
     /*   87581 */   // Label 2310: @87581
     /*   87581 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(87622), // Rule ID 341 //
     /*   87586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   87589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   87599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87603 */     // MIs[0] rs1
     /*   87603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87615 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87620 */     GIR_RootConstrainSelectedInstOperands,
     /*   87621 */     // GIR_Coverage, 341,
     /*   87621 */     GIR_Done,
     /*   87622 */   // Label 2311: @87622
     /*   87622 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(87663), // Rule ID 343 //
     /*   87627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   87630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   87637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   87640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87644 */     // MIs[0] rs1
     /*   87644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87656 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*   87661 */     GIR_RootConstrainSelectedInstOperands,
     /*   87662 */     // GIR_Coverage, 343,
     /*   87662 */     GIR_Done,
     /*   87663 */   // Label 2312: @87663
     /*   87663 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(87704), // Rule ID 505 //
     /*   87668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   87671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   87681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87685 */     // MIs[0] rs1
     /*   87685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87697 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   87702 */     GIR_RootConstrainSelectedInstOperands,
     /*   87703 */     // GIR_Coverage, 505,
     /*   87703 */     GIR_Done,
     /*   87704 */   // Label 2313: @87704
     /*   87704 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(87745), // Rule ID 506 //
     /*   87709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   87712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   87722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87726 */     // MIs[0] rs1
     /*   87726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87738 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*   87743 */     GIR_RootConstrainSelectedInstOperands,
     /*   87744 */     // GIR_Coverage, 506,
     /*   87744 */     GIR_Done,
     /*   87745 */   // Label 2314: @87745
     /*   87745 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(87786), // Rule ID 507 //
     /*   87750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   87753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   87763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87767 */     // MIs[0] rs1
     /*   87767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87779 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*   87784 */     GIR_RootConstrainSelectedInstOperands,
     /*   87785 */     // GIR_Coverage, 507,
     /*   87785 */     GIR_Done,
     /*   87786 */   // Label 2315: @87786
     /*   87786 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(87827), // Rule ID 508 //
     /*   87791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   87794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   87804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87808 */     // MIs[0] rs1
     /*   87808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87820 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*   87825 */     GIR_RootConstrainSelectedInstOperands,
     /*   87826 */     // GIR_Coverage, 508,
     /*   87826 */     GIR_Done,
     /*   87827 */   // Label 2316: @87827
     /*   87827 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(87868), // Rule ID 509 //
     /*   87832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   87835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   87845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87849 */     // MIs[0] rs1
     /*   87849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87861 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*   87866 */     GIR_RootConstrainSelectedInstOperands,
     /*   87867 */     // GIR_Coverage, 509,
     /*   87867 */     GIR_Done,
     /*   87868 */   // Label 2317: @87868
     /*   87868 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(87909), // Rule ID 510 //
     /*   87873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   87876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   87886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87890 */     // MIs[0] rs1
     /*   87890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87902 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   87907 */     GIR_RootConstrainSelectedInstOperands,
     /*   87908 */     // GIR_Coverage, 510,
     /*   87908 */     GIR_Done,
     /*   87909 */   // Label 2318: @87909
     /*   87909 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(87950), // Rule ID 511 //
     /*   87914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   87917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   87927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87931 */     // MIs[0] rs1
     /*   87931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87943 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   87948 */     GIR_RootConstrainSelectedInstOperands,
     /*   87949 */     // GIR_Coverage, 511,
     /*   87949 */     GIR_Done,
     /*   87950 */   // Label 2319: @87950
     /*   87950 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(87991), // Rule ID 512 //
     /*   87955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   87958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   87965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   87968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87972 */     // MIs[0] rs1
     /*   87972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   87976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   87984 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   87984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   87989 */     GIR_RootConstrainSelectedInstOperands,
     /*   87990 */     // GIR_Coverage, 512,
     /*   87990 */     GIR_Done,
     /*   87991 */   // Label 2320: @87991
     /*   87991 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(88032), // Rule ID 513 //
     /*   87996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   87999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   88006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   88009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88013 */     // MIs[0] rs1
     /*   88013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88025 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   88030 */     GIR_RootConstrainSelectedInstOperands,
     /*   88031 */     // GIR_Coverage, 513,
     /*   88031 */     GIR_Done,
     /*   88032 */   // Label 2321: @88032
     /*   88032 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(88073), // Rule ID 514 //
     /*   88037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   88040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   88047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   88050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88054 */     // MIs[0] rs1
     /*   88054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88066 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*   88071 */     GIR_RootConstrainSelectedInstOperands,
     /*   88072 */     // GIR_Coverage, 514,
     /*   88072 */     GIR_Done,
     /*   88073 */   // Label 2322: @88073
     /*   88073 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(88114), // Rule ID 673 //
     /*   88078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   88091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88095 */     // MIs[0] rs1
     /*   88095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88107 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88112 */     GIR_RootConstrainSelectedInstOperands,
     /*   88113 */     // GIR_Coverage, 673,
     /*   88113 */     GIR_Done,
     /*   88114 */   // Label 2323: @88114
     /*   88114 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(88155), // Rule ID 675 //
     /*   88119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   88132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88136 */     // MIs[0] rs1
     /*   88136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88148 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*   88153 */     GIR_RootConstrainSelectedInstOperands,
     /*   88154 */     // GIR_Coverage, 675,
     /*   88154 */     GIR_Done,
     /*   88155 */   // Label 2324: @88155
     /*   88155 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(88196), // Rule ID 677 //
     /*   88160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   88173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88177 */     // MIs[0] rs1
     /*   88177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88189 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*   88194 */     GIR_RootConstrainSelectedInstOperands,
     /*   88195 */     // GIR_Coverage, 677,
     /*   88195 */     GIR_Done,
     /*   88196 */   // Label 2325: @88196
     /*   88196 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(88237), // Rule ID 679 //
     /*   88201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   88214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88218 */     // MIs[0] rs1
     /*   88218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88230 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*   88235 */     GIR_RootConstrainSelectedInstOperands,
     /*   88236 */     // GIR_Coverage, 679,
     /*   88236 */     GIR_Done,
     /*   88237 */   // Label 2326: @88237
     /*   88237 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(88278), // Rule ID 681 //
     /*   88242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   88255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88259 */     // MIs[0] rs1
     /*   88259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88271 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*   88276 */     GIR_RootConstrainSelectedInstOperands,
     /*   88277 */     // GIR_Coverage, 681,
     /*   88277 */     GIR_Done,
     /*   88278 */   // Label 2327: @88278
     /*   88278 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(88319), // Rule ID 683 //
     /*   88283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   88296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88300 */     // MIs[0] rs1
     /*   88300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88312 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88317 */     GIR_RootConstrainSelectedInstOperands,
     /*   88318 */     // GIR_Coverage, 683,
     /*   88318 */     GIR_Done,
     /*   88319 */   // Label 2328: @88319
     /*   88319 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(88360), // Rule ID 685 //
     /*   88324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   88337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88341 */     // MIs[0] rs1
     /*   88341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88353 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88358 */     GIR_RootConstrainSelectedInstOperands,
     /*   88359 */     // GIR_Coverage, 685,
     /*   88359 */     GIR_Done,
     /*   88360 */   // Label 2329: @88360
     /*   88360 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(88401), // Rule ID 687 //
     /*   88365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   88378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88382 */     // MIs[0] rs1
     /*   88382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88394 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88399 */     GIR_RootConstrainSelectedInstOperands,
     /*   88400 */     // GIR_Coverage, 687,
     /*   88400 */     GIR_Done,
     /*   88401 */   // Label 2330: @88401
     /*   88401 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(88442), // Rule ID 689 //
     /*   88406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   88419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88423 */     // MIs[0] rs1
     /*   88423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88435 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88440 */     GIR_RootConstrainSelectedInstOperands,
     /*   88441 */     // GIR_Coverage, 689,
     /*   88441 */     GIR_Done,
     /*   88442 */   // Label 2331: @88442
     /*   88442 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(88483), // Rule ID 691 //
     /*   88447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   88457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   88460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88464 */     // MIs[0] rs1
     /*   88464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88476 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*   88481 */     GIR_RootConstrainSelectedInstOperands,
     /*   88482 */     // GIR_Coverage, 691,
     /*   88482 */     GIR_Done,
     /*   88483 */   // Label 2332: @88483
     /*   88483 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(88524), // Rule ID 853 //
     /*   88488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   88501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88505 */     // MIs[0] rs1
     /*   88505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88517 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88522 */     GIR_RootConstrainSelectedInstOperands,
     /*   88523 */     // GIR_Coverage, 853,
     /*   88523 */     GIR_Done,
     /*   88524 */   // Label 2333: @88524
     /*   88524 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(88565), // Rule ID 855 //
     /*   88529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   88542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88546 */     // MIs[0] rs1
     /*   88546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88558 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*   88563 */     GIR_RootConstrainSelectedInstOperands,
     /*   88564 */     // GIR_Coverage, 855,
     /*   88564 */     GIR_Done,
     /*   88565 */   // Label 2334: @88565
     /*   88565 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(88606), // Rule ID 857 //
     /*   88570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   88583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88587 */     // MIs[0] rs1
     /*   88587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88599 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*   88604 */     GIR_RootConstrainSelectedInstOperands,
     /*   88605 */     // GIR_Coverage, 857,
     /*   88605 */     GIR_Done,
     /*   88606 */   // Label 2335: @88606
     /*   88606 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(88647), // Rule ID 859 //
     /*   88611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   88624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88628 */     // MIs[0] rs1
     /*   88628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88640 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*   88645 */     GIR_RootConstrainSelectedInstOperands,
     /*   88646 */     // GIR_Coverage, 859,
     /*   88646 */     GIR_Done,
     /*   88647 */   // Label 2336: @88647
     /*   88647 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(88688), // Rule ID 861 //
     /*   88652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   88655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   88665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88669 */     // MIs[0] rs1
     /*   88669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88681 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*   88686 */     GIR_RootConstrainSelectedInstOperands,
     /*   88687 */     // GIR_Coverage, 861,
     /*   88687 */     GIR_Done,
     /*   88688 */   // Label 2337: @88688
     /*   88688 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(88729), // Rule ID 863 //
     /*   88693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   88706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88710 */     // MIs[0] rs1
     /*   88710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88722 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88727 */     GIR_RootConstrainSelectedInstOperands,
     /*   88728 */     // GIR_Coverage, 863,
     /*   88728 */     GIR_Done,
     /*   88729 */   // Label 2338: @88729
     /*   88729 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(88770), // Rule ID 865 //
     /*   88734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   88747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88751 */     // MIs[0] rs1
     /*   88751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88763 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88768 */     GIR_RootConstrainSelectedInstOperands,
     /*   88769 */     // GIR_Coverage, 865,
     /*   88769 */     GIR_Done,
     /*   88770 */   // Label 2339: @88770
     /*   88770 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(88811), // Rule ID 867 //
     /*   88775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   88788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88792 */     // MIs[0] rs1
     /*   88792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88804 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88809 */     GIR_RootConstrainSelectedInstOperands,
     /*   88810 */     // GIR_Coverage, 867,
     /*   88810 */     GIR_Done,
     /*   88811 */   // Label 2340: @88811
     /*   88811 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(88852), // Rule ID 869 //
     /*   88816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   88829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88833 */     // MIs[0] rs1
     /*   88833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88845 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88850 */     GIR_RootConstrainSelectedInstOperands,
     /*   88851 */     // GIR_Coverage, 869,
     /*   88851 */     GIR_Done,
     /*   88852 */   // Label 2341: @88852
     /*   88852 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(88893), // Rule ID 871 //
     /*   88857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   88860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   88867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   88870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88874 */     // MIs[0] rs1
     /*   88874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   88878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88886 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   88886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*   88891 */     GIR_RootConstrainSelectedInstOperands,
     /*   88892 */     // GIR_Coverage, 871,
     /*   88892 */     GIR_Done,
     /*   88893 */   // Label 2342: @88893
     /*   88893 */   GIM_Reject,
     /*   88894 */ // Label 2302: @88894
     /*   88894 */ GIM_Reject,
     /*   88895 */ // Label 2270: @88895
     /*   88895 */ GIM_Reject,
     /*   88896 */ // Label 27: @88896
     /*   88896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2345*/ GIMT_Encode4(91805),
     /*   88907 */ /*GILLT_s32*//*Label 2343*/ GIMT_Encode4(88915),
     /*   88911 */ /*GILLT_s64*//*Label 2344*/ GIMT_Encode4(90155),
     /*   88915 */ // Label 2343: @88915
     /*   88915 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(90154),
     /*   88920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   88923 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(88964), // Rule ID 346 //
     /*   88928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   88931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   88938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   88941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88945 */     // MIs[0] rs1
     /*   88945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   88949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88957 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   88957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   88962 */     GIR_RootConstrainSelectedInstOperands,
     /*   88963 */     // GIR_Coverage, 346,
     /*   88963 */     GIR_Done,
     /*   88964 */   // Label 2347: @88964
     /*   88964 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(89005), // Rule ID 348 //
     /*   88969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   88972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   88979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   88982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88986 */     // MIs[0] rs1
     /*   88986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   88990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   88998 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   88998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*   89003 */     GIR_RootConstrainSelectedInstOperands,
     /*   89004 */     // GIR_Coverage, 348,
     /*   89004 */     GIR_Done,
     /*   89005 */   // Label 2348: @89005
     /*   89005 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(89046), // Rule ID 350 //
     /*   89010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   89013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   89023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89027 */     // MIs[0] rs1
     /*   89027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89039 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*   89044 */     GIR_RootConstrainSelectedInstOperands,
     /*   89045 */     // GIR_Coverage, 350,
     /*   89045 */     GIR_Done,
     /*   89046 */   // Label 2349: @89046
     /*   89046 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(89087), // Rule ID 352 //
     /*   89051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   89054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   89064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89068 */     // MIs[0] rs1
     /*   89068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89080 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*   89085 */     GIR_RootConstrainSelectedInstOperands,
     /*   89086 */     // GIR_Coverage, 352,
     /*   89086 */     GIR_Done,
     /*   89087 */   // Label 2350: @89087
     /*   89087 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(89128), // Rule ID 354 //
     /*   89092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   89095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   89105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89109 */     // MIs[0] rs1
     /*   89109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89121 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*   89126 */     GIR_RootConstrainSelectedInstOperands,
     /*   89127 */     // GIR_Coverage, 354,
     /*   89127 */     GIR_Done,
     /*   89128 */   // Label 2351: @89128
     /*   89128 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(89169), // Rule ID 356 //
     /*   89133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   89136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   89146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89150 */     // MIs[0] rs1
     /*   89150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89162 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   89167 */     GIR_RootConstrainSelectedInstOperands,
     /*   89168 */     // GIR_Coverage, 356,
     /*   89168 */     GIR_Done,
     /*   89169 */   // Label 2352: @89169
     /*   89169 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(89210), // Rule ID 358 //
     /*   89174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   89177 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   89187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89191 */     // MIs[0] rs1
     /*   89191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89203 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   89208 */     GIR_RootConstrainSelectedInstOperands,
     /*   89209 */     // GIR_Coverage, 358,
     /*   89209 */     GIR_Done,
     /*   89210 */   // Label 2353: @89210
     /*   89210 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(89251), // Rule ID 360 //
     /*   89215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   89218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   89228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89232 */     // MIs[0] rs1
     /*   89232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89244 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   89249 */     GIR_RootConstrainSelectedInstOperands,
     /*   89250 */     // GIR_Coverage, 360,
     /*   89250 */     GIR_Done,
     /*   89251 */   // Label 2354: @89251
     /*   89251 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(89292), // Rule ID 362 //
     /*   89256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   89259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   89269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89273 */     // MIs[0] rs1
     /*   89273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89285 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   89290 */     GIR_RootConstrainSelectedInstOperands,
     /*   89291 */     // GIR_Coverage, 362,
     /*   89291 */     GIR_Done,
     /*   89292 */   // Label 2355: @89292
     /*   89292 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(89333), // Rule ID 364 //
     /*   89297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   89300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   89307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   89310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89314 */     // MIs[0] rs1
     /*   89314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89326 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   89331 */     GIR_RootConstrainSelectedInstOperands,
     /*   89332 */     // GIR_Coverage, 364,
     /*   89332 */     GIR_Done,
     /*   89333 */   // Label 2356: @89333
     /*   89333 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(89374), // Rule ID 694 //
     /*   89338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   89351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89355 */     // MIs[0] rs1
     /*   89355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89367 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89372 */     GIR_RootConstrainSelectedInstOperands,
     /*   89373 */     // GIR_Coverage, 694,
     /*   89373 */     GIR_Done,
     /*   89374 */   // Label 2357: @89374
     /*   89374 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(89415), // Rule ID 696 //
     /*   89379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   89392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89396 */     // MIs[0] rs1
     /*   89396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89408 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*   89413 */     GIR_RootConstrainSelectedInstOperands,
     /*   89414 */     // GIR_Coverage, 696,
     /*   89414 */     GIR_Done,
     /*   89415 */   // Label 2358: @89415
     /*   89415 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(89456), // Rule ID 698 //
     /*   89420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   89433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89437 */     // MIs[0] rs1
     /*   89437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89449 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*   89454 */     GIR_RootConstrainSelectedInstOperands,
     /*   89455 */     // GIR_Coverage, 698,
     /*   89455 */     GIR_Done,
     /*   89456 */   // Label 2359: @89456
     /*   89456 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(89497), // Rule ID 700 //
     /*   89461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89471 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   89474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89478 */     // MIs[0] rs1
     /*   89478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89490 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*   89495 */     GIR_RootConstrainSelectedInstOperands,
     /*   89496 */     // GIR_Coverage, 700,
     /*   89496 */     GIR_Done,
     /*   89497 */   // Label 2360: @89497
     /*   89497 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(89538), // Rule ID 702 //
     /*   89502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89505 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   89515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89519 */     // MIs[0] rs1
     /*   89519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89531 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*   89536 */     GIR_RootConstrainSelectedInstOperands,
     /*   89537 */     // GIR_Coverage, 702,
     /*   89537 */     GIR_Done,
     /*   89538 */   // Label 2361: @89538
     /*   89538 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(89579), // Rule ID 704 //
     /*   89543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   89556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89560 */     // MIs[0] rs1
     /*   89560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89572 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89577 */     GIR_RootConstrainSelectedInstOperands,
     /*   89578 */     // GIR_Coverage, 704,
     /*   89578 */     GIR_Done,
     /*   89579 */   // Label 2362: @89579
     /*   89579 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(89620), // Rule ID 706 //
     /*   89584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89587 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   89597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89601 */     // MIs[0] rs1
     /*   89601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89613 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89618 */     GIR_RootConstrainSelectedInstOperands,
     /*   89619 */     // GIR_Coverage, 706,
     /*   89619 */     GIR_Done,
     /*   89620 */   // Label 2363: @89620
     /*   89620 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(89661), // Rule ID 708 //
     /*   89625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89628 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   89638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89642 */     // MIs[0] rs1
     /*   89642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89654 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89659 */     GIR_RootConstrainSelectedInstOperands,
     /*   89660 */     // GIR_Coverage, 708,
     /*   89660 */     GIR_Done,
     /*   89661 */   // Label 2364: @89661
     /*   89661 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(89702), // Rule ID 710 //
     /*   89666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   89679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89683 */     // MIs[0] rs1
     /*   89683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89695 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89700 */     GIR_RootConstrainSelectedInstOperands,
     /*   89701 */     // GIR_Coverage, 710,
     /*   89701 */     GIR_Done,
     /*   89702 */   // Label 2365: @89702
     /*   89702 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(89743), // Rule ID 712 //
     /*   89707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   89717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   89720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89724 */     // MIs[0] rs1
     /*   89724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89736 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   89741 */     GIR_RootConstrainSelectedInstOperands,
     /*   89742 */     // GIR_Coverage, 712,
     /*   89742 */     GIR_Done,
     /*   89743 */   // Label 2366: @89743
     /*   89743 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(89784), // Rule ID 874 //
     /*   89748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   89761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89765 */     // MIs[0] rs1
     /*   89765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89777 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   89782 */     GIR_RootConstrainSelectedInstOperands,
     /*   89783 */     // GIR_Coverage, 874,
     /*   89783 */     GIR_Done,
     /*   89784 */   // Label 2367: @89784
     /*   89784 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(89825), // Rule ID 876 //
     /*   89789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   89802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89806 */     // MIs[0] rs1
     /*   89806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89818 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*   89823 */     GIR_RootConstrainSelectedInstOperands,
     /*   89824 */     // GIR_Coverage, 876,
     /*   89824 */     GIR_Done,
     /*   89825 */   // Label 2368: @89825
     /*   89825 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(89866), // Rule ID 878 //
     /*   89830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   89843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89847 */     // MIs[0] rs1
     /*   89847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89859 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*   89864 */     GIR_RootConstrainSelectedInstOperands,
     /*   89865 */     // GIR_Coverage, 878,
     /*   89865 */     GIR_Done,
     /*   89866 */   // Label 2369: @89866
     /*   89866 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(89907), // Rule ID 880 //
     /*   89871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   89884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89888 */     // MIs[0] rs1
     /*   89888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89900 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*   89905 */     GIR_RootConstrainSelectedInstOperands,
     /*   89906 */     // GIR_Coverage, 880,
     /*   89906 */     GIR_Done,
     /*   89907 */   // Label 2370: @89907
     /*   89907 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(89948), // Rule ID 882 //
     /*   89912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   89915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   89925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89929 */     // MIs[0] rs1
     /*   89929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89941 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*   89946 */     GIR_RootConstrainSelectedInstOperands,
     /*   89947 */     // GIR_Coverage, 882,
     /*   89947 */     GIR_Done,
     /*   89948 */   // Label 2371: @89948
     /*   89948 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(89989), // Rule ID 884 //
     /*   89953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   89963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   89966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89970 */     // MIs[0] rs1
     /*   89970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   89974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   89982 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   89982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   89987 */     GIR_RootConstrainSelectedInstOperands,
     /*   89988 */     // GIR_Coverage, 884,
     /*   89988 */     GIR_Done,
     /*   89989 */   // Label 2372: @89989
     /*   89989 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(90030), // Rule ID 886 //
     /*   89994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   89997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   90004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   90007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90011 */     // MIs[0] rs1
     /*   90011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   90015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90023 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   90023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   90028 */     GIR_RootConstrainSelectedInstOperands,
     /*   90029 */     // GIR_Coverage, 886,
     /*   90029 */     GIR_Done,
     /*   90030 */   // Label 2373: @90030
     /*   90030 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(90071), // Rule ID 888 //
     /*   90035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   90038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   90045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   90048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90052 */     // MIs[0] rs1
     /*   90052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   90056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90064 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   90064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   90069 */     GIR_RootConstrainSelectedInstOperands,
     /*   90070 */     // GIR_Coverage, 888,
     /*   90070 */     GIR_Done,
     /*   90071 */   // Label 2374: @90071
     /*   90071 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(90112), // Rule ID 890 //
     /*   90076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   90079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   90086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   90089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90093 */     // MIs[0] rs1
     /*   90093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   90097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90105 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   90105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   90110 */     GIR_RootConstrainSelectedInstOperands,
     /*   90111 */     // GIR_Coverage, 890,
     /*   90111 */     GIR_Done,
     /*   90112 */   // Label 2375: @90112
     /*   90112 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(90153), // Rule ID 892 //
     /*   90117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   90120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   90127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   90130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90134 */     // MIs[0] rs1
     /*   90134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   90138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90146 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   90146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   90151 */     GIR_RootConstrainSelectedInstOperands,
     /*   90152 */     // GIR_Coverage, 892,
     /*   90152 */     GIR_Done,
     /*   90153 */   // Label 2376: @90153
     /*   90153 */   GIM_Reject,
     /*   90154 */ // Label 2346: @90154
     /*   90154 */ GIM_Reject,
     /*   90155 */ // Label 2344: @90155
     /*   90155 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(91804),
     /*   90160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   90163 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(90204), // Rule ID 345 //
     /*   90168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   90171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   90181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90185 */     // MIs[0] rs1
     /*   90185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90197 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90202 */     GIR_RootConstrainSelectedInstOperands,
     /*   90203 */     // GIR_Coverage, 345,
     /*   90203 */     GIR_Done,
     /*   90204 */   // Label 2378: @90204
     /*   90204 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(90245), // Rule ID 347 //
     /*   90209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   90212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   90222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90226 */     // MIs[0] rs1
     /*   90226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90238 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*   90243 */     GIR_RootConstrainSelectedInstOperands,
     /*   90244 */     // GIR_Coverage, 347,
     /*   90244 */     GIR_Done,
     /*   90245 */   // Label 2379: @90245
     /*   90245 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(90286), // Rule ID 349 //
     /*   90250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   90253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   90263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90267 */     // MIs[0] rs1
     /*   90267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90279 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*   90284 */     GIR_RootConstrainSelectedInstOperands,
     /*   90285 */     // GIR_Coverage, 349,
     /*   90285 */     GIR_Done,
     /*   90286 */   // Label 2380: @90286
     /*   90286 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(90327), // Rule ID 351 //
     /*   90291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   90294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   90304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90308 */     // MIs[0] rs1
     /*   90308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90320 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*   90325 */     GIR_RootConstrainSelectedInstOperands,
     /*   90326 */     // GIR_Coverage, 351,
     /*   90326 */     GIR_Done,
     /*   90327 */   // Label 2381: @90327
     /*   90327 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(90368), // Rule ID 353 //
     /*   90332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   90335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   90345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90349 */     // MIs[0] rs1
     /*   90349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90361 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*   90366 */     GIR_RootConstrainSelectedInstOperands,
     /*   90367 */     // GIR_Coverage, 353,
     /*   90367 */     GIR_Done,
     /*   90368 */   // Label 2382: @90368
     /*   90368 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(90409), // Rule ID 355 //
     /*   90373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   90376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   90386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90390 */     // MIs[0] rs1
     /*   90390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90402 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90407 */     GIR_RootConstrainSelectedInstOperands,
     /*   90408 */     // GIR_Coverage, 355,
     /*   90408 */     GIR_Done,
     /*   90409 */   // Label 2383: @90409
     /*   90409 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(90450), // Rule ID 357 //
     /*   90414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   90417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   90427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90431 */     // MIs[0] rs1
     /*   90431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90443 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90448 */     GIR_RootConstrainSelectedInstOperands,
     /*   90449 */     // GIR_Coverage, 357,
     /*   90449 */     GIR_Done,
     /*   90450 */   // Label 2384: @90450
     /*   90450 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(90491), // Rule ID 359 //
     /*   90455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   90458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   90468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90472 */     // MIs[0] rs1
     /*   90472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90484 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90489 */     GIR_RootConstrainSelectedInstOperands,
     /*   90490 */     // GIR_Coverage, 359,
     /*   90490 */     GIR_Done,
     /*   90491 */   // Label 2385: @90491
     /*   90491 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(90532), // Rule ID 361 //
     /*   90496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   90499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   90509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90513 */     // MIs[0] rs1
     /*   90513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90525 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90530 */     GIR_RootConstrainSelectedInstOperands,
     /*   90531 */     // GIR_Coverage, 361,
     /*   90531 */     GIR_Done,
     /*   90532 */   // Label 2386: @90532
     /*   90532 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(90573), // Rule ID 363 //
     /*   90537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   90540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   90547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   90550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90554 */     // MIs[0] rs1
     /*   90554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90566 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*   90571 */     GIR_RootConstrainSelectedInstOperands,
     /*   90572 */     // GIR_Coverage, 363,
     /*   90572 */     GIR_Done,
     /*   90573 */   // Label 2387: @90573
     /*   90573 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(90614), // Rule ID 515 //
     /*   90578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   90581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   90591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90595 */     // MIs[0] rs1
     /*   90595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90607 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90612 */     GIR_RootConstrainSelectedInstOperands,
     /*   90613 */     // GIR_Coverage, 515,
     /*   90613 */     GIR_Done,
     /*   90614 */   // Label 2388: @90614
     /*   90614 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(90655), // Rule ID 516 //
     /*   90619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   90622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   90632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90636 */     // MIs[0] rs1
     /*   90636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90648 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*   90653 */     GIR_RootConstrainSelectedInstOperands,
     /*   90654 */     // GIR_Coverage, 516,
     /*   90654 */     GIR_Done,
     /*   90655 */   // Label 2389: @90655
     /*   90655 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(90696), // Rule ID 517 //
     /*   90660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   90663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   90673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90677 */     // MIs[0] rs1
     /*   90677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90689 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*   90694 */     GIR_RootConstrainSelectedInstOperands,
     /*   90695 */     // GIR_Coverage, 517,
     /*   90695 */     GIR_Done,
     /*   90696 */   // Label 2390: @90696
     /*   90696 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(90737), // Rule ID 518 //
     /*   90701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   90704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   90714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90718 */     // MIs[0] rs1
     /*   90718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90730 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*   90735 */     GIR_RootConstrainSelectedInstOperands,
     /*   90736 */     // GIR_Coverage, 518,
     /*   90736 */     GIR_Done,
     /*   90737 */   // Label 2391: @90737
     /*   90737 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(90778), // Rule ID 519 //
     /*   90742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   90745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   90755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90759 */     // MIs[0] rs1
     /*   90759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90771 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*   90776 */     GIR_RootConstrainSelectedInstOperands,
     /*   90777 */     // GIR_Coverage, 519,
     /*   90777 */     GIR_Done,
     /*   90778 */   // Label 2392: @90778
     /*   90778 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(90819), // Rule ID 520 //
     /*   90783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   90786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   90796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90800 */     // MIs[0] rs1
     /*   90800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90812 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90817 */     GIR_RootConstrainSelectedInstOperands,
     /*   90818 */     // GIR_Coverage, 520,
     /*   90818 */     GIR_Done,
     /*   90819 */   // Label 2393: @90819
     /*   90819 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(90860), // Rule ID 521 //
     /*   90824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   90827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   90837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90841 */     // MIs[0] rs1
     /*   90841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90853 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90858 */     GIR_RootConstrainSelectedInstOperands,
     /*   90859 */     // GIR_Coverage, 521,
     /*   90859 */     GIR_Done,
     /*   90860 */   // Label 2394: @90860
     /*   90860 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(90901), // Rule ID 522 //
     /*   90865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   90868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   90878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90882 */     // MIs[0] rs1
     /*   90882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90894 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90899 */     GIR_RootConstrainSelectedInstOperands,
     /*   90900 */     // GIR_Coverage, 522,
     /*   90900 */     GIR_Done,
     /*   90901 */   // Label 2395: @90901
     /*   90901 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(90942), // Rule ID 523 //
     /*   90906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   90909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   90919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90923 */     // MIs[0] rs1
     /*   90923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90935 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90940 */     GIR_RootConstrainSelectedInstOperands,
     /*   90941 */     // GIR_Coverage, 523,
     /*   90941 */     GIR_Done,
     /*   90942 */   // Label 2396: @90942
     /*   90942 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(90983), // Rule ID 524 //
     /*   90947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   90950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   90957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   90960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90964 */     // MIs[0] rs1
     /*   90964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   90968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   90976 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   90976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*   90981 */     GIR_RootConstrainSelectedInstOperands,
     /*   90982 */     // GIR_Coverage, 524,
     /*   90982 */     GIR_Done,
     /*   90983 */   // Label 2397: @90983
     /*   90983 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(91024), // Rule ID 693 //
     /*   90988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   90991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   90998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   91001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91005 */     // MIs[0] rs1
     /*   91005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91017 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91022 */     GIR_RootConstrainSelectedInstOperands,
     /*   91023 */     // GIR_Coverage, 693,
     /*   91023 */     GIR_Done,
     /*   91024 */   // Label 2398: @91024
     /*   91024 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(91065), // Rule ID 695 //
     /*   91029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   91042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91046 */     // MIs[0] rs1
     /*   91046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91058 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*   91063 */     GIR_RootConstrainSelectedInstOperands,
     /*   91064 */     // GIR_Coverage, 695,
     /*   91064 */     GIR_Done,
     /*   91065 */   // Label 2399: @91065
     /*   91065 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(91106), // Rule ID 697 //
     /*   91070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   91083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91087 */     // MIs[0] rs1
     /*   91087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91099 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*   91104 */     GIR_RootConstrainSelectedInstOperands,
     /*   91105 */     // GIR_Coverage, 697,
     /*   91105 */     GIR_Done,
     /*   91106 */   // Label 2400: @91106
     /*   91106 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(91147), // Rule ID 699 //
     /*   91111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   91124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91128 */     // MIs[0] rs1
     /*   91128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91140 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*   91145 */     GIR_RootConstrainSelectedInstOperands,
     /*   91146 */     // GIR_Coverage, 699,
     /*   91146 */     GIR_Done,
     /*   91147 */   // Label 2401: @91147
     /*   91147 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(91188), // Rule ID 701 //
     /*   91152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   91165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91169 */     // MIs[0] rs1
     /*   91169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91181 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*   91186 */     GIR_RootConstrainSelectedInstOperands,
     /*   91187 */     // GIR_Coverage, 701,
     /*   91187 */     GIR_Done,
     /*   91188 */   // Label 2402: @91188
     /*   91188 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(91229), // Rule ID 703 //
     /*   91193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   91206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91210 */     // MIs[0] rs1
     /*   91210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91222 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91227 */     GIR_RootConstrainSelectedInstOperands,
     /*   91228 */     // GIR_Coverage, 703,
     /*   91228 */     GIR_Done,
     /*   91229 */   // Label 2403: @91229
     /*   91229 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(91270), // Rule ID 705 //
     /*   91234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   91247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91251 */     // MIs[0] rs1
     /*   91251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91263 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91268 */     GIR_RootConstrainSelectedInstOperands,
     /*   91269 */     // GIR_Coverage, 705,
     /*   91269 */     GIR_Done,
     /*   91270 */   // Label 2404: @91270
     /*   91270 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(91311), // Rule ID 707 //
     /*   91275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   91288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91292 */     // MIs[0] rs1
     /*   91292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91304 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91309 */     GIR_RootConstrainSelectedInstOperands,
     /*   91310 */     // GIR_Coverage, 707,
     /*   91310 */     GIR_Done,
     /*   91311 */   // Label 2405: @91311
     /*   91311 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(91352), // Rule ID 709 //
     /*   91316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   91329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91333 */     // MIs[0] rs1
     /*   91333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91345 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91350 */     GIR_RootConstrainSelectedInstOperands,
     /*   91351 */     // GIR_Coverage, 709,
     /*   91351 */     GIR_Done,
     /*   91352 */   // Label 2406: @91352
     /*   91352 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(91393), // Rule ID 711 //
     /*   91357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   91367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   91370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91374 */     // MIs[0] rs1
     /*   91374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91386 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*   91391 */     GIR_RootConstrainSelectedInstOperands,
     /*   91392 */     // GIR_Coverage, 711,
     /*   91392 */     GIR_Done,
     /*   91393 */   // Label 2407: @91393
     /*   91393 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(91434), // Rule ID 873 //
     /*   91398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   91411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91415 */     // MIs[0] rs1
     /*   91415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91427 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91432 */     GIR_RootConstrainSelectedInstOperands,
     /*   91433 */     // GIR_Coverage, 873,
     /*   91433 */     GIR_Done,
     /*   91434 */   // Label 2408: @91434
     /*   91434 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(91475), // Rule ID 875 //
     /*   91439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   91452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91456 */     // MIs[0] rs1
     /*   91456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91468 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*   91473 */     GIR_RootConstrainSelectedInstOperands,
     /*   91474 */     // GIR_Coverage, 875,
     /*   91474 */     GIR_Done,
     /*   91475 */   // Label 2409: @91475
     /*   91475 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(91516), // Rule ID 877 //
     /*   91480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   91493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91497 */     // MIs[0] rs1
     /*   91497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91509 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*   91514 */     GIR_RootConstrainSelectedInstOperands,
     /*   91515 */     // GIR_Coverage, 877,
     /*   91515 */     GIR_Done,
     /*   91516 */   // Label 2410: @91516
     /*   91516 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(91557), // Rule ID 879 //
     /*   91521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   91534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91538 */     // MIs[0] rs1
     /*   91538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91550 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*   91555 */     GIR_RootConstrainSelectedInstOperands,
     /*   91556 */     // GIR_Coverage, 879,
     /*   91556 */     GIR_Done,
     /*   91557 */   // Label 2411: @91557
     /*   91557 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(91598), // Rule ID 881 //
     /*   91562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   91565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   91575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91579 */     // MIs[0] rs1
     /*   91579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91591 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*   91596 */     GIR_RootConstrainSelectedInstOperands,
     /*   91597 */     // GIR_Coverage, 881,
     /*   91597 */     GIR_Done,
     /*   91598 */   // Label 2412: @91598
     /*   91598 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(91639), // Rule ID 883 //
     /*   91603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   91616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91620 */     // MIs[0] rs1
     /*   91620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91632 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91637 */     GIR_RootConstrainSelectedInstOperands,
     /*   91638 */     // GIR_Coverage, 883,
     /*   91638 */     GIR_Done,
     /*   91639 */   // Label 2413: @91639
     /*   91639 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(91680), // Rule ID 885 //
     /*   91644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   91657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91661 */     // MIs[0] rs1
     /*   91661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91673 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91678 */     GIR_RootConstrainSelectedInstOperands,
     /*   91679 */     // GIR_Coverage, 885,
     /*   91679 */     GIR_Done,
     /*   91680 */   // Label 2414: @91680
     /*   91680 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(91721), // Rule ID 887 //
     /*   91685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   91698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91702 */     // MIs[0] rs1
     /*   91702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91714 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91719 */     GIR_RootConstrainSelectedInstOperands,
     /*   91720 */     // GIR_Coverage, 887,
     /*   91720 */     GIR_Done,
     /*   91721 */   // Label 2415: @91721
     /*   91721 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(91762), // Rule ID 889 //
     /*   91726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   91739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91743 */     // MIs[0] rs1
     /*   91743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91755 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91760 */     GIR_RootConstrainSelectedInstOperands,
     /*   91761 */     // GIR_Coverage, 889,
     /*   91761 */     GIR_Done,
     /*   91762 */   // Label 2416: @91762
     /*   91762 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(91803), // Rule ID 891 //
     /*   91767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   91770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   91777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   91780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91784 */     // MIs[0] rs1
     /*   91784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   91788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91796 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   91796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*   91801 */     GIR_RootConstrainSelectedInstOperands,
     /*   91802 */     // GIR_Coverage, 891,
     /*   91802 */     GIR_Done,
     /*   91803 */   // Label 2417: @91803
     /*   91803 */   GIM_Reject,
     /*   91804 */ // Label 2377: @91804
     /*   91804 */ GIM_Reject,
     /*   91805 */ // Label 2345: @91805
     /*   91805 */ GIM_Reject,
     /*   91806 */ // Label 28: @91806
     /*   91806 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2420*/ GIMT_Encode4(94715),
     /*   91817 */ /*GILLT_s32*//*Label 2418*/ GIMT_Encode4(91825),
     /*   91821 */ /*GILLT_s64*//*Label 2419*/ GIMT_Encode4(93065),
     /*   91825 */ // Label 2418: @91825
     /*   91825 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(93064),
     /*   91830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   91833 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(91874), // Rule ID 366 //
     /*   91838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   91841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   91848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   91851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91855 */     // MIs[0] rs1
     /*   91855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   91859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91867 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   91867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   91872 */     GIR_RootConstrainSelectedInstOperands,
     /*   91873 */     // GIR_Coverage, 366,
     /*   91873 */     GIR_Done,
     /*   91874 */   // Label 2422: @91874
     /*   91874 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(91915), // Rule ID 368 //
     /*   91879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   91882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   91889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   91892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91896 */     // MIs[0] rs1
     /*   91896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   91900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91908 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   91908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*   91913 */     GIR_RootConstrainSelectedInstOperands,
     /*   91914 */     // GIR_Coverage, 368,
     /*   91914 */     GIR_Done,
     /*   91915 */   // Label 2423: @91915
     /*   91915 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(91956), // Rule ID 370 //
     /*   91920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   91923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   91930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   91933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91937 */     // MIs[0] rs1
     /*   91937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   91941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91949 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   91949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*   91954 */     GIR_RootConstrainSelectedInstOperands,
     /*   91955 */     // GIR_Coverage, 370,
     /*   91955 */     GIR_Done,
     /*   91956 */   // Label 2424: @91956
     /*   91956 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(91997), // Rule ID 372 //
     /*   91961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   91964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   91971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   91974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91978 */     // MIs[0] rs1
     /*   91978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   91982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   91990 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   91990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*   91995 */     GIR_RootConstrainSelectedInstOperands,
     /*   91996 */     // GIR_Coverage, 372,
     /*   91996 */     GIR_Done,
     /*   91997 */   // Label 2425: @91997
     /*   91997 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(92038), // Rule ID 374 //
     /*   92002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   92005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   92015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92019 */     // MIs[0] rs1
     /*   92019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92031 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*   92036 */     GIR_RootConstrainSelectedInstOperands,
     /*   92037 */     // GIR_Coverage, 374,
     /*   92037 */     GIR_Done,
     /*   92038 */   // Label 2426: @92038
     /*   92038 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(92079), // Rule ID 376 //
     /*   92043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   92046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   92056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92060 */     // MIs[0] rs1
     /*   92060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92072 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   92077 */     GIR_RootConstrainSelectedInstOperands,
     /*   92078 */     // GIR_Coverage, 376,
     /*   92078 */     GIR_Done,
     /*   92079 */   // Label 2427: @92079
     /*   92079 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(92120), // Rule ID 378 //
     /*   92084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   92087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   92097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92101 */     // MIs[0] rs1
     /*   92101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92113 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   92118 */     GIR_RootConstrainSelectedInstOperands,
     /*   92119 */     // GIR_Coverage, 378,
     /*   92119 */     GIR_Done,
     /*   92120 */   // Label 2428: @92120
     /*   92120 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(92161), // Rule ID 380 //
     /*   92125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   92128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   92138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92142 */     // MIs[0] rs1
     /*   92142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92154 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   92159 */     GIR_RootConstrainSelectedInstOperands,
     /*   92160 */     // GIR_Coverage, 380,
     /*   92160 */     GIR_Done,
     /*   92161 */   // Label 2429: @92161
     /*   92161 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(92202), // Rule ID 382 //
     /*   92166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   92169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   92179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92183 */     // MIs[0] rs1
     /*   92183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92195 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   92200 */     GIR_RootConstrainSelectedInstOperands,
     /*   92201 */     // GIR_Coverage, 382,
     /*   92201 */     GIR_Done,
     /*   92202 */   // Label 2430: @92202
     /*   92202 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(92243), // Rule ID 384 //
     /*   92207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   92210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   92217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   92220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92224 */     // MIs[0] rs1
     /*   92224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92236 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   92241 */     GIR_RootConstrainSelectedInstOperands,
     /*   92242 */     // GIR_Coverage, 384,
     /*   92242 */     GIR_Done,
     /*   92243 */   // Label 2431: @92243
     /*   92243 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(92284), // Rule ID 714 //
     /*   92248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   92261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92265 */     // MIs[0] rs1
     /*   92265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92277 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92282 */     GIR_RootConstrainSelectedInstOperands,
     /*   92283 */     // GIR_Coverage, 714,
     /*   92283 */     GIR_Done,
     /*   92284 */   // Label 2432: @92284
     /*   92284 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(92325), // Rule ID 716 //
     /*   92289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   92302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92306 */     // MIs[0] rs1
     /*   92306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92318 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*   92323 */     GIR_RootConstrainSelectedInstOperands,
     /*   92324 */     // GIR_Coverage, 716,
     /*   92324 */     GIR_Done,
     /*   92325 */   // Label 2433: @92325
     /*   92325 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(92366), // Rule ID 718 //
     /*   92330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   92343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92347 */     // MIs[0] rs1
     /*   92347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92359 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*   92364 */     GIR_RootConstrainSelectedInstOperands,
     /*   92365 */     // GIR_Coverage, 718,
     /*   92365 */     GIR_Done,
     /*   92366 */   // Label 2434: @92366
     /*   92366 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(92407), // Rule ID 720 //
     /*   92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92374 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   92384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92388 */     // MIs[0] rs1
     /*   92388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92400 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*   92405 */     GIR_RootConstrainSelectedInstOperands,
     /*   92406 */     // GIR_Coverage, 720,
     /*   92406 */     GIR_Done,
     /*   92407 */   // Label 2435: @92407
     /*   92407 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(92448), // Rule ID 722 //
     /*   92412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92415 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   92425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92429 */     // MIs[0] rs1
     /*   92429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92441 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*   92446 */     GIR_RootConstrainSelectedInstOperands,
     /*   92447 */     // GIR_Coverage, 722,
     /*   92447 */     GIR_Done,
     /*   92448 */   // Label 2436: @92448
     /*   92448 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(92489), // Rule ID 724 //
     /*   92453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   92466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92470 */     // MIs[0] rs1
     /*   92470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92482 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92487 */     GIR_RootConstrainSelectedInstOperands,
     /*   92488 */     // GIR_Coverage, 724,
     /*   92488 */     GIR_Done,
     /*   92489 */   // Label 2437: @92489
     /*   92489 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(92530), // Rule ID 726 //
     /*   92494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   92507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92511 */     // MIs[0] rs1
     /*   92511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92523 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92528 */     GIR_RootConstrainSelectedInstOperands,
     /*   92529 */     // GIR_Coverage, 726,
     /*   92529 */     GIR_Done,
     /*   92530 */   // Label 2438: @92530
     /*   92530 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(92571), // Rule ID 728 //
     /*   92535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   92548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92552 */     // MIs[0] rs1
     /*   92552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92564 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92569 */     GIR_RootConstrainSelectedInstOperands,
     /*   92570 */     // GIR_Coverage, 728,
     /*   92570 */     GIR_Done,
     /*   92571 */   // Label 2439: @92571
     /*   92571 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(92612), // Rule ID 730 //
     /*   92576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92579 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92586 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   92589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92593 */     // MIs[0] rs1
     /*   92593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92605 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92610 */     GIR_RootConstrainSelectedInstOperands,
     /*   92611 */     // GIR_Coverage, 730,
     /*   92611 */     GIR_Done,
     /*   92612 */   // Label 2440: @92612
     /*   92612 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(92653), // Rule ID 732 //
     /*   92617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   92627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   92630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92634 */     // MIs[0] rs1
     /*   92634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92646 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   92651 */     GIR_RootConstrainSelectedInstOperands,
     /*   92652 */     // GIR_Coverage, 732,
     /*   92652 */     GIR_Done,
     /*   92653 */   // Label 2441: @92653
     /*   92653 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(92694), // Rule ID 894 //
     /*   92658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   92671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92675 */     // MIs[0] rs1
     /*   92675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92687 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   92692 */     GIR_RootConstrainSelectedInstOperands,
     /*   92693 */     // GIR_Coverage, 894,
     /*   92693 */     GIR_Done,
     /*   92694 */   // Label 2442: @92694
     /*   92694 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(92735), // Rule ID 896 //
     /*   92699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   92712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92716 */     // MIs[0] rs1
     /*   92716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92728 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*   92733 */     GIR_RootConstrainSelectedInstOperands,
     /*   92734 */     // GIR_Coverage, 896,
     /*   92734 */     GIR_Done,
     /*   92735 */   // Label 2443: @92735
     /*   92735 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(92776), // Rule ID 898 //
     /*   92740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   92753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92757 */     // MIs[0] rs1
     /*   92757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92769 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*   92774 */     GIR_RootConstrainSelectedInstOperands,
     /*   92775 */     // GIR_Coverage, 898,
     /*   92775 */     GIR_Done,
     /*   92776 */   // Label 2444: @92776
     /*   92776 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(92817), // Rule ID 900 //
     /*   92781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   92794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92798 */     // MIs[0] rs1
     /*   92798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92810 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*   92815 */     GIR_RootConstrainSelectedInstOperands,
     /*   92816 */     // GIR_Coverage, 900,
     /*   92816 */     GIR_Done,
     /*   92817 */   // Label 2445: @92817
     /*   92817 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(92858), // Rule ID 902 //
     /*   92822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   92825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   92835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92839 */     // MIs[0] rs1
     /*   92839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92851 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*   92856 */     GIR_RootConstrainSelectedInstOperands,
     /*   92857 */     // GIR_Coverage, 902,
     /*   92857 */     GIR_Done,
     /*   92858 */   // Label 2446: @92858
     /*   92858 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(92899), // Rule ID 904 //
     /*   92863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   92876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92880 */     // MIs[0] rs1
     /*   92880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92892 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   92897 */     GIR_RootConstrainSelectedInstOperands,
     /*   92898 */     // GIR_Coverage, 904,
     /*   92898 */     GIR_Done,
     /*   92899 */   // Label 2447: @92899
     /*   92899 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(92940), // Rule ID 906 //
     /*   92904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   92917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92921 */     // MIs[0] rs1
     /*   92921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92933 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   92938 */     GIR_RootConstrainSelectedInstOperands,
     /*   92939 */     // GIR_Coverage, 906,
     /*   92939 */     GIR_Done,
     /*   92940 */   // Label 2448: @92940
     /*   92940 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(92981), // Rule ID 908 //
     /*   92945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   92958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92962 */     // MIs[0] rs1
     /*   92962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   92966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   92974 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   92974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   92979 */     GIR_RootConstrainSelectedInstOperands,
     /*   92980 */     // GIR_Coverage, 908,
     /*   92980 */     GIR_Done,
     /*   92981 */   // Label 2449: @92981
     /*   92981 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(93022), // Rule ID 910 //
     /*   92986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   92989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   92996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   92999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93003 */     // MIs[0] rs1
     /*   93003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   93007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93015 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   93015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   93020 */     GIR_RootConstrainSelectedInstOperands,
     /*   93021 */     // GIR_Coverage, 910,
     /*   93021 */     GIR_Done,
     /*   93022 */   // Label 2450: @93022
     /*   93022 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(93063), // Rule ID 912 //
     /*   93027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   93030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   93037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   93040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93044 */     // MIs[0] rs1
     /*   93044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   93048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93056 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   93056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   93061 */     GIR_RootConstrainSelectedInstOperands,
     /*   93062 */     // GIR_Coverage, 912,
     /*   93062 */     GIR_Done,
     /*   93063 */   // Label 2451: @93063
     /*   93063 */   GIM_Reject,
     /*   93064 */ // Label 2421: @93064
     /*   93064 */ GIM_Reject,
     /*   93065 */ // Label 2419: @93065
     /*   93065 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(94714),
     /*   93070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   93073 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(93114), // Rule ID 365 //
     /*   93078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   93081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   93091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93095 */     // MIs[0] rs1
     /*   93095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93107 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93112 */     GIR_RootConstrainSelectedInstOperands,
     /*   93113 */     // GIR_Coverage, 365,
     /*   93113 */     GIR_Done,
     /*   93114 */   // Label 2453: @93114
     /*   93114 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(93155), // Rule ID 367 //
     /*   93119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   93122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   93132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93136 */     // MIs[0] rs1
     /*   93136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93148 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*   93153 */     GIR_RootConstrainSelectedInstOperands,
     /*   93154 */     // GIR_Coverage, 367,
     /*   93154 */     GIR_Done,
     /*   93155 */   // Label 2454: @93155
     /*   93155 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(93196), // Rule ID 369 //
     /*   93160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   93163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   93173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93177 */     // MIs[0] rs1
     /*   93177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93189 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*   93194 */     GIR_RootConstrainSelectedInstOperands,
     /*   93195 */     // GIR_Coverage, 369,
     /*   93195 */     GIR_Done,
     /*   93196 */   // Label 2455: @93196
     /*   93196 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(93237), // Rule ID 371 //
     /*   93201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   93204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   93214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93218 */     // MIs[0] rs1
     /*   93218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93230 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*   93235 */     GIR_RootConstrainSelectedInstOperands,
     /*   93236 */     // GIR_Coverage, 371,
     /*   93236 */     GIR_Done,
     /*   93237 */   // Label 2456: @93237
     /*   93237 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(93278), // Rule ID 373 //
     /*   93242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   93245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   93255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93259 */     // MIs[0] rs1
     /*   93259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93271 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*   93276 */     GIR_RootConstrainSelectedInstOperands,
     /*   93277 */     // GIR_Coverage, 373,
     /*   93277 */     GIR_Done,
     /*   93278 */   // Label 2457: @93278
     /*   93278 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(93319), // Rule ID 375 //
     /*   93283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   93286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   93296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93300 */     // MIs[0] rs1
     /*   93300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93312 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93317 */     GIR_RootConstrainSelectedInstOperands,
     /*   93318 */     // GIR_Coverage, 375,
     /*   93318 */     GIR_Done,
     /*   93319 */   // Label 2458: @93319
     /*   93319 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(93360), // Rule ID 377 //
     /*   93324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   93327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   93337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93341 */     // MIs[0] rs1
     /*   93341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93353 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93358 */     GIR_RootConstrainSelectedInstOperands,
     /*   93359 */     // GIR_Coverage, 377,
     /*   93359 */     GIR_Done,
     /*   93360 */   // Label 2459: @93360
     /*   93360 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(93401), // Rule ID 379 //
     /*   93365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   93368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   93378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93382 */     // MIs[0] rs1
     /*   93382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93394 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93399 */     GIR_RootConstrainSelectedInstOperands,
     /*   93400 */     // GIR_Coverage, 379,
     /*   93400 */     GIR_Done,
     /*   93401 */   // Label 2460: @93401
     /*   93401 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(93442), // Rule ID 381 //
     /*   93406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   93409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   93419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93423 */     // MIs[0] rs1
     /*   93423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93435 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93440 */     GIR_RootConstrainSelectedInstOperands,
     /*   93441 */     // GIR_Coverage, 381,
     /*   93441 */     GIR_Done,
     /*   93442 */   // Label 2461: @93442
     /*   93442 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(93483), // Rule ID 383 //
     /*   93447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   93450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   93457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   93460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93464 */     // MIs[0] rs1
     /*   93464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93476 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*   93481 */     GIR_RootConstrainSelectedInstOperands,
     /*   93482 */     // GIR_Coverage, 383,
     /*   93482 */     GIR_Done,
     /*   93483 */   // Label 2462: @93483
     /*   93483 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(93524), // Rule ID 525 //
     /*   93488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   93491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   93501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93505 */     // MIs[0] rs1
     /*   93505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93517 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93522 */     GIR_RootConstrainSelectedInstOperands,
     /*   93523 */     // GIR_Coverage, 525,
     /*   93523 */     GIR_Done,
     /*   93524 */   // Label 2463: @93524
     /*   93524 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(93565), // Rule ID 526 //
     /*   93529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   93532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   93542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93546 */     // MIs[0] rs1
     /*   93546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93558 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*   93563 */     GIR_RootConstrainSelectedInstOperands,
     /*   93564 */     // GIR_Coverage, 526,
     /*   93564 */     GIR_Done,
     /*   93565 */   // Label 2464: @93565
     /*   93565 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(93606), // Rule ID 527 //
     /*   93570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   93573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   93583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93587 */     // MIs[0] rs1
     /*   93587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93599 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*   93604 */     GIR_RootConstrainSelectedInstOperands,
     /*   93605 */     // GIR_Coverage, 527,
     /*   93605 */     GIR_Done,
     /*   93606 */   // Label 2465: @93606
     /*   93606 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(93647), // Rule ID 528 //
     /*   93611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   93614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   93624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93628 */     // MIs[0] rs1
     /*   93628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93640 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*   93645 */     GIR_RootConstrainSelectedInstOperands,
     /*   93646 */     // GIR_Coverage, 528,
     /*   93646 */     GIR_Done,
     /*   93647 */   // Label 2466: @93647
     /*   93647 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(93688), // Rule ID 529 //
     /*   93652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   93655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   93665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93669 */     // MIs[0] rs1
     /*   93669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93681 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*   93686 */     GIR_RootConstrainSelectedInstOperands,
     /*   93687 */     // GIR_Coverage, 529,
     /*   93687 */     GIR_Done,
     /*   93688 */   // Label 2467: @93688
     /*   93688 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(93729), // Rule ID 530 //
     /*   93693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   93696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   93706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93710 */     // MIs[0] rs1
     /*   93710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93722 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93727 */     GIR_RootConstrainSelectedInstOperands,
     /*   93728 */     // GIR_Coverage, 530,
     /*   93728 */     GIR_Done,
     /*   93729 */   // Label 2468: @93729
     /*   93729 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(93770), // Rule ID 531 //
     /*   93734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   93737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   93747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93751 */     // MIs[0] rs1
     /*   93751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93763 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93768 */     GIR_RootConstrainSelectedInstOperands,
     /*   93769 */     // GIR_Coverage, 531,
     /*   93769 */     GIR_Done,
     /*   93770 */   // Label 2469: @93770
     /*   93770 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(93811), // Rule ID 532 //
     /*   93775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   93778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   93788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93792 */     // MIs[0] rs1
     /*   93792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93804 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93809 */     GIR_RootConstrainSelectedInstOperands,
     /*   93810 */     // GIR_Coverage, 532,
     /*   93810 */     GIR_Done,
     /*   93811 */   // Label 2470: @93811
     /*   93811 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(93852), // Rule ID 533 //
     /*   93816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   93819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   93829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93833 */     // MIs[0] rs1
     /*   93833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93845 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93850 */     GIR_RootConstrainSelectedInstOperands,
     /*   93851 */     // GIR_Coverage, 533,
     /*   93851 */     GIR_Done,
     /*   93852 */   // Label 2471: @93852
     /*   93852 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(93893), // Rule ID 534 //
     /*   93857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   93860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   93867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   93870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93874 */     // MIs[0] rs1
     /*   93874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93886 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*   93891 */     GIR_RootConstrainSelectedInstOperands,
     /*   93892 */     // GIR_Coverage, 534,
     /*   93892 */     GIR_Done,
     /*   93893 */   // Label 2472: @93893
     /*   93893 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(93934), // Rule ID 713 //
     /*   93898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   93901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   93908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   93911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93915 */     // MIs[0] rs1
     /*   93915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93927 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   93932 */     GIR_RootConstrainSelectedInstOperands,
     /*   93933 */     // GIR_Coverage, 713,
     /*   93933 */     GIR_Done,
     /*   93934 */   // Label 2473: @93934
     /*   93934 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(93975), // Rule ID 715 //
     /*   93939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   93942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   93949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   93952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93956 */     // MIs[0] rs1
     /*   93956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   93960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93968 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   93968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*   93973 */     GIR_RootConstrainSelectedInstOperands,
     /*   93974 */     // GIR_Coverage, 715,
     /*   93974 */     GIR_Done,
     /*   93975 */   // Label 2474: @93975
     /*   93975 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(94016), // Rule ID 717 //
     /*   93980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   93983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   93990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   93993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   93997 */     // MIs[0] rs1
     /*   93997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94009 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*   94014 */     GIR_RootConstrainSelectedInstOperands,
     /*   94015 */     // GIR_Coverage, 717,
     /*   94015 */     GIR_Done,
     /*   94016 */   // Label 2475: @94016
     /*   94016 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(94057), // Rule ID 719 //
     /*   94021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   94034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94038 */     // MIs[0] rs1
     /*   94038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94050 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*   94055 */     GIR_RootConstrainSelectedInstOperands,
     /*   94056 */     // GIR_Coverage, 719,
     /*   94056 */     GIR_Done,
     /*   94057 */   // Label 2476: @94057
     /*   94057 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(94098), // Rule ID 721 //
     /*   94062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   94075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94079 */     // MIs[0] rs1
     /*   94079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94091 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*   94096 */     GIR_RootConstrainSelectedInstOperands,
     /*   94097 */     // GIR_Coverage, 721,
     /*   94097 */     GIR_Done,
     /*   94098 */   // Label 2477: @94098
     /*   94098 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(94139), // Rule ID 723 //
     /*   94103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   94116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94120 */     // MIs[0] rs1
     /*   94120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94132 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   94137 */     GIR_RootConstrainSelectedInstOperands,
     /*   94138 */     // GIR_Coverage, 723,
     /*   94138 */     GIR_Done,
     /*   94139 */   // Label 2478: @94139
     /*   94139 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(94180), // Rule ID 725 //
     /*   94144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   94157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94161 */     // MIs[0] rs1
     /*   94161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94173 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   94178 */     GIR_RootConstrainSelectedInstOperands,
     /*   94179 */     // GIR_Coverage, 725,
     /*   94179 */     GIR_Done,
     /*   94180 */   // Label 2479: @94180
     /*   94180 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(94221), // Rule ID 727 //
     /*   94185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   94198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94202 */     // MIs[0] rs1
     /*   94202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94214 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   94219 */     GIR_RootConstrainSelectedInstOperands,
     /*   94220 */     // GIR_Coverage, 727,
     /*   94220 */     GIR_Done,
     /*   94221 */   // Label 2480: @94221
     /*   94221 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(94262), // Rule ID 729 //
     /*   94226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   94239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94243 */     // MIs[0] rs1
     /*   94243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94255 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   94260 */     GIR_RootConstrainSelectedInstOperands,
     /*   94261 */     // GIR_Coverage, 729,
     /*   94261 */     GIR_Done,
     /*   94262 */   // Label 2481: @94262
     /*   94262 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(94303), // Rule ID 731 //
     /*   94267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   94277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   94280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94284 */     // MIs[0] rs1
     /*   94284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94296 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*   94301 */     GIR_RootConstrainSelectedInstOperands,
     /*   94302 */     // GIR_Coverage, 731,
     /*   94302 */     GIR_Done,
     /*   94303 */   // Label 2482: @94303
     /*   94303 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(94344), // Rule ID 893 //
     /*   94308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   94321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94325 */     // MIs[0] rs1
     /*   94325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94337 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94342 */     GIR_RootConstrainSelectedInstOperands,
     /*   94343 */     // GIR_Coverage, 893,
     /*   94343 */     GIR_Done,
     /*   94344 */   // Label 2483: @94344
     /*   94344 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(94385), // Rule ID 895 //
     /*   94349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   94362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94366 */     // MIs[0] rs1
     /*   94366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94378 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*   94383 */     GIR_RootConstrainSelectedInstOperands,
     /*   94384 */     // GIR_Coverage, 895,
     /*   94384 */     GIR_Done,
     /*   94385 */   // Label 2484: @94385
     /*   94385 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(94426), // Rule ID 897 //
     /*   94390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   94403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94407 */     // MIs[0] rs1
     /*   94407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94419 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*   94424 */     GIR_RootConstrainSelectedInstOperands,
     /*   94425 */     // GIR_Coverage, 897,
     /*   94425 */     GIR_Done,
     /*   94426 */   // Label 2485: @94426
     /*   94426 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(94467), // Rule ID 899 //
     /*   94431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   94444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94448 */     // MIs[0] rs1
     /*   94448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94460 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*   94465 */     GIR_RootConstrainSelectedInstOperands,
     /*   94466 */     // GIR_Coverage, 899,
     /*   94466 */     GIR_Done,
     /*   94467 */   // Label 2486: @94467
     /*   94467 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(94508), // Rule ID 901 //
     /*   94472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   94475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   94485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94489 */     // MIs[0] rs1
     /*   94489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94501 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*   94506 */     GIR_RootConstrainSelectedInstOperands,
     /*   94507 */     // GIR_Coverage, 901,
     /*   94507 */     GIR_Done,
     /*   94508 */   // Label 2487: @94508
     /*   94508 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(94549), // Rule ID 903 //
     /*   94513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   94526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94530 */     // MIs[0] rs1
     /*   94530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94542 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94547 */     GIR_RootConstrainSelectedInstOperands,
     /*   94548 */     // GIR_Coverage, 903,
     /*   94548 */     GIR_Done,
     /*   94549 */   // Label 2488: @94549
     /*   94549 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(94590), // Rule ID 905 //
     /*   94554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   94567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94571 */     // MIs[0] rs1
     /*   94571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94583 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94588 */     GIR_RootConstrainSelectedInstOperands,
     /*   94589 */     // GIR_Coverage, 905,
     /*   94589 */     GIR_Done,
     /*   94590 */   // Label 2489: @94590
     /*   94590 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(94631), // Rule ID 907 //
     /*   94595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   94608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94612 */     // MIs[0] rs1
     /*   94612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94624 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94629 */     GIR_RootConstrainSelectedInstOperands,
     /*   94630 */     // GIR_Coverage, 907,
     /*   94630 */     GIR_Done,
     /*   94631 */   // Label 2490: @94631
     /*   94631 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(94672), // Rule ID 909 //
     /*   94636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   94649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94653 */     // MIs[0] rs1
     /*   94653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94665 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94670 */     GIR_RootConstrainSelectedInstOperands,
     /*   94671 */     // GIR_Coverage, 909,
     /*   94671 */     GIR_Done,
     /*   94672 */   // Label 2491: @94672
     /*   94672 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(94713), // Rule ID 911 //
     /*   94677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   94680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   94687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   94690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94694 */     // MIs[0] rs1
     /*   94694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   94698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94706 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   94706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*   94711 */     GIR_RootConstrainSelectedInstOperands,
     /*   94712 */     // GIR_Coverage, 911,
     /*   94712 */     GIR_Done,
     /*   94713 */   // Label 2492: @94713
     /*   94713 */   GIM_Reject,
     /*   94714 */ // Label 2452: @94714
     /*   94714 */ GIM_Reject,
     /*   94715 */ // Label 2420: @94715
     /*   94715 */ GIM_Reject,
     /*   94716 */ // Label 29: @94716
     /*   94716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2495*/ GIMT_Encode4(95627),
     /*   94727 */ /*GILLT_s32*//*Label 2493*/ GIMT_Encode4(94735),
     /*   94731 */ /*GILLT_s64*//*Label 2494*/ GIMT_Encode4(95017),
     /*   94735 */ // Label 2493: @94735
     /*   94735 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(95016),
     /*   94740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   94743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   94750 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(94803), // Rule ID 596 //
     /*   94755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*   94758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   94761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94765 */     // MIs[0] addr
     /*   94765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   94769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94777 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*   94777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   94780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   94783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   94785 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   94790 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   94792 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   94794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   94797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   94801 */     GIR_RootConstrainSelectedInstOperands,
     /*   94802 */     // GIR_Coverage, 596,
     /*   94802 */     GIR_EraseRootFromParent_Done,
     /*   94803 */   // Label 2497: @94803
     /*   94803 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(94856), // Rule ID 598 //
     /*   94808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*   94811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   94814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94818 */     // MIs[0] addr
     /*   94818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   94822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94830 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*   94830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   94833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   94836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   94838 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   94843 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   94845 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   94847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   94854 */     GIR_RootConstrainSelectedInstOperands,
     /*   94855 */     // GIR_Coverage, 598,
     /*   94855 */     GIR_EraseRootFromParent_Done,
     /*   94856 */   // Label 2498: @94856
     /*   94856 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(94909), // Rule ID 600 //
     /*   94861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*   94864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   94867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94871 */     // MIs[0] addr
     /*   94871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   94875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94883 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*   94883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   94886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   94889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   94891 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   94896 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   94898 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   94900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   94907 */     GIR_RootConstrainSelectedInstOperands,
     /*   94908 */     // GIR_Coverage, 600,
     /*   94908 */     GIR_EraseRootFromParent_Done,
     /*   94909 */   // Label 2499: @94909
     /*   94909 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(94962), // Rule ID 602 //
     /*   94914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*   94917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   94920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94924 */     // MIs[0] addr
     /*   94924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   94928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94936 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*   94936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   94939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   94942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   94944 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   94949 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   94951 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   94953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   94956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   94960 */     GIR_RootConstrainSelectedInstOperands,
     /*   94961 */     // GIR_Coverage, 602,
     /*   94961 */     GIR_EraseRootFromParent_Done,
     /*   94962 */   // Label 2500: @94962
     /*   94962 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(95015), // Rule ID 604 //
     /*   94967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*   94970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   94973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94977 */     // MIs[0] addr
     /*   94977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   94981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   94989 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*   94989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   94992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   94995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   94997 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95002 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95004 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   95009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95013 */     GIR_RootConstrainSelectedInstOperands,
     /*   95014 */     // GIR_Coverage, 604,
     /*   95014 */     GIR_EraseRootFromParent_Done,
     /*   95015 */   // Label 2501: @95015
     /*   95015 */   GIM_Reject,
     /*   95016 */ // Label 2496: @95016
     /*   95016 */ GIM_Reject,
     /*   95017 */ // Label 2494: @95017
     /*   95017 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(95626),
     /*   95022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   95025 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(95085), // Rule ID 595 //
     /*   95030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*   95033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   95043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95047 */     // MIs[0] addr
     /*   95047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95059 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*   95059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   95065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95067 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95072 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95074 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   95079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95083 */     GIR_RootConstrainSelectedInstOperands,
     /*   95084 */     // GIR_Coverage, 595,
     /*   95084 */     GIR_EraseRootFromParent_Done,
     /*   95085 */   // Label 2503: @95085
     /*   95085 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(95145), // Rule ID 597 //
     /*   95090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*   95093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   95103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95107 */     // MIs[0] addr
     /*   95107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95119 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*   95119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   95125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95127 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95132 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95134 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95143 */     GIR_RootConstrainSelectedInstOperands,
     /*   95144 */     // GIR_Coverage, 597,
     /*   95144 */     GIR_EraseRootFromParent_Done,
     /*   95145 */   // Label 2504: @95145
     /*   95145 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(95205), // Rule ID 599 //
     /*   95150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*   95153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   95163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95167 */     // MIs[0] addr
     /*   95167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95179 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*   95179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   95185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95187 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95192 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95194 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95203 */     GIR_RootConstrainSelectedInstOperands,
     /*   95204 */     // GIR_Coverage, 599,
     /*   95204 */     GIR_EraseRootFromParent_Done,
     /*   95205 */   // Label 2505: @95205
     /*   95205 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(95265), // Rule ID 601 //
     /*   95210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*   95213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   95223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95227 */     // MIs[0] addr
     /*   95227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95239 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*   95239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   95245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95247 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95252 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95254 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   95259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95263 */     GIR_RootConstrainSelectedInstOperands,
     /*   95264 */     // GIR_Coverage, 601,
     /*   95264 */     GIR_EraseRootFromParent_Done,
     /*   95265 */   // Label 2506: @95265
     /*   95265 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(95325), // Rule ID 603 //
     /*   95270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*   95273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   95283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95287 */     // MIs[0] addr
     /*   95287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95299 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*   95299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*   95305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95307 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95312 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95314 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   95319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95323 */     GIR_RootConstrainSelectedInstOperands,
     /*   95324 */     // GIR_Coverage, 603,
     /*   95324 */     GIR_EraseRootFromParent_Done,
     /*   95325 */   // Label 2507: @95325
     /*   95325 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(95385), // Rule ID 613 //
     /*   95330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*   95333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   95340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   95343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95347 */     // MIs[0] addr
     /*   95347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95359 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*   95359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*   95365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95367 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95372 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95374 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*   95379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95383 */     GIR_RootConstrainSelectedInstOperands,
     /*   95384 */     // GIR_Coverage, 613,
     /*   95384 */     GIR_EraseRootFromParent_Done,
     /*   95385 */   // Label 2508: @95385
     /*   95385 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(95445), // Rule ID 614 //
     /*   95390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*   95393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   95400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   95403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95407 */     // MIs[0] addr
     /*   95407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95419 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*   95419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*   95425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95427 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95432 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95434 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95443 */     GIR_RootConstrainSelectedInstOperands,
     /*   95444 */     // GIR_Coverage, 614,
     /*   95444 */     GIR_EraseRootFromParent_Done,
     /*   95445 */   // Label 2509: @95445
     /*   95445 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(95505), // Rule ID 615 //
     /*   95450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*   95453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   95460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   95463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95467 */     // MIs[0] addr
     /*   95467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95479 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*   95479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*   95485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95487 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95492 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95494 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95503 */     GIR_RootConstrainSelectedInstOperands,
     /*   95504 */     // GIR_Coverage, 615,
     /*   95504 */     GIR_EraseRootFromParent_Done,
     /*   95505 */   // Label 2510: @95505
     /*   95505 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(95565), // Rule ID 616 //
     /*   95510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*   95513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   95520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   95523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95527 */     // MIs[0] addr
     /*   95527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95539 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*   95539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*   95545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95547 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95552 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95554 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   95559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95563 */     GIR_RootConstrainSelectedInstOperands,
     /*   95564 */     // GIR_Coverage, 616,
     /*   95564 */     GIR_EraseRootFromParent_Done,
     /*   95565 */   // Label 2511: @95565
     /*   95565 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(95625), // Rule ID 617 //
     /*   95570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*   95573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   95580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   95583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95587 */     // MIs[0] addr
     /*   95587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*   95591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95599 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*   95599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*   95602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*   95605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*   95607 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*   95612 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*   95614 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*   95616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   95619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*   95623 */     GIR_RootConstrainSelectedInstOperands,
     /*   95624 */     // GIR_Coverage, 617,
     /*   95624 */     GIR_EraseRootFromParent_Done,
     /*   95625 */   // Label 2512: @95625
     /*   95625 */   GIM_Reject,
     /*   95626 */ // Label 2502: @95626
     /*   95626 */ GIM_Reject,
     /*   95627 */ // Label 2495: @95627
     /*   95627 */ GIM_Reject,
     /*   95628 */ // Label 30: @95628
     /*   95628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2515*/ GIMT_Encode4(98537),
     /*   95639 */ /*GILLT_s32*//*Label 2513*/ GIMT_Encode4(95647),
     /*   95643 */ /*GILLT_s64*//*Label 2514*/ GIMT_Encode4(96887),
     /*   95647 */ // Label 2513: @95647
     /*   95647 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(96886),
     /*   95652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   95655 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(95696), // Rule ID 386 //
     /*   95660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   95663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   95673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95677 */     // MIs[0] rs1
     /*   95677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95689 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   95694 */     GIR_RootConstrainSelectedInstOperands,
     /*   95695 */     // GIR_Coverage, 386,
     /*   95695 */     GIR_Done,
     /*   95696 */   // Label 2517: @95696
     /*   95696 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(95737), // Rule ID 388 //
     /*   95701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   95704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   95714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95718 */     // MIs[0] rs1
     /*   95718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95730 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*   95735 */     GIR_RootConstrainSelectedInstOperands,
     /*   95736 */     // GIR_Coverage, 388,
     /*   95736 */     GIR_Done,
     /*   95737 */   // Label 2518: @95737
     /*   95737 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(95778), // Rule ID 390 //
     /*   95742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   95745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   95755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95759 */     // MIs[0] rs1
     /*   95759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95771 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*   95776 */     GIR_RootConstrainSelectedInstOperands,
     /*   95777 */     // GIR_Coverage, 390,
     /*   95777 */     GIR_Done,
     /*   95778 */   // Label 2519: @95778
     /*   95778 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(95819), // Rule ID 392 //
     /*   95783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   95786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   95796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95800 */     // MIs[0] rs1
     /*   95800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95812 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*   95817 */     GIR_RootConstrainSelectedInstOperands,
     /*   95818 */     // GIR_Coverage, 392,
     /*   95818 */     GIR_Done,
     /*   95819 */   // Label 2520: @95819
     /*   95819 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(95860), // Rule ID 394 //
     /*   95824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   95827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   95837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95841 */     // MIs[0] rs1
     /*   95841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95853 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*   95858 */     GIR_RootConstrainSelectedInstOperands,
     /*   95859 */     // GIR_Coverage, 394,
     /*   95859 */     GIR_Done,
     /*   95860 */   // Label 2521: @95860
     /*   95860 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(95901), // Rule ID 396 //
     /*   95865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   95868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   95878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95882 */     // MIs[0] rs1
     /*   95882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95894 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   95899 */     GIR_RootConstrainSelectedInstOperands,
     /*   95900 */     // GIR_Coverage, 396,
     /*   95900 */     GIR_Done,
     /*   95901 */   // Label 2522: @95901
     /*   95901 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(95942), // Rule ID 398 //
     /*   95906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   95909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   95919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95923 */     // MIs[0] rs1
     /*   95923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95935 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   95940 */     GIR_RootConstrainSelectedInstOperands,
     /*   95941 */     // GIR_Coverage, 398,
     /*   95941 */     GIR_Done,
     /*   95942 */   // Label 2523: @95942
     /*   95942 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(95983), // Rule ID 400 //
     /*   95947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   95950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   95960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95964 */     // MIs[0] rs1
     /*   95964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   95968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   95976 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   95976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   95981 */     GIR_RootConstrainSelectedInstOperands,
     /*   95982 */     // GIR_Coverage, 400,
     /*   95982 */     GIR_Done,
     /*   95983 */   // Label 2524: @95983
     /*   95983 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(96024), // Rule ID 402 //
     /*   95988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   95991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   95998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   96001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96005 */     // MIs[0] rs1
     /*   96005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96017 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   96022 */     GIR_RootConstrainSelectedInstOperands,
     /*   96023 */     // GIR_Coverage, 402,
     /*   96023 */     GIR_Done,
     /*   96024 */   // Label 2525: @96024
     /*   96024 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(96065), // Rule ID 404 //
     /*   96029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   96032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   96039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   96042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96046 */     // MIs[0] rs1
     /*   96046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96058 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   96063 */     GIR_RootConstrainSelectedInstOperands,
     /*   96064 */     // GIR_Coverage, 404,
     /*   96064 */     GIR_Done,
     /*   96065 */   // Label 2526: @96065
     /*   96065 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(96106), // Rule ID 734 //
     /*   96070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   96083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96087 */     // MIs[0] rs1
     /*   96087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96099 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96104 */     GIR_RootConstrainSelectedInstOperands,
     /*   96105 */     // GIR_Coverage, 734,
     /*   96105 */     GIR_Done,
     /*   96106 */   // Label 2527: @96106
     /*   96106 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(96147), // Rule ID 736 //
     /*   96111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   96124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96128 */     // MIs[0] rs1
     /*   96128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96140 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*   96145 */     GIR_RootConstrainSelectedInstOperands,
     /*   96146 */     // GIR_Coverage, 736,
     /*   96146 */     GIR_Done,
     /*   96147 */   // Label 2528: @96147
     /*   96147 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(96188), // Rule ID 738 //
     /*   96152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   96165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96169 */     // MIs[0] rs1
     /*   96169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96181 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*   96186 */     GIR_RootConstrainSelectedInstOperands,
     /*   96187 */     // GIR_Coverage, 738,
     /*   96187 */     GIR_Done,
     /*   96188 */   // Label 2529: @96188
     /*   96188 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(96229), // Rule ID 740 //
     /*   96193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   96206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96210 */     // MIs[0] rs1
     /*   96210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96222 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*   96227 */     GIR_RootConstrainSelectedInstOperands,
     /*   96228 */     // GIR_Coverage, 740,
     /*   96228 */     GIR_Done,
     /*   96229 */   // Label 2530: @96229
     /*   96229 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(96270), // Rule ID 742 //
     /*   96234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   96247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96251 */     // MIs[0] rs1
     /*   96251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96263 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*   96268 */     GIR_RootConstrainSelectedInstOperands,
     /*   96269 */     // GIR_Coverage, 742,
     /*   96269 */     GIR_Done,
     /*   96270 */   // Label 2531: @96270
     /*   96270 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(96311), // Rule ID 744 //
     /*   96275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   96288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96292 */     // MIs[0] rs1
     /*   96292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96304 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96309 */     GIR_RootConstrainSelectedInstOperands,
     /*   96310 */     // GIR_Coverage, 744,
     /*   96310 */     GIR_Done,
     /*   96311 */   // Label 2532: @96311
     /*   96311 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(96352), // Rule ID 746 //
     /*   96316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   96329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96333 */     // MIs[0] rs1
     /*   96333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96345 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96350 */     GIR_RootConstrainSelectedInstOperands,
     /*   96351 */     // GIR_Coverage, 746,
     /*   96351 */     GIR_Done,
     /*   96352 */   // Label 2533: @96352
     /*   96352 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(96393), // Rule ID 748 //
     /*   96357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   96370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96374 */     // MIs[0] rs1
     /*   96374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96386 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96391 */     GIR_RootConstrainSelectedInstOperands,
     /*   96392 */     // GIR_Coverage, 748,
     /*   96392 */     GIR_Done,
     /*   96393 */   // Label 2534: @96393
     /*   96393 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(96434), // Rule ID 750 //
     /*   96398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   96411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96415 */     // MIs[0] rs1
     /*   96415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96427 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96432 */     GIR_RootConstrainSelectedInstOperands,
     /*   96433 */     // GIR_Coverage, 750,
     /*   96433 */     GIR_Done,
     /*   96434 */   // Label 2535: @96434
     /*   96434 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(96475), // Rule ID 752 //
     /*   96439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   96449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   96452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96456 */     // MIs[0] rs1
     /*   96456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96468 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   96473 */     GIR_RootConstrainSelectedInstOperands,
     /*   96474 */     // GIR_Coverage, 752,
     /*   96474 */     GIR_Done,
     /*   96475 */   // Label 2536: @96475
     /*   96475 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(96516), // Rule ID 914 //
     /*   96480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   96493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96497 */     // MIs[0] rs1
     /*   96497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96509 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96514 */     GIR_RootConstrainSelectedInstOperands,
     /*   96515 */     // GIR_Coverage, 914,
     /*   96515 */     GIR_Done,
     /*   96516 */   // Label 2537: @96516
     /*   96516 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(96557), // Rule ID 916 //
     /*   96521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   96534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96538 */     // MIs[0] rs1
     /*   96538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96550 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*   96555 */     GIR_RootConstrainSelectedInstOperands,
     /*   96556 */     // GIR_Coverage, 916,
     /*   96556 */     GIR_Done,
     /*   96557 */   // Label 2538: @96557
     /*   96557 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(96598), // Rule ID 918 //
     /*   96562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   96575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96579 */     // MIs[0] rs1
     /*   96579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96591 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*   96596 */     GIR_RootConstrainSelectedInstOperands,
     /*   96597 */     // GIR_Coverage, 918,
     /*   96597 */     GIR_Done,
     /*   96598 */   // Label 2539: @96598
     /*   96598 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(96639), // Rule ID 920 //
     /*   96603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   96616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96620 */     // MIs[0] rs1
     /*   96620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96632 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*   96637 */     GIR_RootConstrainSelectedInstOperands,
     /*   96638 */     // GIR_Coverage, 920,
     /*   96638 */     GIR_Done,
     /*   96639 */   // Label 2540: @96639
     /*   96639 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(96680), // Rule ID 922 //
     /*   96644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   96647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   96657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96661 */     // MIs[0] rs1
     /*   96661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96673 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*   96678 */     GIR_RootConstrainSelectedInstOperands,
     /*   96679 */     // GIR_Coverage, 922,
     /*   96679 */     GIR_Done,
     /*   96680 */   // Label 2541: @96680
     /*   96680 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(96721), // Rule ID 924 //
     /*   96685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   96698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96702 */     // MIs[0] rs1
     /*   96702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96714 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96719 */     GIR_RootConstrainSelectedInstOperands,
     /*   96720 */     // GIR_Coverage, 924,
     /*   96720 */     GIR_Done,
     /*   96721 */   // Label 2542: @96721
     /*   96721 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(96762), // Rule ID 926 //
     /*   96726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   96739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96743 */     // MIs[0] rs1
     /*   96743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96755 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96760 */     GIR_RootConstrainSelectedInstOperands,
     /*   96761 */     // GIR_Coverage, 926,
     /*   96761 */     GIR_Done,
     /*   96762 */   // Label 2543: @96762
     /*   96762 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(96803), // Rule ID 928 //
     /*   96767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   96780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96784 */     // MIs[0] rs1
     /*   96784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96796 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96801 */     GIR_RootConstrainSelectedInstOperands,
     /*   96802 */     // GIR_Coverage, 928,
     /*   96802 */     GIR_Done,
     /*   96803 */   // Label 2544: @96803
     /*   96803 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(96844), // Rule ID 930 //
     /*   96808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   96821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96825 */     // MIs[0] rs1
     /*   96825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96837 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96842 */     GIR_RootConstrainSelectedInstOperands,
     /*   96843 */     // GIR_Coverage, 930,
     /*   96843 */     GIR_Done,
     /*   96844 */   // Label 2545: @96844
     /*   96844 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(96885), // Rule ID 932 //
     /*   96849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   96852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   96859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   96862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96866 */     // MIs[0] rs1
     /*   96866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   96870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96878 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   96878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   96883 */     GIR_RootConstrainSelectedInstOperands,
     /*   96884 */     // GIR_Coverage, 932,
     /*   96884 */     GIR_Done,
     /*   96885 */   // Label 2546: @96885
     /*   96885 */   GIM_Reject,
     /*   96886 */ // Label 2516: @96886
     /*   96886 */ GIM_Reject,
     /*   96887 */ // Label 2514: @96887
     /*   96887 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(98536),
     /*   96892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   96895 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(96936), // Rule ID 385 //
     /*   96900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   96903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   96910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   96913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96917 */     // MIs[0] rs1
     /*   96917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   96921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96929 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   96929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   96934 */     GIR_RootConstrainSelectedInstOperands,
     /*   96935 */     // GIR_Coverage, 385,
     /*   96935 */     GIR_Done,
     /*   96936 */   // Label 2548: @96936
     /*   96936 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(96977), // Rule ID 387 //
     /*   96941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   96944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   96951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   96954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96958 */     // MIs[0] rs1
     /*   96958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   96962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96970 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   96970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*   96975 */     GIR_RootConstrainSelectedInstOperands,
     /*   96976 */     // GIR_Coverage, 387,
     /*   96976 */     GIR_Done,
     /*   96977 */   // Label 2549: @96977
     /*   96977 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(97018), // Rule ID 389 //
     /*   96982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   96985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   96992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   96995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   96999 */     // MIs[0] rs1
     /*   96999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97011 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*   97016 */     GIR_RootConstrainSelectedInstOperands,
     /*   97017 */     // GIR_Coverage, 389,
     /*   97017 */     GIR_Done,
     /*   97018 */   // Label 2550: @97018
     /*   97018 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(97059), // Rule ID 391 //
     /*   97023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   97026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   97036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97040 */     // MIs[0] rs1
     /*   97040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97052 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*   97057 */     GIR_RootConstrainSelectedInstOperands,
     /*   97058 */     // GIR_Coverage, 391,
     /*   97058 */     GIR_Done,
     /*   97059 */   // Label 2551: @97059
     /*   97059 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(97100), // Rule ID 393 //
     /*   97064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   97067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   97077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97081 */     // MIs[0] rs1
     /*   97081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97093 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*   97098 */     GIR_RootConstrainSelectedInstOperands,
     /*   97099 */     // GIR_Coverage, 393,
     /*   97099 */     GIR_Done,
     /*   97100 */   // Label 2552: @97100
     /*   97100 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(97141), // Rule ID 395 //
     /*   97105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   97108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   97118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97122 */     // MIs[0] rs1
     /*   97122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97134 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   97139 */     GIR_RootConstrainSelectedInstOperands,
     /*   97140 */     // GIR_Coverage, 395,
     /*   97140 */     GIR_Done,
     /*   97141 */   // Label 2553: @97141
     /*   97141 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(97182), // Rule ID 397 //
     /*   97146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   97149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   97159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97163 */     // MIs[0] rs1
     /*   97163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97175 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   97180 */     GIR_RootConstrainSelectedInstOperands,
     /*   97181 */     // GIR_Coverage, 397,
     /*   97181 */     GIR_Done,
     /*   97182 */   // Label 2554: @97182
     /*   97182 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(97223), // Rule ID 399 //
     /*   97187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   97190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   97200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97204 */     // MIs[0] rs1
     /*   97204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97216 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   97221 */     GIR_RootConstrainSelectedInstOperands,
     /*   97222 */     // GIR_Coverage, 399,
     /*   97222 */     GIR_Done,
     /*   97223 */   // Label 2555: @97223
     /*   97223 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(97264), // Rule ID 401 //
     /*   97228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   97231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   97241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97245 */     // MIs[0] rs1
     /*   97245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97257 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   97262 */     GIR_RootConstrainSelectedInstOperands,
     /*   97263 */     // GIR_Coverage, 401,
     /*   97263 */     GIR_Done,
     /*   97264 */   // Label 2556: @97264
     /*   97264 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(97305), // Rule ID 403 //
     /*   97269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*   97272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   97279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   97282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97286 */     // MIs[0] rs1
     /*   97286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97298 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*   97303 */     GIR_RootConstrainSelectedInstOperands,
     /*   97304 */     // GIR_Coverage, 403,
     /*   97304 */     GIR_Done,
     /*   97305 */   // Label 2557: @97305
     /*   97305 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(97346), // Rule ID 535 //
     /*   97310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   97313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   97323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97327 */     // MIs[0] rs1
     /*   97327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97339 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97344 */     GIR_RootConstrainSelectedInstOperands,
     /*   97345 */     // GIR_Coverage, 535,
     /*   97345 */     GIR_Done,
     /*   97346 */   // Label 2558: @97346
     /*   97346 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(97387), // Rule ID 536 //
     /*   97351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   97354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   97364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97368 */     // MIs[0] rs1
     /*   97368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97380 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*   97385 */     GIR_RootConstrainSelectedInstOperands,
     /*   97386 */     // GIR_Coverage, 536,
     /*   97386 */     GIR_Done,
     /*   97387 */   // Label 2559: @97387
     /*   97387 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(97428), // Rule ID 537 //
     /*   97392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   97395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   97405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97409 */     // MIs[0] rs1
     /*   97409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97421 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*   97426 */     GIR_RootConstrainSelectedInstOperands,
     /*   97427 */     // GIR_Coverage, 537,
     /*   97427 */     GIR_Done,
     /*   97428 */   // Label 2560: @97428
     /*   97428 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(97469), // Rule ID 538 //
     /*   97433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   97436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   97446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97450 */     // MIs[0] rs1
     /*   97450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97462 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*   97467 */     GIR_RootConstrainSelectedInstOperands,
     /*   97468 */     // GIR_Coverage, 538,
     /*   97468 */     GIR_Done,
     /*   97469 */   // Label 2561: @97469
     /*   97469 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(97510), // Rule ID 539 //
     /*   97474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*   97477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   97487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97491 */     // MIs[0] rs1
     /*   97491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97503 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*   97508 */     GIR_RootConstrainSelectedInstOperands,
     /*   97509 */     // GIR_Coverage, 539,
     /*   97509 */     GIR_Done,
     /*   97510 */   // Label 2562: @97510
     /*   97510 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(97551), // Rule ID 540 //
     /*   97515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   97518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   97528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97532 */     // MIs[0] rs1
     /*   97532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97544 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97549 */     GIR_RootConstrainSelectedInstOperands,
     /*   97550 */     // GIR_Coverage, 540,
     /*   97550 */     GIR_Done,
     /*   97551 */   // Label 2563: @97551
     /*   97551 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(97592), // Rule ID 541 //
     /*   97556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   97559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   97569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97573 */     // MIs[0] rs1
     /*   97573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97585 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97590 */     GIR_RootConstrainSelectedInstOperands,
     /*   97591 */     // GIR_Coverage, 541,
     /*   97591 */     GIR_Done,
     /*   97592 */   // Label 2564: @97592
     /*   97592 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(97633), // Rule ID 542 //
     /*   97597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   97600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   97610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97614 */     // MIs[0] rs1
     /*   97614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97626 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97631 */     GIR_RootConstrainSelectedInstOperands,
     /*   97632 */     // GIR_Coverage, 542,
     /*   97632 */     GIR_Done,
     /*   97633 */   // Label 2565: @97633
     /*   97633 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(97674), // Rule ID 543 //
     /*   97638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   97641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   97651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97655 */     // MIs[0] rs1
     /*   97655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97667 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97672 */     GIR_RootConstrainSelectedInstOperands,
     /*   97673 */     // GIR_Coverage, 543,
     /*   97673 */     GIR_Done,
     /*   97674 */   // Label 2566: @97674
     /*   97674 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(97715), // Rule ID 544 //
     /*   97679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*   97682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*   97689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   97692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97696 */     // MIs[0] rs1
     /*   97696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97708 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*   97713 */     GIR_RootConstrainSelectedInstOperands,
     /*   97714 */     // GIR_Coverage, 544,
     /*   97714 */     GIR_Done,
     /*   97715 */   // Label 2567: @97715
     /*   97715 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(97756), // Rule ID 733 //
     /*   97720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   97723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   97733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97737 */     // MIs[0] rs1
     /*   97737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97749 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   97754 */     GIR_RootConstrainSelectedInstOperands,
     /*   97755 */     // GIR_Coverage, 733,
     /*   97755 */     GIR_Done,
     /*   97756 */   // Label 2568: @97756
     /*   97756 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(97797), // Rule ID 735 //
     /*   97761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   97764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   97774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97778 */     // MIs[0] rs1
     /*   97778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97790 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*   97795 */     GIR_RootConstrainSelectedInstOperands,
     /*   97796 */     // GIR_Coverage, 735,
     /*   97796 */     GIR_Done,
     /*   97797 */   // Label 2569: @97797
     /*   97797 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(97838), // Rule ID 737 //
     /*   97802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   97805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   97815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97819 */     // MIs[0] rs1
     /*   97819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97831 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*   97836 */     GIR_RootConstrainSelectedInstOperands,
     /*   97837 */     // GIR_Coverage, 737,
     /*   97837 */     GIR_Done,
     /*   97838 */   // Label 2570: @97838
     /*   97838 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(97879), // Rule ID 739 //
     /*   97843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   97846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   97856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97860 */     // MIs[0] rs1
     /*   97860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97872 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*   97877 */     GIR_RootConstrainSelectedInstOperands,
     /*   97878 */     // GIR_Coverage, 739,
     /*   97878 */     GIR_Done,
     /*   97879 */   // Label 2571: @97879
     /*   97879 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(97920), // Rule ID 741 //
     /*   97884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   97887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   97897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97901 */     // MIs[0] rs1
     /*   97901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97913 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*   97918 */     GIR_RootConstrainSelectedInstOperands,
     /*   97919 */     // GIR_Coverage, 741,
     /*   97919 */     GIR_Done,
     /*   97920 */   // Label 2572: @97920
     /*   97920 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(97961), // Rule ID 743 //
     /*   97925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   97928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   97938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97942 */     // MIs[0] rs1
     /*   97942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97954 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   97959 */     GIR_RootConstrainSelectedInstOperands,
     /*   97960 */     // GIR_Coverage, 743,
     /*   97960 */     GIR_Done,
     /*   97961 */   // Label 2573: @97961
     /*   97961 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(98002), // Rule ID 745 //
     /*   97966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   97969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   97976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   97979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97983 */     // MIs[0] rs1
     /*   97983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   97987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   97995 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   97995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   98000 */     GIR_RootConstrainSelectedInstOperands,
     /*   98001 */     // GIR_Coverage, 745,
     /*   98001 */     GIR_Done,
     /*   98002 */   // Label 2574: @98002
     /*   98002 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(98043), // Rule ID 747 //
     /*   98007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   98017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   98020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98024 */     // MIs[0] rs1
     /*   98024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98036 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   98041 */     GIR_RootConstrainSelectedInstOperands,
     /*   98042 */     // GIR_Coverage, 747,
     /*   98042 */     GIR_Done,
     /*   98043 */   // Label 2575: @98043
     /*   98043 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(98084), // Rule ID 749 //
     /*   98048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   98058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   98061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98065 */     // MIs[0] rs1
     /*   98065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98077 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   98082 */     GIR_RootConstrainSelectedInstOperands,
     /*   98083 */     // GIR_Coverage, 749,
     /*   98083 */     GIR_Done,
     /*   98084 */   // Label 2576: @98084
     /*   98084 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(98125), // Rule ID 751 //
     /*   98089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   98099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   98102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98106 */     // MIs[0] rs1
     /*   98106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98118 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*   98123 */     GIR_RootConstrainSelectedInstOperands,
     /*   98124 */     // GIR_Coverage, 751,
     /*   98124 */     GIR_Done,
     /*   98125 */   // Label 2577: @98125
     /*   98125 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(98166), // Rule ID 913 //
     /*   98130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   98133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   98143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98147 */     // MIs[0] rs1
     /*   98147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98159 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98164 */     GIR_RootConstrainSelectedInstOperands,
     /*   98165 */     // GIR_Coverage, 913,
     /*   98165 */     GIR_Done,
     /*   98166 */   // Label 2578: @98166
     /*   98166 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(98207), // Rule ID 915 //
     /*   98171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   98174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   98184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98188 */     // MIs[0] rs1
     /*   98188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98200 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*   98205 */     GIR_RootConstrainSelectedInstOperands,
     /*   98206 */     // GIR_Coverage, 915,
     /*   98206 */     GIR_Done,
     /*   98207 */   // Label 2579: @98207
     /*   98207 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(98248), // Rule ID 917 //
     /*   98212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   98215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   98225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98229 */     // MIs[0] rs1
     /*   98229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98241 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*   98246 */     GIR_RootConstrainSelectedInstOperands,
     /*   98247 */     // GIR_Coverage, 917,
     /*   98247 */     GIR_Done,
     /*   98248 */   // Label 2580: @98248
     /*   98248 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(98289), // Rule ID 919 //
     /*   98253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   98256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   98266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98270 */     // MIs[0] rs1
     /*   98270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98282 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*   98287 */     GIR_RootConstrainSelectedInstOperands,
     /*   98288 */     // GIR_Coverage, 919,
     /*   98288 */     GIR_Done,
     /*   98289 */   // Label 2581: @98289
     /*   98289 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(98330), // Rule ID 921 //
     /*   98294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*   98297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   98307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98311 */     // MIs[0] rs1
     /*   98311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98323 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*   98328 */     GIR_RootConstrainSelectedInstOperands,
     /*   98329 */     // GIR_Coverage, 921,
     /*   98329 */     GIR_Done,
     /*   98330 */   // Label 2582: @98330
     /*   98330 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(98371), // Rule ID 923 //
     /*   98335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   98348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98352 */     // MIs[0] rs1
     /*   98352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98364 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98369 */     GIR_RootConstrainSelectedInstOperands,
     /*   98370 */     // GIR_Coverage, 923,
     /*   98370 */     GIR_Done,
     /*   98371 */   // Label 2583: @98371
     /*   98371 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(98412), // Rule ID 925 //
     /*   98376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   98389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98393 */     // MIs[0] rs1
     /*   98393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98405 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98410 */     GIR_RootConstrainSelectedInstOperands,
     /*   98411 */     // GIR_Coverage, 925,
     /*   98411 */     GIR_Done,
     /*   98412 */   // Label 2584: @98412
     /*   98412 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(98453), // Rule ID 927 //
     /*   98417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   98430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98434 */     // MIs[0] rs1
     /*   98434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98446 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98451 */     GIR_RootConstrainSelectedInstOperands,
     /*   98452 */     // GIR_Coverage, 927,
     /*   98452 */     GIR_Done,
     /*   98453 */   // Label 2585: @98453
     /*   98453 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(98494), // Rule ID 929 //
     /*   98458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   98471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98475 */     // MIs[0] rs1
     /*   98475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98487 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98492 */     GIR_RootConstrainSelectedInstOperands,
     /*   98493 */     // GIR_Coverage, 929,
     /*   98493 */     GIR_Done,
     /*   98494 */   // Label 2586: @98494
     /*   98494 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(98535), // Rule ID 931 //
     /*   98499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*   98502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   98509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   98512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98516 */     // MIs[0] rs1
     /*   98516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   98520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98528 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   98528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*   98533 */     GIR_RootConstrainSelectedInstOperands,
     /*   98534 */     // GIR_Coverage, 931,
     /*   98534 */     GIR_Done,
     /*   98535 */   // Label 2587: @98535
     /*   98535 */   GIM_Reject,
     /*   98536 */ // Label 2547: @98536
     /*   98536 */ GIM_Reject,
     /*   98537 */ // Label 2515: @98537
     /*   98537 */ GIM_Reject,
     /*   98538 */ // Label 31: @98538
     /*   98538 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2590*/ GIMT_Encode4(101447),
     /*   98549 */ /*GILLT_s32*//*Label 2588*/ GIMT_Encode4(98557),
     /*   98553 */ /*GILLT_s64*//*Label 2589*/ GIMT_Encode4(99797),
     /*   98557 */ // Label 2588: @98557
     /*   98557 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(99796),
     /*   98562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   98565 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(98606), // Rule ID 406 //
     /*   98570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   98573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   98583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98587 */     // MIs[0] rs1
     /*   98587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98599 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98604 */     GIR_RootConstrainSelectedInstOperands,
     /*   98605 */     // GIR_Coverage, 406,
     /*   98605 */     GIR_Done,
     /*   98606 */   // Label 2592: @98606
     /*   98606 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(98647), // Rule ID 408 //
     /*   98611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   98614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   98624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98628 */     // MIs[0] rs1
     /*   98628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98640 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*   98645 */     GIR_RootConstrainSelectedInstOperands,
     /*   98646 */     // GIR_Coverage, 408,
     /*   98646 */     GIR_Done,
     /*   98647 */   // Label 2593: @98647
     /*   98647 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(98688), // Rule ID 410 //
     /*   98652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   98655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   98665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98669 */     // MIs[0] rs1
     /*   98669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98681 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*   98686 */     GIR_RootConstrainSelectedInstOperands,
     /*   98687 */     // GIR_Coverage, 410,
     /*   98687 */     GIR_Done,
     /*   98688 */   // Label 2594: @98688
     /*   98688 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(98729), // Rule ID 412 //
     /*   98693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   98696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   98706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98710 */     // MIs[0] rs1
     /*   98710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98722 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*   98727 */     GIR_RootConstrainSelectedInstOperands,
     /*   98728 */     // GIR_Coverage, 412,
     /*   98728 */     GIR_Done,
     /*   98729 */   // Label 2595: @98729
     /*   98729 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(98770), // Rule ID 414 //
     /*   98734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*   98737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   98747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98751 */     // MIs[0] rs1
     /*   98751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98763 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*   98768 */     GIR_RootConstrainSelectedInstOperands,
     /*   98769 */     // GIR_Coverage, 414,
     /*   98769 */     GIR_Done,
     /*   98770 */   // Label 2596: @98770
     /*   98770 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(98811), // Rule ID 416 //
     /*   98775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   98778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   98788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98792 */     // MIs[0] rs1
     /*   98792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98804 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98809 */     GIR_RootConstrainSelectedInstOperands,
     /*   98810 */     // GIR_Coverage, 416,
     /*   98810 */     GIR_Done,
     /*   98811 */   // Label 2597: @98811
     /*   98811 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(98852), // Rule ID 418 //
     /*   98816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   98819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   98829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98833 */     // MIs[0] rs1
     /*   98833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98845 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98850 */     GIR_RootConstrainSelectedInstOperands,
     /*   98851 */     // GIR_Coverage, 418,
     /*   98851 */     GIR_Done,
     /*   98852 */   // Label 2598: @98852
     /*   98852 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(98893), // Rule ID 420 //
     /*   98857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   98860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   98870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98874 */     // MIs[0] rs1
     /*   98874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98886 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98891 */     GIR_RootConstrainSelectedInstOperands,
     /*   98892 */     // GIR_Coverage, 420,
     /*   98892 */     GIR_Done,
     /*   98893 */   // Label 2599: @98893
     /*   98893 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(98934), // Rule ID 422 //
     /*   98898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   98901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   98911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98915 */     // MIs[0] rs1
     /*   98915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98927 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98932 */     GIR_RootConstrainSelectedInstOperands,
     /*   98933 */     // GIR_Coverage, 422,
     /*   98933 */     GIR_Done,
     /*   98934 */   // Label 2600: @98934
     /*   98934 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(98975), // Rule ID 424 //
     /*   98939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*   98942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   98949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   98952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98956 */     // MIs[0] rs1
     /*   98956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   98960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98968 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   98968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   98973 */     GIR_RootConstrainSelectedInstOperands,
     /*   98974 */     // GIR_Coverage, 424,
     /*   98974 */     GIR_Done,
     /*   98975 */   // Label 2601: @98975
     /*   98975 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(99016), // Rule ID 754 //
     /*   98980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   98983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   98990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   98993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   98997 */     // MIs[0] rs1
     /*   98997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99009 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99014 */     GIR_RootConstrainSelectedInstOperands,
     /*   99015 */     // GIR_Coverage, 754,
     /*   99015 */     GIR_Done,
     /*   99016 */   // Label 2602: @99016
     /*   99016 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(99057), // Rule ID 756 //
     /*   99021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   99034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99038 */     // MIs[0] rs1
     /*   99038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99050 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*   99055 */     GIR_RootConstrainSelectedInstOperands,
     /*   99056 */     // GIR_Coverage, 756,
     /*   99056 */     GIR_Done,
     /*   99057 */   // Label 2603: @99057
     /*   99057 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(99098), // Rule ID 758 //
     /*   99062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   99075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99079 */     // MIs[0] rs1
     /*   99079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99091 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*   99096 */     GIR_RootConstrainSelectedInstOperands,
     /*   99097 */     // GIR_Coverage, 758,
     /*   99097 */     GIR_Done,
     /*   99098 */   // Label 2604: @99098
     /*   99098 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(99139), // Rule ID 760 //
     /*   99103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   99116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99120 */     // MIs[0] rs1
     /*   99120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99132 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*   99137 */     GIR_RootConstrainSelectedInstOperands,
     /*   99138 */     // GIR_Coverage, 760,
     /*   99138 */     GIR_Done,
     /*   99139 */   // Label 2605: @99139
     /*   99139 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(99180), // Rule ID 762 //
     /*   99144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   99157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99161 */     // MIs[0] rs1
     /*   99161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99173 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*   99178 */     GIR_RootConstrainSelectedInstOperands,
     /*   99179 */     // GIR_Coverage, 762,
     /*   99179 */     GIR_Done,
     /*   99180 */   // Label 2606: @99180
     /*   99180 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(99221), // Rule ID 764 //
     /*   99185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   99198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99202 */     // MIs[0] rs1
     /*   99202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99214 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99219 */     GIR_RootConstrainSelectedInstOperands,
     /*   99220 */     // GIR_Coverage, 764,
     /*   99220 */     GIR_Done,
     /*   99221 */   // Label 2607: @99221
     /*   99221 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(99262), // Rule ID 766 //
     /*   99226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   99239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99243 */     // MIs[0] rs1
     /*   99243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99255 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99260 */     GIR_RootConstrainSelectedInstOperands,
     /*   99261 */     // GIR_Coverage, 766,
     /*   99261 */     GIR_Done,
     /*   99262 */   // Label 2608: @99262
     /*   99262 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(99303), // Rule ID 768 //
     /*   99267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   99280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99284 */     // MIs[0] rs1
     /*   99284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99296 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99301 */     GIR_RootConstrainSelectedInstOperands,
     /*   99302 */     // GIR_Coverage, 768,
     /*   99302 */     GIR_Done,
     /*   99303 */   // Label 2609: @99303
     /*   99303 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(99344), // Rule ID 770 //
     /*   99308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   99321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99325 */     // MIs[0] rs1
     /*   99325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99337 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99342 */     GIR_RootConstrainSelectedInstOperands,
     /*   99343 */     // GIR_Coverage, 770,
     /*   99343 */     GIR_Done,
     /*   99344 */   // Label 2610: @99344
     /*   99344 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(99385), // Rule ID 772 //
     /*   99349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*   99359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   99362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99366 */     // MIs[0] rs1
     /*   99366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99378 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*   99383 */     GIR_RootConstrainSelectedInstOperands,
     /*   99384 */     // GIR_Coverage, 772,
     /*   99384 */     GIR_Done,
     /*   99385 */   // Label 2611: @99385
     /*   99385 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(99426), // Rule ID 934 //
     /*   99390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   99403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99407 */     // MIs[0] rs1
     /*   99407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99419 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99424 */     GIR_RootConstrainSelectedInstOperands,
     /*   99425 */     // GIR_Coverage, 934,
     /*   99425 */     GIR_Done,
     /*   99426 */   // Label 2612: @99426
     /*   99426 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(99467), // Rule ID 936 //
     /*   99431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   99444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99448 */     // MIs[0] rs1
     /*   99448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99460 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*   99465 */     GIR_RootConstrainSelectedInstOperands,
     /*   99466 */     // GIR_Coverage, 936,
     /*   99466 */     GIR_Done,
     /*   99467 */   // Label 2613: @99467
     /*   99467 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(99508), // Rule ID 938 //
     /*   99472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   99485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99489 */     // MIs[0] rs1
     /*   99489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99501 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*   99506 */     GIR_RootConstrainSelectedInstOperands,
     /*   99507 */     // GIR_Coverage, 938,
     /*   99507 */     GIR_Done,
     /*   99508 */   // Label 2614: @99508
     /*   99508 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(99549), // Rule ID 940 //
     /*   99513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   99526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99530 */     // MIs[0] rs1
     /*   99530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99542 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*   99547 */     GIR_RootConstrainSelectedInstOperands,
     /*   99548 */     // GIR_Coverage, 940,
     /*   99548 */     GIR_Done,
     /*   99549 */   // Label 2615: @99549
     /*   99549 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(99590), // Rule ID 942 //
     /*   99554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*   99557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   99567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99571 */     // MIs[0] rs1
     /*   99571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99583 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*   99588 */     GIR_RootConstrainSelectedInstOperands,
     /*   99589 */     // GIR_Coverage, 942,
     /*   99589 */     GIR_Done,
     /*   99590 */   // Label 2616: @99590
     /*   99590 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(99631), // Rule ID 944 //
     /*   99595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   99608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99612 */     // MIs[0] rs1
     /*   99612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99624 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99629 */     GIR_RootConstrainSelectedInstOperands,
     /*   99630 */     // GIR_Coverage, 944,
     /*   99630 */     GIR_Done,
     /*   99631 */   // Label 2617: @99631
     /*   99631 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(99672), // Rule ID 946 //
     /*   99636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   99649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99653 */     // MIs[0] rs1
     /*   99653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99665 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99670 */     GIR_RootConstrainSelectedInstOperands,
     /*   99671 */     // GIR_Coverage, 946,
     /*   99671 */     GIR_Done,
     /*   99672 */   // Label 2618: @99672
     /*   99672 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(99713), // Rule ID 948 //
     /*   99677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   99690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99694 */     // MIs[0] rs1
     /*   99694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99706 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99711 */     GIR_RootConstrainSelectedInstOperands,
     /*   99712 */     // GIR_Coverage, 948,
     /*   99712 */     GIR_Done,
     /*   99713 */   // Label 2619: @99713
     /*   99713 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(99754), // Rule ID 950 //
     /*   99718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   99731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99735 */     // MIs[0] rs1
     /*   99735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99747 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99752 */     GIR_RootConstrainSelectedInstOperands,
     /*   99753 */     // GIR_Coverage, 950,
     /*   99753 */     GIR_Done,
     /*   99754 */   // Label 2620: @99754
     /*   99754 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(99795), // Rule ID 952 //
     /*   99759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*   99762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*   99769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   99772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99776 */     // MIs[0] rs1
     /*   99776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*   99780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99788 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   99788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*   99793 */     GIR_RootConstrainSelectedInstOperands,
     /*   99794 */     // GIR_Coverage, 952,
     /*   99794 */     GIR_Done,
     /*   99795 */   // Label 2621: @99795
     /*   99795 */   GIM_Reject,
     /*   99796 */ // Label 2591: @99796
     /*   99796 */ GIM_Reject,
     /*   99797 */ // Label 2589: @99797
     /*   99797 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(101446),
     /*   99802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   99805 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(99846), // Rule ID 405 //
     /*   99810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   99813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   99820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*   99823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99827 */     // MIs[0] rs1
     /*   99827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   99831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99839 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   99839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*   99844 */     GIR_RootConstrainSelectedInstOperands,
     /*   99845 */     // GIR_Coverage, 405,
     /*   99845 */     GIR_Done,
     /*   99846 */   // Label 2623: @99846
     /*   99846 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(99887), // Rule ID 407 //
     /*   99851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   99854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   99861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*   99864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99868 */     // MIs[0] rs1
     /*   99868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   99872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99880 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   99880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*   99885 */     GIR_RootConstrainSelectedInstOperands,
     /*   99886 */     // GIR_Coverage, 407,
     /*   99886 */     GIR_Done,
     /*   99887 */   // Label 2624: @99887
     /*   99887 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(99928), // Rule ID 409 //
     /*   99892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   99895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   99902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*   99905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99909 */     // MIs[0] rs1
     /*   99909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   99913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99921 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   99921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*   99926 */     GIR_RootConstrainSelectedInstOperands,
     /*   99927 */     // GIR_Coverage, 409,
     /*   99927 */     GIR_Done,
     /*   99928 */   // Label 2625: @99928
     /*   99928 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(99969), // Rule ID 411 //
     /*   99933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   99936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   99943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*   99946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99950 */     // MIs[0] rs1
     /*   99950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   99954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99962 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   99962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*   99967 */     GIR_RootConstrainSelectedInstOperands,
     /*   99968 */     // GIR_Coverage, 411,
     /*   99968 */     GIR_Done,
     /*   99969 */   // Label 2626: @99969
     /*   99969 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(100010), // Rule ID 413 //
     /*   99974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*   99977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*   99984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*   99987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99991 */     // MIs[0] rs1
     /*   99991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*   99995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   99999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100003 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  100008 */     GIR_RootConstrainSelectedInstOperands,
     /*  100009 */     // GIR_Coverage, 413,
     /*  100009 */     GIR_Done,
     /*  100010 */   // Label 2627: @100010
     /*  100010 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(100051), // Rule ID 415 //
     /*  100015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  100018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  100025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  100028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100032 */     // MIs[0] rs1
     /*  100032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100044 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  100049 */     GIR_RootConstrainSelectedInstOperands,
     /*  100050 */     // GIR_Coverage, 415,
     /*  100050 */     GIR_Done,
     /*  100051 */   // Label 2628: @100051
     /*  100051 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(100092), // Rule ID 417 //
     /*  100056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  100059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  100066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  100069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100073 */     // MIs[0] rs1
     /*  100073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100085 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  100090 */     GIR_RootConstrainSelectedInstOperands,
     /*  100091 */     // GIR_Coverage, 417,
     /*  100091 */     GIR_Done,
     /*  100092 */   // Label 2629: @100092
     /*  100092 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(100133), // Rule ID 419 //
     /*  100097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  100100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  100107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  100110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100114 */     // MIs[0] rs1
     /*  100114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100126 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  100131 */     GIR_RootConstrainSelectedInstOperands,
     /*  100132 */     // GIR_Coverage, 419,
     /*  100132 */     GIR_Done,
     /*  100133 */   // Label 2630: @100133
     /*  100133 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(100174), // Rule ID 421 //
     /*  100138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  100141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  100148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  100151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100155 */     // MIs[0] rs1
     /*  100155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100167 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  100172 */     GIR_RootConstrainSelectedInstOperands,
     /*  100173 */     // GIR_Coverage, 421,
     /*  100173 */     GIR_Done,
     /*  100174 */   // Label 2631: @100174
     /*  100174 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(100215), // Rule ID 423 //
     /*  100179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  100182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  100189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  100192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100196 */     // MIs[0] rs1
     /*  100196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100208 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  100213 */     GIR_RootConstrainSelectedInstOperands,
     /*  100214 */     // GIR_Coverage, 423,
     /*  100214 */     GIR_Done,
     /*  100215 */   // Label 2632: @100215
     /*  100215 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(100256), // Rule ID 545 //
     /*  100220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  100223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  100233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100237 */     // MIs[0] rs1
     /*  100237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100249 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100254 */     GIR_RootConstrainSelectedInstOperands,
     /*  100255 */     // GIR_Coverage, 545,
     /*  100255 */     GIR_Done,
     /*  100256 */   // Label 2633: @100256
     /*  100256 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(100297), // Rule ID 546 //
     /*  100261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  100264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  100274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100278 */     // MIs[0] rs1
     /*  100278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100290 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  100295 */     GIR_RootConstrainSelectedInstOperands,
     /*  100296 */     // GIR_Coverage, 546,
     /*  100296 */     GIR_Done,
     /*  100297 */   // Label 2634: @100297
     /*  100297 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(100338), // Rule ID 547 //
     /*  100302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  100305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  100315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100319 */     // MIs[0] rs1
     /*  100319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100331 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  100336 */     GIR_RootConstrainSelectedInstOperands,
     /*  100337 */     // GIR_Coverage, 547,
     /*  100337 */     GIR_Done,
     /*  100338 */   // Label 2635: @100338
     /*  100338 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(100379), // Rule ID 548 //
     /*  100343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  100346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  100356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100360 */     // MIs[0] rs1
     /*  100360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100372 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  100377 */     GIR_RootConstrainSelectedInstOperands,
     /*  100378 */     // GIR_Coverage, 548,
     /*  100378 */     GIR_Done,
     /*  100379 */   // Label 2636: @100379
     /*  100379 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(100420), // Rule ID 549 //
     /*  100384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  100387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  100397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100401 */     // MIs[0] rs1
     /*  100401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100413 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  100418 */     GIR_RootConstrainSelectedInstOperands,
     /*  100419 */     // GIR_Coverage, 549,
     /*  100419 */     GIR_Done,
     /*  100420 */   // Label 2637: @100420
     /*  100420 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(100461), // Rule ID 550 //
     /*  100425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  100428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  100438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100442 */     // MIs[0] rs1
     /*  100442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100454 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100459 */     GIR_RootConstrainSelectedInstOperands,
     /*  100460 */     // GIR_Coverage, 550,
     /*  100460 */     GIR_Done,
     /*  100461 */   // Label 2638: @100461
     /*  100461 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(100502), // Rule ID 551 //
     /*  100466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  100469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  100479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100483 */     // MIs[0] rs1
     /*  100483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100495 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100500 */     GIR_RootConstrainSelectedInstOperands,
     /*  100501 */     // GIR_Coverage, 551,
     /*  100501 */     GIR_Done,
     /*  100502 */   // Label 2639: @100502
     /*  100502 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(100543), // Rule ID 552 //
     /*  100507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  100510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  100520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100524 */     // MIs[0] rs1
     /*  100524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100536 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100541 */     GIR_RootConstrainSelectedInstOperands,
     /*  100542 */     // GIR_Coverage, 552,
     /*  100542 */     GIR_Done,
     /*  100543 */   // Label 2640: @100543
     /*  100543 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(100584), // Rule ID 553 //
     /*  100548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  100551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  100561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100565 */     // MIs[0] rs1
     /*  100565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100577 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100582 */     GIR_RootConstrainSelectedInstOperands,
     /*  100583 */     // GIR_Coverage, 553,
     /*  100583 */     GIR_Done,
     /*  100584 */   // Label 2641: @100584
     /*  100584 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(100625), // Rule ID 554 //
     /*  100589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  100592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  100599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  100602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100606 */     // MIs[0] rs1
     /*  100606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100618 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  100623 */     GIR_RootConstrainSelectedInstOperands,
     /*  100624 */     // GIR_Coverage, 554,
     /*  100624 */     GIR_Done,
     /*  100625 */   // Label 2642: @100625
     /*  100625 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(100666), // Rule ID 753 //
     /*  100630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  100633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  100643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100647 */     // MIs[0] rs1
     /*  100647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100659 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  100664 */     GIR_RootConstrainSelectedInstOperands,
     /*  100665 */     // GIR_Coverage, 753,
     /*  100665 */     GIR_Done,
     /*  100666 */   // Label 2643: @100666
     /*  100666 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(100707), // Rule ID 755 //
     /*  100671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  100674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  100684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100688 */     // MIs[0] rs1
     /*  100688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100700 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  100705 */     GIR_RootConstrainSelectedInstOperands,
     /*  100706 */     // GIR_Coverage, 755,
     /*  100706 */     GIR_Done,
     /*  100707 */   // Label 2644: @100707
     /*  100707 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(100748), // Rule ID 757 //
     /*  100712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  100715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  100725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100729 */     // MIs[0] rs1
     /*  100729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100741 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  100746 */     GIR_RootConstrainSelectedInstOperands,
     /*  100747 */     // GIR_Coverage, 757,
     /*  100747 */     GIR_Done,
     /*  100748 */   // Label 2645: @100748
     /*  100748 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(100789), // Rule ID 759 //
     /*  100753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  100756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  100766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100770 */     // MIs[0] rs1
     /*  100770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100782 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  100787 */     GIR_RootConstrainSelectedInstOperands,
     /*  100788 */     // GIR_Coverage, 759,
     /*  100788 */     GIR_Done,
     /*  100789 */   // Label 2646: @100789
     /*  100789 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(100830), // Rule ID 761 //
     /*  100794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  100797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  100807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100811 */     // MIs[0] rs1
     /*  100811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100823 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  100828 */     GIR_RootConstrainSelectedInstOperands,
     /*  100829 */     // GIR_Coverage, 761,
     /*  100829 */     GIR_Done,
     /*  100830 */   // Label 2647: @100830
     /*  100830 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(100871), // Rule ID 763 //
     /*  100835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  100838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  100848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100852 */     // MIs[0] rs1
     /*  100852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100864 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  100869 */     GIR_RootConstrainSelectedInstOperands,
     /*  100870 */     // GIR_Coverage, 763,
     /*  100870 */     GIR_Done,
     /*  100871 */   // Label 2648: @100871
     /*  100871 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(100912), // Rule ID 765 //
     /*  100876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  100879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  100889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100893 */     // MIs[0] rs1
     /*  100893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100905 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  100910 */     GIR_RootConstrainSelectedInstOperands,
     /*  100911 */     // GIR_Coverage, 765,
     /*  100911 */     GIR_Done,
     /*  100912 */   // Label 2649: @100912
     /*  100912 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(100953), // Rule ID 767 //
     /*  100917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  100920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  100930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100934 */     // MIs[0] rs1
     /*  100934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100946 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  100951 */     GIR_RootConstrainSelectedInstOperands,
     /*  100952 */     // GIR_Coverage, 767,
     /*  100952 */     GIR_Done,
     /*  100953 */   // Label 2650: @100953
     /*  100953 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(100994), // Rule ID 769 //
     /*  100958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  100961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  100968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  100971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100975 */     // MIs[0] rs1
     /*  100975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  100979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  100987 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  100987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  100992 */     GIR_RootConstrainSelectedInstOperands,
     /*  100993 */     // GIR_Coverage, 769,
     /*  100993 */     GIR_Done,
     /*  100994 */   // Label 2651: @100994
     /*  100994 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(101035), // Rule ID 771 //
     /*  100999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  101009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  101012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101016 */     // MIs[0] rs1
     /*  101016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101028 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  101033 */     GIR_RootConstrainSelectedInstOperands,
     /*  101034 */     // GIR_Coverage, 771,
     /*  101034 */     GIR_Done,
     /*  101035 */   // Label 2652: @101035
     /*  101035 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(101076), // Rule ID 933 //
     /*  101040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  101043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  101053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101057 */     // MIs[0] rs1
     /*  101057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101069 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101074 */     GIR_RootConstrainSelectedInstOperands,
     /*  101075 */     // GIR_Coverage, 933,
     /*  101075 */     GIR_Done,
     /*  101076 */   // Label 2653: @101076
     /*  101076 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(101117), // Rule ID 935 //
     /*  101081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  101084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  101094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101098 */     // MIs[0] rs1
     /*  101098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101110 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  101115 */     GIR_RootConstrainSelectedInstOperands,
     /*  101116 */     // GIR_Coverage, 935,
     /*  101116 */     GIR_Done,
     /*  101117 */   // Label 2654: @101117
     /*  101117 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(101158), // Rule ID 937 //
     /*  101122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  101125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  101135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101139 */     // MIs[0] rs1
     /*  101139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101151 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  101156 */     GIR_RootConstrainSelectedInstOperands,
     /*  101157 */     // GIR_Coverage, 937,
     /*  101157 */     GIR_Done,
     /*  101158 */   // Label 2655: @101158
     /*  101158 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(101199), // Rule ID 939 //
     /*  101163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  101166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  101176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101180 */     // MIs[0] rs1
     /*  101180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101192 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  101197 */     GIR_RootConstrainSelectedInstOperands,
     /*  101198 */     // GIR_Coverage, 939,
     /*  101198 */     GIR_Done,
     /*  101199 */   // Label 2656: @101199
     /*  101199 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(101240), // Rule ID 941 //
     /*  101204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  101207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  101217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101221 */     // MIs[0] rs1
     /*  101221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101233 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  101238 */     GIR_RootConstrainSelectedInstOperands,
     /*  101239 */     // GIR_Coverage, 941,
     /*  101239 */     GIR_Done,
     /*  101240 */   // Label 2657: @101240
     /*  101240 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(101281), // Rule ID 943 //
     /*  101245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  101258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101262 */     // MIs[0] rs1
     /*  101262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101274 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101279 */     GIR_RootConstrainSelectedInstOperands,
     /*  101280 */     // GIR_Coverage, 943,
     /*  101280 */     GIR_Done,
     /*  101281 */   // Label 2658: @101281
     /*  101281 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(101322), // Rule ID 945 //
     /*  101286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  101299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101303 */     // MIs[0] rs1
     /*  101303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101315 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101320 */     GIR_RootConstrainSelectedInstOperands,
     /*  101321 */     // GIR_Coverage, 945,
     /*  101321 */     GIR_Done,
     /*  101322 */   // Label 2659: @101322
     /*  101322 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(101363), // Rule ID 947 //
     /*  101327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  101340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101344 */     // MIs[0] rs1
     /*  101344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101356 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101361 */     GIR_RootConstrainSelectedInstOperands,
     /*  101362 */     // GIR_Coverage, 947,
     /*  101362 */     GIR_Done,
     /*  101363 */   // Label 2660: @101363
     /*  101363 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(101404), // Rule ID 949 //
     /*  101368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  101381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101385 */     // MIs[0] rs1
     /*  101385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101397 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101402 */     GIR_RootConstrainSelectedInstOperands,
     /*  101403 */     // GIR_Coverage, 949,
     /*  101403 */     GIR_Done,
     /*  101404 */   // Label 2661: @101404
     /*  101404 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(101445), // Rule ID 951 //
     /*  101409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  101412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  101419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  101422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101426 */     // MIs[0] rs1
     /*  101426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  101430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101438 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  101438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  101443 */     GIR_RootConstrainSelectedInstOperands,
     /*  101444 */     // GIR_Coverage, 951,
     /*  101444 */     GIR_Done,
     /*  101445 */   // Label 2662: @101445
     /*  101445 */   GIM_Reject,
     /*  101446 */ // Label 2622: @101446
     /*  101446 */ GIM_Reject,
     /*  101447 */ // Label 2590: @101447
     /*  101447 */ GIM_Reject,
     /*  101448 */ // Label 32: @101448
     /*  101448 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2665*/ GIMT_Encode4(104357),
     /*  101459 */ /*GILLT_s32*//*Label 2663*/ GIMT_Encode4(101467),
     /*  101463 */ /*GILLT_s64*//*Label 2664*/ GIMT_Encode4(102707),
     /*  101467 */ // Label 2663: @101467
     /*  101467 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(102706),
     /*  101472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  101475 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(101516), // Rule ID 426 //
     /*  101480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  101483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  101493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101497 */     // MIs[0] rs1
     /*  101497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101509 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101514 */     GIR_RootConstrainSelectedInstOperands,
     /*  101515 */     // GIR_Coverage, 426,
     /*  101515 */     GIR_Done,
     /*  101516 */   // Label 2667: @101516
     /*  101516 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(101557), // Rule ID 428 //
     /*  101521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  101524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  101534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101538 */     // MIs[0] rs1
     /*  101538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101550 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  101555 */     GIR_RootConstrainSelectedInstOperands,
     /*  101556 */     // GIR_Coverage, 428,
     /*  101556 */     GIR_Done,
     /*  101557 */   // Label 2668: @101557
     /*  101557 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(101598), // Rule ID 430 //
     /*  101562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  101565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  101575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101579 */     // MIs[0] rs1
     /*  101579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101591 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  101596 */     GIR_RootConstrainSelectedInstOperands,
     /*  101597 */     // GIR_Coverage, 430,
     /*  101597 */     GIR_Done,
     /*  101598 */   // Label 2669: @101598
     /*  101598 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(101639), // Rule ID 432 //
     /*  101603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  101606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  101616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101620 */     // MIs[0] rs1
     /*  101620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101632 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  101637 */     GIR_RootConstrainSelectedInstOperands,
     /*  101638 */     // GIR_Coverage, 432,
     /*  101638 */     GIR_Done,
     /*  101639 */   // Label 2670: @101639
     /*  101639 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(101680), // Rule ID 434 //
     /*  101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  101647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  101657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101661 */     // MIs[0] rs1
     /*  101661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101673 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  101678 */     GIR_RootConstrainSelectedInstOperands,
     /*  101679 */     // GIR_Coverage, 434,
     /*  101679 */     GIR_Done,
     /*  101680 */   // Label 2671: @101680
     /*  101680 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(101721), // Rule ID 436 //
     /*  101685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  101688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  101698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101702 */     // MIs[0] rs1
     /*  101702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101714 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101719 */     GIR_RootConstrainSelectedInstOperands,
     /*  101720 */     // GIR_Coverage, 436,
     /*  101720 */     GIR_Done,
     /*  101721 */   // Label 2672: @101721
     /*  101721 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(101762), // Rule ID 438 //
     /*  101726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  101729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  101739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101743 */     // MIs[0] rs1
     /*  101743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101755 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101760 */     GIR_RootConstrainSelectedInstOperands,
     /*  101761 */     // GIR_Coverage, 438,
     /*  101761 */     GIR_Done,
     /*  101762 */   // Label 2673: @101762
     /*  101762 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(101803), // Rule ID 440 //
     /*  101767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  101770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  101780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101784 */     // MIs[0] rs1
     /*  101784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101796 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101801 */     GIR_RootConstrainSelectedInstOperands,
     /*  101802 */     // GIR_Coverage, 440,
     /*  101802 */     GIR_Done,
     /*  101803 */   // Label 2674: @101803
     /*  101803 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(101844), // Rule ID 442 //
     /*  101808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  101811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  101821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101825 */     // MIs[0] rs1
     /*  101825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101837 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101842 */     GIR_RootConstrainSelectedInstOperands,
     /*  101843 */     // GIR_Coverage, 442,
     /*  101843 */     GIR_Done,
     /*  101844 */   // Label 2675: @101844
     /*  101844 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(101885), // Rule ID 444 //
     /*  101849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  101852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  101859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  101862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101866 */     // MIs[0] rs1
     /*  101866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101878 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  101883 */     GIR_RootConstrainSelectedInstOperands,
     /*  101884 */     // GIR_Coverage, 444,
     /*  101884 */     GIR_Done,
     /*  101885 */   // Label 2676: @101885
     /*  101885 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(101926), // Rule ID 774 //
     /*  101890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  101893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  101900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  101903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101907 */     // MIs[0] rs1
     /*  101907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101919 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  101924 */     GIR_RootConstrainSelectedInstOperands,
     /*  101925 */     // GIR_Coverage, 774,
     /*  101925 */     GIR_Done,
     /*  101926 */   // Label 2677: @101926
     /*  101926 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(101967), // Rule ID 776 //
     /*  101931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  101934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  101941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  101944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101948 */     // MIs[0] rs1
     /*  101948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101960 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  101960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  101965 */     GIR_RootConstrainSelectedInstOperands,
     /*  101966 */     // GIR_Coverage, 776,
     /*  101966 */     GIR_Done,
     /*  101967 */   // Label 2678: @101967
     /*  101967 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(102008), // Rule ID 778 //
     /*  101972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  101975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  101982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  101985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101989 */     // MIs[0] rs1
     /*  101989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  101993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  101997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102001 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  102006 */     GIR_RootConstrainSelectedInstOperands,
     /*  102007 */     // GIR_Coverage, 778,
     /*  102007 */     GIR_Done,
     /*  102008 */   // Label 2679: @102008
     /*  102008 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(102049), // Rule ID 780 //
     /*  102013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  102026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102030 */     // MIs[0] rs1
     /*  102030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102042 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  102047 */     GIR_RootConstrainSelectedInstOperands,
     /*  102048 */     // GIR_Coverage, 780,
     /*  102048 */     GIR_Done,
     /*  102049 */   // Label 2680: @102049
     /*  102049 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(102090), // Rule ID 782 //
     /*  102054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  102067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102071 */     // MIs[0] rs1
     /*  102071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102083 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  102088 */     GIR_RootConstrainSelectedInstOperands,
     /*  102089 */     // GIR_Coverage, 782,
     /*  102089 */     GIR_Done,
     /*  102090 */   // Label 2681: @102090
     /*  102090 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(102131), // Rule ID 784 //
     /*  102095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  102108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102112 */     // MIs[0] rs1
     /*  102112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102124 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  102129 */     GIR_RootConstrainSelectedInstOperands,
     /*  102130 */     // GIR_Coverage, 784,
     /*  102130 */     GIR_Done,
     /*  102131 */   // Label 2682: @102131
     /*  102131 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(102172), // Rule ID 786 //
     /*  102136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102139 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  102149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102153 */     // MIs[0] rs1
     /*  102153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102165 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  102170 */     GIR_RootConstrainSelectedInstOperands,
     /*  102171 */     // GIR_Coverage, 786,
     /*  102171 */     GIR_Done,
     /*  102172 */   // Label 2683: @102172
     /*  102172 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(102213), // Rule ID 788 //
     /*  102177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  102190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102194 */     // MIs[0] rs1
     /*  102194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102206 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  102211 */     GIR_RootConstrainSelectedInstOperands,
     /*  102212 */     // GIR_Coverage, 788,
     /*  102212 */     GIR_Done,
     /*  102213 */   // Label 2684: @102213
     /*  102213 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(102254), // Rule ID 790 //
     /*  102218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  102231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102235 */     // MIs[0] rs1
     /*  102235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102247 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  102252 */     GIR_RootConstrainSelectedInstOperands,
     /*  102253 */     // GIR_Coverage, 790,
     /*  102253 */     GIR_Done,
     /*  102254 */   // Label 2685: @102254
     /*  102254 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(102295), // Rule ID 792 //
     /*  102259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  102269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  102272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102276 */     // MIs[0] rs1
     /*  102276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102288 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  102293 */     GIR_RootConstrainSelectedInstOperands,
     /*  102294 */     // GIR_Coverage, 792,
     /*  102294 */     GIR_Done,
     /*  102295 */   // Label 2686: @102295
     /*  102295 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(102336), // Rule ID 954 //
     /*  102300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  102313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102317 */     // MIs[0] rs1
     /*  102317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102329 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102334 */     GIR_RootConstrainSelectedInstOperands,
     /*  102335 */     // GIR_Coverage, 954,
     /*  102335 */     GIR_Done,
     /*  102336 */   // Label 2687: @102336
     /*  102336 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(102377), // Rule ID 956 //
     /*  102341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  102354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102358 */     // MIs[0] rs1
     /*  102358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102370 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  102375 */     GIR_RootConstrainSelectedInstOperands,
     /*  102376 */     // GIR_Coverage, 956,
     /*  102376 */     GIR_Done,
     /*  102377 */   // Label 2688: @102377
     /*  102377 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(102418), // Rule ID 958 //
     /*  102382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  102395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102399 */     // MIs[0] rs1
     /*  102399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102411 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  102416 */     GIR_RootConstrainSelectedInstOperands,
     /*  102417 */     // GIR_Coverage, 958,
     /*  102417 */     GIR_Done,
     /*  102418 */   // Label 2689: @102418
     /*  102418 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(102459), // Rule ID 960 //
     /*  102423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  102436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102440 */     // MIs[0] rs1
     /*  102440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102452 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  102457 */     GIR_RootConstrainSelectedInstOperands,
     /*  102458 */     // GIR_Coverage, 960,
     /*  102458 */     GIR_Done,
     /*  102459 */   // Label 2690: @102459
     /*  102459 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(102500), // Rule ID 962 //
     /*  102464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  102467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  102477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102481 */     // MIs[0] rs1
     /*  102481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102493 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  102498 */     GIR_RootConstrainSelectedInstOperands,
     /*  102499 */     // GIR_Coverage, 962,
     /*  102499 */     GIR_Done,
     /*  102500 */   // Label 2691: @102500
     /*  102500 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(102541), // Rule ID 964 //
     /*  102505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  102518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102522 */     // MIs[0] rs1
     /*  102522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102534 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102539 */     GIR_RootConstrainSelectedInstOperands,
     /*  102540 */     // GIR_Coverage, 964,
     /*  102540 */     GIR_Done,
     /*  102541 */   // Label 2692: @102541
     /*  102541 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(102582), // Rule ID 966 //
     /*  102546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  102559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102563 */     // MIs[0] rs1
     /*  102563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102575 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102580 */     GIR_RootConstrainSelectedInstOperands,
     /*  102581 */     // GIR_Coverage, 966,
     /*  102581 */     GIR_Done,
     /*  102582 */   // Label 2693: @102582
     /*  102582 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(102623), // Rule ID 968 //
     /*  102587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  102600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102604 */     // MIs[0] rs1
     /*  102604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102616 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102621 */     GIR_RootConstrainSelectedInstOperands,
     /*  102622 */     // GIR_Coverage, 968,
     /*  102622 */     GIR_Done,
     /*  102623 */   // Label 2694: @102623
     /*  102623 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(102664), // Rule ID 970 //
     /*  102628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  102641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102645 */     // MIs[0] rs1
     /*  102645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102657 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102662 */     GIR_RootConstrainSelectedInstOperands,
     /*  102663 */     // GIR_Coverage, 970,
     /*  102663 */     GIR_Done,
     /*  102664 */   // Label 2695: @102664
     /*  102664 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(102705), // Rule ID 972 //
     /*  102669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  102672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  102679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  102682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102686 */     // MIs[0] rs1
     /*  102686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  102690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102698 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  102698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  102703 */     GIR_RootConstrainSelectedInstOperands,
     /*  102704 */     // GIR_Coverage, 972,
     /*  102704 */     GIR_Done,
     /*  102705 */   // Label 2696: @102705
     /*  102705 */   GIM_Reject,
     /*  102706 */ // Label 2666: @102706
     /*  102706 */ GIM_Reject,
     /*  102707 */ // Label 2664: @102707
     /*  102707 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(104356),
     /*  102712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  102715 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(102756), // Rule ID 425 //
     /*  102720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  102723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  102733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102737 */     // MIs[0] rs1
     /*  102737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102749 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  102754 */     GIR_RootConstrainSelectedInstOperands,
     /*  102755 */     // GIR_Coverage, 425,
     /*  102755 */     GIR_Done,
     /*  102756 */   // Label 2698: @102756
     /*  102756 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(102797), // Rule ID 427 //
     /*  102761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  102764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  102774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102778 */     // MIs[0] rs1
     /*  102778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102790 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  102795 */     GIR_RootConstrainSelectedInstOperands,
     /*  102796 */     // GIR_Coverage, 427,
     /*  102796 */     GIR_Done,
     /*  102797 */   // Label 2699: @102797
     /*  102797 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(102838), // Rule ID 429 //
     /*  102802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  102805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  102815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102819 */     // MIs[0] rs1
     /*  102819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102831 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  102836 */     GIR_RootConstrainSelectedInstOperands,
     /*  102837 */     // GIR_Coverage, 429,
     /*  102837 */     GIR_Done,
     /*  102838 */   // Label 2700: @102838
     /*  102838 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(102879), // Rule ID 431 //
     /*  102843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  102846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  102856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102860 */     // MIs[0] rs1
     /*  102860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102872 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  102877 */     GIR_RootConstrainSelectedInstOperands,
     /*  102878 */     // GIR_Coverage, 431,
     /*  102878 */     GIR_Done,
     /*  102879 */   // Label 2701: @102879
     /*  102879 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(102920), // Rule ID 433 //
     /*  102884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  102887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  102897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102901 */     // MIs[0] rs1
     /*  102901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102913 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  102918 */     GIR_RootConstrainSelectedInstOperands,
     /*  102919 */     // GIR_Coverage, 433,
     /*  102919 */     GIR_Done,
     /*  102920 */   // Label 2702: @102920
     /*  102920 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(102961), // Rule ID 435 //
     /*  102925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  102928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  102938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102942 */     // MIs[0] rs1
     /*  102942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102954 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  102959 */     GIR_RootConstrainSelectedInstOperands,
     /*  102960 */     // GIR_Coverage, 435,
     /*  102960 */     GIR_Done,
     /*  102961 */   // Label 2703: @102961
     /*  102961 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(103002), // Rule ID 437 //
     /*  102966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  102969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  102976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  102979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102983 */     // MIs[0] rs1
     /*  102983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  102987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  102995 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  102995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  103000 */     GIR_RootConstrainSelectedInstOperands,
     /*  103001 */     // GIR_Coverage, 437,
     /*  103001 */     GIR_Done,
     /*  103002 */   // Label 2704: @103002
     /*  103002 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(103043), // Rule ID 439 //
     /*  103007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  103010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  103017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  103020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103024 */     // MIs[0] rs1
     /*  103024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103036 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  103041 */     GIR_RootConstrainSelectedInstOperands,
     /*  103042 */     // GIR_Coverage, 439,
     /*  103042 */     GIR_Done,
     /*  103043 */   // Label 2705: @103043
     /*  103043 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(103084), // Rule ID 441 //
     /*  103048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  103051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  103058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  103061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103065 */     // MIs[0] rs1
     /*  103065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103077 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  103082 */     GIR_RootConstrainSelectedInstOperands,
     /*  103083 */     // GIR_Coverage, 441,
     /*  103083 */     GIR_Done,
     /*  103084 */   // Label 2706: @103084
     /*  103084 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(103125), // Rule ID 443 //
     /*  103089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  103092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  103099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  103102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103106 */     // MIs[0] rs1
     /*  103106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103118 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  103123 */     GIR_RootConstrainSelectedInstOperands,
     /*  103124 */     // GIR_Coverage, 443,
     /*  103124 */     GIR_Done,
     /*  103125 */   // Label 2707: @103125
     /*  103125 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(103166), // Rule ID 555 //
     /*  103130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  103133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  103143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103147 */     // MIs[0] rs1
     /*  103147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103159 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103164 */     GIR_RootConstrainSelectedInstOperands,
     /*  103165 */     // GIR_Coverage, 555,
     /*  103165 */     GIR_Done,
     /*  103166 */   // Label 2708: @103166
     /*  103166 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(103207), // Rule ID 556 //
     /*  103171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  103174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  103184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103188 */     // MIs[0] rs1
     /*  103188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103200 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  103205 */     GIR_RootConstrainSelectedInstOperands,
     /*  103206 */     // GIR_Coverage, 556,
     /*  103206 */     GIR_Done,
     /*  103207 */   // Label 2709: @103207
     /*  103207 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(103248), // Rule ID 557 //
     /*  103212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  103215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  103225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103229 */     // MIs[0] rs1
     /*  103229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103241 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  103246 */     GIR_RootConstrainSelectedInstOperands,
     /*  103247 */     // GIR_Coverage, 557,
     /*  103247 */     GIR_Done,
     /*  103248 */   // Label 2710: @103248
     /*  103248 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(103289), // Rule ID 558 //
     /*  103253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  103256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  103266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103270 */     // MIs[0] rs1
     /*  103270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103282 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  103287 */     GIR_RootConstrainSelectedInstOperands,
     /*  103288 */     // GIR_Coverage, 558,
     /*  103288 */     GIR_Done,
     /*  103289 */   // Label 2711: @103289
     /*  103289 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(103330), // Rule ID 559 //
     /*  103294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  103297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  103307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103311 */     // MIs[0] rs1
     /*  103311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103323 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  103328 */     GIR_RootConstrainSelectedInstOperands,
     /*  103329 */     // GIR_Coverage, 559,
     /*  103329 */     GIR_Done,
     /*  103330 */   // Label 2712: @103330
     /*  103330 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(103371), // Rule ID 560 //
     /*  103335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  103338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  103348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103352 */     // MIs[0] rs1
     /*  103352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103364 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103369 */     GIR_RootConstrainSelectedInstOperands,
     /*  103370 */     // GIR_Coverage, 560,
     /*  103370 */     GIR_Done,
     /*  103371 */   // Label 2713: @103371
     /*  103371 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(103412), // Rule ID 561 //
     /*  103376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  103379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  103389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103393 */     // MIs[0] rs1
     /*  103393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103405 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103410 */     GIR_RootConstrainSelectedInstOperands,
     /*  103411 */     // GIR_Coverage, 561,
     /*  103411 */     GIR_Done,
     /*  103412 */   // Label 2714: @103412
     /*  103412 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(103453), // Rule ID 562 //
     /*  103417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  103420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  103430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103434 */     // MIs[0] rs1
     /*  103434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103446 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103451 */     GIR_RootConstrainSelectedInstOperands,
     /*  103452 */     // GIR_Coverage, 562,
     /*  103452 */     GIR_Done,
     /*  103453 */   // Label 2715: @103453
     /*  103453 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(103494), // Rule ID 563 //
     /*  103458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  103461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  103471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103475 */     // MIs[0] rs1
     /*  103475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103487 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103492 */     GIR_RootConstrainSelectedInstOperands,
     /*  103493 */     // GIR_Coverage, 563,
     /*  103493 */     GIR_Done,
     /*  103494 */   // Label 2716: @103494
     /*  103494 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(103535), // Rule ID 564 //
     /*  103499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  103502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  103509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  103512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103516 */     // MIs[0] rs1
     /*  103516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103528 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  103533 */     GIR_RootConstrainSelectedInstOperands,
     /*  103534 */     // GIR_Coverage, 564,
     /*  103534 */     GIR_Done,
     /*  103535 */   // Label 2717: @103535
     /*  103535 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(103576), // Rule ID 773 //
     /*  103540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  103553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103557 */     // MIs[0] rs1
     /*  103557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103569 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103574 */     GIR_RootConstrainSelectedInstOperands,
     /*  103575 */     // GIR_Coverage, 773,
     /*  103575 */     GIR_Done,
     /*  103576 */   // Label 2718: @103576
     /*  103576 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(103617), // Rule ID 775 //
     /*  103581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  103594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103598 */     // MIs[0] rs1
     /*  103598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103610 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  103615 */     GIR_RootConstrainSelectedInstOperands,
     /*  103616 */     // GIR_Coverage, 775,
     /*  103616 */     GIR_Done,
     /*  103617 */   // Label 2719: @103617
     /*  103617 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(103658), // Rule ID 777 //
     /*  103622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  103635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103639 */     // MIs[0] rs1
     /*  103639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103651 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  103656 */     GIR_RootConstrainSelectedInstOperands,
     /*  103657 */     // GIR_Coverage, 777,
     /*  103657 */     GIR_Done,
     /*  103658 */   // Label 2720: @103658
     /*  103658 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(103699), // Rule ID 779 //
     /*  103663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  103676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103680 */     // MIs[0] rs1
     /*  103680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103692 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  103697 */     GIR_RootConstrainSelectedInstOperands,
     /*  103698 */     // GIR_Coverage, 779,
     /*  103698 */     GIR_Done,
     /*  103699 */   // Label 2721: @103699
     /*  103699 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(103740), // Rule ID 781 //
     /*  103704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  103717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103721 */     // MIs[0] rs1
     /*  103721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103733 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  103738 */     GIR_RootConstrainSelectedInstOperands,
     /*  103739 */     // GIR_Coverage, 781,
     /*  103739 */     GIR_Done,
     /*  103740 */   // Label 2722: @103740
     /*  103740 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(103781), // Rule ID 783 //
     /*  103745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  103748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  103758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103762 */     // MIs[0] rs1
     /*  103762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103774 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103779 */     GIR_RootConstrainSelectedInstOperands,
     /*  103780 */     // GIR_Coverage, 783,
     /*  103780 */     GIR_Done,
     /*  103781 */   // Label 2723: @103781
     /*  103781 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(103822), // Rule ID 785 //
     /*  103786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  103789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  103799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103803 */     // MIs[0] rs1
     /*  103803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103815 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103820 */     GIR_RootConstrainSelectedInstOperands,
     /*  103821 */     // GIR_Coverage, 785,
     /*  103821 */     GIR_Done,
     /*  103822 */   // Label 2724: @103822
     /*  103822 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(103863), // Rule ID 787 //
     /*  103827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  103830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  103840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103844 */     // MIs[0] rs1
     /*  103844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103856 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103861 */     GIR_RootConstrainSelectedInstOperands,
     /*  103862 */     // GIR_Coverage, 787,
     /*  103862 */     GIR_Done,
     /*  103863 */   // Label 2725: @103863
     /*  103863 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(103904), // Rule ID 789 //
     /*  103868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  103871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  103881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103885 */     // MIs[0] rs1
     /*  103885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103897 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103902 */     GIR_RootConstrainSelectedInstOperands,
     /*  103903 */     // GIR_Coverage, 789,
     /*  103903 */     GIR_Done,
     /*  103904 */   // Label 2726: @103904
     /*  103904 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(103945), // Rule ID 791 //
     /*  103909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  103912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  103919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  103922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103926 */     // MIs[0] rs1
     /*  103926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103938 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  103943 */     GIR_RootConstrainSelectedInstOperands,
     /*  103944 */     // GIR_Coverage, 791,
     /*  103944 */     GIR_Done,
     /*  103945 */   // Label 2727: @103945
     /*  103945 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(103986), // Rule ID 953 //
     /*  103950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  103960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  103963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103967 */     // MIs[0] rs1
     /*  103967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  103971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103979 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  103984 */     GIR_RootConstrainSelectedInstOperands,
     /*  103985 */     // GIR_Coverage, 953,
     /*  103985 */     GIR_Done,
     /*  103986 */   // Label 2728: @103986
     /*  103986 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(104027), // Rule ID 955 //
     /*  103991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  103994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  104004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104008 */     // MIs[0] rs1
     /*  104008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104020 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  104025 */     GIR_RootConstrainSelectedInstOperands,
     /*  104026 */     // GIR_Coverage, 955,
     /*  104026 */     GIR_Done,
     /*  104027 */   // Label 2729: @104027
     /*  104027 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(104068), // Rule ID 957 //
     /*  104032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  104035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  104045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104049 */     // MIs[0] rs1
     /*  104049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104061 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  104066 */     GIR_RootConstrainSelectedInstOperands,
     /*  104067 */     // GIR_Coverage, 957,
     /*  104067 */     GIR_Done,
     /*  104068 */   // Label 2730: @104068
     /*  104068 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(104109), // Rule ID 959 //
     /*  104073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  104076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  104086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104090 */     // MIs[0] rs1
     /*  104090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104102 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  104107 */     GIR_RootConstrainSelectedInstOperands,
     /*  104108 */     // GIR_Coverage, 959,
     /*  104108 */     GIR_Done,
     /*  104109 */   // Label 2731: @104109
     /*  104109 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(104150), // Rule ID 961 //
     /*  104114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  104117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  104127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104131 */     // MIs[0] rs1
     /*  104131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104143 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  104148 */     GIR_RootConstrainSelectedInstOperands,
     /*  104149 */     // GIR_Coverage, 961,
     /*  104149 */     GIR_Done,
     /*  104150 */   // Label 2732: @104150
     /*  104150 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(104191), // Rule ID 963 //
     /*  104155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  104158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  104168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104172 */     // MIs[0] rs1
     /*  104172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104184 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  104189 */     GIR_RootConstrainSelectedInstOperands,
     /*  104190 */     // GIR_Coverage, 963,
     /*  104190 */     GIR_Done,
     /*  104191 */   // Label 2733: @104191
     /*  104191 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(104232), // Rule ID 965 //
     /*  104196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  104199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  104209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104213 */     // MIs[0] rs1
     /*  104213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104225 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  104230 */     GIR_RootConstrainSelectedInstOperands,
     /*  104231 */     // GIR_Coverage, 965,
     /*  104231 */     GIR_Done,
     /*  104232 */   // Label 2734: @104232
     /*  104232 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(104273), // Rule ID 967 //
     /*  104237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  104240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  104250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104254 */     // MIs[0] rs1
     /*  104254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104266 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  104271 */     GIR_RootConstrainSelectedInstOperands,
     /*  104272 */     // GIR_Coverage, 967,
     /*  104272 */     GIR_Done,
     /*  104273 */   // Label 2735: @104273
     /*  104273 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(104314), // Rule ID 969 //
     /*  104278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  104281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  104291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104295 */     // MIs[0] rs1
     /*  104295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104307 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  104312 */     GIR_RootConstrainSelectedInstOperands,
     /*  104313 */     // GIR_Coverage, 969,
     /*  104313 */     GIR_Done,
     /*  104314 */   // Label 2736: @104314
     /*  104314 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(104355), // Rule ID 971 //
     /*  104319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  104322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  104329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  104332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104336 */     // MIs[0] rs1
     /*  104336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  104340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104348 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  104348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  104353 */     GIR_RootConstrainSelectedInstOperands,
     /*  104354 */     // GIR_Coverage, 971,
     /*  104354 */     GIR_Done,
     /*  104355 */   // Label 2737: @104355
     /*  104355 */   GIM_Reject,
     /*  104356 */ // Label 2697: @104356
     /*  104356 */ GIM_Reject,
     /*  104357 */ // Label 2665: @104357
     /*  104357 */ GIM_Reject,
     /*  104358 */ // Label 33: @104358
     /*  104358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2740*/ GIMT_Encode4(107267),
     /*  104369 */ /*GILLT_s32*//*Label 2738*/ GIMT_Encode4(104377),
     /*  104373 */ /*GILLT_s64*//*Label 2739*/ GIMT_Encode4(105617),
     /*  104377 */ // Label 2738: @104377
     /*  104377 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(105616),
     /*  104382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  104385 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(104426), // Rule ID 446 //
     /*  104390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  104393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  104403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104407 */     // MIs[0] rs1
     /*  104407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104419 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104424 */     GIR_RootConstrainSelectedInstOperands,
     /*  104425 */     // GIR_Coverage, 446,
     /*  104425 */     GIR_Done,
     /*  104426 */   // Label 2742: @104426
     /*  104426 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(104467), // Rule ID 448 //
     /*  104431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  104434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  104444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104448 */     // MIs[0] rs1
     /*  104448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104460 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  104465 */     GIR_RootConstrainSelectedInstOperands,
     /*  104466 */     // GIR_Coverage, 448,
     /*  104466 */     GIR_Done,
     /*  104467 */   // Label 2743: @104467
     /*  104467 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(104508), // Rule ID 450 //
     /*  104472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  104475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  104485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104489 */     // MIs[0] rs1
     /*  104489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104501 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  104506 */     GIR_RootConstrainSelectedInstOperands,
     /*  104507 */     // GIR_Coverage, 450,
     /*  104507 */     GIR_Done,
     /*  104508 */   // Label 2744: @104508
     /*  104508 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(104549), // Rule ID 452 //
     /*  104513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  104516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  104526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104530 */     // MIs[0] rs1
     /*  104530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104542 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  104547 */     GIR_RootConstrainSelectedInstOperands,
     /*  104548 */     // GIR_Coverage, 452,
     /*  104548 */     GIR_Done,
     /*  104549 */   // Label 2745: @104549
     /*  104549 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(104590), // Rule ID 454 //
     /*  104554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  104557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  104567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104571 */     // MIs[0] rs1
     /*  104571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104583 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  104588 */     GIR_RootConstrainSelectedInstOperands,
     /*  104589 */     // GIR_Coverage, 454,
     /*  104589 */     GIR_Done,
     /*  104590 */   // Label 2746: @104590
     /*  104590 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(104631), // Rule ID 456 //
     /*  104595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  104598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  104608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104612 */     // MIs[0] rs1
     /*  104612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104624 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104629 */     GIR_RootConstrainSelectedInstOperands,
     /*  104630 */     // GIR_Coverage, 456,
     /*  104630 */     GIR_Done,
     /*  104631 */   // Label 2747: @104631
     /*  104631 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(104672), // Rule ID 458 //
     /*  104636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  104639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  104649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104653 */     // MIs[0] rs1
     /*  104653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104665 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104670 */     GIR_RootConstrainSelectedInstOperands,
     /*  104671 */     // GIR_Coverage, 458,
     /*  104671 */     GIR_Done,
     /*  104672 */   // Label 2748: @104672
     /*  104672 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(104713), // Rule ID 460 //
     /*  104677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  104680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  104690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104694 */     // MIs[0] rs1
     /*  104694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104706 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104711 */     GIR_RootConstrainSelectedInstOperands,
     /*  104712 */     // GIR_Coverage, 460,
     /*  104712 */     GIR_Done,
     /*  104713 */   // Label 2749: @104713
     /*  104713 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(104754), // Rule ID 462 //
     /*  104718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  104721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  104731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104735 */     // MIs[0] rs1
     /*  104735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104747 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104752 */     GIR_RootConstrainSelectedInstOperands,
     /*  104753 */     // GIR_Coverage, 462,
     /*  104753 */     GIR_Done,
     /*  104754 */   // Label 2750: @104754
     /*  104754 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(104795), // Rule ID 464 //
     /*  104759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  104762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  104769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  104772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104776 */     // MIs[0] rs1
     /*  104776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104788 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  104793 */     GIR_RootConstrainSelectedInstOperands,
     /*  104794 */     // GIR_Coverage, 464,
     /*  104794 */     GIR_Done,
     /*  104795 */   // Label 2751: @104795
     /*  104795 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(104836), // Rule ID 794 //
     /*  104800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  104803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  104810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  104813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104817 */     // MIs[0] rs1
     /*  104817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104829 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  104834 */     GIR_RootConstrainSelectedInstOperands,
     /*  104835 */     // GIR_Coverage, 794,
     /*  104835 */     GIR_Done,
     /*  104836 */   // Label 2752: @104836
     /*  104836 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(104877), // Rule ID 796 //
     /*  104841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  104844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  104851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  104854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104858 */     // MIs[0] rs1
     /*  104858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104870 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  104875 */     GIR_RootConstrainSelectedInstOperands,
     /*  104876 */     // GIR_Coverage, 796,
     /*  104876 */     GIR_Done,
     /*  104877 */   // Label 2753: @104877
     /*  104877 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(104918), // Rule ID 798 //
     /*  104882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  104885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  104892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  104895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104899 */     // MIs[0] rs1
     /*  104899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104911 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  104916 */     GIR_RootConstrainSelectedInstOperands,
     /*  104917 */     // GIR_Coverage, 798,
     /*  104917 */     GIR_Done,
     /*  104918 */   // Label 2754: @104918
     /*  104918 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(104959), // Rule ID 800 //
     /*  104923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  104926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  104933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  104936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104940 */     // MIs[0] rs1
     /*  104940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104952 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  104957 */     GIR_RootConstrainSelectedInstOperands,
     /*  104958 */     // GIR_Coverage, 800,
     /*  104958 */     GIR_Done,
     /*  104959 */   // Label 2755: @104959
     /*  104959 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(105000), // Rule ID 802 //
     /*  104964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  104967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  104974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  104977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104981 */     // MIs[0] rs1
     /*  104981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  104985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  104993 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  104993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  104998 */     GIR_RootConstrainSelectedInstOperands,
     /*  104999 */     // GIR_Coverage, 802,
     /*  104999 */     GIR_Done,
     /*  105000 */   // Label 2756: @105000
     /*  105000 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(105041), // Rule ID 804 //
     /*  105005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  105015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  105018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105022 */     // MIs[0] rs1
     /*  105022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105034 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  105039 */     GIR_RootConstrainSelectedInstOperands,
     /*  105040 */     // GIR_Coverage, 804,
     /*  105040 */     GIR_Done,
     /*  105041 */   // Label 2757: @105041
     /*  105041 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(105082), // Rule ID 806 //
     /*  105046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  105056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  105059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105063 */     // MIs[0] rs1
     /*  105063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105075 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  105080 */     GIR_RootConstrainSelectedInstOperands,
     /*  105081 */     // GIR_Coverage, 806,
     /*  105081 */     GIR_Done,
     /*  105082 */   // Label 2758: @105082
     /*  105082 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(105123), // Rule ID 808 //
     /*  105087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  105097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  105100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105104 */     // MIs[0] rs1
     /*  105104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105116 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  105121 */     GIR_RootConstrainSelectedInstOperands,
     /*  105122 */     // GIR_Coverage, 808,
     /*  105122 */     GIR_Done,
     /*  105123 */   // Label 2759: @105123
     /*  105123 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(105164), // Rule ID 810 //
     /*  105128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  105138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  105141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105145 */     // MIs[0] rs1
     /*  105145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105157 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  105162 */     GIR_RootConstrainSelectedInstOperands,
     /*  105163 */     // GIR_Coverage, 810,
     /*  105163 */     GIR_Done,
     /*  105164 */   // Label 2760: @105164
     /*  105164 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(105205), // Rule ID 812 //
     /*  105169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  105179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  105182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105186 */     // MIs[0] rs1
     /*  105186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105198 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  105203 */     GIR_RootConstrainSelectedInstOperands,
     /*  105204 */     // GIR_Coverage, 812,
     /*  105204 */     GIR_Done,
     /*  105205 */   // Label 2761: @105205
     /*  105205 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(105246), // Rule ID 974 //
     /*  105210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  105213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  105223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105227 */     // MIs[0] rs1
     /*  105227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105239 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105244 */     GIR_RootConstrainSelectedInstOperands,
     /*  105245 */     // GIR_Coverage, 974,
     /*  105245 */     GIR_Done,
     /*  105246 */   // Label 2762: @105246
     /*  105246 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(105287), // Rule ID 976 //
     /*  105251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  105254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  105264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105268 */     // MIs[0] rs1
     /*  105268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105280 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  105285 */     GIR_RootConstrainSelectedInstOperands,
     /*  105286 */     // GIR_Coverage, 976,
     /*  105286 */     GIR_Done,
     /*  105287 */   // Label 2763: @105287
     /*  105287 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(105328), // Rule ID 978 //
     /*  105292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  105295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  105305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105309 */     // MIs[0] rs1
     /*  105309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105321 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  105326 */     GIR_RootConstrainSelectedInstOperands,
     /*  105327 */     // GIR_Coverage, 978,
     /*  105327 */     GIR_Done,
     /*  105328 */   // Label 2764: @105328
     /*  105328 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(105369), // Rule ID 980 //
     /*  105333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  105336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  105346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105350 */     // MIs[0] rs1
     /*  105350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105362 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  105367 */     GIR_RootConstrainSelectedInstOperands,
     /*  105368 */     // GIR_Coverage, 980,
     /*  105368 */     GIR_Done,
     /*  105369 */   // Label 2765: @105369
     /*  105369 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(105410), // Rule ID 982 //
     /*  105374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  105377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  105387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105391 */     // MIs[0] rs1
     /*  105391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105403 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  105408 */     GIR_RootConstrainSelectedInstOperands,
     /*  105409 */     // GIR_Coverage, 982,
     /*  105409 */     GIR_Done,
     /*  105410 */   // Label 2766: @105410
     /*  105410 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(105451), // Rule ID 984 //
     /*  105415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  105428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105432 */     // MIs[0] rs1
     /*  105432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105444 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105449 */     GIR_RootConstrainSelectedInstOperands,
     /*  105450 */     // GIR_Coverage, 984,
     /*  105450 */     GIR_Done,
     /*  105451 */   // Label 2767: @105451
     /*  105451 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(105492), // Rule ID 986 //
     /*  105456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  105469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105473 */     // MIs[0] rs1
     /*  105473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105485 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105490 */     GIR_RootConstrainSelectedInstOperands,
     /*  105491 */     // GIR_Coverage, 986,
     /*  105491 */     GIR_Done,
     /*  105492 */   // Label 2768: @105492
     /*  105492 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(105533), // Rule ID 988 //
     /*  105497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  105510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105514 */     // MIs[0] rs1
     /*  105514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105526 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105531 */     GIR_RootConstrainSelectedInstOperands,
     /*  105532 */     // GIR_Coverage, 988,
     /*  105532 */     GIR_Done,
     /*  105533 */   // Label 2769: @105533
     /*  105533 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(105574), // Rule ID 990 //
     /*  105538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  105551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105555 */     // MIs[0] rs1
     /*  105555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105567 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105572 */     GIR_RootConstrainSelectedInstOperands,
     /*  105573 */     // GIR_Coverage, 990,
     /*  105573 */     GIR_Done,
     /*  105574 */   // Label 2770: @105574
     /*  105574 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(105615), // Rule ID 992 //
     /*  105579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  105582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  105589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  105592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105596 */     // MIs[0] rs1
     /*  105596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  105600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105608 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  105608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  105613 */     GIR_RootConstrainSelectedInstOperands,
     /*  105614 */     // GIR_Coverage, 992,
     /*  105614 */     GIR_Done,
     /*  105615 */   // Label 2771: @105615
     /*  105615 */   GIM_Reject,
     /*  105616 */ // Label 2741: @105616
     /*  105616 */ GIM_Reject,
     /*  105617 */ // Label 2739: @105617
     /*  105617 */ GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(107266),
     /*  105622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  105625 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(105666), // Rule ID 445 //
     /*  105630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  105633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  105643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105647 */     // MIs[0] rs1
     /*  105647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105659 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  105664 */     GIR_RootConstrainSelectedInstOperands,
     /*  105665 */     // GIR_Coverage, 445,
     /*  105665 */     GIR_Done,
     /*  105666 */   // Label 2773: @105666
     /*  105666 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(105707), // Rule ID 447 //
     /*  105671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  105674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  105684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105688 */     // MIs[0] rs1
     /*  105688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105700 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  105705 */     GIR_RootConstrainSelectedInstOperands,
     /*  105706 */     // GIR_Coverage, 447,
     /*  105706 */     GIR_Done,
     /*  105707 */   // Label 2774: @105707
     /*  105707 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(105748), // Rule ID 449 //
     /*  105712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  105715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  105725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105729 */     // MIs[0] rs1
     /*  105729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105741 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  105746 */     GIR_RootConstrainSelectedInstOperands,
     /*  105747 */     // GIR_Coverage, 449,
     /*  105747 */     GIR_Done,
     /*  105748 */   // Label 2775: @105748
     /*  105748 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(105789), // Rule ID 451 //
     /*  105753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  105756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  105766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105770 */     // MIs[0] rs1
     /*  105770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105782 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  105787 */     GIR_RootConstrainSelectedInstOperands,
     /*  105788 */     // GIR_Coverage, 451,
     /*  105788 */     GIR_Done,
     /*  105789 */   // Label 2776: @105789
     /*  105789 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(105830), // Rule ID 453 //
     /*  105794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  105797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  105807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105811 */     // MIs[0] rs1
     /*  105811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105823 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  105828 */     GIR_RootConstrainSelectedInstOperands,
     /*  105829 */     // GIR_Coverage, 453,
     /*  105829 */     GIR_Done,
     /*  105830 */   // Label 2777: @105830
     /*  105830 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(105871), // Rule ID 455 //
     /*  105835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  105838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  105848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105852 */     // MIs[0] rs1
     /*  105852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105864 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  105869 */     GIR_RootConstrainSelectedInstOperands,
     /*  105870 */     // GIR_Coverage, 455,
     /*  105870 */     GIR_Done,
     /*  105871 */   // Label 2778: @105871
     /*  105871 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(105912), // Rule ID 457 //
     /*  105876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  105879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  105889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105893 */     // MIs[0] rs1
     /*  105893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105905 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  105910 */     GIR_RootConstrainSelectedInstOperands,
     /*  105911 */     // GIR_Coverage, 457,
     /*  105911 */     GIR_Done,
     /*  105912 */   // Label 2779: @105912
     /*  105912 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(105953), // Rule ID 459 //
     /*  105917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  105920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  105930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105934 */     // MIs[0] rs1
     /*  105934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105946 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  105951 */     GIR_RootConstrainSelectedInstOperands,
     /*  105952 */     // GIR_Coverage, 459,
     /*  105952 */     GIR_Done,
     /*  105953 */   // Label 2780: @105953
     /*  105953 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(105994), // Rule ID 461 //
     /*  105958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  105961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  105968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  105971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105975 */     // MIs[0] rs1
     /*  105975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  105979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  105987 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  105987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  105992 */     GIR_RootConstrainSelectedInstOperands,
     /*  105993 */     // GIR_Coverage, 461,
     /*  105993 */     GIR_Done,
     /*  105994 */   // Label 2781: @105994
     /*  105994 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(106035), // Rule ID 463 //
     /*  105999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  106002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  106009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  106012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106016 */     // MIs[0] rs1
     /*  106016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106028 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  106033 */     GIR_RootConstrainSelectedInstOperands,
     /*  106034 */     // GIR_Coverage, 463,
     /*  106034 */     GIR_Done,
     /*  106035 */   // Label 2782: @106035
     /*  106035 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(106076), // Rule ID 565 //
     /*  106040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  106043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  106053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106057 */     // MIs[0] rs1
     /*  106057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106069 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106074 */     GIR_RootConstrainSelectedInstOperands,
     /*  106075 */     // GIR_Coverage, 565,
     /*  106075 */     GIR_Done,
     /*  106076 */   // Label 2783: @106076
     /*  106076 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(106117), // Rule ID 566 //
     /*  106081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  106084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  106094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106098 */     // MIs[0] rs1
     /*  106098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106110 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  106115 */     GIR_RootConstrainSelectedInstOperands,
     /*  106116 */     // GIR_Coverage, 566,
     /*  106116 */     GIR_Done,
     /*  106117 */   // Label 2784: @106117
     /*  106117 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(106158), // Rule ID 567 //
     /*  106122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  106125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  106135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106139 */     // MIs[0] rs1
     /*  106139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106151 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  106156 */     GIR_RootConstrainSelectedInstOperands,
     /*  106157 */     // GIR_Coverage, 567,
     /*  106157 */     GIR_Done,
     /*  106158 */   // Label 2785: @106158
     /*  106158 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(106199), // Rule ID 568 //
     /*  106163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  106166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  106176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106180 */     // MIs[0] rs1
     /*  106180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106192 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  106197 */     GIR_RootConstrainSelectedInstOperands,
     /*  106198 */     // GIR_Coverage, 568,
     /*  106198 */     GIR_Done,
     /*  106199 */   // Label 2786: @106199
     /*  106199 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(106240), // Rule ID 569 //
     /*  106204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  106207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  106217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106221 */     // MIs[0] rs1
     /*  106221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106233 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  106238 */     GIR_RootConstrainSelectedInstOperands,
     /*  106239 */     // GIR_Coverage, 569,
     /*  106239 */     GIR_Done,
     /*  106240 */   // Label 2787: @106240
     /*  106240 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(106281), // Rule ID 570 //
     /*  106245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  106248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  106258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106262 */     // MIs[0] rs1
     /*  106262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106274 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106279 */     GIR_RootConstrainSelectedInstOperands,
     /*  106280 */     // GIR_Coverage, 570,
     /*  106280 */     GIR_Done,
     /*  106281 */   // Label 2788: @106281
     /*  106281 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(106322), // Rule ID 571 //
     /*  106286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  106289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  106299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106303 */     // MIs[0] rs1
     /*  106303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106315 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106320 */     GIR_RootConstrainSelectedInstOperands,
     /*  106321 */     // GIR_Coverage, 571,
     /*  106321 */     GIR_Done,
     /*  106322 */   // Label 2789: @106322
     /*  106322 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(106363), // Rule ID 572 //
     /*  106327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  106330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  106340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106344 */     // MIs[0] rs1
     /*  106344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106356 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106361 */     GIR_RootConstrainSelectedInstOperands,
     /*  106362 */     // GIR_Coverage, 572,
     /*  106362 */     GIR_Done,
     /*  106363 */   // Label 2790: @106363
     /*  106363 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(106404), // Rule ID 573 //
     /*  106368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  106371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  106381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106385 */     // MIs[0] rs1
     /*  106385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106397 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106402 */     GIR_RootConstrainSelectedInstOperands,
     /*  106403 */     // GIR_Coverage, 573,
     /*  106403 */     GIR_Done,
     /*  106404 */   // Label 2791: @106404
     /*  106404 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(106445), // Rule ID 574 //
     /*  106409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  106412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  106419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  106422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106426 */     // MIs[0] rs1
     /*  106426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106438 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  106443 */     GIR_RootConstrainSelectedInstOperands,
     /*  106444 */     // GIR_Coverage, 574,
     /*  106444 */     GIR_Done,
     /*  106445 */   // Label 2792: @106445
     /*  106445 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(106486), // Rule ID 793 //
     /*  106450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  106463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106467 */     // MIs[0] rs1
     /*  106467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106479 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106484 */     GIR_RootConstrainSelectedInstOperands,
     /*  106485 */     // GIR_Coverage, 793,
     /*  106485 */     GIR_Done,
     /*  106486 */   // Label 2793: @106486
     /*  106486 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(106527), // Rule ID 795 //
     /*  106491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106501 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  106504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106508 */     // MIs[0] rs1
     /*  106508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106520 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  106525 */     GIR_RootConstrainSelectedInstOperands,
     /*  106526 */     // GIR_Coverage, 795,
     /*  106526 */     GIR_Done,
     /*  106527 */   // Label 2794: @106527
     /*  106527 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(106568), // Rule ID 797 //
     /*  106532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  106545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106549 */     // MIs[0] rs1
     /*  106549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106561 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  106566 */     GIR_RootConstrainSelectedInstOperands,
     /*  106567 */     // GIR_Coverage, 797,
     /*  106567 */     GIR_Done,
     /*  106568 */   // Label 2795: @106568
     /*  106568 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(106609), // Rule ID 799 //
     /*  106573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  106586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106590 */     // MIs[0] rs1
     /*  106590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106602 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  106607 */     GIR_RootConstrainSelectedInstOperands,
     /*  106608 */     // GIR_Coverage, 799,
     /*  106608 */     GIR_Done,
     /*  106609 */   // Label 2796: @106609
     /*  106609 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(106650), // Rule ID 801 //
     /*  106614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  106627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106631 */     // MIs[0] rs1
     /*  106631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106643 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  106648 */     GIR_RootConstrainSelectedInstOperands,
     /*  106649 */     // GIR_Coverage, 801,
     /*  106649 */     GIR_Done,
     /*  106650 */   // Label 2797: @106650
     /*  106650 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(106691), // Rule ID 803 //
     /*  106655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  106658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  106668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106672 */     // MIs[0] rs1
     /*  106672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106684 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106689 */     GIR_RootConstrainSelectedInstOperands,
     /*  106690 */     // GIR_Coverage, 803,
     /*  106690 */     GIR_Done,
     /*  106691 */   // Label 2798: @106691
     /*  106691 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(106732), // Rule ID 805 //
     /*  106696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  106699 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  106709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106713 */     // MIs[0] rs1
     /*  106713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106725 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106730 */     GIR_RootConstrainSelectedInstOperands,
     /*  106731 */     // GIR_Coverage, 805,
     /*  106731 */     GIR_Done,
     /*  106732 */   // Label 2799: @106732
     /*  106732 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(106773), // Rule ID 807 //
     /*  106737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  106740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  106750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106754 */     // MIs[0] rs1
     /*  106754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106766 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106771 */     GIR_RootConstrainSelectedInstOperands,
     /*  106772 */     // GIR_Coverage, 807,
     /*  106772 */     GIR_Done,
     /*  106773 */   // Label 2800: @106773
     /*  106773 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(106814), // Rule ID 809 //
     /*  106778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  106781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  106791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106795 */     // MIs[0] rs1
     /*  106795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106807 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106812 */     GIR_RootConstrainSelectedInstOperands,
     /*  106813 */     // GIR_Coverage, 809,
     /*  106813 */     GIR_Done,
     /*  106814 */   // Label 2801: @106814
     /*  106814 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(106855), // Rule ID 811 //
     /*  106819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  106822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  106829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  106832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106836 */     // MIs[0] rs1
     /*  106836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106848 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  106853 */     GIR_RootConstrainSelectedInstOperands,
     /*  106854 */     // GIR_Coverage, 811,
     /*  106854 */     GIR_Done,
     /*  106855 */   // Label 2802: @106855
     /*  106855 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(106896), // Rule ID 973 //
     /*  106860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  106870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  106873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106877 */     // MIs[0] rs1
     /*  106877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106889 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  106894 */     GIR_RootConstrainSelectedInstOperands,
     /*  106895 */     // GIR_Coverage, 973,
     /*  106895 */     GIR_Done,
     /*  106896 */   // Label 2803: @106896
     /*  106896 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(106937), // Rule ID 975 //
     /*  106901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  106911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  106914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106918 */     // MIs[0] rs1
     /*  106918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106930 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  106935 */     GIR_RootConstrainSelectedInstOperands,
     /*  106936 */     // GIR_Coverage, 975,
     /*  106936 */     GIR_Done,
     /*  106937 */   // Label 2804: @106937
     /*  106937 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(106978), // Rule ID 977 //
     /*  106942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  106952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  106955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106959 */     // MIs[0] rs1
     /*  106959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  106963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106971 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  106976 */     GIR_RootConstrainSelectedInstOperands,
     /*  106977 */     // GIR_Coverage, 977,
     /*  106977 */     GIR_Done,
     /*  106978 */   // Label 2805: @106978
     /*  106978 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(107019), // Rule ID 979 //
     /*  106983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  106986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  106993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  106996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107000 */     // MIs[0] rs1
     /*  107000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107012 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  107017 */     GIR_RootConstrainSelectedInstOperands,
     /*  107018 */     // GIR_Coverage, 979,
     /*  107018 */     GIR_Done,
     /*  107019 */   // Label 2806: @107019
     /*  107019 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(107060), // Rule ID 981 //
     /*  107024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  107027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  107037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107041 */     // MIs[0] rs1
     /*  107041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107053 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  107058 */     GIR_RootConstrainSelectedInstOperands,
     /*  107059 */     // GIR_Coverage, 981,
     /*  107059 */     GIR_Done,
     /*  107060 */   // Label 2807: @107060
     /*  107060 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(107101), // Rule ID 983 //
     /*  107065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  107068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  107078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107082 */     // MIs[0] rs1
     /*  107082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107094 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  107099 */     GIR_RootConstrainSelectedInstOperands,
     /*  107100 */     // GIR_Coverage, 983,
     /*  107100 */     GIR_Done,
     /*  107101 */   // Label 2808: @107101
     /*  107101 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(107142), // Rule ID 985 //
     /*  107106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  107109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  107119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107123 */     // MIs[0] rs1
     /*  107123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107135 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  107140 */     GIR_RootConstrainSelectedInstOperands,
     /*  107141 */     // GIR_Coverage, 985,
     /*  107141 */     GIR_Done,
     /*  107142 */   // Label 2809: @107142
     /*  107142 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(107183), // Rule ID 987 //
     /*  107147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  107150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  107160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107164 */     // MIs[0] rs1
     /*  107164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107176 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  107181 */     GIR_RootConstrainSelectedInstOperands,
     /*  107182 */     // GIR_Coverage, 987,
     /*  107182 */     GIR_Done,
     /*  107183 */   // Label 2810: @107183
     /*  107183 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(107224), // Rule ID 989 //
     /*  107188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  107191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  107201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107205 */     // MIs[0] rs1
     /*  107205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107217 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  107222 */     GIR_RootConstrainSelectedInstOperands,
     /*  107223 */     // GIR_Coverage, 989,
     /*  107223 */     GIR_Done,
     /*  107224 */   // Label 2811: @107224
     /*  107224 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(107265), // Rule ID 991 //
     /*  107229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  107232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  107239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  107242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107246 */     // MIs[0] rs1
     /*  107246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  107250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107258 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  107263 */     GIR_RootConstrainSelectedInstOperands,
     /*  107264 */     // GIR_Coverage, 991,
     /*  107264 */     GIR_Done,
     /*  107265 */   // Label 2812: @107265
     /*  107265 */   GIM_Reject,
     /*  107266 */ // Label 2772: @107266
     /*  107266 */ GIM_Reject,
     /*  107267 */ // Label 2740: @107267
     /*  107267 */ GIM_Reject,
     /*  107268 */ // Label 34: @107268
     /*  107268 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2815*/ GIMT_Encode4(110177),
     /*  107279 */ /*GILLT_s32*//*Label 2813*/ GIMT_Encode4(107287),
     /*  107283 */ /*GILLT_s64*//*Label 2814*/ GIMT_Encode4(108527),
     /*  107287 */ // Label 2813: @107287
     /*  107287 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(108526),
     /*  107292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107295 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(107336), // Rule ID 466 //
     /*  107300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  107303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  107313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107317 */     // MIs[0] rs1
     /*  107317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107329 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107334 */     GIR_RootConstrainSelectedInstOperands,
     /*  107335 */     // GIR_Coverage, 466,
     /*  107335 */     GIR_Done,
     /*  107336 */   // Label 2817: @107336
     /*  107336 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(107377), // Rule ID 468 //
     /*  107341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  107344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  107354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107358 */     // MIs[0] rs1
     /*  107358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107370 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  107375 */     GIR_RootConstrainSelectedInstOperands,
     /*  107376 */     // GIR_Coverage, 468,
     /*  107376 */     GIR_Done,
     /*  107377 */   // Label 2818: @107377
     /*  107377 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(107418), // Rule ID 470 //
     /*  107382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  107385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  107395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107399 */     // MIs[0] rs1
     /*  107399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107411 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  107416 */     GIR_RootConstrainSelectedInstOperands,
     /*  107417 */     // GIR_Coverage, 470,
     /*  107417 */     GIR_Done,
     /*  107418 */   // Label 2819: @107418
     /*  107418 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(107459), // Rule ID 472 //
     /*  107423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  107426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  107436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107440 */     // MIs[0] rs1
     /*  107440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107452 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  107457 */     GIR_RootConstrainSelectedInstOperands,
     /*  107458 */     // GIR_Coverage, 472,
     /*  107458 */     GIR_Done,
     /*  107459 */   // Label 2820: @107459
     /*  107459 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(107500), // Rule ID 474 //
     /*  107464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  107467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  107477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107481 */     // MIs[0] rs1
     /*  107481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107493 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  107498 */     GIR_RootConstrainSelectedInstOperands,
     /*  107499 */     // GIR_Coverage, 474,
     /*  107499 */     GIR_Done,
     /*  107500 */   // Label 2821: @107500
     /*  107500 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(107541), // Rule ID 476 //
     /*  107505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  107508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  107518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107522 */     // MIs[0] rs1
     /*  107522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107534 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107539 */     GIR_RootConstrainSelectedInstOperands,
     /*  107540 */     // GIR_Coverage, 476,
     /*  107540 */     GIR_Done,
     /*  107541 */   // Label 2822: @107541
     /*  107541 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(107582), // Rule ID 478 //
     /*  107546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  107549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  107559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107563 */     // MIs[0] rs1
     /*  107563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107575 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107580 */     GIR_RootConstrainSelectedInstOperands,
     /*  107581 */     // GIR_Coverage, 478,
     /*  107581 */     GIR_Done,
     /*  107582 */   // Label 2823: @107582
     /*  107582 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(107623), // Rule ID 480 //
     /*  107587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  107590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  107600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107604 */     // MIs[0] rs1
     /*  107604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107616 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107621 */     GIR_RootConstrainSelectedInstOperands,
     /*  107622 */     // GIR_Coverage, 480,
     /*  107622 */     GIR_Done,
     /*  107623 */   // Label 2824: @107623
     /*  107623 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(107664), // Rule ID 482 //
     /*  107628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  107631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  107641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107645 */     // MIs[0] rs1
     /*  107645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107657 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107662 */     GIR_RootConstrainSelectedInstOperands,
     /*  107663 */     // GIR_Coverage, 482,
     /*  107663 */     GIR_Done,
     /*  107664 */   // Label 2825: @107664
     /*  107664 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(107705), // Rule ID 484 //
     /*  107669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  107672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  107679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  107682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107686 */     // MIs[0] rs1
     /*  107686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107698 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  107703 */     GIR_RootConstrainSelectedInstOperands,
     /*  107704 */     // GIR_Coverage, 484,
     /*  107704 */     GIR_Done,
     /*  107705 */   // Label 2826: @107705
     /*  107705 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(107746), // Rule ID 814 //
     /*  107710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  107713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  107723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107727 */     // MIs[0] rs1
     /*  107727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107739 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  107744 */     GIR_RootConstrainSelectedInstOperands,
     /*  107745 */     // GIR_Coverage, 814,
     /*  107745 */     GIR_Done,
     /*  107746 */   // Label 2827: @107746
     /*  107746 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(107787), // Rule ID 816 //
     /*  107751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  107754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  107764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107768 */     // MIs[0] rs1
     /*  107768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107780 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  107785 */     GIR_RootConstrainSelectedInstOperands,
     /*  107786 */     // GIR_Coverage, 816,
     /*  107786 */     GIR_Done,
     /*  107787 */   // Label 2828: @107787
     /*  107787 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(107828), // Rule ID 818 //
     /*  107792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  107795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  107805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107809 */     // MIs[0] rs1
     /*  107809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107821 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  107826 */     GIR_RootConstrainSelectedInstOperands,
     /*  107827 */     // GIR_Coverage, 818,
     /*  107827 */     GIR_Done,
     /*  107828 */   // Label 2829: @107828
     /*  107828 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(107869), // Rule ID 820 //
     /*  107833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  107836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  107846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107850 */     // MIs[0] rs1
     /*  107850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107862 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  107867 */     GIR_RootConstrainSelectedInstOperands,
     /*  107868 */     // GIR_Coverage, 820,
     /*  107868 */     GIR_Done,
     /*  107869 */   // Label 2830: @107869
     /*  107869 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(107910), // Rule ID 822 //
     /*  107874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  107877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  107887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107891 */     // MIs[0] rs1
     /*  107891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107903 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  107908 */     GIR_RootConstrainSelectedInstOperands,
     /*  107909 */     // GIR_Coverage, 822,
     /*  107909 */     GIR_Done,
     /*  107910 */   // Label 2831: @107910
     /*  107910 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(107951), // Rule ID 824 //
     /*  107915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  107918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  107928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107932 */     // MIs[0] rs1
     /*  107932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107944 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  107949 */     GIR_RootConstrainSelectedInstOperands,
     /*  107950 */     // GIR_Coverage, 824,
     /*  107950 */     GIR_Done,
     /*  107951 */   // Label 2832: @107951
     /*  107951 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(107992), // Rule ID 826 //
     /*  107956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  107959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  107966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  107969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107973 */     // MIs[0] rs1
     /*  107973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  107977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107985 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  107990 */     GIR_RootConstrainSelectedInstOperands,
     /*  107991 */     // GIR_Coverage, 826,
     /*  107991 */     GIR_Done,
     /*  107992 */   // Label 2833: @107992
     /*  107992 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(108033), // Rule ID 828 //
     /*  107997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  108007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  108010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108014 */     // MIs[0] rs1
     /*  108014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108026 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  108031 */     GIR_RootConstrainSelectedInstOperands,
     /*  108032 */     // GIR_Coverage, 828,
     /*  108032 */     GIR_Done,
     /*  108033 */   // Label 2834: @108033
     /*  108033 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(108074), // Rule ID 830 //
     /*  108038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  108048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  108051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108055 */     // MIs[0] rs1
     /*  108055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108067 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  108072 */     GIR_RootConstrainSelectedInstOperands,
     /*  108073 */     // GIR_Coverage, 830,
     /*  108073 */     GIR_Done,
     /*  108074 */   // Label 2835: @108074
     /*  108074 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(108115), // Rule ID 832 //
     /*  108079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  108089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  108092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108096 */     // MIs[0] rs1
     /*  108096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108108 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  108113 */     GIR_RootConstrainSelectedInstOperands,
     /*  108114 */     // GIR_Coverage, 832,
     /*  108114 */     GIR_Done,
     /*  108115 */   // Label 2836: @108115
     /*  108115 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(108156), // Rule ID 994 //
     /*  108120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  108123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  108133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108137 */     // MIs[0] rs1
     /*  108137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108149 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108154 */     GIR_RootConstrainSelectedInstOperands,
     /*  108155 */     // GIR_Coverage, 994,
     /*  108155 */     GIR_Done,
     /*  108156 */   // Label 2837: @108156
     /*  108156 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(108197), // Rule ID 996 //
     /*  108161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  108164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  108174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108178 */     // MIs[0] rs1
     /*  108178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108190 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  108195 */     GIR_RootConstrainSelectedInstOperands,
     /*  108196 */     // GIR_Coverage, 996,
     /*  108196 */     GIR_Done,
     /*  108197 */   // Label 2838: @108197
     /*  108197 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(108238), // Rule ID 998 //
     /*  108202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  108205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  108215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108219 */     // MIs[0] rs1
     /*  108219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108231 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  108236 */     GIR_RootConstrainSelectedInstOperands,
     /*  108237 */     // GIR_Coverage, 998,
     /*  108237 */     GIR_Done,
     /*  108238 */   // Label 2839: @108238
     /*  108238 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(108279), // Rule ID 1000 //
     /*  108243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  108246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  108256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108260 */     // MIs[0] rs1
     /*  108260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108272 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  108277 */     GIR_RootConstrainSelectedInstOperands,
     /*  108278 */     // GIR_Coverage, 1000,
     /*  108278 */     GIR_Done,
     /*  108279 */   // Label 2840: @108279
     /*  108279 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(108320), // Rule ID 1002 //
     /*  108284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  108287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  108297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108301 */     // MIs[0] rs1
     /*  108301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108313 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  108318 */     GIR_RootConstrainSelectedInstOperands,
     /*  108319 */     // GIR_Coverage, 1002,
     /*  108319 */     GIR_Done,
     /*  108320 */   // Label 2841: @108320
     /*  108320 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(108361), // Rule ID 1004 //
     /*  108325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  108338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108342 */     // MIs[0] rs1
     /*  108342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108354 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108359 */     GIR_RootConstrainSelectedInstOperands,
     /*  108360 */     // GIR_Coverage, 1004,
     /*  108360 */     GIR_Done,
     /*  108361 */   // Label 2842: @108361
     /*  108361 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(108402), // Rule ID 1006 //
     /*  108366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  108379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108383 */     // MIs[0] rs1
     /*  108383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108395 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108400 */     GIR_RootConstrainSelectedInstOperands,
     /*  108401 */     // GIR_Coverage, 1006,
     /*  108401 */     GIR_Done,
     /*  108402 */   // Label 2843: @108402
     /*  108402 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(108443), // Rule ID 1008 //
     /*  108407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  108420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108424 */     // MIs[0] rs1
     /*  108424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108436 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108441 */     GIR_RootConstrainSelectedInstOperands,
     /*  108442 */     // GIR_Coverage, 1008,
     /*  108442 */     GIR_Done,
     /*  108443 */   // Label 2844: @108443
     /*  108443 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(108484), // Rule ID 1010 //
     /*  108448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  108461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108465 */     // MIs[0] rs1
     /*  108465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108477 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108482 */     GIR_RootConstrainSelectedInstOperands,
     /*  108483 */     // GIR_Coverage, 1010,
     /*  108483 */     GIR_Done,
     /*  108484 */   // Label 2845: @108484
     /*  108484 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(108525), // Rule ID 1012 //
     /*  108489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  108492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  108499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  108502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108506 */     // MIs[0] rs1
     /*  108506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  108510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108518 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  108523 */     GIR_RootConstrainSelectedInstOperands,
     /*  108524 */     // GIR_Coverage, 1012,
     /*  108524 */     GIR_Done,
     /*  108525 */   // Label 2846: @108525
     /*  108525 */   GIM_Reject,
     /*  108526 */ // Label 2816: @108526
     /*  108526 */ GIM_Reject,
     /*  108527 */ // Label 2814: @108527
     /*  108527 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(110176),
     /*  108532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  108535 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(108576), // Rule ID 465 //
     /*  108540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  108543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  108553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108557 */     // MIs[0] rs1
     /*  108557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108569 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108574 */     GIR_RootConstrainSelectedInstOperands,
     /*  108575 */     // GIR_Coverage, 465,
     /*  108575 */     GIR_Done,
     /*  108576 */   // Label 2848: @108576
     /*  108576 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(108617), // Rule ID 467 //
     /*  108581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  108584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  108594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108598 */     // MIs[0] rs1
     /*  108598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108610 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  108615 */     GIR_RootConstrainSelectedInstOperands,
     /*  108616 */     // GIR_Coverage, 467,
     /*  108616 */     GIR_Done,
     /*  108617 */   // Label 2849: @108617
     /*  108617 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(108658), // Rule ID 469 //
     /*  108622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  108625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  108635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108639 */     // MIs[0] rs1
     /*  108639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108651 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  108656 */     GIR_RootConstrainSelectedInstOperands,
     /*  108657 */     // GIR_Coverage, 469,
     /*  108657 */     GIR_Done,
     /*  108658 */   // Label 2850: @108658
     /*  108658 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(108699), // Rule ID 471 //
     /*  108663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  108666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  108676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108680 */     // MIs[0] rs1
     /*  108680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108692 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  108697 */     GIR_RootConstrainSelectedInstOperands,
     /*  108698 */     // GIR_Coverage, 471,
     /*  108698 */     GIR_Done,
     /*  108699 */   // Label 2851: @108699
     /*  108699 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(108740), // Rule ID 473 //
     /*  108704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  108707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  108717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108721 */     // MIs[0] rs1
     /*  108721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108733 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  108738 */     GIR_RootConstrainSelectedInstOperands,
     /*  108739 */     // GIR_Coverage, 473,
     /*  108739 */     GIR_Done,
     /*  108740 */   // Label 2852: @108740
     /*  108740 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(108781), // Rule ID 475 //
     /*  108745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  108748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  108758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108762 */     // MIs[0] rs1
     /*  108762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108774 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108779 */     GIR_RootConstrainSelectedInstOperands,
     /*  108780 */     // GIR_Coverage, 475,
     /*  108780 */     GIR_Done,
     /*  108781 */   // Label 2853: @108781
     /*  108781 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(108822), // Rule ID 477 //
     /*  108786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  108789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  108799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108803 */     // MIs[0] rs1
     /*  108803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108815 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108820 */     GIR_RootConstrainSelectedInstOperands,
     /*  108821 */     // GIR_Coverage, 477,
     /*  108821 */     GIR_Done,
     /*  108822 */   // Label 2854: @108822
     /*  108822 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(108863), // Rule ID 479 //
     /*  108827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  108830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  108840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108844 */     // MIs[0] rs1
     /*  108844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108856 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108861 */     GIR_RootConstrainSelectedInstOperands,
     /*  108862 */     // GIR_Coverage, 479,
     /*  108862 */     GIR_Done,
     /*  108863 */   // Label 2855: @108863
     /*  108863 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(108904), // Rule ID 481 //
     /*  108868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  108871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  108881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108885 */     // MIs[0] rs1
     /*  108885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108897 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108902 */     GIR_RootConstrainSelectedInstOperands,
     /*  108903 */     // GIR_Coverage, 481,
     /*  108903 */     GIR_Done,
     /*  108904 */   // Label 2856: @108904
     /*  108904 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(108945), // Rule ID 483 //
     /*  108909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  108912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  108919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  108922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108926 */     // MIs[0] rs1
     /*  108926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108938 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  108943 */     GIR_RootConstrainSelectedInstOperands,
     /*  108944 */     // GIR_Coverage, 483,
     /*  108944 */     GIR_Done,
     /*  108945 */   // Label 2857: @108945
     /*  108945 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(108986), // Rule ID 575 //
     /*  108950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  108953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  108960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  108963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108967 */     // MIs[0] rs1
     /*  108967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  108971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108979 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  108984 */     GIR_RootConstrainSelectedInstOperands,
     /*  108985 */     // GIR_Coverage, 575,
     /*  108985 */     GIR_Done,
     /*  108986 */   // Label 2858: @108986
     /*  108986 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(109027), // Rule ID 576 //
     /*  108991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  108994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  109004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109008 */     // MIs[0] rs1
     /*  109008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109020 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  109025 */     GIR_RootConstrainSelectedInstOperands,
     /*  109026 */     // GIR_Coverage, 576,
     /*  109026 */     GIR_Done,
     /*  109027 */   // Label 2859: @109027
     /*  109027 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(109068), // Rule ID 577 //
     /*  109032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  109035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  109045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109049 */     // MIs[0] rs1
     /*  109049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109061 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  109066 */     GIR_RootConstrainSelectedInstOperands,
     /*  109067 */     // GIR_Coverage, 577,
     /*  109067 */     GIR_Done,
     /*  109068 */   // Label 2860: @109068
     /*  109068 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(109109), // Rule ID 578 //
     /*  109073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  109076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  109086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109090 */     // MIs[0] rs1
     /*  109090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109102 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  109107 */     GIR_RootConstrainSelectedInstOperands,
     /*  109108 */     // GIR_Coverage, 578,
     /*  109108 */     GIR_Done,
     /*  109109 */   // Label 2861: @109109
     /*  109109 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(109150), // Rule ID 579 //
     /*  109114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  109117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  109127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109131 */     // MIs[0] rs1
     /*  109131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109143 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  109148 */     GIR_RootConstrainSelectedInstOperands,
     /*  109149 */     // GIR_Coverage, 579,
     /*  109149 */     GIR_Done,
     /*  109150 */   // Label 2862: @109150
     /*  109150 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(109191), // Rule ID 580 //
     /*  109155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  109158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  109168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109172 */     // MIs[0] rs1
     /*  109172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109184 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  109189 */     GIR_RootConstrainSelectedInstOperands,
     /*  109190 */     // GIR_Coverage, 580,
     /*  109190 */     GIR_Done,
     /*  109191 */   // Label 2863: @109191
     /*  109191 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(109232), // Rule ID 581 //
     /*  109196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  109199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  109209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109213 */     // MIs[0] rs1
     /*  109213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109225 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  109230 */     GIR_RootConstrainSelectedInstOperands,
     /*  109231 */     // GIR_Coverage, 581,
     /*  109231 */     GIR_Done,
     /*  109232 */   // Label 2864: @109232
     /*  109232 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(109273), // Rule ID 582 //
     /*  109237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  109240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  109250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109254 */     // MIs[0] rs1
     /*  109254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109266 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  109271 */     GIR_RootConstrainSelectedInstOperands,
     /*  109272 */     // GIR_Coverage, 582,
     /*  109272 */     GIR_Done,
     /*  109273 */   // Label 2865: @109273
     /*  109273 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(109314), // Rule ID 583 //
     /*  109278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  109281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  109291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109295 */     // MIs[0] rs1
     /*  109295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109307 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  109312 */     GIR_RootConstrainSelectedInstOperands,
     /*  109313 */     // GIR_Coverage, 583,
     /*  109313 */     GIR_Done,
     /*  109314 */   // Label 2866: @109314
     /*  109314 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(109355), // Rule ID 584 //
     /*  109319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  109322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  109329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  109332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109336 */     // MIs[0] rs1
     /*  109336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109348 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  109353 */     GIR_RootConstrainSelectedInstOperands,
     /*  109354 */     // GIR_Coverage, 584,
     /*  109354 */     GIR_Done,
     /*  109355 */   // Label 2867: @109355
     /*  109355 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(109396), // Rule ID 813 //
     /*  109360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  109373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109377 */     // MIs[0] rs1
     /*  109377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109389 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109394 */     GIR_RootConstrainSelectedInstOperands,
     /*  109395 */     // GIR_Coverage, 813,
     /*  109395 */     GIR_Done,
     /*  109396 */   // Label 2868: @109396
     /*  109396 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(109437), // Rule ID 815 //
     /*  109401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  109414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109418 */     // MIs[0] rs1
     /*  109418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109430 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  109435 */     GIR_RootConstrainSelectedInstOperands,
     /*  109436 */     // GIR_Coverage, 815,
     /*  109436 */     GIR_Done,
     /*  109437 */   // Label 2869: @109437
     /*  109437 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(109478), // Rule ID 817 //
     /*  109442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  109455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109459 */     // MIs[0] rs1
     /*  109459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109471 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  109476 */     GIR_RootConstrainSelectedInstOperands,
     /*  109477 */     // GIR_Coverage, 817,
     /*  109477 */     GIR_Done,
     /*  109478 */   // Label 2870: @109478
     /*  109478 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(109519), // Rule ID 819 //
     /*  109483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  109496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109500 */     // MIs[0] rs1
     /*  109500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109512 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  109517 */     GIR_RootConstrainSelectedInstOperands,
     /*  109518 */     // GIR_Coverage, 819,
     /*  109518 */     GIR_Done,
     /*  109519 */   // Label 2871: @109519
     /*  109519 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(109560), // Rule ID 821 //
     /*  109524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  109537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109541 */     // MIs[0] rs1
     /*  109541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109553 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  109558 */     GIR_RootConstrainSelectedInstOperands,
     /*  109559 */     // GIR_Coverage, 821,
     /*  109559 */     GIR_Done,
     /*  109560 */   // Label 2872: @109560
     /*  109560 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(109601), // Rule ID 823 //
     /*  109565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  109578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109582 */     // MIs[0] rs1
     /*  109582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109594 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109599 */     GIR_RootConstrainSelectedInstOperands,
     /*  109600 */     // GIR_Coverage, 823,
     /*  109600 */     GIR_Done,
     /*  109601 */   // Label 2873: @109601
     /*  109601 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(109642), // Rule ID 825 //
     /*  109606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  109619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109623 */     // MIs[0] rs1
     /*  109623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109635 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109640 */     GIR_RootConstrainSelectedInstOperands,
     /*  109641 */     // GIR_Coverage, 825,
     /*  109641 */     GIR_Done,
     /*  109642 */   // Label 2874: @109642
     /*  109642 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(109683), // Rule ID 827 //
     /*  109647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  109660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109664 */     // MIs[0] rs1
     /*  109664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109676 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109681 */     GIR_RootConstrainSelectedInstOperands,
     /*  109682 */     // GIR_Coverage, 827,
     /*  109682 */     GIR_Done,
     /*  109683 */   // Label 2875: @109683
     /*  109683 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(109724), // Rule ID 829 //
     /*  109688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  109701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109705 */     // MIs[0] rs1
     /*  109705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109717 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109722 */     GIR_RootConstrainSelectedInstOperands,
     /*  109723 */     // GIR_Coverage, 829,
     /*  109723 */     GIR_Done,
     /*  109724 */   // Label 2876: @109724
     /*  109724 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(109765), // Rule ID 831 //
     /*  109729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109732 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  109739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  109742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109746 */     // MIs[0] rs1
     /*  109746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109758 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  109763 */     GIR_RootConstrainSelectedInstOperands,
     /*  109764 */     // GIR_Coverage, 831,
     /*  109764 */     GIR_Done,
     /*  109765 */   // Label 2877: @109765
     /*  109765 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(109806), // Rule ID 993 //
     /*  109770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  109783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109787 */     // MIs[0] rs1
     /*  109787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109799 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  109804 */     GIR_RootConstrainSelectedInstOperands,
     /*  109805 */     // GIR_Coverage, 993,
     /*  109805 */     GIR_Done,
     /*  109806 */   // Label 2878: @109806
     /*  109806 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(109847), // Rule ID 995 //
     /*  109811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  109824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109828 */     // MIs[0] rs1
     /*  109828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109840 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  109845 */     GIR_RootConstrainSelectedInstOperands,
     /*  109846 */     // GIR_Coverage, 995,
     /*  109846 */     GIR_Done,
     /*  109847 */   // Label 2879: @109847
     /*  109847 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(109888), // Rule ID 997 //
     /*  109852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  109865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109869 */     // MIs[0] rs1
     /*  109869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109881 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  109886 */     GIR_RootConstrainSelectedInstOperands,
     /*  109887 */     // GIR_Coverage, 997,
     /*  109887 */     GIR_Done,
     /*  109888 */   // Label 2880: @109888
     /*  109888 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(109929), // Rule ID 999 //
     /*  109893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  109906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109910 */     // MIs[0] rs1
     /*  109910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109922 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  109927 */     GIR_RootConstrainSelectedInstOperands,
     /*  109928 */     // GIR_Coverage, 999,
     /*  109928 */     GIR_Done,
     /*  109929 */   // Label 2881: @109929
     /*  109929 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(109970), // Rule ID 1001 //
     /*  109934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  109937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  109947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109951 */     // MIs[0] rs1
     /*  109951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109963 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  109963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  109968 */     GIR_RootConstrainSelectedInstOperands,
     /*  109969 */     // GIR_Coverage, 1001,
     /*  109969 */     GIR_Done,
     /*  109970 */   // Label 2882: @109970
     /*  109970 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(110011), // Rule ID 1003 //
     /*  109975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  109978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  109985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  109988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  109992 */     // MIs[0] rs1
     /*  109992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  109996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110004 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  110009 */     GIR_RootConstrainSelectedInstOperands,
     /*  110010 */     // GIR_Coverage, 1003,
     /*  110010 */     GIR_Done,
     /*  110011 */   // Label 2883: @110011
     /*  110011 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(110052), // Rule ID 1005 //
     /*  110016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  110019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  110026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  110029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110033 */     // MIs[0] rs1
     /*  110033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  110037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110045 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  110050 */     GIR_RootConstrainSelectedInstOperands,
     /*  110051 */     // GIR_Coverage, 1005,
     /*  110051 */     GIR_Done,
     /*  110052 */   // Label 2884: @110052
     /*  110052 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(110093), // Rule ID 1007 //
     /*  110057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  110060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  110067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  110070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110074 */     // MIs[0] rs1
     /*  110074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  110078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110086 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  110091 */     GIR_RootConstrainSelectedInstOperands,
     /*  110092 */     // GIR_Coverage, 1007,
     /*  110092 */     GIR_Done,
     /*  110093 */   // Label 2885: @110093
     /*  110093 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(110134), // Rule ID 1009 //
     /*  110098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  110101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  110108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  110111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110115 */     // MIs[0] rs1
     /*  110115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  110119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110127 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  110132 */     GIR_RootConstrainSelectedInstOperands,
     /*  110133 */     // GIR_Coverage, 1009,
     /*  110133 */     GIR_Done,
     /*  110134 */   // Label 2886: @110134
     /*  110134 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(110175), // Rule ID 1011 //
     /*  110139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  110142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  110149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  110152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110156 */     // MIs[0] rs1
     /*  110156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  110160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110168 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  110173 */     GIR_RootConstrainSelectedInstOperands,
     /*  110174 */     // GIR_Coverage, 1011,
     /*  110174 */     GIR_Done,
     /*  110175 */   // Label 2887: @110175
     /*  110175 */   GIM_Reject,
     /*  110176 */ // Label 2847: @110176
     /*  110176 */ GIM_Reject,
     /*  110177 */ // Label 2815: @110177
     /*  110177 */ GIM_Reject,
     /*  110178 */ // Label 35: @110178
     /*  110178 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2890*/ GIMT_Encode4(113087),
     /*  110189 */ /*GILLT_s32*//*Label 2888*/ GIMT_Encode4(110197),
     /*  110193 */ /*GILLT_s64*//*Label 2889*/ GIMT_Encode4(111437),
     /*  110197 */ // Label 2888: @110197
     /*  110197 */ GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(111436),
     /*  110202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110205 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(110246), // Rule ID 486 //
     /*  110210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  110213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  110223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110227 */     // MIs[0] rs1
     /*  110227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110239 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110244 */     GIR_RootConstrainSelectedInstOperands,
     /*  110245 */     // GIR_Coverage, 486,
     /*  110245 */     GIR_Done,
     /*  110246 */   // Label 2892: @110246
     /*  110246 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(110287), // Rule ID 488 //
     /*  110251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  110254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  110264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110268 */     // MIs[0] rs1
     /*  110268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110280 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  110285 */     GIR_RootConstrainSelectedInstOperands,
     /*  110286 */     // GIR_Coverage, 488,
     /*  110286 */     GIR_Done,
     /*  110287 */   // Label 2893: @110287
     /*  110287 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(110328), // Rule ID 490 //
     /*  110292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  110295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  110305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110309 */     // MIs[0] rs1
     /*  110309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110321 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  110326 */     GIR_RootConstrainSelectedInstOperands,
     /*  110327 */     // GIR_Coverage, 490,
     /*  110327 */     GIR_Done,
     /*  110328 */   // Label 2894: @110328
     /*  110328 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(110369), // Rule ID 492 //
     /*  110333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  110336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  110346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110350 */     // MIs[0] rs1
     /*  110350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110362 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  110367 */     GIR_RootConstrainSelectedInstOperands,
     /*  110368 */     // GIR_Coverage, 492,
     /*  110368 */     GIR_Done,
     /*  110369 */   // Label 2895: @110369
     /*  110369 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(110410), // Rule ID 494 //
     /*  110374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  110377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  110387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110391 */     // MIs[0] rs1
     /*  110391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110403 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  110408 */     GIR_RootConstrainSelectedInstOperands,
     /*  110409 */     // GIR_Coverage, 494,
     /*  110409 */     GIR_Done,
     /*  110410 */   // Label 2896: @110410
     /*  110410 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(110451), // Rule ID 496 //
     /*  110415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  110418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  110428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110432 */     // MIs[0] rs1
     /*  110432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110444 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110449 */     GIR_RootConstrainSelectedInstOperands,
     /*  110450 */     // GIR_Coverage, 496,
     /*  110450 */     GIR_Done,
     /*  110451 */   // Label 2897: @110451
     /*  110451 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(110492), // Rule ID 498 //
     /*  110456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  110459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  110469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110473 */     // MIs[0] rs1
     /*  110473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110485 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110490 */     GIR_RootConstrainSelectedInstOperands,
     /*  110491 */     // GIR_Coverage, 498,
     /*  110491 */     GIR_Done,
     /*  110492 */   // Label 2898: @110492
     /*  110492 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(110533), // Rule ID 500 //
     /*  110497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  110500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  110510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110514 */     // MIs[0] rs1
     /*  110514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110526 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110531 */     GIR_RootConstrainSelectedInstOperands,
     /*  110532 */     // GIR_Coverage, 500,
     /*  110532 */     GIR_Done,
     /*  110533 */   // Label 2899: @110533
     /*  110533 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(110574), // Rule ID 502 //
     /*  110538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  110541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  110551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110555 */     // MIs[0] rs1
     /*  110555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110567 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110572 */     GIR_RootConstrainSelectedInstOperands,
     /*  110573 */     // GIR_Coverage, 502,
     /*  110573 */     GIR_Done,
     /*  110574 */   // Label 2900: @110574
     /*  110574 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(110615), // Rule ID 504 //
     /*  110579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  110582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  110589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  110592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110596 */     // MIs[0] rs1
     /*  110596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110608 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  110613 */     GIR_RootConstrainSelectedInstOperands,
     /*  110614 */     // GIR_Coverage, 504,
     /*  110614 */     GIR_Done,
     /*  110615 */   // Label 2901: @110615
     /*  110615 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(110656), // Rule ID 834 //
     /*  110620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  110623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  110633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110637 */     // MIs[0] rs1
     /*  110637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110649 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  110654 */     GIR_RootConstrainSelectedInstOperands,
     /*  110655 */     // GIR_Coverage, 834,
     /*  110655 */     GIR_Done,
     /*  110656 */   // Label 2902: @110656
     /*  110656 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(110697), // Rule ID 836 //
     /*  110661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  110664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  110674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110678 */     // MIs[0] rs1
     /*  110678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110690 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  110695 */     GIR_RootConstrainSelectedInstOperands,
     /*  110696 */     // GIR_Coverage, 836,
     /*  110696 */     GIR_Done,
     /*  110697 */   // Label 2903: @110697
     /*  110697 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(110738), // Rule ID 838 //
     /*  110702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  110705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  110715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110719 */     // MIs[0] rs1
     /*  110719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110731 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  110736 */     GIR_RootConstrainSelectedInstOperands,
     /*  110737 */     // GIR_Coverage, 838,
     /*  110737 */     GIR_Done,
     /*  110738 */   // Label 2904: @110738
     /*  110738 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(110779), // Rule ID 840 //
     /*  110743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  110746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  110756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110760 */     // MIs[0] rs1
     /*  110760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110772 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  110777 */     GIR_RootConstrainSelectedInstOperands,
     /*  110778 */     // GIR_Coverage, 840,
     /*  110778 */     GIR_Done,
     /*  110779 */   // Label 2905: @110779
     /*  110779 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(110820), // Rule ID 842 //
     /*  110784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  110787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  110797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110801 */     // MIs[0] rs1
     /*  110801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110813 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  110818 */     GIR_RootConstrainSelectedInstOperands,
     /*  110819 */     // GIR_Coverage, 842,
     /*  110819 */     GIR_Done,
     /*  110820 */   // Label 2906: @110820
     /*  110820 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(110861), // Rule ID 844 //
     /*  110825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  110828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  110838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110842 */     // MIs[0] rs1
     /*  110842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110854 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  110859 */     GIR_RootConstrainSelectedInstOperands,
     /*  110860 */     // GIR_Coverage, 844,
     /*  110860 */     GIR_Done,
     /*  110861 */   // Label 2907: @110861
     /*  110861 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(110902), // Rule ID 846 //
     /*  110866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  110869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  110879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110883 */     // MIs[0] rs1
     /*  110883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110895 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  110900 */     GIR_RootConstrainSelectedInstOperands,
     /*  110901 */     // GIR_Coverage, 846,
     /*  110901 */     GIR_Done,
     /*  110902 */   // Label 2908: @110902
     /*  110902 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(110943), // Rule ID 848 //
     /*  110907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  110910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  110920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110924 */     // MIs[0] rs1
     /*  110924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110936 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  110941 */     GIR_RootConstrainSelectedInstOperands,
     /*  110942 */     // GIR_Coverage, 848,
     /*  110942 */     GIR_Done,
     /*  110943 */   // Label 2909: @110943
     /*  110943 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(110984), // Rule ID 850 //
     /*  110948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  110951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  110961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110965 */     // MIs[0] rs1
     /*  110965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  110969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110977 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  110982 */     GIR_RootConstrainSelectedInstOperands,
     /*  110983 */     // GIR_Coverage, 850,
     /*  110983 */     GIR_Done,
     /*  110984 */   // Label 2910: @110984
     /*  110984 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(111025), // Rule ID 852 //
     /*  110989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  110992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  110999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  111002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111006 */     // MIs[0] rs1
     /*  111006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111018 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  111023 */     GIR_RootConstrainSelectedInstOperands,
     /*  111024 */     // GIR_Coverage, 852,
     /*  111024 */     GIR_Done,
     /*  111025 */   // Label 2911: @111025
     /*  111025 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(111066), // Rule ID 1014 //
     /*  111030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  111033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  111043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111047 */     // MIs[0] rs1
     /*  111047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111059 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111064 */     GIR_RootConstrainSelectedInstOperands,
     /*  111065 */     // GIR_Coverage, 1014,
     /*  111065 */     GIR_Done,
     /*  111066 */   // Label 2912: @111066
     /*  111066 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(111107), // Rule ID 1016 //
     /*  111071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  111074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  111084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111088 */     // MIs[0] rs1
     /*  111088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111100 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  111105 */     GIR_RootConstrainSelectedInstOperands,
     /*  111106 */     // GIR_Coverage, 1016,
     /*  111106 */     GIR_Done,
     /*  111107 */   // Label 2913: @111107
     /*  111107 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(111148), // Rule ID 1018 //
     /*  111112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  111115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  111125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111129 */     // MIs[0] rs1
     /*  111129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111141 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  111146 */     GIR_RootConstrainSelectedInstOperands,
     /*  111147 */     // GIR_Coverage, 1018,
     /*  111147 */     GIR_Done,
     /*  111148 */   // Label 2914: @111148
     /*  111148 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(111189), // Rule ID 1020 //
     /*  111153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  111156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  111166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111170 */     // MIs[0] rs1
     /*  111170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111182 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  111187 */     GIR_RootConstrainSelectedInstOperands,
     /*  111188 */     // GIR_Coverage, 1020,
     /*  111188 */     GIR_Done,
     /*  111189 */   // Label 2915: @111189
     /*  111189 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(111230), // Rule ID 1022 //
     /*  111194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  111197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  111207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111211 */     // MIs[0] rs1
     /*  111211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111223 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  111228 */     GIR_RootConstrainSelectedInstOperands,
     /*  111229 */     // GIR_Coverage, 1022,
     /*  111229 */     GIR_Done,
     /*  111230 */   // Label 2916: @111230
     /*  111230 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(111271), // Rule ID 1024 //
     /*  111235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  111238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  111248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111252 */     // MIs[0] rs1
     /*  111252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111264 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111269 */     GIR_RootConstrainSelectedInstOperands,
     /*  111270 */     // GIR_Coverage, 1024,
     /*  111270 */     GIR_Done,
     /*  111271 */   // Label 2917: @111271
     /*  111271 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(111312), // Rule ID 1026 //
     /*  111276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  111279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  111289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111293 */     // MIs[0] rs1
     /*  111293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111305 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111310 */     GIR_RootConstrainSelectedInstOperands,
     /*  111311 */     // GIR_Coverage, 1026,
     /*  111311 */     GIR_Done,
     /*  111312 */   // Label 2918: @111312
     /*  111312 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(111353), // Rule ID 1028 //
     /*  111317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  111320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  111330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111334 */     // MIs[0] rs1
     /*  111334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111346 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111351 */     GIR_RootConstrainSelectedInstOperands,
     /*  111352 */     // GIR_Coverage, 1028,
     /*  111352 */     GIR_Done,
     /*  111353 */   // Label 2919: @111353
     /*  111353 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(111394), // Rule ID 1030 //
     /*  111358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  111361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  111371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111375 */     // MIs[0] rs1
     /*  111375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111387 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111392 */     GIR_RootConstrainSelectedInstOperands,
     /*  111393 */     // GIR_Coverage, 1030,
     /*  111393 */     GIR_Done,
     /*  111394 */   // Label 2920: @111394
     /*  111394 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(111435), // Rule ID 1032 //
     /*  111399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  111402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  111409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  111412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111416 */     // MIs[0] rs1
     /*  111416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  111420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111428 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  111433 */     GIR_RootConstrainSelectedInstOperands,
     /*  111434 */     // GIR_Coverage, 1032,
     /*  111434 */     GIR_Done,
     /*  111435 */   // Label 2921: @111435
     /*  111435 */   GIM_Reject,
     /*  111436 */ // Label 2891: @111436
     /*  111436 */ GIM_Reject,
     /*  111437 */ // Label 2889: @111437
     /*  111437 */ GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(113086),
     /*  111442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  111445 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(111486), // Rule ID 485 //
     /*  111450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  111453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  111463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111467 */     // MIs[0] rs1
     /*  111467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111479 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111484 */     GIR_RootConstrainSelectedInstOperands,
     /*  111485 */     // GIR_Coverage, 485,
     /*  111485 */     GIR_Done,
     /*  111486 */   // Label 2923: @111486
     /*  111486 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(111527), // Rule ID 487 //
     /*  111491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  111494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111501 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  111504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111508 */     // MIs[0] rs1
     /*  111508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111520 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  111525 */     GIR_RootConstrainSelectedInstOperands,
     /*  111526 */     // GIR_Coverage, 487,
     /*  111526 */     GIR_Done,
     /*  111527 */   // Label 2924: @111527
     /*  111527 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(111568), // Rule ID 489 //
     /*  111532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  111535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  111545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111549 */     // MIs[0] rs1
     /*  111549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111561 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  111566 */     GIR_RootConstrainSelectedInstOperands,
     /*  111567 */     // GIR_Coverage, 489,
     /*  111567 */     GIR_Done,
     /*  111568 */   // Label 2925: @111568
     /*  111568 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(111609), // Rule ID 491 //
     /*  111573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  111576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  111586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111590 */     // MIs[0] rs1
     /*  111590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111602 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  111607 */     GIR_RootConstrainSelectedInstOperands,
     /*  111608 */     // GIR_Coverage, 491,
     /*  111608 */     GIR_Done,
     /*  111609 */   // Label 2926: @111609
     /*  111609 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(111650), // Rule ID 493 //
     /*  111614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  111617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  111627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111631 */     // MIs[0] rs1
     /*  111631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111643 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  111648 */     GIR_RootConstrainSelectedInstOperands,
     /*  111649 */     // GIR_Coverage, 493,
     /*  111649 */     GIR_Done,
     /*  111650 */   // Label 2927: @111650
     /*  111650 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(111691), // Rule ID 495 //
     /*  111655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  111658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  111668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111672 */     // MIs[0] rs1
     /*  111672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111684 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111689 */     GIR_RootConstrainSelectedInstOperands,
     /*  111690 */     // GIR_Coverage, 495,
     /*  111690 */     GIR_Done,
     /*  111691 */   // Label 2928: @111691
     /*  111691 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(111732), // Rule ID 497 //
     /*  111696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  111699 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  111709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111713 */     // MIs[0] rs1
     /*  111713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111725 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111730 */     GIR_RootConstrainSelectedInstOperands,
     /*  111731 */     // GIR_Coverage, 497,
     /*  111731 */     GIR_Done,
     /*  111732 */   // Label 2929: @111732
     /*  111732 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(111773), // Rule ID 499 //
     /*  111737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  111740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  111750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111754 */     // MIs[0] rs1
     /*  111754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111766 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111771 */     GIR_RootConstrainSelectedInstOperands,
     /*  111772 */     // GIR_Coverage, 499,
     /*  111772 */     GIR_Done,
     /*  111773 */   // Label 2930: @111773
     /*  111773 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(111814), // Rule ID 501 //
     /*  111778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  111781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  111791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111795 */     // MIs[0] rs1
     /*  111795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111807 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111812 */     GIR_RootConstrainSelectedInstOperands,
     /*  111813 */     // GIR_Coverage, 501,
     /*  111813 */     GIR_Done,
     /*  111814 */   // Label 2931: @111814
     /*  111814 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(111855), // Rule ID 503 //
     /*  111819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  111822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  111829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  111832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111836 */     // MIs[0] rs1
     /*  111836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111848 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  111853 */     GIR_RootConstrainSelectedInstOperands,
     /*  111854 */     // GIR_Coverage, 503,
     /*  111854 */     GIR_Done,
     /*  111855 */   // Label 2932: @111855
     /*  111855 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(111896), // Rule ID 585 //
     /*  111860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  111863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  111870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  111873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111877 */     // MIs[0] rs1
     /*  111877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111889 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  111894 */     GIR_RootConstrainSelectedInstOperands,
     /*  111895 */     // GIR_Coverage, 585,
     /*  111895 */     GIR_Done,
     /*  111896 */   // Label 2933: @111896
     /*  111896 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(111937), // Rule ID 586 //
     /*  111901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  111904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  111911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  111914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111918 */     // MIs[0] rs1
     /*  111918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111930 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  111935 */     GIR_RootConstrainSelectedInstOperands,
     /*  111936 */     // GIR_Coverage, 586,
     /*  111936 */     GIR_Done,
     /*  111937 */   // Label 2934: @111937
     /*  111937 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(111978), // Rule ID 587 //
     /*  111942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  111945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  111952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  111955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111959 */     // MIs[0] rs1
     /*  111959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  111963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111971 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  111976 */     GIR_RootConstrainSelectedInstOperands,
     /*  111977 */     // GIR_Coverage, 587,
     /*  111977 */     GIR_Done,
     /*  111978 */   // Label 2935: @111978
     /*  111978 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(112019), // Rule ID 588 //
     /*  111983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  111986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  111993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  111996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112000 */     // MIs[0] rs1
     /*  112000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112012 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  112017 */     GIR_RootConstrainSelectedInstOperands,
     /*  112018 */     // GIR_Coverage, 588,
     /*  112018 */     GIR_Done,
     /*  112019 */   // Label 2936: @112019
     /*  112019 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(112060), // Rule ID 589 //
     /*  112024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  112027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  112037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112041 */     // MIs[0] rs1
     /*  112041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112053 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  112058 */     GIR_RootConstrainSelectedInstOperands,
     /*  112059 */     // GIR_Coverage, 589,
     /*  112059 */     GIR_Done,
     /*  112060 */   // Label 2937: @112060
     /*  112060 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(112101), // Rule ID 590 //
     /*  112065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  112068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  112078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112082 */     // MIs[0] rs1
     /*  112082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112094 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  112099 */     GIR_RootConstrainSelectedInstOperands,
     /*  112100 */     // GIR_Coverage, 590,
     /*  112100 */     GIR_Done,
     /*  112101 */   // Label 2938: @112101
     /*  112101 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(112142), // Rule ID 591 //
     /*  112106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  112109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  112119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112123 */     // MIs[0] rs1
     /*  112123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112135 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  112140 */     GIR_RootConstrainSelectedInstOperands,
     /*  112141 */     // GIR_Coverage, 591,
     /*  112141 */     GIR_Done,
     /*  112142 */   // Label 2939: @112142
     /*  112142 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(112183), // Rule ID 592 //
     /*  112147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  112150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  112160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112164 */     // MIs[0] rs1
     /*  112164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112176 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  112181 */     GIR_RootConstrainSelectedInstOperands,
     /*  112182 */     // GIR_Coverage, 592,
     /*  112182 */     GIR_Done,
     /*  112183 */   // Label 2940: @112183
     /*  112183 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(112224), // Rule ID 593 //
     /*  112188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  112191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  112201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112205 */     // MIs[0] rs1
     /*  112205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112217 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  112222 */     GIR_RootConstrainSelectedInstOperands,
     /*  112223 */     // GIR_Coverage, 593,
     /*  112223 */     GIR_Done,
     /*  112224 */   // Label 2941: @112224
     /*  112224 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(112265), // Rule ID 594 //
     /*  112229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  112232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  112239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  112242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112246 */     // MIs[0] rs1
     /*  112246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112258 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  112263 */     GIR_RootConstrainSelectedInstOperands,
     /*  112264 */     // GIR_Coverage, 594,
     /*  112264 */     GIR_Done,
     /*  112265 */   // Label 2942: @112265
     /*  112265 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(112306), // Rule ID 833 //
     /*  112270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  112283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112287 */     // MIs[0] rs1
     /*  112287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112299 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112304 */     GIR_RootConstrainSelectedInstOperands,
     /*  112305 */     // GIR_Coverage, 833,
     /*  112305 */     GIR_Done,
     /*  112306 */   // Label 2943: @112306
     /*  112306 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(112347), // Rule ID 835 //
     /*  112311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112314 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112321 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  112324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112328 */     // MIs[0] rs1
     /*  112328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112340 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  112345 */     GIR_RootConstrainSelectedInstOperands,
     /*  112346 */     // GIR_Coverage, 835,
     /*  112346 */     GIR_Done,
     /*  112347 */   // Label 2944: @112347
     /*  112347 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(112388), // Rule ID 837 //
     /*  112352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  112365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112369 */     // MIs[0] rs1
     /*  112369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112381 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  112386 */     GIR_RootConstrainSelectedInstOperands,
     /*  112387 */     // GIR_Coverage, 837,
     /*  112387 */     GIR_Done,
     /*  112388 */   // Label 2945: @112388
     /*  112388 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(112429), // Rule ID 839 //
     /*  112393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  112406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112410 */     // MIs[0] rs1
     /*  112410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112422 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  112427 */     GIR_RootConstrainSelectedInstOperands,
     /*  112428 */     // GIR_Coverage, 839,
     /*  112428 */     GIR_Done,
     /*  112429 */   // Label 2946: @112429
     /*  112429 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(112470), // Rule ID 841 //
     /*  112434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  112447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112451 */     // MIs[0] rs1
     /*  112451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112463 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  112468 */     GIR_RootConstrainSelectedInstOperands,
     /*  112469 */     // GIR_Coverage, 841,
     /*  112469 */     GIR_Done,
     /*  112470 */   // Label 2947: @112470
     /*  112470 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(112511), // Rule ID 843 //
     /*  112475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  112488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112492 */     // MIs[0] rs1
     /*  112492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112504 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112509 */     GIR_RootConstrainSelectedInstOperands,
     /*  112510 */     // GIR_Coverage, 843,
     /*  112510 */     GIR_Done,
     /*  112511 */   // Label 2948: @112511
     /*  112511 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(112552), // Rule ID 845 //
     /*  112516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112519 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112526 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  112529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112533 */     // MIs[0] rs1
     /*  112533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112545 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112550 */     GIR_RootConstrainSelectedInstOperands,
     /*  112551 */     // GIR_Coverage, 845,
     /*  112551 */     GIR_Done,
     /*  112552 */   // Label 2949: @112552
     /*  112552 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(112593), // Rule ID 847 //
     /*  112557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112560 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  112570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112574 */     // MIs[0] rs1
     /*  112574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112586 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112591 */     GIR_RootConstrainSelectedInstOperands,
     /*  112592 */     // GIR_Coverage, 847,
     /*  112592 */     GIR_Done,
     /*  112593 */   // Label 2950: @112593
     /*  112593 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(112634), // Rule ID 849 //
     /*  112598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112601 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  112611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112615 */     // MIs[0] rs1
     /*  112615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112627 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112632 */     GIR_RootConstrainSelectedInstOperands,
     /*  112633 */     // GIR_Coverage, 849,
     /*  112633 */     GIR_Done,
     /*  112634 */   // Label 2951: @112634
     /*  112634 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(112675), // Rule ID 851 //
     /*  112639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112642 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  112649 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  112652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112656 */     // MIs[0] rs1
     /*  112656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112668 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  112673 */     GIR_RootConstrainSelectedInstOperands,
     /*  112674 */     // GIR_Coverage, 851,
     /*  112674 */     GIR_Done,
     /*  112675 */   // Label 2952: @112675
     /*  112675 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(112716), // Rule ID 1013 //
     /*  112680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112683 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  112693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112697 */     // MIs[0] rs1
     /*  112697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112709 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  112714 */     GIR_RootConstrainSelectedInstOperands,
     /*  112715 */     // GIR_Coverage, 1013,
     /*  112715 */     GIR_Done,
     /*  112716 */   // Label 2953: @112716
     /*  112716 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(112757), // Rule ID 1015 //
     /*  112721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  112734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112738 */     // MIs[0] rs1
     /*  112738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112750 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  112755 */     GIR_RootConstrainSelectedInstOperands,
     /*  112756 */     // GIR_Coverage, 1015,
     /*  112756 */     GIR_Done,
     /*  112757 */   // Label 2954: @112757
     /*  112757 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(112798), // Rule ID 1017 //
     /*  112762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  112775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112779 */     // MIs[0] rs1
     /*  112779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112791 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  112796 */     GIR_RootConstrainSelectedInstOperands,
     /*  112797 */     // GIR_Coverage, 1017,
     /*  112797 */     GIR_Done,
     /*  112798 */   // Label 2955: @112798
     /*  112798 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(112839), // Rule ID 1019 //
     /*  112803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112813 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  112816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112820 */     // MIs[0] rs1
     /*  112820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112832 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  112837 */     GIR_RootConstrainSelectedInstOperands,
     /*  112838 */     // GIR_Coverage, 1019,
     /*  112838 */     GIR_Done,
     /*  112839 */   // Label 2956: @112839
     /*  112839 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(112880), // Rule ID 1021 //
     /*  112844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  112847 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112854 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  112857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112861 */     // MIs[0] rs1
     /*  112861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112873 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  112878 */     GIR_RootConstrainSelectedInstOperands,
     /*  112879 */     // GIR_Coverage, 1021,
     /*  112879 */     GIR_Done,
     /*  112880 */   // Label 2957: @112880
     /*  112880 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(112921), // Rule ID 1023 //
     /*  112885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  112898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112902 */     // MIs[0] rs1
     /*  112902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112914 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  112919 */     GIR_RootConstrainSelectedInstOperands,
     /*  112920 */     // GIR_Coverage, 1023,
     /*  112920 */     GIR_Done,
     /*  112921 */   // Label 2958: @112921
     /*  112921 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(112962), // Rule ID 1025 //
     /*  112926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  112939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112943 */     // MIs[0] rs1
     /*  112943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112955 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  112960 */     GIR_RootConstrainSelectedInstOperands,
     /*  112961 */     // GIR_Coverage, 1025,
     /*  112961 */     GIR_Done,
     /*  112962 */   // Label 2959: @112962
     /*  112962 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(113003), // Rule ID 1027 //
     /*  112967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  112970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  112977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  112980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112984 */     // MIs[0] rs1
     /*  112984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  112988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112996 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  112996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  113001 */     GIR_RootConstrainSelectedInstOperands,
     /*  113002 */     // GIR_Coverage, 1027,
     /*  113002 */     GIR_Done,
     /*  113003 */   // Label 2960: @113003
     /*  113003 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(113044), // Rule ID 1029 //
     /*  113008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  113011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  113018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  113021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113025 */     // MIs[0] rs1
     /*  113025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  113029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113037 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  113042 */     GIR_RootConstrainSelectedInstOperands,
     /*  113043 */     // GIR_Coverage, 1029,
     /*  113043 */     GIR_Done,
     /*  113044 */   // Label 2961: @113044
     /*  113044 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(113085), // Rule ID 1031 //
     /*  113049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  113052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  113059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  113062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113066 */     // MIs[0] rs1
     /*  113066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  113070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113078 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  113083 */     GIR_RootConstrainSelectedInstOperands,
     /*  113084 */     // GIR_Coverage, 1031,
     /*  113084 */     GIR_Done,
     /*  113085 */   // Label 2962: @113085
     /*  113085 */   GIM_Reject,
     /*  113086 */ // Label 2922: @113086
     /*  113086 */ GIM_Reject,
     /*  113087 */ // Label 2890: @113087
     /*  113087 */ GIM_Reject,
     /*  113088 */ // Label 36: @113088
     /*  113088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2965*/ GIMT_Encode4(113305),
     /*  113099 */ /*GILLT_s32*//*Label 2963*/ GIMT_Encode4(113107),
     /*  113103 */ /*GILLT_s64*//*Label 2964*/ GIMT_Encode4(113206),
     /*  113107 */ // Label 2963: @113107
     /*  113107 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(113133), // Rule ID 245 //
     /*  113112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113115 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  113119 */   // MIs[0] Operand 1
     /*  113119 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113122 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  113122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  113128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113131 */   GIR_RootConstrainSelectedInstOperands,
     /*  113132 */   // GIR_Coverage, 245,
     /*  113132 */   GIR_EraseRootFromParent_Done,
     /*  113133 */ // Label 2966: @113133
     /*  113133 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(113159), // Rule ID 247 //
     /*  113138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113141 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  113145 */   // MIs[0] Operand 1
     /*  113145 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113148 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  113148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  113157 */   GIR_RootConstrainSelectedInstOperands,
     /*  113158 */   // GIR_Coverage, 247,
     /*  113158 */   GIR_EraseRootFromParent_Done,
     /*  113159 */ // Label 2967: @113159
     /*  113159 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(113179), // Rule ID 249 //
     /*  113164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113167 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  113171 */   // MIs[0] Operand 1
     /*  113171 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113174 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  113174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  113177 */   GIR_RootConstrainSelectedInstOperands,
     /*  113178 */   // GIR_Coverage, 249,
     /*  113178 */   GIR_EraseRootFromParent_Done,
     /*  113179 */ // Label 2968: @113179
     /*  113179 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(113205), // Rule ID 251 //
     /*  113184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113187 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  113191 */   // MIs[0] Operand 1
     /*  113191 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113194 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113203 */   GIR_RootConstrainSelectedInstOperands,
     /*  113204 */   // GIR_Coverage, 251,
     /*  113204 */   GIR_EraseRootFromParent_Done,
     /*  113205 */ // Label 2969: @113205
     /*  113205 */ GIM_Reject,
     /*  113206 */ // Label 2964: @113206
     /*  113206 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(113232), // Rule ID 244 //
     /*  113211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113214 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  113218 */   // MIs[0] Operand 1
     /*  113218 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113221 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  113221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  113227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113230 */   GIR_RootConstrainSelectedInstOperands,
     /*  113231 */   // GIR_Coverage, 244,
     /*  113231 */   GIR_EraseRootFromParent_Done,
     /*  113232 */ // Label 2970: @113232
     /*  113232 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(113258), // Rule ID 246 //
     /*  113237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113240 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  113244 */   // MIs[0] Operand 1
     /*  113244 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113247 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  113247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  113256 */   GIR_RootConstrainSelectedInstOperands,
     /*  113257 */   // GIR_Coverage, 246,
     /*  113257 */   GIR_EraseRootFromParent_Done,
     /*  113258 */ // Label 2971: @113258
     /*  113258 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(113278), // Rule ID 248 //
     /*  113263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113266 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  113270 */   // MIs[0] Operand 1
     /*  113270 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113273 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  113273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  113276 */   GIR_RootConstrainSelectedInstOperands,
     /*  113277 */   // GIR_Coverage, 248,
     /*  113277 */   GIR_EraseRootFromParent_Done,
     /*  113278 */ // Label 2972: @113278
     /*  113278 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(113304), // Rule ID 250 //
     /*  113283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113286 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  113290 */   // MIs[0] Operand 1
     /*  113290 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  113293 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  113296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113302 */   GIR_RootConstrainSelectedInstOperands,
     /*  113303 */   // GIR_Coverage, 250,
     /*  113303 */   GIR_EraseRootFromParent_Done,
     /*  113304 */ // Label 2973: @113304
     /*  113304 */ GIM_Reject,
     /*  113305 */ // Label 2965: @113305
     /*  113305 */ GIM_Reject,
     /*  113306 */ // Label 37: @113306
     /*  113306 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(114791),
     /*  113311 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  113314 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(113359), // Rule ID 2572 //
     /*  113319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  113330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  113347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113357 */     GIR_RootConstrainSelectedInstOperands,
     /*  113358 */     // GIR_Coverage, 2572,
     /*  113358 */     GIR_EraseRootFromParent_Done,
     /*  113359 */   // Label 2975: @113359
     /*  113359 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(113404), // Rule ID 2573 //
     /*  113364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  113375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113389 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  113392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113402 */     GIR_RootConstrainSelectedInstOperands,
     /*  113403 */     // GIR_Coverage, 2573,
     /*  113403 */     GIR_EraseRootFromParent_Done,
     /*  113404 */   // Label 2976: @113404
     /*  113404 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(113449), // Rule ID 23114 //
     /*  113409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  113420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  113437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113447 */     GIR_RootConstrainSelectedInstOperands,
     /*  113448 */     // GIR_Coverage, 23114,
     /*  113448 */     GIR_EraseRootFromParent_Done,
     /*  113449 */   // Label 2977: @113449
     /*  113449 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(113494), // Rule ID 23115 //
     /*  113454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  113465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113479 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  113482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113492 */     GIR_RootConstrainSelectedInstOperands,
     /*  113493 */     // GIR_Coverage, 23115,
     /*  113493 */     GIR_EraseRootFromParent_Done,
     /*  113494 */   // Label 2978: @113494
     /*  113494 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(113539), // Rule ID 23116 //
     /*  113499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  113510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  113527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113537 */     GIR_RootConstrainSelectedInstOperands,
     /*  113538 */     // GIR_Coverage, 23116,
     /*  113538 */     GIR_EraseRootFromParent_Done,
     /*  113539 */   // Label 2979: @113539
     /*  113539 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(113584), // Rule ID 23117 //
     /*  113544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  113555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113569 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  113572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113582 */     GIR_RootConstrainSelectedInstOperands,
     /*  113583 */     // GIR_Coverage, 23117,
     /*  113583 */     GIR_EraseRootFromParent_Done,
     /*  113584 */   // Label 2980: @113584
     /*  113584 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(113629), // Rule ID 23118 //
     /*  113589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  113600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  113617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113627 */     GIR_RootConstrainSelectedInstOperands,
     /*  113628 */     // GIR_Coverage, 23118,
     /*  113628 */     GIR_EraseRootFromParent_Done,
     /*  113629 */   // Label 2981: @113629
     /*  113629 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(113674), // Rule ID 23119 //
     /*  113634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  113645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  113662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113672 */     GIR_RootConstrainSelectedInstOperands,
     /*  113673 */     // GIR_Coverage, 23119,
     /*  113673 */     GIR_EraseRootFromParent_Done,
     /*  113674 */   // Label 2982: @113674
     /*  113674 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(113719), // Rule ID 23120 //
     /*  113679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  113690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  113707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113717 */     GIR_RootConstrainSelectedInstOperands,
     /*  113718 */     // GIR_Coverage, 23120,
     /*  113718 */     GIR_EraseRootFromParent_Done,
     /*  113719 */   // Label 2983: @113719
     /*  113719 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(113764), // Rule ID 23121 //
     /*  113724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  113735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  113752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113762 */     GIR_RootConstrainSelectedInstOperands,
     /*  113763 */     // GIR_Coverage, 23121,
     /*  113763 */     GIR_EraseRootFromParent_Done,
     /*  113764 */   // Label 2984: @113764
     /*  113764 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(113809), // Rule ID 23122 //
     /*  113769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  113780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113794 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  113797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113807 */     GIR_RootConstrainSelectedInstOperands,
     /*  113808 */     // GIR_Coverage, 23122,
     /*  113808 */     GIR_EraseRootFromParent_Done,
     /*  113809 */   // Label 2985: @113809
     /*  113809 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(113854), // Rule ID 23123 //
     /*  113814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  113825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113839 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  113842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113852 */     GIR_RootConstrainSelectedInstOperands,
     /*  113853 */     // GIR_Coverage, 23123,
     /*  113853 */     GIR_EraseRootFromParent_Done,
     /*  113854 */   // Label 2986: @113854
     /*  113854 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(113899), // Rule ID 23124 //
     /*  113859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  113870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113884 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  113887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113897 */     GIR_RootConstrainSelectedInstOperands,
     /*  113898 */     // GIR_Coverage, 23124,
     /*  113898 */     GIR_EraseRootFromParent_Done,
     /*  113899 */   // Label 2987: @113899
     /*  113899 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(113944), // Rule ID 23125 //
     /*  113904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  113912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  113915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113929 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11109:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  113929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  113932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113942 */     GIR_RootConstrainSelectedInstOperands,
     /*  113943 */     // GIR_Coverage, 23125,
     /*  113943 */     GIR_EraseRootFromParent_Done,
     /*  113944 */   // Label 2988: @113944
     /*  113944 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(113989), // Rule ID 23126 //
     /*  113949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  113952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  113957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  113960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  113974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  113974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  113977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  113984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  113987 */     GIR_RootConstrainSelectedInstOperands,
     /*  113988 */     // GIR_Coverage, 23126,
     /*  113988 */     GIR_EraseRootFromParent_Done,
     /*  113989 */   // Label 2989: @113989
     /*  113989 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(114034), // Rule ID 23127 //
     /*  113994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  113997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  114005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114019 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  114022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114032 */     GIR_RootConstrainSelectedInstOperands,
     /*  114033 */     // GIR_Coverage, 23127,
     /*  114033 */     GIR_EraseRootFromParent_Done,
     /*  114034 */   // Label 2990: @114034
     /*  114034 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(114079), // Rule ID 23128 //
     /*  114039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  114050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  114067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114077 */     GIR_RootConstrainSelectedInstOperands,
     /*  114078 */     // GIR_Coverage, 23128,
     /*  114078 */     GIR_EraseRootFromParent_Done,
     /*  114079 */   // Label 2991: @114079
     /*  114079 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(114124), // Rule ID 23129 //
     /*  114084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  114095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114109 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  114112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114122 */     GIR_RootConstrainSelectedInstOperands,
     /*  114123 */     // GIR_Coverage, 23129,
     /*  114123 */     GIR_EraseRootFromParent_Done,
     /*  114124 */   // Label 2992: @114124
     /*  114124 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(114169), // Rule ID 23130 //
     /*  114129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  114140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  114157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114167 */     GIR_RootConstrainSelectedInstOperands,
     /*  114168 */     // GIR_Coverage, 23130,
     /*  114168 */     GIR_EraseRootFromParent_Done,
     /*  114169 */   // Label 2993: @114169
     /*  114169 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(114214), // Rule ID 23131 //
     /*  114174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  114185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114199 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  114202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114212 */     GIR_RootConstrainSelectedInstOperands,
     /*  114213 */     // GIR_Coverage, 23131,
     /*  114213 */     GIR_EraseRootFromParent_Done,
     /*  114214 */   // Label 2994: @114214
     /*  114214 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(114259), // Rule ID 23132 //
     /*  114219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  114230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  114247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114257 */     GIR_RootConstrainSelectedInstOperands,
     /*  114258 */     // GIR_Coverage, 23132,
     /*  114258 */     GIR_EraseRootFromParent_Done,
     /*  114259 */   // Label 2995: @114259
     /*  114259 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(114304), // Rule ID 23133 //
     /*  114264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  114275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114289 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  114292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114302 */     GIR_RootConstrainSelectedInstOperands,
     /*  114303 */     // GIR_Coverage, 23133,
     /*  114303 */     GIR_EraseRootFromParent_Done,
     /*  114304 */   // Label 2996: @114304
     /*  114304 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(114349), // Rule ID 23134 //
     /*  114309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  114320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114334 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  114337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114347 */     GIR_RootConstrainSelectedInstOperands,
     /*  114348 */     // GIR_Coverage, 23134,
     /*  114348 */     GIR_EraseRootFromParent_Done,
     /*  114349 */   // Label 2997: @114349
     /*  114349 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(114394), // Rule ID 23135 //
     /*  114354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  114365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114379 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  114382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114392 */     GIR_RootConstrainSelectedInstOperands,
     /*  114393 */     // GIR_Coverage, 23135,
     /*  114393 */     GIR_EraseRootFromParent_Done,
     /*  114394 */   // Label 2998: @114394
     /*  114394 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(114439), // Rule ID 23136 //
     /*  114399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  114410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114424 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  114427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114437 */     GIR_RootConstrainSelectedInstOperands,
     /*  114438 */     // GIR_Coverage, 23136,
     /*  114438 */     GIR_EraseRootFromParent_Done,
     /*  114439 */   // Label 2999: @114439
     /*  114439 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(114484), // Rule ID 23137 //
     /*  114444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  114455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114469 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  114472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114482 */     GIR_RootConstrainSelectedInstOperands,
     /*  114483 */     // GIR_Coverage, 23137,
     /*  114483 */     GIR_EraseRootFromParent_Done,
     /*  114484 */   // Label 3000: @114484
     /*  114484 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(114529), // Rule ID 23138 //
     /*  114489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  114500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114514 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  114517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114527 */     GIR_RootConstrainSelectedInstOperands,
     /*  114528 */     // GIR_Coverage, 23138,
     /*  114528 */     GIR_EraseRootFromParent_Done,
     /*  114529 */   // Label 3001: @114529
     /*  114529 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(114574), // Rule ID 23139 //
     /*  114534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  114542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  114545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114559 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11137:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  114562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114572 */     GIR_RootConstrainSelectedInstOperands,
     /*  114573 */     // GIR_Coverage, 23139,
     /*  114573 */     GIR_EraseRootFromParent_Done,
     /*  114574 */   // Label 3002: @114574
     /*  114574 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(114610), // Rule ID 2509 //
     /*  114579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  114582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  114587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114601 */     // (intrinsic_wo_chain:{ *:[i64] } 10668:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  114601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  114604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114608 */     GIR_RootConstrainSelectedInstOperands,
     /*  114609 */     // GIR_Coverage, 2509,
     /*  114609 */     GIR_EraseRootFromParent_Done,
     /*  114610 */   // Label 3003: @114610
     /*  114610 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(114646), // Rule ID 2530 //
     /*  114615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  114618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  114623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114637 */     // (intrinsic_wo_chain:{ *:[i64] } 10804:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  114637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  114640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114644 */     GIR_RootConstrainSelectedInstOperands,
     /*  114645 */     // GIR_Coverage, 2530,
     /*  114645 */     GIR_EraseRootFromParent_Done,
     /*  114646 */   // Label 3004: @114646
     /*  114646 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(114682), // Rule ID 2531 //
     /*  114651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  114654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  114659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114673 */     // (intrinsic_wo_chain:{ *:[i64] } 10807:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  114673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  114676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114680 */     GIR_RootConstrainSelectedInstOperands,
     /*  114681 */     // GIR_Coverage, 2531,
     /*  114681 */     GIR_EraseRootFromParent_Done,
     /*  114682 */   // Label 3005: @114682
     /*  114682 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(114718), // Rule ID 2532 //
     /*  114687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  114690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  114695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114709 */     // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  114709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  114712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114716 */     GIR_RootConstrainSelectedInstOperands,
     /*  114717 */     // GIR_Coverage, 2532,
     /*  114717 */     GIR_EraseRootFromParent_Done,
     /*  114718 */   // Label 3006: @114718
     /*  114718 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(114754), // Rule ID 2533 //
     /*  114723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  114726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  114731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  114737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114745 */     // (intrinsic_wo_chain:{ *:[i64] } 10812:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  114745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  114748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114752 */     GIR_RootConstrainSelectedInstOperands,
     /*  114753 */     // GIR_Coverage, 2533,
     /*  114753 */     GIR_EraseRootFromParent_Done,
     /*  114754 */   // Label 3007: @114754
     /*  114754 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(114790), // Rule ID 63755 //
     /*  114759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  114762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  114767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  114770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114781 */     // (intrinsic_wo_chain:{ *:[i32] } 10688:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  114781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  114784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114788 */     GIR_RootConstrainSelectedInstOperands,
     /*  114789 */     // GIR_Coverage, 63755,
     /*  114789 */     GIR_EraseRootFromParent_Done,
     /*  114790 */   // Label 3008: @114790
     /*  114790 */   GIM_Reject,
     /*  114791 */ // Label 2974: @114791
     /*  114791 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(122079),
     /*  114796 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  114799 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(114853), // Rule ID 2542 //
     /*  114804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  114812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  114815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  114818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  114821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114836 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  114839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114851 */     GIR_RootConstrainSelectedInstOperands,
     /*  114852 */     // GIR_Coverage, 2542,
     /*  114852 */     GIR_EraseRootFromParent_Done,
     /*  114853 */   // Label 3010: @114853
     /*  114853 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(114907), // Rule ID 2543 //
     /*  114858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  114866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  114869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  114872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  114875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114890 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  114893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114905 */     GIR_RootConstrainSelectedInstOperands,
     /*  114906 */     // GIR_Coverage, 2543,
     /*  114906 */     GIR_EraseRootFromParent_Done,
     /*  114907 */   // Label 3011: @114907
     /*  114907 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(114961), // Rule ID 2548 //
     /*  114912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  114915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  114920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  114923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  114926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  114929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  114944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  114947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  114956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  114959 */     GIR_RootConstrainSelectedInstOperands,
     /*  114960 */     // GIR_Coverage, 2548,
     /*  114960 */     GIR_EraseRootFromParent_Done,
     /*  114961 */   // Label 3012: @114961
     /*  114961 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(115015), // Rule ID 2549 //
     /*  114966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  114969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  114974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  114977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  114980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  114983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  114998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  114998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  115001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115013 */     GIR_RootConstrainSelectedInstOperands,
     /*  115014 */     // GIR_Coverage, 2549,
     /*  115014 */     GIR_EraseRootFromParent_Done,
     /*  115015 */   // Label 3013: @115015
     /*  115015 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(115072), // Rule ID 2568 //
     /*  115020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  115028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  115031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  115052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  115055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  115059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115070 */     GIR_RootConstrainSelectedInstOperands,
     /*  115071 */     // GIR_Coverage, 2568,
     /*  115071 */     GIR_EraseRootFromParent_Done,
     /*  115072 */   // Label 3014: @115072
     /*  115072 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(115129), // Rule ID 2569 //
     /*  115077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  115085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  115088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115109 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  115109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  115112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  115116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115127 */     GIR_RootConstrainSelectedInstOperands,
     /*  115128 */     // GIR_Coverage, 2569,
     /*  115128 */     GIR_EraseRootFromParent_Done,
     /*  115129 */   // Label 3015: @115129
     /*  115129 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(115183), // Rule ID 23140 //
     /*  115134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  115148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115166 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  115169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115181 */     GIR_RootConstrainSelectedInstOperands,
     /*  115182 */     // GIR_Coverage, 23140,
     /*  115182 */     GIR_EraseRootFromParent_Done,
     /*  115183 */   // Label 3016: @115183
     /*  115183 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(115237), // Rule ID 23141 //
     /*  115188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  115202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115220 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  115223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115235 */     GIR_RootConstrainSelectedInstOperands,
     /*  115236 */     // GIR_Coverage, 23141,
     /*  115236 */     GIR_EraseRootFromParent_Done,
     /*  115237 */   // Label 3017: @115237
     /*  115237 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(115291), // Rule ID 23144 //
     /*  115242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  115256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115274 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  115277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115289 */     GIR_RootConstrainSelectedInstOperands,
     /*  115290 */     // GIR_Coverage, 23144,
     /*  115290 */     GIR_EraseRootFromParent_Done,
     /*  115291 */   // Label 3018: @115291
     /*  115291 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(115345), // Rule ID 23145 //
     /*  115296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  115310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115328 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  115331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115343 */     GIR_RootConstrainSelectedInstOperands,
     /*  115344 */     // GIR_Coverage, 23145,
     /*  115344 */     GIR_EraseRootFromParent_Done,
     /*  115345 */   // Label 3019: @115345
     /*  115345 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(115399), // Rule ID 23148 //
     /*  115350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  115364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115382 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  115385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115397 */     GIR_RootConstrainSelectedInstOperands,
     /*  115398 */     // GIR_Coverage, 23148,
     /*  115398 */     GIR_EraseRootFromParent_Done,
     /*  115399 */   // Label 3020: @115399
     /*  115399 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(115453), // Rule ID 23149 //
     /*  115404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  115418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115436 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  115439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115451 */     GIR_RootConstrainSelectedInstOperands,
     /*  115452 */     // GIR_Coverage, 23149,
     /*  115452 */     GIR_EraseRootFromParent_Done,
     /*  115453 */   // Label 3021: @115453
     /*  115453 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(115507), // Rule ID 23152 //
     /*  115458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  115472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115490 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  115493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115505 */     GIR_RootConstrainSelectedInstOperands,
     /*  115506 */     // GIR_Coverage, 23152,
     /*  115506 */     GIR_EraseRootFromParent_Done,
     /*  115507 */   // Label 3022: @115507
     /*  115507 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(115561), // Rule ID 23153 //
     /*  115512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  115526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115544 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  115547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115559 */     GIR_RootConstrainSelectedInstOperands,
     /*  115560 */     // GIR_Coverage, 23153,
     /*  115560 */     GIR_EraseRootFromParent_Done,
     /*  115561 */   // Label 3023: @115561
     /*  115561 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(115615), // Rule ID 23156 //
     /*  115566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  115580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115598 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  115601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115613 */     GIR_RootConstrainSelectedInstOperands,
     /*  115614 */     // GIR_Coverage, 23156,
     /*  115614 */     GIR_EraseRootFromParent_Done,
     /*  115615 */   // Label 3024: @115615
     /*  115615 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(115669), // Rule ID 23157 //
     /*  115620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  115634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115652 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  115655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115667 */     GIR_RootConstrainSelectedInstOperands,
     /*  115668 */     // GIR_Coverage, 23157,
     /*  115668 */     GIR_EraseRootFromParent_Done,
     /*  115669 */   // Label 3025: @115669
     /*  115669 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(115723), // Rule ID 23160 //
     /*  115674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  115688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115706 */     // (intrinsic_wo_chain:{ *:[i64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  115709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115721 */     GIR_RootConstrainSelectedInstOperands,
     /*  115722 */     // GIR_Coverage, 23160,
     /*  115722 */     GIR_EraseRootFromParent_Done,
     /*  115723 */   // Label 3026: @115723
     /*  115723 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(115777), // Rule ID 23161 //
     /*  115728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  115736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  115742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115760 */     // (intrinsic_wo_chain:{ *:[i32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  115763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115775 */     GIR_RootConstrainSelectedInstOperands,
     /*  115776 */     // GIR_Coverage, 23161,
     /*  115776 */     GIR_EraseRootFromParent_Done,
     /*  115777 */   // Label 3027: @115777
     /*  115777 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(115831), // Rule ID 23164 //
     /*  115782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  115790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  115796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115814 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  115817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115829 */     GIR_RootConstrainSelectedInstOperands,
     /*  115830 */     // GIR_Coverage, 23164,
     /*  115830 */     GIR_EraseRootFromParent_Done,
     /*  115831 */   // Label 3028: @115831
     /*  115831 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(115885), // Rule ID 23165 //
     /*  115836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  115844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  115850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115868 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  115871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115883 */     GIR_RootConstrainSelectedInstOperands,
     /*  115884 */     // GIR_Coverage, 23165,
     /*  115884 */     GIR_EraseRootFromParent_Done,
     /*  115885 */   // Label 3029: @115885
     /*  115885 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(115939), // Rule ID 23168 //
     /*  115890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  115893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  115898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  115901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  115904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  115907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115922 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  115922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  115925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115937 */     GIR_RootConstrainSelectedInstOperands,
     /*  115938 */     // GIR_Coverage, 23168,
     /*  115938 */     GIR_EraseRootFromParent_Done,
     /*  115939 */   // Label 3030: @115939
     /*  115939 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(115993), // Rule ID 23169 //
     /*  115944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  115952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  115955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  115958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  115961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  115976 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  115976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  115979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  115988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  115991 */     GIR_RootConstrainSelectedInstOperands,
     /*  115992 */     // GIR_Coverage, 23169,
     /*  115992 */     GIR_EraseRootFromParent_Done,
     /*  115993 */   // Label 3031: @115993
     /*  115993 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(116047), // Rule ID 23172 //
     /*  115998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  116009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  116012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116030 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  116033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116045 */     GIR_RootConstrainSelectedInstOperands,
     /*  116046 */     // GIR_Coverage, 23172,
     /*  116046 */     GIR_EraseRootFromParent_Done,
     /*  116047 */   // Label 3032: @116047
     /*  116047 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(116101), // Rule ID 23173 //
     /*  116052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  116063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  116066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116084 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  116087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116099 */     GIR_RootConstrainSelectedInstOperands,
     /*  116100 */     // GIR_Coverage, 23173,
     /*  116100 */     GIR_EraseRootFromParent_Done,
     /*  116101 */   // Label 3033: @116101
     /*  116101 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(116155), // Rule ID 23176 //
     /*  116106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  116117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  116120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116138 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  116141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116153 */     GIR_RootConstrainSelectedInstOperands,
     /*  116154 */     // GIR_Coverage, 23176,
     /*  116154 */     GIR_EraseRootFromParent_Done,
     /*  116155 */   // Label 3034: @116155
     /*  116155 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(116209), // Rule ID 23177 //
     /*  116160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  116171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  116174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116192 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  116195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116207 */     GIR_RootConstrainSelectedInstOperands,
     /*  116208 */     // GIR_Coverage, 23177,
     /*  116208 */     GIR_EraseRootFromParent_Done,
     /*  116209 */   // Label 3035: @116209
     /*  116209 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(116263), // Rule ID 23180 //
     /*  116214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  116225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  116228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116246 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  116249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116261 */     GIR_RootConstrainSelectedInstOperands,
     /*  116262 */     // GIR_Coverage, 23180,
     /*  116262 */     GIR_EraseRootFromParent_Done,
     /*  116263 */   // Label 3036: @116263
     /*  116263 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(116317), // Rule ID 23181 //
     /*  116268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  116279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  116282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116300 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  116303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116315 */     GIR_RootConstrainSelectedInstOperands,
     /*  116316 */     // GIR_Coverage, 23181,
     /*  116316 */     GIR_EraseRootFromParent_Done,
     /*  116317 */   // Label 3037: @116317
     /*  116317 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(116371), // Rule ID 23184 //
     /*  116322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  116333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  116336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116354 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  116357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116369 */     GIR_RootConstrainSelectedInstOperands,
     /*  116370 */     // GIR_Coverage, 23184,
     /*  116370 */     GIR_EraseRootFromParent_Done,
     /*  116371 */   // Label 3038: @116371
     /*  116371 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(116425), // Rule ID 23185 //
     /*  116376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  116387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  116390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116408 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  116411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116423 */     GIR_RootConstrainSelectedInstOperands,
     /*  116424 */     // GIR_Coverage, 23185,
     /*  116424 */     GIR_EraseRootFromParent_Done,
     /*  116425 */   // Label 3039: @116425
     /*  116425 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(116479), // Rule ID 23188 //
     /*  116430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  116441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  116444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116462 */     // (intrinsic_wo_chain:{ *:[i64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  116465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116477 */     GIR_RootConstrainSelectedInstOperands,
     /*  116478 */     // GIR_Coverage, 23188,
     /*  116478 */     GIR_EraseRootFromParent_Done,
     /*  116479 */   // Label 3040: @116479
     /*  116479 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(116533), // Rule ID 23189 //
     /*  116484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  116492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  116495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  116498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116516 */     // (intrinsic_wo_chain:{ *:[i32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  116519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116531 */     GIR_RootConstrainSelectedInstOperands,
     /*  116532 */     // GIR_Coverage, 23189,
     /*  116532 */     GIR_EraseRootFromParent_Done,
     /*  116533 */   // Label 3041: @116533
     /*  116533 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(116587), // Rule ID 23192 //
     /*  116538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  116549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  116552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  116573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116585 */     GIR_RootConstrainSelectedInstOperands,
     /*  116586 */     // GIR_Coverage, 23192,
     /*  116586 */     GIR_EraseRootFromParent_Done,
     /*  116587 */   // Label 3042: @116587
     /*  116587 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(116641), // Rule ID 23193 //
     /*  116592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  116603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  116606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  116627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116639 */     GIR_RootConstrainSelectedInstOperands,
     /*  116640 */     // GIR_Coverage, 23193,
     /*  116640 */     GIR_EraseRootFromParent_Done,
     /*  116641 */   // Label 3043: @116641
     /*  116641 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(116695), // Rule ID 23196 //
     /*  116646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  116657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  116660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  116681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116693 */     GIR_RootConstrainSelectedInstOperands,
     /*  116694 */     // GIR_Coverage, 23196,
     /*  116694 */     GIR_EraseRootFromParent_Done,
     /*  116695 */   // Label 3044: @116695
     /*  116695 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(116749), // Rule ID 23197 //
     /*  116700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  116711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  116714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  116735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116747 */     GIR_RootConstrainSelectedInstOperands,
     /*  116748 */     // GIR_Coverage, 23197,
     /*  116748 */     GIR_EraseRootFromParent_Done,
     /*  116749 */   // Label 3045: @116749
     /*  116749 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(116803), // Rule ID 23200 //
     /*  116754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  116765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  116768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116786 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  116789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116801 */     GIR_RootConstrainSelectedInstOperands,
     /*  116802 */     // GIR_Coverage, 23200,
     /*  116802 */     GIR_EraseRootFromParent_Done,
     /*  116803 */   // Label 3046: @116803
     /*  116803 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(116857), // Rule ID 23201 //
     /*  116808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  116819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  116822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  116843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116855 */     GIR_RootConstrainSelectedInstOperands,
     /*  116856 */     // GIR_Coverage, 23201,
     /*  116856 */     GIR_EraseRootFromParent_Done,
     /*  116857 */   // Label 3047: @116857
     /*  116857 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(116911), // Rule ID 23204 //
     /*  116862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  116873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  116876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116894 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  116894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  116897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116909 */     GIR_RootConstrainSelectedInstOperands,
     /*  116910 */     // GIR_Coverage, 23204,
     /*  116910 */     GIR_EraseRootFromParent_Done,
     /*  116911 */   // Label 3048: @116911
     /*  116911 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(116965), // Rule ID 23205 //
     /*  116916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  116919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  116927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  116930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  116933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  116948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  116948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  116951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  116960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116963 */     GIR_RootConstrainSelectedInstOperands,
     /*  116964 */     // GIR_Coverage, 23205,
     /*  116964 */     GIR_EraseRootFromParent_Done,
     /*  116965 */   // Label 3049: @116965
     /*  116965 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(117019), // Rule ID 23208 //
     /*  116970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  116978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  116981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  116984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  116987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117002 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  117005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117017 */     GIR_RootConstrainSelectedInstOperands,
     /*  117018 */     // GIR_Coverage, 23208,
     /*  117018 */     GIR_EraseRootFromParent_Done,
     /*  117019 */   // Label 3050: @117019
     /*  117019 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(117073), // Rule ID 23209 //
     /*  117024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  117032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  117035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  117038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  117059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117071 */     GIR_RootConstrainSelectedInstOperands,
     /*  117072 */     // GIR_Coverage, 23209,
     /*  117072 */     GIR_EraseRootFromParent_Done,
     /*  117073 */   // Label 3051: @117073
     /*  117073 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(117127), // Rule ID 23212 //
     /*  117078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  117086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  117089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  117092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117110 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  117113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117125 */     GIR_RootConstrainSelectedInstOperands,
     /*  117126 */     // GIR_Coverage, 23212,
     /*  117126 */     GIR_EraseRootFromParent_Done,
     /*  117127 */   // Label 3052: @117127
     /*  117127 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(117181), // Rule ID 23213 //
     /*  117132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  117140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  117143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  117146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117164 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11133:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  117167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117179 */     GIR_RootConstrainSelectedInstOperands,
     /*  117180 */     // GIR_Coverage, 23213,
     /*  117180 */     GIR_EraseRootFromParent_Done,
     /*  117181 */   // Label 3053: @117181
     /*  117181 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(117235), // Rule ID 23216 //
     /*  117186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  117197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  117221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117233 */     GIR_RootConstrainSelectedInstOperands,
     /*  117234 */     // GIR_Coverage, 23216,
     /*  117234 */     GIR_EraseRootFromParent_Done,
     /*  117235 */   // Label 3054: @117235
     /*  117235 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(117289), // Rule ID 23217 //
     /*  117240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  117251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  117275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117287 */     GIR_RootConstrainSelectedInstOperands,
     /*  117288 */     // GIR_Coverage, 23217,
     /*  117288 */     GIR_EraseRootFromParent_Done,
     /*  117289 */   // Label 3055: @117289
     /*  117289 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(117343), // Rule ID 23220 //
     /*  117294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  117305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  117308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  117329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117341 */     GIR_RootConstrainSelectedInstOperands,
     /*  117342 */     // GIR_Coverage, 23220,
     /*  117342 */     GIR_EraseRootFromParent_Done,
     /*  117343 */   // Label 3056: @117343
     /*  117343 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(117397), // Rule ID 23221 //
     /*  117348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  117359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  117362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  117383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117395 */     GIR_RootConstrainSelectedInstOperands,
     /*  117396 */     // GIR_Coverage, 23221,
     /*  117396 */     GIR_EraseRootFromParent_Done,
     /*  117397 */   // Label 3057: @117397
     /*  117397 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(117451), // Rule ID 23224 //
     /*  117402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  117413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  117416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  117437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117449 */     GIR_RootConstrainSelectedInstOperands,
     /*  117450 */     // GIR_Coverage, 23224,
     /*  117450 */     GIR_EraseRootFromParent_Done,
     /*  117451 */   // Label 3058: @117451
     /*  117451 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(117505), // Rule ID 23225 //
     /*  117456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  117467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  117470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  117491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117503 */     GIR_RootConstrainSelectedInstOperands,
     /*  117504 */     // GIR_Coverage, 23225,
     /*  117504 */     GIR_EraseRootFromParent_Done,
     /*  117505 */   // Label 3059: @117505
     /*  117505 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(117559), // Rule ID 23228 //
     /*  117510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  117521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  117524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  117545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117557 */     GIR_RootConstrainSelectedInstOperands,
     /*  117558 */     // GIR_Coverage, 23228,
     /*  117558 */     GIR_EraseRootFromParent_Done,
     /*  117559 */   // Label 3060: @117559
     /*  117559 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(117613), // Rule ID 23229 //
     /*  117564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  117575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  117578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  117599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117611 */     GIR_RootConstrainSelectedInstOperands,
     /*  117612 */     // GIR_Coverage, 23229,
     /*  117612 */     GIR_EraseRootFromParent_Done,
     /*  117613 */   // Label 3061: @117613
     /*  117613 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(117667), // Rule ID 23232 //
     /*  117618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  117629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  117632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  117653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117665 */     GIR_RootConstrainSelectedInstOperands,
     /*  117666 */     // GIR_Coverage, 23232,
     /*  117666 */     GIR_EraseRootFromParent_Done,
     /*  117667 */   // Label 3062: @117667
     /*  117667 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(117721), // Rule ID 23233 //
     /*  117672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  117683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  117686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  117707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117719 */     GIR_RootConstrainSelectedInstOperands,
     /*  117720 */     // GIR_Coverage, 23233,
     /*  117720 */     GIR_EraseRootFromParent_Done,
     /*  117721 */   // Label 3063: @117721
     /*  117721 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(117775), // Rule ID 23236 //
     /*  117726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  117737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  117740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117758 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  117761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117773 */     GIR_RootConstrainSelectedInstOperands,
     /*  117774 */     // GIR_Coverage, 23236,
     /*  117774 */     GIR_EraseRootFromParent_Done,
     /*  117775 */   // Label 3064: @117775
     /*  117775 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(117829), // Rule ID 23237 //
     /*  117780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  117791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  117794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117812 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  117815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117827 */     GIR_RootConstrainSelectedInstOperands,
     /*  117828 */     // GIR_Coverage, 23237,
     /*  117828 */     GIR_EraseRootFromParent_Done,
     /*  117829 */   // Label 3065: @117829
     /*  117829 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(117883), // Rule ID 23240 //
     /*  117834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  117845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  117848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117866 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  117869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117881 */     GIR_RootConstrainSelectedInstOperands,
     /*  117882 */     // GIR_Coverage, 23240,
     /*  117882 */     GIR_EraseRootFromParent_Done,
     /*  117883 */   // Label 3066: @117883
     /*  117883 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(117937), // Rule ID 23241 //
     /*  117888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  117896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  117899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  117902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  117905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117920 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11146:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  117920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  117923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117935 */     GIR_RootConstrainSelectedInstOperands,
     /*  117936 */     // GIR_Coverage, 23241,
     /*  117936 */     GIR_EraseRootFromParent_Done,
     /*  117937 */   // Label 3067: @117937
     /*  117937 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(117991), // Rule ID 23244 //
     /*  117942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  117945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  117950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  117953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  117959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  117974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  117974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  117977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117989 */     GIR_RootConstrainSelectedInstOperands,
     /*  117990 */     // GIR_Coverage, 23244,
     /*  117990 */     GIR_EraseRootFromParent_Done,
     /*  117991 */   // Label 3068: @117991
     /*  117991 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(118045), // Rule ID 23245 //
     /*  117996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  117999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  118007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  118010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  118031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118043 */     GIR_RootConstrainSelectedInstOperands,
     /*  118044 */     // GIR_Coverage, 23245,
     /*  118044 */     GIR_EraseRootFromParent_Done,
     /*  118045 */   // Label 3069: @118045
     /*  118045 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(118099), // Rule ID 23248 //
     /*  118050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  118061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118082 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  118085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118097 */     GIR_RootConstrainSelectedInstOperands,
     /*  118098 */     // GIR_Coverage, 23248,
     /*  118098 */     GIR_EraseRootFromParent_Done,
     /*  118099 */   // Label 3070: @118099
     /*  118099 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(118153), // Rule ID 23249 //
     /*  118104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  118115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  118139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118151 */     GIR_RootConstrainSelectedInstOperands,
     /*  118152 */     // GIR_Coverage, 23249,
     /*  118152 */     GIR_EraseRootFromParent_Done,
     /*  118153 */   // Label 3071: @118153
     /*  118153 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(118207), // Rule ID 23252 //
     /*  118158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  118169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  118172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  118193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118205 */     GIR_RootConstrainSelectedInstOperands,
     /*  118206 */     // GIR_Coverage, 23252,
     /*  118206 */     GIR_EraseRootFromParent_Done,
     /*  118207 */   // Label 3072: @118207
     /*  118207 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(118261), // Rule ID 23253 //
     /*  118212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  118223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  118226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  118247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118259 */     GIR_RootConstrainSelectedInstOperands,
     /*  118260 */     // GIR_Coverage, 23253,
     /*  118260 */     GIR_EraseRootFromParent_Done,
     /*  118261 */   // Label 3073: @118261
     /*  118261 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(118315), // Rule ID 23256 //
     /*  118266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  118277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  118280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  118301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118313 */     GIR_RootConstrainSelectedInstOperands,
     /*  118314 */     // GIR_Coverage, 23256,
     /*  118314 */     GIR_EraseRootFromParent_Done,
     /*  118315 */   // Label 3074: @118315
     /*  118315 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(118369), // Rule ID 23257 //
     /*  118320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  118331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  118334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  118355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118367 */     GIR_RootConstrainSelectedInstOperands,
     /*  118368 */     // GIR_Coverage, 23257,
     /*  118368 */     GIR_EraseRootFromParent_Done,
     /*  118369 */   // Label 3075: @118369
     /*  118369 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(118423), // Rule ID 23260 //
     /*  118374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  118385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  118388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118406 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  118409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118421 */     GIR_RootConstrainSelectedInstOperands,
     /*  118422 */     // GIR_Coverage, 23260,
     /*  118422 */     GIR_EraseRootFromParent_Done,
     /*  118423 */   // Label 3076: @118423
     /*  118423 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(118477), // Rule ID 23261 //
     /*  118428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  118439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  118442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  118463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118475 */     GIR_RootConstrainSelectedInstOperands,
     /*  118476 */     // GIR_Coverage, 23261,
     /*  118476 */     GIR_EraseRootFromParent_Done,
     /*  118477 */   // Label 3077: @118477
     /*  118477 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(118531), // Rule ID 23264 //
     /*  118482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  118493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  118496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118514 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  118517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118529 */     GIR_RootConstrainSelectedInstOperands,
     /*  118530 */     // GIR_Coverage, 23264,
     /*  118530 */     GIR_EraseRootFromParent_Done,
     /*  118531 */   // Label 3078: @118531
     /*  118531 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(118585), // Rule ID 23265 //
     /*  118536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  118547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  118550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118568 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  118571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118583 */     GIR_RootConstrainSelectedInstOperands,
     /*  118584 */     // GIR_Coverage, 23265,
     /*  118584 */     GIR_EraseRootFromParent_Done,
     /*  118585 */   // Label 3079: @118585
     /*  118585 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(118639), // Rule ID 23268 //
     /*  118590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  118593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  118601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  118604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118622 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  118622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  118625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118637 */     GIR_RootConstrainSelectedInstOperands,
     /*  118638 */     // GIR_Coverage, 23268,
     /*  118638 */     GIR_EraseRootFromParent_Done,
     /*  118639 */   // Label 3080: @118639
     /*  118639 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(118693), // Rule ID 23269 //
     /*  118644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  118647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  118652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  118655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  118658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118676 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11158:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  118676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  118679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118691 */     GIR_RootConstrainSelectedInstOperands,
     /*  118692 */     // GIR_Coverage, 23269,
     /*  118692 */     GIR_EraseRootFromParent_Done,
     /*  118693 */   // Label 3081: @118693
     /*  118693 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(118750), // Rule ID 23356 //
     /*  118698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  118709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  118712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  118730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  118733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  118737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118748 */     GIR_RootConstrainSelectedInstOperands,
     /*  118749 */     // GIR_Coverage, 23356,
     /*  118749 */     GIR_EraseRootFromParent_Done,
     /*  118750 */   // Label 3082: @118750
     /*  118750 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(118807), // Rule ID 23357 //
     /*  118755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  118766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  118769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118787 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  118787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  118790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  118794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118805 */     GIR_RootConstrainSelectedInstOperands,
     /*  118806 */     // GIR_Coverage, 23357,
     /*  118806 */     GIR_EraseRootFromParent_Done,
     /*  118807 */   // Label 3083: @118807
     /*  118807 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(118864), // Rule ID 23360 //
     /*  118812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  118823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  118826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  118844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  118847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  118851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118862 */     GIR_RootConstrainSelectedInstOperands,
     /*  118863 */     // GIR_Coverage, 23360,
     /*  118863 */     GIR_EraseRootFromParent_Done,
     /*  118864 */   // Label 3084: @118864
     /*  118864 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(118921), // Rule ID 23361 //
     /*  118869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  118880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  118883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  118886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  118901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  118904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  118908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118919 */     GIR_RootConstrainSelectedInstOperands,
     /*  118920 */     // GIR_Coverage, 23361,
     /*  118920 */     GIR_EraseRootFromParent_Done,
     /*  118921 */   // Label 3085: @118921
     /*  118921 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(118978), // Rule ID 23364 //
     /*  118926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  118937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  118940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  118943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  118958 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  118958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  118961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  118965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  118970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118976 */     GIR_RootConstrainSelectedInstOperands,
     /*  118977 */     // GIR_Coverage, 23364,
     /*  118977 */     GIR_EraseRootFromParent_Done,
     /*  118978 */   // Label 3086: @118978
     /*  118978 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(119035), // Rule ID 23365 //
     /*  118983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  118991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  118994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  118997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  119015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  119018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119033 */     GIR_RootConstrainSelectedInstOperands,
     /*  119034 */     // GIR_Coverage, 23365,
     /*  119034 */     GIR_EraseRootFromParent_Done,
     /*  119035 */   // Label 3087: @119035
     /*  119035 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(119092), // Rule ID 23368 //
     /*  119040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  119051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  119054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  119072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  119075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119090 */     GIR_RootConstrainSelectedInstOperands,
     /*  119091 */     // GIR_Coverage, 23368,
     /*  119091 */     GIR_EraseRootFromParent_Done,
     /*  119092 */   // Label 3088: @119092
     /*  119092 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(119149), // Rule ID 23369 //
     /*  119097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  119108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  119111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119129 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  119129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  119132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119147 */     GIR_RootConstrainSelectedInstOperands,
     /*  119148 */     // GIR_Coverage, 23369,
     /*  119148 */     GIR_EraseRootFromParent_Done,
     /*  119149 */   // Label 3089: @119149
     /*  119149 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(119206), // Rule ID 23372 //
     /*  119154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  119165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  119168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  119186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  119189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119204 */     GIR_RootConstrainSelectedInstOperands,
     /*  119205 */     // GIR_Coverage, 23372,
     /*  119205 */     GIR_EraseRootFromParent_Done,
     /*  119206 */   // Label 3090: @119206
     /*  119206 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(119263), // Rule ID 23373 //
     /*  119211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  119222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  119225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  119243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  119246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119261 */     GIR_RootConstrainSelectedInstOperands,
     /*  119262 */     // GIR_Coverage, 23373,
     /*  119262 */     GIR_EraseRootFromParent_Done,
     /*  119263 */   // Label 3091: @119263
     /*  119263 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(119320), // Rule ID 23376 //
     /*  119268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  119279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  119282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  119300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119318 */     GIR_RootConstrainSelectedInstOperands,
     /*  119319 */     // GIR_Coverage, 23376,
     /*  119319 */     GIR_EraseRootFromParent_Done,
     /*  119320 */   // Label 3092: @119320
     /*  119320 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(119377), // Rule ID 23377 //
     /*  119325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  119336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  119339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119357 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11012:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  119357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119375 */     GIR_RootConstrainSelectedInstOperands,
     /*  119376 */     // GIR_Coverage, 23377,
     /*  119376 */     GIR_EraseRootFromParent_Done,
     /*  119377 */   // Label 3093: @119377
     /*  119377 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(119434), // Rule ID 23380 //
     /*  119382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  119393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  119396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  119414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119432 */     GIR_RootConstrainSelectedInstOperands,
     /*  119433 */     // GIR_Coverage, 23380,
     /*  119433 */     GIR_EraseRootFromParent_Done,
     /*  119434 */   // Label 3094: @119434
     /*  119434 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(119491), // Rule ID 23381 //
     /*  119439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  119450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  119453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119471 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  119471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119489 */     GIR_RootConstrainSelectedInstOperands,
     /*  119490 */     // GIR_Coverage, 23381,
     /*  119490 */     GIR_EraseRootFromParent_Done,
     /*  119491 */   // Label 3095: @119491
     /*  119491 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(119548), // Rule ID 23384 //
     /*  119496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  119507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  119510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  119528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119546 */     GIR_RootConstrainSelectedInstOperands,
     /*  119547 */     // GIR_Coverage, 23384,
     /*  119547 */     GIR_EraseRootFromParent_Done,
     /*  119548 */   // Label 3096: @119548
     /*  119548 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(119605), // Rule ID 23385 //
     /*  119553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  119564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  119567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119585 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  119585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119603 */     GIR_RootConstrainSelectedInstOperands,
     /*  119604 */     // GIR_Coverage, 23385,
     /*  119604 */     GIR_EraseRootFromParent_Done,
     /*  119605 */   // Label 3097: @119605
     /*  119605 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(119662), // Rule ID 23388 //
     /*  119610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  119613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  119621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  119624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  119642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119660 */     GIR_RootConstrainSelectedInstOperands,
     /*  119661 */     // GIR_Coverage, 23388,
     /*  119661 */     GIR_EraseRootFromParent_Done,
     /*  119662 */   // Label 3098: @119662
     /*  119662 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(119719), // Rule ID 23389 //
     /*  119667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  119670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  119678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  119681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  119699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  119702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119717 */     GIR_RootConstrainSelectedInstOperands,
     /*  119718 */     // GIR_Coverage, 23389,
     /*  119718 */     GIR_EraseRootFromParent_Done,
     /*  119719 */   // Label 3099: @119719
     /*  119719 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(119776), // Rule ID 23392 //
     /*  119724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  119735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  119738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  119756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  119759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119774 */     GIR_RootConstrainSelectedInstOperands,
     /*  119775 */     // GIR_Coverage, 23392,
     /*  119775 */     GIR_EraseRootFromParent_Done,
     /*  119776 */   // Label 3100: @119776
     /*  119776 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(119833), // Rule ID 23393 //
     /*  119781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  119792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  119795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119813 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  119813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  119816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119831 */     GIR_RootConstrainSelectedInstOperands,
     /*  119832 */     // GIR_Coverage, 23393,
     /*  119832 */     GIR_EraseRootFromParent_Done,
     /*  119833 */   // Label 3101: @119833
     /*  119833 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(119890), // Rule ID 23396 //
     /*  119838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  119849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  119852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  119870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  119873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119888 */     GIR_RootConstrainSelectedInstOperands,
     /*  119889 */     // GIR_Coverage, 23396,
     /*  119889 */     GIR_EraseRootFromParent_Done,
     /*  119890 */   // Label 3102: @119890
     /*  119890 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(119947), // Rule ID 23397 //
     /*  119895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  119906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  119909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  119912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119927 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  119927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  119930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119945 */     GIR_RootConstrainSelectedInstOperands,
     /*  119946 */     // GIR_Coverage, 23397,
     /*  119946 */     GIR_EraseRootFromParent_Done,
     /*  119947 */   // Label 3103: @119947
     /*  119947 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(120004), // Rule ID 23400 //
     /*  119952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  119960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  119963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  119966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  119969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  119973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  119977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  119984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  119984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  119987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  119991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  119996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120002 */     GIR_RootConstrainSelectedInstOperands,
     /*  120003 */     // GIR_Coverage, 23400,
     /*  120003 */     GIR_EraseRootFromParent_Done,
     /*  120004 */   // Label 3104: @120004
     /*  120004 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(120061), // Rule ID 23401 //
     /*  120009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  120020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  120023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120041 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  120041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  120044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120059 */     GIR_RootConstrainSelectedInstOperands,
     /*  120060 */     // GIR_Coverage, 23401,
     /*  120060 */     GIR_EraseRootFromParent_Done,
     /*  120061 */   // Label 3105: @120061
     /*  120061 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(120118), // Rule ID 23404 //
     /*  120066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  120077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  120080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  120098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120116 */     GIR_RootConstrainSelectedInstOperands,
     /*  120117 */     // GIR_Coverage, 23404,
     /*  120117 */     GIR_EraseRootFromParent_Done,
     /*  120118 */   // Label 3106: @120118
     /*  120118 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(120175), // Rule ID 23405 //
     /*  120123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  120134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  120137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  120155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120173 */     GIR_RootConstrainSelectedInstOperands,
     /*  120174 */     // GIR_Coverage, 23405,
     /*  120174 */     GIR_EraseRootFromParent_Done,
     /*  120175 */   // Label 3107: @120175
     /*  120175 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(120232), // Rule ID 23408 //
     /*  120180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  120191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  120194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  120212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120230 */     GIR_RootConstrainSelectedInstOperands,
     /*  120231 */     // GIR_Coverage, 23408,
     /*  120231 */     GIR_EraseRootFromParent_Done,
     /*  120232 */   // Label 3108: @120232
     /*  120232 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(120289), // Rule ID 23409 //
     /*  120237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  120248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  120251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  120269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120287 */     GIR_RootConstrainSelectedInstOperands,
     /*  120288 */     // GIR_Coverage, 23409,
     /*  120288 */     GIR_EraseRootFromParent_Done,
     /*  120289 */   // Label 3109: @120289
     /*  120289 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(120346), // Rule ID 23412 //
     /*  120294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  120305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  120308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  120326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  120329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120344 */     GIR_RootConstrainSelectedInstOperands,
     /*  120345 */     // GIR_Coverage, 23412,
     /*  120345 */     GIR_EraseRootFromParent_Done,
     /*  120346 */   // Label 3110: @120346
     /*  120346 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(120403), // Rule ID 23413 //
     /*  120351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  120362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  120365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120383 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  120383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  120386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120401 */     GIR_RootConstrainSelectedInstOperands,
     /*  120402 */     // GIR_Coverage, 23413,
     /*  120402 */     GIR_EraseRootFromParent_Done,
     /*  120403 */   // Label 3111: @120403
     /*  120403 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(120460), // Rule ID 23416 //
     /*  120408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  120419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  120422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  120440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120458 */     GIR_RootConstrainSelectedInstOperands,
     /*  120459 */     // GIR_Coverage, 23416,
     /*  120459 */     GIR_EraseRootFromParent_Done,
     /*  120460 */   // Label 3112: @120460
     /*  120460 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(120517), // Rule ID 23417 //
     /*  120465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  120476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  120479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  120497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120515 */     GIR_RootConstrainSelectedInstOperands,
     /*  120516 */     // GIR_Coverage, 23417,
     /*  120516 */     GIR_EraseRootFromParent_Done,
     /*  120517 */   // Label 3113: @120517
     /*  120517 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(120574), // Rule ID 23420 //
     /*  120522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  120533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  120536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  120554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120572 */     GIR_RootConstrainSelectedInstOperands,
     /*  120573 */     // GIR_Coverage, 23420,
     /*  120573 */     GIR_EraseRootFromParent_Done,
     /*  120574 */   // Label 3114: @120574
     /*  120574 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(120631), // Rule ID 23421 //
     /*  120579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  120590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  120593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  120611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120629 */     GIR_RootConstrainSelectedInstOperands,
     /*  120630 */     // GIR_Coverage, 23421,
     /*  120630 */     GIR_EraseRootFromParent_Done,
     /*  120631 */   // Label 3115: @120631
     /*  120631 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(120688), // Rule ID 23424 //
     /*  120636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  120647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  120650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  120668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  120671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120686 */     GIR_RootConstrainSelectedInstOperands,
     /*  120687 */     // GIR_Coverage, 23424,
     /*  120687 */     GIR_EraseRootFromParent_Done,
     /*  120688 */   // Label 3116: @120688
     /*  120688 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(120745), // Rule ID 23425 //
     /*  120693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  120704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  120707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  120725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  120728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120743 */     GIR_RootConstrainSelectedInstOperands,
     /*  120744 */     // GIR_Coverage, 23425,
     /*  120744 */     GIR_EraseRootFromParent_Done,
     /*  120745 */   // Label 3117: @120745
     /*  120745 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(120802), // Rule ID 23428 //
     /*  120750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  120753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  120761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  120764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  120782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120800 */     GIR_RootConstrainSelectedInstOperands,
     /*  120801 */     // GIR_Coverage, 23428,
     /*  120801 */     GIR_EraseRootFromParent_Done,
     /*  120802 */   // Label 3118: @120802
     /*  120802 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(120859), // Rule ID 23429 //
     /*  120807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  120810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  120818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  120821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  120839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  120842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120857 */     GIR_RootConstrainSelectedInstOperands,
     /*  120858 */     // GIR_Coverage, 23429,
     /*  120858 */     GIR_EraseRootFromParent_Done,
     /*  120859 */   // Label 3119: @120859
     /*  120859 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(120916), // Rule ID 23432 //
     /*  120864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  120867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  120875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  120878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  120896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120914 */     GIR_RootConstrainSelectedInstOperands,
     /*  120915 */     // GIR_Coverage, 23432,
     /*  120915 */     GIR_EraseRootFromParent_Done,
     /*  120916 */   // Label 3120: @120916
     /*  120916 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(120973), // Rule ID 23433 //
     /*  120921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  120924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  120932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  120935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  120938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  120953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  120953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  120956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  120960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  120965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120971 */     GIR_RootConstrainSelectedInstOperands,
     /*  120972 */     // GIR_Coverage, 23433,
     /*  120972 */     GIR_EraseRootFromParent_Done,
     /*  120973 */   // Label 3121: @120973
     /*  120973 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(121030), // Rule ID 23436 //
     /*  120978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  120981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  120986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  120989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  120992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  120995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  120999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  121010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  121010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  121013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  121017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  121022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  121025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121028 */     GIR_RootConstrainSelectedInstOperands,
     /*  121029 */     // GIR_Coverage, 23436,
     /*  121029 */     GIR_EraseRootFromParent_Done,
     /*  121030 */   // Label 3122: @121030
     /*  121030 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(121087), // Rule ID 23437 //
     /*  121035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  121038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  121043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  121046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  121049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  121067 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  121067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  121070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  121074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  121079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  121082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121085 */     GIR_RootConstrainSelectedInstOperands,
     /*  121086 */     // GIR_Coverage, 23437,
     /*  121086 */     GIR_EraseRootFromParent_Done,
     /*  121087 */   // Label 3123: @121087
     /*  121087 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(121133), // Rule ID 2511 //
     /*  121092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  121095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  121100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121114 */     // MIs[0] rnum
     /*  121114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  121117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  121122 */     // (intrinsic_wo_chain:{ *:[i64] } 10669:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  121122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  121125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  121131 */     GIR_RootConstrainSelectedInstOperands,
     /*  121132 */     // GIR_Coverage, 2511,
     /*  121132 */     GIR_EraseRootFromParent_Done,
     /*  121133 */   // Label 3124: @121133
     /*  121133 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(121178), // Rule ID 63763 //
     /*  121138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  121141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  121146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121167 */     // (intrinsic_wo_chain:{ *:[i32] } 10679:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  121170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121176 */     GIR_RootConstrainSelectedInstOperands,
     /*  121177 */     // GIR_Coverage, 63763,
     /*  121177 */     GIR_EraseRootFromParent_Done,
     /*  121178 */   // Label 3125: @121178
     /*  121178 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(121223), // Rule ID 63790 //
     /*  121183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  121186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  121191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121212 */     // (intrinsic_wo_chain:{ *:[i32] } 10680:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  121215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121221 */     GIR_RootConstrainSelectedInstOperands,
     /*  121222 */     // GIR_Coverage, 63790,
     /*  121222 */     GIR_EraseRootFromParent_Done,
     /*  121223 */   // Label 3126: @121223
     /*  121223 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(121268), // Rule ID 2501 //
     /*  121228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  121231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  121236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121257 */     // (intrinsic_wo_chain:{ *:[i64] } 11370:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  121260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121266 */     GIR_RootConstrainSelectedInstOperands,
     /*  121267 */     // GIR_Coverage, 2501,
     /*  121267 */     GIR_EraseRootFromParent_Done,
     /*  121268 */   // Label 3127: @121268
     /*  121268 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(121313), // Rule ID 2502 //
     /*  121273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  121276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  121281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121302 */     // (intrinsic_wo_chain:{ *:[i32] } 11370:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  121305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121311 */     GIR_RootConstrainSelectedInstOperands,
     /*  121312 */     // GIR_Coverage, 2502,
     /*  121312 */     GIR_EraseRootFromParent_Done,
     /*  121313 */   // Label 3128: @121313
     /*  121313 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(121358), // Rule ID 2503 //
     /*  121318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  121321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  121326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121347 */     // (intrinsic_wo_chain:{ *:[i64] } 11371:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  121350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121356 */     GIR_RootConstrainSelectedInstOperands,
     /*  121357 */     // GIR_Coverage, 2503,
     /*  121357 */     GIR_EraseRootFromParent_Done,
     /*  121358 */   // Label 3129: @121358
     /*  121358 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(121403), // Rule ID 2504 //
     /*  121363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  121366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  121371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121392 */     // (intrinsic_wo_chain:{ *:[i32] } 11371:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  121395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121401 */     GIR_RootConstrainSelectedInstOperands,
     /*  121402 */     // GIR_Coverage, 2504,
     /*  121402 */     GIR_EraseRootFromParent_Done,
     /*  121403 */   // Label 3130: @121403
     /*  121403 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(121448), // Rule ID 2507 //
     /*  121408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  121411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  121416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121437 */     // (intrinsic_wo_chain:{ *:[i64] } 10664:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  121440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121446 */     GIR_RootConstrainSelectedInstOperands,
     /*  121447 */     // GIR_Coverage, 2507,
     /*  121447 */     GIR_EraseRootFromParent_Done,
     /*  121448 */   // Label 3131: @121448
     /*  121448 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(121493), // Rule ID 2508 //
     /*  121453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  121456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  121461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121482 */     // (intrinsic_wo_chain:{ *:[i64] } 10665:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  121485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121491 */     GIR_RootConstrainSelectedInstOperands,
     /*  121492 */     // GIR_Coverage, 2508,
     /*  121492 */     GIR_EraseRootFromParent_Done,
     /*  121493 */   // Label 3132: @121493
     /*  121493 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(121538), // Rule ID 2510 //
     /*  121498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  121501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  121506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121527 */     // (intrinsic_wo_chain:{ *:[i64] } 10670:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  121530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121536 */     GIR_RootConstrainSelectedInstOperands,
     /*  121537 */     // GIR_Coverage, 2510,
     /*  121537 */     GIR_EraseRootFromParent_Done,
     /*  121538 */   // Label 3133: @121538
     /*  121538 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(121583), // Rule ID 2514 //
     /*  121543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  121546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  121551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121572 */     // (intrinsic_wo_chain:{ *:[i64] } 10666:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  121575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121581 */     GIR_RootConstrainSelectedInstOperands,
     /*  121582 */     // GIR_Coverage, 2514,
     /*  121582 */     GIR_EraseRootFromParent_Done,
     /*  121583 */   // Label 3134: @121583
     /*  121583 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(121628), // Rule ID 2515 //
     /*  121588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  121591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  121596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  121599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  121602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  121605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121617 */     // (intrinsic_wo_chain:{ *:[i64] } 10667:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  121620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121626 */     GIR_RootConstrainSelectedInstOperands,
     /*  121627 */     // GIR_Coverage, 2515,
     /*  121627 */     GIR_EraseRootFromParent_Done,
     /*  121628 */   // Label 3135: @121628
     /*  121628 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(121673), // Rule ID 2524 //
     /*  121633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  121641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121662 */     // (intrinsic_wo_chain:{ *:[i32] } 10806:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  121665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121671 */     GIR_RootConstrainSelectedInstOperands,
     /*  121672 */     // GIR_Coverage, 2524,
     /*  121672 */     GIR_EraseRootFromParent_Done,
     /*  121673 */   // Label 3136: @121673
     /*  121673 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(121718), // Rule ID 2525 //
     /*  121678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  121686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121707 */     // (intrinsic_wo_chain:{ *:[i32] } 10805:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  121710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121716 */     GIR_RootConstrainSelectedInstOperands,
     /*  121717 */     // GIR_Coverage, 2525,
     /*  121717 */     GIR_EraseRootFromParent_Done,
     /*  121718 */   // Label 3137: @121718
     /*  121718 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(121763), // Rule ID 2526 //
     /*  121723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  121731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121752 */     // (intrinsic_wo_chain:{ *:[i32] } 10809:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  121755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121761 */     GIR_RootConstrainSelectedInstOperands,
     /*  121762 */     // GIR_Coverage, 2526,
     /*  121762 */     GIR_EraseRootFromParent_Done,
     /*  121763 */   // Label 3138: @121763
     /*  121763 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(121808), // Rule ID 2527 //
     /*  121768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  121776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121797 */     // (intrinsic_wo_chain:{ *:[i32] } 10808:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  121800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121806 */     GIR_RootConstrainSelectedInstOperands,
     /*  121807 */     // GIR_Coverage, 2527,
     /*  121807 */     GIR_EraseRootFromParent_Done,
     /*  121808 */   // Label 3139: @121808
     /*  121808 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(121853), // Rule ID 2528 //
     /*  121813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  121821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121842 */     // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  121845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121851 */     GIR_RootConstrainSelectedInstOperands,
     /*  121852 */     // GIR_Coverage, 2528,
     /*  121852 */     GIR_EraseRootFromParent_Done,
     /*  121853 */   // Label 3140: @121853
     /*  121853 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(121898), // Rule ID 2529 //
     /*  121858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  121861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  121866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121887 */     // (intrinsic_wo_chain:{ *:[i32] } 10813:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  121890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121896 */     GIR_RootConstrainSelectedInstOperands,
     /*  121897 */     // GIR_Coverage, 2529,
     /*  121897 */     GIR_EraseRootFromParent_Done,
     /*  121898 */   // Label 3141: @121898
     /*  121898 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(121943), // Rule ID 63740 //
     /*  121903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  121906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  121911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121932 */     // (intrinsic_wo_chain:{ *:[i32] } 10689:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  121935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121941 */     GIR_RootConstrainSelectedInstOperands,
     /*  121942 */     // GIR_Coverage, 63740,
     /*  121942 */     GIR_EraseRootFromParent_Done,
     /*  121943 */   // Label 3142: @121943
     /*  121943 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(121988), // Rule ID 63742 //
     /*  121948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  121951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  121956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  121959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  121962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  121965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121977 */     // (intrinsic_wo_chain:{ *:[i32] } 10690:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  121977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  121980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  121986 */     GIR_RootConstrainSelectedInstOperands,
     /*  121987 */     // GIR_Coverage, 63742,
     /*  121987 */     GIR_EraseRootFromParent_Done,
     /*  121988 */   // Label 3143: @121988
     /*  121988 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(122033), // Rule ID 63744 //
     /*  121993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  121996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  122001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  122004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  122007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122022 */     // (intrinsic_wo_chain:{ *:[i32] } 10685:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  122022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  122025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  122031 */     GIR_RootConstrainSelectedInstOperands,
     /*  122032 */     // GIR_Coverage, 63744,
     /*  122032 */     GIR_EraseRootFromParent_Done,
     /*  122033 */   // Label 3144: @122033
     /*  122033 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(122078), // Rule ID 63746 //
     /*  122038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  122041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  122046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  122049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  122052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  122067 */     // (intrinsic_wo_chain:{ *:[i32] } 10687:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  122067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  122070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  122076 */     GIR_RootConstrainSelectedInstOperands,
     /*  122077 */     // GIR_Coverage, 63746,
     /*  122077 */     GIR_EraseRootFromParent_Done,
     /*  122078 */   // Label 3145: @122078
     /*  122078 */   GIM_Reject,
     /*  122079 */ // Label 3009: @122079
     /*  122079 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(292984),
     /*  122084 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  122087 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(122161), // Rule ID 5314 //
     /*  122092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122132 */     // MIs[1] Operand 1
     /*  122132 */     // No operand predicates
     /*  122132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122141 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  122141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  122144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122159 */     GIR_RootConstrainSelectedInstOperands,
     /*  122160 */     // GIR_Coverage, 5314,
     /*  122160 */     GIR_EraseRootFromParent_Done,
     /*  122161 */   // Label 3147: @122161
     /*  122161 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(122235), // Rule ID 5315 //
     /*  122166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122206 */     // MIs[1] Operand 1
     /*  122206 */     // No operand predicates
     /*  122206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122215 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  122215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  122218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122233 */     GIR_RootConstrainSelectedInstOperands,
     /*  122234 */     // GIR_Coverage, 5315,
     /*  122234 */     GIR_EraseRootFromParent_Done,
     /*  122235 */   // Label 3148: @122235
     /*  122235 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(122309), // Rule ID 5316 //
     /*  122240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  122251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  122254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122280 */     // MIs[1] Operand 1
     /*  122280 */     // No operand predicates
     /*  122280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122289 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  122289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  122292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122307 */     GIR_RootConstrainSelectedInstOperands,
     /*  122308 */     // GIR_Coverage, 5316,
     /*  122308 */     GIR_EraseRootFromParent_Done,
     /*  122309 */   // Label 3149: @122309
     /*  122309 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(122383), // Rule ID 5317 //
     /*  122314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  122325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  122328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122354 */     // MIs[1] Operand 1
     /*  122354 */     // No operand predicates
     /*  122354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  122363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  122366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122381 */     GIR_RootConstrainSelectedInstOperands,
     /*  122382 */     // GIR_Coverage, 5317,
     /*  122382 */     GIR_EraseRootFromParent_Done,
     /*  122383 */   // Label 3150: @122383
     /*  122383 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(122457), // Rule ID 5318 //
     /*  122388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  122399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  122402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122428 */     // MIs[1] Operand 1
     /*  122428 */     // No operand predicates
     /*  122428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122437 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  122437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122455 */     GIR_RootConstrainSelectedInstOperands,
     /*  122456 */     // GIR_Coverage, 5318,
     /*  122456 */     GIR_EraseRootFromParent_Done,
     /*  122457 */   // Label 3151: @122457
     /*  122457 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(122531), // Rule ID 5319 //
     /*  122462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  122473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  122476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122502 */     // MIs[1] Operand 1
     /*  122502 */     // No operand predicates
     /*  122502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122511 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  122511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122529 */     GIR_RootConstrainSelectedInstOperands,
     /*  122530 */     // GIR_Coverage, 5319,
     /*  122530 */     GIR_EraseRootFromParent_Done,
     /*  122531 */   // Label 3152: @122531
     /*  122531 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(122605), // Rule ID 5320 //
     /*  122536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122576 */     // MIs[1] Operand 1
     /*  122576 */     // No operand predicates
     /*  122576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122585 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  122585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  122588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122603 */     GIR_RootConstrainSelectedInstOperands,
     /*  122604 */     // GIR_Coverage, 5320,
     /*  122604 */     GIR_EraseRootFromParent_Done,
     /*  122605 */   // Label 3153: @122605
     /*  122605 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(122679), // Rule ID 5321 //
     /*  122610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122650 */     // MIs[1] Operand 1
     /*  122650 */     // No operand predicates
     /*  122650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122659 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  122659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  122662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122677 */     GIR_RootConstrainSelectedInstOperands,
     /*  122678 */     // GIR_Coverage, 5321,
     /*  122678 */     GIR_EraseRootFromParent_Done,
     /*  122679 */   // Label 3154: @122679
     /*  122679 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(122753), // Rule ID 5322 //
     /*  122684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  122695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  122698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122724 */     // MIs[1] Operand 1
     /*  122724 */     // No operand predicates
     /*  122724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  122733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122751 */     GIR_RootConstrainSelectedInstOperands,
     /*  122752 */     // GIR_Coverage, 5322,
     /*  122752 */     GIR_EraseRootFromParent_Done,
     /*  122753 */   // Label 3155: @122753
     /*  122753 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(122827), // Rule ID 5323 //
     /*  122758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  122769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  122772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122798 */     // MIs[1] Operand 1
     /*  122798 */     // No operand predicates
     /*  122798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  122807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122825 */     GIR_RootConstrainSelectedInstOperands,
     /*  122826 */     // GIR_Coverage, 5323,
     /*  122826 */     GIR_EraseRootFromParent_Done,
     /*  122827 */   // Label 3156: @122827
     /*  122827 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(122901), // Rule ID 5324 //
     /*  122832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  122852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122872 */     // MIs[1] Operand 1
     /*  122872 */     // No operand predicates
     /*  122872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122881 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  122881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122899 */     GIR_RootConstrainSelectedInstOperands,
     /*  122900 */     // GIR_Coverage, 5324,
     /*  122900 */     GIR_EraseRootFromParent_Done,
     /*  122901 */   // Label 3157: @122901
     /*  122901 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(122975), // Rule ID 5325 //
     /*  122906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  122917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  122923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  122926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  122938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  122942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  122946 */     // MIs[1] Operand 1
     /*  122946 */     // No operand predicates
     /*  122946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  122948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  122955 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  122955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  122958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  122965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  122970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122973 */     GIR_RootConstrainSelectedInstOperands,
     /*  122974 */     // GIR_Coverage, 5325,
     /*  122974 */     GIR_EraseRootFromParent_Done,
     /*  122975 */   // Label 3158: @122975
     /*  122975 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(123049), // Rule ID 5326 //
     /*  122980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  122988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  122991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  122994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  122997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123020 */     // MIs[1] Operand 1
     /*  123020 */     // No operand predicates
     /*  123020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  123029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123047 */     GIR_RootConstrainSelectedInstOperands,
     /*  123048 */     // GIR_Coverage, 5326,
     /*  123048 */     GIR_EraseRootFromParent_Done,
     /*  123049 */   // Label 3159: @123049
     /*  123049 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(123123), // Rule ID 5327 //
     /*  123054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  123065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  123068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123094 */     // MIs[1] Operand 1
     /*  123094 */     // No operand predicates
     /*  123094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123103 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  123103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123121 */     GIR_RootConstrainSelectedInstOperands,
     /*  123122 */     // GIR_Coverage, 5327,
     /*  123122 */     GIR_EraseRootFromParent_Done,
     /*  123123 */   // Label 3160: @123123
     /*  123123 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(123197), // Rule ID 5328 //
     /*  123128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  123139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  123142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123168 */     // MIs[1] Operand 1
     /*  123168 */     // No operand predicates
     /*  123168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123177 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  123177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123195 */     GIR_RootConstrainSelectedInstOperands,
     /*  123196 */     // GIR_Coverage, 5328,
     /*  123196 */     GIR_EraseRootFromParent_Done,
     /*  123197 */   // Label 3161: @123197
     /*  123197 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(123271), // Rule ID 5329 //
     /*  123202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  123213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  123216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123242 */     // MIs[1] Operand 1
     /*  123242 */     // No operand predicates
     /*  123242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123251 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  123251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123269 */     GIR_RootConstrainSelectedInstOperands,
     /*  123270 */     // GIR_Coverage, 5329,
     /*  123270 */     GIR_EraseRootFromParent_Done,
     /*  123271 */   // Label 3162: @123271
     /*  123271 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(123345), // Rule ID 5330 //
     /*  123276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  123287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123316 */     // MIs[1] Operand 1
     /*  123316 */     // No operand predicates
     /*  123316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123325 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  123325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123343 */     GIR_RootConstrainSelectedInstOperands,
     /*  123344 */     // GIR_Coverage, 5330,
     /*  123344 */     GIR_EraseRootFromParent_Done,
     /*  123345 */   // Label 3163: @123345
     /*  123345 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(123419), // Rule ID 5331 //
     /*  123350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  123361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123390 */     // MIs[1] Operand 1
     /*  123390 */     // No operand predicates
     /*  123390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  123399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123417 */     GIR_RootConstrainSelectedInstOperands,
     /*  123418 */     // GIR_Coverage, 5331,
     /*  123418 */     GIR_EraseRootFromParent_Done,
     /*  123419 */   // Label 3164: @123419
     /*  123419 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(123493), // Rule ID 5332 //
     /*  123424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  123427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  123435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  123438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123464 */     // MIs[1] Operand 1
     /*  123464 */     // No operand predicates
     /*  123464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123473 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  123473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123491 */     GIR_RootConstrainSelectedInstOperands,
     /*  123492 */     // GIR_Coverage, 5332,
     /*  123492 */     GIR_EraseRootFromParent_Done,
     /*  123493 */   // Label 3165: @123493
     /*  123493 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(123567), // Rule ID 5333 //
     /*  123498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  123501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  123509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  123512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123538 */     // MIs[1] Operand 1
     /*  123538 */     // No operand predicates
     /*  123538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123547 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  123547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  123550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123565 */     GIR_RootConstrainSelectedInstOperands,
     /*  123566 */     // GIR_Coverage, 5333,
     /*  123566 */     GIR_EraseRootFromParent_Done,
     /*  123567 */   // Label 3166: @123567
     /*  123567 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(123641), // Rule ID 5334 //
     /*  123572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  123583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  123586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123612 */     // MIs[1] Operand 1
     /*  123612 */     // No operand predicates
     /*  123612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123621 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  123621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  123624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123639 */     GIR_RootConstrainSelectedInstOperands,
     /*  123640 */     // GIR_Coverage, 5334,
     /*  123640 */     GIR_EraseRootFromParent_Done,
     /*  123641 */   // Label 3167: @123641
     /*  123641 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(123715), // Rule ID 5335 //
     /*  123646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  123657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  123660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123686 */     // MIs[1] Operand 1
     /*  123686 */     // No operand predicates
     /*  123686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  123695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  123698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123713 */     GIR_RootConstrainSelectedInstOperands,
     /*  123714 */     // GIR_Coverage, 5335,
     /*  123714 */     GIR_EraseRootFromParent_Done,
     /*  123715 */   // Label 3168: @123715
     /*  123715 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(123789), // Rule ID 5336 //
     /*  123720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  123731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  123734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  123748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123760 */     // MIs[1] Operand 1
     /*  123760 */     // No operand predicates
     /*  123760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123769 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  123769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  123772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123787 */     GIR_RootConstrainSelectedInstOperands,
     /*  123788 */     // GIR_Coverage, 5336,
     /*  123788 */     GIR_EraseRootFromParent_Done,
     /*  123789 */   // Label 3169: @123789
     /*  123789 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(123863), // Rule ID 5337 //
     /*  123794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  123805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  123808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  123822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123834 */     // MIs[1] Operand 1
     /*  123834 */     // No operand predicates
     /*  123834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123843 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  123843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  123846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123861 */     GIR_RootConstrainSelectedInstOperands,
     /*  123862 */     // GIR_Coverage, 5337,
     /*  123862 */     GIR_EraseRootFromParent_Done,
     /*  123863 */   // Label 3170: @123863
     /*  123863 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(123937), // Rule ID 5338 //
     /*  123868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  123879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  123882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  123885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  123888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  123896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123908 */     // MIs[1] Operand 1
     /*  123908 */     // No operand predicates
     /*  123908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123917 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  123917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  123920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  123927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  123932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123935 */     GIR_RootConstrainSelectedInstOperands,
     /*  123936 */     // GIR_Coverage, 5338,
     /*  123936 */     GIR_EraseRootFromParent_Done,
     /*  123937 */   // Label 3171: @123937
     /*  123937 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(124011), // Rule ID 5339 //
     /*  123942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  123950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  123953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  123956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  123959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  123962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  123970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  123974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  123978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  123982 */     // MIs[1] Operand 1
     /*  123982 */     // No operand predicates
     /*  123982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  123984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  123991 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  123991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  123994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124009 */     GIR_RootConstrainSelectedInstOperands,
     /*  124010 */     // GIR_Coverage, 5339,
     /*  124010 */     GIR_EraseRootFromParent_Done,
     /*  124011 */   // Label 3172: @124011
     /*  124011 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(124085), // Rule ID 5340 //
     /*  124016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  124027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  124030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124056 */     // MIs[1] Operand 1
     /*  124056 */     // No operand predicates
     /*  124056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124065 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  124065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  124068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124083 */     GIR_RootConstrainSelectedInstOperands,
     /*  124084 */     // GIR_Coverage, 5340,
     /*  124084 */     GIR_EraseRootFromParent_Done,
     /*  124085 */   // Label 3173: @124085
     /*  124085 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(124159), // Rule ID 5341 //
     /*  124090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  124101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  124104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124130 */     // MIs[1] Operand 1
     /*  124130 */     // No operand predicates
     /*  124130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  124139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  124142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124157 */     GIR_RootConstrainSelectedInstOperands,
     /*  124158 */     // GIR_Coverage, 5341,
     /*  124158 */     GIR_EraseRootFromParent_Done,
     /*  124159 */   // Label 3174: @124159
     /*  124159 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(124233), // Rule ID 5342 //
     /*  124164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  124175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  124178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124204 */     // MIs[1] Operand 1
     /*  124204 */     // No operand predicates
     /*  124204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  124213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  124216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124231 */     GIR_RootConstrainSelectedInstOperands,
     /*  124232 */     // GIR_Coverage, 5342,
     /*  124232 */     GIR_EraseRootFromParent_Done,
     /*  124233 */   // Label 3175: @124233
     /*  124233 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(124307), // Rule ID 5343 //
     /*  124238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  124249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  124252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124278 */     // MIs[1] Operand 1
     /*  124278 */     // No operand predicates
     /*  124278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  124287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  124290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124305 */     GIR_RootConstrainSelectedInstOperands,
     /*  124306 */     // GIR_Coverage, 5343,
     /*  124306 */     GIR_EraseRootFromParent_Done,
     /*  124307 */   // Label 3176: @124307
     /*  124307 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(124381), // Rule ID 5344 //
     /*  124312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  124323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  124326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  124340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124352 */     // MIs[1] Operand 1
     /*  124352 */     // No operand predicates
     /*  124352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124361 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  124361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  124364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124379 */     GIR_RootConstrainSelectedInstOperands,
     /*  124380 */     // GIR_Coverage, 5344,
     /*  124380 */     GIR_EraseRootFromParent_Done,
     /*  124381 */   // Label 3177: @124381
     /*  124381 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(124455), // Rule ID 5345 //
     /*  124386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  124397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  124400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  124414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124426 */     // MIs[1] Operand 1
     /*  124426 */     // No operand predicates
     /*  124426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124435 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  124435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  124438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124453 */     GIR_RootConstrainSelectedInstOperands,
     /*  124454 */     // GIR_Coverage, 5345,
     /*  124454 */     GIR_EraseRootFromParent_Done,
     /*  124455 */   // Label 3178: @124455
     /*  124455 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(124529), // Rule ID 5346 //
     /*  124460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  124471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124500 */     // MIs[1] Operand 1
     /*  124500 */     // No operand predicates
     /*  124500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124509 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  124509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  124512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124527 */     GIR_RootConstrainSelectedInstOperands,
     /*  124528 */     // GIR_Coverage, 5346,
     /*  124528 */     GIR_EraseRootFromParent_Done,
     /*  124529 */   // Label 3179: @124529
     /*  124529 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(124603), // Rule ID 5347 //
     /*  124534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  124545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124574 */     // MIs[1] Operand 1
     /*  124574 */     // No operand predicates
     /*  124574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  124583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  124586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124601 */     GIR_RootConstrainSelectedInstOperands,
     /*  124602 */     // GIR_Coverage, 5347,
     /*  124602 */     GIR_EraseRootFromParent_Done,
     /*  124603 */   // Label 3180: @124603
     /*  124603 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(124677), // Rule ID 5348 //
     /*  124608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  124619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  124622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124648 */     // MIs[1] Operand 1
     /*  124648 */     // No operand predicates
     /*  124648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124657 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  124657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  124660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124675 */     GIR_RootConstrainSelectedInstOperands,
     /*  124676 */     // GIR_Coverage, 5348,
     /*  124676 */     GIR_EraseRootFromParent_Done,
     /*  124677 */   // Label 3181: @124677
     /*  124677 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(124751), // Rule ID 5349 //
     /*  124682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  124693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  124696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124722 */     // MIs[1] Operand 1
     /*  124722 */     // No operand predicates
     /*  124722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124731 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  124731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  124734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124749 */     GIR_RootConstrainSelectedInstOperands,
     /*  124750 */     // GIR_Coverage, 5349,
     /*  124750 */     GIR_EraseRootFromParent_Done,
     /*  124751 */   // Label 3182: @124751
     /*  124751 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(124825), // Rule ID 5350 //
     /*  124756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  124767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  124770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  124784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124796 */     // MIs[1] Operand 1
     /*  124796 */     // No operand predicates
     /*  124796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124805 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  124805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  124808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124823 */     GIR_RootConstrainSelectedInstOperands,
     /*  124824 */     // GIR_Coverage, 5350,
     /*  124824 */     GIR_EraseRootFromParent_Done,
     /*  124825 */   // Label 3183: @124825
     /*  124825 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(124899), // Rule ID 5351 //
     /*  124830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  124841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  124844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  124858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124870 */     // MIs[1] Operand 1
     /*  124870 */     // No operand predicates
     /*  124870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  124879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  124882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124897 */     GIR_RootConstrainSelectedInstOperands,
     /*  124898 */     // GIR_Coverage, 5351,
     /*  124898 */     GIR_EraseRootFromParent_Done,
     /*  124899 */   // Label 3184: @124899
     /*  124899 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(124973), // Rule ID 5352 //
     /*  124904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  124915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  124918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  124921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  124924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  124936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  124940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  124944 */     // MIs[1] Operand 1
     /*  124944 */     // No operand predicates
     /*  124944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  124946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  124953 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  124953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  124956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  124963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  124968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124971 */     GIR_RootConstrainSelectedInstOperands,
     /*  124972 */     // GIR_Coverage, 5352,
     /*  124972 */     GIR_EraseRootFromParent_Done,
     /*  124973 */   // Label 3185: @124973
     /*  124973 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(125047), // Rule ID 5353 //
     /*  124978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  124986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  124989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  124992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  124995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  124998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125018 */     // MIs[1] Operand 1
     /*  125018 */     // No operand predicates
     /*  125018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125027 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  125027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  125030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125045 */     GIR_RootConstrainSelectedInstOperands,
     /*  125046 */     // GIR_Coverage, 5353,
     /*  125046 */     GIR_EraseRootFromParent_Done,
     /*  125047 */   // Label 3186: @125047
     /*  125047 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(125121), // Rule ID 5354 //
     /*  125052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  125060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  125063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  125066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125092 */     // MIs[1] Operand 1
     /*  125092 */     // No operand predicates
     /*  125092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  125101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  125104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125119 */     GIR_RootConstrainSelectedInstOperands,
     /*  125120 */     // GIR_Coverage, 5354,
     /*  125120 */     GIR_EraseRootFromParent_Done,
     /*  125121 */   // Label 3187: @125121
     /*  125121 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(125195), // Rule ID 5355 //
     /*  125126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  125134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  125137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  125140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125166 */     // MIs[1] Operand 1
     /*  125166 */     // No operand predicates
     /*  125166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125175 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  125175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  125178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125193 */     GIR_RootConstrainSelectedInstOperands,
     /*  125194 */     // GIR_Coverage, 5355,
     /*  125194 */     GIR_EraseRootFromParent_Done,
     /*  125195 */   // Label 3188: @125195
     /*  125195 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(125269), // Rule ID 5356 //
     /*  125200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  125208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  125211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125240 */     // MIs[1] Operand 1
     /*  125240 */     // No operand predicates
     /*  125240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125249 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  125249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  125252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125267 */     GIR_RootConstrainSelectedInstOperands,
     /*  125268 */     // GIR_Coverage, 5356,
     /*  125268 */     GIR_EraseRootFromParent_Done,
     /*  125269 */   // Label 3189: @125269
     /*  125269 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(125343), // Rule ID 5357 //
     /*  125274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  125282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  125285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125314 */     // MIs[1] Operand 1
     /*  125314 */     // No operand predicates
     /*  125314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  125323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  125326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125341 */     GIR_RootConstrainSelectedInstOperands,
     /*  125342 */     // GIR_Coverage, 5357,
     /*  125342 */     GIR_EraseRootFromParent_Done,
     /*  125343 */   // Label 3190: @125343
     /*  125343 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(125417), // Rule ID 7826 //
     /*  125348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  125359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  125362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125388 */     // MIs[1] Operand 1
     /*  125388 */     // No operand predicates
     /*  125388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125397 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  125397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  125400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125415 */     GIR_RootConstrainSelectedInstOperands,
     /*  125416 */     // GIR_Coverage, 7826,
     /*  125416 */     GIR_EraseRootFromParent_Done,
     /*  125417 */   // Label 3191: @125417
     /*  125417 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(125491), // Rule ID 7827 //
     /*  125422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  125433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  125436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125462 */     // MIs[1] Operand 1
     /*  125462 */     // No operand predicates
     /*  125462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125471 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  125471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  125474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125489 */     GIR_RootConstrainSelectedInstOperands,
     /*  125490 */     // GIR_Coverage, 7827,
     /*  125490 */     GIR_EraseRootFromParent_Done,
     /*  125491 */   // Label 3192: @125491
     /*  125491 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(125565), // Rule ID 7830 //
     /*  125496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  125507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  125510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125536 */     // MIs[1] Operand 1
     /*  125536 */     // No operand predicates
     /*  125536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  125545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  125548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125563 */     GIR_RootConstrainSelectedInstOperands,
     /*  125564 */     // GIR_Coverage, 7830,
     /*  125564 */     GIR_EraseRootFromParent_Done,
     /*  125565 */   // Label 3193: @125565
     /*  125565 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(125639), // Rule ID 7831 //
     /*  125570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  125581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  125584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125610 */     // MIs[1] Operand 1
     /*  125610 */     // No operand predicates
     /*  125610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  125619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  125622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125637 */     GIR_RootConstrainSelectedInstOperands,
     /*  125638 */     // GIR_Coverage, 7831,
     /*  125638 */     GIR_EraseRootFromParent_Done,
     /*  125639 */   // Label 3194: @125639
     /*  125639 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(125713), // Rule ID 7834 //
     /*  125644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  125655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  125658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125684 */     // MIs[1] Operand 1
     /*  125684 */     // No operand predicates
     /*  125684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125693 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  125693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  125696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125711 */     GIR_RootConstrainSelectedInstOperands,
     /*  125712 */     // GIR_Coverage, 7834,
     /*  125712 */     GIR_EraseRootFromParent_Done,
     /*  125713 */   // Label 3195: @125713
     /*  125713 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(125787), // Rule ID 7835 //
     /*  125718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  125729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  125732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125758 */     // MIs[1] Operand 1
     /*  125758 */     // No operand predicates
     /*  125758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125767 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  125767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  125770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125785 */     GIR_RootConstrainSelectedInstOperands,
     /*  125786 */     // GIR_Coverage, 7835,
     /*  125786 */     GIR_EraseRootFromParent_Done,
     /*  125787 */   // Label 3196: @125787
     /*  125787 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(125861), // Rule ID 7838 //
     /*  125792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  125803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  125806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125832 */     // MIs[1] Operand 1
     /*  125832 */     // No operand predicates
     /*  125832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125841 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  125841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  125844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125859 */     GIR_RootConstrainSelectedInstOperands,
     /*  125860 */     // GIR_Coverage, 7838,
     /*  125860 */     GIR_EraseRootFromParent_Done,
     /*  125861 */   // Label 3197: @125861
     /*  125861 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(125935), // Rule ID 7839 //
     /*  125866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  125877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  125880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  125883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  125886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125906 */     // MIs[1] Operand 1
     /*  125906 */     // No operand predicates
     /*  125906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125915 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  125915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  125918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  125930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125933 */     GIR_RootConstrainSelectedInstOperands,
     /*  125934 */     // GIR_Coverage, 7839,
     /*  125934 */     GIR_EraseRootFromParent_Done,
     /*  125935 */   // Label 3198: @125935
     /*  125935 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(126009), // Rule ID 7842 //
     /*  125940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  125948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  125951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  125954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  125957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  125960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  125972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  125976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  125980 */     // MIs[1] Operand 1
     /*  125980 */     // No operand predicates
     /*  125980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  125989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  125989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  125992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  125999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126007 */     GIR_RootConstrainSelectedInstOperands,
     /*  126008 */     // GIR_Coverage, 7842,
     /*  126008 */     GIR_EraseRootFromParent_Done,
     /*  126009 */   // Label 3199: @126009
     /*  126009 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(126083), // Rule ID 7843 //
     /*  126014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  126025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  126028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126054 */     // MIs[1] Operand 1
     /*  126054 */     // No operand predicates
     /*  126054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  126063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  126066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126081 */     GIR_RootConstrainSelectedInstOperands,
     /*  126082 */     // GIR_Coverage, 7843,
     /*  126082 */     GIR_EraseRootFromParent_Done,
     /*  126083 */   // Label 3200: @126083
     /*  126083 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(126157), // Rule ID 7846 //
     /*  126088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  126099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  126102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126128 */     // MIs[1] Operand 1
     /*  126128 */     // No operand predicates
     /*  126128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126137 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  126137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  126140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126155 */     GIR_RootConstrainSelectedInstOperands,
     /*  126156 */     // GIR_Coverage, 7846,
     /*  126156 */     GIR_EraseRootFromParent_Done,
     /*  126157 */   // Label 3201: @126157
     /*  126157 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(126231), // Rule ID 7847 //
     /*  126162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  126173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  126176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126202 */     // MIs[1] Operand 1
     /*  126202 */     // No operand predicates
     /*  126202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  126211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  126214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126229 */     GIR_RootConstrainSelectedInstOperands,
     /*  126230 */     // GIR_Coverage, 7847,
     /*  126230 */     GIR_EraseRootFromParent_Done,
     /*  126231 */   // Label 3202: @126231
     /*  126231 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(126305), // Rule ID 7850 //
     /*  126236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  126247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  126250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126276 */     // MIs[1] Operand 1
     /*  126276 */     // No operand predicates
     /*  126276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126285 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  126285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126303 */     GIR_RootConstrainSelectedInstOperands,
     /*  126304 */     // GIR_Coverage, 7850,
     /*  126304 */     GIR_EraseRootFromParent_Done,
     /*  126305 */   // Label 3203: @126305
     /*  126305 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(126379), // Rule ID 7851 //
     /*  126310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  126321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  126324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126350 */     // MIs[1] Operand 1
     /*  126350 */     // No operand predicates
     /*  126350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  126359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126377 */     GIR_RootConstrainSelectedInstOperands,
     /*  126378 */     // GIR_Coverage, 7851,
     /*  126378 */     GIR_EraseRootFromParent_Done,
     /*  126379 */   // Label 3204: @126379
     /*  126379 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(126453), // Rule ID 7854 //
     /*  126384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  126395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  126398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126424 */     // MIs[1] Operand 1
     /*  126424 */     // No operand predicates
     /*  126424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  126433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126451 */     GIR_RootConstrainSelectedInstOperands,
     /*  126452 */     // GIR_Coverage, 7854,
     /*  126452 */     GIR_EraseRootFromParent_Done,
     /*  126453 */   // Label 3205: @126453
     /*  126453 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(126527), // Rule ID 7855 //
     /*  126458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  126469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  126472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126498 */     // MIs[1] Operand 1
     /*  126498 */     // No operand predicates
     /*  126498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126507 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  126507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126525 */     GIR_RootConstrainSelectedInstOperands,
     /*  126526 */     // GIR_Coverage, 7855,
     /*  126526 */     GIR_EraseRootFromParent_Done,
     /*  126527 */   // Label 3206: @126527
     /*  126527 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(126601), // Rule ID 7858 //
     /*  126532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  126543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  126546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126572 */     // MIs[1] Operand 1
     /*  126572 */     // No operand predicates
     /*  126572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126581 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  126581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126599 */     GIR_RootConstrainSelectedInstOperands,
     /*  126600 */     // GIR_Coverage, 7858,
     /*  126600 */     GIR_EraseRootFromParent_Done,
     /*  126601 */   // Label 3207: @126601
     /*  126601 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(126675), // Rule ID 7859 //
     /*  126606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  126617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  126620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126646 */     // MIs[1] Operand 1
     /*  126646 */     // No operand predicates
     /*  126646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126655 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  126655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126673 */     GIR_RootConstrainSelectedInstOperands,
     /*  126674 */     // GIR_Coverage, 7859,
     /*  126674 */     GIR_EraseRootFromParent_Done,
     /*  126675 */   // Label 3208: @126675
     /*  126675 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(126749), // Rule ID 7862 //
     /*  126680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  126683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  126691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  126694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126720 */     // MIs[1] Operand 1
     /*  126720 */     // No operand predicates
     /*  126720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126729 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  126729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126747 */     GIR_RootConstrainSelectedInstOperands,
     /*  126748 */     // GIR_Coverage, 7862,
     /*  126748 */     GIR_EraseRootFromParent_Done,
     /*  126749 */   // Label 3209: @126749
     /*  126749 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(126823), // Rule ID 7863 //
     /*  126754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  126757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  126765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  126768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126794 */     // MIs[1] Operand 1
     /*  126794 */     // No operand predicates
     /*  126794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  126803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  126806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126821 */     GIR_RootConstrainSelectedInstOperands,
     /*  126822 */     // GIR_Coverage, 7863,
     /*  126822 */     GIR_EraseRootFromParent_Done,
     /*  126823 */   // Label 3210: @126823
     /*  126823 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(126897), // Rule ID 7866 //
     /*  126828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  126839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126868 */     // MIs[1] Operand 1
     /*  126868 */     // No operand predicates
     /*  126868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  126877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  126880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126895 */     GIR_RootConstrainSelectedInstOperands,
     /*  126896 */     // GIR_Coverage, 7866,
     /*  126896 */     GIR_EraseRootFromParent_Done,
     /*  126897 */   // Label 3211: @126897
     /*  126897 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(126971), // Rule ID 7867 //
     /*  126902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  126913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  126919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  126922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  126934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  126942 */     // MIs[1] Operand 1
     /*  126942 */     // No operand predicates
     /*  126942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  126951 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  126951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  126954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  126961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  126966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126969 */     GIR_RootConstrainSelectedInstOperands,
     /*  126970 */     // GIR_Coverage, 7867,
     /*  126970 */     GIR_EraseRootFromParent_Done,
     /*  126971 */   // Label 3212: @126971
     /*  126971 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(127045), // Rule ID 7870 //
     /*  126976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  126984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  126987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  126990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  126993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  126996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127016 */     // MIs[1] Operand 1
     /*  127016 */     // No operand predicates
     /*  127016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127025 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  127025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127043 */     GIR_RootConstrainSelectedInstOperands,
     /*  127044 */     // GIR_Coverage, 7870,
     /*  127044 */     GIR_EraseRootFromParent_Done,
     /*  127045 */   // Label 3213: @127045
     /*  127045 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(127119), // Rule ID 7871 //
     /*  127050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  127061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  127064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127090 */     // MIs[1] Operand 1
     /*  127090 */     // No operand predicates
     /*  127090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127099 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  127099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127117 */     GIR_RootConstrainSelectedInstOperands,
     /*  127118 */     // GIR_Coverage, 7871,
     /*  127118 */     GIR_EraseRootFromParent_Done,
     /*  127119 */   // Label 3214: @127119
     /*  127119 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(127193), // Rule ID 7874 //
     /*  127124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  127135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  127138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127164 */     // MIs[1] Operand 1
     /*  127164 */     // No operand predicates
     /*  127164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127173 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  127173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  127176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127191 */     GIR_RootConstrainSelectedInstOperands,
     /*  127192 */     // GIR_Coverage, 7874,
     /*  127192 */     GIR_EraseRootFromParent_Done,
     /*  127193 */   // Label 3215: @127193
     /*  127193 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(127267), // Rule ID 7875 //
     /*  127198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  127209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  127212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127238 */     // MIs[1] Operand 1
     /*  127238 */     // No operand predicates
     /*  127238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127247 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  127247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  127250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127265 */     GIR_RootConstrainSelectedInstOperands,
     /*  127266 */     // GIR_Coverage, 7875,
     /*  127266 */     GIR_EraseRootFromParent_Done,
     /*  127267 */   // Label 3216: @127267
     /*  127267 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(127341), // Rule ID 7878 //
     /*  127272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  127283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  127286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  127300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127312 */     // MIs[1] Operand 1
     /*  127312 */     // No operand predicates
     /*  127312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  127321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  127324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127339 */     GIR_RootConstrainSelectedInstOperands,
     /*  127340 */     // GIR_Coverage, 7878,
     /*  127340 */     GIR_EraseRootFromParent_Done,
     /*  127341 */   // Label 3217: @127341
     /*  127341 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(127415), // Rule ID 7879 //
     /*  127346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  127357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  127360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  127374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127386 */     // MIs[1] Operand 1
     /*  127386 */     // No operand predicates
     /*  127386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  127395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  127398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127413 */     GIR_RootConstrainSelectedInstOperands,
     /*  127414 */     // GIR_Coverage, 7879,
     /*  127414 */     GIR_EraseRootFromParent_Done,
     /*  127415 */   // Label 3218: @127415
     /*  127415 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(127489), // Rule ID 7882 //
     /*  127420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  127431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  127434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127460 */     // MIs[1] Operand 1
     /*  127460 */     // No operand predicates
     /*  127460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127469 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  127469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127487 */     GIR_RootConstrainSelectedInstOperands,
     /*  127488 */     // GIR_Coverage, 7882,
     /*  127488 */     GIR_EraseRootFromParent_Done,
     /*  127489 */   // Label 3219: @127489
     /*  127489 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(127563), // Rule ID 7883 //
     /*  127494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  127505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  127508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127534 */     // MIs[1] Operand 1
     /*  127534 */     // No operand predicates
     /*  127534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127543 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  127543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127561 */     GIR_RootConstrainSelectedInstOperands,
     /*  127562 */     // GIR_Coverage, 7883,
     /*  127562 */     GIR_EraseRootFromParent_Done,
     /*  127563 */   // Label 3220: @127563
     /*  127563 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(127637), // Rule ID 7886 //
     /*  127568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  127579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127608 */     // MIs[1] Operand 1
     /*  127608 */     // No operand predicates
     /*  127608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127617 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  127617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  127620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127635 */     GIR_RootConstrainSelectedInstOperands,
     /*  127636 */     // GIR_Coverage, 7886,
     /*  127636 */     GIR_EraseRootFromParent_Done,
     /*  127637 */   // Label 3221: @127637
     /*  127637 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(127711), // Rule ID 7887 //
     /*  127642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  127653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127682 */     // MIs[1] Operand 1
     /*  127682 */     // No operand predicates
     /*  127682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  127691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  127694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127709 */     GIR_RootConstrainSelectedInstOperands,
     /*  127710 */     // GIR_Coverage, 7887,
     /*  127710 */     GIR_EraseRootFromParent_Done,
     /*  127711 */   // Label 3222: @127711
     /*  127711 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(127785), // Rule ID 7890 //
     /*  127716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  127727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  127730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  127744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127756 */     // MIs[1] Operand 1
     /*  127756 */     // No operand predicates
     /*  127756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127765 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  127765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  127768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127783 */     GIR_RootConstrainSelectedInstOperands,
     /*  127784 */     // GIR_Coverage, 7890,
     /*  127784 */     GIR_EraseRootFromParent_Done,
     /*  127785 */   // Label 3223: @127785
     /*  127785 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(127859), // Rule ID 7891 //
     /*  127790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  127801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  127804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  127818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127830 */     // MIs[1] Operand 1
     /*  127830 */     // No operand predicates
     /*  127830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  127839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  127842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127857 */     GIR_RootConstrainSelectedInstOperands,
     /*  127858 */     // GIR_Coverage, 7891,
     /*  127858 */     GIR_EraseRootFromParent_Done,
     /*  127859 */   // Label 3224: @127859
     /*  127859 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(127933), // Rule ID 7894 //
     /*  127864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  127875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  127878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  127881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  127884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127904 */     // MIs[1] Operand 1
     /*  127904 */     // No operand predicates
     /*  127904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127913 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  127913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  127928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127931 */     GIR_RootConstrainSelectedInstOperands,
     /*  127932 */     // GIR_Coverage, 7894,
     /*  127932 */     GIR_EraseRootFromParent_Done,
     /*  127933 */   // Label 3225: @127933
     /*  127933 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(128007), // Rule ID 7895 //
     /*  127938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  127946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  127949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  127952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  127955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  127958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  127970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  127974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  127978 */     // MIs[1] Operand 1
     /*  127978 */     // No operand predicates
     /*  127978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  127980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  127987 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  127987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  127990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  127997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  128005 */     GIR_RootConstrainSelectedInstOperands,
     /*  128006 */     // GIR_Coverage, 7895,
     /*  128006 */     GIR_EraseRootFromParent_Done,
     /*  128007 */   // Label 3226: @128007
     /*  128007 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(128081), // Rule ID 7898 //
     /*  128012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  128023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  128026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128052 */     // MIs[1] Operand 1
     /*  128052 */     // No operand predicates
     /*  128052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128061 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  128061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  128064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  128079 */     GIR_RootConstrainSelectedInstOperands,
     /*  128080 */     // GIR_Coverage, 7898,
     /*  128080 */     GIR_EraseRootFromParent_Done,
     /*  128081 */   // Label 3227: @128081
     /*  128081 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(128155), // Rule ID 7899 //
     /*  128086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  128097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  128100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128126 */     // MIs[1] Operand 1
     /*  128126 */     // No operand predicates
     /*  128126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  128135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  128138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  128153 */     GIR_RootConstrainSelectedInstOperands,
     /*  128154 */     // GIR_Coverage, 7899,
     /*  128154 */     GIR_EraseRootFromParent_Done,
     /*  128155 */   // Label 3228: @128155
     /*  128155 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(128229), // Rule ID 7902 //
     /*  128160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  128163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  128171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  128174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  128188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128200 */     // MIs[1] Operand 1
     /*  128200 */     // No operand predicates
     /*  128200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  128209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  128212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128227 */     GIR_RootConstrainSelectedInstOperands,
     /*  128228 */     // GIR_Coverage, 7902,
     /*  128228 */     GIR_EraseRootFromParent_Done,
     /*  128229 */   // Label 3229: @128229
     /*  128229 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(128303), // Rule ID 7903 //
     /*  128234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  128237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  128245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  128248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  128262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128274 */     // MIs[1] Operand 1
     /*  128274 */     // No operand predicates
     /*  128274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128283 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  128283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  128286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128301 */     GIR_RootConstrainSelectedInstOperands,
     /*  128302 */     // GIR_Coverage, 7903,
     /*  128302 */     GIR_EraseRootFromParent_Done,
     /*  128303 */   // Label 3230: @128303
     /*  128303 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(128377), // Rule ID 7906 //
     /*  128308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  128311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  128319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  128322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  128336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128348 */     // MIs[1] Operand 1
     /*  128348 */     // No operand predicates
     /*  128348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128357 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  128357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  128360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128375 */     GIR_RootConstrainSelectedInstOperands,
     /*  128376 */     // GIR_Coverage, 7906,
     /*  128376 */     GIR_EraseRootFromParent_Done,
     /*  128377 */   // Label 3231: @128377
     /*  128377 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(128451), // Rule ID 7907 //
     /*  128382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  128385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  128393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  128396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  128410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128422 */     // MIs[1] Operand 1
     /*  128422 */     // No operand predicates
     /*  128422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  128431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  128434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128449 */     GIR_RootConstrainSelectedInstOperands,
     /*  128450 */     // GIR_Coverage, 7907,
     /*  128450 */     GIR_EraseRootFromParent_Done,
     /*  128451 */   // Label 3232: @128451
     /*  128451 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(128525), // Rule ID 7910 //
     /*  128456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  128459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  128467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  128470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128496 */     // MIs[1] Operand 1
     /*  128496 */     // No operand predicates
     /*  128496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128505 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  128505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  128508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128523 */     GIR_RootConstrainSelectedInstOperands,
     /*  128524 */     // GIR_Coverage, 7910,
     /*  128524 */     GIR_EraseRootFromParent_Done,
     /*  128525 */   // Label 3233: @128525
     /*  128525 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(128599), // Rule ID 7911 //
     /*  128530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  128533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  128538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  128541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  128544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128570 */     // MIs[1] Operand 1
     /*  128570 */     // No operand predicates
     /*  128570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128579 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  128579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  128582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  128597 */     GIR_RootConstrainSelectedInstOperands,
     /*  128598 */     // GIR_Coverage, 7911,
     /*  128598 */     GIR_EraseRootFromParent_Done,
     /*  128599 */   // Label 3234: @128599
     /*  128599 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(128673), // Rule ID 8090 //
     /*  128604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  128615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  128618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128644 */     // MIs[1] Operand 1
     /*  128644 */     // No operand predicates
     /*  128644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128653 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  128653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  128656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128671 */     GIR_RootConstrainSelectedInstOperands,
     /*  128672 */     // GIR_Coverage, 8090,
     /*  128672 */     GIR_EraseRootFromParent_Done,
     /*  128673 */   // Label 3235: @128673
     /*  128673 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(128747), // Rule ID 8091 //
     /*  128678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  128689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  128692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128718 */     // MIs[1] Operand 1
     /*  128718 */     // No operand predicates
     /*  128718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128727 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  128727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  128730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128745 */     GIR_RootConstrainSelectedInstOperands,
     /*  128746 */     // GIR_Coverage, 8091,
     /*  128746 */     GIR_EraseRootFromParent_Done,
     /*  128747 */   // Label 3236: @128747
     /*  128747 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(128821), // Rule ID 8094 //
     /*  128752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  128763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  128766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128792 */     // MIs[1] Operand 1
     /*  128792 */     // No operand predicates
     /*  128792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128801 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  128801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  128804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128819 */     GIR_RootConstrainSelectedInstOperands,
     /*  128820 */     // GIR_Coverage, 8094,
     /*  128820 */     GIR_EraseRootFromParent_Done,
     /*  128821 */   // Label 3237: @128821
     /*  128821 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(128895), // Rule ID 8095 //
     /*  128826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  128837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  128840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128866 */     // MIs[1] Operand 1
     /*  128866 */     // No operand predicates
     /*  128866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  128875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  128878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128893 */     GIR_RootConstrainSelectedInstOperands,
     /*  128894 */     // GIR_Coverage, 8095,
     /*  128894 */     GIR_EraseRootFromParent_Done,
     /*  128895 */   // Label 3238: @128895
     /*  128895 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(128969), // Rule ID 8098 //
     /*  128900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  128911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  128914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  128917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  128920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  128932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  128936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  128940 */     // MIs[1] Operand 1
     /*  128940 */     // No operand predicates
     /*  128940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  128949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  128949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  128952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  128959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  128964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128967 */     GIR_RootConstrainSelectedInstOperands,
     /*  128968 */     // GIR_Coverage, 8098,
     /*  128968 */     GIR_EraseRootFromParent_Done,
     /*  128969 */   // Label 3239: @128969
     /*  128969 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(129043), // Rule ID 8099 //
     /*  128974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  128982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  128985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  128988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  128991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  128994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129014 */     // MIs[1] Operand 1
     /*  129014 */     // No operand predicates
     /*  129014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129023 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  129023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  129026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  129041 */     GIR_RootConstrainSelectedInstOperands,
     /*  129042 */     // GIR_Coverage, 8099,
     /*  129042 */     GIR_EraseRootFromParent_Done,
     /*  129043 */   // Label 3240: @129043
     /*  129043 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(129117), // Rule ID 8102 //
     /*  129048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  129059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  129062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129088 */     // MIs[1] Operand 1
     /*  129088 */     // No operand predicates
     /*  129088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129097 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  129097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  129100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129115 */     GIR_RootConstrainSelectedInstOperands,
     /*  129116 */     // GIR_Coverage, 8102,
     /*  129116 */     GIR_EraseRootFromParent_Done,
     /*  129117 */   // Label 3241: @129117
     /*  129117 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(129191), // Rule ID 8103 //
     /*  129122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  129133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  129136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129162 */     // MIs[1] Operand 1
     /*  129162 */     // No operand predicates
     /*  129162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129171 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  129171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  129174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129189 */     GIR_RootConstrainSelectedInstOperands,
     /*  129190 */     // GIR_Coverage, 8103,
     /*  129190 */     GIR_EraseRootFromParent_Done,
     /*  129191 */   // Label 3242: @129191
     /*  129191 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(129265), // Rule ID 8106 //
     /*  129196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  129207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  129210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129236 */     // MIs[1] Operand 1
     /*  129236 */     // No operand predicates
     /*  129236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129245 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  129245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  129248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129263 */     GIR_RootConstrainSelectedInstOperands,
     /*  129264 */     // GIR_Coverage, 8106,
     /*  129264 */     GIR_EraseRootFromParent_Done,
     /*  129265 */   // Label 3243: @129265
     /*  129265 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(129339), // Rule ID 8107 //
     /*  129270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  129281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  129284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129310 */     // MIs[1] Operand 1
     /*  129310 */     // No operand predicates
     /*  129310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  129319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  129322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129337 */     GIR_RootConstrainSelectedInstOperands,
     /*  129338 */     // GIR_Coverage, 8107,
     /*  129338 */     GIR_EraseRootFromParent_Done,
     /*  129339 */   // Label 3244: @129339
     /*  129339 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(129413), // Rule ID 8110 //
     /*  129344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  129355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  129358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129384 */     // MIs[1] Operand 1
     /*  129384 */     // No operand predicates
     /*  129384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  129393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  129396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  129411 */     GIR_RootConstrainSelectedInstOperands,
     /*  129412 */     // GIR_Coverage, 8110,
     /*  129412 */     GIR_EraseRootFromParent_Done,
     /*  129413 */   // Label 3245: @129413
     /*  129413 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(129487), // Rule ID 8111 //
     /*  129418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  129429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  129432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129458 */     // MIs[1] Operand 1
     /*  129458 */     // No operand predicates
     /*  129458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  129467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  129470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  129485 */     GIR_RootConstrainSelectedInstOperands,
     /*  129486 */     // GIR_Coverage, 8111,
     /*  129486 */     GIR_EraseRootFromParent_Done,
     /*  129487 */   // Label 3246: @129487
     /*  129487 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(129561), // Rule ID 8114 //
     /*  129492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  129503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  129506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129532 */     // MIs[1] Operand 1
     /*  129532 */     // No operand predicates
     /*  129532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129541 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  129541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  129559 */     GIR_RootConstrainSelectedInstOperands,
     /*  129560 */     // GIR_Coverage, 8114,
     /*  129560 */     GIR_EraseRootFromParent_Done,
     /*  129561 */   // Label 3247: @129561
     /*  129561 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(129635), // Rule ID 8115 //
     /*  129566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  129577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  129580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129606 */     // MIs[1] Operand 1
     /*  129606 */     // No operand predicates
     /*  129606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  129615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  129633 */     GIR_RootConstrainSelectedInstOperands,
     /*  129634 */     // GIR_Coverage, 8115,
     /*  129634 */     GIR_EraseRootFromParent_Done,
     /*  129635 */   // Label 3248: @129635
     /*  129635 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(129709), // Rule ID 8118 //
     /*  129640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  129651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  129654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129680 */     // MIs[1] Operand 1
     /*  129680 */     // No operand predicates
     /*  129680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  129689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129707 */     GIR_RootConstrainSelectedInstOperands,
     /*  129708 */     // GIR_Coverage, 8118,
     /*  129708 */     GIR_EraseRootFromParent_Done,
     /*  129709 */   // Label 3249: @129709
     /*  129709 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(129783), // Rule ID 8119 //
     /*  129714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  129725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  129728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129754 */     // MIs[1] Operand 1
     /*  129754 */     // No operand predicates
     /*  129754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129763 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  129763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  129781 */     GIR_RootConstrainSelectedInstOperands,
     /*  129782 */     // GIR_Coverage, 8119,
     /*  129782 */     GIR_EraseRootFromParent_Done,
     /*  129783 */   // Label 3250: @129783
     /*  129783 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(129857), // Rule ID 8122 //
     /*  129788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  129799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  129802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129828 */     // MIs[1] Operand 1
     /*  129828 */     // No operand predicates
     /*  129828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129837 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  129837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  129855 */     GIR_RootConstrainSelectedInstOperands,
     /*  129856 */     // GIR_Coverage, 8122,
     /*  129856 */     GIR_EraseRootFromParent_Done,
     /*  129857 */   // Label 3251: @129857
     /*  129857 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(129931), // Rule ID 8123 //
     /*  129862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  129873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  129876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  129879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  129882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129902 */     // MIs[1] Operand 1
     /*  129902 */     // No operand predicates
     /*  129902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  129911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  129926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  129929 */     GIR_RootConstrainSelectedInstOperands,
     /*  129930 */     // GIR_Coverage, 8123,
     /*  129930 */     GIR_EraseRootFromParent_Done,
     /*  129931 */   // Label 3252: @129931
     /*  129931 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(130005), // Rule ID 8126 //
     /*  129936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  129939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  129944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  129947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  129950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  129953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  129956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  129968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  129976 */     // MIs[1] Operand 1
     /*  129976 */     // No operand predicates
     /*  129976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  129985 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  129985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  129988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  129995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  130003 */     GIR_RootConstrainSelectedInstOperands,
     /*  130004 */     // GIR_Coverage, 8126,
     /*  130004 */     GIR_EraseRootFromParent_Done,
     /*  130005 */   // Label 3253: @130005
     /*  130005 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(130079), // Rule ID 8127 //
     /*  130010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  130013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  130021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  130024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130050 */     // MIs[1] Operand 1
     /*  130050 */     // No operand predicates
     /*  130050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130059 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  130059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  130062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  130077 */     GIR_RootConstrainSelectedInstOperands,
     /*  130078 */     // GIR_Coverage, 8127,
     /*  130078 */     GIR_EraseRootFromParent_Done,
     /*  130079 */   // Label 3254: @130079
     /*  130079 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(130153), // Rule ID 8130 //
     /*  130084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  130095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  130098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  130112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130124 */     // MIs[1] Operand 1
     /*  130124 */     // No operand predicates
     /*  130124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130133 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  130133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  130136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130151 */     GIR_RootConstrainSelectedInstOperands,
     /*  130152 */     // GIR_Coverage, 8130,
     /*  130152 */     GIR_EraseRootFromParent_Done,
     /*  130153 */   // Label 3255: @130153
     /*  130153 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(130227), // Rule ID 8131 //
     /*  130158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  130169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  130172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  130186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130198 */     // MIs[1] Operand 1
     /*  130198 */     // No operand predicates
     /*  130198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130207 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  130207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  130210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130225 */     GIR_RootConstrainSelectedInstOperands,
     /*  130226 */     // GIR_Coverage, 8131,
     /*  130226 */     GIR_EraseRootFromParent_Done,
     /*  130227 */   // Label 3256: @130227
     /*  130227 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(130301), // Rule ID 8134 //
     /*  130232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  130243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  130246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  130260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130272 */     // MIs[1] Operand 1
     /*  130272 */     // No operand predicates
     /*  130272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130281 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  130281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  130284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130299 */     GIR_RootConstrainSelectedInstOperands,
     /*  130300 */     // GIR_Coverage, 8134,
     /*  130300 */     GIR_EraseRootFromParent_Done,
     /*  130301 */   // Label 3257: @130301
     /*  130301 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(130375), // Rule ID 8135 //
     /*  130306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  130317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  130320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  130334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130346 */     // MIs[1] Operand 1
     /*  130346 */     // No operand predicates
     /*  130346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130355 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  130355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  130358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130373 */     GIR_RootConstrainSelectedInstOperands,
     /*  130374 */     // GIR_Coverage, 8135,
     /*  130374 */     GIR_EraseRootFromParent_Done,
     /*  130375 */   // Label 3258: @130375
     /*  130375 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(130449), // Rule ID 8138 //
     /*  130380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  130391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  130394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  130408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130420 */     // MIs[1] Operand 1
     /*  130420 */     // No operand predicates
     /*  130420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130429 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  130429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  130432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130447 */     GIR_RootConstrainSelectedInstOperands,
     /*  130448 */     // GIR_Coverage, 8138,
     /*  130448 */     GIR_EraseRootFromParent_Done,
     /*  130449 */   // Label 3259: @130449
     /*  130449 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(130523), // Rule ID 8139 //
     /*  130454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  130465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  130468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  130482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130494 */     // MIs[1] Operand 1
     /*  130494 */     // No operand predicates
     /*  130494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130503 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  130503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  130506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130521 */     GIR_RootConstrainSelectedInstOperands,
     /*  130522 */     // GIR_Coverage, 8139,
     /*  130522 */     GIR_EraseRootFromParent_Done,
     /*  130523 */   // Label 3260: @130523
     /*  130523 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(130597), // Rule ID 8142 //
     /*  130528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  130539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  130542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  130556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130568 */     // MIs[1] Operand 1
     /*  130568 */     // No operand predicates
     /*  130568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130577 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  130577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  130580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130595 */     GIR_RootConstrainSelectedInstOperands,
     /*  130596 */     // GIR_Coverage, 8142,
     /*  130596 */     GIR_EraseRootFromParent_Done,
     /*  130597 */   // Label 3261: @130597
     /*  130597 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(130671), // Rule ID 8143 //
     /*  130602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  130613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  130616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  130630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130642 */     // MIs[1] Operand 1
     /*  130642 */     // No operand predicates
     /*  130642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  130651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  130654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130669 */     GIR_RootConstrainSelectedInstOperands,
     /*  130670 */     // GIR_Coverage, 8143,
     /*  130670 */     GIR_EraseRootFromParent_Done,
     /*  130671 */   // Label 3262: @130671
     /*  130671 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(130745), // Rule ID 8146 //
     /*  130676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  130687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  130690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  130704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130716 */     // MIs[1] Operand 1
     /*  130716 */     // No operand predicates
     /*  130716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130725 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  130725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  130728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130743 */     GIR_RootConstrainSelectedInstOperands,
     /*  130744 */     // GIR_Coverage, 8146,
     /*  130744 */     GIR_EraseRootFromParent_Done,
     /*  130745 */   // Label 3263: @130745
     /*  130745 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(130819), // Rule ID 8147 //
     /*  130750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  130761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  130764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  130778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130790 */     // MIs[1] Operand 1
     /*  130790 */     // No operand predicates
     /*  130790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130799 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  130799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  130802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130817 */     GIR_RootConstrainSelectedInstOperands,
     /*  130818 */     // GIR_Coverage, 8147,
     /*  130818 */     GIR_EraseRootFromParent_Done,
     /*  130819 */   // Label 3264: @130819
     /*  130819 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(130893), // Rule ID 8150 //
     /*  130824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  130835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  130838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  130852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130864 */     // MIs[1] Operand 1
     /*  130864 */     // No operand predicates
     /*  130864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130873 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  130873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  130876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130891 */     GIR_RootConstrainSelectedInstOperands,
     /*  130892 */     // GIR_Coverage, 8150,
     /*  130892 */     GIR_EraseRootFromParent_Done,
     /*  130893 */   // Label 3265: @130893
     /*  130893 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(130967), // Rule ID 8151 //
     /*  130898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  130909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  130912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  130915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  130918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  130926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  130930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  130938 */     // MIs[1] Operand 1
     /*  130938 */     // No operand predicates
     /*  130938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  130947 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  130947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  130950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  130957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  130962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130965 */     GIR_RootConstrainSelectedInstOperands,
     /*  130966 */     // GIR_Coverage, 8151,
     /*  130966 */     GIR_EraseRootFromParent_Done,
     /*  130967 */   // Label 3266: @130967
     /*  130967 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(131041), // Rule ID 8154 //
     /*  130972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  130980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  130983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  130986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  130989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  130992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131012 */     // MIs[1] Operand 1
     /*  131012 */     // No operand predicates
     /*  131012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  131021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  131024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131039 */     GIR_RootConstrainSelectedInstOperands,
     /*  131040 */     // GIR_Coverage, 8154,
     /*  131040 */     GIR_EraseRootFromParent_Done,
     /*  131041 */   // Label 3267: @131041
     /*  131041 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(131115), // Rule ID 8155 //
     /*  131046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  131057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  131060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131086 */     // MIs[1] Operand 1
     /*  131086 */     // No operand predicates
     /*  131086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131095 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  131095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  131098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131113 */     GIR_RootConstrainSelectedInstOperands,
     /*  131114 */     // GIR_Coverage, 8155,
     /*  131114 */     GIR_EraseRootFromParent_Done,
     /*  131115 */   // Label 3268: @131115
     /*  131115 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(131189), // Rule ID 8158 //
     /*  131120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  131131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  131134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  131148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131160 */     // MIs[1] Operand 1
     /*  131160 */     // No operand predicates
     /*  131160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  131169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  131172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131187 */     GIR_RootConstrainSelectedInstOperands,
     /*  131188 */     // GIR_Coverage, 8158,
     /*  131188 */     GIR_EraseRootFromParent_Done,
     /*  131189 */   // Label 3269: @131189
     /*  131189 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(131263), // Rule ID 8159 //
     /*  131194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  131205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  131208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  131222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131234 */     // MIs[1] Operand 1
     /*  131234 */     // No operand predicates
     /*  131234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131243 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  131243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  131246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131261 */     GIR_RootConstrainSelectedInstOperands,
     /*  131262 */     // GIR_Coverage, 8159,
     /*  131262 */     GIR_EraseRootFromParent_Done,
     /*  131263 */   // Label 3270: @131263
     /*  131263 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(131337), // Rule ID 8162 //
     /*  131268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  131279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  131282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  131296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131308 */     // MIs[1] Operand 1
     /*  131308 */     // No operand predicates
     /*  131308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131317 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  131317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  131320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131335 */     GIR_RootConstrainSelectedInstOperands,
     /*  131336 */     // GIR_Coverage, 8162,
     /*  131336 */     GIR_EraseRootFromParent_Done,
     /*  131337 */   // Label 3271: @131337
     /*  131337 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(131411), // Rule ID 8163 //
     /*  131342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  131353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  131356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  131370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131382 */     // MIs[1] Operand 1
     /*  131382 */     // No operand predicates
     /*  131382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  131391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  131394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131409 */     GIR_RootConstrainSelectedInstOperands,
     /*  131410 */     // GIR_Coverage, 8163,
     /*  131410 */     GIR_EraseRootFromParent_Done,
     /*  131411 */   // Label 3272: @131411
     /*  131411 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(131485), // Rule ID 8166 //
     /*  131416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  131419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  131427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  131430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131456 */     // MIs[1] Operand 1
     /*  131456 */     // No operand predicates
     /*  131456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131465 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  131465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  131468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131483 */     GIR_RootConstrainSelectedInstOperands,
     /*  131484 */     // GIR_Coverage, 8166,
     /*  131484 */     GIR_EraseRootFromParent_Done,
     /*  131485 */   // Label 3273: @131485
     /*  131485 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(131559), // Rule ID 8167 //
     /*  131490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  131493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  131501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  131504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131530 */     // MIs[1] Operand 1
     /*  131530 */     // No operand predicates
     /*  131530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  131539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  131542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131557 */     GIR_RootConstrainSelectedInstOperands,
     /*  131558 */     // GIR_Coverage, 8167,
     /*  131558 */     GIR_EraseRootFromParent_Done,
     /*  131559 */   // Label 3274: @131559
     /*  131559 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(131633), // Rule ID 8170 //
     /*  131564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  131567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  131575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  131578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  131592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131604 */     // MIs[1] Operand 1
     /*  131604 */     // No operand predicates
     /*  131604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131613 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  131613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  131616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131631 */     GIR_RootConstrainSelectedInstOperands,
     /*  131632 */     // GIR_Coverage, 8170,
     /*  131632 */     GIR_EraseRootFromParent_Done,
     /*  131633 */   // Label 3275: @131633
     /*  131633 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(131707), // Rule ID 8171 //
     /*  131638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  131641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  131649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  131652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  131666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131678 */     // MIs[1] Operand 1
     /*  131678 */     // No operand predicates
     /*  131678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131687 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  131687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  131690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131705 */     GIR_RootConstrainSelectedInstOperands,
     /*  131706 */     // GIR_Coverage, 8171,
     /*  131706 */     GIR_EraseRootFromParent_Done,
     /*  131707 */   // Label 3276: @131707
     /*  131707 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(131781), // Rule ID 8174 //
     /*  131712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  131715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  131723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  131726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  131740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131752 */     // MIs[1] Operand 1
     /*  131752 */     // No operand predicates
     /*  131752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  131761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  131764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131779 */     GIR_RootConstrainSelectedInstOperands,
     /*  131780 */     // GIR_Coverage, 8174,
     /*  131780 */     GIR_EraseRootFromParent_Done,
     /*  131781 */   // Label 3277: @131781
     /*  131781 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(131855), // Rule ID 8175 //
     /*  131786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  131789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  131794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  131797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  131800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  131814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131826 */     // MIs[1] Operand 1
     /*  131826 */     // No operand predicates
     /*  131826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131835 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  131835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  131838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131853 */     GIR_RootConstrainSelectedInstOperands,
     /*  131854 */     // GIR_Coverage, 8175,
     /*  131854 */     GIR_EraseRootFromParent_Done,
     /*  131855 */   // Label 3278: @131855
     /*  131855 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(131929), // Rule ID 8706 //
     /*  131860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  131868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  131871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  131874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  131877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  131880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131900 */     // MIs[1] Operand 1
     /*  131900 */     // No operand predicates
     /*  131900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131909 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  131909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  131912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131927 */     GIR_RootConstrainSelectedInstOperands,
     /*  131928 */     // GIR_Coverage, 8706,
     /*  131928 */     GIR_EraseRootFromParent_Done,
     /*  131929 */   // Label 3279: @131929
     /*  131929 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(132003), // Rule ID 8707 //
     /*  131934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  131942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  131945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  131948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  131951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  131954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  131966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  131974 */     // MIs[1] Operand 1
     /*  131974 */     // No operand predicates
     /*  131974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  131983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  131983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  131986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  131993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  131998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132001 */     GIR_RootConstrainSelectedInstOperands,
     /*  132002 */     // GIR_Coverage, 8707,
     /*  132002 */     GIR_EraseRootFromParent_Done,
     /*  132003 */   // Label 3280: @132003
     /*  132003 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(132077), // Rule ID 8710 //
     /*  132008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  132019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  132022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132048 */     // MIs[1] Operand 1
     /*  132048 */     // No operand predicates
     /*  132048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132057 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  132057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  132060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132075 */     GIR_RootConstrainSelectedInstOperands,
     /*  132076 */     // GIR_Coverage, 8710,
     /*  132076 */     GIR_EraseRootFromParent_Done,
     /*  132077 */   // Label 3281: @132077
     /*  132077 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(132151), // Rule ID 8711 //
     /*  132082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  132093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  132096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132122 */     // MIs[1] Operand 1
     /*  132122 */     // No operand predicates
     /*  132122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  132131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  132134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132149 */     GIR_RootConstrainSelectedInstOperands,
     /*  132150 */     // GIR_Coverage, 8711,
     /*  132150 */     GIR_EraseRootFromParent_Done,
     /*  132151 */   // Label 3282: @132151
     /*  132151 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(132225), // Rule ID 8714 //
     /*  132156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  132167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  132170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132196 */     // MIs[1] Operand 1
     /*  132196 */     // No operand predicates
     /*  132196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  132205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132223 */     GIR_RootConstrainSelectedInstOperands,
     /*  132224 */     // GIR_Coverage, 8714,
     /*  132224 */     GIR_EraseRootFromParent_Done,
     /*  132225 */   // Label 3283: @132225
     /*  132225 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(132299), // Rule ID 8715 //
     /*  132230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  132241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  132244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132270 */     // MIs[1] Operand 1
     /*  132270 */     // No operand predicates
     /*  132270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132279 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  132279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132297 */     GIR_RootConstrainSelectedInstOperands,
     /*  132298 */     // GIR_Coverage, 8715,
     /*  132298 */     GIR_EraseRootFromParent_Done,
     /*  132299 */   // Label 3284: @132299
     /*  132299 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(132373), // Rule ID 8718 //
     /*  132304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  132315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  132318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132344 */     // MIs[1] Operand 1
     /*  132344 */     // No operand predicates
     /*  132344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132353 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  132353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  132356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132371 */     GIR_RootConstrainSelectedInstOperands,
     /*  132372 */     // GIR_Coverage, 8718,
     /*  132372 */     GIR_EraseRootFromParent_Done,
     /*  132373 */   // Label 3285: @132373
     /*  132373 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(132447), // Rule ID 8719 //
     /*  132378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  132389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  132392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132418 */     // MIs[1] Operand 1
     /*  132418 */     // No operand predicates
     /*  132418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  132427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  132430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132445 */     GIR_RootConstrainSelectedInstOperands,
     /*  132446 */     // GIR_Coverage, 8719,
     /*  132446 */     GIR_EraseRootFromParent_Done,
     /*  132447 */   // Label 3286: @132447
     /*  132447 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(132521), // Rule ID 8722 //
     /*  132452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  132463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  132466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132492 */     // MIs[1] Operand 1
     /*  132492 */     // No operand predicates
     /*  132492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132501 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  132501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132519 */     GIR_RootConstrainSelectedInstOperands,
     /*  132520 */     // GIR_Coverage, 8722,
     /*  132520 */     GIR_EraseRootFromParent_Done,
     /*  132521 */   // Label 3287: @132521
     /*  132521 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(132595), // Rule ID 8723 //
     /*  132526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  132537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  132540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132566 */     // MIs[1] Operand 1
     /*  132566 */     // No operand predicates
     /*  132566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  132575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132593 */     GIR_RootConstrainSelectedInstOperands,
     /*  132594 */     // GIR_Coverage, 8723,
     /*  132594 */     GIR_EraseRootFromParent_Done,
     /*  132595 */   // Label 3288: @132595
     /*  132595 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(132669), // Rule ID 8726 //
     /*  132600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  132611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  132614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132640 */     // MIs[1] Operand 1
     /*  132640 */     // No operand predicates
     /*  132640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132649 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  132649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  132667 */     GIR_RootConstrainSelectedInstOperands,
     /*  132668 */     // GIR_Coverage, 8726,
     /*  132668 */     GIR_EraseRootFromParent_Done,
     /*  132669 */   // Label 3289: @132669
     /*  132669 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(132743), // Rule ID 8727 //
     /*  132674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  132685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  132688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132714 */     // MIs[1] Operand 1
     /*  132714 */     // No operand predicates
     /*  132714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132723 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  132723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  132726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  132741 */     GIR_RootConstrainSelectedInstOperands,
     /*  132742 */     // GIR_Coverage, 8727,
     /*  132742 */     GIR_EraseRootFromParent_Done,
     /*  132743 */   // Label 3290: @132743
     /*  132743 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(132817), // Rule ID 8730 //
     /*  132748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  132759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  132762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132788 */     // MIs[1] Operand 1
     /*  132788 */     // No operand predicates
     /*  132788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132797 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  132797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  132800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132815 */     GIR_RootConstrainSelectedInstOperands,
     /*  132816 */     // GIR_Coverage, 8730,
     /*  132816 */     GIR_EraseRootFromParent_Done,
     /*  132817 */   // Label 3291: @132817
     /*  132817 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(132891), // Rule ID 8731 //
     /*  132822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  132833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  132836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132862 */     // MIs[1] Operand 1
     /*  132862 */     // No operand predicates
     /*  132862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  132871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  132874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132889 */     GIR_RootConstrainSelectedInstOperands,
     /*  132890 */     // GIR_Coverage, 8731,
     /*  132890 */     GIR_EraseRootFromParent_Done,
     /*  132891 */   // Label 3292: @132891
     /*  132891 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(132965), // Rule ID 8734 //
     /*  132896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  132907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  132910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  132913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  132916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  132928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  132932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  132936 */     // MIs[1] Operand 1
     /*  132936 */     // No operand predicates
     /*  132936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  132945 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  132945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  132948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  132955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  132960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132963 */     GIR_RootConstrainSelectedInstOperands,
     /*  132964 */     // GIR_Coverage, 8734,
     /*  132964 */     GIR_EraseRootFromParent_Done,
     /*  132965 */   // Label 3293: @132965
     /*  132965 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(133039), // Rule ID 8735 //
     /*  132970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  132978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  132981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  132984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  132987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  132990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133010 */     // MIs[1] Operand 1
     /*  133010 */     // No operand predicates
     /*  133010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133019 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  133019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  133022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133037 */     GIR_RootConstrainSelectedInstOperands,
     /*  133038 */     // GIR_Coverage, 8735,
     /*  133038 */     GIR_EraseRootFromParent_Done,
     /*  133039 */   // Label 3294: @133039
     /*  133039 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(133113), // Rule ID 8738 //
     /*  133044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  133055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  133058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133084 */     // MIs[1] Operand 1
     /*  133084 */     // No operand predicates
     /*  133084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133093 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  133093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  133096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  133111 */     GIR_RootConstrainSelectedInstOperands,
     /*  133112 */     // GIR_Coverage, 8738,
     /*  133112 */     GIR_EraseRootFromParent_Done,
     /*  133113 */   // Label 3295: @133113
     /*  133113 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(133187), // Rule ID 8739 //
     /*  133118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  133129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  133132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133158 */     // MIs[1] Operand 1
     /*  133158 */     // No operand predicates
     /*  133158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133167 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  133167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  133170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  133185 */     GIR_RootConstrainSelectedInstOperands,
     /*  133186 */     // GIR_Coverage, 8739,
     /*  133186 */     GIR_EraseRootFromParent_Done,
     /*  133187 */   // Label 3296: @133187
     /*  133187 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(133261), // Rule ID 8742 //
     /*  133192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  133195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  133203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  133206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133232 */     // MIs[1] Operand 1
     /*  133232 */     // No operand predicates
     /*  133232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133241 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  133241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  133244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  133259 */     GIR_RootConstrainSelectedInstOperands,
     /*  133260 */     // GIR_Coverage, 8742,
     /*  133260 */     GIR_EraseRootFromParent_Done,
     /*  133261 */   // Label 3297: @133261
     /*  133261 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(133335), // Rule ID 8743 //
     /*  133266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  133269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  133277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  133280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133306 */     // MIs[1] Operand 1
     /*  133306 */     // No operand predicates
     /*  133306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  133333 */     GIR_RootConstrainSelectedInstOperands,
     /*  133334 */     // GIR_Coverage, 8743,
     /*  133334 */     GIR_EraseRootFromParent_Done,
     /*  133335 */   // Label 3298: @133335
     /*  133335 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(133409), // Rule ID 8746 //
     /*  133340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  133351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  133354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133380 */     // MIs[1] Operand 1
     /*  133380 */     // No operand predicates
     /*  133380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133389 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  133389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  133392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133407 */     GIR_RootConstrainSelectedInstOperands,
     /*  133408 */     // GIR_Coverage, 8746,
     /*  133408 */     GIR_EraseRootFromParent_Done,
     /*  133409 */   // Label 3299: @133409
     /*  133409 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(133483), // Rule ID 8747 //
     /*  133414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  133425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  133428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133454 */     // MIs[1] Operand 1
     /*  133454 */     // No operand predicates
     /*  133454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133463 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  133463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  133466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133481 */     GIR_RootConstrainSelectedInstOperands,
     /*  133482 */     // GIR_Coverage, 8747,
     /*  133482 */     GIR_EraseRootFromParent_Done,
     /*  133483 */   // Label 3300: @133483
     /*  133483 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(133557), // Rule ID 8750 //
     /*  133488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  133499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  133502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133528 */     // MIs[1] Operand 1
     /*  133528 */     // No operand predicates
     /*  133528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133537 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  133537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  133540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133555 */     GIR_RootConstrainSelectedInstOperands,
     /*  133556 */     // GIR_Coverage, 8750,
     /*  133556 */     GIR_EraseRootFromParent_Done,
     /*  133557 */   // Label 3301: @133557
     /*  133557 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(133631), // Rule ID 8751 //
     /*  133562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  133573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  133576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133602 */     // MIs[1] Operand 1
     /*  133602 */     // No operand predicates
     /*  133602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133611 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  133611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  133614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133629 */     GIR_RootConstrainSelectedInstOperands,
     /*  133630 */     // GIR_Coverage, 8751,
     /*  133630 */     GIR_EraseRootFromParent_Done,
     /*  133631 */   // Label 3302: @133631
     /*  133631 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(133705), // Rule ID 8754 //
     /*  133636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  133647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  133650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  133664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133676 */     // MIs[1] Operand 1
     /*  133676 */     // No operand predicates
     /*  133676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133685 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  133685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  133688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133703 */     GIR_RootConstrainSelectedInstOperands,
     /*  133704 */     // GIR_Coverage, 8754,
     /*  133704 */     GIR_EraseRootFromParent_Done,
     /*  133705 */   // Label 3303: @133705
     /*  133705 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(133779), // Rule ID 8755 //
     /*  133710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  133721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  133724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  133738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133750 */     // MIs[1] Operand 1
     /*  133750 */     // No operand predicates
     /*  133750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133759 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  133759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  133762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133777 */     GIR_RootConstrainSelectedInstOperands,
     /*  133778 */     // GIR_Coverage, 8755,
     /*  133778 */     GIR_EraseRootFromParent_Done,
     /*  133779 */   // Label 3304: @133779
     /*  133779 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(133853), // Rule ID 8758 //
     /*  133784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  133795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  133798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133824 */     // MIs[1] Operand 1
     /*  133824 */     // No operand predicates
     /*  133824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  133833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  133836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133851 */     GIR_RootConstrainSelectedInstOperands,
     /*  133852 */     // GIR_Coverage, 8758,
     /*  133852 */     GIR_EraseRootFromParent_Done,
     /*  133853 */   // Label 3305: @133853
     /*  133853 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(133927), // Rule ID 8759 //
     /*  133858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  133869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  133872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  133875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  133878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133898 */     // MIs[1] Operand 1
     /*  133898 */     // No operand predicates
     /*  133898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  133907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  133910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133925 */     GIR_RootConstrainSelectedInstOperands,
     /*  133926 */     // GIR_Coverage, 8759,
     /*  133926 */     GIR_EraseRootFromParent_Done,
     /*  133927 */   // Label 3306: @133927
     /*  133927 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(134001), // Rule ID 8762 //
     /*  133932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  133940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  133943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  133946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  133949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  133952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  133964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  133972 */     // MIs[1] Operand 1
     /*  133972 */     // No operand predicates
     /*  133972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  133981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  133981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  133984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  133991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  133996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133999 */     GIR_RootConstrainSelectedInstOperands,
     /*  134000 */     // GIR_Coverage, 8762,
     /*  134000 */     GIR_EraseRootFromParent_Done,
     /*  134001 */   // Label 3307: @134001
     /*  134001 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(134075), // Rule ID 8763 //
     /*  134006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  134017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  134020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134046 */     // MIs[1] Operand 1
     /*  134046 */     // No operand predicates
     /*  134046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134055 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  134055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  134058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134073 */     GIR_RootConstrainSelectedInstOperands,
     /*  134074 */     // GIR_Coverage, 8763,
     /*  134074 */     GIR_EraseRootFromParent_Done,
     /*  134075 */   // Label 3308: @134075
     /*  134075 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(134149), // Rule ID 8766 //
     /*  134080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  134091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  134094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134120 */     // MIs[1] Operand 1
     /*  134120 */     // No operand predicates
     /*  134120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134129 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  134129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  134132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134147 */     GIR_RootConstrainSelectedInstOperands,
     /*  134148 */     // GIR_Coverage, 8766,
     /*  134148 */     GIR_EraseRootFromParent_Done,
     /*  134149 */   // Label 3309: @134149
     /*  134149 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(134223), // Rule ID 8767 //
     /*  134154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  134165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  134168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134194 */     // MIs[1] Operand 1
     /*  134194 */     // No operand predicates
     /*  134194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134203 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  134203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  134206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134221 */     GIR_RootConstrainSelectedInstOperands,
     /*  134222 */     // GIR_Coverage, 8767,
     /*  134222 */     GIR_EraseRootFromParent_Done,
     /*  134223 */   // Label 3310: @134223
     /*  134223 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(134297), // Rule ID 8770 //
     /*  134228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  134239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  134242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134268 */     // MIs[1] Operand 1
     /*  134268 */     // No operand predicates
     /*  134268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134277 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  134277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  134280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134295 */     GIR_RootConstrainSelectedInstOperands,
     /*  134296 */     // GIR_Coverage, 8770,
     /*  134296 */     GIR_EraseRootFromParent_Done,
     /*  134297 */   // Label 3311: @134297
     /*  134297 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(134371), // Rule ID 8771 //
     /*  134302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  134313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  134316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134342 */     // MIs[1] Operand 1
     /*  134342 */     // No operand predicates
     /*  134342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134351 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  134351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  134354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134369 */     GIR_RootConstrainSelectedInstOperands,
     /*  134370 */     // GIR_Coverage, 8771,
     /*  134370 */     GIR_EraseRootFromParent_Done,
     /*  134371 */   // Label 3312: @134371
     /*  134371 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(134445), // Rule ID 8774 //
     /*  134376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  134387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  134390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134416 */     // MIs[1] Operand 1
     /*  134416 */     // No operand predicates
     /*  134416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134425 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  134425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  134428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134443 */     GIR_RootConstrainSelectedInstOperands,
     /*  134444 */     // GIR_Coverage, 8774,
     /*  134444 */     GIR_EraseRootFromParent_Done,
     /*  134445 */   // Label 3313: @134445
     /*  134445 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(134519), // Rule ID 8775 //
     /*  134450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  134461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  134464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134490 */     // MIs[1] Operand 1
     /*  134490 */     // No operand predicates
     /*  134490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  134499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  134502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134517 */     GIR_RootConstrainSelectedInstOperands,
     /*  134518 */     // GIR_Coverage, 8775,
     /*  134518 */     GIR_EraseRootFromParent_Done,
     /*  134519 */   // Label 3314: @134519
     /*  134519 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(134593), // Rule ID 8778 //
     /*  134524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  134535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  134538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134564 */     // MIs[1] Operand 1
     /*  134564 */     // No operand predicates
     /*  134564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134573 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  134573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  134576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134591 */     GIR_RootConstrainSelectedInstOperands,
     /*  134592 */     // GIR_Coverage, 8778,
     /*  134592 */     GIR_EraseRootFromParent_Done,
     /*  134593 */   // Label 3315: @134593
     /*  134593 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(134667), // Rule ID 8779 //
     /*  134598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  134609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  134612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134638 */     // MIs[1] Operand 1
     /*  134638 */     // No operand predicates
     /*  134638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134647 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  134647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  134650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134665 */     GIR_RootConstrainSelectedInstOperands,
     /*  134666 */     // GIR_Coverage, 8779,
     /*  134666 */     GIR_EraseRootFromParent_Done,
     /*  134667 */   // Label 3316: @134667
     /*  134667 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(134741), // Rule ID 8782 //
     /*  134672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  134675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  134683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  134686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134712 */     // MIs[1] Operand 1
     /*  134712 */     // No operand predicates
     /*  134712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  134721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  134724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134739 */     GIR_RootConstrainSelectedInstOperands,
     /*  134740 */     // GIR_Coverage, 8782,
     /*  134740 */     GIR_EraseRootFromParent_Done,
     /*  134741 */   // Label 3317: @134741
     /*  134741 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(134815), // Rule ID 8783 //
     /*  134746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  134749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  134757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  134760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134786 */     // MIs[1] Operand 1
     /*  134786 */     // No operand predicates
     /*  134786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134795 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  134795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  134798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134813 */     GIR_RootConstrainSelectedInstOperands,
     /*  134814 */     // GIR_Coverage, 8783,
     /*  134814 */     GIR_EraseRootFromParent_Done,
     /*  134815 */   // Label 3318: @134815
     /*  134815 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(134889), // Rule ID 8786 //
     /*  134820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  134823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  134831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  134834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134860 */     // MIs[1] Operand 1
     /*  134860 */     // No operand predicates
     /*  134860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  134869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  134872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134887 */     GIR_RootConstrainSelectedInstOperands,
     /*  134888 */     // GIR_Coverage, 8786,
     /*  134888 */     GIR_EraseRootFromParent_Done,
     /*  134889 */   // Label 3319: @134889
     /*  134889 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(134963), // Rule ID 8787 //
     /*  134894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  134897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  134905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  134908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  134911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  134914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  134926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  134934 */     // MIs[1] Operand 1
     /*  134934 */     // No operand predicates
     /*  134934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  134943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  134943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  134946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  134953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  134958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134961 */     GIR_RootConstrainSelectedInstOperands,
     /*  134962 */     // GIR_Coverage, 8787,
     /*  134962 */     GIR_EraseRootFromParent_Done,
     /*  134963 */   // Label 3320: @134963
     /*  134963 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(135037), // Rule ID 8790 //
     /*  134968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  134971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  134976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  134979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  134982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  134985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  134988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135008 */     // MIs[1] Operand 1
     /*  135008 */     // No operand predicates
     /*  135008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135017 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  135017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  135020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135035 */     GIR_RootConstrainSelectedInstOperands,
     /*  135036 */     // GIR_Coverage, 8790,
     /*  135036 */     GIR_EraseRootFromParent_Done,
     /*  135037 */   // Label 3321: @135037
     /*  135037 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(135111), // Rule ID 8791 //
     /*  135042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  135050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  135053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  135056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  135070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135082 */     // MIs[1] Operand 1
     /*  135082 */     // No operand predicates
     /*  135082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  135091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  135094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135109 */     GIR_RootConstrainSelectedInstOperands,
     /*  135110 */     // GIR_Coverage, 8791,
     /*  135110 */     GIR_EraseRootFromParent_Done,
     /*  135111 */   // Label 3322: @135111
     /*  135111 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(135185), // Rule ID 8970 //
     /*  135116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  135130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135156 */     // MIs[1] Operand 1
     /*  135156 */     // No operand predicates
     /*  135156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  135165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  135168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135183 */     GIR_RootConstrainSelectedInstOperands,
     /*  135184 */     // GIR_Coverage, 8970,
     /*  135184 */     GIR_EraseRootFromParent_Done,
     /*  135185 */   // Label 3323: @135185
     /*  135185 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(135259), // Rule ID 8971 //
     /*  135190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  135204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135230 */     // MIs[1] Operand 1
     /*  135230 */     // No operand predicates
     /*  135230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  135239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  135242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135257 */     GIR_RootConstrainSelectedInstOperands,
     /*  135258 */     // GIR_Coverage, 8971,
     /*  135258 */     GIR_EraseRootFromParent_Done,
     /*  135259 */   // Label 3324: @135259
     /*  135259 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(135333), // Rule ID 8974 //
     /*  135264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  135275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135304 */     // MIs[1] Operand 1
     /*  135304 */     // No operand predicates
     /*  135304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135313 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  135313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  135316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135331 */     GIR_RootConstrainSelectedInstOperands,
     /*  135332 */     // GIR_Coverage, 8974,
     /*  135332 */     GIR_EraseRootFromParent_Done,
     /*  135333 */   // Label 3325: @135333
     /*  135333 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(135407), // Rule ID 8975 //
     /*  135338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  135349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135378 */     // MIs[1] Operand 1
     /*  135378 */     // No operand predicates
     /*  135378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135387 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  135387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  135390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135405 */     GIR_RootConstrainSelectedInstOperands,
     /*  135406 */     // GIR_Coverage, 8975,
     /*  135406 */     GIR_EraseRootFromParent_Done,
     /*  135407 */   // Label 3326: @135407
     /*  135407 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(135481), // Rule ID 8978 //
     /*  135412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  135423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  135426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135452 */     // MIs[1] Operand 1
     /*  135452 */     // No operand predicates
     /*  135452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135461 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  135461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135479 */     GIR_RootConstrainSelectedInstOperands,
     /*  135480 */     // GIR_Coverage, 8978,
     /*  135480 */     GIR_EraseRootFromParent_Done,
     /*  135481 */   // Label 3327: @135481
     /*  135481 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(135555), // Rule ID 8979 //
     /*  135486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  135497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  135500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135526 */     // MIs[1] Operand 1
     /*  135526 */     // No operand predicates
     /*  135526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  135535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135553 */     GIR_RootConstrainSelectedInstOperands,
     /*  135554 */     // GIR_Coverage, 8979,
     /*  135554 */     GIR_EraseRootFromParent_Done,
     /*  135555 */   // Label 3328: @135555
     /*  135555 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(135629), // Rule ID 8982 //
     /*  135560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  135574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135600 */     // MIs[1] Operand 1
     /*  135600 */     // No operand predicates
     /*  135600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  135609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  135612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135627 */     GIR_RootConstrainSelectedInstOperands,
     /*  135628 */     // GIR_Coverage, 8982,
     /*  135628 */     GIR_EraseRootFromParent_Done,
     /*  135629 */   // Label 3329: @135629
     /*  135629 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(135703), // Rule ID 8983 //
     /*  135634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  135648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135674 */     // MIs[1] Operand 1
     /*  135674 */     // No operand predicates
     /*  135674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  135683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  135686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135701 */     GIR_RootConstrainSelectedInstOperands,
     /*  135702 */     // GIR_Coverage, 8983,
     /*  135702 */     GIR_EraseRootFromParent_Done,
     /*  135703 */   // Label 3330: @135703
     /*  135703 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(135777), // Rule ID 8986 //
     /*  135708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  135719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135748 */     // MIs[1] Operand 1
     /*  135748 */     // No operand predicates
     /*  135748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135757 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  135757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135775 */     GIR_RootConstrainSelectedInstOperands,
     /*  135776 */     // GIR_Coverage, 8986,
     /*  135776 */     GIR_EraseRootFromParent_Done,
     /*  135777 */   // Label 3331: @135777
     /*  135777 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(135851), // Rule ID 8987 //
     /*  135782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  135793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135822 */     // MIs[1] Operand 1
     /*  135822 */     // No operand predicates
     /*  135822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135831 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  135831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135849 */     GIR_RootConstrainSelectedInstOperands,
     /*  135850 */     // GIR_Coverage, 8987,
     /*  135850 */     GIR_EraseRootFromParent_Done,
     /*  135851 */   // Label 3332: @135851
     /*  135851 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(135925), // Rule ID 8990 //
     /*  135856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  135870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  135873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  135876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135896 */     // MIs[1] Operand 1
     /*  135896 */     // No operand predicates
     /*  135896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135905 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  135905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135923 */     GIR_RootConstrainSelectedInstOperands,
     /*  135924 */     // GIR_Coverage, 8990,
     /*  135924 */     GIR_EraseRootFromParent_Done,
     /*  135925 */   // Label 3333: @135925
     /*  135925 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(135999), // Rule ID 8991 //
     /*  135930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  135938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  135941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  135944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  135947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  135950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  135962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  135966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  135970 */     // MIs[1] Operand 1
     /*  135970 */     // No operand predicates
     /*  135970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  135972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  135979 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  135979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  135982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  135989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  135994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135997 */     GIR_RootConstrainSelectedInstOperands,
     /*  135998 */     // GIR_Coverage, 8991,
     /*  135998 */     GIR_EraseRootFromParent_Done,
     /*  135999 */   // Label 3334: @135999
     /*  135999 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(136073), // Rule ID 8994 //
     /*  136004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  136015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  136018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136044 */     // MIs[1] Operand 1
     /*  136044 */     // No operand predicates
     /*  136044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136053 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  136053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136071 */     GIR_RootConstrainSelectedInstOperands,
     /*  136072 */     // GIR_Coverage, 8994,
     /*  136072 */     GIR_EraseRootFromParent_Done,
     /*  136073 */   // Label 3335: @136073
     /*  136073 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(136147), // Rule ID 8995 //
     /*  136078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  136089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  136092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136118 */     // MIs[1] Operand 1
     /*  136118 */     // No operand predicates
     /*  136118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136127 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  136127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136145 */     GIR_RootConstrainSelectedInstOperands,
     /*  136146 */     // GIR_Coverage, 8995,
     /*  136146 */     GIR_EraseRootFromParent_Done,
     /*  136147 */   // Label 3336: @136147
     /*  136147 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(136221), // Rule ID 8998 //
     /*  136152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  136163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  136166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136192 */     // MIs[1] Operand 1
     /*  136192 */     // No operand predicates
     /*  136192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136201 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  136201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136219 */     GIR_RootConstrainSelectedInstOperands,
     /*  136220 */     // GIR_Coverage, 8998,
     /*  136220 */     GIR_EraseRootFromParent_Done,
     /*  136221 */   // Label 3337: @136221
     /*  136221 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(136295), // Rule ID 8999 //
     /*  136226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  136237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  136240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136266 */     // MIs[1] Operand 1
     /*  136266 */     // No operand predicates
     /*  136266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  136275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136293 */     GIR_RootConstrainSelectedInstOperands,
     /*  136294 */     // GIR_Coverage, 8999,
     /*  136294 */     GIR_EraseRootFromParent_Done,
     /*  136295 */   // Label 3338: @136295
     /*  136295 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(136369), // Rule ID 9002 //
     /*  136300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  136311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136340 */     // MIs[1] Operand 1
     /*  136340 */     // No operand predicates
     /*  136340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136349 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  136349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136367 */     GIR_RootConstrainSelectedInstOperands,
     /*  136368 */     // GIR_Coverage, 9002,
     /*  136368 */     GIR_EraseRootFromParent_Done,
     /*  136369 */   // Label 3339: @136369
     /*  136369 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(136443), // Rule ID 9003 //
     /*  136374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  136385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136414 */     // MIs[1] Operand 1
     /*  136414 */     // No operand predicates
     /*  136414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136423 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  136423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136441 */     GIR_RootConstrainSelectedInstOperands,
     /*  136442 */     // GIR_Coverage, 9003,
     /*  136442 */     GIR_EraseRootFromParent_Done,
     /*  136443 */   // Label 3340: @136443
     /*  136443 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(136517), // Rule ID 9006 //
     /*  136448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  136459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  136462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136488 */     // MIs[1] Operand 1
     /*  136488 */     // No operand predicates
     /*  136488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136497 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  136497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136515 */     GIR_RootConstrainSelectedInstOperands,
     /*  136516 */     // GIR_Coverage, 9006,
     /*  136516 */     GIR_EraseRootFromParent_Done,
     /*  136517 */   // Label 3341: @136517
     /*  136517 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(136591), // Rule ID 9007 //
     /*  136522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  136533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  136536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136562 */     // MIs[1] Operand 1
     /*  136562 */     // No operand predicates
     /*  136562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136571 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  136571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  136574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136589 */     GIR_RootConstrainSelectedInstOperands,
     /*  136590 */     // GIR_Coverage, 9007,
     /*  136590 */     GIR_EraseRootFromParent_Done,
     /*  136591 */   // Label 3342: @136591
     /*  136591 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(136665), // Rule ID 9010 //
     /*  136596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  136607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  136610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136636 */     // MIs[1] Operand 1
     /*  136636 */     // No operand predicates
     /*  136636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136645 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  136645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  136648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136663 */     GIR_RootConstrainSelectedInstOperands,
     /*  136664 */     // GIR_Coverage, 9010,
     /*  136664 */     GIR_EraseRootFromParent_Done,
     /*  136665 */   // Label 3343: @136665
     /*  136665 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(136739), // Rule ID 9011 //
     /*  136670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  136681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  136684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136710 */     // MIs[1] Operand 1
     /*  136710 */     // No operand predicates
     /*  136710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136719 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  136719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  136722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136737 */     GIR_RootConstrainSelectedInstOperands,
     /*  136738 */     // GIR_Coverage, 9011,
     /*  136738 */     GIR_EraseRootFromParent_Done,
     /*  136739 */   // Label 3344: @136739
     /*  136739 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(136813), // Rule ID 9014 //
     /*  136744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  136755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  136758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136784 */     // MIs[1] Operand 1
     /*  136784 */     // No operand predicates
     /*  136784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136793 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  136793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  136796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136811 */     GIR_RootConstrainSelectedInstOperands,
     /*  136812 */     // GIR_Coverage, 9014,
     /*  136812 */     GIR_EraseRootFromParent_Done,
     /*  136813 */   // Label 3345: @136813
     /*  136813 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(136887), // Rule ID 9015 //
     /*  136818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  136829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  136832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136858 */     // MIs[1] Operand 1
     /*  136858 */     // No operand predicates
     /*  136858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136867 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  136867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  136870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136885 */     GIR_RootConstrainSelectedInstOperands,
     /*  136886 */     // GIR_Coverage, 9015,
     /*  136886 */     GIR_EraseRootFromParent_Done,
     /*  136887 */   // Label 3346: @136887
     /*  136887 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(136961), // Rule ID 9018 //
     /*  136892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  136903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  136906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  136909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  136912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  136920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  136932 */     // MIs[1] Operand 1
     /*  136932 */     // No operand predicates
     /*  136932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  136941 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  136941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  136944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  136951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  136956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136959 */     GIR_RootConstrainSelectedInstOperands,
     /*  136960 */     // GIR_Coverage, 9018,
     /*  136960 */     GIR_EraseRootFromParent_Done,
     /*  136961 */   // Label 3347: @136961
     /*  136961 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(137035), // Rule ID 9019 //
     /*  136966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  136974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  136977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  136980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  136983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  136986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  136994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  136998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137006 */     // MIs[1] Operand 1
     /*  137006 */     // No operand predicates
     /*  137006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137015 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  137015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  137018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137033 */     GIR_RootConstrainSelectedInstOperands,
     /*  137034 */     // GIR_Coverage, 9019,
     /*  137034 */     GIR_EraseRootFromParent_Done,
     /*  137035 */   // Label 3348: @137035
     /*  137035 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(137109), // Rule ID 9022 //
     /*  137040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  137051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  137054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137080 */     // MIs[1] Operand 1
     /*  137080 */     // No operand predicates
     /*  137080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137089 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  137089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  137092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137107 */     GIR_RootConstrainSelectedInstOperands,
     /*  137108 */     // GIR_Coverage, 9022,
     /*  137108 */     GIR_EraseRootFromParent_Done,
     /*  137109 */   // Label 3349: @137109
     /*  137109 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(137183), // Rule ID 9023 //
     /*  137114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  137125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  137128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137154 */     // MIs[1] Operand 1
     /*  137154 */     // No operand predicates
     /*  137154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137163 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  137163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  137166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137181 */     GIR_RootConstrainSelectedInstOperands,
     /*  137182 */     // GIR_Coverage, 9023,
     /*  137182 */     GIR_EraseRootFromParent_Done,
     /*  137183 */   // Label 3350: @137183
     /*  137183 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(137257), // Rule ID 9026 //
     /*  137188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  137199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  137202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137228 */     // MIs[1] Operand 1
     /*  137228 */     // No operand predicates
     /*  137228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137237 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  137237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  137240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137255 */     GIR_RootConstrainSelectedInstOperands,
     /*  137256 */     // GIR_Coverage, 9026,
     /*  137256 */     GIR_EraseRootFromParent_Done,
     /*  137257 */   // Label 3351: @137257
     /*  137257 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(137331), // Rule ID 9027 //
     /*  137262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  137273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  137276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137302 */     // MIs[1] Operand 1
     /*  137302 */     // No operand predicates
     /*  137302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  137311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  137314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137329 */     GIR_RootConstrainSelectedInstOperands,
     /*  137330 */     // GIR_Coverage, 9027,
     /*  137330 */     GIR_EraseRootFromParent_Done,
     /*  137331 */   // Label 3352: @137331
     /*  137331 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(137405), // Rule ID 9030 //
     /*  137336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  137347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  137350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137376 */     // MIs[1] Operand 1
     /*  137376 */     // No operand predicates
     /*  137376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137385 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  137385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  137388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137403 */     GIR_RootConstrainSelectedInstOperands,
     /*  137404 */     // GIR_Coverage, 9030,
     /*  137404 */     GIR_EraseRootFromParent_Done,
     /*  137405 */   // Label 3353: @137405
     /*  137405 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(137479), // Rule ID 9031 //
     /*  137410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  137421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  137424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137450 */     // MIs[1] Operand 1
     /*  137450 */     // No operand predicates
     /*  137450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137459 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  137459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  137462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137477 */     GIR_RootConstrainSelectedInstOperands,
     /*  137478 */     // GIR_Coverage, 9031,
     /*  137478 */     GIR_EraseRootFromParent_Done,
     /*  137479 */   // Label 3354: @137479
     /*  137479 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(137553), // Rule ID 9034 //
     /*  137484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  137495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137524 */     // MIs[1] Operand 1
     /*  137524 */     // No operand predicates
     /*  137524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  137533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  137536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137551 */     GIR_RootConstrainSelectedInstOperands,
     /*  137552 */     // GIR_Coverage, 9034,
     /*  137552 */     GIR_EraseRootFromParent_Done,
     /*  137553 */   // Label 3355: @137553
     /*  137553 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(137627), // Rule ID 9035 //
     /*  137558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  137569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137598 */     // MIs[1] Operand 1
     /*  137598 */     // No operand predicates
     /*  137598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  137607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  137610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137625 */     GIR_RootConstrainSelectedInstOperands,
     /*  137626 */     // GIR_Coverage, 9035,
     /*  137626 */     GIR_EraseRootFromParent_Done,
     /*  137627 */   // Label 3356: @137627
     /*  137627 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(137701), // Rule ID 9038 //
     /*  137632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  137643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  137646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137672 */     // MIs[1] Operand 1
     /*  137672 */     // No operand predicates
     /*  137672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  137681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  137684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137699 */     GIR_RootConstrainSelectedInstOperands,
     /*  137700 */     // GIR_Coverage, 9038,
     /*  137700 */     GIR_EraseRootFromParent_Done,
     /*  137701 */   // Label 3357: @137701
     /*  137701 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(137775), // Rule ID 9039 //
     /*  137706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  137717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  137720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137746 */     // MIs[1] Operand 1
     /*  137746 */     // No operand predicates
     /*  137746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  137755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  137758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137773 */     GIR_RootConstrainSelectedInstOperands,
     /*  137774 */     // GIR_Coverage, 9039,
     /*  137774 */     GIR_EraseRootFromParent_Done,
     /*  137775 */   // Label 3358: @137775
     /*  137775 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(137849), // Rule ID 9042 //
     /*  137780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  137791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  137794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137820 */     // MIs[1] Operand 1
     /*  137820 */     // No operand predicates
     /*  137820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137829 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  137829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  137832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137847 */     GIR_RootConstrainSelectedInstOperands,
     /*  137848 */     // GIR_Coverage, 9042,
     /*  137848 */     GIR_EraseRootFromParent_Done,
     /*  137849 */   // Label 3359: @137849
     /*  137849 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(137923), // Rule ID 9043 //
     /*  137854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  137865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  137868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  137871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  137874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137894 */     // MIs[1] Operand 1
     /*  137894 */     // No operand predicates
     /*  137894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137903 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  137903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  137906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137921 */     GIR_RootConstrainSelectedInstOperands,
     /*  137922 */     // GIR_Coverage, 9043,
     /*  137922 */     GIR_EraseRootFromParent_Done,
     /*  137923 */   // Label 3360: @137923
     /*  137923 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(137997), // Rule ID 9046 //
     /*  137928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  137936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  137939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  137942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  137945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  137948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  137960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  137968 */     // MIs[1] Operand 1
     /*  137968 */     // No operand predicates
     /*  137968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  137977 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  137977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  137980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  137987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  137992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137995 */     GIR_RootConstrainSelectedInstOperands,
     /*  137996 */     // GIR_Coverage, 9046,
     /*  137996 */     GIR_EraseRootFromParent_Done,
     /*  137997 */   // Label 3361: @137997
     /*  137997 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(138071), // Rule ID 9047 //
     /*  138002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  138010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  138013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  138016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138042 */     // MIs[1] Operand 1
     /*  138042 */     // No operand predicates
     /*  138042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  138051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  138054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138069 */     GIR_RootConstrainSelectedInstOperands,
     /*  138070 */     // GIR_Coverage, 9047,
     /*  138070 */     GIR_EraseRootFromParent_Done,
     /*  138071 */   // Label 3362: @138071
     /*  138071 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(138145), // Rule ID 9050 //
     /*  138076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  138084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  138087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  138090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138116 */     // MIs[1] Operand 1
     /*  138116 */     // No operand predicates
     /*  138116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138125 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  138125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  138128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138143 */     GIR_RootConstrainSelectedInstOperands,
     /*  138144 */     // GIR_Coverage, 9050,
     /*  138144 */     GIR_EraseRootFromParent_Done,
     /*  138145 */   // Label 3363: @138145
     /*  138145 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(138219), // Rule ID 9051 //
     /*  138150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  138158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  138161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  138164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138190 */     // MIs[1] Operand 1
     /*  138190 */     // No operand predicates
     /*  138190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138199 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  138199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  138202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138217 */     GIR_RootConstrainSelectedInstOperands,
     /*  138218 */     // GIR_Coverage, 9051,
     /*  138218 */     GIR_EraseRootFromParent_Done,
     /*  138219 */   // Label 3364: @138219
     /*  138219 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(138293), // Rule ID 9054 //
     /*  138224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  138232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  138235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138264 */     // MIs[1] Operand 1
     /*  138264 */     // No operand predicates
     /*  138264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138273 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  138273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  138276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138291 */     GIR_RootConstrainSelectedInstOperands,
     /*  138292 */     // GIR_Coverage, 9054,
     /*  138292 */     GIR_EraseRootFromParent_Done,
     /*  138293 */   // Label 3365: @138293
     /*  138293 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(138367), // Rule ID 9055 //
     /*  138298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  138306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  138309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138338 */     // MIs[1] Operand 1
     /*  138338 */     // No operand predicates
     /*  138338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  138347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  138350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138365 */     GIR_RootConstrainSelectedInstOperands,
     /*  138366 */     // GIR_Coverage, 9055,
     /*  138366 */     GIR_EraseRootFromParent_Done,
     /*  138367 */   // Label 3366: @138367
     /*  138367 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(138441), // Rule ID 9146 //
     /*  138372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  138383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  138386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138412 */     // MIs[1] Operand 1
     /*  138412 */     // No operand predicates
     /*  138412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  138421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  138424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138439 */     GIR_RootConstrainSelectedInstOperands,
     /*  138440 */     // GIR_Coverage, 9146,
     /*  138440 */     GIR_EraseRootFromParent_Done,
     /*  138441 */   // Label 3367: @138441
     /*  138441 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(138515), // Rule ID 9147 //
     /*  138446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  138457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  138460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138486 */     // MIs[1] Operand 1
     /*  138486 */     // No operand predicates
     /*  138486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138495 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  138495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  138498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138513 */     GIR_RootConstrainSelectedInstOperands,
     /*  138514 */     // GIR_Coverage, 9147,
     /*  138514 */     GIR_EraseRootFromParent_Done,
     /*  138515 */   // Label 3368: @138515
     /*  138515 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(138589), // Rule ID 9150 //
     /*  138520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  138531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  138534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138560 */     // MIs[1] Operand 1
     /*  138560 */     // No operand predicates
     /*  138560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138569 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  138569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  138572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138587 */     GIR_RootConstrainSelectedInstOperands,
     /*  138588 */     // GIR_Coverage, 9150,
     /*  138588 */     GIR_EraseRootFromParent_Done,
     /*  138589 */   // Label 3369: @138589
     /*  138589 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(138663), // Rule ID 9151 //
     /*  138594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  138605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  138608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138634 */     // MIs[1] Operand 1
     /*  138634 */     // No operand predicates
     /*  138634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  138643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  138646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138661 */     GIR_RootConstrainSelectedInstOperands,
     /*  138662 */     // GIR_Coverage, 9151,
     /*  138662 */     GIR_EraseRootFromParent_Done,
     /*  138663 */   // Label 3370: @138663
     /*  138663 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(138737), // Rule ID 9154 //
     /*  138668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  138679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  138682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138708 */     // MIs[1] Operand 1
     /*  138708 */     // No operand predicates
     /*  138708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138717 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  138717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  138720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138735 */     GIR_RootConstrainSelectedInstOperands,
     /*  138736 */     // GIR_Coverage, 9154,
     /*  138736 */     GIR_EraseRootFromParent_Done,
     /*  138737 */   // Label 3371: @138737
     /*  138737 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(138811), // Rule ID 9155 //
     /*  138742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  138753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  138756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138782 */     // MIs[1] Operand 1
     /*  138782 */     // No operand predicates
     /*  138782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138791 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  138791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  138794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138809 */     GIR_RootConstrainSelectedInstOperands,
     /*  138810 */     // GIR_Coverage, 9155,
     /*  138810 */     GIR_EraseRootFromParent_Done,
     /*  138811 */   // Label 3372: @138811
     /*  138811 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(138885), // Rule ID 9158 //
     /*  138816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  138827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  138830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138856 */     // MIs[1] Operand 1
     /*  138856 */     // No operand predicates
     /*  138856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  138865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  138868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138883 */     GIR_RootConstrainSelectedInstOperands,
     /*  138884 */     // GIR_Coverage, 9158,
     /*  138884 */     GIR_EraseRootFromParent_Done,
     /*  138885 */   // Label 3373: @138885
     /*  138885 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(138959), // Rule ID 9159 //
     /*  138890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  138901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  138904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  138907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  138910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  138926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  138930 */     // MIs[1] Operand 1
     /*  138930 */     // No operand predicates
     /*  138930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  138939 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  138939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  138942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  138949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  138954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138957 */     GIR_RootConstrainSelectedInstOperands,
     /*  138958 */     // GIR_Coverage, 9159,
     /*  138958 */     GIR_EraseRootFromParent_Done,
     /*  138959 */   // Label 3374: @138959
     /*  138959 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(139033), // Rule ID 9162 //
     /*  138964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  138972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  138975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  138978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  138981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  138984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  138996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139004 */     // MIs[1] Operand 1
     /*  139004 */     // No operand predicates
     /*  139004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  139013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  139016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139031 */     GIR_RootConstrainSelectedInstOperands,
     /*  139032 */     // GIR_Coverage, 9162,
     /*  139032 */     GIR_EraseRootFromParent_Done,
     /*  139033 */   // Label 3375: @139033
     /*  139033 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(139107), // Rule ID 9163 //
     /*  139038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  139049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  139052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139078 */     // MIs[1] Operand 1
     /*  139078 */     // No operand predicates
     /*  139078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139087 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  139087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  139090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139105 */     GIR_RootConstrainSelectedInstOperands,
     /*  139106 */     // GIR_Coverage, 9163,
     /*  139106 */     GIR_EraseRootFromParent_Done,
     /*  139107 */   // Label 3376: @139107
     /*  139107 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(139181), // Rule ID 9166 //
     /*  139112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  139123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  139126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139152 */     // MIs[1] Operand 1
     /*  139152 */     // No operand predicates
     /*  139152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139161 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  139161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  139164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139179 */     GIR_RootConstrainSelectedInstOperands,
     /*  139180 */     // GIR_Coverage, 9166,
     /*  139180 */     GIR_EraseRootFromParent_Done,
     /*  139181 */   // Label 3377: @139181
     /*  139181 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(139255), // Rule ID 9167 //
     /*  139186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  139197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  139200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139226 */     // MIs[1] Operand 1
     /*  139226 */     // No operand predicates
     /*  139226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  139235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  139238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139253 */     GIR_RootConstrainSelectedInstOperands,
     /*  139254 */     // GIR_Coverage, 9167,
     /*  139254 */     GIR_EraseRootFromParent_Done,
     /*  139255 */   // Label 3378: @139255
     /*  139255 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(139329), // Rule ID 9170 //
     /*  139260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  139271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  139274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139300 */     // MIs[1] Operand 1
     /*  139300 */     // No operand predicates
     /*  139300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139309 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  139309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139327 */     GIR_RootConstrainSelectedInstOperands,
     /*  139328 */     // GIR_Coverage, 9170,
     /*  139328 */     GIR_EraseRootFromParent_Done,
     /*  139329 */   // Label 3379: @139329
     /*  139329 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(139403), // Rule ID 9171 //
     /*  139334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  139345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  139348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139374 */     // MIs[1] Operand 1
     /*  139374 */     // No operand predicates
     /*  139374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  139383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139401 */     GIR_RootConstrainSelectedInstOperands,
     /*  139402 */     // GIR_Coverage, 9171,
     /*  139402 */     GIR_EraseRootFromParent_Done,
     /*  139403 */   // Label 3380: @139403
     /*  139403 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(139477), // Rule ID 9174 //
     /*  139408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  139419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  139422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139448 */     // MIs[1] Operand 1
     /*  139448 */     // No operand predicates
     /*  139448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139457 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  139457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139475 */     GIR_RootConstrainSelectedInstOperands,
     /*  139476 */     // GIR_Coverage, 9174,
     /*  139476 */     GIR_EraseRootFromParent_Done,
     /*  139477 */   // Label 3381: @139477
     /*  139477 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(139551), // Rule ID 9175 //
     /*  139482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  139493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  139496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139522 */     // MIs[1] Operand 1
     /*  139522 */     // No operand predicates
     /*  139522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139531 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  139531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139549 */     GIR_RootConstrainSelectedInstOperands,
     /*  139550 */     // GIR_Coverage, 9175,
     /*  139550 */     GIR_EraseRootFromParent_Done,
     /*  139551 */   // Label 3382: @139551
     /*  139551 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(139625), // Rule ID 9178 //
     /*  139556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  139567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  139570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139596 */     // MIs[1] Operand 1
     /*  139596 */     // No operand predicates
     /*  139596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  139605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139623 */     GIR_RootConstrainSelectedInstOperands,
     /*  139624 */     // GIR_Coverage, 9178,
     /*  139624 */     GIR_EraseRootFromParent_Done,
     /*  139625 */   // Label 3383: @139625
     /*  139625 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(139699), // Rule ID 9179 //
     /*  139630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  139641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  139644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139670 */     // MIs[1] Operand 1
     /*  139670 */     // No operand predicates
     /*  139670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139679 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  139679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139697 */     GIR_RootConstrainSelectedInstOperands,
     /*  139698 */     // GIR_Coverage, 9179,
     /*  139698 */     GIR_EraseRootFromParent_Done,
     /*  139699 */   // Label 3384: @139699
     /*  139699 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(139773), // Rule ID 9182 //
     /*  139704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  139707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  139715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  139718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139744 */     // MIs[1] Operand 1
     /*  139744 */     // No operand predicates
     /*  139744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139753 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  139753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  139771 */     GIR_RootConstrainSelectedInstOperands,
     /*  139772 */     // GIR_Coverage, 9182,
     /*  139772 */     GIR_EraseRootFromParent_Done,
     /*  139773 */   // Label 3385: @139773
     /*  139773 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(139847), // Rule ID 9183 //
     /*  139778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  139781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  139789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  139792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139818 */     // MIs[1] Operand 1
     /*  139818 */     // No operand predicates
     /*  139818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139827 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  139827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  139830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  139845 */     GIR_RootConstrainSelectedInstOperands,
     /*  139846 */     // GIR_Coverage, 9183,
     /*  139846 */     GIR_EraseRootFromParent_Done,
     /*  139847 */   // Label 3386: @139847
     /*  139847 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(139921), // Rule ID 9186 //
     /*  139852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  139863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  139869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  139872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139892 */     // MIs[1] Operand 1
     /*  139892 */     // No operand predicates
     /*  139892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139901 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  139901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  139904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139919 */     GIR_RootConstrainSelectedInstOperands,
     /*  139920 */     // GIR_Coverage, 9186,
     /*  139920 */     GIR_EraseRootFromParent_Done,
     /*  139921 */   // Label 3387: @139921
     /*  139921 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(139995), // Rule ID 9187 //
     /*  139926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  139934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  139937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  139943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  139946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  139958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  139962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  139966 */     // MIs[1] Operand 1
     /*  139966 */     // No operand predicates
     /*  139966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  139968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  139975 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  139975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  139978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  139985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  139990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139993 */     GIR_RootConstrainSelectedInstOperands,
     /*  139994 */     // GIR_Coverage, 9187,
     /*  139994 */     GIR_EraseRootFromParent_Done,
     /*  139995 */   // Label 3388: @139995
     /*  139995 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(140069), // Rule ID 9190 //
     /*  140000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  140011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  140014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140040 */     // MIs[1] Operand 1
     /*  140040 */     // No operand predicates
     /*  140040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140049 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  140049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  140052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140067 */     GIR_RootConstrainSelectedInstOperands,
     /*  140068 */     // GIR_Coverage, 9190,
     /*  140068 */     GIR_EraseRootFromParent_Done,
     /*  140069 */   // Label 3389: @140069
     /*  140069 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(140143), // Rule ID 9191 //
     /*  140074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  140085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  140088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140114 */     // MIs[1] Operand 1
     /*  140114 */     // No operand predicates
     /*  140114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  140123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  140126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140141 */     GIR_RootConstrainSelectedInstOperands,
     /*  140142 */     // GIR_Coverage, 9191,
     /*  140142 */     GIR_EraseRootFromParent_Done,
     /*  140143 */   // Label 3390: @140143
     /*  140143 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(140217), // Rule ID 9194 //
     /*  140148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  140159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140188 */     // MIs[1] Operand 1
     /*  140188 */     // No operand predicates
     /*  140188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140197 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  140197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  140200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140215 */     GIR_RootConstrainSelectedInstOperands,
     /*  140216 */     // GIR_Coverage, 9194,
     /*  140216 */     GIR_EraseRootFromParent_Done,
     /*  140217 */   // Label 3391: @140217
     /*  140217 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(140291), // Rule ID 9195 //
     /*  140222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  140233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140262 */     // MIs[1] Operand 1
     /*  140262 */     // No operand predicates
     /*  140262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140271 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  140271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  140274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140289 */     GIR_RootConstrainSelectedInstOperands,
     /*  140290 */     // GIR_Coverage, 9195,
     /*  140290 */     GIR_EraseRootFromParent_Done,
     /*  140291 */   // Label 3392: @140291
     /*  140291 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(140365), // Rule ID 9198 //
     /*  140296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  140307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  140310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  140324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140336 */     // MIs[1] Operand 1
     /*  140336 */     // No operand predicates
     /*  140336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  140345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  140348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140363 */     GIR_RootConstrainSelectedInstOperands,
     /*  140364 */     // GIR_Coverage, 9198,
     /*  140364 */     GIR_EraseRootFromParent_Done,
     /*  140365 */   // Label 3393: @140365
     /*  140365 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(140439), // Rule ID 9199 //
     /*  140370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  140381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  140384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  140398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140410 */     // MIs[1] Operand 1
     /*  140410 */     // No operand predicates
     /*  140410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140419 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  140419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  140422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140437 */     GIR_RootConstrainSelectedInstOperands,
     /*  140438 */     // GIR_Coverage, 9199,
     /*  140438 */     GIR_EraseRootFromParent_Done,
     /*  140439 */   // Label 3394: @140439
     /*  140439 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(140513), // Rule ID 9202 //
     /*  140444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  140455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  140458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140484 */     // MIs[1] Operand 1
     /*  140484 */     // No operand predicates
     /*  140484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  140493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  140496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140511 */     GIR_RootConstrainSelectedInstOperands,
     /*  140512 */     // GIR_Coverage, 9202,
     /*  140512 */     GIR_EraseRootFromParent_Done,
     /*  140513 */   // Label 3395: @140513
     /*  140513 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(140587), // Rule ID 9203 //
     /*  140518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  140529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  140532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140558 */     // MIs[1] Operand 1
     /*  140558 */     // No operand predicates
     /*  140558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140567 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  140567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  140570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140585 */     GIR_RootConstrainSelectedInstOperands,
     /*  140586 */     // GIR_Coverage, 9203,
     /*  140586 */     GIR_EraseRootFromParent_Done,
     /*  140587 */   // Label 3396: @140587
     /*  140587 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(140661), // Rule ID 9206 //
     /*  140592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  140603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140632 */     // MIs[1] Operand 1
     /*  140632 */     // No operand predicates
     /*  140632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140641 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  140641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  140644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140659 */     GIR_RootConstrainSelectedInstOperands,
     /*  140660 */     // GIR_Coverage, 9206,
     /*  140660 */     GIR_EraseRootFromParent_Done,
     /*  140661 */   // Label 3397: @140661
     /*  140661 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(140735), // Rule ID 9207 //
     /*  140666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  140677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140706 */     // MIs[1] Operand 1
     /*  140706 */     // No operand predicates
     /*  140706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140715 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  140715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  140718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140733 */     GIR_RootConstrainSelectedInstOperands,
     /*  140734 */     // GIR_Coverage, 9207,
     /*  140734 */     GIR_EraseRootFromParent_Done,
     /*  140735 */   // Label 3398: @140735
     /*  140735 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(140809), // Rule ID 9210 //
     /*  140740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  140751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  140754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  140768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140780 */     // MIs[1] Operand 1
     /*  140780 */     // No operand predicates
     /*  140780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140789 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  140789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  140792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  140807 */     GIR_RootConstrainSelectedInstOperands,
     /*  140808 */     // GIR_Coverage, 9210,
     /*  140808 */     GIR_EraseRootFromParent_Done,
     /*  140809 */   // Label 3399: @140809
     /*  140809 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(140883), // Rule ID 9211 //
     /*  140814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  140825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  140828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  140842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140854 */     // MIs[1] Operand 1
     /*  140854 */     // No operand predicates
     /*  140854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  140863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  140866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  140881 */     GIR_RootConstrainSelectedInstOperands,
     /*  140882 */     // GIR_Coverage, 9211,
     /*  140882 */     GIR_EraseRootFromParent_Done,
     /*  140883 */   // Label 3400: @140883
     /*  140883 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(140957), // Rule ID 9214 //
     /*  140888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  140899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  140902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  140905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  140908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  140928 */     // MIs[1] Operand 1
     /*  140928 */     // No operand predicates
     /*  140928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  140937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  140937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  140940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  140947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  140952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  140955 */     GIR_RootConstrainSelectedInstOperands,
     /*  140956 */     // GIR_Coverage, 9214,
     /*  140956 */     GIR_EraseRootFromParent_Done,
     /*  140957 */   // Label 3401: @140957
     /*  140957 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(141031), // Rule ID 9215 //
     /*  140962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  140970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  140973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  140976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  140979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  140982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  140994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141002 */     // MIs[1] Operand 1
     /*  141002 */     // No operand predicates
     /*  141002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141011 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  141011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  141014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  141029 */     GIR_RootConstrainSelectedInstOperands,
     /*  141030 */     // GIR_Coverage, 9215,
     /*  141030 */     GIR_EraseRootFromParent_Done,
     /*  141031 */   // Label 3402: @141031
     /*  141031 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(141105), // Rule ID 9218 //
     /*  141036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  141047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  141050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141076 */     // MIs[1] Operand 1
     /*  141076 */     // No operand predicates
     /*  141076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  141085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  141088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  141103 */     GIR_RootConstrainSelectedInstOperands,
     /*  141104 */     // GIR_Coverage, 9218,
     /*  141104 */     GIR_EraseRootFromParent_Done,
     /*  141105 */   // Label 3403: @141105
     /*  141105 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(141179), // Rule ID 9219 //
     /*  141110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  141121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  141124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141150 */     // MIs[1] Operand 1
     /*  141150 */     // No operand predicates
     /*  141150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141159 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  141159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  141162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  141177 */     GIR_RootConstrainSelectedInstOperands,
     /*  141178 */     // GIR_Coverage, 9219,
     /*  141178 */     GIR_EraseRootFromParent_Done,
     /*  141179 */   // Label 3404: @141179
     /*  141179 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(141253), // Rule ID 9222 //
     /*  141184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  141187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  141195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  141198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  141212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141224 */     // MIs[1] Operand 1
     /*  141224 */     // No operand predicates
     /*  141224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141233 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  141233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  141236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141251 */     GIR_RootConstrainSelectedInstOperands,
     /*  141252 */     // GIR_Coverage, 9222,
     /*  141252 */     GIR_EraseRootFromParent_Done,
     /*  141253 */   // Label 3405: @141253
     /*  141253 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(141327), // Rule ID 9223 //
     /*  141258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  141261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  141269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  141272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  141286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141298 */     // MIs[1] Operand 1
     /*  141298 */     // No operand predicates
     /*  141298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  141307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  141310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141325 */     GIR_RootConstrainSelectedInstOperands,
     /*  141326 */     // GIR_Coverage, 9223,
     /*  141326 */     GIR_EraseRootFromParent_Done,
     /*  141327 */   // Label 3406: @141327
     /*  141327 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(141401), // Rule ID 9226 //
     /*  141332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  141335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  141343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  141346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  141360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141372 */     // MIs[1] Operand 1
     /*  141372 */     // No operand predicates
     /*  141372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141381 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  141381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  141384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141399 */     GIR_RootConstrainSelectedInstOperands,
     /*  141400 */     // GIR_Coverage, 9226,
     /*  141400 */     GIR_EraseRootFromParent_Done,
     /*  141401 */   // Label 3407: @141401
     /*  141401 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(141475), // Rule ID 9227 //
     /*  141406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  141409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  141417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  141420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  141434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141446 */     // MIs[1] Operand 1
     /*  141446 */     // No operand predicates
     /*  141446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141455 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  141455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  141458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141473 */     GIR_RootConstrainSelectedInstOperands,
     /*  141474 */     // GIR_Coverage, 9227,
     /*  141474 */     GIR_EraseRootFromParent_Done,
     /*  141475 */   // Label 3408: @141475
     /*  141475 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(141549), // Rule ID 9230 //
     /*  141480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  141483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  141491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  141494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141520 */     // MIs[1] Operand 1
     /*  141520 */     // No operand predicates
     /*  141520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  141529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  141532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141547 */     GIR_RootConstrainSelectedInstOperands,
     /*  141548 */     // GIR_Coverage, 9230,
     /*  141548 */     GIR_EraseRootFromParent_Done,
     /*  141549 */   // Label 3409: @141549
     /*  141549 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(141623), // Rule ID 9231 //
     /*  141554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  141557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  141562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  141565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  141568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141594 */     // MIs[1] Operand 1
     /*  141594 */     // No operand predicates
     /*  141594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  141603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  141606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141621 */     GIR_RootConstrainSelectedInstOperands,
     /*  141622 */     // GIR_Coverage, 9231,
     /*  141622 */     GIR_EraseRootFromParent_Done,
     /*  141623 */   // Label 3410: @141623
     /*  141623 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(141697), // Rule ID 9322 //
     /*  141628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  141636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  141639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  141642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141668 */     // MIs[1] Operand 1
     /*  141668 */     // No operand predicates
     /*  141668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141677 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  141677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  141680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141695 */     GIR_RootConstrainSelectedInstOperands,
     /*  141696 */     // GIR_Coverage, 9322,
     /*  141696 */     GIR_EraseRootFromParent_Done,
     /*  141697 */   // Label 3411: @141697
     /*  141697 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(141771), // Rule ID 9323 //
     /*  141702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  141710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  141713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  141716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141742 */     // MIs[1] Operand 1
     /*  141742 */     // No operand predicates
     /*  141742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141751 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  141751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  141754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141769 */     GIR_RootConstrainSelectedInstOperands,
     /*  141770 */     // GIR_Coverage, 9323,
     /*  141770 */     GIR_EraseRootFromParent_Done,
     /*  141771 */   // Label 3412: @141771
     /*  141771 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(141845), // Rule ID 9326 //
     /*  141776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  141784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  141787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  141790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141816 */     // MIs[1] Operand 1
     /*  141816 */     // No operand predicates
     /*  141816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  141825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  141828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141843 */     GIR_RootConstrainSelectedInstOperands,
     /*  141844 */     // GIR_Coverage, 9326,
     /*  141844 */     GIR_EraseRootFromParent_Done,
     /*  141845 */   // Label 3413: @141845
     /*  141845 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(141919), // Rule ID 9327 //
     /*  141850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  141858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  141861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  141864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  141867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  141870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141890 */     // MIs[1] Operand 1
     /*  141890 */     // No operand predicates
     /*  141890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141899 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  141899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  141902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141917 */     GIR_RootConstrainSelectedInstOperands,
     /*  141918 */     // GIR_Coverage, 9327,
     /*  141918 */     GIR_EraseRootFromParent_Done,
     /*  141919 */   // Label 3414: @141919
     /*  141919 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(141993), // Rule ID 9330 //
     /*  141924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  141932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  141935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  141938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  141941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  141944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  141956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  141964 */     // MIs[1] Operand 1
     /*  141964 */     // No operand predicates
     /*  141964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  141973 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  141973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  141976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  141983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  141988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141991 */     GIR_RootConstrainSelectedInstOperands,
     /*  141992 */     // GIR_Coverage, 9330,
     /*  141992 */     GIR_EraseRootFromParent_Done,
     /*  141993 */   // Label 3415: @141993
     /*  141993 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(142067), // Rule ID 9331 //
     /*  141998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  142009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  142012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142038 */     // MIs[1] Operand 1
     /*  142038 */     // No operand predicates
     /*  142038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  142047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  142050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  142065 */     GIR_RootConstrainSelectedInstOperands,
     /*  142066 */     // GIR_Coverage, 9331,
     /*  142066 */     GIR_EraseRootFromParent_Done,
     /*  142067 */   // Label 3416: @142067
     /*  142067 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(142141), // Rule ID 9334 //
     /*  142072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  142083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  142086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142112 */     // MIs[1] Operand 1
     /*  142112 */     // No operand predicates
     /*  142112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142121 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  142121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  142124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142139 */     GIR_RootConstrainSelectedInstOperands,
     /*  142140 */     // GIR_Coverage, 9334,
     /*  142140 */     GIR_EraseRootFromParent_Done,
     /*  142141 */   // Label 3417: @142141
     /*  142141 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(142215), // Rule ID 9335 //
     /*  142146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  142157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  142160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142186 */     // MIs[1] Operand 1
     /*  142186 */     // No operand predicates
     /*  142186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142195 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  142195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  142198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142213 */     GIR_RootConstrainSelectedInstOperands,
     /*  142214 */     // GIR_Coverage, 9335,
     /*  142214 */     GIR_EraseRootFromParent_Done,
     /*  142215 */   // Label 3418: @142215
     /*  142215 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(142289), // Rule ID 9338 //
     /*  142220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  142231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  142234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142260 */     // MIs[1] Operand 1
     /*  142260 */     // No operand predicates
     /*  142260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142269 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  142269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  142272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142287 */     GIR_RootConstrainSelectedInstOperands,
     /*  142288 */     // GIR_Coverage, 9338,
     /*  142288 */     GIR_EraseRootFromParent_Done,
     /*  142289 */   // Label 3419: @142289
     /*  142289 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(142363), // Rule ID 9339 //
     /*  142294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  142305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  142308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142334 */     // MIs[1] Operand 1
     /*  142334 */     // No operand predicates
     /*  142334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142343 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  142343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  142346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142361 */     GIR_RootConstrainSelectedInstOperands,
     /*  142362 */     // GIR_Coverage, 9339,
     /*  142362 */     GIR_EraseRootFromParent_Done,
     /*  142363 */   // Label 3420: @142363
     /*  142363 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(142437), // Rule ID 9342 //
     /*  142368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  142379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  142382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142408 */     // MIs[1] Operand 1
     /*  142408 */     // No operand predicates
     /*  142408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142417 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  142417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  142420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  142435 */     GIR_RootConstrainSelectedInstOperands,
     /*  142436 */     // GIR_Coverage, 9342,
     /*  142436 */     GIR_EraseRootFromParent_Done,
     /*  142437 */   // Label 3421: @142437
     /*  142437 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(142511), // Rule ID 9343 //
     /*  142442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  142453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  142456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142482 */     // MIs[1] Operand 1
     /*  142482 */     // No operand predicates
     /*  142482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  142491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  142494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  142509 */     GIR_RootConstrainSelectedInstOperands,
     /*  142510 */     // GIR_Coverage, 9343,
     /*  142510 */     GIR_EraseRootFromParent_Done,
     /*  142511 */   // Label 3422: @142511
     /*  142511 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(142585), // Rule ID 9346 //
     /*  142516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  142527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  142530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142556 */     // MIs[1] Operand 1
     /*  142556 */     // No operand predicates
     /*  142556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142565 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  142565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  142583 */     GIR_RootConstrainSelectedInstOperands,
     /*  142584 */     // GIR_Coverage, 9346,
     /*  142584 */     GIR_EraseRootFromParent_Done,
     /*  142585 */   // Label 3423: @142585
     /*  142585 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(142659), // Rule ID 9347 //
     /*  142590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  142601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  142604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142630 */     // MIs[1] Operand 1
     /*  142630 */     // No operand predicates
     /*  142630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  142639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  142657 */     GIR_RootConstrainSelectedInstOperands,
     /*  142658 */     // GIR_Coverage, 9347,
     /*  142658 */     GIR_EraseRootFromParent_Done,
     /*  142659 */   // Label 3424: @142659
     /*  142659 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(142733), // Rule ID 9350 //
     /*  142664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  142675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  142678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142704 */     // MIs[1] Operand 1
     /*  142704 */     // No operand predicates
     /*  142704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  142713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142731 */     GIR_RootConstrainSelectedInstOperands,
     /*  142732 */     // GIR_Coverage, 9350,
     /*  142732 */     GIR_EraseRootFromParent_Done,
     /*  142733 */   // Label 3425: @142733
     /*  142733 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(142807), // Rule ID 9351 //
     /*  142738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  142749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  142752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142778 */     // MIs[1] Operand 1
     /*  142778 */     // No operand predicates
     /*  142778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142787 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  142787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  142805 */     GIR_RootConstrainSelectedInstOperands,
     /*  142806 */     // GIR_Coverage, 9351,
     /*  142806 */     GIR_EraseRootFromParent_Done,
     /*  142807 */   // Label 3426: @142807
     /*  142807 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(142881), // Rule ID 9354 //
     /*  142812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  142823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  142826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142852 */     // MIs[1] Operand 1
     /*  142852 */     // No operand predicates
     /*  142852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  142861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  142879 */     GIR_RootConstrainSelectedInstOperands,
     /*  142880 */     // GIR_Coverage, 9354,
     /*  142880 */     GIR_EraseRootFromParent_Done,
     /*  142881 */   // Label 3427: @142881
     /*  142881 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(142955), // Rule ID 9355 //
     /*  142886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  142897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  142900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  142903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  142906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  142926 */     // MIs[1] Operand 1
     /*  142926 */     // No operand predicates
     /*  142926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  142935 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  142935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  142938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  142945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  142950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  142953 */     GIR_RootConstrainSelectedInstOperands,
     /*  142954 */     // GIR_Coverage, 9355,
     /*  142954 */     GIR_EraseRootFromParent_Done,
     /*  142955 */   // Label 3428: @142955
     /*  142955 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(143029), // Rule ID 9358 //
     /*  142960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  142963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  142968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  142971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  142974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  142977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  142980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  142992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143000 */     // MIs[1] Operand 1
     /*  143000 */     // No operand predicates
     /*  143000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143009 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  143009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  143012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143027 */     GIR_RootConstrainSelectedInstOperands,
     /*  143028 */     // GIR_Coverage, 9358,
     /*  143028 */     GIR_EraseRootFromParent_Done,
     /*  143029 */   // Label 3429: @143029
     /*  143029 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(143103), // Rule ID 9359 //
     /*  143034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  143037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  143045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  143048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143074 */     // MIs[1] Operand 1
     /*  143074 */     // No operand predicates
     /*  143074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143083 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  143083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  143086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143101 */     GIR_RootConstrainSelectedInstOperands,
     /*  143102 */     // GIR_Coverage, 9359,
     /*  143102 */     GIR_EraseRootFromParent_Done,
     /*  143103 */   // Label 3430: @143103
     /*  143103 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(143177), // Rule ID 9362 //
     /*  143108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  143119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  143122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143148 */     // MIs[1] Operand 1
     /*  143148 */     // No operand predicates
     /*  143148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143157 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  143157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  143160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143175 */     GIR_RootConstrainSelectedInstOperands,
     /*  143176 */     // GIR_Coverage, 9362,
     /*  143176 */     GIR_EraseRootFromParent_Done,
     /*  143177 */   // Label 3431: @143177
     /*  143177 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(143251), // Rule ID 9363 //
     /*  143182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  143193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  143196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143222 */     // MIs[1] Operand 1
     /*  143222 */     // No operand predicates
     /*  143222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  143231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  143234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143249 */     GIR_RootConstrainSelectedInstOperands,
     /*  143250 */     // GIR_Coverage, 9363,
     /*  143250 */     GIR_EraseRootFromParent_Done,
     /*  143251 */   // Label 3432: @143251
     /*  143251 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(143325), // Rule ID 9366 //
     /*  143256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  143267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  143270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143296 */     // MIs[1] Operand 1
     /*  143296 */     // No operand predicates
     /*  143296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143305 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  143305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  143308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143323 */     GIR_RootConstrainSelectedInstOperands,
     /*  143324 */     // GIR_Coverage, 9366,
     /*  143324 */     GIR_EraseRootFromParent_Done,
     /*  143325 */   // Label 3433: @143325
     /*  143325 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(143399), // Rule ID 9367 //
     /*  143330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  143341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  143344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143370 */     // MIs[1] Operand 1
     /*  143370 */     // No operand predicates
     /*  143370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143379 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  143379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  143382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143397 */     GIR_RootConstrainSelectedInstOperands,
     /*  143398 */     // GIR_Coverage, 9367,
     /*  143398 */     GIR_EraseRootFromParent_Done,
     /*  143399 */   // Label 3434: @143399
     /*  143399 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(143473), // Rule ID 9370 //
     /*  143404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  143415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  143418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  143432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143444 */     // MIs[1] Operand 1
     /*  143444 */     // No operand predicates
     /*  143444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143453 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  143453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  143456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143471 */     GIR_RootConstrainSelectedInstOperands,
     /*  143472 */     // GIR_Coverage, 9370,
     /*  143472 */     GIR_EraseRootFromParent_Done,
     /*  143473 */   // Label 3435: @143473
     /*  143473 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(143547), // Rule ID 9371 //
     /*  143478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  143489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  143492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  143506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143518 */     // MIs[1] Operand 1
     /*  143518 */     // No operand predicates
     /*  143518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143527 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  143527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  143530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143545 */     GIR_RootConstrainSelectedInstOperands,
     /*  143546 */     // GIR_Coverage, 9371,
     /*  143546 */     GIR_EraseRootFromParent_Done,
     /*  143547 */   // Label 3436: @143547
     /*  143547 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(143621), // Rule ID 9374 //
     /*  143552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  143563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  143566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143592 */     // MIs[1] Operand 1
     /*  143592 */     // No operand predicates
     /*  143592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143601 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  143601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  143604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143619 */     GIR_RootConstrainSelectedInstOperands,
     /*  143620 */     // GIR_Coverage, 9374,
     /*  143620 */     GIR_EraseRootFromParent_Done,
     /*  143621 */   // Label 3437: @143621
     /*  143621 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(143695), // Rule ID 9375 //
     /*  143626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  143637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  143640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143666 */     // MIs[1] Operand 1
     /*  143666 */     // No operand predicates
     /*  143666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  143675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  143678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143693 */     GIR_RootConstrainSelectedInstOperands,
     /*  143694 */     // GIR_Coverage, 9375,
     /*  143694 */     GIR_EraseRootFromParent_Done,
     /*  143695 */   // Label 3438: @143695
     /*  143695 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(143769), // Rule ID 9378 //
     /*  143700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  143711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  143714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143740 */     // MIs[1] Operand 1
     /*  143740 */     // No operand predicates
     /*  143740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  143749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  143752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143767 */     GIR_RootConstrainSelectedInstOperands,
     /*  143768 */     // GIR_Coverage, 9378,
     /*  143768 */     GIR_EraseRootFromParent_Done,
     /*  143769 */   // Label 3439: @143769
     /*  143769 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(143843), // Rule ID 9379 //
     /*  143774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  143785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  143788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143814 */     // MIs[1] Operand 1
     /*  143814 */     // No operand predicates
     /*  143814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143823 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  143823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  143826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143841 */     GIR_RootConstrainSelectedInstOperands,
     /*  143842 */     // GIR_Coverage, 9379,
     /*  143842 */     GIR_EraseRootFromParent_Done,
     /*  143843 */   // Label 3440: @143843
     /*  143843 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(143917), // Rule ID 9382 //
     /*  143848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  143859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  143862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  143865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  143868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  143876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143888 */     // MIs[1] Operand 1
     /*  143888 */     // No operand predicates
     /*  143888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143897 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  143897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  143900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143915 */     GIR_RootConstrainSelectedInstOperands,
     /*  143916 */     // GIR_Coverage, 9382,
     /*  143916 */     GIR_EraseRootFromParent_Done,
     /*  143917 */   // Label 3441: @143917
     /*  143917 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(143991), // Rule ID 9383 //
     /*  143922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  143930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  143933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  143936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  143939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  143942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  143950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  143954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  143958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  143962 */     // MIs[1] Operand 1
     /*  143962 */     // No operand predicates
     /*  143962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  143971 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  143971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  143974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  143978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  143981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  143986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143989 */     GIR_RootConstrainSelectedInstOperands,
     /*  143990 */     // GIR_Coverage, 9383,
     /*  143990 */     GIR_EraseRootFromParent_Done,
     /*  143991 */   // Label 3442: @143991
     /*  143991 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(144065), // Rule ID 9386 //
     /*  143996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  144007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  144010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  144024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144036 */     // MIs[1] Operand 1
     /*  144036 */     // No operand predicates
     /*  144036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144045 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  144045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  144048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144063 */     GIR_RootConstrainSelectedInstOperands,
     /*  144064 */     // GIR_Coverage, 9386,
     /*  144064 */     GIR_EraseRootFromParent_Done,
     /*  144065 */   // Label 3443: @144065
     /*  144065 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(144139), // Rule ID 9387 //
     /*  144070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  144081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  144084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  144098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144110 */     // MIs[1] Operand 1
     /*  144110 */     // No operand predicates
     /*  144110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144119 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  144119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  144122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144137 */     GIR_RootConstrainSelectedInstOperands,
     /*  144138 */     // GIR_Coverage, 9387,
     /*  144138 */     GIR_EraseRootFromParent_Done,
     /*  144139 */   // Label 3444: @144139
     /*  144139 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(144213), // Rule ID 9390 //
     /*  144144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  144155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  144158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  144172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144184 */     // MIs[1] Operand 1
     /*  144184 */     // No operand predicates
     /*  144184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144193 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  144193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  144196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144211 */     GIR_RootConstrainSelectedInstOperands,
     /*  144212 */     // GIR_Coverage, 9390,
     /*  144212 */     GIR_EraseRootFromParent_Done,
     /*  144213 */   // Label 3445: @144213
     /*  144213 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(144287), // Rule ID 9391 //
     /*  144218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  144229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  144232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  144246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144258 */     // MIs[1] Operand 1
     /*  144258 */     // No operand predicates
     /*  144258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  144267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  144270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144285 */     GIR_RootConstrainSelectedInstOperands,
     /*  144286 */     // GIR_Coverage, 9391,
     /*  144286 */     GIR_EraseRootFromParent_Done,
     /*  144287 */   // Label 3446: @144287
     /*  144287 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(144361), // Rule ID 9394 //
     /*  144292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  144303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  144306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  144320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144332 */     // MIs[1] Operand 1
     /*  144332 */     // No operand predicates
     /*  144332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144341 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  144341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  144344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144359 */     GIR_RootConstrainSelectedInstOperands,
     /*  144360 */     // GIR_Coverage, 9394,
     /*  144360 */     GIR_EraseRootFromParent_Done,
     /*  144361 */   // Label 3447: @144361
     /*  144361 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(144435), // Rule ID 9395 //
     /*  144366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  144377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  144380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  144394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144406 */     // MIs[1] Operand 1
     /*  144406 */     // No operand predicates
     /*  144406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  144415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  144418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144433 */     GIR_RootConstrainSelectedInstOperands,
     /*  144434 */     // GIR_Coverage, 9395,
     /*  144434 */     GIR_EraseRootFromParent_Done,
     /*  144435 */   // Label 3448: @144435
     /*  144435 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(144509), // Rule ID 9398 //
     /*  144440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  144451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  144454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  144468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144480 */     // MIs[1] Operand 1
     /*  144480 */     // No operand predicates
     /*  144480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144489 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  144489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  144492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144507 */     GIR_RootConstrainSelectedInstOperands,
     /*  144508 */     // GIR_Coverage, 9398,
     /*  144508 */     GIR_EraseRootFromParent_Done,
     /*  144509 */   // Label 3449: @144509
     /*  144509 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(144583), // Rule ID 9399 //
     /*  144514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  144525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  144528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  144542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144554 */     // MIs[1] Operand 1
     /*  144554 */     // No operand predicates
     /*  144554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144563 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  144563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  144566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144581 */     GIR_RootConstrainSelectedInstOperands,
     /*  144582 */     // GIR_Coverage, 9399,
     /*  144582 */     GIR_EraseRootFromParent_Done,
     /*  144583 */   // Label 3450: @144583
     /*  144583 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(144657), // Rule ID 9402 //
     /*  144588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  144599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  144602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  144616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144628 */     // MIs[1] Operand 1
     /*  144628 */     // No operand predicates
     /*  144628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144637 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  144637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  144640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144655 */     GIR_RootConstrainSelectedInstOperands,
     /*  144656 */     // GIR_Coverage, 9402,
     /*  144656 */     GIR_EraseRootFromParent_Done,
     /*  144657 */   // Label 3451: @144657
     /*  144657 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(144731), // Rule ID 9403 //
     /*  144662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  144673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  144676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  144690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144702 */     // MIs[1] Operand 1
     /*  144702 */     // No operand predicates
     /*  144702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144711 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  144711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  144714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144729 */     GIR_RootConstrainSelectedInstOperands,
     /*  144730 */     // GIR_Coverage, 9403,
     /*  144730 */     GIR_EraseRootFromParent_Done,
     /*  144731 */   // Label 3452: @144731
     /*  144731 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(144805), // Rule ID 9406 //
     /*  144736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  144747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  144750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  144753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  144764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144776 */     // MIs[1] Operand 1
     /*  144776 */     // No operand predicates
     /*  144776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144785 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  144785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  144788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144803 */     GIR_RootConstrainSelectedInstOperands,
     /*  144804 */     // GIR_Coverage, 9406,
     /*  144804 */     GIR_EraseRootFromParent_Done,
     /*  144805 */   // Label 3453: @144805
     /*  144805 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(144879), // Rule ID 9407 //
     /*  144810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  144818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  144821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  144824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  144827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  144830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  144838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  144842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  144846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  144850 */     // MIs[1] Operand 1
     /*  144850 */     // No operand predicates
     /*  144850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  144859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  144862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  144869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144877 */     GIR_RootConstrainSelectedInstOperands,
     /*  144878 */     // GIR_Coverage, 9407,
     /*  144878 */     GIR_EraseRootFromParent_Done,
     /*  144879 */   // Label 3454: @144879
     /*  144879 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(144935), // Rule ID 63760 //
     /*  144884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  144887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  144892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  144895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  144898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  144902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  144906 */     // MIs[0] pts
     /*  144906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  144909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  144914 */     // MIs[0] radix
     /*  144914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  144917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  144922 */     // (intrinsic_wo_chain:{ *:[i32] } 10686:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  144922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  144925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144929 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  144931 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  144933 */     GIR_RootConstrainSelectedInstOperands,
     /*  144934 */     // GIR_Coverage, 63760,
     /*  144934 */     GIR_EraseRootFromParent_Done,
     /*  144935 */   // Label 3455: @144935
     /*  144935 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(144998), // Rule ID 2544 //
     /*  144940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  144943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  144948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  144951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  144954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  144957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  144960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  144964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  144972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  144979 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  144979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  144982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  144986 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  144988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  144993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144996 */     GIR_RootConstrainSelectedInstOperands,
     /*  144997 */     // GIR_Coverage, 2544,
     /*  144997 */     GIR_EraseRootFromParent_Done,
     /*  144998 */   // Label 3456: @144998
     /*  144998 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(145061), // Rule ID 2545 //
     /*  145003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  145006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  145011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  145014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  145017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  145020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  145027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  145035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145042 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  145042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  145045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  145049 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  145051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145059 */     GIR_RootConstrainSelectedInstOperands,
     /*  145060 */     // GIR_Coverage, 2545,
     /*  145060 */     GIR_EraseRootFromParent_Done,
     /*  145061 */   // Label 3457: @145061
     /*  145061 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(145127), // Rule ID 2552 //
     /*  145066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  145074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  145077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  145083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145105 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  145105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  145108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145125 */     GIR_RootConstrainSelectedInstOperands,
     /*  145126 */     // GIR_Coverage, 2552,
     /*  145126 */     GIR_EraseRootFromParent_Done,
     /*  145127 */   // Label 3458: @145127
     /*  145127 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(145193), // Rule ID 2553 //
     /*  145132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  145140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  145143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  145149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  145171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  145174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145191 */     GIR_RootConstrainSelectedInstOperands,
     /*  145192 */     // GIR_Coverage, 2553,
     /*  145192 */     GIR_EraseRootFromParent_Done,
     /*  145193 */   // Label 3459: @145193
     /*  145193 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(145259), // Rule ID 2556 //
     /*  145198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  145206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145237 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  145237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  145240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145257 */     GIR_RootConstrainSelectedInstOperands,
     /*  145258 */     // GIR_Coverage, 2556,
     /*  145258 */     GIR_EraseRootFromParent_Done,
     /*  145259 */   // Label 3460: @145259
     /*  145259 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(145325), // Rule ID 2557 //
     /*  145264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  145272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  145303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  145306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145323 */     GIR_RootConstrainSelectedInstOperands,
     /*  145324 */     // GIR_Coverage, 2557,
     /*  145324 */     GIR_EraseRootFromParent_Done,
     /*  145325 */   // Label 3461: @145325
     /*  145325 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(145391), // Rule ID 2560 //
     /*  145330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  145333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  145338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  145347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145369 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  145369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  145372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145389 */     GIR_RootConstrainSelectedInstOperands,
     /*  145390 */     // GIR_Coverage, 2560,
     /*  145390 */     GIR_EraseRootFromParent_Done,
     /*  145391 */   // Label 3462: @145391
     /*  145391 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(145457), // Rule ID 2561 //
     /*  145396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  145399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  145404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  145413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145435 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  145435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  145438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145455 */     GIR_RootConstrainSelectedInstOperands,
     /*  145456 */     // GIR_Coverage, 2561,
     /*  145456 */     GIR_EraseRootFromParent_Done,
     /*  145457 */   // Label 3463: @145457
     /*  145457 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(145520), // Rule ID 2574 //
     /*  145462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  145470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145501 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  145501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  145504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  145508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145518 */     GIR_RootConstrainSelectedInstOperands,
     /*  145519 */     // GIR_Coverage, 2574,
     /*  145519 */     GIR_EraseRootFromParent_Done,
     /*  145520 */   // Label 3464: @145520
     /*  145520 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(145583), // Rule ID 2575 //
     /*  145525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  145533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  145564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  145567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  145571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145581 */     GIR_RootConstrainSelectedInstOperands,
     /*  145582 */     // GIR_Coverage, 2575,
     /*  145582 */     GIR_EraseRootFromParent_Done,
     /*  145583 */   // Label 3465: @145583
     /*  145583 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(145646), // Rule ID 2586 //
     /*  145588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  145596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  145627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  145630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  145634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145644 */     GIR_RootConstrainSelectedInstOperands,
     /*  145645 */     // GIR_Coverage, 2586,
     /*  145645 */     GIR_EraseRootFromParent_Done,
     /*  145646 */   // Label 3466: @145646
     /*  145646 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(145709), // Rule ID 2587 //
     /*  145651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  145659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  145690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  145693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  145697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145707 */     GIR_RootConstrainSelectedInstOperands,
     /*  145708 */     // GIR_Coverage, 2587,
     /*  145708 */     GIR_EraseRootFromParent_Done,
     /*  145709 */   // Label 3467: @145709
     /*  145709 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(145772), // Rule ID 2594 //
     /*  145714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  145722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145753 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  145753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  145756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  145760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145770 */     GIR_RootConstrainSelectedInstOperands,
     /*  145771 */     // GIR_Coverage, 2594,
     /*  145771 */     GIR_EraseRootFromParent_Done,
     /*  145772 */   // Label 3468: @145772
     /*  145772 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(145835), // Rule ID 2595 //
     /*  145777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  145785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  145791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  145794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145816 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  145816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  145819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  145823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145833 */     GIR_RootConstrainSelectedInstOperands,
     /*  145834 */     // GIR_Coverage, 2595,
     /*  145834 */     GIR_EraseRootFromParent_Done,
     /*  145835 */   // Label 3469: @145835
     /*  145835 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(145901), // Rule ID 2596 //
     /*  145840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  145843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  145848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  145857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  145879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  145882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145899 */     GIR_RootConstrainSelectedInstOperands,
     /*  145900 */     // GIR_Coverage, 2596,
     /*  145900 */     GIR_EraseRootFromParent_Done,
     /*  145901 */   // Label 3470: @145901
     /*  145901 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(145967), // Rule ID 2597 //
     /*  145906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  145909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  145914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  145917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  145920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  145923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  145926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  145945 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  145945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  145948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  145952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  145954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  145959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145965 */     GIR_RootConstrainSelectedInstOperands,
     /*  145966 */     // GIR_Coverage, 2597,
     /*  145966 */     GIR_EraseRootFromParent_Done,
     /*  145967 */   // Label 3471: @145967
     /*  145967 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(146030), // Rule ID 2608 //
     /*  145972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  145980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  145983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  145986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  145989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  145992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146011 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  146011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  146014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  146018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146028 */     GIR_RootConstrainSelectedInstOperands,
     /*  146029 */     // GIR_Coverage, 2608,
     /*  146029 */     GIR_EraseRootFromParent_Done,
     /*  146030 */   // Label 3472: @146030
     /*  146030 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(146093), // Rule ID 2609 //
     /*  146035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  146043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  146046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  146049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  146052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  146074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  146077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  146081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146091 */     GIR_RootConstrainSelectedInstOperands,
     /*  146092 */     // GIR_Coverage, 2609,
     /*  146092 */     GIR_EraseRootFromParent_Done,
     /*  146093 */   // Label 3473: @146093
     /*  146093 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(146159), // Rule ID 4748 //
     /*  146098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  146109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  146112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  146115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146137 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  146137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  146140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146157 */     GIR_RootConstrainSelectedInstOperands,
     /*  146158 */     // GIR_Coverage, 4748,
     /*  146158 */     GIR_EraseRootFromParent_Done,
     /*  146159 */   // Label 3474: @146159
     /*  146159 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(146225), // Rule ID 4749 //
     /*  146164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  146175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  146178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  146181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146203 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  146203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  146206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146223 */     GIR_RootConstrainSelectedInstOperands,
     /*  146224 */     // GIR_Coverage, 4749,
     /*  146224 */     GIR_EraseRootFromParent_Done,
     /*  146225 */   // Label 3475: @146225
     /*  146225 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(146291), // Rule ID 4752 //
     /*  146230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  146241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  146244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  146247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  146269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  146272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146289 */     GIR_RootConstrainSelectedInstOperands,
     /*  146290 */     // GIR_Coverage, 4752,
     /*  146290 */     GIR_EraseRootFromParent_Done,
     /*  146291 */   // Label 3476: @146291
     /*  146291 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(146357), // Rule ID 4753 //
     /*  146296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  146307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  146310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  146313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146335 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  146335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  146338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146355 */     GIR_RootConstrainSelectedInstOperands,
     /*  146356 */     // GIR_Coverage, 4753,
     /*  146356 */     GIR_EraseRootFromParent_Done,
     /*  146357 */   // Label 3477: @146357
     /*  146357 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(146423), // Rule ID 4756 //
     /*  146362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  146373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  146376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  146379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  146401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  146404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146421 */     GIR_RootConstrainSelectedInstOperands,
     /*  146422 */     // GIR_Coverage, 4756,
     /*  146422 */     GIR_EraseRootFromParent_Done,
     /*  146423 */   // Label 3478: @146423
     /*  146423 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(146489), // Rule ID 4757 //
     /*  146428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  146439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  146442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  146445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  146467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  146470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146487 */     GIR_RootConstrainSelectedInstOperands,
     /*  146488 */     // GIR_Coverage, 4757,
     /*  146488 */     GIR_EraseRootFromParent_Done,
     /*  146489 */   // Label 3479: @146489
     /*  146489 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(146555), // Rule ID 4760 //
     /*  146494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  146505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  146508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  146511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  146533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  146536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146553 */     GIR_RootConstrainSelectedInstOperands,
     /*  146554 */     // GIR_Coverage, 4760,
     /*  146554 */     GIR_EraseRootFromParent_Done,
     /*  146555 */   // Label 3480: @146555
     /*  146555 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(146621), // Rule ID 4761 //
     /*  146560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  146571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  146574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  146577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  146599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  146602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146619 */     GIR_RootConstrainSelectedInstOperands,
     /*  146620 */     // GIR_Coverage, 4761,
     /*  146620 */     GIR_EraseRootFromParent_Done,
     /*  146621 */   // Label 3481: @146621
     /*  146621 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(146687), // Rule ID 4764 //
     /*  146626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  146637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  146640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  146643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  146650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  146654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146665 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  146665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  146668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146685 */     GIR_RootConstrainSelectedInstOperands,
     /*  146686 */     // GIR_Coverage, 4764,
     /*  146686 */     GIR_EraseRootFromParent_Done,
     /*  146687 */   // Label 3482: @146687
     /*  146687 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(146753), // Rule ID 4765 //
     /*  146692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  146703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  146706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  146709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  146716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  146720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  146724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146731 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  146731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  146734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146751 */     GIR_RootConstrainSelectedInstOperands,
     /*  146752 */     // GIR_Coverage, 4765,
     /*  146752 */     GIR_EraseRootFromParent_Done,
     /*  146753 */   // Label 3483: @146753
     /*  146753 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(146819), // Rule ID 4768 //
     /*  146758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  146769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  146772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  146775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  146797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  146800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146817 */     GIR_RootConstrainSelectedInstOperands,
     /*  146818 */     // GIR_Coverage, 4768,
     /*  146818 */     GIR_EraseRootFromParent_Done,
     /*  146819 */   // Label 3484: @146819
     /*  146819 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(146885), // Rule ID 4769 //
     /*  146824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  146835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  146838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  146841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146863 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  146863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  146866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146883 */     GIR_RootConstrainSelectedInstOperands,
     /*  146884 */     // GIR_Coverage, 4769,
     /*  146884 */     GIR_EraseRootFromParent_Done,
     /*  146885 */   // Label 3485: @146885
     /*  146885 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(146951), // Rule ID 4772 //
     /*  146890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  146901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  146904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  146907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  146910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146929 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  146929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  146932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  146936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  146938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  146943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146949 */     GIR_RootConstrainSelectedInstOperands,
     /*  146950 */     // GIR_Coverage, 4772,
     /*  146950 */     GIR_EraseRootFromParent_Done,
     /*  146951 */   // Label 3486: @146951
     /*  146951 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(147017), // Rule ID 4773 //
     /*  146956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  146964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  146967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  146970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  146973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  146976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  146995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  146995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  146998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147015 */     GIR_RootConstrainSelectedInstOperands,
     /*  147016 */     // GIR_Coverage, 4773,
     /*  147016 */     GIR_EraseRootFromParent_Done,
     /*  147017 */   // Label 3487: @147017
     /*  147017 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(147083), // Rule ID 4776 //
     /*  147022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  147033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  147036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  147039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  147061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  147064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147081 */     GIR_RootConstrainSelectedInstOperands,
     /*  147082 */     // GIR_Coverage, 4776,
     /*  147082 */     GIR_EraseRootFromParent_Done,
     /*  147083 */   // Label 3488: @147083
     /*  147083 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(147149), // Rule ID 4777 //
     /*  147088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  147099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  147102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  147105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  147127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  147130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147147 */     GIR_RootConstrainSelectedInstOperands,
     /*  147148 */     // GIR_Coverage, 4777,
     /*  147148 */     GIR_EraseRootFromParent_Done,
     /*  147149 */   // Label 3489: @147149
     /*  147149 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(147215), // Rule ID 4780 //
     /*  147154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  147165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  147168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  147171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  147193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  147196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147213 */     GIR_RootConstrainSelectedInstOperands,
     /*  147214 */     // GIR_Coverage, 4780,
     /*  147214 */     GIR_EraseRootFromParent_Done,
     /*  147215 */   // Label 3490: @147215
     /*  147215 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(147281), // Rule ID 4781 //
     /*  147220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  147231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  147234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  147237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147259 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  147259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  147262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147279 */     GIR_RootConstrainSelectedInstOperands,
     /*  147280 */     // GIR_Coverage, 4781,
     /*  147280 */     GIR_EraseRootFromParent_Done,
     /*  147281 */   // Label 3491: @147281
     /*  147281 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(147347), // Rule ID 4784 //
     /*  147286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  147297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  147300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  147303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  147325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  147328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147345 */     GIR_RootConstrainSelectedInstOperands,
     /*  147346 */     // GIR_Coverage, 4784,
     /*  147346 */     GIR_EraseRootFromParent_Done,
     /*  147347 */   // Label 3492: @147347
     /*  147347 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(147413), // Rule ID 4785 //
     /*  147352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  147363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  147366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  147369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147391 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  147391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  147394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147411 */     GIR_RootConstrainSelectedInstOperands,
     /*  147412 */     // GIR_Coverage, 4785,
     /*  147412 */     GIR_EraseRootFromParent_Done,
     /*  147413 */   // Label 3493: @147413
     /*  147413 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(147479), // Rule ID 4788 //
     /*  147418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  147421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  147429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  147432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  147435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  147457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  147460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147477 */     GIR_RootConstrainSelectedInstOperands,
     /*  147478 */     // GIR_Coverage, 4788,
     /*  147478 */     GIR_EraseRootFromParent_Done,
     /*  147479 */   // Label 3494: @147479
     /*  147479 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(147545), // Rule ID 4789 //
     /*  147484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  147487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  147495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  147498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  147501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147523 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  147523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  147526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147543 */     GIR_RootConstrainSelectedInstOperands,
     /*  147544 */     // GIR_Coverage, 4789,
     /*  147544 */     GIR_EraseRootFromParent_Done,
     /*  147545 */   // Label 3495: @147545
     /*  147545 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(147611), // Rule ID 4792 //
     /*  147550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  147553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  147561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  147564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  147567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  147589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  147592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147609 */     GIR_RootConstrainSelectedInstOperands,
     /*  147610 */     // GIR_Coverage, 4792,
     /*  147610 */     GIR_EraseRootFromParent_Done,
     /*  147611 */   // Label 3496: @147611
     /*  147611 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(147677), // Rule ID 4793 //
     /*  147616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  147619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  147627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  147630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  147633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  147655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  147658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147675 */     GIR_RootConstrainSelectedInstOperands,
     /*  147676 */     // GIR_Coverage, 4793,
     /*  147676 */     GIR_EraseRootFromParent_Done,
     /*  147677 */   // Label 3497: @147677
     /*  147677 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(147743), // Rule ID 4796 //
     /*  147682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  147685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  147693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  147696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  147699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  147721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  147724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147741 */     GIR_RootConstrainSelectedInstOperands,
     /*  147742 */     // GIR_Coverage, 4796,
     /*  147742 */     GIR_EraseRootFromParent_Done,
     /*  147743 */   // Label 3498: @147743
     /*  147743 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(147809), // Rule ID 4797 //
     /*  147748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  147751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  147759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  147762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  147765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147787 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  147787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  147790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147807 */     GIR_RootConstrainSelectedInstOperands,
     /*  147808 */     // GIR_Coverage, 4797,
     /*  147808 */     GIR_EraseRootFromParent_Done,
     /*  147809 */   // Label 3499: @147809
     /*  147809 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(147875), // Rule ID 4800 //
     /*  147814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  147817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  147825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  147828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  147831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147853 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  147853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  147856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147873 */     GIR_RootConstrainSelectedInstOperands,
     /*  147874 */     // GIR_Coverage, 4800,
     /*  147874 */     GIR_EraseRootFromParent_Done,
     /*  147875 */   // Label 3500: @147875
     /*  147875 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(147941), // Rule ID 4801 //
     /*  147880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  147883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  147891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  147894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  147897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  147900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147919 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  147919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  147922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147939 */     GIR_RootConstrainSelectedInstOperands,
     /*  147940 */     // GIR_Coverage, 4801,
     /*  147940 */     GIR_EraseRootFromParent_Done,
     /*  147941 */   // Label 3501: @147941
     /*  147941 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(148007), // Rule ID 4804 //
     /*  147946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  147954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  147957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  147960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  147963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  147966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  147985 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  147985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  147988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  147992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  147994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  147999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148005 */     GIR_RootConstrainSelectedInstOperands,
     /*  148006 */     // GIR_Coverage, 4804,
     /*  148006 */     GIR_EraseRootFromParent_Done,
     /*  148007 */   // Label 3502: @148007
     /*  148007 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(148073), // Rule ID 4805 //
     /*  148012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  148023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  148026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  148029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  148051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  148054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148071 */     GIR_RootConstrainSelectedInstOperands,
     /*  148072 */     // GIR_Coverage, 4805,
     /*  148072 */     GIR_EraseRootFromParent_Done,
     /*  148073 */   // Label 3503: @148073
     /*  148073 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(148139), // Rule ID 4808 //
     /*  148078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  148089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  148092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  148095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  148117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  148120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148137 */     GIR_RootConstrainSelectedInstOperands,
     /*  148138 */     // GIR_Coverage, 4808,
     /*  148138 */     GIR_EraseRootFromParent_Done,
     /*  148139 */   // Label 3504: @148139
     /*  148139 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(148205), // Rule ID 4809 //
     /*  148144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  148155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  148158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  148161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  148183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  148186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148203 */     GIR_RootConstrainSelectedInstOperands,
     /*  148204 */     // GIR_Coverage, 4809,
     /*  148204 */     GIR_EraseRootFromParent_Done,
     /*  148205 */   // Label 3505: @148205
     /*  148205 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(148271), // Rule ID 4812 //
     /*  148210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  148221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  148227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  148249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  148252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148269 */     GIR_RootConstrainSelectedInstOperands,
     /*  148270 */     // GIR_Coverage, 4812,
     /*  148270 */     GIR_EraseRootFromParent_Done,
     /*  148271 */   // Label 3506: @148271
     /*  148271 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(148337), // Rule ID 4813 //
     /*  148276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  148287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  148293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  148315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  148318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148335 */     GIR_RootConstrainSelectedInstOperands,
     /*  148336 */     // GIR_Coverage, 4813,
     /*  148336 */     GIR_EraseRootFromParent_Done,
     /*  148337 */   // Label 3507: @148337
     /*  148337 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(148403), // Rule ID 4816 //
     /*  148342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  148353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  148356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  148359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148381 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  148381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  148384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148401 */     GIR_RootConstrainSelectedInstOperands,
     /*  148402 */     // GIR_Coverage, 4816,
     /*  148402 */     GIR_EraseRootFromParent_Done,
     /*  148403 */   // Label 3508: @148403
     /*  148403 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(148469), // Rule ID 4817 //
     /*  148408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  148419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  148422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  148425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148447 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  148447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  148450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148467 */     GIR_RootConstrainSelectedInstOperands,
     /*  148468 */     // GIR_Coverage, 4817,
     /*  148468 */     GIR_EraseRootFromParent_Done,
     /*  148469 */   // Label 3509: @148469
     /*  148469 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(148535), // Rule ID 4820 //
     /*  148474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  148485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  148488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  148491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  148498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  148502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148513 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  148513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  148516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148533 */     GIR_RootConstrainSelectedInstOperands,
     /*  148534 */     // GIR_Coverage, 4820,
     /*  148534 */     GIR_EraseRootFromParent_Done,
     /*  148535 */   // Label 3510: @148535
     /*  148535 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(148601), // Rule ID 4821 //
     /*  148540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  148551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  148554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  148557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  148564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  148568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  148579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  148582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148599 */     GIR_RootConstrainSelectedInstOperands,
     /*  148600 */     // GIR_Coverage, 4821,
     /*  148600 */     GIR_EraseRootFromParent_Done,
     /*  148601 */   // Label 3511: @148601
     /*  148601 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(148667), // Rule ID 4824 //
     /*  148606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  148609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  148617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  148620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  148623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148645 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  148645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  148648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148665 */     GIR_RootConstrainSelectedInstOperands,
     /*  148666 */     // GIR_Coverage, 4824,
     /*  148666 */     GIR_EraseRootFromParent_Done,
     /*  148667 */   // Label 3512: @148667
     /*  148667 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(148733), // Rule ID 4825 //
     /*  148672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  148675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  148683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  148686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  148689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148711 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  148711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  148714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148731 */     GIR_RootConstrainSelectedInstOperands,
     /*  148732 */     // GIR_Coverage, 4825,
     /*  148732 */     GIR_EraseRootFromParent_Done,
     /*  148733 */   // Label 3513: @148733
     /*  148733 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(148799), // Rule ID 4828 //
     /*  148738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  148741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  148749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  148752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  148755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  148777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  148780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148797 */     GIR_RootConstrainSelectedInstOperands,
     /*  148798 */     // GIR_Coverage, 4828,
     /*  148798 */     GIR_EraseRootFromParent_Done,
     /*  148799 */   // Label 3514: @148799
     /*  148799 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(148865), // Rule ID 4829 //
     /*  148804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  148807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  148815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  148818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  148821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  148843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  148846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148863 */     GIR_RootConstrainSelectedInstOperands,
     /*  148864 */     // GIR_Coverage, 4829,
     /*  148864 */     GIR_EraseRootFromParent_Done,
     /*  148865 */   // Label 3515: @148865
     /*  148865 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(148931), // Rule ID 4832 //
     /*  148870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  148873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  148881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  148887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  148890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  148909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  148912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148929 */     GIR_RootConstrainSelectedInstOperands,
     /*  148930 */     // GIR_Coverage, 4832,
     /*  148930 */     GIR_EraseRootFromParent_Done,
     /*  148931 */   // Label 3516: @148931
     /*  148931 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(148997), // Rule ID 4833 //
     /*  148936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  148939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  148944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  148947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  148953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  148956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  148975 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  148975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  148978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  148982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  148984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  148989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148995 */     GIR_RootConstrainSelectedInstOperands,
     /*  148996 */     // GIR_Coverage, 4833,
     /*  148996 */     GIR_EraseRootFromParent_Done,
     /*  148997 */   // Label 3517: @148997
     /*  148997 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(149063), // Rule ID 4836 //
     /*  149002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  149005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  149013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  149019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  149041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  149044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149061 */     GIR_RootConstrainSelectedInstOperands,
     /*  149062 */     // GIR_Coverage, 4836,
     /*  149062 */     GIR_EraseRootFromParent_Done,
     /*  149063 */   // Label 3518: @149063
     /*  149063 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(149129), // Rule ID 4837 //
     /*  149068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  149071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  149079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  149085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  149107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  149110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149127 */     GIR_RootConstrainSelectedInstOperands,
     /*  149128 */     // GIR_Coverage, 4837,
     /*  149128 */     GIR_EraseRootFromParent_Done,
     /*  149129 */   // Label 3519: @149129
     /*  149129 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(149195), // Rule ID 4840 //
     /*  149134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  149137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  149145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  149148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  149151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149173 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  149173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  149176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149193 */     GIR_RootConstrainSelectedInstOperands,
     /*  149194 */     // GIR_Coverage, 4840,
     /*  149194 */     GIR_EraseRootFromParent_Done,
     /*  149195 */   // Label 3520: @149195
     /*  149195 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(149261), // Rule ID 4841 //
     /*  149200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  149203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  149211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  149214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  149217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149239 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  149239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  149242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149259 */     GIR_RootConstrainSelectedInstOperands,
     /*  149260 */     // GIR_Coverage, 4841,
     /*  149260 */     GIR_EraseRootFromParent_Done,
     /*  149261 */   // Label 3521: @149261
     /*  149261 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(149327), // Rule ID 4844 //
     /*  149266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  149269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  149277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  149280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  149283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  149305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  149308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149325 */     GIR_RootConstrainSelectedInstOperands,
     /*  149326 */     // GIR_Coverage, 4844,
     /*  149326 */     GIR_EraseRootFromParent_Done,
     /*  149327 */   // Label 3522: @149327
     /*  149327 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(149393), // Rule ID 4845 //
     /*  149332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  149335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  149343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  149346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  149349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11368:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  149371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  149374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149391 */     GIR_RootConstrainSelectedInstOperands,
     /*  149392 */     // GIR_Coverage, 4845,
     /*  149392 */     GIR_EraseRootFromParent_Done,
     /*  149393 */   // Label 3523: @149393
     /*  149393 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(149459), // Rule ID 4848 //
     /*  149398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  149401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  149409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  149412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  149415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149437 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  149437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  149440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149457 */     GIR_RootConstrainSelectedInstOperands,
     /*  149458 */     // GIR_Coverage, 4848,
     /*  149458 */     GIR_EraseRootFromParent_Done,
     /*  149459 */   // Label 3524: @149459
     /*  149459 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(149525), // Rule ID 4849 //
     /*  149464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  149467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  149475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  149478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  149481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149503 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11368:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  149503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  149506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149523 */     GIR_RootConstrainSelectedInstOperands,
     /*  149524 */     // GIR_Coverage, 4849,
     /*  149524 */     GIR_EraseRootFromParent_Done,
     /*  149525 */   // Label 3525: @149525
     /*  149525 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(149591), // Rule ID 4852 //
     /*  149530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  149533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  149541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  149547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  149569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  149572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149589 */     GIR_RootConstrainSelectedInstOperands,
     /*  149590 */     // GIR_Coverage, 4852,
     /*  149590 */     GIR_EraseRootFromParent_Done,
     /*  149591 */   // Label 3526: @149591
     /*  149591 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(149657), // Rule ID 4853 //
     /*  149596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  149599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  149604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  149607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  149613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149635 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11368:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  149635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  149638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149655 */     GIR_RootConstrainSelectedInstOperands,
     /*  149656 */     // GIR_Coverage, 4853,
     /*  149656 */     GIR_EraseRootFromParent_Done,
     /*  149657 */   // Label 3527: @149657
     /*  149657 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(149723), // Rule ID 4856 //
     /*  149662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  149670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  149673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  149676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  149679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149701 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  149701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  149704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149721 */     GIR_RootConstrainSelectedInstOperands,
     /*  149722 */     // GIR_Coverage, 4856,
     /*  149722 */     GIR_EraseRootFromParent_Done,
     /*  149723 */   // Label 3528: @149723
     /*  149723 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(149789), // Rule ID 4857 //
     /*  149728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  149736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  149739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  149742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  149745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149767 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  149767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  149770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149787 */     GIR_RootConstrainSelectedInstOperands,
     /*  149788 */     // GIR_Coverage, 4857,
     /*  149788 */     GIR_EraseRootFromParent_Done,
     /*  149789 */   // Label 3529: @149789
     /*  149789 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(149855), // Rule ID 4860 //
     /*  149794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  149802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  149805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  149808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  149811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  149833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  149836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149853 */     GIR_RootConstrainSelectedInstOperands,
     /*  149854 */     // GIR_Coverage, 4860,
     /*  149854 */     GIR_EraseRootFromParent_Done,
     /*  149855 */   // Label 3530: @149855
     /*  149855 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(149921), // Rule ID 4861 //
     /*  149860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  149868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  149871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  149874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  149877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  149880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  149899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  149902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149919 */     GIR_RootConstrainSelectedInstOperands,
     /*  149920 */     // GIR_Coverage, 4861,
     /*  149920 */     GIR_EraseRootFromParent_Done,
     /*  149921 */   // Label 3531: @149921
     /*  149921 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(149987), // Rule ID 4864 //
     /*  149926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  149934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  149937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  149940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  149943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  149946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  149965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  149965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  149968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  149972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  149974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  149979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149985 */     GIR_RootConstrainSelectedInstOperands,
     /*  149986 */     // GIR_Coverage, 4864,
     /*  149986 */     GIR_EraseRootFromParent_Done,
     /*  149987 */   // Label 3532: @149987
     /*  149987 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(150053), // Rule ID 4865 //
     /*  149992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  150003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  150006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  150009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150031 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  150031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  150034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150051 */     GIR_RootConstrainSelectedInstOperands,
     /*  150052 */     // GIR_Coverage, 4865,
     /*  150052 */     GIR_EraseRootFromParent_Done,
     /*  150053 */   // Label 3533: @150053
     /*  150053 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(150119), // Rule ID 4868 //
     /*  150058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  150069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  150072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  150075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  150097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  150100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150117 */     GIR_RootConstrainSelectedInstOperands,
     /*  150118 */     // GIR_Coverage, 4868,
     /*  150118 */     GIR_EraseRootFromParent_Done,
     /*  150119 */   // Label 3534: @150119
     /*  150119 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(150185), // Rule ID 4869 //
     /*  150124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  150135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  150138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  150141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  150163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  150166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150183 */     GIR_RootConstrainSelectedInstOperands,
     /*  150184 */     // GIR_Coverage, 4869,
     /*  150184 */     GIR_EraseRootFromParent_Done,
     /*  150185 */   // Label 3535: @150185
     /*  150185 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(150251), // Rule ID 4872 //
     /*  150190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  150201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  150204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  150207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150229 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  150229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  150232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150249 */     GIR_RootConstrainSelectedInstOperands,
     /*  150250 */     // GIR_Coverage, 4872,
     /*  150250 */     GIR_EraseRootFromParent_Done,
     /*  150251 */   // Label 3536: @150251
     /*  150251 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(150317), // Rule ID 4873 //
     /*  150256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  150267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  150270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  150273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150295 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  150295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  150298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150315 */     GIR_RootConstrainSelectedInstOperands,
     /*  150316 */     // GIR_Coverage, 4873,
     /*  150316 */     GIR_EraseRootFromParent_Done,
     /*  150317 */   // Label 3537: @150317
     /*  150317 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(150383), // Rule ID 4876 //
     /*  150322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  150333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  150336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  150339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  150361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  150364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150381 */     GIR_RootConstrainSelectedInstOperands,
     /*  150382 */     // GIR_Coverage, 4876,
     /*  150382 */     GIR_EraseRootFromParent_Done,
     /*  150383 */   // Label 3538: @150383
     /*  150383 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(150449), // Rule ID 4877 //
     /*  150388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  150399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  150402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  150405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150427 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  150427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  150430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150447 */     GIR_RootConstrainSelectedInstOperands,
     /*  150448 */     // GIR_Coverage, 4877,
     /*  150448 */     GIR_EraseRootFromParent_Done,
     /*  150449 */   // Label 3539: @150449
     /*  150449 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(150515), // Rule ID 4880 //
     /*  150454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  150465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  150468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  150471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  150493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  150496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150513 */     GIR_RootConstrainSelectedInstOperands,
     /*  150514 */     // GIR_Coverage, 4880,
     /*  150514 */     GIR_EraseRootFromParent_Done,
     /*  150515 */   // Label 3540: @150515
     /*  150515 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(150581), // Rule ID 4881 //
     /*  150520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  150531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  150534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  150537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150559 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  150559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  150562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150579 */     GIR_RootConstrainSelectedInstOperands,
     /*  150580 */     // GIR_Coverage, 4881,
     /*  150580 */     GIR_EraseRootFromParent_Done,
     /*  150581 */   // Label 3541: @150581
     /*  150581 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(150647), // Rule ID 4884 //
     /*  150586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  150597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  150600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  150603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  150625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  150628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150645 */     GIR_RootConstrainSelectedInstOperands,
     /*  150646 */     // GIR_Coverage, 4884,
     /*  150646 */     GIR_EraseRootFromParent_Done,
     /*  150647 */   // Label 3542: @150647
     /*  150647 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(150713), // Rule ID 4885 //
     /*  150652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  150663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  150666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  150669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  150691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  150694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150711 */     GIR_RootConstrainSelectedInstOperands,
     /*  150712 */     // GIR_Coverage, 4885,
     /*  150712 */     GIR_EraseRootFromParent_Done,
     /*  150713 */   // Label 3543: @150713
     /*  150713 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(150779), // Rule ID 4888 //
     /*  150718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  150729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  150732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  150735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  150757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  150760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150777 */     GIR_RootConstrainSelectedInstOperands,
     /*  150778 */     // GIR_Coverage, 4888,
     /*  150778 */     GIR_EraseRootFromParent_Done,
     /*  150779 */   // Label 3544: @150779
     /*  150779 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(150845), // Rule ID 4889 //
     /*  150784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  150795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  150798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  150801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150823 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  150823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  150826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150843 */     GIR_RootConstrainSelectedInstOperands,
     /*  150844 */     // GIR_Coverage, 4889,
     /*  150844 */     GIR_EraseRootFromParent_Done,
     /*  150845 */   // Label 3545: @150845
     /*  150845 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(150911), // Rule ID 4892 //
     /*  150850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  150861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  150867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  150870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  150889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  150892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150909 */     GIR_RootConstrainSelectedInstOperands,
     /*  150910 */     // GIR_Coverage, 4892,
     /*  150910 */     GIR_EraseRootFromParent_Done,
     /*  150911 */   // Label 3546: @150911
     /*  150911 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(150977), // Rule ID 4893 //
     /*  150916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  150927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  150933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  150936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  150955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  150955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  150958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  150962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  150964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  150969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150975 */     GIR_RootConstrainSelectedInstOperands,
     /*  150976 */     // GIR_Coverage, 4893,
     /*  150976 */     GIR_EraseRootFromParent_Done,
     /*  150977 */   // Label 3547: @150977
     /*  150977 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(151043), // Rule ID 4896 //
     /*  150982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  150990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  150993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  150996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  150999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  151021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  151024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151041 */     GIR_RootConstrainSelectedInstOperands,
     /*  151042 */     // GIR_Coverage, 4896,
     /*  151042 */     GIR_EraseRootFromParent_Done,
     /*  151043 */   // Label 3548: @151043
     /*  151043 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(151109), // Rule ID 4897 //
     /*  151048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  151059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  151062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  151065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151087 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  151087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  151090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151107 */     GIR_RootConstrainSelectedInstOperands,
     /*  151108 */     // GIR_Coverage, 4897,
     /*  151108 */     GIR_EraseRootFromParent_Done,
     /*  151109 */   // Label 3549: @151109
     /*  151109 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(151175), // Rule ID 4900 //
     /*  151114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  151117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  151125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  151128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  151131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  151153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  151156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151173 */     GIR_RootConstrainSelectedInstOperands,
     /*  151174 */     // GIR_Coverage, 4900,
     /*  151174 */     GIR_EraseRootFromParent_Done,
     /*  151175 */   // Label 3550: @151175
     /*  151175 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(151241), // Rule ID 4901 //
     /*  151180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  151183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  151191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  151194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  151197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151219 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  151219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  151222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151239 */     GIR_RootConstrainSelectedInstOperands,
     /*  151240 */     // GIR_Coverage, 4901,
     /*  151240 */     GIR_EraseRootFromParent_Done,
     /*  151241 */   // Label 3551: @151241
     /*  151241 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(151307), // Rule ID 4904 //
     /*  151246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  151249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  151257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  151260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  151263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  151285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  151288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151305 */     GIR_RootConstrainSelectedInstOperands,
     /*  151306 */     // GIR_Coverage, 4904,
     /*  151306 */     GIR_EraseRootFromParent_Done,
     /*  151307 */   // Label 3552: @151307
     /*  151307 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(151373), // Rule ID 4905 //
     /*  151312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  151315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  151323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  151326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  151329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  151351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  151354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151371 */     GIR_RootConstrainSelectedInstOperands,
     /*  151372 */     // GIR_Coverage, 4905,
     /*  151372 */     GIR_EraseRootFromParent_Done,
     /*  151373 */   // Label 3553: @151373
     /*  151373 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(151439), // Rule ID 4908 //
     /*  151378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  151381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  151389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  151392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  151395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151417 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  151417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  151420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151437 */     GIR_RootConstrainSelectedInstOperands,
     /*  151438 */     // GIR_Coverage, 4908,
     /*  151438 */     GIR_EraseRootFromParent_Done,
     /*  151439 */   // Label 3554: @151439
     /*  151439 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(151505), // Rule ID 4909 //
     /*  151444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  151447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  151455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  151458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  151461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  151483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  151486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151503 */     GIR_RootConstrainSelectedInstOperands,
     /*  151504 */     // GIR_Coverage, 4909,
     /*  151504 */     GIR_EraseRootFromParent_Done,
     /*  151505 */   // Label 3555: @151505
     /*  151505 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(151571), // Rule ID 4912 //
     /*  151510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  151513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  151521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  151524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  151527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151549 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  151549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  151552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151569 */     GIR_RootConstrainSelectedInstOperands,
     /*  151570 */     // GIR_Coverage, 4912,
     /*  151570 */     GIR_EraseRootFromParent_Done,
     /*  151571 */   // Label 3556: @151571
     /*  151571 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(151637), // Rule ID 4913 //
     /*  151576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  151579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  151587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  151590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  151593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151615 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  151615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  151618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  151632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151635 */     GIR_RootConstrainSelectedInstOperands,
     /*  151636 */     // GIR_Coverage, 4913,
     /*  151636 */     GIR_EraseRootFromParent_Done,
     /*  151637 */   // Label 3557: @151637
     /*  151637 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(151703), // Rule ID 4916 //
     /*  151642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  151653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  151656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  151659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  151681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  151684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151701 */     GIR_RootConstrainSelectedInstOperands,
     /*  151702 */     // GIR_Coverage, 4916,
     /*  151702 */     GIR_EraseRootFromParent_Done,
     /*  151703 */   // Label 3558: @151703
     /*  151703 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(151769), // Rule ID 4917 //
     /*  151708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  151719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  151722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  151725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151747 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  151747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  151750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151767 */     GIR_RootConstrainSelectedInstOperands,
     /*  151768 */     // GIR_Coverage, 4917,
     /*  151768 */     GIR_EraseRootFromParent_Done,
     /*  151769 */   // Label 3559: @151769
     /*  151769 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(151835), // Rule ID 4920 //
     /*  151774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  151785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  151788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  151791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151813 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  151813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  151816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151833 */     GIR_RootConstrainSelectedInstOperands,
     /*  151834 */     // GIR_Coverage, 4920,
     /*  151834 */     GIR_EraseRootFromParent_Done,
     /*  151835 */   // Label 3560: @151835
     /*  151835 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(151901), // Rule ID 4921 //
     /*  151840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  151851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  151854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  151857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151879 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  151879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  151882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151899 */     GIR_RootConstrainSelectedInstOperands,
     /*  151900 */     // GIR_Coverage, 4921,
     /*  151900 */     GIR_EraseRootFromParent_Done,
     /*  151901 */   // Label 3561: @151901
     /*  151901 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(151967), // Rule ID 4924 //
     /*  151906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  151917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  151920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  151923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  151926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  151945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  151945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  151948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  151952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  151954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  151959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151965 */     GIR_RootConstrainSelectedInstOperands,
     /*  151966 */     // GIR_Coverage, 4924,
     /*  151966 */     GIR_EraseRootFromParent_Done,
     /*  151967 */   // Label 3562: @151967
     /*  151967 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(152033), // Rule ID 4925 //
     /*  151972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  151980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  151983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  151986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  151989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  151992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  152011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  152014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152031 */     GIR_RootConstrainSelectedInstOperands,
     /*  152032 */     // GIR_Coverage, 4925,
     /*  152032 */     GIR_EraseRootFromParent_Done,
     /*  152033 */   // Label 3563: @152033
     /*  152033 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(152099), // Rule ID 4928 //
     /*  152038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  152049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  152052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  152055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  152077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  152080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152097 */     GIR_RootConstrainSelectedInstOperands,
     /*  152098 */     // GIR_Coverage, 4928,
     /*  152098 */     GIR_EraseRootFromParent_Done,
     /*  152099 */   // Label 3564: @152099
     /*  152099 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(152165), // Rule ID 4929 //
     /*  152104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  152115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  152118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  152121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  152143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  152146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152163 */     GIR_RootConstrainSelectedInstOperands,
     /*  152164 */     // GIR_Coverage, 4929,
     /*  152164 */     GIR_EraseRootFromParent_Done,
     /*  152165 */   // Label 3565: @152165
     /*  152165 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(152231), // Rule ID 4932 //
     /*  152170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  152181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  152187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  152209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  152212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152229 */     GIR_RootConstrainSelectedInstOperands,
     /*  152230 */     // GIR_Coverage, 4932,
     /*  152230 */     GIR_EraseRootFromParent_Done,
     /*  152231 */   // Label 3566: @152231
     /*  152231 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(152297), // Rule ID 4933 //
     /*  152236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  152247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  152253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152275 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  152275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  152278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152295 */     GIR_RootConstrainSelectedInstOperands,
     /*  152296 */     // GIR_Coverage, 4933,
     /*  152296 */     GIR_EraseRootFromParent_Done,
     /*  152297 */   // Label 3567: @152297
     /*  152297 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(152363), // Rule ID 4936 //
     /*  152302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  152313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  152316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  152319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152341 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  152341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  152344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152361 */     GIR_RootConstrainSelectedInstOperands,
     /*  152362 */     // GIR_Coverage, 4936,
     /*  152362 */     GIR_EraseRootFromParent_Done,
     /*  152363 */   // Label 3568: @152363
     /*  152363 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(152429), // Rule ID 4937 //
     /*  152368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  152371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  152379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  152382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  152385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152407 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  152407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  152410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152427 */     GIR_RootConstrainSelectedInstOperands,
     /*  152428 */     // GIR_Coverage, 4937,
     /*  152428 */     GIR_EraseRootFromParent_Done,
     /*  152429 */   // Label 3569: @152429
     /*  152429 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(152495), // Rule ID 4940 //
     /*  152434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  152445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  152448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  152451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  152473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  152476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152493 */     GIR_RootConstrainSelectedInstOperands,
     /*  152494 */     // GIR_Coverage, 4940,
     /*  152494 */     GIR_EraseRootFromParent_Done,
     /*  152495 */   // Label 3570: @152495
     /*  152495 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(152561), // Rule ID 4941 //
     /*  152500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  152503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  152511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  152514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  152517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  152539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  152542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152559 */     GIR_RootConstrainSelectedInstOperands,
     /*  152560 */     // GIR_Coverage, 4941,
     /*  152560 */     GIR_EraseRootFromParent_Done,
     /*  152561 */   // Label 3571: @152561
     /*  152561 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(152627), // Rule ID 4944 //
     /*  152566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  152577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  152580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  152583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152605 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  152605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  152608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152625 */     GIR_RootConstrainSelectedInstOperands,
     /*  152626 */     // GIR_Coverage, 4944,
     /*  152626 */     GIR_EraseRootFromParent_Done,
     /*  152627 */   // Label 3572: @152627
     /*  152627 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(152693), // Rule ID 4945 //
     /*  152632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  152635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  152643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  152646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  152649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  152671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  152674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152691 */     GIR_RootConstrainSelectedInstOperands,
     /*  152692 */     // GIR_Coverage, 4945,
     /*  152692 */     GIR_EraseRootFromParent_Done,
     /*  152693 */   // Label 3573: @152693
     /*  152693 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(152759), // Rule ID 4948 //
     /*  152698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  152709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  152712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  152715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  152737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  152740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152757 */     GIR_RootConstrainSelectedInstOperands,
     /*  152758 */     // GIR_Coverage, 4948,
     /*  152758 */     GIR_EraseRootFromParent_Done,
     /*  152759 */   // Label 3574: @152759
     /*  152759 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(152825), // Rule ID 4949 //
     /*  152764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  152767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  152775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  152778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  152781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152803 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  152803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  152806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152823 */     GIR_RootConstrainSelectedInstOperands,
     /*  152824 */     // GIR_Coverage, 4949,
     /*  152824 */     GIR_EraseRootFromParent_Done,
     /*  152825 */   // Label 3575: @152825
     /*  152825 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(152891), // Rule ID 4952 //
     /*  152830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  152841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  152844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  152847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  152869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  152872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152889 */     GIR_RootConstrainSelectedInstOperands,
     /*  152890 */     // GIR_Coverage, 4952,
     /*  152890 */     GIR_EraseRootFromParent_Done,
     /*  152891 */   // Label 3576: @152891
     /*  152891 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(152957), // Rule ID 4953 //
     /*  152896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  152899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  152907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  152910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  152913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  152916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  152935 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  152935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  152938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  152942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  152944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  152949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  152952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152955 */     GIR_RootConstrainSelectedInstOperands,
     /*  152956 */     // GIR_Coverage, 4953,
     /*  152956 */     GIR_EraseRootFromParent_Done,
     /*  152957 */   // Label 3577: @152957
     /*  152957 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(153023), // Rule ID 4956 //
     /*  152962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  152965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  152970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  152973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  152976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  152979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  152982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  153001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  153004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153021 */     GIR_RootConstrainSelectedInstOperands,
     /*  153022 */     // GIR_Coverage, 4956,
     /*  153022 */     GIR_EraseRootFromParent_Done,
     /*  153023 */   // Label 3578: @153023
     /*  153023 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(153089), // Rule ID 4957 //
     /*  153028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  153031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  153036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  153039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  153042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  153045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  153052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  153056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153067 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  153067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  153070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153087 */     GIR_RootConstrainSelectedInstOperands,
     /*  153088 */     // GIR_Coverage, 4957,
     /*  153088 */     GIR_EraseRootFromParent_Done,
     /*  153089 */   // Label 3579: @153089
     /*  153089 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(153155), // Rule ID 4960 //
     /*  153094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  153097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  153102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  153105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  153108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  153111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153153 */     GIR_RootConstrainSelectedInstOperands,
     /*  153154 */     // GIR_Coverage, 4960,
     /*  153154 */     GIR_EraseRootFromParent_Done,
     /*  153155 */   // Label 3580: @153155
     /*  153155 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(153221), // Rule ID 4961 //
     /*  153160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  153163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  153168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  153171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  153174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  153177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  153199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  153202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153219 */     GIR_RootConstrainSelectedInstOperands,
     /*  153220 */     // GIR_Coverage, 4961,
     /*  153220 */     GIR_EraseRootFromParent_Done,
     /*  153221 */   // Label 3581: @153221
     /*  153221 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(153287), // Rule ID 4964 //
     /*  153226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  153229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  153234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  153237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  153240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  153243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153265 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  153265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  153268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153285 */     GIR_RootConstrainSelectedInstOperands,
     /*  153286 */     // GIR_Coverage, 4964,
     /*  153286 */     GIR_EraseRootFromParent_Done,
     /*  153287 */   // Label 3582: @153287
     /*  153287 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(153353), // Rule ID 4965 //
     /*  153292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  153295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  153300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  153303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  153306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  153309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  153331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  153334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  153338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  153348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153351 */     GIR_RootConstrainSelectedInstOperands,
     /*  153352 */     // GIR_Coverage, 4965,
     /*  153352 */     GIR_EraseRootFromParent_Done,
     /*  153353 */   // Label 3583: @153353
     /*  153353 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(153416), // Rule ID 5228 //
     /*  153358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  153369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  153372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  153375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153397 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  153397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  153400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153414 */     GIR_RootConstrainSelectedInstOperands,
     /*  153415 */     // GIR_Coverage, 5228,
     /*  153415 */     GIR_EraseRootFromParent_Done,
     /*  153416 */   // Label 3584: @153416
     /*  153416 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(153479), // Rule ID 5229 //
     /*  153421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  153432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  153435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  153438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  153460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  153463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153477 */     GIR_RootConstrainSelectedInstOperands,
     /*  153478 */     // GIR_Coverage, 5229,
     /*  153478 */     GIR_EraseRootFromParent_Done,
     /*  153479 */   // Label 3585: @153479
     /*  153479 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(153542), // Rule ID 5230 //
     /*  153484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  153495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  153498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  153501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153523 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  153523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153540 */     GIR_RootConstrainSelectedInstOperands,
     /*  153541 */     // GIR_Coverage, 5230,
     /*  153541 */     GIR_EraseRootFromParent_Done,
     /*  153542 */   // Label 3586: @153542
     /*  153542 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(153605), // Rule ID 5231 //
     /*  153547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  153558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  153561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  153564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153586 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  153586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153603 */     GIR_RootConstrainSelectedInstOperands,
     /*  153604 */     // GIR_Coverage, 5231,
     /*  153604 */     GIR_EraseRootFromParent_Done,
     /*  153605 */   // Label 3587: @153605
     /*  153605 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(153668), // Rule ID 5232 //
     /*  153610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  153621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  153624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  153627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153649 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  153649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  153652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153666 */     GIR_RootConstrainSelectedInstOperands,
     /*  153667 */     // GIR_Coverage, 5232,
     /*  153667 */     GIR_EraseRootFromParent_Done,
     /*  153668 */   // Label 3588: @153668
     /*  153668 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(153731), // Rule ID 5233 //
     /*  153673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  153684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  153687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  153690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  153712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  153715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153729 */     GIR_RootConstrainSelectedInstOperands,
     /*  153730 */     // GIR_Coverage, 5233,
     /*  153730 */     GIR_EraseRootFromParent_Done,
     /*  153731 */   // Label 3589: @153731
     /*  153731 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(153794), // Rule ID 5234 //
     /*  153736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  153747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  153750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  153753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  153775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153792 */     GIR_RootConstrainSelectedInstOperands,
     /*  153793 */     // GIR_Coverage, 5234,
     /*  153793 */     GIR_EraseRootFromParent_Done,
     /*  153794 */   // Label 3590: @153794
     /*  153794 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(153857), // Rule ID 5235 //
     /*  153799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  153810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  153813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  153816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  153838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153855 */     GIR_RootConstrainSelectedInstOperands,
     /*  153856 */     // GIR_Coverage, 5235,
     /*  153856 */     GIR_EraseRootFromParent_Done,
     /*  153857 */   // Label 3591: @153857
     /*  153857 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(153920), // Rule ID 5236 //
     /*  153862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  153873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  153876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  153879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  153882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153901 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  153901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  153918 */     GIR_RootConstrainSelectedInstOperands,
     /*  153919 */     // GIR_Coverage, 5236,
     /*  153919 */     GIR_EraseRootFromParent_Done,
     /*  153920 */   // Label 3592: @153920
     /*  153920 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(153983), // Rule ID 5237 //
     /*  153925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  153936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  153939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  153942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  153945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  153964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  153964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  153967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  153971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  153973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  153978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  153981 */     GIR_RootConstrainSelectedInstOperands,
     /*  153982 */     // GIR_Coverage, 5237,
     /*  153982 */     GIR_EraseRootFromParent_Done,
     /*  153983 */   // Label 3593: @153983
     /*  153983 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(154046), // Rule ID 5238 //
     /*  153988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  153996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  153999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  154002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  154005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  154027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154044 */     GIR_RootConstrainSelectedInstOperands,
     /*  154045 */     // GIR_Coverage, 5238,
     /*  154045 */     GIR_EraseRootFromParent_Done,
     /*  154046 */   // Label 3594: @154046
     /*  154046 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(154109), // Rule ID 5239 //
     /*  154051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  154062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  154065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  154068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154090 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  154090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154107 */     GIR_RootConstrainSelectedInstOperands,
     /*  154108 */     // GIR_Coverage, 5239,
     /*  154108 */     GIR_EraseRootFromParent_Done,
     /*  154109 */   // Label 3595: @154109
     /*  154109 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(154172), // Rule ID 5240 //
     /*  154114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  154125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  154128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  154131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154153 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  154153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154170 */     GIR_RootConstrainSelectedInstOperands,
     /*  154171 */     // GIR_Coverage, 5240,
     /*  154171 */     GIR_EraseRootFromParent_Done,
     /*  154172 */   // Label 3596: @154172
     /*  154172 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(154235), // Rule ID 5241 //
     /*  154177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  154188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  154191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  154194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  154216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154233 */     GIR_RootConstrainSelectedInstOperands,
     /*  154234 */     // GIR_Coverage, 5241,
     /*  154234 */     GIR_EraseRootFromParent_Done,
     /*  154235 */   // Label 3597: @154235
     /*  154235 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(154298), // Rule ID 5242 //
     /*  154240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  154251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  154254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  154257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  154279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  154296 */     GIR_RootConstrainSelectedInstOperands,
     /*  154297 */     // GIR_Coverage, 5242,
     /*  154297 */     GIR_EraseRootFromParent_Done,
     /*  154298 */   // Label 3598: @154298
     /*  154298 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(154361), // Rule ID 5243 //
     /*  154303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  154314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  154317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  154320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  154342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  154359 */     GIR_RootConstrainSelectedInstOperands,
     /*  154360 */     // GIR_Coverage, 5243,
     /*  154360 */     GIR_EraseRootFromParent_Done,
     /*  154361 */   // Label 3599: @154361
     /*  154361 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(154424), // Rule ID 5244 //
     /*  154366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  154369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  154377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  154380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  154383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154405 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  154405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  154422 */     GIR_RootConstrainSelectedInstOperands,
     /*  154423 */     // GIR_Coverage, 5244,
     /*  154423 */     GIR_EraseRootFromParent_Done,
     /*  154424 */   // Label 3600: @154424
     /*  154424 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(154487), // Rule ID 5245 //
     /*  154429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  154432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  154440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  154443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  154446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  154468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  154471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  154485 */     GIR_RootConstrainSelectedInstOperands,
     /*  154486 */     // GIR_Coverage, 5245,
     /*  154486 */     GIR_EraseRootFromParent_Done,
     /*  154487 */   // Label 3601: @154487
     /*  154487 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(154550), // Rule ID 5246 //
     /*  154492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  154503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  154506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  154509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154531 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  154531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  154534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154548 */     GIR_RootConstrainSelectedInstOperands,
     /*  154549 */     // GIR_Coverage, 5246,
     /*  154549 */     GIR_EraseRootFromParent_Done,
     /*  154550 */   // Label 3602: @154550
     /*  154550 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(154613), // Rule ID 5247 //
     /*  154555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  154566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  154569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  154572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  154594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  154597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154611 */     GIR_RootConstrainSelectedInstOperands,
     /*  154612 */     // GIR_Coverage, 5247,
     /*  154612 */     GIR_EraseRootFromParent_Done,
     /*  154613 */   // Label 3603: @154613
     /*  154613 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(154676), // Rule ID 5248 //
     /*  154618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  154629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  154632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  154635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154657 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  154657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  154660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154674 */     GIR_RootConstrainSelectedInstOperands,
     /*  154675 */     // GIR_Coverage, 5248,
     /*  154675 */     GIR_EraseRootFromParent_Done,
     /*  154676 */   // Label 3604: @154676
     /*  154676 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(154739), // Rule ID 5249 //
     /*  154681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  154692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  154695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  154698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  154720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  154723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154737 */     GIR_RootConstrainSelectedInstOperands,
     /*  154738 */     // GIR_Coverage, 5249,
     /*  154738 */     GIR_EraseRootFromParent_Done,
     /*  154739 */   // Label 3605: @154739
     /*  154739 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(154802), // Rule ID 5250 //
     /*  154744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  154755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  154758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  154761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154783 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  154783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  154786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154800 */     GIR_RootConstrainSelectedInstOperands,
     /*  154801 */     // GIR_Coverage, 5250,
     /*  154801 */     GIR_EraseRootFromParent_Done,
     /*  154802 */   // Label 3606: @154802
     /*  154802 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(154865), // Rule ID 5251 //
     /*  154807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  154818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  154821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  154824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154846 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  154846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  154849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154863 */     GIR_RootConstrainSelectedInstOperands,
     /*  154864 */     // GIR_Coverage, 5251,
     /*  154864 */     GIR_EraseRootFromParent_Done,
     /*  154865 */   // Label 3607: @154865
     /*  154865 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(154928), // Rule ID 5252 //
     /*  154870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  154881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  154884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  154887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  154890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  154909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  154912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154926 */     GIR_RootConstrainSelectedInstOperands,
     /*  154927 */     // GIR_Coverage, 5252,
     /*  154927 */     GIR_EraseRootFromParent_Done,
     /*  154928 */   // Label 3608: @154928
     /*  154928 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(154991), // Rule ID 5253 //
     /*  154933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  154941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  154944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  154947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  154950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  154953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  154965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  154972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  154972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  154975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  154979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  154981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  154986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154989 */     GIR_RootConstrainSelectedInstOperands,
     /*  154990 */     // GIR_Coverage, 5253,
     /*  154990 */     GIR_EraseRootFromParent_Done,
     /*  154991 */   // Label 3609: @154991
     /*  154991 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(155054), // Rule ID 5254 //
     /*  154996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  155007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  155010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  155013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155035 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  155035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  155052 */     GIR_RootConstrainSelectedInstOperands,
     /*  155053 */     // GIR_Coverage, 5254,
     /*  155053 */     GIR_EraseRootFromParent_Done,
     /*  155054 */   // Label 3610: @155054
     /*  155054 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(155117), // Rule ID 5255 //
     /*  155059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  155070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  155073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  155076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155098 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  155098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  155115 */     GIR_RootConstrainSelectedInstOperands,
     /*  155116 */     // GIR_Coverage, 5255,
     /*  155116 */     GIR_EraseRootFromParent_Done,
     /*  155117 */   // Label 3611: @155117
     /*  155117 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(155180), // Rule ID 5256 //
     /*  155122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  155133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  155136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  155139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155161 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  155161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  155178 */     GIR_RootConstrainSelectedInstOperands,
     /*  155179 */     // GIR_Coverage, 5256,
     /*  155179 */     GIR_EraseRootFromParent_Done,
     /*  155180 */   // Label 3612: @155180
     /*  155180 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(155243), // Rule ID 5257 //
     /*  155185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  155196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  155199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  155202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155224 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  155224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  155241 */     GIR_RootConstrainSelectedInstOperands,
     /*  155242 */     // GIR_Coverage, 5257,
     /*  155242 */     GIR_EraseRootFromParent_Done,
     /*  155243 */   // Label 3613: @155243
     /*  155243 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(155306), // Rule ID 5258 //
     /*  155248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  155259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  155262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  155265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155287 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  155287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  155290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155304 */     GIR_RootConstrainSelectedInstOperands,
     /*  155305 */     // GIR_Coverage, 5258,
     /*  155305 */     GIR_EraseRootFromParent_Done,
     /*  155306 */   // Label 3614: @155306
     /*  155306 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(155369), // Rule ID 5259 //
     /*  155311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  155322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  155325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  155328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  155350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  155353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155367 */     GIR_RootConstrainSelectedInstOperands,
     /*  155368 */     // GIR_Coverage, 5259,
     /*  155368 */     GIR_EraseRootFromParent_Done,
     /*  155369 */   // Label 3615: @155369
     /*  155369 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(155432), // Rule ID 5260 //
     /*  155374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  155385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  155388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  155391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155413 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  155413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155430 */     GIR_RootConstrainSelectedInstOperands,
     /*  155431 */     // GIR_Coverage, 5260,
     /*  155431 */     GIR_EraseRootFromParent_Done,
     /*  155432 */   // Label 3616: @155432
     /*  155432 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(155495), // Rule ID 5261 //
     /*  155437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  155448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  155451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  155454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  155476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155493 */     GIR_RootConstrainSelectedInstOperands,
     /*  155494 */     // GIR_Coverage, 5261,
     /*  155494 */     GIR_EraseRootFromParent_Done,
     /*  155495 */   // Label 3617: @155495
     /*  155495 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(155558), // Rule ID 5262 //
     /*  155500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  155511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  155514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  155517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  155539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155556 */     GIR_RootConstrainSelectedInstOperands,
     /*  155557 */     // GIR_Coverage, 5262,
     /*  155557 */     GIR_EraseRootFromParent_Done,
     /*  155558 */   // Label 3618: @155558
     /*  155558 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(155621), // Rule ID 5263 //
     /*  155563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  155574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  155577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  155580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  155602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  155619 */     GIR_RootConstrainSelectedInstOperands,
     /*  155620 */     // GIR_Coverage, 5263,
     /*  155620 */     GIR_EraseRootFromParent_Done,
     /*  155621 */   // Label 3619: @155621
     /*  155621 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(155684), // Rule ID 5264 //
     /*  155626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  155629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  155637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  155640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  155643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155665 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  155665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  155668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155682 */     GIR_RootConstrainSelectedInstOperands,
     /*  155683 */     // GIR_Coverage, 5264,
     /*  155683 */     GIR_EraseRootFromParent_Done,
     /*  155684 */   // Label 3620: @155684
     /*  155684 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(155747), // Rule ID 5265 //
     /*  155689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  155692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  155700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  155703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  155706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  155721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  155728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  155731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155745 */     GIR_RootConstrainSelectedInstOperands,
     /*  155746 */     // GIR_Coverage, 5265,
     /*  155746 */     GIR_EraseRootFromParent_Done,
     /*  155747 */   // Label 3621: @155747
     /*  155747 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(155810), // Rule ID 5266 //
     /*  155752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  155755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  155763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  155766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  155769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155791 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  155791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155808 */     GIR_RootConstrainSelectedInstOperands,
     /*  155809 */     // GIR_Coverage, 5266,
     /*  155809 */     GIR_EraseRootFromParent_Done,
     /*  155810 */   // Label 3622: @155810
     /*  155810 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(155873), // Rule ID 5267 //
     /*  155815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  155818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  155826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  155829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  155832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  155847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  155854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  155857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155871 */     GIR_RootConstrainSelectedInstOperands,
     /*  155872 */     // GIR_Coverage, 5267,
     /*  155872 */     GIR_EraseRootFromParent_Done,
     /*  155873 */   // Label 3623: @155873
     /*  155873 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(155936), // Rule ID 5268 //
     /*  155878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  155881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  155889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  155892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  155895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  155898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  155917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155934 */     GIR_RootConstrainSelectedInstOperands,
     /*  155935 */     // GIR_Coverage, 5268,
     /*  155935 */     GIR_EraseRootFromParent_Done,
     /*  155936 */   // Label 3624: @155936
     /*  155936 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(155999), // Rule ID 5269 //
     /*  155941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  155944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  155949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  155952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  155955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  155958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  155961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  155980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  155980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  155983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  155987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  155989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  155994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  155997 */     GIR_RootConstrainSelectedInstOperands,
     /*  155998 */     // GIR_Coverage, 5269,
     /*  155998 */     GIR_EraseRootFromParent_Done,
     /*  155999 */   // Label 3625: @155999
     /*  155999 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(156062), // Rule ID 5270 //
     /*  156004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  156018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156043 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  156043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  156046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156060 */     GIR_RootConstrainSelectedInstOperands,
     /*  156061 */     // GIR_Coverage, 5270,
     /*  156061 */     GIR_EraseRootFromParent_Done,
     /*  156062 */   // Label 3626: @156062
     /*  156062 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(156125), // Rule ID 5271 //
     /*  156067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  156081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  156106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  156109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156123 */     GIR_RootConstrainSelectedInstOperands,
     /*  156124 */     // GIR_Coverage, 5271,
     /*  156124 */     GIR_EraseRootFromParent_Done,
     /*  156125 */   // Label 3627: @156125
     /*  156125 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(156188), // Rule ID 5272 //
     /*  156130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  156141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  156144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  156169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  156172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156186 */     GIR_RootConstrainSelectedInstOperands,
     /*  156187 */     // GIR_Coverage, 5272,
     /*  156187 */     GIR_EraseRootFromParent_Done,
     /*  156188 */   // Label 3628: @156188
     /*  156188 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(156251), // Rule ID 5273 //
     /*  156193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  156204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  156207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156232 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  156232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  156235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156249 */     GIR_RootConstrainSelectedInstOperands,
     /*  156250 */     // GIR_Coverage, 5273,
     /*  156250 */     GIR_EraseRootFromParent_Done,
     /*  156251 */   // Label 3629: @156251
     /*  156251 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(156314), // Rule ID 5274 //
     /*  156256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  156267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  156270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  156295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156312 */     GIR_RootConstrainSelectedInstOperands,
     /*  156313 */     // GIR_Coverage, 5274,
     /*  156313 */     GIR_EraseRootFromParent_Done,
     /*  156314 */   // Label 3630: @156314
     /*  156314 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(156377), // Rule ID 5275 //
     /*  156319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  156330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  156333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  156358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156375 */     GIR_RootConstrainSelectedInstOperands,
     /*  156376 */     // GIR_Coverage, 5275,
     /*  156376 */     GIR_EraseRootFromParent_Done,
     /*  156377 */   // Label 3631: @156377
     /*  156377 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(156440), // Rule ID 5276 //
     /*  156382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  156396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  156421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  156424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156438 */     GIR_RootConstrainSelectedInstOperands,
     /*  156439 */     // GIR_Coverage, 5276,
     /*  156439 */     GIR_EraseRootFromParent_Done,
     /*  156440 */   // Label 3632: @156440
     /*  156440 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(156503), // Rule ID 5277 //
     /*  156445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  156459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156484 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  156484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  156487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156501 */     GIR_RootConstrainSelectedInstOperands,
     /*  156502 */     // GIR_Coverage, 5277,
     /*  156502 */     GIR_EraseRootFromParent_Done,
     /*  156503 */   // Label 3633: @156503
     /*  156503 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(156566), // Rule ID 5278 //
     /*  156508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  156519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  156522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  156547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156564 */     GIR_RootConstrainSelectedInstOperands,
     /*  156565 */     // GIR_Coverage, 5278,
     /*  156565 */     GIR_EraseRootFromParent_Done,
     /*  156566 */   // Label 3634: @156566
     /*  156566 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(156629), // Rule ID 5279 //
     /*  156571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  156582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  156585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  156610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156627 */     GIR_RootConstrainSelectedInstOperands,
     /*  156628 */     // GIR_Coverage, 5279,
     /*  156628 */     GIR_EraseRootFromParent_Done,
     /*  156629 */   // Label 3635: @156629
     /*  156629 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(156692), // Rule ID 5280 //
     /*  156634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  156648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156673 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  156673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  156690 */     GIR_RootConstrainSelectedInstOperands,
     /*  156691 */     // GIR_Coverage, 5280,
     /*  156691 */     GIR_EraseRootFromParent_Done,
     /*  156692 */   // Label 3636: @156692
     /*  156692 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(156755), // Rule ID 5281 //
     /*  156697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  156708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  156711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  156736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  156739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  156753 */     GIR_RootConstrainSelectedInstOperands,
     /*  156754 */     // GIR_Coverage, 5281,
     /*  156754 */     GIR_EraseRootFromParent_Done,
     /*  156755 */   // Label 3637: @156755
     /*  156755 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(156818), // Rule ID 5282 //
     /*  156760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  156771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  156774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  156799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  156802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156816 */     GIR_RootConstrainSelectedInstOperands,
     /*  156817 */     // GIR_Coverage, 5282,
     /*  156817 */     GIR_EraseRootFromParent_Done,
     /*  156818 */   // Label 3638: @156818
     /*  156818 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(156881), // Rule ID 5283 //
     /*  156823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  156834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  156837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156862 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  156862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  156865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156879 */     GIR_RootConstrainSelectedInstOperands,
     /*  156880 */     // GIR_Coverage, 5283,
     /*  156880 */     GIR_EraseRootFromParent_Done,
     /*  156881 */   // Label 3639: @156881
     /*  156881 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(156944), // Rule ID 5284 //
     /*  156886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  156897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  156900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  156903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  156906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156925 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  156925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  156928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  156939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156942 */     GIR_RootConstrainSelectedInstOperands,
     /*  156943 */     // GIR_Coverage, 5284,
     /*  156943 */     GIR_EraseRootFromParent_Done,
     /*  156944 */   // Label 3640: @156944
     /*  156944 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(157007), // Rule ID 5285 //
     /*  156949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  156957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  156960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  156963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  156966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  156969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  156988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  156988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  156991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  156995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  156997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157005 */     GIR_RootConstrainSelectedInstOperands,
     /*  157006 */     // GIR_Coverage, 5285,
     /*  157006 */     GIR_EraseRootFromParent_Done,
     /*  157007 */   // Label 3641: @157007
     /*  157007 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(157070), // Rule ID 5286 //
     /*  157012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  157023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  157026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  157051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  157054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  157068 */     GIR_RootConstrainSelectedInstOperands,
     /*  157069 */     // GIR_Coverage, 5286,
     /*  157069 */     GIR_EraseRootFromParent_Done,
     /*  157070 */   // Label 3642: @157070
     /*  157070 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(157133), // Rule ID 5287 //
     /*  157075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  157086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  157089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  157114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  157117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  157131 */     GIR_RootConstrainSelectedInstOperands,
     /*  157132 */     // GIR_Coverage, 5287,
     /*  157132 */     GIR_EraseRootFromParent_Done,
     /*  157133 */   // Label 3643: @157133
     /*  157133 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(157196), // Rule ID 5288 //
     /*  157138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  157141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  157149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  157152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  157177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  157180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  157194 */     GIR_RootConstrainSelectedInstOperands,
     /*  157195 */     // GIR_Coverage, 5288,
     /*  157195 */     GIR_EraseRootFromParent_Done,
     /*  157196 */   // Label 3644: @157196
     /*  157196 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(157259), // Rule ID 5289 //
     /*  157201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  157204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  157212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  157215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  157240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  157243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  157257 */     GIR_RootConstrainSelectedInstOperands,
     /*  157258 */     // GIR_Coverage, 5289,
     /*  157258 */     GIR_EraseRootFromParent_Done,
     /*  157259 */   // Label 3645: @157259
     /*  157259 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(157322), // Rule ID 5290 //
     /*  157264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  157275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  157278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  157292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157303 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  157303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  157306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157320 */     GIR_RootConstrainSelectedInstOperands,
     /*  157321 */     // GIR_Coverage, 5290,
     /*  157321 */     GIR_EraseRootFromParent_Done,
     /*  157322 */   // Label 3646: @157322
     /*  157322 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(157385), // Rule ID 5291 //
     /*  157327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  157338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  157341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  157355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  157366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  157369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157383 */     GIR_RootConstrainSelectedInstOperands,
     /*  157384 */     // GIR_Coverage, 5291,
     /*  157384 */     GIR_EraseRootFromParent_Done,
     /*  157385 */   // Label 3647: @157385
     /*  157385 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(157448), // Rule ID 5292 //
     /*  157390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  157401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  157404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  157418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157429 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  157429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  157432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157446 */     GIR_RootConstrainSelectedInstOperands,
     /*  157447 */     // GIR_Coverage, 5292,
     /*  157447 */     GIR_EraseRootFromParent_Done,
     /*  157448 */   // Label 3648: @157448
     /*  157448 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(157511), // Rule ID 5293 //
     /*  157453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  157464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  157467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  157481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  157492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  157495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157509 */     GIR_RootConstrainSelectedInstOperands,
     /*  157510 */     // GIR_Coverage, 5293,
     /*  157510 */     GIR_EraseRootFromParent_Done,
     /*  157511 */   // Label 3649: @157511
     /*  157511 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(157574), // Rule ID 5294 //
     /*  157516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  157527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  157530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  157544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157555 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  157555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  157558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157572 */     GIR_RootConstrainSelectedInstOperands,
     /*  157573 */     // GIR_Coverage, 5294,
     /*  157573 */     GIR_EraseRootFromParent_Done,
     /*  157574 */   // Label 3650: @157574
     /*  157574 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(157637), // Rule ID 5295 //
     /*  157579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  157590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  157593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  157607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157618 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  157618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  157621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  157635 */     GIR_RootConstrainSelectedInstOperands,
     /*  157636 */     // GIR_Coverage, 5295,
     /*  157636 */     GIR_EraseRootFromParent_Done,
     /*  157637 */   // Label 3651: @157637
     /*  157637 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(157700), // Rule ID 5296 //
     /*  157642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  157653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  157656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  157670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  157681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  157684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157698 */     GIR_RootConstrainSelectedInstOperands,
     /*  157699 */     // GIR_Coverage, 5296,
     /*  157699 */     GIR_EraseRootFromParent_Done,
     /*  157700 */   // Label 3652: @157700
     /*  157700 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(157763), // Rule ID 5297 //
     /*  157705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  157716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  157719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  157733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  157744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  157747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157761 */     GIR_RootConstrainSelectedInstOperands,
     /*  157762 */     // GIR_Coverage, 5297,
     /*  157762 */     GIR_EraseRootFromParent_Done,
     /*  157763 */   // Label 3653: @157763
     /*  157763 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(157826), // Rule ID 5298 //
     /*  157768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  157779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  157782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  157796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  157807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  157810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157824 */     GIR_RootConstrainSelectedInstOperands,
     /*  157825 */     // GIR_Coverage, 5298,
     /*  157825 */     GIR_EraseRootFromParent_Done,
     /*  157826 */   // Label 3654: @157826
     /*  157826 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(157889), // Rule ID 5299 //
     /*  157831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  157842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  157845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  157859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  157870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  157873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157887 */     GIR_RootConstrainSelectedInstOperands,
     /*  157888 */     // GIR_Coverage, 5299,
     /*  157888 */     GIR_EraseRootFromParent_Done,
     /*  157889 */   // Label 3655: @157889
     /*  157889 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(157952), // Rule ID 5300 //
     /*  157894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  157897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  157905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  157908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  157911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  157914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  157922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157933 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  157933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  157936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  157940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  157942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  157947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157950 */     GIR_RootConstrainSelectedInstOperands,
     /*  157951 */     // GIR_Coverage, 5300,
     /*  157951 */     GIR_EraseRootFromParent_Done,
     /*  157952 */   // Label 3656: @157952
     /*  157952 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(158015), // Rule ID 5301 //
     /*  157957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  157960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  157965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  157968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  157971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  157974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  157977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  157981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  157985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  157996 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  157996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  157999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  158013 */     GIR_RootConstrainSelectedInstOperands,
     /*  158014 */     // GIR_Coverage, 5301,
     /*  158014 */     GIR_EraseRootFromParent_Done,
     /*  158015 */   // Label 3657: @158015
     /*  158015 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(158078), // Rule ID 5302 //
     /*  158020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  158031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  158034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  158048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  158059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  158062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158076 */     GIR_RootConstrainSelectedInstOperands,
     /*  158077 */     // GIR_Coverage, 5302,
     /*  158077 */     GIR_EraseRootFromParent_Done,
     /*  158078 */   // Label 3658: @158078
     /*  158078 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(158141), // Rule ID 5303 //
     /*  158083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  158094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  158097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  158111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  158122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  158125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158139 */     GIR_RootConstrainSelectedInstOperands,
     /*  158140 */     // GIR_Coverage, 5303,
     /*  158140 */     GIR_EraseRootFromParent_Done,
     /*  158141 */   // Label 3659: @158141
     /*  158141 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(158204), // Rule ID 5304 //
     /*  158146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  158157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  158160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  158174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  158185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  158188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158202 */     GIR_RootConstrainSelectedInstOperands,
     /*  158203 */     // GIR_Coverage, 5304,
     /*  158203 */     GIR_EraseRootFromParent_Done,
     /*  158204 */   // Label 3660: @158204
     /*  158204 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(158267), // Rule ID 5305 //
     /*  158209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  158220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  158223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  158237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  158248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  158251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158265 */     GIR_RootConstrainSelectedInstOperands,
     /*  158266 */     // GIR_Coverage, 5305,
     /*  158266 */     GIR_EraseRootFromParent_Done,
     /*  158267 */   // Label 3661: @158267
     /*  158267 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(158330), // Rule ID 5306 //
     /*  158272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  158283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  158286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  158300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  158311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  158314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158328 */     GIR_RootConstrainSelectedInstOperands,
     /*  158329 */     // GIR_Coverage, 5306,
     /*  158329 */     GIR_EraseRootFromParent_Done,
     /*  158330 */   // Label 3662: @158330
     /*  158330 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(158393), // Rule ID 5307 //
     /*  158335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  158346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  158349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  158363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  158374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  158377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158391 */     GIR_RootConstrainSelectedInstOperands,
     /*  158392 */     // GIR_Coverage, 5307,
     /*  158392 */     GIR_EraseRootFromParent_Done,
     /*  158393 */   // Label 3663: @158393
     /*  158393 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(158456), // Rule ID 5308 //
     /*  158398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  158401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  158409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  158412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  158426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  158437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  158440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158454 */     GIR_RootConstrainSelectedInstOperands,
     /*  158455 */     // GIR_Coverage, 5308,
     /*  158455 */     GIR_EraseRootFromParent_Done,
     /*  158456 */   // Label 3664: @158456
     /*  158456 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(158519), // Rule ID 5309 //
     /*  158461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  158464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  158472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  158475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  158489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158500 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  158500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  158503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158517 */     GIR_RootConstrainSelectedInstOperands,
     /*  158518 */     // GIR_Coverage, 5309,
     /*  158518 */     GIR_EraseRootFromParent_Done,
     /*  158519 */   // Label 3665: @158519
     /*  158519 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(158582), // Rule ID 5310 //
     /*  158524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  158527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  158535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  158538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  158552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  158563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  158566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158580 */     GIR_RootConstrainSelectedInstOperands,
     /*  158581 */     // GIR_Coverage, 5310,
     /*  158581 */     GIR_EraseRootFromParent_Done,
     /*  158582 */   // Label 3666: @158582
     /*  158582 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(158645), // Rule ID 5311 //
     /*  158587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  158590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  158598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  158601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  158615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  158626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  158629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158643 */     GIR_RootConstrainSelectedInstOperands,
     /*  158644 */     // GIR_Coverage, 5311,
     /*  158644 */     GIR_EraseRootFromParent_Done,
     /*  158645 */   // Label 3667: @158645
     /*  158645 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(158708), // Rule ID 5312 //
     /*  158650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  158653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  158661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  158664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  158667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  158678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158689 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  158689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  158692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158706 */     GIR_RootConstrainSelectedInstOperands,
     /*  158707 */     // GIR_Coverage, 5312,
     /*  158707 */     GIR_EraseRootFromParent_Done,
     /*  158708 */   // Label 3668: @158708
     /*  158708 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(158771), // Rule ID 5313 //
     /*  158713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  158716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  158721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  158724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  158727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  158730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  158741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  158752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  158755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158769 */     GIR_RootConstrainSelectedInstOperands,
     /*  158770 */     // GIR_Coverage, 5313,
     /*  158770 */     GIR_EraseRootFromParent_Done,
     /*  158771 */   // Label 3669: @158771
     /*  158771 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(158834), // Rule ID 5534 //
     /*  158776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  158784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  158787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  158790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  158793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158815 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  158815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  158818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158832 */     GIR_RootConstrainSelectedInstOperands,
     /*  158833 */     // GIR_Coverage, 5534,
     /*  158833 */     GIR_EraseRootFromParent_Done,
     /*  158834 */   // Label 3670: @158834
     /*  158834 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(158897), // Rule ID 5535 //
     /*  158839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  158847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  158850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  158853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  158856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  158878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  158881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158895 */     GIR_RootConstrainSelectedInstOperands,
     /*  158896 */     // GIR_Coverage, 5535,
     /*  158896 */     GIR_EraseRootFromParent_Done,
     /*  158897 */   // Label 3671: @158897
     /*  158897 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(158960), // Rule ID 5536 //
     /*  158902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  158910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  158913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  158916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  158919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  158922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  158941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  158941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  158944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  158948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  158950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  158955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158958 */     GIR_RootConstrainSelectedInstOperands,
     /*  158959 */     // GIR_Coverage, 5536,
     /*  158959 */     GIR_EraseRootFromParent_Done,
     /*  158960 */   // Label 3672: @158960
     /*  158960 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(159023), // Rule ID 5537 //
     /*  158965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  158973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  158976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  158979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  158982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  158985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  159004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  159007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159021 */     GIR_RootConstrainSelectedInstOperands,
     /*  159022 */     // GIR_Coverage, 5537,
     /*  159022 */     GIR_EraseRootFromParent_Done,
     /*  159023 */   // Label 3673: @159023
     /*  159023 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(159086), // Rule ID 5538 //
     /*  159028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  159039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  159042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  159045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159067 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  159067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159084 */     GIR_RootConstrainSelectedInstOperands,
     /*  159085 */     // GIR_Coverage, 5538,
     /*  159085 */     GIR_EraseRootFromParent_Done,
     /*  159086 */   // Label 3674: @159086
     /*  159086 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(159149), // Rule ID 5539 //
     /*  159091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  159102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  159105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  159108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  159130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159147 */     GIR_RootConstrainSelectedInstOperands,
     /*  159148 */     // GIR_Coverage, 5539,
     /*  159148 */     GIR_EraseRootFromParent_Done,
     /*  159149 */   // Label 3675: @159149
     /*  159149 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(159212), // Rule ID 5540 //
     /*  159154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  159168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  159171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159193 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  159193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  159196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159210 */     GIR_RootConstrainSelectedInstOperands,
     /*  159211 */     // GIR_Coverage, 5540,
     /*  159211 */     GIR_EraseRootFromParent_Done,
     /*  159212 */   // Label 3676: @159212
     /*  159212 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(159275), // Rule ID 5541 //
     /*  159217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  159231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  159234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  159256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  159259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159273 */     GIR_RootConstrainSelectedInstOperands,
     /*  159274 */     // GIR_Coverage, 5541,
     /*  159274 */     GIR_EraseRootFromParent_Done,
     /*  159275 */   // Label 3677: @159275
     /*  159275 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(159338), // Rule ID 5542 //
     /*  159280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  159291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  159294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  159297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  159319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159336 */     GIR_RootConstrainSelectedInstOperands,
     /*  159337 */     // GIR_Coverage, 5542,
     /*  159337 */     GIR_EraseRootFromParent_Done,
     /*  159338 */   // Label 3678: @159338
     /*  159338 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(159401), // Rule ID 5543 //
     /*  159343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  159354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  159357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  159360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  159382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159399 */     GIR_RootConstrainSelectedInstOperands,
     /*  159400 */     // GIR_Coverage, 5543,
     /*  159400 */     GIR_EraseRootFromParent_Done,
     /*  159401 */   // Label 3679: @159401
     /*  159401 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(159464), // Rule ID 5544 //
     /*  159406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  159420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  159423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  159445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159462 */     GIR_RootConstrainSelectedInstOperands,
     /*  159463 */     // GIR_Coverage, 5544,
     /*  159463 */     GIR_EraseRootFromParent_Done,
     /*  159464 */   // Label 3680: @159464
     /*  159464 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(159527), // Rule ID 5545 //
     /*  159469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  159483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  159486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  159508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  159511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159525 */     GIR_RootConstrainSelectedInstOperands,
     /*  159526 */     // GIR_Coverage, 5545,
     /*  159526 */     GIR_EraseRootFromParent_Done,
     /*  159527 */   // Label 3681: @159527
     /*  159527 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(159590), // Rule ID 5546 //
     /*  159532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  159543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  159546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  159549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  159571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159588 */     GIR_RootConstrainSelectedInstOperands,
     /*  159589 */     // GIR_Coverage, 5546,
     /*  159589 */     GIR_EraseRootFromParent_Done,
     /*  159590 */   // Label 3682: @159590
     /*  159590 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(159653), // Rule ID 5547 //
     /*  159595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  159606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  159609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  159612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159634 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  159634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159651 */     GIR_RootConstrainSelectedInstOperands,
     /*  159652 */     // GIR_Coverage, 5547,
     /*  159652 */     GIR_EraseRootFromParent_Done,
     /*  159653 */   // Label 3683: @159653
     /*  159653 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(159716), // Rule ID 5548 //
     /*  159658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  159669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  159672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  159675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159697 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  159697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159714 */     GIR_RootConstrainSelectedInstOperands,
     /*  159715 */     // GIR_Coverage, 5548,
     /*  159715 */     GIR_EraseRootFromParent_Done,
     /*  159716 */   // Label 3684: @159716
     /*  159716 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(159779), // Rule ID 5549 //
     /*  159721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  159732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  159735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  159738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  159760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159777 */     GIR_RootConstrainSelectedInstOperands,
     /*  159778 */     // GIR_Coverage, 5549,
     /*  159778 */     GIR_EraseRootFromParent_Done,
     /*  159779 */   // Label 3685: @159779
     /*  159779 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(159842), // Rule ID 5550 //
     /*  159784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  159795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  159798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  159801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159823 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  159823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159840 */     GIR_RootConstrainSelectedInstOperands,
     /*  159841 */     // GIR_Coverage, 5550,
     /*  159841 */     GIR_EraseRootFromParent_Done,
     /*  159842 */   // Label 3686: @159842
     /*  159842 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(159905), // Rule ID 5551 //
     /*  159847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  159858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  159861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  159864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  159886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159903 */     GIR_RootConstrainSelectedInstOperands,
     /*  159904 */     // GIR_Coverage, 5551,
     /*  159904 */     GIR_EraseRootFromParent_Done,
     /*  159905 */   // Label 3687: @159905
     /*  159905 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(159968), // Rule ID 5552 //
     /*  159910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  159913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  159924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  159927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  159930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  159949 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  159949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  159952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  159956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  159958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  159963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159966 */     GIR_RootConstrainSelectedInstOperands,
     /*  159967 */     // GIR_Coverage, 5552,
     /*  159967 */     GIR_EraseRootFromParent_Done,
     /*  159968 */   // Label 3688: @159968
     /*  159968 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(160031), // Rule ID 5553 //
     /*  159973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  159976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  159981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  159984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  159987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  159990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  159993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  160012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  160015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160029 */     GIR_RootConstrainSelectedInstOperands,
     /*  160030 */     // GIR_Coverage, 5553,
     /*  160030 */     GIR_EraseRootFromParent_Done,
     /*  160031 */   // Label 3689: @160031
     /*  160031 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(160094), // Rule ID 5554 //
     /*  160036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  160047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  160050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  160053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160075 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  160075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160092 */     GIR_RootConstrainSelectedInstOperands,
     /*  160093 */     // GIR_Coverage, 5554,
     /*  160093 */     GIR_EraseRootFromParent_Done,
     /*  160094 */   // Label 3690: @160094
     /*  160094 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(160157), // Rule ID 5555 //
     /*  160099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  160110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  160113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  160116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  160138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160155 */     GIR_RootConstrainSelectedInstOperands,
     /*  160156 */     // GIR_Coverage, 5555,
     /*  160156 */     GIR_EraseRootFromParent_Done,
     /*  160157 */   // Label 3691: @160157
     /*  160157 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(160220), // Rule ID 5556 //
     /*  160162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  160173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  160176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  160179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160201 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  160201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  160204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160218 */     GIR_RootConstrainSelectedInstOperands,
     /*  160219 */     // GIR_Coverage, 5556,
     /*  160219 */     GIR_EraseRootFromParent_Done,
     /*  160220 */   // Label 3692: @160220
     /*  160220 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(160283), // Rule ID 5557 //
     /*  160225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  160236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  160239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  160242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160264 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  160264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  160267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160281 */     GIR_RootConstrainSelectedInstOperands,
     /*  160282 */     // GIR_Coverage, 5557,
     /*  160282 */     GIR_EraseRootFromParent_Done,
     /*  160283 */   // Label 3693: @160283
     /*  160283 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(160346), // Rule ID 5558 //
     /*  160288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  160299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  160302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  160305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160327 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  160327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  160330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160344 */     GIR_RootConstrainSelectedInstOperands,
     /*  160345 */     // GIR_Coverage, 5558,
     /*  160345 */     GIR_EraseRootFromParent_Done,
     /*  160346 */   // Label 3694: @160346
     /*  160346 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(160409), // Rule ID 5559 //
     /*  160351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  160362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  160365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  160368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160390 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  160390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  160393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160407 */     GIR_RootConstrainSelectedInstOperands,
     /*  160408 */     // GIR_Coverage, 5559,
     /*  160408 */     GIR_EraseRootFromParent_Done,
     /*  160409 */   // Label 3695: @160409
     /*  160409 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(160472), // Rule ID 5560 //
     /*  160414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  160425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  160428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  160431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160453 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  160453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160470 */     GIR_RootConstrainSelectedInstOperands,
     /*  160471 */     // GIR_Coverage, 5560,
     /*  160471 */     GIR_EraseRootFromParent_Done,
     /*  160472 */   // Label 3696: @160472
     /*  160472 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(160535), // Rule ID 5561 //
     /*  160477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  160488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  160491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  160494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  160516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160533 */     GIR_RootConstrainSelectedInstOperands,
     /*  160534 */     // GIR_Coverage, 5561,
     /*  160534 */     GIR_EraseRootFromParent_Done,
     /*  160535 */   // Label 3697: @160535
     /*  160535 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(160598), // Rule ID 5562 //
     /*  160540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  160551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  160554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  160557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  160579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  160582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160596 */     GIR_RootConstrainSelectedInstOperands,
     /*  160597 */     // GIR_Coverage, 5562,
     /*  160597 */     GIR_EraseRootFromParent_Done,
     /*  160598 */   // Label 3698: @160598
     /*  160598 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(160661), // Rule ID 5563 //
     /*  160603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  160614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  160617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  160620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  160642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  160645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160659 */     GIR_RootConstrainSelectedInstOperands,
     /*  160660 */     // GIR_Coverage, 5563,
     /*  160660 */     GIR_EraseRootFromParent_Done,
     /*  160661 */   // Label 3699: @160661
     /*  160661 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(160724), // Rule ID 5564 //
     /*  160666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  160677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  160680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  160683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160705 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  160705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  160708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160722 */     GIR_RootConstrainSelectedInstOperands,
     /*  160723 */     // GIR_Coverage, 5564,
     /*  160723 */     GIR_EraseRootFromParent_Done,
     /*  160724 */   // Label 3700: @160724
     /*  160724 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(160787), // Rule ID 5565 //
     /*  160729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  160740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  160743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  160746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  160761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160768 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  160768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  160771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160785 */     GIR_RootConstrainSelectedInstOperands,
     /*  160786 */     // GIR_Coverage, 5565,
     /*  160786 */     GIR_EraseRootFromParent_Done,
     /*  160787 */   // Label 3701: @160787
     /*  160787 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(160850), // Rule ID 5566 //
     /*  160792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  160803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  160806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  160809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160831 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  160831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160848 */     GIR_RootConstrainSelectedInstOperands,
     /*  160849 */     // GIR_Coverage, 5566,
     /*  160849 */     GIR_EraseRootFromParent_Done,
     /*  160850 */   // Label 3702: @160850
     /*  160850 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(160913), // Rule ID 5567 //
     /*  160855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  160866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  160869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  160872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  160875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160894 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  160894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  160897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160911 */     GIR_RootConstrainSelectedInstOperands,
     /*  160912 */     // GIR_Coverage, 5567,
     /*  160912 */     GIR_EraseRootFromParent_Done,
     /*  160913 */   // Label 3703: @160913
     /*  160913 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(160976), // Rule ID 5568 //
     /*  160918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  160929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  160932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  160935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  160938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  160957 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  160957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  160960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  160964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  160966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  160971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160974 */     GIR_RootConstrainSelectedInstOperands,
     /*  160975 */     // GIR_Coverage, 5568,
     /*  160975 */     GIR_EraseRootFromParent_Done,
     /*  160976 */   // Label 3704: @160976
     /*  160976 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(161039), // Rule ID 5569 //
     /*  160981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  160989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  160992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  160995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  160998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  161020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  161023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161037 */     GIR_RootConstrainSelectedInstOperands,
     /*  161038 */     // GIR_Coverage, 5569,
     /*  161038 */     GIR_EraseRootFromParent_Done,
     /*  161039 */   // Label 3705: @161039
     /*  161039 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(161102), // Rule ID 5570 //
     /*  161044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  161055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  161058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  161061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  161083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  161086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161100 */     GIR_RootConstrainSelectedInstOperands,
     /*  161101 */     // GIR_Coverage, 5570,
     /*  161101 */     GIR_EraseRootFromParent_Done,
     /*  161102 */   // Label 3706: @161102
     /*  161102 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(161165), // Rule ID 5571 //
     /*  161107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  161118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  161121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  161124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  161146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  161149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161163 */     GIR_RootConstrainSelectedInstOperands,
     /*  161164 */     // GIR_Coverage, 5571,
     /*  161164 */     GIR_EraseRootFromParent_Done,
     /*  161165 */   // Label 3707: @161165
     /*  161165 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(161228), // Rule ID 5572 //
     /*  161170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  161173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  161181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  161184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  161187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  161198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  161202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  161209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  161212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161226 */     GIR_RootConstrainSelectedInstOperands,
     /*  161227 */     // GIR_Coverage, 5572,
     /*  161227 */     GIR_EraseRootFromParent_Done,
     /*  161228 */   // Label 3708: @161228
     /*  161228 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(161291), // Rule ID 5573 //
     /*  161233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  161236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  161244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  161247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  161250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  161261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  161265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161272 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  161272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  161275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161289 */     GIR_RootConstrainSelectedInstOperands,
     /*  161290 */     // GIR_Coverage, 5573,
     /*  161290 */     GIR_EraseRootFromParent_Done,
     /*  161291 */   // Label 3709: @161291
     /*  161291 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(161354), // Rule ID 5574 //
     /*  161296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  161299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  161307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  161310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  161313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161335 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  161335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  161338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161352 */     GIR_RootConstrainSelectedInstOperands,
     /*  161353 */     // GIR_Coverage, 5574,
     /*  161353 */     GIR_EraseRootFromParent_Done,
     /*  161354 */   // Label 3710: @161354
     /*  161354 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(161417), // Rule ID 5575 //
     /*  161359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  161362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  161370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  161373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  161376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  161398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  161401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161415 */     GIR_RootConstrainSelectedInstOperands,
     /*  161416 */     // GIR_Coverage, 5575,
     /*  161416 */     GIR_EraseRootFromParent_Done,
     /*  161417 */   // Label 3711: @161417
     /*  161417 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(161480), // Rule ID 5576 //
     /*  161422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  161425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  161433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  161436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  161439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161461 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  161461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  161464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161478 */     GIR_RootConstrainSelectedInstOperands,
     /*  161479 */     // GIR_Coverage, 5576,
     /*  161479 */     GIR_EraseRootFromParent_Done,
     /*  161480 */   // Label 3712: @161480
     /*  161480 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(161543), // Rule ID 5577 //
     /*  161485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  161488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  161496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  161499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  161502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  161524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  161527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161541 */     GIR_RootConstrainSelectedInstOperands,
     /*  161542 */     // GIR_Coverage, 5577,
     /*  161542 */     GIR_EraseRootFromParent_Done,
     /*  161543 */   // Label 3713: @161543
     /*  161543 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(161606), // Rule ID 5578 //
     /*  161548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  161559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  161562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  161565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  161587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  161590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161604 */     GIR_RootConstrainSelectedInstOperands,
     /*  161605 */     // GIR_Coverage, 5578,
     /*  161605 */     GIR_EraseRootFromParent_Done,
     /*  161606 */   // Label 3714: @161606
     /*  161606 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(161669), // Rule ID 5579 //
     /*  161611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  161622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  161625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  161628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161650 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  161650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  161653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161667 */     GIR_RootConstrainSelectedInstOperands,
     /*  161668 */     // GIR_Coverage, 5579,
     /*  161668 */     GIR_EraseRootFromParent_Done,
     /*  161669 */   // Label 3715: @161669
     /*  161669 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(161732), // Rule ID 5580 //
     /*  161674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  161685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  161688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  161691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161713 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  161713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  161716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161730 */     GIR_RootConstrainSelectedInstOperands,
     /*  161731 */     // GIR_Coverage, 5580,
     /*  161731 */     GIR_EraseRootFromParent_Done,
     /*  161732 */   // Label 3716: @161732
     /*  161732 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(161795), // Rule ID 5581 //
     /*  161737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  161748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  161751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  161754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  161776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  161779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161793 */     GIR_RootConstrainSelectedInstOperands,
     /*  161794 */     // GIR_Coverage, 5581,
     /*  161794 */     GIR_EraseRootFromParent_Done,
     /*  161795 */   // Label 3717: @161795
     /*  161795 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(161858), // Rule ID 5582 //
     /*  161800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  161811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  161814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  161817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  161839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  161842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161856 */     GIR_RootConstrainSelectedInstOperands,
     /*  161857 */     // GIR_Coverage, 5582,
     /*  161857 */     GIR_EraseRootFromParent_Done,
     /*  161858 */   // Label 3718: @161858
     /*  161858 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(161921), // Rule ID 5583 //
     /*  161863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  161874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  161877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  161880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  161883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  161902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  161905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161919 */     GIR_RootConstrainSelectedInstOperands,
     /*  161920 */     // GIR_Coverage, 5583,
     /*  161920 */     GIR_EraseRootFromParent_Done,
     /*  161921 */   // Label 3719: @161921
     /*  161921 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(161984), // Rule ID 5584 //
     /*  161926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  161937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  161940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  161943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  161946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  161965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  161965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  161968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  161972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  161974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  161979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161982 */     GIR_RootConstrainSelectedInstOperands,
     /*  161983 */     // GIR_Coverage, 5584,
     /*  161983 */     GIR_EraseRootFromParent_Done,
     /*  161984 */   // Label 3720: @161984
     /*  161984 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(162047), // Rule ID 5585 //
     /*  161989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  161997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  162000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  162003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  162028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  162031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162045 */     GIR_RootConstrainSelectedInstOperands,
     /*  162046 */     // GIR_Coverage, 5585,
     /*  162046 */     GIR_EraseRootFromParent_Done,
     /*  162047 */   // Label 3721: @162047
     /*  162047 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(162110), // Rule ID 5586 //
     /*  162052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  162063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  162066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162091 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  162091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  162094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162108 */     GIR_RootConstrainSelectedInstOperands,
     /*  162109 */     // GIR_Coverage, 5586,
     /*  162109 */     GIR_EraseRootFromParent_Done,
     /*  162110 */   // Label 3722: @162110
     /*  162110 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(162173), // Rule ID 5587 //
     /*  162115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  162126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  162129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  162154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  162157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162171 */     GIR_RootConstrainSelectedInstOperands,
     /*  162172 */     // GIR_Coverage, 5587,
     /*  162172 */     GIR_EraseRootFromParent_Done,
     /*  162173 */   // Label 3723: @162173
     /*  162173 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(162236), // Rule ID 5588 //
     /*  162178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  162189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  162192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162217 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  162217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  162220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162234 */     GIR_RootConstrainSelectedInstOperands,
     /*  162235 */     // GIR_Coverage, 5588,
     /*  162235 */     GIR_EraseRootFromParent_Done,
     /*  162236 */   // Label 3724: @162236
     /*  162236 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(162299), // Rule ID 5589 //
     /*  162241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  162252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  162255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  162280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  162283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162297 */     GIR_RootConstrainSelectedInstOperands,
     /*  162298 */     // GIR_Coverage, 5589,
     /*  162298 */     GIR_EraseRootFromParent_Done,
     /*  162299 */   // Label 3725: @162299
     /*  162299 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(162362), // Rule ID 5590 //
     /*  162304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  162315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  162318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162343 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  162343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162360 */     GIR_RootConstrainSelectedInstOperands,
     /*  162361 */     // GIR_Coverage, 5590,
     /*  162361 */     GIR_EraseRootFromParent_Done,
     /*  162362 */   // Label 3726: @162362
     /*  162362 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(162425), // Rule ID 5591 //
     /*  162367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  162378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  162381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  162406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162423 */     GIR_RootConstrainSelectedInstOperands,
     /*  162424 */     // GIR_Coverage, 5591,
     /*  162424 */     GIR_EraseRootFromParent_Done,
     /*  162425 */   // Label 3727: @162425
     /*  162425 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(162488), // Rule ID 5592 //
     /*  162430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  162441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  162444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  162469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162486 */     GIR_RootConstrainSelectedInstOperands,
     /*  162487 */     // GIR_Coverage, 5592,
     /*  162487 */     GIR_EraseRootFromParent_Done,
     /*  162488 */   // Label 3728: @162488
     /*  162488 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(162551), // Rule ID 5593 //
     /*  162493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  162504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  162507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  162532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162549 */     GIR_RootConstrainSelectedInstOperands,
     /*  162550 */     // GIR_Coverage, 5593,
     /*  162550 */     GIR_EraseRootFromParent_Done,
     /*  162551 */   // Label 3729: @162551
     /*  162551 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(162614), // Rule ID 5594 //
     /*  162556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  162567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  162570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  162595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162612 */     GIR_RootConstrainSelectedInstOperands,
     /*  162613 */     // GIR_Coverage, 5594,
     /*  162613 */     GIR_EraseRootFromParent_Done,
     /*  162614 */   // Label 3730: @162614
     /*  162614 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(162677), // Rule ID 5595 //
     /*  162619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  162630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  162633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  162658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162675 */     GIR_RootConstrainSelectedInstOperands,
     /*  162676 */     // GIR_Coverage, 5595,
     /*  162676 */     GIR_EraseRootFromParent_Done,
     /*  162677 */   // Label 3731: @162677
     /*  162677 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(162740), // Rule ID 5596 //
     /*  162682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  162685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  162693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  162696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162721 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  162721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162738 */     GIR_RootConstrainSelectedInstOperands,
     /*  162739 */     // GIR_Coverage, 5596,
     /*  162739 */     GIR_EraseRootFromParent_Done,
     /*  162740 */   // Label 3732: @162740
     /*  162740 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(162803), // Rule ID 5597 //
     /*  162745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  162748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  162756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  162759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  162784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  162787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162801 */     GIR_RootConstrainSelectedInstOperands,
     /*  162802 */     // GIR_Coverage, 5597,
     /*  162802 */     GIR_EraseRootFromParent_Done,
     /*  162803 */   // Label 3733: @162803
     /*  162803 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(162866), // Rule ID 5598 //
     /*  162808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  162819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  162822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  162836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162847 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  162847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  162850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162864 */     GIR_RootConstrainSelectedInstOperands,
     /*  162865 */     // GIR_Coverage, 5598,
     /*  162865 */     GIR_EraseRootFromParent_Done,
     /*  162866 */   // Label 3734: @162866
     /*  162866 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(162929), // Rule ID 5599 //
     /*  162871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  162882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  162885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  162888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  162891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  162899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  162910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  162913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162927 */     GIR_RootConstrainSelectedInstOperands,
     /*  162928 */     // GIR_Coverage, 5599,
     /*  162928 */     GIR_EraseRootFromParent_Done,
     /*  162929 */   // Label 3735: @162929
     /*  162929 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(162992), // Rule ID 5600 //
     /*  162934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  162942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  162945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  162948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  162951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  162954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  162962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  162973 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  162973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  162976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  162980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  162982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  162987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162990 */     GIR_RootConstrainSelectedInstOperands,
     /*  162991 */     // GIR_Coverage, 5600,
     /*  162991 */     GIR_EraseRootFromParent_Done,
     /*  162992 */   // Label 3736: @162992
     /*  162992 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(163055), // Rule ID 5601 //
     /*  162997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  163008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  163011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  163025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  163036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  163039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163053 */     GIR_RootConstrainSelectedInstOperands,
     /*  163054 */     // GIR_Coverage, 5601,
     /*  163054 */     GIR_EraseRootFromParent_Done,
     /*  163055 */   // Label 3737: @163055
     /*  163055 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(163118), // Rule ID 5602 //
     /*  163060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  163071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  163074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163099 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  163099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163116 */     GIR_RootConstrainSelectedInstOperands,
     /*  163117 */     // GIR_Coverage, 5602,
     /*  163117 */     GIR_EraseRootFromParent_Done,
     /*  163118 */   // Label 3738: @163118
     /*  163118 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(163181), // Rule ID 5603 //
     /*  163123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  163134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  163137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163162 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  163162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163179 */     GIR_RootConstrainSelectedInstOperands,
     /*  163180 */     // GIR_Coverage, 5603,
     /*  163180 */     GIR_EraseRootFromParent_Done,
     /*  163181 */   // Label 3739: @163181
     /*  163181 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(163244), // Rule ID 5604 //
     /*  163186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  163197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  163200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163225 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  163225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  163228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163242 */     GIR_RootConstrainSelectedInstOperands,
     /*  163243 */     // GIR_Coverage, 5604,
     /*  163243 */     GIR_EraseRootFromParent_Done,
     /*  163244 */   // Label 3740: @163244
     /*  163244 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(163307), // Rule ID 5605 //
     /*  163249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  163260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  163263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  163288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  163291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163305 */     GIR_RootConstrainSelectedInstOperands,
     /*  163306 */     // GIR_Coverage, 5605,
     /*  163306 */     GIR_EraseRootFromParent_Done,
     /*  163307 */   // Label 3741: @163307
     /*  163307 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(163370), // Rule ID 5606 //
     /*  163312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  163323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  163326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  163340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163351 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  163351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  163354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163368 */     GIR_RootConstrainSelectedInstOperands,
     /*  163369 */     // GIR_Coverage, 5606,
     /*  163369 */     GIR_EraseRootFromParent_Done,
     /*  163370 */   // Label 3742: @163370
     /*  163370 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(163433), // Rule ID 5607 //
     /*  163375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  163386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  163389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  163403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  163414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  163417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163431 */     GIR_RootConstrainSelectedInstOperands,
     /*  163432 */     // GIR_Coverage, 5607,
     /*  163432 */     GIR_EraseRootFromParent_Done,
     /*  163433 */   // Label 3743: @163433
     /*  163433 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(163496), // Rule ID 5608 //
     /*  163438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  163449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  163452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163477 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  163477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163494 */     GIR_RootConstrainSelectedInstOperands,
     /*  163495 */     // GIR_Coverage, 5608,
     /*  163495 */     GIR_EraseRootFromParent_Done,
     /*  163496 */   // Label 3744: @163496
     /*  163496 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(163559), // Rule ID 5609 //
     /*  163501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  163512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  163515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  163540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163557 */     GIR_RootConstrainSelectedInstOperands,
     /*  163558 */     // GIR_Coverage, 5609,
     /*  163558 */     GIR_EraseRootFromParent_Done,
     /*  163559 */   // Label 3745: @163559
     /*  163559 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(163622), // Rule ID 5610 //
     /*  163564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  163575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  163578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163603 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  163603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  163606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163620 */     GIR_RootConstrainSelectedInstOperands,
     /*  163621 */     // GIR_Coverage, 5610,
     /*  163621 */     GIR_EraseRootFromParent_Done,
     /*  163622 */   // Label 3746: @163622
     /*  163622 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(163685), // Rule ID 5611 //
     /*  163627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  163638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  163641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  163666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  163669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163683 */     GIR_RootConstrainSelectedInstOperands,
     /*  163684 */     // GIR_Coverage, 5611,
     /*  163684 */     GIR_EraseRootFromParent_Done,
     /*  163685 */   // Label 3747: @163685
     /*  163685 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(163748), // Rule ID 5612 //
     /*  163690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  163701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  163704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  163718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  163729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  163732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163746 */     GIR_RootConstrainSelectedInstOperands,
     /*  163747 */     // GIR_Coverage, 5612,
     /*  163747 */     GIR_EraseRootFromParent_Done,
     /*  163748 */   // Label 3748: @163748
     /*  163748 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(163811), // Rule ID 5613 //
     /*  163753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  163764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  163767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  163781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  163792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  163795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163809 */     GIR_RootConstrainSelectedInstOperands,
     /*  163810 */     // GIR_Coverage, 5613,
     /*  163810 */     GIR_EraseRootFromParent_Done,
     /*  163811 */   // Label 3749: @163811
     /*  163811 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(163874), // Rule ID 5614 //
     /*  163816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  163827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  163830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163855 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  163855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163872 */     GIR_RootConstrainSelectedInstOperands,
     /*  163873 */     // GIR_Coverage, 5614,
     /*  163873 */     GIR_EraseRootFromParent_Done,
     /*  163874 */   // Label 3750: @163874
     /*  163874 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(163937), // Rule ID 5615 //
     /*  163879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  163890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  163893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  163896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  163899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  163918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  163921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163935 */     GIR_RootConstrainSelectedInstOperands,
     /*  163936 */     // GIR_Coverage, 5615,
     /*  163936 */     GIR_EraseRootFromParent_Done,
     /*  163937 */   // Label 3751: @163937
     /*  163937 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(164000), // Rule ID 5616 //
     /*  163942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  163950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  163953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  163956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  163959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  163962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  163981 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  163981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  163984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  163988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  163990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  163995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163998 */     GIR_RootConstrainSelectedInstOperands,
     /*  163999 */     // GIR_Coverage, 5616,
     /*  163999 */     GIR_EraseRootFromParent_Done,
     /*  164000 */   // Label 3752: @164000
     /*  164000 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(164063), // Rule ID 5617 //
     /*  164005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  164013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  164016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  164019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  164022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  164044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  164047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164061 */     GIR_RootConstrainSelectedInstOperands,
     /*  164062 */     // GIR_Coverage, 5617,
     /*  164062 */     GIR_EraseRootFromParent_Done,
     /*  164063 */   // Label 3753: @164063
     /*  164063 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(164126), // Rule ID 5618 //
     /*  164068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  164076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  164079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  164082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  164085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164107 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  164107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  164110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164124 */     GIR_RootConstrainSelectedInstOperands,
     /*  164125 */     // GIR_Coverage, 5618,
     /*  164125 */     GIR_EraseRootFromParent_Done,
     /*  164126 */   // Label 3754: @164126
     /*  164126 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(164189), // Rule ID 5619 //
     /*  164131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  164139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  164142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  164145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  164148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  164170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  164173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164187 */     GIR_RootConstrainSelectedInstOperands,
     /*  164188 */     // GIR_Coverage, 5619,
     /*  164188 */     GIR_EraseRootFromParent_Done,
     /*  164189 */   // Label 3755: @164189
     /*  164189 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(164252), // Rule ID 5620 //
     /*  164194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  164202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  164205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  164208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  164211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  164222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164233 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  164233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  164236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164250 */     GIR_RootConstrainSelectedInstOperands,
     /*  164251 */     // GIR_Coverage, 5620,
     /*  164251 */     GIR_EraseRootFromParent_Done,
     /*  164252 */   // Label 3756: @164252
     /*  164252 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(164315), // Rule ID 5621 //
     /*  164257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  164265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  164268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  164271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  164274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  164285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  164296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  164299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164313 */     GIR_RootConstrainSelectedInstOperands,
     /*  164314 */     // GIR_Coverage, 5621,
     /*  164314 */     GIR_EraseRootFromParent_Done,
     /*  164315 */   // Label 3757: @164315
     /*  164315 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(164378), // Rule ID 7654 //
     /*  164320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  164331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  164334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  164337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  164359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  164362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164376 */     GIR_RootConstrainSelectedInstOperands,
     /*  164377 */     // GIR_Coverage, 7654,
     /*  164377 */     GIR_EraseRootFromParent_Done,
     /*  164378 */   // Label 3758: @164378
     /*  164378 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(164441), // Rule ID 7655 //
     /*  164383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  164394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  164397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  164400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  164422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  164425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164439 */     GIR_RootConstrainSelectedInstOperands,
     /*  164440 */     // GIR_Coverage, 7655,
     /*  164440 */     GIR_EraseRootFromParent_Done,
     /*  164441 */   // Label 3759: @164441
     /*  164441 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(164504), // Rule ID 7658 //
     /*  164446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  164457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  164460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  164463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  164485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164502 */     GIR_RootConstrainSelectedInstOperands,
     /*  164503 */     // GIR_Coverage, 7658,
     /*  164503 */     GIR_EraseRootFromParent_Done,
     /*  164504 */   // Label 3760: @164504
     /*  164504 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(164567), // Rule ID 7659 //
     /*  164509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  164520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  164523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  164526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  164548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164565 */     GIR_RootConstrainSelectedInstOperands,
     /*  164566 */     // GIR_Coverage, 7659,
     /*  164566 */     GIR_EraseRootFromParent_Done,
     /*  164567 */   // Label 3761: @164567
     /*  164567 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(164630), // Rule ID 7662 //
     /*  164572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  164583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  164586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  164589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164611 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  164611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  164614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164628 */     GIR_RootConstrainSelectedInstOperands,
     /*  164629 */     // GIR_Coverage, 7662,
     /*  164629 */     GIR_EraseRootFromParent_Done,
     /*  164630 */   // Label 3762: @164630
     /*  164630 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(164693), // Rule ID 7663 //
     /*  164635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  164646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  164649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  164652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  164674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  164677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164691 */     GIR_RootConstrainSelectedInstOperands,
     /*  164692 */     // GIR_Coverage, 7663,
     /*  164692 */     GIR_EraseRootFromParent_Done,
     /*  164693 */   // Label 3763: @164693
     /*  164693 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(164756), // Rule ID 7666 //
     /*  164698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  164709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  164712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  164715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  164737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164754 */     GIR_RootConstrainSelectedInstOperands,
     /*  164755 */     // GIR_Coverage, 7666,
     /*  164755 */     GIR_EraseRootFromParent_Done,
     /*  164756 */   // Label 3764: @164756
     /*  164756 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(164819), // Rule ID 7667 //
     /*  164761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  164772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  164775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  164778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  164800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164817 */     GIR_RootConstrainSelectedInstOperands,
     /*  164818 */     // GIR_Coverage, 7667,
     /*  164818 */     GIR_EraseRootFromParent_Done,
     /*  164819 */   // Label 3765: @164819
     /*  164819 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(164882), // Rule ID 7670 //
     /*  164824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  164835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  164838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  164841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164863 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  164863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164880 */     GIR_RootConstrainSelectedInstOperands,
     /*  164881 */     // GIR_Coverage, 7670,
     /*  164881 */     GIR_EraseRootFromParent_Done,
     /*  164882 */   // Label 3766: @164882
     /*  164882 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(164945), // Rule ID 7671 //
     /*  164887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  164898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  164901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  164904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  164907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164926 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  164926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  164929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  164940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164943 */     GIR_RootConstrainSelectedInstOperands,
     /*  164944 */     // GIR_Coverage, 7671,
     /*  164944 */     GIR_EraseRootFromParent_Done,
     /*  164945 */   // Label 3767: @164945
     /*  164945 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(165008), // Rule ID 7674 //
     /*  164950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  164958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  164961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  164964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  164967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  164970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  164989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  164989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  164992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  164996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  164998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165006 */     GIR_RootConstrainSelectedInstOperands,
     /*  165007 */     // GIR_Coverage, 7674,
     /*  165007 */     GIR_EraseRootFromParent_Done,
     /*  165008 */   // Label 3768: @165008
     /*  165008 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(165071), // Rule ID 7675 //
     /*  165013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  165024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  165027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  165030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  165052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165069 */     GIR_RootConstrainSelectedInstOperands,
     /*  165070 */     // GIR_Coverage, 7675,
     /*  165070 */     GIR_EraseRootFromParent_Done,
     /*  165071 */   // Label 3769: @165071
     /*  165071 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(165134), // Rule ID 7678 //
     /*  165076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  165087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  165090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  165093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  165115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165132 */     GIR_RootConstrainSelectedInstOperands,
     /*  165133 */     // GIR_Coverage, 7678,
     /*  165133 */     GIR_EraseRootFromParent_Done,
     /*  165134 */   // Label 3770: @165134
     /*  165134 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(165197), // Rule ID 7679 //
     /*  165139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  165150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  165153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  165156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165178 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  165178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165195 */     GIR_RootConstrainSelectedInstOperands,
     /*  165196 */     // GIR_Coverage, 7679,
     /*  165196 */     GIR_EraseRootFromParent_Done,
     /*  165197 */   // Label 3771: @165197
     /*  165197 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(165260), // Rule ID 7682 //
     /*  165202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  165213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  165216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  165219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  165241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165258 */     GIR_RootConstrainSelectedInstOperands,
     /*  165259 */     // GIR_Coverage, 7682,
     /*  165259 */     GIR_EraseRootFromParent_Done,
     /*  165260 */   // Label 3772: @165260
     /*  165260 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(165323), // Rule ID 7683 //
     /*  165265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  165276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  165279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  165282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  165304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165321 */     GIR_RootConstrainSelectedInstOperands,
     /*  165322 */     // GIR_Coverage, 7683,
     /*  165322 */     GIR_EraseRootFromParent_Done,
     /*  165323 */   // Label 3773: @165323
     /*  165323 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(165386), // Rule ID 7686 //
     /*  165328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  165339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  165342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  165345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  165367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165384 */     GIR_RootConstrainSelectedInstOperands,
     /*  165385 */     // GIR_Coverage, 7686,
     /*  165385 */     GIR_EraseRootFromParent_Done,
     /*  165386 */   // Label 3774: @165386
     /*  165386 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(165449), // Rule ID 7687 //
     /*  165391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  165402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  165405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  165408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  165430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  165433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165447 */     GIR_RootConstrainSelectedInstOperands,
     /*  165448 */     // GIR_Coverage, 7687,
     /*  165448 */     GIR_EraseRootFromParent_Done,
     /*  165449 */   // Label 3775: @165449
     /*  165449 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(165512), // Rule ID 7690 //
     /*  165454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  165465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  165468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  165471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  165493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  165496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165510 */     GIR_RootConstrainSelectedInstOperands,
     /*  165511 */     // GIR_Coverage, 7690,
     /*  165511 */     GIR_EraseRootFromParent_Done,
     /*  165512 */   // Label 3776: @165512
     /*  165512 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(165575), // Rule ID 7691 //
     /*  165517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  165528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  165531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  165534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165556 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  165556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  165559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165573 */     GIR_RootConstrainSelectedInstOperands,
     /*  165574 */     // GIR_Coverage, 7691,
     /*  165574 */     GIR_EraseRootFromParent_Done,
     /*  165575 */   // Label 3777: @165575
     /*  165575 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(165638), // Rule ID 7694 //
     /*  165580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  165591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  165594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  165597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165619 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  165619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  165622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165636 */     GIR_RootConstrainSelectedInstOperands,
     /*  165637 */     // GIR_Coverage, 7694,
     /*  165637 */     GIR_EraseRootFromParent_Done,
     /*  165638 */   // Label 3778: @165638
     /*  165638 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(165701), // Rule ID 7695 //
     /*  165643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  165654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  165657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  165660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165682 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  165682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  165685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165699 */     GIR_RootConstrainSelectedInstOperands,
     /*  165700 */     // GIR_Coverage, 7695,
     /*  165700 */     GIR_EraseRootFromParent_Done,
     /*  165701 */   // Label 3779: @165701
     /*  165701 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(165764), // Rule ID 7698 //
     /*  165706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  165717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  165720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  165723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165745 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  165745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  165748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165762 */     GIR_RootConstrainSelectedInstOperands,
     /*  165763 */     // GIR_Coverage, 7698,
     /*  165763 */     GIR_EraseRootFromParent_Done,
     /*  165764 */   // Label 3780: @165764
     /*  165764 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(165827), // Rule ID 7699 //
     /*  165769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  165780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  165783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  165786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165808 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  165808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  165811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165825 */     GIR_RootConstrainSelectedInstOperands,
     /*  165826 */     // GIR_Coverage, 7699,
     /*  165826 */     GIR_EraseRootFromParent_Done,
     /*  165827 */   // Label 3781: @165827
     /*  165827 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(165890), // Rule ID 7702 //
     /*  165832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  165843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  165846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  165849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  165871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  165874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165888 */     GIR_RootConstrainSelectedInstOperands,
     /*  165889 */     // GIR_Coverage, 7702,
     /*  165889 */     GIR_EraseRootFromParent_Done,
     /*  165890 */   // Label 3782: @165890
     /*  165890 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(165953), // Rule ID 7703 //
     /*  165895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  165906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  165909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  165912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  165915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  165934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  165937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  165941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  165943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  165948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165951 */     GIR_RootConstrainSelectedInstOperands,
     /*  165952 */     // GIR_Coverage, 7703,
     /*  165952 */     GIR_EraseRootFromParent_Done,
     /*  165953 */   // Label 3783: @165953
     /*  165953 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(166016), // Rule ID 7706 //
     /*  165958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  165966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  165969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  165972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  165975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  165978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  165997 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  165997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166014 */     GIR_RootConstrainSelectedInstOperands,
     /*  166015 */     // GIR_Coverage, 7706,
     /*  166015 */     GIR_EraseRootFromParent_Done,
     /*  166016 */   // Label 3784: @166016
     /*  166016 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(166079), // Rule ID 7707 //
     /*  166021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  166032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  166035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  166038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  166060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166077 */     GIR_RootConstrainSelectedInstOperands,
     /*  166078 */     // GIR_Coverage, 7707,
     /*  166078 */     GIR_EraseRootFromParent_Done,
     /*  166079 */   // Label 3785: @166079
     /*  166079 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(166142), // Rule ID 7710 //
     /*  166084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  166095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  166098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  166101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  166123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166140 */     GIR_RootConstrainSelectedInstOperands,
     /*  166141 */     // GIR_Coverage, 7710,
     /*  166141 */     GIR_EraseRootFromParent_Done,
     /*  166142 */   // Label 3786: @166142
     /*  166142 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(166205), // Rule ID 7711 //
     /*  166147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  166158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  166161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  166164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166186 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  166186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166203 */     GIR_RootConstrainSelectedInstOperands,
     /*  166204 */     // GIR_Coverage, 7711,
     /*  166204 */     GIR_EraseRootFromParent_Done,
     /*  166205 */   // Label 3787: @166205
     /*  166205 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(166268), // Rule ID 7714 //
     /*  166210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  166221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  166224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  166227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166249 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  166249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  166252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166266 */     GIR_RootConstrainSelectedInstOperands,
     /*  166267 */     // GIR_Coverage, 7714,
     /*  166267 */     GIR_EraseRootFromParent_Done,
     /*  166268 */   // Label 3788: @166268
     /*  166268 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(166331), // Rule ID 7715 //
     /*  166273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  166284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  166287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  166290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166312 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  166312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  166315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166329 */     GIR_RootConstrainSelectedInstOperands,
     /*  166330 */     // GIR_Coverage, 7715,
     /*  166330 */     GIR_EraseRootFromParent_Done,
     /*  166331 */   // Label 3789: @166331
     /*  166331 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(166394), // Rule ID 7718 //
     /*  166336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  166347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  166350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  166353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  166375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166392 */     GIR_RootConstrainSelectedInstOperands,
     /*  166393 */     // GIR_Coverage, 7718,
     /*  166393 */     GIR_EraseRootFromParent_Done,
     /*  166394 */   // Label 3790: @166394
     /*  166394 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(166457), // Rule ID 7719 //
     /*  166399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  166410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  166413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  166416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  166438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166455 */     GIR_RootConstrainSelectedInstOperands,
     /*  166456 */     // GIR_Coverage, 7719,
     /*  166456 */     GIR_EraseRootFromParent_Done,
     /*  166457 */   // Label 3791: @166457
     /*  166457 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(166520), // Rule ID 7722 //
     /*  166462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  166473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  166476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  166479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  166501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166518 */     GIR_RootConstrainSelectedInstOperands,
     /*  166519 */     // GIR_Coverage, 7722,
     /*  166519 */     GIR_EraseRootFromParent_Done,
     /*  166520 */   // Label 3792: @166520
     /*  166520 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(166583), // Rule ID 7723 //
     /*  166525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  166536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  166539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  166542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  166564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166581 */     GIR_RootConstrainSelectedInstOperands,
     /*  166582 */     // GIR_Coverage, 7723,
     /*  166582 */     GIR_EraseRootFromParent_Done,
     /*  166583 */   // Label 3793: @166583
     /*  166583 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(166646), // Rule ID 7726 //
     /*  166588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  166591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  166599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  166602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  166605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  166627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  166630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166644 */     GIR_RootConstrainSelectedInstOperands,
     /*  166645 */     // GIR_Coverage, 7726,
     /*  166645 */     GIR_EraseRootFromParent_Done,
     /*  166646 */   // Label 3794: @166646
     /*  166646 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(166709), // Rule ID 7727 //
     /*  166651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  166654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  166662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  166665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  166668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  166690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  166693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166707 */     GIR_RootConstrainSelectedInstOperands,
     /*  166708 */     // GIR_Coverage, 7727,
     /*  166708 */     GIR_EraseRootFromParent_Done,
     /*  166709 */   // Label 3795: @166709
     /*  166709 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(166772), // Rule ID 7730 //
     /*  166714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  166717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  166725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  166728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  166731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  166753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166770 */     GIR_RootConstrainSelectedInstOperands,
     /*  166771 */     // GIR_Coverage, 7730,
     /*  166771 */     GIR_EraseRootFromParent_Done,
     /*  166772 */   // Label 3796: @166772
     /*  166772 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(166835), // Rule ID 7731 //
     /*  166777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  166780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  166788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  166791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  166794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  166816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  166819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166833 */     GIR_RootConstrainSelectedInstOperands,
     /*  166834 */     // GIR_Coverage, 7731,
     /*  166834 */     GIR_EraseRootFromParent_Done,
     /*  166835 */   // Label 3797: @166835
     /*  166835 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(166898), // Rule ID 7734 //
     /*  166840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  166843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  166851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  166854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  166857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  166879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166896 */     GIR_RootConstrainSelectedInstOperands,
     /*  166897 */     // GIR_Coverage, 7734,
     /*  166897 */     GIR_EraseRootFromParent_Done,
     /*  166898 */   // Label 3798: @166898
     /*  166898 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(166961), // Rule ID 7735 //
     /*  166903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  166906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  166914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  166917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  166920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  166923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  166942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  166942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  166945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  166949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  166951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  166956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166959 */     GIR_RootConstrainSelectedInstOperands,
     /*  166960 */     // GIR_Coverage, 7735,
     /*  166960 */     GIR_EraseRootFromParent_Done,
     /*  166961 */   // Label 3799: @166961
     /*  166961 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(167024), // Rule ID 7738 //
     /*  166966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  166974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  166977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  166980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  166983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  166986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  167005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  167008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167022 */     GIR_RootConstrainSelectedInstOperands,
     /*  167023 */     // GIR_Coverage, 7738,
     /*  167023 */     GIR_EraseRootFromParent_Done,
     /*  167024 */   // Label 3800: @167024
     /*  167024 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(167087), // Rule ID 7739 //
     /*  167029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  167040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  167043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167068 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  167068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  167071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167085 */     GIR_RootConstrainSelectedInstOperands,
     /*  167086 */     // GIR_Coverage, 7739,
     /*  167086 */     GIR_EraseRootFromParent_Done,
     /*  167087 */   // Label 3801: @167087
     /*  167087 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(167150), // Rule ID 7742 //
     /*  167092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  167103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  167106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  167131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  167134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167148 */     GIR_RootConstrainSelectedInstOperands,
     /*  167149 */     // GIR_Coverage, 7742,
     /*  167149 */     GIR_EraseRootFromParent_Done,
     /*  167150 */   // Label 3802: @167150
     /*  167150 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(167213), // Rule ID 7743 //
     /*  167155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  167166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  167169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  167194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  167197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167211 */     GIR_RootConstrainSelectedInstOperands,
     /*  167212 */     // GIR_Coverage, 7743,
     /*  167212 */     GIR_EraseRootFromParent_Done,
     /*  167213 */   // Label 3803: @167213
     /*  167213 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(167276), // Rule ID 7746 //
     /*  167218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  167229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  167232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  167257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167274 */     GIR_RootConstrainSelectedInstOperands,
     /*  167275 */     // GIR_Coverage, 7746,
     /*  167275 */     GIR_EraseRootFromParent_Done,
     /*  167276 */   // Label 3804: @167276
     /*  167276 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(167339), // Rule ID 7747 //
     /*  167281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  167292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  167295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  167320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167337 */     GIR_RootConstrainSelectedInstOperands,
     /*  167338 */     // GIR_Coverage, 7747,
     /*  167338 */     GIR_EraseRootFromParent_Done,
     /*  167339 */   // Label 3805: @167339
     /*  167339 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(167402), // Rule ID 7750 //
     /*  167344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  167355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  167358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  167383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  167386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167400 */     GIR_RootConstrainSelectedInstOperands,
     /*  167401 */     // GIR_Coverage, 7750,
     /*  167401 */     GIR_EraseRootFromParent_Done,
     /*  167402 */   // Label 3806: @167402
     /*  167402 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(167465), // Rule ID 7751 //
     /*  167407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  167418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  167421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167446 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  167446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  167449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167463 */     GIR_RootConstrainSelectedInstOperands,
     /*  167464 */     // GIR_Coverage, 7751,
     /*  167464 */     GIR_EraseRootFromParent_Done,
     /*  167465 */   // Label 3807: @167465
     /*  167465 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(167528), // Rule ID 7754 //
     /*  167470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  167481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  167484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  167509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167526 */     GIR_RootConstrainSelectedInstOperands,
     /*  167527 */     // GIR_Coverage, 7754,
     /*  167527 */     GIR_EraseRootFromParent_Done,
     /*  167528 */   // Label 3808: @167528
     /*  167528 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(167591), // Rule ID 7755 //
     /*  167533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  167544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  167547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  167572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167589 */     GIR_RootConstrainSelectedInstOperands,
     /*  167590 */     // GIR_Coverage, 7755,
     /*  167590 */     GIR_EraseRootFromParent_Done,
     /*  167591 */   // Label 3809: @167591
     /*  167591 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(167654), // Rule ID 7758 //
     /*  167596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  167607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  167610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  167635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  167652 */     GIR_RootConstrainSelectedInstOperands,
     /*  167653 */     // GIR_Coverage, 7758,
     /*  167653 */     GIR_EraseRootFromParent_Done,
     /*  167654 */   // Label 3810: @167654
     /*  167654 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(167717), // Rule ID 7759 //
     /*  167659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  167670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  167673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  167698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  167701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  167715 */     GIR_RootConstrainSelectedInstOperands,
     /*  167716 */     // GIR_Coverage, 7759,
     /*  167716 */     GIR_EraseRootFromParent_Done,
     /*  167717 */   // Label 3811: @167717
     /*  167717 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(167780), // Rule ID 7762 //
     /*  167722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  167733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  167736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  167761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  167764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167778 */     GIR_RootConstrainSelectedInstOperands,
     /*  167779 */     // GIR_Coverage, 7762,
     /*  167779 */     GIR_EraseRootFromParent_Done,
     /*  167780 */   // Label 3812: @167780
     /*  167780 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(167843), // Rule ID 7763 //
     /*  167785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  167796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  167799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  167824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  167827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167841 */     GIR_RootConstrainSelectedInstOperands,
     /*  167842 */     // GIR_Coverage, 7763,
     /*  167842 */     GIR_EraseRootFromParent_Done,
     /*  167843 */   // Label 3813: @167843
     /*  167843 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(167906), // Rule ID 7766 //
     /*  167848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  167859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  167862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  167887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  167890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167904 */     GIR_RootConstrainSelectedInstOperands,
     /*  167905 */     // GIR_Coverage, 7766,
     /*  167905 */     GIR_EraseRootFromParent_Done,
     /*  167906 */   // Label 3814: @167906
     /*  167906 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(167969), // Rule ID 7767 //
     /*  167911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  167922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  167925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  167928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  167931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  167950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  167950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  167953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  167957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  167959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  167964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167967 */     GIR_RootConstrainSelectedInstOperands,
     /*  167968 */     // GIR_Coverage, 7767,
     /*  167968 */     GIR_EraseRootFromParent_Done,
     /*  167969 */   // Label 3815: @167969
     /*  167969 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(168032), // Rule ID 7770 //
     /*  167974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  167982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  167985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  167988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  167991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  167994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  168013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  168016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  168030 */     GIR_RootConstrainSelectedInstOperands,
     /*  168031 */     // GIR_Coverage, 7770,
     /*  168031 */     GIR_EraseRootFromParent_Done,
     /*  168032 */   // Label 3816: @168032
     /*  168032 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(168095), // Rule ID 7771 //
     /*  168037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  168048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  168051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  168076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  168079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  168093 */     GIR_RootConstrainSelectedInstOperands,
     /*  168094 */     // GIR_Coverage, 7771,
     /*  168094 */     GIR_EraseRootFromParent_Done,
     /*  168095 */   // Label 3817: @168095
     /*  168095 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(168158), // Rule ID 7774 //
     /*  168100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  168103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  168111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  168114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  168139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  168142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  168156 */     GIR_RootConstrainSelectedInstOperands,
     /*  168157 */     // GIR_Coverage, 7774,
     /*  168157 */     GIR_EraseRootFromParent_Done,
     /*  168158 */   // Label 3818: @168158
     /*  168158 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(168221), // Rule ID 7775 //
     /*  168163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  168166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  168174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  168177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  168202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  168205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  168219 */     GIR_RootConstrainSelectedInstOperands,
     /*  168220 */     // GIR_Coverage, 7775,
     /*  168220 */     GIR_EraseRootFromParent_Done,
     /*  168221 */   // Label 3819: @168221
     /*  168221 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(168284), // Rule ID 7778 //
     /*  168226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  168237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  168240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  168254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168265 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  168265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  168268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168282 */     GIR_RootConstrainSelectedInstOperands,
     /*  168283 */     // GIR_Coverage, 7778,
     /*  168283 */     GIR_EraseRootFromParent_Done,
     /*  168284 */   // Label 3820: @168284
     /*  168284 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(168347), // Rule ID 7779 //
     /*  168289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  168300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  168303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  168317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168328 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  168328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  168331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168345 */     GIR_RootConstrainSelectedInstOperands,
     /*  168346 */     // GIR_Coverage, 7779,
     /*  168346 */     GIR_EraseRootFromParent_Done,
     /*  168347 */   // Label 3821: @168347
     /*  168347 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(168410), // Rule ID 7782 //
     /*  168352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  168363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  168366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  168380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168391 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  168391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  168394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168408 */     GIR_RootConstrainSelectedInstOperands,
     /*  168409 */     // GIR_Coverage, 7782,
     /*  168409 */     GIR_EraseRootFromParent_Done,
     /*  168410 */   // Label 3822: @168410
     /*  168410 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(168473), // Rule ID 7783 //
     /*  168415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  168426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  168429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  168443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168454 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  168454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  168457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168471 */     GIR_RootConstrainSelectedInstOperands,
     /*  168472 */     // GIR_Coverage, 7783,
     /*  168472 */     GIR_EraseRootFromParent_Done,
     /*  168473 */   // Label 3823: @168473
     /*  168473 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(168536), // Rule ID 7786 //
     /*  168478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  168489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  168492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  168506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168517 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  168517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  168520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168534 */     GIR_RootConstrainSelectedInstOperands,
     /*  168535 */     // GIR_Coverage, 7786,
     /*  168535 */     GIR_EraseRootFromParent_Done,
     /*  168536 */   // Label 3824: @168536
     /*  168536 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(168599), // Rule ID 7787 //
     /*  168541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  168552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  168555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  168569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168580 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  168580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  168583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  168597 */     GIR_RootConstrainSelectedInstOperands,
     /*  168598 */     // GIR_Coverage, 7787,
     /*  168598 */     GIR_EraseRootFromParent_Done,
     /*  168599 */   // Label 3825: @168599
     /*  168599 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(168662), // Rule ID 7790 //
     /*  168604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  168615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  168618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  168632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  168643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  168646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168660 */     GIR_RootConstrainSelectedInstOperands,
     /*  168661 */     // GIR_Coverage, 7790,
     /*  168661 */     GIR_EraseRootFromParent_Done,
     /*  168662 */   // Label 3826: @168662
     /*  168662 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(168725), // Rule ID 7791 //
     /*  168667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  168678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  168681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  168695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  168706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  168709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168723 */     GIR_RootConstrainSelectedInstOperands,
     /*  168724 */     // GIR_Coverage, 7791,
     /*  168724 */     GIR_EraseRootFromParent_Done,
     /*  168725 */   // Label 3827: @168725
     /*  168725 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(168788), // Rule ID 7794 //
     /*  168730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  168741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  168744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  168758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168769 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  168769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  168772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168786 */     GIR_RootConstrainSelectedInstOperands,
     /*  168787 */     // GIR_Coverage, 7794,
     /*  168787 */     GIR_EraseRootFromParent_Done,
     /*  168788 */   // Label 3828: @168788
     /*  168788 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(168851), // Rule ID 7795 //
     /*  168793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  168804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  168807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  168821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  168832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  168835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168849 */     GIR_RootConstrainSelectedInstOperands,
     /*  168850 */     // GIR_Coverage, 7795,
     /*  168850 */     GIR_EraseRootFromParent_Done,
     /*  168851 */   // Label 3829: @168851
     /*  168851 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(168914), // Rule ID 7798 //
     /*  168856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  168867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  168870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  168876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  168884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168895 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  168895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  168898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168912 */     GIR_RootConstrainSelectedInstOperands,
     /*  168913 */     // GIR_Coverage, 7798,
     /*  168913 */     GIR_EraseRootFromParent_Done,
     /*  168914 */   // Label 3830: @168914
     /*  168914 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(168977), // Rule ID 7799 //
     /*  168919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  168922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  168930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  168933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  168936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  168939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  168943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  168947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  168958 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  168958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  168961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  168965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  168967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  168972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  168975 */     GIR_RootConstrainSelectedInstOperands,
     /*  168976 */     // GIR_Coverage, 7799,
     /*  168976 */     GIR_EraseRootFromParent_Done,
     /*  168977 */   // Label 3831: @168977
     /*  168977 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(169040), // Rule ID 7802 //
     /*  168982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  168985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  168990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  168993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  168996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  168999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  169010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  169021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  169024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169038 */     GIR_RootConstrainSelectedInstOperands,
     /*  169039 */     // GIR_Coverage, 7802,
     /*  169039 */     GIR_EraseRootFromParent_Done,
     /*  169040 */   // Label 3832: @169040
     /*  169040 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(169103), // Rule ID 7803 //
     /*  169045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  169048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  169056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  169059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  169073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  169084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  169087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169101 */     GIR_RootConstrainSelectedInstOperands,
     /*  169102 */     // GIR_Coverage, 7803,
     /*  169102 */     GIR_EraseRootFromParent_Done,
     /*  169103 */   // Label 3833: @169103
     /*  169103 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(169166), // Rule ID 7806 //
     /*  169108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  169111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  169119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  169122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  169125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  169136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  169147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  169150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169164 */     GIR_RootConstrainSelectedInstOperands,
     /*  169165 */     // GIR_Coverage, 7806,
     /*  169165 */     GIR_EraseRootFromParent_Done,
     /*  169166 */   // Label 3834: @169166
     /*  169166 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(169229), // Rule ID 7807 //
     /*  169171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  169174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  169182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  169185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  169199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  169210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  169213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169227 */     GIR_RootConstrainSelectedInstOperands,
     /*  169228 */     // GIR_Coverage, 7807,
     /*  169228 */     GIR_EraseRootFromParent_Done,
     /*  169229 */   // Label 3835: @169229
     /*  169229 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(169292), // Rule ID 7810 //
     /*  169234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  169237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  169245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  169248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  169251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  169262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  169273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  169276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169290 */     GIR_RootConstrainSelectedInstOperands,
     /*  169291 */     // GIR_Coverage, 7810,
     /*  169291 */     GIR_EraseRootFromParent_Done,
     /*  169292 */   // Label 3836: @169292
     /*  169292 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(169355), // Rule ID 7811 //
     /*  169297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  169300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  169308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  169311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  169325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  169336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  169339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  169353 */     GIR_RootConstrainSelectedInstOperands,
     /*  169354 */     // GIR_Coverage, 7811,
     /*  169354 */     GIR_EraseRootFromParent_Done,
     /*  169355 */   // Label 3837: @169355
     /*  169355 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(169418), // Rule ID 7814 //
     /*  169360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  169363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  169371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  169374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  169377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  169388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  169399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  169402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169416 */     GIR_RootConstrainSelectedInstOperands,
     /*  169417 */     // GIR_Coverage, 7814,
     /*  169417 */     GIR_EraseRootFromParent_Done,
     /*  169418 */   // Label 3838: @169418
     /*  169418 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(169481), // Rule ID 7815 //
     /*  169423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  169426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  169434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  169437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  169451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  169462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  169465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169479 */     GIR_RootConstrainSelectedInstOperands,
     /*  169480 */     // GIR_Coverage, 7815,
     /*  169480 */     GIR_EraseRootFromParent_Done,
     /*  169481 */   // Label 3839: @169481
     /*  169481 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(169544), // Rule ID 7818 //
     /*  169486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  169489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  169497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  169500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  169503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  169514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  169525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  169528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169542 */     GIR_RootConstrainSelectedInstOperands,
     /*  169543 */     // GIR_Coverage, 7818,
     /*  169543 */     GIR_EraseRootFromParent_Done,
     /*  169544 */   // Label 3840: @169544
     /*  169544 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(169607), // Rule ID 7819 //
     /*  169549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  169552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  169560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  169563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  169577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  169588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  169591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169605 */     GIR_RootConstrainSelectedInstOperands,
     /*  169606 */     // GIR_Coverage, 7819,
     /*  169606 */     GIR_EraseRootFromParent_Done,
     /*  169607 */   // Label 3841: @169607
     /*  169607 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(169670), // Rule ID 7822 //
     /*  169612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  169615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  169623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  169626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  169629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  169640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  169651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  169654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169668 */     GIR_RootConstrainSelectedInstOperands,
     /*  169669 */     // GIR_Coverage, 7822,
     /*  169669 */     GIR_EraseRootFromParent_Done,
     /*  169670 */   // Label 3842: @169670
     /*  169670 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(169733), // Rule ID 7823 //
     /*  169675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  169678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  169683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  169686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  169689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  169692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  169703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  169714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  169717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  169731 */     GIR_RootConstrainSelectedInstOperands,
     /*  169732 */     // GIR_Coverage, 7823,
     /*  169732 */     GIR_EraseRootFromParent_Done,
     /*  169733 */   // Label 3843: @169733
     /*  169733 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(169796), // Rule ID 7914 //
     /*  169738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  169741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  169746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  169749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  169752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  169755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169777 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  169777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  169780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  169794 */     GIR_RootConstrainSelectedInstOperands,
     /*  169795 */     // GIR_Coverage, 7914,
     /*  169795 */     GIR_EraseRootFromParent_Done,
     /*  169796 */   // Label 3844: @169796
     /*  169796 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(169859), // Rule ID 7915 //
     /*  169801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  169804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  169809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  169812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  169815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  169818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  169840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  169843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  169857 */     GIR_RootConstrainSelectedInstOperands,
     /*  169858 */     // GIR_Coverage, 7915,
     /*  169858 */     GIR_EraseRootFromParent_Done,
     /*  169859 */   // Label 3845: @169859
     /*  169859 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(169922), // Rule ID 7918 //
     /*  169864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  169867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  169872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  169875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  169878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  169881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  169884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  169903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  169906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  169920 */     GIR_RootConstrainSelectedInstOperands,
     /*  169921 */     // GIR_Coverage, 7918,
     /*  169921 */     GIR_EraseRootFromParent_Done,
     /*  169922 */   // Label 3846: @169922
     /*  169922 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(169985), // Rule ID 7919 //
     /*  169927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  169930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  169935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  169938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  169941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  169944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  169947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  169959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  169966 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  169966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  169969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  169973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  169975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  169980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  169983 */     GIR_RootConstrainSelectedInstOperands,
     /*  169984 */     // GIR_Coverage, 7919,
     /*  169984 */     GIR_EraseRootFromParent_Done,
     /*  169985 */   // Label 3847: @169985
     /*  169985 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(170048), // Rule ID 7922 //
     /*  169990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  169993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  169998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  170001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  170004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  170007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170029 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  170029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  170046 */     GIR_RootConstrainSelectedInstOperands,
     /*  170047 */     // GIR_Coverage, 7922,
     /*  170047 */     GIR_EraseRootFromParent_Done,
     /*  170048 */   // Label 3848: @170048
     /*  170048 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(170111), // Rule ID 7923 //
     /*  170053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  170064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  170067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  170070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  170092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  170109 */     GIR_RootConstrainSelectedInstOperands,
     /*  170110 */     // GIR_Coverage, 7923,
     /*  170110 */     GIR_EraseRootFromParent_Done,
     /*  170111 */   // Label 3849: @170111
     /*  170111 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(170174), // Rule ID 7926 //
     /*  170116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  170130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  170133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  170155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  170158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170172 */     GIR_RootConstrainSelectedInstOperands,
     /*  170173 */     // GIR_Coverage, 7926,
     /*  170173 */     GIR_EraseRootFromParent_Done,
     /*  170174 */   // Label 3850: @170174
     /*  170174 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(170237), // Rule ID 7927 //
     /*  170179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  170193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  170196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  170218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  170221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170235 */     GIR_RootConstrainSelectedInstOperands,
     /*  170236 */     // GIR_Coverage, 7927,
     /*  170236 */     GIR_EraseRootFromParent_Done,
     /*  170237 */   // Label 3851: @170237
     /*  170237 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(170300), // Rule ID 7930 //
     /*  170242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  170253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  170256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  170259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  170281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170298 */     GIR_RootConstrainSelectedInstOperands,
     /*  170299 */     // GIR_Coverage, 7930,
     /*  170299 */     GIR_EraseRootFromParent_Done,
     /*  170300 */   // Label 3852: @170300
     /*  170300 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(170363), // Rule ID 7931 //
     /*  170305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  170316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  170319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  170322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  170344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170361 */     GIR_RootConstrainSelectedInstOperands,
     /*  170362 */     // GIR_Coverage, 7931,
     /*  170362 */     GIR_EraseRootFromParent_Done,
     /*  170363 */   // Label 3853: @170363
     /*  170363 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(170426), // Rule ID 7934 //
     /*  170368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  170382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  170385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  170407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  170424 */     GIR_RootConstrainSelectedInstOperands,
     /*  170425 */     // GIR_Coverage, 7934,
     /*  170425 */     GIR_EraseRootFromParent_Done,
     /*  170426 */   // Label 3854: @170426
     /*  170426 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(170489), // Rule ID 7935 //
     /*  170431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  170445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  170448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  170470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  170473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  170487 */     GIR_RootConstrainSelectedInstOperands,
     /*  170488 */     // GIR_Coverage, 7935,
     /*  170488 */     GIR_EraseRootFromParent_Done,
     /*  170489 */   // Label 3855: @170489
     /*  170489 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(170552), // Rule ID 7938 //
     /*  170494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  170505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  170508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  170511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170533 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  170533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  170550 */     GIR_RootConstrainSelectedInstOperands,
     /*  170551 */     // GIR_Coverage, 7938,
     /*  170551 */     GIR_EraseRootFromParent_Done,
     /*  170552 */   // Label 3856: @170552
     /*  170552 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(170615), // Rule ID 7939 //
     /*  170557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  170568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  170571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  170574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  170596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  170613 */     GIR_RootConstrainSelectedInstOperands,
     /*  170614 */     // GIR_Coverage, 7939,
     /*  170614 */     GIR_EraseRootFromParent_Done,
     /*  170615 */   // Label 3857: @170615
     /*  170615 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(170678), // Rule ID 7942 //
     /*  170620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  170631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  170634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  170637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  170659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170676 */     GIR_RootConstrainSelectedInstOperands,
     /*  170677 */     // GIR_Coverage, 7942,
     /*  170677 */     GIR_EraseRootFromParent_Done,
     /*  170678 */   // Label 3858: @170678
     /*  170678 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(170741), // Rule ID 7943 //
     /*  170683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  170694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  170697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  170700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  170722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  170739 */     GIR_RootConstrainSelectedInstOperands,
     /*  170740 */     // GIR_Coverage, 7943,
     /*  170740 */     GIR_EraseRootFromParent_Done,
     /*  170741 */   // Label 3859: @170741
     /*  170741 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(170804), // Rule ID 7946 //
     /*  170746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  170749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  170757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  170760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  170763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170785 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  170785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  170802 */     GIR_RootConstrainSelectedInstOperands,
     /*  170803 */     // GIR_Coverage, 7946,
     /*  170803 */     GIR_EraseRootFromParent_Done,
     /*  170804 */   // Label 3860: @170804
     /*  170804 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(170867), // Rule ID 7947 //
     /*  170809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  170812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  170820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  170823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  170826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  170848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  170865 */     GIR_RootConstrainSelectedInstOperands,
     /*  170866 */     // GIR_Coverage, 7947,
     /*  170866 */     GIR_EraseRootFromParent_Done,
     /*  170867 */   // Label 3861: @170867
     /*  170867 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(170930), // Rule ID 7950 //
     /*  170872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  170875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  170886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  170889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  170892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170911 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  170911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  170928 */     GIR_RootConstrainSelectedInstOperands,
     /*  170929 */     // GIR_Coverage, 7950,
     /*  170929 */     GIR_EraseRootFromParent_Done,
     /*  170930 */   // Label 3862: @170930
     /*  170930 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(170993), // Rule ID 7951 //
     /*  170935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  170938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  170943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  170946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  170949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  170952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  170955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  170967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  170974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  170974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  170977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  170981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  170983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  170988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  170991 */     GIR_RootConstrainSelectedInstOperands,
     /*  170992 */     // GIR_Coverage, 7951,
     /*  170992 */     GIR_EraseRootFromParent_Done,
     /*  170993 */   // Label 3863: @170993
     /*  170993 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(171056), // Rule ID 7954 //
     /*  170998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  171009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  171012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  171015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  171037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171054 */     GIR_RootConstrainSelectedInstOperands,
     /*  171055 */     // GIR_Coverage, 7954,
     /*  171055 */     GIR_EraseRootFromParent_Done,
     /*  171056 */   // Label 3864: @171056
     /*  171056 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(171119), // Rule ID 7955 //
     /*  171061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  171072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  171075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  171078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  171100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171117 */     GIR_RootConstrainSelectedInstOperands,
     /*  171118 */     // GIR_Coverage, 7955,
     /*  171118 */     GIR_EraseRootFromParent_Done,
     /*  171119 */   // Label 3865: @171119
     /*  171119 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(171182), // Rule ID 7958 //
     /*  171124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  171135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  171138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  171141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  171163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171180 */     GIR_RootConstrainSelectedInstOperands,
     /*  171181 */     // GIR_Coverage, 7958,
     /*  171181 */     GIR_EraseRootFromParent_Done,
     /*  171182 */   // Label 3866: @171182
     /*  171182 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(171245), // Rule ID 7959 //
     /*  171187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  171198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  171201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  171204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171226 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  171226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171243 */     GIR_RootConstrainSelectedInstOperands,
     /*  171244 */     // GIR_Coverage, 7959,
     /*  171244 */     GIR_EraseRootFromParent_Done,
     /*  171245 */   // Label 3867: @171245
     /*  171245 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(171308), // Rule ID 7962 //
     /*  171250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  171261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  171264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  171267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171289 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  171289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  171292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171306 */     GIR_RootConstrainSelectedInstOperands,
     /*  171307 */     // GIR_Coverage, 7962,
     /*  171307 */     GIR_EraseRootFromParent_Done,
     /*  171308 */   // Label 3868: @171308
     /*  171308 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(171371), // Rule ID 7963 //
     /*  171313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  171324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  171327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  171330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171352 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  171352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  171355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171369 */     GIR_RootConstrainSelectedInstOperands,
     /*  171370 */     // GIR_Coverage, 7963,
     /*  171370 */     GIR_EraseRootFromParent_Done,
     /*  171371 */   // Label 3869: @171371
     /*  171371 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(171434), // Rule ID 7966 //
     /*  171376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  171387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  171390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  171393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  171415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171432 */     GIR_RootConstrainSelectedInstOperands,
     /*  171433 */     // GIR_Coverage, 7966,
     /*  171433 */     GIR_EraseRootFromParent_Done,
     /*  171434 */   // Label 3870: @171434
     /*  171434 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(171497), // Rule ID 7967 //
     /*  171439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  171450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  171453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  171456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  171478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171495 */     GIR_RootConstrainSelectedInstOperands,
     /*  171496 */     // GIR_Coverage, 7967,
     /*  171496 */     GIR_EraseRootFromParent_Done,
     /*  171497 */   // Label 3871: @171497
     /*  171497 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(171560), // Rule ID 7970 //
     /*  171502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  171513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  171516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  171519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  171541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171558 */     GIR_RootConstrainSelectedInstOperands,
     /*  171559 */     // GIR_Coverage, 7970,
     /*  171559 */     GIR_EraseRootFromParent_Done,
     /*  171560 */   // Label 3872: @171560
     /*  171560 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(171623), // Rule ID 7971 //
     /*  171565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  171576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  171579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  171582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  171604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171621 */     GIR_RootConstrainSelectedInstOperands,
     /*  171622 */     // GIR_Coverage, 7971,
     /*  171622 */     GIR_EraseRootFromParent_Done,
     /*  171623 */   // Label 3873: @171623
     /*  171623 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(171686), // Rule ID 7974 //
     /*  171628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  171639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  171642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  171645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171667 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  171667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  171670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171684 */     GIR_RootConstrainSelectedInstOperands,
     /*  171685 */     // GIR_Coverage, 7974,
     /*  171685 */     GIR_EraseRootFromParent_Done,
     /*  171686 */   // Label 3874: @171686
     /*  171686 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(171749), // Rule ID 7975 //
     /*  171691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  171702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  171705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  171708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  171723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171730 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  171730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  171733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171747 */     GIR_RootConstrainSelectedInstOperands,
     /*  171748 */     // GIR_Coverage, 7975,
     /*  171748 */     GIR_EraseRootFromParent_Done,
     /*  171749 */   // Label 3875: @171749
     /*  171749 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(171812), // Rule ID 7978 //
     /*  171754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  171765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  171768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  171771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  171793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171810 */     GIR_RootConstrainSelectedInstOperands,
     /*  171811 */     // GIR_Coverage, 7978,
     /*  171811 */     GIR_EraseRootFromParent_Done,
     /*  171812 */   // Label 3876: @171812
     /*  171812 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(171875), // Rule ID 7979 //
     /*  171817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  171828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  171831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  171834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  171849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171856 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  171856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  171859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171873 */     GIR_RootConstrainSelectedInstOperands,
     /*  171874 */     // GIR_Coverage, 7979,
     /*  171874 */     GIR_EraseRootFromParent_Done,
     /*  171875 */   // Label 3877: @171875
     /*  171875 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(171938), // Rule ID 7982 //
     /*  171880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  171891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  171894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  171897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  171900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  171919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171936 */     GIR_RootConstrainSelectedInstOperands,
     /*  171937 */     // GIR_Coverage, 7982,
     /*  171937 */     GIR_EraseRootFromParent_Done,
     /*  171938 */   // Label 3878: @171938
     /*  171938 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(172001), // Rule ID 7983 //
     /*  171943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  171951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  171954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  171957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  171960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  171963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  171975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  171982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  171982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  171985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  171989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  171991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  171996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171999 */     GIR_RootConstrainSelectedInstOperands,
     /*  172000 */     // GIR_Coverage, 7983,
     /*  172000 */     GIR_EraseRootFromParent_Done,
     /*  172001 */   // Label 3879: @172001
     /*  172001 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(172064), // Rule ID 7986 //
     /*  172006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  172017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  172020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  172023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172045 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  172045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  172048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172062 */     GIR_RootConstrainSelectedInstOperands,
     /*  172063 */     // GIR_Coverage, 7986,
     /*  172063 */     GIR_EraseRootFromParent_Done,
     /*  172064 */   // Label 3880: @172064
     /*  172064 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(172127), // Rule ID 7987 //
     /*  172069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  172080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  172083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  172086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  172108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  172111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172125 */     GIR_RootConstrainSelectedInstOperands,
     /*  172126 */     // GIR_Coverage, 7987,
     /*  172126 */     GIR_EraseRootFromParent_Done,
     /*  172127 */   // Label 3881: @172127
     /*  172127 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(172190), // Rule ID 7990 //
     /*  172132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  172143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  172146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  172149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  172160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  172164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  172171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  172174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172188 */     GIR_RootConstrainSelectedInstOperands,
     /*  172189 */     // GIR_Coverage, 7990,
     /*  172189 */     GIR_EraseRootFromParent_Done,
     /*  172190 */   // Label 3882: @172190
     /*  172190 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(172253), // Rule ID 7991 //
     /*  172195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  172206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  172209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  172212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  172223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  172227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172234 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  172234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  172237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172251 */     GIR_RootConstrainSelectedInstOperands,
     /*  172252 */     // GIR_Coverage, 7991,
     /*  172252 */     GIR_EraseRootFromParent_Done,
     /*  172253 */   // Label 3883: @172253
     /*  172253 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(172316), // Rule ID 7994 //
     /*  172258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  172269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  172272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  172275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  172286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  172290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172297 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  172297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  172300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172314 */     GIR_RootConstrainSelectedInstOperands,
     /*  172315 */     // GIR_Coverage, 7994,
     /*  172315 */     GIR_EraseRootFromParent_Done,
     /*  172316 */   // Label 3884: @172316
     /*  172316 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(172379), // Rule ID 7995 //
     /*  172321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  172332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  172335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  172338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  172349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  172353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  172360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  172363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172377 */     GIR_RootConstrainSelectedInstOperands,
     /*  172378 */     // GIR_Coverage, 7995,
     /*  172378 */     GIR_EraseRootFromParent_Done,
     /*  172379 */   // Label 3885: @172379
     /*  172379 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(172442), // Rule ID 7998 //
     /*  172384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  172395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  172398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  172401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172423 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  172423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  172426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172440 */     GIR_RootConstrainSelectedInstOperands,
     /*  172441 */     // GIR_Coverage, 7998,
     /*  172441 */     GIR_EraseRootFromParent_Done,
     /*  172442 */   // Label 3886: @172442
     /*  172442 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(172505), // Rule ID 7999 //
     /*  172447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  172458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  172461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  172464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  172479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  172486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  172489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172503 */     GIR_RootConstrainSelectedInstOperands,
     /*  172504 */     // GIR_Coverage, 7999,
     /*  172504 */     GIR_EraseRootFromParent_Done,
     /*  172505 */   // Label 3887: @172505
     /*  172505 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(172568), // Rule ID 8002 //
     /*  172510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  172521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  172524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  172527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172549 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  172549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  172552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172566 */     GIR_RootConstrainSelectedInstOperands,
     /*  172567 */     // GIR_Coverage, 8002,
     /*  172567 */     GIR_EraseRootFromParent_Done,
     /*  172568 */   // Label 3888: @172568
     /*  172568 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(172631), // Rule ID 8003 //
     /*  172573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  172584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  172587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  172590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  172612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  172615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172629 */     GIR_RootConstrainSelectedInstOperands,
     /*  172630 */     // GIR_Coverage, 8003,
     /*  172630 */     GIR_EraseRootFromParent_Done,
     /*  172631 */   // Label 3889: @172631
     /*  172631 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(172694), // Rule ID 8006 //
     /*  172636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  172647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  172650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  172653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172675 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  172675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  172678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172692 */     GIR_RootConstrainSelectedInstOperands,
     /*  172693 */     // GIR_Coverage, 8006,
     /*  172693 */     GIR_EraseRootFromParent_Done,
     /*  172694 */   // Label 3890: @172694
     /*  172694 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(172757), // Rule ID 8007 //
     /*  172699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  172710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  172713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  172716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  172738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  172741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172755 */     GIR_RootConstrainSelectedInstOperands,
     /*  172756 */     // GIR_Coverage, 8007,
     /*  172756 */     GIR_EraseRootFromParent_Done,
     /*  172757 */   // Label 3891: @172757
     /*  172757 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(172820), // Rule ID 8010 //
     /*  172762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  172773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  172776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  172779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172801 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  172801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  172804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172818 */     GIR_RootConstrainSelectedInstOperands,
     /*  172819 */     // GIR_Coverage, 8010,
     /*  172819 */     GIR_EraseRootFromParent_Done,
     /*  172820 */   // Label 3892: @172820
     /*  172820 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(172883), // Rule ID 8011 //
     /*  172825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  172836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  172839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  172842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  172864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  172867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172881 */     GIR_RootConstrainSelectedInstOperands,
     /*  172882 */     // GIR_Coverage, 8011,
     /*  172882 */     GIR_EraseRootFromParent_Done,
     /*  172883 */   // Label 3893: @172883
     /*  172883 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(172946), // Rule ID 8014 //
     /*  172888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  172899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  172902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  172905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  172908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  172927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  172930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  172941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172944 */     GIR_RootConstrainSelectedInstOperands,
     /*  172945 */     // GIR_Coverage, 8014,
     /*  172945 */     GIR_EraseRootFromParent_Done,
     /*  172946 */   // Label 3894: @172946
     /*  172946 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(173009), // Rule ID 8015 //
     /*  172951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  172959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  172962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  172965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  172968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  172971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  172990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  172990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  172993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  172995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  172997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  172999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173007 */     GIR_RootConstrainSelectedInstOperands,
     /*  173008 */     // GIR_Coverage, 8015,
     /*  173008 */     GIR_EraseRootFromParent_Done,
     /*  173009 */   // Label 3895: @173009
     /*  173009 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(173072), // Rule ID 8018 //
     /*  173014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  173025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  173028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173053 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  173053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  173056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173070 */     GIR_RootConstrainSelectedInstOperands,
     /*  173071 */     // GIR_Coverage, 8018,
     /*  173071 */     GIR_EraseRootFromParent_Done,
     /*  173072 */   // Label 3896: @173072
     /*  173072 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(173135), // Rule ID 8019 //
     /*  173077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  173088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  173091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  173116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  173119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173133 */     GIR_RootConstrainSelectedInstOperands,
     /*  173134 */     // GIR_Coverage, 8019,
     /*  173134 */     GIR_EraseRootFromParent_Done,
     /*  173135 */   // Label 3897: @173135
     /*  173135 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(173198), // Rule ID 8022 //
     /*  173140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  173151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  173154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173179 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  173179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  173182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173196 */     GIR_RootConstrainSelectedInstOperands,
     /*  173197 */     // GIR_Coverage, 8022,
     /*  173197 */     GIR_EraseRootFromParent_Done,
     /*  173198 */   // Label 3898: @173198
     /*  173198 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(173261), // Rule ID 8023 //
     /*  173203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  173214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  173217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  173242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  173245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173259 */     GIR_RootConstrainSelectedInstOperands,
     /*  173260 */     // GIR_Coverage, 8023,
     /*  173260 */     GIR_EraseRootFromParent_Done,
     /*  173261 */   // Label 3899: @173261
     /*  173261 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(173324), // Rule ID 8026 //
     /*  173266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  173277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  173280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  173305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173322 */     GIR_RootConstrainSelectedInstOperands,
     /*  173323 */     // GIR_Coverage, 8026,
     /*  173323 */     GIR_EraseRootFromParent_Done,
     /*  173324 */   // Label 3900: @173324
     /*  173324 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(173387), // Rule ID 8027 //
     /*  173329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  173340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  173343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  173368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173385 */     GIR_RootConstrainSelectedInstOperands,
     /*  173386 */     // GIR_Coverage, 8027,
     /*  173386 */     GIR_EraseRootFromParent_Done,
     /*  173387 */   // Label 3901: @173387
     /*  173387 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(173450), // Rule ID 8030 //
     /*  173392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  173403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  173406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  173431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173448 */     GIR_RootConstrainSelectedInstOperands,
     /*  173449 */     // GIR_Coverage, 8030,
     /*  173449 */     GIR_EraseRootFromParent_Done,
     /*  173450 */   // Label 3902: @173450
     /*  173450 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(173513), // Rule ID 8031 //
     /*  173455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  173466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  173469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  173494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173511 */     GIR_RootConstrainSelectedInstOperands,
     /*  173512 */     // GIR_Coverage, 8031,
     /*  173512 */     GIR_EraseRootFromParent_Done,
     /*  173513 */   // Label 3903: @173513
     /*  173513 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(173576), // Rule ID 8034 //
     /*  173518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  173529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  173532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  173557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173574 */     GIR_RootConstrainSelectedInstOperands,
     /*  173575 */     // GIR_Coverage, 8034,
     /*  173575 */     GIR_EraseRootFromParent_Done,
     /*  173576 */   // Label 3904: @173576
     /*  173576 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(173639), // Rule ID 8035 //
     /*  173581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  173592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  173595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  173620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173637 */     GIR_RootConstrainSelectedInstOperands,
     /*  173638 */     // GIR_Coverage, 8035,
     /*  173638 */     GIR_EraseRootFromParent_Done,
     /*  173639 */   // Label 3905: @173639
     /*  173639 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(173702), // Rule ID 8038 //
     /*  173644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  173655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  173658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  173683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173700 */     GIR_RootConstrainSelectedInstOperands,
     /*  173701 */     // GIR_Coverage, 8038,
     /*  173701 */     GIR_EraseRootFromParent_Done,
     /*  173702 */   // Label 3906: @173702
     /*  173702 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(173765), // Rule ID 8039 //
     /*  173707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  173718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  173721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  173746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  173749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173763 */     GIR_RootConstrainSelectedInstOperands,
     /*  173764 */     // GIR_Coverage, 8039,
     /*  173764 */     GIR_EraseRootFromParent_Done,
     /*  173765 */   // Label 3907: @173765
     /*  173765 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(173828), // Rule ID 8042 //
     /*  173770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  173781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  173784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173809 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  173809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  173812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173826 */     GIR_RootConstrainSelectedInstOperands,
     /*  173827 */     // GIR_Coverage, 8042,
     /*  173827 */     GIR_EraseRootFromParent_Done,
     /*  173828 */   // Label 3908: @173828
     /*  173828 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(173891), // Rule ID 8043 //
     /*  173833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  173844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  173847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  173872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  173875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173889 */     GIR_RootConstrainSelectedInstOperands,
     /*  173890 */     // GIR_Coverage, 8043,
     /*  173890 */     GIR_EraseRootFromParent_Done,
     /*  173891 */   // Label 3909: @173891
     /*  173891 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(173954), // Rule ID 8046 //
     /*  173896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  173907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  173910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  173913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  173916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173935 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  173935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  173938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  173940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  173942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  173944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  173949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173952 */     GIR_RootConstrainSelectedInstOperands,
     /*  173953 */     // GIR_Coverage, 8046,
     /*  173953 */     GIR_EraseRootFromParent_Done,
     /*  173954 */   // Label 3910: @173954
     /*  173954 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(174017), // Rule ID 8047 //
     /*  173959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  173967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  173970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  173973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  173976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  173979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  173998 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  173998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  174001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174015 */     GIR_RootConstrainSelectedInstOperands,
     /*  174016 */     // GIR_Coverage, 8047,
     /*  174016 */     GIR_EraseRootFromParent_Done,
     /*  174017 */   // Label 3911: @174017
     /*  174017 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(174080), // Rule ID 8050 //
     /*  174022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  174033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  174036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174061 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  174061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174078 */     GIR_RootConstrainSelectedInstOperands,
     /*  174079 */     // GIR_Coverage, 8050,
     /*  174079 */     GIR_EraseRootFromParent_Done,
     /*  174080 */   // Label 3912: @174080
     /*  174080 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(174143), // Rule ID 8051 //
     /*  174085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  174096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  174099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174124 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  174124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174141 */     GIR_RootConstrainSelectedInstOperands,
     /*  174142 */     // GIR_Coverage, 8051,
     /*  174142 */     GIR_EraseRootFromParent_Done,
     /*  174143 */   // Label 3913: @174143
     /*  174143 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(174206), // Rule ID 8054 //
     /*  174148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  174159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  174162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  174187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  174190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174204 */     GIR_RootConstrainSelectedInstOperands,
     /*  174205 */     // GIR_Coverage, 8054,
     /*  174205 */     GIR_EraseRootFromParent_Done,
     /*  174206 */   // Label 3914: @174206
     /*  174206 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(174269), // Rule ID 8055 //
     /*  174211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  174222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  174225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  174250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  174253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174267 */     GIR_RootConstrainSelectedInstOperands,
     /*  174268 */     // GIR_Coverage, 8055,
     /*  174268 */     GIR_EraseRootFromParent_Done,
     /*  174269 */   // Label 3915: @174269
     /*  174269 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(174332), // Rule ID 8058 //
     /*  174274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  174285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  174288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  174313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  174316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174330 */     GIR_RootConstrainSelectedInstOperands,
     /*  174331 */     // GIR_Coverage, 8058,
     /*  174331 */     GIR_EraseRootFromParent_Done,
     /*  174332 */   // Label 3916: @174332
     /*  174332 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(174395), // Rule ID 8059 //
     /*  174337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  174348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  174351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  174376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  174379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174393 */     GIR_RootConstrainSelectedInstOperands,
     /*  174394 */     // GIR_Coverage, 8059,
     /*  174394 */     GIR_EraseRootFromParent_Done,
     /*  174395 */   // Label 3917: @174395
     /*  174395 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(174458), // Rule ID 8062 //
     /*  174400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  174411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  174414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174439 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  174439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174456 */     GIR_RootConstrainSelectedInstOperands,
     /*  174457 */     // GIR_Coverage, 8062,
     /*  174457 */     GIR_EraseRootFromParent_Done,
     /*  174458 */   // Label 3918: @174458
     /*  174458 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(174521), // Rule ID 8063 //
     /*  174463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  174474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  174477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  174502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174519 */     GIR_RootConstrainSelectedInstOperands,
     /*  174520 */     // GIR_Coverage, 8063,
     /*  174520 */     GIR_EraseRootFromParent_Done,
     /*  174521 */   // Label 3919: @174521
     /*  174521 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(174584), // Rule ID 8066 //
     /*  174526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  174537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  174540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174565 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  174565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  174568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174582 */     GIR_RootConstrainSelectedInstOperands,
     /*  174583 */     // GIR_Coverage, 8066,
     /*  174583 */     GIR_EraseRootFromParent_Done,
     /*  174584 */   // Label 3920: @174584
     /*  174584 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(174647), // Rule ID 8067 //
     /*  174589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  174600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  174603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  174628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  174631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174645 */     GIR_RootConstrainSelectedInstOperands,
     /*  174646 */     // GIR_Coverage, 8067,
     /*  174646 */     GIR_EraseRootFromParent_Done,
     /*  174647 */   // Label 3921: @174647
     /*  174647 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(174710), // Rule ID 8070 //
     /*  174652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  174663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  174666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  174691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  174694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174708 */     GIR_RootConstrainSelectedInstOperands,
     /*  174709 */     // GIR_Coverage, 8070,
     /*  174709 */     GIR_EraseRootFromParent_Done,
     /*  174710 */   // Label 3922: @174710
     /*  174710 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(174773), // Rule ID 8071 //
     /*  174715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  174726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  174729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  174754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  174757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174771 */     GIR_RootConstrainSelectedInstOperands,
     /*  174772 */     // GIR_Coverage, 8071,
     /*  174772 */     GIR_EraseRootFromParent_Done,
     /*  174773 */   // Label 3923: @174773
     /*  174773 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(174836), // Rule ID 8074 //
     /*  174778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  174789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  174792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  174817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174834 */     GIR_RootConstrainSelectedInstOperands,
     /*  174835 */     // GIR_Coverage, 8074,
     /*  174835 */     GIR_EraseRootFromParent_Done,
     /*  174836 */   // Label 3924: @174836
     /*  174836 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(174899), // Rule ID 8075 //
     /*  174841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  174852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  174855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  174880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  174883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174897 */     GIR_RootConstrainSelectedInstOperands,
     /*  174898 */     // GIR_Coverage, 8075,
     /*  174898 */     GIR_EraseRootFromParent_Done,
     /*  174899 */   // Label 3925: @174899
     /*  174899 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(174962), // Rule ID 8078 //
     /*  174904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  174915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  174918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  174921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  174924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  174943 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  174943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  174946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  174948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  174950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  174952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  174957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174960 */     GIR_RootConstrainSelectedInstOperands,
     /*  174961 */     // GIR_Coverage, 8078,
     /*  174961 */     GIR_EraseRootFromParent_Done,
     /*  174962 */   // Label 3926: @174962
     /*  174962 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(175025), // Rule ID 8079 //
     /*  174967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  174975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  174978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  174981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  174984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  174987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  175006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  175009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175023 */     GIR_RootConstrainSelectedInstOperands,
     /*  175024 */     // GIR_Coverage, 8079,
     /*  175024 */     GIR_EraseRootFromParent_Done,
     /*  175025 */   // Label 3927: @175025
     /*  175025 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(175088), // Rule ID 8082 //
     /*  175030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  175033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  175038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  175041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  175044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  175047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175069 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  175069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  175072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175086 */     GIR_RootConstrainSelectedInstOperands,
     /*  175087 */     // GIR_Coverage, 8082,
     /*  175087 */     GIR_EraseRootFromParent_Done,
     /*  175088 */   // Label 3928: @175088
     /*  175088 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(175151), // Rule ID 8083 //
     /*  175093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  175096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  175101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  175104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  175107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  175132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  175135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175149 */     GIR_RootConstrainSelectedInstOperands,
     /*  175150 */     // GIR_Coverage, 8083,
     /*  175150 */     GIR_EraseRootFromParent_Done,
     /*  175151 */   // Label 3929: @175151
     /*  175151 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(175214), // Rule ID 8086 //
     /*  175156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  175159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  175164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  175167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  175170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  175173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  175195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  175198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175212 */     GIR_RootConstrainSelectedInstOperands,
     /*  175213 */     // GIR_Coverage, 8086,
     /*  175213 */     GIR_EraseRootFromParent_Done,
     /*  175214 */   // Label 3930: @175214
     /*  175214 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(175277), // Rule ID 8087 //
     /*  175219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  175222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  175227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  175230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  175233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  175258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  175261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175275 */     GIR_RootConstrainSelectedInstOperands,
     /*  175276 */     // GIR_Coverage, 8087,
     /*  175276 */     GIR_EraseRootFromParent_Done,
     /*  175277 */   // Label 3931: @175277
     /*  175277 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(175340), // Rule ID 8178 //
     /*  175282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  175296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  175299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175321 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  175321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  175324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175338 */     GIR_RootConstrainSelectedInstOperands,
     /*  175339 */     // GIR_Coverage, 8178,
     /*  175339 */     GIR_EraseRootFromParent_Done,
     /*  175340 */   // Label 3932: @175340
     /*  175340 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(175403), // Rule ID 8179 //
     /*  175345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  175359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  175362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  175384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  175387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175401 */     GIR_RootConstrainSelectedInstOperands,
     /*  175402 */     // GIR_Coverage, 8179,
     /*  175402 */     GIR_EraseRootFromParent_Done,
     /*  175403 */   // Label 3933: @175403
     /*  175403 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(175466), // Rule ID 8182 //
     /*  175408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  175419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  175422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  175425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  175447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  175450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175464 */     GIR_RootConstrainSelectedInstOperands,
     /*  175465 */     // GIR_Coverage, 8182,
     /*  175465 */     GIR_EraseRootFromParent_Done,
     /*  175466 */   // Label 3934: @175466
     /*  175466 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(175529), // Rule ID 8183 //
     /*  175471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  175482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  175485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  175488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  175510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  175513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175527 */     GIR_RootConstrainSelectedInstOperands,
     /*  175528 */     // GIR_Coverage, 8183,
     /*  175528 */     GIR_EraseRootFromParent_Done,
     /*  175529 */   // Label 3935: @175529
     /*  175529 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(175592), // Rule ID 8186 //
     /*  175534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  175545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  175548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  175551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175573 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  175573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  175576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175590 */     GIR_RootConstrainSelectedInstOperands,
     /*  175591 */     // GIR_Coverage, 8186,
     /*  175591 */     GIR_EraseRootFromParent_Done,
     /*  175592 */   // Label 3936: @175592
     /*  175592 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(175655), // Rule ID 8187 //
     /*  175597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  175608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  175611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  175614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175636 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  175636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  175639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175653 */     GIR_RootConstrainSelectedInstOperands,
     /*  175654 */     // GIR_Coverage, 8187,
     /*  175654 */     GIR_EraseRootFromParent_Done,
     /*  175655 */   // Label 3937: @175655
     /*  175655 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(175718), // Rule ID 8190 //
     /*  175660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  175674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  175677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175699 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  175699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  175702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175716 */     GIR_RootConstrainSelectedInstOperands,
     /*  175717 */     // GIR_Coverage, 8190,
     /*  175717 */     GIR_EraseRootFromParent_Done,
     /*  175718 */   // Label 3938: @175718
     /*  175718 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(175781), // Rule ID 8191 //
     /*  175723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  175737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  175740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  175762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  175765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175779 */     GIR_RootConstrainSelectedInstOperands,
     /*  175780 */     // GIR_Coverage, 8191,
     /*  175780 */     GIR_EraseRootFromParent_Done,
     /*  175781 */   // Label 3939: @175781
     /*  175781 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(175844), // Rule ID 8194 //
     /*  175786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  175797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  175800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  175803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  175825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  175828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175842 */     GIR_RootConstrainSelectedInstOperands,
     /*  175843 */     // GIR_Coverage, 8194,
     /*  175843 */     GIR_EraseRootFromParent_Done,
     /*  175844 */   // Label 3940: @175844
     /*  175844 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(175907), // Rule ID 8195 //
     /*  175849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  175860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  175863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  175866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  175888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  175891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175905 */     GIR_RootConstrainSelectedInstOperands,
     /*  175906 */     // GIR_Coverage, 8195,
     /*  175906 */     GIR_EraseRootFromParent_Done,
     /*  175907 */   // Label 3941: @175907
     /*  175907 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(175970), // Rule ID 8198 //
     /*  175912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  175926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  175929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  175932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  175951 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  175951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  175954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  175956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  175958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  175960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  175965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175968 */     GIR_RootConstrainSelectedInstOperands,
     /*  175969 */     // GIR_Coverage, 8198,
     /*  175969 */     GIR_EraseRootFromParent_Done,
     /*  175970 */   // Label 3942: @175970
     /*  175970 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(176033), // Rule ID 8199 //
     /*  175975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  175983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  175986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  175989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  175992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  175995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  176014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  176017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176031 */     GIR_RootConstrainSelectedInstOperands,
     /*  176032 */     // GIR_Coverage, 8199,
     /*  176032 */     GIR_EraseRootFromParent_Done,
     /*  176033 */   // Label 3943: @176033
     /*  176033 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(176096), // Rule ID 8202 //
     /*  176038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  176049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  176052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  176055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  176077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176094 */     GIR_RootConstrainSelectedInstOperands,
     /*  176095 */     // GIR_Coverage, 8202,
     /*  176095 */     GIR_EraseRootFromParent_Done,
     /*  176096 */   // Label 3944: @176096
     /*  176096 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(176159), // Rule ID 8203 //
     /*  176101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  176112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  176115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  176118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  176140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176157 */     GIR_RootConstrainSelectedInstOperands,
     /*  176158 */     // GIR_Coverage, 8203,
     /*  176158 */     GIR_EraseRootFromParent_Done,
     /*  176159 */   // Label 3945: @176159
     /*  176159 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(176222), // Rule ID 8206 //
     /*  176164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  176175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  176178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  176181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  176203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176220 */     GIR_RootConstrainSelectedInstOperands,
     /*  176221 */     // GIR_Coverage, 8206,
     /*  176221 */     GIR_EraseRootFromParent_Done,
     /*  176222 */   // Label 3946: @176222
     /*  176222 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(176285), // Rule ID 8207 //
     /*  176227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  176238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  176241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  176244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  176266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176283 */     GIR_RootConstrainSelectedInstOperands,
     /*  176284 */     // GIR_Coverage, 8207,
     /*  176284 */     GIR_EraseRootFromParent_Done,
     /*  176285 */   // Label 3947: @176285
     /*  176285 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(176348), // Rule ID 8210 //
     /*  176290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  176301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  176304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  176307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  176329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176346 */     GIR_RootConstrainSelectedInstOperands,
     /*  176347 */     // GIR_Coverage, 8210,
     /*  176347 */     GIR_EraseRootFromParent_Done,
     /*  176348 */   // Label 3948: @176348
     /*  176348 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(176411), // Rule ID 8211 //
     /*  176353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  176364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  176367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  176370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  176392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176409 */     GIR_RootConstrainSelectedInstOperands,
     /*  176410 */     // GIR_Coverage, 8211,
     /*  176410 */     GIR_EraseRootFromParent_Done,
     /*  176411 */   // Label 3949: @176411
     /*  176411 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(176474), // Rule ID 8214 //
     /*  176416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  176419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  176427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  176430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  176433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  176455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176472 */     GIR_RootConstrainSelectedInstOperands,
     /*  176473 */     // GIR_Coverage, 8214,
     /*  176473 */     GIR_EraseRootFromParent_Done,
     /*  176474 */   // Label 3950: @176474
     /*  176474 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(176537), // Rule ID 8215 //
     /*  176479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  176482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  176490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  176493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  176496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  176518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  176521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176535 */     GIR_RootConstrainSelectedInstOperands,
     /*  176536 */     // GIR_Coverage, 8215,
     /*  176536 */     GIR_EraseRootFromParent_Done,
     /*  176537 */   // Label 3951: @176537
     /*  176537 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(176600), // Rule ID 8218 //
     /*  176542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  176553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  176556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  176559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176581 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  176581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  176584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176598 */     GIR_RootConstrainSelectedInstOperands,
     /*  176599 */     // GIR_Coverage, 8218,
     /*  176599 */     GIR_EraseRootFromParent_Done,
     /*  176600 */   // Label 3952: @176600
     /*  176600 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(176663), // Rule ID 8219 //
     /*  176605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  176616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  176619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  176622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  176644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  176647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176661 */     GIR_RootConstrainSelectedInstOperands,
     /*  176662 */     // GIR_Coverage, 8219,
     /*  176662 */     GIR_EraseRootFromParent_Done,
     /*  176663 */   // Label 3953: @176663
     /*  176663 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(176726), // Rule ID 8222 //
     /*  176668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  176679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  176682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  176685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  176696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  176700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176707 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  176707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  176710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176724 */     GIR_RootConstrainSelectedInstOperands,
     /*  176725 */     // GIR_Coverage, 8222,
     /*  176725 */     GIR_EraseRootFromParent_Done,
     /*  176726 */   // Label 3954: @176726
     /*  176726 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(176789), // Rule ID 8223 //
     /*  176731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  176742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  176745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  176748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  176759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  176763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176770 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  176770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  176773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176787 */     GIR_RootConstrainSelectedInstOperands,
     /*  176788 */     // GIR_Coverage, 8223,
     /*  176788 */     GIR_EraseRootFromParent_Done,
     /*  176789 */   // Label 3955: @176789
     /*  176789 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(176852), // Rule ID 8226 //
     /*  176794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  176805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  176808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  176811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  176822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  176826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176833 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  176833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  176836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176850 */     GIR_RootConstrainSelectedInstOperands,
     /*  176851 */     // GIR_Coverage, 8226,
     /*  176851 */     GIR_EraseRootFromParent_Done,
     /*  176852 */   // Label 3956: @176852
     /*  176852 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(176915), // Rule ID 8227 //
     /*  176857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  176868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  176871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  176874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  176877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  176885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  176889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176896 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  176896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  176899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176913 */     GIR_RootConstrainSelectedInstOperands,
     /*  176914 */     // GIR_Coverage, 8227,
     /*  176914 */     GIR_EraseRootFromParent_Done,
     /*  176915 */   // Label 3957: @176915
     /*  176915 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(176978), // Rule ID 8230 //
     /*  176920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  176931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  176934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  176937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  176940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  176959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  176959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  176962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  176964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  176966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  176968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  176973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176976 */     GIR_RootConstrainSelectedInstOperands,
     /*  176977 */     // GIR_Coverage, 8230,
     /*  176977 */     GIR_EraseRootFromParent_Done,
     /*  176978 */   // Label 3958: @176978
     /*  176978 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(177041), // Rule ID 8231 //
     /*  176983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  176991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  176994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  176997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  177000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  177022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  177025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177039 */     GIR_RootConstrainSelectedInstOperands,
     /*  177040 */     // GIR_Coverage, 8231,
     /*  177040 */     GIR_EraseRootFromParent_Done,
     /*  177041 */   // Label 3959: @177041
     /*  177041 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(177104), // Rule ID 8234 //
     /*  177046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  177057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  177060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  177063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  177085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177102 */     GIR_RootConstrainSelectedInstOperands,
     /*  177103 */     // GIR_Coverage, 8234,
     /*  177103 */     GIR_EraseRootFromParent_Done,
     /*  177104 */   // Label 3960: @177104
     /*  177104 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(177167), // Rule ID 8235 //
     /*  177109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  177120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  177123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  177126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177148 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  177148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177165 */     GIR_RootConstrainSelectedInstOperands,
     /*  177166 */     // GIR_Coverage, 8235,
     /*  177166 */     GIR_EraseRootFromParent_Done,
     /*  177167 */   // Label 3961: @177167
     /*  177167 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(177230), // Rule ID 8238 //
     /*  177172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  177183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  177186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  177189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  177211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  177214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177228 */     GIR_RootConstrainSelectedInstOperands,
     /*  177229 */     // GIR_Coverage, 8238,
     /*  177229 */     GIR_EraseRootFromParent_Done,
     /*  177230 */   // Label 3962: @177230
     /*  177230 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(177293), // Rule ID 8239 //
     /*  177235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  177246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  177249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  177252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177274 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  177274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  177277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177291 */     GIR_RootConstrainSelectedInstOperands,
     /*  177292 */     // GIR_Coverage, 8239,
     /*  177292 */     GIR_EraseRootFromParent_Done,
     /*  177293 */   // Label 3963: @177293
     /*  177293 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(177356), // Rule ID 8242 //
     /*  177298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  177309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  177312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  177315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177337 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  177337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  177340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177354 */     GIR_RootConstrainSelectedInstOperands,
     /*  177355 */     // GIR_Coverage, 8242,
     /*  177355 */     GIR_EraseRootFromParent_Done,
     /*  177356 */   // Label 3964: @177356
     /*  177356 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(177419), // Rule ID 8243 //
     /*  177361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  177372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  177375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  177378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  177400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  177403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177417 */     GIR_RootConstrainSelectedInstOperands,
     /*  177418 */     // GIR_Coverage, 8243,
     /*  177418 */     GIR_EraseRootFromParent_Done,
     /*  177419 */   // Label 3965: @177419
     /*  177419 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(177482), // Rule ID 8246 //
     /*  177424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  177435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  177438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  177441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  177463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177480 */     GIR_RootConstrainSelectedInstOperands,
     /*  177481 */     // GIR_Coverage, 8246,
     /*  177481 */     GIR_EraseRootFromParent_Done,
     /*  177482 */   // Label 3966: @177482
     /*  177482 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(177545), // Rule ID 8247 //
     /*  177487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  177498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  177501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  177504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  177526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177543 */     GIR_RootConstrainSelectedInstOperands,
     /*  177544 */     // GIR_Coverage, 8247,
     /*  177544 */     GIR_EraseRootFromParent_Done,
     /*  177545 */   // Label 3967: @177545
     /*  177545 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(177608), // Rule ID 8250 //
     /*  177550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  177561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  177564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  177567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  177589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  177592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177606 */     GIR_RootConstrainSelectedInstOperands,
     /*  177607 */     // GIR_Coverage, 8250,
     /*  177607 */     GIR_EraseRootFromParent_Done,
     /*  177608 */   // Label 3968: @177608
     /*  177608 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(177671), // Rule ID 8251 //
     /*  177613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  177624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  177627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  177630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  177652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  177655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177669 */     GIR_RootConstrainSelectedInstOperands,
     /*  177670 */     // GIR_Coverage, 8251,
     /*  177670 */     GIR_EraseRootFromParent_Done,
     /*  177671 */   // Label 3969: @177671
     /*  177671 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(177734), // Rule ID 8254 //
     /*  177676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  177679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  177687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  177690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  177693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  177715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  177718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177732 */     GIR_RootConstrainSelectedInstOperands,
     /*  177733 */     // GIR_Coverage, 8254,
     /*  177733 */     GIR_EraseRootFromParent_Done,
     /*  177734 */   // Label 3970: @177734
     /*  177734 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(177797), // Rule ID 8255 //
     /*  177739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  177742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  177750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  177753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  177756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  177778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  177781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177795 */     GIR_RootConstrainSelectedInstOperands,
     /*  177796 */     // GIR_Coverage, 8255,
     /*  177796 */     GIR_EraseRootFromParent_Done,
     /*  177797 */   // Label 3971: @177797
     /*  177797 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(177860), // Rule ID 8258 //
     /*  177802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  177805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  177813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  177816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  177819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177841 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  177841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177858 */     GIR_RootConstrainSelectedInstOperands,
     /*  177859 */     // GIR_Coverage, 8258,
     /*  177859 */     GIR_EraseRootFromParent_Done,
     /*  177860 */   // Label 3972: @177860
     /*  177860 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(177923), // Rule ID 8259 //
     /*  177865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  177868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  177876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  177879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  177882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  177885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  177904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  177907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177921 */     GIR_RootConstrainSelectedInstOperands,
     /*  177922 */     // GIR_Coverage, 8259,
     /*  177922 */     GIR_EraseRootFromParent_Done,
     /*  177923 */   // Label 3973: @177923
     /*  177923 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(177986), // Rule ID 8262 //
     /*  177928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  177931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  177939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  177942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  177945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  177948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  177960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  177967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  177967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  177970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  177972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  177974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  177976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  177981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177984 */     GIR_RootConstrainSelectedInstOperands,
     /*  177985 */     // GIR_Coverage, 8262,
     /*  177985 */     GIR_EraseRootFromParent_Done,
     /*  177986 */   // Label 3974: @177986
     /*  177986 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(178049), // Rule ID 8263 //
     /*  177991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  177994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  177999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  178002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  178005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  178008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  178030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  178033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178047 */     GIR_RootConstrainSelectedInstOperands,
     /*  178048 */     // GIR_Coverage, 8263,
     /*  178048 */     GIR_EraseRootFromParent_Done,
     /*  178049 */   // Label 3975: @178049
     /*  178049 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(178112), // Rule ID 8266 //
     /*  178054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  178068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178093 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  178093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  178096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178110 */     GIR_RootConstrainSelectedInstOperands,
     /*  178111 */     // GIR_Coverage, 8266,
     /*  178111 */     GIR_EraseRootFromParent_Done,
     /*  178112 */   // Label 3976: @178112
     /*  178112 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(178175), // Rule ID 8267 //
     /*  178117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  178131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178156 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  178156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  178159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178173 */     GIR_RootConstrainSelectedInstOperands,
     /*  178174 */     // GIR_Coverage, 8267,
     /*  178174 */     GIR_EraseRootFromParent_Done,
     /*  178175 */   // Label 3977: @178175
     /*  178175 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(178238), // Rule ID 8270 //
     /*  178180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  178191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  178194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  178219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  178222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178236 */     GIR_RootConstrainSelectedInstOperands,
     /*  178237 */     // GIR_Coverage, 8270,
     /*  178237 */     GIR_EraseRootFromParent_Done,
     /*  178238 */   // Label 3978: @178238
     /*  178238 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(178301), // Rule ID 8271 //
     /*  178243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  178254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  178257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  178282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  178285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178299 */     GIR_RootConstrainSelectedInstOperands,
     /*  178300 */     // GIR_Coverage, 8271,
     /*  178300 */     GIR_EraseRootFromParent_Done,
     /*  178301 */   // Label 3979: @178301
     /*  178301 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(178364), // Rule ID 8274 //
     /*  178306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  178317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  178320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178345 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  178345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178362 */     GIR_RootConstrainSelectedInstOperands,
     /*  178363 */     // GIR_Coverage, 8274,
     /*  178363 */     GIR_EraseRootFromParent_Done,
     /*  178364 */   // Label 3980: @178364
     /*  178364 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(178427), // Rule ID 8275 //
     /*  178369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  178380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  178383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  178408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178425 */     GIR_RootConstrainSelectedInstOperands,
     /*  178426 */     // GIR_Coverage, 8275,
     /*  178426 */     GIR_EraseRootFromParent_Done,
     /*  178427 */   // Label 3981: @178427
     /*  178427 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(178490), // Rule ID 8278 //
     /*  178432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  178446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178471 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  178471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  178474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178488 */     GIR_RootConstrainSelectedInstOperands,
     /*  178489 */     // GIR_Coverage, 8278,
     /*  178489 */     GIR_EraseRootFromParent_Done,
     /*  178490 */   // Label 3982: @178490
     /*  178490 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(178553), // Rule ID 8279 //
     /*  178495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  178509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  178534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  178537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178551 */     GIR_RootConstrainSelectedInstOperands,
     /*  178552 */     // GIR_Coverage, 8279,
     /*  178552 */     GIR_EraseRootFromParent_Done,
     /*  178553 */   // Label 3983: @178553
     /*  178553 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(178616), // Rule ID 8282 //
     /*  178558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  178569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  178572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  178597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178614 */     GIR_RootConstrainSelectedInstOperands,
     /*  178615 */     // GIR_Coverage, 8282,
     /*  178615 */     GIR_EraseRootFromParent_Done,
     /*  178616 */   // Label 3984: @178616
     /*  178616 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(178679), // Rule ID 8283 //
     /*  178621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  178632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  178635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  178660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178677 */     GIR_RootConstrainSelectedInstOperands,
     /*  178678 */     // GIR_Coverage, 8283,
     /*  178678 */     GIR_EraseRootFromParent_Done,
     /*  178679 */   // Label 3985: @178679
     /*  178679 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(178742), // Rule ID 8286 //
     /*  178684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  178698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178723 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  178723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178740 */     GIR_RootConstrainSelectedInstOperands,
     /*  178741 */     // GIR_Coverage, 8286,
     /*  178741 */     GIR_EraseRootFromParent_Done,
     /*  178742 */   // Label 3986: @178742
     /*  178742 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(178805), // Rule ID 8287 //
     /*  178747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  178758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  178761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  178786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  178789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178803 */     GIR_RootConstrainSelectedInstOperands,
     /*  178804 */     // GIR_Coverage, 8287,
     /*  178804 */     GIR_EraseRootFromParent_Done,
     /*  178805 */   // Label 3987: @178805
     /*  178805 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(178868), // Rule ID 8290 //
     /*  178810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  178821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  178824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178849 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  178849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  178852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178866 */     GIR_RootConstrainSelectedInstOperands,
     /*  178867 */     // GIR_Coverage, 8290,
     /*  178867 */     GIR_EraseRootFromParent_Done,
     /*  178868 */   // Label 3988: @178868
     /*  178868 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(178931), // Rule ID 8291 //
     /*  178873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  178884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  178887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  178890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  178893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  178912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  178915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178929 */     GIR_RootConstrainSelectedInstOperands,
     /*  178930 */     // GIR_Coverage, 8291,
     /*  178930 */     GIR_EraseRootFromParent_Done,
     /*  178931 */   // Label 3989: @178931
     /*  178931 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(178994), // Rule ID 8294 //
     /*  178936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  178944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  178947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  178950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  178953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  178956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  178975 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  178975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  178978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  178980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  178982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  178984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  178989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178992 */     GIR_RootConstrainSelectedInstOperands,
     /*  178993 */     // GIR_Coverage, 8294,
     /*  178993 */     GIR_EraseRootFromParent_Done,
     /*  178994 */   // Label 3990: @178994
     /*  178994 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(179057), // Rule ID 8295 //
     /*  178999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  179010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  179013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  179038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  179041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179055 */     GIR_RootConstrainSelectedInstOperands,
     /*  179056 */     // GIR_Coverage, 8295,
     /*  179056 */     GIR_EraseRootFromParent_Done,
     /*  179057 */   // Label 3991: @179057
     /*  179057 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(179120), // Rule ID 8298 //
     /*  179062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  179073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  179076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179101 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  179101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  179104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  179118 */     GIR_RootConstrainSelectedInstOperands,
     /*  179119 */     // GIR_Coverage, 8298,
     /*  179119 */     GIR_EraseRootFromParent_Done,
     /*  179120 */   // Label 3992: @179120
     /*  179120 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(179183), // Rule ID 8299 //
     /*  179125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  179136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  179139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  179164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  179167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  179181 */     GIR_RootConstrainSelectedInstOperands,
     /*  179182 */     // GIR_Coverage, 8299,
     /*  179182 */     GIR_EraseRootFromParent_Done,
     /*  179183 */   // Label 3993: @179183
     /*  179183 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(179246), // Rule ID 8302 //
     /*  179188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  179191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  179199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  179202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  179227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  179230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  179244 */     GIR_RootConstrainSelectedInstOperands,
     /*  179245 */     // GIR_Coverage, 8302,
     /*  179245 */     GIR_EraseRootFromParent_Done,
     /*  179246 */   // Label 3994: @179246
     /*  179246 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(179309), // Rule ID 8303 //
     /*  179251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  179254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  179262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  179265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179290 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  179290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  179293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  179307 */     GIR_RootConstrainSelectedInstOperands,
     /*  179308 */     // GIR_Coverage, 8303,
     /*  179308 */     GIR_EraseRootFromParent_Done,
     /*  179309 */   // Label 3995: @179309
     /*  179309 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(179372), // Rule ID 8306 //
     /*  179314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  179325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  179328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  179342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  179353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  179356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179370 */     GIR_RootConstrainSelectedInstOperands,
     /*  179371 */     // GIR_Coverage, 8306,
     /*  179371 */     GIR_EraseRootFromParent_Done,
     /*  179372 */   // Label 3996: @179372
     /*  179372 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(179435), // Rule ID 8307 //
     /*  179377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  179388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  179391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  179405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  179416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  179419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179433 */     GIR_RootConstrainSelectedInstOperands,
     /*  179434 */     // GIR_Coverage, 8307,
     /*  179434 */     GIR_EraseRootFromParent_Done,
     /*  179435 */   // Label 3997: @179435
     /*  179435 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(179498), // Rule ID 8310 //
     /*  179440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  179451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  179454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  179468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179479 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  179479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  179482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179496 */     GIR_RootConstrainSelectedInstOperands,
     /*  179497 */     // GIR_Coverage, 8310,
     /*  179497 */     GIR_EraseRootFromParent_Done,
     /*  179498 */   // Label 3998: @179498
     /*  179498 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(179561), // Rule ID 8311 //
     /*  179503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  179514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  179517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  179531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179542 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  179542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  179545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179559 */     GIR_RootConstrainSelectedInstOperands,
     /*  179560 */     // GIR_Coverage, 8311,
     /*  179560 */     GIR_EraseRootFromParent_Done,
     /*  179561 */   // Label 3999: @179561
     /*  179561 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(179624), // Rule ID 8314 //
     /*  179566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  179577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  179580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179605 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  179605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  179608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179622 */     GIR_RootConstrainSelectedInstOperands,
     /*  179623 */     // GIR_Coverage, 8314,
     /*  179623 */     GIR_EraseRootFromParent_Done,
     /*  179624 */   // Label 4000: @179624
     /*  179624 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(179687), // Rule ID 8315 //
     /*  179629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  179640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  179643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179668 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  179668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  179671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179685 */     GIR_RootConstrainSelectedInstOperands,
     /*  179686 */     // GIR_Coverage, 8315,
     /*  179686 */     GIR_EraseRootFromParent_Done,
     /*  179687 */   // Label 4001: @179687
     /*  179687 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(179750), // Rule ID 8318 //
     /*  179692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  179703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  179706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  179720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179731 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  179731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  179734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179748 */     GIR_RootConstrainSelectedInstOperands,
     /*  179749 */     // GIR_Coverage, 8318,
     /*  179749 */     GIR_EraseRootFromParent_Done,
     /*  179750 */   // Label 4002: @179750
     /*  179750 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(179813), // Rule ID 8319 //
     /*  179755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  179766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  179769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  179783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  179794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  179797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179811 */     GIR_RootConstrainSelectedInstOperands,
     /*  179812 */     // GIR_Coverage, 8319,
     /*  179812 */     GIR_EraseRootFromParent_Done,
     /*  179813 */   // Label 4003: @179813
     /*  179813 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(179876), // Rule ID 8322 //
     /*  179818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  179829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  179832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  179846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  179857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  179860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179874 */     GIR_RootConstrainSelectedInstOperands,
     /*  179875 */     // GIR_Coverage, 8322,
     /*  179875 */     GIR_EraseRootFromParent_Done,
     /*  179876 */   // Label 4004: @179876
     /*  179876 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(179939), // Rule ID 8323 //
     /*  179881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  179892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  179895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  179901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  179909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  179920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  179923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179937 */     GIR_RootConstrainSelectedInstOperands,
     /*  179938 */     // GIR_Coverage, 8323,
     /*  179938 */     GIR_EraseRootFromParent_Done,
     /*  179939 */   // Label 4005: @179939
     /*  179939 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(180002), // Rule ID 8326 //
     /*  179944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  179952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  179955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  179958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  179961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  179964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  179983 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  179983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  179986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  179988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  179990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  179992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  179997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  180000 */     GIR_RootConstrainSelectedInstOperands,
     /*  180001 */     // GIR_Coverage, 8326,
     /*  180001 */     GIR_EraseRootFromParent_Done,
     /*  180002 */   // Label 4006: @180002
     /*  180002 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(180065), // Rule ID 8327 //
     /*  180007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  180010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  180018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  180021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  180035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  180046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  180049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  180063 */     GIR_RootConstrainSelectedInstOperands,
     /*  180064 */     // GIR_Coverage, 8327,
     /*  180064 */     GIR_EraseRootFromParent_Done,
     /*  180065 */   // Label 4007: @180065
     /*  180065 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(180128), // Rule ID 8330 //
     /*  180070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  180073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  180081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  180084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  180098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  180109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  180112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180126 */     GIR_RootConstrainSelectedInstOperands,
     /*  180127 */     // GIR_Coverage, 8330,
     /*  180127 */     GIR_EraseRootFromParent_Done,
     /*  180128 */   // Label 4008: @180128
     /*  180128 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(180191), // Rule ID 8331 //
     /*  180133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  180136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  180144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  180147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  180161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  180172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  180175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180189 */     GIR_RootConstrainSelectedInstOperands,
     /*  180190 */     // GIR_Coverage, 8331,
     /*  180190 */     GIR_EraseRootFromParent_Done,
     /*  180191 */   // Label 4009: @180191
     /*  180191 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(180254), // Rule ID 8334 //
     /*  180196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  180199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  180207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  180210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  180224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180235 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  180235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  180238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180252 */     GIR_RootConstrainSelectedInstOperands,
     /*  180253 */     // GIR_Coverage, 8334,
     /*  180253 */     GIR_EraseRootFromParent_Done,
     /*  180254 */   // Label 4010: @180254
     /*  180254 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(180317), // Rule ID 8335 //
     /*  180259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  180262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  180270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  180273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  180287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  180298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  180301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180315 */     GIR_RootConstrainSelectedInstOperands,
     /*  180316 */     // GIR_Coverage, 8335,
     /*  180316 */     GIR_EraseRootFromParent_Done,
     /*  180317 */   // Label 4011: @180317
     /*  180317 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(180380), // Rule ID 8338 //
     /*  180322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  180325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  180333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  180336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  180350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180361 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  180361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  180364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180378 */     GIR_RootConstrainSelectedInstOperands,
     /*  180379 */     // GIR_Coverage, 8338,
     /*  180379 */     GIR_EraseRootFromParent_Done,
     /*  180380 */   // Label 4012: @180380
     /*  180380 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(180443), // Rule ID 8339 //
     /*  180385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  180388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  180396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  180399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  180413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  180424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  180427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  180441 */     GIR_RootConstrainSelectedInstOperands,
     /*  180442 */     // GIR_Coverage, 8339,
     /*  180442 */     GIR_EraseRootFromParent_Done,
     /*  180443 */   // Label 4013: @180443
     /*  180443 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(180506), // Rule ID 8342 //
     /*  180448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  180451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  180459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  180462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  180476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  180487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  180490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180504 */     GIR_RootConstrainSelectedInstOperands,
     /*  180505 */     // GIR_Coverage, 8342,
     /*  180505 */     GIR_EraseRootFromParent_Done,
     /*  180506 */   // Label 4014: @180506
     /*  180506 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(180569), // Rule ID 8343 //
     /*  180511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  180514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  180522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  180525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  180539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  180550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  180553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180567 */     GIR_RootConstrainSelectedInstOperands,
     /*  180568 */     // GIR_Coverage, 8343,
     /*  180568 */     GIR_EraseRootFromParent_Done,
     /*  180569 */   // Label 4015: @180569
     /*  180569 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(180632), // Rule ID 8346 //
     /*  180574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  180577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  180585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  180588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  180602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180613 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  180613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  180616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180630 */     GIR_RootConstrainSelectedInstOperands,
     /*  180631 */     // GIR_Coverage, 8346,
     /*  180631 */     GIR_EraseRootFromParent_Done,
     /*  180632 */   // Label 4016: @180632
     /*  180632 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(180695), // Rule ID 8347 //
     /*  180637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  180640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  180648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  180651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  180665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180676 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  180676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  180679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180693 */     GIR_RootConstrainSelectedInstOperands,
     /*  180694 */     // GIR_Coverage, 8347,
     /*  180694 */     GIR_EraseRootFromParent_Done,
     /*  180695 */   // Label 4017: @180695
     /*  180695 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(180758), // Rule ID 8350 //
     /*  180700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  180703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  180711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  180714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  180717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  180728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  180739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  180742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180756 */     GIR_RootConstrainSelectedInstOperands,
     /*  180757 */     // GIR_Coverage, 8350,
     /*  180757 */     GIR_EraseRootFromParent_Done,
     /*  180758 */   // Label 4018: @180758
     /*  180758 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(180821), // Rule ID 8351 //
     /*  180763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  180766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  180771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  180774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  180777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  180780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  180791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  180802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  180805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  180819 */     GIR_RootConstrainSelectedInstOperands,
     /*  180820 */     // GIR_Coverage, 8351,
     /*  180820 */     GIR_EraseRootFromParent_Done,
     /*  180821 */   // Label 4019: @180821
     /*  180821 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(180884), // Rule ID 8354 //
     /*  180826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  180829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  180834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  180837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  180840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  180843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  180865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  180868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  180882 */     GIR_RootConstrainSelectedInstOperands,
     /*  180883 */     // GIR_Coverage, 8354,
     /*  180883 */     GIR_EraseRootFromParent_Done,
     /*  180884 */   // Label 4020: @180884
     /*  180884 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(180947), // Rule ID 8355 //
     /*  180889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  180892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  180897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  180900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  180903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  180906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  180909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  180928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  180931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  180937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  180942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  180945 */     GIR_RootConstrainSelectedInstOperands,
     /*  180946 */     // GIR_Coverage, 8355,
     /*  180946 */     GIR_EraseRootFromParent_Done,
     /*  180947 */   // Label 4021: @180947
     /*  180947 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(181010), // Rule ID 8358 //
     /*  180952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  180955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  180960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  180963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  180966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  180969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  180972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  180984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  180991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  180991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  180994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  180996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  180998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181008 */     GIR_RootConstrainSelectedInstOperands,
     /*  181009 */     // GIR_Coverage, 8358,
     /*  181009 */     GIR_EraseRootFromParent_Done,
     /*  181010 */   // Label 4022: @181010
     /*  181010 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(181073), // Rule ID 8359 //
     /*  181015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  181026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  181029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  181032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  181054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  181057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181071 */     GIR_RootConstrainSelectedInstOperands,
     /*  181072 */     // GIR_Coverage, 8359,
     /*  181072 */     GIR_EraseRootFromParent_Done,
     /*  181073 */   // Label 4023: @181073
     /*  181073 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(181136), // Rule ID 8362 //
     /*  181078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  181089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  181092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  181095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  181117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181134 */     GIR_RootConstrainSelectedInstOperands,
     /*  181135 */     // GIR_Coverage, 8362,
     /*  181135 */     GIR_EraseRootFromParent_Done,
     /*  181136 */   // Label 4024: @181136
     /*  181136 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(181199), // Rule ID 8363 //
     /*  181141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  181152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  181155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  181158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  181180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181197 */     GIR_RootConstrainSelectedInstOperands,
     /*  181198 */     // GIR_Coverage, 8363,
     /*  181198 */     GIR_EraseRootFromParent_Done,
     /*  181199 */   // Label 4025: @181199
     /*  181199 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(181262), // Rule ID 8366 //
     /*  181204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  181215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  181218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  181221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  181243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  181246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181260 */     GIR_RootConstrainSelectedInstOperands,
     /*  181261 */     // GIR_Coverage, 8366,
     /*  181261 */     GIR_EraseRootFromParent_Done,
     /*  181262 */   // Label 4026: @181262
     /*  181262 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(181325), // Rule ID 8367 //
     /*  181267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  181278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  181281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  181284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  181306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  181309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181323 */     GIR_RootConstrainSelectedInstOperands,
     /*  181324 */     // GIR_Coverage, 8367,
     /*  181324 */     GIR_EraseRootFromParent_Done,
     /*  181325 */   // Label 4027: @181325
     /*  181325 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(181388), // Rule ID 8370 //
     /*  181330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  181341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  181344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  181347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  181369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181386 */     GIR_RootConstrainSelectedInstOperands,
     /*  181387 */     // GIR_Coverage, 8370,
     /*  181387 */     GIR_EraseRootFromParent_Done,
     /*  181388 */   // Label 4028: @181388
     /*  181388 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(181451), // Rule ID 8371 //
     /*  181393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  181404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  181407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  181410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  181432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181449 */     GIR_RootConstrainSelectedInstOperands,
     /*  181450 */     // GIR_Coverage, 8371,
     /*  181450 */     GIR_EraseRootFromParent_Done,
     /*  181451 */   // Label 4029: @181451
     /*  181451 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(181514), // Rule ID 8374 //
     /*  181456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  181467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  181470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  181473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181495 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  181495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181512 */     GIR_RootConstrainSelectedInstOperands,
     /*  181513 */     // GIR_Coverage, 8374,
     /*  181513 */     GIR_EraseRootFromParent_Done,
     /*  181514 */   // Label 4030: @181514
     /*  181514 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(181577), // Rule ID 8375 //
     /*  181519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  181530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  181533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  181536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  181558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  181561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181575 */     GIR_RootConstrainSelectedInstOperands,
     /*  181576 */     // GIR_Coverage, 8375,
     /*  181576 */     GIR_EraseRootFromParent_Done,
     /*  181577 */   // Label 4031: @181577
     /*  181577 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(181640), // Rule ID 8378 //
     /*  181582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  181593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  181596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  181599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181621 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  181621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181638 */     GIR_RootConstrainSelectedInstOperands,
     /*  181639 */     // GIR_Coverage, 8378,
     /*  181639 */     GIR_EraseRootFromParent_Done,
     /*  181640 */   // Label 4032: @181640
     /*  181640 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(181703), // Rule ID 8379 //
     /*  181645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  181656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  181659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  181662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  181684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  181701 */     GIR_RootConstrainSelectedInstOperands,
     /*  181702 */     // GIR_Coverage, 8379,
     /*  181702 */     GIR_EraseRootFromParent_Done,
     /*  181703 */   // Label 4033: @181703
     /*  181703 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(181766), // Rule ID 8382 //
     /*  181708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  181719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  181722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  181725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181747 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  181747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181764 */     GIR_RootConstrainSelectedInstOperands,
     /*  181765 */     // GIR_Coverage, 8382,
     /*  181765 */     GIR_EraseRootFromParent_Done,
     /*  181766 */   // Label 4034: @181766
     /*  181766 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(181829), // Rule ID 8383 //
     /*  181771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  181782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  181785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  181788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  181810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181827 */     GIR_RootConstrainSelectedInstOperands,
     /*  181828 */     // GIR_Coverage, 8383,
     /*  181828 */     GIR_EraseRootFromParent_Done,
     /*  181829 */   // Label 4035: @181829
     /*  181829 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(181892), // Rule ID 8386 //
     /*  181834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  181837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  181845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  181848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  181851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181873 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  181873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181890 */     GIR_RootConstrainSelectedInstOperands,
     /*  181891 */     // GIR_Coverage, 8386,
     /*  181891 */     GIR_EraseRootFromParent_Done,
     /*  181892 */   // Label 4036: @181892
     /*  181892 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(181955), // Rule ID 8387 //
     /*  181897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  181900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  181908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  181911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  181914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  181917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  181936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  181939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  181941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  181943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  181945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  181950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181953 */     GIR_RootConstrainSelectedInstOperands,
     /*  181954 */     // GIR_Coverage, 8387,
     /*  181954 */     GIR_EraseRootFromParent_Done,
     /*  181955 */   // Label 4037: @181955
     /*  181955 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(182018), // Rule ID 8390 //
     /*  181960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  181963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  181968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  181971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  181974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  181977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  181980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  181992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  181999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  181999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  182002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  182016 */     GIR_RootConstrainSelectedInstOperands,
     /*  182017 */     // GIR_Coverage, 8390,
     /*  182017 */     GIR_EraseRootFromParent_Done,
     /*  182018 */   // Label 4038: @182018
     /*  182018 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(182081), // Rule ID 8391 //
     /*  182023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  182026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  182034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  182037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  182040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  182062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  182065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  182079 */     GIR_RootConstrainSelectedInstOperands,
     /*  182080 */     // GIR_Coverage, 8391,
     /*  182080 */     GIR_EraseRootFromParent_Done,
     /*  182081 */   // Label 4039: @182081
     /*  182081 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(182144), // Rule ID 8394 //
     /*  182086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  182097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  182100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  182103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182125 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  182125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182142 */     GIR_RootConstrainSelectedInstOperands,
     /*  182143 */     // GIR_Coverage, 8394,
     /*  182143 */     GIR_EraseRootFromParent_Done,
     /*  182144 */   // Label 4040: @182144
     /*  182144 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(182207), // Rule ID 8395 //
     /*  182149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  182160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  182163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  182166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  182188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182205 */     GIR_RootConstrainSelectedInstOperands,
     /*  182206 */     // GIR_Coverage, 8395,
     /*  182206 */     GIR_EraseRootFromParent_Done,
     /*  182207 */   // Label 4041: @182207
     /*  182207 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(182270), // Rule ID 8398 //
     /*  182212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  182223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  182226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  182229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182251 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  182251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  182254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182268 */     GIR_RootConstrainSelectedInstOperands,
     /*  182269 */     // GIR_Coverage, 8398,
     /*  182269 */     GIR_EraseRootFromParent_Done,
     /*  182270 */   // Label 4042: @182270
     /*  182270 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(182333), // Rule ID 8399 //
     /*  182275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  182286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  182289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  182292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182314 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  182314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  182317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182331 */     GIR_RootConstrainSelectedInstOperands,
     /*  182332 */     // GIR_Coverage, 8399,
     /*  182332 */     GIR_EraseRootFromParent_Done,
     /*  182333 */   // Label 4043: @182333
     /*  182333 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(182396), // Rule ID 8402 //
     /*  182338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  182349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  182352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  182355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182377 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  182377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  182380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182394 */     GIR_RootConstrainSelectedInstOperands,
     /*  182395 */     // GIR_Coverage, 8402,
     /*  182395 */     GIR_EraseRootFromParent_Done,
     /*  182396 */   // Label 4044: @182396
     /*  182396 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(182459), // Rule ID 8403 //
     /*  182401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  182412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  182415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  182418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182440 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  182440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  182443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  182457 */     GIR_RootConstrainSelectedInstOperands,
     /*  182458 */     // GIR_Coverage, 8403,
     /*  182458 */     GIR_EraseRootFromParent_Done,
     /*  182459 */   // Label 4045: @182459
     /*  182459 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(182522), // Rule ID 8406 //
     /*  182464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  182475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  182478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  182481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182503 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  182503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182520 */     GIR_RootConstrainSelectedInstOperands,
     /*  182521 */     // GIR_Coverage, 8406,
     /*  182521 */     GIR_EraseRootFromParent_Done,
     /*  182522 */   // Label 4046: @182522
     /*  182522 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(182585), // Rule ID 8407 //
     /*  182527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  182538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  182541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  182544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  182566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182583 */     GIR_RootConstrainSelectedInstOperands,
     /*  182584 */     // GIR_Coverage, 8407,
     /*  182584 */     GIR_EraseRootFromParent_Done,
     /*  182585 */   // Label 4047: @182585
     /*  182585 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(182648), // Rule ID 8410 //
     /*  182590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  182601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  182604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  182607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182629 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  182629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  182632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182646 */     GIR_RootConstrainSelectedInstOperands,
     /*  182647 */     // GIR_Coverage, 8410,
     /*  182647 */     GIR_EraseRootFromParent_Done,
     /*  182648 */   // Label 4048: @182648
     /*  182648 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(182711), // Rule ID 8411 //
     /*  182653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  182664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  182667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  182670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  182692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  182695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182709 */     GIR_RootConstrainSelectedInstOperands,
     /*  182710 */     // GIR_Coverage, 8411,
     /*  182710 */     GIR_EraseRootFromParent_Done,
     /*  182711 */   // Label 4049: @182711
     /*  182711 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(182774), // Rule ID 8414 //
     /*  182716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  182727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  182730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  182733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182755 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  182755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  182758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182772 */     GIR_RootConstrainSelectedInstOperands,
     /*  182773 */     // GIR_Coverage, 8414,
     /*  182773 */     GIR_EraseRootFromParent_Done,
     /*  182774 */   // Label 4050: @182774
     /*  182774 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(182837), // Rule ID 8415 //
     /*  182779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  182790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  182793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  182796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  182811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182818 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  182818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  182821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  182835 */     GIR_RootConstrainSelectedInstOperands,
     /*  182836 */     // GIR_Coverage, 8415,
     /*  182836 */     GIR_EraseRootFromParent_Done,
     /*  182837 */   // Label 4051: @182837
     /*  182837 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(182900), // Rule ID 8418 //
     /*  182842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  182853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  182856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  182859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182881 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  182881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  182898 */     GIR_RootConstrainSelectedInstOperands,
     /*  182899 */     // GIR_Coverage, 8418,
     /*  182899 */     GIR_EraseRootFromParent_Done,
     /*  182900 */   // Label 4052: @182900
     /*  182900 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(182963), // Rule ID 8419 //
     /*  182905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  182908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  182916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  182919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  182922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  182925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  182937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  182944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  182944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  182947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  182949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  182951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  182953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  182958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  182961 */     GIR_RootConstrainSelectedInstOperands,
     /*  182962 */     // GIR_Coverage, 8419,
     /*  182962 */     GIR_EraseRootFromParent_Done,
     /*  182963 */   // Label 4053: @182963
     /*  182963 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(183026), // Rule ID 8422 //
     /*  182968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  182971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  182976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  182979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  182982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  182985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  182988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  182992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  182996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  183007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  183010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  183024 */     GIR_RootConstrainSelectedInstOperands,
     /*  183025 */     // GIR_Coverage, 8422,
     /*  183025 */     GIR_EraseRootFromParent_Done,
     /*  183026 */   // Label 4054: @183026
     /*  183026 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(183089), // Rule ID 8423 //
     /*  183031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  183034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  183042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  183045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  183048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  183070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  183073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  183087 */     GIR_RootConstrainSelectedInstOperands,
     /*  183088 */     // GIR_Coverage, 8423,
     /*  183088 */     GIR_EraseRootFromParent_Done,
     /*  183089 */   // Label 4055: @183089
     /*  183089 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(183152), // Rule ID 8426 //
     /*  183094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  183097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  183105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  183108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  183111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183133 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  183133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  183136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  183150 */     GIR_RootConstrainSelectedInstOperands,
     /*  183151 */     // GIR_Coverage, 8426,
     /*  183151 */     GIR_EraseRootFromParent_Done,
     /*  183152 */   // Label 4056: @183152
     /*  183152 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(183215), // Rule ID 8427 //
     /*  183157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  183160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  183168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  183171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  183174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  183196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  183199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  183213 */     GIR_RootConstrainSelectedInstOperands,
     /*  183214 */     // GIR_Coverage, 8427,
     /*  183214 */     GIR_EraseRootFromParent_Done,
     /*  183215 */   // Label 4057: @183215
     /*  183215 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(183278), // Rule ID 8430 //
     /*  183220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  183223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  183231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  183234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  183237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  183248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  183252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183259 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  183259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  183262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183276 */     GIR_RootConstrainSelectedInstOperands,
     /*  183277 */     // GIR_Coverage, 8430,
     /*  183277 */     GIR_EraseRootFromParent_Done,
     /*  183278 */   // Label 4058: @183278
     /*  183278 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(183341), // Rule ID 8431 //
     /*  183283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  183286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  183294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  183297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  183300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  183311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  183315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  183322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  183325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183339 */     GIR_RootConstrainSelectedInstOperands,
     /*  183340 */     // GIR_Coverage, 8431,
     /*  183340 */     GIR_EraseRootFromParent_Done,
     /*  183341 */   // Label 4059: @183341
     /*  183341 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(183404), // Rule ID 8434 //
     /*  183346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  183349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  183357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  183360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  183363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183385 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  183385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  183388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183402 */     GIR_RootConstrainSelectedInstOperands,
     /*  183403 */     // GIR_Coverage, 8434,
     /*  183403 */     GIR_EraseRootFromParent_Done,
     /*  183404 */   // Label 4060: @183404
     /*  183404 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(183467), // Rule ID 8435 //
     /*  183409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  183412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  183420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  183423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  183426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  183441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  183448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  183451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183465 */     GIR_RootConstrainSelectedInstOperands,
     /*  183466 */     // GIR_Coverage, 8435,
     /*  183466 */     GIR_EraseRootFromParent_Done,
     /*  183467 */   // Label 4061: @183467
     /*  183467 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(183530), // Rule ID 8438 //
     /*  183472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  183475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  183483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  183486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  183489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183511 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  183511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  183514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183528 */     GIR_RootConstrainSelectedInstOperands,
     /*  183529 */     // GIR_Coverage, 8438,
     /*  183529 */     GIR_EraseRootFromParent_Done,
     /*  183530 */   // Label 4062: @183530
     /*  183530 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(183593), // Rule ID 8439 //
     /*  183535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  183538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  183546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  183549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  183552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  183567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  183574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  183577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  183591 */     GIR_RootConstrainSelectedInstOperands,
     /*  183592 */     // GIR_Coverage, 8439,
     /*  183592 */     GIR_EraseRootFromParent_Done,
     /*  183593 */   // Label 4063: @183593
     /*  183593 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(183656), // Rule ID 8442 //
     /*  183598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  183601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  183609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  183612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  183615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183637 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  183637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  183640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183654 */     GIR_RootConstrainSelectedInstOperands,
     /*  183655 */     // GIR_Coverage, 8442,
     /*  183655 */     GIR_EraseRootFromParent_Done,
     /*  183656 */   // Label 4064: @183656
     /*  183656 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(183719), // Rule ID 8443 //
     /*  183661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  183664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  183672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  183675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  183678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  183700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  183703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183717 */     GIR_RootConstrainSelectedInstOperands,
     /*  183718 */     // GIR_Coverage, 8443,
     /*  183718 */     GIR_EraseRootFromParent_Done,
     /*  183719 */   // Label 4065: @183719
     /*  183719 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(183782), // Rule ID 8446 //
     /*  183724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  183727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  183735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  183738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  183741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183763 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  183763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  183766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183780 */     GIR_RootConstrainSelectedInstOperands,
     /*  183781 */     // GIR_Coverage, 8446,
     /*  183781 */     GIR_EraseRootFromParent_Done,
     /*  183782 */   // Label 4066: @183782
     /*  183782 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(183845), // Rule ID 8447 //
     /*  183787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  183790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  183798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  183801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  183804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  183826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  183829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183843 */     GIR_RootConstrainSelectedInstOperands,
     /*  183844 */     // GIR_Coverage, 8447,
     /*  183844 */     GIR_EraseRootFromParent_Done,
     /*  183845 */   // Label 4067: @183845
     /*  183845 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(183908), // Rule ID 8450 //
     /*  183850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  183853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  183861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  183864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  183867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183889 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  183889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  183892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183906 */     GIR_RootConstrainSelectedInstOperands,
     /*  183907 */     // GIR_Coverage, 8450,
     /*  183907 */     GIR_EraseRootFromParent_Done,
     /*  183908 */   // Label 4068: @183908
     /*  183908 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(183971), // Rule ID 8451 //
     /*  183913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  183916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  183924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  183927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  183930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  183933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  183941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  183952 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  183952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  183955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  183957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  183959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  183961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  183966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  183969 */     GIR_RootConstrainSelectedInstOperands,
     /*  183970 */     // GIR_Coverage, 8451,
     /*  183970 */     GIR_EraseRootFromParent_Done,
     /*  183971 */   // Label 4069: @183971
     /*  183971 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(184034), // Rule ID 8454 //
     /*  183976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  183979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  183984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  183987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  183990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  183993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  183996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  184015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  184018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184032 */     GIR_RootConstrainSelectedInstOperands,
     /*  184033 */     // GIR_Coverage, 8454,
     /*  184033 */     GIR_EraseRootFromParent_Done,
     /*  184034 */   // Label 4070: @184034
     /*  184034 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(184097), // Rule ID 8455 //
     /*  184039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  184050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  184053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  184078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  184081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184095 */     GIR_RootConstrainSelectedInstOperands,
     /*  184096 */     // GIR_Coverage, 8455,
     /*  184096 */     GIR_EraseRootFromParent_Done,
     /*  184097 */   // Label 4071: @184097
     /*  184097 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(184160), // Rule ID 8458 //
     /*  184102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  184113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  184116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184141 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  184141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  184144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184158 */     GIR_RootConstrainSelectedInstOperands,
     /*  184159 */     // GIR_Coverage, 8458,
     /*  184159 */     GIR_EraseRootFromParent_Done,
     /*  184160 */   // Label 4072: @184160
     /*  184160 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(184223), // Rule ID 8459 //
     /*  184165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  184176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  184179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  184204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  184207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184221 */     GIR_RootConstrainSelectedInstOperands,
     /*  184222 */     // GIR_Coverage, 8459,
     /*  184222 */     GIR_EraseRootFromParent_Done,
     /*  184223 */   // Label 4073: @184223
     /*  184223 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(184286), // Rule ID 8462 //
     /*  184228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  184239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  184242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  184267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  184270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  184284 */     GIR_RootConstrainSelectedInstOperands,
     /*  184285 */     // GIR_Coverage, 8462,
     /*  184285 */     GIR_EraseRootFromParent_Done,
     /*  184286 */   // Label 4074: @184286
     /*  184286 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(184349), // Rule ID 8463 //
     /*  184291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  184302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  184305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  184330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  184333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  184347 */     GIR_RootConstrainSelectedInstOperands,
     /*  184348 */     // GIR_Coverage, 8463,
     /*  184348 */     GIR_EraseRootFromParent_Done,
     /*  184349 */   // Label 4075: @184349
     /*  184349 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(184412), // Rule ID 8466 //
     /*  184354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  184365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  184368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  184393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  184410 */     GIR_RootConstrainSelectedInstOperands,
     /*  184411 */     // GIR_Coverage, 8466,
     /*  184411 */     GIR_EraseRootFromParent_Done,
     /*  184412 */   // Label 4076: @184412
     /*  184412 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(184475), // Rule ID 8467 //
     /*  184417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  184428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  184431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  184456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  184473 */     GIR_RootConstrainSelectedInstOperands,
     /*  184474 */     // GIR_Coverage, 8467,
     /*  184474 */     GIR_EraseRootFromParent_Done,
     /*  184475 */   // Label 4077: @184475
     /*  184475 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(184538), // Rule ID 8470 //
     /*  184480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  184491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  184494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184519 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  184519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184536 */     GIR_RootConstrainSelectedInstOperands,
     /*  184537 */     // GIR_Coverage, 8470,
     /*  184537 */     GIR_EraseRootFromParent_Done,
     /*  184538 */   // Label 4078: @184538
     /*  184538 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(184601), // Rule ID 8471 //
     /*  184543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  184554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  184557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184582 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  184582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  184599 */     GIR_RootConstrainSelectedInstOperands,
     /*  184600 */     // GIR_Coverage, 8471,
     /*  184600 */     GIR_EraseRootFromParent_Done,
     /*  184601 */   // Label 4079: @184601
     /*  184601 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(184664), // Rule ID 8474 //
     /*  184606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  184617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  184620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  184645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  184662 */     GIR_RootConstrainSelectedInstOperands,
     /*  184663 */     // GIR_Coverage, 8474,
     /*  184663 */     GIR_EraseRootFromParent_Done,
     /*  184664 */   // Label 4080: @184664
     /*  184664 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(184727), // Rule ID 8475 //
     /*  184669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  184680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  184683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  184708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  184725 */     GIR_RootConstrainSelectedInstOperands,
     /*  184726 */     // GIR_Coverage, 8475,
     /*  184726 */     GIR_EraseRootFromParent_Done,
     /*  184727 */   // Label 4081: @184727
     /*  184727 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(184790), // Rule ID 8478 //
     /*  184732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  184735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  184743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  184746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  184771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  184788 */     GIR_RootConstrainSelectedInstOperands,
     /*  184789 */     // GIR_Coverage, 8478,
     /*  184789 */     GIR_EraseRootFromParent_Done,
     /*  184790 */   // Label 4082: @184790
     /*  184790 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(184853), // Rule ID 8479 //
     /*  184795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  184798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  184806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  184809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184834 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  184834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  184837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  184851 */     GIR_RootConstrainSelectedInstOperands,
     /*  184852 */     // GIR_Coverage, 8479,
     /*  184852 */     GIR_EraseRootFromParent_Done,
     /*  184853 */   // Label 4083: @184853
     /*  184853 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(184916), // Rule ID 8482 //
     /*  184858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  184869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  184872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  184875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  184878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  184886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184897 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  184897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  184900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  184914 */     GIR_RootConstrainSelectedInstOperands,
     /*  184915 */     // GIR_Coverage, 8482,
     /*  184915 */     GIR_EraseRootFromParent_Done,
     /*  184916 */   // Label 4084: @184916
     /*  184916 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(184979), // Rule ID 8483 //
     /*  184921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  184924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  184932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  184935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  184938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  184941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  184945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  184949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  184960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  184960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  184963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  184965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  184967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  184969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  184974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  184977 */     GIR_RootConstrainSelectedInstOperands,
     /*  184978 */     // GIR_Coverage, 8483,
     /*  184978 */     GIR_EraseRootFromParent_Done,
     /*  184979 */   // Label 4085: @184979
     /*  184979 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(185042), // Rule ID 8486 //
     /*  184984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  184987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  184992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  184995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  184998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185023 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  185023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  185040 */     GIR_RootConstrainSelectedInstOperands,
     /*  185041 */     // GIR_Coverage, 8486,
     /*  185041 */     GIR_EraseRootFromParent_Done,
     /*  185042 */   // Label 4086: @185042
     /*  185042 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(185105), // Rule ID 8487 //
     /*  185047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  185058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  185061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185086 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  185086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  185103 */     GIR_RootConstrainSelectedInstOperands,
     /*  185104 */     // GIR_Coverage, 8487,
     /*  185104 */     GIR_EraseRootFromParent_Done,
     /*  185105 */   // Label 4087: @185105
     /*  185105 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(185168), // Rule ID 8490 //
     /*  185110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  185121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  185124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185149 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  185149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  185166 */     GIR_RootConstrainSelectedInstOperands,
     /*  185167 */     // GIR_Coverage, 8490,
     /*  185167 */     GIR_EraseRootFromParent_Done,
     /*  185168 */   // Label 4088: @185168
     /*  185168 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(185231), // Rule ID 8491 //
     /*  185173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  185184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  185187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185212 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  185212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  185229 */     GIR_RootConstrainSelectedInstOperands,
     /*  185230 */     // GIR_Coverage, 8491,
     /*  185230 */     GIR_EraseRootFromParent_Done,
     /*  185231 */   // Label 4089: @185231
     /*  185231 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(185294), // Rule ID 8494 //
     /*  185236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  185247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  185250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  185264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  185275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  185278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185292 */     GIR_RootConstrainSelectedInstOperands,
     /*  185293 */     // GIR_Coverage, 8494,
     /*  185293 */     GIR_EraseRootFromParent_Done,
     /*  185294 */   // Label 4090: @185294
     /*  185294 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(185357), // Rule ID 8495 //
     /*  185299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  185310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  185313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  185327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  185338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  185341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185355 */     GIR_RootConstrainSelectedInstOperands,
     /*  185356 */     // GIR_Coverage, 8495,
     /*  185356 */     GIR_EraseRootFromParent_Done,
     /*  185357 */   // Label 4091: @185357
     /*  185357 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(185420), // Rule ID 8498 //
     /*  185362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  185373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  185376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185401 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  185401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185418 */     GIR_RootConstrainSelectedInstOperands,
     /*  185419 */     // GIR_Coverage, 8498,
     /*  185419 */     GIR_EraseRootFromParent_Done,
     /*  185420 */   // Label 4092: @185420
     /*  185420 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(185483), // Rule ID 8499 //
     /*  185425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  185436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  185439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  185464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185481 */     GIR_RootConstrainSelectedInstOperands,
     /*  185482 */     // GIR_Coverage, 8499,
     /*  185482 */     GIR_EraseRootFromParent_Done,
     /*  185483 */   // Label 4093: @185483
     /*  185483 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(185546), // Rule ID 8502 //
     /*  185488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  185499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  185502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185527 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  185527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185544 */     GIR_RootConstrainSelectedInstOperands,
     /*  185545 */     // GIR_Coverage, 8502,
     /*  185545 */     GIR_EraseRootFromParent_Done,
     /*  185546 */   // Label 4094: @185546
     /*  185546 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(185609), // Rule ID 8503 //
     /*  185551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  185562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  185565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185590 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  185590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  185607 */     GIR_RootConstrainSelectedInstOperands,
     /*  185608 */     // GIR_Coverage, 8503,
     /*  185608 */     GIR_EraseRootFromParent_Done,
     /*  185609 */   // Label 4095: @185609
     /*  185609 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(185672), // Rule ID 8506 //
     /*  185614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  185625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  185628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  185642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185653 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  185653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  185656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185670 */     GIR_RootConstrainSelectedInstOperands,
     /*  185671 */     // GIR_Coverage, 8506,
     /*  185671 */     GIR_EraseRootFromParent_Done,
     /*  185672 */   // Label 4096: @185672
     /*  185672 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(185735), // Rule ID 8507 //
     /*  185677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  185688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  185691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  185705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  185716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  185719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185733 */     GIR_RootConstrainSelectedInstOperands,
     /*  185734 */     // GIR_Coverage, 8507,
     /*  185734 */     GIR_EraseRootFromParent_Done,
     /*  185735 */   // Label 4097: @185735
     /*  185735 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(185798), // Rule ID 8510 //
     /*  185740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  185751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  185754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  185779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185796 */     GIR_RootConstrainSelectedInstOperands,
     /*  185797 */     // GIR_Coverage, 8510,
     /*  185797 */     GIR_EraseRootFromParent_Done,
     /*  185798 */   // Label 4098: @185798
     /*  185798 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(185861), // Rule ID 8511 //
     /*  185803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  185814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  185817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  185831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185842 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  185842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  185845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185859 */     GIR_RootConstrainSelectedInstOperands,
     /*  185860 */     // GIR_Coverage, 8511,
     /*  185860 */     GIR_EraseRootFromParent_Done,
     /*  185861 */   // Label 4099: @185861
     /*  185861 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(185924), // Rule ID 8514 //
     /*  185866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  185869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  185877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  185880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  185883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  185886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  185905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185922 */     GIR_RootConstrainSelectedInstOperands,
     /*  185923 */     // GIR_Coverage, 8514,
     /*  185923 */     GIR_EraseRootFromParent_Done,
     /*  185924 */   // Label 4100: @185924
     /*  185924 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(185987), // Rule ID 8515 //
     /*  185929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  185932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  185937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  185940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  185943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  185946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  185949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  185953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  185957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  185968 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  185968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  185971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  185973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  185975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  185977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  185982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  185985 */     GIR_RootConstrainSelectedInstOperands,
     /*  185986 */     // GIR_Coverage, 8515,
     /*  185986 */     GIR_EraseRootFromParent_Done,
     /*  185987 */   // Label 4101: @185987
     /*  185987 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(186050), // Rule ID 8518 //
     /*  185992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  185995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  186006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  186009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  186020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186031 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  186031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  186034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186048 */     GIR_RootConstrainSelectedInstOperands,
     /*  186049 */     // GIR_Coverage, 8518,
     /*  186049 */     GIR_EraseRootFromParent_Done,
     /*  186050 */   // Label 4102: @186050
     /*  186050 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(186113), // Rule ID 8519 //
     /*  186055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  186058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  186069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  186072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  186083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  186094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  186097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186111 */     GIR_RootConstrainSelectedInstOperands,
     /*  186112 */     // GIR_Coverage, 8519,
     /*  186112 */     GIR_EraseRootFromParent_Done,
     /*  186113 */   // Label 4103: @186113
     /*  186113 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(186176), // Rule ID 8522 //
     /*  186118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  186121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  186129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  186132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  186135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  186146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186157 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  186157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  186160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186174 */     GIR_RootConstrainSelectedInstOperands,
     /*  186175 */     // GIR_Coverage, 8522,
     /*  186175 */     GIR_EraseRootFromParent_Done,
     /*  186176 */   // Label 4104: @186176
     /*  186176 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(186239), // Rule ID 8523 //
     /*  186181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  186184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  186192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  186195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  186198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  186209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  186220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  186223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186237 */     GIR_RootConstrainSelectedInstOperands,
     /*  186238 */     // GIR_Coverage, 8523,
     /*  186238 */     GIR_EraseRootFromParent_Done,
     /*  186239 */   // Label 4105: @186239
     /*  186239 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(186302), // Rule ID 8526 //
     /*  186244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  186247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  186255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  186258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  186261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  186272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186283 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  186283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  186286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186300 */     GIR_RootConstrainSelectedInstOperands,
     /*  186301 */     // GIR_Coverage, 8526,
     /*  186301 */     GIR_EraseRootFromParent_Done,
     /*  186302 */   // Label 4106: @186302
     /*  186302 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(186365), // Rule ID 8527 //
     /*  186307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  186310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  186315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  186318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  186321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  186324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  186335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  186346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  186349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  186363 */     GIR_RootConstrainSelectedInstOperands,
     /*  186364 */     // GIR_Coverage, 8527,
     /*  186364 */     GIR_EraseRootFromParent_Done,
     /*  186365 */   // Label 4107: @186365
     /*  186365 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(186428), // Rule ID 8530 //
     /*  186370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  186373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  186381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  186384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  186387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186409 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  186409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  186412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186426 */     GIR_RootConstrainSelectedInstOperands,
     /*  186427 */     // GIR_Coverage, 8530,
     /*  186427 */     GIR_EraseRootFromParent_Done,
     /*  186428 */   // Label 4108: @186428
     /*  186428 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(186491), // Rule ID 8531 //
     /*  186433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  186436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  186444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  186447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  186450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  186472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  186475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186489 */     GIR_RootConstrainSelectedInstOperands,
     /*  186490 */     // GIR_Coverage, 8531,
     /*  186490 */     GIR_EraseRootFromParent_Done,
     /*  186491 */   // Label 4109: @186491
     /*  186491 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(186554), // Rule ID 8534 //
     /*  186496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  186499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  186510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  186513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186535 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  186535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  186538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186552 */     GIR_RootConstrainSelectedInstOperands,
     /*  186553 */     // GIR_Coverage, 8534,
     /*  186553 */     GIR_EraseRootFromParent_Done,
     /*  186554 */   // Label 4110: @186554
     /*  186554 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(186617), // Rule ID 8535 //
     /*  186559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  186562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  186573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  186576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186598 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  186598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  186601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186615 */     GIR_RootConstrainSelectedInstOperands,
     /*  186616 */     // GIR_Coverage, 8535,
     /*  186616 */     GIR_EraseRootFromParent_Done,
     /*  186617 */   // Label 4111: @186617
     /*  186617 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(186680), // Rule ID 8538 //
     /*  186622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  186625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  186633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  186636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  186639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186661 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  186661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  186664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186678 */     GIR_RootConstrainSelectedInstOperands,
     /*  186679 */     // GIR_Coverage, 8538,
     /*  186679 */     GIR_EraseRootFromParent_Done,
     /*  186680 */   // Label 4112: @186680
     /*  186680 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(186743), // Rule ID 8539 //
     /*  186685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  186688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  186696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  186699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  186702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  186724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  186727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  186741 */     GIR_RootConstrainSelectedInstOperands,
     /*  186742 */     // GIR_Coverage, 8539,
     /*  186742 */     GIR_EraseRootFromParent_Done,
     /*  186743 */   // Label 4113: @186743
     /*  186743 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(186806), // Rule ID 8542 //
     /*  186748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  186751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  186759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  186762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  186765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  186787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  186790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  186804 */     GIR_RootConstrainSelectedInstOperands,
     /*  186805 */     // GIR_Coverage, 8542,
     /*  186805 */     GIR_EraseRootFromParent_Done,
     /*  186806 */   // Label 4114: @186806
     /*  186806 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(186869), // Rule ID 8543 //
     /*  186811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  186814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  186822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  186825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  186828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  186850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  186853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  186867 */     GIR_RootConstrainSelectedInstOperands,
     /*  186868 */     // GIR_Coverage, 8543,
     /*  186868 */     GIR_EraseRootFromParent_Done,
     /*  186869 */   // Label 4115: @186869
     /*  186869 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(186932), // Rule ID 8546 //
     /*  186874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  186877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  186888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  186891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  186894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  186913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  186916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  186930 */     GIR_RootConstrainSelectedInstOperands,
     /*  186931 */     // GIR_Coverage, 8546,
     /*  186931 */     GIR_EraseRootFromParent_Done,
     /*  186932 */   // Label 4116: @186932
     /*  186932 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(186995), // Rule ID 8547 //
     /*  186937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  186940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  186945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  186948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  186951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  186954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  186957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  186969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  186976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  186976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  186979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  186981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  186983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  186985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  186990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  186993 */     GIR_RootConstrainSelectedInstOperands,
     /*  186994 */     // GIR_Coverage, 8547,
     /*  186994 */     GIR_EraseRootFromParent_Done,
     /*  186995 */   // Label 4117: @186995
     /*  186995 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(187058), // Rule ID 8550 //
     /*  187000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  187011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  187014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  187017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187039 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  187039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  187042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  187056 */     GIR_RootConstrainSelectedInstOperands,
     /*  187057 */     // GIR_Coverage, 8550,
     /*  187057 */     GIR_EraseRootFromParent_Done,
     /*  187058 */   // Label 4118: @187058
     /*  187058 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(187121), // Rule ID 8551 //
     /*  187063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  187074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  187077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  187080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  187102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  187105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  187119 */     GIR_RootConstrainSelectedInstOperands,
     /*  187120 */     // GIR_Coverage, 8551,
     /*  187120 */     GIR_EraseRootFromParent_Done,
     /*  187121 */   // Label 4119: @187121
     /*  187121 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(187184), // Rule ID 8554 //
     /*  187126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  187137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  187140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  187143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187165 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  187165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187182 */     GIR_RootConstrainSelectedInstOperands,
     /*  187183 */     // GIR_Coverage, 8554,
     /*  187183 */     GIR_EraseRootFromParent_Done,
     /*  187184 */   // Label 4120: @187184
     /*  187184 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(187247), // Rule ID 8555 //
     /*  187189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  187200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  187203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  187206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187228 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  187228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187245 */     GIR_RootConstrainSelectedInstOperands,
     /*  187246 */     // GIR_Coverage, 8555,
     /*  187246 */     GIR_EraseRootFromParent_Done,
     /*  187247 */   // Label 4121: @187247
     /*  187247 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(187310), // Rule ID 8558 //
     /*  187252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  187263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  187266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  187269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  187291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  187308 */     GIR_RootConstrainSelectedInstOperands,
     /*  187309 */     // GIR_Coverage, 8558,
     /*  187309 */     GIR_EraseRootFromParent_Done,
     /*  187310 */   // Label 4122: @187310
     /*  187310 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(187373), // Rule ID 8559 //
     /*  187315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  187326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  187329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  187332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  187354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  187371 */     GIR_RootConstrainSelectedInstOperands,
     /*  187372 */     // GIR_Coverage, 8559,
     /*  187372 */     GIR_EraseRootFromParent_Done,
     /*  187373 */   // Label 4123: @187373
     /*  187373 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(187436), // Rule ID 8562 //
     /*  187378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  187389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  187392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  187395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  187417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  187434 */     GIR_RootConstrainSelectedInstOperands,
     /*  187435 */     // GIR_Coverage, 8562,
     /*  187435 */     GIR_EraseRootFromParent_Done,
     /*  187436 */   // Label 4124: @187436
     /*  187436 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(187499), // Rule ID 8563 //
     /*  187441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  187452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  187455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  187458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  187480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  187497 */     GIR_RootConstrainSelectedInstOperands,
     /*  187498 */     // GIR_Coverage, 8563,
     /*  187498 */     GIR_EraseRootFromParent_Done,
     /*  187499 */   // Label 4125: @187499
     /*  187499 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(187562), // Rule ID 8566 //
     /*  187504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  187507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  187515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  187518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  187521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  187543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  187560 */     GIR_RootConstrainSelectedInstOperands,
     /*  187561 */     // GIR_Coverage, 8566,
     /*  187561 */     GIR_EraseRootFromParent_Done,
     /*  187562 */   // Label 4126: @187562
     /*  187562 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(187625), // Rule ID 8567 //
     /*  187567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  187570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  187578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  187581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  187584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187606 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  187606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  187609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  187623 */     GIR_RootConstrainSelectedInstOperands,
     /*  187624 */     // GIR_Coverage, 8567,
     /*  187624 */     GIR_EraseRootFromParent_Done,
     /*  187625 */   // Label 4127: @187625
     /*  187625 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(187688), // Rule ID 8570 //
     /*  187630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  187641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  187644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  187647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  187658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  187662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187669 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  187669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  187672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187686 */     GIR_RootConstrainSelectedInstOperands,
     /*  187687 */     // GIR_Coverage, 8570,
     /*  187687 */     GIR_EraseRootFromParent_Done,
     /*  187688 */   // Label 4128: @187688
     /*  187688 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(187751), // Rule ID 8571 //
     /*  187693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  187704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  187707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  187710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  187721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  187725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  187732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  187735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187749 */     GIR_RootConstrainSelectedInstOperands,
     /*  187750 */     // GIR_Coverage, 8571,
     /*  187750 */     GIR_EraseRootFromParent_Done,
     /*  187751 */   // Label 4129: @187751
     /*  187751 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(187814), // Rule ID 8574 //
     /*  187756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  187767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  187770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  187773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  187784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  187788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187795 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  187795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  187798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187812 */     GIR_RootConstrainSelectedInstOperands,
     /*  187813 */     // GIR_Coverage, 8574,
     /*  187813 */     GIR_EraseRootFromParent_Done,
     /*  187814 */   // Label 4130: @187814
     /*  187814 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(187877), // Rule ID 8575 //
     /*  187819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  187830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  187833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  187836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  187847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  187851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187858 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  187858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  187861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187875 */     GIR_RootConstrainSelectedInstOperands,
     /*  187876 */     // GIR_Coverage, 8575,
     /*  187876 */     GIR_EraseRootFromParent_Done,
     /*  187877 */   // Label 4131: @187877
     /*  187877 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(187940), // Rule ID 8578 //
     /*  187882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  187885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  187893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  187896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  187899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  187902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  187910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  187914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187921 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  187921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  187924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  187938 */     GIR_RootConstrainSelectedInstOperands,
     /*  187939 */     // GIR_Coverage, 8578,
     /*  187939 */     GIR_EraseRootFromParent_Done,
     /*  187940 */   // Label 4132: @187940
     /*  187940 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(188003), // Rule ID 8579 //
     /*  187945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  187948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  187953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  187956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  187959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  187962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  187965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  187969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  187973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  187977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  187984 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  187984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  187987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  187989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  187991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  187993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  187998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  188001 */     GIR_RootConstrainSelectedInstOperands,
     /*  188002 */     // GIR_Coverage, 8579,
     /*  188002 */     GIR_EraseRootFromParent_Done,
     /*  188003 */   // Label 4133: @188003
     /*  188003 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(188066), // Rule ID 8582 //
     /*  188008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  188019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  188022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  188025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  188047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188064 */     GIR_RootConstrainSelectedInstOperands,
     /*  188065 */     // GIR_Coverage, 8582,
     /*  188065 */     GIR_EraseRootFromParent_Done,
     /*  188066 */   // Label 4134: @188066
     /*  188066 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(188129), // Rule ID 8583 //
     /*  188071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  188082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  188085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  188088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  188110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188127 */     GIR_RootConstrainSelectedInstOperands,
     /*  188128 */     // GIR_Coverage, 8583,
     /*  188128 */     GIR_EraseRootFromParent_Done,
     /*  188129 */   // Label 4135: @188129
     /*  188129 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(188192), // Rule ID 8586 //
     /*  188134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  188145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  188148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  188151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188173 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  188173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188190 */     GIR_RootConstrainSelectedInstOperands,
     /*  188191 */     // GIR_Coverage, 8586,
     /*  188191 */     GIR_EraseRootFromParent_Done,
     /*  188192 */   // Label 4136: @188192
     /*  188192 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(188255), // Rule ID 8587 //
     /*  188197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  188208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  188211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  188214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  188236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188253 */     GIR_RootConstrainSelectedInstOperands,
     /*  188254 */     // GIR_Coverage, 8587,
     /*  188254 */     GIR_EraseRootFromParent_Done,
     /*  188255 */   // Label 4137: @188255
     /*  188255 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(188318), // Rule ID 8590 //
     /*  188260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  188271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  188274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  188277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188299 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  188299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  188302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188316 */     GIR_RootConstrainSelectedInstOperands,
     /*  188317 */     // GIR_Coverage, 8590,
     /*  188317 */     GIR_EraseRootFromParent_Done,
     /*  188318 */   // Label 4138: @188318
     /*  188318 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(188381), // Rule ID 8591 //
     /*  188323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  188334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  188337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  188340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188362 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  188362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  188365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188379 */     GIR_RootConstrainSelectedInstOperands,
     /*  188380 */     // GIR_Coverage, 8591,
     /*  188380 */     GIR_EraseRootFromParent_Done,
     /*  188381 */   // Label 4139: @188381
     /*  188381 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(188444), // Rule ID 8594 //
     /*  188386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  188397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  188400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  188403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188425 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  188425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188442 */     GIR_RootConstrainSelectedInstOperands,
     /*  188443 */     // GIR_Coverage, 8594,
     /*  188443 */     GIR_EraseRootFromParent_Done,
     /*  188444 */   // Label 4140: @188444
     /*  188444 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(188507), // Rule ID 8595 //
     /*  188449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  188460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  188463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  188466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  188488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188505 */     GIR_RootConstrainSelectedInstOperands,
     /*  188506 */     // GIR_Coverage, 8595,
     /*  188506 */     GIR_EraseRootFromParent_Done,
     /*  188507 */   // Label 4141: @188507
     /*  188507 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(188570), // Rule ID 8598 //
     /*  188512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  188523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  188526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  188529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188551 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  188551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188568 */     GIR_RootConstrainSelectedInstOperands,
     /*  188569 */     // GIR_Coverage, 8598,
     /*  188569 */     GIR_EraseRootFromParent_Done,
     /*  188570 */   // Label 4142: @188570
     /*  188570 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(188633), // Rule ID 8599 //
     /*  188575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  188586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  188589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  188592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  188614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188631 */     GIR_RootConstrainSelectedInstOperands,
     /*  188632 */     // GIR_Coverage, 8599,
     /*  188632 */     GIR_EraseRootFromParent_Done,
     /*  188633 */   // Label 4143: @188633
     /*  188633 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(188696), // Rule ID 8602 //
     /*  188638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  188641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  188649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  188652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  188655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188677 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  188677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  188680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188694 */     GIR_RootConstrainSelectedInstOperands,
     /*  188695 */     // GIR_Coverage, 8602,
     /*  188695 */     GIR_EraseRootFromParent_Done,
     /*  188696 */   // Label 4144: @188696
     /*  188696 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(188759), // Rule ID 8603 //
     /*  188701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  188704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  188712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  188715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  188718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  188733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  188740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  188743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188757 */     GIR_RootConstrainSelectedInstOperands,
     /*  188758 */     // GIR_Coverage, 8603,
     /*  188758 */     GIR_EraseRootFromParent_Done,
     /*  188759 */   // Label 4145: @188759
     /*  188759 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(188822), // Rule ID 8606 //
     /*  188764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  188767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  188775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  188778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  188781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188803 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  188803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  188820 */     GIR_RootConstrainSelectedInstOperands,
     /*  188821 */     // GIR_Coverage, 8606,
     /*  188821 */     GIR_EraseRootFromParent_Done,
     /*  188822 */   // Label 4146: @188822
     /*  188822 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(188885), // Rule ID 8607 //
     /*  188827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  188830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  188838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  188841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  188844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  188859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  188866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  188869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  188883 */     GIR_RootConstrainSelectedInstOperands,
     /*  188884 */     // GIR_Coverage, 8607,
     /*  188884 */     GIR_EraseRootFromParent_Done,
     /*  188885 */   // Label 4147: @188885
     /*  188885 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(188948), // Rule ID 8610 //
     /*  188890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  188893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  188901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  188904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  188907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  188910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188929 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  188929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  188938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  188943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  188946 */     GIR_RootConstrainSelectedInstOperands,
     /*  188947 */     // GIR_Coverage, 8610,
     /*  188947 */     GIR_EraseRootFromParent_Done,
     /*  188948 */   // Label 4148: @188948
     /*  188948 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(189011), // Rule ID 8611 //
     /*  188953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  188956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  188961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  188964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  188967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  188970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  188973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  188977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  188985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  188992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  188992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  188995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  188997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  188999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189009 */     GIR_RootConstrainSelectedInstOperands,
     /*  189010 */     // GIR_Coverage, 8611,
     /*  189010 */     GIR_EraseRootFromParent_Done,
     /*  189011 */   // Label 4149: @189011
     /*  189011 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(189074), // Rule ID 8614 //
     /*  189016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  189019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  189027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  189030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  189033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  189044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  189048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189055 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  189055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  189058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189072 */     GIR_RootConstrainSelectedInstOperands,
     /*  189073 */     // GIR_Coverage, 8614,
     /*  189073 */     GIR_EraseRootFromParent_Done,
     /*  189074 */   // Label 4150: @189074
     /*  189074 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(189137), // Rule ID 8615 //
     /*  189079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  189082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  189090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  189093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  189096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  189107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  189111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  189118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  189121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189135 */     GIR_RootConstrainSelectedInstOperands,
     /*  189136 */     // GIR_Coverage, 8615,
     /*  189136 */     GIR_EraseRootFromParent_Done,
     /*  189137 */   // Label 4151: @189137
     /*  189137 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(189200), // Rule ID 8618 //
     /*  189142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  189156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189181 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  189181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  189184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189198 */     GIR_RootConstrainSelectedInstOperands,
     /*  189199 */     // GIR_Coverage, 8618,
     /*  189199 */     GIR_EraseRootFromParent_Done,
     /*  189200 */   // Label 4152: @189200
     /*  189200 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(189263), // Rule ID 8619 //
     /*  189205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  189219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189244 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  189244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  189247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189261 */     GIR_RootConstrainSelectedInstOperands,
     /*  189262 */     // GIR_Coverage, 8619,
     /*  189262 */     GIR_EraseRootFromParent_Done,
     /*  189263 */   // Label 4153: @189263
     /*  189263 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(189326), // Rule ID 8622 //
     /*  189268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  189279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  189282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  189307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  189310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189324 */     GIR_RootConstrainSelectedInstOperands,
     /*  189325 */     // GIR_Coverage, 8622,
     /*  189325 */     GIR_EraseRootFromParent_Done,
     /*  189326 */   // Label 4154: @189326
     /*  189326 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(189389), // Rule ID 8623 //
     /*  189331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  189342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  189345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  189370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  189373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189387 */     GIR_RootConstrainSelectedInstOperands,
     /*  189388 */     // GIR_Coverage, 8623,
     /*  189388 */     GIR_EraseRootFromParent_Done,
     /*  189389 */   // Label 4155: @189389
     /*  189389 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(189452), // Rule ID 8626 //
     /*  189394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  189405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  189408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  189433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189450 */     GIR_RootConstrainSelectedInstOperands,
     /*  189451 */     // GIR_Coverage, 8626,
     /*  189451 */     GIR_EraseRootFromParent_Done,
     /*  189452 */   // Label 4156: @189452
     /*  189452 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(189515), // Rule ID 8627 //
     /*  189457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  189468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  189471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  189496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189513 */     GIR_RootConstrainSelectedInstOperands,
     /*  189514 */     // GIR_Coverage, 8627,
     /*  189514 */     GIR_EraseRootFromParent_Done,
     /*  189515 */   // Label 4157: @189515
     /*  189515 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(189578), // Rule ID 8630 //
     /*  189520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  189534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  189559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  189562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189576 */     GIR_RootConstrainSelectedInstOperands,
     /*  189577 */     // GIR_Coverage, 8630,
     /*  189577 */     GIR_EraseRootFromParent_Done,
     /*  189578 */   // Label 4158: @189578
     /*  189578 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(189641), // Rule ID 8631 //
     /*  189583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  189597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  189622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  189625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189639 */     GIR_RootConstrainSelectedInstOperands,
     /*  189640 */     // GIR_Coverage, 8631,
     /*  189640 */     GIR_EraseRootFromParent_Done,
     /*  189641 */   // Label 4159: @189641
     /*  189641 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(189704), // Rule ID 8634 //
     /*  189646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  189657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  189660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  189685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189702 */     GIR_RootConstrainSelectedInstOperands,
     /*  189703 */     // GIR_Coverage, 8634,
     /*  189703 */     GIR_EraseRootFromParent_Done,
     /*  189704 */   // Label 4160: @189704
     /*  189704 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(189767), // Rule ID 8635 //
     /*  189709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  189720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  189723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  189748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189765 */     GIR_RootConstrainSelectedInstOperands,
     /*  189766 */     // GIR_Coverage, 8635,
     /*  189766 */     GIR_EraseRootFromParent_Done,
     /*  189767 */   // Label 4161: @189767
     /*  189767 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(189830), // Rule ID 8638 //
     /*  189772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  189786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  189811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189828 */     GIR_RootConstrainSelectedInstOperands,
     /*  189829 */     // GIR_Coverage, 8638,
     /*  189829 */     GIR_EraseRootFromParent_Done,
     /*  189830 */   // Label 4162: @189830
     /*  189830 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(189893), // Rule ID 8639 //
     /*  189835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  189846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  189849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  189874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  189877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189891 */     GIR_RootConstrainSelectedInstOperands,
     /*  189892 */     // GIR_Coverage, 8639,
     /*  189892 */     GIR_EraseRootFromParent_Done,
     /*  189893 */   // Label 4163: @189893
     /*  189893 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(189956), // Rule ID 8642 //
     /*  189898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  189901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  189909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  189912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  189915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  189918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  189937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  189937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  189940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  189942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  189944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  189946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  189951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  189954 */     GIR_RootConstrainSelectedInstOperands,
     /*  189955 */     // GIR_Coverage, 8642,
     /*  189955 */     GIR_EraseRootFromParent_Done,
     /*  189956 */   // Label 4164: @189956
     /*  189956 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(190019), // Rule ID 8643 //
     /*  189961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  189964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  189969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  189972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  189975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  189978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  189981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  189989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  190000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190017 */     GIR_RootConstrainSelectedInstOperands,
     /*  190018 */     // GIR_Coverage, 8643,
     /*  190018 */     GIR_EraseRootFromParent_Done,
     /*  190019 */   // Label 4165: @190019
     /*  190019 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(190082), // Rule ID 8646 //
     /*  190024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  190035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  190038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190063 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  190063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190080 */     GIR_RootConstrainSelectedInstOperands,
     /*  190081 */     // GIR_Coverage, 8646,
     /*  190081 */     GIR_EraseRootFromParent_Done,
     /*  190082 */   // Label 4166: @190082
     /*  190082 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(190145), // Rule ID 8647 //
     /*  190087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  190098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  190101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  190126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190143 */     GIR_RootConstrainSelectedInstOperands,
     /*  190144 */     // GIR_Coverage, 8647,
     /*  190144 */     GIR_EraseRootFromParent_Done,
     /*  190145 */   // Label 4167: @190145
     /*  190145 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(190208), // Rule ID 8650 //
     /*  190150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  190161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  190164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  190189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190206 */     GIR_RootConstrainSelectedInstOperands,
     /*  190207 */     // GIR_Coverage, 8650,
     /*  190207 */     GIR_EraseRootFromParent_Done,
     /*  190208 */   // Label 4168: @190208
     /*  190208 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(190271), // Rule ID 8651 //
     /*  190213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  190224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  190227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  190252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190269 */     GIR_RootConstrainSelectedInstOperands,
     /*  190270 */     // GIR_Coverage, 8651,
     /*  190270 */     GIR_EraseRootFromParent_Done,
     /*  190271 */   // Label 4169: @190271
     /*  190271 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(190334), // Rule ID 8654 //
     /*  190276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  190279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  190287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  190290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  190315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190332 */     GIR_RootConstrainSelectedInstOperands,
     /*  190333 */     // GIR_Coverage, 8654,
     /*  190333 */     GIR_EraseRootFromParent_Done,
     /*  190334 */   // Label 4170: @190334
     /*  190334 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(190397), // Rule ID 8655 //
     /*  190339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  190342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  190350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  190353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  190378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  190381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190395 */     GIR_RootConstrainSelectedInstOperands,
     /*  190396 */     // GIR_Coverage, 8655,
     /*  190396 */     GIR_EraseRootFromParent_Done,
     /*  190397 */   // Label 4171: @190397
     /*  190397 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(190460), // Rule ID 8658 //
     /*  190402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  190413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  190416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  190430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  190441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  190444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190458 */     GIR_RootConstrainSelectedInstOperands,
     /*  190459 */     // GIR_Coverage, 8658,
     /*  190459 */     GIR_EraseRootFromParent_Done,
     /*  190460 */   // Label 4172: @190460
     /*  190460 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(190523), // Rule ID 8659 //
     /*  190465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  190476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  190479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  190493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  190504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  190507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190521 */     GIR_RootConstrainSelectedInstOperands,
     /*  190522 */     // GIR_Coverage, 8659,
     /*  190522 */     GIR_EraseRootFromParent_Done,
     /*  190523 */   // Label 4173: @190523
     /*  190523 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(190586), // Rule ID 8662 //
     /*  190528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  190539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  190542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  190556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190567 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  190567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  190570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190584 */     GIR_RootConstrainSelectedInstOperands,
     /*  190585 */     // GIR_Coverage, 8662,
     /*  190585 */     GIR_EraseRootFromParent_Done,
     /*  190586 */   // Label 4174: @190586
     /*  190586 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(190649), // Rule ID 8663 //
     /*  190591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  190602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  190605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  190619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190630 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  190630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  190633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190647 */     GIR_RootConstrainSelectedInstOperands,
     /*  190648 */     // GIR_Coverage, 8663,
     /*  190648 */     GIR_EraseRootFromParent_Done,
     /*  190649 */   // Label 4175: @190649
     /*  190649 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(190712), // Rule ID 8666 //
     /*  190654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  190665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  190668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  190682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190693 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  190693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  190696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190710 */     GIR_RootConstrainSelectedInstOperands,
     /*  190711 */     // GIR_Coverage, 8666,
     /*  190711 */     GIR_EraseRootFromParent_Done,
     /*  190712 */   // Label 4176: @190712
     /*  190712 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(190775), // Rule ID 8667 //
     /*  190717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  190728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  190731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  190745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190756 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  190756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  190759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  190773 */     GIR_RootConstrainSelectedInstOperands,
     /*  190774 */     // GIR_Coverage, 8667,
     /*  190774 */     GIR_EraseRootFromParent_Done,
     /*  190775 */   // Label 4177: @190775
     /*  190775 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(190838), // Rule ID 8670 //
     /*  190780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  190791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  190794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  190808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  190819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  190822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190836 */     GIR_RootConstrainSelectedInstOperands,
     /*  190837 */     // GIR_Coverage, 8670,
     /*  190837 */     GIR_EraseRootFromParent_Done,
     /*  190838 */   // Label 4178: @190838
     /*  190838 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(190901), // Rule ID 8671 //
     /*  190843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  190854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  190857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  190871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  190882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  190885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190899 */     GIR_RootConstrainSelectedInstOperands,
     /*  190900 */     // GIR_Coverage, 8671,
     /*  190900 */     GIR_EraseRootFromParent_Done,
     /*  190901 */   // Label 4179: @190901
     /*  190901 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(190964), // Rule ID 8674 //
     /*  190906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  190909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  190917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  190920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  190923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  190926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  190934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  190945 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  190945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  190948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  190950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  190952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  190954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  190959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190962 */     GIR_RootConstrainSelectedInstOperands,
     /*  190963 */     // GIR_Coverage, 8674,
     /*  190963 */     GIR_EraseRootFromParent_Done,
     /*  190964 */   // Label 4180: @190964
     /*  190964 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(191027), // Rule ID 8675 //
     /*  190969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  190972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  190977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  190980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  190983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  190986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  190989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  190993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  190997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  191008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  191011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  191025 */     GIR_RootConstrainSelectedInstOperands,
     /*  191026 */     // GIR_Coverage, 8675,
     /*  191026 */     GIR_EraseRootFromParent_Done,
     /*  191027 */   // Label 4181: @191027
     /*  191027 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(191090), // Rule ID 8678 //
     /*  191032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  191035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  191043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  191046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191071 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  191071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  191088 */     GIR_RootConstrainSelectedInstOperands,
     /*  191089 */     // GIR_Coverage, 8678,
     /*  191089 */     GIR_EraseRootFromParent_Done,
     /*  191090 */   // Label 4182: @191090
     /*  191090 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(191153), // Rule ID 8679 //
     /*  191095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  191098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  191106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  191109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191134 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  191134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  191151 */     GIR_RootConstrainSelectedInstOperands,
     /*  191152 */     // GIR_Coverage, 8679,
     /*  191152 */     GIR_EraseRootFromParent_Done,
     /*  191153 */   // Label 4183: @191153
     /*  191153 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(191216), // Rule ID 8682 //
     /*  191158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  191161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  191169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  191172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  191186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191197 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  191197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  191200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191214 */     GIR_RootConstrainSelectedInstOperands,
     /*  191215 */     // GIR_Coverage, 8682,
     /*  191215 */     GIR_EraseRootFromParent_Done,
     /*  191216 */   // Label 4184: @191216
     /*  191216 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(191279), // Rule ID 8683 //
     /*  191221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  191224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  191232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  191235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  191249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  191260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  191263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191277 */     GIR_RootConstrainSelectedInstOperands,
     /*  191278 */     // GIR_Coverage, 8683,
     /*  191278 */     GIR_EraseRootFromParent_Done,
     /*  191279 */   // Label 4185: @191279
     /*  191279 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(191342), // Rule ID 8686 //
     /*  191284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  191287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  191295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  191298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  191312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  191323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  191326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191340 */     GIR_RootConstrainSelectedInstOperands,
     /*  191341 */     // GIR_Coverage, 8686,
     /*  191341 */     GIR_EraseRootFromParent_Done,
     /*  191342 */   // Label 4186: @191342
     /*  191342 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(191405), // Rule ID 8687 //
     /*  191347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  191350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  191358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  191361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  191375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  191386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  191389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191403 */     GIR_RootConstrainSelectedInstOperands,
     /*  191404 */     // GIR_Coverage, 8687,
     /*  191404 */     GIR_EraseRootFromParent_Done,
     /*  191405 */   // Label 4187: @191405
     /*  191405 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(191468), // Rule ID 8690 //
     /*  191410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  191413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  191421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  191424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  191449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191466 */     GIR_RootConstrainSelectedInstOperands,
     /*  191467 */     // GIR_Coverage, 8690,
     /*  191467 */     GIR_EraseRootFromParent_Done,
     /*  191468 */   // Label 4188: @191468
     /*  191468 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(191531), // Rule ID 8691 //
     /*  191473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  191476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  191484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  191487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191512 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  191512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  191529 */     GIR_RootConstrainSelectedInstOperands,
     /*  191530 */     // GIR_Coverage, 8691,
     /*  191530 */     GIR_EraseRootFromParent_Done,
     /*  191531 */   // Label 4189: @191531
     /*  191531 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(191594), // Rule ID 8694 //
     /*  191536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  191539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  191547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  191550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  191564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  191575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  191578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191592 */     GIR_RootConstrainSelectedInstOperands,
     /*  191593 */     // GIR_Coverage, 8694,
     /*  191593 */     GIR_EraseRootFromParent_Done,
     /*  191594 */   // Label 4190: @191594
     /*  191594 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(191657), // Rule ID 8695 //
     /*  191599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  191602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  191610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  191613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  191627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  191638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  191641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191655 */     GIR_RootConstrainSelectedInstOperands,
     /*  191656 */     // GIR_Coverage, 8695,
     /*  191656 */     GIR_EraseRootFromParent_Done,
     /*  191657 */   // Label 4191: @191657
     /*  191657 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(191720), // Rule ID 8698 //
     /*  191662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  191665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  191673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  191676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  191690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191701 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  191701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  191704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191718 */     GIR_RootConstrainSelectedInstOperands,
     /*  191719 */     // GIR_Coverage, 8698,
     /*  191719 */     GIR_EraseRootFromParent_Done,
     /*  191720 */   // Label 4192: @191720
     /*  191720 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(191783), // Rule ID 8699 //
     /*  191725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  191728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  191736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  191739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  191753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  191764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  191767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191781 */     GIR_RootConstrainSelectedInstOperands,
     /*  191782 */     // GIR_Coverage, 8699,
     /*  191782 */     GIR_EraseRootFromParent_Done,
     /*  191783 */   // Label 4193: @191783
     /*  191783 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(191846), // Rule ID 8702 //
     /*  191788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  191791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  191799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  191802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  191805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  191827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191844 */     GIR_RootConstrainSelectedInstOperands,
     /*  191845 */     // GIR_Coverage, 8702,
     /*  191845 */     GIR_EraseRootFromParent_Done,
     /*  191846 */   // Label 4194: @191846
     /*  191846 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(191909), // Rule ID 8703 //
     /*  191851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  191854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  191859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  191862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  191865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  191868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  191879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  191890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  191893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  191907 */     GIR_RootConstrainSelectedInstOperands,
     /*  191908 */     // GIR_Coverage, 8703,
     /*  191908 */     GIR_EraseRootFromParent_Done,
     /*  191909 */   // Label 4195: @191909
     /*  191909 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(191972), // Rule ID 8794 //
     /*  191914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  191917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  191922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  191925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  191928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  191931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  191934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  191946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  191953 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  191953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  191956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  191958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  191960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  191962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  191967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  191970 */     GIR_RootConstrainSelectedInstOperands,
     /*  191971 */     // GIR_Coverage, 8794,
     /*  191971 */     GIR_EraseRootFromParent_Done,
     /*  191972 */   // Label 4196: @191972
     /*  191972 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(192035), // Rule ID 8795 //
     /*  191977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  191980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  191985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  191988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  191991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  191994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  191997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  192016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  192019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192033 */     GIR_RootConstrainSelectedInstOperands,
     /*  192034 */     // GIR_Coverage, 8795,
     /*  192034 */     GIR_EraseRootFromParent_Done,
     /*  192035 */   // Label 4197: @192035
     /*  192035 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(192098), // Rule ID 8798 //
     /*  192040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  192054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  192057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192079 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  192079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  192082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192096 */     GIR_RootConstrainSelectedInstOperands,
     /*  192097 */     // GIR_Coverage, 8798,
     /*  192097 */     GIR_EraseRootFromParent_Done,
     /*  192098 */   // Label 4198: @192098
     /*  192098 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(192161), // Rule ID 8799 //
     /*  192103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  192117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  192120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  192142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  192145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192159 */     GIR_RootConstrainSelectedInstOperands,
     /*  192160 */     // GIR_Coverage, 8799,
     /*  192160 */     GIR_EraseRootFromParent_Done,
     /*  192161 */   // Label 4199: @192161
     /*  192161 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(192224), // Rule ID 8802 //
     /*  192166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  192177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  192180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  192183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  192205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192222 */     GIR_RootConstrainSelectedInstOperands,
     /*  192223 */     // GIR_Coverage, 8802,
     /*  192223 */     GIR_EraseRootFromParent_Done,
     /*  192224 */   // Label 4200: @192224
     /*  192224 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(192287), // Rule ID 8803 //
     /*  192229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  192240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  192243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  192246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  192268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192285 */     GIR_RootConstrainSelectedInstOperands,
     /*  192286 */     // GIR_Coverage, 8803,
     /*  192286 */     GIR_EraseRootFromParent_Done,
     /*  192287 */   // Label 4201: @192287
     /*  192287 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(192350), // Rule ID 8806 //
     /*  192292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  192303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  192306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  192309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192331 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  192331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  192334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192348 */     GIR_RootConstrainSelectedInstOperands,
     /*  192349 */     // GIR_Coverage, 8806,
     /*  192349 */     GIR_EraseRootFromParent_Done,
     /*  192350 */   // Label 4202: @192350
     /*  192350 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(192413), // Rule ID 8807 //
     /*  192355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  192366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  192369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  192372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  192394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  192397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192411 */     GIR_RootConstrainSelectedInstOperands,
     /*  192412 */     // GIR_Coverage, 8807,
     /*  192412 */     GIR_EraseRootFromParent_Done,
     /*  192413 */   // Label 4203: @192413
     /*  192413 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(192476), // Rule ID 8810 //
     /*  192418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  192432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  192435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  192457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192474 */     GIR_RootConstrainSelectedInstOperands,
     /*  192475 */     // GIR_Coverage, 8810,
     /*  192475 */     GIR_EraseRootFromParent_Done,
     /*  192476 */   // Label 4204: @192476
     /*  192476 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(192539), // Rule ID 8811 //
     /*  192481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  192495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  192498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  192520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192537 */     GIR_RootConstrainSelectedInstOperands,
     /*  192538 */     // GIR_Coverage, 8811,
     /*  192538 */     GIR_EraseRootFromParent_Done,
     /*  192539 */   // Label 4205: @192539
     /*  192539 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(192602), // Rule ID 8814 //
     /*  192544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  192555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  192558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  192561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192583 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  192583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  192600 */     GIR_RootConstrainSelectedInstOperands,
     /*  192601 */     // GIR_Coverage, 8814,
     /*  192601 */     GIR_EraseRootFromParent_Done,
     /*  192602 */   // Label 4206: @192602
     /*  192602 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(192665), // Rule ID 8815 //
     /*  192607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  192618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  192621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  192624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  192646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  192649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  192663 */     GIR_RootConstrainSelectedInstOperands,
     /*  192664 */     // GIR_Coverage, 8815,
     /*  192664 */     GIR_EraseRootFromParent_Done,
     /*  192665 */   // Label 4207: @192665
     /*  192665 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(192728), // Rule ID 8818 //
     /*  192670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  192681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  192684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  192687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192709 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  192709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  192712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192726 */     GIR_RootConstrainSelectedInstOperands,
     /*  192727 */     // GIR_Coverage, 8818,
     /*  192727 */     GIR_EraseRootFromParent_Done,
     /*  192728 */   // Label 4208: @192728
     /*  192728 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(192791), // Rule ID 8819 //
     /*  192733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  192744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  192747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  192750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  192772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  192775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  192789 */     GIR_RootConstrainSelectedInstOperands,
     /*  192790 */     // GIR_Coverage, 8819,
     /*  192790 */     GIR_EraseRootFromParent_Done,
     /*  192791 */   // Label 4209: @192791
     /*  192791 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(192854), // Rule ID 8822 //
     /*  192796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  192807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  192810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  192813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  192835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  192838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192852 */     GIR_RootConstrainSelectedInstOperands,
     /*  192853 */     // GIR_Coverage, 8822,
     /*  192853 */     GIR_EraseRootFromParent_Done,
     /*  192854 */   // Label 4210: @192854
     /*  192854 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(192917), // Rule ID 8823 //
     /*  192859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  192870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  192873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  192876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  192879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  192898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  192901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  192915 */     GIR_RootConstrainSelectedInstOperands,
     /*  192916 */     // GIR_Coverage, 8823,
     /*  192916 */     GIR_EraseRootFromParent_Done,
     /*  192917 */   // Label 4211: @192917
     /*  192917 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(192980), // Rule ID 8826 //
     /*  192922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  192925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  192936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  192939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  192942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  192954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  192961 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  192961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  192964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  192966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  192968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  192970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  192975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  192978 */     GIR_RootConstrainSelectedInstOperands,
     /*  192979 */     // GIR_Coverage, 8826,
     /*  192979 */     GIR_EraseRootFromParent_Done,
     /*  192980 */   // Label 4212: @192980
     /*  192980 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(193043), // Rule ID 8827 //
     /*  192985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  192988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  192993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  192996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  192999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  193002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  193024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  193027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193041 */     GIR_RootConstrainSelectedInstOperands,
     /*  193042 */     // GIR_Coverage, 8827,
     /*  193042 */     GIR_EraseRootFromParent_Done,
     /*  193043 */   // Label 4213: @193043
     /*  193043 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(193106), // Rule ID 8830 //
     /*  193048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  193051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  193059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  193062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  193065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  193087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  193090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193104 */     GIR_RootConstrainSelectedInstOperands,
     /*  193105 */     // GIR_Coverage, 8830,
     /*  193105 */     GIR_EraseRootFromParent_Done,
     /*  193106 */   // Label 4214: @193106
     /*  193106 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(193169), // Rule ID 8831 //
     /*  193111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  193114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  193122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  193125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  193128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  193150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  193153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193167 */     GIR_RootConstrainSelectedInstOperands,
     /*  193168 */     // GIR_Coverage, 8831,
     /*  193168 */     GIR_EraseRootFromParent_Done,
     /*  193169 */   // Label 4215: @193169
     /*  193169 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(193232), // Rule ID 8834 //
     /*  193174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  193185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  193188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  193191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  193213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  193216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193230 */     GIR_RootConstrainSelectedInstOperands,
     /*  193231 */     // GIR_Coverage, 8834,
     /*  193231 */     GIR_EraseRootFromParent_Done,
     /*  193232 */   // Label 4216: @193232
     /*  193232 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(193295), // Rule ID 8835 //
     /*  193237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  193248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  193251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  193254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  193276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  193279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193293 */     GIR_RootConstrainSelectedInstOperands,
     /*  193294 */     // GIR_Coverage, 8835,
     /*  193294 */     GIR_EraseRootFromParent_Done,
     /*  193295 */   // Label 4217: @193295
     /*  193295 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(193358), // Rule ID 8838 //
     /*  193300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  193311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  193314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  193317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193339 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  193339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  193342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193356 */     GIR_RootConstrainSelectedInstOperands,
     /*  193357 */     // GIR_Coverage, 8838,
     /*  193357 */     GIR_EraseRootFromParent_Done,
     /*  193358 */   // Label 4218: @193358
     /*  193358 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(193421), // Rule ID 8839 //
     /*  193363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  193374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  193377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  193380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  193402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  193405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193419 */     GIR_RootConstrainSelectedInstOperands,
     /*  193420 */     // GIR_Coverage, 8839,
     /*  193420 */     GIR_EraseRootFromParent_Done,
     /*  193421 */   // Label 4219: @193421
     /*  193421 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(193484), // Rule ID 8842 //
     /*  193426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  193437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  193440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  193443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193465 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  193465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  193468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193482 */     GIR_RootConstrainSelectedInstOperands,
     /*  193483 */     // GIR_Coverage, 8842,
     /*  193483 */     GIR_EraseRootFromParent_Done,
     /*  193484 */   // Label 4220: @193484
     /*  193484 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(193547), // Rule ID 8843 //
     /*  193489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  193500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  193503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  193506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193528 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  193528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  193531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  193545 */     GIR_RootConstrainSelectedInstOperands,
     /*  193546 */     // GIR_Coverage, 8843,
     /*  193546 */     GIR_EraseRootFromParent_Done,
     /*  193547 */   // Label 4221: @193547
     /*  193547 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(193610), // Rule ID 8846 //
     /*  193552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  193563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  193566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  193569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193591 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  193591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  193594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193608 */     GIR_RootConstrainSelectedInstOperands,
     /*  193609 */     // GIR_Coverage, 8846,
     /*  193609 */     GIR_EraseRootFromParent_Done,
     /*  193610 */   // Label 4222: @193610
     /*  193610 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(193673), // Rule ID 8847 //
     /*  193615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  193626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  193629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  193632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  193654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  193657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193671 */     GIR_RootConstrainSelectedInstOperands,
     /*  193672 */     // GIR_Coverage, 8847,
     /*  193672 */     GIR_EraseRootFromParent_Done,
     /*  193673 */   // Label 4223: @193673
     /*  193673 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(193736), // Rule ID 8850 //
     /*  193678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  193689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  193692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  193695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  193717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  193720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193734 */     GIR_RootConstrainSelectedInstOperands,
     /*  193735 */     // GIR_Coverage, 8850,
     /*  193735 */     GIR_EraseRootFromParent_Done,
     /*  193736 */   // Label 4224: @193736
     /*  193736 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(193799), // Rule ID 8851 //
     /*  193741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  193752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  193755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  193758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  193773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  193780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  193783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193797 */     GIR_RootConstrainSelectedInstOperands,
     /*  193798 */     // GIR_Coverage, 8851,
     /*  193798 */     GIR_EraseRootFromParent_Done,
     /*  193799 */   // Label 4225: @193799
     /*  193799 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(193862), // Rule ID 8854 //
     /*  193804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  193815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  193818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  193821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193843 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  193843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  193846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193860 */     GIR_RootConstrainSelectedInstOperands,
     /*  193861 */     // GIR_Coverage, 8854,
     /*  193861 */     GIR_EraseRootFromParent_Done,
     /*  193862 */   // Label 4226: @193862
     /*  193862 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(193925), // Rule ID 8855 //
     /*  193867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  193878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  193881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  193884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  193887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  193899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193906 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  193906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  193909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193923 */     GIR_RootConstrainSelectedInstOperands,
     /*  193924 */     // GIR_Coverage, 8855,
     /*  193924 */     GIR_EraseRootFromParent_Done,
     /*  193925 */   // Label 4227: @193925
     /*  193925 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(193988), // Rule ID 8858 //
     /*  193930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  193933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  193938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  193941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  193944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  193947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  193950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  193954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  193962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  193969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  193969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  193972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  193974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  193976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  193978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  193983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193986 */     GIR_RootConstrainSelectedInstOperands,
     /*  193987 */     // GIR_Coverage, 8858,
     /*  193987 */     GIR_EraseRootFromParent_Done,
     /*  193988 */   // Label 4228: @193988
     /*  193988 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(194051), // Rule ID 8859 //
     /*  193993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  193996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  194004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  194007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  194010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  194032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  194035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  194049 */     GIR_RootConstrainSelectedInstOperands,
     /*  194050 */     // GIR_Coverage, 8859,
     /*  194050 */     GIR_EraseRootFromParent_Done,
     /*  194051 */   // Label 4229: @194051
     /*  194051 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(194114), // Rule ID 8862 //
     /*  194056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  194059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  194067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  194070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  194073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  194095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  194098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  194112 */     GIR_RootConstrainSelectedInstOperands,
     /*  194113 */     // GIR_Coverage, 8862,
     /*  194113 */     GIR_EraseRootFromParent_Done,
     /*  194114 */   // Label 4230: @194114
     /*  194114 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(194177), // Rule ID 8863 //
     /*  194119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  194122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  194130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  194133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  194136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194158 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  194158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  194161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  194175 */     GIR_RootConstrainSelectedInstOperands,
     /*  194176 */     // GIR_Coverage, 8863,
     /*  194176 */     GIR_EraseRootFromParent_Done,
     /*  194177 */   // Label 4231: @194177
     /*  194177 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(194240), // Rule ID 8866 //
     /*  194182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  194185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  194193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  194196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  194199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194221 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  194221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  194224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  194238 */     GIR_RootConstrainSelectedInstOperands,
     /*  194239 */     // GIR_Coverage, 8866,
     /*  194239 */     GIR_EraseRootFromParent_Done,
     /*  194240 */   // Label 4232: @194240
     /*  194240 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(194303), // Rule ID 8867 //
     /*  194245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  194248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  194256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  194259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  194262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  194284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  194287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  194301 */     GIR_RootConstrainSelectedInstOperands,
     /*  194302 */     // GIR_Coverage, 8867,
     /*  194302 */     GIR_EraseRootFromParent_Done,
     /*  194303 */   // Label 4233: @194303
     /*  194303 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(194366), // Rule ID 8870 //
     /*  194308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  194311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  194319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  194322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  194325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  194347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  194350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194364 */     GIR_RootConstrainSelectedInstOperands,
     /*  194365 */     // GIR_Coverage, 8870,
     /*  194365 */     GIR_EraseRootFromParent_Done,
     /*  194366 */   // Label 4234: @194366
     /*  194366 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(194429), // Rule ID 8871 //
     /*  194371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  194374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  194382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  194385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  194388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  194403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194410 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  194410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  194413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194427 */     GIR_RootConstrainSelectedInstOperands,
     /*  194428 */     // GIR_Coverage, 8871,
     /*  194428 */     GIR_EraseRootFromParent_Done,
     /*  194429 */   // Label 4235: @194429
     /*  194429 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(194492), // Rule ID 8874 //
     /*  194434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  194437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  194445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  194448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  194451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194473 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  194473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  194476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194490 */     GIR_RootConstrainSelectedInstOperands,
     /*  194491 */     // GIR_Coverage, 8874,
     /*  194491 */     GIR_EraseRootFromParent_Done,
     /*  194492 */   // Label 4236: @194492
     /*  194492 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(194555), // Rule ID 8875 //
     /*  194497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  194500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  194508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  194511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  194514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  194529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  194536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  194539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194553 */     GIR_RootConstrainSelectedInstOperands,
     /*  194554 */     // GIR_Coverage, 8875,
     /*  194554 */     GIR_EraseRootFromParent_Done,
     /*  194555 */   // Label 4237: @194555
     /*  194555 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(194618), // Rule ID 8878 //
     /*  194560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  194563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  194571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  194574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  194577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194599 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  194599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  194602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194616 */     GIR_RootConstrainSelectedInstOperands,
     /*  194617 */     // GIR_Coverage, 8878,
     /*  194617 */     GIR_EraseRootFromParent_Done,
     /*  194618 */   // Label 4238: @194618
     /*  194618 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(194681), // Rule ID 8879 //
     /*  194623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  194626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  194634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  194637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  194640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  194655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  194662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  194665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  194679 */     GIR_RootConstrainSelectedInstOperands,
     /*  194680 */     // GIR_Coverage, 8879,
     /*  194680 */     GIR_EraseRootFromParent_Done,
     /*  194681 */   // Label 4239: @194681
     /*  194681 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(194744), // Rule ID 8882 //
     /*  194686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  194689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  194697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  194700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  194703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194725 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  194725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  194728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  194742 */     GIR_RootConstrainSelectedInstOperands,
     /*  194743 */     // GIR_Coverage, 8882,
     /*  194743 */     GIR_EraseRootFromParent_Done,
     /*  194744 */   // Label 4240: @194744
     /*  194744 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(194807), // Rule ID 8883 //
     /*  194749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  194752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  194760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  194763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  194766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  194788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  194791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  194805 */     GIR_RootConstrainSelectedInstOperands,
     /*  194806 */     // GIR_Coverage, 8883,
     /*  194806 */     GIR_EraseRootFromParent_Done,
     /*  194807 */   // Label 4241: @194807
     /*  194807 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(194870), // Rule ID 8886 //
     /*  194812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  194815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  194823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  194826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  194829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194851 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  194851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  194854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  194868 */     GIR_RootConstrainSelectedInstOperands,
     /*  194869 */     // GIR_Coverage, 8886,
     /*  194869 */     GIR_EraseRootFromParent_Done,
     /*  194870 */   // Label 4242: @194870
     /*  194870 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(194933), // Rule ID 8887 //
     /*  194875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  194878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  194886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  194889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  194892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  194895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  194914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  194917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  194931 */     GIR_RootConstrainSelectedInstOperands,
     /*  194932 */     // GIR_Coverage, 8887,
     /*  194932 */     GIR_EraseRootFromParent_Done,
     /*  194933 */   // Label 4243: @194933
     /*  194933 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(194996), // Rule ID 8890 //
     /*  194938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  194941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  194946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  194949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  194952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  194955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  194958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  194966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  194977 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  194977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  194980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  194982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  194984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  194986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  194991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  194994 */     GIR_RootConstrainSelectedInstOperands,
     /*  194995 */     // GIR_Coverage, 8890,
     /*  194995 */     GIR_EraseRootFromParent_Done,
     /*  194996 */   // Label 4244: @194996
     /*  194996 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(195059), // Rule ID 8891 //
     /*  195001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  195012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  195015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195040 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  195040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  195043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  195057 */     GIR_RootConstrainSelectedInstOperands,
     /*  195058 */     // GIR_Coverage, 8891,
     /*  195058 */     GIR_EraseRootFromParent_Done,
     /*  195059 */   // Label 4245: @195059
     /*  195059 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(195122), // Rule ID 8894 //
     /*  195064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  195078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  195103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  195106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195120 */     GIR_RootConstrainSelectedInstOperands,
     /*  195121 */     // GIR_Coverage, 8894,
     /*  195121 */     GIR_EraseRootFromParent_Done,
     /*  195122 */   // Label 4246: @195122
     /*  195122 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(195185), // Rule ID 8895 //
     /*  195127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  195141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  195166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  195169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195183 */     GIR_RootConstrainSelectedInstOperands,
     /*  195184 */     // GIR_Coverage, 8895,
     /*  195184 */     GIR_EraseRootFromParent_Done,
     /*  195185 */   // Label 4247: @195185
     /*  195185 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(195248), // Rule ID 8898 //
     /*  195190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  195201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  195204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195229 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  195229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  195232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195246 */     GIR_RootConstrainSelectedInstOperands,
     /*  195247 */     // GIR_Coverage, 8898,
     /*  195247 */     GIR_EraseRootFromParent_Done,
     /*  195248 */   // Label 4248: @195248
     /*  195248 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(195311), // Rule ID 8899 //
     /*  195253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  195264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  195267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  195292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  195295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195309 */     GIR_RootConstrainSelectedInstOperands,
     /*  195310 */     // GIR_Coverage, 8899,
     /*  195310 */     GIR_EraseRootFromParent_Done,
     /*  195311 */   // Label 4249: @195311
     /*  195311 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(195374), // Rule ID 8902 //
     /*  195316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  195330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  195355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  195358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  195372 */     GIR_RootConstrainSelectedInstOperands,
     /*  195373 */     // GIR_Coverage, 8902,
     /*  195373 */     GIR_EraseRootFromParent_Done,
     /*  195374 */   // Label 4250: @195374
     /*  195374 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(195437), // Rule ID 8903 //
     /*  195379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  195393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  195418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  195421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  195435 */     GIR_RootConstrainSelectedInstOperands,
     /*  195436 */     // GIR_Coverage, 8903,
     /*  195436 */     GIR_EraseRootFromParent_Done,
     /*  195437 */   // Label 4251: @195437
     /*  195437 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(195500), // Rule ID 8906 //
     /*  195442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  195453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  195456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  195481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  195498 */     GIR_RootConstrainSelectedInstOperands,
     /*  195499 */     // GIR_Coverage, 8906,
     /*  195499 */     GIR_EraseRootFromParent_Done,
     /*  195500 */   // Label 4252: @195500
     /*  195500 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(195563), // Rule ID 8907 //
     /*  195505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  195516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  195519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  195544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  195561 */     GIR_RootConstrainSelectedInstOperands,
     /*  195562 */     // GIR_Coverage, 8907,
     /*  195562 */     GIR_EraseRootFromParent_Done,
     /*  195563 */   // Label 4253: @195563
     /*  195563 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(195626), // Rule ID 8910 //
     /*  195568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  195579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  195582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  195607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195624 */     GIR_RootConstrainSelectedInstOperands,
     /*  195625 */     // GIR_Coverage, 8910,
     /*  195625 */     GIR_EraseRootFromParent_Done,
     /*  195626 */   // Label 4254: @195626
     /*  195626 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(195689), // Rule ID 8911 //
     /*  195631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  195642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  195645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  195670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  195687 */     GIR_RootConstrainSelectedInstOperands,
     /*  195688 */     // GIR_Coverage, 8911,
     /*  195688 */     GIR_EraseRootFromParent_Done,
     /*  195689 */   // Label 4255: @195689
     /*  195689 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(195752), // Rule ID 8914 //
     /*  195694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  195705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  195708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  195733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  195750 */     GIR_RootConstrainSelectedInstOperands,
     /*  195751 */     // GIR_Coverage, 8914,
     /*  195751 */     GIR_EraseRootFromParent_Done,
     /*  195752 */   // Label 4256: @195752
     /*  195752 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(195815), // Rule ID 8915 //
     /*  195757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  195760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  195768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  195771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  195796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  195813 */     GIR_RootConstrainSelectedInstOperands,
     /*  195814 */     // GIR_Coverage, 8915,
     /*  195814 */     GIR_EraseRootFromParent_Done,
     /*  195815 */   // Label 4257: @195815
     /*  195815 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(195878), // Rule ID 8918 //
     /*  195820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  195823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  195834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  195859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  195876 */     GIR_RootConstrainSelectedInstOperands,
     /*  195877 */     // GIR_Coverage, 8918,
     /*  195877 */     GIR_EraseRootFromParent_Done,
     /*  195878 */   // Label 4258: @195878
     /*  195878 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(195941), // Rule ID 8919 //
     /*  195883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  195886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  195894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  195897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  195900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  195903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195922 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  195922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  195925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  195939 */     GIR_RootConstrainSelectedInstOperands,
     /*  195940 */     // GIR_Coverage, 8919,
     /*  195940 */     GIR_EraseRootFromParent_Done,
     /*  195941 */   // Label 4259: @195941
     /*  195941 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(196004), // Rule ID 8922 //
     /*  195946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  195949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  195954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  195957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  195960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  195963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  195966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  195970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  195974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  195985 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  195985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  195988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  195990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  195992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  195994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  195999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196002 */     GIR_RootConstrainSelectedInstOperands,
     /*  196003 */     // GIR_Coverage, 8922,
     /*  196003 */     GIR_EraseRootFromParent_Done,
     /*  196004 */   // Label 4260: @196004
     /*  196004 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(196067), // Rule ID 8923 //
     /*  196009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  196020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  196023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  196037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  196048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  196051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196065 */     GIR_RootConstrainSelectedInstOperands,
     /*  196066 */     // GIR_Coverage, 8923,
     /*  196066 */     GIR_EraseRootFromParent_Done,
     /*  196067 */   // Label 4261: @196067
     /*  196067 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(196130), // Rule ID 8926 //
     /*  196072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  196083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  196086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  196111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196128 */     GIR_RootConstrainSelectedInstOperands,
     /*  196129 */     // GIR_Coverage, 8926,
     /*  196129 */     GIR_EraseRootFromParent_Done,
     /*  196130 */   // Label 4262: @196130
     /*  196130 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(196193), // Rule ID 8927 //
     /*  196135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  196146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  196149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  196174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196191 */     GIR_RootConstrainSelectedInstOperands,
     /*  196192 */     // GIR_Coverage, 8927,
     /*  196192 */     GIR_EraseRootFromParent_Done,
     /*  196193 */   // Label 4263: @196193
     /*  196193 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(196256), // Rule ID 8930 //
     /*  196198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  196209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  196212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  196226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196237 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  196237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  196240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196254 */     GIR_RootConstrainSelectedInstOperands,
     /*  196255 */     // GIR_Coverage, 8930,
     /*  196255 */     GIR_EraseRootFromParent_Done,
     /*  196256 */   // Label 4264: @196256
     /*  196256 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(196319), // Rule ID 8931 //
     /*  196261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  196272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  196275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  196289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196300 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  196300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  196303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  196317 */     GIR_RootConstrainSelectedInstOperands,
     /*  196318 */     // GIR_Coverage, 8931,
     /*  196318 */     GIR_EraseRootFromParent_Done,
     /*  196319 */   // Label 4265: @196319
     /*  196319 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(196382), // Rule ID 8934 //
     /*  196324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  196335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  196338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  196352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  196363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  196366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196380 */     GIR_RootConstrainSelectedInstOperands,
     /*  196381 */     // GIR_Coverage, 8934,
     /*  196381 */     GIR_EraseRootFromParent_Done,
     /*  196382 */   // Label 4266: @196382
     /*  196382 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(196445), // Rule ID 8935 //
     /*  196387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  196398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  196401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  196415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  196426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  196429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196443 */     GIR_RootConstrainSelectedInstOperands,
     /*  196444 */     // GIR_Coverage, 8935,
     /*  196444 */     GIR_EraseRootFromParent_Done,
     /*  196445 */   // Label 4267: @196445
     /*  196445 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(196508), // Rule ID 8938 //
     /*  196450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  196461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  196464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196489 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  196489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196506 */     GIR_RootConstrainSelectedInstOperands,
     /*  196507 */     // GIR_Coverage, 8938,
     /*  196507 */     GIR_EraseRootFromParent_Done,
     /*  196508 */   // Label 4268: @196508
     /*  196508 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(196571), // Rule ID 8939 //
     /*  196513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  196524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  196527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  196552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196569 */     GIR_RootConstrainSelectedInstOperands,
     /*  196570 */     // GIR_Coverage, 8939,
     /*  196570 */     GIR_EraseRootFromParent_Done,
     /*  196571 */   // Label 4269: @196571
     /*  196571 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(196634), // Rule ID 8942 //
     /*  196576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  196587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  196590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  196604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196615 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  196615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  196618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196632 */     GIR_RootConstrainSelectedInstOperands,
     /*  196633 */     // GIR_Coverage, 8942,
     /*  196633 */     GIR_EraseRootFromParent_Done,
     /*  196634 */   // Label 4270: @196634
     /*  196634 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(196697), // Rule ID 8943 //
     /*  196639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  196650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  196653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  196667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196678 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  196678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  196681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  196695 */     GIR_RootConstrainSelectedInstOperands,
     /*  196696 */     // GIR_Coverage, 8943,
     /*  196696 */     GIR_EraseRootFromParent_Done,
     /*  196697 */   // Label 4271: @196697
     /*  196697 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(196760), // Rule ID 8946 //
     /*  196702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  196713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  196716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  196730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  196741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  196744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  196758 */     GIR_RootConstrainSelectedInstOperands,
     /*  196759 */     // GIR_Coverage, 8946,
     /*  196759 */     GIR_EraseRootFromParent_Done,
     /*  196760 */   // Label 4272: @196760
     /*  196760 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(196823), // Rule ID 8947 //
     /*  196765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  196776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  196779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  196793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  196804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  196807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  196821 */     GIR_RootConstrainSelectedInstOperands,
     /*  196822 */     // GIR_Coverage, 8947,
     /*  196822 */     GIR_EraseRootFromParent_Done,
     /*  196823 */   // Label 4273: @196823
     /*  196823 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(196886), // Rule ID 8950 //
     /*  196828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  196839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  196842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196867 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  196867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  196884 */     GIR_RootConstrainSelectedInstOperands,
     /*  196885 */     // GIR_Coverage, 8950,
     /*  196885 */     GIR_EraseRootFromParent_Done,
     /*  196886 */   // Label 4274: @196886
     /*  196886 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(196949), // Rule ID 8951 //
     /*  196891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  196894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  196902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  196905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  196908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  196911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  196919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  196930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  196933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  196937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  196939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  196944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  196947 */     GIR_RootConstrainSelectedInstOperands,
     /*  196948 */     // GIR_Coverage, 8951,
     /*  196948 */     GIR_EraseRootFromParent_Done,
     /*  196949 */   // Label 4275: @196949
     /*  196949 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(197012), // Rule ID 8954 //
     /*  196954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  196957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  196962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  196965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  196968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  196971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  196974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  196978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  196982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  196993 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  196993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  196996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  196998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  197010 */     GIR_RootConstrainSelectedInstOperands,
     /*  197011 */     // GIR_Coverage, 8954,
     /*  197011 */     GIR_EraseRootFromParent_Done,
     /*  197012 */   // Label 4276: @197012
     /*  197012 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(197075), // Rule ID 8955 //
     /*  197017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  197020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  197028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  197031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  197045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  197056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  197059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  197073 */     GIR_RootConstrainSelectedInstOperands,
     /*  197074 */     // GIR_Coverage, 8955,
     /*  197074 */     GIR_EraseRootFromParent_Done,
     /*  197075 */   // Label 4277: @197075
     /*  197075 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(197138), // Rule ID 8958 //
     /*  197080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  197083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  197091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  197094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  197108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  197119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  197122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197136 */     GIR_RootConstrainSelectedInstOperands,
     /*  197137 */     // GIR_Coverage, 8958,
     /*  197137 */     GIR_EraseRootFromParent_Done,
     /*  197138 */   // Label 4278: @197138
     /*  197138 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(197201), // Rule ID 8959 //
     /*  197143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  197146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  197154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  197157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  197171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  197182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  197185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197199 */     GIR_RootConstrainSelectedInstOperands,
     /*  197200 */     // GIR_Coverage, 8959,
     /*  197200 */     GIR_EraseRootFromParent_Done,
     /*  197201 */   // Label 4279: @197201
     /*  197201 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(197264), // Rule ID 8962 //
     /*  197206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  197209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  197217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  197220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  197234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197245 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  197245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  197248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197262 */     GIR_RootConstrainSelectedInstOperands,
     /*  197263 */     // GIR_Coverage, 8962,
     /*  197263 */     GIR_EraseRootFromParent_Done,
     /*  197264 */   // Label 4280: @197264
     /*  197264 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(197327), // Rule ID 8963 //
     /*  197269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  197272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  197280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  197283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  197297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  197308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  197311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197325 */     GIR_RootConstrainSelectedInstOperands,
     /*  197326 */     // GIR_Coverage, 8963,
     /*  197326 */     GIR_EraseRootFromParent_Done,
     /*  197327 */   // Label 4281: @197327
     /*  197327 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(197390), // Rule ID 8966 //
     /*  197332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  197335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  197343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  197346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  197360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197371 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  197371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  197374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197388 */     GIR_RootConstrainSelectedInstOperands,
     /*  197389 */     // GIR_Coverage, 8966,
     /*  197389 */     GIR_EraseRootFromParent_Done,
     /*  197390 */   // Label 4282: @197390
     /*  197390 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(197453), // Rule ID 8967 //
     /*  197395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  197398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  197403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  197406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  197409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  197423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  197434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  197437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  197451 */     GIR_RootConstrainSelectedInstOperands,
     /*  197452 */     // GIR_Coverage, 8967,
     /*  197452 */     GIR_EraseRootFromParent_Done,
     /*  197453 */   // Label 4283: @197453
     /*  197453 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(197516), // Rule ID 9058 //
     /*  197458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  197461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  197469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  197472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197497 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  197497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  197500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197514 */     GIR_RootConstrainSelectedInstOperands,
     /*  197515 */     // GIR_Coverage, 9058,
     /*  197515 */     GIR_EraseRootFromParent_Done,
     /*  197516 */   // Label 4284: @197516
     /*  197516 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(197579), // Rule ID 9059 //
     /*  197521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  197524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  197532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  197535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  197560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  197563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197577 */     GIR_RootConstrainSelectedInstOperands,
     /*  197578 */     // GIR_Coverage, 9059,
     /*  197578 */     GIR_EraseRootFromParent_Done,
     /*  197579 */   // Label 4285: @197579
     /*  197579 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(197642), // Rule ID 9062 //
     /*  197584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  197587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  197595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  197598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197623 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  197623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  197626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197640 */     GIR_RootConstrainSelectedInstOperands,
     /*  197641 */     // GIR_Coverage, 9062,
     /*  197641 */     GIR_EraseRootFromParent_Done,
     /*  197642 */   // Label 4286: @197642
     /*  197642 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(197705), // Rule ID 9063 //
     /*  197647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  197650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  197658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  197661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197686 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  197686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  197689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197703 */     GIR_RootConstrainSelectedInstOperands,
     /*  197704 */     // GIR_Coverage, 9063,
     /*  197704 */     GIR_EraseRootFromParent_Done,
     /*  197705 */   // Label 4287: @197705
     /*  197705 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(197768), // Rule ID 9066 //
     /*  197710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  197713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  197721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  197724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197749 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  197749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  197752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197766 */     GIR_RootConstrainSelectedInstOperands,
     /*  197767 */     // GIR_Coverage, 9066,
     /*  197767 */     GIR_EraseRootFromParent_Done,
     /*  197768 */   // Label 4288: @197768
     /*  197768 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(197831), // Rule ID 9067 //
     /*  197773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  197776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  197784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  197787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  197812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  197815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  197829 */     GIR_RootConstrainSelectedInstOperands,
     /*  197830 */     // GIR_Coverage, 9067,
     /*  197830 */     GIR_EraseRootFromParent_Done,
     /*  197831 */   // Label 4289: @197831
     /*  197831 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(197894), // Rule ID 9070 //
     /*  197836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  197839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  197847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  197850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  197875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  197878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  197892 */     GIR_RootConstrainSelectedInstOperands,
     /*  197893 */     // GIR_Coverage, 9070,
     /*  197893 */     GIR_EraseRootFromParent_Done,
     /*  197894 */   // Label 4290: @197894
     /*  197894 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(197957), // Rule ID 9071 //
     /*  197899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  197902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  197910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  197913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  197916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  197919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  197938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  197938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  197941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  197943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  197945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  197947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  197952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  197955 */     GIR_RootConstrainSelectedInstOperands,
     /*  197956 */     // GIR_Coverage, 9071,
     /*  197956 */     GIR_EraseRootFromParent_Done,
     /*  197957 */   // Label 4291: @197957
     /*  197957 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(198020), // Rule ID 9074 //
     /*  197962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  197965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  197970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  197973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  197976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  197979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  197982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  197990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  198001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  198004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  198018 */     GIR_RootConstrainSelectedInstOperands,
     /*  198019 */     // GIR_Coverage, 9074,
     /*  198019 */     GIR_EraseRootFromParent_Done,
     /*  198020 */   // Label 4292: @198020
     /*  198020 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(198083), // Rule ID 9075 //
     /*  198025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  198036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  198039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  198064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  198067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  198081 */     GIR_RootConstrainSelectedInstOperands,
     /*  198082 */     // GIR_Coverage, 9075,
     /*  198082 */     GIR_EraseRootFromParent_Done,
     /*  198083 */   // Label 4293: @198083
     /*  198083 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(198146), // Rule ID 9078 //
     /*  198088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  198099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  198102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198127 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  198144 */     GIR_RootConstrainSelectedInstOperands,
     /*  198145 */     // GIR_Coverage, 9078,
     /*  198145 */     GIR_EraseRootFromParent_Done,
     /*  198146 */   // Label 4294: @198146
     /*  198146 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(198209), // Rule ID 9079 //
     /*  198151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  198162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  198165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  198190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  198193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  198207 */     GIR_RootConstrainSelectedInstOperands,
     /*  198208 */     // GIR_Coverage, 9079,
     /*  198208 */     GIR_EraseRootFromParent_Done,
     /*  198209 */   // Label 4295: @198209
     /*  198209 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(198272), // Rule ID 9082 //
     /*  198214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  198225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  198228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  198253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198270 */     GIR_RootConstrainSelectedInstOperands,
     /*  198271 */     // GIR_Coverage, 9082,
     /*  198271 */     GIR_EraseRootFromParent_Done,
     /*  198272 */   // Label 4296: @198272
     /*  198272 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(198335), // Rule ID 9083 //
     /*  198277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  198288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  198291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  198316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198333 */     GIR_RootConstrainSelectedInstOperands,
     /*  198334 */     // GIR_Coverage, 9083,
     /*  198334 */     GIR_EraseRootFromParent_Done,
     /*  198335 */   // Label 4297: @198335
     /*  198335 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(198398), // Rule ID 9086 //
     /*  198340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  198351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  198354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198379 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  198379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  198396 */     GIR_RootConstrainSelectedInstOperands,
     /*  198397 */     // GIR_Coverage, 9086,
     /*  198397 */     GIR_EraseRootFromParent_Done,
     /*  198398 */   // Label 4298: @198398
     /*  198398 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(198461), // Rule ID 9087 //
     /*  198403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  198414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  198417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  198442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  198459 */     GIR_RootConstrainSelectedInstOperands,
     /*  198460 */     // GIR_Coverage, 9087,
     /*  198460 */     GIR_EraseRootFromParent_Done,
     /*  198461 */   // Label 4299: @198461
     /*  198461 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(198524), // Rule ID 9090 //
     /*  198466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  198477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  198480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198505 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  198505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  198522 */     GIR_RootConstrainSelectedInstOperands,
     /*  198523 */     // GIR_Coverage, 9090,
     /*  198523 */     GIR_EraseRootFromParent_Done,
     /*  198524 */   // Label 4300: @198524
     /*  198524 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(198587), // Rule ID 9091 //
     /*  198529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  198540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  198543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198568 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  198568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  198585 */     GIR_RootConstrainSelectedInstOperands,
     /*  198586 */     // GIR_Coverage, 9091,
     /*  198586 */     GIR_EraseRootFromParent_Done,
     /*  198587 */   // Label 4301: @198587
     /*  198587 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(198650), // Rule ID 9094 //
     /*  198592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  198595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  198603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  198606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198631 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  198631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  198648 */     GIR_RootConstrainSelectedInstOperands,
     /*  198649 */     // GIR_Coverage, 9094,
     /*  198649 */     GIR_EraseRootFromParent_Done,
     /*  198650 */   // Label 4302: @198650
     /*  198650 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(198713), // Rule ID 9095 //
     /*  198655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  198658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  198666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  198669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  198694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  198697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  198711 */     GIR_RootConstrainSelectedInstOperands,
     /*  198712 */     // GIR_Coverage, 9095,
     /*  198712 */     GIR_EraseRootFromParent_Done,
     /*  198713 */   // Label 4303: @198713
     /*  198713 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(198776), // Rule ID 9098 //
     /*  198718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  198729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  198732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  198746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198757 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  198757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  198760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198774 */     GIR_RootConstrainSelectedInstOperands,
     /*  198775 */     // GIR_Coverage, 9098,
     /*  198775 */     GIR_EraseRootFromParent_Done,
     /*  198776 */   // Label 4304: @198776
     /*  198776 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(198839), // Rule ID 9099 //
     /*  198781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  198792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  198795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  198809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198820 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  198820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  198823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198837 */     GIR_RootConstrainSelectedInstOperands,
     /*  198838 */     // GIR_Coverage, 9099,
     /*  198838 */     GIR_EraseRootFromParent_Done,
     /*  198839 */   // Label 4305: @198839
     /*  198839 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(198902), // Rule ID 9102 //
     /*  198844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  198855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  198858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  198872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198883 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  198883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  198886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198900 */     GIR_RootConstrainSelectedInstOperands,
     /*  198901 */     // GIR_Coverage, 9102,
     /*  198901 */     GIR_EraseRootFromParent_Done,
     /*  198902 */   // Label 4306: @198902
     /*  198902 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(198965), // Rule ID 9103 //
     /*  198907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  198910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  198918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  198921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  198924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  198927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  198935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  198946 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  198946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  198949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  198951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  198953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  198955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  198960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  198963 */     GIR_RootConstrainSelectedInstOperands,
     /*  198964 */     // GIR_Coverage, 9103,
     /*  198964 */     GIR_EraseRootFromParent_Done,
     /*  198965 */   // Label 4307: @198965
     /*  198965 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(199028), // Rule ID 9106 //
     /*  198970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  198973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  198978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  198981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  198984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  198987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  198990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  198994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  198998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199009 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  199009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  199026 */     GIR_RootConstrainSelectedInstOperands,
     /*  199027 */     // GIR_Coverage, 9106,
     /*  199027 */     GIR_EraseRootFromParent_Done,
     /*  199028 */   // Label 4308: @199028
     /*  199028 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(199091), // Rule ID 9107 //
     /*  199033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  199044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  199047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  199061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199072 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  199072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  199089 */     GIR_RootConstrainSelectedInstOperands,
     /*  199090 */     // GIR_Coverage, 9107,
     /*  199090 */     GIR_EraseRootFromParent_Done,
     /*  199091 */   // Label 4309: @199091
     /*  199091 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(199154), // Rule ID 9110 //
     /*  199096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  199107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  199110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199135 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  199135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199152 */     GIR_RootConstrainSelectedInstOperands,
     /*  199153 */     // GIR_Coverage, 9110,
     /*  199153 */     GIR_EraseRootFromParent_Done,
     /*  199154 */   // Label 4310: @199154
     /*  199154 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(199217), // Rule ID 9111 //
     /*  199159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  199170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  199173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199198 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  199198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199215 */     GIR_RootConstrainSelectedInstOperands,
     /*  199216 */     // GIR_Coverage, 9111,
     /*  199216 */     GIR_EraseRootFromParent_Done,
     /*  199217 */   // Label 4311: @199217
     /*  199217 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(199280), // Rule ID 9114 //
     /*  199222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  199233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  199236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  199250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199261 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  199261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  199264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199278 */     GIR_RootConstrainSelectedInstOperands,
     /*  199279 */     // GIR_Coverage, 9114,
     /*  199279 */     GIR_EraseRootFromParent_Done,
     /*  199280 */   // Label 4312: @199280
     /*  199280 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(199343), // Rule ID 9115 //
     /*  199285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  199296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  199299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  199313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  199324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  199327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199341 */     GIR_RootConstrainSelectedInstOperands,
     /*  199342 */     // GIR_Coverage, 9115,
     /*  199342 */     GIR_EraseRootFromParent_Done,
     /*  199343 */   // Label 4313: @199343
     /*  199343 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(199406), // Rule ID 9118 //
     /*  199348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  199359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  199362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  199376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199387 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  199387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199404 */     GIR_RootConstrainSelectedInstOperands,
     /*  199405 */     // GIR_Coverage, 9118,
     /*  199405 */     GIR_EraseRootFromParent_Done,
     /*  199406 */   // Label 4314: @199406
     /*  199406 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(199469), // Rule ID 9119 //
     /*  199411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  199422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  199425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  199439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199450 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  199450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  199467 */     GIR_RootConstrainSelectedInstOperands,
     /*  199468 */     // GIR_Coverage, 9119,
     /*  199468 */     GIR_EraseRootFromParent_Done,
     /*  199469 */   // Label 4315: @199469
     /*  199469 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(199532), // Rule ID 9122 //
     /*  199474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  199485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  199488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199513 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  199513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199530 */     GIR_RootConstrainSelectedInstOperands,
     /*  199531 */     // GIR_Coverage, 9122,
     /*  199531 */     GIR_EraseRootFromParent_Done,
     /*  199532 */   // Label 4316: @199532
     /*  199532 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(199595), // Rule ID 9123 //
     /*  199537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  199548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  199551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  199576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199593 */     GIR_RootConstrainSelectedInstOperands,
     /*  199594 */     // GIR_Coverage, 9123,
     /*  199594 */     GIR_EraseRootFromParent_Done,
     /*  199595 */   // Label 4317: @199595
     /*  199595 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(199658), // Rule ID 9126 //
     /*  199600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  199611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  199614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  199628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  199639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  199642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199656 */     GIR_RootConstrainSelectedInstOperands,
     /*  199657 */     // GIR_Coverage, 9126,
     /*  199657 */     GIR_EraseRootFromParent_Done,
     /*  199658 */   // Label 4318: @199658
     /*  199658 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(199721), // Rule ID 9127 //
     /*  199663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  199674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  199677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  199691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  199702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  199705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199719 */     GIR_RootConstrainSelectedInstOperands,
     /*  199720 */     // GIR_Coverage, 9127,
     /*  199720 */     GIR_EraseRootFromParent_Done,
     /*  199721 */   // Label 4319: @199721
     /*  199721 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(199784), // Rule ID 9130 //
     /*  199726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  199729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  199737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  199740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  199754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199765 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  199765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199782 */     GIR_RootConstrainSelectedInstOperands,
     /*  199783 */     // GIR_Coverage, 9130,
     /*  199783 */     GIR_EraseRootFromParent_Done,
     /*  199784 */   // Label 4320: @199784
     /*  199784 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(199847), // Rule ID 9131 //
     /*  199789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  199792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  199800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  199803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  199817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  199828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  199831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  199845 */     GIR_RootConstrainSelectedInstOperands,
     /*  199846 */     // GIR_Coverage, 9131,
     /*  199846 */     GIR_EraseRootFromParent_Done,
     /*  199847 */   // Label 4321: @199847
     /*  199847 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(199910), // Rule ID 9134 //
     /*  199852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  199855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  199863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  199866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199891 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  199891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  199908 */     GIR_RootConstrainSelectedInstOperands,
     /*  199909 */     // GIR_Coverage, 9134,
     /*  199909 */     GIR_EraseRootFromParent_Done,
     /*  199910 */   // Label 4322: @199910
     /*  199910 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(199973), // Rule ID 9135 //
     /*  199915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  199918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  199926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  199929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  199932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  199935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  199939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  199943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  199954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  199954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  199957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  199959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  199961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  199963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  199968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  199971 */     GIR_RootConstrainSelectedInstOperands,
     /*  199972 */     // GIR_Coverage, 9135,
     /*  199972 */     GIR_EraseRootFromParent_Done,
     /*  199973 */   // Label 4323: @199973
     /*  199973 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(200036), // Rule ID 9138 //
     /*  199978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  199981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  199986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  199989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  199992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  199995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  199998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  200006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  200017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  200020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  200034 */     GIR_RootConstrainSelectedInstOperands,
     /*  200035 */     // GIR_Coverage, 9138,
     /*  200035 */     GIR_EraseRootFromParent_Done,
     /*  200036 */   // Label 4324: @200036
     /*  200036 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(200099), // Rule ID 9139 //
     /*  200041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  200044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  200049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  200052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  200055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  200069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200080 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  200080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  200083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  200097 */     GIR_RootConstrainSelectedInstOperands,
     /*  200098 */     // GIR_Coverage, 9139,
     /*  200098 */     GIR_EraseRootFromParent_Done,
     /*  200099 */   // Label 4325: @200099
     /*  200099 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(200162), // Rule ID 9142 //
     /*  200104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  200107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  200112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  200115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  200118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  200132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200143 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  200143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  200146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  200160 */     GIR_RootConstrainSelectedInstOperands,
     /*  200161 */     // GIR_Coverage, 9142,
     /*  200161 */     GIR_EraseRootFromParent_Done,
     /*  200162 */   // Label 4326: @200162
     /*  200162 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(200225), // Rule ID 9143 //
     /*  200167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  200170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  200175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  200178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  200181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  200195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  200206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  200209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  200223 */     GIR_RootConstrainSelectedInstOperands,
     /*  200224 */     // GIR_Coverage, 9143,
     /*  200224 */     GIR_EraseRootFromParent_Done,
     /*  200225 */   // Label 4327: @200225
     /*  200225 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(200288), // Rule ID 9234 //
     /*  200230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  200244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200269 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  200269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  200272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200286 */     GIR_RootConstrainSelectedInstOperands,
     /*  200287 */     // GIR_Coverage, 9234,
     /*  200287 */     GIR_EraseRootFromParent_Done,
     /*  200288 */   // Label 4328: @200288
     /*  200288 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(200351), // Rule ID 9235 //
     /*  200293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  200307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  200332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  200335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200349 */     GIR_RootConstrainSelectedInstOperands,
     /*  200350 */     // GIR_Coverage, 9235,
     /*  200350 */     GIR_EraseRootFromParent_Done,
     /*  200351 */   // Label 4329: @200351
     /*  200351 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(200414), // Rule ID 9238 //
     /*  200356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  200367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  200370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200395 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  200395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  200398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200412 */     GIR_RootConstrainSelectedInstOperands,
     /*  200413 */     // GIR_Coverage, 9238,
     /*  200413 */     GIR_EraseRootFromParent_Done,
     /*  200414 */   // Label 4330: @200414
     /*  200414 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(200477), // Rule ID 9239 //
     /*  200419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  200430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  200433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  200458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  200461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200475 */     GIR_RootConstrainSelectedInstOperands,
     /*  200476 */     // GIR_Coverage, 9239,
     /*  200476 */     GIR_EraseRootFromParent_Done,
     /*  200477 */   // Label 4331: @200477
     /*  200477 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(200540), // Rule ID 9242 //
     /*  200482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  200493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  200496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200521 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  200521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200538 */     GIR_RootConstrainSelectedInstOperands,
     /*  200539 */     // GIR_Coverage, 9242,
     /*  200539 */     GIR_EraseRootFromParent_Done,
     /*  200540 */   // Label 4332: @200540
     /*  200540 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(200603), // Rule ID 9243 //
     /*  200545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  200556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  200559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  200584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  200601 */     GIR_RootConstrainSelectedInstOperands,
     /*  200602 */     // GIR_Coverage, 9243,
     /*  200602 */     GIR_EraseRootFromParent_Done,
     /*  200603 */   // Label 4333: @200603
     /*  200603 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(200666), // Rule ID 9246 //
     /*  200608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  200622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200647 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  200647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  200650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  200664 */     GIR_RootConstrainSelectedInstOperands,
     /*  200665 */     // GIR_Coverage, 9246,
     /*  200665 */     GIR_EraseRootFromParent_Done,
     /*  200666 */   // Label 4334: @200666
     /*  200666 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(200729), // Rule ID 9247 //
     /*  200671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  200685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  200710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  200713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  200727 */     GIR_RootConstrainSelectedInstOperands,
     /*  200728 */     // GIR_Coverage, 9247,
     /*  200728 */     GIR_EraseRootFromParent_Done,
     /*  200729 */   // Label 4335: @200729
     /*  200729 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(200792), // Rule ID 9250 //
     /*  200734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  200745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  200748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  200773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  200790 */     GIR_RootConstrainSelectedInstOperands,
     /*  200791 */     // GIR_Coverage, 9250,
     /*  200791 */     GIR_EraseRootFromParent_Done,
     /*  200792 */   // Label 4336: @200792
     /*  200792 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(200855), // Rule ID 9251 //
     /*  200797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  200808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  200811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200836 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  200836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  200853 */     GIR_RootConstrainSelectedInstOperands,
     /*  200854 */     // GIR_Coverage, 9251,
     /*  200854 */     GIR_EraseRootFromParent_Done,
     /*  200855 */   // Label 4337: @200855
     /*  200855 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(200918), // Rule ID 9254 //
     /*  200860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  200874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  200877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  200880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200899 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  200899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  200916 */     GIR_RootConstrainSelectedInstOperands,
     /*  200917 */     // GIR_Coverage, 9254,
     /*  200917 */     GIR_EraseRootFromParent_Done,
     /*  200918 */   // Label 4338: @200918
     /*  200918 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(200981), // Rule ID 9255 //
     /*  200923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  200926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  200934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  200937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  200940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  200943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  200951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  200962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  200962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  200965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  200967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  200969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  200971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  200976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  200979 */     GIR_RootConstrainSelectedInstOperands,
     /*  200980 */     // GIR_Coverage, 9255,
     /*  200980 */     GIR_EraseRootFromParent_Done,
     /*  200981 */   // Label 4339: @200981
     /*  200981 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(201044), // Rule ID 9258 //
     /*  200986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  200989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  200994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  200997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  201000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  201025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201042 */     GIR_RootConstrainSelectedInstOperands,
     /*  201043 */     // GIR_Coverage, 9258,
     /*  201043 */     GIR_EraseRootFromParent_Done,
     /*  201044 */   // Label 4340: @201044
     /*  201044 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(201107), // Rule ID 9259 //
     /*  201049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  201060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  201063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  201088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201105 */     GIR_RootConstrainSelectedInstOperands,
     /*  201106 */     // GIR_Coverage, 9259,
     /*  201106 */     GIR_EraseRootFromParent_Done,
     /*  201107 */   // Label 4341: @201107
     /*  201107 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(201170), // Rule ID 9262 //
     /*  201112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  201123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  201126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  201151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  201168 */     GIR_RootConstrainSelectedInstOperands,
     /*  201169 */     // GIR_Coverage, 9262,
     /*  201169 */     GIR_EraseRootFromParent_Done,
     /*  201170 */   // Label 4342: @201170
     /*  201170 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(201233), // Rule ID 9263 //
     /*  201175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  201186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  201189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  201214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  201231 */     GIR_RootConstrainSelectedInstOperands,
     /*  201232 */     // GIR_Coverage, 9263,
     /*  201232 */     GIR_EraseRootFromParent_Done,
     /*  201233 */   // Label 4343: @201233
     /*  201233 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(201296), // Rule ID 9266 //
     /*  201238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  201249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  201252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201277 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  201277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  201294 */     GIR_RootConstrainSelectedInstOperands,
     /*  201295 */     // GIR_Coverage, 9266,
     /*  201295 */     GIR_EraseRootFromParent_Done,
     /*  201296 */   // Label 4344: @201296
     /*  201296 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(201359), // Rule ID 9267 //
     /*  201301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  201312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  201315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  201340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  201357 */     GIR_RootConstrainSelectedInstOperands,
     /*  201358 */     // GIR_Coverage, 9267,
     /*  201358 */     GIR_EraseRootFromParent_Done,
     /*  201359 */   // Label 4345: @201359
     /*  201359 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(201422), // Rule ID 9270 //
     /*  201364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  201367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  201375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  201378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  201403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  201420 */     GIR_RootConstrainSelectedInstOperands,
     /*  201421 */     // GIR_Coverage, 9270,
     /*  201421 */     GIR_EraseRootFromParent_Done,
     /*  201422 */   // Label 4346: @201422
     /*  201422 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(201485), // Rule ID 9271 //
     /*  201427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  201430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  201438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  201441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201466 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  201466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  201469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  201483 */     GIR_RootConstrainSelectedInstOperands,
     /*  201484 */     // GIR_Coverage, 9271,
     /*  201484 */     GIR_EraseRootFromParent_Done,
     /*  201485 */   // Label 4347: @201485
     /*  201485 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(201548), // Rule ID 9274 //
     /*  201490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  201501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  201504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  201518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201529 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  201529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  201532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201546 */     GIR_RootConstrainSelectedInstOperands,
     /*  201547 */     // GIR_Coverage, 9274,
     /*  201547 */     GIR_EraseRootFromParent_Done,
     /*  201548 */   // Label 4348: @201548
     /*  201548 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(201611), // Rule ID 9275 //
     /*  201553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  201564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  201567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  201581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201592 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  201592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  201595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201609 */     GIR_RootConstrainSelectedInstOperands,
     /*  201610 */     // GIR_Coverage, 9275,
     /*  201610 */     GIR_EraseRootFromParent_Done,
     /*  201611 */   // Label 4349: @201611
     /*  201611 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(201674), // Rule ID 9278 //
     /*  201616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  201627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  201630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  201644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201655 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  201655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  201658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201672 */     GIR_RootConstrainSelectedInstOperands,
     /*  201673 */     // GIR_Coverage, 9278,
     /*  201673 */     GIR_EraseRootFromParent_Done,
     /*  201674 */   // Label 4350: @201674
     /*  201674 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(201737), // Rule ID 9279 //
     /*  201679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  201690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  201693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  201707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201718 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  201718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  201721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201735 */     GIR_RootConstrainSelectedInstOperands,
     /*  201736 */     // GIR_Coverage, 9279,
     /*  201736 */     GIR_EraseRootFromParent_Done,
     /*  201737 */   // Label 4351: @201737
     /*  201737 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(201800), // Rule ID 9282 //
     /*  201742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  201753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  201756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  201770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201781 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  201781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  201784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201798 */     GIR_RootConstrainSelectedInstOperands,
     /*  201799 */     // GIR_Coverage, 9282,
     /*  201799 */     GIR_EraseRootFromParent_Done,
     /*  201800 */   // Label 4352: @201800
     /*  201800 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(201863), // Rule ID 9283 //
     /*  201805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  201816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  201819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  201833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201844 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  201844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  201847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  201861 */     GIR_RootConstrainSelectedInstOperands,
     /*  201862 */     // GIR_Coverage, 9283,
     /*  201862 */     GIR_EraseRootFromParent_Done,
     /*  201863 */   // Label 4353: @201863
     /*  201863 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(201926), // Rule ID 9286 //
     /*  201868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  201879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  201882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  201885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  201888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  201896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  201907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  201910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  201924 */     GIR_RootConstrainSelectedInstOperands,
     /*  201925 */     // GIR_Coverage, 9286,
     /*  201925 */     GIR_EraseRootFromParent_Done,
     /*  201926 */   // Label 4354: @201926
     /*  201926 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(201989), // Rule ID 9287 //
     /*  201931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  201934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  201939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  201942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  201945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  201948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  201951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  201955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  201959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  201970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  201970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  201973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  201975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  201977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  201979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  201984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  201987 */     GIR_RootConstrainSelectedInstOperands,
     /*  201988 */     // GIR_Coverage, 9287,
     /*  201988 */     GIR_EraseRootFromParent_Done,
     /*  201989 */   // Label 4355: @201989
     /*  201989 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(202052), // Rule ID 9290 //
     /*  201994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  201997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  202005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  202008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  202033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  202050 */     GIR_RootConstrainSelectedInstOperands,
     /*  202051 */     // GIR_Coverage, 9290,
     /*  202051 */     GIR_EraseRootFromParent_Done,
     /*  202052 */   // Label 4356: @202052
     /*  202052 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(202115), // Rule ID 9291 //
     /*  202057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  202060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  202068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  202071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  202096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  202113 */     GIR_RootConstrainSelectedInstOperands,
     /*  202114 */     // GIR_Coverage, 9291,
     /*  202114 */     GIR_EraseRootFromParent_Done,
     /*  202115 */   // Label 4357: @202115
     /*  202115 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(202178), // Rule ID 9294 //
     /*  202120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  202123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  202131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  202134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202159 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  202159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  202176 */     GIR_RootConstrainSelectedInstOperands,
     /*  202177 */     // GIR_Coverage, 9294,
     /*  202177 */     GIR_EraseRootFromParent_Done,
     /*  202178 */   // Label 4358: @202178
     /*  202178 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(202241), // Rule ID 9295 //
     /*  202183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  202186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  202194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  202197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202222 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  202222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  202239 */     GIR_RootConstrainSelectedInstOperands,
     /*  202240 */     // GIR_Coverage, 9295,
     /*  202240 */     GIR_EraseRootFromParent_Done,
     /*  202241 */   // Label 4359: @202241
     /*  202241 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(202304), // Rule ID 9298 //
     /*  202246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  202249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  202257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  202260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  202274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202285 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  202285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  202288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202302 */     GIR_RootConstrainSelectedInstOperands,
     /*  202303 */     // GIR_Coverage, 9298,
     /*  202303 */     GIR_EraseRootFromParent_Done,
     /*  202304 */   // Label 4360: @202304
     /*  202304 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(202367), // Rule ID 9299 //
     /*  202309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  202312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  202320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  202323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  202337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  202348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  202351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202365 */     GIR_RootConstrainSelectedInstOperands,
     /*  202366 */     // GIR_Coverage, 9299,
     /*  202366 */     GIR_EraseRootFromParent_Done,
     /*  202367 */   // Label 4361: @202367
     /*  202367 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(202430), // Rule ID 9302 //
     /*  202372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  202375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  202383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  202386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202411 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  202411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202428 */     GIR_RootConstrainSelectedInstOperands,
     /*  202429 */     // GIR_Coverage, 9302,
     /*  202429 */     GIR_EraseRootFromParent_Done,
     /*  202430 */   // Label 4362: @202430
     /*  202430 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(202493), // Rule ID 9303 //
     /*  202435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  202438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  202446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  202449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202474 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  202474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202491 */     GIR_RootConstrainSelectedInstOperands,
     /*  202492 */     // GIR_Coverage, 9303,
     /*  202492 */     GIR_EraseRootFromParent_Done,
     /*  202493 */   // Label 4363: @202493
     /*  202493 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(202556), // Rule ID 9306 //
     /*  202498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  202501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  202509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  202512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202537 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  202537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202554 */     GIR_RootConstrainSelectedInstOperands,
     /*  202555 */     // GIR_Coverage, 9306,
     /*  202555 */     GIR_EraseRootFromParent_Done,
     /*  202556 */   // Label 4364: @202556
     /*  202556 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(202619), // Rule ID 9307 //
     /*  202561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  202564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  202572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  202575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  202600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  202617 */     GIR_RootConstrainSelectedInstOperands,
     /*  202618 */     // GIR_Coverage, 9307,
     /*  202618 */     GIR_EraseRootFromParent_Done,
     /*  202619 */   // Label 4365: @202619
     /*  202619 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(202682), // Rule ID 9310 //
     /*  202624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  202627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  202635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  202638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  202652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202663 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  202663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  202666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202680 */     GIR_RootConstrainSelectedInstOperands,
     /*  202681 */     // GIR_Coverage, 9310,
     /*  202681 */     GIR_EraseRootFromParent_Done,
     /*  202682 */   // Label 4366: @202682
     /*  202682 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(202745), // Rule ID 9311 //
     /*  202687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  202690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  202698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  202701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  202715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  202726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  202729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202743 */     GIR_RootConstrainSelectedInstOperands,
     /*  202744 */     // GIR_Coverage, 9311,
     /*  202744 */     GIR_EraseRootFromParent_Done,
     /*  202745 */   // Label 4367: @202745
     /*  202745 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(202808), // Rule ID 9314 //
     /*  202750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  202753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  202761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  202764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202789 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  202789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202806 */     GIR_RootConstrainSelectedInstOperands,
     /*  202807 */     // GIR_Coverage, 9314,
     /*  202807 */     GIR_EraseRootFromParent_Done,
     /*  202808 */   // Label 4368: @202808
     /*  202808 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(202871), // Rule ID 9315 //
     /*  202813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  202816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  202824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  202827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  202841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  202852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  202855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202869 */     GIR_RootConstrainSelectedInstOperands,
     /*  202870 */     // GIR_Coverage, 9315,
     /*  202870 */     GIR_EraseRootFromParent_Done,
     /*  202871 */   // Label 4369: @202871
     /*  202871 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(202934), // Rule ID 9318 //
     /*  202876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  202879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  202887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  202890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  202893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  202896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  202915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202932 */     GIR_RootConstrainSelectedInstOperands,
     /*  202933 */     // GIR_Coverage, 9318,
     /*  202933 */     GIR_EraseRootFromParent_Done,
     /*  202934 */   // Label 4370: @202934
     /*  202934 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(202997), // Rule ID 9319 //
     /*  202939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  202942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  202947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  202950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  202953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  202956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  202959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  202963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  202967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  202978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  202978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  202981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  202983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  202985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  202987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  202992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  202995 */     GIR_RootConstrainSelectedInstOperands,
     /*  202996 */     // GIR_Coverage, 9319,
     /*  202996 */     GIR_EraseRootFromParent_Done,
     /*  202997 */   // Label 4371: @202997
     /*  202997 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(203060), // Rule ID 9410 //
     /*  203002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  203016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  203019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203041 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  203041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  203044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203058 */     GIR_RootConstrainSelectedInstOperands,
     /*  203059 */     // GIR_Coverage, 9410,
     /*  203059 */     GIR_EraseRootFromParent_Done,
     /*  203060 */   // Label 4372: @203060
     /*  203060 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(203123), // Rule ID 9411 //
     /*  203065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  203079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  203082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  203104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  203107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203121 */     GIR_RootConstrainSelectedInstOperands,
     /*  203122 */     // GIR_Coverage, 9411,
     /*  203122 */     GIR_EraseRootFromParent_Done,
     /*  203123 */   // Label 4373: @203123
     /*  203123 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(203186), // Rule ID 9414 //
     /*  203128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  203139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  203142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  203145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  203167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203184 */     GIR_RootConstrainSelectedInstOperands,
     /*  203185 */     // GIR_Coverage, 9414,
     /*  203185 */     GIR_EraseRootFromParent_Done,
     /*  203186 */   // Label 4374: @203186
     /*  203186 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(203249), // Rule ID 9415 //
     /*  203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  203202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  203205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  203208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  203230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203247 */     GIR_RootConstrainSelectedInstOperands,
     /*  203248 */     // GIR_Coverage, 9415,
     /*  203248 */     GIR_EraseRootFromParent_Done,
     /*  203249 */   // Label 4375: @203249
     /*  203249 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(203312), // Rule ID 9418 //
     /*  203254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  203265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  203268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  203271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203293 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  203293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  203296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203310 */     GIR_RootConstrainSelectedInstOperands,
     /*  203311 */     // GIR_Coverage, 9418,
     /*  203311 */     GIR_EraseRootFromParent_Done,
     /*  203312 */   // Label 4376: @203312
     /*  203312 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(203375), // Rule ID 9419 //
     /*  203317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  203328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  203331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  203334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  203356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  203359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203373 */     GIR_RootConstrainSelectedInstOperands,
     /*  203374 */     // GIR_Coverage, 9419,
     /*  203374 */     GIR_EraseRootFromParent_Done,
     /*  203375 */   // Label 4377: @203375
     /*  203375 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(203438), // Rule ID 9422 //
     /*  203380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  203394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  203397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  203419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203436 */     GIR_RootConstrainSelectedInstOperands,
     /*  203437 */     // GIR_Coverage, 9422,
     /*  203437 */     GIR_EraseRootFromParent_Done,
     /*  203438 */   // Label 4378: @203438
     /*  203438 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(203501), // Rule ID 9423 //
     /*  203443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  203457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  203460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  203482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203499 */     GIR_RootConstrainSelectedInstOperands,
     /*  203500 */     // GIR_Coverage, 9423,
     /*  203500 */     GIR_EraseRootFromParent_Done,
     /*  203501 */   // Label 4379: @203501
     /*  203501 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(203564), // Rule ID 9426 //
     /*  203506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  203517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  203520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  203523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203545 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  203545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  203562 */     GIR_RootConstrainSelectedInstOperands,
     /*  203563 */     // GIR_Coverage, 9426,
     /*  203563 */     GIR_EraseRootFromParent_Done,
     /*  203564 */   // Label 4380: @203564
     /*  203564 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(203627), // Rule ID 9427 //
     /*  203569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  203580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  203583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  203586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  203608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  203611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  203625 */     GIR_RootConstrainSelectedInstOperands,
     /*  203626 */     // GIR_Coverage, 9427,
     /*  203626 */     GIR_EraseRootFromParent_Done,
     /*  203627 */   // Label 4381: @203627
     /*  203627 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(203690), // Rule ID 9430 //
     /*  203632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  203643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  203646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  203649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  203671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203688 */     GIR_RootConstrainSelectedInstOperands,
     /*  203689 */     // GIR_Coverage, 9430,
     /*  203689 */     GIR_EraseRootFromParent_Done,
     /*  203690 */   // Label 4382: @203690
     /*  203690 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(203753), // Rule ID 9431 //
     /*  203695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  203706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  203709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  203712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  203734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  203751 */     GIR_RootConstrainSelectedInstOperands,
     /*  203752 */     // GIR_Coverage, 9431,
     /*  203752 */     GIR_EraseRootFromParent_Done,
     /*  203753 */   // Label 4383: @203753
     /*  203753 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(203816), // Rule ID 9434 //
     /*  203758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  203769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  203772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  203775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203797 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  203797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203814 */     GIR_RootConstrainSelectedInstOperands,
     /*  203815 */     // GIR_Coverage, 9434,
     /*  203815 */     GIR_EraseRootFromParent_Done,
     /*  203816 */   // Label 4384: @203816
     /*  203816 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(203879), // Rule ID 9435 //
     /*  203821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  203832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  203835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  203838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  203860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  203877 */     GIR_RootConstrainSelectedInstOperands,
     /*  203878 */     // GIR_Coverage, 9435,
     /*  203878 */     GIR_EraseRootFromParent_Done,
     /*  203879 */   // Label 4385: @203879
     /*  203879 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(203942), // Rule ID 9438 //
     /*  203884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  203887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  203898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  203901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  203904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  203923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  203937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  203940 */     GIR_RootConstrainSelectedInstOperands,
     /*  203941 */     // GIR_Coverage, 9438,
     /*  203941 */     GIR_EraseRootFromParent_Done,
     /*  203942 */   // Label 4386: @203942
     /*  203942 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(204005), // Rule ID 9439 //
     /*  203947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  203950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  203955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  203958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  203961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  203964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  203967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  203979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  203986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  203986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  203989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  203991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  203993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  203995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  204003 */     GIR_RootConstrainSelectedInstOperands,
     /*  204004 */     // GIR_Coverage, 9439,
     /*  204004 */     GIR_EraseRootFromParent_Done,
     /*  204005 */   // Label 4387: @204005
     /*  204005 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(204068), // Rule ID 9442 //
     /*  204010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  204013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  204021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  204024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  204027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204049 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  204049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  204052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  204066 */     GIR_RootConstrainSelectedInstOperands,
     /*  204067 */     // GIR_Coverage, 9442,
     /*  204067 */     GIR_EraseRootFromParent_Done,
     /*  204068 */   // Label 4388: @204068
     /*  204068 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(204131), // Rule ID 9443 //
     /*  204073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  204076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  204084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  204087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  204090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  204112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  204115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  204129 */     GIR_RootConstrainSelectedInstOperands,
     /*  204130 */     // GIR_Coverage, 9443,
     /*  204130 */     GIR_EraseRootFromParent_Done,
     /*  204131 */   // Label 4389: @204131
     /*  204131 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(204194), // Rule ID 9446 //
     /*  204136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  204147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  204150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  204153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  204175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204192 */     GIR_RootConstrainSelectedInstOperands,
     /*  204193 */     // GIR_Coverage, 9446,
     /*  204193 */     GIR_EraseRootFromParent_Done,
     /*  204194 */   // Label 4390: @204194
     /*  204194 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(204257), // Rule ID 9447 //
     /*  204199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  204210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  204213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  204216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  204238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204255 */     GIR_RootConstrainSelectedInstOperands,
     /*  204256 */     // GIR_Coverage, 9447,
     /*  204256 */     GIR_EraseRootFromParent_Done,
     /*  204257 */   // Label 4391: @204257
     /*  204257 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(204320), // Rule ID 9450 //
     /*  204262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  204273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  204276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  204279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204301 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  204301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  204304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204318 */     GIR_RootConstrainSelectedInstOperands,
     /*  204319 */     // GIR_Coverage, 9450,
     /*  204319 */     GIR_EraseRootFromParent_Done,
     /*  204320 */   // Label 4392: @204320
     /*  204320 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(204383), // Rule ID 9451 //
     /*  204325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  204336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  204339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  204342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  204364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  204367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204381 */     GIR_RootConstrainSelectedInstOperands,
     /*  204382 */     // GIR_Coverage, 9451,
     /*  204382 */     GIR_EraseRootFromParent_Done,
     /*  204383 */   // Label 4393: @204383
     /*  204383 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(204446), // Rule ID 9454 //
     /*  204388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  204399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  204402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  204405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204427 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  204427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  204430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204444 */     GIR_RootConstrainSelectedInstOperands,
     /*  204445 */     // GIR_Coverage, 9454,
     /*  204445 */     GIR_EraseRootFromParent_Done,
     /*  204446 */   // Label 4394: @204446
     /*  204446 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(204509), // Rule ID 9455 //
     /*  204451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  204462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  204465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  204468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204490 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  204490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  204493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  204507 */     GIR_RootConstrainSelectedInstOperands,
     /*  204508 */     // GIR_Coverage, 9455,
     /*  204508 */     GIR_EraseRootFromParent_Done,
     /*  204509 */   // Label 4395: @204509
     /*  204509 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(204572), // Rule ID 9458 //
     /*  204514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  204525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  204528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  204531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  204553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204570 */     GIR_RootConstrainSelectedInstOperands,
     /*  204571 */     // GIR_Coverage, 9458,
     /*  204571 */     GIR_EraseRootFromParent_Done,
     /*  204572 */   // Label 4396: @204572
     /*  204572 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(204635), // Rule ID 9459 //
     /*  204577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  204588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  204591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  204594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  204616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204633 */     GIR_RootConstrainSelectedInstOperands,
     /*  204634 */     // GIR_Coverage, 9459,
     /*  204634 */     GIR_EraseRootFromParent_Done,
     /*  204635 */   // Label 4397: @204635
     /*  204635 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(204698), // Rule ID 9462 //
     /*  204640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  204651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  204654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  204657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  204679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  204682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204696 */     GIR_RootConstrainSelectedInstOperands,
     /*  204697 */     // GIR_Coverage, 9462,
     /*  204697 */     GIR_EraseRootFromParent_Done,
     /*  204698 */   // Label 4398: @204698
     /*  204698 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(204761), // Rule ID 9463 //
     /*  204703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  204714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  204717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  204720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  204735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  204742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  204745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204759 */     GIR_RootConstrainSelectedInstOperands,
     /*  204760 */     // GIR_Coverage, 9463,
     /*  204760 */     GIR_EraseRootFromParent_Done,
     /*  204761 */   // Label 4399: @204761
     /*  204761 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(204824), // Rule ID 9466 //
     /*  204766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  204777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  204780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  204783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  204805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  204808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204822 */     GIR_RootConstrainSelectedInstOperands,
     /*  204823 */     // GIR_Coverage, 9466,
     /*  204823 */     GIR_EraseRootFromParent_Done,
     /*  204824 */   // Label 4400: @204824
     /*  204824 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(204887), // Rule ID 9467 //
     /*  204829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  204840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  204843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  204846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  204861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204868 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  204868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  204871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  204885 */     GIR_RootConstrainSelectedInstOperands,
     /*  204886 */     // GIR_Coverage, 9467,
     /*  204886 */     GIR_EraseRootFromParent_Done,
     /*  204887 */   // Label 4401: @204887
     /*  204887 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(204950), // Rule ID 9470 //
     /*  204892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  204895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  204903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  204906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  204909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  204912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204931 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  204931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  204938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  204940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  204945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  204948 */     GIR_RootConstrainSelectedInstOperands,
     /*  204949 */     // GIR_Coverage, 9470,
     /*  204949 */     GIR_EraseRootFromParent_Done,
     /*  204950 */   // Label 4402: @204950
     /*  204950 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(205013), // Rule ID 9471 //
     /*  204955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  204958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  204963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  204966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  204969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  204972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  204975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  204979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  204987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  204994 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  204994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  204997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  204999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  205011 */     GIR_RootConstrainSelectedInstOperands,
     /*  205012 */     // GIR_Coverage, 9471,
     /*  205012 */     GIR_EraseRootFromParent_Done,
     /*  205013 */   // Label 4403: @205013
     /*  205013 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(205076), // Rule ID 9474 //
     /*  205018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  205021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  205029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  205032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  205035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  205057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  205060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  205074 */     GIR_RootConstrainSelectedInstOperands,
     /*  205075 */     // GIR_Coverage, 9474,
     /*  205075 */     GIR_EraseRootFromParent_Done,
     /*  205076 */   // Label 4404: @205076
     /*  205076 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(205139), // Rule ID 9475 //
     /*  205081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  205084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  205092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  205095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  205098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  205120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  205123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  205137 */     GIR_RootConstrainSelectedInstOperands,
     /*  205138 */     // GIR_Coverage, 9475,
     /*  205138 */     GIR_EraseRootFromParent_Done,
     /*  205139 */   // Label 4405: @205139
     /*  205139 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(205202), // Rule ID 9478 //
     /*  205144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  205147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  205155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  205158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  205161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205183 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  205183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  205186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  205200 */     GIR_RootConstrainSelectedInstOperands,
     /*  205201 */     // GIR_Coverage, 9478,
     /*  205201 */     GIR_EraseRootFromParent_Done,
     /*  205202 */   // Label 4406: @205202
     /*  205202 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(205265), // Rule ID 9479 //
     /*  205207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  205210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  205218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  205221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  205224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205246 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  205246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  205249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  205263 */     GIR_RootConstrainSelectedInstOperands,
     /*  205264 */     // GIR_Coverage, 9479,
     /*  205264 */     GIR_EraseRootFromParent_Done,
     /*  205265 */   // Label 4407: @205265
     /*  205265 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(205328), // Rule ID 9482 //
     /*  205270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  205273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  205281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  205284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  205287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  205298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  205302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205309 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  205309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  205312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205326 */     GIR_RootConstrainSelectedInstOperands,
     /*  205327 */     // GIR_Coverage, 9482,
     /*  205327 */     GIR_EraseRootFromParent_Done,
     /*  205328 */   // Label 4408: @205328
     /*  205328 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(205391), // Rule ID 9483 //
     /*  205333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  205336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  205344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  205347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  205350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  205361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  205365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  205372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  205375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205389 */     GIR_RootConstrainSelectedInstOperands,
     /*  205390 */     // GIR_Coverage, 9483,
     /*  205390 */     GIR_EraseRootFromParent_Done,
     /*  205391 */   // Label 4409: @205391
     /*  205391 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(205454), // Rule ID 9486 //
     /*  205396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  205399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  205407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  205410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  205413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  205435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  205438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205452 */     GIR_RootConstrainSelectedInstOperands,
     /*  205453 */     // GIR_Coverage, 9486,
     /*  205453 */     GIR_EraseRootFromParent_Done,
     /*  205454 */   // Label 4410: @205454
     /*  205454 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(205517), // Rule ID 9487 //
     /*  205459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  205462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  205470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  205473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  205476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  205491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  205498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  205501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205515 */     GIR_RootConstrainSelectedInstOperands,
     /*  205516 */     // GIR_Coverage, 9487,
     /*  205516 */     GIR_EraseRootFromParent_Done,
     /*  205517 */   // Label 4411: @205517
     /*  205517 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(205580), // Rule ID 9490 //
     /*  205522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  205525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  205533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  205536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  205539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205561 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  205561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  205564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205578 */     GIR_RootConstrainSelectedInstOperands,
     /*  205579 */     // GIR_Coverage, 9490,
     /*  205579 */     GIR_EraseRootFromParent_Done,
     /*  205580 */   // Label 4412: @205580
     /*  205580 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(205643), // Rule ID 9491 //
     /*  205585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  205588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  205593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  205596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  205599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  205602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  205617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205624 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  205624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  205627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  205641 */     GIR_RootConstrainSelectedInstOperands,
     /*  205642 */     // GIR_Coverage, 9491,
     /*  205642 */     GIR_EraseRootFromParent_Done,
     /*  205643 */   // Label 4413: @205643
     /*  205643 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(205706), // Rule ID 9494 //
     /*  205648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  205651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  205659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  205662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  205665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  205687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  205690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  205704 */     GIR_RootConstrainSelectedInstOperands,
     /*  205705 */     // GIR_Coverage, 9494,
     /*  205705 */     GIR_EraseRootFromParent_Done,
     /*  205706 */   // Label 4414: @205706
     /*  205706 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(205769), // Rule ID 9495 //
     /*  205711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  205714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  205722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  205725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  205728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205750 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  205750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  205753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  205767 */     GIR_RootConstrainSelectedInstOperands,
     /*  205768 */     // GIR_Coverage, 9495,
     /*  205768 */     GIR_EraseRootFromParent_Done,
     /*  205769 */   // Label 4415: @205769
     /*  205769 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(205832), // Rule ID 9498 //
     /*  205774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  205777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  205785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  205788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  205791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205813 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  205813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  205816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  205830 */     GIR_RootConstrainSelectedInstOperands,
     /*  205831 */     // GIR_Coverage, 9498,
     /*  205831 */     GIR_EraseRootFromParent_Done,
     /*  205832 */   // Label 4416: @205832
     /*  205832 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(205895), // Rule ID 9499 //
     /*  205837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  205840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  205848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  205851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  205854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  205876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  205879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  205893 */     GIR_RootConstrainSelectedInstOperands,
     /*  205894 */     // GIR_Coverage, 9499,
     /*  205894 */     GIR_EraseRootFromParent_Done,
     /*  205895 */   // Label 4417: @205895
     /*  205895 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(205958), // Rule ID 9502 //
     /*  205900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  205903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  205911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  205914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  205917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  205920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  205939 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  205939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  205942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  205944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  205946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  205948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  205953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  205956 */     GIR_RootConstrainSelectedInstOperands,
     /*  205957 */     // GIR_Coverage, 9502,
     /*  205957 */     GIR_EraseRootFromParent_Done,
     /*  205958 */   // Label 4418: @205958
     /*  205958 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(206021), // Rule ID 9503 //
     /*  205963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  205966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  205971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  205974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  205977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  205980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  205983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  205995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  206002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  206005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  206019 */     GIR_RootConstrainSelectedInstOperands,
     /*  206020 */     // GIR_Coverage, 9503,
     /*  206020 */     GIR_EraseRootFromParent_Done,
     /*  206021 */   // Label 4419: @206021
     /*  206021 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(206084), // Rule ID 9506 //
     /*  206026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  206040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  206043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206065 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  206065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  206068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206082 */     GIR_RootConstrainSelectedInstOperands,
     /*  206083 */     // GIR_Coverage, 9506,
     /*  206083 */     GIR_EraseRootFromParent_Done,
     /*  206084 */   // Label 4420: @206084
     /*  206084 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(206147), // Rule ID 9507 //
     /*  206089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  206103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  206106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  206128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  206131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206145 */     GIR_RootConstrainSelectedInstOperands,
     /*  206146 */     // GIR_Coverage, 9507,
     /*  206146 */     GIR_EraseRootFromParent_Done,
     /*  206147 */   // Label 4421: @206147
     /*  206147 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(206210), // Rule ID 9510 //
     /*  206152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  206163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  206166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  206169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  206191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  206194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206208 */     GIR_RootConstrainSelectedInstOperands,
     /*  206209 */     // GIR_Coverage, 9510,
     /*  206209 */     GIR_EraseRootFromParent_Done,
     /*  206210 */   // Label 4422: @206210
     /*  206210 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(206273), // Rule ID 9511 //
     /*  206215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  206226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  206229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  206232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  206254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  206257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206271 */     GIR_RootConstrainSelectedInstOperands,
     /*  206272 */     // GIR_Coverage, 9511,
     /*  206272 */     GIR_EraseRootFromParent_Done,
     /*  206273 */   // Label 4423: @206273
     /*  206273 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(206336), // Rule ID 9514 //
     /*  206278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  206292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  206295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206317 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  206317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  206320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  206334 */     GIR_RootConstrainSelectedInstOperands,
     /*  206335 */     // GIR_Coverage, 9514,
     /*  206335 */     GIR_EraseRootFromParent_Done,
     /*  206336 */   // Label 4424: @206336
     /*  206336 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(206399), // Rule ID 9515 //
     /*  206341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  206355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  206358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  206380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  206383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  206397 */     GIR_RootConstrainSelectedInstOperands,
     /*  206398 */     // GIR_Coverage, 9515,
     /*  206398 */     GIR_EraseRootFromParent_Done,
     /*  206399 */   // Label 4425: @206399
     /*  206399 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(206462), // Rule ID 9518 //
     /*  206404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  206415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  206418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  206421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  206443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  206460 */     GIR_RootConstrainSelectedInstOperands,
     /*  206461 */     // GIR_Coverage, 9518,
     /*  206461 */     GIR_EraseRootFromParent_Done,
     /*  206462 */   // Label 4426: @206462
     /*  206462 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(206525), // Rule ID 9519 //
     /*  206467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  206478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  206481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  206484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  206506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  206523 */     GIR_RootConstrainSelectedInstOperands,
     /*  206524 */     // GIR_Coverage, 9519,
     /*  206524 */     GIR_EraseRootFromParent_Done,
     /*  206525 */   // Label 4427: @206525
     /*  206525 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(206588), // Rule ID 9522 //
     /*  206530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  206541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  206544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  206547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206569 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  206569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206586 */     GIR_RootConstrainSelectedInstOperands,
     /*  206587 */     // GIR_Coverage, 9522,
     /*  206587 */     GIR_EraseRootFromParent_Done,
     /*  206588 */   // Label 4428: @206588
     /*  206588 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(206651), // Rule ID 9523 //
     /*  206593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  206604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  206607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  206610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  206632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  206649 */     GIR_RootConstrainSelectedInstOperands,
     /*  206650 */     // GIR_Coverage, 9523,
     /*  206650 */     GIR_EraseRootFromParent_Done,
     /*  206651 */   // Label 4429: @206651
     /*  206651 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(206714), // Rule ID 9526 //
     /*  206656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  206667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  206670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  206673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  206695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  206712 */     GIR_RootConstrainSelectedInstOperands,
     /*  206713 */     // GIR_Coverage, 9526,
     /*  206713 */     GIR_EraseRootFromParent_Done,
     /*  206714 */   // Label 4430: @206714
     /*  206714 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(206777), // Rule ID 9527 //
     /*  206719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  206730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  206733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  206736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  206758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  206775 */     GIR_RootConstrainSelectedInstOperands,
     /*  206776 */     // GIR_Coverage, 9527,
     /*  206776 */     GIR_EraseRootFromParent_Done,
     /*  206777 */   // Label 4431: @206777
     /*  206777 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(206840), // Rule ID 9530 //
     /*  206782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  206785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  206796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  206799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206821 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  206821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  206838 */     GIR_RootConstrainSelectedInstOperands,
     /*  206839 */     // GIR_Coverage, 9530,
     /*  206839 */     GIR_EraseRootFromParent_Done,
     /*  206840 */   // Label 4432: @206840
     /*  206840 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(206903), // Rule ID 9531 //
     /*  206845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  206848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  206856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  206859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  206862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  206884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  206887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  206901 */     GIR_RootConstrainSelectedInstOperands,
     /*  206902 */     // GIR_Coverage, 9531,
     /*  206902 */     GIR_EraseRootFromParent_Done,
     /*  206903 */   // Label 4433: @206903
     /*  206903 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(206966), // Rule ID 9534 //
     /*  206908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  206911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  206919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  206922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  206925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  206928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  206936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  206940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  206947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  206947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  206950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  206952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  206954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  206956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  206961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  206964 */     GIR_RootConstrainSelectedInstOperands,
     /*  206965 */     // GIR_Coverage, 9534,
     /*  206965 */     GIR_EraseRootFromParent_Done,
     /*  206966 */   // Label 4434: @206966
     /*  206966 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(207029), // Rule ID 9535 //
     /*  206971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  206974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  206979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  206982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  206985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  206988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  206991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  206995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  206999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  207010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  207013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207027 */     GIR_RootConstrainSelectedInstOperands,
     /*  207028 */     // GIR_Coverage, 9535,
     /*  207028 */     GIR_EraseRootFromParent_Done,
     /*  207029 */   // Label 4435: @207029
     /*  207029 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(207092), // Rule ID 9538 //
     /*  207034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  207048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  207051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207073 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  207073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207090 */     GIR_RootConstrainSelectedInstOperands,
     /*  207091 */     // GIR_Coverage, 9538,
     /*  207091 */     GIR_EraseRootFromParent_Done,
     /*  207092 */   // Label 4436: @207092
     /*  207092 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(207155), // Rule ID 9539 //
     /*  207097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  207111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  207114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207136 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  207136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207153 */     GIR_RootConstrainSelectedInstOperands,
     /*  207154 */     // GIR_Coverage, 9539,
     /*  207154 */     GIR_EraseRootFromParent_Done,
     /*  207155 */   // Label 4437: @207155
     /*  207155 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(207218), // Rule ID 9542 //
     /*  207160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  207171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  207174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  207177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207199 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  207199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  207202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207216 */     GIR_RootConstrainSelectedInstOperands,
     /*  207217 */     // GIR_Coverage, 9542,
     /*  207217 */     GIR_EraseRootFromParent_Done,
     /*  207218 */   // Label 4438: @207218
     /*  207218 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(207281), // Rule ID 9543 //
     /*  207223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  207234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  207237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  207240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207262 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  207262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  207265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207279 */     GIR_RootConstrainSelectedInstOperands,
     /*  207280 */     // GIR_Coverage, 9543,
     /*  207280 */     GIR_EraseRootFromParent_Done,
     /*  207281 */   // Label 4439: @207281
     /*  207281 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(207344), // Rule ID 9546 //
     /*  207286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  207300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  207303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  207325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  207328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207342 */     GIR_RootConstrainSelectedInstOperands,
     /*  207343 */     // GIR_Coverage, 9546,
     /*  207343 */     GIR_EraseRootFromParent_Done,
     /*  207344 */   // Label 4440: @207344
     /*  207344 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(207407), // Rule ID 9547 //
     /*  207349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  207363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  207366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  207388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  207391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207405 */     GIR_RootConstrainSelectedInstOperands,
     /*  207406 */     // GIR_Coverage, 9547,
     /*  207406 */     GIR_EraseRootFromParent_Done,
     /*  207407 */   // Label 4441: @207407
     /*  207407 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(207470), // Rule ID 9550 //
     /*  207412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  207426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  207429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  207451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207468 */     GIR_RootConstrainSelectedInstOperands,
     /*  207469 */     // GIR_Coverage, 9550,
     /*  207469 */     GIR_EraseRootFromParent_Done,
     /*  207470 */   // Label 4442: @207470
     /*  207470 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(207533), // Rule ID 9551 //
     /*  207475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  207489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  207492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  207514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207531 */     GIR_RootConstrainSelectedInstOperands,
     /*  207532 */     // GIR_Coverage, 9551,
     /*  207532 */     GIR_EraseRootFromParent_Done,
     /*  207533 */   // Label 4443: @207533
     /*  207533 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(207596), // Rule ID 9554 //
     /*  207538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  207552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  207555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207577 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  207577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  207580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207594 */     GIR_RootConstrainSelectedInstOperands,
     /*  207595 */     // GIR_Coverage, 9554,
     /*  207595 */     GIR_EraseRootFromParent_Done,
     /*  207596 */   // Label 4444: @207596
     /*  207596 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(207659), // Rule ID 9555 //
     /*  207601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  207615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  207618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207640 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  207640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  207643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  207657 */     GIR_RootConstrainSelectedInstOperands,
     /*  207658 */     // GIR_Coverage, 9555,
     /*  207658 */     GIR_EraseRootFromParent_Done,
     /*  207659 */   // Label 4445: @207659
     /*  207659 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(207722), // Rule ID 9558 //
     /*  207664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  207678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  207681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207703 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  207703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  207706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  207720 */     GIR_RootConstrainSelectedInstOperands,
     /*  207721 */     // GIR_Coverage, 9558,
     /*  207721 */     GIR_EraseRootFromParent_Done,
     /*  207722 */   // Label 4446: @207722
     /*  207722 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(207785), // Rule ID 9559 //
     /*  207727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  207741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  207744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  207759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  207766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  207769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  207783 */     GIR_RootConstrainSelectedInstOperands,
     /*  207784 */     // GIR_Coverage, 9559,
     /*  207784 */     GIR_EraseRootFromParent_Done,
     /*  207785 */   // Label 4447: @207785
     /*  207785 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(207848), // Rule ID 9562 //
     /*  207790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  207804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  207807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207829 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  207829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  207846 */     GIR_RootConstrainSelectedInstOperands,
     /*  207847 */     // GIR_Coverage, 9562,
     /*  207847 */     GIR_EraseRootFromParent_Done,
     /*  207848 */   // Label 4448: @207848
     /*  207848 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(207911), // Rule ID 9563 //
     /*  207853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  207867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  207870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  207885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  207892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  207895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  207909 */     GIR_RootConstrainSelectedInstOperands,
     /*  207910 */     // GIR_Coverage, 9563,
     /*  207910 */     GIR_EraseRootFromParent_Done,
     /*  207911 */   // Label 4449: @207911
     /*  207911 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(207974), // Rule ID 9566 //
     /*  207916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  207919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  207930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  207933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  207936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  207948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  207955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  207958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  207962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  207964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  207972 */     GIR_RootConstrainSelectedInstOperands,
     /*  207973 */     // GIR_Coverage, 9566,
     /*  207973 */     GIR_EraseRootFromParent_Done,
     /*  207974 */   // Label 4450: @207974
     /*  207974 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(208037), // Rule ID 9567 //
     /*  207979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  207982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  207987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  207993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  207996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  207999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  208018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  208021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  208035 */     GIR_RootConstrainSelectedInstOperands,
     /*  208036 */     // GIR_Coverage, 9567,
     /*  208036 */     GIR_EraseRootFromParent_Done,
     /*  208037 */   // Label 4451: @208037
     /*  208037 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(208100), // Rule ID 9570 //
     /*  208042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  208045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  208056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  208059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  208070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  208074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208081 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  208081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  208084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208098 */     GIR_RootConstrainSelectedInstOperands,
     /*  208099 */     // GIR_Coverage, 9570,
     /*  208099 */     GIR_EraseRootFromParent_Done,
     /*  208100 */   // Label 4452: @208100
     /*  208100 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(208163), // Rule ID 9571 //
     /*  208105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  208108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  208119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  208122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  208133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  208137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208144 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  208144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  208147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208161 */     GIR_RootConstrainSelectedInstOperands,
     /*  208162 */     // GIR_Coverage, 9571,
     /*  208162 */     GIR_EraseRootFromParent_Done,
     /*  208163 */   // Label 4453: @208163
     /*  208163 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(208226), // Rule ID 9574 //
     /*  208168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  208171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  208182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  208185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  208196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  208200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  208207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  208210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208224 */     GIR_RootConstrainSelectedInstOperands,
     /*  208225 */     // GIR_Coverage, 9574,
     /*  208225 */     GIR_EraseRootFromParent_Done,
     /*  208226 */   // Label 4454: @208226
     /*  208226 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(208289), // Rule ID 9575 //
     /*  208231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  208234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  208245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  208248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  208259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  208263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  208270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  208273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208287 */     GIR_RootConstrainSelectedInstOperands,
     /*  208288 */     // GIR_Coverage, 9575,
     /*  208288 */     GIR_EraseRootFromParent_Done,
     /*  208289 */   // Label 4455: @208289
     /*  208289 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(208352), // Rule ID 9578 //
     /*  208294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  208297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  208308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  208311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208333 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  208333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  208336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208350 */     GIR_RootConstrainSelectedInstOperands,
     /*  208351 */     // GIR_Coverage, 9578,
     /*  208351 */     GIR_EraseRootFromParent_Done,
     /*  208352 */   // Label 4456: @208352
     /*  208352 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(208415), // Rule ID 9579 //
     /*  208357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  208360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  208365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  208371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  208374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  208389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208396 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  208396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  208399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  208413 */     GIR_RootConstrainSelectedInstOperands,
     /*  208414 */     // GIR_Coverage, 9579,
     /*  208414 */     GIR_EraseRootFromParent_Done,
     /*  208415 */   // Label 4457: @208415
     /*  208415 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(208478), // Rule ID 9582 //
     /*  208420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  208434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  208437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208459 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  208459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  208462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208476 */     GIR_RootConstrainSelectedInstOperands,
     /*  208477 */     // GIR_Coverage, 9582,
     /*  208477 */     GIR_EraseRootFromParent_Done,
     /*  208478 */   // Label 4458: @208478
     /*  208478 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(208541), // Rule ID 9583 //
     /*  208483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  208497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  208500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  208522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  208525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208539 */     GIR_RootConstrainSelectedInstOperands,
     /*  208540 */     // GIR_Coverage, 9583,
     /*  208540 */     GIR_EraseRootFromParent_Done,
     /*  208541 */   // Label 4459: @208541
     /*  208541 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(208604), // Rule ID 9586 //
     /*  208546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  208560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  208563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208585 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  208585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  208588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208602 */     GIR_RootConstrainSelectedInstOperands,
     /*  208603 */     // GIR_Coverage, 9586,
     /*  208603 */     GIR_EraseRootFromParent_Done,
     /*  208604 */   // Label 4460: @208604
     /*  208604 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(208667), // Rule ID 9587 //
     /*  208609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  208623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  208626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208648 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  208648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  208651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208665 */     GIR_RootConstrainSelectedInstOperands,
     /*  208666 */     // GIR_Coverage, 9587,
     /*  208666 */     GIR_EraseRootFromParent_Done,
     /*  208667 */   // Label 4461: @208667
     /*  208667 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(208730), // Rule ID 9590 //
     /*  208672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  208686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  208689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208711 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  208711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  208714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208728 */     GIR_RootConstrainSelectedInstOperands,
     /*  208729 */     // GIR_Coverage, 9590,
     /*  208729 */     GIR_EraseRootFromParent_Done,
     /*  208730 */   // Label 4462: @208730
     /*  208730 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(208793), // Rule ID 9591 //
     /*  208735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  208749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  208752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  208774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  208777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208791 */     GIR_RootConstrainSelectedInstOperands,
     /*  208792 */     // GIR_Coverage, 9591,
     /*  208792 */     GIR_EraseRootFromParent_Done,
     /*  208793 */   // Label 4463: @208793
     /*  208793 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(208856), // Rule ID 9594 //
     /*  208798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  208812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  208815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208837 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  208837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  208840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  208854 */     GIR_RootConstrainSelectedInstOperands,
     /*  208855 */     // GIR_Coverage, 9594,
     /*  208855 */     GIR_EraseRootFromParent_Done,
     /*  208856 */   // Label 4464: @208856
     /*  208856 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(208919), // Rule ID 9595 //
     /*  208861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  208875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  208878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  208881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  208900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  208903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  208917 */     GIR_RootConstrainSelectedInstOperands,
     /*  208918 */     // GIR_Coverage, 9595,
     /*  208918 */     GIR_EraseRootFromParent_Done,
     /*  208919 */   // Label 4465: @208919
     /*  208919 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(208982), // Rule ID 9598 //
     /*  208924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  208938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  208941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  208944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  208963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  208966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  208970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  208980 */     GIR_RootConstrainSelectedInstOperands,
     /*  208981 */     // GIR_Coverage, 9598,
     /*  208981 */     GIR_EraseRootFromParent_Done,
     /*  208982 */   // Label 4466: @208982
     /*  208982 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(209045), // Rule ID 9599 //
     /*  208987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  208995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  209001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  209004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  209026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  209029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  209043 */     GIR_RootConstrainSelectedInstOperands,
     /*  209044 */     // GIR_Coverage, 9599,
     /*  209044 */     GIR_EraseRootFromParent_Done,
     /*  209045 */   // Label 4467: @209045
     /*  209045 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(209108), // Rule ID 9602 //
     /*  209050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  209064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  209067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209089 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  209089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  209092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  209106 */     GIR_RootConstrainSelectedInstOperands,
     /*  209107 */     // GIR_Coverage, 9602,
     /*  209107 */     GIR_EraseRootFromParent_Done,
     /*  209108 */   // Label 4468: @209108
     /*  209108 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(209171), // Rule ID 9603 //
     /*  209113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  209127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  209130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  209152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  209155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  209169 */     GIR_RootConstrainSelectedInstOperands,
     /*  209170 */     // GIR_Coverage, 9603,
     /*  209170 */     GIR_EraseRootFromParent_Done,
     /*  209171 */   // Label 4469: @209171
     /*  209171 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(209234), // Rule ID 9606 //
     /*  209176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  209190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  209193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209215 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  209215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209232 */     GIR_RootConstrainSelectedInstOperands,
     /*  209233 */     // GIR_Coverage, 9606,
     /*  209233 */     GIR_EraseRootFromParent_Done,
     /*  209234 */   // Label 4470: @209234
     /*  209234 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(209297), // Rule ID 9607 //
     /*  209239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  209253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  209256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  209278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209295 */     GIR_RootConstrainSelectedInstOperands,
     /*  209296 */     // GIR_Coverage, 9607,
     /*  209296 */     GIR_EraseRootFromParent_Done,
     /*  209297 */   // Label 4471: @209297
     /*  209297 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(209360), // Rule ID 9610 //
     /*  209302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  209313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  209316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  209319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209341 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  209341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  209358 */     GIR_RootConstrainSelectedInstOperands,
     /*  209359 */     // GIR_Coverage, 9610,
     /*  209359 */     GIR_EraseRootFromParent_Done,
     /*  209360 */   // Label 4472: @209360
     /*  209360 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(209423), // Rule ID 9611 //
     /*  209365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  209376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  209379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  209382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  209404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  209421 */     GIR_RootConstrainSelectedInstOperands,
     /*  209422 */     // GIR_Coverage, 9611,
     /*  209422 */     GIR_EraseRootFromParent_Done,
     /*  209423 */   // Label 4473: @209423
     /*  209423 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(209486), // Rule ID 9614 //
     /*  209428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  209439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  209442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  209445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209467 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  209467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  209484 */     GIR_RootConstrainSelectedInstOperands,
     /*  209485 */     // GIR_Coverage, 9614,
     /*  209485 */     GIR_EraseRootFromParent_Done,
     /*  209486 */   // Label 4474: @209486
     /*  209486 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(209549), // Rule ID 9615 //
     /*  209491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  209502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  209505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  209508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  209530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  209547 */     GIR_RootConstrainSelectedInstOperands,
     /*  209548 */     // GIR_Coverage, 9615,
     /*  209548 */     GIR_EraseRootFromParent_Done,
     /*  209549 */   // Label 4475: @209549
     /*  209549 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(209612), // Rule ID 9618 //
     /*  209554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  209557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  209568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  209571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209593 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  209593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  209610 */     GIR_RootConstrainSelectedInstOperands,
     /*  209611 */     // GIR_Coverage, 9618,
     /*  209611 */     GIR_EraseRootFromParent_Done,
     /*  209612 */   // Label 4476: @209612
     /*  209612 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(209675), // Rule ID 9619 //
     /*  209617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  209620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  209631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  209634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  209656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  209659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  209673 */     GIR_RootConstrainSelectedInstOperands,
     /*  209674 */     // GIR_Coverage, 9619,
     /*  209674 */     GIR_EraseRootFromParent_Done,
     /*  209675 */   // Label 4477: @209675
     /*  209675 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(209738), // Rule ID 9622 //
     /*  209680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  209694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  209697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  209708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  209712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209719 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  209719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  209722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209736 */     GIR_RootConstrainSelectedInstOperands,
     /*  209737 */     // GIR_Coverage, 9622,
     /*  209737 */     GIR_EraseRootFromParent_Done,
     /*  209738 */   // Label 4478: @209738
     /*  209738 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(209801), // Rule ID 9623 //
     /*  209743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  209757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  209760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  209771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  209775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  209782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  209785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209799 */     GIR_RootConstrainSelectedInstOperands,
     /*  209800 */     // GIR_Coverage, 9623,
     /*  209800 */     GIR_EraseRootFromParent_Done,
     /*  209801 */   // Label 4479: @209801
     /*  209801 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(209864), // Rule ID 9626 //
     /*  209806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  209820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  209823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  209834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  209838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209845 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  209845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  209848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209862 */     GIR_RootConstrainSelectedInstOperands,
     /*  209863 */     // GIR_Coverage, 9626,
     /*  209863 */     GIR_EraseRootFromParent_Done,
     /*  209864 */   // Label 4480: @209864
     /*  209864 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(209927), // Rule ID 9627 //
     /*  209869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  209883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  209886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  209889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  209897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  209901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209908 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  209908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  209911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209925 */     GIR_RootConstrainSelectedInstOperands,
     /*  209926 */     // GIR_Coverage, 9627,
     /*  209926 */     GIR_EraseRootFromParent_Done,
     /*  209927 */   // Label 4481: @209927
     /*  209927 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(209990), // Rule ID 9630 //
     /*  209932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  209940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  209943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  209946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  209949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  209952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  209960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  209964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209971 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  209971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  209974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  209978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209988 */     GIR_RootConstrainSelectedInstOperands,
     /*  209989 */     // GIR_Coverage, 9630,
     /*  209989 */     GIR_EraseRootFromParent_Done,
     /*  209990 */   // Label 4482: @209990
     /*  209990 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(210053), // Rule ID 9631 //
     /*  209995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  210006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  210009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  210012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210034 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  210034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  210037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  210051 */     GIR_RootConstrainSelectedInstOperands,
     /*  210052 */     // GIR_Coverage, 9631,
     /*  210052 */     GIR_EraseRootFromParent_Done,
     /*  210053 */   // Label 4483: @210053
     /*  210053 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(210116), // Rule ID 9634 //
     /*  210058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  210072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  210075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210097 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  210097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210114 */     GIR_RootConstrainSelectedInstOperands,
     /*  210115 */     // GIR_Coverage, 9634,
     /*  210115 */     GIR_EraseRootFromParent_Done,
     /*  210116 */   // Label 4484: @210116
     /*  210116 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(210179), // Rule ID 9635 //
     /*  210121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  210135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  210138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  210160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210177 */     GIR_RootConstrainSelectedInstOperands,
     /*  210178 */     // GIR_Coverage, 9635,
     /*  210178 */     GIR_EraseRootFromParent_Done,
     /*  210179 */   // Label 4485: @210179
     /*  210179 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(210242), // Rule ID 9638 //
     /*  210184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  210198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  210201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210223 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  210223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  210226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210240 */     GIR_RootConstrainSelectedInstOperands,
     /*  210241 */     // GIR_Coverage, 9638,
     /*  210241 */     GIR_EraseRootFromParent_Done,
     /*  210242 */   // Label 4486: @210242
     /*  210242 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(210305), // Rule ID 9639 //
     /*  210247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  210261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  210264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  210286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  210289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210303 */     GIR_RootConstrainSelectedInstOperands,
     /*  210304 */     // GIR_Coverage, 9639,
     /*  210304 */     GIR_EraseRootFromParent_Done,
     /*  210305 */   // Label 4487: @210305
     /*  210305 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(210368), // Rule ID 9642 //
     /*  210310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  210321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  210324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  210327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210349 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  210349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  210352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210366 */     GIR_RootConstrainSelectedInstOperands,
     /*  210367 */     // GIR_Coverage, 9642,
     /*  210367 */     GIR_EraseRootFromParent_Done,
     /*  210368 */   // Label 4488: @210368
     /*  210368 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(210431), // Rule ID 9643 //
     /*  210373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  210384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  210387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  210390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210412 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  210412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  210415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  210429 */     GIR_RootConstrainSelectedInstOperands,
     /*  210430 */     // GIR_Coverage, 9643,
     /*  210430 */     GIR_EraseRootFromParent_Done,
     /*  210431 */   // Label 4489: @210431
     /*  210431 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(210494), // Rule ID 9646 //
     /*  210436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  210447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  210450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  210453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210475 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  210475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210492 */     GIR_RootConstrainSelectedInstOperands,
     /*  210493 */     // GIR_Coverage, 9646,
     /*  210493 */     GIR_EraseRootFromParent_Done,
     /*  210494 */   // Label 4490: @210494
     /*  210494 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(210557), // Rule ID 9647 //
     /*  210499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  210510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  210513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  210516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210538 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  210538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210555 */     GIR_RootConstrainSelectedInstOperands,
     /*  210556 */     // GIR_Coverage, 9647,
     /*  210556 */     GIR_EraseRootFromParent_Done,
     /*  210557 */   // Label 4491: @210557
     /*  210557 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(210620), // Rule ID 9650 //
     /*  210562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  210576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  210579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210601 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  210601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  210604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210618 */     GIR_RootConstrainSelectedInstOperands,
     /*  210619 */     // GIR_Coverage, 9650,
     /*  210619 */     GIR_EraseRootFromParent_Done,
     /*  210620 */   // Label 4492: @210620
     /*  210620 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(210683), // Rule ID 9651 //
     /*  210625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  210639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  210642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  210664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  210667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210681 */     GIR_RootConstrainSelectedInstOperands,
     /*  210682 */     // GIR_Coverage, 9651,
     /*  210682 */     GIR_EraseRootFromParent_Done,
     /*  210683 */   // Label 4493: @210683
     /*  210683 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(210746), // Rule ID 9654 //
     /*  210688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  210691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  210702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  210705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210727 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  210727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  210730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210744 */     GIR_RootConstrainSelectedInstOperands,
     /*  210745 */     // GIR_Coverage, 9654,
     /*  210745 */     GIR_EraseRootFromParent_Done,
     /*  210746 */   // Label 4494: @210746
     /*  210746 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(210809), // Rule ID 9655 //
     /*  210751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  210754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  210765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  210768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  210783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  210790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  210793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  210807 */     GIR_RootConstrainSelectedInstOperands,
     /*  210808 */     // GIR_Coverage, 9655,
     /*  210808 */     GIR_EraseRootFromParent_Done,
     /*  210809 */   // Label 4495: @210809
     /*  210809 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(210872), // Rule ID 9658 //
     /*  210814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  210817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  210828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  210831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210853 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  210853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  210870 */     GIR_RootConstrainSelectedInstOperands,
     /*  210871 */     // GIR_Coverage, 9658,
     /*  210871 */     GIR_EraseRootFromParent_Done,
     /*  210872 */   // Label 4496: @210872
     /*  210872 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(210935), // Rule ID 9659 //
     /*  210877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  210880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  210891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  210894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  210897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  210909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  210916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  210919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  210933 */     GIR_RootConstrainSelectedInstOperands,
     /*  210934 */     // GIR_Coverage, 9659,
     /*  210934 */     GIR_EraseRootFromParent_Done,
     /*  210935 */   // Label 4497: @210935
     /*  210935 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(210998), // Rule ID 9662 //
     /*  210940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  210943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  210948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  210951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  210954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  210957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  210960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  210972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  210979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  210982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  210986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  210996 */     GIR_RootConstrainSelectedInstOperands,
     /*  210997 */     // GIR_Coverage, 9662,
     /*  210997 */     GIR_EraseRootFromParent_Done,
     /*  210998 */   // Label 4498: @210998
     /*  210998 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(211061), // Rule ID 9663 //
     /*  211003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  211006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  211011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  211017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  211020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  211031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  211035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  211042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  211045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  211059 */     GIR_RootConstrainSelectedInstOperands,
     /*  211060 */     // GIR_Coverage, 9663,
     /*  211060 */     GIR_EraseRootFromParent_Done,
     /*  211061 */   // Label 4499: @211061
     /*  211061 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(211124), // Rule ID 9666 //
     /*  211066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  211069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  211074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  211080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  211083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  211094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  211098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211105 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  211105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  211108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  211122 */     GIR_RootConstrainSelectedInstOperands,
     /*  211123 */     // GIR_Coverage, 9666,
     /*  211123 */     GIR_EraseRootFromParent_Done,
     /*  211124 */   // Label 4500: @211124
     /*  211124 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(211187), // Rule ID 9667 //
     /*  211129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  211132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  211137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  211143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  211146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  211157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  211161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  211168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  211171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  211185 */     GIR_RootConstrainSelectedInstOperands,
     /*  211186 */     // GIR_Coverage, 9667,
     /*  211186 */     GIR_EraseRootFromParent_Done,
     /*  211187 */   // Label 4501: @211187
     /*  211187 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(211250), // Rule ID 9670 //
     /*  211192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  211206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  211209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211231 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  211231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  211234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211248 */     GIR_RootConstrainSelectedInstOperands,
     /*  211249 */     // GIR_Coverage, 9670,
     /*  211249 */     GIR_EraseRootFromParent_Done,
     /*  211250 */   // Label 4502: @211250
     /*  211250 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(211313), // Rule ID 9671 //
     /*  211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  211269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  211272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  211294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  211297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211311 */     GIR_RootConstrainSelectedInstOperands,
     /*  211312 */     // GIR_Coverage, 9671,
     /*  211312 */     GIR_EraseRootFromParent_Done,
     /*  211313 */   // Label 4503: @211313
     /*  211313 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(211376), // Rule ID 9674 //
     /*  211318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  211332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  211335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211357 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  211357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  211360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211374 */     GIR_RootConstrainSelectedInstOperands,
     /*  211375 */     // GIR_Coverage, 9674,
     /*  211375 */     GIR_EraseRootFromParent_Done,
     /*  211376 */   // Label 4504: @211376
     /*  211376 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(211439), // Rule ID 9675 //
     /*  211381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  211395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  211398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  211420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  211423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211437 */     GIR_RootConstrainSelectedInstOperands,
     /*  211438 */     // GIR_Coverage, 9675,
     /*  211438 */     GIR_EraseRootFromParent_Done,
     /*  211439 */   // Label 4505: @211439
     /*  211439 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(211502), // Rule ID 9678 //
     /*  211444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  211458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  211461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211483 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  211483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211500 */     GIR_RootConstrainSelectedInstOperands,
     /*  211501 */     // GIR_Coverage, 9678,
     /*  211501 */     GIR_EraseRootFromParent_Done,
     /*  211502 */   // Label 4506: @211502
     /*  211502 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(211565), // Rule ID 9679 //
     /*  211507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  211521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  211524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  211546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211563 */     GIR_RootConstrainSelectedInstOperands,
     /*  211564 */     // GIR_Coverage, 9679,
     /*  211564 */     GIR_EraseRootFromParent_Done,
     /*  211565 */   // Label 4507: @211565
     /*  211565 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(211628), // Rule ID 9682 //
     /*  211570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  211584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  211587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  211609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  211612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  211626 */     GIR_RootConstrainSelectedInstOperands,
     /*  211627 */     // GIR_Coverage, 9682,
     /*  211627 */     GIR_EraseRootFromParent_Done,
     /*  211628 */   // Label 4508: @211628
     /*  211628 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(211691), // Rule ID 9683 //
     /*  211633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  211647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  211650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  211672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  211675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  211689 */     GIR_RootConstrainSelectedInstOperands,
     /*  211690 */     // GIR_Coverage, 9683,
     /*  211690 */     GIR_EraseRootFromParent_Done,
     /*  211691 */   // Label 4509: @211691
     /*  211691 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(211754), // Rule ID 9686 //
     /*  211696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  211710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  211713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  211735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  211752 */     GIR_RootConstrainSelectedInstOperands,
     /*  211753 */     // GIR_Coverage, 9686,
     /*  211753 */     GIR_EraseRootFromParent_Done,
     /*  211754 */   // Label 4510: @211754
     /*  211754 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(211817), // Rule ID 9687 //
     /*  211759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  211773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  211776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211798 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  211798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  211815 */     GIR_RootConstrainSelectedInstOperands,
     /*  211816 */     // GIR_Coverage, 9687,
     /*  211816 */     GIR_EraseRootFromParent_Done,
     /*  211817 */   // Label 4511: @211817
     /*  211817 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(211880), // Rule ID 9690 //
     /*  211822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  211836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  211839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211861 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  211861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  211878 */     GIR_RootConstrainSelectedInstOperands,
     /*  211879 */     // GIR_Coverage, 9690,
     /*  211879 */     GIR_EraseRootFromParent_Done,
     /*  211880 */   // Label 4512: @211880
     /*  211880 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(211943), // Rule ID 9691 //
     /*  211885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  211888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  211899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  211902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  211905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  211924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  211927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  211941 */     GIR_RootConstrainSelectedInstOperands,
     /*  211942 */     // GIR_Coverage, 9691,
     /*  211942 */     GIR_EraseRootFromParent_Done,
     /*  211943 */   // Label 4513: @211943
     /*  211943 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(212006), // Rule ID 9694 //
     /*  211948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  211951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  211956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  211962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  211965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  211968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211987 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  211987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  211990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  211994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212004 */     GIR_RootConstrainSelectedInstOperands,
     /*  212005 */     // GIR_Coverage, 9694,
     /*  212005 */     GIR_EraseRootFromParent_Done,
     /*  212006 */   // Label 4514: @212006
     /*  212006 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(212069), // Rule ID 9695 //
     /*  212011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  212025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  212028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  212050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212067 */     GIR_RootConstrainSelectedInstOperands,
     /*  212068 */     // GIR_Coverage, 9695,
     /*  212068 */     GIR_EraseRootFromParent_Done,
     /*  212069 */   // Label 4515: @212069
     /*  212069 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(212132), // Rule ID 9698 //
     /*  212074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  212088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  212091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212113 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  212113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212130 */     GIR_RootConstrainSelectedInstOperands,
     /*  212131 */     // GIR_Coverage, 9698,
     /*  212131 */     GIR_EraseRootFromParent_Done,
     /*  212132 */   // Label 4516: @212132
     /*  212132 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(212195), // Rule ID 9699 //
     /*  212137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  212151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  212154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  212176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212193 */     GIR_RootConstrainSelectedInstOperands,
     /*  212194 */     // GIR_Coverage, 9699,
     /*  212194 */     GIR_EraseRootFromParent_Done,
     /*  212195 */   // Label 4517: @212195
     /*  212195 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(212258), // Rule ID 9702 //
     /*  212200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  212214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  212217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  212239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  212256 */     GIR_RootConstrainSelectedInstOperands,
     /*  212257 */     // GIR_Coverage, 9702,
     /*  212257 */     GIR_EraseRootFromParent_Done,
     /*  212258 */   // Label 4518: @212258
     /*  212258 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(212321), // Rule ID 9703 //
     /*  212263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  212277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  212280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  212302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  212319 */     GIR_RootConstrainSelectedInstOperands,
     /*  212320 */     // GIR_Coverage, 9703,
     /*  212320 */     GIR_EraseRootFromParent_Done,
     /*  212321 */   // Label 4519: @212321
     /*  212321 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(212384), // Rule ID 9706 //
     /*  212326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  212329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  212340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  212343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212365 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  212365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  212382 */     GIR_RootConstrainSelectedInstOperands,
     /*  212383 */     // GIR_Coverage, 9706,
     /*  212383 */     GIR_EraseRootFromParent_Done,
     /*  212384 */   // Label 4520: @212384
     /*  212384 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(212447), // Rule ID 9707 //
     /*  212389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  212392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  212403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  212406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  212428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  212431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  212445 */     GIR_RootConstrainSelectedInstOperands,
     /*  212446 */     // GIR_Coverage, 9707,
     /*  212446 */     GIR_EraseRootFromParent_Done,
     /*  212447 */   // Label 4521: @212447
     /*  212447 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(212510), // Rule ID 9710 //
     /*  212452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  212466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  212469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212491 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  212491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  212494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212508 */     GIR_RootConstrainSelectedInstOperands,
     /*  212509 */     // GIR_Coverage, 9710,
     /*  212509 */     GIR_EraseRootFromParent_Done,
     /*  212510 */   // Label 4522: @212510
     /*  212510 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(212573), // Rule ID 9711 //
     /*  212515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  212529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  212532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  212554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  212557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212571 */     GIR_RootConstrainSelectedInstOperands,
     /*  212572 */     // GIR_Coverage, 9711,
     /*  212572 */     GIR_EraseRootFromParent_Done,
     /*  212573 */   // Label 4523: @212573
     /*  212573 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(212636), // Rule ID 9714 //
     /*  212578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  212592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  212595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212617 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  212617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  212620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212634 */     GIR_RootConstrainSelectedInstOperands,
     /*  212635 */     // GIR_Coverage, 9714,
     /*  212635 */     GIR_EraseRootFromParent_Done,
     /*  212636 */   // Label 4524: @212636
     /*  212636 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(212699), // Rule ID 9715 //
     /*  212641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  212655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  212658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212680 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  212680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  212683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212697 */     GIR_RootConstrainSelectedInstOperands,
     /*  212698 */     // GIR_Coverage, 9715,
     /*  212698 */     GIR_EraseRootFromParent_Done,
     /*  212699 */   // Label 4525: @212699
     /*  212699 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(212762), // Rule ID 9718 //
     /*  212704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  212718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  212721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  212732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  212736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212743 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  212743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  212746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212760 */     GIR_RootConstrainSelectedInstOperands,
     /*  212761 */     // GIR_Coverage, 9718,
     /*  212761 */     GIR_EraseRootFromParent_Done,
     /*  212762 */   // Label 4526: @212762
     /*  212762 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(212825), // Rule ID 9719 //
     /*  212767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  212781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  212784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  212795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  212799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212806 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  212806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  212809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212823 */     GIR_RootConstrainSelectedInstOperands,
     /*  212824 */     // GIR_Coverage, 9719,
     /*  212824 */     GIR_EraseRootFromParent_Done,
     /*  212825 */   // Label 4527: @212825
     /*  212825 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(212888), // Rule ID 9722 //
     /*  212830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  212844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  212847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212869 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  212869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  212872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212886 */     GIR_RootConstrainSelectedInstOperands,
     /*  212887 */     // GIR_Coverage, 9722,
     /*  212887 */     GIR_EraseRootFromParent_Done,
     /*  212888 */   // Label 4528: @212888
     /*  212888 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(212951), // Rule ID 9723 //
     /*  212893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  212907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  212910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  212913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  212925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  212932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  212935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  212939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212949 */     GIR_RootConstrainSelectedInstOperands,
     /*  212950 */     // GIR_Coverage, 9723,
     /*  212950 */     GIR_EraseRootFromParent_Done,
     /*  212951 */   // Label 4529: @212951
     /*  212951 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(213014), // Rule ID 9726 //
     /*  212956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  212964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  212970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  212973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  212976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  212988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  212995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  212998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213012 */     GIR_RootConstrainSelectedInstOperands,
     /*  213013 */     // GIR_Coverage, 9726,
     /*  213013 */     GIR_EraseRootFromParent_Done,
     /*  213014 */   // Label 4530: @213014
     /*  213014 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(213077), // Rule ID 9727 //
     /*  213019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  213033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  213036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  213058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  213061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213075 */     GIR_RootConstrainSelectedInstOperands,
     /*  213076 */     // GIR_Coverage, 9727,
     /*  213076 */     GIR_EraseRootFromParent_Done,
     /*  213077 */   // Label 4531: @213077
     /*  213077 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(213140), // Rule ID 9730 //
     /*  213082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  213096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  213099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213121 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  213121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213138 */     GIR_RootConstrainSelectedInstOperands,
     /*  213139 */     // GIR_Coverage, 9730,
     /*  213139 */     GIR_EraseRootFromParent_Done,
     /*  213140 */   // Label 4532: @213140
     /*  213140 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(213203), // Rule ID 9731 //
     /*  213145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  213159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  213162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  213184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213201 */     GIR_RootConstrainSelectedInstOperands,
     /*  213202 */     // GIR_Coverage, 9731,
     /*  213202 */     GIR_EraseRootFromParent_Done,
     /*  213203 */   // Label 4533: @213203
     /*  213203 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(213266), // Rule ID 9734 //
     /*  213208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  213222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  213225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  213247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  213250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213264 */     GIR_RootConstrainSelectedInstOperands,
     /*  213265 */     // GIR_Coverage, 9734,
     /*  213265 */     GIR_EraseRootFromParent_Done,
     /*  213266 */   // Label 4534: @213266
     /*  213266 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(213329), // Rule ID 9735 //
     /*  213271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  213285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  213288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  213310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  213313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213327 */     GIR_RootConstrainSelectedInstOperands,
     /*  213328 */     // GIR_Coverage, 9735,
     /*  213328 */     GIR_EraseRootFromParent_Done,
     /*  213329 */   // Label 4535: @213329
     /*  213329 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(213392), // Rule ID 9738 //
     /*  213334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  213348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  213351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213373 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  213373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  213376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213390 */     GIR_RootConstrainSelectedInstOperands,
     /*  213391 */     // GIR_Coverage, 9738,
     /*  213391 */     GIR_EraseRootFromParent_Done,
     /*  213392 */   // Label 4536: @213392
     /*  213392 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(213455), // Rule ID 9739 //
     /*  213397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  213411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  213414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  213436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  213439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213453 */     GIR_RootConstrainSelectedInstOperands,
     /*  213454 */     // GIR_Coverage, 9739,
     /*  213454 */     GIR_EraseRootFromParent_Done,
     /*  213455 */   // Label 4537: @213455
     /*  213455 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(213518), // Rule ID 9742 //
     /*  213460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  213474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  213477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213499 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  213499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213516 */     GIR_RootConstrainSelectedInstOperands,
     /*  213517 */     // GIR_Coverage, 9742,
     /*  213517 */     GIR_EraseRootFromParent_Done,
     /*  213518 */   // Label 4538: @213518
     /*  213518 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(213581), // Rule ID 9743 //
     /*  213523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  213537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  213540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  213562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213579 */     GIR_RootConstrainSelectedInstOperands,
     /*  213580 */     // GIR_Coverage, 9743,
     /*  213580 */     GIR_EraseRootFromParent_Done,
     /*  213581 */   // Label 4539: @213581
     /*  213581 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(213644), // Rule ID 9746 //
     /*  213586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  213589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  213597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  213600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  213603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213625 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  213625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  213628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213642 */     GIR_RootConstrainSelectedInstOperands,
     /*  213643 */     // GIR_Coverage, 9746,
     /*  213643 */     GIR_EraseRootFromParent_Done,
     /*  213644 */   // Label 4540: @213644
     /*  213644 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(213707), // Rule ID 9747 //
     /*  213649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  213652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  213660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  213663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  213666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  213688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  213691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213705 */     GIR_RootConstrainSelectedInstOperands,
     /*  213706 */     // GIR_Coverage, 9747,
     /*  213706 */     GIR_EraseRootFromParent_Done,
     /*  213707 */   // Label 4541: @213707
     /*  213707 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(213770), // Rule ID 9750 //
     /*  213712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  213715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  213726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  213729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213751 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  213751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  213754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213768 */     GIR_RootConstrainSelectedInstOperands,
     /*  213769 */     // GIR_Coverage, 9750,
     /*  213769 */     GIR_EraseRootFromParent_Done,
     /*  213770 */   // Label 4542: @213770
     /*  213770 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(213833), // Rule ID 9751 //
     /*  213775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  213778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  213789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  213792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213814 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  213814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  213817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213831 */     GIR_RootConstrainSelectedInstOperands,
     /*  213832 */     // GIR_Coverage, 9751,
     /*  213832 */     GIR_EraseRootFromParent_Done,
     /*  213833 */   // Label 4543: @213833
     /*  213833 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(213896), // Rule ID 9754 //
     /*  213838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  213841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  213852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  213855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213877 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  213877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213894 */     GIR_RootConstrainSelectedInstOperands,
     /*  213895 */     // GIR_Coverage, 9754,
     /*  213895 */     GIR_EraseRootFromParent_Done,
     /*  213896 */   // Label 4544: @213896
     /*  213896 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(213959), // Rule ID 9755 //
     /*  213901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  213904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  213909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  213915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  213918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  213921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  213940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  213943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  213947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213957 */     GIR_RootConstrainSelectedInstOperands,
     /*  213958 */     // GIR_Coverage, 9755,
     /*  213958 */     GIR_EraseRootFromParent_Done,
     /*  213959 */   // Label 4545: @213959
     /*  213959 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(214025), // Rule ID 13830 //
     /*  213964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  213972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  213975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  213978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  213981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  213984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214003 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  214006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214023 */     GIR_RootConstrainSelectedInstOperands,
     /*  214024 */     // GIR_Coverage, 13830,
     /*  214024 */     GIR_EraseRootFromParent_Done,
     /*  214025 */   // Label 4546: @214025
     /*  214025 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(214091), // Rule ID 13831 //
     /*  214030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  214041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  214044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  214047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214069 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  214072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214089 */     GIR_RootConstrainSelectedInstOperands,
     /*  214090 */     // GIR_Coverage, 13831,
     /*  214090 */     GIR_EraseRootFromParent_Done,
     /*  214091 */   // Label 4547: @214091
     /*  214091 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(214157), // Rule ID 13832 //
     /*  214096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  214107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  214110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  214113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214135 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  214138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214155 */     GIR_RootConstrainSelectedInstOperands,
     /*  214156 */     // GIR_Coverage, 13832,
     /*  214156 */     GIR_EraseRootFromParent_Done,
     /*  214157 */   // Label 4548: @214157
     /*  214157 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(214223), // Rule ID 13833 //
     /*  214162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  214173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  214176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  214179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214201 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  214204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214221 */     GIR_RootConstrainSelectedInstOperands,
     /*  214222 */     // GIR_Coverage, 13833,
     /*  214222 */     GIR_EraseRootFromParent_Done,
     /*  214223 */   // Label 4549: @214223
     /*  214223 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(214289), // Rule ID 13834 //
     /*  214228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  214239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  214242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  214245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214267 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214287 */     GIR_RootConstrainSelectedInstOperands,
     /*  214288 */     // GIR_Coverage, 13834,
     /*  214288 */     GIR_EraseRootFromParent_Done,
     /*  214289 */   // Label 4550: @214289
     /*  214289 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(214355), // Rule ID 13835 //
     /*  214294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  214305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  214308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  214311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214333 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214353 */     GIR_RootConstrainSelectedInstOperands,
     /*  214354 */     // GIR_Coverage, 13835,
     /*  214354 */     GIR_EraseRootFromParent_Done,
     /*  214355 */   // Label 4551: @214355
     /*  214355 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(214421), // Rule ID 13836 //
     /*  214360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  214371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  214374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  214377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214399 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  214402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214419 */     GIR_RootConstrainSelectedInstOperands,
     /*  214420 */     // GIR_Coverage, 13836,
     /*  214420 */     GIR_EraseRootFromParent_Done,
     /*  214421 */   // Label 4552: @214421
     /*  214421 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(214487), // Rule ID 13837 //
     /*  214426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  214437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  214440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  214443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  214468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214485 */     GIR_RootConstrainSelectedInstOperands,
     /*  214486 */     // GIR_Coverage, 13837,
     /*  214486 */     GIR_EraseRootFromParent_Done,
     /*  214487 */   // Label 4553: @214487
     /*  214487 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(214553), // Rule ID 13838 //
     /*  214492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  214503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  214506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  214509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214531 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214551 */     GIR_RootConstrainSelectedInstOperands,
     /*  214552 */     // GIR_Coverage, 13838,
     /*  214552 */     GIR_EraseRootFromParent_Done,
     /*  214553 */   // Label 4554: @214553
     /*  214553 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(214619), // Rule ID 13839 //
     /*  214558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  214569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  214572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  214575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214597 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214617 */     GIR_RootConstrainSelectedInstOperands,
     /*  214618 */     // GIR_Coverage, 13839,
     /*  214618 */     GIR_EraseRootFromParent_Done,
     /*  214619 */   // Label 4555: @214619
     /*  214619 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(214685), // Rule ID 13840 //
     /*  214624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  214641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214663 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214683 */     GIR_RootConstrainSelectedInstOperands,
     /*  214684 */     // GIR_Coverage, 13840,
     /*  214684 */     GIR_EraseRootFromParent_Done,
     /*  214685 */   // Label 4556: @214685
     /*  214685 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(214751), // Rule ID 13841 //
     /*  214690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  214707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  214732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214749 */     GIR_RootConstrainSelectedInstOperands,
     /*  214750 */     // GIR_Coverage, 13841,
     /*  214750 */     GIR_EraseRootFromParent_Done,
     /*  214751 */   // Label 4557: @214751
     /*  214751 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(214817), // Rule ID 13842 //
     /*  214756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  214773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  214798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214815 */     GIR_RootConstrainSelectedInstOperands,
     /*  214816 */     // GIR_Coverage, 13842,
     /*  214816 */     GIR_EraseRootFromParent_Done,
     /*  214817 */   // Label 4558: @214817
     /*  214817 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(214883), // Rule ID 13843 //
     /*  214822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  214839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214861 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  214864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214881 */     GIR_RootConstrainSelectedInstOperands,
     /*  214882 */     // GIR_Coverage, 13843,
     /*  214882 */     GIR_EraseRootFromParent_Done,
     /*  214883 */   // Label 4559: @214883
     /*  214883 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(214949), // Rule ID 13844 //
     /*  214888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  214905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  214908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  214930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  214936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214947 */     GIR_RootConstrainSelectedInstOperands,
     /*  214948 */     // GIR_Coverage, 13844,
     /*  214948 */     GIR_EraseRootFromParent_Done,
     /*  214949 */   // Label 4560: @214949
     /*  214949 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(215015), // Rule ID 13845 //
     /*  214954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  214962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  214971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  214974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  214996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215013 */     GIR_RootConstrainSelectedInstOperands,
     /*  215014 */     // GIR_Coverage, 13845,
     /*  215014 */     GIR_EraseRootFromParent_Done,
     /*  215015 */   // Label 4561: @215015
     /*  215015 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(215081), // Rule ID 13846 //
     /*  215020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  215031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  215034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  215037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  215062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215079 */     GIR_RootConstrainSelectedInstOperands,
     /*  215080 */     // GIR_Coverage, 13846,
     /*  215080 */     GIR_EraseRootFromParent_Done,
     /*  215081 */   // Label 4562: @215081
     /*  215081 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(215147), // Rule ID 13847 //
     /*  215086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  215097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  215100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  215103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215125 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  215128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215145 */     GIR_RootConstrainSelectedInstOperands,
     /*  215146 */     // GIR_Coverage, 13847,
     /*  215146 */     GIR_EraseRootFromParent_Done,
     /*  215147 */   // Label 4563: @215147
     /*  215147 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(215213), // Rule ID 13848 //
     /*  215152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  215163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  215166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  215169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215191 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  215194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215211 */     GIR_RootConstrainSelectedInstOperands,
     /*  215212 */     // GIR_Coverage, 13848,
     /*  215212 */     GIR_EraseRootFromParent_Done,
     /*  215213 */   // Label 4564: @215213
     /*  215213 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(215279), // Rule ID 13849 //
     /*  215218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  215229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  215232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  215235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215257 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  215260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215277 */     GIR_RootConstrainSelectedInstOperands,
     /*  215278 */     // GIR_Coverage, 13849,
     /*  215278 */     GIR_EraseRootFromParent_Done,
     /*  215279 */   // Label 4565: @215279
     /*  215279 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(215345), // Rule ID 13850 //
     /*  215284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  215295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  215298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  215301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  215323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  215326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215343 */     GIR_RootConstrainSelectedInstOperands,
     /*  215344 */     // GIR_Coverage, 13850,
     /*  215344 */     GIR_EraseRootFromParent_Done,
     /*  215345 */   // Label 4566: @215345
     /*  215345 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(215411), // Rule ID 13851 //
     /*  215350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  215361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  215364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  215367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215389 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  215389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  215392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215409 */     GIR_RootConstrainSelectedInstOperands,
     /*  215410 */     // GIR_Coverage, 13851,
     /*  215410 */     GIR_EraseRootFromParent_Done,
     /*  215411 */   // Label 4567: @215411
     /*  215411 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(215477), // Rule ID 13852 //
     /*  215416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  215427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  215430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  215433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215455 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  215455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  215458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215475 */     GIR_RootConstrainSelectedInstOperands,
     /*  215476 */     // GIR_Coverage, 13852,
     /*  215476 */     GIR_EraseRootFromParent_Done,
     /*  215477 */   // Label 4568: @215477
     /*  215477 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(215543), // Rule ID 13853 //
     /*  215482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  215493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  215496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  215499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  215521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  215524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215541 */     GIR_RootConstrainSelectedInstOperands,
     /*  215542 */     // GIR_Coverage, 13853,
     /*  215542 */     GIR_EraseRootFromParent_Done,
     /*  215543 */   // Label 4569: @215543
     /*  215543 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(215609), // Rule ID 13854 //
     /*  215548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  215559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  215562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  215565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215587 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  215587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  215590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215607 */     GIR_RootConstrainSelectedInstOperands,
     /*  215608 */     // GIR_Coverage, 13854,
     /*  215608 */     GIR_EraseRootFromParent_Done,
     /*  215609 */   // Label 4570: @215609
     /*  215609 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(215675), // Rule ID 13855 //
     /*  215614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  215625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  215628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  215631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215653 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  215653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  215656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  215670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215673 */     GIR_RootConstrainSelectedInstOperands,
     /*  215674 */     // GIR_Coverage, 13855,
     /*  215674 */     GIR_EraseRootFromParent_Done,
     /*  215675 */   // Label 4571: @215675
     /*  215675 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(215741), // Rule ID 13856 //
     /*  215680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  215691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  215694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  215697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  215722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215739 */     GIR_RootConstrainSelectedInstOperands,
     /*  215740 */     // GIR_Coverage, 13856,
     /*  215740 */     GIR_EraseRootFromParent_Done,
     /*  215741 */   // Label 4572: @215741
     /*  215741 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(215807), // Rule ID 13857 //
     /*  215746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  215757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  215760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  215763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  215788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215805 */     GIR_RootConstrainSelectedInstOperands,
     /*  215806 */     // GIR_Coverage, 13857,
     /*  215806 */     GIR_EraseRootFromParent_Done,
     /*  215807 */   // Label 4573: @215807
     /*  215807 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(215873), // Rule ID 13858 //
     /*  215812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  215829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215851 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  215854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215871 */     GIR_RootConstrainSelectedInstOperands,
     /*  215872 */     // GIR_Coverage, 13858,
     /*  215872 */     GIR_EraseRootFromParent_Done,
     /*  215873 */   // Label 4574: @215873
     /*  215873 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(215939), // Rule ID 13859 //
     /*  215878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  215895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  215898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  215920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215937 */     GIR_RootConstrainSelectedInstOperands,
     /*  215938 */     // GIR_Coverage, 13859,
     /*  215938 */     GIR_EraseRootFromParent_Done,
     /*  215939 */   // Label 4575: @215939
     /*  215939 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(216005), // Rule ID 13860 //
     /*  215944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  215952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  215955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  215958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  215961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215983 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  215986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  215992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216003 */     GIR_RootConstrainSelectedInstOperands,
     /*  216004 */     // GIR_Coverage, 13860,
     /*  216004 */     GIR_EraseRootFromParent_Done,
     /*  216005 */   // Label 4576: @216005
     /*  216005 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(216071), // Rule ID 13861 //
     /*  216010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  216021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  216024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  216027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216049 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  216049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  216052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216069 */     GIR_RootConstrainSelectedInstOperands,
     /*  216070 */     // GIR_Coverage, 13861,
     /*  216070 */     GIR_EraseRootFromParent_Done,
     /*  216071 */   // Label 4577: @216071
     /*  216071 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(216137), // Rule ID 13862 //
     /*  216076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  216087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  216090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  216093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  216115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  216118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216135 */     GIR_RootConstrainSelectedInstOperands,
     /*  216136 */     // GIR_Coverage, 13862,
     /*  216136 */     GIR_EraseRootFromParent_Done,
     /*  216137 */   // Label 4578: @216137
     /*  216137 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(216203), // Rule ID 13863 //
     /*  216142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  216153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  216156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  216159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  216181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  216184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216201 */     GIR_RootConstrainSelectedInstOperands,
     /*  216202 */     // GIR_Coverage, 13863,
     /*  216202 */     GIR_EraseRootFromParent_Done,
     /*  216203 */   // Label 4579: @216203
     /*  216203 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(216269), // Rule ID 13864 //
     /*  216208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  216219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  216222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  216225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216247 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  216247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  216250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216267 */     GIR_RootConstrainSelectedInstOperands,
     /*  216268 */     // GIR_Coverage, 13864,
     /*  216268 */     GIR_EraseRootFromParent_Done,
     /*  216269 */   // Label 4580: @216269
     /*  216269 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(216335), // Rule ID 13865 //
     /*  216274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  216285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  216288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  216291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  216313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  216316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216333 */     GIR_RootConstrainSelectedInstOperands,
     /*  216334 */     // GIR_Coverage, 13865,
     /*  216334 */     GIR_EraseRootFromParent_Done,
     /*  216335 */   // Label 4581: @216335
     /*  216335 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(216401), // Rule ID 13866 //
     /*  216340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  216351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  216354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  216357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216379 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  216379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  216382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216399 */     GIR_RootConstrainSelectedInstOperands,
     /*  216400 */     // GIR_Coverage, 13866,
     /*  216400 */     GIR_EraseRootFromParent_Done,
     /*  216401 */   // Label 4582: @216401
     /*  216401 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(216467), // Rule ID 13867 //
     /*  216406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  216417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  216420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  216423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216445 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  216445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  216448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216465 */     GIR_RootConstrainSelectedInstOperands,
     /*  216466 */     // GIR_Coverage, 13867,
     /*  216466 */     GIR_EraseRootFromParent_Done,
     /*  216467 */   // Label 4583: @216467
     /*  216467 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(216533), // Rule ID 13868 //
     /*  216472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  216475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  216483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  216486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  216489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  216511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  216514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216531 */     GIR_RootConstrainSelectedInstOperands,
     /*  216532 */     // GIR_Coverage, 13868,
     /*  216532 */     GIR_EraseRootFromParent_Done,
     /*  216533 */   // Label 4584: @216533
     /*  216533 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(216599), // Rule ID 13869 //
     /*  216538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  216541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  216549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  216552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  216555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  216570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  216577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  216580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216597 */     GIR_RootConstrainSelectedInstOperands,
     /*  216598 */     // GIR_Coverage, 13869,
     /*  216598 */     GIR_EraseRootFromParent_Done,
     /*  216599 */   // Label 4585: @216599
     /*  216599 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(216665), // Rule ID 13870 //
     /*  216604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  216607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  216615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  216618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  216621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  216643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  216646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216663 */     GIR_RootConstrainSelectedInstOperands,
     /*  216664 */     // GIR_Coverage, 13870,
     /*  216664 */     GIR_EraseRootFromParent_Done,
     /*  216665 */   // Label 4586: @216665
     /*  216665 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(216731), // Rule ID 13871 //
     /*  216670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  216673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  216681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  216684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  216687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  216702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216709 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  216709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  216712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216729 */     GIR_RootConstrainSelectedInstOperands,
     /*  216730 */     // GIR_Coverage, 13871,
     /*  216730 */     GIR_EraseRootFromParent_Done,
     /*  216731 */   // Label 4587: @216731
     /*  216731 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(216797), // Rule ID 13872 //
     /*  216736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  216739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  216747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  216750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  216753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216775 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  216775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  216778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216795 */     GIR_RootConstrainSelectedInstOperands,
     /*  216796 */     // GIR_Coverage, 13872,
     /*  216796 */     GIR_EraseRootFromParent_Done,
     /*  216797 */   // Label 4588: @216797
     /*  216797 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(216863), // Rule ID 13873 //
     /*  216802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  216805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  216813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  216816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  216819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  216834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216841 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  216841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  216844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  216858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216861 */     GIR_RootConstrainSelectedInstOperands,
     /*  216862 */     // GIR_Coverage, 13873,
     /*  216862 */     GIR_EraseRootFromParent_Done,
     /*  216863 */   // Label 4589: @216863
     /*  216863 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(216929), // Rule ID 13874 //
     /*  216868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  216871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  216879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  216885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216907 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  216907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  216910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216927 */     GIR_RootConstrainSelectedInstOperands,
     /*  216928 */     // GIR_Coverage, 13874,
     /*  216928 */     GIR_EraseRootFromParent_Done,
     /*  216929 */   // Label 4590: @216929
     /*  216929 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(216995), // Rule ID 13875 //
     /*  216934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  216937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  216942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  216945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  216951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216973 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  216973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  216976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  216982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216993 */     GIR_RootConstrainSelectedInstOperands,
     /*  216994 */     // GIR_Coverage, 13875,
     /*  216994 */     GIR_EraseRootFromParent_Done,
     /*  216995 */   // Label 4591: @216995
     /*  216995 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(217061), // Rule ID 13876 //
     /*  217000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  217003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  217017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217039 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  217042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217059 */     GIR_RootConstrainSelectedInstOperands,
     /*  217060 */     // GIR_Coverage, 13876,
     /*  217060 */     GIR_EraseRootFromParent_Done,
     /*  217061 */   // Label 4592: @217061
     /*  217061 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(217127), // Rule ID 13877 //
     /*  217066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  217069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  217083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217105 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  217108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217125 */     GIR_RootConstrainSelectedInstOperands,
     /*  217126 */     // GIR_Coverage, 13877,
     /*  217126 */     GIR_EraseRootFromParent_Done,
     /*  217127 */   // Label 4593: @217127
     /*  217127 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(217193), // Rule ID 13878 //
     /*  217132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  217135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  217149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217171 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  217174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217191 */     GIR_RootConstrainSelectedInstOperands,
     /*  217192 */     // GIR_Coverage, 13878,
     /*  217192 */     GIR_EraseRootFromParent_Done,
     /*  217193 */   // Label 4594: @217193
     /*  217193 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(217259), // Rule ID 13879 //
     /*  217198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  217201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  217215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217237 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  217240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217257 */     GIR_RootConstrainSelectedInstOperands,
     /*  217258 */     // GIR_Coverage, 13879,
     /*  217258 */     GIR_EraseRootFromParent_Done,
     /*  217259 */   // Label 4595: @217259
     /*  217259 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(217325), // Rule ID 13880 //
     /*  217264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  217267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  217281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217303 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217323 */     GIR_RootConstrainSelectedInstOperands,
     /*  217324 */     // GIR_Coverage, 13880,
     /*  217324 */     GIR_EraseRootFromParent_Done,
     /*  217325 */   // Label 4596: @217325
     /*  217325 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(217391), // Rule ID 13881 //
     /*  217330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  217333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  217347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217389 */     GIR_RootConstrainSelectedInstOperands,
     /*  217390 */     // GIR_Coverage, 13881,
     /*  217390 */     GIR_EraseRootFromParent_Done,
     /*  217391 */   // Label 4597: @217391
     /*  217391 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(217457), // Rule ID 13882 //
     /*  217396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  217399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  217413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217435 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217455 */     GIR_RootConstrainSelectedInstOperands,
     /*  217456 */     // GIR_Coverage, 13882,
     /*  217456 */     GIR_EraseRootFromParent_Done,
     /*  217457 */   // Label 4598: @217457
     /*  217457 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(217523), // Rule ID 13883 //
     /*  217462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  217465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  217479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217501 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217521 */     GIR_RootConstrainSelectedInstOperands,
     /*  217522 */     // GIR_Coverage, 13883,
     /*  217522 */     GIR_EraseRootFromParent_Done,
     /*  217523 */   // Label 4599: @217523
     /*  217523 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(217589), // Rule ID 13884 //
     /*  217528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  217531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  217545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217567 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  217567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217587 */     GIR_RootConstrainSelectedInstOperands,
     /*  217588 */     // GIR_Coverage, 13884,
     /*  217588 */     GIR_EraseRootFromParent_Done,
     /*  217589 */   // Label 4600: @217589
     /*  217589 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(217655), // Rule ID 13885 //
     /*  217594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  217597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  217611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  217633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  217636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217653 */     GIR_RootConstrainSelectedInstOperands,
     /*  217654 */     // GIR_Coverage, 13885,
     /*  217654 */     GIR_EraseRootFromParent_Done,
     /*  217655 */   // Label 4601: @217655
     /*  217655 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(217721), // Rule ID 13886 //
     /*  217660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  217663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  217671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  217674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  217677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217699 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  217702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217719 */     GIR_RootConstrainSelectedInstOperands,
     /*  217720 */     // GIR_Coverage, 13886,
     /*  217720 */     GIR_EraseRootFromParent_Done,
     /*  217721 */   // Label 4602: @217721
     /*  217721 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(217787), // Rule ID 13887 //
     /*  217726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  217729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  217737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  217740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  217743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217765 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  217768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217785 */     GIR_RootConstrainSelectedInstOperands,
     /*  217786 */     // GIR_Coverage, 13887,
     /*  217786 */     GIR_EraseRootFromParent_Done,
     /*  217787 */   // Label 4603: @217787
     /*  217787 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(217853), // Rule ID 13888 //
     /*  217792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  217795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  217803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  217806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  217809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217831 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  217834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217851 */     GIR_RootConstrainSelectedInstOperands,
     /*  217852 */     // GIR_Coverage, 13888,
     /*  217852 */     GIR_EraseRootFromParent_Done,
     /*  217853 */   // Label 4604: @217853
     /*  217853 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(217919), // Rule ID 13889 //
     /*  217858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  217861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  217869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  217872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  217875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217897 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  217900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217917 */     GIR_RootConstrainSelectedInstOperands,
     /*  217918 */     // GIR_Coverage, 13889,
     /*  217918 */     GIR_EraseRootFromParent_Done,
     /*  217919 */   // Label 4605: @217919
     /*  217919 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(217985), // Rule ID 13890 //
     /*  217924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  217927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  217935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  217938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  217941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  217948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  217952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  217956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  217966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  217972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217983 */     GIR_RootConstrainSelectedInstOperands,
     /*  217984 */     // GIR_Coverage, 13890,
     /*  217984 */     GIR_EraseRootFromParent_Done,
     /*  217985 */   // Label 4606: @217985
     /*  217985 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(218051), // Rule ID 13891 //
     /*  217990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  217993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  217998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  218001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  218007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218029 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  218032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218049 */     GIR_RootConstrainSelectedInstOperands,
     /*  218050 */     // GIR_Coverage, 13891,
     /*  218050 */     GIR_EraseRootFromParent_Done,
     /*  218051 */   // Label 4607: @218051
     /*  218051 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(218117), // Rule ID 13892 //
     /*  218056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  218059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  218073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218095 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  218098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218115 */     GIR_RootConstrainSelectedInstOperands,
     /*  218116 */     // GIR_Coverage, 13892,
     /*  218116 */     GIR_EraseRootFromParent_Done,
     /*  218117 */   // Label 4608: @218117
     /*  218117 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(218183), // Rule ID 13893 //
     /*  218122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  218125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  218139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218161 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  218164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218181 */     GIR_RootConstrainSelectedInstOperands,
     /*  218182 */     // GIR_Coverage, 13893,
     /*  218182 */     GIR_EraseRootFromParent_Done,
     /*  218183 */   // Label 4609: @218183
     /*  218183 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(218249), // Rule ID 13894 //
     /*  218188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  218191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  218205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  218230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218247 */     GIR_RootConstrainSelectedInstOperands,
     /*  218248 */     // GIR_Coverage, 13894,
     /*  218248 */     GIR_EraseRootFromParent_Done,
     /*  218249 */   // Label 4610: @218249
     /*  218249 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(218315), // Rule ID 13895 //
     /*  218254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  218257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  218271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218293 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  218296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218313 */     GIR_RootConstrainSelectedInstOperands,
     /*  218314 */     // GIR_Coverage, 13895,
     /*  218314 */     GIR_EraseRootFromParent_Done,
     /*  218315 */   // Label 4611: @218315
     /*  218315 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(218381), // Rule ID 13896 //
     /*  218320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  218323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  218337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218359 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  218362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218379 */     GIR_RootConstrainSelectedInstOperands,
     /*  218380 */     // GIR_Coverage, 13896,
     /*  218380 */     GIR_EraseRootFromParent_Done,
     /*  218381 */   // Label 4612: @218381
     /*  218381 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(218447), // Rule ID 13897 //
     /*  218386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  218389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  218403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218425 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  218428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218445 */     GIR_RootConstrainSelectedInstOperands,
     /*  218446 */     // GIR_Coverage, 13897,
     /*  218446 */     GIR_EraseRootFromParent_Done,
     /*  218447 */   // Label 4613: @218447
     /*  218447 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(218513), // Rule ID 13898 //
     /*  218452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  218455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  218463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  218466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  218469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218491 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  218491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  218494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218511 */     GIR_RootConstrainSelectedInstOperands,
     /*  218512 */     // GIR_Coverage, 13898,
     /*  218512 */     GIR_EraseRootFromParent_Done,
     /*  218513 */   // Label 4614: @218513
     /*  218513 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(218579), // Rule ID 13899 //
     /*  218518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  218521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  218529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  218532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  218535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218557 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  218557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  218560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218577 */     GIR_RootConstrainSelectedInstOperands,
     /*  218578 */     // GIR_Coverage, 13899,
     /*  218578 */     GIR_EraseRootFromParent_Done,
     /*  218579 */   // Label 4615: @218579
     /*  218579 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(218645), // Rule ID 13900 //
     /*  218584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  218587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  218595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  218598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  218601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218623 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  218623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  218626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218643 */     GIR_RootConstrainSelectedInstOperands,
     /*  218644 */     // GIR_Coverage, 13900,
     /*  218644 */     GIR_EraseRootFromParent_Done,
     /*  218645 */   // Label 4616: @218645
     /*  218645 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(218711), // Rule ID 13901 //
     /*  218650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  218653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  218661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  218664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  218667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218689 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  218689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  218692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218709 */     GIR_RootConstrainSelectedInstOperands,
     /*  218710 */     // GIR_Coverage, 13901,
     /*  218710 */     GIR_EraseRootFromParent_Done,
     /*  218711 */   // Label 4617: @218711
     /*  218711 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(218777), // Rule ID 13902 //
     /*  218716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  218719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  218727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  218730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  218733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218755 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  218755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  218758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218775 */     GIR_RootConstrainSelectedInstOperands,
     /*  218776 */     // GIR_Coverage, 13902,
     /*  218776 */     GIR_EraseRootFromParent_Done,
     /*  218777 */   // Label 4618: @218777
     /*  218777 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(218843), // Rule ID 13903 //
     /*  218782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  218785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  218790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  218793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  218796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  218799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218821 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  218821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  218824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  218830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218841 */     GIR_RootConstrainSelectedInstOperands,
     /*  218842 */     // GIR_Coverage, 13903,
     /*  218842 */     GIR_EraseRootFromParent_Done,
     /*  218843 */   // Label 4619: @218843
     /*  218843 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(218909), // Rule ID 18906 //
     /*  218848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  218851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  218856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  218859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  218862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  218865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218887 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  218890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  218896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218907 */     GIR_RootConstrainSelectedInstOperands,
     /*  218908 */     // GIR_Coverage, 18906,
     /*  218908 */     GIR_EraseRootFromParent_Done,
     /*  218909 */   // Label 4620: @218909
     /*  218909 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(218975), // Rule ID 18907 //
     /*  218914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  218917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  218922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  218925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  218928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  218931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218953 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  218956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  218962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218973 */     GIR_RootConstrainSelectedInstOperands,
     /*  218974 */     // GIR_Coverage, 18907,
     /*  218974 */     GIR_EraseRootFromParent_Done,
     /*  218975 */   // Label 4621: @218975
     /*  218975 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(219041), // Rule ID 18910 //
     /*  218980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  218983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  218988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  218991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  218994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  218997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219019 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  219019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  219022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219039 */     GIR_RootConstrainSelectedInstOperands,
     /*  219040 */     // GIR_Coverage, 18910,
     /*  219040 */     GIR_EraseRootFromParent_Done,
     /*  219041 */   // Label 4622: @219041
     /*  219041 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(219107), // Rule ID 18911 //
     /*  219046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  219049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  219057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  219060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  219063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219085 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  219085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  219088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219105 */     GIR_RootConstrainSelectedInstOperands,
     /*  219106 */     // GIR_Coverage, 18911,
     /*  219106 */     GIR_EraseRootFromParent_Done,
     /*  219107 */   // Label 4623: @219107
     /*  219107 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(219173), // Rule ID 18914 //
     /*  219112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  219115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  219123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  219126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  219129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219151 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  219151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  219154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219171 */     GIR_RootConstrainSelectedInstOperands,
     /*  219172 */     // GIR_Coverage, 18914,
     /*  219172 */     GIR_EraseRootFromParent_Done,
     /*  219173 */   // Label 4624: @219173
     /*  219173 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(219239), // Rule ID 18915 //
     /*  219178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  219181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  219189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  219192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  219195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219217 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10952:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  219217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  219220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219237 */     GIR_RootConstrainSelectedInstOperands,
     /*  219238 */     // GIR_Coverage, 18915,
     /*  219238 */     GIR_EraseRootFromParent_Done,
     /*  219239 */   // Label 4625: @219239
     /*  219239 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(219305), // Rule ID 18918 //
     /*  219244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  219247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  219255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  219258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  219261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219283 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10952:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  219283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  219286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219303 */     GIR_RootConstrainSelectedInstOperands,
     /*  219304 */     // GIR_Coverage, 18918,
     /*  219304 */     GIR_EraseRootFromParent_Done,
     /*  219305 */   // Label 4626: @219305
     /*  219305 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(219371), // Rule ID 18919 //
     /*  219310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  219313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  219321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  219324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  219327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219349 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10952:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  219349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  219352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219369 */     GIR_RootConstrainSelectedInstOperands,
     /*  219370 */     // GIR_Coverage, 18919,
     /*  219370 */     GIR_EraseRootFromParent_Done,
     /*  219371 */   // Label 4627: @219371
     /*  219371 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(219437), // Rule ID 18922 //
     /*  219376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  219379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  219387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  219390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  219393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219415 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  219418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219435 */     GIR_RootConstrainSelectedInstOperands,
     /*  219436 */     // GIR_Coverage, 18922,
     /*  219436 */     GIR_EraseRootFromParent_Done,
     /*  219437 */   // Label 4628: @219437
     /*  219437 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(219503), // Rule ID 18923 //
     /*  219442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  219445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  219453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  219456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  219459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219481 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10952:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  219484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219501 */     GIR_RootConstrainSelectedInstOperands,
     /*  219502 */     // GIR_Coverage, 18923,
     /*  219502 */     GIR_EraseRootFromParent_Done,
     /*  219503 */   // Label 4629: @219503
     /*  219503 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(219569), // Rule ID 18926 //
     /*  219508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  219511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  219519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  219522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  219525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219547 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  219547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  219550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219567 */     GIR_RootConstrainSelectedInstOperands,
     /*  219568 */     // GIR_Coverage, 18926,
     /*  219568 */     GIR_EraseRootFromParent_Done,
     /*  219569 */   // Label 4630: @219569
     /*  219569 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(219635), // Rule ID 18927 //
     /*  219574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  219577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  219585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  219588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  219591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219613 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  219613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  219616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219633 */     GIR_RootConstrainSelectedInstOperands,
     /*  219634 */     // GIR_Coverage, 18927,
     /*  219634 */     GIR_EraseRootFromParent_Done,
     /*  219635 */   // Label 4631: @219635
     /*  219635 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(219701), // Rule ID 18930 //
     /*  219640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  219643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  219651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  219657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219679 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  219679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  219682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219699 */     GIR_RootConstrainSelectedInstOperands,
     /*  219700 */     // GIR_Coverage, 18930,
     /*  219700 */     GIR_EraseRootFromParent_Done,
     /*  219701 */   // Label 4632: @219701
     /*  219701 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(219767), // Rule ID 18931 //
     /*  219706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  219709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  219717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  219723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219745 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  219745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  219748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219765 */     GIR_RootConstrainSelectedInstOperands,
     /*  219766 */     // GIR_Coverage, 18931,
     /*  219766 */     GIR_EraseRootFromParent_Done,
     /*  219767 */   // Label 4633: @219767
     /*  219767 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(219833), // Rule ID 18934 //
     /*  219772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  219775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  219783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  219789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219811 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  219811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  219814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219831 */     GIR_RootConstrainSelectedInstOperands,
     /*  219832 */     // GIR_Coverage, 18934,
     /*  219832 */     GIR_EraseRootFromParent_Done,
     /*  219833 */   // Label 4634: @219833
     /*  219833 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(219899), // Rule ID 18935 //
     /*  219838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  219841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  219849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  219855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219877 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  219877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  219880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219897 */     GIR_RootConstrainSelectedInstOperands,
     /*  219898 */     // GIR_Coverage, 18935,
     /*  219898 */     GIR_EraseRootFromParent_Done,
     /*  219899 */   // Label 4635: @219899
     /*  219899 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(219965), // Rule ID 18938 //
     /*  219904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  219907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  219915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  219921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219943 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  219943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  219946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219963 */     GIR_RootConstrainSelectedInstOperands,
     /*  219964 */     // GIR_Coverage, 18938,
     /*  219964 */     GIR_EraseRootFromParent_Done,
     /*  219965 */   // Label 4636: @219965
     /*  219965 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(220031), // Rule ID 18939 //
     /*  219970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  219973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  219978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  219981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  219987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220009 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  220009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  220012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220029 */     GIR_RootConstrainSelectedInstOperands,
     /*  220030 */     // GIR_Coverage, 18939,
     /*  220030 */     GIR_EraseRootFromParent_Done,
     /*  220031 */   // Label 4637: @220031
     /*  220031 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(220097), // Rule ID 18942 //
     /*  220036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  220039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  220047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  220050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  220053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220075 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  220075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  220078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220095 */     GIR_RootConstrainSelectedInstOperands,
     /*  220096 */     // GIR_Coverage, 18942,
     /*  220096 */     GIR_EraseRootFromParent_Done,
     /*  220097 */   // Label 4638: @220097
     /*  220097 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(220163), // Rule ID 18943 //
     /*  220102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  220105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  220113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  220116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  220119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220141 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  220141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  220144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220161 */     GIR_RootConstrainSelectedInstOperands,
     /*  220162 */     // GIR_Coverage, 18943,
     /*  220162 */     GIR_EraseRootFromParent_Done,
     /*  220163 */   // Label 4639: @220163
     /*  220163 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(220229), // Rule ID 18946 //
     /*  220168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  220171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  220179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  220182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  220185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220207 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  220207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  220210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220227 */     GIR_RootConstrainSelectedInstOperands,
     /*  220228 */     // GIR_Coverage, 18946,
     /*  220228 */     GIR_EraseRootFromParent_Done,
     /*  220229 */   // Label 4640: @220229
     /*  220229 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(220295), // Rule ID 18947 //
     /*  220234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  220237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  220245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  220248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  220251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220273 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  220273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  220276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220293 */     GIR_RootConstrainSelectedInstOperands,
     /*  220294 */     // GIR_Coverage, 18947,
     /*  220294 */     GIR_EraseRootFromParent_Done,
     /*  220295 */   // Label 4641: @220295
     /*  220295 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(220361), // Rule ID 18950 //
     /*  220300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  220303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  220311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  220314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  220317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220339 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  220339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  220342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220359 */     GIR_RootConstrainSelectedInstOperands,
     /*  220360 */     // GIR_Coverage, 18950,
     /*  220360 */     GIR_EraseRootFromParent_Done,
     /*  220361 */   // Label 4642: @220361
     /*  220361 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(220427), // Rule ID 18951 //
     /*  220366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  220369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  220377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  220380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  220383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220405 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10952:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  220405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  220408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220425 */     GIR_RootConstrainSelectedInstOperands,
     /*  220426 */     // GIR_Coverage, 18951,
     /*  220426 */     GIR_EraseRootFromParent_Done,
     /*  220427 */   // Label 4643: @220427
     /*  220427 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(220493), // Rule ID 18954 //
     /*  220432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  220435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  220443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  220446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  220449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220471 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  220471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  220474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220491 */     GIR_RootConstrainSelectedInstOperands,
     /*  220492 */     // GIR_Coverage, 18954,
     /*  220492 */     GIR_EraseRootFromParent_Done,
     /*  220493 */   // Label 4644: @220493
     /*  220493 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(220559), // Rule ID 18955 //
     /*  220498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  220501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  220509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  220512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  220515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220537 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10952:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  220537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  220540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220557 */     GIR_RootConstrainSelectedInstOperands,
     /*  220558 */     // GIR_Coverage, 18955,
     /*  220558 */     GIR_EraseRootFromParent_Done,
     /*  220559 */   // Label 4645: @220559
     /*  220559 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(220625), // Rule ID 18958 //
     /*  220564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  220567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  220575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  220581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220603 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  220603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  220606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220623 */     GIR_RootConstrainSelectedInstOperands,
     /*  220624 */     // GIR_Coverage, 18958,
     /*  220624 */     GIR_EraseRootFromParent_Done,
     /*  220625 */   // Label 4646: @220625
     /*  220625 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(220691), // Rule ID 18959 //
     /*  220630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  220633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  220638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  220641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  220647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220669 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10952:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  220669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  220672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  220676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  220689 */     GIR_RootConstrainSelectedInstOperands,
     /*  220690 */     // GIR_Coverage, 18959,
     /*  220690 */     GIR_EraseRootFromParent_Done,
     /*  220691 */   // Label 4647: @220691
     /*  220691 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(220754), // Rule ID 19622 //
     /*  220696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  220699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  220704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  220713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220735 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  220738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220752 */     GIR_RootConstrainSelectedInstOperands,
     /*  220753 */     // GIR_Coverage, 19622,
     /*  220753 */     GIR_EraseRootFromParent_Done,
     /*  220754 */   // Label 4648: @220754
     /*  220754 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(220817), // Rule ID 19623 //
     /*  220759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  220762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  220767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  220776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  220801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220815 */     GIR_RootConstrainSelectedInstOperands,
     /*  220816 */     // GIR_Coverage, 19623,
     /*  220816 */     GIR_EraseRootFromParent_Done,
     /*  220817 */   // Label 4649: @220817
     /*  220817 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(220880), // Rule ID 19626 //
     /*  220822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  220825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  220830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  220839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  220864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220878 */     GIR_RootConstrainSelectedInstOperands,
     /*  220879 */     // GIR_Coverage, 19626,
     /*  220879 */     GIR_EraseRootFromParent_Done,
     /*  220880 */   // Label 4650: @220880
     /*  220880 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(220943), // Rule ID 19627 //
     /*  220885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  220888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  220893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  220902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  220927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220941 */     GIR_RootConstrainSelectedInstOperands,
     /*  220942 */     // GIR_Coverage, 19627,
     /*  220942 */     GIR_EraseRootFromParent_Done,
     /*  220943 */   // Label 4651: @220943
     /*  220943 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(221006), // Rule ID 19630 //
     /*  220948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  220951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  220956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  220965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  220990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221004 */     GIR_RootConstrainSelectedInstOperands,
     /*  221005 */     // GIR_Coverage, 19630,
     /*  221005 */     GIR_EraseRootFromParent_Done,
     /*  221006 */   // Label 4652: @221006
     /*  221006 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(221069), // Rule ID 19631 //
     /*  221011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  221014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  221028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221050 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  221053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221067 */     GIR_RootConstrainSelectedInstOperands,
     /*  221068 */     // GIR_Coverage, 19631,
     /*  221068 */     GIR_EraseRootFromParent_Done,
     /*  221069 */   // Label 4653: @221069
     /*  221069 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(221132), // Rule ID 19634 //
     /*  221074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  221077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  221091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221113 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221130 */     GIR_RootConstrainSelectedInstOperands,
     /*  221131 */     // GIR_Coverage, 19634,
     /*  221131 */     GIR_EraseRootFromParent_Done,
     /*  221132 */   // Label 4654: @221132
     /*  221132 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(221195), // Rule ID 19635 //
     /*  221137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  221140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  221154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221193 */     GIR_RootConstrainSelectedInstOperands,
     /*  221194 */     // GIR_Coverage, 19635,
     /*  221194 */     GIR_EraseRootFromParent_Done,
     /*  221195 */   // Label 4655: @221195
     /*  221195 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(221258), // Rule ID 19638 //
     /*  221200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  221203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  221217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221256 */     GIR_RootConstrainSelectedInstOperands,
     /*  221257 */     // GIR_Coverage, 19638,
     /*  221257 */     GIR_EraseRootFromParent_Done,
     /*  221258 */   // Label 4656: @221258
     /*  221258 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(221321), // Rule ID 19639 //
     /*  221263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  221266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  221280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221319 */     GIR_RootConstrainSelectedInstOperands,
     /*  221320 */     // GIR_Coverage, 19639,
     /*  221320 */     GIR_EraseRootFromParent_Done,
     /*  221321 */   // Label 4657: @221321
     /*  221321 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(221384), // Rule ID 19642 //
     /*  221326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  221329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  221343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221365 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221382 */     GIR_RootConstrainSelectedInstOperands,
     /*  221383 */     // GIR_Coverage, 19642,
     /*  221383 */     GIR_EraseRootFromParent_Done,
     /*  221384 */   // Label 4658: @221384
     /*  221384 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(221447), // Rule ID 19643 //
     /*  221389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  221392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  221406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  221431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221445 */     GIR_RootConstrainSelectedInstOperands,
     /*  221446 */     // GIR_Coverage, 19643,
     /*  221446 */     GIR_EraseRootFromParent_Done,
     /*  221447 */   // Label 4659: @221447
     /*  221447 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(221510), // Rule ID 19646 //
     /*  221452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  221455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  221469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221491 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  221494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221508 */     GIR_RootConstrainSelectedInstOperands,
     /*  221509 */     // GIR_Coverage, 19646,
     /*  221509 */     GIR_EraseRootFromParent_Done,
     /*  221510 */   // Label 4660: @221510
     /*  221510 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(221573), // Rule ID 19647 //
     /*  221515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  221518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  221532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221554 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  221557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221571 */     GIR_RootConstrainSelectedInstOperands,
     /*  221572 */     // GIR_Coverage, 19647,
     /*  221572 */     GIR_EraseRootFromParent_Done,
     /*  221573 */   // Label 4661: @221573
     /*  221573 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(221636), // Rule ID 19650 //
     /*  221578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  221581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  221595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221617 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  221620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221634 */     GIR_RootConstrainSelectedInstOperands,
     /*  221635 */     // GIR_Coverage, 19650,
     /*  221635 */     GIR_EraseRootFromParent_Done,
     /*  221636 */   // Label 4662: @221636
     /*  221636 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(221699), // Rule ID 19651 //
     /*  221641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  221644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  221658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  221683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221697 */     GIR_RootConstrainSelectedInstOperands,
     /*  221698 */     // GIR_Coverage, 19651,
     /*  221698 */     GIR_EraseRootFromParent_Done,
     /*  221699 */   // Label 4663: @221699
     /*  221699 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(221762), // Rule ID 19654 //
     /*  221704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  221707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  221721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221743 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  221746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221760 */     GIR_RootConstrainSelectedInstOperands,
     /*  221761 */     // GIR_Coverage, 19654,
     /*  221761 */     GIR_EraseRootFromParent_Done,
     /*  221762 */   // Label 4664: @221762
     /*  221762 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(221825), // Rule ID 19655 //
     /*  221767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  221770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  221784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221806 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  221809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221823 */     GIR_RootConstrainSelectedInstOperands,
     /*  221824 */     // GIR_Coverage, 19655,
     /*  221824 */     GIR_EraseRootFromParent_Done,
     /*  221825 */   // Label 4665: @221825
     /*  221825 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(221888), // Rule ID 19658 //
     /*  221830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  221833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  221844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  221847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  221872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221886 */     GIR_RootConstrainSelectedInstOperands,
     /*  221887 */     // GIR_Coverage, 19658,
     /*  221887 */     GIR_EraseRootFromParent_Done,
     /*  221888 */   // Label 4666: @221888
     /*  221888 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(221951), // Rule ID 19659 //
     /*  221893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  221896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  221907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  221910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  221935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  221941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221949 */     GIR_RootConstrainSelectedInstOperands,
     /*  221950 */     // GIR_Coverage, 19659,
     /*  221950 */     GIR_EraseRootFromParent_Done,
     /*  221951 */   // Label 4667: @221951
     /*  221951 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(222014), // Rule ID 19662 //
     /*  221956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  221959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  221964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  221970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  221973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221995 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  221998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222012 */     GIR_RootConstrainSelectedInstOperands,
     /*  222013 */     // GIR_Coverage, 19662,
     /*  222013 */     GIR_EraseRootFromParent_Done,
     /*  222014 */   // Label 4668: @222014
     /*  222014 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(222077), // Rule ID 19663 //
     /*  222019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  222022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  222036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  222061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222075 */     GIR_RootConstrainSelectedInstOperands,
     /*  222076 */     // GIR_Coverage, 19663,
     /*  222076 */     GIR_EraseRootFromParent_Done,
     /*  222077 */   // Label 4669: @222077
     /*  222077 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(222140), // Rule ID 19666 //
     /*  222082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  222085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  222099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222121 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  222124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222138 */     GIR_RootConstrainSelectedInstOperands,
     /*  222139 */     // GIR_Coverage, 19666,
     /*  222139 */     GIR_EraseRootFromParent_Done,
     /*  222140 */   // Label 4670: @222140
     /*  222140 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(222203), // Rule ID 19667 //
     /*  222145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  222148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  222162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  222187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222201 */     GIR_RootConstrainSelectedInstOperands,
     /*  222202 */     // GIR_Coverage, 19667,
     /*  222202 */     GIR_EraseRootFromParent_Done,
     /*  222203 */   // Label 4671: @222203
     /*  222203 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(222266), // Rule ID 19670 //
     /*  222208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  222211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  222225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222247 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  222250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222264 */     GIR_RootConstrainSelectedInstOperands,
     /*  222265 */     // GIR_Coverage, 19670,
     /*  222265 */     GIR_EraseRootFromParent_Done,
     /*  222266 */   // Label 4672: @222266
     /*  222266 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(222329), // Rule ID 19671 //
     /*  222271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  222274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  222288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  222313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222327 */     GIR_RootConstrainSelectedInstOperands,
     /*  222328 */     // GIR_Coverage, 19671,
     /*  222328 */     GIR_EraseRootFromParent_Done,
     /*  222329 */   // Label 4673: @222329
     /*  222329 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(222392), // Rule ID 19674 //
     /*  222334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  222337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  222351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222373 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  222376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222390 */     GIR_RootConstrainSelectedInstOperands,
     /*  222391 */     // GIR_Coverage, 19674,
     /*  222391 */     GIR_EraseRootFromParent_Done,
     /*  222392 */   // Label 4674: @222392
     /*  222392 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(222455), // Rule ID 19675 //
     /*  222397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  222400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  222414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  222439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222453 */     GIR_RootConstrainSelectedInstOperands,
     /*  222454 */     // GIR_Coverage, 19675,
     /*  222454 */     GIR_EraseRootFromParent_Done,
     /*  222455 */   // Label 4675: @222455
     /*  222455 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(222518), // Rule ID 19678 //
     /*  222460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  222463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  222477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  222502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222516 */     GIR_RootConstrainSelectedInstOperands,
     /*  222517 */     // GIR_Coverage, 19678,
     /*  222517 */     GIR_EraseRootFromParent_Done,
     /*  222518 */   // Label 4676: @222518
     /*  222518 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(222581), // Rule ID 19679 //
     /*  222523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  222526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  222540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  222565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222579 */     GIR_RootConstrainSelectedInstOperands,
     /*  222580 */     // GIR_Coverage, 19679,
     /*  222580 */     GIR_EraseRootFromParent_Done,
     /*  222581 */   // Label 4677: @222581
     /*  222581 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(222644), // Rule ID 19682 //
     /*  222586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  222589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  222600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  222603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  222618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222625 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  222628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222642 */     GIR_RootConstrainSelectedInstOperands,
     /*  222643 */     // GIR_Coverage, 19682,
     /*  222643 */     GIR_EraseRootFromParent_Done,
     /*  222644 */   // Label 4678: @222644
     /*  222644 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(222707), // Rule ID 19683 //
     /*  222649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  222652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  222663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  222666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  222681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  222691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222705 */     GIR_RootConstrainSelectedInstOperands,
     /*  222706 */     // GIR_Coverage, 19683,
     /*  222706 */     GIR_EraseRootFromParent_Done,
     /*  222707 */   // Label 4679: @222707
     /*  222707 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(222770), // Rule ID 19686 //
     /*  222712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  222715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  222726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  222729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  222744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222751 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  222754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222768 */     GIR_RootConstrainSelectedInstOperands,
     /*  222769 */     // GIR_Coverage, 19686,
     /*  222769 */     GIR_EraseRootFromParent_Done,
     /*  222770 */   // Label 4680: @222770
     /*  222770 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(222833), // Rule ID 19687 //
     /*  222775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  222778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  222789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  222792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  222807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222814 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  222817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222831 */     GIR_RootConstrainSelectedInstOperands,
     /*  222832 */     // GIR_Coverage, 19687,
     /*  222832 */     GIR_EraseRootFromParent_Done,
     /*  222833 */   // Label 4681: @222833
     /*  222833 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(222896), // Rule ID 19690 //
     /*  222838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  222841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  222852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  222870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222877 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  222880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222894 */     GIR_RootConstrainSelectedInstOperands,
     /*  222895 */     // GIR_Coverage, 19690,
     /*  222895 */     GIR_EraseRootFromParent_Done,
     /*  222896 */   // Label 4682: @222896
     /*  222896 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(222959), // Rule ID 19691 //
     /*  222901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  222904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  222915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  222933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  222943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  222949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222957 */     GIR_RootConstrainSelectedInstOperands,
     /*  222958 */     // GIR_Coverage, 19691,
     /*  222958 */     GIR_EraseRootFromParent_Done,
     /*  222959 */   // Label 4683: @222959
     /*  222959 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(223022), // Rule ID 19694 //
     /*  222964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  222967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  222972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  222978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  222981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  222996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223003 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  223006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223020 */     GIR_RootConstrainSelectedInstOperands,
     /*  223021 */     // GIR_Coverage, 19694,
     /*  223021 */     GIR_EraseRootFromParent_Done,
     /*  223022 */   // Label 4684: @223022
     /*  223022 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(223085), // Rule ID 19695 //
     /*  223027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  223030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  223041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  223069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223083 */     GIR_RootConstrainSelectedInstOperands,
     /*  223084 */     // GIR_Coverage, 19695,
     /*  223084 */     GIR_EraseRootFromParent_Done,
     /*  223085 */   // Label 4685: @223085
     /*  223085 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(223148), // Rule ID 19698 //
     /*  223090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  223093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  223104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223129 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  223132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223146 */     GIR_RootConstrainSelectedInstOperands,
     /*  223147 */     // GIR_Coverage, 19698,
     /*  223147 */     GIR_EraseRootFromParent_Done,
     /*  223148 */   // Label 4686: @223148
     /*  223148 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(223211), // Rule ID 19699 //
     /*  223153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  223156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  223167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  223195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223209 */     GIR_RootConstrainSelectedInstOperands,
     /*  223210 */     // GIR_Coverage, 19699,
     /*  223210 */     GIR_EraseRootFromParent_Done,
     /*  223211 */   // Label 4687: @223211
     /*  223211 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(223274), // Rule ID 19702 //
     /*  223216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  223219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  223230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  223248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223255 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  223258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223272 */     GIR_RootConstrainSelectedInstOperands,
     /*  223273 */     // GIR_Coverage, 19702,
     /*  223273 */     GIR_EraseRootFromParent_Done,
     /*  223274 */   // Label 4688: @223274
     /*  223274 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(223337), // Rule ID 19703 //
     /*  223279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  223282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  223293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  223311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  223321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223335 */     GIR_RootConstrainSelectedInstOperands,
     /*  223336 */     // GIR_Coverage, 19703,
     /*  223336 */     GIR_EraseRootFromParent_Done,
     /*  223337 */   // Label 4689: @223337
     /*  223337 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(223400), // Rule ID 19706 //
     /*  223342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  223345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  223356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223381 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  223384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223398 */     GIR_RootConstrainSelectedInstOperands,
     /*  223399 */     // GIR_Coverage, 19706,
     /*  223399 */     GIR_EraseRootFromParent_Done,
     /*  223400 */   // Label 4690: @223400
     /*  223400 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(223463), // Rule ID 19707 //
     /*  223405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  223408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  223419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  223447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223461 */     GIR_RootConstrainSelectedInstOperands,
     /*  223462 */     // GIR_Coverage, 19707,
     /*  223462 */     GIR_EraseRootFromParent_Done,
     /*  223463 */   // Label 4691: @223463
     /*  223463 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(223526), // Rule ID 19710 //
     /*  223468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  223471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  223482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223507 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  223510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223524 */     GIR_RootConstrainSelectedInstOperands,
     /*  223525 */     // GIR_Coverage, 19710,
     /*  223525 */     GIR_EraseRootFromParent_Done,
     /*  223526 */   // Label 4692: @223526
     /*  223526 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(223589), // Rule ID 19711 //
     /*  223531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  223534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  223545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223570 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  223573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223587 */     GIR_RootConstrainSelectedInstOperands,
     /*  223588 */     // GIR_Coverage, 19711,
     /*  223588 */     GIR_EraseRootFromParent_Done,
     /*  223589 */   // Label 4693: @223589
     /*  223589 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(223652), // Rule ID 19714 //
     /*  223594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  223597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  223605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  223608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223633 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  223636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223650 */     GIR_RootConstrainSelectedInstOperands,
     /*  223651 */     // GIR_Coverage, 19714,
     /*  223651 */     GIR_EraseRootFromParent_Done,
     /*  223652 */   // Label 4694: @223652
     /*  223652 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(223715), // Rule ID 19715 //
     /*  223657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  223660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  223668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  223671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  223674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  223689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  223699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223713 */     GIR_RootConstrainSelectedInstOperands,
     /*  223714 */     // GIR_Coverage, 19715,
     /*  223714 */     GIR_EraseRootFromParent_Done,
     /*  223715 */   // Label 4695: @223715
     /*  223715 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(223778), // Rule ID 19718 //
     /*  223720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  223723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  223734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223759 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  223762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223776 */     GIR_RootConstrainSelectedInstOperands,
     /*  223777 */     // GIR_Coverage, 19718,
     /*  223777 */     GIR_EraseRootFromParent_Done,
     /*  223778 */   // Label 4696: @223778
     /*  223778 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(223841), // Rule ID 19719 //
     /*  223783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  223786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  223797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  223825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223839 */     GIR_RootConstrainSelectedInstOperands,
     /*  223840 */     // GIR_Coverage, 19719,
     /*  223840 */     GIR_EraseRootFromParent_Done,
     /*  223841 */   // Label 4697: @223841
     /*  223841 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(223904), // Rule ID 19722 //
     /*  223846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  223849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  223860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223885 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  223888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223902 */     GIR_RootConstrainSelectedInstOperands,
     /*  223903 */     // GIR_Coverage, 19722,
     /*  223903 */     GIR_EraseRootFromParent_Done,
     /*  223904 */   // Label 4698: @223904
     /*  223904 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(223967), // Rule ID 19723 //
     /*  223909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  223912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  223923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  223941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  223951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  223957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223965 */     GIR_RootConstrainSelectedInstOperands,
     /*  223966 */     // GIR_Coverage, 19723,
     /*  223966 */     GIR_EraseRootFromParent_Done,
     /*  223967 */   // Label 4699: @223967
     /*  223967 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(224030), // Rule ID 19726 //
     /*  223972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  223975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  223980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  223986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  224004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224011 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  224014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224028 */     GIR_RootConstrainSelectedInstOperands,
     /*  224029 */     // GIR_Coverage, 19726,
     /*  224029 */     GIR_EraseRootFromParent_Done,
     /*  224030 */   // Label 4700: @224030
     /*  224030 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(224093), // Rule ID 19727 //
     /*  224035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  224038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  224049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  224067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  224077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224091 */     GIR_RootConstrainSelectedInstOperands,
     /*  224092 */     // GIR_Coverage, 19727,
     /*  224092 */     GIR_EraseRootFromParent_Done,
     /*  224093 */   // Label 4701: @224093
     /*  224093 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(224156), // Rule ID 19730 //
     /*  224098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  224101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  224112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224137 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  224140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224154 */     GIR_RootConstrainSelectedInstOperands,
     /*  224155 */     // GIR_Coverage, 19730,
     /*  224155 */     GIR_EraseRootFromParent_Done,
     /*  224156 */   // Label 4702: @224156
     /*  224156 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(224219), // Rule ID 19731 //
     /*  224161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  224164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  224175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  224203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224217 */     GIR_RootConstrainSelectedInstOperands,
     /*  224218 */     // GIR_Coverage, 19731,
     /*  224218 */     GIR_EraseRootFromParent_Done,
     /*  224219 */   // Label 4703: @224219
     /*  224219 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(224282), // Rule ID 19734 //
     /*  224224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  224227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  224238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224263 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  224266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224280 */     GIR_RootConstrainSelectedInstOperands,
     /*  224281 */     // GIR_Coverage, 19734,
     /*  224281 */     GIR_EraseRootFromParent_Done,
     /*  224282 */   // Label 4704: @224282
     /*  224282 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(224345), // Rule ID 19735 //
     /*  224287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  224290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  224301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  224329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224343 */     GIR_RootConstrainSelectedInstOperands,
     /*  224344 */     // GIR_Coverage, 19735,
     /*  224344 */     GIR_EraseRootFromParent_Done,
     /*  224345 */   // Label 4705: @224345
     /*  224345 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(224408), // Rule ID 19738 //
     /*  224350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  224353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  224364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224389 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  224392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224406 */     GIR_RootConstrainSelectedInstOperands,
     /*  224407 */     // GIR_Coverage, 19738,
     /*  224407 */     GIR_EraseRootFromParent_Done,
     /*  224408 */   // Label 4706: @224408
     /*  224408 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(224471), // Rule ID 19739 //
     /*  224413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  224416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  224421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  224427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  224445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  224455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224469 */     GIR_RootConstrainSelectedInstOperands,
     /*  224470 */     // GIR_Coverage, 19739,
     /*  224470 */     GIR_EraseRootFromParent_Done,
     /*  224471 */   // Label 4707: @224471
     /*  224471 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(224534), // Rule ID 19742 //
     /*  224476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  224479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  224493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224515 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  224518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224532 */     GIR_RootConstrainSelectedInstOperands,
     /*  224533 */     // GIR_Coverage, 19742,
     /*  224533 */     GIR_EraseRootFromParent_Done,
     /*  224534 */   // Label 4708: @224534
     /*  224534 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(224597), // Rule ID 19743 //
     /*  224539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  224542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  224556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  224581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224595 */     GIR_RootConstrainSelectedInstOperands,
     /*  224596 */     // GIR_Coverage, 19743,
     /*  224596 */     GIR_EraseRootFromParent_Done,
     /*  224597 */   // Label 4709: @224597
     /*  224597 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(224660), // Rule ID 19746 //
     /*  224602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  224605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  224619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224641 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  224644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224658 */     GIR_RootConstrainSelectedInstOperands,
     /*  224659 */     // GIR_Coverage, 19746,
     /*  224659 */     GIR_EraseRootFromParent_Done,
     /*  224660 */   // Label 4710: @224660
     /*  224660 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(224723), // Rule ID 19747 //
     /*  224665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  224668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  224682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  224707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224721 */     GIR_RootConstrainSelectedInstOperands,
     /*  224722 */     // GIR_Coverage, 19747,
     /*  224722 */     GIR_EraseRootFromParent_Done,
     /*  224723 */   // Label 4711: @224723
     /*  224723 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(224786), // Rule ID 19750 //
     /*  224728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  224731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  224745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224767 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  224770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224784 */     GIR_RootConstrainSelectedInstOperands,
     /*  224785 */     // GIR_Coverage, 19750,
     /*  224785 */     GIR_EraseRootFromParent_Done,
     /*  224786 */   // Label 4712: @224786
     /*  224786 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(224849), // Rule ID 19751 //
     /*  224791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  224794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  224808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  224833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224847 */     GIR_RootConstrainSelectedInstOperands,
     /*  224848 */     // GIR_Coverage, 19751,
     /*  224848 */     GIR_EraseRootFromParent_Done,
     /*  224849 */   // Label 4713: @224849
     /*  224849 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(224912), // Rule ID 19754 //
     /*  224854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  224857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  224871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224893 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  224896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224910 */     GIR_RootConstrainSelectedInstOperands,
     /*  224911 */     // GIR_Coverage, 19754,
     /*  224911 */     GIR_EraseRootFromParent_Done,
     /*  224912 */   // Label 4714: @224912
     /*  224912 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(224975), // Rule ID 19755 //
     /*  224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  224934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  224959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  224965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224973 */     GIR_RootConstrainSelectedInstOperands,
     /*  224974 */     // GIR_Coverage, 19755,
     /*  224974 */     GIR_EraseRootFromParent_Done,
     /*  224975 */   // Label 4715: @224975
     /*  224975 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(225038), // Rule ID 19758 //
     /*  224980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  224983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  224988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  224997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225019 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  225022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225036 */     GIR_RootConstrainSelectedInstOperands,
     /*  225037 */     // GIR_Coverage, 19758,
     /*  225037 */     GIR_EraseRootFromParent_Done,
     /*  225038 */   // Label 4716: @225038
     /*  225038 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(225101), // Rule ID 19759 //
     /*  225043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  225046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  225057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  225060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225082 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  225085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225099 */     GIR_RootConstrainSelectedInstOperands,
     /*  225100 */     // GIR_Coverage, 19759,
     /*  225100 */     GIR_EraseRootFromParent_Done,
     /*  225101 */   // Label 4717: @225101
     /*  225101 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(225164), // Rule ID 19762 //
     /*  225106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  225109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  225120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  225123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225145 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  225148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225162 */     GIR_RootConstrainSelectedInstOperands,
     /*  225163 */     // GIR_Coverage, 19762,
     /*  225163 */     GIR_EraseRootFromParent_Done,
     /*  225164 */   // Label 4718: @225164
     /*  225164 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(225227), // Rule ID 19763 //
     /*  225169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  225172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  225183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  225186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  225211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225225 */     GIR_RootConstrainSelectedInstOperands,
     /*  225226 */     // GIR_Coverage, 19763,
     /*  225226 */     GIR_EraseRootFromParent_Done,
     /*  225227 */   // Label 4719: @225227
     /*  225227 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(225290), // Rule ID 19766 //
     /*  225232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  225235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  225249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  225274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225288 */     GIR_RootConstrainSelectedInstOperands,
     /*  225289 */     // GIR_Coverage, 19766,
     /*  225289 */     GIR_EraseRootFromParent_Done,
     /*  225290 */   // Label 4720: @225290
     /*  225290 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(225353), // Rule ID 19767 //
     /*  225295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  225298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  225312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225334 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  225337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225351 */     GIR_RootConstrainSelectedInstOperands,
     /*  225352 */     // GIR_Coverage, 19767,
     /*  225352 */     GIR_EraseRootFromParent_Done,
     /*  225353 */   // Label 4721: @225353
     /*  225353 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(225416), // Rule ID 19770 //
     /*  225358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  225361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  225375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225397 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  225400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225414 */     GIR_RootConstrainSelectedInstOperands,
     /*  225415 */     // GIR_Coverage, 19770,
     /*  225415 */     GIR_EraseRootFromParent_Done,
     /*  225416 */   // Label 4722: @225416
     /*  225416 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(225479), // Rule ID 19771 //
     /*  225421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  225424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  225438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  225463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225477 */     GIR_RootConstrainSelectedInstOperands,
     /*  225478 */     // GIR_Coverage, 19771,
     /*  225478 */     GIR_EraseRootFromParent_Done,
     /*  225479 */   // Label 4723: @225479
     /*  225479 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(225542), // Rule ID 19774 //
     /*  225484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  225487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  225501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225523 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  225526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225540 */     GIR_RootConstrainSelectedInstOperands,
     /*  225541 */     // GIR_Coverage, 19774,
     /*  225541 */     GIR_EraseRootFromParent_Done,
     /*  225542 */   // Label 4724: @225542
     /*  225542 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(225605), // Rule ID 19775 //
     /*  225547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  225550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  225564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225586 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  225589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225603 */     GIR_RootConstrainSelectedInstOperands,
     /*  225604 */     // GIR_Coverage, 19775,
     /*  225604 */     GIR_EraseRootFromParent_Done,
     /*  225605 */   // Label 4725: @225605
     /*  225605 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(225668), // Rule ID 19778 //
     /*  225610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  225613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  225627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225649 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  225652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225666 */     GIR_RootConstrainSelectedInstOperands,
     /*  225667 */     // GIR_Coverage, 19778,
     /*  225667 */     GIR_EraseRootFromParent_Done,
     /*  225668 */   // Label 4726: @225668
     /*  225668 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(225731), // Rule ID 19779 //
     /*  225673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  225676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  225690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  225715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225729 */     GIR_RootConstrainSelectedInstOperands,
     /*  225730 */     // GIR_Coverage, 19779,
     /*  225730 */     GIR_EraseRootFromParent_Done,
     /*  225731 */   // Label 4727: @225731
     /*  225731 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(225794), // Rule ID 19782 //
     /*  225736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  225739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  225753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225775 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  225778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225792 */     GIR_RootConstrainSelectedInstOperands,
     /*  225793 */     // GIR_Coverage, 19782,
     /*  225793 */     GIR_EraseRootFromParent_Done,
     /*  225794 */   // Label 4728: @225794
     /*  225794 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(225857), // Rule ID 19783 //
     /*  225799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  225802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  225816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  225841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225855 */     GIR_RootConstrainSelectedInstOperands,
     /*  225856 */     // GIR_Coverage, 19783,
     /*  225856 */     GIR_EraseRootFromParent_Done,
     /*  225857 */   // Label 4729: @225857
     /*  225857 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(225920), // Rule ID 19786 //
     /*  225862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  225865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  225879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225901 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  225904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225918 */     GIR_RootConstrainSelectedInstOperands,
     /*  225919 */     // GIR_Coverage, 19786,
     /*  225919 */     GIR_EraseRootFromParent_Done,
     /*  225920 */   // Label 4730: @225920
     /*  225920 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(225983), // Rule ID 19787 //
     /*  225925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  225928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  225942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  225967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  225973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225981 */     GIR_RootConstrainSelectedInstOperands,
     /*  225982 */     // GIR_Coverage, 19787,
     /*  225982 */     GIR_EraseRootFromParent_Done,
     /*  225983 */   // Label 4731: @225983
     /*  225983 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(226046), // Rule ID 19790 //
     /*  225988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  225991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  225996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  226005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226027 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  226030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226044 */     GIR_RootConstrainSelectedInstOperands,
     /*  226045 */     // GIR_Coverage, 19790,
     /*  226045 */     GIR_EraseRootFromParent_Done,
     /*  226046 */   // Label 4732: @226046
     /*  226046 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(226109), // Rule ID 19791 //
     /*  226051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  226054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  226068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  226093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226107 */     GIR_RootConstrainSelectedInstOperands,
     /*  226108 */     // GIR_Coverage, 19791,
     /*  226108 */     GIR_EraseRootFromParent_Done,
     /*  226109 */   // Label 4733: @226109
     /*  226109 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(226172), // Rule ID 19794 //
     /*  226114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  226117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  226131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226153 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  226156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226170 */     GIR_RootConstrainSelectedInstOperands,
     /*  226171 */     // GIR_Coverage, 19794,
     /*  226171 */     GIR_EraseRootFromParent_Done,
     /*  226172 */   // Label 4734: @226172
     /*  226172 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(226235), // Rule ID 19795 //
     /*  226177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  226180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  226194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  226219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226233 */     GIR_RootConstrainSelectedInstOperands,
     /*  226234 */     // GIR_Coverage, 19795,
     /*  226234 */     GIR_EraseRootFromParent_Done,
     /*  226235 */   // Label 4735: @226235
     /*  226235 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(226298), // Rule ID 19798 //
     /*  226240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  226243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  226257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226279 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  226282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226296 */     GIR_RootConstrainSelectedInstOperands,
     /*  226297 */     // GIR_Coverage, 19798,
     /*  226297 */     GIR_EraseRootFromParent_Done,
     /*  226298 */   // Label 4736: @226298
     /*  226298 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(226361), // Rule ID 19799 //
     /*  226303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  226306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  226320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  226345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226359 */     GIR_RootConstrainSelectedInstOperands,
     /*  226360 */     // GIR_Coverage, 19799,
     /*  226360 */     GIR_EraseRootFromParent_Done,
     /*  226361 */   // Label 4737: @226361
     /*  226361 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(226424), // Rule ID 19802 //
     /*  226366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  226369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226405 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  226408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226422 */     GIR_RootConstrainSelectedInstOperands,
     /*  226423 */     // GIR_Coverage, 19802,
     /*  226423 */     GIR_EraseRootFromParent_Done,
     /*  226424 */   // Label 4738: @226424
     /*  226424 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(226487), // Rule ID 19803 //
     /*  226429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  226432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  226471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226485 */     GIR_RootConstrainSelectedInstOperands,
     /*  226486 */     // GIR_Coverage, 19803,
     /*  226486 */     GIR_EraseRootFromParent_Done,
     /*  226487 */   // Label 4739: @226487
     /*  226487 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(226550), // Rule ID 19806 //
     /*  226492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  226495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226531 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  226534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226548 */     GIR_RootConstrainSelectedInstOperands,
     /*  226549 */     // GIR_Coverage, 19806,
     /*  226549 */     GIR_EraseRootFromParent_Done,
     /*  226550 */   // Label 4740: @226550
     /*  226550 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(226613), // Rule ID 19807 //
     /*  226555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  226558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  226597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226611 */     GIR_RootConstrainSelectedInstOperands,
     /*  226612 */     // GIR_Coverage, 19807,
     /*  226612 */     GIR_EraseRootFromParent_Done,
     /*  226613 */   // Label 4741: @226613
     /*  226613 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(226676), // Rule ID 19810 //
     /*  226618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  226621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  226632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  226650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226657 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  226660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226674 */     GIR_RootConstrainSelectedInstOperands,
     /*  226675 */     // GIR_Coverage, 19810,
     /*  226675 */     GIR_EraseRootFromParent_Done,
     /*  226676 */   // Label 4742: @226676
     /*  226676 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(226739), // Rule ID 19811 //
     /*  226681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  226684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  226695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  226713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  226723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226737 */     GIR_RootConstrainSelectedInstOperands,
     /*  226738 */     // GIR_Coverage, 19811,
     /*  226738 */     GIR_EraseRootFromParent_Done,
     /*  226739 */   // Label 4743: @226739
     /*  226739 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(226802), // Rule ID 19814 //
     /*  226744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  226747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  226758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  226786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226800 */     GIR_RootConstrainSelectedInstOperands,
     /*  226801 */     // GIR_Coverage, 19814,
     /*  226801 */     GIR_EraseRootFromParent_Done,
     /*  226802 */   // Label 4744: @226802
     /*  226802 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(226865), // Rule ID 19815 //
     /*  226807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  226810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  226821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  226824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  226839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  226849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226863 */     GIR_RootConstrainSelectedInstOperands,
     /*  226864 */     // GIR_Coverage, 19815,
     /*  226864 */     GIR_EraseRootFromParent_Done,
     /*  226865 */   // Label 4745: @226865
     /*  226865 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(226928), // Rule ID 19818 //
     /*  226870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  226873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  226884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  226902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226909 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  226912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226926 */     GIR_RootConstrainSelectedInstOperands,
     /*  226927 */     // GIR_Coverage, 19818,
     /*  226927 */     GIR_EraseRootFromParent_Done,
     /*  226928 */   // Label 4746: @226928
     /*  226928 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(226991), // Rule ID 19819 //
     /*  226933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  226936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  226941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  226947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  226965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  226975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  226981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226989 */     GIR_RootConstrainSelectedInstOperands,
     /*  226990 */     // GIR_Coverage, 19819,
     /*  226990 */     GIR_EraseRootFromParent_Done,
     /*  226991 */   // Label 4747: @226991
     /*  226991 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(227054), // Rule ID 19822 //
     /*  226996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  226999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  227028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227035 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  227035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  227038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227052 */     GIR_RootConstrainSelectedInstOperands,
     /*  227053 */     // GIR_Coverage, 19822,
     /*  227053 */     GIR_EraseRootFromParent_Done,
     /*  227054 */   // Label 4748: @227054
     /*  227054 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(227117), // Rule ID 19823 //
     /*  227059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  227062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  227091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  227098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  227101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227115 */     GIR_RootConstrainSelectedInstOperands,
     /*  227116 */     // GIR_Coverage, 19823,
     /*  227116 */     GIR_EraseRootFromParent_Done,
     /*  227117 */   // Label 4749: @227117
     /*  227117 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(227180), // Rule ID 19826 //
     /*  227122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  227125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  227136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227161 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  227164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227178 */     GIR_RootConstrainSelectedInstOperands,
     /*  227179 */     // GIR_Coverage, 19826,
     /*  227179 */     GIR_EraseRootFromParent_Done,
     /*  227180 */   // Label 4750: @227180
     /*  227180 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(227243), // Rule ID 19827 //
     /*  227185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  227188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  227199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  227227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227241 */     GIR_RootConstrainSelectedInstOperands,
     /*  227242 */     // GIR_Coverage, 19827,
     /*  227242 */     GIR_EraseRootFromParent_Done,
     /*  227243 */   // Label 4751: @227243
     /*  227243 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(227306), // Rule ID 19830 //
     /*  227248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  227251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  227262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  227290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227304 */     GIR_RootConstrainSelectedInstOperands,
     /*  227305 */     // GIR_Coverage, 19830,
     /*  227305 */     GIR_EraseRootFromParent_Done,
     /*  227306 */   // Label 4752: @227306
     /*  227306 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(227369), // Rule ID 19831 //
     /*  227311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  227314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  227325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  227353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227367 */     GIR_RootConstrainSelectedInstOperands,
     /*  227368 */     // GIR_Coverage, 19831,
     /*  227368 */     GIR_EraseRootFromParent_Done,
     /*  227369 */   // Label 4753: @227369
     /*  227369 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(227432), // Rule ID 19834 //
     /*  227374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  227377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  227388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227413 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  227416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227430 */     GIR_RootConstrainSelectedInstOperands,
     /*  227431 */     // GIR_Coverage, 19834,
     /*  227431 */     GIR_EraseRootFromParent_Done,
     /*  227432 */   // Label 4754: @227432
     /*  227432 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(227495), // Rule ID 19835 //
     /*  227437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  227440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  227451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  227454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  227469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  227479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227493 */     GIR_RootConstrainSelectedInstOperands,
     /*  227494 */     // GIR_Coverage, 19835,
     /*  227494 */     GIR_EraseRootFromParent_Done,
     /*  227495 */   // Label 4755: @227495
     /*  227495 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(227558), // Rule ID 19838 //
     /*  227500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  227503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  227514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227539 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  227542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227556 */     GIR_RootConstrainSelectedInstOperands,
     /*  227557 */     // GIR_Coverage, 19838,
     /*  227557 */     GIR_EraseRootFromParent_Done,
     /*  227558 */   // Label 4756: @227558
     /*  227558 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(227621), // Rule ID 19839 //
     /*  227563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  227566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  227577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  227605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227619 */     GIR_RootConstrainSelectedInstOperands,
     /*  227620 */     // GIR_Coverage, 19839,
     /*  227620 */     GIR_EraseRootFromParent_Done,
     /*  227621 */   // Label 4757: @227621
     /*  227621 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(227684), // Rule ID 19842 //
     /*  227626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  227629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  227640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227665 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  227668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227682 */     GIR_RootConstrainSelectedInstOperands,
     /*  227683 */     // GIR_Coverage, 19842,
     /*  227683 */     GIR_EraseRootFromParent_Done,
     /*  227684 */   // Label 4758: @227684
     /*  227684 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(227747), // Rule ID 19843 //
     /*  227689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  227692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  227703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  227731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227745 */     GIR_RootConstrainSelectedInstOperands,
     /*  227746 */     // GIR_Coverage, 19843,
     /*  227746 */     GIR_EraseRootFromParent_Done,
     /*  227747 */   // Label 4759: @227747
     /*  227747 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(227810), // Rule ID 19846 //
     /*  227752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  227755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  227766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  227794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227808 */     GIR_RootConstrainSelectedInstOperands,
     /*  227809 */     // GIR_Coverage, 19846,
     /*  227809 */     GIR_EraseRootFromParent_Done,
     /*  227810 */   // Label 4760: @227810
     /*  227810 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(227873), // Rule ID 19847 //
     /*  227815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  227818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  227829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  227847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  227857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227871 */     GIR_RootConstrainSelectedInstOperands,
     /*  227872 */     // GIR_Coverage, 19847,
     /*  227872 */     GIR_EraseRootFromParent_Done,
     /*  227873 */   // Label 4761: @227873
     /*  227873 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(227936), // Rule ID 19850 //
     /*  227878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  227881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  227892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  227910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227917 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  227917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  227920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227934 */     GIR_RootConstrainSelectedInstOperands,
     /*  227935 */     // GIR_Coverage, 19850,
     /*  227935 */     GIR_EraseRootFromParent_Done,
     /*  227936 */   // Label 4762: @227936
     /*  227936 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(227999), // Rule ID 19851 //
     /*  227941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  227944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  227949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  227955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  227973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  227980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  227983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  227989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227997 */     GIR_RootConstrainSelectedInstOperands,
     /*  227998 */     // GIR_Coverage, 19851,
     /*  227998 */     GIR_EraseRootFromParent_Done,
     /*  227999 */   // Label 4763: @227999
     /*  227999 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(228062), // Rule ID 19854 //
     /*  228004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  228007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  228012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  228018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  228036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228043 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  228046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228060 */     GIR_RootConstrainSelectedInstOperands,
     /*  228061 */     // GIR_Coverage, 19854,
     /*  228061 */     GIR_EraseRootFromParent_Done,
     /*  228062 */   // Label 4764: @228062
     /*  228062 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(228125), // Rule ID 19855 //
     /*  228067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  228070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  228075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  228081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  228099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  228109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228123 */     GIR_RootConstrainSelectedInstOperands,
     /*  228124 */     // GIR_Coverage, 19855,
     /*  228124 */     GIR_EraseRootFromParent_Done,
     /*  228125 */   // Label 4765: @228125
     /*  228125 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(228188), // Rule ID 19858 //
     /*  228130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  228133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  228138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  228144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  228162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  228172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228186 */     GIR_RootConstrainSelectedInstOperands,
     /*  228187 */     // GIR_Coverage, 19858,
     /*  228187 */     GIR_EraseRootFromParent_Done,
     /*  228188 */   // Label 4766: @228188
     /*  228188 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(228251), // Rule ID 19859 //
     /*  228193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  228196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  228201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  228207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  228225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  228235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228249 */     GIR_RootConstrainSelectedInstOperands,
     /*  228250 */     // GIR_Coverage, 19859,
     /*  228250 */     GIR_EraseRootFromParent_Done,
     /*  228251 */   // Label 4767: @228251
     /*  228251 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(228314), // Rule ID 19862 //
     /*  228256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  228259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  228270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  228273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228295 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  228298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228312 */     GIR_RootConstrainSelectedInstOperands,
     /*  228313 */     // GIR_Coverage, 19862,
     /*  228313 */     GIR_EraseRootFromParent_Done,
     /*  228314 */   // Label 4768: @228314
     /*  228314 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(228377), // Rule ID 19863 //
     /*  228319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  228322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  228333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  228336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  228361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228375 */     GIR_RootConstrainSelectedInstOperands,
     /*  228376 */     // GIR_Coverage, 19863,
     /*  228376 */     GIR_EraseRootFromParent_Done,
     /*  228377 */   // Label 4769: @228377
     /*  228377 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(228440), // Rule ID 19866 //
     /*  228382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  228385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  228396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  228399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228421 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  228424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228438 */     GIR_RootConstrainSelectedInstOperands,
     /*  228439 */     // GIR_Coverage, 19866,
     /*  228439 */     GIR_EraseRootFromParent_Done,
     /*  228440 */   // Label 4770: @228440
     /*  228440 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(228503), // Rule ID 19867 //
     /*  228445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  228448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  228459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  228462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  228487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228501 */     GIR_RootConstrainSelectedInstOperands,
     /*  228502 */     // GIR_Coverage, 19867,
     /*  228502 */     GIR_EraseRootFromParent_Done,
     /*  228503 */   // Label 4771: @228503
     /*  228503 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(228566), // Rule ID 19870 //
     /*  228508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  228511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  228522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  228525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228547 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  228550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228564 */     GIR_RootConstrainSelectedInstOperands,
     /*  228565 */     // GIR_Coverage, 19870,
     /*  228565 */     GIR_EraseRootFromParent_Done,
     /*  228566 */   // Label 4772: @228566
     /*  228566 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(228629), // Rule ID 19871 //
     /*  228571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  228574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  228585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  228588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  228613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228627 */     GIR_RootConstrainSelectedInstOperands,
     /*  228628 */     // GIR_Coverage, 19871,
     /*  228628 */     GIR_EraseRootFromParent_Done,
     /*  228629 */   // Label 4773: @228629
     /*  228629 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(228692), // Rule ID 19874 //
     /*  228634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  228637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  228648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  228651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228690 */     GIR_RootConstrainSelectedInstOperands,
     /*  228691 */     // GIR_Coverage, 19874,
     /*  228691 */     GIR_EraseRootFromParent_Done,
     /*  228692 */   // Label 4774: @228692
     /*  228692 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(228755), // Rule ID 19875 //
     /*  228697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  228700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  228711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  228714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228753 */     GIR_RootConstrainSelectedInstOperands,
     /*  228754 */     // GIR_Coverage, 19875,
     /*  228754 */     GIR_EraseRootFromParent_Done,
     /*  228755 */   // Label 4775: @228755
     /*  228755 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(228818), // Rule ID 19878 //
     /*  228760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  228763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  228777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228799 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228816 */     GIR_RootConstrainSelectedInstOperands,
     /*  228817 */     // GIR_Coverage, 19878,
     /*  228817 */     GIR_EraseRootFromParent_Done,
     /*  228818 */   // Label 4776: @228818
     /*  228818 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(228881), // Rule ID 19879 //
     /*  228823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  228826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  228840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228879 */     GIR_RootConstrainSelectedInstOperands,
     /*  228880 */     // GIR_Coverage, 19879,
     /*  228880 */     GIR_EraseRootFromParent_Done,
     /*  228881 */   // Label 4777: @228881
     /*  228881 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(228944), // Rule ID 19882 //
     /*  228886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  228889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  228903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228942 */     GIR_RootConstrainSelectedInstOperands,
     /*  228943 */     // GIR_Coverage, 19882,
     /*  228943 */     GIR_EraseRootFromParent_Done,
     /*  228944 */   // Label 4778: @228944
     /*  228944 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(229007), // Rule ID 19883 //
     /*  228949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  228952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  228957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  228966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  228991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  228997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229005 */     GIR_RootConstrainSelectedInstOperands,
     /*  229006 */     // GIR_Coverage, 19883,
     /*  229006 */     GIR_EraseRootFromParent_Done,
     /*  229007 */   // Label 4779: @229007
     /*  229007 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(229070), // Rule ID 19886 //
     /*  229012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  229015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  229026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  229029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229051 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229068 */     GIR_RootConstrainSelectedInstOperands,
     /*  229069 */     // GIR_Coverage, 19886,
     /*  229069 */     GIR_EraseRootFromParent_Done,
     /*  229070 */   // Label 4780: @229070
     /*  229070 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(229133), // Rule ID 19887 //
     /*  229075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  229078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  229089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  229092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229131 */     GIR_RootConstrainSelectedInstOperands,
     /*  229132 */     // GIR_Coverage, 19887,
     /*  229132 */     GIR_EraseRootFromParent_Done,
     /*  229133 */   // Label 4781: @229133
     /*  229133 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(229196), // Rule ID 19890 //
     /*  229138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  229141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  229152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  229155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229177 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229194 */     GIR_RootConstrainSelectedInstOperands,
     /*  229195 */     // GIR_Coverage, 19890,
     /*  229195 */     GIR_EraseRootFromParent_Done,
     /*  229196 */   // Label 4782: @229196
     /*  229196 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(229259), // Rule ID 19891 //
     /*  229201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  229204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  229215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  229218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229257 */     GIR_RootConstrainSelectedInstOperands,
     /*  229258 */     // GIR_Coverage, 19891,
     /*  229258 */     GIR_EraseRootFromParent_Done,
     /*  229259 */   // Label 4783: @229259
     /*  229259 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(229322), // Rule ID 19894 //
     /*  229264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  229267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  229281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229303 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  229306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229320 */     GIR_RootConstrainSelectedInstOperands,
     /*  229321 */     // GIR_Coverage, 19894,
     /*  229321 */     GIR_EraseRootFromParent_Done,
     /*  229322 */   // Label 4784: @229322
     /*  229322 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(229385), // Rule ID 19895 //
     /*  229327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  229330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  229344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229366 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  229369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229383 */     GIR_RootConstrainSelectedInstOperands,
     /*  229384 */     // GIR_Coverage, 19895,
     /*  229384 */     GIR_EraseRootFromParent_Done,
     /*  229385 */   // Label 4785: @229385
     /*  229385 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(229448), // Rule ID 19898 //
     /*  229390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  229393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  229407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229429 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229446 */     GIR_RootConstrainSelectedInstOperands,
     /*  229447 */     // GIR_Coverage, 19898,
     /*  229447 */     GIR_EraseRootFromParent_Done,
     /*  229448 */   // Label 4786: @229448
     /*  229448 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(229511), // Rule ID 19899 //
     /*  229453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  229456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  229470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229509 */     GIR_RootConstrainSelectedInstOperands,
     /*  229510 */     // GIR_Coverage, 19899,
     /*  229510 */     GIR_EraseRootFromParent_Done,
     /*  229511 */   // Label 4787: @229511
     /*  229511 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(229574), // Rule ID 19902 //
     /*  229516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  229519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  229533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229555 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229572 */     GIR_RootConstrainSelectedInstOperands,
     /*  229573 */     // GIR_Coverage, 19902,
     /*  229573 */     GIR_EraseRootFromParent_Done,
     /*  229574 */   // Label 4788: @229574
     /*  229574 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(229637), // Rule ID 19903 //
     /*  229579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  229582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  229596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229635 */     GIR_RootConstrainSelectedInstOperands,
     /*  229636 */     // GIR_Coverage, 19903,
     /*  229636 */     GIR_EraseRootFromParent_Done,
     /*  229637 */   // Label 4789: @229637
     /*  229637 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(229700), // Rule ID 19906 //
     /*  229642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  229645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  229659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229681 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  229684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229698 */     GIR_RootConstrainSelectedInstOperands,
     /*  229699 */     // GIR_Coverage, 19906,
     /*  229699 */     GIR_EraseRootFromParent_Done,
     /*  229700 */   // Label 4790: @229700
     /*  229700 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(229763), // Rule ID 19907 //
     /*  229705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  229708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  229722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  229747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229761 */     GIR_RootConstrainSelectedInstOperands,
     /*  229762 */     // GIR_Coverage, 19907,
     /*  229762 */     GIR_EraseRootFromParent_Done,
     /*  229763 */   // Label 4791: @229763
     /*  229763 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(229826), // Rule ID 19910 //
     /*  229768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  229771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  229785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229824 */     GIR_RootConstrainSelectedInstOperands,
     /*  229825 */     // GIR_Coverage, 19910,
     /*  229825 */     GIR_EraseRootFromParent_Done,
     /*  229826 */   // Label 4792: @229826
     /*  229826 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(229889), // Rule ID 19911 //
     /*  229831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  229834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  229848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  229873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229887 */     GIR_RootConstrainSelectedInstOperands,
     /*  229888 */     // GIR_Coverage, 19911,
     /*  229888 */     GIR_EraseRootFromParent_Done,
     /*  229889 */   // Label 4793: @229889
     /*  229889 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(229952), // Rule ID 19914 //
     /*  229894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  229897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  229911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229933 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  229942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229950 */     GIR_RootConstrainSelectedInstOperands,
     /*  229951 */     // GIR_Coverage, 19914,
     /*  229951 */     GIR_EraseRootFromParent_Done,
     /*  229952 */   // Label 4794: @229952
     /*  229952 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(230015), // Rule ID 19915 //
     /*  229957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  229960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  229965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  229974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  229999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230013 */     GIR_RootConstrainSelectedInstOperands,
     /*  230014 */     // GIR_Coverage, 19915,
     /*  230014 */     GIR_EraseRootFromParent_Done,
     /*  230015 */   // Label 4795: @230015
     /*  230015 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(230078), // Rule ID 19918 //
     /*  230020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  230023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  230034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  230037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230059 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  230059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  230062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230076 */     GIR_RootConstrainSelectedInstOperands,
     /*  230077 */     // GIR_Coverage, 19918,
     /*  230077 */     GIR_EraseRootFromParent_Done,
     /*  230078 */   // Label 4796: @230078
     /*  230078 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(230141), // Rule ID 19919 //
     /*  230083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  230086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  230097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  230100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  230125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230139 */     GIR_RootConstrainSelectedInstOperands,
     /*  230140 */     // GIR_Coverage, 19919,
     /*  230140 */     GIR_EraseRootFromParent_Done,
     /*  230141 */   // Label 4797: @230141
     /*  230141 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(230204), // Rule ID 19922 //
     /*  230146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  230149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230185 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  230188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230202 */     GIR_RootConstrainSelectedInstOperands,
     /*  230203 */     // GIR_Coverage, 19922,
     /*  230203 */     GIR_EraseRootFromParent_Done,
     /*  230204 */   // Label 4798: @230204
     /*  230204 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(230267), // Rule ID 19923 //
     /*  230209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  230212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  230251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230265 */     GIR_RootConstrainSelectedInstOperands,
     /*  230266 */     // GIR_Coverage, 19923,
     /*  230266 */     GIR_EraseRootFromParent_Done,
     /*  230267 */   // Label 4799: @230267
     /*  230267 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(230330), // Rule ID 19926 //
     /*  230272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  230275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230311 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  230314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230328 */     GIR_RootConstrainSelectedInstOperands,
     /*  230329 */     // GIR_Coverage, 19926,
     /*  230329 */     GIR_EraseRootFromParent_Done,
     /*  230330 */   // Label 4800: @230330
     /*  230330 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(230393), // Rule ID 19927 //
     /*  230335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  230338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  230377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230391 */     GIR_RootConstrainSelectedInstOperands,
     /*  230392 */     // GIR_Coverage, 19927,
     /*  230392 */     GIR_EraseRootFromParent_Done,
     /*  230393 */   // Label 4801: @230393
     /*  230393 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(230456), // Rule ID 19930 //
     /*  230398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  230401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  230430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230437 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  230440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230454 */     GIR_RootConstrainSelectedInstOperands,
     /*  230455 */     // GIR_Coverage, 19930,
     /*  230455 */     GIR_EraseRootFromParent_Done,
     /*  230456 */   // Label 4802: @230456
     /*  230456 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(230519), // Rule ID 19931 //
     /*  230461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  230464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  230493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  230503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230517 */     GIR_RootConstrainSelectedInstOperands,
     /*  230518 */     // GIR_Coverage, 19931,
     /*  230518 */     GIR_EraseRootFromParent_Done,
     /*  230519 */   // Label 4803: @230519
     /*  230519 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(230582), // Rule ID 19934 //
     /*  230524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  230527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  230566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230580 */     GIR_RootConstrainSelectedInstOperands,
     /*  230581 */     // GIR_Coverage, 19934,
     /*  230581 */     GIR_EraseRootFromParent_Done,
     /*  230582 */   // Label 4804: @230582
     /*  230582 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(230645), // Rule ID 19935 //
     /*  230587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  230590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  230629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230643 */     GIR_RootConstrainSelectedInstOperands,
     /*  230644 */     // GIR_Coverage, 19935,
     /*  230644 */     GIR_EraseRootFromParent_Done,
     /*  230645 */   // Label 4805: @230645
     /*  230645 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(230708), // Rule ID 19938 //
     /*  230650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  230653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  230682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230689 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  230692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230706 */     GIR_RootConstrainSelectedInstOperands,
     /*  230707 */     // GIR_Coverage, 19938,
     /*  230707 */     GIR_EraseRootFromParent_Done,
     /*  230708 */   // Label 4806: @230708
     /*  230708 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(230771), // Rule ID 19939 //
     /*  230713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  230716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  230745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  230755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230769 */     GIR_RootConstrainSelectedInstOperands,
     /*  230770 */     // GIR_Coverage, 19939,
     /*  230770 */     GIR_EraseRootFromParent_Done,
     /*  230771 */   // Label 4807: @230771
     /*  230771 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(230834), // Rule ID 19942 //
     /*  230776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  230779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  230808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230815 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  230815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  230818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230832 */     GIR_RootConstrainSelectedInstOperands,
     /*  230833 */     // GIR_Coverage, 19942,
     /*  230833 */     GIR_EraseRootFromParent_Done,
     /*  230834 */   // Label 4808: @230834
     /*  230834 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(230897), // Rule ID 19943 //
     /*  230839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  230842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  230871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  230881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230895 */     GIR_RootConstrainSelectedInstOperands,
     /*  230896 */     // GIR_Coverage, 19943,
     /*  230896 */     GIR_EraseRootFromParent_Done,
     /*  230897 */   // Label 4809: @230897
     /*  230897 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(230960), // Rule ID 19946 //
     /*  230902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  230905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  230916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  230930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230941 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  230944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  230950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230958 */     GIR_RootConstrainSelectedInstOperands,
     /*  230959 */     // GIR_Coverage, 19946,
     /*  230959 */     GIR_EraseRootFromParent_Done,
     /*  230960 */   // Label 4810: @230960
     /*  230960 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(231023), // Rule ID 19947 //
     /*  230965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  230968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  230973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  230979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  230982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  230993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  230997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  231007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231021 */     GIR_RootConstrainSelectedInstOperands,
     /*  231022 */     // GIR_Coverage, 19947,
     /*  231022 */     GIR_EraseRootFromParent_Done,
     /*  231023 */   // Label 4811: @231023
     /*  231023 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(231086), // Rule ID 19950 //
     /*  231028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  231031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  231045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  231060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  231070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231084 */     GIR_RootConstrainSelectedInstOperands,
     /*  231085 */     // GIR_Coverage, 19950,
     /*  231085 */     GIR_EraseRootFromParent_Done,
     /*  231086 */   // Label 4812: @231086
     /*  231086 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(231149), // Rule ID 19951 //
     /*  231091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  231094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  231108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  231123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  231133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231147 */     GIR_RootConstrainSelectedInstOperands,
     /*  231148 */     // GIR_Coverage, 19951,
     /*  231148 */     GIR_EraseRootFromParent_Done,
     /*  231149 */   // Label 4813: @231149
     /*  231149 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(231212), // Rule ID 19954 //
     /*  231154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  231157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  231171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  231186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231193 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  231196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231210 */     GIR_RootConstrainSelectedInstOperands,
     /*  231211 */     // GIR_Coverage, 19954,
     /*  231211 */     GIR_EraseRootFromParent_Done,
     /*  231212 */   // Label 4814: @231212
     /*  231212 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(231275), // Rule ID 19955 //
     /*  231217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  231220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  231234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  231249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231256 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  231259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231273 */     GIR_RootConstrainSelectedInstOperands,
     /*  231274 */     // GIR_Coverage, 19955,
     /*  231274 */     GIR_EraseRootFromParent_Done,
     /*  231275 */   // Label 4815: @231275
     /*  231275 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(231338), // Rule ID 19958 //
     /*  231280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  231283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231319 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  231322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231336 */     GIR_RootConstrainSelectedInstOperands,
     /*  231337 */     // GIR_Coverage, 19958,
     /*  231337 */     GIR_EraseRootFromParent_Done,
     /*  231338 */   // Label 4816: @231338
     /*  231338 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(231401), // Rule ID 19959 //
     /*  231343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  231346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  231385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231399 */     GIR_RootConstrainSelectedInstOperands,
     /*  231400 */     // GIR_Coverage, 19959,
     /*  231400 */     GIR_EraseRootFromParent_Done,
     /*  231401 */   // Label 4817: @231401
     /*  231401 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(231464), // Rule ID 19962 //
     /*  231406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  231409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  231420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231445 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  231448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231462 */     GIR_RootConstrainSelectedInstOperands,
     /*  231463 */     // GIR_Coverage, 19962,
     /*  231463 */     GIR_EraseRootFromParent_Done,
     /*  231464 */   // Label 4818: @231464
     /*  231464 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(231527), // Rule ID 19963 //
     /*  231469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  231472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  231483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  231511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231525 */     GIR_RootConstrainSelectedInstOperands,
     /*  231526 */     // GIR_Coverage, 19963,
     /*  231526 */     GIR_EraseRootFromParent_Done,
     /*  231527 */   // Label 4819: @231527
     /*  231527 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(231590), // Rule ID 19966 //
     /*  231532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  231535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  231546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  231574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231588 */     GIR_RootConstrainSelectedInstOperands,
     /*  231589 */     // GIR_Coverage, 19966,
     /*  231589 */     GIR_EraseRootFromParent_Done,
     /*  231590 */   // Label 4820: @231590
     /*  231590 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(231653), // Rule ID 19967 //
     /*  231595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  231598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  231609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  231627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  231637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231651 */     GIR_RootConstrainSelectedInstOperands,
     /*  231652 */     // GIR_Coverage, 19967,
     /*  231652 */     GIR_EraseRootFromParent_Done,
     /*  231653 */   // Label 4821: @231653
     /*  231653 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(231716), // Rule ID 19970 //
     /*  231658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  231661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  231672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  231690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  231700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231714 */     GIR_RootConstrainSelectedInstOperands,
     /*  231715 */     // GIR_Coverage, 19970,
     /*  231715 */     GIR_EraseRootFromParent_Done,
     /*  231716 */   // Label 4822: @231716
     /*  231716 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(231779), // Rule ID 19971 //
     /*  231721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  231724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  231735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  231753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  231763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231777 */     GIR_RootConstrainSelectedInstOperands,
     /*  231778 */     // GIR_Coverage, 19971,
     /*  231778 */     GIR_EraseRootFromParent_Done,
     /*  231779 */   // Label 4823: @231779
     /*  231779 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(231842), // Rule ID 19974 //
     /*  231784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  231787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  231798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  231816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  231826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231840 */     GIR_RootConstrainSelectedInstOperands,
     /*  231841 */     // GIR_Coverage, 19974,
     /*  231841 */     GIR_EraseRootFromParent_Done,
     /*  231842 */   // Label 4824: @231842
     /*  231842 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(231905), // Rule ID 19975 //
     /*  231847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  231850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  231861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  231879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  231889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231903 */     GIR_RootConstrainSelectedInstOperands,
     /*  231904 */     // GIR_Coverage, 19975,
     /*  231904 */     GIR_EraseRootFromParent_Done,
     /*  231905 */   // Label 4825: @231905
     /*  231905 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(231968), // Rule ID 19978 //
     /*  231910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  231913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  231924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  231942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  231952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  231958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231966 */     GIR_RootConstrainSelectedInstOperands,
     /*  231967 */     // GIR_Coverage, 19978,
     /*  231967 */     GIR_EraseRootFromParent_Done,
     /*  231968 */   // Label 4826: @231968
     /*  231968 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(232031), // Rule ID 19979 //
     /*  231973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  231976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  231981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  231987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  232005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  232015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232029 */     GIR_RootConstrainSelectedInstOperands,
     /*  232030 */     // GIR_Coverage, 19979,
     /*  232030 */     GIR_EraseRootFromParent_Done,
     /*  232031 */   // Label 4827: @232031
     /*  232031 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(232094), // Rule ID 19982 //
     /*  232036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  232039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  232050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  232053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  232078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232092 */     GIR_RootConstrainSelectedInstOperands,
     /*  232093 */     // GIR_Coverage, 19982,
     /*  232093 */     GIR_EraseRootFromParent_Done,
     /*  232094 */   // Label 4828: @232094
     /*  232094 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(232157), // Rule ID 19983 //
     /*  232099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  232102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  232113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  232116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  232141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232155 */     GIR_RootConstrainSelectedInstOperands,
     /*  232156 */     // GIR_Coverage, 19983,
     /*  232156 */     GIR_EraseRootFromParent_Done,
     /*  232157 */   // Label 4829: @232157
     /*  232157 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(232220), // Rule ID 19986 //
     /*  232162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  232165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  232176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  232179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232201 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  232204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232218 */     GIR_RootConstrainSelectedInstOperands,
     /*  232219 */     // GIR_Coverage, 19986,
     /*  232219 */     GIR_EraseRootFromParent_Done,
     /*  232220 */   // Label 4830: @232220
     /*  232220 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(232283), // Rule ID 19987 //
     /*  232225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  232228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  232239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  232242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  232267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232281 */     GIR_RootConstrainSelectedInstOperands,
     /*  232282 */     // GIR_Coverage, 19987,
     /*  232282 */     GIR_EraseRootFromParent_Done,
     /*  232283 */   // Label 4831: @232283
     /*  232283 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(232346), // Rule ID 19990 //
     /*  232288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  232291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  232302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  232305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  232330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232344 */     GIR_RootConstrainSelectedInstOperands,
     /*  232345 */     // GIR_Coverage, 19990,
     /*  232345 */     GIR_EraseRootFromParent_Done,
     /*  232346 */   // Label 4832: @232346
     /*  232346 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(232409), // Rule ID 19991 //
     /*  232351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  232354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  232365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  232368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  232393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232407 */     GIR_RootConstrainSelectedInstOperands,
     /*  232408 */     // GIR_Coverage, 19991,
     /*  232408 */     GIR_EraseRootFromParent_Done,
     /*  232409 */   // Label 4833: @232409
     /*  232409 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(232472), // Rule ID 19994 //
     /*  232414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  232417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  232428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  232431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232470 */     GIR_RootConstrainSelectedInstOperands,
     /*  232471 */     // GIR_Coverage, 19994,
     /*  232471 */     GIR_EraseRootFromParent_Done,
     /*  232472 */   // Label 4834: @232472
     /*  232472 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(232535), // Rule ID 19995 //
     /*  232477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  232480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  232491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  232494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232533 */     GIR_RootConstrainSelectedInstOperands,
     /*  232534 */     // GIR_Coverage, 19995,
     /*  232534 */     GIR_EraseRootFromParent_Done,
     /*  232535 */   // Label 4835: @232535
     /*  232535 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(232598), // Rule ID 19998 //
     /*  232540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  232543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  232554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  232557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232596 */     GIR_RootConstrainSelectedInstOperands,
     /*  232597 */     // GIR_Coverage, 19998,
     /*  232597 */     GIR_EraseRootFromParent_Done,
     /*  232598 */   // Label 4836: @232598
     /*  232598 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(232661), // Rule ID 19999 //
     /*  232603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  232606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  232617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  232620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232659 */     GIR_RootConstrainSelectedInstOperands,
     /*  232660 */     // GIR_Coverage, 19999,
     /*  232660 */     GIR_EraseRootFromParent_Done,
     /*  232661 */   // Label 4837: @232661
     /*  232661 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(232724), // Rule ID 20002 //
     /*  232666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  232669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  232680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  232683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232722 */     GIR_RootConstrainSelectedInstOperands,
     /*  232723 */     // GIR_Coverage, 20002,
     /*  232723 */     GIR_EraseRootFromParent_Done,
     /*  232724 */   // Label 4838: @232724
     /*  232724 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(232787), // Rule ID 20003 //
     /*  232729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  232732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  232743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  232746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  232771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232785 */     GIR_RootConstrainSelectedInstOperands,
     /*  232786 */     // GIR_Coverage, 20003,
     /*  232786 */     GIR_EraseRootFromParent_Done,
     /*  232787 */   // Label 4839: @232787
     /*  232787 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(232850), // Rule ID 20006 //
     /*  232792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  232795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  232809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  232834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232848 */     GIR_RootConstrainSelectedInstOperands,
     /*  232849 */     // GIR_Coverage, 20006,
     /*  232849 */     GIR_EraseRootFromParent_Done,
     /*  232850 */   // Label 4840: @232850
     /*  232850 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(232913), // Rule ID 20007 //
     /*  232855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  232858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  232872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  232897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232911 */     GIR_RootConstrainSelectedInstOperands,
     /*  232912 */     // GIR_Coverage, 20007,
     /*  232912 */     GIR_EraseRootFromParent_Done,
     /*  232913 */   // Label 4841: @232913
     /*  232913 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(232976), // Rule ID 20010 //
     /*  232918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  232921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  232935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232957 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  232960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  232966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232974 */     GIR_RootConstrainSelectedInstOperands,
     /*  232975 */     // GIR_Coverage, 20010,
     /*  232975 */     GIR_EraseRootFromParent_Done,
     /*  232976 */   // Label 4842: @232976
     /*  232976 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(233039), // Rule ID 20011 //
     /*  232981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  232984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  232989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  232998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  233023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233037 */     GIR_RootConstrainSelectedInstOperands,
     /*  233038 */     // GIR_Coverage, 20011,
     /*  233038 */     GIR_EraseRootFromParent_Done,
     /*  233039 */   // Label 4843: @233039
     /*  233039 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(233102), // Rule ID 20014 //
     /*  233044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  233047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  233055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  233058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  233061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233083 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233100 */     GIR_RootConstrainSelectedInstOperands,
     /*  233101 */     // GIR_Coverage, 20014,
     /*  233101 */     GIR_EraseRootFromParent_Done,
     /*  233102 */   // Label 4844: @233102
     /*  233102 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(233165), // Rule ID 20015 //
     /*  233107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  233110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  233118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  233121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  233124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233146 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233163 */     GIR_RootConstrainSelectedInstOperands,
     /*  233164 */     // GIR_Coverage, 20015,
     /*  233164 */     GIR_EraseRootFromParent_Done,
     /*  233165 */   // Label 4845: @233165
     /*  233165 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(233228), // Rule ID 20018 //
     /*  233170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  233173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  233184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  233187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233209 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  233212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233226 */     GIR_RootConstrainSelectedInstOperands,
     /*  233227 */     // GIR_Coverage, 20018,
     /*  233227 */     GIR_EraseRootFromParent_Done,
     /*  233228 */   // Label 4846: @233228
     /*  233228 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(233291), // Rule ID 20019 //
     /*  233233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  233236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  233247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  233250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  233275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233289 */     GIR_RootConstrainSelectedInstOperands,
     /*  233290 */     // GIR_Coverage, 20019,
     /*  233290 */     GIR_EraseRootFromParent_Done,
     /*  233291 */   // Label 4847: @233291
     /*  233291 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(233354), // Rule ID 20022 //
     /*  233296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  233299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  233310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  233313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  233338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233352 */     GIR_RootConstrainSelectedInstOperands,
     /*  233353 */     // GIR_Coverage, 20022,
     /*  233353 */     GIR_EraseRootFromParent_Done,
     /*  233354 */   // Label 4848: @233354
     /*  233354 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(233417), // Rule ID 20023 //
     /*  233359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  233362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  233373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  233376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  233401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233415 */     GIR_RootConstrainSelectedInstOperands,
     /*  233416 */     // GIR_Coverage, 20023,
     /*  233416 */     GIR_EraseRootFromParent_Done,
     /*  233417 */   // Label 4849: @233417
     /*  233417 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(233480), // Rule ID 20026 //
     /*  233422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  233425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  233433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  233436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  233439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233461 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233478 */     GIR_RootConstrainSelectedInstOperands,
     /*  233479 */     // GIR_Coverage, 20026,
     /*  233479 */     GIR_EraseRootFromParent_Done,
     /*  233480 */   // Label 4850: @233480
     /*  233480 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(233543), // Rule ID 20027 //
     /*  233485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  233488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  233496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  233499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  233502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233541 */     GIR_RootConstrainSelectedInstOperands,
     /*  233542 */     // GIR_Coverage, 20027,
     /*  233542 */     GIR_EraseRootFromParent_Done,
     /*  233543 */   // Label 4851: @233543
     /*  233543 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(233606), // Rule ID 20030 //
     /*  233548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  233551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  233562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  233565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233587 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  233590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233604 */     GIR_RootConstrainSelectedInstOperands,
     /*  233605 */     // GIR_Coverage, 20030,
     /*  233605 */     GIR_EraseRootFromParent_Done,
     /*  233606 */   // Label 4852: @233606
     /*  233606 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(233669), // Rule ID 20031 //
     /*  233611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  233614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  233625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  233628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  233653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233667 */     GIR_RootConstrainSelectedInstOperands,
     /*  233668 */     // GIR_Coverage, 20031,
     /*  233668 */     GIR_EraseRootFromParent_Done,
     /*  233669 */   // Label 4853: @233669
     /*  233669 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(233732), // Rule ID 20034 //
     /*  233674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  233677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  233691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  233716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233730 */     GIR_RootConstrainSelectedInstOperands,
     /*  233731 */     // GIR_Coverage, 20034,
     /*  233731 */     GIR_EraseRootFromParent_Done,
     /*  233732 */   // Label 4854: @233732
     /*  233732 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(233795), // Rule ID 20035 //
     /*  233737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  233740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  233754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  233779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233793 */     GIR_RootConstrainSelectedInstOperands,
     /*  233794 */     // GIR_Coverage, 20035,
     /*  233794 */     GIR_EraseRootFromParent_Done,
     /*  233795 */   // Label 4855: @233795
     /*  233795 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(233858), // Rule ID 20038 //
     /*  233800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  233803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  233817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233839 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233856 */     GIR_RootConstrainSelectedInstOperands,
     /*  233857 */     // GIR_Coverage, 20038,
     /*  233857 */     GIR_EraseRootFromParent_Done,
     /*  233858 */   // Label 4856: @233858
     /*  233858 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(233921), // Rule ID 20039 //
     /*  233863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  233866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  233880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  233905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233919 */     GIR_RootConstrainSelectedInstOperands,
     /*  233920 */     // GIR_Coverage, 20039,
     /*  233920 */     GIR_EraseRootFromParent_Done,
     /*  233921 */   // Label 4857: @233921
     /*  233921 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(233984), // Rule ID 20042 //
     /*  233926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  233929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  233943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  233958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  233968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  233974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233982 */     GIR_RootConstrainSelectedInstOperands,
     /*  233983 */     // GIR_Coverage, 20042,
     /*  233983 */     GIR_EraseRootFromParent_Done,
     /*  233984 */   // Label 4858: @233984
     /*  233984 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(234047), // Rule ID 20043 //
     /*  233989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  233992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  233997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  234003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  234031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234045 */     GIR_RootConstrainSelectedInstOperands,
     /*  234046 */     // GIR_Coverage, 20043,
     /*  234046 */     GIR_EraseRootFromParent_Done,
     /*  234047 */   // Label 4859: @234047
     /*  234047 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(234110), // Rule ID 20046 //
     /*  234052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  234055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  234066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234091 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  234094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234108 */     GIR_RootConstrainSelectedInstOperands,
     /*  234109 */     // GIR_Coverage, 20046,
     /*  234109 */     GIR_EraseRootFromParent_Done,
     /*  234110 */   // Label 4860: @234110
     /*  234110 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(234173), // Rule ID 20047 //
     /*  234115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  234118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  234129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  234157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234171 */     GIR_RootConstrainSelectedInstOperands,
     /*  234172 */     // GIR_Coverage, 20047,
     /*  234172 */     GIR_EraseRootFromParent_Done,
     /*  234173 */   // Label 4861: @234173
     /*  234173 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(234236), // Rule ID 20050 //
     /*  234178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  234181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  234210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234217 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  234220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234234 */     GIR_RootConstrainSelectedInstOperands,
     /*  234235 */     // GIR_Coverage, 20050,
     /*  234235 */     GIR_EraseRootFromParent_Done,
     /*  234236 */   // Label 4862: @234236
     /*  234236 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(234299), // Rule ID 20051 //
     /*  234241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  234244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  234273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  234283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234297 */     GIR_RootConstrainSelectedInstOperands,
     /*  234298 */     // GIR_Coverage, 20051,
     /*  234298 */     GIR_EraseRootFromParent_Done,
     /*  234299 */   // Label 4863: @234299
     /*  234299 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(234362), // Rule ID 20054 //
     /*  234304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  234307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234343 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  234346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234360 */     GIR_RootConstrainSelectedInstOperands,
     /*  234361 */     // GIR_Coverage, 20054,
     /*  234361 */     GIR_EraseRootFromParent_Done,
     /*  234362 */   // Label 4864: @234362
     /*  234362 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(234425), // Rule ID 20055 //
     /*  234367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  234370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  234409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234423 */     GIR_RootConstrainSelectedInstOperands,
     /*  234424 */     // GIR_Coverage, 20055,
     /*  234424 */     GIR_EraseRootFromParent_Done,
     /*  234425 */   // Label 4865: @234425
     /*  234425 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(234488), // Rule ID 20058 //
     /*  234430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  234433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  234462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  234472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234486 */     GIR_RootConstrainSelectedInstOperands,
     /*  234487 */     // GIR_Coverage, 20058,
     /*  234487 */     GIR_EraseRootFromParent_Done,
     /*  234488 */   // Label 4866: @234488
     /*  234488 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(234551), // Rule ID 20059 //
     /*  234493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  234496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  234525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  234535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234549 */     GIR_RootConstrainSelectedInstOperands,
     /*  234550 */     // GIR_Coverage, 20059,
     /*  234550 */     GIR_EraseRootFromParent_Done,
     /*  234551 */   // Label 4867: @234551
     /*  234551 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(234614), // Rule ID 20062 //
     /*  234556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  234559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  234588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  234598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234612 */     GIR_RootConstrainSelectedInstOperands,
     /*  234613 */     // GIR_Coverage, 20062,
     /*  234613 */     GIR_EraseRootFromParent_Done,
     /*  234614 */   // Label 4868: @234614
     /*  234614 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(234677), // Rule ID 20063 //
     /*  234619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  234622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  234651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  234661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234675 */     GIR_RootConstrainSelectedInstOperands,
     /*  234676 */     // GIR_Coverage, 20063,
     /*  234676 */     GIR_EraseRootFromParent_Done,
     /*  234677 */   // Label 4869: @234677
     /*  234677 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(234740), // Rule ID 20066 //
     /*  234682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  234685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234721 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  234724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234738 */     GIR_RootConstrainSelectedInstOperands,
     /*  234739 */     // GIR_Coverage, 20066,
     /*  234739 */     GIR_EraseRootFromParent_Done,
     /*  234740 */   // Label 4870: @234740
     /*  234740 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(234803), // Rule ID 20067 //
     /*  234745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  234748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  234787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234801 */     GIR_RootConstrainSelectedInstOperands,
     /*  234802 */     // GIR_Coverage, 20067,
     /*  234802 */     GIR_EraseRootFromParent_Done,
     /*  234803 */   // Label 4871: @234803
     /*  234803 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(234866), // Rule ID 20070 //
     /*  234808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  234811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234847 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  234850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234864 */     GIR_RootConstrainSelectedInstOperands,
     /*  234865 */     // GIR_Coverage, 20070,
     /*  234865 */     GIR_EraseRootFromParent_Done,
     /*  234866 */   // Label 4872: @234866
     /*  234866 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(234929), // Rule ID 20071 //
     /*  234871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  234874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  234913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234927 */     GIR_RootConstrainSelectedInstOperands,
     /*  234928 */     // GIR_Coverage, 20071,
     /*  234928 */     GIR_EraseRootFromParent_Done,
     /*  234929 */   // Label 4873: @234929
     /*  234929 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(234992), // Rule ID 20074 //
     /*  234934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  234937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  234942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  234948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  234951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  234966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234973 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  234976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  234982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234990 */     GIR_RootConstrainSelectedInstOperands,
     /*  234991 */     // GIR_Coverage, 20074,
     /*  234991 */     GIR_EraseRootFromParent_Done,
     /*  234992 */   // Label 4874: @234992
     /*  234992 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(235055), // Rule ID 20075 //
     /*  234997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  235000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  235014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  235029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  235039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235053 */     GIR_RootConstrainSelectedInstOperands,
     /*  235054 */     // GIR_Coverage, 20075,
     /*  235054 */     GIR_EraseRootFromParent_Done,
     /*  235055 */   // Label 4875: @235055
     /*  235055 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(235118), // Rule ID 20078 //
     /*  235060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  235063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235099 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  235102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235116 */     GIR_RootConstrainSelectedInstOperands,
     /*  235117 */     // GIR_Coverage, 20078,
     /*  235117 */     GIR_EraseRootFromParent_Done,
     /*  235118 */   // Label 4876: @235118
     /*  235118 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(235181), // Rule ID 20079 //
     /*  235123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  235126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  235165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235179 */     GIR_RootConstrainSelectedInstOperands,
     /*  235180 */     // GIR_Coverage, 20079,
     /*  235180 */     GIR_EraseRootFromParent_Done,
     /*  235181 */   // Label 4877: @235181
     /*  235181 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(235244), // Rule ID 20082 //
     /*  235186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  235189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235225 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  235228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235242 */     GIR_RootConstrainSelectedInstOperands,
     /*  235243 */     // GIR_Coverage, 20082,
     /*  235243 */     GIR_EraseRootFromParent_Done,
     /*  235244 */   // Label 4878: @235244
     /*  235244 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(235307), // Rule ID 20083 //
     /*  235249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  235252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  235291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235305 */     GIR_RootConstrainSelectedInstOperands,
     /*  235306 */     // GIR_Coverage, 20083,
     /*  235306 */     GIR_EraseRootFromParent_Done,
     /*  235307 */   // Label 4879: @235307
     /*  235307 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(235370), // Rule ID 20086 //
     /*  235312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  235315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235351 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  235354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235368 */     GIR_RootConstrainSelectedInstOperands,
     /*  235369 */     // GIR_Coverage, 20086,
     /*  235369 */     GIR_EraseRootFromParent_Done,
     /*  235370 */   // Label 4880: @235370
     /*  235370 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(235433), // Rule ID 20087 //
     /*  235375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  235378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  235407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  235417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235431 */     GIR_RootConstrainSelectedInstOperands,
     /*  235432 */     // GIR_Coverage, 20087,
     /*  235432 */     GIR_EraseRootFromParent_Done,
     /*  235433 */   // Label 4881: @235433
     /*  235433 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(235496), // Rule ID 20090 //
     /*  235438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  235441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  235480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235494 */     GIR_RootConstrainSelectedInstOperands,
     /*  235495 */     // GIR_Coverage, 20090,
     /*  235495 */     GIR_EraseRootFromParent_Done,
     /*  235496 */   // Label 4882: @235496
     /*  235496 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(235559), // Rule ID 20091 //
     /*  235501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  235504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  235543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235557 */     GIR_RootConstrainSelectedInstOperands,
     /*  235558 */     // GIR_Coverage, 20091,
     /*  235558 */     GIR_EraseRootFromParent_Done,
     /*  235559 */   // Label 4883: @235559
     /*  235559 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(235622), // Rule ID 20094 //
     /*  235564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  235567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235603 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  235606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235620 */     GIR_RootConstrainSelectedInstOperands,
     /*  235621 */     // GIR_Coverage, 20094,
     /*  235621 */     GIR_EraseRootFromParent_Done,
     /*  235622 */   // Label 4884: @235622
     /*  235622 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(235685), // Rule ID 20095 //
     /*  235627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  235630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  235669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235683 */     GIR_RootConstrainSelectedInstOperands,
     /*  235684 */     // GIR_Coverage, 20095,
     /*  235684 */     GIR_EraseRootFromParent_Done,
     /*  235685 */   // Label 4885: @235685
     /*  235685 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(235748), // Rule ID 20098 //
     /*  235690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  235693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  235732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235746 */     GIR_RootConstrainSelectedInstOperands,
     /*  235747 */     // GIR_Coverage, 20098,
     /*  235747 */     GIR_EraseRootFromParent_Done,
     /*  235748 */   // Label 4886: @235748
     /*  235748 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(235811), // Rule ID 20099 //
     /*  235753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  235756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  235761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  235785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  235795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235809 */     GIR_RootConstrainSelectedInstOperands,
     /*  235810 */     // GIR_Coverage, 20099,
     /*  235810 */     GIR_EraseRootFromParent_Done,
     /*  235811 */   // Label 4887: @235811
     /*  235811 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(235874), // Rule ID 20102 //
     /*  235816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  235819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  235824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  235827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  235830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  235833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  235848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235855 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  235858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235872 */     GIR_RootConstrainSelectedInstOperands,
     /*  235873 */     // GIR_Coverage, 20102,
     /*  235873 */     GIR_EraseRootFromParent_Done,
     /*  235874 */   // Label 4888: @235874
     /*  235874 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(235937), // Rule ID 20103 //
     /*  235879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  235882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  235887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  235890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  235893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  235896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  235911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235918 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  235921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235935 */     GIR_RootConstrainSelectedInstOperands,
     /*  235936 */     // GIR_Coverage, 20103,
     /*  235936 */     GIR_EraseRootFromParent_Done,
     /*  235937 */   // Label 4889: @235937
     /*  235937 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(236000), // Rule ID 20106 //
     /*  235942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  235945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  235950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  235956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  235959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  235974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235981 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  235984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  235990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235998 */     GIR_RootConstrainSelectedInstOperands,
     /*  235999 */     // GIR_Coverage, 20106,
     /*  235999 */     GIR_EraseRootFromParent_Done,
     /*  236000 */   // Label 4890: @236000
     /*  236000 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(236063), // Rule ID 20107 //
     /*  236005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  236008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  236047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236061 */     GIR_RootConstrainSelectedInstOperands,
     /*  236062 */     // GIR_Coverage, 20107,
     /*  236062 */     GIR_EraseRootFromParent_Done,
     /*  236063 */   // Label 4891: @236063
     /*  236063 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(236126), // Rule ID 20110 //
     /*  236068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  236071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  236100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236107 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  236110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236124 */     GIR_RootConstrainSelectedInstOperands,
     /*  236125 */     // GIR_Coverage, 20110,
     /*  236125 */     GIR_EraseRootFromParent_Done,
     /*  236126 */   // Label 4892: @236126
     /*  236126 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(236189), // Rule ID 20111 //
     /*  236131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  236134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  236163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  236173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236187 */     GIR_RootConstrainSelectedInstOperands,
     /*  236188 */     // GIR_Coverage, 20111,
     /*  236188 */     GIR_EraseRootFromParent_Done,
     /*  236189 */   // Label 4893: @236189
     /*  236189 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(236252), // Rule ID 20114 //
     /*  236194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  236197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  236208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236233 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  236236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236250 */     GIR_RootConstrainSelectedInstOperands,
     /*  236251 */     // GIR_Coverage, 20114,
     /*  236251 */     GIR_EraseRootFromParent_Done,
     /*  236252 */   // Label 4894: @236252
     /*  236252 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(236315), // Rule ID 20115 //
     /*  236257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  236260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  236271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  236299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236313 */     GIR_RootConstrainSelectedInstOperands,
     /*  236314 */     // GIR_Coverage, 20115,
     /*  236314 */     GIR_EraseRootFromParent_Done,
     /*  236315 */   // Label 4895: @236315
     /*  236315 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(236378), // Rule ID 20118 //
     /*  236320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  236323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  236334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  236352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  236362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236376 */     GIR_RootConstrainSelectedInstOperands,
     /*  236377 */     // GIR_Coverage, 20118,
     /*  236377 */     GIR_EraseRootFromParent_Done,
     /*  236378 */   // Label 4896: @236378
     /*  236378 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(236441), // Rule ID 20119 //
     /*  236383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  236386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  236397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  236415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  236425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236439 */     GIR_RootConstrainSelectedInstOperands,
     /*  236440 */     // GIR_Coverage, 20119,
     /*  236440 */     GIR_EraseRootFromParent_Done,
     /*  236441 */   // Label 4897: @236441
     /*  236441 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(236504), // Rule ID 20122 //
     /*  236446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  236449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  236460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  236478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236485 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  236488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236502 */     GIR_RootConstrainSelectedInstOperands,
     /*  236503 */     // GIR_Coverage, 20122,
     /*  236503 */     GIR_EraseRootFromParent_Done,
     /*  236504 */   // Label 4898: @236504
     /*  236504 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(236567), // Rule ID 20123 //
     /*  236509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  236512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  236523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  236541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236548 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  236551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236565 */     GIR_RootConstrainSelectedInstOperands,
     /*  236566 */     // GIR_Coverage, 20123,
     /*  236566 */     GIR_EraseRootFromParent_Done,
     /*  236567 */   // Label 4899: @236567
     /*  236567 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(236630), // Rule ID 20126 //
     /*  236572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  236575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  236586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  236614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236628 */     GIR_RootConstrainSelectedInstOperands,
     /*  236629 */     // GIR_Coverage, 20126,
     /*  236629 */     GIR_EraseRootFromParent_Done,
     /*  236630 */   // Label 4900: @236630
     /*  236630 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(236693), // Rule ID 20127 //
     /*  236635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  236638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  236649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  236677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236691 */     GIR_RootConstrainSelectedInstOperands,
     /*  236692 */     // GIR_Coverage, 20127,
     /*  236692 */     GIR_EraseRootFromParent_Done,
     /*  236693 */   // Label 4901: @236693
     /*  236693 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(236756), // Rule ID 20130 //
     /*  236698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  236701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  236712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236737 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  236740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236754 */     GIR_RootConstrainSelectedInstOperands,
     /*  236755 */     // GIR_Coverage, 20130,
     /*  236755 */     GIR_EraseRootFromParent_Done,
     /*  236756 */   // Label 4902: @236756
     /*  236756 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(236819), // Rule ID 20131 //
     /*  236761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  236764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  236775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  236803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236817 */     GIR_RootConstrainSelectedInstOperands,
     /*  236818 */     // GIR_Coverage, 20131,
     /*  236818 */     GIR_EraseRootFromParent_Done,
     /*  236819 */   // Label 4903: @236819
     /*  236819 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(236882), // Rule ID 20134 //
     /*  236824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  236827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  236835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  236838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236863 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  236866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236880 */     GIR_RootConstrainSelectedInstOperands,
     /*  236881 */     // GIR_Coverage, 20134,
     /*  236881 */     GIR_EraseRootFromParent_Done,
     /*  236882 */   // Label 4904: @236882
     /*  236882 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(236945), // Rule ID 20135 //
     /*  236887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  236890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  236898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  236901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  236904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  236919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236926 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  236929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236943 */     GIR_RootConstrainSelectedInstOperands,
     /*  236944 */     // GIR_Coverage, 20135,
     /*  236944 */     GIR_EraseRootFromParent_Done,
     /*  236945 */   // Label 4905: @236945
     /*  236945 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(237008), // Rule ID 20138 //
     /*  236950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  236953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  236958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  236964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  236982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236989 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  236992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  236998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237006 */     GIR_RootConstrainSelectedInstOperands,
     /*  237007 */     // GIR_Coverage, 20138,
     /*  237007 */     GIR_EraseRootFromParent_Done,
     /*  237008 */   // Label 4906: @237008
     /*  237008 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(237071), // Rule ID 20139 //
     /*  237013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  237016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  237027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  237055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237069 */     GIR_RootConstrainSelectedInstOperands,
     /*  237070 */     // GIR_Coverage, 20139,
     /*  237070 */     GIR_EraseRootFromParent_Done,
     /*  237071 */   // Label 4907: @237071
     /*  237071 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(237134), // Rule ID 20142 //
     /*  237076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  237079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  237090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237115 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  237118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237132 */     GIR_RootConstrainSelectedInstOperands,
     /*  237133 */     // GIR_Coverage, 20142,
     /*  237133 */     GIR_EraseRootFromParent_Done,
     /*  237134 */   // Label 4908: @237134
     /*  237134 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(237197), // Rule ID 20143 //
     /*  237139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  237142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  237153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  237181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237195 */     GIR_RootConstrainSelectedInstOperands,
     /*  237196 */     // GIR_Coverage, 20143,
     /*  237196 */     GIR_EraseRootFromParent_Done,
     /*  237197 */   // Label 4909: @237197
     /*  237197 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(237260), // Rule ID 20146 //
     /*  237202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  237205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  237216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237241 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  237244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237258 */     GIR_RootConstrainSelectedInstOperands,
     /*  237259 */     // GIR_Coverage, 20146,
     /*  237259 */     GIR_EraseRootFromParent_Done,
     /*  237260 */   // Label 4910: @237260
     /*  237260 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(237323), // Rule ID 20147 //
     /*  237265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  237268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  237279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237304 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  237307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237321 */     GIR_RootConstrainSelectedInstOperands,
     /*  237322 */     // GIR_Coverage, 20147,
     /*  237322 */     GIR_EraseRootFromParent_Done,
     /*  237323 */   // Label 4911: @237323
     /*  237323 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(237386), // Rule ID 20150 //
     /*  237328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  237331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  237342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237367 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  237370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237384 */     GIR_RootConstrainSelectedInstOperands,
     /*  237385 */     // GIR_Coverage, 20150,
     /*  237385 */     GIR_EraseRootFromParent_Done,
     /*  237386 */   // Label 4912: @237386
     /*  237386 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(237449), // Rule ID 20151 //
     /*  237391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  237394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  237405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  237433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237447 */     GIR_RootConstrainSelectedInstOperands,
     /*  237448 */     // GIR_Coverage, 20151,
     /*  237448 */     GIR_EraseRootFromParent_Done,
     /*  237449 */   // Label 4913: @237449
     /*  237449 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(237512), // Rule ID 20154 //
     /*  237454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  237457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  237468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237493 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  237496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237510 */     GIR_RootConstrainSelectedInstOperands,
     /*  237511 */     // GIR_Coverage, 20154,
     /*  237511 */     GIR_EraseRootFromParent_Done,
     /*  237512 */   // Label 4914: @237512
     /*  237512 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(237575), // Rule ID 20155 //
     /*  237517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  237520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  237531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  237559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237573 */     GIR_RootConstrainSelectedInstOperands,
     /*  237574 */     // GIR_Coverage, 20155,
     /*  237574 */     GIR_EraseRootFromParent_Done,
     /*  237575 */   // Label 4915: @237575
     /*  237575 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(237638), // Rule ID 20158 //
     /*  237580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  237583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  237594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237619 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  237622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237636 */     GIR_RootConstrainSelectedInstOperands,
     /*  237637 */     // GIR_Coverage, 20158,
     /*  237637 */     GIR_EraseRootFromParent_Done,
     /*  237638 */   // Label 4916: @237638
     /*  237638 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(237701), // Rule ID 20159 //
     /*  237643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  237646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  237651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  237657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  237675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  237685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237699 */     GIR_RootConstrainSelectedInstOperands,
     /*  237700 */     // GIR_Coverage, 20159,
     /*  237700 */     GIR_EraseRootFromParent_Done,
     /*  237701 */   // Label 4917: @237701
     /*  237701 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(237764), // Rule ID 20162 //
     /*  237706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  237709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  237714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  237723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  237738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  237748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237762 */     GIR_RootConstrainSelectedInstOperands,
     /*  237763 */     // GIR_Coverage, 20162,
     /*  237763 */     GIR_EraseRootFromParent_Done,
     /*  237764 */   // Label 4918: @237764
     /*  237764 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(237827), // Rule ID 20163 //
     /*  237769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  237772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  237777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  237786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  237801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  237811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237825 */     GIR_RootConstrainSelectedInstOperands,
     /*  237826 */     // GIR_Coverage, 20163,
     /*  237826 */     GIR_EraseRootFromParent_Done,
     /*  237827 */   // Label 4919: @237827
     /*  237827 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(237890), // Rule ID 20166 //
     /*  237832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  237835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  237840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  237849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  237864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237871 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  237874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237888 */     GIR_RootConstrainSelectedInstOperands,
     /*  237889 */     // GIR_Coverage, 20166,
     /*  237889 */     GIR_EraseRootFromParent_Done,
     /*  237890 */   // Label 4920: @237890
     /*  237890 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(237953), // Rule ID 20167 //
     /*  237895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  237898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  237903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  237912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  237927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  237937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  237943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237951 */     GIR_RootConstrainSelectedInstOperands,
     /*  237952 */     // GIR_Coverage, 20167,
     /*  237952 */     GIR_EraseRootFromParent_Done,
     /*  237953 */   // Label 4921: @237953
     /*  237953 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(238016), // Rule ID 20170 //
     /*  237958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  237961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  237966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  237990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237997 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  238000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238014 */     GIR_RootConstrainSelectedInstOperands,
     /*  238015 */     // GIR_Coverage, 20170,
     /*  238015 */     GIR_EraseRootFromParent_Done,
     /*  238016 */   // Label 4922: @238016
     /*  238016 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(238079), // Rule ID 20171 //
     /*  238021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  238024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  238032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  238035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  238063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238077 */     GIR_RootConstrainSelectedInstOperands,
     /*  238078 */     // GIR_Coverage, 20171,
     /*  238078 */     GIR_EraseRootFromParent_Done,
     /*  238079 */   // Label 4923: @238079
     /*  238079 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(238142), // Rule ID 20174 //
     /*  238084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  238087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  238098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  238126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238140 */     GIR_RootConstrainSelectedInstOperands,
     /*  238141 */     // GIR_Coverage, 20174,
     /*  238141 */     GIR_EraseRootFromParent_Done,
     /*  238142 */   // Label 4924: @238142
     /*  238142 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(238205), // Rule ID 20175 //
     /*  238147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  238150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  238161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  238189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238203 */     GIR_RootConstrainSelectedInstOperands,
     /*  238204 */     // GIR_Coverage, 20175,
     /*  238204 */     GIR_EraseRootFromParent_Done,
     /*  238205 */   // Label 4925: @238205
     /*  238205 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(238268), // Rule ID 20178 //
     /*  238210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  238213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  238224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238249 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  238252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238266 */     GIR_RootConstrainSelectedInstOperands,
     /*  238267 */     // GIR_Coverage, 20178,
     /*  238267 */     GIR_EraseRootFromParent_Done,
     /*  238268 */   // Label 4926: @238268
     /*  238268 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(238331), // Rule ID 20179 //
     /*  238273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  238276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  238287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  238315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238329 */     GIR_RootConstrainSelectedInstOperands,
     /*  238330 */     // GIR_Coverage, 20179,
     /*  238330 */     GIR_EraseRootFromParent_Done,
     /*  238331 */   // Label 4927: @238331
     /*  238331 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(238394), // Rule ID 20182 //
     /*  238336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  238339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  238347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  238350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  238368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238375 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  238378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238392 */     GIR_RootConstrainSelectedInstOperands,
     /*  238393 */     // GIR_Coverage, 20182,
     /*  238393 */     GIR_EraseRootFromParent_Done,
     /*  238394 */   // Label 4928: @238394
     /*  238394 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(238457), // Rule ID 20183 //
     /*  238399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  238402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  238410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  238413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  238431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238438 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  238441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238455 */     GIR_RootConstrainSelectedInstOperands,
     /*  238456 */     // GIR_Coverage, 20183,
     /*  238456 */     GIR_EraseRootFromParent_Done,
     /*  238457 */   // Label 4929: @238457
     /*  238457 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(238520), // Rule ID 20186 //
     /*  238462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  238465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238501 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  238504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238518 */     GIR_RootConstrainSelectedInstOperands,
     /*  238519 */     // GIR_Coverage, 20186,
     /*  238519 */     GIR_EraseRootFromParent_Done,
     /*  238520 */   // Label 4930: @238520
     /*  238520 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(238583), // Rule ID 20187 //
     /*  238525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  238528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238564 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  238567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238581 */     GIR_RootConstrainSelectedInstOperands,
     /*  238582 */     // GIR_Coverage, 20187,
     /*  238582 */     GIR_EraseRootFromParent_Done,
     /*  238583 */   // Label 4931: @238583
     /*  238583 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(238646), // Rule ID 20190 //
     /*  238588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  238591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238627 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  238630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238644 */     GIR_RootConstrainSelectedInstOperands,
     /*  238645 */     // GIR_Coverage, 20190,
     /*  238645 */     GIR_EraseRootFromParent_Done,
     /*  238646 */   // Label 4932: @238646
     /*  238646 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(238709), // Rule ID 20191 //
     /*  238651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  238654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  238693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238707 */     GIR_RootConstrainSelectedInstOperands,
     /*  238708 */     // GIR_Coverage, 20191,
     /*  238708 */     GIR_EraseRootFromParent_Done,
     /*  238709 */   // Label 4933: @238709
     /*  238709 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(238772), // Rule ID 20194 //
     /*  238714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  238717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238753 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  238756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238770 */     GIR_RootConstrainSelectedInstOperands,
     /*  238771 */     // GIR_Coverage, 20194,
     /*  238771 */     GIR_EraseRootFromParent_Done,
     /*  238772 */   // Label 4934: @238772
     /*  238772 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(238835), // Rule ID 20195 //
     /*  238777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  238780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  238794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  238809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238816 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  238819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238833 */     GIR_RootConstrainSelectedInstOperands,
     /*  238834 */     // GIR_Coverage, 20195,
     /*  238834 */     GIR_EraseRootFromParent_Done,
     /*  238835 */   // Label 4935: @238835
     /*  238835 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(238898), // Rule ID 20198 //
     /*  238840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  238843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238879 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  238882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238896 */     GIR_RootConstrainSelectedInstOperands,
     /*  238897 */     // GIR_Coverage, 20198,
     /*  238897 */     GIR_EraseRootFromParent_Done,
     /*  238898 */   // Label 4936: @238898
     /*  238898 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(238961), // Rule ID 20199 //
     /*  238903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  238906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  238945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238959 */     GIR_RootConstrainSelectedInstOperands,
     /*  238960 */     // GIR_Coverage, 20199,
     /*  238960 */     GIR_EraseRootFromParent_Done,
     /*  238961 */   // Label 4937: @238961
     /*  238961 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(239024), // Rule ID 20202 //
     /*  238966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  238969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  238974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  238998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239005 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  239008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239022 */     GIR_RootConstrainSelectedInstOperands,
     /*  239023 */     // GIR_Coverage, 20202,
     /*  239023 */     GIR_EraseRootFromParent_Done,
     /*  239024 */   // Label 4938: @239024
     /*  239024 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(239087), // Rule ID 20203 //
     /*  239029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  239032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  239061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  239071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239085 */     GIR_RootConstrainSelectedInstOperands,
     /*  239086 */     // GIR_Coverage, 20203,
     /*  239086 */     GIR_EraseRootFromParent_Done,
     /*  239087 */   // Label 4939: @239087
     /*  239087 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(239150), // Rule ID 20206 //
     /*  239092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  239095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  239124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239131 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  239134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239148 */     GIR_RootConstrainSelectedInstOperands,
     /*  239149 */     // GIR_Coverage, 20206,
     /*  239149 */     GIR_EraseRootFromParent_Done,
     /*  239150 */   // Label 4940: @239150
     /*  239150 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(239213), // Rule ID 20207 //
     /*  239155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  239158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  239187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  239197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239211 */     GIR_RootConstrainSelectedInstOperands,
     /*  239212 */     // GIR_Coverage, 20207,
     /*  239212 */     GIR_EraseRootFromParent_Done,
     /*  239213 */   // Label 4941: @239213
     /*  239213 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(239276), // Rule ID 20210 //
     /*  239218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  239221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239257 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  239260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239274 */     GIR_RootConstrainSelectedInstOperands,
     /*  239275 */     // GIR_Coverage, 20210,
     /*  239275 */     GIR_EraseRootFromParent_Done,
     /*  239276 */   // Label 4942: @239276
     /*  239276 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(239339), // Rule ID 20211 //
     /*  239281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  239284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  239323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239337 */     GIR_RootConstrainSelectedInstOperands,
     /*  239338 */     // GIR_Coverage, 20211,
     /*  239338 */     GIR_EraseRootFromParent_Done,
     /*  239339 */   // Label 4943: @239339
     /*  239339 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(239402), // Rule ID 20214 //
     /*  239344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  239347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  239386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239400 */     GIR_RootConstrainSelectedInstOperands,
     /*  239401 */     // GIR_Coverage, 20214,
     /*  239401 */     GIR_EraseRootFromParent_Done,
     /*  239402 */   // Label 4944: @239402
     /*  239402 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(239465), // Rule ID 20215 //
     /*  239407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  239410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  239449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239463 */     GIR_RootConstrainSelectedInstOperands,
     /*  239464 */     // GIR_Coverage, 20215,
     /*  239464 */     GIR_EraseRootFromParent_Done,
     /*  239465 */   // Label 4945: @239465
     /*  239465 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(239528), // Rule ID 20218 //
     /*  239470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  239473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239509 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  239512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239526 */     GIR_RootConstrainSelectedInstOperands,
     /*  239527 */     // GIR_Coverage, 20218,
     /*  239527 */     GIR_EraseRootFromParent_Done,
     /*  239528 */   // Label 4946: @239528
     /*  239528 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(239591), // Rule ID 20219 //
     /*  239533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  239536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  239541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  239565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  239575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239589 */     GIR_RootConstrainSelectedInstOperands,
     /*  239590 */     // GIR_Coverage, 20219,
     /*  239590 */     GIR_EraseRootFromParent_Done,
     /*  239591 */   // Label 4947: @239591
     /*  239591 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(239654), // Rule ID 20222 //
     /*  239596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  239635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  239638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239652 */     GIR_RootConstrainSelectedInstOperands,
     /*  239653 */     // GIR_Coverage, 20222,
     /*  239653 */     GIR_EraseRootFromParent_Done,
     /*  239654 */   // Label 4948: @239654
     /*  239654 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(239717), // Rule ID 20223 //
     /*  239659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  239662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  239698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  239701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239715 */     GIR_RootConstrainSelectedInstOperands,
     /*  239716 */     // GIR_Coverage, 20223,
     /*  239716 */     GIR_EraseRootFromParent_Done,
     /*  239717 */   // Label 4949: @239717
     /*  239717 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(239780), // Rule ID 20226 //
     /*  239722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  239736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  239739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239761 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  239761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  239764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239778 */     GIR_RootConstrainSelectedInstOperands,
     /*  239779 */     // GIR_Coverage, 20226,
     /*  239779 */     GIR_EraseRootFromParent_Done,
     /*  239780 */   // Label 4950: @239780
     /*  239780 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(239843), // Rule ID 20227 //
     /*  239785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  239788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  239799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  239802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  239824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  239827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239841 */     GIR_RootConstrainSelectedInstOperands,
     /*  239842 */     // GIR_Coverage, 20227,
     /*  239842 */     GIR_EraseRootFromParent_Done,
     /*  239843 */   // Label 4951: @239843
     /*  239843 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(239906), // Rule ID 20230 //
     /*  239848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  239851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  239862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  239865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  239890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239904 */     GIR_RootConstrainSelectedInstOperands,
     /*  239905 */     // GIR_Coverage, 20230,
     /*  239905 */     GIR_EraseRootFromParent_Done,
     /*  239906 */   // Label 4952: @239906
     /*  239906 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(239969), // Rule ID 20231 //
     /*  239911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  239914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  239925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  239928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  239953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239967 */     GIR_RootConstrainSelectedInstOperands,
     /*  239968 */     // GIR_Coverage, 20231,
     /*  239968 */     GIR_EraseRootFromParent_Done,
     /*  239969 */   // Label 4953: @239969
     /*  239969 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(240032), // Rule ID 20234 //
     /*  239974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  239982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  239988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  239991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240013 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240030 */     GIR_RootConstrainSelectedInstOperands,
     /*  240031 */     // GIR_Coverage, 20234,
     /*  240031 */     GIR_EraseRootFromParent_Done,
     /*  240032 */   // Label 4954: @240032
     /*  240032 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(240095), // Rule ID 20235 //
     /*  240037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  240054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240093 */     GIR_RootConstrainSelectedInstOperands,
     /*  240094 */     // GIR_Coverage, 20235,
     /*  240094 */     GIR_EraseRootFromParent_Done,
     /*  240095 */   // Label 4955: @240095
     /*  240095 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(240158), // Rule ID 20238 //
     /*  240100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  240103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  240114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  240117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  240139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240156 */     GIR_RootConstrainSelectedInstOperands,
     /*  240157 */     // GIR_Coverage, 20238,
     /*  240157 */     GIR_EraseRootFromParent_Done,
     /*  240158 */   // Label 4956: @240158
     /*  240158 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(240221), // Rule ID 20239 //
     /*  240163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  240166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  240177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  240180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  240202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240219 */     GIR_RootConstrainSelectedInstOperands,
     /*  240220 */     // GIR_Coverage, 20239,
     /*  240220 */     GIR_EraseRootFromParent_Done,
     /*  240221 */   // Label 4957: @240221
     /*  240221 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(240284), // Rule ID 20242 //
     /*  240226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  240229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  240240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  240243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  240265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  240282 */     GIR_RootConstrainSelectedInstOperands,
     /*  240283 */     // GIR_Coverage, 20242,
     /*  240283 */     GIR_EraseRootFromParent_Done,
     /*  240284 */   // Label 4958: @240284
     /*  240284 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(240347), // Rule ID 20243 //
     /*  240289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  240292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  240303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  240306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  240328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  240331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  240345 */     GIR_RootConstrainSelectedInstOperands,
     /*  240346 */     // GIR_Coverage, 20243,
     /*  240346 */     GIR_EraseRootFromParent_Done,
     /*  240347 */   // Label 4959: @240347
     /*  240347 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(240410), // Rule ID 20246 //
     /*  240352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  240355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  240369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240391 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  240394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240408 */     GIR_RootConstrainSelectedInstOperands,
     /*  240409 */     // GIR_Coverage, 20246,
     /*  240409 */     GIR_EraseRootFromParent_Done,
     /*  240410 */   // Label 4960: @240410
     /*  240410 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(240473), // Rule ID 20247 //
     /*  240415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  240432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  240457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240471 */     GIR_RootConstrainSelectedInstOperands,
     /*  240472 */     // GIR_Coverage, 20247,
     /*  240472 */     GIR_EraseRootFromParent_Done,
     /*  240473 */   // Label 4961: @240473
     /*  240473 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(240536), // Rule ID 20250 //
     /*  240478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  240481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  240489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  240495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240517 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  240520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240534 */     GIR_RootConstrainSelectedInstOperands,
     /*  240535 */     // GIR_Coverage, 20250,
     /*  240535 */     GIR_EraseRootFromParent_Done,
     /*  240536 */   // Label 4962: @240536
     /*  240536 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(240599), // Rule ID 20251 //
     /*  240541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  240552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  240558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  240583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240597 */     GIR_RootConstrainSelectedInstOperands,
     /*  240598 */     // GIR_Coverage, 20251,
     /*  240598 */     GIR_EraseRootFromParent_Done,
     /*  240599 */   // Label 4963: @240599
     /*  240599 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(240662), // Rule ID 20254 //
     /*  240604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  240607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  240615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  240618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  240621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240643 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  240646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240660 */     GIR_RootConstrainSelectedInstOperands,
     /*  240661 */     // GIR_Coverage, 20254,
     /*  240661 */     GIR_EraseRootFromParent_Done,
     /*  240662 */   // Label 4964: @240662
     /*  240662 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(240725), // Rule ID 20255 //
     /*  240667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  240678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  240681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  240684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  240709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240723 */     GIR_RootConstrainSelectedInstOperands,
     /*  240724 */     // GIR_Coverage, 20255,
     /*  240724 */     GIR_EraseRootFromParent_Done,
     /*  240725 */   // Label 4965: @240725
     /*  240725 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(240788), // Rule ID 20258 //
     /*  240730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  240733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  240744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  240747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240769 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  240769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  240772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240786 */     GIR_RootConstrainSelectedInstOperands,
     /*  240787 */     // GIR_Coverage, 20258,
     /*  240787 */     GIR_EraseRootFromParent_Done,
     /*  240788 */   // Label 4966: @240788
     /*  240788 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(240851), // Rule ID 20259 //
     /*  240793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  240796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  240807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  240810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  240832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  240835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240849 */     GIR_RootConstrainSelectedInstOperands,
     /*  240850 */     // GIR_Coverage, 20259,
     /*  240850 */     GIR_EraseRootFromParent_Done,
     /*  240851 */   // Label 4967: @240851
     /*  240851 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(240914), // Rule ID 20262 //
     /*  240856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  240859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  240870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  240873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240895 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  240895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  240898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240912 */     GIR_RootConstrainSelectedInstOperands,
     /*  240913 */     // GIR_Coverage, 20262,
     /*  240913 */     GIR_EraseRootFromParent_Done,
     /*  240914 */   // Label 4968: @240914
     /*  240914 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(240977), // Rule ID 20263 //
     /*  240919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  240922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  240933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  240936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  240958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  240961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240975 */     GIR_RootConstrainSelectedInstOperands,
     /*  240976 */     // GIR_Coverage, 20263,
     /*  240976 */     GIR_EraseRootFromParent_Done,
     /*  240977 */   // Label 4969: @240977
     /*  240977 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(241040), // Rule ID 20266 //
     /*  240982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  240985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  240990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  240993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  240996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  240999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241021 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  241021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  241024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241038 */     GIR_RootConstrainSelectedInstOperands,
     /*  241039 */     // GIR_Coverage, 20266,
     /*  241039 */     GIR_EraseRootFromParent_Done,
     /*  241040 */   // Label 4970: @241040
     /*  241040 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(241103), // Rule ID 20267 //
     /*  241045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  241048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  241062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  241084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  241087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241101 */     GIR_RootConstrainSelectedInstOperands,
     /*  241102 */     // GIR_Coverage, 20267,
     /*  241102 */     GIR_EraseRootFromParent_Done,
     /*  241103 */   // Label 4971: @241103
     /*  241103 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(241166), // Rule ID 20270 //
     /*  241108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  241111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  241125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241147 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  241147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  241150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241164 */     GIR_RootConstrainSelectedInstOperands,
     /*  241165 */     // GIR_Coverage, 20270,
     /*  241165 */     GIR_EraseRootFromParent_Done,
     /*  241166 */   // Label 4972: @241166
     /*  241166 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(241229), // Rule ID 20271 //
     /*  241171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  241174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  241188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  241210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  241213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241227 */     GIR_RootConstrainSelectedInstOperands,
     /*  241228 */     // GIR_Coverage, 20271,
     /*  241228 */     GIR_EraseRootFromParent_Done,
     /*  241229 */   // Label 4973: @241229
     /*  241229 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(241292), // Rule ID 20274 //
     /*  241234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  241237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  241245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  241248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  241251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241273 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  241273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  241276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241290 */     GIR_RootConstrainSelectedInstOperands,
     /*  241291 */     // GIR_Coverage, 20274,
     /*  241291 */     GIR_EraseRootFromParent_Done,
     /*  241292 */   // Label 4974: @241292
     /*  241292 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(241355), // Rule ID 20275 //
     /*  241297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  241300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  241308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  241311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  241314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  241336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  241339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241353 */     GIR_RootConstrainSelectedInstOperands,
     /*  241354 */     // GIR_Coverage, 20275,
     /*  241354 */     GIR_EraseRootFromParent_Done,
     /*  241355 */   // Label 4975: @241355
     /*  241355 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(241418), // Rule ID 20278 //
     /*  241360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  241363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  241374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  241377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241399 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  241399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  241402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241416 */     GIR_RootConstrainSelectedInstOperands,
     /*  241417 */     // GIR_Coverage, 20278,
     /*  241417 */     GIR_EraseRootFromParent_Done,
     /*  241418 */   // Label 4976: @241418
     /*  241418 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(241481), // Rule ID 20279 //
     /*  241423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  241426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  241431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  241437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  241440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  241462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  241465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241479 */     GIR_RootConstrainSelectedInstOperands,
     /*  241480 */     // GIR_Coverage, 20279,
     /*  241480 */     GIR_EraseRootFromParent_Done,
     /*  241481 */   // Label 4977: @241481
     /*  241481 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(241544), // Rule ID 20282 //
     /*  241486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  241489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  241500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241525 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  241528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241542 */     GIR_RootConstrainSelectedInstOperands,
     /*  241543 */     // GIR_Coverage, 20282,
     /*  241543 */     GIR_EraseRootFromParent_Done,
     /*  241544 */   // Label 4978: @241544
     /*  241544 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(241607), // Rule ID 20283 //
     /*  241549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  241552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  241563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  241591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241605 */     GIR_RootConstrainSelectedInstOperands,
     /*  241606 */     // GIR_Coverage, 20283,
     /*  241606 */     GIR_EraseRootFromParent_Done,
     /*  241607 */   // Label 4979: @241607
     /*  241607 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(241670), // Rule ID 20286 //
     /*  241612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  241615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  241626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241651 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  241654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241668 */     GIR_RootConstrainSelectedInstOperands,
     /*  241669 */     // GIR_Coverage, 20286,
     /*  241669 */     GIR_EraseRootFromParent_Done,
     /*  241670 */   // Label 4980: @241670
     /*  241670 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(241733), // Rule ID 20287 //
     /*  241675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  241678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  241689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  241717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241731 */     GIR_RootConstrainSelectedInstOperands,
     /*  241732 */     // GIR_Coverage, 20287,
     /*  241732 */     GIR_EraseRootFromParent_Done,
     /*  241733 */   // Label 4981: @241733
     /*  241733 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(241796), // Rule ID 20290 //
     /*  241738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  241741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241777 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  241777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  241780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241794 */     GIR_RootConstrainSelectedInstOperands,
     /*  241795 */     // GIR_Coverage, 20290,
     /*  241795 */     GIR_EraseRootFromParent_Done,
     /*  241796 */   // Label 4982: @241796
     /*  241796 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(241859), // Rule ID 20291 //
     /*  241801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  241804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  241840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  241843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241857 */     GIR_RootConstrainSelectedInstOperands,
     /*  241858 */     // GIR_Coverage, 20291,
     /*  241858 */     GIR_EraseRootFromParent_Done,
     /*  241859 */   // Label 4983: @241859
     /*  241859 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(241922), // Rule ID 20294 //
     /*  241864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  241867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  241875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  241906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241920 */     GIR_RootConstrainSelectedInstOperands,
     /*  241921 */     // GIR_Coverage, 20294,
     /*  241921 */     GIR_EraseRootFromParent_Done,
     /*  241922 */   // Label 4984: @241922
     /*  241922 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(241985), // Rule ID 20295 //
     /*  241927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  241930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  241938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  241969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  241973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  241975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241983 */     GIR_RootConstrainSelectedInstOperands,
     /*  241984 */     // GIR_Coverage, 20295,
     /*  241984 */     GIR_EraseRootFromParent_Done,
     /*  241985 */   // Label 4985: @241985
     /*  241985 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(242048), // Rule ID 20298 //
     /*  241990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  241993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  241998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242029 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  242032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242046 */     GIR_RootConstrainSelectedInstOperands,
     /*  242047 */     // GIR_Coverage, 20298,
     /*  242047 */     GIR_EraseRootFromParent_Done,
     /*  242048 */   // Label 4986: @242048
     /*  242048 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(242111), // Rule ID 20299 //
     /*  242053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  242056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  242095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242109 */     GIR_RootConstrainSelectedInstOperands,
     /*  242110 */     // GIR_Coverage, 20299,
     /*  242110 */     GIR_EraseRootFromParent_Done,
     /*  242111 */   // Label 4987: @242111
     /*  242111 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(242174), // Rule ID 20302 //
     /*  242116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  242119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  242127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  242133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  242155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  242158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242172 */     GIR_RootConstrainSelectedInstOperands,
     /*  242173 */     // GIR_Coverage, 20302,
     /*  242173 */     GIR_EraseRootFromParent_Done,
     /*  242174 */   // Label 4988: @242174
     /*  242174 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(242237), // Rule ID 20303 //
     /*  242179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  242182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  242190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  242196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  242218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  242221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242235 */     GIR_RootConstrainSelectedInstOperands,
     /*  242236 */     // GIR_Coverage, 20303,
     /*  242236 */     GIR_EraseRootFromParent_Done,
     /*  242237 */   // Label 4989: @242237
     /*  242237 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(242300), // Rule ID 20306 //
     /*  242242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  242245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  242256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242281 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  242281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  242284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242298 */     GIR_RootConstrainSelectedInstOperands,
     /*  242299 */     // GIR_Coverage, 20306,
     /*  242299 */     GIR_EraseRootFromParent_Done,
     /*  242300 */   // Label 4990: @242300
     /*  242300 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(242363), // Rule ID 20307 //
     /*  242305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  242308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  242319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  242347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242361 */     GIR_RootConstrainSelectedInstOperands,
     /*  242362 */     // GIR_Coverage, 20307,
     /*  242362 */     GIR_EraseRootFromParent_Done,
     /*  242363 */   // Label 4991: @242363
     /*  242363 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(242426), // Rule ID 20310 //
     /*  242368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  242371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  242382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242407 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  242407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  242410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242424 */     GIR_RootConstrainSelectedInstOperands,
     /*  242425 */     // GIR_Coverage, 20310,
     /*  242425 */     GIR_EraseRootFromParent_Done,
     /*  242426 */   // Label 4992: @242426
     /*  242426 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(242489), // Rule ID 20311 //
     /*  242431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  242434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  242445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  242473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242487 */     GIR_RootConstrainSelectedInstOperands,
     /*  242488 */     // GIR_Coverage, 20311,
     /*  242488 */     GIR_EraseRootFromParent_Done,
     /*  242489 */   // Label 4993: @242489
     /*  242489 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(242552), // Rule ID 20314 //
     /*  242494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  242497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  242511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242533 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  242533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  242536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242550 */     GIR_RootConstrainSelectedInstOperands,
     /*  242551 */     // GIR_Coverage, 20314,
     /*  242551 */     GIR_EraseRootFromParent_Done,
     /*  242552 */   // Label 4994: @242552
     /*  242552 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(242615), // Rule ID 20315 //
     /*  242557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  242560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  242574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242596 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  242599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242613 */     GIR_RootConstrainSelectedInstOperands,
     /*  242614 */     // GIR_Coverage, 20315,
     /*  242614 */     GIR_EraseRootFromParent_Done,
     /*  242615 */   // Label 4995: @242615
     /*  242615 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(242678), // Rule ID 20318 //
     /*  242620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  242623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  242662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242676 */     GIR_RootConstrainSelectedInstOperands,
     /*  242677 */     // GIR_Coverage, 20318,
     /*  242677 */     GIR_EraseRootFromParent_Done,
     /*  242678 */   // Label 4996: @242678
     /*  242678 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(242741), // Rule ID 20319 //
     /*  242683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  242686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  242725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242739 */     GIR_RootConstrainSelectedInstOperands,
     /*  242740 */     // GIR_Coverage, 20319,
     /*  242740 */     GIR_EraseRootFromParent_Done,
     /*  242741 */   // Label 4997: @242741
     /*  242741 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(242804), // Rule ID 20322 //
     /*  242746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  242749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242785 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  242788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242802 */     GIR_RootConstrainSelectedInstOperands,
     /*  242803 */     // GIR_Coverage, 20322,
     /*  242803 */     GIR_EraseRootFromParent_Done,
     /*  242804 */   // Label 4998: @242804
     /*  242804 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(242867), // Rule ID 20323 //
     /*  242809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  242812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  242851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242865 */     GIR_RootConstrainSelectedInstOperands,
     /*  242866 */     // GIR_Coverage, 20323,
     /*  242866 */     GIR_EraseRootFromParent_Done,
     /*  242867 */   // Label 4999: @242867
     /*  242867 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(242930), // Rule ID 20326 //
     /*  242872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  242875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  242889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242911 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  242914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242928 */     GIR_RootConstrainSelectedInstOperands,
     /*  242929 */     // GIR_Coverage, 20326,
     /*  242929 */     GIR_EraseRootFromParent_Done,
     /*  242930 */   // Label 5000: @242930
     /*  242930 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(242993), // Rule ID 20327 //
     /*  242935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  242938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  242943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  242952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  242977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  242981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  242983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242991 */     GIR_RootConstrainSelectedInstOperands,
     /*  242992 */     // GIR_Coverage, 20327,
     /*  242992 */     GIR_EraseRootFromParent_Done,
     /*  242993 */   // Label 5001: @242993
     /*  242993 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(243056), // Rule ID 20330 //
     /*  242998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  243001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  243009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  243015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243037 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  243037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  243040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243054 */     GIR_RootConstrainSelectedInstOperands,
     /*  243055 */     // GIR_Coverage, 20330,
     /*  243055 */     GIR_EraseRootFromParent_Done,
     /*  243056 */   // Label 5002: @243056
     /*  243056 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(243119), // Rule ID 20331 //
     /*  243061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  243064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  243072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  243078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  243100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  243103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243117 */     GIR_RootConstrainSelectedInstOperands,
     /*  243118 */     // GIR_Coverage, 20331,
     /*  243118 */     GIR_EraseRootFromParent_Done,
     /*  243119 */   // Label 5003: @243119
     /*  243119 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(243182), // Rule ID 20334 //
     /*  243124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  243127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  243135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  243141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243163 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  243163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  243166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243180 */     GIR_RootConstrainSelectedInstOperands,
     /*  243181 */     // GIR_Coverage, 20334,
     /*  243181 */     GIR_EraseRootFromParent_Done,
     /*  243182 */   // Label 5004: @243182
     /*  243182 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(243245), // Rule ID 20335 //
     /*  243187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  243190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  243198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  243204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  243226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  243229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243243 */     GIR_RootConstrainSelectedInstOperands,
     /*  243244 */     // GIR_Coverage, 20335,
     /*  243244 */     GIR_EraseRootFromParent_Done,
     /*  243245 */   // Label 5005: @243245
     /*  243245 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(243308), // Rule ID 20338 //
     /*  243250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  243253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  243261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  243267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243289 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  243289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  243292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243306 */     GIR_RootConstrainSelectedInstOperands,
     /*  243307 */     // GIR_Coverage, 20338,
     /*  243307 */     GIR_EraseRootFromParent_Done,
     /*  243308 */   // Label 5006: @243308
     /*  243308 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(243371), // Rule ID 20339 //
     /*  243313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  243316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  243321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  243324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  243330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  243352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  243355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243369 */     GIR_RootConstrainSelectedInstOperands,
     /*  243370 */     // GIR_Coverage, 20339,
     /*  243370 */     GIR_EraseRootFromParent_Done,
     /*  243371 */   // Label 5007: @243371
     /*  243371 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(243437), // Rule ID 20342 //
     /*  243376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  243379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  243387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  243390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243415 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  243418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243435 */     GIR_RootConstrainSelectedInstOperands,
     /*  243436 */     // GIR_Coverage, 20342,
     /*  243436 */     GIR_EraseRootFromParent_Done,
     /*  243437 */   // Label 5008: @243437
     /*  243437 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(243503), // Rule ID 20343 //
     /*  243442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  243445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  243453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  243456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243481 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  243484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243501 */     GIR_RootConstrainSelectedInstOperands,
     /*  243502 */     // GIR_Coverage, 20343,
     /*  243502 */     GIR_EraseRootFromParent_Done,
     /*  243503 */   // Label 5009: @243503
     /*  243503 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(243569), // Rule ID 20346 //
     /*  243508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  243511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  243519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  243522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  243525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243547 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  243550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243567 */     GIR_RootConstrainSelectedInstOperands,
     /*  243568 */     // GIR_Coverage, 20346,
     /*  243568 */     GIR_EraseRootFromParent_Done,
     /*  243569 */   // Label 5010: @243569
     /*  243569 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(243635), // Rule ID 20347 //
     /*  243574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  243577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  243585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  243588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  243591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243613 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  243616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243633 */     GIR_RootConstrainSelectedInstOperands,
     /*  243634 */     // GIR_Coverage, 20347,
     /*  243634 */     GIR_EraseRootFromParent_Done,
     /*  243635 */   // Label 5011: @243635
     /*  243635 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(243701), // Rule ID 20350 //
     /*  243640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  243643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  243651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  243654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243679 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  243682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243699 */     GIR_RootConstrainSelectedInstOperands,
     /*  243700 */     // GIR_Coverage, 20350,
     /*  243700 */     GIR_EraseRootFromParent_Done,
     /*  243701 */   // Label 5012: @243701
     /*  243701 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(243767), // Rule ID 20351 //
     /*  243706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  243709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  243717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  243720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  243748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243765 */     GIR_RootConstrainSelectedInstOperands,
     /*  243766 */     // GIR_Coverage, 20351,
     /*  243766 */     GIR_EraseRootFromParent_Done,
     /*  243767 */   // Label 5013: @243767
     /*  243767 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(243833), // Rule ID 20354 //
     /*  243772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  243775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  243783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  243786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  243789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  243814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243831 */     GIR_RootConstrainSelectedInstOperands,
     /*  243832 */     // GIR_Coverage, 20354,
     /*  243832 */     GIR_EraseRootFromParent_Done,
     /*  243833 */   // Label 5014: @243833
     /*  243833 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(243899), // Rule ID 20355 //
     /*  243838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  243841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  243849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  243852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  243855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  243880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243897 */     GIR_RootConstrainSelectedInstOperands,
     /*  243898 */     // GIR_Coverage, 20355,
     /*  243898 */     GIR_EraseRootFromParent_Done,
     /*  243899 */   // Label 5015: @243899
     /*  243899 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(243965), // Rule ID 20358 //
     /*  243904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  243907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  243921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  243946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243963 */     GIR_RootConstrainSelectedInstOperands,
     /*  243964 */     // GIR_Coverage, 20358,
     /*  243964 */     GIR_EraseRootFromParent_Done,
     /*  243965 */   // Label 5016: @243965
     /*  243965 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(244031), // Rule ID 20359 //
     /*  243970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  243973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  243978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  243987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  244012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244029 */     GIR_RootConstrainSelectedInstOperands,
     /*  244030 */     // GIR_Coverage, 20359,
     /*  244030 */     GIR_EraseRootFromParent_Done,
     /*  244031 */   // Label 5017: @244031
     /*  244031 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(244097), // Rule ID 20362 //
     /*  244036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  244039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  244053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244095 */     GIR_RootConstrainSelectedInstOperands,
     /*  244096 */     // GIR_Coverage, 20362,
     /*  244096 */     GIR_EraseRootFromParent_Done,
     /*  244097 */   // Label 5018: @244097
     /*  244097 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(244163), // Rule ID 20363 //
     /*  244102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  244105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  244119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244141 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244161 */     GIR_RootConstrainSelectedInstOperands,
     /*  244162 */     // GIR_Coverage, 20363,
     /*  244162 */     GIR_EraseRootFromParent_Done,
     /*  244163 */   // Label 5019: @244163
     /*  244163 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(244229), // Rule ID 20366 //
     /*  244168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  244171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  244185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244207 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  244210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244227 */     GIR_RootConstrainSelectedInstOperands,
     /*  244228 */     // GIR_Coverage, 20366,
     /*  244228 */     GIR_EraseRootFromParent_Done,
     /*  244229 */   // Label 5020: @244229
     /*  244229 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(244295), // Rule ID 20367 //
     /*  244234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  244237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  244251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244273 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  244276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244293 */     GIR_RootConstrainSelectedInstOperands,
     /*  244294 */     // GIR_Coverage, 20367,
     /*  244294 */     GIR_EraseRootFromParent_Done,
     /*  244295 */   // Label 5021: @244295
     /*  244295 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(244361), // Rule ID 20370 //
     /*  244300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  244303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  244317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  244342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244359 */     GIR_RootConstrainSelectedInstOperands,
     /*  244360 */     // GIR_Coverage, 20370,
     /*  244360 */     GIR_EraseRootFromParent_Done,
     /*  244361 */   // Label 5022: @244361
     /*  244361 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(244427), // Rule ID 20371 //
     /*  244366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  244369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  244383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244405 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  244408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244425 */     GIR_RootConstrainSelectedInstOperands,
     /*  244426 */     // GIR_Coverage, 20371,
     /*  244426 */     GIR_EraseRootFromParent_Done,
     /*  244427 */   // Label 5023: @244427
     /*  244427 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(244493), // Rule ID 20374 //
     /*  244432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  244435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  244443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  244446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  244449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244491 */     GIR_RootConstrainSelectedInstOperands,
     /*  244492 */     // GIR_Coverage, 20374,
     /*  244492 */     GIR_EraseRootFromParent_Done,
     /*  244493 */   // Label 5024: @244493
     /*  244493 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(244559), // Rule ID 20375 //
     /*  244498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  244501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  244509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  244512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  244515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244557 */     GIR_RootConstrainSelectedInstOperands,
     /*  244558 */     // GIR_Coverage, 20375,
     /*  244558 */     GIR_EraseRootFromParent_Done,
     /*  244559 */   // Label 5025: @244559
     /*  244559 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(244625), // Rule ID 20378 //
     /*  244564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  244567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  244575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  244578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  244581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  244606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244623 */     GIR_RootConstrainSelectedInstOperands,
     /*  244624 */     // GIR_Coverage, 20378,
     /*  244624 */     GIR_EraseRootFromParent_Done,
     /*  244625 */   // Label 5026: @244625
     /*  244625 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(244691), // Rule ID 20379 //
     /*  244630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  244633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  244641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  244644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  244647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  244672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244689 */     GIR_RootConstrainSelectedInstOperands,
     /*  244690 */     // GIR_Coverage, 20379,
     /*  244690 */     GIR_EraseRootFromParent_Done,
     /*  244691 */   // Label 5027: @244691
     /*  244691 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(244757), // Rule ID 20382 //
     /*  244696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  244699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  244707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  244710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  244713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  244738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244755 */     GIR_RootConstrainSelectedInstOperands,
     /*  244756 */     // GIR_Coverage, 20382,
     /*  244756 */     GIR_EraseRootFromParent_Done,
     /*  244757 */   // Label 5028: @244757
     /*  244757 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(244823), // Rule ID 20383 //
     /*  244762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  244765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  244773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  244776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  244779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  244804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244821 */     GIR_RootConstrainSelectedInstOperands,
     /*  244822 */     // GIR_Coverage, 20383,
     /*  244822 */     GIR_EraseRootFromParent_Done,
     /*  244823 */   // Label 5029: @244823
     /*  244823 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(244889), // Rule ID 20386 //
     /*  244828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  244831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  244845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244887 */     GIR_RootConstrainSelectedInstOperands,
     /*  244888 */     // GIR_Coverage, 20386,
     /*  244888 */     GIR_EraseRootFromParent_Done,
     /*  244889 */   // Label 5030: @244889
     /*  244889 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(244955), // Rule ID 20387 //
     /*  244894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  244897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  244911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  244936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244953 */     GIR_RootConstrainSelectedInstOperands,
     /*  244954 */     // GIR_Coverage, 20387,
     /*  244954 */     GIR_EraseRootFromParent_Done,
     /*  244955 */   // Label 5031: @244955
     /*  244955 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(245021), // Rule ID 20390 //
     /*  244960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  244963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  244971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  244974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  244977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244999 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  245002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245019 */     GIR_RootConstrainSelectedInstOperands,
     /*  245020 */     // GIR_Coverage, 20390,
     /*  245020 */     GIR_EraseRootFromParent_Done,
     /*  245021 */   // Label 5032: @245021
     /*  245021 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(245087), // Rule ID 20391 //
     /*  245026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  245029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  245034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  245043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245065 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  245068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245085 */     GIR_RootConstrainSelectedInstOperands,
     /*  245086 */     // GIR_Coverage, 20391,
     /*  245086 */     GIR_EraseRootFromParent_Done,
     /*  245087 */   // Label 5033: @245087
     /*  245087 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(245153), // Rule ID 20394 //
     /*  245092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  245095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  245100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  245109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  245134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245151 */     GIR_RootConstrainSelectedInstOperands,
     /*  245152 */     // GIR_Coverage, 20394,
     /*  245152 */     GIR_EraseRootFromParent_Done,
     /*  245153 */   // Label 5034: @245153
     /*  245153 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(245219), // Rule ID 20395 //
     /*  245158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  245161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  245166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  245175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245197 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  245200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245217 */     GIR_RootConstrainSelectedInstOperands,
     /*  245218 */     // GIR_Coverage, 20395,
     /*  245218 */     GIR_EraseRootFromParent_Done,
     /*  245219 */   // Label 5035: @245219
     /*  245219 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(245285), // Rule ID 20720 //
     /*  245224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  245227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  245235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  245238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245263 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  245266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245283 */     GIR_RootConstrainSelectedInstOperands,
     /*  245284 */     // GIR_Coverage, 20720,
     /*  245284 */     GIR_EraseRootFromParent_Done,
     /*  245285 */   // Label 5036: @245285
     /*  245285 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(245351), // Rule ID 20721 //
     /*  245290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  245293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  245301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  245304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  245332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245349 */     GIR_RootConstrainSelectedInstOperands,
     /*  245350 */     // GIR_Coverage, 20721,
     /*  245350 */     GIR_EraseRootFromParent_Done,
     /*  245351 */   // Label 5037: @245351
     /*  245351 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(245417), // Rule ID 20724 //
     /*  245356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  245359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  245367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  245370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245395 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  245398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245415 */     GIR_RootConstrainSelectedInstOperands,
     /*  245416 */     // GIR_Coverage, 20724,
     /*  245416 */     GIR_EraseRootFromParent_Done,
     /*  245417 */   // Label 5038: @245417
     /*  245417 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(245483), // Rule ID 20725 //
     /*  245422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  245425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  245433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  245436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  245464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245481 */     GIR_RootConstrainSelectedInstOperands,
     /*  245482 */     // GIR_Coverage, 20725,
     /*  245482 */     GIR_EraseRootFromParent_Done,
     /*  245483 */   // Label 5039: @245483
     /*  245483 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(245549), // Rule ID 20728 //
     /*  245488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  245491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245527 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  245530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245547 */     GIR_RootConstrainSelectedInstOperands,
     /*  245548 */     // GIR_Coverage, 20728,
     /*  245548 */     GIR_EraseRootFromParent_Done,
     /*  245549 */   // Label 5040: @245549
     /*  245549 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(245615), // Rule ID 20729 //
     /*  245554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  245557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  245596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245613 */     GIR_RootConstrainSelectedInstOperands,
     /*  245614 */     // GIR_Coverage, 20729,
     /*  245614 */     GIR_EraseRootFromParent_Done,
     /*  245615 */   // Label 5041: @245615
     /*  245615 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(245681), // Rule ID 20732 //
     /*  245620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  245623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  245631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  245634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245659 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245679 */     GIR_RootConstrainSelectedInstOperands,
     /*  245680 */     // GIR_Coverage, 20732,
     /*  245680 */     GIR_EraseRootFromParent_Done,
     /*  245681 */   // Label 5042: @245681
     /*  245681 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(245747), // Rule ID 20733 //
     /*  245686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  245689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  245697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  245700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245725 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10886:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245745 */     GIR_RootConstrainSelectedInstOperands,
     /*  245746 */     // GIR_Coverage, 20733,
     /*  245746 */     GIR_EraseRootFromParent_Done,
     /*  245747 */   // Label 5043: @245747
     /*  245747 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(245813), // Rule ID 20736 //
     /*  245752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  245755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245791 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245811 */     GIR_RootConstrainSelectedInstOperands,
     /*  245812 */     // GIR_Coverage, 20736,
     /*  245812 */     GIR_EraseRootFromParent_Done,
     /*  245813 */   // Label 5044: @245813
     /*  245813 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(245879), // Rule ID 20737 //
     /*  245818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  245821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245857 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245877 */     GIR_RootConstrainSelectedInstOperands,
     /*  245878 */     // GIR_Coverage, 20737,
     /*  245878 */     GIR_EraseRootFromParent_Done,
     /*  245879 */   // Label 5045: @245879
     /*  245879 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(245945), // Rule ID 20740 //
     /*  245884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  245887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  245901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245923 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245943 */     GIR_RootConstrainSelectedInstOperands,
     /*  245944 */     // GIR_Coverage, 20740,
     /*  245944 */     GIR_EraseRootFromParent_Done,
     /*  245945 */   // Label 5046: @245945
     /*  245945 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(246011), // Rule ID 20741 //
     /*  245950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  245953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  245958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  245967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245989 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  245992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246009 */     GIR_RootConstrainSelectedInstOperands,
     /*  246010 */     // GIR_Coverage, 20741,
     /*  246010 */     GIR_EraseRootFromParent_Done,
     /*  246011 */   // Label 5047: @246011
     /*  246011 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(246077), // Rule ID 20744 //
     /*  246016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  246019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  246027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  246030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  246033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  246055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246075 */     GIR_RootConstrainSelectedInstOperands,
     /*  246076 */     // GIR_Coverage, 20744,
     /*  246076 */     GIR_EraseRootFromParent_Done,
     /*  246077 */   // Label 5048: @246077
     /*  246077 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(246143), // Rule ID 20745 //
     /*  246082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  246085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  246093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  246096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  246099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  246121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246141 */     GIR_RootConstrainSelectedInstOperands,
     /*  246142 */     // GIR_Coverage, 20745,
     /*  246142 */     GIR_EraseRootFromParent_Done,
     /*  246143 */   // Label 5049: @246143
     /*  246143 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(246209), // Rule ID 20748 //
     /*  246148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  246151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  246159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  246162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  246165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246187 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  246187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  246190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246207 */     GIR_RootConstrainSelectedInstOperands,
     /*  246208 */     // GIR_Coverage, 20748,
     /*  246208 */     GIR_EraseRootFromParent_Done,
     /*  246209 */   // Label 5050: @246209
     /*  246209 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(246275), // Rule ID 20749 //
     /*  246214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  246217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  246225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  246228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  246231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246253 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  246253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  246256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246273 */     GIR_RootConstrainSelectedInstOperands,
     /*  246274 */     // GIR_Coverage, 20749,
     /*  246274 */     GIR_EraseRootFromParent_Done,
     /*  246275 */   // Label 5051: @246275
     /*  246275 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(246341), // Rule ID 20752 //
     /*  246280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  246283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  246291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  246294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  246297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246319 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  246319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  246322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246339 */     GIR_RootConstrainSelectedInstOperands,
     /*  246340 */     // GIR_Coverage, 20752,
     /*  246340 */     GIR_EraseRootFromParent_Done,
     /*  246341 */   // Label 5052: @246341
     /*  246341 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(246407), // Rule ID 20753 //
     /*  246346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  246349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  246357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  246360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  246363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246385 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  246385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  246388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  246402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246405 */     GIR_RootConstrainSelectedInstOperands,
     /*  246406 */     // GIR_Coverage, 20753,
     /*  246406 */     GIR_EraseRootFromParent_Done,
     /*  246407 */   // Label 5053: @246407
     /*  246407 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(246473), // Rule ID 20756 //
     /*  246412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  246415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246471 */     GIR_RootConstrainSelectedInstOperands,
     /*  246472 */     // GIR_Coverage, 20756,
     /*  246472 */     GIR_EraseRootFromParent_Done,
     /*  246473 */   // Label 5054: @246473
     /*  246473 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(246539), // Rule ID 20757 //
     /*  246478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  246481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246537 */     GIR_RootConstrainSelectedInstOperands,
     /*  246538 */     // GIR_Coverage, 20757,
     /*  246538 */     GIR_EraseRootFromParent_Done,
     /*  246539 */   // Label 5055: @246539
     /*  246539 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(246605), // Rule ID 20760 //
     /*  246544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  246547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  246586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246603 */     GIR_RootConstrainSelectedInstOperands,
     /*  246604 */     // GIR_Coverage, 20760,
     /*  246604 */     GIR_EraseRootFromParent_Done,
     /*  246605 */   // Label 5056: @246605
     /*  246605 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(246671), // Rule ID 20761 //
     /*  246610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  246613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246649 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  246652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246669 */     GIR_RootConstrainSelectedInstOperands,
     /*  246670 */     // GIR_Coverage, 20761,
     /*  246670 */     GIR_EraseRootFromParent_Done,
     /*  246671 */   // Label 5057: @246671
     /*  246671 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(246737), // Rule ID 20764 //
     /*  246676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  246679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  246693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  246718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246735 */     GIR_RootConstrainSelectedInstOperands,
     /*  246736 */     // GIR_Coverage, 20764,
     /*  246736 */     GIR_EraseRootFromParent_Done,
     /*  246737 */   // Label 5058: @246737
     /*  246737 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(246803), // Rule ID 20765 //
     /*  246742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  246745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  246759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  246784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246801 */     GIR_RootConstrainSelectedInstOperands,
     /*  246802 */     // GIR_Coverage, 20765,
     /*  246802 */     GIR_EraseRootFromParent_Done,
     /*  246803 */   // Label 5059: @246803
     /*  246803 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(246869), // Rule ID 20768 //
     /*  246808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  246811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  246825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246847 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246867 */     GIR_RootConstrainSelectedInstOperands,
     /*  246868 */     // GIR_Coverage, 20768,
     /*  246868 */     GIR_EraseRootFromParent_Done,
     /*  246869 */   // Label 5060: @246869
     /*  246869 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(246935), // Rule ID 20769 //
     /*  246874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  246877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  246891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  246916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246933 */     GIR_RootConstrainSelectedInstOperands,
     /*  246934 */     // GIR_Coverage, 20769,
     /*  246934 */     GIR_EraseRootFromParent_Done,
     /*  246935 */   // Label 5061: @246935
     /*  246935 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(247001), // Rule ID 20772 //
     /*  246940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  246943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  246948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  246957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  246982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246999 */     GIR_RootConstrainSelectedInstOperands,
     /*  247000 */     // GIR_Coverage, 20772,
     /*  247000 */     GIR_EraseRootFromParent_Done,
     /*  247001 */   // Label 5062: @247001
     /*  247001 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(247067), // Rule ID 20773 //
     /*  247006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  247009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  247014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  247023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247045 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  247048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247065 */     GIR_RootConstrainSelectedInstOperands,
     /*  247066 */     // GIR_Coverage, 20773,
     /*  247066 */     GIR_EraseRootFromParent_Done,
     /*  247067 */   // Label 5063: @247067
     /*  247067 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(247133), // Rule ID 20776 //
     /*  247072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  247075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  247080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  247089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247111 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  247114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247131 */     GIR_RootConstrainSelectedInstOperands,
     /*  247132 */     // GIR_Coverage, 20776,
     /*  247132 */     GIR_EraseRootFromParent_Done,
     /*  247133 */   // Label 5064: @247133
     /*  247133 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(247199), // Rule ID 20777 //
     /*  247138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  247141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  247146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  247155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  247180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247197 */     GIR_RootConstrainSelectedInstOperands,
     /*  247198 */     // GIR_Coverage, 20777,
     /*  247198 */     GIR_EraseRootFromParent_Done,
     /*  247199 */   // Label 5065: @247199
     /*  247199 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(247265), // Rule ID 20780 //
     /*  247204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  247207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  247243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  247246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247263 */     GIR_RootConstrainSelectedInstOperands,
     /*  247264 */     // GIR_Coverage, 20780,
     /*  247264 */     GIR_EraseRootFromParent_Done,
     /*  247265 */   // Label 5066: @247265
     /*  247265 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(247331), // Rule ID 20781 //
     /*  247270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  247273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  247309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  247312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247329 */     GIR_RootConstrainSelectedInstOperands,
     /*  247330 */     // GIR_Coverage, 20781,
     /*  247330 */     GIR_EraseRootFromParent_Done,
     /*  247331 */   // Label 5067: @247331
     /*  247331 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(247397), // Rule ID 20784 //
     /*  247336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  247339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  247347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  247350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247375 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  247375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  247378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247395 */     GIR_RootConstrainSelectedInstOperands,
     /*  247396 */     // GIR_Coverage, 20784,
     /*  247396 */     GIR_EraseRootFromParent_Done,
     /*  247397 */   // Label 5068: @247397
     /*  247397 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(247463), // Rule ID 20785 //
     /*  247402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  247405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  247413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  247416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247441 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  247441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  247444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247461 */     GIR_RootConstrainSelectedInstOperands,
     /*  247462 */     // GIR_Coverage, 20785,
     /*  247462 */     GIR_EraseRootFromParent_Done,
     /*  247463 */   // Label 5069: @247463
     /*  247463 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(247529), // Rule ID 20788 //
     /*  247468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  247471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  247479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  247482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  247485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  247507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  247510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247527 */     GIR_RootConstrainSelectedInstOperands,
     /*  247528 */     // GIR_Coverage, 20788,
     /*  247528 */     GIR_EraseRootFromParent_Done,
     /*  247529 */   // Label 5070: @247529
     /*  247529 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(247595), // Rule ID 20789 //
     /*  247534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  247537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  247545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  247548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  247551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  247576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247593 */     GIR_RootConstrainSelectedInstOperands,
     /*  247594 */     // GIR_Coverage, 20789,
     /*  247594 */     GIR_EraseRootFromParent_Done,
     /*  247595 */   // Label 5071: @247595
     /*  247595 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(247661), // Rule ID 20792 //
     /*  247600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  247603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  247611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  247614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247639 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  247639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247659 */     GIR_RootConstrainSelectedInstOperands,
     /*  247660 */     // GIR_Coverage, 20792,
     /*  247660 */     GIR_EraseRootFromParent_Done,
     /*  247661 */   // Label 5072: @247661
     /*  247661 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(247727), // Rule ID 20793 //
     /*  247666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  247669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  247677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  247680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247705 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  247705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247725 */     GIR_RootConstrainSelectedInstOperands,
     /*  247726 */     // GIR_Coverage, 20793,
     /*  247726 */     GIR_EraseRootFromParent_Done,
     /*  247727 */   // Label 5073: @247727
     /*  247727 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(247793), // Rule ID 20796 //
     /*  247732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  247735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  247743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  247746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  247749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  247771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247791 */     GIR_RootConstrainSelectedInstOperands,
     /*  247792 */     // GIR_Coverage, 20796,
     /*  247792 */     GIR_EraseRootFromParent_Done,
     /*  247793 */   // Label 5074: @247793
     /*  247793 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(247859), // Rule ID 20797 //
     /*  247798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  247801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  247809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  247812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  247815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247857 */     GIR_RootConstrainSelectedInstOperands,
     /*  247858 */     // GIR_Coverage, 20797,
     /*  247858 */     GIR_EraseRootFromParent_Done,
     /*  247859 */   // Label 5075: @247859
     /*  247859 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(247925), // Rule ID 20800 //
     /*  247864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  247867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  247881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247903 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247923 */     GIR_RootConstrainSelectedInstOperands,
     /*  247924 */     // GIR_Coverage, 20800,
     /*  247924 */     GIR_EraseRootFromParent_Done,
     /*  247925 */   // Label 5076: @247925
     /*  247925 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(247991), // Rule ID 20801 //
     /*  247930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  247933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  247938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  247947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  247972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247989 */     GIR_RootConstrainSelectedInstOperands,
     /*  247990 */     // GIR_Coverage, 20801,
     /*  247990 */     GIR_EraseRootFromParent_Done,
     /*  247991 */   // Label 5077: @247991
     /*  247991 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(248057), // Rule ID 20804 //
     /*  247996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  247999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  248013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248035 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248055 */     GIR_RootConstrainSelectedInstOperands,
     /*  248056 */     // GIR_Coverage, 20804,
     /*  248056 */     GIR_EraseRootFromParent_Done,
     /*  248057 */   // Label 5078: @248057
     /*  248057 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(248123), // Rule ID 20805 //
     /*  248062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  248065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  248079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248121 */     GIR_RootConstrainSelectedInstOperands,
     /*  248122 */     // GIR_Coverage, 20805,
     /*  248122 */     GIR_EraseRootFromParent_Done,
     /*  248123 */   // Label 5079: @248123
     /*  248123 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(248189), // Rule ID 20808 //
     /*  248128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  248131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  248145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248167 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  248170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248187 */     GIR_RootConstrainSelectedInstOperands,
     /*  248188 */     // GIR_Coverage, 20808,
     /*  248188 */     GIR_EraseRootFromParent_Done,
     /*  248189 */   // Label 5080: @248189
     /*  248189 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(248255), // Rule ID 20809 //
     /*  248194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  248197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  248211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248233 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  248236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248253 */     GIR_RootConstrainSelectedInstOperands,
     /*  248254 */     // GIR_Coverage, 20809,
     /*  248254 */     GIR_EraseRootFromParent_Done,
     /*  248255 */   // Label 5081: @248255
     /*  248255 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(248321), // Rule ID 20812 //
     /*  248260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  248263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  248277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  248302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248319 */     GIR_RootConstrainSelectedInstOperands,
     /*  248320 */     // GIR_Coverage, 20812,
     /*  248320 */     GIR_EraseRootFromParent_Done,
     /*  248321 */   // Label 5082: @248321
     /*  248321 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(248387), // Rule ID 20813 //
     /*  248326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  248329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  248343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248365 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  248368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248385 */     GIR_RootConstrainSelectedInstOperands,
     /*  248386 */     // GIR_Coverage, 20813,
     /*  248386 */     GIR_EraseRootFromParent_Done,
     /*  248387 */   // Label 5083: @248387
     /*  248387 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(248453), // Rule ID 20816 //
     /*  248392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  248395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  248403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  248406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  248409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248451 */     GIR_RootConstrainSelectedInstOperands,
     /*  248452 */     // GIR_Coverage, 20816,
     /*  248452 */     GIR_EraseRootFromParent_Done,
     /*  248453 */   // Label 5084: @248453
     /*  248453 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(248519), // Rule ID 20817 //
     /*  248458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  248461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  248469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  248472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  248475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248517 */     GIR_RootConstrainSelectedInstOperands,
     /*  248518 */     // GIR_Coverage, 20817,
     /*  248518 */     GIR_EraseRootFromParent_Done,
     /*  248519 */   // Label 5085: @248519
     /*  248519 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(248585), // Rule ID 20820 //
     /*  248524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  248527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  248535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  248538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  248541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  248566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248583 */     GIR_RootConstrainSelectedInstOperands,
     /*  248584 */     // GIR_Coverage, 20820,
     /*  248584 */     GIR_EraseRootFromParent_Done,
     /*  248585 */   // Label 5086: @248585
     /*  248585 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(248651), // Rule ID 20821 //
     /*  248590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  248593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  248601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  248604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  248607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  248632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248649 */     GIR_RootConstrainSelectedInstOperands,
     /*  248650 */     // GIR_Coverage, 20821,
     /*  248650 */     GIR_EraseRootFromParent_Done,
     /*  248651 */   // Label 5087: @248651
     /*  248651 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(248717), // Rule ID 20824 //
     /*  248656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  248659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  248667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  248670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  248673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248695 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  248698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248715 */     GIR_RootConstrainSelectedInstOperands,
     /*  248716 */     // GIR_Coverage, 20824,
     /*  248716 */     GIR_EraseRootFromParent_Done,
     /*  248717 */   // Label 5088: @248717
     /*  248717 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(248783), // Rule ID 20825 //
     /*  248722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  248725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  248733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  248736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  248739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248761 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  248764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248781 */     GIR_RootConstrainSelectedInstOperands,
     /*  248782 */     // GIR_Coverage, 20825,
     /*  248782 */     GIR_EraseRootFromParent_Done,
     /*  248783 */   // Label 5089: @248783
     /*  248783 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(248849), // Rule ID 20828 //
     /*  248788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  248791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  248799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  248802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  248805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  248827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248847 */     GIR_RootConstrainSelectedInstOperands,
     /*  248848 */     // GIR_Coverage, 20828,
     /*  248848 */     GIR_EraseRootFromParent_Done,
     /*  248849 */   // Label 5090: @248849
     /*  248849 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(248915), // Rule ID 20829 //
     /*  248854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  248857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  248865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  248868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  248871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  248893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  248896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248913 */     GIR_RootConstrainSelectedInstOperands,
     /*  248914 */     // GIR_Coverage, 20829,
     /*  248914 */     GIR_EraseRootFromParent_Done,
     /*  248915 */   // Label 5091: @248915
     /*  248915 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(248981), // Rule ID 20832 //
     /*  248920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  248923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  248931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  248934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  248937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  248959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  248962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248979 */     GIR_RootConstrainSelectedInstOperands,
     /*  248980 */     // GIR_Coverage, 20832,
     /*  248980 */     GIR_EraseRootFromParent_Done,
     /*  248981 */   // Label 5092: @248981
     /*  248981 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(249047), // Rule ID 20833 //
     /*  248986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  248989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  248994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  248997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  249003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249025 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  249028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249045 */     GIR_RootConstrainSelectedInstOperands,
     /*  249046 */     // GIR_Coverage, 20833,
     /*  249046 */     GIR_EraseRootFromParent_Done,
     /*  249047 */   // Label 5093: @249047
     /*  249047 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(249113), // Rule ID 20836 //
     /*  249052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  249055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  249060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  249069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  249094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249111 */     GIR_RootConstrainSelectedInstOperands,
     /*  249112 */     // GIR_Coverage, 20836,
     /*  249112 */     GIR_EraseRootFromParent_Done,
     /*  249113 */   // Label 5094: @249113
     /*  249113 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(249179), // Rule ID 20837 //
     /*  249118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  249121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  249126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  249135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249157 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  249160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249177 */     GIR_RootConstrainSelectedInstOperands,
     /*  249178 */     // GIR_Coverage, 20837,
     /*  249178 */     GIR_EraseRootFromParent_Done,
     /*  249179 */   // Label 5095: @249179
     /*  249179 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(249245), // Rule ID 21104 //
     /*  249184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  249187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  249201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10982:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  249223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  249226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249243 */     GIR_RootConstrainSelectedInstOperands,
     /*  249244 */     // GIR_Coverage, 21104,
     /*  249244 */     GIR_EraseRootFromParent_Done,
     /*  249245 */   // Label 5096: @249245
     /*  249245 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(249311), // Rule ID 21105 //
     /*  249250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  249253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  249267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10982:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  249289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  249292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249309 */     GIR_RootConstrainSelectedInstOperands,
     /*  249310 */     // GIR_Coverage, 21105,
     /*  249310 */     GIR_EraseRootFromParent_Done,
     /*  249311 */   // Label 5097: @249311
     /*  249311 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(249377), // Rule ID 21108 //
     /*  249316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  249319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  249327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  249333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10982:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  249355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  249358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249375 */     GIR_RootConstrainSelectedInstOperands,
     /*  249376 */     // GIR_Coverage, 21108,
     /*  249376 */     GIR_EraseRootFromParent_Done,
     /*  249377 */   // Label 5098: @249377
     /*  249377 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(249443), // Rule ID 21109 //
     /*  249382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  249385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  249393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  249399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249421 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10982:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  249421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  249424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249441 */     GIR_RootConstrainSelectedInstOperands,
     /*  249442 */     // GIR_Coverage, 21109,
     /*  249442 */     GIR_EraseRootFromParent_Done,
     /*  249443 */   // Label 5099: @249443
     /*  249443 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(249509), // Rule ID 21112 //
     /*  249448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  249451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  249459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10982:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  249487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  249490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249507 */     GIR_RootConstrainSelectedInstOperands,
     /*  249508 */     // GIR_Coverage, 21112,
     /*  249508 */     GIR_EraseRootFromParent_Done,
     /*  249509 */   // Label 5100: @249509
     /*  249509 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(249575), // Rule ID 21113 //
     /*  249514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  249517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  249525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10982:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  249553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  249556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249573 */     GIR_RootConstrainSelectedInstOperands,
     /*  249574 */     // GIR_Coverage, 21113,
     /*  249574 */     GIR_EraseRootFromParent_Done,
     /*  249575 */   // Label 5101: @249575
     /*  249575 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(249641), // Rule ID 21116 //
     /*  249580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  249583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10982:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  249619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  249622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249639 */     GIR_RootConstrainSelectedInstOperands,
     /*  249640 */     // GIR_Coverage, 21116,
     /*  249640 */     GIR_EraseRootFromParent_Done,
     /*  249641 */   // Label 5102: @249641
     /*  249641 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(249707), // Rule ID 21117 //
     /*  249646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  249649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249685 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10982:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  249685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  249688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249705 */     GIR_RootConstrainSelectedInstOperands,
     /*  249706 */     // GIR_Coverage, 21117,
     /*  249706 */     GIR_EraseRootFromParent_Done,
     /*  249707 */   // Label 5103: @249707
     /*  249707 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(249773), // Rule ID 21120 //
     /*  249712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  249715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249751 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10982:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  249751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  249754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249771 */     GIR_RootConstrainSelectedInstOperands,
     /*  249772 */     // GIR_Coverage, 21120,
     /*  249772 */     GIR_EraseRootFromParent_Done,
     /*  249773 */   // Label 5104: @249773
     /*  249773 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(249839), // Rule ID 21121 //
     /*  249778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  249781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249817 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10982:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  249817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  249820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249837 */     GIR_RootConstrainSelectedInstOperands,
     /*  249838 */     // GIR_Coverage, 21121,
     /*  249838 */     GIR_EraseRootFromParent_Done,
     /*  249839 */   // Label 5105: @249839
     /*  249839 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(249905), // Rule ID 21124 //
     /*  249844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  249847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10982:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  249886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249903 */     GIR_RootConstrainSelectedInstOperands,
     /*  249904 */     // GIR_Coverage, 21124,
     /*  249904 */     GIR_EraseRootFromParent_Done,
     /*  249905 */   // Label 5106: @249905
     /*  249905 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(249971), // Rule ID 21125 //
     /*  249910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  249913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10982:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  249952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249969 */     GIR_RootConstrainSelectedInstOperands,
     /*  249970 */     // GIR_Coverage, 21125,
     /*  249970 */     GIR_EraseRootFromParent_Done,
     /*  249971 */   // Label 5107: @249971
     /*  249971 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(250037), // Rule ID 21128 //
     /*  249976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  249979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  249984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  249987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10982:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  250018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250035 */     GIR_RootConstrainSelectedInstOperands,
     /*  250036 */     // GIR_Coverage, 21128,
     /*  250036 */     GIR_EraseRootFromParent_Done,
     /*  250037 */   // Label 5108: @250037
     /*  250037 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(250103), // Rule ID 21129 //
     /*  250042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  250045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  250050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  250053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  250059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10982:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  250084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250101 */     GIR_RootConstrainSelectedInstOperands,
     /*  250102 */     // GIR_Coverage, 21129,
     /*  250102 */     GIR_EraseRootFromParent_Done,
     /*  250103 */   // Label 5109: @250103
     /*  250103 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(250169), // Rule ID 21132 //
     /*  250108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  250111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  250116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250147 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10982:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  250150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250167 */     GIR_RootConstrainSelectedInstOperands,
     /*  250168 */     // GIR_Coverage, 21132,
     /*  250168 */     GIR_EraseRootFromParent_Done,
     /*  250169 */   // Label 5110: @250169
     /*  250169 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(250235), // Rule ID 21133 //
     /*  250174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  250177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  250182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250213 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10982:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  250216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250233 */     GIR_RootConstrainSelectedInstOperands,
     /*  250234 */     // GIR_Coverage, 21133,
     /*  250234 */     GIR_EraseRootFromParent_Done,
     /*  250235 */   // Label 5111: @250235
     /*  250235 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(250301), // Rule ID 21136 //
     /*  250240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  250243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  250248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  250251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250279 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10982:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  250282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250299 */     GIR_RootConstrainSelectedInstOperands,
     /*  250300 */     // GIR_Coverage, 21136,
     /*  250300 */     GIR_EraseRootFromParent_Done,
     /*  250301 */   // Label 5112: @250301
     /*  250301 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(250367), // Rule ID 21137 //
     /*  250306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  250309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  250314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  250317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250345 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10982:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  250348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250365 */     GIR_RootConstrainSelectedInstOperands,
     /*  250366 */     // GIR_Coverage, 21137,
     /*  250366 */     GIR_EraseRootFromParent_Done,
     /*  250367 */   // Label 5113: @250367
     /*  250367 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(250433), // Rule ID 21140 //
     /*  250372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  250375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  250383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  250386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10980:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  250411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  250414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250431 */     GIR_RootConstrainSelectedInstOperands,
     /*  250432 */     // GIR_Coverage, 21140,
     /*  250432 */     GIR_EraseRootFromParent_Done,
     /*  250433 */   // Label 5114: @250433
     /*  250433 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(250499), // Rule ID 21141 //
     /*  250438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  250441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  250449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  250452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10980:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  250477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  250480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250497 */     GIR_RootConstrainSelectedInstOperands,
     /*  250498 */     // GIR_Coverage, 21141,
     /*  250498 */     GIR_EraseRootFromParent_Done,
     /*  250499 */   // Label 5115: @250499
     /*  250499 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(250565), // Rule ID 21144 //
     /*  250504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  250507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250543 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10980:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  250543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  250546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250563 */     GIR_RootConstrainSelectedInstOperands,
     /*  250564 */     // GIR_Coverage, 21144,
     /*  250564 */     GIR_EraseRootFromParent_Done,
     /*  250565 */   // Label 5116: @250565
     /*  250565 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(250631), // Rule ID 21145 //
     /*  250570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  250573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250609 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10980:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  250609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  250612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250629 */     GIR_RootConstrainSelectedInstOperands,
     /*  250630 */     // GIR_Coverage, 21145,
     /*  250630 */     GIR_EraseRootFromParent_Done,
     /*  250631 */   // Label 5117: @250631
     /*  250631 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(250697), // Rule ID 21148 //
     /*  250636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  250639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10980:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  250675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  250678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250695 */     GIR_RootConstrainSelectedInstOperands,
     /*  250696 */     // GIR_Coverage, 21148,
     /*  250696 */     GIR_EraseRootFromParent_Done,
     /*  250697 */   // Label 5118: @250697
     /*  250697 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(250763), // Rule ID 21149 //
     /*  250702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  250705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10980:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  250741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  250744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250761 */     GIR_RootConstrainSelectedInstOperands,
     /*  250762 */     // GIR_Coverage, 21149,
     /*  250762 */     GIR_EraseRootFromParent_Done,
     /*  250763 */   // Label 5119: @250763
     /*  250763 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(250829), // Rule ID 21152 //
     /*  250768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  250771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  250785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250807 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10980:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  250807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  250810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250827 */     GIR_RootConstrainSelectedInstOperands,
     /*  250828 */     // GIR_Coverage, 21152,
     /*  250828 */     GIR_EraseRootFromParent_Done,
     /*  250829 */   // Label 5120: @250829
     /*  250829 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(250895), // Rule ID 21153 //
     /*  250834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  250837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  250851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250873 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10980:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  250873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  250876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250893 */     GIR_RootConstrainSelectedInstOperands,
     /*  250894 */     // GIR_Coverage, 21153,
     /*  250894 */     GIR_EraseRootFromParent_Done,
     /*  250895 */   // Label 5121: @250895
     /*  250895 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(250961), // Rule ID 21156 //
     /*  250900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  250903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  250917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10980:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  250939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  250942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250959 */     GIR_RootConstrainSelectedInstOperands,
     /*  250960 */     // GIR_Coverage, 21156,
     /*  250960 */     GIR_EraseRootFromParent_Done,
     /*  250961 */   // Label 5122: @250961
     /*  250961 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(251027), // Rule ID 21157 //
     /*  250966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  250969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  250974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  250983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251005 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10980:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  251005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  251008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251025 */     GIR_RootConstrainSelectedInstOperands,
     /*  251026 */     // GIR_Coverage, 21157,
     /*  251026 */     GIR_EraseRootFromParent_Done,
     /*  251027 */   // Label 5123: @251027
     /*  251027 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(251093), // Rule ID 21160 //
     /*  251032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  251035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  251049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251071 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10980:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  251071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  251074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251091 */     GIR_RootConstrainSelectedInstOperands,
     /*  251092 */     // GIR_Coverage, 21160,
     /*  251092 */     GIR_EraseRootFromParent_Done,
     /*  251093 */   // Label 5124: @251093
     /*  251093 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(251159), // Rule ID 21161 //
     /*  251098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  251101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  251115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251137 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10980:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  251137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  251140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251157 */     GIR_RootConstrainSelectedInstOperands,
     /*  251158 */     // GIR_Coverage, 21161,
     /*  251158 */     GIR_EraseRootFromParent_Done,
     /*  251159 */   // Label 5125: @251159
     /*  251159 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(251225), // Rule ID 21164 //
     /*  251164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  251167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  251181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10980:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  251203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  251206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251223 */     GIR_RootConstrainSelectedInstOperands,
     /*  251224 */     // GIR_Coverage, 21164,
     /*  251224 */     GIR_EraseRootFromParent_Done,
     /*  251225 */   // Label 5126: @251225
     /*  251225 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(251291), // Rule ID 21165 //
     /*  251230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  251233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  251247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10980:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  251269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  251272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251289 */     GIR_RootConstrainSelectedInstOperands,
     /*  251290 */     // GIR_Coverage, 21165,
     /*  251290 */     GIR_EraseRootFromParent_Done,
     /*  251291 */   // Label 5127: @251291
     /*  251291 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(251357), // Rule ID 21168 //
     /*  251296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  251299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  251313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251335 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10980:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  251335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  251338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251355 */     GIR_RootConstrainSelectedInstOperands,
     /*  251356 */     // GIR_Coverage, 21168,
     /*  251356 */     GIR_EraseRootFromParent_Done,
     /*  251357 */   // Label 5128: @251357
     /*  251357 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(251423), // Rule ID 21169 //
     /*  251362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  251365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  251379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10980:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  251401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  251404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251421 */     GIR_RootConstrainSelectedInstOperands,
     /*  251422 */     // GIR_Coverage, 21169,
     /*  251422 */     GIR_EraseRootFromParent_Done,
     /*  251423 */   // Label 5129: @251423
     /*  251423 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(251489), // Rule ID 21172 //
     /*  251428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  251431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  251445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251467 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10980:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  251467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  251470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251487 */     GIR_RootConstrainSelectedInstOperands,
     /*  251488 */     // GIR_Coverage, 21172,
     /*  251488 */     GIR_EraseRootFromParent_Done,
     /*  251489 */   // Label 5130: @251489
     /*  251489 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(251555), // Rule ID 21173 //
     /*  251494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  251497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  251502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  251511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251533 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10980:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  251533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  251536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251553 */     GIR_RootConstrainSelectedInstOperands,
     /*  251554 */     // GIR_Coverage, 21173,
     /*  251554 */     GIR_EraseRootFromParent_Done,
     /*  251555 */   // Label 5131: @251555
     /*  251555 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(251621), // Rule ID 21176 //
     /*  251560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  251563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  251571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251599 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  251599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  251602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251619 */     GIR_RootConstrainSelectedInstOperands,
     /*  251620 */     // GIR_Coverage, 21176,
     /*  251620 */     GIR_EraseRootFromParent_Done,
     /*  251621 */   // Label 5132: @251621
     /*  251621 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(251687), // Rule ID 21177 //
     /*  251626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  251629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  251637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251665 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  251665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  251668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251685 */     GIR_RootConstrainSelectedInstOperands,
     /*  251686 */     // GIR_Coverage, 21177,
     /*  251686 */     GIR_EraseRootFromParent_Done,
     /*  251687 */   // Label 5133: @251687
     /*  251687 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(251753), // Rule ID 21180 //
     /*  251692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  251695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  251703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251731 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  251731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  251734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251751 */     GIR_RootConstrainSelectedInstOperands,
     /*  251752 */     // GIR_Coverage, 21180,
     /*  251752 */     GIR_EraseRootFromParent_Done,
     /*  251753 */   // Label 5134: @251753
     /*  251753 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(251819), // Rule ID 21181 //
     /*  251758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  251761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  251769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251797 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  251797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  251800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251817 */     GIR_RootConstrainSelectedInstOperands,
     /*  251818 */     // GIR_Coverage, 21181,
     /*  251818 */     GIR_EraseRootFromParent_Done,
     /*  251819 */   // Label 5135: @251819
     /*  251819 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(251885), // Rule ID 21184 //
     /*  251824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  251827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  251835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251863 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  251863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  251866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251883 */     GIR_RootConstrainSelectedInstOperands,
     /*  251884 */     // GIR_Coverage, 21184,
     /*  251884 */     GIR_EraseRootFromParent_Done,
     /*  251885 */   // Label 5136: @251885
     /*  251885 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(251951), // Rule ID 21185 //
     /*  251890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  251893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  251901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251929 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10978:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  251929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  251932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251949 */     GIR_RootConstrainSelectedInstOperands,
     /*  251950 */     // GIR_Coverage, 21185,
     /*  251950 */     GIR_EraseRootFromParent_Done,
     /*  251951 */   // Label 5137: @251951
     /*  251951 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(252017), // Rule ID 21188 //
     /*  251956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  251959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  251964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  251967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  251970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  251973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  251995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  251998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252015 */     GIR_RootConstrainSelectedInstOperands,
     /*  252016 */     // GIR_Coverage, 21188,
     /*  252016 */     GIR_EraseRootFromParent_Done,
     /*  252017 */   // Label 5138: @252017
     /*  252017 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(252083), // Rule ID 21189 //
     /*  252022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  252025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  252033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  252039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252061 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  252061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  252064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252081 */     GIR_RootConstrainSelectedInstOperands,
     /*  252082 */     // GIR_Coverage, 21189,
     /*  252082 */     GIR_EraseRootFromParent_Done,
     /*  252083 */   // Label 5139: @252083
     /*  252083 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(252149), // Rule ID 21192 //
     /*  252088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  252091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  252099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252127 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  252127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  252130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252147 */     GIR_RootConstrainSelectedInstOperands,
     /*  252148 */     // GIR_Coverage, 21192,
     /*  252148 */     GIR_EraseRootFromParent_Done,
     /*  252149 */   // Label 5140: @252149
     /*  252149 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(252215), // Rule ID 21193 //
     /*  252154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  252157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  252165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252193 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  252193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  252196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252213 */     GIR_RootConstrainSelectedInstOperands,
     /*  252214 */     // GIR_Coverage, 21193,
     /*  252214 */     GIR_EraseRootFromParent_Done,
     /*  252215 */   // Label 5141: @252215
     /*  252215 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(252281), // Rule ID 21196 //
     /*  252220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  252223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  252231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252259 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  252259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  252262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252279 */     GIR_RootConstrainSelectedInstOperands,
     /*  252280 */     // GIR_Coverage, 21196,
     /*  252280 */     GIR_EraseRootFromParent_Done,
     /*  252281 */   // Label 5142: @252281
     /*  252281 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(252347), // Rule ID 21197 //
     /*  252286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  252289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  252297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252325 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  252325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  252328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252345 */     GIR_RootConstrainSelectedInstOperands,
     /*  252346 */     // GIR_Coverage, 21197,
     /*  252346 */     GIR_EraseRootFromParent_Done,
     /*  252347 */   // Label 5143: @252347
     /*  252347 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(252413), // Rule ID 21200 //
     /*  252352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  252355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  252363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  252369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252391 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  252391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  252394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252411 */     GIR_RootConstrainSelectedInstOperands,
     /*  252412 */     // GIR_Coverage, 21200,
     /*  252412 */     GIR_EraseRootFromParent_Done,
     /*  252413 */   // Label 5144: @252413
     /*  252413 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(252479), // Rule ID 21201 //
     /*  252418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  252421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  252429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  252435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252457 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  252457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  252460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252477 */     GIR_RootConstrainSelectedInstOperands,
     /*  252478 */     // GIR_Coverage, 21201,
     /*  252478 */     GIR_EraseRootFromParent_Done,
     /*  252479 */   // Label 5145: @252479
     /*  252479 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(252545), // Rule ID 21204 //
     /*  252484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  252487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  252495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  252501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252523 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10978:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  252523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  252526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252543 */     GIR_RootConstrainSelectedInstOperands,
     /*  252544 */     // GIR_Coverage, 21204,
     /*  252544 */     GIR_EraseRootFromParent_Done,
     /*  252545 */   // Label 5146: @252545
     /*  252545 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(252611), // Rule ID 21205 //
     /*  252550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  252553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  252561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  252567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252589 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10978:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  252589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  252592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252609 */     GIR_RootConstrainSelectedInstOperands,
     /*  252610 */     // GIR_Coverage, 21205,
     /*  252610 */     GIR_EraseRootFromParent_Done,
     /*  252611 */   // Label 5147: @252611
     /*  252611 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(252677), // Rule ID 21208 //
     /*  252616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  252619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  252627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252655 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  252655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  252658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252675 */     GIR_RootConstrainSelectedInstOperands,
     /*  252676 */     // GIR_Coverage, 21208,
     /*  252676 */     GIR_EraseRootFromParent_Done,
     /*  252677 */   // Label 5148: @252677
     /*  252677 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(252743), // Rule ID 21209 //
     /*  252682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  252685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  252693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252721 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  252721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  252724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252741 */     GIR_RootConstrainSelectedInstOperands,
     /*  252742 */     // GIR_Coverage, 21209,
     /*  252742 */     GIR_EraseRootFromParent_Done,
     /*  252743 */   // Label 5149: @252743
     /*  252743 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(252809), // Rule ID 21212 //
     /*  252748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  252751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  252759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  252765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252787 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  252787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  252790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252807 */     GIR_RootConstrainSelectedInstOperands,
     /*  252808 */     // GIR_Coverage, 21212,
     /*  252808 */     GIR_EraseRootFromParent_Done,
     /*  252809 */   // Label 5150: @252809
     /*  252809 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(252875), // Rule ID 21213 //
     /*  252814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  252817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  252825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  252831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252853 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  252853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  252856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252873 */     GIR_RootConstrainSelectedInstOperands,
     /*  252874 */     // GIR_Coverage, 21213,
     /*  252874 */     GIR_EraseRootFromParent_Done,
     /*  252875 */   // Label 5151: @252875
     /*  252875 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(252941), // Rule ID 21216 //
     /*  252880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  252883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  252891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  252897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252919 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  252919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  252922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  252939 */     GIR_RootConstrainSelectedInstOperands,
     /*  252940 */     // GIR_Coverage, 21216,
     /*  252940 */     GIR_EraseRootFromParent_Done,
     /*  252941 */   // Label 5152: @252941
     /*  252941 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(253007), // Rule ID 21217 //
     /*  252946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  252949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  252954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  252957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  252963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252985 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  252985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  252988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  252992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253005 */     GIR_RootConstrainSelectedInstOperands,
     /*  253006 */     // GIR_Coverage, 21217,
     /*  253006 */     GIR_EraseRootFromParent_Done,
     /*  253007 */   // Label 5153: @253007
     /*  253007 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(253073), // Rule ID 21220 //
     /*  253012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  253015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  253023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  253026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253051 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  253051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  253054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253071 */     GIR_RootConstrainSelectedInstOperands,
     /*  253072 */     // GIR_Coverage, 21220,
     /*  253072 */     GIR_EraseRootFromParent_Done,
     /*  253073 */   // Label 5154: @253073
     /*  253073 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(253139), // Rule ID 21221 //
     /*  253078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  253081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  253089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  253092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253117 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10978:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  253117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  253120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253137 */     GIR_RootConstrainSelectedInstOperands,
     /*  253138 */     // GIR_Coverage, 21221,
     /*  253138 */     GIR_EraseRootFromParent_Done,
     /*  253139 */   // Label 5155: @253139
     /*  253139 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(253205), // Rule ID 21224 //
     /*  253144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  253147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  253155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  253161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  253183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  253186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253203 */     GIR_RootConstrainSelectedInstOperands,
     /*  253204 */     // GIR_Coverage, 21224,
     /*  253204 */     GIR_EraseRootFromParent_Done,
     /*  253205 */   // Label 5156: @253205
     /*  253205 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(253271), // Rule ID 21225 //
     /*  253210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  253213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  253221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  253227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253249 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10978:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  253249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  253252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253269 */     GIR_RootConstrainSelectedInstOperands,
     /*  253270 */     // GIR_Coverage, 21225,
     /*  253270 */     GIR_EraseRootFromParent_Done,
     /*  253271 */   // Label 5157: @253271
     /*  253271 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(253337), // Rule ID 21228 //
     /*  253276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  253279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  253287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253315 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  253315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  253318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253335 */     GIR_RootConstrainSelectedInstOperands,
     /*  253336 */     // GIR_Coverage, 21228,
     /*  253336 */     GIR_EraseRootFromParent_Done,
     /*  253337 */   // Label 5158: @253337
     /*  253337 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(253403), // Rule ID 21229 //
     /*  253342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  253345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  253353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253381 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10978:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  253381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  253384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253401 */     GIR_RootConstrainSelectedInstOperands,
     /*  253402 */     // GIR_Coverage, 21229,
     /*  253402 */     GIR_EraseRootFromParent_Done,
     /*  253403 */   // Label 5159: @253403
     /*  253403 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(253469), // Rule ID 21232 //
     /*  253408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  253411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  253419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253447 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  253447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  253450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253467 */     GIR_RootConstrainSelectedInstOperands,
     /*  253468 */     // GIR_Coverage, 21232,
     /*  253468 */     GIR_EraseRootFromParent_Done,
     /*  253469 */   // Label 5160: @253469
     /*  253469 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(253535), // Rule ID 21233 //
     /*  253474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  253477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  253482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  253485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253513 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10978:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  253513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  253516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253533 */     GIR_RootConstrainSelectedInstOperands,
     /*  253534 */     // GIR_Coverage, 21233,
     /*  253534 */     GIR_EraseRootFromParent_Done,
     /*  253535 */   // Label 5161: @253535
     /*  253535 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(253601), // Rule ID 21236 //
     /*  253540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  253543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  253551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253579 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  253579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  253582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253599 */     GIR_RootConstrainSelectedInstOperands,
     /*  253600 */     // GIR_Coverage, 21236,
     /*  253600 */     GIR_EraseRootFromParent_Done,
     /*  253601 */   // Label 5162: @253601
     /*  253601 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(253667), // Rule ID 21237 //
     /*  253606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  253609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  253617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253645 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  253645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  253648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253665 */     GIR_RootConstrainSelectedInstOperands,
     /*  253666 */     // GIR_Coverage, 21237,
     /*  253666 */     GIR_EraseRootFromParent_Done,
     /*  253667 */   // Label 5163: @253667
     /*  253667 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(253733), // Rule ID 21240 //
     /*  253672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  253675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  253683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253711 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  253711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  253714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253731 */     GIR_RootConstrainSelectedInstOperands,
     /*  253732 */     // GIR_Coverage, 21240,
     /*  253732 */     GIR_EraseRootFromParent_Done,
     /*  253733 */   // Label 5164: @253733
     /*  253733 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(253799), // Rule ID 21241 //
     /*  253738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  253741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  253749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253777 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  253777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  253780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253797 */     GIR_RootConstrainSelectedInstOperands,
     /*  253798 */     // GIR_Coverage, 21241,
     /*  253798 */     GIR_EraseRootFromParent_Done,
     /*  253799 */   // Label 5165: @253799
     /*  253799 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(253865), // Rule ID 21244 //
     /*  253804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  253807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  253815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  253818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253843 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  253843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  253846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253863 */     GIR_RootConstrainSelectedInstOperands,
     /*  253864 */     // GIR_Coverage, 21244,
     /*  253864 */     GIR_EraseRootFromParent_Done,
     /*  253865 */   // Label 5166: @253865
     /*  253865 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(253931), // Rule ID 21245 //
     /*  253870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  253873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  253881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  253884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253909 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10976:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  253909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  253912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253929 */     GIR_RootConstrainSelectedInstOperands,
     /*  253930 */     // GIR_Coverage, 21245,
     /*  253930 */     GIR_EraseRootFromParent_Done,
     /*  253931 */   // Label 5167: @253931
     /*  253931 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(253997), // Rule ID 21248 //
     /*  253936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  253939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  253944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  253947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  253950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  253953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  253975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  253978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  253982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  253995 */     GIR_RootConstrainSelectedInstOperands,
     /*  253996 */     // GIR_Coverage, 21248,
     /*  253996 */     GIR_EraseRootFromParent_Done,
     /*  253997 */   // Label 5168: @253997
     /*  253997 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(254063), // Rule ID 21249 //
     /*  254002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  254005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  254013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  254041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  254044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254061 */     GIR_RootConstrainSelectedInstOperands,
     /*  254062 */     // GIR_Coverage, 21249,
     /*  254062 */     GIR_EraseRootFromParent_Done,
     /*  254063 */   // Label 5169: @254063
     /*  254063 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(254129), // Rule ID 21252 //
     /*  254068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  254071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  254079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254107 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  254107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  254110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254127 */     GIR_RootConstrainSelectedInstOperands,
     /*  254128 */     // GIR_Coverage, 21252,
     /*  254128 */     GIR_EraseRootFromParent_Done,
     /*  254129 */   // Label 5170: @254129
     /*  254129 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(254195), // Rule ID 21253 //
     /*  254134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  254137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  254145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254173 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  254173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  254176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254193 */     GIR_RootConstrainSelectedInstOperands,
     /*  254194 */     // GIR_Coverage, 21253,
     /*  254194 */     GIR_EraseRootFromParent_Done,
     /*  254195 */   // Label 5171: @254195
     /*  254195 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(254261), // Rule ID 21256 //
     /*  254200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  254203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  254211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  254214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254239 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  254239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  254242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254259 */     GIR_RootConstrainSelectedInstOperands,
     /*  254260 */     // GIR_Coverage, 21256,
     /*  254260 */     GIR_EraseRootFromParent_Done,
     /*  254261 */   // Label 5172: @254261
     /*  254261 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(254327), // Rule ID 21257 //
     /*  254266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  254269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  254277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  254280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254305 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  254305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  254308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254325 */     GIR_RootConstrainSelectedInstOperands,
     /*  254326 */     // GIR_Coverage, 21257,
     /*  254326 */     GIR_EraseRootFromParent_Done,
     /*  254327 */   // Label 5173: @254327
     /*  254327 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(254393), // Rule ID 21260 //
     /*  254332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  254335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  254343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254371 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  254371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  254374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254391 */     GIR_RootConstrainSelectedInstOperands,
     /*  254392 */     // GIR_Coverage, 21260,
     /*  254392 */     GIR_EraseRootFromParent_Done,
     /*  254393 */   // Label 5174: @254393
     /*  254393 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(254459), // Rule ID 21261 //
     /*  254398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  254401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  254409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254437 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  254437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  254440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254457 */     GIR_RootConstrainSelectedInstOperands,
     /*  254458 */     // GIR_Coverage, 21261,
     /*  254458 */     GIR_EraseRootFromParent_Done,
     /*  254459 */   // Label 5175: @254459
     /*  254459 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(254525), // Rule ID 21264 //
     /*  254464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  254467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  254475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254503 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10976:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  254503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  254506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254523 */     GIR_RootConstrainSelectedInstOperands,
     /*  254524 */     // GIR_Coverage, 21264,
     /*  254524 */     GIR_EraseRootFromParent_Done,
     /*  254525 */   // Label 5176: @254525
     /*  254525 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(254591), // Rule ID 21265 //
     /*  254530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  254533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  254541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254569 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10976:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  254569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  254572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254589 */     GIR_RootConstrainSelectedInstOperands,
     /*  254590 */     // GIR_Coverage, 21265,
     /*  254590 */     GIR_EraseRootFromParent_Done,
     /*  254591 */   // Label 5177: @254591
     /*  254591 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(254657), // Rule ID 21268 //
     /*  254596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  254599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  254607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  254610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  254635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  254638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254655 */     GIR_RootConstrainSelectedInstOperands,
     /*  254656 */     // GIR_Coverage, 21268,
     /*  254656 */     GIR_EraseRootFromParent_Done,
     /*  254657 */   // Label 5178: @254657
     /*  254657 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(254723), // Rule ID 21269 //
     /*  254662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  254665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  254673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  254676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254701 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  254701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  254704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254721 */     GIR_RootConstrainSelectedInstOperands,
     /*  254722 */     // GIR_Coverage, 21269,
     /*  254722 */     GIR_EraseRootFromParent_Done,
     /*  254723 */   // Label 5179: @254723
     /*  254723 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(254789), // Rule ID 21272 //
     /*  254728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  254731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  254739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  254742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254767 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  254767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  254770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254787 */     GIR_RootConstrainSelectedInstOperands,
     /*  254788 */     // GIR_Coverage, 21272,
     /*  254788 */     GIR_EraseRootFromParent_Done,
     /*  254789 */   // Label 5180: @254789
     /*  254789 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(254855), // Rule ID 21273 //
     /*  254794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  254797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  254805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  254808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  254833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  254836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254853 */     GIR_RootConstrainSelectedInstOperands,
     /*  254854 */     // GIR_Coverage, 21273,
     /*  254854 */     GIR_EraseRootFromParent_Done,
     /*  254855 */   // Label 5181: @254855
     /*  254855 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(254921), // Rule ID 21276 //
     /*  254860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  254863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  254871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  254874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254899 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  254899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  254902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254919 */     GIR_RootConstrainSelectedInstOperands,
     /*  254920 */     // GIR_Coverage, 21276,
     /*  254920 */     GIR_EraseRootFromParent_Done,
     /*  254921 */   // Label 5182: @254921
     /*  254921 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(254987), // Rule ID 21277 //
     /*  254926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  254929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  254934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  254937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  254940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254965 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  254965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  254968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  254972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  254985 */     GIR_RootConstrainSelectedInstOperands,
     /*  254986 */     // GIR_Coverage, 21277,
     /*  254986 */     GIR_EraseRootFromParent_Done,
     /*  254987 */   // Label 5183: @254987
     /*  254987 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(255053), // Rule ID 21280 //
     /*  254992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  254995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  255003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  255009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255031 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  255031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  255034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255051 */     GIR_RootConstrainSelectedInstOperands,
     /*  255052 */     // GIR_Coverage, 21280,
     /*  255052 */     GIR_EraseRootFromParent_Done,
     /*  255053 */   // Label 5184: @255053
     /*  255053 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(255119), // Rule ID 21281 //
     /*  255058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  255061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  255069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  255075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255097 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10976:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  255097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  255100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255117 */     GIR_RootConstrainSelectedInstOperands,
     /*  255118 */     // GIR_Coverage, 21281,
     /*  255118 */     GIR_EraseRootFromParent_Done,
     /*  255119 */   // Label 5185: @255119
     /*  255119 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(255185), // Rule ID 21284 //
     /*  255124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  255127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  255135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  255141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  255163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  255166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255183 */     GIR_RootConstrainSelectedInstOperands,
     /*  255184 */     // GIR_Coverage, 21284,
     /*  255184 */     GIR_EraseRootFromParent_Done,
     /*  255185 */   // Label 5186: @255185
     /*  255185 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(255251), // Rule ID 21285 //
     /*  255190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  255193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  255201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  255207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255229 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10976:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  255229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  255232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255249 */     GIR_RootConstrainSelectedInstOperands,
     /*  255250 */     // GIR_Coverage, 21285,
     /*  255250 */     GIR_EraseRootFromParent_Done,
     /*  255251 */   // Label 5187: @255251
     /*  255251 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(255317), // Rule ID 21288 //
     /*  255256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  255259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  255267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255295 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  255295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  255298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255315 */     GIR_RootConstrainSelectedInstOperands,
     /*  255316 */     // GIR_Coverage, 21288,
     /*  255316 */     GIR_EraseRootFromParent_Done,
     /*  255317 */   // Label 5188: @255317
     /*  255317 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(255383), // Rule ID 21289 //
     /*  255322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  255325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  255333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255361 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10976:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  255361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  255364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255381 */     GIR_RootConstrainSelectedInstOperands,
     /*  255382 */     // GIR_Coverage, 21289,
     /*  255382 */     GIR_EraseRootFromParent_Done,
     /*  255383 */   // Label 5189: @255383
     /*  255383 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(255449), // Rule ID 21292 //
     /*  255388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  255391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  255399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255427 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  255427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  255430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255447 */     GIR_RootConstrainSelectedInstOperands,
     /*  255448 */     // GIR_Coverage, 21292,
     /*  255448 */     GIR_EraseRootFromParent_Done,
     /*  255449 */   // Label 5190: @255449
     /*  255449 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(255515), // Rule ID 21293 //
     /*  255454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  255457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  255462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  255465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255493 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10976:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  255493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  255496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255513 */     GIR_RootConstrainSelectedInstOperands,
     /*  255514 */     // GIR_Coverage, 21293,
     /*  255514 */     GIR_EraseRootFromParent_Done,
     /*  255515 */   // Label 5191: @255515
     /*  255515 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(255581), // Rule ID 21296 //
     /*  255520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  255523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  255531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  255534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  255537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255559 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10974:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  255559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  255562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255579 */     GIR_RootConstrainSelectedInstOperands,
     /*  255580 */     // GIR_Coverage, 21296,
     /*  255580 */     GIR_EraseRootFromParent_Done,
     /*  255581 */   // Label 5192: @255581
     /*  255581 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(255647), // Rule ID 21297 //
     /*  255586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  255589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  255597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  255600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  255603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255625 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10974:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  255625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  255628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255645 */     GIR_RootConstrainSelectedInstOperands,
     /*  255646 */     // GIR_Coverage, 21297,
     /*  255646 */     GIR_EraseRootFromParent_Done,
     /*  255647 */   // Label 5193: @255647
     /*  255647 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(255713), // Rule ID 21300 //
     /*  255652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  255655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  255663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  255669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255691 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10974:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  255691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  255694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255711 */     GIR_RootConstrainSelectedInstOperands,
     /*  255712 */     // GIR_Coverage, 21300,
     /*  255712 */     GIR_EraseRootFromParent_Done,
     /*  255713 */   // Label 5194: @255713
     /*  255713 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(255779), // Rule ID 21301 //
     /*  255718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  255721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  255729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  255735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255757 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10974:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  255757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  255760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255777 */     GIR_RootConstrainSelectedInstOperands,
     /*  255778 */     // GIR_Coverage, 21301,
     /*  255778 */     GIR_EraseRootFromParent_Done,
     /*  255779 */   // Label 5195: @255779
     /*  255779 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(255845), // Rule ID 21304 //
     /*  255784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  255787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  255795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  255801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10974:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  255823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  255826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255843 */     GIR_RootConstrainSelectedInstOperands,
     /*  255844 */     // GIR_Coverage, 21304,
     /*  255844 */     GIR_EraseRootFromParent_Done,
     /*  255845 */   // Label 5196: @255845
     /*  255845 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(255911), // Rule ID 21305 //
     /*  255850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  255853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  255861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  255867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255889 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10974:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  255889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  255892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255909 */     GIR_RootConstrainSelectedInstOperands,
     /*  255910 */     // GIR_Coverage, 21305,
     /*  255910 */     GIR_EraseRootFromParent_Done,
     /*  255911 */   // Label 5197: @255911
     /*  255911 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(255977), // Rule ID 21308 //
     /*  255916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  255919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  255927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255955 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10974:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  255955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  255958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  255962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  255975 */     GIR_RootConstrainSelectedInstOperands,
     /*  255976 */     // GIR_Coverage, 21308,
     /*  255976 */     GIR_EraseRootFromParent_Done,
     /*  255977 */   // Label 5198: @255977
     /*  255977 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(256043), // Rule ID 21309 //
     /*  255982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  255985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  255990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  255993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256021 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10974:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  256021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  256024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256041 */     GIR_RootConstrainSelectedInstOperands,
     /*  256042 */     // GIR_Coverage, 21309,
     /*  256042 */     GIR_EraseRootFromParent_Done,
     /*  256043 */   // Label 5199: @256043
     /*  256043 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(256109), // Rule ID 21312 //
     /*  256048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  256051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  256059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  256065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256087 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10974:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  256087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  256090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256107 */     GIR_RootConstrainSelectedInstOperands,
     /*  256108 */     // GIR_Coverage, 21312,
     /*  256108 */     GIR_EraseRootFromParent_Done,
     /*  256109 */   // Label 5200: @256109
     /*  256109 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(256175), // Rule ID 21313 //
     /*  256114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  256117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  256125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  256131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256153 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10974:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  256153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  256156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256173 */     GIR_RootConstrainSelectedInstOperands,
     /*  256174 */     // GIR_Coverage, 21313,
     /*  256174 */     GIR_EraseRootFromParent_Done,
     /*  256175 */   // Label 5201: @256175
     /*  256175 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(256241), // Rule ID 21316 //
     /*  256180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  256183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  256191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  256194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  256197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256219 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10974:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  256219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  256222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256239 */     GIR_RootConstrainSelectedInstOperands,
     /*  256240 */     // GIR_Coverage, 21316,
     /*  256240 */     GIR_EraseRootFromParent_Done,
     /*  256241 */   // Label 5202: @256241
     /*  256241 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(256307), // Rule ID 21317 //
     /*  256246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  256249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  256257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  256260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  256263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256285 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10974:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  256285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  256288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256305 */     GIR_RootConstrainSelectedInstOperands,
     /*  256306 */     // GIR_Coverage, 21317,
     /*  256306 */     GIR_EraseRootFromParent_Done,
     /*  256307 */   // Label 5203: @256307
     /*  256307 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(256373), // Rule ID 21320 //
     /*  256312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  256315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  256323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  256329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256351 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10974:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  256351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  256354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256371 */     GIR_RootConstrainSelectedInstOperands,
     /*  256372 */     // GIR_Coverage, 21320,
     /*  256372 */     GIR_EraseRootFromParent_Done,
     /*  256373 */   // Label 5204: @256373
     /*  256373 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(256439), // Rule ID 21321 //
     /*  256378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  256381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  256389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  256395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256417 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10974:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  256417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  256420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256437 */     GIR_RootConstrainSelectedInstOperands,
     /*  256438 */     // GIR_Coverage, 21321,
     /*  256438 */     GIR_EraseRootFromParent_Done,
     /*  256439 */   // Label 5205: @256439
     /*  256439 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(256505), // Rule ID 21324 //
     /*  256444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  256447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  256455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  256461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256483 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10974:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  256483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  256486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256503 */     GIR_RootConstrainSelectedInstOperands,
     /*  256504 */     // GIR_Coverage, 21324,
     /*  256504 */     GIR_EraseRootFromParent_Done,
     /*  256505 */   // Label 5206: @256505
     /*  256505 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(256571), // Rule ID 21325 //
     /*  256510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  256513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  256521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  256527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10974:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  256549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  256552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256569 */     GIR_RootConstrainSelectedInstOperands,
     /*  256570 */     // GIR_Coverage, 21325,
     /*  256570 */     GIR_EraseRootFromParent_Done,
     /*  256571 */   // Label 5207: @256571
     /*  256571 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(256637), // Rule ID 21328 //
     /*  256576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  256579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  256587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  256593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256615 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10974:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  256615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  256618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256635 */     GIR_RootConstrainSelectedInstOperands,
     /*  256636 */     // GIR_Coverage, 21328,
     /*  256636 */     GIR_EraseRootFromParent_Done,
     /*  256637 */   // Label 5208: @256637
     /*  256637 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(256703), // Rule ID 21329 //
     /*  256642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  256645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  256650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  256653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  256659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256681 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10974:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  256681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  256684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256701 */     GIR_RootConstrainSelectedInstOperands,
     /*  256702 */     // GIR_Coverage, 21329,
     /*  256702 */     GIR_EraseRootFromParent_Done,
     /*  256703 */   // Label 5209: @256703
     /*  256703 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(256769), // Rule ID 21572 //
     /*  256708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  256711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  256716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  256719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  256725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256747 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  256747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  256750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256767 */     GIR_RootConstrainSelectedInstOperands,
     /*  256768 */     // GIR_Coverage, 21572,
     /*  256768 */     GIR_EraseRootFromParent_Done,
     /*  256769 */   // Label 5210: @256769
     /*  256769 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(256835), // Rule ID 21573 //
     /*  256774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  256777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  256782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  256785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  256791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256813 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  256813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  256816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256833 */     GIR_RootConstrainSelectedInstOperands,
     /*  256834 */     // GIR_Coverage, 21573,
     /*  256834 */     GIR_EraseRootFromParent_Done,
     /*  256835 */   // Label 5211: @256835
     /*  256835 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(256901), // Rule ID 21576 //
     /*  256840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  256843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  256848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  256851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  256857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256879 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  256879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  256882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256899 */     GIR_RootConstrainSelectedInstOperands,
     /*  256900 */     // GIR_Coverage, 21576,
     /*  256900 */     GIR_EraseRootFromParent_Done,
     /*  256901 */   // Label 5212: @256901
     /*  256901 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(256967), // Rule ID 21577 //
     /*  256906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  256909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  256914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  256917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  256923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256945 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  256945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  256948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  256952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  256965 */     GIR_RootConstrainSelectedInstOperands,
     /*  256966 */     // GIR_Coverage, 21577,
     /*  256966 */     GIR_EraseRootFromParent_Done,
     /*  256967 */   // Label 5213: @256967
     /*  256967 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(257033), // Rule ID 21580 //
     /*  256972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  256975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  256980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  256983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  256989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257011 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  257011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  257014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257031 */     GIR_RootConstrainSelectedInstOperands,
     /*  257032 */     // GIR_Coverage, 21580,
     /*  257032 */     GIR_EraseRootFromParent_Done,
     /*  257033 */   // Label 5214: @257033
     /*  257033 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(257099), // Rule ID 21581 //
     /*  257038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  257041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  257049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  257052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  257055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  257077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  257080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257097 */     GIR_RootConstrainSelectedInstOperands,
     /*  257098 */     // GIR_Coverage, 21581,
     /*  257098 */     GIR_EraseRootFromParent_Done,
     /*  257099 */   // Label 5215: @257099
     /*  257099 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(257165), // Rule ID 21584 //
     /*  257104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  257107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  257115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  257121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257143 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  257143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  257146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257163 */     GIR_RootConstrainSelectedInstOperands,
     /*  257164 */     // GIR_Coverage, 21584,
     /*  257164 */     GIR_EraseRootFromParent_Done,
     /*  257165 */   // Label 5216: @257165
     /*  257165 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(257231), // Rule ID 21585 //
     /*  257170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  257173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  257181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  257187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257209 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10924:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  257209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  257212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257229 */     GIR_RootConstrainSelectedInstOperands,
     /*  257230 */     // GIR_Coverage, 21585,
     /*  257230 */     GIR_EraseRootFromParent_Done,
     /*  257231 */   // Label 5217: @257231
     /*  257231 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(257297), // Rule ID 21588 //
     /*  257236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  257239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  257247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  257253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  257275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  257278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257295 */     GIR_RootConstrainSelectedInstOperands,
     /*  257296 */     // GIR_Coverage, 21588,
     /*  257296 */     GIR_EraseRootFromParent_Done,
     /*  257297 */   // Label 5218: @257297
     /*  257297 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(257363), // Rule ID 21589 //
     /*  257302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  257305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  257313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  257319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  257341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  257344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257361 */     GIR_RootConstrainSelectedInstOperands,
     /*  257362 */     // GIR_Coverage, 21589,
     /*  257362 */     GIR_EraseRootFromParent_Done,
     /*  257363 */   // Label 5219: @257363
     /*  257363 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(257429), // Rule ID 21592 //
     /*  257368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  257371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  257379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  257385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257407 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  257407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  257410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257427 */     GIR_RootConstrainSelectedInstOperands,
     /*  257428 */     // GIR_Coverage, 21592,
     /*  257428 */     GIR_EraseRootFromParent_Done,
     /*  257429 */   // Label 5220: @257429
     /*  257429 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(257495), // Rule ID 21593 //
     /*  257434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  257437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  257445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  257451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  257473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  257476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257493 */     GIR_RootConstrainSelectedInstOperands,
     /*  257494 */     // GIR_Coverage, 21593,
     /*  257494 */     GIR_EraseRootFromParent_Done,
     /*  257495 */   // Label 5221: @257495
     /*  257495 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(257561), // Rule ID 21596 //
     /*  257500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  257503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  257511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257539 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  257539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  257542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257559 */     GIR_RootConstrainSelectedInstOperands,
     /*  257560 */     // GIR_Coverage, 21596,
     /*  257560 */     GIR_EraseRootFromParent_Done,
     /*  257561 */   // Label 5222: @257561
     /*  257561 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(257627), // Rule ID 21597 //
     /*  257566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  257569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  257577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257605 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  257605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  257608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257625 */     GIR_RootConstrainSelectedInstOperands,
     /*  257626 */     // GIR_Coverage, 21597,
     /*  257626 */     GIR_EraseRootFromParent_Done,
     /*  257627 */   // Label 5223: @257627
     /*  257627 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(257693), // Rule ID 21600 //
     /*  257632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  257635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  257643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  257649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  257671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  257674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257691 */     GIR_RootConstrainSelectedInstOperands,
     /*  257692 */     // GIR_Coverage, 21600,
     /*  257692 */     GIR_EraseRootFromParent_Done,
     /*  257693 */   // Label 5224: @257693
     /*  257693 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(257759), // Rule ID 21601 //
     /*  257698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  257701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  257709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  257715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257737 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  257737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  257740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257757 */     GIR_RootConstrainSelectedInstOperands,
     /*  257758 */     // GIR_Coverage, 21601,
     /*  257758 */     GIR_EraseRootFromParent_Done,
     /*  257759 */   // Label 5225: @257759
     /*  257759 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(257825), // Rule ID 21604 //
     /*  257764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  257767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  257775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  257781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257803 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  257803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  257806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257823 */     GIR_RootConstrainSelectedInstOperands,
     /*  257824 */     // GIR_Coverage, 21604,
     /*  257824 */     GIR_EraseRootFromParent_Done,
     /*  257825 */   // Label 5226: @257825
     /*  257825 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(257891), // Rule ID 21605 //
     /*  257830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  257833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  257841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  257847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257869 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10924:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  257869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  257872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257889 */     GIR_RootConstrainSelectedInstOperands,
     /*  257890 */     // GIR_Coverage, 21605,
     /*  257890 */     GIR_EraseRootFromParent_Done,
     /*  257891 */   // Label 5227: @257891
     /*  257891 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(257957), // Rule ID 21608 //
     /*  257896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  257899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  257907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  257913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  257935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  257938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  257942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  257955 */     GIR_RootConstrainSelectedInstOperands,
     /*  257956 */     // GIR_Coverage, 21608,
     /*  257956 */     GIR_EraseRootFromParent_Done,
     /*  257957 */   // Label 5228: @257957
     /*  257957 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(258023), // Rule ID 21609 //
     /*  257962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  257965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  257970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  257973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  257979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  258001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  258004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258021 */     GIR_RootConstrainSelectedInstOperands,
     /*  258022 */     // GIR_Coverage, 21609,
     /*  258022 */     GIR_EraseRootFromParent_Done,
     /*  258023 */   // Label 5229: @258023
     /*  258023 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(258089), // Rule ID 21612 //
     /*  258028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  258031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  258039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  258045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  258067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  258070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258087 */     GIR_RootConstrainSelectedInstOperands,
     /*  258088 */     // GIR_Coverage, 21612,
     /*  258088 */     GIR_EraseRootFromParent_Done,
     /*  258089 */   // Label 5230: @258089
     /*  258089 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(258155), // Rule ID 21613 //
     /*  258094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  258097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  258105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  258111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258133 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  258133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  258136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258153 */     GIR_RootConstrainSelectedInstOperands,
     /*  258154 */     // GIR_Coverage, 21613,
     /*  258154 */     GIR_EraseRootFromParent_Done,
     /*  258155 */   // Label 5231: @258155
     /*  258155 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(258221), // Rule ID 21616 //
     /*  258160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  258163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  258171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  258174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258199 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  258199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  258202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258219 */     GIR_RootConstrainSelectedInstOperands,
     /*  258220 */     // GIR_Coverage, 21616,
     /*  258220 */     GIR_EraseRootFromParent_Done,
     /*  258221 */   // Label 5232: @258221
     /*  258221 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(258287), // Rule ID 21617 //
     /*  258226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  258229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  258237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  258240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258265 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  258265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  258268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258285 */     GIR_RootConstrainSelectedInstOperands,
     /*  258286 */     // GIR_Coverage, 21617,
     /*  258286 */     GIR_EraseRootFromParent_Done,
     /*  258287 */   // Label 5233: @258287
     /*  258287 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(258353), // Rule ID 21620 //
     /*  258292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  258295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  258303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  258309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  258331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  258334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258351 */     GIR_RootConstrainSelectedInstOperands,
     /*  258352 */     // GIR_Coverage, 21620,
     /*  258352 */     GIR_EraseRootFromParent_Done,
     /*  258353 */   // Label 5234: @258353
     /*  258353 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(258419), // Rule ID 21621 //
     /*  258358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  258361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  258369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  258375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258397 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  258397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  258400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258417 */     GIR_RootConstrainSelectedInstOperands,
     /*  258418 */     // GIR_Coverage, 21621,
     /*  258418 */     GIR_EraseRootFromParent_Done,
     /*  258419 */   // Label 5235: @258419
     /*  258419 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(258485), // Rule ID 21624 //
     /*  258424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  258427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  258435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  258441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  258463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  258466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258483 */     GIR_RootConstrainSelectedInstOperands,
     /*  258484 */     // GIR_Coverage, 21624,
     /*  258484 */     GIR_EraseRootFromParent_Done,
     /*  258485 */   // Label 5236: @258485
     /*  258485 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(258551), // Rule ID 21625 //
     /*  258490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  258493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  258501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  258507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  258529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  258532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258549 */     GIR_RootConstrainSelectedInstOperands,
     /*  258550 */     // GIR_Coverage, 21625,
     /*  258550 */     GIR_EraseRootFromParent_Done,
     /*  258551 */   // Label 5237: @258551
     /*  258551 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(258617), // Rule ID 21628 //
     /*  258556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  258559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  258567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  258573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258595 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  258595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  258598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258615 */     GIR_RootConstrainSelectedInstOperands,
     /*  258616 */     // GIR_Coverage, 21628,
     /*  258616 */     GIR_EraseRootFromParent_Done,
     /*  258617 */   // Label 5238: @258617
     /*  258617 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(258683), // Rule ID 21629 //
     /*  258622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  258625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  258630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  258633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  258639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  258661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  258664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258681 */     GIR_RootConstrainSelectedInstOperands,
     /*  258682 */     // GIR_Coverage, 21629,
     /*  258682 */     GIR_EraseRootFromParent_Done,
     /*  258683 */   // Label 5239: @258683
     /*  258683 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(258749), // Rule ID 21632 //
     /*  258688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  258691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  258696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  258699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  258702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  258727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  258730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258747 */     GIR_RootConstrainSelectedInstOperands,
     /*  258748 */     // GIR_Coverage, 21632,
     /*  258748 */     GIR_EraseRootFromParent_Done,
     /*  258749 */   // Label 5240: @258749
     /*  258749 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(258815), // Rule ID 21633 //
     /*  258754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  258757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  258762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  258765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  258768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  258793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  258796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258813 */     GIR_RootConstrainSelectedInstOperands,
     /*  258814 */     // GIR_Coverage, 21633,
     /*  258814 */     GIR_EraseRootFromParent_Done,
     /*  258815 */   // Label 5241: @258815
     /*  258815 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(258881), // Rule ID 21636 //
     /*  258820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  258823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  258828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  258831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  258837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258859 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  258859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  258862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258879 */     GIR_RootConstrainSelectedInstOperands,
     /*  258880 */     // GIR_Coverage, 21636,
     /*  258880 */     GIR_EraseRootFromParent_Done,
     /*  258881 */   // Label 5242: @258881
     /*  258881 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(258947), // Rule ID 21637 //
     /*  258886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  258889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  258894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  258897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  258903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258925 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  258925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  258928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  258945 */     GIR_RootConstrainSelectedInstOperands,
     /*  258946 */     // GIR_Coverage, 21637,
     /*  258946 */     GIR_EraseRootFromParent_Done,
     /*  258947 */   // Label 5243: @258947
     /*  258947 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(259013), // Rule ID 21640 //
     /*  258952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  258955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  258960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  258963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  258969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258991 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  258991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  258994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  258998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259011 */     GIR_RootConstrainSelectedInstOperands,
     /*  259012 */     // GIR_Coverage, 21640,
     /*  259012 */     GIR_EraseRootFromParent_Done,
     /*  259013 */   // Label 5244: @259013
     /*  259013 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(259079), // Rule ID 21641 //
     /*  259018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  259021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  259029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  259032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259057 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  259057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  259060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259077 */     GIR_RootConstrainSelectedInstOperands,
     /*  259078 */     // GIR_Coverage, 21641,
     /*  259078 */     GIR_EraseRootFromParent_Done,
     /*  259079 */   // Label 5245: @259079
     /*  259079 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(259145), // Rule ID 21644 //
     /*  259084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  259087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  259095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  259101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259123 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  259123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  259126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259143 */     GIR_RootConstrainSelectedInstOperands,
     /*  259144 */     // GIR_Coverage, 21644,
     /*  259144 */     GIR_EraseRootFromParent_Done,
     /*  259145 */   // Label 5246: @259145
     /*  259145 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(259211), // Rule ID 21645 //
     /*  259150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  259153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  259161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  259167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259189 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10922:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  259189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  259192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259209 */     GIR_RootConstrainSelectedInstOperands,
     /*  259210 */     // GIR_Coverage, 21645,
     /*  259210 */     GIR_EraseRootFromParent_Done,
     /*  259211 */   // Label 5247: @259211
     /*  259211 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(259277), // Rule ID 21648 //
     /*  259216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  259219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  259227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  259233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  259255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  259258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259275 */     GIR_RootConstrainSelectedInstOperands,
     /*  259276 */     // GIR_Coverage, 21648,
     /*  259276 */     GIR_EraseRootFromParent_Done,
     /*  259277 */   // Label 5248: @259277
     /*  259277 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(259343), // Rule ID 21649 //
     /*  259282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  259285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  259293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  259299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259321 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  259321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  259324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259341 */     GIR_RootConstrainSelectedInstOperands,
     /*  259342 */     // GIR_Coverage, 21649,
     /*  259342 */     GIR_EraseRootFromParent_Done,
     /*  259343 */   // Label 5249: @259343
     /*  259343 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(259409), // Rule ID 21652 //
     /*  259348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  259351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  259359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  259365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259387 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  259387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  259390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259407 */     GIR_RootConstrainSelectedInstOperands,
     /*  259408 */     // GIR_Coverage, 21652,
     /*  259408 */     GIR_EraseRootFromParent_Done,
     /*  259409 */   // Label 5250: @259409
     /*  259409 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(259475), // Rule ID 21653 //
     /*  259414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  259417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  259425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  259431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259453 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  259453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  259456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259473 */     GIR_RootConstrainSelectedInstOperands,
     /*  259474 */     // GIR_Coverage, 21653,
     /*  259474 */     GIR_EraseRootFromParent_Done,
     /*  259475 */   // Label 5251: @259475
     /*  259475 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(259541), // Rule ID 21656 //
     /*  259480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  259483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  259491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259519 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  259519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  259522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259539 */     GIR_RootConstrainSelectedInstOperands,
     /*  259540 */     // GIR_Coverage, 21656,
     /*  259540 */     GIR_EraseRootFromParent_Done,
     /*  259541 */   // Label 5252: @259541
     /*  259541 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(259607), // Rule ID 21657 //
     /*  259546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  259549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  259557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259585 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  259585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  259588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259605 */     GIR_RootConstrainSelectedInstOperands,
     /*  259606 */     // GIR_Coverage, 21657,
     /*  259606 */     GIR_EraseRootFromParent_Done,
     /*  259607 */   // Label 5253: @259607
     /*  259607 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(259673), // Rule ID 21660 //
     /*  259612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  259615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  259623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259651 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  259651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  259654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259671 */     GIR_RootConstrainSelectedInstOperands,
     /*  259672 */     // GIR_Coverage, 21660,
     /*  259672 */     GIR_EraseRootFromParent_Done,
     /*  259673 */   // Label 5254: @259673
     /*  259673 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(259739), // Rule ID 21661 //
     /*  259678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  259681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  259689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259717 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  259717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  259720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259737 */     GIR_RootConstrainSelectedInstOperands,
     /*  259738 */     // GIR_Coverage, 21661,
     /*  259738 */     GIR_EraseRootFromParent_Done,
     /*  259739 */   // Label 5255: @259739
     /*  259739 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(259805), // Rule ID 21664 //
     /*  259744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  259747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  259755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  259783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  259786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259803 */     GIR_RootConstrainSelectedInstOperands,
     /*  259804 */     // GIR_Coverage, 21664,
     /*  259804 */     GIR_EraseRootFromParent_Done,
     /*  259805 */   // Label 5256: @259805
     /*  259805 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(259871), // Rule ID 21665 //
     /*  259810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  259813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  259821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10922:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  259849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  259852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259869 */     GIR_RootConstrainSelectedInstOperands,
     /*  259870 */     // GIR_Coverage, 21665,
     /*  259870 */     GIR_EraseRootFromParent_Done,
     /*  259871 */   // Label 5257: @259871
     /*  259871 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(259937), // Rule ID 21668 //
     /*  259876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  259879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  259887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  259890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  259915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  259918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  259935 */     GIR_RootConstrainSelectedInstOperands,
     /*  259936 */     // GIR_Coverage, 21668,
     /*  259936 */     GIR_EraseRootFromParent_Done,
     /*  259937 */   // Label 5258: @259937
     /*  259937 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(260003), // Rule ID 21669 //
     /*  259942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  259945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  259950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  259953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  259956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  259981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  259984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  259988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260001 */     GIR_RootConstrainSelectedInstOperands,
     /*  260002 */     // GIR_Coverage, 21669,
     /*  260002 */     GIR_EraseRootFromParent_Done,
     /*  260003 */   // Label 5259: @260003
     /*  260003 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(260069), // Rule ID 21672 //
     /*  260008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  260011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  260019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260047 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  260047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  260050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260067 */     GIR_RootConstrainSelectedInstOperands,
     /*  260068 */     // GIR_Coverage, 21672,
     /*  260068 */     GIR_EraseRootFromParent_Done,
     /*  260069 */   // Label 5260: @260069
     /*  260069 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(260135), // Rule ID 21673 //
     /*  260074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  260077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  260085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  260113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  260116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260133 */     GIR_RootConstrainSelectedInstOperands,
     /*  260134 */     // GIR_Coverage, 21673,
     /*  260134 */     GIR_EraseRootFromParent_Done,
     /*  260135 */   // Label 5261: @260135
     /*  260135 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(260201), // Rule ID 21676 //
     /*  260140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  260143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  260151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260179 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  260179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  260182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260199 */     GIR_RootConstrainSelectedInstOperands,
     /*  260200 */     // GIR_Coverage, 21676,
     /*  260200 */     GIR_EraseRootFromParent_Done,
     /*  260201 */   // Label 5262: @260201
     /*  260201 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(260267), // Rule ID 21677 //
     /*  260206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  260209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  260217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260245 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  260245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  260248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260265 */     GIR_RootConstrainSelectedInstOperands,
     /*  260266 */     // GIR_Coverage, 21677,
     /*  260266 */     GIR_EraseRootFromParent_Done,
     /*  260267 */   // Label 5263: @260267
     /*  260267 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(260333), // Rule ID 21680 //
     /*  260272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  260275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  260283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  260289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  260311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  260314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260331 */     GIR_RootConstrainSelectedInstOperands,
     /*  260332 */     // GIR_Coverage, 21680,
     /*  260332 */     GIR_EraseRootFromParent_Done,
     /*  260333 */   // Label 5264: @260333
     /*  260333 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(260399), // Rule ID 21681 //
     /*  260338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  260341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  260349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  260355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  260377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  260380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260397 */     GIR_RootConstrainSelectedInstOperands,
     /*  260398 */     // GIR_Coverage, 21681,
     /*  260398 */     GIR_EraseRootFromParent_Done,
     /*  260399 */   // Label 5265: @260399
     /*  260399 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(260465), // Rule ID 21684 //
     /*  260404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  260407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  260415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  260421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  260443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  260446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260463 */     GIR_RootConstrainSelectedInstOperands,
     /*  260464 */     // GIR_Coverage, 21684,
     /*  260464 */     GIR_EraseRootFromParent_Done,
     /*  260465 */   // Label 5266: @260465
     /*  260465 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(260531), // Rule ID 21685 //
     /*  260470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  260473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  260481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  260487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  260509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  260512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260529 */     GIR_RootConstrainSelectedInstOperands,
     /*  260530 */     // GIR_Coverage, 21685,
     /*  260530 */     GIR_EraseRootFromParent_Done,
     /*  260531 */   // Label 5267: @260531
     /*  260531 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(260597), // Rule ID 21688 //
     /*  260536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  260539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  260547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  260553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  260575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  260578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260595 */     GIR_RootConstrainSelectedInstOperands,
     /*  260596 */     // GIR_Coverage, 21688,
     /*  260596 */     GIR_EraseRootFromParent_Done,
     /*  260597 */   // Label 5268: @260597
     /*  260597 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(260663), // Rule ID 21689 //
     /*  260602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  260605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  260610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  260613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  260619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  260641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  260644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260661 */     GIR_RootConstrainSelectedInstOperands,
     /*  260662 */     // GIR_Coverage, 21689,
     /*  260662 */     GIR_EraseRootFromParent_Done,
     /*  260663 */   // Label 5269: @260663
     /*  260663 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(260729), // Rule ID 21800 //
     /*  260668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  260671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  260676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  260679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  260685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260707 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  260707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  260710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260727 */     GIR_RootConstrainSelectedInstOperands,
     /*  260728 */     // GIR_Coverage, 21800,
     /*  260728 */     GIR_EraseRootFromParent_Done,
     /*  260729 */   // Label 5270: @260729
     /*  260729 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(260795), // Rule ID 21801 //
     /*  260734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  260737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  260742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  260745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  260751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260773 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  260773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  260776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260793 */     GIR_RootConstrainSelectedInstOperands,
     /*  260794 */     // GIR_Coverage, 21801,
     /*  260794 */     GIR_EraseRootFromParent_Done,
     /*  260795 */   // Label 5271: @260795
     /*  260795 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(260861), // Rule ID 21804 //
     /*  260800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  260803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  260808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  260811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260839 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  260839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  260842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260859 */     GIR_RootConstrainSelectedInstOperands,
     /*  260860 */     // GIR_Coverage, 21804,
     /*  260860 */     GIR_EraseRootFromParent_Done,
     /*  260861 */   // Label 5272: @260861
     /*  260861 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(260927), // Rule ID 21805 //
     /*  260866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  260869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  260874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  260877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260905 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  260905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  260908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260925 */     GIR_RootConstrainSelectedInstOperands,
     /*  260926 */     // GIR_Coverage, 21805,
     /*  260926 */     GIR_EraseRootFromParent_Done,
     /*  260927 */   // Label 5273: @260927
     /*  260927 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(260993), // Rule ID 21808 //
     /*  260932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  260935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  260940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  260943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260971 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  260971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  260974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  260978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  260991 */     GIR_RootConstrainSelectedInstOperands,
     /*  260992 */     // GIR_Coverage, 21808,
     /*  260992 */     GIR_EraseRootFromParent_Done,
     /*  260993 */   // Label 5274: @260993
     /*  260993 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(261059), // Rule ID 21809 //
     /*  260998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  261001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  261009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  261012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  261015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261037 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10920:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  261037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  261040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261057 */     GIR_RootConstrainSelectedInstOperands,
     /*  261058 */     // GIR_Coverage, 21809,
     /*  261058 */     GIR_EraseRootFromParent_Done,
     /*  261059 */   // Label 5275: @261059
     /*  261059 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(261125), // Rule ID 21812 //
     /*  261064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  261067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  261075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261103 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10920:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  261103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  261106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261123 */     GIR_RootConstrainSelectedInstOperands,
     /*  261124 */     // GIR_Coverage, 21812,
     /*  261124 */     GIR_EraseRootFromParent_Done,
     /*  261125 */   // Label 5276: @261125
     /*  261125 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(261191), // Rule ID 21813 //
     /*  261130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  261133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  261141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261169 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10920:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  261169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  261172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261189 */     GIR_RootConstrainSelectedInstOperands,
     /*  261190 */     // GIR_Coverage, 21813,
     /*  261190 */     GIR_EraseRootFromParent_Done,
     /*  261191 */   // Label 5277: @261191
     /*  261191 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(261257), // Rule ID 21816 //
     /*  261196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  261199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  261207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261235 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10920:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  261235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  261238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261255 */     GIR_RootConstrainSelectedInstOperands,
     /*  261256 */     // GIR_Coverage, 21816,
     /*  261256 */     GIR_EraseRootFromParent_Done,
     /*  261257 */   // Label 5278: @261257
     /*  261257 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(261323), // Rule ID 21817 //
     /*  261262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  261265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  261273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261301 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10920:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  261301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  261304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261321 */     GIR_RootConstrainSelectedInstOperands,
     /*  261322 */     // GIR_Coverage, 21817,
     /*  261322 */     GIR_EraseRootFromParent_Done,
     /*  261323 */   // Label 5279: @261323
     /*  261323 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(261389), // Rule ID 21820 //
     /*  261328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  261331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  261339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  261342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  261345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261367 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  261367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  261370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261387 */     GIR_RootConstrainSelectedInstOperands,
     /*  261388 */     // GIR_Coverage, 21820,
     /*  261388 */     GIR_EraseRootFromParent_Done,
     /*  261389 */   // Label 5280: @261389
     /*  261389 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(261455), // Rule ID 21821 //
     /*  261394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  261397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  261405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  261408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  261411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  261433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  261436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261453 */     GIR_RootConstrainSelectedInstOperands,
     /*  261454 */     // GIR_Coverage, 21821,
     /*  261454 */     GIR_EraseRootFromParent_Done,
     /*  261455 */   // Label 5281: @261455
     /*  261455 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(261521), // Rule ID 21824 //
     /*  261460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  261463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  261471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  261474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  261499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  261502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261519 */     GIR_RootConstrainSelectedInstOperands,
     /*  261520 */     // GIR_Coverage, 21824,
     /*  261520 */     GIR_EraseRootFromParent_Done,
     /*  261521 */   // Label 5282: @261521
     /*  261521 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(261587), // Rule ID 21825 //
     /*  261526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  261529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  261537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  261540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261565 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  261565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  261568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261585 */     GIR_RootConstrainSelectedInstOperands,
     /*  261586 */     // GIR_Coverage, 21825,
     /*  261586 */     GIR_EraseRootFromParent_Done,
     /*  261587 */   // Label 5283: @261587
     /*  261587 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(261653), // Rule ID 21828 //
     /*  261592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  261595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  261603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261631 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10920:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  261631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  261634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261651 */     GIR_RootConstrainSelectedInstOperands,
     /*  261652 */     // GIR_Coverage, 21828,
     /*  261652 */     GIR_EraseRootFromParent_Done,
     /*  261653 */   // Label 5284: @261653
     /*  261653 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(261719), // Rule ID 21829 //
     /*  261658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  261661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  261669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261697 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10920:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  261697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  261700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261717 */     GIR_RootConstrainSelectedInstOperands,
     /*  261718 */     // GIR_Coverage, 21829,
     /*  261718 */     GIR_EraseRootFromParent_Done,
     /*  261719 */   // Label 5285: @261719
     /*  261719 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(261785), // Rule ID 21832 //
     /*  261724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  261727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  261735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261763 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10920:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  261763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  261766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261783 */     GIR_RootConstrainSelectedInstOperands,
     /*  261784 */     // GIR_Coverage, 21832,
     /*  261784 */     GIR_EraseRootFromParent_Done,
     /*  261785 */   // Label 5286: @261785
     /*  261785 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(261851), // Rule ID 21833 //
     /*  261790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  261793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  261798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  261801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261829 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10920:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  261829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  261832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  261836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261849 */     GIR_RootConstrainSelectedInstOperands,
     /*  261850 */     // GIR_Coverage, 21833,
     /*  261850 */     GIR_EraseRootFromParent_Done,
     /*  261851 */   // Label 5287: @261851
     /*  261851 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(261914), // Rule ID 23004 //
     /*  261856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  261864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  261870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  261873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  261895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  261898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261912 */     GIR_RootConstrainSelectedInstOperands,
     /*  261913 */     // GIR_Coverage, 23004,
     /*  261913 */     GIR_EraseRootFromParent_Done,
     /*  261914 */   // Label 5288: @261914
     /*  261914 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(261977), // Rule ID 23005 //
     /*  261919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  261927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  261933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  261936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  261958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  261961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  261975 */     GIR_RootConstrainSelectedInstOperands,
     /*  261976 */     // GIR_Coverage, 23005,
     /*  261976 */     GIR_EraseRootFromParent_Done,
     /*  261977 */   // Label 5289: @261977
     /*  261977 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(262040), // Rule ID 23006 //
     /*  261982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  261990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  261996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  261999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  262024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262038 */     GIR_RootConstrainSelectedInstOperands,
     /*  262039 */     // GIR_Coverage, 23006,
     /*  262039 */     GIR_EraseRootFromParent_Done,
     /*  262040 */   // Label 5290: @262040
     /*  262040 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(262103), // Rule ID 23007 //
     /*  262045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  262059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  262062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  262087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262101 */     GIR_RootConstrainSelectedInstOperands,
     /*  262102 */     // GIR_Coverage, 23007,
     /*  262102 */     GIR_EraseRootFromParent_Done,
     /*  262103 */   // Label 5291: @262103
     /*  262103 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(262166), // Rule ID 23008 //
     /*  262108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  262122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  262125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  262150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262164 */     GIR_RootConstrainSelectedInstOperands,
     /*  262165 */     // GIR_Coverage, 23008,
     /*  262165 */     GIR_EraseRootFromParent_Done,
     /*  262166 */   // Label 5292: @262166
     /*  262166 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(262229), // Rule ID 23009 //
     /*  262171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  262185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  262188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  262213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262227 */     GIR_RootConstrainSelectedInstOperands,
     /*  262228 */     // GIR_Coverage, 23009,
     /*  262228 */     GIR_EraseRootFromParent_Done,
     /*  262229 */   // Label 5293: @262229
     /*  262229 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(262292), // Rule ID 23010 //
     /*  262234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  262248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  262251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  262276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262290 */     GIR_RootConstrainSelectedInstOperands,
     /*  262291 */     // GIR_Coverage, 23010,
     /*  262291 */     GIR_EraseRootFromParent_Done,
     /*  262292 */   // Label 5294: @262292
     /*  262292 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(262355), // Rule ID 23011 //
     /*  262297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  262311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  262314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  262339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262353 */     GIR_RootConstrainSelectedInstOperands,
     /*  262354 */     // GIR_Coverage, 23011,
     /*  262354 */     GIR_EraseRootFromParent_Done,
     /*  262355 */   // Label 5295: @262355
     /*  262355 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(262418), // Rule ID 23012 //
     /*  262360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  262374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  262377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262399 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  262402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262416 */     GIR_RootConstrainSelectedInstOperands,
     /*  262417 */     // GIR_Coverage, 23012,
     /*  262417 */     GIR_EraseRootFromParent_Done,
     /*  262418 */   // Label 5296: @262418
     /*  262418 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(262481), // Rule ID 23013 //
     /*  262423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  262437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  262440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262462 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  262465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262479 */     GIR_RootConstrainSelectedInstOperands,
     /*  262480 */     // GIR_Coverage, 23013,
     /*  262480 */     GIR_EraseRootFromParent_Done,
     /*  262481 */   // Label 5297: @262481
     /*  262481 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(262544), // Rule ID 23014 //
     /*  262486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  262500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  262503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262525 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  262528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262542 */     GIR_RootConstrainSelectedInstOperands,
     /*  262543 */     // GIR_Coverage, 23014,
     /*  262543 */     GIR_EraseRootFromParent_Done,
     /*  262544 */   // Label 5298: @262544
     /*  262544 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(262607), // Rule ID 23015 //
     /*  262549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  262557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  262563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  262566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262588 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11103:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  262591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262605 */     GIR_RootConstrainSelectedInstOperands,
     /*  262606 */     // GIR_Coverage, 23015,
     /*  262606 */     GIR_EraseRootFromParent_Done,
     /*  262607 */   // Label 5299: @262607
     /*  262607 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(262670), // Rule ID 23016 //
     /*  262612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  262626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  262629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262651 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  262654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262668 */     GIR_RootConstrainSelectedInstOperands,
     /*  262669 */     // GIR_Coverage, 23016,
     /*  262669 */     GIR_EraseRootFromParent_Done,
     /*  262670 */   // Label 5300: @262670
     /*  262670 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(262733), // Rule ID 23017 //
     /*  262675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  262689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  262692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262714 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  262717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262731 */     GIR_RootConstrainSelectedInstOperands,
     /*  262732 */     // GIR_Coverage, 23017,
     /*  262732 */     GIR_EraseRootFromParent_Done,
     /*  262733 */   // Label 5301: @262733
     /*  262733 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(262796), // Rule ID 23018 //
     /*  262738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  262752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  262755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  262780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262794 */     GIR_RootConstrainSelectedInstOperands,
     /*  262795 */     // GIR_Coverage, 23018,
     /*  262795 */     GIR_EraseRootFromParent_Done,
     /*  262796 */   // Label 5302: @262796
     /*  262796 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(262859), // Rule ID 23019 //
     /*  262801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  262815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  262818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  262843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262857 */     GIR_RootConstrainSelectedInstOperands,
     /*  262858 */     // GIR_Coverage, 23019,
     /*  262858 */     GIR_EraseRootFromParent_Done,
     /*  262859 */   // Label 5303: @262859
     /*  262859 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(262922), // Rule ID 23020 //
     /*  262864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  262878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  262881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  262903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  262906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262920 */     GIR_RootConstrainSelectedInstOperands,
     /*  262921 */     // GIR_Coverage, 23020,
     /*  262921 */     GIR_EraseRootFromParent_Done,
     /*  262922 */   // Label 5304: @262922
     /*  262922 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(262985), // Rule ID 23021 //
     /*  262927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  262941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  262944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  262966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  262969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  262983 */     GIR_RootConstrainSelectedInstOperands,
     /*  262984 */     // GIR_Coverage, 23021,
     /*  262984 */     GIR_EraseRootFromParent_Done,
     /*  262985 */   // Label 5305: @262985
     /*  262985 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(263048), // Rule ID 23022 //
     /*  262990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  262998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  263004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  263007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  263032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263046 */     GIR_RootConstrainSelectedInstOperands,
     /*  263047 */     // GIR_Coverage, 23022,
     /*  263047 */     GIR_EraseRootFromParent_Done,
     /*  263048 */   // Label 5306: @263048
     /*  263048 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(263111), // Rule ID 23023 //
     /*  263053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  263067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  263070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  263095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263109 */     GIR_RootConstrainSelectedInstOperands,
     /*  263110 */     // GIR_Coverage, 23023,
     /*  263110 */     GIR_EraseRootFromParent_Done,
     /*  263111 */   // Label 5307: @263111
     /*  263111 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(263174), // Rule ID 23024 //
     /*  263116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  263130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  263133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  263158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263172 */     GIR_RootConstrainSelectedInstOperands,
     /*  263173 */     // GIR_Coverage, 23024,
     /*  263173 */     GIR_EraseRootFromParent_Done,
     /*  263174 */   // Label 5308: @263174
     /*  263174 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(263237), // Rule ID 23025 //
     /*  263179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  263193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  263196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  263221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263235 */     GIR_RootConstrainSelectedInstOperands,
     /*  263236 */     // GIR_Coverage, 23025,
     /*  263236 */     GIR_EraseRootFromParent_Done,
     /*  263237 */   // Label 5309: @263237
     /*  263237 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(263300), // Rule ID 23026 //
     /*  263242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  263256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  263259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263281 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  263284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263298 */     GIR_RootConstrainSelectedInstOperands,
     /*  263299 */     // GIR_Coverage, 23026,
     /*  263299 */     GIR_EraseRootFromParent_Done,
     /*  263300 */   // Label 5310: @263300
     /*  263300 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(263363), // Rule ID 23027 //
     /*  263305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  263319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  263322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263344 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  263347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263361 */     GIR_RootConstrainSelectedInstOperands,
     /*  263362 */     // GIR_Coverage, 23027,
     /*  263362 */     GIR_EraseRootFromParent_Done,
     /*  263363 */   // Label 5311: @263363
     /*  263363 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(263426), // Rule ID 23028 //
     /*  263368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  263382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  263385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263407 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  263410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263424 */     GIR_RootConstrainSelectedInstOperands,
     /*  263425 */     // GIR_Coverage, 23028,
     /*  263425 */     GIR_EraseRootFromParent_Done,
     /*  263426 */   // Label 5312: @263426
     /*  263426 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(263489), // Rule ID 23029 //
     /*  263431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  263439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  263445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  263448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263470 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11127:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  263473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263487 */     GIR_RootConstrainSelectedInstOperands,
     /*  263488 */     // GIR_Coverage, 23029,
     /*  263488 */     GIR_EraseRootFromParent_Done,
     /*  263489 */   // Label 5313: @263489
     /*  263489 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(263552), // Rule ID 23030 //
     /*  263494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  263508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  263511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263533 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  263536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263550 */     GIR_RootConstrainSelectedInstOperands,
     /*  263551 */     // GIR_Coverage, 23030,
     /*  263551 */     GIR_EraseRootFromParent_Done,
     /*  263552 */   // Label 5314: @263552
     /*  263552 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(263615), // Rule ID 23031 //
     /*  263557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  263571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  263574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263596 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  263599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263613 */     GIR_RootConstrainSelectedInstOperands,
     /*  263614 */     // GIR_Coverage, 23031,
     /*  263614 */     GIR_EraseRootFromParent_Done,
     /*  263615 */   // Label 5315: @263615
     /*  263615 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(263678), // Rule ID 23032 //
     /*  263620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  263634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  263637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  263662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263676 */     GIR_RootConstrainSelectedInstOperands,
     /*  263677 */     // GIR_Coverage, 23032,
     /*  263677 */     GIR_EraseRootFromParent_Done,
     /*  263678 */   // Label 5316: @263678
     /*  263678 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(263741), // Rule ID 23033 //
     /*  263683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  263697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  263700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  263725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263739 */     GIR_RootConstrainSelectedInstOperands,
     /*  263740 */     // GIR_Coverage, 23033,
     /*  263740 */     GIR_EraseRootFromParent_Done,
     /*  263741 */   // Label 5317: @263741
     /*  263741 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(263804), // Rule ID 23034 //
     /*  263746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  263760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  263763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  263788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263802 */     GIR_RootConstrainSelectedInstOperands,
     /*  263803 */     // GIR_Coverage, 23034,
     /*  263803 */     GIR_EraseRootFromParent_Done,
     /*  263804 */   // Label 5318: @263804
     /*  263804 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(263867), // Rule ID 23035 //
     /*  263809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  263823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  263826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  263851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263865 */     GIR_RootConstrainSelectedInstOperands,
     /*  263866 */     // GIR_Coverage, 23035,
     /*  263866 */     GIR_EraseRootFromParent_Done,
     /*  263867 */   // Label 5319: @263867
     /*  263867 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(263930), // Rule ID 23036 //
     /*  263872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  263886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  263889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  263911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  263914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263928 */     GIR_RootConstrainSelectedInstOperands,
     /*  263929 */     // GIR_Coverage, 23036,
     /*  263929 */     GIR_EraseRootFromParent_Done,
     /*  263930 */   // Label 5320: @263930
     /*  263930 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(263993), // Rule ID 23037 //
     /*  263935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  263943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  263949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  263952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  263974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  263977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  263991 */     GIR_RootConstrainSelectedInstOperands,
     /*  263992 */     // GIR_Coverage, 23037,
     /*  263992 */     GIR_EraseRootFromParent_Done,
     /*  263993 */   // Label 5321: @263993
     /*  263993 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(264056), // Rule ID 23038 //
     /*  263998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  264012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  264015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  264040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264054 */     GIR_RootConstrainSelectedInstOperands,
     /*  264055 */     // GIR_Coverage, 23038,
     /*  264055 */     GIR_EraseRootFromParent_Done,
     /*  264056 */   // Label 5322: @264056
     /*  264056 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(264119), // Rule ID 23039 //
     /*  264061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  264075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  264078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  264103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264117 */     GIR_RootConstrainSelectedInstOperands,
     /*  264118 */     // GIR_Coverage, 23039,
     /*  264118 */     GIR_EraseRootFromParent_Done,
     /*  264119 */   // Label 5323: @264119
     /*  264119 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264182), // Rule ID 23040 //
     /*  264124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  264138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  264141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  264166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264180 */     GIR_RootConstrainSelectedInstOperands,
     /*  264181 */     // GIR_Coverage, 23040,
     /*  264181 */     GIR_EraseRootFromParent_Done,
     /*  264182 */   // Label 5324: @264182
     /*  264182 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(264245), // Rule ID 23041 //
     /*  264187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  264201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  264204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264226 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  264229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264243 */     GIR_RootConstrainSelectedInstOperands,
     /*  264244 */     // GIR_Coverage, 23041,
     /*  264244 */     GIR_EraseRootFromParent_Done,
     /*  264245 */   // Label 5325: @264245
     /*  264245 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(264308), // Rule ID 23042 //
     /*  264250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  264261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  264264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  264267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264289 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  264292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264306 */     GIR_RootConstrainSelectedInstOperands,
     /*  264307 */     // GIR_Coverage, 23042,
     /*  264307 */     GIR_EraseRootFromParent_Done,
     /*  264308 */   // Label 5326: @264308
     /*  264308 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(264371), // Rule ID 23043 //
     /*  264313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  264321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  264324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  264327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  264330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264352 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11104:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  264355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264369 */     GIR_RootConstrainSelectedInstOperands,
     /*  264370 */     // GIR_Coverage, 23043,
     /*  264370 */     GIR_EraseRootFromParent_Done,
     /*  264371 */   // Label 5327: @264371
     /*  264371 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(264434), // Rule ID 23044 //
     /*  264376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  264390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  264393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264415 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  264418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264432 */     GIR_RootConstrainSelectedInstOperands,
     /*  264433 */     // GIR_Coverage, 23044,
     /*  264433 */     GIR_EraseRootFromParent_Done,
     /*  264434 */   // Label 5328: @264434
     /*  264434 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(264497), // Rule ID 23045 //
     /*  264439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  264453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  264456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  264481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264495 */     GIR_RootConstrainSelectedInstOperands,
     /*  264496 */     // GIR_Coverage, 23045,
     /*  264496 */     GIR_EraseRootFromParent_Done,
     /*  264497 */   // Label 5329: @264497
     /*  264497 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(264560), // Rule ID 23046 //
     /*  264502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  264516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  264519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264541 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  264544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264558 */     GIR_RootConstrainSelectedInstOperands,
     /*  264559 */     // GIR_Coverage, 23046,
     /*  264559 */     GIR_EraseRootFromParent_Done,
     /*  264560 */   // Label 5330: @264560
     /*  264560 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(264623), // Rule ID 23047 //
     /*  264565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  264579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  264582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  264607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264621 */     GIR_RootConstrainSelectedInstOperands,
     /*  264622 */     // GIR_Coverage, 23047,
     /*  264622 */     GIR_EraseRootFromParent_Done,
     /*  264623 */   // Label 5331: @264623
     /*  264623 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(264686), // Rule ID 23048 //
     /*  264628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  264642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  264645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264667 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  264670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264684 */     GIR_RootConstrainSelectedInstOperands,
     /*  264685 */     // GIR_Coverage, 23048,
     /*  264685 */     GIR_EraseRootFromParent_Done,
     /*  264686 */   // Label 5332: @264686
     /*  264686 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(264749), // Rule ID 23049 //
     /*  264691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  264705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  264708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  264733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264747 */     GIR_RootConstrainSelectedInstOperands,
     /*  264748 */     // GIR_Coverage, 23049,
     /*  264748 */     GIR_EraseRootFromParent_Done,
     /*  264749 */   // Label 5333: @264749
     /*  264749 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(264812), // Rule ID 23050 //
     /*  264754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  264768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  264771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264793 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  264796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264810 */     GIR_RootConstrainSelectedInstOperands,
     /*  264811 */     // GIR_Coverage, 23050,
     /*  264811 */     GIR_EraseRootFromParent_Done,
     /*  264812 */   // Label 5334: @264812
     /*  264812 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(264875), // Rule ID 23051 //
     /*  264817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  264831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  264834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  264859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264873 */     GIR_RootConstrainSelectedInstOperands,
     /*  264874 */     // GIR_Coverage, 23051,
     /*  264874 */     GIR_EraseRootFromParent_Done,
     /*  264875 */   // Label 5335: @264875
     /*  264875 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(264938), // Rule ID 23052 //
     /*  264880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  264894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  264897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  264919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  264922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264936 */     GIR_RootConstrainSelectedInstOperands,
     /*  264937 */     // GIR_Coverage, 23052,
     /*  264937 */     GIR_EraseRootFromParent_Done,
     /*  264938 */   // Label 5336: @264938
     /*  264938 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(265001), // Rule ID 23053 //
     /*  264943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  264951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  264957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  264960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264982 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  264982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  264985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  264999 */     GIR_RootConstrainSelectedInstOperands,
     /*  265000 */     // GIR_Coverage, 23053,
     /*  265000 */     GIR_EraseRootFromParent_Done,
     /*  265001 */   // Label 5337: @265001
     /*  265001 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(265064), // Rule ID 23054 //
     /*  265006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  265014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  265020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  265023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265045 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  265048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265062 */     GIR_RootConstrainSelectedInstOperands,
     /*  265063 */     // GIR_Coverage, 23054,
     /*  265063 */     GIR_EraseRootFromParent_Done,
     /*  265064 */   // Label 5338: @265064
     /*  265064 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265127), // Rule ID 23055 //
     /*  265069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  265077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  265083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  265086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265108 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  265111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265125 */     GIR_RootConstrainSelectedInstOperands,
     /*  265126 */     // GIR_Coverage, 23055,
     /*  265126 */     GIR_EraseRootFromParent_Done,
     /*  265127 */   // Label 5339: @265127
     /*  265127 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265190), // Rule ID 23056 //
     /*  265132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  265140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  265146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  265149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265171 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  265174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265188 */     GIR_RootConstrainSelectedInstOperands,
     /*  265189 */     // GIR_Coverage, 23056,
     /*  265189 */     GIR_EraseRootFromParent_Done,
     /*  265190 */   // Label 5340: @265190
     /*  265190 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265253), // Rule ID 23057 //
     /*  265195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  265203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  265209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  265212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265234 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11173:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  265237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265251 */     GIR_RootConstrainSelectedInstOperands,
     /*  265252 */     // GIR_Coverage, 23057,
     /*  265252 */     GIR_EraseRootFromParent_Done,
     /*  265253 */   // Label 5341: @265253
     /*  265253 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265316), // Rule ID 23058 //
     /*  265258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  265272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  265275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  265300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265314 */     GIR_RootConstrainSelectedInstOperands,
     /*  265315 */     // GIR_Coverage, 23058,
     /*  265315 */     GIR_EraseRootFromParent_Done,
     /*  265316 */   // Label 5342: @265316
     /*  265316 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(265379), // Rule ID 23059 //
     /*  265321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  265335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  265338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  265363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265377 */     GIR_RootConstrainSelectedInstOperands,
     /*  265378 */     // GIR_Coverage, 23059,
     /*  265378 */     GIR_EraseRootFromParent_Done,
     /*  265379 */   // Label 5343: @265379
     /*  265379 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265442), // Rule ID 23060 //
     /*  265384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  265398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  265401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265423 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  265426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265440 */     GIR_RootConstrainSelectedInstOperands,
     /*  265441 */     // GIR_Coverage, 23060,
     /*  265441 */     GIR_EraseRootFromParent_Done,
     /*  265442 */   // Label 5344: @265442
     /*  265442 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265505), // Rule ID 23061 //
     /*  265447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  265461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  265464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  265489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265503 */     GIR_RootConstrainSelectedInstOperands,
     /*  265504 */     // GIR_Coverage, 23061,
     /*  265504 */     GIR_EraseRootFromParent_Done,
     /*  265505 */   // Label 5345: @265505
     /*  265505 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(265568), // Rule ID 23062 //
     /*  265510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  265524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  265527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265549 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  265552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265566 */     GIR_RootConstrainSelectedInstOperands,
     /*  265567 */     // GIR_Coverage, 23062,
     /*  265567 */     GIR_EraseRootFromParent_Done,
     /*  265568 */   // Label 5346: @265568
     /*  265568 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(265631), // Rule ID 23063 //
     /*  265573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  265587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  265590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  265615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265629 */     GIR_RootConstrainSelectedInstOperands,
     /*  265630 */     // GIR_Coverage, 23063,
     /*  265630 */     GIR_EraseRootFromParent_Done,
     /*  265631 */   // Label 5347: @265631
     /*  265631 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(265694), // Rule ID 23064 //
     /*  265636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  265650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  265653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  265678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265692 */     GIR_RootConstrainSelectedInstOperands,
     /*  265693 */     // GIR_Coverage, 23064,
     /*  265693 */     GIR_EraseRootFromParent_Done,
     /*  265694 */   // Label 5348: @265694
     /*  265694 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265757), // Rule ID 23065 //
     /*  265699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  265713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  265716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  265741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265755 */     GIR_RootConstrainSelectedInstOperands,
     /*  265756 */     // GIR_Coverage, 23065,
     /*  265756 */     GIR_EraseRootFromParent_Done,
     /*  265757 */   // Label 5349: @265757
     /*  265757 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265820), // Rule ID 23066 //
     /*  265762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  265776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  265779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265801 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  265804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265818 */     GIR_RootConstrainSelectedInstOperands,
     /*  265819 */     // GIR_Coverage, 23066,
     /*  265819 */     GIR_EraseRootFromParent_Done,
     /*  265820 */   // Label 5350: @265820
     /*  265820 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265883), // Rule ID 23067 //
     /*  265825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  265839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  265842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  265867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265881 */     GIR_RootConstrainSelectedInstOperands,
     /*  265882 */     // GIR_Coverage, 23067,
     /*  265882 */     GIR_EraseRootFromParent_Done,
     /*  265883 */   // Label 5351: @265883
     /*  265883 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265946), // Rule ID 23068 //
     /*  265888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  265902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  265905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265927 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  265927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  265930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  265944 */     GIR_RootConstrainSelectedInstOperands,
     /*  265945 */     // GIR_Coverage, 23068,
     /*  265945 */     GIR_EraseRootFromParent_Done,
     /*  265946 */   // Label 5352: @265946
     /*  265946 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(266009), // Rule ID 23069 //
     /*  265951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  265959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  265965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  265968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  265990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  265993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266007 */     GIR_RootConstrainSelectedInstOperands,
     /*  266008 */     // GIR_Coverage, 23069,
     /*  266008 */     GIR_EraseRootFromParent_Done,
     /*  266009 */   // Label 5353: @266009
     /*  266009 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(266072), // Rule ID 23070 //
     /*  266014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  266022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  266028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  266031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266053 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  266056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266070 */     GIR_RootConstrainSelectedInstOperands,
     /*  266071 */     // GIR_Coverage, 23070,
     /*  266071 */     GIR_EraseRootFromParent_Done,
     /*  266072 */   // Label 5354: @266072
     /*  266072 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(266135), // Rule ID 23071 //
     /*  266077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  266085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  266091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  266094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266116 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11129:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  266119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266133 */     GIR_RootConstrainSelectedInstOperands,
     /*  266134 */     // GIR_Coverage, 23071,
     /*  266134 */     GIR_EraseRootFromParent_Done,
     /*  266135 */   // Label 5355: @266135
     /*  266135 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(266198), // Rule ID 23072 //
     /*  266140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  266154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  266157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266179 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  266182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266196 */     GIR_RootConstrainSelectedInstOperands,
     /*  266197 */     // GIR_Coverage, 23072,
     /*  266197 */     GIR_EraseRootFromParent_Done,
     /*  266198 */   // Label 5356: @266198
     /*  266198 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(266261), // Rule ID 23073 //
     /*  266203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  266217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  266220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  266245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266259 */     GIR_RootConstrainSelectedInstOperands,
     /*  266260 */     // GIR_Coverage, 23073,
     /*  266260 */     GIR_EraseRootFromParent_Done,
     /*  266261 */   // Label 5357: @266261
     /*  266261 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(266324), // Rule ID 23074 //
     /*  266266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  266280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  266283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266305 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  266308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266322 */     GIR_RootConstrainSelectedInstOperands,
     /*  266323 */     // GIR_Coverage, 23074,
     /*  266323 */     GIR_EraseRootFromParent_Done,
     /*  266324 */   // Label 5358: @266324
     /*  266324 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266387), // Rule ID 23075 //
     /*  266329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  266343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  266346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  266371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266385 */     GIR_RootConstrainSelectedInstOperands,
     /*  266386 */     // GIR_Coverage, 23075,
     /*  266386 */     GIR_EraseRootFromParent_Done,
     /*  266387 */   // Label 5359: @266387
     /*  266387 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266450), // Rule ID 23076 //
     /*  266392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  266406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  266409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  266434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266448 */     GIR_RootConstrainSelectedInstOperands,
     /*  266449 */     // GIR_Coverage, 23076,
     /*  266449 */     GIR_EraseRootFromParent_Done,
     /*  266450 */   // Label 5360: @266450
     /*  266450 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266513), // Rule ID 23077 //
     /*  266455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  266469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  266472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  266497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266511 */     GIR_RootConstrainSelectedInstOperands,
     /*  266512 */     // GIR_Coverage, 23077,
     /*  266512 */     GIR_EraseRootFromParent_Done,
     /*  266513 */   // Label 5361: @266513
     /*  266513 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266576), // Rule ID 23078 //
     /*  266518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  266532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  266535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266557 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  266560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266574 */     GIR_RootConstrainSelectedInstOperands,
     /*  266575 */     // GIR_Coverage, 23078,
     /*  266575 */     GIR_EraseRootFromParent_Done,
     /*  266576 */   // Label 5362: @266576
     /*  266576 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266639), // Rule ID 23079 //
     /*  266581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  266595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  266598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  266623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266637 */     GIR_RootConstrainSelectedInstOperands,
     /*  266638 */     // GIR_Coverage, 23079,
     /*  266638 */     GIR_EraseRootFromParent_Done,
     /*  266639 */   // Label 5363: @266639
     /*  266639 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(266702), // Rule ID 23080 //
     /*  266644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  266658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  266661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266683 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  266686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266700 */     GIR_RootConstrainSelectedInstOperands,
     /*  266701 */     // GIR_Coverage, 23080,
     /*  266701 */     GIR_EraseRootFromParent_Done,
     /*  266702 */   // Label 5364: @266702
     /*  266702 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(266765), // Rule ID 23081 //
     /*  266707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  266721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  266724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  266749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266763 */     GIR_RootConstrainSelectedInstOperands,
     /*  266764 */     // GIR_Coverage, 23081,
     /*  266764 */     GIR_EraseRootFromParent_Done,
     /*  266765 */   // Label 5365: @266765
     /*  266765 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(266828), // Rule ID 23082 //
     /*  266770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  266784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  266787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266809 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  266812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266826 */     GIR_RootConstrainSelectedInstOperands,
     /*  266827 */     // GIR_Coverage, 23082,
     /*  266827 */     GIR_EraseRootFromParent_Done,
     /*  266828 */   // Label 5366: @266828
     /*  266828 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266891), // Rule ID 23083 //
     /*  266833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  266847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  266850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266872 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  266875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266889 */     GIR_RootConstrainSelectedInstOperands,
     /*  266890 */     // GIR_Coverage, 23083,
     /*  266890 */     GIR_EraseRootFromParent_Done,
     /*  266891 */   // Label 5367: @266891
     /*  266891 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266954), // Rule ID 23084 //
     /*  266896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  266910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  266913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266935 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  266935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  266938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  266952 */     GIR_RootConstrainSelectedInstOperands,
     /*  266953 */     // GIR_Coverage, 23084,
     /*  266953 */     GIR_EraseRootFromParent_Done,
     /*  266954 */   // Label 5368: @266954
     /*  266954 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(267017), // Rule ID 23085 //
     /*  266959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  266967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  266973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  266976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266998 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11128:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  266998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  267001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267015 */     GIR_RootConstrainSelectedInstOperands,
     /*  267016 */     // GIR_Coverage, 23085,
     /*  267016 */     GIR_EraseRootFromParent_Done,
     /*  267017 */   // Label 5369: @267017
     /*  267017 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(267080), // Rule ID 23086 //
     /*  267022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  267036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  267039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267061 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  267064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267078 */     GIR_RootConstrainSelectedInstOperands,
     /*  267079 */     // GIR_Coverage, 23086,
     /*  267079 */     GIR_EraseRootFromParent_Done,
     /*  267080 */   // Label 5370: @267080
     /*  267080 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(267143), // Rule ID 23087 //
     /*  267085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  267099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  267102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  267127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267141 */     GIR_RootConstrainSelectedInstOperands,
     /*  267142 */     // GIR_Coverage, 23087,
     /*  267142 */     GIR_EraseRootFromParent_Done,
     /*  267143 */   // Label 5371: @267143
     /*  267143 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(267206), // Rule ID 23088 //
     /*  267148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  267162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  267165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267187 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  267190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267204 */     GIR_RootConstrainSelectedInstOperands,
     /*  267205 */     // GIR_Coverage, 23088,
     /*  267205 */     GIR_EraseRootFromParent_Done,
     /*  267206 */   // Label 5372: @267206
     /*  267206 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(267269), // Rule ID 23089 //
     /*  267211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  267225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  267228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  267253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267267 */     GIR_RootConstrainSelectedInstOperands,
     /*  267268 */     // GIR_Coverage, 23089,
     /*  267268 */     GIR_EraseRootFromParent_Done,
     /*  267269 */   // Label 5373: @267269
     /*  267269 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(267332), // Rule ID 23090 //
     /*  267274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  267288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  267291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267313 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  267316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267330 */     GIR_RootConstrainSelectedInstOperands,
     /*  267331 */     // GIR_Coverage, 23090,
     /*  267331 */     GIR_EraseRootFromParent_Done,
     /*  267332 */   // Label 5374: @267332
     /*  267332 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(267395), // Rule ID 23091 //
     /*  267337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  267351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  267354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  267379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267393 */     GIR_RootConstrainSelectedInstOperands,
     /*  267394 */     // GIR_Coverage, 23091,
     /*  267394 */     GIR_EraseRootFromParent_Done,
     /*  267395 */   // Label 5375: @267395
     /*  267395 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(267458), // Rule ID 23092 //
     /*  267400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  267414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  267417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  267442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267456 */     GIR_RootConstrainSelectedInstOperands,
     /*  267457 */     // GIR_Coverage, 23092,
     /*  267457 */     GIR_EraseRootFromParent_Done,
     /*  267458 */   // Label 5376: @267458
     /*  267458 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(267521), // Rule ID 23093 //
     /*  267463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  267477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  267480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  267505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267519 */     GIR_RootConstrainSelectedInstOperands,
     /*  267520 */     // GIR_Coverage, 23093,
     /*  267520 */     GIR_EraseRootFromParent_Done,
     /*  267521 */   // Label 5377: @267521
     /*  267521 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(267584), // Rule ID 23094 //
     /*  267526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  267540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  267543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  267568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267582 */     GIR_RootConstrainSelectedInstOperands,
     /*  267583 */     // GIR_Coverage, 23094,
     /*  267583 */     GIR_EraseRootFromParent_Done,
     /*  267584 */   // Label 5378: @267584
     /*  267584 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(267647), // Rule ID 23095 //
     /*  267589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  267603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  267606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  267631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267645 */     GIR_RootConstrainSelectedInstOperands,
     /*  267646 */     // GIR_Coverage, 23095,
     /*  267646 */     GIR_EraseRootFromParent_Done,
     /*  267647 */   // Label 5379: @267647
     /*  267647 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(267710), // Rule ID 23096 //
     /*  267652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  267666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  267669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  267694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267708 */     GIR_RootConstrainSelectedInstOperands,
     /*  267709 */     // GIR_Coverage, 23096,
     /*  267709 */     GIR_EraseRootFromParent_Done,
     /*  267710 */   // Label 5380: @267710
     /*  267710 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(267773), // Rule ID 23097 //
     /*  267715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  267729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  267732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267754 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  267757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267771 */     GIR_RootConstrainSelectedInstOperands,
     /*  267772 */     // GIR_Coverage, 23097,
     /*  267772 */     GIR_EraseRootFromParent_Done,
     /*  267773 */   // Label 5381: @267773
     /*  267773 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(267836), // Rule ID 23098 //
     /*  267778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  267789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  267792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  267795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267817 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  267820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267834 */     GIR_RootConstrainSelectedInstOperands,
     /*  267835 */     // GIR_Coverage, 23098,
     /*  267835 */     GIR_EraseRootFromParent_Done,
     /*  267836 */   // Label 5382: @267836
     /*  267836 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(267899), // Rule ID 23099 //
     /*  267841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  267849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  267852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  267855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  267858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267880 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11130:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  267880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  267883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267897 */     GIR_RootConstrainSelectedInstOperands,
     /*  267898 */     // GIR_Coverage, 23099,
     /*  267898 */     GIR_EraseRootFromParent_Done,
     /*  267899 */   // Label 5383: @267899
     /*  267899 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(267962), // Rule ID 23100 //
     /*  267904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  267912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  267918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  267921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267943 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  267943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  267946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  267960 */     GIR_RootConstrainSelectedInstOperands,
     /*  267961 */     // GIR_Coverage, 23100,
     /*  267961 */     GIR_EraseRootFromParent_Done,
     /*  267962 */   // Label 5384: @267962
     /*  267962 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(268025), // Rule ID 23101 //
     /*  267967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  267975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  267981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  267984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268006 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  268009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268023 */     GIR_RootConstrainSelectedInstOperands,
     /*  268024 */     // GIR_Coverage, 23101,
     /*  268024 */     GIR_EraseRootFromParent_Done,
     /*  268025 */   // Label 5385: @268025
     /*  268025 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(268088), // Rule ID 23102 //
     /*  268030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  268044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  268047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268069 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  268072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268086 */     GIR_RootConstrainSelectedInstOperands,
     /*  268087 */     // GIR_Coverage, 23102,
     /*  268087 */     GIR_EraseRootFromParent_Done,
     /*  268088 */   // Label 5386: @268088
     /*  268088 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(268151), // Rule ID 23103 //
     /*  268093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  268107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  268110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  268135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268149 */     GIR_RootConstrainSelectedInstOperands,
     /*  268150 */     // GIR_Coverage, 23103,
     /*  268150 */     GIR_EraseRootFromParent_Done,
     /*  268151 */   // Label 5387: @268151
     /*  268151 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(268214), // Rule ID 23104 //
     /*  268156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  268170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  268173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  268198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268212 */     GIR_RootConstrainSelectedInstOperands,
     /*  268213 */     // GIR_Coverage, 23104,
     /*  268213 */     GIR_EraseRootFromParent_Done,
     /*  268214 */   // Label 5388: @268214
     /*  268214 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(268277), // Rule ID 23105 //
     /*  268219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  268233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  268236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  268261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268275 */     GIR_RootConstrainSelectedInstOperands,
     /*  268276 */     // GIR_Coverage, 23105,
     /*  268276 */     GIR_EraseRootFromParent_Done,
     /*  268277 */   // Label 5389: @268277
     /*  268277 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(268340), // Rule ID 23106 //
     /*  268282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  268296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  268299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  268324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268338 */     GIR_RootConstrainSelectedInstOperands,
     /*  268339 */     // GIR_Coverage, 23106,
     /*  268339 */     GIR_EraseRootFromParent_Done,
     /*  268340 */   // Label 5390: @268340
     /*  268340 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(268403), // Rule ID 23107 //
     /*  268345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  268359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  268362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  268387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268401 */     GIR_RootConstrainSelectedInstOperands,
     /*  268402 */     // GIR_Coverage, 23107,
     /*  268402 */     GIR_EraseRootFromParent_Done,
     /*  268403 */   // Label 5391: @268403
     /*  268403 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(268466), // Rule ID 23108 //
     /*  268408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  268422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  268425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268447 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  268450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268464 */     GIR_RootConstrainSelectedInstOperands,
     /*  268465 */     // GIR_Coverage, 23108,
     /*  268465 */     GIR_EraseRootFromParent_Done,
     /*  268466 */   // Label 5392: @268466
     /*  268466 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(268529), // Rule ID 23109 //
     /*  268471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  268485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  268488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  268513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268527 */     GIR_RootConstrainSelectedInstOperands,
     /*  268528 */     // GIR_Coverage, 23109,
     /*  268528 */     GIR_EraseRootFromParent_Done,
     /*  268529 */   // Label 5393: @268529
     /*  268529 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(268592), // Rule ID 23110 //
     /*  268534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  268548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  268551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268573 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  268576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268590 */     GIR_RootConstrainSelectedInstOperands,
     /*  268591 */     // GIR_Coverage, 23110,
     /*  268591 */     GIR_EraseRootFromParent_Done,
     /*  268592 */   // Label 5394: @268592
     /*  268592 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(268655), // Rule ID 23111 //
     /*  268597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  268611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  268614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  268639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268653 */     GIR_RootConstrainSelectedInstOperands,
     /*  268654 */     // GIR_Coverage, 23111,
     /*  268654 */     GIR_EraseRootFromParent_Done,
     /*  268655 */   // Label 5395: @268655
     /*  268655 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(268718), // Rule ID 23112 //
     /*  268660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  268674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  268677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268699 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  268702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268716 */     GIR_RootConstrainSelectedInstOperands,
     /*  268717 */     // GIR_Coverage, 23112,
     /*  268717 */     GIR_EraseRootFromParent_Done,
     /*  268718 */   // Label 5396: @268718
     /*  268718 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(268781), // Rule ID 23113 //
     /*  268723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  268731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  268737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  268740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268762 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11172:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  268765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268779 */     GIR_RootConstrainSelectedInstOperands,
     /*  268780 */     // GIR_Coverage, 23113,
     /*  268780 */     GIR_EraseRootFromParent_Done,
     /*  268781 */   // Label 5397: @268781
     /*  268781 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(268844), // Rule ID 23142 //
     /*  268786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  268789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  268794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  268797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  268800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  268803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  268818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268825 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  268828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268832 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  268834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268842 */     GIR_RootConstrainSelectedInstOperands,
     /*  268843 */     // GIR_Coverage, 23142,
     /*  268843 */     GIR_EraseRootFromParent_Done,
     /*  268844 */   // Label 5398: @268844
     /*  268844 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(268907), // Rule ID 23143 //
     /*  268849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  268852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  268857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  268860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  268863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  268866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  268881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268888 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  268888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  268891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268895 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  268897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268905 */     GIR_RootConstrainSelectedInstOperands,
     /*  268906 */     // GIR_Coverage, 23143,
     /*  268906 */     GIR_EraseRootFromParent_Done,
     /*  268907 */   // Label 5399: @268907
     /*  268907 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(268970), // Rule ID 23146 //
     /*  268912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  268915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  268920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  268923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  268926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  268929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  268944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268951 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  268951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  268954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268958 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  268960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  268968 */     GIR_RootConstrainSelectedInstOperands,
     /*  268969 */     // GIR_Coverage, 23146,
     /*  268969 */     GIR_EraseRootFromParent_Done,
     /*  268970 */   // Label 5400: @268970
     /*  268970 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(269033), // Rule ID 23147 //
     /*  268975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  268978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  268983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  268986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  268989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  268992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269014 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  269017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269021 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269031 */     GIR_RootConstrainSelectedInstOperands,
     /*  269032 */     // GIR_Coverage, 23147,
     /*  269032 */     GIR_EraseRootFromParent_Done,
     /*  269033 */   // Label 5401: @269033
     /*  269033 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(269096), // Rule ID 23150 //
     /*  269038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  269052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  269055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269077 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  269080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269084 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269094 */     GIR_RootConstrainSelectedInstOperands,
     /*  269095 */     // GIR_Coverage, 23150,
     /*  269095 */     GIR_EraseRootFromParent_Done,
     /*  269096 */   // Label 5402: @269096
     /*  269096 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(269159), // Rule ID 23151 //
     /*  269101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  269115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  269118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269140 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  269143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269147 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269157 */     GIR_RootConstrainSelectedInstOperands,
     /*  269158 */     // GIR_Coverage, 23151,
     /*  269158 */     GIR_EraseRootFromParent_Done,
     /*  269159 */   // Label 5403: @269159
     /*  269159 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(269222), // Rule ID 23154 //
     /*  269164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  269178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  269181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269203 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  269206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269210 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269220 */     GIR_RootConstrainSelectedInstOperands,
     /*  269221 */     // GIR_Coverage, 23154,
     /*  269221 */     GIR_EraseRootFromParent_Done,
     /*  269222 */   // Label 5404: @269222
     /*  269222 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(269285), // Rule ID 23155 //
     /*  269227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  269241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  269244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269266 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  269269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269273 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269283 */     GIR_RootConstrainSelectedInstOperands,
     /*  269284 */     // GIR_Coverage, 23155,
     /*  269284 */     GIR_EraseRootFromParent_Done,
     /*  269285 */   // Label 5405: @269285
     /*  269285 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(269348), // Rule ID 23158 //
     /*  269290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  269304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  269307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269329 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  269332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269336 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269346 */     GIR_RootConstrainSelectedInstOperands,
     /*  269347 */     // GIR_Coverage, 23158,
     /*  269347 */     GIR_EraseRootFromParent_Done,
     /*  269348 */   // Label 5406: @269348
     /*  269348 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(269411), // Rule ID 23159 //
     /*  269353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  269367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  269370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269392 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  269395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269399 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269409 */     GIR_RootConstrainSelectedInstOperands,
     /*  269410 */     // GIR_Coverage, 23159,
     /*  269410 */     GIR_EraseRootFromParent_Done,
     /*  269411 */   // Label 5407: @269411
     /*  269411 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(269474), // Rule ID 23162 //
     /*  269416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  269430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  269433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269455 */     // (intrinsic_wo_chain:{ *:[i64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  269458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269462 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269472 */     GIR_RootConstrainSelectedInstOperands,
     /*  269473 */     // GIR_Coverage, 23162,
     /*  269473 */     GIR_EraseRootFromParent_Done,
     /*  269474 */   // Label 5408: @269474
     /*  269474 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(269537), // Rule ID 23163 //
     /*  269479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  269487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  269493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  269496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269518 */     // (intrinsic_wo_chain:{ *:[i32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  269521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269525 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269535 */     GIR_RootConstrainSelectedInstOperands,
     /*  269536 */     // GIR_Coverage, 23163,
     /*  269536 */     GIR_EraseRootFromParent_Done,
     /*  269537 */   // Label 5409: @269537
     /*  269537 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(269600), // Rule ID 23166 //
     /*  269542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  269556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  269559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269581 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  269584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269588 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269598 */     GIR_RootConstrainSelectedInstOperands,
     /*  269599 */     // GIR_Coverage, 23166,
     /*  269599 */     GIR_EraseRootFromParent_Done,
     /*  269600 */   // Label 5410: @269600
     /*  269600 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(269663), // Rule ID 23167 //
     /*  269605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  269619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  269622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269644 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  269647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269651 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269661 */     GIR_RootConstrainSelectedInstOperands,
     /*  269662 */     // GIR_Coverage, 23167,
     /*  269662 */     GIR_EraseRootFromParent_Done,
     /*  269663 */   // Label 5411: @269663
     /*  269663 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(269726), // Rule ID 23170 //
     /*  269668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  269682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  269685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269707 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  269710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269714 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269724 */     GIR_RootConstrainSelectedInstOperands,
     /*  269725 */     // GIR_Coverage, 23170,
     /*  269725 */     GIR_EraseRootFromParent_Done,
     /*  269726 */   // Label 5412: @269726
     /*  269726 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(269789), // Rule ID 23171 //
     /*  269731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  269745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  269748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269770 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  269773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269777 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269787 */     GIR_RootConstrainSelectedInstOperands,
     /*  269788 */     // GIR_Coverage, 23171,
     /*  269788 */     GIR_EraseRootFromParent_Done,
     /*  269789 */   // Label 5413: @269789
     /*  269789 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(269852), // Rule ID 23174 //
     /*  269794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  269808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  269811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269833 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  269836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269840 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269850 */     GIR_RootConstrainSelectedInstOperands,
     /*  269851 */     // GIR_Coverage, 23174,
     /*  269851 */     GIR_EraseRootFromParent_Done,
     /*  269852 */   // Label 5414: @269852
     /*  269852 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(269915), // Rule ID 23175 //
     /*  269857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  269871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  269874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269896 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  269896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  269899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269903 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269913 */     GIR_RootConstrainSelectedInstOperands,
     /*  269914 */     // GIR_Coverage, 23175,
     /*  269914 */     GIR_EraseRootFromParent_Done,
     /*  269915 */   // Label 5415: @269915
     /*  269915 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(269978), // Rule ID 23178 //
     /*  269920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  269923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  269931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  269934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  269937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  269952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269959 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  269959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  269962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269966 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  269968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  269976 */     GIR_RootConstrainSelectedInstOperands,
     /*  269977 */     // GIR_Coverage, 23178,
     /*  269977 */     GIR_EraseRootFromParent_Done,
     /*  269978 */   // Label 5416: @269978
     /*  269978 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270041), // Rule ID 23179 //
     /*  269983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  269986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  269991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  269994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  269997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  270000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270022 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  270022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  270025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270029 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270039 */     GIR_RootConstrainSelectedInstOperands,
     /*  270040 */     // GIR_Coverage, 23179,
     /*  270040 */     GIR_EraseRootFromParent_Done,
     /*  270041 */   // Label 5417: @270041
     /*  270041 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270104), // Rule ID 23182 //
     /*  270046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  270049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  270057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  270060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  270063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270085 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  270085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  270088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270092 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270102 */     GIR_RootConstrainSelectedInstOperands,
     /*  270103 */     // GIR_Coverage, 23182,
     /*  270103 */     GIR_EraseRootFromParent_Done,
     /*  270104 */   // Label 5418: @270104
     /*  270104 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270167), // Rule ID 23183 //
     /*  270109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  270112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  270120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  270123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  270126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270148 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  270148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  270151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270155 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270165 */     GIR_RootConstrainSelectedInstOperands,
     /*  270166 */     // GIR_Coverage, 23183,
     /*  270166 */     GIR_EraseRootFromParent_Done,
     /*  270167 */   // Label 5419: @270167
     /*  270167 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270230), // Rule ID 23186 //
     /*  270172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  270175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  270183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  270186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  270189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270211 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  270211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  270214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270218 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270228 */     GIR_RootConstrainSelectedInstOperands,
     /*  270229 */     // GIR_Coverage, 23186,
     /*  270229 */     GIR_EraseRootFromParent_Done,
     /*  270230 */   // Label 5420: @270230
     /*  270230 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(270293), // Rule ID 23187 //
     /*  270235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  270238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  270246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  270249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  270252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270274 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  270274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  270277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270281 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270291 */     GIR_RootConstrainSelectedInstOperands,
     /*  270292 */     // GIR_Coverage, 23187,
     /*  270292 */     GIR_EraseRootFromParent_Done,
     /*  270293 */   // Label 5421: @270293
     /*  270293 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(270356), // Rule ID 23190 //
     /*  270298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  270301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  270309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  270312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  270315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270337 */     // (intrinsic_wo_chain:{ *:[i64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  270337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  270340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270344 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270354 */     GIR_RootConstrainSelectedInstOperands,
     /*  270355 */     // GIR_Coverage, 23190,
     /*  270355 */     GIR_EraseRootFromParent_Done,
     /*  270356 */   // Label 5422: @270356
     /*  270356 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(270419), // Rule ID 23191 //
     /*  270361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  270364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  270369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  270372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  270375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  270378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  270393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270400 */     // (intrinsic_wo_chain:{ *:[i32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  270400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  270403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270407 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  270409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270417 */     GIR_RootConstrainSelectedInstOperands,
     /*  270418 */     // GIR_Coverage, 23191,
     /*  270418 */     GIR_EraseRootFromParent_Done,
     /*  270419 */   // Label 5423: @270419
     /*  270419 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(270485), // Rule ID 23272 //
     /*  270424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  270435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  270441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270463 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  270463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  270466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270483 */     GIR_RootConstrainSelectedInstOperands,
     /*  270484 */     // GIR_Coverage, 23272,
     /*  270484 */     GIR_EraseRootFromParent_Done,
     /*  270485 */   // Label 5424: @270485
     /*  270485 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(270551), // Rule ID 23273 //
     /*  270490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  270501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  270507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270529 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  270529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  270532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270549 */     GIR_RootConstrainSelectedInstOperands,
     /*  270550 */     // GIR_Coverage, 23273,
     /*  270550 */     GIR_EraseRootFromParent_Done,
     /*  270551 */   // Label 5425: @270551
     /*  270551 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(270617), // Rule ID 23276 //
     /*  270556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  270567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  270573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270595 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  270595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  270598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270615 */     GIR_RootConstrainSelectedInstOperands,
     /*  270616 */     // GIR_Coverage, 23276,
     /*  270616 */     GIR_EraseRootFromParent_Done,
     /*  270617 */   // Label 5426: @270617
     /*  270617 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(270683), // Rule ID 23277 //
     /*  270622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  270633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  270639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270661 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  270661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  270664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270681 */     GIR_RootConstrainSelectedInstOperands,
     /*  270682 */     // GIR_Coverage, 23277,
     /*  270682 */     GIR_EraseRootFromParent_Done,
     /*  270683 */   // Label 5427: @270683
     /*  270683 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(270749), // Rule ID 23280 //
     /*  270688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  270699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  270705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270727 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  270727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  270730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270747 */     GIR_RootConstrainSelectedInstOperands,
     /*  270748 */     // GIR_Coverage, 23280,
     /*  270748 */     GIR_EraseRootFromParent_Done,
     /*  270749 */   // Label 5428: @270749
     /*  270749 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(270815), // Rule ID 23281 //
     /*  270754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  270765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  270771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270793 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  270793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  270796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270813 */     GIR_RootConstrainSelectedInstOperands,
     /*  270814 */     // GIR_Coverage, 23281,
     /*  270814 */     GIR_EraseRootFromParent_Done,
     /*  270815 */   // Label 5429: @270815
     /*  270815 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(270881), // Rule ID 23284 //
     /*  270820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  270831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  270837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  270859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  270862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270879 */     GIR_RootConstrainSelectedInstOperands,
     /*  270880 */     // GIR_Coverage, 23284,
     /*  270880 */     GIR_EraseRootFromParent_Done,
     /*  270881 */   // Label 5430: @270881
     /*  270881 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(270947), // Rule ID 23285 //
     /*  270886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  270897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  270903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270925 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  270925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  270928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  270945 */     GIR_RootConstrainSelectedInstOperands,
     /*  270946 */     // GIR_Coverage, 23285,
     /*  270946 */     GIR_EraseRootFromParent_Done,
     /*  270947 */   // Label 5431: @270947
     /*  270947 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271013), // Rule ID 23288 //
     /*  270952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  270960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  270963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  270969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270991 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  270991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  270994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  270998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271011 */     GIR_RootConstrainSelectedInstOperands,
     /*  271012 */     // GIR_Coverage, 23288,
     /*  271012 */     GIR_EraseRootFromParent_Done,
     /*  271013 */   // Label 5432: @271013
     /*  271013 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271079), // Rule ID 23289 //
     /*  271018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  271029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  271032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  271035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271057 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  271057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  271060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271077 */     GIR_RootConstrainSelectedInstOperands,
     /*  271078 */     // GIR_Coverage, 23289,
     /*  271078 */     GIR_EraseRootFromParent_Done,
     /*  271079 */   // Label 5433: @271079
     /*  271079 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271145), // Rule ID 23292 //
     /*  271084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  271095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  271101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271123 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  271123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271143 */     GIR_RootConstrainSelectedInstOperands,
     /*  271144 */     // GIR_Coverage, 23292,
     /*  271144 */     GIR_EraseRootFromParent_Done,
     /*  271145 */   // Label 5434: @271145
     /*  271145 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271211), // Rule ID 23293 //
     /*  271150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  271161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  271167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271189 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  271189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271209 */     GIR_RootConstrainSelectedInstOperands,
     /*  271210 */     // GIR_Coverage, 23293,
     /*  271210 */     GIR_EraseRootFromParent_Done,
     /*  271211 */   // Label 5435: @271211
     /*  271211 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271277), // Rule ID 23296 //
     /*  271216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  271227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  271233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271255 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  271255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271275 */     GIR_RootConstrainSelectedInstOperands,
     /*  271276 */     // GIR_Coverage, 23296,
     /*  271276 */     GIR_EraseRootFromParent_Done,
     /*  271277 */   // Label 5436: @271277
     /*  271277 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271343), // Rule ID 23297 //
     /*  271282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  271293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  271299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  271321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271341 */     GIR_RootConstrainSelectedInstOperands,
     /*  271342 */     // GIR_Coverage, 23297,
     /*  271342 */     GIR_EraseRootFromParent_Done,
     /*  271343 */   // Label 5437: @271343
     /*  271343 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271409), // Rule ID 23300 //
     /*  271348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  271359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  271365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  271387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271407 */     GIR_RootConstrainSelectedInstOperands,
     /*  271408 */     // GIR_Coverage, 23300,
     /*  271408 */     GIR_EraseRootFromParent_Done,
     /*  271409 */   // Label 5438: @271409
     /*  271409 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271475), // Rule ID 23301 //
     /*  271414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  271425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  271431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  271453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271473 */     GIR_RootConstrainSelectedInstOperands,
     /*  271474 */     // GIR_Coverage, 23301,
     /*  271474 */     GIR_EraseRootFromParent_Done,
     /*  271475 */   // Label 5439: @271475
     /*  271475 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271541), // Rule ID 23304 //
     /*  271480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  271491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  271497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271519 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  271519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271539 */     GIR_RootConstrainSelectedInstOperands,
     /*  271540 */     // GIR_Coverage, 23304,
     /*  271540 */     GIR_EraseRootFromParent_Done,
     /*  271541 */   // Label 5440: @271541
     /*  271541 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(271607), // Rule ID 23305 //
     /*  271546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  271557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  271563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271585 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  271585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  271588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271605 */     GIR_RootConstrainSelectedInstOperands,
     /*  271606 */     // GIR_Coverage, 23305,
     /*  271606 */     GIR_EraseRootFromParent_Done,
     /*  271607 */   // Label 5441: @271607
     /*  271607 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(271673), // Rule ID 23308 //
     /*  271612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  271623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  271629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  271651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  271654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271671 */     GIR_RootConstrainSelectedInstOperands,
     /*  271672 */     // GIR_Coverage, 23308,
     /*  271672 */     GIR_EraseRootFromParent_Done,
     /*  271673 */   // Label 5442: @271673
     /*  271673 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(271739), // Rule ID 23309 //
     /*  271678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  271689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  271695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271717 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  271717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  271720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271737 */     GIR_RootConstrainSelectedInstOperands,
     /*  271738 */     // GIR_Coverage, 23309,
     /*  271738 */     GIR_EraseRootFromParent_Done,
     /*  271739 */   // Label 5443: @271739
     /*  271739 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(271805), // Rule ID 23312 //
     /*  271744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  271755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  271761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271783 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  271783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  271786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271803 */     GIR_RootConstrainSelectedInstOperands,
     /*  271804 */     // GIR_Coverage, 23312,
     /*  271804 */     GIR_EraseRootFromParent_Done,
     /*  271805 */   // Label 5444: @271805
     /*  271805 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(271871), // Rule ID 23313 //
     /*  271810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  271821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  271827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  271849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  271852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271869 */     GIR_RootConstrainSelectedInstOperands,
     /*  271870 */     // GIR_Coverage, 23313,
     /*  271870 */     GIR_EraseRootFromParent_Done,
     /*  271871 */   // Label 5445: @271871
     /*  271871 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(271937), // Rule ID 23316 //
     /*  271876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  271887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  271893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271915 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  271915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  271918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  271935 */     GIR_RootConstrainSelectedInstOperands,
     /*  271936 */     // GIR_Coverage, 23316,
     /*  271936 */     GIR_EraseRootFromParent_Done,
     /*  271937 */   // Label 5446: @271937
     /*  271937 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272003), // Rule ID 23317 //
     /*  271942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  271950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  271953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  271959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271981 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  271981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  271984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  271988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272001 */     GIR_RootConstrainSelectedInstOperands,
     /*  272002 */     // GIR_Coverage, 23317,
     /*  272002 */     GIR_EraseRootFromParent_Done,
     /*  272003 */   // Label 5447: @272003
     /*  272003 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(272069), // Rule ID 23320 //
     /*  272008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  272019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  272025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272047 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  272047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272067 */     GIR_RootConstrainSelectedInstOperands,
     /*  272068 */     // GIR_Coverage, 23320,
     /*  272068 */     GIR_EraseRootFromParent_Done,
     /*  272069 */   // Label 5448: @272069
     /*  272069 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272135), // Rule ID 23321 //
     /*  272074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  272085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  272091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  272113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272133 */     GIR_RootConstrainSelectedInstOperands,
     /*  272134 */     // GIR_Coverage, 23321,
     /*  272134 */     GIR_EraseRootFromParent_Done,
     /*  272135 */   // Label 5449: @272135
     /*  272135 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272201), // Rule ID 23324 //
     /*  272140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  272151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  272157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272179 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  272179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  272182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272199 */     GIR_RootConstrainSelectedInstOperands,
     /*  272200 */     // GIR_Coverage, 23324,
     /*  272200 */     GIR_EraseRootFromParent_Done,
     /*  272201 */   // Label 5450: @272201
     /*  272201 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272267), // Rule ID 23325 //
     /*  272206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  272217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  272223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  272245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  272248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272265 */     GIR_RootConstrainSelectedInstOperands,
     /*  272266 */     // GIR_Coverage, 23325,
     /*  272266 */     GIR_EraseRootFromParent_Done,
     /*  272267 */   // Label 5451: @272267
     /*  272267 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(272333), // Rule ID 23328 //
     /*  272272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  272283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  272289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272311 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  272311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  272314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272331 */     GIR_RootConstrainSelectedInstOperands,
     /*  272332 */     // GIR_Coverage, 23328,
     /*  272332 */     GIR_EraseRootFromParent_Done,
     /*  272333 */   // Label 5452: @272333
     /*  272333 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(272399), // Rule ID 23329 //
     /*  272338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  272349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  272355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  272377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  272380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272397 */     GIR_RootConstrainSelectedInstOperands,
     /*  272398 */     // GIR_Coverage, 23329,
     /*  272398 */     GIR_EraseRootFromParent_Done,
     /*  272399 */   // Label 5453: @272399
     /*  272399 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(272465), // Rule ID 23332 //
     /*  272404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  272415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  272421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  272443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272463 */     GIR_RootConstrainSelectedInstOperands,
     /*  272464 */     // GIR_Coverage, 23332,
     /*  272464 */     GIR_EraseRootFromParent_Done,
     /*  272465 */   // Label 5454: @272465
     /*  272465 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272531), // Rule ID 23333 //
     /*  272470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  272481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  272487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  272509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272529 */     GIR_RootConstrainSelectedInstOperands,
     /*  272530 */     // GIR_Coverage, 23333,
     /*  272530 */     GIR_EraseRootFromParent_Done,
     /*  272531 */   // Label 5455: @272531
     /*  272531 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(272597), // Rule ID 23336 //
     /*  272536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  272547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  272553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  272575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  272578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272595 */     GIR_RootConstrainSelectedInstOperands,
     /*  272596 */     // GIR_Coverage, 23336,
     /*  272596 */     GIR_EraseRootFromParent_Done,
     /*  272597 */   // Label 5456: @272597
     /*  272597 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(272663), // Rule ID 23337 //
     /*  272602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  272613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  272619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  272641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  272644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272661 */     GIR_RootConstrainSelectedInstOperands,
     /*  272662 */     // GIR_Coverage, 23337,
     /*  272662 */     GIR_EraseRootFromParent_Done,
     /*  272663 */   // Label 5457: @272663
     /*  272663 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(272729), // Rule ID 23340 //
     /*  272668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  272679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  272685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272707 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  272707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  272710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272727 */     GIR_RootConstrainSelectedInstOperands,
     /*  272728 */     // GIR_Coverage, 23340,
     /*  272728 */     GIR_EraseRootFromParent_Done,
     /*  272729 */   // Label 5458: @272729
     /*  272729 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(272795), // Rule ID 23341 //
     /*  272734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  272745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  272751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272773 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  272773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  272776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272793 */     GIR_RootConstrainSelectedInstOperands,
     /*  272794 */     // GIR_Coverage, 23341,
     /*  272794 */     GIR_EraseRootFromParent_Done,
     /*  272795 */   // Label 5459: @272795
     /*  272795 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(272861), // Rule ID 23344 //
     /*  272800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  272811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  272817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  272839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272859 */     GIR_RootConstrainSelectedInstOperands,
     /*  272860 */     // GIR_Coverage, 23344,
     /*  272860 */     GIR_EraseRootFromParent_Done,
     /*  272861 */   // Label 5460: @272861
     /*  272861 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(272927), // Rule ID 23345 //
     /*  272866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  272877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  272883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272905 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  272905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  272908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272925 */     GIR_RootConstrainSelectedInstOperands,
     /*  272926 */     // GIR_Coverage, 23345,
     /*  272926 */     GIR_EraseRootFromParent_Done,
     /*  272927 */   // Label 5461: @272927
     /*  272927 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272993), // Rule ID 23348 //
     /*  272932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  272940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  272943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  272949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  272971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  272974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  272978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  272991 */     GIR_RootConstrainSelectedInstOperands,
     /*  272992 */     // GIR_Coverage, 23348,
     /*  272992 */     GIR_EraseRootFromParent_Done,
     /*  272993 */   // Label 5462: @272993
     /*  272993 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(273059), // Rule ID 23349 //
     /*  272998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  273006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  273009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  273012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  273015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273037 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  273037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  273040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273057 */     GIR_RootConstrainSelectedInstOperands,
     /*  273058 */     // GIR_Coverage, 23349,
     /*  273058 */     GIR_EraseRootFromParent_Done,
     /*  273059 */   // Label 5463: @273059
     /*  273059 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(273125), // Rule ID 23352 //
     /*  273064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  273072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  273075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  273081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273103 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  273103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  273106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273123 */     GIR_RootConstrainSelectedInstOperands,
     /*  273124 */     // GIR_Coverage, 23352,
     /*  273124 */     GIR_EraseRootFromParent_Done,
     /*  273125 */   // Label 5464: @273125
     /*  273125 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(273191), // Rule ID 23353 //
     /*  273130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  273138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  273141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  273147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  273169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  273172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273189 */     GIR_RootConstrainSelectedInstOperands,
     /*  273190 */     // GIR_Coverage, 23353,
     /*  273190 */     GIR_EraseRootFromParent_Done,
     /*  273191 */   // Label 5465: @273191
     /*  273191 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(273257), // Rule ID 59892 //
     /*  273196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  273207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  273235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  273238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273255 */     GIR_RootConstrainSelectedInstOperands,
     /*  273256 */     // GIR_Coverage, 59892,
     /*  273256 */     GIR_EraseRootFromParent_Done,
     /*  273257 */   // Label 5466: @273257
     /*  273257 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(273323), // Rule ID 59893 //
     /*  273262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  273273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  273301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  273304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273321 */     GIR_RootConstrainSelectedInstOperands,
     /*  273322 */     // GIR_Coverage, 59893,
     /*  273322 */     GIR_EraseRootFromParent_Done,
     /*  273323 */   // Label 5467: @273323
     /*  273323 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(273389), // Rule ID 59896 //
     /*  273328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  273339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273367 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  273367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  273370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273387 */     GIR_RootConstrainSelectedInstOperands,
     /*  273388 */     // GIR_Coverage, 59896,
     /*  273388 */     GIR_EraseRootFromParent_Done,
     /*  273389 */   // Label 5468: @273389
     /*  273389 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(273455), // Rule ID 59897 //
     /*  273394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  273405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273433 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  273433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  273436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273453 */     GIR_RootConstrainSelectedInstOperands,
     /*  273454 */     // GIR_Coverage, 59897,
     /*  273454 */     GIR_EraseRootFromParent_Done,
     /*  273455 */   // Label 5469: @273455
     /*  273455 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(273521), // Rule ID 59900 //
     /*  273460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  273471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273499 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  273499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273519 */     GIR_RootConstrainSelectedInstOperands,
     /*  273520 */     // GIR_Coverage, 59900,
     /*  273520 */     GIR_EraseRootFromParent_Done,
     /*  273521 */   // Label 5470: @273521
     /*  273521 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(273587), // Rule ID 59901 //
     /*  273526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  273537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273565 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  273565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273585 */     GIR_RootConstrainSelectedInstOperands,
     /*  273586 */     // GIR_Coverage, 59901,
     /*  273586 */     GIR_EraseRootFromParent_Done,
     /*  273587 */   // Label 5471: @273587
     /*  273587 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(273653), // Rule ID 59904 //
     /*  273592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  273603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273631 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  273631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  273634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273651 */     GIR_RootConstrainSelectedInstOperands,
     /*  273652 */     // GIR_Coverage, 59904,
     /*  273652 */     GIR_EraseRootFromParent_Done,
     /*  273653 */   // Label 5472: @273653
     /*  273653 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(273719), // Rule ID 59905 //
     /*  273658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  273669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273697 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  273697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  273700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273717 */     GIR_RootConstrainSelectedInstOperands,
     /*  273718 */     // GIR_Coverage, 59905,
     /*  273718 */     GIR_EraseRootFromParent_Done,
     /*  273719 */   // Label 5473: @273719
     /*  273719 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(273785), // Rule ID 59908 //
     /*  273724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  273735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  273741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273763 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  273763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273783 */     GIR_RootConstrainSelectedInstOperands,
     /*  273784 */     // GIR_Coverage, 59908,
     /*  273784 */     GIR_EraseRootFromParent_Done,
     /*  273785 */   // Label 5474: @273785
     /*  273785 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(273851), // Rule ID 59909 //
     /*  273790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  273801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  273807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273829 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  273829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273849 */     GIR_RootConstrainSelectedInstOperands,
     /*  273850 */     // GIR_Coverage, 59909,
     /*  273850 */     GIR_EraseRootFromParent_Done,
     /*  273851 */   // Label 5475: @273851
     /*  273851 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(273917), // Rule ID 59912 //
     /*  273856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  273867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  273873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273895 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  273895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273915 */     GIR_RootConstrainSelectedInstOperands,
     /*  273916 */     // GIR_Coverage, 59912,
     /*  273916 */     GIR_EraseRootFromParent_Done,
     /*  273917 */   // Label 5476: @273917
     /*  273917 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(273983), // Rule ID 59913 //
     /*  273922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  273925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  273933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  273939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273961 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  273961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  273964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  273968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  273981 */     GIR_RootConstrainSelectedInstOperands,
     /*  273982 */     // GIR_Coverage, 59913,
     /*  273982 */     GIR_EraseRootFromParent_Done,
     /*  273983 */   // Label 5477: @273983
     /*  273983 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(274049), // Rule ID 59916 //
     /*  273988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  273991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  273996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  273999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  274027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274047 */     GIR_RootConstrainSelectedInstOperands,
     /*  274048 */     // GIR_Coverage, 59916,
     /*  274048 */     GIR_EraseRootFromParent_Done,
     /*  274049 */   // Label 5478: @274049
     /*  274049 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(274115), // Rule ID 59917 //
     /*  274054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  274065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274093 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10855:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  274093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274113 */     GIR_RootConstrainSelectedInstOperands,
     /*  274114 */     // GIR_Coverage, 59917,
     /*  274114 */     GIR_EraseRootFromParent_Done,
     /*  274115 */   // Label 5479: @274115
     /*  274115 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(274181), // Rule ID 59920 //
     /*  274120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  274131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274159 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  274159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274179 */     GIR_RootConstrainSelectedInstOperands,
     /*  274180 */     // GIR_Coverage, 59920,
     /*  274180 */     GIR_EraseRootFromParent_Done,
     /*  274181 */   // Label 5480: @274181
     /*  274181 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(274247), // Rule ID 59921 //
     /*  274186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  274197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274225 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  274225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274245 */     GIR_RootConstrainSelectedInstOperands,
     /*  274246 */     // GIR_Coverage, 59921,
     /*  274246 */     GIR_EraseRootFromParent_Done,
     /*  274247 */   // Label 5481: @274247
     /*  274247 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(274313), // Rule ID 59924 //
     /*  274252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  274263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274291 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  274291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274311 */     GIR_RootConstrainSelectedInstOperands,
     /*  274312 */     // GIR_Coverage, 59924,
     /*  274312 */     GIR_EraseRootFromParent_Done,
     /*  274313 */   // Label 5482: @274313
     /*  274313 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(274379), // Rule ID 59925 //
     /*  274318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  274329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274357 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  274357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274377 */     GIR_RootConstrainSelectedInstOperands,
     /*  274378 */     // GIR_Coverage, 59925,
     /*  274378 */     GIR_EraseRootFromParent_Done,
     /*  274379 */   // Label 5483: @274379
     /*  274379 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(274445), // Rule ID 59928 //
     /*  274384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  274395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274423 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  274423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274443 */     GIR_RootConstrainSelectedInstOperands,
     /*  274444 */     // GIR_Coverage, 59928,
     /*  274444 */     GIR_EraseRootFromParent_Done,
     /*  274445 */   // Label 5484: @274445
     /*  274445 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(274511), // Rule ID 59929 //
     /*  274450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  274461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  274489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  274492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274509 */     GIR_RootConstrainSelectedInstOperands,
     /*  274510 */     // GIR_Coverage, 59929,
     /*  274510 */     GIR_EraseRootFromParent_Done,
     /*  274511 */   // Label 5485: @274511
     /*  274511 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(274577), // Rule ID 59932 //
     /*  274516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  274527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  274555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  274558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274575 */     GIR_RootConstrainSelectedInstOperands,
     /*  274576 */     // GIR_Coverage, 59932,
     /*  274576 */     GIR_EraseRootFromParent_Done,
     /*  274577 */   // Label 5486: @274577
     /*  274577 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(274643), // Rule ID 59933 //
     /*  274582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  274593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  274621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  274624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274641 */     GIR_RootConstrainSelectedInstOperands,
     /*  274642 */     // GIR_Coverage, 59933,
     /*  274642 */     GIR_EraseRootFromParent_Done,
     /*  274643 */   // Label 5487: @274643
     /*  274643 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(274709), // Rule ID 59936 //
     /*  274648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  274659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274687 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  274687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  274690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274707 */     GIR_RootConstrainSelectedInstOperands,
     /*  274708 */     // GIR_Coverage, 59936,
     /*  274708 */     GIR_EraseRootFromParent_Done,
     /*  274709 */   // Label 5488: @274709
     /*  274709 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(274775), // Rule ID 59937 //
     /*  274714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  274725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274753 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  274753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  274756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274773 */     GIR_RootConstrainSelectedInstOperands,
     /*  274774 */     // GIR_Coverage, 59937,
     /*  274774 */     GIR_EraseRootFromParent_Done,
     /*  274775 */   // Label 5489: @274775
     /*  274775 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(274841), // Rule ID 59940 //
     /*  274780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  274791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  274797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  274819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  274822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274839 */     GIR_RootConstrainSelectedInstOperands,
     /*  274840 */     // GIR_Coverage, 59940,
     /*  274840 */     GIR_EraseRootFromParent_Done,
     /*  274841 */   // Label 5490: @274841
     /*  274841 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(274907), // Rule ID 59941 //
     /*  274846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  274857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  274863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274885 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  274885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  274888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274905 */     GIR_RootConstrainSelectedInstOperands,
     /*  274906 */     // GIR_Coverage, 59941,
     /*  274906 */     GIR_EraseRootFromParent_Done,
     /*  274907 */   // Label 5491: @274907
     /*  274907 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(274973), // Rule ID 59944 //
     /*  274912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  274915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  274923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  274929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  274951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  274954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  274958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  274971 */     GIR_RootConstrainSelectedInstOperands,
     /*  274972 */     // GIR_Coverage, 59944,
     /*  274972 */     GIR_EraseRootFromParent_Done,
     /*  274973 */   // Label 5492: @274973
     /*  274973 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(275039), // Rule ID 59945 //
     /*  274978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  274981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  274986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  274989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  274995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  275017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  275020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275037 */     GIR_RootConstrainSelectedInstOperands,
     /*  275038 */     // GIR_Coverage, 59945,
     /*  275038 */     GIR_EraseRootFromParent_Done,
     /*  275039 */   // Label 5493: @275039
     /*  275039 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(275105), // Rule ID 59948 //
     /*  275044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  275055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275083 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  275083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275103 */     GIR_RootConstrainSelectedInstOperands,
     /*  275104 */     // GIR_Coverage, 59948,
     /*  275104 */     GIR_EraseRootFromParent_Done,
     /*  275105 */   // Label 5494: @275105
     /*  275105 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(275171), // Rule ID 59949 //
     /*  275110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  275121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  275149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275169 */     GIR_RootConstrainSelectedInstOperands,
     /*  275170 */     // GIR_Coverage, 59949,
     /*  275170 */     GIR_EraseRootFromParent_Done,
     /*  275171 */   // Label 5495: @275171
     /*  275171 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(275237), // Rule ID 59952 //
     /*  275176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  275187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275215 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  275215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  275218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275235 */     GIR_RootConstrainSelectedInstOperands,
     /*  275236 */     // GIR_Coverage, 59952,
     /*  275236 */     GIR_EraseRootFromParent_Done,
     /*  275237 */   // Label 5496: @275237
     /*  275237 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(275303), // Rule ID 59953 //
     /*  275242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  275253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  275281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  275284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275301 */     GIR_RootConstrainSelectedInstOperands,
     /*  275302 */     // GIR_Coverage, 59953,
     /*  275302 */     GIR_EraseRootFromParent_Done,
     /*  275303 */   // Label 5497: @275303
     /*  275303 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(275369), // Rule ID 59956 //
     /*  275308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  275319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275347 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  275347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  275350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275367 */     GIR_RootConstrainSelectedInstOperands,
     /*  275368 */     // GIR_Coverage, 59956,
     /*  275368 */     GIR_EraseRootFromParent_Done,
     /*  275369 */   // Label 5498: @275369
     /*  275369 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(275435), // Rule ID 59957 //
     /*  275374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  275385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  275413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  275416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275433 */     GIR_RootConstrainSelectedInstOperands,
     /*  275434 */     // GIR_Coverage, 59957,
     /*  275434 */     GIR_EraseRootFromParent_Done,
     /*  275435 */   // Label 5499: @275435
     /*  275435 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(275501), // Rule ID 59960 //
     /*  275440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  275451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  275479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275499 */     GIR_RootConstrainSelectedInstOperands,
     /*  275500 */     // GIR_Coverage, 59960,
     /*  275500 */     GIR_EraseRootFromParent_Done,
     /*  275501 */   // Label 5500: @275501
     /*  275501 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(275567), // Rule ID 59961 //
     /*  275506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  275517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275545 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  275545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275565 */     GIR_RootConstrainSelectedInstOperands,
     /*  275566 */     // GIR_Coverage, 59961,
     /*  275566 */     GIR_EraseRootFromParent_Done,
     /*  275567 */   // Label 5501: @275567
     /*  275567 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(275633), // Rule ID 59964 //
     /*  275572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  275583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275611 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  275611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  275614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275631 */     GIR_RootConstrainSelectedInstOperands,
     /*  275632 */     // GIR_Coverage, 59964,
     /*  275632 */     GIR_EraseRootFromParent_Done,
     /*  275633 */   // Label 5502: @275633
     /*  275633 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(275699), // Rule ID 59965 //
     /*  275638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  275649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  275677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  275680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275697 */     GIR_RootConstrainSelectedInstOperands,
     /*  275698 */     // GIR_Coverage, 59965,
     /*  275698 */     GIR_EraseRootFromParent_Done,
     /*  275699 */   // Label 5503: @275699
     /*  275699 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(275765), // Rule ID 59968 //
     /*  275704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  275715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  275743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  275746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275763 */     GIR_RootConstrainSelectedInstOperands,
     /*  275764 */     // GIR_Coverage, 59968,
     /*  275764 */     GIR_EraseRootFromParent_Done,
     /*  275765 */   // Label 5504: @275765
     /*  275765 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(275831), // Rule ID 59969 //
     /*  275770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  275781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  275809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  275812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275829 */     GIR_RootConstrainSelectedInstOperands,
     /*  275830 */     // GIR_Coverage, 59969,
     /*  275830 */     GIR_EraseRootFromParent_Done,
     /*  275831 */   // Label 5505: @275831
     /*  275831 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(275897), // Rule ID 59972 //
     /*  275836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  275847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  275853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275875 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  275875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275895 */     GIR_RootConstrainSelectedInstOperands,
     /*  275896 */     // GIR_Coverage, 59972,
     /*  275896 */     GIR_EraseRootFromParent_Done,
     /*  275897 */   // Label 5506: @275897
     /*  275897 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(275963), // Rule ID 59973 //
     /*  275902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  275905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  275913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  275919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  275941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  275944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  275948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  275961 */     GIR_RootConstrainSelectedInstOperands,
     /*  275962 */     // GIR_Coverage, 59973,
     /*  275962 */     GIR_EraseRootFromParent_Done,
     /*  275963 */   // Label 5507: @275963
     /*  275963 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(276029), // Rule ID 59976 //
     /*  275968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  275971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  275976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  275979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  275985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276007 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  276007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  276010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276027 */     GIR_RootConstrainSelectedInstOperands,
     /*  276028 */     // GIR_Coverage, 59976,
     /*  276028 */     GIR_EraseRootFromParent_Done,
     /*  276029 */   // Label 5508: @276029
     /*  276029 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(276095), // Rule ID 59977 //
     /*  276034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  276042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  276045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  276048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  276051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  276073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  276076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276093 */     GIR_RootConstrainSelectedInstOperands,
     /*  276094 */     // GIR_Coverage, 59977,
     /*  276094 */     GIR_EraseRootFromParent_Done,
     /*  276095 */   // Label 5509: @276095
     /*  276095 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(276161), // Rule ID 59980 //
     /*  276100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  276111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  276117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  276139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  276142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276159 */     GIR_RootConstrainSelectedInstOperands,
     /*  276160 */     // GIR_Coverage, 59980,
     /*  276160 */     GIR_EraseRootFromParent_Done,
     /*  276161 */   // Label 5510: @276161
     /*  276161 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(276227), // Rule ID 59981 //
     /*  276166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  276177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  276183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276205 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  276205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  276208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276225 */     GIR_RootConstrainSelectedInstOperands,
     /*  276226 */     // GIR_Coverage, 59981,
     /*  276226 */     GIR_EraseRootFromParent_Done,
     /*  276227 */   // Label 5511: @276227
     /*  276227 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(276293), // Rule ID 59984 //
     /*  276232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  276243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  276249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276271 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  276271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  276274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276291 */     GIR_RootConstrainSelectedInstOperands,
     /*  276292 */     // GIR_Coverage, 59984,
     /*  276292 */     GIR_EraseRootFromParent_Done,
     /*  276293 */   // Label 5512: @276293
     /*  276293 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(276359), // Rule ID 59985 //
     /*  276298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  276309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  276315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276337 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  276337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  276340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276357 */     GIR_RootConstrainSelectedInstOperands,
     /*  276358 */     // GIR_Coverage, 59985,
     /*  276358 */     GIR_EraseRootFromParent_Done,
     /*  276359 */   // Label 5513: @276359
     /*  276359 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(276425), // Rule ID 59988 //
     /*  276364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  276375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  276381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276403 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  276403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276423 */     GIR_RootConstrainSelectedInstOperands,
     /*  276424 */     // GIR_Coverage, 59988,
     /*  276424 */     GIR_EraseRootFromParent_Done,
     /*  276425 */   // Label 5514: @276425
     /*  276425 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(276491), // Rule ID 59989 //
     /*  276430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  276441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  276447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  276469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276489 */     GIR_RootConstrainSelectedInstOperands,
     /*  276490 */     // GIR_Coverage, 59989,
     /*  276490 */     GIR_EraseRootFromParent_Done,
     /*  276491 */   // Label 5515: @276491
     /*  276491 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(276557), // Rule ID 59992 //
     /*  276496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  276507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276535 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  276535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  276538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276555 */     GIR_RootConstrainSelectedInstOperands,
     /*  276556 */     // GIR_Coverage, 59992,
     /*  276556 */     GIR_EraseRootFromParent_Done,
     /*  276557 */   // Label 5516: @276557
     /*  276557 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(276623), // Rule ID 59993 //
     /*  276562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  276573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276601 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  276601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  276604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276621 */     GIR_RootConstrainSelectedInstOperands,
     /*  276622 */     // GIR_Coverage, 59993,
     /*  276622 */     GIR_EraseRootFromParent_Done,
     /*  276623 */   // Label 5517: @276623
     /*  276623 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(276689), // Rule ID 59996 //
     /*  276628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  276639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  276667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276687 */     GIR_RootConstrainSelectedInstOperands,
     /*  276688 */     // GIR_Coverage, 59996,
     /*  276688 */     GIR_EraseRootFromParent_Done,
     /*  276689 */   // Label 5518: @276689
     /*  276689 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(276755), // Rule ID 59997 //
     /*  276694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  276705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  276733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276753 */     GIR_RootConstrainSelectedInstOperands,
     /*  276754 */     // GIR_Coverage, 59997,
     /*  276754 */     GIR_EraseRootFromParent_Done,
     /*  276755 */   // Label 5519: @276755
     /*  276755 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(276821), // Rule ID 60000 //
     /*  276760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  276771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276799 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  276799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276819 */     GIR_RootConstrainSelectedInstOperands,
     /*  276820 */     // GIR_Coverage, 60000,
     /*  276820 */     GIR_EraseRootFromParent_Done,
     /*  276821 */   // Label 5520: @276821
     /*  276821 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(276887), // Rule ID 60001 //
     /*  276826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  276837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276865 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  276865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  276868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276885 */     GIR_RootConstrainSelectedInstOperands,
     /*  276886 */     // GIR_Coverage, 60001,
     /*  276886 */     GIR_EraseRootFromParent_Done,
     /*  276887 */   // Label 5521: @276887
     /*  276887 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(276953), // Rule ID 60004 //
     /*  276892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  276895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  276903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276931 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  276931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  276934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  276938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  276951 */     GIR_RootConstrainSelectedInstOperands,
     /*  276952 */     // GIR_Coverage, 60004,
     /*  276952 */     GIR_EraseRootFromParent_Done,
     /*  276953 */   // Label 5522: @276953
     /*  276953 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(277019), // Rule ID 60005 //
     /*  276958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  276961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  276966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  276969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276997 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10863:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  276997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277017 */     GIR_RootConstrainSelectedInstOperands,
     /*  277018 */     // GIR_Coverage, 60005,
     /*  277018 */     GIR_EraseRootFromParent_Done,
     /*  277019 */   // Label 5523: @277019
     /*  277019 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(277085), // Rule ID 60008 //
     /*  277024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  277035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  277041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277063 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  277063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277083 */     GIR_RootConstrainSelectedInstOperands,
     /*  277084 */     // GIR_Coverage, 60008,
     /*  277084 */     GIR_EraseRootFromParent_Done,
     /*  277085 */   // Label 5524: @277085
     /*  277085 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(277151), // Rule ID 60009 //
     /*  277090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  277101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  277107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277129 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  277129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277149 */     GIR_RootConstrainSelectedInstOperands,
     /*  277150 */     // GIR_Coverage, 60009,
     /*  277150 */     GIR_EraseRootFromParent_Done,
     /*  277151 */   // Label 5525: @277151
     /*  277151 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(277217), // Rule ID 60012 //
     /*  277156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  277167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  277173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277195 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  277195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277215 */     GIR_RootConstrainSelectedInstOperands,
     /*  277216 */     // GIR_Coverage, 60012,
     /*  277216 */     GIR_EraseRootFromParent_Done,
     /*  277217 */   // Label 5526: @277217
     /*  277217 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(277283), // Rule ID 60013 //
     /*  277222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  277233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  277239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  277261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277281 */     GIR_RootConstrainSelectedInstOperands,
     /*  277282 */     // GIR_Coverage, 60013,
     /*  277282 */     GIR_EraseRootFromParent_Done,
     /*  277283 */   // Label 5527: @277283
     /*  277283 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(277349), // Rule ID 60016 //
     /*  277288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  277299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  277305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  277327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277347 */     GIR_RootConstrainSelectedInstOperands,
     /*  277348 */     // GIR_Coverage, 60016,
     /*  277348 */     GIR_EraseRootFromParent_Done,
     /*  277349 */   // Label 5528: @277349
     /*  277349 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(277415), // Rule ID 60017 //
     /*  277354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  277365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  277371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  277393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  277396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277413 */     GIR_RootConstrainSelectedInstOperands,
     /*  277414 */     // GIR_Coverage, 60017,
     /*  277414 */     GIR_EraseRootFromParent_Done,
     /*  277415 */   // Label 5529: @277415
     /*  277415 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(277481), // Rule ID 60020 //
     /*  277420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  277431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  277437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  277459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  277462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277479 */     GIR_RootConstrainSelectedInstOperands,
     /*  277480 */     // GIR_Coverage, 60020,
     /*  277480 */     GIR_EraseRootFromParent_Done,
     /*  277481 */   // Label 5530: @277481
     /*  277481 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(277547), // Rule ID 60021 //
     /*  277486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  277497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  277503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  277525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  277528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277545 */     GIR_RootConstrainSelectedInstOperands,
     /*  277546 */     // GIR_Coverage, 60021,
     /*  277546 */     GIR_EraseRootFromParent_Done,
     /*  277547 */   // Label 5531: @277547
     /*  277547 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(277613), // Rule ID 60024 //
     /*  277552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  277563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277591 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  277591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  277594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277611 */     GIR_RootConstrainSelectedInstOperands,
     /*  277612 */     // GIR_Coverage, 60024,
     /*  277612 */     GIR_EraseRootFromParent_Done,
     /*  277613 */   // Label 5532: @277613
     /*  277613 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(277679), // Rule ID 60025 //
     /*  277618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  277629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277657 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  277657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  277660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277677 */     GIR_RootConstrainSelectedInstOperands,
     /*  277678 */     // GIR_Coverage, 60025,
     /*  277678 */     GIR_EraseRootFromParent_Done,
     /*  277679 */   // Label 5533: @277679
     /*  277679 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(277745), // Rule ID 60028 //
     /*  277684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  277695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277723 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  277723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  277726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277743 */     GIR_RootConstrainSelectedInstOperands,
     /*  277744 */     // GIR_Coverage, 60028,
     /*  277744 */     GIR_EraseRootFromParent_Done,
     /*  277745 */   // Label 5534: @277745
     /*  277745 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(277811), // Rule ID 60029 //
     /*  277750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  277761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  277789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  277792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277809 */     GIR_RootConstrainSelectedInstOperands,
     /*  277810 */     // GIR_Coverage, 60029,
     /*  277810 */     GIR_EraseRootFromParent_Done,
     /*  277811 */   // Label 5535: @277811
     /*  277811 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(277877), // Rule ID 60032 //
     /*  277816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  277827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  277855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  277858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277875 */     GIR_RootConstrainSelectedInstOperands,
     /*  277876 */     // GIR_Coverage, 60032,
     /*  277876 */     GIR_EraseRootFromParent_Done,
     /*  277877 */   // Label 5536: @277877
     /*  277877 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(277943), // Rule ID 60033 //
     /*  277882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  277885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  277893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  277921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  277924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  277941 */     GIR_RootConstrainSelectedInstOperands,
     /*  277942 */     // GIR_Coverage, 60033,
     /*  277942 */     GIR_EraseRootFromParent_Done,
     /*  277943 */   // Label 5537: @277943
     /*  277943 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(278009), // Rule ID 60036 //
     /*  277948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  277951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  277956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  277959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277987 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  277987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  277990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  277994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278007 */     GIR_RootConstrainSelectedInstOperands,
     /*  278008 */     // GIR_Coverage, 60036,
     /*  278008 */     GIR_EraseRootFromParent_Done,
     /*  278009 */   // Label 5538: @278009
     /*  278009 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(278075), // Rule ID 60037 //
     /*  278014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  278025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  278028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  278031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278053 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  278053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  278056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278073 */     GIR_RootConstrainSelectedInstOperands,
     /*  278074 */     // GIR_Coverage, 60037,
     /*  278074 */     GIR_EraseRootFromParent_Done,
     /*  278075 */   // Label 5539: @278075
     /*  278075 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(278141), // Rule ID 60040 //
     /*  278080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  278091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  278097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278119 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  278119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278139 */     GIR_RootConstrainSelectedInstOperands,
     /*  278140 */     // GIR_Coverage, 60040,
     /*  278140 */     GIR_EraseRootFromParent_Done,
     /*  278141 */   // Label 5540: @278141
     /*  278141 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(278207), // Rule ID 60041 //
     /*  278146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  278157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  278163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278185 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  278185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278205 */     GIR_RootConstrainSelectedInstOperands,
     /*  278206 */     // GIR_Coverage, 60041,
     /*  278206 */     GIR_EraseRootFromParent_Done,
     /*  278207 */   // Label 5541: @278207
     /*  278207 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(278273), // Rule ID 60044 //
     /*  278212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  278223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  278229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  278251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  278254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278271 */     GIR_RootConstrainSelectedInstOperands,
     /*  278272 */     // GIR_Coverage, 60044,
     /*  278272 */     GIR_EraseRootFromParent_Done,
     /*  278273 */   // Label 5542: @278273
     /*  278273 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(278339), // Rule ID 60045 //
     /*  278278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  278289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  278295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  278317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  278320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278337 */     GIR_RootConstrainSelectedInstOperands,
     /*  278338 */     // GIR_Coverage, 60045,
     /*  278338 */     GIR_EraseRootFromParent_Done,
     /*  278339 */   // Label 5543: @278339
     /*  278339 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(278405), // Rule ID 60048 //
     /*  278344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  278355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  278361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  278383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  278386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278403 */     GIR_RootConstrainSelectedInstOperands,
     /*  278404 */     // GIR_Coverage, 60048,
     /*  278404 */     GIR_EraseRootFromParent_Done,
     /*  278405 */   // Label 5544: @278405
     /*  278405 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(278471), // Rule ID 60049 //
     /*  278410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  278421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  278427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  278449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  278452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278469 */     GIR_RootConstrainSelectedInstOperands,
     /*  278470 */     // GIR_Coverage, 60049,
     /*  278470 */     GIR_EraseRootFromParent_Done,
     /*  278471 */   // Label 5545: @278471
     /*  278471 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(278537), // Rule ID 60052 //
     /*  278476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  278487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  278493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  278515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278535 */     GIR_RootConstrainSelectedInstOperands,
     /*  278536 */     // GIR_Coverage, 60052,
     /*  278536 */     GIR_EraseRootFromParent_Done,
     /*  278537 */   // Label 5546: @278537
     /*  278537 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(278603), // Rule ID 60053 //
     /*  278542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  278553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  278559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  278581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278601 */     GIR_RootConstrainSelectedInstOperands,
     /*  278602 */     // GIR_Coverage, 60053,
     /*  278602 */     GIR_EraseRootFromParent_Done,
     /*  278603 */   // Label 5547: @278603
     /*  278603 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(278669), // Rule ID 60056 //
     /*  278608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  278619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278647 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  278647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  278650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278667 */     GIR_RootConstrainSelectedInstOperands,
     /*  278668 */     // GIR_Coverage, 60056,
     /*  278668 */     GIR_EraseRootFromParent_Done,
     /*  278669 */   // Label 5548: @278669
     /*  278669 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(278735), // Rule ID 60057 //
     /*  278674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  278685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10863:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  278713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  278716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278733 */     GIR_RootConstrainSelectedInstOperands,
     /*  278734 */     // GIR_Coverage, 60057,
     /*  278734 */     GIR_EraseRootFromParent_Done,
     /*  278735 */   // Label 5549: @278735
     /*  278735 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(278801), // Rule ID 60060 //
     /*  278740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  278751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278779 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  278779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  278782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278799 */     GIR_RootConstrainSelectedInstOperands,
     /*  278800 */     // GIR_Coverage, 60060,
     /*  278800 */     GIR_EraseRootFromParent_Done,
     /*  278801 */   // Label 5550: @278801
     /*  278801 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(278867), // Rule ID 60061 //
     /*  278806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  278817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278845 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10863:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  278845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  278848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278865 */     GIR_RootConstrainSelectedInstOperands,
     /*  278866 */     // GIR_Coverage, 60061,
     /*  278866 */     GIR_EraseRootFromParent_Done,
     /*  278867 */   // Label 5551: @278867
     /*  278867 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(278933), // Rule ID 60064 //
     /*  278872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  278875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  278883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278911 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  278911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278931 */     GIR_RootConstrainSelectedInstOperands,
     /*  278932 */     // GIR_Coverage, 60064,
     /*  278932 */     GIR_EraseRootFromParent_Done,
     /*  278933 */   // Label 5552: @278933
     /*  278933 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(278999), // Rule ID 60065 //
     /*  278938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  278941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  278946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  278949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10863:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  278977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  278980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  278984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  278997 */     GIR_RootConstrainSelectedInstOperands,
     /*  278998 */     // GIR_Coverage, 60065,
     /*  278998 */     GIR_EraseRootFromParent_Done,
     /*  278999 */   // Label 5553: @278999
     /*  278999 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(279065), // Rule ID 60068 //
     /*  279004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  279015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279043 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  279043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  279046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279063 */     GIR_RootConstrainSelectedInstOperands,
     /*  279064 */     // GIR_Coverage, 60068,
     /*  279064 */     GIR_EraseRootFromParent_Done,
     /*  279065 */   // Label 5554: @279065
     /*  279065 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(279131), // Rule ID 60069 //
     /*  279070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  279081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279109 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  279109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  279112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279129 */     GIR_RootConstrainSelectedInstOperands,
     /*  279130 */     // GIR_Coverage, 60069,
     /*  279130 */     GIR_EraseRootFromParent_Done,
     /*  279131 */   // Label 5555: @279131
     /*  279131 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(279197), // Rule ID 60072 //
     /*  279136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  279147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279175 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  279175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  279178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279195 */     GIR_RootConstrainSelectedInstOperands,
     /*  279196 */     // GIR_Coverage, 60072,
     /*  279196 */     GIR_EraseRootFromParent_Done,
     /*  279197 */   // Label 5556: @279197
     /*  279197 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(279263), // Rule ID 60073 //
     /*  279202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  279213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279241 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  279241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  279244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279261 */     GIR_RootConstrainSelectedInstOperands,
     /*  279262 */     // GIR_Coverage, 60073,
     /*  279262 */     GIR_EraseRootFromParent_Done,
     /*  279263 */   // Label 5557: @279263
     /*  279263 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(279329), // Rule ID 60076 //
     /*  279268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  279279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279307 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  279307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279327 */     GIR_RootConstrainSelectedInstOperands,
     /*  279328 */     // GIR_Coverage, 60076,
     /*  279328 */     GIR_EraseRootFromParent_Done,
     /*  279329 */   // Label 5558: @279329
     /*  279329 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(279395), // Rule ID 60077 //
     /*  279334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  279345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279373 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  279373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279393 */     GIR_RootConstrainSelectedInstOperands,
     /*  279394 */     // GIR_Coverage, 60077,
     /*  279394 */     GIR_EraseRootFromParent_Done,
     /*  279395 */   // Label 5559: @279395
     /*  279395 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(279461), // Rule ID 60080 //
     /*  279400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  279411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279439 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  279439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  279442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279459 */     GIR_RootConstrainSelectedInstOperands,
     /*  279460 */     // GIR_Coverage, 60080,
     /*  279460 */     GIR_EraseRootFromParent_Done,
     /*  279461 */   // Label 5560: @279461
     /*  279461 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(279527), // Rule ID 60081 //
     /*  279466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  279477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279505 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  279505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  279508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279525 */     GIR_RootConstrainSelectedInstOperands,
     /*  279526 */     // GIR_Coverage, 60081,
     /*  279526 */     GIR_EraseRootFromParent_Done,
     /*  279527 */   // Label 5561: @279527
     /*  279527 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(279593), // Rule ID 60084 //
     /*  279532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  279543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  279571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279591 */     GIR_RootConstrainSelectedInstOperands,
     /*  279592 */     // GIR_Coverage, 60084,
     /*  279592 */     GIR_EraseRootFromParent_Done,
     /*  279593 */   // Label 5562: @279593
     /*  279593 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(279659), // Rule ID 60085 //
     /*  279598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  279609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279637 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  279637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279657 */     GIR_RootConstrainSelectedInstOperands,
     /*  279658 */     // GIR_Coverage, 60085,
     /*  279658 */     GIR_EraseRootFromParent_Done,
     /*  279659 */   // Label 5563: @279659
     /*  279659 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(279725), // Rule ID 60088 //
     /*  279664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  279675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  279703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279723 */     GIR_RootConstrainSelectedInstOperands,
     /*  279724 */     // GIR_Coverage, 60088,
     /*  279724 */     GIR_EraseRootFromParent_Done,
     /*  279725 */   // Label 5564: @279725
     /*  279725 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(279791), // Rule ID 60089 //
     /*  279730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  279741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  279769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  279772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279789 */     GIR_RootConstrainSelectedInstOperands,
     /*  279790 */     // GIR_Coverage, 60089,
     /*  279790 */     GIR_EraseRootFromParent_Done,
     /*  279791 */   // Label 5565: @279791
     /*  279791 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(279857), // Rule ID 60092 //
     /*  279796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  279807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279835 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  279835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  279838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279855 */     GIR_RootConstrainSelectedInstOperands,
     /*  279856 */     // GIR_Coverage, 60092,
     /*  279856 */     GIR_EraseRootFromParent_Done,
     /*  279857 */   // Label 5566: @279857
     /*  279857 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(279923), // Rule ID 60093 //
     /*  279862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  279873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10870:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  279901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  279904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279921 */     GIR_RootConstrainSelectedInstOperands,
     /*  279922 */     // GIR_Coverage, 60093,
     /*  279922 */     GIR_EraseRootFromParent_Done,
     /*  279923 */   // Label 5567: @279923
     /*  279923 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(279989), // Rule ID 60096 //
     /*  279928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  279931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  279936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  279939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  279945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279967 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  279967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  279970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  279974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  279987 */     GIR_RootConstrainSelectedInstOperands,
     /*  279988 */     // GIR_Coverage, 60096,
     /*  279988 */     GIR_EraseRootFromParent_Done,
     /*  279989 */   // Label 5568: @279989
     /*  279989 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(280055), // Rule ID 60097 //
     /*  279994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  279997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  280005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  280008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  280011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  280033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  280036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280053 */     GIR_RootConstrainSelectedInstOperands,
     /*  280054 */     // GIR_Coverage, 60097,
     /*  280054 */     GIR_EraseRootFromParent_Done,
     /*  280055 */   // Label 5569: @280055
     /*  280055 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(280121), // Rule ID 60100 //
     /*  280060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  280071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  280099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  280102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280119 */     GIR_RootConstrainSelectedInstOperands,
     /*  280120 */     // GIR_Coverage, 60100,
     /*  280120 */     GIR_EraseRootFromParent_Done,
     /*  280121 */   // Label 5570: @280121
     /*  280121 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(280187), // Rule ID 60101 //
     /*  280126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  280137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  280165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  280168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280185 */     GIR_RootConstrainSelectedInstOperands,
     /*  280186 */     // GIR_Coverage, 60101,
     /*  280186 */     GIR_EraseRootFromParent_Done,
     /*  280187 */   // Label 5571: @280187
     /*  280187 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(280253), // Rule ID 60104 //
     /*  280192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  280203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280231 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  280231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  280234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280251 */     GIR_RootConstrainSelectedInstOperands,
     /*  280252 */     // GIR_Coverage, 60104,
     /*  280252 */     GIR_EraseRootFromParent_Done,
     /*  280253 */   // Label 5572: @280253
     /*  280253 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(280319), // Rule ID 60105 //
     /*  280258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  280269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280297 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  280297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  280300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280317 */     GIR_RootConstrainSelectedInstOperands,
     /*  280318 */     // GIR_Coverage, 60105,
     /*  280318 */     GIR_EraseRootFromParent_Done,
     /*  280319 */   // Label 5573: @280319
     /*  280319 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(280385), // Rule ID 60108 //
     /*  280324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  280335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  280363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  280366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280383 */     GIR_RootConstrainSelectedInstOperands,
     /*  280384 */     // GIR_Coverage, 60108,
     /*  280384 */     GIR_EraseRootFromParent_Done,
     /*  280385 */   // Label 5574: @280385
     /*  280385 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(280451), // Rule ID 60109 //
     /*  280390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  280401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  280429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  280432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280449 */     GIR_RootConstrainSelectedInstOperands,
     /*  280450 */     // GIR_Coverage, 60109,
     /*  280450 */     GIR_EraseRootFromParent_Done,
     /*  280451 */   // Label 5575: @280451
     /*  280451 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(280517), // Rule ID 60112 //
     /*  280456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  280467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280495 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  280495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  280498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280515 */     GIR_RootConstrainSelectedInstOperands,
     /*  280516 */     // GIR_Coverage, 60112,
     /*  280516 */     GIR_EraseRootFromParent_Done,
     /*  280517 */   // Label 5576: @280517
     /*  280517 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(280583), // Rule ID 60113 //
     /*  280522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  280533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280561 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  280561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  280564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280581 */     GIR_RootConstrainSelectedInstOperands,
     /*  280582 */     // GIR_Coverage, 60113,
     /*  280582 */     GIR_EraseRootFromParent_Done,
     /*  280583 */   // Label 5577: @280583
     /*  280583 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(280649), // Rule ID 60116 //
     /*  280588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  280599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280627 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  280627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  280630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280647 */     GIR_RootConstrainSelectedInstOperands,
     /*  280648 */     // GIR_Coverage, 60116,
     /*  280648 */     GIR_EraseRootFromParent_Done,
     /*  280649 */   // Label 5578: @280649
     /*  280649 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(280715), // Rule ID 60117 //
     /*  280654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  280665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  280693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  280696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280713 */     GIR_RootConstrainSelectedInstOperands,
     /*  280714 */     // GIR_Coverage, 60117,
     /*  280714 */     GIR_EraseRootFromParent_Done,
     /*  280715 */   // Label 5579: @280715
     /*  280715 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(280781), // Rule ID 60120 //
     /*  280720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  280731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  280759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  280762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280779 */     GIR_RootConstrainSelectedInstOperands,
     /*  280780 */     // GIR_Coverage, 60120,
     /*  280780 */     GIR_EraseRootFromParent_Done,
     /*  280781 */   // Label 5580: @280781
     /*  280781 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(280847), // Rule ID 60121 //
     /*  280786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  280797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  280825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  280828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280845 */     GIR_RootConstrainSelectedInstOperands,
     /*  280846 */     // GIR_Coverage, 60121,
     /*  280846 */     GIR_EraseRootFromParent_Done,
     /*  280847 */   // Label 5581: @280847
     /*  280847 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(280913), // Rule ID 60124 //
     /*  280852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  280863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280891 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  280891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  280894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280911 */     GIR_RootConstrainSelectedInstOperands,
     /*  280912 */     // GIR_Coverage, 60124,
     /*  280912 */     GIR_EraseRootFromParent_Done,
     /*  280913 */   // Label 5582: @280913
     /*  280913 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(280979), // Rule ID 60125 //
     /*  280918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  280921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  280929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280957 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  280957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  280960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  280964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  280977 */     GIR_RootConstrainSelectedInstOperands,
     /*  280978 */     // GIR_Coverage, 60125,
     /*  280978 */     GIR_EraseRootFromParent_Done,
     /*  280979 */   // Label 5583: @280979
     /*  280979 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(281045), // Rule ID 60128 //
     /*  280984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  280987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  280992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  280995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  281001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  281023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281043 */     GIR_RootConstrainSelectedInstOperands,
     /*  281044 */     // GIR_Coverage, 60128,
     /*  281044 */     GIR_EraseRootFromParent_Done,
     /*  281045 */   // Label 5584: @281045
     /*  281045 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(281111), // Rule ID 60129 //
     /*  281050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  281061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  281064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  281067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  281089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281109 */     GIR_RootConstrainSelectedInstOperands,
     /*  281110 */     // GIR_Coverage, 60129,
     /*  281110 */     GIR_EraseRootFromParent_Done,
     /*  281111 */   // Label 5585: @281111
     /*  281111 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(281177), // Rule ID 60132 //
     /*  281116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  281127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  281155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  281158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281175 */     GIR_RootConstrainSelectedInstOperands,
     /*  281176 */     // GIR_Coverage, 60132,
     /*  281176 */     GIR_EraseRootFromParent_Done,
     /*  281177 */   // Label 5586: @281177
     /*  281177 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(281243), // Rule ID 60133 //
     /*  281182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  281193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  281221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  281224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281241 */     GIR_RootConstrainSelectedInstOperands,
     /*  281242 */     // GIR_Coverage, 60133,
     /*  281242 */     GIR_EraseRootFromParent_Done,
     /*  281243 */   // Label 5587: @281243
     /*  281243 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(281309), // Rule ID 60136 //
     /*  281248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  281259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281287 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  281287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  281290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281307 */     GIR_RootConstrainSelectedInstOperands,
     /*  281308 */     // GIR_Coverage, 60136,
     /*  281308 */     GIR_EraseRootFromParent_Done,
     /*  281309 */   // Label 5588: @281309
     /*  281309 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(281375), // Rule ID 60137 //
     /*  281314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  281325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  281353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  281356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281373 */     GIR_RootConstrainSelectedInstOperands,
     /*  281374 */     // GIR_Coverage, 60137,
     /*  281374 */     GIR_EraseRootFromParent_Done,
     /*  281375 */   // Label 5589: @281375
     /*  281375 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(281441), // Rule ID 60140 //
     /*  281380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  281391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  281419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281439 */     GIR_RootConstrainSelectedInstOperands,
     /*  281440 */     // GIR_Coverage, 60140,
     /*  281440 */     GIR_EraseRootFromParent_Done,
     /*  281441 */   // Label 5590: @281441
     /*  281441 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(281507), // Rule ID 60141 //
     /*  281446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  281457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  281485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281505 */     GIR_RootConstrainSelectedInstOperands,
     /*  281506 */     // GIR_Coverage, 60141,
     /*  281506 */     GIR_EraseRootFromParent_Done,
     /*  281507 */   // Label 5591: @281507
     /*  281507 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(281573), // Rule ID 60144 //
     /*  281512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  281523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  281551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  281554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281571 */     GIR_RootConstrainSelectedInstOperands,
     /*  281572 */     // GIR_Coverage, 60144,
     /*  281572 */     GIR_EraseRootFromParent_Done,
     /*  281573 */   // Label 5592: @281573
     /*  281573 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(281639), // Rule ID 60145 //
     /*  281578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  281589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281617 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  281617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  281620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281637 */     GIR_RootConstrainSelectedInstOperands,
     /*  281638 */     // GIR_Coverage, 60145,
     /*  281638 */     GIR_EraseRootFromParent_Done,
     /*  281639 */   // Label 5593: @281639
     /*  281639 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(281705), // Rule ID 60148 //
     /*  281644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  281655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281683 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  281683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  281686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281703 */     GIR_RootConstrainSelectedInstOperands,
     /*  281704 */     // GIR_Coverage, 60148,
     /*  281704 */     GIR_EraseRootFromParent_Done,
     /*  281705 */   // Label 5594: @281705
     /*  281705 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(281771), // Rule ID 60149 //
     /*  281710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  281721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281749 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  281749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  281752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281769 */     GIR_RootConstrainSelectedInstOperands,
     /*  281770 */     // GIR_Coverage, 60149,
     /*  281770 */     GIR_EraseRootFromParent_Done,
     /*  281771 */   // Label 5595: @281771
     /*  281771 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(281837), // Rule ID 60152 //
     /*  281776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  281787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  281815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281835 */     GIR_RootConstrainSelectedInstOperands,
     /*  281836 */     // GIR_Coverage, 60152,
     /*  281836 */     GIR_EraseRootFromParent_Done,
     /*  281837 */   // Label 5596: @281837
     /*  281837 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(281903), // Rule ID 60153 //
     /*  281842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  281850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  281853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  281881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  281884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281901 */     GIR_RootConstrainSelectedInstOperands,
     /*  281902 */     // GIR_Coverage, 60153,
     /*  281902 */     GIR_EraseRootFromParent_Done,
     /*  281903 */   // Label 5597: @281903
     /*  281903 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(281969), // Rule ID 60156 //
     /*  281908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  281911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  281916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  281919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281947 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  281947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  281950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  281954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  281967 */     GIR_RootConstrainSelectedInstOperands,
     /*  281968 */     // GIR_Coverage, 60156,
     /*  281968 */     GIR_EraseRootFromParent_Done,
     /*  281969 */   // Label 5598: @281969
     /*  281969 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(282035), // Rule ID 60157 //
     /*  281974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  281977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  281982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  281985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282013 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  282013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  282016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282033 */     GIR_RootConstrainSelectedInstOperands,
     /*  282034 */     // GIR_Coverage, 60157,
     /*  282034 */     GIR_EraseRootFromParent_Done,
     /*  282035 */   // Label 5599: @282035
     /*  282035 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(282101), // Rule ID 60160 //
     /*  282040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  282051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  282054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  282057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282079 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  282079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  282082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282099 */     GIR_RootConstrainSelectedInstOperands,
     /*  282100 */     // GIR_Coverage, 60160,
     /*  282100 */     GIR_EraseRootFromParent_Done,
     /*  282101 */   // Label 5600: @282101
     /*  282101 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(282167), // Rule ID 60161 //
     /*  282106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  282117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  282120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  282123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282145 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  282145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  282148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282165 */     GIR_RootConstrainSelectedInstOperands,
     /*  282166 */     // GIR_Coverage, 60161,
     /*  282166 */     GIR_EraseRootFromParent_Done,
     /*  282167 */   // Label 5601: @282167
     /*  282167 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(282233), // Rule ID 60164 //
     /*  282172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  282183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  282189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282211 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  282211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282231 */     GIR_RootConstrainSelectedInstOperands,
     /*  282232 */     // GIR_Coverage, 60164,
     /*  282232 */     GIR_EraseRootFromParent_Done,
     /*  282233 */   // Label 5602: @282233
     /*  282233 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(282299), // Rule ID 60165 //
     /*  282238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  282249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  282255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282277 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  282277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282297 */     GIR_RootConstrainSelectedInstOperands,
     /*  282298 */     // GIR_Coverage, 60165,
     /*  282298 */     GIR_EraseRootFromParent_Done,
     /*  282299 */   // Label 5603: @282299
     /*  282299 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(282365), // Rule ID 60168 //
     /*  282304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  282315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  282321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  282343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  282346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282363 */     GIR_RootConstrainSelectedInstOperands,
     /*  282364 */     // GIR_Coverage, 60168,
     /*  282364 */     GIR_EraseRootFromParent_Done,
     /*  282365 */   // Label 5604: @282365
     /*  282365 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(282431), // Rule ID 60169 //
     /*  282370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  282381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  282387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  282409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  282412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282429 */     GIR_RootConstrainSelectedInstOperands,
     /*  282430 */     // GIR_Coverage, 60169,
     /*  282430 */     GIR_EraseRootFromParent_Done,
     /*  282431 */   // Label 5605: @282431
     /*  282431 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(282497), // Rule ID 60172 //
     /*  282436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  282447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  282453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282475 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  282475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282495 */     GIR_RootConstrainSelectedInstOperands,
     /*  282496 */     // GIR_Coverage, 60172,
     /*  282496 */     GIR_EraseRootFromParent_Done,
     /*  282497 */   // Label 5606: @282497
     /*  282497 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(282563), // Rule ID 60173 //
     /*  282502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  282513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  282519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282541 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  282541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282561 */     GIR_RootConstrainSelectedInstOperands,
     /*  282562 */     // GIR_Coverage, 60173,
     /*  282562 */     GIR_EraseRootFromParent_Done,
     /*  282563 */   // Label 5607: @282563
     /*  282563 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(282629), // Rule ID 60176 //
     /*  282568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  282579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  282585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282607 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  282607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282627 */     GIR_RootConstrainSelectedInstOperands,
     /*  282628 */     // GIR_Coverage, 60176,
     /*  282628 */     GIR_EraseRootFromParent_Done,
     /*  282629 */   // Label 5608: @282629
     /*  282629 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(282695), // Rule ID 60177 //
     /*  282634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  282645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  282651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282673 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  282673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  282676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282693 */     GIR_RootConstrainSelectedInstOperands,
     /*  282694 */     // GIR_Coverage, 60177,
     /*  282694 */     GIR_EraseRootFromParent_Done,
     /*  282695 */   // Label 5609: @282695
     /*  282695 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(282761), // Rule ID 60180 //
     /*  282700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  282711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  282739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  282742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282759 */     GIR_RootConstrainSelectedInstOperands,
     /*  282760 */     // GIR_Coverage, 60180,
     /*  282760 */     GIR_EraseRootFromParent_Done,
     /*  282761 */   // Label 5610: @282761
     /*  282761 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(282827), // Rule ID 60181 //
     /*  282766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  282777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282805 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10868:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  282805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  282808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282825 */     GIR_RootConstrainSelectedInstOperands,
     /*  282826 */     // GIR_Coverage, 60181,
     /*  282826 */     GIR_EraseRootFromParent_Done,
     /*  282827 */   // Label 5611: @282827
     /*  282827 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(282893), // Rule ID 60184 //
     /*  282832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  282843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282871 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  282871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  282874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282891 */     GIR_RootConstrainSelectedInstOperands,
     /*  282892 */     // GIR_Coverage, 60184,
     /*  282892 */     GIR_EraseRootFromParent_Done,
     /*  282893 */   // Label 5612: @282893
     /*  282893 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(282959), // Rule ID 60185 //
     /*  282898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  282901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  282909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282937 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  282937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  282940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  282944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  282957 */     GIR_RootConstrainSelectedInstOperands,
     /*  282958 */     // GIR_Coverage, 60185,
     /*  282958 */     GIR_EraseRootFromParent_Done,
     /*  282959 */   // Label 5613: @282959
     /*  282959 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(283025), // Rule ID 60188 //
     /*  282964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  282967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  282972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  282975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  282981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283003 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  283003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  283006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283023 */     GIR_RootConstrainSelectedInstOperands,
     /*  283024 */     // GIR_Coverage, 60188,
     /*  283024 */     GIR_EraseRootFromParent_Done,
     /*  283025 */   // Label 5614: @283025
     /*  283025 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(283091), // Rule ID 60189 //
     /*  283030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  283041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  283044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  283047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283069 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  283069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  283072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283089 */     GIR_RootConstrainSelectedInstOperands,
     /*  283090 */     // GIR_Coverage, 60189,
     /*  283090 */     GIR_EraseRootFromParent_Done,
     /*  283091 */   // Label 5615: @283091
     /*  283091 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(283157), // Rule ID 60192 //
     /*  283096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  283107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  283110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  283113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283135 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  283135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  283138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283155 */     GIR_RootConstrainSelectedInstOperands,
     /*  283156 */     // GIR_Coverage, 60192,
     /*  283156 */     GIR_EraseRootFromParent_Done,
     /*  283157 */   // Label 5616: @283157
     /*  283157 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(283223), // Rule ID 60193 //
     /*  283162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  283173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  283176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  283179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283201 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  283201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  283204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283221 */     GIR_RootConstrainSelectedInstOperands,
     /*  283222 */     // GIR_Coverage, 60193,
     /*  283222 */     GIR_EraseRootFromParent_Done,
     /*  283223 */   // Label 5617: @283223
     /*  283223 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(283289), // Rule ID 60196 //
     /*  283228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  283239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  283245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283267 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  283267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  283270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283287 */     GIR_RootConstrainSelectedInstOperands,
     /*  283288 */     // GIR_Coverage, 60196,
     /*  283288 */     GIR_EraseRootFromParent_Done,
     /*  283289 */   // Label 5618: @283289
     /*  283289 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(283355), // Rule ID 60197 //
     /*  283294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  283305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  283311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283333 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  283333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  283336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283353 */     GIR_RootConstrainSelectedInstOperands,
     /*  283354 */     // GIR_Coverage, 60197,
     /*  283354 */     GIR_EraseRootFromParent_Done,
     /*  283355 */   // Label 5619: @283355
     /*  283355 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(283421), // Rule ID 60200 //
     /*  283360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  283371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  283377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283399 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  283399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  283402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283419 */     GIR_RootConstrainSelectedInstOperands,
     /*  283420 */     // GIR_Coverage, 60200,
     /*  283420 */     GIR_EraseRootFromParent_Done,
     /*  283421 */   // Label 5620: @283421
     /*  283421 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(283487), // Rule ID 60201 //
     /*  283426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  283437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  283443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283465 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  283465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  283468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283485 */     GIR_RootConstrainSelectedInstOperands,
     /*  283486 */     // GIR_Coverage, 60201,
     /*  283486 */     GIR_EraseRootFromParent_Done,
     /*  283487 */   // Label 5621: @283487
     /*  283487 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(283553), // Rule ID 60204 //
     /*  283492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  283503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  283509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283531 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  283531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  283534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283551 */     GIR_RootConstrainSelectedInstOperands,
     /*  283552 */     // GIR_Coverage, 60204,
     /*  283552 */     GIR_EraseRootFromParent_Done,
     /*  283553 */   // Label 5622: @283553
     /*  283553 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(283619), // Rule ID 60205 //
     /*  283558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  283569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  283575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283597 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  283597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  283600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283617 */     GIR_RootConstrainSelectedInstOperands,
     /*  283618 */     // GIR_Coverage, 60205,
     /*  283618 */     GIR_EraseRootFromParent_Done,
     /*  283619 */   // Label 5623: @283619
     /*  283619 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(283685), // Rule ID 60208 //
     /*  283624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  283635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  283641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  283663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  283666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283683 */     GIR_RootConstrainSelectedInstOperands,
     /*  283684 */     // GIR_Coverage, 60208,
     /*  283684 */     GIR_EraseRootFromParent_Done,
     /*  283685 */   // Label 5624: @283685
     /*  283685 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(283751), // Rule ID 60209 //
     /*  283690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  283701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  283707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  283729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  283732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283749 */     GIR_RootConstrainSelectedInstOperands,
     /*  283750 */     // GIR_Coverage, 60209,
     /*  283750 */     GIR_EraseRootFromParent_Done,
     /*  283751 */   // Label 5625: @283751
     /*  283751 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(283817), // Rule ID 60212 //
     /*  283756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  283767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283795 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  283795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  283798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283815 */     GIR_RootConstrainSelectedInstOperands,
     /*  283816 */     // GIR_Coverage, 60212,
     /*  283816 */     GIR_EraseRootFromParent_Done,
     /*  283817 */   // Label 5626: @283817
     /*  283817 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(283883), // Rule ID 60213 //
     /*  283822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  283833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  283861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  283864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283881 */     GIR_RootConstrainSelectedInstOperands,
     /*  283882 */     // GIR_Coverage, 60213,
     /*  283882 */     GIR_EraseRootFromParent_Done,
     /*  283883 */   // Label 5627: @283883
     /*  283883 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(283949), // Rule ID 60216 //
     /*  283888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  283891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  283899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  283927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  283930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  283934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  283947 */     GIR_RootConstrainSelectedInstOperands,
     /*  283948 */     // GIR_Coverage, 60216,
     /*  283948 */     GIR_EraseRootFromParent_Done,
     /*  283949 */   // Label 5628: @283949
     /*  283949 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(284015), // Rule ID 60217 //
     /*  283954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  283957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  283962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  283965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283993 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  283993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  283996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284013 */     GIR_RootConstrainSelectedInstOperands,
     /*  284014 */     // GIR_Coverage, 60217,
     /*  284014 */     GIR_EraseRootFromParent_Done,
     /*  284015 */   // Label 5629: @284015
     /*  284015 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(284081), // Rule ID 60220 //
     /*  284020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  284031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  284034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  284037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  284059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  284062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284079 */     GIR_RootConstrainSelectedInstOperands,
     /*  284080 */     // GIR_Coverage, 60220,
     /*  284080 */     GIR_EraseRootFromParent_Done,
     /*  284081 */   // Label 5630: @284081
     /*  284081 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(284147), // Rule ID 60221 //
     /*  284086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  284097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  284100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  284103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  284125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  284128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284145 */     GIR_RootConstrainSelectedInstOperands,
     /*  284146 */     // GIR_Coverage, 60221,
     /*  284146 */     GIR_EraseRootFromParent_Done,
     /*  284147 */   // Label 5631: @284147
     /*  284147 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(284213), // Rule ID 60224 //
     /*  284152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  284163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  284166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  284169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  284191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  284194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284211 */     GIR_RootConstrainSelectedInstOperands,
     /*  284212 */     // GIR_Coverage, 60224,
     /*  284212 */     GIR_EraseRootFromParent_Done,
     /*  284213 */   // Label 5632: @284213
     /*  284213 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(284279), // Rule ID 60225 //
     /*  284218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  284229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  284232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  284235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284257 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  284257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  284260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284277 */     GIR_RootConstrainSelectedInstOperands,
     /*  284278 */     // GIR_Coverage, 60225,
     /*  284278 */     GIR_EraseRootFromParent_Done,
     /*  284279 */   // Label 5633: @284279
     /*  284279 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(284345), // Rule ID 60228 //
     /*  284284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  284295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  284301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  284323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  284326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284343 */     GIR_RootConstrainSelectedInstOperands,
     /*  284344 */     // GIR_Coverage, 60228,
     /*  284344 */     GIR_EraseRootFromParent_Done,
     /*  284345 */   // Label 5634: @284345
     /*  284345 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(284411), // Rule ID 60229 //
     /*  284350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  284361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  284367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284389 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  284389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  284392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284409 */     GIR_RootConstrainSelectedInstOperands,
     /*  284410 */     // GIR_Coverage, 60229,
     /*  284410 */     GIR_EraseRootFromParent_Done,
     /*  284411 */   // Label 5635: @284411
     /*  284411 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(284477), // Rule ID 60232 //
     /*  284416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  284427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  284433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  284455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  284458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284475 */     GIR_RootConstrainSelectedInstOperands,
     /*  284476 */     // GIR_Coverage, 60232,
     /*  284476 */     GIR_EraseRootFromParent_Done,
     /*  284477 */   // Label 5636: @284477
     /*  284477 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(284543), // Rule ID 60233 //
     /*  284482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  284493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  284499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  284521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  284524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284541 */     GIR_RootConstrainSelectedInstOperands,
     /*  284542 */     // GIR_Coverage, 60233,
     /*  284542 */     GIR_EraseRootFromParent_Done,
     /*  284543 */   // Label 5637: @284543
     /*  284543 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(284609), // Rule ID 60236 //
     /*  284548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  284559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  284565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284587 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  284587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  284590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284607 */     GIR_RootConstrainSelectedInstOperands,
     /*  284608 */     // GIR_Coverage, 60236,
     /*  284608 */     GIR_EraseRootFromParent_Done,
     /*  284609 */   // Label 5638: @284609
     /*  284609 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(284675), // Rule ID 60237 //
     /*  284614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  284625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  284631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284653 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  284653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  284656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284673 */     GIR_RootConstrainSelectedInstOperands,
     /*  284674 */     // GIR_Coverage, 60237,
     /*  284674 */     GIR_EraseRootFromParent_Done,
     /*  284675 */   // Label 5639: @284675
     /*  284675 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(284741), // Rule ID 60240 //
     /*  284680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  284683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  284691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  284697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284719 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  284719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  284722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284739 */     GIR_RootConstrainSelectedInstOperands,
     /*  284740 */     // GIR_Coverage, 60240,
     /*  284740 */     GIR_EraseRootFromParent_Done,
     /*  284741 */   // Label 5640: @284741
     /*  284741 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(284807), // Rule ID 60241 //
     /*  284746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  284749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  284754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  284757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  284763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284785 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  284785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  284788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284805 */     GIR_RootConstrainSelectedInstOperands,
     /*  284806 */     // GIR_Coverage, 60241,
     /*  284806 */     GIR_EraseRootFromParent_Done,
     /*  284807 */   // Label 5641: @284807
     /*  284807 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(284873), // Rule ID 60664 //
     /*  284812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  284815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  284820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  284823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284851 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  284851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  284854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284871 */     GIR_RootConstrainSelectedInstOperands,
     /*  284872 */     // GIR_Coverage, 60664,
     /*  284872 */     GIR_EraseRootFromParent_Done,
     /*  284873 */   // Label 5642: @284873
     /*  284873 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(284939), // Rule ID 60665 //
     /*  284878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  284881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  284886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  284889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284917 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  284917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  284920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  284937 */     GIR_RootConstrainSelectedInstOperands,
     /*  284938 */     // GIR_Coverage, 60665,
     /*  284938 */     GIR_EraseRootFromParent_Done,
     /*  284939 */   // Label 5643: @284939
     /*  284939 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(285005), // Rule ID 60668 //
     /*  284944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  284947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  284952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  284955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  284961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  284983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  284986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  284990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285003 */     GIR_RootConstrainSelectedInstOperands,
     /*  285004 */     // GIR_Coverage, 60668,
     /*  285004 */     GIR_EraseRootFromParent_Done,
     /*  285005 */   // Label 5644: @285005
     /*  285005 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(285071), // Rule ID 60669 //
     /*  285010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  285021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  285024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  285027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  285049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  285052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285069 */     GIR_RootConstrainSelectedInstOperands,
     /*  285070 */     // GIR_Coverage, 60669,
     /*  285070 */     GIR_EraseRootFromParent_Done,
     /*  285071 */   // Label 5645: @285071
     /*  285071 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(285137), // Rule ID 60672 //
     /*  285076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  285087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  285090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  285093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285115 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  285115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285135 */     GIR_RootConstrainSelectedInstOperands,
     /*  285136 */     // GIR_Coverage, 60672,
     /*  285136 */     GIR_EraseRootFromParent_Done,
     /*  285137 */   // Label 5646: @285137
     /*  285137 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(285203), // Rule ID 60673 //
     /*  285142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  285153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  285156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  285159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285181 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  285181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285201 */     GIR_RootConstrainSelectedInstOperands,
     /*  285202 */     // GIR_Coverage, 60673,
     /*  285202 */     GIR_EraseRootFromParent_Done,
     /*  285203 */   // Label 5647: @285203
     /*  285203 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(285269), // Rule ID 60676 //
     /*  285208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  285219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  285222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285247 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  285247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  285250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285267 */     GIR_RootConstrainSelectedInstOperands,
     /*  285268 */     // GIR_Coverage, 60676,
     /*  285268 */     GIR_EraseRootFromParent_Done,
     /*  285269 */   // Label 5648: @285269
     /*  285269 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(285335), // Rule ID 60677 //
     /*  285274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  285285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  285288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285313 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  285313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  285316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285333 */     GIR_RootConstrainSelectedInstOperands,
     /*  285334 */     // GIR_Coverage, 60677,
     /*  285334 */     GIR_EraseRootFromParent_Done,
     /*  285335 */   // Label 5649: @285335
     /*  285335 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(285401), // Rule ID 60680 //
     /*  285340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  285351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285379 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  285379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285399 */     GIR_RootConstrainSelectedInstOperands,
     /*  285400 */     // GIR_Coverage, 60680,
     /*  285400 */     GIR_EraseRootFromParent_Done,
     /*  285401 */   // Label 5650: @285401
     /*  285401 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(285467), // Rule ID 60681 //
     /*  285406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  285417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  285445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285465 */     GIR_RootConstrainSelectedInstOperands,
     /*  285466 */     // GIR_Coverage, 60681,
     /*  285466 */     GIR_EraseRootFromParent_Done,
     /*  285467 */   // Label 5651: @285467
     /*  285467 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(285533), // Rule ID 60684 //
     /*  285472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  285483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  285511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285531 */     GIR_RootConstrainSelectedInstOperands,
     /*  285532 */     // GIR_Coverage, 60684,
     /*  285532 */     GIR_EraseRootFromParent_Done,
     /*  285533 */   // Label 5652: @285533
     /*  285533 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(285599), // Rule ID 60685 //
     /*  285538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  285549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  285577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  285580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285597 */     GIR_RootConstrainSelectedInstOperands,
     /*  285598 */     // GIR_Coverage, 60685,
     /*  285598 */     GIR_EraseRootFromParent_Done,
     /*  285599 */   // Label 5653: @285599
     /*  285599 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(285665), // Rule ID 60688 //
     /*  285604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  285615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285643 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  285643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285663 */     GIR_RootConstrainSelectedInstOperands,
     /*  285664 */     // GIR_Coverage, 60688,
     /*  285664 */     GIR_EraseRootFromParent_Done,
     /*  285665 */   // Label 5654: @285665
     /*  285665 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(285731), // Rule ID 60689 //
     /*  285670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  285681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285709 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10857:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  285709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285729 */     GIR_RootConstrainSelectedInstOperands,
     /*  285730 */     // GIR_Coverage, 60689,
     /*  285730 */     GIR_EraseRootFromParent_Done,
     /*  285731 */   // Label 5655: @285731
     /*  285731 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(285797), // Rule ID 60692 //
     /*  285736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  285747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  285775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285795 */     GIR_RootConstrainSelectedInstOperands,
     /*  285796 */     // GIR_Coverage, 60692,
     /*  285796 */     GIR_EraseRootFromParent_Done,
     /*  285797 */   // Label 5656: @285797
     /*  285797 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(285863), // Rule ID 60693 //
     /*  285802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  285813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285841 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  285841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285861 */     GIR_RootConstrainSelectedInstOperands,
     /*  285862 */     // GIR_Coverage, 60693,
     /*  285862 */     GIR_EraseRootFromParent_Done,
     /*  285863 */   // Label 5657: @285863
     /*  285863 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(285929), // Rule ID 60696 //
     /*  285868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  285871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  285879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  285907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285927 */     GIR_RootConstrainSelectedInstOperands,
     /*  285928 */     // GIR_Coverage, 60696,
     /*  285928 */     GIR_EraseRootFromParent_Done,
     /*  285929 */   // Label 5658: @285929
     /*  285929 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(285995), // Rule ID 60697 //
     /*  285934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  285937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  285942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  285945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285973 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  285973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  285976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  285980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  285993 */     GIR_RootConstrainSelectedInstOperands,
     /*  285994 */     // GIR_Coverage, 60697,
     /*  285994 */     GIR_EraseRootFromParent_Done,
     /*  285995 */   // Label 5659: @285995
     /*  285995 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(286061), // Rule ID 60700 //
     /*  286000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  286011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  286014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  286017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286039 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  286039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  286042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286059 */     GIR_RootConstrainSelectedInstOperands,
     /*  286060 */     // GIR_Coverage, 60700,
     /*  286060 */     GIR_EraseRootFromParent_Done,
     /*  286061 */   // Label 5660: @286061
     /*  286061 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(286127), // Rule ID 60701 //
     /*  286066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  286077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  286080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  286083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286105 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  286105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  286108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286125 */     GIR_RootConstrainSelectedInstOperands,
     /*  286126 */     // GIR_Coverage, 60701,
     /*  286126 */     GIR_EraseRootFromParent_Done,
     /*  286127 */   // Label 5661: @286127
     /*  286127 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(286193), // Rule ID 60704 //
     /*  286132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  286143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  286146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  286149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  286171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  286174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286191 */     GIR_RootConstrainSelectedInstOperands,
     /*  286192 */     // GIR_Coverage, 60704,
     /*  286192 */     GIR_EraseRootFromParent_Done,
     /*  286193 */   // Label 5662: @286193
     /*  286193 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(286259), // Rule ID 60705 //
     /*  286198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  286209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  286212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  286215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  286237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  286240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286257 */     GIR_RootConstrainSelectedInstOperands,
     /*  286258 */     // GIR_Coverage, 60705,
     /*  286258 */     GIR_EraseRootFromParent_Done,
     /*  286259 */   // Label 5663: @286259
     /*  286259 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(286325), // Rule ID 60708 //
     /*  286264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  286275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286303 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  286303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  286306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286323 */     GIR_RootConstrainSelectedInstOperands,
     /*  286324 */     // GIR_Coverage, 60708,
     /*  286324 */     GIR_EraseRootFromParent_Done,
     /*  286325 */   // Label 5664: @286325
     /*  286325 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(286391), // Rule ID 60709 //
     /*  286330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  286341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286369 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  286369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  286372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286389 */     GIR_RootConstrainSelectedInstOperands,
     /*  286390 */     // GIR_Coverage, 60709,
     /*  286390 */     GIR_EraseRootFromParent_Done,
     /*  286391 */   // Label 5665: @286391
     /*  286391 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(286457), // Rule ID 60712 //
     /*  286396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  286407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286435 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  286435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  286438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286455 */     GIR_RootConstrainSelectedInstOperands,
     /*  286456 */     // GIR_Coverage, 60712,
     /*  286456 */     GIR_EraseRootFromParent_Done,
     /*  286457 */   // Label 5666: @286457
     /*  286457 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(286523), // Rule ID 60713 //
     /*  286462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  286473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286501 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  286501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  286504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286521 */     GIR_RootConstrainSelectedInstOperands,
     /*  286522 */     // GIR_Coverage, 60713,
     /*  286522 */     GIR_EraseRootFromParent_Done,
     /*  286523 */   // Label 5667: @286523
     /*  286523 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(286589), // Rule ID 60716 //
     /*  286528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  286539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  286567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  286570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286587 */     GIR_RootConstrainSelectedInstOperands,
     /*  286588 */     // GIR_Coverage, 60716,
     /*  286588 */     GIR_EraseRootFromParent_Done,
     /*  286589 */   // Label 5668: @286589
     /*  286589 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(286655), // Rule ID 60717 //
     /*  286594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  286605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  286633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  286636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286653 */     GIR_RootConstrainSelectedInstOperands,
     /*  286654 */     // GIR_Coverage, 60717,
     /*  286654 */     GIR_EraseRootFromParent_Done,
     /*  286655 */   // Label 5669: @286655
     /*  286655 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(286721), // Rule ID 60720 //
     /*  286660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  286671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  286699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  286702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286719 */     GIR_RootConstrainSelectedInstOperands,
     /*  286720 */     // GIR_Coverage, 60720,
     /*  286720 */     GIR_EraseRootFromParent_Done,
     /*  286721 */   // Label 5670: @286721
     /*  286721 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(286787), // Rule ID 60721 //
     /*  286726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  286737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286765 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  286765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  286768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286785 */     GIR_RootConstrainSelectedInstOperands,
     /*  286786 */     // GIR_Coverage, 60721,
     /*  286786 */     GIR_EraseRootFromParent_Done,
     /*  286787 */   // Label 5671: @286787
     /*  286787 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(286853), // Rule ID 60724 //
     /*  286792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  286803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286831 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  286831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  286834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286851 */     GIR_RootConstrainSelectedInstOperands,
     /*  286852 */     // GIR_Coverage, 60724,
     /*  286852 */     GIR_EraseRootFromParent_Done,
     /*  286853 */   // Label 5672: @286853
     /*  286853 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(286919), // Rule ID 60725 //
     /*  286858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  286869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286897 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  286897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  286900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286917 */     GIR_RootConstrainSelectedInstOperands,
     /*  286918 */     // GIR_Coverage, 60725,
     /*  286918 */     GIR_EraseRootFromParent_Done,
     /*  286919 */   // Label 5673: @286919
     /*  286919 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(286985), // Rule ID 60728 //
     /*  286924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  286927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  286935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  286941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  286963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  286966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  286970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  286983 */     GIR_RootConstrainSelectedInstOperands,
     /*  286984 */     // GIR_Coverage, 60728,
     /*  286984 */     GIR_EraseRootFromParent_Done,
     /*  286985 */   // Label 5674: @286985
     /*  286985 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(287051), // Rule ID 60729 //
     /*  286990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  286993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  286998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  287001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  287004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  287007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  287029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  287032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287049 */     GIR_RootConstrainSelectedInstOperands,
     /*  287050 */     // GIR_Coverage, 60729,
     /*  287050 */     GIR_EraseRootFromParent_Done,
     /*  287051 */   // Label 5675: @287051
     /*  287051 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(287117), // Rule ID 60732 //
     /*  287056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  287067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  287070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  287073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  287095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  287098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287115 */     GIR_RootConstrainSelectedInstOperands,
     /*  287116 */     // GIR_Coverage, 60732,
     /*  287116 */     GIR_EraseRootFromParent_Done,
     /*  287117 */   // Label 5676: @287117
     /*  287117 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(287183), // Rule ID 60733 //
     /*  287122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  287133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  287136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  287139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287161 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  287161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  287164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287181 */     GIR_RootConstrainSelectedInstOperands,
     /*  287182 */     // GIR_Coverage, 60733,
     /*  287182 */     GIR_EraseRootFromParent_Done,
     /*  287183 */   // Label 5677: @287183
     /*  287183 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(287249), // Rule ID 60736 //
     /*  287188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  287199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  287202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  287205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  287227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  287230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287247 */     GIR_RootConstrainSelectedInstOperands,
     /*  287248 */     // GIR_Coverage, 60736,
     /*  287248 */     GIR_EraseRootFromParent_Done,
     /*  287249 */   // Label 5678: @287249
     /*  287249 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(287315), // Rule ID 60737 //
     /*  287254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  287265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  287268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  287271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  287293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  287296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287313 */     GIR_RootConstrainSelectedInstOperands,
     /*  287314 */     // GIR_Coverage, 60737,
     /*  287314 */     GIR_EraseRootFromParent_Done,
     /*  287315 */   // Label 5679: @287315
     /*  287315 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(287381), // Rule ID 60740 //
     /*  287320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  287331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  287359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  287362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287379 */     GIR_RootConstrainSelectedInstOperands,
     /*  287380 */     // GIR_Coverage, 60740,
     /*  287380 */     GIR_EraseRootFromParent_Done,
     /*  287381 */   // Label 5680: @287381
     /*  287381 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(287447), // Rule ID 60741 //
     /*  287386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  287397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  287425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  287428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287445 */     GIR_RootConstrainSelectedInstOperands,
     /*  287446 */     // GIR_Coverage, 60741,
     /*  287446 */     GIR_EraseRootFromParent_Done,
     /*  287447 */   // Label 5681: @287447
     /*  287447 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(287513), // Rule ID 60744 //
     /*  287452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  287463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287491 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  287491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  287494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287511 */     GIR_RootConstrainSelectedInstOperands,
     /*  287512 */     // GIR_Coverage, 60744,
     /*  287512 */     GIR_EraseRootFromParent_Done,
     /*  287513 */   // Label 5682: @287513
     /*  287513 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(287579), // Rule ID 60745 //
     /*  287518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  287529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  287557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  287560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287577 */     GIR_RootConstrainSelectedInstOperands,
     /*  287578 */     // GIR_Coverage, 60745,
     /*  287578 */     GIR_EraseRootFromParent_Done,
     /*  287579 */   // Label 5683: @287579
     /*  287579 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(287645), // Rule ID 60748 //
     /*  287584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  287595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287623 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  287623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  287626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287643 */     GIR_RootConstrainSelectedInstOperands,
     /*  287644 */     // GIR_Coverage, 60748,
     /*  287644 */     GIR_EraseRootFromParent_Done,
     /*  287645 */   // Label 5684: @287645
     /*  287645 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(287711), // Rule ID 60749 //
     /*  287650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  287658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  287661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  287689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  287692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287709 */     GIR_RootConstrainSelectedInstOperands,
     /*  287710 */     // GIR_Coverage, 60749,
     /*  287710 */     GIR_EraseRootFromParent_Done,
     /*  287711 */   // Label 5685: @287711
     /*  287711 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(287777), // Rule ID 60752 //
     /*  287716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  287724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  287727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  287733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287755 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  287755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  287758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287775 */     GIR_RootConstrainSelectedInstOperands,
     /*  287776 */     // GIR_Coverage, 60752,
     /*  287776 */     GIR_EraseRootFromParent_Done,
     /*  287777 */   // Label 5686: @287777
     /*  287777 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(287843), // Rule ID 60753 //
     /*  287782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  287790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  287793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  287799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  287821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  287824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287841 */     GIR_RootConstrainSelectedInstOperands,
     /*  287842 */     // GIR_Coverage, 60753,
     /*  287842 */     GIR_EraseRootFromParent_Done,
     /*  287843 */   // Label 5687: @287843
     /*  287843 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(287909), // Rule ID 60756 //
     /*  287848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  287856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  287859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  287865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287887 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  287887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  287890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287907 */     GIR_RootConstrainSelectedInstOperands,
     /*  287908 */     // GIR_Coverage, 60756,
     /*  287908 */     GIR_EraseRootFromParent_Done,
     /*  287909 */   // Label 5688: @287909
     /*  287909 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(287975), // Rule ID 60757 //
     /*  287914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  287917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  287922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  287925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  287931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287953 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  287953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  287956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  287960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  287973 */     GIR_RootConstrainSelectedInstOperands,
     /*  287974 */     // GIR_Coverage, 60757,
     /*  287974 */     GIR_EraseRootFromParent_Done,
     /*  287975 */   // Label 5689: @287975
     /*  287975 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(288041), // Rule ID 60760 //
     /*  287980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  287983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  287988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  287991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  287997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  288019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288039 */     GIR_RootConstrainSelectedInstOperands,
     /*  288040 */     // GIR_Coverage, 60760,
     /*  288040 */     GIR_EraseRootFromParent_Done,
     /*  288041 */   // Label 5690: @288041
     /*  288041 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(288107), // Rule ID 60761 //
     /*  288046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  288057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  288060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  288063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288085 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  288085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288105 */     GIR_RootConstrainSelectedInstOperands,
     /*  288106 */     // GIR_Coverage, 60761,
     /*  288106 */     GIR_EraseRootFromParent_Done,
     /*  288107 */   // Label 5691: @288107
     /*  288107 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(288173), // Rule ID 60764 //
     /*  288112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  288123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  288126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  288129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  288151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  288154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288171 */     GIR_RootConstrainSelectedInstOperands,
     /*  288172 */     // GIR_Coverage, 60764,
     /*  288172 */     GIR_EraseRootFromParent_Done,
     /*  288173 */   // Label 5692: @288173
     /*  288173 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(288239), // Rule ID 60765 //
     /*  288178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  288189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  288192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  288195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288217 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  288217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  288220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288237 */     GIR_RootConstrainSelectedInstOperands,
     /*  288238 */     // GIR_Coverage, 60765,
     /*  288238 */     GIR_EraseRootFromParent_Done,
     /*  288239 */   // Label 5693: @288239
     /*  288239 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(288305), // Rule ID 60768 //
     /*  288244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  288255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  288258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  288261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288283 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  288283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288303 */     GIR_RootConstrainSelectedInstOperands,
     /*  288304 */     // GIR_Coverage, 60768,
     /*  288304 */     GIR_EraseRootFromParent_Done,
     /*  288305 */   // Label 5694: @288305
     /*  288305 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(288371), // Rule ID 60769 //
     /*  288310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  288321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  288324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  288327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288349 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  288349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288369 */     GIR_RootConstrainSelectedInstOperands,
     /*  288370 */     // GIR_Coverage, 60769,
     /*  288370 */     GIR_EraseRootFromParent_Done,
     /*  288371 */   // Label 5695: @288371
     /*  288371 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(288437), // Rule ID 60772 //
     /*  288376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  288387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  288393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288415 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  288415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288435 */     GIR_RootConstrainSelectedInstOperands,
     /*  288436 */     // GIR_Coverage, 60772,
     /*  288436 */     GIR_EraseRootFromParent_Done,
     /*  288437 */   // Label 5696: @288437
     /*  288437 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(288503), // Rule ID 60773 //
     /*  288442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  288453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  288459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288481 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  288481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  288484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288501 */     GIR_RootConstrainSelectedInstOperands,
     /*  288502 */     // GIR_Coverage, 60773,
     /*  288502 */     GIR_EraseRootFromParent_Done,
     /*  288503 */   // Label 5697: @288503
     /*  288503 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(288569), // Rule ID 60776 //
     /*  288508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  288519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  288525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288547 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  288547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288567 */     GIR_RootConstrainSelectedInstOperands,
     /*  288568 */     // GIR_Coverage, 60776,
     /*  288568 */     GIR_EraseRootFromParent_Done,
     /*  288569 */   // Label 5698: @288569
     /*  288569 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(288635), // Rule ID 60777 //
     /*  288574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  288585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  288591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288613 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  288613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288633 */     GIR_RootConstrainSelectedInstOperands,
     /*  288634 */     // GIR_Coverage, 60777,
     /*  288634 */     GIR_EraseRootFromParent_Done,
     /*  288635 */   // Label 5699: @288635
     /*  288635 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(288701), // Rule ID 60780 //
     /*  288640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  288651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  288657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288679 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  288679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288699 */     GIR_RootConstrainSelectedInstOperands,
     /*  288700 */     // GIR_Coverage, 60780,
     /*  288700 */     GIR_EraseRootFromParent_Done,
     /*  288701 */   // Label 5700: @288701
     /*  288701 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(288767), // Rule ID 60781 //
     /*  288706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  288717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  288723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  288745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288765 */     GIR_RootConstrainSelectedInstOperands,
     /*  288766 */     // GIR_Coverage, 60781,
     /*  288766 */     GIR_EraseRootFromParent_Done,
     /*  288767 */   // Label 5701: @288767
     /*  288767 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(288833), // Rule ID 60784 //
     /*  288772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  288783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  288789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  288811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288831 */     GIR_RootConstrainSelectedInstOperands,
     /*  288832 */     // GIR_Coverage, 60784,
     /*  288832 */     GIR_EraseRootFromParent_Done,
     /*  288833 */   // Label 5702: @288833
     /*  288833 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(288899), // Rule ID 60785 //
     /*  288838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  288849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  288855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  288877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288897 */     GIR_RootConstrainSelectedInstOperands,
     /*  288898 */     // GIR_Coverage, 60785,
     /*  288898 */     GIR_EraseRootFromParent_Done,
     /*  288899 */   // Label 5703: @288899
     /*  288899 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(288965), // Rule ID 60788 //
     /*  288904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  288907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  288915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  288921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  288943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  288946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  288950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  288963 */     GIR_RootConstrainSelectedInstOperands,
     /*  288964 */     // GIR_Coverage, 60788,
     /*  288964 */     GIR_EraseRootFromParent_Done,
     /*  288965 */   // Label 5704: @288965
     /*  288965 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(289031), // Rule ID 60789 //
     /*  288970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  288973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  288978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  288981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  288987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  289009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  289012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289029 */     GIR_RootConstrainSelectedInstOperands,
     /*  289030 */     // GIR_Coverage, 60789,
     /*  289030 */     GIR_EraseRootFromParent_Done,
     /*  289031 */   // Label 5705: @289031
     /*  289031 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(289097), // Rule ID 60792 //
     /*  289036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  289047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  289050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  289053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  289075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289095 */     GIR_RootConstrainSelectedInstOperands,
     /*  289096 */     // GIR_Coverage, 60792,
     /*  289096 */     GIR_EraseRootFromParent_Done,
     /*  289097 */   // Label 5706: @289097
     /*  289097 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(289163), // Rule ID 60793 //
     /*  289102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  289113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  289116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  289119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289141 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  289141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289161 */     GIR_RootConstrainSelectedInstOperands,
     /*  289162 */     // GIR_Coverage, 60793,
     /*  289162 */     GIR_EraseRootFromParent_Done,
     /*  289163 */   // Label 5707: @289163
     /*  289163 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(289229), // Rule ID 60796 //
     /*  289168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  289179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  289182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  289185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289207 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  289207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  289210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289227 */     GIR_RootConstrainSelectedInstOperands,
     /*  289228 */     // GIR_Coverage, 60796,
     /*  289228 */     GIR_EraseRootFromParent_Done,
     /*  289229 */   // Label 5708: @289229
     /*  289229 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(289295), // Rule ID 60797 //
     /*  289234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  289245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  289248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  289251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289273 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  289273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  289276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289293 */     GIR_RootConstrainSelectedInstOperands,
     /*  289294 */     // GIR_Coverage, 60797,
     /*  289294 */     GIR_EraseRootFromParent_Done,
     /*  289295 */   // Label 5709: @289295
     /*  289295 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(289361), // Rule ID 60800 //
     /*  289300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  289311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  289314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  289317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289339 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  289339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  289342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289359 */     GIR_RootConstrainSelectedInstOperands,
     /*  289360 */     // GIR_Coverage, 60800,
     /*  289360 */     GIR_EraseRootFromParent_Done,
     /*  289361 */   // Label 5710: @289361
     /*  289361 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(289427), // Rule ID 60801 //
     /*  289366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  289377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  289380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  289383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289405 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  289405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  289408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289425 */     GIR_RootConstrainSelectedInstOperands,
     /*  289426 */     // GIR_Coverage, 60801,
     /*  289426 */     GIR_EraseRootFromParent_Done,
     /*  289427 */   // Label 5711: @289427
     /*  289427 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(289493), // Rule ID 60804 //
     /*  289432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  289443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  289449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  289471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289491 */     GIR_RootConstrainSelectedInstOperands,
     /*  289492 */     // GIR_Coverage, 60804,
     /*  289492 */     GIR_EraseRootFromParent_Done,
     /*  289493 */   // Label 5712: @289493
     /*  289493 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(289559), // Rule ID 60805 //
     /*  289498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  289509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  289515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  289537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289557 */     GIR_RootConstrainSelectedInstOperands,
     /*  289558 */     // GIR_Coverage, 60805,
     /*  289558 */     GIR_EraseRootFromParent_Done,
     /*  289559 */   // Label 5713: @289559
     /*  289559 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(289625), // Rule ID 60808 //
     /*  289564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  289575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  289581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289603 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  289603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  289606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289623 */     GIR_RootConstrainSelectedInstOperands,
     /*  289624 */     // GIR_Coverage, 60808,
     /*  289624 */     GIR_EraseRootFromParent_Done,
     /*  289625 */   // Label 5714: @289625
     /*  289625 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(289691), // Rule ID 60809 //
     /*  289630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  289641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  289647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289669 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  289669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  289672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289689 */     GIR_RootConstrainSelectedInstOperands,
     /*  289690 */     // GIR_Coverage, 60809,
     /*  289690 */     GIR_EraseRootFromParent_Done,
     /*  289691 */   // Label 5715: @289691
     /*  289691 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(289757), // Rule ID 60812 //
     /*  289696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  289707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  289713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289735 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  289735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  289738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289755 */     GIR_RootConstrainSelectedInstOperands,
     /*  289756 */     // GIR_Coverage, 60812,
     /*  289756 */     GIR_EraseRootFromParent_Done,
     /*  289757 */   // Label 5716: @289757
     /*  289757 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(289823), // Rule ID 60813 //
     /*  289762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  289773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  289779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289801 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  289801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  289804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289821 */     GIR_RootConstrainSelectedInstOperands,
     /*  289822 */     // GIR_Coverage, 60813,
     /*  289822 */     GIR_EraseRootFromParent_Done,
     /*  289823 */   // Label 5717: @289823
     /*  289823 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(289889), // Rule ID 60816 //
     /*  289828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  289839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  289845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  289867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289887 */     GIR_RootConstrainSelectedInstOperands,
     /*  289888 */     // GIR_Coverage, 60816,
     /*  289888 */     GIR_EraseRootFromParent_Done,
     /*  289889 */   // Label 5718: @289889
     /*  289889 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(289955), // Rule ID 60817 //
     /*  289894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  289897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  289905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  289911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  289933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  289936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  289940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  289953 */     GIR_RootConstrainSelectedInstOperands,
     /*  289954 */     // GIR_Coverage, 60817,
     /*  289954 */     GIR_EraseRootFromParent_Done,
     /*  289955 */   // Label 5719: @289955
     /*  289955 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(290021), // Rule ID 60820 //
     /*  289960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  289963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  289968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  289971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  289977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  289999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  290002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290019 */     GIR_RootConstrainSelectedInstOperands,
     /*  290020 */     // GIR_Coverage, 60820,
     /*  290020 */     GIR_EraseRootFromParent_Done,
     /*  290021 */   // Label 5720: @290021
     /*  290021 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(290087), // Rule ID 60821 //
     /*  290026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  290029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  290037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  290040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  290043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290065 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  290065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  290068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290085 */     GIR_RootConstrainSelectedInstOperands,
     /*  290086 */     // GIR_Coverage, 60821,
     /*  290086 */     GIR_EraseRootFromParent_Done,
     /*  290087 */   // Label 5721: @290087
     /*  290087 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(290153), // Rule ID 60824 //
     /*  290092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  290095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  290103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  290106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  290109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  290131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  290134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290151 */     GIR_RootConstrainSelectedInstOperands,
     /*  290152 */     // GIR_Coverage, 60824,
     /*  290152 */     GIR_EraseRootFromParent_Done,
     /*  290153 */   // Label 5722: @290153
     /*  290153 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(290219), // Rule ID 60825 //
     /*  290158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  290161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  290169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  290172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  290175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290197 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  290197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  290200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290217 */     GIR_RootConstrainSelectedInstOperands,
     /*  290218 */     // GIR_Coverage, 60825,
     /*  290218 */     GIR_EraseRootFromParent_Done,
     /*  290219 */   // Label 5723: @290219
     /*  290219 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(290285), // Rule ID 60828 //
     /*  290224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  290227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  290235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  290238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  290241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290263 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  290263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  290266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290283 */     GIR_RootConstrainSelectedInstOperands,
     /*  290284 */     // GIR_Coverage, 60828,
     /*  290284 */     GIR_EraseRootFromParent_Done,
     /*  290285 */   // Label 5724: @290285
     /*  290285 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(290351), // Rule ID 60829 //
     /*  290290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  290293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  290301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  290304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  290307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  290329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  290332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290349 */     GIR_RootConstrainSelectedInstOperands,
     /*  290350 */     // GIR_Coverage, 60829,
     /*  290350 */     GIR_EraseRootFromParent_Done,
     /*  290351 */   // Label 5725: @290351
     /*  290351 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(290417), // Rule ID 60832 //
     /*  290356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  290359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  290367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  290370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  290373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290395 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  290395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  290398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290415 */     GIR_RootConstrainSelectedInstOperands,
     /*  290416 */     // GIR_Coverage, 60832,
     /*  290416 */     GIR_EraseRootFromParent_Done,
     /*  290417 */   // Label 5726: @290417
     /*  290417 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(290483), // Rule ID 60833 //
     /*  290422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  290425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  290433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  290436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  290439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  290461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  290464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290481 */     GIR_RootConstrainSelectedInstOperands,
     /*  290482 */     // GIR_Coverage, 60833,
     /*  290482 */     GIR_EraseRootFromParent_Done,
     /*  290483 */   // Label 5727: @290483
     /*  290483 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(290549), // Rule ID 60836 //
     /*  290488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  290491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  290499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  290505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  290527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  290530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290547 */     GIR_RootConstrainSelectedInstOperands,
     /*  290548 */     // GIR_Coverage, 60836,
     /*  290548 */     GIR_EraseRootFromParent_Done,
     /*  290549 */   // Label 5728: @290549
     /*  290549 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(290615), // Rule ID 60837 //
     /*  290554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  290557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  290562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  290565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  290571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290593 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  290593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  290596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  290600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  290613 */     GIR_RootConstrainSelectedInstOperands,
     /*  290614 */     // GIR_Coverage, 60837,
     /*  290614 */     GIR_EraseRootFromParent_Done,
     /*  290615 */   // Label 5729: @290615
     /*  290615 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(290680), // Rule ID 63767 //
     /*  290620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  290628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290664 */     // MIs[1] Operand 1
     /*  290664 */     // No operand predicates
     /*  290664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290666 */     // (intrinsic_wo_chain:{ *:[i32] } 10675:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  290669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  290678 */     GIR_RootConstrainSelectedInstOperands,
     /*  290679 */     // GIR_Coverage, 63767,
     /*  290679 */     GIR_EraseRootFromParent_Done,
     /*  290680 */   // Label 5730: @290680
     /*  290680 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(290745), // Rule ID 63794 //
     /*  290685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  290693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290729 */     // MIs[1] Operand 1
     /*  290729 */     // No operand predicates
     /*  290729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290731 */     // (intrinsic_wo_chain:{ *:[i32] } 10677:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  290734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  290743 */     GIR_RootConstrainSelectedInstOperands,
     /*  290744 */     // GIR_Coverage, 63794,
     /*  290744 */     GIR_EraseRootFromParent_Done,
     /*  290745 */   // Label 5731: @290745
     /*  290745 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(290810), // Rule ID 63797 //
     /*  290750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  290758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290794 */     // MIs[1] Operand 1
     /*  290794 */     // No operand predicates
     /*  290794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290796 */     // (intrinsic_wo_chain:{ *:[i32] } 10676:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  290799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  290808 */     GIR_RootConstrainSelectedInstOperands,
     /*  290809 */     // GIR_Coverage, 63797,
     /*  290809 */     GIR_EraseRootFromParent_Done,
     /*  290810 */   // Label 5732: @290810
     /*  290810 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(290875), // Rule ID 63800 //
     /*  290815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  290823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290859 */     // MIs[1] Operand 1
     /*  290859 */     // No operand predicates
     /*  290859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290861 */     // (intrinsic_wo_chain:{ *:[i32] } 10678:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  290864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  290873 */     GIR_RootConstrainSelectedInstOperands,
     /*  290874 */     // GIR_Coverage, 63800,
     /*  290874 */     GIR_EraseRootFromParent_Done,
     /*  290875 */   // Label 5733: @290875
     /*  290875 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(290940), // Rule ID 63803 //
     /*  290880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  290888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290924 */     // MIs[1] Operand 1
     /*  290924 */     // No operand predicates
     /*  290924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290926 */     // (intrinsic_wo_chain:{ *:[i32] } 10681:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  290929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  290938 */     GIR_RootConstrainSelectedInstOperands,
     /*  290939 */     // GIR_Coverage, 63803,
     /*  290939 */     GIR_EraseRootFromParent_Done,
     /*  290940 */   // Label 5734: @290940
     /*  290940 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(291005), // Rule ID 63806 //
     /*  290945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  290948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  290953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  290956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  290959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  290981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  290985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  290989 */     // MIs[1] Operand 1
     /*  290989 */     // No operand predicates
     /*  290989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  290991 */     // (intrinsic_wo_chain:{ *:[i32] } 10683:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  290991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  290994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  291003 */     GIR_RootConstrainSelectedInstOperands,
     /*  291004 */     // GIR_Coverage, 63806,
     /*  291004 */     GIR_EraseRootFromParent_Done,
     /*  291005 */   // Label 5735: @291005
     /*  291005 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(291070), // Rule ID 63809 //
     /*  291010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  291013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  291018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  291046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  291050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  291054 */     // MIs[1] Operand 1
     /*  291054 */     // No operand predicates
     /*  291054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  291056 */     // (intrinsic_wo_chain:{ *:[i32] } 10682:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  291056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  291059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  291068 */     GIR_RootConstrainSelectedInstOperands,
     /*  291069 */     // GIR_Coverage, 63809,
     /*  291069 */     GIR_EraseRootFromParent_Done,
     /*  291070 */   // Label 5736: @291070
     /*  291070 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(291135), // Rule ID 63812 //
     /*  291075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  291078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  291083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  291111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  291115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  291119 */     // MIs[1] Operand 1
     /*  291119 */     // No operand predicates
     /*  291119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  291121 */     // (intrinsic_wo_chain:{ *:[i32] } 10684:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  291121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  291124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  291133 */     GIR_RootConstrainSelectedInstOperands,
     /*  291134 */     // GIR_Coverage, 63812,
     /*  291134 */     GIR_EraseRootFromParent_Done,
     /*  291135 */   // Label 5737: @291135
     /*  291135 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(291190), // Rule ID 2505 //
     /*  291140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  291143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  291148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291169 */     // MIs[0] imm
     /*  291169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  291177 */     // (intrinsic_wo_chain:{ *:[i32] } 10660:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  291177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  291180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291186 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  291188 */     GIR_RootConstrainSelectedInstOperands,
     /*  291189 */     // GIR_Coverage, 2505,
     /*  291189 */     GIR_EraseRootFromParent_Done,
     /*  291190 */   // Label 5738: @291190
     /*  291190 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(291245), // Rule ID 2506 //
     /*  291195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  291198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  291203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291224 */     // MIs[0] imm
     /*  291224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  291232 */     // (intrinsic_wo_chain:{ *:[i32] } 10661:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  291232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  291235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291241 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  291243 */     GIR_RootConstrainSelectedInstOperands,
     /*  291244 */     // GIR_Coverage, 2506,
     /*  291244 */     GIR_EraseRootFromParent_Done,
     /*  291245 */   // Label 5739: @291245
     /*  291245 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(291300), // Rule ID 2512 //
     /*  291250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  291253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  291258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291279 */     // MIs[0] imm
     /*  291279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  291287 */     // (intrinsic_wo_chain:{ *:[i32] } 10662:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  291287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  291290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291296 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  291298 */     GIR_RootConstrainSelectedInstOperands,
     /*  291299 */     // GIR_Coverage, 2512,
     /*  291299 */     GIR_EraseRootFromParent_Done,
     /*  291300 */   // Label 5740: @291300
     /*  291300 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(291355), // Rule ID 2513 //
     /*  291305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  291308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  291313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291334 */     // MIs[0] imm
     /*  291334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  291342 */     // (intrinsic_wo_chain:{ *:[i32] } 10663:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  291342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  291345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291351 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  291353 */     GIR_RootConstrainSelectedInstOperands,
     /*  291354 */     // GIR_Coverage, 2513,
     /*  291354 */     GIR_EraseRootFromParent_Done,
     /*  291355 */   // Label 5741: @291355
     /*  291355 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(291410), // Rule ID 63823 //
     /*  291360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  291368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291389 */     // MIs[0] imm5
     /*  291389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291397 */     // (intrinsic_wo_chain:{ *:[i32] } 10708:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  291400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291406 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291408 */     GIR_RootConstrainSelectedInstOperands,
     /*  291409 */     // GIR_Coverage, 63823,
     /*  291409 */     GIR_EraseRootFromParent_Done,
     /*  291410 */   // Label 5742: @291410
     /*  291410 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(291465), // Rule ID 63824 //
     /*  291415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  291423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291444 */     // MIs[0] imm5
     /*  291444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291452 */     // (intrinsic_wo_chain:{ *:[i32] } 10704:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  291455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291461 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291463 */     GIR_RootConstrainSelectedInstOperands,
     /*  291464 */     // GIR_Coverage, 63824,
     /*  291464 */     GIR_EraseRootFromParent_Done,
     /*  291465 */   // Label 5743: @291465
     /*  291465 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(291520), // Rule ID 63825 //
     /*  291470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  291478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291499 */     // MIs[0] imm5
     /*  291499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291507 */     // (intrinsic_wo_chain:{ *:[i32] } 10706:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  291510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291516 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291518 */     GIR_RootConstrainSelectedInstOperands,
     /*  291519 */     // GIR_Coverage, 63825,
     /*  291519 */     GIR_EraseRootFromParent_Done,
     /*  291520 */   // Label 5744: @291520
     /*  291520 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(291575), // Rule ID 63826 //
     /*  291525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  291533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291554 */     // MIs[0] imm5
     /*  291554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291562 */     // (intrinsic_wo_chain:{ *:[i32] } 10702:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  291565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291571 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291573 */     GIR_RootConstrainSelectedInstOperands,
     /*  291574 */     // GIR_Coverage, 63826,
     /*  291574 */     GIR_EraseRootFromParent_Done,
     /*  291575 */   // Label 5745: @291575
     /*  291575 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(291630), // Rule ID 63827 //
     /*  291580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  291588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291609 */     // MIs[0] imm5
     /*  291609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291617 */     // (intrinsic_wo_chain:{ *:[i32] } 10709:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  291620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291626 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291628 */     GIR_RootConstrainSelectedInstOperands,
     /*  291629 */     // GIR_Coverage, 63827,
     /*  291629 */     GIR_EraseRootFromParent_Done,
     /*  291630 */   // Label 5746: @291630
     /*  291630 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(291685), // Rule ID 63828 //
     /*  291635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  291643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291664 */     // MIs[0] imm5
     /*  291664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291672 */     // (intrinsic_wo_chain:{ *:[i32] } 10705:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  291675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291681 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291683 */     GIR_RootConstrainSelectedInstOperands,
     /*  291684 */     // GIR_Coverage, 63828,
     /*  291684 */     GIR_EraseRootFromParent_Done,
     /*  291685 */   // Label 5747: @291685
     /*  291685 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(291740), // Rule ID 63829 //
     /*  291690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  291698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291719 */     // MIs[0] imm5
     /*  291719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291727 */     // (intrinsic_wo_chain:{ *:[i32] } 10707:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  291730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291736 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291738 */     GIR_RootConstrainSelectedInstOperands,
     /*  291739 */     // GIR_Coverage, 63829,
     /*  291739 */     GIR_EraseRootFromParent_Done,
     /*  291740 */   // Label 5748: @291740
     /*  291740 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(291795), // Rule ID 63830 //
     /*  291745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  291748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  291753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291774 */     // MIs[0] imm5
     /*  291774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  291777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  291782 */     // (intrinsic_wo_chain:{ *:[i32] } 10703:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  291782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  291785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291791 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  291793 */     GIR_RootConstrainSelectedInstOperands,
     /*  291794 */     // GIR_Coverage, 63830,
     /*  291794 */     GIR_EraseRootFromParent_Done,
     /*  291795 */   // Label 5749: @291795
     /*  291795 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(291849), // Rule ID 63765 //
     /*  291800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  291803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  291808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291836 */     // (intrinsic_wo_chain:{ *:[i32] } 10675:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  291836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  291839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  291841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  291847 */     GIR_RootConstrainSelectedInstOperands,
     /*  291848 */     // GIR_Coverage, 63765,
     /*  291848 */     GIR_EraseRootFromParent_Done,
     /*  291849 */   // Label 5750: @291849
     /*  291849 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(291903), // Rule ID 63766 //
     /*  291854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  291857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  291862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291890 */     // (intrinsic_wo_chain:{ *:[i32] } 10675:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  291890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  291893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  291895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  291901 */     GIR_RootConstrainSelectedInstOperands,
     /*  291902 */     // GIR_Coverage, 63766,
     /*  291902 */     GIR_EraseRootFromParent_Done,
     /*  291903 */   // Label 5751: @291903
     /*  291903 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(291957), // Rule ID 63792 //
     /*  291908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  291911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  291916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291944 */     // (intrinsic_wo_chain:{ *:[i32] } 10677:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  291944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  291947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  291949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  291955 */     GIR_RootConstrainSelectedInstOperands,
     /*  291956 */     // GIR_Coverage, 63792,
     /*  291956 */     GIR_EraseRootFromParent_Done,
     /*  291957 */   // Label 5752: @291957
     /*  291957 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(292011), // Rule ID 63793 //
     /*  291962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  291965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  291970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  291973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  291976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291998 */     // (intrinsic_wo_chain:{ *:[i32] } 10677:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  291998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  292001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292009 */     GIR_RootConstrainSelectedInstOperands,
     /*  292010 */     // GIR_Coverage, 63793,
     /*  292010 */     GIR_EraseRootFromParent_Done,
     /*  292011 */   // Label 5753: @292011
     /*  292011 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(292065), // Rule ID 63795 //
     /*  292016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  292024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292052 */     // (intrinsic_wo_chain:{ *:[i32] } 10676:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  292055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292063 */     GIR_RootConstrainSelectedInstOperands,
     /*  292064 */     // GIR_Coverage, 63795,
     /*  292064 */     GIR_EraseRootFromParent_Done,
     /*  292065 */   // Label 5754: @292065
     /*  292065 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(292119), // Rule ID 63796 //
     /*  292070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  292078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292106 */     // (intrinsic_wo_chain:{ *:[i32] } 10676:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  292109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292117 */     GIR_RootConstrainSelectedInstOperands,
     /*  292118 */     // GIR_Coverage, 63796,
     /*  292118 */     GIR_EraseRootFromParent_Done,
     /*  292119 */   // Label 5755: @292119
     /*  292119 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(292173), // Rule ID 63798 //
     /*  292124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  292132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292160 */     // (intrinsic_wo_chain:{ *:[i32] } 10678:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  292163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292171 */     GIR_RootConstrainSelectedInstOperands,
     /*  292172 */     // GIR_Coverage, 63798,
     /*  292172 */     GIR_EraseRootFromParent_Done,
     /*  292173 */   // Label 5756: @292173
     /*  292173 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(292227), // Rule ID 63799 //
     /*  292178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  292186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292214 */     // (intrinsic_wo_chain:{ *:[i32] } 10678:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  292217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292225 */     GIR_RootConstrainSelectedInstOperands,
     /*  292226 */     // GIR_Coverage, 63799,
     /*  292226 */     GIR_EraseRootFromParent_Done,
     /*  292227 */   // Label 5757: @292227
     /*  292227 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(292281), // Rule ID 63801 //
     /*  292232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  292240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292268 */     // (intrinsic_wo_chain:{ *:[i32] } 10681:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  292271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292279 */     GIR_RootConstrainSelectedInstOperands,
     /*  292280 */     // GIR_Coverage, 63801,
     /*  292280 */     GIR_EraseRootFromParent_Done,
     /*  292281 */   // Label 5758: @292281
     /*  292281 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(292335), // Rule ID 63802 //
     /*  292286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  292294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292322 */     // (intrinsic_wo_chain:{ *:[i32] } 10681:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  292325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292333 */     GIR_RootConstrainSelectedInstOperands,
     /*  292334 */     // GIR_Coverage, 63802,
     /*  292334 */     GIR_EraseRootFromParent_Done,
     /*  292335 */   // Label 5759: @292335
     /*  292335 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(292389), // Rule ID 63804 //
     /*  292340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  292348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292376 */     // (intrinsic_wo_chain:{ *:[i32] } 10683:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  292379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292387 */     GIR_RootConstrainSelectedInstOperands,
     /*  292388 */     // GIR_Coverage, 63804,
     /*  292388 */     GIR_EraseRootFromParent_Done,
     /*  292389 */   // Label 5760: @292389
     /*  292389 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(292443), // Rule ID 63805 //
     /*  292394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  292402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292430 */     // (intrinsic_wo_chain:{ *:[i32] } 10683:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  292433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292441 */     GIR_RootConstrainSelectedInstOperands,
     /*  292442 */     // GIR_Coverage, 63805,
     /*  292442 */     GIR_EraseRootFromParent_Done,
     /*  292443 */   // Label 5761: @292443
     /*  292443 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(292497), // Rule ID 63807 //
     /*  292448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  292456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292484 */     // (intrinsic_wo_chain:{ *:[i32] } 10682:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  292487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292495 */     GIR_RootConstrainSelectedInstOperands,
     /*  292496 */     // GIR_Coverage, 63807,
     /*  292496 */     GIR_EraseRootFromParent_Done,
     /*  292497 */   // Label 5762: @292497
     /*  292497 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(292551), // Rule ID 63808 //
     /*  292502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  292510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292538 */     // (intrinsic_wo_chain:{ *:[i32] } 10682:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  292541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292549 */     GIR_RootConstrainSelectedInstOperands,
     /*  292550 */     // GIR_Coverage, 63808,
     /*  292550 */     GIR_EraseRootFromParent_Done,
     /*  292551 */   // Label 5763: @292551
     /*  292551 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(292605), // Rule ID 63810 //
     /*  292556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  292559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  292564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292592 */     // (intrinsic_wo_chain:{ *:[i32] } 10684:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  292595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292603 */     GIR_RootConstrainSelectedInstOperands,
     /*  292604 */     // GIR_Coverage, 63810,
     /*  292604 */     GIR_EraseRootFromParent_Done,
     /*  292605 */   // Label 5764: @292605
     /*  292605 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(292659), // Rule ID 63811 //
     /*  292610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  292613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  292618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292646 */     // (intrinsic_wo_chain:{ *:[i32] } 10684:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  292646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  292649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  292657 */     GIR_RootConstrainSelectedInstOperands,
     /*  292658 */     // GIR_Coverage, 63811,
     /*  292658 */     GIR_EraseRootFromParent_Done,
     /*  292659 */   // Label 5765: @292659
     /*  292659 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(292713), // Rule ID 63748 //
     /*  292664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  292667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  292672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292700 */     // (intrinsic_wo_chain:{ *:[i32] } 10691:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  292703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292711 */     GIR_RootConstrainSelectedInstOperands,
     /*  292712 */     // GIR_Coverage, 63748,
     /*  292712 */     GIR_EraseRootFromParent_Done,
     /*  292713 */   // Label 5766: @292713
     /*  292713 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(292767), // Rule ID 63749 //
     /*  292718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  292721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  292726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292754 */     // (intrinsic_wo_chain:{ *:[i32] } 10691:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  292757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292765 */     GIR_RootConstrainSelectedInstOperands,
     /*  292766 */     // GIR_Coverage, 63749,
     /*  292766 */     GIR_EraseRootFromParent_Done,
     /*  292767 */   // Label 5767: @292767
     /*  292767 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(292821), // Rule ID 63819 //
     /*  292772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  292775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  292780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292808 */     // (intrinsic_wo_chain:{ *:[i32] } 10692:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  292811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292819 */     GIR_RootConstrainSelectedInstOperands,
     /*  292820 */     // GIR_Coverage, 63819,
     /*  292820 */     GIR_EraseRootFromParent_Done,
     /*  292821 */   // Label 5768: @292821
     /*  292821 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(292875), // Rule ID 63820 //
     /*  292826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  292829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  292834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292862 */     // (intrinsic_wo_chain:{ *:[i32] } 10692:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  292865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292873 */     GIR_RootConstrainSelectedInstOperands,
     /*  292874 */     // GIR_Coverage, 63820,
     /*  292874 */     GIR_EraseRootFromParent_Done,
     /*  292875 */   // Label 5769: @292875
     /*  292875 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(292929), // Rule ID 63821 //
     /*  292880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  292883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  292888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292916 */     // (intrinsic_wo_chain:{ *:[i32] } 10701:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  292919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292927 */     GIR_RootConstrainSelectedInstOperands,
     /*  292928 */     // GIR_Coverage, 63821,
     /*  292928 */     GIR_EraseRootFromParent_Done,
     /*  292929 */   // Label 5770: @292929
     /*  292929 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(292983), // Rule ID 63822 //
     /*  292934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  292937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  292942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  292945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  292948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292970 */     // (intrinsic_wo_chain:{ *:[i32] } 10701:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  292970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  292973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  292975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  292977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292981 */     GIR_RootConstrainSelectedInstOperands,
     /*  292982 */     // GIR_Coverage, 63822,
     /*  292982 */     GIR_EraseRootFromParent_Done,
     /*  292983 */   // Label 5771: @292983
     /*  292983 */   GIM_Reject,
     /*  292984 */ // Label 3146: @292984
     /*  292984 */ GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(811761),
     /*  292989 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  292992 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(293067), // Rule ID 62149 //
     /*  292997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  293008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293015 */     // MIs[0] op1
     /*  293015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293023 */     // MIs[0] op2
     /*  293023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293031 */     // MIs[0] op3
     /*  293031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293046 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  293049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293065 */     GIR_RootConstrainSelectedInstOperands,
     /*  293066 */     // GIR_Coverage, 62149,
     /*  293066 */     GIR_EraseRootFromParent_Done,
     /*  293067 */   // Label 5773: @293067
     /*  293067 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(293142), // Rule ID 62150 //
     /*  293072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  293083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293090 */     // MIs[0] op1
     /*  293090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293098 */     // MIs[0] op2
     /*  293098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293106 */     // MIs[0] op3
     /*  293106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293121 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  293124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293140 */     GIR_RootConstrainSelectedInstOperands,
     /*  293141 */     // GIR_Coverage, 62150,
     /*  293141 */     GIR_EraseRootFromParent_Done,
     /*  293142 */   // Label 5774: @293142
     /*  293142 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(293217), // Rule ID 62181 //
     /*  293147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  293158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293165 */     // MIs[0] op1
     /*  293165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293173 */     // MIs[0] op2
     /*  293173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293181 */     // MIs[0] op3
     /*  293181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  293199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293201 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293203 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293205 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293215 */     GIR_RootConstrainSelectedInstOperands,
     /*  293216 */     // GIR_Coverage, 62181,
     /*  293216 */     GIR_EraseRootFromParent_Done,
     /*  293217 */   // Label 5775: @293217
     /*  293217 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(293292), // Rule ID 62182 //
     /*  293222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  293233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293240 */     // MIs[0] op1
     /*  293240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293248 */     // MIs[0] op2
     /*  293248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293256 */     // MIs[0] op3
     /*  293256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293271 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  293274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293290 */     GIR_RootConstrainSelectedInstOperands,
     /*  293291 */     // GIR_Coverage, 62182,
     /*  293291 */     GIR_EraseRootFromParent_Done,
     /*  293292 */   // Label 5776: @293292
     /*  293292 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(293367), // Rule ID 62225 //
     /*  293297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  293308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293315 */     // MIs[0] op1
     /*  293315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293323 */     // MIs[0] op2
     /*  293323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293331 */     // MIs[0] op3
     /*  293331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293346 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293351 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293353 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293355 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293365 */     GIR_RootConstrainSelectedInstOperands,
     /*  293366 */     // GIR_Coverage, 62225,
     /*  293366 */     GIR_EraseRootFromParent_Done,
     /*  293367 */   // Label 5777: @293367
     /*  293367 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(293442), // Rule ID 62226 //
     /*  293372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  293383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293390 */     // MIs[0] op1
     /*  293390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293398 */     // MIs[0] op2
     /*  293398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293406 */     // MIs[0] op3
     /*  293406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293421 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293426 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293428 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293430 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293440 */     GIR_RootConstrainSelectedInstOperands,
     /*  293441 */     // GIR_Coverage, 62226,
     /*  293441 */     GIR_EraseRootFromParent_Done,
     /*  293442 */   // Label 5778: @293442
     /*  293442 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(293517), // Rule ID 62269 //
     /*  293447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  293458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293465 */     // MIs[0] op1
     /*  293465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293473 */     // MIs[0] op2
     /*  293473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293481 */     // MIs[0] op3
     /*  293481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  293499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293501 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293503 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293505 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293515 */     GIR_RootConstrainSelectedInstOperands,
     /*  293516 */     // GIR_Coverage, 62269,
     /*  293516 */     GIR_EraseRootFromParent_Done,
     /*  293517 */   // Label 5779: @293517
     /*  293517 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(293592), // Rule ID 62270 //
     /*  293522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  293533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293540 */     // MIs[0] op1
     /*  293540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293548 */     // MIs[0] op2
     /*  293548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293556 */     // MIs[0] op3
     /*  293556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293571 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  293574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293576 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293578 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293580 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293590 */     GIR_RootConstrainSelectedInstOperands,
     /*  293591 */     // GIR_Coverage, 62270,
     /*  293591 */     GIR_EraseRootFromParent_Done,
     /*  293592 */   // Label 5780: @293592
     /*  293592 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(293667), // Rule ID 62325 //
     /*  293597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  293608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293615 */     // MIs[0] op1
     /*  293615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293623 */     // MIs[0] op2
     /*  293623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293631 */     // MIs[0] op3
     /*  293631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293651 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293653 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293655 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293665 */     GIR_RootConstrainSelectedInstOperands,
     /*  293666 */     // GIR_Coverage, 62325,
     /*  293666 */     GIR_EraseRootFromParent_Done,
     /*  293667 */   // Label 5781: @293667
     /*  293667 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(293742), // Rule ID 62326 //
     /*  293672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  293683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293690 */     // MIs[0] op1
     /*  293690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293698 */     // MIs[0] op2
     /*  293698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293706 */     // MIs[0] op3
     /*  293706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293721 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293726 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293728 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293730 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293740 */     GIR_RootConstrainSelectedInstOperands,
     /*  293741 */     // GIR_Coverage, 62326,
     /*  293741 */     GIR_EraseRootFromParent_Done,
     /*  293742 */   // Label 5782: @293742
     /*  293742 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(293817), // Rule ID 62381 //
     /*  293747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  293758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293765 */     // MIs[0] op1
     /*  293765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293773 */     // MIs[0] op2
     /*  293773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293781 */     // MIs[0] op3
     /*  293781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293801 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293803 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293805 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293815 */     GIR_RootConstrainSelectedInstOperands,
     /*  293816 */     // GIR_Coverage, 62381,
     /*  293816 */     GIR_EraseRootFromParent_Done,
     /*  293817 */   // Label 5783: @293817
     /*  293817 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(293892), // Rule ID 62382 //
     /*  293822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  293833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293840 */     // MIs[0] op1
     /*  293840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293848 */     // MIs[0] op2
     /*  293848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293856 */     // MIs[0] op3
     /*  293856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293871 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  293874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293876 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293878 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293880 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293890 */     GIR_RootConstrainSelectedInstOperands,
     /*  293891 */     // GIR_Coverage, 62382,
     /*  293891 */     GIR_EraseRootFromParent_Done,
     /*  293892 */   // Label 5784: @293892
     /*  293892 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(293967), // Rule ID 62437 //
     /*  293897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  293900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  293908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  293911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293915 */     // MIs[0] op1
     /*  293915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293923 */     // MIs[0] op2
     /*  293923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  293926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  293931 */     // MIs[0] op3
     /*  293931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  293934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  293939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  293949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  293953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  293955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  293957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293965 */     GIR_RootConstrainSelectedInstOperands,
     /*  293966 */     // GIR_Coverage, 62437,
     /*  293966 */     GIR_EraseRootFromParent_Done,
     /*  293967 */   // Label 5785: @293967
     /*  293967 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294042), // Rule ID 62438 //
     /*  293972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  293975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  293980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  293983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  293986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293990 */     // MIs[0] op1
     /*  293990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  293993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  293998 */     // MIs[0] op2
     /*  293998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294006 */     // MIs[0] op3
     /*  294006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294021 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294040 */     GIR_RootConstrainSelectedInstOperands,
     /*  294041 */     // GIR_Coverage, 62438,
     /*  294041 */     GIR_EraseRootFromParent_Done,
     /*  294042 */   // Label 5786: @294042
     /*  294042 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294117), // Rule ID 62481 //
     /*  294047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  294058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294065 */     // MIs[0] op1
     /*  294065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294073 */     // MIs[0] op2
     /*  294073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294081 */     // MIs[0] op3
     /*  294081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294101 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294103 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294105 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294115 */     GIR_RootConstrainSelectedInstOperands,
     /*  294116 */     // GIR_Coverage, 62481,
     /*  294116 */     GIR_EraseRootFromParent_Done,
     /*  294117 */   // Label 5787: @294117
     /*  294117 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294192), // Rule ID 62482 //
     /*  294122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  294133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294140 */     // MIs[0] op1
     /*  294140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294148 */     // MIs[0] op2
     /*  294148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294156 */     // MIs[0] op3
     /*  294156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294171 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294176 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294178 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294180 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294190 */     GIR_RootConstrainSelectedInstOperands,
     /*  294191 */     // GIR_Coverage, 62482,
     /*  294191 */     GIR_EraseRootFromParent_Done,
     /*  294192 */   // Label 5788: @294192
     /*  294192 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294267), // Rule ID 62537 //
     /*  294197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  294208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294215 */     // MIs[0] op1
     /*  294215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294223 */     // MIs[0] op2
     /*  294223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294231 */     // MIs[0] op3
     /*  294231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294265 */     GIR_RootConstrainSelectedInstOperands,
     /*  294266 */     // GIR_Coverage, 62537,
     /*  294266 */     GIR_EraseRootFromParent_Done,
     /*  294267 */   // Label 5789: @294267
     /*  294267 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294342), // Rule ID 62538 //
     /*  294272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  294283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294290 */     // MIs[0] op1
     /*  294290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294298 */     // MIs[0] op2
     /*  294298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294306 */     // MIs[0] op3
     /*  294306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294326 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294328 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294330 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294340 */     GIR_RootConstrainSelectedInstOperands,
     /*  294341 */     // GIR_Coverage, 62538,
     /*  294341 */     GIR_EraseRootFromParent_Done,
     /*  294342 */   // Label 5790: @294342
     /*  294342 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(294417), // Rule ID 62593 //
     /*  294347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  294358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294365 */     // MIs[0] op1
     /*  294365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294373 */     // MIs[0] op2
     /*  294373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294381 */     // MIs[0] op3
     /*  294381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294415 */     GIR_RootConstrainSelectedInstOperands,
     /*  294416 */     // GIR_Coverage, 62593,
     /*  294416 */     GIR_EraseRootFromParent_Done,
     /*  294417 */   // Label 5791: @294417
     /*  294417 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(294492), // Rule ID 62594 //
     /*  294422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  294433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294440 */     // MIs[0] op1
     /*  294440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294448 */     // MIs[0] op2
     /*  294448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294456 */     // MIs[0] op3
     /*  294456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294471 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  294474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294490 */     GIR_RootConstrainSelectedInstOperands,
     /*  294491 */     // GIR_Coverage, 62594,
     /*  294491 */     GIR_EraseRootFromParent_Done,
     /*  294492 */   // Label 5792: @294492
     /*  294492 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(294567), // Rule ID 62649 //
     /*  294497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  294508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294515 */     // MIs[0] op1
     /*  294515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294523 */     // MIs[0] op2
     /*  294523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294531 */     // MIs[0] op3
     /*  294531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294546 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  294549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294551 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294553 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294555 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294565 */     GIR_RootConstrainSelectedInstOperands,
     /*  294566 */     // GIR_Coverage, 62649,
     /*  294566 */     GIR_EraseRootFromParent_Done,
     /*  294567 */   // Label 5793: @294567
     /*  294567 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(294642), // Rule ID 62650 //
     /*  294572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  294583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294590 */     // MIs[0] op1
     /*  294590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294598 */     // MIs[0] op2
     /*  294598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294606 */     // MIs[0] op3
     /*  294606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  294624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294640 */     GIR_RootConstrainSelectedInstOperands,
     /*  294641 */     // GIR_Coverage, 62650,
     /*  294641 */     GIR_EraseRootFromParent_Done,
     /*  294642 */   // Label 5794: @294642
     /*  294642 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294717), // Rule ID 62693 //
     /*  294647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  294658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294665 */     // MIs[0] op1
     /*  294665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294673 */     // MIs[0] op2
     /*  294673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294681 */     // MIs[0] op3
     /*  294681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  294699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294701 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294703 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294705 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294715 */     GIR_RootConstrainSelectedInstOperands,
     /*  294716 */     // GIR_Coverage, 62693,
     /*  294716 */     GIR_EraseRootFromParent_Done,
     /*  294717 */   // Label 5795: @294717
     /*  294717 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(294792), // Rule ID 62694 //
     /*  294722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  294733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294740 */     // MIs[0] op1
     /*  294740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294748 */     // MIs[0] op2
     /*  294748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294756 */     // MIs[0] op3
     /*  294756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294771 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  294774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294790 */     GIR_RootConstrainSelectedInstOperands,
     /*  294791 */     // GIR_Coverage, 62694,
     /*  294791 */     GIR_EraseRootFromParent_Done,
     /*  294792 */   // Label 5796: @294792
     /*  294792 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(294867), // Rule ID 62737 //
     /*  294797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  294808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294815 */     // MIs[0] op1
     /*  294815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294823 */     // MIs[0] op2
     /*  294823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294831 */     // MIs[0] op3
     /*  294831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  294849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294865 */     GIR_RootConstrainSelectedInstOperands,
     /*  294866 */     // GIR_Coverage, 62737,
     /*  294866 */     GIR_EraseRootFromParent_Done,
     /*  294867 */   // Label 5797: @294867
     /*  294867 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(294942), // Rule ID 62738 //
     /*  294872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  294875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  294883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  294886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294890 */     // MIs[0] op1
     /*  294890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294898 */     // MIs[0] op2
     /*  294898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294906 */     // MIs[0] op3
     /*  294906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294921 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  294924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294926 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  294928 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  294930 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  294932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294940 */     GIR_RootConstrainSelectedInstOperands,
     /*  294941 */     // GIR_Coverage, 62738,
     /*  294941 */     GIR_EraseRootFromParent_Done,
     /*  294942 */   // Label 5798: @294942
     /*  294942 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(295017), // Rule ID 62781 //
     /*  294947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  294950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  294955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  294958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  294961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294965 */     // MIs[0] op1
     /*  294965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  294968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  294973 */     // MIs[0] op2
     /*  294973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  294976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  294981 */     // MIs[0] op3
     /*  294981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  294984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  294989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  294999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295001 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295003 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295005 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295015 */     GIR_RootConstrainSelectedInstOperands,
     /*  295016 */     // GIR_Coverage, 62781,
     /*  295016 */     GIR_EraseRootFromParent_Done,
     /*  295017 */   // Label 5799: @295017
     /*  295017 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(295092), // Rule ID 62782 //
     /*  295022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  295033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295040 */     // MIs[0] op1
     /*  295040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295048 */     // MIs[0] op2
     /*  295048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295056 */     // MIs[0] op3
     /*  295056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  295074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295076 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295078 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295080 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295090 */     GIR_RootConstrainSelectedInstOperands,
     /*  295091 */     // GIR_Coverage, 62782,
     /*  295091 */     GIR_EraseRootFromParent_Done,
     /*  295092 */   // Label 5800: @295092
     /*  295092 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(295167), // Rule ID 62837 //
     /*  295097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  295108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295115 */     // MIs[0] op1
     /*  295115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295123 */     // MIs[0] op2
     /*  295123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295131 */     // MIs[0] op3
     /*  295131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  295149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295151 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295153 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295155 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295165 */     GIR_RootConstrainSelectedInstOperands,
     /*  295166 */     // GIR_Coverage, 62837,
     /*  295166 */     GIR_EraseRootFromParent_Done,
     /*  295167 */   // Label 5801: @295167
     /*  295167 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(295242), // Rule ID 62838 //
     /*  295172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  295183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295190 */     // MIs[0] op1
     /*  295190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295198 */     // MIs[0] op2
     /*  295198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295206 */     // MIs[0] op3
     /*  295206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295221 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  295224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295226 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295228 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295230 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295240 */     GIR_RootConstrainSelectedInstOperands,
     /*  295241 */     // GIR_Coverage, 62838,
     /*  295241 */     GIR_EraseRootFromParent_Done,
     /*  295242 */   // Label 5802: @295242
     /*  295242 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(295317), // Rule ID 62893 //
     /*  295247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  295258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295265 */     // MIs[0] op1
     /*  295265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295273 */     // MIs[0] op2
     /*  295273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295281 */     // MIs[0] op3
     /*  295281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  295299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295301 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295303 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295305 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295315 */     GIR_RootConstrainSelectedInstOperands,
     /*  295316 */     // GIR_Coverage, 62893,
     /*  295316 */     GIR_EraseRootFromParent_Done,
     /*  295317 */   // Label 5803: @295317
     /*  295317 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(295392), // Rule ID 62894 //
     /*  295322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  295333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295340 */     // MIs[0] op1
     /*  295340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295348 */     // MIs[0] op2
     /*  295348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295356 */     // MIs[0] op3
     /*  295356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295371 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  295374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295376 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295378 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295380 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295390 */     GIR_RootConstrainSelectedInstOperands,
     /*  295391 */     // GIR_Coverage, 62894,
     /*  295391 */     GIR_EraseRootFromParent_Done,
     /*  295392 */   // Label 5804: @295392
     /*  295392 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(295467), // Rule ID 62949 //
     /*  295397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  295408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295415 */     // MIs[0] op1
     /*  295415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295423 */     // MIs[0] op2
     /*  295423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295431 */     // MIs[0] op3
     /*  295431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  295449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295451 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295453 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295455 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295465 */     GIR_RootConstrainSelectedInstOperands,
     /*  295466 */     // GIR_Coverage, 62949,
     /*  295466 */     GIR_EraseRootFromParent_Done,
     /*  295467 */   // Label 5805: @295467
     /*  295467 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295542), // Rule ID 62950 //
     /*  295472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  295483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295490 */     // MIs[0] op1
     /*  295490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295498 */     // MIs[0] op2
     /*  295498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295506 */     // MIs[0] op3
     /*  295506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  295524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295540 */     GIR_RootConstrainSelectedInstOperands,
     /*  295541 */     // GIR_Coverage, 62950,
     /*  295541 */     GIR_EraseRootFromParent_Done,
     /*  295542 */   // Label 5806: @295542
     /*  295542 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295617), // Rule ID 63005 //
     /*  295547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  295558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295565 */     // MIs[0] op1
     /*  295565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295573 */     // MIs[0] op2
     /*  295573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295581 */     // MIs[0] op3
     /*  295581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  295599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295601 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295603 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295605 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295615 */     GIR_RootConstrainSelectedInstOperands,
     /*  295616 */     // GIR_Coverage, 63005,
     /*  295616 */     GIR_EraseRootFromParent_Done,
     /*  295617 */   // Label 5807: @295617
     /*  295617 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(295692), // Rule ID 63006 //
     /*  295622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  295633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295640 */     // MIs[0] op1
     /*  295640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295648 */     // MIs[0] op2
     /*  295648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295656 */     // MIs[0] op3
     /*  295656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  295674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295676 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295678 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295680 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295690 */     GIR_RootConstrainSelectedInstOperands,
     /*  295691 */     // GIR_Coverage, 63006,
     /*  295691 */     GIR_EraseRootFromParent_Done,
     /*  295692 */   // Label 5808: @295692
     /*  295692 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(295767), // Rule ID 63061 //
     /*  295697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  295708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295715 */     // MIs[0] op1
     /*  295715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295723 */     // MIs[0] op2
     /*  295723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295731 */     // MIs[0] op3
     /*  295731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  295749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295751 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295753 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295755 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295765 */     GIR_RootConstrainSelectedInstOperands,
     /*  295766 */     // GIR_Coverage, 63061,
     /*  295766 */     GIR_EraseRootFromParent_Done,
     /*  295767 */   // Label 5809: @295767
     /*  295767 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(295842), // Rule ID 63062 //
     /*  295772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  295783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295790 */     // MIs[0] op1
     /*  295790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295798 */     // MIs[0] op2
     /*  295798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295806 */     // MIs[0] op3
     /*  295806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295821 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  295824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295826 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295828 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295830 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295840 */     GIR_RootConstrainSelectedInstOperands,
     /*  295841 */     // GIR_Coverage, 63062,
     /*  295841 */     GIR_EraseRootFromParent_Done,
     /*  295842 */   // Label 5810: @295842
     /*  295842 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(295917), // Rule ID 63117 //
     /*  295847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  295850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  295858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  295861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295865 */     // MIs[0] op1
     /*  295865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295873 */     // MIs[0] op2
     /*  295873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295881 */     // MIs[0] op3
     /*  295881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  295899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295915 */     GIR_RootConstrainSelectedInstOperands,
     /*  295916 */     // GIR_Coverage, 63117,
     /*  295916 */     GIR_EraseRootFromParent_Done,
     /*  295917 */   // Label 5811: @295917
     /*  295917 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(295992), // Rule ID 63118 //
     /*  295922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  295925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  295930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  295933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  295936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295940 */     // MIs[0] op1
     /*  295940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  295943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  295948 */     // MIs[0] op2
     /*  295948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  295951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  295956 */     // MIs[0] op3
     /*  295956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  295959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  295964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  295974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  295978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  295980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  295982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295990 */     GIR_RootConstrainSelectedInstOperands,
     /*  295991 */     // GIR_Coverage, 63118,
     /*  295991 */     GIR_EraseRootFromParent_Done,
     /*  295992 */   // Label 5812: @295992
     /*  295992 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(296067), // Rule ID 63173 //
     /*  295997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  296005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  296008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296015 */     // MIs[0] op1
     /*  296015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296023 */     // MIs[0] op2
     /*  296023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296031 */     // MIs[0] op3
     /*  296031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  296034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  296039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296046 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  296049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296065 */     GIR_RootConstrainSelectedInstOperands,
     /*  296066 */     // GIR_Coverage, 63173,
     /*  296066 */     GIR_EraseRootFromParent_Done,
     /*  296067 */   // Label 5813: @296067
     /*  296067 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(296142), // Rule ID 63174 //
     /*  296072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  296080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  296083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296090 */     // MIs[0] op1
     /*  296090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296098 */     // MIs[0] op2
     /*  296098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296106 */     // MIs[0] op3
     /*  296106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  296109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  296114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296121 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  296124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296140 */     GIR_RootConstrainSelectedInstOperands,
     /*  296141 */     // GIR_Coverage, 63174,
     /*  296141 */     GIR_EraseRootFromParent_Done,
     /*  296142 */   // Label 5814: @296142
     /*  296142 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(296217), // Rule ID 63229 //
     /*  296147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  296155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  296158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296165 */     // MIs[0] op1
     /*  296165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296173 */     // MIs[0] op2
     /*  296173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296181 */     // MIs[0] op3
     /*  296181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  296184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  296189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  296199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296201 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296203 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296205 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296215 */     GIR_RootConstrainSelectedInstOperands,
     /*  296216 */     // GIR_Coverage, 63229,
     /*  296216 */     GIR_EraseRootFromParent_Done,
     /*  296217 */   // Label 5815: @296217
     /*  296217 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(296292), // Rule ID 63230 //
     /*  296222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  296230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  296233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296240 */     // MIs[0] op1
     /*  296240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296248 */     // MIs[0] op2
     /*  296248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296256 */     // MIs[0] op3
     /*  296256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  296259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  296264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296271 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10758:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  296274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296290 */     GIR_RootConstrainSelectedInstOperands,
     /*  296291 */     // GIR_Coverage, 63230,
     /*  296291 */     GIR_EraseRootFromParent_Done,
     /*  296292 */   // Label 5816: @296292
     /*  296292 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(296366), // Rule ID 62131 //
     /*  296297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  296308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296318 */     // MIs[0] op1
     /*  296318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296326 */     // MIs[0] op2
     /*  296326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296345 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  296348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296350 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296352 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296354 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296364 */     GIR_RootConstrainSelectedInstOperands,
     /*  296365 */     // GIR_Coverage, 62131,
     /*  296365 */     GIR_EraseRootFromParent_Done,
     /*  296366 */   // Label 5817: @296366
     /*  296366 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(296440), // Rule ID 62132 //
     /*  296371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  296382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296392 */     // MIs[0] op1
     /*  296392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296400 */     // MIs[0] op2
     /*  296400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296419 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  296422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296438 */     GIR_RootConstrainSelectedInstOperands,
     /*  296439 */     // GIR_Coverage, 62132,
     /*  296439 */     GIR_EraseRootFromParent_Done,
     /*  296440 */   // Label 5818: @296440
     /*  296440 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(296514), // Rule ID 62177 //
     /*  296445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  296456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296466 */     // MIs[0] op1
     /*  296466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296474 */     // MIs[0] op2
     /*  296474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296493 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  296496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296512 */     GIR_RootConstrainSelectedInstOperands,
     /*  296513 */     // GIR_Coverage, 62177,
     /*  296513 */     GIR_EraseRootFromParent_Done,
     /*  296514 */   // Label 5819: @296514
     /*  296514 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(296588), // Rule ID 62178 //
     /*  296519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  296530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296540 */     // MIs[0] op1
     /*  296540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296548 */     // MIs[0] op2
     /*  296548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296567 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  296570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296572 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296574 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296576 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296586 */     GIR_RootConstrainSelectedInstOperands,
     /*  296587 */     // GIR_Coverage, 62178,
     /*  296587 */     GIR_EraseRootFromParent_Done,
     /*  296588 */   // Label 5820: @296588
     /*  296588 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(296662), // Rule ID 62221 //
     /*  296593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  296604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296614 */     // MIs[0] op1
     /*  296614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296622 */     // MIs[0] op2
     /*  296622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296641 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  296644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296646 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296648 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296650 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296660 */     GIR_RootConstrainSelectedInstOperands,
     /*  296661 */     // GIR_Coverage, 62221,
     /*  296661 */     GIR_EraseRootFromParent_Done,
     /*  296662 */   // Label 5821: @296662
     /*  296662 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(296736), // Rule ID 62222 //
     /*  296667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  296678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296688 */     // MIs[0] op1
     /*  296688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296696 */     // MIs[0] op2
     /*  296696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296715 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  296718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296720 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296722 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296724 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296734 */     GIR_RootConstrainSelectedInstOperands,
     /*  296735 */     // GIR_Coverage, 62222,
     /*  296735 */     GIR_EraseRootFromParent_Done,
     /*  296736 */   // Label 5822: @296736
     /*  296736 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(296810), // Rule ID 62265 //
     /*  296741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  296752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296762 */     // MIs[0] op1
     /*  296762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296770 */     // MIs[0] op2
     /*  296770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  296792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296808 */     GIR_RootConstrainSelectedInstOperands,
     /*  296809 */     // GIR_Coverage, 62265,
     /*  296809 */     GIR_EraseRootFromParent_Done,
     /*  296810 */   // Label 5823: @296810
     /*  296810 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(296884), // Rule ID 62266 //
     /*  296815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  296826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296836 */     // MIs[0] op1
     /*  296836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296844 */     // MIs[0] op2
     /*  296844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296863 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  296866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296868 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296870 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296872 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296882 */     GIR_RootConstrainSelectedInstOperands,
     /*  296883 */     // GIR_Coverage, 62266,
     /*  296883 */     GIR_EraseRootFromParent_Done,
     /*  296884 */   // Label 5824: @296884
     /*  296884 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(296958), // Rule ID 62321 //
     /*  296889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  296892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  296900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  296906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296910 */     // MIs[0] op1
     /*  296910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296918 */     // MIs[0] op2
     /*  296918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  296926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  296940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296942 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  296944 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  296946 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  296948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296956 */     GIR_RootConstrainSelectedInstOperands,
     /*  296957 */     // GIR_Coverage, 62321,
     /*  296957 */     GIR_EraseRootFromParent_Done,
     /*  296958 */   // Label 5825: @296958
     /*  296958 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(297032), // Rule ID 62322 //
     /*  296963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  296966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  296971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  296974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  296980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296984 */     // MIs[0] op1
     /*  296984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  296987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  296992 */     // MIs[0] op2
     /*  296992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  296995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  297014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297016 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297018 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297020 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297030 */     GIR_RootConstrainSelectedInstOperands,
     /*  297031 */     // GIR_Coverage, 62322,
     /*  297031 */     GIR_EraseRootFromParent_Done,
     /*  297032 */   // Label 5826: @297032
     /*  297032 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(297106), // Rule ID 62377 //
     /*  297037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  297048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297058 */     // MIs[0] op1
     /*  297058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297066 */     // MIs[0] op2
     /*  297066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297085 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  297088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297090 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297092 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297094 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297104 */     GIR_RootConstrainSelectedInstOperands,
     /*  297105 */     // GIR_Coverage, 62377,
     /*  297105 */     GIR_EraseRootFromParent_Done,
     /*  297106 */   // Label 5827: @297106
     /*  297106 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(297180), // Rule ID 62378 //
     /*  297111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  297122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297132 */     // MIs[0] op1
     /*  297132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297140 */     // MIs[0] op2
     /*  297140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297159 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  297162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297164 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297166 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297168 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297178 */     GIR_RootConstrainSelectedInstOperands,
     /*  297179 */     // GIR_Coverage, 62378,
     /*  297179 */     GIR_EraseRootFromParent_Done,
     /*  297180 */   // Label 5828: @297180
     /*  297180 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(297254), // Rule ID 62433 //
     /*  297185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  297196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297206 */     // MIs[0] op1
     /*  297206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297214 */     // MIs[0] op2
     /*  297214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297233 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297238 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297240 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297242 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297252 */     GIR_RootConstrainSelectedInstOperands,
     /*  297253 */     // GIR_Coverage, 62433,
     /*  297253 */     GIR_EraseRootFromParent_Done,
     /*  297254 */   // Label 5829: @297254
     /*  297254 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(297328), // Rule ID 62434 //
     /*  297259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  297270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297280 */     // MIs[0] op1
     /*  297280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297288 */     // MIs[0] op2
     /*  297288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297326 */     GIR_RootConstrainSelectedInstOperands,
     /*  297327 */     // GIR_Coverage, 62434,
     /*  297327 */     GIR_EraseRootFromParent_Done,
     /*  297328 */   // Label 5830: @297328
     /*  297328 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(297402), // Rule ID 62477 //
     /*  297333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  297344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297354 */     // MIs[0] op1
     /*  297354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297362 */     // MIs[0] op2
     /*  297362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297381 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297386 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297388 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297390 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297400 */     GIR_RootConstrainSelectedInstOperands,
     /*  297401 */     // GIR_Coverage, 62477,
     /*  297401 */     GIR_EraseRootFromParent_Done,
     /*  297402 */   // Label 5831: @297402
     /*  297402 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(297476), // Rule ID 62478 //
     /*  297407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  297418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297428 */     // MIs[0] op1
     /*  297428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297436 */     // MIs[0] op2
     /*  297436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297455 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297474 */     GIR_RootConstrainSelectedInstOperands,
     /*  297475 */     // GIR_Coverage, 62478,
     /*  297475 */     GIR_EraseRootFromParent_Done,
     /*  297476 */   // Label 5832: @297476
     /*  297476 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(297550), // Rule ID 62533 //
     /*  297481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  297492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297502 */     // MIs[0] op1
     /*  297502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297510 */     // MIs[0] op2
     /*  297510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297529 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297534 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297536 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297538 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297548 */     GIR_RootConstrainSelectedInstOperands,
     /*  297549 */     // GIR_Coverage, 62533,
     /*  297549 */     GIR_EraseRootFromParent_Done,
     /*  297550 */   // Label 5833: @297550
     /*  297550 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(297624), // Rule ID 62534 //
     /*  297555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  297566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297576 */     // MIs[0] op1
     /*  297576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297584 */     // MIs[0] op2
     /*  297584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297603 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297622 */     GIR_RootConstrainSelectedInstOperands,
     /*  297623 */     // GIR_Coverage, 62534,
     /*  297623 */     GIR_EraseRootFromParent_Done,
     /*  297624 */   // Label 5834: @297624
     /*  297624 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(297698), // Rule ID 62589 //
     /*  297629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  297640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297650 */     // MIs[0] op1
     /*  297650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297658 */     // MIs[0] op2
     /*  297658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297682 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297684 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297686 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297696 */     GIR_RootConstrainSelectedInstOperands,
     /*  297697 */     // GIR_Coverage, 62589,
     /*  297697 */     GIR_EraseRootFromParent_Done,
     /*  297698 */   // Label 5835: @297698
     /*  297698 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(297772), // Rule ID 62590 //
     /*  297703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  297714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297724 */     // MIs[0] op1
     /*  297724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297732 */     // MIs[0] op2
     /*  297732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297751 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  297754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297770 */     GIR_RootConstrainSelectedInstOperands,
     /*  297771 */     // GIR_Coverage, 62590,
     /*  297771 */     GIR_EraseRootFromParent_Done,
     /*  297772 */   // Label 5836: @297772
     /*  297772 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(297846), // Rule ID 62645 //
     /*  297777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  297788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297798 */     // MIs[0] op1
     /*  297798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297806 */     // MIs[0] op2
     /*  297806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  297828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297844 */     GIR_RootConstrainSelectedInstOperands,
     /*  297845 */     // GIR_Coverage, 62645,
     /*  297845 */     GIR_EraseRootFromParent_Done,
     /*  297846 */   // Label 5837: @297846
     /*  297846 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(297920), // Rule ID 62646 //
     /*  297851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  297854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  297862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  297868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297872 */     // MIs[0] op1
     /*  297872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297880 */     // MIs[0] op2
     /*  297880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297899 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  297902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297904 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297906 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297908 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297918 */     GIR_RootConstrainSelectedInstOperands,
     /*  297919 */     // GIR_Coverage, 62646,
     /*  297919 */     GIR_EraseRootFromParent_Done,
     /*  297920 */   // Label 5838: @297920
     /*  297920 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(297994), // Rule ID 62689 //
     /*  297925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  297928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  297933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  297936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  297942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297946 */     // MIs[0] op1
     /*  297946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  297949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  297954 */     // MIs[0] op2
     /*  297954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  297957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  297962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297973 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  297976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  297980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  297982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  297984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297992 */     GIR_RootConstrainSelectedInstOperands,
     /*  297993 */     // GIR_Coverage, 62689,
     /*  297993 */     GIR_EraseRootFromParent_Done,
     /*  297994 */   // Label 5839: @297994
     /*  297994 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(298068), // Rule ID 62690 //
     /*  297999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  298010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298020 */     // MIs[0] op1
     /*  298020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298028 */     // MIs[0] op2
     /*  298028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298047 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  298050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298052 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298054 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298056 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298066 */     GIR_RootConstrainSelectedInstOperands,
     /*  298067 */     // GIR_Coverage, 62690,
     /*  298067 */     GIR_EraseRootFromParent_Done,
     /*  298068 */   // Label 5840: @298068
     /*  298068 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(298142), // Rule ID 62733 //
     /*  298073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  298084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298094 */     // MIs[0] op1
     /*  298094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298102 */     // MIs[0] op2
     /*  298102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298121 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  298124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298140 */     GIR_RootConstrainSelectedInstOperands,
     /*  298141 */     // GIR_Coverage, 62733,
     /*  298141 */     GIR_EraseRootFromParent_Done,
     /*  298142 */   // Label 5841: @298142
     /*  298142 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(298216), // Rule ID 62734 //
     /*  298147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  298158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298168 */     // MIs[0] op1
     /*  298168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298176 */     // MIs[0] op2
     /*  298176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298195 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  298198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298200 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298202 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298204 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298214 */     GIR_RootConstrainSelectedInstOperands,
     /*  298215 */     // GIR_Coverage, 62734,
     /*  298215 */     GIR_EraseRootFromParent_Done,
     /*  298216 */   // Label 5842: @298216
     /*  298216 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(298290), // Rule ID 62777 //
     /*  298221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  298232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298242 */     // MIs[0] op1
     /*  298242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298250 */     // MIs[0] op2
     /*  298250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  298272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298288 */     GIR_RootConstrainSelectedInstOperands,
     /*  298289 */     // GIR_Coverage, 62777,
     /*  298289 */     GIR_EraseRootFromParent_Done,
     /*  298290 */   // Label 5843: @298290
     /*  298290 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(298364), // Rule ID 62778 //
     /*  298295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  298306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298316 */     // MIs[0] op1
     /*  298316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298324 */     // MIs[0] op2
     /*  298324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  298346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298348 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298350 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298352 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298362 */     GIR_RootConstrainSelectedInstOperands,
     /*  298363 */     // GIR_Coverage, 62778,
     /*  298363 */     GIR_EraseRootFromParent_Done,
     /*  298364 */   // Label 5844: @298364
     /*  298364 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(298438), // Rule ID 62833 //
     /*  298369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  298380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298390 */     // MIs[0] op1
     /*  298390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298398 */     // MIs[0] op2
     /*  298398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298417 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  298420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298422 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298424 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298426 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298436 */     GIR_RootConstrainSelectedInstOperands,
     /*  298437 */     // GIR_Coverage, 62833,
     /*  298437 */     GIR_EraseRootFromParent_Done,
     /*  298438 */   // Label 5845: @298438
     /*  298438 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(298512), // Rule ID 62834 //
     /*  298443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  298454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298464 */     // MIs[0] op1
     /*  298464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298472 */     // MIs[0] op2
     /*  298472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298491 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  298494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298496 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298498 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298500 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298510 */     GIR_RootConstrainSelectedInstOperands,
     /*  298511 */     // GIR_Coverage, 62834,
     /*  298511 */     GIR_EraseRootFromParent_Done,
     /*  298512 */   // Label 5846: @298512
     /*  298512 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(298586), // Rule ID 62889 //
     /*  298517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  298528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298538 */     // MIs[0] op1
     /*  298538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298546 */     // MIs[0] op2
     /*  298546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  298568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298570 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298572 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298574 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298584 */     GIR_RootConstrainSelectedInstOperands,
     /*  298585 */     // GIR_Coverage, 62889,
     /*  298585 */     GIR_EraseRootFromParent_Done,
     /*  298586 */   // Label 5847: @298586
     /*  298586 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(298660), // Rule ID 62890 //
     /*  298591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  298602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298612 */     // MIs[0] op1
     /*  298612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298620 */     // MIs[0] op2
     /*  298620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298639 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  298642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298658 */     GIR_RootConstrainSelectedInstOperands,
     /*  298659 */     // GIR_Coverage, 62890,
     /*  298659 */     GIR_EraseRootFromParent_Done,
     /*  298660 */   // Label 5848: @298660
     /*  298660 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(298734), // Rule ID 62945 //
     /*  298665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  298676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298686 */     // MIs[0] op1
     /*  298686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298694 */     // MIs[0] op2
     /*  298694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  298716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298732 */     GIR_RootConstrainSelectedInstOperands,
     /*  298733 */     // GIR_Coverage, 62945,
     /*  298733 */     GIR_EraseRootFromParent_Done,
     /*  298734 */   // Label 5849: @298734
     /*  298734 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(298808), // Rule ID 62946 //
     /*  298739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  298750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298760 */     // MIs[0] op1
     /*  298760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298768 */     // MIs[0] op2
     /*  298768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  298790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298806 */     GIR_RootConstrainSelectedInstOperands,
     /*  298807 */     // GIR_Coverage, 62946,
     /*  298807 */     GIR_EraseRootFromParent_Done,
     /*  298808 */   // Label 5850: @298808
     /*  298808 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(298882), // Rule ID 63001 //
     /*  298813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  298824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298834 */     // MIs[0] op1
     /*  298834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298842 */     // MIs[0] op2
     /*  298842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298861 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  298864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298880 */     GIR_RootConstrainSelectedInstOperands,
     /*  298881 */     // GIR_Coverage, 63001,
     /*  298881 */     GIR_EraseRootFromParent_Done,
     /*  298882 */   // Label 5851: @298882
     /*  298882 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(298956), // Rule ID 63002 //
     /*  298887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  298890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  298898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  298904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298908 */     // MIs[0] op1
     /*  298908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298916 */     // MIs[0] op2
     /*  298916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298935 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  298938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298940 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  298942 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  298944 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  298946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298954 */     GIR_RootConstrainSelectedInstOperands,
     /*  298955 */     // GIR_Coverage, 63002,
     /*  298955 */     GIR_EraseRootFromParent_Done,
     /*  298956 */   // Label 5852: @298956
     /*  298956 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(299030), // Rule ID 63057 //
     /*  298961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  298964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  298969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  298972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  298978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298982 */     // MIs[0] op1
     /*  298982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  298985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  298990 */     // MIs[0] op2
     /*  298990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  298993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  298998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299009 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  299012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299014 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299016 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299018 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299028 */     GIR_RootConstrainSelectedInstOperands,
     /*  299029 */     // GIR_Coverage, 63057,
     /*  299029 */     GIR_EraseRootFromParent_Done,
     /*  299030 */   // Label 5853: @299030
     /*  299030 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(299104), // Rule ID 63058 //
     /*  299035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  299046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299056 */     // MIs[0] op1
     /*  299056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299064 */     // MIs[0] op2
     /*  299064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299083 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  299086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299102 */     GIR_RootConstrainSelectedInstOperands,
     /*  299103 */     // GIR_Coverage, 63058,
     /*  299103 */     GIR_EraseRootFromParent_Done,
     /*  299104 */   // Label 5854: @299104
     /*  299104 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(299178), // Rule ID 63113 //
     /*  299109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  299120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299130 */     // MIs[0] op1
     /*  299130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299138 */     // MIs[0] op2
     /*  299138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  299160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299176 */     GIR_RootConstrainSelectedInstOperands,
     /*  299177 */     // GIR_Coverage, 63113,
     /*  299177 */     GIR_EraseRootFromParent_Done,
     /*  299178 */   // Label 5855: @299178
     /*  299178 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(299252), // Rule ID 63114 //
     /*  299183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  299194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299204 */     // MIs[0] op1
     /*  299204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299212 */     // MIs[0] op2
     /*  299212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299231 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  299234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299236 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299238 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299240 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299250 */     GIR_RootConstrainSelectedInstOperands,
     /*  299251 */     // GIR_Coverage, 63114,
     /*  299251 */     GIR_EraseRootFromParent_Done,
     /*  299252 */   // Label 5856: @299252
     /*  299252 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(299326), // Rule ID 63169 //
     /*  299257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  299268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299278 */     // MIs[0] op1
     /*  299278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299286 */     // MIs[0] op2
     /*  299286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299305 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  299308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299324 */     GIR_RootConstrainSelectedInstOperands,
     /*  299325 */     // GIR_Coverage, 63169,
     /*  299325 */     GIR_EraseRootFromParent_Done,
     /*  299326 */   // Label 5857: @299326
     /*  299326 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(299400), // Rule ID 63170 //
     /*  299331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  299342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299352 */     // MIs[0] op1
     /*  299352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299360 */     // MIs[0] op2
     /*  299360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  299382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299384 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299386 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299388 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299398 */     GIR_RootConstrainSelectedInstOperands,
     /*  299399 */     // GIR_Coverage, 63170,
     /*  299399 */     GIR_EraseRootFromParent_Done,
     /*  299400 */   // Label 5858: @299400
     /*  299400 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(299474), // Rule ID 63225 //
     /*  299405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  299416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299426 */     // MIs[0] op1
     /*  299426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299434 */     // MIs[0] op2
     /*  299434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299453 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  299456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299472 */     GIR_RootConstrainSelectedInstOperands,
     /*  299473 */     // GIR_Coverage, 63225,
     /*  299473 */     GIR_EraseRootFromParent_Done,
     /*  299474 */   // Label 5859: @299474
     /*  299474 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(299548), // Rule ID 63226 //
     /*  299479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  299487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  299490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299500 */     // MIs[0] op1
     /*  299500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299508 */     // MIs[0] op2
     /*  299508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  299511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  299516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  299530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299532 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299534 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299536 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299546 */     GIR_RootConstrainSelectedInstOperands,
     /*  299547 */     // GIR_Coverage, 63226,
     /*  299547 */     GIR_EraseRootFromParent_Done,
     /*  299548 */   // Label 5860: @299548
     /*  299548 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(299622), // Rule ID 62155 //
     /*  299553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  299564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  299567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299574 */     // MIs[0] op1
     /*  299574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299586 */     // MIs[0] op3
     /*  299586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  299604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299620 */     GIR_RootConstrainSelectedInstOperands,
     /*  299621 */     // GIR_Coverage, 62155,
     /*  299621 */     GIR_EraseRootFromParent_Done,
     /*  299622 */   // Label 5861: @299622
     /*  299622 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(299696), // Rule ID 62156 //
     /*  299627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  299638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  299641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299648 */     // MIs[0] op1
     /*  299648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299660 */     // MIs[0] op3
     /*  299660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299675 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  299678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299680 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299682 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299684 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299694 */     GIR_RootConstrainSelectedInstOperands,
     /*  299695 */     // GIR_Coverage, 62156,
     /*  299695 */     GIR_EraseRootFromParent_Done,
     /*  299696 */   // Label 5862: @299696
     /*  299696 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(299770), // Rule ID 62193 //
     /*  299701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  299712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  299715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299722 */     // MIs[0] op1
     /*  299722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299734 */     // MIs[0] op3
     /*  299734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299749 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  299752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299754 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299756 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299758 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299768 */     GIR_RootConstrainSelectedInstOperands,
     /*  299769 */     // GIR_Coverage, 62193,
     /*  299769 */     GIR_EraseRootFromParent_Done,
     /*  299770 */   // Label 5863: @299770
     /*  299770 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(299844), // Rule ID 62194 //
     /*  299775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  299786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  299789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299796 */     // MIs[0] op1
     /*  299796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299808 */     // MIs[0] op3
     /*  299808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299823 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  299826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299828 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299830 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299832 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299842 */     GIR_RootConstrainSelectedInstOperands,
     /*  299843 */     // GIR_Coverage, 62194,
     /*  299843 */     GIR_EraseRootFromParent_Done,
     /*  299844 */   // Label 5864: @299844
     /*  299844 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(299918), // Rule ID 62237 //
     /*  299849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  299852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  299860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  299863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  299866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299870 */     // MIs[0] op1
     /*  299870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299882 */     // MIs[0] op3
     /*  299882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299897 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  299900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299902 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299904 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299906 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299916 */     GIR_RootConstrainSelectedInstOperands,
     /*  299917 */     // GIR_Coverage, 62237,
     /*  299917 */     GIR_EraseRootFromParent_Done,
     /*  299918 */   // Label 5865: @299918
     /*  299918 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(299992), // Rule ID 62238 //
     /*  299923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  299926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  299931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  299934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  299937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  299940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299944 */     // MIs[0] op1
     /*  299944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  299947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  299952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299956 */     // MIs[0] op3
     /*  299956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  299959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  299964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  299974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  299978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  299980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  299982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299990 */     GIR_RootConstrainSelectedInstOperands,
     /*  299991 */     // GIR_Coverage, 62238,
     /*  299991 */     GIR_EraseRootFromParent_Done,
     /*  299992 */   // Label 5866: @299992
     /*  299992 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(300066), // Rule ID 62281 //
     /*  299997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  300008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300018 */     // MIs[0] op1
     /*  300018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300030 */     // MIs[0] op3
     /*  300030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300045 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  300048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300050 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300052 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300054 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300064 */     GIR_RootConstrainSelectedInstOperands,
     /*  300065 */     // GIR_Coverage, 62281,
     /*  300065 */     GIR_EraseRootFromParent_Done,
     /*  300066 */   // Label 5867: @300066
     /*  300066 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(300140), // Rule ID 62282 //
     /*  300071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  300082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300092 */     // MIs[0] op1
     /*  300092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300104 */     // MIs[0] op3
     /*  300104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300119 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  300122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300138 */     GIR_RootConstrainSelectedInstOperands,
     /*  300139 */     // GIR_Coverage, 62282,
     /*  300139 */     GIR_EraseRootFromParent_Done,
     /*  300140 */   // Label 5868: @300140
     /*  300140 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(300214), // Rule ID 62337 //
     /*  300145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  300156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300166 */     // MIs[0] op1
     /*  300166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300178 */     // MIs[0] op3
     /*  300178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  300196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300198 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300200 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300202 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300212 */     GIR_RootConstrainSelectedInstOperands,
     /*  300213 */     // GIR_Coverage, 62337,
     /*  300213 */     GIR_EraseRootFromParent_Done,
     /*  300214 */   // Label 5869: @300214
     /*  300214 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(300288), // Rule ID 62338 //
     /*  300219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  300230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300240 */     // MIs[0] op1
     /*  300240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300252 */     // MIs[0] op3
     /*  300252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  300270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300286 */     GIR_RootConstrainSelectedInstOperands,
     /*  300287 */     // GIR_Coverage, 62338,
     /*  300287 */     GIR_EraseRootFromParent_Done,
     /*  300288 */   // Label 5870: @300288
     /*  300288 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(300362), // Rule ID 62393 //
     /*  300293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  300304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300314 */     // MIs[0] op1
     /*  300314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300326 */     // MIs[0] op3
     /*  300326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300341 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  300344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300360 */     GIR_RootConstrainSelectedInstOperands,
     /*  300361 */     // GIR_Coverage, 62393,
     /*  300361 */     GIR_EraseRootFromParent_Done,
     /*  300362 */   // Label 5871: @300362
     /*  300362 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(300436), // Rule ID 62394 //
     /*  300367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  300378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300388 */     // MIs[0] op1
     /*  300388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300400 */     // MIs[0] op3
     /*  300400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300415 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  300418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300434 */     GIR_RootConstrainSelectedInstOperands,
     /*  300435 */     // GIR_Coverage, 62394,
     /*  300435 */     GIR_EraseRootFromParent_Done,
     /*  300436 */   // Label 5872: @300436
     /*  300436 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(300510), // Rule ID 62449 //
     /*  300441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  300452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300462 */     // MIs[0] op1
     /*  300462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300474 */     // MIs[0] op3
     /*  300474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300489 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300508 */     GIR_RootConstrainSelectedInstOperands,
     /*  300509 */     // GIR_Coverage, 62449,
     /*  300509 */     GIR_EraseRootFromParent_Done,
     /*  300510 */   // Label 5873: @300510
     /*  300510 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(300584), // Rule ID 62450 //
     /*  300515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  300526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300536 */     // MIs[0] op1
     /*  300536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300548 */     // MIs[0] op3
     /*  300548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300563 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300582 */     GIR_RootConstrainSelectedInstOperands,
     /*  300583 */     // GIR_Coverage, 62450,
     /*  300583 */     GIR_EraseRootFromParent_Done,
     /*  300584 */   // Label 5874: @300584
     /*  300584 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(300658), // Rule ID 62493 //
     /*  300589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  300600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300610 */     // MIs[0] op1
     /*  300610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300622 */     // MIs[0] op3
     /*  300622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300637 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300656 */     GIR_RootConstrainSelectedInstOperands,
     /*  300657 */     // GIR_Coverage, 62493,
     /*  300657 */     GIR_EraseRootFromParent_Done,
     /*  300658 */   // Label 5875: @300658
     /*  300658 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(300732), // Rule ID 62494 //
     /*  300663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  300674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300684 */     // MIs[0] op1
     /*  300684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300696 */     // MIs[0] op3
     /*  300696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300711 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300716 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300718 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300720 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300730 */     GIR_RootConstrainSelectedInstOperands,
     /*  300731 */     // GIR_Coverage, 62494,
     /*  300731 */     GIR_EraseRootFromParent_Done,
     /*  300732 */   // Label 5876: @300732
     /*  300732 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(300806), // Rule ID 62549 //
     /*  300737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  300748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  300751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300758 */     // MIs[0] op1
     /*  300758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300770 */     // MIs[0] op3
     /*  300770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300785 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300804 */     GIR_RootConstrainSelectedInstOperands,
     /*  300805 */     // GIR_Coverage, 62549,
     /*  300805 */     GIR_EraseRootFromParent_Done,
     /*  300806 */   // Label 5877: @300806
     /*  300806 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(300880), // Rule ID 62550 //
     /*  300811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  300822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  300825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300832 */     // MIs[0] op1
     /*  300832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300844 */     // MIs[0] op3
     /*  300844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300864 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300866 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300868 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300878 */     GIR_RootConstrainSelectedInstOperands,
     /*  300879 */     // GIR_Coverage, 62550,
     /*  300879 */     GIR_EraseRootFromParent_Done,
     /*  300880 */   // Label 5878: @300880
     /*  300880 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(300954), // Rule ID 62605 //
     /*  300885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  300888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  300896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  300899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  300902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300906 */     // MIs[0] op1
     /*  300906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300918 */     // MIs[0] op3
     /*  300918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  300926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300933 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  300936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  300940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  300942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  300944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300952 */     GIR_RootConstrainSelectedInstOperands,
     /*  300953 */     // GIR_Coverage, 62605,
     /*  300953 */     GIR_EraseRootFromParent_Done,
     /*  300954 */   // Label 5879: @300954
     /*  300954 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(301028), // Rule ID 62606 //
     /*  300959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  300962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  300967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  300970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  300973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  300976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300980 */     // MIs[0] op1
     /*  300980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  300983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  300988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300992 */     // MIs[0] op3
     /*  300992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  300995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301007 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  301010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301012 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301014 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301016 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301026 */     GIR_RootConstrainSelectedInstOperands,
     /*  301027 */     // GIR_Coverage, 62606,
     /*  301027 */     GIR_EraseRootFromParent_Done,
     /*  301028 */   // Label 5880: @301028
     /*  301028 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(301102), // Rule ID 62661 //
     /*  301033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  301044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301054 */     // MIs[0] op1
     /*  301054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301066 */     // MIs[0] op3
     /*  301066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301081 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  301084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301100 */     GIR_RootConstrainSelectedInstOperands,
     /*  301101 */     // GIR_Coverage, 62661,
     /*  301101 */     GIR_EraseRootFromParent_Done,
     /*  301102 */   // Label 5881: @301102
     /*  301102 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(301176), // Rule ID 62662 //
     /*  301107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  301118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301128 */     // MIs[0] op1
     /*  301128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301140 */     // MIs[0] op3
     /*  301140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  301158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301160 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301162 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301164 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301174 */     GIR_RootConstrainSelectedInstOperands,
     /*  301175 */     // GIR_Coverage, 62662,
     /*  301175 */     GIR_EraseRootFromParent_Done,
     /*  301176 */   // Label 5882: @301176
     /*  301176 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(301250), // Rule ID 62705 //
     /*  301181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  301192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301202 */     // MIs[0] op1
     /*  301202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301214 */     // MIs[0] op3
     /*  301214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  301232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301234 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301236 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301238 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301248 */     GIR_RootConstrainSelectedInstOperands,
     /*  301249 */     // GIR_Coverage, 62705,
     /*  301249 */     GIR_EraseRootFromParent_Done,
     /*  301250 */   // Label 5883: @301250
     /*  301250 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(301324), // Rule ID 62706 //
     /*  301255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  301266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301276 */     // MIs[0] op1
     /*  301276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301288 */     // MIs[0] op3
     /*  301288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301303 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  301306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301322 */     GIR_RootConstrainSelectedInstOperands,
     /*  301323 */     // GIR_Coverage, 62706,
     /*  301323 */     GIR_EraseRootFromParent_Done,
     /*  301324 */   // Label 5884: @301324
     /*  301324 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(301398), // Rule ID 62749 //
     /*  301329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  301340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301350 */     // MIs[0] op1
     /*  301350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301362 */     // MIs[0] op3
     /*  301362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301377 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  301380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301382 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301384 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301386 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301396 */     GIR_RootConstrainSelectedInstOperands,
     /*  301397 */     // GIR_Coverage, 62749,
     /*  301397 */     GIR_EraseRootFromParent_Done,
     /*  301398 */   // Label 5885: @301398
     /*  301398 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(301472), // Rule ID 62750 //
     /*  301403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  301414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301424 */     // MIs[0] op1
     /*  301424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301436 */     // MIs[0] op3
     /*  301436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301451 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  301454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301470 */     GIR_RootConstrainSelectedInstOperands,
     /*  301471 */     // GIR_Coverage, 62750,
     /*  301471 */     GIR_EraseRootFromParent_Done,
     /*  301472 */   // Label 5886: @301472
     /*  301472 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(301546), // Rule ID 62793 //
     /*  301477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  301488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301498 */     // MIs[0] op1
     /*  301498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301510 */     // MIs[0] op3
     /*  301510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  301528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301530 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301532 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301534 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301544 */     GIR_RootConstrainSelectedInstOperands,
     /*  301545 */     // GIR_Coverage, 62793,
     /*  301545 */     GIR_EraseRootFromParent_Done,
     /*  301546 */   // Label 5887: @301546
     /*  301546 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(301620), // Rule ID 62794 //
     /*  301551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  301562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301572 */     // MIs[0] op1
     /*  301572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301584 */     // MIs[0] op3
     /*  301584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  301602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301618 */     GIR_RootConstrainSelectedInstOperands,
     /*  301619 */     // GIR_Coverage, 62794,
     /*  301619 */     GIR_EraseRootFromParent_Done,
     /*  301620 */   // Label 5888: @301620
     /*  301620 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(301694), // Rule ID 62849 //
     /*  301625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  301636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301646 */     // MIs[0] op1
     /*  301646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301658 */     // MIs[0] op3
     /*  301658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301673 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  301676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301678 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301680 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301682 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301692 */     GIR_RootConstrainSelectedInstOperands,
     /*  301693 */     // GIR_Coverage, 62849,
     /*  301693 */     GIR_EraseRootFromParent_Done,
     /*  301694 */   // Label 5889: @301694
     /*  301694 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(301768), // Rule ID 62850 //
     /*  301699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  301710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301720 */     // MIs[0] op1
     /*  301720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301732 */     // MIs[0] op3
     /*  301732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301747 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  301750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301766 */     GIR_RootConstrainSelectedInstOperands,
     /*  301767 */     // GIR_Coverage, 62850,
     /*  301767 */     GIR_EraseRootFromParent_Done,
     /*  301768 */   // Label 5890: @301768
     /*  301768 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(301842), // Rule ID 62905 //
     /*  301773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  301784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301794 */     // MIs[0] op1
     /*  301794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301806 */     // MIs[0] op3
     /*  301806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  301824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301826 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301828 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301830 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301840 */     GIR_RootConstrainSelectedInstOperands,
     /*  301841 */     // GIR_Coverage, 62905,
     /*  301841 */     GIR_EraseRootFromParent_Done,
     /*  301842 */   // Label 5891: @301842
     /*  301842 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(301916), // Rule ID 62906 //
     /*  301847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  301858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  301864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301868 */     // MIs[0] op1
     /*  301868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301880 */     // MIs[0] op3
     /*  301880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301895 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  301898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301900 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301902 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301904 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301914 */     GIR_RootConstrainSelectedInstOperands,
     /*  301915 */     // GIR_Coverage, 62906,
     /*  301915 */     GIR_EraseRootFromParent_Done,
     /*  301916 */   // Label 5892: @301916
     /*  301916 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(301990), // Rule ID 62961 //
     /*  301921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  301924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  301929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  301932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  301935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  301938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301942 */     // MIs[0] op1
     /*  301942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  301945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  301950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301954 */     // MIs[0] op3
     /*  301954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  301957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  301962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  301972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  301976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  301978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  301980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301988 */     GIR_RootConstrainSelectedInstOperands,
     /*  301989 */     // GIR_Coverage, 62961,
     /*  301989 */     GIR_EraseRootFromParent_Done,
     /*  301990 */   // Label 5893: @301990
     /*  301990 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(302064), // Rule ID 62962 //
     /*  301995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  301998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  302006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302016 */     // MIs[0] op1
     /*  302016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302028 */     // MIs[0] op3
     /*  302028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  302046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302062 */     GIR_RootConstrainSelectedInstOperands,
     /*  302063 */     // GIR_Coverage, 62962,
     /*  302063 */     GIR_EraseRootFromParent_Done,
     /*  302064 */   // Label 5894: @302064
     /*  302064 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(302138), // Rule ID 63017 //
     /*  302069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  302072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  302080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302090 */     // MIs[0] op1
     /*  302090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302102 */     // MIs[0] op3
     /*  302102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302117 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  302120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302122 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302124 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302126 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302136 */     GIR_RootConstrainSelectedInstOperands,
     /*  302137 */     // GIR_Coverage, 63017,
     /*  302137 */     GIR_EraseRootFromParent_Done,
     /*  302138 */   // Label 5895: @302138
     /*  302138 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(302212), // Rule ID 63018 //
     /*  302143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  302146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  302154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302164 */     // MIs[0] op1
     /*  302164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302176 */     // MIs[0] op3
     /*  302176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  302194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302196 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302198 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302200 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302210 */     GIR_RootConstrainSelectedInstOperands,
     /*  302211 */     // GIR_Coverage, 63018,
     /*  302211 */     GIR_EraseRootFromParent_Done,
     /*  302212 */   // Label 5896: @302212
     /*  302212 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(302286), // Rule ID 63073 //
     /*  302217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  302220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  302228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302238 */     // MIs[0] op1
     /*  302238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302250 */     // MIs[0] op3
     /*  302250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302265 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  302268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302270 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302272 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302274 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302284 */     GIR_RootConstrainSelectedInstOperands,
     /*  302285 */     // GIR_Coverage, 63073,
     /*  302285 */     GIR_EraseRootFromParent_Done,
     /*  302286 */   // Label 5897: @302286
     /*  302286 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(302360), // Rule ID 63074 //
     /*  302291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  302294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  302302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302312 */     // MIs[0] op1
     /*  302312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302324 */     // MIs[0] op3
     /*  302324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  302342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302344 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302346 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302348 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302358 */     GIR_RootConstrainSelectedInstOperands,
     /*  302359 */     // GIR_Coverage, 63074,
     /*  302359 */     GIR_EraseRootFromParent_Done,
     /*  302360 */   // Label 5898: @302360
     /*  302360 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(302434), // Rule ID 63129 //
     /*  302365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  302368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  302376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302386 */     // MIs[0] op1
     /*  302386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302398 */     // MIs[0] op3
     /*  302398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302413 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  302416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302432 */     GIR_RootConstrainSelectedInstOperands,
     /*  302433 */     // GIR_Coverage, 63129,
     /*  302433 */     GIR_EraseRootFromParent_Done,
     /*  302434 */   // Label 5899: @302434
     /*  302434 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(302508), // Rule ID 63130 //
     /*  302439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  302442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  302450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302460 */     // MIs[0] op1
     /*  302460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302472 */     // MIs[0] op3
     /*  302472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  302490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302492 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302494 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302496 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302506 */     GIR_RootConstrainSelectedInstOperands,
     /*  302507 */     // GIR_Coverage, 63130,
     /*  302507 */     GIR_EraseRootFromParent_Done,
     /*  302508 */   // Label 5900: @302508
     /*  302508 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(302582), // Rule ID 63185 //
     /*  302513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  302516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  302524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302534 */     // MIs[0] op1
     /*  302534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302546 */     // MIs[0] op3
     /*  302546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302561 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  302564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302566 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302568 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302570 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302580 */     GIR_RootConstrainSelectedInstOperands,
     /*  302581 */     // GIR_Coverage, 63185,
     /*  302581 */     GIR_EraseRootFromParent_Done,
     /*  302582 */   // Label 5901: @302582
     /*  302582 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(302656), // Rule ID 63186 //
     /*  302587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  302590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  302598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302608 */     // MIs[0] op1
     /*  302608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302620 */     // MIs[0] op3
     /*  302620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302635 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  302638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302640 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302642 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302644 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302654 */     GIR_RootConstrainSelectedInstOperands,
     /*  302655 */     // GIR_Coverage, 63186,
     /*  302655 */     GIR_EraseRootFromParent_Done,
     /*  302656 */   // Label 5902: @302656
     /*  302656 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(302730), // Rule ID 63241 //
     /*  302661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  302664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  302672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302682 */     // MIs[0] op1
     /*  302682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302694 */     // MIs[0] op3
     /*  302694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  302712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302714 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302716 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302718 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302728 */     GIR_RootConstrainSelectedInstOperands,
     /*  302729 */     // GIR_Coverage, 63241,
     /*  302729 */     GIR_EraseRootFromParent_Done,
     /*  302730 */   // Label 5903: @302730
     /*  302730 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(302804), // Rule ID 63242 //
     /*  302735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  302738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  302743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  302746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302756 */     // MIs[0] op1
     /*  302756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  302759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  302764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302768 */     // MIs[0] op3
     /*  302768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  302771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  302776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302783 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10760:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  302786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  302790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  302792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  302794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302802 */     GIR_RootConstrainSelectedInstOperands,
     /*  302803 */     // GIR_Coverage, 63242,
     /*  302803 */     GIR_EraseRootFromParent_Done,
     /*  302804 */   // Label 5904: @302804
     /*  302804 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(302879), // Rule ID 7206 //
     /*  302809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  302817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  302820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  302848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302855 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  302855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  302858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  302862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  302877 */     GIR_RootConstrainSelectedInstOperands,
     /*  302878 */     // GIR_Coverage, 7206,
     /*  302878 */     GIR_EraseRootFromParent_Done,
     /*  302879 */   // Label 5905: @302879
     /*  302879 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(302954), // Rule ID 7207 //
     /*  302884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  302892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  302895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  302907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  302923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302930 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  302930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  302933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  302937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  302952 */     GIR_RootConstrainSelectedInstOperands,
     /*  302953 */     // GIR_Coverage, 7207,
     /*  302953 */     GIR_EraseRootFromParent_Done,
     /*  302954 */   // Label 5906: @302954
     /*  302954 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(303029), // Rule ID 7210 //
     /*  302959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  302967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  302970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  302973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  302976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  302982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  302998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303005 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  303005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  303008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303027 */     GIR_RootConstrainSelectedInstOperands,
     /*  303028 */     // GIR_Coverage, 7210,
     /*  303028 */     GIR_EraseRootFromParent_Done,
     /*  303029 */   // Label 5907: @303029
     /*  303029 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(303104), // Rule ID 7211 //
     /*  303034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  303045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  303080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  303083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303102 */     GIR_RootConstrainSelectedInstOperands,
     /*  303103 */     // GIR_Coverage, 7211,
     /*  303103 */     GIR_EraseRootFromParent_Done,
     /*  303104 */   // Label 5908: @303104
     /*  303104 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(303179), // Rule ID 7214 //
     /*  303109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  303120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303155 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  303155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303177 */     GIR_RootConstrainSelectedInstOperands,
     /*  303178 */     // GIR_Coverage, 7214,
     /*  303178 */     GIR_EraseRootFromParent_Done,
     /*  303179 */   // Label 5909: @303179
     /*  303179 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(303254), // Rule ID 7215 //
     /*  303184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  303195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303230 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  303230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303252 */     GIR_RootConstrainSelectedInstOperands,
     /*  303253 */     // GIR_Coverage, 7215,
     /*  303253 */     GIR_EraseRootFromParent_Done,
     /*  303254 */   // Label 5910: @303254
     /*  303254 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(303329), // Rule ID 7218 //
     /*  303259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  303270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303305 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  303305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  303308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303327 */     GIR_RootConstrainSelectedInstOperands,
     /*  303328 */     // GIR_Coverage, 7218,
     /*  303328 */     GIR_EraseRootFromParent_Done,
     /*  303329 */   // Label 5911: @303329
     /*  303329 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(303404), // Rule ID 7219 //
     /*  303334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  303345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  303380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  303383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303402 */     GIR_RootConstrainSelectedInstOperands,
     /*  303403 */     // GIR_Coverage, 7219,
     /*  303403 */     GIR_EraseRootFromParent_Done,
     /*  303404 */   // Label 5912: @303404
     /*  303404 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(303479), // Rule ID 7222 //
     /*  303409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  303420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303455 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  303455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303477 */     GIR_RootConstrainSelectedInstOperands,
     /*  303478 */     // GIR_Coverage, 7222,
     /*  303478 */     GIR_EraseRootFromParent_Done,
     /*  303479 */   // Label 5913: @303479
     /*  303479 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(303554), // Rule ID 7223 //
     /*  303484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  303495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  303530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303552 */     GIR_RootConstrainSelectedInstOperands,
     /*  303553 */     // GIR_Coverage, 7223,
     /*  303553 */     GIR_EraseRootFromParent_Done,
     /*  303554 */   // Label 5914: @303554
     /*  303554 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(303629), // Rule ID 7226 //
     /*  303559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  303570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303605 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  303605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303627 */     GIR_RootConstrainSelectedInstOperands,
     /*  303628 */     // GIR_Coverage, 7226,
     /*  303628 */     GIR_EraseRootFromParent_Done,
     /*  303629 */   // Label 5915: @303629
     /*  303629 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(303704), // Rule ID 7227 //
     /*  303634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  303645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  303680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  303683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303702 */     GIR_RootConstrainSelectedInstOperands,
     /*  303703 */     // GIR_Coverage, 7227,
     /*  303703 */     GIR_EraseRootFromParent_Done,
     /*  303704 */   // Label 5916: @303704
     /*  303704 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(303779), // Rule ID 7230 //
     /*  303709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  303720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303755 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  303755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  303758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303777 */     GIR_RootConstrainSelectedInstOperands,
     /*  303778 */     // GIR_Coverage, 7230,
     /*  303778 */     GIR_EraseRootFromParent_Done,
     /*  303779 */   // Label 5917: @303779
     /*  303779 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(303854), // Rule ID 7231 //
     /*  303784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  303795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303830 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  303830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  303833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303852 */     GIR_RootConstrainSelectedInstOperands,
     /*  303853 */     // GIR_Coverage, 7231,
     /*  303853 */     GIR_EraseRootFromParent_Done,
     /*  303854 */   // Label 5918: @303854
     /*  303854 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(303929), // Rule ID 7234 //
     /*  303859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  303870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  303882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303905 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  303905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  303908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  303927 */     GIR_RootConstrainSelectedInstOperands,
     /*  303928 */     // GIR_Coverage, 7234,
     /*  303928 */     GIR_EraseRootFromParent_Done,
     /*  303929 */   // Label 5919: @303929
     /*  303929 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(304004), // Rule ID 7235 //
     /*  303934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  303942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  303945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  303957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  303973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  303980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  303983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  303987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304002 */     GIR_RootConstrainSelectedInstOperands,
     /*  304003 */     // GIR_Coverage, 7235,
     /*  304003 */     GIR_EraseRootFromParent_Done,
     /*  304004 */   // Label 5920: @304004
     /*  304004 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(304079), // Rule ID 7238 //
     /*  304009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  304020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  304055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  304058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304077 */     GIR_RootConstrainSelectedInstOperands,
     /*  304078 */     // GIR_Coverage, 7238,
     /*  304078 */     GIR_EraseRootFromParent_Done,
     /*  304079 */   // Label 5921: @304079
     /*  304079 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(304154), // Rule ID 7239 //
     /*  304084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  304095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  304130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  304133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304152 */     GIR_RootConstrainSelectedInstOperands,
     /*  304153 */     // GIR_Coverage, 7239,
     /*  304153 */     GIR_EraseRootFromParent_Done,
     /*  304154 */   // Label 5922: @304154
     /*  304154 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(304229), // Rule ID 7242 //
     /*  304159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  304170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304205 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  304205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  304208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304227 */     GIR_RootConstrainSelectedInstOperands,
     /*  304228 */     // GIR_Coverage, 7242,
     /*  304228 */     GIR_EraseRootFromParent_Done,
     /*  304229 */   // Label 5923: @304229
     /*  304229 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(304304), // Rule ID 7243 //
     /*  304234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  304245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  304280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  304283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304302 */     GIR_RootConstrainSelectedInstOperands,
     /*  304303 */     // GIR_Coverage, 7243,
     /*  304303 */     GIR_EraseRootFromParent_Done,
     /*  304304 */   // Label 5924: @304304
     /*  304304 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(304379), // Rule ID 7246 //
     /*  304309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  304320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  304355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  304358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304377 */     GIR_RootConstrainSelectedInstOperands,
     /*  304378 */     // GIR_Coverage, 7246,
     /*  304378 */     GIR_EraseRootFromParent_Done,
     /*  304379 */   // Label 5925: @304379
     /*  304379 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(304454), // Rule ID 7247 //
     /*  304384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  304395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  304430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  304433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304452 */     GIR_RootConstrainSelectedInstOperands,
     /*  304453 */     // GIR_Coverage, 7247,
     /*  304453 */     GIR_EraseRootFromParent_Done,
     /*  304454 */   // Label 5926: @304454
     /*  304454 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(304529), // Rule ID 7250 //
     /*  304459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  304470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304505 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  304505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  304508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304527 */     GIR_RootConstrainSelectedInstOperands,
     /*  304528 */     // GIR_Coverage, 7250,
     /*  304528 */     GIR_EraseRootFromParent_Done,
     /*  304529 */   // Label 5927: @304529
     /*  304529 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(304604), // Rule ID 7251 //
     /*  304534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  304545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  304580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  304583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304602 */     GIR_RootConstrainSelectedInstOperands,
     /*  304603 */     // GIR_Coverage, 7251,
     /*  304603 */     GIR_EraseRootFromParent_Done,
     /*  304604 */   // Label 5928: @304604
     /*  304604 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(304679), // Rule ID 7254 //
     /*  304609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  304620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304655 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  304655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  304658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304677 */     GIR_RootConstrainSelectedInstOperands,
     /*  304678 */     // GIR_Coverage, 7254,
     /*  304678 */     GIR_EraseRootFromParent_Done,
     /*  304679 */   // Label 5929: @304679
     /*  304679 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(304754), // Rule ID 7255 //
     /*  304684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  304695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304730 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  304730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  304733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304752 */     GIR_RootConstrainSelectedInstOperands,
     /*  304753 */     // GIR_Coverage, 7255,
     /*  304753 */     GIR_EraseRootFromParent_Done,
     /*  304754 */   // Label 5930: @304754
     /*  304754 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(304829), // Rule ID 7258 //
     /*  304759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  304770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  304805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  304808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304827 */     GIR_RootConstrainSelectedInstOperands,
     /*  304828 */     // GIR_Coverage, 7258,
     /*  304828 */     GIR_EraseRootFromParent_Done,
     /*  304829 */   // Label 5931: @304829
     /*  304829 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(304904), // Rule ID 7259 //
     /*  304834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  304845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  304857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  304880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  304883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304902 */     GIR_RootConstrainSelectedInstOperands,
     /*  304903 */     // GIR_Coverage, 7259,
     /*  304903 */     GIR_EraseRootFromParent_Done,
     /*  304904 */   // Label 5932: @304904
     /*  304904 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(304979), // Rule ID 7262 //
     /*  304909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  304920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  304932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  304948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304955 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  304955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  304958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  304962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  304977 */     GIR_RootConstrainSelectedInstOperands,
     /*  304978 */     // GIR_Coverage, 7262,
     /*  304978 */     GIR_EraseRootFromParent_Done,
     /*  304979 */   // Label 5933: @304979
     /*  304979 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(305054), // Rule ID 7263 //
     /*  304984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  304992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  304995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  305030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  305033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305052 */     GIR_RootConstrainSelectedInstOperands,
     /*  305053 */     // GIR_Coverage, 7263,
     /*  305053 */     GIR_EraseRootFromParent_Done,
     /*  305054 */   // Label 5934: @305054
     /*  305054 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(305129), // Rule ID 7266 //
     /*  305059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  305070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  305105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  305108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305127 */     GIR_RootConstrainSelectedInstOperands,
     /*  305128 */     // GIR_Coverage, 7266,
     /*  305128 */     GIR_EraseRootFromParent_Done,
     /*  305129 */   // Label 5935: @305129
     /*  305129 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(305204), // Rule ID 7267 //
     /*  305134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  305145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  305180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  305183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305202 */     GIR_RootConstrainSelectedInstOperands,
     /*  305203 */     // GIR_Coverage, 7267,
     /*  305203 */     GIR_EraseRootFromParent_Done,
     /*  305204 */   // Label 5936: @305204
     /*  305204 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(305279), // Rule ID 7270 //
     /*  305209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  305220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  305255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  305258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305277 */     GIR_RootConstrainSelectedInstOperands,
     /*  305278 */     // GIR_Coverage, 7270,
     /*  305278 */     GIR_EraseRootFromParent_Done,
     /*  305279 */   // Label 5937: @305279
     /*  305279 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(305354), // Rule ID 7271 //
     /*  305284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  305295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  305330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  305333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305352 */     GIR_RootConstrainSelectedInstOperands,
     /*  305353 */     // GIR_Coverage, 7271,
     /*  305353 */     GIR_EraseRootFromParent_Done,
     /*  305354 */   // Label 5938: @305354
     /*  305354 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(305429), // Rule ID 7274 //
     /*  305359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  305370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  305405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  305408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305427 */     GIR_RootConstrainSelectedInstOperands,
     /*  305428 */     // GIR_Coverage, 7274,
     /*  305428 */     GIR_EraseRootFromParent_Done,
     /*  305429 */   // Label 5939: @305429
     /*  305429 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(305504), // Rule ID 7275 //
     /*  305434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  305445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  305480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  305483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305502 */     GIR_RootConstrainSelectedInstOperands,
     /*  305503 */     // GIR_Coverage, 7275,
     /*  305503 */     GIR_EraseRootFromParent_Done,
     /*  305504 */   // Label 5940: @305504
     /*  305504 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(305579), // Rule ID 7278 //
     /*  305509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  305520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305555 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  305555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  305558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305577 */     GIR_RootConstrainSelectedInstOperands,
     /*  305578 */     // GIR_Coverage, 7278,
     /*  305578 */     GIR_EraseRootFromParent_Done,
     /*  305579 */   // Label 5941: @305579
     /*  305579 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(305654), // Rule ID 7279 //
     /*  305584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  305595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  305630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  305633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305652 */     GIR_RootConstrainSelectedInstOperands,
     /*  305653 */     // GIR_Coverage, 7279,
     /*  305653 */     GIR_EraseRootFromParent_Done,
     /*  305654 */   // Label 5942: @305654
     /*  305654 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(305729), // Rule ID 7282 //
     /*  305659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  305670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  305705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  305708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305727 */     GIR_RootConstrainSelectedInstOperands,
     /*  305728 */     // GIR_Coverage, 7282,
     /*  305728 */     GIR_EraseRootFromParent_Done,
     /*  305729 */   // Label 5943: @305729
     /*  305729 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(305804), // Rule ID 7283 //
     /*  305734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  305745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  305780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  305783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305802 */     GIR_RootConstrainSelectedInstOperands,
     /*  305803 */     // GIR_Coverage, 7283,
     /*  305803 */     GIR_EraseRootFromParent_Done,
     /*  305804 */   // Label 5944: @305804
     /*  305804 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(305879), // Rule ID 7286 //
     /*  305809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  305820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305855 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  305855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  305858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305877 */     GIR_RootConstrainSelectedInstOperands,
     /*  305878 */     // GIR_Coverage, 7286,
     /*  305878 */     GIR_EraseRootFromParent_Done,
     /*  305879 */   // Label 5945: @305879
     /*  305879 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(305954), // Rule ID 7287 //
     /*  305884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  305895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  305907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  305930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  305933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  305937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  305952 */     GIR_RootConstrainSelectedInstOperands,
     /*  305953 */     // GIR_Coverage, 7287,
     /*  305953 */     GIR_EraseRootFromParent_Done,
     /*  305954 */   // Label 5946: @305954
     /*  305954 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(306029), // Rule ID 7290 //
     /*  305959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  305967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  305970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  305982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  305998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306005 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  306005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  306008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306027 */     GIR_RootConstrainSelectedInstOperands,
     /*  306028 */     // GIR_Coverage, 7290,
     /*  306028 */     GIR_EraseRootFromParent_Done,
     /*  306029 */   // Label 5947: @306029
     /*  306029 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(306104), // Rule ID 7291 //
     /*  306034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  306042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  306045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  306073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  306080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  306083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306102 */     GIR_RootConstrainSelectedInstOperands,
     /*  306103 */     // GIR_Coverage, 7291,
     /*  306103 */     GIR_EraseRootFromParent_Done,
     /*  306104 */   // Label 5948: @306104
     /*  306104 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(306181), // Rule ID 2604 //
     /*  306109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  306112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  306120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306141 */     // MIs[0] Operand 4
     /*  306141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306159 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  306159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  306162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306179 */     GIR_RootConstrainSelectedInstOperands,
     /*  306180 */     // GIR_Coverage, 2604,
     /*  306180 */     GIR_EraseRootFromParent_Done,
     /*  306181 */   // Label 5949: @306181
     /*  306181 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(306258), // Rule ID 2605 //
     /*  306186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  306189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  306197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306218 */     // MIs[0] Operand 4
     /*  306218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  306236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  306239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306256 */     GIR_RootConstrainSelectedInstOperands,
     /*  306257 */     // GIR_Coverage, 2605,
     /*  306257 */     GIR_EraseRootFromParent_Done,
     /*  306258 */   // Label 5950: @306258
     /*  306258 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(306335), // Rule ID 20488 //
     /*  306263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  306266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  306274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306295 */     // MIs[0] Operand 4
     /*  306295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306313 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  306313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  306316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306333 */     GIR_RootConstrainSelectedInstOperands,
     /*  306334 */     // GIR_Coverage, 20488,
     /*  306334 */     GIR_EraseRootFromParent_Done,
     /*  306335 */   // Label 5951: @306335
     /*  306335 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(306412), // Rule ID 20489 //
     /*  306340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  306343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  306351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306372 */     // MIs[0] Operand 4
     /*  306372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  306390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  306393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306410 */     GIR_RootConstrainSelectedInstOperands,
     /*  306411 */     // GIR_Coverage, 20489,
     /*  306411 */     GIR_EraseRootFromParent_Done,
     /*  306412 */   // Label 5952: @306412
     /*  306412 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(306489), // Rule ID 20492 //
     /*  306417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  306420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  306428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306449 */     // MIs[0] Operand 4
     /*  306449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306467 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  306467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  306470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306487 */     GIR_RootConstrainSelectedInstOperands,
     /*  306488 */     // GIR_Coverage, 20492,
     /*  306488 */     GIR_EraseRootFromParent_Done,
     /*  306489 */   // Label 5953: @306489
     /*  306489 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(306566), // Rule ID 20493 //
     /*  306494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  306497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  306505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306526 */     // MIs[0] Operand 4
     /*  306526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  306544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  306547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306564 */     GIR_RootConstrainSelectedInstOperands,
     /*  306565 */     // GIR_Coverage, 20493,
     /*  306565 */     GIR_EraseRootFromParent_Done,
     /*  306566 */   // Label 5954: @306566
     /*  306566 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(306643), // Rule ID 20496 //
     /*  306571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  306574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  306582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306603 */     // MIs[0] Operand 4
     /*  306603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  306621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  306624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306641 */     GIR_RootConstrainSelectedInstOperands,
     /*  306642 */     // GIR_Coverage, 20496,
     /*  306642 */     GIR_EraseRootFromParent_Done,
     /*  306643 */   // Label 5955: @306643
     /*  306643 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(306720), // Rule ID 20497 //
     /*  306648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  306651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  306659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306680 */     // MIs[0] Operand 4
     /*  306680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  306698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  306701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306718 */     GIR_RootConstrainSelectedInstOperands,
     /*  306719 */     // GIR_Coverage, 20497,
     /*  306719 */     GIR_EraseRootFromParent_Done,
     /*  306720 */   // Label 5956: @306720
     /*  306720 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(306797), // Rule ID 20500 //
     /*  306725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  306728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  306736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306757 */     // MIs[0] Operand 4
     /*  306757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  306775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  306778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306795 */     GIR_RootConstrainSelectedInstOperands,
     /*  306796 */     // GIR_Coverage, 20500,
     /*  306796 */     GIR_EraseRootFromParent_Done,
     /*  306797 */   // Label 5957: @306797
     /*  306797 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(306874), // Rule ID 20501 //
     /*  306802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  306805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  306813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306834 */     // MIs[0] Operand 4
     /*  306834 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  306852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  306855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306872 */     GIR_RootConstrainSelectedInstOperands,
     /*  306873 */     // GIR_Coverage, 20501,
     /*  306873 */     GIR_EraseRootFromParent_Done,
     /*  306874 */   // Label 5958: @306874
     /*  306874 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(306951), // Rule ID 20504 //
     /*  306879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  306882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  306890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  306899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306911 */     // MIs[0] Operand 4
     /*  306911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306929 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  306929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  306932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  306936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  306938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  306949 */     GIR_RootConstrainSelectedInstOperands,
     /*  306950 */     // GIR_Coverage, 20504,
     /*  306950 */     GIR_EraseRootFromParent_Done,
     /*  306951 */   // Label 5959: @306951
     /*  306951 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(307028), // Rule ID 20505 //
     /*  306956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  306959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  306964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  306967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  306976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306988 */     // MIs[0] Operand 4
     /*  306988 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  306999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  307006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  307009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307026 */     GIR_RootConstrainSelectedInstOperands,
     /*  307027 */     // GIR_Coverage, 20505,
     /*  307027 */     GIR_EraseRootFromParent_Done,
     /*  307028 */   // Label 5960: @307028
     /*  307028 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(307105), // Rule ID 20508 //
     /*  307033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  307036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  307044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307065 */     // MIs[0] Operand 4
     /*  307065 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307083 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  307083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  307086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307103 */     GIR_RootConstrainSelectedInstOperands,
     /*  307104 */     // GIR_Coverage, 20508,
     /*  307104 */     GIR_EraseRootFromParent_Done,
     /*  307105 */   // Label 5961: @307105
     /*  307105 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(307182), // Rule ID 20509 //
     /*  307110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  307113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  307121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307142 */     // MIs[0] Operand 4
     /*  307142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  307160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  307163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307180 */     GIR_RootConstrainSelectedInstOperands,
     /*  307181 */     // GIR_Coverage, 20509,
     /*  307181 */     GIR_EraseRootFromParent_Done,
     /*  307182 */   // Label 5962: @307182
     /*  307182 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(307259), // Rule ID 20512 //
     /*  307187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  307190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  307198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307219 */     // MIs[0] Operand 4
     /*  307219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  307237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  307240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307257 */     GIR_RootConstrainSelectedInstOperands,
     /*  307258 */     // GIR_Coverage, 20512,
     /*  307258 */     GIR_EraseRootFromParent_Done,
     /*  307259 */   // Label 5963: @307259
     /*  307259 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(307336), // Rule ID 20513 //
     /*  307264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  307267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  307275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307296 */     // MIs[0] Operand 4
     /*  307296 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  307314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  307317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307334 */     GIR_RootConstrainSelectedInstOperands,
     /*  307335 */     // GIR_Coverage, 20513,
     /*  307335 */     GIR_EraseRootFromParent_Done,
     /*  307336 */   // Label 5964: @307336
     /*  307336 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(307413), // Rule ID 20516 //
     /*  307341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  307344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  307352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307373 */     // MIs[0] Operand 4
     /*  307373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307391 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  307391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  307394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307411 */     GIR_RootConstrainSelectedInstOperands,
     /*  307412 */     // GIR_Coverage, 20516,
     /*  307412 */     GIR_EraseRootFromParent_Done,
     /*  307413 */   // Label 5965: @307413
     /*  307413 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(307490), // Rule ID 20517 //
     /*  307418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  307421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  307429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307450 */     // MIs[0] Operand 4
     /*  307450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  307468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  307471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307488 */     GIR_RootConstrainSelectedInstOperands,
     /*  307489 */     // GIR_Coverage, 20517,
     /*  307489 */     GIR_EraseRootFromParent_Done,
     /*  307490 */   // Label 5966: @307490
     /*  307490 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(307567), // Rule ID 20520 //
     /*  307495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  307498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  307506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307527 */     // MIs[0] Operand 4
     /*  307527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  307545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  307548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307565 */     GIR_RootConstrainSelectedInstOperands,
     /*  307566 */     // GIR_Coverage, 20520,
     /*  307566 */     GIR_EraseRootFromParent_Done,
     /*  307567 */   // Label 5967: @307567
     /*  307567 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(307644), // Rule ID 20521 //
     /*  307572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  307575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  307583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307604 */     // MIs[0] Operand 4
     /*  307604 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  307622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  307625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307642 */     GIR_RootConstrainSelectedInstOperands,
     /*  307643 */     // GIR_Coverage, 20521,
     /*  307643 */     GIR_EraseRootFromParent_Done,
     /*  307644 */   // Label 5968: @307644
     /*  307644 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(307721), // Rule ID 20524 //
     /*  307649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  307652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  307660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307681 */     // MIs[0] Operand 4
     /*  307681 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307699 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  307699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  307702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307719 */     GIR_RootConstrainSelectedInstOperands,
     /*  307720 */     // GIR_Coverage, 20524,
     /*  307720 */     GIR_EraseRootFromParent_Done,
     /*  307721 */   // Label 5969: @307721
     /*  307721 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(307798), // Rule ID 20525 //
     /*  307726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  307729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  307737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307758 */     // MIs[0] Operand 4
     /*  307758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  307776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  307779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307796 */     GIR_RootConstrainSelectedInstOperands,
     /*  307797 */     // GIR_Coverage, 20525,
     /*  307797 */     GIR_EraseRootFromParent_Done,
     /*  307798 */   // Label 5970: @307798
     /*  307798 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(307875), // Rule ID 20528 //
     /*  307803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  307806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  307814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307835 */     // MIs[0] Operand 4
     /*  307835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307853 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  307853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  307856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307873 */     GIR_RootConstrainSelectedInstOperands,
     /*  307874 */     // GIR_Coverage, 20528,
     /*  307874 */     GIR_EraseRootFromParent_Done,
     /*  307875 */   // Label 5971: @307875
     /*  307875 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(307952), // Rule ID 20529 //
     /*  307880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  307883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  307891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  307900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307912 */     // MIs[0] Operand 4
     /*  307912 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  307923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  307930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  307933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  307939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307950 */     GIR_RootConstrainSelectedInstOperands,
     /*  307951 */     // GIR_Coverage, 20529,
     /*  307951 */     GIR_EraseRootFromParent_Done,
     /*  307952 */   // Label 5972: @307952
     /*  307952 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(308029), // Rule ID 20532 //
     /*  307957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  307960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  307965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  307968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  307971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  307974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  307977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307989 */     // MIs[0] Operand 4
     /*  307989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  308007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  308010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308027 */     GIR_RootConstrainSelectedInstOperands,
     /*  308028 */     // GIR_Coverage, 20532,
     /*  308028 */     GIR_EraseRootFromParent_Done,
     /*  308029 */   // Label 5973: @308029
     /*  308029 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(308106), // Rule ID 20533 //
     /*  308034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  308037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  308042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  308045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308066 */     // MIs[0] Operand 4
     /*  308066 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  308084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  308087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308104 */     GIR_RootConstrainSelectedInstOperands,
     /*  308105 */     // GIR_Coverage, 20533,
     /*  308105 */     GIR_EraseRootFromParent_Done,
     /*  308106 */   // Label 5974: @308106
     /*  308106 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(308183), // Rule ID 20536 //
     /*  308111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  308114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  308119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  308122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308143 */     // MIs[0] Operand 4
     /*  308143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308161 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  308161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  308164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308181 */     GIR_RootConstrainSelectedInstOperands,
     /*  308182 */     // GIR_Coverage, 20536,
     /*  308182 */     GIR_EraseRootFromParent_Done,
     /*  308183 */   // Label 5975: @308183
     /*  308183 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(308260), // Rule ID 20537 //
     /*  308188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  308191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  308196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  308199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308220 */     // MIs[0] Operand 4
     /*  308220 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  308238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  308241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308258 */     GIR_RootConstrainSelectedInstOperands,
     /*  308259 */     // GIR_Coverage, 20537,
     /*  308259 */     GIR_EraseRootFromParent_Done,
     /*  308260 */   // Label 5976: @308260
     /*  308260 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(308337), // Rule ID 20540 //
     /*  308265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  308268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  308273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  308276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308297 */     // MIs[0] Operand 4
     /*  308297 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  308315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  308318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308335 */     GIR_RootConstrainSelectedInstOperands,
     /*  308336 */     // GIR_Coverage, 20540,
     /*  308336 */     GIR_EraseRootFromParent_Done,
     /*  308337 */   // Label 5977: @308337
     /*  308337 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(308414), // Rule ID 20541 //
     /*  308342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  308345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  308350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  308353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308374 */     // MIs[0] Operand 4
     /*  308374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  308392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  308395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308412 */     GIR_RootConstrainSelectedInstOperands,
     /*  308413 */     // GIR_Coverage, 20541,
     /*  308413 */     GIR_EraseRootFromParent_Done,
     /*  308414 */   // Label 5978: @308414
     /*  308414 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(308491), // Rule ID 20544 //
     /*  308419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  308422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308451 */     // MIs[0] Operand 4
     /*  308451 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  308472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308489 */     GIR_RootConstrainSelectedInstOperands,
     /*  308490 */     // GIR_Coverage, 20544,
     /*  308490 */     GIR_EraseRootFromParent_Done,
     /*  308491 */   // Label 5979: @308491
     /*  308491 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(308568), // Rule ID 20545 //
     /*  308496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  308499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308528 */     // MIs[0] Operand 4
     /*  308528 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  308549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308566 */     GIR_RootConstrainSelectedInstOperands,
     /*  308567 */     // GIR_Coverage, 20545,
     /*  308567 */     GIR_EraseRootFromParent_Done,
     /*  308568 */   // Label 5980: @308568
     /*  308568 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(308645), // Rule ID 20548 //
     /*  308573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  308576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308605 */     // MIs[0] Operand 4
     /*  308605 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  308626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308643 */     GIR_RootConstrainSelectedInstOperands,
     /*  308644 */     // GIR_Coverage, 20548,
     /*  308644 */     GIR_EraseRootFromParent_Done,
     /*  308645 */   // Label 5981: @308645
     /*  308645 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(308722), // Rule ID 20549 //
     /*  308650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  308653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308682 */     // MIs[0] Operand 4
     /*  308682 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  308703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308720 */     GIR_RootConstrainSelectedInstOperands,
     /*  308721 */     // GIR_Coverage, 20549,
     /*  308721 */     GIR_EraseRootFromParent_Done,
     /*  308722 */   // Label 5982: @308722
     /*  308722 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(308799), // Rule ID 20552 //
     /*  308727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  308730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  308738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  308741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  308744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308759 */     // MIs[0] Operand 4
     /*  308759 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  308777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  308780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308797 */     GIR_RootConstrainSelectedInstOperands,
     /*  308798 */     // GIR_Coverage, 20552,
     /*  308798 */     GIR_EraseRootFromParent_Done,
     /*  308799 */   // Label 5983: @308799
     /*  308799 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(308876), // Rule ID 20553 //
     /*  308804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  308807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  308815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  308818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  308821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308836 */     // MIs[0] Operand 4
     /*  308836 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  308854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  308857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308874 */     GIR_RootConstrainSelectedInstOperands,
     /*  308875 */     // GIR_Coverage, 20553,
     /*  308875 */     GIR_EraseRootFromParent_Done,
     /*  308876 */   // Label 5984: @308876
     /*  308876 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(308953), // Rule ID 20556 //
     /*  308881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  308884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  308892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  308895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  308898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  308901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308913 */     // MIs[0] Operand 4
     /*  308913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  308924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308931 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  308934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  308940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308951 */     GIR_RootConstrainSelectedInstOperands,
     /*  308952 */     // GIR_Coverage, 20556,
     /*  308952 */     GIR_EraseRootFromParent_Done,
     /*  308953 */   // Label 5985: @308953
     /*  308953 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(309030), // Rule ID 20557 //
     /*  308958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  308961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  308966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  308969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  308972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  308975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  308978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308990 */     // MIs[0] Operand 4
     /*  308990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  309011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309028 */     GIR_RootConstrainSelectedInstOperands,
     /*  309029 */     // GIR_Coverage, 20557,
     /*  309029 */     GIR_EraseRootFromParent_Done,
     /*  309030 */   // Label 5986: @309030
     /*  309030 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(309107), // Rule ID 20560 //
     /*  309035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  309038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309067 */     // MIs[0] Operand 4
     /*  309067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309085 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  309088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309105 */     GIR_RootConstrainSelectedInstOperands,
     /*  309106 */     // GIR_Coverage, 20560,
     /*  309106 */     GIR_EraseRootFromParent_Done,
     /*  309107 */   // Label 5987: @309107
     /*  309107 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(309184), // Rule ID 20561 //
     /*  309112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  309115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309144 */     // MIs[0] Operand 4
     /*  309144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  309165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309182 */     GIR_RootConstrainSelectedInstOperands,
     /*  309183 */     // GIR_Coverage, 20561,
     /*  309183 */     GIR_EraseRootFromParent_Done,
     /*  309184 */   // Label 5988: @309184
     /*  309184 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(309261), // Rule ID 20564 //
     /*  309189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  309192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309221 */     // MIs[0] Operand 4
     /*  309221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309239 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  309239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  309242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309259 */     GIR_RootConstrainSelectedInstOperands,
     /*  309260 */     // GIR_Coverage, 20564,
     /*  309260 */     GIR_EraseRootFromParent_Done,
     /*  309261 */   // Label 5989: @309261
     /*  309261 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(309338), // Rule ID 20565 //
     /*  309266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  309269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309298 */     // MIs[0] Operand 4
     /*  309298 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  309316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  309319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309336 */     GIR_RootConstrainSelectedInstOperands,
     /*  309337 */     // GIR_Coverage, 20565,
     /*  309337 */     GIR_EraseRootFromParent_Done,
     /*  309338 */   // Label 5990: @309338
     /*  309338 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(309415), // Rule ID 20568 //
     /*  309343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  309346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  309354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  309357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  309360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309375 */     // MIs[0] Operand 4
     /*  309375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  309396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309413 */     GIR_RootConstrainSelectedInstOperands,
     /*  309414 */     // GIR_Coverage, 20568,
     /*  309414 */     GIR_EraseRootFromParent_Done,
     /*  309415 */   // Label 5991: @309415
     /*  309415 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(309492), // Rule ID 20569 //
     /*  309420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  309423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  309431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  309434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  309437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309452 */     // MIs[0] Operand 4
     /*  309452 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  309473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309490 */     GIR_RootConstrainSelectedInstOperands,
     /*  309491 */     // GIR_Coverage, 20569,
     /*  309491 */     GIR_EraseRootFromParent_Done,
     /*  309492 */   // Label 5992: @309492
     /*  309492 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(309569), // Rule ID 20572 //
     /*  309497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  309500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  309508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  309511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  309514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309529 */     // MIs[0] Operand 4
     /*  309529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309547 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  309550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309567 */     GIR_RootConstrainSelectedInstOperands,
     /*  309568 */     // GIR_Coverage, 20572,
     /*  309568 */     GIR_EraseRootFromParent_Done,
     /*  309569 */   // Label 5993: @309569
     /*  309569 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(309646), // Rule ID 20573 //
     /*  309574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  309577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  309585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  309588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  309591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309606 */     // MIs[0] Operand 4
     /*  309606 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  309627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309644 */     GIR_RootConstrainSelectedInstOperands,
     /*  309645 */     // GIR_Coverage, 20573,
     /*  309645 */     GIR_EraseRootFromParent_Done,
     /*  309646 */   // Label 5994: @309646
     /*  309646 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(309723), // Rule ID 20576 //
     /*  309651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  309654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  309662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  309665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  309668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309683 */     // MIs[0] Operand 4
     /*  309683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309701 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  309704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309721 */     GIR_RootConstrainSelectedInstOperands,
     /*  309722 */     // GIR_Coverage, 20576,
     /*  309722 */     GIR_EraseRootFromParent_Done,
     /*  309723 */   // Label 5995: @309723
     /*  309723 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(309800), // Rule ID 20577 //
     /*  309728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  309731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  309739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  309742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  309745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309760 */     // MIs[0] Operand 4
     /*  309760 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  309781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309798 */     GIR_RootConstrainSelectedInstOperands,
     /*  309799 */     // GIR_Coverage, 20577,
     /*  309799 */     GIR_EraseRootFromParent_Done,
     /*  309800 */   // Label 5996: @309800
     /*  309800 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(309877), // Rule ID 20580 //
     /*  309805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  309808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  309816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  309819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  309822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309837 */     // MIs[0] Operand 4
     /*  309837 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309855 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  309858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309875 */     GIR_RootConstrainSelectedInstOperands,
     /*  309876 */     // GIR_Coverage, 20580,
     /*  309876 */     GIR_EraseRootFromParent_Done,
     /*  309877 */   // Label 5997: @309877
     /*  309877 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(309954), // Rule ID 20581 //
     /*  309882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  309885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  309893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  309896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  309899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  309902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309914 */     // MIs[0] Operand 4
     /*  309914 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  309925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  309935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  309941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309952 */     GIR_RootConstrainSelectedInstOperands,
     /*  309953 */     // GIR_Coverage, 20581,
     /*  309953 */     GIR_EraseRootFromParent_Done,
     /*  309954 */   // Label 5998: @309954
     /*  309954 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(310031), // Rule ID 20584 //
     /*  309959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  309962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  309967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  309970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  309973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  309976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  309979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309991 */     // MIs[0] Operand 4
     /*  309991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  310012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310029 */     GIR_RootConstrainSelectedInstOperands,
     /*  310030 */     // GIR_Coverage, 20584,
     /*  310030 */     GIR_EraseRootFromParent_Done,
     /*  310031 */   // Label 5999: @310031
     /*  310031 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(310108), // Rule ID 20585 //
     /*  310036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  310039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310068 */     // MIs[0] Operand 4
     /*  310068 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  310089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310106 */     GIR_RootConstrainSelectedInstOperands,
     /*  310107 */     // GIR_Coverage, 20585,
     /*  310107 */     GIR_EraseRootFromParent_Done,
     /*  310108 */   // Label 6000: @310108
     /*  310108 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(310185), // Rule ID 20588 //
     /*  310113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  310116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310145 */     // MIs[0] Operand 4
     /*  310145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  310166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310183 */     GIR_RootConstrainSelectedInstOperands,
     /*  310184 */     // GIR_Coverage, 20588,
     /*  310184 */     GIR_EraseRootFromParent_Done,
     /*  310185 */   // Label 6001: @310185
     /*  310185 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(310262), // Rule ID 20589 //
     /*  310190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  310193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310222 */     // MIs[0] Operand 4
     /*  310222 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  310243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310260 */     GIR_RootConstrainSelectedInstOperands,
     /*  310261 */     // GIR_Coverage, 20589,
     /*  310261 */     GIR_EraseRootFromParent_Done,
     /*  310262 */   // Label 6002: @310262
     /*  310262 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(310339), // Rule ID 20592 //
     /*  310267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  310270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310299 */     // MIs[0] Operand 4
     /*  310299 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  310320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310337 */     GIR_RootConstrainSelectedInstOperands,
     /*  310338 */     // GIR_Coverage, 20592,
     /*  310338 */     GIR_EraseRootFromParent_Done,
     /*  310339 */   // Label 6003: @310339
     /*  310339 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(310416), // Rule ID 20593 //
     /*  310344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  310347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310376 */     // MIs[0] Operand 4
     /*  310376 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  310397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310414 */     GIR_RootConstrainSelectedInstOperands,
     /*  310415 */     // GIR_Coverage, 20593,
     /*  310415 */     GIR_EraseRootFromParent_Done,
     /*  310416 */   // Label 6004: @310416
     /*  310416 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(310493), // Rule ID 20596 //
     /*  310421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  310424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  310432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  310435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  310438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310453 */     // MIs[0] Operand 4
     /*  310453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  310474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310491 */     GIR_RootConstrainSelectedInstOperands,
     /*  310492 */     // GIR_Coverage, 20596,
     /*  310492 */     GIR_EraseRootFromParent_Done,
     /*  310493 */   // Label 6005: @310493
     /*  310493 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(310570), // Rule ID 20597 //
     /*  310498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  310501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  310509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  310512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  310515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310530 */     // MIs[0] Operand 4
     /*  310530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  310551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310568 */     GIR_RootConstrainSelectedInstOperands,
     /*  310569 */     // GIR_Coverage, 20597,
     /*  310569 */     GIR_EraseRootFromParent_Done,
     /*  310570 */   // Label 6006: @310570
     /*  310570 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(310647), // Rule ID 20600 //
     /*  310575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  310578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  310586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  310589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  310592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310607 */     // MIs[0] Operand 4
     /*  310607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  310628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310645 */     GIR_RootConstrainSelectedInstOperands,
     /*  310646 */     // GIR_Coverage, 20600,
     /*  310646 */     GIR_EraseRootFromParent_Done,
     /*  310647 */   // Label 6007: @310647
     /*  310647 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(310724), // Rule ID 20601 //
     /*  310652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  310655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  310660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  310663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  310666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  310669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310684 */     // MIs[0] Operand 4
     /*  310684 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  310705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310722 */     GIR_RootConstrainSelectedInstOperands,
     /*  310723 */     // GIR_Coverage, 20601,
     /*  310723 */     GIR_EraseRootFromParent_Done,
     /*  310724 */   // Label 6008: @310724
     /*  310724 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(310801), // Rule ID 20960 //
     /*  310729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  310732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  310737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  310740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  310746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310761 */     // MIs[0] Operand 4
     /*  310761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310779 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  310782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310799 */     GIR_RootConstrainSelectedInstOperands,
     /*  310800 */     // GIR_Coverage, 20960,
     /*  310800 */     GIR_EraseRootFromParent_Done,
     /*  310801 */   // Label 6009: @310801
     /*  310801 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(310878), // Rule ID 20961 //
     /*  310806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  310809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  310814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  310817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  310823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310838 */     // MIs[0] Operand 4
     /*  310838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  310859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310876 */     GIR_RootConstrainSelectedInstOperands,
     /*  310877 */     // GIR_Coverage, 20961,
     /*  310877 */     GIR_EraseRootFromParent_Done,
     /*  310878 */   // Label 6010: @310878
     /*  310878 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(310955), // Rule ID 20964 //
     /*  310883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  310886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  310891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  310894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  310903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310915 */     // MIs[0] Operand 4
     /*  310915 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  310926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  310936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  310942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310953 */     GIR_RootConstrainSelectedInstOperands,
     /*  310954 */     // GIR_Coverage, 20964,
     /*  310954 */     GIR_EraseRootFromParent_Done,
     /*  310955 */   // Label 6011: @310955
     /*  310955 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(311032), // Rule ID 20965 //
     /*  310960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  310963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  310968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  310971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  310980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310992 */     // MIs[0] Operand 4
     /*  310992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  311013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311030 */     GIR_RootConstrainSelectedInstOperands,
     /*  311031 */     // GIR_Coverage, 20965,
     /*  311031 */     GIR_EraseRootFromParent_Done,
     /*  311032 */   // Label 6012: @311032
     /*  311032 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(311109), // Rule ID 20968 //
     /*  311037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  311040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  311048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311069 */     // MIs[0] Operand 4
     /*  311069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  311090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311107 */     GIR_RootConstrainSelectedInstOperands,
     /*  311108 */     // GIR_Coverage, 20968,
     /*  311108 */     GIR_EraseRootFromParent_Done,
     /*  311109 */   // Label 6013: @311109
     /*  311109 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(311186), // Rule ID 20969 //
     /*  311114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  311117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  311125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311146 */     // MIs[0] Operand 4
     /*  311146 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  311167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311184 */     GIR_RootConstrainSelectedInstOperands,
     /*  311185 */     // GIR_Coverage, 20969,
     /*  311185 */     GIR_EraseRootFromParent_Done,
     /*  311186 */   // Label 6014: @311186
     /*  311186 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(311263), // Rule ID 20972 //
     /*  311191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  311194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311223 */     // MIs[0] Operand 4
     /*  311223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311241 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  311244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311261 */     GIR_RootConstrainSelectedInstOperands,
     /*  311262 */     // GIR_Coverage, 20972,
     /*  311262 */     GIR_EraseRootFromParent_Done,
     /*  311263 */   // Label 6015: @311263
     /*  311263 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(311340), // Rule ID 20973 //
     /*  311268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  311271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311300 */     // MIs[0] Operand 4
     /*  311300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  311321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311338 */     GIR_RootConstrainSelectedInstOperands,
     /*  311339 */     // GIR_Coverage, 20973,
     /*  311339 */     GIR_EraseRootFromParent_Done,
     /*  311340 */   // Label 6016: @311340
     /*  311340 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(311417), // Rule ID 20976 //
     /*  311345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  311348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311377 */     // MIs[0] Operand 4
     /*  311377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311395 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  311398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311415 */     GIR_RootConstrainSelectedInstOperands,
     /*  311416 */     // GIR_Coverage, 20976,
     /*  311416 */     GIR_EraseRootFromParent_Done,
     /*  311417 */   // Label 6017: @311417
     /*  311417 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(311494), // Rule ID 20977 //
     /*  311422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  311425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311454 */     // MIs[0] Operand 4
     /*  311454 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  311475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311492 */     GIR_RootConstrainSelectedInstOperands,
     /*  311493 */     // GIR_Coverage, 20977,
     /*  311493 */     GIR_EraseRootFromParent_Done,
     /*  311494 */   // Label 6018: @311494
     /*  311494 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(311571), // Rule ID 20980 //
     /*  311499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  311502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311531 */     // MIs[0] Operand 4
     /*  311531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  311552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311569 */     GIR_RootConstrainSelectedInstOperands,
     /*  311570 */     // GIR_Coverage, 20980,
     /*  311570 */     GIR_EraseRootFromParent_Done,
     /*  311571 */   // Label 6019: @311571
     /*  311571 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(311648), // Rule ID 20981 //
     /*  311576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  311579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311608 */     // MIs[0] Operand 4
     /*  311608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  311629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311646 */     GIR_RootConstrainSelectedInstOperands,
     /*  311647 */     // GIR_Coverage, 20981,
     /*  311647 */     GIR_EraseRootFromParent_Done,
     /*  311648 */   // Label 6020: @311648
     /*  311648 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(311725), // Rule ID 20984 //
     /*  311653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  311656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311685 */     // MIs[0] Operand 4
     /*  311685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  311706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311723 */     GIR_RootConstrainSelectedInstOperands,
     /*  311724 */     // GIR_Coverage, 20984,
     /*  311724 */     GIR_EraseRootFromParent_Done,
     /*  311725 */   // Label 6021: @311725
     /*  311725 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(311802), // Rule ID 20985 //
     /*  311730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  311733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311762 */     // MIs[0] Operand 4
     /*  311762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  311783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311800 */     GIR_RootConstrainSelectedInstOperands,
     /*  311801 */     // GIR_Coverage, 20985,
     /*  311801 */     GIR_EraseRootFromParent_Done,
     /*  311802 */   // Label 6022: @311802
     /*  311802 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(311879), // Rule ID 20988 //
     /*  311807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  311810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311839 */     // MIs[0] Operand 4
     /*  311839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311857 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  311860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311877 */     GIR_RootConstrainSelectedInstOperands,
     /*  311878 */     // GIR_Coverage, 20988,
     /*  311878 */     GIR_EraseRootFromParent_Done,
     /*  311879 */   // Label 6023: @311879
     /*  311879 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(311956), // Rule ID 20989 //
     /*  311884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  311887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  311904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311916 */     // MIs[0] Operand 4
     /*  311916 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  311927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  311937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  311943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311954 */     GIR_RootConstrainSelectedInstOperands,
     /*  311955 */     // GIR_Coverage, 20989,
     /*  311955 */     GIR_EraseRootFromParent_Done,
     /*  311956 */   // Label 6024: @311956
     /*  311956 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(312033), // Rule ID 20992 //
     /*  311961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  311964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  311969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  311981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311993 */     // MIs[0] Operand 4
     /*  311993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312011 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  312014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312031 */     GIR_RootConstrainSelectedInstOperands,
     /*  312032 */     // GIR_Coverage, 20992,
     /*  312032 */     GIR_EraseRootFromParent_Done,
     /*  312033 */   // Label 6025: @312033
     /*  312033 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(312110), // Rule ID 20993 //
     /*  312038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  312041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  312046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  312049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312070 */     // MIs[0] Operand 4
     /*  312070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  312091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312108 */     GIR_RootConstrainSelectedInstOperands,
     /*  312109 */     // GIR_Coverage, 20993,
     /*  312109 */     GIR_EraseRootFromParent_Done,
     /*  312110 */   // Label 6026: @312110
     /*  312110 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(312187), // Rule ID 20996 //
     /*  312115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  312118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312147 */     // MIs[0] Operand 4
     /*  312147 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312165 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  312168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312185 */     GIR_RootConstrainSelectedInstOperands,
     /*  312186 */     // GIR_Coverage, 20996,
     /*  312186 */     GIR_EraseRootFromParent_Done,
     /*  312187 */   // Label 6027: @312187
     /*  312187 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(312264), // Rule ID 20997 //
     /*  312192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  312195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312224 */     // MIs[0] Operand 4
     /*  312224 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  312245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312262 */     GIR_RootConstrainSelectedInstOperands,
     /*  312263 */     // GIR_Coverage, 20997,
     /*  312263 */     GIR_EraseRootFromParent_Done,
     /*  312264 */   // Label 6028: @312264
     /*  312264 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(312341), // Rule ID 21000 //
     /*  312269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  312272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312301 */     // MIs[0] Operand 4
     /*  312301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312319 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  312322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312339 */     GIR_RootConstrainSelectedInstOperands,
     /*  312340 */     // GIR_Coverage, 21000,
     /*  312340 */     GIR_EraseRootFromParent_Done,
     /*  312341 */   // Label 6029: @312341
     /*  312341 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(312418), // Rule ID 21001 //
     /*  312346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  312349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312378 */     // MIs[0] Operand 4
     /*  312378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  312399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312416 */     GIR_RootConstrainSelectedInstOperands,
     /*  312417 */     // GIR_Coverage, 21001,
     /*  312417 */     GIR_EraseRootFromParent_Done,
     /*  312418 */   // Label 6030: @312418
     /*  312418 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(312495), // Rule ID 21004 //
     /*  312423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  312426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312455 */     // MIs[0] Operand 4
     /*  312455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312473 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  312476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312493 */     GIR_RootConstrainSelectedInstOperands,
     /*  312494 */     // GIR_Coverage, 21004,
     /*  312494 */     GIR_EraseRootFromParent_Done,
     /*  312495 */   // Label 6031: @312495
     /*  312495 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(312572), // Rule ID 21005 //
     /*  312500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  312503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312532 */     // MIs[0] Operand 4
     /*  312532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  312553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312570 */     GIR_RootConstrainSelectedInstOperands,
     /*  312571 */     // GIR_Coverage, 21005,
     /*  312571 */     GIR_EraseRootFromParent_Done,
     /*  312572 */   // Label 6032: @312572
     /*  312572 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(312649), // Rule ID 21008 //
     /*  312577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  312580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312609 */     // MIs[0] Operand 4
     /*  312609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312627 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  312630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312647 */     GIR_RootConstrainSelectedInstOperands,
     /*  312648 */     // GIR_Coverage, 21008,
     /*  312648 */     GIR_EraseRootFromParent_Done,
     /*  312649 */   // Label 6033: @312649
     /*  312649 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(312726), // Rule ID 21009 //
     /*  312654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  312657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312686 */     // MIs[0] Operand 4
     /*  312686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  312707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312724 */     GIR_RootConstrainSelectedInstOperands,
     /*  312725 */     // GIR_Coverage, 21009,
     /*  312725 */     GIR_EraseRootFromParent_Done,
     /*  312726 */   // Label 6034: @312726
     /*  312726 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(312803), // Rule ID 21012 //
     /*  312731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  312734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312763 */     // MIs[0] Operand 4
     /*  312763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  312784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312801 */     GIR_RootConstrainSelectedInstOperands,
     /*  312802 */     // GIR_Coverage, 21012,
     /*  312802 */     GIR_EraseRootFromParent_Done,
     /*  312803 */   // Label 6035: @312803
     /*  312803 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(312880), // Rule ID 21013 //
     /*  312808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  312811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312840 */     // MIs[0] Operand 4
     /*  312840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  312861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312878 */     GIR_RootConstrainSelectedInstOperands,
     /*  312879 */     // GIR_Coverage, 21013,
     /*  312879 */     GIR_EraseRootFromParent_Done,
     /*  312880 */   // Label 6036: @312880
     /*  312880 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(312957), // Rule ID 21016 //
     /*  312885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  312888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  312905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312917 */     // MIs[0] Operand 4
     /*  312917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  312928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312935 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  312938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312955 */     GIR_RootConstrainSelectedInstOperands,
     /*  312956 */     // GIR_Coverage, 21016,
     /*  312956 */     GIR_EraseRootFromParent_Done,
     /*  312957 */   // Label 6037: @312957
     /*  312957 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(313034), // Rule ID 21017 //
     /*  312962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  312965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  312970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  312982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312994 */     // MIs[0] Operand 4
     /*  312994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  313015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313032 */     GIR_RootConstrainSelectedInstOperands,
     /*  313033 */     // GIR_Coverage, 21017,
     /*  313033 */     GIR_EraseRootFromParent_Done,
     /*  313034 */   // Label 6038: @313034
     /*  313034 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(313111), // Rule ID 21020 //
     /*  313039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  313042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313071 */     // MIs[0] Operand 4
     /*  313071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  313092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313109 */     GIR_RootConstrainSelectedInstOperands,
     /*  313110 */     // GIR_Coverage, 21020,
     /*  313110 */     GIR_EraseRootFromParent_Done,
     /*  313111 */   // Label 6039: @313111
     /*  313111 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(313188), // Rule ID 21021 //
     /*  313116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  313119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313148 */     // MIs[0] Operand 4
     /*  313148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  313169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313186 */     GIR_RootConstrainSelectedInstOperands,
     /*  313187 */     // GIR_Coverage, 21021,
     /*  313187 */     GIR_EraseRootFromParent_Done,
     /*  313188 */   // Label 6040: @313188
     /*  313188 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(313265), // Rule ID 21024 //
     /*  313193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  313196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  313210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313225 */     // MIs[0] Operand 4
     /*  313225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313243 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  313246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313263 */     GIR_RootConstrainSelectedInstOperands,
     /*  313264 */     // GIR_Coverage, 21024,
     /*  313264 */     GIR_EraseRootFromParent_Done,
     /*  313265 */   // Label 6041: @313265
     /*  313265 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(313342), // Rule ID 21025 //
     /*  313270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  313273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  313287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313302 */     // MIs[0] Operand 4
     /*  313302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  313323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313340 */     GIR_RootConstrainSelectedInstOperands,
     /*  313341 */     // GIR_Coverage, 21025,
     /*  313341 */     GIR_EraseRootFromParent_Done,
     /*  313342 */   // Label 6042: @313342
     /*  313342 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(313419), // Rule ID 21028 //
     /*  313347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  313350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313379 */     // MIs[0] Operand 4
     /*  313379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313397 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  313400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313417 */     GIR_RootConstrainSelectedInstOperands,
     /*  313418 */     // GIR_Coverage, 21028,
     /*  313418 */     GIR_EraseRootFromParent_Done,
     /*  313419 */   // Label 6043: @313419
     /*  313419 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(313496), // Rule ID 21029 //
     /*  313424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  313427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  313432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313456 */     // MIs[0] Operand 4
     /*  313456 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  313477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313494 */     GIR_RootConstrainSelectedInstOperands,
     /*  313495 */     // GIR_Coverage, 21029,
     /*  313495 */     GIR_EraseRootFromParent_Done,
     /*  313496 */   // Label 6044: @313496
     /*  313496 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(313573), // Rule ID 21332 //
     /*  313501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  313504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  313512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  313515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  313518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313533 */     // MIs[0] Operand 4
     /*  313533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  313554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313571 */     GIR_RootConstrainSelectedInstOperands,
     /*  313572 */     // GIR_Coverage, 21332,
     /*  313572 */     GIR_EraseRootFromParent_Done,
     /*  313573 */   // Label 6045: @313573
     /*  313573 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(313650), // Rule ID 21333 //
     /*  313578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  313581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  313589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  313592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  313595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313610 */     // MIs[0] Operand 4
     /*  313610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  313631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313648 */     GIR_RootConstrainSelectedInstOperands,
     /*  313649 */     // GIR_Coverage, 21333,
     /*  313649 */     GIR_EraseRootFromParent_Done,
     /*  313650 */   // Label 6046: @313650
     /*  313650 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(313727), // Rule ID 21336 //
     /*  313655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  313658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  313666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  313669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313687 */     // MIs[0] Operand 4
     /*  313687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313705 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  313708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313725 */     GIR_RootConstrainSelectedInstOperands,
     /*  313726 */     // GIR_Coverage, 21336,
     /*  313726 */     GIR_EraseRootFromParent_Done,
     /*  313727 */   // Label 6047: @313727
     /*  313727 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(313804), // Rule ID 21337 //
     /*  313732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  313735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  313743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  313746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313764 */     // MIs[0] Operand 4
     /*  313764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313782 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  313785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313802 */     GIR_RootConstrainSelectedInstOperands,
     /*  313803 */     // GIR_Coverage, 21337,
     /*  313803 */     GIR_EraseRootFromParent_Done,
     /*  313804 */   // Label 6048: @313804
     /*  313804 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(313881), // Rule ID 21340 //
     /*  313809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  313812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  313820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  313823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313841 */     // MIs[0] Operand 4
     /*  313841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  313862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313879 */     GIR_RootConstrainSelectedInstOperands,
     /*  313880 */     // GIR_Coverage, 21340,
     /*  313880 */     GIR_EraseRootFromParent_Done,
     /*  313881 */   // Label 6049: @313881
     /*  313881 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(313958), // Rule ID 21341 //
     /*  313886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  313889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  313897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  313900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  313906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313918 */     // MIs[0] Operand 4
     /*  313918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  313929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  313939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313956 */     GIR_RootConstrainSelectedInstOperands,
     /*  313957 */     // GIR_Coverage, 21341,
     /*  313957 */     GIR_EraseRootFromParent_Done,
     /*  313958 */   // Label 6050: @313958
     /*  313958 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(314035), // Rule ID 21344 //
     /*  313963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  313966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  313971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  313974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  313977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  313983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313995 */     // MIs[0] Operand 4
     /*  313995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314013 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  314013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  314016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314033 */     GIR_RootConstrainSelectedInstOperands,
     /*  314034 */     // GIR_Coverage, 21344,
     /*  314034 */     GIR_EraseRootFromParent_Done,
     /*  314035 */   // Label 6051: @314035
     /*  314035 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(314112), // Rule ID 21345 //
     /*  314040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  314043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  314051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  314054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314072 */     // MIs[0] Operand 4
     /*  314072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  314090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  314093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314110 */     GIR_RootConstrainSelectedInstOperands,
     /*  314111 */     // GIR_Coverage, 21345,
     /*  314111 */     GIR_EraseRootFromParent_Done,
     /*  314112 */   // Label 6052: @314112
     /*  314112 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(314189), // Rule ID 21348 //
     /*  314117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  314120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  314128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  314131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314149 */     // MIs[0] Operand 4
     /*  314149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314167 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  314167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  314170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314187 */     GIR_RootConstrainSelectedInstOperands,
     /*  314188 */     // GIR_Coverage, 21348,
     /*  314188 */     GIR_EraseRootFromParent_Done,
     /*  314189 */   // Label 6053: @314189
     /*  314189 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(314266), // Rule ID 21349 //
     /*  314194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  314197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  314205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  314208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314226 */     // MIs[0] Operand 4
     /*  314226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  314244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  314247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314264 */     GIR_RootConstrainSelectedInstOperands,
     /*  314265 */     // GIR_Coverage, 21349,
     /*  314265 */     GIR_EraseRootFromParent_Done,
     /*  314266 */   // Label 6054: @314266
     /*  314266 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(314343), // Rule ID 21352 //
     /*  314271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  314274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  314282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  314285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314303 */     // MIs[0] Operand 4
     /*  314303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  314321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  314324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314341 */     GIR_RootConstrainSelectedInstOperands,
     /*  314342 */     // GIR_Coverage, 21352,
     /*  314342 */     GIR_EraseRootFromParent_Done,
     /*  314343 */   // Label 6055: @314343
     /*  314343 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(314420), // Rule ID 21353 //
     /*  314348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  314351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  314359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  314362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314380 */     // MIs[0] Operand 4
     /*  314380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314398 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  314398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  314401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  314415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314418 */     GIR_RootConstrainSelectedInstOperands,
     /*  314419 */     // GIR_Coverage, 21353,
     /*  314419 */     GIR_EraseRootFromParent_Done,
     /*  314420 */   // Label 6056: @314420
     /*  314420 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(314497), // Rule ID 21356 //
     /*  314425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  314428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  314436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  314439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  314442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314457 */     // MIs[0] Operand 4
     /*  314457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314475 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  314478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314495 */     GIR_RootConstrainSelectedInstOperands,
     /*  314496 */     // GIR_Coverage, 21356,
     /*  314496 */     GIR_EraseRootFromParent_Done,
     /*  314497 */   // Label 6057: @314497
     /*  314497 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(314574), // Rule ID 21357 //
     /*  314502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  314505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  314513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  314516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  314519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314534 */     // MIs[0] Operand 4
     /*  314534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  314555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314572 */     GIR_RootConstrainSelectedInstOperands,
     /*  314573 */     // GIR_Coverage, 21357,
     /*  314573 */     GIR_EraseRootFromParent_Done,
     /*  314574 */   // Label 6058: @314574
     /*  314574 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(314651), // Rule ID 21360 //
     /*  314579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  314582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  314590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  314593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314611 */     // MIs[0] Operand 4
     /*  314611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314629 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  314632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314649 */     GIR_RootConstrainSelectedInstOperands,
     /*  314650 */     // GIR_Coverage, 21360,
     /*  314650 */     GIR_EraseRootFromParent_Done,
     /*  314651 */   // Label 6059: @314651
     /*  314651 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(314728), // Rule ID 21361 //
     /*  314656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  314659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  314667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  314670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314688 */     // MIs[0] Operand 4
     /*  314688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  314709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314726 */     GIR_RootConstrainSelectedInstOperands,
     /*  314727 */     // GIR_Coverage, 21361,
     /*  314727 */     GIR_EraseRootFromParent_Done,
     /*  314728 */   // Label 6060: @314728
     /*  314728 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(314805), // Rule ID 21364 //
     /*  314733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  314736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  314744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  314747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314765 */     // MIs[0] Operand 4
     /*  314765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  314786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314803 */     GIR_RootConstrainSelectedInstOperands,
     /*  314804 */     // GIR_Coverage, 21364,
     /*  314804 */     GIR_EraseRootFromParent_Done,
     /*  314805 */   // Label 6061: @314805
     /*  314805 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(314882), // Rule ID 21365 //
     /*  314810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  314813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  314821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  314824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314842 */     // MIs[0] Operand 4
     /*  314842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  314863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314880 */     GIR_RootConstrainSelectedInstOperands,
     /*  314881 */     // GIR_Coverage, 21365,
     /*  314881 */     GIR_EraseRootFromParent_Done,
     /*  314882 */   // Label 6062: @314882
     /*  314882 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(314959), // Rule ID 21368 //
     /*  314887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  314890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  314907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314919 */     // MIs[0] Operand 4
     /*  314919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  314930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  314940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314957 */     GIR_RootConstrainSelectedInstOperands,
     /*  314958 */     // GIR_Coverage, 21368,
     /*  314958 */     GIR_EraseRootFromParent_Done,
     /*  314959 */   // Label 6063: @314959
     /*  314959 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(315036), // Rule ID 21369 //
     /*  314964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  314967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  314972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  314984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314996 */     // MIs[0] Operand 4
     /*  314996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  315017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315034 */     GIR_RootConstrainSelectedInstOperands,
     /*  315035 */     // GIR_Coverage, 21369,
     /*  315035 */     GIR_EraseRootFromParent_Done,
     /*  315036 */   // Label 6064: @315036
     /*  315036 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(315113), // Rule ID 21372 //
     /*  315041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  315044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  315052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315073 */     // MIs[0] Operand 4
     /*  315073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315091 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  315094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315111 */     GIR_RootConstrainSelectedInstOperands,
     /*  315112 */     // GIR_Coverage, 21372,
     /*  315112 */     GIR_EraseRootFromParent_Done,
     /*  315113 */   // Label 6065: @315113
     /*  315113 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(315190), // Rule ID 21373 //
     /*  315118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  315121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  315129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315150 */     // MIs[0] Operand 4
     /*  315150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  315171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315188 */     GIR_RootConstrainSelectedInstOperands,
     /*  315189 */     // GIR_Coverage, 21373,
     /*  315189 */     GIR_EraseRootFromParent_Done,
     /*  315190 */   // Label 6066: @315190
     /*  315190 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(315267), // Rule ID 21376 //
     /*  315195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  315198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315227 */     // MIs[0] Operand 4
     /*  315227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315245 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  315248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315265 */     GIR_RootConstrainSelectedInstOperands,
     /*  315266 */     // GIR_Coverage, 21376,
     /*  315266 */     GIR_EraseRootFromParent_Done,
     /*  315267 */   // Label 6067: @315267
     /*  315267 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(315344), // Rule ID 21377 //
     /*  315272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  315275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315304 */     // MIs[0] Operand 4
     /*  315304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  315325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315342 */     GIR_RootConstrainSelectedInstOperands,
     /*  315343 */     // GIR_Coverage, 21377,
     /*  315343 */     GIR_EraseRootFromParent_Done,
     /*  315344 */   // Label 6068: @315344
     /*  315344 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(315421), // Rule ID 21380 //
     /*  315349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  315352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315381 */     // MIs[0] Operand 4
     /*  315381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  315402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315419 */     GIR_RootConstrainSelectedInstOperands,
     /*  315420 */     // GIR_Coverage, 21380,
     /*  315420 */     GIR_EraseRootFromParent_Done,
     /*  315421 */   // Label 6069: @315421
     /*  315421 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(315498), // Rule ID 21381 //
     /*  315426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  315429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315458 */     // MIs[0] Operand 4
     /*  315458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  315479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315496 */     GIR_RootConstrainSelectedInstOperands,
     /*  315497 */     // GIR_Coverage, 21381,
     /*  315497 */     GIR_EraseRootFromParent_Done,
     /*  315498 */   // Label 6070: @315498
     /*  315498 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(315575), // Rule ID 21384 //
     /*  315503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  315506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  315514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  315517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315535 */     // MIs[0] Operand 4
     /*  315535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  315556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315573 */     GIR_RootConstrainSelectedInstOperands,
     /*  315574 */     // GIR_Coverage, 21384,
     /*  315574 */     GIR_EraseRootFromParent_Done,
     /*  315575 */   // Label 6071: @315575
     /*  315575 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(315652), // Rule ID 21385 //
     /*  315580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  315583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  315591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  315594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315612 */     // MIs[0] Operand 4
     /*  315612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  315633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315650 */     GIR_RootConstrainSelectedInstOperands,
     /*  315651 */     // GIR_Coverage, 21385,
     /*  315651 */     GIR_EraseRootFromParent_Done,
     /*  315652 */   // Label 6072: @315652
     /*  315652 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(315729), // Rule ID 21388 //
     /*  315657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  315660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  315668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  315671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315689 */     // MIs[0] Operand 4
     /*  315689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315707 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  315710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315727 */     GIR_RootConstrainSelectedInstOperands,
     /*  315728 */     // GIR_Coverage, 21388,
     /*  315728 */     GIR_EraseRootFromParent_Done,
     /*  315729 */   // Label 6073: @315729
     /*  315729 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(315806), // Rule ID 21389 //
     /*  315734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  315737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  315742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  315745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  315748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315766 */     // MIs[0] Operand 4
     /*  315766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  315787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315804 */     GIR_RootConstrainSelectedInstOperands,
     /*  315805 */     // GIR_Coverage, 21389,
     /*  315805 */     GIR_EraseRootFromParent_Done,
     /*  315806 */   // Label 6074: @315806
     /*  315806 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(315883), // Rule ID 21392 //
     /*  315811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  315814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  315819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  315822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  315825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315843 */     // MIs[0] Operand 4
     /*  315843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315861 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  315861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  315864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  315878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315881 */     GIR_RootConstrainSelectedInstOperands,
     /*  315882 */     // GIR_Coverage, 21392,
     /*  315882 */     GIR_EraseRootFromParent_Done,
     /*  315883 */   // Label 6075: @315883
     /*  315883 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(315960), // Rule ID 21393 //
     /*  315888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  315891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  315896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  315899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  315902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  315908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315920 */     // MIs[0] Operand 4
     /*  315920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  315931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315938 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  315938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  315941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  315955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315958 */     GIR_RootConstrainSelectedInstOperands,
     /*  315959 */     // GIR_Coverage, 21393,
     /*  315959 */     GIR_EraseRootFromParent_Done,
     /*  315960 */   // Label 6076: @315960
     /*  315960 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(316037), // Rule ID 21396 //
     /*  315965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  315968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  315973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  315976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  315979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  315985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315997 */     // MIs[0] Operand 4
     /*  315997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316015 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  316015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  316018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316035 */     GIR_RootConstrainSelectedInstOperands,
     /*  316036 */     // GIR_Coverage, 21396,
     /*  316036 */     GIR_EraseRootFromParent_Done,
     /*  316037 */   // Label 6077: @316037
     /*  316037 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(316114), // Rule ID 21397 //
     /*  316042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  316045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  316053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  316056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  316059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316074 */     // MIs[0] Operand 4
     /*  316074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316092 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  316092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  316095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316112 */     GIR_RootConstrainSelectedInstOperands,
     /*  316113 */     // GIR_Coverage, 21397,
     /*  316113 */     GIR_EraseRootFromParent_Done,
     /*  316114 */   // Label 6078: @316114
     /*  316114 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(316191), // Rule ID 21400 //
     /*  316119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  316122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  316130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  316133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  316136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316151 */     // MIs[0] Operand 4
     /*  316151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316169 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  316169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  316172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316189 */     GIR_RootConstrainSelectedInstOperands,
     /*  316190 */     // GIR_Coverage, 21400,
     /*  316190 */     GIR_EraseRootFromParent_Done,
     /*  316191 */   // Label 6079: @316191
     /*  316191 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(316268), // Rule ID 21401 //
     /*  316196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  316199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  316207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  316210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  316213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316228 */     // MIs[0] Operand 4
     /*  316228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316246 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  316246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  316249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316266 */     GIR_RootConstrainSelectedInstOperands,
     /*  316267 */     // GIR_Coverage, 21401,
     /*  316267 */     GIR_EraseRootFromParent_Done,
     /*  316268 */   // Label 6080: @316268
     /*  316268 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(316345), // Rule ID 21404 //
     /*  316273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  316276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  316284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  316287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316305 */     // MIs[0] Operand 4
     /*  316305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316323 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  316323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  316326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316343 */     GIR_RootConstrainSelectedInstOperands,
     /*  316344 */     // GIR_Coverage, 21404,
     /*  316344 */     GIR_EraseRootFromParent_Done,
     /*  316345 */   // Label 6081: @316345
     /*  316345 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(316422), // Rule ID 21405 //
     /*  316350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  316353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  316361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  316364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316382 */     // MIs[0] Operand 4
     /*  316382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  316400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  316403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316420 */     GIR_RootConstrainSelectedInstOperands,
     /*  316421 */     // GIR_Coverage, 21405,
     /*  316421 */     GIR_EraseRootFromParent_Done,
     /*  316422 */   // Label 6082: @316422
     /*  316422 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(316499), // Rule ID 21408 //
     /*  316427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  316430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  316438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  316441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316459 */     // MIs[0] Operand 4
     /*  316459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316477 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  316477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  316480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316497 */     GIR_RootConstrainSelectedInstOperands,
     /*  316498 */     // GIR_Coverage, 21408,
     /*  316498 */     GIR_EraseRootFromParent_Done,
     /*  316499 */   // Label 6083: @316499
     /*  316499 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(316576), // Rule ID 21409 //
     /*  316504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  316507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  316515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  316518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316536 */     // MIs[0] Operand 4
     /*  316536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  316554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  316557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316574 */     GIR_RootConstrainSelectedInstOperands,
     /*  316575 */     // GIR_Coverage, 21409,
     /*  316575 */     GIR_EraseRootFromParent_Done,
     /*  316576 */   // Label 6084: @316576
     /*  316576 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(316653), // Rule ID 21412 //
     /*  316581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  316584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  316592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  316595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316613 */     // MIs[0] Operand 4
     /*  316613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316631 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  316631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  316634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316651 */     GIR_RootConstrainSelectedInstOperands,
     /*  316652 */     // GIR_Coverage, 21412,
     /*  316652 */     GIR_EraseRootFromParent_Done,
     /*  316653 */   // Label 6085: @316653
     /*  316653 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(316730), // Rule ID 21413 //
     /*  316658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  316661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  316669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  316672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316690 */     // MIs[0] Operand 4
     /*  316690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  316708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  316711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  316725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316728 */     GIR_RootConstrainSelectedInstOperands,
     /*  316729 */     // GIR_Coverage, 21413,
     /*  316729 */     GIR_EraseRootFromParent_Done,
     /*  316730 */   // Label 6086: @316730
     /*  316730 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(316807), // Rule ID 21416 //
     /*  316735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  316738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  316746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  316749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  316752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316767 */     // MIs[0] Operand 4
     /*  316767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  316788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316805 */     GIR_RootConstrainSelectedInstOperands,
     /*  316806 */     // GIR_Coverage, 21416,
     /*  316806 */     GIR_EraseRootFromParent_Done,
     /*  316807 */   // Label 6087: @316807
     /*  316807 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(316884), // Rule ID 21417 //
     /*  316812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  316815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  316823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  316826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  316829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316844 */     // MIs[0] Operand 4
     /*  316844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  316865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316882 */     GIR_RootConstrainSelectedInstOperands,
     /*  316883 */     // GIR_Coverage, 21417,
     /*  316883 */     GIR_EraseRootFromParent_Done,
     /*  316884 */   // Label 6088: @316884
     /*  316884 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(316961), // Rule ID 21420 //
     /*  316889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  316892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  316900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  316903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  316909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316921 */     // MIs[0] Operand 4
     /*  316921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  316932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  316942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316959 */     GIR_RootConstrainSelectedInstOperands,
     /*  316960 */     // GIR_Coverage, 21420,
     /*  316960 */     GIR_EraseRootFromParent_Done,
     /*  316961 */   // Label 6089: @316961
     /*  316961 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(317038), // Rule ID 21421 //
     /*  316966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  316969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  316974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  316977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  316980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  316986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316998 */     // MIs[0] Operand 4
     /*  316998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  317019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317036 */     GIR_RootConstrainSelectedInstOperands,
     /*  317037 */     // GIR_Coverage, 21421,
     /*  317037 */     GIR_EraseRootFromParent_Done,
     /*  317038 */   // Label 6090: @317038
     /*  317038 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(317115), // Rule ID 21424 //
     /*  317043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  317046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  317060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317075 */     // MIs[0] Operand 4
     /*  317075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317093 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  317096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317113 */     GIR_RootConstrainSelectedInstOperands,
     /*  317114 */     // GIR_Coverage, 21424,
     /*  317114 */     GIR_EraseRootFromParent_Done,
     /*  317115 */   // Label 6091: @317115
     /*  317115 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(317192), // Rule ID 21425 //
     /*  317120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  317123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  317137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317152 */     // MIs[0] Operand 4
     /*  317152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  317173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317190 */     GIR_RootConstrainSelectedInstOperands,
     /*  317191 */     // GIR_Coverage, 21425,
     /*  317191 */     GIR_EraseRootFromParent_Done,
     /*  317192 */   // Label 6092: @317192
     /*  317192 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(317269), // Rule ID 21428 //
     /*  317197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  317200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  317214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317229 */     // MIs[0] Operand 4
     /*  317229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317247 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  317250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317267 */     GIR_RootConstrainSelectedInstOperands,
     /*  317268 */     // GIR_Coverage, 21428,
     /*  317268 */     GIR_EraseRootFromParent_Done,
     /*  317269 */   // Label 6093: @317269
     /*  317269 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(317346), // Rule ID 21429 //
     /*  317274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  317277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  317291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317306 */     // MIs[0] Operand 4
     /*  317306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  317327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317344 */     GIR_RootConstrainSelectedInstOperands,
     /*  317345 */     // GIR_Coverage, 21429,
     /*  317345 */     GIR_EraseRootFromParent_Done,
     /*  317346 */   // Label 6094: @317346
     /*  317346 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(317423), // Rule ID 21432 //
     /*  317351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  317354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  317368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317383 */     // MIs[0] Operand 4
     /*  317383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  317404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317421 */     GIR_RootConstrainSelectedInstOperands,
     /*  317422 */     // GIR_Coverage, 21432,
     /*  317422 */     GIR_EraseRootFromParent_Done,
     /*  317423 */   // Label 6095: @317423
     /*  317423 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(317500), // Rule ID 21433 //
     /*  317428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  317431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  317445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317460 */     // MIs[0] Operand 4
     /*  317460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  317481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317498 */     GIR_RootConstrainSelectedInstOperands,
     /*  317499 */     // GIR_Coverage, 21433,
     /*  317499 */     GIR_EraseRootFromParent_Done,
     /*  317500 */   // Label 6096: @317500
     /*  317500 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(317577), // Rule ID 21436 //
     /*  317505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  317508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317537 */     // MIs[0] Operand 4
     /*  317537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317555 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  317558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317575 */     GIR_RootConstrainSelectedInstOperands,
     /*  317576 */     // GIR_Coverage, 21436,
     /*  317576 */     GIR_EraseRootFromParent_Done,
     /*  317577 */   // Label 6097: @317577
     /*  317577 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(317654), // Rule ID 21437 //
     /*  317582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  317585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317614 */     // MIs[0] Operand 4
     /*  317614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  317635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317652 */     GIR_RootConstrainSelectedInstOperands,
     /*  317653 */     // GIR_Coverage, 21437,
     /*  317653 */     GIR_EraseRootFromParent_Done,
     /*  317654 */   // Label 6098: @317654
     /*  317654 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(317731), // Rule ID 21440 //
     /*  317659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  317662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317691 */     // MIs[0] Operand 4
     /*  317691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317709 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  317712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317729 */     GIR_RootConstrainSelectedInstOperands,
     /*  317730 */     // GIR_Coverage, 21440,
     /*  317730 */     GIR_EraseRootFromParent_Done,
     /*  317731 */   // Label 6099: @317731
     /*  317731 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(317808), // Rule ID 21441 //
     /*  317736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  317739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317768 */     // MIs[0] Operand 4
     /*  317768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  317789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317806 */     GIR_RootConstrainSelectedInstOperands,
     /*  317807 */     // GIR_Coverage, 21441,
     /*  317807 */     GIR_EraseRootFromParent_Done,
     /*  317808 */   // Label 6100: @317808
     /*  317808 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(317885), // Rule ID 21444 //
     /*  317813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  317816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  317824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  317827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317845 */     // MIs[0] Operand 4
     /*  317845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317863 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  317866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317883 */     GIR_RootConstrainSelectedInstOperands,
     /*  317884 */     // GIR_Coverage, 21444,
     /*  317884 */     GIR_EraseRootFromParent_Done,
     /*  317885 */   // Label 6101: @317885
     /*  317885 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(317962), // Rule ID 21445 //
     /*  317890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  317893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  317901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  317904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  317910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317922 */     // MIs[0] Operand 4
     /*  317922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  317933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  317943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317960 */     GIR_RootConstrainSelectedInstOperands,
     /*  317961 */     // GIR_Coverage, 21445,
     /*  317961 */     GIR_EraseRootFromParent_Done,
     /*  317962 */   // Label 6102: @317962
     /*  317962 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(318039), // Rule ID 21448 //
     /*  317967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  317970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  317975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  317978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  317981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  317987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317999 */     // MIs[0] Operand 4
     /*  317999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  318010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318017 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  318020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318037 */     GIR_RootConstrainSelectedInstOperands,
     /*  318038 */     // GIR_Coverage, 21448,
     /*  318038 */     GIR_EraseRootFromParent_Done,
     /*  318039 */   // Label 6103: @318039
     /*  318039 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(318116), // Rule ID 21449 //
     /*  318044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  318047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  318052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  318055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  318061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318076 */     // MIs[0] Operand 4
     /*  318076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  318087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  318097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318114 */     GIR_RootConstrainSelectedInstOperands,
     /*  318115 */     // GIR_Coverage, 21449,
     /*  318115 */     GIR_EraseRootFromParent_Done,
     /*  318116 */   // Label 6104: @318116
     /*  318116 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(318189), // Rule ID 62137 //
     /*  318121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  318132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  318135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318145 */     // MIs[0] op1
     /*  318145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318168 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  318171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318173 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318175 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318177 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318187 */     GIR_RootConstrainSelectedInstOperands,
     /*  318188 */     // GIR_Coverage, 62137,
     /*  318188 */     GIR_EraseRootFromParent_Done,
     /*  318189 */   // Label 6105: @318189
     /*  318189 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(318262), // Rule ID 62138 //
     /*  318194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  318205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  318208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318218 */     // MIs[0] op1
     /*  318218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318241 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  318244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318246 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318248 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318250 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318260 */     GIR_RootConstrainSelectedInstOperands,
     /*  318261 */     // GIR_Coverage, 62138,
     /*  318261 */     GIR_EraseRootFromParent_Done,
     /*  318262 */   // Label 6106: @318262
     /*  318262 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(318335), // Rule ID 62161 //
     /*  318267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  318278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  318281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  318284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318291 */     // MIs[0] op1
     /*  318291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318314 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  318317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318319 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318321 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318323 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318333 */     GIR_RootConstrainSelectedInstOperands,
     /*  318334 */     // GIR_Coverage, 62161,
     /*  318334 */     GIR_EraseRootFromParent_Done,
     /*  318335 */   // Label 6107: @318335
     /*  318335 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(318408), // Rule ID 62162 //
     /*  318340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  318351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  318354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  318357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318364 */     // MIs[0] op1
     /*  318364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318387 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  318390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318392 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318394 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318396 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318406 */     GIR_RootConstrainSelectedInstOperands,
     /*  318407 */     // GIR_Coverage, 62162,
     /*  318407 */     GIR_EraseRootFromParent_Done,
     /*  318408 */   // Label 6108: @318408
     /*  318408 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(318481), // Rule ID 62187 //
     /*  318413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  318424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  318427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318437 */     // MIs[0] op1
     /*  318437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318460 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  318463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318465 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318467 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318469 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318479 */     GIR_RootConstrainSelectedInstOperands,
     /*  318480 */     // GIR_Coverage, 62187,
     /*  318480 */     GIR_EraseRootFromParent_Done,
     /*  318481 */   // Label 6109: @318481
     /*  318481 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(318554), // Rule ID 62188 //
     /*  318486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  318497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  318500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318510 */     // MIs[0] op1
     /*  318510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318533 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  318536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318552 */     GIR_RootConstrainSelectedInstOperands,
     /*  318553 */     // GIR_Coverage, 62188,
     /*  318553 */     GIR_EraseRootFromParent_Done,
     /*  318554 */   // Label 6110: @318554
     /*  318554 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(318627), // Rule ID 62199 //
     /*  318559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  318570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  318573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  318576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318583 */     // MIs[0] op1
     /*  318583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  318609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318611 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318613 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318615 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318625 */     GIR_RootConstrainSelectedInstOperands,
     /*  318626 */     // GIR_Coverage, 62199,
     /*  318626 */     GIR_EraseRootFromParent_Done,
     /*  318627 */   // Label 6111: @318627
     /*  318627 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(318700), // Rule ID 62200 //
     /*  318632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  318643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  318646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  318649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318656 */     // MIs[0] op1
     /*  318656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318679 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  318682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318684 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318686 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318688 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318698 */     GIR_RootConstrainSelectedInstOperands,
     /*  318699 */     // GIR_Coverage, 62200,
     /*  318699 */     GIR_EraseRootFromParent_Done,
     /*  318700 */   // Label 6112: @318700
     /*  318700 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(318773), // Rule ID 62231 //
     /*  318705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  318716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  318719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318729 */     // MIs[0] op1
     /*  318729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  318755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318757 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318759 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318761 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318771 */     GIR_RootConstrainSelectedInstOperands,
     /*  318772 */     // GIR_Coverage, 62231,
     /*  318772 */     GIR_EraseRootFromParent_Done,
     /*  318773 */   // Label 6113: @318773
     /*  318773 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(318846), // Rule ID 62232 //
     /*  318778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  318786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  318789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  318792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318802 */     // MIs[0] op1
     /*  318802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  318818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318825 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  318828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318844 */     GIR_RootConstrainSelectedInstOperands,
     /*  318845 */     // GIR_Coverage, 62232,
     /*  318845 */     GIR_EraseRootFromParent_Done,
     /*  318846 */   // Label 6114: @318846
     /*  318846 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(318919), // Rule ID 62243 //
     /*  318851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  318854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  318862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  318865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  318868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  318871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318875 */     // MIs[0] op1
     /*  318875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318898 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  318898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  318901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318903 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318905 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318907 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318917 */     GIR_RootConstrainSelectedInstOperands,
     /*  318918 */     // GIR_Coverage, 62243,
     /*  318918 */     GIR_EraseRootFromParent_Done,
     /*  318919 */   // Label 6115: @318919
     /*  318919 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(318992), // Rule ID 62244 //
     /*  318924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  318927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  318932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  318935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  318938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  318941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  318944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318948 */     // MIs[0] op1
     /*  318948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  318951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  318956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  318971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  318974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  318978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  318980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  318982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  318990 */     GIR_RootConstrainSelectedInstOperands,
     /*  318991 */     // GIR_Coverage, 62244,
     /*  318991 */     GIR_EraseRootFromParent_Done,
     /*  318992 */   // Label 6116: @318992
     /*  318992 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(319065), // Rule ID 62275 //
     /*  318997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319021 */     // MIs[0] op1
     /*  319021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  319047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319049 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319051 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319053 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319063 */     GIR_RootConstrainSelectedInstOperands,
     /*  319064 */     // GIR_Coverage, 62275,
     /*  319064 */     GIR_EraseRootFromParent_Done,
     /*  319065 */   // Label 6117: @319065
     /*  319065 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(319138), // Rule ID 62276 //
     /*  319070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319094 */     // MIs[0] op1
     /*  319094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319117 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  319120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319122 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319124 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319126 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319136 */     GIR_RootConstrainSelectedInstOperands,
     /*  319137 */     // GIR_Coverage, 62276,
     /*  319137 */     GIR_EraseRootFromParent_Done,
     /*  319138 */   // Label 6118: @319138
     /*  319138 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(319211), // Rule ID 62287 //
     /*  319143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  319151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  319160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319167 */     // MIs[0] op1
     /*  319167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  319193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319195 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319197 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319199 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319209 */     GIR_RootConstrainSelectedInstOperands,
     /*  319210 */     // GIR_Coverage, 62287,
     /*  319210 */     GIR_EraseRootFromParent_Done,
     /*  319211 */   // Label 6119: @319211
     /*  319211 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(319284), // Rule ID 62288 //
     /*  319216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  319224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  319233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319240 */     // MIs[0] op1
     /*  319240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319263 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  319266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319268 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319270 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319272 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319282 */     GIR_RootConstrainSelectedInstOperands,
     /*  319283 */     // GIR_Coverage, 62288,
     /*  319283 */     GIR_EraseRootFromParent_Done,
     /*  319284 */   // Label 6120: @319284
     /*  319284 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(319357), // Rule ID 62311 //
     /*  319289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  319297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  319306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319313 */     // MIs[0] op1
     /*  319313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  319321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  319329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  319339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319341 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319343 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319345 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319355 */     GIR_RootConstrainSelectedInstOperands,
     /*  319356 */     // GIR_Coverage, 62311,
     /*  319356 */     GIR_EraseRootFromParent_Done,
     /*  319357 */   // Label 6121: @319357
     /*  319357 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(319430), // Rule ID 62312 //
     /*  319362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  319370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  319373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  319379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319386 */     // MIs[0] op1
     /*  319386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  319394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  319402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  319412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319414 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319416 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319418 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319428 */     GIR_RootConstrainSelectedInstOperands,
     /*  319429 */     // GIR_Coverage, 62312,
     /*  319429 */     GIR_EraseRootFromParent_Done,
     /*  319430 */   // Label 6122: @319430
     /*  319430 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(319503), // Rule ID 62331 //
     /*  319435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319459 */     // MIs[0] op1
     /*  319459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  319485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319487 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319489 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319491 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319501 */     GIR_RootConstrainSelectedInstOperands,
     /*  319502 */     // GIR_Coverage, 62331,
     /*  319502 */     GIR_EraseRootFromParent_Done,
     /*  319503 */   // Label 6123: @319503
     /*  319503 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(319576), // Rule ID 62332 //
     /*  319508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319532 */     // MIs[0] op1
     /*  319532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319555 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  319558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319574 */     GIR_RootConstrainSelectedInstOperands,
     /*  319575 */     // GIR_Coverage, 62332,
     /*  319575 */     GIR_EraseRootFromParent_Done,
     /*  319576 */   // Label 6124: @319576
     /*  319576 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(319649), // Rule ID 62343 //
     /*  319581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  319589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  319598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319605 */     // MIs[0] op1
     /*  319605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  319631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319633 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319635 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319637 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319647 */     GIR_RootConstrainSelectedInstOperands,
     /*  319648 */     // GIR_Coverage, 62343,
     /*  319648 */     GIR_EraseRootFromParent_Done,
     /*  319649 */   // Label 6125: @319649
     /*  319649 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(319722), // Rule ID 62344 //
     /*  319654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  319662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  319671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319678 */     // MIs[0] op1
     /*  319678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  319704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319706 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319708 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319710 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319720 */     GIR_RootConstrainSelectedInstOperands,
     /*  319721 */     // GIR_Coverage, 62344,
     /*  319721 */     GIR_EraseRootFromParent_Done,
     /*  319722 */   // Label 6126: @319722
     /*  319722 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(319795), // Rule ID 62367 //
     /*  319727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  319735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  319744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319751 */     // MIs[0] op1
     /*  319751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  319759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  319767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  319777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319779 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319781 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319783 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319793 */     GIR_RootConstrainSelectedInstOperands,
     /*  319794 */     // GIR_Coverage, 62367,
     /*  319794 */     GIR_EraseRootFromParent_Done,
     /*  319795 */   // Label 6127: @319795
     /*  319795 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(319868), // Rule ID 62368 //
     /*  319800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  319808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  319811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  319817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319824 */     // MIs[0] op1
     /*  319824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  319832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  319840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319847 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  319850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319852 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319854 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319856 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319866 */     GIR_RootConstrainSelectedInstOperands,
     /*  319867 */     // GIR_Coverage, 62368,
     /*  319867 */     GIR_EraseRootFromParent_Done,
     /*  319868 */   // Label 6128: @319868
     /*  319868 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(319941), // Rule ID 62387 //
     /*  319873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  319876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  319884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  319893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319897 */     // MIs[0] op1
     /*  319897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  319923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319925 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  319927 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  319929 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  319931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319939 */     GIR_RootConstrainSelectedInstOperands,
     /*  319940 */     // GIR_Coverage, 62387,
     /*  319940 */     GIR_EraseRootFromParent_Done,
     /*  319941 */   // Label 6129: @319941
     /*  319941 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(320014), // Rule ID 62388 //
     /*  319946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  319949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  319954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  319957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  319966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319970 */     // MIs[0] op1
     /*  319970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  319973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  319978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  319986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  319996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319998 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320000 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320002 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320012 */     GIR_RootConstrainSelectedInstOperands,
     /*  320013 */     // GIR_Coverage, 62388,
     /*  320013 */     GIR_EraseRootFromParent_Done,
     /*  320014 */   // Label 6130: @320014
     /*  320014 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(320087), // Rule ID 62399 //
     /*  320019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  320030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  320033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  320036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320043 */     // MIs[0] op1
     /*  320043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  320069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320085 */     GIR_RootConstrainSelectedInstOperands,
     /*  320086 */     // GIR_Coverage, 62399,
     /*  320086 */     GIR_EraseRootFromParent_Done,
     /*  320087 */   // Label 6131: @320087
     /*  320087 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(320160), // Rule ID 62400 //
     /*  320092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  320103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  320106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  320109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320116 */     // MIs[0] op1
     /*  320116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320139 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  320142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320158 */     GIR_RootConstrainSelectedInstOperands,
     /*  320159 */     // GIR_Coverage, 62400,
     /*  320159 */     GIR_EraseRootFromParent_Done,
     /*  320160 */   // Label 6132: @320160
     /*  320160 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(320233), // Rule ID 62423 //
     /*  320165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  320173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  320176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  320179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320189 */     // MIs[0] op1
     /*  320189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  320197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  320215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320231 */     GIR_RootConstrainSelectedInstOperands,
     /*  320232 */     // GIR_Coverage, 62423,
     /*  320232 */     GIR_EraseRootFromParent_Done,
     /*  320233 */   // Label 6133: @320233
     /*  320233 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(320306), // Rule ID 62424 //
     /*  320238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  320246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  320249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  320252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320262 */     // MIs[0] op1
     /*  320262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  320270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320285 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  320288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320290 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320292 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320294 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320304 */     GIR_RootConstrainSelectedInstOperands,
     /*  320305 */     // GIR_Coverage, 62424,
     /*  320305 */     GIR_EraseRootFromParent_Done,
     /*  320306 */   // Label 6134: @320306
     /*  320306 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(320379), // Rule ID 62443 //
     /*  320311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  320319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  320322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  320325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320335 */     // MIs[0] op1
     /*  320335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  320351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  320358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  320361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  320377 */     GIR_RootConstrainSelectedInstOperands,
     /*  320378 */     // GIR_Coverage, 62443,
     /*  320378 */     GIR_EraseRootFromParent_Done,
     /*  320379 */   // Label 6135: @320379
     /*  320379 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(320452), // Rule ID 62444 //
     /*  320384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  320392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  320395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  320398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320408 */     // MIs[0] op1
     /*  320408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  320424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320431 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  320431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  320434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  320450 */     GIR_RootConstrainSelectedInstOperands,
     /*  320451 */     // GIR_Coverage, 62444,
     /*  320451 */     GIR_EraseRootFromParent_Done,
     /*  320452 */   // Label 6136: @320452
     /*  320452 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(320525), // Rule ID 62455 //
     /*  320457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  320468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  320471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  320474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320481 */     // MIs[0] op1
     /*  320481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  320504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  320507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320509 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320511 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320513 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  320523 */     GIR_RootConstrainSelectedInstOperands,
     /*  320524 */     // GIR_Coverage, 62455,
     /*  320524 */     GIR_EraseRootFromParent_Done,
     /*  320525 */   // Label 6137: @320525
     /*  320525 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(320598), // Rule ID 62456 //
     /*  320530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  320541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  320544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  320547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320554 */     // MIs[0] op1
     /*  320554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  320577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  320580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320582 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320584 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320586 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  320596 */     GIR_RootConstrainSelectedInstOperands,
     /*  320597 */     // GIR_Coverage, 62456,
     /*  320597 */     GIR_EraseRootFromParent_Done,
     /*  320598 */   // Label 6138: @320598
     /*  320598 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(320671), // Rule ID 62487 //
     /*  320603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  320611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320627 */     // MIs[0] op1
     /*  320627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  320643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  320653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320655 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320657 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320659 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320669 */     GIR_RootConstrainSelectedInstOperands,
     /*  320670 */     // GIR_Coverage, 62487,
     /*  320670 */     GIR_EraseRootFromParent_Done,
     /*  320671 */   // Label 6139: @320671
     /*  320671 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(320744), // Rule ID 62488 //
     /*  320676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  320684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320700 */     // MIs[0] op1
     /*  320700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  320716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320723 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  320726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320728 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320730 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320732 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320742 */     GIR_RootConstrainSelectedInstOperands,
     /*  320743 */     // GIR_Coverage, 62488,
     /*  320743 */     GIR_EraseRootFromParent_Done,
     /*  320744 */   // Label 6140: @320744
     /*  320744 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(320817), // Rule ID 62499 //
     /*  320749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  320766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320773 */     // MIs[0] op1
     /*  320773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  320799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320801 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320803 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320805 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320815 */     GIR_RootConstrainSelectedInstOperands,
     /*  320816 */     // GIR_Coverage, 62499,
     /*  320816 */     GIR_EraseRootFromParent_Done,
     /*  320817 */   // Label 6141: @320817
     /*  320817 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(320890), // Rule ID 62500 //
     /*  320822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  320830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  320839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320846 */     // MIs[0] op1
     /*  320846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  320854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320869 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  320872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320874 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320876 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320878 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320888 */     GIR_RootConstrainSelectedInstOperands,
     /*  320889 */     // GIR_Coverage, 62500,
     /*  320889 */     GIR_EraseRootFromParent_Done,
     /*  320890 */   // Label 6142: @320890
     /*  320890 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(320963), // Rule ID 62523 //
     /*  320895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  320898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  320903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  320912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  320915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320919 */     // MIs[0] op1
     /*  320919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  320927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  320945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320947 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  320949 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  320951 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  320953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320961 */     GIR_RootConstrainSelectedInstOperands,
     /*  320962 */     // GIR_Coverage, 62523,
     /*  320962 */     GIR_EraseRootFromParent_Done,
     /*  320963 */   // Label 6143: @320963
     /*  320963 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(321036), // Rule ID 62524 //
     /*  320968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  320971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  320976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  320979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  320982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  320985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  320988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320992 */     // MIs[0] op1
     /*  320992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  320995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  321000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  321018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321020 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321022 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321024 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321034 */     GIR_RootConstrainSelectedInstOperands,
     /*  321035 */     // GIR_Coverage, 62524,
     /*  321035 */     GIR_EraseRootFromParent_Done,
     /*  321036 */   // Label 6144: @321036
     /*  321036 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(321109), // Rule ID 62543 //
     /*  321041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321065 */     // MIs[0] op1
     /*  321065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  321081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  321091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321093 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321095 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321097 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321107 */     GIR_RootConstrainSelectedInstOperands,
     /*  321108 */     // GIR_Coverage, 62543,
     /*  321108 */     GIR_EraseRootFromParent_Done,
     /*  321109 */   // Label 6145: @321109
     /*  321109 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(321182), // Rule ID 62544 //
     /*  321114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321138 */     // MIs[0] op1
     /*  321138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  321154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321161 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  321164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321180 */     GIR_RootConstrainSelectedInstOperands,
     /*  321181 */     // GIR_Coverage, 62544,
     /*  321181 */     GIR_EraseRootFromParent_Done,
     /*  321182 */   // Label 6146: @321182
     /*  321182 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(321255), // Rule ID 62555 //
     /*  321187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  321195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  321204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321211 */     // MIs[0] op1
     /*  321211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  321237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321239 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321241 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321243 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321253 */     GIR_RootConstrainSelectedInstOperands,
     /*  321254 */     // GIR_Coverage, 62555,
     /*  321254 */     GIR_EraseRootFromParent_Done,
     /*  321255 */   // Label 6147: @321255
     /*  321255 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(321328), // Rule ID 62556 //
     /*  321260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  321268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  321277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321284 */     // MIs[0] op1
     /*  321284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  321310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321326 */     GIR_RootConstrainSelectedInstOperands,
     /*  321327 */     // GIR_Coverage, 62556,
     /*  321327 */     GIR_EraseRootFromParent_Done,
     /*  321328 */   // Label 6148: @321328
     /*  321328 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(321401), // Rule ID 62579 //
     /*  321333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  321341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321357 */     // MIs[0] op1
     /*  321357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  321365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  321383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321385 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321387 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321389 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321399 */     GIR_RootConstrainSelectedInstOperands,
     /*  321400 */     // GIR_Coverage, 62579,
     /*  321400 */     GIR_EraseRootFromParent_Done,
     /*  321401 */   // Label 6149: @321401
     /*  321401 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(321474), // Rule ID 62580 //
     /*  321406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  321414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  321417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  321420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321430 */     // MIs[0] op1
     /*  321430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  321438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  321456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321472 */     GIR_RootConstrainSelectedInstOperands,
     /*  321473 */     // GIR_Coverage, 62580,
     /*  321473 */     GIR_EraseRootFromParent_Done,
     /*  321474 */   // Label 6150: @321474
     /*  321474 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(321547), // Rule ID 62599 //
     /*  321479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321503 */     // MIs[0] op1
     /*  321503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  321519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  321529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321545 */     GIR_RootConstrainSelectedInstOperands,
     /*  321546 */     // GIR_Coverage, 62599,
     /*  321546 */     GIR_EraseRootFromParent_Done,
     /*  321547 */   // Label 6151: @321547
     /*  321547 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(321620), // Rule ID 62600 //
     /*  321552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321576 */     // MIs[0] op1
     /*  321576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  321592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321599 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  321602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321618 */     GIR_RootConstrainSelectedInstOperands,
     /*  321619 */     // GIR_Coverage, 62600,
     /*  321619 */     GIR_EraseRootFromParent_Done,
     /*  321620 */   // Label 6152: @321620
     /*  321620 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(321693), // Rule ID 62611 //
     /*  321625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  321633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  321642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321649 */     // MIs[0] op1
     /*  321649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  321675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321691 */     GIR_RootConstrainSelectedInstOperands,
     /*  321692 */     // GIR_Coverage, 62611,
     /*  321692 */     GIR_EraseRootFromParent_Done,
     /*  321693 */   // Label 6153: @321693
     /*  321693 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(321766), // Rule ID 62612 //
     /*  321698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  321706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  321715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321722 */     // MIs[0] op1
     /*  321722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321745 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  321748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321750 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321752 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321754 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321764 */     GIR_RootConstrainSelectedInstOperands,
     /*  321765 */     // GIR_Coverage, 62612,
     /*  321765 */     GIR_EraseRootFromParent_Done,
     /*  321766 */   // Label 6154: @321766
     /*  321766 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(321839), // Rule ID 62635 //
     /*  321771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  321779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321795 */     // MIs[0] op1
     /*  321795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  321803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  321821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321823 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321825 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321827 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321837 */     GIR_RootConstrainSelectedInstOperands,
     /*  321838 */     // GIR_Coverage, 62635,
     /*  321838 */     GIR_EraseRootFromParent_Done,
     /*  321839 */   // Label 6155: @321839
     /*  321839 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(321912), // Rule ID 62636 //
     /*  321844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  321852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  321855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  321858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  321864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321868 */     // MIs[0] op1
     /*  321868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  321876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321891 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  321894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321896 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321898 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321900 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321910 */     GIR_RootConstrainSelectedInstOperands,
     /*  321911 */     // GIR_Coverage, 62636,
     /*  321911 */     GIR_EraseRootFromParent_Done,
     /*  321912 */   // Label 6156: @321912
     /*  321912 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(321985), // Rule ID 62655 //
     /*  321917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  321920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  321928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  321931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  321937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321941 */     // MIs[0] op1
     /*  321941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  321944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  321949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  321957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  321964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  321967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321969 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  321971 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  321973 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  321975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  321983 */     GIR_RootConstrainSelectedInstOperands,
     /*  321984 */     // GIR_Coverage, 62655,
     /*  321984 */     GIR_EraseRootFromParent_Done,
     /*  321985 */   // Label 6157: @321985
     /*  321985 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(322058), // Rule ID 62656 //
     /*  321990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  321993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  321998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  322001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  322004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322014 */     // MIs[0] op1
     /*  322014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322037 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  322040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322042 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322044 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322046 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322056 */     GIR_RootConstrainSelectedInstOperands,
     /*  322057 */     // GIR_Coverage, 62656,
     /*  322057 */     GIR_EraseRootFromParent_Done,
     /*  322058 */   // Label 6158: @322058
     /*  322058 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(322131), // Rule ID 62667 //
     /*  322063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  322074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  322077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  322080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322087 */     // MIs[0] op1
     /*  322087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  322110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  322113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322115 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322117 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322119 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322129 */     GIR_RootConstrainSelectedInstOperands,
     /*  322130 */     // GIR_Coverage, 62667,
     /*  322130 */     GIR_EraseRootFromParent_Done,
     /*  322131 */   // Label 6159: @322131
     /*  322131 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(322204), // Rule ID 62668 //
     /*  322136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  322147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  322150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  322153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322160 */     // MIs[0] op1
     /*  322160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322183 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  322186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322188 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322190 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322192 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322202 */     GIR_RootConstrainSelectedInstOperands,
     /*  322203 */     // GIR_Coverage, 62668,
     /*  322203 */     GIR_EraseRootFromParent_Done,
     /*  322204 */   // Label 6160: @322204
     /*  322204 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(322277), // Rule ID 62699 //
     /*  322209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  322220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  322223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322233 */     // MIs[0] op1
     /*  322233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322256 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  322256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  322259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322261 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322263 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322265 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322275 */     GIR_RootConstrainSelectedInstOperands,
     /*  322276 */     // GIR_Coverage, 62699,
     /*  322276 */     GIR_EraseRootFromParent_Done,
     /*  322277 */   // Label 6161: @322277
     /*  322277 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(322350), // Rule ID 62700 //
     /*  322282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  322293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  322296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322306 */     // MIs[0] op1
     /*  322306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322329 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  322332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322334 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322336 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322338 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322348 */     GIR_RootConstrainSelectedInstOperands,
     /*  322349 */     // GIR_Coverage, 62700,
     /*  322349 */     GIR_EraseRootFromParent_Done,
     /*  322350 */   // Label 6162: @322350
     /*  322350 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(322423), // Rule ID 62711 //
     /*  322355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  322366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  322369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  322372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322379 */     // MIs[0] op1
     /*  322379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  322402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  322405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322407 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322409 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322411 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322421 */     GIR_RootConstrainSelectedInstOperands,
     /*  322422 */     // GIR_Coverage, 62711,
     /*  322422 */     GIR_EraseRootFromParent_Done,
     /*  322423 */   // Label 6163: @322423
     /*  322423 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(322496), // Rule ID 62712 //
     /*  322428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  322439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  322442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  322445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322452 */     // MIs[0] op1
     /*  322452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322475 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  322478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322480 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322482 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322484 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322494 */     GIR_RootConstrainSelectedInstOperands,
     /*  322495 */     // GIR_Coverage, 62712,
     /*  322495 */     GIR_EraseRootFromParent_Done,
     /*  322496 */   // Label 6164: @322496
     /*  322496 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(322569), // Rule ID 62743 //
     /*  322501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  322512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  322515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322525 */     // MIs[0] op1
     /*  322525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  322548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  322551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322553 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322555 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322557 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322567 */     GIR_RootConstrainSelectedInstOperands,
     /*  322568 */     // GIR_Coverage, 62743,
     /*  322568 */     GIR_EraseRootFromParent_Done,
     /*  322569 */   // Label 6165: @322569
     /*  322569 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(322642), // Rule ID 62744 //
     /*  322574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  322585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  322588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322598 */     // MIs[0] op1
     /*  322598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  322624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322640 */     GIR_RootConstrainSelectedInstOperands,
     /*  322641 */     // GIR_Coverage, 62744,
     /*  322641 */     GIR_EraseRootFromParent_Done,
     /*  322642 */   // Label 6166: @322642
     /*  322642 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(322715), // Rule ID 62755 //
     /*  322647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  322658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  322661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  322664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322671 */     // MIs[0] op1
     /*  322671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322694 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  322694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  322697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322699 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322701 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322703 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322713 */     GIR_RootConstrainSelectedInstOperands,
     /*  322714 */     // GIR_Coverage, 62755,
     /*  322714 */     GIR_EraseRootFromParent_Done,
     /*  322715 */   // Label 6167: @322715
     /*  322715 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(322788), // Rule ID 62756 //
     /*  322720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  322731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  322734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  322737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322744 */     // MIs[0] op1
     /*  322744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322767 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  322767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  322770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  322786 */     GIR_RootConstrainSelectedInstOperands,
     /*  322787 */     // GIR_Coverage, 62756,
     /*  322787 */     GIR_EraseRootFromParent_Done,
     /*  322788 */   // Label 6168: @322788
     /*  322788 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(322861), // Rule ID 62787 //
     /*  322793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  322804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  322807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322817 */     // MIs[0] op1
     /*  322817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  322843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322845 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322847 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322849 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322859 */     GIR_RootConstrainSelectedInstOperands,
     /*  322860 */     // GIR_Coverage, 62787,
     /*  322860 */     GIR_EraseRootFromParent_Done,
     /*  322861 */   // Label 6169: @322861
     /*  322861 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(322934), // Rule ID 62788 //
     /*  322866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  322869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  322874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  322877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  322880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  322886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322890 */     // MIs[0] op1
     /*  322890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  322906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  322916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322918 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322920 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322922 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322932 */     GIR_RootConstrainSelectedInstOperands,
     /*  322933 */     // GIR_Coverage, 62788,
     /*  322933 */     GIR_EraseRootFromParent_Done,
     /*  322934 */   // Label 6170: @322934
     /*  322934 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(323007), // Rule ID 62799 //
     /*  322939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  322942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  322947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  322950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  322953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  322956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  322959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322963 */     // MIs[0] op1
     /*  322963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  322966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  322971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  322989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322991 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  322993 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  322995 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  322997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323005 */     GIR_RootConstrainSelectedInstOperands,
     /*  323006 */     // GIR_Coverage, 62799,
     /*  323006 */     GIR_EraseRootFromParent_Done,
     /*  323007 */   // Label 6171: @323007
     /*  323007 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(323080), // Rule ID 62800 //
     /*  323012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  323020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  323023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  323029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323036 */     // MIs[0] op1
     /*  323036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  323062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323064 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323066 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323068 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323078 */     GIR_RootConstrainSelectedInstOperands,
     /*  323079 */     // GIR_Coverage, 62800,
     /*  323079 */     GIR_EraseRootFromParent_Done,
     /*  323080 */   // Label 6172: @323080
     /*  323080 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(323153), // Rule ID 62823 //
     /*  323085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  323093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  323096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  323102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323109 */     // MIs[0] op1
     /*  323109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  323117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  323125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  323135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323137 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323139 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323141 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323151 */     GIR_RootConstrainSelectedInstOperands,
     /*  323152 */     // GIR_Coverage, 62823,
     /*  323152 */     GIR_EraseRootFromParent_Done,
     /*  323153 */   // Label 6173: @323153
     /*  323153 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(323226), // Rule ID 62824 //
     /*  323158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  323166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  323169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  323175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323182 */     // MIs[0] op1
     /*  323182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  323190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  323198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  323208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323224 */     GIR_RootConstrainSelectedInstOperands,
     /*  323225 */     // GIR_Coverage, 62824,
     /*  323225 */     GIR_EraseRootFromParent_Done,
     /*  323226 */   // Label 6174: @323226
     /*  323226 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(323299), // Rule ID 62843 //
     /*  323231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  323239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323255 */     // MIs[0] op1
     /*  323255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  323271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323278 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  323281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323283 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323285 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323287 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323297 */     GIR_RootConstrainSelectedInstOperands,
     /*  323298 */     // GIR_Coverage, 62843,
     /*  323298 */     GIR_EraseRootFromParent_Done,
     /*  323299 */   // Label 6175: @323299
     /*  323299 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(323372), // Rule ID 62844 //
     /*  323304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  323312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323328 */     // MIs[0] op1
     /*  323328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  323344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323351 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  323354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323356 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323358 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323360 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323370 */     GIR_RootConstrainSelectedInstOperands,
     /*  323371 */     // GIR_Coverage, 62844,
     /*  323371 */     GIR_EraseRootFromParent_Done,
     /*  323372 */   // Label 6176: @323372
     /*  323372 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(323445), // Rule ID 62855 //
     /*  323377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  323385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  323394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323401 */     // MIs[0] op1
     /*  323401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  323427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323429 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323431 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323433 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323443 */     GIR_RootConstrainSelectedInstOperands,
     /*  323444 */     // GIR_Coverage, 62855,
     /*  323444 */     GIR_EraseRootFromParent_Done,
     /*  323445 */   // Label 6177: @323445
     /*  323445 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(323518), // Rule ID 62856 //
     /*  323450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  323458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  323467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323474 */     // MIs[0] op1
     /*  323474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323497 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  323500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323502 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323504 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323506 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323516 */     GIR_RootConstrainSelectedInstOperands,
     /*  323517 */     // GIR_Coverage, 62856,
     /*  323517 */     GIR_EraseRootFromParent_Done,
     /*  323518 */   // Label 6178: @323518
     /*  323518 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(323591), // Rule ID 62879 //
     /*  323523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  323531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  323540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323547 */     // MIs[0] op1
     /*  323547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  323555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  323563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  323573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323575 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323577 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323579 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323589 */     GIR_RootConstrainSelectedInstOperands,
     /*  323590 */     // GIR_Coverage, 62879,
     /*  323590 */     GIR_EraseRootFromParent_Done,
     /*  323591 */   // Label 6179: @323591
     /*  323591 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(323664), // Rule ID 62880 //
     /*  323596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  323604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  323607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  323613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323620 */     // MIs[0] op1
     /*  323620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  323628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  323636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323643 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  323646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323648 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323650 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323652 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323662 */     GIR_RootConstrainSelectedInstOperands,
     /*  323663 */     // GIR_Coverage, 62880,
     /*  323663 */     GIR_EraseRootFromParent_Done,
     /*  323664 */   // Label 6180: @323664
     /*  323664 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(323737), // Rule ID 62899 //
     /*  323669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  323677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  323680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323693 */     // MIs[0] op1
     /*  323693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  323709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  323719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323721 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323723 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323725 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323735 */     GIR_RootConstrainSelectedInstOperands,
     /*  323736 */     // GIR_Coverage, 62899,
     /*  323736 */     GIR_EraseRootFromParent_Done,
     /*  323737 */   // Label 6181: @323737
     /*  323737 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(323810), // Rule ID 62900 //
     /*  323742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  323750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  323753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323766 */     // MIs[0] op1
     /*  323766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  323782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  323792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323808 */     GIR_RootConstrainSelectedInstOperands,
     /*  323809 */     // GIR_Coverage, 62900,
     /*  323809 */     GIR_EraseRootFromParent_Done,
     /*  323810 */   // Label 6182: @323810
     /*  323810 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(323883), // Rule ID 62911 //
     /*  323815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  323823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  323826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  323832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323839 */     // MIs[0] op1
     /*  323839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  323865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323867 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323869 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323871 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323881 */     GIR_RootConstrainSelectedInstOperands,
     /*  323882 */     // GIR_Coverage, 62911,
     /*  323882 */     GIR_EraseRootFromParent_Done,
     /*  323883 */   // Label 6183: @323883
     /*  323883 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(323956), // Rule ID 62912 //
     /*  323888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  323891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  323896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  323899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  323905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  323908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323912 */     // MIs[0] op1
     /*  323912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  323920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323935 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  323938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323940 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  323942 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  323944 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  323946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323954 */     GIR_RootConstrainSelectedInstOperands,
     /*  323955 */     // GIR_Coverage, 62912,
     /*  323955 */     GIR_EraseRootFromParent_Done,
     /*  323956 */   // Label 6184: @323956
     /*  323956 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(324029), // Rule ID 62935 //
     /*  323961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  323964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  323969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  323972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  323978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  323981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323985 */     // MIs[0] op1
     /*  323985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  323988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  323993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  324011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324027 */     GIR_RootConstrainSelectedInstOperands,
     /*  324028 */     // GIR_Coverage, 62935,
     /*  324028 */     GIR_EraseRootFromParent_Done,
     /*  324029 */   // Label 6185: @324029
     /*  324029 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(324102), // Rule ID 62936 //
     /*  324034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  324042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  324045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  324048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  324051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324058 */     // MIs[0] op1
     /*  324058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  324066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324081 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  324084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324100 */     GIR_RootConstrainSelectedInstOperands,
     /*  324101 */     // GIR_Coverage, 62936,
     /*  324101 */     GIR_EraseRootFromParent_Done,
     /*  324102 */   // Label 6186: @324102
     /*  324102 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(324175), // Rule ID 62955 //
     /*  324107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  324115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324131 */     // MIs[0] op1
     /*  324131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  324147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  324157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324159 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324161 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324163 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324173 */     GIR_RootConstrainSelectedInstOperands,
     /*  324174 */     // GIR_Coverage, 62955,
     /*  324174 */     GIR_EraseRootFromParent_Done,
     /*  324175 */   // Label 6187: @324175
     /*  324175 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(324248), // Rule ID 62956 //
     /*  324180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  324188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324204 */     // MIs[0] op1
     /*  324204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  324220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  324230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324232 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324234 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324236 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324246 */     GIR_RootConstrainSelectedInstOperands,
     /*  324247 */     // GIR_Coverage, 62956,
     /*  324247 */     GIR_EraseRootFromParent_Done,
     /*  324248 */   // Label 6188: @324248
     /*  324248 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(324321), // Rule ID 62967 //
     /*  324253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  324261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  324270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324277 */     // MIs[0] op1
     /*  324277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  324303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324305 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324307 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324309 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324319 */     GIR_RootConstrainSelectedInstOperands,
     /*  324320 */     // GIR_Coverage, 62967,
     /*  324320 */     GIR_EraseRootFromParent_Done,
     /*  324321 */   // Label 6189: @324321
     /*  324321 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(324394), // Rule ID 62968 //
     /*  324326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  324334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  324343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324350 */     // MIs[0] op1
     /*  324350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  324376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324378 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324380 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324382 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324392 */     GIR_RootConstrainSelectedInstOperands,
     /*  324393 */     // GIR_Coverage, 62968,
     /*  324393 */     GIR_EraseRootFromParent_Done,
     /*  324394 */   // Label 6190: @324394
     /*  324394 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(324467), // Rule ID 62991 //
     /*  324399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  324407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324423 */     // MIs[0] op1
     /*  324423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  324431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  324449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324451 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324453 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324455 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324465 */     GIR_RootConstrainSelectedInstOperands,
     /*  324466 */     // GIR_Coverage, 62991,
     /*  324466 */     GIR_EraseRootFromParent_Done,
     /*  324467 */   // Label 6191: @324467
     /*  324467 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(324540), // Rule ID 62992 //
     /*  324472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  324480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  324483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324496 */     // MIs[0] op1
     /*  324496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  324504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  324522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324524 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324526 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324528 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324538 */     GIR_RootConstrainSelectedInstOperands,
     /*  324539 */     // GIR_Coverage, 62992,
     /*  324539 */     GIR_EraseRootFromParent_Done,
     /*  324540 */   // Label 6192: @324540
     /*  324540 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(324613), // Rule ID 63011 //
     /*  324545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  324553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324569 */     // MIs[0] op1
     /*  324569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  324585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  324595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324597 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324599 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324601 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324611 */     GIR_RootConstrainSelectedInstOperands,
     /*  324612 */     // GIR_Coverage, 63011,
     /*  324612 */     GIR_EraseRootFromParent_Done,
     /*  324613 */   // Label 6193: @324613
     /*  324613 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(324686), // Rule ID 63012 //
     /*  324618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  324626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324642 */     // MIs[0] op1
     /*  324642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  324658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  324668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324670 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324672 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324674 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324684 */     GIR_RootConstrainSelectedInstOperands,
     /*  324685 */     // GIR_Coverage, 63012,
     /*  324685 */     GIR_EraseRootFromParent_Done,
     /*  324686 */   // Label 6194: @324686
     /*  324686 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(324759), // Rule ID 63023 //
     /*  324691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  324699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  324708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324715 */     // MIs[0] op1
     /*  324715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  324741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324743 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324745 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324747 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324757 */     GIR_RootConstrainSelectedInstOperands,
     /*  324758 */     // GIR_Coverage, 63023,
     /*  324758 */     GIR_EraseRootFromParent_Done,
     /*  324759 */   // Label 6195: @324759
     /*  324759 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(324832), // Rule ID 63024 //
     /*  324764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  324772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  324781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324788 */     // MIs[0] op1
     /*  324788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  324796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324811 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  324814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324816 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324818 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324820 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324830 */     GIR_RootConstrainSelectedInstOperands,
     /*  324831 */     // GIR_Coverage, 63024,
     /*  324831 */     GIR_EraseRootFromParent_Done,
     /*  324832 */   // Label 6196: @324832
     /*  324832 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(324905), // Rule ID 63047 //
     /*  324837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  324845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  324857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324861 */     // MIs[0] op1
     /*  324861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  324869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  324887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324889 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324891 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324893 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324903 */     GIR_RootConstrainSelectedInstOperands,
     /*  324904 */     // GIR_Coverage, 63047,
     /*  324904 */     GIR_EraseRootFromParent_Done,
     /*  324905 */   // Label 6197: @324905
     /*  324905 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(324978), // Rule ID 63048 //
     /*  324910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  324913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  324918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  324921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  324930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324934 */     // MIs[0] op1
     /*  324934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  324937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  324942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  324960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324962 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  324964 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  324966 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  324968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324976 */     GIR_RootConstrainSelectedInstOperands,
     /*  324977 */     // GIR_Coverage, 63048,
     /*  324977 */     GIR_EraseRootFromParent_Done,
     /*  324978 */   // Label 6198: @324978
     /*  324978 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(325051), // Rule ID 63067 //
     /*  324983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  324986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  324991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  324994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325007 */     // MIs[0] op1
     /*  325007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  325033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325035 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325037 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325039 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325049 */     GIR_RootConstrainSelectedInstOperands,
     /*  325050 */     // GIR_Coverage, 63067,
     /*  325050 */     GIR_EraseRootFromParent_Done,
     /*  325051 */   // Label 6199: @325051
     /*  325051 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(325124), // Rule ID 63068 //
     /*  325056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  325064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  325067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  325070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325080 */     // MIs[0] op1
     /*  325080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325103 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  325106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325122 */     GIR_RootConstrainSelectedInstOperands,
     /*  325123 */     // GIR_Coverage, 63068,
     /*  325123 */     GIR_EraseRootFromParent_Done,
     /*  325124 */   // Label 6200: @325124
     /*  325124 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(325197), // Rule ID 63079 //
     /*  325129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  325137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  325140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  325143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  325146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325153 */     // MIs[0] op1
     /*  325153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  325179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325181 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325183 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325185 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325195 */     GIR_RootConstrainSelectedInstOperands,
     /*  325196 */     // GIR_Coverage, 63079,
     /*  325196 */     GIR_EraseRootFromParent_Done,
     /*  325197 */   // Label 6201: @325197
     /*  325197 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(325270), // Rule ID 63080 //
     /*  325202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  325210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  325213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  325216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  325219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325226 */     // MIs[0] op1
     /*  325226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  325252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325254 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325256 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325258 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325268 */     GIR_RootConstrainSelectedInstOperands,
     /*  325269 */     // GIR_Coverage, 63080,
     /*  325269 */     GIR_EraseRootFromParent_Done,
     /*  325270 */   // Label 6202: @325270
     /*  325270 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(325343), // Rule ID 63103 //
     /*  325275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  325283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  325286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  325289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325299 */     // MIs[0] op1
     /*  325299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  325307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  325325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325327 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325329 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325331 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325341 */     GIR_RootConstrainSelectedInstOperands,
     /*  325342 */     // GIR_Coverage, 63103,
     /*  325342 */     GIR_EraseRootFromParent_Done,
     /*  325343 */   // Label 6203: @325343
     /*  325343 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(325416), // Rule ID 63104 //
     /*  325348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  325356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  325359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  325362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325372 */     // MIs[0] op1
     /*  325372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  325380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325395 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  325398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325400 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325402 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325404 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325414 */     GIR_RootConstrainSelectedInstOperands,
     /*  325415 */     // GIR_Coverage, 63104,
     /*  325415 */     GIR_EraseRootFromParent_Done,
     /*  325416 */   // Label 6204: @325416
     /*  325416 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(325489), // Rule ID 63123 //
     /*  325421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  325429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325445 */     // MIs[0] op1
     /*  325445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  325471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325473 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325475 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325477 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325487 */     GIR_RootConstrainSelectedInstOperands,
     /*  325488 */     // GIR_Coverage, 63123,
     /*  325488 */     GIR_EraseRootFromParent_Done,
     /*  325489 */   // Label 6205: @325489
     /*  325489 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(325562), // Rule ID 63124 //
     /*  325494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  325502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325518 */     // MIs[0] op1
     /*  325518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  325544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325546 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325548 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325550 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325560 */     GIR_RootConstrainSelectedInstOperands,
     /*  325561 */     // GIR_Coverage, 63124,
     /*  325561 */     GIR_EraseRootFromParent_Done,
     /*  325562 */   // Label 6206: @325562
     /*  325562 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(325635), // Rule ID 63135 //
     /*  325567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  325575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  325584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325591 */     // MIs[0] op1
     /*  325591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  325617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325619 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325621 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325623 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325633 */     GIR_RootConstrainSelectedInstOperands,
     /*  325634 */     // GIR_Coverage, 63135,
     /*  325634 */     GIR_EraseRootFromParent_Done,
     /*  325635 */   // Label 6207: @325635
     /*  325635 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(325708), // Rule ID 63136 //
     /*  325640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  325648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  325657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325664 */     // MIs[0] op1
     /*  325664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  325690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325692 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325694 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325696 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325706 */     GIR_RootConstrainSelectedInstOperands,
     /*  325707 */     // GIR_Coverage, 63136,
     /*  325707 */     GIR_EraseRootFromParent_Done,
     /*  325708 */   // Label 6208: @325708
     /*  325708 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(325781), // Rule ID 63159 //
     /*  325713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  325721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325737 */     // MIs[0] op1
     /*  325737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  325745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  325763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325765 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325767 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325769 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325779 */     GIR_RootConstrainSelectedInstOperands,
     /*  325780 */     // GIR_Coverage, 63159,
     /*  325780 */     GIR_EraseRootFromParent_Done,
     /*  325781 */   // Label 6209: @325781
     /*  325781 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(325854), // Rule ID 63160 //
     /*  325786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  325794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  325797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  325800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325810 */     // MIs[0] op1
     /*  325810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  325818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325833 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  325836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325852 */     GIR_RootConstrainSelectedInstOperands,
     /*  325853 */     // GIR_Coverage, 63160,
     /*  325853 */     GIR_EraseRootFromParent_Done,
     /*  325854 */   // Label 6210: @325854
     /*  325854 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(325927), // Rule ID 63179 //
     /*  325859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  325862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  325867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  325870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  325873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  325879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325883 */     // MIs[0] op1
     /*  325883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  325909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325911 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325913 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325915 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325925 */     GIR_RootConstrainSelectedInstOperands,
     /*  325926 */     // GIR_Coverage, 63179,
     /*  325926 */     GIR_EraseRootFromParent_Done,
     /*  325927 */   // Label 6211: @325927
     /*  325927 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(326000), // Rule ID 63180 //
     /*  325932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  325935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  325940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  325943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  325946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  325952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325956 */     // MIs[0] op1
     /*  325956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  325959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  325964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  325972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  325982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  325986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  325988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  325990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325998 */     GIR_RootConstrainSelectedInstOperands,
     /*  325999 */     // GIR_Coverage, 63180,
     /*  325999 */     GIR_EraseRootFromParent_Done,
     /*  326000 */   // Label 6212: @326000
     /*  326000 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(326073), // Rule ID 63191 //
     /*  326005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  326008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  326013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  326016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  326019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  326022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326029 */     // MIs[0] op1
     /*  326029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  326055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326057 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326059 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326061 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326071 */     GIR_RootConstrainSelectedInstOperands,
     /*  326072 */     // GIR_Coverage, 63191,
     /*  326072 */     GIR_EraseRootFromParent_Done,
     /*  326073 */   // Label 6213: @326073
     /*  326073 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(326146), // Rule ID 63192 //
     /*  326078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  326081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  326086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  326089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  326092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  326095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326102 */     // MIs[0] op1
     /*  326102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326125 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  326128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326144 */     GIR_RootConstrainSelectedInstOperands,
     /*  326145 */     // GIR_Coverage, 63192,
     /*  326145 */     GIR_EraseRootFromParent_Done,
     /*  326146 */   // Label 6214: @326146
     /*  326146 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(326219), // Rule ID 63215 //
     /*  326151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  326154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  326159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  326162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  326165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326175 */     // MIs[0] op1
     /*  326175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  326183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  326201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326203 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326205 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326207 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326217 */     GIR_RootConstrainSelectedInstOperands,
     /*  326218 */     // GIR_Coverage, 63215,
     /*  326218 */     GIR_EraseRootFromParent_Done,
     /*  326219 */   // Label 6215: @326219
     /*  326219 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(326292), // Rule ID 63216 //
     /*  326224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  326227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  326232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  326235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  326238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326248 */     // MIs[0] op1
     /*  326248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  326256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  326274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326290 */     GIR_RootConstrainSelectedInstOperands,
     /*  326291 */     // GIR_Coverage, 63216,
     /*  326291 */     GIR_EraseRootFromParent_Done,
     /*  326292 */   // Label 6216: @326292
     /*  326292 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(326365), // Rule ID 63235 //
     /*  326297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  326300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  326305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326321 */     // MIs[0] op1
     /*  326321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  326337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  326347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326349 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326351 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326353 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326363 */     GIR_RootConstrainSelectedInstOperands,
     /*  326364 */     // GIR_Coverage, 63235,
     /*  326364 */     GIR_EraseRootFromParent_Done,
     /*  326365 */   // Label 6217: @326365
     /*  326365 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(326438), // Rule ID 63236 //
     /*  326370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  326373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  326378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326394 */     // MIs[0] op1
     /*  326394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  326410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  326420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326422 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326424 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326426 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326436 */     GIR_RootConstrainSelectedInstOperands,
     /*  326437 */     // GIR_Coverage, 63236,
     /*  326437 */     GIR_EraseRootFromParent_Done,
     /*  326438 */   // Label 6218: @326438
     /*  326438 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(326511), // Rule ID 63247 //
     /*  326443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  326446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  326451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  326460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326467 */     // MIs[0] op1
     /*  326467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  326493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326495 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326497 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326499 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326509 */     GIR_RootConstrainSelectedInstOperands,
     /*  326510 */     // GIR_Coverage, 63247,
     /*  326510 */     GIR_EraseRootFromParent_Done,
     /*  326511 */   // Label 6219: @326511
     /*  326511 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(326584), // Rule ID 63248 //
     /*  326516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  326519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  326524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  326533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326540 */     // MIs[0] op1
     /*  326540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  326548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326563 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  326566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326582 */     GIR_RootConstrainSelectedInstOperands,
     /*  326583 */     // GIR_Coverage, 63248,
     /*  326583 */     GIR_EraseRootFromParent_Done,
     /*  326584 */   // Label 6220: @326584
     /*  326584 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(326657), // Rule ID 63271 //
     /*  326589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  326592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  326597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326613 */     // MIs[0] op1
     /*  326613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  326621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  326639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326641 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326643 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326645 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326655 */     GIR_RootConstrainSelectedInstOperands,
     /*  326656 */     // GIR_Coverage, 63271,
     /*  326656 */     GIR_EraseRootFromParent_Done,
     /*  326657 */   // Label 6221: @326657
     /*  326657 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(326730), // Rule ID 63272 //
     /*  326662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  326665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  326670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  326673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  326676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326686 */     // MIs[0] op1
     /*  326686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  326689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  326694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10752:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  326712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326714 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  326716 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  326718 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  326720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326728 */     GIR_RootConstrainSelectedInstOperands,
     /*  326729 */     // GIR_Coverage, 63272,
     /*  326729 */     GIR_EraseRootFromParent_Done,
     /*  326730 */   // Label 6222: @326730
     /*  326730 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(326813), // Rule ID 5184 //
     /*  326735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  326738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  326743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  326749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  326755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  326770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  326774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  326778 */     // MIs[1] Operand 1
     /*  326778 */     // No operand predicates
     /*  326778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  326782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  326784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326791 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  326791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  326794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  326801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  326803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  326811 */     GIR_RootConstrainSelectedInstOperands,
     /*  326812 */     // GIR_Coverage, 5184,
     /*  326812 */     GIR_EraseRootFromParent_Done,
     /*  326813 */   // Label 6223: @326813
     /*  326813 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(326896), // Rule ID 5185 //
     /*  326818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  326821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  326826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  326832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  326838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  326841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  326853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  326857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  326861 */     // MIs[1] Operand 1
     /*  326861 */     // No operand predicates
     /*  326861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  326865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  326867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  326874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  326877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  326884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  326886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  326894 */     GIR_RootConstrainSelectedInstOperands,
     /*  326895 */     // GIR_Coverage, 5185,
     /*  326895 */     GIR_EraseRootFromParent_Done,
     /*  326896 */   // Label 6224: @326896
     /*  326896 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(326979), // Rule ID 5186 //
     /*  326901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  326904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  326909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  326915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  326921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  326924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  326936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  326940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  326944 */     // MIs[1] Operand 1
     /*  326944 */     // No operand predicates
     /*  326944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  326948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  326950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326957 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  326957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  326960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  326967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  326969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  326977 */     GIR_RootConstrainSelectedInstOperands,
     /*  326978 */     // GIR_Coverage, 5186,
     /*  326978 */     GIR_EraseRootFromParent_Done,
     /*  326979 */   // Label 6225: @326979
     /*  326979 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(327062), // Rule ID 5187 //
     /*  326984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  326987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  326992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  326998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  327004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327027 */     // MIs[1] Operand 1
     /*  327027 */     // No operand predicates
     /*  327027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  327040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  327043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  327060 */     GIR_RootConstrainSelectedInstOperands,
     /*  327061 */     // GIR_Coverage, 5187,
     /*  327061 */     GIR_EraseRootFromParent_Done,
     /*  327062 */   // Label 6226: @327062
     /*  327062 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(327145), // Rule ID 5188 //
     /*  327067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  327081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  327087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327110 */     // MIs[1] Operand 1
     /*  327110 */     // No operand predicates
     /*  327110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  327123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  327143 */     GIR_RootConstrainSelectedInstOperands,
     /*  327144 */     // GIR_Coverage, 5188,
     /*  327144 */     GIR_EraseRootFromParent_Done,
     /*  327145 */   // Label 6227: @327145
     /*  327145 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(327228), // Rule ID 5189 //
     /*  327150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  327164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  327170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327193 */     // MIs[1] Operand 1
     /*  327193 */     // No operand predicates
     /*  327193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  327206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  327226 */     GIR_RootConstrainSelectedInstOperands,
     /*  327227 */     // GIR_Coverage, 5189,
     /*  327227 */     GIR_EraseRootFromParent_Done,
     /*  327228 */   // Label 6228: @327228
     /*  327228 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(327311), // Rule ID 5190 //
     /*  327233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  327247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  327253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327276 */     // MIs[1] Operand 1
     /*  327276 */     // No operand predicates
     /*  327276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327289 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  327292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327309 */     GIR_RootConstrainSelectedInstOperands,
     /*  327310 */     // GIR_Coverage, 5190,
     /*  327310 */     GIR_EraseRootFromParent_Done,
     /*  327311 */   // Label 6229: @327311
     /*  327311 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(327394), // Rule ID 5191 //
     /*  327316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  327330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  327336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327359 */     // MIs[1] Operand 1
     /*  327359 */     // No operand predicates
     /*  327359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327372 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  327375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327392 */     GIR_RootConstrainSelectedInstOperands,
     /*  327393 */     // GIR_Coverage, 5191,
     /*  327393 */     GIR_EraseRootFromParent_Done,
     /*  327394 */   // Label 6230: @327394
     /*  327394 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(327477), // Rule ID 5192 //
     /*  327399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  327419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327442 */     // MIs[1] Operand 1
     /*  327442 */     // No operand predicates
     /*  327442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327475 */     GIR_RootConstrainSelectedInstOperands,
     /*  327476 */     // GIR_Coverage, 5192,
     /*  327476 */     GIR_EraseRootFromParent_Done,
     /*  327477 */   // Label 6231: @327477
     /*  327477 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(327560), // Rule ID 5193 //
     /*  327482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  327502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327525 */     // MIs[1] Operand 1
     /*  327525 */     // No operand predicates
     /*  327525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327558 */     GIR_RootConstrainSelectedInstOperands,
     /*  327559 */     // GIR_Coverage, 5193,
     /*  327559 */     GIR_EraseRootFromParent_Done,
     /*  327560 */   // Label 6232: @327560
     /*  327560 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(327643), // Rule ID 5194 //
     /*  327565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  327585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327608 */     // MIs[1] Operand 1
     /*  327608 */     // No operand predicates
     /*  327608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327621 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327641 */     GIR_RootConstrainSelectedInstOperands,
     /*  327642 */     // GIR_Coverage, 5194,
     /*  327642 */     GIR_EraseRootFromParent_Done,
     /*  327643 */   // Label 6233: @327643
     /*  327643 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(327726), // Rule ID 5195 //
     /*  327648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  327668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327691 */     // MIs[1] Operand 1
     /*  327691 */     // No operand predicates
     /*  327691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  327707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327724 */     GIR_RootConstrainSelectedInstOperands,
     /*  327725 */     // GIR_Coverage, 5195,
     /*  327725 */     GIR_EraseRootFromParent_Done,
     /*  327726 */   // Label 6234: @327726
     /*  327726 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(327809), // Rule ID 5196 //
     /*  327731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  327745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  327751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327774 */     // MIs[1] Operand 1
     /*  327774 */     // No operand predicates
     /*  327774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327787 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  327787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  327790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  327807 */     GIR_RootConstrainSelectedInstOperands,
     /*  327808 */     // GIR_Coverage, 5196,
     /*  327808 */     GIR_EraseRootFromParent_Done,
     /*  327809 */   // Label 6235: @327809
     /*  327809 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(327892), // Rule ID 5197 //
     /*  327814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  327828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  327834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  327837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327857 */     // MIs[1] Operand 1
     /*  327857 */     // No operand predicates
     /*  327857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  327870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  327873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327880 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  327890 */     GIR_RootConstrainSelectedInstOperands,
     /*  327891 */     // GIR_Coverage, 5197,
     /*  327891 */     GIR_EraseRootFromParent_Done,
     /*  327892 */   // Label 6236: @327892
     /*  327892 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(327975), // Rule ID 5198 //
     /*  327897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  327900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  327914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  327917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  327920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  327932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  327936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  327940 */     // MIs[1] Operand 1
     /*  327940 */     // No operand predicates
     /*  327940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  327944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  327946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327953 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  327956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  327963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  327965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327973 */     GIR_RootConstrainSelectedInstOperands,
     /*  327974 */     // GIR_Coverage, 5198,
     /*  327974 */     GIR_EraseRootFromParent_Done,
     /*  327975 */   // Label 6237: @327975
     /*  327975 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(328058), // Rule ID 5199 //
     /*  327980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  327983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  327988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  327997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  328000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328023 */     // MIs[1] Operand 1
     /*  328023 */     // No operand predicates
     /*  328023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  328039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328056 */     GIR_RootConstrainSelectedInstOperands,
     /*  328057 */     // GIR_Coverage, 5199,
     /*  328057 */     GIR_EraseRootFromParent_Done,
     /*  328058 */   // Label 6238: @328058
     /*  328058 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(328141), // Rule ID 5200 //
     /*  328063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  328066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  328083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328106 */     // MIs[1] Operand 1
     /*  328106 */     // No operand predicates
     /*  328106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  328122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328139 */     GIR_RootConstrainSelectedInstOperands,
     /*  328140 */     // GIR_Coverage, 5200,
     /*  328140 */     GIR_EraseRootFromParent_Done,
     /*  328141 */   // Label 6239: @328141
     /*  328141 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(328224), // Rule ID 5201 //
     /*  328146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  328149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  328166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328189 */     // MIs[1] Operand 1
     /*  328189 */     // No operand predicates
     /*  328189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  328205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328222 */     GIR_RootConstrainSelectedInstOperands,
     /*  328223 */     // GIR_Coverage, 5201,
     /*  328223 */     GIR_EraseRootFromParent_Done,
     /*  328224 */   // Label 6240: @328224
     /*  328224 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(328307), // Rule ID 5202 //
     /*  328229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  328232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  328249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328272 */     // MIs[1] Operand 1
     /*  328272 */     // No operand predicates
     /*  328272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  328288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328305 */     GIR_RootConstrainSelectedInstOperands,
     /*  328306 */     // GIR_Coverage, 5202,
     /*  328306 */     GIR_EraseRootFromParent_Done,
     /*  328307 */   // Label 6241: @328307
     /*  328307 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(328390), // Rule ID 5203 //
     /*  328312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  328315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  328332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328355 */     // MIs[1] Operand 1
     /*  328355 */     // No operand predicates
     /*  328355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328368 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  328371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328388 */     GIR_RootConstrainSelectedInstOperands,
     /*  328389 */     // GIR_Coverage, 5203,
     /*  328389 */     GIR_EraseRootFromParent_Done,
     /*  328390 */   // Label 6242: @328390
     /*  328390 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(328473), // Rule ID 5204 //
     /*  328395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  328398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  328409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  328415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328438 */     // MIs[1] Operand 1
     /*  328438 */     // No operand predicates
     /*  328438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  328451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  328454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328471 */     GIR_RootConstrainSelectedInstOperands,
     /*  328472 */     // GIR_Coverage, 5204,
     /*  328472 */     GIR_EraseRootFromParent_Done,
     /*  328473 */   // Label 6243: @328473
     /*  328473 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(328556), // Rule ID 5205 //
     /*  328478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  328481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  328492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  328498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328521 */     // MIs[1] Operand 1
     /*  328521 */     // No operand predicates
     /*  328521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328534 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  328534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  328537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328554 */     GIR_RootConstrainSelectedInstOperands,
     /*  328555 */     // GIR_Coverage, 5205,
     /*  328555 */     GIR_EraseRootFromParent_Done,
     /*  328556 */   // Label 6244: @328556
     /*  328556 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(328639), // Rule ID 5206 //
     /*  328561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  328564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  328572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  328575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  328581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328604 */     // MIs[1] Operand 1
     /*  328604 */     // No operand predicates
     /*  328604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328617 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  328617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  328620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328637 */     GIR_RootConstrainSelectedInstOperands,
     /*  328638 */     // GIR_Coverage, 5206,
     /*  328638 */     GIR_EraseRootFromParent_Done,
     /*  328639 */   // Label 6245: @328639
     /*  328639 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(328722), // Rule ID 5207 //
     /*  328644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  328647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  328655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  328658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  328664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328687 */     // MIs[1] Operand 1
     /*  328687 */     // No operand predicates
     /*  328687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328700 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  328700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  328703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328720 */     GIR_RootConstrainSelectedInstOperands,
     /*  328721 */     // GIR_Coverage, 5207,
     /*  328721 */     GIR_EraseRootFromParent_Done,
     /*  328722 */   // Label 6246: @328722
     /*  328722 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(328805), // Rule ID 5208 //
     /*  328727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  328730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  328738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  328741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  328747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328770 */     // MIs[1] Operand 1
     /*  328770 */     // No operand predicates
     /*  328770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328783 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  328783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  328786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328803 */     GIR_RootConstrainSelectedInstOperands,
     /*  328804 */     // GIR_Coverage, 5208,
     /*  328804 */     GIR_EraseRootFromParent_Done,
     /*  328805 */   // Label 6247: @328805
     /*  328805 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(328888), // Rule ID 5209 //
     /*  328810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  328813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  328821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  328824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  328830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328853 */     // MIs[1] Operand 1
     /*  328853 */     // No operand predicates
     /*  328853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328866 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  328866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  328869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  328886 */     GIR_RootConstrainSelectedInstOperands,
     /*  328887 */     // GIR_Coverage, 5209,
     /*  328887 */     GIR_EraseRootFromParent_Done,
     /*  328888 */   // Label 6248: @328888
     /*  328888 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(328971), // Rule ID 5210 //
     /*  328893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  328896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  328907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  328913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  328916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  328928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  328932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  328936 */     // MIs[1] Operand 1
     /*  328936 */     // No operand predicates
     /*  328936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  328940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  328942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  328952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  328959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  328961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328969 */     GIR_RootConstrainSelectedInstOperands,
     /*  328970 */     // GIR_Coverage, 5210,
     /*  328970 */     GIR_EraseRootFromParent_Done,
     /*  328971 */   // Label 6249: @328971
     /*  328971 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(329054), // Rule ID 5211 //
     /*  328976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  328979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  328984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  328990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  328996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  328999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329019 */     // MIs[1] Operand 1
     /*  329019 */     // No operand predicates
     /*  329019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  329035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329052 */     GIR_RootConstrainSelectedInstOperands,
     /*  329053 */     // GIR_Coverage, 5211,
     /*  329053 */     GIR_EraseRootFromParent_Done,
     /*  329054 */   // Label 6250: @329054
     /*  329054 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(329137), // Rule ID 5212 //
     /*  329059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  329062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  329079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329102 */     // MIs[1] Operand 1
     /*  329102 */     // No operand predicates
     /*  329102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329115 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  329118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329135 */     GIR_RootConstrainSelectedInstOperands,
     /*  329136 */     // GIR_Coverage, 5212,
     /*  329136 */     GIR_EraseRootFromParent_Done,
     /*  329137 */   // Label 6251: @329137
     /*  329137 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(329220), // Rule ID 5213 //
     /*  329142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  329145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  329162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329185 */     // MIs[1] Operand 1
     /*  329185 */     // No operand predicates
     /*  329185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  329201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329218 */     GIR_RootConstrainSelectedInstOperands,
     /*  329219 */     // GIR_Coverage, 5213,
     /*  329219 */     GIR_EraseRootFromParent_Done,
     /*  329220 */   // Label 6252: @329220
     /*  329220 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(329303), // Rule ID 5214 //
     /*  329225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  329228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  329245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329268 */     // MIs[1] Operand 1
     /*  329268 */     // No operand predicates
     /*  329268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329281 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  329284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329301 */     GIR_RootConstrainSelectedInstOperands,
     /*  329302 */     // GIR_Coverage, 5214,
     /*  329302 */     GIR_EraseRootFromParent_Done,
     /*  329303 */   // Label 6253: @329303
     /*  329303 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(329386), // Rule ID 5215 //
     /*  329308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  329311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  329328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329351 */     // MIs[1] Operand 1
     /*  329351 */     // No operand predicates
     /*  329351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  329367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329384 */     GIR_RootConstrainSelectedInstOperands,
     /*  329385 */     // GIR_Coverage, 5215,
     /*  329385 */     GIR_EraseRootFromParent_Done,
     /*  329386 */   // Label 6254: @329386
     /*  329386 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(329469), // Rule ID 5216 //
     /*  329391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  329394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  329411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329434 */     // MIs[1] Operand 1
     /*  329434 */     // No operand predicates
     /*  329434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  329450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329467 */     GIR_RootConstrainSelectedInstOperands,
     /*  329468 */     // GIR_Coverage, 5216,
     /*  329468 */     GIR_EraseRootFromParent_Done,
     /*  329469 */   // Label 6255: @329469
     /*  329469 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(329552), // Rule ID 5217 //
     /*  329474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  329477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  329494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329517 */     // MIs[1] Operand 1
     /*  329517 */     // No operand predicates
     /*  329517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  329533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329550 */     GIR_RootConstrainSelectedInstOperands,
     /*  329551 */     // GIR_Coverage, 5217,
     /*  329551 */     GIR_EraseRootFromParent_Done,
     /*  329552 */   // Label 6256: @329552
     /*  329552 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(329635), // Rule ID 5218 //
     /*  329557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  329560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  329577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329600 */     // MIs[1] Operand 1
     /*  329600 */     // No operand predicates
     /*  329600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329613 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  329616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329633 */     GIR_RootConstrainSelectedInstOperands,
     /*  329634 */     // GIR_Coverage, 5218,
     /*  329634 */     GIR_EraseRootFromParent_Done,
     /*  329635 */   // Label 6257: @329635
     /*  329635 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(329718), // Rule ID 5219 //
     /*  329640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  329643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  329660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329683 */     // MIs[1] Operand 1
     /*  329683 */     // No operand predicates
     /*  329683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  329699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329716 */     GIR_RootConstrainSelectedInstOperands,
     /*  329717 */     // GIR_Coverage, 5219,
     /*  329717 */     GIR_EraseRootFromParent_Done,
     /*  329718 */   // Label 6258: @329718
     /*  329718 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(329801), // Rule ID 5220 //
     /*  329723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  329726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  329743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329766 */     // MIs[1] Operand 1
     /*  329766 */     // No operand predicates
     /*  329766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329779 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  329782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329799 */     GIR_RootConstrainSelectedInstOperands,
     /*  329800 */     // GIR_Coverage, 5220,
     /*  329800 */     GIR_EraseRootFromParent_Done,
     /*  329801 */   // Label 6259: @329801
     /*  329801 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(329884), // Rule ID 5221 //
     /*  329806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  329809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  329826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329849 */     // MIs[1] Operand 1
     /*  329849 */     // No operand predicates
     /*  329849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  329865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329882 */     GIR_RootConstrainSelectedInstOperands,
     /*  329883 */     // GIR_Coverage, 5221,
     /*  329883 */     GIR_EraseRootFromParent_Done,
     /*  329884 */   // Label 6260: @329884
     /*  329884 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(329967), // Rule ID 5222 //
     /*  329889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  329892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  329909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  329912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  329924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  329928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  329932 */     // MIs[1] Operand 1
     /*  329932 */     // No operand predicates
     /*  329932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  329936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  329938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  329948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  329955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  329957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329965 */     GIR_RootConstrainSelectedInstOperands,
     /*  329966 */     // GIR_Coverage, 5222,
     /*  329966 */     GIR_EraseRootFromParent_Done,
     /*  329967 */   // Label 6261: @329967
     /*  329967 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(330050), // Rule ID 5223 //
     /*  329972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  329975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  329980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  329992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  329995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  330007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  330011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  330015 */     // MIs[1] Operand 1
     /*  330015 */     // No operand predicates
     /*  330015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  330019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  330031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  330038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  330040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330048 */     GIR_RootConstrainSelectedInstOperands,
     /*  330049 */     // GIR_Coverage, 5223,
     /*  330049 */     GIR_EraseRootFromParent_Done,
     /*  330050 */   // Label 6262: @330050
     /*  330050 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(330133), // Rule ID 5224 //
     /*  330055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  330058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  330063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  330075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  330090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  330094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  330098 */     // MIs[1] Operand 1
     /*  330098 */     // No operand predicates
     /*  330098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  330102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330111 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  330114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  330121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  330123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330131 */     GIR_RootConstrainSelectedInstOperands,
     /*  330132 */     // GIR_Coverage, 5224,
     /*  330132 */     GIR_EraseRootFromParent_Done,
     /*  330133 */   // Label 6263: @330133
     /*  330133 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(330216), // Rule ID 5225 //
     /*  330138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  330141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  330146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  330158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  330173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  330177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  330181 */     // MIs[1] Operand 1
     /*  330181 */     // No operand predicates
     /*  330181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  330185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  330197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  330204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  330206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330214 */     GIR_RootConstrainSelectedInstOperands,
     /*  330215 */     // GIR_Coverage, 5225,
     /*  330215 */     GIR_EraseRootFromParent_Done,
     /*  330216 */   // Label 6264: @330216
     /*  330216 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(330299), // Rule ID 5226 //
     /*  330221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  330224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  330229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  330241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  330256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  330260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  330264 */     // MIs[1] Operand 1
     /*  330264 */     // No operand predicates
     /*  330264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  330268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  330280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  330287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  330289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330297 */     GIR_RootConstrainSelectedInstOperands,
     /*  330298 */     // GIR_Coverage, 5226,
     /*  330298 */     GIR_EraseRootFromParent_Done,
     /*  330299 */   // Label 6265: @330299
     /*  330299 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(330382), // Rule ID 5227 //
     /*  330304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  330307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  330312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  330324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  330339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  330343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  330347 */     // MIs[1] Operand 1
     /*  330347 */     // No operand predicates
     /*  330347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  330351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  330363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  330370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  330372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330380 */     GIR_RootConstrainSelectedInstOperands,
     /*  330381 */     // GIR_Coverage, 5227,
     /*  330381 */     GIR_EraseRootFromParent_Done,
     /*  330382 */   // Label 6266: @330382
     /*  330382 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(330458), // Rule ID 59884 //
     /*  330387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  330390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  330398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330419 */     // MIs[0] rs2
     /*  330419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  330434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  330437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330456 */     GIR_RootConstrainSelectedInstOperands,
     /*  330457 */     // GIR_Coverage, 59884,
     /*  330457 */     GIR_EraseRootFromParent_Done,
     /*  330458 */   // Label 6267: @330458
     /*  330458 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(330534), // Rule ID 59885 //
     /*  330463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  330466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  330474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330495 */     // MIs[0] rs2
     /*  330495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  330510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  330513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330532 */     GIR_RootConstrainSelectedInstOperands,
     /*  330533 */     // GIR_Coverage, 59885,
     /*  330533 */     GIR_EraseRootFromParent_Done,
     /*  330534 */   // Label 6268: @330534
     /*  330534 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(330610), // Rule ID 61530 //
     /*  330539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  330542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  330550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330571 */     // MIs[0] rs2
     /*  330571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  330586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  330589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330608 */     GIR_RootConstrainSelectedInstOperands,
     /*  330609 */     // GIR_Coverage, 61530,
     /*  330609 */     GIR_EraseRootFromParent_Done,
     /*  330610 */   // Label 6269: @330610
     /*  330610 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(330686), // Rule ID 61531 //
     /*  330615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  330618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  330626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330647 */     // MIs[0] rs2
     /*  330647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  330662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  330665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330684 */     GIR_RootConstrainSelectedInstOperands,
     /*  330685 */     // GIR_Coverage, 61531,
     /*  330685 */     GIR_EraseRootFromParent_Done,
     /*  330686 */   // Label 6270: @330686
     /*  330686 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(330762), // Rule ID 61532 //
     /*  330691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  330694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  330702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  330705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  330708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330723 */     // MIs[0] rs2
     /*  330723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  330738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  330741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330760 */     GIR_RootConstrainSelectedInstOperands,
     /*  330761 */     // GIR_Coverage, 61532,
     /*  330761 */     GIR_EraseRootFromParent_Done,
     /*  330762 */   // Label 6271: @330762
     /*  330762 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(330838), // Rule ID 61533 //
     /*  330767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  330770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  330778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  330781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  330784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330799 */     // MIs[0] rs2
     /*  330799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  330814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  330817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330836 */     GIR_RootConstrainSelectedInstOperands,
     /*  330837 */     // GIR_Coverage, 61533,
     /*  330837 */     GIR_EraseRootFromParent_Done,
     /*  330838 */   // Label 6272: @330838
     /*  330838 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(330914), // Rule ID 61534 //
     /*  330843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  330846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  330854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  330860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  330863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330875 */     // MIs[0] rs2
     /*  330875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  330890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  330893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330912 */     GIR_RootConstrainSelectedInstOperands,
     /*  330913 */     // GIR_Coverage, 61534,
     /*  330913 */     GIR_EraseRootFromParent_Done,
     /*  330914 */   // Label 6273: @330914
     /*  330914 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(330990), // Rule ID 61535 //
     /*  330919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  330922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  330927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  330930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  330936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  330939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330951 */     // MIs[0] rs2
     /*  330951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  330954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  330959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  330966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  330969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  330973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  330975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  330977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  330988 */     GIR_RootConstrainSelectedInstOperands,
     /*  330989 */     // GIR_Coverage, 61535,
     /*  330989 */     GIR_EraseRootFromParent_Done,
     /*  330990 */   // Label 6274: @330990
     /*  330990 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(331066), // Rule ID 61536 //
     /*  330995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  330998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  331003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  331006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331027 */     // MIs[0] rs2
     /*  331027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10844:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  331045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331064 */     GIR_RootConstrainSelectedInstOperands,
     /*  331065 */     // GIR_Coverage, 61536,
     /*  331065 */     GIR_EraseRootFromParent_Done,
     /*  331066 */   // Label 6275: @331066
     /*  331066 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(331142), // Rule ID 61537 //
     /*  331071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  331074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  331079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  331082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331103 */     // MIs[0] rs2
     /*  331103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10844:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  331121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331140 */     GIR_RootConstrainSelectedInstOperands,
     /*  331141 */     // GIR_Coverage, 61537,
     /*  331141 */     GIR_EraseRootFromParent_Done,
     /*  331142 */   // Label 6276: @331142
     /*  331142 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(331218), // Rule ID 61658 //
     /*  331147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  331150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  331158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  331164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331179 */     // MIs[0] rs2
     /*  331179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  331197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331216 */     GIR_RootConstrainSelectedInstOperands,
     /*  331217 */     // GIR_Coverage, 61658,
     /*  331217 */     GIR_EraseRootFromParent_Done,
     /*  331218 */   // Label 6277: @331218
     /*  331218 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(331294), // Rule ID 61659 //
     /*  331223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  331226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  331234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  331240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331255 */     // MIs[0] rs2
     /*  331255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  331273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331292 */     GIR_RootConstrainSelectedInstOperands,
     /*  331293 */     // GIR_Coverage, 61659,
     /*  331293 */     GIR_EraseRootFromParent_Done,
     /*  331294 */   // Label 6278: @331294
     /*  331294 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(331370), // Rule ID 61660 //
     /*  331299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  331302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  331310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  331316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331331 */     // MIs[0] rs2
     /*  331331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  331349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331368 */     GIR_RootConstrainSelectedInstOperands,
     /*  331369 */     // GIR_Coverage, 61660,
     /*  331369 */     GIR_EraseRootFromParent_Done,
     /*  331370 */   // Label 6279: @331370
     /*  331370 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(331446), // Rule ID 61661 //
     /*  331375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  331378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  331386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  331392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331407 */     // MIs[0] rs2
     /*  331407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  331425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331444 */     GIR_RootConstrainSelectedInstOperands,
     /*  331445 */     // GIR_Coverage, 61661,
     /*  331445 */     GIR_EraseRootFromParent_Done,
     /*  331446 */   // Label 6280: @331446
     /*  331446 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(331522), // Rule ID 61662 //
     /*  331451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  331454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  331462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331483 */     // MIs[0] rs2
     /*  331483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  331501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331520 */     GIR_RootConstrainSelectedInstOperands,
     /*  331521 */     // GIR_Coverage, 61662,
     /*  331521 */     GIR_EraseRootFromParent_Done,
     /*  331522 */   // Label 6281: @331522
     /*  331522 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(331598), // Rule ID 61663 //
     /*  331527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  331530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  331538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331559 */     // MIs[0] rs2
     /*  331559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  331577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331596 */     GIR_RootConstrainSelectedInstOperands,
     /*  331597 */     // GIR_Coverage, 61663,
     /*  331597 */     GIR_EraseRootFromParent_Done,
     /*  331598 */   // Label 6282: @331598
     /*  331598 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(331674), // Rule ID 61664 //
     /*  331603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  331606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  331614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331635 */     // MIs[0] rs2
     /*  331635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  331653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331672 */     GIR_RootConstrainSelectedInstOperands,
     /*  331673 */     // GIR_Coverage, 61664,
     /*  331673 */     GIR_EraseRootFromParent_Done,
     /*  331674 */   // Label 6283: @331674
     /*  331674 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(331750), // Rule ID 61665 //
     /*  331679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  331682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  331690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331711 */     // MIs[0] rs2
     /*  331711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  331729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331748 */     GIR_RootConstrainSelectedInstOperands,
     /*  331749 */     // GIR_Coverage, 61665,
     /*  331749 */     GIR_EraseRootFromParent_Done,
     /*  331750 */   // Label 6284: @331750
     /*  331750 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(331826), // Rule ID 61666 //
     /*  331755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  331758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  331766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331787 */     // MIs[0] rs2
     /*  331787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  331802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  331805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331824 */     GIR_RootConstrainSelectedInstOperands,
     /*  331825 */     // GIR_Coverage, 61666,
     /*  331825 */     GIR_EraseRootFromParent_Done,
     /*  331826 */   // Label 6285: @331826
     /*  331826 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(331902), // Rule ID 61667 //
     /*  331831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  331834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  331839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  331842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  331851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331863 */     // MIs[0] rs2
     /*  331863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  331866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  331871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  331878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  331881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  331889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331900 */     GIR_RootConstrainSelectedInstOperands,
     /*  331901 */     // GIR_Coverage, 61667,
     /*  331901 */     GIR_EraseRootFromParent_Done,
     /*  331902 */   // Label 6286: @331902
     /*  331902 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(331990), // Rule ID 2654 //
     /*  331907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  331910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  331915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  331918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  331921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  331924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  331930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  331946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  331950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  331954 */     // MIs[1] Operand 1
     /*  331954 */     // No operand predicates
     /*  331954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  331956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331963 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  331963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  331966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  331970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  331972 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  331977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  331985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  331988 */     GIR_RootConstrainSelectedInstOperands,
     /*  331989 */     // GIR_Coverage, 2654,
     /*  331989 */     GIR_EraseRootFromParent_Done,
     /*  331990 */   // Label 6287: @331990
     /*  331990 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(332078), // Rule ID 2655 //
     /*  331995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  331998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  332006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  332009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  332012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332042 */     // MIs[1] Operand 1
     /*  332042 */     // No operand predicates
     /*  332042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332051 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  332051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  332054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332060 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  332073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332076 */     GIR_RootConstrainSelectedInstOperands,
     /*  332077 */     // GIR_Coverage, 2655,
     /*  332077 */     GIR_EraseRootFromParent_Done,
     /*  332078 */   // Label 6288: @332078
     /*  332078 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(332166), // Rule ID 2662 //
     /*  332083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  332094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  332097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  332100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332130 */     // MIs[1] Operand 1
     /*  332130 */     // No operand predicates
     /*  332130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  332139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  332142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332148 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  332161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332164 */     GIR_RootConstrainSelectedInstOperands,
     /*  332165 */     // GIR_Coverage, 2662,
     /*  332165 */     GIR_EraseRootFromParent_Done,
     /*  332166 */   // Label 6289: @332166
     /*  332166 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(332254), // Rule ID 2663 //
     /*  332171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  332174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  332182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  332185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  332188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332218 */     // MIs[1] Operand 1
     /*  332218 */     // No operand predicates
     /*  332218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332227 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  332227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  332230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332236 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  332249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332252 */     GIR_RootConstrainSelectedInstOperands,
     /*  332253 */     // GIR_Coverage, 2663,
     /*  332253 */     GIR_EraseRootFromParent_Done,
     /*  332254 */   // Label 6290: @332254
     /*  332254 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(332342), // Rule ID 2670 //
     /*  332259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  332270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  332273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  332276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332306 */     // MIs[1] Operand 1
     /*  332306 */     // No operand predicates
     /*  332306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332315 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  332315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332324 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  332337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332340 */     GIR_RootConstrainSelectedInstOperands,
     /*  332341 */     // GIR_Coverage, 2670,
     /*  332341 */     GIR_EraseRootFromParent_Done,
     /*  332342 */   // Label 6291: @332342
     /*  332342 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(332430), // Rule ID 2671 //
     /*  332347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  332350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  332358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  332361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  332364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332394 */     // MIs[1] Operand 1
     /*  332394 */     // No operand predicates
     /*  332394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332403 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  332403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332412 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  332425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332428 */     GIR_RootConstrainSelectedInstOperands,
     /*  332429 */     // GIR_Coverage, 2671,
     /*  332429 */     GIR_EraseRootFromParent_Done,
     /*  332430 */   // Label 6292: @332430
     /*  332430 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(332518), // Rule ID 2678 //
     /*  332435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  332446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  332452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332482 */     // MIs[1] Operand 1
     /*  332482 */     // No operand predicates
     /*  332482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  332491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  332494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332500 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332516 */     GIR_RootConstrainSelectedInstOperands,
     /*  332517 */     // GIR_Coverage, 2678,
     /*  332517 */     GIR_EraseRootFromParent_Done,
     /*  332518 */   // Label 6293: @332518
     /*  332518 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(332606), // Rule ID 2679 //
     /*  332523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  332526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  332534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  332540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332570 */     // MIs[1] Operand 1
     /*  332570 */     // No operand predicates
     /*  332570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  332579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  332582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332588 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332604 */     GIR_RootConstrainSelectedInstOperands,
     /*  332605 */     // GIR_Coverage, 2679,
     /*  332605 */     GIR_EraseRootFromParent_Done,
     /*  332606 */   // Label 6294: @332606
     /*  332606 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(332694), // Rule ID 2686 //
     /*  332611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  332622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  332628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332658 */     // MIs[1] Operand 1
     /*  332658 */     // No operand predicates
     /*  332658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  332667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332676 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332692 */     GIR_RootConstrainSelectedInstOperands,
     /*  332693 */     // GIR_Coverage, 2686,
     /*  332693 */     GIR_EraseRootFromParent_Done,
     /*  332694 */   // Label 6295: @332694
     /*  332694 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(332782), // Rule ID 2687 //
     /*  332699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  332702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  332710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  332716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332746 */     // MIs[1] Operand 1
     /*  332746 */     // No operand predicates
     /*  332746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332755 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  332755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332764 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332780 */     GIR_RootConstrainSelectedInstOperands,
     /*  332781 */     // GIR_Coverage, 2687,
     /*  332781 */     GIR_EraseRootFromParent_Done,
     /*  332782 */   // Label 6296: @332782
     /*  332782 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(332870), // Rule ID 2694 //
     /*  332787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  332798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  332804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332834 */     // MIs[1] Operand 1
     /*  332834 */     // No operand predicates
     /*  332834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  332843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332852 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332868 */     GIR_RootConstrainSelectedInstOperands,
     /*  332869 */     // GIR_Coverage, 2694,
     /*  332869 */     GIR_EraseRootFromParent_Done,
     /*  332870 */   // Label 6297: @332870
     /*  332870 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(332958), // Rule ID 2695 //
     /*  332875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  332878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  332886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  332892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  332898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  332914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  332918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  332922 */     // MIs[1] Operand 1
     /*  332922 */     // No operand predicates
     /*  332922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  332924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332931 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  332931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  332934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  332938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  332940 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  332945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  332956 */     GIR_RootConstrainSelectedInstOperands,
     /*  332957 */     // GIR_Coverage, 2695,
     /*  332957 */     GIR_EraseRootFromParent_Done,
     /*  332958 */   // Label 6298: @332958
     /*  332958 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(333046), // Rule ID 2702 //
     /*  332963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  332966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  332971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  332974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  332977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  332980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  332986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333010 */     // MIs[1] Operand 1
     /*  333010 */     // No operand predicates
     /*  333010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  333019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333028 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  333041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333044 */     GIR_RootConstrainSelectedInstOperands,
     /*  333045 */     // GIR_Coverage, 2702,
     /*  333045 */     GIR_EraseRootFromParent_Done,
     /*  333046 */   // Label 6299: @333046
     /*  333046 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(333134), // Rule ID 2703 //
     /*  333051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  333054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  333062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  333065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  333068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333098 */     // MIs[1] Operand 1
     /*  333098 */     // No operand predicates
     /*  333098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  333107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333116 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  333129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333132 */     GIR_RootConstrainSelectedInstOperands,
     /*  333133 */     // GIR_Coverage, 2703,
     /*  333133 */     GIR_EraseRootFromParent_Done,
     /*  333134 */   // Label 6300: @333134
     /*  333134 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(333222), // Rule ID 2710 //
     /*  333139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  333142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  333150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  333156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  333162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333186 */     // MIs[1] Operand 1
     /*  333186 */     // No operand predicates
     /*  333186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  333195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333204 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333220 */     GIR_RootConstrainSelectedInstOperands,
     /*  333221 */     // GIR_Coverage, 2710,
     /*  333221 */     GIR_EraseRootFromParent_Done,
     /*  333222 */   // Label 6301: @333222
     /*  333222 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(333310), // Rule ID 2711 //
     /*  333227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  333230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  333238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  333244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333274 */     // MIs[1] Operand 1
     /*  333274 */     // No operand predicates
     /*  333274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  333283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333292 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333308 */     GIR_RootConstrainSelectedInstOperands,
     /*  333309 */     // GIR_Coverage, 2711,
     /*  333309 */     GIR_EraseRootFromParent_Done,
     /*  333310 */   // Label 6302: @333310
     /*  333310 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(333398), // Rule ID 2718 //
     /*  333315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  333318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  333326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  333332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  333338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333362 */     // MIs[1] Operand 1
     /*  333362 */     // No operand predicates
     /*  333362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  333371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333380 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333396 */     GIR_RootConstrainSelectedInstOperands,
     /*  333397 */     // GIR_Coverage, 2718,
     /*  333397 */     GIR_EraseRootFromParent_Done,
     /*  333398 */   // Label 6303: @333398
     /*  333398 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(333486), // Rule ID 2719 //
     /*  333403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  333406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  333414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  333420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333450 */     // MIs[1] Operand 1
     /*  333450 */     // No operand predicates
     /*  333450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  333459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333468 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333484 */     GIR_RootConstrainSelectedInstOperands,
     /*  333485 */     // GIR_Coverage, 2719,
     /*  333485 */     GIR_EraseRootFromParent_Done,
     /*  333486 */   // Label 6304: @333486
     /*  333486 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(333574), // Rule ID 2726 //
     /*  333491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  333494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  333502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  333508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  333514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333538 */     // MIs[1] Operand 1
     /*  333538 */     // No operand predicates
     /*  333538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333547 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  333547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333556 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333572 */     GIR_RootConstrainSelectedInstOperands,
     /*  333573 */     // GIR_Coverage, 2726,
     /*  333573 */     GIR_EraseRootFromParent_Done,
     /*  333574 */   // Label 6305: @333574
     /*  333574 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(333662), // Rule ID 2727 //
     /*  333579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  333582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  333590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  333596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333626 */     // MIs[1] Operand 1
     /*  333626 */     // No operand predicates
     /*  333626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333635 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  333635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  333638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333644 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333660 */     GIR_RootConstrainSelectedInstOperands,
     /*  333661 */     // GIR_Coverage, 2727,
     /*  333661 */     GIR_EraseRootFromParent_Done,
     /*  333662 */   // Label 6306: @333662
     /*  333662 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(333750), // Rule ID 2734 //
     /*  333667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  333670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  333678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  333681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  333684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  333690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333714 */     // MIs[1] Operand 1
     /*  333714 */     // No operand predicates
     /*  333714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  333723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  333726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333732 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  333745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333748 */     GIR_RootConstrainSelectedInstOperands,
     /*  333749 */     // GIR_Coverage, 2734,
     /*  333749 */     GIR_EraseRootFromParent_Done,
     /*  333750 */   // Label 6307: @333750
     /*  333750 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(333838), // Rule ID 2735 //
     /*  333755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  333758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  333766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  333769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  333772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333802 */     // MIs[1] Operand 1
     /*  333802 */     // No operand predicates
     /*  333802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333811 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  333811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  333814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333820 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  333833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333836 */     GIR_RootConstrainSelectedInstOperands,
     /*  333837 */     // GIR_Coverage, 2735,
     /*  333837 */     GIR_EraseRootFromParent_Done,
     /*  333838 */   // Label 6308: @333838
     /*  333838 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(333926), // Rule ID 2742 //
     /*  333843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  333846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  333854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  333857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  333860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  333866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333890 */     // MIs[1] Operand 1
     /*  333890 */     // No operand predicates
     /*  333890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333899 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  333899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  333902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333908 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  333913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  333921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  333924 */     GIR_RootConstrainSelectedInstOperands,
     /*  333925 */     // GIR_Coverage, 2742,
     /*  333925 */     GIR_EraseRootFromParent_Done,
     /*  333926 */   // Label 6309: @333926
     /*  333926 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(334014), // Rule ID 2743 //
     /*  333931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  333934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  333939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  333942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  333945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  333948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  333954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  333970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  333974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  333978 */     // MIs[1] Operand 1
     /*  333978 */     // No operand predicates
     /*  333978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  333980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333987 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  333987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  333990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  333994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333996 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  334009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334012 */     GIR_RootConstrainSelectedInstOperands,
     /*  334013 */     // GIR_Coverage, 2743,
     /*  334013 */     GIR_EraseRootFromParent_Done,
     /*  334014 */   // Label 6310: @334014
     /*  334014 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(334102), // Rule ID 2750 //
     /*  334019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  334030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  334033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  334036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334066 */     // MIs[1] Operand 1
     /*  334066 */     // No operand predicates
     /*  334066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334075 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  334075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  334078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334084 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  334097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334100 */     GIR_RootConstrainSelectedInstOperands,
     /*  334101 */     // GIR_Coverage, 2750,
     /*  334101 */     GIR_EraseRootFromParent_Done,
     /*  334102 */   // Label 6311: @334102
     /*  334102 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(334190), // Rule ID 2751 //
     /*  334107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  334118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  334121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  334124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  334130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334154 */     // MIs[1] Operand 1
     /*  334154 */     // No operand predicates
     /*  334154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334163 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  334163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  334166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334172 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  334185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334188 */     GIR_RootConstrainSelectedInstOperands,
     /*  334189 */     // GIR_Coverage, 2751,
     /*  334189 */     GIR_EraseRootFromParent_Done,
     /*  334190 */   // Label 6312: @334190
     /*  334190 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(334278), // Rule ID 2758 //
     /*  334195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  334206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334242 */     // MIs[1] Operand 1
     /*  334242 */     // No operand predicates
     /*  334242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  334251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  334254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334260 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334276 */     GIR_RootConstrainSelectedInstOperands,
     /*  334277 */     // GIR_Coverage, 2758,
     /*  334277 */     GIR_EraseRootFromParent_Done,
     /*  334278 */   // Label 6313: @334278
     /*  334278 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(334366), // Rule ID 2759 //
     /*  334283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  334294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  334306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334330 */     // MIs[1] Operand 1
     /*  334330 */     // No operand predicates
     /*  334330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  334339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  334342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334348 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334364 */     GIR_RootConstrainSelectedInstOperands,
     /*  334365 */     // GIR_Coverage, 2759,
     /*  334365 */     GIR_EraseRootFromParent_Done,
     /*  334366 */   // Label 6314: @334366
     /*  334366 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(334454), // Rule ID 2766 //
     /*  334371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  334382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334418 */     // MIs[1] Operand 1
     /*  334418 */     // No operand predicates
     /*  334418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  334427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  334430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334436 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334452 */     GIR_RootConstrainSelectedInstOperands,
     /*  334453 */     // GIR_Coverage, 2766,
     /*  334453 */     GIR_EraseRootFromParent_Done,
     /*  334454 */   // Label 6315: @334454
     /*  334454 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(334542), // Rule ID 2767 //
     /*  334459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  334470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  334482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334506 */     // MIs[1] Operand 1
     /*  334506 */     // No operand predicates
     /*  334506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334515 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  334515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  334518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334524 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334540 */     GIR_RootConstrainSelectedInstOperands,
     /*  334541 */     // GIR_Coverage, 2767,
     /*  334541 */     GIR_EraseRootFromParent_Done,
     /*  334542 */   // Label 6316: @334542
     /*  334542 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(334630), // Rule ID 2774 //
     /*  334547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  334558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  334561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  334564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334594 */     // MIs[1] Operand 1
     /*  334594 */     // No operand predicates
     /*  334594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334603 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  334603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  334606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334612 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334628 */     GIR_RootConstrainSelectedInstOperands,
     /*  334629 */     // GIR_Coverage, 2774,
     /*  334629 */     GIR_EraseRootFromParent_Done,
     /*  334630 */   // Label 6317: @334630
     /*  334630 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(334718), // Rule ID 2775 //
     /*  334635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  334646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  334649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  334652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  334658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334682 */     // MIs[1] Operand 1
     /*  334682 */     // No operand predicates
     /*  334682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  334691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  334694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334700 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334716 */     GIR_RootConstrainSelectedInstOperands,
     /*  334717 */     // GIR_Coverage, 2775,
     /*  334717 */     GIR_EraseRootFromParent_Done,
     /*  334718 */   // Label 6318: @334718
     /*  334718 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(334806), // Rule ID 2782 //
     /*  334723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  334734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  334737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  334740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334770 */     // MIs[1] Operand 1
     /*  334770 */     // No operand predicates
     /*  334770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  334779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  334782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334788 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334804 */     GIR_RootConstrainSelectedInstOperands,
     /*  334805 */     // GIR_Coverage, 2782,
     /*  334805 */     GIR_EraseRootFromParent_Done,
     /*  334806 */   // Label 6319: @334806
     /*  334806 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(334894), // Rule ID 2783 //
     /*  334811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  334822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  334825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  334828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  334834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334858 */     // MIs[1] Operand 1
     /*  334858 */     // No operand predicates
     /*  334858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  334867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  334870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334876 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334892 */     GIR_RootConstrainSelectedInstOperands,
     /*  334893 */     // GIR_Coverage, 2783,
     /*  334893 */     GIR_EraseRootFromParent_Done,
     /*  334894 */   // Label 6320: @334894
     /*  334894 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(334982), // Rule ID 2790 //
     /*  334899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  334902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  334910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  334913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  334916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  334922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  334938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  334942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  334946 */     // MIs[1] Operand 1
     /*  334946 */     // No operand predicates
     /*  334946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  334948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  334955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  334958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  334962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334964 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  334969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  334980 */     GIR_RootConstrainSelectedInstOperands,
     /*  334981 */     // GIR_Coverage, 2790,
     /*  334981 */     GIR_EraseRootFromParent_Done,
     /*  334982 */   // Label 6321: @334982
     /*  334982 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(335070), // Rule ID 2791 //
     /*  334987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  334990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  334995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  334998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335034 */     // MIs[1] Operand 1
     /*  335034 */     // No operand predicates
     /*  335034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  335043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  335046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335052 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335068 */     GIR_RootConstrainSelectedInstOperands,
     /*  335069 */     // GIR_Coverage, 2791,
     /*  335069 */     GIR_EraseRootFromParent_Done,
     /*  335070 */   // Label 6322: @335070
     /*  335070 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(335158), // Rule ID 2798 //
     /*  335075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  335078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  335086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335122 */     // MIs[1] Operand 1
     /*  335122 */     // No operand predicates
     /*  335122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  335131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  335134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335140 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335156 */     GIR_RootConstrainSelectedInstOperands,
     /*  335157 */     // GIR_Coverage, 2798,
     /*  335157 */     GIR_EraseRootFromParent_Done,
     /*  335158 */   // Label 6323: @335158
     /*  335158 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(335246), // Rule ID 2799 //
     /*  335163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  335166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  335174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335210 */     // MIs[1] Operand 1
     /*  335210 */     // No operand predicates
     /*  335210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335219 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  335219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  335222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335228 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335244 */     GIR_RootConstrainSelectedInstOperands,
     /*  335245 */     // GIR_Coverage, 2799,
     /*  335245 */     GIR_EraseRootFromParent_Done,
     /*  335246 */   // Label 6324: @335246
     /*  335246 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(335334), // Rule ID 2806 //
     /*  335251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  335254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  335262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335298 */     // MIs[1] Operand 1
     /*  335298 */     // No operand predicates
     /*  335298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  335307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  335310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335316 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335332 */     GIR_RootConstrainSelectedInstOperands,
     /*  335333 */     // GIR_Coverage, 2806,
     /*  335333 */     GIR_EraseRootFromParent_Done,
     /*  335334 */   // Label 6325: @335334
     /*  335334 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(335422), // Rule ID 2807 //
     /*  335339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  335342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  335350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335386 */     // MIs[1] Operand 1
     /*  335386 */     // No operand predicates
     /*  335386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  335395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  335398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335404 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335420 */     GIR_RootConstrainSelectedInstOperands,
     /*  335421 */     // GIR_Coverage, 2807,
     /*  335421 */     GIR_EraseRootFromParent_Done,
     /*  335422 */   // Label 6326: @335422
     /*  335422 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(335510), // Rule ID 2814 //
     /*  335427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  335430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  335438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335474 */     // MIs[1] Operand 1
     /*  335474 */     // No operand predicates
     /*  335474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  335483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  335486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335492 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335508 */     GIR_RootConstrainSelectedInstOperands,
     /*  335509 */     // GIR_Coverage, 2814,
     /*  335509 */     GIR_EraseRootFromParent_Done,
     /*  335510 */   // Label 6327: @335510
     /*  335510 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(335598), // Rule ID 2815 //
     /*  335515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  335518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  335526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335562 */     // MIs[1] Operand 1
     /*  335562 */     // No operand predicates
     /*  335562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  335571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  335574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335580 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335596 */     GIR_RootConstrainSelectedInstOperands,
     /*  335597 */     // GIR_Coverage, 2815,
     /*  335597 */     GIR_EraseRootFromParent_Done,
     /*  335598 */   // Label 6328: @335598
     /*  335598 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(335686), // Rule ID 2822 //
     /*  335603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  335606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  335614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335650 */     // MIs[1] Operand 1
     /*  335650 */     // No operand predicates
     /*  335650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335659 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  335659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  335662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335668 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335684 */     GIR_RootConstrainSelectedInstOperands,
     /*  335685 */     // GIR_Coverage, 2822,
     /*  335685 */     GIR_EraseRootFromParent_Done,
     /*  335686 */   // Label 6329: @335686
     /*  335686 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(335774), // Rule ID 2823 //
     /*  335691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  335694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  335699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  335702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  335738 */     // MIs[1] Operand 1
     /*  335738 */     // No operand predicates
     /*  335738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335747 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  335747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  335750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335756 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  335761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335772 */     GIR_RootConstrainSelectedInstOperands,
     /*  335773 */     // GIR_Coverage, 2823,
     /*  335773 */     GIR_EraseRootFromParent_Done,
     /*  335774 */   // Label 6330: @335774
     /*  335774 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(335860), // Rule ID 2998 //
     /*  335779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  335782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  335787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  335790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  335793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  335796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  335826 */     // MIs[1] Operand 1
     /*  335826 */     // No operand predicates
     /*  335826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335835 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  335835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  335838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  335847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  335855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335858 */     GIR_RootConstrainSelectedInstOperands,
     /*  335859 */     // GIR_Coverage, 2998,
     /*  335859 */     GIR_EraseRootFromParent_Done,
     /*  335860 */   // Label 6331: @335860
     /*  335860 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(335946), // Rule ID 2999 //
     /*  335865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  335868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  335873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  335876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  335879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  335882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  335888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  335912 */     // MIs[1] Operand 1
     /*  335912 */     // No operand predicates
     /*  335912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  335914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335921 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  335921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  335924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  335928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  335933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  335941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  335944 */     GIR_RootConstrainSelectedInstOperands,
     /*  335945 */     // GIR_Coverage, 2999,
     /*  335945 */     GIR_EraseRootFromParent_Done,
     /*  335946 */   // Label 6332: @335946
     /*  335946 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(336032), // Rule ID 3002 //
     /*  335951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  335954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  335959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  335962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  335965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  335968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  335974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  335990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  335994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  335998 */     // MIs[1] Operand 1
     /*  335998 */     // No operand predicates
     /*  335998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336007 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  336007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  336010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336030 */     GIR_RootConstrainSelectedInstOperands,
     /*  336031 */     // GIR_Coverage, 3002,
     /*  336031 */     GIR_EraseRootFromParent_Done,
     /*  336032 */   // Label 6333: @336032
     /*  336032 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(336118), // Rule ID 3003 //
     /*  336037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  336048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  336051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  336054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336084 */     // MIs[1] Operand 1
     /*  336084 */     // No operand predicates
     /*  336084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  336093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  336096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336116 */     GIR_RootConstrainSelectedInstOperands,
     /*  336117 */     // GIR_Coverage, 3003,
     /*  336117 */     GIR_EraseRootFromParent_Done,
     /*  336118 */   // Label 6334: @336118
     /*  336118 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(336204), // Rule ID 3006 //
     /*  336123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  336134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  336137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  336140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  336146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336170 */     // MIs[1] Operand 1
     /*  336170 */     // No operand predicates
     /*  336170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336179 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  336179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336202 */     GIR_RootConstrainSelectedInstOperands,
     /*  336203 */     // GIR_Coverage, 3006,
     /*  336203 */     GIR_EraseRootFromParent_Done,
     /*  336204 */   // Label 6335: @336204
     /*  336204 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(336290), // Rule ID 3007 //
     /*  336209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  336220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  336223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  336226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336256 */     // MIs[1] Operand 1
     /*  336256 */     // No operand predicates
     /*  336256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336265 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  336265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336288 */     GIR_RootConstrainSelectedInstOperands,
     /*  336289 */     // GIR_Coverage, 3007,
     /*  336289 */     GIR_EraseRootFromParent_Done,
     /*  336290 */   // Label 6336: @336290
     /*  336290 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(336376), // Rule ID 3010 //
     /*  336295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  336306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  336318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336342 */     // MIs[1] Operand 1
     /*  336342 */     // No operand predicates
     /*  336342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  336351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  336354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336374 */     GIR_RootConstrainSelectedInstOperands,
     /*  336375 */     // GIR_Coverage, 3010,
     /*  336375 */     GIR_EraseRootFromParent_Done,
     /*  336376 */   // Label 6337: @336376
     /*  336376 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(336462), // Rule ID 3011 //
     /*  336381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  336392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336428 */     // MIs[1] Operand 1
     /*  336428 */     // No operand predicates
     /*  336428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  336437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  336440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336460 */     GIR_RootConstrainSelectedInstOperands,
     /*  336461 */     // GIR_Coverage, 3011,
     /*  336461 */     GIR_EraseRootFromParent_Done,
     /*  336462 */   // Label 6338: @336462
     /*  336462 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(336548), // Rule ID 3014 //
     /*  336467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  336478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  336490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336514 */     // MIs[1] Operand 1
     /*  336514 */     // No operand predicates
     /*  336514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336523 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  336523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336546 */     GIR_RootConstrainSelectedInstOperands,
     /*  336547 */     // GIR_Coverage, 3014,
     /*  336547 */     GIR_EraseRootFromParent_Done,
     /*  336548 */   // Label 6339: @336548
     /*  336548 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(336634), // Rule ID 3015 //
     /*  336553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  336564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336600 */     // MIs[1] Operand 1
     /*  336600 */     // No operand predicates
     /*  336600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  336609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336632 */     GIR_RootConstrainSelectedInstOperands,
     /*  336633 */     // GIR_Coverage, 3015,
     /*  336633 */     GIR_EraseRootFromParent_Done,
     /*  336634 */   // Label 6340: @336634
     /*  336634 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(336720), // Rule ID 3018 //
     /*  336639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  336650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  336662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336686 */     // MIs[1] Operand 1
     /*  336686 */     // No operand predicates
     /*  336686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336695 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  336695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336718 */     GIR_RootConstrainSelectedInstOperands,
     /*  336719 */     // GIR_Coverage, 3018,
     /*  336719 */     GIR_EraseRootFromParent_Done,
     /*  336720 */   // Label 6341: @336720
     /*  336720 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(336806), // Rule ID 3019 //
     /*  336725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  336736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336772 */     // MIs[1] Operand 1
     /*  336772 */     // No operand predicates
     /*  336772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  336781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  336784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336804 */     GIR_RootConstrainSelectedInstOperands,
     /*  336805 */     // GIR_Coverage, 3019,
     /*  336805 */     GIR_EraseRootFromParent_Done,
     /*  336806 */   // Label 6342: @336806
     /*  336806 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(336892), // Rule ID 3022 //
     /*  336811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  336822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  336825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  336828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  336834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336858 */     // MIs[1] Operand 1
     /*  336858 */     // No operand predicates
     /*  336858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336867 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  336867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  336870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336890 */     GIR_RootConstrainSelectedInstOperands,
     /*  336891 */     // GIR_Coverage, 3022,
     /*  336891 */     GIR_EraseRootFromParent_Done,
     /*  336892 */   // Label 6343: @336892
     /*  336892 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(336978), // Rule ID 3023 //
     /*  336897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  336900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  336908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  336911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  336914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  336920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  336936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  336940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  336944 */     // MIs[1] Operand 1
     /*  336944 */     // No operand predicates
     /*  336944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  336946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336953 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  336953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  336956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  336960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  336965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  336973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  336976 */     GIR_RootConstrainSelectedInstOperands,
     /*  336977 */     // GIR_Coverage, 3023,
     /*  336977 */     GIR_EraseRootFromParent_Done,
     /*  336978 */   // Label 6344: @336978
     /*  336978 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(337064), // Rule ID 3026 //
     /*  336983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  336986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  336991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  336994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  337000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337030 */     // MIs[1] Operand 1
     /*  337030 */     // No operand predicates
     /*  337030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337039 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337062 */     GIR_RootConstrainSelectedInstOperands,
     /*  337063 */     // GIR_Coverage, 3026,
     /*  337063 */     GIR_EraseRootFromParent_Done,
     /*  337064 */   // Label 6345: @337064
     /*  337064 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(337150), // Rule ID 3027 //
     /*  337069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  337072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  337080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  337083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  337086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337116 */     // MIs[1] Operand 1
     /*  337116 */     // No operand predicates
     /*  337116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337125 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  337125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337148 */     GIR_RootConstrainSelectedInstOperands,
     /*  337149 */     // GIR_Coverage, 3027,
     /*  337149 */     GIR_EraseRootFromParent_Done,
     /*  337150 */   // Label 6346: @337150
     /*  337150 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(337236), // Rule ID 3030 //
     /*  337155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  337158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  337166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  337169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  337172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337202 */     // MIs[1] Operand 1
     /*  337202 */     // No operand predicates
     /*  337202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337211 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  337211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337234 */     GIR_RootConstrainSelectedInstOperands,
     /*  337235 */     // GIR_Coverage, 3030,
     /*  337235 */     GIR_EraseRootFromParent_Done,
     /*  337236 */   // Label 6347: @337236
     /*  337236 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(337322), // Rule ID 3031 //
     /*  337241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  337244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  337252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  337255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  337258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337288 */     // MIs[1] Operand 1
     /*  337288 */     // No operand predicates
     /*  337288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337297 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  337297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337320 */     GIR_RootConstrainSelectedInstOperands,
     /*  337321 */     // GIR_Coverage, 3031,
     /*  337321 */     GIR_EraseRootFromParent_Done,
     /*  337322 */   // Label 6348: @337322
     /*  337322 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(337408), // Rule ID 3034 //
     /*  337327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  337330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  337338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337374 */     // MIs[1] Operand 1
     /*  337374 */     // No operand predicates
     /*  337374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  337383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337406 */     GIR_RootConstrainSelectedInstOperands,
     /*  337407 */     // GIR_Coverage, 3034,
     /*  337407 */     GIR_EraseRootFromParent_Done,
     /*  337408 */   // Label 6349: @337408
     /*  337408 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(337494), // Rule ID 3035 //
     /*  337413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  337416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  337424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337460 */     // MIs[1] Operand 1
     /*  337460 */     // No operand predicates
     /*  337460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337469 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  337469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  337472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337492 */     GIR_RootConstrainSelectedInstOperands,
     /*  337493 */     // GIR_Coverage, 3035,
     /*  337493 */     GIR_EraseRootFromParent_Done,
     /*  337494 */   // Label 6350: @337494
     /*  337494 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(337580), // Rule ID 3038 //
     /*  337499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  337502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  337510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  337513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  337516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337546 */     // MIs[1] Operand 1
     /*  337546 */     // No operand predicates
     /*  337546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  337555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  337558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  337575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337578 */     GIR_RootConstrainSelectedInstOperands,
     /*  337579 */     // GIR_Coverage, 3038,
     /*  337579 */     GIR_EraseRootFromParent_Done,
     /*  337580 */   // Label 6351: @337580
     /*  337580 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(337666), // Rule ID 3039 //
     /*  337585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  337588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  337596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  337599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  337602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337632 */     // MIs[1] Operand 1
     /*  337632 */     // No operand predicates
     /*  337632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  337641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  337644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  337661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337664 */     GIR_RootConstrainSelectedInstOperands,
     /*  337665 */     // GIR_Coverage, 3039,
     /*  337665 */     GIR_EraseRootFromParent_Done,
     /*  337666 */   // Label 6352: @337666
     /*  337666 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(337752), // Rule ID 3042 //
     /*  337671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  337674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  337682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  337685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  337688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337718 */     // MIs[1] Operand 1
     /*  337718 */     // No operand predicates
     /*  337718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  337727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  337730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  337747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337750 */     GIR_RootConstrainSelectedInstOperands,
     /*  337751 */     // GIR_Coverage, 3042,
     /*  337751 */     GIR_EraseRootFromParent_Done,
     /*  337752 */   // Label 6353: @337752
     /*  337752 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(337838), // Rule ID 3043 //
     /*  337757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  337760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  337768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  337771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  337774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337804 */     // MIs[1] Operand 1
     /*  337804 */     // No operand predicates
     /*  337804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337813 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  337813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  337816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  337833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337836 */     GIR_RootConstrainSelectedInstOperands,
     /*  337837 */     // GIR_Coverage, 3043,
     /*  337837 */     GIR_EraseRootFromParent_Done,
     /*  337838 */   // Label 6354: @337838
     /*  337838 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(337924), // Rule ID 3046 //
     /*  337843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  337846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  337854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  337857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  337860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  337866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337890 */     // MIs[1] Operand 1
     /*  337890 */     // No operand predicates
     /*  337890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337899 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  337899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  337902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  337919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337922 */     GIR_RootConstrainSelectedInstOperands,
     /*  337923 */     // GIR_Coverage, 3046,
     /*  337923 */     GIR_EraseRootFromParent_Done,
     /*  337924 */   // Label 6355: @337924
     /*  337924 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(338010), // Rule ID 3047 //
     /*  337929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  337932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  337937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  337940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  337943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  337946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  337952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  337968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  337972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  337976 */     // MIs[1] Operand 1
     /*  337976 */     // No operand predicates
     /*  337976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  337978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337985 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  337985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  337988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  337997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  338005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338008 */     GIR_RootConstrainSelectedInstOperands,
     /*  338009 */     // GIR_Coverage, 3047,
     /*  338009 */     GIR_EraseRootFromParent_Done,
     /*  338010 */   // Label 6356: @338010
     /*  338010 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(338096), // Rule ID 3050 //
     /*  338015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338062 */     // MIs[1] Operand 1
     /*  338062 */     // No operand predicates
     /*  338062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  338074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338094 */     GIR_RootConstrainSelectedInstOperands,
     /*  338095 */     // GIR_Coverage, 3050,
     /*  338095 */     GIR_EraseRootFromParent_Done,
     /*  338096 */   // Label 6357: @338096
     /*  338096 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(338182), // Rule ID 3051 //
     /*  338101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338148 */     // MIs[1] Operand 1
     /*  338148 */     // No operand predicates
     /*  338148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338157 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  338160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338180 */     GIR_RootConstrainSelectedInstOperands,
     /*  338181 */     // GIR_Coverage, 3051,
     /*  338181 */     GIR_EraseRootFromParent_Done,
     /*  338182 */   // Label 6358: @338182
     /*  338182 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(338268), // Rule ID 3054 //
     /*  338187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338234 */     // MIs[1] Operand 1
     /*  338234 */     // No operand predicates
     /*  338234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  338246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338266 */     GIR_RootConstrainSelectedInstOperands,
     /*  338267 */     // GIR_Coverage, 3054,
     /*  338267 */     GIR_EraseRootFromParent_Done,
     /*  338268 */   // Label 6359: @338268
     /*  338268 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(338354), // Rule ID 3055 //
     /*  338273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338320 */     // MIs[1] Operand 1
     /*  338320 */     // No operand predicates
     /*  338320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338329 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  338332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338352 */     GIR_RootConstrainSelectedInstOperands,
     /*  338353 */     // GIR_Coverage, 3055,
     /*  338353 */     GIR_EraseRootFromParent_Done,
     /*  338354 */   // Label 6360: @338354
     /*  338354 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(338440), // Rule ID 3058 //
     /*  338359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338406 */     // MIs[1] Operand 1
     /*  338406 */     // No operand predicates
     /*  338406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338415 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  338418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338438 */     GIR_RootConstrainSelectedInstOperands,
     /*  338439 */     // GIR_Coverage, 3058,
     /*  338439 */     GIR_EraseRootFromParent_Done,
     /*  338440 */   // Label 6361: @338440
     /*  338440 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(338526), // Rule ID 3059 //
     /*  338445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338492 */     // MIs[1] Operand 1
     /*  338492 */     // No operand predicates
     /*  338492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338501 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  338504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338524 */     GIR_RootConstrainSelectedInstOperands,
     /*  338525 */     // GIR_Coverage, 3059,
     /*  338525 */     GIR_EraseRootFromParent_Done,
     /*  338526 */   // Label 6362: @338526
     /*  338526 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(338612), // Rule ID 3062 //
     /*  338531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338578 */     // MIs[1] Operand 1
     /*  338578 */     // No operand predicates
     /*  338578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  338590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338610 */     GIR_RootConstrainSelectedInstOperands,
     /*  338611 */     // GIR_Coverage, 3062,
     /*  338611 */     GIR_EraseRootFromParent_Done,
     /*  338612 */   // Label 6363: @338612
     /*  338612 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(338698), // Rule ID 3063 //
     /*  338617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338664 */     // MIs[1] Operand 1
     /*  338664 */     // No operand predicates
     /*  338664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  338676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338696 */     GIR_RootConstrainSelectedInstOperands,
     /*  338697 */     // GIR_Coverage, 3063,
     /*  338697 */     GIR_EraseRootFromParent_Done,
     /*  338698 */   // Label 6364: @338698
     /*  338698 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(338784), // Rule ID 3066 //
     /*  338703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338750 */     // MIs[1] Operand 1
     /*  338750 */     // No operand predicates
     /*  338750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338759 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  338762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338782 */     GIR_RootConstrainSelectedInstOperands,
     /*  338783 */     // GIR_Coverage, 3066,
     /*  338783 */     GIR_EraseRootFromParent_Done,
     /*  338784 */   // Label 6365: @338784
     /*  338784 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(338870), // Rule ID 3067 //
     /*  338789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338836 */     // MIs[1] Operand 1
     /*  338836 */     // No operand predicates
     /*  338836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338845 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  338848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338868 */     GIR_RootConstrainSelectedInstOperands,
     /*  338869 */     // GIR_Coverage, 3067,
     /*  338869 */     GIR_EraseRootFromParent_Done,
     /*  338870 */   // Label 6366: @338870
     /*  338870 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(338956), // Rule ID 3070 //
     /*  338875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  338878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  338886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  338889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  338892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  338898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  338914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  338918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  338922 */     // MIs[1] Operand 1
     /*  338922 */     // No operand predicates
     /*  338922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  338924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338931 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  338934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  338943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338954 */     GIR_RootConstrainSelectedInstOperands,
     /*  338955 */     // GIR_Coverage, 3070,
     /*  338955 */     GIR_EraseRootFromParent_Done,
     /*  338956 */   // Label 6367: @338956
     /*  338956 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(339042), // Rule ID 3071 //
     /*  338961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  338964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  338969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  338972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  338975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  338978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  338984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339008 */     // MIs[1] Operand 1
     /*  339008 */     // No operand predicates
     /*  339008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339017 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  339020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339040 */     GIR_RootConstrainSelectedInstOperands,
     /*  339041 */     // GIR_Coverage, 3071,
     /*  339041 */     GIR_EraseRootFromParent_Done,
     /*  339042 */   // Label 6368: @339042
     /*  339042 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(339128), // Rule ID 3074 //
     /*  339047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  339050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339094 */     // MIs[1] Operand 1
     /*  339094 */     // No operand predicates
     /*  339094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  339106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339126 */     GIR_RootConstrainSelectedInstOperands,
     /*  339127 */     // GIR_Coverage, 3074,
     /*  339127 */     GIR_EraseRootFromParent_Done,
     /*  339128 */   // Label 6369: @339128
     /*  339128 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(339214), // Rule ID 3075 //
     /*  339133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  339136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  339156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339180 */     // MIs[1] Operand 1
     /*  339180 */     // No operand predicates
     /*  339180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  339192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339212 */     GIR_RootConstrainSelectedInstOperands,
     /*  339213 */     // GIR_Coverage, 3075,
     /*  339213 */     GIR_EraseRootFromParent_Done,
     /*  339214 */   // Label 6370: @339214
     /*  339214 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(339300), // Rule ID 3078 //
     /*  339219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  339222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339266 */     // MIs[1] Operand 1
     /*  339266 */     // No operand predicates
     /*  339266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339275 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  339278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339298 */     GIR_RootConstrainSelectedInstOperands,
     /*  339299 */     // GIR_Coverage, 3078,
     /*  339299 */     GIR_EraseRootFromParent_Done,
     /*  339300 */   // Label 6371: @339300
     /*  339300 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(339386), // Rule ID 3079 //
     /*  339305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  339308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  339328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339352 */     // MIs[1] Operand 1
     /*  339352 */     // No operand predicates
     /*  339352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339361 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  339364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339384 */     GIR_RootConstrainSelectedInstOperands,
     /*  339385 */     // GIR_Coverage, 3079,
     /*  339385 */     GIR_EraseRootFromParent_Done,
     /*  339386 */   // Label 6372: @339386
     /*  339386 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(339472), // Rule ID 3082 //
     /*  339391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  339394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339438 */     // MIs[1] Operand 1
     /*  339438 */     // No operand predicates
     /*  339438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339447 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  339450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339470 */     GIR_RootConstrainSelectedInstOperands,
     /*  339471 */     // GIR_Coverage, 3082,
     /*  339471 */     GIR_EraseRootFromParent_Done,
     /*  339472 */   // Label 6373: @339472
     /*  339472 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(339558), // Rule ID 3083 //
     /*  339477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  339480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  339485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  339500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339524 */     // MIs[1] Operand 1
     /*  339524 */     // No operand predicates
     /*  339524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339533 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  339536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339556 */     GIR_RootConstrainSelectedInstOperands,
     /*  339557 */     // GIR_Coverage, 3083,
     /*  339557 */     GIR_EraseRootFromParent_Done,
     /*  339558 */   // Label 6374: @339558
     /*  339558 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(339644), // Rule ID 3350 //
     /*  339563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  339566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  339571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  339574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  339577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  339580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339610 */     // MIs[1] Operand 1
     /*  339610 */     // No operand predicates
     /*  339610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  339619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  339622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  339639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339642 */     GIR_RootConstrainSelectedInstOperands,
     /*  339643 */     // GIR_Coverage, 3350,
     /*  339643 */     GIR_EraseRootFromParent_Done,
     /*  339644 */   // Label 6375: @339644
     /*  339644 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(339730), // Rule ID 3351 //
     /*  339649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  339652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  339657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  339660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  339663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  339666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  339672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339696 */     // MIs[1] Operand 1
     /*  339696 */     // No operand predicates
     /*  339696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339705 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  339705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  339708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  339725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339728 */     GIR_RootConstrainSelectedInstOperands,
     /*  339729 */     // GIR_Coverage, 3351,
     /*  339729 */     GIR_EraseRootFromParent_Done,
     /*  339730 */   // Label 6376: @339730
     /*  339730 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(339816), // Rule ID 3354 //
     /*  339735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  339738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  339743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  339746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  339749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  339752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339782 */     // MIs[1] Operand 1
     /*  339782 */     // No operand predicates
     /*  339782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339791 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  339791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  339794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  339811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339814 */     GIR_RootConstrainSelectedInstOperands,
     /*  339815 */     // GIR_Coverage, 3354,
     /*  339815 */     GIR_EraseRootFromParent_Done,
     /*  339816 */   // Label 6377: @339816
     /*  339816 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(339902), // Rule ID 3355 //
     /*  339821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  339824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  339829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  339832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  339835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  339838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  339844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339868 */     // MIs[1] Operand 1
     /*  339868 */     // No operand predicates
     /*  339868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  339877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  339880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  339897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339900 */     GIR_RootConstrainSelectedInstOperands,
     /*  339901 */     // GIR_Coverage, 3355,
     /*  339901 */     GIR_EraseRootFromParent_Done,
     /*  339902 */   // Label 6378: @339902
     /*  339902 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(339988), // Rule ID 3358 //
     /*  339907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  339910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  339915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  339918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  339921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  339924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  339930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  339946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  339950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  339954 */     // MIs[1] Operand 1
     /*  339954 */     // No operand predicates
     /*  339954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  339956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339963 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  339963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  339966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  339975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  339983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339986 */     GIR_RootConstrainSelectedInstOperands,
     /*  339987 */     // GIR_Coverage, 3358,
     /*  339987 */     GIR_EraseRootFromParent_Done,
     /*  339988 */   // Label 6379: @339988
     /*  339988 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(340074), // Rule ID 3359 //
     /*  339993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  339996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  340004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  340007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  340010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340040 */     // MIs[1] Operand 1
     /*  340040 */     // No operand predicates
     /*  340040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340049 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  340049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  340052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  340069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340072 */     GIR_RootConstrainSelectedInstOperands,
     /*  340073 */     // GIR_Coverage, 3359,
     /*  340073 */     GIR_EraseRootFromParent_Done,
     /*  340074 */   // Label 6380: @340074
     /*  340074 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(340160), // Rule ID 3362 //
     /*  340079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340126 */     // MIs[1] Operand 1
     /*  340126 */     // No operand predicates
     /*  340126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340135 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  340138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340158 */     GIR_RootConstrainSelectedInstOperands,
     /*  340159 */     // GIR_Coverage, 3362,
     /*  340159 */     GIR_EraseRootFromParent_Done,
     /*  340160 */   // Label 6381: @340160
     /*  340160 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(340246), // Rule ID 3363 //
     /*  340165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  340168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340212 */     // MIs[1] Operand 1
     /*  340212 */     // No operand predicates
     /*  340212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  340224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340244 */     GIR_RootConstrainSelectedInstOperands,
     /*  340245 */     // GIR_Coverage, 3363,
     /*  340245 */     GIR_EraseRootFromParent_Done,
     /*  340246 */   // Label 6382: @340246
     /*  340246 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(340332), // Rule ID 3366 //
     /*  340251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340298 */     // MIs[1] Operand 1
     /*  340298 */     // No operand predicates
     /*  340298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340307 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  340310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340330 */     GIR_RootConstrainSelectedInstOperands,
     /*  340331 */     // GIR_Coverage, 3366,
     /*  340331 */     GIR_EraseRootFromParent_Done,
     /*  340332 */   // Label 6383: @340332
     /*  340332 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(340418), // Rule ID 3367 //
     /*  340337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  340340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340384 */     // MIs[1] Operand 1
     /*  340384 */     // No operand predicates
     /*  340384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340393 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  340396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340416 */     GIR_RootConstrainSelectedInstOperands,
     /*  340417 */     // GIR_Coverage, 3367,
     /*  340417 */     GIR_EraseRootFromParent_Done,
     /*  340418 */   // Label 6384: @340418
     /*  340418 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(340504), // Rule ID 3370 //
     /*  340423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340470 */     // MIs[1] Operand 1
     /*  340470 */     // No operand predicates
     /*  340470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340479 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  340482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340502 */     GIR_RootConstrainSelectedInstOperands,
     /*  340503 */     // GIR_Coverage, 3370,
     /*  340503 */     GIR_EraseRootFromParent_Done,
     /*  340504 */   // Label 6385: @340504
     /*  340504 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(340590), // Rule ID 3371 //
     /*  340509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  340512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340556 */     // MIs[1] Operand 1
     /*  340556 */     // No operand predicates
     /*  340556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340565 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  340568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340588 */     GIR_RootConstrainSelectedInstOperands,
     /*  340589 */     // GIR_Coverage, 3371,
     /*  340589 */     GIR_EraseRootFromParent_Done,
     /*  340590 */   // Label 6386: @340590
     /*  340590 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(340676), // Rule ID 3374 //
     /*  340595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  340606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  340609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  340612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340642 */     // MIs[1] Operand 1
     /*  340642 */     // No operand predicates
     /*  340642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340651 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  340651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  340654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  340671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340674 */     GIR_RootConstrainSelectedInstOperands,
     /*  340675 */     // GIR_Coverage, 3374,
     /*  340675 */     GIR_EraseRootFromParent_Done,
     /*  340676 */   // Label 6387: @340676
     /*  340676 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(340762), // Rule ID 3375 //
     /*  340681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  340684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  340692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  340695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  340698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340728 */     // MIs[1] Operand 1
     /*  340728 */     // No operand predicates
     /*  340728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340737 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  340737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  340740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  340757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340760 */     GIR_RootConstrainSelectedInstOperands,
     /*  340761 */     // GIR_Coverage, 3375,
     /*  340761 */     GIR_EraseRootFromParent_Done,
     /*  340762 */   // Label 6388: @340762
     /*  340762 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(340848), // Rule ID 3378 //
     /*  340767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340814 */     // MIs[1] Operand 1
     /*  340814 */     // No operand predicates
     /*  340814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340823 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  340826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340846 */     GIR_RootConstrainSelectedInstOperands,
     /*  340847 */     // GIR_Coverage, 3378,
     /*  340847 */     GIR_EraseRootFromParent_Done,
     /*  340848 */   // Label 6389: @340848
     /*  340848 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(340934), // Rule ID 3379 //
     /*  340853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  340856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  340876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340900 */     // MIs[1] Operand 1
     /*  340900 */     // No operand predicates
     /*  340900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  340912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  340921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340932 */     GIR_RootConstrainSelectedInstOperands,
     /*  340933 */     // GIR_Coverage, 3379,
     /*  340933 */     GIR_EraseRootFromParent_Done,
     /*  340934 */   // Label 6390: @340934
     /*  340934 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(341020), // Rule ID 3382 //
     /*  340939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  340942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  340947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  340962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  340978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  340982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  340986 */     // MIs[1] Operand 1
     /*  340986 */     // No operand predicates
     /*  340986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  340988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  340998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341018 */     GIR_RootConstrainSelectedInstOperands,
     /*  341019 */     // GIR_Coverage, 3382,
     /*  341019 */     GIR_EraseRootFromParent_Done,
     /*  341020 */   // Label 6391: @341020
     /*  341020 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(341106), // Rule ID 3383 //
     /*  341025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  341028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  341036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  341039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  341042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341072 */     // MIs[1] Operand 1
     /*  341072 */     // No operand predicates
     /*  341072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  341084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341104 */     GIR_RootConstrainSelectedInstOperands,
     /*  341105 */     // GIR_Coverage, 3383,
     /*  341105 */     GIR_EraseRootFromParent_Done,
     /*  341106 */   // Label 6392: @341106
     /*  341106 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(341192), // Rule ID 3386 //
     /*  341111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  341114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  341122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  341125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  341128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341158 */     // MIs[1] Operand 1
     /*  341158 */     // No operand predicates
     /*  341158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341167 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  341170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341190 */     GIR_RootConstrainSelectedInstOperands,
     /*  341191 */     // GIR_Coverage, 3386,
     /*  341191 */     GIR_EraseRootFromParent_Done,
     /*  341192 */   // Label 6393: @341192
     /*  341192 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(341278), // Rule ID 3387 //
     /*  341197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  341200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  341208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  341211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  341214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341244 */     // MIs[1] Operand 1
     /*  341244 */     // No operand predicates
     /*  341244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341253 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  341256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341276 */     GIR_RootConstrainSelectedInstOperands,
     /*  341277 */     // GIR_Coverage, 3387,
     /*  341277 */     GIR_EraseRootFromParent_Done,
     /*  341278 */   // Label 6394: @341278
     /*  341278 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(341364), // Rule ID 3390 //
     /*  341283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  341286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  341294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  341297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  341300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341330 */     // MIs[1] Operand 1
     /*  341330 */     // No operand predicates
     /*  341330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  341339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  341342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341362 */     GIR_RootConstrainSelectedInstOperands,
     /*  341363 */     // GIR_Coverage, 3390,
     /*  341363 */     GIR_EraseRootFromParent_Done,
     /*  341364 */   // Label 6395: @341364
     /*  341364 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(341450), // Rule ID 3391 //
     /*  341369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  341372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  341380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  341383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  341386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341416 */     // MIs[1] Operand 1
     /*  341416 */     // No operand predicates
     /*  341416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341425 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  341425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  341428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341448 */     GIR_RootConstrainSelectedInstOperands,
     /*  341449 */     // GIR_Coverage, 3391,
     /*  341449 */     GIR_EraseRootFromParent_Done,
     /*  341450 */   // Label 6396: @341450
     /*  341450 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(341536), // Rule ID 3394 //
     /*  341455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  341458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  341466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  341469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  341472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341502 */     // MIs[1] Operand 1
     /*  341502 */     // No operand predicates
     /*  341502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341511 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  341511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  341514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341534 */     GIR_RootConstrainSelectedInstOperands,
     /*  341535 */     // GIR_Coverage, 3394,
     /*  341535 */     GIR_EraseRootFromParent_Done,
     /*  341536 */   // Label 6397: @341536
     /*  341536 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(341622), // Rule ID 3395 //
     /*  341541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  341544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  341552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  341555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  341558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341588 */     // MIs[1] Operand 1
     /*  341588 */     // No operand predicates
     /*  341588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341597 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  341597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  341600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341620 */     GIR_RootConstrainSelectedInstOperands,
     /*  341621 */     // GIR_Coverage, 3395,
     /*  341621 */     GIR_EraseRootFromParent_Done,
     /*  341622 */   // Label 6398: @341622
     /*  341622 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(341708), // Rule ID 3398 //
     /*  341627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  341630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  341638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  341641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  341644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341674 */     // MIs[1] Operand 1
     /*  341674 */     // No operand predicates
     /*  341674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341683 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  341683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  341686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341706 */     GIR_RootConstrainSelectedInstOperands,
     /*  341707 */     // GIR_Coverage, 3398,
     /*  341707 */     GIR_EraseRootFromParent_Done,
     /*  341708 */   // Label 6399: @341708
     /*  341708 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(341794), // Rule ID 3399 //
     /*  341713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  341716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  341724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  341727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  341730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341760 */     // MIs[1] Operand 1
     /*  341760 */     // No operand predicates
     /*  341760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341769 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  341769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  341772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  341789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341792 */     GIR_RootConstrainSelectedInstOperands,
     /*  341793 */     // GIR_Coverage, 3399,
     /*  341793 */     GIR_EraseRootFromParent_Done,
     /*  341794 */   // Label 6400: @341794
     /*  341794 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(341880), // Rule ID 3402 //
     /*  341799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  341802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  341810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  341813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  341816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341846 */     // MIs[1] Operand 1
     /*  341846 */     // No operand predicates
     /*  341846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  341858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341878 */     GIR_RootConstrainSelectedInstOperands,
     /*  341879 */     // GIR_Coverage, 3402,
     /*  341879 */     GIR_EraseRootFromParent_Done,
     /*  341880 */   // Label 6401: @341880
     /*  341880 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(341966), // Rule ID 3403 //
     /*  341885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  341888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  341896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  341899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  341902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  341908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  341924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  341928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  341932 */     // MIs[1] Operand 1
     /*  341932 */     // No operand predicates
     /*  341932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  341934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  341944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  341953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341964 */     GIR_RootConstrainSelectedInstOperands,
     /*  341965 */     // GIR_Coverage, 3403,
     /*  341965 */     GIR_EraseRootFromParent_Done,
     /*  341966 */   // Label 6402: @341966
     /*  341966 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(342052), // Rule ID 3406 //
     /*  341971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  341974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  341979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  341982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  341985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  341988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  341994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342018 */     // MIs[1] Operand 1
     /*  342018 */     // No operand predicates
     /*  342018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  342030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342050 */     GIR_RootConstrainSelectedInstOperands,
     /*  342051 */     // GIR_Coverage, 3406,
     /*  342051 */     GIR_EraseRootFromParent_Done,
     /*  342052 */   // Label 6403: @342052
     /*  342052 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(342138), // Rule ID 3407 //
     /*  342057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  342060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342104 */     // MIs[1] Operand 1
     /*  342104 */     // No operand predicates
     /*  342104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  342116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342136 */     GIR_RootConstrainSelectedInstOperands,
     /*  342137 */     // GIR_Coverage, 3407,
     /*  342137 */     GIR_EraseRootFromParent_Done,
     /*  342138 */   // Label 6404: @342138
     /*  342138 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(342224), // Rule ID 3410 //
     /*  342143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  342146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  342166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342190 */     // MIs[1] Operand 1
     /*  342190 */     // No operand predicates
     /*  342190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342199 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  342202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342222 */     GIR_RootConstrainSelectedInstOperands,
     /*  342223 */     // GIR_Coverage, 3410,
     /*  342223 */     GIR_EraseRootFromParent_Done,
     /*  342224 */   // Label 6405: @342224
     /*  342224 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(342310), // Rule ID 3411 //
     /*  342229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  342232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342276 */     // MIs[1] Operand 1
     /*  342276 */     // No operand predicates
     /*  342276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342285 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  342288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342308 */     GIR_RootConstrainSelectedInstOperands,
     /*  342309 */     // GIR_Coverage, 3411,
     /*  342309 */     GIR_EraseRootFromParent_Done,
     /*  342310 */   // Label 6406: @342310
     /*  342310 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(342396), // Rule ID 3414 //
     /*  342315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  342318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  342338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342362 */     // MIs[1] Operand 1
     /*  342362 */     // No operand predicates
     /*  342362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  342374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342394 */     GIR_RootConstrainSelectedInstOperands,
     /*  342395 */     // GIR_Coverage, 3414,
     /*  342395 */     GIR_EraseRootFromParent_Done,
     /*  342396 */   // Label 6407: @342396
     /*  342396 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(342482), // Rule ID 3415 //
     /*  342401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  342404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342448 */     // MIs[1] Operand 1
     /*  342448 */     // No operand predicates
     /*  342448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  342460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342480 */     GIR_RootConstrainSelectedInstOperands,
     /*  342481 */     // GIR_Coverage, 3415,
     /*  342481 */     GIR_EraseRootFromParent_Done,
     /*  342482 */   // Label 6408: @342482
     /*  342482 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(342568), // Rule ID 3418 //
     /*  342487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  342490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  342510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342534 */     // MIs[1] Operand 1
     /*  342534 */     // No operand predicates
     /*  342534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  342546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342566 */     GIR_RootConstrainSelectedInstOperands,
     /*  342567 */     // GIR_Coverage, 3418,
     /*  342567 */     GIR_EraseRootFromParent_Done,
     /*  342568 */   // Label 6409: @342568
     /*  342568 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(342654), // Rule ID 3419 //
     /*  342573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  342576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342620 */     // MIs[1] Operand 1
     /*  342620 */     // No operand predicates
     /*  342620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  342632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342652 */     GIR_RootConstrainSelectedInstOperands,
     /*  342653 */     // GIR_Coverage, 3419,
     /*  342653 */     GIR_EraseRootFromParent_Done,
     /*  342654 */   // Label 6410: @342654
     /*  342654 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(342740), // Rule ID 3422 //
     /*  342659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  342662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  342682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342706 */     // MIs[1] Operand 1
     /*  342706 */     // No operand predicates
     /*  342706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  342718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342738 */     GIR_RootConstrainSelectedInstOperands,
     /*  342739 */     // GIR_Coverage, 3422,
     /*  342739 */     GIR_EraseRootFromParent_Done,
     /*  342740 */   // Label 6411: @342740
     /*  342740 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(342826), // Rule ID 3423 //
     /*  342745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  342748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342792 */     // MIs[1] Operand 1
     /*  342792 */     // No operand predicates
     /*  342792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  342804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342824 */     GIR_RootConstrainSelectedInstOperands,
     /*  342825 */     // GIR_Coverage, 3423,
     /*  342825 */     GIR_EraseRootFromParent_Done,
     /*  342826 */   // Label 6412: @342826
     /*  342826 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(342912), // Rule ID 3426 //
     /*  342831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  342834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  342842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  342845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  342848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  342854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342878 */     // MIs[1] Operand 1
     /*  342878 */     // No operand predicates
     /*  342878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  342890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342910 */     GIR_RootConstrainSelectedInstOperands,
     /*  342911 */     // GIR_Coverage, 3426,
     /*  342911 */     GIR_EraseRootFromParent_Done,
     /*  342912 */   // Label 6413: @342912
     /*  342912 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(342998), // Rule ID 3427 //
     /*  342917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  342920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  342925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  342928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  342931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  342934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  342940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  342956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  342960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  342964 */     // MIs[1] Operand 1
     /*  342964 */     // No operand predicates
     /*  342964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  342966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  342976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  342982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  342985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342996 */     GIR_RootConstrainSelectedInstOperands,
     /*  342997 */     // GIR_Coverage, 3427,
     /*  342997 */     GIR_EraseRootFromParent_Done,
     /*  342998 */   // Label 6414: @342998
     /*  342998 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(343084), // Rule ID 3430 //
     /*  343003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  343006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  343011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343050 */     // MIs[1] Operand 1
     /*  343050 */     // No operand predicates
     /*  343050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  343062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343082 */     GIR_RootConstrainSelectedInstOperands,
     /*  343083 */     // GIR_Coverage, 3430,
     /*  343083 */     GIR_EraseRootFromParent_Done,
     /*  343084 */   // Label 6415: @343084
     /*  343084 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(343170), // Rule ID 3431 //
     /*  343089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  343092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  343097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343136 */     // MIs[1] Operand 1
     /*  343136 */     // No operand predicates
     /*  343136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  343148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343168 */     GIR_RootConstrainSelectedInstOperands,
     /*  343169 */     // GIR_Coverage, 3431,
     /*  343169 */     GIR_EraseRootFromParent_Done,
     /*  343170 */   // Label 6416: @343170
     /*  343170 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(343256), // Rule ID 3434 //
     /*  343175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  343178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  343183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343222 */     // MIs[1] Operand 1
     /*  343222 */     // No operand predicates
     /*  343222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  343234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343254 */     GIR_RootConstrainSelectedInstOperands,
     /*  343255 */     // GIR_Coverage, 3434,
     /*  343255 */     GIR_EraseRootFromParent_Done,
     /*  343256 */   // Label 6417: @343256
     /*  343256 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(343342), // Rule ID 3435 //
     /*  343261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  343264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  343269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343308 */     // MIs[1] Operand 1
     /*  343308 */     // No operand predicates
     /*  343308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343317 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  343320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343340 */     GIR_RootConstrainSelectedInstOperands,
     /*  343341 */     // GIR_Coverage, 3435,
     /*  343341 */     GIR_EraseRootFromParent_Done,
     /*  343342 */   // Label 6418: @343342
     /*  343342 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(343428), // Rule ID 5798 //
     /*  343347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  343350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  343358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  343361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  343364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343394 */     // MIs[1] Operand 1
     /*  343394 */     // No operand predicates
     /*  343394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343403 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  343403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  343406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343426 */     GIR_RootConstrainSelectedInstOperands,
     /*  343427 */     // GIR_Coverage, 5798,
     /*  343427 */     GIR_EraseRootFromParent_Done,
     /*  343428 */   // Label 6419: @343428
     /*  343428 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(343514), // Rule ID 5799 //
     /*  343433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  343436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  343444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  343447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  343450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343480 */     // MIs[1] Operand 1
     /*  343480 */     // No operand predicates
     /*  343480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343489 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  343489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  343492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343512 */     GIR_RootConstrainSelectedInstOperands,
     /*  343513 */     // GIR_Coverage, 5799,
     /*  343513 */     GIR_EraseRootFromParent_Done,
     /*  343514 */   // Label 6420: @343514
     /*  343514 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(343600), // Rule ID 5802 //
     /*  343519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  343522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  343530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  343533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  343536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343566 */     // MIs[1] Operand 1
     /*  343566 */     // No operand predicates
     /*  343566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343575 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  343575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  343578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343598 */     GIR_RootConstrainSelectedInstOperands,
     /*  343599 */     // GIR_Coverage, 5802,
     /*  343599 */     GIR_EraseRootFromParent_Done,
     /*  343600 */   // Label 6421: @343600
     /*  343600 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(343686), // Rule ID 5803 //
     /*  343605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  343608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  343616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  343619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  343622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343652 */     // MIs[1] Operand 1
     /*  343652 */     // No operand predicates
     /*  343652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343661 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  343661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  343664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343684 */     GIR_RootConstrainSelectedInstOperands,
     /*  343685 */     // GIR_Coverage, 5803,
     /*  343685 */     GIR_EraseRootFromParent_Done,
     /*  343686 */   // Label 6422: @343686
     /*  343686 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(343772), // Rule ID 5806 //
     /*  343691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  343694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  343702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  343705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  343708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343738 */     // MIs[1] Operand 1
     /*  343738 */     // No operand predicates
     /*  343738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343747 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  343747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  343750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343770 */     GIR_RootConstrainSelectedInstOperands,
     /*  343771 */     // GIR_Coverage, 5806,
     /*  343771 */     GIR_EraseRootFromParent_Done,
     /*  343772 */   // Label 6423: @343772
     /*  343772 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(343858), // Rule ID 5807 //
     /*  343777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  343780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  343788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  343791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  343794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343824 */     // MIs[1] Operand 1
     /*  343824 */     // No operand predicates
     /*  343824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343833 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  343833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  343836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  343853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343856 */     GIR_RootConstrainSelectedInstOperands,
     /*  343857 */     // GIR_Coverage, 5807,
     /*  343857 */     GIR_EraseRootFromParent_Done,
     /*  343858 */   // Label 6424: @343858
     /*  343858 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(343944), // Rule ID 5810 //
     /*  343863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  343866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  343886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343910 */     // MIs[1] Operand 1
     /*  343910 */     // No operand predicates
     /*  343910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343919 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  343922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  343928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  343931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343942 */     GIR_RootConstrainSelectedInstOperands,
     /*  343943 */     // GIR_Coverage, 5810,
     /*  343943 */     GIR_EraseRootFromParent_Done,
     /*  343944 */   // Label 6425: @343944
     /*  343944 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(344030), // Rule ID 5811 //
     /*  343949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  343952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  343957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  343972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  343988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  343992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  343996 */     // MIs[1] Operand 1
     /*  343996 */     // No operand predicates
     /*  343996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  343998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344005 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  344008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344028 */     GIR_RootConstrainSelectedInstOperands,
     /*  344029 */     // GIR_Coverage, 5811,
     /*  344029 */     GIR_EraseRootFromParent_Done,
     /*  344030 */   // Label 6426: @344030
     /*  344030 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(344116), // Rule ID 5814 //
     /*  344035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  344038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  344046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  344049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344082 */     // MIs[1] Operand 1
     /*  344082 */     // No operand predicates
     /*  344082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344091 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  344094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344114 */     GIR_RootConstrainSelectedInstOperands,
     /*  344115 */     // GIR_Coverage, 5814,
     /*  344115 */     GIR_EraseRootFromParent_Done,
     /*  344116 */   // Label 6427: @344116
     /*  344116 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(344202), // Rule ID 5815 //
     /*  344121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  344124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  344132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  344135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  344144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344168 */     // MIs[1] Operand 1
     /*  344168 */     // No operand predicates
     /*  344168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344177 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  344180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344200 */     GIR_RootConstrainSelectedInstOperands,
     /*  344201 */     // GIR_Coverage, 5815,
     /*  344201 */     GIR_EraseRootFromParent_Done,
     /*  344202 */   // Label 6428: @344202
     /*  344202 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(344288), // Rule ID 5818 //
     /*  344207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  344210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344254 */     // MIs[1] Operand 1
     /*  344254 */     // No operand predicates
     /*  344254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  344266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344286 */     GIR_RootConstrainSelectedInstOperands,
     /*  344287 */     // GIR_Coverage, 5818,
     /*  344287 */     GIR_EraseRootFromParent_Done,
     /*  344288 */   // Label 6429: @344288
     /*  344288 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(344374), // Rule ID 5819 //
     /*  344293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  344296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  344316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344340 */     // MIs[1] Operand 1
     /*  344340 */     // No operand predicates
     /*  344340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344349 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  344352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344372 */     GIR_RootConstrainSelectedInstOperands,
     /*  344373 */     // GIR_Coverage, 5819,
     /*  344373 */     GIR_EraseRootFromParent_Done,
     /*  344374 */   // Label 6430: @344374
     /*  344374 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(344460), // Rule ID 5822 //
     /*  344379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  344382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  344390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  344393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  344396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344426 */     // MIs[1] Operand 1
     /*  344426 */     // No operand predicates
     /*  344426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344435 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  344435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  344455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344458 */     GIR_RootConstrainSelectedInstOperands,
     /*  344459 */     // GIR_Coverage, 5822,
     /*  344459 */     GIR_EraseRootFromParent_Done,
     /*  344460 */   // Label 6431: @344460
     /*  344460 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(344546), // Rule ID 5823 //
     /*  344465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  344468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  344476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  344479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  344482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  344488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344512 */     // MIs[1] Operand 1
     /*  344512 */     // No operand predicates
     /*  344512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  344521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  344541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344544 */     GIR_RootConstrainSelectedInstOperands,
     /*  344545 */     // GIR_Coverage, 5823,
     /*  344545 */     GIR_EraseRootFromParent_Done,
     /*  344546 */   // Label 6432: @344546
     /*  344546 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(344632), // Rule ID 5826 //
     /*  344551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  344554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  344562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  344565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344598 */     // MIs[1] Operand 1
     /*  344598 */     // No operand predicates
     /*  344598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344607 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344630 */     GIR_RootConstrainSelectedInstOperands,
     /*  344631 */     // GIR_Coverage, 5826,
     /*  344631 */     GIR_EraseRootFromParent_Done,
     /*  344632 */   // Label 6433: @344632
     /*  344632 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(344718), // Rule ID 5827 //
     /*  344637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  344640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  344648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  344651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  344660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344684 */     // MIs[1] Operand 1
     /*  344684 */     // No operand predicates
     /*  344684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344716 */     GIR_RootConstrainSelectedInstOperands,
     /*  344717 */     // GIR_Coverage, 5827,
     /*  344717 */     GIR_EraseRootFromParent_Done,
     /*  344718 */   // Label 6434: @344718
     /*  344718 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(344804), // Rule ID 5830 //
     /*  344723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  344726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344770 */     // MIs[1] Operand 1
     /*  344770 */     // No operand predicates
     /*  344770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344802 */     GIR_RootConstrainSelectedInstOperands,
     /*  344803 */     // GIR_Coverage, 5830,
     /*  344803 */     GIR_EraseRootFromParent_Done,
     /*  344804 */   // Label 6435: @344804
     /*  344804 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(344890), // Rule ID 5831 //
     /*  344809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  344812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  344832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344856 */     // MIs[1] Operand 1
     /*  344856 */     // No operand predicates
     /*  344856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344888 */     GIR_RootConstrainSelectedInstOperands,
     /*  344889 */     // GIR_Coverage, 5831,
     /*  344889 */     GIR_EraseRootFromParent_Done,
     /*  344890 */   // Label 6436: @344890
     /*  344890 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(344976), // Rule ID 5834 //
     /*  344895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  344898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  344918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  344934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  344938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  344942 */     // MIs[1] Operand 1
     /*  344942 */     // No operand predicates
     /*  344942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  344944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  344951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  344954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  344960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  344963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344974 */     GIR_RootConstrainSelectedInstOperands,
     /*  344975 */     // GIR_Coverage, 5834,
     /*  344975 */     GIR_EraseRootFromParent_Done,
     /*  344976 */   // Label 6437: @344976
     /*  344976 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(345062), // Rule ID 5835 //
     /*  344981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  344984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  344989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345028 */     // MIs[1] Operand 1
     /*  345028 */     // No operand predicates
     /*  345028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345037 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  345040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345060 */     GIR_RootConstrainSelectedInstOperands,
     /*  345061 */     // GIR_Coverage, 5835,
     /*  345061 */     GIR_EraseRootFromParent_Done,
     /*  345062 */   // Label 6438: @345062
     /*  345062 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(345148), // Rule ID 5838 //
     /*  345067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  345078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  345081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  345084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345114 */     // MIs[1] Operand 1
     /*  345114 */     // No operand predicates
     /*  345114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  345126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345146 */     GIR_RootConstrainSelectedInstOperands,
     /*  345147 */     // GIR_Coverage, 5838,
     /*  345147 */     GIR_EraseRootFromParent_Done,
     /*  345148 */   // Label 6439: @345148
     /*  345148 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(345234), // Rule ID 5839 //
     /*  345153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  345156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  345164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  345167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  345170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345200 */     // MIs[1] Operand 1
     /*  345200 */     // No operand predicates
     /*  345200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345209 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  345212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345232 */     GIR_RootConstrainSelectedInstOperands,
     /*  345233 */     // GIR_Coverage, 5839,
     /*  345233 */     GIR_EraseRootFromParent_Done,
     /*  345234 */   // Label 6440: @345234
     /*  345234 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(345320), // Rule ID 5842 //
     /*  345239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  345250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  345253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  345256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345286 */     // MIs[1] Operand 1
     /*  345286 */     // No operand predicates
     /*  345286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345295 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  345298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345318 */     GIR_RootConstrainSelectedInstOperands,
     /*  345319 */     // GIR_Coverage, 5842,
     /*  345319 */     GIR_EraseRootFromParent_Done,
     /*  345320 */   // Label 6441: @345320
     /*  345320 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(345406), // Rule ID 5843 //
     /*  345325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  345328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  345336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  345339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  345342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345372 */     // MIs[1] Operand 1
     /*  345372 */     // No operand predicates
     /*  345372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345381 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  345384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345404 */     GIR_RootConstrainSelectedInstOperands,
     /*  345405 */     // GIR_Coverage, 5843,
     /*  345405 */     GIR_EraseRootFromParent_Done,
     /*  345406 */   // Label 6442: @345406
     /*  345406 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(345492), // Rule ID 5846 //
     /*  345411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  345422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  345425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  345428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345458 */     // MIs[1] Operand 1
     /*  345458 */     // No operand predicates
     /*  345458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345467 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  345470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345490 */     GIR_RootConstrainSelectedInstOperands,
     /*  345491 */     // GIR_Coverage, 5846,
     /*  345491 */     GIR_EraseRootFromParent_Done,
     /*  345492 */   // Label 6443: @345492
     /*  345492 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(345578), // Rule ID 5847 //
     /*  345497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  345500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  345508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  345511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  345514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345544 */     // MIs[1] Operand 1
     /*  345544 */     // No operand predicates
     /*  345544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345553 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  345556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345576 */     GIR_RootConstrainSelectedInstOperands,
     /*  345577 */     // GIR_Coverage, 5847,
     /*  345577 */     GIR_EraseRootFromParent_Done,
     /*  345578 */   // Label 6444: @345578
     /*  345578 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(345664), // Rule ID 5850 //
     /*  345583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  345594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  345597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345630 */     // MIs[1] Operand 1
     /*  345630 */     // No operand predicates
     /*  345630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  345642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345662 */     GIR_RootConstrainSelectedInstOperands,
     /*  345663 */     // GIR_Coverage, 5850,
     /*  345663 */     GIR_EraseRootFromParent_Done,
     /*  345664 */   // Label 6445: @345664
     /*  345664 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(345750), // Rule ID 5851 //
     /*  345669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  345672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  345680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  345683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345716 */     // MIs[1] Operand 1
     /*  345716 */     // No operand predicates
     /*  345716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  345728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345748 */     GIR_RootConstrainSelectedInstOperands,
     /*  345749 */     // GIR_Coverage, 5851,
     /*  345749 */     GIR_EraseRootFromParent_Done,
     /*  345750 */   // Label 6446: @345750
     /*  345750 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(345836), // Rule ID 5854 //
     /*  345755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  345766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  345769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345802 */     // MIs[1] Operand 1
     /*  345802 */     // No operand predicates
     /*  345802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345811 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  345814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345834 */     GIR_RootConstrainSelectedInstOperands,
     /*  345835 */     // GIR_Coverage, 5854,
     /*  345835 */     GIR_EraseRootFromParent_Done,
     /*  345836 */   // Label 6447: @345836
     /*  345836 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(345922), // Rule ID 5855 //
     /*  345841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  345844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  345852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  345855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  345864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345888 */     // MIs[1] Operand 1
     /*  345888 */     // No operand predicates
     /*  345888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345897 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  345900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345920 */     GIR_RootConstrainSelectedInstOperands,
     /*  345921 */     // GIR_Coverage, 5855,
     /*  345921 */     GIR_EraseRootFromParent_Done,
     /*  345922 */   // Label 6448: @345922
     /*  345922 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(346008), // Rule ID 5858 //
     /*  345927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  345930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  345935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  345938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  345941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  345944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  345950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  345966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  345970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  345974 */     // MIs[1] Operand 1
     /*  345974 */     // No operand predicates
     /*  345974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  345976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345983 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  345986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  345992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  345995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346006 */     GIR_RootConstrainSelectedInstOperands,
     /*  346007 */     // GIR_Coverage, 5858,
     /*  346007 */     GIR_EraseRootFromParent_Done,
     /*  346008 */   // Label 6449: @346008
     /*  346008 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(346094), // Rule ID 5859 //
     /*  346013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  346016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  346030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346060 */     // MIs[1] Operand 1
     /*  346060 */     // No operand predicates
     /*  346060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346069 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  346072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346092 */     GIR_RootConstrainSelectedInstOperands,
     /*  346093 */     // GIR_Coverage, 5859,
     /*  346093 */     GIR_EraseRootFromParent_Done,
     /*  346094 */   // Label 6450: @346094
     /*  346094 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(346180), // Rule ID 5862 //
     /*  346099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  346102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346146 */     // MIs[1] Operand 1
     /*  346146 */     // No operand predicates
     /*  346146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  346158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346178 */     GIR_RootConstrainSelectedInstOperands,
     /*  346179 */     // GIR_Coverage, 5862,
     /*  346179 */     GIR_EraseRootFromParent_Done,
     /*  346180 */   // Label 6451: @346180
     /*  346180 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(346266), // Rule ID 5863 //
     /*  346185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  346188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346232 */     // MIs[1] Operand 1
     /*  346232 */     // No operand predicates
     /*  346232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  346244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346264 */     GIR_RootConstrainSelectedInstOperands,
     /*  346265 */     // GIR_Coverage, 5863,
     /*  346265 */     GIR_EraseRootFromParent_Done,
     /*  346266 */   // Label 6452: @346266
     /*  346266 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(346352), // Rule ID 5866 //
     /*  346271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  346274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346318 */     // MIs[1] Operand 1
     /*  346318 */     // No operand predicates
     /*  346318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  346330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346350 */     GIR_RootConstrainSelectedInstOperands,
     /*  346351 */     // GIR_Coverage, 5866,
     /*  346351 */     GIR_EraseRootFromParent_Done,
     /*  346352 */   // Label 6453: @346352
     /*  346352 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(346438), // Rule ID 5867 //
     /*  346357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  346360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346404 */     // MIs[1] Operand 1
     /*  346404 */     // No operand predicates
     /*  346404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346413 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  346416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346436 */     GIR_RootConstrainSelectedInstOperands,
     /*  346437 */     // GIR_Coverage, 5867,
     /*  346437 */     GIR_EraseRootFromParent_Done,
     /*  346438 */   // Label 6454: @346438
     /*  346438 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(346524), // Rule ID 5870 //
     /*  346443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  346446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346490 */     // MIs[1] Operand 1
     /*  346490 */     // No operand predicates
     /*  346490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  346502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346522 */     GIR_RootConstrainSelectedInstOperands,
     /*  346523 */     // GIR_Coverage, 5870,
     /*  346523 */     GIR_EraseRootFromParent_Done,
     /*  346524 */   // Label 6455: @346524
     /*  346524 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(346610), // Rule ID 5871 //
     /*  346529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  346532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346576 */     // MIs[1] Operand 1
     /*  346576 */     // No operand predicates
     /*  346576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  346588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346608 */     GIR_RootConstrainSelectedInstOperands,
     /*  346609 */     // GIR_Coverage, 5871,
     /*  346609 */     GIR_EraseRootFromParent_Done,
     /*  346610 */   // Label 6456: @346610
     /*  346610 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(346696), // Rule ID 5874 //
     /*  346615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  346618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  346632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346662 */     // MIs[1] Operand 1
     /*  346662 */     // No operand predicates
     /*  346662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  346671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  346674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346694 */     GIR_RootConstrainSelectedInstOperands,
     /*  346695 */     // GIR_Coverage, 5874,
     /*  346695 */     GIR_EraseRootFromParent_Done,
     /*  346696 */   // Label 6457: @346696
     /*  346696 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(346782), // Rule ID 5875 //
     /*  346701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  346704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  346718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346748 */     // MIs[1] Operand 1
     /*  346748 */     // No operand predicates
     /*  346748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  346757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  346760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346780 */     GIR_RootConstrainSelectedInstOperands,
     /*  346781 */     // GIR_Coverage, 5875,
     /*  346781 */     GIR_EraseRootFromParent_Done,
     /*  346782 */   // Label 6458: @346782
     /*  346782 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(346868), // Rule ID 5878 //
     /*  346787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  346790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  346804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346834 */     // MIs[1] Operand 1
     /*  346834 */     // No operand predicates
     /*  346834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346843 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  346843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  346846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346866 */     GIR_RootConstrainSelectedInstOperands,
     /*  346867 */     // GIR_Coverage, 5878,
     /*  346867 */     GIR_EraseRootFromParent_Done,
     /*  346868 */   // Label 6459: @346868
     /*  346868 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(346954), // Rule ID 5879 //
     /*  346873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  346876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  346890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  346896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  346916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  346920 */     // MIs[1] Operand 1
     /*  346920 */     // No operand predicates
     /*  346920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  346922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346929 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  346929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  346932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  346938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  346941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346952 */     GIR_RootConstrainSelectedInstOperands,
     /*  346953 */     // GIR_Coverage, 5879,
     /*  346953 */     GIR_EraseRootFromParent_Done,
     /*  346954 */   // Label 6460: @346954
     /*  346954 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(347040), // Rule ID 5882 //
     /*  346959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  346962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  346967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  346970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  346973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  346976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  346982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  346998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347006 */     // MIs[1] Operand 1
     /*  347006 */     // No operand predicates
     /*  347006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347015 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  347018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347038 */     GIR_RootConstrainSelectedInstOperands,
     /*  347039 */     // GIR_Coverage, 5882,
     /*  347039 */     GIR_EraseRootFromParent_Done,
     /*  347040 */   // Label 6461: @347040
     /*  347040 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(347126), // Rule ID 5883 //
     /*  347045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  347048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  347053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  347062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347092 */     // MIs[1] Operand 1
     /*  347092 */     // No operand predicates
     /*  347092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347101 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  347104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347124 */     GIR_RootConstrainSelectedInstOperands,
     /*  347125 */     // GIR_Coverage, 5883,
     /*  347125 */     GIR_EraseRootFromParent_Done,
     /*  347126 */   // Label 6462: @347126
     /*  347126 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(347212), // Rule ID 6062 //
     /*  347131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  347142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  347145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  347154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347178 */     // MIs[1] Operand 1
     /*  347178 */     // No operand predicates
     /*  347178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347187 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  347190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347210 */     GIR_RootConstrainSelectedInstOperands,
     /*  347211 */     // GIR_Coverage, 6062,
     /*  347211 */     GIR_EraseRootFromParent_Done,
     /*  347212 */   // Label 6463: @347212
     /*  347212 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(347298), // Rule ID 6063 //
     /*  347217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  347220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  347228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  347231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347264 */     // MIs[1] Operand 1
     /*  347264 */     // No operand predicates
     /*  347264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347273 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  347276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347296 */     GIR_RootConstrainSelectedInstOperands,
     /*  347297 */     // GIR_Coverage, 6063,
     /*  347297 */     GIR_EraseRootFromParent_Done,
     /*  347298 */   // Label 6464: @347298
     /*  347298 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(347384), // Rule ID 6066 //
     /*  347303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  347314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  347317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  347320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  347326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347350 */     // MIs[1] Operand 1
     /*  347350 */     // No operand predicates
     /*  347350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347359 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  347362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347382 */     GIR_RootConstrainSelectedInstOperands,
     /*  347383 */     // GIR_Coverage, 6066,
     /*  347383 */     GIR_EraseRootFromParent_Done,
     /*  347384 */   // Label 6465: @347384
     /*  347384 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(347470), // Rule ID 6067 //
     /*  347389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  347392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  347400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  347403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  347406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347436 */     // MIs[1] Operand 1
     /*  347436 */     // No operand predicates
     /*  347436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  347448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347468 */     GIR_RootConstrainSelectedInstOperands,
     /*  347469 */     // GIR_Coverage, 6067,
     /*  347469 */     GIR_EraseRootFromParent_Done,
     /*  347470 */   // Label 6466: @347470
     /*  347470 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(347556), // Rule ID 6070 //
     /*  347475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  347486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  347489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  347492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  347498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347522 */     // MIs[1] Operand 1
     /*  347522 */     // No operand predicates
     /*  347522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347531 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  347534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347554 */     GIR_RootConstrainSelectedInstOperands,
     /*  347555 */     // GIR_Coverage, 6070,
     /*  347555 */     GIR_EraseRootFromParent_Done,
     /*  347556 */   // Label 6467: @347556
     /*  347556 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(347642), // Rule ID 6071 //
     /*  347561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  347564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  347572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  347575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  347578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347608 */     // MIs[1] Operand 1
     /*  347608 */     // No operand predicates
     /*  347608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347617 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  347620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347640 */     GIR_RootConstrainSelectedInstOperands,
     /*  347641 */     // GIR_Coverage, 6071,
     /*  347641 */     GIR_EraseRootFromParent_Done,
     /*  347642 */   // Label 6468: @347642
     /*  347642 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(347728), // Rule ID 6074 //
     /*  347647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  347670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347694 */     // MIs[1] Operand 1
     /*  347694 */     // No operand predicates
     /*  347694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347703 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  347706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347726 */     GIR_RootConstrainSelectedInstOperands,
     /*  347727 */     // GIR_Coverage, 6074,
     /*  347727 */     GIR_EraseRootFromParent_Done,
     /*  347728 */   // Label 6469: @347728
     /*  347728 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(347814), // Rule ID 6075 //
     /*  347733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  347736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347780 */     // MIs[1] Operand 1
     /*  347780 */     // No operand predicates
     /*  347780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  347792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347812 */     GIR_RootConstrainSelectedInstOperands,
     /*  347813 */     // GIR_Coverage, 6075,
     /*  347813 */     GIR_EraseRootFromParent_Done,
     /*  347814 */   // Label 6470: @347814
     /*  347814 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(347900), // Rule ID 6078 //
     /*  347819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  347830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  347833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  347842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347866 */     // MIs[1] Operand 1
     /*  347866 */     // No operand predicates
     /*  347866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  347878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347898 */     GIR_RootConstrainSelectedInstOperands,
     /*  347899 */     // GIR_Coverage, 6078,
     /*  347899 */     GIR_EraseRootFromParent_Done,
     /*  347900 */   // Label 6471: @347900
     /*  347900 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(347986), // Rule ID 6079 //
     /*  347905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  347908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  347916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  347919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  347928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  347944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  347948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  347952 */     // MIs[1] Operand 1
     /*  347952 */     // No operand predicates
     /*  347952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  347954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347961 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  347964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  347970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  347973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347984 */     GIR_RootConstrainSelectedInstOperands,
     /*  347985 */     // GIR_Coverage, 6079,
     /*  347985 */     GIR_EraseRootFromParent_Done,
     /*  347986 */   // Label 6472: @347986
     /*  347986 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(348072), // Rule ID 6082 //
     /*  347991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  347994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  347999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348038 */     // MIs[1] Operand 1
     /*  348038 */     // No operand predicates
     /*  348038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348047 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  348050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348070 */     GIR_RootConstrainSelectedInstOperands,
     /*  348071 */     // GIR_Coverage, 6082,
     /*  348071 */     GIR_EraseRootFromParent_Done,
     /*  348072 */   // Label 6473: @348072
     /*  348072 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(348158), // Rule ID 6083 //
     /*  348077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  348080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348124 */     // MIs[1] Operand 1
     /*  348124 */     // No operand predicates
     /*  348124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  348136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348156 */     GIR_RootConstrainSelectedInstOperands,
     /*  348157 */     // GIR_Coverage, 6083,
     /*  348157 */     GIR_EraseRootFromParent_Done,
     /*  348158 */   // Label 6474: @348158
     /*  348158 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(348244), // Rule ID 6086 //
     /*  348163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  348166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  348174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  348177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348210 */     // MIs[1] Operand 1
     /*  348210 */     // No operand predicates
     /*  348210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348242 */     GIR_RootConstrainSelectedInstOperands,
     /*  348243 */     // GIR_Coverage, 6086,
     /*  348243 */     GIR_EraseRootFromParent_Done,
     /*  348244 */   // Label 6475: @348244
     /*  348244 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(348330), // Rule ID 6087 //
     /*  348249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  348252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  348260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  348263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348296 */     // MIs[1] Operand 1
     /*  348296 */     // No operand predicates
     /*  348296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348305 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348328 */     GIR_RootConstrainSelectedInstOperands,
     /*  348329 */     // GIR_Coverage, 6087,
     /*  348329 */     GIR_EraseRootFromParent_Done,
     /*  348330 */   // Label 6476: @348330
     /*  348330 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(348416), // Rule ID 6090 //
     /*  348335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  348338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348382 */     // MIs[1] Operand 1
     /*  348382 */     // No operand predicates
     /*  348382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348414 */     GIR_RootConstrainSelectedInstOperands,
     /*  348415 */     // GIR_Coverage, 6090,
     /*  348415 */     GIR_EraseRootFromParent_Done,
     /*  348416 */   // Label 6477: @348416
     /*  348416 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(348502), // Rule ID 6091 //
     /*  348421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  348424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348468 */     // MIs[1] Operand 1
     /*  348468 */     // No operand predicates
     /*  348468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348500 */     GIR_RootConstrainSelectedInstOperands,
     /*  348501 */     // GIR_Coverage, 6091,
     /*  348501 */     GIR_EraseRootFromParent_Done,
     /*  348502 */   // Label 6478: @348502
     /*  348502 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(348588), // Rule ID 6094 //
     /*  348507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  348510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348554 */     // MIs[1] Operand 1
     /*  348554 */     // No operand predicates
     /*  348554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348586 */     GIR_RootConstrainSelectedInstOperands,
     /*  348587 */     // GIR_Coverage, 6094,
     /*  348587 */     GIR_EraseRootFromParent_Done,
     /*  348588 */   // Label 6479: @348588
     /*  348588 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(348674), // Rule ID 6095 //
     /*  348593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  348596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348640 */     // MIs[1] Operand 1
     /*  348640 */     // No operand predicates
     /*  348640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348672 */     GIR_RootConstrainSelectedInstOperands,
     /*  348673 */     // GIR_Coverage, 6095,
     /*  348673 */     GIR_EraseRootFromParent_Done,
     /*  348674 */   // Label 6480: @348674
     /*  348674 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(348760), // Rule ID 6098 //
     /*  348679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  348682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  348696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348726 */     // MIs[1] Operand 1
     /*  348726 */     // No operand predicates
     /*  348726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348735 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  348735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  348755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348758 */     GIR_RootConstrainSelectedInstOperands,
     /*  348759 */     // GIR_Coverage, 6098,
     /*  348759 */     GIR_EraseRootFromParent_Done,
     /*  348760 */   // Label 6481: @348760
     /*  348760 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(348846), // Rule ID 6099 //
     /*  348765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  348768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  348782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348812 */     // MIs[1] Operand 1
     /*  348812 */     // No operand predicates
     /*  348812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  348821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  348824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  348841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348844 */     GIR_RootConstrainSelectedInstOperands,
     /*  348845 */     // GIR_Coverage, 6099,
     /*  348845 */     GIR_EraseRootFromParent_Done,
     /*  348846 */   // Label 6482: @348846
     /*  348846 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(348932), // Rule ID 6102 //
     /*  348851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  348854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  348862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  348865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  348874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348898 */     // MIs[1] Operand 1
     /*  348898 */     // No operand predicates
     /*  348898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348907 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  348910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  348916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  348919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348930 */     GIR_RootConstrainSelectedInstOperands,
     /*  348931 */     // GIR_Coverage, 6102,
     /*  348931 */     GIR_EraseRootFromParent_Done,
     /*  348932 */   // Label 6483: @348932
     /*  348932 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(349018), // Rule ID 6103 //
     /*  348937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  348940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  348945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  348948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  348951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  348960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  348976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  348980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  348984 */     // MIs[1] Operand 1
     /*  348984 */     // No operand predicates
     /*  348984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  348986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  348996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349016 */     GIR_RootConstrainSelectedInstOperands,
     /*  349017 */     // GIR_Coverage, 6103,
     /*  349017 */     GIR_EraseRootFromParent_Done,
     /*  349018 */   // Label 6484: @349018
     /*  349018 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(349104), // Rule ID 6106 //
     /*  349023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  349034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  349037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349070 */     // MIs[1] Operand 1
     /*  349070 */     // No operand predicates
     /*  349070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349079 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  349082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349102 */     GIR_RootConstrainSelectedInstOperands,
     /*  349103 */     // GIR_Coverage, 6106,
     /*  349103 */     GIR_EraseRootFromParent_Done,
     /*  349104 */   // Label 6485: @349104
     /*  349104 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(349190), // Rule ID 6107 //
     /*  349109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  349120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  349123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349156 */     // MIs[1] Operand 1
     /*  349156 */     // No operand predicates
     /*  349156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349165 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  349168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349188 */     GIR_RootConstrainSelectedInstOperands,
     /*  349189 */     // GIR_Coverage, 6107,
     /*  349189 */     GIR_EraseRootFromParent_Done,
     /*  349190 */   // Label 6486: @349190
     /*  349190 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(349276), // Rule ID 6110 //
     /*  349195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  349206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  349209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  349212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349242 */     // MIs[1] Operand 1
     /*  349242 */     // No operand predicates
     /*  349242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349251 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  349254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349274 */     GIR_RootConstrainSelectedInstOperands,
     /*  349275 */     // GIR_Coverage, 6110,
     /*  349275 */     GIR_EraseRootFromParent_Done,
     /*  349276 */   // Label 6487: @349276
     /*  349276 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(349362), // Rule ID 6111 //
     /*  349281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  349292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  349295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  349298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349328 */     // MIs[1] Operand 1
     /*  349328 */     // No operand predicates
     /*  349328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349337 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  349340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349360 */     GIR_RootConstrainSelectedInstOperands,
     /*  349361 */     // GIR_Coverage, 6111,
     /*  349361 */     GIR_EraseRootFromParent_Done,
     /*  349362 */   // Label 6488: @349362
     /*  349362 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(349448), // Rule ID 6114 //
     /*  349367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  349378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  349381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349414 */     // MIs[1] Operand 1
     /*  349414 */     // No operand predicates
     /*  349414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  349426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349446 */     GIR_RootConstrainSelectedInstOperands,
     /*  349447 */     // GIR_Coverage, 6114,
     /*  349447 */     GIR_EraseRootFromParent_Done,
     /*  349448 */   // Label 6489: @349448
     /*  349448 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(349534), // Rule ID 6115 //
     /*  349453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  349464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  349467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349500 */     // MIs[1] Operand 1
     /*  349500 */     // No operand predicates
     /*  349500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  349512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349532 */     GIR_RootConstrainSelectedInstOperands,
     /*  349533 */     // GIR_Coverage, 6115,
     /*  349533 */     GIR_EraseRootFromParent_Done,
     /*  349534 */   // Label 6490: @349534
     /*  349534 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(349620), // Rule ID 6118 //
     /*  349539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  349550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  349553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349586 */     // MIs[1] Operand 1
     /*  349586 */     // No operand predicates
     /*  349586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349595 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  349598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349618 */     GIR_RootConstrainSelectedInstOperands,
     /*  349619 */     // GIR_Coverage, 6118,
     /*  349619 */     GIR_EraseRootFromParent_Done,
     /*  349620 */   // Label 6491: @349620
     /*  349620 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(349706), // Rule ID 6119 //
     /*  349625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  349636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  349639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349672 */     // MIs[1] Operand 1
     /*  349672 */     // No operand predicates
     /*  349672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349681 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  349684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349704 */     GIR_RootConstrainSelectedInstOperands,
     /*  349705 */     // GIR_Coverage, 6119,
     /*  349705 */     GIR_EraseRootFromParent_Done,
     /*  349706 */   // Label 6492: @349706
     /*  349706 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(349792), // Rule ID 6122 //
     /*  349711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  349728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349758 */     // MIs[1] Operand 1
     /*  349758 */     // No operand predicates
     /*  349758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349767 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  349770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349790 */     GIR_RootConstrainSelectedInstOperands,
     /*  349791 */     // GIR_Coverage, 6122,
     /*  349791 */     GIR_EraseRootFromParent_Done,
     /*  349792 */   // Label 6493: @349792
     /*  349792 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(349878), // Rule ID 6123 //
     /*  349797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  349814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349844 */     // MIs[1] Operand 1
     /*  349844 */     // No operand predicates
     /*  349844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349853 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  349856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349876 */     GIR_RootConstrainSelectedInstOperands,
     /*  349877 */     // GIR_Coverage, 6123,
     /*  349877 */     GIR_EraseRootFromParent_Done,
     /*  349878 */   // Label 6494: @349878
     /*  349878 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(349964), // Rule ID 6126 //
     /*  349883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  349886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  349906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  349922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  349926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  349930 */     // MIs[1] Operand 1
     /*  349930 */     // No operand predicates
     /*  349930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  349932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  349942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  349948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  349951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349962 */     GIR_RootConstrainSelectedInstOperands,
     /*  349963 */     // GIR_Coverage, 6126,
     /*  349963 */     GIR_EraseRootFromParent_Done,
     /*  349964 */   // Label 6495: @349964
     /*  349964 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(350050), // Rule ID 6127 //
     /*  349969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  349972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  349977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  349992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350016 */     // MIs[1] Operand 1
     /*  350016 */     // No operand predicates
     /*  350016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  350028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350048 */     GIR_RootConstrainSelectedInstOperands,
     /*  350049 */     // GIR_Coverage, 6127,
     /*  350049 */     GIR_EraseRootFromParent_Done,
     /*  350050 */   // Label 6496: @350050
     /*  350050 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(350136), // Rule ID 6130 //
     /*  350055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  350058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350102 */     // MIs[1] Operand 1
     /*  350102 */     // No operand predicates
     /*  350102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  350114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350134 */     GIR_RootConstrainSelectedInstOperands,
     /*  350135 */     // GIR_Coverage, 6130,
     /*  350135 */     GIR_EraseRootFromParent_Done,
     /*  350136 */   // Label 6497: @350136
     /*  350136 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(350222), // Rule ID 6131 //
     /*  350141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  350144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  350164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350188 */     // MIs[1] Operand 1
     /*  350188 */     // No operand predicates
     /*  350188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350197 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  350200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350220 */     GIR_RootConstrainSelectedInstOperands,
     /*  350221 */     // GIR_Coverage, 6131,
     /*  350221 */     GIR_EraseRootFromParent_Done,
     /*  350222 */   // Label 6498: @350222
     /*  350222 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(350308), // Rule ID 6134 //
     /*  350227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  350230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  350244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350274 */     // MIs[1] Operand 1
     /*  350274 */     // No operand predicates
     /*  350274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350283 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  350286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350306 */     GIR_RootConstrainSelectedInstOperands,
     /*  350307 */     // GIR_Coverage, 6134,
     /*  350307 */     GIR_EraseRootFromParent_Done,
     /*  350308 */   // Label 6499: @350308
     /*  350308 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(350394), // Rule ID 6135 //
     /*  350313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  350316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  350330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  350336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350360 */     // MIs[1] Operand 1
     /*  350360 */     // No operand predicates
     /*  350360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350369 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  350372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350392 */     GIR_RootConstrainSelectedInstOperands,
     /*  350393 */     // GIR_Coverage, 6135,
     /*  350393 */     GIR_EraseRootFromParent_Done,
     /*  350394 */   // Label 6500: @350394
     /*  350394 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(350480), // Rule ID 6138 //
     /*  350399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  350402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  350416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350446 */     // MIs[1] Operand 1
     /*  350446 */     // No operand predicates
     /*  350446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  350455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  350458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350478 */     GIR_RootConstrainSelectedInstOperands,
     /*  350479 */     // GIR_Coverage, 6138,
     /*  350479 */     GIR_EraseRootFromParent_Done,
     /*  350480 */   // Label 6501: @350480
     /*  350480 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(350566), // Rule ID 6139 //
     /*  350485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  350488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  350502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  350508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350532 */     // MIs[1] Operand 1
     /*  350532 */     // No operand predicates
     /*  350532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  350541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  350544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350564 */     GIR_RootConstrainSelectedInstOperands,
     /*  350565 */     // GIR_Coverage, 6139,
     /*  350565 */     GIR_EraseRootFromParent_Done,
     /*  350566 */   // Label 6502: @350566
     /*  350566 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(350652), // Rule ID 6142 //
     /*  350571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  350574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  350588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350618 */     // MIs[1] Operand 1
     /*  350618 */     // No operand predicates
     /*  350618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  350627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  350630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350650 */     GIR_RootConstrainSelectedInstOperands,
     /*  350651 */     // GIR_Coverage, 6142,
     /*  350651 */     GIR_EraseRootFromParent_Done,
     /*  350652 */   // Label 6503: @350652
     /*  350652 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(350738), // Rule ID 6143 //
     /*  350657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  350660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  350674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  350680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350704 */     // MIs[1] Operand 1
     /*  350704 */     // No operand predicates
     /*  350704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350713 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  350713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  350716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350736 */     GIR_RootConstrainSelectedInstOperands,
     /*  350737 */     // GIR_Coverage, 6143,
     /*  350737 */     GIR_EraseRootFromParent_Done,
     /*  350738 */   // Label 6504: @350738
     /*  350738 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(350824), // Rule ID 6146 //
     /*  350743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  350746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  350760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350790 */     // MIs[1] Operand 1
     /*  350790 */     // No operand predicates
     /*  350790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350799 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  350799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  350802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350822 */     GIR_RootConstrainSelectedInstOperands,
     /*  350823 */     // GIR_Coverage, 6146,
     /*  350823 */     GIR_EraseRootFromParent_Done,
     /*  350824 */   // Label 6505: @350824
     /*  350824 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(350910), // Rule ID 6147 //
     /*  350829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  350832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  350837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  350846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  350852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350876 */     // MIs[1] Operand 1
     /*  350876 */     // No operand predicates
     /*  350876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350885 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  350885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  350888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  350905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350908 */     GIR_RootConstrainSelectedInstOperands,
     /*  350909 */     // GIR_Coverage, 6147,
     /*  350909 */     GIR_EraseRootFromParent_Done,
     /*  350910 */   // Label 6506: @350910
     /*  350910 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(350996), // Rule ID 6326 //
     /*  350915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  350918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  350923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  350926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  350929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  350932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  350938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  350954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  350958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  350962 */     // MIs[1] Operand 1
     /*  350962 */     // No operand predicates
     /*  350962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  350964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  350974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  350980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  350983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350994 */     GIR_RootConstrainSelectedInstOperands,
     /*  350995 */     // GIR_Coverage, 6326,
     /*  350995 */     GIR_EraseRootFromParent_Done,
     /*  350996 */   // Label 6507: @350996
     /*  350996 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(351082), // Rule ID 6327 //
     /*  351001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  351018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351048 */     // MIs[1] Operand 1
     /*  351048 */     // No operand predicates
     /*  351048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351057 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  351060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351080 */     GIR_RootConstrainSelectedInstOperands,
     /*  351081 */     // GIR_Coverage, 6327,
     /*  351081 */     GIR_EraseRootFromParent_Done,
     /*  351082 */   // Label 6508: @351082
     /*  351082 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(351168), // Rule ID 6330 //
     /*  351087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351134 */     // MIs[1] Operand 1
     /*  351134 */     // No operand predicates
     /*  351134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  351146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351166 */     GIR_RootConstrainSelectedInstOperands,
     /*  351167 */     // GIR_Coverage, 6330,
     /*  351167 */     GIR_EraseRootFromParent_Done,
     /*  351168 */   // Label 6509: @351168
     /*  351168 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(351254), // Rule ID 6331 //
     /*  351173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351220 */     // MIs[1] Operand 1
     /*  351220 */     // No operand predicates
     /*  351220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351229 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  351232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351252 */     GIR_RootConstrainSelectedInstOperands,
     /*  351253 */     // GIR_Coverage, 6331,
     /*  351253 */     GIR_EraseRootFromParent_Done,
     /*  351254 */   // Label 6510: @351254
     /*  351254 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(351340), // Rule ID 6334 //
     /*  351259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  351276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351306 */     // MIs[1] Operand 1
     /*  351306 */     // No operand predicates
     /*  351306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351315 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351338 */     GIR_RootConstrainSelectedInstOperands,
     /*  351339 */     // GIR_Coverage, 6334,
     /*  351339 */     GIR_EraseRootFromParent_Done,
     /*  351340 */   // Label 6511: @351340
     /*  351340 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(351426), // Rule ID 6335 //
     /*  351345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  351362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351392 */     // MIs[1] Operand 1
     /*  351392 */     // No operand predicates
     /*  351392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351401 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351424 */     GIR_RootConstrainSelectedInstOperands,
     /*  351425 */     // GIR_Coverage, 6335,
     /*  351425 */     GIR_EraseRootFromParent_Done,
     /*  351426 */   // Label 6512: @351426
     /*  351426 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(351512), // Rule ID 6338 //
     /*  351431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351478 */     // MIs[1] Operand 1
     /*  351478 */     // No operand predicates
     /*  351478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351487 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  351490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351510 */     GIR_RootConstrainSelectedInstOperands,
     /*  351511 */     // GIR_Coverage, 6338,
     /*  351511 */     GIR_EraseRootFromParent_Done,
     /*  351512 */   // Label 6513: @351512
     /*  351512 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(351598), // Rule ID 6339 //
     /*  351517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351564 */     // MIs[1] Operand 1
     /*  351564 */     // No operand predicates
     /*  351564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  351576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351596 */     GIR_RootConstrainSelectedInstOperands,
     /*  351597 */     // GIR_Coverage, 6339,
     /*  351597 */     GIR_EraseRootFromParent_Done,
     /*  351598 */   // Label 6514: @351598
     /*  351598 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(351684), // Rule ID 6342 //
     /*  351603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351650 */     // MIs[1] Operand 1
     /*  351650 */     // No operand predicates
     /*  351650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351682 */     GIR_RootConstrainSelectedInstOperands,
     /*  351683 */     // GIR_Coverage, 6342,
     /*  351683 */     GIR_EraseRootFromParent_Done,
     /*  351684 */   // Label 6515: @351684
     /*  351684 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(351770), // Rule ID 6343 //
     /*  351689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351736 */     // MIs[1] Operand 1
     /*  351736 */     // No operand predicates
     /*  351736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351745 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351768 */     GIR_RootConstrainSelectedInstOperands,
     /*  351769 */     // GIR_Coverage, 6343,
     /*  351769 */     GIR_EraseRootFromParent_Done,
     /*  351770 */   // Label 6516: @351770
     /*  351770 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(351856), // Rule ID 6346 //
     /*  351775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  351786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  351789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351822 */     // MIs[1] Operand 1
     /*  351822 */     // No operand predicates
     /*  351822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351831 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351854 */     GIR_RootConstrainSelectedInstOperands,
     /*  351855 */     // GIR_Coverage, 6346,
     /*  351855 */     GIR_EraseRootFromParent_Done,
     /*  351856 */   // Label 6517: @351856
     /*  351856 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(351942), // Rule ID 6347 //
     /*  351861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  351864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  351872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  351875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  351884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351908 */     // MIs[1] Operand 1
     /*  351908 */     // No operand predicates
     /*  351908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351917 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  351920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  351926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  351929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351940 */     GIR_RootConstrainSelectedInstOperands,
     /*  351941 */     // GIR_Coverage, 6347,
     /*  351941 */     GIR_EraseRootFromParent_Done,
     /*  351942 */   // Label 6518: @351942
     /*  351942 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(352028), // Rule ID 6350 //
     /*  351947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  351950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  351955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  351964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  351970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  351986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  351990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  351994 */     // MIs[1] Operand 1
     /*  351994 */     // No operand predicates
     /*  351994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  351996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352003 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352026 */     GIR_RootConstrainSelectedInstOperands,
     /*  352027 */     // GIR_Coverage, 6350,
     /*  352027 */     GIR_EraseRootFromParent_Done,
     /*  352028 */   // Label 6519: @352028
     /*  352028 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(352114), // Rule ID 6351 //
     /*  352033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  352036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  352044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  352047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  352050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352080 */     // MIs[1] Operand 1
     /*  352080 */     // No operand predicates
     /*  352080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352089 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352112 */     GIR_RootConstrainSelectedInstOperands,
     /*  352113 */     // GIR_Coverage, 6351,
     /*  352113 */     GIR_EraseRootFromParent_Done,
     /*  352114 */   // Label 6520: @352114
     /*  352114 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(352200), // Rule ID 6354 //
     /*  352119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  352122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  352142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352166 */     // MIs[1] Operand 1
     /*  352166 */     // No operand predicates
     /*  352166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352198 */     GIR_RootConstrainSelectedInstOperands,
     /*  352199 */     // GIR_Coverage, 6354,
     /*  352199 */     GIR_EraseRootFromParent_Done,
     /*  352200 */   // Label 6521: @352200
     /*  352200 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(352286), // Rule ID 6355 //
     /*  352205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  352208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352252 */     // MIs[1] Operand 1
     /*  352252 */     // No operand predicates
     /*  352252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352284 */     GIR_RootConstrainSelectedInstOperands,
     /*  352285 */     // GIR_Coverage, 6355,
     /*  352285 */     GIR_EraseRootFromParent_Done,
     /*  352286 */   // Label 6522: @352286
     /*  352286 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(352372), // Rule ID 6358 //
     /*  352291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  352294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  352314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352338 */     // MIs[1] Operand 1
     /*  352338 */     // No operand predicates
     /*  352338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352370 */     GIR_RootConstrainSelectedInstOperands,
     /*  352371 */     // GIR_Coverage, 6358,
     /*  352371 */     GIR_EraseRootFromParent_Done,
     /*  352372 */   // Label 6523: @352372
     /*  352372 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(352458), // Rule ID 6359 //
     /*  352377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  352380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352424 */     // MIs[1] Operand 1
     /*  352424 */     // No operand predicates
     /*  352424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352456 */     GIR_RootConstrainSelectedInstOperands,
     /*  352457 */     // GIR_Coverage, 6359,
     /*  352457 */     GIR_EraseRootFromParent_Done,
     /*  352458 */   // Label 6524: @352458
     /*  352458 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(352544), // Rule ID 6362 //
     /*  352463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  352466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  352474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  352477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  352486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352510 */     // MIs[1] Operand 1
     /*  352510 */     // No operand predicates
     /*  352510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352519 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  352519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  352539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352542 */     GIR_RootConstrainSelectedInstOperands,
     /*  352543 */     // GIR_Coverage, 6362,
     /*  352543 */     GIR_EraseRootFromParent_Done,
     /*  352544 */   // Label 6525: @352544
     /*  352544 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(352630), // Rule ID 6363 //
     /*  352549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  352552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  352560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  352563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352596 */     // MIs[1] Operand 1
     /*  352596 */     // No operand predicates
     /*  352596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352605 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  352605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  352608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  352625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352628 */     GIR_RootConstrainSelectedInstOperands,
     /*  352629 */     // GIR_Coverage, 6363,
     /*  352629 */     GIR_EraseRootFromParent_Done,
     /*  352630 */   // Label 6526: @352630
     /*  352630 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(352716), // Rule ID 6366 //
     /*  352635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  352638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  352658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352682 */     // MIs[1] Operand 1
     /*  352682 */     // No operand predicates
     /*  352682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  352694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352714 */     GIR_RootConstrainSelectedInstOperands,
     /*  352715 */     // GIR_Coverage, 6366,
     /*  352715 */     GIR_EraseRootFromParent_Done,
     /*  352716 */   // Label 6527: @352716
     /*  352716 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(352802), // Rule ID 6367 //
     /*  352721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  352724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352768 */     // MIs[1] Operand 1
     /*  352768 */     // No operand predicates
     /*  352768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  352780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352800 */     GIR_RootConstrainSelectedInstOperands,
     /*  352801 */     // GIR_Coverage, 6367,
     /*  352801 */     GIR_EraseRootFromParent_Done,
     /*  352802 */   // Label 6528: @352802
     /*  352802 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(352888), // Rule ID 6370 //
     /*  352807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  352810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  352830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352854 */     // MIs[1] Operand 1
     /*  352854 */     // No operand predicates
     /*  352854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352863 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  352866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352886 */     GIR_RootConstrainSelectedInstOperands,
     /*  352887 */     // GIR_Coverage, 6370,
     /*  352887 */     GIR_EraseRootFromParent_Done,
     /*  352888 */   // Label 6529: @352888
     /*  352888 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(352974), // Rule ID 6371 //
     /*  352893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  352896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  352916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  352932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  352936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  352940 */     // MIs[1] Operand 1
     /*  352940 */     // No operand predicates
     /*  352940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  352942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352949 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  352952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  352958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  352961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352972 */     GIR_RootConstrainSelectedInstOperands,
     /*  352973 */     // GIR_Coverage, 6371,
     /*  352973 */     GIR_EraseRootFromParent_Done,
     /*  352974 */   // Label 6530: @352974
     /*  352974 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(353060), // Rule ID 6374 //
     /*  352979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  352982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  352987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  352990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  352993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  352996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353026 */     // MIs[1] Operand 1
     /*  353026 */     // No operand predicates
     /*  353026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353035 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  353038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353058 */     GIR_RootConstrainSelectedInstOperands,
     /*  353059 */     // GIR_Coverage, 6374,
     /*  353059 */     GIR_EraseRootFromParent_Done,
     /*  353060 */   // Label 6531: @353060
     /*  353060 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(353146), // Rule ID 6375 //
     /*  353065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  353076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  353079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  353082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353112 */     // MIs[1] Operand 1
     /*  353112 */     // No operand predicates
     /*  353112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353121 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  353124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353144 */     GIR_RootConstrainSelectedInstOperands,
     /*  353145 */     // GIR_Coverage, 6375,
     /*  353145 */     GIR_EraseRootFromParent_Done,
     /*  353146 */   // Label 6532: @353146
     /*  353146 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(353232), // Rule ID 6378 //
     /*  353151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  353154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  353162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  353165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353198 */     // MIs[1] Operand 1
     /*  353198 */     // No operand predicates
     /*  353198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353207 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  353210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353230 */     GIR_RootConstrainSelectedInstOperands,
     /*  353231 */     // GIR_Coverage, 6378,
     /*  353231 */     GIR_EraseRootFromParent_Done,
     /*  353232 */   // Label 6533: @353232
     /*  353232 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(353318), // Rule ID 6379 //
     /*  353237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  353248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  353251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353284 */     // MIs[1] Operand 1
     /*  353284 */     // No operand predicates
     /*  353284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  353296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353316 */     GIR_RootConstrainSelectedInstOperands,
     /*  353317 */     // GIR_Coverage, 6379,
     /*  353317 */     GIR_EraseRootFromParent_Done,
     /*  353318 */   // Label 6534: @353318
     /*  353318 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(353404), // Rule ID 6382 //
     /*  353323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  353326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  353334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  353337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353370 */     // MIs[1] Operand 1
     /*  353370 */     // No operand predicates
     /*  353370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353379 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  353382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353402 */     GIR_RootConstrainSelectedInstOperands,
     /*  353403 */     // GIR_Coverage, 6382,
     /*  353403 */     GIR_EraseRootFromParent_Done,
     /*  353404 */   // Label 6535: @353404
     /*  353404 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(353490), // Rule ID 6383 //
     /*  353409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  353420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  353423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353456 */     // MIs[1] Operand 1
     /*  353456 */     // No operand predicates
     /*  353456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353465 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  353468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353488 */     GIR_RootConstrainSelectedInstOperands,
     /*  353489 */     // GIR_Coverage, 6383,
     /*  353489 */     GIR_EraseRootFromParent_Done,
     /*  353490 */   // Label 6536: @353490
     /*  353490 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(353576), // Rule ID 6386 //
     /*  353495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  353498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  353506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  353509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353542 */     // MIs[1] Operand 1
     /*  353542 */     // No operand predicates
     /*  353542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353551 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  353554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353574 */     GIR_RootConstrainSelectedInstOperands,
     /*  353575 */     // GIR_Coverage, 6386,
     /*  353575 */     GIR_EraseRootFromParent_Done,
     /*  353576 */   // Label 6537: @353576
     /*  353576 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(353662), // Rule ID 6387 //
     /*  353581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  353592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  353595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353628 */     // MIs[1] Operand 1
     /*  353628 */     // No operand predicates
     /*  353628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353637 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  353640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353660 */     GIR_RootConstrainSelectedInstOperands,
     /*  353661 */     // GIR_Coverage, 6387,
     /*  353661 */     GIR_EraseRootFromParent_Done,
     /*  353662 */   // Label 6538: @353662
     /*  353662 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(353748), // Rule ID 6390 //
     /*  353667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  353670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353714 */     // MIs[1] Operand 1
     /*  353714 */     // No operand predicates
     /*  353714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  353726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353746 */     GIR_RootConstrainSelectedInstOperands,
     /*  353747 */     // GIR_Coverage, 6390,
     /*  353747 */     GIR_EraseRootFromParent_Done,
     /*  353748 */   // Label 6539: @353748
     /*  353748 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(353834), // Rule ID 6391 //
     /*  353753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353800 */     // MIs[1] Operand 1
     /*  353800 */     // No operand predicates
     /*  353800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  353812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353832 */     GIR_RootConstrainSelectedInstOperands,
     /*  353833 */     // GIR_Coverage, 6391,
     /*  353833 */     GIR_EraseRootFromParent_Done,
     /*  353834 */   // Label 6540: @353834
     /*  353834 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(353920), // Rule ID 6394 //
     /*  353839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  353842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  353862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353886 */     // MIs[1] Operand 1
     /*  353886 */     // No operand predicates
     /*  353886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353895 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  353898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353918 */     GIR_RootConstrainSelectedInstOperands,
     /*  353919 */     // GIR_Coverage, 6394,
     /*  353919 */     GIR_EraseRootFromParent_Done,
     /*  353920 */   // Label 6541: @353920
     /*  353920 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(354006), // Rule ID 6395 //
     /*  353925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  353928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  353933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  353948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  353964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  353968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  353972 */     // MIs[1] Operand 1
     /*  353972 */     // No operand predicates
     /*  353972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  353974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  353984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  353990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  353993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354004 */     GIR_RootConstrainSelectedInstOperands,
     /*  354005 */     // GIR_Coverage, 6395,
     /*  354005 */     GIR_EraseRootFromParent_Done,
     /*  354006 */   // Label 6542: @354006
     /*  354006 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(354092), // Rule ID 6398 //
     /*  354011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  354014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354058 */     // MIs[1] Operand 1
     /*  354058 */     // No operand predicates
     /*  354058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354067 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  354070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354090 */     GIR_RootConstrainSelectedInstOperands,
     /*  354091 */     // GIR_Coverage, 6398,
     /*  354091 */     GIR_EraseRootFromParent_Done,
     /*  354092 */   // Label 6543: @354092
     /*  354092 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(354178), // Rule ID 6399 //
     /*  354097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  354100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354144 */     // MIs[1] Operand 1
     /*  354144 */     // No operand predicates
     /*  354144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354153 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  354156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354176 */     GIR_RootConstrainSelectedInstOperands,
     /*  354177 */     // GIR_Coverage, 6399,
     /*  354177 */     GIR_EraseRootFromParent_Done,
     /*  354178 */   // Label 6544: @354178
     /*  354178 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(354264), // Rule ID 6402 //
     /*  354183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  354186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354230 */     // MIs[1] Operand 1
     /*  354230 */     // No operand predicates
     /*  354230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  354239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  354242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354262 */     GIR_RootConstrainSelectedInstOperands,
     /*  354263 */     // GIR_Coverage, 6402,
     /*  354263 */     GIR_EraseRootFromParent_Done,
     /*  354264 */   // Label 6545: @354264
     /*  354264 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(354350), // Rule ID 6403 //
     /*  354269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  354272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354316 */     // MIs[1] Operand 1
     /*  354316 */     // No operand predicates
     /*  354316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354325 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  354325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  354328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354348 */     GIR_RootConstrainSelectedInstOperands,
     /*  354349 */     // GIR_Coverage, 6403,
     /*  354349 */     GIR_EraseRootFromParent_Done,
     /*  354350 */   // Label 6546: @354350
     /*  354350 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(354436), // Rule ID 6406 //
     /*  354355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  354358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354402 */     // MIs[1] Operand 1
     /*  354402 */     // No operand predicates
     /*  354402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354411 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  354411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  354414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354434 */     GIR_RootConstrainSelectedInstOperands,
     /*  354435 */     // GIR_Coverage, 6406,
     /*  354435 */     GIR_EraseRootFromParent_Done,
     /*  354436 */   // Label 6547: @354436
     /*  354436 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(354522), // Rule ID 6407 //
     /*  354441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  354444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354488 */     // MIs[1] Operand 1
     /*  354488 */     // No operand predicates
     /*  354488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354497 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  354497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  354500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354520 */     GIR_RootConstrainSelectedInstOperands,
     /*  354521 */     // GIR_Coverage, 6407,
     /*  354521 */     GIR_EraseRootFromParent_Done,
     /*  354522 */   // Label 6548: @354522
     /*  354522 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(354608), // Rule ID 6410 //
     /*  354527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  354530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354574 */     // MIs[1] Operand 1
     /*  354574 */     // No operand predicates
     /*  354574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354583 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  354583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  354586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354606 */     GIR_RootConstrainSelectedInstOperands,
     /*  354607 */     // GIR_Coverage, 6410,
     /*  354607 */     GIR_EraseRootFromParent_Done,
     /*  354608 */   // Label 6549: @354608
     /*  354608 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(354694), // Rule ID 6411 //
     /*  354613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  354616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  354621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  354660 */     // MIs[1] Operand 1
     /*  354660 */     // No operand predicates
     /*  354660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354669 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  354669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  354672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  354689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354692 */     GIR_RootConstrainSelectedInstOperands,
     /*  354693 */     // GIR_Coverage, 6411,
     /*  354693 */     GIR_EraseRootFromParent_Done,
     /*  354694 */   // Label 6550: @354694
     /*  354694 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(354780), // Rule ID 6590 //
     /*  354699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  354702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  354707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  354710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  354713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  354716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  354746 */     // MIs[1] Operand 1
     /*  354746 */     // No operand predicates
     /*  354746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354755 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  354758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354778 */     GIR_RootConstrainSelectedInstOperands,
     /*  354779 */     // GIR_Coverage, 6590,
     /*  354779 */     GIR_EraseRootFromParent_Done,
     /*  354780 */   // Label 6551: @354780
     /*  354780 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(354866), // Rule ID 6591 //
     /*  354785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  354788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  354793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  354796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  354799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  354802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  354832 */     // MIs[1] Operand 1
     /*  354832 */     // No operand predicates
     /*  354832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354841 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  354844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354864 */     GIR_RootConstrainSelectedInstOperands,
     /*  354865 */     // GIR_Coverage, 6591,
     /*  354865 */     GIR_EraseRootFromParent_Done,
     /*  354866 */   // Label 6552: @354866
     /*  354866 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(354952), // Rule ID 6594 //
     /*  354871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  354874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  354879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  354882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  354885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  354888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  354894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  354914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  354918 */     // MIs[1] Operand 1
     /*  354918 */     // No operand predicates
     /*  354918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  354920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  354930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  354936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  354939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354950 */     GIR_RootConstrainSelectedInstOperands,
     /*  354951 */     // GIR_Coverage, 6594,
     /*  354951 */     GIR_EraseRootFromParent_Done,
     /*  354952 */   // Label 6553: @354952
     /*  354952 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(355038), // Rule ID 6595 //
     /*  354957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  354960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  354965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  354968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  354971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  354974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  354980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  354996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355004 */     // MIs[1] Operand 1
     /*  355004 */     // No operand predicates
     /*  355004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355013 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  355016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355036 */     GIR_RootConstrainSelectedInstOperands,
     /*  355037 */     // GIR_Coverage, 6595,
     /*  355037 */     GIR_EraseRootFromParent_Done,
     /*  355038 */   // Label 6554: @355038
     /*  355038 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(355124), // Rule ID 6598 //
     /*  355043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  355060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355090 */     // MIs[1] Operand 1
     /*  355090 */     // No operand predicates
     /*  355090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355099 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355122 */     GIR_RootConstrainSelectedInstOperands,
     /*  355123 */     // GIR_Coverage, 6598,
     /*  355123 */     GIR_EraseRootFromParent_Done,
     /*  355124 */   // Label 6555: @355124
     /*  355124 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(355210), // Rule ID 6599 //
     /*  355129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  355146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  355152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355176 */     // MIs[1] Operand 1
     /*  355176 */     // No operand predicates
     /*  355176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355185 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355208 */     GIR_RootConstrainSelectedInstOperands,
     /*  355209 */     // GIR_Coverage, 6599,
     /*  355209 */     GIR_EraseRootFromParent_Done,
     /*  355210 */   // Label 6556: @355210
     /*  355210 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(355296), // Rule ID 6602 //
     /*  355215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  355232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355262 */     // MIs[1] Operand 1
     /*  355262 */     // No operand predicates
     /*  355262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355271 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  355274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355294 */     GIR_RootConstrainSelectedInstOperands,
     /*  355295 */     // GIR_Coverage, 6602,
     /*  355295 */     GIR_EraseRootFromParent_Done,
     /*  355296 */   // Label 6557: @355296
     /*  355296 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(355382), // Rule ID 6603 //
     /*  355301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  355318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  355324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355348 */     // MIs[1] Operand 1
     /*  355348 */     // No operand predicates
     /*  355348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355357 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  355360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355380 */     GIR_RootConstrainSelectedInstOperands,
     /*  355381 */     // GIR_Coverage, 6603,
     /*  355381 */     GIR_EraseRootFromParent_Done,
     /*  355382 */   // Label 6558: @355382
     /*  355382 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(355468), // Rule ID 6606 //
     /*  355387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355434 */     // MIs[1] Operand 1
     /*  355434 */     // No operand predicates
     /*  355434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355443 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355466 */     GIR_RootConstrainSelectedInstOperands,
     /*  355467 */     // GIR_Coverage, 6606,
     /*  355467 */     GIR_EraseRootFromParent_Done,
     /*  355468 */   // Label 6559: @355468
     /*  355468 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(355554), // Rule ID 6607 //
     /*  355473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  355496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355520 */     // MIs[1] Operand 1
     /*  355520 */     // No operand predicates
     /*  355520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355529 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355552 */     GIR_RootConstrainSelectedInstOperands,
     /*  355553 */     // GIR_Coverage, 6607,
     /*  355553 */     GIR_EraseRootFromParent_Done,
     /*  355554 */   // Label 6560: @355554
     /*  355554 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(355640), // Rule ID 6610 //
     /*  355559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355606 */     // MIs[1] Operand 1
     /*  355606 */     // No operand predicates
     /*  355606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355615 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355638 */     GIR_RootConstrainSelectedInstOperands,
     /*  355639 */     // GIR_Coverage, 6610,
     /*  355639 */     GIR_EraseRootFromParent_Done,
     /*  355640 */   // Label 6561: @355640
     /*  355640 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(355726), // Rule ID 6611 //
     /*  355645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  355668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355692 */     // MIs[1] Operand 1
     /*  355692 */     // No operand predicates
     /*  355692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355701 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  355704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355724 */     GIR_RootConstrainSelectedInstOperands,
     /*  355725 */     // GIR_Coverage, 6611,
     /*  355725 */     GIR_EraseRootFromParent_Done,
     /*  355726 */   // Label 6562: @355726
     /*  355726 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(355812), // Rule ID 6614 //
     /*  355731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  355748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355778 */     // MIs[1] Operand 1
     /*  355778 */     // No operand predicates
     /*  355778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355787 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  355790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355810 */     GIR_RootConstrainSelectedInstOperands,
     /*  355811 */     // GIR_Coverage, 6614,
     /*  355811 */     GIR_EraseRootFromParent_Done,
     /*  355812 */   // Label 6563: @355812
     /*  355812 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(355898), // Rule ID 6615 //
     /*  355817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  355834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  355840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355864 */     // MIs[1] Operand 1
     /*  355864 */     // No operand predicates
     /*  355864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355873 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  355876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355896 */     GIR_RootConstrainSelectedInstOperands,
     /*  355897 */     // GIR_Coverage, 6615,
     /*  355897 */     GIR_EraseRootFromParent_Done,
     /*  355898 */   // Label 6564: @355898
     /*  355898 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(355984), // Rule ID 6618 //
     /*  355903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  355920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  355926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  355942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  355946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  355950 */     // MIs[1] Operand 1
     /*  355950 */     // No operand predicates
     /*  355950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  355952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355959 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  355962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  355968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  355971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355982 */     GIR_RootConstrainSelectedInstOperands,
     /*  355983 */     // GIR_Coverage, 6618,
     /*  355983 */     GIR_EraseRootFromParent_Done,
     /*  355984 */   // Label 6565: @355984
     /*  355984 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(356070), // Rule ID 6619 //
     /*  355989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  355997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  356000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  356003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  356006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356036 */     // MIs[1] Operand 1
     /*  356036 */     // No operand predicates
     /*  356036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  356048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356068 */     GIR_RootConstrainSelectedInstOperands,
     /*  356069 */     // GIR_Coverage, 6619,
     /*  356069 */     GIR_EraseRootFromParent_Done,
     /*  356070 */   // Label 6566: @356070
     /*  356070 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(356156), // Rule ID 6622 //
     /*  356075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  356092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356122 */     // MIs[1] Operand 1
     /*  356122 */     // No operand predicates
     /*  356122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356131 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  356134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356154 */     GIR_RootConstrainSelectedInstOperands,
     /*  356155 */     // GIR_Coverage, 6622,
     /*  356155 */     GIR_EraseRootFromParent_Done,
     /*  356156 */   // Label 6567: @356156
     /*  356156 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(356242), // Rule ID 6623 //
     /*  356161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  356178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356208 */     // MIs[1] Operand 1
     /*  356208 */     // No operand predicates
     /*  356208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  356220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356240 */     GIR_RootConstrainSelectedInstOperands,
     /*  356241 */     // GIR_Coverage, 6623,
     /*  356241 */     GIR_EraseRootFromParent_Done,
     /*  356242 */   // Label 6568: @356242
     /*  356242 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(356328), // Rule ID 6626 //
     /*  356247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  356250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  356258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  356261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356294 */     // MIs[1] Operand 1
     /*  356294 */     // No operand predicates
     /*  356294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356303 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  356303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  356306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  356323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356326 */     GIR_RootConstrainSelectedInstOperands,
     /*  356327 */     // GIR_Coverage, 6626,
     /*  356327 */     GIR_EraseRootFromParent_Done,
     /*  356328 */   // Label 6569: @356328
     /*  356328 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(356414), // Rule ID 6627 //
     /*  356333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  356336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  356344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  356347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356380 */     // MIs[1] Operand 1
     /*  356380 */     // No operand predicates
     /*  356380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  356389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  356392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  356409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356412 */     GIR_RootConstrainSelectedInstOperands,
     /*  356413 */     // GIR_Coverage, 6627,
     /*  356413 */     GIR_EraseRootFromParent_Done,
     /*  356414 */   // Label 6570: @356414
     /*  356414 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(356500), // Rule ID 6630 //
     /*  356419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  356430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  356433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  356436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356466 */     // MIs[1] Operand 1
     /*  356466 */     // No operand predicates
     /*  356466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356475 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  356475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  356478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356498 */     GIR_RootConstrainSelectedInstOperands,
     /*  356499 */     // GIR_Coverage, 6630,
     /*  356499 */     GIR_EraseRootFromParent_Done,
     /*  356500 */   // Label 6571: @356500
     /*  356500 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(356586), // Rule ID 6631 //
     /*  356505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  356516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  356519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  356522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356552 */     // MIs[1] Operand 1
     /*  356552 */     // No operand predicates
     /*  356552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356561 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  356561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  356564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356584 */     GIR_RootConstrainSelectedInstOperands,
     /*  356585 */     // GIR_Coverage, 6631,
     /*  356585 */     GIR_EraseRootFromParent_Done,
     /*  356586 */   // Label 6572: @356586
     /*  356586 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(356672), // Rule ID 6634 //
     /*  356591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  356602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  356605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  356608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356638 */     // MIs[1] Operand 1
     /*  356638 */     // No operand predicates
     /*  356638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356647 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  356647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  356650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356670 */     GIR_RootConstrainSelectedInstOperands,
     /*  356671 */     // GIR_Coverage, 6634,
     /*  356671 */     GIR_EraseRootFromParent_Done,
     /*  356672 */   // Label 6573: @356672
     /*  356672 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(356758), // Rule ID 6635 //
     /*  356677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  356688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  356691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  356694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356724 */     // MIs[1] Operand 1
     /*  356724 */     // No operand predicates
     /*  356724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356733 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  356733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  356736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356756 */     GIR_RootConstrainSelectedInstOperands,
     /*  356757 */     // GIR_Coverage, 6635,
     /*  356757 */     GIR_EraseRootFromParent_Done,
     /*  356758 */   // Label 6574: @356758
     /*  356758 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(356844), // Rule ID 6638 //
     /*  356763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  356774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  356777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  356780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356810 */     // MIs[1] Operand 1
     /*  356810 */     // No operand predicates
     /*  356810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  356819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  356822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356842 */     GIR_RootConstrainSelectedInstOperands,
     /*  356843 */     // GIR_Coverage, 6638,
     /*  356843 */     GIR_EraseRootFromParent_Done,
     /*  356844 */   // Label 6575: @356844
     /*  356844 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(356930), // Rule ID 6639 //
     /*  356849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  356860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  356863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  356866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  356872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356896 */     // MIs[1] Operand 1
     /*  356896 */     // No operand predicates
     /*  356896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356905 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  356905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  356908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  356914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  356917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356928 */     GIR_RootConstrainSelectedInstOperands,
     /*  356929 */     // GIR_Coverage, 6639,
     /*  356929 */     GIR_EraseRootFromParent_Done,
     /*  356930 */   // Label 6576: @356930
     /*  356930 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(357016), // Rule ID 6642 //
     /*  356935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  356943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  356952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  356958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  356974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  356978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  356982 */     // MIs[1] Operand 1
     /*  356982 */     // No operand predicates
     /*  356982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  356984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  356994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357014 */     GIR_RootConstrainSelectedInstOperands,
     /*  357015 */     // GIR_Coverage, 6642,
     /*  357015 */     GIR_EraseRootFromParent_Done,
     /*  357016 */   // Label 6577: @357016
     /*  357016 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(357102), // Rule ID 6643 //
     /*  357021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  357032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  357035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  357038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357068 */     // MIs[1] Operand 1
     /*  357068 */     // No operand predicates
     /*  357068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  357080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357100 */     GIR_RootConstrainSelectedInstOperands,
     /*  357101 */     // GIR_Coverage, 6643,
     /*  357101 */     GIR_EraseRootFromParent_Done,
     /*  357102 */   // Label 6578: @357102
     /*  357102 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(357188), // Rule ID 6646 //
     /*  357107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  357118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  357121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357154 */     // MIs[1] Operand 1
     /*  357154 */     // No operand predicates
     /*  357154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  357166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357186 */     GIR_RootConstrainSelectedInstOperands,
     /*  357187 */     // GIR_Coverage, 6646,
     /*  357187 */     GIR_EraseRootFromParent_Done,
     /*  357188 */   // Label 6579: @357188
     /*  357188 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(357274), // Rule ID 6647 //
     /*  357193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  357204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  357207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357240 */     // MIs[1] Operand 1
     /*  357240 */     // No operand predicates
     /*  357240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357249 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  357252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357272 */     GIR_RootConstrainSelectedInstOperands,
     /*  357273 */     // GIR_Coverage, 6647,
     /*  357273 */     GIR_EraseRootFromParent_Done,
     /*  357274 */   // Label 6580: @357274
     /*  357274 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(357360), // Rule ID 6650 //
     /*  357279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  357290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  357293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357326 */     // MIs[1] Operand 1
     /*  357326 */     // No operand predicates
     /*  357326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357335 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  357338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357358 */     GIR_RootConstrainSelectedInstOperands,
     /*  357359 */     // GIR_Coverage, 6650,
     /*  357359 */     GIR_EraseRootFromParent_Done,
     /*  357360 */   // Label 6581: @357360
     /*  357360 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(357446), // Rule ID 6651 //
     /*  357365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  357376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  357379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357412 */     // MIs[1] Operand 1
     /*  357412 */     // No operand predicates
     /*  357412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  357424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357444 */     GIR_RootConstrainSelectedInstOperands,
     /*  357445 */     // GIR_Coverage, 6651,
     /*  357445 */     GIR_EraseRootFromParent_Done,
     /*  357446 */   // Label 6582: @357446
     /*  357446 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(357532), // Rule ID 6654 //
     /*  357451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  357462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  357465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  357468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357498 */     // MIs[1] Operand 1
     /*  357498 */     // No operand predicates
     /*  357498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  357507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  357510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357530 */     GIR_RootConstrainSelectedInstOperands,
     /*  357531 */     // GIR_Coverage, 6654,
     /*  357531 */     GIR_EraseRootFromParent_Done,
     /*  357532 */   // Label 6583: @357532
     /*  357532 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(357618), // Rule ID 6655 //
     /*  357537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  357548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  357551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  357554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357584 */     // MIs[1] Operand 1
     /*  357584 */     // No operand predicates
     /*  357584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  357593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  357596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357616 */     GIR_RootConstrainSelectedInstOperands,
     /*  357617 */     // GIR_Coverage, 6655,
     /*  357617 */     GIR_EraseRootFromParent_Done,
     /*  357618 */   // Label 6584: @357618
     /*  357618 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(357704), // Rule ID 6658 //
     /*  357623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  357634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  357637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  357640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357670 */     // MIs[1] Operand 1
     /*  357670 */     // No operand predicates
     /*  357670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357679 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  357679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  357682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357702 */     GIR_RootConstrainSelectedInstOperands,
     /*  357703 */     // GIR_Coverage, 6658,
     /*  357703 */     GIR_EraseRootFromParent_Done,
     /*  357704 */   // Label 6585: @357704
     /*  357704 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(357790), // Rule ID 6659 //
     /*  357709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  357720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  357723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  357726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357756 */     // MIs[1] Operand 1
     /*  357756 */     // No operand predicates
     /*  357756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357765 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  357765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  357768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357788 */     GIR_RootConstrainSelectedInstOperands,
     /*  357789 */     // GIR_Coverage, 6659,
     /*  357789 */     GIR_EraseRootFromParent_Done,
     /*  357790 */   // Label 6586: @357790
     /*  357790 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(357876), // Rule ID 6662 //
     /*  357795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  357806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  357809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  357812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357842 */     // MIs[1] Operand 1
     /*  357842 */     // No operand predicates
     /*  357842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357851 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  357851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  357854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357874 */     GIR_RootConstrainSelectedInstOperands,
     /*  357875 */     // GIR_Coverage, 6662,
     /*  357875 */     GIR_EraseRootFromParent_Done,
     /*  357876 */   // Label 6587: @357876
     /*  357876 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(357962), // Rule ID 6663 //
     /*  357881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  357892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  357895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  357898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  357904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  357920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  357924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  357928 */     // MIs[1] Operand 1
     /*  357928 */     // No operand predicates
     /*  357928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  357930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357937 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  357937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  357940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  357946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  357949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  357957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357960 */     GIR_RootConstrainSelectedInstOperands,
     /*  357961 */     // GIR_Coverage, 6663,
     /*  357961 */     GIR_EraseRootFromParent_Done,
     /*  357962 */   // Label 6588: @357962
     /*  357962 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(358048), // Rule ID 6666 //
     /*  357967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  357970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  357975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  357978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  357981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  357984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  357990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358014 */     // MIs[1] Operand 1
     /*  358014 */     // No operand predicates
     /*  358014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  358023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  358026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358046 */     GIR_RootConstrainSelectedInstOperands,
     /*  358047 */     // GIR_Coverage, 6666,
     /*  358047 */     GIR_EraseRootFromParent_Done,
     /*  358048 */   // Label 6589: @358048
     /*  358048 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(358134), // Rule ID 6667 //
     /*  358053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  358056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  358061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  358064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  358067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  358070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358100 */     // MIs[1] Operand 1
     /*  358100 */     // No operand predicates
     /*  358100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  358109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  358112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358132 */     GIR_RootConstrainSelectedInstOperands,
     /*  358133 */     // GIR_Coverage, 6667,
     /*  358133 */     GIR_EraseRootFromParent_Done,
     /*  358134 */   // Label 6590: @358134
     /*  358134 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(358220), // Rule ID 6670 //
     /*  358139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  358142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  358147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  358150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  358153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  358162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358186 */     // MIs[1] Operand 1
     /*  358186 */     // No operand predicates
     /*  358186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358195 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  358195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  358198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358218 */     GIR_RootConstrainSelectedInstOperands,
     /*  358219 */     // GIR_Coverage, 6670,
     /*  358219 */     GIR_EraseRootFromParent_Done,
     /*  358220 */   // Label 6591: @358220
     /*  358220 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(358306), // Rule ID 6671 //
     /*  358225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  358228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  358233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  358236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  358239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358272 */     // MIs[1] Operand 1
     /*  358272 */     // No operand predicates
     /*  358272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358281 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  358281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  358284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358304 */     GIR_RootConstrainSelectedInstOperands,
     /*  358305 */     // GIR_Coverage, 6671,
     /*  358305 */     GIR_EraseRootFromParent_Done,
     /*  358306 */   // Label 6592: @358306
     /*  358306 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(358392), // Rule ID 6674 //
     /*  358311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  358314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  358319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  358322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  358325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  358334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358358 */     // MIs[1] Operand 1
     /*  358358 */     // No operand predicates
     /*  358358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358367 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  358367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  358370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358390 */     GIR_RootConstrainSelectedInstOperands,
     /*  358391 */     // GIR_Coverage, 6674,
     /*  358391 */     GIR_EraseRootFromParent_Done,
     /*  358392 */   // Label 6593: @358392
     /*  358392 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(358478), // Rule ID 6675 //
     /*  358397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  358400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  358405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  358408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  358411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358444 */     // MIs[1] Operand 1
     /*  358444 */     // No operand predicates
     /*  358444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358453 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  358453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  358456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  358473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358476 */     GIR_RootConstrainSelectedInstOperands,
     /*  358477 */     // GIR_Coverage, 6675,
     /*  358477 */     GIR_EraseRootFromParent_Done,
     /*  358478 */   // Label 6594: @358478
     /*  358478 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(358564), // Rule ID 6854 //
     /*  358483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  358494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  358497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  358500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  358506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358530 */     // MIs[1] Operand 1
     /*  358530 */     // No operand predicates
     /*  358530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  358539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  358542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358562 */     GIR_RootConstrainSelectedInstOperands,
     /*  358563 */     // GIR_Coverage, 6854,
     /*  358563 */     GIR_EraseRootFromParent_Done,
     /*  358564 */   // Label 6595: @358564
     /*  358564 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(358650), // Rule ID 6855 //
     /*  358569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  358580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  358583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  358586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358616 */     // MIs[1] Operand 1
     /*  358616 */     // No operand predicates
     /*  358616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358625 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  358625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  358628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358648 */     GIR_RootConstrainSelectedInstOperands,
     /*  358649 */     // GIR_Coverage, 6855,
     /*  358649 */     GIR_EraseRootFromParent_Done,
     /*  358650 */   // Label 6596: @358650
     /*  358650 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(358736), // Rule ID 6858 //
     /*  358655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  358666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  358669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  358672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  358678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358702 */     // MIs[1] Operand 1
     /*  358702 */     // No operand predicates
     /*  358702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358711 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  358711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  358714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358734 */     GIR_RootConstrainSelectedInstOperands,
     /*  358735 */     // GIR_Coverage, 6858,
     /*  358735 */     GIR_EraseRootFromParent_Done,
     /*  358736 */   // Label 6597: @358736
     /*  358736 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(358822), // Rule ID 6859 //
     /*  358741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  358752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  358755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  358758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358788 */     // MIs[1] Operand 1
     /*  358788 */     // No operand predicates
     /*  358788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358797 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  358797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  358800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358820 */     GIR_RootConstrainSelectedInstOperands,
     /*  358821 */     // GIR_Coverage, 6859,
     /*  358821 */     GIR_EraseRootFromParent_Done,
     /*  358822 */   // Label 6598: @358822
     /*  358822 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(358908), // Rule ID 6862 //
     /*  358827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  358838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  358841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  358844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  358850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358874 */     // MIs[1] Operand 1
     /*  358874 */     // No operand predicates
     /*  358874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358883 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  358883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  358886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358906 */     GIR_RootConstrainSelectedInstOperands,
     /*  358907 */     // GIR_Coverage, 6862,
     /*  358907 */     GIR_EraseRootFromParent_Done,
     /*  358908 */   // Label 6599: @358908
     /*  358908 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(358994), // Rule ID 6863 //
     /*  358913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  358921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  358924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  358927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  358930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  358936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  358952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  358956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  358960 */     // MIs[1] Operand 1
     /*  358960 */     // No operand predicates
     /*  358960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  358962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358969 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  358969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  358972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  358978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  358981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  358989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358992 */     GIR_RootConstrainSelectedInstOperands,
     /*  358993 */     // GIR_Coverage, 6863,
     /*  358993 */     GIR_EraseRootFromParent_Done,
     /*  358994 */   // Label 6600: @358994
     /*  358994 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(359080), // Rule ID 6866 //
     /*  358999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  359010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  359013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  359016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359046 */     // MIs[1] Operand 1
     /*  359046 */     // No operand predicates
     /*  359046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359055 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  359058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359078 */     GIR_RootConstrainSelectedInstOperands,
     /*  359079 */     // GIR_Coverage, 6866,
     /*  359079 */     GIR_EraseRootFromParent_Done,
     /*  359080 */   // Label 6601: @359080
     /*  359080 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(359166), // Rule ID 6867 //
     /*  359085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  359096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  359099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  359102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359132 */     // MIs[1] Operand 1
     /*  359132 */     // No operand predicates
     /*  359132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359141 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  359144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359164 */     GIR_RootConstrainSelectedInstOperands,
     /*  359165 */     // GIR_Coverage, 6867,
     /*  359165 */     GIR_EraseRootFromParent_Done,
     /*  359166 */   // Label 6602: @359166
     /*  359166 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(359252), // Rule ID 6870 //
     /*  359171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  359188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359218 */     // MIs[1] Operand 1
     /*  359218 */     // No operand predicates
     /*  359218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359227 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  359230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359250 */     GIR_RootConstrainSelectedInstOperands,
     /*  359251 */     // GIR_Coverage, 6870,
     /*  359251 */     GIR_EraseRootFromParent_Done,
     /*  359252 */   // Label 6603: @359252
     /*  359252 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(359338), // Rule ID 6871 //
     /*  359257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  359274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359304 */     // MIs[1] Operand 1
     /*  359304 */     // No operand predicates
     /*  359304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359313 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  359316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359336 */     GIR_RootConstrainSelectedInstOperands,
     /*  359337 */     // GIR_Coverage, 6871,
     /*  359337 */     GIR_EraseRootFromParent_Done,
     /*  359338 */   // Label 6604: @359338
     /*  359338 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(359424), // Rule ID 6874 //
     /*  359343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  359360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359390 */     // MIs[1] Operand 1
     /*  359390 */     // No operand predicates
     /*  359390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  359402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359422 */     GIR_RootConstrainSelectedInstOperands,
     /*  359423 */     // GIR_Coverage, 6874,
     /*  359423 */     GIR_EraseRootFromParent_Done,
     /*  359424 */   // Label 6605: @359424
     /*  359424 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(359510), // Rule ID 6875 //
     /*  359429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  359446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359476 */     // MIs[1] Operand 1
     /*  359476 */     // No operand predicates
     /*  359476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359485 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  359488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359508 */     GIR_RootConstrainSelectedInstOperands,
     /*  359509 */     // GIR_Coverage, 6875,
     /*  359509 */     GIR_EraseRootFromParent_Done,
     /*  359510 */   // Label 6606: @359510
     /*  359510 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(359596), // Rule ID 6878 //
     /*  359515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  359526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  359529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  359532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359562 */     // MIs[1] Operand 1
     /*  359562 */     // No operand predicates
     /*  359562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  359571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  359574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  359591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359594 */     GIR_RootConstrainSelectedInstOperands,
     /*  359595 */     // GIR_Coverage, 6878,
     /*  359595 */     GIR_EraseRootFromParent_Done,
     /*  359596 */   // Label 6607: @359596
     /*  359596 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(359682), // Rule ID 6879 //
     /*  359601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  359612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  359615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  359618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359648 */     // MIs[1] Operand 1
     /*  359648 */     // No operand predicates
     /*  359648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359657 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  359657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  359660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  359677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359680 */     GIR_RootConstrainSelectedInstOperands,
     /*  359681 */     // GIR_Coverage, 6879,
     /*  359681 */     GIR_EraseRootFromParent_Done,
     /*  359682 */   // Label 6608: @359682
     /*  359682 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(359768), // Rule ID 6882 //
     /*  359687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  359704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359734 */     // MIs[1] Operand 1
     /*  359734 */     // No operand predicates
     /*  359734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  359746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359766 */     GIR_RootConstrainSelectedInstOperands,
     /*  359767 */     // GIR_Coverage, 6882,
     /*  359767 */     GIR_EraseRootFromParent_Done,
     /*  359768 */   // Label 6609: @359768
     /*  359768 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(359854), // Rule ID 6883 //
     /*  359773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  359790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359820 */     // MIs[1] Operand 1
     /*  359820 */     // No operand predicates
     /*  359820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359829 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  359832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359852 */     GIR_RootConstrainSelectedInstOperands,
     /*  359853 */     // GIR_Coverage, 6883,
     /*  359853 */     GIR_EraseRootFromParent_Done,
     /*  359854 */   // Label 6610: @359854
     /*  359854 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(359940), // Rule ID 6886 //
     /*  359859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  359882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359906 */     // MIs[1] Operand 1
     /*  359906 */     // No operand predicates
     /*  359906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  359918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  359924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  359927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359938 */     GIR_RootConstrainSelectedInstOperands,
     /*  359939 */     // GIR_Coverage, 6886,
     /*  359939 */     GIR_EraseRootFromParent_Done,
     /*  359940 */   // Label 6611: @359940
     /*  359940 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(360026), // Rule ID 6887 //
     /*  359945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  359953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  359968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  359984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  359988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  359992 */     // MIs[1] Operand 1
     /*  359992 */     // No operand predicates
     /*  359992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  359994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  360001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  360004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  360021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360024 */     GIR_RootConstrainSelectedInstOperands,
     /*  360025 */     // GIR_Coverage, 6887,
     /*  360025 */     GIR_EraseRootFromParent_Done,
     /*  360026 */   // Label 6612: @360026
     /*  360026 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(360112), // Rule ID 6890 //
     /*  360031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  360034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  360042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  360045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  360048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360078 */     // MIs[1] Operand 1
     /*  360078 */     // No operand predicates
     /*  360078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360087 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  360087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  360090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  360107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360110 */     GIR_RootConstrainSelectedInstOperands,
     /*  360111 */     // GIR_Coverage, 6890,
     /*  360111 */     GIR_EraseRootFromParent_Done,
     /*  360112 */   // Label 6613: @360112
     /*  360112 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(360198), // Rule ID 6891 //
     /*  360117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  360120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  360128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  360131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  360134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  360140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360164 */     // MIs[1] Operand 1
     /*  360164 */     // No operand predicates
     /*  360164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360173 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  360173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  360176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  360193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360196 */     GIR_RootConstrainSelectedInstOperands,
     /*  360197 */     // GIR_Coverage, 6891,
     /*  360197 */     GIR_EraseRootFromParent_Done,
     /*  360198 */   // Label 6614: @360198
     /*  360198 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(360284), // Rule ID 6894 //
     /*  360203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  360214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  360217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  360220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360250 */     // MIs[1] Operand 1
     /*  360250 */     // No operand predicates
     /*  360250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  360259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  360262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360282 */     GIR_RootConstrainSelectedInstOperands,
     /*  360283 */     // GIR_Coverage, 6894,
     /*  360283 */     GIR_EraseRootFromParent_Done,
     /*  360284 */   // Label 6615: @360284
     /*  360284 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(360370), // Rule ID 6895 //
     /*  360289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  360300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  360303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  360306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  360312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360336 */     // MIs[1] Operand 1
     /*  360336 */     // No operand predicates
     /*  360336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  360345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  360348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360368 */     GIR_RootConstrainSelectedInstOperands,
     /*  360369 */     // GIR_Coverage, 6895,
     /*  360369 */     GIR_EraseRootFromParent_Done,
     /*  360370 */   // Label 6616: @360370
     /*  360370 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(360456), // Rule ID 6898 //
     /*  360375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  360386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  360389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  360392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360422 */     // MIs[1] Operand 1
     /*  360422 */     // No operand predicates
     /*  360422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360431 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  360431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  360434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360454 */     GIR_RootConstrainSelectedInstOperands,
     /*  360455 */     // GIR_Coverage, 6898,
     /*  360455 */     GIR_EraseRootFromParent_Done,
     /*  360456 */   // Label 6617: @360456
     /*  360456 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(360542), // Rule ID 6899 //
     /*  360461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  360472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  360475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  360478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  360484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360508 */     // MIs[1] Operand 1
     /*  360508 */     // No operand predicates
     /*  360508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360517 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  360517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  360520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360540 */     GIR_RootConstrainSelectedInstOperands,
     /*  360541 */     // GIR_Coverage, 6899,
     /*  360541 */     GIR_EraseRootFromParent_Done,
     /*  360542 */   // Label 6618: @360542
     /*  360542 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(360628), // Rule ID 6902 //
     /*  360547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  360558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  360561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  360564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360594 */     // MIs[1] Operand 1
     /*  360594 */     // No operand predicates
     /*  360594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360603 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  360603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  360606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360626 */     GIR_RootConstrainSelectedInstOperands,
     /*  360627 */     // GIR_Coverage, 6902,
     /*  360627 */     GIR_EraseRootFromParent_Done,
     /*  360628 */   // Label 6619: @360628
     /*  360628 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(360714), // Rule ID 6903 //
     /*  360633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  360644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  360647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  360650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  360656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360680 */     // MIs[1] Operand 1
     /*  360680 */     // No operand predicates
     /*  360680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360689 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  360689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  360692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  360709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360712 */     GIR_RootConstrainSelectedInstOperands,
     /*  360713 */     // GIR_Coverage, 6903,
     /*  360713 */     GIR_EraseRootFromParent_Done,
     /*  360714 */   // Label 6620: @360714
     /*  360714 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(360800), // Rule ID 6906 //
     /*  360719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  360730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  360733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  360736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360766 */     // MIs[1] Operand 1
     /*  360766 */     // No operand predicates
     /*  360766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  360775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  360778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  360795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360798 */     GIR_RootConstrainSelectedInstOperands,
     /*  360799 */     // GIR_Coverage, 6906,
     /*  360799 */     GIR_EraseRootFromParent_Done,
     /*  360800 */   // Label 6621: @360800
     /*  360800 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(360886), // Rule ID 6907 //
     /*  360805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  360816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  360819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  360822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  360828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  360840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360852 */     // MIs[1] Operand 1
     /*  360852 */     // No operand predicates
     /*  360852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360861 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  360861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  360864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  360881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360884 */     GIR_RootConstrainSelectedInstOperands,
     /*  360885 */     // GIR_Coverage, 6907,
     /*  360885 */     GIR_EraseRootFromParent_Done,
     /*  360886 */   // Label 6622: @360886
     /*  360886 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(360972), // Rule ID 6910 //
     /*  360891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  360902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  360905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  360908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  360914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  360930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  360934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  360938 */     // MIs[1] Operand 1
     /*  360938 */     // No operand predicates
     /*  360938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  360940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360947 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  360947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  360950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  360956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  360959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  360967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360970 */     GIR_RootConstrainSelectedInstOperands,
     /*  360971 */     // GIR_Coverage, 6910,
     /*  360971 */     GIR_EraseRootFromParent_Done,
     /*  360972 */   // Label 6623: @360972
     /*  360972 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(361058), // Rule ID 6911 //
     /*  360977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  360985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  360988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  360991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  360994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361024 */     // MIs[1] Operand 1
     /*  361024 */     // No operand predicates
     /*  361024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361033 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  361033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  361036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  361053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361056 */     GIR_RootConstrainSelectedInstOperands,
     /*  361057 */     // GIR_Coverage, 6911,
     /*  361057 */     GIR_EraseRootFromParent_Done,
     /*  361058 */   // Label 6624: @361058
     /*  361058 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(361144), // Rule ID 6914 //
     /*  361063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  361074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  361077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  361080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361110 */     // MIs[1] Operand 1
     /*  361110 */     // No operand predicates
     /*  361110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361119 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  361119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  361122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  361139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361142 */     GIR_RootConstrainSelectedInstOperands,
     /*  361143 */     // GIR_Coverage, 6914,
     /*  361143 */     GIR_EraseRootFromParent_Done,
     /*  361144 */   // Label 6625: @361144
     /*  361144 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(361230), // Rule ID 6915 //
     /*  361149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  361160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  361163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  361166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361196 */     // MIs[1] Operand 1
     /*  361196 */     // No operand predicates
     /*  361196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361205 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  361205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  361208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  361225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361228 */     GIR_RootConstrainSelectedInstOperands,
     /*  361229 */     // GIR_Coverage, 6915,
     /*  361229 */     GIR_EraseRootFromParent_Done,
     /*  361230 */   // Label 6626: @361230
     /*  361230 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(361316), // Rule ID 6918 //
     /*  361235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  361246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  361249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  361252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361282 */     // MIs[1] Operand 1
     /*  361282 */     // No operand predicates
     /*  361282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  361291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  361294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361314 */     GIR_RootConstrainSelectedInstOperands,
     /*  361315 */     // GIR_Coverage, 6918,
     /*  361315 */     GIR_EraseRootFromParent_Done,
     /*  361316 */   // Label 6627: @361316
     /*  361316 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(361402), // Rule ID 6919 //
     /*  361321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  361332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  361335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  361338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361368 */     // MIs[1] Operand 1
     /*  361368 */     // No operand predicates
     /*  361368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  361377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  361380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361400 */     GIR_RootConstrainSelectedInstOperands,
     /*  361401 */     // GIR_Coverage, 6919,
     /*  361401 */     GIR_EraseRootFromParent_Done,
     /*  361402 */   // Label 6628: @361402
     /*  361402 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(361488), // Rule ID 6922 //
     /*  361407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  361418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  361421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  361424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361454 */     // MIs[1] Operand 1
     /*  361454 */     // No operand predicates
     /*  361454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361463 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  361463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  361466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361486 */     GIR_RootConstrainSelectedInstOperands,
     /*  361487 */     // GIR_Coverage, 6922,
     /*  361487 */     GIR_EraseRootFromParent_Done,
     /*  361488 */   // Label 6629: @361488
     /*  361488 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(361574), // Rule ID 6923 //
     /*  361493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  361504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  361507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  361510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361540 */     // MIs[1] Operand 1
     /*  361540 */     // No operand predicates
     /*  361540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361549 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  361549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  361552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361572 */     GIR_RootConstrainSelectedInstOperands,
     /*  361573 */     // GIR_Coverage, 6923,
     /*  361573 */     GIR_EraseRootFromParent_Done,
     /*  361574 */   // Label 6630: @361574
     /*  361574 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(361660), // Rule ID 6926 //
     /*  361579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  361590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  361593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  361596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361626 */     // MIs[1] Operand 1
     /*  361626 */     // No operand predicates
     /*  361626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361635 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  361635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  361638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361658 */     GIR_RootConstrainSelectedInstOperands,
     /*  361659 */     // GIR_Coverage, 6926,
     /*  361659 */     GIR_EraseRootFromParent_Done,
     /*  361660 */   // Label 6631: @361660
     /*  361660 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(361746), // Rule ID 6927 //
     /*  361665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  361676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  361679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  361682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  361700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361712 */     // MIs[1] Operand 1
     /*  361712 */     // No operand predicates
     /*  361712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361721 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  361721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  361724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  361741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361744 */     GIR_RootConstrainSelectedInstOperands,
     /*  361745 */     // GIR_Coverage, 6927,
     /*  361745 */     GIR_EraseRootFromParent_Done,
     /*  361746 */   // Label 6632: @361746
     /*  361746 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(361832), // Rule ID 6930 //
     /*  361751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  361754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  361762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  361765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  361768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361798 */     // MIs[1] Operand 1
     /*  361798 */     // No operand predicates
     /*  361798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  361807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  361810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  361827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361830 */     GIR_RootConstrainSelectedInstOperands,
     /*  361831 */     // GIR_Coverage, 6930,
     /*  361831 */     GIR_EraseRootFromParent_Done,
     /*  361832 */   // Label 6633: @361832
     /*  361832 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(361918), // Rule ID 6931 //
     /*  361837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  361840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  361848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  361851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  361854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  361860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  361872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361884 */     // MIs[1] Operand 1
     /*  361884 */     // No operand predicates
     /*  361884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  361893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  361896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  361913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361916 */     GIR_RootConstrainSelectedInstOperands,
     /*  361917 */     // GIR_Coverage, 6931,
     /*  361917 */     GIR_EraseRootFromParent_Done,
     /*  361918 */   // Label 6634: @361918
     /*  361918 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(362004), // Rule ID 6934 //
     /*  361923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  361926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  361931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  361934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  361937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  361940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  361946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  361958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  361962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  361966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  361970 */     // MIs[1] Operand 1
     /*  361970 */     // No operand predicates
     /*  361970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  361972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  361979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  361982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  361986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  361988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  361991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  361999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362002 */     GIR_RootConstrainSelectedInstOperands,
     /*  362003 */     // GIR_Coverage, 6934,
     /*  362003 */     GIR_EraseRootFromParent_Done,
     /*  362004 */   // Label 6635: @362004
     /*  362004 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(362090), // Rule ID 6935 //
     /*  362009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  362012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  362017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  362020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  362023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  362026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  362036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  362040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  362044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362056 */     // MIs[1] Operand 1
     /*  362056 */     // No operand predicates
     /*  362056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362065 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  362065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  362068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  362085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362088 */     GIR_RootConstrainSelectedInstOperands,
     /*  362089 */     // GIR_Coverage, 6935,
     /*  362089 */     GIR_EraseRootFromParent_Done,
     /*  362090 */   // Label 6636: @362090
     /*  362090 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(362176), // Rule ID 6938 //
     /*  362095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  362098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  362103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  362106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  362109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  362112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362142 */     // MIs[1] Operand 1
     /*  362142 */     // No operand predicates
     /*  362142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362151 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  362151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  362154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  362171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362174 */     GIR_RootConstrainSelectedInstOperands,
     /*  362175 */     // GIR_Coverage, 6938,
     /*  362175 */     GIR_EraseRootFromParent_Done,
     /*  362176 */   // Label 6637: @362176
     /*  362176 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(362262), // Rule ID 6939 //
     /*  362181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  362184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  362189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  362192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  362195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  362198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  362216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362228 */     // MIs[1] Operand 1
     /*  362228 */     // No operand predicates
     /*  362228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362237 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  362237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  362240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  362257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362260 */     GIR_RootConstrainSelectedInstOperands,
     /*  362261 */     // GIR_Coverage, 6939,
     /*  362261 */     GIR_EraseRootFromParent_Done,
     /*  362262 */   // Label 6638: @362262
     /*  362262 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(362348), // Rule ID 7118 //
     /*  362267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  362278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  362281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  362284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362314 */     // MIs[1] Operand 1
     /*  362314 */     // No operand predicates
     /*  362314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362323 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  362323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  362326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362346 */     GIR_RootConstrainSelectedInstOperands,
     /*  362347 */     // GIR_Coverage, 7118,
     /*  362347 */     GIR_EraseRootFromParent_Done,
     /*  362348 */   // Label 6639: @362348
     /*  362348 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(362434), // Rule ID 7119 //
     /*  362353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  362364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  362367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  362370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362400 */     // MIs[1] Operand 1
     /*  362400 */     // No operand predicates
     /*  362400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362409 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  362409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  362412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362432 */     GIR_RootConstrainSelectedInstOperands,
     /*  362433 */     // GIR_Coverage, 7119,
     /*  362433 */     GIR_EraseRootFromParent_Done,
     /*  362434 */   // Label 6640: @362434
     /*  362434 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(362520), // Rule ID 7122 //
     /*  362439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  362450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  362453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  362456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362486 */     // MIs[1] Operand 1
     /*  362486 */     // No operand predicates
     /*  362486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362495 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  362495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  362498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362518 */     GIR_RootConstrainSelectedInstOperands,
     /*  362519 */     // GIR_Coverage, 7122,
     /*  362519 */     GIR_EraseRootFromParent_Done,
     /*  362520 */   // Label 6641: @362520
     /*  362520 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(362606), // Rule ID 7123 //
     /*  362525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  362536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  362539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  362542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362572 */     // MIs[1] Operand 1
     /*  362572 */     // No operand predicates
     /*  362572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362581 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  362581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  362584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362604 */     GIR_RootConstrainSelectedInstOperands,
     /*  362605 */     // GIR_Coverage, 7123,
     /*  362605 */     GIR_EraseRootFromParent_Done,
     /*  362606 */   // Label 6642: @362606
     /*  362606 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(362692), // Rule ID 7126 //
     /*  362611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  362622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  362625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  362628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362658 */     // MIs[1] Operand 1
     /*  362658 */     // No operand predicates
     /*  362658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362667 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  362667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  362670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362690 */     GIR_RootConstrainSelectedInstOperands,
     /*  362691 */     // GIR_Coverage, 7126,
     /*  362691 */     GIR_EraseRootFromParent_Done,
     /*  362692 */   // Label 6643: @362692
     /*  362692 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(362778), // Rule ID 7127 //
     /*  362697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  362708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  362711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  362714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362744 */     // MIs[1] Operand 1
     /*  362744 */     // No operand predicates
     /*  362744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362753 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  362753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  362756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  362773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362776 */     GIR_RootConstrainSelectedInstOperands,
     /*  362777 */     // GIR_Coverage, 7127,
     /*  362777 */     GIR_EraseRootFromParent_Done,
     /*  362778 */   // Label 6644: @362778
     /*  362778 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(362864), // Rule ID 7130 //
     /*  362783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  362794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  362797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  362800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362830 */     // MIs[1] Operand 1
     /*  362830 */     // No operand predicates
     /*  362830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362839 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  362839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  362842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  362859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362862 */     GIR_RootConstrainSelectedInstOperands,
     /*  362863 */     // GIR_Coverage, 7130,
     /*  362863 */     GIR_EraseRootFromParent_Done,
     /*  362864 */   // Label 6645: @362864
     /*  362864 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(362950), // Rule ID 7131 //
     /*  362869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  362880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  362883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  362886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  362892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  362916 */     // MIs[1] Operand 1
     /*  362916 */     // No operand predicates
     /*  362916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  362918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362925 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  362925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  362928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  362932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  362934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  362937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  362945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362948 */     GIR_RootConstrainSelectedInstOperands,
     /*  362949 */     // GIR_Coverage, 7131,
     /*  362949 */     GIR_EraseRootFromParent_Done,
     /*  362950 */   // Label 6646: @362950
     /*  362950 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(363036), // Rule ID 7134 //
     /*  362955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  362963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  362966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  362969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  362972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  362978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  362994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  362998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363002 */     // MIs[1] Operand 1
     /*  363002 */     // No operand predicates
     /*  363002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  363011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  363014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  363031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363034 */     GIR_RootConstrainSelectedInstOperands,
     /*  363035 */     // GIR_Coverage, 7134,
     /*  363035 */     GIR_EraseRootFromParent_Done,
     /*  363036 */   // Label 6647: @363036
     /*  363036 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(363122), // Rule ID 7135 //
     /*  363041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  363052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  363055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  363058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363088 */     // MIs[1] Operand 1
     /*  363088 */     // No operand predicates
     /*  363088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363097 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  363097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  363100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  363117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363120 */     GIR_RootConstrainSelectedInstOperands,
     /*  363121 */     // GIR_Coverage, 7135,
     /*  363121 */     GIR_EraseRootFromParent_Done,
     /*  363122 */   // Label 6648: @363122
     /*  363122 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(363208), // Rule ID 7138 //
     /*  363127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  363138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  363141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  363144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  363150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363174 */     // MIs[1] Operand 1
     /*  363174 */     // No operand predicates
     /*  363174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  363183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  363186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  363203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363206 */     GIR_RootConstrainSelectedInstOperands,
     /*  363207 */     // GIR_Coverage, 7138,
     /*  363207 */     GIR_EraseRootFromParent_Done,
     /*  363208 */   // Label 6649: @363208
     /*  363208 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(363294), // Rule ID 7139 //
     /*  363213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  363224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  363227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  363230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363260 */     // MIs[1] Operand 1
     /*  363260 */     // No operand predicates
     /*  363260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363269 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  363269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  363272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  363289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363292 */     GIR_RootConstrainSelectedInstOperands,
     /*  363293 */     // GIR_Coverage, 7139,
     /*  363293 */     GIR_EraseRootFromParent_Done,
     /*  363294 */   // Label 6650: @363294
     /*  363294 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(363380), // Rule ID 7142 //
     /*  363299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  363310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  363313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  363316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  363322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363346 */     // MIs[1] Operand 1
     /*  363346 */     // No operand predicates
     /*  363346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363355 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  363355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  363375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363378 */     GIR_RootConstrainSelectedInstOperands,
     /*  363379 */     // GIR_Coverage, 7142,
     /*  363379 */     GIR_EraseRootFromParent_Done,
     /*  363380 */   // Label 6651: @363380
     /*  363380 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(363466), // Rule ID 7143 //
     /*  363385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  363396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  363399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  363402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363432 */     // MIs[1] Operand 1
     /*  363432 */     // No operand predicates
     /*  363432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363441 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  363441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  363461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363464 */     GIR_RootConstrainSelectedInstOperands,
     /*  363465 */     // GIR_Coverage, 7143,
     /*  363465 */     GIR_EraseRootFromParent_Done,
     /*  363466 */   // Label 6652: @363466
     /*  363466 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(363552), // Rule ID 7146 //
     /*  363471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  363482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  363485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  363488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  363494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363518 */     // MIs[1] Operand 1
     /*  363518 */     // No operand predicates
     /*  363518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  363527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  363547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363550 */     GIR_RootConstrainSelectedInstOperands,
     /*  363551 */     // GIR_Coverage, 7146,
     /*  363551 */     GIR_EraseRootFromParent_Done,
     /*  363552 */   // Label 6653: @363552
     /*  363552 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(363638), // Rule ID 7147 //
     /*  363557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  363568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  363571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  363574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363604 */     // MIs[1] Operand 1
     /*  363604 */     // No operand predicates
     /*  363604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363613 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  363613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  363633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363636 */     GIR_RootConstrainSelectedInstOperands,
     /*  363637 */     // GIR_Coverage, 7147,
     /*  363637 */     GIR_EraseRootFromParent_Done,
     /*  363638 */   // Label 6654: @363638
     /*  363638 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(363724), // Rule ID 7150 //
     /*  363643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  363654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  363657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  363660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  363666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363690 */     // MIs[1] Operand 1
     /*  363690 */     // No operand predicates
     /*  363690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  363699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  363719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363722 */     GIR_RootConstrainSelectedInstOperands,
     /*  363723 */     // GIR_Coverage, 7150,
     /*  363723 */     GIR_EraseRootFromParent_Done,
     /*  363724 */   // Label 6655: @363724
     /*  363724 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(363810), // Rule ID 7151 //
     /*  363729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  363740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  363743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  363746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363776 */     // MIs[1] Operand 1
     /*  363776 */     // No operand predicates
     /*  363776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363785 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  363785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  363805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363808 */     GIR_RootConstrainSelectedInstOperands,
     /*  363809 */     // GIR_Coverage, 7151,
     /*  363809 */     GIR_EraseRootFromParent_Done,
     /*  363810 */   // Label 6656: @363810
     /*  363810 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(363896), // Rule ID 7154 //
     /*  363815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  363818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  363826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  363829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  363832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  363838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363862 */     // MIs[1] Operand 1
     /*  363862 */     // No operand predicates
     /*  363862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363871 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  363871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  363891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363894 */     GIR_RootConstrainSelectedInstOperands,
     /*  363895 */     // GIR_Coverage, 7154,
     /*  363895 */     GIR_EraseRootFromParent_Done,
     /*  363896 */   // Label 6657: @363896
     /*  363896 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(363982), // Rule ID 7155 //
     /*  363901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  363904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  363912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  363915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  363918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  363924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  363940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  363944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  363948 */     // MIs[1] Operand 1
     /*  363948 */     // No operand predicates
     /*  363948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  363950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363957 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  363957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  363960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  363964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  363966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  363969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  363977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363980 */     GIR_RootConstrainSelectedInstOperands,
     /*  363981 */     // GIR_Coverage, 7155,
     /*  363981 */     GIR_EraseRootFromParent_Done,
     /*  363982 */   // Label 6658: @363982
     /*  363982 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(364068), // Rule ID 7158 //
     /*  363987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  363995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  363998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  364001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  364004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364034 */     // MIs[1] Operand 1
     /*  364034 */     // No operand predicates
     /*  364034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  364046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364066 */     GIR_RootConstrainSelectedInstOperands,
     /*  364067 */     // GIR_Coverage, 7158,
     /*  364067 */     GIR_EraseRootFromParent_Done,
     /*  364068 */   // Label 6659: @364068
     /*  364068 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(364154), // Rule ID 7159 //
     /*  364073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  364084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  364087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  364090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364120 */     // MIs[1] Operand 1
     /*  364120 */     // No operand predicates
     /*  364120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  364132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364152 */     GIR_RootConstrainSelectedInstOperands,
     /*  364153 */     // GIR_Coverage, 7159,
     /*  364153 */     GIR_EraseRootFromParent_Done,
     /*  364154 */   // Label 6660: @364154
     /*  364154 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(364240), // Rule ID 7162 //
     /*  364159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  364170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  364173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  364176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364206 */     // MIs[1] Operand 1
     /*  364206 */     // No operand predicates
     /*  364206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364215 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  364218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364238 */     GIR_RootConstrainSelectedInstOperands,
     /*  364239 */     // GIR_Coverage, 7162,
     /*  364239 */     GIR_EraseRootFromParent_Done,
     /*  364240 */   // Label 6661: @364240
     /*  364240 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(364326), // Rule ID 7163 //
     /*  364245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  364256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  364259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  364262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364292 */     // MIs[1] Operand 1
     /*  364292 */     // No operand predicates
     /*  364292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364301 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  364304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364324 */     GIR_RootConstrainSelectedInstOperands,
     /*  364325 */     // GIR_Coverage, 7163,
     /*  364325 */     GIR_EraseRootFromParent_Done,
     /*  364326 */   // Label 6662: @364326
     /*  364326 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(364412), // Rule ID 7166 //
     /*  364331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  364342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  364345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  364348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364378 */     // MIs[1] Operand 1
     /*  364378 */     // No operand predicates
     /*  364378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364387 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  364390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364410 */     GIR_RootConstrainSelectedInstOperands,
     /*  364411 */     // GIR_Coverage, 7166,
     /*  364411 */     GIR_EraseRootFromParent_Done,
     /*  364412 */   // Label 6663: @364412
     /*  364412 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(364498), // Rule ID 7167 //
     /*  364417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  364428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  364431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  364434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364464 */     // MIs[1] Operand 1
     /*  364464 */     // No operand predicates
     /*  364464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364473 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  364476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364496 */     GIR_RootConstrainSelectedInstOperands,
     /*  364497 */     // GIR_Coverage, 7167,
     /*  364497 */     GIR_EraseRootFromParent_Done,
     /*  364498 */   // Label 6664: @364498
     /*  364498 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(364584), // Rule ID 7170 //
     /*  364503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  364514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  364517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  364520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364550 */     // MIs[1] Operand 1
     /*  364550 */     // No operand predicates
     /*  364550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  364559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  364562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364582 */     GIR_RootConstrainSelectedInstOperands,
     /*  364583 */     // GIR_Coverage, 7170,
     /*  364583 */     GIR_EraseRootFromParent_Done,
     /*  364584 */   // Label 6665: @364584
     /*  364584 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(364670), // Rule ID 7171 //
     /*  364589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  364600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  364603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  364606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  364624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364636 */     // MIs[1] Operand 1
     /*  364636 */     // No operand predicates
     /*  364636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364645 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  364645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  364648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364668 */     GIR_RootConstrainSelectedInstOperands,
     /*  364669 */     // GIR_Coverage, 7171,
     /*  364669 */     GIR_EraseRootFromParent_Done,
     /*  364670 */   // Label 6666: @364670
     /*  364670 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(364756), // Rule ID 7174 //
     /*  364675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  364686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  364689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  364692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364722 */     // MIs[1] Operand 1
     /*  364722 */     // No operand predicates
     /*  364722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364731 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  364731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  364734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364754 */     GIR_RootConstrainSelectedInstOperands,
     /*  364755 */     // GIR_Coverage, 7174,
     /*  364755 */     GIR_EraseRootFromParent_Done,
     /*  364756 */   // Label 6667: @364756
     /*  364756 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(364842), // Rule ID 7175 //
     /*  364761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  364772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  364775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  364778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  364796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364808 */     // MIs[1] Operand 1
     /*  364808 */     // No operand predicates
     /*  364808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364817 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  364817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  364820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364840 */     GIR_RootConstrainSelectedInstOperands,
     /*  364841 */     // GIR_Coverage, 7175,
     /*  364841 */     GIR_EraseRootFromParent_Done,
     /*  364842 */   // Label 6668: @364842
     /*  364842 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(364928), // Rule ID 7178 //
     /*  364847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  364858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  364861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  364864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  364870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364894 */     // MIs[1] Operand 1
     /*  364894 */     // No operand predicates
     /*  364894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364903 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  364903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  364906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  364915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364926 */     GIR_RootConstrainSelectedInstOperands,
     /*  364927 */     // GIR_Coverage, 7178,
     /*  364927 */     GIR_EraseRootFromParent_Done,
     /*  364928 */   // Label 6669: @364928
     /*  364928 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(365014), // Rule ID 7179 //
     /*  364933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  364941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  364944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  364947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  364950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  364956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  364968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  364972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  364976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  364980 */     // MIs[1] Operand 1
     /*  364980 */     // No operand predicates
     /*  364980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  364982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  364989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  364992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  364998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365012 */     GIR_RootConstrainSelectedInstOperands,
     /*  365013 */     // GIR_Coverage, 7179,
     /*  365013 */     GIR_EraseRootFromParent_Done,
     /*  365014 */   // Label 6670: @365014
     /*  365014 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(365100), // Rule ID 7182 //
     /*  365019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  365030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  365033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  365036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365066 */     // MIs[1] Operand 1
     /*  365066 */     // No operand predicates
     /*  365066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  365078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365098 */     GIR_RootConstrainSelectedInstOperands,
     /*  365099 */     // GIR_Coverage, 7182,
     /*  365099 */     GIR_EraseRootFromParent_Done,
     /*  365100 */   // Label 6671: @365100
     /*  365100 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(365186), // Rule ID 7183 //
     /*  365105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  365116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  365119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  365122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365152 */     // MIs[1] Operand 1
     /*  365152 */     // No operand predicates
     /*  365152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  365164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365184 */     GIR_RootConstrainSelectedInstOperands,
     /*  365185 */     // GIR_Coverage, 7183,
     /*  365185 */     GIR_EraseRootFromParent_Done,
     /*  365186 */   // Label 6672: @365186
     /*  365186 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(365272), // Rule ID 7186 //
     /*  365191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  365202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  365205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  365208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365238 */     // MIs[1] Operand 1
     /*  365238 */     // No operand predicates
     /*  365238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365247 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  365250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365270 */     GIR_RootConstrainSelectedInstOperands,
     /*  365271 */     // GIR_Coverage, 7186,
     /*  365271 */     GIR_EraseRootFromParent_Done,
     /*  365272 */   // Label 6673: @365272
     /*  365272 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(365358), // Rule ID 7187 //
     /*  365277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  365288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  365291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  365294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365324 */     // MIs[1] Operand 1
     /*  365324 */     // No operand predicates
     /*  365324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365333 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  365336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365356 */     GIR_RootConstrainSelectedInstOperands,
     /*  365357 */     // GIR_Coverage, 7187,
     /*  365357 */     GIR_EraseRootFromParent_Done,
     /*  365358 */   // Label 6674: @365358
     /*  365358 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(365444), // Rule ID 7190 //
     /*  365363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  365374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  365377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  365380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365410 */     // MIs[1] Operand 1
     /*  365410 */     // No operand predicates
     /*  365410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  365422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365442 */     GIR_RootConstrainSelectedInstOperands,
     /*  365443 */     // GIR_Coverage, 7190,
     /*  365443 */     GIR_EraseRootFromParent_Done,
     /*  365444 */   // Label 6675: @365444
     /*  365444 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(365530), // Rule ID 7191 //
     /*  365449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  365460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  365463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  365466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365496 */     // MIs[1] Operand 1
     /*  365496 */     // No operand predicates
     /*  365496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365505 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  365508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365528 */     GIR_RootConstrainSelectedInstOperands,
     /*  365529 */     // GIR_Coverage, 7191,
     /*  365529 */     GIR_EraseRootFromParent_Done,
     /*  365530 */   // Label 6676: @365530
     /*  365530 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(365616), // Rule ID 7194 //
     /*  365535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  365546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  365549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  365552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365582 */     // MIs[1] Operand 1
     /*  365582 */     // No operand predicates
     /*  365582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  365594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365614 */     GIR_RootConstrainSelectedInstOperands,
     /*  365615 */     // GIR_Coverage, 7194,
     /*  365615 */     GIR_EraseRootFromParent_Done,
     /*  365616 */   // Label 6677: @365616
     /*  365616 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(365702), // Rule ID 7195 //
     /*  365621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  365632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  365635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  365638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365668 */     // MIs[1] Operand 1
     /*  365668 */     // No operand predicates
     /*  365668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  365677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  365680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365700 */     GIR_RootConstrainSelectedInstOperands,
     /*  365701 */     // GIR_Coverage, 7195,
     /*  365701 */     GIR_EraseRootFromParent_Done,
     /*  365702 */   // Label 6678: @365702
     /*  365702 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(365788), // Rule ID 7198 //
     /*  365707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  365718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  365721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  365724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365754 */     // MIs[1] Operand 1
     /*  365754 */     // No operand predicates
     /*  365754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365763 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  365766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365786 */     GIR_RootConstrainSelectedInstOperands,
     /*  365787 */     // GIR_Coverage, 7198,
     /*  365787 */     GIR_EraseRootFromParent_Done,
     /*  365788 */   // Label 6679: @365788
     /*  365788 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(365874), // Rule ID 7199 //
     /*  365793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  365804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  365807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  365810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365840 */     // MIs[1] Operand 1
     /*  365840 */     // No operand predicates
     /*  365840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365849 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  365849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  365852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365872 */     GIR_RootConstrainSelectedInstOperands,
     /*  365873 */     // GIR_Coverage, 7199,
     /*  365873 */     GIR_EraseRootFromParent_Done,
     /*  365874 */   // Label 6680: @365874
     /*  365874 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(365960), // Rule ID 7202 //
     /*  365879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  365890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  365893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  365896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  365902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  365918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  365922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  365926 */     // MIs[1] Operand 1
     /*  365926 */     // No operand predicates
     /*  365926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  365928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365935 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  365938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  365944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  365947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365958 */     GIR_RootConstrainSelectedInstOperands,
     /*  365959 */     // GIR_Coverage, 7202,
     /*  365959 */     GIR_EraseRootFromParent_Done,
     /*  365960 */   // Label 6681: @365960
     /*  365960 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(366046), // Rule ID 7203 //
     /*  365965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  365973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  365976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  365979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  365982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  365988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366012 */     // MIs[1] Operand 1
     /*  366012 */     // No operand predicates
     /*  366012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  366021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  366024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366044 */     GIR_RootConstrainSelectedInstOperands,
     /*  366045 */     // GIR_Coverage, 7203,
     /*  366045 */     GIR_EraseRootFromParent_Done,
     /*  366046 */   // Label 6682: @366046
     /*  366046 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(366132), // Rule ID 7414 //
     /*  366051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  366062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  366065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  366068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366098 */     // MIs[1] Operand 1
     /*  366098 */     // No operand predicates
     /*  366098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366107 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  366110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366130 */     GIR_RootConstrainSelectedInstOperands,
     /*  366131 */     // GIR_Coverage, 7414,
     /*  366131 */     GIR_EraseRootFromParent_Done,
     /*  366132 */   // Label 6683: @366132
     /*  366132 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(366218), // Rule ID 7415 //
     /*  366137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  366148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  366151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  366154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  366160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366184 */     // MIs[1] Operand 1
     /*  366184 */     // No operand predicates
     /*  366184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  366196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366216 */     GIR_RootConstrainSelectedInstOperands,
     /*  366217 */     // GIR_Coverage, 7415,
     /*  366217 */     GIR_EraseRootFromParent_Done,
     /*  366218 */   // Label 6684: @366218
     /*  366218 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(366304), // Rule ID 7418 //
     /*  366223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  366234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  366237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  366240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366270 */     // MIs[1] Operand 1
     /*  366270 */     // No operand predicates
     /*  366270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366279 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  366282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366302 */     GIR_RootConstrainSelectedInstOperands,
     /*  366303 */     // GIR_Coverage, 7418,
     /*  366303 */     GIR_EraseRootFromParent_Done,
     /*  366304 */   // Label 6685: @366304
     /*  366304 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(366390), // Rule ID 7419 //
     /*  366309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  366320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  366323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  366326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  366332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366356 */     // MIs[1] Operand 1
     /*  366356 */     // No operand predicates
     /*  366356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366365 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  366368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366388 */     GIR_RootConstrainSelectedInstOperands,
     /*  366389 */     // GIR_Coverage, 7419,
     /*  366389 */     GIR_EraseRootFromParent_Done,
     /*  366390 */   // Label 6686: @366390
     /*  366390 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(366476), // Rule ID 7422 //
     /*  366395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  366406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  366409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  366412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366442 */     // MIs[1] Operand 1
     /*  366442 */     // No operand predicates
     /*  366442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366451 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  366454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366474 */     GIR_RootConstrainSelectedInstOperands,
     /*  366475 */     // GIR_Coverage, 7422,
     /*  366475 */     GIR_EraseRootFromParent_Done,
     /*  366476 */   // Label 6687: @366476
     /*  366476 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(366562), // Rule ID 7423 //
     /*  366481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  366492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  366495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  366498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  366504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366528 */     // MIs[1] Operand 1
     /*  366528 */     // No operand predicates
     /*  366528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366537 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  366540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366560 */     GIR_RootConstrainSelectedInstOperands,
     /*  366561 */     // GIR_Coverage, 7423,
     /*  366561 */     GIR_EraseRootFromParent_Done,
     /*  366562 */   // Label 6688: @366562
     /*  366562 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(366648), // Rule ID 7426 //
     /*  366567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  366578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  366581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  366584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366614 */     // MIs[1] Operand 1
     /*  366614 */     // No operand predicates
     /*  366614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366623 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  366626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366646 */     GIR_RootConstrainSelectedInstOperands,
     /*  366647 */     // GIR_Coverage, 7426,
     /*  366647 */     GIR_EraseRootFromParent_Done,
     /*  366648 */   // Label 6689: @366648
     /*  366648 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(366734), // Rule ID 7427 //
     /*  366653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  366664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  366667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  366670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  366676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366700 */     // MIs[1] Operand 1
     /*  366700 */     // No operand predicates
     /*  366700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366709 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  366712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366732 */     GIR_RootConstrainSelectedInstOperands,
     /*  366733 */     // GIR_Coverage, 7427,
     /*  366733 */     GIR_EraseRootFromParent_Done,
     /*  366734 */   // Label 6690: @366734
     /*  366734 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(366820), // Rule ID 7430 //
     /*  366739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  366756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366786 */     // MIs[1] Operand 1
     /*  366786 */     // No operand predicates
     /*  366786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  366798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366818 */     GIR_RootConstrainSelectedInstOperands,
     /*  366819 */     // GIR_Coverage, 7430,
     /*  366819 */     GIR_EraseRootFromParent_Done,
     /*  366820 */   // Label 6691: @366820
     /*  366820 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(366906), // Rule ID 7431 //
     /*  366825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  366842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  366848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366872 */     // MIs[1] Operand 1
     /*  366872 */     // No operand predicates
     /*  366872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  366884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366904 */     GIR_RootConstrainSelectedInstOperands,
     /*  366905 */     // GIR_Coverage, 7431,
     /*  366905 */     GIR_EraseRootFromParent_Done,
     /*  366906 */   // Label 6692: @366906
     /*  366906 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(366992), // Rule ID 7434 //
     /*  366911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  366919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  366928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  366934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  366950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  366954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  366958 */     // MIs[1] Operand 1
     /*  366958 */     // No operand predicates
     /*  366958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  366960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366967 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  366970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  366976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  366979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366990 */     GIR_RootConstrainSelectedInstOperands,
     /*  366991 */     // GIR_Coverage, 7434,
     /*  366991 */     GIR_EraseRootFromParent_Done,
     /*  366992 */   // Label 6693: @366992
     /*  366992 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(367078), // Rule ID 7435 //
     /*  366997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  367008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  367011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  367014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367044 */     // MIs[1] Operand 1
     /*  367044 */     // No operand predicates
     /*  367044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367053 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  367056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367076 */     GIR_RootConstrainSelectedInstOperands,
     /*  367077 */     // GIR_Coverage, 7435,
     /*  367077 */     GIR_EraseRootFromParent_Done,
     /*  367078 */   // Label 6694: @367078
     /*  367078 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(367164), // Rule ID 7438 //
     /*  367083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  367094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  367097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  367100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367130 */     // MIs[1] Operand 1
     /*  367130 */     // No operand predicates
     /*  367130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  367142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367162 */     GIR_RootConstrainSelectedInstOperands,
     /*  367163 */     // GIR_Coverage, 7438,
     /*  367163 */     GIR_EraseRootFromParent_Done,
     /*  367164 */   // Label 6695: @367164
     /*  367164 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(367250), // Rule ID 7439 //
     /*  367169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  367180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  367183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  367186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367216 */     // MIs[1] Operand 1
     /*  367216 */     // No operand predicates
     /*  367216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367225 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  367228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367248 */     GIR_RootConstrainSelectedInstOperands,
     /*  367249 */     // GIR_Coverage, 7439,
     /*  367249 */     GIR_EraseRootFromParent_Done,
     /*  367250 */   // Label 6696: @367250
     /*  367250 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(367336), // Rule ID 7442 //
     /*  367255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  367266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  367269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  367272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367302 */     // MIs[1] Operand 1
     /*  367302 */     // No operand predicates
     /*  367302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  367314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367334 */     GIR_RootConstrainSelectedInstOperands,
     /*  367335 */     // GIR_Coverage, 7442,
     /*  367335 */     GIR_EraseRootFromParent_Done,
     /*  367336 */   // Label 6697: @367336
     /*  367336 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(367422), // Rule ID 7443 //
     /*  367341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  367352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  367355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  367358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367388 */     // MIs[1] Operand 1
     /*  367388 */     // No operand predicates
     /*  367388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367397 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  367400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367420 */     GIR_RootConstrainSelectedInstOperands,
     /*  367421 */     // GIR_Coverage, 7443,
     /*  367421 */     GIR_EraseRootFromParent_Done,
     /*  367422 */   // Label 6698: @367422
     /*  367422 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(367508), // Rule ID 7446 //
     /*  367427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  367438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  367441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  367444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367474 */     // MIs[1] Operand 1
     /*  367474 */     // No operand predicates
     /*  367474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  367486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367506 */     GIR_RootConstrainSelectedInstOperands,
     /*  367507 */     // GIR_Coverage, 7446,
     /*  367507 */     GIR_EraseRootFromParent_Done,
     /*  367508 */   // Label 6699: @367508
     /*  367508 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(367594), // Rule ID 7447 //
     /*  367513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  367524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  367527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  367530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367560 */     // MIs[1] Operand 1
     /*  367560 */     // No operand predicates
     /*  367560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  367572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367592 */     GIR_RootConstrainSelectedInstOperands,
     /*  367593 */     // GIR_Coverage, 7447,
     /*  367593 */     GIR_EraseRootFromParent_Done,
     /*  367594 */   // Label 6700: @367594
     /*  367594 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(367680), // Rule ID 7450 //
     /*  367599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  367610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  367613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  367616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367646 */     // MIs[1] Operand 1
     /*  367646 */     // No operand predicates
     /*  367646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  367658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367678 */     GIR_RootConstrainSelectedInstOperands,
     /*  367679 */     // GIR_Coverage, 7450,
     /*  367679 */     GIR_EraseRootFromParent_Done,
     /*  367680 */   // Label 6701: @367680
     /*  367680 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(367766), // Rule ID 7451 //
     /*  367685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  367696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  367699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  367702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367732 */     // MIs[1] Operand 1
     /*  367732 */     // No operand predicates
     /*  367732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  367744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367764 */     GIR_RootConstrainSelectedInstOperands,
     /*  367765 */     // GIR_Coverage, 7451,
     /*  367765 */     GIR_EraseRootFromParent_Done,
     /*  367766 */   // Label 6702: @367766
     /*  367766 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(367852), // Rule ID 7454 //
     /*  367771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  367788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367818 */     // MIs[1] Operand 1
     /*  367818 */     // No operand predicates
     /*  367818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367827 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  367830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367850 */     GIR_RootConstrainSelectedInstOperands,
     /*  367851 */     // GIR_Coverage, 7454,
     /*  367851 */     GIR_EraseRootFromParent_Done,
     /*  367852 */   // Label 6703: @367852
     /*  367852 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(367938), // Rule ID 7455 //
     /*  367857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  367874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  367880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367904 */     // MIs[1] Operand 1
     /*  367904 */     // No operand predicates
     /*  367904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367913 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  367916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  367922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  367925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367936 */     GIR_RootConstrainSelectedInstOperands,
     /*  367937 */     // GIR_Coverage, 7455,
     /*  367937 */     GIR_EraseRootFromParent_Done,
     /*  367938 */   // Label 6704: @367938
     /*  367938 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(368024), // Rule ID 7458 //
     /*  367943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  367946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  367951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  367954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  367957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  367960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  367966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  367982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  367986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  367990 */     // MIs[1] Operand 1
     /*  367990 */     // No operand predicates
     /*  367990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  367992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  368002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368022 */     GIR_RootConstrainSelectedInstOperands,
     /*  368023 */     // GIR_Coverage, 7458,
     /*  368023 */     GIR_EraseRootFromParent_Done,
     /*  368024 */   // Label 6705: @368024
     /*  368024 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(368110), // Rule ID 7459 //
     /*  368029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  368032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368076 */     // MIs[1] Operand 1
     /*  368076 */     // No operand predicates
     /*  368076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368085 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  368088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368108 */     GIR_RootConstrainSelectedInstOperands,
     /*  368109 */     // GIR_Coverage, 7459,
     /*  368109 */     GIR_EraseRootFromParent_Done,
     /*  368110 */   // Label 6706: @368110
     /*  368110 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(368196), // Rule ID 7462 //
     /*  368115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  368118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  368132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368162 */     // MIs[1] Operand 1
     /*  368162 */     // No operand predicates
     /*  368162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  368174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368194 */     GIR_RootConstrainSelectedInstOperands,
     /*  368195 */     // GIR_Coverage, 7462,
     /*  368195 */     GIR_EraseRootFromParent_Done,
     /*  368196 */   // Label 6707: @368196
     /*  368196 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(368282), // Rule ID 7463 //
     /*  368201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  368204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  368218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368248 */     // MIs[1] Operand 1
     /*  368248 */     // No operand predicates
     /*  368248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368257 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  368260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368280 */     GIR_RootConstrainSelectedInstOperands,
     /*  368281 */     // GIR_Coverage, 7463,
     /*  368281 */     GIR_EraseRootFromParent_Done,
     /*  368282 */   // Label 6708: @368282
     /*  368282 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(368368), // Rule ID 7466 //
     /*  368287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  368290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  368298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  368301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  368304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368334 */     // MIs[1] Operand 1
     /*  368334 */     // No operand predicates
     /*  368334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  368346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368366 */     GIR_RootConstrainSelectedInstOperands,
     /*  368367 */     // GIR_Coverage, 7466,
     /*  368367 */     GIR_EraseRootFromParent_Done,
     /*  368368 */   // Label 6709: @368368
     /*  368368 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(368454), // Rule ID 7467 //
     /*  368373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  368376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  368384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  368387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  368390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368420 */     // MIs[1] Operand 1
     /*  368420 */     // No operand predicates
     /*  368420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  368432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368452 */     GIR_RootConstrainSelectedInstOperands,
     /*  368453 */     // GIR_Coverage, 7467,
     /*  368453 */     GIR_EraseRootFromParent_Done,
     /*  368454 */   // Label 6710: @368454
     /*  368454 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(368540), // Rule ID 7470 //
     /*  368459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  368462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  368470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  368473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  368476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368506 */     // MIs[1] Operand 1
     /*  368506 */     // No operand predicates
     /*  368506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368515 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  368518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368538 */     GIR_RootConstrainSelectedInstOperands,
     /*  368539 */     // GIR_Coverage, 7470,
     /*  368539 */     GIR_EraseRootFromParent_Done,
     /*  368540 */   // Label 6711: @368540
     /*  368540 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(368626), // Rule ID 7471 //
     /*  368545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  368548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  368553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  368556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  368559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  368562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368592 */     // MIs[1] Operand 1
     /*  368592 */     // No operand predicates
     /*  368592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368601 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  368604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368624 */     GIR_RootConstrainSelectedInstOperands,
     /*  368625 */     // GIR_Coverage, 7471,
     /*  368625 */     GIR_EraseRootFromParent_Done,
     /*  368626 */   // Label 6712: @368626
     /*  368626 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(368712), // Rule ID 7594 //
     /*  368631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  368639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368678 */     // MIs[1] Operand 1
     /*  368678 */     // No operand predicates
     /*  368678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368687 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  368690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368710 */     GIR_RootConstrainSelectedInstOperands,
     /*  368711 */     // GIR_Coverage, 7594,
     /*  368711 */     GIR_EraseRootFromParent_Done,
     /*  368712 */   // Label 6713: @368712
     /*  368712 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(368798), // Rule ID 7595 //
     /*  368717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  368725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368764 */     // MIs[1] Operand 1
     /*  368764 */     // No operand predicates
     /*  368764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368773 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  368776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368796 */     GIR_RootConstrainSelectedInstOperands,
     /*  368797 */     // GIR_Coverage, 7595,
     /*  368797 */     GIR_EraseRootFromParent_Done,
     /*  368798 */   // Label 6714: @368798
     /*  368798 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(368884), // Rule ID 7598 //
     /*  368803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  368811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368850 */     // MIs[1] Operand 1
     /*  368850 */     // No operand predicates
     /*  368850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368859 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  368862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368882 */     GIR_RootConstrainSelectedInstOperands,
     /*  368883 */     // GIR_Coverage, 7598,
     /*  368883 */     GIR_EraseRootFromParent_Done,
     /*  368884 */   // Label 6715: @368884
     /*  368884 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(368970), // Rule ID 7599 //
     /*  368889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  368897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  368912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  368928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  368932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  368936 */     // MIs[1] Operand 1
     /*  368936 */     // No operand predicates
     /*  368936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  368938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368945 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  368948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  368954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  368957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368968 */     GIR_RootConstrainSelectedInstOperands,
     /*  368969 */     // GIR_Coverage, 7599,
     /*  368969 */     GIR_EraseRootFromParent_Done,
     /*  368970 */   // Label 6716: @368970
     /*  368970 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(369056), // Rule ID 7602 //
     /*  368975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  368983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  368998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369022 */     // MIs[1] Operand 1
     /*  369022 */     // No operand predicates
     /*  369022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369031 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  369034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369054 */     GIR_RootConstrainSelectedInstOperands,
     /*  369055 */     // GIR_Coverage, 7602,
     /*  369055 */     GIR_EraseRootFromParent_Done,
     /*  369056 */   // Label 6717: @369056
     /*  369056 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(369142), // Rule ID 7603 //
     /*  369061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  369072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  369075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  369078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369108 */     // MIs[1] Operand 1
     /*  369108 */     // No operand predicates
     /*  369108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369117 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  369120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369140 */     GIR_RootConstrainSelectedInstOperands,
     /*  369141 */     // GIR_Coverage, 7603,
     /*  369141 */     GIR_EraseRootFromParent_Done,
     /*  369142 */   // Label 6718: @369142
     /*  369142 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(369228), // Rule ID 7606 //
     /*  369147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  369170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369194 */     // MIs[1] Operand 1
     /*  369194 */     // No operand predicates
     /*  369194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369203 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  369206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369226 */     GIR_RootConstrainSelectedInstOperands,
     /*  369227 */     // GIR_Coverage, 7606,
     /*  369227 */     GIR_EraseRootFromParent_Done,
     /*  369228 */   // Label 6719: @369228
     /*  369228 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(369314), // Rule ID 7607 //
     /*  369233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369280 */     // MIs[1] Operand 1
     /*  369280 */     // No operand predicates
     /*  369280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369289 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  369292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369312 */     GIR_RootConstrainSelectedInstOperands,
     /*  369313 */     // GIR_Coverage, 7607,
     /*  369313 */     GIR_EraseRootFromParent_Done,
     /*  369314 */   // Label 6720: @369314
     /*  369314 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(369400), // Rule ID 7610 //
     /*  369319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  369342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369366 */     // MIs[1] Operand 1
     /*  369366 */     // No operand predicates
     /*  369366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  369378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369398 */     GIR_RootConstrainSelectedInstOperands,
     /*  369399 */     // GIR_Coverage, 7610,
     /*  369399 */     GIR_EraseRootFromParent_Done,
     /*  369400 */   // Label 6721: @369400
     /*  369400 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(369486), // Rule ID 7611 //
     /*  369405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369452 */     // MIs[1] Operand 1
     /*  369452 */     // No operand predicates
     /*  369452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  369464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369484 */     GIR_RootConstrainSelectedInstOperands,
     /*  369485 */     // GIR_Coverage, 7611,
     /*  369485 */     GIR_EraseRootFromParent_Done,
     /*  369486 */   // Label 6722: @369486
     /*  369486 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(369572), // Rule ID 7614 //
     /*  369491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  369514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369538 */     // MIs[1] Operand 1
     /*  369538 */     // No operand predicates
     /*  369538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369547 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  369550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369570 */     GIR_RootConstrainSelectedInstOperands,
     /*  369571 */     // GIR_Coverage, 7614,
     /*  369571 */     GIR_EraseRootFromParent_Done,
     /*  369572 */   // Label 6723: @369572
     /*  369572 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(369658), // Rule ID 7615 //
     /*  369577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369624 */     // MIs[1] Operand 1
     /*  369624 */     // No operand predicates
     /*  369624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369633 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  369636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369656 */     GIR_RootConstrainSelectedInstOperands,
     /*  369657 */     // GIR_Coverage, 7615,
     /*  369657 */     GIR_EraseRootFromParent_Done,
     /*  369658 */   // Label 6724: @369658
     /*  369658 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(369744), // Rule ID 7618 //
     /*  369663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  369674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  369677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  369680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  369686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369710 */     // MIs[1] Operand 1
     /*  369710 */     // No operand predicates
     /*  369710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369719 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  369722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369742 */     GIR_RootConstrainSelectedInstOperands,
     /*  369743 */     // GIR_Coverage, 7618,
     /*  369743 */     GIR_EraseRootFromParent_Done,
     /*  369744 */   // Label 6725: @369744
     /*  369744 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(369830), // Rule ID 7619 //
     /*  369749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  369760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  369763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  369766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369796 */     // MIs[1] Operand 1
     /*  369796 */     // No operand predicates
     /*  369796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369805 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  369808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369828 */     GIR_RootConstrainSelectedInstOperands,
     /*  369829 */     // GIR_Coverage, 7619,
     /*  369829 */     GIR_EraseRootFromParent_Done,
     /*  369830 */   // Label 6726: @369830
     /*  369830 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(369916), // Rule ID 7622 //
     /*  369835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  369858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369882 */     // MIs[1] Operand 1
     /*  369882 */     // No operand predicates
     /*  369882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369891 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  369894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369914 */     GIR_RootConstrainSelectedInstOperands,
     /*  369915 */     // GIR_Coverage, 7622,
     /*  369915 */     GIR_EraseRootFromParent_Done,
     /*  369916 */   // Label 6727: @369916
     /*  369916 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(370002), // Rule ID 7623 //
     /*  369921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  369929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  369944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  369960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  369964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  369968 */     // MIs[1] Operand 1
     /*  369968 */     // No operand predicates
     /*  369968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  369970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  369980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  369986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  369989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370000 */     GIR_RootConstrainSelectedInstOperands,
     /*  370001 */     // GIR_Coverage, 7623,
     /*  370001 */     GIR_EraseRootFromParent_Done,
     /*  370002 */   // Label 6728: @370002
     /*  370002 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(370088), // Rule ID 7626 //
     /*  370007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  370018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  370021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370054 */     // MIs[1] Operand 1
     /*  370054 */     // No operand predicates
     /*  370054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370063 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  370066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370086 */     GIR_RootConstrainSelectedInstOperands,
     /*  370087 */     // GIR_Coverage, 7626,
     /*  370087 */     GIR_EraseRootFromParent_Done,
     /*  370088 */   // Label 6729: @370088
     /*  370088 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(370174), // Rule ID 7627 //
     /*  370093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  370104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  370107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370140 */     // MIs[1] Operand 1
     /*  370140 */     // No operand predicates
     /*  370140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  370152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370172 */     GIR_RootConstrainSelectedInstOperands,
     /*  370173 */     // GIR_Coverage, 7627,
     /*  370173 */     GIR_EraseRootFromParent_Done,
     /*  370174 */   // Label 6730: @370174
     /*  370174 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(370260), // Rule ID 7630 //
     /*  370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370226 */     // MIs[1] Operand 1
     /*  370226 */     // No operand predicates
     /*  370226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  370238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370258 */     GIR_RootConstrainSelectedInstOperands,
     /*  370259 */     // GIR_Coverage, 7630,
     /*  370259 */     GIR_EraseRootFromParent_Done,
     /*  370260 */   // Label 6731: @370260
     /*  370260 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(370346), // Rule ID 7631 //
     /*  370265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370312 */     // MIs[1] Operand 1
     /*  370312 */     // No operand predicates
     /*  370312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  370324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370344 */     GIR_RootConstrainSelectedInstOperands,
     /*  370345 */     // GIR_Coverage, 7631,
     /*  370345 */     GIR_EraseRootFromParent_Done,
     /*  370346 */   // Label 6732: @370346
     /*  370346 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(370432), // Rule ID 7634 //
     /*  370351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370398 */     // MIs[1] Operand 1
     /*  370398 */     // No operand predicates
     /*  370398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370407 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  370410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370430 */     GIR_RootConstrainSelectedInstOperands,
     /*  370431 */     // GIR_Coverage, 7634,
     /*  370431 */     GIR_EraseRootFromParent_Done,
     /*  370432 */   // Label 6733: @370432
     /*  370432 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(370518), // Rule ID 7635 //
     /*  370437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370484 */     // MIs[1] Operand 1
     /*  370484 */     // No operand predicates
     /*  370484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  370496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370516 */     GIR_RootConstrainSelectedInstOperands,
     /*  370517 */     // GIR_Coverage, 7635,
     /*  370517 */     GIR_EraseRootFromParent_Done,
     /*  370518 */   // Label 6734: @370518
     /*  370518 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(370604), // Rule ID 7638 //
     /*  370523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  370526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  370534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  370537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  370540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370570 */     // MIs[1] Operand 1
     /*  370570 */     // No operand predicates
     /*  370570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370579 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  370582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370602 */     GIR_RootConstrainSelectedInstOperands,
     /*  370603 */     // GIR_Coverage, 7638,
     /*  370603 */     GIR_EraseRootFromParent_Done,
     /*  370604 */   // Label 6735: @370604
     /*  370604 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(370690), // Rule ID 7639 //
     /*  370609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  370612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  370620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  370623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  370626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370656 */     // MIs[1] Operand 1
     /*  370656 */     // No operand predicates
     /*  370656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370665 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  370668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370688 */     GIR_RootConstrainSelectedInstOperands,
     /*  370689 */     // GIR_Coverage, 7639,
     /*  370689 */     GIR_EraseRootFromParent_Done,
     /*  370690 */   // Label 6736: @370690
     /*  370690 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(370776), // Rule ID 7642 //
     /*  370695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  370698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  370706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  370709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370742 */     // MIs[1] Operand 1
     /*  370742 */     // No operand predicates
     /*  370742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370751 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  370754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370774 */     GIR_RootConstrainSelectedInstOperands,
     /*  370775 */     // GIR_Coverage, 7642,
     /*  370775 */     GIR_EraseRootFromParent_Done,
     /*  370776 */   // Label 6737: @370776
     /*  370776 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(370862), // Rule ID 7643 //
     /*  370781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  370784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  370792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  370795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370828 */     // MIs[1] Operand 1
     /*  370828 */     // No operand predicates
     /*  370828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  370840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370860 */     GIR_RootConstrainSelectedInstOperands,
     /*  370861 */     // GIR_Coverage, 7643,
     /*  370861 */     GIR_EraseRootFromParent_Done,
     /*  370862 */   // Label 6738: @370862
     /*  370862 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(370948), // Rule ID 7646 //
     /*  370867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  370870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  370890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  370914 */     // MIs[1] Operand 1
     /*  370914 */     // No operand predicates
     /*  370914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  370916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  370926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  370932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  370935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370946 */     GIR_RootConstrainSelectedInstOperands,
     /*  370947 */     // GIR_Coverage, 7646,
     /*  370947 */     GIR_EraseRootFromParent_Done,
     /*  370948 */   // Label 6739: @370948
     /*  370948 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(371034), // Rule ID 7647 //
     /*  370953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  370956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  370961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  370976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  370992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  370996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  371000 */     // MIs[1] Operand 1
     /*  371000 */     // No operand predicates
     /*  371000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  371012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371032 */     GIR_RootConstrainSelectedInstOperands,
     /*  371033 */     // GIR_Coverage, 7647,
     /*  371033 */     GIR_EraseRootFromParent_Done,
     /*  371034 */   // Label 6740: @371034
     /*  371034 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(371120), // Rule ID 7650 //
     /*  371039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  371042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  371047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  371050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  371053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  371056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  371086 */     // MIs[1] Operand 1
     /*  371086 */     // No operand predicates
     /*  371086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  371098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371118 */     GIR_RootConstrainSelectedInstOperands,
     /*  371119 */     // GIR_Coverage, 7650,
     /*  371119 */     GIR_EraseRootFromParent_Done,
     /*  371120 */   // Label 6741: @371120
     /*  371120 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(371206), // Rule ID 7651 //
     /*  371125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  371128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  371133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  371136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  371139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  371142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  371148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  371172 */     // MIs[1] Operand 1
     /*  371172 */     // No operand predicates
     /*  371172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  371184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371204 */     GIR_RootConstrainSelectedInstOperands,
     /*  371205 */     // GIR_Coverage, 7651,
     /*  371205 */     GIR_EraseRootFromParent_Done,
     /*  371206 */   // Label 6742: @371206
     /*  371206 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(371295), // Rule ID 14080 //
     /*  371211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  371214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371258 */     // MIs[1] Operand 1
     /*  371258 */     // No operand predicates
     /*  371258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371267 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  371270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371293 */     GIR_RootConstrainSelectedInstOperands,
     /*  371294 */     // GIR_Coverage, 14080,
     /*  371294 */     GIR_EraseRootFromParent_Done,
     /*  371295 */   // Label 6743: @371295
     /*  371295 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(371384), // Rule ID 14081 //
     /*  371300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  371303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  371323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371347 */     // MIs[1] Operand 1
     /*  371347 */     // No operand predicates
     /*  371347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  371359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371382 */     GIR_RootConstrainSelectedInstOperands,
     /*  371383 */     // GIR_Coverage, 14081,
     /*  371383 */     GIR_EraseRootFromParent_Done,
     /*  371384 */   // Label 6744: @371384
     /*  371384 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(371473), // Rule ID 14084 //
     /*  371389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  371392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371436 */     // MIs[1] Operand 1
     /*  371436 */     // No operand predicates
     /*  371436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  371448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371471 */     GIR_RootConstrainSelectedInstOperands,
     /*  371472 */     // GIR_Coverage, 14084,
     /*  371472 */     GIR_EraseRootFromParent_Done,
     /*  371473 */   // Label 6745: @371473
     /*  371473 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(371562), // Rule ID 14085 //
     /*  371478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  371481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  371501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371525 */     // MIs[1] Operand 1
     /*  371525 */     // No operand predicates
     /*  371525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371534 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  371537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371560 */     GIR_RootConstrainSelectedInstOperands,
     /*  371561 */     // GIR_Coverage, 14085,
     /*  371561 */     GIR_EraseRootFromParent_Done,
     /*  371562 */   // Label 6746: @371562
     /*  371562 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(371651), // Rule ID 14088 //
     /*  371567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  371570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371614 */     // MIs[1] Operand 1
     /*  371614 */     // No operand predicates
     /*  371614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  371626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371649 */     GIR_RootConstrainSelectedInstOperands,
     /*  371650 */     // GIR_Coverage, 14088,
     /*  371650 */     GIR_EraseRootFromParent_Done,
     /*  371651 */   // Label 6747: @371651
     /*  371651 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(371740), // Rule ID 14089 //
     /*  371656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  371659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  371679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371703 */     // MIs[1] Operand 1
     /*  371703 */     // No operand predicates
     /*  371703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371712 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  371715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371738 */     GIR_RootConstrainSelectedInstOperands,
     /*  371739 */     // GIR_Coverage, 14089,
     /*  371739 */     GIR_EraseRootFromParent_Done,
     /*  371740 */   // Label 6748: @371740
     /*  371740 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(371829), // Rule ID 14092 //
     /*  371745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  371748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371792 */     // MIs[1] Operand 1
     /*  371792 */     // No operand predicates
     /*  371792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371801 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  371804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371827 */     GIR_RootConstrainSelectedInstOperands,
     /*  371828 */     // GIR_Coverage, 14092,
     /*  371828 */     GIR_EraseRootFromParent_Done,
     /*  371829 */   // Label 6749: @371829
     /*  371829 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(371918), // Rule ID 14093 //
     /*  371834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  371837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  371857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371881 */     // MIs[1] Operand 1
     /*  371881 */     // No operand predicates
     /*  371881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  371893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  371916 */     GIR_RootConstrainSelectedInstOperands,
     /*  371917 */     // GIR_Coverage, 14093,
     /*  371917 */     GIR_EraseRootFromParent_Done,
     /*  371918 */   // Label 6750: @371918
     /*  371918 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(372007), // Rule ID 14096 //
     /*  371923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  371926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  371931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  371946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  371962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  371966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  371970 */     // MIs[1] Operand 1
     /*  371970 */     // No operand predicates
     /*  371970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  371972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371979 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  371982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  371988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  371991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372005 */     GIR_RootConstrainSelectedInstOperands,
     /*  372006 */     // GIR_Coverage, 14096,
     /*  372006 */     GIR_EraseRootFromParent_Done,
     /*  372007 */   // Label 6751: @372007
     /*  372007 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(372096), // Rule ID 14097 //
     /*  372012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  372015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  372023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  372026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  372029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372059 */     // MIs[1] Operand 1
     /*  372059 */     // No operand predicates
     /*  372059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  372071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372094 */     GIR_RootConstrainSelectedInstOperands,
     /*  372095 */     // GIR_Coverage, 14097,
     /*  372095 */     GIR_EraseRootFromParent_Done,
     /*  372096 */   // Label 6752: @372096
     /*  372096 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(372185), // Rule ID 14100 //
     /*  372101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  372104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  372124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372148 */     // MIs[1] Operand 1
     /*  372148 */     // No operand predicates
     /*  372148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  372160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372183 */     GIR_RootConstrainSelectedInstOperands,
     /*  372184 */     // GIR_Coverage, 14100,
     /*  372184 */     GIR_EraseRootFromParent_Done,
     /*  372185 */   // Label 6753: @372185
     /*  372185 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(372274), // Rule ID 14101 //
     /*  372190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  372193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372237 */     // MIs[1] Operand 1
     /*  372237 */     // No operand predicates
     /*  372237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  372249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372272 */     GIR_RootConstrainSelectedInstOperands,
     /*  372273 */     // GIR_Coverage, 14101,
     /*  372273 */     GIR_EraseRootFromParent_Done,
     /*  372274 */   // Label 6754: @372274
     /*  372274 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(372363), // Rule ID 14104 //
     /*  372279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  372282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  372302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372326 */     // MIs[1] Operand 1
     /*  372326 */     // No operand predicates
     /*  372326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372335 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372361 */     GIR_RootConstrainSelectedInstOperands,
     /*  372362 */     // GIR_Coverage, 14104,
     /*  372362 */     GIR_EraseRootFromParent_Done,
     /*  372363 */   // Label 6755: @372363
     /*  372363 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(372452), // Rule ID 14105 //
     /*  372368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  372371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372415 */     // MIs[1] Operand 1
     /*  372415 */     // No operand predicates
     /*  372415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372450 */     GIR_RootConstrainSelectedInstOperands,
     /*  372451 */     // GIR_Coverage, 14105,
     /*  372451 */     GIR_EraseRootFromParent_Done,
     /*  372452 */   // Label 6756: @372452
     /*  372452 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(372541), // Rule ID 14108 //
     /*  372457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  372460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  372480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372504 */     // MIs[1] Operand 1
     /*  372504 */     // No operand predicates
     /*  372504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372513 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372539 */     GIR_RootConstrainSelectedInstOperands,
     /*  372540 */     // GIR_Coverage, 14108,
     /*  372540 */     GIR_EraseRootFromParent_Done,
     /*  372541 */   // Label 6757: @372541
     /*  372541 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(372630), // Rule ID 14109 //
     /*  372546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  372549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372593 */     // MIs[1] Operand 1
     /*  372593 */     // No operand predicates
     /*  372593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372628 */     GIR_RootConstrainSelectedInstOperands,
     /*  372629 */     // GIR_Coverage, 14109,
     /*  372629 */     GIR_EraseRootFromParent_Done,
     /*  372630 */   // Label 6758: @372630
     /*  372630 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(372719), // Rule ID 14112 //
     /*  372635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  372638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  372658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372682 */     // MIs[1] Operand 1
     /*  372682 */     // No operand predicates
     /*  372682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372717 */     GIR_RootConstrainSelectedInstOperands,
     /*  372718 */     // GIR_Coverage, 14112,
     /*  372718 */     GIR_EraseRootFromParent_Done,
     /*  372719 */   // Label 6759: @372719
     /*  372719 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(372808), // Rule ID 14113 //
     /*  372724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  372727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372771 */     // MIs[1] Operand 1
     /*  372771 */     // No operand predicates
     /*  372771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372806 */     GIR_RootConstrainSelectedInstOperands,
     /*  372807 */     // GIR_Coverage, 14113,
     /*  372807 */     GIR_EraseRootFromParent_Done,
     /*  372808 */   // Label 6760: @372808
     /*  372808 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(372897), // Rule ID 14116 //
     /*  372813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  372816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  372836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372860 */     // MIs[1] Operand 1
     /*  372860 */     // No operand predicates
     /*  372860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372895 */     GIR_RootConstrainSelectedInstOperands,
     /*  372896 */     // GIR_Coverage, 14116,
     /*  372896 */     GIR_EraseRootFromParent_Done,
     /*  372897 */   // Label 6761: @372897
     /*  372897 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(372986), // Rule ID 14117 //
     /*  372902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  372905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  372925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  372941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  372945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  372949 */     // MIs[1] Operand 1
     /*  372949 */     // No operand predicates
     /*  372949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  372951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  372961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  372967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  372970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  372984 */     GIR_RootConstrainSelectedInstOperands,
     /*  372985 */     // GIR_Coverage, 14117,
     /*  372985 */     GIR_EraseRootFromParent_Done,
     /*  372986 */   // Label 6762: @372986
     /*  372986 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(373075), // Rule ID 14120 //
     /*  372991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  372994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  372999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  373002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  373005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  373008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373038 */     // MIs[1] Operand 1
     /*  373038 */     // No operand predicates
     /*  373038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  373050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373073 */     GIR_RootConstrainSelectedInstOperands,
     /*  373074 */     // GIR_Coverage, 14120,
     /*  373074 */     GIR_EraseRootFromParent_Done,
     /*  373075 */   // Label 6763: @373075
     /*  373075 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(373164), // Rule ID 14121 //
     /*  373080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  373091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  373094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  373097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373127 */     // MIs[1] Operand 1
     /*  373127 */     // No operand predicates
     /*  373127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  373139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373162 */     GIR_RootConstrainSelectedInstOperands,
     /*  373163 */     // GIR_Coverage, 14121,
     /*  373163 */     GIR_EraseRootFromParent_Done,
     /*  373164 */   // Label 6764: @373164
     /*  373164 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(373253), // Rule ID 14124 //
     /*  373169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  373172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  373180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  373183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  373186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373216 */     // MIs[1] Operand 1
     /*  373216 */     // No operand predicates
     /*  373216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  373228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373251 */     GIR_RootConstrainSelectedInstOperands,
     /*  373252 */     // GIR_Coverage, 14124,
     /*  373252 */     GIR_EraseRootFromParent_Done,
     /*  373253 */   // Label 6765: @373253
     /*  373253 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(373342), // Rule ID 14125 //
     /*  373258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  373269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  373272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  373275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373305 */     // MIs[1] Operand 1
     /*  373305 */     // No operand predicates
     /*  373305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  373317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373340 */     GIR_RootConstrainSelectedInstOperands,
     /*  373341 */     // GIR_Coverage, 14125,
     /*  373341 */     GIR_EraseRootFromParent_Done,
     /*  373342 */   // Label 6766: @373342
     /*  373342 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(373431), // Rule ID 14128 //
     /*  373347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  373350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373394 */     // MIs[1] Operand 1
     /*  373394 */     // No operand predicates
     /*  373394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373403 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  373406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373429 */     GIR_RootConstrainSelectedInstOperands,
     /*  373430 */     // GIR_Coverage, 14128,
     /*  373430 */     GIR_EraseRootFromParent_Done,
     /*  373431 */   // Label 6767: @373431
     /*  373431 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(373520), // Rule ID 14129 //
     /*  373436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373483 */     // MIs[1] Operand 1
     /*  373483 */     // No operand predicates
     /*  373483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  373495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373518 */     GIR_RootConstrainSelectedInstOperands,
     /*  373519 */     // GIR_Coverage, 14129,
     /*  373519 */     GIR_EraseRootFromParent_Done,
     /*  373520 */   // Label 6768: @373520
     /*  373520 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(373609), // Rule ID 14132 //
     /*  373525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  373528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373572 */     // MIs[1] Operand 1
     /*  373572 */     // No operand predicates
     /*  373572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  373584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373607 */     GIR_RootConstrainSelectedInstOperands,
     /*  373608 */     // GIR_Coverage, 14132,
     /*  373608 */     GIR_EraseRootFromParent_Done,
     /*  373609 */   // Label 6769: @373609
     /*  373609 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(373698), // Rule ID 14133 //
     /*  373614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373661 */     // MIs[1] Operand 1
     /*  373661 */     // No operand predicates
     /*  373661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  373673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373696 */     GIR_RootConstrainSelectedInstOperands,
     /*  373697 */     // GIR_Coverage, 14133,
     /*  373697 */     GIR_EraseRootFromParent_Done,
     /*  373698 */   // Label 6770: @373698
     /*  373698 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(373787), // Rule ID 14136 //
     /*  373703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  373706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373750 */     // MIs[1] Operand 1
     /*  373750 */     // No operand predicates
     /*  373750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  373762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373785 */     GIR_RootConstrainSelectedInstOperands,
     /*  373786 */     // GIR_Coverage, 14136,
     /*  373786 */     GIR_EraseRootFromParent_Done,
     /*  373787 */   // Label 6771: @373787
     /*  373787 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(373876), // Rule ID 14137 //
     /*  373792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373839 */     // MIs[1] Operand 1
     /*  373839 */     // No operand predicates
     /*  373839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  373851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373874 */     GIR_RootConstrainSelectedInstOperands,
     /*  373875 */     // GIR_Coverage, 14137,
     /*  373875 */     GIR_EraseRootFromParent_Done,
     /*  373876 */   // Label 6772: @373876
     /*  373876 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(373965), // Rule ID 14140 //
     /*  373881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  373884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  373904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  373920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  373924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  373928 */     // MIs[1] Operand 1
     /*  373928 */     // No operand predicates
     /*  373928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  373930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373937 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  373940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  373946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  373949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  373963 */     GIR_RootConstrainSelectedInstOperands,
     /*  373964 */     // GIR_Coverage, 14140,
     /*  373964 */     GIR_EraseRootFromParent_Done,
     /*  373965 */   // Label 6773: @373965
     /*  373965 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(374054), // Rule ID 14141 //
     /*  373970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  373973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  373978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  373993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374017 */     // MIs[1] Operand 1
     /*  374017 */     // No operand predicates
     /*  374017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  374029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374052 */     GIR_RootConstrainSelectedInstOperands,
     /*  374053 */     // GIR_Coverage, 14141,
     /*  374053 */     GIR_EraseRootFromParent_Done,
     /*  374054 */   // Label 6774: @374054
     /*  374054 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(374143), // Rule ID 14144 //
     /*  374059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  374062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  374070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  374073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  374076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374106 */     // MIs[1] Operand 1
     /*  374106 */     // No operand predicates
     /*  374106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  374118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374141 */     GIR_RootConstrainSelectedInstOperands,
     /*  374142 */     // GIR_Coverage, 14144,
     /*  374142 */     GIR_EraseRootFromParent_Done,
     /*  374143 */   // Label 6775: @374143
     /*  374143 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(374232), // Rule ID 14145 //
     /*  374148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  374151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  374159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  374162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  374165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  374171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374195 */     // MIs[1] Operand 1
     /*  374195 */     // No operand predicates
     /*  374195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  374207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374230 */     GIR_RootConstrainSelectedInstOperands,
     /*  374231 */     // GIR_Coverage, 14145,
     /*  374231 */     GIR_EraseRootFromParent_Done,
     /*  374232 */   // Label 6776: @374232
     /*  374232 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(374321), // Rule ID 14148 //
     /*  374237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  374240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  374248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  374251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  374254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374284 */     // MIs[1] Operand 1
     /*  374284 */     // No operand predicates
     /*  374284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  374296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374319 */     GIR_RootConstrainSelectedInstOperands,
     /*  374320 */     // GIR_Coverage, 14148,
     /*  374320 */     GIR_EraseRootFromParent_Done,
     /*  374321 */   // Label 6777: @374321
     /*  374321 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(374410), // Rule ID 14149 //
     /*  374326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  374329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  374337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  374340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  374343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  374349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374373 */     // MIs[1] Operand 1
     /*  374373 */     // No operand predicates
     /*  374373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  374385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374408 */     GIR_RootConstrainSelectedInstOperands,
     /*  374409 */     // GIR_Coverage, 14149,
     /*  374409 */     GIR_EraseRootFromParent_Done,
     /*  374410 */   // Label 6778: @374410
     /*  374410 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(374499), // Rule ID 14152 //
     /*  374415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  374418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  374426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  374429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  374432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374462 */     // MIs[1] Operand 1
     /*  374462 */     // No operand predicates
     /*  374462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  374474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374497 */     GIR_RootConstrainSelectedInstOperands,
     /*  374498 */     // GIR_Coverage, 14152,
     /*  374498 */     GIR_EraseRootFromParent_Done,
     /*  374499 */   // Label 6779: @374499
     /*  374499 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(374588), // Rule ID 14153 //
     /*  374504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  374507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  374515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  374518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  374521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  374527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374551 */     // MIs[1] Operand 1
     /*  374551 */     // No operand predicates
     /*  374551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  374563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374586 */     GIR_RootConstrainSelectedInstOperands,
     /*  374587 */     // GIR_Coverage, 14153,
     /*  374587 */     GIR_EraseRootFromParent_Done,
     /*  374588 */   // Label 6780: @374588
     /*  374588 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(374677), // Rule ID 14156 //
     /*  374593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  374596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  374604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  374607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  374610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374640 */     // MIs[1] Operand 1
     /*  374640 */     // No operand predicates
     /*  374640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  374652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374675 */     GIR_RootConstrainSelectedInstOperands,
     /*  374676 */     // GIR_Coverage, 14156,
     /*  374676 */     GIR_EraseRootFromParent_Done,
     /*  374677 */   // Label 6781: @374677
     /*  374677 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(374766), // Rule ID 14157 //
     /*  374682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  374685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  374693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  374696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  374699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  374705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374729 */     // MIs[1] Operand 1
     /*  374729 */     // No operand predicates
     /*  374729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  374741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374764 */     GIR_RootConstrainSelectedInstOperands,
     /*  374765 */     // GIR_Coverage, 14157,
     /*  374765 */     GIR_EraseRootFromParent_Done,
     /*  374766 */   // Label 6782: @374766
     /*  374766 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(374855), // Rule ID 14160 //
     /*  374771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  374774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374818 */     // MIs[1] Operand 1
     /*  374818 */     // No operand predicates
     /*  374818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374827 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  374830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374853 */     GIR_RootConstrainSelectedInstOperands,
     /*  374854 */     // GIR_Coverage, 14160,
     /*  374854 */     GIR_EraseRootFromParent_Done,
     /*  374855 */   // Label 6783: @374855
     /*  374855 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(374944), // Rule ID 14161 //
     /*  374860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  374863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  374883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374907 */     // MIs[1] Operand 1
     /*  374907 */     // No operand predicates
     /*  374907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  374919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  374925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  374928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  374942 */     GIR_RootConstrainSelectedInstOperands,
     /*  374943 */     // GIR_Coverage, 14161,
     /*  374943 */     GIR_EraseRootFromParent_Done,
     /*  374944 */   // Label 6784: @374944
     /*  374944 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(375033), // Rule ID 14164 //
     /*  374949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  374952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  374957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  374960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  374963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  374966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  374972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  374988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  374992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  374996 */     // MIs[1] Operand 1
     /*  374996 */     // No operand predicates
     /*  374996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  374998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375005 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  375008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375031 */     GIR_RootConstrainSelectedInstOperands,
     /*  375032 */     // GIR_Coverage, 14164,
     /*  375032 */     GIR_EraseRootFromParent_Done,
     /*  375033 */   // Label 6785: @375033
     /*  375033 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(375122), // Rule ID 14165 //
     /*  375038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  375041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  375046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  375049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  375052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  375055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375085 */     // MIs[1] Operand 1
     /*  375085 */     // No operand predicates
     /*  375085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  375097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375120 */     GIR_RootConstrainSelectedInstOperands,
     /*  375121 */     // GIR_Coverage, 14165,
     /*  375121 */     GIR_EraseRootFromParent_Done,
     /*  375122 */   // Label 6786: @375122
     /*  375122 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(375211), // Rule ID 14344 //
     /*  375127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  375130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  375138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  375141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  375144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  375150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375174 */     // MIs[1] Operand 1
     /*  375174 */     // No operand predicates
     /*  375174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375183 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  375186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375209 */     GIR_RootConstrainSelectedInstOperands,
     /*  375210 */     // GIR_Coverage, 14344,
     /*  375210 */     GIR_EraseRootFromParent_Done,
     /*  375211 */   // Label 6787: @375211
     /*  375211 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(375300), // Rule ID 14345 //
     /*  375216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  375219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  375227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  375230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  375233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375263 */     // MIs[1] Operand 1
     /*  375263 */     // No operand predicates
     /*  375263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  375275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375298 */     GIR_RootConstrainSelectedInstOperands,
     /*  375299 */     // GIR_Coverage, 14345,
     /*  375299 */     GIR_EraseRootFromParent_Done,
     /*  375300 */   // Label 6788: @375300
     /*  375300 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(375389), // Rule ID 14348 //
     /*  375305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  375308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  375316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  375319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  375322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  375328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375352 */     // MIs[1] Operand 1
     /*  375352 */     // No operand predicates
     /*  375352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375361 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  375364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375387 */     GIR_RootConstrainSelectedInstOperands,
     /*  375388 */     // GIR_Coverage, 14348,
     /*  375388 */     GIR_EraseRootFromParent_Done,
     /*  375389 */   // Label 6789: @375389
     /*  375389 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(375478), // Rule ID 14349 //
     /*  375394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  375397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  375405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  375408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  375411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375441 */     // MIs[1] Operand 1
     /*  375441 */     // No operand predicates
     /*  375441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  375453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375476 */     GIR_RootConstrainSelectedInstOperands,
     /*  375477 */     // GIR_Coverage, 14349,
     /*  375477 */     GIR_EraseRootFromParent_Done,
     /*  375478 */   // Label 6790: @375478
     /*  375478 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(375567), // Rule ID 14352 //
     /*  375483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  375486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  375494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  375497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  375500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  375506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375530 */     // MIs[1] Operand 1
     /*  375530 */     // No operand predicates
     /*  375530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  375542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375565 */     GIR_RootConstrainSelectedInstOperands,
     /*  375566 */     // GIR_Coverage, 14352,
     /*  375566 */     GIR_EraseRootFromParent_Done,
     /*  375567 */   // Label 6791: @375567
     /*  375567 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(375656), // Rule ID 14353 //
     /*  375572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  375575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  375583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  375586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  375589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375619 */     // MIs[1] Operand 1
     /*  375619 */     // No operand predicates
     /*  375619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375628 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  375631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375654 */     GIR_RootConstrainSelectedInstOperands,
     /*  375655 */     // GIR_Coverage, 14353,
     /*  375655 */     GIR_EraseRootFromParent_Done,
     /*  375656 */   // Label 6792: @375656
     /*  375656 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(375745), // Rule ID 14356 //
     /*  375661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  375664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  375672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  375675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  375678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  375684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375708 */     // MIs[1] Operand 1
     /*  375708 */     // No operand predicates
     /*  375708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375717 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  375720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375743 */     GIR_RootConstrainSelectedInstOperands,
     /*  375744 */     // GIR_Coverage, 14356,
     /*  375744 */     GIR_EraseRootFromParent_Done,
     /*  375745 */   // Label 6793: @375745
     /*  375745 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(375834), // Rule ID 14357 //
     /*  375750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  375753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  375761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  375764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  375767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375797 */     // MIs[1] Operand 1
     /*  375797 */     // No operand predicates
     /*  375797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375806 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  375809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375832 */     GIR_RootConstrainSelectedInstOperands,
     /*  375833 */     // GIR_Coverage, 14357,
     /*  375833 */     GIR_EraseRootFromParent_Done,
     /*  375834 */   // Label 6794: @375834
     /*  375834 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(375923), // Rule ID 14360 //
     /*  375839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  375842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  375850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  375853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  375856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  375862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375886 */     // MIs[1] Operand 1
     /*  375886 */     // No operand predicates
     /*  375886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375895 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  375898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  375921 */     GIR_RootConstrainSelectedInstOperands,
     /*  375922 */     // GIR_Coverage, 14360,
     /*  375922 */     GIR_EraseRootFromParent_Done,
     /*  375923 */   // Label 6795: @375923
     /*  375923 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(376012), // Rule ID 14361 //
     /*  375928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  375931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  375936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  375939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  375942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  375945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  375951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  375967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  375971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  375975 */     // MIs[1] Operand 1
     /*  375975 */     // No operand predicates
     /*  375975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  375977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  375987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  375993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  375996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376010 */     GIR_RootConstrainSelectedInstOperands,
     /*  376011 */     // GIR_Coverage, 14361,
     /*  376011 */     GIR_EraseRootFromParent_Done,
     /*  376012 */   // Label 6796: @376012
     /*  376012 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(376101), // Rule ID 14364 //
     /*  376017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  376020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376064 */     // MIs[1] Operand 1
     /*  376064 */     // No operand predicates
     /*  376064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376073 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  376076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376099 */     GIR_RootConstrainSelectedInstOperands,
     /*  376100 */     // GIR_Coverage, 14364,
     /*  376100 */     GIR_EraseRootFromParent_Done,
     /*  376101 */   // Label 6797: @376101
     /*  376101 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(376190), // Rule ID 14365 //
     /*  376106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  376109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  376129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376153 */     // MIs[1] Operand 1
     /*  376153 */     // No operand predicates
     /*  376153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376162 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  376165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376188 */     GIR_RootConstrainSelectedInstOperands,
     /*  376189 */     // GIR_Coverage, 14365,
     /*  376189 */     GIR_EraseRootFromParent_Done,
     /*  376190 */   // Label 6798: @376190
     /*  376190 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(376279), // Rule ID 14368 //
     /*  376195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  376198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  376206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  376209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  376212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376242 */     // MIs[1] Operand 1
     /*  376242 */     // No operand predicates
     /*  376242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376251 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376277 */     GIR_RootConstrainSelectedInstOperands,
     /*  376278 */     // GIR_Coverage, 14368,
     /*  376278 */     GIR_EraseRootFromParent_Done,
     /*  376279 */   // Label 6799: @376279
     /*  376279 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(376368), // Rule ID 14369 //
     /*  376284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  376287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  376295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  376298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  376301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  376307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376331 */     // MIs[1] Operand 1
     /*  376331 */     // No operand predicates
     /*  376331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376366 */     GIR_RootConstrainSelectedInstOperands,
     /*  376367 */     // GIR_Coverage, 14369,
     /*  376367 */     GIR_EraseRootFromParent_Done,
     /*  376368 */   // Label 6800: @376368
     /*  376368 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(376457), // Rule ID 14372 //
     /*  376373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  376376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  376384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  376387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  376390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376420 */     // MIs[1] Operand 1
     /*  376420 */     // No operand predicates
     /*  376420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376429 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376455 */     GIR_RootConstrainSelectedInstOperands,
     /*  376456 */     // GIR_Coverage, 14372,
     /*  376456 */     GIR_EraseRootFromParent_Done,
     /*  376457 */   // Label 6801: @376457
     /*  376457 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(376546), // Rule ID 14373 //
     /*  376462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  376465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  376473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  376476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  376479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  376485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376509 */     // MIs[1] Operand 1
     /*  376509 */     // No operand predicates
     /*  376509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376544 */     GIR_RootConstrainSelectedInstOperands,
     /*  376545 */     // GIR_Coverage, 14373,
     /*  376545 */     GIR_EraseRootFromParent_Done,
     /*  376546 */   // Label 6802: @376546
     /*  376546 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(376635), // Rule ID 14376 //
     /*  376551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  376554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  376562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  376565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  376568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376598 */     // MIs[1] Operand 1
     /*  376598 */     // No operand predicates
     /*  376598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376633 */     GIR_RootConstrainSelectedInstOperands,
     /*  376634 */     // GIR_Coverage, 14376,
     /*  376634 */     GIR_EraseRootFromParent_Done,
     /*  376635 */   // Label 6803: @376635
     /*  376635 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(376724), // Rule ID 14377 //
     /*  376640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  376643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  376651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  376654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  376657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  376663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376687 */     // MIs[1] Operand 1
     /*  376687 */     // No operand predicates
     /*  376687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376722 */     GIR_RootConstrainSelectedInstOperands,
     /*  376723 */     // GIR_Coverage, 14377,
     /*  376723 */     GIR_EraseRootFromParent_Done,
     /*  376724 */   // Label 6804: @376724
     /*  376724 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(376813), // Rule ID 14380 //
     /*  376729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  376732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  376740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  376743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  376746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376776 */     // MIs[1] Operand 1
     /*  376776 */     // No operand predicates
     /*  376776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376785 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376811 */     GIR_RootConstrainSelectedInstOperands,
     /*  376812 */     // GIR_Coverage, 14380,
     /*  376812 */     GIR_EraseRootFromParent_Done,
     /*  376813 */   // Label 6805: @376813
     /*  376813 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(376902), // Rule ID 14381 //
     /*  376818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  376821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  376829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  376832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  376835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  376841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376865 */     // MIs[1] Operand 1
     /*  376865 */     // No operand predicates
     /*  376865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  376877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376900 */     GIR_RootConstrainSelectedInstOperands,
     /*  376901 */     // GIR_Coverage, 14381,
     /*  376901 */     GIR_EraseRootFromParent_Done,
     /*  376902 */   // Label 6806: @376902
     /*  376902 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(376991), // Rule ID 14384 //
     /*  376907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  376910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  376915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  376918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  376921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  376924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  376930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  376946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  376950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  376954 */     // MIs[1] Operand 1
     /*  376954 */     // No operand predicates
     /*  376954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  376956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376963 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  376966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  376972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  376975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  376989 */     GIR_RootConstrainSelectedInstOperands,
     /*  376990 */     // GIR_Coverage, 14384,
     /*  376990 */     GIR_EraseRootFromParent_Done,
     /*  376991 */   // Label 6807: @376991
     /*  376991 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(377080), // Rule ID 14385 //
     /*  376996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  376999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377043 */     // MIs[1] Operand 1
     /*  377043 */     // No operand predicates
     /*  377043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  377055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377078 */     GIR_RootConstrainSelectedInstOperands,
     /*  377079 */     // GIR_Coverage, 14385,
     /*  377079 */     GIR_EraseRootFromParent_Done,
     /*  377080 */   // Label 6808: @377080
     /*  377080 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(377169), // Rule ID 14388 //
     /*  377085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377132 */     // MIs[1] Operand 1
     /*  377132 */     // No operand predicates
     /*  377132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377141 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  377144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377167 */     GIR_RootConstrainSelectedInstOperands,
     /*  377168 */     // GIR_Coverage, 14388,
     /*  377168 */     GIR_EraseRootFromParent_Done,
     /*  377169 */   // Label 6809: @377169
     /*  377169 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(377258), // Rule ID 14389 //
     /*  377174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  377177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377221 */     // MIs[1] Operand 1
     /*  377221 */     // No operand predicates
     /*  377221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377230 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  377233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377256 */     GIR_RootConstrainSelectedInstOperands,
     /*  377257 */     // GIR_Coverage, 14389,
     /*  377257 */     GIR_EraseRootFromParent_Done,
     /*  377258 */   // Label 6810: @377258
     /*  377258 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(377347), // Rule ID 14392 //
     /*  377263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377310 */     // MIs[1] Operand 1
     /*  377310 */     // No operand predicates
     /*  377310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377319 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  377322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377345 */     GIR_RootConstrainSelectedInstOperands,
     /*  377346 */     // GIR_Coverage, 14392,
     /*  377346 */     GIR_EraseRootFromParent_Done,
     /*  377347 */   // Label 6811: @377347
     /*  377347 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(377436), // Rule ID 14393 //
     /*  377352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  377355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377399 */     // MIs[1] Operand 1
     /*  377399 */     // No operand predicates
     /*  377399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377408 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377434 */     GIR_RootConstrainSelectedInstOperands,
     /*  377435 */     // GIR_Coverage, 14393,
     /*  377435 */     GIR_EraseRootFromParent_Done,
     /*  377436 */   // Label 6812: @377436
     /*  377436 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(377525), // Rule ID 14396 //
     /*  377441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  377452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  377455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  377458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377488 */     // MIs[1] Operand 1
     /*  377488 */     // No operand predicates
     /*  377488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377497 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  377500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377523 */     GIR_RootConstrainSelectedInstOperands,
     /*  377524 */     // GIR_Coverage, 14396,
     /*  377524 */     GIR_EraseRootFromParent_Done,
     /*  377525 */   // Label 6813: @377525
     /*  377525 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(377614), // Rule ID 14397 //
     /*  377530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  377533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  377541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  377544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  377547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377577 */     // MIs[1] Operand 1
     /*  377577 */     // No operand predicates
     /*  377577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  377589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377612 */     GIR_RootConstrainSelectedInstOperands,
     /*  377613 */     // GIR_Coverage, 14397,
     /*  377613 */     GIR_EraseRootFromParent_Done,
     /*  377614 */   // Label 6814: @377614
     /*  377614 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(377703), // Rule ID 14400 //
     /*  377619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  377630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  377633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  377636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377666 */     // MIs[1] Operand 1
     /*  377666 */     // No operand predicates
     /*  377666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377675 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  377678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377701 */     GIR_RootConstrainSelectedInstOperands,
     /*  377702 */     // GIR_Coverage, 14400,
     /*  377702 */     GIR_EraseRootFromParent_Done,
     /*  377703 */   // Label 6815: @377703
     /*  377703 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(377792), // Rule ID 14401 //
     /*  377708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  377711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  377719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  377722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  377725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377755 */     // MIs[1] Operand 1
     /*  377755 */     // No operand predicates
     /*  377755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  377767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377790 */     GIR_RootConstrainSelectedInstOperands,
     /*  377791 */     // GIR_Coverage, 14401,
     /*  377791 */     GIR_EraseRootFromParent_Done,
     /*  377792 */   // Label 6816: @377792
     /*  377792 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(377881), // Rule ID 14404 //
     /*  377797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  377808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  377811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  377814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377844 */     // MIs[1] Operand 1
     /*  377844 */     // No operand predicates
     /*  377844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377853 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  377856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377879 */     GIR_RootConstrainSelectedInstOperands,
     /*  377880 */     // GIR_Coverage, 14404,
     /*  377880 */     GIR_EraseRootFromParent_Done,
     /*  377881 */   // Label 6817: @377881
     /*  377881 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(377970), // Rule ID 14405 //
     /*  377886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  377889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  377897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  377900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  377903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  377909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  377925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  377929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  377933 */     // MIs[1] Operand 1
     /*  377933 */     // No operand predicates
     /*  377933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  377935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  377945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  377951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  377954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  377968 */     GIR_RootConstrainSelectedInstOperands,
     /*  377969 */     // GIR_Coverage, 14405,
     /*  377969 */     GIR_EraseRootFromParent_Done,
     /*  377970 */   // Label 6818: @377970
     /*  377970 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(378059), // Rule ID 14408 //
     /*  377975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  377978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  377983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  377986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  377989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  377992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  377998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378022 */     // MIs[1] Operand 1
     /*  378022 */     // No operand predicates
     /*  378022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  378034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378057 */     GIR_RootConstrainSelectedInstOperands,
     /*  378058 */     // GIR_Coverage, 14408,
     /*  378058 */     GIR_EraseRootFromParent_Done,
     /*  378059 */   // Label 6819: @378059
     /*  378059 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(378148), // Rule ID 14409 //
     /*  378064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  378067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378111 */     // MIs[1] Operand 1
     /*  378111 */     // No operand predicates
     /*  378111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  378123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378146 */     GIR_RootConstrainSelectedInstOperands,
     /*  378147 */     // GIR_Coverage, 14409,
     /*  378147 */     GIR_EraseRootFromParent_Done,
     /*  378148 */   // Label 6820: @378148
     /*  378148 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(378237), // Rule ID 14412 //
     /*  378153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  378156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  378176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378200 */     // MIs[1] Operand 1
     /*  378200 */     // No operand predicates
     /*  378200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  378212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378235 */     GIR_RootConstrainSelectedInstOperands,
     /*  378236 */     // GIR_Coverage, 14412,
     /*  378236 */     GIR_EraseRootFromParent_Done,
     /*  378237 */   // Label 6821: @378237
     /*  378237 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(378326), // Rule ID 14413 //
     /*  378242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  378245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378289 */     // MIs[1] Operand 1
     /*  378289 */     // No operand predicates
     /*  378289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  378301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378324 */     GIR_RootConstrainSelectedInstOperands,
     /*  378325 */     // GIR_Coverage, 14413,
     /*  378325 */     GIR_EraseRootFromParent_Done,
     /*  378326 */   // Label 6822: @378326
     /*  378326 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(378415), // Rule ID 14416 //
     /*  378331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  378334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  378354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378378 */     // MIs[1] Operand 1
     /*  378378 */     // No operand predicates
     /*  378378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378387 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  378390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378413 */     GIR_RootConstrainSelectedInstOperands,
     /*  378414 */     // GIR_Coverage, 14416,
     /*  378414 */     GIR_EraseRootFromParent_Done,
     /*  378415 */   // Label 6823: @378415
     /*  378415 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(378504), // Rule ID 14417 //
     /*  378420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  378423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378467 */     // MIs[1] Operand 1
     /*  378467 */     // No operand predicates
     /*  378467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  378479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378502 */     GIR_RootConstrainSelectedInstOperands,
     /*  378503 */     // GIR_Coverage, 14417,
     /*  378503 */     GIR_EraseRootFromParent_Done,
     /*  378504 */   // Label 6824: @378504
     /*  378504 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(378593), // Rule ID 14420 //
     /*  378509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  378512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  378532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378556 */     // MIs[1] Operand 1
     /*  378556 */     // No operand predicates
     /*  378556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  378568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378591 */     GIR_RootConstrainSelectedInstOperands,
     /*  378592 */     // GIR_Coverage, 14420,
     /*  378592 */     GIR_EraseRootFromParent_Done,
     /*  378593 */   // Label 6825: @378593
     /*  378593 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(378682), // Rule ID 14421 //
     /*  378598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  378601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378645 */     // MIs[1] Operand 1
     /*  378645 */     // No operand predicates
     /*  378645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  378657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378680 */     GIR_RootConstrainSelectedInstOperands,
     /*  378681 */     // GIR_Coverage, 14421,
     /*  378681 */     GIR_EraseRootFromParent_Done,
     /*  378682 */   // Label 6826: @378682
     /*  378682 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(378771), // Rule ID 14424 //
     /*  378687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  378690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  378710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378734 */     // MIs[1] Operand 1
     /*  378734 */     // No operand predicates
     /*  378734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378743 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  378746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378769 */     GIR_RootConstrainSelectedInstOperands,
     /*  378770 */     // GIR_Coverage, 14424,
     /*  378770 */     GIR_EraseRootFromParent_Done,
     /*  378771 */   // Label 6827: @378771
     /*  378771 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(378860), // Rule ID 14425 //
     /*  378776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  378779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378823 */     // MIs[1] Operand 1
     /*  378823 */     // No operand predicates
     /*  378823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  378835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378858 */     GIR_RootConstrainSelectedInstOperands,
     /*  378859 */     // GIR_Coverage, 14425,
     /*  378859 */     GIR_EraseRootFromParent_Done,
     /*  378860 */   // Label 6828: @378860
     /*  378860 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(378949), // Rule ID 14428 //
     /*  378865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  378868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  378876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  378879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  378882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  378888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  378912 */     // MIs[1] Operand 1
     /*  378912 */     // No operand predicates
     /*  378912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  378914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  378924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  378930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  378933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  378947 */     GIR_RootConstrainSelectedInstOperands,
     /*  378948 */     // GIR_Coverage, 14428,
     /*  378948 */     GIR_EraseRootFromParent_Done,
     /*  378949 */   // Label 6829: @378949
     /*  378949 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(379038), // Rule ID 14429 //
     /*  378954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  378957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  378962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  378965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  378968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  378971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  378977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  378993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  378997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  379001 */     // MIs[1] Operand 1
     /*  379001 */     // No operand predicates
     /*  379001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  379013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  379036 */     GIR_RootConstrainSelectedInstOperands,
     /*  379037 */     // GIR_Coverage, 14429,
     /*  379037 */     GIR_EraseRootFromParent_Done,
     /*  379038 */   // Label 6830: @379038
     /*  379038 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(379124), // Rule ID 24524 //
     /*  379043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379090 */     // MIs[1] Operand 1
     /*  379090 */     // No operand predicates
     /*  379090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  379102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379122 */     GIR_RootConstrainSelectedInstOperands,
     /*  379123 */     // GIR_Coverage, 24524,
     /*  379123 */     GIR_EraseRootFromParent_Done,
     /*  379124 */   // Label 6831: @379124
     /*  379124 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(379210), // Rule ID 24525 //
     /*  379129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  379152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379176 */     // MIs[1] Operand 1
     /*  379176 */     // No operand predicates
     /*  379176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379185 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  379188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379208 */     GIR_RootConstrainSelectedInstOperands,
     /*  379209 */     // GIR_Coverage, 24525,
     /*  379209 */     GIR_EraseRootFromParent_Done,
     /*  379210 */   // Label 6832: @379210
     /*  379210 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(379296), // Rule ID 24528 //
     /*  379215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379262 */     // MIs[1] Operand 1
     /*  379262 */     // No operand predicates
     /*  379262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379271 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  379274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379294 */     GIR_RootConstrainSelectedInstOperands,
     /*  379295 */     // GIR_Coverage, 24528,
     /*  379295 */     GIR_EraseRootFromParent_Done,
     /*  379296 */   // Label 6833: @379296
     /*  379296 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(379382), // Rule ID 24529 //
     /*  379301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  379324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379348 */     // MIs[1] Operand 1
     /*  379348 */     // No operand predicates
     /*  379348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379357 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  379360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379380 */     GIR_RootConstrainSelectedInstOperands,
     /*  379381 */     // GIR_Coverage, 24529,
     /*  379381 */     GIR_EraseRootFromParent_Done,
     /*  379382 */   // Label 6834: @379382
     /*  379382 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(379468), // Rule ID 24532 //
     /*  379387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379434 */     // MIs[1] Operand 1
     /*  379434 */     // No operand predicates
     /*  379434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379443 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  379446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379466 */     GIR_RootConstrainSelectedInstOperands,
     /*  379467 */     // GIR_Coverage, 24532,
     /*  379467 */     GIR_EraseRootFromParent_Done,
     /*  379468 */   // Label 6835: @379468
     /*  379468 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(379554), // Rule ID 24533 //
     /*  379473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  379496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379520 */     // MIs[1] Operand 1
     /*  379520 */     // No operand predicates
     /*  379520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379529 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  379532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379552 */     GIR_RootConstrainSelectedInstOperands,
     /*  379553 */     // GIR_Coverage, 24533,
     /*  379553 */     GIR_EraseRootFromParent_Done,
     /*  379554 */   // Label 6836: @379554
     /*  379554 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(379640), // Rule ID 24536 //
     /*  379559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379606 */     // MIs[1] Operand 1
     /*  379606 */     // No operand predicates
     /*  379606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379615 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  379618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379638 */     GIR_RootConstrainSelectedInstOperands,
     /*  379639 */     // GIR_Coverage, 24536,
     /*  379639 */     GIR_EraseRootFromParent_Done,
     /*  379640 */   // Label 6837: @379640
     /*  379640 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(379726), // Rule ID 24537 //
     /*  379645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  379668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379692 */     // MIs[1] Operand 1
     /*  379692 */     // No operand predicates
     /*  379692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379701 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  379704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379724 */     GIR_RootConstrainSelectedInstOperands,
     /*  379725 */     // GIR_Coverage, 24537,
     /*  379725 */     GIR_EraseRootFromParent_Done,
     /*  379726 */   // Label 6838: @379726
     /*  379726 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(379812), // Rule ID 24540 //
     /*  379731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379778 */     // MIs[1] Operand 1
     /*  379778 */     // No operand predicates
     /*  379778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379787 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  379790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379810 */     GIR_RootConstrainSelectedInstOperands,
     /*  379811 */     // GIR_Coverage, 24540,
     /*  379811 */     GIR_EraseRootFromParent_Done,
     /*  379812 */   // Label 6839: @379812
     /*  379812 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(379898), // Rule ID 24541 //
     /*  379817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  379840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379864 */     // MIs[1] Operand 1
     /*  379864 */     // No operand predicates
     /*  379864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379873 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  379876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379896 */     GIR_RootConstrainSelectedInstOperands,
     /*  379897 */     // GIR_Coverage, 24541,
     /*  379897 */     GIR_EraseRootFromParent_Done,
     /*  379898 */   // Label 6840: @379898
     /*  379898 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(379984), // Rule ID 24544 //
     /*  379903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  379906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  379926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  379942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  379946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  379950 */     // MIs[1] Operand 1
     /*  379950 */     // No operand predicates
     /*  379950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  379952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379959 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  379962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  379968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  379971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379982 */     GIR_RootConstrainSelectedInstOperands,
     /*  379983 */     // GIR_Coverage, 24544,
     /*  379983 */     GIR_EraseRootFromParent_Done,
     /*  379984 */   // Label 6841: @379984
     /*  379984 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(380070), // Rule ID 24545 //
     /*  379989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  379992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  379997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380036 */     // MIs[1] Operand 1
     /*  380036 */     // No operand predicates
     /*  380036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380045 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  380048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380068 */     GIR_RootConstrainSelectedInstOperands,
     /*  380069 */     // GIR_Coverage, 24545,
     /*  380069 */     GIR_EraseRootFromParent_Done,
     /*  380070 */   // Label 6842: @380070
     /*  380070 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(380156), // Rule ID 24548 //
     /*  380075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  380078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380122 */     // MIs[1] Operand 1
     /*  380122 */     // No operand predicates
     /*  380122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380131 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380154 */     GIR_RootConstrainSelectedInstOperands,
     /*  380155 */     // GIR_Coverage, 24548,
     /*  380155 */     GIR_EraseRootFromParent_Done,
     /*  380156 */   // Label 6843: @380156
     /*  380156 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(380242), // Rule ID 24549 //
     /*  380161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  380164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380208 */     // MIs[1] Operand 1
     /*  380208 */     // No operand predicates
     /*  380208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380217 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380240 */     GIR_RootConstrainSelectedInstOperands,
     /*  380241 */     // GIR_Coverage, 24549,
     /*  380241 */     GIR_EraseRootFromParent_Done,
     /*  380242 */   // Label 6844: @380242
     /*  380242 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(380328), // Rule ID 24552 //
     /*  380247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  380250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380294 */     // MIs[1] Operand 1
     /*  380294 */     // No operand predicates
     /*  380294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380303 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380326 */     GIR_RootConstrainSelectedInstOperands,
     /*  380327 */     // GIR_Coverage, 24552,
     /*  380327 */     GIR_EraseRootFromParent_Done,
     /*  380328 */   // Label 6845: @380328
     /*  380328 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(380414), // Rule ID 24553 //
     /*  380333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  380336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380380 */     // MIs[1] Operand 1
     /*  380380 */     // No operand predicates
     /*  380380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380412 */     GIR_RootConstrainSelectedInstOperands,
     /*  380413 */     // GIR_Coverage, 24553,
     /*  380413 */     GIR_EraseRootFromParent_Done,
     /*  380414 */   // Label 6846: @380414
     /*  380414 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(380500), // Rule ID 24556 //
     /*  380419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  380422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380466 */     // MIs[1] Operand 1
     /*  380466 */     // No operand predicates
     /*  380466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380498 */     GIR_RootConstrainSelectedInstOperands,
     /*  380499 */     // GIR_Coverage, 24556,
     /*  380499 */     GIR_EraseRootFromParent_Done,
     /*  380500 */   // Label 6847: @380500
     /*  380500 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(380586), // Rule ID 24557 //
     /*  380505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  380508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380552 */     // MIs[1] Operand 1
     /*  380552 */     // No operand predicates
     /*  380552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380561 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380584 */     GIR_RootConstrainSelectedInstOperands,
     /*  380585 */     // GIR_Coverage, 24557,
     /*  380585 */     GIR_EraseRootFromParent_Done,
     /*  380586 */   // Label 6848: @380586
     /*  380586 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(380672), // Rule ID 24560 //
     /*  380591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  380594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380638 */     // MIs[1] Operand 1
     /*  380638 */     // No operand predicates
     /*  380638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380647 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380670 */     GIR_RootConstrainSelectedInstOperands,
     /*  380671 */     // GIR_Coverage, 24560,
     /*  380671 */     GIR_EraseRootFromParent_Done,
     /*  380672 */   // Label 6849: @380672
     /*  380672 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(380758), // Rule ID 24561 //
     /*  380677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  380680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380724 */     // MIs[1] Operand 1
     /*  380724 */     // No operand predicates
     /*  380724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380733 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  380736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380756 */     GIR_RootConstrainSelectedInstOperands,
     /*  380757 */     // GIR_Coverage, 24561,
     /*  380757 */     GIR_EraseRootFromParent_Done,
     /*  380758 */   // Label 6850: @380758
     /*  380758 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(380844), // Rule ID 24564 //
     /*  380763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  380766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380810 */     // MIs[1] Operand 1
     /*  380810 */     // No operand predicates
     /*  380810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  380822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380842 */     GIR_RootConstrainSelectedInstOperands,
     /*  380843 */     // GIR_Coverage, 24564,
     /*  380843 */     GIR_EraseRootFromParent_Done,
     /*  380844 */   // Label 6851: @380844
     /*  380844 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(380930), // Rule ID 24565 //
     /*  380849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  380852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  380872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380896 */     // MIs[1] Operand 1
     /*  380896 */     // No operand predicates
     /*  380896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380905 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  380908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  380914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  380917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380928 */     GIR_RootConstrainSelectedInstOperands,
     /*  380929 */     // GIR_Coverage, 24565,
     /*  380929 */     GIR_EraseRootFromParent_Done,
     /*  380930 */   // Label 6852: @380930
     /*  380930 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(381016), // Rule ID 24568 //
     /*  380935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  380938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  380943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  380958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  380974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  380978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  380982 */     // MIs[1] Operand 1
     /*  380982 */     // No operand predicates
     /*  380982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  380984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380991 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  380994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381014 */     GIR_RootConstrainSelectedInstOperands,
     /*  381015 */     // GIR_Coverage, 24568,
     /*  381015 */     GIR_EraseRootFromParent_Done,
     /*  381016 */   // Label 6853: @381016
     /*  381016 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(381102), // Rule ID 24569 //
     /*  381021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381068 */     // MIs[1] Operand 1
     /*  381068 */     // No operand predicates
     /*  381068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381077 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  381080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381100 */     GIR_RootConstrainSelectedInstOperands,
     /*  381101 */     // GIR_Coverage, 24569,
     /*  381101 */     GIR_EraseRootFromParent_Done,
     /*  381102 */   // Label 6854: @381102
     /*  381102 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(381188), // Rule ID 24572 //
     /*  381107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381154 */     // MIs[1] Operand 1
     /*  381154 */     // No operand predicates
     /*  381154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381163 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  381166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381186 */     GIR_RootConstrainSelectedInstOperands,
     /*  381187 */     // GIR_Coverage, 24572,
     /*  381187 */     GIR_EraseRootFromParent_Done,
     /*  381188 */   // Label 6855: @381188
     /*  381188 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(381274), // Rule ID 24573 //
     /*  381193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381240 */     // MIs[1] Operand 1
     /*  381240 */     // No operand predicates
     /*  381240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381249 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  381252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381272 */     GIR_RootConstrainSelectedInstOperands,
     /*  381273 */     // GIR_Coverage, 24573,
     /*  381273 */     GIR_EraseRootFromParent_Done,
     /*  381274 */   // Label 6856: @381274
     /*  381274 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(381360), // Rule ID 24576 //
     /*  381279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381326 */     // MIs[1] Operand 1
     /*  381326 */     // No operand predicates
     /*  381326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381335 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  381338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381358 */     GIR_RootConstrainSelectedInstOperands,
     /*  381359 */     // GIR_Coverage, 24576,
     /*  381359 */     GIR_EraseRootFromParent_Done,
     /*  381360 */   // Label 6857: @381360
     /*  381360 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(381446), // Rule ID 24577 //
     /*  381365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381412 */     // MIs[1] Operand 1
     /*  381412 */     // No operand predicates
     /*  381412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  381424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381444 */     GIR_RootConstrainSelectedInstOperands,
     /*  381445 */     // GIR_Coverage, 24577,
     /*  381445 */     GIR_EraseRootFromParent_Done,
     /*  381446 */   // Label 6858: @381446
     /*  381446 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(381532), // Rule ID 24580 //
     /*  381451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381498 */     // MIs[1] Operand 1
     /*  381498 */     // No operand predicates
     /*  381498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381507 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  381510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381530 */     GIR_RootConstrainSelectedInstOperands,
     /*  381531 */     // GIR_Coverage, 24580,
     /*  381531 */     GIR_EraseRootFromParent_Done,
     /*  381532 */   // Label 6859: @381532
     /*  381532 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(381618), // Rule ID 24581 //
     /*  381537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381584 */     // MIs[1] Operand 1
     /*  381584 */     // No operand predicates
     /*  381584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381593 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  381596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381616 */     GIR_RootConstrainSelectedInstOperands,
     /*  381617 */     // GIR_Coverage, 24581,
     /*  381617 */     GIR_EraseRootFromParent_Done,
     /*  381618 */   // Label 6860: @381618
     /*  381618 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(381704), // Rule ID 24584 //
     /*  381623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381670 */     // MIs[1] Operand 1
     /*  381670 */     // No operand predicates
     /*  381670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381679 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  381682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381702 */     GIR_RootConstrainSelectedInstOperands,
     /*  381703 */     // GIR_Coverage, 24584,
     /*  381703 */     GIR_EraseRootFromParent_Done,
     /*  381704 */   // Label 6861: @381704
     /*  381704 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(381790), // Rule ID 24585 //
     /*  381709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381756 */     // MIs[1] Operand 1
     /*  381756 */     // No operand predicates
     /*  381756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381765 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  381768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381788 */     GIR_RootConstrainSelectedInstOperands,
     /*  381789 */     // GIR_Coverage, 24585,
     /*  381789 */     GIR_EraseRootFromParent_Done,
     /*  381790 */   // Label 6862: @381790
     /*  381790 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(381876), // Rule ID 24588 //
     /*  381795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381842 */     // MIs[1] Operand 1
     /*  381842 */     // No operand predicates
     /*  381842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  381854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381874 */     GIR_RootConstrainSelectedInstOperands,
     /*  381875 */     // GIR_Coverage, 24588,
     /*  381875 */     GIR_EraseRootFromParent_Done,
     /*  381876 */   // Label 6863: @381876
     /*  381876 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(381962), // Rule ID 24589 //
     /*  381881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  381884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  381904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  381920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  381924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  381928 */     // MIs[1] Operand 1
     /*  381928 */     // No operand predicates
     /*  381928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  381930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  381940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  381946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  381949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381960 */     GIR_RootConstrainSelectedInstOperands,
     /*  381961 */     // GIR_Coverage, 24589,
     /*  381961 */     GIR_EraseRootFromParent_Done,
     /*  381962 */   // Label 6864: @381962
     /*  381962 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(382048), // Rule ID 24592 //
     /*  381967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  381970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  381975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  381990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382014 */     // MIs[1] Operand 1
     /*  382014 */     // No operand predicates
     /*  382014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  382026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382046 */     GIR_RootConstrainSelectedInstOperands,
     /*  382047 */     // GIR_Coverage, 24592,
     /*  382047 */     GIR_EraseRootFromParent_Done,
     /*  382048 */   // Label 6865: @382048
     /*  382048 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(382134), // Rule ID 24593 //
     /*  382053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  382056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382100 */     // MIs[1] Operand 1
     /*  382100 */     // No operand predicates
     /*  382100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  382112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382132 */     GIR_RootConstrainSelectedInstOperands,
     /*  382133 */     // GIR_Coverage, 24593,
     /*  382133 */     GIR_EraseRootFromParent_Done,
     /*  382134 */   // Label 6866: @382134
     /*  382134 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(382220), // Rule ID 24596 //
     /*  382139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  382142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  382162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382186 */     // MIs[1] Operand 1
     /*  382186 */     // No operand predicates
     /*  382186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  382198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382218 */     GIR_RootConstrainSelectedInstOperands,
     /*  382219 */     // GIR_Coverage, 24596,
     /*  382219 */     GIR_EraseRootFromParent_Done,
     /*  382220 */   // Label 6867: @382220
     /*  382220 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(382306), // Rule ID 24597 //
     /*  382225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  382228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382272 */     // MIs[1] Operand 1
     /*  382272 */     // No operand predicates
     /*  382272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382281 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  382284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382304 */     GIR_RootConstrainSelectedInstOperands,
     /*  382305 */     // GIR_Coverage, 24597,
     /*  382305 */     GIR_EraseRootFromParent_Done,
     /*  382306 */   // Label 6868: @382306
     /*  382306 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(382392), // Rule ID 24600 //
     /*  382311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  382314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  382334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382358 */     // MIs[1] Operand 1
     /*  382358 */     // No operand predicates
     /*  382358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  382370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382390 */     GIR_RootConstrainSelectedInstOperands,
     /*  382391 */     // GIR_Coverage, 24600,
     /*  382391 */     GIR_EraseRootFromParent_Done,
     /*  382392 */   // Label 6869: @382392
     /*  382392 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(382478), // Rule ID 24601 //
     /*  382397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  382400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382444 */     // MIs[1] Operand 1
     /*  382444 */     // No operand predicates
     /*  382444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  382456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382476 */     GIR_RootConstrainSelectedInstOperands,
     /*  382477 */     // GIR_Coverage, 24601,
     /*  382477 */     GIR_EraseRootFromParent_Done,
     /*  382478 */   // Label 6870: @382478
     /*  382478 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(382564), // Rule ID 24604 //
     /*  382483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  382486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  382506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382530 */     // MIs[1] Operand 1
     /*  382530 */     // No operand predicates
     /*  382530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382539 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  382542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382562 */     GIR_RootConstrainSelectedInstOperands,
     /*  382563 */     // GIR_Coverage, 24604,
     /*  382563 */     GIR_EraseRootFromParent_Done,
     /*  382564 */   // Label 6871: @382564
     /*  382564 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(382650), // Rule ID 24605 //
     /*  382569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  382572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382616 */     // MIs[1] Operand 1
     /*  382616 */     // No operand predicates
     /*  382616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382625 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  382628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382648 */     GIR_RootConstrainSelectedInstOperands,
     /*  382649 */     // GIR_Coverage, 24605,
     /*  382649 */     GIR_EraseRootFromParent_Done,
     /*  382650 */   // Label 6872: @382650
     /*  382650 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(382736), // Rule ID 24608 //
     /*  382655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  382658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  382678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382702 */     // MIs[1] Operand 1
     /*  382702 */     // No operand predicates
     /*  382702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  382714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382734 */     GIR_RootConstrainSelectedInstOperands,
     /*  382735 */     // GIR_Coverage, 24608,
     /*  382735 */     GIR_EraseRootFromParent_Done,
     /*  382736 */   // Label 6873: @382736
     /*  382736 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(382822), // Rule ID 24609 //
     /*  382741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  382744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382788 */     // MIs[1] Operand 1
     /*  382788 */     // No operand predicates
     /*  382788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382797 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  382800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382820 */     GIR_RootConstrainSelectedInstOperands,
     /*  382821 */     // GIR_Coverage, 24609,
     /*  382821 */     GIR_EraseRootFromParent_Done,
     /*  382822 */   // Label 6874: @382822
     /*  382822 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(382908), // Rule ID 24768 //
     /*  382827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  382830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  382850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382874 */     // MIs[1] Operand 1
     /*  382874 */     // No operand predicates
     /*  382874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382883 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  382886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382906 */     GIR_RootConstrainSelectedInstOperands,
     /*  382907 */     // GIR_Coverage, 24768,
     /*  382907 */     GIR_EraseRootFromParent_Done,
     /*  382908 */   // Label 6875: @382908
     /*  382908 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(382994), // Rule ID 24769 //
     /*  382913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  382916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  382921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  382936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  382952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  382956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  382960 */     // MIs[1] Operand 1
     /*  382960 */     // No operand predicates
     /*  382960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  382962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382969 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  382972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  382978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  382981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382992 */     GIR_RootConstrainSelectedInstOperands,
     /*  382993 */     // GIR_Coverage, 24769,
     /*  382993 */     GIR_EraseRootFromParent_Done,
     /*  382994 */   // Label 6876: @382994
     /*  382994 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(383080), // Rule ID 24772 //
     /*  382999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  383002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383046 */     // MIs[1] Operand 1
     /*  383046 */     // No operand predicates
     /*  383046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383055 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  383058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383078 */     GIR_RootConstrainSelectedInstOperands,
     /*  383079 */     // GIR_Coverage, 24772,
     /*  383079 */     GIR_EraseRootFromParent_Done,
     /*  383080 */   // Label 6877: @383080
     /*  383080 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(383166), // Rule ID 24773 //
     /*  383085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  383088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383132 */     // MIs[1] Operand 1
     /*  383132 */     // No operand predicates
     /*  383132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383141 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  383144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383164 */     GIR_RootConstrainSelectedInstOperands,
     /*  383165 */     // GIR_Coverage, 24773,
     /*  383165 */     GIR_EraseRootFromParent_Done,
     /*  383166 */   // Label 6878: @383166
     /*  383166 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(383252), // Rule ID 24776 //
     /*  383171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  383174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383218 */     // MIs[1] Operand 1
     /*  383218 */     // No operand predicates
     /*  383218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  383230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383250 */     GIR_RootConstrainSelectedInstOperands,
     /*  383251 */     // GIR_Coverage, 24776,
     /*  383251 */     GIR_EraseRootFromParent_Done,
     /*  383252 */   // Label 6879: @383252
     /*  383252 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(383338), // Rule ID 24777 //
     /*  383257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  383260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383304 */     // MIs[1] Operand 1
     /*  383304 */     // No operand predicates
     /*  383304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383313 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  383316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383336 */     GIR_RootConstrainSelectedInstOperands,
     /*  383337 */     // GIR_Coverage, 24777,
     /*  383337 */     GIR_EraseRootFromParent_Done,
     /*  383338 */   // Label 6880: @383338
     /*  383338 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(383424), // Rule ID 24780 //
     /*  383343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  383346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  383354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  383357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  383360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383390 */     // MIs[1] Operand 1
     /*  383390 */     // No operand predicates
     /*  383390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383399 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  383402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383422 */     GIR_RootConstrainSelectedInstOperands,
     /*  383423 */     // GIR_Coverage, 24780,
     /*  383423 */     GIR_EraseRootFromParent_Done,
     /*  383424 */   // Label 6881: @383424
     /*  383424 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(383510), // Rule ID 24781 //
     /*  383429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  383432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  383440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  383443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  383446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383476 */     // MIs[1] Operand 1
     /*  383476 */     // No operand predicates
     /*  383476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383485 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  383488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383508 */     GIR_RootConstrainSelectedInstOperands,
     /*  383509 */     // GIR_Coverage, 24781,
     /*  383509 */     GIR_EraseRootFromParent_Done,
     /*  383510 */   // Label 6882: @383510
     /*  383510 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(383596), // Rule ID 24784 //
     /*  383515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  383518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  383526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  383529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  383532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383562 */     // MIs[1] Operand 1
     /*  383562 */     // No operand predicates
     /*  383562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383571 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  383574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383594 */     GIR_RootConstrainSelectedInstOperands,
     /*  383595 */     // GIR_Coverage, 24784,
     /*  383595 */     GIR_EraseRootFromParent_Done,
     /*  383596 */   // Label 6883: @383596
     /*  383596 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(383682), // Rule ID 24785 //
     /*  383601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  383604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  383612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  383615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  383618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383648 */     // MIs[1] Operand 1
     /*  383648 */     // No operand predicates
     /*  383648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383657 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  383660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383680 */     GIR_RootConstrainSelectedInstOperands,
     /*  383681 */     // GIR_Coverage, 24785,
     /*  383681 */     GIR_EraseRootFromParent_Done,
     /*  383682 */   // Label 6884: @383682
     /*  383682 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(383768), // Rule ID 24788 //
     /*  383687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  383690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  383698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  383701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  383704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383734 */     // MIs[1] Operand 1
     /*  383734 */     // No operand predicates
     /*  383734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383743 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  383746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383766 */     GIR_RootConstrainSelectedInstOperands,
     /*  383767 */     // GIR_Coverage, 24788,
     /*  383767 */     GIR_EraseRootFromParent_Done,
     /*  383768 */   // Label 6885: @383768
     /*  383768 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(383854), // Rule ID 24789 //
     /*  383773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  383776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  383784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  383787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  383790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383820 */     // MIs[1] Operand 1
     /*  383820 */     // No operand predicates
     /*  383820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383829 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  383832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383852 */     GIR_RootConstrainSelectedInstOperands,
     /*  383853 */     // GIR_Coverage, 24789,
     /*  383853 */     GIR_EraseRootFromParent_Done,
     /*  383854 */   // Label 6886: @383854
     /*  383854 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(383940), // Rule ID 24792 //
     /*  383859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  383862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  383870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  383873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  383876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  383882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383906 */     // MIs[1] Operand 1
     /*  383906 */     // No operand predicates
     /*  383906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383915 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  383918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  383924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  383927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383938 */     GIR_RootConstrainSelectedInstOperands,
     /*  383939 */     // GIR_Coverage, 24792,
     /*  383939 */     GIR_EraseRootFromParent_Done,
     /*  383940 */   // Label 6887: @383940
     /*  383940 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(384026), // Rule ID 24793 //
     /*  383945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  383948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  383953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  383956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  383959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  383962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  383968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  383984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  383988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  383992 */     // MIs[1] Operand 1
     /*  383992 */     // No operand predicates
     /*  383992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  383994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384001 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  384004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384024 */     GIR_RootConstrainSelectedInstOperands,
     /*  384025 */     // GIR_Coverage, 24793,
     /*  384025 */     GIR_EraseRootFromParent_Done,
     /*  384026 */   // Label 6888: @384026
     /*  384026 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(384112), // Rule ID 24796 //
     /*  384031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  384034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384078 */     // MIs[1] Operand 1
     /*  384078 */     // No operand predicates
     /*  384078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384087 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  384090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384110 */     GIR_RootConstrainSelectedInstOperands,
     /*  384111 */     // GIR_Coverage, 24796,
     /*  384111 */     GIR_EraseRootFromParent_Done,
     /*  384112 */   // Label 6889: @384112
     /*  384112 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(384198), // Rule ID 24797 //
     /*  384117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  384120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  384140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384164 */     // MIs[1] Operand 1
     /*  384164 */     // No operand predicates
     /*  384164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384173 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  384176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384196 */     GIR_RootConstrainSelectedInstOperands,
     /*  384197 */     // GIR_Coverage, 24797,
     /*  384197 */     GIR_EraseRootFromParent_Done,
     /*  384198 */   // Label 6890: @384198
     /*  384198 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(384284), // Rule ID 24800 //
     /*  384203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  384206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384250 */     // MIs[1] Operand 1
     /*  384250 */     // No operand predicates
     /*  384250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384259 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  384262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384282 */     GIR_RootConstrainSelectedInstOperands,
     /*  384283 */     // GIR_Coverage, 24800,
     /*  384283 */     GIR_EraseRootFromParent_Done,
     /*  384284 */   // Label 6891: @384284
     /*  384284 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(384370), // Rule ID 24801 //
     /*  384289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  384292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  384312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384336 */     // MIs[1] Operand 1
     /*  384336 */     // No operand predicates
     /*  384336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384345 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  384348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384368 */     GIR_RootConstrainSelectedInstOperands,
     /*  384369 */     // GIR_Coverage, 24801,
     /*  384369 */     GIR_EraseRootFromParent_Done,
     /*  384370 */   // Label 6892: @384370
     /*  384370 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(384456), // Rule ID 24852 //
     /*  384375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  384378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  384386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  384389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  384392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384422 */     // MIs[1] Operand 1
     /*  384422 */     // No operand predicates
     /*  384422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384431 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  384434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384454 */     GIR_RootConstrainSelectedInstOperands,
     /*  384455 */     // GIR_Coverage, 24852,
     /*  384455 */     GIR_EraseRootFromParent_Done,
     /*  384456 */   // Label 6893: @384456
     /*  384456 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(384542), // Rule ID 24853 //
     /*  384461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  384464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  384472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  384475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  384478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  384484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384508 */     // MIs[1] Operand 1
     /*  384508 */     // No operand predicates
     /*  384508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384517 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  384520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384540 */     GIR_RootConstrainSelectedInstOperands,
     /*  384541 */     // GIR_Coverage, 24853,
     /*  384541 */     GIR_EraseRootFromParent_Done,
     /*  384542 */   // Label 6894: @384542
     /*  384542 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(384628), // Rule ID 24856 //
     /*  384547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  384550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  384558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  384561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  384564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384594 */     // MIs[1] Operand 1
     /*  384594 */     // No operand predicates
     /*  384594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384603 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  384606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384626 */     GIR_RootConstrainSelectedInstOperands,
     /*  384627 */     // GIR_Coverage, 24856,
     /*  384627 */     GIR_EraseRootFromParent_Done,
     /*  384628 */   // Label 6895: @384628
     /*  384628 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(384714), // Rule ID 24857 //
     /*  384633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  384636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  384644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  384647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  384650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  384656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384680 */     // MIs[1] Operand 1
     /*  384680 */     // No operand predicates
     /*  384680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384689 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  384692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384712 */     GIR_RootConstrainSelectedInstOperands,
     /*  384713 */     // GIR_Coverage, 24857,
     /*  384713 */     GIR_EraseRootFromParent_Done,
     /*  384714 */   // Label 6896: @384714
     /*  384714 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(384800), // Rule ID 24860 //
     /*  384719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  384722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  384730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  384733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  384736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384766 */     // MIs[1] Operand 1
     /*  384766 */     // No operand predicates
     /*  384766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384775 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  384778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384798 */     GIR_RootConstrainSelectedInstOperands,
     /*  384799 */     // GIR_Coverage, 24860,
     /*  384799 */     GIR_EraseRootFromParent_Done,
     /*  384800 */   // Label 6897: @384800
     /*  384800 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(384886), // Rule ID 24861 //
     /*  384805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  384808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  384816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  384819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  384822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  384828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384852 */     // MIs[1] Operand 1
     /*  384852 */     // No operand predicates
     /*  384852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384861 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  384864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384884 */     GIR_RootConstrainSelectedInstOperands,
     /*  384885 */     // GIR_Coverage, 24861,
     /*  384885 */     GIR_EraseRootFromParent_Done,
     /*  384886 */   // Label 6898: @384886
     /*  384886 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(384972), // Rule ID 24864 //
     /*  384891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  384894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  384914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384938 */     // MIs[1] Operand 1
     /*  384938 */     // No operand predicates
     /*  384938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384947 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  384950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  384956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  384959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384970 */     GIR_RootConstrainSelectedInstOperands,
     /*  384971 */     // GIR_Coverage, 24864,
     /*  384971 */     GIR_EraseRootFromParent_Done,
     /*  384972 */   // Label 6899: @384972
     /*  384972 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(385058), // Rule ID 24865 //
     /*  384977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  384980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  384985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385024 */     // MIs[1] Operand 1
     /*  385024 */     // No operand predicates
     /*  385024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  385036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385056 */     GIR_RootConstrainSelectedInstOperands,
     /*  385057 */     // GIR_Coverage, 24865,
     /*  385057 */     GIR_EraseRootFromParent_Done,
     /*  385058 */   // Label 6900: @385058
     /*  385058 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(385144), // Rule ID 24868 //
     /*  385063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  385066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  385071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  385074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  385077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  385080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385110 */     // MIs[1] Operand 1
     /*  385110 */     // No operand predicates
     /*  385110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385119 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  385119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  385122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385142 */     GIR_RootConstrainSelectedInstOperands,
     /*  385143 */     // GIR_Coverage, 24868,
     /*  385143 */     GIR_EraseRootFromParent_Done,
     /*  385144 */   // Label 6901: @385144
     /*  385144 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(385230), // Rule ID 24869 //
     /*  385149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  385152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  385157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  385160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  385163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  385166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385196 */     // MIs[1] Operand 1
     /*  385196 */     // No operand predicates
     /*  385196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385205 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  385208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385228 */     GIR_RootConstrainSelectedInstOperands,
     /*  385229 */     // GIR_Coverage, 24869,
     /*  385229 */     GIR_EraseRootFromParent_Done,
     /*  385230 */   // Label 6902: @385230
     /*  385230 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(385316), // Rule ID 24872 //
     /*  385235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  385238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  385243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385282 */     // MIs[1] Operand 1
     /*  385282 */     // No operand predicates
     /*  385282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385291 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  385291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  385294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385314 */     GIR_RootConstrainSelectedInstOperands,
     /*  385315 */     // GIR_Coverage, 24872,
     /*  385315 */     GIR_EraseRootFromParent_Done,
     /*  385316 */   // Label 6903: @385316
     /*  385316 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(385402), // Rule ID 24873 //
     /*  385321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  385324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  385329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385368 */     // MIs[1] Operand 1
     /*  385368 */     // No operand predicates
     /*  385368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385377 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  385380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385400 */     GIR_RootConstrainSelectedInstOperands,
     /*  385401 */     // GIR_Coverage, 24873,
     /*  385401 */     GIR_EraseRootFromParent_Done,
     /*  385402 */   // Label 6904: @385402
     /*  385402 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(385488), // Rule ID 60308 //
     /*  385407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  385410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  385418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  385421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  385424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385454 */     // MIs[1] Operand 1
     /*  385454 */     // No operand predicates
     /*  385454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385463 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  385466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385486 */     GIR_RootConstrainSelectedInstOperands,
     /*  385487 */     // GIR_Coverage, 60308,
     /*  385487 */     GIR_EraseRootFromParent_Done,
     /*  385488 */   // Label 6905: @385488
     /*  385488 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(385574), // Rule ID 60309 //
     /*  385493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  385496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  385504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  385507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  385510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385540 */     // MIs[1] Operand 1
     /*  385540 */     // No operand predicates
     /*  385540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  385549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  385552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385572 */     GIR_RootConstrainSelectedInstOperands,
     /*  385573 */     // GIR_Coverage, 60309,
     /*  385573 */     GIR_EraseRootFromParent_Done,
     /*  385574 */   // Label 6906: @385574
     /*  385574 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(385660), // Rule ID 60316 //
     /*  385579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  385582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  385590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  385593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  385596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385626 */     // MIs[1] Operand 1
     /*  385626 */     // No operand predicates
     /*  385626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385635 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  385638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385658 */     GIR_RootConstrainSelectedInstOperands,
     /*  385659 */     // GIR_Coverage, 60316,
     /*  385659 */     GIR_EraseRootFromParent_Done,
     /*  385660 */   // Label 6907: @385660
     /*  385660 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(385746), // Rule ID 60317 //
     /*  385665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  385668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  385676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  385679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  385682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385712 */     // MIs[1] Operand 1
     /*  385712 */     // No operand predicates
     /*  385712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385721 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  385721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  385724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385744 */     GIR_RootConstrainSelectedInstOperands,
     /*  385745 */     // GIR_Coverage, 60317,
     /*  385745 */     GIR_EraseRootFromParent_Done,
     /*  385746 */   // Label 6908: @385746
     /*  385746 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(385832), // Rule ID 60324 //
     /*  385751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  385754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  385762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  385765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  385768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385798 */     // MIs[1] Operand 1
     /*  385798 */     // No operand predicates
     /*  385798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  385810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385830 */     GIR_RootConstrainSelectedInstOperands,
     /*  385831 */     // GIR_Coverage, 60324,
     /*  385831 */     GIR_EraseRootFromParent_Done,
     /*  385832 */   // Label 6909: @385832
     /*  385832 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(385918), // Rule ID 60325 //
     /*  385837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  385840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  385848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  385851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  385854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  385860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385884 */     // MIs[1] Operand 1
     /*  385884 */     // No operand predicates
     /*  385884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  385893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  385896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385916 */     GIR_RootConstrainSelectedInstOperands,
     /*  385917 */     // GIR_Coverage, 60325,
     /*  385917 */     GIR_EraseRootFromParent_Done,
     /*  385918 */   // Label 6910: @385918
     /*  385918 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(386004), // Rule ID 60332 //
     /*  385923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  385926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  385931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  385934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  385937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  385940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  385946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385970 */     // MIs[1] Operand 1
     /*  385970 */     // No operand predicates
     /*  385970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385979 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  385982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  385988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  385991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  385999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386002 */     GIR_RootConstrainSelectedInstOperands,
     /*  386003 */     // GIR_Coverage, 60332,
     /*  386003 */     GIR_EraseRootFromParent_Done,
     /*  386004 */   // Label 6911: @386004
     /*  386004 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(386090), // Rule ID 60333 //
     /*  386009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  386020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  386023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  386026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386056 */     // MIs[1] Operand 1
     /*  386056 */     // No operand predicates
     /*  386056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  386068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386088 */     GIR_RootConstrainSelectedInstOperands,
     /*  386089 */     // GIR_Coverage, 60333,
     /*  386089 */     GIR_EraseRootFromParent_Done,
     /*  386090 */   // Label 6912: @386090
     /*  386090 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(386176), // Rule ID 60340 //
     /*  386095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  386106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  386109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  386112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386142 */     // MIs[1] Operand 1
     /*  386142 */     // No operand predicates
     /*  386142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386151 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  386154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386174 */     GIR_RootConstrainSelectedInstOperands,
     /*  386175 */     // GIR_Coverage, 60340,
     /*  386175 */     GIR_EraseRootFromParent_Done,
     /*  386176 */   // Label 6913: @386176
     /*  386176 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(386262), // Rule ID 60341 //
     /*  386181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  386192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  386195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  386198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386228 */     // MIs[1] Operand 1
     /*  386228 */     // No operand predicates
     /*  386228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  386240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386260 */     GIR_RootConstrainSelectedInstOperands,
     /*  386261 */     // GIR_Coverage, 60341,
     /*  386261 */     GIR_EraseRootFromParent_Done,
     /*  386262 */   // Label 6914: @386262
     /*  386262 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(386348), // Rule ID 60348 //
     /*  386267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  386278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  386281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  386284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  386294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  386298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386314 */     // MIs[1] Operand 1
     /*  386314 */     // No operand predicates
     /*  386314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  386326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386346 */     GIR_RootConstrainSelectedInstOperands,
     /*  386347 */     // GIR_Coverage, 60348,
     /*  386347 */     GIR_EraseRootFromParent_Done,
     /*  386348 */   // Label 6915: @386348
     /*  386348 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(386434), // Rule ID 60349 //
     /*  386353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  386364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  386367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  386370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  386380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  386384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386400 */     // MIs[1] Operand 1
     /*  386400 */     // No operand predicates
     /*  386400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  386412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386432 */     GIR_RootConstrainSelectedInstOperands,
     /*  386433 */     // GIR_Coverage, 60349,
     /*  386433 */     GIR_EraseRootFromParent_Done,
     /*  386434 */   // Label 6916: @386434
     /*  386434 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(386520), // Rule ID 60356 //
     /*  386439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386486 */     // MIs[1] Operand 1
     /*  386486 */     // No operand predicates
     /*  386486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386495 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  386498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386518 */     GIR_RootConstrainSelectedInstOperands,
     /*  386519 */     // GIR_Coverage, 60356,
     /*  386519 */     GIR_EraseRootFromParent_Done,
     /*  386520 */   // Label 6917: @386520
     /*  386520 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(386606), // Rule ID 60357 //
     /*  386525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386572 */     // MIs[1] Operand 1
     /*  386572 */     // No operand predicates
     /*  386572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386581 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  386584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386604 */     GIR_RootConstrainSelectedInstOperands,
     /*  386605 */     // GIR_Coverage, 60357,
     /*  386605 */     GIR_EraseRootFromParent_Done,
     /*  386606 */   // Label 6918: @386606
     /*  386606 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(386692), // Rule ID 60364 //
     /*  386611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  386622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  386625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386658 */     // MIs[1] Operand 1
     /*  386658 */     // No operand predicates
     /*  386658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  386670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386690 */     GIR_RootConstrainSelectedInstOperands,
     /*  386691 */     // GIR_Coverage, 60364,
     /*  386691 */     GIR_EraseRootFromParent_Done,
     /*  386692 */   // Label 6919: @386692
     /*  386692 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(386778), // Rule ID 60365 //
     /*  386697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  386708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  386711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386744 */     // MIs[1] Operand 1
     /*  386744 */     // No operand predicates
     /*  386744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  386756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386776 */     GIR_RootConstrainSelectedInstOperands,
     /*  386777 */     // GIR_Coverage, 60365,
     /*  386777 */     GIR_EraseRootFromParent_Done,
     /*  386778 */   // Label 6920: @386778
     /*  386778 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(386864), // Rule ID 60372 //
     /*  386783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  386794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  386797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386830 */     // MIs[1] Operand 1
     /*  386830 */     // No operand predicates
     /*  386830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  386842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386862 */     GIR_RootConstrainSelectedInstOperands,
     /*  386863 */     // GIR_Coverage, 60372,
     /*  386863 */     GIR_EraseRootFromParent_Done,
     /*  386864 */   // Label 6921: @386864
     /*  386864 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(386950), // Rule ID 60373 //
     /*  386869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  386872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  386880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  386883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  386916 */     // MIs[1] Operand 1
     /*  386916 */     // No operand predicates
     /*  386916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  386918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  386928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  386934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  386937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386948 */     GIR_RootConstrainSelectedInstOperands,
     /*  386949 */     // GIR_Coverage, 60373,
     /*  386949 */     GIR_EraseRootFromParent_Done,
     /*  386950 */   // Label 6922: @386950
     /*  386950 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(387036), // Rule ID 60380 //
     /*  386955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  386958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  386963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  386966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  386969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  386972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  386986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  386990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  386994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  386998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387002 */     // MIs[1] Operand 1
     /*  387002 */     // No operand predicates
     /*  387002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  387014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387034 */     GIR_RootConstrainSelectedInstOperands,
     /*  387035 */     // GIR_Coverage, 60380,
     /*  387035 */     GIR_EraseRootFromParent_Done,
     /*  387036 */   // Label 6923: @387036
     /*  387036 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(387122), // Rule ID 60381 //
     /*  387041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  387052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  387055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  387058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387088 */     // MIs[1] Operand 1
     /*  387088 */     // No operand predicates
     /*  387088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387097 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  387100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387120 */     GIR_RootConstrainSelectedInstOperands,
     /*  387121 */     // GIR_Coverage, 60381,
     /*  387121 */     GIR_EraseRootFromParent_Done,
     /*  387122 */   // Label 6924: @387122
     /*  387122 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(387208), // Rule ID 60388 //
     /*  387127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  387130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  387138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  387141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387174 */     // MIs[1] Operand 1
     /*  387174 */     // No operand predicates
     /*  387174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387183 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  387186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387206 */     GIR_RootConstrainSelectedInstOperands,
     /*  387207 */     // GIR_Coverage, 60388,
     /*  387207 */     GIR_EraseRootFromParent_Done,
     /*  387208 */   // Label 6925: @387208
     /*  387208 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(387294), // Rule ID 60389 //
     /*  387213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  387224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  387227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387260 */     // MIs[1] Operand 1
     /*  387260 */     // No operand predicates
     /*  387260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387269 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  387272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387292 */     GIR_RootConstrainSelectedInstOperands,
     /*  387293 */     // GIR_Coverage, 60389,
     /*  387293 */     GIR_EraseRootFromParent_Done,
     /*  387294 */   // Label 6926: @387294
     /*  387294 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(387380), // Rule ID 60396 //
     /*  387299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  387302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  387316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387346 */     // MIs[1] Operand 1
     /*  387346 */     // No operand predicates
     /*  387346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387355 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  387358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387378 */     GIR_RootConstrainSelectedInstOperands,
     /*  387379 */     // GIR_Coverage, 60396,
     /*  387379 */     GIR_EraseRootFromParent_Done,
     /*  387380 */   // Label 6927: @387380
     /*  387380 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(387466), // Rule ID 60397 //
     /*  387385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  387402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387432 */     // MIs[1] Operand 1
     /*  387432 */     // No operand predicates
     /*  387432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387441 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  387444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387464 */     GIR_RootConstrainSelectedInstOperands,
     /*  387465 */     // GIR_Coverage, 60397,
     /*  387465 */     GIR_EraseRootFromParent_Done,
     /*  387466 */   // Label 6928: @387466
     /*  387466 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(387552), // Rule ID 60404 //
     /*  387471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  387474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  387482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  387485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387518 */     // MIs[1] Operand 1
     /*  387518 */     // No operand predicates
     /*  387518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387527 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  387530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387550 */     GIR_RootConstrainSelectedInstOperands,
     /*  387551 */     // GIR_Coverage, 60404,
     /*  387551 */     GIR_EraseRootFromParent_Done,
     /*  387552 */   // Label 6929: @387552
     /*  387552 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(387638), // Rule ID 60405 //
     /*  387557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  387568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  387571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387604 */     // MIs[1] Operand 1
     /*  387604 */     // No operand predicates
     /*  387604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  387616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387636 */     GIR_RootConstrainSelectedInstOperands,
     /*  387637 */     // GIR_Coverage, 60405,
     /*  387637 */     GIR_EraseRootFromParent_Done,
     /*  387638 */   // Label 6930: @387638
     /*  387638 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(387724), // Rule ID 60412 //
     /*  387643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  387646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  387654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  387657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  387660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387690 */     // MIs[1] Operand 1
     /*  387690 */     // No operand predicates
     /*  387690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  387702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387722 */     GIR_RootConstrainSelectedInstOperands,
     /*  387723 */     // GIR_Coverage, 60412,
     /*  387723 */     GIR_EraseRootFromParent_Done,
     /*  387724 */   // Label 6931: @387724
     /*  387724 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(387810), // Rule ID 60413 //
     /*  387729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  387740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  387743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  387746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387776 */     // MIs[1] Operand 1
     /*  387776 */     // No operand predicates
     /*  387776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  387788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387808 */     GIR_RootConstrainSelectedInstOperands,
     /*  387809 */     // GIR_Coverage, 60413,
     /*  387809 */     GIR_EraseRootFromParent_Done,
     /*  387810 */   // Label 6932: @387810
     /*  387810 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(387896), // Rule ID 60420 //
     /*  387815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  387818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  387826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  387829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  387832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387862 */     // MIs[1] Operand 1
     /*  387862 */     // No operand predicates
     /*  387862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387871 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  387874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387894 */     GIR_RootConstrainSelectedInstOperands,
     /*  387895 */     // GIR_Coverage, 60420,
     /*  387895 */     GIR_EraseRootFromParent_Done,
     /*  387896 */   // Label 6933: @387896
     /*  387896 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(387982), // Rule ID 60421 //
     /*  387901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  387904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  387909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  387912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  387915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  387918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  387940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  387944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  387948 */     // MIs[1] Operand 1
     /*  387948 */     // No operand predicates
     /*  387948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  387950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387957 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  387960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  387966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  387969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387980 */     GIR_RootConstrainSelectedInstOperands,
     /*  387981 */     // GIR_Coverage, 60421,
     /*  387981 */     GIR_EraseRootFromParent_Done,
     /*  387982 */   // Label 6934: @387982
     /*  387982 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(388068), // Rule ID 61276 //
     /*  387987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  387995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  388001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  388004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388034 */     // MIs[1] Operand 1
     /*  388034 */     // No operand predicates
     /*  388034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388043 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  388043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  388046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388066 */     GIR_RootConstrainSelectedInstOperands,
     /*  388067 */     // GIR_Coverage, 61276,
     /*  388067 */     GIR_EraseRootFromParent_Done,
     /*  388068 */   // Label 6935: @388068
     /*  388068 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(388154), // Rule ID 61277 //
     /*  388073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  388084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  388087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  388090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388120 */     // MIs[1] Operand 1
     /*  388120 */     // No operand predicates
     /*  388120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388129 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  388129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  388132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388152 */     GIR_RootConstrainSelectedInstOperands,
     /*  388153 */     // GIR_Coverage, 61277,
     /*  388153 */     GIR_EraseRootFromParent_Done,
     /*  388154 */   // Label 6936: @388154
     /*  388154 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(388240), // Rule ID 61280 //
     /*  388159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  388173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  388176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388206 */     // MIs[1] Operand 1
     /*  388206 */     // No operand predicates
     /*  388206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388215 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  388215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  388218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388238 */     GIR_RootConstrainSelectedInstOperands,
     /*  388239 */     // GIR_Coverage, 61280,
     /*  388239 */     GIR_EraseRootFromParent_Done,
     /*  388240 */   // Label 6937: @388240
     /*  388240 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(388326), // Rule ID 61281 //
     /*  388245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  388259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  388262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388292 */     // MIs[1] Operand 1
     /*  388292 */     // No operand predicates
     /*  388292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388301 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  388301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  388304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388324 */     GIR_RootConstrainSelectedInstOperands,
     /*  388325 */     // GIR_Coverage, 61281,
     /*  388325 */     GIR_EraseRootFromParent_Done,
     /*  388326 */   // Label 6938: @388326
     /*  388326 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(388412), // Rule ID 61284 //
     /*  388331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  388345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  388348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388378 */     // MIs[1] Operand 1
     /*  388378 */     // No operand predicates
     /*  388378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388387 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  388387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388410 */     GIR_RootConstrainSelectedInstOperands,
     /*  388411 */     // GIR_Coverage, 61284,
     /*  388411 */     GIR_EraseRootFromParent_Done,
     /*  388412 */   // Label 6939: @388412
     /*  388412 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(388498), // Rule ID 61285 //
     /*  388417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  388431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  388434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388464 */     // MIs[1] Operand 1
     /*  388464 */     // No operand predicates
     /*  388464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388473 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  388473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388496 */     GIR_RootConstrainSelectedInstOperands,
     /*  388497 */     // GIR_Coverage, 61285,
     /*  388497 */     GIR_EraseRootFromParent_Done,
     /*  388498 */   // Label 6940: @388498
     /*  388498 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(388584), // Rule ID 61288 //
     /*  388503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  388517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  388520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388550 */     // MIs[1] Operand 1
     /*  388550 */     // No operand predicates
     /*  388550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388559 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  388559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  388562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388582 */     GIR_RootConstrainSelectedInstOperands,
     /*  388583 */     // GIR_Coverage, 61288,
     /*  388583 */     GIR_EraseRootFromParent_Done,
     /*  388584 */   // Label 6941: @388584
     /*  388584 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(388670), // Rule ID 61289 //
     /*  388589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  388603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  388606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388636 */     // MIs[1] Operand 1
     /*  388636 */     // No operand predicates
     /*  388636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388645 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  388645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  388648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388668 */     GIR_RootConstrainSelectedInstOperands,
     /*  388669 */     // GIR_Coverage, 61289,
     /*  388669 */     GIR_EraseRootFromParent_Done,
     /*  388670 */   // Label 6942: @388670
     /*  388670 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(388756), // Rule ID 61292 //
     /*  388675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  388689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  388692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388722 */     // MIs[1] Operand 1
     /*  388722 */     // No operand predicates
     /*  388722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388731 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  388731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388754 */     GIR_RootConstrainSelectedInstOperands,
     /*  388755 */     // GIR_Coverage, 61292,
     /*  388755 */     GIR_EraseRootFromParent_Done,
     /*  388756 */   // Label 6943: @388756
     /*  388756 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(388842), // Rule ID 61293 //
     /*  388761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  388775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  388778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388808 */     // MIs[1] Operand 1
     /*  388808 */     // No operand predicates
     /*  388808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388817 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  388817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388840 */     GIR_RootConstrainSelectedInstOperands,
     /*  388841 */     // GIR_Coverage, 61293,
     /*  388841 */     GIR_EraseRootFromParent_Done,
     /*  388842 */   // Label 6944: @388842
     /*  388842 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(388928), // Rule ID 61296 //
     /*  388847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  388861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  388864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388894 */     // MIs[1] Operand 1
     /*  388894 */     // No operand predicates
     /*  388894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388903 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  388915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388926 */     GIR_RootConstrainSelectedInstOperands,
     /*  388927 */     // GIR_Coverage, 61296,
     /*  388927 */     GIR_EraseRootFromParent_Done,
     /*  388928 */   // Label 6945: @388928
     /*  388928 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(389014), // Rule ID 61297 //
     /*  388933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  388941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  388947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  388950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  388980 */     // MIs[1] Operand 1
     /*  388980 */     // No operand predicates
     /*  388980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388989 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  388992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  388998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389012 */     GIR_RootConstrainSelectedInstOperands,
     /*  389013 */     // GIR_Coverage, 61297,
     /*  389013 */     GIR_EraseRootFromParent_Done,
     /*  389014 */   // Label 6946: @389014
     /*  389014 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(389100), // Rule ID 61300 //
     /*  389019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  389030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  389033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  389036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389066 */     // MIs[1] Operand 1
     /*  389066 */     // No operand predicates
     /*  389066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389075 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  389075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389098 */     GIR_RootConstrainSelectedInstOperands,
     /*  389099 */     // GIR_Coverage, 61300,
     /*  389099 */     GIR_EraseRootFromParent_Done,
     /*  389100 */   // Label 6947: @389100
     /*  389100 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(389186), // Rule ID 61301 //
     /*  389105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  389116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  389119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  389122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389152 */     // MIs[1] Operand 1
     /*  389152 */     // No operand predicates
     /*  389152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389161 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  389161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389184 */     GIR_RootConstrainSelectedInstOperands,
     /*  389185 */     // GIR_Coverage, 61301,
     /*  389185 */     GIR_EraseRootFromParent_Done,
     /*  389186 */   // Label 6948: @389186
     /*  389186 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(389272), // Rule ID 61304 //
     /*  389191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  389202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  389205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  389208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389238 */     // MIs[1] Operand 1
     /*  389238 */     // No operand predicates
     /*  389238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389247 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  389247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389270 */     GIR_RootConstrainSelectedInstOperands,
     /*  389271 */     // GIR_Coverage, 61304,
     /*  389271 */     GIR_EraseRootFromParent_Done,
     /*  389272 */   // Label 6949: @389272
     /*  389272 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(389358), // Rule ID 61305 //
     /*  389277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  389288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  389291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  389294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389324 */     // MIs[1] Operand 1
     /*  389324 */     // No operand predicates
     /*  389324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  389333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389356 */     GIR_RootConstrainSelectedInstOperands,
     /*  389357 */     // GIR_Coverage, 61305,
     /*  389357 */     GIR_EraseRootFromParent_Done,
     /*  389358 */   // Label 6950: @389358
     /*  389358 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(389444), // Rule ID 61308 //
     /*  389363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  389377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  389380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389410 */     // MIs[1] Operand 1
     /*  389410 */     // No operand predicates
     /*  389410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  389419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389442 */     GIR_RootConstrainSelectedInstOperands,
     /*  389443 */     // GIR_Coverage, 61308,
     /*  389443 */     GIR_EraseRootFromParent_Done,
     /*  389444 */   // Label 6951: @389444
     /*  389444 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(389530), // Rule ID 61309 //
     /*  389449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  389463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  389466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389496 */     // MIs[1] Operand 1
     /*  389496 */     // No operand predicates
     /*  389496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389505 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  389505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389528 */     GIR_RootConstrainSelectedInstOperands,
     /*  389529 */     // GIR_Coverage, 61309,
     /*  389529 */     GIR_EraseRootFromParent_Done,
     /*  389530 */   // Label 6952: @389530
     /*  389530 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(389616), // Rule ID 61312 //
     /*  389535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  389549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  389552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389582 */     // MIs[1] Operand 1
     /*  389582 */     // No operand predicates
     /*  389582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389591 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  389591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389614 */     GIR_RootConstrainSelectedInstOperands,
     /*  389615 */     // GIR_Coverage, 61312,
     /*  389615 */     GIR_EraseRootFromParent_Done,
     /*  389616 */   // Label 6953: @389616
     /*  389616 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(389702), // Rule ID 61313 //
     /*  389621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  389635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  389638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389668 */     // MIs[1] Operand 1
     /*  389668 */     // No operand predicates
     /*  389668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  389677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  389680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389700 */     GIR_RootConstrainSelectedInstOperands,
     /*  389701 */     // GIR_Coverage, 61313,
     /*  389701 */     GIR_EraseRootFromParent_Done,
     /*  389702 */   // Label 6954: @389702
     /*  389702 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(389788), // Rule ID 61316 //
     /*  389707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  389721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  389724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389754 */     // MIs[1] Operand 1
     /*  389754 */     // No operand predicates
     /*  389754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389763 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  389763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  389766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389786 */     GIR_RootConstrainSelectedInstOperands,
     /*  389787 */     // GIR_Coverage, 61316,
     /*  389787 */     GIR_EraseRootFromParent_Done,
     /*  389788 */   // Label 6955: @389788
     /*  389788 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(389874), // Rule ID 61317 //
     /*  389793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  389807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  389810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389840 */     // MIs[1] Operand 1
     /*  389840 */     // No operand predicates
     /*  389840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  389849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  389852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389872 */     GIR_RootConstrainSelectedInstOperands,
     /*  389873 */     // GIR_Coverage, 61317,
     /*  389873 */     GIR_EraseRootFromParent_Done,
     /*  389874 */   // Label 6956: @389874
     /*  389874 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(389960), // Rule ID 61320 //
     /*  389879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  389882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  389893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  389896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  389899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  389926 */     // MIs[1] Operand 1
     /*  389926 */     // No operand predicates
     /*  389926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389935 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  389935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  389938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  389942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  389944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  389947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  389958 */     GIR_RootConstrainSelectedInstOperands,
     /*  389959 */     // GIR_Coverage, 61320,
     /*  389959 */     GIR_EraseRootFromParent_Done,
     /*  389960 */   // Label 6957: @389960
     /*  389960 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(390046), // Rule ID 61321 //
     /*  389965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  389968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  389973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  389979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  389982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390012 */     // MIs[1] Operand 1
     /*  390012 */     // No operand predicates
     /*  390012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  390021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  390024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390044 */     GIR_RootConstrainSelectedInstOperands,
     /*  390045 */     // GIR_Coverage, 61321,
     /*  390045 */     GIR_EraseRootFromParent_Done,
     /*  390046 */   // Label 6958: @390046
     /*  390046 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(390132), // Rule ID 61324 //
     /*  390051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  390062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  390065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  390068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390098 */     // MIs[1] Operand 1
     /*  390098 */     // No operand predicates
     /*  390098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390107 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  390107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  390110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390130 */     GIR_RootConstrainSelectedInstOperands,
     /*  390131 */     // GIR_Coverage, 61324,
     /*  390131 */     GIR_EraseRootFromParent_Done,
     /*  390132 */   // Label 6959: @390132
     /*  390132 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(390218), // Rule ID 61325 //
     /*  390137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  390140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  390148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  390151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  390154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390184 */     // MIs[1] Operand 1
     /*  390184 */     // No operand predicates
     /*  390184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390193 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  390193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  390196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390216 */     GIR_RootConstrainSelectedInstOperands,
     /*  390217 */     // GIR_Coverage, 61325,
     /*  390217 */     GIR_EraseRootFromParent_Done,
     /*  390218 */   // Label 6960: @390218
     /*  390218 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(390304), // Rule ID 61328 //
     /*  390223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  390234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  390237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  390240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390270 */     // MIs[1] Operand 1
     /*  390270 */     // No operand predicates
     /*  390270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  390279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  390282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390302 */     GIR_RootConstrainSelectedInstOperands,
     /*  390303 */     // GIR_Coverage, 61328,
     /*  390303 */     GIR_EraseRootFromParent_Done,
     /*  390304 */   // Label 6961: @390304
     /*  390304 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(390390), // Rule ID 61329 //
     /*  390309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  390312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  390320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  390323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  390326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390356 */     // MIs[1] Operand 1
     /*  390356 */     // No operand predicates
     /*  390356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  390365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  390368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390388 */     GIR_RootConstrainSelectedInstOperands,
     /*  390389 */     // GIR_Coverage, 61329,
     /*  390389 */     GIR_EraseRootFromParent_Done,
     /*  390390 */   // Label 6962: @390390
     /*  390390 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(390476), // Rule ID 61332 //
     /*  390395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  390406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  390409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  390412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390442 */     // MIs[1] Operand 1
     /*  390442 */     // No operand predicates
     /*  390442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390451 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  390451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  390454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390474 */     GIR_RootConstrainSelectedInstOperands,
     /*  390475 */     // GIR_Coverage, 61332,
     /*  390475 */     GIR_EraseRootFromParent_Done,
     /*  390476 */   // Label 6963: @390476
     /*  390476 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(390562), // Rule ID 61333 //
     /*  390481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  390484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  390492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  390495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  390498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390528 */     // MIs[1] Operand 1
     /*  390528 */     // No operand predicates
     /*  390528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  390537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  390540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390560 */     GIR_RootConstrainSelectedInstOperands,
     /*  390561 */     // GIR_Coverage, 61333,
     /*  390561 */     GIR_EraseRootFromParent_Done,
     /*  390562 */   // Label 6964: @390562
     /*  390562 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(390648), // Rule ID 61336 //
     /*  390567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  390581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  390584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390614 */     // MIs[1] Operand 1
     /*  390614 */     // No operand predicates
     /*  390614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  390623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  390626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390646 */     GIR_RootConstrainSelectedInstOperands,
     /*  390647 */     // GIR_Coverage, 61336,
     /*  390647 */     GIR_EraseRootFromParent_Done,
     /*  390648 */   // Label 6965: @390648
     /*  390648 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(390734), // Rule ID 61337 //
     /*  390653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  390656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  390667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  390670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390700 */     // MIs[1] Operand 1
     /*  390700 */     // No operand predicates
     /*  390700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  390709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  390712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390732 */     GIR_RootConstrainSelectedInstOperands,
     /*  390733 */     // GIR_Coverage, 61337,
     /*  390733 */     GIR_EraseRootFromParent_Done,
     /*  390734 */   // Label 6966: @390734
     /*  390734 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(390820), // Rule ID 61340 //
     /*  390739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  390753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  390756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390786 */     // MIs[1] Operand 1
     /*  390786 */     // No operand predicates
     /*  390786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  390795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  390798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390818 */     GIR_RootConstrainSelectedInstOperands,
     /*  390819 */     // GIR_Coverage, 61340,
     /*  390819 */     GIR_EraseRootFromParent_Done,
     /*  390820 */   // Label 6967: @390820
     /*  390820 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(390906), // Rule ID 61341 //
     /*  390825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  390828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  390839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  390842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390872 */     // MIs[1] Operand 1
     /*  390872 */     // No operand predicates
     /*  390872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  390881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  390884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390904 */     GIR_RootConstrainSelectedInstOperands,
     /*  390905 */     // GIR_Coverage, 61341,
     /*  390905 */     GIR_EraseRootFromParent_Done,
     /*  390906 */   // Label 6968: @390906
     /*  390906 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(390992), // Rule ID 61344 //
     /*  390911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  390914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  390919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  390925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  390928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  390950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  390954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  390958 */     // MIs[1] Operand 1
     /*  390958 */     // No operand predicates
     /*  390958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  390960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390967 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  390967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  390970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  390974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  390976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  390979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  390990 */     GIR_RootConstrainSelectedInstOperands,
     /*  390991 */     // GIR_Coverage, 61344,
     /*  390991 */     GIR_EraseRootFromParent_Done,
     /*  390992 */   // Label 6969: @390992
     /*  390992 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(391078), // Rule ID 61345 //
     /*  390997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  391000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  391008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  391011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  391014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391044 */     // MIs[1] Operand 1
     /*  391044 */     // No operand predicates
     /*  391044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391053 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  391053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  391056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391076 */     GIR_RootConstrainSelectedInstOperands,
     /*  391077 */     // GIR_Coverage, 61345,
     /*  391077 */     GIR_EraseRootFromParent_Done,
     /*  391078 */   // Label 6970: @391078
     /*  391078 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(391164), // Rule ID 61348 //
     /*  391083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  391086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  391094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  391097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  391100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391130 */     // MIs[1] Operand 1
     /*  391130 */     // No operand predicates
     /*  391130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  391139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  391142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391162 */     GIR_RootConstrainSelectedInstOperands,
     /*  391163 */     // GIR_Coverage, 61348,
     /*  391163 */     GIR_EraseRootFromParent_Done,
     /*  391164 */   // Label 6971: @391164
     /*  391164 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(391250), // Rule ID 61349 //
     /*  391169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  391172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  391180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  391183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  391186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391216 */     // MIs[1] Operand 1
     /*  391216 */     // No operand predicates
     /*  391216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391225 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  391225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  391228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391248 */     GIR_RootConstrainSelectedInstOperands,
     /*  391249 */     // GIR_Coverage, 61349,
     /*  391249 */     GIR_EraseRootFromParent_Done,
     /*  391250 */   // Label 6972: @391250
     /*  391250 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(391336), // Rule ID 61352 //
     /*  391255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  391258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  391266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  391269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  391272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391302 */     // MIs[1] Operand 1
     /*  391302 */     // No operand predicates
     /*  391302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  391311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  391314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391334 */     GIR_RootConstrainSelectedInstOperands,
     /*  391335 */     // GIR_Coverage, 61352,
     /*  391335 */     GIR_EraseRootFromParent_Done,
     /*  391336 */   // Label 6973: @391336
     /*  391336 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(391422), // Rule ID 61353 //
     /*  391341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  391344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  391352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  391355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  391358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391388 */     // MIs[1] Operand 1
     /*  391388 */     // No operand predicates
     /*  391388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391397 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  391397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  391400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391420 */     GIR_RootConstrainSelectedInstOperands,
     /*  391421 */     // GIR_Coverage, 61353,
     /*  391421 */     GIR_EraseRootFromParent_Done,
     /*  391422 */   // Label 6974: @391422
     /*  391422 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(391508), // Rule ID 61356 //
     /*  391427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  391430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  391438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  391441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  391444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391474 */     // MIs[1] Operand 1
     /*  391474 */     // No operand predicates
     /*  391474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  391483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  391486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391506 */     GIR_RootConstrainSelectedInstOperands,
     /*  391507 */     // GIR_Coverage, 61356,
     /*  391507 */     GIR_EraseRootFromParent_Done,
     /*  391508 */   // Label 6975: @391508
     /*  391508 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(391594), // Rule ID 61357 //
     /*  391513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  391516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  391524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  391527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  391530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391560 */     // MIs[1] Operand 1
     /*  391560 */     // No operand predicates
     /*  391560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391569 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  391569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  391572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391592 */     GIR_RootConstrainSelectedInstOperands,
     /*  391593 */     // GIR_Coverage, 61357,
     /*  391593 */     GIR_EraseRootFromParent_Done,
     /*  391594 */   // Label 6976: @391594
     /*  391594 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(391680), // Rule ID 61360 //
     /*  391599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  391602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  391613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  391616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391646 */     // MIs[1] Operand 1
     /*  391646 */     // No operand predicates
     /*  391646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391655 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  391655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  391658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391678 */     GIR_RootConstrainSelectedInstOperands,
     /*  391679 */     // GIR_Coverage, 61360,
     /*  391679 */     GIR_EraseRootFromParent_Done,
     /*  391680 */   // Label 6977: @391680
     /*  391680 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(391766), // Rule ID 61361 //
     /*  391685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  391688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  391693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  391699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  391702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  391724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  391728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  391732 */     // MIs[1] Operand 1
     /*  391732 */     // No operand predicates
     /*  391732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391741 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  391741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  391744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  391748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  391753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  391764 */     GIR_RootConstrainSelectedInstOperands,
     /*  391765 */     // GIR_Coverage, 61361,
     /*  391765 */     GIR_EraseRootFromParent_Done,
     /*  391766 */   // Label 6978: @391766
     /*  391766 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(391845), // Rule ID 2610 //
     /*  391771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  391774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  391779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  391785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  391788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  391791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  391802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  391806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  391823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  391826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  391832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  391843 */     GIR_RootConstrainSelectedInstOperands,
     /*  391844 */     // GIR_Coverage, 2610,
     /*  391844 */     GIR_EraseRootFromParent_Done,
     /*  391845 */   // Label 6979: @391845
     /*  391845 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(391924), // Rule ID 2611 //
     /*  391850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  391853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  391858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  391864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  391867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  391870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  391881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  391885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  391902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  391905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  391911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  391922 */     GIR_RootConstrainSelectedInstOperands,
     /*  391923 */     // GIR_Coverage, 2611,
     /*  391923 */     GIR_EraseRootFromParent_Done,
     /*  391924 */   // Label 6980: @391924
     /*  391924 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(392003), // Rule ID 3918 //
     /*  391929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  391932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  391937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  391943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  391946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  391949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  391960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  391964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  391974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391981 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  391981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  391984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  391988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  391990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392001 */     GIR_RootConstrainSelectedInstOperands,
     /*  392002 */     // GIR_Coverage, 3918,
     /*  392002 */     GIR_EraseRootFromParent_Done,
     /*  392003 */   // Label 6981: @392003
     /*  392003 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(392082), // Rule ID 3919 //
     /*  392008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  392019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  392022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  392025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  392028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  392060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  392063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392080 */     GIR_RootConstrainSelectedInstOperands,
     /*  392081 */     // GIR_Coverage, 3919,
     /*  392081 */     GIR_EraseRootFromParent_Done,
     /*  392082 */   // Label 6982: @392082
     /*  392082 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(392161), // Rule ID 3928 //
     /*  392087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  392101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  392104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  392107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392139 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  392139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  392142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392159 */     GIR_RootConstrainSelectedInstOperands,
     /*  392160 */     // GIR_Coverage, 3928,
     /*  392160 */     GIR_EraseRootFromParent_Done,
     /*  392161 */   // Label 6983: @392161
     /*  392161 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(392240), // Rule ID 3929 //
     /*  392166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  392180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  392183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  392186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  392218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  392221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392238 */     GIR_RootConstrainSelectedInstOperands,
     /*  392239 */     // GIR_Coverage, 3929,
     /*  392239 */     GIR_EraseRootFromParent_Done,
     /*  392240 */   // Label 6984: @392240
     /*  392240 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(392319), // Rule ID 3938 //
     /*  392245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  392259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  392262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  392265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  392297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  392300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392317 */     GIR_RootConstrainSelectedInstOperands,
     /*  392318 */     // GIR_Coverage, 3938,
     /*  392318 */     GIR_EraseRootFromParent_Done,
     /*  392319 */   // Label 6985: @392319
     /*  392319 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(392398), // Rule ID 3939 //
     /*  392324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  392338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  392341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  392344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  392376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  392379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392396 */     GIR_RootConstrainSelectedInstOperands,
     /*  392397 */     // GIR_Coverage, 3939,
     /*  392397 */     GIR_EraseRootFromParent_Done,
     /*  392398 */   // Label 6986: @392398
     /*  392398 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(392477), // Rule ID 3948 //
     /*  392403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  392417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  392420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  392423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392455 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  392455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  392458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392475 */     GIR_RootConstrainSelectedInstOperands,
     /*  392476 */     // GIR_Coverage, 3948,
     /*  392476 */     GIR_EraseRootFromParent_Done,
     /*  392477 */   // Label 6987: @392477
     /*  392477 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(392556), // Rule ID 3949 //
     /*  392482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  392496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  392499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  392502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  392534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  392537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392554 */     GIR_RootConstrainSelectedInstOperands,
     /*  392555 */     // GIR_Coverage, 3949,
     /*  392555 */     GIR_EraseRootFromParent_Done,
     /*  392556 */   // Label 6988: @392556
     /*  392556 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(392635), // Rule ID 3958 //
     /*  392561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  392575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  392578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  392581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392613 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  392613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  392616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392633 */     GIR_RootConstrainSelectedInstOperands,
     /*  392634 */     // GIR_Coverage, 3958,
     /*  392634 */     GIR_EraseRootFromParent_Done,
     /*  392635 */   // Label 6989: @392635
     /*  392635 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(392714), // Rule ID 3959 //
     /*  392640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  392654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  392657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  392660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  392692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  392695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392712 */     GIR_RootConstrainSelectedInstOperands,
     /*  392713 */     // GIR_Coverage, 3959,
     /*  392713 */     GIR_EraseRootFromParent_Done,
     /*  392714 */   // Label 6990: @392714
     /*  392714 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(392793), // Rule ID 3968 //
     /*  392719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  392730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  392733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  392736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  392739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  392771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  392774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392791 */     GIR_RootConstrainSelectedInstOperands,
     /*  392792 */     // GIR_Coverage, 3968,
     /*  392792 */     GIR_EraseRootFromParent_Done,
     /*  392793 */   // Label 6991: @392793
     /*  392793 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(392872), // Rule ID 3969 //
     /*  392798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  392809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  392812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  392815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  392818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  392850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  392853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392870 */     GIR_RootConstrainSelectedInstOperands,
     /*  392871 */     // GIR_Coverage, 3969,
     /*  392871 */     GIR_EraseRootFromParent_Done,
     /*  392872 */   // Label 6992: @392872
     /*  392872 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(392951), // Rule ID 3978 //
     /*  392877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  392880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  392891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  392894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  392897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  392922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392929 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  392929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  392932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  392936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  392938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  392949 */     GIR_RootConstrainSelectedInstOperands,
     /*  392950 */     // GIR_Coverage, 3978,
     /*  392950 */     GIR_EraseRootFromParent_Done,
     /*  392951 */   // Label 6993: @392951
     /*  392951 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(393030), // Rule ID 3979 //
     /*  392956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  392959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  392964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  392970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  392973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  392976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  392987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  392991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  393008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  393011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393028 */     GIR_RootConstrainSelectedInstOperands,
     /*  393029 */     // GIR_Coverage, 3979,
     /*  393029 */     GIR_EraseRootFromParent_Done,
     /*  393030 */   // Label 6994: @393030
     /*  393030 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(393109), // Rule ID 3988 //
     /*  393035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  393038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  393049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  393052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  393055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  393087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  393090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393107 */     GIR_RootConstrainSelectedInstOperands,
     /*  393108 */     // GIR_Coverage, 3988,
     /*  393108 */     GIR_EraseRootFromParent_Done,
     /*  393109 */   // Label 6995: @393109
     /*  393109 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(393188), // Rule ID 3989 //
     /*  393114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  393117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  393128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  393131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  393134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  393166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  393169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393186 */     GIR_RootConstrainSelectedInstOperands,
     /*  393187 */     // GIR_Coverage, 3989,
     /*  393187 */     GIR_EraseRootFromParent_Done,
     /*  393188 */   // Label 6996: @393188
     /*  393188 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(393267), // Rule ID 3998 //
     /*  393193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  393196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  393207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  393210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  393213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393245 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  393245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  393248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393265 */     GIR_RootConstrainSelectedInstOperands,
     /*  393266 */     // GIR_Coverage, 3998,
     /*  393266 */     GIR_EraseRootFromParent_Done,
     /*  393267 */   // Label 6997: @393267
     /*  393267 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(393346), // Rule ID 3999 //
     /*  393272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  393275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  393286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  393289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  393292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  393324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  393327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393344 */     GIR_RootConstrainSelectedInstOperands,
     /*  393345 */     // GIR_Coverage, 3999,
     /*  393345 */     GIR_EraseRootFromParent_Done,
     /*  393346 */   // Label 6998: @393346
     /*  393346 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(393425), // Rule ID 4008 //
     /*  393351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  393354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  393365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  393368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  393371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  393403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  393406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393423 */     GIR_RootConstrainSelectedInstOperands,
     /*  393424 */     // GIR_Coverage, 4008,
     /*  393424 */     GIR_EraseRootFromParent_Done,
     /*  393425 */   // Label 6999: @393425
     /*  393425 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(393504), // Rule ID 4009 //
     /*  393430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  393433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  393444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  393447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  393450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  393482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  393485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393502 */     GIR_RootConstrainSelectedInstOperands,
     /*  393503 */     // GIR_Coverage, 4009,
     /*  393503 */     GIR_EraseRootFromParent_Done,
     /*  393504 */   // Label 7000: @393504
     /*  393504 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(393583), // Rule ID 4018 //
     /*  393509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  393512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  393520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  393523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  393526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  393529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  393561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  393564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393581 */     GIR_RootConstrainSelectedInstOperands,
     /*  393582 */     // GIR_Coverage, 4018,
     /*  393582 */     GIR_EraseRootFromParent_Done,
     /*  393583 */   // Label 7001: @393583
     /*  393583 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(393662), // Rule ID 4019 //
     /*  393588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  393591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  393599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  393602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  393605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  393608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  393640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  393643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393660 */     GIR_RootConstrainSelectedInstOperands,
     /*  393661 */     // GIR_Coverage, 4019,
     /*  393661 */     GIR_EraseRootFromParent_Done,
     /*  393662 */   // Label 7002: @393662
     /*  393662 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(393741), // Rule ID 4028 //
     /*  393667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  393670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  393681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  393684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  393687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  393719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  393722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393739 */     GIR_RootConstrainSelectedInstOperands,
     /*  393740 */     // GIR_Coverage, 4028,
     /*  393740 */     GIR_EraseRootFromParent_Done,
     /*  393741 */   // Label 7003: @393741
     /*  393741 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(393820), // Rule ID 4029 //
     /*  393746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  393749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  393760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  393763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  393766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  393798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  393801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393818 */     GIR_RootConstrainSelectedInstOperands,
     /*  393819 */     // GIR_Coverage, 4029,
     /*  393819 */     GIR_EraseRootFromParent_Done,
     /*  393820 */   // Label 7004: @393820
     /*  393820 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(393899), // Rule ID 4038 //
     /*  393825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  393828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  393839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  393842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  393845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393877 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  393877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  393880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393897 */     GIR_RootConstrainSelectedInstOperands,
     /*  393898 */     // GIR_Coverage, 4038,
     /*  393898 */     GIR_EraseRootFromParent_Done,
     /*  393899 */   // Label 7005: @393899
     /*  393899 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(393978), // Rule ID 4039 //
     /*  393904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  393907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  393918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  393921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  393924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  393935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  393939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  393949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  393956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  393959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  393963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  393965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  393976 */     GIR_RootConstrainSelectedInstOperands,
     /*  393977 */     // GIR_Coverage, 4039,
     /*  393977 */     GIR_EraseRootFromParent_Done,
     /*  393978 */   // Label 7006: @393978
     /*  393978 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(394057), // Rule ID 4048 //
     /*  393983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  393986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  393991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  393997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  394000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  394003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394035 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  394035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  394038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394055 */     GIR_RootConstrainSelectedInstOperands,
     /*  394056 */     // GIR_Coverage, 4048,
     /*  394056 */     GIR_EraseRootFromParent_Done,
     /*  394057 */   // Label 7007: @394057
     /*  394057 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(394136), // Rule ID 4049 //
     /*  394062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  394065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  394070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  394076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  394079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  394082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  394114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  394117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394134 */     GIR_RootConstrainSelectedInstOperands,
     /*  394135 */     // GIR_Coverage, 4049,
     /*  394135 */     GIR_EraseRootFromParent_Done,
     /*  394136 */   // Label 7008: @394136
     /*  394136 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(394215), // Rule ID 4118 //
     /*  394141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  394155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  394161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394193 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  394196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394213 */     GIR_RootConstrainSelectedInstOperands,
     /*  394214 */     // GIR_Coverage, 4118,
     /*  394214 */     GIR_EraseRootFromParent_Done,
     /*  394215 */   // Label 7009: @394215
     /*  394215 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(394294), // Rule ID 4119 //
     /*  394220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  394223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  394234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  394240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  394272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  394275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394292 */     GIR_RootConstrainSelectedInstOperands,
     /*  394293 */     // GIR_Coverage, 4119,
     /*  394293 */     GIR_EraseRootFromParent_Done,
     /*  394294 */   // Label 7010: @394294
     /*  394294 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(394373), // Rule ID 4128 //
     /*  394299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  394313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  394319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394351 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  394354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394371 */     GIR_RootConstrainSelectedInstOperands,
     /*  394372 */     // GIR_Coverage, 4128,
     /*  394372 */     GIR_EraseRootFromParent_Done,
     /*  394373 */   // Label 7011: @394373
     /*  394373 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(394452), // Rule ID 4129 //
     /*  394378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  394381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  394392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  394398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  394430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  394433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394450 */     GIR_RootConstrainSelectedInstOperands,
     /*  394451 */     // GIR_Coverage, 4129,
     /*  394451 */     GIR_EraseRootFromParent_Done,
     /*  394452 */   // Label 7012: @394452
     /*  394452 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(394531), // Rule ID 4138 //
     /*  394457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  394468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  394471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  394474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  394477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  394512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394529 */     GIR_RootConstrainSelectedInstOperands,
     /*  394530 */     // GIR_Coverage, 4138,
     /*  394530 */     GIR_EraseRootFromParent_Done,
     /*  394531 */   // Label 7013: @394531
     /*  394531 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(394610), // Rule ID 4139 //
     /*  394536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  394539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  394547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  394550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  394553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  394556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  394588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  394591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394608 */     GIR_RootConstrainSelectedInstOperands,
     /*  394609 */     // GIR_Coverage, 4139,
     /*  394609 */     GIR_EraseRootFromParent_Done,
     /*  394610 */   // Label 7014: @394610
     /*  394610 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(394689), // Rule ID 4148 //
     /*  394615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  394626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  394629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  394632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  394635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394667 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  394670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394687 */     GIR_RootConstrainSelectedInstOperands,
     /*  394688 */     // GIR_Coverage, 4148,
     /*  394688 */     GIR_EraseRootFromParent_Done,
     /*  394689 */   // Label 7015: @394689
     /*  394689 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(394768), // Rule ID 4149 //
     /*  394694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  394697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  394705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  394708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  394711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  394714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  394746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  394749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394766 */     GIR_RootConstrainSelectedInstOperands,
     /*  394767 */     // GIR_Coverage, 4149,
     /*  394767 */     GIR_EraseRootFromParent_Done,
     /*  394768 */   // Label 7016: @394768
     /*  394768 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(394847), // Rule ID 4158 //
     /*  394773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  394784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  394787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  394790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  394793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394825 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  394828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394845 */     GIR_RootConstrainSelectedInstOperands,
     /*  394846 */     // GIR_Coverage, 4158,
     /*  394846 */     GIR_EraseRootFromParent_Done,
     /*  394847 */   // Label 7017: @394847
     /*  394847 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(394926), // Rule ID 4159 //
     /*  394852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  394855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  394863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  394866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  394869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  394872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  394904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  394907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  394924 */     GIR_RootConstrainSelectedInstOperands,
     /*  394925 */     // GIR_Coverage, 4159,
     /*  394925 */     GIR_EraseRootFromParent_Done,
     /*  394926 */   // Label 7018: @394926
     /*  394926 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(395005), // Rule ID 4168 //
     /*  394931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  394934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  394939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  394942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  394945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  394948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  394951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  394962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  394966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394983 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  394983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  394986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  394990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  394992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395003 */     GIR_RootConstrainSelectedInstOperands,
     /*  395004 */     // GIR_Coverage, 4168,
     /*  395004 */     GIR_EraseRootFromParent_Done,
     /*  395005 */   // Label 7019: @395005
     /*  395005 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(395084), // Rule ID 4169 //
     /*  395010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  395021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  395024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  395027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  395030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  395062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  395065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395082 */     GIR_RootConstrainSelectedInstOperands,
     /*  395083 */     // GIR_Coverage, 4169,
     /*  395083 */     GIR_EraseRootFromParent_Done,
     /*  395084 */   // Label 7020: @395084
     /*  395084 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(395163), // Rule ID 4178 //
     /*  395089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  395092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  395103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  395109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  395141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  395144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395161 */     GIR_RootConstrainSelectedInstOperands,
     /*  395162 */     // GIR_Coverage, 4178,
     /*  395162 */     GIR_EraseRootFromParent_Done,
     /*  395163 */   // Label 7021: @395163
     /*  395163 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(395242), // Rule ID 4179 //
     /*  395168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  395182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  395188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  395220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  395223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395240 */     GIR_RootConstrainSelectedInstOperands,
     /*  395241 */     // GIR_Coverage, 4179,
     /*  395241 */     GIR_EraseRootFromParent_Done,
     /*  395242 */   // Label 7022: @395242
     /*  395242 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(395321), // Rule ID 4188 //
     /*  395247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  395250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  395261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  395267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  395299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  395302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395319 */     GIR_RootConstrainSelectedInstOperands,
     /*  395320 */     // GIR_Coverage, 4188,
     /*  395320 */     GIR_EraseRootFromParent_Done,
     /*  395321 */   // Label 7023: @395321
     /*  395321 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(395400), // Rule ID 4189 //
     /*  395326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  395340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  395346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  395378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  395381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395398 */     GIR_RootConstrainSelectedInstOperands,
     /*  395399 */     // GIR_Coverage, 4189,
     /*  395399 */     GIR_EraseRootFromParent_Done,
     /*  395400 */   // Label 7024: @395400
     /*  395400 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(395479), // Rule ID 4198 //
     /*  395405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  395408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  395416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  395419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  395422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  395425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  395457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  395460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395477 */     GIR_RootConstrainSelectedInstOperands,
     /*  395478 */     // GIR_Coverage, 4198,
     /*  395478 */     GIR_EraseRootFromParent_Done,
     /*  395479 */   // Label 7025: @395479
     /*  395479 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(395558), // Rule ID 4199 //
     /*  395484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  395495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  395498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  395501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  395504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  395536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  395539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395556 */     GIR_RootConstrainSelectedInstOperands,
     /*  395557 */     // GIR_Coverage, 4199,
     /*  395557 */     GIR_EraseRootFromParent_Done,
     /*  395558 */   // Label 7026: @395558
     /*  395558 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(395637), // Rule ID 4208 //
     /*  395563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  395566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  395574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  395577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  395580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  395583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  395615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  395618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395635 */     GIR_RootConstrainSelectedInstOperands,
     /*  395636 */     // GIR_Coverage, 4208,
     /*  395636 */     GIR_EraseRootFromParent_Done,
     /*  395637 */   // Label 7027: @395637
     /*  395637 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(395716), // Rule ID 4209 //
     /*  395642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  395653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  395656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  395659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  395662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  395694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  395697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395714 */     GIR_RootConstrainSelectedInstOperands,
     /*  395715 */     // GIR_Coverage, 4209,
     /*  395715 */     GIR_EraseRootFromParent_Done,
     /*  395716 */   // Label 7028: @395716
     /*  395716 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(395795), // Rule ID 4218 //
     /*  395721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  395724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  395732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  395735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  395738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  395741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395773 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  395773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  395776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395793 */     GIR_RootConstrainSelectedInstOperands,
     /*  395794 */     // GIR_Coverage, 4218,
     /*  395794 */     GIR_EraseRootFromParent_Done,
     /*  395795 */   // Label 7029: @395795
     /*  395795 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(395874), // Rule ID 4219 //
     /*  395800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  395803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  395811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  395814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  395817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  395820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  395852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  395855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395872 */     GIR_RootConstrainSelectedInstOperands,
     /*  395873 */     // GIR_Coverage, 4219,
     /*  395873 */     GIR_EraseRootFromParent_Done,
     /*  395874 */   // Label 7030: @395874
     /*  395874 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(395953), // Rule ID 4228 //
     /*  395879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  395882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  395893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  395899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  395924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  395931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  395934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  395938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  395940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  395951 */     GIR_RootConstrainSelectedInstOperands,
     /*  395952 */     // GIR_Coverage, 4228,
     /*  395952 */     GIR_EraseRootFromParent_Done,
     /*  395953 */   // Label 7031: @395953
     /*  395953 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(396032), // Rule ID 4229 //
     /*  395958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  395961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  395966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  395972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  395978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  395989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  395993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  396010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  396013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396030 */     GIR_RootConstrainSelectedInstOperands,
     /*  396031 */     // GIR_Coverage, 4229,
     /*  396031 */     GIR_EraseRootFromParent_Done,
     /*  396032 */   // Label 7032: @396032
     /*  396032 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(396111), // Rule ID 4238 //
     /*  396037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  396040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  396051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  396057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  396089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  396092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396109 */     GIR_RootConstrainSelectedInstOperands,
     /*  396110 */     // GIR_Coverage, 4238,
     /*  396110 */     GIR_EraseRootFromParent_Done,
     /*  396111 */   // Label 7033: @396111
     /*  396111 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(396190), // Rule ID 4239 //
     /*  396116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  396119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  396130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  396136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  396168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  396171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396188 */     GIR_RootConstrainSelectedInstOperands,
     /*  396189 */     // GIR_Coverage, 4239,
     /*  396189 */     GIR_EraseRootFromParent_Done,
     /*  396190 */   // Label 7034: @396190
     /*  396190 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(396269), // Rule ID 4248 //
     /*  396195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  396198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  396209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  396215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396247 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  396247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  396250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396267 */     GIR_RootConstrainSelectedInstOperands,
     /*  396268 */     // GIR_Coverage, 4248,
     /*  396268 */     GIR_EraseRootFromParent_Done,
     /*  396269 */   // Label 7035: @396269
     /*  396269 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(396348), // Rule ID 4249 //
     /*  396274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  396277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  396288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  396294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396326 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  396326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  396329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396346 */     GIR_RootConstrainSelectedInstOperands,
     /*  396347 */     // GIR_Coverage, 4249,
     /*  396347 */     GIR_EraseRootFromParent_Done,
     /*  396348 */   // Label 7036: @396348
     /*  396348 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(396427), // Rule ID 4258 //
     /*  396353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  396356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  396364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  396367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  396370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  396373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396405 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  396405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  396408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396425 */     GIR_RootConstrainSelectedInstOperands,
     /*  396426 */     // GIR_Coverage, 4258,
     /*  396426 */     GIR_EraseRootFromParent_Done,
     /*  396427 */   // Label 7037: @396427
     /*  396427 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(396506), // Rule ID 4259 //
     /*  396432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  396435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  396440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  396443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  396446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  396449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  396452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  396484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  396487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396504 */     GIR_RootConstrainSelectedInstOperands,
     /*  396505 */     // GIR_Coverage, 4259,
     /*  396505 */     GIR_EraseRootFromParent_Done,
     /*  396506 */   // Label 7038: @396506
     /*  396506 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(396585), // Rule ID 4328 //
     /*  396511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  396522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  396525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  396528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  396531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396563 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  396563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  396566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396583 */     GIR_RootConstrainSelectedInstOperands,
     /*  396584 */     // GIR_Coverage, 4328,
     /*  396584 */     GIR_EraseRootFromParent_Done,
     /*  396585 */   // Label 7039: @396585
     /*  396585 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(396664), // Rule ID 4329 //
     /*  396590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  396593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  396601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  396604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  396607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  396610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  396642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  396645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396662 */     GIR_RootConstrainSelectedInstOperands,
     /*  396663 */     // GIR_Coverage, 4329,
     /*  396663 */     GIR_EraseRootFromParent_Done,
     /*  396664 */   // Label 7040: @396664
     /*  396664 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(396743), // Rule ID 4338 //
     /*  396669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  396680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  396683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  396686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  396689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396721 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  396721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  396724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396741 */     GIR_RootConstrainSelectedInstOperands,
     /*  396742 */     // GIR_Coverage, 4338,
     /*  396742 */     GIR_EraseRootFromParent_Done,
     /*  396743 */   // Label 7041: @396743
     /*  396743 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(396822), // Rule ID 4339 //
     /*  396748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  396751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  396759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  396762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  396765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  396768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  396800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  396803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396820 */     GIR_RootConstrainSelectedInstOperands,
     /*  396821 */     // GIR_Coverage, 4339,
     /*  396821 */     GIR_EraseRootFromParent_Done,
     /*  396822 */   // Label 7042: @396822
     /*  396822 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(396901), // Rule ID 4348 //
     /*  396827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  396838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  396841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  396844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  396847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396879 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  396879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  396882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396899 */     GIR_RootConstrainSelectedInstOperands,
     /*  396900 */     // GIR_Coverage, 4348,
     /*  396900 */     GIR_EraseRootFromParent_Done,
     /*  396901 */   // Label 7043: @396901
     /*  396901 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(396980), // Rule ID 4349 //
     /*  396906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  396909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  396917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  396920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  396923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  396926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  396937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  396941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  396951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  396958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  396961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  396967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  396978 */     GIR_RootConstrainSelectedInstOperands,
     /*  396979 */     // GIR_Coverage, 4349,
     /*  396979 */     GIR_EraseRootFromParent_Done,
     /*  396980 */   // Label 7044: @396980
     /*  396980 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(397059), // Rule ID 4358 //
     /*  396985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  396993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  396999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  397002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  397005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  397037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  397040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397057 */     GIR_RootConstrainSelectedInstOperands,
     /*  397058 */     // GIR_Coverage, 4358,
     /*  397058 */     GIR_EraseRootFromParent_Done,
     /*  397059 */   // Label 7045: @397059
     /*  397059 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(397138), // Rule ID 4359 //
     /*  397064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  397075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  397078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  397081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  397084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  397116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  397119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397136 */     GIR_RootConstrainSelectedInstOperands,
     /*  397137 */     // GIR_Coverage, 4359,
     /*  397137 */     GIR_EraseRootFromParent_Done,
     /*  397138 */   // Label 7046: @397138
     /*  397138 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(397217), // Rule ID 4368 //
     /*  397143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  397154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  397157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  397160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  397163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397195 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  397195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  397198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397215 */     GIR_RootConstrainSelectedInstOperands,
     /*  397216 */     // GIR_Coverage, 4368,
     /*  397216 */     GIR_EraseRootFromParent_Done,
     /*  397217 */   // Label 7047: @397217
     /*  397217 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(397296), // Rule ID 4369 //
     /*  397222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  397233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  397236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  397239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  397242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  397274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  397277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397294 */     GIR_RootConstrainSelectedInstOperands,
     /*  397295 */     // GIR_Coverage, 4369,
     /*  397295 */     GIR_EraseRootFromParent_Done,
     /*  397296 */   // Label 7048: @397296
     /*  397296 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(397375), // Rule ID 4378 //
     /*  397301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  397312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  397315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  397318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  397321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397353 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  397353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  397356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397373 */     GIR_RootConstrainSelectedInstOperands,
     /*  397374 */     // GIR_Coverage, 4378,
     /*  397374 */     GIR_EraseRootFromParent_Done,
     /*  397375 */   // Label 7049: @397375
     /*  397375 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(397454), // Rule ID 4379 //
     /*  397380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  397391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  397394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  397397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  397400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  397432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  397435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397452 */     GIR_RootConstrainSelectedInstOperands,
     /*  397453 */     // GIR_Coverage, 4379,
     /*  397453 */     GIR_EraseRootFromParent_Done,
     /*  397454 */   // Label 7050: @397454
     /*  397454 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(397533), // Rule ID 4388 //
     /*  397459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  397479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  397511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  397514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397531 */     GIR_RootConstrainSelectedInstOperands,
     /*  397532 */     // GIR_Coverage, 4388,
     /*  397532 */     GIR_EraseRootFromParent_Done,
     /*  397533 */   // Label 7051: @397533
     /*  397533 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(397612), // Rule ID 4389 //
     /*  397538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  397558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  397590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  397593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397610 */     GIR_RootConstrainSelectedInstOperands,
     /*  397611 */     // GIR_Coverage, 4389,
     /*  397611 */     GIR_EraseRootFromParent_Done,
     /*  397612 */   // Label 7052: @397612
     /*  397612 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(397691), // Rule ID 4398 //
     /*  397617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  397628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  397631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  397634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  397637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397669 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  397669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  397672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397689 */     GIR_RootConstrainSelectedInstOperands,
     /*  397690 */     // GIR_Coverage, 4398,
     /*  397690 */     GIR_EraseRootFromParent_Done,
     /*  397691 */   // Label 7053: @397691
     /*  397691 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(397770), // Rule ID 4399 //
     /*  397696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  397707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  397710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  397713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  397716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  397748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  397751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397768 */     GIR_RootConstrainSelectedInstOperands,
     /*  397769 */     // GIR_Coverage, 4399,
     /*  397769 */     GIR_EraseRootFromParent_Done,
     /*  397770 */   // Label 7054: @397770
     /*  397770 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(397849), // Rule ID 4408 //
     /*  397775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  397786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  397789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  397792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  397795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  397827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  397830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397847 */     GIR_RootConstrainSelectedInstOperands,
     /*  397848 */     // GIR_Coverage, 4408,
     /*  397848 */     GIR_EraseRootFromParent_Done,
     /*  397849 */   // Label 7055: @397849
     /*  397849 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(397928), // Rule ID 4409 //
     /*  397854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  397865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  397868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  397871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  397874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  397906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  397909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  397926 */     GIR_RootConstrainSelectedInstOperands,
     /*  397927 */     // GIR_Coverage, 4409,
     /*  397927 */     GIR_EraseRootFromParent_Done,
     /*  397928 */   // Label 7056: @397928
     /*  397928 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(398007), // Rule ID 4418 //
     /*  397933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  397941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  397947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  397950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  397953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  397964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  397968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  397978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  397985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  397988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  397994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398005 */     GIR_RootConstrainSelectedInstOperands,
     /*  398006 */     // GIR_Coverage, 4418,
     /*  398006 */     GIR_EraseRootFromParent_Done,
     /*  398007 */   // Label 7057: @398007
     /*  398007 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(398086), // Rule ID 4419 //
     /*  398012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  398023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  398026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  398029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  398032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  398064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  398067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398084 */     GIR_RootConstrainSelectedInstOperands,
     /*  398085 */     // GIR_Coverage, 4419,
     /*  398085 */     GIR_EraseRootFromParent_Done,
     /*  398086 */   // Label 7058: @398086
     /*  398086 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(398165), // Rule ID 4428 //
     /*  398091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  398102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  398105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  398108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  398111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  398143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  398146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398163 */     GIR_RootConstrainSelectedInstOperands,
     /*  398164 */     // GIR_Coverage, 4428,
     /*  398164 */     GIR_EraseRootFromParent_Done,
     /*  398165 */   // Label 7059: @398165
     /*  398165 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(398244), // Rule ID 4429 //
     /*  398170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  398181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  398184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  398187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  398190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  398222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  398225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398242 */     GIR_RootConstrainSelectedInstOperands,
     /*  398243 */     // GIR_Coverage, 4429,
     /*  398243 */     GIR_EraseRootFromParent_Done,
     /*  398244 */   // Label 7060: @398244
     /*  398244 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(398323), // Rule ID 4438 //
     /*  398249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  398252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  398269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398301 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  398301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  398304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398321 */     GIR_RootConstrainSelectedInstOperands,
     /*  398322 */     // GIR_Coverage, 4438,
     /*  398322 */     GIR_EraseRootFromParent_Done,
     /*  398323 */   // Label 7061: @398323
     /*  398323 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(398402), // Rule ID 4439 //
     /*  398328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  398331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  398348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398380 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  398380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  398383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398400 */     GIR_RootConstrainSelectedInstOperands,
     /*  398401 */     // GIR_Coverage, 4439,
     /*  398401 */     GIR_EraseRootFromParent_Done,
     /*  398402 */   // Label 7062: @398402
     /*  398402 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(398481), // Rule ID 4448 //
     /*  398407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  398410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  398418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  398421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  398424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  398427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398459 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  398459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  398462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398479 */     GIR_RootConstrainSelectedInstOperands,
     /*  398480 */     // GIR_Coverage, 4448,
     /*  398480 */     GIR_EraseRootFromParent_Done,
     /*  398481 */   // Label 7063: @398481
     /*  398481 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(398560), // Rule ID 4449 //
     /*  398486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  398489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  398497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  398500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  398503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  398506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  398538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  398541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398558 */     GIR_RootConstrainSelectedInstOperands,
     /*  398559 */     // GIR_Coverage, 4449,
     /*  398559 */     GIR_EraseRootFromParent_Done,
     /*  398560 */   // Label 7064: @398560
     /*  398560 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(398639), // Rule ID 4458 //
     /*  398565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  398568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  398576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  398579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  398582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  398585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398617 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  398617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  398620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398637 */     GIR_RootConstrainSelectedInstOperands,
     /*  398638 */     // GIR_Coverage, 4458,
     /*  398638 */     GIR_EraseRootFromParent_Done,
     /*  398639 */   // Label 7065: @398639
     /*  398639 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(398718), // Rule ID 4459 //
     /*  398644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  398647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  398655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  398658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  398661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  398664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  398696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  398699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398716 */     GIR_RootConstrainSelectedInstOperands,
     /*  398717 */     // GIR_Coverage, 4459,
     /*  398717 */     GIR_EraseRootFromParent_Done,
     /*  398718 */   // Label 7066: @398718
     /*  398718 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(398797), // Rule ID 4468 //
     /*  398723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  398726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  398734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  398737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  398740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  398743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398775 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  398775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  398778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398795 */     GIR_RootConstrainSelectedInstOperands,
     /*  398796 */     // GIR_Coverage, 4468,
     /*  398796 */     GIR_EraseRootFromParent_Done,
     /*  398797 */   // Label 7067: @398797
     /*  398797 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(398876), // Rule ID 4469 //
     /*  398802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  398805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  398810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  398813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  398816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  398819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  398822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  398854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  398857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398874 */     GIR_RootConstrainSelectedInstOperands,
     /*  398875 */     // GIR_Coverage, 4469,
     /*  398875 */     GIR_EraseRootFromParent_Done,
     /*  398876 */   // Label 7068: @398876
     /*  398876 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(398955), // Rule ID 4538 //
     /*  398881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  398889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  398901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  398926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398933 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  398933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  398936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  398942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  398953 */     GIR_RootConstrainSelectedInstOperands,
     /*  398954 */     // GIR_Coverage, 4538,
     /*  398954 */     GIR_EraseRootFromParent_Done,
     /*  398955 */   // Label 7069: @398955
     /*  398955 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(399034), // Rule ID 4539 //
     /*  398960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  398968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  398980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  398991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  398995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399012 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  399015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399032 */     GIR_RootConstrainSelectedInstOperands,
     /*  399033 */     // GIR_Coverage, 4539,
     /*  399033 */     GIR_EraseRootFromParent_Done,
     /*  399034 */   // Label 7070: @399034
     /*  399034 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(399113), // Rule ID 4548 //
     /*  399039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  399050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  399053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  399056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  399059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399091 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  399091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  399094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399111 */     GIR_RootConstrainSelectedInstOperands,
     /*  399112 */     // GIR_Coverage, 4548,
     /*  399112 */     GIR_EraseRootFromParent_Done,
     /*  399113 */   // Label 7071: @399113
     /*  399113 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(399192), // Rule ID 4549 //
     /*  399118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  399129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  399132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  399135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  399138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  399173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399190 */     GIR_RootConstrainSelectedInstOperands,
     /*  399191 */     // GIR_Coverage, 4549,
     /*  399191 */     GIR_EraseRootFromParent_Done,
     /*  399192 */   // Label 7072: @399192
     /*  399192 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(399271), // Rule ID 4558 //
     /*  399197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  399208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  399211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  399214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  399217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  399249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  399252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399269 */     GIR_RootConstrainSelectedInstOperands,
     /*  399270 */     // GIR_Coverage, 4558,
     /*  399270 */     GIR_EraseRootFromParent_Done,
     /*  399271 */   // Label 7073: @399271
     /*  399271 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(399350), // Rule ID 4559 //
     /*  399276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  399287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  399290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  399293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  399296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  399331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399348 */     GIR_RootConstrainSelectedInstOperands,
     /*  399349 */     // GIR_Coverage, 4559,
     /*  399349 */     GIR_EraseRootFromParent_Done,
     /*  399350 */   // Label 7074: @399350
     /*  399350 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(399429), // Rule ID 4568 //
     /*  399355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  399375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  399407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  399410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399427 */     GIR_RootConstrainSelectedInstOperands,
     /*  399428 */     // GIR_Coverage, 4568,
     /*  399428 */     GIR_EraseRootFromParent_Done,
     /*  399429 */   // Label 7075: @399429
     /*  399429 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(399508), // Rule ID 4569 //
     /*  399434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  399454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  399489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399506 */     GIR_RootConstrainSelectedInstOperands,
     /*  399507 */     // GIR_Coverage, 4569,
     /*  399507 */     GIR_EraseRootFromParent_Done,
     /*  399508 */   // Label 7076: @399508
     /*  399508 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(399587), // Rule ID 4578 //
     /*  399513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  399533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  399565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  399568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399585 */     GIR_RootConstrainSelectedInstOperands,
     /*  399586 */     // GIR_Coverage, 4578,
     /*  399586 */     GIR_EraseRootFromParent_Done,
     /*  399587 */   // Label 7077: @399587
     /*  399587 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(399666), // Rule ID 4579 //
     /*  399592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  399612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  399647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399664 */     GIR_RootConstrainSelectedInstOperands,
     /*  399665 */     // GIR_Coverage, 4579,
     /*  399665 */     GIR_EraseRootFromParent_Done,
     /*  399666 */   // Label 7078: @399666
     /*  399666 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(399745), // Rule ID 4588 //
     /*  399671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  399691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399723 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  399723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  399726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399743 */     GIR_RootConstrainSelectedInstOperands,
     /*  399744 */     // GIR_Coverage, 4588,
     /*  399744 */     GIR_EraseRootFromParent_Done,
     /*  399745 */   // Label 7079: @399745
     /*  399745 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(399824), // Rule ID 4589 //
     /*  399750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  399770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  399802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  399805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399822 */     GIR_RootConstrainSelectedInstOperands,
     /*  399823 */     // GIR_Coverage, 4589,
     /*  399823 */     GIR_EraseRootFromParent_Done,
     /*  399824 */   // Label 7080: @399824
     /*  399824 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(399903), // Rule ID 4598 //
     /*  399829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  399840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  399843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  399846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  399849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399881 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  399881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  399884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399901 */     GIR_RootConstrainSelectedInstOperands,
     /*  399902 */     // GIR_Coverage, 4598,
     /*  399902 */     GIR_EraseRootFromParent_Done,
     /*  399903 */   // Label 7081: @399903
     /*  399903 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(399982), // Rule ID 4599 //
     /*  399908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  399919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  399922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  399925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  399928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  399939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  399943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  399953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  399960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  399963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  399969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  399980 */     GIR_RootConstrainSelectedInstOperands,
     /*  399981 */     // GIR_Coverage, 4599,
     /*  399981 */     GIR_EraseRootFromParent_Done,
     /*  399982 */   // Label 7082: @399982
     /*  399982 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(400061), // Rule ID 4608 //
     /*  399987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  399995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  399998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  400001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  400004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  400007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  400039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  400042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400059 */     GIR_RootConstrainSelectedInstOperands,
     /*  400060 */     // GIR_Coverage, 4608,
     /*  400060 */     GIR_EraseRootFromParent_Done,
     /*  400061 */   // Label 7083: @400061
     /*  400061 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(400140), // Rule ID 4609 //
     /*  400066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  400077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  400080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  400083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  400086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  400118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  400121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400138 */     GIR_RootConstrainSelectedInstOperands,
     /*  400139 */     // GIR_Coverage, 4609,
     /*  400139 */     GIR_EraseRootFromParent_Done,
     /*  400140 */   // Label 7084: @400140
     /*  400140 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(400219), // Rule ID 4618 //
     /*  400145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  400165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  400197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  400200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400217 */     GIR_RootConstrainSelectedInstOperands,
     /*  400218 */     // GIR_Coverage, 4618,
     /*  400218 */     GIR_EraseRootFromParent_Done,
     /*  400219 */   // Label 7085: @400219
     /*  400219 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(400298), // Rule ID 4619 //
     /*  400224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  400244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  400276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  400279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400296 */     GIR_RootConstrainSelectedInstOperands,
     /*  400297 */     // GIR_Coverage, 4619,
     /*  400297 */     GIR_EraseRootFromParent_Done,
     /*  400298 */   // Label 7086: @400298
     /*  400298 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(400377), // Rule ID 4628 //
     /*  400303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  400323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400355 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  400355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  400358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400375 */     GIR_RootConstrainSelectedInstOperands,
     /*  400376 */     // GIR_Coverage, 4628,
     /*  400376 */     GIR_EraseRootFromParent_Done,
     /*  400377 */   // Label 7087: @400377
     /*  400377 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(400456), // Rule ID 4629 //
     /*  400382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  400402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  400434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  400437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400454 */     GIR_RootConstrainSelectedInstOperands,
     /*  400455 */     // GIR_Coverage, 4629,
     /*  400455 */     GIR_EraseRootFromParent_Done,
     /*  400456 */   // Label 7088: @400456
     /*  400456 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(400535), // Rule ID 4638 //
     /*  400461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  400481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400513 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  400513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  400516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400533 */     GIR_RootConstrainSelectedInstOperands,
     /*  400534 */     // GIR_Coverage, 4638,
     /*  400534 */     GIR_EraseRootFromParent_Done,
     /*  400535 */   // Label 7089: @400535
     /*  400535 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(400614), // Rule ID 4639 //
     /*  400540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  400560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  400592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  400595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400612 */     GIR_RootConstrainSelectedInstOperands,
     /*  400613 */     // GIR_Coverage, 4639,
     /*  400613 */     GIR_EraseRootFromParent_Done,
     /*  400614 */   // Label 7090: @400614
     /*  400614 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(400693), // Rule ID 4648 //
     /*  400619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  400622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  400630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  400633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  400636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  400639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  400671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  400674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400691 */     GIR_RootConstrainSelectedInstOperands,
     /*  400692 */     // GIR_Coverage, 4648,
     /*  400692 */     GIR_EraseRootFromParent_Done,
     /*  400693 */   // Label 7091: @400693
     /*  400693 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(400772), // Rule ID 4649 //
     /*  400698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  400701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  400709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  400712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  400715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  400718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  400750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  400753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400770 */     GIR_RootConstrainSelectedInstOperands,
     /*  400771 */     // GIR_Coverage, 4649,
     /*  400771 */     GIR_EraseRootFromParent_Done,
     /*  400772 */   // Label 7092: @400772
     /*  400772 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(400851), // Rule ID 4658 //
     /*  400777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  400780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  400797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  400829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  400832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400849 */     GIR_RootConstrainSelectedInstOperands,
     /*  400850 */     // GIR_Coverage, 4658,
     /*  400850 */     GIR_EraseRootFromParent_Done,
     /*  400851 */   // Label 7093: @400851
     /*  400851 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(400930), // Rule ID 4659 //
     /*  400856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  400859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  400876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  400908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  400911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  400928 */     GIR_RootConstrainSelectedInstOperands,
     /*  400929 */     // GIR_Coverage, 4659,
     /*  400929 */     GIR_EraseRootFromParent_Done,
     /*  400930 */   // Label 7094: @400930
     /*  400930 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(401009), // Rule ID 4668 //
     /*  400935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  400938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  400943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  400955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  400966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  400970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  400980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400987 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  400987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  400990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  400996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  401007 */     GIR_RootConstrainSelectedInstOperands,
     /*  401008 */     // GIR_Coverage, 4668,
     /*  401008 */     GIR_EraseRootFromParent_Done,
     /*  401009 */   // Label 7095: @401009
     /*  401009 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(401088), // Rule ID 4669 //
     /*  401014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  401017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  401022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  401025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  401028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  401031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  401034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  401045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  401049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  401059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  401066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  401069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  401075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  401086 */     GIR_RootConstrainSelectedInstOperands,
     /*  401087 */     // GIR_Coverage, 4669,
     /*  401087 */     GIR_EraseRootFromParent_Done,
     /*  401088 */   // Label 7096: @401088
     /*  401088 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(401167), // Rule ID 4678 //
     /*  401093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  401096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  401101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  401104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  401107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  401110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  401113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  401124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  401128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  401138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401145 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  401145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  401148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  401154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  401165 */     GIR_RootConstrainSelectedInstOperands,
     /*  401166 */     // GIR_Coverage, 4678,
     /*  401166 */     GIR_EraseRootFromParent_Done,
     /*  401167 */   // Label 7097: @401167
     /*  401167 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(401246), // Rule ID 4679 //
     /*  401172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  401175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  401180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  401183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  401186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  401189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  401192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  401203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  401207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  401217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  401224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  401227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  401233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  401244 */     GIR_RootConstrainSelectedInstOperands,
     /*  401245 */     // GIR_Coverage, 4679,
     /*  401245 */     GIR_EraseRootFromParent_Done,
     /*  401246 */   // Label 7098: @401246
     /*  401246 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(401314), // Rule ID 2570 //
     /*  401251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  401268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401283 */     // MIs[0] policy
     /*  401283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  401296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401300 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401310 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401312 */     GIR_RootConstrainSelectedInstOperands,
     /*  401313 */     // GIR_Coverage, 2570,
     /*  401313 */     GIR_EraseRootFromParent_Done,
     /*  401314 */   // Label 7099: @401314
     /*  401314 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(401382), // Rule ID 2571 //
     /*  401319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  401336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401351 */     // MIs[0] policy
     /*  401351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401361 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  401361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  401364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401368 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401378 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401380 */     GIR_RootConstrainSelectedInstOperands,
     /*  401381 */     // GIR_Coverage, 2571,
     /*  401381 */     GIR_EraseRootFromParent_Done,
     /*  401382 */   // Label 7100: @401382
     /*  401382 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(401450), // Rule ID 23358 //
     /*  401387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  401404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401419 */     // MIs[0] policy
     /*  401419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  401432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401436 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401446 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401448 */     GIR_RootConstrainSelectedInstOperands,
     /*  401449 */     // GIR_Coverage, 23358,
     /*  401449 */     GIR_EraseRootFromParent_Done,
     /*  401450 */   // Label 7101: @401450
     /*  401450 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(401518), // Rule ID 23359 //
     /*  401455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  401472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401487 */     // MIs[0] policy
     /*  401487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401497 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  401497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  401500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401504 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401514 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401516 */     GIR_RootConstrainSelectedInstOperands,
     /*  401517 */     // GIR_Coverage, 23359,
     /*  401517 */     GIR_EraseRootFromParent_Done,
     /*  401518 */   // Label 7102: @401518
     /*  401518 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(401586), // Rule ID 23362 //
     /*  401523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  401540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401555 */     // MIs[0] policy
     /*  401555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401565 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  401568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401572 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401582 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401584 */     GIR_RootConstrainSelectedInstOperands,
     /*  401585 */     // GIR_Coverage, 23362,
     /*  401585 */     GIR_EraseRootFromParent_Done,
     /*  401586 */   // Label 7103: @401586
     /*  401586 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(401654), // Rule ID 23363 //
     /*  401591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  401608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401623 */     // MIs[0] policy
     /*  401623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401633 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  401633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  401636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401640 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401650 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401652 */     GIR_RootConstrainSelectedInstOperands,
     /*  401653 */     // GIR_Coverage, 23363,
     /*  401653 */     GIR_EraseRootFromParent_Done,
     /*  401654 */   // Label 7104: @401654
     /*  401654 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(401722), // Rule ID 23366 //
     /*  401659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  401676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401691 */     // MIs[0] policy
     /*  401691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401701 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  401704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401708 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401718 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401720 */     GIR_RootConstrainSelectedInstOperands,
     /*  401721 */     // GIR_Coverage, 23366,
     /*  401721 */     GIR_EraseRootFromParent_Done,
     /*  401722 */   // Label 7105: @401722
     /*  401722 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(401790), // Rule ID 23367 //
     /*  401727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  401744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401759 */     // MIs[0] policy
     /*  401759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  401769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  401772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401776 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401786 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401788 */     GIR_RootConstrainSelectedInstOperands,
     /*  401789 */     // GIR_Coverage, 23367,
     /*  401789 */     GIR_EraseRootFromParent_Done,
     /*  401790 */   // Label 7106: @401790
     /*  401790 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(401858), // Rule ID 23370 //
     /*  401795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  401812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401827 */     // MIs[0] policy
     /*  401827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401837 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  401840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401844 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401854 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401856 */     GIR_RootConstrainSelectedInstOperands,
     /*  401857 */     // GIR_Coverage, 23370,
     /*  401857 */     GIR_EraseRootFromParent_Done,
     /*  401858 */   // Label 7107: @401858
     /*  401858 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(401926), // Rule ID 23371 //
     /*  401863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  401880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401895 */     // MIs[0] policy
     /*  401895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401905 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  401905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  401908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401912 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401922 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401924 */     GIR_RootConstrainSelectedInstOperands,
     /*  401925 */     // GIR_Coverage, 23371,
     /*  401925 */     GIR_EraseRootFromParent_Done,
     /*  401926 */   // Label 7108: @401926
     /*  401926 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(401994), // Rule ID 23374 //
     /*  401931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  401939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  401948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  401955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  401963 */     // MIs[0] policy
     /*  401963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  401966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401973 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  401973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  401976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401980 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  401982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401990 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  401992 */     GIR_RootConstrainSelectedInstOperands,
     /*  401993 */     // GIR_Coverage, 23374,
     /*  401993 */     GIR_EraseRootFromParent_Done,
     /*  401994 */   // Label 7109: @401994
     /*  401994 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(402062), // Rule ID 23375 //
     /*  401999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  402010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  402013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  402016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402031 */     // MIs[0] policy
     /*  402031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402041 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  402044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402048 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402058 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402060 */     GIR_RootConstrainSelectedInstOperands,
     /*  402061 */     // GIR_Coverage, 23375,
     /*  402061 */     GIR_EraseRootFromParent_Done,
     /*  402062 */   // Label 7110: @402062
     /*  402062 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(402130), // Rule ID 23378 //
     /*  402067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  402078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  402081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  402084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402099 */     // MIs[0] policy
     /*  402099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402109 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402116 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402126 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402128 */     GIR_RootConstrainSelectedInstOperands,
     /*  402129 */     // GIR_Coverage, 23378,
     /*  402129 */     GIR_EraseRootFromParent_Done,
     /*  402130 */   // Label 7111: @402130
     /*  402130 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(402198), // Rule ID 23379 //
     /*  402135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  402146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  402149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  402152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402167 */     // MIs[0] policy
     /*  402167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402184 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402194 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402196 */     GIR_RootConstrainSelectedInstOperands,
     /*  402197 */     // GIR_Coverage, 23379,
     /*  402197 */     GIR_EraseRootFromParent_Done,
     /*  402198 */   // Label 7112: @402198
     /*  402198 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(402266), // Rule ID 23382 //
     /*  402203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  402220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402235 */     // MIs[0] policy
     /*  402235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402252 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402262 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402264 */     GIR_RootConstrainSelectedInstOperands,
     /*  402265 */     // GIR_Coverage, 23382,
     /*  402265 */     GIR_EraseRootFromParent_Done,
     /*  402266 */   // Label 7113: @402266
     /*  402266 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(402334), // Rule ID 23383 //
     /*  402271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  402288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402303 */     // MIs[0] policy
     /*  402303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402313 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402320 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402330 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402332 */     GIR_RootConstrainSelectedInstOperands,
     /*  402333 */     // GIR_Coverage, 23383,
     /*  402333 */     GIR_EraseRootFromParent_Done,
     /*  402334 */   // Label 7114: @402334
     /*  402334 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(402402), // Rule ID 23386 //
     /*  402339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  402356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402371 */     // MIs[0] policy
     /*  402371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402381 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402388 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402398 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402400 */     GIR_RootConstrainSelectedInstOperands,
     /*  402401 */     // GIR_Coverage, 23386,
     /*  402401 */     GIR_EraseRootFromParent_Done,
     /*  402402 */   // Label 7115: @402402
     /*  402402 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(402470), // Rule ID 23387 //
     /*  402407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  402424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402439 */     // MIs[0] policy
     /*  402439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402456 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402466 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402468 */     GIR_RootConstrainSelectedInstOperands,
     /*  402469 */     // GIR_Coverage, 23387,
     /*  402469 */     GIR_EraseRootFromParent_Done,
     /*  402470 */   // Label 7116: @402470
     /*  402470 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(402538), // Rule ID 23390 //
     /*  402475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  402478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  402492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402507 */     // MIs[0] policy
     /*  402507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402524 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402534 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402536 */     GIR_RootConstrainSelectedInstOperands,
     /*  402537 */     // GIR_Coverage, 23390,
     /*  402537 */     GIR_EraseRootFromParent_Done,
     /*  402538 */   // Label 7117: @402538
     /*  402538 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(402606), // Rule ID 23391 //
     /*  402543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  402546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  402560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  402567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402575 */     // MIs[0] policy
     /*  402575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402585 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  402588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402592 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402602 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402604 */     GIR_RootConstrainSelectedInstOperands,
     /*  402605 */     // GIR_Coverage, 23391,
     /*  402605 */     GIR_EraseRootFromParent_Done,
     /*  402606 */   // Label 7118: @402606
     /*  402606 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(402674), // Rule ID 23394 //
     /*  402611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  402628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  402635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402643 */     // MIs[0] policy
     /*  402643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  402656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402660 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402670 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402672 */     GIR_RootConstrainSelectedInstOperands,
     /*  402673 */     // GIR_Coverage, 23394,
     /*  402673 */     GIR_EraseRootFromParent_Done,
     /*  402674 */   // Label 7119: @402674
     /*  402674 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(402742), // Rule ID 23395 //
     /*  402679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  402696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  402703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402711 */     // MIs[0] policy
     /*  402711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  402724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402728 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402738 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402740 */     GIR_RootConstrainSelectedInstOperands,
     /*  402741 */     // GIR_Coverage, 23395,
     /*  402741 */     GIR_EraseRootFromParent_Done,
     /*  402742 */   // Label 7120: @402742
     /*  402742 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(402810), // Rule ID 23398 //
     /*  402747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  402764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  402771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402779 */     // MIs[0] policy
     /*  402779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  402792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402796 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402806 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402808 */     GIR_RootConstrainSelectedInstOperands,
     /*  402809 */     // GIR_Coverage, 23398,
     /*  402809 */     GIR_EraseRootFromParent_Done,
     /*  402810 */   // Label 7121: @402810
     /*  402810 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(402878), // Rule ID 23399 //
     /*  402815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  402832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  402839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402847 */     // MIs[0] policy
     /*  402847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402857 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  402860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402864 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402874 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402876 */     GIR_RootConstrainSelectedInstOperands,
     /*  402877 */     // GIR_Coverage, 23399,
     /*  402877 */     GIR_EraseRootFromParent_Done,
     /*  402878 */   // Label 7122: @402878
     /*  402878 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(402946), // Rule ID 23402 //
     /*  402883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  402900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  402907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402915 */     // MIs[0] policy
     /*  402915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402925 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  402925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  402928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402932 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  402934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402942 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  402944 */     GIR_RootConstrainSelectedInstOperands,
     /*  402945 */     // GIR_Coverage, 23402,
     /*  402945 */     GIR_EraseRootFromParent_Done,
     /*  402946 */   // Label 7123: @402946
     /*  402946 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(403014), // Rule ID 23403 //
     /*  402951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  402959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  402968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  402975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  402983 */     // MIs[0] policy
     /*  402983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  402986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  402993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  402996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403000 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  403010 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403012 */     GIR_RootConstrainSelectedInstOperands,
     /*  403013 */     // GIR_Coverage, 23403,
     /*  403013 */     GIR_EraseRootFromParent_Done,
     /*  403014 */   // Label 7124: @403014
     /*  403014 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(403082), // Rule ID 23406 //
     /*  403019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  403036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403051 */     // MIs[0] policy
     /*  403051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403068 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403078 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403080 */     GIR_RootConstrainSelectedInstOperands,
     /*  403081 */     // GIR_Coverage, 23406,
     /*  403081 */     GIR_EraseRootFromParent_Done,
     /*  403082 */   // Label 7125: @403082
     /*  403082 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(403150), // Rule ID 23407 //
     /*  403087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  403104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403119 */     // MIs[0] policy
     /*  403119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403136 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403146 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403148 */     GIR_RootConstrainSelectedInstOperands,
     /*  403149 */     // GIR_Coverage, 23407,
     /*  403149 */     GIR_EraseRootFromParent_Done,
     /*  403150 */   // Label 7126: @403150
     /*  403150 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(403218), // Rule ID 23410 //
     /*  403155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  403172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  403179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403187 */     // MIs[0] policy
     /*  403187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403197 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  403200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403204 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403214 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403216 */     GIR_RootConstrainSelectedInstOperands,
     /*  403217 */     // GIR_Coverage, 23410,
     /*  403217 */     GIR_EraseRootFromParent_Done,
     /*  403218 */   // Label 7127: @403218
     /*  403218 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(403286), // Rule ID 23411 //
     /*  403223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  403240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  403247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403255 */     // MIs[0] policy
     /*  403255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  403268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403272 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403282 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403284 */     GIR_RootConstrainSelectedInstOperands,
     /*  403285 */     // GIR_Coverage, 23411,
     /*  403285 */     GIR_EraseRootFromParent_Done,
     /*  403286 */   // Label 7128: @403286
     /*  403286 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(403354), // Rule ID 23414 //
     /*  403291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  403308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  403315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403323 */     // MIs[0] policy
     /*  403323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403333 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  403336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403340 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403350 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403352 */     GIR_RootConstrainSelectedInstOperands,
     /*  403353 */     // GIR_Coverage, 23414,
     /*  403353 */     GIR_EraseRootFromParent_Done,
     /*  403354 */   // Label 7129: @403354
     /*  403354 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(403422), // Rule ID 23415 //
     /*  403359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  403376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  403383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403391 */     // MIs[0] policy
     /*  403391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  403404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403408 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403418 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403420 */     GIR_RootConstrainSelectedInstOperands,
     /*  403421 */     // GIR_Coverage, 23415,
     /*  403421 */     GIR_EraseRootFromParent_Done,
     /*  403422 */   // Label 7130: @403422
     /*  403422 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(403490), // Rule ID 23418 //
     /*  403427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  403444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403459 */     // MIs[0] policy
     /*  403459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403476 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403486 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403488 */     GIR_RootConstrainSelectedInstOperands,
     /*  403489 */     // GIR_Coverage, 23418,
     /*  403489 */     GIR_EraseRootFromParent_Done,
     /*  403490 */   // Label 7131: @403490
     /*  403490 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(403558), // Rule ID 23419 //
     /*  403495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  403512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403527 */     // MIs[0] policy
     /*  403527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403544 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403554 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403556 */     GIR_RootConstrainSelectedInstOperands,
     /*  403557 */     // GIR_Coverage, 23419,
     /*  403557 */     GIR_EraseRootFromParent_Done,
     /*  403558 */   // Label 7132: @403558
     /*  403558 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(403626), // Rule ID 23422 //
     /*  403563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  403580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  403587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403595 */     // MIs[0] policy
     /*  403595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403605 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  403608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403612 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403622 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403624 */     GIR_RootConstrainSelectedInstOperands,
     /*  403625 */     // GIR_Coverage, 23422,
     /*  403625 */     GIR_EraseRootFromParent_Done,
     /*  403626 */   // Label 7133: @403626
     /*  403626 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(403694), // Rule ID 23423 //
     /*  403631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  403648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  403655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403663 */     // MIs[0] policy
     /*  403663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403673 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  403676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403680 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403690 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403692 */     GIR_RootConstrainSelectedInstOperands,
     /*  403693 */     // GIR_Coverage, 23423,
     /*  403693 */     GIR_EraseRootFromParent_Done,
     /*  403694 */   // Label 7134: @403694
     /*  403694 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(403762), // Rule ID 23426 //
     /*  403699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  403716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  403723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403731 */     // MIs[0] policy
     /*  403731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  403744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403748 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403758 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403760 */     GIR_RootConstrainSelectedInstOperands,
     /*  403761 */     // GIR_Coverage, 23426,
     /*  403761 */     GIR_EraseRootFromParent_Done,
     /*  403762 */   // Label 7135: @403762
     /*  403762 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(403830), // Rule ID 23427 //
     /*  403767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  403784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  403791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403799 */     // MIs[0] policy
     /*  403799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  403812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403816 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403826 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403828 */     GIR_RootConstrainSelectedInstOperands,
     /*  403829 */     // GIR_Coverage, 23427,
     /*  403829 */     GIR_EraseRootFromParent_Done,
     /*  403830 */   // Label 7136: @403830
     /*  403830 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(403898), // Rule ID 23430 //
     /*  403835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  403838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  403852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403867 */     // MIs[0] policy
     /*  403867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  403877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403884 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403894 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403896 */     GIR_RootConstrainSelectedInstOperands,
     /*  403897 */     // GIR_Coverage, 23430,
     /*  403897 */     GIR_EraseRootFromParent_Done,
     /*  403898 */   // Label 7137: @403898
     /*  403898 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(403966), // Rule ID 23431 //
     /*  403903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  403906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  403920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  403927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  403935 */     // MIs[0] policy
     /*  403935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  403938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  403945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  403948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403952 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  403954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403962 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  403964 */     GIR_RootConstrainSelectedInstOperands,
     /*  403965 */     // GIR_Coverage, 23431,
     /*  403965 */     GIR_EraseRootFromParent_Done,
     /*  403966 */   // Label 7138: @403966
     /*  403966 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(404034), // Rule ID 23434 //
     /*  403971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  403974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  403979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  403982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  403985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  403988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  403995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  404003 */     // MIs[0] policy
     /*  404003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404013 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  404016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404020 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  404022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404030 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404032 */     GIR_RootConstrainSelectedInstOperands,
     /*  404033 */     // GIR_Coverage, 23434,
     /*  404033 */     GIR_EraseRootFromParent_Done,
     /*  404034 */   // Label 7139: @404034
     /*  404034 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(404102), // Rule ID 23435 //
     /*  404039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  404047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  404056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  404063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  404071 */     // MIs[0] policy
     /*  404071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  404084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404088 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  404090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404098 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404100 */     GIR_RootConstrainSelectedInstOperands,
     /*  404101 */     // GIR_Coverage, 23435,
     /*  404101 */     GIR_EraseRootFromParent_Done,
     /*  404102 */   // Label 7140: @404102
     /*  404102 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(404170), // Rule ID 23438 //
     /*  404107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  404110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  404115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  404124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  404131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  404139 */     // MIs[0] policy
     /*  404139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404149 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  404152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404156 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  404158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404166 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404168 */     GIR_RootConstrainSelectedInstOperands,
     /*  404169 */     // GIR_Coverage, 23438,
     /*  404169 */     GIR_EraseRootFromParent_Done,
     /*  404170 */   // Label 7141: @404170
     /*  404170 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(404238), // Rule ID 23439 //
     /*  404175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  404183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  404192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  404199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  404207 */     // MIs[0] policy
     /*  404207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404217 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  404220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404224 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  404226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404234 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404236 */     GIR_RootConstrainSelectedInstOperands,
     /*  404237 */     // GIR_Coverage, 23439,
     /*  404237 */     GIR_EraseRootFromParent_Done,
     /*  404238 */   // Label 7142: @404238
     /*  404238 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(404306), // Rule ID 59876 //
     /*  404243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  404246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404275 */     // MIs[0] policy
     /*  404275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404285 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11011:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  404288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404302 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404304 */     GIR_RootConstrainSelectedInstOperands,
     /*  404305 */     // GIR_Coverage, 59876,
     /*  404305 */     GIR_EraseRootFromParent_Done,
     /*  404306 */   // Label 7143: @404306
     /*  404306 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(404374), // Rule ID 59877 //
     /*  404311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  404314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404343 */     // MIs[0] policy
     /*  404343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404353 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11011:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  404356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404370 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404372 */     GIR_RootConstrainSelectedInstOperands,
     /*  404373 */     // GIR_Coverage, 59877,
     /*  404373 */     GIR_EraseRootFromParent_Done,
     /*  404374 */   // Label 7144: @404374
     /*  404374 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(404442), // Rule ID 59878 //
     /*  404379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  404382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  404387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404411 */     // MIs[0] policy
     /*  404411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  404424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404438 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404440 */     GIR_RootConstrainSelectedInstOperands,
     /*  404441 */     // GIR_Coverage, 59878,
     /*  404441 */     GIR_EraseRootFromParent_Done,
     /*  404442 */   // Label 7145: @404442
     /*  404442 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(404510), // Rule ID 59879 //
     /*  404447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  404450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  404455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404479 */     // MIs[0] policy
     /*  404479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  404492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404506 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404508 */     GIR_RootConstrainSelectedInstOperands,
     /*  404509 */     // GIR_Coverage, 59879,
     /*  404509 */     GIR_EraseRootFromParent_Done,
     /*  404510 */   // Label 7146: @404510
     /*  404510 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(404578), // Rule ID 61372 //
     /*  404515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  404518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  404532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404547 */     // MIs[0] policy
     /*  404547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11011:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  404560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404574 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404576 */     GIR_RootConstrainSelectedInstOperands,
     /*  404577 */     // GIR_Coverage, 61372,
     /*  404577 */     GIR_EraseRootFromParent_Done,
     /*  404578 */   // Label 7147: @404578
     /*  404578 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(404646), // Rule ID 61373 //
     /*  404583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  404586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  404600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404615 */     // MIs[0] policy
     /*  404615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11011:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  404628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404642 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404644 */     GIR_RootConstrainSelectedInstOperands,
     /*  404645 */     // GIR_Coverage, 61373,
     /*  404645 */     GIR_EraseRootFromParent_Done,
     /*  404646 */   // Label 7148: @404646
     /*  404646 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(404714), // Rule ID 61374 //
     /*  404651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  404654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404683 */     // MIs[0] policy
     /*  404683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11011:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  404696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404710 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404712 */     GIR_RootConstrainSelectedInstOperands,
     /*  404713 */     // GIR_Coverage, 61374,
     /*  404713 */     GIR_EraseRootFromParent_Done,
     /*  404714 */   // Label 7149: @404714
     /*  404714 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(404782), // Rule ID 61375 //
     /*  404719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  404722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404751 */     // MIs[0] policy
     /*  404751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11011:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  404764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404778 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404780 */     GIR_RootConstrainSelectedInstOperands,
     /*  404781 */     // GIR_Coverage, 61375,
     /*  404781 */     GIR_EraseRootFromParent_Done,
     /*  404782 */   // Label 7150: @404782
     /*  404782 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(404850), // Rule ID 61376 //
     /*  404787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  404790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404819 */     // MIs[0] policy
     /*  404819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11011:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  404832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404846 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404848 */     GIR_RootConstrainSelectedInstOperands,
     /*  404849 */     // GIR_Coverage, 61376,
     /*  404849 */     GIR_EraseRootFromParent_Done,
     /*  404850 */   // Label 7151: @404850
     /*  404850 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(404918), // Rule ID 61377 //
     /*  404855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  404858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404887 */     // MIs[0] policy
     /*  404887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404897 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11011:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  404897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  404900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404914 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404916 */     GIR_RootConstrainSelectedInstOperands,
     /*  404917 */     // GIR_Coverage, 61377,
     /*  404917 */     GIR_EraseRootFromParent_Done,
     /*  404918 */   // Label 7152: @404918
     /*  404918 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(404986), // Rule ID 61378 //
     /*  404923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  404926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404955 */     // MIs[0] policy
     /*  404955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  404958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11011:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  404965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  404968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  404970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  404972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404982 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  404984 */     GIR_RootConstrainSelectedInstOperands,
     /*  404985 */     // GIR_Coverage, 61378,
     /*  404985 */     GIR_EraseRootFromParent_Done,
     /*  404986 */   // Label 7153: @404986
     /*  404986 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(405054), // Rule ID 61379 //
     /*  404991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  404994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  404999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  405008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405023 */     // MIs[0] policy
     /*  405023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11011:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  405036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405050 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405052 */     GIR_RootConstrainSelectedInstOperands,
     /*  405053 */     // GIR_Coverage, 61379,
     /*  405053 */     GIR_EraseRootFromParent_Done,
     /*  405054 */   // Label 7154: @405054
     /*  405054 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(405122), // Rule ID 61380 //
     /*  405059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405091 */     // MIs[0] policy
     /*  405091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  405104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405118 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405120 */     GIR_RootConstrainSelectedInstOperands,
     /*  405121 */     // GIR_Coverage, 61380,
     /*  405121 */     GIR_EraseRootFromParent_Done,
     /*  405122 */   // Label 7155: @405122
     /*  405122 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(405190), // Rule ID 61381 //
     /*  405127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405159 */     // MIs[0] policy
     /*  405159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  405172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405186 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405188 */     GIR_RootConstrainSelectedInstOperands,
     /*  405189 */     // GIR_Coverage, 61381,
     /*  405189 */     GIR_EraseRootFromParent_Done,
     /*  405190 */   // Label 7156: @405190
     /*  405190 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(405258), // Rule ID 61382 //
     /*  405195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405227 */     // MIs[0] policy
     /*  405227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405237 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  405240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405254 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405256 */     GIR_RootConstrainSelectedInstOperands,
     /*  405257 */     // GIR_Coverage, 61382,
     /*  405257 */     GIR_EraseRootFromParent_Done,
     /*  405258 */   // Label 7157: @405258
     /*  405258 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(405326), // Rule ID 61383 //
     /*  405263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405295 */     // MIs[0] policy
     /*  405295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405305 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  405308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405322 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405324 */     GIR_RootConstrainSelectedInstOperands,
     /*  405325 */     // GIR_Coverage, 61383,
     /*  405325 */     GIR_EraseRootFromParent_Done,
     /*  405326 */   // Label 7158: @405326
     /*  405326 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(405394), // Rule ID 61384 //
     /*  405331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405363 */     // MIs[0] policy
     /*  405363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  405376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405390 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405392 */     GIR_RootConstrainSelectedInstOperands,
     /*  405393 */     // GIR_Coverage, 61384,
     /*  405393 */     GIR_EraseRootFromParent_Done,
     /*  405394 */   // Label 7159: @405394
     /*  405394 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(405462), // Rule ID 61385 //
     /*  405399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405431 */     // MIs[0] policy
     /*  405431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  405444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405458 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405460 */     GIR_RootConstrainSelectedInstOperands,
     /*  405461 */     // GIR_Coverage, 61385,
     /*  405461 */     GIR_EraseRootFromParent_Done,
     /*  405462 */   // Label 7160: @405462
     /*  405462 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(405530), // Rule ID 61386 //
     /*  405467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405499 */     // MIs[0] policy
     /*  405499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  405512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405526 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405528 */     GIR_RootConstrainSelectedInstOperands,
     /*  405529 */     // GIR_Coverage, 61386,
     /*  405529 */     GIR_EraseRootFromParent_Done,
     /*  405530 */   // Label 7161: @405530
     /*  405530 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(405598), // Rule ID 61387 //
     /*  405535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405567 */     // MIs[0] policy
     /*  405567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  405580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405594 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405596 */     GIR_RootConstrainSelectedInstOperands,
     /*  405597 */     // GIR_Coverage, 61387,
     /*  405597 */     GIR_EraseRootFromParent_Done,
     /*  405598 */   // Label 7162: @405598
     /*  405598 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(405666), // Rule ID 61388 //
     /*  405603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  405620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405635 */     // MIs[0] policy
     /*  405635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405645 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10837:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  405648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405662 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405664 */     GIR_RootConstrainSelectedInstOperands,
     /*  405665 */     // GIR_Coverage, 61388,
     /*  405665 */     GIR_EraseRootFromParent_Done,
     /*  405666 */   // Label 7163: @405666
     /*  405666 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(405734), // Rule ID 61389 //
     /*  405671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  405679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  405688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405703 */     // MIs[0] policy
     /*  405703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405713 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10837:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  405716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405730 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405732 */     GIR_RootConstrainSelectedInstOperands,
     /*  405733 */     // GIR_Coverage, 61389,
     /*  405733 */     GIR_EraseRootFromParent_Done,
     /*  405734 */   // Label 7164: @405734
     /*  405734 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(405802), // Rule ID 61390 //
     /*  405739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  405747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405771 */     // MIs[0] policy
     /*  405771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405781 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  405784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405798 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405800 */     GIR_RootConstrainSelectedInstOperands,
     /*  405801 */     // GIR_Coverage, 61390,
     /*  405801 */     GIR_EraseRootFromParent_Done,
     /*  405802 */   // Label 7165: @405802
     /*  405802 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(405870), // Rule ID 61391 //
     /*  405807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  405815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405839 */     // MIs[0] policy
     /*  405839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  405852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405866 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405868 */     GIR_RootConstrainSelectedInstOperands,
     /*  405869 */     // GIR_Coverage, 61391,
     /*  405869 */     GIR_EraseRootFromParent_Done,
     /*  405870 */   // Label 7166: @405870
     /*  405870 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(405938), // Rule ID 61392 //
     /*  405875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  405878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  405883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  405895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405907 */     // MIs[0] policy
     /*  405907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405917 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  405917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  405920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405934 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  405936 */     GIR_RootConstrainSelectedInstOperands,
     /*  405937 */     // GIR_Coverage, 61392,
     /*  405937 */     GIR_EraseRootFromParent_Done,
     /*  405938 */   // Label 7167: @405938
     /*  405938 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(406006), // Rule ID 61393 //
     /*  405943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  405946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  405951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  405963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405975 */     // MIs[0] policy
     /*  405975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  405978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405985 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  405985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  405988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  405990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  405992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406002 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406004 */     GIR_RootConstrainSelectedInstOperands,
     /*  406005 */     // GIR_Coverage, 61393,
     /*  406005 */     GIR_EraseRootFromParent_Done,
     /*  406006 */   // Label 7168: @406006
     /*  406006 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(406074), // Rule ID 61394 //
     /*  406011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406043 */     // MIs[0] policy
     /*  406043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406053 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  406056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406070 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406072 */     GIR_RootConstrainSelectedInstOperands,
     /*  406073 */     // GIR_Coverage, 61394,
     /*  406073 */     GIR_EraseRootFromParent_Done,
     /*  406074 */   // Label 7169: @406074
     /*  406074 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(406142), // Rule ID 61395 //
     /*  406079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406111 */     // MIs[0] policy
     /*  406111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  406124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406138 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406140 */     GIR_RootConstrainSelectedInstOperands,
     /*  406141 */     // GIR_Coverage, 61395,
     /*  406141 */     GIR_EraseRootFromParent_Done,
     /*  406142 */   // Label 7170: @406142
     /*  406142 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(406210), // Rule ID 61396 //
     /*  406147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406179 */     // MIs[0] policy
     /*  406179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  406192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406206 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406208 */     GIR_RootConstrainSelectedInstOperands,
     /*  406209 */     // GIR_Coverage, 61396,
     /*  406209 */     GIR_EraseRootFromParent_Done,
     /*  406210 */   // Label 7171: @406210
     /*  406210 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(406278), // Rule ID 61397 //
     /*  406215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406247 */     // MIs[0] policy
     /*  406247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  406260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406274 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406276 */     GIR_RootConstrainSelectedInstOperands,
     /*  406277 */     // GIR_Coverage, 61397,
     /*  406277 */     GIR_EraseRootFromParent_Done,
     /*  406278 */   // Label 7172: @406278
     /*  406278 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(406346), // Rule ID 61398 //
     /*  406283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406315 */     // MIs[0] policy
     /*  406315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  406328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406342 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406344 */     GIR_RootConstrainSelectedInstOperands,
     /*  406345 */     // GIR_Coverage, 61398,
     /*  406345 */     GIR_EraseRootFromParent_Done,
     /*  406346 */   // Label 7173: @406346
     /*  406346 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(406414), // Rule ID 61399 //
     /*  406351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406383 */     // MIs[0] policy
     /*  406383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  406396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406410 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406412 */     GIR_RootConstrainSelectedInstOperands,
     /*  406413 */     // GIR_Coverage, 61399,
     /*  406413 */     GIR_EraseRootFromParent_Done,
     /*  406414 */   // Label 7174: @406414
     /*  406414 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(406482), // Rule ID 61400 //
     /*  406419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406451 */     // MIs[0] policy
     /*  406451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  406464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406478 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406480 */     GIR_RootConstrainSelectedInstOperands,
     /*  406481 */     // GIR_Coverage, 61400,
     /*  406481 */     GIR_EraseRootFromParent_Done,
     /*  406482 */   // Label 7175: @406482
     /*  406482 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(406550), // Rule ID 61401 //
     /*  406487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406519 */     // MIs[0] policy
     /*  406519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  406532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406546 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406548 */     GIR_RootConstrainSelectedInstOperands,
     /*  406549 */     // GIR_Coverage, 61401,
     /*  406549 */     GIR_EraseRootFromParent_Done,
     /*  406550 */   // Label 7176: @406550
     /*  406550 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(406618), // Rule ID 61402 //
     /*  406555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406587 */     // MIs[0] policy
     /*  406587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406597 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  406600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406614 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406616 */     GIR_RootConstrainSelectedInstOperands,
     /*  406617 */     // GIR_Coverage, 61402,
     /*  406617 */     GIR_EraseRootFromParent_Done,
     /*  406618 */   // Label 7177: @406618
     /*  406618 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(406686), // Rule ID 61403 //
     /*  406623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406655 */     // MIs[0] policy
     /*  406655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  406668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406682 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406684 */     GIR_RootConstrainSelectedInstOperands,
     /*  406685 */     // GIR_Coverage, 61403,
     /*  406685 */     GIR_EraseRootFromParent_Done,
     /*  406686 */   // Label 7178: @406686
     /*  406686 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(406754), // Rule ID 61404 //
     /*  406691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406723 */     // MIs[0] policy
     /*  406723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406733 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  406736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406750 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406752 */     GIR_RootConstrainSelectedInstOperands,
     /*  406753 */     // GIR_Coverage, 61404,
     /*  406753 */     GIR_EraseRootFromParent_Done,
     /*  406754 */   // Label 7179: @406754
     /*  406754 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(406822), // Rule ID 61405 //
     /*  406759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406791 */     // MIs[0] policy
     /*  406791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  406804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406818 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406820 */     GIR_RootConstrainSelectedInstOperands,
     /*  406821 */     // GIR_Coverage, 61405,
     /*  406821 */     GIR_EraseRootFromParent_Done,
     /*  406822 */   // Label 7180: @406822
     /*  406822 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(406890), // Rule ID 61406 //
     /*  406827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406859 */     // MIs[0] policy
     /*  406859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406869 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  406869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  406872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406886 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406888 */     GIR_RootConstrainSelectedInstOperands,
     /*  406889 */     // GIR_Coverage, 61406,
     /*  406889 */     GIR_EraseRootFromParent_Done,
     /*  406890 */   // Label 7181: @406890
     /*  406890 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(406958), // Rule ID 61407 //
     /*  406895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  406898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  406915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406927 */     // MIs[0] policy
     /*  406927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  406937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  406940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  406942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  406944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406954 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  406956 */     GIR_RootConstrainSelectedInstOperands,
     /*  406957 */     // GIR_Coverage, 61407,
     /*  406957 */     GIR_EraseRootFromParent_Done,
     /*  406958 */   // Label 7182: @406958
     /*  406958 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(407026), // Rule ID 61408 //
     /*  406963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  406966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  406971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  406983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406995 */     // MIs[0] policy
     /*  406995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  406998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407005 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  407008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407022 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407024 */     GIR_RootConstrainSelectedInstOperands,
     /*  407025 */     // GIR_Coverage, 61408,
     /*  407025 */     GIR_EraseRootFromParent_Done,
     /*  407026 */   // Label 7183: @407026
     /*  407026 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(407094), // Rule ID 61409 //
     /*  407031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407063 */     // MIs[0] policy
     /*  407063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  407076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407090 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407092 */     GIR_RootConstrainSelectedInstOperands,
     /*  407093 */     // GIR_Coverage, 61409,
     /*  407093 */     GIR_EraseRootFromParent_Done,
     /*  407094 */   // Label 7184: @407094
     /*  407094 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(407162), // Rule ID 61410 //
     /*  407099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407131 */     // MIs[0] policy
     /*  407131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407141 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  407144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407158 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407160 */     GIR_RootConstrainSelectedInstOperands,
     /*  407161 */     // GIR_Coverage, 61410,
     /*  407161 */     GIR_EraseRootFromParent_Done,
     /*  407162 */   // Label 7185: @407162
     /*  407162 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(407230), // Rule ID 61411 //
     /*  407167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407199 */     // MIs[0] policy
     /*  407199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  407212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407226 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407228 */     GIR_RootConstrainSelectedInstOperands,
     /*  407229 */     // GIR_Coverage, 61411,
     /*  407229 */     GIR_EraseRootFromParent_Done,
     /*  407230 */   // Label 7186: @407230
     /*  407230 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(407298), // Rule ID 61412 //
     /*  407235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407267 */     // MIs[0] policy
     /*  407267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407277 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  407280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407294 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407296 */     GIR_RootConstrainSelectedInstOperands,
     /*  407297 */     // GIR_Coverage, 61412,
     /*  407297 */     GIR_EraseRootFromParent_Done,
     /*  407298 */   // Label 7187: @407298
     /*  407298 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(407366), // Rule ID 61413 //
     /*  407303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407335 */     // MIs[0] policy
     /*  407335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407345 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  407348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407362 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407364 */     GIR_RootConstrainSelectedInstOperands,
     /*  407365 */     // GIR_Coverage, 61413,
     /*  407365 */     GIR_EraseRootFromParent_Done,
     /*  407366 */   // Label 7188: @407366
     /*  407366 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(407434), // Rule ID 61414 //
     /*  407371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407403 */     // MIs[0] policy
     /*  407403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  407416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407430 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407432 */     GIR_RootConstrainSelectedInstOperands,
     /*  407433 */     // GIR_Coverage, 61414,
     /*  407433 */     GIR_EraseRootFromParent_Done,
     /*  407434 */   // Label 7189: @407434
     /*  407434 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(407502), // Rule ID 61415 //
     /*  407439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  407447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407471 */     // MIs[0] policy
     /*  407471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407481 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10836:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  407484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407498 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407500 */     GIR_RootConstrainSelectedInstOperands,
     /*  407501 */     // GIR_Coverage, 61415,
     /*  407501 */     GIR_EraseRootFromParent_Done,
     /*  407502 */   // Label 7190: @407502
     /*  407502 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(407570), // Rule ID 61416 //
     /*  407507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407539 */     // MIs[0] policy
     /*  407539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  407552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407566 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407568 */     GIR_RootConstrainSelectedInstOperands,
     /*  407569 */     // GIR_Coverage, 61416,
     /*  407569 */     GIR_EraseRootFromParent_Done,
     /*  407570 */   // Label 7191: @407570
     /*  407570 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(407638), // Rule ID 61417 //
     /*  407575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407607 */     // MIs[0] policy
     /*  407607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  407620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407634 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407636 */     GIR_RootConstrainSelectedInstOperands,
     /*  407637 */     // GIR_Coverage, 61417,
     /*  407637 */     GIR_EraseRootFromParent_Done,
     /*  407638 */   // Label 7192: @407638
     /*  407638 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(407706), // Rule ID 61418 //
     /*  407643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407675 */     // MIs[0] policy
     /*  407675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407685 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  407688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407702 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407704 */     GIR_RootConstrainSelectedInstOperands,
     /*  407705 */     // GIR_Coverage, 61418,
     /*  407705 */     GIR_EraseRootFromParent_Done,
     /*  407706 */   // Label 7193: @407706
     /*  407706 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(407774), // Rule ID 61419 //
     /*  407711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407743 */     // MIs[0] policy
     /*  407743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  407756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407770 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407772 */     GIR_RootConstrainSelectedInstOperands,
     /*  407773 */     // GIR_Coverage, 61419,
     /*  407773 */     GIR_EraseRootFromParent_Done,
     /*  407774 */   // Label 7194: @407774
     /*  407774 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(407842), // Rule ID 61420 //
     /*  407779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407811 */     // MIs[0] policy
     /*  407811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  407824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407838 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407840 */     GIR_RootConstrainSelectedInstOperands,
     /*  407841 */     // GIR_Coverage, 61420,
     /*  407841 */     GIR_EraseRootFromParent_Done,
     /*  407842 */   // Label 7195: @407842
     /*  407842 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(407910), // Rule ID 61421 //
     /*  407847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  407867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407879 */     // MIs[0] policy
     /*  407879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  407889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  407892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407906 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407908 */     GIR_RootConstrainSelectedInstOperands,
     /*  407909 */     // GIR_Coverage, 61421,
     /*  407909 */     GIR_EraseRootFromParent_Done,
     /*  407910 */   // Label 7196: @407910
     /*  407910 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(407978), // Rule ID 61422 //
     /*  407915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  407918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  407935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407947 */     // MIs[0] policy
     /*  407947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  407950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  407957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  407960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  407962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  407964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407974 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  407976 */     GIR_RootConstrainSelectedInstOperands,
     /*  407977 */     // GIR_Coverage, 61422,
     /*  407977 */     GIR_EraseRootFromParent_Done,
     /*  407978 */   // Label 7197: @407978
     /*  407978 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(408046), // Rule ID 61423 //
     /*  407983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  407986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  407991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408015 */     // MIs[0] policy
     /*  408015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  408028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408042 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408044 */     GIR_RootConstrainSelectedInstOperands,
     /*  408045 */     // GIR_Coverage, 61423,
     /*  408045 */     GIR_EraseRootFromParent_Done,
     /*  408046 */   // Label 7198: @408046
     /*  408046 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(408114), // Rule ID 61424 //
     /*  408051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  408059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408083 */     // MIs[0] policy
     /*  408083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10839:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  408096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408110 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408112 */     GIR_RootConstrainSelectedInstOperands,
     /*  408113 */     // GIR_Coverage, 61424,
     /*  408113 */     GIR_EraseRootFromParent_Done,
     /*  408114 */   // Label 7199: @408114
     /*  408114 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(408182), // Rule ID 61425 //
     /*  408119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  408127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408151 */     // MIs[0] policy
     /*  408151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408161 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10839:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  408164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408178 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408180 */     GIR_RootConstrainSelectedInstOperands,
     /*  408181 */     // GIR_Coverage, 61425,
     /*  408181 */     GIR_EraseRootFromParent_Done,
     /*  408182 */   // Label 7200: @408182
     /*  408182 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(408250), // Rule ID 61426 //
     /*  408187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  408198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  408201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408219 */     // MIs[0] policy
     /*  408219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408229 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  408232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408246 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408248 */     GIR_RootConstrainSelectedInstOperands,
     /*  408249 */     // GIR_Coverage, 61426,
     /*  408249 */     GIR_EraseRootFromParent_Done,
     /*  408250 */   // Label 7201: @408250
     /*  408250 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(408318), // Rule ID 61427 //
     /*  408255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  408266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  408269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408287 */     // MIs[0] policy
     /*  408287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408297 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  408300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408314 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408316 */     GIR_RootConstrainSelectedInstOperands,
     /*  408317 */     // GIR_Coverage, 61427,
     /*  408317 */     GIR_EraseRootFromParent_Done,
     /*  408318 */   // Label 7202: @408318
     /*  408318 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(408386), // Rule ID 61428 //
     /*  408323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  408334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  408337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408355 */     // MIs[0] policy
     /*  408355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  408368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408382 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408384 */     GIR_RootConstrainSelectedInstOperands,
     /*  408385 */     // GIR_Coverage, 61428,
     /*  408385 */     GIR_EraseRootFromParent_Done,
     /*  408386 */   // Label 7203: @408386
     /*  408386 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(408454), // Rule ID 61429 //
     /*  408391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  408402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  408405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408423 */     // MIs[0] policy
     /*  408423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  408436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408450 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408452 */     GIR_RootConstrainSelectedInstOperands,
     /*  408453 */     // GIR_Coverage, 61429,
     /*  408453 */     GIR_EraseRootFromParent_Done,
     /*  408454 */   // Label 7204: @408454
     /*  408454 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(408522), // Rule ID 61430 //
     /*  408459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  408470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  408473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408491 */     // MIs[0] policy
     /*  408491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  408504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408518 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408520 */     GIR_RootConstrainSelectedInstOperands,
     /*  408521 */     // GIR_Coverage, 61430,
     /*  408521 */     GIR_EraseRootFromParent_Done,
     /*  408522 */   // Label 7205: @408522
     /*  408522 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(408590), // Rule ID 61431 //
     /*  408527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  408538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  408541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408559 */     // MIs[0] policy
     /*  408559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408569 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  408572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408586 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408588 */     GIR_RootConstrainSelectedInstOperands,
     /*  408589 */     // GIR_Coverage, 61431,
     /*  408589 */     GIR_EraseRootFromParent_Done,
     /*  408590 */   // Label 7206: @408590
     /*  408590 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(408658), // Rule ID 61432 //
     /*  408595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408627 */     // MIs[0] policy
     /*  408627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  408640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408654 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408656 */     GIR_RootConstrainSelectedInstOperands,
     /*  408657 */     // GIR_Coverage, 61432,
     /*  408657 */     GIR_EraseRootFromParent_Done,
     /*  408658 */   // Label 7207: @408658
     /*  408658 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(408726), // Rule ID 61433 //
     /*  408663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408695 */     // MIs[0] policy
     /*  408695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  408708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408722 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408724 */     GIR_RootConstrainSelectedInstOperands,
     /*  408725 */     // GIR_Coverage, 61433,
     /*  408725 */     GIR_EraseRootFromParent_Done,
     /*  408726 */   // Label 7208: @408726
     /*  408726 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(408794), // Rule ID 61434 //
     /*  408731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408763 */     // MIs[0] policy
     /*  408763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  408776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408790 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408792 */     GIR_RootConstrainSelectedInstOperands,
     /*  408793 */     // GIR_Coverage, 61434,
     /*  408793 */     GIR_EraseRootFromParent_Done,
     /*  408794 */   // Label 7209: @408794
     /*  408794 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(408862), // Rule ID 61435 //
     /*  408799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408831 */     // MIs[0] policy
     /*  408831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  408844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408858 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408860 */     GIR_RootConstrainSelectedInstOperands,
     /*  408861 */     // GIR_Coverage, 61435,
     /*  408861 */     GIR_EraseRootFromParent_Done,
     /*  408862 */   // Label 7210: @408862
     /*  408862 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(408930), // Rule ID 61436 //
     /*  408867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  408870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  408887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408899 */     // MIs[0] policy
     /*  408899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  408909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  408912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408926 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408928 */     GIR_RootConstrainSelectedInstOperands,
     /*  408929 */     // GIR_Coverage, 61436,
     /*  408929 */     GIR_EraseRootFromParent_Done,
     /*  408930 */   // Label 7211: @408930
     /*  408930 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(408998), // Rule ID 61437 //
     /*  408935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  408938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  408943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  408955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408967 */     // MIs[0] policy
     /*  408967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  408970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  408977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  408980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  408982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  408984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408994 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  408996 */     GIR_RootConstrainSelectedInstOperands,
     /*  408997 */     // GIR_Coverage, 61437,
     /*  408997 */     GIR_EraseRootFromParent_Done,
     /*  408998 */   // Label 7212: @408998
     /*  408998 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(409066), // Rule ID 61438 //
     /*  409003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409035 */     // MIs[0] policy
     /*  409035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409045 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  409048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409062 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409064 */     GIR_RootConstrainSelectedInstOperands,
     /*  409065 */     // GIR_Coverage, 61438,
     /*  409065 */     GIR_EraseRootFromParent_Done,
     /*  409066 */   // Label 7213: @409066
     /*  409066 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(409134), // Rule ID 61439 //
     /*  409071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409103 */     // MIs[0] policy
     /*  409103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409113 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  409116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409130 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409132 */     GIR_RootConstrainSelectedInstOperands,
     /*  409133 */     // GIR_Coverage, 61439,
     /*  409133 */     GIR_EraseRootFromParent_Done,
     /*  409134 */   // Label 7214: @409134
     /*  409134 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(409202), // Rule ID 61440 //
     /*  409139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409171 */     // MIs[0] policy
     /*  409171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  409184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409198 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409200 */     GIR_RootConstrainSelectedInstOperands,
     /*  409201 */     // GIR_Coverage, 61440,
     /*  409201 */     GIR_EraseRootFromParent_Done,
     /*  409202 */   // Label 7215: @409202
     /*  409202 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(409270), // Rule ID 61441 //
     /*  409207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409239 */     // MIs[0] policy
     /*  409239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409249 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  409252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409266 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409268 */     GIR_RootConstrainSelectedInstOperands,
     /*  409269 */     // GIR_Coverage, 61441,
     /*  409269 */     GIR_EraseRootFromParent_Done,
     /*  409270 */   // Label 7216: @409270
     /*  409270 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(409338), // Rule ID 61442 //
     /*  409275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409307 */     // MIs[0] policy
     /*  409307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  409320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409334 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409336 */     GIR_RootConstrainSelectedInstOperands,
     /*  409337 */     // GIR_Coverage, 61442,
     /*  409337 */     GIR_EraseRootFromParent_Done,
     /*  409338 */   // Label 7217: @409338
     /*  409338 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(409406), // Rule ID 61443 //
     /*  409343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409375 */     // MIs[0] policy
     /*  409375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409385 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  409388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409402 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409404 */     GIR_RootConstrainSelectedInstOperands,
     /*  409405 */     // GIR_Coverage, 61443,
     /*  409405 */     GIR_EraseRootFromParent_Done,
     /*  409406 */   // Label 7218: @409406
     /*  409406 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(409474), // Rule ID 61444 //
     /*  409411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409443 */     // MIs[0] policy
     /*  409443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409453 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  409456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409470 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409472 */     GIR_RootConstrainSelectedInstOperands,
     /*  409473 */     // GIR_Coverage, 61444,
     /*  409473 */     GIR_EraseRootFromParent_Done,
     /*  409474 */   // Label 7219: @409474
     /*  409474 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(409542), // Rule ID 61445 //
     /*  409479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409511 */     // MIs[0] policy
     /*  409511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  409524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409538 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409540 */     GIR_RootConstrainSelectedInstOperands,
     /*  409541 */     // GIR_Coverage, 61445,
     /*  409541 */     GIR_EraseRootFromParent_Done,
     /*  409542 */   // Label 7220: @409542
     /*  409542 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(409610), // Rule ID 61446 //
     /*  409547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409579 */     // MIs[0] policy
     /*  409579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409589 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  409592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409606 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409608 */     GIR_RootConstrainSelectedInstOperands,
     /*  409609 */     // GIR_Coverage, 61446,
     /*  409609 */     GIR_EraseRootFromParent_Done,
     /*  409610 */   // Label 7221: @409610
     /*  409610 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(409678), // Rule ID 61447 //
     /*  409615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409647 */     // MIs[0] policy
     /*  409647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409657 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  409660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409674 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409676 */     GIR_RootConstrainSelectedInstOperands,
     /*  409677 */     // GIR_Coverage, 61447,
     /*  409677 */     GIR_EraseRootFromParent_Done,
     /*  409678 */   // Label 7222: @409678
     /*  409678 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(409746), // Rule ID 61448 //
     /*  409683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409715 */     // MIs[0] policy
     /*  409715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  409728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409742 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409744 */     GIR_RootConstrainSelectedInstOperands,
     /*  409745 */     // GIR_Coverage, 61448,
     /*  409745 */     GIR_EraseRootFromParent_Done,
     /*  409746 */   // Label 7223: @409746
     /*  409746 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(409814), // Rule ID 61449 //
     /*  409751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409783 */     // MIs[0] policy
     /*  409783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  409796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409810 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409812 */     GIR_RootConstrainSelectedInstOperands,
     /*  409813 */     // GIR_Coverage, 61449,
     /*  409813 */     GIR_EraseRootFromParent_Done,
     /*  409814 */   // Label 7224: @409814
     /*  409814 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(409882), // Rule ID 61450 //
     /*  409819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409851 */     // MIs[0] policy
     /*  409851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  409864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409878 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409880 */     GIR_RootConstrainSelectedInstOperands,
     /*  409881 */     // GIR_Coverage, 61450,
     /*  409881 */     GIR_EraseRootFromParent_Done,
     /*  409882 */   // Label 7225: @409882
     /*  409882 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(409950), // Rule ID 61451 //
     /*  409887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  409890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  409907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409919 */     // MIs[0] policy
     /*  409919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409929 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  409929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  409932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  409934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  409936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409946 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  409948 */     GIR_RootConstrainSelectedInstOperands,
     /*  409949 */     // GIR_Coverage, 61451,
     /*  409949 */     GIR_EraseRootFromParent_Done,
     /*  409950 */   // Label 7226: @409950
     /*  409950 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(410018), // Rule ID 61452 //
     /*  409955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  409958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  409963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  409975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409987 */     // MIs[0] policy
     /*  409987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  409990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409997 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  409997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  410000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410014 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410016 */     GIR_RootConstrainSelectedInstOperands,
     /*  410017 */     // GIR_Coverage, 61452,
     /*  410017 */     GIR_EraseRootFromParent_Done,
     /*  410018 */   // Label 7227: @410018
     /*  410018 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(410086), // Rule ID 61453 //
     /*  410023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  410031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  410034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  410037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410055 */     // MIs[0] policy
     /*  410055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10838:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  410068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410082 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410084 */     GIR_RootConstrainSelectedInstOperands,
     /*  410085 */     // GIR_Coverage, 61453,
     /*  410085 */     GIR_EraseRootFromParent_Done,
     /*  410086 */   // Label 7228: @410086
     /*  410086 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(410154), // Rule ID 61454 //
     /*  410091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410123 */     // MIs[0] policy
     /*  410123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  410136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410150 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410152 */     GIR_RootConstrainSelectedInstOperands,
     /*  410153 */     // GIR_Coverage, 61454,
     /*  410153 */     GIR_EraseRootFromParent_Done,
     /*  410154 */   // Label 7229: @410154
     /*  410154 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(410222), // Rule ID 61455 //
     /*  410159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410191 */     // MIs[0] policy
     /*  410191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410201 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  410204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410218 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410220 */     GIR_RootConstrainSelectedInstOperands,
     /*  410221 */     // GIR_Coverage, 61455,
     /*  410221 */     GIR_EraseRootFromParent_Done,
     /*  410222 */   // Label 7230: @410222
     /*  410222 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(410290), // Rule ID 61456 //
     /*  410227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  410244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410259 */     // MIs[0] policy
     /*  410259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410269 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  410272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410286 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410288 */     GIR_RootConstrainSelectedInstOperands,
     /*  410289 */     // GIR_Coverage, 61456,
     /*  410289 */     GIR_EraseRootFromParent_Done,
     /*  410290 */   // Label 7231: @410290
     /*  410290 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(410358), // Rule ID 61457 //
     /*  410295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  410312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410327 */     // MIs[0] policy
     /*  410327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  410340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410354 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410356 */     GIR_RootConstrainSelectedInstOperands,
     /*  410357 */     // GIR_Coverage, 61457,
     /*  410357 */     GIR_EraseRootFromParent_Done,
     /*  410358 */   // Label 7232: @410358
     /*  410358 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(410426), // Rule ID 61458 //
     /*  410363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410395 */     // MIs[0] policy
     /*  410395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  410408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410422 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410424 */     GIR_RootConstrainSelectedInstOperands,
     /*  410425 */     // GIR_Coverage, 61458,
     /*  410425 */     GIR_EraseRootFromParent_Done,
     /*  410426 */   // Label 7233: @410426
     /*  410426 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(410494), // Rule ID 61459 //
     /*  410431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410463 */     // MIs[0] policy
     /*  410463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410473 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  410476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410490 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410492 */     GIR_RootConstrainSelectedInstOperands,
     /*  410493 */     // GIR_Coverage, 61459,
     /*  410493 */     GIR_EraseRootFromParent_Done,
     /*  410494 */   // Label 7234: @410494
     /*  410494 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(410562), // Rule ID 61460 //
     /*  410499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410531 */     // MIs[0] policy
     /*  410531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410541 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  410544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410558 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410560 */     GIR_RootConstrainSelectedInstOperands,
     /*  410561 */     // GIR_Coverage, 61460,
     /*  410561 */     GIR_EraseRootFromParent_Done,
     /*  410562 */   // Label 7235: @410562
     /*  410562 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(410630), // Rule ID 61461 //
     /*  410567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410599 */     // MIs[0] policy
     /*  410599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  410612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410626 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410628 */     GIR_RootConstrainSelectedInstOperands,
     /*  410629 */     // GIR_Coverage, 61461,
     /*  410629 */     GIR_EraseRootFromParent_Done,
     /*  410630 */   // Label 7236: @410630
     /*  410630 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(410698), // Rule ID 61462 //
     /*  410635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  410646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  410649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  410652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410667 */     // MIs[0] policy
     /*  410667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10841:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  410680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410694 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410696 */     GIR_RootConstrainSelectedInstOperands,
     /*  410697 */     // GIR_Coverage, 61462,
     /*  410697 */     GIR_EraseRootFromParent_Done,
     /*  410698 */   // Label 7237: @410698
     /*  410698 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(410766), // Rule ID 61463 //
     /*  410703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  410711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  410714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  410717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  410720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410735 */     // MIs[0] policy
     /*  410735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10841:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  410748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410762 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410764 */     GIR_RootConstrainSelectedInstOperands,
     /*  410765 */     // GIR_Coverage, 61463,
     /*  410765 */     GIR_EraseRootFromParent_Done,
     /*  410766 */   // Label 7238: @410766
     /*  410766 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(410834), // Rule ID 61464 //
     /*  410771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  410779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410803 */     // MIs[0] policy
     /*  410803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410813 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  410816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410830 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410832 */     GIR_RootConstrainSelectedInstOperands,
     /*  410833 */     // GIR_Coverage, 61464,
     /*  410833 */     GIR_EraseRootFromParent_Done,
     /*  410834 */   // Label 7239: @410834
     /*  410834 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(410902), // Rule ID 61465 //
     /*  410839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  410847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410871 */     // MIs[0] policy
     /*  410871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410881 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  410881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  410884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410898 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410900 */     GIR_RootConstrainSelectedInstOperands,
     /*  410901 */     // GIR_Coverage, 61465,
     /*  410901 */     GIR_EraseRootFromParent_Done,
     /*  410902 */   // Label 7240: @410902
     /*  410902 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(410970), // Rule ID 61466 //
     /*  410907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  410910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  410915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  410927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410939 */     // MIs[0] policy
     /*  410939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  410942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410949 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  410949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  410952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  410954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  410956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410966 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  410968 */     GIR_RootConstrainSelectedInstOperands,
     /*  410969 */     // GIR_Coverage, 61466,
     /*  410969 */     GIR_EraseRootFromParent_Done,
     /*  410970 */   // Label 7241: @410970
     /*  410970 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(411038), // Rule ID 61467 //
     /*  410975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  410978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  410983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  410995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411007 */     // MIs[0] policy
     /*  411007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  411020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411034 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411036 */     GIR_RootConstrainSelectedInstOperands,
     /*  411037 */     // GIR_Coverage, 61467,
     /*  411037 */     GIR_EraseRootFromParent_Done,
     /*  411038 */   // Label 7242: @411038
     /*  411038 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(411106), // Rule ID 61468 //
     /*  411043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  411054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  411057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411075 */     // MIs[0] policy
     /*  411075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411085 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  411088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411102 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411104 */     GIR_RootConstrainSelectedInstOperands,
     /*  411105 */     // GIR_Coverage, 61468,
     /*  411105 */     GIR_EraseRootFromParent_Done,
     /*  411106 */   // Label 7243: @411106
     /*  411106 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(411174), // Rule ID 61469 //
     /*  411111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  411122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  411125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411143 */     // MIs[0] policy
     /*  411143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  411156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411170 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411172 */     GIR_RootConstrainSelectedInstOperands,
     /*  411173 */     // GIR_Coverage, 61469,
     /*  411173 */     GIR_EraseRootFromParent_Done,
     /*  411174 */   // Label 7244: @411174
     /*  411174 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(411242), // Rule ID 61470 //
     /*  411179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411211 */     // MIs[0] policy
     /*  411211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  411224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411238 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411240 */     GIR_RootConstrainSelectedInstOperands,
     /*  411241 */     // GIR_Coverage, 61470,
     /*  411241 */     GIR_EraseRootFromParent_Done,
     /*  411242 */   // Label 7245: @411242
     /*  411242 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(411310), // Rule ID 61471 //
     /*  411247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411279 */     // MIs[0] policy
     /*  411279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  411292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411306 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411308 */     GIR_RootConstrainSelectedInstOperands,
     /*  411309 */     // GIR_Coverage, 61471,
     /*  411309 */     GIR_EraseRootFromParent_Done,
     /*  411310 */   // Label 7246: @411310
     /*  411310 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(411378), // Rule ID 61472 //
     /*  411315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411347 */     // MIs[0] policy
     /*  411347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  411360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411374 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411376 */     GIR_RootConstrainSelectedInstOperands,
     /*  411377 */     // GIR_Coverage, 61472,
     /*  411377 */     GIR_EraseRootFromParent_Done,
     /*  411378 */   // Label 7247: @411378
     /*  411378 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(411446), // Rule ID 61473 //
     /*  411383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411415 */     // MIs[0] policy
     /*  411415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  411428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411442 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411444 */     GIR_RootConstrainSelectedInstOperands,
     /*  411445 */     // GIR_Coverage, 61473,
     /*  411445 */     GIR_EraseRootFromParent_Done,
     /*  411446 */   // Label 7248: @411446
     /*  411446 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(411514), // Rule ID 61474 //
     /*  411451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411483 */     // MIs[0] policy
     /*  411483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  411496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411510 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411512 */     GIR_RootConstrainSelectedInstOperands,
     /*  411513 */     // GIR_Coverage, 61474,
     /*  411513 */     GIR_EraseRootFromParent_Done,
     /*  411514 */   // Label 7249: @411514
     /*  411514 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(411582), // Rule ID 61475 //
     /*  411519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411551 */     // MIs[0] policy
     /*  411551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  411564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411578 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411580 */     GIR_RootConstrainSelectedInstOperands,
     /*  411581 */     // GIR_Coverage, 61475,
     /*  411581 */     GIR_EraseRootFromParent_Done,
     /*  411582 */   // Label 7250: @411582
     /*  411582 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(411650), // Rule ID 61476 //
     /*  411587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411619 */     // MIs[0] policy
     /*  411619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  411632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411646 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411648 */     GIR_RootConstrainSelectedInstOperands,
     /*  411649 */     // GIR_Coverage, 61476,
     /*  411649 */     GIR_EraseRootFromParent_Done,
     /*  411650 */   // Label 7251: @411650
     /*  411650 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(411718), // Rule ID 61477 //
     /*  411655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411687 */     // MIs[0] policy
     /*  411687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411697 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  411700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411714 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411716 */     GIR_RootConstrainSelectedInstOperands,
     /*  411717 */     // GIR_Coverage, 61477,
     /*  411717 */     GIR_EraseRootFromParent_Done,
     /*  411718 */   // Label 7252: @411718
     /*  411718 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(411786), // Rule ID 61478 //
     /*  411723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411755 */     // MIs[0] policy
     /*  411755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411765 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  411768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411782 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411784 */     GIR_RootConstrainSelectedInstOperands,
     /*  411785 */     // GIR_Coverage, 61478,
     /*  411785 */     GIR_EraseRootFromParent_Done,
     /*  411786 */   // Label 7253: @411786
     /*  411786 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(411854), // Rule ID 61479 //
     /*  411791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411823 */     // MIs[0] policy
     /*  411823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  411836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411850 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411852 */     GIR_RootConstrainSelectedInstOperands,
     /*  411853 */     // GIR_Coverage, 61479,
     /*  411853 */     GIR_EraseRootFromParent_Done,
     /*  411854 */   // Label 7254: @411854
     /*  411854 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(411922), // Rule ID 61480 //
     /*  411859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  411879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411891 */     // MIs[0] policy
     /*  411891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411901 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  411901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  411904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411918 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411920 */     GIR_RootConstrainSelectedInstOperands,
     /*  411921 */     // GIR_Coverage, 61480,
     /*  411921 */     GIR_EraseRootFromParent_Done,
     /*  411922 */   // Label 7255: @411922
     /*  411922 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(411990), // Rule ID 61481 //
     /*  411927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  411930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  411935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  411947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411959 */     // MIs[0] policy
     /*  411959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  411962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  411969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  411972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  411974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  411976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411986 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  411988 */     GIR_RootConstrainSelectedInstOperands,
     /*  411989 */     // GIR_Coverage, 61481,
     /*  411989 */     GIR_EraseRootFromParent_Done,
     /*  411990 */   // Label 7256: @411990
     /*  411990 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(412058), // Rule ID 61482 //
     /*  411995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  411998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412027 */     // MIs[0] policy
     /*  412027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412037 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  412040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412054 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412056 */     GIR_RootConstrainSelectedInstOperands,
     /*  412057 */     // GIR_Coverage, 61482,
     /*  412057 */     GIR_EraseRootFromParent_Done,
     /*  412058 */   // Label 7257: @412058
     /*  412058 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(412126), // Rule ID 61483 //
     /*  412063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412095 */     // MIs[0] policy
     /*  412095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412105 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  412108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412122 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412124 */     GIR_RootConstrainSelectedInstOperands,
     /*  412125 */     // GIR_Coverage, 61483,
     /*  412125 */     GIR_EraseRootFromParent_Done,
     /*  412126 */   // Label 7258: @412126
     /*  412126 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(412194), // Rule ID 61484 //
     /*  412131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412163 */     // MIs[0] policy
     /*  412163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412173 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  412176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412190 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412192 */     GIR_RootConstrainSelectedInstOperands,
     /*  412193 */     // GIR_Coverage, 61484,
     /*  412193 */     GIR_EraseRootFromParent_Done,
     /*  412194 */   // Label 7259: @412194
     /*  412194 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(412262), // Rule ID 61485 //
     /*  412199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412231 */     // MIs[0] policy
     /*  412231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412241 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  412244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412258 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412260 */     GIR_RootConstrainSelectedInstOperands,
     /*  412261 */     // GIR_Coverage, 61485,
     /*  412261 */     GIR_EraseRootFromParent_Done,
     /*  412262 */   // Label 7260: @412262
     /*  412262 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(412330), // Rule ID 61486 //
     /*  412267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412299 */     // MIs[0] policy
     /*  412299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412309 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  412312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412326 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412328 */     GIR_RootConstrainSelectedInstOperands,
     /*  412329 */     // GIR_Coverage, 61486,
     /*  412329 */     GIR_EraseRootFromParent_Done,
     /*  412330 */   // Label 7261: @412330
     /*  412330 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(412398), // Rule ID 61487 //
     /*  412335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412367 */     // MIs[0] policy
     /*  412367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  412380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412394 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412396 */     GIR_RootConstrainSelectedInstOperands,
     /*  412397 */     // GIR_Coverage, 61487,
     /*  412397 */     GIR_EraseRootFromParent_Done,
     /*  412398 */   // Label 7262: @412398
     /*  412398 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(412466), // Rule ID 61488 //
     /*  412403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412435 */     // MIs[0] policy
     /*  412435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412445 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  412448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412462 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412464 */     GIR_RootConstrainSelectedInstOperands,
     /*  412465 */     // GIR_Coverage, 61488,
     /*  412465 */     GIR_EraseRootFromParent_Done,
     /*  412466 */   // Label 7263: @412466
     /*  412466 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(412534), // Rule ID 61489 //
     /*  412471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412503 */     // MIs[0] policy
     /*  412503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412513 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  412516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412530 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412532 */     GIR_RootConstrainSelectedInstOperands,
     /*  412533 */     // GIR_Coverage, 61489,
     /*  412533 */     GIR_EraseRootFromParent_Done,
     /*  412534 */   // Label 7264: @412534
     /*  412534 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(412602), // Rule ID 61490 //
     /*  412539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412571 */     // MIs[0] policy
     /*  412571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  412584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412598 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412600 */     GIR_RootConstrainSelectedInstOperands,
     /*  412601 */     // GIR_Coverage, 61490,
     /*  412601 */     GIR_EraseRootFromParent_Done,
     /*  412602 */   // Label 7265: @412602
     /*  412602 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(412670), // Rule ID 61491 //
     /*  412607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  412615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  412618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  412621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412639 */     // MIs[0] policy
     /*  412639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412649 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10840:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  412652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412666 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412668 */     GIR_RootConstrainSelectedInstOperands,
     /*  412669 */     // GIR_Coverage, 61491,
     /*  412669 */     GIR_EraseRootFromParent_Done,
     /*  412670 */   // Label 7266: @412670
     /*  412670 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(412738), // Rule ID 61492 //
     /*  412675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  412683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412707 */     // MIs[0] policy
     /*  412707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412717 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  412720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412734 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412736 */     GIR_RootConstrainSelectedInstOperands,
     /*  412737 */     // GIR_Coverage, 61492,
     /*  412737 */     GIR_EraseRootFromParent_Done,
     /*  412738 */   // Label 7267: @412738
     /*  412738 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(412806), // Rule ID 61493 //
     /*  412743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  412751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412775 */     // MIs[0] policy
     /*  412775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412785 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  412788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412802 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412804 */     GIR_RootConstrainSelectedInstOperands,
     /*  412805 */     // GIR_Coverage, 61493,
     /*  412805 */     GIR_EraseRootFromParent_Done,
     /*  412806 */   // Label 7268: @412806
     /*  412806 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(412874), // Rule ID 61494 //
     /*  412811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  412819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412843 */     // MIs[0] policy
     /*  412843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412853 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  412856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412870 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412872 */     GIR_RootConstrainSelectedInstOperands,
     /*  412873 */     // GIR_Coverage, 61494,
     /*  412873 */     GIR_EraseRootFromParent_Done,
     /*  412874 */   // Label 7269: @412874
     /*  412874 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(412942), // Rule ID 61495 //
     /*  412879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  412882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  412887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412911 */     // MIs[0] policy
     /*  412911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412921 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  412921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  412924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412938 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  412940 */     GIR_RootConstrainSelectedInstOperands,
     /*  412941 */     // GIR_Coverage, 61495,
     /*  412941 */     GIR_EraseRootFromParent_Done,
     /*  412942 */   // Label 7270: @412942
     /*  412942 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(413010), // Rule ID 61496 //
     /*  412947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  412950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  412955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412979 */     // MIs[0] policy
     /*  412979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  412982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  412989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  412992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  412994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  412996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413006 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413008 */     GIR_RootConstrainSelectedInstOperands,
     /*  413009 */     // GIR_Coverage, 61496,
     /*  413009 */     GIR_EraseRootFromParent_Done,
     /*  413010 */   // Label 7271: @413010
     /*  413010 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(413078), // Rule ID 61497 //
     /*  413015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  413023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  413032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413047 */     // MIs[0] policy
     /*  413047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  413060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413074 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413076 */     GIR_RootConstrainSelectedInstOperands,
     /*  413077 */     // GIR_Coverage, 61497,
     /*  413077 */     GIR_EraseRootFromParent_Done,
     /*  413078 */   // Label 7272: @413078
     /*  413078 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(413146), // Rule ID 61498 //
     /*  413083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  413091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413115 */     // MIs[0] policy
     /*  413115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413125 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  413128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413142 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413144 */     GIR_RootConstrainSelectedInstOperands,
     /*  413145 */     // GIR_Coverage, 61498,
     /*  413145 */     GIR_EraseRootFromParent_Done,
     /*  413146 */   // Label 7273: @413146
     /*  413146 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(413214), // Rule ID 61499 //
     /*  413151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  413159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413183 */     // MIs[0] policy
     /*  413183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  413196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413210 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413212 */     GIR_RootConstrainSelectedInstOperands,
     /*  413213 */     // GIR_Coverage, 61499,
     /*  413213 */     GIR_EraseRootFromParent_Done,
     /*  413214 */   // Label 7274: @413214
     /*  413214 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(413282), // Rule ID 61500 //
     /*  413219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  413227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  413230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  413233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413251 */     // MIs[0] policy
     /*  413251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10843:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  413264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413278 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413280 */     GIR_RootConstrainSelectedInstOperands,
     /*  413281 */     // GIR_Coverage, 61500,
     /*  413281 */     GIR_EraseRootFromParent_Done,
     /*  413282 */   // Label 7275: @413282
     /*  413282 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(413350), // Rule ID 61501 //
     /*  413287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  413295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  413298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  413301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413319 */     // MIs[0] policy
     /*  413319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413329 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10843:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  413332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413346 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413348 */     GIR_RootConstrainSelectedInstOperands,
     /*  413349 */     // GIR_Coverage, 61501,
     /*  413349 */     GIR_EraseRootFromParent_Done,
     /*  413350 */   // Label 7276: @413350
     /*  413350 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(413418), // Rule ID 61502 //
     /*  413355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413387 */     // MIs[0] policy
     /*  413387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413397 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  413400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413414 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413416 */     GIR_RootConstrainSelectedInstOperands,
     /*  413417 */     // GIR_Coverage, 61502,
     /*  413417 */     GIR_EraseRootFromParent_Done,
     /*  413418 */   // Label 7277: @413418
     /*  413418 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(413486), // Rule ID 61503 //
     /*  413423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413455 */     // MIs[0] policy
     /*  413455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  413468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413482 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413484 */     GIR_RootConstrainSelectedInstOperands,
     /*  413485 */     // GIR_Coverage, 61503,
     /*  413485 */     GIR_EraseRootFromParent_Done,
     /*  413486 */   // Label 7278: @413486
     /*  413486 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(413554), // Rule ID 61504 //
     /*  413491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413523 */     // MIs[0] policy
     /*  413523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  413536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413550 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413552 */     GIR_RootConstrainSelectedInstOperands,
     /*  413553 */     // GIR_Coverage, 61504,
     /*  413553 */     GIR_EraseRootFromParent_Done,
     /*  413554 */   // Label 7279: @413554
     /*  413554 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(413622), // Rule ID 61505 //
     /*  413559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413591 */     // MIs[0] policy
     /*  413591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413601 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  413604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413618 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413620 */     GIR_RootConstrainSelectedInstOperands,
     /*  413621 */     // GIR_Coverage, 61505,
     /*  413621 */     GIR_EraseRootFromParent_Done,
     /*  413622 */   // Label 7280: @413622
     /*  413622 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(413690), // Rule ID 61506 //
     /*  413627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  413644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413659 */     // MIs[0] policy
     /*  413659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413669 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  413672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413686 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413688 */     GIR_RootConstrainSelectedInstOperands,
     /*  413689 */     // GIR_Coverage, 61506,
     /*  413689 */     GIR_EraseRootFromParent_Done,
     /*  413690 */   // Label 7281: @413690
     /*  413690 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(413758), // Rule ID 61507 //
     /*  413695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  413712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413727 */     // MIs[0] policy
     /*  413727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413737 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  413740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413754 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413756 */     GIR_RootConstrainSelectedInstOperands,
     /*  413757 */     // GIR_Coverage, 61507,
     /*  413757 */     GIR_EraseRootFromParent_Done,
     /*  413758 */   // Label 7282: @413758
     /*  413758 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(413826), // Rule ID 61508 //
     /*  413763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413795 */     // MIs[0] policy
     /*  413795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  413808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413822 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413824 */     GIR_RootConstrainSelectedInstOperands,
     /*  413825 */     // GIR_Coverage, 61508,
     /*  413825 */     GIR_EraseRootFromParent_Done,
     /*  413826 */   // Label 7283: @413826
     /*  413826 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(413894), // Rule ID 61509 //
     /*  413831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413863 */     // MIs[0] policy
     /*  413863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  413873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  413876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413890 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413892 */     GIR_RootConstrainSelectedInstOperands,
     /*  413893 */     // GIR_Coverage, 61509,
     /*  413893 */     GIR_EraseRootFromParent_Done,
     /*  413894 */   // Label 7284: @413894
     /*  413894 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(413962), // Rule ID 61510 //
     /*  413899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  413902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  413916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413931 */     // MIs[0] policy
     /*  413931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  413934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  413941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  413944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  413946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  413948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413958 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  413960 */     GIR_RootConstrainSelectedInstOperands,
     /*  413961 */     // GIR_Coverage, 61510,
     /*  413961 */     GIR_EraseRootFromParent_Done,
     /*  413962 */   // Label 7285: @413962
     /*  413962 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(414030), // Rule ID 61511 //
     /*  413967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  413970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  413975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  413984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413999 */     // MIs[0] policy
     /*  413999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  414012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414026 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414028 */     GIR_RootConstrainSelectedInstOperands,
     /*  414029 */     // GIR_Coverage, 61511,
     /*  414029 */     GIR_EraseRootFromParent_Done,
     /*  414030 */   // Label 7286: @414030
     /*  414030 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(414098), // Rule ID 61512 //
     /*  414035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  414046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  414049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  414052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414067 */     // MIs[0] policy
     /*  414067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  414080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414094 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414096 */     GIR_RootConstrainSelectedInstOperands,
     /*  414097 */     // GIR_Coverage, 61512,
     /*  414097 */     GIR_EraseRootFromParent_Done,
     /*  414098 */   // Label 7287: @414098
     /*  414098 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(414166), // Rule ID 61513 //
     /*  414103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  414114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  414117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  414120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414135 */     // MIs[0] policy
     /*  414135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  414148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414162 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414164 */     GIR_RootConstrainSelectedInstOperands,
     /*  414165 */     // GIR_Coverage, 61513,
     /*  414165 */     GIR_EraseRootFromParent_Done,
     /*  414166 */   // Label 7288: @414166
     /*  414166 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(414234), // Rule ID 61514 //
     /*  414171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414203 */     // MIs[0] policy
     /*  414203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414213 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  414216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414230 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414232 */     GIR_RootConstrainSelectedInstOperands,
     /*  414233 */     // GIR_Coverage, 61514,
     /*  414233 */     GIR_EraseRootFromParent_Done,
     /*  414234 */   // Label 7289: @414234
     /*  414234 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(414302), // Rule ID 61515 //
     /*  414239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414271 */     // MIs[0] policy
     /*  414271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414281 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  414284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414298 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414300 */     GIR_RootConstrainSelectedInstOperands,
     /*  414301 */     // GIR_Coverage, 61515,
     /*  414301 */     GIR_EraseRootFromParent_Done,
     /*  414302 */   // Label 7290: @414302
     /*  414302 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(414370), // Rule ID 61516 //
     /*  414307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  414324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414339 */     // MIs[0] policy
     /*  414339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  414352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414366 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414368 */     GIR_RootConstrainSelectedInstOperands,
     /*  414369 */     // GIR_Coverage, 61516,
     /*  414369 */     GIR_EraseRootFromParent_Done,
     /*  414370 */   // Label 7291: @414370
     /*  414370 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(414438), // Rule ID 61517 //
     /*  414375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  414392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414407 */     // MIs[0] policy
     /*  414407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414417 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  414420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414434 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414436 */     GIR_RootConstrainSelectedInstOperands,
     /*  414437 */     // GIR_Coverage, 61517,
     /*  414437 */     GIR_EraseRootFromParent_Done,
     /*  414438 */   // Label 7292: @414438
     /*  414438 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(414506), // Rule ID 61518 //
     /*  414443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  414460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414475 */     // MIs[0] policy
     /*  414475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414485 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  414488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414502 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414504 */     GIR_RootConstrainSelectedInstOperands,
     /*  414505 */     // GIR_Coverage, 61518,
     /*  414505 */     GIR_EraseRootFromParent_Done,
     /*  414506 */   // Label 7293: @414506
     /*  414506 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(414574), // Rule ID 61519 //
     /*  414511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  414528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414543 */     // MIs[0] policy
     /*  414543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  414556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414570 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414572 */     GIR_RootConstrainSelectedInstOperands,
     /*  414573 */     // GIR_Coverage, 61519,
     /*  414573 */     GIR_EraseRootFromParent_Done,
     /*  414574 */   // Label 7294: @414574
     /*  414574 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(414642), // Rule ID 61520 //
     /*  414579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  414596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414611 */     // MIs[0] policy
     /*  414611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  414624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414638 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414640 */     GIR_RootConstrainSelectedInstOperands,
     /*  414641 */     // GIR_Coverage, 61520,
     /*  414641 */     GIR_EraseRootFromParent_Done,
     /*  414642 */   // Label 7295: @414642
     /*  414642 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(414710), // Rule ID 61521 //
     /*  414647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  414658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  414661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  414664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414679 */     // MIs[0] policy
     /*  414679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  414692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414706 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414708 */     GIR_RootConstrainSelectedInstOperands,
     /*  414709 */     // GIR_Coverage, 61521,
     /*  414709 */     GIR_EraseRootFromParent_Done,
     /*  414710 */   // Label 7296: @414710
     /*  414710 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(414778), // Rule ID 61522 //
     /*  414715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  414726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  414729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414747 */     // MIs[0] policy
     /*  414747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414757 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  414760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414774 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414776 */     GIR_RootConstrainSelectedInstOperands,
     /*  414777 */     // GIR_Coverage, 61522,
     /*  414777 */     GIR_EraseRootFromParent_Done,
     /*  414778 */   // Label 7297: @414778
     /*  414778 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(414846), // Rule ID 61523 //
     /*  414783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  414794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  414797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414815 */     // MIs[0] policy
     /*  414815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414825 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  414828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414842 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414844 */     GIR_RootConstrainSelectedInstOperands,
     /*  414845 */     // GIR_Coverage, 61523,
     /*  414845 */     GIR_EraseRootFromParent_Done,
     /*  414846 */   // Label 7298: @414846
     /*  414846 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(414914), // Rule ID 61524 //
     /*  414851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  414862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  414865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  414868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414883 */     // MIs[0] policy
     /*  414883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  414893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  414896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414910 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414912 */     GIR_RootConstrainSelectedInstOperands,
     /*  414913 */     // GIR_Coverage, 61524,
     /*  414913 */     GIR_EraseRootFromParent_Done,
     /*  414914 */   // Label 7299: @414914
     /*  414914 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(414982), // Rule ID 61525 //
     /*  414919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  414922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  414930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  414933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  414936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414951 */     // MIs[0] policy
     /*  414951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  414954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  414961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  414964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  414966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  414968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414978 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  414980 */     GIR_RootConstrainSelectedInstOperands,
     /*  414981 */     // GIR_Coverage, 61525,
     /*  414981 */     GIR_EraseRootFromParent_Done,
     /*  414982 */   // Label 7300: @414982
     /*  414982 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(415050), // Rule ID 61526 //
     /*  414987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  414990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  414995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  414998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  415001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415019 */     // MIs[0] policy
     /*  415019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415029 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  415032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415046 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415048 */     GIR_RootConstrainSelectedInstOperands,
     /*  415049 */     // GIR_Coverage, 61526,
     /*  415049 */     GIR_EraseRootFromParent_Done,
     /*  415050 */   // Label 7301: @415050
     /*  415050 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(415118), // Rule ID 61527 //
     /*  415055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  415063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  415066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  415069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415087 */     // MIs[0] policy
     /*  415087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415097 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  415100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415114 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415116 */     GIR_RootConstrainSelectedInstOperands,
     /*  415117 */     // GIR_Coverage, 61527,
     /*  415117 */     GIR_EraseRootFromParent_Done,
     /*  415118 */   // Label 7302: @415118
     /*  415118 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(415186), // Rule ID 61528 //
     /*  415123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  415131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  415134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  415137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415155 */     // MIs[0] policy
     /*  415155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415165 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  415168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415182 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415184 */     GIR_RootConstrainSelectedInstOperands,
     /*  415185 */     // GIR_Coverage, 61528,
     /*  415185 */     GIR_EraseRootFromParent_Done,
     /*  415186 */   // Label 7303: @415186
     /*  415186 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(415254), // Rule ID 61529 //
     /*  415191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  415199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  415202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  415205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415223 */     // MIs[0] policy
     /*  415223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415233 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10842:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  415236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415250 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415252 */     GIR_RootConstrainSelectedInstOperands,
     /*  415253 */     // GIR_Coverage, 61529,
     /*  415253 */     GIR_EraseRootFromParent_Done,
     /*  415254 */   // Label 7304: @415254
     /*  415254 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(415322), // Rule ID 61546 //
     /*  415259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415291 */     // MIs[0] policy
     /*  415291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415301 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  415304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415318 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415320 */     GIR_RootConstrainSelectedInstOperands,
     /*  415321 */     // GIR_Coverage, 61546,
     /*  415321 */     GIR_EraseRootFromParent_Done,
     /*  415322 */   // Label 7305: @415322
     /*  415322 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(415390), // Rule ID 61547 //
     /*  415327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415359 */     // MIs[0] policy
     /*  415359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  415372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415386 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415388 */     GIR_RootConstrainSelectedInstOperands,
     /*  415389 */     // GIR_Coverage, 61547,
     /*  415389 */     GIR_EraseRootFromParent_Done,
     /*  415390 */   // Label 7306: @415390
     /*  415390 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(415458), // Rule ID 61548 //
     /*  415395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415427 */     // MIs[0] policy
     /*  415427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  415440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415454 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415456 */     GIR_RootConstrainSelectedInstOperands,
     /*  415457 */     // GIR_Coverage, 61548,
     /*  415457 */     GIR_EraseRootFromParent_Done,
     /*  415458 */   // Label 7307: @415458
     /*  415458 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(415526), // Rule ID 61549 //
     /*  415463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415495 */     // MIs[0] policy
     /*  415495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415505 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  415508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415522 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415524 */     GIR_RootConstrainSelectedInstOperands,
     /*  415525 */     // GIR_Coverage, 61549,
     /*  415525 */     GIR_EraseRootFromParent_Done,
     /*  415526 */   // Label 7308: @415526
     /*  415526 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(415594), // Rule ID 61550 //
     /*  415531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415563 */     // MIs[0] policy
     /*  415563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415573 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  415576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415590 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415592 */     GIR_RootConstrainSelectedInstOperands,
     /*  415593 */     // GIR_Coverage, 61550,
     /*  415593 */     GIR_EraseRootFromParent_Done,
     /*  415594 */   // Label 7309: @415594
     /*  415594 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(415662), // Rule ID 61551 //
     /*  415599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415631 */     // MIs[0] policy
     /*  415631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10846:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  415644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415658 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415660 */     GIR_RootConstrainSelectedInstOperands,
     /*  415661 */     // GIR_Coverage, 61551,
     /*  415661 */     GIR_EraseRootFromParent_Done,
     /*  415662 */   // Label 7310: @415662
     /*  415662 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(415730), // Rule ID 61552 //
     /*  415667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  415678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  415681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415699 */     // MIs[0] policy
     /*  415699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  415712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415726 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415728 */     GIR_RootConstrainSelectedInstOperands,
     /*  415729 */     // GIR_Coverage, 61552,
     /*  415729 */     GIR_EraseRootFromParent_Done,
     /*  415730 */   // Label 7311: @415730
     /*  415730 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(415798), // Rule ID 61553 //
     /*  415735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  415746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  415749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415767 */     // MIs[0] policy
     /*  415767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  415780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415794 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415796 */     GIR_RootConstrainSelectedInstOperands,
     /*  415797 */     // GIR_Coverage, 61553,
     /*  415797 */     GIR_EraseRootFromParent_Done,
     /*  415798 */   // Label 7312: @415798
     /*  415798 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(415866), // Rule ID 61554 //
     /*  415803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  415814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  415817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415835 */     // MIs[0] policy
     /*  415835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  415848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415862 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415864 */     GIR_RootConstrainSelectedInstOperands,
     /*  415865 */     // GIR_Coverage, 61554,
     /*  415865 */     GIR_EraseRootFromParent_Done,
     /*  415866 */   // Label 7313: @415866
     /*  415866 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(415934), // Rule ID 61555 //
     /*  415871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  415874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  415882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  415885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415903 */     // MIs[0] policy
     /*  415903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  415913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  415916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415930 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  415932 */     GIR_RootConstrainSelectedInstOperands,
     /*  415933 */     // GIR_Coverage, 61555,
     /*  415933 */     GIR_EraseRootFromParent_Done,
     /*  415934 */   // Label 7314: @415934
     /*  415934 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(416002), // Rule ID 61556 //
     /*  415939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  415942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  415947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  415950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  415953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415971 */     // MIs[0] policy
     /*  415971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  415974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  415981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  415984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  415986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  415988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415998 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416000 */     GIR_RootConstrainSelectedInstOperands,
     /*  416001 */     // GIR_Coverage, 61556,
     /*  416001 */     GIR_EraseRootFromParent_Done,
     /*  416002 */   // Label 7315: @416002
     /*  416002 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(416070), // Rule ID 61557 //
     /*  416007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  416018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  416021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  416024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416039 */     // MIs[0] policy
     /*  416039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10846:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  416052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416066 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416068 */     GIR_RootConstrainSelectedInstOperands,
     /*  416069 */     // GIR_Coverage, 61557,
     /*  416069 */     GIR_EraseRootFromParent_Done,
     /*  416070 */   // Label 7316: @416070
     /*  416070 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(416138), // Rule ID 61558 //
     /*  416075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  416092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416107 */     // MIs[0] policy
     /*  416107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416117 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  416120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416134 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416136 */     GIR_RootConstrainSelectedInstOperands,
     /*  416137 */     // GIR_Coverage, 61558,
     /*  416137 */     GIR_EraseRootFromParent_Done,
     /*  416138 */   // Label 7317: @416138
     /*  416138 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(416206), // Rule ID 61559 //
     /*  416143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  416160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416175 */     // MIs[0] policy
     /*  416175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  416188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416202 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416204 */     GIR_RootConstrainSelectedInstOperands,
     /*  416205 */     // GIR_Coverage, 61559,
     /*  416205 */     GIR_EraseRootFromParent_Done,
     /*  416206 */   // Label 7318: @416206
     /*  416206 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(416274), // Rule ID 61560 //
     /*  416211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416243 */     // MIs[0] policy
     /*  416243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416253 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  416256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416270 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416272 */     GIR_RootConstrainSelectedInstOperands,
     /*  416273 */     // GIR_Coverage, 61560,
     /*  416273 */     GIR_EraseRootFromParent_Done,
     /*  416274 */   // Label 7319: @416274
     /*  416274 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(416342), // Rule ID 61561 //
     /*  416279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416311 */     // MIs[0] policy
     /*  416311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  416324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416338 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416340 */     GIR_RootConstrainSelectedInstOperands,
     /*  416341 */     // GIR_Coverage, 61561,
     /*  416341 */     GIR_EraseRootFromParent_Done,
     /*  416342 */   // Label 7320: @416342
     /*  416342 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(416410), // Rule ID 61562 //
     /*  416347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  416364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416379 */     // MIs[0] policy
     /*  416379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  416392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416406 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416408 */     GIR_RootConstrainSelectedInstOperands,
     /*  416409 */     // GIR_Coverage, 61562,
     /*  416409 */     GIR_EraseRootFromParent_Done,
     /*  416410 */   // Label 7321: @416410
     /*  416410 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(416478), // Rule ID 61563 //
     /*  416415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  416432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416447 */     // MIs[0] policy
     /*  416447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416457 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  416460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416474 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416476 */     GIR_RootConstrainSelectedInstOperands,
     /*  416477 */     // GIR_Coverage, 61563,
     /*  416477 */     GIR_EraseRootFromParent_Done,
     /*  416478 */   // Label 7322: @416478
     /*  416478 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(416546), // Rule ID 61564 //
     /*  416483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  416500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416515 */     // MIs[0] policy
     /*  416515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416525 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  416528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416542 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416544 */     GIR_RootConstrainSelectedInstOperands,
     /*  416545 */     // GIR_Coverage, 61564,
     /*  416545 */     GIR_EraseRootFromParent_Done,
     /*  416546 */   // Label 7323: @416546
     /*  416546 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(416614), // Rule ID 61565 //
     /*  416551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  416568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416583 */     // MIs[0] policy
     /*  416583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10846:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  416596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416610 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416612 */     GIR_RootConstrainSelectedInstOperands,
     /*  416613 */     // GIR_Coverage, 61565,
     /*  416613 */     GIR_EraseRootFromParent_Done,
     /*  416614 */   // Label 7324: @416614
     /*  416614 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(416682), // Rule ID 61566 //
     /*  416619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  416636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416651 */     // MIs[0] policy
     /*  416651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416661 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  416664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416678 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416680 */     GIR_RootConstrainSelectedInstOperands,
     /*  416681 */     // GIR_Coverage, 61566,
     /*  416681 */     GIR_EraseRootFromParent_Done,
     /*  416682 */   // Label 7325: @416682
     /*  416682 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(416750), // Rule ID 61567 //
     /*  416687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  416704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416719 */     // MIs[0] policy
     /*  416719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  416732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416746 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416748 */     GIR_RootConstrainSelectedInstOperands,
     /*  416749 */     // GIR_Coverage, 61567,
     /*  416749 */     GIR_EraseRootFromParent_Done,
     /*  416750 */   // Label 7326: @416750
     /*  416750 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(416818), // Rule ID 61568 //
     /*  416755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416787 */     // MIs[0] policy
     /*  416787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  416800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416814 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416816 */     GIR_RootConstrainSelectedInstOperands,
     /*  416817 */     // GIR_Coverage, 61568,
     /*  416817 */     GIR_EraseRootFromParent_Done,
     /*  416818 */   // Label 7327: @416818
     /*  416818 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(416886), // Rule ID 61569 //
     /*  416823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416855 */     // MIs[0] policy
     /*  416855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  416865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  416868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416882 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416884 */     GIR_RootConstrainSelectedInstOperands,
     /*  416885 */     // GIR_Coverage, 61569,
     /*  416885 */     GIR_EraseRootFromParent_Done,
     /*  416886 */   // Label 7328: @416886
     /*  416886 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(416954), // Rule ID 61570 //
     /*  416891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  416894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  416908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416923 */     // MIs[0] policy
     /*  416923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416933 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  416933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  416936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  416938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  416940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416950 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  416952 */     GIR_RootConstrainSelectedInstOperands,
     /*  416953 */     // GIR_Coverage, 61570,
     /*  416953 */     GIR_EraseRootFromParent_Done,
     /*  416954 */   // Label 7329: @416954
     /*  416954 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(417022), // Rule ID 61571 //
     /*  416959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  416962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  416967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  416970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  416973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  416976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416991 */     // MIs[0] policy
     /*  416991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  416994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417001 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  417004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417018 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417020 */     GIR_RootConstrainSelectedInstOperands,
     /*  417021 */     // GIR_Coverage, 61571,
     /*  417021 */     GIR_EraseRootFromParent_Done,
     /*  417022 */   // Label 7330: @417022
     /*  417022 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(417090), // Rule ID 61572 //
     /*  417027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  417030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  417035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  417038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  417041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  417044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417059 */     // MIs[0] policy
     /*  417059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417069 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  417072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417086 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417088 */     GIR_RootConstrainSelectedInstOperands,
     /*  417089 */     // GIR_Coverage, 61572,
     /*  417089 */     GIR_EraseRootFromParent_Done,
     /*  417090 */   // Label 7331: @417090
     /*  417090 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(417158), // Rule ID 61573 //
     /*  417095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  417098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  417103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  417106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  417109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  417112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417127 */     // MIs[0] policy
     /*  417127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10846:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  417140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417154 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417156 */     GIR_RootConstrainSelectedInstOperands,
     /*  417157 */     // GIR_Coverage, 61573,
     /*  417157 */     GIR_EraseRootFromParent_Done,
     /*  417158 */   // Label 7332: @417158
     /*  417158 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(417226), // Rule ID 61668 //
     /*  417163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  417174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  417177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  417180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417195 */     // MIs[0] policy
     /*  417195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417205 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  417208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417222 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417224 */     GIR_RootConstrainSelectedInstOperands,
     /*  417225 */     // GIR_Coverage, 61668,
     /*  417225 */     GIR_EraseRootFromParent_Done,
     /*  417226 */   // Label 7333: @417226
     /*  417226 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(417294), // Rule ID 61669 //
     /*  417231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  417242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  417245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  417248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417263 */     // MIs[0] policy
     /*  417263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417273 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  417276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417290 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417292 */     GIR_RootConstrainSelectedInstOperands,
     /*  417293 */     // GIR_Coverage, 61669,
     /*  417293 */     GIR_EraseRootFromParent_Done,
     /*  417294 */   // Label 7334: @417294
     /*  417294 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(417362), // Rule ID 61670 //
     /*  417299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  417310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  417313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  417316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417331 */     // MIs[0] policy
     /*  417331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417341 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  417344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417358 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417360 */     GIR_RootConstrainSelectedInstOperands,
     /*  417361 */     // GIR_Coverage, 61670,
     /*  417361 */     GIR_EraseRootFromParent_Done,
     /*  417362 */   // Label 7335: @417362
     /*  417362 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(417430), // Rule ID 61671 //
     /*  417367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  417378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  417381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  417384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417399 */     // MIs[0] policy
     /*  417399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417409 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  417412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417426 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417428 */     GIR_RootConstrainSelectedInstOperands,
     /*  417429 */     // GIR_Coverage, 61671,
     /*  417429 */     GIR_EraseRootFromParent_Done,
     /*  417430 */   // Label 7336: @417430
     /*  417430 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(417498), // Rule ID 61672 //
     /*  417435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  417446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  417449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  417452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417467 */     // MIs[0] policy
     /*  417467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  417480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417494 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417496 */     GIR_RootConstrainSelectedInstOperands,
     /*  417497 */     // GIR_Coverage, 61672,
     /*  417497 */     GIR_EraseRootFromParent_Done,
     /*  417498 */   // Label 7337: @417498
     /*  417498 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(417566), // Rule ID 61673 //
     /*  417503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  417514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  417517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  417520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417535 */     // MIs[0] policy
     /*  417535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  417548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417562 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417564 */     GIR_RootConstrainSelectedInstOperands,
     /*  417565 */     // GIR_Coverage, 61673,
     /*  417565 */     GIR_EraseRootFromParent_Done,
     /*  417566 */   // Label 7338: @417566
     /*  417566 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(417634), // Rule ID 61674 //
     /*  417571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  417582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  417585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  417588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417603 */     // MIs[0] policy
     /*  417603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417613 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  417616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417630 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417632 */     GIR_RootConstrainSelectedInstOperands,
     /*  417633 */     // GIR_Coverage, 61674,
     /*  417633 */     GIR_EraseRootFromParent_Done,
     /*  417634 */   // Label 7339: @417634
     /*  417634 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(417702), // Rule ID 61675 //
     /*  417639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  417650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  417653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  417656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417671 */     // MIs[0] policy
     /*  417671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417681 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  417684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417698 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417700 */     GIR_RootConstrainSelectedInstOperands,
     /*  417701 */     // GIR_Coverage, 61675,
     /*  417701 */     GIR_EraseRootFromParent_Done,
     /*  417702 */   // Label 7340: @417702
     /*  417702 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(417770), // Rule ID 61676 //
     /*  417707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  417718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  417721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  417724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417739 */     // MIs[0] policy
     /*  417739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  417752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417766 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417768 */     GIR_RootConstrainSelectedInstOperands,
     /*  417769 */     // GIR_Coverage, 61676,
     /*  417769 */     GIR_EraseRootFromParent_Done,
     /*  417770 */   // Label 7341: @417770
     /*  417770 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(417838), // Rule ID 61677 //
     /*  417775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  417783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  417786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  417789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  417792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417807 */     // MIs[0] policy
     /*  417807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417817 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  417820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417834 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417836 */     GIR_RootConstrainSelectedInstOperands,
     /*  417837 */     // GIR_Coverage, 61677,
     /*  417837 */     GIR_EraseRootFromParent_Done,
     /*  417838 */   // Label 7342: @417838
     /*  417838 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(417906), // Rule ID 61678 //
     /*  417843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  417851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  417854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  417857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  417860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417875 */     // MIs[0] policy
     /*  417875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417885 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  417885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  417888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417902 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417904 */     GIR_RootConstrainSelectedInstOperands,
     /*  417905 */     // GIR_Coverage, 61678,
     /*  417905 */     GIR_EraseRootFromParent_Done,
     /*  417906 */   // Label 7343: @417906
     /*  417906 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(417974), // Rule ID 61679 //
     /*  417911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  417914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  417919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  417922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  417925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  417928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417943 */     // MIs[0] policy
     /*  417943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  417946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  417953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  417956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  417958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  417960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  417962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  417970 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  417972 */     GIR_RootConstrainSelectedInstOperands,
     /*  417973 */     // GIR_Coverage, 61679,
     /*  417973 */     GIR_EraseRootFromParent_Done,
     /*  417974 */   // Label 7344: @417974
     /*  417974 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(418042), // Rule ID 61680 //
     /*  417979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  417982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  417987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  417990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  417993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  417996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418011 */     // MIs[0] policy
     /*  418011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418021 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  418024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418038 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418040 */     GIR_RootConstrainSelectedInstOperands,
     /*  418041 */     // GIR_Coverage, 61680,
     /*  418041 */     GIR_EraseRootFromParent_Done,
     /*  418042 */   // Label 7345: @418042
     /*  418042 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(418110), // Rule ID 61681 //
     /*  418047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  418058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  418061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418079 */     // MIs[0] policy
     /*  418079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  418092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418106 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418108 */     GIR_RootConstrainSelectedInstOperands,
     /*  418109 */     // GIR_Coverage, 61681,
     /*  418109 */     GIR_EraseRootFromParent_Done,
     /*  418110 */   // Label 7346: @418110
     /*  418110 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(418178), // Rule ID 61682 //
     /*  418115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  418126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  418129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418147 */     // MIs[0] policy
     /*  418147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  418160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418174 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418176 */     GIR_RootConstrainSelectedInstOperands,
     /*  418177 */     // GIR_Coverage, 61682,
     /*  418177 */     GIR_EraseRootFromParent_Done,
     /*  418178 */   // Label 7347: @418178
     /*  418178 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(418246), // Rule ID 61683 //
     /*  418183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  418194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  418197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418215 */     // MIs[0] policy
     /*  418215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  418228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418242 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418244 */     GIR_RootConstrainSelectedInstOperands,
     /*  418245 */     // GIR_Coverage, 61683,
     /*  418245 */     GIR_EraseRootFromParent_Done,
     /*  418246 */   // Label 7348: @418246
     /*  418246 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(418314), // Rule ID 61684 //
     /*  418251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418283 */     // MIs[0] policy
     /*  418283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  418296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418310 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418312 */     GIR_RootConstrainSelectedInstOperands,
     /*  418313 */     // GIR_Coverage, 61684,
     /*  418313 */     GIR_EraseRootFromParent_Done,
     /*  418314 */   // Label 7349: @418314
     /*  418314 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(418382), // Rule ID 61685 //
     /*  418319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418351 */     // MIs[0] policy
     /*  418351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  418364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418378 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418380 */     GIR_RootConstrainSelectedInstOperands,
     /*  418381 */     // GIR_Coverage, 61685,
     /*  418381 */     GIR_EraseRootFromParent_Done,
     /*  418382 */   // Label 7350: @418382
     /*  418382 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(418450), // Rule ID 61686 //
     /*  418387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418419 */     // MIs[0] policy
     /*  418419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  418432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418446 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418448 */     GIR_RootConstrainSelectedInstOperands,
     /*  418449 */     // GIR_Coverage, 61686,
     /*  418449 */     GIR_EraseRootFromParent_Done,
     /*  418450 */   // Label 7351: @418450
     /*  418450 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(418518), // Rule ID 61687 //
     /*  418455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418487 */     // MIs[0] policy
     /*  418487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  418500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418514 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418516 */     GIR_RootConstrainSelectedInstOperands,
     /*  418517 */     // GIR_Coverage, 61687,
     /*  418517 */     GIR_EraseRootFromParent_Done,
     /*  418518 */   // Label 7352: @418518
     /*  418518 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(418586), // Rule ID 61688 //
     /*  418523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418555 */     // MIs[0] policy
     /*  418555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  418568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418582 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418584 */     GIR_RootConstrainSelectedInstOperands,
     /*  418585 */     // GIR_Coverage, 61688,
     /*  418585 */     GIR_EraseRootFromParent_Done,
     /*  418586 */   // Label 7353: @418586
     /*  418586 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(418654), // Rule ID 61689 //
     /*  418591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  418605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418623 */     // MIs[0] policy
     /*  418623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  418636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418650 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418652 */     GIR_RootConstrainSelectedInstOperands,
     /*  418653 */     // GIR_Coverage, 61689,
     /*  418653 */     GIR_EraseRootFromParent_Done,
     /*  418654 */   // Label 7354: @418654
     /*  418654 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(418722), // Rule ID 61690 //
     /*  418659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  418673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418691 */     // MIs[0] policy
     /*  418691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418701 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  418704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418718 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418720 */     GIR_RootConstrainSelectedInstOperands,
     /*  418721 */     // GIR_Coverage, 61690,
     /*  418721 */     GIR_EraseRootFromParent_Done,
     /*  418722 */   // Label 7355: @418722
     /*  418722 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(418790), // Rule ID 61691 //
     /*  418727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  418741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418759 */     // MIs[0] policy
     /*  418759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  418772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418786 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418788 */     GIR_RootConstrainSelectedInstOperands,
     /*  418789 */     // GIR_Coverage, 61691,
     /*  418789 */     GIR_EraseRootFromParent_Done,
     /*  418790 */   // Label 7356: @418790
     /*  418790 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(418858), // Rule ID 61692 //
     /*  418795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  418809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418827 */     // MIs[0] policy
     /*  418827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418837 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  418840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418854 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418856 */     GIR_RootConstrainSelectedInstOperands,
     /*  418857 */     // GIR_Coverage, 61692,
     /*  418857 */     GIR_EraseRootFromParent_Done,
     /*  418858 */   // Label 7357: @418858
     /*  418858 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(418926), // Rule ID 61693 //
     /*  418863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  418866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  418877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  418880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418895 */     // MIs[0] policy
     /*  418895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418905 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  418905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  418908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418922 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418924 */     GIR_RootConstrainSelectedInstOperands,
     /*  418925 */     // GIR_Coverage, 61693,
     /*  418925 */     GIR_EraseRootFromParent_Done,
     /*  418926 */   // Label 7358: @418926
     /*  418926 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(418994), // Rule ID 61694 //
     /*  418931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  418934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  418939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  418945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418963 */     // MIs[0] policy
     /*  418963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  418966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418973 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  418973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  418976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  418978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  418980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  418982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418990 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  418992 */     GIR_RootConstrainSelectedInstOperands,
     /*  418993 */     // GIR_Coverage, 61694,
     /*  418993 */     GIR_EraseRootFromParent_Done,
     /*  418994 */   // Label 7359: @418994
     /*  418994 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(419062), // Rule ID 61695 //
     /*  418999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  419013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419031 */     // MIs[0] policy
     /*  419031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  419044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419058 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419060 */     GIR_RootConstrainSelectedInstOperands,
     /*  419061 */     // GIR_Coverage, 61695,
     /*  419061 */     GIR_EraseRootFromParent_Done,
     /*  419062 */   // Label 7360: @419062
     /*  419062 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(419130), // Rule ID 61696 //
     /*  419067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  419070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  419081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419099 */     // MIs[0] policy
     /*  419099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  419109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  419112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419126 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419128 */     GIR_RootConstrainSelectedInstOperands,
     /*  419129 */     // GIR_Coverage, 61696,
     /*  419129 */     GIR_EraseRootFromParent_Done,
     /*  419130 */   // Label 7361: @419130
     /*  419130 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(419198), // Rule ID 61697 //
     /*  419135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  419149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419167 */     // MIs[0] policy
     /*  419167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  419180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419194 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419196 */     GIR_RootConstrainSelectedInstOperands,
     /*  419197 */     // GIR_Coverage, 61697,
     /*  419197 */     GIR_EraseRootFromParent_Done,
     /*  419198 */   // Label 7362: @419198
     /*  419198 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(419266), // Rule ID 61698 //
     /*  419203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  419206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  419220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419235 */     // MIs[0] policy
     /*  419235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  419245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  419248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419262 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419264 */     GIR_RootConstrainSelectedInstOperands,
     /*  419265 */     // GIR_Coverage, 61698,
     /*  419265 */     GIR_EraseRootFromParent_Done,
     /*  419266 */   // Label 7363: @419266
     /*  419266 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(419334), // Rule ID 61699 //
     /*  419271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  419288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419303 */     // MIs[0] policy
     /*  419303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419313 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  419316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419330 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419332 */     GIR_RootConstrainSelectedInstOperands,
     /*  419333 */     // GIR_Coverage, 61699,
     /*  419333 */     GIR_EraseRootFromParent_Done,
     /*  419334 */   // Label 7364: @419334
     /*  419334 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(419402), // Rule ID 61700 //
     /*  419339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  419342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419371 */     // MIs[0] policy
     /*  419371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  419381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  419384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419398 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419400 */     GIR_RootConstrainSelectedInstOperands,
     /*  419401 */     // GIR_Coverage, 61700,
     /*  419401 */     GIR_EraseRootFromParent_Done,
     /*  419402 */   // Label 7365: @419402
     /*  419402 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(419470), // Rule ID 61701 //
     /*  419407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419439 */     // MIs[0] policy
     /*  419439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419449 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  419452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419466 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419468 */     GIR_RootConstrainSelectedInstOperands,
     /*  419469 */     // GIR_Coverage, 61701,
     /*  419469 */     GIR_EraseRootFromParent_Done,
     /*  419470 */   // Label 7366: @419470
     /*  419470 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(419538), // Rule ID 61702 //
     /*  419475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  419478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419507 */     // MIs[0] policy
     /*  419507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419517 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  419517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  419520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419534 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419536 */     GIR_RootConstrainSelectedInstOperands,
     /*  419537 */     // GIR_Coverage, 61702,
     /*  419537 */     GIR_EraseRootFromParent_Done,
     /*  419538 */   // Label 7367: @419538
     /*  419538 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(419606), // Rule ID 61703 //
     /*  419543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419575 */     // MIs[0] policy
     /*  419575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  419588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419602 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419604 */     GIR_RootConstrainSelectedInstOperands,
     /*  419605 */     // GIR_Coverage, 61703,
     /*  419605 */     GIR_EraseRootFromParent_Done,
     /*  419606 */   // Label 7368: @419606
     /*  419606 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(419674), // Rule ID 61704 //
     /*  419611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  419614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419643 */     // MIs[0] policy
     /*  419643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419653 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  419653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  419656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419670 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419672 */     GIR_RootConstrainSelectedInstOperands,
     /*  419673 */     // GIR_Coverage, 61704,
     /*  419673 */     GIR_EraseRootFromParent_Done,
     /*  419674 */   // Label 7369: @419674
     /*  419674 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(419742), // Rule ID 61705 //
     /*  419679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  419682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  419687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  419693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419711 */     // MIs[0] policy
     /*  419711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  419714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419721 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  419721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  419724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  419726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  419728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419738 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  419740 */     GIR_RootConstrainSelectedInstOperands,
     /*  419741 */     // GIR_Coverage, 61705,
     /*  419741 */     GIR_EraseRootFromParent_Done,
     /*  419742 */   // Label 7370: @419742
     /*  419742 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(419813), // Rule ID 2564 //
     /*  419747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  419750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  419755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  419758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  419761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  419764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419779 */     // MIs[0] round
     /*  419779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  419782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419789 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  419789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  419792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  419796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419798 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  419800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  419811 */     GIR_RootConstrainSelectedInstOperands,
     /*  419812 */     // GIR_Coverage, 2564,
     /*  419812 */     GIR_EraseRootFromParent_Done,
     /*  419813 */   // Label 7371: @419813
     /*  419813 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(419884), // Rule ID 2565 //
     /*  419818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  419821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  419826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  419829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  419832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  419835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419850 */     // MIs[0] round
     /*  419850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  419853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419860 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  419860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  419863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  419867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419869 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  419871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  419882 */     GIR_RootConstrainSelectedInstOperands,
     /*  419883 */     // GIR_Coverage, 2565,
     /*  419883 */     GIR_EraseRootFromParent_Done,
     /*  419884 */   // Label 7372: @419884
     /*  419884 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(419955), // Rule ID 2600 //
     /*  419889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  419892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  419897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  419900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  419903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  419906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419921 */     // MIs[0] round
     /*  419921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  419924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419931 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  419931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  419934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  419938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  419940 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  419942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  419953 */     GIR_RootConstrainSelectedInstOperands,
     /*  419954 */     // GIR_Coverage, 2600,
     /*  419954 */     GIR_EraseRootFromParent_Done,
     /*  419955 */   // Label 7373: @419955
     /*  419955 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(420026), // Rule ID 2601 //
     /*  419960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  419963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  419968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  419971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  419974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  419977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419992 */     // MIs[0] round
     /*  419992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  419995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  420002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  420005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420011 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420024 */     GIR_RootConstrainSelectedInstOperands,
     /*  420025 */     // GIR_Coverage, 2601,
     /*  420025 */     GIR_EraseRootFromParent_Done,
     /*  420026 */   // Label 7374: @420026
     /*  420026 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(420097), // Rule ID 18850 //
     /*  420031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  420034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  420042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  420045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  420048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420063 */     // MIs[0] round
     /*  420063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420073 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  420073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  420076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420082 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420095 */     GIR_RootConstrainSelectedInstOperands,
     /*  420096 */     // GIR_Coverage, 18850,
     /*  420096 */     GIR_EraseRootFromParent_Done,
     /*  420097 */   // Label 7375: @420097
     /*  420097 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(420168), // Rule ID 18851 //
     /*  420102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  420105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  420113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  420116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  420119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420134 */     // MIs[0] round
     /*  420134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420144 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  420144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  420147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420153 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420166 */     GIR_RootConstrainSelectedInstOperands,
     /*  420167 */     // GIR_Coverage, 18851,
     /*  420167 */     GIR_EraseRootFromParent_Done,
     /*  420168 */   // Label 7376: @420168
     /*  420168 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(420239), // Rule ID 18854 //
     /*  420173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  420176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  420184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  420187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  420190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420205 */     // MIs[0] round
     /*  420205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420215 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  420215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  420218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420224 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420237 */     GIR_RootConstrainSelectedInstOperands,
     /*  420238 */     // GIR_Coverage, 18854,
     /*  420238 */     GIR_EraseRootFromParent_Done,
     /*  420239 */   // Label 7377: @420239
     /*  420239 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(420310), // Rule ID 18855 //
     /*  420244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  420247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  420255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  420258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  420261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420276 */     // MIs[0] round
     /*  420276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420286 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  420286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  420289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420295 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420308 */     GIR_RootConstrainSelectedInstOperands,
     /*  420309 */     // GIR_Coverage, 18855,
     /*  420309 */     GIR_EraseRootFromParent_Done,
     /*  420310 */   // Label 7378: @420310
     /*  420310 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(420381), // Rule ID 18858 //
     /*  420315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  420318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  420326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  420329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  420332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420347 */     // MIs[0] round
     /*  420347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420357 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  420357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  420360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420366 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420379 */     GIR_RootConstrainSelectedInstOperands,
     /*  420380 */     // GIR_Coverage, 18858,
     /*  420380 */     GIR_EraseRootFromParent_Done,
     /*  420381 */   // Label 7379: @420381
     /*  420381 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(420452), // Rule ID 18859 //
     /*  420386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  420389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  420397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  420400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  420403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420418 */     // MIs[0] round
     /*  420418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420428 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10966:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  420428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  420431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420437 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420450 */     GIR_RootConstrainSelectedInstOperands,
     /*  420451 */     // GIR_Coverage, 18859,
     /*  420451 */     GIR_EraseRootFromParent_Done,
     /*  420452 */   // Label 7380: @420452
     /*  420452 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(420523), // Rule ID 18862 //
     /*  420457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  420460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  420468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  420471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  420474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420489 */     // MIs[0] round
     /*  420489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10966:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  420499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  420502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420508 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420521 */     GIR_RootConstrainSelectedInstOperands,
     /*  420522 */     // GIR_Coverage, 18862,
     /*  420522 */     GIR_EraseRootFromParent_Done,
     /*  420523 */   // Label 7381: @420523
     /*  420523 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(420594), // Rule ID 18863 //
     /*  420528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  420531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  420539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  420542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  420545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420560 */     // MIs[0] round
     /*  420560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10966:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  420570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  420573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420579 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420592 */     GIR_RootConstrainSelectedInstOperands,
     /*  420593 */     // GIR_Coverage, 18863,
     /*  420593 */     GIR_EraseRootFromParent_Done,
     /*  420594 */   // Label 7382: @420594
     /*  420594 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(420665), // Rule ID 18866 //
     /*  420599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  420602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  420613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420631 */     // MIs[0] round
     /*  420631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420641 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  420641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  420644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420650 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420663 */     GIR_RootConstrainSelectedInstOperands,
     /*  420664 */     // GIR_Coverage, 18866,
     /*  420664 */     GIR_EraseRootFromParent_Done,
     /*  420665 */   // Label 7383: @420665
     /*  420665 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(420736), // Rule ID 18867 //
     /*  420670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  420673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  420684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420702 */     // MIs[0] round
     /*  420702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420712 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10966:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  420712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  420715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420721 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420734 */     GIR_RootConstrainSelectedInstOperands,
     /*  420735 */     // GIR_Coverage, 18867,
     /*  420735 */     GIR_EraseRootFromParent_Done,
     /*  420736 */   // Label 7384: @420736
     /*  420736 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(420807), // Rule ID 18870 //
     /*  420741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  420744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  420752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  420755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  420758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420773 */     // MIs[0] round
     /*  420773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  420783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  420786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420792 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420805 */     GIR_RootConstrainSelectedInstOperands,
     /*  420806 */     // GIR_Coverage, 18870,
     /*  420806 */     GIR_EraseRootFromParent_Done,
     /*  420807 */   // Label 7385: @420807
     /*  420807 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(420878), // Rule ID 18871 //
     /*  420812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  420815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  420823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  420826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  420829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420844 */     // MIs[0] round
     /*  420844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420854 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  420854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  420857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420863 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420876 */     GIR_RootConstrainSelectedInstOperands,
     /*  420877 */     // GIR_Coverage, 18871,
     /*  420877 */     GIR_EraseRootFromParent_Done,
     /*  420878 */   // Label 7386: @420878
     /*  420878 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(420949), // Rule ID 18874 //
     /*  420883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  420886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  420894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  420897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  420900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420915 */     // MIs[0] round
     /*  420915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420925 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  420925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  420928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  420932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  420934 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  420936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  420944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  420947 */     GIR_RootConstrainSelectedInstOperands,
     /*  420948 */     // GIR_Coverage, 18874,
     /*  420948 */     GIR_EraseRootFromParent_Done,
     /*  420949 */   // Label 7387: @420949
     /*  420949 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(421020), // Rule ID 18875 //
     /*  420954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  420957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  420962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  420965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  420968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  420971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420986 */     // MIs[0] round
     /*  420986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  420989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420996 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  420996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  420999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421005 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421018 */     GIR_RootConstrainSelectedInstOperands,
     /*  421019 */     // GIR_Coverage, 18875,
     /*  421019 */     GIR_EraseRootFromParent_Done,
     /*  421020 */   // Label 7388: @421020
     /*  421020 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(421091), // Rule ID 18878 //
     /*  421025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  421028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  421039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421057 */     // MIs[0] round
     /*  421057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421067 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  421067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  421070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421076 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421089 */     GIR_RootConstrainSelectedInstOperands,
     /*  421090 */     // GIR_Coverage, 18878,
     /*  421090 */     GIR_EraseRootFromParent_Done,
     /*  421091 */   // Label 7389: @421091
     /*  421091 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(421162), // Rule ID 18879 //
     /*  421096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  421099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  421110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421128 */     // MIs[0] round
     /*  421128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421138 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  421138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  421141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421147 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421160 */     GIR_RootConstrainSelectedInstOperands,
     /*  421161 */     // GIR_Coverage, 18879,
     /*  421161 */     GIR_EraseRootFromParent_Done,
     /*  421162 */   // Label 7390: @421162
     /*  421162 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(421233), // Rule ID 18882 //
     /*  421167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  421170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  421178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  421181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  421184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421199 */     // MIs[0] round
     /*  421199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  421209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  421212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421218 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421231 */     GIR_RootConstrainSelectedInstOperands,
     /*  421232 */     // GIR_Coverage, 18882,
     /*  421232 */     GIR_EraseRootFromParent_Done,
     /*  421233 */   // Label 7391: @421233
     /*  421233 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(421304), // Rule ID 18883 //
     /*  421238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  421241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  421249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  421252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  421255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421270 */     // MIs[0] round
     /*  421270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421280 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  421280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  421283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421289 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421302 */     GIR_RootConstrainSelectedInstOperands,
     /*  421303 */     // GIR_Coverage, 18883,
     /*  421303 */     GIR_EraseRootFromParent_Done,
     /*  421304 */   // Label 7392: @421304
     /*  421304 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(421375), // Rule ID 18886 //
     /*  421309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  421312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  421320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  421323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  421326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421341 */     // MIs[0] round
     /*  421341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421351 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  421351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  421354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421360 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421373 */     GIR_RootConstrainSelectedInstOperands,
     /*  421374 */     // GIR_Coverage, 18886,
     /*  421374 */     GIR_EraseRootFromParent_Done,
     /*  421375 */   // Label 7393: @421375
     /*  421375 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(421446), // Rule ID 18887 //
     /*  421380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  421383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  421391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  421394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  421397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421412 */     // MIs[0] round
     /*  421412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421422 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  421422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  421425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421431 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421444 */     GIR_RootConstrainSelectedInstOperands,
     /*  421445 */     // GIR_Coverage, 18887,
     /*  421445 */     GIR_EraseRootFromParent_Done,
     /*  421446 */   // Label 7394: @421446
     /*  421446 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(421517), // Rule ID 18890 //
     /*  421451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  421454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  421462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  421465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  421468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421483 */     // MIs[0] round
     /*  421483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421493 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  421493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  421496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421502 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421515 */     GIR_RootConstrainSelectedInstOperands,
     /*  421516 */     // GIR_Coverage, 18890,
     /*  421516 */     GIR_EraseRootFromParent_Done,
     /*  421517 */   // Label 7395: @421517
     /*  421517 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(421588), // Rule ID 18891 //
     /*  421522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  421525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  421533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  421536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  421539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421554 */     // MIs[0] round
     /*  421554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421564 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  421564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  421567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421573 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421586 */     GIR_RootConstrainSelectedInstOperands,
     /*  421587 */     // GIR_Coverage, 18891,
     /*  421587 */     GIR_EraseRootFromParent_Done,
     /*  421588 */   // Label 7396: @421588
     /*  421588 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(421659), // Rule ID 18894 //
     /*  421593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  421596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  421604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  421607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  421610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421625 */     // MIs[0] round
     /*  421625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  421635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  421638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421644 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421657 */     GIR_RootConstrainSelectedInstOperands,
     /*  421658 */     // GIR_Coverage, 18894,
     /*  421658 */     GIR_EraseRootFromParent_Done,
     /*  421659 */   // Label 7397: @421659
     /*  421659 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(421730), // Rule ID 18895 //
     /*  421664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  421667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  421675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  421678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  421681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421696 */     // MIs[0] round
     /*  421696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421706 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10966:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  421706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  421709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421715 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421728 */     GIR_RootConstrainSelectedInstOperands,
     /*  421729 */     // GIR_Coverage, 18895,
     /*  421729 */     GIR_EraseRootFromParent_Done,
     /*  421730 */   // Label 7398: @421730
     /*  421730 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(421801), // Rule ID 18898 //
     /*  421735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  421738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  421749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421767 */     // MIs[0] round
     /*  421767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421777 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  421777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  421780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421786 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421799 */     GIR_RootConstrainSelectedInstOperands,
     /*  421800 */     // GIR_Coverage, 18898,
     /*  421800 */     GIR_EraseRootFromParent_Done,
     /*  421801 */   // Label 7399: @421801
     /*  421801 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(421872), // Rule ID 18899 //
     /*  421806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  421809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  421820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421838 */     // MIs[0] round
     /*  421838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421848 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10966:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  421848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  421851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421857 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421870 */     GIR_RootConstrainSelectedInstOperands,
     /*  421871 */     // GIR_Coverage, 18899,
     /*  421871 */     GIR_EraseRootFromParent_Done,
     /*  421872 */   // Label 7400: @421872
     /*  421872 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(421943), // Rule ID 18902 //
     /*  421877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  421880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  421891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421909 */     // MIs[0] round
     /*  421909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421919 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  421919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  421922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421928 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  421930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  421941 */     GIR_RootConstrainSelectedInstOperands,
     /*  421942 */     // GIR_Coverage, 18902,
     /*  421942 */     GIR_EraseRootFromParent_Done,
     /*  421943 */   // Label 7401: @421943
     /*  421943 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(422014), // Rule ID 18903 //
     /*  421948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  421951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  421956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  421962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421980 */     // MIs[0] round
     /*  421980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  421983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421990 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10966:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  421990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  421993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  421997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  421999 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422012 */     GIR_RootConstrainSelectedInstOperands,
     /*  422013 */     // GIR_Coverage, 18903,
     /*  422013 */     GIR_EraseRootFromParent_Done,
     /*  422014 */   // Label 7402: @422014
     /*  422014 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(422085), // Rule ID 18962 //
     /*  422019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  422022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  422030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  422036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422051 */     // MIs[0] round
     /*  422051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422061 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  422061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  422064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422070 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422083 */     GIR_RootConstrainSelectedInstOperands,
     /*  422084 */     // GIR_Coverage, 18962,
     /*  422084 */     GIR_EraseRootFromParent_Done,
     /*  422085 */   // Label 7403: @422085
     /*  422085 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(422156), // Rule ID 18963 //
     /*  422090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  422093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  422101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  422107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422122 */     // MIs[0] round
     /*  422122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422132 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  422132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  422135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422141 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422154 */     GIR_RootConstrainSelectedInstOperands,
     /*  422155 */     // GIR_Coverage, 18963,
     /*  422155 */     GIR_EraseRootFromParent_Done,
     /*  422156 */   // Label 7404: @422156
     /*  422156 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(422227), // Rule ID 18966 //
     /*  422161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  422164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  422172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  422178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422193 */     // MIs[0] round
     /*  422193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422203 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  422203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  422206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422212 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422225 */     GIR_RootConstrainSelectedInstOperands,
     /*  422226 */     // GIR_Coverage, 18966,
     /*  422226 */     GIR_EraseRootFromParent_Done,
     /*  422227 */   // Label 7405: @422227
     /*  422227 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(422298), // Rule ID 18967 //
     /*  422232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  422235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  422243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  422249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422264 */     // MIs[0] round
     /*  422264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422274 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  422274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  422277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422283 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422296 */     GIR_RootConstrainSelectedInstOperands,
     /*  422297 */     // GIR_Coverage, 18967,
     /*  422297 */     GIR_EraseRootFromParent_Done,
     /*  422298 */   // Label 7406: @422298
     /*  422298 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(422369), // Rule ID 18970 //
     /*  422303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  422306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  422314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  422320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422335 */     // MIs[0] round
     /*  422335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422345 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  422345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  422348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422354 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422367 */     GIR_RootConstrainSelectedInstOperands,
     /*  422368 */     // GIR_Coverage, 18970,
     /*  422368 */     GIR_EraseRootFromParent_Done,
     /*  422369 */   // Label 7407: @422369
     /*  422369 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(422440), // Rule ID 18971 //
     /*  422374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  422377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  422385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  422391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422406 */     // MIs[0] round
     /*  422406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422416 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  422416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  422419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422425 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422438 */     GIR_RootConstrainSelectedInstOperands,
     /*  422439 */     // GIR_Coverage, 18971,
     /*  422439 */     GIR_EraseRootFromParent_Done,
     /*  422440 */   // Label 7408: @422440
     /*  422440 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(422511), // Rule ID 18974 //
     /*  422445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  422448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  422456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  422462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422477 */     // MIs[0] round
     /*  422477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422487 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  422487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  422490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422496 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422509 */     GIR_RootConstrainSelectedInstOperands,
     /*  422510 */     // GIR_Coverage, 18974,
     /*  422510 */     GIR_EraseRootFromParent_Done,
     /*  422511 */   // Label 7409: @422511
     /*  422511 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(422582), // Rule ID 18975 //
     /*  422516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  422519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  422527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  422533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422548 */     // MIs[0] round
     /*  422548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422558 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10942:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  422558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  422561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422567 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422580 */     GIR_RootConstrainSelectedInstOperands,
     /*  422581 */     // GIR_Coverage, 18975,
     /*  422581 */     GIR_EraseRootFromParent_Done,
     /*  422582 */   // Label 7410: @422582
     /*  422582 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(422653), // Rule ID 18978 //
     /*  422587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  422590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  422598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  422604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422619 */     // MIs[0] round
     /*  422619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422629 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10942:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  422629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  422632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422638 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422651 */     GIR_RootConstrainSelectedInstOperands,
     /*  422652 */     // GIR_Coverage, 18978,
     /*  422652 */     GIR_EraseRootFromParent_Done,
     /*  422653 */   // Label 7411: @422653
     /*  422653 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(422724), // Rule ID 18979 //
     /*  422658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  422661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  422669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  422675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422690 */     // MIs[0] round
     /*  422690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10942:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  422700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  422703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422709 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422722 */     GIR_RootConstrainSelectedInstOperands,
     /*  422723 */     // GIR_Coverage, 18979,
     /*  422723 */     GIR_EraseRootFromParent_Done,
     /*  422724 */   // Label 7412: @422724
     /*  422724 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(422795), // Rule ID 18982 //
     /*  422729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  422732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  422740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  422746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422761 */     // MIs[0] round
     /*  422761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422771 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  422771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  422774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422780 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422793 */     GIR_RootConstrainSelectedInstOperands,
     /*  422794 */     // GIR_Coverage, 18982,
     /*  422794 */     GIR_EraseRootFromParent_Done,
     /*  422795 */   // Label 7413: @422795
     /*  422795 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(422866), // Rule ID 18983 //
     /*  422800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  422803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  422811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  422817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422832 */     // MIs[0] round
     /*  422832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422842 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10942:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  422842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  422845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422851 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422864 */     GIR_RootConstrainSelectedInstOperands,
     /*  422865 */     // GIR_Coverage, 18983,
     /*  422865 */     GIR_EraseRootFromParent_Done,
     /*  422866 */   // Label 7414: @422866
     /*  422866 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(422937), // Rule ID 18986 //
     /*  422871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  422874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  422882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  422885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  422888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422903 */     // MIs[0] round
     /*  422903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422913 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  422913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  422916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422922 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  422935 */     GIR_RootConstrainSelectedInstOperands,
     /*  422936 */     // GIR_Coverage, 18986,
     /*  422936 */     GIR_EraseRootFromParent_Done,
     /*  422937 */   // Label 7415: @422937
     /*  422937 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(423008), // Rule ID 18987 //
     /*  422942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  422945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  422950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  422953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  422956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  422959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422974 */     // MIs[0] round
     /*  422974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  422977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  422984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  422987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  422991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  422993 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  422995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423006 */     GIR_RootConstrainSelectedInstOperands,
     /*  423007 */     // GIR_Coverage, 18987,
     /*  423007 */     GIR_EraseRootFromParent_Done,
     /*  423008 */   // Label 7416: @423008
     /*  423008 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(423079), // Rule ID 18990 //
     /*  423013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  423016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  423024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  423030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423045 */     // MIs[0] round
     /*  423045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423055 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  423055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  423058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423064 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423077 */     GIR_RootConstrainSelectedInstOperands,
     /*  423078 */     // GIR_Coverage, 18990,
     /*  423078 */     GIR_EraseRootFromParent_Done,
     /*  423079 */   // Label 7417: @423079
     /*  423079 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(423150), // Rule ID 18991 //
     /*  423084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  423087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  423095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  423101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423116 */     // MIs[0] round
     /*  423116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423126 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  423126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  423129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423135 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423148 */     GIR_RootConstrainSelectedInstOperands,
     /*  423149 */     // GIR_Coverage, 18991,
     /*  423149 */     GIR_EraseRootFromParent_Done,
     /*  423150 */   // Label 7418: @423150
     /*  423150 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(423221), // Rule ID 18994 //
     /*  423155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  423158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  423166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  423172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423187 */     // MIs[0] round
     /*  423187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423197 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  423197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  423200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423206 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423219 */     GIR_RootConstrainSelectedInstOperands,
     /*  423220 */     // GIR_Coverage, 18994,
     /*  423220 */     GIR_EraseRootFromParent_Done,
     /*  423221 */   // Label 7419: @423221
     /*  423221 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(423292), // Rule ID 18995 //
     /*  423226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  423229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  423237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  423243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423258 */     // MIs[0] round
     /*  423258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423268 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  423268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  423271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423277 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423290 */     GIR_RootConstrainSelectedInstOperands,
     /*  423291 */     // GIR_Coverage, 18995,
     /*  423291 */     GIR_EraseRootFromParent_Done,
     /*  423292 */   // Label 7420: @423292
     /*  423292 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(423363), // Rule ID 18998 //
     /*  423297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  423300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  423308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  423314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423329 */     // MIs[0] round
     /*  423329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  423339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  423342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423348 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423361 */     GIR_RootConstrainSelectedInstOperands,
     /*  423362 */     // GIR_Coverage, 18998,
     /*  423362 */     GIR_EraseRootFromParent_Done,
     /*  423363 */   // Label 7421: @423363
     /*  423363 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(423434), // Rule ID 18999 //
     /*  423368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  423371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  423379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  423385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423400 */     // MIs[0] round
     /*  423400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423410 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  423410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  423413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423419 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423432 */     GIR_RootConstrainSelectedInstOperands,
     /*  423433 */     // GIR_Coverage, 18999,
     /*  423433 */     GIR_EraseRootFromParent_Done,
     /*  423434 */   // Label 7422: @423434
     /*  423434 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(423505), // Rule ID 19002 //
     /*  423439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  423442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423471 */     // MIs[0] round
     /*  423471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423481 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  423481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  423484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423490 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423503 */     GIR_RootConstrainSelectedInstOperands,
     /*  423504 */     // GIR_Coverage, 19002,
     /*  423504 */     GIR_EraseRootFromParent_Done,
     /*  423505 */   // Label 7423: @423505
     /*  423505 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(423576), // Rule ID 19003 //
     /*  423510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  423513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423542 */     // MIs[0] round
     /*  423542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  423552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  423555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423561 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423574 */     GIR_RootConstrainSelectedInstOperands,
     /*  423575 */     // GIR_Coverage, 19003,
     /*  423575 */     GIR_EraseRootFromParent_Done,
     /*  423576 */   // Label 7424: @423576
     /*  423576 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(423647), // Rule ID 19006 //
     /*  423581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  423584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  423595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423613 */     // MIs[0] round
     /*  423613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423623 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  423623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  423626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423632 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423645 */     GIR_RootConstrainSelectedInstOperands,
     /*  423646 */     // GIR_Coverage, 19006,
     /*  423646 */     GIR_EraseRootFromParent_Done,
     /*  423647 */   // Label 7425: @423647
     /*  423647 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(423718), // Rule ID 19007 //
     /*  423652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  423655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  423666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423684 */     // MIs[0] round
     /*  423684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  423694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  423697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423703 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423716 */     GIR_RootConstrainSelectedInstOperands,
     /*  423717 */     // GIR_Coverage, 19007,
     /*  423717 */     GIR_EraseRootFromParent_Done,
     /*  423718 */   // Label 7426: @423718
     /*  423718 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(423789), // Rule ID 19010 //
     /*  423723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  423726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  423737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423755 */     // MIs[0] round
     /*  423755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423765 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  423765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  423768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423774 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423787 */     GIR_RootConstrainSelectedInstOperands,
     /*  423788 */     // GIR_Coverage, 19010,
     /*  423788 */     GIR_EraseRootFromParent_Done,
     /*  423789 */   // Label 7427: @423789
     /*  423789 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(423860), // Rule ID 19011 //
     /*  423794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  423797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  423808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423826 */     // MIs[0] round
     /*  423826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10942:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  423836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  423839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423845 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423858 */     GIR_RootConstrainSelectedInstOperands,
     /*  423859 */     // GIR_Coverage, 19011,
     /*  423859 */     GIR_EraseRootFromParent_Done,
     /*  423860 */   // Label 7428: @423860
     /*  423860 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(423931), // Rule ID 19014 //
     /*  423865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  423868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  423876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  423879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  423882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423897 */     // MIs[0] round
     /*  423897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423907 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  423907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  423910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423916 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  423929 */     GIR_RootConstrainSelectedInstOperands,
     /*  423930 */     // GIR_Coverage, 19014,
     /*  423930 */     GIR_EraseRootFromParent_Done,
     /*  423931 */   // Label 7429: @423931
     /*  423931 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(424002), // Rule ID 19015 //
     /*  423936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  423939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  423944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  423947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  423950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  423953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423968 */     // MIs[0] round
     /*  423968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  423971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423978 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10942:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  423978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  423981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  423985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  423987 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  423989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424000 */     GIR_RootConstrainSelectedInstOperands,
     /*  424001 */     // GIR_Coverage, 19015,
     /*  424001 */     GIR_EraseRootFromParent_Done,
     /*  424002 */   // Label 7430: @424002
     /*  424002 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(424073), // Rule ID 19018 //
     /*  424007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  424010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  424015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424039 */     // MIs[0] round
     /*  424039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  424049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  424052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424058 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424071 */     GIR_RootConstrainSelectedInstOperands,
     /*  424072 */     // GIR_Coverage, 19018,
     /*  424072 */     GIR_EraseRootFromParent_Done,
     /*  424073 */   // Label 7431: @424073
     /*  424073 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(424144), // Rule ID 19019 //
     /*  424078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  424081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  424086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424110 */     // MIs[0] round
     /*  424110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424120 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10942:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  424120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  424123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424129 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424142 */     GIR_RootConstrainSelectedInstOperands,
     /*  424143 */     // GIR_Coverage, 19019,
     /*  424143 */     GIR_EraseRootFromParent_Done,
     /*  424144 */   // Label 7432: @424144
     /*  424144 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(424215), // Rule ID 20604 //
     /*  424149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  424152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  424160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  424163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  424166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424181 */     // MIs[0] round
     /*  424181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424191 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  424191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  424194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424200 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424213 */     GIR_RootConstrainSelectedInstOperands,
     /*  424214 */     // GIR_Coverage, 20604,
     /*  424214 */     GIR_EraseRootFromParent_Done,
     /*  424215 */   // Label 7433: @424215
     /*  424215 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(424286), // Rule ID 20605 //
     /*  424220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  424223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  424231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  424234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  424237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424252 */     // MIs[0] round
     /*  424252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424262 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  424262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  424265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424271 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424284 */     GIR_RootConstrainSelectedInstOperands,
     /*  424285 */     // GIR_Coverage, 20605,
     /*  424285 */     GIR_EraseRootFromParent_Done,
     /*  424286 */   // Label 7434: @424286
     /*  424286 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(424357), // Rule ID 20608 //
     /*  424291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  424294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424323 */     // MIs[0] round
     /*  424323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424333 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  424336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424342 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424355 */     GIR_RootConstrainSelectedInstOperands,
     /*  424356 */     // GIR_Coverage, 20608,
     /*  424356 */     GIR_EraseRootFromParent_Done,
     /*  424357 */   // Label 7435: @424357
     /*  424357 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(424428), // Rule ID 20609 //
     /*  424362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  424365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424394 */     // MIs[0] round
     /*  424394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  424407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424413 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424426 */     GIR_RootConstrainSelectedInstOperands,
     /*  424427 */     // GIR_Coverage, 20609,
     /*  424427 */     GIR_EraseRootFromParent_Done,
     /*  424428 */   // Label 7436: @424428
     /*  424428 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(424499), // Rule ID 20612 //
     /*  424433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  424436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  424444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  424447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  424450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424465 */     // MIs[0] round
     /*  424465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  424475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424484 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424497 */     GIR_RootConstrainSelectedInstOperands,
     /*  424498 */     // GIR_Coverage, 20612,
     /*  424498 */     GIR_EraseRootFromParent_Done,
     /*  424499 */   // Label 7437: @424499
     /*  424499 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(424570), // Rule ID 20613 //
     /*  424504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  424507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  424515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  424518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  424521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424536 */     // MIs[0] round
     /*  424536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10888:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  424546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424555 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424568 */     GIR_RootConstrainSelectedInstOperands,
     /*  424569 */     // GIR_Coverage, 20613,
     /*  424569 */     GIR_EraseRootFromParent_Done,
     /*  424570 */   // Label 7438: @424570
     /*  424570 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(424641), // Rule ID 20616 //
     /*  424575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  424578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424607 */     // MIs[0] round
     /*  424607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424617 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424626 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424639 */     GIR_RootConstrainSelectedInstOperands,
     /*  424640 */     // GIR_Coverage, 20616,
     /*  424640 */     GIR_EraseRootFromParent_Done,
     /*  424641 */   // Label 7439: @424641
     /*  424641 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(424712), // Rule ID 20617 //
     /*  424646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  424649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424678 */     // MIs[0] round
     /*  424678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424697 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424710 */     GIR_RootConstrainSelectedInstOperands,
     /*  424711 */     // GIR_Coverage, 20617,
     /*  424711 */     GIR_EraseRootFromParent_Done,
     /*  424712 */   // Label 7440: @424712
     /*  424712 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(424783), // Rule ID 20620 //
     /*  424717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  424720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  424728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  424731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  424734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424749 */     // MIs[0] round
     /*  424749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424759 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  424759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424768 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424781 */     GIR_RootConstrainSelectedInstOperands,
     /*  424782 */     // GIR_Coverage, 20620,
     /*  424782 */     GIR_EraseRootFromParent_Done,
     /*  424783 */   // Label 7441: @424783
     /*  424783 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(424854), // Rule ID 20621 //
     /*  424788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  424791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  424799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  424802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  424805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424820 */     // MIs[0] round
     /*  424820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424830 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  424830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  424833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424839 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424852 */     GIR_RootConstrainSelectedInstOperands,
     /*  424853 */     // GIR_Coverage, 20621,
     /*  424853 */     GIR_EraseRootFromParent_Done,
     /*  424854 */   // Label 7442: @424854
     /*  424854 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(424925), // Rule ID 20624 //
     /*  424859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  424862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  424870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  424873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  424876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424891 */     // MIs[0] round
     /*  424891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  424901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  424904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424910 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424923 */     GIR_RootConstrainSelectedInstOperands,
     /*  424924 */     // GIR_Coverage, 20624,
     /*  424924 */     GIR_EraseRootFromParent_Done,
     /*  424925 */   // Label 7443: @424925
     /*  424925 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(424996), // Rule ID 20625 //
     /*  424930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  424933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  424938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  424941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  424944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  424947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424962 */     // MIs[0] round
     /*  424962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  424972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  424975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  424981 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  424983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424994 */     GIR_RootConstrainSelectedInstOperands,
     /*  424995 */     // GIR_Coverage, 20625,
     /*  424995 */     GIR_EraseRootFromParent_Done,
     /*  424996 */   // Label 7444: @424996
     /*  424996 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(425067), // Rule ID 20628 //
     /*  425001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  425004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  425012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  425015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  425018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425033 */     // MIs[0] round
     /*  425033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  425043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425052 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425065 */     GIR_RootConstrainSelectedInstOperands,
     /*  425066 */     // GIR_Coverage, 20628,
     /*  425066 */     GIR_EraseRootFromParent_Done,
     /*  425067 */   // Label 7445: @425067
     /*  425067 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(425138), // Rule ID 20629 //
     /*  425072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  425075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  425083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  425086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  425089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425104 */     // MIs[0] round
     /*  425104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  425114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425123 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425136 */     GIR_RootConstrainSelectedInstOperands,
     /*  425137 */     // GIR_Coverage, 20629,
     /*  425137 */     GIR_EraseRootFromParent_Done,
     /*  425138 */   // Label 7446: @425138
     /*  425138 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(425209), // Rule ID 20632 //
     /*  425143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  425146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  425154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  425157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  425160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425175 */     // MIs[0] round
     /*  425175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425185 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  425185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  425188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425194 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425207 */     GIR_RootConstrainSelectedInstOperands,
     /*  425208 */     // GIR_Coverage, 20632,
     /*  425208 */     GIR_EraseRootFromParent_Done,
     /*  425209 */   // Label 7447: @425209
     /*  425209 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(425280), // Rule ID 20633 //
     /*  425214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  425217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  425225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  425228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  425231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425246 */     // MIs[0] round
     /*  425246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  425256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  425259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425265 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425278 */     GIR_RootConstrainSelectedInstOperands,
     /*  425279 */     // GIR_Coverage, 20633,
     /*  425279 */     GIR_EraseRootFromParent_Done,
     /*  425280 */   // Label 7448: @425280
     /*  425280 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(425351), // Rule ID 20636 //
     /*  425285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  425288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425317 */     // MIs[0] round
     /*  425317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  425330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425336 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425349 */     GIR_RootConstrainSelectedInstOperands,
     /*  425350 */     // GIR_Coverage, 20636,
     /*  425350 */     GIR_EraseRootFromParent_Done,
     /*  425351 */   // Label 7449: @425351
     /*  425351 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(425422), // Rule ID 20637 //
     /*  425356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  425359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425388 */     // MIs[0] round
     /*  425388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  425401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425407 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425420 */     GIR_RootConstrainSelectedInstOperands,
     /*  425421 */     // GIR_Coverage, 20637,
     /*  425421 */     GIR_EraseRootFromParent_Done,
     /*  425422 */   // Label 7450: @425422
     /*  425422 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(425493), // Rule ID 20640 //
     /*  425427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  425430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425459 */     // MIs[0] round
     /*  425459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425478 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425491 */     GIR_RootConstrainSelectedInstOperands,
     /*  425492 */     // GIR_Coverage, 20640,
     /*  425492 */     GIR_EraseRootFromParent_Done,
     /*  425493 */   // Label 7451: @425493
     /*  425493 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(425564), // Rule ID 20641 //
     /*  425498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  425501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425530 */     // MIs[0] round
     /*  425530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425549 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425562 */     GIR_RootConstrainSelectedInstOperands,
     /*  425563 */     // GIR_Coverage, 20641,
     /*  425563 */     GIR_EraseRootFromParent_Done,
     /*  425564 */   // Label 7452: @425564
     /*  425564 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(425635), // Rule ID 20644 //
     /*  425569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  425572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425601 */     // MIs[0] round
     /*  425601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425611 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  425614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425620 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425633 */     GIR_RootConstrainSelectedInstOperands,
     /*  425634 */     // GIR_Coverage, 20644,
     /*  425634 */     GIR_EraseRootFromParent_Done,
     /*  425635 */   // Label 7453: @425635
     /*  425635 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(425706), // Rule ID 20645 //
     /*  425640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  425643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425672 */     // MIs[0] round
     /*  425672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  425685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425691 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425704 */     GIR_RootConstrainSelectedInstOperands,
     /*  425705 */     // GIR_Coverage, 20645,
     /*  425705 */     GIR_EraseRootFromParent_Done,
     /*  425706 */   // Label 7454: @425706
     /*  425706 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(425777), // Rule ID 20648 //
     /*  425711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  425714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  425722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  425725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  425728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425743 */     // MIs[0] round
     /*  425743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  425753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  425756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425762 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425775 */     GIR_RootConstrainSelectedInstOperands,
     /*  425776 */     // GIR_Coverage, 20648,
     /*  425776 */     GIR_EraseRootFromParent_Done,
     /*  425777 */   // Label 7455: @425777
     /*  425777 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(425848), // Rule ID 20649 //
     /*  425782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  425785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  425793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  425796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  425799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425814 */     // MIs[0] round
     /*  425814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  425824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  425827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425833 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425846 */     GIR_RootConstrainSelectedInstOperands,
     /*  425847 */     // GIR_Coverage, 20649,
     /*  425847 */     GIR_EraseRootFromParent_Done,
     /*  425848 */   // Label 7456: @425848
     /*  425848 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(425919), // Rule ID 20652 //
     /*  425853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  425856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  425864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  425867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  425870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425885 */     // MIs[0] round
     /*  425885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425895 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  425895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425904 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425917 */     GIR_RootConstrainSelectedInstOperands,
     /*  425918 */     // GIR_Coverage, 20652,
     /*  425918 */     GIR_EraseRootFromParent_Done,
     /*  425919 */   // Label 7457: @425919
     /*  425919 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(425990), // Rule ID 20653 //
     /*  425924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  425927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  425932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  425935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  425938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  425941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425956 */     // MIs[0] round
     /*  425956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  425966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  425969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  425975 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  425977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425988 */     GIR_RootConstrainSelectedInstOperands,
     /*  425989 */     // GIR_Coverage, 20653,
     /*  425989 */     GIR_EraseRootFromParent_Done,
     /*  425990 */   // Label 7458: @425990
     /*  425990 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(426061), // Rule ID 20656 //
     /*  425995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  425998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  426003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  426006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  426009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  426012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426027 */     // MIs[0] round
     /*  426027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  426037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  426040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426046 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426059 */     GIR_RootConstrainSelectedInstOperands,
     /*  426060 */     // GIR_Coverage, 20656,
     /*  426060 */     GIR_EraseRootFromParent_Done,
     /*  426061 */   // Label 7459: @426061
     /*  426061 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(426132), // Rule ID 20657 //
     /*  426066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  426069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  426074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  426077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  426080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  426083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426098 */     // MIs[0] round
     /*  426098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  426108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  426111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426117 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426130 */     GIR_RootConstrainSelectedInstOperands,
     /*  426131 */     // GIR_Coverage, 20657,
     /*  426131 */     GIR_EraseRootFromParent_Done,
     /*  426132 */   // Label 7460: @426132
     /*  426132 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(426203), // Rule ID 20660 //
     /*  426137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  426140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426169 */     // MIs[0] round
     /*  426169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426179 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  426182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426188 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426201 */     GIR_RootConstrainSelectedInstOperands,
     /*  426202 */     // GIR_Coverage, 20660,
     /*  426202 */     GIR_EraseRootFromParent_Done,
     /*  426203 */   // Label 7461: @426203
     /*  426203 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(426274), // Rule ID 20661 //
     /*  426208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  426211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426240 */     // MIs[0] round
     /*  426240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  426253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426259 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426272 */     GIR_RootConstrainSelectedInstOperands,
     /*  426273 */     // GIR_Coverage, 20661,
     /*  426273 */     GIR_EraseRootFromParent_Done,
     /*  426274 */   // Label 7462: @426274
     /*  426274 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(426345), // Rule ID 20664 //
     /*  426279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  426282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  426290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  426293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  426296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426311 */     // MIs[0] round
     /*  426311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426321 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  426324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426330 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426343 */     GIR_RootConstrainSelectedInstOperands,
     /*  426344 */     // GIR_Coverage, 20664,
     /*  426344 */     GIR_EraseRootFromParent_Done,
     /*  426345 */   // Label 7463: @426345
     /*  426345 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(426416), // Rule ID 20665 //
     /*  426350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  426353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  426361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  426364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  426367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426382 */     // MIs[0] round
     /*  426382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  426395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426401 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426414 */     GIR_RootConstrainSelectedInstOperands,
     /*  426415 */     // GIR_Coverage, 20665,
     /*  426415 */     GIR_EraseRootFromParent_Done,
     /*  426416 */   // Label 7464: @426416
     /*  426416 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(426487), // Rule ID 20668 //
     /*  426421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  426424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426453 */     // MIs[0] round
     /*  426453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426463 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  426466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426472 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426485 */     GIR_RootConstrainSelectedInstOperands,
     /*  426486 */     // GIR_Coverage, 20668,
     /*  426486 */     GIR_EraseRootFromParent_Done,
     /*  426487 */   // Label 7465: @426487
     /*  426487 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(426558), // Rule ID 20669 //
     /*  426492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  426495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426524 */     // MIs[0] round
     /*  426524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  426537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426543 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426556 */     GIR_RootConstrainSelectedInstOperands,
     /*  426557 */     // GIR_Coverage, 20669,
     /*  426557 */     GIR_EraseRootFromParent_Done,
     /*  426558 */   // Label 7466: @426558
     /*  426558 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(426629), // Rule ID 20672 //
     /*  426563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  426566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  426574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  426580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426595 */     // MIs[0] round
     /*  426595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426605 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426614 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426627 */     GIR_RootConstrainSelectedInstOperands,
     /*  426628 */     // GIR_Coverage, 20672,
     /*  426628 */     GIR_EraseRootFromParent_Done,
     /*  426629 */   // Label 7467: @426629
     /*  426629 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(426700), // Rule ID 20673 //
     /*  426634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  426637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  426645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  426651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426666 */     // MIs[0] round
     /*  426666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10890:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426685 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426698 */     GIR_RootConstrainSelectedInstOperands,
     /*  426699 */     // GIR_Coverage, 20673,
     /*  426699 */     GIR_EraseRootFromParent_Done,
     /*  426700 */   // Label 7468: @426700
     /*  426700 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(426771), // Rule ID 20676 //
     /*  426705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  426708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426737 */     // MIs[0] round
     /*  426737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426756 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426769 */     GIR_RootConstrainSelectedInstOperands,
     /*  426770 */     // GIR_Coverage, 20676,
     /*  426770 */     GIR_EraseRootFromParent_Done,
     /*  426771 */   // Label 7469: @426771
     /*  426771 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(426842), // Rule ID 20677 //
     /*  426776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  426779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426808 */     // MIs[0] round
     /*  426808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426827 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426840 */     GIR_RootConstrainSelectedInstOperands,
     /*  426841 */     // GIR_Coverage, 20677,
     /*  426841 */     GIR_EraseRootFromParent_Done,
     /*  426842 */   // Label 7470: @426842
     /*  426842 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(426913), // Rule ID 20680 //
     /*  426847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  426850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  426858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  426864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426879 */     // MIs[0] round
     /*  426879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  426889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426898 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426911 */     GIR_RootConstrainSelectedInstOperands,
     /*  426912 */     // GIR_Coverage, 20680,
     /*  426912 */     GIR_EraseRootFromParent_Done,
     /*  426913 */   // Label 7471: @426913
     /*  426913 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(426984), // Rule ID 20681 //
     /*  426918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  426921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  426929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  426935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426950 */     // MIs[0] round
     /*  426950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  426960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  426963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  426969 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  426971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426982 */     GIR_RootConstrainSelectedInstOperands,
     /*  426983 */     // GIR_Coverage, 20681,
     /*  426983 */     GIR_EraseRootFromParent_Done,
     /*  426984 */   // Label 7472: @426984
     /*  426984 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(427055), // Rule ID 20684 //
     /*  426989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  426992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  426997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  427000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  427006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427021 */     // MIs[0] round
     /*  427021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427040 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427053 */     GIR_RootConstrainSelectedInstOperands,
     /*  427054 */     // GIR_Coverage, 20684,
     /*  427054 */     GIR_EraseRootFromParent_Done,
     /*  427055 */   // Label 7473: @427055
     /*  427055 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(427126), // Rule ID 20685 //
     /*  427060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  427063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  427071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  427077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427092 */     // MIs[0] round
     /*  427092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427111 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427124 */     GIR_RootConstrainSelectedInstOperands,
     /*  427125 */     // GIR_Coverage, 20685,
     /*  427125 */     GIR_EraseRootFromParent_Done,
     /*  427126 */   // Label 7474: @427126
     /*  427126 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(427197), // Rule ID 20688 //
     /*  427131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  427134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  427142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  427148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427163 */     // MIs[0] round
     /*  427163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427173 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  427176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427182 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427195 */     GIR_RootConstrainSelectedInstOperands,
     /*  427196 */     // GIR_Coverage, 20688,
     /*  427196 */     GIR_EraseRootFromParent_Done,
     /*  427197 */   // Label 7475: @427197
     /*  427197 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(427268), // Rule ID 20689 //
     /*  427202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  427205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  427213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  427219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427234 */     // MIs[0] round
     /*  427234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  427247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427253 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427266 */     GIR_RootConstrainSelectedInstOperands,
     /*  427267 */     // GIR_Coverage, 20689,
     /*  427267 */     GIR_EraseRootFromParent_Done,
     /*  427268 */   // Label 7476: @427268
     /*  427268 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(427339), // Rule ID 20692 //
     /*  427273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  427276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  427284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  427290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427305 */     // MIs[0] round
     /*  427305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  427318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427324 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427337 */     GIR_RootConstrainSelectedInstOperands,
     /*  427338 */     // GIR_Coverage, 20692,
     /*  427338 */     GIR_EraseRootFromParent_Done,
     /*  427339 */   // Label 7477: @427339
     /*  427339 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(427410), // Rule ID 20693 //
     /*  427344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  427347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  427355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  427361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427376 */     // MIs[0] round
     /*  427376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  427389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427395 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427408 */     GIR_RootConstrainSelectedInstOperands,
     /*  427409 */     // GIR_Coverage, 20693,
     /*  427409 */     GIR_EraseRootFromParent_Done,
     /*  427410 */   // Label 7478: @427410
     /*  427410 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(427481), // Rule ID 20696 //
     /*  427415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  427418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  427426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  427432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427447 */     // MIs[0] round
     /*  427447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427466 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427479 */     GIR_RootConstrainSelectedInstOperands,
     /*  427480 */     // GIR_Coverage, 20696,
     /*  427480 */     GIR_EraseRootFromParent_Done,
     /*  427481 */   // Label 7479: @427481
     /*  427481 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(427552), // Rule ID 20697 //
     /*  427486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  427489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  427497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  427503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427518 */     // MIs[0] round
     /*  427518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427537 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427550 */     GIR_RootConstrainSelectedInstOperands,
     /*  427551 */     // GIR_Coverage, 20697,
     /*  427551 */     GIR_EraseRootFromParent_Done,
     /*  427552 */   // Label 7480: @427552
     /*  427552 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(427623), // Rule ID 20700 //
     /*  427557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  427560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  427568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  427574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427589 */     // MIs[0] round
     /*  427589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  427602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427608 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427621 */     GIR_RootConstrainSelectedInstOperands,
     /*  427622 */     // GIR_Coverage, 20700,
     /*  427622 */     GIR_EraseRootFromParent_Done,
     /*  427623 */   // Label 7481: @427623
     /*  427623 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(427694), // Rule ID 20701 //
     /*  427628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  427631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  427639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  427645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427660 */     // MIs[0] round
     /*  427660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  427673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427679 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427692 */     GIR_RootConstrainSelectedInstOperands,
     /*  427693 */     // GIR_Coverage, 20701,
     /*  427693 */     GIR_EraseRootFromParent_Done,
     /*  427694 */   // Label 7482: @427694
     /*  427694 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(427765), // Rule ID 20704 //
     /*  427699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  427702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  427710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  427713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  427716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427731 */     // MIs[0] round
     /*  427731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  427744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427750 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427763 */     GIR_RootConstrainSelectedInstOperands,
     /*  427764 */     // GIR_Coverage, 20704,
     /*  427764 */     GIR_EraseRootFromParent_Done,
     /*  427765 */   // Label 7483: @427765
     /*  427765 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(427836), // Rule ID 20705 //
     /*  427770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  427773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  427781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  427784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  427787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427802 */     // MIs[0] round
     /*  427802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  427815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427821 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427834 */     GIR_RootConstrainSelectedInstOperands,
     /*  427835 */     // GIR_Coverage, 20705,
     /*  427835 */     GIR_EraseRootFromParent_Done,
     /*  427836 */   // Label 7484: @427836
     /*  427836 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(427907), // Rule ID 20708 //
     /*  427841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  427844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  427852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  427855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  427858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427873 */     // MIs[0] round
     /*  427873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  427883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427892 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427905 */     GIR_RootConstrainSelectedInstOperands,
     /*  427906 */     // GIR_Coverage, 20708,
     /*  427906 */     GIR_EraseRootFromParent_Done,
     /*  427907 */   // Label 7485: @427907
     /*  427907 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(427978), // Rule ID 20709 //
     /*  427912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  427915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  427923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  427926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  427929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427944 */     // MIs[0] round
     /*  427944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  427947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  427954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  427957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  427963 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  427965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427976 */     GIR_RootConstrainSelectedInstOperands,
     /*  427977 */     // GIR_Coverage, 20709,
     /*  427977 */     GIR_EraseRootFromParent_Done,
     /*  427978 */   // Label 7486: @427978
     /*  427978 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(428049), // Rule ID 20712 //
     /*  427983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  427986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  427991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  427994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  427997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  428000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428015 */     // MIs[0] round
     /*  428015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428025 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  428025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  428028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428034 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428047 */     GIR_RootConstrainSelectedInstOperands,
     /*  428048 */     // GIR_Coverage, 20712,
     /*  428048 */     GIR_EraseRootFromParent_Done,
     /*  428049 */   // Label 7487: @428049
     /*  428049 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(428120), // Rule ID 20713 //
     /*  428054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  428057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  428062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  428065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  428068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  428071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428086 */     // MIs[0] round
     /*  428086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  428099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428105 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428118 */     GIR_RootConstrainSelectedInstOperands,
     /*  428119 */     // GIR_Coverage, 20713,
     /*  428119 */     GIR_EraseRootFromParent_Done,
     /*  428120 */   // Label 7488: @428120
     /*  428120 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(428191), // Rule ID 20716 //
     /*  428125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  428128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  428133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  428136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  428142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428157 */     // MIs[0] round
     /*  428157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428167 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  428167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  428170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428176 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428189 */     GIR_RootConstrainSelectedInstOperands,
     /*  428190 */     // GIR_Coverage, 20716,
     /*  428190 */     GIR_EraseRootFromParent_Done,
     /*  428191 */   // Label 7489: @428191
     /*  428191 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(428262), // Rule ID 20717 //
     /*  428196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  428199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  428204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  428207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  428213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428228 */     // MIs[0] round
     /*  428228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  428241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428247 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428260 */     GIR_RootConstrainSelectedInstOperands,
     /*  428261 */     // GIR_Coverage, 20717,
     /*  428261 */     GIR_EraseRootFromParent_Done,
     /*  428262 */   // Label 7490: @428262
     /*  428262 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(428333), // Rule ID 20840 //
     /*  428267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  428270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  428278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  428281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  428284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428299 */     // MIs[0] round
     /*  428299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428309 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  428312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428318 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428331 */     GIR_RootConstrainSelectedInstOperands,
     /*  428332 */     // GIR_Coverage, 20840,
     /*  428332 */     GIR_EraseRootFromParent_Done,
     /*  428333 */   // Label 7491: @428333
     /*  428333 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(428404), // Rule ID 20841 //
     /*  428338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  428341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  428349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  428352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  428355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428370 */     // MIs[0] round
     /*  428370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  428383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428389 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428402 */     GIR_RootConstrainSelectedInstOperands,
     /*  428403 */     // GIR_Coverage, 20841,
     /*  428403 */     GIR_EraseRootFromParent_Done,
     /*  428404 */   // Label 7492: @428404
     /*  428404 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(428475), // Rule ID 20844 //
     /*  428409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  428412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  428420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  428423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  428426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428441 */     // MIs[0] round
     /*  428441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428451 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  428454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428460 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428473 */     GIR_RootConstrainSelectedInstOperands,
     /*  428474 */     // GIR_Coverage, 20844,
     /*  428474 */     GIR_EraseRootFromParent_Done,
     /*  428475 */   // Label 7493: @428475
     /*  428475 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(428546), // Rule ID 20845 //
     /*  428480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  428483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  428491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  428494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  428497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428512 */     // MIs[0] round
     /*  428512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428522 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  428525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428531 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428544 */     GIR_RootConstrainSelectedInstOperands,
     /*  428545 */     // GIR_Coverage, 20845,
     /*  428545 */     GIR_EraseRootFromParent_Done,
     /*  428546 */   // Label 7494: @428546
     /*  428546 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(428617), // Rule ID 20848 //
     /*  428551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  428554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428583 */     // MIs[0] round
     /*  428583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428593 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  428596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428602 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428615 */     GIR_RootConstrainSelectedInstOperands,
     /*  428616 */     // GIR_Coverage, 20848,
     /*  428616 */     GIR_EraseRootFromParent_Done,
     /*  428617 */   // Label 7495: @428617
     /*  428617 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(428688), // Rule ID 20849 //
     /*  428622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  428625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428654 */     // MIs[0] round
     /*  428654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  428667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428673 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428686 */     GIR_RootConstrainSelectedInstOperands,
     /*  428687 */     // GIR_Coverage, 20849,
     /*  428687 */     GIR_EraseRootFromParent_Done,
     /*  428688 */   // Label 7496: @428688
     /*  428688 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(428759), // Rule ID 20852 //
     /*  428693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  428696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428725 */     // MIs[0] round
     /*  428725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428735 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  428738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428744 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428757 */     GIR_RootConstrainSelectedInstOperands,
     /*  428758 */     // GIR_Coverage, 20852,
     /*  428758 */     GIR_EraseRootFromParent_Done,
     /*  428759 */   // Label 7497: @428759
     /*  428759 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(428830), // Rule ID 20853 //
     /*  428764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  428767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428796 */     // MIs[0] round
     /*  428796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428806 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  428809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428815 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428828 */     GIR_RootConstrainSelectedInstOperands,
     /*  428829 */     // GIR_Coverage, 20853,
     /*  428829 */     GIR_EraseRootFromParent_Done,
     /*  428830 */   // Label 7498: @428830
     /*  428830 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(428901), // Rule ID 20856 //
     /*  428835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  428838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428867 */     // MIs[0] round
     /*  428867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428877 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  428880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428886 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428899 */     GIR_RootConstrainSelectedInstOperands,
     /*  428900 */     // GIR_Coverage, 20856,
     /*  428900 */     GIR_EraseRootFromParent_Done,
     /*  428901 */   // Label 7499: @428901
     /*  428901 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(428972), // Rule ID 20857 //
     /*  428906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  428909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428938 */     // MIs[0] round
     /*  428938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  428951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  428957 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  428959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428970 */     GIR_RootConstrainSelectedInstOperands,
     /*  428971 */     // GIR_Coverage, 20857,
     /*  428971 */     GIR_EraseRootFromParent_Done,
     /*  428972 */   // Label 7500: @428972
     /*  428972 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(429043), // Rule ID 20860 //
     /*  428977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  428980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  428985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  428988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  428991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429009 */     // MIs[0] round
     /*  429009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  429022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429028 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429041 */     GIR_RootConstrainSelectedInstOperands,
     /*  429042 */     // GIR_Coverage, 20860,
     /*  429042 */     GIR_EraseRootFromParent_Done,
     /*  429043 */   // Label 7501: @429043
     /*  429043 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(429114), // Rule ID 20861 //
     /*  429048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  429051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  429059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  429062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  429065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429080 */     // MIs[0] round
     /*  429080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  429093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429099 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429112 */     GIR_RootConstrainSelectedInstOperands,
     /*  429113 */     // GIR_Coverage, 20861,
     /*  429113 */     GIR_EraseRootFromParent_Done,
     /*  429114 */   // Label 7502: @429114
     /*  429114 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(429185), // Rule ID 20864 //
     /*  429119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  429122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429151 */     // MIs[0] round
     /*  429151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429161 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  429164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429170 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429183 */     GIR_RootConstrainSelectedInstOperands,
     /*  429184 */     // GIR_Coverage, 20864,
     /*  429184 */     GIR_EraseRootFromParent_Done,
     /*  429185 */   // Label 7503: @429185
     /*  429185 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(429256), // Rule ID 20865 //
     /*  429190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  429193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429222 */     // MIs[0] round
     /*  429222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  429235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429241 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429254 */     GIR_RootConstrainSelectedInstOperands,
     /*  429255 */     // GIR_Coverage, 20865,
     /*  429255 */     GIR_EraseRootFromParent_Done,
     /*  429256 */   // Label 7504: @429256
     /*  429256 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(429327), // Rule ID 20868 //
     /*  429261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  429264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429293 */     // MIs[0] round
     /*  429293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429303 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  429306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429312 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429325 */     GIR_RootConstrainSelectedInstOperands,
     /*  429326 */     // GIR_Coverage, 20868,
     /*  429326 */     GIR_EraseRootFromParent_Done,
     /*  429327 */   // Label 7505: @429327
     /*  429327 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(429398), // Rule ID 20869 //
     /*  429332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  429335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429364 */     // MIs[0] round
     /*  429364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429374 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  429377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429383 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429396 */     GIR_RootConstrainSelectedInstOperands,
     /*  429397 */     // GIR_Coverage, 20869,
     /*  429397 */     GIR_EraseRootFromParent_Done,
     /*  429398 */   // Label 7506: @429398
     /*  429398 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(429469), // Rule ID 20872 //
     /*  429403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  429406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429435 */     // MIs[0] round
     /*  429435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429445 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  429448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429454 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429467 */     GIR_RootConstrainSelectedInstOperands,
     /*  429468 */     // GIR_Coverage, 20872,
     /*  429468 */     GIR_EraseRootFromParent_Done,
     /*  429469 */   // Label 7507: @429469
     /*  429469 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(429540), // Rule ID 20873 //
     /*  429474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  429477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429506 */     // MIs[0] round
     /*  429506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  429519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429525 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429538 */     GIR_RootConstrainSelectedInstOperands,
     /*  429539 */     // GIR_Coverage, 20873,
     /*  429539 */     GIR_EraseRootFromParent_Done,
     /*  429540 */   // Label 7508: @429540
     /*  429540 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(429611), // Rule ID 20876 //
     /*  429545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  429548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429577 */     // MIs[0] round
     /*  429577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429587 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  429590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429596 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429609 */     GIR_RootConstrainSelectedInstOperands,
     /*  429610 */     // GIR_Coverage, 20876,
     /*  429610 */     GIR_EraseRootFromParent_Done,
     /*  429611 */   // Label 7509: @429611
     /*  429611 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(429682), // Rule ID 20877 //
     /*  429616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  429619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429648 */     // MIs[0] round
     /*  429648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  429661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429667 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429680 */     GIR_RootConstrainSelectedInstOperands,
     /*  429681 */     // GIR_Coverage, 20877,
     /*  429681 */     GIR_EraseRootFromParent_Done,
     /*  429682 */   // Label 7510: @429682
     /*  429682 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(429753), // Rule ID 20880 //
     /*  429687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  429690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429719 */     // MIs[0] round
     /*  429719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429729 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  429732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429738 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429751 */     GIR_RootConstrainSelectedInstOperands,
     /*  429752 */     // GIR_Coverage, 20880,
     /*  429752 */     GIR_EraseRootFromParent_Done,
     /*  429753 */   // Label 7511: @429753
     /*  429753 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(429824), // Rule ID 20881 //
     /*  429758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  429761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429790 */     // MIs[0] round
     /*  429790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429800 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  429803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429809 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429822 */     GIR_RootConstrainSelectedInstOperands,
     /*  429823 */     // GIR_Coverage, 20881,
     /*  429823 */     GIR_EraseRootFromParent_Done,
     /*  429824 */   // Label 7512: @429824
     /*  429824 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(429895), // Rule ID 20884 //
     /*  429829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  429832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429861 */     // MIs[0] round
     /*  429861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429871 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  429874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429880 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429893 */     GIR_RootConstrainSelectedInstOperands,
     /*  429894 */     // GIR_Coverage, 20884,
     /*  429894 */     GIR_EraseRootFromParent_Done,
     /*  429895 */   // Label 7513: @429895
     /*  429895 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(429966), // Rule ID 20885 //
     /*  429900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  429903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429932 */     // MIs[0] round
     /*  429932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  429945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  429951 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  429953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429964 */     GIR_RootConstrainSelectedInstOperands,
     /*  429965 */     // GIR_Coverage, 20885,
     /*  429965 */     GIR_EraseRootFromParent_Done,
     /*  429966 */   // Label 7514: @429966
     /*  429966 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(430037), // Rule ID 20888 //
     /*  429971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  429974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  429979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430003 */     // MIs[0] round
     /*  430003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  430016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430022 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430035 */     GIR_RootConstrainSelectedInstOperands,
     /*  430036 */     // GIR_Coverage, 20888,
     /*  430036 */     GIR_EraseRootFromParent_Done,
     /*  430037 */   // Label 7515: @430037
     /*  430037 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(430108), // Rule ID 20889 //
     /*  430042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  430045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  430050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  430053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  430056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  430059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430074 */     // MIs[0] round
     /*  430074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430084 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  430087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430093 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430106 */     GIR_RootConstrainSelectedInstOperands,
     /*  430107 */     // GIR_Coverage, 20889,
     /*  430107 */     GIR_EraseRootFromParent_Done,
     /*  430108 */   // Label 7516: @430108
     /*  430108 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(430179), // Rule ID 20892 //
     /*  430113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  430116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  430121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430145 */     // MIs[0] round
     /*  430145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430155 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  430158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430164 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430177 */     GIR_RootConstrainSelectedInstOperands,
     /*  430178 */     // GIR_Coverage, 20892,
     /*  430178 */     GIR_EraseRootFromParent_Done,
     /*  430179 */   // Label 7517: @430179
     /*  430179 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(430250), // Rule ID 20893 //
     /*  430184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  430187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  430192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430216 */     // MIs[0] round
     /*  430216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430226 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  430229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430235 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430248 */     GIR_RootConstrainSelectedInstOperands,
     /*  430249 */     // GIR_Coverage, 20893,
     /*  430249 */     GIR_EraseRootFromParent_Done,
     /*  430250 */   // Label 7518: @430250
     /*  430250 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(430321), // Rule ID 20896 //
     /*  430255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  430258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  430263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430287 */     // MIs[0] round
     /*  430287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430297 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  430300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430306 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430319 */     GIR_RootConstrainSelectedInstOperands,
     /*  430320 */     // GIR_Coverage, 20896,
     /*  430320 */     GIR_EraseRootFromParent_Done,
     /*  430321 */   // Label 7519: @430321
     /*  430321 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(430392), // Rule ID 20897 //
     /*  430326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  430329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  430334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430358 */     // MIs[0] round
     /*  430358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430368 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  430371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430377 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430390 */     GIR_RootConstrainSelectedInstOperands,
     /*  430391 */     // GIR_Coverage, 20897,
     /*  430391 */     GIR_EraseRootFromParent_Done,
     /*  430392 */   // Label 7520: @430392
     /*  430392 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(430463), // Rule ID 20900 //
     /*  430397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  430400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430429 */     // MIs[0] round
     /*  430429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430439 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  430442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430448 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430461 */     GIR_RootConstrainSelectedInstOperands,
     /*  430462 */     // GIR_Coverage, 20900,
     /*  430462 */     GIR_EraseRootFromParent_Done,
     /*  430463 */   // Label 7521: @430463
     /*  430463 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(430534), // Rule ID 20901 //
     /*  430468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  430471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430500 */     // MIs[0] round
     /*  430500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430510 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  430513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430519 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430532 */     GIR_RootConstrainSelectedInstOperands,
     /*  430533 */     // GIR_Coverage, 20901,
     /*  430533 */     GIR_EraseRootFromParent_Done,
     /*  430534 */   // Label 7522: @430534
     /*  430534 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(430605), // Rule ID 20904 //
     /*  430539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  430542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430571 */     // MIs[0] round
     /*  430571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430581 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  430584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430590 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430603 */     GIR_RootConstrainSelectedInstOperands,
     /*  430604 */     // GIR_Coverage, 20904,
     /*  430604 */     GIR_EraseRootFromParent_Done,
     /*  430605 */   // Label 7523: @430605
     /*  430605 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(430676), // Rule ID 20905 //
     /*  430610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  430613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430642 */     // MIs[0] round
     /*  430642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430652 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  430655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430661 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430674 */     GIR_RootConstrainSelectedInstOperands,
     /*  430675 */     // GIR_Coverage, 20905,
     /*  430675 */     GIR_EraseRootFromParent_Done,
     /*  430676 */   // Label 7524: @430676
     /*  430676 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(430747), // Rule ID 20908 //
     /*  430681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  430684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  430692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  430695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  430698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430713 */     // MIs[0] round
     /*  430713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430723 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  430723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  430726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430732 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430745 */     GIR_RootConstrainSelectedInstOperands,
     /*  430746 */     // GIR_Coverage, 20908,
     /*  430746 */     GIR_EraseRootFromParent_Done,
     /*  430747 */   // Label 7525: @430747
     /*  430747 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(430818), // Rule ID 20909 //
     /*  430752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  430755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  430763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  430766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  430769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430784 */     // MIs[0] round
     /*  430784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430794 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  430797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430803 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430816 */     GIR_RootConstrainSelectedInstOperands,
     /*  430817 */     // GIR_Coverage, 20909,
     /*  430817 */     GIR_EraseRootFromParent_Done,
     /*  430818 */   // Label 7526: @430818
     /*  430818 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(430889), // Rule ID 20912 //
     /*  430823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  430826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  430834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  430837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  430840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430855 */     // MIs[0] round
     /*  430855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  430868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430874 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430887 */     GIR_RootConstrainSelectedInstOperands,
     /*  430888 */     // GIR_Coverage, 20912,
     /*  430888 */     GIR_EraseRootFromParent_Done,
     /*  430889 */   // Label 7527: @430889
     /*  430889 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(430960), // Rule ID 20913 //
     /*  430894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  430897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  430905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  430908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  430911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430926 */     // MIs[0] round
     /*  430926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430936 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  430939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  430945 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  430947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430958 */     GIR_RootConstrainSelectedInstOperands,
     /*  430959 */     // GIR_Coverage, 20913,
     /*  430959 */     GIR_EraseRootFromParent_Done,
     /*  430960 */   // Label 7528: @430960
     /*  430960 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(431031), // Rule ID 20916 //
     /*  430965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  430968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  430973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  430976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  430979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  430982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430997 */     // MIs[0] round
     /*  430997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431007 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  431010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431016 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431029 */     GIR_RootConstrainSelectedInstOperands,
     /*  431030 */     // GIR_Coverage, 20916,
     /*  431030 */     GIR_EraseRootFromParent_Done,
     /*  431031 */   // Label 7529: @431031
     /*  431031 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(431102), // Rule ID 20917 //
     /*  431036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  431039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431068 */     // MIs[0] round
     /*  431068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  431081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431087 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431100 */     GIR_RootConstrainSelectedInstOperands,
     /*  431101 */     // GIR_Coverage, 20917,
     /*  431101 */     GIR_EraseRootFromParent_Done,
     /*  431102 */   // Label 7530: @431102
     /*  431102 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(431173), // Rule ID 20920 //
     /*  431107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  431110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431139 */     // MIs[0] round
     /*  431139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431149 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  431152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431158 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431171 */     GIR_RootConstrainSelectedInstOperands,
     /*  431172 */     // GIR_Coverage, 20920,
     /*  431172 */     GIR_EraseRootFromParent_Done,
     /*  431173 */   // Label 7531: @431173
     /*  431173 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(431244), // Rule ID 20921 //
     /*  431178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  431181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431210 */     // MIs[0] round
     /*  431210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431220 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  431223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431229 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431242 */     GIR_RootConstrainSelectedInstOperands,
     /*  431243 */     // GIR_Coverage, 20921,
     /*  431243 */     GIR_EraseRootFromParent_Done,
     /*  431244 */   // Label 7532: @431244
     /*  431244 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(431315), // Rule ID 20924 //
     /*  431249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  431252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  431260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  431263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  431266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431281 */     // MIs[0] round
     /*  431281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431291 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  431294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431300 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431313 */     GIR_RootConstrainSelectedInstOperands,
     /*  431314 */     // GIR_Coverage, 20924,
     /*  431314 */     GIR_EraseRootFromParent_Done,
     /*  431315 */   // Label 7533: @431315
     /*  431315 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(431386), // Rule ID 20925 //
     /*  431320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  431323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  431331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  431334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  431337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431352 */     // MIs[0] round
     /*  431352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  431365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431371 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431384 */     GIR_RootConstrainSelectedInstOperands,
     /*  431385 */     // GIR_Coverage, 20925,
     /*  431385 */     GIR_EraseRootFromParent_Done,
     /*  431386 */   // Label 7534: @431386
     /*  431386 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(431457), // Rule ID 20928 //
     /*  431391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  431394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  431402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  431405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  431408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431423 */     // MIs[0] round
     /*  431423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  431436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431442 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431455 */     GIR_RootConstrainSelectedInstOperands,
     /*  431456 */     // GIR_Coverage, 20928,
     /*  431456 */     GIR_EraseRootFromParent_Done,
     /*  431457 */   // Label 7535: @431457
     /*  431457 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(431528), // Rule ID 20929 //
     /*  431462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  431465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  431473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  431476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  431479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431494 */     // MIs[0] round
     /*  431494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431504 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  431507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431513 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431526 */     GIR_RootConstrainSelectedInstOperands,
     /*  431527 */     // GIR_Coverage, 20929,
     /*  431527 */     GIR_EraseRootFromParent_Done,
     /*  431528 */   // Label 7536: @431528
     /*  431528 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(431599), // Rule ID 20932 //
     /*  431533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  431536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  431544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  431547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  431550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431565 */     // MIs[0] round
     /*  431565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431575 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  431578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431584 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431597 */     GIR_RootConstrainSelectedInstOperands,
     /*  431598 */     // GIR_Coverage, 20932,
     /*  431598 */     GIR_EraseRootFromParent_Done,
     /*  431599 */   // Label 7537: @431599
     /*  431599 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(431670), // Rule ID 20933 //
     /*  431604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  431607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  431615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  431618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  431621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431636 */     // MIs[0] round
     /*  431636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431646 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  431649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431655 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431668 */     GIR_RootConstrainSelectedInstOperands,
     /*  431669 */     // GIR_Coverage, 20933,
     /*  431669 */     GIR_EraseRootFromParent_Done,
     /*  431670 */   // Label 7538: @431670
     /*  431670 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(431741), // Rule ID 20936 //
     /*  431675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  431678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  431686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  431689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  431692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431707 */     // MIs[0] round
     /*  431707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431717 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  431720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431726 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431739 */     GIR_RootConstrainSelectedInstOperands,
     /*  431740 */     // GIR_Coverage, 20936,
     /*  431740 */     GIR_EraseRootFromParent_Done,
     /*  431741 */   // Label 7539: @431741
     /*  431741 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(431812), // Rule ID 20937 //
     /*  431746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  431749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  431757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  431760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  431763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431778 */     // MIs[0] round
     /*  431778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431788 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  431791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431797 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431810 */     GIR_RootConstrainSelectedInstOperands,
     /*  431811 */     // GIR_Coverage, 20937,
     /*  431811 */     GIR_EraseRootFromParent_Done,
     /*  431812 */   // Label 7540: @431812
     /*  431812 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(431883), // Rule ID 20940 //
     /*  431817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  431820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  431828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  431831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  431834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431849 */     // MIs[0] round
     /*  431849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431859 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  431862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431868 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431881 */     GIR_RootConstrainSelectedInstOperands,
     /*  431882 */     // GIR_Coverage, 20940,
     /*  431882 */     GIR_EraseRootFromParent_Done,
     /*  431883 */   // Label 7541: @431883
     /*  431883 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(431954), // Rule ID 20941 //
     /*  431888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  431891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  431899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  431902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  431905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431920 */     // MIs[0] round
     /*  431920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  431933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  431939 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  431941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431952 */     GIR_RootConstrainSelectedInstOperands,
     /*  431953 */     // GIR_Coverage, 20941,
     /*  431953 */     GIR_EraseRootFromParent_Done,
     /*  431954 */   // Label 7542: @431954
     /*  431954 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(432025), // Rule ID 20944 //
     /*  431959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  431962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  431967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  431970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  431973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  431976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431991 */     // MIs[0] round
     /*  431991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  431994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432001 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  432004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432010 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432023 */     GIR_RootConstrainSelectedInstOperands,
     /*  432024 */     // GIR_Coverage, 20944,
     /*  432024 */     GIR_EraseRootFromParent_Done,
     /*  432025 */   // Label 7543: @432025
     /*  432025 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(432096), // Rule ID 20945 //
     /*  432030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  432033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  432041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  432044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  432047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432062 */     // MIs[0] round
     /*  432062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432072 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  432075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432081 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432094 */     GIR_RootConstrainSelectedInstOperands,
     /*  432095 */     // GIR_Coverage, 20945,
     /*  432095 */     GIR_EraseRootFromParent_Done,
     /*  432096 */   // Label 7544: @432096
     /*  432096 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(432167), // Rule ID 20948 //
     /*  432101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  432104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  432112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  432115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  432118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432133 */     // MIs[0] round
     /*  432133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432143 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  432146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432152 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432165 */     GIR_RootConstrainSelectedInstOperands,
     /*  432166 */     // GIR_Coverage, 20948,
     /*  432166 */     GIR_EraseRootFromParent_Done,
     /*  432167 */   // Label 7545: @432167
     /*  432167 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(432238), // Rule ID 20949 //
     /*  432172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  432175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  432183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  432186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  432189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432204 */     // MIs[0] round
     /*  432204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432214 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  432214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  432217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432223 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432236 */     GIR_RootConstrainSelectedInstOperands,
     /*  432237 */     // GIR_Coverage, 20949,
     /*  432237 */     GIR_EraseRootFromParent_Done,
     /*  432238 */   // Label 7546: @432238
     /*  432238 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(432309), // Rule ID 20952 //
     /*  432243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  432246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  432254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  432257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  432260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432275 */     // MIs[0] round
     /*  432275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432285 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  432288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432294 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432307 */     GIR_RootConstrainSelectedInstOperands,
     /*  432308 */     // GIR_Coverage, 20952,
     /*  432308 */     GIR_EraseRootFromParent_Done,
     /*  432309 */   // Label 7547: @432309
     /*  432309 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(432380), // Rule ID 20953 //
     /*  432314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  432317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  432325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  432328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  432331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432346 */     // MIs[0] round
     /*  432346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  432356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  432359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432365 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432378 */     GIR_RootConstrainSelectedInstOperands,
     /*  432379 */     // GIR_Coverage, 20953,
     /*  432379 */     GIR_EraseRootFromParent_Done,
     /*  432380 */   // Label 7548: @432380
     /*  432380 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(432451), // Rule ID 20956 //
     /*  432385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  432388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  432396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  432399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  432402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432417 */     // MIs[0] round
     /*  432417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432427 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  432430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432436 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432449 */     GIR_RootConstrainSelectedInstOperands,
     /*  432450 */     // GIR_Coverage, 20956,
     /*  432450 */     GIR_EraseRootFromParent_Done,
     /*  432451 */   // Label 7549: @432451
     /*  432451 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(432522), // Rule ID 20957 //
     /*  432456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  432459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  432464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  432467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  432470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  432473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432488 */     // MIs[0] round
     /*  432488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  432498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  432501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432507 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432520 */     GIR_RootConstrainSelectedInstOperands,
     /*  432521 */     // GIR_Coverage, 20957,
     /*  432521 */     GIR_EraseRootFromParent_Done,
     /*  432522 */   // Label 7550: @432522
     /*  432522 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(432593), // Rule ID 21032 //
     /*  432527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  432530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  432538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  432541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  432544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432559 */     // MIs[0] round
     /*  432559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  432572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432578 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432591 */     GIR_RootConstrainSelectedInstOperands,
     /*  432592 */     // GIR_Coverage, 21032,
     /*  432592 */     GIR_EraseRootFromParent_Done,
     /*  432593 */   // Label 7551: @432593
     /*  432593 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(432664), // Rule ID 21033 //
     /*  432598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  432601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  432609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  432612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  432615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432630 */     // MIs[0] round
     /*  432630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  432643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432649 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432662 */     GIR_RootConstrainSelectedInstOperands,
     /*  432663 */     // GIR_Coverage, 21033,
     /*  432663 */     GIR_EraseRootFromParent_Done,
     /*  432664 */   // Label 7552: @432664
     /*  432664 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(432735), // Rule ID 21036 //
     /*  432669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  432672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  432686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432701 */     // MIs[0] round
     /*  432701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  432714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432720 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432733 */     GIR_RootConstrainSelectedInstOperands,
     /*  432734 */     // GIR_Coverage, 21036,
     /*  432734 */     GIR_EraseRootFromParent_Done,
     /*  432735 */   // Label 7553: @432735
     /*  432735 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(432806), // Rule ID 21037 //
     /*  432740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  432743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  432757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432772 */     // MIs[0] round
     /*  432772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10986:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  432785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432791 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432804 */     GIR_RootConstrainSelectedInstOperands,
     /*  432805 */     // GIR_Coverage, 21037,
     /*  432805 */     GIR_EraseRootFromParent_Done,
     /*  432806 */   // Label 7554: @432806
     /*  432806 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(432877), // Rule ID 21040 //
     /*  432811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  432814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  432828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432843 */     // MIs[0] round
     /*  432843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  432856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432862 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432875 */     GIR_RootConstrainSelectedInstOperands,
     /*  432876 */     // GIR_Coverage, 21040,
     /*  432876 */     GIR_EraseRootFromParent_Done,
     /*  432877 */   // Label 7555: @432877
     /*  432877 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(432948), // Rule ID 21041 //
     /*  432882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  432885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  432899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432914 */     // MIs[0] round
     /*  432914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  432927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  432933 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  432935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432946 */     GIR_RootConstrainSelectedInstOperands,
     /*  432947 */     // GIR_Coverage, 21041,
     /*  432947 */     GIR_EraseRootFromParent_Done,
     /*  432948 */   // Label 7556: @432948
     /*  432948 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(433019), // Rule ID 21044 //
     /*  432953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  432956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  432961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  432964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  432967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432985 */     // MIs[0] round
     /*  432985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  432988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432995 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  432998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433004 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433017 */     GIR_RootConstrainSelectedInstOperands,
     /*  433018 */     // GIR_Coverage, 21044,
     /*  433018 */     GIR_EraseRootFromParent_Done,
     /*  433019 */   // Label 7557: @433019
     /*  433019 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(433090), // Rule ID 21045 //
     /*  433024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  433027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  433041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433056 */     // MIs[0] round
     /*  433056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  433069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433075 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433088 */     GIR_RootConstrainSelectedInstOperands,
     /*  433089 */     // GIR_Coverage, 21045,
     /*  433089 */     GIR_EraseRootFromParent_Done,
     /*  433090 */   // Label 7558: @433090
     /*  433090 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(433161), // Rule ID 21048 //
     /*  433095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  433098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433127 */     // MIs[0] round
     /*  433127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  433140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433146 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433159 */     GIR_RootConstrainSelectedInstOperands,
     /*  433160 */     // GIR_Coverage, 21048,
     /*  433160 */     GIR_EraseRootFromParent_Done,
     /*  433161 */   // Label 7559: @433161
     /*  433161 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(433232), // Rule ID 21049 //
     /*  433166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  433169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433198 */     // MIs[0] round
     /*  433198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  433211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433217 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433230 */     GIR_RootConstrainSelectedInstOperands,
     /*  433231 */     // GIR_Coverage, 21049,
     /*  433231 */     GIR_EraseRootFromParent_Done,
     /*  433232 */   // Label 7560: @433232
     /*  433232 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(433303), // Rule ID 21052 //
     /*  433237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  433240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  433248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  433251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  433254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433269 */     // MIs[0] round
     /*  433269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433279 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  433282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433288 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433301 */     GIR_RootConstrainSelectedInstOperands,
     /*  433302 */     // GIR_Coverage, 21052,
     /*  433302 */     GIR_EraseRootFromParent_Done,
     /*  433303 */   // Label 7561: @433303
     /*  433303 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(433374), // Rule ID 21053 //
     /*  433308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  433311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  433319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  433322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  433325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433340 */     // MIs[0] round
     /*  433340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10986:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  433353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433359 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433372 */     GIR_RootConstrainSelectedInstOperands,
     /*  433373 */     // GIR_Coverage, 21053,
     /*  433373 */     GIR_EraseRootFromParent_Done,
     /*  433374 */   // Label 7562: @433374
     /*  433374 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(433445), // Rule ID 21056 //
     /*  433379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  433382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  433396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433411 */     // MIs[0] round
     /*  433411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  433424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433430 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433443 */     GIR_RootConstrainSelectedInstOperands,
     /*  433444 */     // GIR_Coverage, 21056,
     /*  433444 */     GIR_EraseRootFromParent_Done,
     /*  433445 */   // Label 7563: @433445
     /*  433445 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(433516), // Rule ID 21057 //
     /*  433450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  433453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  433467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433482 */     // MIs[0] round
     /*  433482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10986:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  433495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433501 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433514 */     GIR_RootConstrainSelectedInstOperands,
     /*  433515 */     // GIR_Coverage, 21057,
     /*  433515 */     GIR_EraseRootFromParent_Done,
     /*  433516 */   // Label 7564: @433516
     /*  433516 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(433587), // Rule ID 21060 //
     /*  433521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  433524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433553 */     // MIs[0] round
     /*  433553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  433566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433572 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433585 */     GIR_RootConstrainSelectedInstOperands,
     /*  433586 */     // GIR_Coverage, 21060,
     /*  433586 */     GIR_EraseRootFromParent_Done,
     /*  433587 */   // Label 7565: @433587
     /*  433587 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(433658), // Rule ID 21061 //
     /*  433592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  433595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433624 */     // MIs[0] round
     /*  433624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10986:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  433637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433643 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433656 */     GIR_RootConstrainSelectedInstOperands,
     /*  433657 */     // GIR_Coverage, 21061,
     /*  433657 */     GIR_EraseRootFromParent_Done,
     /*  433658 */   // Label 7566: @433658
     /*  433658 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(433729), // Rule ID 21064 //
     /*  433663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  433666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433695 */     // MIs[0] round
     /*  433695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433705 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  433708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433714 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433727 */     GIR_RootConstrainSelectedInstOperands,
     /*  433728 */     // GIR_Coverage, 21064,
     /*  433728 */     GIR_EraseRootFromParent_Done,
     /*  433729 */   // Label 7567: @433729
     /*  433729 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(433800), // Rule ID 21065 //
     /*  433734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  433737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  433742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433766 */     // MIs[0] round
     /*  433766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10986:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  433779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433785 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433798 */     GIR_RootConstrainSelectedInstOperands,
     /*  433799 */     // GIR_Coverage, 21065,
     /*  433799 */     GIR_EraseRootFromParent_Done,
     /*  433800 */   // Label 7568: @433800
     /*  433800 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(433871), // Rule ID 21068 //
     /*  433805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  433808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  433813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  433816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  433819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  433822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433837 */     // MIs[0] round
     /*  433837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433847 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  433850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433856 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433869 */     GIR_RootConstrainSelectedInstOperands,
     /*  433870 */     // GIR_Coverage, 21068,
     /*  433870 */     GIR_EraseRootFromParent_Done,
     /*  433871 */   // Label 7569: @433871
     /*  433871 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(433942), // Rule ID 21069 //
     /*  433876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  433879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  433884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  433887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  433890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  433893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433908 */     // MIs[0] round
     /*  433908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  433921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433927 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  433929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433940 */     GIR_RootConstrainSelectedInstOperands,
     /*  433941 */     // GIR_Coverage, 21069,
     /*  433941 */     GIR_EraseRootFromParent_Done,
     /*  433942 */   // Label 7570: @433942
     /*  433942 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(434013), // Rule ID 21072 //
     /*  433947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  433950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  433955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  433958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  433961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  433964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433979 */     // MIs[0] round
     /*  433979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  433982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  433992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  433998 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434011 */     GIR_RootConstrainSelectedInstOperands,
     /*  434012 */     // GIR_Coverage, 21072,
     /*  434012 */     GIR_EraseRootFromParent_Done,
     /*  434013 */   // Label 7571: @434013
     /*  434013 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(434084), // Rule ID 21073 //
     /*  434018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  434021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  434029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  434032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434050 */     // MIs[0] round
     /*  434050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10984:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  434063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434069 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434082 */     GIR_RootConstrainSelectedInstOperands,
     /*  434083 */     // GIR_Coverage, 21073,
     /*  434083 */     GIR_EraseRootFromParent_Done,
     /*  434084 */   // Label 7572: @434084
     /*  434084 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(434155), // Rule ID 21076 //
     /*  434089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  434092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  434100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  434103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  434106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434121 */     // MIs[0] round
     /*  434121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  434134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434140 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434153 */     GIR_RootConstrainSelectedInstOperands,
     /*  434154 */     // GIR_Coverage, 21076,
     /*  434154 */     GIR_EraseRootFromParent_Done,
     /*  434155 */   // Label 7573: @434155
     /*  434155 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(434226), // Rule ID 21077 //
     /*  434160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  434163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  434171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  434174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  434177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434192 */     // MIs[0] round
     /*  434192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  434205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434211 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434224 */     GIR_RootConstrainSelectedInstOperands,
     /*  434225 */     // GIR_Coverage, 21077,
     /*  434225 */     GIR_EraseRootFromParent_Done,
     /*  434226 */   // Label 7574: @434226
     /*  434226 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(434297), // Rule ID 21080 //
     /*  434231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  434234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  434242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  434245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  434248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434263 */     // MIs[0] round
     /*  434263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434273 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  434276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434282 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434295 */     GIR_RootConstrainSelectedInstOperands,
     /*  434296 */     // GIR_Coverage, 21080,
     /*  434296 */     GIR_EraseRootFromParent_Done,
     /*  434297 */   // Label 7575: @434297
     /*  434297 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(434368), // Rule ID 21081 //
     /*  434302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  434305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  434313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  434316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  434319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434334 */     // MIs[0] round
     /*  434334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  434347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434353 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434366 */     GIR_RootConstrainSelectedInstOperands,
     /*  434367 */     // GIR_Coverage, 21081,
     /*  434367 */     GIR_EraseRootFromParent_Done,
     /*  434368 */   // Label 7576: @434368
     /*  434368 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(434439), // Rule ID 21084 //
     /*  434373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  434376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  434384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  434387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  434390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434405 */     // MIs[0] round
     /*  434405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434415 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  434418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434424 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434437 */     GIR_RootConstrainSelectedInstOperands,
     /*  434438 */     // GIR_Coverage, 21084,
     /*  434438 */     GIR_EraseRootFromParent_Done,
     /*  434439 */   // Label 7577: @434439
     /*  434439 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(434510), // Rule ID 21085 //
     /*  434444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  434447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  434455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  434458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  434461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434476 */     // MIs[0] round
     /*  434476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  434489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434495 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434508 */     GIR_RootConstrainSelectedInstOperands,
     /*  434509 */     // GIR_Coverage, 21085,
     /*  434509 */     GIR_EraseRootFromParent_Done,
     /*  434510 */   // Label 7578: @434510
     /*  434510 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(434581), // Rule ID 21088 //
     /*  434515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  434518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  434526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  434529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434547 */     // MIs[0] round
     /*  434547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  434560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434566 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434579 */     GIR_RootConstrainSelectedInstOperands,
     /*  434580 */     // GIR_Coverage, 21088,
     /*  434580 */     GIR_EraseRootFromParent_Done,
     /*  434581 */   // Label 7579: @434581
     /*  434581 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(434652), // Rule ID 21089 //
     /*  434586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  434589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  434597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  434600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434618 */     // MIs[0] round
     /*  434618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10984:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  434631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434637 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434650 */     GIR_RootConstrainSelectedInstOperands,
     /*  434651 */     // GIR_Coverage, 21089,
     /*  434651 */     GIR_EraseRootFromParent_Done,
     /*  434652 */   // Label 7580: @434652
     /*  434652 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(434723), // Rule ID 21092 //
     /*  434657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  434660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  434668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  434671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  434674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434689 */     // MIs[0] round
     /*  434689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  434702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434708 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434721 */     GIR_RootConstrainSelectedInstOperands,
     /*  434722 */     // GIR_Coverage, 21092,
     /*  434722 */     GIR_EraseRootFromParent_Done,
     /*  434723 */   // Label 7581: @434723
     /*  434723 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(434794), // Rule ID 21093 //
     /*  434728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  434731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  434739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  434742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  434745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434760 */     // MIs[0] round
     /*  434760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10984:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  434773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434779 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434792 */     GIR_RootConstrainSelectedInstOperands,
     /*  434793 */     // GIR_Coverage, 21093,
     /*  434793 */     GIR_EraseRootFromParent_Done,
     /*  434794 */   // Label 7582: @434794
     /*  434794 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(434865), // Rule ID 21096 //
     /*  434799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  434802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  434816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434831 */     // MIs[0] round
     /*  434831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  434844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434850 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434863 */     GIR_RootConstrainSelectedInstOperands,
     /*  434864 */     // GIR_Coverage, 21096,
     /*  434864 */     GIR_EraseRootFromParent_Done,
     /*  434865 */   // Label 7583: @434865
     /*  434865 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(434936), // Rule ID 21097 //
     /*  434870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  434873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  434887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434902 */     // MIs[0] round
     /*  434902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434912 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10984:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  434915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434921 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434934 */     GIR_RootConstrainSelectedInstOperands,
     /*  434935 */     // GIR_Coverage, 21097,
     /*  434935 */     GIR_EraseRootFromParent_Done,
     /*  434936 */   // Label 7584: @434936
     /*  434936 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(435007), // Rule ID 21100 //
     /*  434941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  434944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  434949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  434952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  434955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  434958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434973 */     // MIs[0] round
     /*  434973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  434976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  434986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  434992 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  434994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435005 */     GIR_RootConstrainSelectedInstOperands,
     /*  435006 */     // GIR_Coverage, 21100,
     /*  435006 */     GIR_EraseRootFromParent_Done,
     /*  435007 */   // Label 7585: @435007
     /*  435007 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(435078), // Rule ID 21101 //
     /*  435012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  435015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  435020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  435023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  435026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  435029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435044 */     // MIs[0] round
     /*  435044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10984:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  435057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435063 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435076 */     GIR_RootConstrainSelectedInstOperands,
     /*  435077 */     // GIR_Coverage, 21101,
     /*  435077 */     GIR_EraseRootFromParent_Done,
     /*  435078 */   // Label 7586: @435078
     /*  435078 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(435149), // Rule ID 21452 //
     /*  435083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  435094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  435097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  435100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435115 */     // MIs[0] round
     /*  435115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435125 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  435128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435134 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435147 */     GIR_RootConstrainSelectedInstOperands,
     /*  435148 */     // GIR_Coverage, 21452,
     /*  435148 */     GIR_EraseRootFromParent_Done,
     /*  435149 */   // Label 7587: @435149
     /*  435149 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(435220), // Rule ID 21453 //
     /*  435154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  435165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  435168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  435171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435186 */     // MIs[0] round
     /*  435186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  435199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435205 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435218 */     GIR_RootConstrainSelectedInstOperands,
     /*  435219 */     // GIR_Coverage, 21453,
     /*  435219 */     GIR_EraseRootFromParent_Done,
     /*  435220 */   // Label 7588: @435220
     /*  435220 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(435291), // Rule ID 21456 //
     /*  435225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  435236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  435239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435257 */     // MIs[0] round
     /*  435257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435267 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  435270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435276 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435289 */     GIR_RootConstrainSelectedInstOperands,
     /*  435290 */     // GIR_Coverage, 21456,
     /*  435290 */     GIR_EraseRootFromParent_Done,
     /*  435291 */   // Label 7589: @435291
     /*  435291 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(435362), // Rule ID 21457 //
     /*  435296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  435307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  435310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435328 */     // MIs[0] round
     /*  435328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  435341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435347 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435360 */     GIR_RootConstrainSelectedInstOperands,
     /*  435361 */     // GIR_Coverage, 21457,
     /*  435361 */     GIR_EraseRootFromParent_Done,
     /*  435362 */   // Label 7590: @435362
     /*  435362 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(435433), // Rule ID 21460 //
     /*  435367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  435378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  435381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435399 */     // MIs[0] round
     /*  435399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435409 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  435412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435418 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435431 */     GIR_RootConstrainSelectedInstOperands,
     /*  435432 */     // GIR_Coverage, 21460,
     /*  435432 */     GIR_EraseRootFromParent_Done,
     /*  435433 */   // Label 7591: @435433
     /*  435433 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(435504), // Rule ID 21461 //
     /*  435438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  435449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  435452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435470 */     // MIs[0] round
     /*  435470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  435483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435489 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435502 */     GIR_RootConstrainSelectedInstOperands,
     /*  435503 */     // GIR_Coverage, 21461,
     /*  435503 */     GIR_EraseRootFromParent_Done,
     /*  435504 */   // Label 7592: @435504
     /*  435504 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(435575), // Rule ID 21464 //
     /*  435509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  435526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435541 */     // MIs[0] round
     /*  435541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435551 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  435554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435560 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435573 */     GIR_RootConstrainSelectedInstOperands,
     /*  435574 */     // GIR_Coverage, 21464,
     /*  435574 */     GIR_EraseRootFromParent_Done,
     /*  435575 */   // Label 7593: @435575
     /*  435575 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(435646), // Rule ID 21465 //
     /*  435580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  435597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435612 */     // MIs[0] round
     /*  435612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  435625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435631 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435644 */     GIR_RootConstrainSelectedInstOperands,
     /*  435645 */     // GIR_Coverage, 21465,
     /*  435645 */     GIR_EraseRootFromParent_Done,
     /*  435646 */   // Label 7594: @435646
     /*  435646 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(435717), // Rule ID 21468 //
     /*  435651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  435668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435683 */     // MIs[0] round
     /*  435683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  435696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435702 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435715 */     GIR_RootConstrainSelectedInstOperands,
     /*  435716 */     // GIR_Coverage, 21468,
     /*  435716 */     GIR_EraseRootFromParent_Done,
     /*  435717 */   // Label 7595: @435717
     /*  435717 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(435788), // Rule ID 21469 //
     /*  435722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  435739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435754 */     // MIs[0] round
     /*  435754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  435767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435773 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435786 */     GIR_RootConstrainSelectedInstOperands,
     /*  435787 */     // GIR_Coverage, 21469,
     /*  435787 */     GIR_EraseRootFromParent_Done,
     /*  435788 */   // Label 7596: @435788
     /*  435788 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(435859), // Rule ID 21472 //
     /*  435793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  435796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  435810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435825 */     // MIs[0] round
     /*  435825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435835 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  435838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435844 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435857 */     GIR_RootConstrainSelectedInstOperands,
     /*  435858 */     // GIR_Coverage, 21472,
     /*  435858 */     GIR_EraseRootFromParent_Done,
     /*  435859 */   // Label 7597: @435859
     /*  435859 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(435930), // Rule ID 21473 //
     /*  435864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  435867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  435881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435896 */     // MIs[0] round
     /*  435896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435906 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  435909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435915 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435928 */     GIR_RootConstrainSelectedInstOperands,
     /*  435929 */     // GIR_Coverage, 21473,
     /*  435929 */     GIR_EraseRootFromParent_Done,
     /*  435930 */   // Label 7598: @435930
     /*  435930 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(436001), // Rule ID 21476 //
     /*  435935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  435938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  435943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  435946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  435949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  435952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435967 */     // MIs[0] round
     /*  435967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  435970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  435980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  435986 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  435988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435999 */     GIR_RootConstrainSelectedInstOperands,
     /*  436000 */     // GIR_Coverage, 21476,
     /*  436000 */     GIR_EraseRootFromParent_Done,
     /*  436001 */   // Label 7599: @436001
     /*  436001 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(436072), // Rule ID 21477 //
     /*  436006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  436009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  436017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  436020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  436023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436038 */     // MIs[0] round
     /*  436038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436048 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  436051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436057 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436070 */     GIR_RootConstrainSelectedInstOperands,
     /*  436071 */     // GIR_Coverage, 21477,
     /*  436071 */     GIR_EraseRootFromParent_Done,
     /*  436072 */   // Label 7600: @436072
     /*  436072 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(436143), // Rule ID 21480 //
     /*  436077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  436080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  436088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  436091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  436094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436109 */     // MIs[0] round
     /*  436109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  436122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436128 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436141 */     GIR_RootConstrainSelectedInstOperands,
     /*  436142 */     // GIR_Coverage, 21480,
     /*  436142 */     GIR_EraseRootFromParent_Done,
     /*  436143 */   // Label 7601: @436143
     /*  436143 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(436214), // Rule ID 21481 //
     /*  436148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  436151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  436159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  436162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  436165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436180 */     // MIs[0] round
     /*  436180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  436193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436199 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436212 */     GIR_RootConstrainSelectedInstOperands,
     /*  436213 */     // GIR_Coverage, 21481,
     /*  436213 */     GIR_EraseRootFromParent_Done,
     /*  436214 */   // Label 7602: @436214
     /*  436214 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(436285), // Rule ID 21484 //
     /*  436219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  436222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  436230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  436233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436251 */     // MIs[0] round
     /*  436251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  436264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436270 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436283 */     GIR_RootConstrainSelectedInstOperands,
     /*  436284 */     // GIR_Coverage, 21484,
     /*  436284 */     GIR_EraseRootFromParent_Done,
     /*  436285 */   // Label 7603: @436285
     /*  436285 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(436356), // Rule ID 21485 //
     /*  436290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  436293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  436301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  436304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436322 */     // MIs[0] round
     /*  436322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  436335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436341 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436354 */     GIR_RootConstrainSelectedInstOperands,
     /*  436355 */     // GIR_Coverage, 21485,
     /*  436355 */     GIR_EraseRootFromParent_Done,
     /*  436356 */   // Label 7604: @436356
     /*  436356 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(436427), // Rule ID 21488 //
     /*  436361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  436364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436393 */     // MIs[0] round
     /*  436393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  436406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436412 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436425 */     GIR_RootConstrainSelectedInstOperands,
     /*  436426 */     // GIR_Coverage, 21488,
     /*  436426 */     GIR_EraseRootFromParent_Done,
     /*  436427 */   // Label 7605: @436427
     /*  436427 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(436498), // Rule ID 21489 //
     /*  436432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  436435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436464 */     // MIs[0] round
     /*  436464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  436477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436483 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436496 */     GIR_RootConstrainSelectedInstOperands,
     /*  436497 */     // GIR_Coverage, 21489,
     /*  436497 */     GIR_EraseRootFromParent_Done,
     /*  436498 */   // Label 7606: @436498
     /*  436498 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(436569), // Rule ID 21492 //
     /*  436503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  436506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  436520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436535 */     // MIs[0] round
     /*  436535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436545 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  436548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436554 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436567 */     GIR_RootConstrainSelectedInstOperands,
     /*  436568 */     // GIR_Coverage, 21492,
     /*  436568 */     GIR_EraseRootFromParent_Done,
     /*  436569 */   // Label 7607: @436569
     /*  436569 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(436640), // Rule ID 21493 //
     /*  436574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  436577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  436591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436606 */     // MIs[0] round
     /*  436606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  436619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436625 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436638 */     GIR_RootConstrainSelectedInstOperands,
     /*  436639 */     // GIR_Coverage, 21493,
     /*  436639 */     GIR_EraseRootFromParent_Done,
     /*  436640 */   // Label 7608: @436640
     /*  436640 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(436711), // Rule ID 21496 //
     /*  436645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  436648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  436656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  436659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  436662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436677 */     // MIs[0] round
     /*  436677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436687 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  436690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436696 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436709 */     GIR_RootConstrainSelectedInstOperands,
     /*  436710 */     // GIR_Coverage, 21496,
     /*  436710 */     GIR_EraseRootFromParent_Done,
     /*  436711 */   // Label 7609: @436711
     /*  436711 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(436782), // Rule ID 21497 //
     /*  436716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  436719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  436727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  436730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  436733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436748 */     // MIs[0] round
     /*  436748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  436761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436767 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436780 */     GIR_RootConstrainSelectedInstOperands,
     /*  436781 */     // GIR_Coverage, 21497,
     /*  436781 */     GIR_EraseRootFromParent_Done,
     /*  436782 */   // Label 7610: @436782
     /*  436782 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(436853), // Rule ID 21500 //
     /*  436787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  436790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  436798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  436801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  436804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436819 */     // MIs[0] round
     /*  436819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436829 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  436832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436838 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436851 */     GIR_RootConstrainSelectedInstOperands,
     /*  436852 */     // GIR_Coverage, 21500,
     /*  436852 */     GIR_EraseRootFromParent_Done,
     /*  436853 */   // Label 7611: @436853
     /*  436853 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(436924), // Rule ID 21501 //
     /*  436858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  436861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  436869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  436872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  436875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436890 */     // MIs[0] round
     /*  436890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  436903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436909 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436922 */     GIR_RootConstrainSelectedInstOperands,
     /*  436923 */     // GIR_Coverage, 21501,
     /*  436923 */     GIR_EraseRootFromParent_Done,
     /*  436924 */   // Label 7612: @436924
     /*  436924 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(436995), // Rule ID 21504 //
     /*  436929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  436932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  436937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  436946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436961 */     // MIs[0] round
     /*  436961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  436964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  436974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  436980 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  436982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436993 */     GIR_RootConstrainSelectedInstOperands,
     /*  436994 */     // GIR_Coverage, 21504,
     /*  436994 */     GIR_EraseRootFromParent_Done,
     /*  436995 */   // Label 7613: @436995
     /*  436995 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(437066), // Rule ID 21505 //
     /*  437000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  437003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  437008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  437011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  437014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437032 */     // MIs[0] round
     /*  437032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  437045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437051 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437064 */     GIR_RootConstrainSelectedInstOperands,
     /*  437065 */     // GIR_Coverage, 21505,
     /*  437065 */     GIR_EraseRootFromParent_Done,
     /*  437066 */   // Label 7614: @437066
     /*  437066 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(437137), // Rule ID 21508 //
     /*  437071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  437074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  437079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437103 */     // MIs[0] round
     /*  437103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437113 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  437116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437122 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437135 */     GIR_RootConstrainSelectedInstOperands,
     /*  437136 */     // GIR_Coverage, 21508,
     /*  437136 */     GIR_EraseRootFromParent_Done,
     /*  437137 */   // Label 7615: @437137
     /*  437137 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(437208), // Rule ID 21509 //
     /*  437142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  437145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  437150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437174 */     // MIs[0] round
     /*  437174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  437187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437193 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437206 */     GIR_RootConstrainSelectedInstOperands,
     /*  437207 */     // GIR_Coverage, 21509,
     /*  437207 */     GIR_EraseRootFromParent_Done,
     /*  437208 */   // Label 7616: @437208
     /*  437208 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(437279), // Rule ID 21512 //
     /*  437213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  437230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437245 */     // MIs[0] round
     /*  437245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  437258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437264 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437277 */     GIR_RootConstrainSelectedInstOperands,
     /*  437278 */     // GIR_Coverage, 21512,
     /*  437278 */     GIR_EraseRootFromParent_Done,
     /*  437279 */   // Label 7617: @437279
     /*  437279 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(437350), // Rule ID 21513 //
     /*  437284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  437301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437316 */     // MIs[0] round
     /*  437316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  437329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437335 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437348 */     GIR_RootConstrainSelectedInstOperands,
     /*  437349 */     // GIR_Coverage, 21513,
     /*  437349 */     GIR_EraseRootFromParent_Done,
     /*  437350 */   // Label 7618: @437350
     /*  437350 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(437421), // Rule ID 21516 //
     /*  437355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  437372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437387 */     // MIs[0] round
     /*  437387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437397 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  437400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437406 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437419 */     GIR_RootConstrainSelectedInstOperands,
     /*  437420 */     // GIR_Coverage, 21516,
     /*  437420 */     GIR_EraseRootFromParent_Done,
     /*  437421 */   // Label 7619: @437421
     /*  437421 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(437492), // Rule ID 21517 //
     /*  437426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  437443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437458 */     // MIs[0] round
     /*  437458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  437471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437477 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437490 */     GIR_RootConstrainSelectedInstOperands,
     /*  437491 */     // GIR_Coverage, 21517,
     /*  437491 */     GIR_EraseRootFromParent_Done,
     /*  437492 */   // Label 7620: @437492
     /*  437492 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(437563), // Rule ID 21520 //
     /*  437497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  437508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  437511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  437514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437529 */     // MIs[0] round
     /*  437529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  437542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437548 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437561 */     GIR_RootConstrainSelectedInstOperands,
     /*  437562 */     // GIR_Coverage, 21520,
     /*  437562 */     GIR_EraseRootFromParent_Done,
     /*  437563 */   // Label 7621: @437563
     /*  437563 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(437634), // Rule ID 21521 //
     /*  437568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  437579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  437582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  437585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437600 */     // MIs[0] round
     /*  437600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  437613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437619 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437632 */     GIR_RootConstrainSelectedInstOperands,
     /*  437633 */     // GIR_Coverage, 21521,
     /*  437633 */     GIR_EraseRootFromParent_Done,
     /*  437634 */   // Label 7622: @437634
     /*  437634 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(437705), // Rule ID 21524 //
     /*  437639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  437650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  437653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  437656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437671 */     // MIs[0] round
     /*  437671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437681 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  437684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437690 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437703 */     GIR_RootConstrainSelectedInstOperands,
     /*  437704 */     // GIR_Coverage, 21524,
     /*  437704 */     GIR_EraseRootFromParent_Done,
     /*  437705 */   // Label 7623: @437705
     /*  437705 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(437776), // Rule ID 21525 //
     /*  437710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  437721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  437724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  437727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437742 */     // MIs[0] round
     /*  437742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10926:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  437755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437761 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437774 */     GIR_RootConstrainSelectedInstOperands,
     /*  437775 */     // GIR_Coverage, 21525,
     /*  437775 */     GIR_EraseRootFromParent_Done,
     /*  437776 */   // Label 7624: @437776
     /*  437776 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(437847), // Rule ID 21528 //
     /*  437781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  437792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  437795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  437798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437813 */     // MIs[0] round
     /*  437813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  437826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437832 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437845 */     GIR_RootConstrainSelectedInstOperands,
     /*  437846 */     // GIR_Coverage, 21528,
     /*  437846 */     GIR_EraseRootFromParent_Done,
     /*  437847 */   // Label 7625: @437847
     /*  437847 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(437918), // Rule ID 21529 //
     /*  437852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  437863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  437866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  437869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437884 */     // MIs[0] round
     /*  437884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  437897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437903 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437916 */     GIR_RootConstrainSelectedInstOperands,
     /*  437917 */     // GIR_Coverage, 21529,
     /*  437917 */     GIR_EraseRootFromParent_Done,
     /*  437918 */   // Label 7626: @437918
     /*  437918 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(437989), // Rule ID 21532 //
     /*  437923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  437926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  437931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  437934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  437937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  437940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437955 */     // MIs[0] round
     /*  437955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  437958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437965 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  437968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  437974 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  437976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437987 */     GIR_RootConstrainSelectedInstOperands,
     /*  437988 */     // GIR_Coverage, 21532,
     /*  437988 */     GIR_EraseRootFromParent_Done,
     /*  437989 */   // Label 7627: @437989
     /*  437989 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(438060), // Rule ID 21533 //
     /*  437994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  437997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  438005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  438008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  438011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438026 */     // MIs[0] round
     /*  438026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  438039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438045 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438058 */     GIR_RootConstrainSelectedInstOperands,
     /*  438059 */     // GIR_Coverage, 21533,
     /*  438059 */     GIR_EraseRootFromParent_Done,
     /*  438060 */   // Label 7628: @438060
     /*  438060 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(438131), // Rule ID 21536 //
     /*  438065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  438068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438097 */     // MIs[0] round
     /*  438097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438107 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  438110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438116 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438129 */     GIR_RootConstrainSelectedInstOperands,
     /*  438130 */     // GIR_Coverage, 21536,
     /*  438130 */     GIR_EraseRootFromParent_Done,
     /*  438131 */   // Label 7629: @438131
     /*  438131 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(438202), // Rule ID 21537 //
     /*  438136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  438139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438168 */     // MIs[0] round
     /*  438168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  438181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438187 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438200 */     GIR_RootConstrainSelectedInstOperands,
     /*  438201 */     // GIR_Coverage, 21537,
     /*  438201 */     GIR_EraseRootFromParent_Done,
     /*  438202 */   // Label 7630: @438202
     /*  438202 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(438273), // Rule ID 21540 //
     /*  438207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  438210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  438224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438239 */     // MIs[0] round
     /*  438239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  438252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438258 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438271 */     GIR_RootConstrainSelectedInstOperands,
     /*  438272 */     // GIR_Coverage, 21540,
     /*  438272 */     GIR_EraseRootFromParent_Done,
     /*  438273 */   // Label 7631: @438273
     /*  438273 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(438344), // Rule ID 21541 //
     /*  438278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  438281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  438295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438310 */     // MIs[0] round
     /*  438310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  438323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438329 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438342 */     GIR_RootConstrainSelectedInstOperands,
     /*  438343 */     // GIR_Coverage, 21541,
     /*  438343 */     GIR_EraseRootFromParent_Done,
     /*  438344 */   // Label 7632: @438344
     /*  438344 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(438415), // Rule ID 21544 //
     /*  438349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  438352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  438366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438381 */     // MIs[0] round
     /*  438381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  438394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438400 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438413 */     GIR_RootConstrainSelectedInstOperands,
     /*  438414 */     // GIR_Coverage, 21544,
     /*  438414 */     GIR_EraseRootFromParent_Done,
     /*  438415 */   // Label 7633: @438415
     /*  438415 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(438486), // Rule ID 21545 //
     /*  438420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  438423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  438437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438452 */     // MIs[0] round
     /*  438452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10926:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  438465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438471 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438484 */     GIR_RootConstrainSelectedInstOperands,
     /*  438485 */     // GIR_Coverage, 21545,
     /*  438485 */     GIR_EraseRootFromParent_Done,
     /*  438486 */   // Label 7634: @438486
     /*  438486 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(438557), // Rule ID 21548 //
     /*  438491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  438494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  438502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  438505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  438508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438523 */     // MIs[0] round
     /*  438523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438533 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  438536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438542 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438555 */     GIR_RootConstrainSelectedInstOperands,
     /*  438556 */     // GIR_Coverage, 21548,
     /*  438556 */     GIR_EraseRootFromParent_Done,
     /*  438557 */   // Label 7635: @438557
     /*  438557 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(438628), // Rule ID 21549 //
     /*  438562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  438565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  438573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  438576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  438579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438594 */     // MIs[0] round
     /*  438594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  438607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438613 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438626 */     GIR_RootConstrainSelectedInstOperands,
     /*  438627 */     // GIR_Coverage, 21549,
     /*  438627 */     GIR_EraseRootFromParent_Done,
     /*  438628 */   // Label 7636: @438628
     /*  438628 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(438699), // Rule ID 21552 //
     /*  438633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  438636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  438644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  438647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  438650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438665 */     // MIs[0] round
     /*  438665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438675 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  438678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438684 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438697 */     GIR_RootConstrainSelectedInstOperands,
     /*  438698 */     // GIR_Coverage, 21552,
     /*  438698 */     GIR_EraseRootFromParent_Done,
     /*  438699 */   // Label 7637: @438699
     /*  438699 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(438770), // Rule ID 21553 //
     /*  438704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  438707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  438715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  438718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  438721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  438732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438736 */     // MIs[0] round
     /*  438736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  438749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438755 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438768 */     GIR_RootConstrainSelectedInstOperands,
     /*  438769 */     // GIR_Coverage, 21553,
     /*  438769 */     GIR_EraseRootFromParent_Done,
     /*  438770 */   // Label 7638: @438770
     /*  438770 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(438841), // Rule ID 21556 //
     /*  438775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  438778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  438792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438807 */     // MIs[0] round
     /*  438807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438817 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  438820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438826 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438839 */     GIR_RootConstrainSelectedInstOperands,
     /*  438840 */     // GIR_Coverage, 21556,
     /*  438840 */     GIR_EraseRootFromParent_Done,
     /*  438841 */   // Label 7639: @438841
     /*  438841 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(438912), // Rule ID 21557 //
     /*  438846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  438849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  438863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438878 */     // MIs[0] round
     /*  438878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  438891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438897 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438910 */     GIR_RootConstrainSelectedInstOperands,
     /*  438911 */     // GIR_Coverage, 21557,
     /*  438911 */     GIR_EraseRootFromParent_Done,
     /*  438912 */   // Label 7640: @438912
     /*  438912 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(438983), // Rule ID 21560 //
     /*  438917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  438920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  438928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  438931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  438934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438949 */     // MIs[0] round
     /*  438949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  438952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  438962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  438968 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  438970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438981 */     GIR_RootConstrainSelectedInstOperands,
     /*  438982 */     // GIR_Coverage, 21560,
     /*  438982 */     GIR_EraseRootFromParent_Done,
     /*  438983 */   // Label 7641: @438983
     /*  438983 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(439054), // Rule ID 21561 //
     /*  438988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  438991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  438996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  438999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  439005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439020 */     // MIs[0] round
     /*  439020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  439033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439039 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439052 */     GIR_RootConstrainSelectedInstOperands,
     /*  439053 */     // GIR_Coverage, 21561,
     /*  439053 */     GIR_EraseRootFromParent_Done,
     /*  439054 */   // Label 7642: @439054
     /*  439054 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(439125), // Rule ID 21564 //
     /*  439059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  439062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  439067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  439070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  439073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  439076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439091 */     // MIs[0] round
     /*  439091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  439104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439110 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439123 */     GIR_RootConstrainSelectedInstOperands,
     /*  439124 */     // GIR_Coverage, 21564,
     /*  439124 */     GIR_EraseRootFromParent_Done,
     /*  439125 */   // Label 7643: @439125
     /*  439125 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(439196), // Rule ID 21565 //
     /*  439130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  439133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  439138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  439141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  439144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  439147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439162 */     // MIs[0] round
     /*  439162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  439175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439181 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439194 */     GIR_RootConstrainSelectedInstOperands,
     /*  439195 */     // GIR_Coverage, 21565,
     /*  439195 */     GIR_EraseRootFromParent_Done,
     /*  439196 */   // Label 7644: @439196
     /*  439196 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(439267), // Rule ID 21568 //
     /*  439201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  439204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  439209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  439212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  439215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  439218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439233 */     // MIs[0] round
     /*  439233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  439246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439252 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439265 */     GIR_RootConstrainSelectedInstOperands,
     /*  439266 */     // GIR_Coverage, 21568,
     /*  439266 */     GIR_EraseRootFromParent_Done,
     /*  439267 */   // Label 7645: @439267
     /*  439267 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(439338), // Rule ID 21569 //
     /*  439272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  439275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  439280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  439283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  439286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  439289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439304 */     // MIs[0] round
     /*  439304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  439317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439323 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439336 */     GIR_RootConstrainSelectedInstOperands,
     /*  439337 */     // GIR_Coverage, 21569,
     /*  439337 */     GIR_EraseRootFromParent_Done,
     /*  439338 */   // Label 7646: @439338
     /*  439338 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(439409), // Rule ID 21692 //
     /*  439343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  439346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  439354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  439357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439375 */     // MIs[0] round
     /*  439375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439385 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  439388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439394 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439407 */     GIR_RootConstrainSelectedInstOperands,
     /*  439408 */     // GIR_Coverage, 21692,
     /*  439408 */     GIR_EraseRootFromParent_Done,
     /*  439409 */   // Label 7647: @439409
     /*  439409 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(439480), // Rule ID 21693 //
     /*  439414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  439417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  439425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  439428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439446 */     // MIs[0] round
     /*  439446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  439459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439465 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439478 */     GIR_RootConstrainSelectedInstOperands,
     /*  439479 */     // GIR_Coverage, 21693,
     /*  439479 */     GIR_EraseRootFromParent_Done,
     /*  439480 */   // Label 7648: @439480
     /*  439480 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(439551), // Rule ID 21696 //
     /*  439485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  439488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  439496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  439499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439517 */     // MIs[0] round
     /*  439517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439527 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  439530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439536 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439549 */     GIR_RootConstrainSelectedInstOperands,
     /*  439550 */     // GIR_Coverage, 21696,
     /*  439550 */     GIR_EraseRootFromParent_Done,
     /*  439551 */   // Label 7649: @439551
     /*  439551 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(439622), // Rule ID 21697 //
     /*  439556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  439559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  439567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  439570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439588 */     // MIs[0] round
     /*  439588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439598 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  439601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439607 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439620 */     GIR_RootConstrainSelectedInstOperands,
     /*  439621 */     // GIR_Coverage, 21697,
     /*  439621 */     GIR_EraseRootFromParent_Done,
     /*  439622 */   // Label 7650: @439622
     /*  439622 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(439693), // Rule ID 21700 //
     /*  439627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  439630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  439644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439659 */     // MIs[0] round
     /*  439659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439669 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  439672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439678 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439691 */     GIR_RootConstrainSelectedInstOperands,
     /*  439692 */     // GIR_Coverage, 21700,
     /*  439692 */     GIR_EraseRootFromParent_Done,
     /*  439693 */   // Label 7651: @439693
     /*  439693 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(439764), // Rule ID 21701 //
     /*  439698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  439701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  439715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439730 */     // MIs[0] round
     /*  439730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439740 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10918:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  439743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439749 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439762 */     GIR_RootConstrainSelectedInstOperands,
     /*  439763 */     // GIR_Coverage, 21701,
     /*  439763 */     GIR_EraseRootFromParent_Done,
     /*  439764 */   // Label 7652: @439764
     /*  439764 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(439835), // Rule ID 21704 //
     /*  439769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  439772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  439783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  439786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439801 */     // MIs[0] round
     /*  439801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439811 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10918:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  439814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439820 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439833 */     GIR_RootConstrainSelectedInstOperands,
     /*  439834 */     // GIR_Coverage, 21704,
     /*  439834 */     GIR_EraseRootFromParent_Done,
     /*  439835 */   // Label 7653: @439835
     /*  439835 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(439906), // Rule ID 21705 //
     /*  439840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  439843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  439854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  439857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439872 */     // MIs[0] round
     /*  439872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10918:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  439885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439891 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439904 */     GIR_RootConstrainSelectedInstOperands,
     /*  439905 */     // GIR_Coverage, 21705,
     /*  439905 */     GIR_EraseRootFromParent_Done,
     /*  439906 */   // Label 7654: @439906
     /*  439906 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(439977), // Rule ID 21708 //
     /*  439911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  439914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  439922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  439925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  439928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439943 */     // MIs[0] round
     /*  439943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  439946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439953 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10918:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  439956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  439962 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  439964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439975 */     GIR_RootConstrainSelectedInstOperands,
     /*  439976 */     // GIR_Coverage, 21708,
     /*  439976 */     GIR_EraseRootFromParent_Done,
     /*  439977 */   // Label 7655: @439977
     /*  439977 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(440048), // Rule ID 21709 //
     /*  439982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  439985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  439990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  439993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  439996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  439999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440014 */     // MIs[0] round
     /*  440014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440024 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10918:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  440027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440033 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440046 */     GIR_RootConstrainSelectedInstOperands,
     /*  440047 */     // GIR_Coverage, 21709,
     /*  440047 */     GIR_EraseRootFromParent_Done,
     /*  440048 */   // Label 7656: @440048
     /*  440048 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(440119), // Rule ID 21712 //
     /*  440053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  440056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  440064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  440067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  440070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440085 */     // MIs[0] round
     /*  440085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440095 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  440098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440104 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440117 */     GIR_RootConstrainSelectedInstOperands,
     /*  440118 */     // GIR_Coverage, 21712,
     /*  440118 */     GIR_EraseRootFromParent_Done,
     /*  440119 */   // Label 7657: @440119
     /*  440119 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(440190), // Rule ID 21713 //
     /*  440124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  440127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  440135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  440138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  440141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440156 */     // MIs[0] round
     /*  440156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440166 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  440169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440175 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440188 */     GIR_RootConstrainSelectedInstOperands,
     /*  440189 */     // GIR_Coverage, 21713,
     /*  440189 */     GIR_EraseRootFromParent_Done,
     /*  440190 */   // Label 7658: @440190
     /*  440190 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(440261), // Rule ID 21716 //
     /*  440195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  440198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  440206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  440209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  440212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440227 */     // MIs[0] round
     /*  440227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440237 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  440240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440246 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440259 */     GIR_RootConstrainSelectedInstOperands,
     /*  440260 */     // GIR_Coverage, 21716,
     /*  440260 */     GIR_EraseRootFromParent_Done,
     /*  440261 */   // Label 7659: @440261
     /*  440261 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(440332), // Rule ID 21717 //
     /*  440266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  440269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  440277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  440280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  440283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440298 */     // MIs[0] round
     /*  440298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  440311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440317 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440330 */     GIR_RootConstrainSelectedInstOperands,
     /*  440331 */     // GIR_Coverage, 21717,
     /*  440331 */     GIR_EraseRootFromParent_Done,
     /*  440332 */   // Label 7660: @440332
     /*  440332 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(440403), // Rule ID 21720 //
     /*  440337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  440340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  440354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440369 */     // MIs[0] round
     /*  440369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440379 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10918:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  440382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440388 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440401 */     GIR_RootConstrainSelectedInstOperands,
     /*  440402 */     // GIR_Coverage, 21720,
     /*  440402 */     GIR_EraseRootFromParent_Done,
     /*  440403 */   // Label 7661: @440403
     /*  440403 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(440474), // Rule ID 21721 //
     /*  440408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  440411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  440425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440440 */     // MIs[0] round
     /*  440440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10918:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  440453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440459 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440472 */     GIR_RootConstrainSelectedInstOperands,
     /*  440473 */     // GIR_Coverage, 21721,
     /*  440473 */     GIR_EraseRootFromParent_Done,
     /*  440474 */   // Label 7662: @440474
     /*  440474 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(440545), // Rule ID 21724 //
     /*  440479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  440482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  440496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440511 */     // MIs[0] round
     /*  440511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440521 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10918:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  440524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440530 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440543 */     GIR_RootConstrainSelectedInstOperands,
     /*  440544 */     // GIR_Coverage, 21724,
     /*  440544 */     GIR_EraseRootFromParent_Done,
     /*  440545 */   // Label 7663: @440545
     /*  440545 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(440616), // Rule ID 21725 //
     /*  440550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  440553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  440558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  440567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440582 */     // MIs[0] round
     /*  440582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440592 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10918:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  440595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440601 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440614 */     GIR_RootConstrainSelectedInstOperands,
     /*  440615 */     // GIR_Coverage, 21725,
     /*  440615 */     GIR_EraseRootFromParent_Done,
     /*  440616 */   // Label 7664: @440616
     /*  440616 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(440687), // Rule ID 21728 //
     /*  440621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  440624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  440632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  440635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  440638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440653 */     // MIs[0] round
     /*  440653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440663 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  440666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440672 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440685 */     GIR_RootConstrainSelectedInstOperands,
     /*  440686 */     // GIR_Coverage, 21728,
     /*  440686 */     GIR_EraseRootFromParent_Done,
     /*  440687 */   // Label 7665: @440687
     /*  440687 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(440758), // Rule ID 21729 //
     /*  440692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  440695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  440703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  440706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  440709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440724 */     // MIs[0] round
     /*  440724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440734 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  440737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440743 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440756 */     GIR_RootConstrainSelectedInstOperands,
     /*  440757 */     // GIR_Coverage, 21729,
     /*  440757 */     GIR_EraseRootFromParent_Done,
     /*  440758 */   // Label 7666: @440758
     /*  440758 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(440829), // Rule ID 21732 //
     /*  440763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  440766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  440774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  440777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  440780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440795 */     // MIs[0] round
     /*  440795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440805 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  440808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440814 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440827 */     GIR_RootConstrainSelectedInstOperands,
     /*  440828 */     // GIR_Coverage, 21732,
     /*  440828 */     GIR_EraseRootFromParent_Done,
     /*  440829 */   // Label 7667: @440829
     /*  440829 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(440900), // Rule ID 21733 //
     /*  440834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  440837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  440845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  440848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  440851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440866 */     // MIs[0] round
     /*  440866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440876 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  440879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440885 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440898 */     GIR_RootConstrainSelectedInstOperands,
     /*  440899 */     // GIR_Coverage, 21733,
     /*  440899 */     GIR_EraseRootFromParent_Done,
     /*  440900 */   // Label 7668: @440900
     /*  440900 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(440971), // Rule ID 21736 //
     /*  440905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  440908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  440916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  440919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  440933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440937 */     // MIs[0] round
     /*  440937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  440940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440947 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  440950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  440956 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  440958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440969 */     GIR_RootConstrainSelectedInstOperands,
     /*  440970 */     // GIR_Coverage, 21736,
     /*  440970 */     GIR_EraseRootFromParent_Done,
     /*  440971 */   // Label 7669: @440971
     /*  440971 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(441042), // Rule ID 21737 //
     /*  440976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  440979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  440984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  440987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  440990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441008 */     // MIs[0] round
     /*  441008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441018 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10916:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  441018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  441021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441027 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441040 */     GIR_RootConstrainSelectedInstOperands,
     /*  441041 */     // GIR_Coverage, 21737,
     /*  441041 */     GIR_EraseRootFromParent_Done,
     /*  441042 */   // Label 7670: @441042
     /*  441042 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(441113), // Rule ID 21740 //
     /*  441047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  441050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  441058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  441061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441079 */     // MIs[0] round
     /*  441079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441089 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  441089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  441092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441098 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441111 */     GIR_RootConstrainSelectedInstOperands,
     /*  441112 */     // GIR_Coverage, 21740,
     /*  441112 */     GIR_EraseRootFromParent_Done,
     /*  441113 */   // Label 7671: @441113
     /*  441113 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(441184), // Rule ID 21741 //
     /*  441118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  441121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  441129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  441132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441150 */     // MIs[0] round
     /*  441150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441160 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  441160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  441163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441169 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441182 */     GIR_RootConstrainSelectedInstOperands,
     /*  441183 */     // GIR_Coverage, 21741,
     /*  441183 */     GIR_EraseRootFromParent_Done,
     /*  441184 */   // Label 7672: @441184
     /*  441184 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(441255), // Rule ID 21744 //
     /*  441189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  441192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  441200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  441203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441221 */     // MIs[0] round
     /*  441221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441231 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  441231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  441234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441240 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441253 */     GIR_RootConstrainSelectedInstOperands,
     /*  441254 */     // GIR_Coverage, 21744,
     /*  441254 */     GIR_EraseRootFromParent_Done,
     /*  441255 */   // Label 7673: @441255
     /*  441255 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(441326), // Rule ID 21745 //
     /*  441260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  441263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  441271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  441274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441292 */     // MIs[0] round
     /*  441292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441302 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  441302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  441305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441311 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441324 */     GIR_RootConstrainSelectedInstOperands,
     /*  441325 */     // GIR_Coverage, 21745,
     /*  441325 */     GIR_EraseRootFromParent_Done,
     /*  441326 */   // Label 7674: @441326
     /*  441326 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(441397), // Rule ID 21748 //
     /*  441331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  441334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  441348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441363 */     // MIs[0] round
     /*  441363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441373 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  441376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441382 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441395 */     GIR_RootConstrainSelectedInstOperands,
     /*  441396 */     // GIR_Coverage, 21748,
     /*  441396 */     GIR_EraseRootFromParent_Done,
     /*  441397 */   // Label 7675: @441397
     /*  441397 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(441468), // Rule ID 21749 //
     /*  441402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  441405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  441419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441434 */     // MIs[0] round
     /*  441434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  441447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441453 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441466 */     GIR_RootConstrainSelectedInstOperands,
     /*  441467 */     // GIR_Coverage, 21749,
     /*  441467 */     GIR_EraseRootFromParent_Done,
     /*  441468 */   // Label 7676: @441468
     /*  441468 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(441539), // Rule ID 21752 //
     /*  441473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  441476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  441484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  441487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441505 */     // MIs[0] round
     /*  441505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441515 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  441518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441524 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441537 */     GIR_RootConstrainSelectedInstOperands,
     /*  441538 */     // GIR_Coverage, 21752,
     /*  441538 */     GIR_EraseRootFromParent_Done,
     /*  441539 */   // Label 7677: @441539
     /*  441539 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(441610), // Rule ID 21753 //
     /*  441544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  441547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  441555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  441558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441576 */     // MIs[0] round
     /*  441576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441586 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  441589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441595 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441608 */     GIR_RootConstrainSelectedInstOperands,
     /*  441609 */     // GIR_Coverage, 21753,
     /*  441609 */     GIR_EraseRootFromParent_Done,
     /*  441610 */   // Label 7678: @441610
     /*  441610 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(441681), // Rule ID 21756 //
     /*  441615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  441618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  441626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  441629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441647 */     // MIs[0] round
     /*  441647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441657 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  441660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441666 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441679 */     GIR_RootConstrainSelectedInstOperands,
     /*  441680 */     // GIR_Coverage, 21756,
     /*  441680 */     GIR_EraseRootFromParent_Done,
     /*  441681 */   // Label 7679: @441681
     /*  441681 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(441752), // Rule ID 21757 //
     /*  441686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  441689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  441697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  441700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441718 */     // MIs[0] round
     /*  441718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441728 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  441731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441737 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441750 */     GIR_RootConstrainSelectedInstOperands,
     /*  441751 */     // GIR_Coverage, 21757,
     /*  441751 */     GIR_EraseRootFromParent_Done,
     /*  441752 */   // Label 7680: @441752
     /*  441752 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(441823), // Rule ID 21760 //
     /*  441757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  441760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441789 */     // MIs[0] round
     /*  441789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441799 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  441802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441808 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441821 */     GIR_RootConstrainSelectedInstOperands,
     /*  441822 */     // GIR_Coverage, 21760,
     /*  441822 */     GIR_EraseRootFromParent_Done,
     /*  441823 */   // Label 7681: @441823
     /*  441823 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(441894), // Rule ID 21761 //
     /*  441828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  441831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  441836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441860 */     // MIs[0] round
     /*  441860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441870 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  441873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441879 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441892 */     GIR_RootConstrainSelectedInstOperands,
     /*  441893 */     // GIR_Coverage, 21761,
     /*  441893 */     GIR_EraseRootFromParent_Done,
     /*  441894 */   // Label 7682: @441894
     /*  441894 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(441965), // Rule ID 21764 //
     /*  441899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  441902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  441907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  441916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441931 */     // MIs[0] round
     /*  441931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  441934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441941 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  441944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  441950 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  441952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441963 */     GIR_RootConstrainSelectedInstOperands,
     /*  441964 */     // GIR_Coverage, 21764,
     /*  441964 */     GIR_EraseRootFromParent_Done,
     /*  441965 */   // Label 7683: @441965
     /*  441965 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(442036), // Rule ID 21765 //
     /*  441970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  441973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  441978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  441987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442002 */     // MIs[0] round
     /*  442002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442012 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  442015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442021 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442034 */     GIR_RootConstrainSelectedInstOperands,
     /*  442035 */     // GIR_Coverage, 21765,
     /*  442035 */     GIR_EraseRootFromParent_Done,
     /*  442036 */   // Label 7684: @442036
     /*  442036 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(442107), // Rule ID 21768 //
     /*  442041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  442044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  442058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442073 */     // MIs[0] round
     /*  442073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442083 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  442086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442092 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442105 */     GIR_RootConstrainSelectedInstOperands,
     /*  442106 */     // GIR_Coverage, 21768,
     /*  442106 */     GIR_EraseRootFromParent_Done,
     /*  442107 */   // Label 7685: @442107
     /*  442107 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(442178), // Rule ID 21769 //
     /*  442112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  442115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  442129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442144 */     // MIs[0] round
     /*  442144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  442157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442163 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442176 */     GIR_RootConstrainSelectedInstOperands,
     /*  442177 */     // GIR_Coverage, 21769,
     /*  442177 */     GIR_EraseRootFromParent_Done,
     /*  442178 */   // Label 7686: @442178
     /*  442178 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(442249), // Rule ID 21772 //
     /*  442183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  442186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  442194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  442197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  442200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442215 */     // MIs[0] round
     /*  442215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  442228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442234 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442247 */     GIR_RootConstrainSelectedInstOperands,
     /*  442248 */     // GIR_Coverage, 21772,
     /*  442248 */     GIR_EraseRootFromParent_Done,
     /*  442249 */   // Label 7687: @442249
     /*  442249 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(442320), // Rule ID 21773 //
     /*  442254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  442257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  442265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  442268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  442271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442286 */     // MIs[0] round
     /*  442286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  442299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442305 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442318 */     GIR_RootConstrainSelectedInstOperands,
     /*  442319 */     // GIR_Coverage, 21773,
     /*  442319 */     GIR_EraseRootFromParent_Done,
     /*  442320 */   // Label 7688: @442320
     /*  442320 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(442391), // Rule ID 21776 //
     /*  442325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  442328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  442336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  442339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  442342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  442357 */     // MIs[0] round
     /*  442357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442367 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  442370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442376 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442389 */     GIR_RootConstrainSelectedInstOperands,
     /*  442390 */     // GIR_Coverage, 21776,
     /*  442390 */     GIR_EraseRootFromParent_Done,
     /*  442391 */   // Label 7689: @442391
     /*  442391 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(442462), // Rule ID 21777 //
     /*  442396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  442399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  442407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  442410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  442413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  442428 */     // MIs[0] round
     /*  442428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442438 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  442441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442447 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442460 */     GIR_RootConstrainSelectedInstOperands,
     /*  442461 */     // GIR_Coverage, 21777,
     /*  442461 */     GIR_EraseRootFromParent_Done,
     /*  442462 */   // Label 7690: @442462
     /*  442462 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(442533), // Rule ID 21780 //
     /*  442467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  442470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442499 */     // MIs[0] round
     /*  442499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442509 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  442512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442518 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442531 */     GIR_RootConstrainSelectedInstOperands,
     /*  442532 */     // GIR_Coverage, 21780,
     /*  442532 */     GIR_EraseRootFromParent_Done,
     /*  442533 */   // Label 7691: @442533
     /*  442533 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(442604), // Rule ID 21781 //
     /*  442538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  442541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442570 */     // MIs[0] round
     /*  442570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442580 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  442583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442589 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442602 */     GIR_RootConstrainSelectedInstOperands,
     /*  442603 */     // GIR_Coverage, 21781,
     /*  442603 */     GIR_EraseRootFromParent_Done,
     /*  442604 */   // Label 7692: @442604
     /*  442604 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(442675), // Rule ID 21784 //
     /*  442609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  442612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442641 */     // MIs[0] round
     /*  442641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442651 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  442654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442660 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442673 */     GIR_RootConstrainSelectedInstOperands,
     /*  442674 */     // GIR_Coverage, 21784,
     /*  442674 */     GIR_EraseRootFromParent_Done,
     /*  442675 */   // Label 7693: @442675
     /*  442675 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(442746), // Rule ID 21785 //
     /*  442680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  442683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442712 */     // MIs[0] round
     /*  442712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442722 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  442725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442731 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442744 */     GIR_RootConstrainSelectedInstOperands,
     /*  442745 */     // GIR_Coverage, 21785,
     /*  442745 */     GIR_EraseRootFromParent_Done,
     /*  442746 */   // Label 7694: @442746
     /*  442746 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(442817), // Rule ID 21788 //
     /*  442751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  442754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  442768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442783 */     // MIs[0] round
     /*  442783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442793 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  442796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442802 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442815 */     GIR_RootConstrainSelectedInstOperands,
     /*  442816 */     // GIR_Coverage, 21788,
     /*  442816 */     GIR_EraseRootFromParent_Done,
     /*  442817 */   // Label 7695: @442817
     /*  442817 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(442888), // Rule ID 21789 //
     /*  442822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  442825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  442839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442854 */     // MIs[0] round
     /*  442854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442864 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10914:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  442867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442873 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442886 */     GIR_RootConstrainSelectedInstOperands,
     /*  442887 */     // GIR_Coverage, 21789,
     /*  442887 */     GIR_EraseRootFromParent_Done,
     /*  442888 */   // Label 7696: @442888
     /*  442888 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(442959), // Rule ID 21792 //
     /*  442893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  442896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  442904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  442907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  442910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442925 */     // MIs[0] round
     /*  442925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442935 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  442938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  442944 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  442946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442957 */     GIR_RootConstrainSelectedInstOperands,
     /*  442958 */     // GIR_Coverage, 21792,
     /*  442958 */     GIR_EraseRootFromParent_Done,
     /*  442959 */   // Label 7697: @442959
     /*  442959 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(443030), // Rule ID 21793 //
     /*  442964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  442967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  442972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  442975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  442978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  442981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442996 */     // MIs[0] round
     /*  442996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  442999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443006 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  443009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  443015 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  443017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443028 */     GIR_RootConstrainSelectedInstOperands,
     /*  443029 */     // GIR_Coverage, 21793,
     /*  443029 */     GIR_EraseRootFromParent_Done,
     /*  443030 */   // Label 7698: @443030
     /*  443030 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(443101), // Rule ID 21796 //
     /*  443035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  443038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  443043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  443052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443067 */     // MIs[0] round
     /*  443067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  443070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443077 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  443080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  443086 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  443088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443099 */     GIR_RootConstrainSelectedInstOperands,
     /*  443100 */     // GIR_Coverage, 21796,
     /*  443100 */     GIR_EraseRootFromParent_Done,
     /*  443101 */   // Label 7699: @443101
     /*  443101 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(443172), // Rule ID 21797 //
     /*  443106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  443109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  443114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  443123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443138 */     // MIs[0] round
     /*  443138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  443141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443148 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  443151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  443157 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  443159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443170 */     GIR_RootConstrainSelectedInstOperands,
     /*  443171 */     // GIR_Coverage, 21797,
     /*  443171 */     GIR_EraseRootFromParent_Done,
     /*  443172 */   // Label 7700: @443172
     /*  443172 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(443243), // Rule ID 2614 //
     /*  443177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  443188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  443191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  443194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443205 */     // MIs[0] passthru
     /*  443205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  443224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443241 */     GIR_RootConstrainSelectedInstOperands,
     /*  443242 */     // GIR_Coverage, 2614,
     /*  443242 */     GIR_EraseRootFromParent_Done,
     /*  443243 */   // Label 7701: @443243
     /*  443243 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(443314), // Rule ID 2615 //
     /*  443248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  443259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  443262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  443265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443276 */     // MIs[0] passthru
     /*  443276 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  443295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443312 */     GIR_RootConstrainSelectedInstOperands,
     /*  443313 */     // GIR_Coverage, 2615,
     /*  443313 */     GIR_EraseRootFromParent_Done,
     /*  443314 */   // Label 7702: @443314
     /*  443314 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(443385), // Rule ID 3922 //
     /*  443319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  443330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  443333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  443336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443347 */     // MIs[0] passthru
     /*  443347 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443363 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  443366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443383 */     GIR_RootConstrainSelectedInstOperands,
     /*  443384 */     // GIR_Coverage, 3922,
     /*  443384 */     GIR_EraseRootFromParent_Done,
     /*  443385 */   // Label 7703: @443385
     /*  443385 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(443456), // Rule ID 3923 //
     /*  443390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  443401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  443404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  443407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443418 */     // MIs[0] passthru
     /*  443418 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  443437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443454 */     GIR_RootConstrainSelectedInstOperands,
     /*  443455 */     // GIR_Coverage, 3923,
     /*  443455 */     GIR_EraseRootFromParent_Done,
     /*  443456 */   // Label 7704: @443456
     /*  443456 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(443527), // Rule ID 3932 //
     /*  443461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  443478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443489 */     // MIs[0] passthru
     /*  443489 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443505 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  443508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443525 */     GIR_RootConstrainSelectedInstOperands,
     /*  443526 */     // GIR_Coverage, 3932,
     /*  443526 */     GIR_EraseRootFromParent_Done,
     /*  443527 */   // Label 7705: @443527
     /*  443527 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(443598), // Rule ID 3933 //
     /*  443532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  443549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443560 */     // MIs[0] passthru
     /*  443560 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  443579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443596 */     GIR_RootConstrainSelectedInstOperands,
     /*  443597 */     // GIR_Coverage, 3933,
     /*  443597 */     GIR_EraseRootFromParent_Done,
     /*  443598 */   // Label 7706: @443598
     /*  443598 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(443669), // Rule ID 3942 //
     /*  443603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  443620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443631 */     // MIs[0] passthru
     /*  443631 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  443650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443667 */     GIR_RootConstrainSelectedInstOperands,
     /*  443668 */     // GIR_Coverage, 3942,
     /*  443668 */     GIR_EraseRootFromParent_Done,
     /*  443669 */   // Label 7707: @443669
     /*  443669 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(443740), // Rule ID 3943 //
     /*  443674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  443691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443702 */     // MIs[0] passthru
     /*  443702 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  443721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443738 */     GIR_RootConstrainSelectedInstOperands,
     /*  443739 */     // GIR_Coverage, 3943,
     /*  443739 */     GIR_EraseRootFromParent_Done,
     /*  443740 */   // Label 7708: @443740
     /*  443740 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(443811), // Rule ID 3952 //
     /*  443745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  443762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443773 */     // MIs[0] passthru
     /*  443773 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  443792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443809 */     GIR_RootConstrainSelectedInstOperands,
     /*  443810 */     // GIR_Coverage, 3952,
     /*  443810 */     GIR_EraseRootFromParent_Done,
     /*  443811 */   // Label 7709: @443811
     /*  443811 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(443882), // Rule ID 3953 //
     /*  443816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  443833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443844 */     // MIs[0] passthru
     /*  443844 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443860 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  443863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443880 */     GIR_RootConstrainSelectedInstOperands,
     /*  443881 */     // GIR_Coverage, 3953,
     /*  443881 */     GIR_EraseRootFromParent_Done,
     /*  443882 */   // Label 7710: @443882
     /*  443882 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(443953), // Rule ID 3962 //
     /*  443887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  443898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  443901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  443904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443915 */     // MIs[0] passthru
     /*  443915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443931 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  443934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  443940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443951 */     GIR_RootConstrainSelectedInstOperands,
     /*  443952 */     // GIR_Coverage, 3962,
     /*  443952 */     GIR_EraseRootFromParent_Done,
     /*  443953 */   // Label 7711: @443953
     /*  443953 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(444024), // Rule ID 3963 //
     /*  443958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  443966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  443969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  443972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  443975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443986 */     // MIs[0] passthru
     /*  443986 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  443991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  444005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444022 */     GIR_RootConstrainSelectedInstOperands,
     /*  444023 */     // GIR_Coverage, 3963,
     /*  444023 */     GIR_EraseRootFromParent_Done,
     /*  444024 */   // Label 7712: @444024
     /*  444024 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(444095), // Rule ID 3972 //
     /*  444029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  444040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  444043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  444046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444057 */     // MIs[0] passthru
     /*  444057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444073 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  444076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444093 */     GIR_RootConstrainSelectedInstOperands,
     /*  444094 */     // GIR_Coverage, 3972,
     /*  444094 */     GIR_EraseRootFromParent_Done,
     /*  444095 */   // Label 7713: @444095
     /*  444095 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(444166), // Rule ID 3973 //
     /*  444100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  444111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  444114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  444117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444128 */     // MIs[0] passthru
     /*  444128 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  444147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444164 */     GIR_RootConstrainSelectedInstOperands,
     /*  444165 */     // GIR_Coverage, 3973,
     /*  444165 */     GIR_EraseRootFromParent_Done,
     /*  444166 */   // Label 7714: @444166
     /*  444166 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(444237), // Rule ID 3982 //
     /*  444171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  444182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  444185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  444188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444199 */     // MIs[0] passthru
     /*  444199 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444215 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  444218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444235 */     GIR_RootConstrainSelectedInstOperands,
     /*  444236 */     // GIR_Coverage, 3982,
     /*  444236 */     GIR_EraseRootFromParent_Done,
     /*  444237 */   // Label 7715: @444237
     /*  444237 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(444308), // Rule ID 3983 //
     /*  444242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  444253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  444256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  444259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444270 */     // MIs[0] passthru
     /*  444270 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  444289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444306 */     GIR_RootConstrainSelectedInstOperands,
     /*  444307 */     // GIR_Coverage, 3983,
     /*  444307 */     GIR_EraseRootFromParent_Done,
     /*  444308 */   // Label 7716: @444308
     /*  444308 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(444379), // Rule ID 3992 //
     /*  444313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  444330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444341 */     // MIs[0] passthru
     /*  444341 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  444360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444377 */     GIR_RootConstrainSelectedInstOperands,
     /*  444378 */     // GIR_Coverage, 3992,
     /*  444378 */     GIR_EraseRootFromParent_Done,
     /*  444379 */   // Label 7717: @444379
     /*  444379 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(444450), // Rule ID 3993 //
     /*  444384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  444401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444412 */     // MIs[0] passthru
     /*  444412 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  444431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444448 */     GIR_RootConstrainSelectedInstOperands,
     /*  444449 */     // GIR_Coverage, 3993,
     /*  444449 */     GIR_EraseRootFromParent_Done,
     /*  444450 */   // Label 7718: @444450
     /*  444450 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(444521), // Rule ID 4002 //
     /*  444455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  444472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444483 */     // MIs[0] passthru
     /*  444483 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444499 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  444502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444519 */     GIR_RootConstrainSelectedInstOperands,
     /*  444520 */     // GIR_Coverage, 4002,
     /*  444520 */     GIR_EraseRootFromParent_Done,
     /*  444521 */   // Label 7719: @444521
     /*  444521 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(444592), // Rule ID 4003 //
     /*  444526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  444543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444554 */     // MIs[0] passthru
     /*  444554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  444573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444590 */     GIR_RootConstrainSelectedInstOperands,
     /*  444591 */     // GIR_Coverage, 4003,
     /*  444591 */     GIR_EraseRootFromParent_Done,
     /*  444592 */   // Label 7720: @444592
     /*  444592 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(444663), // Rule ID 4012 //
     /*  444597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  444614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444625 */     // MIs[0] passthru
     /*  444625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444641 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  444644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444661 */     GIR_RootConstrainSelectedInstOperands,
     /*  444662 */     // GIR_Coverage, 4012,
     /*  444662 */     GIR_EraseRootFromParent_Done,
     /*  444663 */   // Label 7721: @444663
     /*  444663 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(444734), // Rule ID 4013 //
     /*  444668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  444685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444696 */     // MIs[0] passthru
     /*  444696 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  444715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444732 */     GIR_RootConstrainSelectedInstOperands,
     /*  444733 */     // GIR_Coverage, 4013,
     /*  444733 */     GIR_EraseRootFromParent_Done,
     /*  444734 */   // Label 7722: @444734
     /*  444734 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(444805), // Rule ID 4022 //
     /*  444739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  444742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  444750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  444753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  444756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444767 */     // MIs[0] passthru
     /*  444767 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  444786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444803 */     GIR_RootConstrainSelectedInstOperands,
     /*  444804 */     // GIR_Coverage, 4022,
     /*  444804 */     GIR_EraseRootFromParent_Done,
     /*  444805 */   // Label 7723: @444805
     /*  444805 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(444876), // Rule ID 4023 //
     /*  444810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  444813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  444821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  444824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  444827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444838 */     // MIs[0] passthru
     /*  444838 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  444857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444874 */     GIR_RootConstrainSelectedInstOperands,
     /*  444875 */     // GIR_Coverage, 4023,
     /*  444875 */     GIR_EraseRootFromParent_Done,
     /*  444876 */   // Label 7724: @444876
     /*  444876 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(444947), // Rule ID 4032 //
     /*  444881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  444884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  444898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444909 */     // MIs[0] passthru
     /*  444909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  444928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  444934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444945 */     GIR_RootConstrainSelectedInstOperands,
     /*  444946 */     // GIR_Coverage, 4032,
     /*  444946 */     GIR_EraseRootFromParent_Done,
     /*  444947 */   // Label 7725: @444947
     /*  444947 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(445018), // Rule ID 4033 //
     /*  444952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  444955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  444960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  444969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444980 */     // MIs[0] passthru
     /*  444980 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  444985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  444999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445016 */     GIR_RootConstrainSelectedInstOperands,
     /*  445017 */     // GIR_Coverage, 4033,
     /*  445017 */     GIR_EraseRootFromParent_Done,
     /*  445018 */   // Label 7726: @445018
     /*  445018 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(445089), // Rule ID 4042 //
     /*  445023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  445026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  445031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  445040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445051 */     // MIs[0] passthru
     /*  445051 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445067 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  445067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  445070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445087 */     GIR_RootConstrainSelectedInstOperands,
     /*  445088 */     // GIR_Coverage, 4042,
     /*  445088 */     GIR_EraseRootFromParent_Done,
     /*  445089 */   // Label 7727: @445089
     /*  445089 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(445160), // Rule ID 4043 //
     /*  445094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  445097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  445102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  445111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445122 */     // MIs[0] passthru
     /*  445122 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445138 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  445141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445158 */     GIR_RootConstrainSelectedInstOperands,
     /*  445159 */     // GIR_Coverage, 4043,
     /*  445159 */     GIR_EraseRootFromParent_Done,
     /*  445160 */   // Label 7728: @445160
     /*  445160 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(445231), // Rule ID 4052 //
     /*  445165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  445168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  445173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  445182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445193 */     // MIs[0] passthru
     /*  445193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  445209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  445212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445229 */     GIR_RootConstrainSelectedInstOperands,
     /*  445230 */     // GIR_Coverage, 4052,
     /*  445230 */     GIR_EraseRootFromParent_Done,
     /*  445231 */   // Label 7729: @445231
     /*  445231 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(445302), // Rule ID 4053 //
     /*  445236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  445239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  445244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  445253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445264 */     // MIs[0] passthru
     /*  445264 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  445283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445300 */     GIR_RootConstrainSelectedInstOperands,
     /*  445301 */     // GIR_Coverage, 4053,
     /*  445301 */     GIR_EraseRootFromParent_Done,
     /*  445302 */   // Label 7730: @445302
     /*  445302 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(445373), // Rule ID 4122 //
     /*  445307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  445324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445335 */     // MIs[0] passthru
     /*  445335 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  445354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445371 */     GIR_RootConstrainSelectedInstOperands,
     /*  445372 */     // GIR_Coverage, 4122,
     /*  445372 */     GIR_EraseRootFromParent_Done,
     /*  445373 */   // Label 7731: @445373
     /*  445373 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(445444), // Rule ID 4123 //
     /*  445378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  445395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445406 */     // MIs[0] passthru
     /*  445406 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445422 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  445425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445442 */     GIR_RootConstrainSelectedInstOperands,
     /*  445443 */     // GIR_Coverage, 4123,
     /*  445443 */     GIR_EraseRootFromParent_Done,
     /*  445444 */   // Label 7732: @445444
     /*  445444 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(445515), // Rule ID 4132 //
     /*  445449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  445460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  445463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  445466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445477 */     // MIs[0] passthru
     /*  445477 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  445496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445513 */     GIR_RootConstrainSelectedInstOperands,
     /*  445514 */     // GIR_Coverage, 4132,
     /*  445514 */     GIR_EraseRootFromParent_Done,
     /*  445515 */   // Label 7733: @445515
     /*  445515 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(445586), // Rule ID 4133 //
     /*  445520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  445531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  445534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  445537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445548 */     // MIs[0] passthru
     /*  445548 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  445567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445584 */     GIR_RootConstrainSelectedInstOperands,
     /*  445585 */     // GIR_Coverage, 4133,
     /*  445585 */     GIR_EraseRootFromParent_Done,
     /*  445586 */   // Label 7734: @445586
     /*  445586 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(445657), // Rule ID 4142 //
     /*  445591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  445602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  445605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  445608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445619 */     // MIs[0] passthru
     /*  445619 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445635 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  445638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445655 */     GIR_RootConstrainSelectedInstOperands,
     /*  445656 */     // GIR_Coverage, 4142,
     /*  445656 */     GIR_EraseRootFromParent_Done,
     /*  445657 */   // Label 7735: @445657
     /*  445657 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(445728), // Rule ID 4143 //
     /*  445662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  445673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  445676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  445679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445690 */     // MIs[0] passthru
     /*  445690 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  445709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445726 */     GIR_RootConstrainSelectedInstOperands,
     /*  445727 */     // GIR_Coverage, 4143,
     /*  445727 */     GIR_EraseRootFromParent_Done,
     /*  445728 */   // Label 7736: @445728
     /*  445728 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(445799), // Rule ID 4152 //
     /*  445733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  445744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  445747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  445750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445761 */     // MIs[0] passthru
     /*  445761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  445780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445797 */     GIR_RootConstrainSelectedInstOperands,
     /*  445798 */     // GIR_Coverage, 4152,
     /*  445798 */     GIR_EraseRootFromParent_Done,
     /*  445799 */   // Label 7737: @445799
     /*  445799 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(445870), // Rule ID 4153 //
     /*  445804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  445815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  445818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  445821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445832 */     // MIs[0] passthru
     /*  445832 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  445851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445868 */     GIR_RootConstrainSelectedInstOperands,
     /*  445869 */     // GIR_Coverage, 4153,
     /*  445869 */     GIR_EraseRootFromParent_Done,
     /*  445870 */   // Label 7738: @445870
     /*  445870 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(445941), // Rule ID 4162 //
     /*  445875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  445886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  445889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  445892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445903 */     // MIs[0] passthru
     /*  445903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  445922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445939 */     GIR_RootConstrainSelectedInstOperands,
     /*  445940 */     // GIR_Coverage, 4162,
     /*  445940 */     GIR_EraseRootFromParent_Done,
     /*  445941 */   // Label 7739: @445941
     /*  445941 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(446012), // Rule ID 4163 //
     /*  445946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  445954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  445957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  445960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  445963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445974 */     // MIs[0] passthru
     /*  445974 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  445979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  445993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  445999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446010 */     GIR_RootConstrainSelectedInstOperands,
     /*  446011 */     // GIR_Coverage, 4163,
     /*  446011 */     GIR_EraseRootFromParent_Done,
     /*  446012 */   // Label 7740: @446012
     /*  446012 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(446083), // Rule ID 4172 //
     /*  446017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  446028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  446031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  446034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446045 */     // MIs[0] passthru
     /*  446045 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  446064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446081 */     GIR_RootConstrainSelectedInstOperands,
     /*  446082 */     // GIR_Coverage, 4172,
     /*  446082 */     GIR_EraseRootFromParent_Done,
     /*  446083 */   // Label 7741: @446083
     /*  446083 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(446154), // Rule ID 4173 //
     /*  446088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  446099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  446102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  446105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446116 */     // MIs[0] passthru
     /*  446116 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  446135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446152 */     GIR_RootConstrainSelectedInstOperands,
     /*  446153 */     // GIR_Coverage, 4173,
     /*  446153 */     GIR_EraseRootFromParent_Done,
     /*  446154 */   // Label 7742: @446154
     /*  446154 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(446225), // Rule ID 4182 //
     /*  446159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  446176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446187 */     // MIs[0] passthru
     /*  446187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446203 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  446206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446223 */     GIR_RootConstrainSelectedInstOperands,
     /*  446224 */     // GIR_Coverage, 4182,
     /*  446224 */     GIR_EraseRootFromParent_Done,
     /*  446225 */   // Label 7743: @446225
     /*  446225 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(446296), // Rule ID 4183 //
     /*  446230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  446247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446258 */     // MIs[0] passthru
     /*  446258 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  446277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446294 */     GIR_RootConstrainSelectedInstOperands,
     /*  446295 */     // GIR_Coverage, 4183,
     /*  446295 */     GIR_EraseRootFromParent_Done,
     /*  446296 */   // Label 7744: @446296
     /*  446296 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(446367), // Rule ID 4192 //
     /*  446301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  446318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446329 */     // MIs[0] passthru
     /*  446329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446345 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  446348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446365 */     GIR_RootConstrainSelectedInstOperands,
     /*  446366 */     // GIR_Coverage, 4192,
     /*  446366 */     GIR_EraseRootFromParent_Done,
     /*  446367 */   // Label 7745: @446367
     /*  446367 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(446438), // Rule ID 4193 //
     /*  446372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  446389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446400 */     // MIs[0] passthru
     /*  446400 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  446419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446436 */     GIR_RootConstrainSelectedInstOperands,
     /*  446437 */     // GIR_Coverage, 4193,
     /*  446437 */     GIR_EraseRootFromParent_Done,
     /*  446438 */   // Label 7746: @446438
     /*  446438 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(446509), // Rule ID 4202 //
     /*  446443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  446454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  446457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  446460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446471 */     // MIs[0] passthru
     /*  446471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  446490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446507 */     GIR_RootConstrainSelectedInstOperands,
     /*  446508 */     // GIR_Coverage, 4202,
     /*  446508 */     GIR_EraseRootFromParent_Done,
     /*  446509 */   // Label 7747: @446509
     /*  446509 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(446580), // Rule ID 4203 //
     /*  446514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  446525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  446528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  446531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446542 */     // MIs[0] passthru
     /*  446542 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  446561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446578 */     GIR_RootConstrainSelectedInstOperands,
     /*  446579 */     // GIR_Coverage, 4203,
     /*  446579 */     GIR_EraseRootFromParent_Done,
     /*  446580 */   // Label 7748: @446580
     /*  446580 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(446651), // Rule ID 4212 //
     /*  446585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  446596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  446599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  446602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446613 */     // MIs[0] passthru
     /*  446613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  446632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446649 */     GIR_RootConstrainSelectedInstOperands,
     /*  446650 */     // GIR_Coverage, 4212,
     /*  446650 */     GIR_EraseRootFromParent_Done,
     /*  446651 */   // Label 7749: @446651
     /*  446651 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(446722), // Rule ID 4213 //
     /*  446656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  446667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  446670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  446673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446684 */     // MIs[0] passthru
     /*  446684 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  446703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446720 */     GIR_RootConstrainSelectedInstOperands,
     /*  446721 */     // GIR_Coverage, 4213,
     /*  446721 */     GIR_EraseRootFromParent_Done,
     /*  446722 */   // Label 7750: @446722
     /*  446722 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(446793), // Rule ID 4222 //
     /*  446727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  446738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  446741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  446744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446755 */     // MIs[0] passthru
     /*  446755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  446774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446791 */     GIR_RootConstrainSelectedInstOperands,
     /*  446792 */     // GIR_Coverage, 4222,
     /*  446792 */     GIR_EraseRootFromParent_Done,
     /*  446793 */   // Label 7751: @446793
     /*  446793 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(446864), // Rule ID 4223 //
     /*  446798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  446809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  446812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  446815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446826 */     // MIs[0] passthru
     /*  446826 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  446845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446862 */     GIR_RootConstrainSelectedInstOperands,
     /*  446863 */     // GIR_Coverage, 4223,
     /*  446863 */     GIR_EraseRootFromParent_Done,
     /*  446864 */   // Label 7752: @446864
     /*  446864 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(446935), // Rule ID 4232 //
     /*  446869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  446872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  446886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446897 */     // MIs[0] passthru
     /*  446897 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446913 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  446916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446933 */     GIR_RootConstrainSelectedInstOperands,
     /*  446934 */     // GIR_Coverage, 4232,
     /*  446934 */     GIR_EraseRootFromParent_Done,
     /*  446935 */   // Label 7753: @446935
     /*  446935 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(447006), // Rule ID 4233 //
     /*  446940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  446943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  446948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  446957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446968 */     // MIs[0] passthru
     /*  446968 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  446973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  446987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  446993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447004 */     GIR_RootConstrainSelectedInstOperands,
     /*  447005 */     // GIR_Coverage, 4233,
     /*  447005 */     GIR_EraseRootFromParent_Done,
     /*  447006 */   // Label 7754: @447006
     /*  447006 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(447077), // Rule ID 4242 //
     /*  447011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  447014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  447022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  447025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  447028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447039 */     // MIs[0] passthru
     /*  447039 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  447058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447075 */     GIR_RootConstrainSelectedInstOperands,
     /*  447076 */     // GIR_Coverage, 4242,
     /*  447076 */     GIR_EraseRootFromParent_Done,
     /*  447077 */   // Label 7755: @447077
     /*  447077 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(447148), // Rule ID 4243 //
     /*  447082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  447085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  447093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  447096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  447099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447110 */     // MIs[0] passthru
     /*  447110 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  447129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447146 */     GIR_RootConstrainSelectedInstOperands,
     /*  447147 */     // GIR_Coverage, 4243,
     /*  447147 */     GIR_EraseRootFromParent_Done,
     /*  447148 */   // Label 7756: @447148
     /*  447148 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(447219), // Rule ID 4252 //
     /*  447153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  447156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  447164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  447167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  447170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447181 */     // MIs[0] passthru
     /*  447181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447197 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  447200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447217 */     GIR_RootConstrainSelectedInstOperands,
     /*  447218 */     // GIR_Coverage, 4252,
     /*  447218 */     GIR_EraseRootFromParent_Done,
     /*  447219 */   // Label 7757: @447219
     /*  447219 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(447290), // Rule ID 4253 //
     /*  447224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  447227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  447235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  447238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  447241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447252 */     // MIs[0] passthru
     /*  447252 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  447271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447288 */     GIR_RootConstrainSelectedInstOperands,
     /*  447289 */     // GIR_Coverage, 4253,
     /*  447289 */     GIR_EraseRootFromParent_Done,
     /*  447290 */   // Label 7758: @447290
     /*  447290 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(447361), // Rule ID 4262 //
     /*  447295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  447298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  447306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  447309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  447312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447323 */     // MIs[0] passthru
     /*  447323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447339 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  447342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447359 */     GIR_RootConstrainSelectedInstOperands,
     /*  447360 */     // GIR_Coverage, 4262,
     /*  447360 */     GIR_EraseRootFromParent_Done,
     /*  447361 */   // Label 7759: @447361
     /*  447361 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(447432), // Rule ID 4263 //
     /*  447366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  447369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  447374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  447377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  447380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  447383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447394 */     // MIs[0] passthru
     /*  447394 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  447413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447430 */     GIR_RootConstrainSelectedInstOperands,
     /*  447431 */     // GIR_Coverage, 4263,
     /*  447431 */     GIR_EraseRootFromParent_Done,
     /*  447432 */   // Label 7760: @447432
     /*  447432 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(447503), // Rule ID 4332 //
     /*  447437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  447448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  447451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  447454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447465 */     // MIs[0] passthru
     /*  447465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447481 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  447484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447501 */     GIR_RootConstrainSelectedInstOperands,
     /*  447502 */     // GIR_Coverage, 4332,
     /*  447502 */     GIR_EraseRootFromParent_Done,
     /*  447503 */   // Label 7761: @447503
     /*  447503 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(447574), // Rule ID 4333 //
     /*  447508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  447519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  447522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  447525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447536 */     // MIs[0] passthru
     /*  447536 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  447555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447572 */     GIR_RootConstrainSelectedInstOperands,
     /*  447573 */     // GIR_Coverage, 4333,
     /*  447573 */     GIR_EraseRootFromParent_Done,
     /*  447574 */   // Label 7762: @447574
     /*  447574 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(447645), // Rule ID 4342 //
     /*  447579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  447590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  447593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  447596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447607 */     // MIs[0] passthru
     /*  447607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  447626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447643 */     GIR_RootConstrainSelectedInstOperands,
     /*  447644 */     // GIR_Coverage, 4342,
     /*  447644 */     GIR_EraseRootFromParent_Done,
     /*  447645 */   // Label 7763: @447645
     /*  447645 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(447716), // Rule ID 4343 //
     /*  447650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  447661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  447664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  447667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447678 */     // MIs[0] passthru
     /*  447678 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  447697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447714 */     GIR_RootConstrainSelectedInstOperands,
     /*  447715 */     // GIR_Coverage, 4343,
     /*  447715 */     GIR_EraseRootFromParent_Done,
     /*  447716 */   // Label 7764: @447716
     /*  447716 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(447787), // Rule ID 4352 //
     /*  447721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  447732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  447735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  447738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447749 */     // MIs[0] passthru
     /*  447749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  447768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447785 */     GIR_RootConstrainSelectedInstOperands,
     /*  447786 */     // GIR_Coverage, 4352,
     /*  447786 */     GIR_EraseRootFromParent_Done,
     /*  447787 */   // Label 7765: @447787
     /*  447787 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(447858), // Rule ID 4353 //
     /*  447792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  447803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  447806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  447809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447820 */     // MIs[0] passthru
     /*  447820 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  447839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447856 */     GIR_RootConstrainSelectedInstOperands,
     /*  447857 */     // GIR_Coverage, 4353,
     /*  447857 */     GIR_EraseRootFromParent_Done,
     /*  447858 */   // Label 7766: @447858
     /*  447858 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(447929), // Rule ID 4362 //
     /*  447863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  447880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447891 */     // MIs[0] passthru
     /*  447891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  447910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447927 */     GIR_RootConstrainSelectedInstOperands,
     /*  447928 */     // GIR_Coverage, 4362,
     /*  447928 */     GIR_EraseRootFromParent_Done,
     /*  447929 */   // Label 7767: @447929
     /*  447929 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(448000), // Rule ID 4363 //
     /*  447934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  447942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  447951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447962 */     // MIs[0] passthru
     /*  447962 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  447967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  447981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  447987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447998 */     GIR_RootConstrainSelectedInstOperands,
     /*  447999 */     // GIR_Coverage, 4363,
     /*  447999 */     GIR_EraseRootFromParent_Done,
     /*  448000 */   // Label 7768: @448000
     /*  448000 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(448071), // Rule ID 4372 //
     /*  448005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  448022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448033 */     // MIs[0] passthru
     /*  448033 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448049 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  448049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  448052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448069 */     GIR_RootConstrainSelectedInstOperands,
     /*  448070 */     // GIR_Coverage, 4372,
     /*  448070 */     GIR_EraseRootFromParent_Done,
     /*  448071 */   // Label 7769: @448071
     /*  448071 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(448142), // Rule ID 4373 //
     /*  448076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  448093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448104 */     // MIs[0] passthru
     /*  448104 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  448120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  448123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448140 */     GIR_RootConstrainSelectedInstOperands,
     /*  448141 */     // GIR_Coverage, 4373,
     /*  448141 */     GIR_EraseRootFromParent_Done,
     /*  448142 */   // Label 7770: @448142
     /*  448142 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(448213), // Rule ID 4382 //
     /*  448147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  448164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448175 */     // MIs[0] passthru
     /*  448175 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448191 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  448191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  448194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448211 */     GIR_RootConstrainSelectedInstOperands,
     /*  448212 */     // GIR_Coverage, 4382,
     /*  448212 */     GIR_EraseRootFromParent_Done,
     /*  448213 */   // Label 7771: @448213
     /*  448213 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(448284), // Rule ID 4383 //
     /*  448218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  448235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448246 */     // MIs[0] passthru
     /*  448246 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  448262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  448265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448282 */     GIR_RootConstrainSelectedInstOperands,
     /*  448283 */     // GIR_Coverage, 4383,
     /*  448283 */     GIR_EraseRootFromParent_Done,
     /*  448284 */   // Label 7772: @448284
     /*  448284 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(448355), // Rule ID 4392 //
     /*  448289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  448300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  448303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  448306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448317 */     // MIs[0] passthru
     /*  448317 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448333 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  448336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448353 */     GIR_RootConstrainSelectedInstOperands,
     /*  448354 */     // GIR_Coverage, 4392,
     /*  448354 */     GIR_EraseRootFromParent_Done,
     /*  448355 */   // Label 7773: @448355
     /*  448355 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(448426), // Rule ID 4393 //
     /*  448360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  448371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  448374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  448377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448388 */     // MIs[0] passthru
     /*  448388 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  448407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448424 */     GIR_RootConstrainSelectedInstOperands,
     /*  448425 */     // GIR_Coverage, 4393,
     /*  448425 */     GIR_EraseRootFromParent_Done,
     /*  448426 */   // Label 7774: @448426
     /*  448426 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(448497), // Rule ID 4402 //
     /*  448431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  448442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  448445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  448448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448459 */     // MIs[0] passthru
     /*  448459 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  448478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448495 */     GIR_RootConstrainSelectedInstOperands,
     /*  448496 */     // GIR_Coverage, 4402,
     /*  448496 */     GIR_EraseRootFromParent_Done,
     /*  448497 */   // Label 7775: @448497
     /*  448497 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(448568), // Rule ID 4403 //
     /*  448502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  448513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  448516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  448519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448530 */     // MIs[0] passthru
     /*  448530 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  448549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448566 */     GIR_RootConstrainSelectedInstOperands,
     /*  448567 */     // GIR_Coverage, 4403,
     /*  448567 */     GIR_EraseRootFromParent_Done,
     /*  448568 */   // Label 7776: @448568
     /*  448568 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(448639), // Rule ID 4412 //
     /*  448573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  448590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448601 */     // MIs[0] passthru
     /*  448601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  448620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448637 */     GIR_RootConstrainSelectedInstOperands,
     /*  448638 */     // GIR_Coverage, 4412,
     /*  448638 */     GIR_EraseRootFromParent_Done,
     /*  448639 */   // Label 7777: @448639
     /*  448639 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(448710), // Rule ID 4413 //
     /*  448644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  448661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448672 */     // MIs[0] passthru
     /*  448672 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  448691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448708 */     GIR_RootConstrainSelectedInstOperands,
     /*  448709 */     // GIR_Coverage, 4413,
     /*  448709 */     GIR_EraseRootFromParent_Done,
     /*  448710 */   // Label 7778: @448710
     /*  448710 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(448781), // Rule ID 4422 //
     /*  448715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  448732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448743 */     // MIs[0] passthru
     /*  448743 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448759 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  448762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448779 */     GIR_RootConstrainSelectedInstOperands,
     /*  448780 */     // GIR_Coverage, 4422,
     /*  448780 */     GIR_EraseRootFromParent_Done,
     /*  448781 */   // Label 7779: @448781
     /*  448781 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(448852), // Rule ID 4423 //
     /*  448786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  448803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448814 */     // MIs[0] passthru
     /*  448814 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  448833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448850 */     GIR_RootConstrainSelectedInstOperands,
     /*  448851 */     // GIR_Coverage, 4423,
     /*  448851 */     GIR_EraseRootFromParent_Done,
     /*  448852 */   // Label 7780: @448852
     /*  448852 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(448923), // Rule ID 4432 //
     /*  448857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  448874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448885 */     // MIs[0] passthru
     /*  448885 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  448904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448921 */     GIR_RootConstrainSelectedInstOperands,
     /*  448922 */     // GIR_Coverage, 4432,
     /*  448922 */     GIR_EraseRootFromParent_Done,
     /*  448923 */   // Label 7781: @448923
     /*  448923 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(448994), // Rule ID 4433 //
     /*  448928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  448936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  448945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448956 */     // MIs[0] passthru
     /*  448956 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  448961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  448975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  448981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448992 */     GIR_RootConstrainSelectedInstOperands,
     /*  448993 */     // GIR_Coverage, 4433,
     /*  448993 */     GIR_EraseRootFromParent_Done,
     /*  448994 */   // Label 7782: @448994
     /*  448994 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(449065), // Rule ID 4442 //
     /*  448999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  449002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  449010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  449013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  449016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449027 */     // MIs[0] passthru
     /*  449027 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  449043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  449046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449063 */     GIR_RootConstrainSelectedInstOperands,
     /*  449064 */     // GIR_Coverage, 4442,
     /*  449064 */     GIR_EraseRootFromParent_Done,
     /*  449065 */   // Label 7783: @449065
     /*  449065 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(449136), // Rule ID 4443 //
     /*  449070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  449073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  449081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  449084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  449087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449098 */     // MIs[0] passthru
     /*  449098 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  449117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449134 */     GIR_RootConstrainSelectedInstOperands,
     /*  449135 */     // GIR_Coverage, 4443,
     /*  449135 */     GIR_EraseRootFromParent_Done,
     /*  449136 */   // Label 7784: @449136
     /*  449136 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(449207), // Rule ID 4452 //
     /*  449141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  449144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  449158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449169 */     // MIs[0] passthru
     /*  449169 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  449185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  449188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449205 */     GIR_RootConstrainSelectedInstOperands,
     /*  449206 */     // GIR_Coverage, 4452,
     /*  449206 */     GIR_EraseRootFromParent_Done,
     /*  449207 */   // Label 7785: @449207
     /*  449207 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(449278), // Rule ID 4453 //
     /*  449212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  449215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  449229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449240 */     // MIs[0] passthru
     /*  449240 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  449259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449276 */     GIR_RootConstrainSelectedInstOperands,
     /*  449277 */     // GIR_Coverage, 4453,
     /*  449277 */     GIR_EraseRootFromParent_Done,
     /*  449278 */   // Label 7786: @449278
     /*  449278 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(449349), // Rule ID 4462 //
     /*  449283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  449286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  449300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449311 */     // MIs[0] passthru
     /*  449311 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  449327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  449330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449347 */     GIR_RootConstrainSelectedInstOperands,
     /*  449348 */     // GIR_Coverage, 4462,
     /*  449348 */     GIR_EraseRootFromParent_Done,
     /*  449349 */   // Label 7787: @449349
     /*  449349 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(449420), // Rule ID 4463 //
     /*  449354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  449357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  449371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449382 */     // MIs[0] passthru
     /*  449382 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  449401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449418 */     GIR_RootConstrainSelectedInstOperands,
     /*  449419 */     // GIR_Coverage, 4463,
     /*  449419 */     GIR_EraseRootFromParent_Done,
     /*  449420 */   // Label 7788: @449420
     /*  449420 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(449491), // Rule ID 4472 //
     /*  449425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  449428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  449442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449453 */     // MIs[0] passthru
     /*  449453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  449469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  449472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449489 */     GIR_RootConstrainSelectedInstOperands,
     /*  449490 */     // GIR_Coverage, 4472,
     /*  449490 */     GIR_EraseRootFromParent_Done,
     /*  449491 */   // Label 7789: @449491
     /*  449491 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(449562), // Rule ID 4473 //
     /*  449496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  449499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  449504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  449513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449524 */     // MIs[0] passthru
     /*  449524 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  449543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449560 */     GIR_RootConstrainSelectedInstOperands,
     /*  449561 */     // GIR_Coverage, 4473,
     /*  449561 */     GIR_EraseRootFromParent_Done,
     /*  449562 */   // Label 7790: @449562
     /*  449562 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(449633), // Rule ID 4542 //
     /*  449567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  449584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449595 */     // MIs[0] passthru
     /*  449595 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  449614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449631 */     GIR_RootConstrainSelectedInstOperands,
     /*  449632 */     // GIR_Coverage, 4542,
     /*  449632 */     GIR_EraseRootFromParent_Done,
     /*  449633 */   // Label 7791: @449633
     /*  449633 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(449704), // Rule ID 4543 //
     /*  449638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  449655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449666 */     // MIs[0] passthru
     /*  449666 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  449685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449702 */     GIR_RootConstrainSelectedInstOperands,
     /*  449703 */     // GIR_Coverage, 4543,
     /*  449703 */     GIR_EraseRootFromParent_Done,
     /*  449704 */   // Label 7792: @449704
     /*  449704 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(449775), // Rule ID 4552 //
     /*  449709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  449726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449737 */     // MIs[0] passthru
     /*  449737 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449753 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  449756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449773 */     GIR_RootConstrainSelectedInstOperands,
     /*  449774 */     // GIR_Coverage, 4552,
     /*  449774 */     GIR_EraseRootFromParent_Done,
     /*  449775 */   // Label 7793: @449775
     /*  449775 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(449846), // Rule ID 4553 //
     /*  449780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  449797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449808 */     // MIs[0] passthru
     /*  449808 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  449827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449844 */     GIR_RootConstrainSelectedInstOperands,
     /*  449845 */     // GIR_Coverage, 4553,
     /*  449845 */     GIR_EraseRootFromParent_Done,
     /*  449846 */   // Label 7794: @449846
     /*  449846 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(449917), // Rule ID 4562 //
     /*  449851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  449862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  449865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  449868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449879 */     // MIs[0] passthru
     /*  449879 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  449898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449915 */     GIR_RootConstrainSelectedInstOperands,
     /*  449916 */     // GIR_Coverage, 4562,
     /*  449916 */     GIR_EraseRootFromParent_Done,
     /*  449917 */   // Label 7795: @449917
     /*  449917 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(449988), // Rule ID 4563 //
     /*  449922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  449930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  449933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  449936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  449939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449950 */     // MIs[0] passthru
     /*  449950 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  449955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  449969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  449975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449986 */     GIR_RootConstrainSelectedInstOperands,
     /*  449987 */     // GIR_Coverage, 4563,
     /*  449987 */     GIR_EraseRootFromParent_Done,
     /*  449988 */   // Label 7796: @449988
     /*  449988 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(450059), // Rule ID 4572 //
     /*  449993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  450004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  450007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  450010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450021 */     // MIs[0] passthru
     /*  450021 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  450040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450057 */     GIR_RootConstrainSelectedInstOperands,
     /*  450058 */     // GIR_Coverage, 4572,
     /*  450058 */     GIR_EraseRootFromParent_Done,
     /*  450059 */   // Label 7797: @450059
     /*  450059 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(450130), // Rule ID 4573 //
     /*  450064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  450075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  450078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  450081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450092 */     // MIs[0] passthru
     /*  450092 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  450111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450128 */     GIR_RootConstrainSelectedInstOperands,
     /*  450129 */     // GIR_Coverage, 4573,
     /*  450129 */     GIR_EraseRootFromParent_Done,
     /*  450130 */   // Label 7798: @450130
     /*  450130 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(450201), // Rule ID 4582 //
     /*  450135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  450146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  450149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  450152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450163 */     // MIs[0] passthru
     /*  450163 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450179 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  450182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450199 */     GIR_RootConstrainSelectedInstOperands,
     /*  450200 */     // GIR_Coverage, 4582,
     /*  450200 */     GIR_EraseRootFromParent_Done,
     /*  450201 */   // Label 7799: @450201
     /*  450201 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(450272), // Rule ID 4583 //
     /*  450206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  450217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  450220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  450223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450234 */     // MIs[0] passthru
     /*  450234 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450250 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  450253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450270 */     GIR_RootConstrainSelectedInstOperands,
     /*  450271 */     // GIR_Coverage, 4583,
     /*  450271 */     GIR_EraseRootFromParent_Done,
     /*  450272 */   // Label 7800: @450272
     /*  450272 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(450343), // Rule ID 4592 //
     /*  450277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  450288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  450291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  450294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450305 */     // MIs[0] passthru
     /*  450305 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  450324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450341 */     GIR_RootConstrainSelectedInstOperands,
     /*  450342 */     // GIR_Coverage, 4592,
     /*  450342 */     GIR_EraseRootFromParent_Done,
     /*  450343 */   // Label 7801: @450343
     /*  450343 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(450414), // Rule ID 4593 //
     /*  450348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  450359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  450362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  450365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450376 */     // MIs[0] passthru
     /*  450376 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  450395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450412 */     GIR_RootConstrainSelectedInstOperands,
     /*  450413 */     // GIR_Coverage, 4593,
     /*  450413 */     GIR_EraseRootFromParent_Done,
     /*  450414 */   // Label 7802: @450414
     /*  450414 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(450485), // Rule ID 4602 //
     /*  450419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  450436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450447 */     // MIs[0] passthru
     /*  450447 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450463 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  450466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450483 */     GIR_RootConstrainSelectedInstOperands,
     /*  450484 */     // GIR_Coverage, 4602,
     /*  450484 */     GIR_EraseRootFromParent_Done,
     /*  450485 */   // Label 7803: @450485
     /*  450485 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(450556), // Rule ID 4603 //
     /*  450490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  450507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450518 */     // MIs[0] passthru
     /*  450518 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  450537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450554 */     GIR_RootConstrainSelectedInstOperands,
     /*  450555 */     // GIR_Coverage, 4603,
     /*  450555 */     GIR_EraseRootFromParent_Done,
     /*  450556 */   // Label 7804: @450556
     /*  450556 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(450627), // Rule ID 4612 //
     /*  450561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  450578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450589 */     // MIs[0] passthru
     /*  450589 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  450608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450625 */     GIR_RootConstrainSelectedInstOperands,
     /*  450626 */     // GIR_Coverage, 4612,
     /*  450626 */     GIR_EraseRootFromParent_Done,
     /*  450627 */   // Label 7805: @450627
     /*  450627 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(450698), // Rule ID 4613 //
     /*  450632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  450649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450660 */     // MIs[0] passthru
     /*  450660 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  450679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450696 */     GIR_RootConstrainSelectedInstOperands,
     /*  450697 */     // GIR_Coverage, 4613,
     /*  450697 */     GIR_EraseRootFromParent_Done,
     /*  450698 */   // Label 7806: @450698
     /*  450698 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(450769), // Rule ID 4622 //
     /*  450703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  450714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  450717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  450720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450731 */     // MIs[0] passthru
     /*  450731 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  450750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450767 */     GIR_RootConstrainSelectedInstOperands,
     /*  450768 */     // GIR_Coverage, 4622,
     /*  450768 */     GIR_EraseRootFromParent_Done,
     /*  450769 */   // Label 7807: @450769
     /*  450769 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(450840), // Rule ID 4623 //
     /*  450774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  450785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  450788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  450791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450802 */     // MIs[0] passthru
     /*  450802 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  450821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450838 */     GIR_RootConstrainSelectedInstOperands,
     /*  450839 */     // GIR_Coverage, 4623,
     /*  450839 */     GIR_EraseRootFromParent_Done,
     /*  450840 */   // Label 7808: @450840
     /*  450840 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(450911), // Rule ID 4632 //
     /*  450845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  450856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  450859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  450862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450873 */     // MIs[0] passthru
     /*  450873 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450889 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  450892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450909 */     GIR_RootConstrainSelectedInstOperands,
     /*  450910 */     // GIR_Coverage, 4632,
     /*  450910 */     GIR_EraseRootFromParent_Done,
     /*  450911 */   // Label 7809: @450911
     /*  450911 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(450982), // Rule ID 4633 //
     /*  450916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  450927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  450930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  450933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450944 */     // MIs[0] passthru
     /*  450944 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  450949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450960 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  450963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  450969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450980 */     GIR_RootConstrainSelectedInstOperands,
     /*  450981 */     // GIR_Coverage, 4633,
     /*  450981 */     GIR_EraseRootFromParent_Done,
     /*  450982 */   // Label 7810: @450982
     /*  450982 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(451053), // Rule ID 4642 //
     /*  450987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  450995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  450998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  451001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  451004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451015 */     // MIs[0] passthru
     /*  451015 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451031 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  451034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451051 */     GIR_RootConstrainSelectedInstOperands,
     /*  451052 */     // GIR_Coverage, 4642,
     /*  451052 */     GIR_EraseRootFromParent_Done,
     /*  451053 */   // Label 7811: @451053
     /*  451053 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(451124), // Rule ID 4643 //
     /*  451058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  451069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  451072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  451075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451086 */     // MIs[0] passthru
     /*  451086 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  451105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451122 */     GIR_RootConstrainSelectedInstOperands,
     /*  451123 */     // GIR_Coverage, 4643,
     /*  451123 */     GIR_EraseRootFromParent_Done,
     /*  451124 */   // Label 7812: @451124
     /*  451124 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(451195), // Rule ID 4652 //
     /*  451129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  451132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  451146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451157 */     // MIs[0] passthru
     /*  451157 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451173 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  451176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451193 */     GIR_RootConstrainSelectedInstOperands,
     /*  451194 */     // GIR_Coverage, 4652,
     /*  451194 */     GIR_EraseRootFromParent_Done,
     /*  451195 */   // Label 7813: @451195
     /*  451195 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(451266), // Rule ID 4653 //
     /*  451200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  451203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  451217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451228 */     // MIs[0] passthru
     /*  451228 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  451247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451264 */     GIR_RootConstrainSelectedInstOperands,
     /*  451265 */     // GIR_Coverage, 4653,
     /*  451265 */     GIR_EraseRootFromParent_Done,
     /*  451266 */   // Label 7814: @451266
     /*  451266 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(451337), // Rule ID 4662 //
     /*  451271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  451274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  451282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  451285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  451288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451299 */     // MIs[0] passthru
     /*  451299 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  451318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451335 */     GIR_RootConstrainSelectedInstOperands,
     /*  451336 */     // GIR_Coverage, 4662,
     /*  451336 */     GIR_EraseRootFromParent_Done,
     /*  451337 */   // Label 7815: @451337
     /*  451337 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(451408), // Rule ID 4663 //
     /*  451342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  451345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  451353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  451356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  451359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451370 */     // MIs[0] passthru
     /*  451370 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  451389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451406 */     GIR_RootConstrainSelectedInstOperands,
     /*  451407 */     // GIR_Coverage, 4663,
     /*  451407 */     GIR_EraseRootFromParent_Done,
     /*  451408 */   // Label 7816: @451408
     /*  451408 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(451479), // Rule ID 4672 //
     /*  451413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  451416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  451424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  451427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  451430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451441 */     // MIs[0] passthru
     /*  451441 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451457 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  451460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451477 */     GIR_RootConstrainSelectedInstOperands,
     /*  451478 */     // GIR_Coverage, 4672,
     /*  451478 */     GIR_EraseRootFromParent_Done,
     /*  451479 */   // Label 7817: @451479
     /*  451479 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(451550), // Rule ID 4673 //
     /*  451484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  451487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  451495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  451498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  451501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451512 */     // MIs[0] passthru
     /*  451512 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  451531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451548 */     GIR_RootConstrainSelectedInstOperands,
     /*  451549 */     // GIR_Coverage, 4673,
     /*  451549 */     GIR_EraseRootFromParent_Done,
     /*  451550 */   // Label 7818: @451550
     /*  451550 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(451621), // Rule ID 4682 //
     /*  451555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  451558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  451566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  451569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  451572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451583 */     // MIs[0] passthru
     /*  451583 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  451602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451619 */     GIR_RootConstrainSelectedInstOperands,
     /*  451620 */     // GIR_Coverage, 4682,
     /*  451620 */     GIR_EraseRootFromParent_Done,
     /*  451621 */   // Label 7819: @451621
     /*  451621 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(451692), // Rule ID 4683 //
     /*  451626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  451629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  451634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  451637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  451640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  451643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451654 */     // MIs[0] passthru
     /*  451654 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  451659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  451673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451690 */     GIR_RootConstrainSelectedInstOperands,
     /*  451691 */     // GIR_Coverage, 4683,
     /*  451691 */     GIR_EraseRootFromParent_Done,
     /*  451692 */   // Label 7820: @451692
     /*  451692 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(451764), // Rule ID 2546 //
     /*  451697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  451705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  451708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  451711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  451714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  451717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451743 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  451743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  451746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451762 */     GIR_RootConstrainSelectedInstOperands,
     /*  451763 */     // GIR_Coverage, 2546,
     /*  451763 */     GIR_EraseRootFromParent_Done,
     /*  451764 */   // Label 7821: @451764
     /*  451764 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(451836), // Rule ID 2547 //
     /*  451769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  451777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  451780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  451783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  451786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  451789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451815 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  451815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  451818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  451826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451834 */     GIR_RootConstrainSelectedInstOperands,
     /*  451835 */     // GIR_Coverage, 2547,
     /*  451835 */     GIR_EraseRootFromParent_Done,
     /*  451836 */   // Label 7822: @451836
     /*  451836 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(451911), // Rule ID 2550 //
     /*  451841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  451844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  451849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  451852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  451855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  451858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  451861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  451868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  451880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  451887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  451890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  451896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  451898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  451909 */     GIR_RootConstrainSelectedInstOperands,
     /*  451910 */     // GIR_Coverage, 2550,
     /*  451910 */     GIR_EraseRootFromParent_Done,
     /*  451911 */   // Label 7823: @451911
     /*  451911 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(451986), // Rule ID 2551 //
     /*  451916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  451919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  451924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  451927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  451930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  451933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  451936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  451943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  451955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  451962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  451965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  451971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  451973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  451984 */     GIR_RootConstrainSelectedInstOperands,
     /*  451985 */     // GIR_Coverage, 2551,
     /*  451985 */     GIR_EraseRootFromParent_Done,
     /*  451986 */   // Label 7824: @451986
     /*  451986 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(452061), // Rule ID 2578 //
     /*  451991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  451999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452037 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  452040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452059 */     GIR_RootConstrainSelectedInstOperands,
     /*  452060 */     // GIR_Coverage, 2578,
     /*  452060 */     GIR_EraseRootFromParent_Done,
     /*  452061 */   // Label 7825: @452061
     /*  452061 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(452136), // Rule ID 2579 //
     /*  452066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  452074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452112 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  452115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452134 */     GIR_RootConstrainSelectedInstOperands,
     /*  452135 */     // GIR_Coverage, 2579,
     /*  452135 */     GIR_EraseRootFromParent_Done,
     /*  452136 */   // Label 7826: @452136
     /*  452136 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(452208), // Rule ID 2592 //
     /*  452141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  452149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  452152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  452161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  452180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  452187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  452190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  452194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  452198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452206 */     GIR_RootConstrainSelectedInstOperands,
     /*  452207 */     // GIR_Coverage, 2592,
     /*  452207 */     GIR_EraseRootFromParent_Done,
     /*  452208 */   // Label 7827: @452208
     /*  452208 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(452280), // Rule ID 2593 //
     /*  452213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  452221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  452224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  452233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  452252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452259 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  452259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  452262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  452266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  452270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452278 */     GIR_RootConstrainSelectedInstOperands,
     /*  452279 */     // GIR_Coverage, 2593,
     /*  452279 */     GIR_EraseRootFromParent_Done,
     /*  452280 */   // Label 7828: @452280
     /*  452280 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(452355), // Rule ID 2612 //
     /*  452285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  452293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  452296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  452299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  452302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452331 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  452334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452353 */     GIR_RootConstrainSelectedInstOperands,
     /*  452354 */     // GIR_Coverage, 2612,
     /*  452354 */     GIR_EraseRootFromParent_Done,
     /*  452355 */   // Label 7829: @452355
     /*  452355 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(452430), // Rule ID 2613 //
     /*  452360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  452368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  452371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  452374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  452377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  452409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452428 */     GIR_RootConstrainSelectedInstOperands,
     /*  452429 */     // GIR_Coverage, 2613,
     /*  452429 */     GIR_EraseRootFromParent_Done,
     /*  452430 */   // Label 7830: @452430
     /*  452430 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(452505), // Rule ID 2638 //
     /*  452435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  452443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  452446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  452449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  452455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452481 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  452484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  452488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452503 */     GIR_RootConstrainSelectedInstOperands,
     /*  452504 */     // GIR_Coverage, 2638,
     /*  452504 */     GIR_EraseRootFromParent_Done,
     /*  452505 */   // Label 7831: @452505
     /*  452505 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(452580), // Rule ID 2639 //
     /*  452510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  452518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  452521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  452524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  452530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  452559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  452563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  452567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452578 */     GIR_RootConstrainSelectedInstOperands,
     /*  452579 */     // GIR_Coverage, 2639,
     /*  452579 */     GIR_EraseRootFromParent_Done,
     /*  452580 */   // Label 7832: @452580
     /*  452580 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(452655), // Rule ID 2650 //
     /*  452585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452631 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  452634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  452640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452653 */     GIR_RootConstrainSelectedInstOperands,
     /*  452654 */     // GIR_Coverage, 2650,
     /*  452654 */     GIR_EraseRootFromParent_Done,
     /*  452655 */   // Label 7833: @452655
     /*  452655 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(452730), // Rule ID 2651 //
     /*  452660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  452680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  452709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  452715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452728 */     GIR_RootConstrainSelectedInstOperands,
     /*  452729 */     // GIR_Coverage, 2651,
     /*  452729 */     GIR_EraseRootFromParent_Done,
     /*  452730 */   // Label 7834: @452730
     /*  452730 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(452805), // Rule ID 2658 //
     /*  452735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  452746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  452749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  452752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  452755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452781 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  452784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  452790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452803 */     GIR_RootConstrainSelectedInstOperands,
     /*  452804 */     // GIR_Coverage, 2658,
     /*  452804 */     GIR_EraseRootFromParent_Done,
     /*  452805 */   // Label 7835: @452805
     /*  452805 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(452880), // Rule ID 2659 //
     /*  452810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  452821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  452824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  452827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  452830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  452859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  452865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452878 */     GIR_RootConstrainSelectedInstOperands,
     /*  452879 */     // GIR_Coverage, 2659,
     /*  452879 */     GIR_EraseRootFromParent_Done,
     /*  452880 */   // Label 7836: @452880
     /*  452880 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(452955), // Rule ID 2666 //
     /*  452885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  452896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  452899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  452902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  452905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452931 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  452934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  452940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  452942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452953 */     GIR_RootConstrainSelectedInstOperands,
     /*  452954 */     // GIR_Coverage, 2666,
     /*  452954 */     GIR_EraseRootFromParent_Done,
     /*  452955 */   // Label 7837: @452955
     /*  452955 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(453030), // Rule ID 2667 //
     /*  452960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  452968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  452971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  452974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  452977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  452980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  453009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453028 */     GIR_RootConstrainSelectedInstOperands,
     /*  453029 */     // GIR_Coverage, 2667,
     /*  453029 */     GIR_EraseRootFromParent_Done,
     /*  453030 */   // Label 7838: @453030
     /*  453030 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(453105), // Rule ID 2674 //
     /*  453035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  453055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  453084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453103 */     GIR_RootConstrainSelectedInstOperands,
     /*  453104 */     // GIR_Coverage, 2674,
     /*  453104 */     GIR_EraseRootFromParent_Done,
     /*  453105 */   // Label 7839: @453105
     /*  453105 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(453180), // Rule ID 2675 //
     /*  453110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  453130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  453159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453178 */     GIR_RootConstrainSelectedInstOperands,
     /*  453179 */     // GIR_Coverage, 2675,
     /*  453179 */     GIR_EraseRootFromParent_Done,
     /*  453180 */   // Label 7840: @453180
     /*  453180 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(453255), // Rule ID 2682 //
     /*  453185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  453205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453231 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  453234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453253 */     GIR_RootConstrainSelectedInstOperands,
     /*  453254 */     // GIR_Coverage, 2682,
     /*  453254 */     GIR_EraseRootFromParent_Done,
     /*  453255 */   // Label 7841: @453255
     /*  453255 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(453330), // Rule ID 2683 //
     /*  453260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  453280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  453309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453328 */     GIR_RootConstrainSelectedInstOperands,
     /*  453329 */     // GIR_Coverage, 2683,
     /*  453329 */     GIR_EraseRootFromParent_Done,
     /*  453330 */   // Label 7842: @453330
     /*  453330 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(453405), // Rule ID 2690 //
     /*  453335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  453355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453381 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  453384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453403 */     GIR_RootConstrainSelectedInstOperands,
     /*  453404 */     // GIR_Coverage, 2690,
     /*  453404 */     GIR_EraseRootFromParent_Done,
     /*  453405 */   // Label 7843: @453405
     /*  453405 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(453480), // Rule ID 2691 //
     /*  453410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  453430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  453459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453478 */     GIR_RootConstrainSelectedInstOperands,
     /*  453479 */     // GIR_Coverage, 2691,
     /*  453479 */     GIR_EraseRootFromParent_Done,
     /*  453480 */   // Label 7844: @453480
     /*  453480 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(453555), // Rule ID 2698 //
     /*  453485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  453505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453531 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453553 */     GIR_RootConstrainSelectedInstOperands,
     /*  453554 */     // GIR_Coverage, 2698,
     /*  453554 */     GIR_EraseRootFromParent_Done,
     /*  453555 */   // Label 7845: @453555
     /*  453555 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(453630), // Rule ID 2699 //
     /*  453560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  453580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453606 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453628 */     GIR_RootConstrainSelectedInstOperands,
     /*  453629 */     // GIR_Coverage, 2699,
     /*  453629 */     GIR_EraseRootFromParent_Done,
     /*  453630 */   // Label 7846: @453630
     /*  453630 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(453705), // Rule ID 2706 //
     /*  453635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  453646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  453649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  453652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  453655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453681 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453703 */     GIR_RootConstrainSelectedInstOperands,
     /*  453704 */     // GIR_Coverage, 2706,
     /*  453704 */     GIR_EraseRootFromParent_Done,
     /*  453705 */   // Label 7847: @453705
     /*  453705 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(453780), // Rule ID 2707 //
     /*  453710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  453721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  453724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  453727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  453730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453778 */     GIR_RootConstrainSelectedInstOperands,
     /*  453779 */     // GIR_Coverage, 2707,
     /*  453779 */     GIR_EraseRootFromParent_Done,
     /*  453780 */   // Label 7848: @453780
     /*  453780 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(453855), // Rule ID 2714 //
     /*  453785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  453796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  453799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  453802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  453805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453853 */     GIR_RootConstrainSelectedInstOperands,
     /*  453854 */     // GIR_Coverage, 2714,
     /*  453854 */     GIR_EraseRootFromParent_Done,
     /*  453855 */   // Label 7849: @453855
     /*  453855 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(453930), // Rule ID 2715 //
     /*  453860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  453871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  453874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  453877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  453880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453928 */     GIR_RootConstrainSelectedInstOperands,
     /*  453929 */     // GIR_Coverage, 2715,
     /*  453929 */     GIR_EraseRootFromParent_Done,
     /*  453930 */   // Label 7850: @453930
     /*  453930 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(454005), // Rule ID 2722 //
     /*  453935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  453943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  453946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  453949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  453952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  453955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  453984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  453990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  453992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454003 */     GIR_RootConstrainSelectedInstOperands,
     /*  454004 */     // GIR_Coverage, 2722,
     /*  454004 */     GIR_EraseRootFromParent_Done,
     /*  454005 */   // Label 7851: @454005
     /*  454005 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(454080), // Rule ID 2723 //
     /*  454010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  454030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  454059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454078 */     GIR_RootConstrainSelectedInstOperands,
     /*  454079 */     // GIR_Coverage, 2723,
     /*  454079 */     GIR_EraseRootFromParent_Done,
     /*  454080 */   // Label 7852: @454080
     /*  454080 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(454155), // Rule ID 2730 //
     /*  454085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  454105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  454134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454153 */     GIR_RootConstrainSelectedInstOperands,
     /*  454154 */     // GIR_Coverage, 2730,
     /*  454154 */     GIR_EraseRootFromParent_Done,
     /*  454155 */   // Label 7853: @454155
     /*  454155 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(454230), // Rule ID 2731 //
     /*  454160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  454180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  454209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454228 */     GIR_RootConstrainSelectedInstOperands,
     /*  454229 */     // GIR_Coverage, 2731,
     /*  454229 */     GIR_EraseRootFromParent_Done,
     /*  454230 */   // Label 7854: @454230
     /*  454230 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(454305), // Rule ID 2738 //
     /*  454235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  454255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454281 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  454284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454303 */     GIR_RootConstrainSelectedInstOperands,
     /*  454304 */     // GIR_Coverage, 2738,
     /*  454304 */     GIR_EraseRootFromParent_Done,
     /*  454305 */   // Label 7855: @454305
     /*  454305 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(454380), // Rule ID 2739 //
     /*  454310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  454330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  454359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454378 */     GIR_RootConstrainSelectedInstOperands,
     /*  454379 */     // GIR_Coverage, 2739,
     /*  454379 */     GIR_EraseRootFromParent_Done,
     /*  454380 */   // Label 7856: @454380
     /*  454380 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(454455), // Rule ID 2746 //
     /*  454385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  454405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454431 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  454434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454453 */     GIR_RootConstrainSelectedInstOperands,
     /*  454454 */     // GIR_Coverage, 2746,
     /*  454454 */     GIR_EraseRootFromParent_Done,
     /*  454455 */   // Label 7857: @454455
     /*  454455 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(454530), // Rule ID 2747 //
     /*  454460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  454480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  454509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454528 */     GIR_RootConstrainSelectedInstOperands,
     /*  454529 */     // GIR_Coverage, 2747,
     /*  454529 */     GIR_EraseRootFromParent_Done,
     /*  454530 */   // Label 7858: @454530
     /*  454530 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(454605), // Rule ID 2754 //
     /*  454535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  454546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  454549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  454552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  454555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  454584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454603 */     GIR_RootConstrainSelectedInstOperands,
     /*  454604 */     // GIR_Coverage, 2754,
     /*  454604 */     GIR_EraseRootFromParent_Done,
     /*  454605 */   // Label 7859: @454605
     /*  454605 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(454680), // Rule ID 2755 //
     /*  454610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  454621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  454624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  454627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  454630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  454659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454678 */     GIR_RootConstrainSelectedInstOperands,
     /*  454679 */     // GIR_Coverage, 2755,
     /*  454679 */     GIR_EraseRootFromParent_Done,
     /*  454680 */   // Label 7860: @454680
     /*  454680 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(454755), // Rule ID 2762 //
     /*  454685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  454696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  454699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  454702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  454705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454731 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  454734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454753 */     GIR_RootConstrainSelectedInstOperands,
     /*  454754 */     // GIR_Coverage, 2762,
     /*  454754 */     GIR_EraseRootFromParent_Done,
     /*  454755 */   // Label 7861: @454755
     /*  454755 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(454830), // Rule ID 2763 //
     /*  454760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  454771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  454774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  454777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  454780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  454809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454828 */     GIR_RootConstrainSelectedInstOperands,
     /*  454829 */     // GIR_Coverage, 2763,
     /*  454829 */     GIR_EraseRootFromParent_Done,
     /*  454830 */   // Label 7862: @454830
     /*  454830 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(454905), // Rule ID 2770 //
     /*  454835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  454846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  454849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  454852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  454855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454881 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  454884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454903 */     GIR_RootConstrainSelectedInstOperands,
     /*  454904 */     // GIR_Coverage, 2770,
     /*  454904 */     GIR_EraseRootFromParent_Done,
     /*  454905 */   // Label 7863: @454905
     /*  454905 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(454980), // Rule ID 2771 //
     /*  454910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  454921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  454924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  454927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  454930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  454959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  454965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  454967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454978 */     GIR_RootConstrainSelectedInstOperands,
     /*  454979 */     // GIR_Coverage, 2771,
     /*  454979 */     GIR_EraseRootFromParent_Done,
     /*  454980 */   // Label 7864: @454980
     /*  454980 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(455055), // Rule ID 2778 //
     /*  454985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  454993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  454996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  454999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  455005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  455034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455053 */     GIR_RootConstrainSelectedInstOperands,
     /*  455054 */     // GIR_Coverage, 2778,
     /*  455054 */     GIR_EraseRootFromParent_Done,
     /*  455055 */   // Label 7865: @455055
     /*  455055 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(455130), // Rule ID 2779 //
     /*  455060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  455080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  455109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455128 */     GIR_RootConstrainSelectedInstOperands,
     /*  455129 */     // GIR_Coverage, 2779,
     /*  455129 */     GIR_EraseRootFromParent_Done,
     /*  455130 */   // Label 7866: @455130
     /*  455130 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(455205), // Rule ID 2786 //
     /*  455135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  455155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  455184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455203 */     GIR_RootConstrainSelectedInstOperands,
     /*  455204 */     // GIR_Coverage, 2786,
     /*  455204 */     GIR_EraseRootFromParent_Done,
     /*  455205 */   // Label 7867: @455205
     /*  455205 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(455280), // Rule ID 2787 //
     /*  455210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  455230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  455259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455278 */     GIR_RootConstrainSelectedInstOperands,
     /*  455279 */     // GIR_Coverage, 2787,
     /*  455279 */     GIR_EraseRootFromParent_Done,
     /*  455280 */   // Label 7868: @455280
     /*  455280 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(455355), // Rule ID 2794 //
     /*  455285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  455302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  455305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455331 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  455334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455353 */     GIR_RootConstrainSelectedInstOperands,
     /*  455354 */     // GIR_Coverage, 2794,
     /*  455354 */     GIR_EraseRootFromParent_Done,
     /*  455355 */   // Label 7869: @455355
     /*  455355 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(455430), // Rule ID 2795 //
     /*  455360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  455377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  455380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  455409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455428 */     GIR_RootConstrainSelectedInstOperands,
     /*  455429 */     // GIR_Coverage, 2795,
     /*  455429 */     GIR_EraseRootFromParent_Done,
     /*  455430 */   // Label 7870: @455430
     /*  455430 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(455505), // Rule ID 2802 //
     /*  455435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  455446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  455449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  455452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  455455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  455481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  455484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455503 */     GIR_RootConstrainSelectedInstOperands,
     /*  455504 */     // GIR_Coverage, 2802,
     /*  455504 */     GIR_EraseRootFromParent_Done,
     /*  455505 */   // Label 7871: @455505
     /*  455505 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(455580), // Rule ID 2803 //
     /*  455510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  455513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  455521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  455524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  455527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  455530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  455559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455578 */     GIR_RootConstrainSelectedInstOperands,
     /*  455579 */     // GIR_Coverage, 2803,
     /*  455579 */     GIR_EraseRootFromParent_Done,
     /*  455580 */   // Label 7872: @455580
     /*  455580 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(455655), // Rule ID 2810 //
     /*  455585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  455596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  455599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  455602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  455605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455631 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  455631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  455634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455653 */     GIR_RootConstrainSelectedInstOperands,
     /*  455654 */     // GIR_Coverage, 2810,
     /*  455654 */     GIR_EraseRootFromParent_Done,
     /*  455655 */   // Label 7873: @455655
     /*  455655 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(455730), // Rule ID 2811 //
     /*  455660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  455663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  455671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  455674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  455677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  455680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455706 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  455709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455728 */     GIR_RootConstrainSelectedInstOperands,
     /*  455729 */     // GIR_Coverage, 2811,
     /*  455729 */     GIR_EraseRootFromParent_Done,
     /*  455730 */   // Label 7874: @455730
     /*  455730 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(455805), // Rule ID 2818 //
     /*  455735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  455746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  455749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  455752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  455755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455781 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  455781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  455784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455803 */     GIR_RootConstrainSelectedInstOperands,
     /*  455804 */     // GIR_Coverage, 2818,
     /*  455804 */     GIR_EraseRootFromParent_Done,
     /*  455805 */   // Label 7875: @455805
     /*  455805 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(455880), // Rule ID 2819 //
     /*  455810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  455813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  455818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  455821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  455824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  455827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  455830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  455859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  455865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  455867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455878 */     GIR_RootConstrainSelectedInstOperands,
     /*  455879 */     // GIR_Coverage, 2819,
     /*  455879 */     GIR_EraseRootFromParent_Done,
     /*  455880 */   // Label 7876: @455880
     /*  455880 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(455955), // Rule ID 2826 //
     /*  455885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  455893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  455896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  455899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  455902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  455905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455931 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  455934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  455942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455953 */     GIR_RootConstrainSelectedInstOperands,
     /*  455954 */     // GIR_Coverage, 2826,
     /*  455954 */     GIR_EraseRootFromParent_Done,
     /*  455955 */   // Label 7877: @455955
     /*  455955 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(456030), // Rule ID 2827 //
     /*  455960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  455968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  455971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  455974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  455977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  455980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  456009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456028 */     GIR_RootConstrainSelectedInstOperands,
     /*  456029 */     // GIR_Coverage, 2827,
     /*  456029 */     GIR_EraseRootFromParent_Done,
     /*  456030 */   // Label 7878: @456030
     /*  456030 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(456105), // Rule ID 2830 //
     /*  456035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  456046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  456049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  456052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  456055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456081 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456103 */     GIR_RootConstrainSelectedInstOperands,
     /*  456104 */     // GIR_Coverage, 2830,
     /*  456104 */     GIR_EraseRootFromParent_Done,
     /*  456105 */   // Label 7879: @456105
     /*  456105 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(456180), // Rule ID 2831 //
     /*  456110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  456121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  456124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  456127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  456130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456178 */     GIR_RootConstrainSelectedInstOperands,
     /*  456179 */     // GIR_Coverage, 2831,
     /*  456179 */     GIR_EraseRootFromParent_Done,
     /*  456180 */   // Label 7880: @456180
     /*  456180 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(456255), // Rule ID 2834 //
     /*  456185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  456196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  456199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  456202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  456205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456231 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  456231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  456234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456253 */     GIR_RootConstrainSelectedInstOperands,
     /*  456254 */     // GIR_Coverage, 2834,
     /*  456254 */     GIR_EraseRootFromParent_Done,
     /*  456255 */   // Label 7881: @456255
     /*  456255 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(456330), // Rule ID 2835 //
     /*  456260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  456271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  456274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  456277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  456280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  456309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456328 */     GIR_RootConstrainSelectedInstOperands,
     /*  456329 */     // GIR_Coverage, 2835,
     /*  456329 */     GIR_EraseRootFromParent_Done,
     /*  456330 */   // Label 7882: @456330
     /*  456330 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(456405), // Rule ID 2838 //
     /*  456335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  456346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  456349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  456352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  456355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456381 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  456381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456403 */     GIR_RootConstrainSelectedInstOperands,
     /*  456404 */     // GIR_Coverage, 2838,
     /*  456404 */     GIR_EraseRootFromParent_Done,
     /*  456405 */   // Label 7883: @456405
     /*  456405 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(456480), // Rule ID 2839 //
     /*  456410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  456421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  456424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  456427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  456430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456478 */     GIR_RootConstrainSelectedInstOperands,
     /*  456479 */     // GIR_Coverage, 2839,
     /*  456479 */     GIR_EraseRootFromParent_Done,
     /*  456480 */   // Label 7884: @456480
     /*  456480 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(456555), // Rule ID 2842 //
     /*  456485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  456496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  456499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  456502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  456505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456531 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456553 */     GIR_RootConstrainSelectedInstOperands,
     /*  456554 */     // GIR_Coverage, 2842,
     /*  456554 */     GIR_EraseRootFromParent_Done,
     /*  456555 */   // Label 7885: @456555
     /*  456555 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(456630), // Rule ID 2843 //
     /*  456560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  456571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  456574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  456577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  456580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  456609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456628 */     GIR_RootConstrainSelectedInstOperands,
     /*  456629 */     // GIR_Coverage, 2843,
     /*  456629 */     GIR_EraseRootFromParent_Done,
     /*  456630 */   // Label 7886: @456630
     /*  456630 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(456705), // Rule ID 2846 //
     /*  456635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  456646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  456649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  456652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  456655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456681 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  456684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456703 */     GIR_RootConstrainSelectedInstOperands,
     /*  456704 */     // GIR_Coverage, 2846,
     /*  456704 */     GIR_EraseRootFromParent_Done,
     /*  456705 */   // Label 7887: @456705
     /*  456705 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(456780), // Rule ID 2847 //
     /*  456710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  456721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  456724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  456727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  456730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  456759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456778 */     GIR_RootConstrainSelectedInstOperands,
     /*  456779 */     // GIR_Coverage, 2847,
     /*  456779 */     GIR_EraseRootFromParent_Done,
     /*  456780 */   // Label 7888: @456780
     /*  456780 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(456855), // Rule ID 2850 //
     /*  456785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  456796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  456799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  456802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  456805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456831 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  456831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  456834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456853 */     GIR_RootConstrainSelectedInstOperands,
     /*  456854 */     // GIR_Coverage, 2850,
     /*  456854 */     GIR_EraseRootFromParent_Done,
     /*  456855 */   // Label 7889: @456855
     /*  456855 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(456930), // Rule ID 2851 //
     /*  456860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  456871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  456874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  456877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  456880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  456909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456928 */     GIR_RootConstrainSelectedInstOperands,
     /*  456929 */     // GIR_Coverage, 2851,
     /*  456929 */     GIR_EraseRootFromParent_Done,
     /*  456930 */   // Label 7890: @456930
     /*  456930 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(457005), // Rule ID 2854 //
     /*  456935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  456943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  456946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  456949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  456952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  456955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456981 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  456984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  456992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457003 */     GIR_RootConstrainSelectedInstOperands,
     /*  457004 */     // GIR_Coverage, 2854,
     /*  457004 */     GIR_EraseRootFromParent_Done,
     /*  457005 */   // Label 7891: @457005
     /*  457005 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(457080), // Rule ID 2855 //
     /*  457010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  457021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  457024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  457027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  457030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  457059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457078 */     GIR_RootConstrainSelectedInstOperands,
     /*  457079 */     // GIR_Coverage, 2855,
     /*  457079 */     GIR_EraseRootFromParent_Done,
     /*  457080 */   // Label 7892: @457080
     /*  457080 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(457155), // Rule ID 2858 //
     /*  457085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  457088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  457096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  457099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  457102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  457105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457131 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  457131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  457134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457153 */     GIR_RootConstrainSelectedInstOperands,
     /*  457154 */     // GIR_Coverage, 2858,
     /*  457154 */     GIR_EraseRootFromParent_Done,
     /*  457155 */   // Label 7893: @457155
     /*  457155 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(457230), // Rule ID 2859 //
     /*  457160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  457163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  457171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  457174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  457177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  457180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  457206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  457209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457228 */     GIR_RootConstrainSelectedInstOperands,
     /*  457229 */     // GIR_Coverage, 2859,
     /*  457229 */     GIR_EraseRootFromParent_Done,
     /*  457230 */   // Label 7894: @457230
     /*  457230 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(457305), // Rule ID 2862 //
     /*  457235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  457246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  457249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  457252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  457255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  457284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457303 */     GIR_RootConstrainSelectedInstOperands,
     /*  457304 */     // GIR_Coverage, 2862,
     /*  457304 */     GIR_EraseRootFromParent_Done,
     /*  457305 */   // Label 7895: @457305
     /*  457305 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(457380), // Rule ID 2863 //
     /*  457310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  457321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  457324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  457327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  457330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  457359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457378 */     GIR_RootConstrainSelectedInstOperands,
     /*  457379 */     // GIR_Coverage, 2863,
     /*  457379 */     GIR_EraseRootFromParent_Done,
     /*  457380 */   // Label 7896: @457380
     /*  457380 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(457455), // Rule ID 2866 //
     /*  457385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  457396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  457399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  457402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  457405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457431 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  457434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457453 */     GIR_RootConstrainSelectedInstOperands,
     /*  457454 */     // GIR_Coverage, 2866,
     /*  457454 */     GIR_EraseRootFromParent_Done,
     /*  457455 */   // Label 7897: @457455
     /*  457455 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(457530), // Rule ID 2867 //
     /*  457460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  457471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  457474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  457477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  457480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  457509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457528 */     GIR_RootConstrainSelectedInstOperands,
     /*  457529 */     // GIR_Coverage, 2867,
     /*  457529 */     GIR_EraseRootFromParent_Done,
     /*  457530 */   // Label 7898: @457530
     /*  457530 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(457605), // Rule ID 2870 //
     /*  457535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  457546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  457549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  457552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  457555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457581 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  457584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457603 */     GIR_RootConstrainSelectedInstOperands,
     /*  457604 */     // GIR_Coverage, 2870,
     /*  457604 */     GIR_EraseRootFromParent_Done,
     /*  457605 */   // Label 7899: @457605
     /*  457605 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(457680), // Rule ID 2871 //
     /*  457610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  457621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  457624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  457627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  457630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  457659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457678 */     GIR_RootConstrainSelectedInstOperands,
     /*  457679 */     // GIR_Coverage, 2871,
     /*  457679 */     GIR_EraseRootFromParent_Done,
     /*  457680 */   // Label 7900: @457680
     /*  457680 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(457755), // Rule ID 2874 //
     /*  457685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  457696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  457699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  457702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  457705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  457734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457753 */     GIR_RootConstrainSelectedInstOperands,
     /*  457754 */     // GIR_Coverage, 2874,
     /*  457754 */     GIR_EraseRootFromParent_Done,
     /*  457755 */   // Label 7901: @457755
     /*  457755 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(457830), // Rule ID 2875 //
     /*  457760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  457771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  457774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  457777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  457780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  457809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457828 */     GIR_RootConstrainSelectedInstOperands,
     /*  457829 */     // GIR_Coverage, 2875,
     /*  457829 */     GIR_EraseRootFromParent_Done,
     /*  457830 */   // Label 7902: @457830
     /*  457830 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(457905), // Rule ID 2878 //
     /*  457835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  457846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  457849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  457852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  457855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457881 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  457884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457903 */     GIR_RootConstrainSelectedInstOperands,
     /*  457904 */     // GIR_Coverage, 2878,
     /*  457904 */     GIR_EraseRootFromParent_Done,
     /*  457905 */   // Label 7903: @457905
     /*  457905 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(457980), // Rule ID 2879 //
     /*  457910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  457921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  457924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  457927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  457930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  457949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  457959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  457967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457978 */     GIR_RootConstrainSelectedInstOperands,
     /*  457979 */     // GIR_Coverage, 2879,
     /*  457979 */     GIR_EraseRootFromParent_Done,
     /*  457980 */   // Label 7904: @457980
     /*  457980 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(458055), // Rule ID 2882 //
     /*  457985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  457993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  457996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  457999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  458002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  458005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  458034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458053 */     GIR_RootConstrainSelectedInstOperands,
     /*  458054 */     // GIR_Coverage, 2882,
     /*  458054 */     GIR_EraseRootFromParent_Done,
     /*  458055 */   // Label 7905: @458055
     /*  458055 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(458130), // Rule ID 2883 //
     /*  458060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  458071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  458074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  458077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  458080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  458109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458128 */     GIR_RootConstrainSelectedInstOperands,
     /*  458129 */     // GIR_Coverage, 2883,
     /*  458129 */     GIR_EraseRootFromParent_Done,
     /*  458130 */   // Label 7906: @458130
     /*  458130 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(458205), // Rule ID 2886 //
     /*  458135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  458146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  458149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  458152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  458155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  458184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458203 */     GIR_RootConstrainSelectedInstOperands,
     /*  458204 */     // GIR_Coverage, 2886,
     /*  458204 */     GIR_EraseRootFromParent_Done,
     /*  458205 */   // Label 7907: @458205
     /*  458205 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(458280), // Rule ID 2887 //
     /*  458210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  458221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  458224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  458227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  458230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  458259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458278 */     GIR_RootConstrainSelectedInstOperands,
     /*  458279 */     // GIR_Coverage, 2887,
     /*  458279 */     GIR_EraseRootFromParent_Done,
     /*  458280 */   // Label 7908: @458280
     /*  458280 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(458355), // Rule ID 2890 //
     /*  458285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  458296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  458299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  458302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  458305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458331 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  458334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458353 */     GIR_RootConstrainSelectedInstOperands,
     /*  458354 */     // GIR_Coverage, 2890,
     /*  458354 */     GIR_EraseRootFromParent_Done,
     /*  458355 */   // Label 7909: @458355
     /*  458355 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(458430), // Rule ID 2891 //
     /*  458360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  458371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  458374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  458377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  458380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  458409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458428 */     GIR_RootConstrainSelectedInstOperands,
     /*  458429 */     // GIR_Coverage, 2891,
     /*  458429 */     GIR_EraseRootFromParent_Done,
     /*  458430 */   // Label 7910: @458430
     /*  458430 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(458505), // Rule ID 2894 //
     /*  458435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  458446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  458449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  458452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  458455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458481 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  458484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458503 */     GIR_RootConstrainSelectedInstOperands,
     /*  458504 */     // GIR_Coverage, 2894,
     /*  458504 */     GIR_EraseRootFromParent_Done,
     /*  458505 */   // Label 7911: @458505
     /*  458505 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(458580), // Rule ID 2895 //
     /*  458510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  458521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  458524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  458527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  458530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  458559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458578 */     GIR_RootConstrainSelectedInstOperands,
     /*  458579 */     // GIR_Coverage, 2895,
     /*  458579 */     GIR_EraseRootFromParent_Done,
     /*  458580 */   // Label 7912: @458580
     /*  458580 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(458655), // Rule ID 2898 //
     /*  458585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  458596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  458599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  458602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  458605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  458634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458653 */     GIR_RootConstrainSelectedInstOperands,
     /*  458654 */     // GIR_Coverage, 2898,
     /*  458654 */     GIR_EraseRootFromParent_Done,
     /*  458655 */   // Label 7913: @458655
     /*  458655 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(458730), // Rule ID 2899 //
     /*  458660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  458671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  458674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  458677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  458680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  458709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458728 */     GIR_RootConstrainSelectedInstOperands,
     /*  458729 */     // GIR_Coverage, 2899,
     /*  458729 */     GIR_EraseRootFromParent_Done,
     /*  458730 */   // Label 7914: @458730
     /*  458730 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(458805), // Rule ID 2902 //
     /*  458735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  458746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  458749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  458752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  458755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458781 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  458784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458803 */     GIR_RootConstrainSelectedInstOperands,
     /*  458804 */     // GIR_Coverage, 2902,
     /*  458804 */     GIR_EraseRootFromParent_Done,
     /*  458805 */   // Label 7915: @458805
     /*  458805 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(458880), // Rule ID 2903 //
     /*  458810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  458821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  458824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  458827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  458830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  458859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458878 */     GIR_RootConstrainSelectedInstOperands,
     /*  458879 */     // GIR_Coverage, 2903,
     /*  458879 */     GIR_EraseRootFromParent_Done,
     /*  458880 */   // Label 7916: @458880
     /*  458880 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(458955), // Rule ID 2906 //
     /*  458885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  458896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  458899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  458902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  458905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458931 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  458934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  458942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458953 */     GIR_RootConstrainSelectedInstOperands,
     /*  458954 */     // GIR_Coverage, 2906,
     /*  458954 */     GIR_EraseRootFromParent_Done,
     /*  458955 */   // Label 7917: @458955
     /*  458955 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(459030), // Rule ID 2907 //
     /*  458960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  458968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  458971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  458974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  458977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  458980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459006 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  459006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  459009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459028 */     GIR_RootConstrainSelectedInstOperands,
     /*  459029 */     // GIR_Coverage, 2907,
     /*  459029 */     GIR_EraseRootFromParent_Done,
     /*  459030 */   // Label 7918: @459030
     /*  459030 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(459105), // Rule ID 2910 //
     /*  459035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  459046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  459049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  459052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459081 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  459084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459103 */     GIR_RootConstrainSelectedInstOperands,
     /*  459104 */     // GIR_Coverage, 2910,
     /*  459104 */     GIR_EraseRootFromParent_Done,
     /*  459105 */   // Label 7919: @459105
     /*  459105 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(459180), // Rule ID 2911 //
     /*  459110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  459121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  459124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  459127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  459159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459178 */     GIR_RootConstrainSelectedInstOperands,
     /*  459179 */     // GIR_Coverage, 2911,
     /*  459179 */     GIR_EraseRootFromParent_Done,
     /*  459180 */   // Label 7920: @459180
     /*  459180 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(459255), // Rule ID 2914 //
     /*  459185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  459196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  459199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  459202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459231 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  459234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459253 */     GIR_RootConstrainSelectedInstOperands,
     /*  459254 */     // GIR_Coverage, 2914,
     /*  459254 */     GIR_EraseRootFromParent_Done,
     /*  459255 */   // Label 7921: @459255
     /*  459255 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(459330), // Rule ID 2915 //
     /*  459260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  459271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  459274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  459277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459306 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  459309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459328 */     GIR_RootConstrainSelectedInstOperands,
     /*  459329 */     // GIR_Coverage, 2915,
     /*  459329 */     GIR_EraseRootFromParent_Done,
     /*  459330 */   // Label 7922: @459330
     /*  459330 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(459405), // Rule ID 2918 //
     /*  459335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  459346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  459349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  459352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459381 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459403 */     GIR_RootConstrainSelectedInstOperands,
     /*  459404 */     // GIR_Coverage, 2918,
     /*  459404 */     GIR_EraseRootFromParent_Done,
     /*  459405 */   // Label 7923: @459405
     /*  459405 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(459480), // Rule ID 2919 //
     /*  459410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  459421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  459424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  459427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459478 */     GIR_RootConstrainSelectedInstOperands,
     /*  459479 */     // GIR_Coverage, 2919,
     /*  459479 */     GIR_EraseRootFromParent_Done,
     /*  459480 */   // Label 7924: @459480
     /*  459480 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(459555), // Rule ID 2922 //
     /*  459485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  459496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  459499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  459502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459531 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  459534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459553 */     GIR_RootConstrainSelectedInstOperands,
     /*  459554 */     // GIR_Coverage, 2922,
     /*  459554 */     GIR_EraseRootFromParent_Done,
     /*  459555 */   // Label 7925: @459555
     /*  459555 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(459630), // Rule ID 2923 //
     /*  459560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  459571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  459574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  459577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  459609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459628 */     GIR_RootConstrainSelectedInstOperands,
     /*  459629 */     // GIR_Coverage, 2923,
     /*  459629 */     GIR_EraseRootFromParent_Done,
     /*  459630 */   // Label 7926: @459630
     /*  459630 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(459705), // Rule ID 2926 //
     /*  459635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  459646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  459649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  459652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459681 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459703 */     GIR_RootConstrainSelectedInstOperands,
     /*  459704 */     // GIR_Coverage, 2926,
     /*  459704 */     GIR_EraseRootFromParent_Done,
     /*  459705 */   // Label 7927: @459705
     /*  459705 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(459780), // Rule ID 2927 //
     /*  459710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  459721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  459724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  459727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459778 */     GIR_RootConstrainSelectedInstOperands,
     /*  459779 */     // GIR_Coverage, 2927,
     /*  459779 */     GIR_EraseRootFromParent_Done,
     /*  459780 */   // Label 7928: @459780
     /*  459780 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(459855), // Rule ID 2930 //
     /*  459785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  459796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  459799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  459802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459831 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459853 */     GIR_RootConstrainSelectedInstOperands,
     /*  459854 */     // GIR_Coverage, 2930,
     /*  459854 */     GIR_EraseRootFromParent_Done,
     /*  459855 */   // Label 7929: @459855
     /*  459855 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(459930), // Rule ID 2931 //
     /*  459860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  459871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  459874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  459877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  459909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459928 */     GIR_RootConstrainSelectedInstOperands,
     /*  459929 */     // GIR_Coverage, 2931,
     /*  459929 */     GIR_EraseRootFromParent_Done,
     /*  459930 */   // Label 7930: @459930
     /*  459930 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(460005), // Rule ID 2934 //
     /*  459935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  459943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  459946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  459949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  459952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  459974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459981 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  459984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  459992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460003 */     GIR_RootConstrainSelectedInstOperands,
     /*  460004 */     // GIR_Coverage, 2934,
     /*  460004 */     GIR_EraseRootFromParent_Done,
     /*  460005 */   // Label 7931: @460005
     /*  460005 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(460080), // Rule ID 2935 //
     /*  460010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  460021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  460024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  460027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10834:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460078 */     GIR_RootConstrainSelectedInstOperands,
     /*  460079 */     // GIR_Coverage, 2935,
     /*  460079 */     GIR_EraseRootFromParent_Done,
     /*  460080 */   // Label 7932: @460080
     /*  460080 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(460155), // Rule ID 2938 //
     /*  460085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  460096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  460099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  460131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  460150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460153 */     GIR_RootConstrainSelectedInstOperands,
     /*  460154 */     // GIR_Coverage, 2938,
     /*  460154 */     GIR_EraseRootFromParent_Done,
     /*  460155 */   // Label 7933: @460155
     /*  460155 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(460230), // Rule ID 2939 //
     /*  460160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  460171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  460174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  460206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  460225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460228 */     GIR_RootConstrainSelectedInstOperands,
     /*  460229 */     // GIR_Coverage, 2939,
     /*  460229 */     GIR_EraseRootFromParent_Done,
     /*  460230 */   // Label 7934: @460230
     /*  460230 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(460305), // Rule ID 2942 //
     /*  460235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  460246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  460249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  460252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460281 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  460281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460303 */     GIR_RootConstrainSelectedInstOperands,
     /*  460304 */     // GIR_Coverage, 2942,
     /*  460304 */     GIR_EraseRootFromParent_Done,
     /*  460305 */   // Label 7935: @460305
     /*  460305 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(460380), // Rule ID 2943 //
     /*  460310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  460321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  460324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  460327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460378 */     GIR_RootConstrainSelectedInstOperands,
     /*  460379 */     // GIR_Coverage, 2943,
     /*  460379 */     GIR_EraseRootFromParent_Done,
     /*  460380 */   // Label 7936: @460380
     /*  460380 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(460455), // Rule ID 2946 //
     /*  460385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  460396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  460399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  460402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460431 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460453 */     GIR_RootConstrainSelectedInstOperands,
     /*  460454 */     // GIR_Coverage, 2946,
     /*  460454 */     GIR_EraseRootFromParent_Done,
     /*  460455 */   // Label 7937: @460455
     /*  460455 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(460530), // Rule ID 2947 //
     /*  460460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  460471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  460474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  460477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  460509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460528 */     GIR_RootConstrainSelectedInstOperands,
     /*  460529 */     // GIR_Coverage, 2947,
     /*  460529 */     GIR_EraseRootFromParent_Done,
     /*  460530 */   // Label 7938: @460530
     /*  460530 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(460605), // Rule ID 2950 //
     /*  460535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  460546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  460549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  460552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  460584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460603 */     GIR_RootConstrainSelectedInstOperands,
     /*  460604 */     // GIR_Coverage, 2950,
     /*  460604 */     GIR_EraseRootFromParent_Done,
     /*  460605 */   // Label 7939: @460605
     /*  460605 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(460680), // Rule ID 2951 //
     /*  460610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  460621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  460624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  460627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  460659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460678 */     GIR_RootConstrainSelectedInstOperands,
     /*  460679 */     // GIR_Coverage, 2951,
     /*  460679 */     GIR_EraseRootFromParent_Done,
     /*  460680 */   // Label 7940: @460680
     /*  460680 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(460755), // Rule ID 2954 //
     /*  460685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  460696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  460699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  460702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460731 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  460734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460753 */     GIR_RootConstrainSelectedInstOperands,
     /*  460754 */     // GIR_Coverage, 2954,
     /*  460754 */     GIR_EraseRootFromParent_Done,
     /*  460755 */   // Label 7941: @460755
     /*  460755 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(460830), // Rule ID 2955 //
     /*  460760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  460771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  460774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  460777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460806 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  460809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460828 */     GIR_RootConstrainSelectedInstOperands,
     /*  460829 */     // GIR_Coverage, 2955,
     /*  460829 */     GIR_EraseRootFromParent_Done,
     /*  460830 */   // Label 7942: @460830
     /*  460830 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(460905), // Rule ID 2958 //
     /*  460835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  460846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  460849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  460852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460881 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  460884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460903 */     GIR_RootConstrainSelectedInstOperands,
     /*  460904 */     // GIR_Coverage, 2958,
     /*  460904 */     GIR_EraseRootFromParent_Done,
     /*  460905 */   // Label 7943: @460905
     /*  460905 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(460980), // Rule ID 2959 //
     /*  460910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  460921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  460924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  460927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  460949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  460959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  460967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460978 */     GIR_RootConstrainSelectedInstOperands,
     /*  460979 */     // GIR_Coverage, 2959,
     /*  460979 */     GIR_EraseRootFromParent_Done,
     /*  460980 */   // Label 7944: @460980
     /*  460980 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(461055), // Rule ID 2962 //
     /*  460985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  460993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  460996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  460999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  461034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461053 */     GIR_RootConstrainSelectedInstOperands,
     /*  461054 */     // GIR_Coverage, 2962,
     /*  461054 */     GIR_EraseRootFromParent_Done,
     /*  461055 */   // Label 7945: @461055
     /*  461055 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(461130), // Rule ID 2963 //
     /*  461060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  461071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  461074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  461109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461128 */     GIR_RootConstrainSelectedInstOperands,
     /*  461129 */     // GIR_Coverage, 2963,
     /*  461129 */     GIR_EraseRootFromParent_Done,
     /*  461130 */   // Label 7946: @461130
     /*  461130 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(461205), // Rule ID 2966 //
     /*  461135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  461146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  461149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461181 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  461184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461203 */     GIR_RootConstrainSelectedInstOperands,
     /*  461204 */     // GIR_Coverage, 2966,
     /*  461204 */     GIR_EraseRootFromParent_Done,
     /*  461205 */   // Label 7947: @461205
     /*  461205 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(461280), // Rule ID 2967 //
     /*  461210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  461221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  461224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461256 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  461259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461278 */     GIR_RootConstrainSelectedInstOperands,
     /*  461279 */     // GIR_Coverage, 2967,
     /*  461279 */     GIR_EraseRootFromParent_Done,
     /*  461280 */   // Label 7948: @461280
     /*  461280 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(461355), // Rule ID 2970 //
     /*  461285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  461296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  461299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461331 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  461334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461353 */     GIR_RootConstrainSelectedInstOperands,
     /*  461354 */     // GIR_Coverage, 2970,
     /*  461354 */     GIR_EraseRootFromParent_Done,
     /*  461355 */   // Label 7949: @461355
     /*  461355 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(461430), // Rule ID 2971 //
     /*  461360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  461371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  461374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  461409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461428 */     GIR_RootConstrainSelectedInstOperands,
     /*  461429 */     // GIR_Coverage, 2971,
     /*  461429 */     GIR_EraseRootFromParent_Done,
     /*  461430 */   // Label 7950: @461430
     /*  461430 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(461505), // Rule ID 2974 //
     /*  461435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  461446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  461449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  461484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461503 */     GIR_RootConstrainSelectedInstOperands,
     /*  461504 */     // GIR_Coverage, 2974,
     /*  461504 */     GIR_EraseRootFromParent_Done,
     /*  461505 */   // Label 7951: @461505
     /*  461505 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(461580), // Rule ID 2975 //
     /*  461510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  461521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  461524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  461559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461578 */     GIR_RootConstrainSelectedInstOperands,
     /*  461579 */     // GIR_Coverage, 2975,
     /*  461579 */     GIR_EraseRootFromParent_Done,
     /*  461580 */   // Label 7952: @461580
     /*  461580 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(461655), // Rule ID 2978 //
     /*  461585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  461596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  461599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  461602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461631 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  461634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461653 */     GIR_RootConstrainSelectedInstOperands,
     /*  461654 */     // GIR_Coverage, 2978,
     /*  461654 */     GIR_EraseRootFromParent_Done,
     /*  461655 */   // Label 7953: @461655
     /*  461655 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(461730), // Rule ID 2979 //
     /*  461660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  461671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  461674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  461677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  461709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461728 */     GIR_RootConstrainSelectedInstOperands,
     /*  461729 */     // GIR_Coverage, 2979,
     /*  461729 */     GIR_EraseRootFromParent_Done,
     /*  461730 */   // Label 7954: @461730
     /*  461730 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(461805), // Rule ID 2982 //
     /*  461735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  461746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  461749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  461752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  461784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461803 */     GIR_RootConstrainSelectedInstOperands,
     /*  461804 */     // GIR_Coverage, 2982,
     /*  461804 */     GIR_EraseRootFromParent_Done,
     /*  461805 */   // Label 7955: @461805
     /*  461805 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(461880), // Rule ID 2983 //
     /*  461810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  461821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  461824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  461827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  461859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461878 */     GIR_RootConstrainSelectedInstOperands,
     /*  461879 */     // GIR_Coverage, 2983,
     /*  461879 */     GIR_EraseRootFromParent_Done,
     /*  461880 */   // Label 7956: @461880
     /*  461880 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(461955), // Rule ID 2986 //
     /*  461885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  461888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  461896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  461899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  461902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  461931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  461934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  461942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  461950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461953 */     GIR_RootConstrainSelectedInstOperands,
     /*  461954 */     // GIR_Coverage, 2986,
     /*  461954 */     GIR_EraseRootFromParent_Done,
     /*  461955 */   // Label 7957: @461955
     /*  461955 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(462030), // Rule ID 2987 //
     /*  461960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  461963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  461968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  461971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  461974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  461977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  461999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  462006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  462009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462028 */     GIR_RootConstrainSelectedInstOperands,
     /*  462029 */     // GIR_Coverage, 2987,
     /*  462029 */     GIR_EraseRootFromParent_Done,
     /*  462030 */   // Label 7958: @462030
     /*  462030 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(462105), // Rule ID 2990 //
     /*  462035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  462038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  462043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  462046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  462049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  462074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  462081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  462084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462103 */     GIR_RootConstrainSelectedInstOperands,
     /*  462104 */     // GIR_Coverage, 2990,
     /*  462104 */     GIR_EraseRootFromParent_Done,
     /*  462105 */   // Label 7959: @462105
     /*  462105 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(462180), // Rule ID 2991 //
     /*  462110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  462113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  462118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  462121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  462124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  462149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  462156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  462159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462178 */     GIR_RootConstrainSelectedInstOperands,
     /*  462179 */     // GIR_Coverage, 2991,
     /*  462179 */     GIR_EraseRootFromParent_Done,
     /*  462180 */   // Label 7960: @462180
     /*  462180 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(462255), // Rule ID 2994 //
     /*  462185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  462188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  462193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  462196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  462199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  462224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  462231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  462234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462253 */     GIR_RootConstrainSelectedInstOperands,
     /*  462254 */     // GIR_Coverage, 2994,
     /*  462254 */     GIR_EraseRootFromParent_Done,
     /*  462255 */   // Label 7961: @462255
     /*  462255 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(462330), // Rule ID 2995 //
     /*  462260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  462263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  462268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  462271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  462274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  462299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10834:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  462306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  462309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462328 */     GIR_RootConstrainSelectedInstOperands,
     /*  462329 */     // GIR_Coverage, 2995,
     /*  462329 */     GIR_EraseRootFromParent_Done,
     /*  462330 */   // Label 7962: @462330
     /*  462330 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(462405), // Rule ID 3086 //
     /*  462335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  462346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  462349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  462352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  462355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462381 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  462384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462403 */     GIR_RootConstrainSelectedInstOperands,
     /*  462404 */     // GIR_Coverage, 3086,
     /*  462404 */     GIR_EraseRootFromParent_Done,
     /*  462405 */   // Label 7963: @462405
     /*  462405 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(462480), // Rule ID 3087 //
     /*  462410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  462421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  462424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  462427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  462430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462456 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  462459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462478 */     GIR_RootConstrainSelectedInstOperands,
     /*  462479 */     // GIR_Coverage, 3087,
     /*  462479 */     GIR_EraseRootFromParent_Done,
     /*  462480 */   // Label 7964: @462480
     /*  462480 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(462555), // Rule ID 3090 //
     /*  462485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  462496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  462499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  462502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  462505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462531 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  462534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462553 */     GIR_RootConstrainSelectedInstOperands,
     /*  462554 */     // GIR_Coverage, 3090,
     /*  462554 */     GIR_EraseRootFromParent_Done,
     /*  462555 */   // Label 7965: @462555
     /*  462555 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(462630), // Rule ID 3091 //
     /*  462560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  462571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  462574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  462577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  462580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  462609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462628 */     GIR_RootConstrainSelectedInstOperands,
     /*  462629 */     // GIR_Coverage, 3091,
     /*  462629 */     GIR_EraseRootFromParent_Done,
     /*  462630 */   // Label 7966: @462630
     /*  462630 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(462705), // Rule ID 3094 //
     /*  462635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  462646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  462649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  462652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  462655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462681 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  462684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462703 */     GIR_RootConstrainSelectedInstOperands,
     /*  462704 */     // GIR_Coverage, 3094,
     /*  462704 */     GIR_EraseRootFromParent_Done,
     /*  462705 */   // Label 7967: @462705
     /*  462705 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(462780), // Rule ID 3095 //
     /*  462710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  462721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  462724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  462727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  462730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462756 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  462759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462778 */     GIR_RootConstrainSelectedInstOperands,
     /*  462779 */     // GIR_Coverage, 3095,
     /*  462779 */     GIR_EraseRootFromParent_Done,
     /*  462780 */   // Label 7968: @462780
     /*  462780 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(462855), // Rule ID 3098 //
     /*  462785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  462796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  462799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  462802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  462805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462831 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  462834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462853 */     GIR_RootConstrainSelectedInstOperands,
     /*  462854 */     // GIR_Coverage, 3098,
     /*  462854 */     GIR_EraseRootFromParent_Done,
     /*  462855 */   // Label 7969: @462855
     /*  462855 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(462930), // Rule ID 3099 //
     /*  462860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  462871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  462874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  462877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  462880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462906 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  462909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462928 */     GIR_RootConstrainSelectedInstOperands,
     /*  462929 */     // GIR_Coverage, 3099,
     /*  462929 */     GIR_EraseRootFromParent_Done,
     /*  462930 */   // Label 7970: @462930
     /*  462930 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(463005), // Rule ID 3102 //
     /*  462935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  462943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  462946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  462949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  462952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  462955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462981 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  462984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  462992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463003 */     GIR_RootConstrainSelectedInstOperands,
     /*  463004 */     // GIR_Coverage, 3102,
     /*  463004 */     GIR_EraseRootFromParent_Done,
     /*  463005 */   // Label 7971: @463005
     /*  463005 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(463080), // Rule ID 3103 //
     /*  463010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  463021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  463024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  463030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  463059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463078 */     GIR_RootConstrainSelectedInstOperands,
     /*  463079 */     // GIR_Coverage, 3103,
     /*  463079 */     GIR_EraseRootFromParent_Done,
     /*  463080 */   // Label 7972: @463080
     /*  463080 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(463155), // Rule ID 3106 //
     /*  463085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  463096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  463099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  463102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  463105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463131 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  463134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463153 */     GIR_RootConstrainSelectedInstOperands,
     /*  463154 */     // GIR_Coverage, 3106,
     /*  463154 */     GIR_EraseRootFromParent_Done,
     /*  463155 */   // Label 7973: @463155
     /*  463155 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(463230), // Rule ID 3107 //
     /*  463160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  463171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  463174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  463177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  463180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463206 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  463209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463228 */     GIR_RootConstrainSelectedInstOperands,
     /*  463229 */     // GIR_Coverage, 3107,
     /*  463229 */     GIR_EraseRootFromParent_Done,
     /*  463230 */   // Label 7974: @463230
     /*  463230 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(463305), // Rule ID 3110 //
     /*  463235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  463252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  463255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463281 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463303 */     GIR_RootConstrainSelectedInstOperands,
     /*  463304 */     // GIR_Coverage, 3110,
     /*  463304 */     GIR_EraseRootFromParent_Done,
     /*  463305 */   // Label 7975: @463305
     /*  463305 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(463380), // Rule ID 3111 //
     /*  463310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  463327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  463330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463378 */     GIR_RootConstrainSelectedInstOperands,
     /*  463379 */     // GIR_Coverage, 3111,
     /*  463379 */     GIR_EraseRootFromParent_Done,
     /*  463380 */   // Label 7976: @463380
     /*  463380 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(463455), // Rule ID 3114 //
     /*  463385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  463396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  463399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  463405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463431 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463453 */     GIR_RootConstrainSelectedInstOperands,
     /*  463454 */     // GIR_Coverage, 3114,
     /*  463454 */     GIR_EraseRootFromParent_Done,
     /*  463455 */   // Label 7977: @463455
     /*  463455 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(463530), // Rule ID 3115 //
     /*  463460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  463471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  463474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  463480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463528 */     GIR_RootConstrainSelectedInstOperands,
     /*  463529 */     // GIR_Coverage, 3115,
     /*  463529 */     GIR_EraseRootFromParent_Done,
     /*  463530 */   // Label 7978: @463530
     /*  463530 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(463605), // Rule ID 3118 //
     /*  463535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  463546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  463549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  463552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  463555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463603 */     GIR_RootConstrainSelectedInstOperands,
     /*  463604 */     // GIR_Coverage, 3118,
     /*  463604 */     GIR_EraseRootFromParent_Done,
     /*  463605 */   // Label 7979: @463605
     /*  463605 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(463680), // Rule ID 3119 //
     /*  463610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  463621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  463624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  463627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  463630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463678 */     GIR_RootConstrainSelectedInstOperands,
     /*  463679 */     // GIR_Coverage, 3119,
     /*  463679 */     GIR_EraseRootFromParent_Done,
     /*  463680 */   // Label 7980: @463680
     /*  463680 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(463755), // Rule ID 3122 //
     /*  463685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  463688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  463696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  463699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  463702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  463705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  463731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463753 */     GIR_RootConstrainSelectedInstOperands,
     /*  463754 */     // GIR_Coverage, 3122,
     /*  463754 */     GIR_EraseRootFromParent_Done,
     /*  463755 */   // Label 7981: @463755
     /*  463755 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(463830), // Rule ID 3123 //
     /*  463760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  463763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  463771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  463774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  463777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  463780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463806 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  463806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  463809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463828 */     GIR_RootConstrainSelectedInstOperands,
     /*  463829 */     // GIR_Coverage, 3123,
     /*  463829 */     GIR_EraseRootFromParent_Done,
     /*  463830 */   // Label 7982: @463830
     /*  463830 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(463905), // Rule ID 3126 //
     /*  463835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  463852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  463855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  463884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463903 */     GIR_RootConstrainSelectedInstOperands,
     /*  463904 */     // GIR_Coverage, 3126,
     /*  463904 */     GIR_EraseRootFromParent_Done,
     /*  463905 */   // Label 7983: @463905
     /*  463905 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(463980), // Rule ID 3127 //
     /*  463910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  463927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  463930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  463959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  463967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463978 */     GIR_RootConstrainSelectedInstOperands,
     /*  463979 */     // GIR_Coverage, 3127,
     /*  463979 */     GIR_EraseRootFromParent_Done,
     /*  463980 */   // Label 7984: @463980
     /*  463980 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(464055), // Rule ID 3130 //
     /*  463985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  463993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  464002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  464005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464031 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  464034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464053 */     GIR_RootConstrainSelectedInstOperands,
     /*  464054 */     // GIR_Coverage, 3130,
     /*  464054 */     GIR_EraseRootFromParent_Done,
     /*  464055 */   // Label 7985: @464055
     /*  464055 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(464130), // Rule ID 3131 //
     /*  464060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  464071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  464074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  464077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  464080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464106 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  464109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464128 */     GIR_RootConstrainSelectedInstOperands,
     /*  464129 */     // GIR_Coverage, 3131,
     /*  464129 */     GIR_EraseRootFromParent_Done,
     /*  464130 */   // Label 7986: @464130
     /*  464130 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(464205), // Rule ID 3134 //
     /*  464135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  464146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  464149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  464152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  464155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464181 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  464184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464203 */     GIR_RootConstrainSelectedInstOperands,
     /*  464204 */     // GIR_Coverage, 3134,
     /*  464204 */     GIR_EraseRootFromParent_Done,
     /*  464205 */   // Label 7987: @464205
     /*  464205 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(464280), // Rule ID 3135 //
     /*  464210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  464221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  464224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  464227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  464230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464256 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  464259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464278 */     GIR_RootConstrainSelectedInstOperands,
     /*  464279 */     // GIR_Coverage, 3135,
     /*  464279 */     GIR_EraseRootFromParent_Done,
     /*  464280 */   // Label 7988: @464280
     /*  464280 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(464355), // Rule ID 3138 //
     /*  464285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  464305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  464334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464353 */     GIR_RootConstrainSelectedInstOperands,
     /*  464354 */     // GIR_Coverage, 3138,
     /*  464354 */     GIR_EraseRootFromParent_Done,
     /*  464355 */   // Label 7989: @464355
     /*  464355 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(464430), // Rule ID 3139 //
     /*  464360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  464380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  464409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464428 */     GIR_RootConstrainSelectedInstOperands,
     /*  464429 */     // GIR_Coverage, 3139,
     /*  464429 */     GIR_EraseRootFromParent_Done,
     /*  464430 */   // Label 7990: @464430
     /*  464430 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(464505), // Rule ID 3142 //
     /*  464435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  464455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  464484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464503 */     GIR_RootConstrainSelectedInstOperands,
     /*  464504 */     // GIR_Coverage, 3142,
     /*  464504 */     GIR_EraseRootFromParent_Done,
     /*  464505 */   // Label 7991: @464505
     /*  464505 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(464580), // Rule ID 3143 //
     /*  464510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  464530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  464559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464578 */     GIR_RootConstrainSelectedInstOperands,
     /*  464579 */     // GIR_Coverage, 3143,
     /*  464579 */     GIR_EraseRootFromParent_Done,
     /*  464580 */   // Label 7992: @464580
     /*  464580 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(464655), // Rule ID 3146 //
     /*  464585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  464596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  464599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  464605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  464634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464653 */     GIR_RootConstrainSelectedInstOperands,
     /*  464654 */     // GIR_Coverage, 3146,
     /*  464654 */     GIR_EraseRootFromParent_Done,
     /*  464655 */   // Label 7993: @464655
     /*  464655 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(464730), // Rule ID 3147 //
     /*  464660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  464671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  464674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  464680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  464709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464728 */     GIR_RootConstrainSelectedInstOperands,
     /*  464729 */     // GIR_Coverage, 3147,
     /*  464729 */     GIR_EraseRootFromParent_Done,
     /*  464730 */   // Label 7994: @464730
     /*  464730 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(464805), // Rule ID 3150 //
     /*  464735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  464746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  464749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  464755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464781 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  464784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464803 */     GIR_RootConstrainSelectedInstOperands,
     /*  464804 */     // GIR_Coverage, 3150,
     /*  464804 */     GIR_EraseRootFromParent_Done,
     /*  464805 */   // Label 7995: @464805
     /*  464805 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(464880), // Rule ID 3151 //
     /*  464810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  464821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  464824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  464830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  464856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  464859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464878 */     GIR_RootConstrainSelectedInstOperands,
     /*  464879 */     // GIR_Coverage, 3151,
     /*  464879 */     GIR_EraseRootFromParent_Done,
     /*  464880 */   // Label 7996: @464880
     /*  464880 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(464955), // Rule ID 3154 //
     /*  464885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  464896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  464899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  464905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  464934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  464942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464953 */     GIR_RootConstrainSelectedInstOperands,
     /*  464954 */     // GIR_Coverage, 3154,
     /*  464954 */     GIR_EraseRootFromParent_Done,
     /*  464955 */   // Label 7997: @464955
     /*  464955 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(465030), // Rule ID 3155 //
     /*  464960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  464968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  464971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  464974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  464980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  465009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465028 */     GIR_RootConstrainSelectedInstOperands,
     /*  465029 */     // GIR_Coverage, 3155,
     /*  465029 */     GIR_EraseRootFromParent_Done,
     /*  465030 */   // Label 7998: @465030
     /*  465030 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(465105), // Rule ID 3158 //
     /*  465035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  465046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  465049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  465055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465081 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  465084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465103 */     GIR_RootConstrainSelectedInstOperands,
     /*  465104 */     // GIR_Coverage, 3158,
     /*  465104 */     GIR_EraseRootFromParent_Done,
     /*  465105 */   // Label 7999: @465105
     /*  465105 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(465180), // Rule ID 3159 //
     /*  465110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  465121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  465124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  465130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465156 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  465159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465178 */     GIR_RootConstrainSelectedInstOperands,
     /*  465179 */     // GIR_Coverage, 3159,
     /*  465179 */     GIR_EraseRootFromParent_Done,
     /*  465180 */   // Label 8000: @465180
     /*  465180 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(465255), // Rule ID 3162 //
     /*  465185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  465188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  465196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  465199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  465205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465231 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  465231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  465234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465253 */     GIR_RootConstrainSelectedInstOperands,
     /*  465254 */     // GIR_Coverage, 3162,
     /*  465254 */     GIR_EraseRootFromParent_Done,
     /*  465255 */   // Label 8001: @465255
     /*  465255 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(465330), // Rule ID 3163 //
     /*  465260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  465263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  465271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  465274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  465280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  465306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  465309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465328 */     GIR_RootConstrainSelectedInstOperands,
     /*  465329 */     // GIR_Coverage, 3163,
     /*  465329 */     GIR_EraseRootFromParent_Done,
     /*  465330 */   // Label 8002: @465330
     /*  465330 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(465405), // Rule ID 3166 //
     /*  465335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  465338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  465346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  465349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  465355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465381 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  465381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  465384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465403 */     GIR_RootConstrainSelectedInstOperands,
     /*  465404 */     // GIR_Coverage, 3166,
     /*  465404 */     GIR_EraseRootFromParent_Done,
     /*  465405 */   // Label 8003: @465405
     /*  465405 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(465480), // Rule ID 3167 //
     /*  465410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  465413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  465421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  465424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  465430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465456 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  465456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  465459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465478 */     GIR_RootConstrainSelectedInstOperands,
     /*  465479 */     // GIR_Coverage, 3167,
     /*  465479 */     GIR_EraseRootFromParent_Done,
     /*  465480 */   // Label 8004: @465480
     /*  465480 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(465555), // Rule ID 3170 //
     /*  465485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  465488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  465496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  465499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  465505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465531 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  465531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  465534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465553 */     GIR_RootConstrainSelectedInstOperands,
     /*  465554 */     // GIR_Coverage, 3170,
     /*  465554 */     GIR_EraseRootFromParent_Done,
     /*  465555 */   // Label 8005: @465555
     /*  465555 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(465630), // Rule ID 3171 //
     /*  465560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  465563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  465571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  465574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  465580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465606 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  465606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  465609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  465625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465628 */     GIR_RootConstrainSelectedInstOperands,
     /*  465629 */     // GIR_Coverage, 3171,
     /*  465629 */     GIR_EraseRootFromParent_Done,
     /*  465630 */   // Label 8006: @465630
     /*  465630 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(465705), // Rule ID 3174 //
     /*  465635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  465674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465681 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  465684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465703 */     GIR_RootConstrainSelectedInstOperands,
     /*  465704 */     // GIR_Coverage, 3174,
     /*  465704 */     GIR_EraseRootFromParent_Done,
     /*  465705 */   // Label 8007: @465705
     /*  465705 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(465780), // Rule ID 3175 //
     /*  465710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  465749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  465759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465778 */     GIR_RootConstrainSelectedInstOperands,
     /*  465779 */     // GIR_Coverage, 3175,
     /*  465779 */     GIR_EraseRootFromParent_Done,
     /*  465780 */   // Label 8008: @465780
     /*  465780 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(465855), // Rule ID 3178 //
     /*  465785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  465824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465831 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  465834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465853 */     GIR_RootConstrainSelectedInstOperands,
     /*  465854 */     // GIR_Coverage, 3178,
     /*  465854 */     GIR_EraseRootFromParent_Done,
     /*  465855 */   // Label 8009: @465855
     /*  465855 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(465930), // Rule ID 3179 //
     /*  465860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  465899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  465909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465928 */     GIR_RootConstrainSelectedInstOperands,
     /*  465929 */     // GIR_Coverage, 3179,
     /*  465929 */     GIR_EraseRootFromParent_Done,
     /*  465930 */   // Label 8010: @465930
     /*  465930 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(466005), // Rule ID 3182 //
     /*  465935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  465943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  465946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  465949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  465952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  465974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465981 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  465984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  465992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466003 */     GIR_RootConstrainSelectedInstOperands,
     /*  466004 */     // GIR_Coverage, 3182,
     /*  466004 */     GIR_EraseRootFromParent_Done,
     /*  466005 */   // Label 8011: @466005
     /*  466005 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(466080), // Rule ID 3183 //
     /*  466010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466056 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  466059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466078 */     GIR_RootConstrainSelectedInstOperands,
     /*  466079 */     // GIR_Coverage, 3183,
     /*  466079 */     GIR_EraseRootFromParent_Done,
     /*  466080 */   // Label 8012: @466080
     /*  466080 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(466155), // Rule ID 3186 //
     /*  466085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466131 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  466134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466153 */     GIR_RootConstrainSelectedInstOperands,
     /*  466154 */     // GIR_Coverage, 3186,
     /*  466154 */     GIR_EraseRootFromParent_Done,
     /*  466155 */   // Label 8013: @466155
     /*  466155 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(466230), // Rule ID 3187 //
     /*  466160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  466209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466228 */     GIR_RootConstrainSelectedInstOperands,
     /*  466229 */     // GIR_Coverage, 3187,
     /*  466229 */     GIR_EraseRootFromParent_Done,
     /*  466230 */   // Label 8014: @466230
     /*  466230 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(466305), // Rule ID 3190 //
     /*  466235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466281 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  466284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466303 */     GIR_RootConstrainSelectedInstOperands,
     /*  466304 */     // GIR_Coverage, 3190,
     /*  466304 */     GIR_EraseRootFromParent_Done,
     /*  466305 */   // Label 8015: @466305
     /*  466305 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(466380), // Rule ID 3191 //
     /*  466310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  466359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466378 */     GIR_RootConstrainSelectedInstOperands,
     /*  466379 */     // GIR_Coverage, 3191,
     /*  466379 */     GIR_EraseRootFromParent_Done,
     /*  466380 */   // Label 8016: @466380
     /*  466380 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(466455), // Rule ID 3194 //
     /*  466385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  466434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466453 */     GIR_RootConstrainSelectedInstOperands,
     /*  466454 */     // GIR_Coverage, 3194,
     /*  466454 */     GIR_EraseRootFromParent_Done,
     /*  466455 */   // Label 8017: @466455
     /*  466455 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(466530), // Rule ID 3195 //
     /*  466460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  466509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466528 */     GIR_RootConstrainSelectedInstOperands,
     /*  466529 */     // GIR_Coverage, 3195,
     /*  466529 */     GIR_EraseRootFromParent_Done,
     /*  466530 */   // Label 8018: @466530
     /*  466530 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(466605), // Rule ID 3198 //
     /*  466535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466581 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466603 */     GIR_RootConstrainSelectedInstOperands,
     /*  466604 */     // GIR_Coverage, 3198,
     /*  466604 */     GIR_EraseRootFromParent_Done,
     /*  466605 */   // Label 8019: @466605
     /*  466605 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(466680), // Rule ID 3199 //
     /*  466610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466656 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11312:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466678 */     GIR_RootConstrainSelectedInstOperands,
     /*  466679 */     // GIR_Coverage, 3199,
     /*  466679 */     GIR_EraseRootFromParent_Done,
     /*  466680 */   // Label 8020: @466680
     /*  466680 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(466755), // Rule ID 3202 //
     /*  466685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466731 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466753 */     GIR_RootConstrainSelectedInstOperands,
     /*  466754 */     // GIR_Coverage, 3202,
     /*  466754 */     GIR_EraseRootFromParent_Done,
     /*  466755 */   // Label 8021: @466755
     /*  466755 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(466830), // Rule ID 3203 //
     /*  466760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466828 */     GIR_RootConstrainSelectedInstOperands,
     /*  466829 */     // GIR_Coverage, 3203,
     /*  466829 */     GIR_EraseRootFromParent_Done,
     /*  466830 */   // Label 8022: @466830
     /*  466830 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(466905), // Rule ID 3206 //
     /*  466835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  466852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466881 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466903 */     GIR_RootConstrainSelectedInstOperands,
     /*  466904 */     // GIR_Coverage, 3206,
     /*  466904 */     GIR_EraseRootFromParent_Done,
     /*  466905 */   // Label 8023: @466905
     /*  466905 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(466980), // Rule ID 3207 //
     /*  466910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  466927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  466949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  466959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  466967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466978 */     GIR_RootConstrainSelectedInstOperands,
     /*  466979 */     // GIR_Coverage, 3207,
     /*  466979 */     GIR_EraseRootFromParent_Done,
     /*  466980 */   // Label 8024: @466980
     /*  466980 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(467055), // Rule ID 3210 //
     /*  466985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  466988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  466993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  466996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  466999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  467031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  467034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467053 */     GIR_RootConstrainSelectedInstOperands,
     /*  467054 */     // GIR_Coverage, 3210,
     /*  467054 */     GIR_EraseRootFromParent_Done,
     /*  467055 */   // Label 8025: @467055
     /*  467055 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(467130), // Rule ID 3211 //
     /*  467060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  467063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  467106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  467109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467128 */     GIR_RootConstrainSelectedInstOperands,
     /*  467129 */     // GIR_Coverage, 3211,
     /*  467129 */     GIR_EraseRootFromParent_Done,
     /*  467130 */   // Label 8026: @467130
     /*  467130 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(467205), // Rule ID 3214 //
     /*  467135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  467184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467203 */     GIR_RootConstrainSelectedInstOperands,
     /*  467204 */     // GIR_Coverage, 3214,
     /*  467204 */     GIR_EraseRootFromParent_Done,
     /*  467205 */   // Label 8027: @467205
     /*  467205 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(467280), // Rule ID 3215 //
     /*  467210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  467259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467278 */     GIR_RootConstrainSelectedInstOperands,
     /*  467279 */     // GIR_Coverage, 3215,
     /*  467279 */     GIR_EraseRootFromParent_Done,
     /*  467280 */   // Label 8028: @467280
     /*  467280 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(467355), // Rule ID 3218 //
     /*  467285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467331 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  467334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467353 */     GIR_RootConstrainSelectedInstOperands,
     /*  467354 */     // GIR_Coverage, 3218,
     /*  467354 */     GIR_EraseRootFromParent_Done,
     /*  467355 */   // Label 8029: @467355
     /*  467355 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(467430), // Rule ID 3219 //
     /*  467360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467406 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  467409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467428 */     GIR_RootConstrainSelectedInstOperands,
     /*  467429 */     // GIR_Coverage, 3219,
     /*  467429 */     GIR_EraseRootFromParent_Done,
     /*  467430 */   // Label 8030: @467430
     /*  467430 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(467505), // Rule ID 3222 //
     /*  467435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467481 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  467484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467503 */     GIR_RootConstrainSelectedInstOperands,
     /*  467504 */     // GIR_Coverage, 3222,
     /*  467504 */     GIR_EraseRootFromParent_Done,
     /*  467505 */   // Label 8031: @467505
     /*  467505 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(467580), // Rule ID 3223 //
     /*  467510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  467559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467578 */     GIR_RootConstrainSelectedInstOperands,
     /*  467579 */     // GIR_Coverage, 3223,
     /*  467579 */     GIR_EraseRootFromParent_Done,
     /*  467580 */   // Label 8032: @467580
     /*  467580 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(467655), // Rule ID 3226 //
     /*  467585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  467634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467653 */     GIR_RootConstrainSelectedInstOperands,
     /*  467654 */     // GIR_Coverage, 3226,
     /*  467654 */     GIR_EraseRootFromParent_Done,
     /*  467655 */   // Label 8033: @467655
     /*  467655 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(467730), // Rule ID 3227 //
     /*  467660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  467709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467728 */     GIR_RootConstrainSelectedInstOperands,
     /*  467729 */     // GIR_Coverage, 3227,
     /*  467729 */     GIR_EraseRootFromParent_Done,
     /*  467730 */   // Label 8034: @467730
     /*  467730 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(467805), // Rule ID 3230 //
     /*  467735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  467746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  467749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467781 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  467784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467803 */     GIR_RootConstrainSelectedInstOperands,
     /*  467804 */     // GIR_Coverage, 3230,
     /*  467804 */     GIR_EraseRootFromParent_Done,
     /*  467805 */   // Label 8035: @467805
     /*  467805 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(467880), // Rule ID 3231 //
     /*  467810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  467821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  467824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467856 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  467859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467878 */     GIR_RootConstrainSelectedInstOperands,
     /*  467879 */     // GIR_Coverage, 3231,
     /*  467879 */     GIR_EraseRootFromParent_Done,
     /*  467880 */   // Label 8036: @467880
     /*  467880 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(467955), // Rule ID 3234 //
     /*  467885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  467896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  467899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467931 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  467934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  467942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467953 */     GIR_RootConstrainSelectedInstOperands,
     /*  467954 */     // GIR_Coverage, 3234,
     /*  467954 */     GIR_EraseRootFromParent_Done,
     /*  467955 */   // Label 8037: @467955
     /*  467955 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(468030), // Rule ID 3235 //
     /*  467960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  467968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  467971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  467974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  467999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  468009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468028 */     GIR_RootConstrainSelectedInstOperands,
     /*  468029 */     // GIR_Coverage, 3235,
     /*  468029 */     GIR_EraseRootFromParent_Done,
     /*  468030 */   // Label 8038: @468030
     /*  468030 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(468105), // Rule ID 3238 //
     /*  468035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  468084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468103 */     GIR_RootConstrainSelectedInstOperands,
     /*  468104 */     // GIR_Coverage, 3238,
     /*  468104 */     GIR_EraseRootFromParent_Done,
     /*  468105 */   // Label 8039: @468105
     /*  468105 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(468180), // Rule ID 3239 //
     /*  468110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  468159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468178 */     GIR_RootConstrainSelectedInstOperands,
     /*  468179 */     // GIR_Coverage, 3239,
     /*  468179 */     GIR_EraseRootFromParent_Done,
     /*  468180 */   // Label 8040: @468180
     /*  468180 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(468255), // Rule ID 3242 //
     /*  468185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468231 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  468234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468253 */     GIR_RootConstrainSelectedInstOperands,
     /*  468254 */     // GIR_Coverage, 3242,
     /*  468254 */     GIR_EraseRootFromParent_Done,
     /*  468255 */   // Label 8041: @468255
     /*  468255 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(468330), // Rule ID 3243 //
     /*  468260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  468309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468328 */     GIR_RootConstrainSelectedInstOperands,
     /*  468329 */     // GIR_Coverage, 3243,
     /*  468329 */     GIR_EraseRootFromParent_Done,
     /*  468330 */   // Label 8042: @468330
     /*  468330 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(468405), // Rule ID 3246 //
     /*  468335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  468384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468403 */     GIR_RootConstrainSelectedInstOperands,
     /*  468404 */     // GIR_Coverage, 3246,
     /*  468404 */     GIR_EraseRootFromParent_Done,
     /*  468405 */   // Label 8043: @468405
     /*  468405 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(468480), // Rule ID 3247 //
     /*  468410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  468459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468478 */     GIR_RootConstrainSelectedInstOperands,
     /*  468479 */     // GIR_Coverage, 3247,
     /*  468479 */     GIR_EraseRootFromParent_Done,
     /*  468480 */   // Label 8044: @468480
     /*  468480 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(468555), // Rule ID 3250 //
     /*  468485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  468496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  468499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  468534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468553 */     GIR_RootConstrainSelectedInstOperands,
     /*  468554 */     // GIR_Coverage, 3250,
     /*  468554 */     GIR_EraseRootFromParent_Done,
     /*  468555 */   // Label 8045: @468555
     /*  468555 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(468630), // Rule ID 3251 //
     /*  468560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  468571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  468574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11312:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  468609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468628 */     GIR_RootConstrainSelectedInstOperands,
     /*  468629 */     // GIR_Coverage, 3251,
     /*  468629 */     GIR_EraseRootFromParent_Done,
     /*  468630 */   // Label 8046: @468630
     /*  468630 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(468705), // Rule ID 3254 //
     /*  468635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  468646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  468649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  468652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468681 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  468684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468703 */     GIR_RootConstrainSelectedInstOperands,
     /*  468704 */     // GIR_Coverage, 3254,
     /*  468704 */     GIR_EraseRootFromParent_Done,
     /*  468705 */   // Label 8047: @468705
     /*  468705 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(468780), // Rule ID 3255 //
     /*  468710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  468721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  468724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  468727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468756 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11312:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  468759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468778 */     GIR_RootConstrainSelectedInstOperands,
     /*  468779 */     // GIR_Coverage, 3255,
     /*  468779 */     GIR_EraseRootFromParent_Done,
     /*  468780 */   // Label 8048: @468780
     /*  468780 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(468855), // Rule ID 3258 //
     /*  468785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  468796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  468799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  468802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468831 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  468834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468853 */     GIR_RootConstrainSelectedInstOperands,
     /*  468854 */     // GIR_Coverage, 3258,
     /*  468854 */     GIR_EraseRootFromParent_Done,
     /*  468855 */   // Label 8049: @468855
     /*  468855 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(468930), // Rule ID 3259 //
     /*  468860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  468868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  468871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  468874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  468877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11312:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  468909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468928 */     GIR_RootConstrainSelectedInstOperands,
     /*  468929 */     // GIR_Coverage, 3259,
     /*  468929 */     GIR_EraseRootFromParent_Done,
     /*  468930 */   // Label 8050: @468930
     /*  468930 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(469005), // Rule ID 3262 //
     /*  468935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  468943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  468946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  468949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  468952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  468974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468981 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  468981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  468984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  468992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469003 */     GIR_RootConstrainSelectedInstOperands,
     /*  469004 */     // GIR_Coverage, 3262,
     /*  469004 */     GIR_EraseRootFromParent_Done,
     /*  469005 */   // Label 8051: @469005
     /*  469005 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(469080), // Rule ID 3263 //
     /*  469010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  469059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469078 */     GIR_RootConstrainSelectedInstOperands,
     /*  469079 */     // GIR_Coverage, 3263,
     /*  469079 */     GIR_EraseRootFromParent_Done,
     /*  469080 */   // Label 8052: @469080
     /*  469080 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(469155), // Rule ID 3266 //
     /*  469085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469131 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  469134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469153 */     GIR_RootConstrainSelectedInstOperands,
     /*  469154 */     // GIR_Coverage, 3266,
     /*  469154 */     GIR_EraseRootFromParent_Done,
     /*  469155 */   // Label 8053: @469155
     /*  469155 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(469230), // Rule ID 3267 //
     /*  469160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469206 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  469209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469228 */     GIR_RootConstrainSelectedInstOperands,
     /*  469229 */     // GIR_Coverage, 3267,
     /*  469229 */     GIR_EraseRootFromParent_Done,
     /*  469230 */   // Label 8054: @469230
     /*  469230 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(469305), // Rule ID 3270 //
     /*  469235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469281 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469303 */     GIR_RootConstrainSelectedInstOperands,
     /*  469304 */     // GIR_Coverage, 3270,
     /*  469304 */     GIR_EraseRootFromParent_Done,
     /*  469305 */   // Label 8055: @469305
     /*  469305 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(469380), // Rule ID 3271 //
     /*  469310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469378 */     GIR_RootConstrainSelectedInstOperands,
     /*  469379 */     // GIR_Coverage, 3271,
     /*  469379 */     GIR_EraseRootFromParent_Done,
     /*  469380 */   // Label 8056: @469380
     /*  469380 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(469455), // Rule ID 3274 //
     /*  469385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469431 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  469431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  469434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469453 */     GIR_RootConstrainSelectedInstOperands,
     /*  469454 */     // GIR_Coverage, 3274,
     /*  469454 */     GIR_EraseRootFromParent_Done,
     /*  469455 */   // Label 8057: @469455
     /*  469455 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(469530), // Rule ID 3275 //
     /*  469460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  469506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  469509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469528 */     GIR_RootConstrainSelectedInstOperands,
     /*  469529 */     // GIR_Coverage, 3275,
     /*  469529 */     GIR_EraseRootFromParent_Done,
     /*  469530 */   // Label 8058: @469530
     /*  469530 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(469605), // Rule ID 3278 //
     /*  469535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  469546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  469549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  469552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469581 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  469581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469603 */     GIR_RootConstrainSelectedInstOperands,
     /*  469604 */     // GIR_Coverage, 3278,
     /*  469604 */     GIR_EraseRootFromParent_Done,
     /*  469605 */   // Label 8059: @469605
     /*  469605 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(469680), // Rule ID 3279 //
     /*  469610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  469621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  469624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  469627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  469656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469678 */     GIR_RootConstrainSelectedInstOperands,
     /*  469679 */     // GIR_Coverage, 3279,
     /*  469679 */     GIR_EraseRootFromParent_Done,
     /*  469680 */   // Label 8060: @469680
     /*  469680 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(469755), // Rule ID 3282 //
     /*  469685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  469696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  469699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  469702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469753 */     GIR_RootConstrainSelectedInstOperands,
     /*  469754 */     // GIR_Coverage, 3282,
     /*  469754 */     GIR_EraseRootFromParent_Done,
     /*  469755 */   // Label 8061: @469755
     /*  469755 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(469830), // Rule ID 3283 //
     /*  469760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  469771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  469774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  469777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  469809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469828 */     GIR_RootConstrainSelectedInstOperands,
     /*  469829 */     // GIR_Coverage, 3283,
     /*  469829 */     GIR_EraseRootFromParent_Done,
     /*  469830 */   // Label 8062: @469830
     /*  469830 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(469905), // Rule ID 3286 //
     /*  469835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  469846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  469849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  469852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469881 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  469884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469903 */     GIR_RootConstrainSelectedInstOperands,
     /*  469904 */     // GIR_Coverage, 3286,
     /*  469904 */     GIR_EraseRootFromParent_Done,
     /*  469905 */   // Label 8063: @469905
     /*  469905 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(469980), // Rule ID 3287 //
     /*  469910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  469921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  469924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  469927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  469949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  469959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  469967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469978 */     GIR_RootConstrainSelectedInstOperands,
     /*  469979 */     // GIR_Coverage, 3287,
     /*  469979 */     GIR_EraseRootFromParent_Done,
     /*  469980 */   // Label 8064: @469980
     /*  469980 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(470055), // Rule ID 3290 //
     /*  469985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  469993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  469996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  469999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470031 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470053 */     GIR_RootConstrainSelectedInstOperands,
     /*  470054 */     // GIR_Coverage, 3290,
     /*  470054 */     GIR_EraseRootFromParent_Done,
     /*  470055 */   // Label 8065: @470055
     /*  470055 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(470130), // Rule ID 3291 //
     /*  470060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470128 */     GIR_RootConstrainSelectedInstOperands,
     /*  470129 */     // GIR_Coverage, 3291,
     /*  470129 */     GIR_EraseRootFromParent_Done,
     /*  470130 */   // Label 8066: @470130
     /*  470130 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(470205), // Rule ID 3294 //
     /*  470135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470203 */     GIR_RootConstrainSelectedInstOperands,
     /*  470204 */     // GIR_Coverage, 3294,
     /*  470204 */     GIR_EraseRootFromParent_Done,
     /*  470205 */   // Label 8067: @470205
     /*  470205 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(470280), // Rule ID 3295 //
     /*  470210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470278 */     GIR_RootConstrainSelectedInstOperands,
     /*  470279 */     // GIR_Coverage, 3295,
     /*  470279 */     GIR_EraseRootFromParent_Done,
     /*  470280 */   // Label 8068: @470280
     /*  470280 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(470355), // Rule ID 3298 //
     /*  470285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  470288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  470296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  470299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  470302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470331 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  470331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  470350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470353 */     GIR_RootConstrainSelectedInstOperands,
     /*  470354 */     // GIR_Coverage, 3298,
     /*  470354 */     GIR_EraseRootFromParent_Done,
     /*  470355 */   // Label 8069: @470355
     /*  470355 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(470430), // Rule ID 3299 //
     /*  470360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  470363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  470371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  470374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  470377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  470406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  470409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  470425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470428 */     GIR_RootConstrainSelectedInstOperands,
     /*  470429 */     // GIR_Coverage, 3299,
     /*  470429 */     GIR_EraseRootFromParent_Done,
     /*  470430 */   // Label 8070: @470430
     /*  470430 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(470505), // Rule ID 3302 //
     /*  470435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  470446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  470449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  470452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  470484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470503 */     GIR_RootConstrainSelectedInstOperands,
     /*  470504 */     // GIR_Coverage, 3302,
     /*  470504 */     GIR_EraseRootFromParent_Done,
     /*  470505 */   // Label 8071: @470505
     /*  470505 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(470580), // Rule ID 3303 //
     /*  470510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  470521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  470524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  470527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  470559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470578 */     GIR_RootConstrainSelectedInstOperands,
     /*  470579 */     // GIR_Coverage, 3303,
     /*  470579 */     GIR_EraseRootFromParent_Done,
     /*  470580 */   // Label 8072: @470580
     /*  470580 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(470655), // Rule ID 3306 //
     /*  470585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  470596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  470599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  470602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470631 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  470634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470653 */     GIR_RootConstrainSelectedInstOperands,
     /*  470654 */     // GIR_Coverage, 3306,
     /*  470654 */     GIR_EraseRootFromParent_Done,
     /*  470655 */   // Label 8073: @470655
     /*  470655 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(470730), // Rule ID 3307 //
     /*  470660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  470671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  470674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  470677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  470709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470728 */     GIR_RootConstrainSelectedInstOperands,
     /*  470729 */     // GIR_Coverage, 3307,
     /*  470729 */     GIR_EraseRootFromParent_Done,
     /*  470730 */   // Label 8074: @470730
     /*  470730 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(470805), // Rule ID 3310 //
     /*  470735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  470746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  470749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  470752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  470784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470803 */     GIR_RootConstrainSelectedInstOperands,
     /*  470804 */     // GIR_Coverage, 3310,
     /*  470804 */     GIR_EraseRootFromParent_Done,
     /*  470805 */   // Label 8075: @470805
     /*  470805 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(470880), // Rule ID 3311 //
     /*  470810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  470821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  470824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  470827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  470845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  470859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470878 */     GIR_RootConstrainSelectedInstOperands,
     /*  470879 */     // GIR_Coverage, 3311,
     /*  470879 */     GIR_EraseRootFromParent_Done,
     /*  470880 */   // Label 8076: @470880
     /*  470880 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(470955), // Rule ID 3314 //
     /*  470885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  470896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  470899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  470902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  470934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  470942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470953 */     GIR_RootConstrainSelectedInstOperands,
     /*  470954 */     // GIR_Coverage, 3314,
     /*  470954 */     GIR_EraseRootFromParent_Done,
     /*  470955 */   // Label 8077: @470955
     /*  470955 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(471030), // Rule ID 3315 //
     /*  470960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  470968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  470971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  470974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  470977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  470999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  471009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471028 */     GIR_RootConstrainSelectedInstOperands,
     /*  471029 */     // GIR_Coverage, 3315,
     /*  471029 */     GIR_EraseRootFromParent_Done,
     /*  471030 */   // Label 8078: @471030
     /*  471030 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(471105), // Rule ID 3318 //
     /*  471035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471081 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  471084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471103 */     GIR_RootConstrainSelectedInstOperands,
     /*  471104 */     // GIR_Coverage, 3318,
     /*  471104 */     GIR_EraseRootFromParent_Done,
     /*  471105 */   // Label 8079: @471105
     /*  471105 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(471180), // Rule ID 3319 //
     /*  471110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  471159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471178 */     GIR_RootConstrainSelectedInstOperands,
     /*  471179 */     // GIR_Coverage, 3319,
     /*  471179 */     GIR_EraseRootFromParent_Done,
     /*  471180 */   // Label 8080: @471180
     /*  471180 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(471255), // Rule ID 3322 //
     /*  471185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  471196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  471199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  471202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471231 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  471234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471253 */     GIR_RootConstrainSelectedInstOperands,
     /*  471254 */     // GIR_Coverage, 3322,
     /*  471254 */     GIR_EraseRootFromParent_Done,
     /*  471255 */   // Label 8081: @471255
     /*  471255 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(471330), // Rule ID 3323 //
     /*  471260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  471271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  471274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  471277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  471309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471328 */     GIR_RootConstrainSelectedInstOperands,
     /*  471329 */     // GIR_Coverage, 3323,
     /*  471329 */     GIR_EraseRootFromParent_Done,
     /*  471330 */   // Label 8082: @471330
     /*  471330 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(471405), // Rule ID 3326 //
     /*  471335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  471346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  471349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  471352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  471384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471403 */     GIR_RootConstrainSelectedInstOperands,
     /*  471404 */     // GIR_Coverage, 3326,
     /*  471404 */     GIR_EraseRootFromParent_Done,
     /*  471405 */   // Label 8083: @471405
     /*  471405 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(471480), // Rule ID 3327 //
     /*  471410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  471421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  471424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  471427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  471459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471478 */     GIR_RootConstrainSelectedInstOperands,
     /*  471479 */     // GIR_Coverage, 3327,
     /*  471479 */     GIR_EraseRootFromParent_Done,
     /*  471480 */   // Label 8084: @471480
     /*  471480 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(471555), // Rule ID 3330 //
     /*  471485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  471496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  471499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  471502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471531 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  471534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471553 */     GIR_RootConstrainSelectedInstOperands,
     /*  471554 */     // GIR_Coverage, 3330,
     /*  471554 */     GIR_EraseRootFromParent_Done,
     /*  471555 */   // Label 8085: @471555
     /*  471555 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(471630), // Rule ID 3331 //
     /*  471560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  471571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  471574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  471577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  471609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471628 */     GIR_RootConstrainSelectedInstOperands,
     /*  471629 */     // GIR_Coverage, 3331,
     /*  471629 */     GIR_EraseRootFromParent_Done,
     /*  471630 */   // Label 8086: @471630
     /*  471630 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(471705), // Rule ID 3334 //
     /*  471635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  471646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  471649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  471652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471681 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  471684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471703 */     GIR_RootConstrainSelectedInstOperands,
     /*  471704 */     // GIR_Coverage, 3334,
     /*  471704 */     GIR_EraseRootFromParent_Done,
     /*  471705 */   // Label 8087: @471705
     /*  471705 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(471780), // Rule ID 3335 //
     /*  471710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  471721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  471724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  471727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471756 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  471759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471778 */     GIR_RootConstrainSelectedInstOperands,
     /*  471779 */     // GIR_Coverage, 3335,
     /*  471779 */     GIR_EraseRootFromParent_Done,
     /*  471780 */   // Label 8088: @471780
     /*  471780 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(471855), // Rule ID 3338 //
     /*  471785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  471796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  471799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  471802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471831 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  471834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471853 */     GIR_RootConstrainSelectedInstOperands,
     /*  471854 */     // GIR_Coverage, 3338,
     /*  471854 */     GIR_EraseRootFromParent_Done,
     /*  471855 */   // Label 8089: @471855
     /*  471855 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(471930), // Rule ID 3339 //
     /*  471860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  471871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  471874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  471877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  471909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471928 */     GIR_RootConstrainSelectedInstOperands,
     /*  471929 */     // GIR_Coverage, 3339,
     /*  471929 */     GIR_EraseRootFromParent_Done,
     /*  471930 */   // Label 8090: @471930
     /*  471930 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(472005), // Rule ID 3342 //
     /*  471935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  471943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  471946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  471949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  471952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  471974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471981 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  471984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  471992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472003 */     GIR_RootConstrainSelectedInstOperands,
     /*  472004 */     // GIR_Coverage, 3342,
     /*  472004 */     GIR_EraseRootFromParent_Done,
     /*  472005 */   // Label 8091: @472005
     /*  472005 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(472080), // Rule ID 3343 //
     /*  472010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  472018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  472021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  472024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  472027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  472049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  472059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472078 */     GIR_RootConstrainSelectedInstOperands,
     /*  472079 */     // GIR_Coverage, 3343,
     /*  472079 */     GIR_EraseRootFromParent_Done,
     /*  472080 */   // Label 8092: @472080
     /*  472080 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(472155), // Rule ID 3346 //
     /*  472085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  472093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  472096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  472099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  472102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  472124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  472134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472153 */     GIR_RootConstrainSelectedInstOperands,
     /*  472154 */     // GIR_Coverage, 3346,
     /*  472154 */     GIR_EraseRootFromParent_Done,
     /*  472155 */   // Label 8093: @472155
     /*  472155 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(472230), // Rule ID 3347 //
     /*  472160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  472168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  472171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  472174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  472177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  472199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  472209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472228 */     GIR_RootConstrainSelectedInstOperands,
     /*  472229 */     // GIR_Coverage, 3347,
     /*  472229 */     GIR_EraseRootFromParent_Done,
     /*  472230 */   // Label 8094: @472230
     /*  472230 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(472305), // Rule ID 3438 //
     /*  472235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  472246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  472249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  472252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  472255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  472284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472303 */     GIR_RootConstrainSelectedInstOperands,
     /*  472304 */     // GIR_Coverage, 3438,
     /*  472304 */     GIR_EraseRootFromParent_Done,
     /*  472305 */   // Label 8095: @472305
     /*  472305 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(472380), // Rule ID 3439 //
     /*  472310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  472321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  472324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  472327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  472330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  472359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472378 */     GIR_RootConstrainSelectedInstOperands,
     /*  472379 */     // GIR_Coverage, 3439,
     /*  472379 */     GIR_EraseRootFromParent_Done,
     /*  472380 */   // Label 8096: @472380
     /*  472380 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(472455), // Rule ID 3442 //
     /*  472385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  472396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  472399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  472402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  472405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472431 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  472434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472453 */     GIR_RootConstrainSelectedInstOperands,
     /*  472454 */     // GIR_Coverage, 3442,
     /*  472454 */     GIR_EraseRootFromParent_Done,
     /*  472455 */   // Label 8097: @472455
     /*  472455 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(472530), // Rule ID 3443 //
     /*  472460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  472471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  472474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  472477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  472480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  472509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472528 */     GIR_RootConstrainSelectedInstOperands,
     /*  472529 */     // GIR_Coverage, 3443,
     /*  472529 */     GIR_EraseRootFromParent_Done,
     /*  472530 */   // Label 8098: @472530
     /*  472530 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(472605), // Rule ID 3446 //
     /*  472535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  472546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  472549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  472552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  472555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  472584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472603 */     GIR_RootConstrainSelectedInstOperands,
     /*  472604 */     // GIR_Coverage, 3446,
     /*  472604 */     GIR_EraseRootFromParent_Done,
     /*  472605 */   // Label 8099: @472605
     /*  472605 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(472680), // Rule ID 3447 //
     /*  472610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  472621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  472624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  472627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  472630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  472659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472678 */     GIR_RootConstrainSelectedInstOperands,
     /*  472679 */     // GIR_Coverage, 3447,
     /*  472679 */     GIR_EraseRootFromParent_Done,
     /*  472680 */   // Label 8100: @472680
     /*  472680 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(472755), // Rule ID 3450 //
     /*  472685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  472702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  472705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  472734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472753 */     GIR_RootConstrainSelectedInstOperands,
     /*  472754 */     // GIR_Coverage, 3450,
     /*  472754 */     GIR_EraseRootFromParent_Done,
     /*  472755 */   // Label 8101: @472755
     /*  472755 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(472830), // Rule ID 3451 //
     /*  472760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  472777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  472780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  472809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472828 */     GIR_RootConstrainSelectedInstOperands,
     /*  472829 */     // GIR_Coverage, 3451,
     /*  472829 */     GIR_EraseRootFromParent_Done,
     /*  472830 */   // Label 8102: @472830
     /*  472830 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(472905), // Rule ID 3454 //
     /*  472835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  472852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  472855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472881 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  472884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472903 */     GIR_RootConstrainSelectedInstOperands,
     /*  472904 */     // GIR_Coverage, 3454,
     /*  472904 */     GIR_EraseRootFromParent_Done,
     /*  472905 */   // Label 8103: @472905
     /*  472905 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(472980), // Rule ID 3455 //
     /*  472910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  472927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  472930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  472959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  472967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472978 */     GIR_RootConstrainSelectedInstOperands,
     /*  472979 */     // GIR_Coverage, 3455,
     /*  472979 */     GIR_EraseRootFromParent_Done,
     /*  472980 */   // Label 8104: @472980
     /*  472980 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(473055), // Rule ID 3458 //
     /*  472985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  472993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  473002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  473005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  473034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473053 */     GIR_RootConstrainSelectedInstOperands,
     /*  473054 */     // GIR_Coverage, 3458,
     /*  473054 */     GIR_EraseRootFromParent_Done,
     /*  473055 */   // Label 8105: @473055
     /*  473055 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(473130), // Rule ID 3459 //
     /*  473060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  473071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  473074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  473077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  473080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  473109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473128 */     GIR_RootConstrainSelectedInstOperands,
     /*  473129 */     // GIR_Coverage, 3459,
     /*  473129 */     GIR_EraseRootFromParent_Done,
     /*  473130 */   // Label 8106: @473130
     /*  473130 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(473205), // Rule ID 3462 //
     /*  473135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  473146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  473149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  473155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  473184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473203 */     GIR_RootConstrainSelectedInstOperands,
     /*  473204 */     // GIR_Coverage, 3462,
     /*  473204 */     GIR_EraseRootFromParent_Done,
     /*  473205 */   // Label 8107: @473205
     /*  473205 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(473280), // Rule ID 3463 //
     /*  473210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  473221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  473224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  473230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  473259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473278 */     GIR_RootConstrainSelectedInstOperands,
     /*  473279 */     // GIR_Coverage, 3463,
     /*  473279 */     GIR_EraseRootFromParent_Done,
     /*  473280 */   // Label 8108: @473280
     /*  473280 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(473355), // Rule ID 3466 //
     /*  473285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  473296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  473299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  473302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  473305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  473334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473353 */     GIR_RootConstrainSelectedInstOperands,
     /*  473354 */     // GIR_Coverage, 3466,
     /*  473354 */     GIR_EraseRootFromParent_Done,
     /*  473355 */   // Label 8109: @473355
     /*  473355 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(473430), // Rule ID 3467 //
     /*  473360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  473371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  473374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  473377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  473380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  473409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473428 */     GIR_RootConstrainSelectedInstOperands,
     /*  473429 */     // GIR_Coverage, 3467,
     /*  473429 */     GIR_EraseRootFromParent_Done,
     /*  473430 */   // Label 8110: @473430
     /*  473430 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(473505), // Rule ID 3470 //
     /*  473435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  473446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  473449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  473452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  473455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  473484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473503 */     GIR_RootConstrainSelectedInstOperands,
     /*  473504 */     // GIR_Coverage, 3470,
     /*  473504 */     GIR_EraseRootFromParent_Done,
     /*  473505 */   // Label 8111: @473505
     /*  473505 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(473580), // Rule ID 3471 //
     /*  473510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  473521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  473524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  473527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  473530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  473559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473578 */     GIR_RootConstrainSelectedInstOperands,
     /*  473579 */     // GIR_Coverage, 3471,
     /*  473579 */     GIR_EraseRootFromParent_Done,
     /*  473580 */   // Label 8112: @473580
     /*  473580 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(473655), // Rule ID 3474 //
     /*  473585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  473602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  473605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473631 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  473634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473653 */     GIR_RootConstrainSelectedInstOperands,
     /*  473654 */     // GIR_Coverage, 3474,
     /*  473654 */     GIR_EraseRootFromParent_Done,
     /*  473655 */   // Label 8113: @473655
     /*  473655 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(473730), // Rule ID 3475 //
     /*  473660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  473677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  473680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  473709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473728 */     GIR_RootConstrainSelectedInstOperands,
     /*  473729 */     // GIR_Coverage, 3475,
     /*  473729 */     GIR_EraseRootFromParent_Done,
     /*  473730 */   // Label 8114: @473730
     /*  473730 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(473805), // Rule ID 3478 //
     /*  473735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  473752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  473755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  473784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473803 */     GIR_RootConstrainSelectedInstOperands,
     /*  473804 */     // GIR_Coverage, 3478,
     /*  473804 */     GIR_EraseRootFromParent_Done,
     /*  473805 */   // Label 8115: @473805
     /*  473805 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(473880), // Rule ID 3479 //
     /*  473810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  473827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  473830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  473859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473878 */     GIR_RootConstrainSelectedInstOperands,
     /*  473879 */     // GIR_Coverage, 3479,
     /*  473879 */     GIR_EraseRootFromParent_Done,
     /*  473880 */   // Label 8116: @473880
     /*  473880 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(473955), // Rule ID 3482 //
     /*  473885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  473888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  473896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  473899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  473902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  473905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  473934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  473942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473953 */     GIR_RootConstrainSelectedInstOperands,
     /*  473954 */     // GIR_Coverage, 3482,
     /*  473954 */     GIR_EraseRootFromParent_Done,
     /*  473955 */   // Label 8117: @473955
     /*  473955 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(474030), // Rule ID 3483 //
     /*  473960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  473963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  473968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  473971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  473974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  473977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  473980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  474009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474028 */     GIR_RootConstrainSelectedInstOperands,
     /*  474029 */     // GIR_Coverage, 3483,
     /*  474029 */     GIR_EraseRootFromParent_Done,
     /*  474030 */   // Label 8118: @474030
     /*  474030 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(474105), // Rule ID 3486 //
     /*  474035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  474038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  474046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  474049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  474055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  474084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474103 */     GIR_RootConstrainSelectedInstOperands,
     /*  474104 */     // GIR_Coverage, 3486,
     /*  474104 */     GIR_EraseRootFromParent_Done,
     /*  474105 */   // Label 8119: @474105
     /*  474105 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(474180), // Rule ID 3487 //
     /*  474110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  474113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  474121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  474124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  474130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  474159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474178 */     GIR_RootConstrainSelectedInstOperands,
     /*  474179 */     // GIR_Coverage, 3487,
     /*  474179 */     GIR_EraseRootFromParent_Done,
     /*  474180 */   // Label 8120: @474180
     /*  474180 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(474255), // Rule ID 3490 //
     /*  474185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  474188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  474196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  474199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  474202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  474205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  474234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474253 */     GIR_RootConstrainSelectedInstOperands,
     /*  474254 */     // GIR_Coverage, 3490,
     /*  474254 */     GIR_EraseRootFromParent_Done,
     /*  474255 */   // Label 8121: @474255
     /*  474255 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(474330), // Rule ID 3491 //
     /*  474260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  474263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  474271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  474274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  474277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  474280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  474309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474328 */     GIR_RootConstrainSelectedInstOperands,
     /*  474329 */     // GIR_Coverage, 3491,
     /*  474329 */     GIR_EraseRootFromParent_Done,
     /*  474330 */   // Label 8122: @474330
     /*  474330 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(474405), // Rule ID 3494 //
     /*  474335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  474338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  474346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  474349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  474352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  474355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  474362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  474366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474381 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  474384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474403 */     GIR_RootConstrainSelectedInstOperands,
     /*  474404 */     // GIR_Coverage, 3494,
     /*  474404 */     GIR_EraseRootFromParent_Done,
     /*  474405 */   // Label 8123: @474405
     /*  474405 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(474480), // Rule ID 3495 //
     /*  474410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  474413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  474421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  474424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  474427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  474430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  474437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  474441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  474459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474478 */     GIR_RootConstrainSelectedInstOperands,
     /*  474479 */     // GIR_Coverage, 3495,
     /*  474479 */     GIR_EraseRootFromParent_Done,
     /*  474480 */   // Label 8124: @474480
     /*  474480 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(474555), // Rule ID 3498 //
     /*  474485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  474502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474531 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  474534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474553 */     GIR_RootConstrainSelectedInstOperands,
     /*  474554 */     // GIR_Coverage, 3498,
     /*  474554 */     GIR_EraseRootFromParent_Done,
     /*  474555 */   // Label 8125: @474555
     /*  474555 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(474630), // Rule ID 3499 //
     /*  474560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  474577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  474609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474628 */     GIR_RootConstrainSelectedInstOperands,
     /*  474629 */     // GIR_Coverage, 3499,
     /*  474629 */     GIR_EraseRootFromParent_Done,
     /*  474630 */   // Label 8126: @474630
     /*  474630 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(474705), // Rule ID 3502 //
     /*  474635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474681 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  474684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474703 */     GIR_RootConstrainSelectedInstOperands,
     /*  474704 */     // GIR_Coverage, 3502,
     /*  474704 */     GIR_EraseRootFromParent_Done,
     /*  474705 */   // Label 8127: @474705
     /*  474705 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(474780), // Rule ID 3503 //
     /*  474710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  474759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474778 */     GIR_RootConstrainSelectedInstOperands,
     /*  474779 */     // GIR_Coverage, 3503,
     /*  474779 */     GIR_EraseRootFromParent_Done,
     /*  474780 */   // Label 8128: @474780
     /*  474780 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(474855), // Rule ID 3506 //
     /*  474785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474831 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  474834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474853 */     GIR_RootConstrainSelectedInstOperands,
     /*  474854 */     // GIR_Coverage, 3506,
     /*  474854 */     GIR_EraseRootFromParent_Done,
     /*  474855 */   // Label 8129: @474855
     /*  474855 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(474930), // Rule ID 3507 //
     /*  474860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  474909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474928 */     GIR_RootConstrainSelectedInstOperands,
     /*  474929 */     // GIR_Coverage, 3507,
     /*  474929 */     GIR_EraseRootFromParent_Done,
     /*  474930 */   // Label 8130: @474930
     /*  474930 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(475005), // Rule ID 3510 //
     /*  474935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  474943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  474946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  474949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  474974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  474984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  474992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475003 */     GIR_RootConstrainSelectedInstOperands,
     /*  475004 */     // GIR_Coverage, 3510,
     /*  475004 */     GIR_EraseRootFromParent_Done,
     /*  475005 */   // Label 8131: @475005
     /*  475005 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(475080), // Rule ID 3511 //
     /*  475010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  475027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  475059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475078 */     GIR_RootConstrainSelectedInstOperands,
     /*  475079 */     // GIR_Coverage, 3511,
     /*  475079 */     GIR_EraseRootFromParent_Done,
     /*  475080 */   // Label 8132: @475080
     /*  475080 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(475155), // Rule ID 3514 //
     /*  475085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475131 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  475134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475153 */     GIR_RootConstrainSelectedInstOperands,
     /*  475154 */     // GIR_Coverage, 3514,
     /*  475154 */     GIR_EraseRootFromParent_Done,
     /*  475155 */   // Label 8133: @475155
     /*  475155 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(475230), // Rule ID 3515 //
     /*  475160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  475209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475228 */     GIR_RootConstrainSelectedInstOperands,
     /*  475229 */     // GIR_Coverage, 3515,
     /*  475229 */     GIR_EraseRootFromParent_Done,
     /*  475230 */   // Label 8134: @475230
     /*  475230 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(475305), // Rule ID 3518 //
     /*  475235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  475246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  475249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  475284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475303 */     GIR_RootConstrainSelectedInstOperands,
     /*  475304 */     // GIR_Coverage, 3518,
     /*  475304 */     GIR_EraseRootFromParent_Done,
     /*  475305 */   // Label 8135: @475305
     /*  475305 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(475380), // Rule ID 3519 //
     /*  475310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  475321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  475324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  475359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475378 */     GIR_RootConstrainSelectedInstOperands,
     /*  475379 */     // GIR_Coverage, 3519,
     /*  475379 */     GIR_EraseRootFromParent_Done,
     /*  475380 */   // Label 8136: @475380
     /*  475380 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(475455), // Rule ID 3522 //
     /*  475385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  475396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  475399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  475402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  475434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475453 */     GIR_RootConstrainSelectedInstOperands,
     /*  475454 */     // GIR_Coverage, 3522,
     /*  475454 */     GIR_EraseRootFromParent_Done,
     /*  475455 */   // Label 8137: @475455
     /*  475455 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(475530), // Rule ID 3523 //
     /*  475460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  475471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  475474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  475477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  475509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475528 */     GIR_RootConstrainSelectedInstOperands,
     /*  475529 */     // GIR_Coverage, 3523,
     /*  475529 */     GIR_EraseRootFromParent_Done,
     /*  475530 */   // Label 8138: @475530
     /*  475530 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(475605), // Rule ID 3526 //
     /*  475535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  475552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  475584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475603 */     GIR_RootConstrainSelectedInstOperands,
     /*  475604 */     // GIR_Coverage, 3526,
     /*  475604 */     GIR_EraseRootFromParent_Done,
     /*  475605 */   // Label 8139: @475605
     /*  475605 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(475680), // Rule ID 3527 //
     /*  475610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  475627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  475659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475678 */     GIR_RootConstrainSelectedInstOperands,
     /*  475679 */     // GIR_Coverage, 3527,
     /*  475679 */     GIR_EraseRootFromParent_Done,
     /*  475680 */   // Label 8140: @475680
     /*  475680 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(475755), // Rule ID 3530 //
     /*  475685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  475696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  475699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  475734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475753 */     GIR_RootConstrainSelectedInstOperands,
     /*  475754 */     // GIR_Coverage, 3530,
     /*  475754 */     GIR_EraseRootFromParent_Done,
     /*  475755 */   // Label 8141: @475755
     /*  475755 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(475830), // Rule ID 3531 //
     /*  475760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  475771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  475774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  475809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475828 */     GIR_RootConstrainSelectedInstOperands,
     /*  475829 */     // GIR_Coverage, 3531,
     /*  475829 */     GIR_EraseRootFromParent_Done,
     /*  475830 */   // Label 8142: @475830
     /*  475830 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(475905), // Rule ID 3534 //
     /*  475835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  475846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  475849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  475884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475903 */     GIR_RootConstrainSelectedInstOperands,
     /*  475904 */     // GIR_Coverage, 3534,
     /*  475904 */     GIR_EraseRootFromParent_Done,
     /*  475905 */   // Label 8143: @475905
     /*  475905 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(475980), // Rule ID 3535 //
     /*  475910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  475921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  475924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  475949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  475959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  475967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475978 */     GIR_RootConstrainSelectedInstOperands,
     /*  475979 */     // GIR_Coverage, 3535,
     /*  475979 */     GIR_EraseRootFromParent_Done,
     /*  475980 */   // Label 8144: @475980
     /*  475980 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(476055), // Rule ID 3538 //
     /*  475985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  475993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  475996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  475999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476031 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  476034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476053 */     GIR_RootConstrainSelectedInstOperands,
     /*  476054 */     // GIR_Coverage, 3538,
     /*  476054 */     GIR_EraseRootFromParent_Done,
     /*  476055 */   // Label 8145: @476055
     /*  476055 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(476130), // Rule ID 3539 //
     /*  476060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  476109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476128 */     GIR_RootConstrainSelectedInstOperands,
     /*  476129 */     // GIR_Coverage, 3539,
     /*  476129 */     GIR_EraseRootFromParent_Done,
     /*  476130 */   // Label 8146: @476130
     /*  476130 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(476205), // Rule ID 3542 //
     /*  476135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  476138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  476146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  476149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  476152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476181 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  476184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476203 */     GIR_RootConstrainSelectedInstOperands,
     /*  476204 */     // GIR_Coverage, 3542,
     /*  476204 */     GIR_EraseRootFromParent_Done,
     /*  476205 */   // Label 8147: @476205
     /*  476205 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(476280), // Rule ID 3543 //
     /*  476210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  476213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  476221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  476224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  476227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  476259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476278 */     GIR_RootConstrainSelectedInstOperands,
     /*  476279 */     // GIR_Coverage, 3543,
     /*  476279 */     GIR_EraseRootFromParent_Done,
     /*  476280 */   // Label 8148: @476280
     /*  476280 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(476355), // Rule ID 3546 //
     /*  476285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  476288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  476302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476331 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  476334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476353 */     GIR_RootConstrainSelectedInstOperands,
     /*  476354 */     // GIR_Coverage, 3546,
     /*  476354 */     GIR_EraseRootFromParent_Done,
     /*  476355 */   // Label 8149: @476355
     /*  476355 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(476430), // Rule ID 3547 //
     /*  476360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  476363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  476377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  476409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476428 */     GIR_RootConstrainSelectedInstOperands,
     /*  476429 */     // GIR_Coverage, 3547,
     /*  476429 */     GIR_EraseRootFromParent_Done,
     /*  476430 */   // Label 8150: @476430
     /*  476430 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(476505), // Rule ID 3550 //
     /*  476435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  476438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476481 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  476484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476503 */     GIR_RootConstrainSelectedInstOperands,
     /*  476504 */     // GIR_Coverage, 3550,
     /*  476504 */     GIR_EraseRootFromParent_Done,
     /*  476505 */   // Label 8151: @476505
     /*  476505 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(476580), // Rule ID 3551 //
     /*  476510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  476513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  476559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476578 */     GIR_RootConstrainSelectedInstOperands,
     /*  476579 */     // GIR_Coverage, 3551,
     /*  476579 */     GIR_EraseRootFromParent_Done,
     /*  476580 */   // Label 8152: @476580
     /*  476580 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(476655), // Rule ID 3554 //
     /*  476585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  476588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  476596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  476599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476631 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  476634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476653 */     GIR_RootConstrainSelectedInstOperands,
     /*  476654 */     // GIR_Coverage, 3554,
     /*  476654 */     GIR_EraseRootFromParent_Done,
     /*  476655 */   // Label 8153: @476655
     /*  476655 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(476730), // Rule ID 3555 //
     /*  476660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  476663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  476668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  476671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  476674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  476699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  476709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476728 */     GIR_RootConstrainSelectedInstOperands,
     /*  476729 */     // GIR_Coverage, 3555,
     /*  476729 */     GIR_EraseRootFromParent_Done,
     /*  476730 */   // Label 8154: @476730
     /*  476730 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(476805), // Rule ID 3558 //
     /*  476735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  476743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  476746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  476749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  476752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  476755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  476781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  476784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476803 */     GIR_RootConstrainSelectedInstOperands,
     /*  476804 */     // GIR_Coverage, 3558,
     /*  476804 */     GIR_EraseRootFromParent_Done,
     /*  476805 */   // Label 8155: @476805
     /*  476805 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(476880), // Rule ID 3559 //
     /*  476810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  476818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  476821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  476824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  476827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  476830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  476856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  476859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476878 */     GIR_RootConstrainSelectedInstOperands,
     /*  476879 */     // GIR_Coverage, 3559,
     /*  476879 */     GIR_EraseRootFromParent_Done,
     /*  476880 */   // Label 8156: @476880
     /*  476880 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(476955), // Rule ID 3562 //
     /*  476885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  476893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  476896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  476899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  476902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  476905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476931 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  476931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  476934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  476942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476953 */     GIR_RootConstrainSelectedInstOperands,
     /*  476954 */     // GIR_Coverage, 3562,
     /*  476954 */     GIR_EraseRootFromParent_Done,
     /*  476955 */   // Label 8157: @476955
     /*  476955 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(477030), // Rule ID 3563 //
     /*  476960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  476968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  476971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  476974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  476977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  476980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  477009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477028 */     GIR_RootConstrainSelectedInstOperands,
     /*  477029 */     // GIR_Coverage, 3563,
     /*  477029 */     GIR_EraseRootFromParent_Done,
     /*  477030 */   // Label 8158: @477030
     /*  477030 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(477105), // Rule ID 3566 //
     /*  477035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  477055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  477084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477103 */     GIR_RootConstrainSelectedInstOperands,
     /*  477104 */     // GIR_Coverage, 3566,
     /*  477104 */     GIR_EraseRootFromParent_Done,
     /*  477105 */   // Label 8159: @477105
     /*  477105 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(477180), // Rule ID 3567 //
     /*  477110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  477130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  477159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477178 */     GIR_RootConstrainSelectedInstOperands,
     /*  477179 */     // GIR_Coverage, 3567,
     /*  477179 */     GIR_EraseRootFromParent_Done,
     /*  477180 */   // Label 8160: @477180
     /*  477180 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(477255), // Rule ID 3570 //
     /*  477185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  477196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  477199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  477202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  477205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  477234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477253 */     GIR_RootConstrainSelectedInstOperands,
     /*  477254 */     // GIR_Coverage, 3570,
     /*  477254 */     GIR_EraseRootFromParent_Done,
     /*  477255 */   // Label 8161: @477255
     /*  477255 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(477330), // Rule ID 3571 //
     /*  477260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  477271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  477274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  477277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  477280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  477309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477328 */     GIR_RootConstrainSelectedInstOperands,
     /*  477329 */     // GIR_Coverage, 3571,
     /*  477329 */     GIR_EraseRootFromParent_Done,
     /*  477330 */   // Label 8162: @477330
     /*  477330 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(477405), // Rule ID 3574 //
     /*  477335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  477346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  477349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  477352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  477355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477381 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  477384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477403 */     GIR_RootConstrainSelectedInstOperands,
     /*  477404 */     // GIR_Coverage, 3574,
     /*  477404 */     GIR_EraseRootFromParent_Done,
     /*  477405 */   // Label 8163: @477405
     /*  477405 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(477480), // Rule ID 3575 //
     /*  477410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  477421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  477424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  477427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  477430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477456 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  477459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477478 */     GIR_RootConstrainSelectedInstOperands,
     /*  477479 */     // GIR_Coverage, 3575,
     /*  477479 */     GIR_EraseRootFromParent_Done,
     /*  477480 */   // Label 8164: @477480
     /*  477480 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(477555), // Rule ID 3578 //
     /*  477485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  477496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  477499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  477502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  477505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477531 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  477534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477553 */     GIR_RootConstrainSelectedInstOperands,
     /*  477554 */     // GIR_Coverage, 3578,
     /*  477554 */     GIR_EraseRootFromParent_Done,
     /*  477555 */   // Label 8165: @477555
     /*  477555 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(477630), // Rule ID 3579 //
     /*  477560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  477571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  477574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  477577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  477580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  477609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477628 */     GIR_RootConstrainSelectedInstOperands,
     /*  477629 */     // GIR_Coverage, 3579,
     /*  477629 */     GIR_EraseRootFromParent_Done,
     /*  477630 */   // Label 8166: @477630
     /*  477630 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(477705), // Rule ID 3582 //
     /*  477635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  477655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  477684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477703 */     GIR_RootConstrainSelectedInstOperands,
     /*  477704 */     // GIR_Coverage, 3582,
     /*  477704 */     GIR_EraseRootFromParent_Done,
     /*  477705 */   // Label 8167: @477705
     /*  477705 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(477780), // Rule ID 3583 //
     /*  477710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  477730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  477759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477778 */     GIR_RootConstrainSelectedInstOperands,
     /*  477779 */     // GIR_Coverage, 3583,
     /*  477779 */     GIR_EraseRootFromParent_Done,
     /*  477780 */   // Label 8168: @477780
     /*  477780 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(477855), // Rule ID 3586 //
     /*  477785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  477796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  477799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  477805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  477834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477853 */     GIR_RootConstrainSelectedInstOperands,
     /*  477854 */     // GIR_Coverage, 3586,
     /*  477854 */     GIR_EraseRootFromParent_Done,
     /*  477855 */   // Label 8169: @477855
     /*  477855 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(477930), // Rule ID 3587 //
     /*  477860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  477871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  477874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  477880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  477909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477928 */     GIR_RootConstrainSelectedInstOperands,
     /*  477929 */     // GIR_Coverage, 3587,
     /*  477929 */     GIR_EraseRootFromParent_Done,
     /*  477930 */   // Label 8170: @477930
     /*  477930 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(478005), // Rule ID 3590 //
     /*  477935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  477943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  477946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  477949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  477952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  477955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  477984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  477992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478003 */     GIR_RootConstrainSelectedInstOperands,
     /*  478004 */     // GIR_Coverage, 3590,
     /*  478004 */     GIR_EraseRootFromParent_Done,
     /*  478005 */   // Label 8171: @478005
     /*  478005 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(478080), // Rule ID 3591 //
     /*  478010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  478021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  478024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  478030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  478059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478078 */     GIR_RootConstrainSelectedInstOperands,
     /*  478079 */     // GIR_Coverage, 3591,
     /*  478079 */     GIR_EraseRootFromParent_Done,
     /*  478080 */   // Label 8172: @478080
     /*  478080 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(478155), // Rule ID 3594 //
     /*  478085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  478096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  478099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  478105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  478134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478153 */     GIR_RootConstrainSelectedInstOperands,
     /*  478154 */     // GIR_Coverage, 3594,
     /*  478154 */     GIR_EraseRootFromParent_Done,
     /*  478155 */   // Label 8173: @478155
     /*  478155 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(478230), // Rule ID 3595 //
     /*  478160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  478171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  478174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  478180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  478209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478228 */     GIR_RootConstrainSelectedInstOperands,
     /*  478229 */     // GIR_Coverage, 3595,
     /*  478229 */     GIR_EraseRootFromParent_Done,
     /*  478230 */   // Label 8174: @478230
     /*  478230 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(478305), // Rule ID 3598 //
     /*  478235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  478246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  478249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  478255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478281 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  478284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478303 */     GIR_RootConstrainSelectedInstOperands,
     /*  478304 */     // GIR_Coverage, 3598,
     /*  478304 */     GIR_EraseRootFromParent_Done,
     /*  478305 */   // Label 8175: @478305
     /*  478305 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(478380), // Rule ID 3599 //
     /*  478310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  478321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  478324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  478330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478356 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  478359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478378 */     GIR_RootConstrainSelectedInstOperands,
     /*  478379 */     // GIR_Coverage, 3599,
     /*  478379 */     GIR_EraseRootFromParent_Done,
     /*  478380 */   // Label 8176: @478380
     /*  478380 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(478455), // Rule ID 3602 //
     /*  478385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  478388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  478405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478431 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  478434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478453 */     GIR_RootConstrainSelectedInstOperands,
     /*  478454 */     // GIR_Coverage, 3602,
     /*  478454 */     GIR_EraseRootFromParent_Done,
     /*  478455 */   // Label 8177: @478455
     /*  478455 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(478530), // Rule ID 3603 //
     /*  478460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  478463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  478480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  478509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478528 */     GIR_RootConstrainSelectedInstOperands,
     /*  478529 */     // GIR_Coverage, 3603,
     /*  478529 */     GIR_EraseRootFromParent_Done,
     /*  478530 */   // Label 8178: @478530
     /*  478530 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(478605), // Rule ID 3606 //
     /*  478535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  478538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  478546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  478549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  478555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478581 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  478584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478603 */     GIR_RootConstrainSelectedInstOperands,
     /*  478604 */     // GIR_Coverage, 3606,
     /*  478604 */     GIR_EraseRootFromParent_Done,
     /*  478605 */   // Label 8179: @478605
     /*  478605 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(478680), // Rule ID 3607 //
     /*  478610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  478613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  478621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  478624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  478630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  478659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478678 */     GIR_RootConstrainSelectedInstOperands,
     /*  478679 */     // GIR_Coverage, 3607,
     /*  478679 */     GIR_EraseRootFromParent_Done,
     /*  478680 */   // Label 8180: @478680
     /*  478680 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(478755), // Rule ID 3610 //
     /*  478685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  478688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  478696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  478699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  478705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478731 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  478734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478753 */     GIR_RootConstrainSelectedInstOperands,
     /*  478754 */     // GIR_Coverage, 3610,
     /*  478754 */     GIR_EraseRootFromParent_Done,
     /*  478755 */   // Label 8181: @478755
     /*  478755 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(478830), // Rule ID 3611 //
     /*  478760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  478763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  478771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  478774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  478780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  478809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478828 */     GIR_RootConstrainSelectedInstOperands,
     /*  478829 */     // GIR_Coverage, 3611,
     /*  478829 */     GIR_EraseRootFromParent_Done,
     /*  478830 */   // Label 8182: @478830
     /*  478830 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(478905), // Rule ID 3614 //
     /*  478835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  478838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  478846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  478849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  478852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  478855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  478884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478903 */     GIR_RootConstrainSelectedInstOperands,
     /*  478904 */     // GIR_Coverage, 3614,
     /*  478904 */     GIR_EraseRootFromParent_Done,
     /*  478905 */   // Label 8183: @478905
     /*  478905 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(478980), // Rule ID 3615 //
     /*  478910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  478913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  478921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  478924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  478927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  478930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  478959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  478967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478978 */     GIR_RootConstrainSelectedInstOperands,
     /*  478979 */     // GIR_Coverage, 3615,
     /*  478979 */     GIR_EraseRootFromParent_Done,
     /*  478980 */   // Label 8184: @478980
     /*  478980 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(479055), // Rule ID 3618 //
     /*  478985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  478993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  478996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  478999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479031 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  479034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479053 */     GIR_RootConstrainSelectedInstOperands,
     /*  479054 */     // GIR_Coverage, 3618,
     /*  479054 */     GIR_EraseRootFromParent_Done,
     /*  479055 */   // Label 8185: @479055
     /*  479055 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(479130), // Rule ID 3619 //
     /*  479060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  479109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479128 */     GIR_RootConstrainSelectedInstOperands,
     /*  479129 */     // GIR_Coverage, 3619,
     /*  479129 */     GIR_EraseRootFromParent_Done,
     /*  479130 */   // Label 8186: @479130
     /*  479130 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(479205), // Rule ID 3622 //
     /*  479135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  479152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479181 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  479184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479203 */     GIR_RootConstrainSelectedInstOperands,
     /*  479204 */     // GIR_Coverage, 3622,
     /*  479204 */     GIR_EraseRootFromParent_Done,
     /*  479205 */   // Label 8187: @479205
     /*  479205 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(479280), // Rule ID 3623 //
     /*  479210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  479227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  479259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479278 */     GIR_RootConstrainSelectedInstOperands,
     /*  479279 */     // GIR_Coverage, 3623,
     /*  479279 */     GIR_EraseRootFromParent_Done,
     /*  479280 */   // Label 8188: @479280
     /*  479280 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(479355), // Rule ID 3626 //
     /*  479285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  479296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  479299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  479302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479331 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  479334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479353 */     GIR_RootConstrainSelectedInstOperands,
     /*  479354 */     // GIR_Coverage, 3626,
     /*  479354 */     GIR_EraseRootFromParent_Done,
     /*  479355 */   // Label 8189: @479355
     /*  479355 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(479430), // Rule ID 3627 //
     /*  479360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  479371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  479374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  479377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  479409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479428 */     GIR_RootConstrainSelectedInstOperands,
     /*  479429 */     // GIR_Coverage, 3627,
     /*  479429 */     GIR_EraseRootFromParent_Done,
     /*  479430 */   // Label 8190: @479430
     /*  479430 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(479505), // Rule ID 3630 //
     /*  479435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  479452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  479484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479503 */     GIR_RootConstrainSelectedInstOperands,
     /*  479504 */     // GIR_Coverage, 3630,
     /*  479504 */     GIR_EraseRootFromParent_Done,
     /*  479505 */   // Label 8191: @479505
     /*  479505 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(479580), // Rule ID 3631 //
     /*  479510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  479527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  479559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479578 */     GIR_RootConstrainSelectedInstOperands,
     /*  479579 */     // GIR_Coverage, 3631,
     /*  479579 */     GIR_EraseRootFromParent_Done,
     /*  479580 */   // Label 8192: @479580
     /*  479580 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(479655), // Rule ID 3634 //
     /*  479585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  479634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479653 */     GIR_RootConstrainSelectedInstOperands,
     /*  479654 */     // GIR_Coverage, 3634,
     /*  479654 */     GIR_EraseRootFromParent_Done,
     /*  479655 */   // Label 8193: @479655
     /*  479655 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(479730), // Rule ID 3635 //
     /*  479660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479706 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  479709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479728 */     GIR_RootConstrainSelectedInstOperands,
     /*  479729 */     // GIR_Coverage, 3635,
     /*  479729 */     GIR_EraseRootFromParent_Done,
     /*  479730 */   // Label 8194: @479730
     /*  479730 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(479805), // Rule ID 3638 //
     /*  479735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479781 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  479784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479803 */     GIR_RootConstrainSelectedInstOperands,
     /*  479804 */     // GIR_Coverage, 3638,
     /*  479804 */     GIR_EraseRootFromParent_Done,
     /*  479805 */   // Label 8195: @479805
     /*  479805 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(479880), // Rule ID 3639 //
     /*  479810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  479859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479878 */     GIR_RootConstrainSelectedInstOperands,
     /*  479879 */     // GIR_Coverage, 3639,
     /*  479879 */     GIR_EraseRootFromParent_Done,
     /*  479880 */   // Label 8196: @479880
     /*  479880 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(479955), // Rule ID 3642 //
     /*  479885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  479896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  479899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  479902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479931 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  479934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  479942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479953 */     GIR_RootConstrainSelectedInstOperands,
     /*  479954 */     // GIR_Coverage, 3642,
     /*  479954 */     GIR_EraseRootFromParent_Done,
     /*  479955 */   // Label 8197: @479955
     /*  479955 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(480030), // Rule ID 3643 //
     /*  479960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  479968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  479971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  479974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  479977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  479999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  480009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480028 */     GIR_RootConstrainSelectedInstOperands,
     /*  480029 */     // GIR_Coverage, 3643,
     /*  480029 */     GIR_EraseRootFromParent_Done,
     /*  480030 */   // Label 8198: @480030
     /*  480030 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(480105), // Rule ID 3646 //
     /*  480035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  480046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  480049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  480052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  480084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480103 */     GIR_RootConstrainSelectedInstOperands,
     /*  480104 */     // GIR_Coverage, 3646,
     /*  480104 */     GIR_EraseRootFromParent_Done,
     /*  480105 */   // Label 8199: @480105
     /*  480105 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(480180), // Rule ID 3647 //
     /*  480110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  480121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  480124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  480127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  480159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480178 */     GIR_RootConstrainSelectedInstOperands,
     /*  480179 */     // GIR_Coverage, 3647,
     /*  480179 */     GIR_EraseRootFromParent_Done,
     /*  480180 */   // Label 8200: @480180
     /*  480180 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(480255), // Rule ID 3650 //
     /*  480185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  480202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  480234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480253 */     GIR_RootConstrainSelectedInstOperands,
     /*  480254 */     // GIR_Coverage, 3650,
     /*  480254 */     GIR_EraseRootFromParent_Done,
     /*  480255 */   // Label 8201: @480255
     /*  480255 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(480330), // Rule ID 3651 //
     /*  480260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  480277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  480309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480328 */     GIR_RootConstrainSelectedInstOperands,
     /*  480329 */     // GIR_Coverage, 3651,
     /*  480329 */     GIR_EraseRootFromParent_Done,
     /*  480330 */   // Label 8202: @480330
     /*  480330 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(480405), // Rule ID 3654 //
     /*  480335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  480352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480381 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  480384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480403 */     GIR_RootConstrainSelectedInstOperands,
     /*  480404 */     // GIR_Coverage, 3654,
     /*  480404 */     GIR_EraseRootFromParent_Done,
     /*  480405 */   // Label 8203: @480405
     /*  480405 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(480480), // Rule ID 3655 //
     /*  480410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  480427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  480459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480478 */     GIR_RootConstrainSelectedInstOperands,
     /*  480479 */     // GIR_Coverage, 3655,
     /*  480479 */     GIR_EraseRootFromParent_Done,
     /*  480480 */   // Label 8204: @480480
     /*  480480 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(480555), // Rule ID 3658 //
     /*  480485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  480502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480531 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  480534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480553 */     GIR_RootConstrainSelectedInstOperands,
     /*  480554 */     // GIR_Coverage, 3658,
     /*  480554 */     GIR_EraseRootFromParent_Done,
     /*  480555 */   // Label 8205: @480555
     /*  480555 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(480630), // Rule ID 3659 //
     /*  480560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  480577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  480609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480628 */     GIR_RootConstrainSelectedInstOperands,
     /*  480629 */     // GIR_Coverage, 3659,
     /*  480629 */     GIR_EraseRootFromParent_Done,
     /*  480630 */   // Label 8206: @480630
     /*  480630 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(480705), // Rule ID 3662 //
     /*  480635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  480638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  480646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  480649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  480652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480681 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  480684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480703 */     GIR_RootConstrainSelectedInstOperands,
     /*  480704 */     // GIR_Coverage, 3662,
     /*  480704 */     GIR_EraseRootFromParent_Done,
     /*  480705 */   // Label 8207: @480705
     /*  480705 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(480780), // Rule ID 3663 //
     /*  480710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  480713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  480721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  480724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  480727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  480759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480778 */     GIR_RootConstrainSelectedInstOperands,
     /*  480779 */     // GIR_Coverage, 3663,
     /*  480779 */     GIR_EraseRootFromParent_Done,
     /*  480780 */   // Label 8208: @480780
     /*  480780 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(480855), // Rule ID 3666 //
     /*  480785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  480788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  480802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480831 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  480834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480853 */     GIR_RootConstrainSelectedInstOperands,
     /*  480854 */     // GIR_Coverage, 3666,
     /*  480854 */     GIR_EraseRootFromParent_Done,
     /*  480855 */   // Label 8209: @480855
     /*  480855 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(480930), // Rule ID 3667 //
     /*  480860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  480863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  480877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  480909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480928 */     GIR_RootConstrainSelectedInstOperands,
     /*  480929 */     // GIR_Coverage, 3667,
     /*  480929 */     GIR_EraseRootFromParent_Done,
     /*  480930 */   // Label 8210: @480930
     /*  480930 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(481005), // Rule ID 3670 //
     /*  480935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  480938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  480943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  480952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  480974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480981 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  480984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  480992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481003 */     GIR_RootConstrainSelectedInstOperands,
     /*  481004 */     // GIR_Coverage, 3670,
     /*  481004 */     GIR_EraseRootFromParent_Done,
     /*  481005 */   // Label 8211: @481005
     /*  481005 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(481080), // Rule ID 3671 //
     /*  481010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  481013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  481018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  481021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  481024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  481049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  481059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481078 */     GIR_RootConstrainSelectedInstOperands,
     /*  481079 */     // GIR_Coverage, 3671,
     /*  481079 */     GIR_EraseRootFromParent_Done,
     /*  481080 */   // Label 8212: @481080
     /*  481080 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(481155), // Rule ID 3674 //
     /*  481085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  481088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  481093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  481096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  481099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  481124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  481134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481153 */     GIR_RootConstrainSelectedInstOperands,
     /*  481154 */     // GIR_Coverage, 3674,
     /*  481154 */     GIR_EraseRootFromParent_Done,
     /*  481155 */   // Label 8213: @481155
     /*  481155 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(481230), // Rule ID 3675 //
     /*  481160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  481163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  481168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  481171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  481174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  481199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  481209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481228 */     GIR_RootConstrainSelectedInstOperands,
     /*  481229 */     // GIR_Coverage, 3675,
     /*  481229 */     GIR_EraseRootFromParent_Done,
     /*  481230 */   // Label 8214: @481230
     /*  481230 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(481305), // Rule ID 3678 //
     /*  481235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  481246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  481249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  481252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  481255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  481284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481303 */     GIR_RootConstrainSelectedInstOperands,
     /*  481304 */     // GIR_Coverage, 3678,
     /*  481304 */     GIR_EraseRootFromParent_Done,
     /*  481305 */   // Label 8215: @481305
     /*  481305 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(481380), // Rule ID 3679 //
     /*  481310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  481313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  481321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  481324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  481327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  481330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  481359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481378 */     GIR_RootConstrainSelectedInstOperands,
     /*  481379 */     // GIR_Coverage, 3679,
     /*  481379 */     GIR_EraseRootFromParent_Done,
     /*  481380 */   // Label 8216: @481380
     /*  481380 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(481455), // Rule ID 3682 //
     /*  481385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  481396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  481399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  481402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  481405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481431 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  481434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481453 */     GIR_RootConstrainSelectedInstOperands,
     /*  481454 */     // GIR_Coverage, 3682,
     /*  481454 */     GIR_EraseRootFromParent_Done,
     /*  481455 */   // Label 8217: @481455
     /*  481455 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(481530), // Rule ID 3683 //
     /*  481460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  481463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  481471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  481474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  481477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  481480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  481509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481528 */     GIR_RootConstrainSelectedInstOperands,
     /*  481529 */     // GIR_Coverage, 3683,
     /*  481529 */     GIR_EraseRootFromParent_Done,
     /*  481530 */   // Label 8218: @481530
     /*  481530 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(481605), // Rule ID 3686 //
     /*  481535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  481546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  481549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  481552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  481555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  481584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481603 */     GIR_RootConstrainSelectedInstOperands,
     /*  481604 */     // GIR_Coverage, 3686,
     /*  481604 */     GIR_EraseRootFromParent_Done,
     /*  481605 */   // Label 8219: @481605
     /*  481605 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(481680), // Rule ID 3687 //
     /*  481610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  481613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  481621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  481624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  481627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  481630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  481659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481678 */     GIR_RootConstrainSelectedInstOperands,
     /*  481679 */     // GIR_Coverage, 3687,
     /*  481679 */     GIR_EraseRootFromParent_Done,
     /*  481680 */   // Label 8220: @481680
     /*  481680 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(481755), // Rule ID 3690 //
     /*  481685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  481696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  481699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  481702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  481705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  481734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481753 */     GIR_RootConstrainSelectedInstOperands,
     /*  481754 */     // GIR_Coverage, 3690,
     /*  481754 */     GIR_EraseRootFromParent_Done,
     /*  481755 */   // Label 8221: @481755
     /*  481755 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(481830), // Rule ID 3691 //
     /*  481760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  481763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  481771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  481774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  481777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  481780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  481809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481828 */     GIR_RootConstrainSelectedInstOperands,
     /*  481829 */     // GIR_Coverage, 3691,
     /*  481829 */     GIR_EraseRootFromParent_Done,
     /*  481830 */   // Label 8222: @481830
     /*  481830 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(481905), // Rule ID 3694 //
     /*  481835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  481846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  481849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  481852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  481855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481881 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  481884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481903 */     GIR_RootConstrainSelectedInstOperands,
     /*  481904 */     // GIR_Coverage, 3694,
     /*  481904 */     GIR_EraseRootFromParent_Done,
     /*  481905 */   // Label 8223: @481905
     /*  481905 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(481980), // Rule ID 3695 //
     /*  481910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  481913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  481921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  481924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  481927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  481930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  481959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  481967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481978 */     GIR_RootConstrainSelectedInstOperands,
     /*  481979 */     // GIR_Coverage, 3695,
     /*  481979 */     GIR_EraseRootFromParent_Done,
     /*  481980 */   // Label 8224: @481980
     /*  481980 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(482055), // Rule ID 3698 //
     /*  481985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  481988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  481993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  481996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  481999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  482002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  482005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  482034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482053 */     GIR_RootConstrainSelectedInstOperands,
     /*  482054 */     // GIR_Coverage, 3698,
     /*  482054 */     GIR_EraseRootFromParent_Done,
     /*  482055 */   // Label 8225: @482055
     /*  482055 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(482130), // Rule ID 3699 //
     /*  482060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  482071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  482074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  482077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  482080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  482109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482128 */     GIR_RootConstrainSelectedInstOperands,
     /*  482129 */     // GIR_Coverage, 3699,
     /*  482129 */     GIR_EraseRootFromParent_Done,
     /*  482130 */   // Label 8226: @482130
     /*  482130 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(482205), // Rule ID 3702 //
     /*  482135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  482138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  482146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  482149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  482155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  482184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482203 */     GIR_RootConstrainSelectedInstOperands,
     /*  482204 */     // GIR_Coverage, 3702,
     /*  482204 */     GIR_EraseRootFromParent_Done,
     /*  482205 */   // Label 8227: @482205
     /*  482205 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(482280), // Rule ID 3703 //
     /*  482210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  482221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  482224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  482230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  482259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482278 */     GIR_RootConstrainSelectedInstOperands,
     /*  482279 */     // GIR_Coverage, 3703,
     /*  482279 */     GIR_EraseRootFromParent_Done,
     /*  482280 */   // Label 8228: @482280
     /*  482280 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(482355), // Rule ID 3706 //
     /*  482285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  482288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  482296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  482299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  482305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  482334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482353 */     GIR_RootConstrainSelectedInstOperands,
     /*  482354 */     // GIR_Coverage, 3706,
     /*  482354 */     GIR_EraseRootFromParent_Done,
     /*  482355 */   // Label 8229: @482355
     /*  482355 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(482430), // Rule ID 3707 //
     /*  482360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  482371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  482374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  482380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  482409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482428 */     GIR_RootConstrainSelectedInstOperands,
     /*  482429 */     // GIR_Coverage, 3707,
     /*  482429 */     GIR_EraseRootFromParent_Done,
     /*  482430 */   // Label 8230: @482430
     /*  482430 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(482505), // Rule ID 3710 //
     /*  482435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  482438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  482446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  482449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  482452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  482455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  482484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482503 */     GIR_RootConstrainSelectedInstOperands,
     /*  482504 */     // GIR_Coverage, 3710,
     /*  482504 */     GIR_EraseRootFromParent_Done,
     /*  482505 */   // Label 8231: @482505
     /*  482505 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(482580), // Rule ID 3711 //
     /*  482510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  482521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  482524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  482527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  482530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  482559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482578 */     GIR_RootConstrainSelectedInstOperands,
     /*  482579 */     // GIR_Coverage, 3711,
     /*  482579 */     GIR_EraseRootFromParent_Done,
     /*  482580 */   // Label 8232: @482580
     /*  482580 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(482655), // Rule ID 3714 //
     /*  482585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  482588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  482596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  482599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  482602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  482605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482631 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  482634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482653 */     GIR_RootConstrainSelectedInstOperands,
     /*  482654 */     // GIR_Coverage, 3714,
     /*  482654 */     GIR_EraseRootFromParent_Done,
     /*  482655 */   // Label 8233: @482655
     /*  482655 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(482730), // Rule ID 3715 //
     /*  482660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  482671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  482674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  482677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  482680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  482709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482728 */     GIR_RootConstrainSelectedInstOperands,
     /*  482729 */     // GIR_Coverage, 3715,
     /*  482729 */     GIR_EraseRootFromParent_Done,
     /*  482730 */   // Label 8234: @482730
     /*  482730 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(482805), // Rule ID 3718 //
     /*  482735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  482738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  482755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  482784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482803 */     GIR_RootConstrainSelectedInstOperands,
     /*  482804 */     // GIR_Coverage, 3718,
     /*  482804 */     GIR_EraseRootFromParent_Done,
     /*  482805 */   // Label 8235: @482805
     /*  482805 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(482880), // Rule ID 3719 //
     /*  482810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  482813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  482830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  482859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482878 */     GIR_RootConstrainSelectedInstOperands,
     /*  482879 */     // GIR_Coverage, 3719,
     /*  482879 */     GIR_EraseRootFromParent_Done,
     /*  482880 */   // Label 8236: @482880
     /*  482880 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(482955), // Rule ID 3722 //
     /*  482885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  482888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  482905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  482934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  482942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482953 */     GIR_RootConstrainSelectedInstOperands,
     /*  482954 */     // GIR_Coverage, 3722,
     /*  482954 */     GIR_EraseRootFromParent_Done,
     /*  482955 */   // Label 8237: @482955
     /*  482955 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(483030), // Rule ID 3723 //
     /*  482960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  482963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  482968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  482980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  483009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483028 */     GIR_RootConstrainSelectedInstOperands,
     /*  483029 */     // GIR_Coverage, 3723,
     /*  483029 */     GIR_EraseRootFromParent_Done,
     /*  483030 */   // Label 8238: @483030
     /*  483030 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(483105), // Rule ID 3726 //
     /*  483035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  483038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  483046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  483049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  483055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  483084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483103 */     GIR_RootConstrainSelectedInstOperands,
     /*  483104 */     // GIR_Coverage, 3726,
     /*  483104 */     GIR_EraseRootFromParent_Done,
     /*  483105 */   // Label 8239: @483105
     /*  483105 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(483180), // Rule ID 3727 //
     /*  483110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  483113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  483121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  483124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  483130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  483159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483178 */     GIR_RootConstrainSelectedInstOperands,
     /*  483179 */     // GIR_Coverage, 3727,
     /*  483179 */     GIR_EraseRootFromParent_Done,
     /*  483180 */   // Label 8240: @483180
     /*  483180 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(483255), // Rule ID 3730 //
     /*  483185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  483188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  483196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  483199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  483202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  483205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  483234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483253 */     GIR_RootConstrainSelectedInstOperands,
     /*  483254 */     // GIR_Coverage, 3730,
     /*  483254 */     GIR_EraseRootFromParent_Done,
     /*  483255 */   // Label 8241: @483255
     /*  483255 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(483330), // Rule ID 3731 //
     /*  483260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  483263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  483271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  483274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  483277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  483280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  483309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483328 */     GIR_RootConstrainSelectedInstOperands,
     /*  483329 */     // GIR_Coverage, 3731,
     /*  483329 */     GIR_EraseRootFromParent_Done,
     /*  483330 */   // Label 8242: @483330
     /*  483330 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(483405), // Rule ID 3734 //
     /*  483335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  483338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  483346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  483349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  483352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  483355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483381 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  483384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483403 */     GIR_RootConstrainSelectedInstOperands,
     /*  483404 */     // GIR_Coverage, 3734,
     /*  483404 */     GIR_EraseRootFromParent_Done,
     /*  483405 */   // Label 8243: @483405
     /*  483405 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(483480), // Rule ID 3735 //
     /*  483410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  483413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  483421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  483424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  483427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  483430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  483459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483478 */     GIR_RootConstrainSelectedInstOperands,
     /*  483479 */     // GIR_Coverage, 3735,
     /*  483479 */     GIR_EraseRootFromParent_Done,
     /*  483480 */   // Label 8244: @483480
     /*  483480 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(483555), // Rule ID 3738 //
     /*  483485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  483488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483531 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  483534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483553 */     GIR_RootConstrainSelectedInstOperands,
     /*  483554 */     // GIR_Coverage, 3738,
     /*  483554 */     GIR_EraseRootFromParent_Done,
     /*  483555 */   // Label 8245: @483555
     /*  483555 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(483630), // Rule ID 3739 //
     /*  483560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  483563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  483609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483628 */     GIR_RootConstrainSelectedInstOperands,
     /*  483629 */     // GIR_Coverage, 3739,
     /*  483629 */     GIR_EraseRootFromParent_Done,
     /*  483630 */   // Label 8246: @483630
     /*  483630 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(483705), // Rule ID 3742 //
     /*  483635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  483638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483681 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  483684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483703 */     GIR_RootConstrainSelectedInstOperands,
     /*  483704 */     // GIR_Coverage, 3742,
     /*  483704 */     GIR_EraseRootFromParent_Done,
     /*  483705 */   // Label 8247: @483705
     /*  483705 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(483780), // Rule ID 3743 //
     /*  483710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  483713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  483759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483778 */     GIR_RootConstrainSelectedInstOperands,
     /*  483779 */     // GIR_Coverage, 3743,
     /*  483779 */     GIR_EraseRootFromParent_Done,
     /*  483780 */   // Label 8248: @483780
     /*  483780 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(483855), // Rule ID 3746 //
     /*  483785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  483788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483831 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  483834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483853 */     GIR_RootConstrainSelectedInstOperands,
     /*  483854 */     // GIR_Coverage, 3746,
     /*  483854 */     GIR_EraseRootFromParent_Done,
     /*  483855 */   // Label 8249: @483855
     /*  483855 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(483930), // Rule ID 3747 //
     /*  483860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  483863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  483909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483928 */     GIR_RootConstrainSelectedInstOperands,
     /*  483929 */     // GIR_Coverage, 3747,
     /*  483929 */     GIR_EraseRootFromParent_Done,
     /*  483930 */   // Label 8250: @483930
     /*  483930 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(484005), // Rule ID 3750 //
     /*  483935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  483938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  483943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  483946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  483949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  483974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  483984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  483992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484003 */     GIR_RootConstrainSelectedInstOperands,
     /*  484004 */     // GIR_Coverage, 3750,
     /*  484004 */     GIR_EraseRootFromParent_Done,
     /*  484005 */   // Label 8251: @484005
     /*  484005 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(484080), // Rule ID 3751 //
     /*  484010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  484027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  484059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484078 */     GIR_RootConstrainSelectedInstOperands,
     /*  484079 */     // GIR_Coverage, 3751,
     /*  484079 */     GIR_EraseRootFromParent_Done,
     /*  484080 */   // Label 8252: @484080
     /*  484080 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(484155), // Rule ID 3754 //
     /*  484085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484131 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  484134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484153 */     GIR_RootConstrainSelectedInstOperands,
     /*  484154 */     // GIR_Coverage, 3754,
     /*  484154 */     GIR_EraseRootFromParent_Done,
     /*  484155 */   // Label 8253: @484155
     /*  484155 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(484230), // Rule ID 3755 //
     /*  484160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  484209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484228 */     GIR_RootConstrainSelectedInstOperands,
     /*  484229 */     // GIR_Coverage, 3755,
     /*  484229 */     GIR_EraseRootFromParent_Done,
     /*  484230 */   // Label 8254: @484230
     /*  484230 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(484305), // Rule ID 3758 //
     /*  484235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  484284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484303 */     GIR_RootConstrainSelectedInstOperands,
     /*  484304 */     // GIR_Coverage, 3758,
     /*  484304 */     GIR_EraseRootFromParent_Done,
     /*  484305 */   // Label 8255: @484305
     /*  484305 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(484380), // Rule ID 3759 //
     /*  484310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  484359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484378 */     GIR_RootConstrainSelectedInstOperands,
     /*  484379 */     // GIR_Coverage, 3759,
     /*  484379 */     GIR_EraseRootFromParent_Done,
     /*  484380 */   // Label 8256: @484380
     /*  484380 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(484455), // Rule ID 3762 //
     /*  484385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  484434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484453 */     GIR_RootConstrainSelectedInstOperands,
     /*  484454 */     // GIR_Coverage, 3762,
     /*  484454 */     GIR_EraseRootFromParent_Done,
     /*  484455 */   // Label 8257: @484455
     /*  484455 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(484530), // Rule ID 3763 //
     /*  484460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  484509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484528 */     GIR_RootConstrainSelectedInstOperands,
     /*  484529 */     // GIR_Coverage, 3763,
     /*  484529 */     GIR_EraseRootFromParent_Done,
     /*  484530 */   // Label 8258: @484530
     /*  484530 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(484605), // Rule ID 3766 //
     /*  484535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  484584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484603 */     GIR_RootConstrainSelectedInstOperands,
     /*  484604 */     // GIR_Coverage, 3766,
     /*  484604 */     GIR_EraseRootFromParent_Done,
     /*  484605 */   // Label 8259: @484605
     /*  484605 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(484680), // Rule ID 3767 //
     /*  484610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  484659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484678 */     GIR_RootConstrainSelectedInstOperands,
     /*  484679 */     // GIR_Coverage, 3767,
     /*  484679 */     GIR_EraseRootFromParent_Done,
     /*  484680 */   // Label 8260: @484680
     /*  484680 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(484755), // Rule ID 3770 //
     /*  484685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  484696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  484699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  484734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484753 */     GIR_RootConstrainSelectedInstOperands,
     /*  484754 */     // GIR_Coverage, 3770,
     /*  484754 */     GIR_EraseRootFromParent_Done,
     /*  484755 */   // Label 8261: @484755
     /*  484755 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(484830), // Rule ID 3771 //
     /*  484760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  484771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  484774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  484809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484828 */     GIR_RootConstrainSelectedInstOperands,
     /*  484829 */     // GIR_Coverage, 3771,
     /*  484829 */     GIR_EraseRootFromParent_Done,
     /*  484830 */   // Label 8262: @484830
     /*  484830 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(484905), // Rule ID 3774 //
     /*  484835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  484846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  484849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  484884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484903 */     GIR_RootConstrainSelectedInstOperands,
     /*  484904 */     // GIR_Coverage, 3774,
     /*  484904 */     GIR_EraseRootFromParent_Done,
     /*  484905 */   // Label 8263: @484905
     /*  484905 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(484980), // Rule ID 3775 //
     /*  484910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  484913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  484921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  484924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  484949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  484959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  484967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484978 */     GIR_RootConstrainSelectedInstOperands,
     /*  484979 */     // GIR_Coverage, 3775,
     /*  484979 */     GIR_EraseRootFromParent_Done,
     /*  484980 */   // Label 8264: @484980
     /*  484980 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(485055), // Rule ID 3778 //
     /*  484985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  484988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  484993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  484996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  484999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485031 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  485034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485053 */     GIR_RootConstrainSelectedInstOperands,
     /*  485054 */     // GIR_Coverage, 3778,
     /*  485054 */     GIR_EraseRootFromParent_Done,
     /*  485055 */   // Label 8265: @485055
     /*  485055 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(485130), // Rule ID 3779 //
     /*  485060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  485063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  485109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485128 */     GIR_RootConstrainSelectedInstOperands,
     /*  485129 */     // GIR_Coverage, 3779,
     /*  485129 */     GIR_EraseRootFromParent_Done,
     /*  485130 */   // Label 8266: @485130
     /*  485130 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(485205), // Rule ID 3782 //
     /*  485135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  485138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485181 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  485184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485203 */     GIR_RootConstrainSelectedInstOperands,
     /*  485204 */     // GIR_Coverage, 3782,
     /*  485204 */     GIR_EraseRootFromParent_Done,
     /*  485205 */   // Label 8267: @485205
     /*  485205 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(485280), // Rule ID 3783 //
     /*  485210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  485213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  485259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485278 */     GIR_RootConstrainSelectedInstOperands,
     /*  485279 */     // GIR_Coverage, 3783,
     /*  485279 */     GIR_EraseRootFromParent_Done,
     /*  485280 */   // Label 8268: @485280
     /*  485280 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(485355), // Rule ID 3786 //
     /*  485285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  485288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485331 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  485334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485353 */     GIR_RootConstrainSelectedInstOperands,
     /*  485354 */     // GIR_Coverage, 3786,
     /*  485354 */     GIR_EraseRootFromParent_Done,
     /*  485355 */   // Label 8269: @485355
     /*  485355 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(485430), // Rule ID 3787 //
     /*  485360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  485363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  485409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485428 */     GIR_RootConstrainSelectedInstOperands,
     /*  485429 */     // GIR_Coverage, 3787,
     /*  485429 */     GIR_EraseRootFromParent_Done,
     /*  485430 */   // Label 8270: @485430
     /*  485430 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(485505), // Rule ID 3790 //
     /*  485435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  485438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485481 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  485484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485503 */     GIR_RootConstrainSelectedInstOperands,
     /*  485504 */     // GIR_Coverage, 3790,
     /*  485504 */     GIR_EraseRootFromParent_Done,
     /*  485505 */   // Label 8271: @485505
     /*  485505 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(485580), // Rule ID 3791 //
     /*  485510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  485513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  485559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485578 */     GIR_RootConstrainSelectedInstOperands,
     /*  485579 */     // GIR_Coverage, 3791,
     /*  485579 */     GIR_EraseRootFromParent_Done,
     /*  485580 */   // Label 8272: @485580
     /*  485580 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(485655), // Rule ID 3794 //
     /*  485585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  485588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  485596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  485599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485631 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  485634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485653 */     GIR_RootConstrainSelectedInstOperands,
     /*  485654 */     // GIR_Coverage, 3794,
     /*  485654 */     GIR_EraseRootFromParent_Done,
     /*  485655 */   // Label 8273: @485655
     /*  485655 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(485730), // Rule ID 3795 //
     /*  485660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  485663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  485668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  485671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  485674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  485699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  485709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485728 */     GIR_RootConstrainSelectedInstOperands,
     /*  485729 */     // GIR_Coverage, 3795,
     /*  485729 */     GIR_EraseRootFromParent_Done,
     /*  485730 */   // Label 8274: @485730
     /*  485730 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(485805), // Rule ID 3798 //
     /*  485735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  485738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  485743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  485746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  485749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  485752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  485755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  485781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  485784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485803 */     GIR_RootConstrainSelectedInstOperands,
     /*  485804 */     // GIR_Coverage, 3798,
     /*  485804 */     GIR_EraseRootFromParent_Done,
     /*  485805 */   // Label 8275: @485805
     /*  485805 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(485880), // Rule ID 3799 //
     /*  485810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  485813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  485818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  485821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  485824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  485827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  485830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  485856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  485859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485878 */     GIR_RootConstrainSelectedInstOperands,
     /*  485879 */     // GIR_Coverage, 3799,
     /*  485879 */     GIR_EraseRootFromParent_Done,
     /*  485880 */   // Label 8276: @485880
     /*  485880 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(485955), // Rule ID 3802 //
     /*  485885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  485888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  485893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  485896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  485899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  485902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  485905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485931 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  485931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  485934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485953 */     GIR_RootConstrainSelectedInstOperands,
     /*  485954 */     // GIR_Coverage, 3802,
     /*  485954 */     GIR_EraseRootFromParent_Done,
     /*  485955 */   // Label 8277: @485955
     /*  485955 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(486030), // Rule ID 3803 //
     /*  485960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  485963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  485968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  485971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  485974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  485977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  485980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  486009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486028 */     GIR_RootConstrainSelectedInstOperands,
     /*  486029 */     // GIR_Coverage, 3803,
     /*  486029 */     GIR_EraseRootFromParent_Done,
     /*  486030 */   // Label 8278: @486030
     /*  486030 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(486105), // Rule ID 3806 //
     /*  486035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  486084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486103 */     GIR_RootConstrainSelectedInstOperands,
     /*  486104 */     // GIR_Coverage, 3806,
     /*  486104 */     GIR_EraseRootFromParent_Done,
     /*  486105 */   // Label 8279: @486105
     /*  486105 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(486180), // Rule ID 3807 //
     /*  486110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  486159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486178 */     GIR_RootConstrainSelectedInstOperands,
     /*  486179 */     // GIR_Coverage, 3807,
     /*  486179 */     GIR_EraseRootFromParent_Done,
     /*  486180 */   // Label 8280: @486180
     /*  486180 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(486255), // Rule ID 3810 //
     /*  486185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  486202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  486234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486253 */     GIR_RootConstrainSelectedInstOperands,
     /*  486254 */     // GIR_Coverage, 3810,
     /*  486254 */     GIR_EraseRootFromParent_Done,
     /*  486255 */   // Label 8281: @486255
     /*  486255 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(486330), // Rule ID 3811 //
     /*  486260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  486277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  486309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486328 */     GIR_RootConstrainSelectedInstOperands,
     /*  486329 */     // GIR_Coverage, 3811,
     /*  486329 */     GIR_EraseRootFromParent_Done,
     /*  486330 */   // Label 8282: @486330
     /*  486330 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(486405), // Rule ID 3814 //
     /*  486335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  486352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486381 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  486384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486403 */     GIR_RootConstrainSelectedInstOperands,
     /*  486404 */     // GIR_Coverage, 3814,
     /*  486404 */     GIR_EraseRootFromParent_Done,
     /*  486405 */   // Label 8283: @486405
     /*  486405 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(486480), // Rule ID 3815 //
     /*  486410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  486427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486456 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  486459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486478 */     GIR_RootConstrainSelectedInstOperands,
     /*  486479 */     // GIR_Coverage, 3815,
     /*  486479 */     GIR_EraseRootFromParent_Done,
     /*  486480 */   // Label 8284: @486480
     /*  486480 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(486555), // Rule ID 3818 //
     /*  486485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  486502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486531 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  486534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486553 */     GIR_RootConstrainSelectedInstOperands,
     /*  486554 */     // GIR_Coverage, 3818,
     /*  486554 */     GIR_EraseRootFromParent_Done,
     /*  486555 */   // Label 8285: @486555
     /*  486555 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(486630), // Rule ID 3819 //
     /*  486560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  486577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  486609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486628 */     GIR_RootConstrainSelectedInstOperands,
     /*  486629 */     // GIR_Coverage, 3819,
     /*  486629 */     GIR_EraseRootFromParent_Done,
     /*  486630 */   // Label 8286: @486630
     /*  486630 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(486705), // Rule ID 3822 //
     /*  486635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  486646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  486649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  486655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  486684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486703 */     GIR_RootConstrainSelectedInstOperands,
     /*  486704 */     // GIR_Coverage, 3822,
     /*  486704 */     GIR_EraseRootFromParent_Done,
     /*  486705 */   // Label 8287: @486705
     /*  486705 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(486780), // Rule ID 3823 //
     /*  486710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  486721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  486724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  486730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  486756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  486759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486778 */     GIR_RootConstrainSelectedInstOperands,
     /*  486779 */     // GIR_Coverage, 3823,
     /*  486779 */     GIR_EraseRootFromParent_Done,
     /*  486780 */   // Label 8288: @486780
     /*  486780 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(486855), // Rule ID 3826 //
     /*  486785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  486796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  486799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  486805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  486834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486853 */     GIR_RootConstrainSelectedInstOperands,
     /*  486854 */     // GIR_Coverage, 3826,
     /*  486854 */     GIR_EraseRootFromParent_Done,
     /*  486855 */   // Label 8289: @486855
     /*  486855 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(486930), // Rule ID 3827 //
     /*  486860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  486871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  486874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  486880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  486906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  486909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486928 */     GIR_RootConstrainSelectedInstOperands,
     /*  486929 */     // GIR_Coverage, 3827,
     /*  486929 */     GIR_EraseRootFromParent_Done,
     /*  486930 */   // Label 8290: @486930
     /*  486930 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(487005), // Rule ID 3830 //
     /*  486935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  486943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  486946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  486949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  486955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  486984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487003 */     GIR_RootConstrainSelectedInstOperands,
     /*  487004 */     // GIR_Coverage, 3830,
     /*  487004 */     GIR_EraseRootFromParent_Done,
     /*  487005 */   // Label 8291: @487005
     /*  487005 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(487080), // Rule ID 3831 //
     /*  487010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  487059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487078 */     GIR_RootConstrainSelectedInstOperands,
     /*  487079 */     // GIR_Coverage, 3831,
     /*  487079 */     GIR_EraseRootFromParent_Done,
     /*  487080 */   // Label 8292: @487080
     /*  487080 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(487155), // Rule ID 3834 //
     /*  487085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  487131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  487134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487153 */     GIR_RootConstrainSelectedInstOperands,
     /*  487154 */     // GIR_Coverage, 3834,
     /*  487154 */     GIR_EraseRootFromParent_Done,
     /*  487155 */   // Label 8293: @487155
     /*  487155 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(487230), // Rule ID 3835 //
     /*  487160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  487209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487228 */     GIR_RootConstrainSelectedInstOperands,
     /*  487229 */     // GIR_Coverage, 3835,
     /*  487229 */     GIR_EraseRootFromParent_Done,
     /*  487230 */   // Label 8294: @487230
     /*  487230 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(487305), // Rule ID 3838 //
     /*  487235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487281 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  487281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  487284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487303 */     GIR_RootConstrainSelectedInstOperands,
     /*  487304 */     // GIR_Coverage, 3838,
     /*  487304 */     GIR_EraseRootFromParent_Done,
     /*  487305 */   // Label 8295: @487305
     /*  487305 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(487380), // Rule ID 3839 //
     /*  487310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487356 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  487359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487378 */     GIR_RootConstrainSelectedInstOperands,
     /*  487379 */     // GIR_Coverage, 3839,
     /*  487379 */     GIR_EraseRootFromParent_Done,
     /*  487380 */   // Label 8296: @487380
     /*  487380 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(487455), // Rule ID 3842 //
     /*  487385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487431 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  487434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487453 */     GIR_RootConstrainSelectedInstOperands,
     /*  487454 */     // GIR_Coverage, 3842,
     /*  487454 */     GIR_EraseRootFromParent_Done,
     /*  487455 */   // Label 8297: @487455
     /*  487455 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(487530), // Rule ID 3843 //
     /*  487460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  487509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487528 */     GIR_RootConstrainSelectedInstOperands,
     /*  487529 */     // GIR_Coverage, 3843,
     /*  487529 */     GIR_EraseRootFromParent_Done,
     /*  487530 */   // Label 8298: @487530
     /*  487530 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(487605), // Rule ID 3846 //
     /*  487535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  487546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  487549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  487555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487581 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  487584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487603 */     GIR_RootConstrainSelectedInstOperands,
     /*  487604 */     // GIR_Coverage, 3846,
     /*  487604 */     GIR_EraseRootFromParent_Done,
     /*  487605 */   // Label 8299: @487605
     /*  487605 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(487680), // Rule ID 3847 //
     /*  487610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  487621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  487624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  487630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  487659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487678 */     GIR_RootConstrainSelectedInstOperands,
     /*  487679 */     // GIR_Coverage, 3847,
     /*  487679 */     GIR_EraseRootFromParent_Done,
     /*  487680 */   // Label 8300: @487680
     /*  487680 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(487755), // Rule ID 3850 //
     /*  487685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  487696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  487699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  487705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487731 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  487734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487753 */     GIR_RootConstrainSelectedInstOperands,
     /*  487754 */     // GIR_Coverage, 3850,
     /*  487754 */     GIR_EraseRootFromParent_Done,
     /*  487755 */   // Label 8301: @487755
     /*  487755 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(487830), // Rule ID 3851 //
     /*  487760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  487771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  487774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  487780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  487809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487828 */     GIR_RootConstrainSelectedInstOperands,
     /*  487829 */     // GIR_Coverage, 3851,
     /*  487829 */     GIR_EraseRootFromParent_Done,
     /*  487830 */   // Label 8302: @487830
     /*  487830 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(487905), // Rule ID 3854 //
     /*  487835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  487846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  487849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  487855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  487884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487903 */     GIR_RootConstrainSelectedInstOperands,
     /*  487904 */     // GIR_Coverage, 3854,
     /*  487904 */     GIR_EraseRootFromParent_Done,
     /*  487905 */   // Label 8303: @487905
     /*  487905 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(487980), // Rule ID 3855 //
     /*  487910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  487921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  487924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  487930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  487959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487978 */     GIR_RootConstrainSelectedInstOperands,
     /*  487979 */     // GIR_Coverage, 3855,
     /*  487979 */     GIR_EraseRootFromParent_Done,
     /*  487980 */   // Label 8304: @487980
     /*  487980 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(488055), // Rule ID 3858 //
     /*  487985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  487993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  487996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  487999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  488002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488031 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  488034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488053 */     GIR_RootConstrainSelectedInstOperands,
     /*  488054 */     // GIR_Coverage, 3858,
     /*  488054 */     GIR_EraseRootFromParent_Done,
     /*  488055 */   // Label 8305: @488055
     /*  488055 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(488130), // Rule ID 3859 //
     /*  488060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  488077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  488109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488128 */     GIR_RootConstrainSelectedInstOperands,
     /*  488129 */     // GIR_Coverage, 3859,
     /*  488129 */     GIR_EraseRootFromParent_Done,
     /*  488130 */   // Label 8306: @488130
     /*  488130 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(488205), // Rule ID 3862 //
     /*  488135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  488152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488181 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  488184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488203 */     GIR_RootConstrainSelectedInstOperands,
     /*  488204 */     // GIR_Coverage, 3862,
     /*  488204 */     GIR_EraseRootFromParent_Done,
     /*  488205 */   // Label 8307: @488205
     /*  488205 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(488280), // Rule ID 3863 //
     /*  488210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  488227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  488259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488278 */     GIR_RootConstrainSelectedInstOperands,
     /*  488279 */     // GIR_Coverage, 3863,
     /*  488279 */     GIR_EraseRootFromParent_Done,
     /*  488280 */   // Label 8308: @488280
     /*  488280 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(488355), // Rule ID 3866 //
     /*  488285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  488302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488331 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  488334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488353 */     GIR_RootConstrainSelectedInstOperands,
     /*  488354 */     // GIR_Coverage, 3866,
     /*  488354 */     GIR_EraseRootFromParent_Done,
     /*  488355 */   // Label 8309: @488355
     /*  488355 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(488430), // Rule ID 3867 //
     /*  488360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  488377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  488409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488428 */     GIR_RootConstrainSelectedInstOperands,
     /*  488429 */     // GIR_Coverage, 3867,
     /*  488429 */     GIR_EraseRootFromParent_Done,
     /*  488430 */   // Label 8310: @488430
     /*  488430 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(488505), // Rule ID 3870 //
     /*  488435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  488452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  488484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488503 */     GIR_RootConstrainSelectedInstOperands,
     /*  488504 */     // GIR_Coverage, 3870,
     /*  488504 */     GIR_EraseRootFromParent_Done,
     /*  488505 */   // Label 8311: @488505
     /*  488505 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(488580), // Rule ID 3871 //
     /*  488510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  488527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  488559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488578 */     GIR_RootConstrainSelectedInstOperands,
     /*  488579 */     // GIR_Coverage, 3871,
     /*  488579 */     GIR_EraseRootFromParent_Done,
     /*  488580 */   // Label 8312: @488580
     /*  488580 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(488655), // Rule ID 3874 //
     /*  488585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  488602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  488634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488653 */     GIR_RootConstrainSelectedInstOperands,
     /*  488654 */     // GIR_Coverage, 3874,
     /*  488654 */     GIR_EraseRootFromParent_Done,
     /*  488655 */   // Label 8313: @488655
     /*  488655 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(488730), // Rule ID 3875 //
     /*  488660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  488677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488706 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  488709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488728 */     GIR_RootConstrainSelectedInstOperands,
     /*  488729 */     // GIR_Coverage, 3875,
     /*  488729 */     GIR_EraseRootFromParent_Done,
     /*  488730 */   // Label 8314: @488730
     /*  488730 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(488805), // Rule ID 3878 //
     /*  488735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488781 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  488784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488803 */     GIR_RootConstrainSelectedInstOperands,
     /*  488804 */     // GIR_Coverage, 3878,
     /*  488804 */     GIR_EraseRootFromParent_Done,
     /*  488805 */   // Label 8315: @488805
     /*  488805 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(488880), // Rule ID 3879 //
     /*  488810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  488859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488878 */     GIR_RootConstrainSelectedInstOperands,
     /*  488879 */     // GIR_Coverage, 3879,
     /*  488879 */     GIR_EraseRootFromParent_Done,
     /*  488880 */   // Label 8316: @488880
     /*  488880 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(488955), // Rule ID 3882 //
     /*  488885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  488896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  488899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488931 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  488934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488953 */     GIR_RootConstrainSelectedInstOperands,
     /*  488954 */     // GIR_Coverage, 3882,
     /*  488954 */     GIR_EraseRootFromParent_Done,
     /*  488955 */   // Label 8317: @488955
     /*  488955 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(489030), // Rule ID 3883 //
     /*  488960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  488968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  488971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  488974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  488999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  489006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  489009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489028 */     GIR_RootConstrainSelectedInstOperands,
     /*  489029 */     // GIR_Coverage, 3883,
     /*  489029 */     GIR_EraseRootFromParent_Done,
     /*  489030 */   // Label 8318: @489030
     /*  489030 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(489105), // Rule ID 3886 //
     /*  489035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  489081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  489084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489103 */     GIR_RootConstrainSelectedInstOperands,
     /*  489104 */     // GIR_Coverage, 3886,
     /*  489104 */     GIR_EraseRootFromParent_Done,
     /*  489105 */   // Label 8319: @489105
     /*  489105 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(489180), // Rule ID 3887 //
     /*  489110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  489156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  489159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489178 */     GIR_RootConstrainSelectedInstOperands,
     /*  489179 */     // GIR_Coverage, 3887,
     /*  489179 */     GIR_EraseRootFromParent_Done,
     /*  489180 */   // Label 8320: @489180
     /*  489180 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(489255), // Rule ID 3890 //
     /*  489185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  489231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  489234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489253 */     GIR_RootConstrainSelectedInstOperands,
     /*  489254 */     // GIR_Coverage, 3890,
     /*  489254 */     GIR_EraseRootFromParent_Done,
     /*  489255 */   // Label 8321: @489255
     /*  489255 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(489330), // Rule ID 3891 //
     /*  489260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  489306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  489309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489328 */     GIR_RootConstrainSelectedInstOperands,
     /*  489329 */     // GIR_Coverage, 3891,
     /*  489329 */     GIR_EraseRootFromParent_Done,
     /*  489330 */   // Label 8322: @489330
     /*  489330 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(489405), // Rule ID 3894 //
     /*  489335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489381 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  489381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  489384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489403 */     GIR_RootConstrainSelectedInstOperands,
     /*  489404 */     // GIR_Coverage, 3894,
     /*  489404 */     GIR_EraseRootFromParent_Done,
     /*  489405 */   // Label 8323: @489405
     /*  489405 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(489480), // Rule ID 3895 //
     /*  489410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  489456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  489459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489478 */     GIR_RootConstrainSelectedInstOperands,
     /*  489479 */     // GIR_Coverage, 3895,
     /*  489479 */     GIR_EraseRootFromParent_Done,
     /*  489480 */   // Label 8324: @489480
     /*  489480 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(489555), // Rule ID 3898 //
     /*  489485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489531 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  489531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  489534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489553 */     GIR_RootConstrainSelectedInstOperands,
     /*  489554 */     // GIR_Coverage, 3898,
     /*  489554 */     GIR_EraseRootFromParent_Done,
     /*  489555 */   // Label 8325: @489555
     /*  489555 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(489630), // Rule ID 3899 //
     /*  489560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  489606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  489609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489628 */     GIR_RootConstrainSelectedInstOperands,
     /*  489629 */     // GIR_Coverage, 3899,
     /*  489629 */     GIR_EraseRootFromParent_Done,
     /*  489630 */   // Label 8326: @489630
     /*  489630 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(489705), // Rule ID 3902 //
     /*  489635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  489638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  489646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  489649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489681 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  489684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489703 */     GIR_RootConstrainSelectedInstOperands,
     /*  489704 */     // GIR_Coverage, 3902,
     /*  489704 */     GIR_EraseRootFromParent_Done,
     /*  489705 */   // Label 8327: @489705
     /*  489705 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(489780), // Rule ID 3903 //
     /*  489710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  489713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  489721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  489724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  489759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489778 */     GIR_RootConstrainSelectedInstOperands,
     /*  489779 */     // GIR_Coverage, 3903,
     /*  489779 */     GIR_EraseRootFromParent_Done,
     /*  489780 */   // Label 8328: @489780
     /*  489780 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(489855), // Rule ID 3906 //
     /*  489785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  489788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489831 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  489834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489853 */     GIR_RootConstrainSelectedInstOperands,
     /*  489854 */     // GIR_Coverage, 3906,
     /*  489854 */     GIR_EraseRootFromParent_Done,
     /*  489855 */   // Label 8329: @489855
     /*  489855 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(489930), // Rule ID 3907 //
     /*  489860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  489863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  489909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489928 */     GIR_RootConstrainSelectedInstOperands,
     /*  489929 */     // GIR_Coverage, 3907,
     /*  489929 */     GIR_EraseRootFromParent_Done,
     /*  489930 */   // Label 8330: @489930
     /*  489930 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(490005), // Rule ID 3910 //
     /*  489935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  489938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  489943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  489946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  489949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  489974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489981 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  489984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490003 */     GIR_RootConstrainSelectedInstOperands,
     /*  490004 */     // GIR_Coverage, 3910,
     /*  490004 */     GIR_EraseRootFromParent_Done,
     /*  490005 */   // Label 8331: @490005
     /*  490005 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(490080), // Rule ID 3911 //
     /*  490010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  490018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  490027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  490030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  490049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  490056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  490059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490078 */     GIR_RootConstrainSelectedInstOperands,
     /*  490079 */     // GIR_Coverage, 3911,
     /*  490079 */     GIR_EraseRootFromParent_Done,
     /*  490080 */   // Label 8332: @490080
     /*  490080 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(490155), // Rule ID 3914 //
     /*  490085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  490093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  490105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  490124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  490131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  490134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490153 */     GIR_RootConstrainSelectedInstOperands,
     /*  490154 */     // GIR_Coverage, 3914,
     /*  490154 */     GIR_EraseRootFromParent_Done,
     /*  490155 */   // Label 8333: @490155
     /*  490155 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(490230), // Rule ID 3915 //
     /*  490160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  490168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  490180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  490199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  490206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  490209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490228 */     GIR_RootConstrainSelectedInstOperands,
     /*  490229 */     // GIR_Coverage, 3915,
     /*  490229 */     GIR_EraseRootFromParent_Done,
     /*  490230 */   // Label 8334: @490230
     /*  490230 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(490305), // Rule ID 3920 //
     /*  490235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490281 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  490281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  490284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490303 */     GIR_RootConstrainSelectedInstOperands,
     /*  490304 */     // GIR_Coverage, 3920,
     /*  490304 */     GIR_EraseRootFromParent_Done,
     /*  490305 */   // Label 8335: @490305
     /*  490305 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(490380), // Rule ID 3921 //
     /*  490310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  490356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  490359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490378 */     GIR_RootConstrainSelectedInstOperands,
     /*  490379 */     // GIR_Coverage, 3921,
     /*  490379 */     GIR_EraseRootFromParent_Done,
     /*  490380 */   // Label 8336: @490380
     /*  490380 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(490455), // Rule ID 3930 //
     /*  490385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490431 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  490431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  490434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490453 */     GIR_RootConstrainSelectedInstOperands,
     /*  490454 */     // GIR_Coverage, 3930,
     /*  490454 */     GIR_EraseRootFromParent_Done,
     /*  490455 */   // Label 8337: @490455
     /*  490455 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(490530), // Rule ID 3931 //
     /*  490460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  490506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  490509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490528 */     GIR_RootConstrainSelectedInstOperands,
     /*  490529 */     // GIR_Coverage, 3931,
     /*  490529 */     GIR_EraseRootFromParent_Done,
     /*  490530 */   // Label 8338: @490530
     /*  490530 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(490605), // Rule ID 3940 //
     /*  490535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  490581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  490584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490603 */     GIR_RootConstrainSelectedInstOperands,
     /*  490604 */     // GIR_Coverage, 3940,
     /*  490604 */     GIR_EraseRootFromParent_Done,
     /*  490605 */   // Label 8339: @490605
     /*  490605 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(490680), // Rule ID 3941 //
     /*  490610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  490656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  490659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490678 */     GIR_RootConstrainSelectedInstOperands,
     /*  490679 */     // GIR_Coverage, 3941,
     /*  490679 */     GIR_EraseRootFromParent_Done,
     /*  490680 */   // Label 8340: @490680
     /*  490680 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(490755), // Rule ID 3950 //
     /*  490685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490731 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  490731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  490734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490753 */     GIR_RootConstrainSelectedInstOperands,
     /*  490754 */     // GIR_Coverage, 3950,
     /*  490754 */     GIR_EraseRootFromParent_Done,
     /*  490755 */   // Label 8341: @490755
     /*  490755 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(490830), // Rule ID 3951 //
     /*  490760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  490806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  490809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490828 */     GIR_RootConstrainSelectedInstOperands,
     /*  490829 */     // GIR_Coverage, 3951,
     /*  490829 */     GIR_EraseRootFromParent_Done,
     /*  490830 */   // Label 8342: @490830
     /*  490830 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(490905), // Rule ID 3960 //
     /*  490835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490881 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  490881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  490884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490903 */     GIR_RootConstrainSelectedInstOperands,
     /*  490904 */     // GIR_Coverage, 3960,
     /*  490904 */     GIR_EraseRootFromParent_Done,
     /*  490905 */   // Label 8343: @490905
     /*  490905 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(490980), // Rule ID 3961 //
     /*  490910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  490956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  490959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  490963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490978 */     GIR_RootConstrainSelectedInstOperands,
     /*  490979 */     // GIR_Coverage, 3961,
     /*  490979 */     GIR_EraseRootFromParent_Done,
     /*  490980 */   // Label 8344: @490980
     /*  490980 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(491055), // Rule ID 3970 //
     /*  490985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  490996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  490999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491031 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  491031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  491034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491053 */     GIR_RootConstrainSelectedInstOperands,
     /*  491054 */     // GIR_Coverage, 3970,
     /*  491054 */     GIR_EraseRootFromParent_Done,
     /*  491055 */   // Label 8345: @491055
     /*  491055 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(491130), // Rule ID 3971 //
     /*  491060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  491106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  491109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491128 */     GIR_RootConstrainSelectedInstOperands,
     /*  491129 */     // GIR_Coverage, 3971,
     /*  491129 */     GIR_EraseRootFromParent_Done,
     /*  491130 */   // Label 8346: @491130
     /*  491130 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(491205), // Rule ID 3980 //
     /*  491135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  491181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  491184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491203 */     GIR_RootConstrainSelectedInstOperands,
     /*  491204 */     // GIR_Coverage, 3980,
     /*  491204 */     GIR_EraseRootFromParent_Done,
     /*  491205 */   // Label 8347: @491205
     /*  491205 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(491280), // Rule ID 3981 //
     /*  491210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  491256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  491259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491278 */     GIR_RootConstrainSelectedInstOperands,
     /*  491279 */     // GIR_Coverage, 3981,
     /*  491279 */     GIR_EraseRootFromParent_Done,
     /*  491280 */   // Label 8348: @491280
     /*  491280 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(491355), // Rule ID 3990 //
     /*  491285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  491331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  491334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491353 */     GIR_RootConstrainSelectedInstOperands,
     /*  491354 */     // GIR_Coverage, 3990,
     /*  491354 */     GIR_EraseRootFromParent_Done,
     /*  491355 */   // Label 8349: @491355
     /*  491355 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(491430), // Rule ID 3991 //
     /*  491360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  491406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  491409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491428 */     GIR_RootConstrainSelectedInstOperands,
     /*  491429 */     // GIR_Coverage, 3991,
     /*  491429 */     GIR_EraseRootFromParent_Done,
     /*  491430 */   // Label 8350: @491430
     /*  491430 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(491505), // Rule ID 4000 //
     /*  491435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  491481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  491484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491503 */     GIR_RootConstrainSelectedInstOperands,
     /*  491504 */     // GIR_Coverage, 4000,
     /*  491504 */     GIR_EraseRootFromParent_Done,
     /*  491505 */   // Label 8351: @491505
     /*  491505 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(491580), // Rule ID 4001 //
     /*  491510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  491556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  491559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491578 */     GIR_RootConstrainSelectedInstOperands,
     /*  491579 */     // GIR_Coverage, 4001,
     /*  491579 */     GIR_EraseRootFromParent_Done,
     /*  491580 */   // Label 8352: @491580
     /*  491580 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(491655), // Rule ID 4010 //
     /*  491585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491631 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  491631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  491634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491653 */     GIR_RootConstrainSelectedInstOperands,
     /*  491654 */     // GIR_Coverage, 4010,
     /*  491654 */     GIR_EraseRootFromParent_Done,
     /*  491655 */   // Label 8353: @491655
     /*  491655 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(491730), // Rule ID 4011 //
     /*  491660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  491706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  491709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491728 */     GIR_RootConstrainSelectedInstOperands,
     /*  491729 */     // GIR_Coverage, 4011,
     /*  491729 */     GIR_EraseRootFromParent_Done,
     /*  491730 */   // Label 8354: @491730
     /*  491730 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(491805), // Rule ID 4020 //
     /*  491735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491781 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  491781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  491784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491803 */     GIR_RootConstrainSelectedInstOperands,
     /*  491804 */     // GIR_Coverage, 4020,
     /*  491804 */     GIR_EraseRootFromParent_Done,
     /*  491805 */   // Label 8355: @491805
     /*  491805 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(491880), // Rule ID 4021 //
     /*  491810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  491856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  491859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491878 */     GIR_RootConstrainSelectedInstOperands,
     /*  491879 */     // GIR_Coverage, 4021,
     /*  491879 */     GIR_EraseRootFromParent_Done,
     /*  491880 */   // Label 8356: @491880
     /*  491880 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(491955), // Rule ID 4030 //
     /*  491885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  491902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  491905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  491931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  491934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  491938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  491953 */     GIR_RootConstrainSelectedInstOperands,
     /*  491954 */     // GIR_Coverage, 4030,
     /*  491954 */     GIR_EraseRootFromParent_Done,
     /*  491955 */   // Label 8357: @491955
     /*  491955 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(492030), // Rule ID 4031 //
     /*  491960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  491977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  491980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  492006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  492009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492028 */     GIR_RootConstrainSelectedInstOperands,
     /*  492029 */     // GIR_Coverage, 4031,
     /*  492029 */     GIR_EraseRootFromParent_Done,
     /*  492030 */   // Label 8358: @492030
     /*  492030 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(492105), // Rule ID 4040 //
     /*  492035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  492081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  492084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492103 */     GIR_RootConstrainSelectedInstOperands,
     /*  492104 */     // GIR_Coverage, 4040,
     /*  492104 */     GIR_EraseRootFromParent_Done,
     /*  492105 */   // Label 8359: @492105
     /*  492105 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(492180), // Rule ID 4041 //
     /*  492110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  492156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  492159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492178 */     GIR_RootConstrainSelectedInstOperands,
     /*  492179 */     // GIR_Coverage, 4041,
     /*  492179 */     GIR_EraseRootFromParent_Done,
     /*  492180 */   // Label 8360: @492180
     /*  492180 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(492255), // Rule ID 4050 //
     /*  492185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  492231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  492234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492253 */     GIR_RootConstrainSelectedInstOperands,
     /*  492254 */     // GIR_Coverage, 4050,
     /*  492254 */     GIR_EraseRootFromParent_Done,
     /*  492255 */   // Label 8361: @492255
     /*  492255 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(492330), // Rule ID 4051 //
     /*  492260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  492306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  492309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492328 */     GIR_RootConstrainSelectedInstOperands,
     /*  492329 */     // GIR_Coverage, 4051,
     /*  492329 */     GIR_EraseRootFromParent_Done,
     /*  492330 */   // Label 8362: @492330
     /*  492330 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(492405), // Rule ID 4058 //
     /*  492335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  492355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492381 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  492381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  492384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492403 */     GIR_RootConstrainSelectedInstOperands,
     /*  492404 */     // GIR_Coverage, 4058,
     /*  492404 */     GIR_EraseRootFromParent_Done,
     /*  492405 */   // Label 8363: @492405
     /*  492405 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(492480), // Rule ID 4059 //
     /*  492410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  492430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  492456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  492459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492478 */     GIR_RootConstrainSelectedInstOperands,
     /*  492479 */     // GIR_Coverage, 4059,
     /*  492479 */     GIR_EraseRootFromParent_Done,
     /*  492480 */   // Label 8364: @492480
     /*  492480 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(492555), // Rule ID 4062 //
     /*  492485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  492505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492531 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  492531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  492534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492553 */     GIR_RootConstrainSelectedInstOperands,
     /*  492554 */     // GIR_Coverage, 4062,
     /*  492554 */     GIR_EraseRootFromParent_Done,
     /*  492555 */   // Label 8365: @492555
     /*  492555 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(492630), // Rule ID 4063 //
     /*  492560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  492580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  492606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  492609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492628 */     GIR_RootConstrainSelectedInstOperands,
     /*  492629 */     // GIR_Coverage, 4063,
     /*  492629 */     GIR_EraseRootFromParent_Done,
     /*  492630 */   // Label 8366: @492630
     /*  492630 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(492705), // Rule ID 4066 //
     /*  492635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  492655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492681 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  492681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  492684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492703 */     GIR_RootConstrainSelectedInstOperands,
     /*  492704 */     // GIR_Coverage, 4066,
     /*  492704 */     GIR_EraseRootFromParent_Done,
     /*  492705 */   // Label 8367: @492705
     /*  492705 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(492780), // Rule ID 4067 //
     /*  492710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  492730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11336:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  492756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  492759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492778 */     GIR_RootConstrainSelectedInstOperands,
     /*  492779 */     // GIR_Coverage, 4067,
     /*  492779 */     GIR_EraseRootFromParent_Done,
     /*  492780 */   // Label 8368: @492780
     /*  492780 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(492855), // Rule ID 4070 //
     /*  492785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  492805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  492831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  492834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492853 */     GIR_RootConstrainSelectedInstOperands,
     /*  492854 */     // GIR_Coverage, 4070,
     /*  492854 */     GIR_EraseRootFromParent_Done,
     /*  492855 */   // Label 8369: @492855
     /*  492855 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(492930), // Rule ID 4071 //
     /*  492860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  492880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  492906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  492909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  492928 */     GIR_RootConstrainSelectedInstOperands,
     /*  492929 */     // GIR_Coverage, 4071,
     /*  492929 */     GIR_EraseRootFromParent_Done,
     /*  492930 */   // Label 8370: @492930
     /*  492930 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(493005), // Rule ID 4074 //
     /*  492935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  492946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  492949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  492952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  492955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  492974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492981 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  492981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  492984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  492988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493003 */     GIR_RootConstrainSelectedInstOperands,
     /*  493004 */     // GIR_Coverage, 4074,
     /*  493004 */     GIR_EraseRootFromParent_Done,
     /*  493005 */   // Label 8371: @493005
     /*  493005 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(493080), // Rule ID 4075 //
     /*  493010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  493056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  493059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493078 */     GIR_RootConstrainSelectedInstOperands,
     /*  493079 */     // GIR_Coverage, 4075,
     /*  493079 */     GIR_EraseRootFromParent_Done,
     /*  493080 */   // Label 8372: @493080
     /*  493080 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(493155), // Rule ID 4078 //
     /*  493085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493131 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  493131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  493134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493153 */     GIR_RootConstrainSelectedInstOperands,
     /*  493154 */     // GIR_Coverage, 4078,
     /*  493154 */     GIR_EraseRootFromParent_Done,
     /*  493155 */   // Label 8373: @493155
     /*  493155 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(493230), // Rule ID 4079 //
     /*  493160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  493206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  493209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493228 */     GIR_RootConstrainSelectedInstOperands,
     /*  493229 */     // GIR_Coverage, 4079,
     /*  493229 */     GIR_EraseRootFromParent_Done,
     /*  493230 */   // Label 8374: @493230
     /*  493230 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(493305), // Rule ID 4082 //
     /*  493235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  493281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  493284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493303 */     GIR_RootConstrainSelectedInstOperands,
     /*  493304 */     // GIR_Coverage, 4082,
     /*  493304 */     GIR_EraseRootFromParent_Done,
     /*  493305 */   // Label 8375: @493305
     /*  493305 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(493380), // Rule ID 4083 //
     /*  493310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  493356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  493359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493378 */     GIR_RootConstrainSelectedInstOperands,
     /*  493379 */     // GIR_Coverage, 4083,
     /*  493379 */     GIR_EraseRootFromParent_Done,
     /*  493380 */   // Label 8376: @493380
     /*  493380 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(493455), // Rule ID 4086 //
     /*  493385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493431 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  493431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  493434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493453 */     GIR_RootConstrainSelectedInstOperands,
     /*  493454 */     // GIR_Coverage, 4086,
     /*  493454 */     GIR_EraseRootFromParent_Done,
     /*  493455 */   // Label 8377: @493455
     /*  493455 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(493530), // Rule ID 4087 //
     /*  493460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  493506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  493509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493528 */     GIR_RootConstrainSelectedInstOperands,
     /*  493529 */     // GIR_Coverage, 4087,
     /*  493529 */     GIR_EraseRootFromParent_Done,
     /*  493530 */   // Label 8378: @493530
     /*  493530 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(493605), // Rule ID 4090 //
     /*  493535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  493581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  493584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493603 */     GIR_RootConstrainSelectedInstOperands,
     /*  493604 */     // GIR_Coverage, 4090,
     /*  493604 */     GIR_EraseRootFromParent_Done,
     /*  493605 */   // Label 8379: @493605
     /*  493605 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(493680), // Rule ID 4091 //
     /*  493610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  493656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  493659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493678 */     GIR_RootConstrainSelectedInstOperands,
     /*  493679 */     // GIR_Coverage, 4091,
     /*  493679 */     GIR_EraseRootFromParent_Done,
     /*  493680 */   // Label 8380: @493680
     /*  493680 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(493755), // Rule ID 4094 //
     /*  493685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  493731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  493734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493753 */     GIR_RootConstrainSelectedInstOperands,
     /*  493754 */     // GIR_Coverage, 4094,
     /*  493754 */     GIR_EraseRootFromParent_Done,
     /*  493755 */   // Label 8381: @493755
     /*  493755 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(493830), // Rule ID 4095 //
     /*  493760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  493806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  493809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493828 */     GIR_RootConstrainSelectedInstOperands,
     /*  493829 */     // GIR_Coverage, 4095,
     /*  493829 */     GIR_EraseRootFromParent_Done,
     /*  493830 */   // Label 8382: @493830
     /*  493830 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(493905), // Rule ID 4098 //
     /*  493835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  493855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  493881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  493884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493903 */     GIR_RootConstrainSelectedInstOperands,
     /*  493904 */     // GIR_Coverage, 4098,
     /*  493904 */     GIR_EraseRootFromParent_Done,
     /*  493905 */   // Label 8383: @493905
     /*  493905 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(493980), // Rule ID 4099 //
     /*  493910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  493930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  493949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  493956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  493959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  493963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  493978 */     GIR_RootConstrainSelectedInstOperands,
     /*  493979 */     // GIR_Coverage, 4099,
     /*  493979 */     GIR_EraseRootFromParent_Done,
     /*  493980 */   // Label 8384: @493980
     /*  493980 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(494055), // Rule ID 4102 //
     /*  493985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  493993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  493996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  493999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  494005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  494031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  494034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494053 */     GIR_RootConstrainSelectedInstOperands,
     /*  494054 */     // GIR_Coverage, 4102,
     /*  494054 */     GIR_EraseRootFromParent_Done,
     /*  494055 */   // Label 8385: @494055
     /*  494055 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(494130), // Rule ID 4103 //
     /*  494060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  494080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  494106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  494109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494128 */     GIR_RootConstrainSelectedInstOperands,
     /*  494129 */     // GIR_Coverage, 4103,
     /*  494129 */     GIR_EraseRootFromParent_Done,
     /*  494130 */   // Label 8386: @494130
     /*  494130 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(494205), // Rule ID 4106 //
     /*  494135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  494155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  494181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  494184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494203 */     GIR_RootConstrainSelectedInstOperands,
     /*  494204 */     // GIR_Coverage, 4106,
     /*  494204 */     GIR_EraseRootFromParent_Done,
     /*  494205 */   // Label 8387: @494205
     /*  494205 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(494280), // Rule ID 4107 //
     /*  494210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  494230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  494256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  494259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494278 */     GIR_RootConstrainSelectedInstOperands,
     /*  494279 */     // GIR_Coverage, 4107,
     /*  494279 */     GIR_EraseRootFromParent_Done,
     /*  494280 */   // Label 8388: @494280
     /*  494280 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(494355), // Rule ID 4110 //
     /*  494285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  494305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494331 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  494331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  494334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494353 */     GIR_RootConstrainSelectedInstOperands,
     /*  494354 */     // GIR_Coverage, 4110,
     /*  494354 */     GIR_EraseRootFromParent_Done,
     /*  494355 */   // Label 8389: @494355
     /*  494355 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(494430), // Rule ID 4111 //
     /*  494360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  494380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  494406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  494409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494428 */     GIR_RootConstrainSelectedInstOperands,
     /*  494429 */     // GIR_Coverage, 4111,
     /*  494429 */     GIR_EraseRootFromParent_Done,
     /*  494430 */   // Label 8390: @494430
     /*  494430 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(494505), // Rule ID 4114 //
     /*  494435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  494455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494481 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  494481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  494484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494503 */     GIR_RootConstrainSelectedInstOperands,
     /*  494504 */     // GIR_Coverage, 4114,
     /*  494504 */     GIR_EraseRootFromParent_Done,
     /*  494505 */   // Label 8391: @494505
     /*  494505 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(494580), // Rule ID 4115 //
     /*  494510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  494518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  494530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  494549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  494556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  494559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494578 */     GIR_RootConstrainSelectedInstOperands,
     /*  494579 */     // GIR_Coverage, 4115,
     /*  494579 */     GIR_EraseRootFromParent_Done,
     /*  494580 */   // Label 8392: @494580
     /*  494580 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(494655), // Rule ID 4120 //
     /*  494585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494631 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  494631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  494634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494653 */     GIR_RootConstrainSelectedInstOperands,
     /*  494654 */     // GIR_Coverage, 4120,
     /*  494654 */     GIR_EraseRootFromParent_Done,
     /*  494655 */   // Label 8393: @494655
     /*  494655 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(494730), // Rule ID 4121 //
     /*  494660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  494706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  494709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494728 */     GIR_RootConstrainSelectedInstOperands,
     /*  494729 */     // GIR_Coverage, 4121,
     /*  494729 */     GIR_EraseRootFromParent_Done,
     /*  494730 */   // Label 8394: @494730
     /*  494730 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(494805), // Rule ID 4130 //
     /*  494735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  494752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  494755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494781 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  494781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  494784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494803 */     GIR_RootConstrainSelectedInstOperands,
     /*  494804 */     // GIR_Coverage, 4130,
     /*  494804 */     GIR_EraseRootFromParent_Done,
     /*  494805 */   // Label 8395: @494805
     /*  494805 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(494880), // Rule ID 4131 //
     /*  494810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  494827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  494830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  494856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  494859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494878 */     GIR_RootConstrainSelectedInstOperands,
     /*  494879 */     // GIR_Coverage, 4131,
     /*  494879 */     GIR_EraseRootFromParent_Done,
     /*  494880 */   // Label 8396: @494880
     /*  494880 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(494955), // Rule ID 4140 //
     /*  494885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494931 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  494931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  494934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  494938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  494953 */     GIR_RootConstrainSelectedInstOperands,
     /*  494954 */     // GIR_Coverage, 4140,
     /*  494954 */     GIR_EraseRootFromParent_Done,
     /*  494955 */   // Label 8397: @494955
     /*  494955 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(495030), // Rule ID 4141 //
     /*  494960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  495006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  495009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495028 */     GIR_RootConstrainSelectedInstOperands,
     /*  495029 */     // GIR_Coverage, 4141,
     /*  495029 */     GIR_EraseRootFromParent_Done,
     /*  495030 */   // Label 8398: @495030
     /*  495030 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(495105), // Rule ID 4150 //
     /*  495035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  495081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  495084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495103 */     GIR_RootConstrainSelectedInstOperands,
     /*  495104 */     // GIR_Coverage, 4150,
     /*  495104 */     GIR_EraseRootFromParent_Done,
     /*  495105 */   // Label 8399: @495105
     /*  495105 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(495180), // Rule ID 4151 //
     /*  495110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  495156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  495159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495178 */     GIR_RootConstrainSelectedInstOperands,
     /*  495179 */     // GIR_Coverage, 4151,
     /*  495179 */     GIR_EraseRootFromParent_Done,
     /*  495180 */   // Label 8400: @495180
     /*  495180 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(495255), // Rule ID 4160 //
     /*  495185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495231 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  495231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  495234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495253 */     GIR_RootConstrainSelectedInstOperands,
     /*  495254 */     // GIR_Coverage, 4160,
     /*  495254 */     GIR_EraseRootFromParent_Done,
     /*  495255 */   // Label 8401: @495255
     /*  495255 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(495330), // Rule ID 4161 //
     /*  495260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  495306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  495309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495328 */     GIR_RootConstrainSelectedInstOperands,
     /*  495329 */     // GIR_Coverage, 4161,
     /*  495329 */     GIR_EraseRootFromParent_Done,
     /*  495330 */   // Label 8402: @495330
     /*  495330 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(495405), // Rule ID 4170 //
     /*  495335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495381 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  495381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  495384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495403 */     GIR_RootConstrainSelectedInstOperands,
     /*  495404 */     // GIR_Coverage, 4170,
     /*  495404 */     GIR_EraseRootFromParent_Done,
     /*  495405 */   // Label 8403: @495405
     /*  495405 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(495480), // Rule ID 4171 //
     /*  495410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495456 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  495456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  495459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495478 */     GIR_RootConstrainSelectedInstOperands,
     /*  495479 */     // GIR_Coverage, 4171,
     /*  495479 */     GIR_EraseRootFromParent_Done,
     /*  495480 */   // Label 8404: @495480
     /*  495480 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(495555), // Rule ID 4180 //
     /*  495485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495531 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  495531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  495534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495553 */     GIR_RootConstrainSelectedInstOperands,
     /*  495554 */     // GIR_Coverage, 4180,
     /*  495554 */     GIR_EraseRootFromParent_Done,
     /*  495555 */   // Label 8405: @495555
     /*  495555 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(495630), // Rule ID 4181 //
     /*  495560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  495606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  495609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495628 */     GIR_RootConstrainSelectedInstOperands,
     /*  495629 */     // GIR_Coverage, 4181,
     /*  495629 */     GIR_EraseRootFromParent_Done,
     /*  495630 */   // Label 8406: @495630
     /*  495630 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(495705), // Rule ID 4190 //
     /*  495635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  495681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  495684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495703 */     GIR_RootConstrainSelectedInstOperands,
     /*  495704 */     // GIR_Coverage, 4190,
     /*  495704 */     GIR_EraseRootFromParent_Done,
     /*  495705 */   // Label 8407: @495705
     /*  495705 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(495780), // Rule ID 4191 //
     /*  495710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  495756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  495759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495778 */     GIR_RootConstrainSelectedInstOperands,
     /*  495779 */     // GIR_Coverage, 4191,
     /*  495779 */     GIR_EraseRootFromParent_Done,
     /*  495780 */   // Label 8408: @495780
     /*  495780 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(495855), // Rule ID 4200 //
     /*  495785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  495831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  495834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495853 */     GIR_RootConstrainSelectedInstOperands,
     /*  495854 */     // GIR_Coverage, 4200,
     /*  495854 */     GIR_EraseRootFromParent_Done,
     /*  495855 */   // Label 8409: @495855
     /*  495855 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(495930), // Rule ID 4201 //
     /*  495860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  495906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  495909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  495928 */     GIR_RootConstrainSelectedInstOperands,
     /*  495929 */     // GIR_Coverage, 4201,
     /*  495929 */     GIR_EraseRootFromParent_Done,
     /*  495930 */   // Label 8410: @495930
     /*  495930 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(496005), // Rule ID 4210 //
     /*  495935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  495943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  495946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  495949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  495952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  495955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  495981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  495984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496003 */     GIR_RootConstrainSelectedInstOperands,
     /*  496004 */     // GIR_Coverage, 4210,
     /*  496004 */     GIR_EraseRootFromParent_Done,
     /*  496005 */   // Label 8411: @496005
     /*  496005 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(496080), // Rule ID 4211 //
     /*  496010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  496021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  496024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  496027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  496030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  496056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  496059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496078 */     GIR_RootConstrainSelectedInstOperands,
     /*  496079 */     // GIR_Coverage, 4211,
     /*  496079 */     GIR_EraseRootFromParent_Done,
     /*  496080 */   // Label 8412: @496080
     /*  496080 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(496155), // Rule ID 4220 //
     /*  496085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  496131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  496134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496153 */     GIR_RootConstrainSelectedInstOperands,
     /*  496154 */     // GIR_Coverage, 4220,
     /*  496154 */     GIR_EraseRootFromParent_Done,
     /*  496155 */   // Label 8413: @496155
     /*  496155 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(496230), // Rule ID 4221 //
     /*  496160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  496206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  496209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496228 */     GIR_RootConstrainSelectedInstOperands,
     /*  496229 */     // GIR_Coverage, 4221,
     /*  496229 */     GIR_EraseRootFromParent_Done,
     /*  496230 */   // Label 8414: @496230
     /*  496230 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(496305), // Rule ID 4230 //
     /*  496235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496281 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  496281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  496284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496303 */     GIR_RootConstrainSelectedInstOperands,
     /*  496304 */     // GIR_Coverage, 4230,
     /*  496304 */     GIR_EraseRootFromParent_Done,
     /*  496305 */   // Label 8415: @496305
     /*  496305 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(496380), // Rule ID 4231 //
     /*  496310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  496356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  496359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496378 */     GIR_RootConstrainSelectedInstOperands,
     /*  496379 */     // GIR_Coverage, 4231,
     /*  496379 */     GIR_EraseRootFromParent_Done,
     /*  496380 */   // Label 8416: @496380
     /*  496380 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(496455), // Rule ID 4240 //
     /*  496385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  496431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  496434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496453 */     GIR_RootConstrainSelectedInstOperands,
     /*  496454 */     // GIR_Coverage, 4240,
     /*  496454 */     GIR_EraseRootFromParent_Done,
     /*  496455 */   // Label 8417: @496455
     /*  496455 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(496530), // Rule ID 4241 //
     /*  496460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  496506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  496509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496528 */     GIR_RootConstrainSelectedInstOperands,
     /*  496529 */     // GIR_Coverage, 4241,
     /*  496529 */     GIR_EraseRootFromParent_Done,
     /*  496530 */   // Label 8418: @496530
     /*  496530 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(496605), // Rule ID 4250 //
     /*  496535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  496581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  496584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496603 */     GIR_RootConstrainSelectedInstOperands,
     /*  496604 */     // GIR_Coverage, 4250,
     /*  496604 */     GIR_EraseRootFromParent_Done,
     /*  496605 */   // Label 8419: @496605
     /*  496605 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(496680), // Rule ID 4251 //
     /*  496610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  496656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  496659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496678 */     GIR_RootConstrainSelectedInstOperands,
     /*  496679 */     // GIR_Coverage, 4251,
     /*  496679 */     GIR_EraseRootFromParent_Done,
     /*  496680 */   // Label 8420: @496680
     /*  496680 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(496755), // Rule ID 4260 //
     /*  496685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496731 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  496731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  496734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496753 */     GIR_RootConstrainSelectedInstOperands,
     /*  496754 */     // GIR_Coverage, 4260,
     /*  496754 */     GIR_EraseRootFromParent_Done,
     /*  496755 */   // Label 8421: @496755
     /*  496755 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(496830), // Rule ID 4261 //
     /*  496760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  496806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  496809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496828 */     GIR_RootConstrainSelectedInstOperands,
     /*  496829 */     // GIR_Coverage, 4261,
     /*  496829 */     GIR_EraseRootFromParent_Done,
     /*  496830 */   // Label 8422: @496830
     /*  496830 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(496905), // Rule ID 4268 //
     /*  496835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  496852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  496874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496881 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  496881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  496884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496903 */     GIR_RootConstrainSelectedInstOperands,
     /*  496904 */     // GIR_Coverage, 4268,
     /*  496904 */     GIR_EraseRootFromParent_Done,
     /*  496905 */   // Label 8423: @496905
     /*  496905 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(496980), // Rule ID 4269 //
     /*  496910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  496927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  496949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  496956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  496959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  496978 */     GIR_RootConstrainSelectedInstOperands,
     /*  496979 */     // GIR_Coverage, 4269,
     /*  496979 */     GIR_EraseRootFromParent_Done,
     /*  496980 */   // Label 8424: @496980
     /*  496980 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(497055), // Rule ID 4272 //
     /*  496985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  496993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  497031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  497034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497053 */     GIR_RootConstrainSelectedInstOperands,
     /*  497054 */     // GIR_Coverage, 4272,
     /*  497054 */     GIR_EraseRootFromParent_Done,
     /*  497055 */   // Label 8425: @497055
     /*  497055 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(497130), // Rule ID 4273 //
     /*  497060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  497071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  497074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  497106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  497109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497128 */     GIR_RootConstrainSelectedInstOperands,
     /*  497129 */     // GIR_Coverage, 4273,
     /*  497129 */     GIR_EraseRootFromParent_Done,
     /*  497130 */   // Label 8426: @497130
     /*  497130 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(497205), // Rule ID 4276 //
     /*  497135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497181 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  497181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  497184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497203 */     GIR_RootConstrainSelectedInstOperands,
     /*  497204 */     // GIR_Coverage, 4276,
     /*  497204 */     GIR_EraseRootFromParent_Done,
     /*  497205 */   // Label 8427: @497205
     /*  497205 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(497280), // Rule ID 4277 //
     /*  497210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  497256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  497259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497278 */     GIR_RootConstrainSelectedInstOperands,
     /*  497279 */     // GIR_Coverage, 4277,
     /*  497279 */     GIR_EraseRootFromParent_Done,
     /*  497280 */   // Label 8428: @497280
     /*  497280 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(497355), // Rule ID 4280 //
     /*  497285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  497331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  497334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497353 */     GIR_RootConstrainSelectedInstOperands,
     /*  497354 */     // GIR_Coverage, 4280,
     /*  497354 */     GIR_EraseRootFromParent_Done,
     /*  497355 */   // Label 8429: @497355
     /*  497355 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(497430), // Rule ID 4281 //
     /*  497360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  497406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  497409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497428 */     GIR_RootConstrainSelectedInstOperands,
     /*  497429 */     // GIR_Coverage, 4281,
     /*  497429 */     GIR_EraseRootFromParent_Done,
     /*  497430 */   // Label 8430: @497430
     /*  497430 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(497505), // Rule ID 4284 //
     /*  497435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  497481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  497484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497503 */     GIR_RootConstrainSelectedInstOperands,
     /*  497504 */     // GIR_Coverage, 4284,
     /*  497504 */     GIR_EraseRootFromParent_Done,
     /*  497505 */   // Label 8431: @497505
     /*  497505 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(497580), // Rule ID 4285 //
     /*  497510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  497556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  497559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497578 */     GIR_RootConstrainSelectedInstOperands,
     /*  497579 */     // GIR_Coverage, 4285,
     /*  497579 */     GIR_EraseRootFromParent_Done,
     /*  497580 */   // Label 8432: @497580
     /*  497580 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(497655), // Rule ID 4288 //
     /*  497585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  497602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  497631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  497634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497653 */     GIR_RootConstrainSelectedInstOperands,
     /*  497654 */     // GIR_Coverage, 4288,
     /*  497654 */     GIR_EraseRootFromParent_Done,
     /*  497655 */   // Label 8433: @497655
     /*  497655 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(497730), // Rule ID 4289 //
     /*  497660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  497677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  497706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  497709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497728 */     GIR_RootConstrainSelectedInstOperands,
     /*  497729 */     // GIR_Coverage, 4289,
     /*  497729 */     GIR_EraseRootFromParent_Done,
     /*  497730 */   // Label 8434: @497730
     /*  497730 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(497805), // Rule ID 4292 //
     /*  497735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  497746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  497749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  497752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  497781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  497784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497803 */     GIR_RootConstrainSelectedInstOperands,
     /*  497804 */     // GIR_Coverage, 4292,
     /*  497804 */     GIR_EraseRootFromParent_Done,
     /*  497805 */   // Label 8435: @497805
     /*  497805 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(497880), // Rule ID 4293 //
     /*  497810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  497821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  497824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  497827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  497856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  497859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497878 */     GIR_RootConstrainSelectedInstOperands,
     /*  497879 */     // GIR_Coverage, 4293,
     /*  497879 */     GIR_EraseRootFromParent_Done,
     /*  497880 */   // Label 8436: @497880
     /*  497880 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(497955), // Rule ID 4296 //
     /*  497885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  497902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497931 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  497931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  497934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  497953 */     GIR_RootConstrainSelectedInstOperands,
     /*  497954 */     // GIR_Coverage, 4296,
     /*  497954 */     GIR_EraseRootFromParent_Done,
     /*  497955 */   // Label 8437: @497955
     /*  497955 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(498030), // Rule ID 4297 //
     /*  497960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  497968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  497977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  497999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  498006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  498009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498028 */     GIR_RootConstrainSelectedInstOperands,
     /*  498029 */     // GIR_Coverage, 4297,
     /*  498029 */     GIR_EraseRootFromParent_Done,
     /*  498030 */   // Label 8438: @498030
     /*  498030 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(498105), // Rule ID 4300 //
     /*  498035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  498081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  498084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498103 */     GIR_RootConstrainSelectedInstOperands,
     /*  498104 */     // GIR_Coverage, 4300,
     /*  498104 */     GIR_EraseRootFromParent_Done,
     /*  498105 */   // Label 8439: @498105
     /*  498105 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(498180), // Rule ID 4301 //
     /*  498110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  498156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  498159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498178 */     GIR_RootConstrainSelectedInstOperands,
     /*  498179 */     // GIR_Coverage, 4301,
     /*  498179 */     GIR_EraseRootFromParent_Done,
     /*  498180 */   // Label 8440: @498180
     /*  498180 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(498255), // Rule ID 4304 //
     /*  498185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498231 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  498231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  498234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498253 */     GIR_RootConstrainSelectedInstOperands,
     /*  498254 */     // GIR_Coverage, 4304,
     /*  498254 */     GIR_EraseRootFromParent_Done,
     /*  498255 */   // Label 8441: @498255
     /*  498255 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(498330), // Rule ID 4305 //
     /*  498260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  498306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  498309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498328 */     GIR_RootConstrainSelectedInstOperands,
     /*  498329 */     // GIR_Coverage, 4305,
     /*  498329 */     GIR_EraseRootFromParent_Done,
     /*  498330 */   // Label 8442: @498330
     /*  498330 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(498405), // Rule ID 4308 //
     /*  498335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  498381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  498384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498403 */     GIR_RootConstrainSelectedInstOperands,
     /*  498404 */     // GIR_Coverage, 4308,
     /*  498404 */     GIR_EraseRootFromParent_Done,
     /*  498405 */   // Label 8443: @498405
     /*  498405 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(498480), // Rule ID 4309 //
     /*  498410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  498456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  498459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498478 */     GIR_RootConstrainSelectedInstOperands,
     /*  498479 */     // GIR_Coverage, 4309,
     /*  498479 */     GIR_EraseRootFromParent_Done,
     /*  498480 */   // Label 8444: @498480
     /*  498480 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(498555), // Rule ID 4312 //
     /*  498485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498531 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  498531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  498534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498553 */     GIR_RootConstrainSelectedInstOperands,
     /*  498554 */     // GIR_Coverage, 4312,
     /*  498554 */     GIR_EraseRootFromParent_Done,
     /*  498555 */   // Label 8445: @498555
     /*  498555 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(498630), // Rule ID 4313 //
     /*  498560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  498563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  498606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  498609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498628 */     GIR_RootConstrainSelectedInstOperands,
     /*  498629 */     // GIR_Coverage, 4313,
     /*  498629 */     GIR_EraseRootFromParent_Done,
     /*  498630 */   // Label 8446: @498630
     /*  498630 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(498705), // Rule ID 4316 //
     /*  498635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  498652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  498681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  498684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498703 */     GIR_RootConstrainSelectedInstOperands,
     /*  498704 */     // GIR_Coverage, 4316,
     /*  498704 */     GIR_EraseRootFromParent_Done,
     /*  498705 */   // Label 8447: @498705
     /*  498705 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(498780), // Rule ID 4317 //
     /*  498710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  498713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  498727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  498756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  498759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498778 */     GIR_RootConstrainSelectedInstOperands,
     /*  498779 */     // GIR_Coverage, 4317,
     /*  498779 */     GIR_EraseRootFromParent_Done,
     /*  498780 */   // Label 8448: @498780
     /*  498780 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(498855), // Rule ID 4320 //
     /*  498785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  498802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498831 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  498831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  498834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498853 */     GIR_RootConstrainSelectedInstOperands,
     /*  498854 */     // GIR_Coverage, 4320,
     /*  498854 */     GIR_EraseRootFromParent_Done,
     /*  498855 */   // Label 8449: @498855
     /*  498855 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(498930), // Rule ID 4321 //
     /*  498860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  498863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  498877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  498906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  498909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  498928 */     GIR_RootConstrainSelectedInstOperands,
     /*  498929 */     // GIR_Coverage, 4321,
     /*  498929 */     GIR_EraseRootFromParent_Done,
     /*  498930 */   // Label 8450: @498930
     /*  498930 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(499005), // Rule ID 4324 //
     /*  498935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  498943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  498952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  498974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498981 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  498981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  498984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499003 */     GIR_RootConstrainSelectedInstOperands,
     /*  499004 */     // GIR_Coverage, 4324,
     /*  499004 */     GIR_EraseRootFromParent_Done,
     /*  499005 */   // Label 8451: @499005
     /*  499005 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(499080), // Rule ID 4325 //
     /*  499010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  499018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  499027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  499049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  499056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  499059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499078 */     GIR_RootConstrainSelectedInstOperands,
     /*  499079 */     // GIR_Coverage, 4325,
     /*  499079 */     GIR_EraseRootFromParent_Done,
     /*  499080 */   // Label 8452: @499080
     /*  499080 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(499155), // Rule ID 4330 //
     /*  499085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  499102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  499105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499131 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  499134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499153 */     GIR_RootConstrainSelectedInstOperands,
     /*  499154 */     // GIR_Coverage, 4330,
     /*  499154 */     GIR_EraseRootFromParent_Done,
     /*  499155 */   // Label 8453: @499155
     /*  499155 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(499230), // Rule ID 4331 //
     /*  499160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  499177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  499180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  499209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499228 */     GIR_RootConstrainSelectedInstOperands,
     /*  499229 */     // GIR_Coverage, 4331,
     /*  499229 */     GIR_EraseRootFromParent_Done,
     /*  499230 */   // Label 8454: @499230
     /*  499230 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(499305), // Rule ID 4340 //
     /*  499235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  499246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  499249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  499252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  499255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499281 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  499284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499303 */     GIR_RootConstrainSelectedInstOperands,
     /*  499304 */     // GIR_Coverage, 4340,
     /*  499304 */     GIR_EraseRootFromParent_Done,
     /*  499305 */   // Label 8455: @499305
     /*  499305 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(499380), // Rule ID 4341 //
     /*  499310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  499321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  499324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  499327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  499330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  499359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499378 */     GIR_RootConstrainSelectedInstOperands,
     /*  499379 */     // GIR_Coverage, 4341,
     /*  499379 */     GIR_EraseRootFromParent_Done,
     /*  499380 */   // Label 8456: @499380
     /*  499380 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(499455), // Rule ID 4350 //
     /*  499385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  499396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  499399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  499402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  499405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499431 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  499434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499453 */     GIR_RootConstrainSelectedInstOperands,
     /*  499454 */     // GIR_Coverage, 4350,
     /*  499454 */     GIR_EraseRootFromParent_Done,
     /*  499455 */   // Label 8457: @499455
     /*  499455 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(499530), // Rule ID 4351 //
     /*  499460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  499471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  499474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  499477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  499480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  499509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499528 */     GIR_RootConstrainSelectedInstOperands,
     /*  499529 */     // GIR_Coverage, 4351,
     /*  499529 */     GIR_EraseRootFromParent_Done,
     /*  499530 */   // Label 8458: @499530
     /*  499530 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(499605), // Rule ID 4360 //
     /*  499535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  499546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  499549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  499552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  499555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  499584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499603 */     GIR_RootConstrainSelectedInstOperands,
     /*  499604 */     // GIR_Coverage, 4360,
     /*  499604 */     GIR_EraseRootFromParent_Done,
     /*  499605 */   // Label 8459: @499605
     /*  499605 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(499680), // Rule ID 4361 //
     /*  499610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  499621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  499624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  499627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  499630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  499659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499678 */     GIR_RootConstrainSelectedInstOperands,
     /*  499679 */     // GIR_Coverage, 4361,
     /*  499679 */     GIR_EraseRootFromParent_Done,
     /*  499680 */   // Label 8460: @499680
     /*  499680 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(499755), // Rule ID 4370 //
     /*  499685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  499696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  499699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  499702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  499705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499731 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  499734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499753 */     GIR_RootConstrainSelectedInstOperands,
     /*  499754 */     // GIR_Coverage, 4370,
     /*  499754 */     GIR_EraseRootFromParent_Done,
     /*  499755 */   // Label 8461: @499755
     /*  499755 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(499830), // Rule ID 4371 //
     /*  499760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  499771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  499774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  499777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  499780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  499809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499828 */     GIR_RootConstrainSelectedInstOperands,
     /*  499829 */     // GIR_Coverage, 4371,
     /*  499829 */     GIR_EraseRootFromParent_Done,
     /*  499830 */   // Label 8462: @499830
     /*  499830 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(499905), // Rule ID 4380 //
     /*  499835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  499846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  499849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  499852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  499855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499881 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  499881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  499884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499903 */     GIR_RootConstrainSelectedInstOperands,
     /*  499904 */     // GIR_Coverage, 4380,
     /*  499904 */     GIR_EraseRootFromParent_Done,
     /*  499905 */   // Label 8463: @499905
     /*  499905 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(499980), // Rule ID 4381 //
     /*  499910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  499921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  499924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  499927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  499930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  499956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  499959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  499978 */     GIR_RootConstrainSelectedInstOperands,
     /*  499979 */     // GIR_Coverage, 4381,
     /*  499979 */     GIR_EraseRootFromParent_Done,
     /*  499980 */   // Label 8464: @499980
     /*  499980 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(500055), // Rule ID 4390 //
     /*  499985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  499993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  500005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500031 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  500031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  500034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500053 */     GIR_RootConstrainSelectedInstOperands,
     /*  500054 */     // GIR_Coverage, 4390,
     /*  500054 */     GIR_EraseRootFromParent_Done,
     /*  500055 */   // Label 8465: @500055
     /*  500055 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(500130), // Rule ID 4391 //
     /*  500060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  500080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  500106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  500109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500128 */     GIR_RootConstrainSelectedInstOperands,
     /*  500129 */     // GIR_Coverage, 4391,
     /*  500129 */     GIR_EraseRootFromParent_Done,
     /*  500130 */   // Label 8466: @500130
     /*  500130 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(500205), // Rule ID 4400 //
     /*  500135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  500155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  500181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  500184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500203 */     GIR_RootConstrainSelectedInstOperands,
     /*  500204 */     // GIR_Coverage, 4400,
     /*  500204 */     GIR_EraseRootFromParent_Done,
     /*  500205 */   // Label 8467: @500205
     /*  500205 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(500280), // Rule ID 4401 //
     /*  500210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  500230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  500256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  500259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500278 */     GIR_RootConstrainSelectedInstOperands,
     /*  500279 */     // GIR_Coverage, 4401,
     /*  500279 */     GIR_EraseRootFromParent_Done,
     /*  500280 */   // Label 8468: @500280
     /*  500280 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(500355), // Rule ID 4410 //
     /*  500285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  500305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  500331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  500334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500353 */     GIR_RootConstrainSelectedInstOperands,
     /*  500354 */     // GIR_Coverage, 4410,
     /*  500354 */     GIR_EraseRootFromParent_Done,
     /*  500355 */   // Label 8469: @500355
     /*  500355 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(500430), // Rule ID 4411 //
     /*  500360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  500380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  500406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  500409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500428 */     GIR_RootConstrainSelectedInstOperands,
     /*  500429 */     // GIR_Coverage, 4411,
     /*  500429 */     GIR_EraseRootFromParent_Done,
     /*  500430 */   // Label 8470: @500430
     /*  500430 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(500505), // Rule ID 4420 //
     /*  500435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  500455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  500481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  500484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500503 */     GIR_RootConstrainSelectedInstOperands,
     /*  500504 */     // GIR_Coverage, 4420,
     /*  500504 */     GIR_EraseRootFromParent_Done,
     /*  500505 */   // Label 8471: @500505
     /*  500505 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(500580), // Rule ID 4421 //
     /*  500510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  500530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  500556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  500559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500578 */     GIR_RootConstrainSelectedInstOperands,
     /*  500579 */     // GIR_Coverage, 4421,
     /*  500579 */     GIR_EraseRootFromParent_Done,
     /*  500580 */   // Label 8472: @500580
     /*  500580 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(500655), // Rule ID 4430 //
     /*  500585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  500605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500631 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  500631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  500634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500653 */     GIR_RootConstrainSelectedInstOperands,
     /*  500654 */     // GIR_Coverage, 4430,
     /*  500654 */     GIR_EraseRootFromParent_Done,
     /*  500655 */   // Label 8473: @500655
     /*  500655 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(500730), // Rule ID 4431 //
     /*  500660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  500680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  500706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  500709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500728 */     GIR_RootConstrainSelectedInstOperands,
     /*  500729 */     // GIR_Coverage, 4431,
     /*  500729 */     GIR_EraseRootFromParent_Done,
     /*  500730 */   // Label 8474: @500730
     /*  500730 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(500805), // Rule ID 4440 //
     /*  500735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  500738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  500752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  500755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500781 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  500781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  500784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500803 */     GIR_RootConstrainSelectedInstOperands,
     /*  500804 */     // GIR_Coverage, 4440,
     /*  500804 */     GIR_EraseRootFromParent_Done,
     /*  500805 */   // Label 8475: @500805
     /*  500805 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(500880), // Rule ID 4441 //
     /*  500810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  500813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  500827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  500830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  500856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  500859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500878 */     GIR_RootConstrainSelectedInstOperands,
     /*  500879 */     // GIR_Coverage, 4441,
     /*  500879 */     GIR_EraseRootFromParent_Done,
     /*  500880 */   // Label 8476: @500880
     /*  500880 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(500955), // Rule ID 4450 //
     /*  500885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  500888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  500896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  500899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  500902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  500905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  500908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  500931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  500934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  500940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  500942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  500953 */     GIR_RootConstrainSelectedInstOperands,
     /*  500954 */     // GIR_Coverage, 4450,
     /*  500954 */     GIR_EraseRootFromParent_Done,
     /*  500955 */   // Label 8477: @500955
     /*  500955 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(501030), // Rule ID 4451 //
     /*  500960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  500963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  500968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  500971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  500974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  500977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  500980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  500983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  501006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  501009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501028 */     GIR_RootConstrainSelectedInstOperands,
     /*  501029 */     // GIR_Coverage, 4451,
     /*  501029 */     GIR_EraseRootFromParent_Done,
     /*  501030 */   // Label 8478: @501030
     /*  501030 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(501105), // Rule ID 4460 //
     /*  501035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  501038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  501046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  501049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  501052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  501055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  501081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  501084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501103 */     GIR_RootConstrainSelectedInstOperands,
     /*  501104 */     // GIR_Coverage, 4460,
     /*  501104 */     GIR_EraseRootFromParent_Done,
     /*  501105 */   // Label 8479: @501105
     /*  501105 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(501180), // Rule ID 4461 //
     /*  501110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  501113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  501121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  501124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  501127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  501130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  501156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  501159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501178 */     GIR_RootConstrainSelectedInstOperands,
     /*  501179 */     // GIR_Coverage, 4461,
     /*  501179 */     GIR_EraseRootFromParent_Done,
     /*  501180 */   // Label 8480: @501180
     /*  501180 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(501255), // Rule ID 4470 //
     /*  501185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  501188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  501196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  501199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  501202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  501205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  501231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  501234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501253 */     GIR_RootConstrainSelectedInstOperands,
     /*  501254 */     // GIR_Coverage, 4470,
     /*  501254 */     GIR_EraseRootFromParent_Done,
     /*  501255 */   // Label 8481: @501255
     /*  501255 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(501330), // Rule ID 4471 //
     /*  501260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  501263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  501271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  501274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  501277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  501280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  501306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  501309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501328 */     GIR_RootConstrainSelectedInstOperands,
     /*  501329 */     // GIR_Coverage, 4471,
     /*  501329 */     GIR_EraseRootFromParent_Done,
     /*  501330 */   // Label 8482: @501330
     /*  501330 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(501405), // Rule ID 4478 //
     /*  501335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  501346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  501349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  501352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501381 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  501381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  501384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501403 */     GIR_RootConstrainSelectedInstOperands,
     /*  501404 */     // GIR_Coverage, 4478,
     /*  501404 */     GIR_EraseRootFromParent_Done,
     /*  501405 */   // Label 8483: @501405
     /*  501405 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(501480), // Rule ID 4479 //
     /*  501410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  501421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  501424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  501427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  501456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  501459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501478 */     GIR_RootConstrainSelectedInstOperands,
     /*  501479 */     // GIR_Coverage, 4479,
     /*  501479 */     GIR_EraseRootFromParent_Done,
     /*  501480 */   // Label 8484: @501480
     /*  501480 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(501555), // Rule ID 4482 //
     /*  501485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  501496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  501499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  501502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501531 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  501531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  501534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501553 */     GIR_RootConstrainSelectedInstOperands,
     /*  501554 */     // GIR_Coverage, 4482,
     /*  501554 */     GIR_EraseRootFromParent_Done,
     /*  501555 */   // Label 8485: @501555
     /*  501555 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(501630), // Rule ID 4483 //
     /*  501560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  501571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  501574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  501577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  501606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  501609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501628 */     GIR_RootConstrainSelectedInstOperands,
     /*  501629 */     // GIR_Coverage, 4483,
     /*  501629 */     GIR_EraseRootFromParent_Done,
     /*  501630 */   // Label 8486: @501630
     /*  501630 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(501705), // Rule ID 4486 //
     /*  501635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  501646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  501649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  501652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501681 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  501681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  501684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501703 */     GIR_RootConstrainSelectedInstOperands,
     /*  501704 */     // GIR_Coverage, 4486,
     /*  501704 */     GIR_EraseRootFromParent_Done,
     /*  501705 */   // Label 8487: @501705
     /*  501705 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(501780), // Rule ID 4487 //
     /*  501710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  501721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  501724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  501727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  501756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  501759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501778 */     GIR_RootConstrainSelectedInstOperands,
     /*  501779 */     // GIR_Coverage, 4487,
     /*  501779 */     GIR_EraseRootFromParent_Done,
     /*  501780 */   // Label 8488: @501780
     /*  501780 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(501855), // Rule ID 4490 //
     /*  501785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  501802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  501831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  501834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501853 */     GIR_RootConstrainSelectedInstOperands,
     /*  501854 */     // GIR_Coverage, 4490,
     /*  501854 */     GIR_EraseRootFromParent_Done,
     /*  501855 */   // Label 8489: @501855
     /*  501855 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(501930), // Rule ID 4491 //
     /*  501860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  501877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  501883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  501906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  501909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  501928 */     GIR_RootConstrainSelectedInstOperands,
     /*  501929 */     // GIR_Coverage, 4491,
     /*  501929 */     GIR_EraseRootFromParent_Done,
     /*  501930 */   // Label 8490: @501930
     /*  501930 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(502005), // Rule ID 4494 //
     /*  501935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  501943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  501946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  501949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  501952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  501958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  501974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501981 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  501981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  501984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  501990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  501992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  502000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502003 */     GIR_RootConstrainSelectedInstOperands,
     /*  502004 */     // GIR_Coverage, 4494,
     /*  502004 */     GIR_EraseRootFromParent_Done,
     /*  502005 */   // Label 8491: @502005
     /*  502005 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(502080), // Rule ID 4495 //
     /*  502010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  502021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  502024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  502027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  502056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  502059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  502075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502078 */     GIR_RootConstrainSelectedInstOperands,
     /*  502079 */     // GIR_Coverage, 4495,
     /*  502079 */     GIR_EraseRootFromParent_Done,
     /*  502080 */   // Label 8492: @502080
     /*  502080 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(502155), // Rule ID 4498 //
     /*  502085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  502096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  502099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  502102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502131 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  502131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  502134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  502150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502153 */     GIR_RootConstrainSelectedInstOperands,
     /*  502154 */     // GIR_Coverage, 4498,
     /*  502154 */     GIR_EraseRootFromParent_Done,
     /*  502155 */   // Label 8493: @502155
     /*  502155 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(502230), // Rule ID 4499 //
     /*  502160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  502171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  502174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  502177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  502206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  502209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  502225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502228 */     GIR_RootConstrainSelectedInstOperands,
     /*  502229 */     // GIR_Coverage, 4499,
     /*  502229 */     GIR_EraseRootFromParent_Done,
     /*  502230 */   // Label 8494: @502230
     /*  502230 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(502305), // Rule ID 4502 //
     /*  502235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  502281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  502284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502303 */     GIR_RootConstrainSelectedInstOperands,
     /*  502304 */     // GIR_Coverage, 4502,
     /*  502304 */     GIR_EraseRootFromParent_Done,
     /*  502305 */   // Label 8495: @502305
     /*  502305 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(502380), // Rule ID 4503 //
     /*  502310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  502356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  502359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502378 */     GIR_RootConstrainSelectedInstOperands,
     /*  502379 */     // GIR_Coverage, 4503,
     /*  502379 */     GIR_EraseRootFromParent_Done,
     /*  502380 */   // Label 8496: @502380
     /*  502380 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(502455), // Rule ID 4506 //
     /*  502385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502431 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  502431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  502434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502453 */     GIR_RootConstrainSelectedInstOperands,
     /*  502454 */     // GIR_Coverage, 4506,
     /*  502454 */     GIR_EraseRootFromParent_Done,
     /*  502455 */   // Label 8497: @502455
     /*  502455 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(502530), // Rule ID 4507 //
     /*  502460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  502506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  502509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502528 */     GIR_RootConstrainSelectedInstOperands,
     /*  502529 */     // GIR_Coverage, 4507,
     /*  502529 */     GIR_EraseRootFromParent_Done,
     /*  502530 */   // Label 8498: @502530
     /*  502530 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(502605), // Rule ID 4510 //
     /*  502535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  502581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  502584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502603 */     GIR_RootConstrainSelectedInstOperands,
     /*  502604 */     // GIR_Coverage, 4510,
     /*  502604 */     GIR_EraseRootFromParent_Done,
     /*  502605 */   // Label 8499: @502605
     /*  502605 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(502680), // Rule ID 4511 //
     /*  502610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  502656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  502659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502678 */     GIR_RootConstrainSelectedInstOperands,
     /*  502679 */     // GIR_Coverage, 4511,
     /*  502679 */     GIR_EraseRootFromParent_Done,
     /*  502680 */   // Label 8500: @502680
     /*  502680 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(502755), // Rule ID 4514 //
     /*  502685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  502731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  502734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502753 */     GIR_RootConstrainSelectedInstOperands,
     /*  502754 */     // GIR_Coverage, 4514,
     /*  502754 */     GIR_EraseRootFromParent_Done,
     /*  502755 */   // Label 8501: @502755
     /*  502755 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(502830), // Rule ID 4515 //
     /*  502760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  502806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  502809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502828 */     GIR_RootConstrainSelectedInstOperands,
     /*  502829 */     // GIR_Coverage, 4515,
     /*  502829 */     GIR_EraseRootFromParent_Done,
     /*  502830 */   // Label 8502: @502830
     /*  502830 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(502905), // Rule ID 4518 //
     /*  502835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  502838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  502858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  502881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  502884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502903 */     GIR_RootConstrainSelectedInstOperands,
     /*  502904 */     // GIR_Coverage, 4518,
     /*  502904 */     GIR_EraseRootFromParent_Done,
     /*  502905 */   // Label 8503: @502905
     /*  502905 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(502980), // Rule ID 4519 //
     /*  502910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  502933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  502949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  502956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  502959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  502965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  502967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  502975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  502978 */     GIR_RootConstrainSelectedInstOperands,
     /*  502979 */     // GIR_Coverage, 4519,
     /*  502979 */     GIR_EraseRootFromParent_Done,
     /*  502980 */   // Label 8504: @502980
     /*  502980 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(503055), // Rule ID 4522 //
     /*  502985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  502988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  502993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  502996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  502999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  503002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  503031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  503034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503053 */     GIR_RootConstrainSelectedInstOperands,
     /*  503054 */     // GIR_Coverage, 4522,
     /*  503054 */     GIR_EraseRootFromParent_Done,
     /*  503055 */   // Label 8505: @503055
     /*  503055 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(503130), // Rule ID 4523 //
     /*  503060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  503063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  503071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  503074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  503077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  503106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  503109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503128 */     GIR_RootConstrainSelectedInstOperands,
     /*  503129 */     // GIR_Coverage, 4523,
     /*  503129 */     GIR_EraseRootFromParent_Done,
     /*  503130 */   // Label 8506: @503130
     /*  503130 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(503205), // Rule ID 4526 //
     /*  503135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  503138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  503146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  503149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  503152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  503181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  503184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503203 */     GIR_RootConstrainSelectedInstOperands,
     /*  503204 */     // GIR_Coverage, 4526,
     /*  503204 */     GIR_EraseRootFromParent_Done,
     /*  503205 */   // Label 8507: @503205
     /*  503205 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(503280), // Rule ID 4527 //
     /*  503210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  503213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  503221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  503224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  503227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  503256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  503259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503278 */     GIR_RootConstrainSelectedInstOperands,
     /*  503279 */     // GIR_Coverage, 4527,
     /*  503279 */     GIR_EraseRootFromParent_Done,
     /*  503280 */   // Label 8508: @503280
     /*  503280 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(503355), // Rule ID 4530 //
     /*  503285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  503288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  503296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  503299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  503302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503331 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  503331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  503334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503353 */     GIR_RootConstrainSelectedInstOperands,
     /*  503354 */     // GIR_Coverage, 4530,
     /*  503354 */     GIR_EraseRootFromParent_Done,
     /*  503355 */   // Label 8509: @503355
     /*  503355 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(503430), // Rule ID 4531 //
     /*  503360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  503363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  503371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  503374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  503377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  503406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  503409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503428 */     GIR_RootConstrainSelectedInstOperands,
     /*  503429 */     // GIR_Coverage, 4531,
     /*  503429 */     GIR_EraseRootFromParent_Done,
     /*  503430 */   // Label 8510: @503430
     /*  503430 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(503505), // Rule ID 4534 //
     /*  503435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  503438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  503446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  503449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  503452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503481 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  503481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  503484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503503 */     GIR_RootConstrainSelectedInstOperands,
     /*  503504 */     // GIR_Coverage, 4534,
     /*  503504 */     GIR_EraseRootFromParent_Done,
     /*  503505 */   // Label 8511: @503505
     /*  503505 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(503580), // Rule ID 4535 //
     /*  503510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  503513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  503518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  503521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  503524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  503527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  503549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  503556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  503559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503578 */     GIR_RootConstrainSelectedInstOperands,
     /*  503579 */     // GIR_Coverage, 4535,
     /*  503579 */     GIR_EraseRootFromParent_Done,
     /*  503580 */   // Label 8512: @503580
     /*  503580 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(503655), // Rule ID 4540 //
     /*  503585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  503588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  503596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  503599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  503602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  503605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503631 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  503631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  503634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  503650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503653 */     GIR_RootConstrainSelectedInstOperands,
     /*  503654 */     // GIR_Coverage, 4540,
     /*  503654 */     GIR_EraseRootFromParent_Done,
     /*  503655 */   // Label 8513: @503655
     /*  503655 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(503730), // Rule ID 4541 //
     /*  503660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  503663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  503671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  503674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  503677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  503680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  503706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  503709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  503725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503728 */     GIR_RootConstrainSelectedInstOperands,
     /*  503729 */     // GIR_Coverage, 4541,
     /*  503729 */     GIR_EraseRootFromParent_Done,
     /*  503730 */   // Label 8514: @503730
     /*  503730 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(503805), // Rule ID 4550 //
     /*  503735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  503738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  503746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  503749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  503752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  503755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503781 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  503781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  503784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  503800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503803 */     GIR_RootConstrainSelectedInstOperands,
     /*  503804 */     // GIR_Coverage, 4550,
     /*  503804 */     GIR_EraseRootFromParent_Done,
     /*  503805 */   // Label 8515: @503805
     /*  503805 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(503880), // Rule ID 4551 //
     /*  503810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  503813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  503821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  503824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  503827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  503830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  503856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  503859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  503875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503878 */     GIR_RootConstrainSelectedInstOperands,
     /*  503879 */     // GIR_Coverage, 4551,
     /*  503879 */     GIR_EraseRootFromParent_Done,
     /*  503880 */   // Label 8516: @503880
     /*  503880 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(503955), // Rule ID 4560 //
     /*  503885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  503888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  503896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  503899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  503902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  503905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  503908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503931 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  503931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  503934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  503936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  503938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  503940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  503942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  503950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  503953 */     GIR_RootConstrainSelectedInstOperands,
     /*  503954 */     // GIR_Coverage, 4560,
     /*  503954 */     GIR_EraseRootFromParent_Done,
     /*  503955 */   // Label 8517: @503955
     /*  503955 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(504030), // Rule ID 4561 //
     /*  503960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  503963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  503968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  503971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  503974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  503977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  503980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  503983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  504006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  504009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504028 */     GIR_RootConstrainSelectedInstOperands,
     /*  504029 */     // GIR_Coverage, 4561,
     /*  504029 */     GIR_EraseRootFromParent_Done,
     /*  504030 */   // Label 8518: @504030
     /*  504030 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(504105), // Rule ID 4570 //
     /*  504035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  504046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  504049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  504052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  504055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  504081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  504084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504103 */     GIR_RootConstrainSelectedInstOperands,
     /*  504104 */     // GIR_Coverage, 4570,
     /*  504104 */     GIR_EraseRootFromParent_Done,
     /*  504105 */   // Label 8519: @504105
     /*  504105 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(504180), // Rule ID 4571 //
     /*  504110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  504121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  504124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  504127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  504130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  504156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  504159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504178 */     GIR_RootConstrainSelectedInstOperands,
     /*  504179 */     // GIR_Coverage, 4571,
     /*  504179 */     GIR_EraseRootFromParent_Done,
     /*  504180 */   // Label 8520: @504180
     /*  504180 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(504255), // Rule ID 4580 //
     /*  504185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  504196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  504199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  504202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  504205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504231 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  504231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  504234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504253 */     GIR_RootConstrainSelectedInstOperands,
     /*  504254 */     // GIR_Coverage, 4580,
     /*  504254 */     GIR_EraseRootFromParent_Done,
     /*  504255 */   // Label 8521: @504255
     /*  504255 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(504330), // Rule ID 4581 //
     /*  504260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  504271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  504274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  504277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  504280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  504306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  504309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504328 */     GIR_RootConstrainSelectedInstOperands,
     /*  504329 */     // GIR_Coverage, 4581,
     /*  504329 */     GIR_EraseRootFromParent_Done,
     /*  504330 */   // Label 8522: @504330
     /*  504330 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(504405), // Rule ID 4590 //
     /*  504335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  504346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  504349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  504352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  504355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504381 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  504381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  504384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504403 */     GIR_RootConstrainSelectedInstOperands,
     /*  504404 */     // GIR_Coverage, 4590,
     /*  504404 */     GIR_EraseRootFromParent_Done,
     /*  504405 */   // Label 8523: @504405
     /*  504405 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(504480), // Rule ID 4591 //
     /*  504410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  504421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  504424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  504427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  504430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504456 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  504456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  504459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  504475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504478 */     GIR_RootConstrainSelectedInstOperands,
     /*  504479 */     // GIR_Coverage, 4591,
     /*  504479 */     GIR_EraseRootFromParent_Done,
     /*  504480 */   // Label 8524: @504480
     /*  504480 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(504555), // Rule ID 4600 //
     /*  504485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  504505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504531 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  504531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  504534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504553 */     GIR_RootConstrainSelectedInstOperands,
     /*  504554 */     // GIR_Coverage, 4600,
     /*  504554 */     GIR_EraseRootFromParent_Done,
     /*  504555 */   // Label 8525: @504555
     /*  504555 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(504630), // Rule ID 4601 //
     /*  504560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  504580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  504606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  504609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504628 */     GIR_RootConstrainSelectedInstOperands,
     /*  504629 */     // GIR_Coverage, 4601,
     /*  504629 */     GIR_EraseRootFromParent_Done,
     /*  504630 */   // Label 8526: @504630
     /*  504630 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(504705), // Rule ID 4610 //
     /*  504635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  504655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  504681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  504684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504703 */     GIR_RootConstrainSelectedInstOperands,
     /*  504704 */     // GIR_Coverage, 4610,
     /*  504704 */     GIR_EraseRootFromParent_Done,
     /*  504705 */   // Label 8527: @504705
     /*  504705 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(504780), // Rule ID 4611 //
     /*  504710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  504730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  504756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  504759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504778 */     GIR_RootConstrainSelectedInstOperands,
     /*  504779 */     // GIR_Coverage, 4611,
     /*  504779 */     GIR_EraseRootFromParent_Done,
     /*  504780 */   // Label 8528: @504780
     /*  504780 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(504855), // Rule ID 4620 //
     /*  504785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  504805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  504831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  504834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504853 */     GIR_RootConstrainSelectedInstOperands,
     /*  504854 */     // GIR_Coverage, 4620,
     /*  504854 */     GIR_EraseRootFromParent_Done,
     /*  504855 */   // Label 8529: @504855
     /*  504855 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(504930), // Rule ID 4621 //
     /*  504860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  504863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  504880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  504883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  504906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  504909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  504925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  504928 */     GIR_RootConstrainSelectedInstOperands,
     /*  504929 */     // GIR_Coverage, 4621,
     /*  504929 */     GIR_EraseRootFromParent_Done,
     /*  504930 */   // Label 8530: @504930
     /*  504930 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(505005), // Rule ID 4630 //
     /*  504935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  504938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  504943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  504955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  504958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  504981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  504984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  504986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  504988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  504990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  504992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  505000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505003 */     GIR_RootConstrainSelectedInstOperands,
     /*  505004 */     // GIR_Coverage, 4630,
     /*  505004 */     GIR_EraseRootFromParent_Done,
     /*  505005 */   // Label 8531: @505005
     /*  505005 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(505080), // Rule ID 4631 //
     /*  505010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  505013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  505030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  505056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  505059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  505075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505078 */     GIR_RootConstrainSelectedInstOperands,
     /*  505079 */     // GIR_Coverage, 4631,
     /*  505079 */     GIR_EraseRootFromParent_Done,
     /*  505080 */   // Label 8532: @505080
     /*  505080 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(505155), // Rule ID 4640 //
     /*  505085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  505088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  505105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  505131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  505134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  505150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505153 */     GIR_RootConstrainSelectedInstOperands,
     /*  505154 */     // GIR_Coverage, 4640,
     /*  505154 */     GIR_EraseRootFromParent_Done,
     /*  505155 */   // Label 8533: @505155
     /*  505155 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(505230), // Rule ID 4641 //
     /*  505160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  505163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  505180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  505206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  505209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  505225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505228 */     GIR_RootConstrainSelectedInstOperands,
     /*  505229 */     // GIR_Coverage, 4641,
     /*  505229 */     GIR_EraseRootFromParent_Done,
     /*  505230 */   // Label 8534: @505230
     /*  505230 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(505305), // Rule ID 4650 //
     /*  505235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  505238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  505246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  505249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  505252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  505255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505281 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  505281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  505284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505303 */     GIR_RootConstrainSelectedInstOperands,
     /*  505304 */     // GIR_Coverage, 4650,
     /*  505304 */     GIR_EraseRootFromParent_Done,
     /*  505305 */   // Label 8535: @505305
     /*  505305 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(505380), // Rule ID 4651 //
     /*  505310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  505313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  505321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  505324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  505327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  505330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  505356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  505359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505378 */     GIR_RootConstrainSelectedInstOperands,
     /*  505379 */     // GIR_Coverage, 4651,
     /*  505379 */     GIR_EraseRootFromParent_Done,
     /*  505380 */   // Label 8536: @505380
     /*  505380 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(505455), // Rule ID 4660 //
     /*  505385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  505388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  505396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  505399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  505402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  505405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  505431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  505434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505453 */     GIR_RootConstrainSelectedInstOperands,
     /*  505454 */     // GIR_Coverage, 4660,
     /*  505454 */     GIR_EraseRootFromParent_Done,
     /*  505455 */   // Label 8537: @505455
     /*  505455 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(505530), // Rule ID 4661 //
     /*  505460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  505463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  505471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  505474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  505477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  505480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  505506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  505509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505528 */     GIR_RootConstrainSelectedInstOperands,
     /*  505529 */     // GIR_Coverage, 4661,
     /*  505529 */     GIR_EraseRootFromParent_Done,
     /*  505530 */   // Label 8538: @505530
     /*  505530 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(505605), // Rule ID 4670 //
     /*  505535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  505538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  505546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  505549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  505552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  505555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  505581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  505584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505603 */     GIR_RootConstrainSelectedInstOperands,
     /*  505604 */     // GIR_Coverage, 4670,
     /*  505604 */     GIR_EraseRootFromParent_Done,
     /*  505605 */   // Label 8539: @505605
     /*  505605 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(505680), // Rule ID 4671 //
     /*  505610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  505613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  505621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  505624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  505627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  505630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  505656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  505659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505678 */     GIR_RootConstrainSelectedInstOperands,
     /*  505679 */     // GIR_Coverage, 4671,
     /*  505679 */     GIR_EraseRootFromParent_Done,
     /*  505680 */   // Label 8540: @505680
     /*  505680 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(505755), // Rule ID 4680 //
     /*  505685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  505688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  505696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  505699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  505702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  505705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505731 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  505731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  505734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505753 */     GIR_RootConstrainSelectedInstOperands,
     /*  505754 */     // GIR_Coverage, 4680,
     /*  505754 */     GIR_EraseRootFromParent_Done,
     /*  505755 */   // Label 8541: @505755
     /*  505755 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(505830), // Rule ID 4681 //
     /*  505760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  505763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  505771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  505774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  505777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  505780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  505806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  505809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505828 */     GIR_RootConstrainSelectedInstOperands,
     /*  505829 */     // GIR_Coverage, 4681,
     /*  505829 */     GIR_EraseRootFromParent_Done,
     /*  505830 */   // Label 8542: @505830
     /*  505830 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(505905), // Rule ID 4688 //
     /*  505835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  505838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  505846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  505849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  505852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  505858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  505874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505881 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  505881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  505884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  505900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505903 */     GIR_RootConstrainSelectedInstOperands,
     /*  505904 */     // GIR_Coverage, 4688,
     /*  505904 */     GIR_EraseRootFromParent_Done,
     /*  505905 */   // Label 8543: @505905
     /*  505905 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(505980), // Rule ID 4689 //
     /*  505910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  505913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  505921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  505924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  505927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  505933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  505949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  505956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  505959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  505961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  505963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  505965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  505967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  505975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  505978 */     GIR_RootConstrainSelectedInstOperands,
     /*  505979 */     // GIR_Coverage, 4689,
     /*  505979 */     GIR_EraseRootFromParent_Done,
     /*  505980 */   // Label 8544: @505980
     /*  505980 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(506055), // Rule ID 4692 //
     /*  505985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  505988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  505993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  505996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  505999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  506002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  506031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  506034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506053 */     GIR_RootConstrainSelectedInstOperands,
     /*  506054 */     // GIR_Coverage, 4692,
     /*  506054 */     GIR_EraseRootFromParent_Done,
     /*  506055 */   // Label 8545: @506055
     /*  506055 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(506130), // Rule ID 4693 //
     /*  506060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  506071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  506074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  506077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  506106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  506109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506128 */     GIR_RootConstrainSelectedInstOperands,
     /*  506129 */     // GIR_Coverage, 4693,
     /*  506129 */     GIR_EraseRootFromParent_Done,
     /*  506130 */   // Label 8546: @506130
     /*  506130 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(506205), // Rule ID 4696 //
     /*  506135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  506146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  506149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  506152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506181 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  506181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  506184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506203 */     GIR_RootConstrainSelectedInstOperands,
     /*  506204 */     // GIR_Coverage, 4696,
     /*  506204 */     GIR_EraseRootFromParent_Done,
     /*  506205 */   // Label 8547: @506205
     /*  506205 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(506280), // Rule ID 4697 //
     /*  506210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  506221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  506224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  506227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  506256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  506259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506278 */     GIR_RootConstrainSelectedInstOperands,
     /*  506279 */     // GIR_Coverage, 4697,
     /*  506279 */     GIR_EraseRootFromParent_Done,
     /*  506280 */   // Label 8548: @506280
     /*  506280 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(506355), // Rule ID 4700 //
     /*  506285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  506296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  506299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  506302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  506331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  506334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506353 */     GIR_RootConstrainSelectedInstOperands,
     /*  506354 */     // GIR_Coverage, 4700,
     /*  506354 */     GIR_EraseRootFromParent_Done,
     /*  506355 */   // Label 8549: @506355
     /*  506355 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(506430), // Rule ID 4701 //
     /*  506360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  506371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  506374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  506377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  506406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  506409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506428 */     GIR_RootConstrainSelectedInstOperands,
     /*  506429 */     // GIR_Coverage, 4701,
     /*  506429 */     GIR_EraseRootFromParent_Done,
     /*  506430 */   // Label 8550: @506430
     /*  506430 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(506505), // Rule ID 4704 //
     /*  506435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  506446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  506449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  506452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  506481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  506484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506503 */     GIR_RootConstrainSelectedInstOperands,
     /*  506504 */     // GIR_Coverage, 4704,
     /*  506504 */     GIR_EraseRootFromParent_Done,
     /*  506505 */   // Label 8551: @506505
     /*  506505 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(506580), // Rule ID 4705 //
     /*  506510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  506521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  506524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  506527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  506556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  506559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506578 */     GIR_RootConstrainSelectedInstOperands,
     /*  506579 */     // GIR_Coverage, 4705,
     /*  506579 */     GIR_EraseRootFromParent_Done,
     /*  506580 */   // Label 8552: @506580
     /*  506580 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(506655), // Rule ID 4708 //
     /*  506585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  506596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  506599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  506602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  506631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  506634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506653 */     GIR_RootConstrainSelectedInstOperands,
     /*  506654 */     // GIR_Coverage, 4708,
     /*  506654 */     GIR_EraseRootFromParent_Done,
     /*  506655 */   // Label 8553: @506655
     /*  506655 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(506730), // Rule ID 4709 //
     /*  506660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  506671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  506674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  506677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  506706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  506709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  506725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506728 */     GIR_RootConstrainSelectedInstOperands,
     /*  506729 */     // GIR_Coverage, 4709,
     /*  506729 */     GIR_EraseRootFromParent_Done,
     /*  506730 */   // Label 8554: @506730
     /*  506730 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(506805), // Rule ID 4712 //
     /*  506735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  506781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  506784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  506800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506803 */     GIR_RootConstrainSelectedInstOperands,
     /*  506804 */     // GIR_Coverage, 4712,
     /*  506804 */     GIR_EraseRootFromParent_Done,
     /*  506805 */   // Label 8555: @506805
     /*  506805 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(506880), // Rule ID 4713 //
     /*  506810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  506856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  506859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  506875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506878 */     GIR_RootConstrainSelectedInstOperands,
     /*  506879 */     // GIR_Coverage, 4713,
     /*  506879 */     GIR_EraseRootFromParent_Done,
     /*  506880 */   // Label 8556: @506880
     /*  506880 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(506955), // Rule ID 4716 //
     /*  506885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  506888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  506908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506931 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  506931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  506934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  506936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  506938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  506940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  506942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  506950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  506953 */     GIR_RootConstrainSelectedInstOperands,
     /*  506954 */     // GIR_Coverage, 4716,
     /*  506954 */     GIR_EraseRootFromParent_Done,
     /*  506955 */   // Label 8557: @506955
     /*  506955 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(507030), // Rule ID 4717 //
     /*  506960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  506963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  506968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  506983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  506999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  507006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  507009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507028 */     GIR_RootConstrainSelectedInstOperands,
     /*  507029 */     // GIR_Coverage, 4717,
     /*  507029 */     GIR_EraseRootFromParent_Done,
     /*  507030 */   // Label 8558: @507030
     /*  507030 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(507105), // Rule ID 4720 //
     /*  507035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  507038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  507081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  507084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507103 */     GIR_RootConstrainSelectedInstOperands,
     /*  507104 */     // GIR_Coverage, 4720,
     /*  507104 */     GIR_EraseRootFromParent_Done,
     /*  507105 */   // Label 8559: @507105
     /*  507105 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(507180), // Rule ID 4721 //
     /*  507110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  507113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  507156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  507159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507178 */     GIR_RootConstrainSelectedInstOperands,
     /*  507179 */     // GIR_Coverage, 4721,
     /*  507179 */     GIR_EraseRootFromParent_Done,
     /*  507180 */   // Label 8560: @507180
     /*  507180 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(507255), // Rule ID 4724 //
     /*  507185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  507188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507231 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  507231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  507234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507253 */     GIR_RootConstrainSelectedInstOperands,
     /*  507254 */     // GIR_Coverage, 4724,
     /*  507254 */     GIR_EraseRootFromParent_Done,
     /*  507255 */   // Label 8561: @507255
     /*  507255 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(507330), // Rule ID 4725 //
     /*  507260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  507263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  507306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  507309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507328 */     GIR_RootConstrainSelectedInstOperands,
     /*  507329 */     // GIR_Coverage, 4725,
     /*  507329 */     GIR_EraseRootFromParent_Done,
     /*  507330 */   // Label 8562: @507330
     /*  507330 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(507405), // Rule ID 4728 //
     /*  507335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  507338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  507381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  507384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507403 */     GIR_RootConstrainSelectedInstOperands,
     /*  507404 */     // GIR_Coverage, 4728,
     /*  507404 */     GIR_EraseRootFromParent_Done,
     /*  507405 */   // Label 8563: @507405
     /*  507405 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(507480), // Rule ID 4729 //
     /*  507410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  507413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  507456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  507459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  507475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507478 */     GIR_RootConstrainSelectedInstOperands,
     /*  507479 */     // GIR_Coverage, 4729,
     /*  507479 */     GIR_EraseRootFromParent_Done,
     /*  507480 */   // Label 8564: @507480
     /*  507480 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(507555), // Rule ID 4732 //
     /*  507485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  507488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  507496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  507499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  507502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507531 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  507531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  507534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507553 */     GIR_RootConstrainSelectedInstOperands,
     /*  507554 */     // GIR_Coverage, 4732,
     /*  507554 */     GIR_EraseRootFromParent_Done,
     /*  507555 */   // Label 8565: @507555
     /*  507555 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(507630), // Rule ID 4733 //
     /*  507560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  507563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  507571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  507574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  507577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  507606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  507609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507628 */     GIR_RootConstrainSelectedInstOperands,
     /*  507629 */     // GIR_Coverage, 4733,
     /*  507629 */     GIR_EraseRootFromParent_Done,
     /*  507630 */   // Label 8566: @507630
     /*  507630 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(507705), // Rule ID 4736 //
     /*  507635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  507638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  507646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  507649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  507652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  507681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  507684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507703 */     GIR_RootConstrainSelectedInstOperands,
     /*  507704 */     // GIR_Coverage, 4736,
     /*  507704 */     GIR_EraseRootFromParent_Done,
     /*  507705 */   // Label 8567: @507705
     /*  507705 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(507780), // Rule ID 4737 //
     /*  507710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  507713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  507721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  507724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  507727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  507756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  507759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507778 */     GIR_RootConstrainSelectedInstOperands,
     /*  507779 */     // GIR_Coverage, 4737,
     /*  507779 */     GIR_EraseRootFromParent_Done,
     /*  507780 */   // Label 8568: @507780
     /*  507780 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(507855), // Rule ID 4740 //
     /*  507785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  507788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  507796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  507799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  507802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507831 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  507831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  507834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507853 */     GIR_RootConstrainSelectedInstOperands,
     /*  507854 */     // GIR_Coverage, 4740,
     /*  507854 */     GIR_EraseRootFromParent_Done,
     /*  507855 */   // Label 8569: @507855
     /*  507855 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(507930), // Rule ID 4741 //
     /*  507860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  507863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  507871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  507874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  507877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  507883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  507906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  507909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  507928 */     GIR_RootConstrainSelectedInstOperands,
     /*  507929 */     // GIR_Coverage, 4741,
     /*  507929 */     GIR_EraseRootFromParent_Done,
     /*  507930 */   // Label 8570: @507930
     /*  507930 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(508005), // Rule ID 4744 //
     /*  507935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  507938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  507943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  507946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  507949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  507952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  507958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  507974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507981 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  507981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  507984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  507986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  507988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  507990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  507992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  508003 */     GIR_RootConstrainSelectedInstOperands,
     /*  508004 */     // GIR_Coverage, 4744,
     /*  508004 */     GIR_EraseRootFromParent_Done,
     /*  508005 */   // Label 8571: @508005
     /*  508005 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(508080), // Rule ID 4745 //
     /*  508010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  508013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  508018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  508021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  508024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  508027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  508049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  508056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  508059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  508063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  508065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  508067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  508078 */     GIR_RootConstrainSelectedInstOperands,
     /*  508079 */     // GIR_Coverage, 4745,
     /*  508079 */     GIR_EraseRootFromParent_Done,
     /*  508080 */   // Label 8572: @508080
     /*  508080 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(508152), // Rule ID 5098 //
     /*  508085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  508096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  508099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  508102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  508105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  508131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  508134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508150 */     GIR_RootConstrainSelectedInstOperands,
     /*  508151 */     // GIR_Coverage, 5098,
     /*  508151 */     GIR_EraseRootFromParent_Done,
     /*  508152 */   // Label 8573: @508152
     /*  508152 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(508224), // Rule ID 5099 //
     /*  508157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  508168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  508171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  508174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  508177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  508203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  508206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508222 */     GIR_RootConstrainSelectedInstOperands,
     /*  508223 */     // GIR_Coverage, 5099,
     /*  508223 */     GIR_EraseRootFromParent_Done,
     /*  508224 */   // Label 8574: @508224
     /*  508224 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(508296), // Rule ID 5100 //
     /*  508229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  508240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  508243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  508246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  508249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  508275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508294 */     GIR_RootConstrainSelectedInstOperands,
     /*  508295 */     // GIR_Coverage, 5100,
     /*  508295 */     GIR_EraseRootFromParent_Done,
     /*  508296 */   // Label 8575: @508296
     /*  508296 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(508368), // Rule ID 5101 //
     /*  508301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  508312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  508315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  508318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  508321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508347 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  508347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508366 */     GIR_RootConstrainSelectedInstOperands,
     /*  508367 */     // GIR_Coverage, 5101,
     /*  508367 */     GIR_EraseRootFromParent_Done,
     /*  508368 */   // Label 8576: @508368
     /*  508368 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(508440), // Rule ID 5102 //
     /*  508373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  508384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  508387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  508390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  508393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508419 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  508419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  508422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  508438 */     GIR_RootConstrainSelectedInstOperands,
     /*  508439 */     // GIR_Coverage, 5102,
     /*  508439 */     GIR_EraseRootFromParent_Done,
     /*  508440 */   // Label 8577: @508440
     /*  508440 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(508512), // Rule ID 5103 //
     /*  508445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  508456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  508459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  508462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  508465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  508491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  508494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  508510 */     GIR_RootConstrainSelectedInstOperands,
     /*  508511 */     // GIR_Coverage, 5103,
     /*  508511 */     GIR_EraseRootFromParent_Done,
     /*  508512 */   // Label 8578: @508512
     /*  508512 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(508584), // Rule ID 5104 //
     /*  508517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  508528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  508531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  508534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  508537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508563 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  508563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  508582 */     GIR_RootConstrainSelectedInstOperands,
     /*  508583 */     // GIR_Coverage, 5104,
     /*  508583 */     GIR_EraseRootFromParent_Done,
     /*  508584 */   // Label 8579: @508584
     /*  508584 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(508656), // Rule ID 5105 //
     /*  508589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  508600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  508603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  508606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  508609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  508635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  508654 */     GIR_RootConstrainSelectedInstOperands,
     /*  508655 */     // GIR_Coverage, 5105,
     /*  508655 */     GIR_EraseRootFromParent_Done,
     /*  508656 */   // Label 8580: @508656
     /*  508656 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(508728), // Rule ID 5106 //
     /*  508661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  508672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  508681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  508707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508726 */     GIR_RootConstrainSelectedInstOperands,
     /*  508727 */     // GIR_Coverage, 5106,
     /*  508727 */     GIR_EraseRootFromParent_Done,
     /*  508728 */   // Label 8581: @508728
     /*  508728 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(508800), // Rule ID 5107 //
     /*  508733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  508744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  508753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508779 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  508779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  508782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508798 */     GIR_RootConstrainSelectedInstOperands,
     /*  508799 */     // GIR_Coverage, 5107,
     /*  508799 */     GIR_EraseRootFromParent_Done,
     /*  508800 */   // Label 8582: @508800
     /*  508800 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(508872), // Rule ID 5108 //
     /*  508805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  508816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  508819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  508822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  508825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  508851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  508854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508870 */     GIR_RootConstrainSelectedInstOperands,
     /*  508871 */     // GIR_Coverage, 5108,
     /*  508871 */     GIR_EraseRootFromParent_Done,
     /*  508872 */   // Label 8583: @508872
     /*  508872 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(508944), // Rule ID 5109 //
     /*  508877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  508880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  508888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  508891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  508894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  508897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  508900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508923 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  508923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  508926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  508928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  508930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  508934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  508942 */     GIR_RootConstrainSelectedInstOperands,
     /*  508943 */     // GIR_Coverage, 5109,
     /*  508943 */     GIR_EraseRootFromParent_Done,
     /*  508944 */   // Label 8584: @508944
     /*  508944 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(509016), // Rule ID 5110 //
     /*  508949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  508952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  508957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  508960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  508963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  508966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  508969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  508972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  508988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508995 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  508995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  508998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  509014 */     GIR_RootConstrainSelectedInstOperands,
     /*  509015 */     // GIR_Coverage, 5110,
     /*  509015 */     GIR_EraseRootFromParent_Done,
     /*  509016 */   // Label 8585: @509016
     /*  509016 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(509088), // Rule ID 5111 //
     /*  509021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  509032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  509035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  509038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  509041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509067 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  509067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  509070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  509086 */     GIR_RootConstrainSelectedInstOperands,
     /*  509087 */     // GIR_Coverage, 5111,
     /*  509087 */     GIR_EraseRootFromParent_Done,
     /*  509088 */   // Label 8586: @509088
     /*  509088 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(509160), // Rule ID 5112 //
     /*  509093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  509104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  509113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  509139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  509142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509158 */     GIR_RootConstrainSelectedInstOperands,
     /*  509159 */     // GIR_Coverage, 5112,
     /*  509159 */     GIR_EraseRootFromParent_Done,
     /*  509160 */   // Label 8587: @509160
     /*  509160 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(509232), // Rule ID 5113 //
     /*  509165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  509176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  509185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509211 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  509211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  509214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509230 */     GIR_RootConstrainSelectedInstOperands,
     /*  509231 */     // GIR_Coverage, 5113,
     /*  509231 */     GIR_EraseRootFromParent_Done,
     /*  509232 */   // Label 8588: @509232
     /*  509232 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(509304), // Rule ID 5114 //
     /*  509237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  509240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  509248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  509251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  509254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  509257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  509283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  509286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  509302 */     GIR_RootConstrainSelectedInstOperands,
     /*  509303 */     // GIR_Coverage, 5114,
     /*  509303 */     GIR_EraseRootFromParent_Done,
     /*  509304 */   // Label 8589: @509304
     /*  509304 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(509376), // Rule ID 5115 //
     /*  509309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  509312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  509320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  509323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  509326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  509329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  509355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  509358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  509374 */     GIR_RootConstrainSelectedInstOperands,
     /*  509375 */     // GIR_Coverage, 5115,
     /*  509375 */     GIR_EraseRootFromParent_Done,
     /*  509376 */   // Label 8590: @509376
     /*  509376 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(509448), // Rule ID 5116 //
     /*  509381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  509392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  509395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  509398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  509401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509427 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  509427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  509430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509446 */     GIR_RootConstrainSelectedInstOperands,
     /*  509447 */     // GIR_Coverage, 5116,
     /*  509447 */     GIR_EraseRootFromParent_Done,
     /*  509448 */   // Label 8591: @509448
     /*  509448 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(509520), // Rule ID 5117 //
     /*  509453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  509464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  509467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  509470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  509473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509499 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  509499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  509502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509518 */     GIR_RootConstrainSelectedInstOperands,
     /*  509519 */     // GIR_Coverage, 5117,
     /*  509519 */     GIR_EraseRootFromParent_Done,
     /*  509520 */   // Label 8592: @509520
     /*  509520 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(509592), // Rule ID 5118 //
     /*  509525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  509536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  509539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  509542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  509545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509571 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  509571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  509574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509590 */     GIR_RootConstrainSelectedInstOperands,
     /*  509591 */     // GIR_Coverage, 5118,
     /*  509591 */     GIR_EraseRootFromParent_Done,
     /*  509592 */   // Label 8593: @509592
     /*  509592 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(509664), // Rule ID 5119 //
     /*  509597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  509608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  509611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  509614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  509617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509643 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  509643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  509646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509662 */     GIR_RootConstrainSelectedInstOperands,
     /*  509663 */     // GIR_Coverage, 5119,
     /*  509663 */     GIR_EraseRootFromParent_Done,
     /*  509664 */   // Label 8594: @509664
     /*  509664 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(509736), // Rule ID 5120 //
     /*  509669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  509680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  509683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  509686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  509689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509715 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  509715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  509718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509734 */     GIR_RootConstrainSelectedInstOperands,
     /*  509735 */     // GIR_Coverage, 5120,
     /*  509735 */     GIR_EraseRootFromParent_Done,
     /*  509736 */   // Label 8595: @509736
     /*  509736 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(509808), // Rule ID 5121 //
     /*  509741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  509752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  509755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  509758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  509761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509787 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  509787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  509790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  509806 */     GIR_RootConstrainSelectedInstOperands,
     /*  509807 */     // GIR_Coverage, 5121,
     /*  509807 */     GIR_EraseRootFromParent_Done,
     /*  509808 */   // Label 8596: @509808
     /*  509808 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(509880), // Rule ID 5122 //
     /*  509813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  509824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  509827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  509830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  509833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  509859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  509862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  509878 */     GIR_RootConstrainSelectedInstOperands,
     /*  509879 */     // GIR_Coverage, 5122,
     /*  509879 */     GIR_EraseRootFromParent_Done,
     /*  509880 */   // Label 8597: @509880
     /*  509880 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(509952), // Rule ID 5123 //
     /*  509885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  509888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  509896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  509899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  509902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  509905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  509908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509931 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  509931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  509934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  509936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  509938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  509942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  509950 */     GIR_RootConstrainSelectedInstOperands,
     /*  509951 */     // GIR_Coverage, 5123,
     /*  509951 */     GIR_EraseRootFromParent_Done,
     /*  509952 */   // Label 8598: @509952
     /*  509952 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(510024), // Rule ID 5124 //
     /*  509957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  509960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  509965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  509968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  509971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  509974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  509977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  509980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  509996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510003 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  510003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  510022 */     GIR_RootConstrainSelectedInstOperands,
     /*  510023 */     // GIR_Coverage, 5124,
     /*  510023 */     GIR_EraseRootFromParent_Done,
     /*  510024 */   // Label 8599: @510024
     /*  510024 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(510096), // Rule ID 5125 //
     /*  510029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  510032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  510040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  510043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  510046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  510049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510075 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  510075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  510094 */     GIR_RootConstrainSelectedInstOperands,
     /*  510095 */     // GIR_Coverage, 5125,
     /*  510095 */     GIR_EraseRootFromParent_Done,
     /*  510096 */   // Label 8600: @510096
     /*  510096 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(510168), // Rule ID 5126 //
     /*  510101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  510104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  510112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  510115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  510118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  510121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510147 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  510147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  510150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  510166 */     GIR_RootConstrainSelectedInstOperands,
     /*  510167 */     // GIR_Coverage, 5126,
     /*  510167 */     GIR_EraseRootFromParent_Done,
     /*  510168 */   // Label 8601: @510168
     /*  510168 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(510240), // Rule ID 5127 //
     /*  510173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  510176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  510184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  510187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  510190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  510193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510219 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  510219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  510222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  510238 */     GIR_RootConstrainSelectedInstOperands,
     /*  510239 */     // GIR_Coverage, 5127,
     /*  510239 */     GIR_EraseRootFromParent_Done,
     /*  510240 */   // Label 8602: @510240
     /*  510240 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(510312), // Rule ID 5128 //
     /*  510245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  510248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  510256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  510265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  510291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  510294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510310 */     GIR_RootConstrainSelectedInstOperands,
     /*  510311 */     // GIR_Coverage, 5128,
     /*  510311 */     GIR_EraseRootFromParent_Done,
     /*  510312 */   // Label 8603: @510312
     /*  510312 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(510384), // Rule ID 5129 //
     /*  510317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  510320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  510328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  510337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  510363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  510366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510382 */     GIR_RootConstrainSelectedInstOperands,
     /*  510383 */     // GIR_Coverage, 5129,
     /*  510383 */     GIR_EraseRootFromParent_Done,
     /*  510384 */   // Label 8604: @510384
     /*  510384 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(510456), // Rule ID 5130 //
     /*  510389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  510392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  510400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  510409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  510435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510454 */     GIR_RootConstrainSelectedInstOperands,
     /*  510455 */     // GIR_Coverage, 5130,
     /*  510455 */     GIR_EraseRootFromParent_Done,
     /*  510456 */   // Label 8605: @510456
     /*  510456 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(510528), // Rule ID 5131 //
     /*  510461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  510464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  510472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  510481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510507 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  510507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510526 */     GIR_RootConstrainSelectedInstOperands,
     /*  510527 */     // GIR_Coverage, 5131,
     /*  510527 */     GIR_EraseRootFromParent_Done,
     /*  510528 */   // Label 8606: @510528
     /*  510528 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(510600), // Rule ID 5132 //
     /*  510533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  510536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  510544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  510550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  510553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  510579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  510582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510598 */     GIR_RootConstrainSelectedInstOperands,
     /*  510599 */     // GIR_Coverage, 5132,
     /*  510599 */     GIR_EraseRootFromParent_Done,
     /*  510600 */   // Label 8607: @510600
     /*  510600 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(510672), // Rule ID 5133 //
     /*  510605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  510608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  510616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  510622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  510625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  510651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  510654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510670 */     GIR_RootConstrainSelectedInstOperands,
     /*  510671 */     // GIR_Coverage, 5133,
     /*  510671 */     GIR_EraseRootFromParent_Done,
     /*  510672 */   // Label 8608: @510672
     /*  510672 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(510744), // Rule ID 5134 //
     /*  510677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  510680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  510688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  510691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  510694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  510697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  510723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  510726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  510742 */     GIR_RootConstrainSelectedInstOperands,
     /*  510743 */     // GIR_Coverage, 5134,
     /*  510743 */     GIR_EraseRootFromParent_Done,
     /*  510744 */   // Label 8609: @510744
     /*  510744 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(510816), // Rule ID 5135 //
     /*  510749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  510752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  510760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  510763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  510766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  510769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510795 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  510795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  510798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  510814 */     GIR_RootConstrainSelectedInstOperands,
     /*  510815 */     // GIR_Coverage, 5135,
     /*  510815 */     GIR_EraseRootFromParent_Done,
     /*  510816 */   // Label 8610: @510816
     /*  510816 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(510888), // Rule ID 5136 //
     /*  510821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  510824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  510832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  510835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  510838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  510841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510867 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  510867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  510886 */     GIR_RootConstrainSelectedInstOperands,
     /*  510887 */     // GIR_Coverage, 5136,
     /*  510887 */     GIR_EraseRootFromParent_Done,
     /*  510888 */   // Label 8611: @510888
     /*  510888 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(510960), // Rule ID 5137 //
     /*  510893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  510896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  510904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  510907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  510910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  510913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  510916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  510932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510939 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  510939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  510942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  510944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  510946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  510950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  510958 */     GIR_RootConstrainSelectedInstOperands,
     /*  510959 */     // GIR_Coverage, 5137,
     /*  510959 */     GIR_EraseRootFromParent_Done,
     /*  510960 */   // Label 8612: @510960
     /*  510960 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(511032), // Rule ID 5138 //
     /*  510965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  510968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  510973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  510976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  510979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  510982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  510985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  510988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511011 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  511011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  511014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  511030 */     GIR_RootConstrainSelectedInstOperands,
     /*  511031 */     // GIR_Coverage, 5138,
     /*  511031 */     GIR_EraseRootFromParent_Done,
     /*  511032 */   // Label 8613: @511032
     /*  511032 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(511104), // Rule ID 5139 //
     /*  511037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  511040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  511048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  511051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  511054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  511057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511083 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  511083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  511086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  511102 */     GIR_RootConstrainSelectedInstOperands,
     /*  511103 */     // GIR_Coverage, 5139,
     /*  511103 */     GIR_EraseRootFromParent_Done,
     /*  511104 */   // Label 8614: @511104
     /*  511104 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(511176), // Rule ID 5140 //
     /*  511109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  511123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  511155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  511158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511174 */     GIR_RootConstrainSelectedInstOperands,
     /*  511175 */     // GIR_Coverage, 5140,
     /*  511175 */     GIR_EraseRootFromParent_Done,
     /*  511176 */   // Label 8615: @511176
     /*  511176 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(511248), // Rule ID 5141 //
     /*  511181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  511195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  511227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  511230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511246 */     GIR_RootConstrainSelectedInstOperands,
     /*  511247 */     // GIR_Coverage, 5141,
     /*  511247 */     GIR_EraseRootFromParent_Done,
     /*  511248 */   // Label 8616: @511248
     /*  511248 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(511320), // Rule ID 5142 //
     /*  511253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  511264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  511267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  511273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511299 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  511299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  511302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511318 */     GIR_RootConstrainSelectedInstOperands,
     /*  511319 */     // GIR_Coverage, 5142,
     /*  511319 */     GIR_EraseRootFromParent_Done,
     /*  511320 */   // Label 8617: @511320
     /*  511320 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(511392), // Rule ID 5143 //
     /*  511325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  511336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  511339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  511345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511371 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  511371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  511374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511390 */     GIR_RootConstrainSelectedInstOperands,
     /*  511391 */     // GIR_Coverage, 5143,
     /*  511391 */     GIR_EraseRootFromParent_Done,
     /*  511392 */   // Label 8618: @511392
     /*  511392 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(511464), // Rule ID 5144 //
     /*  511397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  511408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  511411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  511417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  511443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511462 */     GIR_RootConstrainSelectedInstOperands,
     /*  511463 */     // GIR_Coverage, 5144,
     /*  511463 */     GIR_EraseRootFromParent_Done,
     /*  511464 */   // Label 8619: @511464
     /*  511464 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(511536), // Rule ID 5145 //
     /*  511469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  511480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  511483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  511489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511515 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  511515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  511534 */     GIR_RootConstrainSelectedInstOperands,
     /*  511535 */     // GIR_Coverage, 5145,
     /*  511535 */     GIR_EraseRootFromParent_Done,
     /*  511536 */   // Label 8620: @511536
     /*  511536 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(511608), // Rule ID 5146 //
     /*  511541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  511555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  511587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  511590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  511606 */     GIR_RootConstrainSelectedInstOperands,
     /*  511607 */     // GIR_Coverage, 5146,
     /*  511607 */     GIR_EraseRootFromParent_Done,
     /*  511608 */   // Label 8621: @511608
     /*  511608 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(511680), // Rule ID 5147 //
     /*  511613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  511627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511659 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  511659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  511662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  511678 */     GIR_RootConstrainSelectedInstOperands,
     /*  511679 */     // GIR_Coverage, 5147,
     /*  511679 */     GIR_EraseRootFromParent_Done,
     /*  511680 */   // Label 8622: @511680
     /*  511680 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(511752), // Rule ID 5148 //
     /*  511685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  511696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  511699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  511705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511731 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  511731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  511750 */     GIR_RootConstrainSelectedInstOperands,
     /*  511751 */     // GIR_Coverage, 5148,
     /*  511751 */     GIR_EraseRootFromParent_Done,
     /*  511752 */   // Label 8623: @511752
     /*  511752 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(511824), // Rule ID 5149 //
     /*  511757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  511768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  511771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  511777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511803 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  511803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  511822 */     GIR_RootConstrainSelectedInstOperands,
     /*  511823 */     // GIR_Coverage, 5149,
     /*  511823 */     GIR_EraseRootFromParent_Done,
     /*  511824 */   // Label 8624: @511824
     /*  511824 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(511896), // Rule ID 5150 //
     /*  511829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  511875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511894 */     GIR_RootConstrainSelectedInstOperands,
     /*  511895 */     // GIR_Coverage, 5150,
     /*  511895 */     GIR_EraseRootFromParent_Done,
     /*  511896 */   // Label 8625: @511896
     /*  511896 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(511968), // Rule ID 5151 //
     /*  511901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  511904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  511912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  511918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  511921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  511924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  511936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  511940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511947 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  511947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  511950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  511952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  511954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  511958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511966 */     GIR_RootConstrainSelectedInstOperands,
     /*  511967 */     // GIR_Coverage, 5151,
     /*  511967 */     GIR_EraseRootFromParent_Done,
     /*  511968 */   // Label 8626: @511968
     /*  511968 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(512040), // Rule ID 5152 //
     /*  511973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  511976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  511981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  511984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  511987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  511990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  511993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  511996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512019 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  512019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512038 */     GIR_RootConstrainSelectedInstOperands,
     /*  512039 */     // GIR_Coverage, 5152,
     /*  512039 */     GIR_EraseRootFromParent_Done,
     /*  512040 */   // Label 8627: @512040
     /*  512040 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(512112), // Rule ID 5153 //
     /*  512045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  512056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  512059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  512065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  512091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512110 */     GIR_RootConstrainSelectedInstOperands,
     /*  512111 */     // GIR_Coverage, 5153,
     /*  512111 */     GIR_EraseRootFromParent_Done,
     /*  512112 */   // Label 8628: @512112
     /*  512112 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(512184), // Rule ID 5154 //
     /*  512117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  512128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  512131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  512137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512163 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  512163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  512182 */     GIR_RootConstrainSelectedInstOperands,
     /*  512183 */     // GIR_Coverage, 5154,
     /*  512183 */     GIR_EraseRootFromParent_Done,
     /*  512184 */   // Label 8629: @512184
     /*  512184 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(512256), // Rule ID 5155 //
     /*  512189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  512200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  512203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  512209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512235 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  512235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  512254 */     GIR_RootConstrainSelectedInstOperands,
     /*  512255 */     // GIR_Coverage, 5155,
     /*  512255 */     GIR_EraseRootFromParent_Done,
     /*  512256 */   // Label 8630: @512256
     /*  512256 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(512328), // Rule ID 5156 //
     /*  512261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  512272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  512281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  512307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512326 */     GIR_RootConstrainSelectedInstOperands,
     /*  512327 */     // GIR_Coverage, 5156,
     /*  512327 */     GIR_EraseRootFromParent_Done,
     /*  512328 */   // Label 8631: @512328
     /*  512328 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(512400), // Rule ID 5157 //
     /*  512333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  512344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  512353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  512379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512398 */     GIR_RootConstrainSelectedInstOperands,
     /*  512399 */     // GIR_Coverage, 5157,
     /*  512399 */     GIR_EraseRootFromParent_Done,
     /*  512400 */   // Label 8632: @512400
     /*  512400 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(512472), // Rule ID 5158 //
     /*  512405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  512408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  512416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  512419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  512425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512451 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  512451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  512470 */     GIR_RootConstrainSelectedInstOperands,
     /*  512471 */     // GIR_Coverage, 5158,
     /*  512471 */     GIR_EraseRootFromParent_Done,
     /*  512472 */   // Label 8633: @512472
     /*  512472 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(512544), // Rule ID 5159 //
     /*  512477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  512480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  512488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  512491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  512497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512523 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  512523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  512526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  512542 */     GIR_RootConstrainSelectedInstOperands,
     /*  512543 */     // GIR_Coverage, 5159,
     /*  512543 */     GIR_EraseRootFromParent_Done,
     /*  512544 */   // Label 8634: @512544
     /*  512544 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(512616), // Rule ID 5160 //
     /*  512549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  512560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  512563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  512569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512595 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  512595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  512598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512614 */     GIR_RootConstrainSelectedInstOperands,
     /*  512615 */     // GIR_Coverage, 5160,
     /*  512615 */     GIR_EraseRootFromParent_Done,
     /*  512616 */   // Label 8635: @512616
     /*  512616 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(512688), // Rule ID 5161 //
     /*  512621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  512632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  512635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  512641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512667 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  512667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  512670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512686 */     GIR_RootConstrainSelectedInstOperands,
     /*  512687 */     // GIR_Coverage, 5161,
     /*  512687 */     GIR_EraseRootFromParent_Done,
     /*  512688 */   // Label 8636: @512688
     /*  512688 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(512760), // Rule ID 5162 //
     /*  512693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  512704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  512707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  512713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512739 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  512739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  512742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512758 */     GIR_RootConstrainSelectedInstOperands,
     /*  512759 */     // GIR_Coverage, 5162,
     /*  512759 */     GIR_EraseRootFromParent_Done,
     /*  512760 */   // Label 8637: @512760
     /*  512760 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(512832), // Rule ID 5163 //
     /*  512765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  512776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  512779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  512785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512811 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  512811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  512814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512830 */     GIR_RootConstrainSelectedInstOperands,
     /*  512831 */     // GIR_Coverage, 5163,
     /*  512831 */     GIR_EraseRootFromParent_Done,
     /*  512832 */   // Label 8638: @512832
     /*  512832 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(512904), // Rule ID 5164 //
     /*  512837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  512848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  512851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  512857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  512860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512883 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  512883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  512886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512902 */     GIR_RootConstrainSelectedInstOperands,
     /*  512903 */     // GIR_Coverage, 5164,
     /*  512903 */     GIR_EraseRootFromParent_Done,
     /*  512904 */   // Label 8639: @512904
     /*  512904 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(512976), // Rule ID 5165 //
     /*  512909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  512912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  512920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  512923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  512926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  512929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  512932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  512944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  512948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512955 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  512955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  512958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  512960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  512962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  512966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  512974 */     GIR_RootConstrainSelectedInstOperands,
     /*  512975 */     // GIR_Coverage, 5165,
     /*  512975 */     GIR_EraseRootFromParent_Done,
     /*  512976 */   // Label 8640: @512976
     /*  512976 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(513048), // Rule ID 5166 //
     /*  512981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  512984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  512989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  512992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  512995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  512998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  513001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  513027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513046 */     GIR_RootConstrainSelectedInstOperands,
     /*  513047 */     // GIR_Coverage, 5166,
     /*  513047 */     GIR_EraseRootFromParent_Done,
     /*  513048 */   // Label 8641: @513048
     /*  513048 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(513120), // Rule ID 5167 //
     /*  513053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  513064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  513067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  513073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  513099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513118 */     GIR_RootConstrainSelectedInstOperands,
     /*  513119 */     // GIR_Coverage, 5167,
     /*  513119 */     GIR_EraseRootFromParent_Done,
     /*  513120 */   // Label 8642: @513120
     /*  513120 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(513192), // Rule ID 5168 //
     /*  513125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  513128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  513136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  513139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  513145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513171 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  513171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  513174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513190 */     GIR_RootConstrainSelectedInstOperands,
     /*  513191 */     // GIR_Coverage, 5168,
     /*  513191 */     GIR_EraseRootFromParent_Done,
     /*  513192 */   // Label 8643: @513192
     /*  513192 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(513264), // Rule ID 5169 //
     /*  513197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  513208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  513211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  513217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513243 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  513243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  513246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513262 */     GIR_RootConstrainSelectedInstOperands,
     /*  513263 */     // GIR_Coverage, 5169,
     /*  513263 */     GIR_EraseRootFromParent_Done,
     /*  513264 */   // Label 8644: @513264
     /*  513264 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(513336), // Rule ID 5170 //
     /*  513269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  513272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  513280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  513283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  513289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513315 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  513315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  513318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513334 */     GIR_RootConstrainSelectedInstOperands,
     /*  513335 */     // GIR_Coverage, 5170,
     /*  513335 */     GIR_EraseRootFromParent_Done,
     /*  513336 */   // Label 8645: @513336
     /*  513336 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(513408), // Rule ID 5171 //
     /*  513341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  513352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  513355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  513361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513387 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  513387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  513390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513406 */     GIR_RootConstrainSelectedInstOperands,
     /*  513407 */     // GIR_Coverage, 5171,
     /*  513407 */     GIR_EraseRootFromParent_Done,
     /*  513408 */   // Label 8646: @513408
     /*  513408 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(513480), // Rule ID 5172 //
     /*  513413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  513416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  513424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  513433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513459 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  513459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513478 */     GIR_RootConstrainSelectedInstOperands,
     /*  513479 */     // GIR_Coverage, 5172,
     /*  513479 */     GIR_EraseRootFromParent_Done,
     /*  513480 */   // Label 8647: @513480
     /*  513480 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(513552), // Rule ID 5173 //
     /*  513485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  513496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  513505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513531 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  513531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513550 */     GIR_RootConstrainSelectedInstOperands,
     /*  513551 */     // GIR_Coverage, 5173,
     /*  513551 */     GIR_EraseRootFromParent_Done,
     /*  513552 */   // Label 8648: @513552
     /*  513552 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(513624), // Rule ID 5174 //
     /*  513557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  513560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  513568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  513577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  513603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  513606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513622 */     GIR_RootConstrainSelectedInstOperands,
     /*  513623 */     // GIR_Coverage, 5174,
     /*  513623 */     GIR_EraseRootFromParent_Done,
     /*  513624 */   // Label 8649: @513624
     /*  513624 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(513696), // Rule ID 5175 //
     /*  513629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  513640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  513649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  513675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  513678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513694 */     GIR_RootConstrainSelectedInstOperands,
     /*  513695 */     // GIR_Coverage, 5175,
     /*  513695 */     GIR_EraseRootFromParent_Done,
     /*  513696 */   // Label 8650: @513696
     /*  513696 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(513768), // Rule ID 5176 //
     /*  513701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  513704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  513712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  513721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513747 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  513747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  513750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513766 */     GIR_RootConstrainSelectedInstOperands,
     /*  513767 */     // GIR_Coverage, 5176,
     /*  513767 */     GIR_EraseRootFromParent_Done,
     /*  513768 */   // Label 8651: @513768
     /*  513768 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(513840), // Rule ID 5177 //
     /*  513773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  513776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  513784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  513793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  513819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  513822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513838 */     GIR_RootConstrainSelectedInstOperands,
     /*  513839 */     // GIR_Coverage, 5177,
     /*  513839 */     GIR_EraseRootFromParent_Done,
     /*  513840 */   // Label 8652: @513840
     /*  513840 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(513912), // Rule ID 5178 //
     /*  513845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  513848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  513856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  513859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  513862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  513865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513891 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  513891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  513910 */     GIR_RootConstrainSelectedInstOperands,
     /*  513911 */     // GIR_Coverage, 5178,
     /*  513911 */     GIR_EraseRootFromParent_Done,
     /*  513912 */   // Label 8653: @513912
     /*  513912 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(513984), // Rule ID 5179 //
     /*  513917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  513920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  513928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  513931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  513934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  513937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  513952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  513956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  513963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  513966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  513970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  513974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  513982 */     GIR_RootConstrainSelectedInstOperands,
     /*  513983 */     // GIR_Coverage, 5179,
     /*  513983 */     GIR_EraseRootFromParent_Done,
     /*  513984 */   // Label 8654: @513984
     /*  513984 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(514056), // Rule ID 5180 //
     /*  513989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  513992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  513997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  514000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  514003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  514006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  514009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  514024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  514035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  514038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514054 */     GIR_RootConstrainSelectedInstOperands,
     /*  514055 */     // GIR_Coverage, 5180,
     /*  514055 */     GIR_EraseRootFromParent_Done,
     /*  514056 */   // Label 8655: @514056
     /*  514056 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(514128), // Rule ID 5181 //
     /*  514061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  514064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  514069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  514072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  514075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  514078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  514081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  514096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514107 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  514107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  514110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514126 */     GIR_RootConstrainSelectedInstOperands,
     /*  514127 */     // GIR_Coverage, 5181,
     /*  514127 */     GIR_EraseRootFromParent_Done,
     /*  514128 */   // Label 8656: @514128
     /*  514128 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(514200), // Rule ID 5182 //
     /*  514133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  514136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  514141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  514144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  514147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  514150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  514153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  514168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  514179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  514182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514198 */     GIR_RootConstrainSelectedInstOperands,
     /*  514199 */     // GIR_Coverage, 5182,
     /*  514199 */     GIR_EraseRootFromParent_Done,
     /*  514200 */   // Label 8657: @514200
     /*  514200 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(514272), // Rule ID 5183 //
     /*  514205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  514208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  514213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  514216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  514219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  514222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  514225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  514240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514251 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  514251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  514254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514270 */     GIR_RootConstrainSelectedInstOperands,
     /*  514271 */     // GIR_Coverage, 5183,
     /*  514271 */     GIR_EraseRootFromParent_Done,
     /*  514272 */   // Label 8658: @514272
     /*  514272 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(514344), // Rule ID 5446 //
     /*  514277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  514280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  514288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  514291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  514294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  514297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514323 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  514323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  514326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514342 */     GIR_RootConstrainSelectedInstOperands,
     /*  514343 */     // GIR_Coverage, 5446,
     /*  514343 */     GIR_EraseRootFromParent_Done,
     /*  514344 */   // Label 8659: @514344
     /*  514344 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(514416), // Rule ID 5447 //
     /*  514349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  514352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  514360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  514363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  514366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  514369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514395 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  514395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  514398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514414 */     GIR_RootConstrainSelectedInstOperands,
     /*  514415 */     // GIR_Coverage, 5447,
     /*  514415 */     GIR_EraseRootFromParent_Done,
     /*  514416 */   // Label 8660: @514416
     /*  514416 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(514488), // Rule ID 5448 //
     /*  514421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  514424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  514432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  514435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  514438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  514441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514467 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  514467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  514470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514486 */     GIR_RootConstrainSelectedInstOperands,
     /*  514487 */     // GIR_Coverage, 5448,
     /*  514487 */     GIR_EraseRootFromParent_Done,
     /*  514488 */   // Label 8661: @514488
     /*  514488 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(514560), // Rule ID 5449 //
     /*  514493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  514496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  514504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  514507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  514510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  514513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  514539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  514542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514558 */     GIR_RootConstrainSelectedInstOperands,
     /*  514559 */     // GIR_Coverage, 5449,
     /*  514559 */     GIR_EraseRootFromParent_Done,
     /*  514560 */   // Label 8662: @514560
     /*  514560 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(514632), // Rule ID 5450 //
     /*  514565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  514568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  514576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  514579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  514582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  514585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514611 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  514611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  514614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514630 */     GIR_RootConstrainSelectedInstOperands,
     /*  514631 */     // GIR_Coverage, 5450,
     /*  514631 */     GIR_EraseRootFromParent_Done,
     /*  514632 */   // Label 8663: @514632
     /*  514632 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(514704), // Rule ID 5451 //
     /*  514637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  514640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  514648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  514651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  514654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  514657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  514683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  514686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  514702 */     GIR_RootConstrainSelectedInstOperands,
     /*  514703 */     // GIR_Coverage, 5451,
     /*  514703 */     GIR_EraseRootFromParent_Done,
     /*  514704 */   // Label 8664: @514704
     /*  514704 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(514776), // Rule ID 5452 //
     /*  514709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  514712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  514720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  514729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514755 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  514755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  514758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514774 */     GIR_RootConstrainSelectedInstOperands,
     /*  514775 */     // GIR_Coverage, 5452,
     /*  514775 */     GIR_EraseRootFromParent_Done,
     /*  514776 */   // Label 8665: @514776
     /*  514776 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(514848), // Rule ID 5453 //
     /*  514781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  514784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  514792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  514801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514827 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  514827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  514830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514846 */     GIR_RootConstrainSelectedInstOperands,
     /*  514847 */     // GIR_Coverage, 5453,
     /*  514847 */     GIR_EraseRootFromParent_Done,
     /*  514848 */   // Label 8666: @514848
     /*  514848 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(514920), // Rule ID 5454 //
     /*  514853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  514856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  514864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  514873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514899 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  514899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  514902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514918 */     GIR_RootConstrainSelectedInstOperands,
     /*  514919 */     // GIR_Coverage, 5454,
     /*  514919 */     GIR_EraseRootFromParent_Done,
     /*  514920 */   // Label 8667: @514920
     /*  514920 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(514992), // Rule ID 5455 //
     /*  514925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  514928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  514933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  514936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  514945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  514964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514971 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  514971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  514974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  514978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  514982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514990 */     GIR_RootConstrainSelectedInstOperands,
     /*  514991 */     // GIR_Coverage, 5455,
     /*  514991 */     GIR_EraseRootFromParent_Done,
     /*  514992 */   // Label 8668: @514992
     /*  514992 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(515064), // Rule ID 5456 //
     /*  514997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  515008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  515017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515043 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  515043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  515046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515062 */     GIR_RootConstrainSelectedInstOperands,
     /*  515063 */     // GIR_Coverage, 5456,
     /*  515063 */     GIR_EraseRootFromParent_Done,
     /*  515064 */   // Label 8669: @515064
     /*  515064 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(515136), // Rule ID 5457 //
     /*  515069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  515080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  515089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  515115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  515118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515134 */     GIR_RootConstrainSelectedInstOperands,
     /*  515135 */     // GIR_Coverage, 5457,
     /*  515135 */     GIR_EraseRootFromParent_Done,
     /*  515136 */   // Label 8670: @515136
     /*  515136 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(515208), // Rule ID 5458 //
     /*  515141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  515152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  515155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  515158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  515161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  515187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515206 */     GIR_RootConstrainSelectedInstOperands,
     /*  515207 */     // GIR_Coverage, 5458,
     /*  515207 */     GIR_EraseRootFromParent_Done,
     /*  515208 */   // Label 8671: @515208
     /*  515208 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(515280), // Rule ID 5459 //
     /*  515213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  515224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  515227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  515230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  515233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  515259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515278 */     GIR_RootConstrainSelectedInstOperands,
     /*  515279 */     // GIR_Coverage, 5459,
     /*  515279 */     GIR_EraseRootFromParent_Done,
     /*  515280 */   // Label 8672: @515280
     /*  515280 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(515352), // Rule ID 5460 //
     /*  515285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  515296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  515305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515331 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  515331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515350 */     GIR_RootConstrainSelectedInstOperands,
     /*  515351 */     // GIR_Coverage, 5460,
     /*  515351 */     GIR_EraseRootFromParent_Done,
     /*  515352 */   // Label 8673: @515352
     /*  515352 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(515424), // Rule ID 5461 //
     /*  515357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  515368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  515377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515403 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  515403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515422 */     GIR_RootConstrainSelectedInstOperands,
     /*  515423 */     // GIR_Coverage, 5461,
     /*  515423 */     GIR_EraseRootFromParent_Done,
     /*  515424 */   // Label 8674: @515424
     /*  515424 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(515496), // Rule ID 5462 //
     /*  515429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  515440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  515449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515475 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  515475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515494 */     GIR_RootConstrainSelectedInstOperands,
     /*  515495 */     // GIR_Coverage, 5462,
     /*  515495 */     GIR_EraseRootFromParent_Done,
     /*  515496 */   // Label 8675: @515496
     /*  515496 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(515568), // Rule ID 5463 //
     /*  515501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  515512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  515521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  515547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515566 */     GIR_RootConstrainSelectedInstOperands,
     /*  515567 */     // GIR_Coverage, 5463,
     /*  515567 */     GIR_EraseRootFromParent_Done,
     /*  515568 */   // Label 8676: @515568
     /*  515568 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(515640), // Rule ID 5464 //
     /*  515573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  515576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  515584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  515593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515619 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  515619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515638 */     GIR_RootConstrainSelectedInstOperands,
     /*  515639 */     // GIR_Coverage, 5464,
     /*  515639 */     GIR_EraseRootFromParent_Done,
     /*  515640 */   // Label 8677: @515640
     /*  515640 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(515712), // Rule ID 5465 //
     /*  515645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  515648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  515656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  515665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515691 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  515691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  515694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515710 */     GIR_RootConstrainSelectedInstOperands,
     /*  515711 */     // GIR_Coverage, 5465,
     /*  515711 */     GIR_EraseRootFromParent_Done,
     /*  515712 */   // Label 8678: @515712
     /*  515712 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(515784), // Rule ID 5466 //
     /*  515717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  515728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  515731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  515734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  515737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515763 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  515763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  515766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515782 */     GIR_RootConstrainSelectedInstOperands,
     /*  515783 */     // GIR_Coverage, 5466,
     /*  515783 */     GIR_EraseRootFromParent_Done,
     /*  515784 */   // Label 8679: @515784
     /*  515784 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(515856), // Rule ID 5467 //
     /*  515789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  515800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  515803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  515806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  515809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515835 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  515835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  515838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515854 */     GIR_RootConstrainSelectedInstOperands,
     /*  515855 */     // GIR_Coverage, 5467,
     /*  515855 */     GIR_EraseRootFromParent_Done,
     /*  515856 */   // Label 8680: @515856
     /*  515856 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(515928), // Rule ID 5468 //
     /*  515861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  515864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  515872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  515875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  515878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  515881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515907 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  515907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  515910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515926 */     GIR_RootConstrainSelectedInstOperands,
     /*  515927 */     // GIR_Coverage, 5468,
     /*  515927 */     GIR_EraseRootFromParent_Done,
     /*  515928 */   // Label 8681: @515928
     /*  515928 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(516000), // Rule ID 5469 //
     /*  515933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  515936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  515941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  515944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  515947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  515950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  515953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  515972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515979 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  515979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  515982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  515986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  515990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  515998 */     GIR_RootConstrainSelectedInstOperands,
     /*  515999 */     // GIR_Coverage, 5469,
     /*  515999 */     GIR_EraseRootFromParent_Done,
     /*  516000 */   // Label 8682: @516000
     /*  516000 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(516072), // Rule ID 5470 //
     /*  516005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  516016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  516019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  516022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  516025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516051 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  516051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  516070 */     GIR_RootConstrainSelectedInstOperands,
     /*  516071 */     // GIR_Coverage, 5470,
     /*  516071 */     GIR_EraseRootFromParent_Done,
     /*  516072 */   // Label 8683: @516072
     /*  516072 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(516144), // Rule ID 5471 //
     /*  516077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  516088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  516091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  516094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  516097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516123 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  516123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  516142 */     GIR_RootConstrainSelectedInstOperands,
     /*  516143 */     // GIR_Coverage, 5471,
     /*  516143 */     GIR_EraseRootFromParent_Done,
     /*  516144 */   // Label 8684: @516144
     /*  516144 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(516216), // Rule ID 5472 //
     /*  516149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  516160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  516163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  516166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  516169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  516195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  516198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516214 */     GIR_RootConstrainSelectedInstOperands,
     /*  516215 */     // GIR_Coverage, 5472,
     /*  516215 */     GIR_EraseRootFromParent_Done,
     /*  516216 */   // Label 8685: @516216
     /*  516216 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(516288), // Rule ID 5473 //
     /*  516221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  516232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  516235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  516238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  516241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  516267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  516270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516286 */     GIR_RootConstrainSelectedInstOperands,
     /*  516287 */     // GIR_Coverage, 5473,
     /*  516287 */     GIR_EraseRootFromParent_Done,
     /*  516288 */   // Label 8686: @516288
     /*  516288 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(516360), // Rule ID 5474 //
     /*  516293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  516304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  516307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  516310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  516313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516339 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  516339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  516342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516358 */     GIR_RootConstrainSelectedInstOperands,
     /*  516359 */     // GIR_Coverage, 5474,
     /*  516359 */     GIR_EraseRootFromParent_Done,
     /*  516360 */   // Label 8687: @516360
     /*  516360 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(516432), // Rule ID 5475 //
     /*  516365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  516376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  516379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  516382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  516385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516411 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  516411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  516414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516430 */     GIR_RootConstrainSelectedInstOperands,
     /*  516431 */     // GIR_Coverage, 5475,
     /*  516431 */     GIR_EraseRootFromParent_Done,
     /*  516432 */   // Label 8688: @516432
     /*  516432 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(516504), // Rule ID 5476 //
     /*  516437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  516448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  516451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  516454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  516457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516483 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  516483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516502 */     GIR_RootConstrainSelectedInstOperands,
     /*  516503 */     // GIR_Coverage, 5476,
     /*  516503 */     GIR_EraseRootFromParent_Done,
     /*  516504 */   // Label 8689: @516504
     /*  516504 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(516576), // Rule ID 5477 //
     /*  516509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  516520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  516523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  516526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  516529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516555 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  516555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516574 */     GIR_RootConstrainSelectedInstOperands,
     /*  516575 */     // GIR_Coverage, 5477,
     /*  516575 */     GIR_EraseRootFromParent_Done,
     /*  516576 */   // Label 8690: @516576
     /*  516576 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(516648), // Rule ID 5478 //
     /*  516581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  516592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  516601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  516627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  516630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516646 */     GIR_RootConstrainSelectedInstOperands,
     /*  516647 */     // GIR_Coverage, 5478,
     /*  516647 */     GIR_EraseRootFromParent_Done,
     /*  516648 */   // Label 8691: @516648
     /*  516648 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(516720), // Rule ID 5479 //
     /*  516653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  516664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  516673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516699 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  516699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  516702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516718 */     GIR_RootConstrainSelectedInstOperands,
     /*  516719 */     // GIR_Coverage, 5479,
     /*  516719 */     GIR_EraseRootFromParent_Done,
     /*  516720 */   // Label 8692: @516720
     /*  516720 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(516792), // Rule ID 5480 //
     /*  516725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  516736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  516745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516771 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  516771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  516774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516790 */     GIR_RootConstrainSelectedInstOperands,
     /*  516791 */     // GIR_Coverage, 5480,
     /*  516791 */     GIR_EraseRootFromParent_Done,
     /*  516792 */   // Label 8693: @516792
     /*  516792 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(516864), // Rule ID 5481 //
     /*  516797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  516808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  516817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516843 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  516843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  516846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516862 */     GIR_RootConstrainSelectedInstOperands,
     /*  516863 */     // GIR_Coverage, 5481,
     /*  516863 */     GIR_EraseRootFromParent_Done,
     /*  516864 */   // Label 8694: @516864
     /*  516864 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(516936), // Rule ID 5482 //
     /*  516869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  516872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  516880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  516889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  516915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516934 */     GIR_RootConstrainSelectedInstOperands,
     /*  516935 */     // GIR_Coverage, 5482,
     /*  516935 */     GIR_EraseRootFromParent_Done,
     /*  516936 */   // Label 8695: @516936
     /*  516936 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(517008), // Rule ID 5483 //
     /*  516941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  516944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  516949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  516952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  516961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  516980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516987 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  516987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  516990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  516994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  516998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517006 */     GIR_RootConstrainSelectedInstOperands,
     /*  517007 */     // GIR_Coverage, 5483,
     /*  517007 */     GIR_EraseRootFromParent_Done,
     /*  517008 */   // Label 8696: @517008
     /*  517008 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(517080), // Rule ID 5484 //
     /*  517013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  517016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  517024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  517027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  517030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  517033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  517059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  517062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517078 */     GIR_RootConstrainSelectedInstOperands,
     /*  517079 */     // GIR_Coverage, 5484,
     /*  517079 */     GIR_EraseRootFromParent_Done,
     /*  517080 */   // Label 8697: @517080
     /*  517080 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(517152), // Rule ID 5485 //
     /*  517085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  517088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  517096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  517099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  517102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  517105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  517131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  517134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517150 */     GIR_RootConstrainSelectedInstOperands,
     /*  517151 */     // GIR_Coverage, 5485,
     /*  517151 */     GIR_EraseRootFromParent_Done,
     /*  517152 */   // Label 8698: @517152
     /*  517152 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(517224), // Rule ID 5486 //
     /*  517157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  517160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  517168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  517171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  517174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  517177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  517203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  517206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517222 */     GIR_RootConstrainSelectedInstOperands,
     /*  517223 */     // GIR_Coverage, 5486,
     /*  517223 */     GIR_EraseRootFromParent_Done,
     /*  517224 */   // Label 8699: @517224
     /*  517224 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(517296), // Rule ID 5487 //
     /*  517229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  517232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  517240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  517243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  517246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  517249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  517275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  517278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517294 */     GIR_RootConstrainSelectedInstOperands,
     /*  517295 */     // GIR_Coverage, 5487,
     /*  517295 */     GIR_EraseRootFromParent_Done,
     /*  517296 */   // Label 8700: @517296
     /*  517296 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(517368), // Rule ID 5488 //
     /*  517301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  517304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  517312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  517315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  517318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  517321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  517347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  517350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517366 */     GIR_RootConstrainSelectedInstOperands,
     /*  517367 */     // GIR_Coverage, 5488,
     /*  517367 */     GIR_EraseRootFromParent_Done,
     /*  517368 */   // Label 8701: @517368
     /*  517368 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(517440), // Rule ID 5489 //
     /*  517373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  517376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  517384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  517387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  517390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  517393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517419 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  517419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  517422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517438 */     GIR_RootConstrainSelectedInstOperands,
     /*  517439 */     // GIR_Coverage, 5489,
     /*  517439 */     GIR_EraseRootFromParent_Done,
     /*  517440 */   // Label 8702: @517440
     /*  517440 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(517512), // Rule ID 5490 //
     /*  517445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  517448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  517456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  517459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  517462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  517465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  517491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  517494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517510 */     GIR_RootConstrainSelectedInstOperands,
     /*  517511 */     // GIR_Coverage, 5490,
     /*  517511 */     GIR_EraseRootFromParent_Done,
     /*  517512 */   // Label 8703: @517512
     /*  517512 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(517584), // Rule ID 5491 //
     /*  517517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  517520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  517528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  517531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  517534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  517537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  517563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  517566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517582 */     GIR_RootConstrainSelectedInstOperands,
     /*  517583 */     // GIR_Coverage, 5491,
     /*  517583 */     GIR_EraseRootFromParent_Done,
     /*  517584 */   // Label 8704: @517584
     /*  517584 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(517656), // Rule ID 5492 //
     /*  517589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  517592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  517600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  517603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  517606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  517609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  517635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  517638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517654 */     GIR_RootConstrainSelectedInstOperands,
     /*  517655 */     // GIR_Coverage, 5492,
     /*  517655 */     GIR_EraseRootFromParent_Done,
     /*  517656 */   // Label 8705: @517656
     /*  517656 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(517728), // Rule ID 5493 //
     /*  517661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  517664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  517672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  517675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  517678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  517681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517707 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  517707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  517710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517726 */     GIR_RootConstrainSelectedInstOperands,
     /*  517727 */     // GIR_Coverage, 5493,
     /*  517727 */     GIR_EraseRootFromParent_Done,
     /*  517728 */   // Label 8706: @517728
     /*  517728 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(517800), // Rule ID 5494 //
     /*  517733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  517736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  517744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  517747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  517750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  517753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517779 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  517779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  517782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517798 */     GIR_RootConstrainSelectedInstOperands,
     /*  517799 */     // GIR_Coverage, 5494,
     /*  517799 */     GIR_EraseRootFromParent_Done,
     /*  517800 */   // Label 8707: @517800
     /*  517800 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(517872), // Rule ID 5495 //
     /*  517805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  517808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  517816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  517819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  517822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  517825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  517851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  517854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  517870 */     GIR_RootConstrainSelectedInstOperands,
     /*  517871 */     // GIR_Coverage, 5495,
     /*  517871 */     GIR_EraseRootFromParent_Done,
     /*  517872 */   // Label 8708: @517872
     /*  517872 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(517944), // Rule ID 5496 //
     /*  517877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  517880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  517888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  517891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  517894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  517897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517923 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  517923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  517926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  517930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  517934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517942 */     GIR_RootConstrainSelectedInstOperands,
     /*  517943 */     // GIR_Coverage, 5496,
     /*  517943 */     GIR_EraseRootFromParent_Done,
     /*  517944 */   // Label 8709: @517944
     /*  517944 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(518016), // Rule ID 5497 //
     /*  517949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  517952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  517957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  517960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  517963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  517966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  517969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  517984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  517988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517995 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  517995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  517998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518014 */     GIR_RootConstrainSelectedInstOperands,
     /*  518015 */     // GIR_Coverage, 5497,
     /*  518015 */     GIR_EraseRootFromParent_Done,
     /*  518016 */   // Label 8710: @518016
     /*  518016 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(518088), // Rule ID 5498 //
     /*  518021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  518032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  518041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518067 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  518067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  518070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518086 */     GIR_RootConstrainSelectedInstOperands,
     /*  518087 */     // GIR_Coverage, 5498,
     /*  518087 */     GIR_EraseRootFromParent_Done,
     /*  518088 */   // Label 8711: @518088
     /*  518088 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(518160), // Rule ID 5499 //
     /*  518093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  518104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  518113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  518139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  518142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518158 */     GIR_RootConstrainSelectedInstOperands,
     /*  518159 */     // GIR_Coverage, 5499,
     /*  518159 */     GIR_EraseRootFromParent_Done,
     /*  518160 */   // Label 8712: @518160
     /*  518160 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(518232), // Rule ID 5500 //
     /*  518165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  518176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  518185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  518211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  518214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518230 */     GIR_RootConstrainSelectedInstOperands,
     /*  518231 */     // GIR_Coverage, 5500,
     /*  518231 */     GIR_EraseRootFromParent_Done,
     /*  518232 */   // Label 8713: @518232
     /*  518232 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(518304), // Rule ID 5501 //
     /*  518237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  518248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  518257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  518283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  518286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518302 */     GIR_RootConstrainSelectedInstOperands,
     /*  518303 */     // GIR_Coverage, 5501,
     /*  518303 */     GIR_EraseRootFromParent_Done,
     /*  518304 */   // Label 8714: @518304
     /*  518304 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(518376), // Rule ID 5502 //
     /*  518309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  518320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  518323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  518329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  518355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  518374 */     GIR_RootConstrainSelectedInstOperands,
     /*  518375 */     // GIR_Coverage, 5502,
     /*  518375 */     GIR_EraseRootFromParent_Done,
     /*  518376 */   // Label 8715: @518376
     /*  518376 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(518448), // Rule ID 5503 //
     /*  518381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  518392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  518395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  518401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518427 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  518427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  518446 */     GIR_RootConstrainSelectedInstOperands,
     /*  518447 */     // GIR_Coverage, 5503,
     /*  518447 */     GIR_EraseRootFromParent_Done,
     /*  518448 */   // Label 8716: @518448
     /*  518448 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(518520), // Rule ID 5504 //
     /*  518453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  518464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  518473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  518499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518518 */     GIR_RootConstrainSelectedInstOperands,
     /*  518519 */     // GIR_Coverage, 5504,
     /*  518519 */     GIR_EraseRootFromParent_Done,
     /*  518520 */   // Label 8717: @518520
     /*  518520 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(518592), // Rule ID 5505 //
     /*  518525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  518536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  518545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  518571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518590 */     GIR_RootConstrainSelectedInstOperands,
     /*  518591 */     // GIR_Coverage, 5505,
     /*  518591 */     GIR_EraseRootFromParent_Done,
     /*  518592 */   // Label 8718: @518592
     /*  518592 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(518664), // Rule ID 5506 //
     /*  518597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  518608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  518617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  518643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518662 */     GIR_RootConstrainSelectedInstOperands,
     /*  518663 */     // GIR_Coverage, 5506,
     /*  518663 */     GIR_EraseRootFromParent_Done,
     /*  518664 */   // Label 8719: @518664
     /*  518664 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(518736), // Rule ID 5507 //
     /*  518669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  518680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  518689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  518715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518734 */     GIR_RootConstrainSelectedInstOperands,
     /*  518735 */     // GIR_Coverage, 5507,
     /*  518735 */     GIR_EraseRootFromParent_Done,
     /*  518736 */   // Label 8720: @518736
     /*  518736 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(518808), // Rule ID 5508 //
     /*  518741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  518744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  518752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  518761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  518787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518806 */     GIR_RootConstrainSelectedInstOperands,
     /*  518807 */     // GIR_Coverage, 5508,
     /*  518807 */     GIR_EraseRootFromParent_Done,
     /*  518808 */   // Label 8721: @518808
     /*  518808 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(518880), // Rule ID 5509 //
     /*  518813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  518816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  518824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  518833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  518859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  518862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518878 */     GIR_RootConstrainSelectedInstOperands,
     /*  518879 */     // GIR_Coverage, 5509,
     /*  518879 */     GIR_EraseRootFromParent_Done,
     /*  518880 */   // Label 8722: @518880
     /*  518880 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(518952), // Rule ID 5510 //
     /*  518885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  518888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  518896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  518899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  518902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  518905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518931 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  518931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  518934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  518938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  518942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  518950 */     GIR_RootConstrainSelectedInstOperands,
     /*  518951 */     // GIR_Coverage, 5510,
     /*  518951 */     GIR_EraseRootFromParent_Done,
     /*  518952 */   // Label 8723: @518952
     /*  518952 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(519024), // Rule ID 5511 //
     /*  518957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  518960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  518965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  518968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  518971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  518974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  518977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  518992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  518996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519003 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  519003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  519006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  519022 */     GIR_RootConstrainSelectedInstOperands,
     /*  519023 */     // GIR_Coverage, 5511,
     /*  519023 */     GIR_EraseRootFromParent_Done,
     /*  519024 */   // Label 8724: @519024
     /*  519024 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(519096), // Rule ID 5512 //
     /*  519029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  519040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  519043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  519049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519075 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  519075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  519078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  519094 */     GIR_RootConstrainSelectedInstOperands,
     /*  519095 */     // GIR_Coverage, 5512,
     /*  519095 */     GIR_EraseRootFromParent_Done,
     /*  519096 */   // Label 8725: @519096
     /*  519096 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(519168), // Rule ID 5513 //
     /*  519101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  519112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  519115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  519121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519147 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  519147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  519150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  519166 */     GIR_RootConstrainSelectedInstOperands,
     /*  519167 */     // GIR_Coverage, 5513,
     /*  519167 */     GIR_EraseRootFromParent_Done,
     /*  519168 */   // Label 8726: @519168
     /*  519168 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(519240), // Rule ID 5514 //
     /*  519173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  519184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  519187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  519193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519219 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  519219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  519222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  519238 */     GIR_RootConstrainSelectedInstOperands,
     /*  519239 */     // GIR_Coverage, 5514,
     /*  519239 */     GIR_EraseRootFromParent_Done,
     /*  519240 */   // Label 8727: @519240
     /*  519240 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(519312), // Rule ID 5515 //
     /*  519245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  519256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  519259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  519265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519291 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  519291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  519294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  519310 */     GIR_RootConstrainSelectedInstOperands,
     /*  519311 */     // GIR_Coverage, 5515,
     /*  519311 */     GIR_EraseRootFromParent_Done,
     /*  519312 */   // Label 8728: @519312
     /*  519312 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(519384), // Rule ID 5516 //
     /*  519317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  519328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  519337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  519363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  519366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519382 */     GIR_RootConstrainSelectedInstOperands,
     /*  519383 */     // GIR_Coverage, 5516,
     /*  519383 */     GIR_EraseRootFromParent_Done,
     /*  519384 */   // Label 8729: @519384
     /*  519384 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(519456), // Rule ID 5517 //
     /*  519389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  519400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  519409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  519435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  519438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519454 */     GIR_RootConstrainSelectedInstOperands,
     /*  519455 */     // GIR_Coverage, 5517,
     /*  519455 */     GIR_EraseRootFromParent_Done,
     /*  519456 */   // Label 8730: @519456
     /*  519456 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(519528), // Rule ID 5518 //
     /*  519461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  519472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  519481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519507 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  519507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  519510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519526 */     GIR_RootConstrainSelectedInstOperands,
     /*  519527 */     // GIR_Coverage, 5518,
     /*  519527 */     GIR_EraseRootFromParent_Done,
     /*  519528 */   // Label 8731: @519528
     /*  519528 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(519600), // Rule ID 5519 //
     /*  519533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  519544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  519553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  519579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  519582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519598 */     GIR_RootConstrainSelectedInstOperands,
     /*  519599 */     // GIR_Coverage, 5519,
     /*  519599 */     GIR_EraseRootFromParent_Done,
     /*  519600 */   // Label 8732: @519600
     /*  519600 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(519672), // Rule ID 5520 //
     /*  519605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  519616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  519625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519651 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  519651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  519654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519670 */     GIR_RootConstrainSelectedInstOperands,
     /*  519671 */     // GIR_Coverage, 5520,
     /*  519671 */     GIR_EraseRootFromParent_Done,
     /*  519672 */   // Label 8733: @519672
     /*  519672 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(519744), // Rule ID 5521 //
     /*  519677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  519688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  519697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519723 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  519723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  519726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519742 */     GIR_RootConstrainSelectedInstOperands,
     /*  519743 */     // GIR_Coverage, 5521,
     /*  519743 */     GIR_EraseRootFromParent_Done,
     /*  519744 */   // Label 8734: @519744
     /*  519744 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(519816), // Rule ID 5522 //
     /*  519749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  519760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  519769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519795 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  519795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  519798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519814 */     GIR_RootConstrainSelectedInstOperands,
     /*  519815 */     // GIR_Coverage, 5522,
     /*  519815 */     GIR_EraseRootFromParent_Done,
     /*  519816 */   // Label 8735: @519816
     /*  519816 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(519888), // Rule ID 5523 //
     /*  519821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  519832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  519841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519867 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  519867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  519870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519886 */     GIR_RootConstrainSelectedInstOperands,
     /*  519887 */     // GIR_Coverage, 5523,
     /*  519887 */     GIR_EraseRootFromParent_Done,
     /*  519888 */   // Label 8736: @519888
     /*  519888 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(519960), // Rule ID 5524 //
     /*  519893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  519896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  519904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  519910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  519913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  519928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  519932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519939 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  519939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  519942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  519946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  519950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519958 */     GIR_RootConstrainSelectedInstOperands,
     /*  519959 */     // GIR_Coverage, 5524,
     /*  519959 */     GIR_EraseRootFromParent_Done,
     /*  519960 */   // Label 8737: @519960
     /*  519960 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(520032), // Rule ID 5525 //
     /*  519965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  519968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  519973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  519976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  519982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  519985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520011 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  520011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  520014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520030 */     GIR_RootConstrainSelectedInstOperands,
     /*  520031 */     // GIR_Coverage, 5525,
     /*  520031 */     GIR_EraseRootFromParent_Done,
     /*  520032 */   // Label 8738: @520032
     /*  520032 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(520104), // Rule ID 5526 //
     /*  520037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  520040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  520048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  520054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  520057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  520083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  520086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520102 */     GIR_RootConstrainSelectedInstOperands,
     /*  520103 */     // GIR_Coverage, 5526,
     /*  520103 */     GIR_EraseRootFromParent_Done,
     /*  520104 */   // Label 8739: @520104
     /*  520104 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(520176), // Rule ID 5527 //
     /*  520109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  520112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  520120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  520126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  520129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  520155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  520158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520174 */     GIR_RootConstrainSelectedInstOperands,
     /*  520175 */     // GIR_Coverage, 5527,
     /*  520175 */     GIR_EraseRootFromParent_Done,
     /*  520176 */   // Label 8740: @520176
     /*  520176 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(520248), // Rule ID 5528 //
     /*  520181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  520184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  520192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  520198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  520201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520227 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  520227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  520230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520246 */     GIR_RootConstrainSelectedInstOperands,
     /*  520247 */     // GIR_Coverage, 5528,
     /*  520247 */     GIR_EraseRootFromParent_Done,
     /*  520248 */   // Label 8741: @520248
     /*  520248 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(520320), // Rule ID 5529 //
     /*  520253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  520256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  520264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  520270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  520273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520299 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  520299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  520302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520318 */     GIR_RootConstrainSelectedInstOperands,
     /*  520319 */     // GIR_Coverage, 5529,
     /*  520319 */     GIR_EraseRootFromParent_Done,
     /*  520320 */   // Label 8742: @520320
     /*  520320 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(520392), // Rule ID 5530 //
     /*  520325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  520328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  520336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  520342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  520345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520371 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  520371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  520374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520390 */     GIR_RootConstrainSelectedInstOperands,
     /*  520391 */     // GIR_Coverage, 5530,
     /*  520391 */     GIR_EraseRootFromParent_Done,
     /*  520392 */   // Label 8743: @520392
     /*  520392 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(520464), // Rule ID 5531 //
     /*  520397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  520400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  520408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  520414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  520417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  520443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  520446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520462 */     GIR_RootConstrainSelectedInstOperands,
     /*  520463 */     // GIR_Coverage, 5531,
     /*  520463 */     GIR_EraseRootFromParent_Done,
     /*  520464 */   // Label 8744: @520464
     /*  520464 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(520536), // Rule ID 5532 //
     /*  520469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  520472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  520480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  520486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  520489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  520515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  520518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520534 */     GIR_RootConstrainSelectedInstOperands,
     /*  520535 */     // GIR_Coverage, 5532,
     /*  520535 */     GIR_EraseRootFromParent_Done,
     /*  520536 */   // Label 8745: @520536
     /*  520536 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(520608), // Rule ID 5533 //
     /*  520541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  520544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  520549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  520552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  520558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  520561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  520576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  520580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520587 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  520587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  520590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  520594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  520598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520606 */     GIR_RootConstrainSelectedInstOperands,
     /*  520607 */     // GIR_Coverage, 5533,
     /*  520607 */     GIR_EraseRootFromParent_Done,
     /*  520608 */   // Label 8746: @520608
     /*  520608 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(520683), // Rule ID 5622 //
     /*  520613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  520616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  520624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  520627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  520630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  520633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  520659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  520662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  520668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  520670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  520678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520681 */     GIR_RootConstrainSelectedInstOperands,
     /*  520682 */     // GIR_Coverage, 5622,
     /*  520682 */     GIR_EraseRootFromParent_Done,
     /*  520683 */   // Label 8747: @520683
     /*  520683 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(520758), // Rule ID 5623 //
     /*  520688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  520691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  520699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  520702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  520705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  520708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  520734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  520737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  520743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  520745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  520753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520756 */     GIR_RootConstrainSelectedInstOperands,
     /*  520757 */     // GIR_Coverage, 5623,
     /*  520757 */     GIR_EraseRootFromParent_Done,
     /*  520758 */   // Label 8748: @520758
     /*  520758 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(520833), // Rule ID 5626 //
     /*  520763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  520766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  520774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  520777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  520780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  520783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  520809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  520812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  520818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  520820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  520828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520831 */     GIR_RootConstrainSelectedInstOperands,
     /*  520832 */     // GIR_Coverage, 5626,
     /*  520832 */     GIR_EraseRootFromParent_Done,
     /*  520833 */   // Label 8749: @520833
     /*  520833 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(520908), // Rule ID 5627 //
     /*  520838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  520841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  520849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  520852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  520855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  520858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  520884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  520887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  520893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  520895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  520903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520906 */     GIR_RootConstrainSelectedInstOperands,
     /*  520907 */     // GIR_Coverage, 5627,
     /*  520907 */     GIR_EraseRootFromParent_Done,
     /*  520908 */   // Label 8750: @520908
     /*  520908 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(520983), // Rule ID 5630 //
     /*  520913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  520916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  520924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  520927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  520930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  520933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  520959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  520962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  520968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  520970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  520978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520981 */     GIR_RootConstrainSelectedInstOperands,
     /*  520982 */     // GIR_Coverage, 5630,
     /*  520982 */     GIR_EraseRootFromParent_Done,
     /*  520983 */   // Label 8751: @520983
     /*  520983 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(521058), // Rule ID 5631 //
     /*  520988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  520991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  520996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  520999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  521002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  521005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  521008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  521034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  521037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  521053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521056 */     GIR_RootConstrainSelectedInstOperands,
     /*  521057 */     // GIR_Coverage, 5631,
     /*  521057 */     GIR_EraseRootFromParent_Done,
     /*  521058 */   // Label 8752: @521058
     /*  521058 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(521133), // Rule ID 5634 //
     /*  521063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  521083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  521112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521131 */     GIR_RootConstrainSelectedInstOperands,
     /*  521132 */     // GIR_Coverage, 5634,
     /*  521132 */     GIR_EraseRootFromParent_Done,
     /*  521133 */   // Label 8753: @521133
     /*  521133 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(521208), // Rule ID 5635 //
     /*  521138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  521158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  521187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521206 */     GIR_RootConstrainSelectedInstOperands,
     /*  521207 */     // GIR_Coverage, 5635,
     /*  521207 */     GIR_EraseRootFromParent_Done,
     /*  521208 */   // Label 8754: @521208
     /*  521208 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(521283), // Rule ID 5638 //
     /*  521213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  521233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  521262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521281 */     GIR_RootConstrainSelectedInstOperands,
     /*  521282 */     // GIR_Coverage, 5638,
     /*  521282 */     GIR_EraseRootFromParent_Done,
     /*  521283 */   // Label 8755: @521283
     /*  521283 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(521358), // Rule ID 5639 //
     /*  521288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  521308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  521337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521356 */     GIR_RootConstrainSelectedInstOperands,
     /*  521357 */     // GIR_Coverage, 5639,
     /*  521357 */     GIR_EraseRootFromParent_Done,
     /*  521358 */   // Label 8756: @521358
     /*  521358 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(521433), // Rule ID 5642 //
     /*  521363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  521383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  521412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521431 */     GIR_RootConstrainSelectedInstOperands,
     /*  521432 */     // GIR_Coverage, 5642,
     /*  521432 */     GIR_EraseRootFromParent_Done,
     /*  521433 */   // Label 8757: @521433
     /*  521433 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(521508), // Rule ID 5643 //
     /*  521438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  521458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  521487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521506 */     GIR_RootConstrainSelectedInstOperands,
     /*  521507 */     // GIR_Coverage, 5643,
     /*  521507 */     GIR_EraseRootFromParent_Done,
     /*  521508 */   // Label 8758: @521508
     /*  521508 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(521583), // Rule ID 5646 //
     /*  521513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  521524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  521527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  521530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  521533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521559 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  521559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  521578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521581 */     GIR_RootConstrainSelectedInstOperands,
     /*  521582 */     // GIR_Coverage, 5646,
     /*  521582 */     GIR_EraseRootFromParent_Done,
     /*  521583 */   // Label 8759: @521583
     /*  521583 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(521658), // Rule ID 5647 //
     /*  521588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  521599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  521602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  521605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  521608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  521634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  521653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521656 */     GIR_RootConstrainSelectedInstOperands,
     /*  521657 */     // GIR_Coverage, 5647,
     /*  521657 */     GIR_EraseRootFromParent_Done,
     /*  521658 */   // Label 8760: @521658
     /*  521658 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(521733), // Rule ID 5650 //
     /*  521663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  521683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521731 */     GIR_RootConstrainSelectedInstOperands,
     /*  521732 */     // GIR_Coverage, 5650,
     /*  521732 */     GIR_EraseRootFromParent_Done,
     /*  521733 */   // Label 8761: @521733
     /*  521733 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(521808), // Rule ID 5651 //
     /*  521738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  521758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521806 */     GIR_RootConstrainSelectedInstOperands,
     /*  521807 */     // GIR_Coverage, 5651,
     /*  521807 */     GIR_EraseRootFromParent_Done,
     /*  521808 */   // Label 8762: @521808
     /*  521808 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(521883), // Rule ID 5654 //
     /*  521813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  521816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  521833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521881 */     GIR_RootConstrainSelectedInstOperands,
     /*  521882 */     // GIR_Coverage, 5654,
     /*  521882 */     GIR_EraseRootFromParent_Done,
     /*  521883 */   // Label 8763: @521883
     /*  521883 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(521958), // Rule ID 5655 //
     /*  521888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  521891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  521908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  521937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  521943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  521945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521956 */     GIR_RootConstrainSelectedInstOperands,
     /*  521957 */     // GIR_Coverage, 5655,
     /*  521957 */     GIR_EraseRootFromParent_Done,
     /*  521958 */   // Label 8764: @521958
     /*  521958 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(522033), // Rule ID 5658 //
     /*  521963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  521966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  521971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  521983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  522012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522031 */     GIR_RootConstrainSelectedInstOperands,
     /*  522032 */     // GIR_Coverage, 5658,
     /*  522032 */     GIR_EraseRootFromParent_Done,
     /*  522033 */   // Label 8765: @522033
     /*  522033 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(522108), // Rule ID 5659 //
     /*  522038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  522041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  522049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  522052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  522055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  522058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  522087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522106 */     GIR_RootConstrainSelectedInstOperands,
     /*  522107 */     // GIR_Coverage, 5659,
     /*  522107 */     GIR_EraseRootFromParent_Done,
     /*  522108 */   // Label 8766: @522108
     /*  522108 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(522183), // Rule ID 5662 //
     /*  522113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  522124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  522127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  522130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  522133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  522159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  522162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522181 */     GIR_RootConstrainSelectedInstOperands,
     /*  522182 */     // GIR_Coverage, 5662,
     /*  522182 */     GIR_EraseRootFromParent_Done,
     /*  522183 */   // Label 8767: @522183
     /*  522183 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(522258), // Rule ID 5663 //
     /*  522188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  522199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  522202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  522205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  522208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  522234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  522237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522256 */     GIR_RootConstrainSelectedInstOperands,
     /*  522257 */     // GIR_Coverage, 5663,
     /*  522257 */     GIR_EraseRootFromParent_Done,
     /*  522258 */   // Label 8768: @522258
     /*  522258 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(522333), // Rule ID 5666 //
     /*  522263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  522274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  522277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  522280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  522283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522309 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  522309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  522312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522331 */     GIR_RootConstrainSelectedInstOperands,
     /*  522332 */     // GIR_Coverage, 5666,
     /*  522332 */     GIR_EraseRootFromParent_Done,
     /*  522333 */   // Label 8769: @522333
     /*  522333 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(522408), // Rule ID 5667 //
     /*  522338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  522349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  522352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  522355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  522358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  522384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  522387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522406 */     GIR_RootConstrainSelectedInstOperands,
     /*  522407 */     // GIR_Coverage, 5667,
     /*  522407 */     GIR_EraseRootFromParent_Done,
     /*  522408 */   // Label 8770: @522408
     /*  522408 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(522483), // Rule ID 5670 //
     /*  522413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  522424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  522427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  522430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  522433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522459 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  522459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  522462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522481 */     GIR_RootConstrainSelectedInstOperands,
     /*  522482 */     // GIR_Coverage, 5670,
     /*  522482 */     GIR_EraseRootFromParent_Done,
     /*  522483 */   // Label 8771: @522483
     /*  522483 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(522558), // Rule ID 5671 //
     /*  522488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  522499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  522502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  522505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  522508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  522534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  522537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  522553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522556 */     GIR_RootConstrainSelectedInstOperands,
     /*  522557 */     // GIR_Coverage, 5671,
     /*  522557 */     GIR_EraseRootFromParent_Done,
     /*  522558 */   // Label 8772: @522558
     /*  522558 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(522633), // Rule ID 5674 //
     /*  522563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  522574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  522577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  522580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  522583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  522612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522631 */     GIR_RootConstrainSelectedInstOperands,
     /*  522632 */     // GIR_Coverage, 5674,
     /*  522632 */     GIR_EraseRootFromParent_Done,
     /*  522633 */   // Label 8773: @522633
     /*  522633 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(522708), // Rule ID 5675 //
     /*  522638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  522649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  522652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  522655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  522658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  522687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522706 */     GIR_RootConstrainSelectedInstOperands,
     /*  522707 */     // GIR_Coverage, 5675,
     /*  522707 */     GIR_EraseRootFromParent_Done,
     /*  522708 */   // Label 8774: @522708
     /*  522708 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(522783), // Rule ID 5678 //
     /*  522713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  522733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  522762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522781 */     GIR_RootConstrainSelectedInstOperands,
     /*  522782 */     // GIR_Coverage, 5678,
     /*  522782 */     GIR_EraseRootFromParent_Done,
     /*  522783 */   // Label 8775: @522783
     /*  522783 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(522858), // Rule ID 5679 //
     /*  522788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  522808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  522837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522856 */     GIR_RootConstrainSelectedInstOperands,
     /*  522857 */     // GIR_Coverage, 5679,
     /*  522857 */     GIR_EraseRootFromParent_Done,
     /*  522858 */   // Label 8776: @522858
     /*  522858 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(522933), // Rule ID 5682 //
     /*  522863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  522866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  522883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522909 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  522912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522931 */     GIR_RootConstrainSelectedInstOperands,
     /*  522932 */     // GIR_Coverage, 5682,
     /*  522932 */     GIR_EraseRootFromParent_Done,
     /*  522933 */   // Label 8777: @522933
     /*  522933 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(523008), // Rule ID 5683 //
     /*  522938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  522941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  522946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  522958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  522987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  522993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  522995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523006 */     GIR_RootConstrainSelectedInstOperands,
     /*  523007 */     // GIR_Coverage, 5683,
     /*  523007 */     GIR_EraseRootFromParent_Done,
     /*  523008 */   // Label 8778: @523008
     /*  523008 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(523083), // Rule ID 5686 //
     /*  523013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  523016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  523033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  523062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523081 */     GIR_RootConstrainSelectedInstOperands,
     /*  523082 */     // GIR_Coverage, 5686,
     /*  523082 */     GIR_EraseRootFromParent_Done,
     /*  523083 */   // Label 8779: @523083
     /*  523083 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(523158), // Rule ID 5687 //
     /*  523088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  523091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  523108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  523137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523156 */     GIR_RootConstrainSelectedInstOperands,
     /*  523157 */     // GIR_Coverage, 5687,
     /*  523157 */     GIR_EraseRootFromParent_Done,
     /*  523158 */   // Label 8780: @523158
     /*  523158 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(523233), // Rule ID 5690 //
     /*  523163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  523166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  523183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  523212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523231 */     GIR_RootConstrainSelectedInstOperands,
     /*  523232 */     // GIR_Coverage, 5690,
     /*  523232 */     GIR_EraseRootFromParent_Done,
     /*  523233 */   // Label 8781: @523233
     /*  523233 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(523308), // Rule ID 5691 //
     /*  523238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  523241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  523258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  523287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523306 */     GIR_RootConstrainSelectedInstOperands,
     /*  523307 */     // GIR_Coverage, 5691,
     /*  523307 */     GIR_EraseRootFromParent_Done,
     /*  523308 */   // Label 8782: @523308
     /*  523308 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(523383), // Rule ID 5694 //
     /*  523313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  523316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  523333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523359 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  523362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523381 */     GIR_RootConstrainSelectedInstOperands,
     /*  523382 */     // GIR_Coverage, 5694,
     /*  523382 */     GIR_EraseRootFromParent_Done,
     /*  523383 */   // Label 8783: @523383
     /*  523383 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(523458), // Rule ID 5695 //
     /*  523388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  523391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  523408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  523437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523456 */     GIR_RootConstrainSelectedInstOperands,
     /*  523457 */     // GIR_Coverage, 5695,
     /*  523457 */     GIR_EraseRootFromParent_Done,
     /*  523458 */   // Label 8784: @523458
     /*  523458 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(523533), // Rule ID 5698 //
     /*  523463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  523466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  523483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  523512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523531 */     GIR_RootConstrainSelectedInstOperands,
     /*  523532 */     // GIR_Coverage, 5698,
     /*  523532 */     GIR_EraseRootFromParent_Done,
     /*  523533 */   // Label 8785: @523533
     /*  523533 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(523608), // Rule ID 5699 //
     /*  523538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  523541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  523558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  523587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523606 */     GIR_RootConstrainSelectedInstOperands,
     /*  523607 */     // GIR_Coverage, 5699,
     /*  523607 */     GIR_EraseRootFromParent_Done,
     /*  523608 */   // Label 8786: @523608
     /*  523608 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(523683), // Rule ID 5702 //
     /*  523613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  523616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  523624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  523627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  523630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  523633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  523662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523681 */     GIR_RootConstrainSelectedInstOperands,
     /*  523682 */     // GIR_Coverage, 5702,
     /*  523682 */     GIR_EraseRootFromParent_Done,
     /*  523683 */   // Label 8787: @523683
     /*  523683 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(523758), // Rule ID 5703 //
     /*  523688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  523691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  523699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  523702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  523705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  523708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  523737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523756 */     GIR_RootConstrainSelectedInstOperands,
     /*  523757 */     // GIR_Coverage, 5703,
     /*  523757 */     GIR_EraseRootFromParent_Done,
     /*  523758 */   // Label 8788: @523758
     /*  523758 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(523833), // Rule ID 5706 //
     /*  523763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  523766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  523774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  523777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  523783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  523812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523831 */     GIR_RootConstrainSelectedInstOperands,
     /*  523832 */     // GIR_Coverage, 5706,
     /*  523832 */     GIR_EraseRootFromParent_Done,
     /*  523833 */   // Label 8789: @523833
     /*  523833 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(523908), // Rule ID 5707 //
     /*  523838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  523841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  523849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  523852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  523858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  523887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523906 */     GIR_RootConstrainSelectedInstOperands,
     /*  523907 */     // GIR_Coverage, 5707,
     /*  523907 */     GIR_EraseRootFromParent_Done,
     /*  523908 */   // Label 8790: @523908
     /*  523908 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(523983), // Rule ID 5710 //
     /*  523913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  523916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  523924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  523927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  523930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  523933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  523952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  523959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  523962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  523968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  523970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  523978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523981 */     GIR_RootConstrainSelectedInstOperands,
     /*  523982 */     // GIR_Coverage, 5710,
     /*  523982 */     GIR_EraseRootFromParent_Done,
     /*  523983 */   // Label 8791: @523983
     /*  523983 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(524058), // Rule ID 5711 //
     /*  523988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  523991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  523996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  523999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  524002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  524005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  524034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  524037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524056 */     GIR_RootConstrainSelectedInstOperands,
     /*  524057 */     // GIR_Coverage, 5711,
     /*  524057 */     GIR_EraseRootFromParent_Done,
     /*  524058 */   // Label 8792: @524058
     /*  524058 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(524133), // Rule ID 5714 //
     /*  524063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  524074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  524077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  524080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  524109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  524112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524131 */     GIR_RootConstrainSelectedInstOperands,
     /*  524132 */     // GIR_Coverage, 5714,
     /*  524132 */     GIR_EraseRootFromParent_Done,
     /*  524133 */   // Label 8793: @524133
     /*  524133 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(524208), // Rule ID 5715 //
     /*  524138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  524149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  524152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  524155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  524184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  524187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524206 */     GIR_RootConstrainSelectedInstOperands,
     /*  524207 */     // GIR_Coverage, 5715,
     /*  524207 */     GIR_EraseRootFromParent_Done,
     /*  524208 */   // Label 8794: @524208
     /*  524208 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(524283), // Rule ID 5718 //
     /*  524213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  524224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  524227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  524230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  524259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524281 */     GIR_RootConstrainSelectedInstOperands,
     /*  524282 */     // GIR_Coverage, 5718,
     /*  524282 */     GIR_EraseRootFromParent_Done,
     /*  524283 */   // Label 8795: @524283
     /*  524283 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(524358), // Rule ID 5719 //
     /*  524288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  524299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  524302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  524305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  524334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524356 */     GIR_RootConstrainSelectedInstOperands,
     /*  524357 */     // GIR_Coverage, 5719,
     /*  524357 */     GIR_EraseRootFromParent_Done,
     /*  524358 */   // Label 8796: @524358
     /*  524358 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(524433), // Rule ID 5722 //
     /*  524363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  524412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524431 */     GIR_RootConstrainSelectedInstOperands,
     /*  524432 */     // GIR_Coverage, 5722,
     /*  524432 */     GIR_EraseRootFromParent_Done,
     /*  524433 */   // Label 8797: @524433
     /*  524433 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(524508), // Rule ID 5723 //
     /*  524438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  524487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524506 */     GIR_RootConstrainSelectedInstOperands,
     /*  524507 */     // GIR_Coverage, 5723,
     /*  524507 */     GIR_EraseRootFromParent_Done,
     /*  524508 */   // Label 8798: @524508
     /*  524508 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(524583), // Rule ID 5726 //
     /*  524513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524581 */     GIR_RootConstrainSelectedInstOperands,
     /*  524582 */     // GIR_Coverage, 5726,
     /*  524582 */     GIR_EraseRootFromParent_Done,
     /*  524583 */   // Label 8799: @524583
     /*  524583 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(524658), // Rule ID 5727 //
     /*  524588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524656 */     GIR_RootConstrainSelectedInstOperands,
     /*  524657 */     // GIR_Coverage, 5727,
     /*  524657 */     GIR_EraseRootFromParent_Done,
     /*  524658 */   // Label 8800: @524658
     /*  524658 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(524733), // Rule ID 5730 //
     /*  524663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524731 */     GIR_RootConstrainSelectedInstOperands,
     /*  524732 */     // GIR_Coverage, 5730,
     /*  524732 */     GIR_EraseRootFromParent_Done,
     /*  524733 */   // Label 8801: @524733
     /*  524733 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(524808), // Rule ID 5731 //
     /*  524738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  524787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524806 */     GIR_RootConstrainSelectedInstOperands,
     /*  524807 */     // GIR_Coverage, 5731,
     /*  524807 */     GIR_EraseRootFromParent_Done,
     /*  524808 */   // Label 8802: @524808
     /*  524808 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(524883), // Rule ID 5734 //
     /*  524813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  524824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  524827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  524830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  524859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  524862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524881 */     GIR_RootConstrainSelectedInstOperands,
     /*  524882 */     // GIR_Coverage, 5734,
     /*  524882 */     GIR_EraseRootFromParent_Done,
     /*  524883 */   // Label 8803: @524883
     /*  524883 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(524958), // Rule ID 5735 //
     /*  524888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  524891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  524899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  524902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  524905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  524908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  524927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10847:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  524934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  524937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  524943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  524945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  524953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524956 */     GIR_RootConstrainSelectedInstOperands,
     /*  524957 */     // GIR_Coverage, 5735,
     /*  524957 */     GIR_EraseRootFromParent_Done,
     /*  524958 */   // Label 8804: @524958
     /*  524958 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(525033), // Rule ID 5738 //
     /*  524963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  524966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  524971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  524983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525031 */     GIR_RootConstrainSelectedInstOperands,
     /*  525032 */     // GIR_Coverage, 5738,
     /*  525032 */     GIR_EraseRootFromParent_Done,
     /*  525033 */   // Label 8805: @525033
     /*  525033 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(525108), // Rule ID 5739 //
     /*  525038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10847:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525106 */     GIR_RootConstrainSelectedInstOperands,
     /*  525107 */     // GIR_Coverage, 5739,
     /*  525107 */     GIR_EraseRootFromParent_Done,
     /*  525108 */   // Label 8806: @525108
     /*  525108 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(525183), // Rule ID 5742 //
     /*  525113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  525116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525159 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525181 */     GIR_RootConstrainSelectedInstOperands,
     /*  525182 */     // GIR_Coverage, 5742,
     /*  525182 */     GIR_EraseRootFromParent_Done,
     /*  525183 */   // Label 8807: @525183
     /*  525183 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(525258), // Rule ID 5743 //
     /*  525188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10847:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525256 */     GIR_RootConstrainSelectedInstOperands,
     /*  525257 */     // GIR_Coverage, 5743,
     /*  525257 */     GIR_EraseRootFromParent_Done,
     /*  525258 */   // Label 8808: @525258
     /*  525258 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(525333), // Rule ID 5746 //
     /*  525263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  525266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525331 */     GIR_RootConstrainSelectedInstOperands,
     /*  525332 */     // GIR_Coverage, 5746,
     /*  525332 */     GIR_EraseRootFromParent_Done,
     /*  525333 */   // Label 8809: @525333
     /*  525333 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(525408), // Rule ID 5747 //
     /*  525338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  525341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10847:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  525387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525406 */     GIR_RootConstrainSelectedInstOperands,
     /*  525407 */     // GIR_Coverage, 5747,
     /*  525407 */     GIR_EraseRootFromParent_Done,
     /*  525408 */   // Label 8810: @525408
     /*  525408 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(525483), // Rule ID 5750 //
     /*  525413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  525416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  525424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  525427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  525430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  525459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  525462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525481 */     GIR_RootConstrainSelectedInstOperands,
     /*  525482 */     // GIR_Coverage, 5750,
     /*  525482 */     GIR_EraseRootFromParent_Done,
     /*  525483 */   // Label 8811: @525483
     /*  525483 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(525558), // Rule ID 5751 //
     /*  525488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  525499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  525502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  525505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  525534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  525537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525556 */     GIR_RootConstrainSelectedInstOperands,
     /*  525557 */     // GIR_Coverage, 5751,
     /*  525557 */     GIR_EraseRootFromParent_Done,
     /*  525558 */   // Label 8812: @525558
     /*  525558 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(525633), // Rule ID 5754 //
     /*  525563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  525566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  525574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  525577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  525580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525609 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  525609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  525612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525631 */     GIR_RootConstrainSelectedInstOperands,
     /*  525632 */     // GIR_Coverage, 5754,
     /*  525632 */     GIR_EraseRootFromParent_Done,
     /*  525633 */   // Label 8813: @525633
     /*  525633 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(525708), // Rule ID 5755 //
     /*  525638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  525649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  525652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  525655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  525684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  525687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525706 */     GIR_RootConstrainSelectedInstOperands,
     /*  525707 */     // GIR_Coverage, 5755,
     /*  525707 */     GIR_EraseRootFromParent_Done,
     /*  525708 */   // Label 8814: @525708
     /*  525708 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(525783), // Rule ID 5758 //
     /*  525713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  525716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  525724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  525727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  525730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  525759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  525762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525781 */     GIR_RootConstrainSelectedInstOperands,
     /*  525782 */     // GIR_Coverage, 5758,
     /*  525782 */     GIR_EraseRootFromParent_Done,
     /*  525783 */   // Label 8815: @525783
     /*  525783 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(525858), // Rule ID 5759 //
     /*  525788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  525799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  525802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  525805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  525834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  525837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  525853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525856 */     GIR_RootConstrainSelectedInstOperands,
     /*  525857 */     // GIR_Coverage, 5759,
     /*  525857 */     GIR_EraseRootFromParent_Done,
     /*  525858 */   // Label 8816: @525858
     /*  525858 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(525933), // Rule ID 5762 //
     /*  525863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  525866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  525883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  525912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525931 */     GIR_RootConstrainSelectedInstOperands,
     /*  525932 */     // GIR_Coverage, 5762,
     /*  525932 */     GIR_EraseRootFromParent_Done,
     /*  525933 */   // Label 8817: @525933
     /*  525933 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(526008), // Rule ID 5763 //
     /*  525938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  525941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  525946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  525958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  525977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  525987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  525993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  525995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526006 */     GIR_RootConstrainSelectedInstOperands,
     /*  526007 */     // GIR_Coverage, 5763,
     /*  526007 */     GIR_EraseRootFromParent_Done,
     /*  526008 */   // Label 8818: @526008
     /*  526008 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(526083), // Rule ID 5766 //
     /*  526013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  526016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  526062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526081 */     GIR_RootConstrainSelectedInstOperands,
     /*  526082 */     // GIR_Coverage, 5766,
     /*  526082 */     GIR_EraseRootFromParent_Done,
     /*  526083 */   // Label 8819: @526083
     /*  526083 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(526158), // Rule ID 5767 //
     /*  526088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  526091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  526137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526156 */     GIR_RootConstrainSelectedInstOperands,
     /*  526157 */     // GIR_Coverage, 5767,
     /*  526157 */     GIR_EraseRootFromParent_Done,
     /*  526158 */   // Label 8820: @526158
     /*  526158 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(526233), // Rule ID 5770 //
     /*  526163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  526166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  526212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526231 */     GIR_RootConstrainSelectedInstOperands,
     /*  526232 */     // GIR_Coverage, 5770,
     /*  526232 */     GIR_EraseRootFromParent_Done,
     /*  526233 */   // Label 8821: @526233
     /*  526233 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(526308), // Rule ID 5771 //
     /*  526238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  526241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  526287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526306 */     GIR_RootConstrainSelectedInstOperands,
     /*  526307 */     // GIR_Coverage, 5771,
     /*  526307 */     GIR_EraseRootFromParent_Done,
     /*  526308 */   // Label 8822: @526308
     /*  526308 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(526383), // Rule ID 5774 //
     /*  526313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  526316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  526362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526381 */     GIR_RootConstrainSelectedInstOperands,
     /*  526382 */     // GIR_Coverage, 5774,
     /*  526382 */     GIR_EraseRootFromParent_Done,
     /*  526383 */   // Label 8823: @526383
     /*  526383 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(526458), // Rule ID 5775 //
     /*  526388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  526391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  526437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526456 */     GIR_RootConstrainSelectedInstOperands,
     /*  526457 */     // GIR_Coverage, 5775,
     /*  526457 */     GIR_EraseRootFromParent_Done,
     /*  526458 */   // Label 8824: @526458
     /*  526458 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(526533), // Rule ID 5778 //
     /*  526463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  526466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  526512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526531 */     GIR_RootConstrainSelectedInstOperands,
     /*  526532 */     // GIR_Coverage, 5778,
     /*  526532 */     GIR_EraseRootFromParent_Done,
     /*  526533 */   // Label 8825: @526533
     /*  526533 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(526608), // Rule ID 5779 //
     /*  526538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  526541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  526587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526606 */     GIR_RootConstrainSelectedInstOperands,
     /*  526607 */     // GIR_Coverage, 5779,
     /*  526607 */     GIR_EraseRootFromParent_Done,
     /*  526608 */   // Label 8826: @526608
     /*  526608 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(526683), // Rule ID 5782 //
     /*  526613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  526616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  526662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526681 */     GIR_RootConstrainSelectedInstOperands,
     /*  526682 */     // GIR_Coverage, 5782,
     /*  526682 */     GIR_EraseRootFromParent_Done,
     /*  526683 */   // Label 8827: @526683
     /*  526683 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(526758), // Rule ID 5783 //
     /*  526688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  526691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  526737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526756 */     GIR_RootConstrainSelectedInstOperands,
     /*  526757 */     // GIR_Coverage, 5783,
     /*  526757 */     GIR_EraseRootFromParent_Done,
     /*  526758 */   // Label 8828: @526758
     /*  526758 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(526833), // Rule ID 5786 //
     /*  526763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  526766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  526812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526831 */     GIR_RootConstrainSelectedInstOperands,
     /*  526832 */     // GIR_Coverage, 5786,
     /*  526832 */     GIR_EraseRootFromParent_Done,
     /*  526833 */   // Label 8829: @526833
     /*  526833 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(526908), // Rule ID 5787 //
     /*  526838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  526841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  526858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10847:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  526887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526906 */     GIR_RootConstrainSelectedInstOperands,
     /*  526907 */     // GIR_Coverage, 5787,
     /*  526907 */     GIR_EraseRootFromParent_Done,
     /*  526908 */   // Label 8830: @526908
     /*  526908 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(526983), // Rule ID 5790 //
     /*  526913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  526916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  526933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  526952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  526962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  526968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  526970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526981 */     GIR_RootConstrainSelectedInstOperands,
     /*  526982 */     // GIR_Coverage, 5790,
     /*  526982 */     GIR_EraseRootFromParent_Done,
     /*  526983 */   // Label 8831: @526983
     /*  526983 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(527058), // Rule ID 5791 //
     /*  526988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  526991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  526996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  527005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  527008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  527027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10847:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  527037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527056 */     GIR_RootConstrainSelectedInstOperands,
     /*  527057 */     // GIR_Coverage, 5791,
     /*  527057 */     GIR_EraseRootFromParent_Done,
     /*  527058 */   // Label 8832: @527058
     /*  527058 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(527133), // Rule ID 5794 //
     /*  527063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  527066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  527071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  527083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  527102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  527112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527131 */     GIR_RootConstrainSelectedInstOperands,
     /*  527132 */     // GIR_Coverage, 5794,
     /*  527132 */     GIR_EraseRootFromParent_Done,
     /*  527133 */   // Label 8833: @527133
     /*  527133 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(527208), // Rule ID 5795 //
     /*  527138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  527141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  527146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  527158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  527177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10847:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  527187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527206 */     GIR_RootConstrainSelectedInstOperands,
     /*  527207 */     // GIR_Coverage, 5795,
     /*  527207 */     GIR_EraseRootFromParent_Done,
     /*  527208 */   // Label 8834: @527208
     /*  527208 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(527283), // Rule ID 5886 //
     /*  527213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  527224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  527227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  527230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  527233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  527259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  527262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527281 */     GIR_RootConstrainSelectedInstOperands,
     /*  527282 */     // GIR_Coverage, 5886,
     /*  527282 */     GIR_EraseRootFromParent_Done,
     /*  527283 */   // Label 8835: @527283
     /*  527283 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(527358), // Rule ID 5887 //
     /*  527288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  527291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  527299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  527302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  527305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  527308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  527334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  527337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527356 */     GIR_RootConstrainSelectedInstOperands,
     /*  527357 */     // GIR_Coverage, 5887,
     /*  527357 */     GIR_EraseRootFromParent_Done,
     /*  527358 */   // Label 8836: @527358
     /*  527358 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(527433), // Rule ID 5890 //
     /*  527363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  527374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  527377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  527380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  527383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  527409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  527412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527431 */     GIR_RootConstrainSelectedInstOperands,
     /*  527432 */     // GIR_Coverage, 5890,
     /*  527432 */     GIR_EraseRootFromParent_Done,
     /*  527433 */   // Label 8837: @527433
     /*  527433 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(527508), // Rule ID 5891 //
     /*  527438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  527441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  527449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  527452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  527455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  527458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  527484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  527487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527506 */     GIR_RootConstrainSelectedInstOperands,
     /*  527507 */     // GIR_Coverage, 5891,
     /*  527507 */     GIR_EraseRootFromParent_Done,
     /*  527508 */   // Label 8838: @527508
     /*  527508 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(527583), // Rule ID 5894 //
     /*  527513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  527524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  527527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  527530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  527533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527559 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  527559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  527562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527581 */     GIR_RootConstrainSelectedInstOperands,
     /*  527582 */     // GIR_Coverage, 5894,
     /*  527582 */     GIR_EraseRootFromParent_Done,
     /*  527583 */   // Label 8839: @527583
     /*  527583 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(527658), // Rule ID 5895 //
     /*  527588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  527591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  527599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  527602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  527605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  527608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  527634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  527637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  527653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527656 */     GIR_RootConstrainSelectedInstOperands,
     /*  527657 */     // GIR_Coverage, 5895,
     /*  527657 */     GIR_EraseRootFromParent_Done,
     /*  527658 */   // Label 8840: @527658
     /*  527658 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(527733), // Rule ID 5898 //
     /*  527663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  527674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  527677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  527683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  527712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527731 */     GIR_RootConstrainSelectedInstOperands,
     /*  527732 */     // GIR_Coverage, 5898,
     /*  527732 */     GIR_EraseRootFromParent_Done,
     /*  527733 */   // Label 8841: @527733
     /*  527733 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(527808), // Rule ID 5899 //
     /*  527738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  527741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  527749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  527752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  527758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  527787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527806 */     GIR_RootConstrainSelectedInstOperands,
     /*  527807 */     // GIR_Coverage, 5899,
     /*  527807 */     GIR_EraseRootFromParent_Done,
     /*  527808 */   // Label 8842: @527808
     /*  527808 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(527883), // Rule ID 5902 //
     /*  527813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  527824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  527827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  527833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  527862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527881 */     GIR_RootConstrainSelectedInstOperands,
     /*  527882 */     // GIR_Coverage, 5902,
     /*  527882 */     GIR_EraseRootFromParent_Done,
     /*  527883 */   // Label 8843: @527883
     /*  527883 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(527958), // Rule ID 5903 //
     /*  527888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  527891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  527899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  527902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  527908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  527937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  527943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  527945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527956 */     GIR_RootConstrainSelectedInstOperands,
     /*  527957 */     // GIR_Coverage, 5903,
     /*  527957 */     GIR_EraseRootFromParent_Done,
     /*  527958 */   // Label 8844: @527958
     /*  527958 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(528033), // Rule ID 5906 //
     /*  527963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  527966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  527971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  527983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  528012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528031 */     GIR_RootConstrainSelectedInstOperands,
     /*  528032 */     // GIR_Coverage, 5906,
     /*  528032 */     GIR_EraseRootFromParent_Done,
     /*  528033 */   // Label 8845: @528033
     /*  528033 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(528108), // Rule ID 5907 //
     /*  528038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  528058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  528087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528106 */     GIR_RootConstrainSelectedInstOperands,
     /*  528107 */     // GIR_Coverage, 5907,
     /*  528107 */     GIR_EraseRootFromParent_Done,
     /*  528108 */   // Label 8846: @528108
     /*  528108 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(528183), // Rule ID 5910 //
     /*  528113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  528116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  528124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  528127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  528130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  528133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  528159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  528178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528181 */     GIR_RootConstrainSelectedInstOperands,
     /*  528182 */     // GIR_Coverage, 5910,
     /*  528182 */     GIR_EraseRootFromParent_Done,
     /*  528183 */   // Label 8847: @528183
     /*  528183 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(528258), // Rule ID 5911 //
     /*  528188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  528199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  528202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  528205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  528208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  528234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  528253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528256 */     GIR_RootConstrainSelectedInstOperands,
     /*  528257 */     // GIR_Coverage, 5911,
     /*  528257 */     GIR_EraseRootFromParent_Done,
     /*  528258 */   // Label 8848: @528258
     /*  528258 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(528333), // Rule ID 5914 //
     /*  528263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  528266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  528274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  528277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  528283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528331 */     GIR_RootConstrainSelectedInstOperands,
     /*  528332 */     // GIR_Coverage, 5914,
     /*  528332 */     GIR_EraseRootFromParent_Done,
     /*  528333 */   // Label 8849: @528333
     /*  528333 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(528408), // Rule ID 5915 //
     /*  528338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  528349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  528352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  528358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528406 */     GIR_RootConstrainSelectedInstOperands,
     /*  528407 */     // GIR_Coverage, 5915,
     /*  528407 */     GIR_EraseRootFromParent_Done,
     /*  528408 */   // Label 8850: @528408
     /*  528408 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(528483), // Rule ID 5918 //
     /*  528413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  528416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  528433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528481 */     GIR_RootConstrainSelectedInstOperands,
     /*  528482 */     // GIR_Coverage, 5918,
     /*  528482 */     GIR_EraseRootFromParent_Done,
     /*  528483 */   // Label 8851: @528483
     /*  528483 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(528558), // Rule ID 5919 //
     /*  528488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  528508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528556 */     GIR_RootConstrainSelectedInstOperands,
     /*  528557 */     // GIR_Coverage, 5919,
     /*  528557 */     GIR_EraseRootFromParent_Done,
     /*  528558 */   // Label 8852: @528558
     /*  528558 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(528633), // Rule ID 5922 //
     /*  528563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  528566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  528580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  528583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528631 */     GIR_RootConstrainSelectedInstOperands,
     /*  528632 */     // GIR_Coverage, 5922,
     /*  528632 */     GIR_EraseRootFromParent_Done,
     /*  528633 */   // Label 8853: @528633
     /*  528633 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(528708), // Rule ID 5923 //
     /*  528638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  528641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  528655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  528658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  528687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528706 */     GIR_RootConstrainSelectedInstOperands,
     /*  528707 */     // GIR_Coverage, 5923,
     /*  528707 */     GIR_EraseRootFromParent_Done,
     /*  528708 */   // Label 8854: @528708
     /*  528708 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(528783), // Rule ID 5926 //
     /*  528713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  528716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  528724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  528727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  528730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  528733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  528759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  528762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  528778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528781 */     GIR_RootConstrainSelectedInstOperands,
     /*  528782 */     // GIR_Coverage, 5926,
     /*  528782 */     GIR_EraseRootFromParent_Done,
     /*  528783 */   // Label 8855: @528783
     /*  528783 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(528858), // Rule ID 5927 //
     /*  528788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  528799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  528802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  528805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  528808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  528834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  528837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  528853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528856 */     GIR_RootConstrainSelectedInstOperands,
     /*  528857 */     // GIR_Coverage, 5927,
     /*  528857 */     GIR_EraseRootFromParent_Done,
     /*  528858 */   // Label 8856: @528858
     /*  528858 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(528933), // Rule ID 5930 //
     /*  528863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  528866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  528874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  528877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  528880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  528883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  528909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  528912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  528928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528931 */     GIR_RootConstrainSelectedInstOperands,
     /*  528932 */     // GIR_Coverage, 5930,
     /*  528932 */     GIR_EraseRootFromParent_Done,
     /*  528933 */   // Label 8857: @528933
     /*  528933 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(529008), // Rule ID 5931 //
     /*  528938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  528941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  528946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  528949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  528952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  528955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  528958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  528984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  528987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  528993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  528995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529006 */     GIR_RootConstrainSelectedInstOperands,
     /*  529007 */     // GIR_Coverage, 5931,
     /*  529007 */     GIR_EraseRootFromParent_Done,
     /*  529008 */   // Label 8858: @529008
     /*  529008 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(529083), // Rule ID 5934 //
     /*  529013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  529024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  529027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  529030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  529033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529059 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  529062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529081 */     GIR_RootConstrainSelectedInstOperands,
     /*  529082 */     // GIR_Coverage, 5934,
     /*  529082 */     GIR_EraseRootFromParent_Done,
     /*  529083 */   // Label 8859: @529083
     /*  529083 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(529158), // Rule ID 5935 //
     /*  529088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  529099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  529102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  529105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  529108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  529137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529156 */     GIR_RootConstrainSelectedInstOperands,
     /*  529157 */     // GIR_Coverage, 5935,
     /*  529157 */     GIR_EraseRootFromParent_Done,
     /*  529158 */   // Label 8860: @529158
     /*  529158 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(529233), // Rule ID 5938 //
     /*  529163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  529183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  529212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529231 */     GIR_RootConstrainSelectedInstOperands,
     /*  529232 */     // GIR_Coverage, 5938,
     /*  529232 */     GIR_EraseRootFromParent_Done,
     /*  529233 */   // Label 8861: @529233
     /*  529233 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(529308), // Rule ID 5939 //
     /*  529238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  529258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  529287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529306 */     GIR_RootConstrainSelectedInstOperands,
     /*  529307 */     // GIR_Coverage, 5939,
     /*  529307 */     GIR_EraseRootFromParent_Done,
     /*  529308 */   // Label 8862: @529308
     /*  529308 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(529383), // Rule ID 5942 //
     /*  529313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  529333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529359 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  529362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529381 */     GIR_RootConstrainSelectedInstOperands,
     /*  529382 */     // GIR_Coverage, 5942,
     /*  529382 */     GIR_EraseRootFromParent_Done,
     /*  529383 */   // Label 8863: @529383
     /*  529383 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(529458), // Rule ID 5943 //
     /*  529388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  529408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  529437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529456 */     GIR_RootConstrainSelectedInstOperands,
     /*  529457 */     // GIR_Coverage, 5943,
     /*  529457 */     GIR_EraseRootFromParent_Done,
     /*  529458 */   // Label 8864: @529458
     /*  529458 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(529533), // Rule ID 5946 //
     /*  529463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  529483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529509 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  529512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529531 */     GIR_RootConstrainSelectedInstOperands,
     /*  529532 */     // GIR_Coverage, 5946,
     /*  529532 */     GIR_EraseRootFromParent_Done,
     /*  529533 */   // Label 8865: @529533
     /*  529533 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(529608), // Rule ID 5947 //
     /*  529538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  529558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  529587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529606 */     GIR_RootConstrainSelectedInstOperands,
     /*  529607 */     // GIR_Coverage, 5947,
     /*  529607 */     GIR_EraseRootFromParent_Done,
     /*  529608 */   // Label 8866: @529608
     /*  529608 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(529683), // Rule ID 5950 //
     /*  529613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  529633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  529662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529681 */     GIR_RootConstrainSelectedInstOperands,
     /*  529682 */     // GIR_Coverage, 5950,
     /*  529682 */     GIR_EraseRootFromParent_Done,
     /*  529683 */   // Label 8867: @529683
     /*  529683 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(529758), // Rule ID 5951 //
     /*  529688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  529708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  529737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529756 */     GIR_RootConstrainSelectedInstOperands,
     /*  529757 */     // GIR_Coverage, 5951,
     /*  529757 */     GIR_EraseRootFromParent_Done,
     /*  529758 */   // Label 8868: @529758
     /*  529758 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(529833), // Rule ID 5954 //
     /*  529763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  529783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  529812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529831 */     GIR_RootConstrainSelectedInstOperands,
     /*  529832 */     // GIR_Coverage, 5954,
     /*  529832 */     GIR_EraseRootFromParent_Done,
     /*  529833 */   // Label 8869: @529833
     /*  529833 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(529908), // Rule ID 5955 //
     /*  529838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  529858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  529887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529906 */     GIR_RootConstrainSelectedInstOperands,
     /*  529907 */     // GIR_Coverage, 5955,
     /*  529907 */     GIR_EraseRootFromParent_Done,
     /*  529908 */   // Label 8870: @529908
     /*  529908 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(529983), // Rule ID 5958 //
     /*  529913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  529916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  529927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  529930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  529933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  529962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  529968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  529970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529981 */     GIR_RootConstrainSelectedInstOperands,
     /*  529982 */     // GIR_Coverage, 5958,
     /*  529982 */     GIR_EraseRootFromParent_Done,
     /*  529983 */   // Label 8871: @529983
     /*  529983 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(530058), // Rule ID 5959 //
     /*  529988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  529991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  529996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  530002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  530008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  530037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530056 */     GIR_RootConstrainSelectedInstOperands,
     /*  530057 */     // GIR_Coverage, 5959,
     /*  530057 */     GIR_EraseRootFromParent_Done,
     /*  530058 */   // Label 8872: @530058
     /*  530058 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(530133), // Rule ID 5962 //
     /*  530063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  530066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  530083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  530112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530131 */     GIR_RootConstrainSelectedInstOperands,
     /*  530132 */     // GIR_Coverage, 5962,
     /*  530132 */     GIR_EraseRootFromParent_Done,
     /*  530133 */   // Label 8873: @530133
     /*  530133 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(530208), // Rule ID 5963 //
     /*  530138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  530141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  530158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  530187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530206 */     GIR_RootConstrainSelectedInstOperands,
     /*  530207 */     // GIR_Coverage, 5963,
     /*  530207 */     GIR_EraseRootFromParent_Done,
     /*  530208 */   // Label 8874: @530208
     /*  530208 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(530283), // Rule ID 5966 //
     /*  530213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  530216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  530233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530259 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  530262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530281 */     GIR_RootConstrainSelectedInstOperands,
     /*  530282 */     // GIR_Coverage, 5966,
     /*  530282 */     GIR_EraseRootFromParent_Done,
     /*  530283 */   // Label 8875: @530283
     /*  530283 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(530358), // Rule ID 5967 //
     /*  530288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  530291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  530308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  530337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530356 */     GIR_RootConstrainSelectedInstOperands,
     /*  530357 */     // GIR_Coverage, 5967,
     /*  530357 */     GIR_EraseRootFromParent_Done,
     /*  530358 */   // Label 8876: @530358
     /*  530358 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(530433), // Rule ID 5970 //
     /*  530363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  530366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  530383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  530412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530431 */     GIR_RootConstrainSelectedInstOperands,
     /*  530432 */     // GIR_Coverage, 5970,
     /*  530432 */     GIR_EraseRootFromParent_Done,
     /*  530433 */   // Label 8877: @530433
     /*  530433 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(530508), // Rule ID 5971 //
     /*  530438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  530441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  530458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  530487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530506 */     GIR_RootConstrainSelectedInstOperands,
     /*  530507 */     // GIR_Coverage, 5971,
     /*  530507 */     GIR_EraseRootFromParent_Done,
     /*  530508 */   // Label 8878: @530508
     /*  530508 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(530583), // Rule ID 5974 //
     /*  530513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  530516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  530524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  530527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  530530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  530533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530559 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  530562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530581 */     GIR_RootConstrainSelectedInstOperands,
     /*  530582 */     // GIR_Coverage, 5974,
     /*  530582 */     GIR_EraseRootFromParent_Done,
     /*  530583 */   // Label 8879: @530583
     /*  530583 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(530658), // Rule ID 5975 //
     /*  530588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  530591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  530599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  530602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  530605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  530608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  530637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530656 */     GIR_RootConstrainSelectedInstOperands,
     /*  530657 */     // GIR_Coverage, 5975,
     /*  530657 */     GIR_EraseRootFromParent_Done,
     /*  530658 */   // Label 8880: @530658
     /*  530658 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(530733), // Rule ID 5978 //
     /*  530663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  530666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  530680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  530683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  530712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530731 */     GIR_RootConstrainSelectedInstOperands,
     /*  530732 */     // GIR_Coverage, 5978,
     /*  530732 */     GIR_EraseRootFromParent_Done,
     /*  530733 */   // Label 8881: @530733
     /*  530733 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(530808), // Rule ID 5979 //
     /*  530738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  530741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  530755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  530758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  530787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530806 */     GIR_RootConstrainSelectedInstOperands,
     /*  530807 */     // GIR_Coverage, 5979,
     /*  530807 */     GIR_EraseRootFromParent_Done,
     /*  530808 */   // Label 8882: @530808
     /*  530808 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(530883), // Rule ID 5982 //
     /*  530813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  530816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  530830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  530833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  530862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530881 */     GIR_RootConstrainSelectedInstOperands,
     /*  530882 */     // GIR_Coverage, 5982,
     /*  530882 */     GIR_EraseRootFromParent_Done,
     /*  530883 */   // Label 8883: @530883
     /*  530883 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(530958), // Rule ID 5983 //
     /*  530888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  530891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  530905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  530908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  530927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  530937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  530943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  530945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530956 */     GIR_RootConstrainSelectedInstOperands,
     /*  530957 */     // GIR_Coverage, 5983,
     /*  530957 */     GIR_EraseRootFromParent_Done,
     /*  530958 */   // Label 8884: @530958
     /*  530958 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(531033), // Rule ID 5986 //
     /*  530963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  530966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  530971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  530983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  531012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531031 */     GIR_RootConstrainSelectedInstOperands,
     /*  531032 */     // GIR_Coverage, 5986,
     /*  531032 */     GIR_EraseRootFromParent_Done,
     /*  531033 */   // Label 8885: @531033
     /*  531033 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(531108), // Rule ID 5987 //
     /*  531038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  531049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  531052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  531087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531106 */     GIR_RootConstrainSelectedInstOperands,
     /*  531107 */     // GIR_Coverage, 5987,
     /*  531107 */     GIR_EraseRootFromParent_Done,
     /*  531108 */   // Label 8886: @531108
     /*  531108 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(531183), // Rule ID 5990 //
     /*  531113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  531116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  531124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  531127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  531162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531181 */     GIR_RootConstrainSelectedInstOperands,
     /*  531182 */     // GIR_Coverage, 5990,
     /*  531182 */     GIR_EraseRootFromParent_Done,
     /*  531183 */   // Label 8887: @531183
     /*  531183 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(531258), // Rule ID 5991 //
     /*  531188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  531199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  531202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  531237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531256 */     GIR_RootConstrainSelectedInstOperands,
     /*  531257 */     // GIR_Coverage, 5991,
     /*  531257 */     GIR_EraseRootFromParent_Done,
     /*  531258 */   // Label 8888: @531258
     /*  531258 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(531333), // Rule ID 5994 //
     /*  531263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  531266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531309 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  531312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531331 */     GIR_RootConstrainSelectedInstOperands,
     /*  531332 */     // GIR_Coverage, 5994,
     /*  531332 */     GIR_EraseRootFromParent_Done,
     /*  531333 */   // Label 8889: @531333
     /*  531333 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(531408), // Rule ID 5995 //
     /*  531338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  531387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531406 */     GIR_RootConstrainSelectedInstOperands,
     /*  531407 */     // GIR_Coverage, 5995,
     /*  531407 */     GIR_EraseRootFromParent_Done,
     /*  531408 */   // Label 8890: @531408
     /*  531408 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(531483), // Rule ID 5998 //
     /*  531413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  531416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  531424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  531427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  531430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531481 */     GIR_RootConstrainSelectedInstOperands,
     /*  531482 */     // GIR_Coverage, 5998,
     /*  531482 */     GIR_EraseRootFromParent_Done,
     /*  531483 */   // Label 8891: @531483
     /*  531483 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(531558), // Rule ID 5999 //
     /*  531488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  531499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  531502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  531505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531556 */     GIR_RootConstrainSelectedInstOperands,
     /*  531557 */     // GIR_Coverage, 5999,
     /*  531557 */     GIR_EraseRootFromParent_Done,
     /*  531558 */   // Label 8892: @531558
     /*  531558 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(531633), // Rule ID 6002 //
     /*  531563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  531566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531609 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531631 */     GIR_RootConstrainSelectedInstOperands,
     /*  531632 */     // GIR_Coverage, 6002,
     /*  531632 */     GIR_EraseRootFromParent_Done,
     /*  531633 */   // Label 8893: @531633
     /*  531633 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(531708), // Rule ID 6003 //
     /*  531638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531706 */     GIR_RootConstrainSelectedInstOperands,
     /*  531707 */     // GIR_Coverage, 6003,
     /*  531707 */     GIR_EraseRootFromParent_Done,
     /*  531708 */   // Label 8894: @531708
     /*  531708 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(531783), // Rule ID 6006 //
     /*  531713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  531716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531781 */     GIR_RootConstrainSelectedInstOperands,
     /*  531782 */     // GIR_Coverage, 6006,
     /*  531782 */     GIR_EraseRootFromParent_Done,
     /*  531783 */   // Label 8895: @531783
     /*  531783 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(531858), // Rule ID 6007 //
     /*  531788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  531791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531856 */     GIR_RootConstrainSelectedInstOperands,
     /*  531857 */     // GIR_Coverage, 6007,
     /*  531857 */     GIR_EraseRootFromParent_Done,
     /*  531858 */   // Label 8896: @531858
     /*  531858 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(531933), // Rule ID 6010 //
     /*  531863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  531866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  531883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  531909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  531928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531931 */     GIR_RootConstrainSelectedInstOperands,
     /*  531932 */     // GIR_Coverage, 6010,
     /*  531932 */     GIR_EraseRootFromParent_Done,
     /*  531933 */   // Label 8897: @531933
     /*  531933 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(532008), // Rule ID 6011 //
     /*  531938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  531941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  531946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  531958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  531977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  531984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  531987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  531993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  531995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  532003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532006 */     GIR_RootConstrainSelectedInstOperands,
     /*  532007 */     // GIR_Coverage, 6011,
     /*  532007 */     GIR_EraseRootFromParent_Done,
     /*  532008 */   // Label 8898: @532008
     /*  532008 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(532083), // Rule ID 6014 //
     /*  532013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  532030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  532062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532081 */     GIR_RootConstrainSelectedInstOperands,
     /*  532082 */     // GIR_Coverage, 6014,
     /*  532082 */     GIR_EraseRootFromParent_Done,
     /*  532083 */   // Label 8899: @532083
     /*  532083 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(532158), // Rule ID 6015 //
     /*  532088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  532105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  532137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532156 */     GIR_RootConstrainSelectedInstOperands,
     /*  532157 */     // GIR_Coverage, 6015,
     /*  532157 */     GIR_EraseRootFromParent_Done,
     /*  532158 */   // Label 8900: @532158
     /*  532158 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(532233), // Rule ID 6018 //
     /*  532163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  532180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532209 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  532212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532231 */     GIR_RootConstrainSelectedInstOperands,
     /*  532232 */     // GIR_Coverage, 6018,
     /*  532232 */     GIR_EraseRootFromParent_Done,
     /*  532233 */   // Label 8901: @532233
     /*  532233 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(532308), // Rule ID 6019 //
     /*  532238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  532255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  532287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532306 */     GIR_RootConstrainSelectedInstOperands,
     /*  532307 */     // GIR_Coverage, 6019,
     /*  532307 */     GIR_EraseRootFromParent_Done,
     /*  532308 */   // Label 8902: @532308
     /*  532308 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(532383), // Rule ID 6022 //
     /*  532313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  532324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  532327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  532330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532359 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  532362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532381 */     GIR_RootConstrainSelectedInstOperands,
     /*  532382 */     // GIR_Coverage, 6022,
     /*  532382 */     GIR_EraseRootFromParent_Done,
     /*  532383 */   // Label 8903: @532383
     /*  532383 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(532458), // Rule ID 6023 //
     /*  532388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  532399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  532402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  532405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532434 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  532437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532456 */     GIR_RootConstrainSelectedInstOperands,
     /*  532457 */     // GIR_Coverage, 6023,
     /*  532457 */     GIR_EraseRootFromParent_Done,
     /*  532458 */   // Label 8904: @532458
     /*  532458 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(532533), // Rule ID 6026 //
     /*  532463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  532512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532531 */     GIR_RootConstrainSelectedInstOperands,
     /*  532532 */     // GIR_Coverage, 6026,
     /*  532532 */     GIR_EraseRootFromParent_Done,
     /*  532533 */   // Label 8905: @532533
     /*  532533 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(532608), // Rule ID 6027 //
     /*  532538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  532587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532606 */     GIR_RootConstrainSelectedInstOperands,
     /*  532607 */     // GIR_Coverage, 6027,
     /*  532607 */     GIR_EraseRootFromParent_Done,
     /*  532608 */   // Label 8906: @532608
     /*  532608 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(532683), // Rule ID 6030 //
     /*  532613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  532624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  532627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532659 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  532662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532681 */     GIR_RootConstrainSelectedInstOperands,
     /*  532682 */     // GIR_Coverage, 6030,
     /*  532682 */     GIR_EraseRootFromParent_Done,
     /*  532683 */   // Label 8907: @532683
     /*  532683 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(532758), // Rule ID 6031 //
     /*  532688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  532699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  532702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  532737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532756 */     GIR_RootConstrainSelectedInstOperands,
     /*  532757 */     // GIR_Coverage, 6031,
     /*  532757 */     GIR_EraseRootFromParent_Done,
     /*  532758 */   // Label 8908: @532758
     /*  532758 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(532833), // Rule ID 6034 //
     /*  532763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  532774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  532777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  532812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532831 */     GIR_RootConstrainSelectedInstOperands,
     /*  532832 */     // GIR_Coverage, 6034,
     /*  532832 */     GIR_EraseRootFromParent_Done,
     /*  532833 */   // Label 8909: @532833
     /*  532833 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(532908), // Rule ID 6035 //
     /*  532838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  532849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  532852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  532858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  532887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532906 */     GIR_RootConstrainSelectedInstOperands,
     /*  532907 */     // GIR_Coverage, 6035,
     /*  532907 */     GIR_EraseRootFromParent_Done,
     /*  532908 */   // Label 8910: @532908
     /*  532908 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(532983), // Rule ID 6038 //
     /*  532913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  532916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  532933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  532952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  532962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  532968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  532970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532981 */     GIR_RootConstrainSelectedInstOperands,
     /*  532982 */     // GIR_Coverage, 6038,
     /*  532982 */     GIR_EraseRootFromParent_Done,
     /*  532983 */   // Label 8911: @532983
     /*  532983 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(533058), // Rule ID 6039 //
     /*  532988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  532991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  532996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  533037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533056 */     GIR_RootConstrainSelectedInstOperands,
     /*  533057 */     // GIR_Coverage, 6039,
     /*  533057 */     GIR_EraseRootFromParent_Done,
     /*  533058 */   // Label 8912: @533058
     /*  533058 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(533133), // Rule ID 6042 //
     /*  533063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  533066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  533083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  533112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533131 */     GIR_RootConstrainSelectedInstOperands,
     /*  533132 */     // GIR_Coverage, 6042,
     /*  533132 */     GIR_EraseRootFromParent_Done,
     /*  533133 */   // Label 8913: @533133
     /*  533133 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(533208), // Rule ID 6043 //
     /*  533138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  533141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  533187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533206 */     GIR_RootConstrainSelectedInstOperands,
     /*  533207 */     // GIR_Coverage, 6043,
     /*  533207 */     GIR_EraseRootFromParent_Done,
     /*  533208 */   // Label 8914: @533208
     /*  533208 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(533283), // Rule ID 6046 //
     /*  533213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  533216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  533224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  533227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  533233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  533262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533281 */     GIR_RootConstrainSelectedInstOperands,
     /*  533282 */     // GIR_Coverage, 6046,
     /*  533282 */     GIR_EraseRootFromParent_Done,
     /*  533283 */   // Label 8915: @533283
     /*  533283 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(533358), // Rule ID 6047 //
     /*  533288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  533291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  533299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  533302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  533337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533356 */     GIR_RootConstrainSelectedInstOperands,
     /*  533357 */     // GIR_Coverage, 6047,
     /*  533357 */     GIR_EraseRootFromParent_Done,
     /*  533358 */   // Label 8916: @533358
     /*  533358 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(533433), // Rule ID 6050 //
     /*  533363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  533366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  533374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  533377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  533383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  533409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  533412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533431 */     GIR_RootConstrainSelectedInstOperands,
     /*  533432 */     // GIR_Coverage, 6050,
     /*  533432 */     GIR_EraseRootFromParent_Done,
     /*  533433 */   // Label 8917: @533433
     /*  533433 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(533508), // Rule ID 6051 //
     /*  533438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  533441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  533449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  533452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  533484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  533487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533506 */     GIR_RootConstrainSelectedInstOperands,
     /*  533507 */     // GIR_Coverage, 6051,
     /*  533507 */     GIR_EraseRootFromParent_Done,
     /*  533508 */   // Label 8918: @533508
     /*  533508 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(533583), // Rule ID 6054 //
     /*  533513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  533516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  533533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  533559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  533562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533581 */     GIR_RootConstrainSelectedInstOperands,
     /*  533582 */     // GIR_Coverage, 6054,
     /*  533582 */     GIR_EraseRootFromParent_Done,
     /*  533583 */   // Label 8919: @533583
     /*  533583 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(533658), // Rule ID 6055 //
     /*  533588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  533591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  533634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  533637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533656 */     GIR_RootConstrainSelectedInstOperands,
     /*  533657 */     // GIR_Coverage, 6055,
     /*  533657 */     GIR_EraseRootFromParent_Done,
     /*  533658 */   // Label 8920: @533658
     /*  533658 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(533733), // Rule ID 6058 //
     /*  533663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  533666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  533683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  533709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  533712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533731 */     GIR_RootConstrainSelectedInstOperands,
     /*  533732 */     // GIR_Coverage, 6058,
     /*  533732 */     GIR_EraseRootFromParent_Done,
     /*  533733 */   // Label 8921: @533733
     /*  533733 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(533808), // Rule ID 6059 //
     /*  533738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  533741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  533746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  533758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  533777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  533784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  533787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  533803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533806 */     GIR_RootConstrainSelectedInstOperands,
     /*  533807 */     // GIR_Coverage, 6059,
     /*  533807 */     GIR_EraseRootFromParent_Done,
     /*  533808 */   // Label 8922: @533808
     /*  533808 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(533883), // Rule ID 6150 //
     /*  533813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  533816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  533821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  533830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  533833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  533862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533881 */     GIR_RootConstrainSelectedInstOperands,
     /*  533882 */     // GIR_Coverage, 6150,
     /*  533882 */     GIR_EraseRootFromParent_Done,
     /*  533883 */   // Label 8923: @533883
     /*  533883 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(533958), // Rule ID 6151 //
     /*  533888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  533891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  533896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  533905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  533908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533934 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  533937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  533943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  533945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533956 */     GIR_RootConstrainSelectedInstOperands,
     /*  533957 */     // GIR_Coverage, 6151,
     /*  533957 */     GIR_EraseRootFromParent_Done,
     /*  533958 */   // Label 8924: @533958
     /*  533958 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(534033), // Rule ID 6154 //
     /*  533963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  533966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  533971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  533974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  533977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  533980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  533983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  534009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  534012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534031 */     GIR_RootConstrainSelectedInstOperands,
     /*  534032 */     // GIR_Coverage, 6154,
     /*  534032 */     GIR_EraseRootFromParent_Done,
     /*  534033 */   // Label 8925: @534033
     /*  534033 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(534108), // Rule ID 6155 //
     /*  534038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  534049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  534052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  534055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  534058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  534087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534106 */     GIR_RootConstrainSelectedInstOperands,
     /*  534107 */     // GIR_Coverage, 6155,
     /*  534107 */     GIR_EraseRootFromParent_Done,
     /*  534108 */   // Label 8926: @534108
     /*  534108 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(534183), // Rule ID 6158 //
     /*  534113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  534124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  534127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  534130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  534133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  534159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534181 */     GIR_RootConstrainSelectedInstOperands,
     /*  534182 */     // GIR_Coverage, 6158,
     /*  534182 */     GIR_EraseRootFromParent_Done,
     /*  534183 */   // Label 8927: @534183
     /*  534183 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(534258), // Rule ID 6159 //
     /*  534188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  534199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  534202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  534205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  534208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534256 */     GIR_RootConstrainSelectedInstOperands,
     /*  534257 */     // GIR_Coverage, 6159,
     /*  534257 */     GIR_EraseRootFromParent_Done,
     /*  534258 */   // Label 8928: @534258
     /*  534258 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(534333), // Rule ID 6162 //
     /*  534263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  534280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  534283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  534312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534331 */     GIR_RootConstrainSelectedInstOperands,
     /*  534332 */     // GIR_Coverage, 6162,
     /*  534332 */     GIR_EraseRootFromParent_Done,
     /*  534333 */   // Label 8929: @534333
     /*  534333 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(534408), // Rule ID 6163 //
     /*  534338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  534355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  534358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534384 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  534387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534406 */     GIR_RootConstrainSelectedInstOperands,
     /*  534407 */     // GIR_Coverage, 6163,
     /*  534407 */     GIR_EraseRootFromParent_Done,
     /*  534408 */   // Label 8930: @534408
     /*  534408 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(534483), // Rule ID 6166 //
     /*  534413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  534430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  534433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534459 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534481 */     GIR_RootConstrainSelectedInstOperands,
     /*  534482 */     // GIR_Coverage, 6166,
     /*  534482 */     GIR_EraseRootFromParent_Done,
     /*  534483 */   // Label 8931: @534483
     /*  534483 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(534558), // Rule ID 6167 //
     /*  534488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  534505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  534508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534556 */     GIR_RootConstrainSelectedInstOperands,
     /*  534557 */     // GIR_Coverage, 6167,
     /*  534557 */     GIR_EraseRootFromParent_Done,
     /*  534558 */   // Label 8932: @534558
     /*  534558 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(534633), // Rule ID 6170 //
     /*  534563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  534583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534631 */     GIR_RootConstrainSelectedInstOperands,
     /*  534632 */     // GIR_Coverage, 6170,
     /*  534632 */     GIR_EraseRootFromParent_Done,
     /*  534633 */   // Label 8933: @534633
     /*  534633 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(534708), // Rule ID 6171 //
     /*  534638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  534658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  534687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534706 */     GIR_RootConstrainSelectedInstOperands,
     /*  534707 */     // GIR_Coverage, 6171,
     /*  534707 */     GIR_EraseRootFromParent_Done,
     /*  534708 */   // Label 8934: @534708
     /*  534708 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(534783), // Rule ID 6174 //
     /*  534713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  534724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  534727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  534730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  534733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  534759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  534762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534781 */     GIR_RootConstrainSelectedInstOperands,
     /*  534782 */     // GIR_Coverage, 6174,
     /*  534782 */     GIR_EraseRootFromParent_Done,
     /*  534783 */   // Label 8935: @534783
     /*  534783 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(534858), // Rule ID 6175 //
     /*  534788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  534799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  534802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  534805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  534808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  534837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534856 */     GIR_RootConstrainSelectedInstOperands,
     /*  534857 */     // GIR_Coverage, 6175,
     /*  534857 */     GIR_EraseRootFromParent_Done,
     /*  534858 */   // Label 8936: @534858
     /*  534858 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(534933), // Rule ID 6178 //
     /*  534863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  534866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  534880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  534883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  534912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534931 */     GIR_RootConstrainSelectedInstOperands,
     /*  534932 */     // GIR_Coverage, 6178,
     /*  534932 */     GIR_EraseRootFromParent_Done,
     /*  534933 */   // Label 8937: @534933
     /*  534933 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(535008), // Rule ID 6179 //
     /*  534938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  534941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  534946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  534955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  534958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  534987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  534993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  534995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535006 */     GIR_RootConstrainSelectedInstOperands,
     /*  535007 */     // GIR_Coverage, 6179,
     /*  535007 */     GIR_EraseRootFromParent_Done,
     /*  535008 */   // Label 8938: @535008
     /*  535008 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(535083), // Rule ID 6182 //
     /*  535013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  535033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  535062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535081 */     GIR_RootConstrainSelectedInstOperands,
     /*  535082 */     // GIR_Coverage, 6182,
     /*  535082 */     GIR_EraseRootFromParent_Done,
     /*  535083 */   // Label 8939: @535083
     /*  535083 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(535158), // Rule ID 6183 //
     /*  535088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  535108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  535137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535156 */     GIR_RootConstrainSelectedInstOperands,
     /*  535157 */     // GIR_Coverage, 6183,
     /*  535157 */     GIR_EraseRootFromParent_Done,
     /*  535158 */   // Label 8940: @535158
     /*  535158 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(535233), // Rule ID 6186 //
     /*  535163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  535166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  535174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  535177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  535183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  535209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  535212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  535228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535231 */     GIR_RootConstrainSelectedInstOperands,
     /*  535232 */     // GIR_Coverage, 6186,
     /*  535232 */     GIR_EraseRootFromParent_Done,
     /*  535233 */   // Label 8941: @535233
     /*  535233 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(535308), // Rule ID 6187 //
     /*  535238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  535241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  535249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  535252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  535258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  535284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  535287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  535303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535306 */     GIR_RootConstrainSelectedInstOperands,
     /*  535307 */     // GIR_Coverage, 6187,
     /*  535307 */     GIR_EraseRootFromParent_Done,
     /*  535308 */   // Label 8942: @535308
     /*  535308 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(535383), // Rule ID 6190 //
     /*  535313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  535324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  535327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  535330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  535333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  535362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535381 */     GIR_RootConstrainSelectedInstOperands,
     /*  535382 */     // GIR_Coverage, 6190,
     /*  535382 */     GIR_EraseRootFromParent_Done,
     /*  535383 */   // Label 8943: @535383
     /*  535383 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(535458), // Rule ID 6191 //
     /*  535388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  535399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  535402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  535405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  535408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  535437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535456 */     GIR_RootConstrainSelectedInstOperands,
     /*  535457 */     // GIR_Coverage, 6191,
     /*  535457 */     GIR_EraseRootFromParent_Done,
     /*  535458 */   // Label 8944: @535458
     /*  535458 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(535533), // Rule ID 6194 //
     /*  535463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  535474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  535477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  535480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  535483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  535512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535531 */     GIR_RootConstrainSelectedInstOperands,
     /*  535532 */     // GIR_Coverage, 6194,
     /*  535532 */     GIR_EraseRootFromParent_Done,
     /*  535533 */   // Label 8945: @535533
     /*  535533 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(535608), // Rule ID 6195 //
     /*  535538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  535549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  535552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  535555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  535558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  535587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535606 */     GIR_RootConstrainSelectedInstOperands,
     /*  535607 */     // GIR_Coverage, 6195,
     /*  535607 */     GIR_EraseRootFromParent_Done,
     /*  535608 */   // Label 8946: @535608
     /*  535608 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(535683), // Rule ID 6198 //
     /*  535613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  535624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  535627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  535630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  535633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535659 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  535662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535681 */     GIR_RootConstrainSelectedInstOperands,
     /*  535682 */     // GIR_Coverage, 6198,
     /*  535682 */     GIR_EraseRootFromParent_Done,
     /*  535683 */   // Label 8947: @535683
     /*  535683 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(535758), // Rule ID 6199 //
     /*  535688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  535699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  535702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  535705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  535708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  535737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535756 */     GIR_RootConstrainSelectedInstOperands,
     /*  535757 */     // GIR_Coverage, 6199,
     /*  535757 */     GIR_EraseRootFromParent_Done,
     /*  535758 */   // Label 8948: @535758
     /*  535758 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(535833), // Rule ID 6202 //
     /*  535763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  535783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  535812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535831 */     GIR_RootConstrainSelectedInstOperands,
     /*  535832 */     // GIR_Coverage, 6202,
     /*  535832 */     GIR_EraseRootFromParent_Done,
     /*  535833 */   // Label 8949: @535833
     /*  535833 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(535908), // Rule ID 6203 //
     /*  535838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  535858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  535887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535906 */     GIR_RootConstrainSelectedInstOperands,
     /*  535907 */     // GIR_Coverage, 6203,
     /*  535907 */     GIR_EraseRootFromParent_Done,
     /*  535908 */   // Label 8950: @535908
     /*  535908 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(535983), // Rule ID 6206 //
     /*  535913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  535916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  535930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  535933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  535962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  535968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  535970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535981 */     GIR_RootConstrainSelectedInstOperands,
     /*  535982 */     // GIR_Coverage, 6206,
     /*  535982 */     GIR_EraseRootFromParent_Done,
     /*  535983 */   // Label 8951: @535983
     /*  535983 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(536058), // Rule ID 6207 //
     /*  535988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  535991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  535996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  536005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  536008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  536037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536056 */     GIR_RootConstrainSelectedInstOperands,
     /*  536057 */     // GIR_Coverage, 6207,
     /*  536057 */     GIR_EraseRootFromParent_Done,
     /*  536058 */   // Label 8952: @536058
     /*  536058 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(536133), // Rule ID 6210 //
     /*  536063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  536066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  536074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  536077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  536083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  536112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536131 */     GIR_RootConstrainSelectedInstOperands,
     /*  536132 */     // GIR_Coverage, 6210,
     /*  536132 */     GIR_EraseRootFromParent_Done,
     /*  536133 */   // Label 8953: @536133
     /*  536133 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(536208), // Rule ID 6211 //
     /*  536138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  536141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  536149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  536152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  536158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  536187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536206 */     GIR_RootConstrainSelectedInstOperands,
     /*  536207 */     // GIR_Coverage, 6211,
     /*  536207 */     GIR_EraseRootFromParent_Done,
     /*  536208 */   // Label 8954: @536208
     /*  536208 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(536283), // Rule ID 6214 //
     /*  536213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  536216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  536233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  536262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536281 */     GIR_RootConstrainSelectedInstOperands,
     /*  536282 */     // GIR_Coverage, 6214,
     /*  536282 */     GIR_EraseRootFromParent_Done,
     /*  536283 */   // Label 8955: @536283
     /*  536283 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(536358), // Rule ID 6215 //
     /*  536288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  536291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  536308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  536337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536356 */     GIR_RootConstrainSelectedInstOperands,
     /*  536357 */     // GIR_Coverage, 6215,
     /*  536357 */     GIR_EraseRootFromParent_Done,
     /*  536358 */   // Label 8956: @536358
     /*  536358 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(536433), // Rule ID 6218 //
     /*  536363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  536366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  536383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  536412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536431 */     GIR_RootConstrainSelectedInstOperands,
     /*  536432 */     // GIR_Coverage, 6218,
     /*  536432 */     GIR_EraseRootFromParent_Done,
     /*  536433 */   // Label 8957: @536433
     /*  536433 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(536508), // Rule ID 6219 //
     /*  536438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  536441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  536458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  536487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536506 */     GIR_RootConstrainSelectedInstOperands,
     /*  536507 */     // GIR_Coverage, 6219,
     /*  536507 */     GIR_EraseRootFromParent_Done,
     /*  536508 */   // Label 8958: @536508
     /*  536508 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(536583), // Rule ID 6222 //
     /*  536513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  536516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  536524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  536527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  536533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  536562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536581 */     GIR_RootConstrainSelectedInstOperands,
     /*  536582 */     // GIR_Coverage, 6222,
     /*  536582 */     GIR_EraseRootFromParent_Done,
     /*  536583 */   // Label 8959: @536583
     /*  536583 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(536658), // Rule ID 6223 //
     /*  536588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  536591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  536599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  536602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  536608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  536637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536656 */     GIR_RootConstrainSelectedInstOperands,
     /*  536657 */     // GIR_Coverage, 6223,
     /*  536657 */     GIR_EraseRootFromParent_Done,
     /*  536658 */   // Label 8960: @536658
     /*  536658 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(536733), // Rule ID 6226 //
     /*  536663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  536666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  536674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  536677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  536683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  536709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  536712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  536728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536731 */     GIR_RootConstrainSelectedInstOperands,
     /*  536732 */     // GIR_Coverage, 6226,
     /*  536732 */     GIR_EraseRootFromParent_Done,
     /*  536733 */   // Label 8961: @536733
     /*  536733 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(536808), // Rule ID 6227 //
     /*  536738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  536741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  536749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  536752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  536758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  536784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  536787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  536803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536806 */     GIR_RootConstrainSelectedInstOperands,
     /*  536807 */     // GIR_Coverage, 6227,
     /*  536807 */     GIR_EraseRootFromParent_Done,
     /*  536808 */   // Label 8962: @536808
     /*  536808 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(536883), // Rule ID 6230 //
     /*  536813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  536816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  536824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  536827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  536833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  536859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  536862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  536878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536881 */     GIR_RootConstrainSelectedInstOperands,
     /*  536882 */     // GIR_Coverage, 6230,
     /*  536882 */     GIR_EraseRootFromParent_Done,
     /*  536883 */   // Label 8963: @536883
     /*  536883 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(536958), // Rule ID 6231 //
     /*  536888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  536891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  536899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  536902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  536908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  536934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  536937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  536943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  536945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  536953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536956 */     GIR_RootConstrainSelectedInstOperands,
     /*  536957 */     // GIR_Coverage, 6231,
     /*  536957 */     GIR_EraseRootFromParent_Done,
     /*  536958 */   // Label 8964: @536958
     /*  536958 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(537033), // Rule ID 6234 //
     /*  536963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  536966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  536971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  536974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  536977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  536983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537009 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  537009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  537012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  537028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537031 */     GIR_RootConstrainSelectedInstOperands,
     /*  537032 */     // GIR_Coverage, 6234,
     /*  537032 */     GIR_EraseRootFromParent_Done,
     /*  537033 */   // Label 8965: @537033
     /*  537033 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(537108), // Rule ID 6235 //
     /*  537038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  537041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  537049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  537052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  537058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  537084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  537087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  537103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537106 */     GIR_RootConstrainSelectedInstOperands,
     /*  537107 */     // GIR_Coverage, 6235,
     /*  537107 */     GIR_EraseRootFromParent_Done,
     /*  537108 */   // Label 8966: @537108
     /*  537108 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(537183), // Rule ID 6238 //
     /*  537113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  537124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  537127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  537130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537159 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  537162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537181 */     GIR_RootConstrainSelectedInstOperands,
     /*  537182 */     // GIR_Coverage, 6238,
     /*  537182 */     GIR_EraseRootFromParent_Done,
     /*  537183 */   // Label 8967: @537183
     /*  537183 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(537258), // Rule ID 6239 //
     /*  537188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  537199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  537202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  537205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  537237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537256 */     GIR_RootConstrainSelectedInstOperands,
     /*  537257 */     // GIR_Coverage, 6239,
     /*  537257 */     GIR_EraseRootFromParent_Done,
     /*  537258 */   // Label 8968: @537258
     /*  537258 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(537333), // Rule ID 6242 //
     /*  537263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  537274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  537277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  537280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  537312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537331 */     GIR_RootConstrainSelectedInstOperands,
     /*  537332 */     // GIR_Coverage, 6242,
     /*  537332 */     GIR_EraseRootFromParent_Done,
     /*  537333 */   // Label 8969: @537333
     /*  537333 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(537408), // Rule ID 6243 //
     /*  537338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  537349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  537352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  537355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  537387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537406 */     GIR_RootConstrainSelectedInstOperands,
     /*  537407 */     // GIR_Coverage, 6243,
     /*  537407 */     GIR_EraseRootFromParent_Done,
     /*  537408 */   // Label 8970: @537408
     /*  537408 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(537483), // Rule ID 6246 //
     /*  537413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  537424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  537427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  537430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537459 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537481 */     GIR_RootConstrainSelectedInstOperands,
     /*  537482 */     // GIR_Coverage, 6246,
     /*  537482 */     GIR_EraseRootFromParent_Done,
     /*  537483 */   // Label 8971: @537483
     /*  537483 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(537558), // Rule ID 6247 //
     /*  537488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  537499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  537502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  537505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537556 */     GIR_RootConstrainSelectedInstOperands,
     /*  537557 */     // GIR_Coverage, 6247,
     /*  537557 */     GIR_EraseRootFromParent_Done,
     /*  537558 */   // Label 8972: @537558
     /*  537558 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(537633), // Rule ID 6250 //
     /*  537563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  537580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  537612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537631 */     GIR_RootConstrainSelectedInstOperands,
     /*  537632 */     // GIR_Coverage, 6250,
     /*  537632 */     GIR_EraseRootFromParent_Done,
     /*  537633 */   // Label 8973: @537633
     /*  537633 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(537708), // Rule ID 6251 //
     /*  537638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  537655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  537687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537706 */     GIR_RootConstrainSelectedInstOperands,
     /*  537707 */     // GIR_Coverage, 6251,
     /*  537707 */     GIR_EraseRootFromParent_Done,
     /*  537708 */   // Label 8974: @537708
     /*  537708 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(537783), // Rule ID 6254 //
     /*  537713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  537730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537759 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537781 */     GIR_RootConstrainSelectedInstOperands,
     /*  537782 */     // GIR_Coverage, 6254,
     /*  537782 */     GIR_EraseRootFromParent_Done,
     /*  537783 */   // Label 8975: @537783
     /*  537783 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(537858), // Rule ID 6255 //
     /*  537788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  537805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537856 */     GIR_RootConstrainSelectedInstOperands,
     /*  537857 */     // GIR_Coverage, 6255,
     /*  537857 */     GIR_EraseRootFromParent_Done,
     /*  537858 */   // Label 8976: @537858
     /*  537858 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(537933), // Rule ID 6258 //
     /*  537863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  537883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537931 */     GIR_RootConstrainSelectedInstOperands,
     /*  537932 */     // GIR_Coverage, 6258,
     /*  537932 */     GIR_EraseRootFromParent_Done,
     /*  537933 */   // Label 8977: @537933
     /*  537933 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(538008), // Rule ID 6259 //
     /*  537938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  537946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  537958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  537977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  537987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  537993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538006 */     GIR_RootConstrainSelectedInstOperands,
     /*  538007 */     // GIR_Coverage, 6259,
     /*  538007 */     GIR_EraseRootFromParent_Done,
     /*  538008 */   // Label 8978: @538008
     /*  538008 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(538083), // Rule ID 6262 //
     /*  538013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  538024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  538027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  538030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538081 */     GIR_RootConstrainSelectedInstOperands,
     /*  538082 */     // GIR_Coverage, 6262,
     /*  538082 */     GIR_EraseRootFromParent_Done,
     /*  538083 */   // Label 8979: @538083
     /*  538083 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(538158), // Rule ID 6263 //
     /*  538088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  538099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  538102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  538105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538156 */     GIR_RootConstrainSelectedInstOperands,
     /*  538157 */     // GIR_Coverage, 6263,
     /*  538157 */     GIR_EraseRootFromParent_Done,
     /*  538158 */   // Label 8980: @538158
     /*  538158 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(538233), // Rule ID 6266 //
     /*  538163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  538180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538231 */     GIR_RootConstrainSelectedInstOperands,
     /*  538232 */     // GIR_Coverage, 6266,
     /*  538232 */     GIR_EraseRootFromParent_Done,
     /*  538233 */   // Label 8981: @538233
     /*  538233 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(538308), // Rule ID 6267 //
     /*  538238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  538255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538306 */     GIR_RootConstrainSelectedInstOperands,
     /*  538307 */     // GIR_Coverage, 6267,
     /*  538307 */     GIR_EraseRootFromParent_Done,
     /*  538308 */   // Label 8982: @538308
     /*  538308 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(538383), // Rule ID 6270 //
     /*  538313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  538330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538381 */     GIR_RootConstrainSelectedInstOperands,
     /*  538382 */     // GIR_Coverage, 6270,
     /*  538382 */     GIR_EraseRootFromParent_Done,
     /*  538383 */   // Label 8983: @538383
     /*  538383 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(538458), // Rule ID 6271 //
     /*  538388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  538405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538456 */     GIR_RootConstrainSelectedInstOperands,
     /*  538457 */     // GIR_Coverage, 6271,
     /*  538457 */     GIR_EraseRootFromParent_Done,
     /*  538458 */   // Label 8984: @538458
     /*  538458 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(538533), // Rule ID 6274 //
     /*  538463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  538466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  538474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  538477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  538509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  538528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538531 */     GIR_RootConstrainSelectedInstOperands,
     /*  538532 */     // GIR_Coverage, 6274,
     /*  538532 */     GIR_EraseRootFromParent_Done,
     /*  538533 */   // Label 8985: @538533
     /*  538533 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(538608), // Rule ID 6275 //
     /*  538538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  538541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  538549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  538552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  538584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  538587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  538603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538606 */     GIR_RootConstrainSelectedInstOperands,
     /*  538607 */     // GIR_Coverage, 6275,
     /*  538607 */     GIR_EraseRootFromParent_Done,
     /*  538608 */   // Label 8986: @538608
     /*  538608 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(538683), // Rule ID 6278 //
     /*  538613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  538624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  538627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  538630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  538662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538681 */     GIR_RootConstrainSelectedInstOperands,
     /*  538682 */     // GIR_Coverage, 6278,
     /*  538682 */     GIR_EraseRootFromParent_Done,
     /*  538683 */   // Label 8987: @538683
     /*  538683 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(538758), // Rule ID 6279 //
     /*  538688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  538699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  538702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  538705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  538737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538756 */     GIR_RootConstrainSelectedInstOperands,
     /*  538757 */     // GIR_Coverage, 6279,
     /*  538757 */     GIR_EraseRootFromParent_Done,
     /*  538758 */   // Label 8988: @538758
     /*  538758 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(538833), // Rule ID 6282 //
     /*  538763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  538774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  538777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  538780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538809 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  538812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538831 */     GIR_RootConstrainSelectedInstOperands,
     /*  538832 */     // GIR_Coverage, 6282,
     /*  538832 */     GIR_EraseRootFromParent_Done,
     /*  538833 */   // Label 8989: @538833
     /*  538833 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(538908), // Rule ID 6283 //
     /*  538838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  538849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  538852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  538855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  538858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  538887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538906 */     GIR_RootConstrainSelectedInstOperands,
     /*  538907 */     // GIR_Coverage, 6283,
     /*  538907 */     GIR_EraseRootFromParent_Done,
     /*  538908 */   // Label 8990: @538908
     /*  538908 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(538983), // Rule ID 6286 //
     /*  538913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  538924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  538927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  538930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  538933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  538952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538959 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  538962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  538968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538981 */     GIR_RootConstrainSelectedInstOperands,
     /*  538982 */     // GIR_Coverage, 6286,
     /*  538982 */     GIR_EraseRootFromParent_Done,
     /*  538983 */   // Label 8991: @538983
     /*  538983 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(539058), // Rule ID 6287 //
     /*  538988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  538996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  538999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  539002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  539005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539034 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  539037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539056 */     GIR_RootConstrainSelectedInstOperands,
     /*  539057 */     // GIR_Coverage, 6287,
     /*  539057 */     GIR_EraseRootFromParent_Done,
     /*  539058 */   // Label 8992: @539058
     /*  539058 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(539133), // Rule ID 6290 //
     /*  539063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  539080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  539112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539131 */     GIR_RootConstrainSelectedInstOperands,
     /*  539132 */     // GIR_Coverage, 6290,
     /*  539132 */     GIR_EraseRootFromParent_Done,
     /*  539133 */   // Label 8993: @539133
     /*  539133 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(539208), // Rule ID 6291 //
     /*  539138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  539155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  539187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539206 */     GIR_RootConstrainSelectedInstOperands,
     /*  539207 */     // GIR_Coverage, 6291,
     /*  539207 */     GIR_EraseRootFromParent_Done,
     /*  539208 */   // Label 8994: @539208
     /*  539208 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(539283), // Rule ID 6294 //
     /*  539213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  539230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539259 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  539262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539281 */     GIR_RootConstrainSelectedInstOperands,
     /*  539282 */     // GIR_Coverage, 6294,
     /*  539282 */     GIR_EraseRootFromParent_Done,
     /*  539283 */   // Label 8995: @539283
     /*  539283 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(539358), // Rule ID 6295 //
     /*  539288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  539305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  539337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539356 */     GIR_RootConstrainSelectedInstOperands,
     /*  539357 */     // GIR_Coverage, 6295,
     /*  539357 */     GIR_EraseRootFromParent_Done,
     /*  539358 */   // Label 8996: @539358
     /*  539358 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(539433), // Rule ID 6298 //
     /*  539363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  539374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  539377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  539380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  539412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539431 */     GIR_RootConstrainSelectedInstOperands,
     /*  539432 */     // GIR_Coverage, 6298,
     /*  539432 */     GIR_EraseRootFromParent_Done,
     /*  539433 */   // Label 8997: @539433
     /*  539433 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(539508), // Rule ID 6299 //
     /*  539438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  539449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  539452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  539455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539484 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  539487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539506 */     GIR_RootConstrainSelectedInstOperands,
     /*  539507 */     // GIR_Coverage, 6299,
     /*  539507 */     GIR_EraseRootFromParent_Done,
     /*  539508 */   // Label 8998: @539508
     /*  539508 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(539583), // Rule ID 6302 //
     /*  539513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  539562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539581 */     GIR_RootConstrainSelectedInstOperands,
     /*  539582 */     // GIR_Coverage, 6302,
     /*  539582 */     GIR_EraseRootFromParent_Done,
     /*  539583 */   // Label 8999: @539583
     /*  539583 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(539658), // Rule ID 6303 //
     /*  539588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  539637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539656 */     GIR_RootConstrainSelectedInstOperands,
     /*  539657 */     // GIR_Coverage, 6303,
     /*  539657 */     GIR_EraseRootFromParent_Done,
     /*  539658 */   // Label 9000: @539658
     /*  539658 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(539733), // Rule ID 6306 //
     /*  539663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539709 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  539712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539731 */     GIR_RootConstrainSelectedInstOperands,
     /*  539732 */     // GIR_Coverage, 6306,
     /*  539732 */     GIR_EraseRootFromParent_Done,
     /*  539733 */   // Label 9001: @539733
     /*  539733 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(539808), // Rule ID 6307 //
     /*  539738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  539787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539806 */     GIR_RootConstrainSelectedInstOperands,
     /*  539807 */     // GIR_Coverage, 6307,
     /*  539807 */     GIR_EraseRootFromParent_Done,
     /*  539808 */   // Label 9002: @539808
     /*  539808 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(539883), // Rule ID 6310 //
     /*  539813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  539862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539881 */     GIR_RootConstrainSelectedInstOperands,
     /*  539882 */     // GIR_Coverage, 6310,
     /*  539882 */     GIR_EraseRootFromParent_Done,
     /*  539883 */   // Label 9003: @539883
     /*  539883 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(539958), // Rule ID 6311 //
     /*  539888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  539908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  539927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  539937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  539943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539956 */     GIR_RootConstrainSelectedInstOperands,
     /*  539957 */     // GIR_Coverage, 6311,
     /*  539957 */     GIR_EraseRootFromParent_Done,
     /*  539958 */   // Label 9004: @539958
     /*  539958 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(540033), // Rule ID 6314 //
     /*  539963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  539966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  539971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  539980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  539983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  540009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  540012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540031 */     GIR_RootConstrainSelectedInstOperands,
     /*  540032 */     // GIR_Coverage, 6314,
     /*  540032 */     GIR_EraseRootFromParent_Done,
     /*  540033 */   // Label 9005: @540033
     /*  540033 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(540108), // Rule ID 6315 //
     /*  540038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  540041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  540046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  540049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  540052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  540055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  540058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  540084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  540087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540106 */     GIR_RootConstrainSelectedInstOperands,
     /*  540107 */     // GIR_Coverage, 6315,
     /*  540107 */     GIR_EraseRootFromParent_Done,
     /*  540108 */   // Label 9006: @540108
     /*  540108 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(540183), // Rule ID 6318 //
     /*  540113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  540116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  540121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  540124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  540127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  540133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  540159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  540162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540181 */     GIR_RootConstrainSelectedInstOperands,
     /*  540182 */     // GIR_Coverage, 6318,
     /*  540182 */     GIR_EraseRootFromParent_Done,
     /*  540183 */   // Label 9007: @540183
     /*  540183 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(540258), // Rule ID 6319 //
     /*  540188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  540191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  540196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  540199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  540202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  540208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  540234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  540237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540256 */     GIR_RootConstrainSelectedInstOperands,
     /*  540257 */     // GIR_Coverage, 6319,
     /*  540257 */     GIR_EraseRootFromParent_Done,
     /*  540258 */   // Label 9008: @540258
     /*  540258 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(540333), // Rule ID 6322 //
     /*  540263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  540266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  540271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  540283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  540309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  540312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540331 */     GIR_RootConstrainSelectedInstOperands,
     /*  540332 */     // GIR_Coverage, 6322,
     /*  540332 */     GIR_EraseRootFromParent_Done,
     /*  540333 */   // Label 9009: @540333
     /*  540333 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(540408), // Rule ID 6323 //
     /*  540338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  540341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  540346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  540358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  540377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  540384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  540387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  540403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540406 */     GIR_RootConstrainSelectedInstOperands,
     /*  540407 */     // GIR_Coverage, 6323,
     /*  540407 */     GIR_EraseRootFromParent_Done,
     /*  540408 */   // Label 9010: @540408
     /*  540408 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(540483), // Rule ID 6414 //
     /*  540413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  540424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  540427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  540430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  540462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540481 */     GIR_RootConstrainSelectedInstOperands,
     /*  540482 */     // GIR_Coverage, 6414,
     /*  540482 */     GIR_EraseRootFromParent_Done,
     /*  540483 */   // Label 9011: @540483
     /*  540483 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(540558), // Rule ID 6415 //
     /*  540488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  540499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  540502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  540505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  540537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540556 */     GIR_RootConstrainSelectedInstOperands,
     /*  540557 */     // GIR_Coverage, 6415,
     /*  540557 */     GIR_EraseRootFromParent_Done,
     /*  540558 */   // Label 9012: @540558
     /*  540558 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(540633), // Rule ID 6418 //
     /*  540563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  540574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  540577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  540580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540609 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  540612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540631 */     GIR_RootConstrainSelectedInstOperands,
     /*  540632 */     // GIR_Coverage, 6418,
     /*  540632 */     GIR_EraseRootFromParent_Done,
     /*  540633 */   // Label 9013: @540633
     /*  540633 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(540708), // Rule ID 6419 //
     /*  540638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  540649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  540652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  540655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  540687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540706 */     GIR_RootConstrainSelectedInstOperands,
     /*  540707 */     // GIR_Coverage, 6419,
     /*  540707 */     GIR_EraseRootFromParent_Done,
     /*  540708 */   // Label 9014: @540708
     /*  540708 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(540783), // Rule ID 6422 //
     /*  540713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  540724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  540727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  540730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  540762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540781 */     GIR_RootConstrainSelectedInstOperands,
     /*  540782 */     // GIR_Coverage, 6422,
     /*  540782 */     GIR_EraseRootFromParent_Done,
     /*  540783 */   // Label 9015: @540783
     /*  540783 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(540858), // Rule ID 6423 //
     /*  540788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  540799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  540802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  540805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  540837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540856 */     GIR_RootConstrainSelectedInstOperands,
     /*  540857 */     // GIR_Coverage, 6423,
     /*  540857 */     GIR_EraseRootFromParent_Done,
     /*  540858 */   // Label 9016: @540858
     /*  540858 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(540933), // Rule ID 6426 //
     /*  540863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  540880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  540912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540931 */     GIR_RootConstrainSelectedInstOperands,
     /*  540932 */     // GIR_Coverage, 6426,
     /*  540932 */     GIR_EraseRootFromParent_Done,
     /*  540933 */   // Label 9017: @540933
     /*  540933 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(541008), // Rule ID 6427 //
     /*  540938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  540946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  540955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  540987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  540993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541006 */     GIR_RootConstrainSelectedInstOperands,
     /*  541007 */     // GIR_Coverage, 6427,
     /*  541007 */     GIR_EraseRootFromParent_Done,
     /*  541008 */   // Label 9018: @541008
     /*  541008 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(541083), // Rule ID 6430 //
     /*  541013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  541030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  541062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541081 */     GIR_RootConstrainSelectedInstOperands,
     /*  541082 */     // GIR_Coverage, 6430,
     /*  541082 */     GIR_EraseRootFromParent_Done,
     /*  541083 */   // Label 9019: @541083
     /*  541083 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(541158), // Rule ID 6431 //
     /*  541088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  541105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  541137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541156 */     GIR_RootConstrainSelectedInstOperands,
     /*  541157 */     // GIR_Coverage, 6431,
     /*  541157 */     GIR_EraseRootFromParent_Done,
     /*  541158 */   // Label 9020: @541158
     /*  541158 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(541233), // Rule ID 6434 //
     /*  541163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  541180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541209 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  541212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541231 */     GIR_RootConstrainSelectedInstOperands,
     /*  541232 */     // GIR_Coverage, 6434,
     /*  541232 */     GIR_EraseRootFromParent_Done,
     /*  541233 */   // Label 9021: @541233
     /*  541233 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(541308), // Rule ID 6435 //
     /*  541238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  541255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  541287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541306 */     GIR_RootConstrainSelectedInstOperands,
     /*  541307 */     // GIR_Coverage, 6435,
     /*  541307 */     GIR_EraseRootFromParent_Done,
     /*  541308 */   // Label 9022: @541308
     /*  541308 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(541383), // Rule ID 6438 //
     /*  541313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  541324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  541327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  541330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541381 */     GIR_RootConstrainSelectedInstOperands,
     /*  541382 */     // GIR_Coverage, 6438,
     /*  541382 */     GIR_EraseRootFromParent_Done,
     /*  541383 */   // Label 9023: @541383
     /*  541383 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(541458), // Rule ID 6439 //
     /*  541388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  541399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  541402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  541405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541456 */     GIR_RootConstrainSelectedInstOperands,
     /*  541457 */     // GIR_Coverage, 6439,
     /*  541457 */     GIR_EraseRootFromParent_Done,
     /*  541458 */   // Label 9024: @541458
     /*  541458 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(541533), // Rule ID 6442 //
     /*  541463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  541480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541531 */     GIR_RootConstrainSelectedInstOperands,
     /*  541532 */     // GIR_Coverage, 6442,
     /*  541532 */     GIR_EraseRootFromParent_Done,
     /*  541533 */   // Label 9025: @541533
     /*  541533 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(541608), // Rule ID 6443 //
     /*  541538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  541555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541606 */     GIR_RootConstrainSelectedInstOperands,
     /*  541607 */     // GIR_Coverage, 6443,
     /*  541607 */     GIR_EraseRootFromParent_Done,
     /*  541608 */   // Label 9026: @541608
     /*  541608 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(541683), // Rule ID 6446 //
     /*  541613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  541630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541681 */     GIR_RootConstrainSelectedInstOperands,
     /*  541682 */     // GIR_Coverage, 6446,
     /*  541682 */     GIR_EraseRootFromParent_Done,
     /*  541683 */   // Label 9027: @541683
     /*  541683 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(541758), // Rule ID 6447 //
     /*  541688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  541705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541756 */     GIR_RootConstrainSelectedInstOperands,
     /*  541757 */     // GIR_Coverage, 6447,
     /*  541757 */     GIR_EraseRootFromParent_Done,
     /*  541758 */   // Label 9028: @541758
     /*  541758 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(541833), // Rule ID 6450 //
     /*  541763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  541766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  541780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  541783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541809 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  541809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  541828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541831 */     GIR_RootConstrainSelectedInstOperands,
     /*  541832 */     // GIR_Coverage, 6450,
     /*  541832 */     GIR_EraseRootFromParent_Done,
     /*  541833 */   // Label 9029: @541833
     /*  541833 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(541908), // Rule ID 6451 //
     /*  541838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  541841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  541855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  541858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  541884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  541887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  541903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541906 */     GIR_RootConstrainSelectedInstOperands,
     /*  541907 */     // GIR_Coverage, 6451,
     /*  541907 */     GIR_EraseRootFromParent_Done,
     /*  541908 */   // Label 9030: @541908
     /*  541908 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(541983), // Rule ID 6454 //
     /*  541913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  541924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  541927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  541930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  541933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  541962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  541968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541981 */     GIR_RootConstrainSelectedInstOperands,
     /*  541982 */     // GIR_Coverage, 6454,
     /*  541982 */     GIR_EraseRootFromParent_Done,
     /*  541983 */   // Label 9031: @541983
     /*  541983 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(542058), // Rule ID 6455 //
     /*  541988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  541996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  541999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  542002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  542005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  542037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542056 */     GIR_RootConstrainSelectedInstOperands,
     /*  542057 */     // GIR_Coverage, 6455,
     /*  542057 */     GIR_EraseRootFromParent_Done,
     /*  542058 */   // Label 9032: @542058
     /*  542058 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(542133), // Rule ID 6458 //
     /*  542063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  542074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  542077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  542080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542109 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  542112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542131 */     GIR_RootConstrainSelectedInstOperands,
     /*  542132 */     // GIR_Coverage, 6458,
     /*  542132 */     GIR_EraseRootFromParent_Done,
     /*  542133 */   // Label 9033: @542133
     /*  542133 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(542208), // Rule ID 6459 //
     /*  542138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  542149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  542152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  542155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542184 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  542187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542206 */     GIR_RootConstrainSelectedInstOperands,
     /*  542207 */     // GIR_Coverage, 6459,
     /*  542207 */     GIR_EraseRootFromParent_Done,
     /*  542208 */   // Label 9034: @542208
     /*  542208 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(542283), // Rule ID 6462 //
     /*  542213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  542224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  542227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  542230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  542233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  542262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542281 */     GIR_RootConstrainSelectedInstOperands,
     /*  542282 */     // GIR_Coverage, 6462,
     /*  542282 */     GIR_EraseRootFromParent_Done,
     /*  542283 */   // Label 9035: @542283
     /*  542283 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(542358), // Rule ID 6463 //
     /*  542288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  542299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  542302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  542305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  542308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542334 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  542337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542356 */     GIR_RootConstrainSelectedInstOperands,
     /*  542357 */     // GIR_Coverage, 6463,
     /*  542357 */     GIR_EraseRootFromParent_Done,
     /*  542358 */   // Label 9036: @542358
     /*  542358 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(542433), // Rule ID 6466 //
     /*  542363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  542380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  542412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542431 */     GIR_RootConstrainSelectedInstOperands,
     /*  542432 */     // GIR_Coverage, 6466,
     /*  542432 */     GIR_EraseRootFromParent_Done,
     /*  542433 */   // Label 9037: @542433
     /*  542433 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(542508), // Rule ID 6467 //
     /*  542438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  542455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  542487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542506 */     GIR_RootConstrainSelectedInstOperands,
     /*  542507 */     // GIR_Coverage, 6467,
     /*  542507 */     GIR_EraseRootFromParent_Done,
     /*  542508 */   // Label 9038: @542508
     /*  542508 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(542583), // Rule ID 6470 //
     /*  542513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  542530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542559 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  542562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542581 */     GIR_RootConstrainSelectedInstOperands,
     /*  542582 */     // GIR_Coverage, 6470,
     /*  542582 */     GIR_EraseRootFromParent_Done,
     /*  542583 */   // Label 9039: @542583
     /*  542583 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(542658), // Rule ID 6471 //
     /*  542588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  542605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  542637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542656 */     GIR_RootConstrainSelectedInstOperands,
     /*  542657 */     // GIR_Coverage, 6471,
     /*  542657 */     GIR_EraseRootFromParent_Done,
     /*  542658 */   // Label 9040: @542658
     /*  542658 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(542733), // Rule ID 6474 //
     /*  542663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  542680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  542683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  542712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542731 */     GIR_RootConstrainSelectedInstOperands,
     /*  542732 */     // GIR_Coverage, 6474,
     /*  542732 */     GIR_EraseRootFromParent_Done,
     /*  542733 */   // Label 9041: @542733
     /*  542733 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(542808), // Rule ID 6475 //
     /*  542738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  542755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  542758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  542787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542806 */     GIR_RootConstrainSelectedInstOperands,
     /*  542807 */     // GIR_Coverage, 6475,
     /*  542807 */     GIR_EraseRootFromParent_Done,
     /*  542808 */   // Label 9042: @542808
     /*  542808 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(542883), // Rule ID 6478 //
     /*  542813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  542830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  542862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542881 */     GIR_RootConstrainSelectedInstOperands,
     /*  542882 */     // GIR_Coverage, 6478,
     /*  542882 */     GIR_EraseRootFromParent_Done,
     /*  542883 */   // Label 9043: @542883
     /*  542883 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(542958), // Rule ID 6479 //
     /*  542888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  542905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  542937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  542943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542956 */     GIR_RootConstrainSelectedInstOperands,
     /*  542957 */     // GIR_Coverage, 6479,
     /*  542957 */     GIR_EraseRootFromParent_Done,
     /*  542958 */   // Label 9044: @542958
     /*  542958 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(543033), // Rule ID 6482 //
     /*  542963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  542971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  542980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  542983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  543012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543031 */     GIR_RootConstrainSelectedInstOperands,
     /*  543032 */     // GIR_Coverage, 6482,
     /*  543032 */     GIR_EraseRootFromParent_Done,
     /*  543033 */   // Label 9045: @543033
     /*  543033 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(543108), // Rule ID 6483 //
     /*  543038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  543055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  543087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543106 */     GIR_RootConstrainSelectedInstOperands,
     /*  543107 */     // GIR_Coverage, 6483,
     /*  543107 */     GIR_EraseRootFromParent_Done,
     /*  543108 */   // Label 9046: @543108
     /*  543108 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(543183), // Rule ID 6486 //
     /*  543113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  543130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  543133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  543162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543181 */     GIR_RootConstrainSelectedInstOperands,
     /*  543182 */     // GIR_Coverage, 6486,
     /*  543182 */     GIR_EraseRootFromParent_Done,
     /*  543183 */   // Label 9047: @543183
     /*  543183 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(543258), // Rule ID 6487 //
     /*  543188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  543205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  543208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  543237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543256 */     GIR_RootConstrainSelectedInstOperands,
     /*  543257 */     // GIR_Coverage, 6487,
     /*  543257 */     GIR_EraseRootFromParent_Done,
     /*  543258 */   // Label 9048: @543258
     /*  543258 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(543333), // Rule ID 6490 //
     /*  543263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  543266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  543280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  543283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  543309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  543312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543331 */     GIR_RootConstrainSelectedInstOperands,
     /*  543332 */     // GIR_Coverage, 6490,
     /*  543332 */     GIR_EraseRootFromParent_Done,
     /*  543333 */   // Label 9049: @543333
     /*  543333 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(543408), // Rule ID 6491 //
     /*  543338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  543341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  543355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  543358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  543384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  543387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543406 */     GIR_RootConstrainSelectedInstOperands,
     /*  543407 */     // GIR_Coverage, 6491,
     /*  543407 */     GIR_EraseRootFromParent_Done,
     /*  543408 */   // Label 9050: @543408
     /*  543408 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(543483), // Rule ID 6494 //
     /*  543413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  543416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  543430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  543433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  543459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  543462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543481 */     GIR_RootConstrainSelectedInstOperands,
     /*  543482 */     // GIR_Coverage, 6494,
     /*  543482 */     GIR_EraseRootFromParent_Done,
     /*  543483 */   // Label 9051: @543483
     /*  543483 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(543558), // Rule ID 6495 //
     /*  543488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  543491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  543505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  543508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543534 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  543534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  543537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543556 */     GIR_RootConstrainSelectedInstOperands,
     /*  543557 */     // GIR_Coverage, 6495,
     /*  543557 */     GIR_EraseRootFromParent_Done,
     /*  543558 */   // Label 9052: @543558
     /*  543558 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(543633), // Rule ID 6498 //
     /*  543563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  543566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  543580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  543583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  543609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  543612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543631 */     GIR_RootConstrainSelectedInstOperands,
     /*  543632 */     // GIR_Coverage, 6498,
     /*  543632 */     GIR_EraseRootFromParent_Done,
     /*  543633 */   // Label 9053: @543633
     /*  543633 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(543708), // Rule ID 6499 //
     /*  543638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  543641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  543655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  543658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  543684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  543687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  543703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543706 */     GIR_RootConstrainSelectedInstOperands,
     /*  543707 */     // GIR_Coverage, 6499,
     /*  543707 */     GIR_EraseRootFromParent_Done,
     /*  543708 */   // Label 9054: @543708
     /*  543708 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(543783), // Rule ID 6502 //
     /*  543713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  543724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  543727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  543730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  543733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  543752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  543762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543781 */     GIR_RootConstrainSelectedInstOperands,
     /*  543782 */     // GIR_Coverage, 6502,
     /*  543782 */     GIR_EraseRootFromParent_Done,
     /*  543783 */   // Label 9055: @543783
     /*  543783 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(543858), // Rule ID 6503 //
     /*  543788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  543799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  543802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  543805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  543808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  543827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543834 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  543837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543856 */     GIR_RootConstrainSelectedInstOperands,
     /*  543857 */     // GIR_Coverage, 6503,
     /*  543857 */     GIR_EraseRootFromParent_Done,
     /*  543858 */   // Label 9056: @543858
     /*  543858 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(543933), // Rule ID 6506 //
     /*  543863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  543874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  543877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  543880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  543883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  543902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543909 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  543912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543931 */     GIR_RootConstrainSelectedInstOperands,
     /*  543932 */     // GIR_Coverage, 6506,
     /*  543932 */     GIR_EraseRootFromParent_Done,
     /*  543933 */   // Label 9057: @543933
     /*  543933 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(544008), // Rule ID 6507 //
     /*  543938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  543946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  543949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  543952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  543955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  543958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  543977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  543987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  543993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544006 */     GIR_RootConstrainSelectedInstOperands,
     /*  544007 */     // GIR_Coverage, 6507,
     /*  544007 */     GIR_EraseRootFromParent_Done,
     /*  544008 */   // Label 9058: @544008
     /*  544008 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(544083), // Rule ID 6510 //
     /*  544013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  544024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  544027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  544030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544059 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544081 */     GIR_RootConstrainSelectedInstOperands,
     /*  544082 */     // GIR_Coverage, 6510,
     /*  544082 */     GIR_EraseRootFromParent_Done,
     /*  544083 */   // Label 9059: @544083
     /*  544083 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(544158), // Rule ID 6511 //
     /*  544088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  544099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  544102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  544105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544156 */     GIR_RootConstrainSelectedInstOperands,
     /*  544157 */     // GIR_Coverage, 6511,
     /*  544157 */     GIR_EraseRootFromParent_Done,
     /*  544158 */   // Label 9060: @544158
     /*  544158 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(544233), // Rule ID 6514 //
     /*  544163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  544180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  544212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544231 */     GIR_RootConstrainSelectedInstOperands,
     /*  544232 */     // GIR_Coverage, 6514,
     /*  544232 */     GIR_EraseRootFromParent_Done,
     /*  544233 */   // Label 9061: @544233
     /*  544233 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(544308), // Rule ID 6515 //
     /*  544238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  544255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  544287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544306 */     GIR_RootConstrainSelectedInstOperands,
     /*  544307 */     // GIR_Coverage, 6515,
     /*  544307 */     GIR_EraseRootFromParent_Done,
     /*  544308 */   // Label 9062: @544308
     /*  544308 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(544383), // Rule ID 6518 //
     /*  544313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  544330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544381 */     GIR_RootConstrainSelectedInstOperands,
     /*  544382 */     // GIR_Coverage, 6518,
     /*  544382 */     GIR_EraseRootFromParent_Done,
     /*  544383 */   // Label 9063: @544383
     /*  544383 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(544458), // Rule ID 6519 //
     /*  544388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  544405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544456 */     GIR_RootConstrainSelectedInstOperands,
     /*  544457 */     // GIR_Coverage, 6519,
     /*  544457 */     GIR_EraseRootFromParent_Done,
     /*  544458 */   // Label 9064: @544458
     /*  544458 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(544533), // Rule ID 6522 //
     /*  544463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  544480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544531 */     GIR_RootConstrainSelectedInstOperands,
     /*  544532 */     // GIR_Coverage, 6522,
     /*  544532 */     GIR_EraseRootFromParent_Done,
     /*  544533 */   // Label 9065: @544533
     /*  544533 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(544608), // Rule ID 6523 //
     /*  544538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  544555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  544587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544606 */     GIR_RootConstrainSelectedInstOperands,
     /*  544607 */     // GIR_Coverage, 6523,
     /*  544607 */     GIR_EraseRootFromParent_Done,
     /*  544608 */   // Label 9066: @544608
     /*  544608 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(544683), // Rule ID 6526 //
     /*  544613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  544624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  544627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  544630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  544662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544681 */     GIR_RootConstrainSelectedInstOperands,
     /*  544682 */     // GIR_Coverage, 6526,
     /*  544682 */     GIR_EraseRootFromParent_Done,
     /*  544683 */   // Label 9067: @544683
     /*  544683 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(544758), // Rule ID 6527 //
     /*  544688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  544699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  544702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  544705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11244:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  544737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544756 */     GIR_RootConstrainSelectedInstOperands,
     /*  544757 */     // GIR_Coverage, 6527,
     /*  544757 */     GIR_EraseRootFromParent_Done,
     /*  544758 */   // Label 9068: @544758
     /*  544758 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(544833), // Rule ID 6530 //
     /*  544763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  544780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  544812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544831 */     GIR_RootConstrainSelectedInstOperands,
     /*  544832 */     // GIR_Coverage, 6530,
     /*  544832 */     GIR_EraseRootFromParent_Done,
     /*  544833 */   // Label 9069: @544833
     /*  544833 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(544908), // Rule ID 6531 //
     /*  544838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  544855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  544858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  544887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544906 */     GIR_RootConstrainSelectedInstOperands,
     /*  544907 */     // GIR_Coverage, 6531,
     /*  544907 */     GIR_EraseRootFromParent_Done,
     /*  544908 */   // Label 9070: @544908
     /*  544908 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(544983), // Rule ID 6534 //
     /*  544913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  544930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  544933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  544952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  544962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  544968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544981 */     GIR_RootConstrainSelectedInstOperands,
     /*  544982 */     // GIR_Coverage, 6534,
     /*  544982 */     GIR_EraseRootFromParent_Done,
     /*  544983 */   // Label 9071: @544983
     /*  544983 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(545058), // Rule ID 6535 //
     /*  544988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  544996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  545005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  545037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545056 */     GIR_RootConstrainSelectedInstOperands,
     /*  545057 */     // GIR_Coverage, 6535,
     /*  545057 */     GIR_EraseRootFromParent_Done,
     /*  545058 */   // Label 9072: @545058
     /*  545058 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(545133), // Rule ID 6538 //
     /*  545063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  545066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  545080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  545109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  545112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  545128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545131 */     GIR_RootConstrainSelectedInstOperands,
     /*  545132 */     // GIR_Coverage, 6538,
     /*  545132 */     GIR_EraseRootFromParent_Done,
     /*  545133 */   // Label 9073: @545133
     /*  545133 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(545208), // Rule ID 6539 //
     /*  545138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  545141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  545155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  545184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  545187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  545203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545206 */     GIR_RootConstrainSelectedInstOperands,
     /*  545207 */     // GIR_Coverage, 6539,
     /*  545207 */     GIR_EraseRootFromParent_Done,
     /*  545208 */   // Label 9074: @545208
     /*  545208 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(545283), // Rule ID 6542 //
     /*  545213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  545224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  545227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  545230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  545262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545281 */     GIR_RootConstrainSelectedInstOperands,
     /*  545282 */     // GIR_Coverage, 6542,
     /*  545282 */     GIR_EraseRootFromParent_Done,
     /*  545283 */   // Label 9075: @545283
     /*  545283 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(545358), // Rule ID 6543 //
     /*  545288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  545299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  545302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  545305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  545337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545356 */     GIR_RootConstrainSelectedInstOperands,
     /*  545357 */     // GIR_Coverage, 6543,
     /*  545357 */     GIR_EraseRootFromParent_Done,
     /*  545358 */   // Label 9076: @545358
     /*  545358 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(545433), // Rule ID 6546 //
     /*  545363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  545374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  545377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  545380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545409 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  545412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545431 */     GIR_RootConstrainSelectedInstOperands,
     /*  545432 */     // GIR_Coverage, 6546,
     /*  545432 */     GIR_EraseRootFromParent_Done,
     /*  545433 */   // Label 9077: @545433
     /*  545433 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(545508), // Rule ID 6547 //
     /*  545438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  545449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  545452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  545455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  545487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545506 */     GIR_RootConstrainSelectedInstOperands,
     /*  545507 */     // GIR_Coverage, 6547,
     /*  545507 */     GIR_EraseRootFromParent_Done,
     /*  545508 */   // Label 9078: @545508
     /*  545508 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(545583), // Rule ID 6550 //
     /*  545513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  545524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  545527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  545530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  545562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545581 */     GIR_RootConstrainSelectedInstOperands,
     /*  545582 */     // GIR_Coverage, 6550,
     /*  545582 */     GIR_EraseRootFromParent_Done,
     /*  545583 */   // Label 9079: @545583
     /*  545583 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(545658), // Rule ID 6551 //
     /*  545588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  545599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  545602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  545605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  545637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545656 */     GIR_RootConstrainSelectedInstOperands,
     /*  545657 */     // GIR_Coverage, 6551,
     /*  545657 */     GIR_EraseRootFromParent_Done,
     /*  545658 */   // Label 9080: @545658
     /*  545658 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(545733), // Rule ID 6554 //
     /*  545663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  545674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  545677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  545680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  545712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545731 */     GIR_RootConstrainSelectedInstOperands,
     /*  545732 */     // GIR_Coverage, 6554,
     /*  545732 */     GIR_EraseRootFromParent_Done,
     /*  545733 */   // Label 9081: @545733
     /*  545733 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(545808), // Rule ID 6555 //
     /*  545738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  545749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  545752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  545755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  545787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545806 */     GIR_RootConstrainSelectedInstOperands,
     /*  545807 */     // GIR_Coverage, 6555,
     /*  545807 */     GIR_EraseRootFromParent_Done,
     /*  545808 */   // Label 9082: @545808
     /*  545808 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(545883), // Rule ID 6558 //
     /*  545813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  545830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545859 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  545862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545881 */     GIR_RootConstrainSelectedInstOperands,
     /*  545882 */     // GIR_Coverage, 6558,
     /*  545882 */     GIR_EraseRootFromParent_Done,
     /*  545883 */   // Label 9083: @545883
     /*  545883 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(545958), // Rule ID 6559 //
     /*  545888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  545905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  545908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  545927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  545937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545956 */     GIR_RootConstrainSelectedInstOperands,
     /*  545957 */     // GIR_Coverage, 6559,
     /*  545957 */     GIR_EraseRootFromParent_Done,
     /*  545958 */   // Label 9084: @545958
     /*  545958 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(546033), // Rule ID 6562 //
     /*  545963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  545971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  545974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  545977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  545980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  545983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546009 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546031 */     GIR_RootConstrainSelectedInstOperands,
     /*  546032 */     // GIR_Coverage, 6562,
     /*  546032 */     GIR_EraseRootFromParent_Done,
     /*  546033 */   // Label 9085: @546033
     /*  546033 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(546108), // Rule ID 6563 //
     /*  546038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  546049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  546052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  546055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546106 */     GIR_RootConstrainSelectedInstOperands,
     /*  546107 */     // GIR_Coverage, 6563,
     /*  546107 */     GIR_EraseRootFromParent_Done,
     /*  546108 */   // Label 9086: @546108
     /*  546108 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(546183), // Rule ID 6566 //
     /*  546113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  546130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  546162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546181 */     GIR_RootConstrainSelectedInstOperands,
     /*  546182 */     // GIR_Coverage, 6566,
     /*  546182 */     GIR_EraseRootFromParent_Done,
     /*  546183 */   // Label 9087: @546183
     /*  546183 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(546258), // Rule ID 6567 //
     /*  546188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  546205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  546237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546256 */     GIR_RootConstrainSelectedInstOperands,
     /*  546257 */     // GIR_Coverage, 6567,
     /*  546257 */     GIR_EraseRootFromParent_Done,
     /*  546258 */   // Label 9088: @546258
     /*  546258 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(546333), // Rule ID 6570 //
     /*  546263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  546274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  546277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  546280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  546312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546331 */     GIR_RootConstrainSelectedInstOperands,
     /*  546332 */     // GIR_Coverage, 6570,
     /*  546332 */     GIR_EraseRootFromParent_Done,
     /*  546333 */   // Label 9089: @546333
     /*  546333 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(546408), // Rule ID 6571 //
     /*  546338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  546349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  546352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  546355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  546387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546406 */     GIR_RootConstrainSelectedInstOperands,
     /*  546407 */     // GIR_Coverage, 6571,
     /*  546407 */     GIR_EraseRootFromParent_Done,
     /*  546408 */   // Label 9090: @546408
     /*  546408 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(546483), // Rule ID 6574 //
     /*  546413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  546424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  546427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  546430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546481 */     GIR_RootConstrainSelectedInstOperands,
     /*  546482 */     // GIR_Coverage, 6574,
     /*  546482 */     GIR_EraseRootFromParent_Done,
     /*  546483 */   // Label 9091: @546483
     /*  546483 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(546558), // Rule ID 6575 //
     /*  546488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  546499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  546502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  546505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546556 */     GIR_RootConstrainSelectedInstOperands,
     /*  546557 */     // GIR_Coverage, 6575,
     /*  546557 */     GIR_EraseRootFromParent_Done,
     /*  546558 */   // Label 9092: @546558
     /*  546558 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(546633), // Rule ID 6578 //
     /*  546563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  546566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  546580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  546609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  546612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  546628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546631 */     GIR_RootConstrainSelectedInstOperands,
     /*  546632 */     // GIR_Coverage, 6578,
     /*  546632 */     GIR_EraseRootFromParent_Done,
     /*  546633 */   // Label 9093: @546633
     /*  546633 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(546708), // Rule ID 6579 //
     /*  546638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  546641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  546655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  546684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  546687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  546703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546706 */     GIR_RootConstrainSelectedInstOperands,
     /*  546707 */     // GIR_Coverage, 6579,
     /*  546707 */     GIR_EraseRootFromParent_Done,
     /*  546708 */   // Label 9094: @546708
     /*  546708 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(546783), // Rule ID 6582 //
     /*  546713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  546716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  546730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  546759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  546762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  546778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546781 */     GIR_RootConstrainSelectedInstOperands,
     /*  546782 */     // GIR_Coverage, 6582,
     /*  546782 */     GIR_EraseRootFromParent_Done,
     /*  546783 */   // Label 9095: @546783
     /*  546783 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(546858), // Rule ID 6583 //
     /*  546788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  546791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  546805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  546834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  546837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  546853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546856 */     GIR_RootConstrainSelectedInstOperands,
     /*  546857 */     // GIR_Coverage, 6583,
     /*  546857 */     GIR_EraseRootFromParent_Done,
     /*  546858 */   // Label 9096: @546858
     /*  546858 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(546933), // Rule ID 6586 //
     /*  546863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  546866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  546880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  546883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  546909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  546928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546931 */     GIR_RootConstrainSelectedInstOperands,
     /*  546932 */     // GIR_Coverage, 6586,
     /*  546932 */     GIR_EraseRootFromParent_Done,
     /*  546933 */   // Label 9097: @546933
     /*  546933 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(547008), // Rule ID 6587 //
     /*  546938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  546941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  546946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  546955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  546958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  546977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  546984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  546987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  547003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547006 */     GIR_RootConstrainSelectedInstOperands,
     /*  547007 */     // GIR_Coverage, 6587,
     /*  547007 */     GIR_EraseRootFromParent_Done,
     /*  547008 */   // Label 9098: @547008
     /*  547008 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(547083), // Rule ID 6678 //
     /*  547013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  547062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547081 */     GIR_RootConstrainSelectedInstOperands,
     /*  547082 */     // GIR_Coverage, 6678,
     /*  547082 */     GIR_EraseRootFromParent_Done,
     /*  547083 */   // Label 9099: @547083
     /*  547083 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(547158), // Rule ID 6679 //
     /*  547088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  547137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547156 */     GIR_RootConstrainSelectedInstOperands,
     /*  547157 */     // GIR_Coverage, 6679,
     /*  547157 */     GIR_EraseRootFromParent_Done,
     /*  547158 */   // Label 9100: @547158
     /*  547158 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(547233), // Rule ID 6682 //
     /*  547163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  547212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547231 */     GIR_RootConstrainSelectedInstOperands,
     /*  547232 */     // GIR_Coverage, 6682,
     /*  547232 */     GIR_EraseRootFromParent_Done,
     /*  547233 */   // Label 9101: @547233
     /*  547233 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(547308), // Rule ID 6683 //
     /*  547238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  547287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547306 */     GIR_RootConstrainSelectedInstOperands,
     /*  547307 */     // GIR_Coverage, 6683,
     /*  547307 */     GIR_EraseRootFromParent_Done,
     /*  547308 */   // Label 9102: @547308
     /*  547308 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(547383), // Rule ID 6686 //
     /*  547313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547359 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547381 */     GIR_RootConstrainSelectedInstOperands,
     /*  547382 */     // GIR_Coverage, 6686,
     /*  547382 */     GIR_EraseRootFromParent_Done,
     /*  547383 */   // Label 9103: @547383
     /*  547383 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(547458), // Rule ID 6687 //
     /*  547388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547456 */     GIR_RootConstrainSelectedInstOperands,
     /*  547457 */     // GIR_Coverage, 6687,
     /*  547457 */     GIR_EraseRootFromParent_Done,
     /*  547458 */   // Label 9104: @547458
     /*  547458 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(547533), // Rule ID 6690 //
     /*  547463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  547512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547531 */     GIR_RootConstrainSelectedInstOperands,
     /*  547532 */     // GIR_Coverage, 6690,
     /*  547532 */     GIR_EraseRootFromParent_Done,
     /*  547533 */   // Label 9105: @547533
     /*  547533 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(547608), // Rule ID 6691 //
     /*  547538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  547587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547606 */     GIR_RootConstrainSelectedInstOperands,
     /*  547607 */     // GIR_Coverage, 6691,
     /*  547607 */     GIR_EraseRootFromParent_Done,
     /*  547608 */   // Label 9106: @547608
     /*  547608 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(547683), // Rule ID 6694 //
     /*  547613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547681 */     GIR_RootConstrainSelectedInstOperands,
     /*  547682 */     // GIR_Coverage, 6694,
     /*  547682 */     GIR_EraseRootFromParent_Done,
     /*  547683 */   // Label 9107: @547683
     /*  547683 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(547758), // Rule ID 6695 //
     /*  547688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547756 */     GIR_RootConstrainSelectedInstOperands,
     /*  547757 */     // GIR_Coverage, 6695,
     /*  547757 */     GIR_EraseRootFromParent_Done,
     /*  547758 */   // Label 9108: @547758
     /*  547758 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(547833), // Rule ID 6698 //
     /*  547763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547831 */     GIR_RootConstrainSelectedInstOperands,
     /*  547832 */     // GIR_Coverage, 6698,
     /*  547832 */     GIR_EraseRootFromParent_Done,
     /*  547833 */   // Label 9109: @547833
     /*  547833 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(547908), // Rule ID 6699 //
     /*  547838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  547887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547906 */     GIR_RootConstrainSelectedInstOperands,
     /*  547907 */     // GIR_Coverage, 6699,
     /*  547907 */     GIR_EraseRootFromParent_Done,
     /*  547908 */   // Label 9110: @547908
     /*  547908 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(547983), // Rule ID 6702 //
     /*  547913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  547962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547981 */     GIR_RootConstrainSelectedInstOperands,
     /*  547982 */     // GIR_Coverage, 6702,
     /*  547982 */     GIR_EraseRootFromParent_Done,
     /*  547983 */   // Label 9111: @547983
     /*  547983 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(548058), // Rule ID 6703 //
     /*  547988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  547996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  548002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  548005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548056 */     GIR_RootConstrainSelectedInstOperands,
     /*  548057 */     // GIR_Coverage, 6703,
     /*  548057 */     GIR_EraseRootFromParent_Done,
     /*  548058 */   // Label 9112: @548058
     /*  548058 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(548133), // Rule ID 6706 //
     /*  548063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548131 */     GIR_RootConstrainSelectedInstOperands,
     /*  548132 */     // GIR_Coverage, 6706,
     /*  548132 */     GIR_EraseRootFromParent_Done,
     /*  548133 */   // Label 9113: @548133
     /*  548133 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(548208), // Rule ID 6707 //
     /*  548138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548206 */     GIR_RootConstrainSelectedInstOperands,
     /*  548207 */     // GIR_Coverage, 6707,
     /*  548207 */     GIR_EraseRootFromParent_Done,
     /*  548208 */   // Label 9114: @548208
     /*  548208 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(548283), // Rule ID 6710 //
     /*  548213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548281 */     GIR_RootConstrainSelectedInstOperands,
     /*  548282 */     // GIR_Coverage, 6710,
     /*  548282 */     GIR_EraseRootFromParent_Done,
     /*  548283 */   // Label 9115: @548283
     /*  548283 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(548358), // Rule ID 6711 //
     /*  548288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548356 */     GIR_RootConstrainSelectedInstOperands,
     /*  548357 */     // GIR_Coverage, 6711,
     /*  548357 */     GIR_EraseRootFromParent_Done,
     /*  548358 */   // Label 9116: @548358
     /*  548358 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(548433), // Rule ID 6714 //
     /*  548363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  548366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548409 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  548409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548431 */     GIR_RootConstrainSelectedInstOperands,
     /*  548432 */     // GIR_Coverage, 6714,
     /*  548432 */     GIR_EraseRootFromParent_Done,
     /*  548433 */   // Label 9117: @548433
     /*  548433 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(548508), // Rule ID 6715 //
     /*  548438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  548441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  548484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  548487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548506 */     GIR_RootConstrainSelectedInstOperands,
     /*  548507 */     // GIR_Coverage, 6715,
     /*  548507 */     GIR_EraseRootFromParent_Done,
     /*  548508 */   // Label 9118: @548508
     /*  548508 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(548583), // Rule ID 6718 //
     /*  548513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  548562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548581 */     GIR_RootConstrainSelectedInstOperands,
     /*  548582 */     // GIR_Coverage, 6718,
     /*  548582 */     GIR_EraseRootFromParent_Done,
     /*  548583 */   // Label 9119: @548583
     /*  548583 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(548658), // Rule ID 6719 //
     /*  548588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  548637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548656 */     GIR_RootConstrainSelectedInstOperands,
     /*  548657 */     // GIR_Coverage, 6719,
     /*  548657 */     GIR_EraseRootFromParent_Done,
     /*  548658 */   // Label 9120: @548658
     /*  548658 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(548733), // Rule ID 6722 //
     /*  548663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548709 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  548712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548731 */     GIR_RootConstrainSelectedInstOperands,
     /*  548732 */     // GIR_Coverage, 6722,
     /*  548732 */     GIR_EraseRootFromParent_Done,
     /*  548733 */   // Label 9121: @548733
     /*  548733 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(548808), // Rule ID 6723 //
     /*  548738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  548787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548806 */     GIR_RootConstrainSelectedInstOperands,
     /*  548807 */     // GIR_Coverage, 6723,
     /*  548807 */     GIR_EraseRootFromParent_Done,
     /*  548808 */   // Label 9122: @548808
     /*  548808 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(548883), // Rule ID 6726 //
     /*  548813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548859 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  548862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548881 */     GIR_RootConstrainSelectedInstOperands,
     /*  548882 */     // GIR_Coverage, 6726,
     /*  548882 */     GIR_EraseRootFromParent_Done,
     /*  548883 */   // Label 9123: @548883
     /*  548883 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(548958), // Rule ID 6727 //
     /*  548888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  548937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  548943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548956 */     GIR_RootConstrainSelectedInstOperands,
     /*  548957 */     // GIR_Coverage, 6727,
     /*  548957 */     GIR_EraseRootFromParent_Done,
     /*  548958 */   // Label 9124: @548958
     /*  548958 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(549033), // Rule ID 6730 //
     /*  548963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  548971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  548980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  548983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549031 */     GIR_RootConstrainSelectedInstOperands,
     /*  549032 */     // GIR_Coverage, 6730,
     /*  549032 */     GIR_EraseRootFromParent_Done,
     /*  549033 */   // Label 9125: @549033
     /*  549033 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(549108), // Rule ID 6731 //
     /*  549038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549106 */     GIR_RootConstrainSelectedInstOperands,
     /*  549107 */     // GIR_Coverage, 6731,
     /*  549107 */     GIR_EraseRootFromParent_Done,
     /*  549108 */   // Label 9126: @549108
     /*  549108 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(549183), // Rule ID 6734 //
     /*  549113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  549162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549181 */     GIR_RootConstrainSelectedInstOperands,
     /*  549182 */     // GIR_Coverage, 6734,
     /*  549182 */     GIR_EraseRootFromParent_Done,
     /*  549183 */   // Label 9127: @549183
     /*  549183 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(549258), // Rule ID 6735 //
     /*  549188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  549237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549256 */     GIR_RootConstrainSelectedInstOperands,
     /*  549257 */     // GIR_Coverage, 6735,
     /*  549257 */     GIR_EraseRootFromParent_Done,
     /*  549258 */   // Label 9128: @549258
     /*  549258 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(549333), // Rule ID 6738 //
     /*  549263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  549312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549331 */     GIR_RootConstrainSelectedInstOperands,
     /*  549332 */     // GIR_Coverage, 6738,
     /*  549332 */     GIR_EraseRootFromParent_Done,
     /*  549333 */   // Label 9129: @549333
     /*  549333 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(549408), // Rule ID 6739 //
     /*  549338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  549387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549406 */     GIR_RootConstrainSelectedInstOperands,
     /*  549407 */     // GIR_Coverage, 6739,
     /*  549407 */     GIR_EraseRootFromParent_Done,
     /*  549408 */   // Label 9130: @549408
     /*  549408 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(549483), // Rule ID 6742 //
     /*  549413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549481 */     GIR_RootConstrainSelectedInstOperands,
     /*  549482 */     // GIR_Coverage, 6742,
     /*  549482 */     GIR_EraseRootFromParent_Done,
     /*  549483 */   // Label 9131: @549483
     /*  549483 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(549558), // Rule ID 6743 //
     /*  549488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549556 */     GIR_RootConstrainSelectedInstOperands,
     /*  549557 */     // GIR_Coverage, 6743,
     /*  549557 */     GIR_EraseRootFromParent_Done,
     /*  549558 */   // Label 9132: @549558
     /*  549558 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(549633), // Rule ID 6746 //
     /*  549563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  549612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549631 */     GIR_RootConstrainSelectedInstOperands,
     /*  549632 */     // GIR_Coverage, 6746,
     /*  549632 */     GIR_EraseRootFromParent_Done,
     /*  549633 */   // Label 9133: @549633
     /*  549633 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(549708), // Rule ID 6747 //
     /*  549638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  549687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549706 */     GIR_RootConstrainSelectedInstOperands,
     /*  549707 */     // GIR_Coverage, 6747,
     /*  549707 */     GIR_EraseRootFromParent_Done,
     /*  549708 */   // Label 9134: @549708
     /*  549708 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(549783), // Rule ID 6750 //
     /*  549713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549759 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  549762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549781 */     GIR_RootConstrainSelectedInstOperands,
     /*  549782 */     // GIR_Coverage, 6750,
     /*  549782 */     GIR_EraseRootFromParent_Done,
     /*  549783 */   // Label 9135: @549783
     /*  549783 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(549858), // Rule ID 6751 //
     /*  549788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  549837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549856 */     GIR_RootConstrainSelectedInstOperands,
     /*  549857 */     // GIR_Coverage, 6751,
     /*  549857 */     GIR_EraseRootFromParent_Done,
     /*  549858 */   // Label 9136: @549858
     /*  549858 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(549933), // Rule ID 6754 //
     /*  549863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549931 */     GIR_RootConstrainSelectedInstOperands,
     /*  549932 */     // GIR_Coverage, 6754,
     /*  549932 */     GIR_EraseRootFromParent_Done,
     /*  549933 */   // Label 9137: @549933
     /*  549933 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(550008), // Rule ID 6755 //
     /*  549938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  549946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  549987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550006 */     GIR_RootConstrainSelectedInstOperands,
     /*  550007 */     // GIR_Coverage, 6755,
     /*  550007 */     GIR_EraseRootFromParent_Done,
     /*  550008 */   // Label 9138: @550008
     /*  550008 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(550083), // Rule ID 6758 //
     /*  550013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  550062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550081 */     GIR_RootConstrainSelectedInstOperands,
     /*  550082 */     // GIR_Coverage, 6758,
     /*  550082 */     GIR_EraseRootFromParent_Done,
     /*  550083 */   // Label 9139: @550083
     /*  550083 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(550158), // Rule ID 6759 //
     /*  550088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  550137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550156 */     GIR_RootConstrainSelectedInstOperands,
     /*  550157 */     // GIR_Coverage, 6759,
     /*  550157 */     GIR_EraseRootFromParent_Done,
     /*  550158 */   // Label 9140: @550158
     /*  550158 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(550233), // Rule ID 6762 //
     /*  550163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  550212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550231 */     GIR_RootConstrainSelectedInstOperands,
     /*  550232 */     // GIR_Coverage, 6762,
     /*  550232 */     GIR_EraseRootFromParent_Done,
     /*  550233 */   // Label 9141: @550233
     /*  550233 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(550308), // Rule ID 6763 //
     /*  550238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  550287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550306 */     GIR_RootConstrainSelectedInstOperands,
     /*  550307 */     // GIR_Coverage, 6763,
     /*  550307 */     GIR_EraseRootFromParent_Done,
     /*  550308 */   // Label 9142: @550308
     /*  550308 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(550383), // Rule ID 6766 //
     /*  550313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  550333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  550362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550381 */     GIR_RootConstrainSelectedInstOperands,
     /*  550382 */     // GIR_Coverage, 6766,
     /*  550382 */     GIR_EraseRootFromParent_Done,
     /*  550383 */   // Label 9143: @550383
     /*  550383 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(550458), // Rule ID 6767 //
     /*  550388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  550408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  550437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550456 */     GIR_RootConstrainSelectedInstOperands,
     /*  550457 */     // GIR_Coverage, 6767,
     /*  550457 */     GIR_EraseRootFromParent_Done,
     /*  550458 */   // Label 9144: @550458
     /*  550458 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(550533), // Rule ID 6770 //
     /*  550463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  550483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550509 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  550512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550531 */     GIR_RootConstrainSelectedInstOperands,
     /*  550532 */     // GIR_Coverage, 6770,
     /*  550532 */     GIR_EraseRootFromParent_Done,
     /*  550533 */   // Label 9145: @550533
     /*  550533 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(550608), // Rule ID 6771 //
     /*  550538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  550558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550584 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  550587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550606 */     GIR_RootConstrainSelectedInstOperands,
     /*  550607 */     // GIR_Coverage, 6771,
     /*  550607 */     GIR_EraseRootFromParent_Done,
     /*  550608 */   // Label 9146: @550608
     /*  550608 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(550683), // Rule ID 6774 //
     /*  550613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  550633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550659 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  550662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550681 */     GIR_RootConstrainSelectedInstOperands,
     /*  550682 */     // GIR_Coverage, 6774,
     /*  550682 */     GIR_EraseRootFromParent_Done,
     /*  550683 */   // Label 9147: @550683
     /*  550683 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(550758), // Rule ID 6775 //
     /*  550688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  550708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  550737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550756 */     GIR_RootConstrainSelectedInstOperands,
     /*  550757 */     // GIR_Coverage, 6775,
     /*  550757 */     GIR_EraseRootFromParent_Done,
     /*  550758 */   // Label 9148: @550758
     /*  550758 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(550833), // Rule ID 6778 //
     /*  550763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  550783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  550812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550831 */     GIR_RootConstrainSelectedInstOperands,
     /*  550832 */     // GIR_Coverage, 6778,
     /*  550832 */     GIR_EraseRootFromParent_Done,
     /*  550833 */   // Label 9149: @550833
     /*  550833 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(550908), // Rule ID 6779 //
     /*  550838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  550858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  550887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550906 */     GIR_RootConstrainSelectedInstOperands,
     /*  550907 */     // GIR_Coverage, 6779,
     /*  550907 */     GIR_EraseRootFromParent_Done,
     /*  550908 */   // Label 9150: @550908
     /*  550908 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(550983), // Rule ID 6782 //
     /*  550913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  550933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  550952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  550962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550981 */     GIR_RootConstrainSelectedInstOperands,
     /*  550982 */     // GIR_Coverage, 6782,
     /*  550982 */     GIR_EraseRootFromParent_Done,
     /*  550983 */   // Label 9151: @550983
     /*  550983 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(551058), // Rule ID 6783 //
     /*  550988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  550996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  551037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551056 */     GIR_RootConstrainSelectedInstOperands,
     /*  551057 */     // GIR_Coverage, 6783,
     /*  551057 */     GIR_EraseRootFromParent_Done,
     /*  551058 */   // Label 9152: @551058
     /*  551058 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(551133), // Rule ID 6786 //
     /*  551063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  551112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551131 */     GIR_RootConstrainSelectedInstOperands,
     /*  551132 */     // GIR_Coverage, 6786,
     /*  551132 */     GIR_EraseRootFromParent_Done,
     /*  551133 */   // Label 9153: @551133
     /*  551133 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(551208), // Rule ID 6787 //
     /*  551138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  551187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551206 */     GIR_RootConstrainSelectedInstOperands,
     /*  551207 */     // GIR_Coverage, 6787,
     /*  551207 */     GIR_EraseRootFromParent_Done,
     /*  551208 */   // Label 9154: @551208
     /*  551208 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(551283), // Rule ID 6790 //
     /*  551213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551281 */     GIR_RootConstrainSelectedInstOperands,
     /*  551282 */     // GIR_Coverage, 6790,
     /*  551282 */     GIR_EraseRootFromParent_Done,
     /*  551283 */   // Label 9155: @551283
     /*  551283 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(551358), // Rule ID 6791 //
     /*  551288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11272:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551356 */     GIR_RootConstrainSelectedInstOperands,
     /*  551357 */     // GIR_Coverage, 6791,
     /*  551357 */     GIR_EraseRootFromParent_Done,
     /*  551358 */   // Label 9156: @551358
     /*  551358 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(551433), // Rule ID 6794 //
     /*  551363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551431 */     GIR_RootConstrainSelectedInstOperands,
     /*  551432 */     // GIR_Coverage, 6794,
     /*  551432 */     GIR_EraseRootFromParent_Done,
     /*  551433 */   // Label 9157: @551433
     /*  551433 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(551508), // Rule ID 6795 //
     /*  551438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551506 */     GIR_RootConstrainSelectedInstOperands,
     /*  551507 */     // GIR_Coverage, 6795,
     /*  551507 */     GIR_EraseRootFromParent_Done,
     /*  551508 */   // Label 9158: @551508
     /*  551508 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(551583), // Rule ID 6798 //
     /*  551513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551581 */     GIR_RootConstrainSelectedInstOperands,
     /*  551582 */     // GIR_Coverage, 6798,
     /*  551582 */     GIR_EraseRootFromParent_Done,
     /*  551583 */   // Label 9159: @551583
     /*  551583 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(551658), // Rule ID 6799 //
     /*  551588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551656 */     GIR_RootConstrainSelectedInstOperands,
     /*  551657 */     // GIR_Coverage, 6799,
     /*  551657 */     GIR_EraseRootFromParent_Done,
     /*  551658 */   // Label 9160: @551658
     /*  551658 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(551733), // Rule ID 6802 //
     /*  551663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  551666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551731 */     GIR_RootConstrainSelectedInstOperands,
     /*  551732 */     // GIR_Coverage, 6802,
     /*  551732 */     GIR_EraseRootFromParent_Done,
     /*  551733 */   // Label 9161: @551733
     /*  551733 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(551808), // Rule ID 6803 //
     /*  551738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  551741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  551784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  551787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551806 */     GIR_RootConstrainSelectedInstOperands,
     /*  551807 */     // GIR_Coverage, 6803,
     /*  551807 */     GIR_EraseRootFromParent_Done,
     /*  551808 */   // Label 9162: @551808
     /*  551808 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(551883), // Rule ID 6806 //
     /*  551813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  551862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551881 */     GIR_RootConstrainSelectedInstOperands,
     /*  551882 */     // GIR_Coverage, 6806,
     /*  551882 */     GIR_EraseRootFromParent_Done,
     /*  551883 */   // Label 9163: @551883
     /*  551883 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(551958), // Rule ID 6807 //
     /*  551888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  551908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  551927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  551937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551956 */     GIR_RootConstrainSelectedInstOperands,
     /*  551957 */     // GIR_Coverage, 6807,
     /*  551957 */     GIR_EraseRootFromParent_Done,
     /*  551958 */   // Label 9164: @551958
     /*  551958 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(552033), // Rule ID 6810 //
     /*  551963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  551971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  551983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552009 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552031 */     GIR_RootConstrainSelectedInstOperands,
     /*  552032 */     // GIR_Coverage, 6810,
     /*  552032 */     GIR_EraseRootFromParent_Done,
     /*  552033 */   // Label 9165: @552033
     /*  552033 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(552108), // Rule ID 6811 //
     /*  552038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552106 */     GIR_RootConstrainSelectedInstOperands,
     /*  552107 */     // GIR_Coverage, 6811,
     /*  552107 */     GIR_EraseRootFromParent_Done,
     /*  552108 */   // Label 9166: @552108
     /*  552108 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(552183), // Rule ID 6814 //
     /*  552113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  552162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552181 */     GIR_RootConstrainSelectedInstOperands,
     /*  552182 */     // GIR_Coverage, 6814,
     /*  552182 */     GIR_EraseRootFromParent_Done,
     /*  552183 */   // Label 9167: @552183
     /*  552183 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(552258), // Rule ID 6815 //
     /*  552188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552234 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  552237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552256 */     GIR_RootConstrainSelectedInstOperands,
     /*  552257 */     // GIR_Coverage, 6815,
     /*  552257 */     GIR_EraseRootFromParent_Done,
     /*  552258 */   // Label 9168: @552258
     /*  552258 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(552333), // Rule ID 6818 //
     /*  552263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  552312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552331 */     GIR_RootConstrainSelectedInstOperands,
     /*  552332 */     // GIR_Coverage, 6818,
     /*  552332 */     GIR_EraseRootFromParent_Done,
     /*  552333 */   // Label 9169: @552333
     /*  552333 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(552408), // Rule ID 6819 //
     /*  552338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  552387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552406 */     GIR_RootConstrainSelectedInstOperands,
     /*  552407 */     // GIR_Coverage, 6819,
     /*  552407 */     GIR_EraseRootFromParent_Done,
     /*  552408 */   // Label 9170: @552408
     /*  552408 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(552483), // Rule ID 6822 //
     /*  552413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552481 */     GIR_RootConstrainSelectedInstOperands,
     /*  552482 */     // GIR_Coverage, 6822,
     /*  552482 */     GIR_EraseRootFromParent_Done,
     /*  552483 */   // Label 9171: @552483
     /*  552483 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(552558), // Rule ID 6823 //
     /*  552488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552556 */     GIR_RootConstrainSelectedInstOperands,
     /*  552557 */     // GIR_Coverage, 6823,
     /*  552557 */     GIR_EraseRootFromParent_Done,
     /*  552558 */   // Label 9172: @552558
     /*  552558 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(552633), // Rule ID 6826 //
     /*  552563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  552612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552631 */     GIR_RootConstrainSelectedInstOperands,
     /*  552632 */     // GIR_Coverage, 6826,
     /*  552632 */     GIR_EraseRootFromParent_Done,
     /*  552633 */   // Label 9173: @552633
     /*  552633 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(552708), // Rule ID 6827 //
     /*  552638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  552687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552706 */     GIR_RootConstrainSelectedInstOperands,
     /*  552707 */     // GIR_Coverage, 6827,
     /*  552707 */     GIR_EraseRootFromParent_Done,
     /*  552708 */   // Label 9174: @552708
     /*  552708 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(552783), // Rule ID 6830 //
     /*  552713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  552762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552781 */     GIR_RootConstrainSelectedInstOperands,
     /*  552782 */     // GIR_Coverage, 6830,
     /*  552782 */     GIR_EraseRootFromParent_Done,
     /*  552783 */   // Label 9175: @552783
     /*  552783 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(552858), // Rule ID 6831 //
     /*  552788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  552837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552856 */     GIR_RootConstrainSelectedInstOperands,
     /*  552857 */     // GIR_Coverage, 6831,
     /*  552857 */     GIR_EraseRootFromParent_Done,
     /*  552858 */   // Label 9176: @552858
     /*  552858 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(552933), // Rule ID 6834 //
     /*  552863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552909 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552931 */     GIR_RootConstrainSelectedInstOperands,
     /*  552932 */     // GIR_Coverage, 6834,
     /*  552932 */     GIR_EraseRootFromParent_Done,
     /*  552933 */   // Label 9177: @552933
     /*  552933 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(553008), // Rule ID 6835 //
     /*  552938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  552946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  552958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  552987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553006 */     GIR_RootConstrainSelectedInstOperands,
     /*  553007 */     // GIR_Coverage, 6835,
     /*  553007 */     GIR_EraseRootFromParent_Done,
     /*  553008 */   // Label 9178: @553008
     /*  553008 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(553083), // Rule ID 6838 //
     /*  553013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  553062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553081 */     GIR_RootConstrainSelectedInstOperands,
     /*  553082 */     // GIR_Coverage, 6838,
     /*  553082 */     GIR_EraseRootFromParent_Done,
     /*  553083 */   // Label 9179: @553083
     /*  553083 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(553158), // Rule ID 6839 //
     /*  553088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  553137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553156 */     GIR_RootConstrainSelectedInstOperands,
     /*  553157 */     // GIR_Coverage, 6839,
     /*  553157 */     GIR_EraseRootFromParent_Done,
     /*  553158 */   // Label 9180: @553158
     /*  553158 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(553233), // Rule ID 6842 //
     /*  553163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  553212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553231 */     GIR_RootConstrainSelectedInstOperands,
     /*  553232 */     // GIR_Coverage, 6842,
     /*  553232 */     GIR_EraseRootFromParent_Done,
     /*  553233 */   // Label 9181: @553233
     /*  553233 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(553308), // Rule ID 6843 //
     /*  553238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  553287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553306 */     GIR_RootConstrainSelectedInstOperands,
     /*  553307 */     // GIR_Coverage, 6843,
     /*  553307 */     GIR_EraseRootFromParent_Done,
     /*  553308 */   // Label 9182: @553308
     /*  553308 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(553383), // Rule ID 6846 //
     /*  553313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  553362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553381 */     GIR_RootConstrainSelectedInstOperands,
     /*  553382 */     // GIR_Coverage, 6846,
     /*  553382 */     GIR_EraseRootFromParent_Done,
     /*  553383 */   // Label 9183: @553383
     /*  553383 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(553458), // Rule ID 6847 //
     /*  553388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  553437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553456 */     GIR_RootConstrainSelectedInstOperands,
     /*  553457 */     // GIR_Coverage, 6847,
     /*  553457 */     GIR_EraseRootFromParent_Done,
     /*  553458 */   // Label 9184: @553458
     /*  553458 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(553533), // Rule ID 6850 //
     /*  553463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  553512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553531 */     GIR_RootConstrainSelectedInstOperands,
     /*  553532 */     // GIR_Coverage, 6850,
     /*  553532 */     GIR_EraseRootFromParent_Done,
     /*  553533 */   // Label 9185: @553533
     /*  553533 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(553608), // Rule ID 6851 //
     /*  553538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  553546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  553587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553606 */     GIR_RootConstrainSelectedInstOperands,
     /*  553607 */     // GIR_Coverage, 6851,
     /*  553607 */     GIR_EraseRootFromParent_Done,
     /*  553608 */   // Label 9186: @553608
     /*  553608 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(553683), // Rule ID 6942 //
     /*  553613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  553633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  553662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553681 */     GIR_RootConstrainSelectedInstOperands,
     /*  553682 */     // GIR_Coverage, 6942,
     /*  553682 */     GIR_EraseRootFromParent_Done,
     /*  553683 */   // Label 9187: @553683
     /*  553683 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(553758), // Rule ID 6943 //
     /*  553688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  553708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  553737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553756 */     GIR_RootConstrainSelectedInstOperands,
     /*  553757 */     // GIR_Coverage, 6943,
     /*  553757 */     GIR_EraseRootFromParent_Done,
     /*  553758 */   // Label 9188: @553758
     /*  553758 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(553833), // Rule ID 6946 //
     /*  553763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  553783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  553812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553831 */     GIR_RootConstrainSelectedInstOperands,
     /*  553832 */     // GIR_Coverage, 6946,
     /*  553832 */     GIR_EraseRootFromParent_Done,
     /*  553833 */   // Label 9189: @553833
     /*  553833 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(553908), // Rule ID 6947 //
     /*  553838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  553858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  553887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553906 */     GIR_RootConstrainSelectedInstOperands,
     /*  553907 */     // GIR_Coverage, 6947,
     /*  553907 */     GIR_EraseRootFromParent_Done,
     /*  553908 */   // Label 9190: @553908
     /*  553908 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(553983), // Rule ID 6950 //
     /*  553913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  553933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  553962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553981 */     GIR_RootConstrainSelectedInstOperands,
     /*  553982 */     // GIR_Coverage, 6950,
     /*  553982 */     GIR_EraseRootFromParent_Done,
     /*  553983 */   // Label 9191: @553983
     /*  553983 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(554058), // Rule ID 6951 //
     /*  553988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  553996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  554008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  554037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554056 */     GIR_RootConstrainSelectedInstOperands,
     /*  554057 */     // GIR_Coverage, 6951,
     /*  554057 */     GIR_EraseRootFromParent_Done,
     /*  554058 */   // Label 9192: @554058
     /*  554058 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(554133), // Rule ID 6954 //
     /*  554063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  554112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554131 */     GIR_RootConstrainSelectedInstOperands,
     /*  554132 */     // GIR_Coverage, 6954,
     /*  554132 */     GIR_EraseRootFromParent_Done,
     /*  554133 */   // Label 9193: @554133
     /*  554133 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(554208), // Rule ID 6955 //
     /*  554138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  554187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554206 */     GIR_RootConstrainSelectedInstOperands,
     /*  554207 */     // GIR_Coverage, 6955,
     /*  554207 */     GIR_EraseRootFromParent_Done,
     /*  554208 */   // Label 9194: @554208
     /*  554208 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(554283), // Rule ID 6958 //
     /*  554213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  554262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554281 */     GIR_RootConstrainSelectedInstOperands,
     /*  554282 */     // GIR_Coverage, 6958,
     /*  554282 */     GIR_EraseRootFromParent_Done,
     /*  554283 */   // Label 9195: @554283
     /*  554283 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(554358), // Rule ID 6959 //
     /*  554288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  554337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554356 */     GIR_RootConstrainSelectedInstOperands,
     /*  554357 */     // GIR_Coverage, 6959,
     /*  554357 */     GIR_EraseRootFromParent_Done,
     /*  554358 */   // Label 9196: @554358
     /*  554358 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(554433), // Rule ID 6962 //
     /*  554363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  554412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554431 */     GIR_RootConstrainSelectedInstOperands,
     /*  554432 */     // GIR_Coverage, 6962,
     /*  554432 */     GIR_EraseRootFromParent_Done,
     /*  554433 */   // Label 9197: @554433
     /*  554433 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(554508), // Rule ID 6963 //
     /*  554438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  554487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554506 */     GIR_RootConstrainSelectedInstOperands,
     /*  554507 */     // GIR_Coverage, 6963,
     /*  554507 */     GIR_EraseRootFromParent_Done,
     /*  554508 */   // Label 9198: @554508
     /*  554508 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(554583), // Rule ID 6966 //
     /*  554513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554559 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554581 */     GIR_RootConstrainSelectedInstOperands,
     /*  554582 */     // GIR_Coverage, 6966,
     /*  554582 */     GIR_EraseRootFromParent_Done,
     /*  554583 */   // Label 9199: @554583
     /*  554583 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(554658), // Rule ID 6967 //
     /*  554588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554656 */     GIR_RootConstrainSelectedInstOperands,
     /*  554657 */     // GIR_Coverage, 6967,
     /*  554657 */     GIR_EraseRootFromParent_Done,
     /*  554658 */   // Label 9200: @554658
     /*  554658 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(554733), // Rule ID 6970 //
     /*  554663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  554683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554731 */     GIR_RootConstrainSelectedInstOperands,
     /*  554732 */     // GIR_Coverage, 6970,
     /*  554732 */     GIR_EraseRootFromParent_Done,
     /*  554733 */   // Label 9201: @554733
     /*  554733 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(554808), // Rule ID 6971 //
     /*  554738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  554758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554806 */     GIR_RootConstrainSelectedInstOperands,
     /*  554807 */     // GIR_Coverage, 6971,
     /*  554807 */     GIR_EraseRootFromParent_Done,
     /*  554808 */   // Label 9202: @554808
     /*  554808 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(554883), // Rule ID 6974 //
     /*  554813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  554833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554881 */     GIR_RootConstrainSelectedInstOperands,
     /*  554882 */     // GIR_Coverage, 6974,
     /*  554882 */     GIR_EraseRootFromParent_Done,
     /*  554883 */   // Label 9203: @554883
     /*  554883 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(554958), // Rule ID 6975 //
     /*  554888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  554908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  554937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554956 */     GIR_RootConstrainSelectedInstOperands,
     /*  554957 */     // GIR_Coverage, 6975,
     /*  554957 */     GIR_EraseRootFromParent_Done,
     /*  554958 */   // Label 9204: @554958
     /*  554958 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(555033), // Rule ID 6978 //
     /*  554963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  554966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  554971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  554983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  555012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555031 */     GIR_RootConstrainSelectedInstOperands,
     /*  555032 */     // GIR_Coverage, 6978,
     /*  555032 */     GIR_EraseRootFromParent_Done,
     /*  555033 */   // Label 9205: @555033
     /*  555033 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(555108), // Rule ID 6979 //
     /*  555038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  555058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  555087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555106 */     GIR_RootConstrainSelectedInstOperands,
     /*  555107 */     // GIR_Coverage, 6979,
     /*  555107 */     GIR_EraseRootFromParent_Done,
     /*  555108 */   // Label 9206: @555108
     /*  555108 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(555183), // Rule ID 6982 //
     /*  555113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  555162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555181 */     GIR_RootConstrainSelectedInstOperands,
     /*  555182 */     // GIR_Coverage, 6982,
     /*  555182 */     GIR_EraseRootFromParent_Done,
     /*  555183 */   // Label 9207: @555183
     /*  555183 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(555258), // Rule ID 6983 //
     /*  555188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  555237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555256 */     GIR_RootConstrainSelectedInstOperands,
     /*  555257 */     // GIR_Coverage, 6983,
     /*  555257 */     GIR_EraseRootFromParent_Done,
     /*  555258 */   // Label 9208: @555258
     /*  555258 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(555333), // Rule ID 6986 //
     /*  555263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555309 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  555312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555331 */     GIR_RootConstrainSelectedInstOperands,
     /*  555332 */     // GIR_Coverage, 6986,
     /*  555332 */     GIR_EraseRootFromParent_Done,
     /*  555333 */   // Label 9209: @555333
     /*  555333 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(555408), // Rule ID 6987 //
     /*  555338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  555387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555406 */     GIR_RootConstrainSelectedInstOperands,
     /*  555407 */     // GIR_Coverage, 6987,
     /*  555407 */     GIR_EraseRootFromParent_Done,
     /*  555408 */   // Label 9210: @555408
     /*  555408 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(555483), // Rule ID 6990 //
     /*  555413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555459 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  555462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555481 */     GIR_RootConstrainSelectedInstOperands,
     /*  555482 */     // GIR_Coverage, 6990,
     /*  555482 */     GIR_EraseRootFromParent_Done,
     /*  555483 */   // Label 9211: @555483
     /*  555483 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(555558), // Rule ID 6991 //
     /*  555488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  555537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555556 */     GIR_RootConstrainSelectedInstOperands,
     /*  555557 */     // GIR_Coverage, 6991,
     /*  555557 */     GIR_EraseRootFromParent_Done,
     /*  555558 */   // Label 9212: @555558
     /*  555558 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(555633), // Rule ID 6994 //
     /*  555563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  555583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  555612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555631 */     GIR_RootConstrainSelectedInstOperands,
     /*  555632 */     // GIR_Coverage, 6994,
     /*  555632 */     GIR_EraseRootFromParent_Done,
     /*  555633 */   // Label 9213: @555633
     /*  555633 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(555708), // Rule ID 6995 //
     /*  555638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  555658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  555687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555706 */     GIR_RootConstrainSelectedInstOperands,
     /*  555707 */     // GIR_Coverage, 6995,
     /*  555707 */     GIR_EraseRootFromParent_Done,
     /*  555708 */   // Label 9214: @555708
     /*  555708 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(555783), // Rule ID 6998 //
     /*  555713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  555733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  555762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555781 */     GIR_RootConstrainSelectedInstOperands,
     /*  555782 */     // GIR_Coverage, 6998,
     /*  555782 */     GIR_EraseRootFromParent_Done,
     /*  555783 */   // Label 9215: @555783
     /*  555783 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(555858), // Rule ID 6999 //
     /*  555788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  555808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  555837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555856 */     GIR_RootConstrainSelectedInstOperands,
     /*  555857 */     // GIR_Coverage, 6999,
     /*  555857 */     GIR_EraseRootFromParent_Done,
     /*  555858 */   // Label 9216: @555858
     /*  555858 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(555933), // Rule ID 7002 //
     /*  555863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  555883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555909 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  555912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555931 */     GIR_RootConstrainSelectedInstOperands,
     /*  555932 */     // GIR_Coverage, 7002,
     /*  555932 */     GIR_EraseRootFromParent_Done,
     /*  555933 */   // Label 9217: @555933
     /*  555933 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(556008), // Rule ID 7003 //
     /*  555938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  555946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  555958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  555987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556006 */     GIR_RootConstrainSelectedInstOperands,
     /*  556007 */     // GIR_Coverage, 7003,
     /*  556007 */     GIR_EraseRootFromParent_Done,
     /*  556008 */   // Label 9218: @556008
     /*  556008 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(556083), // Rule ID 7006 //
     /*  556013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  556062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556081 */     GIR_RootConstrainSelectedInstOperands,
     /*  556082 */     // GIR_Coverage, 7006,
     /*  556082 */     GIR_EraseRootFromParent_Done,
     /*  556083 */   // Label 9219: @556083
     /*  556083 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(556158), // Rule ID 7007 //
     /*  556088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  556137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556156 */     GIR_RootConstrainSelectedInstOperands,
     /*  556157 */     // GIR_Coverage, 7007,
     /*  556157 */     GIR_EraseRootFromParent_Done,
     /*  556158 */   // Label 9220: @556158
     /*  556158 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(556233), // Rule ID 7010 //
     /*  556163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  556212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556231 */     GIR_RootConstrainSelectedInstOperands,
     /*  556232 */     // GIR_Coverage, 7010,
     /*  556232 */     GIR_EraseRootFromParent_Done,
     /*  556233 */   // Label 9221: @556233
     /*  556233 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(556308), // Rule ID 7011 //
     /*  556238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  556287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556306 */     GIR_RootConstrainSelectedInstOperands,
     /*  556307 */     // GIR_Coverage, 7011,
     /*  556307 */     GIR_EraseRootFromParent_Done,
     /*  556308 */   // Label 9222: @556308
     /*  556308 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(556383), // Rule ID 7014 //
     /*  556313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556359 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  556362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556381 */     GIR_RootConstrainSelectedInstOperands,
     /*  556382 */     // GIR_Coverage, 7014,
     /*  556382 */     GIR_EraseRootFromParent_Done,
     /*  556383 */   // Label 9223: @556383
     /*  556383 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(556458), // Rule ID 7015 //
     /*  556388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  556437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556456 */     GIR_RootConstrainSelectedInstOperands,
     /*  556457 */     // GIR_Coverage, 7015,
     /*  556457 */     GIR_EraseRootFromParent_Done,
     /*  556458 */   // Label 9224: @556458
     /*  556458 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(556533), // Rule ID 7018 //
     /*  556463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  556512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556531 */     GIR_RootConstrainSelectedInstOperands,
     /*  556532 */     // GIR_Coverage, 7018,
     /*  556532 */     GIR_EraseRootFromParent_Done,
     /*  556533 */   // Label 9225: @556533
     /*  556533 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(556608), // Rule ID 7019 //
     /*  556538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  556587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556606 */     GIR_RootConstrainSelectedInstOperands,
     /*  556607 */     // GIR_Coverage, 7019,
     /*  556607 */     GIR_EraseRootFromParent_Done,
     /*  556608 */   // Label 9226: @556608
     /*  556608 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(556683), // Rule ID 7022 //
     /*  556613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  556633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  556662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556681 */     GIR_RootConstrainSelectedInstOperands,
     /*  556682 */     // GIR_Coverage, 7022,
     /*  556682 */     GIR_EraseRootFromParent_Done,
     /*  556683 */   // Label 9227: @556683
     /*  556683 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(556758), // Rule ID 7023 //
     /*  556688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  556708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  556737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556756 */     GIR_RootConstrainSelectedInstOperands,
     /*  556757 */     // GIR_Coverage, 7023,
     /*  556757 */     GIR_EraseRootFromParent_Done,
     /*  556758 */   // Label 9228: @556758
     /*  556758 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(556833), // Rule ID 7026 //
     /*  556763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  556783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  556812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556831 */     GIR_RootConstrainSelectedInstOperands,
     /*  556832 */     // GIR_Coverage, 7026,
     /*  556832 */     GIR_EraseRootFromParent_Done,
     /*  556833 */   // Label 9229: @556833
     /*  556833 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(556908), // Rule ID 7027 //
     /*  556838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  556858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  556887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556906 */     GIR_RootConstrainSelectedInstOperands,
     /*  556907 */     // GIR_Coverage, 7027,
     /*  556907 */     GIR_EraseRootFromParent_Done,
     /*  556908 */   // Label 9230: @556908
     /*  556908 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(556983), // Rule ID 7030 //
     /*  556913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  556962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556981 */     GIR_RootConstrainSelectedInstOperands,
     /*  556982 */     // GIR_Coverage, 7030,
     /*  556982 */     GIR_EraseRootFromParent_Done,
     /*  556983 */   // Label 9231: @556983
     /*  556983 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(557058), // Rule ID 7031 //
     /*  556988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  556996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  557037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557056 */     GIR_RootConstrainSelectedInstOperands,
     /*  557057 */     // GIR_Coverage, 7031,
     /*  557057 */     GIR_EraseRootFromParent_Done,
     /*  557058 */   // Label 9232: @557058
     /*  557058 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(557133), // Rule ID 7034 //
     /*  557063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  557112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557131 */     GIR_RootConstrainSelectedInstOperands,
     /*  557132 */     // GIR_Coverage, 7034,
     /*  557132 */     GIR_EraseRootFromParent_Done,
     /*  557133 */   // Label 9233: @557133
     /*  557133 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(557208), // Rule ID 7035 //
     /*  557138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  557187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557206 */     GIR_RootConstrainSelectedInstOperands,
     /*  557207 */     // GIR_Coverage, 7035,
     /*  557207 */     GIR_EraseRootFromParent_Done,
     /*  557208 */   // Label 9234: @557208
     /*  557208 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(557283), // Rule ID 7038 //
     /*  557213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557281 */     GIR_RootConstrainSelectedInstOperands,
     /*  557282 */     // GIR_Coverage, 7038,
     /*  557282 */     GIR_EraseRootFromParent_Done,
     /*  557283 */   // Label 9235: @557283
     /*  557283 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(557358), // Rule ID 7039 //
     /*  557288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557356 */     GIR_RootConstrainSelectedInstOperands,
     /*  557357 */     // GIR_Coverage, 7039,
     /*  557357 */     GIR_EraseRootFromParent_Done,
     /*  557358 */   // Label 9236: @557358
     /*  557358 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(557433), // Rule ID 7042 //
     /*  557363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  557412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557431 */     GIR_RootConstrainSelectedInstOperands,
     /*  557432 */     // GIR_Coverage, 7042,
     /*  557432 */     GIR_EraseRootFromParent_Done,
     /*  557433 */   // Label 9237: @557433
     /*  557433 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(557508), // Rule ID 7043 //
     /*  557438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  557487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557506 */     GIR_RootConstrainSelectedInstOperands,
     /*  557507 */     // GIR_Coverage, 7043,
     /*  557507 */     GIR_EraseRootFromParent_Done,
     /*  557508 */   // Label 9238: @557508
     /*  557508 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(557583), // Rule ID 7046 //
     /*  557513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557581 */     GIR_RootConstrainSelectedInstOperands,
     /*  557582 */     // GIR_Coverage, 7046,
     /*  557582 */     GIR_EraseRootFromParent_Done,
     /*  557583 */   // Label 9239: @557583
     /*  557583 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(557658), // Rule ID 7047 //
     /*  557588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557656 */     GIR_RootConstrainSelectedInstOperands,
     /*  557657 */     // GIR_Coverage, 7047,
     /*  557657 */     GIR_EraseRootFromParent_Done,
     /*  557658 */   // Label 9240: @557658
     /*  557658 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(557733), // Rule ID 7050 //
     /*  557663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557731 */     GIR_RootConstrainSelectedInstOperands,
     /*  557732 */     // GIR_Coverage, 7050,
     /*  557732 */     GIR_EraseRootFromParent_Done,
     /*  557733 */   // Label 9241: @557733
     /*  557733 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(557808), // Rule ID 7051 //
     /*  557738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  557784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  557787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557806 */     GIR_RootConstrainSelectedInstOperands,
     /*  557807 */     // GIR_Coverage, 7051,
     /*  557807 */     GIR_EraseRootFromParent_Done,
     /*  557808 */   // Label 9242: @557808
     /*  557808 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(557883), // Rule ID 7054 //
     /*  557813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  557862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557881 */     GIR_RootConstrainSelectedInstOperands,
     /*  557882 */     // GIR_Coverage, 7054,
     /*  557882 */     GIR_EraseRootFromParent_Done,
     /*  557883 */   // Label 9243: @557883
     /*  557883 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(557958), // Rule ID 7055 //
     /*  557888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11270:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  557937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557956 */     GIR_RootConstrainSelectedInstOperands,
     /*  557957 */     // GIR_Coverage, 7055,
     /*  557957 */     GIR_EraseRootFromParent_Done,
     /*  557958 */   // Label 9244: @557958
     /*  557958 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(558033), // Rule ID 7058 //
     /*  557963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  557971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558031 */     GIR_RootConstrainSelectedInstOperands,
     /*  558032 */     // GIR_Coverage, 7058,
     /*  558032 */     GIR_EraseRootFromParent_Done,
     /*  558033 */   // Label 9245: @558033
     /*  558033 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(558108), // Rule ID 7059 //
     /*  558038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558106 */     GIR_RootConstrainSelectedInstOperands,
     /*  558107 */     // GIR_Coverage, 7059,
     /*  558107 */     GIR_EraseRootFromParent_Done,
     /*  558108 */   // Label 9246: @558108
     /*  558108 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(558183), // Rule ID 7062 //
     /*  558113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558159 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558181 */     GIR_RootConstrainSelectedInstOperands,
     /*  558182 */     // GIR_Coverage, 7062,
     /*  558182 */     GIR_EraseRootFromParent_Done,
     /*  558183 */   // Label 9247: @558183
     /*  558183 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(558258), // Rule ID 7063 //
     /*  558188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558256 */     GIR_RootConstrainSelectedInstOperands,
     /*  558257 */     // GIR_Coverage, 7063,
     /*  558257 */     GIR_EraseRootFromParent_Done,
     /*  558258 */   // Label 9248: @558258
     /*  558258 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(558333), // Rule ID 7066 //
     /*  558263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558331 */     GIR_RootConstrainSelectedInstOperands,
     /*  558332 */     // GIR_Coverage, 7066,
     /*  558332 */     GIR_EraseRootFromParent_Done,
     /*  558333 */   // Label 9249: @558333
     /*  558333 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(558408), // Rule ID 7067 //
     /*  558338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  558387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558406 */     GIR_RootConstrainSelectedInstOperands,
     /*  558407 */     // GIR_Coverage, 7067,
     /*  558407 */     GIR_EraseRootFromParent_Done,
     /*  558408 */   // Label 9250: @558408
     /*  558408 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(558483), // Rule ID 7070 //
     /*  558413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  558462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558481 */     GIR_RootConstrainSelectedInstOperands,
     /*  558482 */     // GIR_Coverage, 7070,
     /*  558482 */     GIR_EraseRootFromParent_Done,
     /*  558483 */   // Label 9251: @558483
     /*  558483 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(558558), // Rule ID 7071 //
     /*  558488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  558537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558556 */     GIR_RootConstrainSelectedInstOperands,
     /*  558557 */     // GIR_Coverage, 7071,
     /*  558557 */     GIR_EraseRootFromParent_Done,
     /*  558558 */   // Label 9252: @558558
     /*  558558 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(558633), // Rule ID 7074 //
     /*  558563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558609 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  558612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558631 */     GIR_RootConstrainSelectedInstOperands,
     /*  558632 */     // GIR_Coverage, 7074,
     /*  558632 */     GIR_EraseRootFromParent_Done,
     /*  558633 */   // Label 9253: @558633
     /*  558633 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(558708), // Rule ID 7075 //
     /*  558638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  558687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558706 */     GIR_RootConstrainSelectedInstOperands,
     /*  558707 */     // GIR_Coverage, 7075,
     /*  558707 */     GIR_EraseRootFromParent_Done,
     /*  558708 */   // Label 9254: @558708
     /*  558708 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(558783), // Rule ID 7078 //
     /*  558713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  558762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558781 */     GIR_RootConstrainSelectedInstOperands,
     /*  558782 */     // GIR_Coverage, 7078,
     /*  558782 */     GIR_EraseRootFromParent_Done,
     /*  558783 */   // Label 9255: @558783
     /*  558783 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(558858), // Rule ID 7079 //
     /*  558788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  558837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558856 */     GIR_RootConstrainSelectedInstOperands,
     /*  558857 */     // GIR_Coverage, 7079,
     /*  558857 */     GIR_EraseRootFromParent_Done,
     /*  558858 */   // Label 9256: @558858
     /*  558858 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(558933), // Rule ID 7082 //
     /*  558863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  558912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558931 */     GIR_RootConstrainSelectedInstOperands,
     /*  558932 */     // GIR_Coverage, 7082,
     /*  558932 */     GIR_EraseRootFromParent_Done,
     /*  558933 */   // Label 9257: @558933
     /*  558933 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(559008), // Rule ID 7083 //
     /*  558938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  558946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  558987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559006 */     GIR_RootConstrainSelectedInstOperands,
     /*  559007 */     // GIR_Coverage, 7083,
     /*  559007 */     GIR_EraseRootFromParent_Done,
     /*  559008 */   // Label 9258: @559008
     /*  559008 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(559083), // Rule ID 7086 //
     /*  559013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  559062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559081 */     GIR_RootConstrainSelectedInstOperands,
     /*  559082 */     // GIR_Coverage, 7086,
     /*  559082 */     GIR_EraseRootFromParent_Done,
     /*  559083 */   // Label 9259: @559083
     /*  559083 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(559158), // Rule ID 7087 //
     /*  559088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  559137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559156 */     GIR_RootConstrainSelectedInstOperands,
     /*  559157 */     // GIR_Coverage, 7087,
     /*  559157 */     GIR_EraseRootFromParent_Done,
     /*  559158 */   // Label 9260: @559158
     /*  559158 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(559233), // Rule ID 7090 //
     /*  559163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  559212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559231 */     GIR_RootConstrainSelectedInstOperands,
     /*  559232 */     // GIR_Coverage, 7090,
     /*  559232 */     GIR_EraseRootFromParent_Done,
     /*  559233 */   // Label 9261: @559233
     /*  559233 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(559308), // Rule ID 7091 //
     /*  559238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  559287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559306 */     GIR_RootConstrainSelectedInstOperands,
     /*  559307 */     // GIR_Coverage, 7091,
     /*  559307 */     GIR_EraseRootFromParent_Done,
     /*  559308 */   // Label 9262: @559308
     /*  559308 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(559383), // Rule ID 7094 //
     /*  559313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  559362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559381 */     GIR_RootConstrainSelectedInstOperands,
     /*  559382 */     // GIR_Coverage, 7094,
     /*  559382 */     GIR_EraseRootFromParent_Done,
     /*  559383 */   // Label 9263: @559383
     /*  559383 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(559458), // Rule ID 7095 //
     /*  559388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  559437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559456 */     GIR_RootConstrainSelectedInstOperands,
     /*  559457 */     // GIR_Coverage, 7095,
     /*  559457 */     GIR_EraseRootFromParent_Done,
     /*  559458 */   // Label 9264: @559458
     /*  559458 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(559533), // Rule ID 7098 //
     /*  559463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  559512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559531 */     GIR_RootConstrainSelectedInstOperands,
     /*  559532 */     // GIR_Coverage, 7098,
     /*  559532 */     GIR_EraseRootFromParent_Done,
     /*  559533 */   // Label 9265: @559533
     /*  559533 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(559608), // Rule ID 7099 //
     /*  559538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  559587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559606 */     GIR_RootConstrainSelectedInstOperands,
     /*  559607 */     // GIR_Coverage, 7099,
     /*  559607 */     GIR_EraseRootFromParent_Done,
     /*  559608 */   // Label 9266: @559608
     /*  559608 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(559683), // Rule ID 7102 //
     /*  559613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  559662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559681 */     GIR_RootConstrainSelectedInstOperands,
     /*  559682 */     // GIR_Coverage, 7102,
     /*  559682 */     GIR_EraseRootFromParent_Done,
     /*  559683 */   // Label 9267: @559683
     /*  559683 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(559758), // Rule ID 7103 //
     /*  559688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  559737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559756 */     GIR_RootConstrainSelectedInstOperands,
     /*  559757 */     // GIR_Coverage, 7103,
     /*  559757 */     GIR_EraseRootFromParent_Done,
     /*  559758 */   // Label 9268: @559758
     /*  559758 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(559833), // Rule ID 7106 //
     /*  559763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  559812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559831 */     GIR_RootConstrainSelectedInstOperands,
     /*  559832 */     // GIR_Coverage, 7106,
     /*  559832 */     GIR_EraseRootFromParent_Done,
     /*  559833 */   // Label 9269: @559833
     /*  559833 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(559908), // Rule ID 7107 //
     /*  559838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  559887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559906 */     GIR_RootConstrainSelectedInstOperands,
     /*  559907 */     // GIR_Coverage, 7107,
     /*  559907 */     GIR_EraseRootFromParent_Done,
     /*  559908 */   // Label 9270: @559908
     /*  559908 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(559983), // Rule ID 7110 //
     /*  559913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  559962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559981 */     GIR_RootConstrainSelectedInstOperands,
     /*  559982 */     // GIR_Coverage, 7110,
     /*  559982 */     GIR_EraseRootFromParent_Done,
     /*  559983 */   // Label 9271: @559983
     /*  559983 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(560058), // Rule ID 7111 //
     /*  559988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  559996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  560037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560056 */     GIR_RootConstrainSelectedInstOperands,
     /*  560057 */     // GIR_Coverage, 7111,
     /*  560057 */     GIR_EraseRootFromParent_Done,
     /*  560058 */   // Label 9272: @560058
     /*  560058 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(560133), // Rule ID 7114 //
     /*  560063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  560071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  560112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560131 */     GIR_RootConstrainSelectedInstOperands,
     /*  560132 */     // GIR_Coverage, 7114,
     /*  560132 */     GIR_EraseRootFromParent_Done,
     /*  560133 */   // Label 9273: @560133
     /*  560133 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(560208), // Rule ID 7115 //
     /*  560138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  560146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  560187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560206 */     GIR_RootConstrainSelectedInstOperands,
     /*  560207 */     // GIR_Coverage, 7115,
     /*  560207 */     GIR_EraseRootFromParent_Done,
     /*  560208 */   // Label 9274: @560208
     /*  560208 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(560283), // Rule ID 7294 //
     /*  560213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  560262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560281 */     GIR_RootConstrainSelectedInstOperands,
     /*  560282 */     // GIR_Coverage, 7294,
     /*  560282 */     GIR_EraseRootFromParent_Done,
     /*  560283 */   // Label 9275: @560283
     /*  560283 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(560358), // Rule ID 7295 //
     /*  560288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  560337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560356 */     GIR_RootConstrainSelectedInstOperands,
     /*  560357 */     // GIR_Coverage, 7295,
     /*  560357 */     GIR_EraseRootFromParent_Done,
     /*  560358 */   // Label 9276: @560358
     /*  560358 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(560433), // Rule ID 7298 //
     /*  560363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  560412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560431 */     GIR_RootConstrainSelectedInstOperands,
     /*  560432 */     // GIR_Coverage, 7298,
     /*  560432 */     GIR_EraseRootFromParent_Done,
     /*  560433 */   // Label 9277: @560433
     /*  560433 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(560508), // Rule ID 7299 //
     /*  560438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  560487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560506 */     GIR_RootConstrainSelectedInstOperands,
     /*  560507 */     // GIR_Coverage, 7299,
     /*  560507 */     GIR_EraseRootFromParent_Done,
     /*  560508 */   // Label 9278: @560508
     /*  560508 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(560583), // Rule ID 7302 //
     /*  560513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  560530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560559 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  560562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560581 */     GIR_RootConstrainSelectedInstOperands,
     /*  560582 */     // GIR_Coverage, 7302,
     /*  560582 */     GIR_EraseRootFromParent_Done,
     /*  560583 */   // Label 9279: @560583
     /*  560583 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(560658), // Rule ID 7303 //
     /*  560588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  560605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  560637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560656 */     GIR_RootConstrainSelectedInstOperands,
     /*  560657 */     // GIR_Coverage, 7303,
     /*  560657 */     GIR_EraseRootFromParent_Done,
     /*  560658 */   // Label 9280: @560658
     /*  560658 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(560733), // Rule ID 7306 //
     /*  560663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  560680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  560683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560709 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  560712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560731 */     GIR_RootConstrainSelectedInstOperands,
     /*  560732 */     // GIR_Coverage, 7306,
     /*  560732 */     GIR_EraseRootFromParent_Done,
     /*  560733 */   // Label 9281: @560733
     /*  560733 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(560808), // Rule ID 7307 //
     /*  560738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  560755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  560758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  560787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560806 */     GIR_RootConstrainSelectedInstOperands,
     /*  560807 */     // GIR_Coverage, 7307,
     /*  560807 */     GIR_EraseRootFromParent_Done,
     /*  560808 */   // Label 9282: @560808
     /*  560808 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(560883), // Rule ID 7310 //
     /*  560813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  560824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  560827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  560830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  560833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  560862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560881 */     GIR_RootConstrainSelectedInstOperands,
     /*  560882 */     // GIR_Coverage, 7310,
     /*  560882 */     GIR_EraseRootFromParent_Done,
     /*  560883 */   // Label 9283: @560883
     /*  560883 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(560958), // Rule ID 7311 //
     /*  560888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  560899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  560902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  560905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  560908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  560937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560956 */     GIR_RootConstrainSelectedInstOperands,
     /*  560957 */     // GIR_Coverage, 7311,
     /*  560957 */     GIR_EraseRootFromParent_Done,
     /*  560958 */   // Label 9284: @560958
     /*  560958 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(561033), // Rule ID 7314 //
     /*  560963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  560971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  560974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  560977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  560980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  560983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561009 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  561012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561031 */     GIR_RootConstrainSelectedInstOperands,
     /*  561032 */     // GIR_Coverage, 7314,
     /*  561032 */     GIR_EraseRootFromParent_Done,
     /*  561033 */   // Label 9285: @561033
     /*  561033 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(561108), // Rule ID 7315 //
     /*  561038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  561055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  561058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  561087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561106 */     GIR_RootConstrainSelectedInstOperands,
     /*  561107 */     // GIR_Coverage, 7315,
     /*  561107 */     GIR_EraseRootFromParent_Done,
     /*  561108 */   // Label 9286: @561108
     /*  561108 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(561183), // Rule ID 7318 //
     /*  561113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561159 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  561162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561181 */     GIR_RootConstrainSelectedInstOperands,
     /*  561182 */     // GIR_Coverage, 7318,
     /*  561182 */     GIR_EraseRootFromParent_Done,
     /*  561183 */   // Label 9287: @561183
     /*  561183 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(561258), // Rule ID 7319 //
     /*  561188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561234 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  561237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561256 */     GIR_RootConstrainSelectedInstOperands,
     /*  561257 */     // GIR_Coverage, 7319,
     /*  561257 */     GIR_EraseRootFromParent_Done,
     /*  561258 */   // Label 9288: @561258
     /*  561258 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(561333), // Rule ID 7322 //
     /*  561263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  561312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561331 */     GIR_RootConstrainSelectedInstOperands,
     /*  561332 */     // GIR_Coverage, 7322,
     /*  561332 */     GIR_EraseRootFromParent_Done,
     /*  561333 */   // Label 9289: @561333
     /*  561333 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(561408), // Rule ID 7323 //
     /*  561338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  561387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561406 */     GIR_RootConstrainSelectedInstOperands,
     /*  561407 */     // GIR_Coverage, 7323,
     /*  561407 */     GIR_EraseRootFromParent_Done,
     /*  561408 */   // Label 9290: @561408
     /*  561408 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(561483), // Rule ID 7326 //
     /*  561413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  561430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  561462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561481 */     GIR_RootConstrainSelectedInstOperands,
     /*  561482 */     // GIR_Coverage, 7326,
     /*  561482 */     GIR_EraseRootFromParent_Done,
     /*  561483 */   // Label 9291: @561483
     /*  561483 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(561558), // Rule ID 7327 //
     /*  561488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  561505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  561537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561556 */     GIR_RootConstrainSelectedInstOperands,
     /*  561557 */     // GIR_Coverage, 7327,
     /*  561557 */     GIR_EraseRootFromParent_Done,
     /*  561558 */   // Label 9292: @561558
     /*  561558 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(561633), // Rule ID 7330 //
     /*  561563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  561574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  561577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  561580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  561583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  561612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561631 */     GIR_RootConstrainSelectedInstOperands,
     /*  561632 */     // GIR_Coverage, 7330,
     /*  561632 */     GIR_EraseRootFromParent_Done,
     /*  561633 */   // Label 9293: @561633
     /*  561633 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(561708), // Rule ID 7331 //
     /*  561638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  561649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  561652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  561655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  561658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  561687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561706 */     GIR_RootConstrainSelectedInstOperands,
     /*  561707 */     // GIR_Coverage, 7331,
     /*  561707 */     GIR_EraseRootFromParent_Done,
     /*  561708 */   // Label 9294: @561708
     /*  561708 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(561783), // Rule ID 7334 //
     /*  561713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  561724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  561727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  561730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  561733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  561762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561781 */     GIR_RootConstrainSelectedInstOperands,
     /*  561782 */     // GIR_Coverage, 7334,
     /*  561782 */     GIR_EraseRootFromParent_Done,
     /*  561783 */   // Label 9295: @561783
     /*  561783 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(561858), // Rule ID 7335 //
     /*  561788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  561799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  561802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  561805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  561808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  561837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561856 */     GIR_RootConstrainSelectedInstOperands,
     /*  561857 */     // GIR_Coverage, 7335,
     /*  561857 */     GIR_EraseRootFromParent_Done,
     /*  561858 */   // Label 9296: @561858
     /*  561858 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(561933), // Rule ID 7338 //
     /*  561863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  561866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  561912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561931 */     GIR_RootConstrainSelectedInstOperands,
     /*  561932 */     // GIR_Coverage, 7338,
     /*  561932 */     GIR_EraseRootFromParent_Done,
     /*  561933 */   // Label 9297: @561933
     /*  561933 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(562008), // Rule ID 7339 //
     /*  561938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  561941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  561946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  561987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562006 */     GIR_RootConstrainSelectedInstOperands,
     /*  562007 */     // GIR_Coverage, 7339,
     /*  562007 */     GIR_EraseRootFromParent_Done,
     /*  562008 */   // Label 9298: @562008
     /*  562008 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(562083), // Rule ID 7342 //
     /*  562013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  562016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  562024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  562027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  562033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  562062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562081 */     GIR_RootConstrainSelectedInstOperands,
     /*  562082 */     // GIR_Coverage, 7342,
     /*  562082 */     GIR_EraseRootFromParent_Done,
     /*  562083 */   // Label 9299: @562083
     /*  562083 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(562158), // Rule ID 7343 //
     /*  562088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  562091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  562099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  562102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  562108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  562137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562156 */     GIR_RootConstrainSelectedInstOperands,
     /*  562157 */     // GIR_Coverage, 7343,
     /*  562157 */     GIR_EraseRootFromParent_Done,
     /*  562158 */   // Label 9300: @562158
     /*  562158 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(562233), // Rule ID 7346 //
     /*  562163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  562166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  562180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  562183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  562212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562231 */     GIR_RootConstrainSelectedInstOperands,
     /*  562232 */     // GIR_Coverage, 7346,
     /*  562232 */     GIR_EraseRootFromParent_Done,
     /*  562233 */   // Label 9301: @562233
     /*  562233 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(562308), // Rule ID 7347 //
     /*  562238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  562241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  562255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  562258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  562287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562306 */     GIR_RootConstrainSelectedInstOperands,
     /*  562307 */     // GIR_Coverage, 7347,
     /*  562307 */     GIR_EraseRootFromParent_Done,
     /*  562308 */   // Label 9302: @562308
     /*  562308 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(562383), // Rule ID 7350 //
     /*  562313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  562316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  562330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  562333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562359 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  562362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562381 */     GIR_RootConstrainSelectedInstOperands,
     /*  562382 */     // GIR_Coverage, 7350,
     /*  562382 */     GIR_EraseRootFromParent_Done,
     /*  562383 */   // Label 9303: @562383
     /*  562383 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(562458), // Rule ID 7351 //
     /*  562388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  562391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  562405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  562408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  562437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562456 */     GIR_RootConstrainSelectedInstOperands,
     /*  562457 */     // GIR_Coverage, 7351,
     /*  562457 */     GIR_EraseRootFromParent_Done,
     /*  562458 */   // Label 9304: @562458
     /*  562458 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(562533), // Rule ID 7354 //
     /*  562463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  562474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  562477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  562480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562509 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  562512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562531 */     GIR_RootConstrainSelectedInstOperands,
     /*  562532 */     // GIR_Coverage, 7354,
     /*  562532 */     GIR_EraseRootFromParent_Done,
     /*  562533 */   // Label 9305: @562533
     /*  562533 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(562608), // Rule ID 7355 //
     /*  562538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  562549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  562552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  562555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562584 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  562587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562606 */     GIR_RootConstrainSelectedInstOperands,
     /*  562607 */     // GIR_Coverage, 7355,
     /*  562607 */     GIR_EraseRootFromParent_Done,
     /*  562608 */   // Label 9306: @562608
     /*  562608 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(562683), // Rule ID 7358 //
     /*  562613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  562624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  562627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  562630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562659 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  562662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562681 */     GIR_RootConstrainSelectedInstOperands,
     /*  562682 */     // GIR_Coverage, 7358,
     /*  562682 */     GIR_EraseRootFromParent_Done,
     /*  562683 */   // Label 9307: @562683
     /*  562683 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(562758), // Rule ID 7359 //
     /*  562688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  562699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  562702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  562705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  562737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562756 */     GIR_RootConstrainSelectedInstOperands,
     /*  562757 */     // GIR_Coverage, 7359,
     /*  562757 */     GIR_EraseRootFromParent_Done,
     /*  562758 */   // Label 9308: @562758
     /*  562758 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(562833), // Rule ID 7362 //
     /*  562763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  562774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  562777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  562780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562809 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  562812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562831 */     GIR_RootConstrainSelectedInstOperands,
     /*  562832 */     // GIR_Coverage, 7362,
     /*  562832 */     GIR_EraseRootFromParent_Done,
     /*  562833 */   // Label 9309: @562833
     /*  562833 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(562908), // Rule ID 7363 //
     /*  562838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  562849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  562852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  562855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  562887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562906 */     GIR_RootConstrainSelectedInstOperands,
     /*  562907 */     // GIR_Coverage, 7363,
     /*  562907 */     GIR_EraseRootFromParent_Done,
     /*  562908 */   // Label 9310: @562908
     /*  562908 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(562983), // Rule ID 7366 //
     /*  562913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  562924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  562927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  562962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562981 */     GIR_RootConstrainSelectedInstOperands,
     /*  562982 */     // GIR_Coverage, 7366,
     /*  562982 */     GIR_EraseRootFromParent_Done,
     /*  562983 */   // Label 9311: @562983
     /*  562983 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(563058), // Rule ID 7367 //
     /*  562988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  562996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  562999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  563002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  563005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  563037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563056 */     GIR_RootConstrainSelectedInstOperands,
     /*  563057 */     // GIR_Coverage, 7367,
     /*  563057 */     GIR_EraseRootFromParent_Done,
     /*  563058 */   // Label 9312: @563058
     /*  563058 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(563133), // Rule ID 7370 //
     /*  563063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  563074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  563077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  563080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  563112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563131 */     GIR_RootConstrainSelectedInstOperands,
     /*  563132 */     // GIR_Coverage, 7370,
     /*  563132 */     GIR_EraseRootFromParent_Done,
     /*  563133 */   // Label 9313: @563133
     /*  563133 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(563208), // Rule ID 7371 //
     /*  563138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  563149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  563152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  563155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  563187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563206 */     GIR_RootConstrainSelectedInstOperands,
     /*  563207 */     // GIR_Coverage, 7371,
     /*  563207 */     GIR_EraseRootFromParent_Done,
     /*  563208 */   // Label 9314: @563208
     /*  563208 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(563283), // Rule ID 7374 //
     /*  563213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  563224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  563227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  563230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563259 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  563262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563281 */     GIR_RootConstrainSelectedInstOperands,
     /*  563282 */     // GIR_Coverage, 7374,
     /*  563282 */     GIR_EraseRootFromParent_Done,
     /*  563283 */   // Label 9315: @563283
     /*  563283 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(563358), // Rule ID 7375 //
     /*  563288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  563299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  563302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  563305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  563337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563356 */     GIR_RootConstrainSelectedInstOperands,
     /*  563357 */     // GIR_Coverage, 7375,
     /*  563357 */     GIR_EraseRootFromParent_Done,
     /*  563358 */   // Label 9316: @563358
     /*  563358 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(563433), // Rule ID 7378 //
     /*  563363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  563380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  563412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563431 */     GIR_RootConstrainSelectedInstOperands,
     /*  563432 */     // GIR_Coverage, 7378,
     /*  563432 */     GIR_EraseRootFromParent_Done,
     /*  563433 */   // Label 9317: @563433
     /*  563433 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(563508), // Rule ID 7379 //
     /*  563438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  563455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  563487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563506 */     GIR_RootConstrainSelectedInstOperands,
     /*  563507 */     // GIR_Coverage, 7379,
     /*  563507 */     GIR_EraseRootFromParent_Done,
     /*  563508 */   // Label 9318: @563508
     /*  563508 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(563583), // Rule ID 7382 //
     /*  563513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  563530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  563562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563581 */     GIR_RootConstrainSelectedInstOperands,
     /*  563582 */     // GIR_Coverage, 7382,
     /*  563582 */     GIR_EraseRootFromParent_Done,
     /*  563583 */   // Label 9319: @563583
     /*  563583 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(563658), // Rule ID 7383 //
     /*  563588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  563605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  563637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563656 */     GIR_RootConstrainSelectedInstOperands,
     /*  563657 */     // GIR_Coverage, 7383,
     /*  563657 */     GIR_EraseRootFromParent_Done,
     /*  563658 */   // Label 9320: @563658
     /*  563658 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(563733), // Rule ID 7386 //
     /*  563663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  563674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  563677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  563680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  563712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563731 */     GIR_RootConstrainSelectedInstOperands,
     /*  563732 */     // GIR_Coverage, 7386,
     /*  563732 */     GIR_EraseRootFromParent_Done,
     /*  563733 */   // Label 9321: @563733
     /*  563733 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(563808), // Rule ID 7387 //
     /*  563738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  563749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  563752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  563755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  563787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563806 */     GIR_RootConstrainSelectedInstOperands,
     /*  563807 */     // GIR_Coverage, 7387,
     /*  563807 */     GIR_EraseRootFromParent_Done,
     /*  563808 */   // Label 9322: @563808
     /*  563808 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(563883), // Rule ID 7390 //
     /*  563813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  563824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  563827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  563862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563881 */     GIR_RootConstrainSelectedInstOperands,
     /*  563882 */     // GIR_Coverage, 7390,
     /*  563882 */     GIR_EraseRootFromParent_Done,
     /*  563883 */   // Label 9323: @563883
     /*  563883 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(563958), // Rule ID 7391 //
     /*  563888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  563899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  563902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  563937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563956 */     GIR_RootConstrainSelectedInstOperands,
     /*  563957 */     // GIR_Coverage, 7391,
     /*  563957 */     GIR_EraseRootFromParent_Done,
     /*  563958 */   // Label 9324: @563958
     /*  563958 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(564033), // Rule ID 7394 //
     /*  563963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  563971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  563974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  563977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564009 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  564012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564031 */     GIR_RootConstrainSelectedInstOperands,
     /*  564032 */     // GIR_Coverage, 7394,
     /*  564032 */     GIR_EraseRootFromParent_Done,
     /*  564033 */   // Label 9325: @564033
     /*  564033 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(564108), // Rule ID 7395 //
     /*  564038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  564049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  564052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  564055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  564087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564106 */     GIR_RootConstrainSelectedInstOperands,
     /*  564107 */     // GIR_Coverage, 7395,
     /*  564107 */     GIR_EraseRootFromParent_Done,
     /*  564108 */   // Label 9326: @564108
     /*  564108 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(564183), // Rule ID 7398 //
     /*  564113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  564116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564159 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  564162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564181 */     GIR_RootConstrainSelectedInstOperands,
     /*  564182 */     // GIR_Coverage, 7398,
     /*  564182 */     GIR_EraseRootFromParent_Done,
     /*  564183 */   // Label 9327: @564183
     /*  564183 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(564258), // Rule ID 7399 //
     /*  564188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  564191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  564237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564256 */     GIR_RootConstrainSelectedInstOperands,
     /*  564257 */     // GIR_Coverage, 7399,
     /*  564257 */     GIR_EraseRootFromParent_Done,
     /*  564258 */   // Label 9328: @564258
     /*  564258 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(564333), // Rule ID 7402 //
     /*  564263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  564266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  564280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564309 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  564312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564331 */     GIR_RootConstrainSelectedInstOperands,
     /*  564332 */     // GIR_Coverage, 7402,
     /*  564332 */     GIR_EraseRootFromParent_Done,
     /*  564333 */   // Label 9329: @564333
     /*  564333 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(564408), // Rule ID 7403 //
     /*  564338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  564341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  564355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  564387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564406 */     GIR_RootConstrainSelectedInstOperands,
     /*  564407 */     // GIR_Coverage, 7403,
     /*  564407 */     GIR_EraseRootFromParent_Done,
     /*  564408 */   // Label 9330: @564408
     /*  564408 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(564483), // Rule ID 7406 //
     /*  564413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  564416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  564424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  564427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  564430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  564462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564481 */     GIR_RootConstrainSelectedInstOperands,
     /*  564482 */     // GIR_Coverage, 7406,
     /*  564482 */     GIR_EraseRootFromParent_Done,
     /*  564483 */   // Label 9331: @564483
     /*  564483 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(564558), // Rule ID 7407 //
     /*  564488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  564491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  564499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  564502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  564505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  564537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564556 */     GIR_RootConstrainSelectedInstOperands,
     /*  564557 */     // GIR_Coverage, 7407,
     /*  564557 */     GIR_EraseRootFromParent_Done,
     /*  564558 */   // Label 9332: @564558
     /*  564558 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(564633), // Rule ID 7410 //
     /*  564563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  564566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  564574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  564577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  564580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  564612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564631 */     GIR_RootConstrainSelectedInstOperands,
     /*  564632 */     // GIR_Coverage, 7410,
     /*  564632 */     GIR_EraseRootFromParent_Done,
     /*  564633 */   // Label 9333: @564633
     /*  564633 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(564708), // Rule ID 7411 //
     /*  564638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  564641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  564646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  564649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  564652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  564655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  564687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564706 */     GIR_RootConstrainSelectedInstOperands,
     /*  564707 */     // GIR_Coverage, 7411,
     /*  564707 */     GIR_EraseRootFromParent_Done,
     /*  564708 */   // Label 9334: @564708
     /*  564708 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(564783), // Rule ID 7474 //
     /*  564713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  564721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  564724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  564727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  564733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  564762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564781 */     GIR_RootConstrainSelectedInstOperands,
     /*  564782 */     // GIR_Coverage, 7474,
     /*  564782 */     GIR_EraseRootFromParent_Done,
     /*  564783 */   // Label 9335: @564783
     /*  564783 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(564858), // Rule ID 7475 //
     /*  564788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  564796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  564799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  564802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  564808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564834 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  564837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564856 */     GIR_RootConstrainSelectedInstOperands,
     /*  564857 */     // GIR_Coverage, 7475,
     /*  564857 */     GIR_EraseRootFromParent_Done,
     /*  564858 */   // Label 9336: @564858
     /*  564858 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(564933), // Rule ID 7478 //
     /*  564863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  564871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  564883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564909 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  564912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564931 */     GIR_RootConstrainSelectedInstOperands,
     /*  564932 */     // GIR_Coverage, 7478,
     /*  564932 */     GIR_EraseRootFromParent_Done,
     /*  564933 */   // Label 9337: @564933
     /*  564933 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(565008), // Rule ID 7479 //
     /*  564938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  564946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  564958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  564987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565006 */     GIR_RootConstrainSelectedInstOperands,
     /*  565007 */     // GIR_Coverage, 7479,
     /*  565007 */     GIR_EraseRootFromParent_Done,
     /*  565008 */   // Label 9338: @565008
     /*  565008 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(565083), // Rule ID 7482 //
     /*  565013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  565024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  565027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  565030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  565033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565059 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  565062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565081 */     GIR_RootConstrainSelectedInstOperands,
     /*  565082 */     // GIR_Coverage, 7482,
     /*  565082 */     GIR_EraseRootFromParent_Done,
     /*  565083 */   // Label 9339: @565083
     /*  565083 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(565158), // Rule ID 7483 //
     /*  565088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  565099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  565102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  565105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  565108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  565137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565156 */     GIR_RootConstrainSelectedInstOperands,
     /*  565157 */     // GIR_Coverage, 7483,
     /*  565157 */     GIR_EraseRootFromParent_Done,
     /*  565158 */   // Label 9340: @565158
     /*  565158 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(565233), // Rule ID 7486 //
     /*  565163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  565174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  565177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  565183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565209 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  565212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565231 */     GIR_RootConstrainSelectedInstOperands,
     /*  565232 */     // GIR_Coverage, 7486,
     /*  565232 */     GIR_EraseRootFromParent_Done,
     /*  565233 */   // Label 9341: @565233
     /*  565233 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(565308), // Rule ID 7487 //
     /*  565238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  565249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  565252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  565258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  565287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565306 */     GIR_RootConstrainSelectedInstOperands,
     /*  565307 */     // GIR_Coverage, 7487,
     /*  565307 */     GIR_EraseRootFromParent_Done,
     /*  565308 */   // Label 9342: @565308
     /*  565308 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(565383), // Rule ID 7490 //
     /*  565313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  565333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  565362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565381 */     GIR_RootConstrainSelectedInstOperands,
     /*  565382 */     // GIR_Coverage, 7490,
     /*  565382 */     GIR_EraseRootFromParent_Done,
     /*  565383 */   // Label 9343: @565383
     /*  565383 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(565458), // Rule ID 7491 //
     /*  565388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  565408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  565437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565456 */     GIR_RootConstrainSelectedInstOperands,
     /*  565457 */     // GIR_Coverage, 7491,
     /*  565457 */     GIR_EraseRootFromParent_Done,
     /*  565458 */   // Label 9344: @565458
     /*  565458 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(565533), // Rule ID 7494 //
     /*  565463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  565483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  565512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565531 */     GIR_RootConstrainSelectedInstOperands,
     /*  565532 */     // GIR_Coverage, 7494,
     /*  565532 */     GIR_EraseRootFromParent_Done,
     /*  565533 */   // Label 9345: @565533
     /*  565533 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(565608), // Rule ID 7495 //
     /*  565538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  565558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  565587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565606 */     GIR_RootConstrainSelectedInstOperands,
     /*  565607 */     // GIR_Coverage, 7495,
     /*  565607 */     GIR_EraseRootFromParent_Done,
     /*  565608 */   // Label 9346: @565608
     /*  565608 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(565683), // Rule ID 7498 //
     /*  565613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  565624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  565627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  565630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  565633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  565662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565681 */     GIR_RootConstrainSelectedInstOperands,
     /*  565682 */     // GIR_Coverage, 7498,
     /*  565682 */     GIR_EraseRootFromParent_Done,
     /*  565683 */   // Label 9347: @565683
     /*  565683 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(565758), // Rule ID 7499 //
     /*  565688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  565699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  565702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  565705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  565708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  565737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565756 */     GIR_RootConstrainSelectedInstOperands,
     /*  565757 */     // GIR_Coverage, 7499,
     /*  565757 */     GIR_EraseRootFromParent_Done,
     /*  565758 */   // Label 9348: @565758
     /*  565758 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(565833), // Rule ID 7502 //
     /*  565763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  565774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  565777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  565783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565809 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  565812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565831 */     GIR_RootConstrainSelectedInstOperands,
     /*  565832 */     // GIR_Coverage, 7502,
     /*  565832 */     GIR_EraseRootFromParent_Done,
     /*  565833 */   // Label 9349: @565833
     /*  565833 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(565908), // Rule ID 7503 //
     /*  565838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  565849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  565852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  565858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  565887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565906 */     GIR_RootConstrainSelectedInstOperands,
     /*  565907 */     // GIR_Coverage, 7503,
     /*  565907 */     GIR_EraseRootFromParent_Done,
     /*  565908 */   // Label 9350: @565908
     /*  565908 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(565983), // Rule ID 7506 //
     /*  565913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  565924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  565927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  565933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565959 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  565962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565981 */     GIR_RootConstrainSelectedInstOperands,
     /*  565982 */     // GIR_Coverage, 7506,
     /*  565982 */     GIR_EraseRootFromParent_Done,
     /*  565983 */   // Label 9351: @565983
     /*  565983 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(566058), // Rule ID 7507 //
     /*  565988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  565996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  565999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  566002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  566008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  566037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566056 */     GIR_RootConstrainSelectedInstOperands,
     /*  566057 */     // GIR_Coverage, 7507,
     /*  566057 */     GIR_EraseRootFromParent_Done,
     /*  566058 */   // Label 9352: @566058
     /*  566058 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(566133), // Rule ID 7510 //
     /*  566063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  566074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  566077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  566083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  566112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566131 */     GIR_RootConstrainSelectedInstOperands,
     /*  566132 */     // GIR_Coverage, 7510,
     /*  566132 */     GIR_EraseRootFromParent_Done,
     /*  566133 */   // Label 9353: @566133
     /*  566133 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(566208), // Rule ID 7511 //
     /*  566138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  566149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  566152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  566158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  566187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566206 */     GIR_RootConstrainSelectedInstOperands,
     /*  566207 */     // GIR_Coverage, 7511,
     /*  566207 */     GIR_EraseRootFromParent_Done,
     /*  566208 */   // Label 9354: @566208
     /*  566208 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(566283), // Rule ID 7514 //
     /*  566213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  566233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566259 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  566262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566281 */     GIR_RootConstrainSelectedInstOperands,
     /*  566282 */     // GIR_Coverage, 7514,
     /*  566282 */     GIR_EraseRootFromParent_Done,
     /*  566283 */   // Label 9355: @566283
     /*  566283 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(566358), // Rule ID 7515 //
     /*  566288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  566308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  566337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566356 */     GIR_RootConstrainSelectedInstOperands,
     /*  566357 */     // GIR_Coverage, 7515,
     /*  566357 */     GIR_EraseRootFromParent_Done,
     /*  566358 */   // Label 9356: @566358
     /*  566358 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(566433), // Rule ID 7518 //
     /*  566363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  566366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  566374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  566377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  566380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  566383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  566412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566431 */     GIR_RootConstrainSelectedInstOperands,
     /*  566432 */     // GIR_Coverage, 7518,
     /*  566432 */     GIR_EraseRootFromParent_Done,
     /*  566433 */   // Label 9357: @566433
     /*  566433 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(566508), // Rule ID 7519 //
     /*  566438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  566441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  566449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  566452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  566455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  566458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  566487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566506 */     GIR_RootConstrainSelectedInstOperands,
     /*  566507 */     // GIR_Coverage, 7519,
     /*  566507 */     GIR_EraseRootFromParent_Done,
     /*  566508 */   // Label 9358: @566508
     /*  566508 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(566583), // Rule ID 7522 //
     /*  566513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  566516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  566524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  566527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  566533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  566562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566581 */     GIR_RootConstrainSelectedInstOperands,
     /*  566582 */     // GIR_Coverage, 7522,
     /*  566582 */     GIR_EraseRootFromParent_Done,
     /*  566583 */   // Label 9359: @566583
     /*  566583 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(566658), // Rule ID 7523 //
     /*  566588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  566591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  566599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  566602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  566608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  566637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566656 */     GIR_RootConstrainSelectedInstOperands,
     /*  566657 */     // GIR_Coverage, 7523,
     /*  566657 */     GIR_EraseRootFromParent_Done,
     /*  566658 */   // Label 9360: @566658
     /*  566658 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(566733), // Rule ID 7526 //
     /*  566663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  566666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  566683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  566712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566731 */     GIR_RootConstrainSelectedInstOperands,
     /*  566732 */     // GIR_Coverage, 7526,
     /*  566732 */     GIR_EraseRootFromParent_Done,
     /*  566733 */   // Label 9361: @566733
     /*  566733 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(566808), // Rule ID 7527 //
     /*  566738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  566741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  566758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  566787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566806 */     GIR_RootConstrainSelectedInstOperands,
     /*  566807 */     // GIR_Coverage, 7527,
     /*  566807 */     GIR_EraseRootFromParent_Done,
     /*  566808 */   // Label 9362: @566808
     /*  566808 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(566883), // Rule ID 7530 //
     /*  566813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  566816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  566833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566859 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  566862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566881 */     GIR_RootConstrainSelectedInstOperands,
     /*  566882 */     // GIR_Coverage, 7530,
     /*  566882 */     GIR_EraseRootFromParent_Done,
     /*  566883 */   // Label 9363: @566883
     /*  566883 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(566958), // Rule ID 7531 //
     /*  566888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  566891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  566908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  566937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566956 */     GIR_RootConstrainSelectedInstOperands,
     /*  566957 */     // GIR_Coverage, 7531,
     /*  566957 */     GIR_EraseRootFromParent_Done,
     /*  566958 */   // Label 9364: @566958
     /*  566958 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(567033), // Rule ID 7534 //
     /*  566963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  566971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  566974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  566977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  566980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567009 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  567012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567031 */     GIR_RootConstrainSelectedInstOperands,
     /*  567032 */     // GIR_Coverage, 7534,
     /*  567032 */     GIR_EraseRootFromParent_Done,
     /*  567033 */   // Label 9365: @567033
     /*  567033 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(567108), // Rule ID 7535 //
     /*  567038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  567049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  567052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  567087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567106 */     GIR_RootConstrainSelectedInstOperands,
     /*  567107 */     // GIR_Coverage, 7535,
     /*  567107 */     GIR_EraseRootFromParent_Done,
     /*  567108 */   // Label 9366: @567108
     /*  567108 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(567183), // Rule ID 7538 //
     /*  567113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567159 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  567162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567181 */     GIR_RootConstrainSelectedInstOperands,
     /*  567182 */     // GIR_Coverage, 7538,
     /*  567182 */     GIR_EraseRootFromParent_Done,
     /*  567183 */   // Label 9367: @567183
     /*  567183 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(567258), // Rule ID 7539 //
     /*  567188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  567237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567256 */     GIR_RootConstrainSelectedInstOperands,
     /*  567257 */     // GIR_Coverage, 7539,
     /*  567257 */     GIR_EraseRootFromParent_Done,
     /*  567258 */   // Label 9368: @567258
     /*  567258 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(567333), // Rule ID 7542 //
     /*  567263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567309 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  567312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567331 */     GIR_RootConstrainSelectedInstOperands,
     /*  567332 */     // GIR_Coverage, 7542,
     /*  567332 */     GIR_EraseRootFromParent_Done,
     /*  567333 */   // Label 9369: @567333
     /*  567333 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(567408), // Rule ID 7543 //
     /*  567338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  567387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567406 */     GIR_RootConstrainSelectedInstOperands,
     /*  567407 */     // GIR_Coverage, 7543,
     /*  567407 */     GIR_EraseRootFromParent_Done,
     /*  567408 */   // Label 9370: @567408
     /*  567408 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(567483), // Rule ID 7546 //
     /*  567413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  567424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  567427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  567430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  567462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567481 */     GIR_RootConstrainSelectedInstOperands,
     /*  567482 */     // GIR_Coverage, 7546,
     /*  567482 */     GIR_EraseRootFromParent_Done,
     /*  567483 */   // Label 9371: @567483
     /*  567483 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(567558), // Rule ID 7547 //
     /*  567488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  567499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  567502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  567505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  567537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567556 */     GIR_RootConstrainSelectedInstOperands,
     /*  567557 */     // GIR_Coverage, 7547,
     /*  567557 */     GIR_EraseRootFromParent_Done,
     /*  567558 */   // Label 9372: @567558
     /*  567558 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(567633), // Rule ID 7550 //
     /*  567563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  567574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  567577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  567580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567609 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  567612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567631 */     GIR_RootConstrainSelectedInstOperands,
     /*  567632 */     // GIR_Coverage, 7550,
     /*  567632 */     GIR_EraseRootFromParent_Done,
     /*  567633 */   // Label 9373: @567633
     /*  567633 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(567708), // Rule ID 7551 //
     /*  567638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  567649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  567652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  567655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  567687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567706 */     GIR_RootConstrainSelectedInstOperands,
     /*  567707 */     // GIR_Coverage, 7551,
     /*  567707 */     GIR_EraseRootFromParent_Done,
     /*  567708 */   // Label 9374: @567708
     /*  567708 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(567783), // Rule ID 7554 //
     /*  567713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  567724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  567727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  567730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  567762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567781 */     GIR_RootConstrainSelectedInstOperands,
     /*  567782 */     // GIR_Coverage, 7554,
     /*  567782 */     GIR_EraseRootFromParent_Done,
     /*  567783 */   // Label 9375: @567783
     /*  567783 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(567858), // Rule ID 7555 //
     /*  567788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  567799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  567802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  567805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  567837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567856 */     GIR_RootConstrainSelectedInstOperands,
     /*  567857 */     // GIR_Coverage, 7555,
     /*  567857 */     GIR_EraseRootFromParent_Done,
     /*  567858 */   // Label 9376: @567858
     /*  567858 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(567933), // Rule ID 7558 //
     /*  567863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  567912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567931 */     GIR_RootConstrainSelectedInstOperands,
     /*  567932 */     // GIR_Coverage, 7558,
     /*  567932 */     GIR_EraseRootFromParent_Done,
     /*  567933 */   // Label 9377: @567933
     /*  567933 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(568008), // Rule ID 7559 //
     /*  567938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  567946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  567987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568006 */     GIR_RootConstrainSelectedInstOperands,
     /*  568007 */     // GIR_Coverage, 7559,
     /*  568007 */     GIR_EraseRootFromParent_Done,
     /*  568008 */   // Label 9378: @568008
     /*  568008 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(568083), // Rule ID 7562 //
     /*  568013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  568024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  568027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  568062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568081 */     GIR_RootConstrainSelectedInstOperands,
     /*  568082 */     // GIR_Coverage, 7562,
     /*  568082 */     GIR_EraseRootFromParent_Done,
     /*  568083 */   // Label 9379: @568083
     /*  568083 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(568158), // Rule ID 7563 //
     /*  568088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  568099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  568102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  568137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568156 */     GIR_RootConstrainSelectedInstOperands,
     /*  568157 */     // GIR_Coverage, 7563,
     /*  568157 */     GIR_EraseRootFromParent_Done,
     /*  568158 */   // Label 9380: @568158
     /*  568158 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(568233), // Rule ID 7566 //
     /*  568163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  568212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568231 */     GIR_RootConstrainSelectedInstOperands,
     /*  568232 */     // GIR_Coverage, 7566,
     /*  568232 */     GIR_EraseRootFromParent_Done,
     /*  568233 */   // Label 9381: @568233
     /*  568233 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(568308), // Rule ID 7567 //
     /*  568238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  568287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568306 */     GIR_RootConstrainSelectedInstOperands,
     /*  568307 */     // GIR_Coverage, 7567,
     /*  568307 */     GIR_EraseRootFromParent_Done,
     /*  568308 */   // Label 9382: @568308
     /*  568308 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(568383), // Rule ID 7570 //
     /*  568313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  568324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  568327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  568362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568381 */     GIR_RootConstrainSelectedInstOperands,
     /*  568382 */     // GIR_Coverage, 7570,
     /*  568382 */     GIR_EraseRootFromParent_Done,
     /*  568383 */   // Label 9383: @568383
     /*  568383 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(568458), // Rule ID 7571 //
     /*  568388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  568399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  568402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  568437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568456 */     GIR_RootConstrainSelectedInstOperands,
     /*  568457 */     // GIR_Coverage, 7571,
     /*  568457 */     GIR_EraseRootFromParent_Done,
     /*  568458 */   // Label 9384: @568458
     /*  568458 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(568533), // Rule ID 7574 //
     /*  568463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  568474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  568477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  568480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  568512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568531 */     GIR_RootConstrainSelectedInstOperands,
     /*  568532 */     // GIR_Coverage, 7574,
     /*  568532 */     GIR_EraseRootFromParent_Done,
     /*  568533 */   // Label 9385: @568533
     /*  568533 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(568608), // Rule ID 7575 //
     /*  568538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  568549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  568552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  568555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  568587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568606 */     GIR_RootConstrainSelectedInstOperands,
     /*  568607 */     // GIR_Coverage, 7575,
     /*  568607 */     GIR_EraseRootFromParent_Done,
     /*  568608 */   // Label 9386: @568608
     /*  568608 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(568683), // Rule ID 7578 //
     /*  568613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568659 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  568662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568681 */     GIR_RootConstrainSelectedInstOperands,
     /*  568682 */     // GIR_Coverage, 7578,
     /*  568682 */     GIR_EraseRootFromParent_Done,
     /*  568683 */   // Label 9387: @568683
     /*  568683 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(568758), // Rule ID 7579 //
     /*  568688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  568737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568756 */     GIR_RootConstrainSelectedInstOperands,
     /*  568757 */     // GIR_Coverage, 7579,
     /*  568757 */     GIR_EraseRootFromParent_Done,
     /*  568758 */   // Label 9388: @568758
     /*  568758 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(568833), // Rule ID 7582 //
     /*  568763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  568780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568809 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  568812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568831 */     GIR_RootConstrainSelectedInstOperands,
     /*  568832 */     // GIR_Coverage, 7582,
     /*  568832 */     GIR_EraseRootFromParent_Done,
     /*  568833 */   // Label 9389: @568833
     /*  568833 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(568908), // Rule ID 7583 //
     /*  568838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  568855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  568887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568906 */     GIR_RootConstrainSelectedInstOperands,
     /*  568907 */     // GIR_Coverage, 7583,
     /*  568907 */     GIR_EraseRootFromParent_Done,
     /*  568908 */   // Label 9390: @568908
     /*  568908 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(568983), // Rule ID 7586 //
     /*  568913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  568927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  568930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  568962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568981 */     GIR_RootConstrainSelectedInstOperands,
     /*  568982 */     // GIR_Coverage, 7586,
     /*  568982 */     GIR_EraseRootFromParent_Done,
     /*  568983 */   // Label 9391: @568983
     /*  568983 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(569058), // Rule ID 7587 //
     /*  568988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  568996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  569005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  569037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569056 */     GIR_RootConstrainSelectedInstOperands,
     /*  569057 */     // GIR_Coverage, 7587,
     /*  569057 */     GIR_EraseRootFromParent_Done,
     /*  569058 */   // Label 9392: @569058
     /*  569058 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(569133), // Rule ID 7590 //
     /*  569063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  569066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  569071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  569080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  569112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569131 */     GIR_RootConstrainSelectedInstOperands,
     /*  569132 */     // GIR_Coverage, 7590,
     /*  569132 */     GIR_EraseRootFromParent_Done,
     /*  569133 */   // Label 9393: @569133
     /*  569133 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(569208), // Rule ID 7591 //
     /*  569138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  569141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  569146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  569155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  569187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569206 */     GIR_RootConstrainSelectedInstOperands,
     /*  569207 */     // GIR_Coverage, 7591,
     /*  569207 */     GIR_EraseRootFromParent_Done,
     /*  569208 */   // Label 9394: @569208
     /*  569208 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(569283), // Rule ID 10106 //
     /*  569213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  569224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  569227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  569233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  569262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569281 */     GIR_RootConstrainSelectedInstOperands,
     /*  569282 */     // GIR_Coverage, 10106,
     /*  569282 */     GIR_EraseRootFromParent_Done,
     /*  569283 */   // Label 9395: @569283
     /*  569283 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(569358), // Rule ID 10107 //
     /*  569288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  569299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  569302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  569308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  569337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569356 */     GIR_RootConstrainSelectedInstOperands,
     /*  569357 */     // GIR_Coverage, 10107,
     /*  569357 */     GIR_EraseRootFromParent_Done,
     /*  569358 */   // Label 9396: @569358
     /*  569358 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(569433), // Rule ID 10110 //
     /*  569363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  569374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  569377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  569383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  569412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569431 */     GIR_RootConstrainSelectedInstOperands,
     /*  569432 */     // GIR_Coverage, 10110,
     /*  569432 */     GIR_EraseRootFromParent_Done,
     /*  569433 */   // Label 9397: @569433
     /*  569433 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(569508), // Rule ID 10111 //
     /*  569438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  569449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  569452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  569458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  569487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569506 */     GIR_RootConstrainSelectedInstOperands,
     /*  569507 */     // GIR_Coverage, 10111,
     /*  569507 */     GIR_EraseRootFromParent_Done,
     /*  569508 */   // Label 9398: @569508
     /*  569508 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(569583), // Rule ID 10114 //
     /*  569513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  569524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  569527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  569533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569559 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  569562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569581 */     GIR_RootConstrainSelectedInstOperands,
     /*  569582 */     // GIR_Coverage, 10114,
     /*  569582 */     GIR_EraseRootFromParent_Done,
     /*  569583 */   // Label 9399: @569583
     /*  569583 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(569658), // Rule ID 10115 //
     /*  569588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  569599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  569602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  569608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  569637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569656 */     GIR_RootConstrainSelectedInstOperands,
     /*  569657 */     // GIR_Coverage, 10115,
     /*  569657 */     GIR_EraseRootFromParent_Done,
     /*  569658 */   // Label 9400: @569658
     /*  569658 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(569733), // Rule ID 10118 //
     /*  569663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  569683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  569712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569731 */     GIR_RootConstrainSelectedInstOperands,
     /*  569732 */     // GIR_Coverage, 10118,
     /*  569732 */     GIR_EraseRootFromParent_Done,
     /*  569733 */   // Label 9401: @569733
     /*  569733 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(569808), // Rule ID 10119 //
     /*  569738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  569758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  569787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569806 */     GIR_RootConstrainSelectedInstOperands,
     /*  569807 */     // GIR_Coverage, 10119,
     /*  569807 */     GIR_EraseRootFromParent_Done,
     /*  569808 */   // Label 9402: @569808
     /*  569808 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(569883), // Rule ID 10122 //
     /*  569813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  569833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  569862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569881 */     GIR_RootConstrainSelectedInstOperands,
     /*  569882 */     // GIR_Coverage, 10122,
     /*  569882 */     GIR_EraseRootFromParent_Done,
     /*  569883 */   // Label 9403: @569883
     /*  569883 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(569958), // Rule ID 10123 //
     /*  569888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  569908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  569937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569956 */     GIR_RootConstrainSelectedInstOperands,
     /*  569957 */     // GIR_Coverage, 10123,
     /*  569957 */     GIR_EraseRootFromParent_Done,
     /*  569958 */   // Label 9404: @569958
     /*  569958 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(570033), // Rule ID 10126 //
     /*  569963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  569971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  569980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  569983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  570012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570031 */     GIR_RootConstrainSelectedInstOperands,
     /*  570032 */     // GIR_Coverage, 10126,
     /*  570032 */     GIR_EraseRootFromParent_Done,
     /*  570033 */   // Label 9405: @570033
     /*  570033 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(570108), // Rule ID 10127 //
     /*  570038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  570049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  570052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  570058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  570087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570106 */     GIR_RootConstrainSelectedInstOperands,
     /*  570107 */     // GIR_Coverage, 10127,
     /*  570107 */     GIR_EraseRootFromParent_Done,
     /*  570108 */   // Label 9406: @570108
     /*  570108 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(570183), // Rule ID 10130 //
     /*  570113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  570124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  570127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  570130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  570133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570181 */     GIR_RootConstrainSelectedInstOperands,
     /*  570182 */     // GIR_Coverage, 10130,
     /*  570182 */     GIR_EraseRootFromParent_Done,
     /*  570183 */   // Label 9407: @570183
     /*  570183 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(570258), // Rule ID 10131 //
     /*  570188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  570199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  570202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  570205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  570208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570256 */     GIR_RootConstrainSelectedInstOperands,
     /*  570257 */     // GIR_Coverage, 10131,
     /*  570257 */     GIR_EraseRootFromParent_Done,
     /*  570258 */   // Label 9408: @570258
     /*  570258 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(570333), // Rule ID 10134 //
     /*  570263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  570283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570331 */     GIR_RootConstrainSelectedInstOperands,
     /*  570332 */     // GIR_Coverage, 10134,
     /*  570332 */     GIR_EraseRootFromParent_Done,
     /*  570333 */   // Label 9409: @570333
     /*  570333 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(570408), // Rule ID 10135 //
     /*  570338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  570358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570406 */     GIR_RootConstrainSelectedInstOperands,
     /*  570407 */     // GIR_Coverage, 10135,
     /*  570407 */     GIR_EraseRootFromParent_Done,
     /*  570408 */   // Label 9410: @570408
     /*  570408 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(570483), // Rule ID 10138 //
     /*  570413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  570433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570481 */     GIR_RootConstrainSelectedInstOperands,
     /*  570482 */     // GIR_Coverage, 10138,
     /*  570482 */     GIR_EraseRootFromParent_Done,
     /*  570483 */   // Label 9411: @570483
     /*  570483 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(570558), // Rule ID 10139 //
     /*  570488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  570508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570556 */     GIR_RootConstrainSelectedInstOperands,
     /*  570557 */     // GIR_Coverage, 10139,
     /*  570557 */     GIR_EraseRootFromParent_Done,
     /*  570558 */   // Label 9412: @570558
     /*  570558 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(570633), // Rule ID 10142 //
     /*  570563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  570580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  570583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570631 */     GIR_RootConstrainSelectedInstOperands,
     /*  570632 */     // GIR_Coverage, 10142,
     /*  570632 */     GIR_EraseRootFromParent_Done,
     /*  570633 */   // Label 9413: @570633
     /*  570633 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(570708), // Rule ID 10143 //
     /*  570638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  570655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  570658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  570687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570706 */     GIR_RootConstrainSelectedInstOperands,
     /*  570707 */     // GIR_Coverage, 10143,
     /*  570707 */     GIR_EraseRootFromParent_Done,
     /*  570708 */   // Label 9414: @570708
     /*  570708 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(570783), // Rule ID 10146 //
     /*  570713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  570724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  570727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  570730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  570733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  570762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570781 */     GIR_RootConstrainSelectedInstOperands,
     /*  570782 */     // GIR_Coverage, 10146,
     /*  570782 */     GIR_EraseRootFromParent_Done,
     /*  570783 */   // Label 9415: @570783
     /*  570783 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(570858), // Rule ID 10147 //
     /*  570788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  570799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  570802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  570805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  570808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  570837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570856 */     GIR_RootConstrainSelectedInstOperands,
     /*  570857 */     // GIR_Coverage, 10147,
     /*  570857 */     GIR_EraseRootFromParent_Done,
     /*  570858 */   // Label 9416: @570858
     /*  570858 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(570933), // Rule ID 10150 //
     /*  570863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  570874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  570877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  570883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  570912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570931 */     GIR_RootConstrainSelectedInstOperands,
     /*  570932 */     // GIR_Coverage, 10150,
     /*  570932 */     GIR_EraseRootFromParent_Done,
     /*  570933 */   // Label 9417: @570933
     /*  570933 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(571008), // Rule ID 10151 //
     /*  570938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  570946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  570949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  570952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  570958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  570987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571006 */     GIR_RootConstrainSelectedInstOperands,
     /*  571007 */     // GIR_Coverage, 10151,
     /*  571007 */     GIR_EraseRootFromParent_Done,
     /*  571008 */   // Label 9418: @571008
     /*  571008 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(571083), // Rule ID 10154 //
     /*  571013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  571024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  571027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  571030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  571033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571059 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  571062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571081 */     GIR_RootConstrainSelectedInstOperands,
     /*  571082 */     // GIR_Coverage, 10154,
     /*  571082 */     GIR_EraseRootFromParent_Done,
     /*  571083 */   // Label 9419: @571083
     /*  571083 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(571158), // Rule ID 10155 //
     /*  571088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  571099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  571102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  571105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  571108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  571137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571156 */     GIR_RootConstrainSelectedInstOperands,
     /*  571157 */     // GIR_Coverage, 10155,
     /*  571157 */     GIR_EraseRootFromParent_Done,
     /*  571158 */   // Label 9420: @571158
     /*  571158 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(571233), // Rule ID 10158 //
     /*  571163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  571212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571231 */     GIR_RootConstrainSelectedInstOperands,
     /*  571232 */     // GIR_Coverage, 10158,
     /*  571232 */     GIR_EraseRootFromParent_Done,
     /*  571233 */   // Label 9421: @571233
     /*  571233 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(571308), // Rule ID 10159 //
     /*  571238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  571287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571306 */     GIR_RootConstrainSelectedInstOperands,
     /*  571307 */     // GIR_Coverage, 10159,
     /*  571307 */     GIR_EraseRootFromParent_Done,
     /*  571308 */   // Label 9422: @571308
     /*  571308 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(571383), // Rule ID 10162 //
     /*  571313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  571330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  571333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571359 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  571362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571381 */     GIR_RootConstrainSelectedInstOperands,
     /*  571382 */     // GIR_Coverage, 10162,
     /*  571382 */     GIR_EraseRootFromParent_Done,
     /*  571383 */   // Label 9423: @571383
     /*  571383 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(571458), // Rule ID 10163 //
     /*  571388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  571405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  571408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  571437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571456 */     GIR_RootConstrainSelectedInstOperands,
     /*  571457 */     // GIR_Coverage, 10163,
     /*  571457 */     GIR_EraseRootFromParent_Done,
     /*  571458 */   // Label 9424: @571458
     /*  571458 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(571533), // Rule ID 10166 //
     /*  571463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  571480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  571483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571509 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  571512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571531 */     GIR_RootConstrainSelectedInstOperands,
     /*  571532 */     // GIR_Coverage, 10166,
     /*  571532 */     GIR_EraseRootFromParent_Done,
     /*  571533 */   // Label 9425: @571533
     /*  571533 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(571608), // Rule ID 10167 //
     /*  571538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  571555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  571558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  571587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571606 */     GIR_RootConstrainSelectedInstOperands,
     /*  571607 */     // GIR_Coverage, 10167,
     /*  571607 */     GIR_EraseRootFromParent_Done,
     /*  571608 */   // Label 9426: @571608
     /*  571608 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(571683), // Rule ID 10170 //
     /*  571613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  571633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  571662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571681 */     GIR_RootConstrainSelectedInstOperands,
     /*  571682 */     // GIR_Coverage, 10170,
     /*  571682 */     GIR_EraseRootFromParent_Done,
     /*  571683 */   // Label 9427: @571683
     /*  571683 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(571758), // Rule ID 10171 //
     /*  571688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  571708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  571737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571756 */     GIR_RootConstrainSelectedInstOperands,
     /*  571757 */     // GIR_Coverage, 10171,
     /*  571757 */     GIR_EraseRootFromParent_Done,
     /*  571758 */   // Label 9428: @571758
     /*  571758 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(571833), // Rule ID 10174 //
     /*  571763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  571783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  571812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571831 */     GIR_RootConstrainSelectedInstOperands,
     /*  571832 */     // GIR_Coverage, 10174,
     /*  571832 */     GIR_EraseRootFromParent_Done,
     /*  571833 */   // Label 9429: @571833
     /*  571833 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(571908), // Rule ID 10175 //
     /*  571838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  571858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  571887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571906 */     GIR_RootConstrainSelectedInstOperands,
     /*  571907 */     // GIR_Coverage, 10175,
     /*  571907 */     GIR_EraseRootFromParent_Done,
     /*  571908 */   // Label 9430: @571908
     /*  571908 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(571983), // Rule ID 10178 //
     /*  571913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  571924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  571927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  571930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  571933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  571962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571981 */     GIR_RootConstrainSelectedInstOperands,
     /*  571982 */     // GIR_Coverage, 10178,
     /*  571982 */     GIR_EraseRootFromParent_Done,
     /*  571983 */   // Label 9431: @571983
     /*  571983 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(572058), // Rule ID 10179 //
     /*  571988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  571996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  571999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  572005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  572008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  572037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572056 */     GIR_RootConstrainSelectedInstOperands,
     /*  572057 */     // GIR_Coverage, 10179,
     /*  572057 */     GIR_EraseRootFromParent_Done,
     /*  572058 */   // Label 9432: @572058
     /*  572058 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(572133), // Rule ID 10182 //
     /*  572063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  572066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  572080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  572083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  572109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  572112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572131 */     GIR_RootConstrainSelectedInstOperands,
     /*  572132 */     // GIR_Coverage, 10182,
     /*  572132 */     GIR_EraseRootFromParent_Done,
     /*  572133 */   // Label 9433: @572133
     /*  572133 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(572208), // Rule ID 10183 //
     /*  572138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  572141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  572155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  572158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  572184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  572187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572206 */     GIR_RootConstrainSelectedInstOperands,
     /*  572207 */     // GIR_Coverage, 10183,
     /*  572207 */     GIR_EraseRootFromParent_Done,
     /*  572208 */   // Label 9434: @572208
     /*  572208 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(572283), // Rule ID 10186 //
     /*  572213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  572216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  572230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  572233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572259 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  572259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  572262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572281 */     GIR_RootConstrainSelectedInstOperands,
     /*  572282 */     // GIR_Coverage, 10186,
     /*  572282 */     GIR_EraseRootFromParent_Done,
     /*  572283 */   // Label 9435: @572283
     /*  572283 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(572358), // Rule ID 10187 //
     /*  572288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  572291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  572305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  572308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  572334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  572337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572356 */     GIR_RootConstrainSelectedInstOperands,
     /*  572357 */     // GIR_Coverage, 10187,
     /*  572357 */     GIR_EraseRootFromParent_Done,
     /*  572358 */   // Label 9436: @572358
     /*  572358 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(572433), // Rule ID 10190 //
     /*  572363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  572366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  572380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  572383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  572409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  572412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572431 */     GIR_RootConstrainSelectedInstOperands,
     /*  572432 */     // GIR_Coverage, 10190,
     /*  572432 */     GIR_EraseRootFromParent_Done,
     /*  572433 */   // Label 9437: @572433
     /*  572433 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(572508), // Rule ID 10191 //
     /*  572438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  572441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  572455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  572458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  572484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  572487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  572503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572506 */     GIR_RootConstrainSelectedInstOperands,
     /*  572507 */     // GIR_Coverage, 10191,
     /*  572507 */     GIR_EraseRootFromParent_Done,
     /*  572508 */   // Label 9438: @572508
     /*  572508 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(572583), // Rule ID 10194 //
     /*  572513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  572524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  572527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572559 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  572562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572581 */     GIR_RootConstrainSelectedInstOperands,
     /*  572582 */     // GIR_Coverage, 10194,
     /*  572582 */     GIR_EraseRootFromParent_Done,
     /*  572583 */   // Label 9439: @572583
     /*  572583 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(572658), // Rule ID 10195 //
     /*  572588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  572599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  572602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  572637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572656 */     GIR_RootConstrainSelectedInstOperands,
     /*  572657 */     // GIR_Coverage, 10195,
     /*  572657 */     GIR_EraseRootFromParent_Done,
     /*  572658 */   // Label 9440: @572658
     /*  572658 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(572733), // Rule ID 10198 //
     /*  572663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  572674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  572677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  572712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572731 */     GIR_RootConstrainSelectedInstOperands,
     /*  572732 */     // GIR_Coverage, 10198,
     /*  572732 */     GIR_EraseRootFromParent_Done,
     /*  572733 */   // Label 9441: @572733
     /*  572733 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(572808), // Rule ID 10199 //
     /*  572738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  572749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  572752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  572787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572806 */     GIR_RootConstrainSelectedInstOperands,
     /*  572807 */     // GIR_Coverage, 10199,
     /*  572807 */     GIR_EraseRootFromParent_Done,
     /*  572808 */   // Label 9442: @572808
     /*  572808 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(572883), // Rule ID 10202 //
     /*  572813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  572824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  572827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  572830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  572862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572881 */     GIR_RootConstrainSelectedInstOperands,
     /*  572882 */     // GIR_Coverage, 10202,
     /*  572882 */     GIR_EraseRootFromParent_Done,
     /*  572883 */   // Label 9443: @572883
     /*  572883 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(572958), // Rule ID 10203 //
     /*  572888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  572899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  572902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  572905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  572937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572956 */     GIR_RootConstrainSelectedInstOperands,
     /*  572957 */     // GIR_Coverage, 10203,
     /*  572957 */     GIR_EraseRootFromParent_Done,
     /*  572958 */   // Label 9444: @572958
     /*  572958 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(573033), // Rule ID 10206 //
     /*  572963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  572971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  573012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573031 */     GIR_RootConstrainSelectedInstOperands,
     /*  573032 */     // GIR_Coverage, 10206,
     /*  573032 */     GIR_EraseRootFromParent_Done,
     /*  573033 */   // Label 9445: @573033
     /*  573033 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(573108), // Rule ID 10207 //
     /*  573038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  573087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573106 */     GIR_RootConstrainSelectedInstOperands,
     /*  573107 */     // GIR_Coverage, 10207,
     /*  573107 */     GIR_EraseRootFromParent_Done,
     /*  573108 */   // Label 9446: @573108
     /*  573108 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(573183), // Rule ID 10210 //
     /*  573113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  573162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573181 */     GIR_RootConstrainSelectedInstOperands,
     /*  573182 */     // GIR_Coverage, 10210,
     /*  573182 */     GIR_EraseRootFromParent_Done,
     /*  573183 */   // Label 9447: @573183
     /*  573183 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(573258), // Rule ID 10211 //
     /*  573188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  573237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573256 */     GIR_RootConstrainSelectedInstOperands,
     /*  573257 */     // GIR_Coverage, 10211,
     /*  573257 */     GIR_EraseRootFromParent_Done,
     /*  573258 */   // Label 9448: @573258
     /*  573258 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(573333), // Rule ID 10214 //
     /*  573263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573309 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  573312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573331 */     GIR_RootConstrainSelectedInstOperands,
     /*  573332 */     // GIR_Coverage, 10214,
     /*  573332 */     GIR_EraseRootFromParent_Done,
     /*  573333 */   // Label 9449: @573333
     /*  573333 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(573408), // Rule ID 10215 //
     /*  573338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  573387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573406 */     GIR_RootConstrainSelectedInstOperands,
     /*  573407 */     // GIR_Coverage, 10215,
     /*  573407 */     GIR_EraseRootFromParent_Done,
     /*  573408 */   // Label 9450: @573408
     /*  573408 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(573483), // Rule ID 10218 //
     /*  573413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  573424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  573427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573481 */     GIR_RootConstrainSelectedInstOperands,
     /*  573482 */     // GIR_Coverage, 10218,
     /*  573482 */     GIR_EraseRootFromParent_Done,
     /*  573483 */   // Label 9451: @573483
     /*  573483 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(573558), // Rule ID 10219 //
     /*  573488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  573499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  573502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573556 */     GIR_RootConstrainSelectedInstOperands,
     /*  573557 */     // GIR_Coverage, 10219,
     /*  573557 */     GIR_EraseRootFromParent_Done,
     /*  573558 */   // Label 9452: @573558
     /*  573558 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(573633), // Rule ID 10222 //
     /*  573563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  573580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573609 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573631 */     GIR_RootConstrainSelectedInstOperands,
     /*  573632 */     // GIR_Coverage, 10222,
     /*  573632 */     GIR_EraseRootFromParent_Done,
     /*  573633 */   // Label 9453: @573633
     /*  573633 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(573708), // Rule ID 10223 //
     /*  573638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  573655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573706 */     GIR_RootConstrainSelectedInstOperands,
     /*  573707 */     // GIR_Coverage, 10223,
     /*  573707 */     GIR_EraseRootFromParent_Done,
     /*  573708 */   // Label 9454: @573708
     /*  573708 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(573783), // Rule ID 10226 //
     /*  573713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573781 */     GIR_RootConstrainSelectedInstOperands,
     /*  573782 */     // GIR_Coverage, 10226,
     /*  573782 */     GIR_EraseRootFromParent_Done,
     /*  573783 */   // Label 9455: @573783
     /*  573783 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(573858), // Rule ID 10227 //
     /*  573788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573856 */     GIR_RootConstrainSelectedInstOperands,
     /*  573857 */     // GIR_Coverage, 10227,
     /*  573857 */     GIR_EraseRootFromParent_Done,
     /*  573858 */   // Label 9456: @573858
     /*  573858 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(573933), // Rule ID 10230 //
     /*  573863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  573866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  573880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  573909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  573928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573931 */     GIR_RootConstrainSelectedInstOperands,
     /*  573932 */     // GIR_Coverage, 10230,
     /*  573932 */     GIR_EraseRootFromParent_Done,
     /*  573933 */   // Label 9457: @573933
     /*  573933 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(574008), // Rule ID 10231 //
     /*  573938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  573941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  573946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  573955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  573984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  573987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  574003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574006 */     GIR_RootConstrainSelectedInstOperands,
     /*  574007 */     // GIR_Coverage, 10231,
     /*  574007 */     GIR_EraseRootFromParent_Done,
     /*  574008 */   // Label 9458: @574008
     /*  574008 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(574083), // Rule ID 10234 //
     /*  574013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  574024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  574027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  574062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574081 */     GIR_RootConstrainSelectedInstOperands,
     /*  574082 */     // GIR_Coverage, 10234,
     /*  574082 */     GIR_EraseRootFromParent_Done,
     /*  574083 */   // Label 9459: @574083
     /*  574083 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(574158), // Rule ID 10235 //
     /*  574088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  574099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  574102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  574137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574156 */     GIR_RootConstrainSelectedInstOperands,
     /*  574157 */     // GIR_Coverage, 10235,
     /*  574157 */     GIR_EraseRootFromParent_Done,
     /*  574158 */   // Label 9460: @574158
     /*  574158 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(574233), // Rule ID 10238 //
     /*  574163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  574174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  574177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574209 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  574212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574231 */     GIR_RootConstrainSelectedInstOperands,
     /*  574232 */     // GIR_Coverage, 10238,
     /*  574232 */     GIR_EraseRootFromParent_Done,
     /*  574233 */   // Label 9461: @574233
     /*  574233 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(574308), // Rule ID 10239 //
     /*  574238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  574249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  574252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  574287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574306 */     GIR_RootConstrainSelectedInstOperands,
     /*  574307 */     // GIR_Coverage, 10239,
     /*  574307 */     GIR_EraseRootFromParent_Done,
     /*  574308 */   // Label 9462: @574308
     /*  574308 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(574383), // Rule ID 10242 //
     /*  574313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  574324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  574327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  574330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574359 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  574362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574381 */     GIR_RootConstrainSelectedInstOperands,
     /*  574382 */     // GIR_Coverage, 10242,
     /*  574382 */     GIR_EraseRootFromParent_Done,
     /*  574383 */   // Label 9463: @574383
     /*  574383 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(574458), // Rule ID 10243 //
     /*  574388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  574399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  574402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  574405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574434 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  574437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574456 */     GIR_RootConstrainSelectedInstOperands,
     /*  574457 */     // GIR_Coverage, 10243,
     /*  574457 */     GIR_EraseRootFromParent_Done,
     /*  574458 */   // Label 9464: @574458
     /*  574458 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(574533), // Rule ID 10246 //
     /*  574463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  574512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574531 */     GIR_RootConstrainSelectedInstOperands,
     /*  574532 */     // GIR_Coverage, 10246,
     /*  574532 */     GIR_EraseRootFromParent_Done,
     /*  574533 */   // Label 9465: @574533
     /*  574533 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(574608), // Rule ID 10247 //
     /*  574538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  574587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574606 */     GIR_RootConstrainSelectedInstOperands,
     /*  574607 */     // GIR_Coverage, 10247,
     /*  574607 */     GIR_EraseRootFromParent_Done,
     /*  574608 */   // Label 9466: @574608
     /*  574608 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(574683), // Rule ID 10250 //
     /*  574613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574659 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  574662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574681 */     GIR_RootConstrainSelectedInstOperands,
     /*  574682 */     // GIR_Coverage, 10250,
     /*  574682 */     GIR_EraseRootFromParent_Done,
     /*  574683 */   // Label 9467: @574683
     /*  574683 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(574758), // Rule ID 10251 //
     /*  574688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  574737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574756 */     GIR_RootConstrainSelectedInstOperands,
     /*  574757 */     // GIR_Coverage, 10251,
     /*  574757 */     GIR_EraseRootFromParent_Done,
     /*  574758 */   // Label 9468: @574758
     /*  574758 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(574833), // Rule ID 10254 //
     /*  574763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  574780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  574812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574831 */     GIR_RootConstrainSelectedInstOperands,
     /*  574832 */     // GIR_Coverage, 10254,
     /*  574832 */     GIR_EraseRootFromParent_Done,
     /*  574833 */   // Label 9469: @574833
     /*  574833 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(574908), // Rule ID 10255 //
     /*  574838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  574855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  574887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574906 */     GIR_RootConstrainSelectedInstOperands,
     /*  574907 */     // GIR_Coverage, 10255,
     /*  574907 */     GIR_EraseRootFromParent_Done,
     /*  574908 */   // Label 9470: @574908
     /*  574908 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(574983), // Rule ID 10258 //
     /*  574913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  574962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574981 */     GIR_RootConstrainSelectedInstOperands,
     /*  574982 */     // GIR_Coverage, 10258,
     /*  574982 */     GIR_EraseRootFromParent_Done,
     /*  574983 */   // Label 9471: @574983
     /*  574983 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(575058), // Rule ID 10259 //
     /*  574988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  574996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  575002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  575037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575056 */     GIR_RootConstrainSelectedInstOperands,
     /*  575057 */     // GIR_Coverage, 10259,
     /*  575057 */     GIR_EraseRootFromParent_Done,
     /*  575058 */   // Label 9472: @575058
     /*  575058 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(575133), // Rule ID 10262 //
     /*  575063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  575112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575131 */     GIR_RootConstrainSelectedInstOperands,
     /*  575132 */     // GIR_Coverage, 10262,
     /*  575132 */     GIR_EraseRootFromParent_Done,
     /*  575133 */   // Label 9473: @575133
     /*  575133 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(575208), // Rule ID 10263 //
     /*  575138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  575187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575206 */     GIR_RootConstrainSelectedInstOperands,
     /*  575207 */     // GIR_Coverage, 10263,
     /*  575207 */     GIR_EraseRootFromParent_Done,
     /*  575208 */   // Label 9474: @575208
     /*  575208 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(575283), // Rule ID 10266 //
     /*  575213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  575230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  575262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575281 */     GIR_RootConstrainSelectedInstOperands,
     /*  575282 */     // GIR_Coverage, 10266,
     /*  575282 */     GIR_EraseRootFromParent_Done,
     /*  575283 */   // Label 9475: @575283
     /*  575283 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(575358), // Rule ID 10267 //
     /*  575288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  575305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  575337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575356 */     GIR_RootConstrainSelectedInstOperands,
     /*  575357 */     // GIR_Coverage, 10267,
     /*  575357 */     GIR_EraseRootFromParent_Done,
     /*  575358 */   // Label 9476: @575358
     /*  575358 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(575433), // Rule ID 10270 //
     /*  575363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  575366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  575380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  575409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  575412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575431 */     GIR_RootConstrainSelectedInstOperands,
     /*  575432 */     // GIR_Coverage, 10270,
     /*  575432 */     GIR_EraseRootFromParent_Done,
     /*  575433 */   // Label 9477: @575433
     /*  575433 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(575508), // Rule ID 10271 //
     /*  575438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  575441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  575455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  575484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  575487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575506 */     GIR_RootConstrainSelectedInstOperands,
     /*  575507 */     // GIR_Coverage, 10271,
     /*  575507 */     GIR_EraseRootFromParent_Done,
     /*  575508 */   // Label 9478: @575508
     /*  575508 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(575583), // Rule ID 10274 //
     /*  575513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  575516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  575530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  575559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  575562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575581 */     GIR_RootConstrainSelectedInstOperands,
     /*  575582 */     // GIR_Coverage, 10274,
     /*  575582 */     GIR_EraseRootFromParent_Done,
     /*  575583 */   // Label 9479: @575583
     /*  575583 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(575658), // Rule ID 10275 //
     /*  575588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  575591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  575605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  575634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  575637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575656 */     GIR_RootConstrainSelectedInstOperands,
     /*  575657 */     // GIR_Coverage, 10275,
     /*  575657 */     GIR_EraseRootFromParent_Done,
     /*  575658 */   // Label 9480: @575658
     /*  575658 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(575733), // Rule ID 10278 //
     /*  575663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  575666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  575680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  575709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  575712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575731 */     GIR_RootConstrainSelectedInstOperands,
     /*  575732 */     // GIR_Coverage, 10278,
     /*  575732 */     GIR_EraseRootFromParent_Done,
     /*  575733 */   // Label 9481: @575733
     /*  575733 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(575808), // Rule ID 10279 //
     /*  575738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  575741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  575746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  575755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  575784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  575787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  575803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575806 */     GIR_RootConstrainSelectedInstOperands,
     /*  575807 */     // GIR_Coverage, 10279,
     /*  575807 */     GIR_EraseRootFromParent_Done,
     /*  575808 */   // Label 9482: @575808
     /*  575808 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(575883), // Rule ID 10282 //
     /*  575813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  575821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  575824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  575827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  575862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575881 */     GIR_RootConstrainSelectedInstOperands,
     /*  575882 */     // GIR_Coverage, 10282,
     /*  575882 */     GIR_EraseRootFromParent_Done,
     /*  575883 */   // Label 9483: @575883
     /*  575883 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(575958), // Rule ID 10283 //
     /*  575888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  575896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  575899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  575902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575934 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  575937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575956 */     GIR_RootConstrainSelectedInstOperands,
     /*  575957 */     // GIR_Coverage, 10283,
     /*  575957 */     GIR_EraseRootFromParent_Done,
     /*  575958 */   // Label 9484: @575958
     /*  575958 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(576033), // Rule ID 10286 //
     /*  575963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  575971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  575974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  575977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  576012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576031 */     GIR_RootConstrainSelectedInstOperands,
     /*  576032 */     // GIR_Coverage, 10286,
     /*  576032 */     GIR_EraseRootFromParent_Done,
     /*  576033 */   // Label 9485: @576033
     /*  576033 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(576108), // Rule ID 10287 //
     /*  576038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  576049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  576052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  576055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  576058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  576087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576106 */     GIR_RootConstrainSelectedInstOperands,
     /*  576107 */     // GIR_Coverage, 10287,
     /*  576107 */     GIR_EraseRootFromParent_Done,
     /*  576108 */   // Label 9486: @576108
     /*  576108 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(576183), // Rule ID 10290 //
     /*  576113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  576124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  576127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576181 */     GIR_RootConstrainSelectedInstOperands,
     /*  576182 */     // GIR_Coverage, 10290,
     /*  576182 */     GIR_EraseRootFromParent_Done,
     /*  576183 */   // Label 9487: @576183
     /*  576183 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(576258), // Rule ID 10291 //
     /*  576188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  576199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  576202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576256 */     GIR_RootConstrainSelectedInstOperands,
     /*  576257 */     // GIR_Coverage, 10291,
     /*  576257 */     GIR_EraseRootFromParent_Done,
     /*  576258 */   // Label 9488: @576258
     /*  576258 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(576333), // Rule ID 10294 //
     /*  576263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  576312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576331 */     GIR_RootConstrainSelectedInstOperands,
     /*  576332 */     // GIR_Coverage, 10294,
     /*  576332 */     GIR_EraseRootFromParent_Done,
     /*  576333 */   // Label 9489: @576333
     /*  576333 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(576408), // Rule ID 10295 //
     /*  576338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576384 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  576387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576406 */     GIR_RootConstrainSelectedInstOperands,
     /*  576407 */     // GIR_Coverage, 10295,
     /*  576407 */     GIR_EraseRootFromParent_Done,
     /*  576408 */   // Label 9490: @576408
     /*  576408 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(576483), // Rule ID 10298 //
     /*  576413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576459 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576481 */     GIR_RootConstrainSelectedInstOperands,
     /*  576482 */     // GIR_Coverage, 10298,
     /*  576482 */     GIR_EraseRootFromParent_Done,
     /*  576483 */   // Label 9491: @576483
     /*  576483 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(576558), // Rule ID 10299 //
     /*  576488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576556 */     GIR_RootConstrainSelectedInstOperands,
     /*  576557 */     // GIR_Coverage, 10299,
     /*  576557 */     GIR_EraseRootFromParent_Done,
     /*  576558 */   // Label 9492: @576558
     /*  576558 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(576633), // Rule ID 10302 //
     /*  576563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576631 */     GIR_RootConstrainSelectedInstOperands,
     /*  576632 */     // GIR_Coverage, 10302,
     /*  576632 */     GIR_EraseRootFromParent_Done,
     /*  576633 */   // Label 9493: @576633
     /*  576633 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(576708), // Rule ID 10303 //
     /*  576638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  576687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576706 */     GIR_RootConstrainSelectedInstOperands,
     /*  576707 */     // GIR_Coverage, 10303,
     /*  576707 */     GIR_EraseRootFromParent_Done,
     /*  576708 */   // Label 9494: @576708
     /*  576708 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(576783), // Rule ID 10306 //
     /*  576713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  576724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  576727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  576762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576781 */     GIR_RootConstrainSelectedInstOperands,
     /*  576782 */     // GIR_Coverage, 10306,
     /*  576782 */     GIR_EraseRootFromParent_Done,
     /*  576783 */   // Label 9495: @576783
     /*  576783 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(576858), // Rule ID 10307 //
     /*  576788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  576799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  576802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  576837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576856 */     GIR_RootConstrainSelectedInstOperands,
     /*  576857 */     // GIR_Coverage, 10307,
     /*  576857 */     GIR_EraseRootFromParent_Done,
     /*  576858 */   // Label 9496: @576858
     /*  576858 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(576933), // Rule ID 10310 //
     /*  576863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  576912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576931 */     GIR_RootConstrainSelectedInstOperands,
     /*  576932 */     // GIR_Coverage, 10310,
     /*  576932 */     GIR_EraseRootFromParent_Done,
     /*  576933 */   // Label 9497: @576933
     /*  576933 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(577008), // Rule ID 10311 //
     /*  576938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  576946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  576987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577006 */     GIR_RootConstrainSelectedInstOperands,
     /*  577007 */     // GIR_Coverage, 10311,
     /*  577007 */     GIR_EraseRootFromParent_Done,
     /*  577008 */   // Label 9498: @577008
     /*  577008 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(577083), // Rule ID 10314 //
     /*  577013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  577062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577081 */     GIR_RootConstrainSelectedInstOperands,
     /*  577082 */     // GIR_Coverage, 10314,
     /*  577082 */     GIR_EraseRootFromParent_Done,
     /*  577083 */   // Label 9499: @577083
     /*  577083 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(577158), // Rule ID 10315 //
     /*  577088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  577137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577156 */     GIR_RootConstrainSelectedInstOperands,
     /*  577157 */     // GIR_Coverage, 10315,
     /*  577157 */     GIR_EraseRootFromParent_Done,
     /*  577158 */   // Label 9500: @577158
     /*  577158 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(577233), // Rule ID 10318 //
     /*  577163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  577166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  577180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  577183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  577209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  577212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  577228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577231 */     GIR_RootConstrainSelectedInstOperands,
     /*  577232 */     // GIR_Coverage, 10318,
     /*  577232 */     GIR_EraseRootFromParent_Done,
     /*  577233 */   // Label 9501: @577233
     /*  577233 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(577308), // Rule ID 10319 //
     /*  577238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  577241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  577255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  577258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  577284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  577287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  577303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577306 */     GIR_RootConstrainSelectedInstOperands,
     /*  577307 */     // GIR_Coverage, 10319,
     /*  577307 */     GIR_EraseRootFromParent_Done,
     /*  577308 */   // Label 9502: @577308
     /*  577308 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(577383), // Rule ID 10322 //
     /*  577313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  577324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  577327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  577333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  577362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577381 */     GIR_RootConstrainSelectedInstOperands,
     /*  577382 */     // GIR_Coverage, 10322,
     /*  577382 */     GIR_EraseRootFromParent_Done,
     /*  577383 */   // Label 9503: @577383
     /*  577383 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(577458), // Rule ID 10323 //
     /*  577388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  577399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  577402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  577408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  577437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577456 */     GIR_RootConstrainSelectedInstOperands,
     /*  577457 */     // GIR_Coverage, 10323,
     /*  577457 */     GIR_EraseRootFromParent_Done,
     /*  577458 */   // Label 9504: @577458
     /*  577458 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(577533), // Rule ID 10326 //
     /*  577463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  577474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  577477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  577480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  577483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  577512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577531 */     GIR_RootConstrainSelectedInstOperands,
     /*  577532 */     // GIR_Coverage, 10326,
     /*  577532 */     GIR_EraseRootFromParent_Done,
     /*  577533 */   // Label 9505: @577533
     /*  577533 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(577608), // Rule ID 10327 //
     /*  577538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  577549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  577552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  577555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  577558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  577587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577606 */     GIR_RootConstrainSelectedInstOperands,
     /*  577607 */     // GIR_Coverage, 10327,
     /*  577607 */     GIR_EraseRootFromParent_Done,
     /*  577608 */   // Label 9506: @577608
     /*  577608 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(577683), // Rule ID 10330 //
     /*  577613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  577624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  577627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  577630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  577633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577659 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  577662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577681 */     GIR_RootConstrainSelectedInstOperands,
     /*  577682 */     // GIR_Coverage, 10330,
     /*  577682 */     GIR_EraseRootFromParent_Done,
     /*  577683 */   // Label 9507: @577683
     /*  577683 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(577758), // Rule ID 10331 //
     /*  577688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  577699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  577702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  577705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  577708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  577737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577756 */     GIR_RootConstrainSelectedInstOperands,
     /*  577757 */     // GIR_Coverage, 10331,
     /*  577757 */     GIR_EraseRootFromParent_Done,
     /*  577758 */   // Label 9508: @577758
     /*  577758 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(577833), // Rule ID 10334 //
     /*  577763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  577812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577831 */     GIR_RootConstrainSelectedInstOperands,
     /*  577832 */     // GIR_Coverage, 10334,
     /*  577832 */     GIR_EraseRootFromParent_Done,
     /*  577833 */   // Label 9509: @577833
     /*  577833 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(577908), // Rule ID 10335 //
     /*  577838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  577887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577906 */     GIR_RootConstrainSelectedInstOperands,
     /*  577907 */     // GIR_Coverage, 10335,
     /*  577907 */     GIR_EraseRootFromParent_Done,
     /*  577908 */   // Label 9510: @577908
     /*  577908 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(577983), // Rule ID 10338 //
     /*  577913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  577962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577981 */     GIR_RootConstrainSelectedInstOperands,
     /*  577982 */     // GIR_Coverage, 10338,
     /*  577982 */     GIR_EraseRootFromParent_Done,
     /*  577983 */   // Label 9511: @577983
     /*  577983 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(578058), // Rule ID 10339 //
     /*  577988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  577996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  578008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  578037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578056 */     GIR_RootConstrainSelectedInstOperands,
     /*  578057 */     // GIR_Coverage, 10339,
     /*  578057 */     GIR_EraseRootFromParent_Done,
     /*  578058 */   // Label 9512: @578058
     /*  578058 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(578133), // Rule ID 10342 //
     /*  578063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  578080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  578083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  578112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578131 */     GIR_RootConstrainSelectedInstOperands,
     /*  578132 */     // GIR_Coverage, 10342,
     /*  578132 */     GIR_EraseRootFromParent_Done,
     /*  578133 */   // Label 9513: @578133
     /*  578133 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(578208), // Rule ID 10343 //
     /*  578138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  578155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  578158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  578187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578206 */     GIR_RootConstrainSelectedInstOperands,
     /*  578207 */     // GIR_Coverage, 10343,
     /*  578207 */     GIR_EraseRootFromParent_Done,
     /*  578208 */   // Label 9514: @578208
     /*  578208 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(578283), // Rule ID 10346 //
     /*  578213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  578262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578281 */     GIR_RootConstrainSelectedInstOperands,
     /*  578282 */     // GIR_Coverage, 10346,
     /*  578282 */     GIR_EraseRootFromParent_Done,
     /*  578283 */   // Label 9515: @578283
     /*  578283 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(578358), // Rule ID 10347 //
     /*  578288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  578337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578356 */     GIR_RootConstrainSelectedInstOperands,
     /*  578357 */     // GIR_Coverage, 10347,
     /*  578357 */     GIR_EraseRootFromParent_Done,
     /*  578358 */   // Label 9516: @578358
     /*  578358 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(578433), // Rule ID 10350 //
     /*  578363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  578412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578431 */     GIR_RootConstrainSelectedInstOperands,
     /*  578432 */     // GIR_Coverage, 10350,
     /*  578432 */     GIR_EraseRootFromParent_Done,
     /*  578433 */   // Label 9517: @578433
     /*  578433 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(578508), // Rule ID 10351 //
     /*  578438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  578487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578506 */     GIR_RootConstrainSelectedInstOperands,
     /*  578507 */     // GIR_Coverage, 10351,
     /*  578507 */     GIR_EraseRootFromParent_Done,
     /*  578508 */   // Label 9518: @578508
     /*  578508 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(578583), // Rule ID 10354 //
     /*  578513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  578530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  578533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  578562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578581 */     GIR_RootConstrainSelectedInstOperands,
     /*  578582 */     // GIR_Coverage, 10354,
     /*  578582 */     GIR_EraseRootFromParent_Done,
     /*  578583 */   // Label 9519: @578583
     /*  578583 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(578658), // Rule ID 10355 //
     /*  578588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  578605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  578608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  578637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578656 */     GIR_RootConstrainSelectedInstOperands,
     /*  578657 */     // GIR_Coverage, 10355,
     /*  578657 */     GIR_EraseRootFromParent_Done,
     /*  578658 */   // Label 9520: @578658
     /*  578658 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(578733), // Rule ID 10358 //
     /*  578663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  578666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  578674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  578677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  578680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  578683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  578709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  578712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  578728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578731 */     GIR_RootConstrainSelectedInstOperands,
     /*  578732 */     // GIR_Coverage, 10358,
     /*  578732 */     GIR_EraseRootFromParent_Done,
     /*  578733 */   // Label 9521: @578733
     /*  578733 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(578808), // Rule ID 10359 //
     /*  578738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  578741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  578749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  578752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  578755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  578758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  578784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  578787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  578803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578806 */     GIR_RootConstrainSelectedInstOperands,
     /*  578807 */     // GIR_Coverage, 10359,
     /*  578807 */     GIR_EraseRootFromParent_Done,
     /*  578808 */   // Label 9522: @578808
     /*  578808 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(578883), // Rule ID 10362 //
     /*  578813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  578816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  578830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  578833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  578859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  578862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  578878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578881 */     GIR_RootConstrainSelectedInstOperands,
     /*  578882 */     // GIR_Coverage, 10362,
     /*  578882 */     GIR_EraseRootFromParent_Done,
     /*  578883 */   // Label 9523: @578883
     /*  578883 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(578958), // Rule ID 10363 //
     /*  578888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  578891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  578905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  578908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  578934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  578937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  578953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578956 */     GIR_RootConstrainSelectedInstOperands,
     /*  578957 */     // GIR_Coverage, 10363,
     /*  578957 */     GIR_EraseRootFromParent_Done,
     /*  578958 */   // Label 9524: @578958
     /*  578958 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(579033), // Rule ID 10366 //
     /*  578963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  578966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  578971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  578974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  578977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  578980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  578983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579009 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  579009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  579012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  579028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579031 */     GIR_RootConstrainSelectedInstOperands,
     /*  579032 */     // GIR_Coverage, 10366,
     /*  579032 */     GIR_EraseRootFromParent_Done,
     /*  579033 */   // Label 9525: @579033
     /*  579033 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(579108), // Rule ID 10367 //
     /*  579038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  579041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  579055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  579058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  579084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  579087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  579103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579106 */     GIR_RootConstrainSelectedInstOperands,
     /*  579107 */     // GIR_Coverage, 10367,
     /*  579107 */     GIR_EraseRootFromParent_Done,
     /*  579108 */   // Label 9526: @579108
     /*  579108 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(579183), // Rule ID 10370 //
     /*  579113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  579124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  579127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579159 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  579162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579181 */     GIR_RootConstrainSelectedInstOperands,
     /*  579182 */     // GIR_Coverage, 10370,
     /*  579182 */     GIR_EraseRootFromParent_Done,
     /*  579183 */   // Label 9527: @579183
     /*  579183 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(579258), // Rule ID 10371 //
     /*  579188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  579199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  579202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  579237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579256 */     GIR_RootConstrainSelectedInstOperands,
     /*  579257 */     // GIR_Coverage, 10371,
     /*  579257 */     GIR_EraseRootFromParent_Done,
     /*  579258 */   // Label 9528: @579258
     /*  579258 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(579333), // Rule ID 10374 //
     /*  579263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  579274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  579277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  579312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579331 */     GIR_RootConstrainSelectedInstOperands,
     /*  579332 */     // GIR_Coverage, 10374,
     /*  579332 */     GIR_EraseRootFromParent_Done,
     /*  579333 */   // Label 9529: @579333
     /*  579333 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(579408), // Rule ID 10375 //
     /*  579338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  579349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  579352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  579387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579406 */     GIR_RootConstrainSelectedInstOperands,
     /*  579407 */     // GIR_Coverage, 10375,
     /*  579407 */     GIR_EraseRootFromParent_Done,
     /*  579408 */   // Label 9530: @579408
     /*  579408 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(579483), // Rule ID 10378 //
     /*  579413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  579424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  579427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579459 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579481 */     GIR_RootConstrainSelectedInstOperands,
     /*  579482 */     // GIR_Coverage, 10378,
     /*  579482 */     GIR_EraseRootFromParent_Done,
     /*  579483 */   // Label 9531: @579483
     /*  579483 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(579558), // Rule ID 10379 //
     /*  579488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  579499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  579502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579556 */     GIR_RootConstrainSelectedInstOperands,
     /*  579557 */     // GIR_Coverage, 10379,
     /*  579557 */     GIR_EraseRootFromParent_Done,
     /*  579558 */   // Label 9532: @579558
     /*  579558 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(579633), // Rule ID 10382 //
     /*  579563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  579612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579631 */     GIR_RootConstrainSelectedInstOperands,
     /*  579632 */     // GIR_Coverage, 10382,
     /*  579632 */     GIR_EraseRootFromParent_Done,
     /*  579633 */   // Label 9533: @579633
     /*  579633 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(579708), // Rule ID 10383 //
     /*  579638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  579687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579706 */     GIR_RootConstrainSelectedInstOperands,
     /*  579707 */     // GIR_Coverage, 10383,
     /*  579707 */     GIR_EraseRootFromParent_Done,
     /*  579708 */   // Label 9534: @579708
     /*  579708 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(579783), // Rule ID 10386 //
     /*  579713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579759 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579781 */     GIR_RootConstrainSelectedInstOperands,
     /*  579782 */     // GIR_Coverage, 10386,
     /*  579782 */     GIR_EraseRootFromParent_Done,
     /*  579783 */   // Label 9535: @579783
     /*  579783 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(579858), // Rule ID 10387 //
     /*  579788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579856 */     GIR_RootConstrainSelectedInstOperands,
     /*  579857 */     // GIR_Coverage, 10387,
     /*  579857 */     GIR_EraseRootFromParent_Done,
     /*  579858 */   // Label 9536: @579858
     /*  579858 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(579933), // Rule ID 10390 //
     /*  579863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579931 */     GIR_RootConstrainSelectedInstOperands,
     /*  579932 */     // GIR_Coverage, 10390,
     /*  579932 */     GIR_EraseRootFromParent_Done,
     /*  579933 */   // Label 9537: @579933
     /*  579933 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(580008), // Rule ID 10391 //
     /*  579938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  579946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  579987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580006 */     GIR_RootConstrainSelectedInstOperands,
     /*  580007 */     // GIR_Coverage, 10391,
     /*  580007 */     GIR_EraseRootFromParent_Done,
     /*  580008 */   // Label 9538: @580008
     /*  580008 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(580083), // Rule ID 10394 //
     /*  580013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  580024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  580027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580081 */     GIR_RootConstrainSelectedInstOperands,
     /*  580082 */     // GIR_Coverage, 10394,
     /*  580082 */     GIR_EraseRootFromParent_Done,
     /*  580083 */   // Label 9539: @580083
     /*  580083 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(580158), // Rule ID 10395 //
     /*  580088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  580099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  580102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580156 */     GIR_RootConstrainSelectedInstOperands,
     /*  580157 */     // GIR_Coverage, 10395,
     /*  580157 */     GIR_EraseRootFromParent_Done,
     /*  580158 */   // Label 9540: @580158
     /*  580158 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(580233), // Rule ID 10398 //
     /*  580163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580231 */     GIR_RootConstrainSelectedInstOperands,
     /*  580232 */     // GIR_Coverage, 10398,
     /*  580232 */     GIR_EraseRootFromParent_Done,
     /*  580233 */   // Label 9541: @580233
     /*  580233 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(580308), // Rule ID 10399 //
     /*  580238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580306 */     GIR_RootConstrainSelectedInstOperands,
     /*  580307 */     // GIR_Coverage, 10399,
     /*  580307 */     GIR_EraseRootFromParent_Done,
     /*  580308 */   // Label 9542: @580308
     /*  580308 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(580383), // Rule ID 10402 //
     /*  580313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580381 */     GIR_RootConstrainSelectedInstOperands,
     /*  580382 */     // GIR_Coverage, 10402,
     /*  580382 */     GIR_EraseRootFromParent_Done,
     /*  580383 */   // Label 9543: @580383
     /*  580383 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(580458), // Rule ID 10403 //
     /*  580388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580456 */     GIR_RootConstrainSelectedInstOperands,
     /*  580457 */     // GIR_Coverage, 10403,
     /*  580457 */     GIR_EraseRootFromParent_Done,
     /*  580458 */   // Label 9544: @580458
     /*  580458 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(580533), // Rule ID 10406 //
     /*  580463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  580466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  580480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  580509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  580528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580531 */     GIR_RootConstrainSelectedInstOperands,
     /*  580532 */     // GIR_Coverage, 10406,
     /*  580532 */     GIR_EraseRootFromParent_Done,
     /*  580533 */   // Label 9545: @580533
     /*  580533 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(580608), // Rule ID 10407 //
     /*  580538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  580541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  580555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  580584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  580587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  580603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580606 */     GIR_RootConstrainSelectedInstOperands,
     /*  580607 */     // GIR_Coverage, 10407,
     /*  580607 */     GIR_EraseRootFromParent_Done,
     /*  580608 */   // Label 9546: @580608
     /*  580608 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(580683), // Rule ID 10410 //
     /*  580613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  580624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  580627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  580662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580681 */     GIR_RootConstrainSelectedInstOperands,
     /*  580682 */     // GIR_Coverage, 10410,
     /*  580682 */     GIR_EraseRootFromParent_Done,
     /*  580683 */   // Label 9547: @580683
     /*  580683 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(580758), // Rule ID 10411 //
     /*  580688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  580699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  580702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  580737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580756 */     GIR_RootConstrainSelectedInstOperands,
     /*  580757 */     // GIR_Coverage, 10411,
     /*  580757 */     GIR_EraseRootFromParent_Done,
     /*  580758 */   // Label 9548: @580758
     /*  580758 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(580833), // Rule ID 10414 //
     /*  580763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  580774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  580777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580809 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  580812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580831 */     GIR_RootConstrainSelectedInstOperands,
     /*  580832 */     // GIR_Coverage, 10414,
     /*  580832 */     GIR_EraseRootFromParent_Done,
     /*  580833 */   // Label 9549: @580833
     /*  580833 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(580908), // Rule ID 10415 //
     /*  580838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  580849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  580852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  580887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580906 */     GIR_RootConstrainSelectedInstOperands,
     /*  580907 */     // GIR_Coverage, 10415,
     /*  580907 */     GIR_EraseRootFromParent_Done,
     /*  580908 */   // Label 9550: @580908
     /*  580908 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(580983), // Rule ID 10418 //
     /*  580913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  580924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  580927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  580930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580959 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  580962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580981 */     GIR_RootConstrainSelectedInstOperands,
     /*  580982 */     // GIR_Coverage, 10418,
     /*  580982 */     GIR_EraseRootFromParent_Done,
     /*  580983 */   // Label 9551: @580983
     /*  580983 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(581058), // Rule ID 10419 //
     /*  580988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  580996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  580999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  581002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  581005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581034 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  581037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581056 */     GIR_RootConstrainSelectedInstOperands,
     /*  581057 */     // GIR_Coverage, 10419,
     /*  581057 */     GIR_EraseRootFromParent_Done,
     /*  581058 */   // Label 9552: @581058
     /*  581058 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(581133), // Rule ID 10422 //
     /*  581063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  581112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581131 */     GIR_RootConstrainSelectedInstOperands,
     /*  581132 */     // GIR_Coverage, 10422,
     /*  581132 */     GIR_EraseRootFromParent_Done,
     /*  581133 */   // Label 9553: @581133
     /*  581133 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(581208), // Rule ID 10423 //
     /*  581138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  581187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581206 */     GIR_RootConstrainSelectedInstOperands,
     /*  581207 */     // GIR_Coverage, 10423,
     /*  581207 */     GIR_EraseRootFromParent_Done,
     /*  581208 */   // Label 9554: @581208
     /*  581208 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(581283), // Rule ID 10426 //
     /*  581213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581259 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  581262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581281 */     GIR_RootConstrainSelectedInstOperands,
     /*  581282 */     // GIR_Coverage, 10426,
     /*  581282 */     GIR_EraseRootFromParent_Done,
     /*  581283 */   // Label 9555: @581283
     /*  581283 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(581358), // Rule ID 10427 //
     /*  581288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  581337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581356 */     GIR_RootConstrainSelectedInstOperands,
     /*  581357 */     // GIR_Coverage, 10427,
     /*  581357 */     GIR_EraseRootFromParent_Done,
     /*  581358 */   // Label 9556: @581358
     /*  581358 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(581433), // Rule ID 10430 //
     /*  581363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  581380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  581412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581431 */     GIR_RootConstrainSelectedInstOperands,
     /*  581432 */     // GIR_Coverage, 10430,
     /*  581432 */     GIR_EraseRootFromParent_Done,
     /*  581433 */   // Label 9557: @581433
     /*  581433 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(581508), // Rule ID 10431 //
     /*  581438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  581455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581484 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  581487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581506 */     GIR_RootConstrainSelectedInstOperands,
     /*  581507 */     // GIR_Coverage, 10431,
     /*  581507 */     GIR_EraseRootFromParent_Done,
     /*  581508 */   // Label 9558: @581508
     /*  581508 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(581583), // Rule ID 10434 //
     /*  581513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  581562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581581 */     GIR_RootConstrainSelectedInstOperands,
     /*  581582 */     // GIR_Coverage, 10434,
     /*  581582 */     GIR_EraseRootFromParent_Done,
     /*  581583 */   // Label 9559: @581583
     /*  581583 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(581658), // Rule ID 10435 //
     /*  581588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  581637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581656 */     GIR_RootConstrainSelectedInstOperands,
     /*  581657 */     // GIR_Coverage, 10435,
     /*  581657 */     GIR_EraseRootFromParent_Done,
     /*  581658 */   // Label 9560: @581658
     /*  581658 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(581733), // Rule ID 10438 //
     /*  581663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581709 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  581712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581731 */     GIR_RootConstrainSelectedInstOperands,
     /*  581732 */     // GIR_Coverage, 10438,
     /*  581732 */     GIR_EraseRootFromParent_Done,
     /*  581733 */   // Label 9561: @581733
     /*  581733 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(581808), // Rule ID 10439 //
     /*  581738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  581787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581806 */     GIR_RootConstrainSelectedInstOperands,
     /*  581807 */     // GIR_Coverage, 10439,
     /*  581807 */     GIR_EraseRootFromParent_Done,
     /*  581808 */   // Label 9562: @581808
     /*  581808 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(581883), // Rule ID 10442 //
     /*  581813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  581830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  581862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581881 */     GIR_RootConstrainSelectedInstOperands,
     /*  581882 */     // GIR_Coverage, 10442,
     /*  581882 */     GIR_EraseRootFromParent_Done,
     /*  581883 */   // Label 9563: @581883
     /*  581883 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(581958), // Rule ID 10443 //
     /*  581888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  581905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  581937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581956 */     GIR_RootConstrainSelectedInstOperands,
     /*  581957 */     // GIR_Coverage, 10443,
     /*  581957 */     GIR_EraseRootFromParent_Done,
     /*  581958 */   // Label 9564: @581958
     /*  581958 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(582033), // Rule ID 10446 //
     /*  581963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  581966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  581971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  581980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  582009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  582012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582031 */     GIR_RootConstrainSelectedInstOperands,
     /*  582032 */     // GIR_Coverage, 10446,
     /*  582032 */     GIR_EraseRootFromParent_Done,
     /*  582033 */   // Label 9565: @582033
     /*  582033 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(582108), // Rule ID 10447 //
     /*  582038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  582041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  582046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  582055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  582084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  582087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582106 */     GIR_RootConstrainSelectedInstOperands,
     /*  582107 */     // GIR_Coverage, 10447,
     /*  582107 */     GIR_EraseRootFromParent_Done,
     /*  582108 */   // Label 9566: @582108
     /*  582108 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(582183), // Rule ID 10450 //
     /*  582113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  582116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  582121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  582130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  582159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  582162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582181 */     GIR_RootConstrainSelectedInstOperands,
     /*  582182 */     // GIR_Coverage, 10450,
     /*  582182 */     GIR_EraseRootFromParent_Done,
     /*  582183 */   // Label 9567: @582183
     /*  582183 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(582258), // Rule ID 10451 //
     /*  582188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  582191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  582196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  582205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  582234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  582237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582256 */     GIR_RootConstrainSelectedInstOperands,
     /*  582257 */     // GIR_Coverage, 10451,
     /*  582257 */     GIR_EraseRootFromParent_Done,
     /*  582258 */   // Label 9568: @582258
     /*  582258 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(582333), // Rule ID 10454 //
     /*  582263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  582266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  582271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  582280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  582309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  582312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582331 */     GIR_RootConstrainSelectedInstOperands,
     /*  582332 */     // GIR_Coverage, 10454,
     /*  582332 */     GIR_EraseRootFromParent_Done,
     /*  582333 */   // Label 9569: @582333
     /*  582333 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(582408), // Rule ID 10455 //
     /*  582338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  582341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  582346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  582355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  582384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  582387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  582403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582406 */     GIR_RootConstrainSelectedInstOperands,
     /*  582407 */     // GIR_Coverage, 10455,
     /*  582407 */     GIR_EraseRootFromParent_Done,
     /*  582408 */   // Label 9570: @582408
     /*  582408 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(582483), // Rule ID 10458 //
     /*  582413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  582424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  582427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  582433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  582462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582481 */     GIR_RootConstrainSelectedInstOperands,
     /*  582482 */     // GIR_Coverage, 10458,
     /*  582482 */     GIR_EraseRootFromParent_Done,
     /*  582483 */   // Label 9571: @582483
     /*  582483 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(582558), // Rule ID 10459 //
     /*  582488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  582499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  582502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  582508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  582537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582556 */     GIR_RootConstrainSelectedInstOperands,
     /*  582557 */     // GIR_Coverage, 10459,
     /*  582557 */     GIR_EraseRootFromParent_Done,
     /*  582558 */   // Label 9572: @582558
     /*  582558 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(582633), // Rule ID 10462 //
     /*  582563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  582574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  582577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  582583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582609 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  582612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582631 */     GIR_RootConstrainSelectedInstOperands,
     /*  582632 */     // GIR_Coverage, 10462,
     /*  582632 */     GIR_EraseRootFromParent_Done,
     /*  582633 */   // Label 9573: @582633
     /*  582633 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(582708), // Rule ID 10463 //
     /*  582638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  582649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  582652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  582658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  582687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582706 */     GIR_RootConstrainSelectedInstOperands,
     /*  582707 */     // GIR_Coverage, 10463,
     /*  582707 */     GIR_EraseRootFromParent_Done,
     /*  582708 */   // Label 9574: @582708
     /*  582708 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(582783), // Rule ID 10466 //
     /*  582713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  582724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  582727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  582733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  582762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582781 */     GIR_RootConstrainSelectedInstOperands,
     /*  582782 */     // GIR_Coverage, 10466,
     /*  582782 */     GIR_EraseRootFromParent_Done,
     /*  582783 */   // Label 9575: @582783
     /*  582783 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(582858), // Rule ID 10467 //
     /*  582788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  582799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  582802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  582808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  582837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582856 */     GIR_RootConstrainSelectedInstOperands,
     /*  582857 */     // GIR_Coverage, 10467,
     /*  582857 */     GIR_EraseRootFromParent_Done,
     /*  582858 */   // Label 9576: @582858
     /*  582858 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(582933), // Rule ID 10470 //
     /*  582863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  582883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  582912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582931 */     GIR_RootConstrainSelectedInstOperands,
     /*  582932 */     // GIR_Coverage, 10470,
     /*  582932 */     GIR_EraseRootFromParent_Done,
     /*  582933 */   // Label 9577: @582933
     /*  582933 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(583008), // Rule ID 10471 //
     /*  582938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  582946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  582958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  582987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583006 */     GIR_RootConstrainSelectedInstOperands,
     /*  583007 */     // GIR_Coverage, 10471,
     /*  583007 */     GIR_EraseRootFromParent_Done,
     /*  583008 */   // Label 9578: @583008
     /*  583008 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(583083), // Rule ID 10474 //
     /*  583013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  583033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  583062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583081 */     GIR_RootConstrainSelectedInstOperands,
     /*  583082 */     // GIR_Coverage, 10474,
     /*  583082 */     GIR_EraseRootFromParent_Done,
     /*  583083 */   // Label 9579: @583083
     /*  583083 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(583158), // Rule ID 10475 //
     /*  583088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  583108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  583137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583156 */     GIR_RootConstrainSelectedInstOperands,
     /*  583157 */     // GIR_Coverage, 10475,
     /*  583157 */     GIR_EraseRootFromParent_Done,
     /*  583158 */   // Label 9580: @583158
     /*  583158 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(583233), // Rule ID 10478 //
     /*  583163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  583183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583209 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  583212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583231 */     GIR_RootConstrainSelectedInstOperands,
     /*  583232 */     // GIR_Coverage, 10478,
     /*  583232 */     GIR_EraseRootFromParent_Done,
     /*  583233 */   // Label 9581: @583233
     /*  583233 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(583308), // Rule ID 10479 //
     /*  583238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  583258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  583287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583306 */     GIR_RootConstrainSelectedInstOperands,
     /*  583307 */     // GIR_Coverage, 10479,
     /*  583307 */     GIR_EraseRootFromParent_Done,
     /*  583308 */   // Label 9582: @583308
     /*  583308 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(583383), // Rule ID 10482 //
     /*  583313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  583324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  583327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  583333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583381 */     GIR_RootConstrainSelectedInstOperands,
     /*  583382 */     // GIR_Coverage, 10482,
     /*  583382 */     GIR_EraseRootFromParent_Done,
     /*  583383 */   // Label 9583: @583383
     /*  583383 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(583458), // Rule ID 10483 //
     /*  583388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  583399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  583402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  583408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583456 */     GIR_RootConstrainSelectedInstOperands,
     /*  583457 */     // GIR_Coverage, 10483,
     /*  583457 */     GIR_EraseRootFromParent_Done,
     /*  583458 */   // Label 9584: @583458
     /*  583458 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(583533), // Rule ID 10486 //
     /*  583463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  583483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583531 */     GIR_RootConstrainSelectedInstOperands,
     /*  583532 */     // GIR_Coverage, 10486,
     /*  583532 */     GIR_EraseRootFromParent_Done,
     /*  583533 */   // Label 9585: @583533
     /*  583533 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(583608), // Rule ID 10487 //
     /*  583538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  583558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583606 */     GIR_RootConstrainSelectedInstOperands,
     /*  583607 */     // GIR_Coverage, 10487,
     /*  583607 */     GIR_EraseRootFromParent_Done,
     /*  583608 */   // Label 9586: @583608
     /*  583608 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(583683), // Rule ID 10490 //
     /*  583613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  583633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583681 */     GIR_RootConstrainSelectedInstOperands,
     /*  583682 */     // GIR_Coverage, 10490,
     /*  583682 */     GIR_EraseRootFromParent_Done,
     /*  583683 */   // Label 9587: @583683
     /*  583683 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(583758), // Rule ID 10491 //
     /*  583688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  583708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583756 */     GIR_RootConstrainSelectedInstOperands,
     /*  583757 */     // GIR_Coverage, 10491,
     /*  583757 */     GIR_EraseRootFromParent_Done,
     /*  583758 */   // Label 9588: @583758
     /*  583758 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(583833), // Rule ID 10494 //
     /*  583763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  583766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  583780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  583783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583809 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  583809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  583828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583831 */     GIR_RootConstrainSelectedInstOperands,
     /*  583832 */     // GIR_Coverage, 10494,
     /*  583832 */     GIR_EraseRootFromParent_Done,
     /*  583833 */   // Label 9589: @583833
     /*  583833 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(583908), // Rule ID 10495 //
     /*  583838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  583841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  583855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  583858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  583884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  583887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  583903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583906 */     GIR_RootConstrainSelectedInstOperands,
     /*  583907 */     // GIR_Coverage, 10495,
     /*  583907 */     GIR_EraseRootFromParent_Done,
     /*  583908 */   // Label 9590: @583908
     /*  583908 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(583983), // Rule ID 10498 //
     /*  583913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  583924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  583927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  583933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  583962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583981 */     GIR_RootConstrainSelectedInstOperands,
     /*  583982 */     // GIR_Coverage, 10498,
     /*  583982 */     GIR_EraseRootFromParent_Done,
     /*  583983 */   // Label 9591: @583983
     /*  583983 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(584058), // Rule ID 10499 //
     /*  583988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  583996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  583999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  584002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  584005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  584037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584056 */     GIR_RootConstrainSelectedInstOperands,
     /*  584057 */     // GIR_Coverage, 10499,
     /*  584057 */     GIR_EraseRootFromParent_Done,
     /*  584058 */   // Label 9592: @584058
     /*  584058 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(584133), // Rule ID 10502 //
     /*  584063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  584074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  584077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584109 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  584112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584131 */     GIR_RootConstrainSelectedInstOperands,
     /*  584132 */     // GIR_Coverage, 10502,
     /*  584132 */     GIR_EraseRootFromParent_Done,
     /*  584133 */   // Label 9593: @584133
     /*  584133 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(584208), // Rule ID 10503 //
     /*  584138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  584149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  584152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584184 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  584187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584206 */     GIR_RootConstrainSelectedInstOperands,
     /*  584207 */     // GIR_Coverage, 10503,
     /*  584207 */     GIR_EraseRootFromParent_Done,
     /*  584208 */   // Label 9594: @584208
     /*  584208 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(584283), // Rule ID 10506 //
     /*  584213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  584224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  584227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  584230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  584233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  584262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584281 */     GIR_RootConstrainSelectedInstOperands,
     /*  584282 */     // GIR_Coverage, 10506,
     /*  584282 */     GIR_EraseRootFromParent_Done,
     /*  584283 */   // Label 9595: @584283
     /*  584283 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(584358), // Rule ID 10507 //
     /*  584288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  584299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  584302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  584305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  584308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584334 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  584337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584356 */     GIR_RootConstrainSelectedInstOperands,
     /*  584357 */     // GIR_Coverage, 10507,
     /*  584357 */     GIR_EraseRootFromParent_Done,
     /*  584358 */   // Label 9596: @584358
     /*  584358 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(584433), // Rule ID 10510 //
     /*  584363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  584383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  584412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584431 */     GIR_RootConstrainSelectedInstOperands,
     /*  584432 */     // GIR_Coverage, 10510,
     /*  584432 */     GIR_EraseRootFromParent_Done,
     /*  584433 */   // Label 9597: @584433
     /*  584433 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(584508), // Rule ID 10511 //
     /*  584438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  584458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  584487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584506 */     GIR_RootConstrainSelectedInstOperands,
     /*  584507 */     // GIR_Coverage, 10511,
     /*  584507 */     GIR_EraseRootFromParent_Done,
     /*  584508 */   // Label 9598: @584508
     /*  584508 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(584583), // Rule ID 10514 //
     /*  584513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  584533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584559 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  584562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584581 */     GIR_RootConstrainSelectedInstOperands,
     /*  584582 */     // GIR_Coverage, 10514,
     /*  584582 */     GIR_EraseRootFromParent_Done,
     /*  584583 */   // Label 9599: @584583
     /*  584583 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(584658), // Rule ID 10515 //
     /*  584588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  584608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  584637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584656 */     GIR_RootConstrainSelectedInstOperands,
     /*  584657 */     // GIR_Coverage, 10515,
     /*  584657 */     GIR_EraseRootFromParent_Done,
     /*  584658 */   // Label 9600: @584658
     /*  584658 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(584733), // Rule ID 10518 //
     /*  584663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  584680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  584683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  584712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584731 */     GIR_RootConstrainSelectedInstOperands,
     /*  584732 */     // GIR_Coverage, 10518,
     /*  584732 */     GIR_EraseRootFromParent_Done,
     /*  584733 */   // Label 9601: @584733
     /*  584733 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(584808), // Rule ID 10519 //
     /*  584738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  584755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  584758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  584787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584806 */     GIR_RootConstrainSelectedInstOperands,
     /*  584807 */     // GIR_Coverage, 10519,
     /*  584807 */     GIR_EraseRootFromParent_Done,
     /*  584808 */   // Label 9602: @584808
     /*  584808 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(584883), // Rule ID 10522 //
     /*  584813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  584833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  584862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584881 */     GIR_RootConstrainSelectedInstOperands,
     /*  584882 */     // GIR_Coverage, 10522,
     /*  584882 */     GIR_EraseRootFromParent_Done,
     /*  584883 */   // Label 9603: @584883
     /*  584883 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(584958), // Rule ID 10523 //
     /*  584888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  584908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  584937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584956 */     GIR_RootConstrainSelectedInstOperands,
     /*  584957 */     // GIR_Coverage, 10523,
     /*  584957 */     GIR_EraseRootFromParent_Done,
     /*  584958 */   // Label 9604: @584958
     /*  584958 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(585033), // Rule ID 10526 //
     /*  584963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  584971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  584974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  584977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  584983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  585012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585031 */     GIR_RootConstrainSelectedInstOperands,
     /*  585032 */     // GIR_Coverage, 10526,
     /*  585032 */     GIR_EraseRootFromParent_Done,
     /*  585033 */   // Label 9605: @585033
     /*  585033 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(585108), // Rule ID 10527 //
     /*  585038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  585058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  585087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585106 */     GIR_RootConstrainSelectedInstOperands,
     /*  585107 */     // GIR_Coverage, 10527,
     /*  585107 */     GIR_EraseRootFromParent_Done,
     /*  585108 */   // Label 9606: @585108
     /*  585108 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(585183), // Rule ID 10530 //
     /*  585113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  585130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  585133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  585162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585181 */     GIR_RootConstrainSelectedInstOperands,
     /*  585182 */     // GIR_Coverage, 10530,
     /*  585182 */     GIR_EraseRootFromParent_Done,
     /*  585183 */   // Label 9607: @585183
     /*  585183 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(585258), // Rule ID 10531 //
     /*  585188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  585205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  585208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  585237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585256 */     GIR_RootConstrainSelectedInstOperands,
     /*  585257 */     // GIR_Coverage, 10531,
     /*  585257 */     GIR_EraseRootFromParent_Done,
     /*  585258 */   // Label 9608: @585258
     /*  585258 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(585333), // Rule ID 10534 //
     /*  585263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  585266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  585280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  585283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  585309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  585312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585331 */     GIR_RootConstrainSelectedInstOperands,
     /*  585332 */     // GIR_Coverage, 10534,
     /*  585332 */     GIR_EraseRootFromParent_Done,
     /*  585333 */   // Label 9609: @585333
     /*  585333 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(585408), // Rule ID 10535 //
     /*  585338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  585341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  585355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  585358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  585384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  585387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585406 */     GIR_RootConstrainSelectedInstOperands,
     /*  585407 */     // GIR_Coverage, 10535,
     /*  585407 */     GIR_EraseRootFromParent_Done,
     /*  585408 */   // Label 9610: @585408
     /*  585408 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(585483), // Rule ID 10538 //
     /*  585413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  585416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  585424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  585427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  585430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  585433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  585459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  585462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585481 */     GIR_RootConstrainSelectedInstOperands,
     /*  585482 */     // GIR_Coverage, 10538,
     /*  585482 */     GIR_EraseRootFromParent_Done,
     /*  585483 */   // Label 9611: @585483
     /*  585483 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(585558), // Rule ID 10539 //
     /*  585488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  585491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  585499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  585502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  585505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  585508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585534 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  585534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  585537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585556 */     GIR_RootConstrainSelectedInstOperands,
     /*  585557 */     // GIR_Coverage, 10539,
     /*  585557 */     GIR_EraseRootFromParent_Done,
     /*  585558 */   // Label 9612: @585558
     /*  585558 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(585633), // Rule ID 10542 //
     /*  585563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  585566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  585574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  585577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  585580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  585583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  585609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  585612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585631 */     GIR_RootConstrainSelectedInstOperands,
     /*  585632 */     // GIR_Coverage, 10542,
     /*  585632 */     GIR_EraseRootFromParent_Done,
     /*  585633 */   // Label 9613: @585633
     /*  585633 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(585708), // Rule ID 10543 //
     /*  585638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  585641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  585649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  585652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  585655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  585658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  585684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  585687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  585703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585706 */     GIR_RootConstrainSelectedInstOperands,
     /*  585707 */     // GIR_Coverage, 10543,
     /*  585707 */     GIR_EraseRootFromParent_Done,
     /*  585708 */   // Label 9614: @585708
     /*  585708 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(585783), // Rule ID 10546 //
     /*  585713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  585724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  585727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  585730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  585733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  585762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585781 */     GIR_RootConstrainSelectedInstOperands,
     /*  585782 */     // GIR_Coverage, 10546,
     /*  585782 */     GIR_EraseRootFromParent_Done,
     /*  585783 */   // Label 9615: @585783
     /*  585783 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(585858), // Rule ID 10547 //
     /*  585788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  585799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  585802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  585805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  585808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585834 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  585837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585856 */     GIR_RootConstrainSelectedInstOperands,
     /*  585857 */     // GIR_Coverage, 10547,
     /*  585857 */     GIR_EraseRootFromParent_Done,
     /*  585858 */   // Label 9616: @585858
     /*  585858 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(585933), // Rule ID 10550 //
     /*  585863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  585874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  585877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  585880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  585883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585909 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  585912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585931 */     GIR_RootConstrainSelectedInstOperands,
     /*  585932 */     // GIR_Coverage, 10550,
     /*  585932 */     GIR_EraseRootFromParent_Done,
     /*  585933 */   // Label 9617: @585933
     /*  585933 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(586008), // Rule ID 10551 //
     /*  585938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  585946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  585949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  585952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  585955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  585958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  585987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586006 */     GIR_RootConstrainSelectedInstOperands,
     /*  586007 */     // GIR_Coverage, 10551,
     /*  586007 */     GIR_EraseRootFromParent_Done,
     /*  586008 */   // Label 9618: @586008
     /*  586008 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(586083), // Rule ID 10554 //
     /*  586013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  586024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  586027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586059 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586081 */     GIR_RootConstrainSelectedInstOperands,
     /*  586082 */     // GIR_Coverage, 10554,
     /*  586082 */     GIR_EraseRootFromParent_Done,
     /*  586083 */   // Label 9619: @586083
     /*  586083 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(586158), // Rule ID 10555 //
     /*  586088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  586099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  586102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586156 */     GIR_RootConstrainSelectedInstOperands,
     /*  586157 */     // GIR_Coverage, 10555,
     /*  586157 */     GIR_EraseRootFromParent_Done,
     /*  586158 */   // Label 9620: @586158
     /*  586158 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(586233), // Rule ID 10558 //
     /*  586163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  586212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586231 */     GIR_RootConstrainSelectedInstOperands,
     /*  586232 */     // GIR_Coverage, 10558,
     /*  586232 */     GIR_EraseRootFromParent_Done,
     /*  586233 */   // Label 9621: @586233
     /*  586233 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(586308), // Rule ID 10559 //
     /*  586238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  586287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586306 */     GIR_RootConstrainSelectedInstOperands,
     /*  586307 */     // GIR_Coverage, 10559,
     /*  586307 */     GIR_EraseRootFromParent_Done,
     /*  586308 */   // Label 9622: @586308
     /*  586308 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(586383), // Rule ID 10562 //
     /*  586313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586381 */     GIR_RootConstrainSelectedInstOperands,
     /*  586382 */     // GIR_Coverage, 10562,
     /*  586382 */     GIR_EraseRootFromParent_Done,
     /*  586383 */   // Label 9623: @586383
     /*  586383 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(586458), // Rule ID 10563 //
     /*  586388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586456 */     GIR_RootConstrainSelectedInstOperands,
     /*  586457 */     // GIR_Coverage, 10563,
     /*  586457 */     GIR_EraseRootFromParent_Done,
     /*  586458 */   // Label 9624: @586458
     /*  586458 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(586533), // Rule ID 10566 //
     /*  586463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  586474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  586477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  586480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586531 */     GIR_RootConstrainSelectedInstOperands,
     /*  586532 */     // GIR_Coverage, 10566,
     /*  586532 */     GIR_EraseRootFromParent_Done,
     /*  586533 */   // Label 9625: @586533
     /*  586533 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(586608), // Rule ID 10567 //
     /*  586538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  586549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  586552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  586555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  586587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586606 */     GIR_RootConstrainSelectedInstOperands,
     /*  586607 */     // GIR_Coverage, 10567,
     /*  586607 */     GIR_EraseRootFromParent_Done,
     /*  586608 */   // Label 9626: @586608
     /*  586608 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(586683), // Rule ID 10570 //
     /*  586613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  586624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  586627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  586662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586681 */     GIR_RootConstrainSelectedInstOperands,
     /*  586682 */     // GIR_Coverage, 10570,
     /*  586682 */     GIR_EraseRootFromParent_Done,
     /*  586683 */   // Label 9627: @586683
     /*  586683 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(586758), // Rule ID 10571 //
     /*  586688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  586699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  586702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  586737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586756 */     GIR_RootConstrainSelectedInstOperands,
     /*  586757 */     // GIR_Coverage, 10571,
     /*  586757 */     GIR_EraseRootFromParent_Done,
     /*  586758 */   // Label 9628: @586758
     /*  586758 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(586833), // Rule ID 10574 //
     /*  586763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  586780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  586812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586831 */     GIR_RootConstrainSelectedInstOperands,
     /*  586832 */     // GIR_Coverage, 10574,
     /*  586832 */     GIR_EraseRootFromParent_Done,
     /*  586833 */   // Label 9629: @586833
     /*  586833 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(586908), // Rule ID 10575 //
     /*  586838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  586855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  586887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586906 */     GIR_RootConstrainSelectedInstOperands,
     /*  586907 */     // GIR_Coverage, 10575,
     /*  586907 */     GIR_EraseRootFromParent_Done,
     /*  586908 */   // Label 9630: @586908
     /*  586908 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(586983), // Rule ID 10578 //
     /*  586913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  586927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  586930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  586962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586981 */     GIR_RootConstrainSelectedInstOperands,
     /*  586982 */     // GIR_Coverage, 10578,
     /*  586982 */     GIR_EraseRootFromParent_Done,
     /*  586983 */   // Label 9631: @586983
     /*  586983 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(587058), // Rule ID 10579 //
     /*  586988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  586996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  587037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587056 */     GIR_RootConstrainSelectedInstOperands,
     /*  587057 */     // GIR_Coverage, 10579,
     /*  587057 */     GIR_EraseRootFromParent_Done,
     /*  587058 */   // Label 9632: @587058
     /*  587058 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(587133), // Rule ID 10582 //
     /*  587063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  587066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  587080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  587109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  587112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  587128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587131 */     GIR_RootConstrainSelectedInstOperands,
     /*  587132 */     // GIR_Coverage, 10582,
     /*  587132 */     GIR_EraseRootFromParent_Done,
     /*  587133 */   // Label 9633: @587133
     /*  587133 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(587208), // Rule ID 10583 //
     /*  587138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  587141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  587155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  587184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  587187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  587203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587206 */     GIR_RootConstrainSelectedInstOperands,
     /*  587207 */     // GIR_Coverage, 10583,
     /*  587207 */     GIR_EraseRootFromParent_Done,
     /*  587208 */   // Label 9634: @587208
     /*  587208 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(587283), // Rule ID 10586 //
     /*  587213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  587224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  587227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  587230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  587262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587281 */     GIR_RootConstrainSelectedInstOperands,
     /*  587282 */     // GIR_Coverage, 10586,
     /*  587282 */     GIR_EraseRootFromParent_Done,
     /*  587283 */   // Label 9635: @587283
     /*  587283 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(587358), // Rule ID 10587 //
     /*  587288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  587299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  587302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  587305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  587337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587356 */     GIR_RootConstrainSelectedInstOperands,
     /*  587357 */     // GIR_Coverage, 10587,
     /*  587357 */     GIR_EraseRootFromParent_Done,
     /*  587358 */   // Label 9636: @587358
     /*  587358 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(587433), // Rule ID 10590 //
     /*  587363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  587374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  587377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  587380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587409 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  587412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587431 */     GIR_RootConstrainSelectedInstOperands,
     /*  587432 */     // GIR_Coverage, 10590,
     /*  587432 */     GIR_EraseRootFromParent_Done,
     /*  587433 */   // Label 9637: @587433
     /*  587433 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(587508), // Rule ID 10591 //
     /*  587438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  587449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  587452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  587455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  587487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587506 */     GIR_RootConstrainSelectedInstOperands,
     /*  587507 */     // GIR_Coverage, 10591,
     /*  587507 */     GIR_EraseRootFromParent_Done,
     /*  587508 */   // Label 9638: @587508
     /*  587508 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(587583), // Rule ID 10594 //
     /*  587513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  587524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  587527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  587530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  587562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587581 */     GIR_RootConstrainSelectedInstOperands,
     /*  587582 */     // GIR_Coverage, 10594,
     /*  587582 */     GIR_EraseRootFromParent_Done,
     /*  587583 */   // Label 9639: @587583
     /*  587583 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(587658), // Rule ID 10595 //
     /*  587588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  587599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  587602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  587605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  587637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587656 */     GIR_RootConstrainSelectedInstOperands,
     /*  587657 */     // GIR_Coverage, 10595,
     /*  587657 */     GIR_EraseRootFromParent_Done,
     /*  587658 */   // Label 9640: @587658
     /*  587658 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(587733), // Rule ID 10598 //
     /*  587663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  587712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587731 */     GIR_RootConstrainSelectedInstOperands,
     /*  587732 */     // GIR_Coverage, 10598,
     /*  587732 */     GIR_EraseRootFromParent_Done,
     /*  587733 */   // Label 9641: @587733
     /*  587733 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(587808), // Rule ID 10599 //
     /*  587738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  587787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587806 */     GIR_RootConstrainSelectedInstOperands,
     /*  587807 */     // GIR_Coverage, 10599,
     /*  587807 */     GIR_EraseRootFromParent_Done,
     /*  587808 */   // Label 9642: @587808
     /*  587808 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(587883), // Rule ID 10602 //
     /*  587813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587859 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  587862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587881 */     GIR_RootConstrainSelectedInstOperands,
     /*  587882 */     // GIR_Coverage, 10602,
     /*  587882 */     GIR_EraseRootFromParent_Done,
     /*  587883 */   // Label 9643: @587883
     /*  587883 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(587958), // Rule ID 10603 //
     /*  587888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  587937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587956 */     GIR_RootConstrainSelectedInstOperands,
     /*  587957 */     // GIR_Coverage, 10603,
     /*  587957 */     GIR_EraseRootFromParent_Done,
     /*  587958 */   // Label 9644: @587958
     /*  587958 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(588033), // Rule ID 10606 //
     /*  587963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  587971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588009 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588031 */     GIR_RootConstrainSelectedInstOperands,
     /*  588032 */     // GIR_Coverage, 10606,
     /*  588032 */     GIR_EraseRootFromParent_Done,
     /*  588033 */   // Label 9645: @588033
     /*  588033 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(588108), // Rule ID 10607 //
     /*  588038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  588049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  588052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  588055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588106 */     GIR_RootConstrainSelectedInstOperands,
     /*  588107 */     // GIR_Coverage, 10607,
     /*  588107 */     GIR_EraseRootFromParent_Done,
     /*  588108 */   // Label 9646: @588108
     /*  588108 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(588183), // Rule ID 10610 //
     /*  588113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  588162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588181 */     GIR_RootConstrainSelectedInstOperands,
     /*  588182 */     // GIR_Coverage, 10610,
     /*  588182 */     GIR_EraseRootFromParent_Done,
     /*  588183 */   // Label 9647: @588183
     /*  588183 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(588258), // Rule ID 10611 //
     /*  588188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  588237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588256 */     GIR_RootConstrainSelectedInstOperands,
     /*  588257 */     // GIR_Coverage, 10611,
     /*  588257 */     GIR_EraseRootFromParent_Done,
     /*  588258 */   // Label 9648: @588258
     /*  588258 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(588333), // Rule ID 10614 //
     /*  588263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  588312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588331 */     GIR_RootConstrainSelectedInstOperands,
     /*  588332 */     // GIR_Coverage, 10614,
     /*  588332 */     GIR_EraseRootFromParent_Done,
     /*  588333 */   // Label 9649: @588333
     /*  588333 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(588408), // Rule ID 10615 //
     /*  588338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  588387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588406 */     GIR_RootConstrainSelectedInstOperands,
     /*  588407 */     // GIR_Coverage, 10615,
     /*  588407 */     GIR_EraseRootFromParent_Done,
     /*  588408 */   // Label 9650: @588408
     /*  588408 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(588483), // Rule ID 10618 //
     /*  588413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588481 */     GIR_RootConstrainSelectedInstOperands,
     /*  588482 */     // GIR_Coverage, 10618,
     /*  588482 */     GIR_EraseRootFromParent_Done,
     /*  588483 */   // Label 9651: @588483
     /*  588483 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(588558), // Rule ID 10619 //
     /*  588488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588556 */     GIR_RootConstrainSelectedInstOperands,
     /*  588557 */     // GIR_Coverage, 10619,
     /*  588557 */     GIR_EraseRootFromParent_Done,
     /*  588558 */   // Label 9652: @588558
     /*  588558 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(588633), // Rule ID 10622 //
     /*  588563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  588566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  588609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  588612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  588628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588631 */     GIR_RootConstrainSelectedInstOperands,
     /*  588632 */     // GIR_Coverage, 10622,
     /*  588632 */     GIR_EraseRootFromParent_Done,
     /*  588633 */   // Label 9653: @588633
     /*  588633 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(588708), // Rule ID 10623 //
     /*  588638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  588641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  588684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  588687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  588703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588706 */     GIR_RootConstrainSelectedInstOperands,
     /*  588707 */     // GIR_Coverage, 10623,
     /*  588707 */     GIR_EraseRootFromParent_Done,
     /*  588708 */   // Label 9654: @588708
     /*  588708 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(588783), // Rule ID 10626 //
     /*  588713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  588716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  588759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  588762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  588778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588781 */     GIR_RootConstrainSelectedInstOperands,
     /*  588782 */     // GIR_Coverage, 10626,
     /*  588782 */     GIR_EraseRootFromParent_Done,
     /*  588783 */   // Label 9655: @588783
     /*  588783 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(588858), // Rule ID 10627 //
     /*  588788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  588791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  588834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  588837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  588853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588856 */     GIR_RootConstrainSelectedInstOperands,
     /*  588857 */     // GIR_Coverage, 10627,
     /*  588857 */     GIR_EraseRootFromParent_Done,
     /*  588858 */   // Label 9656: @588858
     /*  588858 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(588933), // Rule ID 10630 //
     /*  588863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  588866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  588909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  588928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588931 */     GIR_RootConstrainSelectedInstOperands,
     /*  588932 */     // GIR_Coverage, 10630,
     /*  588932 */     GIR_EraseRootFromParent_Done,
     /*  588933 */   // Label 9657: @588933
     /*  588933 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(589008), // Rule ID 10631 //
     /*  588938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  588941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  588946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  588984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  588987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  589003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589006 */     GIR_RootConstrainSelectedInstOperands,
     /*  589007 */     // GIR_Coverage, 10631,
     /*  589007 */     GIR_EraseRootFromParent_Done,
     /*  589008 */   // Label 9658: @589008
     /*  589008 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(589083), // Rule ID 10634 //
     /*  589013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  589024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  589027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  589030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  589062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589081 */     GIR_RootConstrainSelectedInstOperands,
     /*  589082 */     // GIR_Coverage, 10634,
     /*  589082 */     GIR_EraseRootFromParent_Done,
     /*  589083 */   // Label 9659: @589083
     /*  589083 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(589158), // Rule ID 10635 //
     /*  589088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  589099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  589102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  589105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  589137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589156 */     GIR_RootConstrainSelectedInstOperands,
     /*  589157 */     // GIR_Coverage, 10635,
     /*  589157 */     GIR_EraseRootFromParent_Done,
     /*  589158 */   // Label 9660: @589158
     /*  589158 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(589233), // Rule ID 10638 //
     /*  589163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  589174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  589177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  589180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  589212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589231 */     GIR_RootConstrainSelectedInstOperands,
     /*  589232 */     // GIR_Coverage, 10638,
     /*  589232 */     GIR_EraseRootFromParent_Done,
     /*  589233 */   // Label 9661: @589233
     /*  589233 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(589308), // Rule ID 10639 //
     /*  589238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  589249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  589252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  589255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  589287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589306 */     GIR_RootConstrainSelectedInstOperands,
     /*  589307 */     // GIR_Coverage, 10639,
     /*  589307 */     GIR_EraseRootFromParent_Done,
     /*  589308 */   // Label 9662: @589308
     /*  589308 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(589383), // Rule ID 10642 //
     /*  589313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  589324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  589327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  589330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589359 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589381 */     GIR_RootConstrainSelectedInstOperands,
     /*  589382 */     // GIR_Coverage, 10642,
     /*  589382 */     GIR_EraseRootFromParent_Done,
     /*  589383 */   // Label 9663: @589383
     /*  589383 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(589458), // Rule ID 10643 //
     /*  589388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  589399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  589402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  589405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589456 */     GIR_RootConstrainSelectedInstOperands,
     /*  589457 */     // GIR_Coverage, 10643,
     /*  589457 */     GIR_EraseRootFromParent_Done,
     /*  589458 */   // Label 9664: @589458
     /*  589458 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(589533), // Rule ID 10646 //
     /*  589463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  589512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589531 */     GIR_RootConstrainSelectedInstOperands,
     /*  589532 */     // GIR_Coverage, 10646,
     /*  589532 */     GIR_EraseRootFromParent_Done,
     /*  589533 */   // Label 9665: @589533
     /*  589533 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(589608), // Rule ID 10647 //
     /*  589538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  589587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589606 */     GIR_RootConstrainSelectedInstOperands,
     /*  589607 */     // GIR_Coverage, 10647,
     /*  589607 */     GIR_EraseRootFromParent_Done,
     /*  589608 */   // Label 9666: @589608
     /*  589608 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(589683), // Rule ID 10650 //
     /*  589613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589681 */     GIR_RootConstrainSelectedInstOperands,
     /*  589682 */     // GIR_Coverage, 10650,
     /*  589682 */     GIR_EraseRootFromParent_Done,
     /*  589683 */   // Label 9667: @589683
     /*  589683 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(589758), // Rule ID 10651 //
     /*  589688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589756 */     GIR_RootConstrainSelectedInstOperands,
     /*  589757 */     // GIR_Coverage, 10651,
     /*  589757 */     GIR_EraseRootFromParent_Done,
     /*  589758 */   // Label 9668: @589758
     /*  589758 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(589833), // Rule ID 10654 //
     /*  589763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  589783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589831 */     GIR_RootConstrainSelectedInstOperands,
     /*  589832 */     // GIR_Coverage, 10654,
     /*  589832 */     GIR_EraseRootFromParent_Done,
     /*  589833 */   // Label 9669: @589833
     /*  589833 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(589908), // Rule ID 10655 //
     /*  589838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  589858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  589887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589906 */     GIR_RootConstrainSelectedInstOperands,
     /*  589907 */     // GIR_Coverage, 10655,
     /*  589907 */     GIR_EraseRootFromParent_Done,
     /*  589908 */   // Label 9670: @589908
     /*  589908 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(589983), // Rule ID 10658 //
     /*  589913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  589924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  589927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  589930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  589962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589981 */     GIR_RootConstrainSelectedInstOperands,
     /*  589982 */     // GIR_Coverage, 10658,
     /*  589982 */     GIR_EraseRootFromParent_Done,
     /*  589983 */   // Label 9671: @589983
     /*  589983 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(590058), // Rule ID 10659 //
     /*  589988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  589996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  589999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  590002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  590005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  590008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590056 */     GIR_RootConstrainSelectedInstOperands,
     /*  590057 */     // GIR_Coverage, 10659,
     /*  590057 */     GIR_EraseRootFromParent_Done,
     /*  590058 */   // Label 9672: @590058
     /*  590058 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(590133), // Rule ID 10662 //
     /*  590063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590131 */     GIR_RootConstrainSelectedInstOperands,
     /*  590132 */     // GIR_Coverage, 10662,
     /*  590132 */     GIR_EraseRootFromParent_Done,
     /*  590133 */   // Label 9673: @590133
     /*  590133 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(590208), // Rule ID 10663 //
     /*  590138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590206 */     GIR_RootConstrainSelectedInstOperands,
     /*  590207 */     // GIR_Coverage, 10663,
     /*  590207 */     GIR_EraseRootFromParent_Done,
     /*  590208 */   // Label 9674: @590208
     /*  590208 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(590283), // Rule ID 10666 //
     /*  590213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590281 */     GIR_RootConstrainSelectedInstOperands,
     /*  590282 */     // GIR_Coverage, 10666,
     /*  590282 */     GIR_EraseRootFromParent_Done,
     /*  590283 */   // Label 9675: @590283
     /*  590283 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(590358), // Rule ID 10667 //
     /*  590288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590356 */     GIR_RootConstrainSelectedInstOperands,
     /*  590357 */     // GIR_Coverage, 10667,
     /*  590357 */     GIR_EraseRootFromParent_Done,
     /*  590358 */   // Label 9676: @590358
     /*  590358 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(590433), // Rule ID 10670 //
     /*  590363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  590366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  590383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590409 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  590409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  590428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590431 */     GIR_RootConstrainSelectedInstOperands,
     /*  590432 */     // GIR_Coverage, 10670,
     /*  590432 */     GIR_EraseRootFromParent_Done,
     /*  590433 */   // Label 9677: @590433
     /*  590433 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(590508), // Rule ID 10671 //
     /*  590438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  590441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  590458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  590484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  590487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  590503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590506 */     GIR_RootConstrainSelectedInstOperands,
     /*  590507 */     // GIR_Coverage, 10671,
     /*  590507 */     GIR_EraseRootFromParent_Done,
     /*  590508 */   // Label 9678: @590508
     /*  590508 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(590583), // Rule ID 10674 //
     /*  590513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  590524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  590527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  590530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  590562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590581 */     GIR_RootConstrainSelectedInstOperands,
     /*  590582 */     // GIR_Coverage, 10674,
     /*  590582 */     GIR_EraseRootFromParent_Done,
     /*  590583 */   // Label 9679: @590583
     /*  590583 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(590658), // Rule ID 10675 //
     /*  590588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  590599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  590602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  590605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  590637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590656 */     GIR_RootConstrainSelectedInstOperands,
     /*  590657 */     // GIR_Coverage, 10675,
     /*  590657 */     GIR_EraseRootFromParent_Done,
     /*  590658 */   // Label 9680: @590658
     /*  590658 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(590733), // Rule ID 10678 //
     /*  590663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  590674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  590677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  590680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590709 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  590712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590731 */     GIR_RootConstrainSelectedInstOperands,
     /*  590732 */     // GIR_Coverage, 10678,
     /*  590732 */     GIR_EraseRootFromParent_Done,
     /*  590733 */   // Label 9681: @590733
     /*  590733 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(590808), // Rule ID 10679 //
     /*  590738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  590749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  590752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  590755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  590787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590806 */     GIR_RootConstrainSelectedInstOperands,
     /*  590807 */     // GIR_Coverage, 10679,
     /*  590807 */     GIR_EraseRootFromParent_Done,
     /*  590808 */   // Label 9682: @590808
     /*  590808 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(590883), // Rule ID 10682 //
     /*  590813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  590824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  590827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  590830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  590833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590859 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  590862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590881 */     GIR_RootConstrainSelectedInstOperands,
     /*  590882 */     // GIR_Coverage, 10682,
     /*  590882 */     GIR_EraseRootFromParent_Done,
     /*  590883 */   // Label 9683: @590883
     /*  590883 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(590958), // Rule ID 10683 //
     /*  590888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  590899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  590902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  590905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  590908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  590937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590956 */     GIR_RootConstrainSelectedInstOperands,
     /*  590957 */     // GIR_Coverage, 10683,
     /*  590957 */     GIR_EraseRootFromParent_Done,
     /*  590958 */   // Label 9684: @590958
     /*  590958 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(591033), // Rule ID 10686 //
     /*  590963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  590971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  590974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  590977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  590980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591031 */     GIR_RootConstrainSelectedInstOperands,
     /*  591032 */     // GIR_Coverage, 10686,
     /*  591032 */     GIR_EraseRootFromParent_Done,
     /*  591033 */   // Label 9685: @591033
     /*  591033 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(591108), // Rule ID 10687 //
     /*  591038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  591058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591106 */     GIR_RootConstrainSelectedInstOperands,
     /*  591107 */     // GIR_Coverage, 10687,
     /*  591107 */     GIR_EraseRootFromParent_Done,
     /*  591108 */   // Label 9686: @591108
     /*  591108 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(591183), // Rule ID 10690 //
     /*  591113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  591133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  591162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591181 */     GIR_RootConstrainSelectedInstOperands,
     /*  591182 */     // GIR_Coverage, 10690,
     /*  591182 */     GIR_EraseRootFromParent_Done,
     /*  591183 */   // Label 9687: @591183
     /*  591183 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(591258), // Rule ID 10691 //
     /*  591188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  591208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  591237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591256 */     GIR_RootConstrainSelectedInstOperands,
     /*  591257 */     // GIR_Coverage, 10691,
     /*  591257 */     GIR_EraseRootFromParent_Done,
     /*  591258 */   // Label 9688: @591258
     /*  591258 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(591333), // Rule ID 10694 //
     /*  591263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  591283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  591312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591331 */     GIR_RootConstrainSelectedInstOperands,
     /*  591332 */     // GIR_Coverage, 10694,
     /*  591332 */     GIR_EraseRootFromParent_Done,
     /*  591333 */   // Label 9689: @591333
     /*  591333 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(591408), // Rule ID 10695 //
     /*  591338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  591358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  591387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591406 */     GIR_RootConstrainSelectedInstOperands,
     /*  591407 */     // GIR_Coverage, 10695,
     /*  591407 */     GIR_EraseRootFromParent_Done,
     /*  591408 */   // Label 9690: @591408
     /*  591408 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(591483), // Rule ID 10698 //
     /*  591413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591481 */     GIR_RootConstrainSelectedInstOperands,
     /*  591482 */     // GIR_Coverage, 10698,
     /*  591482 */     GIR_EraseRootFromParent_Done,
     /*  591483 */   // Label 9691: @591483
     /*  591483 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(591558), // Rule ID 10699 //
     /*  591488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591556 */     GIR_RootConstrainSelectedInstOperands,
     /*  591557 */     // GIR_Coverage, 10699,
     /*  591557 */     GIR_EraseRootFromParent_Done,
     /*  591558 */   // Label 9692: @591558
     /*  591558 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(591633), // Rule ID 10702 //
     /*  591563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  591574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  591577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  591580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  591612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591631 */     GIR_RootConstrainSelectedInstOperands,
     /*  591632 */     // GIR_Coverage, 10702,
     /*  591632 */     GIR_EraseRootFromParent_Done,
     /*  591633 */   // Label 9693: @591633
     /*  591633 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(591708), // Rule ID 10703 //
     /*  591638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  591649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  591652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  591655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  591687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591706 */     GIR_RootConstrainSelectedInstOperands,
     /*  591707 */     // GIR_Coverage, 10703,
     /*  591707 */     GIR_EraseRootFromParent_Done,
     /*  591708 */   // Label 9694: @591708
     /*  591708 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(591783), // Rule ID 10706 //
     /*  591713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  591724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  591727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  591730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  591733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591759 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  591762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591781 */     GIR_RootConstrainSelectedInstOperands,
     /*  591782 */     // GIR_Coverage, 10706,
     /*  591782 */     GIR_EraseRootFromParent_Done,
     /*  591783 */   // Label 9695: @591783
     /*  591783 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(591858), // Rule ID 10707 //
     /*  591788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  591799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  591802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  591805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  591808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  591837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591856 */     GIR_RootConstrainSelectedInstOperands,
     /*  591857 */     // GIR_Coverage, 10707,
     /*  591857 */     GIR_EraseRootFromParent_Done,
     /*  591858 */   // Label 9696: @591858
     /*  591858 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(591933), // Rule ID 10710 //
     /*  591863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  591866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  591883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  591909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  591928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591931 */     GIR_RootConstrainSelectedInstOperands,
     /*  591932 */     // GIR_Coverage, 10710,
     /*  591932 */     GIR_EraseRootFromParent_Done,
     /*  591933 */   // Label 9697: @591933
     /*  591933 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(592008), // Rule ID 10711 //
     /*  591938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  591941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  591946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  591958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  591984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  591987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  592003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592006 */     GIR_RootConstrainSelectedInstOperands,
     /*  592007 */     // GIR_Coverage, 10711,
     /*  592007 */     GIR_EraseRootFromParent_Done,
     /*  592008 */   // Label 9698: @592008
     /*  592008 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(592083), // Rule ID 10714 //
     /*  592013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  592016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  592033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  592059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  592062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  592078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592081 */     GIR_RootConstrainSelectedInstOperands,
     /*  592082 */     // GIR_Coverage, 10714,
     /*  592082 */     GIR_EraseRootFromParent_Done,
     /*  592083 */   // Label 9699: @592083
     /*  592083 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(592158), // Rule ID 10715 //
     /*  592088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  592091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  592108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  592134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  592137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  592153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592156 */     GIR_RootConstrainSelectedInstOperands,
     /*  592157 */     // GIR_Coverage, 10715,
     /*  592157 */     GIR_EraseRootFromParent_Done,
     /*  592158 */   // Label 9700: @592158
     /*  592158 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(592233), // Rule ID 10718 //
     /*  592163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  592166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  592183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  592209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  592212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  592228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592231 */     GIR_RootConstrainSelectedInstOperands,
     /*  592232 */     // GIR_Coverage, 10718,
     /*  592232 */     GIR_EraseRootFromParent_Done,
     /*  592233 */   // Label 9701: @592233
     /*  592233 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(592308), // Rule ID 10719 //
     /*  592238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  592241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  592258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  592284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  592287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  592303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592306 */     GIR_RootConstrainSelectedInstOperands,
     /*  592307 */     // GIR_Coverage, 10719,
     /*  592307 */     GIR_EraseRootFromParent_Done,
     /*  592308 */   // Label 9702: @592308
     /*  592308 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(592383), // Rule ID 10722 //
     /*  592313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  592324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  592327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  592330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  592362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592381 */     GIR_RootConstrainSelectedInstOperands,
     /*  592382 */     // GIR_Coverage, 10722,
     /*  592382 */     GIR_EraseRootFromParent_Done,
     /*  592383 */   // Label 9703: @592383
     /*  592383 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(592458), // Rule ID 10723 //
     /*  592388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  592399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  592402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  592405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  592437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592456 */     GIR_RootConstrainSelectedInstOperands,
     /*  592457 */     // GIR_Coverage, 10723,
     /*  592457 */     GIR_EraseRootFromParent_Done,
     /*  592458 */   // Label 9704: @592458
     /*  592458 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(592533), // Rule ID 10726 //
     /*  592463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  592474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  592477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  592480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592509 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  592512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592531 */     GIR_RootConstrainSelectedInstOperands,
     /*  592532 */     // GIR_Coverage, 10726,
     /*  592532 */     GIR_EraseRootFromParent_Done,
     /*  592533 */   // Label 9705: @592533
     /*  592533 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(592608), // Rule ID 10727 //
     /*  592538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  592549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  592552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  592555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592584 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  592587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592606 */     GIR_RootConstrainSelectedInstOperands,
     /*  592607 */     // GIR_Coverage, 10727,
     /*  592607 */     GIR_EraseRootFromParent_Done,
     /*  592608 */   // Label 9706: @592608
     /*  592608 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(592683), // Rule ID 10730 //
     /*  592613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  592624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  592627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  592630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592659 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  592662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592681 */     GIR_RootConstrainSelectedInstOperands,
     /*  592682 */     // GIR_Coverage, 10730,
     /*  592682 */     GIR_EraseRootFromParent_Done,
     /*  592683 */   // Label 9707: @592683
     /*  592683 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(592758), // Rule ID 10731 //
     /*  592688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  592699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  592702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  592705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  592737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592756 */     GIR_RootConstrainSelectedInstOperands,
     /*  592757 */     // GIR_Coverage, 10731,
     /*  592757 */     GIR_EraseRootFromParent_Done,
     /*  592758 */   // Label 9708: @592758
     /*  592758 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(592833), // Rule ID 10734 //
     /*  592763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  592812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592831 */     GIR_RootConstrainSelectedInstOperands,
     /*  592832 */     // GIR_Coverage, 10734,
     /*  592832 */     GIR_EraseRootFromParent_Done,
     /*  592833 */   // Label 9709: @592833
     /*  592833 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(592908), // Rule ID 10735 //
     /*  592838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  592887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592906 */     GIR_RootConstrainSelectedInstOperands,
     /*  592907 */     // GIR_Coverage, 10735,
     /*  592907 */     GIR_EraseRootFromParent_Done,
     /*  592908 */   // Label 9710: @592908
     /*  592908 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(592983), // Rule ID 10738 //
     /*  592913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  592924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  592927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  592930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  592962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592981 */     GIR_RootConstrainSelectedInstOperands,
     /*  592982 */     // GIR_Coverage, 10738,
     /*  592982 */     GIR_EraseRootFromParent_Done,
     /*  592983 */   // Label 9711: @592983
     /*  592983 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(593058), // Rule ID 10739 //
     /*  592988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  592996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  592999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  593037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593056 */     GIR_RootConstrainSelectedInstOperands,
     /*  593057 */     // GIR_Coverage, 10739,
     /*  593057 */     GIR_EraseRootFromParent_Done,
     /*  593058 */   // Label 9712: @593058
     /*  593058 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(593133), // Rule ID 10742 //
     /*  593063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  593112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593131 */     GIR_RootConstrainSelectedInstOperands,
     /*  593132 */     // GIR_Coverage, 10742,
     /*  593132 */     GIR_EraseRootFromParent_Done,
     /*  593133 */   // Label 9713: @593133
     /*  593133 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(593208), // Rule ID 10743 //
     /*  593138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  593187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593206 */     GIR_RootConstrainSelectedInstOperands,
     /*  593207 */     // GIR_Coverage, 10743,
     /*  593207 */     GIR_EraseRootFromParent_Done,
     /*  593208 */   // Label 9714: @593208
     /*  593208 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(593283), // Rule ID 10746 //
     /*  593213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  593224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  593227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  593230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593281 */     GIR_RootConstrainSelectedInstOperands,
     /*  593282 */     // GIR_Coverage, 10746,
     /*  593282 */     GIR_EraseRootFromParent_Done,
     /*  593283 */   // Label 9715: @593283
     /*  593283 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(593358), // Rule ID 10747 //
     /*  593288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  593299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  593302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  593305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593356 */     GIR_RootConstrainSelectedInstOperands,
     /*  593357 */     // GIR_Coverage, 10747,
     /*  593357 */     GIR_EraseRootFromParent_Done,
     /*  593358 */   // Label 9716: @593358
     /*  593358 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(593433), // Rule ID 10750 //
     /*  593363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593431 */     GIR_RootConstrainSelectedInstOperands,
     /*  593432 */     // GIR_Coverage, 10750,
     /*  593432 */     GIR_EraseRootFromParent_Done,
     /*  593433 */   // Label 9717: @593433
     /*  593433 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(593508), // Rule ID 10751 //
     /*  593438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593506 */     GIR_RootConstrainSelectedInstOperands,
     /*  593507 */     // GIR_Coverage, 10751,
     /*  593507 */     GIR_EraseRootFromParent_Done,
     /*  593508 */   // Label 9718: @593508
     /*  593508 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(593583), // Rule ID 10754 //
     /*  593513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593581 */     GIR_RootConstrainSelectedInstOperands,
     /*  593582 */     // GIR_Coverage, 10754,
     /*  593582 */     GIR_EraseRootFromParent_Done,
     /*  593583 */   // Label 9719: @593583
     /*  593583 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(593658), // Rule ID 10755 //
     /*  593588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593656 */     GIR_RootConstrainSelectedInstOperands,
     /*  593657 */     // GIR_Coverage, 10755,
     /*  593657 */     GIR_EraseRootFromParent_Done,
     /*  593658 */   // Label 9720: @593658
     /*  593658 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(593733), // Rule ID 10758 //
     /*  593663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  593666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  593709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  593728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593731 */     GIR_RootConstrainSelectedInstOperands,
     /*  593732 */     // GIR_Coverage, 10758,
     /*  593732 */     GIR_EraseRootFromParent_Done,
     /*  593733 */   // Label 9721: @593733
     /*  593733 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(593808), // Rule ID 10759 //
     /*  593738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  593741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  593784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  593787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  593803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593806 */     GIR_RootConstrainSelectedInstOperands,
     /*  593807 */     // GIR_Coverage, 10759,
     /*  593807 */     GIR_EraseRootFromParent_Done,
     /*  593808 */   // Label 9722: @593808
     /*  593808 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(593883), // Rule ID 10762 //
     /*  593813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  593824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  593827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  593830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  593862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593881 */     GIR_RootConstrainSelectedInstOperands,
     /*  593882 */     // GIR_Coverage, 10762,
     /*  593882 */     GIR_EraseRootFromParent_Done,
     /*  593883 */   // Label 9723: @593883
     /*  593883 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(593958), // Rule ID 10763 //
     /*  593888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  593899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  593902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  593905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  593937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593956 */     GIR_RootConstrainSelectedInstOperands,
     /*  593957 */     // GIR_Coverage, 10763,
     /*  593957 */     GIR_EraseRootFromParent_Done,
     /*  593958 */   // Label 9724: @593958
     /*  593958 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(594033), // Rule ID 10766 //
     /*  593963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  593971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  593974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  593977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  593980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594009 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594031 */     GIR_RootConstrainSelectedInstOperands,
     /*  594032 */     // GIR_Coverage, 10766,
     /*  594032 */     GIR_EraseRootFromParent_Done,
     /*  594033 */   // Label 9725: @594033
     /*  594033 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(594108), // Rule ID 10767 //
     /*  594038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  594049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  594052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  594055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594106 */     GIR_RootConstrainSelectedInstOperands,
     /*  594107 */     // GIR_Coverage, 10767,
     /*  594107 */     GIR_EraseRootFromParent_Done,
     /*  594108 */   // Label 9726: @594108
     /*  594108 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(594183), // Rule ID 10770 //
     /*  594113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  594124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  594127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  594130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  594162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594181 */     GIR_RootConstrainSelectedInstOperands,
     /*  594182 */     // GIR_Coverage, 10770,
     /*  594182 */     GIR_EraseRootFromParent_Done,
     /*  594183 */   // Label 9727: @594183
     /*  594183 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(594258), // Rule ID 10771 //
     /*  594188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  594199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  594202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  594205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594234 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  594237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594256 */     GIR_RootConstrainSelectedInstOperands,
     /*  594257 */     // GIR_Coverage, 10771,
     /*  594257 */     GIR_EraseRootFromParent_Done,
     /*  594258 */   // Label 9728: @594258
     /*  594258 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(594333), // Rule ID 10774 //
     /*  594263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  594312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594331 */     GIR_RootConstrainSelectedInstOperands,
     /*  594332 */     // GIR_Coverage, 10774,
     /*  594332 */     GIR_EraseRootFromParent_Done,
     /*  594333 */   // Label 9729: @594333
     /*  594333 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(594408), // Rule ID 10775 //
     /*  594338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  594387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594406 */     GIR_RootConstrainSelectedInstOperands,
     /*  594407 */     // GIR_Coverage, 10775,
     /*  594407 */     GIR_EraseRootFromParent_Done,
     /*  594408 */   // Label 9730: @594408
     /*  594408 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(594483), // Rule ID 10778 //
     /*  594413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594481 */     GIR_RootConstrainSelectedInstOperands,
     /*  594482 */     // GIR_Coverage, 10778,
     /*  594482 */     GIR_EraseRootFromParent_Done,
     /*  594483 */   // Label 9731: @594483
     /*  594483 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(594558), // Rule ID 10779 //
     /*  594488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594556 */     GIR_RootConstrainSelectedInstOperands,
     /*  594557 */     // GIR_Coverage, 10779,
     /*  594557 */     GIR_EraseRootFromParent_Done,
     /*  594558 */   // Label 9732: @594558
     /*  594558 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(594633), // Rule ID 10782 //
     /*  594563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  594612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594631 */     GIR_RootConstrainSelectedInstOperands,
     /*  594632 */     // GIR_Coverage, 10782,
     /*  594632 */     GIR_EraseRootFromParent_Done,
     /*  594633 */   // Label 9733: @594633
     /*  594633 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(594708), // Rule ID 10783 //
     /*  594638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  594687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594706 */     GIR_RootConstrainSelectedInstOperands,
     /*  594707 */     // GIR_Coverage, 10783,
     /*  594707 */     GIR_EraseRootFromParent_Done,
     /*  594708 */   // Label 9734: @594708
     /*  594708 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(594783), // Rule ID 10786 //
     /*  594713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  594762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594781 */     GIR_RootConstrainSelectedInstOperands,
     /*  594782 */     // GIR_Coverage, 10786,
     /*  594782 */     GIR_EraseRootFromParent_Done,
     /*  594783 */   // Label 9735: @594783
     /*  594783 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(594858), // Rule ID 10787 //
     /*  594788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  594837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594856 */     GIR_RootConstrainSelectedInstOperands,
     /*  594857 */     // GIR_Coverage, 10787,
     /*  594857 */     GIR_EraseRootFromParent_Done,
     /*  594858 */   // Label 9736: @594858
     /*  594858 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(594933), // Rule ID 10790 //
     /*  594863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  594883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594909 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594931 */     GIR_RootConstrainSelectedInstOperands,
     /*  594932 */     // GIR_Coverage, 10790,
     /*  594932 */     GIR_EraseRootFromParent_Done,
     /*  594933 */   // Label 9737: @594933
     /*  594933 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(595008), // Rule ID 10791 //
     /*  594938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  594946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  594958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  594977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  594987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595006 */     GIR_RootConstrainSelectedInstOperands,
     /*  595007 */     // GIR_Coverage, 10791,
     /*  595007 */     GIR_EraseRootFromParent_Done,
     /*  595008 */   // Label 9738: @595008
     /*  595008 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(595083), // Rule ID 10794 //
     /*  595013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  595062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595081 */     GIR_RootConstrainSelectedInstOperands,
     /*  595082 */     // GIR_Coverage, 10794,
     /*  595082 */     GIR_EraseRootFromParent_Done,
     /*  595083 */   // Label 9739: @595083
     /*  595083 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(595158), // Rule ID 10795 //
     /*  595088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  595137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595156 */     GIR_RootConstrainSelectedInstOperands,
     /*  595157 */     // GIR_Coverage, 10795,
     /*  595157 */     GIR_EraseRootFromParent_Done,
     /*  595158 */   // Label 9740: @595158
     /*  595158 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(595233), // Rule ID 10798 //
     /*  595163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  595166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  595209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  595212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595231 */     GIR_RootConstrainSelectedInstOperands,
     /*  595232 */     // GIR_Coverage, 10798,
     /*  595232 */     GIR_EraseRootFromParent_Done,
     /*  595233 */   // Label 9741: @595233
     /*  595233 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(595308), // Rule ID 10799 //
     /*  595238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  595241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  595284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  595287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595306 */     GIR_RootConstrainSelectedInstOperands,
     /*  595307 */     // GIR_Coverage, 10799,
     /*  595307 */     GIR_EraseRootFromParent_Done,
     /*  595308 */   // Label 9742: @595308
     /*  595308 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(595383), // Rule ID 10802 //
     /*  595313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  595316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  595359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  595362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595381 */     GIR_RootConstrainSelectedInstOperands,
     /*  595382 */     // GIR_Coverage, 10802,
     /*  595382 */     GIR_EraseRootFromParent_Done,
     /*  595383 */   // Label 9743: @595383
     /*  595383 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(595458), // Rule ID 10803 //
     /*  595388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  595391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  595434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  595437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595456 */     GIR_RootConstrainSelectedInstOperands,
     /*  595457 */     // GIR_Coverage, 10803,
     /*  595457 */     GIR_EraseRootFromParent_Done,
     /*  595458 */   // Label 9744: @595458
     /*  595458 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(595533), // Rule ID 10806 //
     /*  595463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  595466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  595509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  595512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595531 */     GIR_RootConstrainSelectedInstOperands,
     /*  595532 */     // GIR_Coverage, 10806,
     /*  595532 */     GIR_EraseRootFromParent_Done,
     /*  595533 */   // Label 9745: @595533
     /*  595533 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(595608), // Rule ID 10807 //
     /*  595538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  595541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  595546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  595584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  595587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  595603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595606 */     GIR_RootConstrainSelectedInstOperands,
     /*  595607 */     // GIR_Coverage, 10807,
     /*  595607 */     GIR_EraseRootFromParent_Done,
     /*  595608 */   // Label 9746: @595608
     /*  595608 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(595683), // Rule ID 10810 //
     /*  595613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  595624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  595627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  595630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  595633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  595662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595681 */     GIR_RootConstrainSelectedInstOperands,
     /*  595682 */     // GIR_Coverage, 10810,
     /*  595682 */     GIR_EraseRootFromParent_Done,
     /*  595683 */   // Label 9747: @595683
     /*  595683 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(595758), // Rule ID 10811 //
     /*  595688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  595699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  595702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  595705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  595708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  595737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595756 */     GIR_RootConstrainSelectedInstOperands,
     /*  595757 */     // GIR_Coverage, 10811,
     /*  595757 */     GIR_EraseRootFromParent_Done,
     /*  595758 */   // Label 9748: @595758
     /*  595758 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(595833), // Rule ID 10814 //
     /*  595763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  595774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  595777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  595780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  595783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  595812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595831 */     GIR_RootConstrainSelectedInstOperands,
     /*  595832 */     // GIR_Coverage, 10814,
     /*  595832 */     GIR_EraseRootFromParent_Done,
     /*  595833 */   // Label 9749: @595833
     /*  595833 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(595908), // Rule ID 10815 //
     /*  595838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  595849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  595852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  595855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  595858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  595887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595906 */     GIR_RootConstrainSelectedInstOperands,
     /*  595907 */     // GIR_Coverage, 10815,
     /*  595907 */     GIR_EraseRootFromParent_Done,
     /*  595908 */   // Label 9750: @595908
     /*  595908 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(595983), // Rule ID 10818 //
     /*  595913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  595924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  595927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  595930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  595933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  595962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595981 */     GIR_RootConstrainSelectedInstOperands,
     /*  595982 */     // GIR_Coverage, 10818,
     /*  595982 */     GIR_EraseRootFromParent_Done,
     /*  595983 */   // Label 9751: @595983
     /*  595983 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(596058), // Rule ID 10819 //
     /*  595988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  595996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  595999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  596002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  596005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  596008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  596037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596056 */     GIR_RootConstrainSelectedInstOperands,
     /*  596057 */     // GIR_Coverage, 10819,
     /*  596057 */     GIR_EraseRootFromParent_Done,
     /*  596058 */   // Label 9752: @596058
     /*  596058 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(596133), // Rule ID 10822 //
     /*  596063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  596083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  596112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596131 */     GIR_RootConstrainSelectedInstOperands,
     /*  596132 */     // GIR_Coverage, 10822,
     /*  596132 */     GIR_EraseRootFromParent_Done,
     /*  596133 */   // Label 9753: @596133
     /*  596133 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(596208), // Rule ID 10823 //
     /*  596138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  596158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  596187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596206 */     GIR_RootConstrainSelectedInstOperands,
     /*  596207 */     // GIR_Coverage, 10823,
     /*  596207 */     GIR_EraseRootFromParent_Done,
     /*  596208 */   // Label 9754: @596208
     /*  596208 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(596283), // Rule ID 10826 //
     /*  596213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  596233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  596262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596281 */     GIR_RootConstrainSelectedInstOperands,
     /*  596282 */     // GIR_Coverage, 10826,
     /*  596282 */     GIR_EraseRootFromParent_Done,
     /*  596283 */   // Label 9755: @596283
     /*  596283 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(596358), // Rule ID 10827 //
     /*  596288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  596308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  596337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596356 */     GIR_RootConstrainSelectedInstOperands,
     /*  596357 */     // GIR_Coverage, 10827,
     /*  596357 */     GIR_EraseRootFromParent_Done,
     /*  596358 */   // Label 9756: @596358
     /*  596358 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(596433), // Rule ID 10830 //
     /*  596363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  596383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  596412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596431 */     GIR_RootConstrainSelectedInstOperands,
     /*  596432 */     // GIR_Coverage, 10830,
     /*  596432 */     GIR_EraseRootFromParent_Done,
     /*  596433 */   // Label 9757: @596433
     /*  596433 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(596508), // Rule ID 10831 //
     /*  596438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  596458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  596487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596506 */     GIR_RootConstrainSelectedInstOperands,
     /*  596507 */     // GIR_Coverage, 10831,
     /*  596507 */     GIR_EraseRootFromParent_Done,
     /*  596508 */   // Label 9758: @596508
     /*  596508 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(596583), // Rule ID 10834 //
     /*  596513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  596524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  596527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  596530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  596533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596559 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596581 */     GIR_RootConstrainSelectedInstOperands,
     /*  596582 */     // GIR_Coverage, 10834,
     /*  596582 */     GIR_EraseRootFromParent_Done,
     /*  596583 */   // Label 9759: @596583
     /*  596583 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(596658), // Rule ID 10835 //
     /*  596588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  596599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  596602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  596605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  596608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596656 */     GIR_RootConstrainSelectedInstOperands,
     /*  596657 */     // GIR_Coverage, 10835,
     /*  596657 */     GIR_EraseRootFromParent_Done,
     /*  596658 */   // Label 9760: @596658
     /*  596658 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(596733), // Rule ID 10838 //
     /*  596663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  596683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596731 */     GIR_RootConstrainSelectedInstOperands,
     /*  596732 */     // GIR_Coverage, 10838,
     /*  596732 */     GIR_EraseRootFromParent_Done,
     /*  596733 */   // Label 9761: @596733
     /*  596733 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(596808), // Rule ID 10839 //
     /*  596738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  596758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596806 */     GIR_RootConstrainSelectedInstOperands,
     /*  596807 */     // GIR_Coverage, 10839,
     /*  596807 */     GIR_EraseRootFromParent_Done,
     /*  596808 */   // Label 9762: @596808
     /*  596808 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(596883), // Rule ID 10842 //
     /*  596813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  596833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596881 */     GIR_RootConstrainSelectedInstOperands,
     /*  596882 */     // GIR_Coverage, 10842,
     /*  596882 */     GIR_EraseRootFromParent_Done,
     /*  596883 */   // Label 9763: @596883
     /*  596883 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(596958), // Rule ID 10843 //
     /*  596888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  596908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  596937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596956 */     GIR_RootConstrainSelectedInstOperands,
     /*  596957 */     // GIR_Coverage, 10843,
     /*  596957 */     GIR_EraseRootFromParent_Done,
     /*  596958 */   // Label 9764: @596958
     /*  596958 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(597033), // Rule ID 10846 //
     /*  596963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  596966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  596971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  596983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  597009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  597012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  597028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597031 */     GIR_RootConstrainSelectedInstOperands,
     /*  597032 */     // GIR_Coverage, 10846,
     /*  597032 */     GIR_EraseRootFromParent_Done,
     /*  597033 */   // Label 9765: @597033
     /*  597033 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(597108), // Rule ID 10847 //
     /*  597038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  597041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  597058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  597084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  597087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  597103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597106 */     GIR_RootConstrainSelectedInstOperands,
     /*  597107 */     // GIR_Coverage, 10847,
     /*  597107 */     GIR_EraseRootFromParent_Done,
     /*  597108 */   // Label 9766: @597108
     /*  597108 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(597183), // Rule ID 10850 //
     /*  597113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  597124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  597127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  597130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  597133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  597162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597181 */     GIR_RootConstrainSelectedInstOperands,
     /*  597182 */     // GIR_Coverage, 10850,
     /*  597182 */     GIR_EraseRootFromParent_Done,
     /*  597183 */   // Label 9767: @597183
     /*  597183 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(597258), // Rule ID 10851 //
     /*  597188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  597199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  597202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  597205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  597208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  597237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597256 */     GIR_RootConstrainSelectedInstOperands,
     /*  597257 */     // GIR_Coverage, 10851,
     /*  597257 */     GIR_EraseRootFromParent_Done,
     /*  597258 */   // Label 9768: @597258
     /*  597258 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(597333), // Rule ID 10854 //
     /*  597263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  597274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  597277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  597280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  597283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597309 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  597312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597331 */     GIR_RootConstrainSelectedInstOperands,
     /*  597332 */     // GIR_Coverage, 10854,
     /*  597332 */     GIR_EraseRootFromParent_Done,
     /*  597333 */   // Label 9769: @597333
     /*  597333 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(597408), // Rule ID 10855 //
     /*  597338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  597349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  597352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  597355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  597358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  597387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597406 */     GIR_RootConstrainSelectedInstOperands,
     /*  597407 */     // GIR_Coverage, 10855,
     /*  597407 */     GIR_EraseRootFromParent_Done,
     /*  597408 */   // Label 9770: @597408
     /*  597408 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(597483), // Rule ID 10858 //
     /*  597413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  597424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  597427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  597430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  597433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597459 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  597462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597481 */     GIR_RootConstrainSelectedInstOperands,
     /*  597482 */     // GIR_Coverage, 10858,
     /*  597482 */     GIR_EraseRootFromParent_Done,
     /*  597483 */   // Label 9771: @597483
     /*  597483 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(597558), // Rule ID 10859 //
     /*  597488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  597499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  597502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  597505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  597508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  597537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597556 */     GIR_RootConstrainSelectedInstOperands,
     /*  597557 */     // GIR_Coverage, 10859,
     /*  597557 */     GIR_EraseRootFromParent_Done,
     /*  597558 */   // Label 9772: @597558
     /*  597558 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(597633), // Rule ID 10862 //
     /*  597563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  597583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  597612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597631 */     GIR_RootConstrainSelectedInstOperands,
     /*  597632 */     // GIR_Coverage, 10862,
     /*  597632 */     GIR_EraseRootFromParent_Done,
     /*  597633 */   // Label 9773: @597633
     /*  597633 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(597708), // Rule ID 10863 //
     /*  597638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  597658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  597687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597706 */     GIR_RootConstrainSelectedInstOperands,
     /*  597707 */     // GIR_Coverage, 10863,
     /*  597707 */     GIR_EraseRootFromParent_Done,
     /*  597708 */   // Label 9774: @597708
     /*  597708 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(597783), // Rule ID 10866 //
     /*  597713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  597724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  597727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  597730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  597733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  597762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597781 */     GIR_RootConstrainSelectedInstOperands,
     /*  597782 */     // GIR_Coverage, 10866,
     /*  597782 */     GIR_EraseRootFromParent_Done,
     /*  597783 */   // Label 9775: @597783
     /*  597783 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(597858), // Rule ID 10867 //
     /*  597788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  597799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  597802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  597805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  597808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  597837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597856 */     GIR_RootConstrainSelectedInstOperands,
     /*  597857 */     // GIR_Coverage, 10867,
     /*  597857 */     GIR_EraseRootFromParent_Done,
     /*  597858 */   // Label 9776: @597858
     /*  597858 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(597933), // Rule ID 10870 //
     /*  597863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  597874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  597877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  597880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  597883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597909 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  597912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597931 */     GIR_RootConstrainSelectedInstOperands,
     /*  597932 */     // GIR_Coverage, 10870,
     /*  597932 */     GIR_EraseRootFromParent_Done,
     /*  597933 */   // Label 9777: @597933
     /*  597933 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(598008), // Rule ID 10871 //
     /*  597938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  597946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  597949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  597952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  597955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  597958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  597987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598006 */     GIR_RootConstrainSelectedInstOperands,
     /*  598007 */     // GIR_Coverage, 10871,
     /*  598007 */     GIR_EraseRootFromParent_Done,
     /*  598008 */   // Label 9778: @598008
     /*  598008 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(598083), // Rule ID 10874 //
     /*  598013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  598033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  598062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598081 */     GIR_RootConstrainSelectedInstOperands,
     /*  598082 */     // GIR_Coverage, 10874,
     /*  598082 */     GIR_EraseRootFromParent_Done,
     /*  598083 */   // Label 9779: @598083
     /*  598083 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(598158), // Rule ID 10875 //
     /*  598088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  598108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  598137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598156 */     GIR_RootConstrainSelectedInstOperands,
     /*  598157 */     // GIR_Coverage, 10875,
     /*  598157 */     GIR_EraseRootFromParent_Done,
     /*  598158 */   // Label 9780: @598158
     /*  598158 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(598233), // Rule ID 10878 //
     /*  598163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  598183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  598212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598231 */     GIR_RootConstrainSelectedInstOperands,
     /*  598232 */     // GIR_Coverage, 10878,
     /*  598232 */     GIR_EraseRootFromParent_Done,
     /*  598233 */   // Label 9781: @598233
     /*  598233 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(598308), // Rule ID 10879 //
     /*  598238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  598258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  598287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598306 */     GIR_RootConstrainSelectedInstOperands,
     /*  598307 */     // GIR_Coverage, 10879,
     /*  598307 */     GIR_EraseRootFromParent_Done,
     /*  598308 */   // Label 9782: @598308
     /*  598308 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(598383), // Rule ID 10882 //
     /*  598313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  598333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598359 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  598362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598381 */     GIR_RootConstrainSelectedInstOperands,
     /*  598382 */     // GIR_Coverage, 10882,
     /*  598382 */     GIR_EraseRootFromParent_Done,
     /*  598383 */   // Label 9783: @598383
     /*  598383 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(598458), // Rule ID 10883 //
     /*  598388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  598408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  598437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598456 */     GIR_RootConstrainSelectedInstOperands,
     /*  598457 */     // GIR_Coverage, 10883,
     /*  598457 */     GIR_EraseRootFromParent_Done,
     /*  598458 */   // Label 9784: @598458
     /*  598458 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(598533), // Rule ID 10886 //
     /*  598463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  598466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  598483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  598509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  598512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598531 */     GIR_RootConstrainSelectedInstOperands,
     /*  598532 */     // GIR_Coverage, 10886,
     /*  598532 */     GIR_EraseRootFromParent_Done,
     /*  598533 */   // Label 9785: @598533
     /*  598533 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(598608), // Rule ID 10887 //
     /*  598538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  598541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  598558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  598584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  598587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598606 */     GIR_RootConstrainSelectedInstOperands,
     /*  598607 */     // GIR_Coverage, 10887,
     /*  598607 */     GIR_EraseRootFromParent_Done,
     /*  598608 */   // Label 9786: @598608
     /*  598608 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(598683), // Rule ID 10890 //
     /*  598613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  598616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  598633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  598659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  598662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598681 */     GIR_RootConstrainSelectedInstOperands,
     /*  598682 */     // GIR_Coverage, 10890,
     /*  598682 */     GIR_EraseRootFromParent_Done,
     /*  598683 */   // Label 9787: @598683
     /*  598683 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(598758), // Rule ID 10891 //
     /*  598688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  598691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  598708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  598734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  598737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598756 */     GIR_RootConstrainSelectedInstOperands,
     /*  598757 */     // GIR_Coverage, 10891,
     /*  598757 */     GIR_EraseRootFromParent_Done,
     /*  598758 */   // Label 9788: @598758
     /*  598758 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(598833), // Rule ID 10894 //
     /*  598763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  598766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  598783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  598809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  598812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598831 */     GIR_RootConstrainSelectedInstOperands,
     /*  598832 */     // GIR_Coverage, 10894,
     /*  598832 */     GIR_EraseRootFromParent_Done,
     /*  598833 */   // Label 9789: @598833
     /*  598833 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(598908), // Rule ID 10895 //
     /*  598838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  598841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  598858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  598884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  598887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  598903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598906 */     GIR_RootConstrainSelectedInstOperands,
     /*  598907 */     // GIR_Coverage, 10895,
     /*  598907 */     GIR_EraseRootFromParent_Done,
     /*  598908 */   // Label 9790: @598908
     /*  598908 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(598983), // Rule ID 10898 //
     /*  598913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  598924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  598927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  598930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  598962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598981 */     GIR_RootConstrainSelectedInstOperands,
     /*  598982 */     // GIR_Coverage, 10898,
     /*  598982 */     GIR_EraseRootFromParent_Done,
     /*  598983 */   // Label 9791: @598983
     /*  598983 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(599058), // Rule ID 10899 //
     /*  598988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  598996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  598999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  599002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  599005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  599037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599056 */     GIR_RootConstrainSelectedInstOperands,
     /*  599057 */     // GIR_Coverage, 10899,
     /*  599057 */     GIR_EraseRootFromParent_Done,
     /*  599058 */   // Label 9792: @599058
     /*  599058 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(599133), // Rule ID 10902 //
     /*  599063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  599074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  599077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  599080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  599112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599131 */     GIR_RootConstrainSelectedInstOperands,
     /*  599132 */     // GIR_Coverage, 10902,
     /*  599132 */     GIR_EraseRootFromParent_Done,
     /*  599133 */   // Label 9793: @599133
     /*  599133 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(599208), // Rule ID 10903 //
     /*  599138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  599149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  599152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  599155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  599187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599206 */     GIR_RootConstrainSelectedInstOperands,
     /*  599207 */     // GIR_Coverage, 10903,
     /*  599207 */     GIR_EraseRootFromParent_Done,
     /*  599208 */   // Label 9794: @599208
     /*  599208 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(599283), // Rule ID 10906 //
     /*  599213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  599224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  599227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  599230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599281 */     GIR_RootConstrainSelectedInstOperands,
     /*  599282 */     // GIR_Coverage, 10906,
     /*  599282 */     GIR_EraseRootFromParent_Done,
     /*  599283 */   // Label 9795: @599283
     /*  599283 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(599358), // Rule ID 10907 //
     /*  599288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  599299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  599302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  599305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599356 */     GIR_RootConstrainSelectedInstOperands,
     /*  599357 */     // GIR_Coverage, 10907,
     /*  599357 */     GIR_EraseRootFromParent_Done,
     /*  599358 */   // Label 9796: @599358
     /*  599358 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(599433), // Rule ID 10910 //
     /*  599363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  599412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599431 */     GIR_RootConstrainSelectedInstOperands,
     /*  599432 */     // GIR_Coverage, 10910,
     /*  599432 */     GIR_EraseRootFromParent_Done,
     /*  599433 */   // Label 9797: @599433
     /*  599433 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(599508), // Rule ID 10911 //
     /*  599438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  599487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599506 */     GIR_RootConstrainSelectedInstOperands,
     /*  599507 */     // GIR_Coverage, 10911,
     /*  599507 */     GIR_EraseRootFromParent_Done,
     /*  599508 */   // Label 9798: @599508
     /*  599508 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(599583), // Rule ID 10914 //
     /*  599513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599581 */     GIR_RootConstrainSelectedInstOperands,
     /*  599582 */     // GIR_Coverage, 10914,
     /*  599582 */     GIR_EraseRootFromParent_Done,
     /*  599583 */   // Label 9799: @599583
     /*  599583 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(599658), // Rule ID 10915 //
     /*  599588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599656 */     GIR_RootConstrainSelectedInstOperands,
     /*  599657 */     // GIR_Coverage, 10915,
     /*  599657 */     GIR_EraseRootFromParent_Done,
     /*  599658 */   // Label 9800: @599658
     /*  599658 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(599733), // Rule ID 10918 //
     /*  599663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599731 */     GIR_RootConstrainSelectedInstOperands,
     /*  599732 */     // GIR_Coverage, 10918,
     /*  599732 */     GIR_EraseRootFromParent_Done,
     /*  599733 */   // Label 9801: @599733
     /*  599733 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(599808), // Rule ID 10919 //
     /*  599738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  599787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599806 */     GIR_RootConstrainSelectedInstOperands,
     /*  599807 */     // GIR_Coverage, 10919,
     /*  599807 */     GIR_EraseRootFromParent_Done,
     /*  599808 */   // Label 9802: @599808
     /*  599808 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(599883), // Rule ID 10922 //
     /*  599813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  599824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  599827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  599830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  599862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599881 */     GIR_RootConstrainSelectedInstOperands,
     /*  599882 */     // GIR_Coverage, 10922,
     /*  599882 */     GIR_EraseRootFromParent_Done,
     /*  599883 */   // Label 9803: @599883
     /*  599883 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(599958), // Rule ID 10923 //
     /*  599888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  599899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  599902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  599905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  599937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599956 */     GIR_RootConstrainSelectedInstOperands,
     /*  599957 */     // GIR_Coverage, 10923,
     /*  599957 */     GIR_EraseRootFromParent_Done,
     /*  599958 */   // Label 9804: @599958
     /*  599958 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(600033), // Rule ID 10926 //
     /*  599963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  599971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  599974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  599977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  599980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600031 */     GIR_RootConstrainSelectedInstOperands,
     /*  600032 */     // GIR_Coverage, 10926,
     /*  600032 */     GIR_EraseRootFromParent_Done,
     /*  600033 */   // Label 9805: @600033
     /*  600033 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(600108), // Rule ID 10927 //
     /*  600038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600106 */     GIR_RootConstrainSelectedInstOperands,
     /*  600107 */     // GIR_Coverage, 10927,
     /*  600107 */     GIR_EraseRootFromParent_Done,
     /*  600108 */   // Label 9806: @600108
     /*  600108 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(600183), // Rule ID 10930 //
     /*  600113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600159 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600181 */     GIR_RootConstrainSelectedInstOperands,
     /*  600182 */     // GIR_Coverage, 10930,
     /*  600182 */     GIR_EraseRootFromParent_Done,
     /*  600183 */   // Label 9807: @600183
     /*  600183 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(600258), // Rule ID 10931 //
     /*  600188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600256 */     GIR_RootConstrainSelectedInstOperands,
     /*  600257 */     // GIR_Coverage, 10931,
     /*  600257 */     GIR_EraseRootFromParent_Done,
     /*  600258 */   // Label 9808: @600258
     /*  600258 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(600333), // Rule ID 10934 //
     /*  600263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  600266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  600309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  600328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600331 */     GIR_RootConstrainSelectedInstOperands,
     /*  600332 */     // GIR_Coverage, 10934,
     /*  600332 */     GIR_EraseRootFromParent_Done,
     /*  600333 */   // Label 9809: @600333
     /*  600333 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(600408), // Rule ID 10935 //
     /*  600338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  600341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  600384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  600387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  600403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600406 */     GIR_RootConstrainSelectedInstOperands,
     /*  600407 */     // GIR_Coverage, 10935,
     /*  600407 */     GIR_EraseRootFromParent_Done,
     /*  600408 */   // Label 9810: @600408
     /*  600408 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(600483), // Rule ID 10938 //
     /*  600413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  600424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  600427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  600430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  600462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600481 */     GIR_RootConstrainSelectedInstOperands,
     /*  600482 */     // GIR_Coverage, 10938,
     /*  600482 */     GIR_EraseRootFromParent_Done,
     /*  600483 */   // Label 9811: @600483
     /*  600483 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(600558), // Rule ID 10939 //
     /*  600488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  600499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  600502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  600505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  600537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600556 */     GIR_RootConstrainSelectedInstOperands,
     /*  600557 */     // GIR_Coverage, 10939,
     /*  600557 */     GIR_EraseRootFromParent_Done,
     /*  600558 */   // Label 9812: @600558
     /*  600558 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(600633), // Rule ID 10942 //
     /*  600563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  600574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  600577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  600580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600609 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  600612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600631 */     GIR_RootConstrainSelectedInstOperands,
     /*  600632 */     // GIR_Coverage, 10942,
     /*  600632 */     GIR_EraseRootFromParent_Done,
     /*  600633 */   // Label 9813: @600633
     /*  600633 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(600708), // Rule ID 10943 //
     /*  600638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  600649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  600652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  600655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  600687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600706 */     GIR_RootConstrainSelectedInstOperands,
     /*  600707 */     // GIR_Coverage, 10943,
     /*  600707 */     GIR_EraseRootFromParent_Done,
     /*  600708 */   // Label 9814: @600708
     /*  600708 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(600783), // Rule ID 10946 //
     /*  600713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  600724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  600727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  600730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  600762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600781 */     GIR_RootConstrainSelectedInstOperands,
     /*  600782 */     // GIR_Coverage, 10946,
     /*  600782 */     GIR_EraseRootFromParent_Done,
     /*  600783 */   // Label 9815: @600783
     /*  600783 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(600858), // Rule ID 10947 //
     /*  600788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  600799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  600802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  600805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  600837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600856 */     GIR_RootConstrainSelectedInstOperands,
     /*  600857 */     // GIR_Coverage, 10947,
     /*  600857 */     GIR_EraseRootFromParent_Done,
     /*  600858 */   // Label 9816: @600858
     /*  600858 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(600933), // Rule ID 10950 //
     /*  600863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  600912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600931 */     GIR_RootConstrainSelectedInstOperands,
     /*  600932 */     // GIR_Coverage, 10950,
     /*  600932 */     GIR_EraseRootFromParent_Done,
     /*  600933 */   // Label 9817: @600933
     /*  600933 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(601008), // Rule ID 10951 //
     /*  600938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  600946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  600987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601006 */     GIR_RootConstrainSelectedInstOperands,
     /*  601007 */     // GIR_Coverage, 10951,
     /*  601007 */     GIR_EraseRootFromParent_Done,
     /*  601008 */   // Label 9818: @601008
     /*  601008 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(601083), // Rule ID 10954 //
     /*  601013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  601062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601081 */     GIR_RootConstrainSelectedInstOperands,
     /*  601082 */     // GIR_Coverage, 10954,
     /*  601082 */     GIR_EraseRootFromParent_Done,
     /*  601083 */   // Label 9819: @601083
     /*  601083 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(601158), // Rule ID 10955 //
     /*  601088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  601137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601156 */     GIR_RootConstrainSelectedInstOperands,
     /*  601157 */     // GIR_Coverage, 10955,
     /*  601157 */     GIR_EraseRootFromParent_Done,
     /*  601158 */   // Label 9820: @601158
     /*  601158 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(601233), // Rule ID 10958 //
     /*  601163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  601212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601231 */     GIR_RootConstrainSelectedInstOperands,
     /*  601232 */     // GIR_Coverage, 10958,
     /*  601232 */     GIR_EraseRootFromParent_Done,
     /*  601233 */   // Label 9821: @601233
     /*  601233 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(601308), // Rule ID 10959 //
     /*  601238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  601287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601306 */     GIR_RootConstrainSelectedInstOperands,
     /*  601307 */     // GIR_Coverage, 10959,
     /*  601307 */     GIR_EraseRootFromParent_Done,
     /*  601308 */   // Label 9822: @601308
     /*  601308 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(601383), // Rule ID 10962 //
     /*  601313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  601362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601381 */     GIR_RootConstrainSelectedInstOperands,
     /*  601382 */     // GIR_Coverage, 10962,
     /*  601382 */     GIR_EraseRootFromParent_Done,
     /*  601383 */   // Label 9823: @601383
     /*  601383 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(601458), // Rule ID 10963 //
     /*  601388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  601437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601456 */     GIR_RootConstrainSelectedInstOperands,
     /*  601457 */     // GIR_Coverage, 10963,
     /*  601457 */     GIR_EraseRootFromParent_Done,
     /*  601458 */   // Label 9824: @601458
     /*  601458 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(601533), // Rule ID 10966 //
     /*  601463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  601512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601531 */     GIR_RootConstrainSelectedInstOperands,
     /*  601532 */     // GIR_Coverage, 10966,
     /*  601532 */     GIR_EraseRootFromParent_Done,
     /*  601533 */   // Label 9825: @601533
     /*  601533 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(601608), // Rule ID 10967 //
     /*  601538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  601587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601606 */     GIR_RootConstrainSelectedInstOperands,
     /*  601607 */     // GIR_Coverage, 10967,
     /*  601607 */     GIR_EraseRootFromParent_Done,
     /*  601608 */   // Label 9826: @601608
     /*  601608 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(601683), // Rule ID 10970 //
     /*  601613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  601662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601681 */     GIR_RootConstrainSelectedInstOperands,
     /*  601682 */     // GIR_Coverage, 10970,
     /*  601682 */     GIR_EraseRootFromParent_Done,
     /*  601683 */   // Label 9827: @601683
     /*  601683 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(601758), // Rule ID 10971 //
     /*  601688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  601737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601756 */     GIR_RootConstrainSelectedInstOperands,
     /*  601757 */     // GIR_Coverage, 10971,
     /*  601757 */     GIR_EraseRootFromParent_Done,
     /*  601758 */   // Label 9828: @601758
     /*  601758 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(601833), // Rule ID 10974 //
     /*  601763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  601766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  601809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  601812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  601828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601831 */     GIR_RootConstrainSelectedInstOperands,
     /*  601832 */     // GIR_Coverage, 10974,
     /*  601832 */     GIR_EraseRootFromParent_Done,
     /*  601833 */   // Label 9829: @601833
     /*  601833 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(601908), // Rule ID 10975 //
     /*  601838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  601841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  601884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  601887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  601903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601906 */     GIR_RootConstrainSelectedInstOperands,
     /*  601907 */     // GIR_Coverage, 10975,
     /*  601907 */     GIR_EraseRootFromParent_Done,
     /*  601908 */   // Label 9830: @601908
     /*  601908 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(601983), // Rule ID 10978 //
     /*  601913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  601916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  601959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  601962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  601978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601981 */     GIR_RootConstrainSelectedInstOperands,
     /*  601982 */     // GIR_Coverage, 10978,
     /*  601982 */     GIR_EraseRootFromParent_Done,
     /*  601983 */   // Label 9831: @601983
     /*  601983 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(602058), // Rule ID 10979 //
     /*  601988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  601991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  601996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  602034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  602037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  602053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602056 */     GIR_RootConstrainSelectedInstOperands,
     /*  602057 */     // GIR_Coverage, 10979,
     /*  602057 */     GIR_EraseRootFromParent_Done,
     /*  602058 */   // Label 9832: @602058
     /*  602058 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(602133), // Rule ID 10982 //
     /*  602063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  602066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  602071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  602109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  602112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  602128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602131 */     GIR_RootConstrainSelectedInstOperands,
     /*  602132 */     // GIR_Coverage, 10982,
     /*  602132 */     GIR_EraseRootFromParent_Done,
     /*  602133 */   // Label 9833: @602133
     /*  602133 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(602208), // Rule ID 10983 //
     /*  602138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  602141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  602146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  602184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  602187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  602203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602206 */     GIR_RootConstrainSelectedInstOperands,
     /*  602207 */     // GIR_Coverage, 10983,
     /*  602207 */     GIR_EraseRootFromParent_Done,
     /*  602208 */   // Label 9834: @602208
     /*  602208 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(602283), // Rule ID 10986 //
     /*  602213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  602224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  602227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  602230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  602233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  602262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602281 */     GIR_RootConstrainSelectedInstOperands,
     /*  602282 */     // GIR_Coverage, 10986,
     /*  602282 */     GIR_EraseRootFromParent_Done,
     /*  602283 */   // Label 9835: @602283
     /*  602283 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(602358), // Rule ID 10987 //
     /*  602288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  602299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  602302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  602305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  602308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  602337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602356 */     GIR_RootConstrainSelectedInstOperands,
     /*  602357 */     // GIR_Coverage, 10987,
     /*  602357 */     GIR_EraseRootFromParent_Done,
     /*  602358 */   // Label 9836: @602358
     /*  602358 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(602433), // Rule ID 10990 //
     /*  602363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  602374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  602383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  602412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602431 */     GIR_RootConstrainSelectedInstOperands,
     /*  602432 */     // GIR_Coverage, 10990,
     /*  602432 */     GIR_EraseRootFromParent_Done,
     /*  602433 */   // Label 9837: @602433
     /*  602433 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(602508), // Rule ID 10991 //
     /*  602438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  602449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  602458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  602487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602506 */     GIR_RootConstrainSelectedInstOperands,
     /*  602507 */     // GIR_Coverage, 10991,
     /*  602507 */     GIR_EraseRootFromParent_Done,
     /*  602508 */   // Label 9838: @602508
     /*  602508 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(602583), // Rule ID 10994 //
     /*  602513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  602524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602559 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  602562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602581 */     GIR_RootConstrainSelectedInstOperands,
     /*  602582 */     // GIR_Coverage, 10994,
     /*  602582 */     GIR_EraseRootFromParent_Done,
     /*  602583 */   // Label 9839: @602583
     /*  602583 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(602658), // Rule ID 10995 //
     /*  602588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  602599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  602637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602656 */     GIR_RootConstrainSelectedInstOperands,
     /*  602657 */     // GIR_Coverage, 10995,
     /*  602657 */     GIR_EraseRootFromParent_Done,
     /*  602658 */   // Label 9840: @602658
     /*  602658 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(602733), // Rule ID 10998 //
     /*  602663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  602674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  602712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602731 */     GIR_RootConstrainSelectedInstOperands,
     /*  602732 */     // GIR_Coverage, 10998,
     /*  602732 */     GIR_EraseRootFromParent_Done,
     /*  602733 */   // Label 9841: @602733
     /*  602733 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(602808), // Rule ID 10999 //
     /*  602738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  602749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  602787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602806 */     GIR_RootConstrainSelectedInstOperands,
     /*  602807 */     // GIR_Coverage, 10999,
     /*  602807 */     GIR_EraseRootFromParent_Done,
     /*  602808 */   // Label 9842: @602808
     /*  602808 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(602883), // Rule ID 11002 //
     /*  602813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  602824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  602862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602881 */     GIR_RootConstrainSelectedInstOperands,
     /*  602882 */     // GIR_Coverage, 11002,
     /*  602882 */     GIR_EraseRootFromParent_Done,
     /*  602883 */   // Label 9843: @602883
     /*  602883 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(602958), // Rule ID 11003 //
     /*  602888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  602899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  602937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602956 */     GIR_RootConstrainSelectedInstOperands,
     /*  602957 */     // GIR_Coverage, 11003,
     /*  602957 */     GIR_EraseRootFromParent_Done,
     /*  602958 */   // Label 9844: @602958
     /*  602958 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(603033), // Rule ID 11006 //
     /*  602963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  602971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  602974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  602983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  603012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603031 */     GIR_RootConstrainSelectedInstOperands,
     /*  603032 */     // GIR_Coverage, 11006,
     /*  603032 */     GIR_EraseRootFromParent_Done,
     /*  603033 */   // Label 9845: @603033
     /*  603033 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(603108), // Rule ID 11007 //
     /*  603038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  603049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  603058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  603087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603106 */     GIR_RootConstrainSelectedInstOperands,
     /*  603107 */     // GIR_Coverage, 11007,
     /*  603107 */     GIR_EraseRootFromParent_Done,
     /*  603108 */   // Label 9846: @603108
     /*  603108 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(603183), // Rule ID 11010 //
     /*  603113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  603124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  603133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  603159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603181 */     GIR_RootConstrainSelectedInstOperands,
     /*  603182 */     // GIR_Coverage, 11010,
     /*  603182 */     GIR_EraseRootFromParent_Done,
     /*  603183 */   // Label 9847: @603183
     /*  603183 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(603258), // Rule ID 11011 //
     /*  603188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  603199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  603208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  603234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603256 */     GIR_RootConstrainSelectedInstOperands,
     /*  603257 */     // GIR_Coverage, 11011,
     /*  603257 */     GIR_EraseRootFromParent_Done,
     /*  603258 */   // Label 9848: @603258
     /*  603258 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(603333), // Rule ID 11014 //
     /*  603263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  603274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603331 */     GIR_RootConstrainSelectedInstOperands,
     /*  603332 */     // GIR_Coverage, 11014,
     /*  603332 */     GIR_EraseRootFromParent_Done,
     /*  603333 */   // Label 9849: @603333
     /*  603333 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(603408), // Rule ID 11015 //
     /*  603338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  603349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603406 */     GIR_RootConstrainSelectedInstOperands,
     /*  603407 */     // GIR_Coverage, 11015,
     /*  603407 */     GIR_EraseRootFromParent_Done,
     /*  603408 */   // Label 9850: @603408
     /*  603408 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(603483), // Rule ID 11018 //
     /*  603413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  603424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603481 */     GIR_RootConstrainSelectedInstOperands,
     /*  603482 */     // GIR_Coverage, 11018,
     /*  603482 */     GIR_EraseRootFromParent_Done,
     /*  603483 */   // Label 9851: @603483
     /*  603483 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(603558), // Rule ID 11019 //
     /*  603488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  603499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  603537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603556 */     GIR_RootConstrainSelectedInstOperands,
     /*  603557 */     // GIR_Coverage, 11019,
     /*  603557 */     GIR_EraseRootFromParent_Done,
     /*  603558 */   // Label 9852: @603558
     /*  603558 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(603633), // Rule ID 11022 //
     /*  603563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  603574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  603583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603609 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  603609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  603612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603631 */     GIR_RootConstrainSelectedInstOperands,
     /*  603632 */     // GIR_Coverage, 11022,
     /*  603632 */     GIR_EraseRootFromParent_Done,
     /*  603633 */   // Label 9853: @603633
     /*  603633 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(603708), // Rule ID 11023 //
     /*  603638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  603649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  603658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  603684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  603687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603706 */     GIR_RootConstrainSelectedInstOperands,
     /*  603707 */     // GIR_Coverage, 11023,
     /*  603707 */     GIR_EraseRootFromParent_Done,
     /*  603708 */   // Label 9854: @603708
     /*  603708 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(603783), // Rule ID 11026 //
     /*  603713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  603724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  603733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  603759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  603762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603781 */     GIR_RootConstrainSelectedInstOperands,
     /*  603782 */     // GIR_Coverage, 11026,
     /*  603782 */     GIR_EraseRootFromParent_Done,
     /*  603783 */   // Label 9855: @603783
     /*  603783 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(603858), // Rule ID 11027 //
     /*  603788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  603799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  603808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  603834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  603837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603856 */     GIR_RootConstrainSelectedInstOperands,
     /*  603857 */     // GIR_Coverage, 11027,
     /*  603857 */     GIR_EraseRootFromParent_Done,
     /*  603858 */   // Label 9856: @603858
     /*  603858 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(603933), // Rule ID 11030 //
     /*  603863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  603874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  603877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  603880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  603883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603909 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  603909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  603912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603931 */     GIR_RootConstrainSelectedInstOperands,
     /*  603932 */     // GIR_Coverage, 11030,
     /*  603932 */     GIR_EraseRootFromParent_Done,
     /*  603933 */   // Label 9857: @603933
     /*  603933 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(604008), // Rule ID 11031 //
     /*  603938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  603946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  603949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  603952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  603955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  603958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  603984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  603987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604006 */     GIR_RootConstrainSelectedInstOperands,
     /*  604007 */     // GIR_Coverage, 11031,
     /*  604007 */     GIR_EraseRootFromParent_Done,
     /*  604008 */   // Label 9858: @604008
     /*  604008 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(604083), // Rule ID 11034 //
     /*  604013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  604033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  604059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  604062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604081 */     GIR_RootConstrainSelectedInstOperands,
     /*  604082 */     // GIR_Coverage, 11034,
     /*  604082 */     GIR_EraseRootFromParent_Done,
     /*  604083 */   // Label 9859: @604083
     /*  604083 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(604158), // Rule ID 11035 //
     /*  604088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  604108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  604134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  604137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604156 */     GIR_RootConstrainSelectedInstOperands,
     /*  604157 */     // GIR_Coverage, 11035,
     /*  604157 */     GIR_EraseRootFromParent_Done,
     /*  604158 */   // Label 9860: @604158
     /*  604158 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(604233), // Rule ID 11038 //
     /*  604163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  604183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604209 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  604209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  604212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604231 */     GIR_RootConstrainSelectedInstOperands,
     /*  604232 */     // GIR_Coverage, 11038,
     /*  604232 */     GIR_EraseRootFromParent_Done,
     /*  604233 */   // Label 9861: @604233
     /*  604233 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(604308), // Rule ID 11039 //
     /*  604238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  604258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  604284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  604287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604306 */     GIR_RootConstrainSelectedInstOperands,
     /*  604307 */     // GIR_Coverage, 11039,
     /*  604307 */     GIR_EraseRootFromParent_Done,
     /*  604308 */   // Label 9862: @604308
     /*  604308 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(604383), // Rule ID 11042 //
     /*  604313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  604333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604359 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  604359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  604362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604381 */     GIR_RootConstrainSelectedInstOperands,
     /*  604382 */     // GIR_Coverage, 11042,
     /*  604382 */     GIR_EraseRootFromParent_Done,
     /*  604383 */   // Label 9863: @604383
     /*  604383 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(604458), // Rule ID 11043 //
     /*  604388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  604408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604434 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  604434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  604437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604456 */     GIR_RootConstrainSelectedInstOperands,
     /*  604457 */     // GIR_Coverage, 11043,
     /*  604457 */     GIR_EraseRootFromParent_Done,
     /*  604458 */   // Label 9864: @604458
     /*  604458 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(604533), // Rule ID 11046 //
     /*  604463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  604474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  604483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  604509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  604512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604531 */     GIR_RootConstrainSelectedInstOperands,
     /*  604532 */     // GIR_Coverage, 11046,
     /*  604532 */     GIR_EraseRootFromParent_Done,
     /*  604533 */   // Label 9865: @604533
     /*  604533 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(604608), // Rule ID 11047 //
     /*  604538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  604549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  604558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  604584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  604587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604606 */     GIR_RootConstrainSelectedInstOperands,
     /*  604607 */     // GIR_Coverage, 11047,
     /*  604607 */     GIR_EraseRootFromParent_Done,
     /*  604608 */   // Label 9866: @604608
     /*  604608 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(604683), // Rule ID 11050 //
     /*  604613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  604624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  604633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604659 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  604659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  604662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604681 */     GIR_RootConstrainSelectedInstOperands,
     /*  604682 */     // GIR_Coverage, 11050,
     /*  604682 */     GIR_EraseRootFromParent_Done,
     /*  604683 */   // Label 9867: @604683
     /*  604683 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(604758), // Rule ID 11051 //
     /*  604688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  604699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  604708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  604734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  604737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604756 */     GIR_RootConstrainSelectedInstOperands,
     /*  604757 */     // GIR_Coverage, 11051,
     /*  604757 */     GIR_EraseRootFromParent_Done,
     /*  604758 */   // Label 9868: @604758
     /*  604758 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(604833), // Rule ID 11054 //
     /*  604763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  604774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  604783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  604809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  604812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604831 */     GIR_RootConstrainSelectedInstOperands,
     /*  604832 */     // GIR_Coverage, 11054,
     /*  604832 */     GIR_EraseRootFromParent_Done,
     /*  604833 */   // Label 9869: @604833
     /*  604833 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(604908), // Rule ID 11055 //
     /*  604838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  604849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  604858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  604884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  604887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604906 */     GIR_RootConstrainSelectedInstOperands,
     /*  604907 */     // GIR_Coverage, 11055,
     /*  604907 */     GIR_EraseRootFromParent_Done,
     /*  604908 */   // Label 9870: @604908
     /*  604908 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(604983), // Rule ID 11058 //
     /*  604913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  604924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  604927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  604930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  604962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604981 */     GIR_RootConstrainSelectedInstOperands,
     /*  604982 */     // GIR_Coverage, 11058,
     /*  604982 */     GIR_EraseRootFromParent_Done,
     /*  604983 */   // Label 9871: @604983
     /*  604983 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(605058), // Rule ID 11059 //
     /*  604988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  604996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  604999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  605005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  605034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  605037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605056 */     GIR_RootConstrainSelectedInstOperands,
     /*  605057 */     // GIR_Coverage, 11059,
     /*  605057 */     GIR_EraseRootFromParent_Done,
     /*  605058 */   // Label 9872: @605058
     /*  605058 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(605133), // Rule ID 11062 //
     /*  605063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  605074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  605080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  605109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  605112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605131 */     GIR_RootConstrainSelectedInstOperands,
     /*  605132 */     // GIR_Coverage, 11062,
     /*  605132 */     GIR_EraseRootFromParent_Done,
     /*  605133 */   // Label 9873: @605133
     /*  605133 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(605208), // Rule ID 11063 //
     /*  605138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  605149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  605155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  605184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  605187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605206 */     GIR_RootConstrainSelectedInstOperands,
     /*  605207 */     // GIR_Coverage, 11063,
     /*  605207 */     GIR_EraseRootFromParent_Done,
     /*  605208 */   // Label 9874: @605208
     /*  605208 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(605283), // Rule ID 11066 //
     /*  605213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  605224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  605230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  605259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605281 */     GIR_RootConstrainSelectedInstOperands,
     /*  605282 */     // GIR_Coverage, 11066,
     /*  605282 */     GIR_EraseRootFromParent_Done,
     /*  605283 */   // Label 9875: @605283
     /*  605283 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(605358), // Rule ID 11067 //
     /*  605288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  605299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  605305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  605334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605356 */     GIR_RootConstrainSelectedInstOperands,
     /*  605357 */     // GIR_Coverage, 11067,
     /*  605357 */     GIR_EraseRootFromParent_Done,
     /*  605358 */   // Label 9876: @605358
     /*  605358 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(605433), // Rule ID 11070 //
     /*  605363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  605374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  605380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  605412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605431 */     GIR_RootConstrainSelectedInstOperands,
     /*  605432 */     // GIR_Coverage, 11070,
     /*  605432 */     GIR_EraseRootFromParent_Done,
     /*  605433 */   // Label 9877: @605433
     /*  605433 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(605508), // Rule ID 11071 //
     /*  605438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  605449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  605455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  605487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605506 */     GIR_RootConstrainSelectedInstOperands,
     /*  605507 */     // GIR_Coverage, 11071,
     /*  605507 */     GIR_EraseRootFromParent_Done,
     /*  605508 */   // Label 9878: @605508
     /*  605508 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(605583), // Rule ID 11074 //
     /*  605513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  605524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  605527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  605530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605581 */     GIR_RootConstrainSelectedInstOperands,
     /*  605582 */     // GIR_Coverage, 11074,
     /*  605582 */     GIR_EraseRootFromParent_Done,
     /*  605583 */   // Label 9879: @605583
     /*  605583 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(605658), // Rule ID 11075 //
     /*  605588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  605599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  605602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  605605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605656 */     GIR_RootConstrainSelectedInstOperands,
     /*  605657 */     // GIR_Coverage, 11075,
     /*  605657 */     GIR_EraseRootFromParent_Done,
     /*  605658 */   // Label 9880: @605658
     /*  605658 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(605733), // Rule ID 11078 //
     /*  605663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  605674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  605680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  605709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605731 */     GIR_RootConstrainSelectedInstOperands,
     /*  605732 */     // GIR_Coverage, 11078,
     /*  605732 */     GIR_EraseRootFromParent_Done,
     /*  605733 */   // Label 9881: @605733
     /*  605733 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(605808), // Rule ID 11079 //
     /*  605738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  605749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  605755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  605784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  605787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605806 */     GIR_RootConstrainSelectedInstOperands,
     /*  605807 */     // GIR_Coverage, 11079,
     /*  605807 */     GIR_EraseRootFromParent_Done,
     /*  605808 */   // Label 9882: @605808
     /*  605808 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(605883), // Rule ID 11082 //
     /*  605813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  605824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  605827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  605830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  605859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  605862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605881 */     GIR_RootConstrainSelectedInstOperands,
     /*  605882 */     // GIR_Coverage, 11082,
     /*  605882 */     GIR_EraseRootFromParent_Done,
     /*  605883 */   // Label 9883: @605883
     /*  605883 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(605958), // Rule ID 11083 //
     /*  605888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  605899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  605902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  605905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  605934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  605937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605956 */     GIR_RootConstrainSelectedInstOperands,
     /*  605957 */     // GIR_Coverage, 11083,
     /*  605957 */     GIR_EraseRootFromParent_Done,
     /*  605958 */   // Label 9884: @605958
     /*  605958 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(606033), // Rule ID 11086 //
     /*  605963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  605971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  605974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  605977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  605980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  606009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  606012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606031 */     GIR_RootConstrainSelectedInstOperands,
     /*  606032 */     // GIR_Coverage, 11086,
     /*  606032 */     GIR_EraseRootFromParent_Done,
     /*  606033 */   // Label 9885: @606033
     /*  606033 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(606108), // Rule ID 11087 //
     /*  606038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  606049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  606055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  606084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  606087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606106 */     GIR_RootConstrainSelectedInstOperands,
     /*  606107 */     // GIR_Coverage, 11087,
     /*  606107 */     GIR_EraseRootFromParent_Done,
     /*  606108 */   // Label 9886: @606108
     /*  606108 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(606183), // Rule ID 11090 //
     /*  606113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  606124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  606130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606159 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  606159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  606162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606181 */     GIR_RootConstrainSelectedInstOperands,
     /*  606182 */     // GIR_Coverage, 11090,
     /*  606182 */     GIR_EraseRootFromParent_Done,
     /*  606183 */   // Label 9887: @606183
     /*  606183 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(606258), // Rule ID 11091 //
     /*  606188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  606199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  606205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  606234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  606237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606256 */     GIR_RootConstrainSelectedInstOperands,
     /*  606257 */     // GIR_Coverage, 11091,
     /*  606257 */     GIR_EraseRootFromParent_Done,
     /*  606258 */   // Label 9888: @606258
     /*  606258 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(606333), // Rule ID 11094 //
     /*  606263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  606274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  606280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606309 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  606309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  606312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606331 */     GIR_RootConstrainSelectedInstOperands,
     /*  606332 */     // GIR_Coverage, 11094,
     /*  606332 */     GIR_EraseRootFromParent_Done,
     /*  606333 */   // Label 9889: @606333
     /*  606333 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(606408), // Rule ID 11095 //
     /*  606338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  606349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  606355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  606384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  606387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606406 */     GIR_RootConstrainSelectedInstOperands,
     /*  606407 */     // GIR_Coverage, 11095,
     /*  606407 */     GIR_EraseRootFromParent_Done,
     /*  606408 */   // Label 9890: @606408
     /*  606408 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(606483), // Rule ID 11098 //
     /*  606413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  606424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  606427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  606430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  606459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  606462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606481 */     GIR_RootConstrainSelectedInstOperands,
     /*  606482 */     // GIR_Coverage, 11098,
     /*  606482 */     GIR_EraseRootFromParent_Done,
     /*  606483 */   // Label 9891: @606483
     /*  606483 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(606558), // Rule ID 11099 //
     /*  606488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  606499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  606502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  606505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606534 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  606534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  606537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606556 */     GIR_RootConstrainSelectedInstOperands,
     /*  606557 */     // GIR_Coverage, 11099,
     /*  606557 */     GIR_EraseRootFromParent_Done,
     /*  606558 */   // Label 9892: @606558
     /*  606558 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(606633), // Rule ID 11102 //
     /*  606563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  606574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  606577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  606580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606609 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  606609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  606612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606631 */     GIR_RootConstrainSelectedInstOperands,
     /*  606632 */     // GIR_Coverage, 11102,
     /*  606632 */     GIR_EraseRootFromParent_Done,
     /*  606633 */   // Label 9893: @606633
     /*  606633 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(606708), // Rule ID 11103 //
     /*  606638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  606649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  606652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  606655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  606684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  606687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606706 */     GIR_RootConstrainSelectedInstOperands,
     /*  606707 */     // GIR_Coverage, 11103,
     /*  606707 */     GIR_EraseRootFromParent_Done,
     /*  606708 */   // Label 9894: @606708
     /*  606708 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(606783), // Rule ID 11106 //
     /*  606713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  606724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  606727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  606730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  606759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  606762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606781 */     GIR_RootConstrainSelectedInstOperands,
     /*  606782 */     // GIR_Coverage, 11106,
     /*  606782 */     GIR_EraseRootFromParent_Done,
     /*  606783 */   // Label 9895: @606783
     /*  606783 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(606858), // Rule ID 11107 //
     /*  606788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  606799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  606802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  606805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  606834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  606837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606856 */     GIR_RootConstrainSelectedInstOperands,
     /*  606857 */     // GIR_Coverage, 11107,
     /*  606857 */     GIR_EraseRootFromParent_Done,
     /*  606858 */   // Label 9896: @606858
     /*  606858 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(606933), // Rule ID 11110 //
     /*  606863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  606874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  606877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  606880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606909 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  606909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  606912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606931 */     GIR_RootConstrainSelectedInstOperands,
     /*  606932 */     // GIR_Coverage, 11110,
     /*  606932 */     GIR_EraseRootFromParent_Done,
     /*  606933 */   // Label 9897: @606933
     /*  606933 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(607008), // Rule ID 11111 //
     /*  606938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  606946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  606949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  606952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  606955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  606984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  606987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607006 */     GIR_RootConstrainSelectedInstOperands,
     /*  607007 */     // GIR_Coverage, 11111,
     /*  607007 */     GIR_EraseRootFromParent_Done,
     /*  607008 */   // Label 9898: @607008
     /*  607008 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(607083), // Rule ID 11114 //
     /*  607013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  607024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  607030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  607033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607059 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  607059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  607062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607081 */     GIR_RootConstrainSelectedInstOperands,
     /*  607082 */     // GIR_Coverage, 11114,
     /*  607082 */     GIR_EraseRootFromParent_Done,
     /*  607083 */   // Label 9899: @607083
     /*  607083 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(607158), // Rule ID 11115 //
     /*  607088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  607099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  607105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  607108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  607134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  607137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607156 */     GIR_RootConstrainSelectedInstOperands,
     /*  607157 */     // GIR_Coverage, 11115,
     /*  607157 */     GIR_EraseRootFromParent_Done,
     /*  607158 */   // Label 9900: @607158
     /*  607158 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(607233), // Rule ID 11118 //
     /*  607163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  607174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  607180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  607183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  607209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  607212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607231 */     GIR_RootConstrainSelectedInstOperands,
     /*  607232 */     // GIR_Coverage, 11118,
     /*  607232 */     GIR_EraseRootFromParent_Done,
     /*  607233 */   // Label 9901: @607233
     /*  607233 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(607308), // Rule ID 11119 //
     /*  607238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  607249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  607255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  607258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  607284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  607287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607306 */     GIR_RootConstrainSelectedInstOperands,
     /*  607307 */     // GIR_Coverage, 11119,
     /*  607307 */     GIR_EraseRootFromParent_Done,
     /*  607308 */   // Label 9902: @607308
     /*  607308 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(607383), // Rule ID 11122 //
     /*  607313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  607324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  607330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  607333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607359 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  607359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  607362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607381 */     GIR_RootConstrainSelectedInstOperands,
     /*  607382 */     // GIR_Coverage, 11122,
     /*  607382 */     GIR_EraseRootFromParent_Done,
     /*  607383 */   // Label 9903: @607383
     /*  607383 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(607458), // Rule ID 11123 //
     /*  607388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  607399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  607405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  607408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  607434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  607437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607456 */     GIR_RootConstrainSelectedInstOperands,
     /*  607457 */     // GIR_Coverage, 11123,
     /*  607457 */     GIR_EraseRootFromParent_Done,
     /*  607458 */   // Label 9904: @607458
     /*  607458 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(607533), // Rule ID 11126 //
     /*  607463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  607474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  607477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  607480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  607483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607509 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  607509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  607512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607531 */     GIR_RootConstrainSelectedInstOperands,
     /*  607532 */     // GIR_Coverage, 11126,
     /*  607532 */     GIR_EraseRootFromParent_Done,
     /*  607533 */   // Label 9905: @607533
     /*  607533 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(607608), // Rule ID 11127 //
     /*  607538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  607546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  607549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  607552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  607555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  607558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607584 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  607584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  607587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607606 */     GIR_RootConstrainSelectedInstOperands,
     /*  607607 */     // GIR_Coverage, 11127,
     /*  607607 */     GIR_EraseRootFromParent_Done,
     /*  607608 */   // Label 9906: @607608
     /*  607608 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(607683), // Rule ID 11130 //
     /*  607613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  607624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  607627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  607630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  607633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  607659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  607662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607681 */     GIR_RootConstrainSelectedInstOperands,
     /*  607682 */     // GIR_Coverage, 11130,
     /*  607682 */     GIR_EraseRootFromParent_Done,
     /*  607683 */   // Label 9907: @607683
     /*  607683 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(607758), // Rule ID 11131 //
     /*  607688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  607699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  607702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  607705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  607708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  607734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  607737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607756 */     GIR_RootConstrainSelectedInstOperands,
     /*  607757 */     // GIR_Coverage, 11131,
     /*  607757 */     GIR_EraseRootFromParent_Done,
     /*  607758 */   // Label 9908: @607758
     /*  607758 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(607833), // Rule ID 11134 //
     /*  607763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  607774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  607777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  607780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  607783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  607809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  607812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607831 */     GIR_RootConstrainSelectedInstOperands,
     /*  607832 */     // GIR_Coverage, 11134,
     /*  607832 */     GIR_EraseRootFromParent_Done,
     /*  607833 */   // Label 9909: @607833
     /*  607833 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(607908), // Rule ID 11135 //
     /*  607838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  607849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  607852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  607855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  607858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  607884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  607887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607906 */     GIR_RootConstrainSelectedInstOperands,
     /*  607907 */     // GIR_Coverage, 11135,
     /*  607907 */     GIR_EraseRootFromParent_Done,
     /*  607908 */   // Label 9910: @607908
     /*  607908 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(607983), // Rule ID 11138 //
     /*  607913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  607924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  607927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  607930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  607933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  607959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  607962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  607966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  607968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  607970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  607981 */     GIR_RootConstrainSelectedInstOperands,
     /*  607982 */     // GIR_Coverage, 11138,
     /*  607982 */     GIR_EraseRootFromParent_Done,
     /*  607983 */   // Label 9911: @607983
     /*  607983 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(608058), // Rule ID 11139 //
     /*  607988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  607996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  607999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  608002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  608005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  608008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  608034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  608037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608056 */     GIR_RootConstrainSelectedInstOperands,
     /*  608057 */     // GIR_Coverage, 11139,
     /*  608057 */     GIR_EraseRootFromParent_Done,
     /*  608058 */   // Label 9912: @608058
     /*  608058 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(608133), // Rule ID 11142 //
     /*  608063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  608074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  608077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  608080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  608083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  608109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  608112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608131 */     GIR_RootConstrainSelectedInstOperands,
     /*  608132 */     // GIR_Coverage, 11142,
     /*  608132 */     GIR_EraseRootFromParent_Done,
     /*  608133 */   // Label 9913: @608133
     /*  608133 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(608208), // Rule ID 11143 //
     /*  608138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  608149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  608152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  608155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  608158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  608184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  608187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608206 */     GIR_RootConstrainSelectedInstOperands,
     /*  608207 */     // GIR_Coverage, 11143,
     /*  608207 */     GIR_EraseRootFromParent_Done,
     /*  608208 */   // Label 9914: @608208
     /*  608208 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(608283), // Rule ID 11146 //
     /*  608213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  608224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  608227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  608230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  608233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  608259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  608262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608281 */     GIR_RootConstrainSelectedInstOperands,
     /*  608282 */     // GIR_Coverage, 11146,
     /*  608282 */     GIR_EraseRootFromParent_Done,
     /*  608283 */   // Label 9915: @608283
     /*  608283 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(608358), // Rule ID 11147 //
     /*  608288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  608299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  608302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  608305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  608308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  608334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  608337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608356 */     GIR_RootConstrainSelectedInstOperands,
     /*  608357 */     // GIR_Coverage, 11147,
     /*  608357 */     GIR_EraseRootFromParent_Done,
     /*  608358 */   // Label 9916: @608358
     /*  608358 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(608433), // Rule ID 11150 //
     /*  608363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  608374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  608377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  608380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  608383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  608409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  608412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608431 */     GIR_RootConstrainSelectedInstOperands,
     /*  608432 */     // GIR_Coverage, 11150,
     /*  608432 */     GIR_EraseRootFromParent_Done,
     /*  608433 */   // Label 9917: @608433
     /*  608433 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(608508), // Rule ID 11151 //
     /*  608438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  608449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  608452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  608455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  608458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  608484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  608487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608506 */     GIR_RootConstrainSelectedInstOperands,
     /*  608507 */     // GIR_Coverage, 11151,
     /*  608507 */     GIR_EraseRootFromParent_Done,
     /*  608508 */   // Label 9918: @608508
     /*  608508 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(608583), // Rule ID 11154 //
     /*  608513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  608524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  608527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  608530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  608533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608559 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  608559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608581 */     GIR_RootConstrainSelectedInstOperands,
     /*  608582 */     // GIR_Coverage, 11154,
     /*  608582 */     GIR_EraseRootFromParent_Done,
     /*  608583 */   // Label 9919: @608583
     /*  608583 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(608658), // Rule ID 11155 //
     /*  608588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  608599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  608602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  608605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  608608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  608634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608656 */     GIR_RootConstrainSelectedInstOperands,
     /*  608657 */     // GIR_Coverage, 11155,
     /*  608657 */     GIR_EraseRootFromParent_Done,
     /*  608658 */   // Label 9920: @608658
     /*  608658 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(608733), // Rule ID 11158 //
     /*  608663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  608674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  608677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  608680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  608683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  608709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608731 */     GIR_RootConstrainSelectedInstOperands,
     /*  608732 */     // GIR_Coverage, 11158,
     /*  608732 */     GIR_EraseRootFromParent_Done,
     /*  608733 */   // Label 9921: @608733
     /*  608733 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(608808), // Rule ID 11159 //
     /*  608738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  608749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  608752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  608755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  608758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  608784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608806 */     GIR_RootConstrainSelectedInstOperands,
     /*  608807 */     // GIR_Coverage, 11159,
     /*  608807 */     GIR_EraseRootFromParent_Done,
     /*  608808 */   // Label 9922: @608808
     /*  608808 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(608883), // Rule ID 11162 //
     /*  608813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  608824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  608827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  608830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  608833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  608859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608881 */     GIR_RootConstrainSelectedInstOperands,
     /*  608882 */     // GIR_Coverage, 11162,
     /*  608882 */     GIR_EraseRootFromParent_Done,
     /*  608883 */   // Label 9923: @608883
     /*  608883 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(608958), // Rule ID 11163 //
     /*  608888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  608899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  608902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  608905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  608908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  608934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  608937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  608941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  608943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  608945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  608956 */     GIR_RootConstrainSelectedInstOperands,
     /*  608957 */     // GIR_Coverage, 11163,
     /*  608957 */     GIR_EraseRootFromParent_Done,
     /*  608958 */   // Label 9924: @608958
     /*  608958 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(609033), // Rule ID 11166 //
     /*  608963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  608971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  608974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  608977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  608980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  608983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609009 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  609009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609031 */     GIR_RootConstrainSelectedInstOperands,
     /*  609032 */     // GIR_Coverage, 11166,
     /*  609032 */     GIR_EraseRootFromParent_Done,
     /*  609033 */   // Label 9925: @609033
     /*  609033 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(609108), // Rule ID 11167 //
     /*  609038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  609049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  609052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  609055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  609058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  609084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609106 */     GIR_RootConstrainSelectedInstOperands,
     /*  609107 */     // GIR_Coverage, 11167,
     /*  609107 */     GIR_EraseRootFromParent_Done,
     /*  609108 */   // Label 9926: @609108
     /*  609108 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(609183), // Rule ID 11170 //
     /*  609113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  609124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  609127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  609130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  609133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609159 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  609159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  609162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609181 */     GIR_RootConstrainSelectedInstOperands,
     /*  609182 */     // GIR_Coverage, 11170,
     /*  609182 */     GIR_EraseRootFromParent_Done,
     /*  609183 */   // Label 9927: @609183
     /*  609183 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(609258), // Rule ID 11171 //
     /*  609188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  609199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  609202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  609205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  609208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609234 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  609234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  609237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609256 */     GIR_RootConstrainSelectedInstOperands,
     /*  609257 */     // GIR_Coverage, 11171,
     /*  609257 */     GIR_EraseRootFromParent_Done,
     /*  609258 */   // Label 9928: @609258
     /*  609258 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(609333), // Rule ID 11174 //
     /*  609263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  609274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  609277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  609280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  609283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609309 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  609309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  609312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609331 */     GIR_RootConstrainSelectedInstOperands,
     /*  609332 */     // GIR_Coverage, 11174,
     /*  609332 */     GIR_EraseRootFromParent_Done,
     /*  609333 */   // Label 9929: @609333
     /*  609333 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(609408), // Rule ID 11175 //
     /*  609338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  609349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  609352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  609355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  609358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609384 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  609384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  609387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609406 */     GIR_RootConstrainSelectedInstOperands,
     /*  609407 */     // GIR_Coverage, 11175,
     /*  609407 */     GIR_EraseRootFromParent_Done,
     /*  609408 */   // Label 9930: @609408
     /*  609408 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(609483), // Rule ID 11178 //
     /*  609413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  609424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  609427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  609430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  609433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  609459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609481 */     GIR_RootConstrainSelectedInstOperands,
     /*  609482 */     // GIR_Coverage, 11178,
     /*  609482 */     GIR_EraseRootFromParent_Done,
     /*  609483 */   // Label 9931: @609483
     /*  609483 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(609558), // Rule ID 11179 //
     /*  609488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  609499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  609502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  609505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  609508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  609534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609556 */     GIR_RootConstrainSelectedInstOperands,
     /*  609557 */     // GIR_Coverage, 11179,
     /*  609557 */     GIR_EraseRootFromParent_Done,
     /*  609558 */   // Label 9932: @609558
     /*  609558 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(609633), // Rule ID 11182 //
     /*  609563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  609574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  609577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  609580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  609583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609609 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  609609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  609612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609631 */     GIR_RootConstrainSelectedInstOperands,
     /*  609632 */     // GIR_Coverage, 11182,
     /*  609632 */     GIR_EraseRootFromParent_Done,
     /*  609633 */   // Label 9933: @609633
     /*  609633 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(609708), // Rule ID 11183 //
     /*  609638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  609649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  609652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  609655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  609658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  609684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  609687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609706 */     GIR_RootConstrainSelectedInstOperands,
     /*  609707 */     // GIR_Coverage, 11183,
     /*  609707 */     GIR_EraseRootFromParent_Done,
     /*  609708 */   // Label 9934: @609708
     /*  609708 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(609783), // Rule ID 11186 //
     /*  609713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  609724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  609727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  609730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  609733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609759 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  609759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  609762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609781 */     GIR_RootConstrainSelectedInstOperands,
     /*  609782 */     // GIR_Coverage, 11186,
     /*  609782 */     GIR_EraseRootFromParent_Done,
     /*  609783 */   // Label 9935: @609783
     /*  609783 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(609858), // Rule ID 11187 //
     /*  609788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  609799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  609802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  609805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  609808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609834 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  609834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  609837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609856 */     GIR_RootConstrainSelectedInstOperands,
     /*  609857 */     // GIR_Coverage, 11187,
     /*  609857 */     GIR_EraseRootFromParent_Done,
     /*  609858 */   // Label 9936: @609858
     /*  609858 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(609933), // Rule ID 11190 //
     /*  609863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  609874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  609877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  609880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  609883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  609909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  609931 */     GIR_RootConstrainSelectedInstOperands,
     /*  609932 */     // GIR_Coverage, 11190,
     /*  609932 */     GIR_EraseRootFromParent_Done,
     /*  609933 */   // Label 9937: @609933
     /*  609933 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(610008), // Rule ID 11191 //
     /*  609938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  609946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  609949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  609952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  609955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  609958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  609984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  609987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  609991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  609993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  609995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610006 */     GIR_RootConstrainSelectedInstOperands,
     /*  610007 */     // GIR_Coverage, 11191,
     /*  610007 */     GIR_EraseRootFromParent_Done,
     /*  610008 */   // Label 9938: @610008
     /*  610008 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(610083), // Rule ID 11194 //
     /*  610013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  610024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  610027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  610030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  610033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  610059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  610062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610081 */     GIR_RootConstrainSelectedInstOperands,
     /*  610082 */     // GIR_Coverage, 11194,
     /*  610082 */     GIR_EraseRootFromParent_Done,
     /*  610083 */   // Label 9939: @610083
     /*  610083 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(610158), // Rule ID 11195 //
     /*  610088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  610099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  610102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  610105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  610108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  610134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  610137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610156 */     GIR_RootConstrainSelectedInstOperands,
     /*  610157 */     // GIR_Coverage, 11195,
     /*  610157 */     GIR_EraseRootFromParent_Done,
     /*  610158 */   // Label 9940: @610158
     /*  610158 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(610233), // Rule ID 11198 //
     /*  610163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  610174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  610177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  610180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  610183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  610209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  610212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610231 */     GIR_RootConstrainSelectedInstOperands,
     /*  610232 */     // GIR_Coverage, 11198,
     /*  610232 */     GIR_EraseRootFromParent_Done,
     /*  610233 */   // Label 9941: @610233
     /*  610233 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(610308), // Rule ID 11199 //
     /*  610238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  610249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  610252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  610255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  610258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  610284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  610287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610306 */     GIR_RootConstrainSelectedInstOperands,
     /*  610307 */     // GIR_Coverage, 11199,
     /*  610307 */     GIR_EraseRootFromParent_Done,
     /*  610308 */   // Label 9942: @610308
     /*  610308 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(610383), // Rule ID 11202 //
     /*  610313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  610324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  610327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  610330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  610333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  610359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  610362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610381 */     GIR_RootConstrainSelectedInstOperands,
     /*  610382 */     // GIR_Coverage, 11202,
     /*  610382 */     GIR_EraseRootFromParent_Done,
     /*  610383 */   // Label 9943: @610383
     /*  610383 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(610458), // Rule ID 11203 //
     /*  610388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  610399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  610402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  610405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  610408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  610434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  610437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610456 */     GIR_RootConstrainSelectedInstOperands,
     /*  610457 */     // GIR_Coverage, 11203,
     /*  610457 */     GIR_EraseRootFromParent_Done,
     /*  610458 */   // Label 9944: @610458
     /*  610458 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(610533), // Rule ID 11206 //
     /*  610463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  610474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  610477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  610480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  610483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610509 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  610509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  610512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610531 */     GIR_RootConstrainSelectedInstOperands,
     /*  610532 */     // GIR_Coverage, 11206,
     /*  610532 */     GIR_EraseRootFromParent_Done,
     /*  610533 */   // Label 9945: @610533
     /*  610533 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(610608), // Rule ID 11207 //
     /*  610538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  610549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  610552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  610555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  610558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610584 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  610584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  610587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610606 */     GIR_RootConstrainSelectedInstOperands,
     /*  610607 */     // GIR_Coverage, 11207,
     /*  610607 */     GIR_EraseRootFromParent_Done,
     /*  610608 */   // Label 9946: @610608
     /*  610608 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(610683), // Rule ID 11210 //
     /*  610613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  610624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  610627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  610630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  610633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610659 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  610659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  610662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610681 */     GIR_RootConstrainSelectedInstOperands,
     /*  610682 */     // GIR_Coverage, 11210,
     /*  610682 */     GIR_EraseRootFromParent_Done,
     /*  610683 */   // Label 9947: @610683
     /*  610683 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(610758), // Rule ID 11211 //
     /*  610688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  610699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  610702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  610705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  610708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  610734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  610737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610756 */     GIR_RootConstrainSelectedInstOperands,
     /*  610757 */     // GIR_Coverage, 11211,
     /*  610757 */     GIR_EraseRootFromParent_Done,
     /*  610758 */   // Label 9948: @610758
     /*  610758 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(610833), // Rule ID 11214 //
     /*  610763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  610774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  610777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  610780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  610783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  610809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  610812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610831 */     GIR_RootConstrainSelectedInstOperands,
     /*  610832 */     // GIR_Coverage, 11214,
     /*  610832 */     GIR_EraseRootFromParent_Done,
     /*  610833 */   // Label 9949: @610833
     /*  610833 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(610908), // Rule ID 11215 //
     /*  610838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  610849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  610852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  610855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  610858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  610884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  610887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610906 */     GIR_RootConstrainSelectedInstOperands,
     /*  610907 */     // GIR_Coverage, 11215,
     /*  610907 */     GIR_EraseRootFromParent_Done,
     /*  610908 */   // Label 9950: @610908
     /*  610908 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(610983), // Rule ID 11218 //
     /*  610913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  610924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  610927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  610930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  610933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  610959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  610962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  610966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  610968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  610970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  610981 */     GIR_RootConstrainSelectedInstOperands,
     /*  610982 */     // GIR_Coverage, 11218,
     /*  610982 */     GIR_EraseRootFromParent_Done,
     /*  610983 */   // Label 9951: @610983
     /*  610983 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(611058), // Rule ID 11219 //
     /*  610988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  610996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  610999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  611002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  611005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  611034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  611037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611056 */     GIR_RootConstrainSelectedInstOperands,
     /*  611057 */     // GIR_Coverage, 11219,
     /*  611057 */     GIR_EraseRootFromParent_Done,
     /*  611058 */   // Label 9952: @611058
     /*  611058 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(611133), // Rule ID 11222 //
     /*  611063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  611074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  611077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  611080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  611109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  611112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611131 */     GIR_RootConstrainSelectedInstOperands,
     /*  611132 */     // GIR_Coverage, 11222,
     /*  611132 */     GIR_EraseRootFromParent_Done,
     /*  611133 */   // Label 9953: @611133
     /*  611133 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(611208), // Rule ID 11223 //
     /*  611138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  611149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  611152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  611155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  611184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  611187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611206 */     GIR_RootConstrainSelectedInstOperands,
     /*  611207 */     // GIR_Coverage, 11223,
     /*  611207 */     GIR_EraseRootFromParent_Done,
     /*  611208 */   // Label 9954: @611208
     /*  611208 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(611283), // Rule ID 11226 //
     /*  611213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  611224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  611227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  611230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  611259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611281 */     GIR_RootConstrainSelectedInstOperands,
     /*  611282 */     // GIR_Coverage, 11226,
     /*  611282 */     GIR_EraseRootFromParent_Done,
     /*  611283 */   // Label 9955: @611283
     /*  611283 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(611358), // Rule ID 11227 //
     /*  611288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  611299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  611302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  611305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  611334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611356 */     GIR_RootConstrainSelectedInstOperands,
     /*  611357 */     // GIR_Coverage, 11227,
     /*  611357 */     GIR_EraseRootFromParent_Done,
     /*  611358 */   // Label 9956: @611358
     /*  611358 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(611433), // Rule ID 11230 //
     /*  611363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  611374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  611377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  611380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  611409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611431 */     GIR_RootConstrainSelectedInstOperands,
     /*  611432 */     // GIR_Coverage, 11230,
     /*  611432 */     GIR_EraseRootFromParent_Done,
     /*  611433 */   // Label 9957: @611433
     /*  611433 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(611508), // Rule ID 11231 //
     /*  611438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  611449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  611452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  611455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  611484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611506 */     GIR_RootConstrainSelectedInstOperands,
     /*  611507 */     // GIR_Coverage, 11231,
     /*  611507 */     GIR_EraseRootFromParent_Done,
     /*  611508 */   // Label 9958: @611508
     /*  611508 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(611583), // Rule ID 11234 //
     /*  611513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  611524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  611527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  611530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  611559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611581 */     GIR_RootConstrainSelectedInstOperands,
     /*  611582 */     // GIR_Coverage, 11234,
     /*  611582 */     GIR_EraseRootFromParent_Done,
     /*  611583 */   // Label 9959: @611583
     /*  611583 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(611658), // Rule ID 11235 //
     /*  611588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  611599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  611602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  611605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  611634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  611637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611656 */     GIR_RootConstrainSelectedInstOperands,
     /*  611657 */     // GIR_Coverage, 11235,
     /*  611657 */     GIR_EraseRootFromParent_Done,
     /*  611658 */   // Label 9960: @611658
     /*  611658 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(611733), // Rule ID 11238 //
     /*  611663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  611674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  611677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  611680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611709 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  611709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  611712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611731 */     GIR_RootConstrainSelectedInstOperands,
     /*  611732 */     // GIR_Coverage, 11238,
     /*  611732 */     GIR_EraseRootFromParent_Done,
     /*  611733 */   // Label 9961: @611733
     /*  611733 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(611808), // Rule ID 11239 //
     /*  611738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  611749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  611752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  611755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  611784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  611787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611806 */     GIR_RootConstrainSelectedInstOperands,
     /*  611807 */     // GIR_Coverage, 11239,
     /*  611807 */     GIR_EraseRootFromParent_Done,
     /*  611808 */   // Label 9962: @611808
     /*  611808 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(611883), // Rule ID 11242 //
     /*  611813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  611824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  611827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  611830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611859 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  611859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  611862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611881 */     GIR_RootConstrainSelectedInstOperands,
     /*  611882 */     // GIR_Coverage, 11242,
     /*  611882 */     GIR_EraseRootFromParent_Done,
     /*  611883 */   // Label 9963: @611883
     /*  611883 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(611958), // Rule ID 11243 //
     /*  611888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  611899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  611902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  611905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  611908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  611934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  611937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  611941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  611943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  611945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  611956 */     GIR_RootConstrainSelectedInstOperands,
     /*  611957 */     // GIR_Coverage, 11243,
     /*  611957 */     GIR_EraseRootFromParent_Done,
     /*  611958 */   // Label 9964: @611958
     /*  611958 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(612033), // Rule ID 11246 //
     /*  611963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  611971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  611974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  611977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  611980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  611983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612009 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  612009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612031 */     GIR_RootConstrainSelectedInstOperands,
     /*  612032 */     // GIR_Coverage, 11246,
     /*  612032 */     GIR_EraseRootFromParent_Done,
     /*  612033 */   // Label 9965: @612033
     /*  612033 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(612108), // Rule ID 11247 //
     /*  612038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  612049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  612052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  612055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  612084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612106 */     GIR_RootConstrainSelectedInstOperands,
     /*  612107 */     // GIR_Coverage, 11247,
     /*  612107 */     GIR_EraseRootFromParent_Done,
     /*  612108 */   // Label 9966: @612108
     /*  612108 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(612183), // Rule ID 11250 //
     /*  612113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  612124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  612127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  612130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  612159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  612162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612181 */     GIR_RootConstrainSelectedInstOperands,
     /*  612182 */     // GIR_Coverage, 11250,
     /*  612182 */     GIR_EraseRootFromParent_Done,
     /*  612183 */   // Label 9967: @612183
     /*  612183 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(612258), // Rule ID 11251 //
     /*  612188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  612199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  612202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  612205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  612234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  612237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612256 */     GIR_RootConstrainSelectedInstOperands,
     /*  612257 */     // GIR_Coverage, 11251,
     /*  612257 */     GIR_EraseRootFromParent_Done,
     /*  612258 */   // Label 9968: @612258
     /*  612258 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(612333), // Rule ID 11254 //
     /*  612263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  612274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  612277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  612280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  612309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  612312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612331 */     GIR_RootConstrainSelectedInstOperands,
     /*  612332 */     // GIR_Coverage, 11254,
     /*  612332 */     GIR_EraseRootFromParent_Done,
     /*  612333 */   // Label 9969: @612333
     /*  612333 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(612408), // Rule ID 11255 //
     /*  612338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  612349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  612352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  612355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  612384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  612387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612406 */     GIR_RootConstrainSelectedInstOperands,
     /*  612407 */     // GIR_Coverage, 11255,
     /*  612407 */     GIR_EraseRootFromParent_Done,
     /*  612408 */   // Label 9970: @612408
     /*  612408 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(612483), // Rule ID 11258 //
     /*  612413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  612424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  612427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  612430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612459 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  612459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612481 */     GIR_RootConstrainSelectedInstOperands,
     /*  612482 */     // GIR_Coverage, 11258,
     /*  612482 */     GIR_EraseRootFromParent_Done,
     /*  612483 */   // Label 9971: @612483
     /*  612483 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(612558), // Rule ID 11259 //
     /*  612488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  612499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  612502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  612505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  612534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612556 */     GIR_RootConstrainSelectedInstOperands,
     /*  612557 */     // GIR_Coverage, 11259,
     /*  612557 */     GIR_EraseRootFromParent_Done,
     /*  612558 */   // Label 9972: @612558
     /*  612558 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(612633), // Rule ID 11262 //
     /*  612563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  612574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  612577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  612580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  612609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  612612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612631 */     GIR_RootConstrainSelectedInstOperands,
     /*  612632 */     // GIR_Coverage, 11262,
     /*  612632 */     GIR_EraseRootFromParent_Done,
     /*  612633 */   // Label 9973: @612633
     /*  612633 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(612708), // Rule ID 11263 //
     /*  612638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  612649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  612652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  612655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  612684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  612687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612706 */     GIR_RootConstrainSelectedInstOperands,
     /*  612707 */     // GIR_Coverage, 11263,
     /*  612707 */     GIR_EraseRootFromParent_Done,
     /*  612708 */   // Label 9974: @612708
     /*  612708 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(612783), // Rule ID 11266 //
     /*  612713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  612724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  612727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  612730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612759 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  612759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  612762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612781 */     GIR_RootConstrainSelectedInstOperands,
     /*  612782 */     // GIR_Coverage, 11266,
     /*  612782 */     GIR_EraseRootFromParent_Done,
     /*  612783 */   // Label 9975: @612783
     /*  612783 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(612858), // Rule ID 11267 //
     /*  612788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  612799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  612802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  612805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  612834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  612837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612856 */     GIR_RootConstrainSelectedInstOperands,
     /*  612857 */     // GIR_Coverage, 11267,
     /*  612857 */     GIR_EraseRootFromParent_Done,
     /*  612858 */   // Label 9976: @612858
     /*  612858 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(612933), // Rule ID 11270 //
     /*  612863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  612874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  612877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  612880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  612883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612909 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  612909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  612931 */     GIR_RootConstrainSelectedInstOperands,
     /*  612932 */     // GIR_Coverage, 11270,
     /*  612932 */     GIR_EraseRootFromParent_Done,
     /*  612933 */   // Label 9977: @612933
     /*  612933 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(613008), // Rule ID 11271 //
     /*  612938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  612946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  612949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  612952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  612955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  612958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  612984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  612987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  612991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  612993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  612995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613006 */     GIR_RootConstrainSelectedInstOperands,
     /*  613007 */     // GIR_Coverage, 11271,
     /*  613007 */     GIR_EraseRootFromParent_Done,
     /*  613008 */   // Label 9978: @613008
     /*  613008 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(613083), // Rule ID 11274 //
     /*  613013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  613024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  613027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  613030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  613033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  613059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  613062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613081 */     GIR_RootConstrainSelectedInstOperands,
     /*  613082 */     // GIR_Coverage, 11274,
     /*  613082 */     GIR_EraseRootFromParent_Done,
     /*  613083 */   // Label 9979: @613083
     /*  613083 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(613158), // Rule ID 11275 //
     /*  613088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  613099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  613102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  613105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  613108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  613134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  613137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613156 */     GIR_RootConstrainSelectedInstOperands,
     /*  613157 */     // GIR_Coverage, 11275,
     /*  613157 */     GIR_EraseRootFromParent_Done,
     /*  613158 */   // Label 9980: @613158
     /*  613158 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(613233), // Rule ID 11278 //
     /*  613163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  613174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  613177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  613180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  613183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  613209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  613212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613231 */     GIR_RootConstrainSelectedInstOperands,
     /*  613232 */     // GIR_Coverage, 11278,
     /*  613232 */     GIR_EraseRootFromParent_Done,
     /*  613233 */   // Label 9981: @613233
     /*  613233 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(613308), // Rule ID 11279 //
     /*  613238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  613249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  613252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  613255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  613258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  613284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  613287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613306 */     GIR_RootConstrainSelectedInstOperands,
     /*  613307 */     // GIR_Coverage, 11279,
     /*  613307 */     GIR_EraseRootFromParent_Done,
     /*  613308 */   // Label 9982: @613308
     /*  613308 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(613383), // Rule ID 11282 //
     /*  613313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  613324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  613327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  613330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  613333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613359 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  613359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613381 */     GIR_RootConstrainSelectedInstOperands,
     /*  613382 */     // GIR_Coverage, 11282,
     /*  613382 */     GIR_EraseRootFromParent_Done,
     /*  613383 */   // Label 9983: @613383
     /*  613383 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(613458), // Rule ID 11283 //
     /*  613388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  613399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  613402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  613405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  613408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  613434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613456 */     GIR_RootConstrainSelectedInstOperands,
     /*  613457 */     // GIR_Coverage, 11283,
     /*  613457 */     GIR_EraseRootFromParent_Done,
     /*  613458 */   // Label 9984: @613458
     /*  613458 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(613533), // Rule ID 11286 //
     /*  613463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  613474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  613477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  613480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  613483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  613509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  613512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613531 */     GIR_RootConstrainSelectedInstOperands,
     /*  613532 */     // GIR_Coverage, 11286,
     /*  613532 */     GIR_EraseRootFromParent_Done,
     /*  613533 */   // Label 9985: @613533
     /*  613533 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(613608), // Rule ID 11287 //
     /*  613538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  613549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  613552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  613555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  613558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  613584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  613587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613606 */     GIR_RootConstrainSelectedInstOperands,
     /*  613607 */     // GIR_Coverage, 11287,
     /*  613607 */     GIR_EraseRootFromParent_Done,
     /*  613608 */   // Label 9986: @613608
     /*  613608 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(613683), // Rule ID 11290 //
     /*  613613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  613624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  613633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  613659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613681 */     GIR_RootConstrainSelectedInstOperands,
     /*  613682 */     // GIR_Coverage, 11290,
     /*  613682 */     GIR_EraseRootFromParent_Done,
     /*  613683 */   // Label 9987: @613683
     /*  613683 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(613758), // Rule ID 11291 //
     /*  613688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  613699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  613708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  613734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613756 */     GIR_RootConstrainSelectedInstOperands,
     /*  613757 */     // GIR_Coverage, 11291,
     /*  613757 */     GIR_EraseRootFromParent_Done,
     /*  613758 */   // Label 9988: @613758
     /*  613758 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(613833), // Rule ID 11294 //
     /*  613763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  613774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  613783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  613809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613831 */     GIR_RootConstrainSelectedInstOperands,
     /*  613832 */     // GIR_Coverage, 11294,
     /*  613832 */     GIR_EraseRootFromParent_Done,
     /*  613833 */   // Label 9989: @613833
     /*  613833 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(613908), // Rule ID 11295 //
     /*  613838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  613849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  613858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  613884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  613887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613906 */     GIR_RootConstrainSelectedInstOperands,
     /*  613907 */     // GIR_Coverage, 11295,
     /*  613907 */     GIR_EraseRootFromParent_Done,
     /*  613908 */   // Label 9990: @613908
     /*  613908 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(613983), // Rule ID 11298 //
     /*  613913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  613924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  613930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  613933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  613959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  613962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  613966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  613968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  613970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  613981 */     GIR_RootConstrainSelectedInstOperands,
     /*  613982 */     // GIR_Coverage, 11298,
     /*  613982 */     GIR_EraseRootFromParent_Done,
     /*  613983 */   // Label 9991: @613983
     /*  613983 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(614058), // Rule ID 11299 //
     /*  613988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  613996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  613999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  614002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  614005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  614008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  614037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614056 */     GIR_RootConstrainSelectedInstOperands,
     /*  614057 */     // GIR_Coverage, 11299,
     /*  614057 */     GIR_EraseRootFromParent_Done,
     /*  614058 */   // Label 9992: @614058
     /*  614058 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(614133), // Rule ID 11302 //
     /*  614063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  614074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  614077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  614080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  614083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  614109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  614112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614131 */     GIR_RootConstrainSelectedInstOperands,
     /*  614132 */     // GIR_Coverage, 11302,
     /*  614132 */     GIR_EraseRootFromParent_Done,
     /*  614133 */   // Label 9993: @614133
     /*  614133 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(614208), // Rule ID 11303 //
     /*  614138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  614149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  614152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  614155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  614158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  614184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  614187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614206 */     GIR_RootConstrainSelectedInstOperands,
     /*  614207 */     // GIR_Coverage, 11303,
     /*  614207 */     GIR_EraseRootFromParent_Done,
     /*  614208 */   // Label 9994: @614208
     /*  614208 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(614283), // Rule ID 11306 //
     /*  614213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  614224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  614227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  614230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  614233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  614259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  614262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614281 */     GIR_RootConstrainSelectedInstOperands,
     /*  614282 */     // GIR_Coverage, 11306,
     /*  614282 */     GIR_EraseRootFromParent_Done,
     /*  614283 */   // Label 9995: @614283
     /*  614283 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(614358), // Rule ID 11307 //
     /*  614288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  614299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  614302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  614305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  614308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  614334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  614337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614356 */     GIR_RootConstrainSelectedInstOperands,
     /*  614357 */     // GIR_Coverage, 11307,
     /*  614357 */     GIR_EraseRootFromParent_Done,
     /*  614358 */   // Label 9996: @614358
     /*  614358 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(614433), // Rule ID 11310 //
     /*  614363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  614374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  614377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  614380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  614383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614409 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  614412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614431 */     GIR_RootConstrainSelectedInstOperands,
     /*  614432 */     // GIR_Coverage, 11310,
     /*  614432 */     GIR_EraseRootFromParent_Done,
     /*  614433 */   // Label 9997: @614433
     /*  614433 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(614508), // Rule ID 11311 //
     /*  614438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  614449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  614452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  614455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  614458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  614487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614506 */     GIR_RootConstrainSelectedInstOperands,
     /*  614507 */     // GIR_Coverage, 11311,
     /*  614507 */     GIR_EraseRootFromParent_Done,
     /*  614508 */   // Label 9998: @614508
     /*  614508 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(614583), // Rule ID 11314 //
     /*  614513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  614524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  614533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614559 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  614562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614581 */     GIR_RootConstrainSelectedInstOperands,
     /*  614582 */     // GIR_Coverage, 11314,
     /*  614582 */     GIR_EraseRootFromParent_Done,
     /*  614583 */   // Label 9999: @614583
     /*  614583 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(614658), // Rule ID 11315 //
     /*  614588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  614599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  614608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  614637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614656 */     GIR_RootConstrainSelectedInstOperands,
     /*  614657 */     // GIR_Coverage, 11315,
     /*  614657 */     GIR_EraseRootFromParent_Done,
     /*  614658 */   // Label 10000: @614658
     /*  614658 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(614733), // Rule ID 11318 //
     /*  614663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  614674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  614683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614709 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  614712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614731 */     GIR_RootConstrainSelectedInstOperands,
     /*  614732 */     // GIR_Coverage, 11318,
     /*  614732 */     GIR_EraseRootFromParent_Done,
     /*  614733 */   // Label 10001: @614733
     /*  614733 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(614808), // Rule ID 11319 //
     /*  614738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  614749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  614758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614784 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  614787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614806 */     GIR_RootConstrainSelectedInstOperands,
     /*  614807 */     // GIR_Coverage, 11319,
     /*  614807 */     GIR_EraseRootFromParent_Done,
     /*  614808 */   // Label 10002: @614808
     /*  614808 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(614883), // Rule ID 11322 //
     /*  614813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  614824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  614833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  614859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  614862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614881 */     GIR_RootConstrainSelectedInstOperands,
     /*  614882 */     // GIR_Coverage, 11322,
     /*  614882 */     GIR_EraseRootFromParent_Done,
     /*  614883 */   // Label 10003: @614883
     /*  614883 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(614958), // Rule ID 11323 //
     /*  614888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  614899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  614908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  614934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  614937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614956 */     GIR_RootConstrainSelectedInstOperands,
     /*  614957 */     // GIR_Coverage, 11323,
     /*  614957 */     GIR_EraseRootFromParent_Done,
     /*  614958 */   // Label 10004: @614958
     /*  614958 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(615033), // Rule ID 11326 //
     /*  614963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  614971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  614974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  614980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  614983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615009 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  615012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615031 */     GIR_RootConstrainSelectedInstOperands,
     /*  615032 */     // GIR_Coverage, 11326,
     /*  615032 */     GIR_EraseRootFromParent_Done,
     /*  615033 */   // Label 10005: @615033
     /*  615033 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(615108), // Rule ID 11327 //
     /*  615038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  615049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  615052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  615055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  615058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  615087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615106 */     GIR_RootConstrainSelectedInstOperands,
     /*  615107 */     // GIR_Coverage, 11327,
     /*  615107 */     GIR_EraseRootFromParent_Done,
     /*  615108 */   // Label 10006: @615108
     /*  615108 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(615183), // Rule ID 11330 //
     /*  615113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  615124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  615127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  615130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  615133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615159 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  615162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615181 */     GIR_RootConstrainSelectedInstOperands,
     /*  615182 */     // GIR_Coverage, 11330,
     /*  615182 */     GIR_EraseRootFromParent_Done,
     /*  615183 */   // Label 10007: @615183
     /*  615183 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(615258), // Rule ID 11331 //
     /*  615188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  615199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  615202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  615205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  615208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  615237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615256 */     GIR_RootConstrainSelectedInstOperands,
     /*  615257 */     // GIR_Coverage, 11331,
     /*  615257 */     GIR_EraseRootFromParent_Done,
     /*  615258 */   // Label 10008: @615258
     /*  615258 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(615333), // Rule ID 11334 //
     /*  615263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  615274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  615277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  615280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  615283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  615312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615331 */     GIR_RootConstrainSelectedInstOperands,
     /*  615332 */     // GIR_Coverage, 11334,
     /*  615332 */     GIR_EraseRootFromParent_Done,
     /*  615333 */   // Label 10009: @615333
     /*  615333 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(615408), // Rule ID 11335 //
     /*  615338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  615349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  615352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  615355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  615358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  615387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615406 */     GIR_RootConstrainSelectedInstOperands,
     /*  615407 */     // GIR_Coverage, 11335,
     /*  615407 */     GIR_EraseRootFromParent_Done,
     /*  615408 */   // Label 10010: @615408
     /*  615408 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(615483), // Rule ID 11338 //
     /*  615413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  615424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  615427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  615430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  615433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  615462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615481 */     GIR_RootConstrainSelectedInstOperands,
     /*  615482 */     // GIR_Coverage, 11338,
     /*  615482 */     GIR_EraseRootFromParent_Done,
     /*  615483 */   // Label 10011: @615483
     /*  615483 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(615558), // Rule ID 11339 //
     /*  615488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  615499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  615502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  615505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  615508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  615537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615556 */     GIR_RootConstrainSelectedInstOperands,
     /*  615557 */     // GIR_Coverage, 11339,
     /*  615557 */     GIR_EraseRootFromParent_Done,
     /*  615558 */   // Label 10012: @615558
     /*  615558 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(615633), // Rule ID 11342 //
     /*  615563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  615574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  615583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615609 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  615612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615631 */     GIR_RootConstrainSelectedInstOperands,
     /*  615632 */     // GIR_Coverage, 11342,
     /*  615632 */     GIR_EraseRootFromParent_Done,
     /*  615633 */   // Label 10013: @615633
     /*  615633 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(615708), // Rule ID 11343 //
     /*  615638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  615649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  615658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  615687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615706 */     GIR_RootConstrainSelectedInstOperands,
     /*  615707 */     // GIR_Coverage, 11343,
     /*  615707 */     GIR_EraseRootFromParent_Done,
     /*  615708 */   // Label 10014: @615708
     /*  615708 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(615783), // Rule ID 11346 //
     /*  615713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  615733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  615762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615781 */     GIR_RootConstrainSelectedInstOperands,
     /*  615782 */     // GIR_Coverage, 11346,
     /*  615782 */     GIR_EraseRootFromParent_Done,
     /*  615783 */   // Label 10015: @615783
     /*  615783 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(615858), // Rule ID 11347 //
     /*  615788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  615808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615834 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  615837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615856 */     GIR_RootConstrainSelectedInstOperands,
     /*  615857 */     // GIR_Coverage, 11347,
     /*  615857 */     GIR_EraseRootFromParent_Done,
     /*  615858 */   // Label 10016: @615858
     /*  615858 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(615933), // Rule ID 11350 //
     /*  615863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  615883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615909 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  615912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615931 */     GIR_RootConstrainSelectedInstOperands,
     /*  615932 */     // GIR_Coverage, 11350,
     /*  615932 */     GIR_EraseRootFromParent_Done,
     /*  615933 */   // Label 10017: @615933
     /*  615933 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(616008), // Rule ID 11351 //
     /*  615938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  615946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  615958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  615987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616006 */     GIR_RootConstrainSelectedInstOperands,
     /*  616007 */     // GIR_Coverage, 11351,
     /*  616007 */     GIR_EraseRootFromParent_Done,
     /*  616008 */   // Label 10018: @616008
     /*  616008 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(616083), // Rule ID 11354 //
     /*  616013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  616024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  616027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  616030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616059 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616081 */     GIR_RootConstrainSelectedInstOperands,
     /*  616082 */     // GIR_Coverage, 11354,
     /*  616082 */     GIR_EraseRootFromParent_Done,
     /*  616083 */   // Label 10019: @616083
     /*  616083 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(616158), // Rule ID 11355 //
     /*  616088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  616099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  616102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  616105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616156 */     GIR_RootConstrainSelectedInstOperands,
     /*  616157 */     // GIR_Coverage, 11355,
     /*  616157 */     GIR_EraseRootFromParent_Done,
     /*  616158 */   // Label 10020: @616158
     /*  616158 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(616233), // Rule ID 11358 //
     /*  616163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  616174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  616180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  616212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616231 */     GIR_RootConstrainSelectedInstOperands,
     /*  616232 */     // GIR_Coverage, 11358,
     /*  616232 */     GIR_EraseRootFromParent_Done,
     /*  616233 */   // Label 10021: @616233
     /*  616233 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(616308), // Rule ID 11359 //
     /*  616238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  616249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  616255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  616287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616306 */     GIR_RootConstrainSelectedInstOperands,
     /*  616307 */     // GIR_Coverage, 11359,
     /*  616307 */     GIR_EraseRootFromParent_Done,
     /*  616308 */   // Label 10022: @616308
     /*  616308 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(616383), // Rule ID 11362 //
     /*  616313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616381 */     GIR_RootConstrainSelectedInstOperands,
     /*  616382 */     // GIR_Coverage, 11362,
     /*  616382 */     GIR_EraseRootFromParent_Done,
     /*  616383 */   // Label 10023: @616383
     /*  616383 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(616458), // Rule ID 11363 //
     /*  616388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616456 */     GIR_RootConstrainSelectedInstOperands,
     /*  616457 */     // GIR_Coverage, 11363,
     /*  616457 */     GIR_EraseRootFromParent_Done,
     /*  616458 */   // Label 10024: @616458
     /*  616458 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(616533), // Rule ID 11366 //
     /*  616463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616531 */     GIR_RootConstrainSelectedInstOperands,
     /*  616532 */     // GIR_Coverage, 11366,
     /*  616532 */     GIR_EraseRootFromParent_Done,
     /*  616533 */   // Label 10025: @616533
     /*  616533 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(616608), // Rule ID 11367 //
     /*  616538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  616587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616606 */     GIR_RootConstrainSelectedInstOperands,
     /*  616607 */     // GIR_Coverage, 11367,
     /*  616607 */     GIR_EraseRootFromParent_Done,
     /*  616608 */   // Label 10026: @616608
     /*  616608 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(616683), // Rule ID 11370 //
     /*  616613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  616662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616681 */     GIR_RootConstrainSelectedInstOperands,
     /*  616682 */     // GIR_Coverage, 11370,
     /*  616682 */     GIR_EraseRootFromParent_Done,
     /*  616683 */   // Label 10027: @616683
     /*  616683 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(616758), // Rule ID 11371 //
     /*  616688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  616737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616756 */     GIR_RootConstrainSelectedInstOperands,
     /*  616757 */     // GIR_Coverage, 11371,
     /*  616757 */     GIR_EraseRootFromParent_Done,
     /*  616758 */   // Label 10028: @616758
     /*  616758 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(616833), // Rule ID 11374 //
     /*  616763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  616812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616831 */     GIR_RootConstrainSelectedInstOperands,
     /*  616832 */     // GIR_Coverage, 11374,
     /*  616832 */     GIR_EraseRootFromParent_Done,
     /*  616833 */   // Label 10029: @616833
     /*  616833 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(616908), // Rule ID 11375 //
     /*  616838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  616858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  616887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616906 */     GIR_RootConstrainSelectedInstOperands,
     /*  616907 */     // GIR_Coverage, 11375,
     /*  616907 */     GIR_EraseRootFromParent_Done,
     /*  616908 */   // Label 10030: @616908
     /*  616908 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(616983), // Rule ID 11378 //
     /*  616913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  616933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  616962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616981 */     GIR_RootConstrainSelectedInstOperands,
     /*  616982 */     // GIR_Coverage, 11378,
     /*  616982 */     GIR_EraseRootFromParent_Done,
     /*  616983 */   // Label 10031: @616983
     /*  616983 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(617058), // Rule ID 11379 //
     /*  616988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  616996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  617002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  617005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  617037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617056 */     GIR_RootConstrainSelectedInstOperands,
     /*  617057 */     // GIR_Coverage, 11379,
     /*  617057 */     GIR_EraseRootFromParent_Done,
     /*  617058 */   // Label 10032: @617058
     /*  617058 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(617133), // Rule ID 11382 //
     /*  617063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  617074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  617080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  617112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617131 */     GIR_RootConstrainSelectedInstOperands,
     /*  617132 */     // GIR_Coverage, 11382,
     /*  617132 */     GIR_EraseRootFromParent_Done,
     /*  617133 */   // Label 10033: @617133
     /*  617133 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(617208), // Rule ID 11383 //
     /*  617138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  617149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  617155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  617187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617206 */     GIR_RootConstrainSelectedInstOperands,
     /*  617207 */     // GIR_Coverage, 11383,
     /*  617207 */     GIR_EraseRootFromParent_Done,
     /*  617208 */   // Label 10034: @617208
     /*  617208 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(617283), // Rule ID 11386 //
     /*  617213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617259 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  617262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617281 */     GIR_RootConstrainSelectedInstOperands,
     /*  617282 */     // GIR_Coverage, 11386,
     /*  617282 */     GIR_EraseRootFromParent_Done,
     /*  617283 */   // Label 10035: @617283
     /*  617283 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(617358), // Rule ID 11387 //
     /*  617288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  617337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617356 */     GIR_RootConstrainSelectedInstOperands,
     /*  617357 */     // GIR_Coverage, 11387,
     /*  617357 */     GIR_EraseRootFromParent_Done,
     /*  617358 */   // Label 10036: @617358
     /*  617358 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(617433), // Rule ID 11390 //
     /*  617363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617409 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  617412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617431 */     GIR_RootConstrainSelectedInstOperands,
     /*  617432 */     // GIR_Coverage, 11390,
     /*  617432 */     GIR_EraseRootFromParent_Done,
     /*  617433 */   // Label 10037: @617433
     /*  617433 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(617508), // Rule ID 11391 //
     /*  617438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  617487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617506 */     GIR_RootConstrainSelectedInstOperands,
     /*  617507 */     // GIR_Coverage, 11391,
     /*  617507 */     GIR_EraseRootFromParent_Done,
     /*  617508 */   // Label 10038: @617508
     /*  617508 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(617583), // Rule ID 11394 //
     /*  617513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  617562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617581 */     GIR_RootConstrainSelectedInstOperands,
     /*  617582 */     // GIR_Coverage, 11394,
     /*  617582 */     GIR_EraseRootFromParent_Done,
     /*  617583 */   // Label 10039: @617583
     /*  617583 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(617658), // Rule ID 11395 //
     /*  617588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  617637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617656 */     GIR_RootConstrainSelectedInstOperands,
     /*  617657 */     // GIR_Coverage, 11395,
     /*  617657 */     GIR_EraseRootFromParent_Done,
     /*  617658 */   // Label 10040: @617658
     /*  617658 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(617733), // Rule ID 11398 //
     /*  617663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617709 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  617712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617731 */     GIR_RootConstrainSelectedInstOperands,
     /*  617732 */     // GIR_Coverage, 11398,
     /*  617732 */     GIR_EraseRootFromParent_Done,
     /*  617733 */   // Label 10041: @617733
     /*  617733 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(617808), // Rule ID 11399 //
     /*  617738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  617787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617806 */     GIR_RootConstrainSelectedInstOperands,
     /*  617807 */     // GIR_Coverage, 11399,
     /*  617807 */     GIR_EraseRootFromParent_Done,
     /*  617808 */   // Label 10042: @617808
     /*  617808 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(617883), // Rule ID 11402 //
     /*  617813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617859 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  617862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617881 */     GIR_RootConstrainSelectedInstOperands,
     /*  617882 */     // GIR_Coverage, 11402,
     /*  617882 */     GIR_EraseRootFromParent_Done,
     /*  617883 */   // Label 10043: @617883
     /*  617883 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(617958), // Rule ID 11403 //
     /*  617888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  617937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617956 */     GIR_RootConstrainSelectedInstOperands,
     /*  617957 */     // GIR_Coverage, 11403,
     /*  617957 */     GIR_EraseRootFromParent_Done,
     /*  617958 */   // Label 10044: @617958
     /*  617958 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(618033), // Rule ID 11406 //
     /*  617963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  617971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  618012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618031 */     GIR_RootConstrainSelectedInstOperands,
     /*  618032 */     // GIR_Coverage, 11406,
     /*  618032 */     GIR_EraseRootFromParent_Done,
     /*  618033 */   // Label 10045: @618033
     /*  618033 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(618108), // Rule ID 11407 //
     /*  618038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  618046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  618049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  618052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  618055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  618087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618106 */     GIR_RootConstrainSelectedInstOperands,
     /*  618107 */     // GIR_Coverage, 11407,
     /*  618107 */     GIR_EraseRootFromParent_Done,
     /*  618108 */   // Label 10046: @618108
     /*  618108 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(618183), // Rule ID 11410 //
     /*  618113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  618121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618159 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  618162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618181 */     GIR_RootConstrainSelectedInstOperands,
     /*  618182 */     // GIR_Coverage, 11410,
     /*  618182 */     GIR_EraseRootFromParent_Done,
     /*  618183 */   // Label 10047: @618183
     /*  618183 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(618258), // Rule ID 11411 //
     /*  618188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  618196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  618237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618256 */     GIR_RootConstrainSelectedInstOperands,
     /*  618257 */     // GIR_Coverage, 11411,
     /*  618257 */     GIR_EraseRootFromParent_Done,
     /*  618258 */   // Label 10048: @618258
     /*  618258 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(618333), // Rule ID 11414 //
     /*  618263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  618271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618309 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  618312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618331 */     GIR_RootConstrainSelectedInstOperands,
     /*  618332 */     // GIR_Coverage, 11414,
     /*  618332 */     GIR_EraseRootFromParent_Done,
     /*  618333 */   // Label 10049: @618333
     /*  618333 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(618408), // Rule ID 11415 //
     /*  618338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  618346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  618387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618406 */     GIR_RootConstrainSelectedInstOperands,
     /*  618407 */     // GIR_Coverage, 11415,
     /*  618407 */     GIR_EraseRootFromParent_Done,
     /*  618408 */   // Label 10050: @618408
     /*  618408 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(618483), // Rule ID 11418 //
     /*  618413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  618416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  618424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  618427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  618430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  618433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618459 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  618462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618481 */     GIR_RootConstrainSelectedInstOperands,
     /*  618482 */     // GIR_Coverage, 11418,
     /*  618482 */     GIR_EraseRootFromParent_Done,
     /*  618483 */   // Label 10051: @618483
     /*  618483 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(618558), // Rule ID 11419 //
     /*  618488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  618491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  618499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  618502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  618505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  618508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  618537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618556 */     GIR_RootConstrainSelectedInstOperands,
     /*  618557 */     // GIR_Coverage, 11419,
     /*  618557 */     GIR_EraseRootFromParent_Done,
     /*  618558 */   // Label 10052: @618558
     /*  618558 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(618633), // Rule ID 11422 //
     /*  618563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  618566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  618612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618631 */     GIR_RootConstrainSelectedInstOperands,
     /*  618632 */     // GIR_Coverage, 11422,
     /*  618632 */     GIR_EraseRootFromParent_Done,
     /*  618633 */   // Label 10053: @618633
     /*  618633 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(618708), // Rule ID 11423 //
     /*  618638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  618641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  618687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618706 */     GIR_RootConstrainSelectedInstOperands,
     /*  618707 */     // GIR_Coverage, 11423,
     /*  618707 */     GIR_EraseRootFromParent_Done,
     /*  618708 */   // Label 10054: @618708
     /*  618708 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(618783), // Rule ID 11426 //
     /*  618713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  618716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  618762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618781 */     GIR_RootConstrainSelectedInstOperands,
     /*  618782 */     // GIR_Coverage, 11426,
     /*  618782 */     GIR_EraseRootFromParent_Done,
     /*  618783 */   // Label 10055: @618783
     /*  618783 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(618858), // Rule ID 11427 //
     /*  618788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  618791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  618837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618856 */     GIR_RootConstrainSelectedInstOperands,
     /*  618857 */     // GIR_Coverage, 11427,
     /*  618857 */     GIR_EraseRootFromParent_Done,
     /*  618858 */   // Label 10056: @618858
     /*  618858 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(618933), // Rule ID 11430 //
     /*  618863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  618866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  618912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618931 */     GIR_RootConstrainSelectedInstOperands,
     /*  618932 */     // GIR_Coverage, 11430,
     /*  618932 */     GIR_EraseRootFromParent_Done,
     /*  618933 */   // Label 10057: @618933
     /*  618933 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(619008), // Rule ID 11431 //
     /*  618938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  618941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  618946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  618987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619006 */     GIR_RootConstrainSelectedInstOperands,
     /*  619007 */     // GIR_Coverage, 11431,
     /*  619007 */     GIR_EraseRootFromParent_Done,
     /*  619008 */   // Label 10058: @619008
     /*  619008 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(619083), // Rule ID 11434 //
     /*  619013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  619062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619081 */     GIR_RootConstrainSelectedInstOperands,
     /*  619082 */     // GIR_Coverage, 11434,
     /*  619082 */     GIR_EraseRootFromParent_Done,
     /*  619083 */   // Label 10059: @619083
     /*  619083 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(619158), // Rule ID 11435 //
     /*  619088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619134 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  619137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619156 */     GIR_RootConstrainSelectedInstOperands,
     /*  619157 */     // GIR_Coverage, 11435,
     /*  619157 */     GIR_EraseRootFromParent_Done,
     /*  619158 */   // Label 10060: @619158
     /*  619158 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(619233), // Rule ID 11438 //
     /*  619163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  619174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  619177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  619180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  619212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619231 */     GIR_RootConstrainSelectedInstOperands,
     /*  619232 */     // GIR_Coverage, 11438,
     /*  619232 */     GIR_EraseRootFromParent_Done,
     /*  619233 */   // Label 10061: @619233
     /*  619233 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(619308), // Rule ID 11439 //
     /*  619238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  619249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  619252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  619255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  619287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619306 */     GIR_RootConstrainSelectedInstOperands,
     /*  619307 */     // GIR_Coverage, 11439,
     /*  619307 */     GIR_EraseRootFromParent_Done,
     /*  619308 */   // Label 10062: @619308
     /*  619308 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(619383), // Rule ID 11442 //
     /*  619313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  619324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  619327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  619330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  619362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619381 */     GIR_RootConstrainSelectedInstOperands,
     /*  619382 */     // GIR_Coverage, 11442,
     /*  619382 */     GIR_EraseRootFromParent_Done,
     /*  619383 */   // Label 10063: @619383
     /*  619383 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(619458), // Rule ID 11443 //
     /*  619388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  619399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  619402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  619405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  619437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619456 */     GIR_RootConstrainSelectedInstOperands,
     /*  619457 */     // GIR_Coverage, 11443,
     /*  619457 */     GIR_EraseRootFromParent_Done,
     /*  619458 */   // Label 10064: @619458
     /*  619458 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(619533), // Rule ID 11446 //
     /*  619463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  619474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  619477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  619480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  619512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619531 */     GIR_RootConstrainSelectedInstOperands,
     /*  619532 */     // GIR_Coverage, 11446,
     /*  619532 */     GIR_EraseRootFromParent_Done,
     /*  619533 */   // Label 10065: @619533
     /*  619533 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(619608), // Rule ID 11447 //
     /*  619538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  619546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  619549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  619552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  619555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  619587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619606 */     GIR_RootConstrainSelectedInstOperands,
     /*  619607 */     // GIR_Coverage, 11447,
     /*  619607 */     GIR_EraseRootFromParent_Done,
     /*  619608 */   // Label 10066: @619608
     /*  619608 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(619683), // Rule ID 11450 //
     /*  619613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  619633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619659 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  619662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619681 */     GIR_RootConstrainSelectedInstOperands,
     /*  619682 */     // GIR_Coverage, 11450,
     /*  619682 */     GIR_EraseRootFromParent_Done,
     /*  619683 */   // Label 10067: @619683
     /*  619683 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(619758), // Rule ID 11451 //
     /*  619688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  619708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  619737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619756 */     GIR_RootConstrainSelectedInstOperands,
     /*  619757 */     // GIR_Coverage, 11451,
     /*  619757 */     GIR_EraseRootFromParent_Done,
     /*  619758 */   // Label 10068: @619758
     /*  619758 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(619833), // Rule ID 11454 //
     /*  619763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  619774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  619777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  619780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  619783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  619812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619831 */     GIR_RootConstrainSelectedInstOperands,
     /*  619832 */     // GIR_Coverage, 11454,
     /*  619832 */     GIR_EraseRootFromParent_Done,
     /*  619833 */   // Label 10069: @619833
     /*  619833 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(619908), // Rule ID 11455 //
     /*  619838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  619849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  619852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  619855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  619858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  619887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619906 */     GIR_RootConstrainSelectedInstOperands,
     /*  619907 */     // GIR_Coverage, 11455,
     /*  619907 */     GIR_EraseRootFromParent_Done,
     /*  619908 */   // Label 10070: @619908
     /*  619908 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(619983), // Rule ID 11458 //
     /*  619913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  619916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  619924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  619927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  619930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  619933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  619962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619981 */     GIR_RootConstrainSelectedInstOperands,
     /*  619982 */     // GIR_Coverage, 11458,
     /*  619982 */     GIR_EraseRootFromParent_Done,
     /*  619983 */   // Label 10071: @619983
     /*  619983 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(620058), // Rule ID 11459 //
     /*  619988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  619991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  619996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  619999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  620002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  620005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  620008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  620037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620056 */     GIR_RootConstrainSelectedInstOperands,
     /*  620057 */     // GIR_Coverage, 11459,
     /*  620057 */     GIR_EraseRootFromParent_Done,
     /*  620058 */   // Label 10072: @620058
     /*  620058 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(620133), // Rule ID 11462 //
     /*  620063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  620074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  620077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  620080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  620083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  620112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620131 */     GIR_RootConstrainSelectedInstOperands,
     /*  620132 */     // GIR_Coverage, 11462,
     /*  620132 */     GIR_EraseRootFromParent_Done,
     /*  620133 */   // Label 10073: @620133
     /*  620133 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(620208), // Rule ID 11463 //
     /*  620138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  620149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  620152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  620155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  620158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  620187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620206 */     GIR_RootConstrainSelectedInstOperands,
     /*  620207 */     // GIR_Coverage, 11463,
     /*  620207 */     GIR_EraseRootFromParent_Done,
     /*  620208 */   // Label 10074: @620208
     /*  620208 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(620283), // Rule ID 11466 //
     /*  620213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  620262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620281 */     GIR_RootConstrainSelectedInstOperands,
     /*  620282 */     // GIR_Coverage, 11466,
     /*  620282 */     GIR_EraseRootFromParent_Done,
     /*  620283 */   // Label 10075: @620283
     /*  620283 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(620358), // Rule ID 11467 //
     /*  620288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  620337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620356 */     GIR_RootConstrainSelectedInstOperands,
     /*  620357 */     // GIR_Coverage, 11467,
     /*  620357 */     GIR_EraseRootFromParent_Done,
     /*  620358 */   // Label 10076: @620358
     /*  620358 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(620433), // Rule ID 11470 //
     /*  620363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  620374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  620377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  620380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  620412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620431 */     GIR_RootConstrainSelectedInstOperands,
     /*  620432 */     // GIR_Coverage, 11470,
     /*  620432 */     GIR_EraseRootFromParent_Done,
     /*  620433 */   // Label 10077: @620433
     /*  620433 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(620508), // Rule ID 11471 //
     /*  620438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  620449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  620452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  620455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  620487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620506 */     GIR_RootConstrainSelectedInstOperands,
     /*  620507 */     // GIR_Coverage, 11471,
     /*  620507 */     GIR_EraseRootFromParent_Done,
     /*  620508 */   // Label 10078: @620508
     /*  620508 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(620583), // Rule ID 11474 //
     /*  620513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  620524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  620527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  620530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  620562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620581 */     GIR_RootConstrainSelectedInstOperands,
     /*  620582 */     // GIR_Coverage, 11474,
     /*  620582 */     GIR_EraseRootFromParent_Done,
     /*  620583 */   // Label 10079: @620583
     /*  620583 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(620658), // Rule ID 11475 //
     /*  620588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  620599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  620602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  620605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  620637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620656 */     GIR_RootConstrainSelectedInstOperands,
     /*  620657 */     // GIR_Coverage, 11475,
     /*  620657 */     GIR_EraseRootFromParent_Done,
     /*  620658 */   // Label 10080: @620658
     /*  620658 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(620733), // Rule ID 11478 //
     /*  620663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  620674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  620677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  620680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  620712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620731 */     GIR_RootConstrainSelectedInstOperands,
     /*  620732 */     // GIR_Coverage, 11478,
     /*  620732 */     GIR_EraseRootFromParent_Done,
     /*  620733 */   // Label 10081: @620733
     /*  620733 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(620808), // Rule ID 11479 //
     /*  620738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  620746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  620749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  620752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  620755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  620787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620806 */     GIR_RootConstrainSelectedInstOperands,
     /*  620807 */     // GIR_Coverage, 11479,
     /*  620807 */     GIR_EraseRootFromParent_Done,
     /*  620808 */   // Label 10082: @620808
     /*  620808 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(620883), // Rule ID 11482 //
     /*  620813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  620821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620859 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  620862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620881 */     GIR_RootConstrainSelectedInstOperands,
     /*  620882 */     // GIR_Coverage, 11482,
     /*  620882 */     GIR_EraseRootFromParent_Done,
     /*  620883 */   // Label 10083: @620883
     /*  620883 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(620958), // Rule ID 11483 //
     /*  620888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  620891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  620896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  620937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620956 */     GIR_RootConstrainSelectedInstOperands,
     /*  620957 */     // GIR_Coverage, 11483,
     /*  620957 */     GIR_EraseRootFromParent_Done,
     /*  620958 */   // Label 10084: @620958
     /*  620958 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(621033), // Rule ID 11486 //
     /*  620963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  620966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  620971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  620974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  620977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  620980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  620983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  621012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621031 */     GIR_RootConstrainSelectedInstOperands,
     /*  621032 */     // GIR_Coverage, 11486,
     /*  621032 */     GIR_EraseRootFromParent_Done,
     /*  621033 */   // Label 10085: @621033
     /*  621033 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(621108), // Rule ID 11487 //
     /*  621038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  621058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  621087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621106 */     GIR_RootConstrainSelectedInstOperands,
     /*  621107 */     // GIR_Coverage, 11487,
     /*  621107 */     GIR_EraseRootFromParent_Done,
     /*  621108 */   // Label 10086: @621108
     /*  621108 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(621183), // Rule ID 11490 //
     /*  621113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  621162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621181 */     GIR_RootConstrainSelectedInstOperands,
     /*  621182 */     // GIR_Coverage, 11490,
     /*  621182 */     GIR_EraseRootFromParent_Done,
     /*  621183 */   // Label 10087: @621183
     /*  621183 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(621258), // Rule ID 11491 //
     /*  621188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  621237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621256 */     GIR_RootConstrainSelectedInstOperands,
     /*  621257 */     // GIR_Coverage, 11491,
     /*  621257 */     GIR_EraseRootFromParent_Done,
     /*  621258 */   // Label 10088: @621258
     /*  621258 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(621333), // Rule ID 11494 //
     /*  621263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  621283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  621312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621331 */     GIR_RootConstrainSelectedInstOperands,
     /*  621332 */     // GIR_Coverage, 11494,
     /*  621332 */     GIR_EraseRootFromParent_Done,
     /*  621333 */   // Label 10089: @621333
     /*  621333 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(621408), // Rule ID 11495 //
     /*  621338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  621358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  621387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621406 */     GIR_RootConstrainSelectedInstOperands,
     /*  621407 */     // GIR_Coverage, 11495,
     /*  621407 */     GIR_EraseRootFromParent_Done,
     /*  621408 */   // Label 10090: @621408
     /*  621408 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(621483), // Rule ID 11498 //
     /*  621413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  621424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  621427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  621430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621459 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  621462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621481 */     GIR_RootConstrainSelectedInstOperands,
     /*  621482 */     // GIR_Coverage, 11498,
     /*  621482 */     GIR_EraseRootFromParent_Done,
     /*  621483 */   // Label 10091: @621483
     /*  621483 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(621558), // Rule ID 11499 //
     /*  621488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  621499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  621502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  621505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  621537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621556 */     GIR_RootConstrainSelectedInstOperands,
     /*  621557 */     // GIR_Coverage, 11499,
     /*  621557 */     GIR_EraseRootFromParent_Done,
     /*  621558 */   // Label 10092: @621558
     /*  621558 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(621633), // Rule ID 11502 //
     /*  621563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  621612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621631 */     GIR_RootConstrainSelectedInstOperands,
     /*  621632 */     // GIR_Coverage, 11502,
     /*  621632 */     GIR_EraseRootFromParent_Done,
     /*  621633 */   // Label 10093: @621633
     /*  621633 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(621708), // Rule ID 11503 //
     /*  621638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  621687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621706 */     GIR_RootConstrainSelectedInstOperands,
     /*  621707 */     // GIR_Coverage, 11503,
     /*  621707 */     GIR_EraseRootFromParent_Done,
     /*  621708 */   // Label 10094: @621708
     /*  621708 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(621783), // Rule ID 11506 //
     /*  621713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  621762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621781 */     GIR_RootConstrainSelectedInstOperands,
     /*  621782 */     // GIR_Coverage, 11506,
     /*  621782 */     GIR_EraseRootFromParent_Done,
     /*  621783 */   // Label 10095: @621783
     /*  621783 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(621858), // Rule ID 11507 //
     /*  621788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  621837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621856 */     GIR_RootConstrainSelectedInstOperands,
     /*  621857 */     // GIR_Coverage, 11507,
     /*  621857 */     GIR_EraseRootFromParent_Done,
     /*  621858 */   // Label 10096: @621858
     /*  621858 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(621933), // Rule ID 11510 //
     /*  621863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  621866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  621912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621931 */     GIR_RootConstrainSelectedInstOperands,
     /*  621932 */     // GIR_Coverage, 11510,
     /*  621932 */     GIR_EraseRootFromParent_Done,
     /*  621933 */   // Label 10097: @621933
     /*  621933 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(622008), // Rule ID 11511 //
     /*  621938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  621941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  621946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  621987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622006 */     GIR_RootConstrainSelectedInstOperands,
     /*  622007 */     // GIR_Coverage, 11511,
     /*  622007 */     GIR_EraseRootFromParent_Done,
     /*  622008 */   // Label 10098: @622008
     /*  622008 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(622083), // Rule ID 11514 //
     /*  622013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  622062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622081 */     GIR_RootConstrainSelectedInstOperands,
     /*  622082 */     // GIR_Coverage, 11514,
     /*  622082 */     GIR_EraseRootFromParent_Done,
     /*  622083 */   // Label 10099: @622083
     /*  622083 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(622158), // Rule ID 11515 //
     /*  622088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  622137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622156 */     GIR_RootConstrainSelectedInstOperands,
     /*  622157 */     // GIR_Coverage, 11515,
     /*  622157 */     GIR_EraseRootFromParent_Done,
     /*  622158 */   // Label 10100: @622158
     /*  622158 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(622233), // Rule ID 11518 //
     /*  622163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  622212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622231 */     GIR_RootConstrainSelectedInstOperands,
     /*  622232 */     // GIR_Coverage, 11518,
     /*  622232 */     GIR_EraseRootFromParent_Done,
     /*  622233 */   // Label 10101: @622233
     /*  622233 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(622308), // Rule ID 11519 //
     /*  622238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  622287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622306 */     GIR_RootConstrainSelectedInstOperands,
     /*  622307 */     // GIR_Coverage, 11519,
     /*  622307 */     GIR_EraseRootFromParent_Done,
     /*  622308 */   // Label 10102: @622308
     /*  622308 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(622383), // Rule ID 11522 //
     /*  622313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622359 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  622362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622381 */     GIR_RootConstrainSelectedInstOperands,
     /*  622382 */     // GIR_Coverage, 11522,
     /*  622382 */     GIR_EraseRootFromParent_Done,
     /*  622383 */   // Label 10103: @622383
     /*  622383 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(622458), // Rule ID 11523 //
     /*  622388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  622437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622456 */     GIR_RootConstrainSelectedInstOperands,
     /*  622457 */     // GIR_Coverage, 11523,
     /*  622457 */     GIR_EraseRootFromParent_Done,
     /*  622458 */   // Label 10104: @622458
     /*  622458 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(622533), // Rule ID 11526 //
     /*  622463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  622512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622531 */     GIR_RootConstrainSelectedInstOperands,
     /*  622532 */     // GIR_Coverage, 11526,
     /*  622532 */     GIR_EraseRootFromParent_Done,
     /*  622533 */   // Label 10105: @622533
     /*  622533 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(622608), // Rule ID 11527 //
     /*  622538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  622587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622606 */     GIR_RootConstrainSelectedInstOperands,
     /*  622607 */     // GIR_Coverage, 11527,
     /*  622607 */     GIR_EraseRootFromParent_Done,
     /*  622608 */   // Label 10106: @622608
     /*  622608 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(622683), // Rule ID 11530 //
     /*  622613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  622662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622681 */     GIR_RootConstrainSelectedInstOperands,
     /*  622682 */     // GIR_Coverage, 11530,
     /*  622682 */     GIR_EraseRootFromParent_Done,
     /*  622683 */   // Label 10107: @622683
     /*  622683 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(622758), // Rule ID 11531 //
     /*  622688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  622737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622756 */     GIR_RootConstrainSelectedInstOperands,
     /*  622757 */     // GIR_Coverage, 11531,
     /*  622757 */     GIR_EraseRootFromParent_Done,
     /*  622758 */   // Label 10108: @622758
     /*  622758 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(622833), // Rule ID 11534 //
     /*  622763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  622812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622831 */     GIR_RootConstrainSelectedInstOperands,
     /*  622832 */     // GIR_Coverage, 11534,
     /*  622832 */     GIR_EraseRootFromParent_Done,
     /*  622833 */   // Label 10109: @622833
     /*  622833 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(622908), // Rule ID 11535 //
     /*  622838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  622887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622906 */     GIR_RootConstrainSelectedInstOperands,
     /*  622907 */     // GIR_Coverage, 11535,
     /*  622907 */     GIR_EraseRootFromParent_Done,
     /*  622908 */   // Label 10110: @622908
     /*  622908 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(622983), // Rule ID 11538 //
     /*  622913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  622962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622981 */     GIR_RootConstrainSelectedInstOperands,
     /*  622982 */     // GIR_Coverage, 11538,
     /*  622982 */     GIR_EraseRootFromParent_Done,
     /*  622983 */   // Label 10111: @622983
     /*  622983 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(623058), // Rule ID 11539 //
     /*  622988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  622996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  623008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  623037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623056 */     GIR_RootConstrainSelectedInstOperands,
     /*  623057 */     // GIR_Coverage, 11539,
     /*  623057 */     GIR_EraseRootFromParent_Done,
     /*  623058 */   // Label 10112: @623058
     /*  623058 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(623133), // Rule ID 11542 //
     /*  623063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  623112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623131 */     GIR_RootConstrainSelectedInstOperands,
     /*  623132 */     // GIR_Coverage, 11542,
     /*  623132 */     GIR_EraseRootFromParent_Done,
     /*  623133 */   // Label 10113: @623133
     /*  623133 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(623208), // Rule ID 11543 //
     /*  623138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  623187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623206 */     GIR_RootConstrainSelectedInstOperands,
     /*  623207 */     // GIR_Coverage, 11543,
     /*  623207 */     GIR_EraseRootFromParent_Done,
     /*  623208 */   // Label 10114: @623208
     /*  623208 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(623283), // Rule ID 11546 //
     /*  623213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  623262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623281 */     GIR_RootConstrainSelectedInstOperands,
     /*  623282 */     // GIR_Coverage, 11546,
     /*  623282 */     GIR_EraseRootFromParent_Done,
     /*  623283 */   // Label 10115: @623283
     /*  623283 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(623358), // Rule ID 11547 //
     /*  623288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  623337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623356 */     GIR_RootConstrainSelectedInstOperands,
     /*  623357 */     // GIR_Coverage, 11547,
     /*  623357 */     GIR_EraseRootFromParent_Done,
     /*  623358 */   // Label 10116: @623358
     /*  623358 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(623433), // Rule ID 11550 //
     /*  623363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623409 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  623412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623431 */     GIR_RootConstrainSelectedInstOperands,
     /*  623432 */     // GIR_Coverage, 11550,
     /*  623432 */     GIR_EraseRootFromParent_Done,
     /*  623433 */   // Label 10117: @623433
     /*  623433 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(623508), // Rule ID 11551 //
     /*  623438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  623487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623506 */     GIR_RootConstrainSelectedInstOperands,
     /*  623507 */     // GIR_Coverage, 11551,
     /*  623507 */     GIR_EraseRootFromParent_Done,
     /*  623508 */   // Label 10118: @623508
     /*  623508 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(623583), // Rule ID 11554 //
     /*  623513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  623562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623581 */     GIR_RootConstrainSelectedInstOperands,
     /*  623582 */     // GIR_Coverage, 11554,
     /*  623582 */     GIR_EraseRootFromParent_Done,
     /*  623583 */   // Label 10119: @623583
     /*  623583 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(623658), // Rule ID 11555 //
     /*  623588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  623637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623656 */     GIR_RootConstrainSelectedInstOperands,
     /*  623657 */     // GIR_Coverage, 11555,
     /*  623657 */     GIR_EraseRootFromParent_Done,
     /*  623658 */   // Label 10120: @623658
     /*  623658 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(623733), // Rule ID 11558 //
     /*  623663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623709 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  623712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623731 */     GIR_RootConstrainSelectedInstOperands,
     /*  623732 */     // GIR_Coverage, 11558,
     /*  623732 */     GIR_EraseRootFromParent_Done,
     /*  623733 */   // Label 10121: @623733
     /*  623733 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(623808), // Rule ID 11559 //
     /*  623738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  623787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623806 */     GIR_RootConstrainSelectedInstOperands,
     /*  623807 */     // GIR_Coverage, 11559,
     /*  623807 */     GIR_EraseRootFromParent_Done,
     /*  623808 */   // Label 10122: @623808
     /*  623808 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(623883), // Rule ID 11562 //
     /*  623813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623859 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  623862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623881 */     GIR_RootConstrainSelectedInstOperands,
     /*  623882 */     // GIR_Coverage, 11562,
     /*  623882 */     GIR_EraseRootFromParent_Done,
     /*  623883 */   // Label 10123: @623883
     /*  623883 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(623958), // Rule ID 11563 //
     /*  623888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  623937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623956 */     GIR_RootConstrainSelectedInstOperands,
     /*  623957 */     // GIR_Coverage, 11563,
     /*  623957 */     GIR_EraseRootFromParent_Done,
     /*  623958 */   // Label 10124: @623958
     /*  623958 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(624033), // Rule ID 11566 //
     /*  623963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  623971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  624012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624031 */     GIR_RootConstrainSelectedInstOperands,
     /*  624032 */     // GIR_Coverage, 11566,
     /*  624032 */     GIR_EraseRootFromParent_Done,
     /*  624033 */   // Label 10125: @624033
     /*  624033 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(624108), // Rule ID 11567 //
     /*  624038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  624058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  624087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624106 */     GIR_RootConstrainSelectedInstOperands,
     /*  624107 */     // GIR_Coverage, 11567,
     /*  624107 */     GIR_EraseRootFromParent_Done,
     /*  624108 */   // Label 10126: @624108
     /*  624108 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(624183), // Rule ID 11570 //
     /*  624113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  624162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624181 */     GIR_RootConstrainSelectedInstOperands,
     /*  624182 */     // GIR_Coverage, 11570,
     /*  624182 */     GIR_EraseRootFromParent_Done,
     /*  624183 */   // Label 10127: @624183
     /*  624183 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(624258), // Rule ID 11571 //
     /*  624188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  624237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624256 */     GIR_RootConstrainSelectedInstOperands,
     /*  624257 */     // GIR_Coverage, 11571,
     /*  624257 */     GIR_EraseRootFromParent_Done,
     /*  624258 */   // Label 10128: @624258
     /*  624258 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(624333), // Rule ID 11574 //
     /*  624263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  624312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624331 */     GIR_RootConstrainSelectedInstOperands,
     /*  624332 */     // GIR_Coverage, 11574,
     /*  624332 */     GIR_EraseRootFromParent_Done,
     /*  624333 */   // Label 10129: @624333
     /*  624333 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(624408), // Rule ID 11575 //
     /*  624338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  624387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624406 */     GIR_RootConstrainSelectedInstOperands,
     /*  624407 */     // GIR_Coverage, 11575,
     /*  624407 */     GIR_EraseRootFromParent_Done,
     /*  624408 */   // Label 10130: @624408
     /*  624408 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(624483), // Rule ID 11578 //
     /*  624413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  624462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624481 */     GIR_RootConstrainSelectedInstOperands,
     /*  624482 */     // GIR_Coverage, 11578,
     /*  624482 */     GIR_EraseRootFromParent_Done,
     /*  624483 */   // Label 10131: @624483
     /*  624483 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(624558), // Rule ID 11579 //
     /*  624488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  624537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624556 */     GIR_RootConstrainSelectedInstOperands,
     /*  624557 */     // GIR_Coverage, 11579,
     /*  624557 */     GIR_EraseRootFromParent_Done,
     /*  624558 */   // Label 10132: @624558
     /*  624558 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(624633), // Rule ID 11582 //
     /*  624563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  624612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624631 */     GIR_RootConstrainSelectedInstOperands,
     /*  624632 */     // GIR_Coverage, 11582,
     /*  624632 */     GIR_EraseRootFromParent_Done,
     /*  624633 */   // Label 10133: @624633
     /*  624633 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(624708), // Rule ID 11583 //
     /*  624638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  624687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624706 */     GIR_RootConstrainSelectedInstOperands,
     /*  624707 */     // GIR_Coverage, 11583,
     /*  624707 */     GIR_EraseRootFromParent_Done,
     /*  624708 */   // Label 10134: @624708
     /*  624708 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(624783), // Rule ID 11586 //
     /*  624713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624759 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  624762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624781 */     GIR_RootConstrainSelectedInstOperands,
     /*  624782 */     // GIR_Coverage, 11586,
     /*  624782 */     GIR_EraseRootFromParent_Done,
     /*  624783 */   // Label 10135: @624783
     /*  624783 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(624858), // Rule ID 11587 //
     /*  624788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  624837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624856 */     GIR_RootConstrainSelectedInstOperands,
     /*  624857 */     // GIR_Coverage, 11587,
     /*  624857 */     GIR_EraseRootFromParent_Done,
     /*  624858 */   // Label 10136: @624858
     /*  624858 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(624933), // Rule ID 11590 //
     /*  624863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  624912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624931 */     GIR_RootConstrainSelectedInstOperands,
     /*  624932 */     // GIR_Coverage, 11590,
     /*  624932 */     GIR_EraseRootFromParent_Done,
     /*  624933 */   // Label 10137: @624933
     /*  624933 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(625008), // Rule ID 11591 //
     /*  624938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  624946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  624987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625006 */     GIR_RootConstrainSelectedInstOperands,
     /*  625007 */     // GIR_Coverage, 11591,
     /*  625007 */     GIR_EraseRootFromParent_Done,
     /*  625008 */   // Label 10138: @625008
     /*  625008 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(625083), // Rule ID 11594 //
     /*  625013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  625062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625081 */     GIR_RootConstrainSelectedInstOperands,
     /*  625082 */     // GIR_Coverage, 11594,
     /*  625082 */     GIR_EraseRootFromParent_Done,
     /*  625083 */   // Label 10139: @625083
     /*  625083 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(625158), // Rule ID 11595 //
     /*  625088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  625137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625156 */     GIR_RootConstrainSelectedInstOperands,
     /*  625157 */     // GIR_Coverage, 11595,
     /*  625157 */     GIR_EraseRootFromParent_Done,
     /*  625158 */   // Label 10140: @625158
     /*  625158 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(625233), // Rule ID 11598 //
     /*  625163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  625212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625231 */     GIR_RootConstrainSelectedInstOperands,
     /*  625232 */     // GIR_Coverage, 11598,
     /*  625232 */     GIR_EraseRootFromParent_Done,
     /*  625233 */   // Label 10141: @625233
     /*  625233 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(625308), // Rule ID 11599 //
     /*  625238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  625287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625306 */     GIR_RootConstrainSelectedInstOperands,
     /*  625307 */     // GIR_Coverage, 11599,
     /*  625307 */     GIR_EraseRootFromParent_Done,
     /*  625308 */   // Label 10142: @625308
     /*  625308 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(625383), // Rule ID 11602 //
     /*  625313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  625362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625381 */     GIR_RootConstrainSelectedInstOperands,
     /*  625382 */     // GIR_Coverage, 11602,
     /*  625382 */     GIR_EraseRootFromParent_Done,
     /*  625383 */   // Label 10143: @625383
     /*  625383 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(625458), // Rule ID 11603 //
     /*  625388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  625437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625456 */     GIR_RootConstrainSelectedInstOperands,
     /*  625457 */     // GIR_Coverage, 11603,
     /*  625457 */     GIR_EraseRootFromParent_Done,
     /*  625458 */   // Label 10144: @625458
     /*  625458 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(625533), // Rule ID 11606 //
     /*  625463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625509 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  625512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625531 */     GIR_RootConstrainSelectedInstOperands,
     /*  625532 */     // GIR_Coverage, 11606,
     /*  625532 */     GIR_EraseRootFromParent_Done,
     /*  625533 */   // Label 10145: @625533
     /*  625533 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(625608), // Rule ID 11607 //
     /*  625538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625584 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  625587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625606 */     GIR_RootConstrainSelectedInstOperands,
     /*  625607 */     // GIR_Coverage, 11607,
     /*  625607 */     GIR_EraseRootFromParent_Done,
     /*  625608 */   // Label 10146: @625608
     /*  625608 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(625683), // Rule ID 11610 //
     /*  625613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625659 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  625662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625681 */     GIR_RootConstrainSelectedInstOperands,
     /*  625682 */     // GIR_Coverage, 11610,
     /*  625682 */     GIR_EraseRootFromParent_Done,
     /*  625683 */   // Label 10147: @625683
     /*  625683 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(625758), // Rule ID 11611 //
     /*  625688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  625737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625756 */     GIR_RootConstrainSelectedInstOperands,
     /*  625757 */     // GIR_Coverage, 11611,
     /*  625757 */     GIR_EraseRootFromParent_Done,
     /*  625758 */   // Label 10148: @625758
     /*  625758 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(625833), // Rule ID 11614 //
     /*  625763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  625812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625831 */     GIR_RootConstrainSelectedInstOperands,
     /*  625832 */     // GIR_Coverage, 11614,
     /*  625832 */     GIR_EraseRootFromParent_Done,
     /*  625833 */   // Label 10149: @625833
     /*  625833 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(625908), // Rule ID 11615 //
     /*  625838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  625887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625906 */     GIR_RootConstrainSelectedInstOperands,
     /*  625907 */     // GIR_Coverage, 11615,
     /*  625907 */     GIR_EraseRootFromParent_Done,
     /*  625908 */   // Label 10150: @625908
     /*  625908 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(625983), // Rule ID 11618 //
     /*  625913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  625962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625981 */     GIR_RootConstrainSelectedInstOperands,
     /*  625982 */     // GIR_Coverage, 11618,
     /*  625982 */     GIR_EraseRootFromParent_Done,
     /*  625983 */   // Label 10151: @625983
     /*  625983 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(626058), // Rule ID 11619 //
     /*  625988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  625996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  626037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626056 */     GIR_RootConstrainSelectedInstOperands,
     /*  626057 */     // GIR_Coverage, 11619,
     /*  626057 */     GIR_EraseRootFromParent_Done,
     /*  626058 */   // Label 10152: @626058
     /*  626058 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(626133), // Rule ID 11622 //
     /*  626063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  626112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626131 */     GIR_RootConstrainSelectedInstOperands,
     /*  626132 */     // GIR_Coverage, 11622,
     /*  626132 */     GIR_EraseRootFromParent_Done,
     /*  626133 */   // Label 10153: @626133
     /*  626133 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(626208), // Rule ID 11623 //
     /*  626138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  626187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626206 */     GIR_RootConstrainSelectedInstOperands,
     /*  626207 */     // GIR_Coverage, 11623,
     /*  626207 */     GIR_EraseRootFromParent_Done,
     /*  626208 */   // Label 10154: @626208
     /*  626208 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(626283), // Rule ID 11626 //
     /*  626213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  626262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626281 */     GIR_RootConstrainSelectedInstOperands,
     /*  626282 */     // GIR_Coverage, 11626,
     /*  626282 */     GIR_EraseRootFromParent_Done,
     /*  626283 */   // Label 10155: @626283
     /*  626283 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(626358), // Rule ID 11627 //
     /*  626288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10874:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  626337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626356 */     GIR_RootConstrainSelectedInstOperands,
     /*  626357 */     // GIR_Coverage, 11627,
     /*  626357 */     GIR_EraseRootFromParent_Done,
     /*  626358 */   // Label 10156: @626358
     /*  626358 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(626433), // Rule ID 11630 //
     /*  626363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  626412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626431 */     GIR_RootConstrainSelectedInstOperands,
     /*  626432 */     // GIR_Coverage, 11630,
     /*  626432 */     GIR_EraseRootFromParent_Done,
     /*  626433 */   // Label 10157: @626433
     /*  626433 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(626508), // Rule ID 11631 //
     /*  626438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  626487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626506 */     GIR_RootConstrainSelectedInstOperands,
     /*  626507 */     // GIR_Coverage, 11631,
     /*  626507 */     GIR_EraseRootFromParent_Done,
     /*  626508 */   // Label 10158: @626508
     /*  626508 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(626583), // Rule ID 11634 //
     /*  626513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  626562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626581 */     GIR_RootConstrainSelectedInstOperands,
     /*  626582 */     // GIR_Coverage, 11634,
     /*  626582 */     GIR_EraseRootFromParent_Done,
     /*  626583 */   // Label 10159: @626583
     /*  626583 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(626658), // Rule ID 11635 //
     /*  626588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  626637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626656 */     GIR_RootConstrainSelectedInstOperands,
     /*  626657 */     // GIR_Coverage, 11635,
     /*  626657 */     GIR_EraseRootFromParent_Done,
     /*  626658 */   // Label 10160: @626658
     /*  626658 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(626733), // Rule ID 11638 //
     /*  626663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  626712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626731 */     GIR_RootConstrainSelectedInstOperands,
     /*  626732 */     // GIR_Coverage, 11638,
     /*  626732 */     GIR_EraseRootFromParent_Done,
     /*  626733 */   // Label 10161: @626733
     /*  626733 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(626808), // Rule ID 11639 //
     /*  626738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  626787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626806 */     GIR_RootConstrainSelectedInstOperands,
     /*  626807 */     // GIR_Coverage, 11639,
     /*  626807 */     GIR_EraseRootFromParent_Done,
     /*  626808 */   // Label 10162: @626808
     /*  626808 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(626883), // Rule ID 11642 //
     /*  626813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  626862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626881 */     GIR_RootConstrainSelectedInstOperands,
     /*  626882 */     // GIR_Coverage, 11642,
     /*  626882 */     GIR_EraseRootFromParent_Done,
     /*  626883 */   // Label 10163: @626883
     /*  626883 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(626958), // Rule ID 11643 //
     /*  626888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  626937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626956 */     GIR_RootConstrainSelectedInstOperands,
     /*  626957 */     // GIR_Coverage, 11643,
     /*  626957 */     GIR_EraseRootFromParent_Done,
     /*  626958 */   // Label 10164: @626958
     /*  626958 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(627033), // Rule ID 11646 //
     /*  626963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  626971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627009 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  627012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627031 */     GIR_RootConstrainSelectedInstOperands,
     /*  627032 */     // GIR_Coverage, 11646,
     /*  627032 */     GIR_EraseRootFromParent_Done,
     /*  627033 */   // Label 10165: @627033
     /*  627033 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(627108), // Rule ID 11647 //
     /*  627038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  627087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627106 */     GIR_RootConstrainSelectedInstOperands,
     /*  627107 */     // GIR_Coverage, 11647,
     /*  627107 */     GIR_EraseRootFromParent_Done,
     /*  627108 */   // Label 10166: @627108
     /*  627108 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(627183), // Rule ID 11650 //
     /*  627113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  627162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627181 */     GIR_RootConstrainSelectedInstOperands,
     /*  627182 */     // GIR_Coverage, 11650,
     /*  627182 */     GIR_EraseRootFromParent_Done,
     /*  627183 */   // Label 10167: @627183
     /*  627183 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(627258), // Rule ID 11651 //
     /*  627188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627234 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  627237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627256 */     GIR_RootConstrainSelectedInstOperands,
     /*  627257 */     // GIR_Coverage, 11651,
     /*  627257 */     GIR_EraseRootFromParent_Done,
     /*  627258 */   // Label 10168: @627258
     /*  627258 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(627333), // Rule ID 11654 //
     /*  627263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  627312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627331 */     GIR_RootConstrainSelectedInstOperands,
     /*  627332 */     // GIR_Coverage, 11654,
     /*  627332 */     GIR_EraseRootFromParent_Done,
     /*  627333 */   // Label 10169: @627333
     /*  627333 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(627408), // Rule ID 11655 //
     /*  627338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  627387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627406 */     GIR_RootConstrainSelectedInstOperands,
     /*  627407 */     // GIR_Coverage, 11655,
     /*  627407 */     GIR_EraseRootFromParent_Done,
     /*  627408 */   // Label 10170: @627408
     /*  627408 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(627483), // Rule ID 11658 //
     /*  627413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  627462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627481 */     GIR_RootConstrainSelectedInstOperands,
     /*  627482 */     // GIR_Coverage, 11658,
     /*  627482 */     GIR_EraseRootFromParent_Done,
     /*  627483 */   // Label 10171: @627483
     /*  627483 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(627558), // Rule ID 11659 //
     /*  627488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  627537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627556 */     GIR_RootConstrainSelectedInstOperands,
     /*  627557 */     // GIR_Coverage, 11659,
     /*  627557 */     GIR_EraseRootFromParent_Done,
     /*  627558 */   // Label 10172: @627558
     /*  627558 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(627633), // Rule ID 11662 //
     /*  627563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  627612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627631 */     GIR_RootConstrainSelectedInstOperands,
     /*  627632 */     // GIR_Coverage, 11662,
     /*  627632 */     GIR_EraseRootFromParent_Done,
     /*  627633 */   // Label 10173: @627633
     /*  627633 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(627708), // Rule ID 11663 //
     /*  627638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  627687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627706 */     GIR_RootConstrainSelectedInstOperands,
     /*  627707 */     // GIR_Coverage, 11663,
     /*  627707 */     GIR_EraseRootFromParent_Done,
     /*  627708 */   // Label 10174: @627708
     /*  627708 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(627783), // Rule ID 11666 //
     /*  627713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  627762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627781 */     GIR_RootConstrainSelectedInstOperands,
     /*  627782 */     // GIR_Coverage, 11666,
     /*  627782 */     GIR_EraseRootFromParent_Done,
     /*  627783 */   // Label 10175: @627783
     /*  627783 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(627858), // Rule ID 11667 //
     /*  627788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  627837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627856 */     GIR_RootConstrainSelectedInstOperands,
     /*  627857 */     // GIR_Coverage, 11667,
     /*  627857 */     GIR_EraseRootFromParent_Done,
     /*  627858 */   // Label 10176: @627858
     /*  627858 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(627933), // Rule ID 11670 //
     /*  627863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627909 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  627912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627931 */     GIR_RootConstrainSelectedInstOperands,
     /*  627932 */     // GIR_Coverage, 11670,
     /*  627932 */     GIR_EraseRootFromParent_Done,
     /*  627933 */   // Label 10177: @627933
     /*  627933 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(628008), // Rule ID 11671 //
     /*  627938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  627946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  627987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628006 */     GIR_RootConstrainSelectedInstOperands,
     /*  628007 */     // GIR_Coverage, 11671,
     /*  628007 */     GIR_EraseRootFromParent_Done,
     /*  628008 */   // Label 10178: @628008
     /*  628008 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(628083), // Rule ID 11674 //
     /*  628013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  628062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628081 */     GIR_RootConstrainSelectedInstOperands,
     /*  628082 */     // GIR_Coverage, 11674,
     /*  628082 */     GIR_EraseRootFromParent_Done,
     /*  628083 */   // Label 10179: @628083
     /*  628083 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(628158), // Rule ID 11675 //
     /*  628088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  628137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628156 */     GIR_RootConstrainSelectedInstOperands,
     /*  628157 */     // GIR_Coverage, 11675,
     /*  628157 */     GIR_EraseRootFromParent_Done,
     /*  628158 */   // Label 10180: @628158
     /*  628158 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(628233), // Rule ID 11678 //
     /*  628163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  628212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628231 */     GIR_RootConstrainSelectedInstOperands,
     /*  628232 */     // GIR_Coverage, 11678,
     /*  628232 */     GIR_EraseRootFromParent_Done,
     /*  628233 */   // Label 10181: @628233
     /*  628233 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(628308), // Rule ID 11679 //
     /*  628238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  628287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628306 */     GIR_RootConstrainSelectedInstOperands,
     /*  628307 */     // GIR_Coverage, 11679,
     /*  628307 */     GIR_EraseRootFromParent_Done,
     /*  628308 */   // Label 10182: @628308
     /*  628308 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(628383), // Rule ID 11682 //
     /*  628313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  628362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628381 */     GIR_RootConstrainSelectedInstOperands,
     /*  628382 */     // GIR_Coverage, 11682,
     /*  628382 */     GIR_EraseRootFromParent_Done,
     /*  628383 */   // Label 10183: @628383
     /*  628383 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(628458), // Rule ID 11683 //
     /*  628388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  628437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628456 */     GIR_RootConstrainSelectedInstOperands,
     /*  628457 */     // GIR_Coverage, 11683,
     /*  628457 */     GIR_EraseRootFromParent_Done,
     /*  628458 */   // Label 10184: @628458
     /*  628458 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(628533), // Rule ID 11686 //
     /*  628463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  628512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628531 */     GIR_RootConstrainSelectedInstOperands,
     /*  628532 */     // GIR_Coverage, 11686,
     /*  628532 */     GIR_EraseRootFromParent_Done,
     /*  628533 */   // Label 10185: @628533
     /*  628533 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(628608), // Rule ID 11687 //
     /*  628538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  628546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  628587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628606 */     GIR_RootConstrainSelectedInstOperands,
     /*  628607 */     // GIR_Coverage, 11687,
     /*  628607 */     GIR_EraseRootFromParent_Done,
     /*  628608 */   // Label 10186: @628608
     /*  628608 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(628683), // Rule ID 11690 //
     /*  628613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  628662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628681 */     GIR_RootConstrainSelectedInstOperands,
     /*  628682 */     // GIR_Coverage, 11690,
     /*  628682 */     GIR_EraseRootFromParent_Done,
     /*  628683 */   // Label 10187: @628683
     /*  628683 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(628758), // Rule ID 11691 //
     /*  628688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  628737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628756 */     GIR_RootConstrainSelectedInstOperands,
     /*  628757 */     // GIR_Coverage, 11691,
     /*  628757 */     GIR_EraseRootFromParent_Done,
     /*  628758 */   // Label 10188: @628758
     /*  628758 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(628833), // Rule ID 11694 //
     /*  628763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  628812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628831 */     GIR_RootConstrainSelectedInstOperands,
     /*  628832 */     // GIR_Coverage, 11694,
     /*  628832 */     GIR_EraseRootFromParent_Done,
     /*  628833 */   // Label 10189: @628833
     /*  628833 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(628908), // Rule ID 11695 //
     /*  628838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  628887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628906 */     GIR_RootConstrainSelectedInstOperands,
     /*  628907 */     // GIR_Coverage, 11695,
     /*  628907 */     GIR_EraseRootFromParent_Done,
     /*  628908 */   // Label 10190: @628908
     /*  628908 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(628983), // Rule ID 11698 //
     /*  628913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  628962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628981 */     GIR_RootConstrainSelectedInstOperands,
     /*  628982 */     // GIR_Coverage, 11698,
     /*  628982 */     GIR_EraseRootFromParent_Done,
     /*  628983 */   // Label 10191: @628983
     /*  628983 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(629058), // Rule ID 11699 //
     /*  628988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  628996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  629008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  629037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629056 */     GIR_RootConstrainSelectedInstOperands,
     /*  629057 */     // GIR_Coverage, 11699,
     /*  629057 */     GIR_EraseRootFromParent_Done,
     /*  629058 */   // Label 10192: @629058
     /*  629058 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(629133), // Rule ID 11702 //
     /*  629063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  629112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629131 */     GIR_RootConstrainSelectedInstOperands,
     /*  629132 */     // GIR_Coverage, 11702,
     /*  629132 */     GIR_EraseRootFromParent_Done,
     /*  629133 */   // Label 10193: @629133
     /*  629133 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(629208), // Rule ID 11703 //
     /*  629138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  629187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629206 */     GIR_RootConstrainSelectedInstOperands,
     /*  629207 */     // GIR_Coverage, 11703,
     /*  629207 */     GIR_EraseRootFromParent_Done,
     /*  629208 */   // Label 10194: @629208
     /*  629208 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(629283), // Rule ID 11706 //
     /*  629213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  629262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629281 */     GIR_RootConstrainSelectedInstOperands,
     /*  629282 */     // GIR_Coverage, 11706,
     /*  629282 */     GIR_EraseRootFromParent_Done,
     /*  629283 */   // Label 10195: @629283
     /*  629283 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(629358), // Rule ID 11707 //
     /*  629288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  629337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629356 */     GIR_RootConstrainSelectedInstOperands,
     /*  629357 */     // GIR_Coverage, 11707,
     /*  629357 */     GIR_EraseRootFromParent_Done,
     /*  629358 */   // Label 10196: @629358
     /*  629358 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(629433), // Rule ID 11710 //
     /*  629363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  629412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629431 */     GIR_RootConstrainSelectedInstOperands,
     /*  629432 */     // GIR_Coverage, 11710,
     /*  629432 */     GIR_EraseRootFromParent_Done,
     /*  629433 */   // Label 10197: @629433
     /*  629433 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(629508), // Rule ID 11711 //
     /*  629438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  629487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629506 */     GIR_RootConstrainSelectedInstOperands,
     /*  629507 */     // GIR_Coverage, 11711,
     /*  629507 */     GIR_EraseRootFromParent_Done,
     /*  629508 */   // Label 10198: @629508
     /*  629508 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(629583), // Rule ID 11714 //
     /*  629513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629559 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  629562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629581 */     GIR_RootConstrainSelectedInstOperands,
     /*  629582 */     // GIR_Coverage, 11714,
     /*  629582 */     GIR_EraseRootFromParent_Done,
     /*  629583 */   // Label 10199: @629583
     /*  629583 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(629658), // Rule ID 11715 //
     /*  629588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  629637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629656 */     GIR_RootConstrainSelectedInstOperands,
     /*  629657 */     // GIR_Coverage, 11715,
     /*  629657 */     GIR_EraseRootFromParent_Done,
     /*  629658 */   // Label 10200: @629658
     /*  629658 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(629733), // Rule ID 11718 //
     /*  629663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  629712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629731 */     GIR_RootConstrainSelectedInstOperands,
     /*  629732 */     // GIR_Coverage, 11718,
     /*  629732 */     GIR_EraseRootFromParent_Done,
     /*  629733 */   // Label 10201: @629733
     /*  629733 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(629808), // Rule ID 11719 //
     /*  629738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  629787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629806 */     GIR_RootConstrainSelectedInstOperands,
     /*  629807 */     // GIR_Coverage, 11719,
     /*  629807 */     GIR_EraseRootFromParent_Done,
     /*  629808 */   // Label 10202: @629808
     /*  629808 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(629883), // Rule ID 11722 //
     /*  629813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  629862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629881 */     GIR_RootConstrainSelectedInstOperands,
     /*  629882 */     // GIR_Coverage, 11722,
     /*  629882 */     GIR_EraseRootFromParent_Done,
     /*  629883 */   // Label 10203: @629883
     /*  629883 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(629958), // Rule ID 11723 //
     /*  629888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  629937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629956 */     GIR_RootConstrainSelectedInstOperands,
     /*  629957 */     // GIR_Coverage, 11723,
     /*  629957 */     GIR_EraseRootFromParent_Done,
     /*  629958 */   // Label 10204: @629958
     /*  629958 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(630033), // Rule ID 11726 //
     /*  629963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  629966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  629971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  630012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630031 */     GIR_RootConstrainSelectedInstOperands,
     /*  630032 */     // GIR_Coverage, 11726,
     /*  630032 */     GIR_EraseRootFromParent_Done,
     /*  630033 */   // Label 10205: @630033
     /*  630033 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(630108), // Rule ID 11727 //
     /*  630038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  630058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  630087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630106 */     GIR_RootConstrainSelectedInstOperands,
     /*  630107 */     // GIR_Coverage, 11727,
     /*  630107 */     GIR_EraseRootFromParent_Done,
     /*  630108 */   // Label 10206: @630108
     /*  630108 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(630183), // Rule ID 11730 //
     /*  630113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  630162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630181 */     GIR_RootConstrainSelectedInstOperands,
     /*  630182 */     // GIR_Coverage, 11730,
     /*  630182 */     GIR_EraseRootFromParent_Done,
     /*  630183 */   // Label 10207: @630183
     /*  630183 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(630258), // Rule ID 11731 //
     /*  630188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  630237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630256 */     GIR_RootConstrainSelectedInstOperands,
     /*  630257 */     // GIR_Coverage, 11731,
     /*  630257 */     GIR_EraseRootFromParent_Done,
     /*  630258 */   // Label 10208: @630258
     /*  630258 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(630333), // Rule ID 11734 //
     /*  630263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630309 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  630312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630331 */     GIR_RootConstrainSelectedInstOperands,
     /*  630332 */     // GIR_Coverage, 11734,
     /*  630332 */     GIR_EraseRootFromParent_Done,
     /*  630333 */   // Label 10209: @630333
     /*  630333 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(630408), // Rule ID 11735 //
     /*  630338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  630387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630406 */     GIR_RootConstrainSelectedInstOperands,
     /*  630407 */     // GIR_Coverage, 11735,
     /*  630407 */     GIR_EraseRootFromParent_Done,
     /*  630408 */   // Label 10210: @630408
     /*  630408 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(630483), // Rule ID 11738 //
     /*  630413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630459 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  630462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630481 */     GIR_RootConstrainSelectedInstOperands,
     /*  630482 */     // GIR_Coverage, 11738,
     /*  630482 */     GIR_EraseRootFromParent_Done,
     /*  630483 */   // Label 10211: @630483
     /*  630483 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(630558), // Rule ID 11739 //
     /*  630488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  630537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630556 */     GIR_RootConstrainSelectedInstOperands,
     /*  630557 */     // GIR_Coverage, 11739,
     /*  630557 */     GIR_EraseRootFromParent_Done,
     /*  630558 */   // Label 10212: @630558
     /*  630558 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(630633), // Rule ID 11742 //
     /*  630563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  630612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630631 */     GIR_RootConstrainSelectedInstOperands,
     /*  630632 */     // GIR_Coverage, 11742,
     /*  630632 */     GIR_EraseRootFromParent_Done,
     /*  630633 */   // Label 10213: @630633
     /*  630633 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(630708), // Rule ID 11743 //
     /*  630638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  630687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630706 */     GIR_RootConstrainSelectedInstOperands,
     /*  630707 */     // GIR_Coverage, 11743,
     /*  630707 */     GIR_EraseRootFromParent_Done,
     /*  630708 */   // Label 10214: @630708
     /*  630708 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(630783), // Rule ID 11746 //
     /*  630713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  630762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630781 */     GIR_RootConstrainSelectedInstOperands,
     /*  630782 */     // GIR_Coverage, 11746,
     /*  630782 */     GIR_EraseRootFromParent_Done,
     /*  630783 */   // Label 10215: @630783
     /*  630783 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(630858), // Rule ID 11747 //
     /*  630788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  630837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630856 */     GIR_RootConstrainSelectedInstOperands,
     /*  630857 */     // GIR_Coverage, 11747,
     /*  630857 */     GIR_EraseRootFromParent_Done,
     /*  630858 */   // Label 10216: @630858
     /*  630858 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(630933), // Rule ID 11750 //
     /*  630863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630909 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  630912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630931 */     GIR_RootConstrainSelectedInstOperands,
     /*  630932 */     // GIR_Coverage, 11750,
     /*  630932 */     GIR_EraseRootFromParent_Done,
     /*  630933 */   // Label 10217: @630933
     /*  630933 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(631008), // Rule ID 11751 //
     /*  630938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  630946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  630987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631006 */     GIR_RootConstrainSelectedInstOperands,
     /*  631007 */     // GIR_Coverage, 11751,
     /*  631007 */     GIR_EraseRootFromParent_Done,
     /*  631008 */   // Label 10218: @631008
     /*  631008 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(631083), // Rule ID 11754 //
     /*  631013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  631062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631081 */     GIR_RootConstrainSelectedInstOperands,
     /*  631082 */     // GIR_Coverage, 11754,
     /*  631082 */     GIR_EraseRootFromParent_Done,
     /*  631083 */   // Label 10219: @631083
     /*  631083 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(631158), // Rule ID 11755 //
     /*  631088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  631137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631156 */     GIR_RootConstrainSelectedInstOperands,
     /*  631157 */     // GIR_Coverage, 11755,
     /*  631157 */     GIR_EraseRootFromParent_Done,
     /*  631158 */   // Label 10220: @631158
     /*  631158 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(631233), // Rule ID 11758 //
     /*  631163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  631212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631231 */     GIR_RootConstrainSelectedInstOperands,
     /*  631232 */     // GIR_Coverage, 11758,
     /*  631232 */     GIR_EraseRootFromParent_Done,
     /*  631233 */   // Label 10221: @631233
     /*  631233 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(631308), // Rule ID 11759 //
     /*  631238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  631287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631306 */     GIR_RootConstrainSelectedInstOperands,
     /*  631307 */     // GIR_Coverage, 11759,
     /*  631307 */     GIR_EraseRootFromParent_Done,
     /*  631308 */   // Label 10222: @631308
     /*  631308 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(631383), // Rule ID 11762 //
     /*  631313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631359 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  631362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631381 */     GIR_RootConstrainSelectedInstOperands,
     /*  631382 */     // GIR_Coverage, 11762,
     /*  631382 */     GIR_EraseRootFromParent_Done,
     /*  631383 */   // Label 10223: @631383
     /*  631383 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(631458), // Rule ID 11763 //
     /*  631388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  631437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631456 */     GIR_RootConstrainSelectedInstOperands,
     /*  631457 */     // GIR_Coverage, 11763,
     /*  631457 */     GIR_EraseRootFromParent_Done,
     /*  631458 */   // Label 10224: @631458
     /*  631458 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(631533), // Rule ID 11766 //
     /*  631463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  631512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631531 */     GIR_RootConstrainSelectedInstOperands,
     /*  631532 */     // GIR_Coverage, 11766,
     /*  631532 */     GIR_EraseRootFromParent_Done,
     /*  631533 */   // Label 10225: @631533
     /*  631533 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(631608), // Rule ID 11767 //
     /*  631538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  631587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631606 */     GIR_RootConstrainSelectedInstOperands,
     /*  631607 */     // GIR_Coverage, 11767,
     /*  631607 */     GIR_EraseRootFromParent_Done,
     /*  631608 */   // Label 10226: @631608
     /*  631608 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(631683), // Rule ID 11770 //
     /*  631613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  631662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631681 */     GIR_RootConstrainSelectedInstOperands,
     /*  631682 */     // GIR_Coverage, 11770,
     /*  631682 */     GIR_EraseRootFromParent_Done,
     /*  631683 */   // Label 10227: @631683
     /*  631683 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(631758), // Rule ID 11771 //
     /*  631688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  631737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631756 */     GIR_RootConstrainSelectedInstOperands,
     /*  631757 */     // GIR_Coverage, 11771,
     /*  631757 */     GIR_EraseRootFromParent_Done,
     /*  631758 */   // Label 10228: @631758
     /*  631758 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(631833), // Rule ID 11774 //
     /*  631763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  631812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631831 */     GIR_RootConstrainSelectedInstOperands,
     /*  631832 */     // GIR_Coverage, 11774,
     /*  631832 */     GIR_EraseRootFromParent_Done,
     /*  631833 */   // Label 10229: @631833
     /*  631833 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(631908), // Rule ID 11775 //
     /*  631838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  631887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631906 */     GIR_RootConstrainSelectedInstOperands,
     /*  631907 */     // GIR_Coverage, 11775,
     /*  631907 */     GIR_EraseRootFromParent_Done,
     /*  631908 */   // Label 10230: @631908
     /*  631908 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(631983), // Rule ID 11778 //
     /*  631913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  631962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631981 */     GIR_RootConstrainSelectedInstOperands,
     /*  631982 */     // GIR_Coverage, 11778,
     /*  631982 */     GIR_EraseRootFromParent_Done,
     /*  631983 */   // Label 10231: @631983
     /*  631983 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(632058), // Rule ID 11779 //
     /*  631988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  631996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  632037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632056 */     GIR_RootConstrainSelectedInstOperands,
     /*  632057 */     // GIR_Coverage, 11779,
     /*  632057 */     GIR_EraseRootFromParent_Done,
     /*  632058 */   // Label 10232: @632058
     /*  632058 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(632133), // Rule ID 11782 //
     /*  632063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  632112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632131 */     GIR_RootConstrainSelectedInstOperands,
     /*  632132 */     // GIR_Coverage, 11782,
     /*  632132 */     GIR_EraseRootFromParent_Done,
     /*  632133 */   // Label 10233: @632133
     /*  632133 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(632208), // Rule ID 11783 //
     /*  632138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  632187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632206 */     GIR_RootConstrainSelectedInstOperands,
     /*  632207 */     // GIR_Coverage, 11783,
     /*  632207 */     GIR_EraseRootFromParent_Done,
     /*  632208 */   // Label 10234: @632208
     /*  632208 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(632283), // Rule ID 11786 //
     /*  632213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  632262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632281 */     GIR_RootConstrainSelectedInstOperands,
     /*  632282 */     // GIR_Coverage, 11786,
     /*  632282 */     GIR_EraseRootFromParent_Done,
     /*  632283 */   // Label 10235: @632283
     /*  632283 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(632358), // Rule ID 11787 //
     /*  632288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  632337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632356 */     GIR_RootConstrainSelectedInstOperands,
     /*  632357 */     // GIR_Coverage, 11787,
     /*  632357 */     GIR_EraseRootFromParent_Done,
     /*  632358 */   // Label 10236: @632358
     /*  632358 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(632433), // Rule ID 11790 //
     /*  632363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632409 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  632412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632431 */     GIR_RootConstrainSelectedInstOperands,
     /*  632432 */     // GIR_Coverage, 11790,
     /*  632432 */     GIR_EraseRootFromParent_Done,
     /*  632433 */   // Label 10237: @632433
     /*  632433 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(632508), // Rule ID 11791 //
     /*  632438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  632487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632506 */     GIR_RootConstrainSelectedInstOperands,
     /*  632507 */     // GIR_Coverage, 11791,
     /*  632507 */     GIR_EraseRootFromParent_Done,
     /*  632508 */   // Label 10238: @632508
     /*  632508 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(632583), // Rule ID 11794 //
     /*  632513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  632562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632581 */     GIR_RootConstrainSelectedInstOperands,
     /*  632582 */     // GIR_Coverage, 11794,
     /*  632582 */     GIR_EraseRootFromParent_Done,
     /*  632583 */   // Label 10239: @632583
     /*  632583 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(632658), // Rule ID 11795 //
     /*  632588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  632637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632656 */     GIR_RootConstrainSelectedInstOperands,
     /*  632657 */     // GIR_Coverage, 11795,
     /*  632657 */     GIR_EraseRootFromParent_Done,
     /*  632658 */   // Label 10240: @632658
     /*  632658 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(632733), // Rule ID 11798 //
     /*  632663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  632712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632731 */     GIR_RootConstrainSelectedInstOperands,
     /*  632732 */     // GIR_Coverage, 11798,
     /*  632732 */     GIR_EraseRootFromParent_Done,
     /*  632733 */   // Label 10241: @632733
     /*  632733 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(632808), // Rule ID 11799 //
     /*  632738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  632787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632806 */     GIR_RootConstrainSelectedInstOperands,
     /*  632807 */     // GIR_Coverage, 11799,
     /*  632807 */     GIR_EraseRootFromParent_Done,
     /*  632808 */   // Label 10242: @632808
     /*  632808 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(632883), // Rule ID 11802 //
     /*  632813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  632862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632881 */     GIR_RootConstrainSelectedInstOperands,
     /*  632882 */     // GIR_Coverage, 11802,
     /*  632882 */     GIR_EraseRootFromParent_Done,
     /*  632883 */   // Label 10243: @632883
     /*  632883 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(632958), // Rule ID 11803 //
     /*  632888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10872:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  632937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632956 */     GIR_RootConstrainSelectedInstOperands,
     /*  632957 */     // GIR_Coverage, 11803,
     /*  632957 */     GIR_EraseRootFromParent_Done,
     /*  632958 */   // Label 10244: @632958
     /*  632958 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(633033), // Rule ID 11806 //
     /*  632963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  632971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  633012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633031 */     GIR_RootConstrainSelectedInstOperands,
     /*  633032 */     // GIR_Coverage, 11806,
     /*  633032 */     GIR_EraseRootFromParent_Done,
     /*  633033 */   // Label 10245: @633033
     /*  633033 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(633108), // Rule ID 11807 //
     /*  633038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  633087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633106 */     GIR_RootConstrainSelectedInstOperands,
     /*  633107 */     // GIR_Coverage, 11807,
     /*  633107 */     GIR_EraseRootFromParent_Done,
     /*  633108 */   // Label 10246: @633108
     /*  633108 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(633183), // Rule ID 11810 //
     /*  633113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633159 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  633162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633181 */     GIR_RootConstrainSelectedInstOperands,
     /*  633182 */     // GIR_Coverage, 11810,
     /*  633182 */     GIR_EraseRootFromParent_Done,
     /*  633183 */   // Label 10247: @633183
     /*  633183 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(633258), // Rule ID 11811 //
     /*  633188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  633237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633256 */     GIR_RootConstrainSelectedInstOperands,
     /*  633257 */     // GIR_Coverage, 11811,
     /*  633257 */     GIR_EraseRootFromParent_Done,
     /*  633258 */   // Label 10248: @633258
     /*  633258 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(633333), // Rule ID 11814 //
     /*  633263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  633312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633331 */     GIR_RootConstrainSelectedInstOperands,
     /*  633332 */     // GIR_Coverage, 11814,
     /*  633332 */     GIR_EraseRootFromParent_Done,
     /*  633333 */   // Label 10249: @633333
     /*  633333 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(633408), // Rule ID 11815 //
     /*  633338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  633387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633406 */     GIR_RootConstrainSelectedInstOperands,
     /*  633407 */     // GIR_Coverage, 11815,
     /*  633407 */     GIR_EraseRootFromParent_Done,
     /*  633408 */   // Label 10250: @633408
     /*  633408 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(633483), // Rule ID 11818 //
     /*  633413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  633462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633481 */     GIR_RootConstrainSelectedInstOperands,
     /*  633482 */     // GIR_Coverage, 11818,
     /*  633482 */     GIR_EraseRootFromParent_Done,
     /*  633483 */   // Label 10251: @633483
     /*  633483 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(633558), // Rule ID 11819 //
     /*  633488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  633537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633556 */     GIR_RootConstrainSelectedInstOperands,
     /*  633557 */     // GIR_Coverage, 11819,
     /*  633557 */     GIR_EraseRootFromParent_Done,
     /*  633558 */   // Label 10252: @633558
     /*  633558 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(633633), // Rule ID 11822 //
     /*  633563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633609 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  633612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633631 */     GIR_RootConstrainSelectedInstOperands,
     /*  633632 */     // GIR_Coverage, 11822,
     /*  633632 */     GIR_EraseRootFromParent_Done,
     /*  633633 */   // Label 10253: @633633
     /*  633633 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(633708), // Rule ID 11823 //
     /*  633638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  633687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633706 */     GIR_RootConstrainSelectedInstOperands,
     /*  633707 */     // GIR_Coverage, 11823,
     /*  633707 */     GIR_EraseRootFromParent_Done,
     /*  633708 */   // Label 10254: @633708
     /*  633708 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(633783), // Rule ID 11826 //
     /*  633713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  633762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633781 */     GIR_RootConstrainSelectedInstOperands,
     /*  633782 */     // GIR_Coverage, 11826,
     /*  633782 */     GIR_EraseRootFromParent_Done,
     /*  633783 */   // Label 10255: @633783
     /*  633783 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(633858), // Rule ID 11827 //
     /*  633788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  633837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633856 */     GIR_RootConstrainSelectedInstOperands,
     /*  633857 */     // GIR_Coverage, 11827,
     /*  633857 */     GIR_EraseRootFromParent_Done,
     /*  633858 */   // Label 10256: @633858
     /*  633858 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(633933), // Rule ID 11830 //
     /*  633863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  633912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633931 */     GIR_RootConstrainSelectedInstOperands,
     /*  633932 */     // GIR_Coverage, 11830,
     /*  633932 */     GIR_EraseRootFromParent_Done,
     /*  633933 */   // Label 10257: @633933
     /*  633933 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(634008), // Rule ID 11831 //
     /*  633938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  633946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  633987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634006 */     GIR_RootConstrainSelectedInstOperands,
     /*  634007 */     // GIR_Coverage, 11831,
     /*  634007 */     GIR_EraseRootFromParent_Done,
     /*  634008 */   // Label 10258: @634008
     /*  634008 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(634083), // Rule ID 11834 //
     /*  634013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  634062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634081 */     GIR_RootConstrainSelectedInstOperands,
     /*  634082 */     // GIR_Coverage, 11834,
     /*  634082 */     GIR_EraseRootFromParent_Done,
     /*  634083 */   // Label 10259: @634083
     /*  634083 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(634158), // Rule ID 11835 //
     /*  634088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  634137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634156 */     GIR_RootConstrainSelectedInstOperands,
     /*  634157 */     // GIR_Coverage, 11835,
     /*  634157 */     GIR_EraseRootFromParent_Done,
     /*  634158 */   // Label 10260: @634158
     /*  634158 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(634233), // Rule ID 11838 //
     /*  634163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  634212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634231 */     GIR_RootConstrainSelectedInstOperands,
     /*  634232 */     // GIR_Coverage, 11838,
     /*  634232 */     GIR_EraseRootFromParent_Done,
     /*  634233 */   // Label 10261: @634233
     /*  634233 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(634308), // Rule ID 11839 //
     /*  634238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  634287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634306 */     GIR_RootConstrainSelectedInstOperands,
     /*  634307 */     // GIR_Coverage, 11839,
     /*  634307 */     GIR_EraseRootFromParent_Done,
     /*  634308 */   // Label 10262: @634308
     /*  634308 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(634383), // Rule ID 11842 //
     /*  634313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  634362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634381 */     GIR_RootConstrainSelectedInstOperands,
     /*  634382 */     // GIR_Coverage, 11842,
     /*  634382 */     GIR_EraseRootFromParent_Done,
     /*  634383 */   // Label 10263: @634383
     /*  634383 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(634458), // Rule ID 11843 //
     /*  634388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  634437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634456 */     GIR_RootConstrainSelectedInstOperands,
     /*  634457 */     // GIR_Coverage, 11843,
     /*  634457 */     GIR_EraseRootFromParent_Done,
     /*  634458 */   // Label 10264: @634458
     /*  634458 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(634533), // Rule ID 11846 //
     /*  634463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  634512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634531 */     GIR_RootConstrainSelectedInstOperands,
     /*  634532 */     // GIR_Coverage, 11846,
     /*  634532 */     GIR_EraseRootFromParent_Done,
     /*  634533 */   // Label 10265: @634533
     /*  634533 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(634608), // Rule ID 11847 //
     /*  634538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  634587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634606 */     GIR_RootConstrainSelectedInstOperands,
     /*  634607 */     // GIR_Coverage, 11847,
     /*  634607 */     GIR_EraseRootFromParent_Done,
     /*  634608 */   // Label 10266: @634608
     /*  634608 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(634683), // Rule ID 11850 //
     /*  634613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  634662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634681 */     GIR_RootConstrainSelectedInstOperands,
     /*  634682 */     // GIR_Coverage, 11850,
     /*  634682 */     GIR_EraseRootFromParent_Done,
     /*  634683 */   // Label 10267: @634683
     /*  634683 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(634758), // Rule ID 11851 //
     /*  634688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  634737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634756 */     GIR_RootConstrainSelectedInstOperands,
     /*  634757 */     // GIR_Coverage, 11851,
     /*  634757 */     GIR_EraseRootFromParent_Done,
     /*  634758 */   // Label 10268: @634758
     /*  634758 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(634833), // Rule ID 11854 //
     /*  634763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  634812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634831 */     GIR_RootConstrainSelectedInstOperands,
     /*  634832 */     // GIR_Coverage, 11854,
     /*  634832 */     GIR_EraseRootFromParent_Done,
     /*  634833 */   // Label 10269: @634833
     /*  634833 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(634908), // Rule ID 11855 //
     /*  634838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  634887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634906 */     GIR_RootConstrainSelectedInstOperands,
     /*  634907 */     // GIR_Coverage, 11855,
     /*  634907 */     GIR_EraseRootFromParent_Done,
     /*  634908 */   // Label 10270: @634908
     /*  634908 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(634983), // Rule ID 11858 //
     /*  634913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  634962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634981 */     GIR_RootConstrainSelectedInstOperands,
     /*  634982 */     // GIR_Coverage, 11858,
     /*  634982 */     GIR_EraseRootFromParent_Done,
     /*  634983 */   // Label 10271: @634983
     /*  634983 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(635058), // Rule ID 11859 //
     /*  634988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  634996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  635037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635056 */     GIR_RootConstrainSelectedInstOperands,
     /*  635057 */     // GIR_Coverage, 11859,
     /*  635057 */     GIR_EraseRootFromParent_Done,
     /*  635058 */   // Label 10272: @635058
     /*  635058 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(635133), // Rule ID 11862 //
     /*  635063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  635071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  635112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635131 */     GIR_RootConstrainSelectedInstOperands,
     /*  635132 */     // GIR_Coverage, 11862,
     /*  635132 */     GIR_EraseRootFromParent_Done,
     /*  635133 */   // Label 10273: @635133
     /*  635133 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(635208), // Rule ID 11863 //
     /*  635138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  635146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  635187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635206 */     GIR_RootConstrainSelectedInstOperands,
     /*  635207 */     // GIR_Coverage, 11863,
     /*  635207 */     GIR_EraseRootFromParent_Done,
     /*  635208 */   // Label 10274: @635208
     /*  635208 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(635283), // Rule ID 11866 //
     /*  635213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  635262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635281 */     GIR_RootConstrainSelectedInstOperands,
     /*  635282 */     // GIR_Coverage, 11866,
     /*  635282 */     GIR_EraseRootFromParent_Done,
     /*  635283 */   // Label 10275: @635283
     /*  635283 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(635358), // Rule ID 11867 //
     /*  635288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  635337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635356 */     GIR_RootConstrainSelectedInstOperands,
     /*  635357 */     // GIR_Coverage, 11867,
     /*  635357 */     GIR_EraseRootFromParent_Done,
     /*  635358 */   // Label 10276: @635358
     /*  635358 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(635433), // Rule ID 11870 //
     /*  635363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  635412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635431 */     GIR_RootConstrainSelectedInstOperands,
     /*  635432 */     // GIR_Coverage, 11870,
     /*  635432 */     GIR_EraseRootFromParent_Done,
     /*  635433 */   // Label 10277: @635433
     /*  635433 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(635508), // Rule ID 11871 //
     /*  635438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  635487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635506 */     GIR_RootConstrainSelectedInstOperands,
     /*  635507 */     // GIR_Coverage, 11871,
     /*  635507 */     GIR_EraseRootFromParent_Done,
     /*  635508 */   // Label 10278: @635508
     /*  635508 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(635583), // Rule ID 11874 //
     /*  635513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635559 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  635562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635581 */     GIR_RootConstrainSelectedInstOperands,
     /*  635582 */     // GIR_Coverage, 11874,
     /*  635582 */     GIR_EraseRootFromParent_Done,
     /*  635583 */   // Label 10279: @635583
     /*  635583 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(635658), // Rule ID 11875 //
     /*  635588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  635637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635656 */     GIR_RootConstrainSelectedInstOperands,
     /*  635657 */     // GIR_Coverage, 11875,
     /*  635657 */     GIR_EraseRootFromParent_Done,
     /*  635658 */   // Label 10280: @635658
     /*  635658 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(635733), // Rule ID 11878 //
     /*  635663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  635712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635731 */     GIR_RootConstrainSelectedInstOperands,
     /*  635732 */     // GIR_Coverage, 11878,
     /*  635732 */     GIR_EraseRootFromParent_Done,
     /*  635733 */   // Label 10281: @635733
     /*  635733 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(635808), // Rule ID 11879 //
     /*  635738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  635787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635806 */     GIR_RootConstrainSelectedInstOperands,
     /*  635807 */     // GIR_Coverage, 11879,
     /*  635807 */     GIR_EraseRootFromParent_Done,
     /*  635808 */   // Label 10282: @635808
     /*  635808 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(635883), // Rule ID 11882 //
     /*  635813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  635862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635881 */     GIR_RootConstrainSelectedInstOperands,
     /*  635882 */     // GIR_Coverage, 11882,
     /*  635882 */     GIR_EraseRootFromParent_Done,
     /*  635883 */   // Label 10283: @635883
     /*  635883 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(635958), // Rule ID 11883 //
     /*  635888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  635937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635956 */     GIR_RootConstrainSelectedInstOperands,
     /*  635957 */     // GIR_Coverage, 11883,
     /*  635957 */     GIR_EraseRootFromParent_Done,
     /*  635958 */   // Label 10284: @635958
     /*  635958 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(636033), // Rule ID 11886 //
     /*  635963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  635971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  636012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636031 */     GIR_RootConstrainSelectedInstOperands,
     /*  636032 */     // GIR_Coverage, 11886,
     /*  636032 */     GIR_EraseRootFromParent_Done,
     /*  636033 */   // Label 10285: @636033
     /*  636033 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(636108), // Rule ID 11887 //
     /*  636038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  636058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  636087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636106 */     GIR_RootConstrainSelectedInstOperands,
     /*  636107 */     // GIR_Coverage, 11887,
     /*  636107 */     GIR_EraseRootFromParent_Done,
     /*  636108 */   // Label 10286: @636108
     /*  636108 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(636183), // Rule ID 11890 //
     /*  636113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  636162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636181 */     GIR_RootConstrainSelectedInstOperands,
     /*  636182 */     // GIR_Coverage, 11890,
     /*  636182 */     GIR_EraseRootFromParent_Done,
     /*  636183 */   // Label 10287: @636183
     /*  636183 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(636258), // Rule ID 11891 //
     /*  636188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  636237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636256 */     GIR_RootConstrainSelectedInstOperands,
     /*  636257 */     // GIR_Coverage, 11891,
     /*  636257 */     GIR_EraseRootFromParent_Done,
     /*  636258 */   // Label 10288: @636258
     /*  636258 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(636333), // Rule ID 11894 //
     /*  636263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  636312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636331 */     GIR_RootConstrainSelectedInstOperands,
     /*  636332 */     // GIR_Coverage, 11894,
     /*  636332 */     GIR_EraseRootFromParent_Done,
     /*  636333 */   // Label 10289: @636333
     /*  636333 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(636408), // Rule ID 11895 //
     /*  636338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  636387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636406 */     GIR_RootConstrainSelectedInstOperands,
     /*  636407 */     // GIR_Coverage, 11895,
     /*  636407 */     GIR_EraseRootFromParent_Done,
     /*  636408 */   // Label 10290: @636408
     /*  636408 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(636483), // Rule ID 11898 //
     /*  636413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  636462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636481 */     GIR_RootConstrainSelectedInstOperands,
     /*  636482 */     // GIR_Coverage, 11898,
     /*  636482 */     GIR_EraseRootFromParent_Done,
     /*  636483 */   // Label 10291: @636483
     /*  636483 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(636558), // Rule ID 11899 //
     /*  636488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  636537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636556 */     GIR_RootConstrainSelectedInstOperands,
     /*  636557 */     // GIR_Coverage, 11899,
     /*  636557 */     GIR_EraseRootFromParent_Done,
     /*  636558 */   // Label 10292: @636558
     /*  636558 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(636633), // Rule ID 11902 //
     /*  636563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  636612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636631 */     GIR_RootConstrainSelectedInstOperands,
     /*  636632 */     // GIR_Coverage, 11902,
     /*  636632 */     GIR_EraseRootFromParent_Done,
     /*  636633 */   // Label 10293: @636633
     /*  636633 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(636708), // Rule ID 11903 //
     /*  636638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  636687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636706 */     GIR_RootConstrainSelectedInstOperands,
     /*  636707 */     // GIR_Coverage, 11903,
     /*  636707 */     GIR_EraseRootFromParent_Done,
     /*  636708 */   // Label 10294: @636708
     /*  636708 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(636783), // Rule ID 11906 //
     /*  636713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  636762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636781 */     GIR_RootConstrainSelectedInstOperands,
     /*  636782 */     // GIR_Coverage, 11906,
     /*  636782 */     GIR_EraseRootFromParent_Done,
     /*  636783 */   // Label 10295: @636783
     /*  636783 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(636858), // Rule ID 11907 //
     /*  636788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  636837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636856 */     GIR_RootConstrainSelectedInstOperands,
     /*  636857 */     // GIR_Coverage, 11907,
     /*  636857 */     GIR_EraseRootFromParent_Done,
     /*  636858 */   // Label 10296: @636858
     /*  636858 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(636933), // Rule ID 11910 //
     /*  636863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  636912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636931 */     GIR_RootConstrainSelectedInstOperands,
     /*  636932 */     // GIR_Coverage, 11910,
     /*  636932 */     GIR_EraseRootFromParent_Done,
     /*  636933 */   // Label 10297: @636933
     /*  636933 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(637008), // Rule ID 11911 //
     /*  636938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  636946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  636987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637006 */     GIR_RootConstrainSelectedInstOperands,
     /*  637007 */     // GIR_Coverage, 11911,
     /*  637007 */     GIR_EraseRootFromParent_Done,
     /*  637008 */   // Label 10298: @637008
     /*  637008 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(637083), // Rule ID 11914 //
     /*  637013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637059 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  637062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637081 */     GIR_RootConstrainSelectedInstOperands,
     /*  637082 */     // GIR_Coverage, 11914,
     /*  637082 */     GIR_EraseRootFromParent_Done,
     /*  637083 */   // Label 10299: @637083
     /*  637083 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(637158), // Rule ID 11915 //
     /*  637088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  637137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637156 */     GIR_RootConstrainSelectedInstOperands,
     /*  637157 */     // GIR_Coverage, 11915,
     /*  637157 */     GIR_EraseRootFromParent_Done,
     /*  637158 */   // Label 10300: @637158
     /*  637158 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(637233), // Rule ID 11918 //
     /*  637163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  637212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637231 */     GIR_RootConstrainSelectedInstOperands,
     /*  637232 */     // GIR_Coverage, 11918,
     /*  637232 */     GIR_EraseRootFromParent_Done,
     /*  637233 */   // Label 10301: @637233
     /*  637233 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(637308), // Rule ID 11919 //
     /*  637238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  637287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637306 */     GIR_RootConstrainSelectedInstOperands,
     /*  637307 */     // GIR_Coverage, 11919,
     /*  637307 */     GIR_EraseRootFromParent_Done,
     /*  637308 */   // Label 10302: @637308
     /*  637308 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(637383), // Rule ID 11922 //
     /*  637313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637359 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  637362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637381 */     GIR_RootConstrainSelectedInstOperands,
     /*  637382 */     // GIR_Coverage, 11922,
     /*  637382 */     GIR_EraseRootFromParent_Done,
     /*  637383 */   // Label 10303: @637383
     /*  637383 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(637458), // Rule ID 11923 //
     /*  637388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  637437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637456 */     GIR_RootConstrainSelectedInstOperands,
     /*  637457 */     // GIR_Coverage, 11923,
     /*  637457 */     GIR_EraseRootFromParent_Done,
     /*  637458 */   // Label 10304: @637458
     /*  637458 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(637533), // Rule ID 11926 //
     /*  637463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637509 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  637512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637531 */     GIR_RootConstrainSelectedInstOperands,
     /*  637532 */     // GIR_Coverage, 11926,
     /*  637532 */     GIR_EraseRootFromParent_Done,
     /*  637533 */   // Label 10305: @637533
     /*  637533 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(637608), // Rule ID 11927 //
     /*  637538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  637587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637606 */     GIR_RootConstrainSelectedInstOperands,
     /*  637607 */     // GIR_Coverage, 11927,
     /*  637607 */     GIR_EraseRootFromParent_Done,
     /*  637608 */   // Label 10306: @637608
     /*  637608 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(637683), // Rule ID 11930 //
     /*  637613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  637662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637681 */     GIR_RootConstrainSelectedInstOperands,
     /*  637682 */     // GIR_Coverage, 11930,
     /*  637682 */     GIR_EraseRootFromParent_Done,
     /*  637683 */   // Label 10307: @637683
     /*  637683 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(637758), // Rule ID 11931 //
     /*  637688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  637737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637756 */     GIR_RootConstrainSelectedInstOperands,
     /*  637757 */     // GIR_Coverage, 11931,
     /*  637757 */     GIR_EraseRootFromParent_Done,
     /*  637758 */   // Label 10308: @637758
     /*  637758 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(637833), // Rule ID 11934 //
     /*  637763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  637812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637831 */     GIR_RootConstrainSelectedInstOperands,
     /*  637832 */     // GIR_Coverage, 11934,
     /*  637832 */     GIR_EraseRootFromParent_Done,
     /*  637833 */   // Label 10309: @637833
     /*  637833 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(637908), // Rule ID 11935 //
     /*  637838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  637887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637906 */     GIR_RootConstrainSelectedInstOperands,
     /*  637907 */     // GIR_Coverage, 11935,
     /*  637907 */     GIR_EraseRootFromParent_Done,
     /*  637908 */   // Label 10310: @637908
     /*  637908 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(637983), // Rule ID 11938 //
     /*  637913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  637962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637981 */     GIR_RootConstrainSelectedInstOperands,
     /*  637982 */     // GIR_Coverage, 11938,
     /*  637982 */     GIR_EraseRootFromParent_Done,
     /*  637983 */   // Label 10311: @637983
     /*  637983 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(638058), // Rule ID 11939 //
     /*  637988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  637996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  638008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  638037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638056 */     GIR_RootConstrainSelectedInstOperands,
     /*  638057 */     // GIR_Coverage, 11939,
     /*  638057 */     GIR_EraseRootFromParent_Done,
     /*  638058 */   // Label 10312: @638058
     /*  638058 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(638133), // Rule ID 11942 //
     /*  638063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  638112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638131 */     GIR_RootConstrainSelectedInstOperands,
     /*  638132 */     // GIR_Coverage, 11942,
     /*  638132 */     GIR_EraseRootFromParent_Done,
     /*  638133 */   // Label 10313: @638133
     /*  638133 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(638208), // Rule ID 11943 //
     /*  638138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  638187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638206 */     GIR_RootConstrainSelectedInstOperands,
     /*  638207 */     // GIR_Coverage, 11943,
     /*  638207 */     GIR_EraseRootFromParent_Done,
     /*  638208 */   // Label 10314: @638208
     /*  638208 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(638283), // Rule ID 11946 //
     /*  638213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638259 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  638262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638281 */     GIR_RootConstrainSelectedInstOperands,
     /*  638282 */     // GIR_Coverage, 11946,
     /*  638282 */     GIR_EraseRootFromParent_Done,
     /*  638283 */   // Label 10315: @638283
     /*  638283 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(638358), // Rule ID 11947 //
     /*  638288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  638337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638356 */     GIR_RootConstrainSelectedInstOperands,
     /*  638357 */     // GIR_Coverage, 11947,
     /*  638357 */     GIR_EraseRootFromParent_Done,
     /*  638358 */   // Label 10316: @638358
     /*  638358 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(638433), // Rule ID 11950 //
     /*  638363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  638412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638431 */     GIR_RootConstrainSelectedInstOperands,
     /*  638432 */     // GIR_Coverage, 11950,
     /*  638432 */     GIR_EraseRootFromParent_Done,
     /*  638433 */   // Label 10317: @638433
     /*  638433 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(638508), // Rule ID 11951 //
     /*  638438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  638487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638506 */     GIR_RootConstrainSelectedInstOperands,
     /*  638507 */     // GIR_Coverage, 11951,
     /*  638507 */     GIR_EraseRootFromParent_Done,
     /*  638508 */   // Label 10318: @638508
     /*  638508 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(638583), // Rule ID 11954 //
     /*  638513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638559 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  638562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638581 */     GIR_RootConstrainSelectedInstOperands,
     /*  638582 */     // GIR_Coverage, 11954,
     /*  638582 */     GIR_EraseRootFromParent_Done,
     /*  638583 */   // Label 10319: @638583
     /*  638583 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(638658), // Rule ID 11955 //
     /*  638588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  638637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638656 */     GIR_RootConstrainSelectedInstOperands,
     /*  638657 */     // GIR_Coverage, 11955,
     /*  638657 */     GIR_EraseRootFromParent_Done,
     /*  638658 */   // Label 10320: @638658
     /*  638658 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(638733), // Rule ID 11958 //
     /*  638663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  638712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638731 */     GIR_RootConstrainSelectedInstOperands,
     /*  638732 */     // GIR_Coverage, 11958,
     /*  638732 */     GIR_EraseRootFromParent_Done,
     /*  638733 */   // Label 10321: @638733
     /*  638733 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(638808), // Rule ID 11959 //
     /*  638738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  638787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638806 */     GIR_RootConstrainSelectedInstOperands,
     /*  638807 */     // GIR_Coverage, 11959,
     /*  638807 */     GIR_EraseRootFromParent_Done,
     /*  638808 */   // Label 10322: @638808
     /*  638808 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(638883), // Rule ID 11962 //
     /*  638813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  638862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638881 */     GIR_RootConstrainSelectedInstOperands,
     /*  638882 */     // GIR_Coverage, 11962,
     /*  638882 */     GIR_EraseRootFromParent_Done,
     /*  638883 */   // Label 10323: @638883
     /*  638883 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(638958), // Rule ID 11963 //
     /*  638888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  638937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638956 */     GIR_RootConstrainSelectedInstOperands,
     /*  638957 */     // GIR_Coverage, 11963,
     /*  638957 */     GIR_EraseRootFromParent_Done,
     /*  638958 */   // Label 10324: @638958
     /*  638958 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(639033), // Rule ID 11966 //
     /*  638963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  638971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  639012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639031 */     GIR_RootConstrainSelectedInstOperands,
     /*  639032 */     // GIR_Coverage, 11966,
     /*  639032 */     GIR_EraseRootFromParent_Done,
     /*  639033 */   // Label 10325: @639033
     /*  639033 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(639108), // Rule ID 11967 //
     /*  639038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  639087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639106 */     GIR_RootConstrainSelectedInstOperands,
     /*  639107 */     // GIR_Coverage, 11967,
     /*  639107 */     GIR_EraseRootFromParent_Done,
     /*  639108 */   // Label 10326: @639108
     /*  639108 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(639183), // Rule ID 11970 //
     /*  639113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  639162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639181 */     GIR_RootConstrainSelectedInstOperands,
     /*  639182 */     // GIR_Coverage, 11970,
     /*  639182 */     GIR_EraseRootFromParent_Done,
     /*  639183 */   // Label 10327: @639183
     /*  639183 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(639258), // Rule ID 11971 //
     /*  639188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  639237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639256 */     GIR_RootConstrainSelectedInstOperands,
     /*  639257 */     // GIR_Coverage, 11971,
     /*  639257 */     GIR_EraseRootFromParent_Done,
     /*  639258 */   // Label 10328: @639258
     /*  639258 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(639333), // Rule ID 11974 //
     /*  639263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639309 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  639312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639331 */     GIR_RootConstrainSelectedInstOperands,
     /*  639332 */     // GIR_Coverage, 11974,
     /*  639332 */     GIR_EraseRootFromParent_Done,
     /*  639333 */   // Label 10329: @639333
     /*  639333 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(639408), // Rule ID 11975 //
     /*  639338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  639387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639406 */     GIR_RootConstrainSelectedInstOperands,
     /*  639407 */     // GIR_Coverage, 11975,
     /*  639407 */     GIR_EraseRootFromParent_Done,
     /*  639408 */   // Label 10330: @639408
     /*  639408 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(639483), // Rule ID 11978 //
     /*  639413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  639462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639481 */     GIR_RootConstrainSelectedInstOperands,
     /*  639482 */     // GIR_Coverage, 11978,
     /*  639482 */     GIR_EraseRootFromParent_Done,
     /*  639483 */   // Label 10331: @639483
     /*  639483 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(639558), // Rule ID 11979 //
     /*  639488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  639537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639556 */     GIR_RootConstrainSelectedInstOperands,
     /*  639557 */     // GIR_Coverage, 11979,
     /*  639557 */     GIR_EraseRootFromParent_Done,
     /*  639558 */   // Label 10332: @639558
     /*  639558 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(639633), // Rule ID 11982 //
     /*  639563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639609 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  639612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639631 */     GIR_RootConstrainSelectedInstOperands,
     /*  639632 */     // GIR_Coverage, 11982,
     /*  639632 */     GIR_EraseRootFromParent_Done,
     /*  639633 */   // Label 10333: @639633
     /*  639633 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(639708), // Rule ID 11983 //
     /*  639638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  639687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639706 */     GIR_RootConstrainSelectedInstOperands,
     /*  639707 */     // GIR_Coverage, 11983,
     /*  639707 */     GIR_EraseRootFromParent_Done,
     /*  639708 */   // Label 10334: @639708
     /*  639708 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(639783), // Rule ID 11986 //
     /*  639713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  639762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639781 */     GIR_RootConstrainSelectedInstOperands,
     /*  639782 */     // GIR_Coverage, 11986,
     /*  639782 */     GIR_EraseRootFromParent_Done,
     /*  639783 */   // Label 10335: @639783
     /*  639783 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(639858), // Rule ID 11987 //
     /*  639788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  639837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639856 */     GIR_RootConstrainSelectedInstOperands,
     /*  639857 */     // GIR_Coverage, 11987,
     /*  639857 */     GIR_EraseRootFromParent_Done,
     /*  639858 */   // Label 10336: @639858
     /*  639858 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(639933), // Rule ID 11990 //
     /*  639863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  639866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  639909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  639912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639931 */     GIR_RootConstrainSelectedInstOperands,
     /*  639932 */     // GIR_Coverage, 11990,
     /*  639932 */     GIR_EraseRootFromParent_Done,
     /*  639933 */   // Label 10337: @639933
     /*  639933 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(640008), // Rule ID 11991 //
     /*  639938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  639941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  639946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  639984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  639987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640006 */     GIR_RootConstrainSelectedInstOperands,
     /*  640007 */     // GIR_Coverage, 11991,
     /*  640007 */     GIR_EraseRootFromParent_Done,
     /*  640008 */   // Label 10338: @640008
     /*  640008 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(640083), // Rule ID 11994 //
     /*  640013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  640062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640081 */     GIR_RootConstrainSelectedInstOperands,
     /*  640082 */     // GIR_Coverage, 11994,
     /*  640082 */     GIR_EraseRootFromParent_Done,
     /*  640083 */   // Label 10339: @640083
     /*  640083 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(640158), // Rule ID 11995 //
     /*  640088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  640137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640156 */     GIR_RootConstrainSelectedInstOperands,
     /*  640157 */     // GIR_Coverage, 11995,
     /*  640157 */     GIR_EraseRootFromParent_Done,
     /*  640158 */   // Label 10340: @640158
     /*  640158 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(640233), // Rule ID 11998 //
     /*  640163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640209 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  640212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640231 */     GIR_RootConstrainSelectedInstOperands,
     /*  640232 */     // GIR_Coverage, 11998,
     /*  640232 */     GIR_EraseRootFromParent_Done,
     /*  640233 */   // Label 10341: @640233
     /*  640233 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(640308), // Rule ID 11999 //
     /*  640238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  640287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640306 */     GIR_RootConstrainSelectedInstOperands,
     /*  640307 */     // GIR_Coverage, 11999,
     /*  640307 */     GIR_EraseRootFromParent_Done,
     /*  640308 */   // Label 10342: @640308
     /*  640308 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(640383), // Rule ID 12002 //
     /*  640313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640359 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  640362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640381 */     GIR_RootConstrainSelectedInstOperands,
     /*  640382 */     // GIR_Coverage, 12002,
     /*  640382 */     GIR_EraseRootFromParent_Done,
     /*  640383 */   // Label 10343: @640383
     /*  640383 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(640458), // Rule ID 12003 //
     /*  640388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640434 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  640437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640456 */     GIR_RootConstrainSelectedInstOperands,
     /*  640457 */     // GIR_Coverage, 12003,
     /*  640457 */     GIR_EraseRootFromParent_Done,
     /*  640458 */   // Label 10344: @640458
     /*  640458 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(640533), // Rule ID 12006 //
     /*  640463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  640512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640531 */     GIR_RootConstrainSelectedInstOperands,
     /*  640532 */     // GIR_Coverage, 12006,
     /*  640532 */     GIR_EraseRootFromParent_Done,
     /*  640533 */   // Label 10345: @640533
     /*  640533 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(640608), // Rule ID 12007 //
     /*  640538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  640587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640606 */     GIR_RootConstrainSelectedInstOperands,
     /*  640607 */     // GIR_Coverage, 12007,
     /*  640607 */     GIR_EraseRootFromParent_Done,
     /*  640608 */   // Label 10346: @640608
     /*  640608 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(640683), // Rule ID 12010 //
     /*  640613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640659 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  640662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640681 */     GIR_RootConstrainSelectedInstOperands,
     /*  640682 */     // GIR_Coverage, 12010,
     /*  640682 */     GIR_EraseRootFromParent_Done,
     /*  640683 */   // Label 10347: @640683
     /*  640683 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(640758), // Rule ID 12011 //
     /*  640688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  640737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640756 */     GIR_RootConstrainSelectedInstOperands,
     /*  640757 */     // GIR_Coverage, 12011,
     /*  640757 */     GIR_EraseRootFromParent_Done,
     /*  640758 */   // Label 10348: @640758
     /*  640758 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(640833), // Rule ID 12014 //
     /*  640763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  640812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640831 */     GIR_RootConstrainSelectedInstOperands,
     /*  640832 */     // GIR_Coverage, 12014,
     /*  640832 */     GIR_EraseRootFromParent_Done,
     /*  640833 */   // Label 10349: @640833
     /*  640833 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(640908), // Rule ID 12015 //
     /*  640838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  640887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640906 */     GIR_RootConstrainSelectedInstOperands,
     /*  640907 */     // GIR_Coverage, 12015,
     /*  640907 */     GIR_EraseRootFromParent_Done,
     /*  640908 */   // Label 10350: @640908
     /*  640908 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(640983), // Rule ID 12018 //
     /*  640913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  640962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640981 */     GIR_RootConstrainSelectedInstOperands,
     /*  640982 */     // GIR_Coverage, 12018,
     /*  640982 */     GIR_EraseRootFromParent_Done,
     /*  640983 */   // Label 10351: @640983
     /*  640983 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(641058), // Rule ID 12019 //
     /*  640988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  640996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  641037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641056 */     GIR_RootConstrainSelectedInstOperands,
     /*  641057 */     // GIR_Coverage, 12019,
     /*  641057 */     GIR_EraseRootFromParent_Done,
     /*  641058 */   // Label 10352: @641058
     /*  641058 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(641133), // Rule ID 12022 //
     /*  641063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  641112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641131 */     GIR_RootConstrainSelectedInstOperands,
     /*  641132 */     // GIR_Coverage, 12022,
     /*  641132 */     GIR_EraseRootFromParent_Done,
     /*  641133 */   // Label 10353: @641133
     /*  641133 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(641208), // Rule ID 12023 //
     /*  641138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  641187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641206 */     GIR_RootConstrainSelectedInstOperands,
     /*  641207 */     // GIR_Coverage, 12023,
     /*  641207 */     GIR_EraseRootFromParent_Done,
     /*  641208 */   // Label 10354: @641208
     /*  641208 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(641283), // Rule ID 12026 //
     /*  641213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  641262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641281 */     GIR_RootConstrainSelectedInstOperands,
     /*  641282 */     // GIR_Coverage, 12026,
     /*  641282 */     GIR_EraseRootFromParent_Done,
     /*  641283 */   // Label 10355: @641283
     /*  641283 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(641358), // Rule ID 12027 //
     /*  641288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  641337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641356 */     GIR_RootConstrainSelectedInstOperands,
     /*  641357 */     // GIR_Coverage, 12027,
     /*  641357 */     GIR_EraseRootFromParent_Done,
     /*  641358 */   // Label 10356: @641358
     /*  641358 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(641433), // Rule ID 12030 //
     /*  641363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  641412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641431 */     GIR_RootConstrainSelectedInstOperands,
     /*  641432 */     // GIR_Coverage, 12030,
     /*  641432 */     GIR_EraseRootFromParent_Done,
     /*  641433 */   // Label 10357: @641433
     /*  641433 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(641508), // Rule ID 12031 //
     /*  641438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  641487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641506 */     GIR_RootConstrainSelectedInstOperands,
     /*  641507 */     // GIR_Coverage, 12031,
     /*  641507 */     GIR_EraseRootFromParent_Done,
     /*  641508 */   // Label 10358: @641508
     /*  641508 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(641583), // Rule ID 12034 //
     /*  641513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  641562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641581 */     GIR_RootConstrainSelectedInstOperands,
     /*  641582 */     // GIR_Coverage, 12034,
     /*  641582 */     GIR_EraseRootFromParent_Done,
     /*  641583 */   // Label 10359: @641583
     /*  641583 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(641658), // Rule ID 12035 //
     /*  641588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  641637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641656 */     GIR_RootConstrainSelectedInstOperands,
     /*  641657 */     // GIR_Coverage, 12035,
     /*  641657 */     GIR_EraseRootFromParent_Done,
     /*  641658 */   // Label 10360: @641658
     /*  641658 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(641733), // Rule ID 12038 //
     /*  641663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  641712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641731 */     GIR_RootConstrainSelectedInstOperands,
     /*  641732 */     // GIR_Coverage, 12038,
     /*  641732 */     GIR_EraseRootFromParent_Done,
     /*  641733 */   // Label 10361: @641733
     /*  641733 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(641808), // Rule ID 12039 //
     /*  641738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  641746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  641787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641806 */     GIR_RootConstrainSelectedInstOperands,
     /*  641807 */     // GIR_Coverage, 12039,
     /*  641807 */     GIR_EraseRootFromParent_Done,
     /*  641808 */   // Label 10362: @641808
     /*  641808 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(641883), // Rule ID 12042 //
     /*  641813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  641821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  641862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641881 */     GIR_RootConstrainSelectedInstOperands,
     /*  641882 */     // GIR_Coverage, 12042,
     /*  641882 */     GIR_EraseRootFromParent_Done,
     /*  641883 */   // Label 10363: @641883
     /*  641883 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(641958), // Rule ID 12043 //
     /*  641888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  641896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641934 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  641937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641956 */     GIR_RootConstrainSelectedInstOperands,
     /*  641957 */     // GIR_Coverage, 12043,
     /*  641957 */     GIR_EraseRootFromParent_Done,
     /*  641958 */   // Label 10364: @641958
     /*  641958 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(642033), // Rule ID 12046 //
     /*  641963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  641971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  642012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642031 */     GIR_RootConstrainSelectedInstOperands,
     /*  642032 */     // GIR_Coverage, 12046,
     /*  642032 */     GIR_EraseRootFromParent_Done,
     /*  642033 */   // Label 10365: @642033
     /*  642033 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(642108), // Rule ID 12047 //
     /*  642038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  642058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  642087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642106 */     GIR_RootConstrainSelectedInstOperands,
     /*  642107 */     // GIR_Coverage, 12047,
     /*  642107 */     GIR_EraseRootFromParent_Done,
     /*  642108 */   // Label 10366: @642108
     /*  642108 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(642183), // Rule ID 12050 //
     /*  642113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  642162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642181 */     GIR_RootConstrainSelectedInstOperands,
     /*  642182 */     // GIR_Coverage, 12050,
     /*  642182 */     GIR_EraseRootFromParent_Done,
     /*  642183 */   // Label 10367: @642183
     /*  642183 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(642258), // Rule ID 12051 //
     /*  642188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  642237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642256 */     GIR_RootConstrainSelectedInstOperands,
     /*  642257 */     // GIR_Coverage, 12051,
     /*  642257 */     GIR_EraseRootFromParent_Done,
     /*  642258 */   // Label 10368: @642258
     /*  642258 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(642333), // Rule ID 12054 //
     /*  642263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  642312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642331 */     GIR_RootConstrainSelectedInstOperands,
     /*  642332 */     // GIR_Coverage, 12054,
     /*  642332 */     GIR_EraseRootFromParent_Done,
     /*  642333 */   // Label 10369: @642333
     /*  642333 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(642408), // Rule ID 12055 //
     /*  642338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642384 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  642387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642406 */     GIR_RootConstrainSelectedInstOperands,
     /*  642407 */     // GIR_Coverage, 12055,
     /*  642407 */     GIR_EraseRootFromParent_Done,
     /*  642408 */   // Label 10370: @642408
     /*  642408 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(642483), // Rule ID 12058 //
     /*  642413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642459 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  642462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642481 */     GIR_RootConstrainSelectedInstOperands,
     /*  642482 */     // GIR_Coverage, 12058,
     /*  642482 */     GIR_EraseRootFromParent_Done,
     /*  642483 */   // Label 10371: @642483
     /*  642483 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(642558), // Rule ID 12059 //
     /*  642488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  642537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642556 */     GIR_RootConstrainSelectedInstOperands,
     /*  642557 */     // GIR_Coverage, 12059,
     /*  642557 */     GIR_EraseRootFromParent_Done,
     /*  642558 */   // Label 10372: @642558
     /*  642558 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(642633), // Rule ID 12062 //
     /*  642563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  642612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642631 */     GIR_RootConstrainSelectedInstOperands,
     /*  642632 */     // GIR_Coverage, 12062,
     /*  642632 */     GIR_EraseRootFromParent_Done,
     /*  642633 */   // Label 10373: @642633
     /*  642633 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(642708), // Rule ID 12063 //
     /*  642638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  642687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642706 */     GIR_RootConstrainSelectedInstOperands,
     /*  642707 */     // GIR_Coverage, 12063,
     /*  642707 */     GIR_EraseRootFromParent_Done,
     /*  642708 */   // Label 10374: @642708
     /*  642708 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(642783), // Rule ID 12066 //
     /*  642713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  642762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642781 */     GIR_RootConstrainSelectedInstOperands,
     /*  642782 */     // GIR_Coverage, 12066,
     /*  642782 */     GIR_EraseRootFromParent_Done,
     /*  642783 */   // Label 10375: @642783
     /*  642783 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(642858), // Rule ID 12067 //
     /*  642788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  642837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642856 */     GIR_RootConstrainSelectedInstOperands,
     /*  642857 */     // GIR_Coverage, 12067,
     /*  642857 */     GIR_EraseRootFromParent_Done,
     /*  642858 */   // Label 10376: @642858
     /*  642858 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(642933), // Rule ID 12070 //
     /*  642863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  642912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642931 */     GIR_RootConstrainSelectedInstOperands,
     /*  642932 */     // GIR_Coverage, 12070,
     /*  642932 */     GIR_EraseRootFromParent_Done,
     /*  642933 */   // Label 10377: @642933
     /*  642933 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(643008), // Rule ID 12071 //
     /*  642938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  642946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  642987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643006 */     GIR_RootConstrainSelectedInstOperands,
     /*  643007 */     // GIR_Coverage, 12071,
     /*  643007 */     GIR_EraseRootFromParent_Done,
     /*  643008 */   // Label 10378: @643008
     /*  643008 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(643083), // Rule ID 12074 //
     /*  643013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  643062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643081 */     GIR_RootConstrainSelectedInstOperands,
     /*  643082 */     // GIR_Coverage, 12074,
     /*  643082 */     GIR_EraseRootFromParent_Done,
     /*  643083 */   // Label 10379: @643083
     /*  643083 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(643158), // Rule ID 12075 //
     /*  643088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  643137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643156 */     GIR_RootConstrainSelectedInstOperands,
     /*  643157 */     // GIR_Coverage, 12075,
     /*  643157 */     GIR_EraseRootFromParent_Done,
     /*  643158 */   // Label 10380: @643158
     /*  643158 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(643233), // Rule ID 12078 //
     /*  643163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  643212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643231 */     GIR_RootConstrainSelectedInstOperands,
     /*  643232 */     // GIR_Coverage, 12078,
     /*  643232 */     GIR_EraseRootFromParent_Done,
     /*  643233 */   // Label 10381: @643233
     /*  643233 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(643308), // Rule ID 12079 //
     /*  643238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  643287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643306 */     GIR_RootConstrainSelectedInstOperands,
     /*  643307 */     // GIR_Coverage, 12079,
     /*  643307 */     GIR_EraseRootFromParent_Done,
     /*  643308 */   // Label 10382: @643308
     /*  643308 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(643383), // Rule ID 12082 //
     /*  643313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  643362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643381 */     GIR_RootConstrainSelectedInstOperands,
     /*  643382 */     // GIR_Coverage, 12082,
     /*  643382 */     GIR_EraseRootFromParent_Done,
     /*  643383 */   // Label 10383: @643383
     /*  643383 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(643458), // Rule ID 12083 //
     /*  643388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  643437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643456 */     GIR_RootConstrainSelectedInstOperands,
     /*  643457 */     // GIR_Coverage, 12083,
     /*  643457 */     GIR_EraseRootFromParent_Done,
     /*  643458 */   // Label 10384: @643458
     /*  643458 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(643533), // Rule ID 12086 //
     /*  643463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  643512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643531 */     GIR_RootConstrainSelectedInstOperands,
     /*  643532 */     // GIR_Coverage, 12086,
     /*  643532 */     GIR_EraseRootFromParent_Done,
     /*  643533 */   // Label 10385: @643533
     /*  643533 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(643608), // Rule ID 12087 //
     /*  643538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  643587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643606 */     GIR_RootConstrainSelectedInstOperands,
     /*  643607 */     // GIR_Coverage, 12087,
     /*  643607 */     GIR_EraseRootFromParent_Done,
     /*  643608 */   // Label 10386: @643608
     /*  643608 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(643683), // Rule ID 12090 //
     /*  643613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643659 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  643662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643681 */     GIR_RootConstrainSelectedInstOperands,
     /*  643682 */     // GIR_Coverage, 12090,
     /*  643682 */     GIR_EraseRootFromParent_Done,
     /*  643683 */   // Label 10387: @643683
     /*  643683 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(643758), // Rule ID 12091 //
     /*  643688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  643737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643756 */     GIR_RootConstrainSelectedInstOperands,
     /*  643757 */     // GIR_Coverage, 12091,
     /*  643757 */     GIR_EraseRootFromParent_Done,
     /*  643758 */   // Label 10388: @643758
     /*  643758 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(643833), // Rule ID 12094 //
     /*  643763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  643812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643831 */     GIR_RootConstrainSelectedInstOperands,
     /*  643832 */     // GIR_Coverage, 12094,
     /*  643832 */     GIR_EraseRootFromParent_Done,
     /*  643833 */   // Label 10389: @643833
     /*  643833 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(643908), // Rule ID 12095 //
     /*  643838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  643887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643906 */     GIR_RootConstrainSelectedInstOperands,
     /*  643907 */     // GIR_Coverage, 12095,
     /*  643907 */     GIR_EraseRootFromParent_Done,
     /*  643908 */   // Label 10390: @643908
     /*  643908 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(643983), // Rule ID 12098 //
     /*  643913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  643962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643981 */     GIR_RootConstrainSelectedInstOperands,
     /*  643982 */     // GIR_Coverage, 12098,
     /*  643982 */     GIR_EraseRootFromParent_Done,
     /*  643983 */   // Label 10391: @643983
     /*  643983 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(644058), // Rule ID 12099 //
     /*  643988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  643996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  644008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  644037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644056 */     GIR_RootConstrainSelectedInstOperands,
     /*  644057 */     // GIR_Coverage, 12099,
     /*  644057 */     GIR_EraseRootFromParent_Done,
     /*  644058 */   // Label 10392: @644058
     /*  644058 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(644133), // Rule ID 12102 //
     /*  644063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  644112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644131 */     GIR_RootConstrainSelectedInstOperands,
     /*  644132 */     // GIR_Coverage, 12102,
     /*  644132 */     GIR_EraseRootFromParent_Done,
     /*  644133 */   // Label 10393: @644133
     /*  644133 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(644208), // Rule ID 12103 //
     /*  644138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  644187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644206 */     GIR_RootConstrainSelectedInstOperands,
     /*  644207 */     // GIR_Coverage, 12103,
     /*  644207 */     GIR_EraseRootFromParent_Done,
     /*  644208 */   // Label 10394: @644208
     /*  644208 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(644283), // Rule ID 12106 //
     /*  644213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  644262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644281 */     GIR_RootConstrainSelectedInstOperands,
     /*  644282 */     // GIR_Coverage, 12106,
     /*  644282 */     GIR_EraseRootFromParent_Done,
     /*  644283 */   // Label 10395: @644283
     /*  644283 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(644358), // Rule ID 12107 //
     /*  644288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  644337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644356 */     GIR_RootConstrainSelectedInstOperands,
     /*  644357 */     // GIR_Coverage, 12107,
     /*  644357 */     GIR_EraseRootFromParent_Done,
     /*  644358 */   // Label 10396: @644358
     /*  644358 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(644433), // Rule ID 12110 //
     /*  644363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  644412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644431 */     GIR_RootConstrainSelectedInstOperands,
     /*  644432 */     // GIR_Coverage, 12110,
     /*  644432 */     GIR_EraseRootFromParent_Done,
     /*  644433 */   // Label 10397: @644433
     /*  644433 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(644508), // Rule ID 12111 //
     /*  644438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  644487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644506 */     GIR_RootConstrainSelectedInstOperands,
     /*  644507 */     // GIR_Coverage, 12111,
     /*  644507 */     GIR_EraseRootFromParent_Done,
     /*  644508 */   // Label 10398: @644508
     /*  644508 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(644583), // Rule ID 12114 //
     /*  644513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  644562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644581 */     GIR_RootConstrainSelectedInstOperands,
     /*  644582 */     // GIR_Coverage, 12114,
     /*  644582 */     GIR_EraseRootFromParent_Done,
     /*  644583 */   // Label 10399: @644583
     /*  644583 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(644658), // Rule ID 12115 //
     /*  644588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  644637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644656 */     GIR_RootConstrainSelectedInstOperands,
     /*  644657 */     // GIR_Coverage, 12115,
     /*  644657 */     GIR_EraseRootFromParent_Done,
     /*  644658 */   // Label 10400: @644658
     /*  644658 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(644733), // Rule ID 12118 //
     /*  644663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  644712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644731 */     GIR_RootConstrainSelectedInstOperands,
     /*  644732 */     // GIR_Coverage, 12118,
     /*  644732 */     GIR_EraseRootFromParent_Done,
     /*  644733 */   // Label 10401: @644733
     /*  644733 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(644808), // Rule ID 12119 //
     /*  644738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  644787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644806 */     GIR_RootConstrainSelectedInstOperands,
     /*  644807 */     // GIR_Coverage, 12119,
     /*  644807 */     GIR_EraseRootFromParent_Done,
     /*  644808 */   // Label 10402: @644808
     /*  644808 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(644883), // Rule ID 12122 //
     /*  644813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  644862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644881 */     GIR_RootConstrainSelectedInstOperands,
     /*  644882 */     // GIR_Coverage, 12122,
     /*  644882 */     GIR_EraseRootFromParent_Done,
     /*  644883 */   // Label 10403: @644883
     /*  644883 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(644958), // Rule ID 12123 //
     /*  644888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  644937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644956 */     GIR_RootConstrainSelectedInstOperands,
     /*  644957 */     // GIR_Coverage, 12123,
     /*  644957 */     GIR_EraseRootFromParent_Done,
     /*  644958 */   // Label 10404: @644958
     /*  644958 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(645033), // Rule ID 12126 //
     /*  644963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  644971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645009 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  645012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645031 */     GIR_RootConstrainSelectedInstOperands,
     /*  645032 */     // GIR_Coverage, 12126,
     /*  645032 */     GIR_EraseRootFromParent_Done,
     /*  645033 */   // Label 10405: @645033
     /*  645033 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(645108), // Rule ID 12127 //
     /*  645038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  645058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  645087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645106 */     GIR_RootConstrainSelectedInstOperands,
     /*  645107 */     // GIR_Coverage, 12127,
     /*  645107 */     GIR_EraseRootFromParent_Done,
     /*  645108 */   // Label 10406: @645108
     /*  645108 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(645183), // Rule ID 12130 //
     /*  645113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645159 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  645162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645181 */     GIR_RootConstrainSelectedInstOperands,
     /*  645182 */     // GIR_Coverage, 12130,
     /*  645182 */     GIR_EraseRootFromParent_Done,
     /*  645183 */   // Label 10407: @645183
     /*  645183 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(645258), // Rule ID 12131 //
     /*  645188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  645237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645256 */     GIR_RootConstrainSelectedInstOperands,
     /*  645257 */     // GIR_Coverage, 12131,
     /*  645257 */     GIR_EraseRootFromParent_Done,
     /*  645258 */   // Label 10408: @645258
     /*  645258 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(645333), // Rule ID 12134 //
     /*  645263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  645312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645331 */     GIR_RootConstrainSelectedInstOperands,
     /*  645332 */     // GIR_Coverage, 12134,
     /*  645332 */     GIR_EraseRootFromParent_Done,
     /*  645333 */   // Label 10409: @645333
     /*  645333 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(645408), // Rule ID 12135 //
     /*  645338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  645387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645406 */     GIR_RootConstrainSelectedInstOperands,
     /*  645407 */     // GIR_Coverage, 12135,
     /*  645407 */     GIR_EraseRootFromParent_Done,
     /*  645408 */   // Label 10410: @645408
     /*  645408 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(645483), // Rule ID 12138 //
     /*  645413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645459 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  645462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645481 */     GIR_RootConstrainSelectedInstOperands,
     /*  645482 */     // GIR_Coverage, 12138,
     /*  645482 */     GIR_EraseRootFromParent_Done,
     /*  645483 */   // Label 10411: @645483
     /*  645483 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(645558), // Rule ID 12139 //
     /*  645488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  645537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645556 */     GIR_RootConstrainSelectedInstOperands,
     /*  645557 */     // GIR_Coverage, 12139,
     /*  645557 */     GIR_EraseRootFromParent_Done,
     /*  645558 */   // Label 10412: @645558
     /*  645558 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(645633), // Rule ID 12142 //
     /*  645563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  645612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645631 */     GIR_RootConstrainSelectedInstOperands,
     /*  645632 */     // GIR_Coverage, 12142,
     /*  645632 */     GIR_EraseRootFromParent_Done,
     /*  645633 */   // Label 10413: @645633
     /*  645633 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(645708), // Rule ID 12143 //
     /*  645638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  645687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645706 */     GIR_RootConstrainSelectedInstOperands,
     /*  645707 */     // GIR_Coverage, 12143,
     /*  645707 */     GIR_EraseRootFromParent_Done,
     /*  645708 */   // Label 10414: @645708
     /*  645708 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(645783), // Rule ID 12146 //
     /*  645713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645759 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  645762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645781 */     GIR_RootConstrainSelectedInstOperands,
     /*  645782 */     // GIR_Coverage, 12146,
     /*  645782 */     GIR_EraseRootFromParent_Done,
     /*  645783 */   // Label 10415: @645783
     /*  645783 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(645858), // Rule ID 12147 //
     /*  645788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  645837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645856 */     GIR_RootConstrainSelectedInstOperands,
     /*  645857 */     // GIR_Coverage, 12147,
     /*  645857 */     GIR_EraseRootFromParent_Done,
     /*  645858 */   // Label 10416: @645858
     /*  645858 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(645933), // Rule ID 12150 //
     /*  645863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  645912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645931 */     GIR_RootConstrainSelectedInstOperands,
     /*  645932 */     // GIR_Coverage, 12150,
     /*  645932 */     GIR_EraseRootFromParent_Done,
     /*  645933 */   // Label 10417: @645933
     /*  645933 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(646008), // Rule ID 12151 //
     /*  645938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  645946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  645984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  645987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646006 */     GIR_RootConstrainSelectedInstOperands,
     /*  646007 */     // GIR_Coverage, 12151,
     /*  646007 */     GIR_EraseRootFromParent_Done,
     /*  646008 */   // Label 10418: @646008
     /*  646008 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(646083), // Rule ID 12154 //
     /*  646013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  646062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646081 */     GIR_RootConstrainSelectedInstOperands,
     /*  646082 */     // GIR_Coverage, 12154,
     /*  646082 */     GIR_EraseRootFromParent_Done,
     /*  646083 */   // Label 10419: @646083
     /*  646083 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(646158), // Rule ID 12155 //
     /*  646088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  646137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646156 */     GIR_RootConstrainSelectedInstOperands,
     /*  646157 */     // GIR_Coverage, 12155,
     /*  646157 */     GIR_EraseRootFromParent_Done,
     /*  646158 */   // Label 10420: @646158
     /*  646158 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(646233), // Rule ID 12158 //
     /*  646163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  646212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646231 */     GIR_RootConstrainSelectedInstOperands,
     /*  646232 */     // GIR_Coverage, 12158,
     /*  646232 */     GIR_EraseRootFromParent_Done,
     /*  646233 */   // Label 10421: @646233
     /*  646233 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(646308), // Rule ID 12159 //
     /*  646238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  646287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646306 */     GIR_RootConstrainSelectedInstOperands,
     /*  646307 */     // GIR_Coverage, 12159,
     /*  646307 */     GIR_EraseRootFromParent_Done,
     /*  646308 */   // Label 10422: @646308
     /*  646308 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(646383), // Rule ID 12162 //
     /*  646313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  646362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646381 */     GIR_RootConstrainSelectedInstOperands,
     /*  646382 */     // GIR_Coverage, 12162,
     /*  646382 */     GIR_EraseRootFromParent_Done,
     /*  646383 */   // Label 10423: @646383
     /*  646383 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(646458), // Rule ID 12163 //
     /*  646388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  646437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646456 */     GIR_RootConstrainSelectedInstOperands,
     /*  646457 */     // GIR_Coverage, 12163,
     /*  646457 */     GIR_EraseRootFromParent_Done,
     /*  646458 */   // Label 10424: @646458
     /*  646458 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(646533), // Rule ID 12166 //
     /*  646463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  646512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646531 */     GIR_RootConstrainSelectedInstOperands,
     /*  646532 */     // GIR_Coverage, 12166,
     /*  646532 */     GIR_EraseRootFromParent_Done,
     /*  646533 */   // Label 10425: @646533
     /*  646533 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(646608), // Rule ID 12167 //
     /*  646538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  646587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646606 */     GIR_RootConstrainSelectedInstOperands,
     /*  646607 */     // GIR_Coverage, 12167,
     /*  646607 */     GIR_EraseRootFromParent_Done,
     /*  646608 */   // Label 10426: @646608
     /*  646608 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(646683), // Rule ID 12170 //
     /*  646613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  646662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646681 */     GIR_RootConstrainSelectedInstOperands,
     /*  646682 */     // GIR_Coverage, 12170,
     /*  646682 */     GIR_EraseRootFromParent_Done,
     /*  646683 */   // Label 10427: @646683
     /*  646683 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(646758), // Rule ID 12171 //
     /*  646688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  646737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646756 */     GIR_RootConstrainSelectedInstOperands,
     /*  646757 */     // GIR_Coverage, 12171,
     /*  646757 */     GIR_EraseRootFromParent_Done,
     /*  646758 */   // Label 10428: @646758
     /*  646758 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(646833), // Rule ID 12174 //
     /*  646763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646809 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  646812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646831 */     GIR_RootConstrainSelectedInstOperands,
     /*  646832 */     // GIR_Coverage, 12174,
     /*  646832 */     GIR_EraseRootFromParent_Done,
     /*  646833 */   // Label 10429: @646833
     /*  646833 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(646908), // Rule ID 12175 //
     /*  646838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  646887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646906 */     GIR_RootConstrainSelectedInstOperands,
     /*  646907 */     // GIR_Coverage, 12175,
     /*  646907 */     GIR_EraseRootFromParent_Done,
     /*  646908 */   // Label 10430: @646908
     /*  646908 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(646983), // Rule ID 12178 //
     /*  646913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646959 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  646962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646981 */     GIR_RootConstrainSelectedInstOperands,
     /*  646982 */     // GIR_Coverage, 12178,
     /*  646982 */     GIR_EraseRootFromParent_Done,
     /*  646983 */   // Label 10431: @646983
     /*  646983 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(647058), // Rule ID 12179 //
     /*  646988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  646996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647034 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  647037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647056 */     GIR_RootConstrainSelectedInstOperands,
     /*  647057 */     // GIR_Coverage, 12179,
     /*  647057 */     GIR_EraseRootFromParent_Done,
     /*  647058 */   // Label 10432: @647058
     /*  647058 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(647133), // Rule ID 12182 //
     /*  647063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  647112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647131 */     GIR_RootConstrainSelectedInstOperands,
     /*  647132 */     // GIR_Coverage, 12182,
     /*  647132 */     GIR_EraseRootFromParent_Done,
     /*  647133 */   // Label 10433: @647133
     /*  647133 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(647208), // Rule ID 12183 //
     /*  647138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  647187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647206 */     GIR_RootConstrainSelectedInstOperands,
     /*  647207 */     // GIR_Coverage, 12183,
     /*  647207 */     GIR_EraseRootFromParent_Done,
     /*  647208 */   // Label 10434: @647208
     /*  647208 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(647283), // Rule ID 12186 //
     /*  647213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647259 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  647262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647281 */     GIR_RootConstrainSelectedInstOperands,
     /*  647282 */     // GIR_Coverage, 12186,
     /*  647282 */     GIR_EraseRootFromParent_Done,
     /*  647283 */   // Label 10435: @647283
     /*  647283 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(647358), // Rule ID 12187 //
     /*  647288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  647337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647356 */     GIR_RootConstrainSelectedInstOperands,
     /*  647357 */     // GIR_Coverage, 12187,
     /*  647357 */     GIR_EraseRootFromParent_Done,
     /*  647358 */   // Label 10436: @647358
     /*  647358 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(647433), // Rule ID 12190 //
     /*  647363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  647412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647431 */     GIR_RootConstrainSelectedInstOperands,
     /*  647432 */     // GIR_Coverage, 12190,
     /*  647432 */     GIR_EraseRootFromParent_Done,
     /*  647433 */   // Label 10437: @647433
     /*  647433 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(647508), // Rule ID 12191 //
     /*  647438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647484 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  647487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647506 */     GIR_RootConstrainSelectedInstOperands,
     /*  647507 */     // GIR_Coverage, 12191,
     /*  647507 */     GIR_EraseRootFromParent_Done,
     /*  647508 */   // Label 10438: @647508
     /*  647508 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(647583), // Rule ID 12194 //
     /*  647513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  647562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647581 */     GIR_RootConstrainSelectedInstOperands,
     /*  647582 */     // GIR_Coverage, 12194,
     /*  647582 */     GIR_EraseRootFromParent_Done,
     /*  647583 */   // Label 10439: @647583
     /*  647583 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(647658), // Rule ID 12195 //
     /*  647588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  647637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647656 */     GIR_RootConstrainSelectedInstOperands,
     /*  647657 */     // GIR_Coverage, 12195,
     /*  647657 */     GIR_EraseRootFromParent_Done,
     /*  647658 */   // Label 10440: @647658
     /*  647658 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(647733), // Rule ID 12198 //
     /*  647663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647709 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  647712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647731 */     GIR_RootConstrainSelectedInstOperands,
     /*  647732 */     // GIR_Coverage, 12198,
     /*  647732 */     GIR_EraseRootFromParent_Done,
     /*  647733 */   // Label 10441: @647733
     /*  647733 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(647808), // Rule ID 12199 //
     /*  647738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  647787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647806 */     GIR_RootConstrainSelectedInstOperands,
     /*  647807 */     // GIR_Coverage, 12199,
     /*  647807 */     GIR_EraseRootFromParent_Done,
     /*  647808 */   // Label 10442: @647808
     /*  647808 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(647883), // Rule ID 12202 //
     /*  647813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  647862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647881 */     GIR_RootConstrainSelectedInstOperands,
     /*  647882 */     // GIR_Coverage, 12202,
     /*  647882 */     GIR_EraseRootFromParent_Done,
     /*  647883 */   // Label 10443: @647883
     /*  647883 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(647958), // Rule ID 12203 //
     /*  647888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  647937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647956 */     GIR_RootConstrainSelectedInstOperands,
     /*  647957 */     // GIR_Coverage, 12203,
     /*  647957 */     GIR_EraseRootFromParent_Done,
     /*  647958 */   // Label 10444: @647958
     /*  647958 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(648033), // Rule ID 12206 //
     /*  647963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  647971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  648012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648031 */     GIR_RootConstrainSelectedInstOperands,
     /*  648032 */     // GIR_Coverage, 12206,
     /*  648032 */     GIR_EraseRootFromParent_Done,
     /*  648033 */   // Label 10445: @648033
     /*  648033 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(648108), // Rule ID 12207 //
     /*  648038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  648046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  648087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648106 */     GIR_RootConstrainSelectedInstOperands,
     /*  648107 */     // GIR_Coverage, 12207,
     /*  648107 */     GIR_EraseRootFromParent_Done,
     /*  648108 */   // Label 10446: @648108
     /*  648108 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(648183), // Rule ID 12210 //
     /*  648113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  648121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  648162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648181 */     GIR_RootConstrainSelectedInstOperands,
     /*  648182 */     // GIR_Coverage, 12210,
     /*  648182 */     GIR_EraseRootFromParent_Done,
     /*  648183 */   // Label 10447: @648183
     /*  648183 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(648258), // Rule ID 12211 //
     /*  648188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  648196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  648237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648256 */     GIR_RootConstrainSelectedInstOperands,
     /*  648257 */     // GIR_Coverage, 12211,
     /*  648257 */     GIR_EraseRootFromParent_Done,
     /*  648258 */   // Label 10448: @648258
     /*  648258 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(648333), // Rule ID 12214 //
     /*  648263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  648271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  648312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648331 */     GIR_RootConstrainSelectedInstOperands,
     /*  648332 */     // GIR_Coverage, 12214,
     /*  648332 */     GIR_EraseRootFromParent_Done,
     /*  648333 */   // Label 10449: @648333
     /*  648333 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(648408), // Rule ID 12215 //
     /*  648338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  648346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  648387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648406 */     GIR_RootConstrainSelectedInstOperands,
     /*  648407 */     // GIR_Coverage, 12215,
     /*  648407 */     GIR_EraseRootFromParent_Done,
     /*  648408 */   // Label 10450: @648408
     /*  648408 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(648483), // Rule ID 12218 //
     /*  648413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648459 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  648462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648481 */     GIR_RootConstrainSelectedInstOperands,
     /*  648482 */     // GIR_Coverage, 12218,
     /*  648482 */     GIR_EraseRootFromParent_Done,
     /*  648483 */   // Label 10451: @648483
     /*  648483 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(648558), // Rule ID 12219 //
     /*  648488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  648537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648556 */     GIR_RootConstrainSelectedInstOperands,
     /*  648557 */     // GIR_Coverage, 12219,
     /*  648557 */     GIR_EraseRootFromParent_Done,
     /*  648558 */   // Label 10452: @648558
     /*  648558 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(648633), // Rule ID 12222 //
     /*  648563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  648612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648631 */     GIR_RootConstrainSelectedInstOperands,
     /*  648632 */     // GIR_Coverage, 12222,
     /*  648632 */     GIR_EraseRootFromParent_Done,
     /*  648633 */   // Label 10453: @648633
     /*  648633 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(648708), // Rule ID 12223 //
     /*  648638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  648687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648706 */     GIR_RootConstrainSelectedInstOperands,
     /*  648707 */     // GIR_Coverage, 12223,
     /*  648707 */     GIR_EraseRootFromParent_Done,
     /*  648708 */   // Label 10454: @648708
     /*  648708 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(648783), // Rule ID 12226 //
     /*  648713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  648724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  648727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648759 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  648762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648781 */     GIR_RootConstrainSelectedInstOperands,
     /*  648782 */     // GIR_Coverage, 12226,
     /*  648782 */     GIR_EraseRootFromParent_Done,
     /*  648783 */   // Label 10455: @648783
     /*  648783 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(648858), // Rule ID 12227 //
     /*  648788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  648799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  648802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  648837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648856 */     GIR_RootConstrainSelectedInstOperands,
     /*  648857 */     // GIR_Coverage, 12227,
     /*  648857 */     GIR_EraseRootFromParent_Done,
     /*  648858 */   // Label 10456: @648858
     /*  648858 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(648933), // Rule ID 12230 //
     /*  648863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  648874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  648877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  648912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648931 */     GIR_RootConstrainSelectedInstOperands,
     /*  648932 */     // GIR_Coverage, 12230,
     /*  648932 */     GIR_EraseRootFromParent_Done,
     /*  648933 */   // Label 10457: @648933
     /*  648933 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(649008), // Rule ID 12231 //
     /*  648938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  648946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  648949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  648952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  648987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649006 */     GIR_RootConstrainSelectedInstOperands,
     /*  649007 */     // GIR_Coverage, 12231,
     /*  649007 */     GIR_EraseRootFromParent_Done,
     /*  649008 */   // Label 10458: @649008
     /*  649008 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(649083), // Rule ID 12234 //
     /*  649013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  649024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  649027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  649062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649081 */     GIR_RootConstrainSelectedInstOperands,
     /*  649082 */     // GIR_Coverage, 12234,
     /*  649082 */     GIR_EraseRootFromParent_Done,
     /*  649083 */   // Label 10459: @649083
     /*  649083 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(649158), // Rule ID 12235 //
     /*  649088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  649099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  649102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  649137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649156 */     GIR_RootConstrainSelectedInstOperands,
     /*  649157 */     // GIR_Coverage, 12235,
     /*  649157 */     GIR_EraseRootFromParent_Done,
     /*  649158 */   // Label 10460: @649158
     /*  649158 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(649233), // Rule ID 12238 //
     /*  649163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  649174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  649177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  649212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649231 */     GIR_RootConstrainSelectedInstOperands,
     /*  649232 */     // GIR_Coverage, 12238,
     /*  649232 */     GIR_EraseRootFromParent_Done,
     /*  649233 */   // Label 10461: @649233
     /*  649233 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(649308), // Rule ID 12239 //
     /*  649238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  649249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  649252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  649287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649306 */     GIR_RootConstrainSelectedInstOperands,
     /*  649307 */     // GIR_Coverage, 12239,
     /*  649307 */     GIR_EraseRootFromParent_Done,
     /*  649308 */   // Label 10462: @649308
     /*  649308 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(649383), // Rule ID 12242 //
     /*  649313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  649333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649359 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  649362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649381 */     GIR_RootConstrainSelectedInstOperands,
     /*  649382 */     // GIR_Coverage, 12242,
     /*  649382 */     GIR_EraseRootFromParent_Done,
     /*  649383 */   // Label 10463: @649383
     /*  649383 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(649458), // Rule ID 12243 //
     /*  649388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  649408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  649437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649456 */     GIR_RootConstrainSelectedInstOperands,
     /*  649457 */     // GIR_Coverage, 12243,
     /*  649457 */     GIR_EraseRootFromParent_Done,
     /*  649458 */   // Label 10464: @649458
     /*  649458 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(649533), // Rule ID 12246 //
     /*  649463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649509 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  649512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649531 */     GIR_RootConstrainSelectedInstOperands,
     /*  649532 */     // GIR_Coverage, 12246,
     /*  649532 */     GIR_EraseRootFromParent_Done,
     /*  649533 */   // Label 10465: @649533
     /*  649533 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(649608), // Rule ID 12247 //
     /*  649538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  649587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649606 */     GIR_RootConstrainSelectedInstOperands,
     /*  649607 */     // GIR_Coverage, 12247,
     /*  649607 */     GIR_EraseRootFromParent_Done,
     /*  649608 */   // Label 10466: @649608
     /*  649608 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(649683), // Rule ID 12250 //
     /*  649613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  649624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  649627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  649662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649681 */     GIR_RootConstrainSelectedInstOperands,
     /*  649682 */     // GIR_Coverage, 12250,
     /*  649682 */     GIR_EraseRootFromParent_Done,
     /*  649683 */   // Label 10467: @649683
     /*  649683 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(649758), // Rule ID 12251 //
     /*  649688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  649699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  649702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  649737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649756 */     GIR_RootConstrainSelectedInstOperands,
     /*  649757 */     // GIR_Coverage, 12251,
     /*  649757 */     GIR_EraseRootFromParent_Done,
     /*  649758 */   // Label 10468: @649758
     /*  649758 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(649833), // Rule ID 12254 //
     /*  649763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  649774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  649777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  649812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649831 */     GIR_RootConstrainSelectedInstOperands,
     /*  649832 */     // GIR_Coverage, 12254,
     /*  649832 */     GIR_EraseRootFromParent_Done,
     /*  649833 */   // Label 10469: @649833
     /*  649833 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(649908), // Rule ID 12255 //
     /*  649838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  649849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  649852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  649887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649906 */     GIR_RootConstrainSelectedInstOperands,
     /*  649907 */     // GIR_Coverage, 12255,
     /*  649907 */     GIR_EraseRootFromParent_Done,
     /*  649908 */   // Label 10470: @649908
     /*  649908 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(649983), // Rule ID 12258 //
     /*  649913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  649924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  649927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  649930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  649933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  649962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649981 */     GIR_RootConstrainSelectedInstOperands,
     /*  649982 */     // GIR_Coverage, 12258,
     /*  649982 */     GIR_EraseRootFromParent_Done,
     /*  649983 */   // Label 10471: @649983
     /*  649983 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(650058), // Rule ID 12259 //
     /*  649988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  649996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  649999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  650037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650056 */     GIR_RootConstrainSelectedInstOperands,
     /*  650057 */     // GIR_Coverage, 12259,
     /*  650057 */     GIR_EraseRootFromParent_Done,
     /*  650058 */   // Label 10472: @650058
     /*  650058 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(650133), // Rule ID 12262 //
     /*  650063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  650066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  650074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  650077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  650080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  650083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  650112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650131 */     GIR_RootConstrainSelectedInstOperands,
     /*  650132 */     // GIR_Coverage, 12262,
     /*  650132 */     GIR_EraseRootFromParent_Done,
     /*  650133 */   // Label 10473: @650133
     /*  650133 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(650208), // Rule ID 12263 //
     /*  650138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  650141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  650149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  650152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  650155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  650158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  650187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650206 */     GIR_RootConstrainSelectedInstOperands,
     /*  650207 */     // GIR_Coverage, 12263,
     /*  650207 */     GIR_EraseRootFromParent_Done,
     /*  650208 */   // Label 10474: @650208
     /*  650208 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(650283), // Rule ID 12266 //
     /*  650213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  650216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  650230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  650233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  650262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650281 */     GIR_RootConstrainSelectedInstOperands,
     /*  650282 */     // GIR_Coverage, 12266,
     /*  650282 */     GIR_EraseRootFromParent_Done,
     /*  650283 */   // Label 10475: @650283
     /*  650283 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(650358), // Rule ID 12267 //
     /*  650288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  650291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  650305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  650308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  650337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650356 */     GIR_RootConstrainSelectedInstOperands,
     /*  650357 */     // GIR_Coverage, 12267,
     /*  650357 */     GIR_EraseRootFromParent_Done,
     /*  650358 */   // Label 10476: @650358
     /*  650358 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(650433), // Rule ID 12270 //
     /*  650363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  650366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  650374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  650377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650409 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  650412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650431 */     GIR_RootConstrainSelectedInstOperands,
     /*  650432 */     // GIR_Coverage, 12270,
     /*  650432 */     GIR_EraseRootFromParent_Done,
     /*  650433 */   // Label 10477: @650433
     /*  650433 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(650508), // Rule ID 12271 //
     /*  650438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  650441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  650449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  650452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  650487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650506 */     GIR_RootConstrainSelectedInstOperands,
     /*  650507 */     // GIR_Coverage, 12271,
     /*  650507 */     GIR_EraseRootFromParent_Done,
     /*  650508 */   // Label 10478: @650508
     /*  650508 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(650583), // Rule ID 12274 //
     /*  650513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  650516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  650524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  650527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650559 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  650562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650581 */     GIR_RootConstrainSelectedInstOperands,
     /*  650582 */     // GIR_Coverage, 12274,
     /*  650582 */     GIR_EraseRootFromParent_Done,
     /*  650583 */   // Label 10479: @650583
     /*  650583 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(650658), // Rule ID 12275 //
     /*  650588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  650591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  650599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  650602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  650637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650656 */     GIR_RootConstrainSelectedInstOperands,
     /*  650657 */     // GIR_Coverage, 12275,
     /*  650657 */     GIR_EraseRootFromParent_Done,
     /*  650658 */   // Label 10480: @650658
     /*  650658 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(650733), // Rule ID 12278 //
     /*  650663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  650674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  650677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  650680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  650712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650731 */     GIR_RootConstrainSelectedInstOperands,
     /*  650732 */     // GIR_Coverage, 12278,
     /*  650732 */     GIR_EraseRootFromParent_Done,
     /*  650733 */   // Label 10481: @650733
     /*  650733 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(650808), // Rule ID 12279 //
     /*  650738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  650749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  650752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  650755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  650787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650806 */     GIR_RootConstrainSelectedInstOperands,
     /*  650807 */     // GIR_Coverage, 12279,
     /*  650807 */     GIR_EraseRootFromParent_Done,
     /*  650808 */   // Label 10482: @650808
     /*  650808 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(650883), // Rule ID 12282 //
     /*  650813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  650824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  650827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  650830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  650862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650881 */     GIR_RootConstrainSelectedInstOperands,
     /*  650882 */     // GIR_Coverage, 12282,
     /*  650882 */     GIR_EraseRootFromParent_Done,
     /*  650883 */   // Label 10483: @650883
     /*  650883 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(650958), // Rule ID 12283 //
     /*  650888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  650899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  650902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  650905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  650937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650956 */     GIR_RootConstrainSelectedInstOperands,
     /*  650957 */     // GIR_Coverage, 12283,
     /*  650957 */     GIR_EraseRootFromParent_Done,
     /*  650958 */   // Label 10484: @650958
     /*  650958 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(651033), // Rule ID 12286 //
     /*  650963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  650971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  650974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  650977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  650980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  651012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651031 */     GIR_RootConstrainSelectedInstOperands,
     /*  651032 */     // GIR_Coverage, 12286,
     /*  651032 */     GIR_EraseRootFromParent_Done,
     /*  651033 */   // Label 10485: @651033
     /*  651033 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(651108), // Rule ID 12287 //
     /*  651038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  651049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  651052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  651087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651106 */     GIR_RootConstrainSelectedInstOperands,
     /*  651107 */     // GIR_Coverage, 12287,
     /*  651107 */     GIR_EraseRootFromParent_Done,
     /*  651108 */   // Label 10486: @651108
     /*  651108 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(651183), // Rule ID 12290 //
     /*  651113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  651124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  651127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  651130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  651162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651181 */     GIR_RootConstrainSelectedInstOperands,
     /*  651182 */     // GIR_Coverage, 12290,
     /*  651182 */     GIR_EraseRootFromParent_Done,
     /*  651183 */   // Label 10487: @651183
     /*  651183 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(651258), // Rule ID 12291 //
     /*  651188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  651199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  651202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  651205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  651237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651256 */     GIR_RootConstrainSelectedInstOperands,
     /*  651257 */     // GIR_Coverage, 12291,
     /*  651257 */     GIR_EraseRootFromParent_Done,
     /*  651258 */   // Label 10488: @651258
     /*  651258 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(651333), // Rule ID 12294 //
     /*  651263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  651274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  651277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  651280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  651312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651331 */     GIR_RootConstrainSelectedInstOperands,
     /*  651332 */     // GIR_Coverage, 12294,
     /*  651332 */     GIR_EraseRootFromParent_Done,
     /*  651333 */   // Label 10489: @651333
     /*  651333 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(651408), // Rule ID 12295 //
     /*  651338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  651349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  651352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  651355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  651387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651406 */     GIR_RootConstrainSelectedInstOperands,
     /*  651407 */     // GIR_Coverage, 12295,
     /*  651407 */     GIR_EraseRootFromParent_Done,
     /*  651408 */   // Label 10490: @651408
     /*  651408 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(651483), // Rule ID 12298 //
     /*  651413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  651424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  651427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  651430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651459 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  651462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651481 */     GIR_RootConstrainSelectedInstOperands,
     /*  651482 */     // GIR_Coverage, 12298,
     /*  651482 */     GIR_EraseRootFromParent_Done,
     /*  651483 */   // Label 10491: @651483
     /*  651483 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(651558), // Rule ID 12299 //
     /*  651488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  651499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  651502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  651505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  651537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651556 */     GIR_RootConstrainSelectedInstOperands,
     /*  651557 */     // GIR_Coverage, 12299,
     /*  651557 */     GIR_EraseRootFromParent_Done,
     /*  651558 */   // Label 10492: @651558
     /*  651558 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(651633), // Rule ID 12302 //
     /*  651563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  651574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  651577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  651612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651631 */     GIR_RootConstrainSelectedInstOperands,
     /*  651632 */     // GIR_Coverage, 12302,
     /*  651632 */     GIR_EraseRootFromParent_Done,
     /*  651633 */   // Label 10493: @651633
     /*  651633 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(651708), // Rule ID 12303 //
     /*  651638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  651649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  651652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  651687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651706 */     GIR_RootConstrainSelectedInstOperands,
     /*  651707 */     // GIR_Coverage, 12303,
     /*  651707 */     GIR_EraseRootFromParent_Done,
     /*  651708 */   // Label 10494: @651708
     /*  651708 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(651783), // Rule ID 12306 //
     /*  651713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  651724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  651727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  651762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651781 */     GIR_RootConstrainSelectedInstOperands,
     /*  651782 */     // GIR_Coverage, 12306,
     /*  651782 */     GIR_EraseRootFromParent_Done,
     /*  651783 */   // Label 10495: @651783
     /*  651783 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(651858), // Rule ID 12307 //
     /*  651788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  651799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  651802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  651837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651856 */     GIR_RootConstrainSelectedInstOperands,
     /*  651857 */     // GIR_Coverage, 12307,
     /*  651857 */     GIR_EraseRootFromParent_Done,
     /*  651858 */   // Label 10496: @651858
     /*  651858 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(651933), // Rule ID 12310 //
     /*  651863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  651874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  651877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  651880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  651912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651931 */     GIR_RootConstrainSelectedInstOperands,
     /*  651932 */     // GIR_Coverage, 12310,
     /*  651932 */     GIR_EraseRootFromParent_Done,
     /*  651933 */   // Label 10497: @651933
     /*  651933 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(652008), // Rule ID 12311 //
     /*  651938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  651946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  651949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  651952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  651955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  651987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652006 */     GIR_RootConstrainSelectedInstOperands,
     /*  652007 */     // GIR_Coverage, 12311,
     /*  652007 */     GIR_EraseRootFromParent_Done,
     /*  652008 */   // Label 10498: @652008
     /*  652008 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(652083), // Rule ID 12314 //
     /*  652013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  652024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  652027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  652030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  652062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652081 */     GIR_RootConstrainSelectedInstOperands,
     /*  652082 */     // GIR_Coverage, 12314,
     /*  652082 */     GIR_EraseRootFromParent_Done,
     /*  652083 */   // Label 10499: @652083
     /*  652083 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(652158), // Rule ID 12315 //
     /*  652088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  652099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  652102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  652105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  652137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652156 */     GIR_RootConstrainSelectedInstOperands,
     /*  652157 */     // GIR_Coverage, 12315,
     /*  652157 */     GIR_EraseRootFromParent_Done,
     /*  652158 */   // Label 10500: @652158
     /*  652158 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(652233), // Rule ID 12318 //
     /*  652163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  652174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  652177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  652180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  652212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652231 */     GIR_RootConstrainSelectedInstOperands,
     /*  652232 */     // GIR_Coverage, 12318,
     /*  652232 */     GIR_EraseRootFromParent_Done,
     /*  652233 */   // Label 10501: @652233
     /*  652233 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(652308), // Rule ID 12319 //
     /*  652238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  652249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  652252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  652255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  652287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652306 */     GIR_RootConstrainSelectedInstOperands,
     /*  652307 */     // GIR_Coverage, 12319,
     /*  652307 */     GIR_EraseRootFromParent_Done,
     /*  652308 */   // Label 10502: @652308
     /*  652308 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(652383), // Rule ID 12322 //
     /*  652313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  652316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652359 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  652362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652381 */     GIR_RootConstrainSelectedInstOperands,
     /*  652382 */     // GIR_Coverage, 12322,
     /*  652382 */     GIR_EraseRootFromParent_Done,
     /*  652383 */   // Label 10503: @652383
     /*  652383 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(652458), // Rule ID 12323 //
     /*  652388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  652391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  652437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652456 */     GIR_RootConstrainSelectedInstOperands,
     /*  652457 */     // GIR_Coverage, 12323,
     /*  652457 */     GIR_EraseRootFromParent_Done,
     /*  652458 */   // Label 10504: @652458
     /*  652458 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(652533), // Rule ID 12326 //
     /*  652463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  652466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  652474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  652477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  652512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652531 */     GIR_RootConstrainSelectedInstOperands,
     /*  652532 */     // GIR_Coverage, 12326,
     /*  652532 */     GIR_EraseRootFromParent_Done,
     /*  652533 */   // Label 10505: @652533
     /*  652533 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(652608), // Rule ID 12327 //
     /*  652538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  652541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  652549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  652552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  652587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652606 */     GIR_RootConstrainSelectedInstOperands,
     /*  652607 */     // GIR_Coverage, 12327,
     /*  652607 */     GIR_EraseRootFromParent_Done,
     /*  652608 */   // Label 10506: @652608
     /*  652608 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(652683), // Rule ID 12330 //
     /*  652613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  652616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  652624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  652627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  652630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  652662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652681 */     GIR_RootConstrainSelectedInstOperands,
     /*  652682 */     // GIR_Coverage, 12330,
     /*  652682 */     GIR_EraseRootFromParent_Done,
     /*  652683 */   // Label 10507: @652683
     /*  652683 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(652758), // Rule ID 12331 //
     /*  652688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  652691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  652699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  652702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  652705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  652737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652756 */     GIR_RootConstrainSelectedInstOperands,
     /*  652757 */     // GIR_Coverage, 12331,
     /*  652757 */     GIR_EraseRootFromParent_Done,
     /*  652758 */   // Label 10508: @652758
     /*  652758 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(652833), // Rule ID 12334 //
     /*  652763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  652766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  652774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  652777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  652780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  652812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652831 */     GIR_RootConstrainSelectedInstOperands,
     /*  652832 */     // GIR_Coverage, 12334,
     /*  652832 */     GIR_EraseRootFromParent_Done,
     /*  652833 */   // Label 10509: @652833
     /*  652833 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(652908), // Rule ID 12335 //
     /*  652838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  652841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  652846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  652849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  652852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  652855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  652887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652906 */     GIR_RootConstrainSelectedInstOperands,
     /*  652907 */     // GIR_Coverage, 12335,
     /*  652907 */     GIR_EraseRootFromParent_Done,
     /*  652908 */   // Label 10510: @652908
     /*  652908 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(652983), // Rule ID 12338 //
     /*  652913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  652921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  652930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  652933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652959 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  652962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652981 */     GIR_RootConstrainSelectedInstOperands,
     /*  652982 */     // GIR_Coverage, 12338,
     /*  652982 */     GIR_EraseRootFromParent_Done,
     /*  652983 */   // Label 10511: @652983
     /*  652983 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(653058), // Rule ID 12339 //
     /*  652988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  652996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  653002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  653005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  653008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  653037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653056 */     GIR_RootConstrainSelectedInstOperands,
     /*  653057 */     // GIR_Coverage, 12339,
     /*  653057 */     GIR_EraseRootFromParent_Done,
     /*  653058 */   // Label 10512: @653058
     /*  653058 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(653133), // Rule ID 12342 //
     /*  653063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  653074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  653077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  653080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  653083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653109 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  653112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653131 */     GIR_RootConstrainSelectedInstOperands,
     /*  653132 */     // GIR_Coverage, 12342,
     /*  653132 */     GIR_EraseRootFromParent_Done,
     /*  653133 */   // Label 10513: @653133
     /*  653133 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(653208), // Rule ID 12343 //
     /*  653138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  653149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  653152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  653155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  653158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653184 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  653187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653206 */     GIR_RootConstrainSelectedInstOperands,
     /*  653207 */     // GIR_Coverage, 12343,
     /*  653207 */     GIR_EraseRootFromParent_Done,
     /*  653208 */   // Label 10514: @653208
     /*  653208 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(653283), // Rule ID 12346 //
     /*  653213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  653224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  653227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  653230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  653233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653259 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  653262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653281 */     GIR_RootConstrainSelectedInstOperands,
     /*  653282 */     // GIR_Coverage, 12346,
     /*  653282 */     GIR_EraseRootFromParent_Done,
     /*  653283 */   // Label 10515: @653283
     /*  653283 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(653358), // Rule ID 12347 //
     /*  653288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  653299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  653302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  653305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  653308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653334 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  653337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653356 */     GIR_RootConstrainSelectedInstOperands,
     /*  653357 */     // GIR_Coverage, 12347,
     /*  653357 */     GIR_EraseRootFromParent_Done,
     /*  653358 */   // Label 10516: @653358
     /*  653358 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(653433), // Rule ID 12350 //
     /*  653363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  653380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  653383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  653412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653431 */     GIR_RootConstrainSelectedInstOperands,
     /*  653432 */     // GIR_Coverage, 12350,
     /*  653432 */     GIR_EraseRootFromParent_Done,
     /*  653433 */   // Label 10517: @653433
     /*  653433 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(653508), // Rule ID 12351 //
     /*  653438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  653455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  653458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  653487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653506 */     GIR_RootConstrainSelectedInstOperands,
     /*  653507 */     // GIR_Coverage, 12351,
     /*  653507 */     GIR_EraseRootFromParent_Done,
     /*  653508 */   // Label 10518: @653508
     /*  653508 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(653583), // Rule ID 12354 //
     /*  653513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653559 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  653562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653581 */     GIR_RootConstrainSelectedInstOperands,
     /*  653582 */     // GIR_Coverage, 12354,
     /*  653582 */     GIR_EraseRootFromParent_Done,
     /*  653583 */   // Label 10519: @653583
     /*  653583 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(653658), // Rule ID 12355 //
     /*  653588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  653637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653656 */     GIR_RootConstrainSelectedInstOperands,
     /*  653657 */     // GIR_Coverage, 12355,
     /*  653657 */     GIR_EraseRootFromParent_Done,
     /*  653658 */   // Label 10520: @653658
     /*  653658 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(653733), // Rule ID 12358 //
     /*  653663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  653712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653731 */     GIR_RootConstrainSelectedInstOperands,
     /*  653732 */     // GIR_Coverage, 12358,
     /*  653732 */     GIR_EraseRootFromParent_Done,
     /*  653733 */   // Label 10521: @653733
     /*  653733 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(653808), // Rule ID 12359 //
     /*  653738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  653787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653806 */     GIR_RootConstrainSelectedInstOperands,
     /*  653807 */     // GIR_Coverage, 12359,
     /*  653807 */     GIR_EraseRootFromParent_Done,
     /*  653808 */   // Label 10522: @653808
     /*  653808 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(653883), // Rule ID 12362 //
     /*  653813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  653824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  653827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  653830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  653833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  653862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653881 */     GIR_RootConstrainSelectedInstOperands,
     /*  653882 */     // GIR_Coverage, 12362,
     /*  653882 */     GIR_EraseRootFromParent_Done,
     /*  653883 */   // Label 10523: @653883
     /*  653883 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(653958), // Rule ID 12363 //
     /*  653888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  653899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  653902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  653905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  653908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653934 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  653937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653956 */     GIR_RootConstrainSelectedInstOperands,
     /*  653957 */     // GIR_Coverage, 12363,
     /*  653957 */     GIR_EraseRootFromParent_Done,
     /*  653958 */   // Label 10524: @653958
     /*  653958 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(654033), // Rule ID 12366 //
     /*  653963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  653971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  653980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  653983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  654012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654031 */     GIR_RootConstrainSelectedInstOperands,
     /*  654032 */     // GIR_Coverage, 12366,
     /*  654032 */     GIR_EraseRootFromParent_Done,
     /*  654033 */   // Label 10525: @654033
     /*  654033 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(654108), // Rule ID 12367 //
     /*  654038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  654049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  654052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  654058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  654087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654106 */     GIR_RootConstrainSelectedInstOperands,
     /*  654107 */     // GIR_Coverage, 12367,
     /*  654107 */     GIR_EraseRootFromParent_Done,
     /*  654108 */   // Label 10526: @654108
     /*  654108 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(654183), // Rule ID 12370 //
     /*  654113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  654133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  654162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654181 */     GIR_RootConstrainSelectedInstOperands,
     /*  654182 */     // GIR_Coverage, 12370,
     /*  654182 */     GIR_EraseRootFromParent_Done,
     /*  654183 */   // Label 10527: @654183
     /*  654183 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(654258), // Rule ID 12371 //
     /*  654188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  654208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  654237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654256 */     GIR_RootConstrainSelectedInstOperands,
     /*  654257 */     // GIR_Coverage, 12371,
     /*  654257 */     GIR_EraseRootFromParent_Done,
     /*  654258 */   // Label 10528: @654258
     /*  654258 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(654333), // Rule ID 12374 //
     /*  654263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  654280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  654283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  654312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654331 */     GIR_RootConstrainSelectedInstOperands,
     /*  654332 */     // GIR_Coverage, 12374,
     /*  654332 */     GIR_EraseRootFromParent_Done,
     /*  654333 */   // Label 10529: @654333
     /*  654333 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(654408), // Rule ID 12375 //
     /*  654338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  654355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  654358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  654387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654406 */     GIR_RootConstrainSelectedInstOperands,
     /*  654407 */     // GIR_Coverage, 12375,
     /*  654407 */     GIR_EraseRootFromParent_Done,
     /*  654408 */   // Label 10530: @654408
     /*  654408 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(654483), // Rule ID 12378 //
     /*  654413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  654433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  654462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654481 */     GIR_RootConstrainSelectedInstOperands,
     /*  654482 */     // GIR_Coverage, 12378,
     /*  654482 */     GIR_EraseRootFromParent_Done,
     /*  654483 */   // Label 10531: @654483
     /*  654483 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(654558), // Rule ID 12379 //
     /*  654488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  654508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  654537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654556 */     GIR_RootConstrainSelectedInstOperands,
     /*  654557 */     // GIR_Coverage, 12379,
     /*  654557 */     GIR_EraseRootFromParent_Done,
     /*  654558 */   // Label 10532: @654558
     /*  654558 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(654633), // Rule ID 12382 //
     /*  654563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  654566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  654574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  654577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  654580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  654583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  654612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654631 */     GIR_RootConstrainSelectedInstOperands,
     /*  654632 */     // GIR_Coverage, 12382,
     /*  654632 */     GIR_EraseRootFromParent_Done,
     /*  654633 */   // Label 10533: @654633
     /*  654633 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(654708), // Rule ID 12383 //
     /*  654638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  654641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  654649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  654652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  654655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  654658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  654687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654706 */     GIR_RootConstrainSelectedInstOperands,
     /*  654707 */     // GIR_Coverage, 12383,
     /*  654707 */     GIR_EraseRootFromParent_Done,
     /*  654708 */   // Label 10534: @654708
     /*  654708 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(654783), // Rule ID 12386 //
     /*  654713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  654716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  654730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  654733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  654762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654781 */     GIR_RootConstrainSelectedInstOperands,
     /*  654782 */     // GIR_Coverage, 12386,
     /*  654782 */     GIR_EraseRootFromParent_Done,
     /*  654783 */   // Label 10535: @654783
     /*  654783 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(654858), // Rule ID 12387 //
     /*  654788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  654791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  654805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  654808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  654837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654856 */     GIR_RootConstrainSelectedInstOperands,
     /*  654857 */     // GIR_Coverage, 12387,
     /*  654857 */     GIR_EraseRootFromParent_Done,
     /*  654858 */   // Label 10536: @654858
     /*  654858 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(654933), // Rule ID 12390 //
     /*  654863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  654866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  654912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654931 */     GIR_RootConstrainSelectedInstOperands,
     /*  654932 */     // GIR_Coverage, 12390,
     /*  654932 */     GIR_EraseRootFromParent_Done,
     /*  654933 */   // Label 10537: @654933
     /*  654933 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(655008), // Rule ID 12391 //
     /*  654938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  654941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  654946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  654987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655006 */     GIR_RootConstrainSelectedInstOperands,
     /*  655007 */     // GIR_Coverage, 12391,
     /*  655007 */     GIR_EraseRootFromParent_Done,
     /*  655008 */   // Label 10538: @655008
     /*  655008 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(655083), // Rule ID 12394 //
     /*  655013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  655016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  655033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  655059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  655062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655081 */     GIR_RootConstrainSelectedInstOperands,
     /*  655082 */     // GIR_Coverage, 12394,
     /*  655082 */     GIR_EraseRootFromParent_Done,
     /*  655083 */   // Label 10539: @655083
     /*  655083 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(655158), // Rule ID 12395 //
     /*  655088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  655091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  655108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  655134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  655137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655156 */     GIR_RootConstrainSelectedInstOperands,
     /*  655157 */     // GIR_Coverage, 12395,
     /*  655157 */     GIR_EraseRootFromParent_Done,
     /*  655158 */   // Label 10540: @655158
     /*  655158 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(655233), // Rule ID 12398 //
     /*  655163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  655212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655231 */     GIR_RootConstrainSelectedInstOperands,
     /*  655232 */     // GIR_Coverage, 12398,
     /*  655232 */     GIR_EraseRootFromParent_Done,
     /*  655233 */   // Label 10541: @655233
     /*  655233 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(655308), // Rule ID 12399 //
     /*  655238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  655287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655306 */     GIR_RootConstrainSelectedInstOperands,
     /*  655307 */     // GIR_Coverage, 12399,
     /*  655307 */     GIR_EraseRootFromParent_Done,
     /*  655308 */   // Label 10542: @655308
     /*  655308 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(655383), // Rule ID 12402 //
     /*  655313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  655362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655381 */     GIR_RootConstrainSelectedInstOperands,
     /*  655382 */     // GIR_Coverage, 12402,
     /*  655382 */     GIR_EraseRootFromParent_Done,
     /*  655383 */   // Label 10543: @655383
     /*  655383 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(655458), // Rule ID 12403 //
     /*  655388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  655437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655456 */     GIR_RootConstrainSelectedInstOperands,
     /*  655457 */     // GIR_Coverage, 12403,
     /*  655457 */     GIR_EraseRootFromParent_Done,
     /*  655458 */   // Label 10544: @655458
     /*  655458 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(655533), // Rule ID 12406 //
     /*  655463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  655512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655531 */     GIR_RootConstrainSelectedInstOperands,
     /*  655532 */     // GIR_Coverage, 12406,
     /*  655532 */     GIR_EraseRootFromParent_Done,
     /*  655533 */   // Label 10545: @655533
     /*  655533 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(655608), // Rule ID 12407 //
     /*  655538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  655587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655606 */     GIR_RootConstrainSelectedInstOperands,
     /*  655607 */     // GIR_Coverage, 12407,
     /*  655607 */     GIR_EraseRootFromParent_Done,
     /*  655608 */   // Label 10546: @655608
     /*  655608 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(655683), // Rule ID 12410 //
     /*  655613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  655630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  655662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655681 */     GIR_RootConstrainSelectedInstOperands,
     /*  655682 */     // GIR_Coverage, 12410,
     /*  655682 */     GIR_EraseRootFromParent_Done,
     /*  655683 */   // Label 10547: @655683
     /*  655683 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(655758), // Rule ID 12411 //
     /*  655688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  655705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  655737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655756 */     GIR_RootConstrainSelectedInstOperands,
     /*  655757 */     // GIR_Coverage, 12411,
     /*  655757 */     GIR_EraseRootFromParent_Done,
     /*  655758 */   // Label 10548: @655758
     /*  655758 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(655833), // Rule ID 12414 //
     /*  655763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  655774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  655777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  655780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655809 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  655812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655831 */     GIR_RootConstrainSelectedInstOperands,
     /*  655832 */     // GIR_Coverage, 12414,
     /*  655832 */     GIR_EraseRootFromParent_Done,
     /*  655833 */   // Label 10549: @655833
     /*  655833 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(655908), // Rule ID 12415 //
     /*  655838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  655849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  655852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  655855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  655887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655906 */     GIR_RootConstrainSelectedInstOperands,
     /*  655907 */     // GIR_Coverage, 12415,
     /*  655907 */     GIR_EraseRootFromParent_Done,
     /*  655908 */   // Label 10550: @655908
     /*  655908 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(655983), // Rule ID 12418 //
     /*  655913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  655924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  655927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  655930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655959 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  655962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655981 */     GIR_RootConstrainSelectedInstOperands,
     /*  655982 */     // GIR_Coverage, 12418,
     /*  655982 */     GIR_EraseRootFromParent_Done,
     /*  655983 */   // Label 10551: @655983
     /*  655983 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(656058), // Rule ID 12419 //
     /*  655988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  655996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  655999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  656002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  656005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656034 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  656037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656056 */     GIR_RootConstrainSelectedInstOperands,
     /*  656057 */     // GIR_Coverage, 12419,
     /*  656057 */     GIR_EraseRootFromParent_Done,
     /*  656058 */   // Label 10552: @656058
     /*  656058 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(656133), // Rule ID 12422 //
     /*  656063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  656112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656131 */     GIR_RootConstrainSelectedInstOperands,
     /*  656132 */     // GIR_Coverage, 12422,
     /*  656132 */     GIR_EraseRootFromParent_Done,
     /*  656133 */   // Label 10553: @656133
     /*  656133 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(656208), // Rule ID 12423 //
     /*  656138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  656187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656206 */     GIR_RootConstrainSelectedInstOperands,
     /*  656207 */     // GIR_Coverage, 12423,
     /*  656207 */     GIR_EraseRootFromParent_Done,
     /*  656208 */   // Label 10554: @656208
     /*  656208 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(656283), // Rule ID 12426 //
     /*  656213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  656230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  656262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656281 */     GIR_RootConstrainSelectedInstOperands,
     /*  656282 */     // GIR_Coverage, 12426,
     /*  656282 */     GIR_EraseRootFromParent_Done,
     /*  656283 */   // Label 10555: @656283
     /*  656283 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(656358), // Rule ID 12427 //
     /*  656288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  656305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  656337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656356 */     GIR_RootConstrainSelectedInstOperands,
     /*  656357 */     // GIR_Coverage, 12427,
     /*  656357 */     GIR_EraseRootFromParent_Done,
     /*  656358 */   // Label 10556: @656358
     /*  656358 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(656433), // Rule ID 12430 //
     /*  656363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  656412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656431 */     GIR_RootConstrainSelectedInstOperands,
     /*  656432 */     // GIR_Coverage, 12430,
     /*  656432 */     GIR_EraseRootFromParent_Done,
     /*  656433 */   // Label 10557: @656433
     /*  656433 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(656508), // Rule ID 12431 //
     /*  656438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  656487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656506 */     GIR_RootConstrainSelectedInstOperands,
     /*  656507 */     // GIR_Coverage, 12431,
     /*  656507 */     GIR_EraseRootFromParent_Done,
     /*  656508 */   // Label 10558: @656508
     /*  656508 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(656583), // Rule ID 12434 //
     /*  656513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  656530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  656562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656581 */     GIR_RootConstrainSelectedInstOperands,
     /*  656582 */     // GIR_Coverage, 12434,
     /*  656582 */     GIR_EraseRootFromParent_Done,
     /*  656583 */   // Label 10559: @656583
     /*  656583 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(656658), // Rule ID 12435 //
     /*  656588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  656605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656634 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  656637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656656 */     GIR_RootConstrainSelectedInstOperands,
     /*  656657 */     // GIR_Coverage, 12435,
     /*  656657 */     GIR_EraseRootFromParent_Done,
     /*  656658 */   // Label 10560: @656658
     /*  656658 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(656733), // Rule ID 12438 //
     /*  656663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  656674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  656677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  656680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  656712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656731 */     GIR_RootConstrainSelectedInstOperands,
     /*  656732 */     // GIR_Coverage, 12438,
     /*  656732 */     GIR_EraseRootFromParent_Done,
     /*  656733 */   // Label 10561: @656733
     /*  656733 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(656808), // Rule ID 12439 //
     /*  656738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  656749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  656752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  656755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  656787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656806 */     GIR_RootConstrainSelectedInstOperands,
     /*  656807 */     // GIR_Coverage, 12439,
     /*  656807 */     GIR_EraseRootFromParent_Done,
     /*  656808 */   // Label 10562: @656808
     /*  656808 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(656883), // Rule ID 12442 //
     /*  656813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  656830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656859 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  656862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656881 */     GIR_RootConstrainSelectedInstOperands,
     /*  656882 */     // GIR_Coverage, 12442,
     /*  656882 */     GIR_EraseRootFromParent_Done,
     /*  656883 */   // Label 10563: @656883
     /*  656883 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(656958), // Rule ID 12443 //
     /*  656888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  656905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  656937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656956 */     GIR_RootConstrainSelectedInstOperands,
     /*  656957 */     // GIR_Coverage, 12443,
     /*  656957 */     GIR_EraseRootFromParent_Done,
     /*  656958 */   // Label 10564: @656958
     /*  656958 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(657033), // Rule ID 12446 //
     /*  656963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  656971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  656974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  656977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  657012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657031 */     GIR_RootConstrainSelectedInstOperands,
     /*  657032 */     // GIR_Coverage, 12446,
     /*  657032 */     GIR_EraseRootFromParent_Done,
     /*  657033 */   // Label 10565: @657033
     /*  657033 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(657108), // Rule ID 12447 //
     /*  657038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  657046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  657049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  657052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  657087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657106 */     GIR_RootConstrainSelectedInstOperands,
     /*  657107 */     // GIR_Coverage, 12447,
     /*  657107 */     GIR_EraseRootFromParent_Done,
     /*  657108 */   // Label 10566: @657108
     /*  657108 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(657183), // Rule ID 12450 //
     /*  657113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  657121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  657124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  657127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  657162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657181 */     GIR_RootConstrainSelectedInstOperands,
     /*  657182 */     // GIR_Coverage, 12450,
     /*  657182 */     GIR_EraseRootFromParent_Done,
     /*  657183 */   // Label 10567: @657183
     /*  657183 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(657258), // Rule ID 12451 //
     /*  657188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  657196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  657199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  657202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  657237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657256 */     GIR_RootConstrainSelectedInstOperands,
     /*  657257 */     // GIR_Coverage, 12451,
     /*  657257 */     GIR_EraseRootFromParent_Done,
     /*  657258 */   // Label 10568: @657258
     /*  657258 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(657333), // Rule ID 12454 //
     /*  657263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  657271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  657274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  657277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  657312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657331 */     GIR_RootConstrainSelectedInstOperands,
     /*  657332 */     // GIR_Coverage, 12454,
     /*  657332 */     GIR_EraseRootFromParent_Done,
     /*  657333 */   // Label 10569: @657333
     /*  657333 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(657408), // Rule ID 12455 //
     /*  657338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  657346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  657349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  657352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  657387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657406 */     GIR_RootConstrainSelectedInstOperands,
     /*  657407 */     // GIR_Coverage, 12455,
     /*  657407 */     GIR_EraseRootFromParent_Done,
     /*  657408 */   // Label 10570: @657408
     /*  657408 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(657483), // Rule ID 12458 //
     /*  657413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  657430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  657433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657459 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  657462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657481 */     GIR_RootConstrainSelectedInstOperands,
     /*  657482 */     // GIR_Coverage, 12458,
     /*  657482 */     GIR_EraseRootFromParent_Done,
     /*  657483 */   // Label 10571: @657483
     /*  657483 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(657558), // Rule ID 12459 //
     /*  657488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  657505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  657508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  657537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657556 */     GIR_RootConstrainSelectedInstOperands,
     /*  657557 */     // GIR_Coverage, 12459,
     /*  657557 */     GIR_EraseRootFromParent_Done,
     /*  657558 */   // Label 10572: @657558
     /*  657558 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(657633), // Rule ID 12462 //
     /*  657563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  657580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  657583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  657612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657631 */     GIR_RootConstrainSelectedInstOperands,
     /*  657632 */     // GIR_Coverage, 12462,
     /*  657632 */     GIR_EraseRootFromParent_Done,
     /*  657633 */   // Label 10573: @657633
     /*  657633 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(657708), // Rule ID 12463 //
     /*  657638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  657655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  657658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  657687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657706 */     GIR_RootConstrainSelectedInstOperands,
     /*  657707 */     // GIR_Coverage, 12463,
     /*  657707 */     GIR_EraseRootFromParent_Done,
     /*  657708 */   // Label 10574: @657708
     /*  657708 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(657783), // Rule ID 12466 //
     /*  657713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  657724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  657727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  657730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  657733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657759 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  657762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657781 */     GIR_RootConstrainSelectedInstOperands,
     /*  657782 */     // GIR_Coverage, 12466,
     /*  657782 */     GIR_EraseRootFromParent_Done,
     /*  657783 */   // Label 10575: @657783
     /*  657783 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(657858), // Rule ID 12467 //
     /*  657788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  657799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  657802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  657805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  657808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  657837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657856 */     GIR_RootConstrainSelectedInstOperands,
     /*  657857 */     // GIR_Coverage, 12467,
     /*  657857 */     GIR_EraseRootFromParent_Done,
     /*  657858 */   // Label 10576: @657858
     /*  657858 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(657933), // Rule ID 12470 //
     /*  657863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  657880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  657883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  657912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657931 */     GIR_RootConstrainSelectedInstOperands,
     /*  657932 */     // GIR_Coverage, 12470,
     /*  657932 */     GIR_EraseRootFromParent_Done,
     /*  657933 */   // Label 10577: @657933
     /*  657933 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(658008), // Rule ID 12471 //
     /*  657938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  657946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  657955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  657958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  657987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658006 */     GIR_RootConstrainSelectedInstOperands,
     /*  658007 */     // GIR_Coverage, 12471,
     /*  658007 */     GIR_EraseRootFromParent_Done,
     /*  658008 */   // Label 10578: @658008
     /*  658008 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(658083), // Rule ID 12474 //
     /*  658013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  658030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  658033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  658062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658081 */     GIR_RootConstrainSelectedInstOperands,
     /*  658082 */     // GIR_Coverage, 12474,
     /*  658082 */     GIR_EraseRootFromParent_Done,
     /*  658083 */   // Label 10579: @658083
     /*  658083 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(658158), // Rule ID 12475 //
     /*  658088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  658105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  658108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  658137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658156 */     GIR_RootConstrainSelectedInstOperands,
     /*  658157 */     // GIR_Coverage, 12475,
     /*  658157 */     GIR_EraseRootFromParent_Done,
     /*  658158 */   // Label 10580: @658158
     /*  658158 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(658233), // Rule ID 12478 //
     /*  658163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  658174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  658177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  658180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  658183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  658212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658231 */     GIR_RootConstrainSelectedInstOperands,
     /*  658232 */     // GIR_Coverage, 12478,
     /*  658232 */     GIR_EraseRootFromParent_Done,
     /*  658233 */   // Label 10581: @658233
     /*  658233 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(658308), // Rule ID 12479 //
     /*  658238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  658249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  658252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  658255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  658258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  658287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658306 */     GIR_RootConstrainSelectedInstOperands,
     /*  658307 */     // GIR_Coverage, 12479,
     /*  658307 */     GIR_EraseRootFromParent_Done,
     /*  658308 */   // Label 10582: @658308
     /*  658308 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(658383), // Rule ID 12482 //
     /*  658313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  658333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658359 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  658362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658381 */     GIR_RootConstrainSelectedInstOperands,
     /*  658382 */     // GIR_Coverage, 12482,
     /*  658382 */     GIR_EraseRootFromParent_Done,
     /*  658383 */   // Label 10583: @658383
     /*  658383 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(658458), // Rule ID 12483 //
     /*  658388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  658408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  658437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658456 */     GIR_RootConstrainSelectedInstOperands,
     /*  658457 */     // GIR_Coverage, 12483,
     /*  658457 */     GIR_EraseRootFromParent_Done,
     /*  658458 */   // Label 10584: @658458
     /*  658458 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(658533), // Rule ID 12486 //
     /*  658463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  658483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658509 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  658512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658531 */     GIR_RootConstrainSelectedInstOperands,
     /*  658532 */     // GIR_Coverage, 12486,
     /*  658532 */     GIR_EraseRootFromParent_Done,
     /*  658533 */   // Label 10585: @658533
     /*  658533 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(658608), // Rule ID 12487 //
     /*  658538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  658558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  658587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658606 */     GIR_RootConstrainSelectedInstOperands,
     /*  658607 */     // GIR_Coverage, 12487,
     /*  658607 */     GIR_EraseRootFromParent_Done,
     /*  658608 */   // Label 10586: @658608
     /*  658608 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(658683), // Rule ID 12490 //
     /*  658613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  658633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  658662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658681 */     GIR_RootConstrainSelectedInstOperands,
     /*  658682 */     // GIR_Coverage, 12490,
     /*  658682 */     GIR_EraseRootFromParent_Done,
     /*  658683 */   // Label 10587: @658683
     /*  658683 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(658758), // Rule ID 12491 //
     /*  658688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  658708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  658737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658756 */     GIR_RootConstrainSelectedInstOperands,
     /*  658757 */     // GIR_Coverage, 12491,
     /*  658757 */     GIR_EraseRootFromParent_Done,
     /*  658758 */   // Label 10588: @658758
     /*  658758 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(658833), // Rule ID 12494 //
     /*  658763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  658783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  658812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658831 */     GIR_RootConstrainSelectedInstOperands,
     /*  658832 */     // GIR_Coverage, 12494,
     /*  658832 */     GIR_EraseRootFromParent_Done,
     /*  658833 */   // Label 10589: @658833
     /*  658833 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(658908), // Rule ID 12495 //
     /*  658838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  658858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  658887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658906 */     GIR_RootConstrainSelectedInstOperands,
     /*  658907 */     // GIR_Coverage, 12495,
     /*  658907 */     GIR_EraseRootFromParent_Done,
     /*  658908 */   // Label 10590: @658908
     /*  658908 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(658983), // Rule ID 12498 //
     /*  658913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  658924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  658927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  658930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  658933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  658962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658981 */     GIR_RootConstrainSelectedInstOperands,
     /*  658982 */     // GIR_Coverage, 12498,
     /*  658982 */     GIR_EraseRootFromParent_Done,
     /*  658983 */   // Label 10591: @658983
     /*  658983 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(659058), // Rule ID 12499 //
     /*  658988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  658996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  658999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  659002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  659008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  659037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659056 */     GIR_RootConstrainSelectedInstOperands,
     /*  659057 */     // GIR_Coverage, 12499,
     /*  659057 */     GIR_EraseRootFromParent_Done,
     /*  659058 */   // Label 10592: @659058
     /*  659058 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(659133), // Rule ID 12502 //
     /*  659063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  659074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  659077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  659083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  659112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659131 */     GIR_RootConstrainSelectedInstOperands,
     /*  659132 */     // GIR_Coverage, 12502,
     /*  659132 */     GIR_EraseRootFromParent_Done,
     /*  659133 */   // Label 10593: @659133
     /*  659133 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(659208), // Rule ID 12503 //
     /*  659138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  659149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  659152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  659158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  659187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659206 */     GIR_RootConstrainSelectedInstOperands,
     /*  659207 */     // GIR_Coverage, 12503,
     /*  659207 */     GIR_EraseRootFromParent_Done,
     /*  659208 */   // Label 10594: @659208
     /*  659208 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(659283), // Rule ID 12506 //
     /*  659213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  659224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  659227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  659233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  659262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659281 */     GIR_RootConstrainSelectedInstOperands,
     /*  659282 */     // GIR_Coverage, 12506,
     /*  659282 */     GIR_EraseRootFromParent_Done,
     /*  659283 */   // Label 10595: @659283
     /*  659283 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(659358), // Rule ID 12507 //
     /*  659288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  659299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  659302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  659308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  659337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659356 */     GIR_RootConstrainSelectedInstOperands,
     /*  659357 */     // GIR_Coverage, 12507,
     /*  659357 */     GIR_EraseRootFromParent_Done,
     /*  659358 */   // Label 10596: @659358
     /*  659358 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(659433), // Rule ID 12510 //
     /*  659363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  659374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  659377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  659383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659409 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  659412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659431 */     GIR_RootConstrainSelectedInstOperands,
     /*  659432 */     // GIR_Coverage, 12510,
     /*  659432 */     GIR_EraseRootFromParent_Done,
     /*  659433 */   // Label 10597: @659433
     /*  659433 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(659508), // Rule ID 12511 //
     /*  659438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  659449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  659452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  659458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  659487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659506 */     GIR_RootConstrainSelectedInstOperands,
     /*  659507 */     // GIR_Coverage, 12511,
     /*  659507 */     GIR_EraseRootFromParent_Done,
     /*  659508 */   // Label 10598: @659508
     /*  659508 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(659583), // Rule ID 12514 //
     /*  659513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  659524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  659527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  659533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659559 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  659562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659581 */     GIR_RootConstrainSelectedInstOperands,
     /*  659582 */     // GIR_Coverage, 12514,
     /*  659582 */     GIR_EraseRootFromParent_Done,
     /*  659583 */   // Label 10599: @659583
     /*  659583 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(659658), // Rule ID 12515 //
     /*  659588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  659599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  659602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  659608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  659637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659656 */     GIR_RootConstrainSelectedInstOperands,
     /*  659657 */     // GIR_Coverage, 12515,
     /*  659657 */     GIR_EraseRootFromParent_Done,
     /*  659658 */   // Label 10600: @659658
     /*  659658 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(659733), // Rule ID 12518 //
     /*  659663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  659680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  659712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659731 */     GIR_RootConstrainSelectedInstOperands,
     /*  659732 */     // GIR_Coverage, 12518,
     /*  659732 */     GIR_EraseRootFromParent_Done,
     /*  659733 */   // Label 10601: @659733
     /*  659733 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(659808), // Rule ID 12519 //
     /*  659738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  659755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  659787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659806 */     GIR_RootConstrainSelectedInstOperands,
     /*  659807 */     // GIR_Coverage, 12519,
     /*  659807 */     GIR_EraseRootFromParent_Done,
     /*  659808 */   // Label 10602: @659808
     /*  659808 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(659883), // Rule ID 12522 //
     /*  659813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  659830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  659862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659881 */     GIR_RootConstrainSelectedInstOperands,
     /*  659882 */     // GIR_Coverage, 12522,
     /*  659882 */     GIR_EraseRootFromParent_Done,
     /*  659883 */   // Label 10603: @659883
     /*  659883 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(659958), // Rule ID 12523 //
     /*  659888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  659905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  659937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659956 */     GIR_RootConstrainSelectedInstOperands,
     /*  659957 */     // GIR_Coverage, 12523,
     /*  659957 */     GIR_EraseRootFromParent_Done,
     /*  659958 */   // Label 10604: @659958
     /*  659958 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(660033), // Rule ID 12526 //
     /*  659963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  659971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  659980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  660012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660031 */     GIR_RootConstrainSelectedInstOperands,
     /*  660032 */     // GIR_Coverage, 12526,
     /*  660032 */     GIR_EraseRootFromParent_Done,
     /*  660033 */   // Label 10605: @660033
     /*  660033 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(660108), // Rule ID 12527 //
     /*  660038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  660055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  660087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660106 */     GIR_RootConstrainSelectedInstOperands,
     /*  660107 */     // GIR_Coverage, 12527,
     /*  660107 */     GIR_EraseRootFromParent_Done,
     /*  660108 */   // Label 10606: @660108
     /*  660108 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(660183), // Rule ID 12530 //
     /*  660113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  660130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  660162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660181 */     GIR_RootConstrainSelectedInstOperands,
     /*  660182 */     // GIR_Coverage, 12530,
     /*  660182 */     GIR_EraseRootFromParent_Done,
     /*  660183 */   // Label 10607: @660183
     /*  660183 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(660258), // Rule ID 12531 //
     /*  660188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  660205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  660237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660256 */     GIR_RootConstrainSelectedInstOperands,
     /*  660257 */     // GIR_Coverage, 12531,
     /*  660257 */     GIR_EraseRootFromParent_Done,
     /*  660258 */   // Label 10608: @660258
     /*  660258 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(660333), // Rule ID 12534 //
     /*  660263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  660280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  660312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660331 */     GIR_RootConstrainSelectedInstOperands,
     /*  660332 */     // GIR_Coverage, 12534,
     /*  660332 */     GIR_EraseRootFromParent_Done,
     /*  660333 */   // Label 10609: @660333
     /*  660333 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(660408), // Rule ID 12535 //
     /*  660338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  660355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  660387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660406 */     GIR_RootConstrainSelectedInstOperands,
     /*  660407 */     // GIR_Coverage, 12535,
     /*  660407 */     GIR_EraseRootFromParent_Done,
     /*  660408 */   // Label 10610: @660408
     /*  660408 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(660483), // Rule ID 12538 //
     /*  660413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  660424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  660427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  660430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660459 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  660462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660481 */     GIR_RootConstrainSelectedInstOperands,
     /*  660482 */     // GIR_Coverage, 12538,
     /*  660482 */     GIR_EraseRootFromParent_Done,
     /*  660483 */   // Label 10611: @660483
     /*  660483 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(660558), // Rule ID 12539 //
     /*  660488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  660499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  660502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  660505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  660537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660556 */     GIR_RootConstrainSelectedInstOperands,
     /*  660557 */     // GIR_Coverage, 12539,
     /*  660557 */     GIR_EraseRootFromParent_Done,
     /*  660558 */   // Label 10612: @660558
     /*  660558 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(660633), // Rule ID 12542 //
     /*  660563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  660612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660631 */     GIR_RootConstrainSelectedInstOperands,
     /*  660632 */     // GIR_Coverage, 12542,
     /*  660632 */     GIR_EraseRootFromParent_Done,
     /*  660633 */   // Label 10613: @660633
     /*  660633 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(660708), // Rule ID 12543 //
     /*  660638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  660687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660706 */     GIR_RootConstrainSelectedInstOperands,
     /*  660707 */     // GIR_Coverage, 12543,
     /*  660707 */     GIR_EraseRootFromParent_Done,
     /*  660708 */   // Label 10614: @660708
     /*  660708 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(660783), // Rule ID 12546 //
     /*  660713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  660762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660781 */     GIR_RootConstrainSelectedInstOperands,
     /*  660782 */     // GIR_Coverage, 12546,
     /*  660782 */     GIR_EraseRootFromParent_Done,
     /*  660783 */   // Label 10615: @660783
     /*  660783 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(660858), // Rule ID 12547 //
     /*  660788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  660837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660856 */     GIR_RootConstrainSelectedInstOperands,
     /*  660857 */     // GIR_Coverage, 12547,
     /*  660857 */     GIR_EraseRootFromParent_Done,
     /*  660858 */   // Label 10616: @660858
     /*  660858 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(660933), // Rule ID 12550 //
     /*  660863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  660880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  660912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660931 */     GIR_RootConstrainSelectedInstOperands,
     /*  660932 */     // GIR_Coverage, 12550,
     /*  660932 */     GIR_EraseRootFromParent_Done,
     /*  660933 */   // Label 10617: @660933
     /*  660933 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(661008), // Rule ID 12551 //
     /*  660938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  660946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  660955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  660987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661006 */     GIR_RootConstrainSelectedInstOperands,
     /*  661007 */     // GIR_Coverage, 12551,
     /*  661007 */     GIR_EraseRootFromParent_Done,
     /*  661008 */   // Label 10618: @661008
     /*  661008 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(661083), // Rule ID 12554 //
     /*  661013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  661062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661081 */     GIR_RootConstrainSelectedInstOperands,
     /*  661082 */     // GIR_Coverage, 12554,
     /*  661082 */     GIR_EraseRootFromParent_Done,
     /*  661083 */   // Label 10619: @661083
     /*  661083 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(661158), // Rule ID 12555 //
     /*  661088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  661137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661156 */     GIR_RootConstrainSelectedInstOperands,
     /*  661157 */     // GIR_Coverage, 12555,
     /*  661157 */     GIR_EraseRootFromParent_Done,
     /*  661158 */   // Label 10620: @661158
     /*  661158 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(661233), // Rule ID 12558 //
     /*  661163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  661174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  661177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  661212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661231 */     GIR_RootConstrainSelectedInstOperands,
     /*  661232 */     // GIR_Coverage, 12558,
     /*  661232 */     GIR_EraseRootFromParent_Done,
     /*  661233 */   // Label 10621: @661233
     /*  661233 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(661308), // Rule ID 12559 //
     /*  661238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  661249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  661252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  661287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661306 */     GIR_RootConstrainSelectedInstOperands,
     /*  661307 */     // GIR_Coverage, 12559,
     /*  661307 */     GIR_EraseRootFromParent_Done,
     /*  661308 */   // Label 10622: @661308
     /*  661308 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(661383), // Rule ID 12562 //
     /*  661313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  661324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  661327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661359 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  661362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661381 */     GIR_RootConstrainSelectedInstOperands,
     /*  661382 */     // GIR_Coverage, 12562,
     /*  661382 */     GIR_EraseRootFromParent_Done,
     /*  661383 */   // Label 10623: @661383
     /*  661383 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(661458), // Rule ID 12563 //
     /*  661388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  661399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  661402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  661437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661456 */     GIR_RootConstrainSelectedInstOperands,
     /*  661457 */     // GIR_Coverage, 12563,
     /*  661457 */     GIR_EraseRootFromParent_Done,
     /*  661458 */   // Label 10624: @661458
     /*  661458 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(661533), // Rule ID 12566 //
     /*  661463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  661474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  661477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  661512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661531 */     GIR_RootConstrainSelectedInstOperands,
     /*  661532 */     // GIR_Coverage, 12566,
     /*  661532 */     GIR_EraseRootFromParent_Done,
     /*  661533 */   // Label 10625: @661533
     /*  661533 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(661608), // Rule ID 12567 //
     /*  661538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  661549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  661552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  661587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661606 */     GIR_RootConstrainSelectedInstOperands,
     /*  661607 */     // GIR_Coverage, 12567,
     /*  661607 */     GIR_EraseRootFromParent_Done,
     /*  661608 */   // Label 10626: @661608
     /*  661608 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(661683), // Rule ID 12570 //
     /*  661613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  661624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  661627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  661662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661681 */     GIR_RootConstrainSelectedInstOperands,
     /*  661682 */     // GIR_Coverage, 12570,
     /*  661682 */     GIR_EraseRootFromParent_Done,
     /*  661683 */   // Label 10627: @661683
     /*  661683 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(661758), // Rule ID 12571 //
     /*  661688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  661699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  661702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  661737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661756 */     GIR_RootConstrainSelectedInstOperands,
     /*  661757 */     // GIR_Coverage, 12571,
     /*  661757 */     GIR_EraseRootFromParent_Done,
     /*  661758 */   // Label 10628: @661758
     /*  661758 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(661833), // Rule ID 12574 //
     /*  661763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  661774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  661777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  661780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  661812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661831 */     GIR_RootConstrainSelectedInstOperands,
     /*  661832 */     // GIR_Coverage, 12574,
     /*  661832 */     GIR_EraseRootFromParent_Done,
     /*  661833 */   // Label 10629: @661833
     /*  661833 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(661908), // Rule ID 12575 //
     /*  661838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  661846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  661849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  661852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  661855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  661887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661906 */     GIR_RootConstrainSelectedInstOperands,
     /*  661907 */     // GIR_Coverage, 12575,
     /*  661907 */     GIR_EraseRootFromParent_Done,
     /*  661908 */   // Label 10630: @661908
     /*  661908 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(661986), // Rule ID 13904 //
     /*  661913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  661921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  661930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  661933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  661962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  661984 */     GIR_RootConstrainSelectedInstOperands,
     /*  661985 */     // GIR_Coverage, 13904,
     /*  661985 */     GIR_EraseRootFromParent_Done,
     /*  661986 */   // Label 10631: @661986
     /*  661986 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(662064), // Rule ID 13905 //
     /*  661991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  661999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  662002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  662005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  662008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  662011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662037 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  662040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662062 */     GIR_RootConstrainSelectedInstOperands,
     /*  662063 */     // GIR_Coverage, 13905,
     /*  662063 */     GIR_EraseRootFromParent_Done,
     /*  662064 */   // Label 10632: @662064
     /*  662064 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(662142), // Rule ID 13908 //
     /*  662069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  662080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  662083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  662086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  662089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662115 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  662118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662140 */     GIR_RootConstrainSelectedInstOperands,
     /*  662141 */     // GIR_Coverage, 13908,
     /*  662141 */     GIR_EraseRootFromParent_Done,
     /*  662142 */   // Label 10633: @662142
     /*  662142 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(662220), // Rule ID 13909 //
     /*  662147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  662158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  662161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  662164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  662167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662193 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  662196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662218 */     GIR_RootConstrainSelectedInstOperands,
     /*  662219 */     // GIR_Coverage, 13909,
     /*  662219 */     GIR_EraseRootFromParent_Done,
     /*  662220 */   // Label 10634: @662220
     /*  662220 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(662298), // Rule ID 13912 //
     /*  662225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  662242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  662245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662296 */     GIR_RootConstrainSelectedInstOperands,
     /*  662297 */     // GIR_Coverage, 13912,
     /*  662297 */     GIR_EraseRootFromParent_Done,
     /*  662298 */   // Label 10635: @662298
     /*  662298 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(662376), // Rule ID 13913 //
     /*  662303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  662320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  662323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662349 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662374 */     GIR_RootConstrainSelectedInstOperands,
     /*  662375 */     // GIR_Coverage, 13913,
     /*  662375 */     GIR_EraseRootFromParent_Done,
     /*  662376 */   // Label 10636: @662376
     /*  662376 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(662454), // Rule ID 13916 //
     /*  662381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  662398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  662401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662427 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  662430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662452 */     GIR_RootConstrainSelectedInstOperands,
     /*  662453 */     // GIR_Coverage, 13916,
     /*  662453 */     GIR_EraseRootFromParent_Done,
     /*  662454 */   // Label 10637: @662454
     /*  662454 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(662532), // Rule ID 13917 //
     /*  662459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  662476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  662479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662505 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  662508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662530 */     GIR_RootConstrainSelectedInstOperands,
     /*  662531 */     // GIR_Coverage, 13917,
     /*  662531 */     GIR_EraseRootFromParent_Done,
     /*  662532 */   // Label 10638: @662532
     /*  662532 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(662610), // Rule ID 13920 //
     /*  662537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  662554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  662557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662583 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662608 */     GIR_RootConstrainSelectedInstOperands,
     /*  662609 */     // GIR_Coverage, 13920,
     /*  662609 */     GIR_EraseRootFromParent_Done,
     /*  662610 */   // Label 10639: @662610
     /*  662610 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(662688), // Rule ID 13921 //
     /*  662615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  662632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  662635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662661 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662686 */     GIR_RootConstrainSelectedInstOperands,
     /*  662687 */     // GIR_Coverage, 13921,
     /*  662687 */     GIR_EraseRootFromParent_Done,
     /*  662688 */   // Label 10640: @662688
     /*  662688 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(662766), // Rule ID 13924 //
     /*  662693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  662713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662764 */     GIR_RootConstrainSelectedInstOperands,
     /*  662765 */     // GIR_Coverage, 13924,
     /*  662765 */     GIR_EraseRootFromParent_Done,
     /*  662766 */   // Label 10641: @662766
     /*  662766 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(662844), // Rule ID 13925 //
     /*  662771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  662791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662817 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  662820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662842 */     GIR_RootConstrainSelectedInstOperands,
     /*  662843 */     // GIR_Coverage, 13925,
     /*  662843 */     GIR_EraseRootFromParent_Done,
     /*  662844 */   // Label 10642: @662844
     /*  662844 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(662922), // Rule ID 13928 //
     /*  662849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  662866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  662869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662895 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  662898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662920 */     GIR_RootConstrainSelectedInstOperands,
     /*  662921 */     // GIR_Coverage, 13928,
     /*  662921 */     GIR_EraseRootFromParent_Done,
     /*  662922 */   // Label 10643: @662922
     /*  662922 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(663000), // Rule ID 13929 //
     /*  662927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  662935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  662944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  662947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662973 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  662976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  662998 */     GIR_RootConstrainSelectedInstOperands,
     /*  662999 */     // GIR_Coverage, 13929,
     /*  662999 */     GIR_EraseRootFromParent_Done,
     /*  663000 */   // Label 10644: @663000
     /*  663000 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(663078), // Rule ID 13932 //
     /*  663005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  663025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663076 */     GIR_RootConstrainSelectedInstOperands,
     /*  663077 */     // GIR_Coverage, 13932,
     /*  663077 */     GIR_EraseRootFromParent_Done,
     /*  663078 */   // Label 10645: @663078
     /*  663078 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(663156), // Rule ID 13933 //
     /*  663083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  663103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663129 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663154 */     GIR_RootConstrainSelectedInstOperands,
     /*  663155 */     // GIR_Coverage, 13933,
     /*  663155 */     GIR_EraseRootFromParent_Done,
     /*  663156 */   // Label 10646: @663156
     /*  663156 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(663234), // Rule ID 13936 //
     /*  663161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  663178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  663181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663232 */     GIR_RootConstrainSelectedInstOperands,
     /*  663233 */     // GIR_Coverage, 13936,
     /*  663233 */     GIR_EraseRootFromParent_Done,
     /*  663234 */   // Label 10647: @663234
     /*  663234 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(663312), // Rule ID 13937 //
     /*  663239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  663256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  663259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663310 */     GIR_RootConstrainSelectedInstOperands,
     /*  663311 */     // GIR_Coverage, 13937,
     /*  663311 */     GIR_EraseRootFromParent_Done,
     /*  663312 */   // Label 10648: @663312
     /*  663312 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(663390), // Rule ID 13940 //
     /*  663317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  663320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  663328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  663331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  663337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663363 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  663363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  663382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663388 */     GIR_RootConstrainSelectedInstOperands,
     /*  663389 */     // GIR_Coverage, 13940,
     /*  663389 */     GIR_EraseRootFromParent_Done,
     /*  663390 */   // Label 10649: @663390
     /*  663390 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(663468), // Rule ID 13941 //
     /*  663395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  663398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  663406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  663409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  663415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663441 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  663441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  663444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  663460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663466 */     GIR_RootConstrainSelectedInstOperands,
     /*  663467 */     // GIR_Coverage, 13941,
     /*  663467 */     GIR_EraseRootFromParent_Done,
     /*  663468 */   // Label 10650: @663468
     /*  663468 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(663546), // Rule ID 13944 //
     /*  663473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  663490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  663522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663544 */     GIR_RootConstrainSelectedInstOperands,
     /*  663545 */     // GIR_Coverage, 13944,
     /*  663545 */     GIR_EraseRootFromParent_Done,
     /*  663546 */   // Label 10651: @663546
     /*  663546 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(663624), // Rule ID 13945 //
     /*  663551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  663568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  663600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663622 */     GIR_RootConstrainSelectedInstOperands,
     /*  663623 */     // GIR_Coverage, 13945,
     /*  663623 */     GIR_EraseRootFromParent_Done,
     /*  663624 */   // Label 10652: @663624
     /*  663624 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(663702), // Rule ID 13948 //
     /*  663629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  663646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663675 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  663678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663700 */     GIR_RootConstrainSelectedInstOperands,
     /*  663701 */     // GIR_Coverage, 13948,
     /*  663701 */     GIR_EraseRootFromParent_Done,
     /*  663702 */   // Label 10653: @663702
     /*  663702 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(663780), // Rule ID 13949 //
     /*  663707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  663724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663753 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  663756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663778 */     GIR_RootConstrainSelectedInstOperands,
     /*  663779 */     // GIR_Coverage, 13949,
     /*  663779 */     GIR_EraseRootFromParent_Done,
     /*  663780 */   // Label 10654: @663780
     /*  663780 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(663858), // Rule ID 13952 //
     /*  663785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  663796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  663799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  663802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  663805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663831 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  663834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663856 */     GIR_RootConstrainSelectedInstOperands,
     /*  663857 */     // GIR_Coverage, 13952,
     /*  663857 */     GIR_EraseRootFromParent_Done,
     /*  663858 */   // Label 10655: @663858
     /*  663858 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(663936), // Rule ID 13953 //
     /*  663863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  663874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  663877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  663880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  663883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663909 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  663912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  663934 */     GIR_RootConstrainSelectedInstOperands,
     /*  663935 */     // GIR_Coverage, 13953,
     /*  663935 */     GIR_EraseRootFromParent_Done,
     /*  663936 */   // Label 10656: @663936
     /*  663936 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(664014), // Rule ID 13956 //
     /*  663941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  663949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  663952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  663955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  663958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  663961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  663990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664012 */     GIR_RootConstrainSelectedInstOperands,
     /*  664013 */     // GIR_Coverage, 13956,
     /*  664013 */     GIR_EraseRootFromParent_Done,
     /*  664014 */   // Label 10657: @664014
     /*  664014 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(664092), // Rule ID 13957 //
     /*  664019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  664030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  664033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  664036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  664039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  664068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664090 */     GIR_RootConstrainSelectedInstOperands,
     /*  664091 */     // GIR_Coverage, 13957,
     /*  664091 */     GIR_EraseRootFromParent_Done,
     /*  664092 */   // Label 10658: @664092
     /*  664092 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(664170), // Rule ID 13960 //
     /*  664097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  664114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664143 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  664146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664168 */     GIR_RootConstrainSelectedInstOperands,
     /*  664169 */     // GIR_Coverage, 13960,
     /*  664169 */     GIR_EraseRootFromParent_Done,
     /*  664170 */   // Label 10659: @664170
     /*  664170 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(664248), // Rule ID 13961 //
     /*  664175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  664192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664221 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  664224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664246 */     GIR_RootConstrainSelectedInstOperands,
     /*  664247 */     // GIR_Coverage, 13961,
     /*  664247 */     GIR_EraseRootFromParent_Done,
     /*  664248 */   // Label 10660: @664248
     /*  664248 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(664326), // Rule ID 13964 //
     /*  664253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  664264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  664267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  664270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  664273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  664302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664324 */     GIR_RootConstrainSelectedInstOperands,
     /*  664325 */     // GIR_Coverage, 13964,
     /*  664325 */     GIR_EraseRootFromParent_Done,
     /*  664326 */   // Label 10661: @664326
     /*  664326 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(664404), // Rule ID 13965 //
     /*  664331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  664342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  664345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  664348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  664351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  664380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664402 */     GIR_RootConstrainSelectedInstOperands,
     /*  664403 */     // GIR_Coverage, 13965,
     /*  664403 */     GIR_EraseRootFromParent_Done,
     /*  664404 */   // Label 10662: @664404
     /*  664404 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(664482), // Rule ID 13968 //
     /*  664409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  664458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664480 */     GIR_RootConstrainSelectedInstOperands,
     /*  664481 */     // GIR_Coverage, 13968,
     /*  664481 */     GIR_EraseRootFromParent_Done,
     /*  664482 */   // Label 10663: @664482
     /*  664482 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(664560), // Rule ID 13969 //
     /*  664487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  664536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664558 */     GIR_RootConstrainSelectedInstOperands,
     /*  664559 */     // GIR_Coverage, 13969,
     /*  664559 */     GIR_EraseRootFromParent_Done,
     /*  664560 */   // Label 10664: @664560
     /*  664560 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(664638), // Rule ID 13972 //
     /*  664565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  664576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  664579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  664585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  664614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664636 */     GIR_RootConstrainSelectedInstOperands,
     /*  664637 */     // GIR_Coverage, 13972,
     /*  664637 */     GIR_EraseRootFromParent_Done,
     /*  664638 */   // Label 10665: @664638
     /*  664638 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(664716), // Rule ID 13973 //
     /*  664643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  664654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  664657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  664663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  664692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664714 */     GIR_RootConstrainSelectedInstOperands,
     /*  664715 */     // GIR_Coverage, 13973,
     /*  664715 */     GIR_EraseRootFromParent_Done,
     /*  664716 */   // Label 10666: @664716
     /*  664716 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(664794), // Rule ID 13976 //
     /*  664721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  664732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  664735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  664741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664767 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  664770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664792 */     GIR_RootConstrainSelectedInstOperands,
     /*  664793 */     // GIR_Coverage, 13976,
     /*  664793 */     GIR_EraseRootFromParent_Done,
     /*  664794 */   // Label 10667: @664794
     /*  664794 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(664872), // Rule ID 13977 //
     /*  664799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  664810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  664813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  664819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664845 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  664848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664870 */     GIR_RootConstrainSelectedInstOperands,
     /*  664871 */     // GIR_Coverage, 13977,
     /*  664871 */     GIR_EraseRootFromParent_Done,
     /*  664872 */   // Label 10668: @664872
     /*  664872 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(664950), // Rule ID 13980 //
     /*  664877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  664880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  664888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  664891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  664897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  664923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  664926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  664942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  664948 */     GIR_RootConstrainSelectedInstOperands,
     /*  664949 */     // GIR_Coverage, 13980,
     /*  664949 */     GIR_EraseRootFromParent_Done,
     /*  664950 */   // Label 10669: @664950
     /*  664950 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(665028), // Rule ID 13981 //
     /*  664955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  664958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  664963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  664966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  664969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  664975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  665004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665026 */     GIR_RootConstrainSelectedInstOperands,
     /*  665027 */     // GIR_Coverage, 13981,
     /*  665027 */     GIR_EraseRootFromParent_Done,
     /*  665028 */   // Label 10670: @665028
     /*  665028 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(665106), // Rule ID 13984 //
     /*  665033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  665036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  665044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  665047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  665050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  665053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665079 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  665082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665104 */     GIR_RootConstrainSelectedInstOperands,
     /*  665105 */     // GIR_Coverage, 13984,
     /*  665105 */     GIR_EraseRootFromParent_Done,
     /*  665106 */   // Label 10671: @665106
     /*  665106 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(665184), // Rule ID 13985 //
     /*  665111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  665122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  665125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  665128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  665131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665157 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  665160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665182 */     GIR_RootConstrainSelectedInstOperands,
     /*  665183 */     // GIR_Coverage, 13985,
     /*  665183 */     GIR_EraseRootFromParent_Done,
     /*  665184 */   // Label 10672: @665184
     /*  665184 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(665262), // Rule ID 13988 //
     /*  665189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  665192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  665200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  665203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  665209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665235 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  665238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665260 */     GIR_RootConstrainSelectedInstOperands,
     /*  665261 */     // GIR_Coverage, 13988,
     /*  665261 */     GIR_EraseRootFromParent_Done,
     /*  665262 */   // Label 10673: @665262
     /*  665262 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(665340), // Rule ID 13989 //
     /*  665267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  665278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  665281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  665287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665313 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  665316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665338 */     GIR_RootConstrainSelectedInstOperands,
     /*  665339 */     // GIR_Coverage, 13989,
     /*  665339 */     GIR_EraseRootFromParent_Done,
     /*  665340 */   // Label 10674: @665340
     /*  665340 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(665418), // Rule ID 13992 //
     /*  665345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  665362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665391 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  665394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665416 */     GIR_RootConstrainSelectedInstOperands,
     /*  665417 */     // GIR_Coverage, 13992,
     /*  665417 */     GIR_EraseRootFromParent_Done,
     /*  665418 */   // Label 10675: @665418
     /*  665418 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(665496), // Rule ID 13993 //
     /*  665423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  665440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  665472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665494 */     GIR_RootConstrainSelectedInstOperands,
     /*  665495 */     // GIR_Coverage, 13993,
     /*  665495 */     GIR_EraseRootFromParent_Done,
     /*  665496 */   // Label 10676: @665496
     /*  665496 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(665574), // Rule ID 13996 //
     /*  665501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  665518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665547 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  665550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665572 */     GIR_RootConstrainSelectedInstOperands,
     /*  665573 */     // GIR_Coverage, 13996,
     /*  665573 */     GIR_EraseRootFromParent_Done,
     /*  665574 */   // Label 10677: @665574
     /*  665574 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(665652), // Rule ID 13997 //
     /*  665579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  665596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665625 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  665628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665650 */     GIR_RootConstrainSelectedInstOperands,
     /*  665651 */     // GIR_Coverage, 13997,
     /*  665651 */     GIR_EraseRootFromParent_Done,
     /*  665652 */   // Label 10678: @665652
     /*  665652 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(665730), // Rule ID 14000 //
     /*  665657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  665674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665703 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  665706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665728 */     GIR_RootConstrainSelectedInstOperands,
     /*  665729 */     // GIR_Coverage, 14000,
     /*  665729 */     GIR_EraseRootFromParent_Done,
     /*  665730 */   // Label 10679: @665730
     /*  665730 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(665808), // Rule ID 14001 //
     /*  665735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  665752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665781 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  665784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665806 */     GIR_RootConstrainSelectedInstOperands,
     /*  665807 */     // GIR_Coverage, 14001,
     /*  665807 */     GIR_EraseRootFromParent_Done,
     /*  665808 */   // Label 10680: @665808
     /*  665808 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(665886), // Rule ID 14004 //
     /*  665813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  665824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  665827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665859 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  665862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665884 */     GIR_RootConstrainSelectedInstOperands,
     /*  665885 */     // GIR_Coverage, 14004,
     /*  665885 */     GIR_EraseRootFromParent_Done,
     /*  665886 */   // Label 10681: @665886
     /*  665886 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(665964), // Rule ID 14005 //
     /*  665891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  665902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  665905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665937 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  665940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  665962 */     GIR_RootConstrainSelectedInstOperands,
     /*  665963 */     // GIR_Coverage, 14005,
     /*  665963 */     GIR_EraseRootFromParent_Done,
     /*  665964 */   // Label 10682: @665964
     /*  665964 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(666042), // Rule ID 14008 //
     /*  665969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  665977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  665980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  665983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  665986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666015 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  666018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666040 */     GIR_RootConstrainSelectedInstOperands,
     /*  666041 */     // GIR_Coverage, 14008,
     /*  666041 */     GIR_EraseRootFromParent_Done,
     /*  666042 */   // Label 10683: @666042
     /*  666042 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(666120), // Rule ID 14009 //
     /*  666047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  666058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  666061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  666064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  666096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666118 */     GIR_RootConstrainSelectedInstOperands,
     /*  666119 */     // GIR_Coverage, 14009,
     /*  666119 */     GIR_EraseRootFromParent_Done,
     /*  666120 */   // Label 10684: @666120
     /*  666120 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(666198), // Rule ID 14012 //
     /*  666125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  666174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666196 */     GIR_RootConstrainSelectedInstOperands,
     /*  666197 */     // GIR_Coverage, 14012,
     /*  666197 */     GIR_EraseRootFromParent_Done,
     /*  666198 */   // Label 10685: @666198
     /*  666198 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(666276), // Rule ID 14013 //
     /*  666203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  666252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666274 */     GIR_RootConstrainSelectedInstOperands,
     /*  666275 */     // GIR_Coverage, 14013,
     /*  666275 */     GIR_EraseRootFromParent_Done,
     /*  666276 */   // Label 10686: @666276
     /*  666276 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(666354), // Rule ID 14016 //
     /*  666281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  666292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  666295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  666298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666352 */     GIR_RootConstrainSelectedInstOperands,
     /*  666353 */     // GIR_Coverage, 14016,
     /*  666353 */     GIR_EraseRootFromParent_Done,
     /*  666354 */   // Label 10687: @666354
     /*  666354 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(666432), // Rule ID 14017 //
     /*  666359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  666370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  666373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  666376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666405 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666430 */     GIR_RootConstrainSelectedInstOperands,
     /*  666431 */     // GIR_Coverage, 14017,
     /*  666431 */     GIR_EraseRootFromParent_Done,
     /*  666432 */   // Label 10688: @666432
     /*  666432 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(666510), // Rule ID 14020 //
     /*  666437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  666454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666508 */     GIR_RootConstrainSelectedInstOperands,
     /*  666509 */     // GIR_Coverage, 14020,
     /*  666509 */     GIR_EraseRootFromParent_Done,
     /*  666510 */   // Label 10689: @666510
     /*  666510 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(666588), // Rule ID 14021 //
     /*  666515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  666532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666586 */     GIR_RootConstrainSelectedInstOperands,
     /*  666587 */     // GIR_Coverage, 14021,
     /*  666587 */     GIR_EraseRootFromParent_Done,
     /*  666588 */   // Label 10690: @666588
     /*  666588 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(666666), // Rule ID 14024 //
     /*  666593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  666604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  666607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666664 */     GIR_RootConstrainSelectedInstOperands,
     /*  666665 */     // GIR_Coverage, 14024,
     /*  666665 */     GIR_EraseRootFromParent_Done,
     /*  666666 */   // Label 10691: @666666
     /*  666666 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(666744), // Rule ID 14025 //
     /*  666671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  666682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  666685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666717 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666742 */     GIR_RootConstrainSelectedInstOperands,
     /*  666743 */     // GIR_Coverage, 14025,
     /*  666743 */     GIR_EraseRootFromParent_Done,
     /*  666744 */   // Label 10692: @666744
     /*  666744 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(666822), // Rule ID 14028 //
     /*  666749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  666760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  666763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666795 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666820 */     GIR_RootConstrainSelectedInstOperands,
     /*  666821 */     // GIR_Coverage, 14028,
     /*  666821 */     GIR_EraseRootFromParent_Done,
     /*  666822 */   // Label 10693: @666822
     /*  666822 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(666900), // Rule ID 14029 //
     /*  666827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  666838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  666841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  666876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666898 */     GIR_RootConstrainSelectedInstOperands,
     /*  666899 */     // GIR_Coverage, 14029,
     /*  666899 */     GIR_EraseRootFromParent_Done,
     /*  666900 */   // Label 10694: @666900
     /*  666900 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(666978), // Rule ID 14032 //
     /*  666905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  666916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  666919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  666922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666951 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  666954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  666976 */     GIR_RootConstrainSelectedInstOperands,
     /*  666977 */     // GIR_Coverage, 14032,
     /*  666977 */     GIR_EraseRootFromParent_Done,
     /*  666978 */   // Label 10695: @666978
     /*  666978 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(667056), // Rule ID 14033 //
     /*  666983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  666991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  666994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  666997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  667000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  667032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667054 */     GIR_RootConstrainSelectedInstOperands,
     /*  667055 */     // GIR_Coverage, 14033,
     /*  667055 */     GIR_EraseRootFromParent_Done,
     /*  667056 */   // Label 10696: @667056
     /*  667056 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(667134), // Rule ID 14036 //
     /*  667061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  667072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  667075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  667078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667107 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  667110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667132 */     GIR_RootConstrainSelectedInstOperands,
     /*  667133 */     // GIR_Coverage, 14036,
     /*  667133 */     GIR_EraseRootFromParent_Done,
     /*  667134 */   // Label 10697: @667134
     /*  667134 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(667212), // Rule ID 14037 //
     /*  667139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  667150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  667153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  667156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667185 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  667188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667210 */     GIR_RootConstrainSelectedInstOperands,
     /*  667211 */     // GIR_Coverage, 14037,
     /*  667211 */     GIR_EraseRootFromParent_Done,
     /*  667212 */   // Label 10698: @667212
     /*  667212 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(667290), // Rule ID 14040 //
     /*  667217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  667228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  667231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  667234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667263 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  667266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667288 */     GIR_RootConstrainSelectedInstOperands,
     /*  667289 */     // GIR_Coverage, 14040,
     /*  667289 */     GIR_EraseRootFromParent_Done,
     /*  667290 */   // Label 10699: @667290
     /*  667290 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(667368), // Rule ID 14041 //
     /*  667295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  667306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  667309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  667312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667341 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  667344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667366 */     GIR_RootConstrainSelectedInstOperands,
     /*  667367 */     // GIR_Coverage, 14041,
     /*  667367 */     GIR_EraseRootFromParent_Done,
     /*  667368 */   // Label 10700: @667368
     /*  667368 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(667446), // Rule ID 14044 //
     /*  667373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  667384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  667387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  667390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  667422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667444 */     GIR_RootConstrainSelectedInstOperands,
     /*  667445 */     // GIR_Coverage, 14044,
     /*  667445 */     GIR_EraseRootFromParent_Done,
     /*  667446 */   // Label 10701: @667446
     /*  667446 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(667524), // Rule ID 14045 //
     /*  667451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  667462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  667465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  667468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667497 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  667500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667522 */     GIR_RootConstrainSelectedInstOperands,
     /*  667523 */     // GIR_Coverage, 14045,
     /*  667523 */     GIR_EraseRootFromParent_Done,
     /*  667524 */   // Label 10702: @667524
     /*  667524 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(667602), // Rule ID 14048 //
     /*  667529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  667540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  667543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  667546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667575 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  667578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667600 */     GIR_RootConstrainSelectedInstOperands,
     /*  667601 */     // GIR_Coverage, 14048,
     /*  667601 */     GIR_EraseRootFromParent_Done,
     /*  667602 */   // Label 10703: @667602
     /*  667602 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(667680), // Rule ID 14049 //
     /*  667607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  667618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  667621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  667624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667653 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  667656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667678 */     GIR_RootConstrainSelectedInstOperands,
     /*  667679 */     // GIR_Coverage, 14049,
     /*  667679 */     GIR_EraseRootFromParent_Done,
     /*  667680 */   // Label 10704: @667680
     /*  667680 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(667758), // Rule ID 14052 //
     /*  667685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  667696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  667699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  667702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667731 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  667734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667756 */     GIR_RootConstrainSelectedInstOperands,
     /*  667757 */     // GIR_Coverage, 14052,
     /*  667757 */     GIR_EraseRootFromParent_Done,
     /*  667758 */   // Label 10705: @667758
     /*  667758 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(667836), // Rule ID 14053 //
     /*  667763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  667774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  667777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  667780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  667812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667834 */     GIR_RootConstrainSelectedInstOperands,
     /*  667835 */     // GIR_Coverage, 14053,
     /*  667835 */     GIR_EraseRootFromParent_Done,
     /*  667836 */   // Label 10706: @667836
     /*  667836 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(667914), // Rule ID 14056 //
     /*  667841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  667858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  667890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667912 */     GIR_RootConstrainSelectedInstOperands,
     /*  667913 */     // GIR_Coverage, 14056,
     /*  667913 */     GIR_EraseRootFromParent_Done,
     /*  667914 */   // Label 10707: @667914
     /*  667914 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(667992), // Rule ID 14057 //
     /*  667919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  667927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  667936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  667968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  667990 */     GIR_RootConstrainSelectedInstOperands,
     /*  667991 */     // GIR_Coverage, 14057,
     /*  667991 */     GIR_EraseRootFromParent_Done,
     /*  667992 */   // Label 10708: @667992
     /*  667992 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(668070), // Rule ID 14060 //
     /*  667997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  668008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  668011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  668014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  668046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668068 */     GIR_RootConstrainSelectedInstOperands,
     /*  668069 */     // GIR_Coverage, 14060,
     /*  668069 */     GIR_EraseRootFromParent_Done,
     /*  668070 */   // Label 10709: @668070
     /*  668070 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(668148), // Rule ID 14061 //
     /*  668075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  668086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  668089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  668092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  668124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668146 */     GIR_RootConstrainSelectedInstOperands,
     /*  668147 */     // GIR_Coverage, 14061,
     /*  668147 */     GIR_EraseRootFromParent_Done,
     /*  668148 */   // Label 10710: @668148
     /*  668148 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(668226), // Rule ID 14064 //
     /*  668153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  668164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  668167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  668170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668199 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  668202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668224 */     GIR_RootConstrainSelectedInstOperands,
     /*  668225 */     // GIR_Coverage, 14064,
     /*  668225 */     GIR_EraseRootFromParent_Done,
     /*  668226 */   // Label 10711: @668226
     /*  668226 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(668304), // Rule ID 14065 //
     /*  668231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  668242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  668245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  668248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668277 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  668280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668302 */     GIR_RootConstrainSelectedInstOperands,
     /*  668303 */     // GIR_Coverage, 14065,
     /*  668303 */     GIR_EraseRootFromParent_Done,
     /*  668304 */   // Label 10712: @668304
     /*  668304 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(668382), // Rule ID 14068 //
     /*  668309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  668320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  668323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  668326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  668358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668380 */     GIR_RootConstrainSelectedInstOperands,
     /*  668381 */     // GIR_Coverage, 14068,
     /*  668381 */     GIR_EraseRootFromParent_Done,
     /*  668382 */   // Label 10713: @668382
     /*  668382 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(668460), // Rule ID 14069 //
     /*  668387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  668398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  668401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  668404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668433 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  668436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668458 */     GIR_RootConstrainSelectedInstOperands,
     /*  668459 */     // GIR_Coverage, 14069,
     /*  668459 */     GIR_EraseRootFromParent_Done,
     /*  668460 */   // Label 10714: @668460
     /*  668460 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(668538), // Rule ID 14072 //
     /*  668465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  668476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  668479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  668482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  668514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668536 */     GIR_RootConstrainSelectedInstOperands,
     /*  668537 */     // GIR_Coverage, 14072,
     /*  668537 */     GIR_EraseRootFromParent_Done,
     /*  668538 */   // Label 10715: @668538
     /*  668538 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(668616), // Rule ID 14073 //
     /*  668543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  668554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  668557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  668560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668589 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  668592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668614 */     GIR_RootConstrainSelectedInstOperands,
     /*  668615 */     // GIR_Coverage, 14073,
     /*  668615 */     GIR_EraseRootFromParent_Done,
     /*  668616 */   // Label 10716: @668616
     /*  668616 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(668694), // Rule ID 14076 //
     /*  668621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  668632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  668635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  668638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668667 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  668670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668692 */     GIR_RootConstrainSelectedInstOperands,
     /*  668693 */     // GIR_Coverage, 14076,
     /*  668693 */     GIR_EraseRootFromParent_Done,
     /*  668694 */   // Label 10717: @668694
     /*  668694 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(668772), // Rule ID 14077 //
     /*  668699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  668707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  668710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  668713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  668716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668745 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  668748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668770 */     GIR_RootConstrainSelectedInstOperands,
     /*  668771 */     // GIR_Coverage, 14077,
     /*  668771 */     GIR_EraseRootFromParent_Done,
     /*  668772 */   // Label 10718: @668772
     /*  668772 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(668850), // Rule ID 14168 //
     /*  668777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  668785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  668788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  668791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  668794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  668797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668823 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  668826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668848 */     GIR_RootConstrainSelectedInstOperands,
     /*  668849 */     // GIR_Coverage, 14168,
     /*  668849 */     GIR_EraseRootFromParent_Done,
     /*  668850 */   // Label 10719: @668850
     /*  668850 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(668928), // Rule ID 14169 //
     /*  668855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  668863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  668866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  668869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  668872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  668875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  668904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  668926 */     GIR_RootConstrainSelectedInstOperands,
     /*  668927 */     // GIR_Coverage, 14169,
     /*  668927 */     GIR_EraseRootFromParent_Done,
     /*  668928 */   // Label 10720: @668928
     /*  668928 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(669006), // Rule ID 14172 //
     /*  668933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  668941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  668944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  668947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  668950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  668953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668979 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  668982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669004 */     GIR_RootConstrainSelectedInstOperands,
     /*  669005 */     // GIR_Coverage, 14172,
     /*  669005 */     GIR_EraseRootFromParent_Done,
     /*  669006 */   // Label 10721: @669006
     /*  669006 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(669084), // Rule ID 14173 //
     /*  669011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  669022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  669025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  669028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  669031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669057 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  669060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669082 */     GIR_RootConstrainSelectedInstOperands,
     /*  669083 */     // GIR_Coverage, 14173,
     /*  669083 */     GIR_EraseRootFromParent_Done,
     /*  669084 */   // Label 10722: @669084
     /*  669084 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(669162), // Rule ID 14176 //
     /*  669089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  669100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  669103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  669106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  669109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669135 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669160 */     GIR_RootConstrainSelectedInstOperands,
     /*  669161 */     // GIR_Coverage, 14176,
     /*  669161 */     GIR_EraseRootFromParent_Done,
     /*  669162 */   // Label 10723: @669162
     /*  669162 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(669240), // Rule ID 14177 //
     /*  669167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  669178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  669181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  669184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  669187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669213 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669238 */     GIR_RootConstrainSelectedInstOperands,
     /*  669239 */     // GIR_Coverage, 14177,
     /*  669239 */     GIR_EraseRootFromParent_Done,
     /*  669240 */   // Label 10724: @669240
     /*  669240 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(669318), // Rule ID 14180 //
     /*  669245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  669256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  669259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  669262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  669265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  669294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669316 */     GIR_RootConstrainSelectedInstOperands,
     /*  669317 */     // GIR_Coverage, 14180,
     /*  669317 */     GIR_EraseRootFromParent_Done,
     /*  669318 */   // Label 10725: @669318
     /*  669318 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(669396), // Rule ID 14181 //
     /*  669323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  669334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  669337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  669340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  669343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  669372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669394 */     GIR_RootConstrainSelectedInstOperands,
     /*  669395 */     // GIR_Coverage, 14181,
     /*  669395 */     GIR_EraseRootFromParent_Done,
     /*  669396 */   // Label 10726: @669396
     /*  669396 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(669474), // Rule ID 14184 //
     /*  669401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  669412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  669415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  669418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  669421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669447 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669472 */     GIR_RootConstrainSelectedInstOperands,
     /*  669473 */     // GIR_Coverage, 14184,
     /*  669473 */     GIR_EraseRootFromParent_Done,
     /*  669474 */   // Label 10727: @669474
     /*  669474 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(669552), // Rule ID 14185 //
     /*  669479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  669490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  669493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  669496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  669499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669525 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669550 */     GIR_RootConstrainSelectedInstOperands,
     /*  669551 */     // GIR_Coverage, 14185,
     /*  669551 */     GIR_EraseRootFromParent_Done,
     /*  669552 */   // Label 10728: @669552
     /*  669552 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(669630), // Rule ID 14188 //
     /*  669557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  669568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  669571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  669574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  669577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669603 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669628 */     GIR_RootConstrainSelectedInstOperands,
     /*  669629 */     // GIR_Coverage, 14188,
     /*  669629 */     GIR_EraseRootFromParent_Done,
     /*  669630 */   // Label 10729: @669630
     /*  669630 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(669708), // Rule ID 14189 //
     /*  669635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  669646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  669649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  669652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  669655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  669684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669706 */     GIR_RootConstrainSelectedInstOperands,
     /*  669707 */     // GIR_Coverage, 14189,
     /*  669707 */     GIR_EraseRootFromParent_Done,
     /*  669708 */   // Label 10730: @669708
     /*  669708 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(669786), // Rule ID 14192 //
     /*  669713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  669724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  669727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  669730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  669733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  669762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669784 */     GIR_RootConstrainSelectedInstOperands,
     /*  669785 */     // GIR_Coverage, 14192,
     /*  669785 */     GIR_EraseRootFromParent_Done,
     /*  669786 */   // Label 10731: @669786
     /*  669786 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(669864), // Rule ID 14193 //
     /*  669791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  669802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  669805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  669808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  669811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669837 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  669840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669862 */     GIR_RootConstrainSelectedInstOperands,
     /*  669863 */     // GIR_Coverage, 14193,
     /*  669863 */     GIR_EraseRootFromParent_Done,
     /*  669864 */   // Label 10732: @669864
     /*  669864 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(669942), // Rule ID 14196 //
     /*  669869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  669880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  669883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  669886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  669889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  669918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  669940 */     GIR_RootConstrainSelectedInstOperands,
     /*  669941 */     // GIR_Coverage, 14196,
     /*  669941 */     GIR_EraseRootFromParent_Done,
     /*  669942 */   // Label 10733: @669942
     /*  669942 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(670020), // Rule ID 14197 //
     /*  669947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  669955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  669958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  669961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  669964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  669967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  669996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670018 */     GIR_RootConstrainSelectedInstOperands,
     /*  670019 */     // GIR_Coverage, 14197,
     /*  670019 */     GIR_EraseRootFromParent_Done,
     /*  670020 */   // Label 10734: @670020
     /*  670020 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(670098), // Rule ID 14200 //
     /*  670025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  670036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  670039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  670042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  670045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  670074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670096 */     GIR_RootConstrainSelectedInstOperands,
     /*  670097 */     // GIR_Coverage, 14200,
     /*  670097 */     GIR_EraseRootFromParent_Done,
     /*  670098 */   // Label 10735: @670098
     /*  670098 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(670176), // Rule ID 14201 //
     /*  670103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  670114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  670117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  670120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  670123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670149 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  670152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670174 */     GIR_RootConstrainSelectedInstOperands,
     /*  670175 */     // GIR_Coverage, 14201,
     /*  670175 */     GIR_EraseRootFromParent_Done,
     /*  670176 */   // Label 10736: @670176
     /*  670176 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(670254), // Rule ID 14204 //
     /*  670181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  670192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  670195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  670198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  670201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  670230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670252 */     GIR_RootConstrainSelectedInstOperands,
     /*  670253 */     // GIR_Coverage, 14204,
     /*  670253 */     GIR_EraseRootFromParent_Done,
     /*  670254 */   // Label 10737: @670254
     /*  670254 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(670332), // Rule ID 14205 //
     /*  670259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  670270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  670273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  670276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  670279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670305 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  670308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670330 */     GIR_RootConstrainSelectedInstOperands,
     /*  670331 */     // GIR_Coverage, 14205,
     /*  670331 */     GIR_EraseRootFromParent_Done,
     /*  670332 */   // Label 10738: @670332
     /*  670332 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(670410), // Rule ID 14208 //
     /*  670337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  670348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  670351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  670354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  670357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  670386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670408 */     GIR_RootConstrainSelectedInstOperands,
     /*  670409 */     // GIR_Coverage, 14208,
     /*  670409 */     GIR_EraseRootFromParent_Done,
     /*  670410 */   // Label 10739: @670410
     /*  670410 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(670488), // Rule ID 14209 //
     /*  670415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  670426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  670429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  670432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  670435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  670464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670486 */     GIR_RootConstrainSelectedInstOperands,
     /*  670487 */     // GIR_Coverage, 14209,
     /*  670487 */     GIR_EraseRootFromParent_Done,
     /*  670488 */   // Label 10740: @670488
     /*  670488 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(670566), // Rule ID 14212 //
     /*  670493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  670504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  670507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  670510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  670513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670539 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  670542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670564 */     GIR_RootConstrainSelectedInstOperands,
     /*  670565 */     // GIR_Coverage, 14212,
     /*  670565 */     GIR_EraseRootFromParent_Done,
     /*  670566 */   // Label 10741: @670566
     /*  670566 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(670644), // Rule ID 14213 //
     /*  670571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  670582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  670585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  670588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  670591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  670620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670642 */     GIR_RootConstrainSelectedInstOperands,
     /*  670643 */     // GIR_Coverage, 14213,
     /*  670643 */     GIR_EraseRootFromParent_Done,
     /*  670644 */   // Label 10742: @670644
     /*  670644 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(670722), // Rule ID 14216 //
     /*  670649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  670660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  670663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  670666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  670669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670695 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  670698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670720 */     GIR_RootConstrainSelectedInstOperands,
     /*  670721 */     // GIR_Coverage, 14216,
     /*  670721 */     GIR_EraseRootFromParent_Done,
     /*  670722 */   // Label 10743: @670722
     /*  670722 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(670800), // Rule ID 14217 //
     /*  670727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  670738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  670741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  670744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  670747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670773 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  670776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670798 */     GIR_RootConstrainSelectedInstOperands,
     /*  670799 */     // GIR_Coverage, 14217,
     /*  670799 */     GIR_EraseRootFromParent_Done,
     /*  670800 */   // Label 10744: @670800
     /*  670800 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(670878), // Rule ID 14220 //
     /*  670805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  670816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  670819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  670822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  670825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  670854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670876 */     GIR_RootConstrainSelectedInstOperands,
     /*  670877 */     // GIR_Coverage, 14220,
     /*  670877 */     GIR_EraseRootFromParent_Done,
     /*  670878 */   // Label 10745: @670878
     /*  670878 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(670956), // Rule ID 14221 //
     /*  670883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  670894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  670897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  670900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  670903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  670932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  670954 */     GIR_RootConstrainSelectedInstOperands,
     /*  670955 */     // GIR_Coverage, 14221,
     /*  670955 */     GIR_EraseRootFromParent_Done,
     /*  670956 */   // Label 10746: @670956
     /*  670956 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(671034), // Rule ID 14224 //
     /*  670961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  670969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  670972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  670975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  670978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  670981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671007 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  671010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671032 */     GIR_RootConstrainSelectedInstOperands,
     /*  671033 */     // GIR_Coverage, 14224,
     /*  671033 */     GIR_EraseRootFromParent_Done,
     /*  671034 */   // Label 10747: @671034
     /*  671034 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(671112), // Rule ID 14225 //
     /*  671039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  671050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  671053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  671056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  671059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671085 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  671088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671110 */     GIR_RootConstrainSelectedInstOperands,
     /*  671111 */     // GIR_Coverage, 14225,
     /*  671111 */     GIR_EraseRootFromParent_Done,
     /*  671112 */   // Label 10748: @671112
     /*  671112 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(671190), // Rule ID 14228 //
     /*  671117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  671128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  671131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  671134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  671137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671163 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  671166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671188 */     GIR_RootConstrainSelectedInstOperands,
     /*  671189 */     // GIR_Coverage, 14228,
     /*  671189 */     GIR_EraseRootFromParent_Done,
     /*  671190 */   // Label 10749: @671190
     /*  671190 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(671268), // Rule ID 14229 //
     /*  671195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  671206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  671209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  671212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  671215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  671244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671266 */     GIR_RootConstrainSelectedInstOperands,
     /*  671267 */     // GIR_Coverage, 14229,
     /*  671267 */     GIR_EraseRootFromParent_Done,
     /*  671268 */   // Label 10750: @671268
     /*  671268 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(671346), // Rule ID 14232 //
     /*  671273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  671284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  671287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  671290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  671293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  671322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671344 */     GIR_RootConstrainSelectedInstOperands,
     /*  671345 */     // GIR_Coverage, 14232,
     /*  671345 */     GIR_EraseRootFromParent_Done,
     /*  671346 */   // Label 10751: @671346
     /*  671346 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(671424), // Rule ID 14233 //
     /*  671351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  671362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  671365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  671368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  671371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  671400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671422 */     GIR_RootConstrainSelectedInstOperands,
     /*  671423 */     // GIR_Coverage, 14233,
     /*  671423 */     GIR_EraseRootFromParent_Done,
     /*  671424 */   // Label 10752: @671424
     /*  671424 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(671502), // Rule ID 14236 //
     /*  671429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  671440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  671443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  671446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  671449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671475 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  671478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671500 */     GIR_RootConstrainSelectedInstOperands,
     /*  671501 */     // GIR_Coverage, 14236,
     /*  671501 */     GIR_EraseRootFromParent_Done,
     /*  671502 */   // Label 10753: @671502
     /*  671502 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(671580), // Rule ID 14237 //
     /*  671507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  671518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  671521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  671524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  671527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  671556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671578 */     GIR_RootConstrainSelectedInstOperands,
     /*  671579 */     // GIR_Coverage, 14237,
     /*  671579 */     GIR_EraseRootFromParent_Done,
     /*  671580 */   // Label 10754: @671580
     /*  671580 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(671658), // Rule ID 14240 //
     /*  671585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  671596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  671599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  671602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  671605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671631 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  671634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671656 */     GIR_RootConstrainSelectedInstOperands,
     /*  671657 */     // GIR_Coverage, 14240,
     /*  671657 */     GIR_EraseRootFromParent_Done,
     /*  671658 */   // Label 10755: @671658
     /*  671658 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(671736), // Rule ID 14241 //
     /*  671663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  671674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  671677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  671680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  671683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  671712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671734 */     GIR_RootConstrainSelectedInstOperands,
     /*  671735 */     // GIR_Coverage, 14241,
     /*  671735 */     GIR_EraseRootFromParent_Done,
     /*  671736 */   // Label 10756: @671736
     /*  671736 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(671814), // Rule ID 14244 //
     /*  671741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  671744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  671752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  671755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  671758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  671761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  671787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  671790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671812 */     GIR_RootConstrainSelectedInstOperands,
     /*  671813 */     // GIR_Coverage, 14244,
     /*  671813 */     GIR_EraseRootFromParent_Done,
     /*  671814 */   // Label 10757: @671814
     /*  671814 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(671892), // Rule ID 14245 //
     /*  671819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  671822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  671830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  671833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  671836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  671839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  671865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  671868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671890 */     GIR_RootConstrainSelectedInstOperands,
     /*  671891 */     // GIR_Coverage, 14245,
     /*  671891 */     GIR_EraseRootFromParent_Done,
     /*  671892 */   // Label 10758: @671892
     /*  671892 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(671970), // Rule ID 14248 //
     /*  671897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  671900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  671908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  671911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  671914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  671917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671943 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  671943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  671946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  671968 */     GIR_RootConstrainSelectedInstOperands,
     /*  671969 */     // GIR_Coverage, 14248,
     /*  671969 */     GIR_EraseRootFromParent_Done,
     /*  671970 */   // Label 10759: @671970
     /*  671970 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(672048), // Rule ID 14249 //
     /*  671975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  671978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  671983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  671986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  671989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  671992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  671995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  672024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672046 */     GIR_RootConstrainSelectedInstOperands,
     /*  672047 */     // GIR_Coverage, 14249,
     /*  672047 */     GIR_EraseRootFromParent_Done,
     /*  672048 */   // Label 10760: @672048
     /*  672048 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(672126), // Rule ID 14252 //
     /*  672053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  672064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  672067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  672070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  672073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672099 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  672102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672124 */     GIR_RootConstrainSelectedInstOperands,
     /*  672125 */     // GIR_Coverage, 14252,
     /*  672125 */     GIR_EraseRootFromParent_Done,
     /*  672126 */   // Label 10761: @672126
     /*  672126 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(672204), // Rule ID 14253 //
     /*  672131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  672142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  672145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  672148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  672151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  672180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672202 */     GIR_RootConstrainSelectedInstOperands,
     /*  672203 */     // GIR_Coverage, 14253,
     /*  672203 */     GIR_EraseRootFromParent_Done,
     /*  672204 */   // Label 10762: @672204
     /*  672204 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(672282), // Rule ID 14256 //
     /*  672209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  672220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  672223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  672226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  672258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672280 */     GIR_RootConstrainSelectedInstOperands,
     /*  672281 */     // GIR_Coverage, 14256,
     /*  672281 */     GIR_EraseRootFromParent_Done,
     /*  672282 */   // Label 10763: @672282
     /*  672282 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(672360), // Rule ID 14257 //
     /*  672287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  672298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  672301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  672304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672333 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  672336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672358 */     GIR_RootConstrainSelectedInstOperands,
     /*  672359 */     // GIR_Coverage, 14257,
     /*  672359 */     GIR_EraseRootFromParent_Done,
     /*  672360 */   // Label 10764: @672360
     /*  672360 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(672438), // Rule ID 14260 //
     /*  672365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  672376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  672379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  672382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672411 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  672414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672436 */     GIR_RootConstrainSelectedInstOperands,
     /*  672437 */     // GIR_Coverage, 14260,
     /*  672437 */     GIR_EraseRootFromParent_Done,
     /*  672438 */   // Label 10765: @672438
     /*  672438 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(672516), // Rule ID 14261 //
     /*  672443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  672454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  672457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  672460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  672492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672514 */     GIR_RootConstrainSelectedInstOperands,
     /*  672515 */     // GIR_Coverage, 14261,
     /*  672515 */     GIR_EraseRootFromParent_Done,
     /*  672516 */   // Label 10766: @672516
     /*  672516 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(672594), // Rule ID 14264 //
     /*  672521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  672532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  672535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  672538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672567 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  672570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672592 */     GIR_RootConstrainSelectedInstOperands,
     /*  672593 */     // GIR_Coverage, 14264,
     /*  672593 */     GIR_EraseRootFromParent_Done,
     /*  672594 */   // Label 10767: @672594
     /*  672594 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(672672), // Rule ID 14265 //
     /*  672599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  672610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  672613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  672616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672645 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  672648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672670 */     GIR_RootConstrainSelectedInstOperands,
     /*  672671 */     // GIR_Coverage, 14265,
     /*  672671 */     GIR_EraseRootFromParent_Done,
     /*  672672 */   // Label 10768: @672672
     /*  672672 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(672750), // Rule ID 14268 //
     /*  672677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  672688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  672691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  672694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672723 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  672726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672748 */     GIR_RootConstrainSelectedInstOperands,
     /*  672749 */     // GIR_Coverage, 14268,
     /*  672749 */     GIR_EraseRootFromParent_Done,
     /*  672750 */   // Label 10769: @672750
     /*  672750 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(672828), // Rule ID 14269 //
     /*  672755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  672766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  672769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  672772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672801 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  672804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672826 */     GIR_RootConstrainSelectedInstOperands,
     /*  672827 */     // GIR_Coverage, 14269,
     /*  672827 */     GIR_EraseRootFromParent_Done,
     /*  672828 */   // Label 10770: @672828
     /*  672828 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(672906), // Rule ID 14272 //
     /*  672833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  672844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  672847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  672850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672879 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  672882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672904 */     GIR_RootConstrainSelectedInstOperands,
     /*  672905 */     // GIR_Coverage, 14272,
     /*  672905 */     GIR_EraseRootFromParent_Done,
     /*  672906 */   // Label 10771: @672906
     /*  672906 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(672984), // Rule ID 14273 //
     /*  672911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  672922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  672925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  672928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  672960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  672982 */     GIR_RootConstrainSelectedInstOperands,
     /*  672983 */     // GIR_Coverage, 14273,
     /*  672983 */     GIR_EraseRootFromParent_Done,
     /*  672984 */   // Label 10772: @672984
     /*  672984 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(673062), // Rule ID 14276 //
     /*  672989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  672997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  673000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  673003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  673006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673035 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  673038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673060 */     GIR_RootConstrainSelectedInstOperands,
     /*  673061 */     // GIR_Coverage, 14276,
     /*  673061 */     GIR_EraseRootFromParent_Done,
     /*  673062 */   // Label 10773: @673062
     /*  673062 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(673140), // Rule ID 14277 //
     /*  673067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  673078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  673081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  673084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673113 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  673116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673138 */     GIR_RootConstrainSelectedInstOperands,
     /*  673139 */     // GIR_Coverage, 14277,
     /*  673139 */     GIR_EraseRootFromParent_Done,
     /*  673140 */   // Label 10774: @673140
     /*  673140 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(673218), // Rule ID 14280 //
     /*  673145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  673156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  673159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  673162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673191 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673216 */     GIR_RootConstrainSelectedInstOperands,
     /*  673217 */     // GIR_Coverage, 14280,
     /*  673217 */     GIR_EraseRootFromParent_Done,
     /*  673218 */   // Label 10775: @673218
     /*  673218 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(673296), // Rule ID 14281 //
     /*  673223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  673234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  673237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  673240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673269 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673294 */     GIR_RootConstrainSelectedInstOperands,
     /*  673295 */     // GIR_Coverage, 14281,
     /*  673295 */     GIR_EraseRootFromParent_Done,
     /*  673296 */   // Label 10776: @673296
     /*  673296 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(673374), // Rule ID 14284 //
     /*  673301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  673312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  673315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  673318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  673347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673372 */     GIR_RootConstrainSelectedInstOperands,
     /*  673373 */     // GIR_Coverage, 14284,
     /*  673373 */     GIR_EraseRootFromParent_Done,
     /*  673374 */   // Label 10777: @673374
     /*  673374 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(673452), // Rule ID 14285 //
     /*  673379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  673390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  673393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  673396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673450 */     GIR_RootConstrainSelectedInstOperands,
     /*  673451 */     // GIR_Coverage, 14285,
     /*  673451 */     GIR_EraseRootFromParent_Done,
     /*  673452 */   // Label 10778: @673452
     /*  673452 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(673530), // Rule ID 14288 //
     /*  673457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  673468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  673471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  673474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673503 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673528 */     GIR_RootConstrainSelectedInstOperands,
     /*  673529 */     // GIR_Coverage, 14288,
     /*  673529 */     GIR_EraseRootFromParent_Done,
     /*  673530 */   // Label 10779: @673530
     /*  673530 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(673608), // Rule ID 14289 //
     /*  673535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  673546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  673549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  673552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673606 */     GIR_RootConstrainSelectedInstOperands,
     /*  673607 */     // GIR_Coverage, 14289,
     /*  673607 */     GIR_EraseRootFromParent_Done,
     /*  673608 */   // Label 10780: @673608
     /*  673608 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(673686), // Rule ID 14292 //
     /*  673613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  673624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  673627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  673630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673659 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673684 */     GIR_RootConstrainSelectedInstOperands,
     /*  673685 */     // GIR_Coverage, 14292,
     /*  673685 */     GIR_EraseRootFromParent_Done,
     /*  673686 */   // Label 10781: @673686
     /*  673686 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(673764), // Rule ID 14293 //
     /*  673691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  673702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  673705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  673708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673737 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  673740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673762 */     GIR_RootConstrainSelectedInstOperands,
     /*  673763 */     // GIR_Coverage, 14293,
     /*  673763 */     GIR_EraseRootFromParent_Done,
     /*  673764 */   // Label 10782: @673764
     /*  673764 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(673842), // Rule ID 14296 //
     /*  673769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  673780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  673783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  673786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  673818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673840 */     GIR_RootConstrainSelectedInstOperands,
     /*  673841 */     // GIR_Coverage, 14296,
     /*  673841 */     GIR_EraseRootFromParent_Done,
     /*  673842 */   // Label 10783: @673842
     /*  673842 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(673920), // Rule ID 14297 //
     /*  673847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  673858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  673861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  673864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  673896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673918 */     GIR_RootConstrainSelectedInstOperands,
     /*  673919 */     // GIR_Coverage, 14297,
     /*  673919 */     GIR_EraseRootFromParent_Done,
     /*  673920 */   // Label 10784: @673920
     /*  673920 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(673998), // Rule ID 14300 //
     /*  673925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  673933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  673936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  673939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  673942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673971 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  673974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  673996 */     GIR_RootConstrainSelectedInstOperands,
     /*  673997 */     // GIR_Coverage, 14300,
     /*  673997 */     GIR_EraseRootFromParent_Done,
     /*  673998 */   // Label 10785: @673998
     /*  673998 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(674076), // Rule ID 14301 //
     /*  674003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  674014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  674017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  674020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674049 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  674052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674074 */     GIR_RootConstrainSelectedInstOperands,
     /*  674075 */     // GIR_Coverage, 14301,
     /*  674075 */     GIR_EraseRootFromParent_Done,
     /*  674076 */   // Label 10786: @674076
     /*  674076 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(674154), // Rule ID 14304 //
     /*  674081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  674092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  674095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  674098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  674130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674152 */     GIR_RootConstrainSelectedInstOperands,
     /*  674153 */     // GIR_Coverage, 14304,
     /*  674153 */     GIR_EraseRootFromParent_Done,
     /*  674154 */   // Label 10787: @674154
     /*  674154 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(674232), // Rule ID 14305 //
     /*  674159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  674170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  674173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  674176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674205 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  674208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674230 */     GIR_RootConstrainSelectedInstOperands,
     /*  674231 */     // GIR_Coverage, 14305,
     /*  674231 */     GIR_EraseRootFromParent_Done,
     /*  674232 */   // Label 10788: @674232
     /*  674232 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(674310), // Rule ID 14308 //
     /*  674237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  674248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  674251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  674254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  674286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674308 */     GIR_RootConstrainSelectedInstOperands,
     /*  674309 */     // GIR_Coverage, 14308,
     /*  674309 */     GIR_EraseRootFromParent_Done,
     /*  674310 */   // Label 10789: @674310
     /*  674310 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(674388), // Rule ID 14309 //
     /*  674315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  674326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  674329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  674332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  674364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674386 */     GIR_RootConstrainSelectedInstOperands,
     /*  674387 */     // GIR_Coverage, 14309,
     /*  674387 */     GIR_EraseRootFromParent_Done,
     /*  674388 */   // Label 10790: @674388
     /*  674388 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(674466), // Rule ID 14312 //
     /*  674393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  674404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  674407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  674410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  674442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674464 */     GIR_RootConstrainSelectedInstOperands,
     /*  674465 */     // GIR_Coverage, 14312,
     /*  674465 */     GIR_EraseRootFromParent_Done,
     /*  674466 */   // Label 10791: @674466
     /*  674466 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(674544), // Rule ID 14313 //
     /*  674471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  674482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  674485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  674488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674517 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  674520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674542 */     GIR_RootConstrainSelectedInstOperands,
     /*  674543 */     // GIR_Coverage, 14313,
     /*  674543 */     GIR_EraseRootFromParent_Done,
     /*  674544 */   // Label 10792: @674544
     /*  674544 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(674622), // Rule ID 14316 //
     /*  674549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  674560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  674563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  674566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  674598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674620 */     GIR_RootConstrainSelectedInstOperands,
     /*  674621 */     // GIR_Coverage, 14316,
     /*  674621 */     GIR_EraseRootFromParent_Done,
     /*  674622 */   // Label 10793: @674622
     /*  674622 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(674700), // Rule ID 14317 //
     /*  674627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  674638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  674641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  674644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674673 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  674676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674698 */     GIR_RootConstrainSelectedInstOperands,
     /*  674699 */     // GIR_Coverage, 14317,
     /*  674699 */     GIR_EraseRootFromParent_Done,
     /*  674700 */   // Label 10794: @674700
     /*  674700 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(674778), // Rule ID 14320 //
     /*  674705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  674716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  674719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  674722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  674754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674776 */     GIR_RootConstrainSelectedInstOperands,
     /*  674777 */     // GIR_Coverage, 14320,
     /*  674777 */     GIR_EraseRootFromParent_Done,
     /*  674778 */   // Label 10795: @674778
     /*  674778 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(674856), // Rule ID 14321 //
     /*  674783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  674794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  674797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  674800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  674832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674854 */     GIR_RootConstrainSelectedInstOperands,
     /*  674855 */     // GIR_Coverage, 14321,
     /*  674855 */     GIR_EraseRootFromParent_Done,
     /*  674856 */   // Label 10796: @674856
     /*  674856 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(674934), // Rule ID 14324 //
     /*  674861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  674872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  674875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  674878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  674910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  674932 */     GIR_RootConstrainSelectedInstOperands,
     /*  674933 */     // GIR_Coverage, 14324,
     /*  674933 */     GIR_EraseRootFromParent_Done,
     /*  674934 */   // Label 10797: @674934
     /*  674934 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(675012), // Rule ID 14325 //
     /*  674939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  674947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  674950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  674953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  674956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  674988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675010 */     GIR_RootConstrainSelectedInstOperands,
     /*  675011 */     // GIR_Coverage, 14325,
     /*  675011 */     GIR_EraseRootFromParent_Done,
     /*  675012 */   // Label 10798: @675012
     /*  675012 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(675090), // Rule ID 14328 //
     /*  675017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  675028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  675031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  675034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675063 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  675066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675088 */     GIR_RootConstrainSelectedInstOperands,
     /*  675089 */     // GIR_Coverage, 14328,
     /*  675089 */     GIR_EraseRootFromParent_Done,
     /*  675090 */   // Label 10799: @675090
     /*  675090 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(675168), // Rule ID 14329 //
     /*  675095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  675106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  675109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  675112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675141 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  675144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675166 */     GIR_RootConstrainSelectedInstOperands,
     /*  675167 */     // GIR_Coverage, 14329,
     /*  675167 */     GIR_EraseRootFromParent_Done,
     /*  675168 */   // Label 10800: @675168
     /*  675168 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(675246), // Rule ID 14332 //
     /*  675173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  675184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  675187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  675190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  675222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675244 */     GIR_RootConstrainSelectedInstOperands,
     /*  675245 */     // GIR_Coverage, 14332,
     /*  675245 */     GIR_EraseRootFromParent_Done,
     /*  675246 */   // Label 10801: @675246
     /*  675246 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(675324), // Rule ID 14333 //
     /*  675251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  675262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  675265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  675268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  675300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675322 */     GIR_RootConstrainSelectedInstOperands,
     /*  675323 */     // GIR_Coverage, 14333,
     /*  675323 */     GIR_EraseRootFromParent_Done,
     /*  675324 */   // Label 10802: @675324
     /*  675324 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(675402), // Rule ID 14336 //
     /*  675329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  675340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  675343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  675346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675375 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  675378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675400 */     GIR_RootConstrainSelectedInstOperands,
     /*  675401 */     // GIR_Coverage, 14336,
     /*  675401 */     GIR_EraseRootFromParent_Done,
     /*  675402 */   // Label 10803: @675402
     /*  675402 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(675480), // Rule ID 14337 //
     /*  675407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  675418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  675421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  675424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675453 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  675456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675478 */     GIR_RootConstrainSelectedInstOperands,
     /*  675479 */     // GIR_Coverage, 14337,
     /*  675479 */     GIR_EraseRootFromParent_Done,
     /*  675480 */   // Label 10804: @675480
     /*  675480 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(675558), // Rule ID 14340 //
     /*  675485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  675496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  675499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  675502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675531 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  675534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675556 */     GIR_RootConstrainSelectedInstOperands,
     /*  675557 */     // GIR_Coverage, 14340,
     /*  675557 */     GIR_EraseRootFromParent_Done,
     /*  675558 */   // Label 10805: @675558
     /*  675558 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(675636), // Rule ID 14341 //
     /*  675563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  675571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  675574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  675577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  675580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  675612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675634 */     GIR_RootConstrainSelectedInstOperands,
     /*  675635 */     // GIR_Coverage, 14341,
     /*  675635 */     GIR_EraseRootFromParent_Done,
     /*  675636 */   // Label 10806: @675636
     /*  675636 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(675714), // Rule ID 14432 //
     /*  675641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  675649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  675652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  675655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  675658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  675661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675687 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  675690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675712 */     GIR_RootConstrainSelectedInstOperands,
     /*  675713 */     // GIR_Coverage, 14432,
     /*  675713 */     GIR_EraseRootFromParent_Done,
     /*  675714 */   // Label 10807: @675714
     /*  675714 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(675792), // Rule ID 14433 //
     /*  675719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  675727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  675730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  675733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  675736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  675739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675765 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  675768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675790 */     GIR_RootConstrainSelectedInstOperands,
     /*  675791 */     // GIR_Coverage, 14433,
     /*  675791 */     GIR_EraseRootFromParent_Done,
     /*  675792 */   // Label 10808: @675792
     /*  675792 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(675870), // Rule ID 14436 //
     /*  675797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  675805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  675808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  675811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  675814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  675817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  675846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675868 */     GIR_RootConstrainSelectedInstOperands,
     /*  675869 */     // GIR_Coverage, 14436,
     /*  675869 */     GIR_EraseRootFromParent_Done,
     /*  675870 */   // Label 10809: @675870
     /*  675870 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(675948), // Rule ID 14437 //
     /*  675875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  675883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  675886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  675889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  675892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  675895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  675924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  675946 */     GIR_RootConstrainSelectedInstOperands,
     /*  675947 */     // GIR_Coverage, 14437,
     /*  675947 */     GIR_EraseRootFromParent_Done,
     /*  675948 */   // Label 10810: @675948
     /*  675948 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(676026), // Rule ID 14440 //
     /*  675953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  675961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  675964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  675967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  675970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  675973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675999 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676024 */     GIR_RootConstrainSelectedInstOperands,
     /*  676025 */     // GIR_Coverage, 14440,
     /*  676025 */     GIR_EraseRootFromParent_Done,
     /*  676026 */   // Label 10811: @676026
     /*  676026 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(676104), // Rule ID 14441 //
     /*  676031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  676042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  676045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  676048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  676051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676102 */     GIR_RootConstrainSelectedInstOperands,
     /*  676103 */     // GIR_Coverage, 14441,
     /*  676103 */     GIR_EraseRootFromParent_Done,
     /*  676104 */   // Label 10812: @676104
     /*  676104 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(676182), // Rule ID 14444 //
     /*  676109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  676120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  676123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  676126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  676129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676155 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  676158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676180 */     GIR_RootConstrainSelectedInstOperands,
     /*  676181 */     // GIR_Coverage, 14444,
     /*  676181 */     GIR_EraseRootFromParent_Done,
     /*  676182 */   // Label 10813: @676182
     /*  676182 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(676260), // Rule ID 14445 //
     /*  676187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  676198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  676201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  676204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  676207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676233 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  676236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676258 */     GIR_RootConstrainSelectedInstOperands,
     /*  676259 */     // GIR_Coverage, 14445,
     /*  676259 */     GIR_EraseRootFromParent_Done,
     /*  676260 */   // Label 10814: @676260
     /*  676260 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(676338), // Rule ID 14448 //
     /*  676265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  676276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  676279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  676282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  676285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676336 */     GIR_RootConstrainSelectedInstOperands,
     /*  676337 */     // GIR_Coverage, 14448,
     /*  676337 */     GIR_EraseRootFromParent_Done,
     /*  676338 */   // Label 10815: @676338
     /*  676338 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(676416), // Rule ID 14449 //
     /*  676343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  676354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  676357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  676360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  676363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676389 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676414 */     GIR_RootConstrainSelectedInstOperands,
     /*  676415 */     // GIR_Coverage, 14449,
     /*  676415 */     GIR_EraseRootFromParent_Done,
     /*  676416 */   // Label 10816: @676416
     /*  676416 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(676494), // Rule ID 14452 //
     /*  676421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  676432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  676435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  676438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  676441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676467 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676492 */     GIR_RootConstrainSelectedInstOperands,
     /*  676493 */     // GIR_Coverage, 14452,
     /*  676493 */     GIR_EraseRootFromParent_Done,
     /*  676494 */   // Label 10817: @676494
     /*  676494 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(676572), // Rule ID 14453 //
     /*  676499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  676510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  676513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  676516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  676519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676545 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  676548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676570 */     GIR_RootConstrainSelectedInstOperands,
     /*  676571 */     // GIR_Coverage, 14453,
     /*  676571 */     GIR_EraseRootFromParent_Done,
     /*  676572 */   // Label 10818: @676572
     /*  676572 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(676650), // Rule ID 14456 //
     /*  676577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  676588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  676591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  676594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  676597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676623 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  676626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676648 */     GIR_RootConstrainSelectedInstOperands,
     /*  676649 */     // GIR_Coverage, 14456,
     /*  676649 */     GIR_EraseRootFromParent_Done,
     /*  676650 */   // Label 10819: @676650
     /*  676650 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(676728), // Rule ID 14457 //
     /*  676655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  676666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  676669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  676672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  676675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676701 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  676704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676726 */     GIR_RootConstrainSelectedInstOperands,
     /*  676727 */     // GIR_Coverage, 14457,
     /*  676727 */     GIR_EraseRootFromParent_Done,
     /*  676728 */   // Label 10820: @676728
     /*  676728 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(676806), // Rule ID 14460 //
     /*  676733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  676744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  676747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  676750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  676753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  676782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676804 */     GIR_RootConstrainSelectedInstOperands,
     /*  676805 */     // GIR_Coverage, 14460,
     /*  676805 */     GIR_EraseRootFromParent_Done,
     /*  676806 */   // Label 10821: @676806
     /*  676806 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(676884), // Rule ID 14461 //
     /*  676811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  676822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  676825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  676828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  676831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  676860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676882 */     GIR_RootConstrainSelectedInstOperands,
     /*  676883 */     // GIR_Coverage, 14461,
     /*  676883 */     GIR_EraseRootFromParent_Done,
     /*  676884 */   // Label 10822: @676884
     /*  676884 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(676962), // Rule ID 14464 //
     /*  676889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  676900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  676903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  676906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  676909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676935 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  676938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  676960 */     GIR_RootConstrainSelectedInstOperands,
     /*  676961 */     // GIR_Coverage, 14464,
     /*  676961 */     GIR_EraseRootFromParent_Done,
     /*  676962 */   // Label 10823: @676962
     /*  676962 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(677040), // Rule ID 14465 //
     /*  676967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  676975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  676978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  676981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  676984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  676987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677013 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  677013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  677016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677038 */     GIR_RootConstrainSelectedInstOperands,
     /*  677039 */     // GIR_Coverage, 14465,
     /*  677039 */     GIR_EraseRootFromParent_Done,
     /*  677040 */   // Label 10824: @677040
     /*  677040 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(677118), // Rule ID 14468 //
     /*  677045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  677056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  677059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  677062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  677065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  677094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677116 */     GIR_RootConstrainSelectedInstOperands,
     /*  677117 */     // GIR_Coverage, 14468,
     /*  677117 */     GIR_EraseRootFromParent_Done,
     /*  677118 */   // Label 10825: @677118
     /*  677118 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(677196), // Rule ID 14469 //
     /*  677123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  677134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  677137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  677140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  677143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  677172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677194 */     GIR_RootConstrainSelectedInstOperands,
     /*  677195 */     // GIR_Coverage, 14469,
     /*  677195 */     GIR_EraseRootFromParent_Done,
     /*  677196 */   // Label 10826: @677196
     /*  677196 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(677274), // Rule ID 14472 //
     /*  677201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  677212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  677215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  677218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  677221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  677250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677272 */     GIR_RootConstrainSelectedInstOperands,
     /*  677273 */     // GIR_Coverage, 14472,
     /*  677273 */     GIR_EraseRootFromParent_Done,
     /*  677274 */   // Label 10827: @677274
     /*  677274 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(677352), // Rule ID 14473 //
     /*  677279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  677290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  677293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  677296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  677299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677325 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  677328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677350 */     GIR_RootConstrainSelectedInstOperands,
     /*  677351 */     // GIR_Coverage, 14473,
     /*  677351 */     GIR_EraseRootFromParent_Done,
     /*  677352 */   // Label 10828: @677352
     /*  677352 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(677430), // Rule ID 14476 //
     /*  677357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  677368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  677371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  677374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  677377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677403 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  677406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677428 */     GIR_RootConstrainSelectedInstOperands,
     /*  677429 */     // GIR_Coverage, 14476,
     /*  677429 */     GIR_EraseRootFromParent_Done,
     /*  677430 */   // Label 10829: @677430
     /*  677430 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(677508), // Rule ID 14477 //
     /*  677435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  677446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  677449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  677452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  677455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677481 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  677484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677506 */     GIR_RootConstrainSelectedInstOperands,
     /*  677507 */     // GIR_Coverage, 14477,
     /*  677507 */     GIR_EraseRootFromParent_Done,
     /*  677508 */   // Label 10830: @677508
     /*  677508 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(677586), // Rule ID 14480 //
     /*  677513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  677524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  677527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  677530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  677533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  677562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677584 */     GIR_RootConstrainSelectedInstOperands,
     /*  677585 */     // GIR_Coverage, 14480,
     /*  677585 */     GIR_EraseRootFromParent_Done,
     /*  677586 */   // Label 10831: @677586
     /*  677586 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(677664), // Rule ID 14481 //
     /*  677591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  677602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  677605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  677608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  677611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677637 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  677640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677662 */     GIR_RootConstrainSelectedInstOperands,
     /*  677663 */     // GIR_Coverage, 14481,
     /*  677663 */     GIR_EraseRootFromParent_Done,
     /*  677664 */   // Label 10832: @677664
     /*  677664 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(677742), // Rule ID 14484 //
     /*  677669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  677680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  677683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  677686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  677689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  677718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677740 */     GIR_RootConstrainSelectedInstOperands,
     /*  677741 */     // GIR_Coverage, 14484,
     /*  677741 */     GIR_EraseRootFromParent_Done,
     /*  677742 */   // Label 10833: @677742
     /*  677742 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(677820), // Rule ID 14485 //
     /*  677747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  677758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  677761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  677764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  677767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  677796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677818 */     GIR_RootConstrainSelectedInstOperands,
     /*  677819 */     // GIR_Coverage, 14485,
     /*  677819 */     GIR_EraseRootFromParent_Done,
     /*  677820 */   // Label 10834: @677820
     /*  677820 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(677898), // Rule ID 14488 //
     /*  677825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  677836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  677839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  677842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  677845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  677874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677896 */     GIR_RootConstrainSelectedInstOperands,
     /*  677897 */     // GIR_Coverage, 14488,
     /*  677897 */     GIR_EraseRootFromParent_Done,
     /*  677898 */   // Label 10835: @677898
     /*  677898 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(677976), // Rule ID 14489 //
     /*  677903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  677914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  677917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  677920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  677923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677949 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  677952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  677974 */     GIR_RootConstrainSelectedInstOperands,
     /*  677975 */     // GIR_Coverage, 14489,
     /*  677975 */     GIR_EraseRootFromParent_Done,
     /*  677976 */   // Label 10836: @677976
     /*  677976 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(678054), // Rule ID 14492 //
     /*  677981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  677989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  677992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  677995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  677998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  678001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678027 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  678030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678052 */     GIR_RootConstrainSelectedInstOperands,
     /*  678053 */     // GIR_Coverage, 14492,
     /*  678053 */     GIR_EraseRootFromParent_Done,
     /*  678054 */   // Label 10837: @678054
     /*  678054 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(678132), // Rule ID 14493 //
     /*  678059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  678070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  678073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  678076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  678079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  678108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678130 */     GIR_RootConstrainSelectedInstOperands,
     /*  678131 */     // GIR_Coverage, 14493,
     /*  678131 */     GIR_EraseRootFromParent_Done,
     /*  678132 */   // Label 10838: @678132
     /*  678132 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(678210), // Rule ID 14496 //
     /*  678137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  678148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  678151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  678154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  678157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  678186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678208 */     GIR_RootConstrainSelectedInstOperands,
     /*  678209 */     // GIR_Coverage, 14496,
     /*  678209 */     GIR_EraseRootFromParent_Done,
     /*  678210 */   // Label 10839: @678210
     /*  678210 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(678288), // Rule ID 14497 //
     /*  678215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  678226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  678229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  678232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  678235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  678264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678286 */     GIR_RootConstrainSelectedInstOperands,
     /*  678287 */     // GIR_Coverage, 14497,
     /*  678287 */     GIR_EraseRootFromParent_Done,
     /*  678288 */   // Label 10840: @678288
     /*  678288 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(678366), // Rule ID 14500 //
     /*  678293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  678304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  678307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  678310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  678313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678339 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  678342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678364 */     GIR_RootConstrainSelectedInstOperands,
     /*  678365 */     // GIR_Coverage, 14500,
     /*  678365 */     GIR_EraseRootFromParent_Done,
     /*  678366 */   // Label 10841: @678366
     /*  678366 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(678444), // Rule ID 14501 //
     /*  678371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  678382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  678385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  678388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  678391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678417 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  678420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678442 */     GIR_RootConstrainSelectedInstOperands,
     /*  678443 */     // GIR_Coverage, 14501,
     /*  678443 */     GIR_EraseRootFromParent_Done,
     /*  678444 */   // Label 10842: @678444
     /*  678444 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(678522), // Rule ID 14504 //
     /*  678449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  678460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  678463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  678466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  678469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  678498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678520 */     GIR_RootConstrainSelectedInstOperands,
     /*  678521 */     // GIR_Coverage, 14504,
     /*  678521 */     GIR_EraseRootFromParent_Done,
     /*  678522 */   // Label 10843: @678522
     /*  678522 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(678600), // Rule ID 14505 //
     /*  678527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  678538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  678541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  678544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  678547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  678576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678598 */     GIR_RootConstrainSelectedInstOperands,
     /*  678599 */     // GIR_Coverage, 14505,
     /*  678599 */     GIR_EraseRootFromParent_Done,
     /*  678600 */   // Label 10844: @678600
     /*  678600 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(678678), // Rule ID 14508 //
     /*  678605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  678616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  678619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  678622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  678625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  678654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678676 */     GIR_RootConstrainSelectedInstOperands,
     /*  678677 */     // GIR_Coverage, 14508,
     /*  678677 */     GIR_EraseRootFromParent_Done,
     /*  678678 */   // Label 10845: @678678
     /*  678678 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(678756), // Rule ID 14509 //
     /*  678683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  678694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  678697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  678700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  678703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  678732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678754 */     GIR_RootConstrainSelectedInstOperands,
     /*  678755 */     // GIR_Coverage, 14509,
     /*  678755 */     GIR_EraseRootFromParent_Done,
     /*  678756 */   // Label 10846: @678756
     /*  678756 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(678834), // Rule ID 14512 //
     /*  678761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  678772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  678775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  678778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  678781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678807 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  678810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678832 */     GIR_RootConstrainSelectedInstOperands,
     /*  678833 */     // GIR_Coverage, 14512,
     /*  678833 */     GIR_EraseRootFromParent_Done,
     /*  678834 */   // Label 10847: @678834
     /*  678834 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(678912), // Rule ID 14513 //
     /*  678839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  678850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  678853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  678856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  678859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678885 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  678888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678910 */     GIR_RootConstrainSelectedInstOperands,
     /*  678911 */     // GIR_Coverage, 14513,
     /*  678911 */     GIR_EraseRootFromParent_Done,
     /*  678912 */   // Label 10848: @678912
     /*  678912 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(678990), // Rule ID 14516 //
     /*  678917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  678925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  678928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  678931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  678934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  678937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678963 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  678966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  678988 */     GIR_RootConstrainSelectedInstOperands,
     /*  678989 */     // GIR_Coverage, 14516,
     /*  678989 */     GIR_EraseRootFromParent_Done,
     /*  678990 */   // Label 10849: @678990
     /*  678990 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(679068), // Rule ID 14517 //
     /*  678995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  679006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  679009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  679012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  679015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  679044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679066 */     GIR_RootConstrainSelectedInstOperands,
     /*  679067 */     // GIR_Coverage, 14517,
     /*  679067 */     GIR_EraseRootFromParent_Done,
     /*  679068 */   // Label 10850: @679068
     /*  679068 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(679146), // Rule ID 14520 //
     /*  679073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  679084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  679087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  679090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679119 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  679122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679144 */     GIR_RootConstrainSelectedInstOperands,
     /*  679145 */     // GIR_Coverage, 14520,
     /*  679145 */     GIR_EraseRootFromParent_Done,
     /*  679146 */   // Label 10851: @679146
     /*  679146 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(679224), // Rule ID 14521 //
     /*  679151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  679162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  679165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  679168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679197 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  679200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679222 */     GIR_RootConstrainSelectedInstOperands,
     /*  679223 */     // GIR_Coverage, 14521,
     /*  679223 */     GIR_EraseRootFromParent_Done,
     /*  679224 */   // Label 10852: @679224
     /*  679224 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(679302), // Rule ID 14524 //
     /*  679229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  679240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  679243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  679246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679275 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  679278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679300 */     GIR_RootConstrainSelectedInstOperands,
     /*  679301 */     // GIR_Coverage, 14524,
     /*  679301 */     GIR_EraseRootFromParent_Done,
     /*  679302 */   // Label 10853: @679302
     /*  679302 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(679380), // Rule ID 14525 //
     /*  679307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  679318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  679321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  679324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679353 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  679356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679378 */     GIR_RootConstrainSelectedInstOperands,
     /*  679379 */     // GIR_Coverage, 14525,
     /*  679379 */     GIR_EraseRootFromParent_Done,
     /*  679380 */   // Label 10854: @679380
     /*  679380 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(679458), // Rule ID 14528 //
     /*  679385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  679396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  679399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  679402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679431 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679456 */     GIR_RootConstrainSelectedInstOperands,
     /*  679457 */     // GIR_Coverage, 14528,
     /*  679457 */     GIR_EraseRootFromParent_Done,
     /*  679458 */   // Label 10855: @679458
     /*  679458 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(679536), // Rule ID 14529 //
     /*  679463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  679474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  679477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  679480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679509 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679534 */     GIR_RootConstrainSelectedInstOperands,
     /*  679535 */     // GIR_Coverage, 14529,
     /*  679535 */     GIR_EraseRootFromParent_Done,
     /*  679536 */   // Label 10856: @679536
     /*  679536 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(679614), // Rule ID 14532 //
     /*  679541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  679552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  679555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  679558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679587 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  679590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679612 */     GIR_RootConstrainSelectedInstOperands,
     /*  679613 */     // GIR_Coverage, 14532,
     /*  679613 */     GIR_EraseRootFromParent_Done,
     /*  679614 */   // Label 10857: @679614
     /*  679614 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(679692), // Rule ID 14533 //
     /*  679619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  679630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  679633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  679636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679665 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  679668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679690 */     GIR_RootConstrainSelectedInstOperands,
     /*  679691 */     // GIR_Coverage, 14533,
     /*  679691 */     GIR_EraseRootFromParent_Done,
     /*  679692 */   // Label 10858: @679692
     /*  679692 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(679770), // Rule ID 14536 //
     /*  679697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  679708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  679711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  679714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679768 */     GIR_RootConstrainSelectedInstOperands,
     /*  679769 */     // GIR_Coverage, 14536,
     /*  679769 */     GIR_EraseRootFromParent_Done,
     /*  679770 */   // Label 10859: @679770
     /*  679770 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(679848), // Rule ID 14537 //
     /*  679775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  679786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  679789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  679792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679821 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679846 */     GIR_RootConstrainSelectedInstOperands,
     /*  679847 */     // GIR_Coverage, 14537,
     /*  679847 */     GIR_EraseRootFromParent_Done,
     /*  679848 */   // Label 10860: @679848
     /*  679848 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(679926), // Rule ID 14540 //
     /*  679853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  679864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  679867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  679870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  679924 */     GIR_RootConstrainSelectedInstOperands,
     /*  679925 */     // GIR_Coverage, 14540,
     /*  679925 */     GIR_EraseRootFromParent_Done,
     /*  679926 */   // Label 10861: @679926
     /*  679926 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(680004), // Rule ID 14541 //
     /*  679931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  679939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  679942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  679945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  679948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  679980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680002 */     GIR_RootConstrainSelectedInstOperands,
     /*  680003 */     // GIR_Coverage, 14541,
     /*  680003 */     GIR_EraseRootFromParent_Done,
     /*  680004 */   // Label 10862: @680004
     /*  680004 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(680082), // Rule ID 14544 //
     /*  680009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  680020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  680023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  680026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680055 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680080 */     GIR_RootConstrainSelectedInstOperands,
     /*  680081 */     // GIR_Coverage, 14544,
     /*  680081 */     GIR_EraseRootFromParent_Done,
     /*  680082 */   // Label 10863: @680082
     /*  680082 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(680160), // Rule ID 14545 //
     /*  680087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  680098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  680101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  680104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11310:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680158 */     GIR_RootConstrainSelectedInstOperands,
     /*  680159 */     // GIR_Coverage, 14545,
     /*  680159 */     GIR_EraseRootFromParent_Done,
     /*  680160 */   // Label 10864: @680160
     /*  680160 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(680238), // Rule ID 14548 //
     /*  680165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  680176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  680179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  680182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680236 */     GIR_RootConstrainSelectedInstOperands,
     /*  680237 */     // GIR_Coverage, 14548,
     /*  680237 */     GIR_EraseRootFromParent_Done,
     /*  680238 */   // Label 10865: @680238
     /*  680238 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(680316), // Rule ID 14549 //
     /*  680243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  680254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  680257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  680260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680314 */     GIR_RootConstrainSelectedInstOperands,
     /*  680315 */     // GIR_Coverage, 14549,
     /*  680315 */     GIR_EraseRootFromParent_Done,
     /*  680316 */   // Label 10866: @680316
     /*  680316 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(680394), // Rule ID 14552 //
     /*  680321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  680332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  680335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  680338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680367 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680392 */     GIR_RootConstrainSelectedInstOperands,
     /*  680393 */     // GIR_Coverage, 14552,
     /*  680393 */     GIR_EraseRootFromParent_Done,
     /*  680394 */   // Label 10867: @680394
     /*  680394 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(680472), // Rule ID 14553 //
     /*  680399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  680410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  680413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  680416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680470 */     GIR_RootConstrainSelectedInstOperands,
     /*  680471 */     // GIR_Coverage, 14553,
     /*  680471 */     GIR_EraseRootFromParent_Done,
     /*  680472 */   // Label 10868: @680472
     /*  680472 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(680550), // Rule ID 14556 //
     /*  680477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  680488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  680491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  680494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680523 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680548 */     GIR_RootConstrainSelectedInstOperands,
     /*  680549 */     // GIR_Coverage, 14556,
     /*  680549 */     GIR_EraseRootFromParent_Done,
     /*  680550 */   // Label 10869: @680550
     /*  680550 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(680628), // Rule ID 14557 //
     /*  680555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  680566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  680569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  680572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680601 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  680604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680626 */     GIR_RootConstrainSelectedInstOperands,
     /*  680627 */     // GIR_Coverage, 14557,
     /*  680627 */     GIR_EraseRootFromParent_Done,
     /*  680628 */   // Label 10870: @680628
     /*  680628 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(680706), // Rule ID 14560 //
     /*  680633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  680644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  680647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  680650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680679 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  680682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680704 */     GIR_RootConstrainSelectedInstOperands,
     /*  680705 */     // GIR_Coverage, 14560,
     /*  680705 */     GIR_EraseRootFromParent_Done,
     /*  680706 */   // Label 10871: @680706
     /*  680706 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(680784), // Rule ID 14561 //
     /*  680711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  680722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  680725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  680728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  680760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680782 */     GIR_RootConstrainSelectedInstOperands,
     /*  680783 */     // GIR_Coverage, 14561,
     /*  680783 */     GIR_EraseRootFromParent_Done,
     /*  680784 */   // Label 10872: @680784
     /*  680784 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(680862), // Rule ID 14564 //
     /*  680789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  680800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  680803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  680806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680835 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  680838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680860 */     GIR_RootConstrainSelectedInstOperands,
     /*  680861 */     // GIR_Coverage, 14564,
     /*  680861 */     GIR_EraseRootFromParent_Done,
     /*  680862 */   // Label 10873: @680862
     /*  680862 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(680940), // Rule ID 14565 //
     /*  680867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  680878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  680881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  680884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680913 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  680916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  680938 */     GIR_RootConstrainSelectedInstOperands,
     /*  680939 */     // GIR_Coverage, 14565,
     /*  680939 */     GIR_EraseRootFromParent_Done,
     /*  680940 */   // Label 10874: @680940
     /*  680940 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(681018), // Rule ID 14568 //
     /*  680945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  680953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  680956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  680959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  680962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680991 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  680994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681016 */     GIR_RootConstrainSelectedInstOperands,
     /*  681017 */     // GIR_Coverage, 14568,
     /*  681017 */     GIR_EraseRootFromParent_Done,
     /*  681018 */   // Label 10875: @681018
     /*  681018 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(681096), // Rule ID 14569 //
     /*  681023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681069 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  681072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681094 */     GIR_RootConstrainSelectedInstOperands,
     /*  681095 */     // GIR_Coverage, 14569,
     /*  681095 */     GIR_EraseRootFromParent_Done,
     /*  681096 */   // Label 10876: @681096
     /*  681096 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(681174), // Rule ID 14572 //
     /*  681101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  681112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  681115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  681118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  681150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681172 */     GIR_RootConstrainSelectedInstOperands,
     /*  681173 */     // GIR_Coverage, 14572,
     /*  681173 */     GIR_EraseRootFromParent_Done,
     /*  681174 */   // Label 10877: @681174
     /*  681174 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(681252), // Rule ID 14573 //
     /*  681179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  681190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  681193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  681196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681225 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  681228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681250 */     GIR_RootConstrainSelectedInstOperands,
     /*  681251 */     // GIR_Coverage, 14573,
     /*  681251 */     GIR_EraseRootFromParent_Done,
     /*  681252 */   // Label 10878: @681252
     /*  681252 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(681330), // Rule ID 14576 //
     /*  681257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  681268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  681271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  681274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681303 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  681306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681328 */     GIR_RootConstrainSelectedInstOperands,
     /*  681329 */     // GIR_Coverage, 14576,
     /*  681329 */     GIR_EraseRootFromParent_Done,
     /*  681330 */   // Label 10879: @681330
     /*  681330 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(681408), // Rule ID 14577 //
     /*  681335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  681346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  681349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  681352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681381 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  681384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681406 */     GIR_RootConstrainSelectedInstOperands,
     /*  681407 */     // GIR_Coverage, 14577,
     /*  681407 */     GIR_EraseRootFromParent_Done,
     /*  681408 */   // Label 10880: @681408
     /*  681408 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(681486), // Rule ID 14580 //
     /*  681413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  681424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  681427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  681430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681459 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  681462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681484 */     GIR_RootConstrainSelectedInstOperands,
     /*  681485 */     // GIR_Coverage, 14580,
     /*  681485 */     GIR_EraseRootFromParent_Done,
     /*  681486 */   // Label 10881: @681486
     /*  681486 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(681564), // Rule ID 14581 //
     /*  681491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  681502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  681505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  681508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681537 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  681540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681562 */     GIR_RootConstrainSelectedInstOperands,
     /*  681563 */     // GIR_Coverage, 14581,
     /*  681563 */     GIR_EraseRootFromParent_Done,
     /*  681564 */   // Label 10882: @681564
     /*  681564 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(681642), // Rule ID 14584 //
     /*  681569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  681580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  681583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  681586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  681618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681640 */     GIR_RootConstrainSelectedInstOperands,
     /*  681641 */     // GIR_Coverage, 14584,
     /*  681641 */     GIR_EraseRootFromParent_Done,
     /*  681642 */   // Label 10883: @681642
     /*  681642 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(681720), // Rule ID 14585 //
     /*  681647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  681658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  681661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  681664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  681696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681718 */     GIR_RootConstrainSelectedInstOperands,
     /*  681719 */     // GIR_Coverage, 14585,
     /*  681719 */     GIR_EraseRootFromParent_Done,
     /*  681720 */   // Label 10884: @681720
     /*  681720 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(681798), // Rule ID 14588 //
     /*  681725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  681736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  681739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  681742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  681774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681796 */     GIR_RootConstrainSelectedInstOperands,
     /*  681797 */     // GIR_Coverage, 14588,
     /*  681797 */     GIR_EraseRootFromParent_Done,
     /*  681798 */   // Label 10885: @681798
     /*  681798 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(681876), // Rule ID 14589 //
     /*  681803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  681814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  681817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  681820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  681852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681874 */     GIR_RootConstrainSelectedInstOperands,
     /*  681875 */     // GIR_Coverage, 14589,
     /*  681875 */     GIR_EraseRootFromParent_Done,
     /*  681876 */   // Label 10886: @681876
     /*  681876 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(681954), // Rule ID 14592 //
     /*  681881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  681892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  681895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  681898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  681930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  681952 */     GIR_RootConstrainSelectedInstOperands,
     /*  681953 */     // GIR_Coverage, 14592,
     /*  681953 */     GIR_EraseRootFromParent_Done,
     /*  681954 */   // Label 10887: @681954
     /*  681954 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(682032), // Rule ID 14593 //
     /*  681959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  681967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  681970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  681973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  681976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682005 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  682008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682030 */     GIR_RootConstrainSelectedInstOperands,
     /*  682031 */     // GIR_Coverage, 14593,
     /*  682031 */     GIR_EraseRootFromParent_Done,
     /*  682032 */   // Label 10888: @682032
     /*  682032 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(682110), // Rule ID 14596 //
     /*  682037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682083 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  682086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682108 */     GIR_RootConstrainSelectedInstOperands,
     /*  682109 */     // GIR_Coverage, 14596,
     /*  682109 */     GIR_EraseRootFromParent_Done,
     /*  682110 */   // Label 10889: @682110
     /*  682110 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(682188), // Rule ID 14597 //
     /*  682115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  682164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682186 */     GIR_RootConstrainSelectedInstOperands,
     /*  682187 */     // GIR_Coverage, 14597,
     /*  682187 */     GIR_EraseRootFromParent_Done,
     /*  682188 */   // Label 10890: @682188
     /*  682188 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(682266), // Rule ID 14600 //
     /*  682193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  682204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  682207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  682210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682239 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  682242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682264 */     GIR_RootConstrainSelectedInstOperands,
     /*  682265 */     // GIR_Coverage, 14600,
     /*  682265 */     GIR_EraseRootFromParent_Done,
     /*  682266 */   // Label 10891: @682266
     /*  682266 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(682344), // Rule ID 14601 //
     /*  682271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  682282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  682285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  682288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682317 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  682320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682342 */     GIR_RootConstrainSelectedInstOperands,
     /*  682343 */     // GIR_Coverage, 14601,
     /*  682343 */     GIR_EraseRootFromParent_Done,
     /*  682344 */   // Label 10892: @682344
     /*  682344 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(682422), // Rule ID 14604 //
     /*  682349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  682360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  682363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  682366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682395 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  682398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682420 */     GIR_RootConstrainSelectedInstOperands,
     /*  682421 */     // GIR_Coverage, 14604,
     /*  682421 */     GIR_EraseRootFromParent_Done,
     /*  682422 */   // Label 10893: @682422
     /*  682422 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(682500), // Rule ID 14605 //
     /*  682427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  682435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  682438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  682441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  682444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682473 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  682476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682498 */     GIR_RootConstrainSelectedInstOperands,
     /*  682499 */     // GIR_Coverage, 14605,
     /*  682499 */     GIR_EraseRootFromParent_Done,
     /*  682500 */   // Label 10894: @682500
     /*  682500 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(682578), // Rule ID 14608 //
     /*  682505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  682516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  682519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  682522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  682525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  682554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682576 */     GIR_RootConstrainSelectedInstOperands,
     /*  682577 */     // GIR_Coverage, 14608,
     /*  682577 */     GIR_EraseRootFromParent_Done,
     /*  682578 */   // Label 10895: @682578
     /*  682578 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(682656), // Rule ID 14609 //
     /*  682583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  682594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  682597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  682600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  682603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682629 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  682632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682654 */     GIR_RootConstrainSelectedInstOperands,
     /*  682655 */     // GIR_Coverage, 14609,
     /*  682655 */     GIR_EraseRootFromParent_Done,
     /*  682656 */   // Label 10896: @682656
     /*  682656 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(682734), // Rule ID 14612 //
     /*  682661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  682672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  682675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  682678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  682681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  682710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682732 */     GIR_RootConstrainSelectedInstOperands,
     /*  682733 */     // GIR_Coverage, 14612,
     /*  682733 */     GIR_EraseRootFromParent_Done,
     /*  682734 */   // Label 10897: @682734
     /*  682734 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(682812), // Rule ID 14613 //
     /*  682739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  682750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  682753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  682756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  682759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682785 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  682788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682810 */     GIR_RootConstrainSelectedInstOperands,
     /*  682811 */     // GIR_Coverage, 14613,
     /*  682811 */     GIR_EraseRootFromParent_Done,
     /*  682812 */   // Label 10898: @682812
     /*  682812 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(682890), // Rule ID 14616 //
     /*  682817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  682828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  682831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  682834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  682837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682863 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  682866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682888 */     GIR_RootConstrainSelectedInstOperands,
     /*  682889 */     // GIR_Coverage, 14616,
     /*  682889 */     GIR_EraseRootFromParent_Done,
     /*  682890 */   // Label 10899: @682890
     /*  682890 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(682968), // Rule ID 14617 //
     /*  682895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  682906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  682909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  682912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  682915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682941 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  682944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  682966 */     GIR_RootConstrainSelectedInstOperands,
     /*  682967 */     // GIR_Coverage, 14617,
     /*  682967 */     GIR_EraseRootFromParent_Done,
     /*  682968 */   // Label 10900: @682968
     /*  682968 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(683046), // Rule ID 14620 //
     /*  682973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  682981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  682984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  682987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  682990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  682993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683019 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  683022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683044 */     GIR_RootConstrainSelectedInstOperands,
     /*  683045 */     // GIR_Coverage, 14620,
     /*  683045 */     GIR_EraseRootFromParent_Done,
     /*  683046 */   // Label 10901: @683046
     /*  683046 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(683124), // Rule ID 14621 //
     /*  683051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683097 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  683100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683122 */     GIR_RootConstrainSelectedInstOperands,
     /*  683123 */     // GIR_Coverage, 14621,
     /*  683123 */     GIR_EraseRootFromParent_Done,
     /*  683124 */   // Label 10902: @683124
     /*  683124 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(683202), // Rule ID 14624 //
     /*  683129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  683140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  683143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  683146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  683149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683175 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  683178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683200 */     GIR_RootConstrainSelectedInstOperands,
     /*  683201 */     // GIR_Coverage, 14624,
     /*  683201 */     GIR_EraseRootFromParent_Done,
     /*  683202 */   // Label 10903: @683202
     /*  683202 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(683280), // Rule ID 14625 //
     /*  683207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  683218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  683221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  683224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  683227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  683256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683278 */     GIR_RootConstrainSelectedInstOperands,
     /*  683279 */     // GIR_Coverage, 14625,
     /*  683279 */     GIR_EraseRootFromParent_Done,
     /*  683280 */   // Label 10904: @683280
     /*  683280 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(683358), // Rule ID 14628 //
     /*  683285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  683296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  683299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  683302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  683305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  683334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683356 */     GIR_RootConstrainSelectedInstOperands,
     /*  683357 */     // GIR_Coverage, 14628,
     /*  683357 */     GIR_EraseRootFromParent_Done,
     /*  683358 */   // Label 10905: @683358
     /*  683358 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(683436), // Rule ID 14629 //
     /*  683363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  683374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  683377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  683380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  683383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  683412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683434 */     GIR_RootConstrainSelectedInstOperands,
     /*  683435 */     // GIR_Coverage, 14629,
     /*  683435 */     GIR_EraseRootFromParent_Done,
     /*  683436 */   // Label 10906: @683436
     /*  683436 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(683514), // Rule ID 14632 //
     /*  683441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  683452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  683455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  683458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  683461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683487 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683512 */     GIR_RootConstrainSelectedInstOperands,
     /*  683513 */     // GIR_Coverage, 14632,
     /*  683513 */     GIR_EraseRootFromParent_Done,
     /*  683514 */   // Label 10907: @683514
     /*  683514 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(683592), // Rule ID 14633 //
     /*  683519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  683530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  683533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  683536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  683539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683590 */     GIR_RootConstrainSelectedInstOperands,
     /*  683591 */     // GIR_Coverage, 14633,
     /*  683591 */     GIR_EraseRootFromParent_Done,
     /*  683592 */   // Label 10908: @683592
     /*  683592 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(683670), // Rule ID 14636 //
     /*  683597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  683608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  683611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  683614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  683617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683668 */     GIR_RootConstrainSelectedInstOperands,
     /*  683669 */     // GIR_Coverage, 14636,
     /*  683669 */     GIR_EraseRootFromParent_Done,
     /*  683670 */   // Label 10909: @683670
     /*  683670 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(683748), // Rule ID 14637 //
     /*  683675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  683686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  683689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  683692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  683695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683746 */     GIR_RootConstrainSelectedInstOperands,
     /*  683747 */     // GIR_Coverage, 14637,
     /*  683747 */     GIR_EraseRootFromParent_Done,
     /*  683748 */   // Label 10910: @683748
     /*  683748 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(683826), // Rule ID 14640 //
     /*  683753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  683764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  683767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  683770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  683773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683824 */     GIR_RootConstrainSelectedInstOperands,
     /*  683825 */     // GIR_Coverage, 14640,
     /*  683825 */     GIR_EraseRootFromParent_Done,
     /*  683826 */   // Label 10911: @683826
     /*  683826 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(683904), // Rule ID 14641 //
     /*  683831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  683842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  683845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  683848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  683851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683902 */     GIR_RootConstrainSelectedInstOperands,
     /*  683903 */     // GIR_Coverage, 14641,
     /*  683903 */     GIR_EraseRootFromParent_Done,
     /*  683904 */   // Label 10912: @683904
     /*  683904 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(683982), // Rule ID 14644 //
     /*  683909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  683920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  683923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  683926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  683929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683955 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  683958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  683980 */     GIR_RootConstrainSelectedInstOperands,
     /*  683981 */     // GIR_Coverage, 14644,
     /*  683981 */     GIR_EraseRootFromParent_Done,
     /*  683982 */   // Label 10913: @683982
     /*  683982 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(684060), // Rule ID 14645 //
     /*  683987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  683995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  683998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  684033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  684036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684058 */     GIR_RootConstrainSelectedInstOperands,
     /*  684059 */     // GIR_Coverage, 14645,
     /*  684059 */     GIR_EraseRootFromParent_Done,
     /*  684060 */   // Label 10914: @684060
     /*  684060 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(684138), // Rule ID 14648 //
     /*  684065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684111 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  684114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684136 */     GIR_RootConstrainSelectedInstOperands,
     /*  684137 */     // GIR_Coverage, 14648,
     /*  684137 */     GIR_EraseRootFromParent_Done,
     /*  684138 */   // Label 10915: @684138
     /*  684138 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(684216), // Rule ID 14649 //
     /*  684143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  684192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684214 */     GIR_RootConstrainSelectedInstOperands,
     /*  684215 */     // GIR_Coverage, 14649,
     /*  684215 */     GIR_EraseRootFromParent_Done,
     /*  684216 */   // Label 10916: @684216
     /*  684216 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(684294), // Rule ID 14652 //
     /*  684221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  684232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  684235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  684238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  684241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684267 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  684270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684292 */     GIR_RootConstrainSelectedInstOperands,
     /*  684293 */     // GIR_Coverage, 14652,
     /*  684293 */     GIR_EraseRootFromParent_Done,
     /*  684294 */   // Label 10917: @684294
     /*  684294 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(684372), // Rule ID 14653 //
     /*  684299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  684310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  684313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  684316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  684319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684345 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  684348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684370 */     GIR_RootConstrainSelectedInstOperands,
     /*  684371 */     // GIR_Coverage, 14653,
     /*  684371 */     GIR_EraseRootFromParent_Done,
     /*  684372 */   // Label 10918: @684372
     /*  684372 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(684450), // Rule ID 14656 //
     /*  684377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  684388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  684391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  684394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  684397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684423 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  684426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684448 */     GIR_RootConstrainSelectedInstOperands,
     /*  684449 */     // GIR_Coverage, 14656,
     /*  684449 */     GIR_EraseRootFromParent_Done,
     /*  684450 */   // Label 10919: @684450
     /*  684450 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(684528), // Rule ID 14657 //
     /*  684455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  684466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  684469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  684472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  684475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684501 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  684504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684526 */     GIR_RootConstrainSelectedInstOperands,
     /*  684527 */     // GIR_Coverage, 14657,
     /*  684527 */     GIR_EraseRootFromParent_Done,
     /*  684528 */   // Label 10920: @684528
     /*  684528 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(684606), // Rule ID 14660 //
     /*  684533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  684544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  684547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  684550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  684553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  684582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684604 */     GIR_RootConstrainSelectedInstOperands,
     /*  684605 */     // GIR_Coverage, 14660,
     /*  684605 */     GIR_EraseRootFromParent_Done,
     /*  684606 */   // Label 10921: @684606
     /*  684606 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(684684), // Rule ID 14661 //
     /*  684611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  684622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  684625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  684628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  684631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684657 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  684660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684682 */     GIR_RootConstrainSelectedInstOperands,
     /*  684683 */     // GIR_Coverage, 14661,
     /*  684683 */     GIR_EraseRootFromParent_Done,
     /*  684684 */   // Label 10922: @684684
     /*  684684 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(684762), // Rule ID 14664 //
     /*  684689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  684700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  684703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  684706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  684709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684735 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  684738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684760 */     GIR_RootConstrainSelectedInstOperands,
     /*  684761 */     // GIR_Coverage, 14664,
     /*  684761 */     GIR_EraseRootFromParent_Done,
     /*  684762 */   // Label 10923: @684762
     /*  684762 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(684840), // Rule ID 14665 //
     /*  684767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  684778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  684781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  684784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  684787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684813 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  684816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684838 */     GIR_RootConstrainSelectedInstOperands,
     /*  684839 */     // GIR_Coverage, 14665,
     /*  684839 */     GIR_EraseRootFromParent_Done,
     /*  684840 */   // Label 10924: @684840
     /*  684840 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(684918), // Rule ID 14668 //
     /*  684845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  684856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  684859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  684862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  684865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684891 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  684894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684916 */     GIR_RootConstrainSelectedInstOperands,
     /*  684917 */     // GIR_Coverage, 14668,
     /*  684917 */     GIR_EraseRootFromParent_Done,
     /*  684918 */   // Label 10925: @684918
     /*  684918 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(684996), // Rule ID 14669 //
     /*  684923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  684931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  684934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  684937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  684940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  684943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  684972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  684994 */     GIR_RootConstrainSelectedInstOperands,
     /*  684995 */     // GIR_Coverage, 14669,
     /*  684995 */     GIR_EraseRootFromParent_Done,
     /*  684996 */   // Label 10926: @684996
     /*  684996 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(685074), // Rule ID 14672 //
     /*  685001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  685050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685072 */     GIR_RootConstrainSelectedInstOperands,
     /*  685073 */     // GIR_Coverage, 14672,
     /*  685073 */     GIR_EraseRootFromParent_Done,
     /*  685074 */   // Label 10927: @685074
     /*  685074 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(685152), // Rule ID 14673 //
     /*  685079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  685128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685150 */     GIR_RootConstrainSelectedInstOperands,
     /*  685151 */     // GIR_Coverage, 14673,
     /*  685151 */     GIR_EraseRootFromParent_Done,
     /*  685152 */   // Label 10928: @685152
     /*  685152 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(685230), // Rule ID 14676 //
     /*  685157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  685206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685228 */     GIR_RootConstrainSelectedInstOperands,
     /*  685229 */     // GIR_Coverage, 14676,
     /*  685229 */     GIR_EraseRootFromParent_Done,
     /*  685230 */   // Label 10929: @685230
     /*  685230 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(685308), // Rule ID 14677 //
     /*  685235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685281 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  685284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685306 */     GIR_RootConstrainSelectedInstOperands,
     /*  685307 */     // GIR_Coverage, 14677,
     /*  685307 */     GIR_EraseRootFromParent_Done,
     /*  685308 */   // Label 10930: @685308
     /*  685308 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(685386), // Rule ID 14680 //
     /*  685313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  685324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  685327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  685330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  685333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685359 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  685362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685384 */     GIR_RootConstrainSelectedInstOperands,
     /*  685385 */     // GIR_Coverage, 14680,
     /*  685385 */     GIR_EraseRootFromParent_Done,
     /*  685386 */   // Label 10931: @685386
     /*  685386 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(685464), // Rule ID 14681 //
     /*  685391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  685402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  685405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  685408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  685411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685437 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  685440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685462 */     GIR_RootConstrainSelectedInstOperands,
     /*  685463 */     // GIR_Coverage, 14681,
     /*  685463 */     GIR_EraseRootFromParent_Done,
     /*  685464 */   // Label 10932: @685464
     /*  685464 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(685542), // Rule ID 14684 //
     /*  685469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  685480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  685483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  685486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  685489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  685518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685540 */     GIR_RootConstrainSelectedInstOperands,
     /*  685541 */     // GIR_Coverage, 14684,
     /*  685541 */     GIR_EraseRootFromParent_Done,
     /*  685542 */   // Label 10933: @685542
     /*  685542 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(685620), // Rule ID 14685 //
     /*  685547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  685558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  685561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  685564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  685567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  685596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685618 */     GIR_RootConstrainSelectedInstOperands,
     /*  685619 */     // GIR_Coverage, 14685,
     /*  685619 */     GIR_EraseRootFromParent_Done,
     /*  685620 */   // Label 10934: @685620
     /*  685620 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(685698), // Rule ID 14688 //
     /*  685625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  685636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  685639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  685642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  685645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  685674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685696 */     GIR_RootConstrainSelectedInstOperands,
     /*  685697 */     // GIR_Coverage, 14688,
     /*  685697 */     GIR_EraseRootFromParent_Done,
     /*  685698 */   // Label 10935: @685698
     /*  685698 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(685776), // Rule ID 14689 //
     /*  685703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  685714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  685717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  685720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  685723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685749 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  685752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685774 */     GIR_RootConstrainSelectedInstOperands,
     /*  685775 */     // GIR_Coverage, 14689,
     /*  685775 */     GIR_EraseRootFromParent_Done,
     /*  685776 */   // Label 10936: @685776
     /*  685776 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(685854), // Rule ID 14692 //
     /*  685781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  685792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  685795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  685798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  685801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685827 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  685830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685852 */     GIR_RootConstrainSelectedInstOperands,
     /*  685853 */     // GIR_Coverage, 14692,
     /*  685853 */     GIR_EraseRootFromParent_Done,
     /*  685854 */   // Label 10937: @685854
     /*  685854 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(685932), // Rule ID 14693 //
     /*  685859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  685870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  685873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  685876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  685879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685905 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  685908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  685930 */     GIR_RootConstrainSelectedInstOperands,
     /*  685931 */     // GIR_Coverage, 14693,
     /*  685931 */     GIR_EraseRootFromParent_Done,
     /*  685932 */   // Label 10938: @685932
     /*  685932 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(686010), // Rule ID 14696 //
     /*  685937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  685945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  685948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  685951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  685954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685983 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  685986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686008 */     GIR_RootConstrainSelectedInstOperands,
     /*  686009 */     // GIR_Coverage, 14696,
     /*  686009 */     GIR_EraseRootFromParent_Done,
     /*  686010 */   // Label 10939: @686010
     /*  686010 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(686088), // Rule ID 14697 //
     /*  686015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686061 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  686064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686086 */     GIR_RootConstrainSelectedInstOperands,
     /*  686087 */     // GIR_Coverage, 14697,
     /*  686087 */     GIR_EraseRootFromParent_Done,
     /*  686088 */   // Label 10940: @686088
     /*  686088 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(686166), // Rule ID 14700 //
     /*  686093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  686142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686164 */     GIR_RootConstrainSelectedInstOperands,
     /*  686165 */     // GIR_Coverage, 14700,
     /*  686165 */     GIR_EraseRootFromParent_Done,
     /*  686166 */   // Label 10941: @686166
     /*  686166 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(686244), // Rule ID 14701 //
     /*  686171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686217 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  686220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686242 */     GIR_RootConstrainSelectedInstOperands,
     /*  686243 */     // GIR_Coverage, 14701,
     /*  686243 */     GIR_EraseRootFromParent_Done,
     /*  686244 */   // Label 10942: @686244
     /*  686244 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(686322), // Rule ID 14704 //
     /*  686249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  686260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  686263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  686266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686295 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686320 */     GIR_RootConstrainSelectedInstOperands,
     /*  686321 */     // GIR_Coverage, 14704,
     /*  686321 */     GIR_EraseRootFromParent_Done,
     /*  686322 */   // Label 10943: @686322
     /*  686322 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(686400), // Rule ID 14705 //
     /*  686327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  686338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  686341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  686344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686373 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686398 */     GIR_RootConstrainSelectedInstOperands,
     /*  686399 */     // GIR_Coverage, 14705,
     /*  686399 */     GIR_EraseRootFromParent_Done,
     /*  686400 */   // Label 10944: @686400
     /*  686400 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(686478), // Rule ID 14708 //
     /*  686405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  686416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  686419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  686422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  686454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686476 */     GIR_RootConstrainSelectedInstOperands,
     /*  686477 */     // GIR_Coverage, 14708,
     /*  686477 */     GIR_EraseRootFromParent_Done,
     /*  686478 */   // Label 10945: @686478
     /*  686478 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(686556), // Rule ID 14709 //
     /*  686483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  686494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  686497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  686500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  686532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686554 */     GIR_RootConstrainSelectedInstOperands,
     /*  686555 */     // GIR_Coverage, 14709,
     /*  686555 */     GIR_EraseRootFromParent_Done,
     /*  686556 */   // Label 10946: @686556
     /*  686556 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(686634), // Rule ID 14712 //
     /*  686561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  686572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  686575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  686578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686632 */     GIR_RootConstrainSelectedInstOperands,
     /*  686633 */     // GIR_Coverage, 14712,
     /*  686633 */     GIR_EraseRootFromParent_Done,
     /*  686634 */   // Label 10947: @686634
     /*  686634 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(686712), // Rule ID 14713 //
     /*  686639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  686650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  686653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  686656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686685 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686710 */     GIR_RootConstrainSelectedInstOperands,
     /*  686711 */     // GIR_Coverage, 14713,
     /*  686711 */     GIR_EraseRootFromParent_Done,
     /*  686712 */   // Label 10948: @686712
     /*  686712 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(686790), // Rule ID 14716 //
     /*  686717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  686728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  686731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  686734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686763 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686788 */     GIR_RootConstrainSelectedInstOperands,
     /*  686789 */     // GIR_Coverage, 14716,
     /*  686789 */     GIR_EraseRootFromParent_Done,
     /*  686790 */   // Label 10949: @686790
     /*  686790 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(686868), // Rule ID 14717 //
     /*  686795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  686806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  686809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  686812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  686844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686866 */     GIR_RootConstrainSelectedInstOperands,
     /*  686867 */     // GIR_Coverage, 14717,
     /*  686867 */     GIR_EraseRootFromParent_Done,
     /*  686868 */   // Label 10950: @686868
     /*  686868 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(686946), // Rule ID 14720 //
     /*  686873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  686884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  686887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  686890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  686922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  686944 */     GIR_RootConstrainSelectedInstOperands,
     /*  686945 */     // GIR_Coverage, 14720,
     /*  686945 */     GIR_EraseRootFromParent_Done,
     /*  686946 */   // Label 10951: @686946
     /*  686946 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(687024), // Rule ID 14721 //
     /*  686951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  686959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  686962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  686965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  686968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686997 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11308:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687022 */     GIR_RootConstrainSelectedInstOperands,
     /*  687023 */     // GIR_Coverage, 14721,
     /*  687023 */     GIR_EraseRootFromParent_Done,
     /*  687024 */   // Label 10952: @687024
     /*  687024 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(687102), // Rule ID 14724 //
     /*  687029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687100 */     GIR_RootConstrainSelectedInstOperands,
     /*  687101 */     // GIR_Coverage, 14724,
     /*  687101 */     GIR_EraseRootFromParent_Done,
     /*  687102 */   // Label 10953: @687102
     /*  687102 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(687180), // Rule ID 14725 //
     /*  687107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687153 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687178 */     GIR_RootConstrainSelectedInstOperands,
     /*  687179 */     // GIR_Coverage, 14725,
     /*  687179 */     GIR_EraseRootFromParent_Done,
     /*  687180 */   // Label 10954: @687180
     /*  687180 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(687258), // Rule ID 14728 //
     /*  687185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687231 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687256 */     GIR_RootConstrainSelectedInstOperands,
     /*  687257 */     // GIR_Coverage, 14728,
     /*  687257 */     GIR_EraseRootFromParent_Done,
     /*  687258 */   // Label 10955: @687258
     /*  687258 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(687336), // Rule ID 14729 //
     /*  687263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687309 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  687309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687334 */     GIR_RootConstrainSelectedInstOperands,
     /*  687335 */     // GIR_Coverage, 14729,
     /*  687335 */     GIR_EraseRootFromParent_Done,
     /*  687336 */   // Label 10956: @687336
     /*  687336 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(687414), // Rule ID 14732 //
     /*  687341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  687352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  687355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  687358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687387 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687412 */     GIR_RootConstrainSelectedInstOperands,
     /*  687413 */     // GIR_Coverage, 14732,
     /*  687413 */     GIR_EraseRootFromParent_Done,
     /*  687414 */   // Label 10957: @687414
     /*  687414 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(687492), // Rule ID 14733 //
     /*  687419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  687430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  687433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  687436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687465 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  687468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687490 */     GIR_RootConstrainSelectedInstOperands,
     /*  687491 */     // GIR_Coverage, 14733,
     /*  687491 */     GIR_EraseRootFromParent_Done,
     /*  687492 */   // Label 10958: @687492
     /*  687492 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(687570), // Rule ID 14736 //
     /*  687497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  687508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  687511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  687514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  687546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687568 */     GIR_RootConstrainSelectedInstOperands,
     /*  687569 */     // GIR_Coverage, 14736,
     /*  687569 */     GIR_EraseRootFromParent_Done,
     /*  687570 */   // Label 10959: @687570
     /*  687570 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(687648), // Rule ID 14737 //
     /*  687575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  687586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  687589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  687592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  687624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687646 */     GIR_RootConstrainSelectedInstOperands,
     /*  687647 */     // GIR_Coverage, 14737,
     /*  687647 */     GIR_EraseRootFromParent_Done,
     /*  687648 */   // Label 10960: @687648
     /*  687648 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(687726), // Rule ID 14740 //
     /*  687653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  687664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  687667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  687670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687699 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  687702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687724 */     GIR_RootConstrainSelectedInstOperands,
     /*  687725 */     // GIR_Coverage, 14740,
     /*  687725 */     GIR_EraseRootFromParent_Done,
     /*  687726 */   // Label 10961: @687726
     /*  687726 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(687804), // Rule ID 14741 //
     /*  687731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  687742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  687745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  687748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687777 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  687780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687802 */     GIR_RootConstrainSelectedInstOperands,
     /*  687803 */     // GIR_Coverage, 14741,
     /*  687803 */     GIR_EraseRootFromParent_Done,
     /*  687804 */   // Label 10962: @687804
     /*  687804 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(687882), // Rule ID 14744 //
     /*  687809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  687820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  687823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  687826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687855 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  687858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687880 */     GIR_RootConstrainSelectedInstOperands,
     /*  687881 */     // GIR_Coverage, 14744,
     /*  687881 */     GIR_EraseRootFromParent_Done,
     /*  687882 */   // Label 10963: @687882
     /*  687882 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(687960), // Rule ID 14745 //
     /*  687887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  687898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  687901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  687904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687933 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  687936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  687958 */     GIR_RootConstrainSelectedInstOperands,
     /*  687959 */     // GIR_Coverage, 14745,
     /*  687959 */     GIR_EraseRootFromParent_Done,
     /*  687960 */   // Label 10964: @687960
     /*  687960 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(688038), // Rule ID 14748 //
     /*  687965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  687973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  687976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  687979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  687982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  688014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688036 */     GIR_RootConstrainSelectedInstOperands,
     /*  688037 */     // GIR_Coverage, 14748,
     /*  688037 */     GIR_EraseRootFromParent_Done,
     /*  688038 */   // Label 10965: @688038
     /*  688038 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(688116), // Rule ID 14749 //
     /*  688043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  688092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688114 */     GIR_RootConstrainSelectedInstOperands,
     /*  688115 */     // GIR_Coverage, 14749,
     /*  688115 */     GIR_EraseRootFromParent_Done,
     /*  688116 */   // Label 10966: @688116
     /*  688116 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(688194), // Rule ID 14752 //
     /*  688121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688167 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  688170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688192 */     GIR_RootConstrainSelectedInstOperands,
     /*  688193 */     // GIR_Coverage, 14752,
     /*  688193 */     GIR_EraseRootFromParent_Done,
     /*  688194 */   // Label 10967: @688194
     /*  688194 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(688272), // Rule ID 14753 //
     /*  688199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  688248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688270 */     GIR_RootConstrainSelectedInstOperands,
     /*  688271 */     // GIR_Coverage, 14753,
     /*  688271 */     GIR_EraseRootFromParent_Done,
     /*  688272 */   // Label 10968: @688272
     /*  688272 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(688350), // Rule ID 14756 //
     /*  688277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  688326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688348 */     GIR_RootConstrainSelectedInstOperands,
     /*  688349 */     // GIR_Coverage, 14756,
     /*  688349 */     GIR_EraseRootFromParent_Done,
     /*  688350 */   // Label 10969: @688350
     /*  688350 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(688428), // Rule ID 14757 //
     /*  688355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  688404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688426 */     GIR_RootConstrainSelectedInstOperands,
     /*  688427 */     // GIR_Coverage, 14757,
     /*  688427 */     GIR_EraseRootFromParent_Done,
     /*  688428 */   // Label 10970: @688428
     /*  688428 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(688506), // Rule ID 14760 //
     /*  688433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  688444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  688447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  688450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  688482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688504 */     GIR_RootConstrainSelectedInstOperands,
     /*  688505 */     // GIR_Coverage, 14760,
     /*  688505 */     GIR_EraseRootFromParent_Done,
     /*  688506 */   // Label 10971: @688506
     /*  688506 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(688584), // Rule ID 14761 //
     /*  688511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  688522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  688525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  688528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  688560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688582 */     GIR_RootConstrainSelectedInstOperands,
     /*  688583 */     // GIR_Coverage, 14761,
     /*  688583 */     GIR_EraseRootFromParent_Done,
     /*  688584 */   // Label 10972: @688584
     /*  688584 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(688662), // Rule ID 14764 //
     /*  688589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  688600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  688603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  688606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  688638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688660 */     GIR_RootConstrainSelectedInstOperands,
     /*  688661 */     // GIR_Coverage, 14764,
     /*  688661 */     GIR_EraseRootFromParent_Done,
     /*  688662 */   // Label 10973: @688662
     /*  688662 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(688740), // Rule ID 14765 //
     /*  688667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  688678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  688681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  688684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688713 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  688716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688738 */     GIR_RootConstrainSelectedInstOperands,
     /*  688739 */     // GIR_Coverage, 14765,
     /*  688739 */     GIR_EraseRootFromParent_Done,
     /*  688740 */   // Label 10974: @688740
     /*  688740 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(688818), // Rule ID 14768 //
     /*  688745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  688756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  688759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  688762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688791 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  688794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688816 */     GIR_RootConstrainSelectedInstOperands,
     /*  688817 */     // GIR_Coverage, 14768,
     /*  688817 */     GIR_EraseRootFromParent_Done,
     /*  688818 */   // Label 10975: @688818
     /*  688818 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(688896), // Rule ID 14769 //
     /*  688823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  688834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  688837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  688840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  688872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688894 */     GIR_RootConstrainSelectedInstOperands,
     /*  688895 */     // GIR_Coverage, 14769,
     /*  688895 */     GIR_EraseRootFromParent_Done,
     /*  688896 */   // Label 10976: @688896
     /*  688896 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(688974), // Rule ID 14772 //
     /*  688901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  688912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  688915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  688918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  688950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  688972 */     GIR_RootConstrainSelectedInstOperands,
     /*  688973 */     // GIR_Coverage, 14772,
     /*  688973 */     GIR_EraseRootFromParent_Done,
     /*  688974 */   // Label 10977: @688974
     /*  688974 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(689052), // Rule ID 14773 //
     /*  688979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  688987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  688990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  688993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  688996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  689028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  689050 */     GIR_RootConstrainSelectedInstOperands,
     /*  689051 */     // GIR_Coverage, 14773,
     /*  689051 */     GIR_EraseRootFromParent_Done,
     /*  689052 */   // Label 10978: @689052
     /*  689052 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(689130), // Rule ID 14776 //
     /*  689057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  689065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689103 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  689106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  689128 */     GIR_RootConstrainSelectedInstOperands,
     /*  689129 */     // GIR_Coverage, 14776,
     /*  689129 */     GIR_EraseRootFromParent_Done,
     /*  689130 */   // Label 10979: @689130
     /*  689130 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(689208), // Rule ID 14777 //
     /*  689135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  689143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  689184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  689206 */     GIR_RootConstrainSelectedInstOperands,
     /*  689207 */     // GIR_Coverage, 14777,
     /*  689207 */     GIR_EraseRootFromParent_Done,
     /*  689208 */   // Label 10980: @689208
     /*  689208 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(689286), // Rule ID 14780 //
     /*  689213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  689221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689259 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  689262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  689284 */     GIR_RootConstrainSelectedInstOperands,
     /*  689285 */     // GIR_Coverage, 14780,
     /*  689285 */     GIR_EraseRootFromParent_Done,
     /*  689286 */   // Label 10981: @689286
     /*  689286 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(689364), // Rule ID 14781 //
     /*  689291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  689299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689337 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  689340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  689362 */     GIR_RootConstrainSelectedInstOperands,
     /*  689363 */     // GIR_Coverage, 14781,
     /*  689363 */     GIR_EraseRootFromParent_Done,
     /*  689364 */   // Label 10982: @689364
     /*  689364 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(689439), // Rule ID 19022 //
     /*  689369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  689372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  689380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  689383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  689386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  689389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689415 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  689418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689437 */     GIR_RootConstrainSelectedInstOperands,
     /*  689438 */     // GIR_Coverage, 19022,
     /*  689438 */     GIR_EraseRootFromParent_Done,
     /*  689439 */   // Label 10983: @689439
     /*  689439 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(689514), // Rule ID 19023 //
     /*  689444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  689447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  689455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  689458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  689461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  689464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689490 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  689493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689512 */     GIR_RootConstrainSelectedInstOperands,
     /*  689513 */     // GIR_Coverage, 19023,
     /*  689513 */     GIR_EraseRootFromParent_Done,
     /*  689514 */   // Label 10984: @689514
     /*  689514 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(689589), // Rule ID 19026 //
     /*  689519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  689522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  689530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  689533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  689536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  689539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  689568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689587 */     GIR_RootConstrainSelectedInstOperands,
     /*  689588 */     // GIR_Coverage, 19026,
     /*  689588 */     GIR_EraseRootFromParent_Done,
     /*  689589 */   // Label 10985: @689589
     /*  689589 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(689664), // Rule ID 19027 //
     /*  689594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  689597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  689605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  689608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  689611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  689614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  689643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689662 */     GIR_RootConstrainSelectedInstOperands,
     /*  689663 */     // GIR_Coverage, 19027,
     /*  689663 */     GIR_EraseRootFromParent_Done,
     /*  689664 */   // Label 10986: @689664
     /*  689664 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(689739), // Rule ID 19030 //
     /*  689669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  689672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  689680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  689683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  689686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  689689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689715 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  689718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689737 */     GIR_RootConstrainSelectedInstOperands,
     /*  689738 */     // GIR_Coverage, 19030,
     /*  689738 */     GIR_EraseRootFromParent_Done,
     /*  689739 */   // Label 10987: @689739
     /*  689739 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(689814), // Rule ID 19031 //
     /*  689744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  689747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  689755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  689758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  689761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  689764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  689793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689812 */     GIR_RootConstrainSelectedInstOperands,
     /*  689813 */     // GIR_Coverage, 19031,
     /*  689813 */     GIR_EraseRootFromParent_Done,
     /*  689814 */   // Label 10988: @689814
     /*  689814 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(689889), // Rule ID 19034 //
     /*  689819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  689822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  689830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  689833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  689836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  689839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  689868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689887 */     GIR_RootConstrainSelectedInstOperands,
     /*  689888 */     // GIR_Coverage, 19034,
     /*  689888 */     GIR_EraseRootFromParent_Done,
     /*  689889 */   // Label 10989: @689889
     /*  689889 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(689964), // Rule ID 19035 //
     /*  689894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  689897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  689905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  689908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  689911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  689914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  689943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689962 */     GIR_RootConstrainSelectedInstOperands,
     /*  689963 */     // GIR_Coverage, 19035,
     /*  689963 */     GIR_EraseRootFromParent_Done,
     /*  689964 */   // Label 10990: @689964
     /*  689964 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(690039), // Rule ID 19038 //
     /*  689969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  689972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  689977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  689980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  689983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  689986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  689989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  690018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690037 */     GIR_RootConstrainSelectedInstOperands,
     /*  690038 */     // GIR_Coverage, 19038,
     /*  690038 */     GIR_EraseRootFromParent_Done,
     /*  690039 */   // Label 10991: @690039
     /*  690039 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(690114), // Rule ID 19039 //
     /*  690044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  690047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  690055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  690058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  690061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  690064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  690093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690112 */     GIR_RootConstrainSelectedInstOperands,
     /*  690113 */     // GIR_Coverage, 19039,
     /*  690113 */     GIR_EraseRootFromParent_Done,
     /*  690114 */   // Label 10992: @690114
     /*  690114 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(690189), // Rule ID 19042 //
     /*  690119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  690122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  690130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  690133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  690136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  690139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690165 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  690168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690187 */     GIR_RootConstrainSelectedInstOperands,
     /*  690188 */     // GIR_Coverage, 19042,
     /*  690188 */     GIR_EraseRootFromParent_Done,
     /*  690189 */   // Label 10993: @690189
     /*  690189 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(690264), // Rule ID 19043 //
     /*  690194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  690197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  690205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  690208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  690211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  690214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  690243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690262 */     GIR_RootConstrainSelectedInstOperands,
     /*  690263 */     // GIR_Coverage, 19043,
     /*  690263 */     GIR_EraseRootFromParent_Done,
     /*  690264 */   // Label 10994: @690264
     /*  690264 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(690339), // Rule ID 19046 //
     /*  690269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  690272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  690280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  690283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  690286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  690289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  690318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690337 */     GIR_RootConstrainSelectedInstOperands,
     /*  690338 */     // GIR_Coverage, 19046,
     /*  690338 */     GIR_EraseRootFromParent_Done,
     /*  690339 */   // Label 10995: @690339
     /*  690339 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(690414), // Rule ID 19047 //
     /*  690344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  690347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  690355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  690358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  690361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  690364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690390 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  690393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690412 */     GIR_RootConstrainSelectedInstOperands,
     /*  690413 */     // GIR_Coverage, 19047,
     /*  690413 */     GIR_EraseRootFromParent_Done,
     /*  690414 */   // Label 10996: @690414
     /*  690414 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(690489), // Rule ID 19050 //
     /*  690419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  690422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  690430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  690433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  690436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  690439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690465 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  690468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690487 */     GIR_RootConstrainSelectedInstOperands,
     /*  690488 */     // GIR_Coverage, 19050,
     /*  690488 */     GIR_EraseRootFromParent_Done,
     /*  690489 */   // Label 10997: @690489
     /*  690489 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(690564), // Rule ID 19051 //
     /*  690494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  690497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  690505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  690508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  690511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  690514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  690543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690562 */     GIR_RootConstrainSelectedInstOperands,
     /*  690563 */     // GIR_Coverage, 19051,
     /*  690563 */     GIR_EraseRootFromParent_Done,
     /*  690564 */   // Label 10998: @690564
     /*  690564 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(690639), // Rule ID 19054 //
     /*  690569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  690572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  690580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  690583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  690586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  690589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690615 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  690618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690637 */     GIR_RootConstrainSelectedInstOperands,
     /*  690638 */     // GIR_Coverage, 19054,
     /*  690638 */     GIR_EraseRootFromParent_Done,
     /*  690639 */   // Label 10999: @690639
     /*  690639 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(690714), // Rule ID 19055 //
     /*  690644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  690647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  690655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  690658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  690661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  690664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  690693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690712 */     GIR_RootConstrainSelectedInstOperands,
     /*  690713 */     // GIR_Coverage, 19055,
     /*  690713 */     GIR_EraseRootFromParent_Done,
     /*  690714 */   // Label 11000: @690714
     /*  690714 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(690789), // Rule ID 19058 //
     /*  690719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  690722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  690730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  690733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  690736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  690739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  690768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690787 */     GIR_RootConstrainSelectedInstOperands,
     /*  690788 */     // GIR_Coverage, 19058,
     /*  690788 */     GIR_EraseRootFromParent_Done,
     /*  690789 */   // Label 11001: @690789
     /*  690789 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(690864), // Rule ID 19059 //
     /*  690794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  690797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  690805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  690808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  690811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  690814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  690843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690862 */     GIR_RootConstrainSelectedInstOperands,
     /*  690863 */     // GIR_Coverage, 19059,
     /*  690863 */     GIR_EraseRootFromParent_Done,
     /*  690864 */   // Label 11002: @690864
     /*  690864 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(690939), // Rule ID 19062 //
     /*  690869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  690872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  690880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  690883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  690886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  690889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690915 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  690918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690937 */     GIR_RootConstrainSelectedInstOperands,
     /*  690938 */     // GIR_Coverage, 19062,
     /*  690938 */     GIR_EraseRootFromParent_Done,
     /*  690939 */   // Label 11003: @690939
     /*  690939 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(691014), // Rule ID 19063 //
     /*  690944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  690947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  690952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  690955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  690958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  690961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  690964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  690993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691012 */     GIR_RootConstrainSelectedInstOperands,
     /*  691013 */     // GIR_Coverage, 19063,
     /*  691013 */     GIR_EraseRootFromParent_Done,
     /*  691014 */   // Label 11004: @691014
     /*  691014 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(691089), // Rule ID 19066 //
     /*  691019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  691022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  691030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  691033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  691036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  691039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  691068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691087 */     GIR_RootConstrainSelectedInstOperands,
     /*  691088 */     // GIR_Coverage, 19066,
     /*  691088 */     GIR_EraseRootFromParent_Done,
     /*  691089 */   // Label 11005: @691089
     /*  691089 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(691164), // Rule ID 19067 //
     /*  691094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  691097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  691105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  691108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  691111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  691114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  691143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691162 */     GIR_RootConstrainSelectedInstOperands,
     /*  691163 */     // GIR_Coverage, 19067,
     /*  691163 */     GIR_EraseRootFromParent_Done,
     /*  691164 */   // Label 11006: @691164
     /*  691164 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(691239), // Rule ID 19070 //
     /*  691169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  691172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  691180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  691183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  691186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  691189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  691218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691237 */     GIR_RootConstrainSelectedInstOperands,
     /*  691238 */     // GIR_Coverage, 19070,
     /*  691238 */     GIR_EraseRootFromParent_Done,
     /*  691239 */   // Label 11007: @691239
     /*  691239 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(691314), // Rule ID 19071 //
     /*  691244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  691247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  691255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  691258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  691261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  691264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  691293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691312 */     GIR_RootConstrainSelectedInstOperands,
     /*  691313 */     // GIR_Coverage, 19071,
     /*  691313 */     GIR_EraseRootFromParent_Done,
     /*  691314 */   // Label 11008: @691314
     /*  691314 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(691389), // Rule ID 19074 //
     /*  691319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  691322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  691330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  691333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  691336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  691339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691365 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  691368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691387 */     GIR_RootConstrainSelectedInstOperands,
     /*  691388 */     // GIR_Coverage, 19074,
     /*  691388 */     GIR_EraseRootFromParent_Done,
     /*  691389 */   // Label 11009: @691389
     /*  691389 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(691464), // Rule ID 19075 //
     /*  691394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  691397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  691405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  691408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  691411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  691414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  691443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691462 */     GIR_RootConstrainSelectedInstOperands,
     /*  691463 */     // GIR_Coverage, 19075,
     /*  691463 */     GIR_EraseRootFromParent_Done,
     /*  691464 */   // Label 11010: @691464
     /*  691464 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(691539), // Rule ID 19078 //
     /*  691469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  691472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  691480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  691483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  691486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  691489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  691518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691537 */     GIR_RootConstrainSelectedInstOperands,
     /*  691538 */     // GIR_Coverage, 19078,
     /*  691538 */     GIR_EraseRootFromParent_Done,
     /*  691539 */   // Label 11011: @691539
     /*  691539 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(691614), // Rule ID 19079 //
     /*  691544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  691547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  691555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  691558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  691561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  691564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  691593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691612 */     GIR_RootConstrainSelectedInstOperands,
     /*  691613 */     // GIR_Coverage, 19079,
     /*  691613 */     GIR_EraseRootFromParent_Done,
     /*  691614 */   // Label 11012: @691614
     /*  691614 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(691689), // Rule ID 19082 //
     /*  691619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  691622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  691639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  691658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691665 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  691668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691687 */     GIR_RootConstrainSelectedInstOperands,
     /*  691688 */     // GIR_Coverage, 19082,
     /*  691688 */     GIR_EraseRootFromParent_Done,
     /*  691689 */   // Label 11013: @691689
     /*  691689 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(691764), // Rule ID 19083 //
     /*  691694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  691697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  691714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  691733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691740 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  691743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691762 */     GIR_RootConstrainSelectedInstOperands,
     /*  691763 */     // GIR_Coverage, 19083,
     /*  691763 */     GIR_EraseRootFromParent_Done,
     /*  691764 */   // Label 11014: @691764
     /*  691764 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(691839), // Rule ID 19086 //
     /*  691769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  691772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  691789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  691808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  691818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691837 */     GIR_RootConstrainSelectedInstOperands,
     /*  691838 */     // GIR_Coverage, 19086,
     /*  691838 */     GIR_EraseRootFromParent_Done,
     /*  691839 */   // Label 11015: @691839
     /*  691839 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(691914), // Rule ID 19087 //
     /*  691844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  691847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  691864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  691883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  691893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691912 */     GIR_RootConstrainSelectedInstOperands,
     /*  691913 */     // GIR_Coverage, 19087,
     /*  691913 */     GIR_EraseRootFromParent_Done,
     /*  691914 */   // Label 11016: @691914
     /*  691914 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(691989), // Rule ID 19090 //
     /*  691919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  691922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  691927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  691958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691965 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  691968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691987 */     GIR_RootConstrainSelectedInstOperands,
     /*  691988 */     // GIR_Coverage, 19090,
     /*  691988 */     GIR_EraseRootFromParent_Done,
     /*  691989 */   // Label 11017: @691989
     /*  691989 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(692064), // Rule ID 19091 //
     /*  691994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  691997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  692005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  692008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  692011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  692033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692040 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  692043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692062 */     GIR_RootConstrainSelectedInstOperands,
     /*  692063 */     // GIR_Coverage, 19091,
     /*  692063 */     GIR_EraseRootFromParent_Done,
     /*  692064 */   // Label 11018: @692064
     /*  692064 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(692139), // Rule ID 19094 //
     /*  692069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  692072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  692080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  692083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  692086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  692118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692137 */     GIR_RootConstrainSelectedInstOperands,
     /*  692138 */     // GIR_Coverage, 19094,
     /*  692138 */     GIR_EraseRootFromParent_Done,
     /*  692139 */   // Label 11019: @692139
     /*  692139 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(692214), // Rule ID 19095 //
     /*  692144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  692147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  692155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  692158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  692161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10903:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  692193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692212 */     GIR_RootConstrainSelectedInstOperands,
     /*  692213 */     // GIR_Coverage, 19095,
     /*  692213 */     GIR_EraseRootFromParent_Done,
     /*  692214 */   // Label 11020: @692214
     /*  692214 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(692289), // Rule ID 19098 //
     /*  692219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  692222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  692230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  692233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  692236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  692258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  692268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692287 */     GIR_RootConstrainSelectedInstOperands,
     /*  692288 */     // GIR_Coverage, 19098,
     /*  692288 */     GIR_EraseRootFromParent_Done,
     /*  692289 */   // Label 11021: @692289
     /*  692289 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(692364), // Rule ID 19099 //
     /*  692294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  692297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  692305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  692308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  692311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  692333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692340 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  692343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692362 */     GIR_RootConstrainSelectedInstOperands,
     /*  692363 */     // GIR_Coverage, 19099,
     /*  692363 */     GIR_EraseRootFromParent_Done,
     /*  692364 */   // Label 11022: @692364
     /*  692364 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(692439), // Rule ID 19102 //
     /*  692369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  692372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  692380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  692383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  692386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  692408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692415 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  692418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692437 */     GIR_RootConstrainSelectedInstOperands,
     /*  692438 */     // GIR_Coverage, 19102,
     /*  692438 */     GIR_EraseRootFromParent_Done,
     /*  692439 */   // Label 11023: @692439
     /*  692439 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(692514), // Rule ID 19103 //
     /*  692444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  692447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  692455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  692458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  692461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  692483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  692493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692512 */     GIR_RootConstrainSelectedInstOperands,
     /*  692513 */     // GIR_Coverage, 19103,
     /*  692513 */     GIR_EraseRootFromParent_Done,
     /*  692514 */   // Label 11024: @692514
     /*  692514 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(692589), // Rule ID 19106 //
     /*  692519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  692522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  692568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692587 */     GIR_RootConstrainSelectedInstOperands,
     /*  692588 */     // GIR_Coverage, 19106,
     /*  692588 */     GIR_EraseRootFromParent_Done,
     /*  692589 */   // Label 11025: @692589
     /*  692589 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(692664), // Rule ID 19107 //
     /*  692594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  692597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692640 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  692643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692662 */     GIR_RootConstrainSelectedInstOperands,
     /*  692663 */     // GIR_Coverage, 19107,
     /*  692663 */     GIR_EraseRootFromParent_Done,
     /*  692664 */   // Label 11026: @692664
     /*  692664 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(692739), // Rule ID 19110 //
     /*  692669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  692672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692715 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  692718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692737 */     GIR_RootConstrainSelectedInstOperands,
     /*  692738 */     // GIR_Coverage, 19110,
     /*  692738 */     GIR_EraseRootFromParent_Done,
     /*  692739 */   // Label 11027: @692739
     /*  692739 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(692814), // Rule ID 19111 //
     /*  692744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  692747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692790 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  692793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692812 */     GIR_RootConstrainSelectedInstOperands,
     /*  692813 */     // GIR_Coverage, 19111,
     /*  692813 */     GIR_EraseRootFromParent_Done,
     /*  692814 */   // Label 11028: @692814
     /*  692814 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(692889), // Rule ID 19114 //
     /*  692819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  692822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692865 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  692868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692887 */     GIR_RootConstrainSelectedInstOperands,
     /*  692888 */     // GIR_Coverage, 19114,
     /*  692888 */     GIR_EraseRootFromParent_Done,
     /*  692889 */   // Label 11029: @692889
     /*  692889 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(692964), // Rule ID 19115 //
     /*  692894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  692897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  692914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  692933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692940 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  692943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692962 */     GIR_RootConstrainSelectedInstOperands,
     /*  692963 */     // GIR_Coverage, 19115,
     /*  692963 */     GIR_EraseRootFromParent_Done,
     /*  692964 */   // Label 11030: @692964
     /*  692964 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(693039), // Rule ID 19118 //
     /*  692969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  692972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  692977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  693018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693037 */     GIR_RootConstrainSelectedInstOperands,
     /*  693038 */     // GIR_Coverage, 19118,
     /*  693038 */     GIR_EraseRootFromParent_Done,
     /*  693039 */   // Label 11031: @693039
     /*  693039 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(693114), // Rule ID 19119 //
     /*  693044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  693047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  693055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  693058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  693061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  693093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693112 */     GIR_RootConstrainSelectedInstOperands,
     /*  693113 */     // GIR_Coverage, 19119,
     /*  693113 */     GIR_EraseRootFromParent_Done,
     /*  693114 */   // Label 11032: @693114
     /*  693114 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(693189), // Rule ID 19122 //
     /*  693119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  693122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693165 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  693168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693187 */     GIR_RootConstrainSelectedInstOperands,
     /*  693188 */     // GIR_Coverage, 19122,
     /*  693188 */     GIR_EraseRootFromParent_Done,
     /*  693189 */   // Label 11033: @693189
     /*  693189 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(693264), // Rule ID 19123 //
     /*  693194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  693197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  693243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693262 */     GIR_RootConstrainSelectedInstOperands,
     /*  693263 */     // GIR_Coverage, 19123,
     /*  693263 */     GIR_EraseRootFromParent_Done,
     /*  693264 */   // Label 11034: @693264
     /*  693264 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(693339), // Rule ID 19126 //
     /*  693269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  693272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693315 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  693318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693337 */     GIR_RootConstrainSelectedInstOperands,
     /*  693338 */     // GIR_Coverage, 19126,
     /*  693338 */     GIR_EraseRootFromParent_Done,
     /*  693339 */   // Label 11035: @693339
     /*  693339 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(693414), // Rule ID 19127 //
     /*  693344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  693347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  693383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  693393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693412 */     GIR_RootConstrainSelectedInstOperands,
     /*  693413 */     // GIR_Coverage, 19127,
     /*  693413 */     GIR_EraseRootFromParent_Done,
     /*  693414 */   // Label 11036: @693414
     /*  693414 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(693489), // Rule ID 19130 //
     /*  693419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  693422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  693468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693487 */     GIR_RootConstrainSelectedInstOperands,
     /*  693488 */     // GIR_Coverage, 19130,
     /*  693488 */     GIR_EraseRootFromParent_Done,
     /*  693489 */   // Label 11037: @693489
     /*  693489 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(693564), // Rule ID 19131 //
     /*  693494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  693497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693540 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  693543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693562 */     GIR_RootConstrainSelectedInstOperands,
     /*  693563 */     // GIR_Coverage, 19131,
     /*  693563 */     GIR_EraseRootFromParent_Done,
     /*  693564 */   // Label 11038: @693564
     /*  693564 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(693639), // Rule ID 19134 //
     /*  693569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  693572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693615 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  693618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693637 */     GIR_RootConstrainSelectedInstOperands,
     /*  693638 */     // GIR_Coverage, 19134,
     /*  693638 */     GIR_EraseRootFromParent_Done,
     /*  693639 */   // Label 11039: @693639
     /*  693639 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(693714), // Rule ID 19135 //
     /*  693644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  693647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  693693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693712 */     GIR_RootConstrainSelectedInstOperands,
     /*  693713 */     // GIR_Coverage, 19135,
     /*  693713 */     GIR_EraseRootFromParent_Done,
     /*  693714 */   // Label 11040: @693714
     /*  693714 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(693789), // Rule ID 19138 //
     /*  693719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  693722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693765 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  693768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693787 */     GIR_RootConstrainSelectedInstOperands,
     /*  693788 */     // GIR_Coverage, 19138,
     /*  693788 */     GIR_EraseRootFromParent_Done,
     /*  693789 */   // Label 11041: @693789
     /*  693789 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(693864), // Rule ID 19139 //
     /*  693794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  693797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  693802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  693833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  693843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693862 */     GIR_RootConstrainSelectedInstOperands,
     /*  693863 */     // GIR_Coverage, 19139,
     /*  693863 */     GIR_EraseRootFromParent_Done,
     /*  693864 */   // Label 11042: @693864
     /*  693864 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(693939), // Rule ID 19142 //
     /*  693869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  693872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  693877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  693889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  693918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693937 */     GIR_RootConstrainSelectedInstOperands,
     /*  693938 */     // GIR_Coverage, 19142,
     /*  693938 */     GIR_EraseRootFromParent_Done,
     /*  693939 */   // Label 11043: @693939
     /*  693939 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(694014), // Rule ID 19143 //
     /*  693944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  693947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  693952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  693964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693990 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  693993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694012 */     GIR_RootConstrainSelectedInstOperands,
     /*  694013 */     // GIR_Coverage, 19143,
     /*  694013 */     GIR_EraseRootFromParent_Done,
     /*  694014 */   // Label 11044: @694014
     /*  694014 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(694089), // Rule ID 19146 //
     /*  694019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  694022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694065 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  694068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694087 */     GIR_RootConstrainSelectedInstOperands,
     /*  694088 */     // GIR_Coverage, 19146,
     /*  694088 */     GIR_EraseRootFromParent_Done,
     /*  694089 */   // Label 11045: @694089
     /*  694089 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(694164), // Rule ID 19147 //
     /*  694094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  694097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  694143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694162 */     GIR_RootConstrainSelectedInstOperands,
     /*  694163 */     // GIR_Coverage, 19147,
     /*  694163 */     GIR_EraseRootFromParent_Done,
     /*  694164 */   // Label 11046: @694164
     /*  694164 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(694239), // Rule ID 19150 //
     /*  694169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  694172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694215 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  694218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694237 */     GIR_RootConstrainSelectedInstOperands,
     /*  694238 */     // GIR_Coverage, 19150,
     /*  694238 */     GIR_EraseRootFromParent_Done,
     /*  694239 */   // Label 11047: @694239
     /*  694239 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(694314), // Rule ID 19151 //
     /*  694244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  694247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  694293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694312 */     GIR_RootConstrainSelectedInstOperands,
     /*  694313 */     // GIR_Coverage, 19151,
     /*  694313 */     GIR_EraseRootFromParent_Done,
     /*  694314 */   // Label 11048: @694314
     /*  694314 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(694389), // Rule ID 19154 //
     /*  694319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  694322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694365 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  694368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694387 */     GIR_RootConstrainSelectedInstOperands,
     /*  694388 */     // GIR_Coverage, 19154,
     /*  694388 */     GIR_EraseRootFromParent_Done,
     /*  694389 */   // Label 11049: @694389
     /*  694389 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(694464), // Rule ID 19155 //
     /*  694394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  694397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  694443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694462 */     GIR_RootConstrainSelectedInstOperands,
     /*  694463 */     // GIR_Coverage, 19155,
     /*  694463 */     GIR_EraseRootFromParent_Done,
     /*  694464 */   // Label 11050: @694464
     /*  694464 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(694539), // Rule ID 19158 //
     /*  694469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  694472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  694489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694515 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  694518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694537 */     GIR_RootConstrainSelectedInstOperands,
     /*  694538 */     // GIR_Coverage, 19158,
     /*  694538 */     GIR_EraseRootFromParent_Done,
     /*  694539 */   // Label 11051: @694539
     /*  694539 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(694614), // Rule ID 19159 //
     /*  694544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  694547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  694564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694590 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  694593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694612 */     GIR_RootConstrainSelectedInstOperands,
     /*  694613 */     // GIR_Coverage, 19159,
     /*  694613 */     GIR_EraseRootFromParent_Done,
     /*  694614 */   // Label 11052: @694614
     /*  694614 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(694689), // Rule ID 19162 //
     /*  694619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  694622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  694639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694665 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  694665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  694668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694687 */     GIR_RootConstrainSelectedInstOperands,
     /*  694688 */     // GIR_Coverage, 19162,
     /*  694688 */     GIR_EraseRootFromParent_Done,
     /*  694689 */   // Label 11053: @694689
     /*  694689 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(694764), // Rule ID 19163 //
     /*  694694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  694697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  694714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  694740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  694743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694762 */     GIR_RootConstrainSelectedInstOperands,
     /*  694763 */     // GIR_Coverage, 19163,
     /*  694763 */     GIR_EraseRootFromParent_Done,
     /*  694764 */   // Label 11054: @694764
     /*  694764 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(694839), // Rule ID 19166 //
     /*  694769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  694772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  694780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  694783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  694786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  694789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694815 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  694818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694837 */     GIR_RootConstrainSelectedInstOperands,
     /*  694838 */     // GIR_Coverage, 19166,
     /*  694838 */     GIR_EraseRootFromParent_Done,
     /*  694839 */   // Label 11055: @694839
     /*  694839 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(694914), // Rule ID 19167 //
     /*  694844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  694847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  694855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  694858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  694861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  694864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  694893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694912 */     GIR_RootConstrainSelectedInstOperands,
     /*  694913 */     // GIR_Coverage, 19167,
     /*  694913 */     GIR_EraseRootFromParent_Done,
     /*  694914 */   // Label 11056: @694914
     /*  694914 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(694989), // Rule ID 19170 //
     /*  694919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  694922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  694927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  694930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  694933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  694936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  694939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694965 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  694968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694987 */     GIR_RootConstrainSelectedInstOperands,
     /*  694988 */     // GIR_Coverage, 19170,
     /*  694988 */     GIR_EraseRootFromParent_Done,
     /*  694989 */   // Label 11057: @694989
     /*  694989 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(695064), // Rule ID 19171 //
     /*  694994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  694997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  695014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  695043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695062 */     GIR_RootConstrainSelectedInstOperands,
     /*  695063 */     // GIR_Coverage, 19171,
     /*  695063 */     GIR_EraseRootFromParent_Done,
     /*  695064 */   // Label 11058: @695064
     /*  695064 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(695139), // Rule ID 19174 //
     /*  695069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  695072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  695089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695115 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  695118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695137 */     GIR_RootConstrainSelectedInstOperands,
     /*  695138 */     // GIR_Coverage, 19174,
     /*  695138 */     GIR_EraseRootFromParent_Done,
     /*  695139 */   // Label 11059: @695139
     /*  695139 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(695214), // Rule ID 19175 //
     /*  695144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  695147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  695164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695190 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  695193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695212 */     GIR_RootConstrainSelectedInstOperands,
     /*  695213 */     // GIR_Coverage, 19175,
     /*  695213 */     GIR_EraseRootFromParent_Done,
     /*  695214 */   // Label 11060: @695214
     /*  695214 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(695289), // Rule ID 19178 //
     /*  695219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  695222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  695239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695265 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  695268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695287 */     GIR_RootConstrainSelectedInstOperands,
     /*  695288 */     // GIR_Coverage, 19178,
     /*  695288 */     GIR_EraseRootFromParent_Done,
     /*  695289 */   // Label 11061: @695289
     /*  695289 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(695364), // Rule ID 19179 //
     /*  695294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  695297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  695314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  695343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695362 */     GIR_RootConstrainSelectedInstOperands,
     /*  695363 */     // GIR_Coverage, 19179,
     /*  695363 */     GIR_EraseRootFromParent_Done,
     /*  695364 */   // Label 11062: @695364
     /*  695364 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(695439), // Rule ID 19182 //
     /*  695369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  695372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  695389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695415 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  695418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695437 */     GIR_RootConstrainSelectedInstOperands,
     /*  695438 */     // GIR_Coverage, 19182,
     /*  695438 */     GIR_EraseRootFromParent_Done,
     /*  695439 */   // Label 11063: @695439
     /*  695439 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(695514), // Rule ID 19183 //
     /*  695444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  695447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  695464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695490 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  695493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695512 */     GIR_RootConstrainSelectedInstOperands,
     /*  695513 */     // GIR_Coverage, 19183,
     /*  695513 */     GIR_EraseRootFromParent_Done,
     /*  695514 */   // Label 11064: @695514
     /*  695514 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(695589), // Rule ID 19186 //
     /*  695519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  695522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  695530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  695533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  695536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  695539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695565 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  695568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695587 */     GIR_RootConstrainSelectedInstOperands,
     /*  695588 */     // GIR_Coverage, 19186,
     /*  695588 */     GIR_EraseRootFromParent_Done,
     /*  695589 */   // Label 11065: @695589
     /*  695589 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(695664), // Rule ID 19187 //
     /*  695594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  695597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  695605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  695608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  695611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  695614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  695643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695662 */     GIR_RootConstrainSelectedInstOperands,
     /*  695663 */     // GIR_Coverage, 19187,
     /*  695663 */     GIR_EraseRootFromParent_Done,
     /*  695664 */   // Label 11066: @695664
     /*  695664 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(695739), // Rule ID 19190 //
     /*  695669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  695672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  695680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  695683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  695686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  695689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  695718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695737 */     GIR_RootConstrainSelectedInstOperands,
     /*  695738 */     // GIR_Coverage, 19190,
     /*  695738 */     GIR_EraseRootFromParent_Done,
     /*  695739 */   // Label 11067: @695739
     /*  695739 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(695814), // Rule ID 19191 //
     /*  695744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  695747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  695755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  695758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  695761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  695764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  695793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695812 */     GIR_RootConstrainSelectedInstOperands,
     /*  695813 */     // GIR_Coverage, 19191,
     /*  695813 */     GIR_EraseRootFromParent_Done,
     /*  695814 */   // Label 11068: @695814
     /*  695814 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(695889), // Rule ID 19194 //
     /*  695819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  695822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  695830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  695833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  695836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  695839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  695868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695887 */     GIR_RootConstrainSelectedInstOperands,
     /*  695888 */     // GIR_Coverage, 19194,
     /*  695888 */     GIR_EraseRootFromParent_Done,
     /*  695889 */   // Label 11069: @695889
     /*  695889 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(695964), // Rule ID 19195 //
     /*  695894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  695897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  695905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  695908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  695911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  695914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  695943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695962 */     GIR_RootConstrainSelectedInstOperands,
     /*  695963 */     // GIR_Coverage, 19195,
     /*  695963 */     GIR_EraseRootFromParent_Done,
     /*  695964 */   // Label 11070: @695964
     /*  695964 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(696039), // Rule ID 19198 //
     /*  695969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  695972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  695977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  695980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  695983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  695986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  695989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696015 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  696018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696037 */     GIR_RootConstrainSelectedInstOperands,
     /*  696038 */     // GIR_Coverage, 19198,
     /*  696038 */     GIR_EraseRootFromParent_Done,
     /*  696039 */   // Label 11071: @696039
     /*  696039 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(696114), // Rule ID 19199 //
     /*  696044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  696047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  696064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  696093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696112 */     GIR_RootConstrainSelectedInstOperands,
     /*  696113 */     // GIR_Coverage, 19199,
     /*  696113 */     GIR_EraseRootFromParent_Done,
     /*  696114 */   // Label 11072: @696114
     /*  696114 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(696189), // Rule ID 19202 //
     /*  696119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  696122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  696130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  696133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  696136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696165 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  696168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696187 */     GIR_RootConstrainSelectedInstOperands,
     /*  696188 */     // GIR_Coverage, 19202,
     /*  696188 */     GIR_EraseRootFromParent_Done,
     /*  696189 */   // Label 11073: @696189
     /*  696189 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(696264), // Rule ID 19203 //
     /*  696194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  696197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  696205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  696208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  696211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696240 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  696243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696262 */     GIR_RootConstrainSelectedInstOperands,
     /*  696263 */     // GIR_Coverage, 19203,
     /*  696263 */     GIR_EraseRootFromParent_Done,
     /*  696264 */   // Label 11074: @696264
     /*  696264 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(696339), // Rule ID 19206 //
     /*  696269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  696272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  696280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  696283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  696286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696315 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  696318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696337 */     GIR_RootConstrainSelectedInstOperands,
     /*  696338 */     // GIR_Coverage, 19206,
     /*  696338 */     GIR_EraseRootFromParent_Done,
     /*  696339 */   // Label 11075: @696339
     /*  696339 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(696414), // Rule ID 19207 //
     /*  696344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  696347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  696355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  696358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  696361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696390 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  696393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696412 */     GIR_RootConstrainSelectedInstOperands,
     /*  696413 */     // GIR_Coverage, 19207,
     /*  696413 */     GIR_EraseRootFromParent_Done,
     /*  696414 */   // Label 11076: @696414
     /*  696414 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(696489), // Rule ID 19210 //
     /*  696419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  696422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  696430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  696433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  696436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  696458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696465 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  696468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696487 */     GIR_RootConstrainSelectedInstOperands,
     /*  696488 */     // GIR_Coverage, 19210,
     /*  696488 */     GIR_EraseRootFromParent_Done,
     /*  696489 */   // Label 11077: @696489
     /*  696489 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(696564), // Rule ID 19211 //
     /*  696494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  696497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  696505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  696508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  696511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  696533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696540 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  696543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696562 */     GIR_RootConstrainSelectedInstOperands,
     /*  696563 */     // GIR_Coverage, 19211,
     /*  696563 */     GIR_EraseRootFromParent_Done,
     /*  696564 */   // Label 11078: @696564
     /*  696564 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(696639), // Rule ID 19214 //
     /*  696569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  696572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  696580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  696583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  696586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696615 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  696618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696637 */     GIR_RootConstrainSelectedInstOperands,
     /*  696638 */     // GIR_Coverage, 19214,
     /*  696638 */     GIR_EraseRootFromParent_Done,
     /*  696639 */   // Label 11079: @696639
     /*  696639 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(696714), // Rule ID 19215 //
     /*  696644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  696647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  696655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  696658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  696661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  696664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  696683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10900:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  696693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696712 */     GIR_RootConstrainSelectedInstOperands,
     /*  696713 */     // GIR_Coverage, 19215,
     /*  696713 */     GIR_EraseRootFromParent_Done,
     /*  696714 */   // Label 11080: @696714
     /*  696714 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(696789), // Rule ID 19218 //
     /*  696719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  696722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  696730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  696733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  696736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  696758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696765 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  696768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696787 */     GIR_RootConstrainSelectedInstOperands,
     /*  696788 */     // GIR_Coverage, 19218,
     /*  696788 */     GIR_EraseRootFromParent_Done,
     /*  696789 */   // Label 11081: @696789
     /*  696789 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(696864), // Rule ID 19219 //
     /*  696794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  696797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  696805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  696808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  696811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  696833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  696843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696862 */     GIR_RootConstrainSelectedInstOperands,
     /*  696863 */     // GIR_Coverage, 19219,
     /*  696863 */     GIR_EraseRootFromParent_Done,
     /*  696864 */   // Label 11082: @696864
     /*  696864 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(696939), // Rule ID 19222 //
     /*  696869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  696872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  696880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  696883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  696886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  696908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696915 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  696918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696937 */     GIR_RootConstrainSelectedInstOperands,
     /*  696938 */     // GIR_Coverage, 19222,
     /*  696938 */     GIR_EraseRootFromParent_Done,
     /*  696939 */   // Label 11083: @696939
     /*  696939 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(697014), // Rule ID 19223 //
     /*  696944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  696947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  696952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  696955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  696958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  696961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  696983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696990 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  696993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697012 */     GIR_RootConstrainSelectedInstOperands,
     /*  697013 */     // GIR_Coverage, 19223,
     /*  697013 */     GIR_EraseRootFromParent_Done,
     /*  697014 */   // Label 11084: @697014
     /*  697014 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(697089), // Rule ID 19226 //
     /*  697019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  697022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  697030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  697033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  697036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  697068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697087 */     GIR_RootConstrainSelectedInstOperands,
     /*  697088 */     // GIR_Coverage, 19226,
     /*  697088 */     GIR_EraseRootFromParent_Done,
     /*  697089 */   // Label 11085: @697089
     /*  697089 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(697164), // Rule ID 19227 //
     /*  697094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  697097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  697105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  697108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  697111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697140 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  697143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697162 */     GIR_RootConstrainSelectedInstOperands,
     /*  697163 */     // GIR_Coverage, 19227,
     /*  697163 */     GIR_EraseRootFromParent_Done,
     /*  697164 */   // Label 11086: @697164
     /*  697164 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(697239), // Rule ID 19230 //
     /*  697169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  697172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  697180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  697183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  697186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697215 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  697218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697237 */     GIR_RootConstrainSelectedInstOperands,
     /*  697238 */     // GIR_Coverage, 19230,
     /*  697238 */     GIR_EraseRootFromParent_Done,
     /*  697239 */   // Label 11087: @697239
     /*  697239 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(697314), // Rule ID 19231 //
     /*  697244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  697247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  697255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  697258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  697261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  697293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697312 */     GIR_RootConstrainSelectedInstOperands,
     /*  697313 */     // GIR_Coverage, 19231,
     /*  697313 */     GIR_EraseRootFromParent_Done,
     /*  697314 */   // Label 11088: @697314
     /*  697314 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(697389), // Rule ID 19234 //
     /*  697319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  697322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  697330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  697333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  697336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697365 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  697368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697387 */     GIR_RootConstrainSelectedInstOperands,
     /*  697388 */     // GIR_Coverage, 19234,
     /*  697388 */     GIR_EraseRootFromParent_Done,
     /*  697389 */   // Label 11089: @697389
     /*  697389 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(697464), // Rule ID 19235 //
     /*  697394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  697397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  697405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  697408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  697411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  697414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  697433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  697443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697462 */     GIR_RootConstrainSelectedInstOperands,
     /*  697463 */     // GIR_Coverage, 19235,
     /*  697463 */     GIR_EraseRootFromParent_Done,
     /*  697464 */   // Label 11090: @697464
     /*  697464 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(697539), // Rule ID 19238 //
     /*  697469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  697472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  697480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  697483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  697486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697515 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  697518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697537 */     GIR_RootConstrainSelectedInstOperands,
     /*  697538 */     // GIR_Coverage, 19238,
     /*  697538 */     GIR_EraseRootFromParent_Done,
     /*  697539 */   // Label 11091: @697539
     /*  697539 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(697614), // Rule ID 19239 //
     /*  697544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  697547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  697555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  697558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  697561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  697593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697612 */     GIR_RootConstrainSelectedInstOperands,
     /*  697613 */     // GIR_Coverage, 19239,
     /*  697613 */     GIR_EraseRootFromParent_Done,
     /*  697614 */   // Label 11092: @697614
     /*  697614 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(697689), // Rule ID 19242 //
     /*  697619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  697622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  697630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  697633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  697636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697665 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  697668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697687 */     GIR_RootConstrainSelectedInstOperands,
     /*  697688 */     // GIR_Coverage, 19242,
     /*  697688 */     GIR_EraseRootFromParent_Done,
     /*  697689 */   // Label 11093: @697689
     /*  697689 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(697764), // Rule ID 19243 //
     /*  697694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  697697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  697705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  697708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  697711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697740 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  697743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697762 */     GIR_RootConstrainSelectedInstOperands,
     /*  697763 */     // GIR_Coverage, 19243,
     /*  697763 */     GIR_EraseRootFromParent_Done,
     /*  697764 */   // Label 11094: @697764
     /*  697764 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(697839), // Rule ID 19246 //
     /*  697769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  697772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  697780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  697783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  697786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697815 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  697818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697837 */     GIR_RootConstrainSelectedInstOperands,
     /*  697838 */     // GIR_Coverage, 19246,
     /*  697838 */     GIR_EraseRootFromParent_Done,
     /*  697839 */   // Label 11095: @697839
     /*  697839 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(697914), // Rule ID 19247 //
     /*  697844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  697847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  697855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  697858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  697861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  697883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697890 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  697893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697912 */     GIR_RootConstrainSelectedInstOperands,
     /*  697913 */     // GIR_Coverage, 19247,
     /*  697913 */     GIR_EraseRootFromParent_Done,
     /*  697914 */   // Label 11096: @697914
     /*  697914 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(697989), // Rule ID 19250 //
     /*  697919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  697922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  697927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  697930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  697933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  697936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  697958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697965 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  697965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  697968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697987 */     GIR_RootConstrainSelectedInstOperands,
     /*  697988 */     // GIR_Coverage, 19250,
     /*  697988 */     GIR_EraseRootFromParent_Done,
     /*  697989 */   // Label 11097: @697989
     /*  697989 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(698064), // Rule ID 19251 //
     /*  697994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  697997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  698002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  698005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  698008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  698011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  698033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  698040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  698043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698062 */     GIR_RootConstrainSelectedInstOperands,
     /*  698063 */     // GIR_Coverage, 19251,
     /*  698063 */     GIR_EraseRootFromParent_Done,
     /*  698064 */   // Label 11098: @698064
     /*  698064 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(698139), // Rule ID 19254 //
     /*  698069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  698072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  698077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  698080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  698083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  698086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  698108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698115 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  698115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  698118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698137 */     GIR_RootConstrainSelectedInstOperands,
     /*  698138 */     // GIR_Coverage, 19254,
     /*  698138 */     GIR_EraseRootFromParent_Done,
     /*  698139 */   // Label 11099: @698139
     /*  698139 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(698214), // Rule ID 19255 //
     /*  698144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  698147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  698152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  698155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  698158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  698161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  698183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698190 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  698190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  698193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698212 */     GIR_RootConstrainSelectedInstOperands,
     /*  698213 */     // GIR_Coverage, 19255,
     /*  698213 */     GIR_EraseRootFromParent_Done,
     /*  698214 */   // Label 11100: @698214
     /*  698214 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(698289), // Rule ID 19258 //
     /*  698219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  698222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  698227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  698230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  698233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  698236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  698258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698265 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  698265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  698268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698287 */     GIR_RootConstrainSelectedInstOperands,
     /*  698288 */     // GIR_Coverage, 19258,
     /*  698288 */     GIR_EraseRootFromParent_Done,
     /*  698289 */   // Label 11101: @698289
     /*  698289 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(698364), // Rule ID 19259 //
     /*  698294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  698297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  698302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  698305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  698308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  698311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  698333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698340 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  698340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  698343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698362 */     GIR_RootConstrainSelectedInstOperands,
     /*  698363 */     // GIR_Coverage, 19259,
     /*  698363 */     GIR_EraseRootFromParent_Done,
     /*  698364 */   // Label 11102: @698364
     /*  698364 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(698439), // Rule ID 19262 //
     /*  698369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  698372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  698380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  698383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  698386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  698389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698415 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  698418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698437 */     GIR_RootConstrainSelectedInstOperands,
     /*  698438 */     // GIR_Coverage, 19262,
     /*  698438 */     GIR_EraseRootFromParent_Done,
     /*  698439 */   // Label 11103: @698439
     /*  698439 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(698514), // Rule ID 19263 //
     /*  698444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  698447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  698455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  698458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  698461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  698464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698490 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  698493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698512 */     GIR_RootConstrainSelectedInstOperands,
     /*  698513 */     // GIR_Coverage, 19263,
     /*  698513 */     GIR_EraseRootFromParent_Done,
     /*  698514 */   // Label 11104: @698514
     /*  698514 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(698589), // Rule ID 19266 //
     /*  698519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  698522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  698530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  698533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  698536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  698539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  698568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698587 */     GIR_RootConstrainSelectedInstOperands,
     /*  698588 */     // GIR_Coverage, 19266,
     /*  698588 */     GIR_EraseRootFromParent_Done,
     /*  698589 */   // Label 11105: @698589
     /*  698589 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(698664), // Rule ID 19267 //
     /*  698594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  698597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  698605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  698608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  698611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  698614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  698643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698662 */     GIR_RootConstrainSelectedInstOperands,
     /*  698663 */     // GIR_Coverage, 19267,
     /*  698663 */     GIR_EraseRootFromParent_Done,
     /*  698664 */   // Label 11106: @698664
     /*  698664 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(698739), // Rule ID 19270 //
     /*  698669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  698672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  698680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  698683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  698686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  698689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698715 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  698718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698737 */     GIR_RootConstrainSelectedInstOperands,
     /*  698738 */     // GIR_Coverage, 19270,
     /*  698738 */     GIR_EraseRootFromParent_Done,
     /*  698739 */   // Label 11107: @698739
     /*  698739 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(698814), // Rule ID 19271 //
     /*  698744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  698747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  698755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  698758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  698761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  698764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  698793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698812 */     GIR_RootConstrainSelectedInstOperands,
     /*  698813 */     // GIR_Coverage, 19271,
     /*  698813 */     GIR_EraseRootFromParent_Done,
     /*  698814 */   // Label 11108: @698814
     /*  698814 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(698889), // Rule ID 19274 //
     /*  698819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  698822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  698868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698887 */     GIR_RootConstrainSelectedInstOperands,
     /*  698888 */     // GIR_Coverage, 19274,
     /*  698888 */     GIR_EraseRootFromParent_Done,
     /*  698889 */   // Label 11109: @698889
     /*  698889 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(698964), // Rule ID 19275 //
     /*  698894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  698897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  698943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698962 */     GIR_RootConstrainSelectedInstOperands,
     /*  698963 */     // GIR_Coverage, 19275,
     /*  698963 */     GIR_EraseRootFromParent_Done,
     /*  698964 */   // Label 11110: @698964
     /*  698964 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(699039), // Rule ID 19278 //
     /*  698969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  698972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  698977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  698989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  699018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699037 */     GIR_RootConstrainSelectedInstOperands,
     /*  699038 */     // GIR_Coverage, 19278,
     /*  699038 */     GIR_EraseRootFromParent_Done,
     /*  699039 */   // Label 11111: @699039
     /*  699039 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(699114), // Rule ID 19279 //
     /*  699044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  699047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  699055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  699058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  699061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  699064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  699093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699112 */     GIR_RootConstrainSelectedInstOperands,
     /*  699113 */     // GIR_Coverage, 19279,
     /*  699113 */     GIR_EraseRootFromParent_Done,
     /*  699114 */   // Label 11112: @699114
     /*  699114 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(699189), // Rule ID 19282 //
     /*  699119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  699122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  699130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  699133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  699136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  699139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699165 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  699165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  699168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  699184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699187 */     GIR_RootConstrainSelectedInstOperands,
     /*  699188 */     // GIR_Coverage, 19282,
     /*  699188 */     GIR_EraseRootFromParent_Done,
     /*  699189 */   // Label 11113: @699189
     /*  699189 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(699264), // Rule ID 19283 //
     /*  699194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  699197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  699205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  699208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  699211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  699214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  699240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  699243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  699259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699262 */     GIR_RootConstrainSelectedInstOperands,
     /*  699263 */     // GIR_Coverage, 19283,
     /*  699263 */     GIR_EraseRootFromParent_Done,
     /*  699264 */   // Label 11114: @699264
     /*  699264 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(699339), // Rule ID 19286 //
     /*  699269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  699272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  699289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  699318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699337 */     GIR_RootConstrainSelectedInstOperands,
     /*  699338 */     // GIR_Coverage, 19286,
     /*  699338 */     GIR_EraseRootFromParent_Done,
     /*  699339 */   // Label 11115: @699339
     /*  699339 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(699414), // Rule ID 19287 //
     /*  699344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  699347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  699364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699390 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  699393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699412 */     GIR_RootConstrainSelectedInstOperands,
     /*  699413 */     // GIR_Coverage, 19287,
     /*  699413 */     GIR_EraseRootFromParent_Done,
     /*  699414 */   // Label 11116: @699414
     /*  699414 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(699489), // Rule ID 19290 //
     /*  699419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  699422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699465 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  699468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699487 */     GIR_RootConstrainSelectedInstOperands,
     /*  699488 */     // GIR_Coverage, 19290,
     /*  699488 */     GIR_EraseRootFromParent_Done,
     /*  699489 */   // Label 11117: @699489
     /*  699489 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(699564), // Rule ID 19291 //
     /*  699494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  699497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  699543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699562 */     GIR_RootConstrainSelectedInstOperands,
     /*  699563 */     // GIR_Coverage, 19291,
     /*  699563 */     GIR_EraseRootFromParent_Done,
     /*  699564 */   // Label 11118: @699564
     /*  699564 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(699639), // Rule ID 19294 //
     /*  699569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  699572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699615 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  699618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699637 */     GIR_RootConstrainSelectedInstOperands,
     /*  699638 */     // GIR_Coverage, 19294,
     /*  699638 */     GIR_EraseRootFromParent_Done,
     /*  699639 */   // Label 11119: @699639
     /*  699639 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(699714), // Rule ID 19295 //
     /*  699644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  699647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  699693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699712 */     GIR_RootConstrainSelectedInstOperands,
     /*  699713 */     // GIR_Coverage, 19295,
     /*  699713 */     GIR_EraseRootFromParent_Done,
     /*  699714 */   // Label 11120: @699714
     /*  699714 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(699789), // Rule ID 19298 //
     /*  699719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  699722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  699768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699787 */     GIR_RootConstrainSelectedInstOperands,
     /*  699788 */     // GIR_Coverage, 19298,
     /*  699788 */     GIR_EraseRootFromParent_Done,
     /*  699789 */   // Label 11121: @699789
     /*  699789 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(699864), // Rule ID 19299 //
     /*  699794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  699797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  699843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699862 */     GIR_RootConstrainSelectedInstOperands,
     /*  699863 */     // GIR_Coverage, 19299,
     /*  699863 */     GIR_EraseRootFromParent_Done,
     /*  699864 */   // Label 11122: @699864
     /*  699864 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(699939), // Rule ID 19302 //
     /*  699869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  699872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699915 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  699918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699937 */     GIR_RootConstrainSelectedInstOperands,
     /*  699938 */     // GIR_Coverage, 19302,
     /*  699938 */     GIR_EraseRootFromParent_Done,
     /*  699939 */   // Label 11123: @699939
     /*  699939 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(700014), // Rule ID 19303 //
     /*  699944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  699947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  699952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  699993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700012 */     GIR_RootConstrainSelectedInstOperands,
     /*  700013 */     // GIR_Coverage, 19303,
     /*  700013 */     GIR_EraseRootFromParent_Done,
     /*  700014 */   // Label 11124: @700014
     /*  700014 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(700089), // Rule ID 19306 //
     /*  700019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  700022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  700030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  700033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  700036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  700039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  700068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700087 */     GIR_RootConstrainSelectedInstOperands,
     /*  700088 */     // GIR_Coverage, 19306,
     /*  700088 */     GIR_EraseRootFromParent_Done,
     /*  700089 */   // Label 11125: @700089
     /*  700089 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(700164), // Rule ID 19307 //
     /*  700094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  700097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  700105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  700108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  700111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  700114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  700143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700162 */     GIR_RootConstrainSelectedInstOperands,
     /*  700163 */     // GIR_Coverage, 19307,
     /*  700163 */     GIR_EraseRootFromParent_Done,
     /*  700164 */   // Label 11126: @700164
     /*  700164 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(700239), // Rule ID 19310 //
     /*  700169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  700172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  700189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  700218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700237 */     GIR_RootConstrainSelectedInstOperands,
     /*  700238 */     // GIR_Coverage, 19310,
     /*  700238 */     GIR_EraseRootFromParent_Done,
     /*  700239 */   // Label 11127: @700239
     /*  700239 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(700314), // Rule ID 19311 //
     /*  700244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  700247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  700264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  700293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700312 */     GIR_RootConstrainSelectedInstOperands,
     /*  700313 */     // GIR_Coverage, 19311,
     /*  700313 */     GIR_EraseRootFromParent_Done,
     /*  700314 */   // Label 11128: @700314
     /*  700314 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(700389), // Rule ID 19314 //
     /*  700319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  700322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  700339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700365 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  700368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700387 */     GIR_RootConstrainSelectedInstOperands,
     /*  700388 */     // GIR_Coverage, 19314,
     /*  700388 */     GIR_EraseRootFromParent_Done,
     /*  700389 */   // Label 11129: @700389
     /*  700389 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(700464), // Rule ID 19315 //
     /*  700394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  700397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  700414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  700443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700462 */     GIR_RootConstrainSelectedInstOperands,
     /*  700463 */     // GIR_Coverage, 19315,
     /*  700463 */     GIR_EraseRootFromParent_Done,
     /*  700464 */   // Label 11130: @700464
     /*  700464 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(700539), // Rule ID 19318 //
     /*  700469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  700472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  700489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  700518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700537 */     GIR_RootConstrainSelectedInstOperands,
     /*  700538 */     // GIR_Coverage, 19318,
     /*  700538 */     GIR_EraseRootFromParent_Done,
     /*  700539 */   // Label 11131: @700539
     /*  700539 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(700614), // Rule ID 19319 //
     /*  700544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  700547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  700564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  700593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700612 */     GIR_RootConstrainSelectedInstOperands,
     /*  700613 */     // GIR_Coverage, 19319,
     /*  700613 */     GIR_EraseRootFromParent_Done,
     /*  700614 */   // Label 11132: @700614
     /*  700614 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(700689), // Rule ID 19322 //
     /*  700619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  700622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  700639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  700658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700665 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  700668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700687 */     GIR_RootConstrainSelectedInstOperands,
     /*  700688 */     // GIR_Coverage, 19322,
     /*  700688 */     GIR_EraseRootFromParent_Done,
     /*  700689 */   // Label 11133: @700689
     /*  700689 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(700764), // Rule ID 19323 //
     /*  700694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  700697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  700714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  700733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700740 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  700743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700762 */     GIR_RootConstrainSelectedInstOperands,
     /*  700763 */     // GIR_Coverage, 19323,
     /*  700763 */     GIR_EraseRootFromParent_Done,
     /*  700764 */   // Label 11134: @700764
     /*  700764 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(700839), // Rule ID 19326 //
     /*  700769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  700772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  700789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  700808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  700818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700837 */     GIR_RootConstrainSelectedInstOperands,
     /*  700838 */     // GIR_Coverage, 19326,
     /*  700838 */     GIR_EraseRootFromParent_Done,
     /*  700839 */   // Label 11135: @700839
     /*  700839 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(700914), // Rule ID 19327 //
     /*  700844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  700847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  700864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  700883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  700893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700912 */     GIR_RootConstrainSelectedInstOperands,
     /*  700913 */     // GIR_Coverage, 19327,
     /*  700913 */     GIR_EraseRootFromParent_Done,
     /*  700914 */   // Label 11136: @700914
     /*  700914 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(700989), // Rule ID 19330 //
     /*  700919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  700922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  700927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  700958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700965 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  700968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700987 */     GIR_RootConstrainSelectedInstOperands,
     /*  700988 */     // GIR_Coverage, 19330,
     /*  700988 */     GIR_EraseRootFromParent_Done,
     /*  700989 */   // Label 11137: @700989
     /*  700989 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(701064), // Rule ID 19331 //
     /*  700994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  700997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  701005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  701008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  701011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  701033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701040 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  701043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701062 */     GIR_RootConstrainSelectedInstOperands,
     /*  701063 */     // GIR_Coverage, 19331,
     /*  701063 */     GIR_EraseRootFromParent_Done,
     /*  701064 */   // Label 11138: @701064
     /*  701064 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(701139), // Rule ID 19334 //
     /*  701069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  701072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  701118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701137 */     GIR_RootConstrainSelectedInstOperands,
     /*  701138 */     // GIR_Coverage, 19334,
     /*  701138 */     GIR_EraseRootFromParent_Done,
     /*  701139 */   // Label 11139: @701139
     /*  701139 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(701214), // Rule ID 19335 //
     /*  701144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  701147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10956:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  701193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701212 */     GIR_RootConstrainSelectedInstOperands,
     /*  701213 */     // GIR_Coverage, 19335,
     /*  701213 */     GIR_EraseRootFromParent_Done,
     /*  701214 */   // Label 11140: @701214
     /*  701214 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(701289), // Rule ID 19338 //
     /*  701219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  701222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  701258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  701268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701287 */     GIR_RootConstrainSelectedInstOperands,
     /*  701288 */     // GIR_Coverage, 19338,
     /*  701288 */     GIR_EraseRootFromParent_Done,
     /*  701289 */   // Label 11141: @701289
     /*  701289 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(701364), // Rule ID 19339 //
     /*  701294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  701297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  701333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701340 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10956:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  701343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701362 */     GIR_RootConstrainSelectedInstOperands,
     /*  701363 */     // GIR_Coverage, 19339,
     /*  701363 */     GIR_EraseRootFromParent_Done,
     /*  701364 */   // Label 11142: @701364
     /*  701364 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(701439), // Rule ID 19342 //
     /*  701369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  701372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  701380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  701383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  701386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  701408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701415 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  701415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  701418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  701434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701437 */     GIR_RootConstrainSelectedInstOperands,
     /*  701438 */     // GIR_Coverage, 19342,
     /*  701438 */     GIR_EraseRootFromParent_Done,
     /*  701439 */   // Label 11143: @701439
     /*  701439 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(701514), // Rule ID 19343 //
     /*  701444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  701447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  701455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  701458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  701461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  701483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10956:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  701490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  701493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  701509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701512 */     GIR_RootConstrainSelectedInstOperands,
     /*  701513 */     // GIR_Coverage, 19343,
     /*  701513 */     GIR_EraseRootFromParent_Done,
     /*  701514 */   // Label 11144: @701514
     /*  701514 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(701589), // Rule ID 19346 //
     /*  701519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  701522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  701568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701587 */     GIR_RootConstrainSelectedInstOperands,
     /*  701588 */     // GIR_Coverage, 19346,
     /*  701588 */     GIR_EraseRootFromParent_Done,
     /*  701589 */   // Label 11145: @701589
     /*  701589 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(701664), // Rule ID 19347 //
     /*  701594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  701597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701640 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  701643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701662 */     GIR_RootConstrainSelectedInstOperands,
     /*  701663 */     // GIR_Coverage, 19347,
     /*  701663 */     GIR_EraseRootFromParent_Done,
     /*  701664 */   // Label 11146: @701664
     /*  701664 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(701739), // Rule ID 19350 //
     /*  701669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  701672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701715 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  701718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701737 */     GIR_RootConstrainSelectedInstOperands,
     /*  701738 */     // GIR_Coverage, 19350,
     /*  701738 */     GIR_EraseRootFromParent_Done,
     /*  701739 */   // Label 11147: @701739
     /*  701739 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(701814), // Rule ID 19351 //
     /*  701744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  701747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701790 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  701793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701812 */     GIR_RootConstrainSelectedInstOperands,
     /*  701813 */     // GIR_Coverage, 19351,
     /*  701813 */     GIR_EraseRootFromParent_Done,
     /*  701814 */   // Label 11148: @701814
     /*  701814 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(701889), // Rule ID 19354 //
     /*  701819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  701822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701865 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  701868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701887 */     GIR_RootConstrainSelectedInstOperands,
     /*  701888 */     // GIR_Coverage, 19354,
     /*  701888 */     GIR_EraseRootFromParent_Done,
     /*  701889 */   // Label 11149: @701889
     /*  701889 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(701964), // Rule ID 19355 //
     /*  701894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  701897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  701914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  701933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701940 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  701943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701962 */     GIR_RootConstrainSelectedInstOperands,
     /*  701963 */     // GIR_Coverage, 19355,
     /*  701963 */     GIR_EraseRootFromParent_Done,
     /*  701964 */   // Label 11150: @701964
     /*  701964 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(702039), // Rule ID 19358 //
     /*  701969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  701972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  701977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  702018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702037 */     GIR_RootConstrainSelectedInstOperands,
     /*  702038 */     // GIR_Coverage, 19358,
     /*  702038 */     GIR_EraseRootFromParent_Done,
     /*  702039 */   // Label 11151: @702039
     /*  702039 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(702114), // Rule ID 19359 //
     /*  702044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  702047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  702093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702112 */     GIR_RootConstrainSelectedInstOperands,
     /*  702113 */     // GIR_Coverage, 19359,
     /*  702113 */     GIR_EraseRootFromParent_Done,
     /*  702114 */   // Label 11152: @702114
     /*  702114 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(702189), // Rule ID 19362 //
     /*  702119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  702122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702165 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  702168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702187 */     GIR_RootConstrainSelectedInstOperands,
     /*  702188 */     // GIR_Coverage, 19362,
     /*  702188 */     GIR_EraseRootFromParent_Done,
     /*  702189 */   // Label 11153: @702189
     /*  702189 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(702264), // Rule ID 19363 //
     /*  702194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  702197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  702243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702262 */     GIR_RootConstrainSelectedInstOperands,
     /*  702263 */     // GIR_Coverage, 19363,
     /*  702263 */     GIR_EraseRootFromParent_Done,
     /*  702264 */   // Label 11154: @702264
     /*  702264 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(702339), // Rule ID 19366 //
     /*  702269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  702272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702315 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  702318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702337 */     GIR_RootConstrainSelectedInstOperands,
     /*  702338 */     // GIR_Coverage, 19366,
     /*  702338 */     GIR_EraseRootFromParent_Done,
     /*  702339 */   // Label 11155: @702339
     /*  702339 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(702414), // Rule ID 19367 //
     /*  702344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  702347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  702383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  702393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702412 */     GIR_RootConstrainSelectedInstOperands,
     /*  702413 */     // GIR_Coverage, 19367,
     /*  702413 */     GIR_EraseRootFromParent_Done,
     /*  702414 */   // Label 11156: @702414
     /*  702414 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(702489), // Rule ID 19370 //
     /*  702419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  702422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  702430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  702433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  702436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  702465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  702468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702487 */     GIR_RootConstrainSelectedInstOperands,
     /*  702488 */     // GIR_Coverage, 19370,
     /*  702488 */     GIR_EraseRootFromParent_Done,
     /*  702489 */   // Label 11157: @702489
     /*  702489 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(702564), // Rule ID 19371 //
     /*  702494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  702497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  702505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  702508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  702511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702540 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10956:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  702540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  702543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702562 */     GIR_RootConstrainSelectedInstOperands,
     /*  702563 */     // GIR_Coverage, 19371,
     /*  702563 */     GIR_EraseRootFromParent_Done,
     /*  702564 */   // Label 11158: @702564
     /*  702564 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(702639), // Rule ID 19374 //
     /*  702569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  702572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  702580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  702583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  702586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702615 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  702615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  702618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702637 */     GIR_RootConstrainSelectedInstOperands,
     /*  702638 */     // GIR_Coverage, 19374,
     /*  702638 */     GIR_EraseRootFromParent_Done,
     /*  702639 */   // Label 11159: @702639
     /*  702639 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(702714), // Rule ID 19375 //
     /*  702644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  702647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  702655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  702658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  702661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10956:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  702690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  702693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702712 */     GIR_RootConstrainSelectedInstOperands,
     /*  702713 */     // GIR_Coverage, 19375,
     /*  702713 */     GIR_EraseRootFromParent_Done,
     /*  702714 */   // Label 11160: @702714
     /*  702714 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(702789), // Rule ID 19378 //
     /*  702719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  702722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  702730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  702733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  702736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702765 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  702765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  702768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702787 */     GIR_RootConstrainSelectedInstOperands,
     /*  702788 */     // GIR_Coverage, 19378,
     /*  702788 */     GIR_EraseRootFromParent_Done,
     /*  702789 */   // Label 11161: @702789
     /*  702789 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(702864), // Rule ID 19379 //
     /*  702794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  702797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  702802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  702805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  702808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  702811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  702833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10956:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  702840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  702843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  702859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702862 */     GIR_RootConstrainSelectedInstOperands,
     /*  702863 */     // GIR_Coverage, 19379,
     /*  702863 */     GIR_EraseRootFromParent_Done,
     /*  702864 */   // Label 11162: @702864
     /*  702864 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(702939), // Rule ID 19382 //
     /*  702869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  702872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  702877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  702918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702937 */     GIR_RootConstrainSelectedInstOperands,
     /*  702938 */     // GIR_Coverage, 19382,
     /*  702938 */     GIR_EraseRootFromParent_Done,
     /*  702939 */   // Label 11163: @702939
     /*  702939 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(703014), // Rule ID 19383 //
     /*  702944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  702947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  702952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702990 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  702993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703012 */     GIR_RootConstrainSelectedInstOperands,
     /*  703013 */     // GIR_Coverage, 19383,
     /*  703013 */     GIR_EraseRootFromParent_Done,
     /*  703014 */   // Label 11164: @703014
     /*  703014 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(703089), // Rule ID 19386 //
     /*  703019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  703022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703065 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  703068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703087 */     GIR_RootConstrainSelectedInstOperands,
     /*  703088 */     // GIR_Coverage, 19386,
     /*  703088 */     GIR_EraseRootFromParent_Done,
     /*  703089 */   // Label 11165: @703089
     /*  703089 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(703164), // Rule ID 19387 //
     /*  703094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  703097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  703143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703162 */     GIR_RootConstrainSelectedInstOperands,
     /*  703163 */     // GIR_Coverage, 19387,
     /*  703163 */     GIR_EraseRootFromParent_Done,
     /*  703164 */   // Label 11166: @703164
     /*  703164 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(703239), // Rule ID 19390 //
     /*  703169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  703172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703215 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  703218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703237 */     GIR_RootConstrainSelectedInstOperands,
     /*  703238 */     // GIR_Coverage, 19390,
     /*  703238 */     GIR_EraseRootFromParent_Done,
     /*  703239 */   // Label 11167: @703239
     /*  703239 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(703314), // Rule ID 19391 //
     /*  703244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  703247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  703293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703312 */     GIR_RootConstrainSelectedInstOperands,
     /*  703313 */     // GIR_Coverage, 19391,
     /*  703313 */     GIR_EraseRootFromParent_Done,
     /*  703314 */   // Label 11168: @703314
     /*  703314 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(703389), // Rule ID 19394 //
     /*  703319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  703322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703365 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  703368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703387 */     GIR_RootConstrainSelectedInstOperands,
     /*  703388 */     // GIR_Coverage, 19394,
     /*  703388 */     GIR_EraseRootFromParent_Done,
     /*  703389 */   // Label 11169: @703389
     /*  703389 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(703464), // Rule ID 19395 //
     /*  703394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  703397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  703443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703462 */     GIR_RootConstrainSelectedInstOperands,
     /*  703463 */     // GIR_Coverage, 19395,
     /*  703463 */     GIR_EraseRootFromParent_Done,
     /*  703464 */   // Label 11170: @703464
     /*  703464 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(703539), // Rule ID 19398 //
     /*  703469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  703472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703515 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  703518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703537 */     GIR_RootConstrainSelectedInstOperands,
     /*  703538 */     // GIR_Coverage, 19398,
     /*  703538 */     GIR_EraseRootFromParent_Done,
     /*  703539 */   // Label 11171: @703539
     /*  703539 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(703614), // Rule ID 19399 //
     /*  703544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  703547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703590 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  703593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703612 */     GIR_RootConstrainSelectedInstOperands,
     /*  703613 */     // GIR_Coverage, 19399,
     /*  703613 */     GIR_EraseRootFromParent_Done,
     /*  703614 */   // Label 11172: @703614
     /*  703614 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(703689), // Rule ID 19402 //
     /*  703619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  703622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  703630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  703633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  703636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  703639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703665 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  703665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  703668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  703684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703687 */     GIR_RootConstrainSelectedInstOperands,
     /*  703688 */     // GIR_Coverage, 19402,
     /*  703688 */     GIR_EraseRootFromParent_Done,
     /*  703689 */   // Label 11173: @703689
     /*  703689 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(703764), // Rule ID 19403 //
     /*  703694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  703697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  703705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  703708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  703711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  703714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  703740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  703743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  703759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703762 */     GIR_RootConstrainSelectedInstOperands,
     /*  703763 */     // GIR_Coverage, 19403,
     /*  703763 */     GIR_EraseRootFromParent_Done,
     /*  703764 */   // Label 11174: @703764
     /*  703764 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(703839), // Rule ID 19406 //
     /*  703769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  703772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703815 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  703818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703837 */     GIR_RootConstrainSelectedInstOperands,
     /*  703838 */     // GIR_Coverage, 19406,
     /*  703838 */     GIR_EraseRootFromParent_Done,
     /*  703839 */   // Label 11175: @703839
     /*  703839 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(703914), // Rule ID 19407 //
     /*  703844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  703847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  703893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703912 */     GIR_RootConstrainSelectedInstOperands,
     /*  703913 */     // GIR_Coverage, 19407,
     /*  703913 */     GIR_EraseRootFromParent_Done,
     /*  703914 */   // Label 11176: @703914
     /*  703914 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(703989), // Rule ID 19410 //
     /*  703919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  703922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  703927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  703930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  703933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  703936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  703939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703965 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  703968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703987 */     GIR_RootConstrainSelectedInstOperands,
     /*  703988 */     // GIR_Coverage, 19410,
     /*  703988 */     GIR_EraseRootFromParent_Done,
     /*  703989 */   // Label 11177: @703989
     /*  703989 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(704064), // Rule ID 19411 //
     /*  703994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  703997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  704043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704062 */     GIR_RootConstrainSelectedInstOperands,
     /*  704063 */     // GIR_Coverage, 19411,
     /*  704063 */     GIR_EraseRootFromParent_Done,
     /*  704064 */   // Label 11178: @704064
     /*  704064 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(704139), // Rule ID 19414 //
     /*  704069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  704072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704115 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  704118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704137 */     GIR_RootConstrainSelectedInstOperands,
     /*  704138 */     // GIR_Coverage, 19414,
     /*  704138 */     GIR_EraseRootFromParent_Done,
     /*  704139 */   // Label 11179: @704139
     /*  704139 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(704214), // Rule ID 19415 //
     /*  704144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  704147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704190 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  704193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704212 */     GIR_RootConstrainSelectedInstOperands,
     /*  704213 */     // GIR_Coverage, 19415,
     /*  704213 */     GIR_EraseRootFromParent_Done,
     /*  704214 */   // Label 11180: @704214
     /*  704214 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(704289), // Rule ID 19418 //
     /*  704219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  704222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704265 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  704268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704287 */     GIR_RootConstrainSelectedInstOperands,
     /*  704288 */     // GIR_Coverage, 19418,
     /*  704288 */     GIR_EraseRootFromParent_Done,
     /*  704289 */   // Label 11181: @704289
     /*  704289 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(704364), // Rule ID 19419 //
     /*  704294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  704297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  704343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704362 */     GIR_RootConstrainSelectedInstOperands,
     /*  704363 */     // GIR_Coverage, 19419,
     /*  704363 */     GIR_EraseRootFromParent_Done,
     /*  704364 */   // Label 11182: @704364
     /*  704364 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(704439), // Rule ID 19422 //
     /*  704369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  704372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704415 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  704418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704437 */     GIR_RootConstrainSelectedInstOperands,
     /*  704438 */     // GIR_Coverage, 19422,
     /*  704438 */     GIR_EraseRootFromParent_Done,
     /*  704439 */   // Label 11183: @704439
     /*  704439 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(704514), // Rule ID 19423 //
     /*  704444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  704447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704490 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  704493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704512 */     GIR_RootConstrainSelectedInstOperands,
     /*  704513 */     // GIR_Coverage, 19423,
     /*  704513 */     GIR_EraseRootFromParent_Done,
     /*  704514 */   // Label 11184: @704514
     /*  704514 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(704589), // Rule ID 19426 //
     /*  704519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  704522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704565 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  704568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704587 */     GIR_RootConstrainSelectedInstOperands,
     /*  704588 */     // GIR_Coverage, 19426,
     /*  704588 */     GIR_EraseRootFromParent_Done,
     /*  704589 */   // Label 11185: @704589
     /*  704589 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(704664), // Rule ID 19427 //
     /*  704594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  704597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  704643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704662 */     GIR_RootConstrainSelectedInstOperands,
     /*  704663 */     // GIR_Coverage, 19427,
     /*  704663 */     GIR_EraseRootFromParent_Done,
     /*  704664 */   // Label 11186: @704664
     /*  704664 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(704739), // Rule ID 19430 //
     /*  704669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  704672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  704680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  704683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  704686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  704689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  704715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  704718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  704734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704737 */     GIR_RootConstrainSelectedInstOperands,
     /*  704738 */     // GIR_Coverage, 19430,
     /*  704738 */     GIR_EraseRootFromParent_Done,
     /*  704739 */   // Label 11187: @704739
     /*  704739 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(704814), // Rule ID 19431 //
     /*  704744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  704747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  704755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  704758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  704761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  704764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  704790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  704793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  704809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704812 */     GIR_RootConstrainSelectedInstOperands,
     /*  704813 */     // GIR_Coverage, 19431,
     /*  704813 */     GIR_EraseRootFromParent_Done,
     /*  704814 */   // Label 11188: @704814
     /*  704814 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(704889), // Rule ID 19434 //
     /*  704819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  704822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  704830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  704833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  704836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  704839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  704865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  704868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  704884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704887 */     GIR_RootConstrainSelectedInstOperands,
     /*  704888 */     // GIR_Coverage, 19434,
     /*  704888 */     GIR_EraseRootFromParent_Done,
     /*  704889 */   // Label 11189: @704889
     /*  704889 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(704964), // Rule ID 19435 //
     /*  704894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  704897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  704905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  704908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  704911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  704914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  704940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  704943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  704959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704962 */     GIR_RootConstrainSelectedInstOperands,
     /*  704963 */     // GIR_Coverage, 19435,
     /*  704963 */     GIR_EraseRootFromParent_Done,
     /*  704964 */   // Label 11190: @704964
     /*  704964 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(705039), // Rule ID 19438 //
     /*  704969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  704972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  704977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  704980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  704983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  704986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  704989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705015 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  705015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  705018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  705034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705037 */     GIR_RootConstrainSelectedInstOperands,
     /*  705038 */     // GIR_Coverage, 19438,
     /*  705038 */     GIR_EraseRootFromParent_Done,
     /*  705039 */   // Label 11191: @705039
     /*  705039 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(705114), // Rule ID 19439 //
     /*  705044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  705047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  705055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  705058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  705061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  705064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  705090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  705093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  705109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705112 */     GIR_RootConstrainSelectedInstOperands,
     /*  705113 */     // GIR_Coverage, 19439,
     /*  705113 */     GIR_EraseRootFromParent_Done,
     /*  705114 */   // Label 11192: @705114
     /*  705114 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(705189), // Rule ID 19442 //
     /*  705119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  705122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705165 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  705168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705187 */     GIR_RootConstrainSelectedInstOperands,
     /*  705188 */     // GIR_Coverage, 19442,
     /*  705188 */     GIR_EraseRootFromParent_Done,
     /*  705189 */   // Label 11193: @705189
     /*  705189 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(705264), // Rule ID 19443 //
     /*  705194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  705197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705240 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  705243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705262 */     GIR_RootConstrainSelectedInstOperands,
     /*  705263 */     // GIR_Coverage, 19443,
     /*  705263 */     GIR_EraseRootFromParent_Done,
     /*  705264 */   // Label 11194: @705264
     /*  705264 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(705339), // Rule ID 19446 //
     /*  705269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  705272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705315 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  705318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705337 */     GIR_RootConstrainSelectedInstOperands,
     /*  705338 */     // GIR_Coverage, 19446,
     /*  705338 */     GIR_EraseRootFromParent_Done,
     /*  705339 */   // Label 11195: @705339
     /*  705339 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(705414), // Rule ID 19447 //
     /*  705344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  705347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705390 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  705393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705412 */     GIR_RootConstrainSelectedInstOperands,
     /*  705413 */     // GIR_Coverage, 19447,
     /*  705413 */     GIR_EraseRootFromParent_Done,
     /*  705414 */   // Label 11196: @705414
     /*  705414 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(705489), // Rule ID 19450 //
     /*  705419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  705422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  705458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705465 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  705468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705487 */     GIR_RootConstrainSelectedInstOperands,
     /*  705488 */     // GIR_Coverage, 19450,
     /*  705488 */     GIR_EraseRootFromParent_Done,
     /*  705489 */   // Label 11197: @705489
     /*  705489 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(705564), // Rule ID 19451 //
     /*  705494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  705497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  705533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705540 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  705543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705562 */     GIR_RootConstrainSelectedInstOperands,
     /*  705563 */     // GIR_Coverage, 19451,
     /*  705563 */     GIR_EraseRootFromParent_Done,
     /*  705564 */   // Label 11198: @705564
     /*  705564 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(705639), // Rule ID 19454 //
     /*  705569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  705572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705615 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  705618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705637 */     GIR_RootConstrainSelectedInstOperands,
     /*  705638 */     // GIR_Coverage, 19454,
     /*  705638 */     GIR_EraseRootFromParent_Done,
     /*  705639 */   // Label 11199: @705639
     /*  705639 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(705714), // Rule ID 19455 //
     /*  705644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  705647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  705664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  705683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10958:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  705693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705712 */     GIR_RootConstrainSelectedInstOperands,
     /*  705713 */     // GIR_Coverage, 19455,
     /*  705713 */     GIR_EraseRootFromParent_Done,
     /*  705714 */   // Label 11200: @705714
     /*  705714 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(705789), // Rule ID 19458 //
     /*  705719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  705722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  705758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705765 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  705768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705787 */     GIR_RootConstrainSelectedInstOperands,
     /*  705788 */     // GIR_Coverage, 19458,
     /*  705788 */     GIR_EraseRootFromParent_Done,
     /*  705789 */   // Label 11201: @705789
     /*  705789 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(705864), // Rule ID 19459 //
     /*  705794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  705797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  705833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10958:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  705843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705862 */     GIR_RootConstrainSelectedInstOperands,
     /*  705863 */     // GIR_Coverage, 19459,
     /*  705863 */     GIR_EraseRootFromParent_Done,
     /*  705864 */   // Label 11202: @705864
     /*  705864 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(705939), // Rule ID 19462 //
     /*  705869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  705872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  705880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  705883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  705886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  705908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705915 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  705915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  705918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  705934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705937 */     GIR_RootConstrainSelectedInstOperands,
     /*  705938 */     // GIR_Coverage, 19462,
     /*  705938 */     GIR_EraseRootFromParent_Done,
     /*  705939 */   // Label 11203: @705939
     /*  705939 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(706014), // Rule ID 19463 //
     /*  705944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  705947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  705952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  705955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  705958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  705961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  705983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705990 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10958:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  705990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  705993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  706009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706012 */     GIR_RootConstrainSelectedInstOperands,
     /*  706013 */     // GIR_Coverage, 19463,
     /*  706013 */     GIR_EraseRootFromParent_Done,
     /*  706014 */   // Label 11204: @706014
     /*  706014 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(706089), // Rule ID 19466 //
     /*  706019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  706022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  706068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706087 */     GIR_RootConstrainSelectedInstOperands,
     /*  706088 */     // GIR_Coverage, 19466,
     /*  706088 */     GIR_EraseRootFromParent_Done,
     /*  706089 */   // Label 11205: @706089
     /*  706089 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(706164), // Rule ID 19467 //
     /*  706094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  706097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706140 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  706143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706162 */     GIR_RootConstrainSelectedInstOperands,
     /*  706163 */     // GIR_Coverage, 19467,
     /*  706163 */     GIR_EraseRootFromParent_Done,
     /*  706164 */   // Label 11206: @706164
     /*  706164 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(706239), // Rule ID 19470 //
     /*  706169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  706172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706215 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  706218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706237 */     GIR_RootConstrainSelectedInstOperands,
     /*  706238 */     // GIR_Coverage, 19470,
     /*  706238 */     GIR_EraseRootFromParent_Done,
     /*  706239 */   // Label 11207: @706239
     /*  706239 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(706314), // Rule ID 19471 //
     /*  706244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  706247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  706293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706312 */     GIR_RootConstrainSelectedInstOperands,
     /*  706313 */     // GIR_Coverage, 19471,
     /*  706313 */     GIR_EraseRootFromParent_Done,
     /*  706314 */   // Label 11208: @706314
     /*  706314 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(706389), // Rule ID 19474 //
     /*  706319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  706322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706365 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  706368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706387 */     GIR_RootConstrainSelectedInstOperands,
     /*  706388 */     // GIR_Coverage, 19474,
     /*  706388 */     GIR_EraseRootFromParent_Done,
     /*  706389 */   // Label 11209: @706389
     /*  706389 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(706464), // Rule ID 19475 //
     /*  706394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  706397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  706414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  706433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  706443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706462 */     GIR_RootConstrainSelectedInstOperands,
     /*  706463 */     // GIR_Coverage, 19475,
     /*  706463 */     GIR_EraseRootFromParent_Done,
     /*  706464 */   // Label 11210: @706464
     /*  706464 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(706539), // Rule ID 19478 //
     /*  706469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  706472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706515 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  706518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706537 */     GIR_RootConstrainSelectedInstOperands,
     /*  706538 */     // GIR_Coverage, 19478,
     /*  706538 */     GIR_EraseRootFromParent_Done,
     /*  706539 */   // Label 11211: @706539
     /*  706539 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(706614), // Rule ID 19479 //
     /*  706544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  706547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  706593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706612 */     GIR_RootConstrainSelectedInstOperands,
     /*  706613 */     // GIR_Coverage, 19479,
     /*  706613 */     GIR_EraseRootFromParent_Done,
     /*  706614 */   // Label 11212: @706614
     /*  706614 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(706689), // Rule ID 19482 //
     /*  706619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  706622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  706630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  706633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  706636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706665 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  706668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706687 */     GIR_RootConstrainSelectedInstOperands,
     /*  706688 */     // GIR_Coverage, 19482,
     /*  706688 */     GIR_EraseRootFromParent_Done,
     /*  706689 */   // Label 11213: @706689
     /*  706689 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(706764), // Rule ID 19483 //
     /*  706694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  706697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  706705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  706708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  706711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706740 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  706743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706762 */     GIR_RootConstrainSelectedInstOperands,
     /*  706763 */     // GIR_Coverage, 19483,
     /*  706763 */     GIR_EraseRootFromParent_Done,
     /*  706764 */   // Label 11214: @706764
     /*  706764 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(706839), // Rule ID 19486 //
     /*  706769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  706772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  706780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  706783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  706786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706815 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  706818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706837 */     GIR_RootConstrainSelectedInstOperands,
     /*  706838 */     // GIR_Coverage, 19486,
     /*  706838 */     GIR_EraseRootFromParent_Done,
     /*  706839 */   // Label 11215: @706839
     /*  706839 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(706914), // Rule ID 19487 //
     /*  706844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  706847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  706855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  706858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  706861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  706883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706890 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  706893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706912 */     GIR_RootConstrainSelectedInstOperands,
     /*  706913 */     // GIR_Coverage, 19487,
     /*  706913 */     GIR_EraseRootFromParent_Done,
     /*  706914 */   // Label 11216: @706914
     /*  706914 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(706989), // Rule ID 19490 //
     /*  706919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  706922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  706927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  706930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  706933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  706936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  706958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706965 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  706965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  706968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  706984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706987 */     GIR_RootConstrainSelectedInstOperands,
     /*  706988 */     // GIR_Coverage, 19490,
     /*  706988 */     GIR_EraseRootFromParent_Done,
     /*  706989 */   // Label 11217: @706989
     /*  706989 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(707064), // Rule ID 19491 //
     /*  706994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  706997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  707002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  707005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  707008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  707011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  707033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10958:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  707040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  707043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  707059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707062 */     GIR_RootConstrainSelectedInstOperands,
     /*  707063 */     // GIR_Coverage, 19491,
     /*  707063 */     GIR_EraseRootFromParent_Done,
     /*  707064 */   // Label 11218: @707064
     /*  707064 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(707139), // Rule ID 19494 //
     /*  707069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  707072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  707077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  707080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  707083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  707086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  707108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707115 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  707115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  707118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  707134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707137 */     GIR_RootConstrainSelectedInstOperands,
     /*  707138 */     // GIR_Coverage, 19494,
     /*  707138 */     GIR_EraseRootFromParent_Done,
     /*  707139 */   // Label 11219: @707139
     /*  707139 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(707214), // Rule ID 19495 //
     /*  707144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  707147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  707152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  707155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  707158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  707161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  707183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707190 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10958:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  707190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  707193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  707209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707212 */     GIR_RootConstrainSelectedInstOperands,
     /*  707213 */     // GIR_Coverage, 19495,
     /*  707213 */     GIR_EraseRootFromParent_Done,
     /*  707214 */   // Label 11220: @707214
     /*  707214 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(707289), // Rule ID 19498 //
     /*  707219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  707222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  707227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  707230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  707233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  707236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  707258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707265 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  707265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  707268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  707284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707287 */     GIR_RootConstrainSelectedInstOperands,
     /*  707288 */     // GIR_Coverage, 19498,
     /*  707288 */     GIR_EraseRootFromParent_Done,
     /*  707289 */   // Label 11221: @707289
     /*  707289 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(707364), // Rule ID 19499 //
     /*  707294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  707297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  707302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  707305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  707308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  707311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  707333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707340 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10958:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  707340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  707343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  707359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707362 */     GIR_RootConstrainSelectedInstOperands,
     /*  707363 */     // GIR_Coverage, 19499,
     /*  707363 */     GIR_EraseRootFromParent_Done,
     /*  707364 */   // Label 11222: @707364
     /*  707364 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(707439), // Rule ID 19502 //
     /*  707369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  707372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707415 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  707418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707437 */     GIR_RootConstrainSelectedInstOperands,
     /*  707438 */     // GIR_Coverage, 19502,
     /*  707438 */     GIR_EraseRootFromParent_Done,
     /*  707439 */   // Label 11223: @707439
     /*  707439 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(707514), // Rule ID 19503 //
     /*  707444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  707447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707490 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  707493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707512 */     GIR_RootConstrainSelectedInstOperands,
     /*  707513 */     // GIR_Coverage, 19503,
     /*  707513 */     GIR_EraseRootFromParent_Done,
     /*  707514 */   // Label 11224: @707514
     /*  707514 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(707589), // Rule ID 19506 //
     /*  707519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  707522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  707530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  707533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  707536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  707539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  707568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707587 */     GIR_RootConstrainSelectedInstOperands,
     /*  707588 */     // GIR_Coverage, 19506,
     /*  707588 */     GIR_EraseRootFromParent_Done,
     /*  707589 */   // Label 11225: @707589
     /*  707589 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(707664), // Rule ID 19507 //
     /*  707594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  707597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  707605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  707608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  707611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  707614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  707643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707662 */     GIR_RootConstrainSelectedInstOperands,
     /*  707663 */     // GIR_Coverage, 19507,
     /*  707663 */     GIR_EraseRootFromParent_Done,
     /*  707664 */   // Label 11226: @707664
     /*  707664 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(707739), // Rule ID 19510 //
     /*  707669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  707672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  707680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  707683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  707686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  707689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707715 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  707718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707737 */     GIR_RootConstrainSelectedInstOperands,
     /*  707738 */     // GIR_Coverage, 19510,
     /*  707738 */     GIR_EraseRootFromParent_Done,
     /*  707739 */   // Label 11227: @707739
     /*  707739 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(707814), // Rule ID 19511 //
     /*  707744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  707747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  707755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  707758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  707761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  707764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  707793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707812 */     GIR_RootConstrainSelectedInstOperands,
     /*  707813 */     // GIR_Coverage, 19511,
     /*  707813 */     GIR_EraseRootFromParent_Done,
     /*  707814 */   // Label 11228: @707814
     /*  707814 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(707889), // Rule ID 19514 //
     /*  707819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  707822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  707830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  707833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  707836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  707839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  707868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707887 */     GIR_RootConstrainSelectedInstOperands,
     /*  707888 */     // GIR_Coverage, 19514,
     /*  707888 */     GIR_EraseRootFromParent_Done,
     /*  707889 */   // Label 11229: @707889
     /*  707889 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(707964), // Rule ID 19515 //
     /*  707894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  707897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  707905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  707908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  707911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  707914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  707943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707962 */     GIR_RootConstrainSelectedInstOperands,
     /*  707963 */     // GIR_Coverage, 19515,
     /*  707963 */     GIR_EraseRootFromParent_Done,
     /*  707964 */   // Label 11230: @707964
     /*  707964 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(708039), // Rule ID 19518 //
     /*  707969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  707972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  707977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  707980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  707983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  707986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  707989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  708018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708037 */     GIR_RootConstrainSelectedInstOperands,
     /*  708038 */     // GIR_Coverage, 19518,
     /*  708038 */     GIR_EraseRootFromParent_Done,
     /*  708039 */   // Label 11231: @708039
     /*  708039 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(708114), // Rule ID 19519 //
     /*  708044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  708047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  708093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708112 */     GIR_RootConstrainSelectedInstOperands,
     /*  708113 */     // GIR_Coverage, 19519,
     /*  708113 */     GIR_EraseRootFromParent_Done,
     /*  708114 */   // Label 11232: @708114
     /*  708114 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(708189), // Rule ID 19522 //
     /*  708119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  708122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  708130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  708133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  708136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  708139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708165 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  708165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  708168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  708184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708187 */     GIR_RootConstrainSelectedInstOperands,
     /*  708188 */     // GIR_Coverage, 19522,
     /*  708188 */     GIR_EraseRootFromParent_Done,
     /*  708189 */   // Label 11233: @708189
     /*  708189 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(708264), // Rule ID 19523 //
     /*  708194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  708197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  708205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  708208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  708211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  708214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  708240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  708243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  708259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708262 */     GIR_RootConstrainSelectedInstOperands,
     /*  708263 */     // GIR_Coverage, 19523,
     /*  708263 */     GIR_EraseRootFromParent_Done,
     /*  708264 */   // Label 11234: @708264
     /*  708264 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(708339), // Rule ID 19526 //
     /*  708269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  708272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  708280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  708283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  708286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  708289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  708318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708337 */     GIR_RootConstrainSelectedInstOperands,
     /*  708338 */     // GIR_Coverage, 19526,
     /*  708338 */     GIR_EraseRootFromParent_Done,
     /*  708339 */   // Label 11235: @708339
     /*  708339 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(708414), // Rule ID 19527 //
     /*  708344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  708347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  708355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  708358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  708361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  708364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708390 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  708393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708412 */     GIR_RootConstrainSelectedInstOperands,
     /*  708413 */     // GIR_Coverage, 19527,
     /*  708413 */     GIR_EraseRootFromParent_Done,
     /*  708414 */   // Label 11236: @708414
     /*  708414 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(708489), // Rule ID 19530 //
     /*  708419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  708422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  708430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  708433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  708436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  708439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708465 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  708468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708487 */     GIR_RootConstrainSelectedInstOperands,
     /*  708488 */     // GIR_Coverage, 19530,
     /*  708488 */     GIR_EraseRootFromParent_Done,
     /*  708489 */   // Label 11237: @708489
     /*  708489 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(708564), // Rule ID 19531 //
     /*  708494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  708497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  708505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  708508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  708511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  708514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  708543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708562 */     GIR_RootConstrainSelectedInstOperands,
     /*  708563 */     // GIR_Coverage, 19531,
     /*  708563 */     GIR_EraseRootFromParent_Done,
     /*  708564 */   // Label 11238: @708564
     /*  708564 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(708639), // Rule ID 19534 //
     /*  708569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  708572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  708580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  708583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  708586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  708589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708615 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  708618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708637 */     GIR_RootConstrainSelectedInstOperands,
     /*  708638 */     // GIR_Coverage, 19534,
     /*  708638 */     GIR_EraseRootFromParent_Done,
     /*  708639 */   // Label 11239: @708639
     /*  708639 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(708714), // Rule ID 19535 //
     /*  708644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  708647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  708655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  708658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  708661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  708664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  708693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708712 */     GIR_RootConstrainSelectedInstOperands,
     /*  708713 */     // GIR_Coverage, 19535,
     /*  708713 */     GIR_EraseRootFromParent_Done,
     /*  708714 */   // Label 11240: @708714
     /*  708714 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(708789), // Rule ID 19538 //
     /*  708719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  708722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  708768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708787 */     GIR_RootConstrainSelectedInstOperands,
     /*  708788 */     // GIR_Coverage, 19538,
     /*  708788 */     GIR_EraseRootFromParent_Done,
     /*  708789 */   // Label 11241: @708789
     /*  708789 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(708864), // Rule ID 19539 //
     /*  708794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  708797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  708843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708862 */     GIR_RootConstrainSelectedInstOperands,
     /*  708863 */     // GIR_Coverage, 19539,
     /*  708863 */     GIR_EraseRootFromParent_Done,
     /*  708864 */   // Label 11242: @708864
     /*  708864 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(708939), // Rule ID 19542 //
     /*  708869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  708872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708915 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  708918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708937 */     GIR_RootConstrainSelectedInstOperands,
     /*  708938 */     // GIR_Coverage, 19542,
     /*  708938 */     GIR_EraseRootFromParent_Done,
     /*  708939 */   // Label 11243: @708939
     /*  708939 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(709014), // Rule ID 19543 //
     /*  708944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  708947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  708952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  708993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709012 */     GIR_RootConstrainSelectedInstOperands,
     /*  709013 */     // GIR_Coverage, 19543,
     /*  709013 */     GIR_EraseRootFromParent_Done,
     /*  709014 */   // Label 11244: @709014
     /*  709014 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(709089), // Rule ID 19546 //
     /*  709019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  709022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  709068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709087 */     GIR_RootConstrainSelectedInstOperands,
     /*  709088 */     // GIR_Coverage, 19546,
     /*  709088 */     GIR_EraseRootFromParent_Done,
     /*  709089 */   // Label 11245: @709089
     /*  709089 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(709164), // Rule ID 19547 //
     /*  709094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  709097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  709143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709162 */     GIR_RootConstrainSelectedInstOperands,
     /*  709163 */     // GIR_Coverage, 19547,
     /*  709163 */     GIR_EraseRootFromParent_Done,
     /*  709164 */   // Label 11246: @709164
     /*  709164 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(709239), // Rule ID 19550 //
     /*  709169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  709172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  709180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  709183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  709186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  709189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  709215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  709218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709237 */     GIR_RootConstrainSelectedInstOperands,
     /*  709238 */     // GIR_Coverage, 19550,
     /*  709238 */     GIR_EraseRootFromParent_Done,
     /*  709239 */   // Label 11247: @709239
     /*  709239 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(709314), // Rule ID 19551 //
     /*  709244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  709247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  709255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  709258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  709261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  709264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  709290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  709293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709312 */     GIR_RootConstrainSelectedInstOperands,
     /*  709313 */     // GIR_Coverage, 19551,
     /*  709313 */     GIR_EraseRootFromParent_Done,
     /*  709314 */   // Label 11248: @709314
     /*  709314 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(709389), // Rule ID 19554 //
     /*  709319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  709322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  709330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  709333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  709336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  709339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709365 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  709365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  709368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709387 */     GIR_RootConstrainSelectedInstOperands,
     /*  709388 */     // GIR_Coverage, 19554,
     /*  709388 */     GIR_EraseRootFromParent_Done,
     /*  709389 */   // Label 11249: @709389
     /*  709389 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(709464), // Rule ID 19555 //
     /*  709394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  709397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  709405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  709408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  709411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  709414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  709440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  709443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709462 */     GIR_RootConstrainSelectedInstOperands,
     /*  709463 */     // GIR_Coverage, 19555,
     /*  709463 */     GIR_EraseRootFromParent_Done,
     /*  709464 */   // Label 11250: @709464
     /*  709464 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(709539), // Rule ID 19558 //
     /*  709469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  709472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  709480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  709483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  709486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  709489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  709515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  709518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709537 */     GIR_RootConstrainSelectedInstOperands,
     /*  709538 */     // GIR_Coverage, 19558,
     /*  709538 */     GIR_EraseRootFromParent_Done,
     /*  709539 */   // Label 11251: @709539
     /*  709539 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(709614), // Rule ID 19559 //
     /*  709544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  709547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  709555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  709558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  709561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  709564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  709590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  709593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  709609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709612 */     GIR_RootConstrainSelectedInstOperands,
     /*  709613 */     // GIR_Coverage, 19559,
     /*  709613 */     GIR_EraseRootFromParent_Done,
     /*  709614 */   // Label 11252: @709614
     /*  709614 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(709689), // Rule ID 19562 //
     /*  709619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  709622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  709639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  709658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709665 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  709668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709687 */     GIR_RootConstrainSelectedInstOperands,
     /*  709688 */     // GIR_Coverage, 19562,
     /*  709688 */     GIR_EraseRootFromParent_Done,
     /*  709689 */   // Label 11253: @709689
     /*  709689 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(709764), // Rule ID 19563 //
     /*  709694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  709697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  709714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  709733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709740 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  709743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709762 */     GIR_RootConstrainSelectedInstOperands,
     /*  709763 */     // GIR_Coverage, 19563,
     /*  709763 */     GIR_EraseRootFromParent_Done,
     /*  709764 */   // Label 11254: @709764
     /*  709764 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(709839), // Rule ID 19566 //
     /*  709769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  709772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  709789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  709808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  709818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709837 */     GIR_RootConstrainSelectedInstOperands,
     /*  709838 */     // GIR_Coverage, 19566,
     /*  709838 */     GIR_EraseRootFromParent_Done,
     /*  709839 */   // Label 11255: @709839
     /*  709839 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(709914), // Rule ID 19567 //
     /*  709844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  709847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  709864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  709883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  709893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709912 */     GIR_RootConstrainSelectedInstOperands,
     /*  709913 */     // GIR_Coverage, 19567,
     /*  709913 */     GIR_EraseRootFromParent_Done,
     /*  709914 */   // Label 11256: @709914
     /*  709914 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(709989), // Rule ID 19570 //
     /*  709919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  709922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  709927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  709930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  709933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  709936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  709958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709965 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  709968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709987 */     GIR_RootConstrainSelectedInstOperands,
     /*  709988 */     // GIR_Coverage, 19570,
     /*  709988 */     GIR_EraseRootFromParent_Done,
     /*  709989 */   // Label 11257: @709989
     /*  709989 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(710064), // Rule ID 19571 //
     /*  709994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  709997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  710033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710040 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  710043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710062 */     GIR_RootConstrainSelectedInstOperands,
     /*  710063 */     // GIR_Coverage, 19571,
     /*  710063 */     GIR_EraseRootFromParent_Done,
     /*  710064 */   // Label 11258: @710064
     /*  710064 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(710139), // Rule ID 19574 //
     /*  710069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  710072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  710080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  710083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  710086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  710118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710137 */     GIR_RootConstrainSelectedInstOperands,
     /*  710138 */     // GIR_Coverage, 19574,
     /*  710138 */     GIR_EraseRootFromParent_Done,
     /*  710139 */   // Label 11259: @710139
     /*  710139 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(710214), // Rule ID 19575 //
     /*  710144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  710147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  710155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  710158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  710161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10960:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  710193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710212 */     GIR_RootConstrainSelectedInstOperands,
     /*  710213 */     // GIR_Coverage, 19575,
     /*  710213 */     GIR_EraseRootFromParent_Done,
     /*  710214 */   // Label 11260: @710214
     /*  710214 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(710289), // Rule ID 19578 //
     /*  710219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  710222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  710230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  710233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  710236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  710258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  710268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710287 */     GIR_RootConstrainSelectedInstOperands,
     /*  710288 */     // GIR_Coverage, 19578,
     /*  710288 */     GIR_EraseRootFromParent_Done,
     /*  710289 */   // Label 11261: @710289
     /*  710289 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(710364), // Rule ID 19579 //
     /*  710294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  710297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  710305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  710308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  710311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  710333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710340 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10960:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  710343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710362 */     GIR_RootConstrainSelectedInstOperands,
     /*  710363 */     // GIR_Coverage, 19579,
     /*  710363 */     GIR_EraseRootFromParent_Done,
     /*  710364 */   // Label 11262: @710364
     /*  710364 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(710439), // Rule ID 19582 //
     /*  710369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  710372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  710380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  710383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  710386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  710408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710415 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  710415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  710418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  710434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710437 */     GIR_RootConstrainSelectedInstOperands,
     /*  710438 */     // GIR_Coverage, 19582,
     /*  710438 */     GIR_EraseRootFromParent_Done,
     /*  710439 */   // Label 11263: @710439
     /*  710439 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(710514), // Rule ID 19583 //
     /*  710444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  710447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  710455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  710458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  710461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  710483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10960:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  710490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  710493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  710509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710512 */     GIR_RootConstrainSelectedInstOperands,
     /*  710513 */     // GIR_Coverage, 19583,
     /*  710513 */     GIR_EraseRootFromParent_Done,
     /*  710514 */   // Label 11264: @710514
     /*  710514 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(710589), // Rule ID 19586 //
     /*  710519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  710522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  710568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710587 */     GIR_RootConstrainSelectedInstOperands,
     /*  710588 */     // GIR_Coverage, 19586,
     /*  710588 */     GIR_EraseRootFromParent_Done,
     /*  710589 */   // Label 11265: @710589
     /*  710589 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(710664), // Rule ID 19587 //
     /*  710594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  710597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710640 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  710643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710662 */     GIR_RootConstrainSelectedInstOperands,
     /*  710663 */     // GIR_Coverage, 19587,
     /*  710663 */     GIR_EraseRootFromParent_Done,
     /*  710664 */   // Label 11266: @710664
     /*  710664 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(710739), // Rule ID 19590 //
     /*  710669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  710672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710715 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  710718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710737 */     GIR_RootConstrainSelectedInstOperands,
     /*  710738 */     // GIR_Coverage, 19590,
     /*  710738 */     GIR_EraseRootFromParent_Done,
     /*  710739 */   // Label 11267: @710739
     /*  710739 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(710814), // Rule ID 19591 //
     /*  710744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  710747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710790 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  710793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710812 */     GIR_RootConstrainSelectedInstOperands,
     /*  710813 */     // GIR_Coverage, 19591,
     /*  710813 */     GIR_EraseRootFromParent_Done,
     /*  710814 */   // Label 11268: @710814
     /*  710814 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(710889), // Rule ID 19594 //
     /*  710819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  710822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710865 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  710868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710887 */     GIR_RootConstrainSelectedInstOperands,
     /*  710888 */     // GIR_Coverage, 19594,
     /*  710888 */     GIR_EraseRootFromParent_Done,
     /*  710889 */   // Label 11269: @710889
     /*  710889 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(710964), // Rule ID 19595 //
     /*  710894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  710897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  710914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  710933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710940 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  710943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710962 */     GIR_RootConstrainSelectedInstOperands,
     /*  710963 */     // GIR_Coverage, 19595,
     /*  710963 */     GIR_EraseRootFromParent_Done,
     /*  710964 */   // Label 11270: @710964
     /*  710964 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(711039), // Rule ID 19598 //
     /*  710969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  710972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  710977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  711018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711037 */     GIR_RootConstrainSelectedInstOperands,
     /*  711038 */     // GIR_Coverage, 19598,
     /*  711038 */     GIR_EraseRootFromParent_Done,
     /*  711039 */   // Label 11271: @711039
     /*  711039 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(711114), // Rule ID 19599 //
     /*  711044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  711047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  711055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  711058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  711061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  711093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711112 */     GIR_RootConstrainSelectedInstOperands,
     /*  711113 */     // GIR_Coverage, 19599,
     /*  711113 */     GIR_EraseRootFromParent_Done,
     /*  711114 */   // Label 11272: @711114
     /*  711114 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(711189), // Rule ID 19602 //
     /*  711119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  711122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  711130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  711133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  711136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711165 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  711168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711187 */     GIR_RootConstrainSelectedInstOperands,
     /*  711188 */     // GIR_Coverage, 19602,
     /*  711188 */     GIR_EraseRootFromParent_Done,
     /*  711189 */   // Label 11273: @711189
     /*  711189 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(711264), // Rule ID 19603 //
     /*  711194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  711197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  711205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  711208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  711211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  711243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711262 */     GIR_RootConstrainSelectedInstOperands,
     /*  711263 */     // GIR_Coverage, 19603,
     /*  711263 */     GIR_EraseRootFromParent_Done,
     /*  711264 */   // Label 11274: @711264
     /*  711264 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(711339), // Rule ID 19606 //
     /*  711269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  711272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711315 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  711318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711337 */     GIR_RootConstrainSelectedInstOperands,
     /*  711338 */     // GIR_Coverage, 19606,
     /*  711338 */     GIR_EraseRootFromParent_Done,
     /*  711339 */   // Label 11275: @711339
     /*  711339 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(711414), // Rule ID 19607 //
     /*  711344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  711347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  711383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  711393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711412 */     GIR_RootConstrainSelectedInstOperands,
     /*  711413 */     // GIR_Coverage, 19607,
     /*  711413 */     GIR_EraseRootFromParent_Done,
     /*  711414 */   // Label 11276: @711414
     /*  711414 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(711489), // Rule ID 19610 //
     /*  711419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  711422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  711430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  711433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  711436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  711465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  711468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711487 */     GIR_RootConstrainSelectedInstOperands,
     /*  711488 */     // GIR_Coverage, 19610,
     /*  711488 */     GIR_EraseRootFromParent_Done,
     /*  711489 */   // Label 11277: @711489
     /*  711489 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(711564), // Rule ID 19611 //
     /*  711494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  711497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  711505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  711508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  711511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711540 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10960:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  711540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  711543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711562 */     GIR_RootConstrainSelectedInstOperands,
     /*  711563 */     // GIR_Coverage, 19611,
     /*  711563 */     GIR_EraseRootFromParent_Done,
     /*  711564 */   // Label 11278: @711564
     /*  711564 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(711639), // Rule ID 19614 //
     /*  711569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  711572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  711580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  711583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  711586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711615 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  711615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  711618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711637 */     GIR_RootConstrainSelectedInstOperands,
     /*  711638 */     // GIR_Coverage, 19614,
     /*  711638 */     GIR_EraseRootFromParent_Done,
     /*  711639 */   // Label 11279: @711639
     /*  711639 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(711714), // Rule ID 19615 //
     /*  711644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  711647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  711655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  711658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  711661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10960:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  711690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  711693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711712 */     GIR_RootConstrainSelectedInstOperands,
     /*  711713 */     // GIR_Coverage, 19615,
     /*  711713 */     GIR_EraseRootFromParent_Done,
     /*  711714 */   // Label 11280: @711714
     /*  711714 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(711789), // Rule ID 19618 //
     /*  711719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  711722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  711730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  711733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  711736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711765 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  711765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  711768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711787 */     GIR_RootConstrainSelectedInstOperands,
     /*  711788 */     // GIR_Coverage, 19618,
     /*  711788 */     GIR_EraseRootFromParent_Done,
     /*  711789 */   // Label 11281: @711789
     /*  711789 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(711864), // Rule ID 19619 //
     /*  711794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  711797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  711802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  711805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  711808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  711811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  711833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10960:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  711840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  711843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  711859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711862 */     GIR_RootConstrainSelectedInstOperands,
     /*  711863 */     // GIR_Coverage, 19619,
     /*  711863 */     GIR_EraseRootFromParent_Done,
     /*  711864 */   // Label 11282: @711864
     /*  711864 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(711939), // Rule ID 21836 //
     /*  711869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  711877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  711889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711915 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  711918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  711922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711937 */     GIR_RootConstrainSelectedInstOperands,
     /*  711938 */     // GIR_Coverage, 21836,
     /*  711938 */     GIR_EraseRootFromParent_Done,
     /*  711939 */   // Label 11283: @711939
     /*  711939 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(712014), // Rule ID 21837 //
     /*  711944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  711952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  711964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  711993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  711997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712012 */     GIR_RootConstrainSelectedInstOperands,
     /*  712013 */     // GIR_Coverage, 21837,
     /*  712013 */     GIR_EraseRootFromParent_Done,
     /*  712014 */   // Label 11284: @712014
     /*  712014 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(712089), // Rule ID 21840 //
     /*  712019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  712036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  712068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712087 */     GIR_RootConstrainSelectedInstOperands,
     /*  712088 */     // GIR_Coverage, 21840,
     /*  712088 */     GIR_EraseRootFromParent_Done,
     /*  712089 */   // Label 11285: @712089
     /*  712089 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(712164), // Rule ID 21841 //
     /*  712094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  712111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  712143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712162 */     GIR_RootConstrainSelectedInstOperands,
     /*  712163 */     // GIR_Coverage, 21841,
     /*  712163 */     GIR_EraseRootFromParent_Done,
     /*  712164 */   // Label 11286: @712164
     /*  712164 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(712239), // Rule ID 21844 //
     /*  712169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  712186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  712218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712237 */     GIR_RootConstrainSelectedInstOperands,
     /*  712238 */     // GIR_Coverage, 21844,
     /*  712238 */     GIR_EraseRootFromParent_Done,
     /*  712239 */   // Label 11287: @712239
     /*  712239 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(712314), // Rule ID 21845 //
     /*  712244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  712261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  712293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712312 */     GIR_RootConstrainSelectedInstOperands,
     /*  712313 */     // GIR_Coverage, 21845,
     /*  712313 */     GIR_EraseRootFromParent_Done,
     /*  712314 */   // Label 11288: @712314
     /*  712314 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(712389), // Rule ID 21848 //
     /*  712319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  712336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  712368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712387 */     GIR_RootConstrainSelectedInstOperands,
     /*  712388 */     // GIR_Coverage, 21848,
     /*  712388 */     GIR_EraseRootFromParent_Done,
     /*  712389 */   // Label 11289: @712389
     /*  712389 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(712464), // Rule ID 21849 //
     /*  712394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  712411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  712443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712462 */     GIR_RootConstrainSelectedInstOperands,
     /*  712463 */     // GIR_Coverage, 21849,
     /*  712463 */     GIR_EraseRootFromParent_Done,
     /*  712464 */   // Label 11290: @712464
     /*  712464 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(712539), // Rule ID 21852 //
     /*  712469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  712518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712537 */     GIR_RootConstrainSelectedInstOperands,
     /*  712538 */     // GIR_Coverage, 21852,
     /*  712538 */     GIR_EraseRootFromParent_Done,
     /*  712539 */   // Label 11291: @712539
     /*  712539 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(712614), // Rule ID 21853 //
     /*  712544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  712593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712612 */     GIR_RootConstrainSelectedInstOperands,
     /*  712613 */     // GIR_Coverage, 21853,
     /*  712613 */     GIR_EraseRootFromParent_Done,
     /*  712614 */   // Label 11292: @712614
     /*  712614 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(712689), // Rule ID 21856 //
     /*  712619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712665 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  712668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712687 */     GIR_RootConstrainSelectedInstOperands,
     /*  712688 */     // GIR_Coverage, 21856,
     /*  712688 */     GIR_EraseRootFromParent_Done,
     /*  712689 */   // Label 11293: @712689
     /*  712689 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(712764), // Rule ID 21857 //
     /*  712694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  712743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712762 */     GIR_RootConstrainSelectedInstOperands,
     /*  712763 */     // GIR_Coverage, 21857,
     /*  712763 */     GIR_EraseRootFromParent_Done,
     /*  712764 */   // Label 11294: @712764
     /*  712764 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(712839), // Rule ID 21860 //
     /*  712769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  712818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712837 */     GIR_RootConstrainSelectedInstOperands,
     /*  712838 */     // GIR_Coverage, 21860,
     /*  712838 */     GIR_EraseRootFromParent_Done,
     /*  712839 */   // Label 11295: @712839
     /*  712839 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(712914), // Rule ID 21861 //
     /*  712844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  712893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712912 */     GIR_RootConstrainSelectedInstOperands,
     /*  712913 */     // GIR_Coverage, 21861,
     /*  712913 */     GIR_EraseRootFromParent_Done,
     /*  712914 */   // Label 11296: @712914
     /*  712914 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(712989), // Rule ID 21864 //
     /*  712919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  712927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  712936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  712968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  712972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712987 */     GIR_RootConstrainSelectedInstOperands,
     /*  712988 */     // GIR_Coverage, 21864,
     /*  712988 */     GIR_EraseRootFromParent_Done,
     /*  712989 */   // Label 11297: @712989
     /*  712989 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(713064), // Rule ID 21865 //
     /*  712994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  713005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  713008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  713011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  713014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  713043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713062 */     GIR_RootConstrainSelectedInstOperands,
     /*  713063 */     // GIR_Coverage, 21865,
     /*  713063 */     GIR_EraseRootFromParent_Done,
     /*  713064 */   // Label 11298: @713064
     /*  713064 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(713139), // Rule ID 21868 //
     /*  713069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  713072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  713118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713137 */     GIR_RootConstrainSelectedInstOperands,
     /*  713138 */     // GIR_Coverage, 21868,
     /*  713138 */     GIR_EraseRootFromParent_Done,
     /*  713139 */   // Label 11299: @713139
     /*  713139 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(713214), // Rule ID 21869 //
     /*  713144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  713147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  713193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713212 */     GIR_RootConstrainSelectedInstOperands,
     /*  713213 */     // GIR_Coverage, 21869,
     /*  713213 */     GIR_EraseRootFromParent_Done,
     /*  713214 */   // Label 11300: @713214
     /*  713214 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(713289), // Rule ID 21872 //
     /*  713219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  713236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  713265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  713268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713287 */     GIR_RootConstrainSelectedInstOperands,
     /*  713288 */     // GIR_Coverage, 21872,
     /*  713288 */     GIR_EraseRootFromParent_Done,
     /*  713289 */   // Label 11301: @713289
     /*  713289 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(713364), // Rule ID 21873 //
     /*  713294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  713311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  713340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  713343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713362 */     GIR_RootConstrainSelectedInstOperands,
     /*  713363 */     // GIR_Coverage, 21873,
     /*  713363 */     GIR_EraseRootFromParent_Done,
     /*  713364 */   // Label 11302: @713364
     /*  713364 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(713439), // Rule ID 21876 //
     /*  713369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  713386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713415 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  713415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  713418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713437 */     GIR_RootConstrainSelectedInstOperands,
     /*  713438 */     // GIR_Coverage, 21876,
     /*  713438 */     GIR_EraseRootFromParent_Done,
     /*  713439 */   // Label 11303: @713439
     /*  713439 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(713514), // Rule ID 21877 //
     /*  713444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  713461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  713490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  713493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713512 */     GIR_RootConstrainSelectedInstOperands,
     /*  713513 */     // GIR_Coverage, 21877,
     /*  713513 */     GIR_EraseRootFromParent_Done,
     /*  713514 */   // Label 11304: @713514
     /*  713514 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(713589), // Rule ID 21880 //
     /*  713519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  713536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  713565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  713568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713587 */     GIR_RootConstrainSelectedInstOperands,
     /*  713588 */     // GIR_Coverage, 21880,
     /*  713588 */     GIR_EraseRootFromParent_Done,
     /*  713589 */   // Label 11305: @713589
     /*  713589 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(713664), // Rule ID 21881 //
     /*  713594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  713605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  713608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  713611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  713614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  713640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  713643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713662 */     GIR_RootConstrainSelectedInstOperands,
     /*  713663 */     // GIR_Coverage, 21881,
     /*  713663 */     GIR_EraseRootFromParent_Done,
     /*  713664 */   // Label 11306: @713664
     /*  713664 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(713739), // Rule ID 21884 //
     /*  713669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  713680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  713683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  713689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  713718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713737 */     GIR_RootConstrainSelectedInstOperands,
     /*  713738 */     // GIR_Coverage, 21884,
     /*  713738 */     GIR_EraseRootFromParent_Done,
     /*  713739 */   // Label 11307: @713739
     /*  713739 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(713814), // Rule ID 21885 //
     /*  713744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  713755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  713758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  713764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  713793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713812 */     GIR_RootConstrainSelectedInstOperands,
     /*  713813 */     // GIR_Coverage, 21885,
     /*  713813 */     GIR_EraseRootFromParent_Done,
     /*  713814 */   // Label 11308: @713814
     /*  713814 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(713889), // Rule ID 21888 //
     /*  713819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  713830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  713833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  713839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  713868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713887 */     GIR_RootConstrainSelectedInstOperands,
     /*  713888 */     // GIR_Coverage, 21888,
     /*  713888 */     GIR_EraseRootFromParent_Done,
     /*  713889 */   // Label 11309: @713889
     /*  713889 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(713964), // Rule ID 21889 //
     /*  713894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  713905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  713908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  713914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  713943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  713947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713962 */     GIR_RootConstrainSelectedInstOperands,
     /*  713963 */     // GIR_Coverage, 21889,
     /*  713963 */     GIR_EraseRootFromParent_Done,
     /*  713964 */   // Label 11310: @713964
     /*  713964 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(714039), // Rule ID 21892 //
     /*  713969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  713977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  713980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  713983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  713986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  713989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  714015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  714018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714037 */     GIR_RootConstrainSelectedInstOperands,
     /*  714038 */     // GIR_Coverage, 21892,
     /*  714038 */     GIR_EraseRootFromParent_Done,
     /*  714039 */   // Label 11311: @714039
     /*  714039 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(714114), // Rule ID 21893 //
     /*  714044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  714055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  714058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  714061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  714064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  714090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  714093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714112 */     GIR_RootConstrainSelectedInstOperands,
     /*  714113 */     // GIR_Coverage, 21893,
     /*  714113 */     GIR_EraseRootFromParent_Done,
     /*  714114 */   // Label 11312: @714114
     /*  714114 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(714189), // Rule ID 21896 //
     /*  714119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  714136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  714165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  714168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714187 */     GIR_RootConstrainSelectedInstOperands,
     /*  714188 */     // GIR_Coverage, 21896,
     /*  714188 */     GIR_EraseRootFromParent_Done,
     /*  714189 */   // Label 11313: @714189
     /*  714189 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(714264), // Rule ID 21897 //
     /*  714194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  714211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  714240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  714243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714262 */     GIR_RootConstrainSelectedInstOperands,
     /*  714263 */     // GIR_Coverage, 21897,
     /*  714263 */     GIR_EraseRootFromParent_Done,
     /*  714264 */   // Label 11314: @714264
     /*  714264 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(714339), // Rule ID 21900 //
     /*  714269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  714286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714315 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  714315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  714318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714337 */     GIR_RootConstrainSelectedInstOperands,
     /*  714338 */     // GIR_Coverage, 21900,
     /*  714338 */     GIR_EraseRootFromParent_Done,
     /*  714339 */   // Label 11315: @714339
     /*  714339 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(714414), // Rule ID 21901 //
     /*  714344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  714361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  714390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  714393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714412 */     GIR_RootConstrainSelectedInstOperands,
     /*  714413 */     // GIR_Coverage, 21901,
     /*  714413 */     GIR_EraseRootFromParent_Done,
     /*  714414 */   // Label 11316: @714414
     /*  714414 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(714489), // Rule ID 21904 //
     /*  714419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  714436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714465 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  714465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  714468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714487 */     GIR_RootConstrainSelectedInstOperands,
     /*  714488 */     // GIR_Coverage, 21904,
     /*  714488 */     GIR_EraseRootFromParent_Done,
     /*  714489 */   // Label 11317: @714489
     /*  714489 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(714564), // Rule ID 21905 //
     /*  714494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  714505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  714508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  714511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  714514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  714540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  714543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714562 */     GIR_RootConstrainSelectedInstOperands,
     /*  714563 */     // GIR_Coverage, 21905,
     /*  714563 */     GIR_EraseRootFromParent_Done,
     /*  714564 */   // Label 11318: @714564
     /*  714564 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(714639), // Rule ID 21908 //
     /*  714569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  714572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  714618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714637 */     GIR_RootConstrainSelectedInstOperands,
     /*  714638 */     // GIR_Coverage, 21908,
     /*  714638 */     GIR_EraseRootFromParent_Done,
     /*  714639 */   // Label 11319: @714639
     /*  714639 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(714714), // Rule ID 21909 //
     /*  714644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  714647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  714693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714712 */     GIR_RootConstrainSelectedInstOperands,
     /*  714713 */     // GIR_Coverage, 21909,
     /*  714713 */     GIR_EraseRootFromParent_Done,
     /*  714714 */   // Label 11320: @714714
     /*  714714 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(714789), // Rule ID 21912 //
     /*  714719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  714722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714765 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  714768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714787 */     GIR_RootConstrainSelectedInstOperands,
     /*  714788 */     // GIR_Coverage, 21912,
     /*  714788 */     GIR_EraseRootFromParent_Done,
     /*  714789 */   // Label 11321: @714789
     /*  714789 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(714864), // Rule ID 21913 //
     /*  714794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  714797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  714843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714862 */     GIR_RootConstrainSelectedInstOperands,
     /*  714863 */     // GIR_Coverage, 21913,
     /*  714863 */     GIR_EraseRootFromParent_Done,
     /*  714864 */   // Label 11322: @714864
     /*  714864 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(714939), // Rule ID 21916 //
     /*  714869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  714872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  714918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714937 */     GIR_RootConstrainSelectedInstOperands,
     /*  714938 */     // GIR_Coverage, 21916,
     /*  714938 */     GIR_EraseRootFromParent_Done,
     /*  714939 */   // Label 11323: @714939
     /*  714939 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(715014), // Rule ID 21917 //
     /*  714944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  714947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  714952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  714993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  714997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715012 */     GIR_RootConstrainSelectedInstOperands,
     /*  715013 */     // GIR_Coverage, 21917,
     /*  715013 */     GIR_EraseRootFromParent_Done,
     /*  715014 */   // Label 11324: @715014
     /*  715014 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(715089), // Rule ID 21920 //
     /*  715019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  715036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  715068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715087 */     GIR_RootConstrainSelectedInstOperands,
     /*  715088 */     // GIR_Coverage, 21920,
     /*  715088 */     GIR_EraseRootFromParent_Done,
     /*  715089 */   // Label 11325: @715089
     /*  715089 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(715164), // Rule ID 21921 //
     /*  715094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  715111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  715143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715162 */     GIR_RootConstrainSelectedInstOperands,
     /*  715163 */     // GIR_Coverage, 21921,
     /*  715163 */     GIR_EraseRootFromParent_Done,
     /*  715164 */   // Label 11326: @715164
     /*  715164 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(715239), // Rule ID 21924 //
     /*  715169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  715186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  715218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715237 */     GIR_RootConstrainSelectedInstOperands,
     /*  715238 */     // GIR_Coverage, 21924,
     /*  715238 */     GIR_EraseRootFromParent_Done,
     /*  715239 */   // Label 11327: @715239
     /*  715239 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(715314), // Rule ID 21925 //
     /*  715244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  715261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  715293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715312 */     GIR_RootConstrainSelectedInstOperands,
     /*  715313 */     // GIR_Coverage, 21925,
     /*  715313 */     GIR_EraseRootFromParent_Done,
     /*  715314 */   // Label 11328: @715314
     /*  715314 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(715389), // Rule ID 21928 //
     /*  715319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  715336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  715368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715387 */     GIR_RootConstrainSelectedInstOperands,
     /*  715388 */     // GIR_Coverage, 21928,
     /*  715388 */     GIR_EraseRootFromParent_Done,
     /*  715389 */   // Label 11329: @715389
     /*  715389 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(715464), // Rule ID 21929 //
     /*  715394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  715411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  715443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715462 */     GIR_RootConstrainSelectedInstOperands,
     /*  715463 */     // GIR_Coverage, 21929,
     /*  715463 */     GIR_EraseRootFromParent_Done,
     /*  715464 */   // Label 11330: @715464
     /*  715464 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(715539), // Rule ID 21932 //
     /*  715469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  715486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  715489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  715518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715537 */     GIR_RootConstrainSelectedInstOperands,
     /*  715538 */     // GIR_Coverage, 21932,
     /*  715538 */     GIR_EraseRootFromParent_Done,
     /*  715539 */   // Label 11331: @715539
     /*  715539 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(715614), // Rule ID 21933 //
     /*  715544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  715561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  715564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  715593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715612 */     GIR_RootConstrainSelectedInstOperands,
     /*  715613 */     // GIR_Coverage, 21933,
     /*  715613 */     GIR_EraseRootFromParent_Done,
     /*  715614 */   // Label 11332: @715614
     /*  715614 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(715689), // Rule ID 21936 //
     /*  715619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  715636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  715639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  715668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715687 */     GIR_RootConstrainSelectedInstOperands,
     /*  715688 */     // GIR_Coverage, 21936,
     /*  715688 */     GIR_EraseRootFromParent_Done,
     /*  715689 */   // Label 11333: @715689
     /*  715689 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(715764), // Rule ID 21937 //
     /*  715694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  715711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  715714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  715743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715762 */     GIR_RootConstrainSelectedInstOperands,
     /*  715763 */     // GIR_Coverage, 21937,
     /*  715763 */     GIR_EraseRootFromParent_Done,
     /*  715764 */   // Label 11334: @715764
     /*  715764 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(715839), // Rule ID 21940 //
     /*  715769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  715786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  715789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  715815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  715818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715837 */     GIR_RootConstrainSelectedInstOperands,
     /*  715838 */     // GIR_Coverage, 21940,
     /*  715838 */     GIR_EraseRootFromParent_Done,
     /*  715839 */   // Label 11335: @715839
     /*  715839 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(715914), // Rule ID 21941 //
     /*  715844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  715861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  715864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  715890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  715893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715912 */     GIR_RootConstrainSelectedInstOperands,
     /*  715913 */     // GIR_Coverage, 21941,
     /*  715913 */     GIR_EraseRootFromParent_Done,
     /*  715914 */   // Label 11336: @715914
     /*  715914 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(715989), // Rule ID 21944 //
     /*  715919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  715927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  715930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  715933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  715936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  715939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  715968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  715972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715987 */     GIR_RootConstrainSelectedInstOperands,
     /*  715988 */     // GIR_Coverage, 21944,
     /*  715988 */     GIR_EraseRootFromParent_Done,
     /*  715989 */   // Label 11337: @715989
     /*  715989 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(716064), // Rule ID 21945 //
     /*  715994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  716011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  716043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716062 */     GIR_RootConstrainSelectedInstOperands,
     /*  716063 */     // GIR_Coverage, 21945,
     /*  716063 */     GIR_EraseRootFromParent_Done,
     /*  716064 */   // Label 11338: @716064
     /*  716064 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(716139), // Rule ID 21948 //
     /*  716069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  716080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  716083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  716086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  716089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  716118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716137 */     GIR_RootConstrainSelectedInstOperands,
     /*  716138 */     // GIR_Coverage, 21948,
     /*  716138 */     GIR_EraseRootFromParent_Done,
     /*  716139 */   // Label 11339: @716139
     /*  716139 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(716214), // Rule ID 21949 //
     /*  716144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  716155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  716158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  716161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  716164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  716193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716212 */     GIR_RootConstrainSelectedInstOperands,
     /*  716213 */     // GIR_Coverage, 21949,
     /*  716213 */     GIR_EraseRootFromParent_Done,
     /*  716214 */   // Label 11340: @716214
     /*  716214 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(716289), // Rule ID 21952 //
     /*  716219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  716230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  716233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  716236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  716239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  716268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716287 */     GIR_RootConstrainSelectedInstOperands,
     /*  716288 */     // GIR_Coverage, 21952,
     /*  716288 */     GIR_EraseRootFromParent_Done,
     /*  716289 */   // Label 11341: @716289
     /*  716289 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(716364), // Rule ID 21953 //
     /*  716294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  716305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  716308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  716311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  716314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  716343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716362 */     GIR_RootConstrainSelectedInstOperands,
     /*  716363 */     // GIR_Coverage, 21953,
     /*  716363 */     GIR_EraseRootFromParent_Done,
     /*  716364 */   // Label 11342: @716364
     /*  716364 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(716439), // Rule ID 21956 //
     /*  716369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  716372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  716418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716437 */     GIR_RootConstrainSelectedInstOperands,
     /*  716438 */     // GIR_Coverage, 21956,
     /*  716438 */     GIR_EraseRootFromParent_Done,
     /*  716439 */   // Label 11343: @716439
     /*  716439 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(716514), // Rule ID 21957 //
     /*  716444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  716447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  716493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716512 */     GIR_RootConstrainSelectedInstOperands,
     /*  716513 */     // GIR_Coverage, 21957,
     /*  716513 */     GIR_EraseRootFromParent_Done,
     /*  716514 */   // Label 11344: @716514
     /*  716514 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(716589), // Rule ID 21960 //
     /*  716519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  716536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  716568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716587 */     GIR_RootConstrainSelectedInstOperands,
     /*  716588 */     // GIR_Coverage, 21960,
     /*  716588 */     GIR_EraseRootFromParent_Done,
     /*  716589 */   // Label 11345: @716589
     /*  716589 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(716664), // Rule ID 21961 //
     /*  716594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  716611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  716643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716662 */     GIR_RootConstrainSelectedInstOperands,
     /*  716663 */     // GIR_Coverage, 21961,
     /*  716663 */     GIR_EraseRootFromParent_Done,
     /*  716664 */   // Label 11346: @716664
     /*  716664 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(716739), // Rule ID 21964 //
     /*  716669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  716686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716715 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  716718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716737 */     GIR_RootConstrainSelectedInstOperands,
     /*  716738 */     // GIR_Coverage, 21964,
     /*  716738 */     GIR_EraseRootFromParent_Done,
     /*  716739 */   // Label 11347: @716739
     /*  716739 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(716814), // Rule ID 21965 //
     /*  716744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  716761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  716793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716812 */     GIR_RootConstrainSelectedInstOperands,
     /*  716813 */     // GIR_Coverage, 21965,
     /*  716813 */     GIR_EraseRootFromParent_Done,
     /*  716814 */   // Label 11348: @716814
     /*  716814 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(716889), // Rule ID 21968 //
     /*  716819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  716836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  716868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716887 */     GIR_RootConstrainSelectedInstOperands,
     /*  716888 */     // GIR_Coverage, 21968,
     /*  716888 */     GIR_EraseRootFromParent_Done,
     /*  716889 */   // Label 11349: @716889
     /*  716889 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(716964), // Rule ID 21969 //
     /*  716894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  716911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  716943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  716947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716962 */     GIR_RootConstrainSelectedInstOperands,
     /*  716963 */     // GIR_Coverage, 21969,
     /*  716963 */     GIR_EraseRootFromParent_Done,
     /*  716964 */   // Label 11350: @716964
     /*  716964 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(717039), // Rule ID 21972 //
     /*  716969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  716977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  716980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  716983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  716986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  716989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  717018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717037 */     GIR_RootConstrainSelectedInstOperands,
     /*  717038 */     // GIR_Coverage, 21972,
     /*  717038 */     GIR_EraseRootFromParent_Done,
     /*  717039 */   // Label 11351: @717039
     /*  717039 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(717114), // Rule ID 21973 //
     /*  717044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  717061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  717093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717112 */     GIR_RootConstrainSelectedInstOperands,
     /*  717113 */     // GIR_Coverage, 21973,
     /*  717113 */     GIR_EraseRootFromParent_Done,
     /*  717114 */   // Label 11352: @717114
     /*  717114 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(717189), // Rule ID 21976 //
     /*  717119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  717136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  717168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717187 */     GIR_RootConstrainSelectedInstOperands,
     /*  717188 */     // GIR_Coverage, 21976,
     /*  717188 */     GIR_EraseRootFromParent_Done,
     /*  717189 */   // Label 11353: @717189
     /*  717189 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(717264), // Rule ID 21977 //
     /*  717194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  717211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  717243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717262 */     GIR_RootConstrainSelectedInstOperands,
     /*  717263 */     // GIR_Coverage, 21977,
     /*  717263 */     GIR_EraseRootFromParent_Done,
     /*  717264 */   // Label 11354: @717264
     /*  717264 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(717339), // Rule ID 21980 //
     /*  717269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  717286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  717318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717337 */     GIR_RootConstrainSelectedInstOperands,
     /*  717338 */     // GIR_Coverage, 21980,
     /*  717338 */     GIR_EraseRootFromParent_Done,
     /*  717339 */   // Label 11355: @717339
     /*  717339 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(717414), // Rule ID 21981 //
     /*  717344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  717361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  717393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717412 */     GIR_RootConstrainSelectedInstOperands,
     /*  717413 */     // GIR_Coverage, 21981,
     /*  717413 */     GIR_EraseRootFromParent_Done,
     /*  717414 */   // Label 11356: @717414
     /*  717414 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(717489), // Rule ID 21984 //
     /*  717419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  717436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717465 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  717468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717487 */     GIR_RootConstrainSelectedInstOperands,
     /*  717488 */     // GIR_Coverage, 21984,
     /*  717488 */     GIR_EraseRootFromParent_Done,
     /*  717489 */   // Label 11357: @717489
     /*  717489 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(717564), // Rule ID 21985 //
     /*  717494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  717511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  717543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717562 */     GIR_RootConstrainSelectedInstOperands,
     /*  717563 */     // GIR_Coverage, 21985,
     /*  717563 */     GIR_EraseRootFromParent_Done,
     /*  717564 */   // Label 11358: @717564
     /*  717564 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(717639), // Rule ID 21988 //
     /*  717569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  717586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  717618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717637 */     GIR_RootConstrainSelectedInstOperands,
     /*  717638 */     // GIR_Coverage, 21988,
     /*  717638 */     GIR_EraseRootFromParent_Done,
     /*  717639 */   // Label 11359: @717639
     /*  717639 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(717714), // Rule ID 21989 //
     /*  717644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  717661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  717693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717712 */     GIR_RootConstrainSelectedInstOperands,
     /*  717713 */     // GIR_Coverage, 21989,
     /*  717713 */     GIR_EraseRootFromParent_Done,
     /*  717714 */   // Label 11360: @717714
     /*  717714 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(717789), // Rule ID 21992 //
     /*  717719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  717736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  717768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717787 */     GIR_RootConstrainSelectedInstOperands,
     /*  717788 */     // GIR_Coverage, 21992,
     /*  717788 */     GIR_EraseRootFromParent_Done,
     /*  717789 */   // Label 11361: @717789
     /*  717789 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(717864), // Rule ID 21993 //
     /*  717794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  717811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  717843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717862 */     GIR_RootConstrainSelectedInstOperands,
     /*  717863 */     // GIR_Coverage, 21993,
     /*  717863 */     GIR_EraseRootFromParent_Done,
     /*  717864 */   // Label 11362: @717864
     /*  717864 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(717939), // Rule ID 21996 //
     /*  717869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  717872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  717918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717937 */     GIR_RootConstrainSelectedInstOperands,
     /*  717938 */     // GIR_Coverage, 21996,
     /*  717938 */     GIR_EraseRootFromParent_Done,
     /*  717939 */   // Label 11363: @717939
     /*  717939 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(718014), // Rule ID 21997 //
     /*  717944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  717947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  717952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  717993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  717997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718012 */     GIR_RootConstrainSelectedInstOperands,
     /*  718013 */     // GIR_Coverage, 21997,
     /*  718013 */     GIR_EraseRootFromParent_Done,
     /*  718014 */   // Label 11364: @718014
     /*  718014 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(718089), // Rule ID 22000 //
     /*  718019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  718027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  718068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718087 */     GIR_RootConstrainSelectedInstOperands,
     /*  718088 */     // GIR_Coverage, 22000,
     /*  718088 */     GIR_EraseRootFromParent_Done,
     /*  718089 */   // Label 11365: @718089
     /*  718089 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(718164), // Rule ID 22001 //
     /*  718094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  718102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  718143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718162 */     GIR_RootConstrainSelectedInstOperands,
     /*  718163 */     // GIR_Coverage, 22001,
     /*  718163 */     GIR_EraseRootFromParent_Done,
     /*  718164 */   // Label 11366: @718164
     /*  718164 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(718239), // Rule ID 22004 //
     /*  718169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  718177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  718218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718237 */     GIR_RootConstrainSelectedInstOperands,
     /*  718238 */     // GIR_Coverage, 22004,
     /*  718238 */     GIR_EraseRootFromParent_Done,
     /*  718239 */   // Label 11367: @718239
     /*  718239 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(718314), // Rule ID 22005 //
     /*  718244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  718252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  718293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718312 */     GIR_RootConstrainSelectedInstOperands,
     /*  718313 */     // GIR_Coverage, 22005,
     /*  718313 */     GIR_EraseRootFromParent_Done,
     /*  718314 */   // Label 11368: @718314
     /*  718314 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(718389), // Rule ID 22008 //
     /*  718319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  718336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  718368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718387 */     GIR_RootConstrainSelectedInstOperands,
     /*  718388 */     // GIR_Coverage, 22008,
     /*  718388 */     GIR_EraseRootFromParent_Done,
     /*  718389 */   // Label 11369: @718389
     /*  718389 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(718464), // Rule ID 22009 //
     /*  718394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  718411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  718443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718462 */     GIR_RootConstrainSelectedInstOperands,
     /*  718463 */     // GIR_Coverage, 22009,
     /*  718463 */     GIR_EraseRootFromParent_Done,
     /*  718464 */   // Label 11370: @718464
     /*  718464 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(718539), // Rule ID 22012 //
     /*  718469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  718486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718515 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  718518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718537 */     GIR_RootConstrainSelectedInstOperands,
     /*  718538 */     // GIR_Coverage, 22012,
     /*  718538 */     GIR_EraseRootFromParent_Done,
     /*  718539 */   // Label 11371: @718539
     /*  718539 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(718614), // Rule ID 22013 //
     /*  718544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  718561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  718593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718612 */     GIR_RootConstrainSelectedInstOperands,
     /*  718613 */     // GIR_Coverage, 22013,
     /*  718613 */     GIR_EraseRootFromParent_Done,
     /*  718614 */   // Label 11372: @718614
     /*  718614 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(718689), // Rule ID 22016 //
     /*  718619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  718636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718665 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  718668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718687 */     GIR_RootConstrainSelectedInstOperands,
     /*  718688 */     // GIR_Coverage, 22016,
     /*  718688 */     GIR_EraseRootFromParent_Done,
     /*  718689 */   // Label 11373: @718689
     /*  718689 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(718764), // Rule ID 22017 //
     /*  718694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  718705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  718708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  718711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  718714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  718743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718762 */     GIR_RootConstrainSelectedInstOperands,
     /*  718763 */     // GIR_Coverage, 22017,
     /*  718763 */     GIR_EraseRootFromParent_Done,
     /*  718764 */   // Label 11374: @718764
     /*  718764 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(718839), // Rule ID 22020 //
     /*  718769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  718780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  718783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  718786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  718789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  718818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718837 */     GIR_RootConstrainSelectedInstOperands,
     /*  718838 */     // GIR_Coverage, 22020,
     /*  718838 */     GIR_EraseRootFromParent_Done,
     /*  718839 */   // Label 11375: @718839
     /*  718839 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(718914), // Rule ID 22021 //
     /*  718844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  718855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  718858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  718861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  718864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  718893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718912 */     GIR_RootConstrainSelectedInstOperands,
     /*  718913 */     // GIR_Coverage, 22021,
     /*  718913 */     GIR_EraseRootFromParent_Done,
     /*  718914 */   // Label 11376: @718914
     /*  718914 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(718989), // Rule ID 22024 //
     /*  718919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  718927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  718930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  718933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  718936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  718939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  718968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  718972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718987 */     GIR_RootConstrainSelectedInstOperands,
     /*  718988 */     // GIR_Coverage, 22024,
     /*  718988 */     GIR_EraseRootFromParent_Done,
     /*  718989 */   // Label 11377: @718989
     /*  718989 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(719064), // Rule ID 22025 //
     /*  718994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  719005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  719008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  719011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  719014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  719043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719062 */     GIR_RootConstrainSelectedInstOperands,
     /*  719063 */     // GIR_Coverage, 22025,
     /*  719063 */     GIR_EraseRootFromParent_Done,
     /*  719064 */   // Label 11378: @719064
     /*  719064 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(719139), // Rule ID 22028 //
     /*  719069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  719080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  719083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  719086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  719089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  719118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719137 */     GIR_RootConstrainSelectedInstOperands,
     /*  719138 */     // GIR_Coverage, 22028,
     /*  719138 */     GIR_EraseRootFromParent_Done,
     /*  719139 */   // Label 11379: @719139
     /*  719139 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(719214), // Rule ID 22029 //
     /*  719144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  719155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  719158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  719161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  719164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  719193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719212 */     GIR_RootConstrainSelectedInstOperands,
     /*  719213 */     // GIR_Coverage, 22029,
     /*  719213 */     GIR_EraseRootFromParent_Done,
     /*  719214 */   // Label 11380: @719214
     /*  719214 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(719289), // Rule ID 22032 //
     /*  719219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  719230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  719233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  719236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  719239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  719268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719287 */     GIR_RootConstrainSelectedInstOperands,
     /*  719288 */     // GIR_Coverage, 22032,
     /*  719288 */     GIR_EraseRootFromParent_Done,
     /*  719289 */   // Label 11381: @719289
     /*  719289 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(719364), // Rule ID 22033 //
     /*  719294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  719305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  719308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  719311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  719314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  719343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719362 */     GIR_RootConstrainSelectedInstOperands,
     /*  719363 */     // GIR_Coverage, 22033,
     /*  719363 */     GIR_EraseRootFromParent_Done,
     /*  719364 */   // Label 11382: @719364
     /*  719364 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(719439), // Rule ID 22036 //
     /*  719369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  719380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  719383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  719386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  719389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  719418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719437 */     GIR_RootConstrainSelectedInstOperands,
     /*  719438 */     // GIR_Coverage, 22036,
     /*  719438 */     GIR_EraseRootFromParent_Done,
     /*  719439 */   // Label 11383: @719439
     /*  719439 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(719514), // Rule ID 22037 //
     /*  719444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  719455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  719458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  719461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  719464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  719493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719512 */     GIR_RootConstrainSelectedInstOperands,
     /*  719513 */     // GIR_Coverage, 22037,
     /*  719513 */     GIR_EraseRootFromParent_Done,
     /*  719514 */   // Label 11384: @719514
     /*  719514 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(719589), // Rule ID 22040 //
     /*  719519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  719530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  719533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  719536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  719539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719565 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  719568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719587 */     GIR_RootConstrainSelectedInstOperands,
     /*  719588 */     // GIR_Coverage, 22040,
     /*  719588 */     GIR_EraseRootFromParent_Done,
     /*  719589 */   // Label 11385: @719589
     /*  719589 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(719664), // Rule ID 22041 //
     /*  719594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  719605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  719608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  719611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  719614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  719643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719662 */     GIR_RootConstrainSelectedInstOperands,
     /*  719663 */     // GIR_Coverage, 22041,
     /*  719663 */     GIR_EraseRootFromParent_Done,
     /*  719664 */   // Label 11386: @719664
     /*  719664 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(719739), // Rule ID 22044 //
     /*  719669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  719718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719737 */     GIR_RootConstrainSelectedInstOperands,
     /*  719738 */     // GIR_Coverage, 22044,
     /*  719738 */     GIR_EraseRootFromParent_Done,
     /*  719739 */   // Label 11387: @719739
     /*  719739 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(719814), // Rule ID 22045 //
     /*  719744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  719793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719812 */     GIR_RootConstrainSelectedInstOperands,
     /*  719813 */     // GIR_Coverage, 22045,
     /*  719813 */     GIR_EraseRootFromParent_Done,
     /*  719814 */   // Label 11388: @719814
     /*  719814 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(719889), // Rule ID 22048 //
     /*  719819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  719830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  719833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  719836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  719839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  719868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719887 */     GIR_RootConstrainSelectedInstOperands,
     /*  719888 */     // GIR_Coverage, 22048,
     /*  719888 */     GIR_EraseRootFromParent_Done,
     /*  719889 */   // Label 11389: @719889
     /*  719889 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(719964), // Rule ID 22049 //
     /*  719894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  719905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  719908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  719911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  719914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  719943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  719947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719962 */     GIR_RootConstrainSelectedInstOperands,
     /*  719963 */     // GIR_Coverage, 22049,
     /*  719963 */     GIR_EraseRootFromParent_Done,
     /*  719964 */   // Label 11390: @719964
     /*  719964 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(720039), // Rule ID 22052 //
     /*  719969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  719977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  719980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  719983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  719986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  719989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  720018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720037 */     GIR_RootConstrainSelectedInstOperands,
     /*  720038 */     // GIR_Coverage, 22052,
     /*  720038 */     GIR_EraseRootFromParent_Done,
     /*  720039 */   // Label 11391: @720039
     /*  720039 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(720114), // Rule ID 22053 //
     /*  720044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  720061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  720064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  720093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720112 */     GIR_RootConstrainSelectedInstOperands,
     /*  720113 */     // GIR_Coverage, 22053,
     /*  720113 */     GIR_EraseRootFromParent_Done,
     /*  720114 */   // Label 11392: @720114
     /*  720114 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(720189), // Rule ID 22056 //
     /*  720119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  720136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  720139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720165 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  720168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720187 */     GIR_RootConstrainSelectedInstOperands,
     /*  720188 */     // GIR_Coverage, 22056,
     /*  720188 */     GIR_EraseRootFromParent_Done,
     /*  720189 */   // Label 11393: @720189
     /*  720189 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(720264), // Rule ID 22057 //
     /*  720194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  720211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  720214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  720243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720262 */     GIR_RootConstrainSelectedInstOperands,
     /*  720263 */     // GIR_Coverage, 22057,
     /*  720263 */     GIR_EraseRootFromParent_Done,
     /*  720264 */   // Label 11394: @720264
     /*  720264 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(720339), // Rule ID 22060 //
     /*  720269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  720286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  720318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720337 */     GIR_RootConstrainSelectedInstOperands,
     /*  720338 */     // GIR_Coverage, 22060,
     /*  720338 */     GIR_EraseRootFromParent_Done,
     /*  720339 */   // Label 11395: @720339
     /*  720339 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(720414), // Rule ID 22061 //
     /*  720344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  720361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  720393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720412 */     GIR_RootConstrainSelectedInstOperands,
     /*  720413 */     // GIR_Coverage, 22061,
     /*  720413 */     GIR_EraseRootFromParent_Done,
     /*  720414 */   // Label 11396: @720414
     /*  720414 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(720489), // Rule ID 22064 //
     /*  720419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  720436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720465 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  720468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720487 */     GIR_RootConstrainSelectedInstOperands,
     /*  720488 */     // GIR_Coverage, 22064,
     /*  720488 */     GIR_EraseRootFromParent_Done,
     /*  720489 */   // Label 11397: @720489
     /*  720489 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(720564), // Rule ID 22065 //
     /*  720494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  720511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  720543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720562 */     GIR_RootConstrainSelectedInstOperands,
     /*  720563 */     // GIR_Coverage, 22065,
     /*  720563 */     GIR_EraseRootFromParent_Done,
     /*  720564 */   // Label 11398: @720564
     /*  720564 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(720639), // Rule ID 22068 //
     /*  720569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  720586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  720618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720637 */     GIR_RootConstrainSelectedInstOperands,
     /*  720638 */     // GIR_Coverage, 22068,
     /*  720638 */     GIR_EraseRootFromParent_Done,
     /*  720639 */   // Label 11399: @720639
     /*  720639 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(720714), // Rule ID 22069 //
     /*  720644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  720661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  720664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  720693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720712 */     GIR_RootConstrainSelectedInstOperands,
     /*  720713 */     // GIR_Coverage, 22069,
     /*  720713 */     GIR_EraseRootFromParent_Done,
     /*  720714 */   // Label 11400: @720714
     /*  720714 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(720789), // Rule ID 22072 //
     /*  720719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  720736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  720739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  720768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720787 */     GIR_RootConstrainSelectedInstOperands,
     /*  720788 */     // GIR_Coverage, 22072,
     /*  720788 */     GIR_EraseRootFromParent_Done,
     /*  720789 */   // Label 11401: @720789
     /*  720789 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(720864), // Rule ID 22073 //
     /*  720794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  720811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  720814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  720843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720862 */     GIR_RootConstrainSelectedInstOperands,
     /*  720863 */     // GIR_Coverage, 22073,
     /*  720863 */     GIR_EraseRootFromParent_Done,
     /*  720864 */   // Label 11402: @720864
     /*  720864 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(720939), // Rule ID 22076 //
     /*  720869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  720886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  720889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  720918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720937 */     GIR_RootConstrainSelectedInstOperands,
     /*  720938 */     // GIR_Coverage, 22076,
     /*  720938 */     GIR_EraseRootFromParent_Done,
     /*  720939 */   // Label 11403: @720939
     /*  720939 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(721014), // Rule ID 22077 //
     /*  720944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  720952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  720961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  720964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  720993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  720997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721012 */     GIR_RootConstrainSelectedInstOperands,
     /*  721013 */     // GIR_Coverage, 22077,
     /*  721013 */     GIR_EraseRootFromParent_Done,
     /*  721014 */   // Label 11404: @721014
     /*  721014 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(721089), // Rule ID 22080 //
     /*  721019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  721036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721065 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  721068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721087 */     GIR_RootConstrainSelectedInstOperands,
     /*  721088 */     // GIR_Coverage, 22080,
     /*  721088 */     GIR_EraseRootFromParent_Done,
     /*  721089 */   // Label 11405: @721089
     /*  721089 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(721164), // Rule ID 22081 //
     /*  721094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  721111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  721143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721162 */     GIR_RootConstrainSelectedInstOperands,
     /*  721163 */     // GIR_Coverage, 22081,
     /*  721163 */     GIR_EraseRootFromParent_Done,
     /*  721164 */   // Label 11406: @721164
     /*  721164 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(721239), // Rule ID 22084 //
     /*  721169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  721186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  721218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721237 */     GIR_RootConstrainSelectedInstOperands,
     /*  721238 */     // GIR_Coverage, 22084,
     /*  721238 */     GIR_EraseRootFromParent_Done,
     /*  721239 */   // Label 11407: @721239
     /*  721239 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(721314), // Rule ID 22085 //
     /*  721244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  721261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  721293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721312 */     GIR_RootConstrainSelectedInstOperands,
     /*  721313 */     // GIR_Coverage, 22085,
     /*  721313 */     GIR_EraseRootFromParent_Done,
     /*  721314 */   // Label 11408: @721314
     /*  721314 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(721389), // Rule ID 22088 //
     /*  721319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  721336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  721368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721387 */     GIR_RootConstrainSelectedInstOperands,
     /*  721388 */     // GIR_Coverage, 22088,
     /*  721388 */     GIR_EraseRootFromParent_Done,
     /*  721389 */   // Label 11409: @721389
     /*  721389 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(721464), // Rule ID 22089 //
     /*  721394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  721411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  721443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721462 */     GIR_RootConstrainSelectedInstOperands,
     /*  721463 */     // GIR_Coverage, 22089,
     /*  721463 */     GIR_EraseRootFromParent_Done,
     /*  721464 */   // Label 11410: @721464
     /*  721464 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(721539), // Rule ID 22092 //
     /*  721469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  721486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  721518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721537 */     GIR_RootConstrainSelectedInstOperands,
     /*  721538 */     // GIR_Coverage, 22092,
     /*  721538 */     GIR_EraseRootFromParent_Done,
     /*  721539 */   // Label 11411: @721539
     /*  721539 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(721614), // Rule ID 22093 //
     /*  721544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  721552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  721561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  721593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721612 */     GIR_RootConstrainSelectedInstOperands,
     /*  721613 */     // GIR_Coverage, 22093,
     /*  721613 */     GIR_EraseRootFromParent_Done,
     /*  721614 */   // Label 11412: @721614
     /*  721614 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(721689), // Rule ID 22096 //
     /*  721619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  721627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  721636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721665 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  721668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721687 */     GIR_RootConstrainSelectedInstOperands,
     /*  721688 */     // GIR_Coverage, 22096,
     /*  721688 */     GIR_EraseRootFromParent_Done,
     /*  721689 */   // Label 11413: @721689
     /*  721689 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(721764), // Rule ID 22097 //
     /*  721694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  721702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  721711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  721743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721762 */     GIR_RootConstrainSelectedInstOperands,
     /*  721763 */     // GIR_Coverage, 22097,
     /*  721763 */     GIR_EraseRootFromParent_Done,
     /*  721764 */   // Label 11414: @721764
     /*  721764 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(721839), // Rule ID 22100 //
     /*  721769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  721777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  721786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721815 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  721818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721837 */     GIR_RootConstrainSelectedInstOperands,
     /*  721838 */     // GIR_Coverage, 22100,
     /*  721838 */     GIR_EraseRootFromParent_Done,
     /*  721839 */   // Label 11415: @721839
     /*  721839 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(721914), // Rule ID 22101 //
     /*  721844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  721852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  721861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  721893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721912 */     GIR_RootConstrainSelectedInstOperands,
     /*  721913 */     // GIR_Coverage, 22101,
     /*  721913 */     GIR_EraseRootFromParent_Done,
     /*  721914 */   // Label 11416: @721914
     /*  721914 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(721989), // Rule ID 22104 //
     /*  721919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  721927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  721936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  721968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  721972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721987 */     GIR_RootConstrainSelectedInstOperands,
     /*  721988 */     // GIR_Coverage, 22104,
     /*  721988 */     GIR_EraseRootFromParent_Done,
     /*  721989 */   // Label 11417: @721989
     /*  721989 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(722064), // Rule ID 22105 //
     /*  721994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  722005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  722008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  722011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  722014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  722043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722062 */     GIR_RootConstrainSelectedInstOperands,
     /*  722063 */     // GIR_Coverage, 22105,
     /*  722063 */     GIR_EraseRootFromParent_Done,
     /*  722064 */   // Label 11418: @722064
     /*  722064 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(722139), // Rule ID 22108 //
     /*  722069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  722086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  722118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722137 */     GIR_RootConstrainSelectedInstOperands,
     /*  722138 */     // GIR_Coverage, 22108,
     /*  722138 */     GIR_EraseRootFromParent_Done,
     /*  722139 */   // Label 11419: @722139
     /*  722139 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(722214), // Rule ID 22109 //
     /*  722144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  722161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  722193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722212 */     GIR_RootConstrainSelectedInstOperands,
     /*  722213 */     // GIR_Coverage, 22109,
     /*  722213 */     GIR_EraseRootFromParent_Done,
     /*  722214 */   // Label 11420: @722214
     /*  722214 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(722289), // Rule ID 22112 //
     /*  722219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  722236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722265 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  722268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722287 */     GIR_RootConstrainSelectedInstOperands,
     /*  722288 */     // GIR_Coverage, 22112,
     /*  722288 */     GIR_EraseRootFromParent_Done,
     /*  722289 */   // Label 11421: @722289
     /*  722289 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(722364), // Rule ID 22113 //
     /*  722294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  722311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  722343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722362 */     GIR_RootConstrainSelectedInstOperands,
     /*  722363 */     // GIR_Coverage, 22113,
     /*  722363 */     GIR_EraseRootFromParent_Done,
     /*  722364 */   // Label 11422: @722364
     /*  722364 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(722439), // Rule ID 22116 //
     /*  722369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  722380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  722383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  722386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  722389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722415 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  722418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722437 */     GIR_RootConstrainSelectedInstOperands,
     /*  722438 */     // GIR_Coverage, 22116,
     /*  722438 */     GIR_EraseRootFromParent_Done,
     /*  722439 */   // Label 11423: @722439
     /*  722439 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(722514), // Rule ID 22117 //
     /*  722444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  722455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  722458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  722461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  722464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  722493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722512 */     GIR_RootConstrainSelectedInstOperands,
     /*  722513 */     // GIR_Coverage, 22117,
     /*  722513 */     GIR_EraseRootFromParent_Done,
     /*  722514 */   // Label 11424: @722514
     /*  722514 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(722589), // Rule ID 22120 //
     /*  722519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  722530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  722533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  722536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  722539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  722568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722587 */     GIR_RootConstrainSelectedInstOperands,
     /*  722588 */     // GIR_Coverage, 22120,
     /*  722588 */     GIR_EraseRootFromParent_Done,
     /*  722589 */   // Label 11425: @722589
     /*  722589 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(722664), // Rule ID 22121 //
     /*  722594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  722605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  722608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  722611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  722614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  722643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722662 */     GIR_RootConstrainSelectedInstOperands,
     /*  722663 */     // GIR_Coverage, 22121,
     /*  722663 */     GIR_EraseRootFromParent_Done,
     /*  722664 */   // Label 11426: @722664
     /*  722664 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(722739), // Rule ID 22124 //
     /*  722669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  722686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  722718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722737 */     GIR_RootConstrainSelectedInstOperands,
     /*  722738 */     // GIR_Coverage, 22124,
     /*  722738 */     GIR_EraseRootFromParent_Done,
     /*  722739 */   // Label 11427: @722739
     /*  722739 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(722814), // Rule ID 22125 //
     /*  722744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  722755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  722758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  722761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  722764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  722793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722812 */     GIR_RootConstrainSelectedInstOperands,
     /*  722813 */     // GIR_Coverage, 22125,
     /*  722813 */     GIR_EraseRootFromParent_Done,
     /*  722814 */   // Label 11428: @722814
     /*  722814 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(722889), // Rule ID 22128 //
     /*  722819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  722830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  722833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  722836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  722839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  722868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722887 */     GIR_RootConstrainSelectedInstOperands,
     /*  722888 */     // GIR_Coverage, 22128,
     /*  722888 */     GIR_EraseRootFromParent_Done,
     /*  722889 */   // Label 11429: @722889
     /*  722889 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(722964), // Rule ID 22129 //
     /*  722894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  722905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  722908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  722911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  722914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  722943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  722947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722962 */     GIR_RootConstrainSelectedInstOperands,
     /*  722963 */     // GIR_Coverage, 22129,
     /*  722963 */     GIR_EraseRootFromParent_Done,
     /*  722964 */   // Label 11430: @722964
     /*  722964 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(723039), // Rule ID 22132 //
     /*  722969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  722977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  722980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  722983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  722986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  722989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723015 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  723018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723037 */     GIR_RootConstrainSelectedInstOperands,
     /*  723038 */     // GIR_Coverage, 22132,
     /*  723038 */     GIR_EraseRootFromParent_Done,
     /*  723039 */   // Label 11431: @723039
     /*  723039 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(723114), // Rule ID 22133 //
     /*  723044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  723055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  723058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  723061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  723064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  723093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723112 */     GIR_RootConstrainSelectedInstOperands,
     /*  723113 */     // GIR_Coverage, 22133,
     /*  723113 */     GIR_EraseRootFromParent_Done,
     /*  723114 */   // Label 11432: @723114
     /*  723114 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(723189), // Rule ID 22136 //
     /*  723119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  723136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723165 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  723168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723187 */     GIR_RootConstrainSelectedInstOperands,
     /*  723188 */     // GIR_Coverage, 22136,
     /*  723188 */     GIR_EraseRootFromParent_Done,
     /*  723189 */   // Label 11433: @723189
     /*  723189 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(723264), // Rule ID 22137 //
     /*  723194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  723211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  723243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723262 */     GIR_RootConstrainSelectedInstOperands,
     /*  723263 */     // GIR_Coverage, 22137,
     /*  723263 */     GIR_EraseRootFromParent_Done,
     /*  723264 */   // Label 11434: @723264
     /*  723264 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(723339), // Rule ID 22140 //
     /*  723269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  723286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  723318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723337 */     GIR_RootConstrainSelectedInstOperands,
     /*  723338 */     // GIR_Coverage, 22140,
     /*  723338 */     GIR_EraseRootFromParent_Done,
     /*  723339 */   // Label 11435: @723339
     /*  723339 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(723414), // Rule ID 22141 //
     /*  723344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  723361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  723393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723412 */     GIR_RootConstrainSelectedInstOperands,
     /*  723413 */     // GIR_Coverage, 22141,
     /*  723413 */     GIR_EraseRootFromParent_Done,
     /*  723414 */   // Label 11436: @723414
     /*  723414 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(723489), // Rule ID 22144 //
     /*  723419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  723436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723465 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  723468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723487 */     GIR_RootConstrainSelectedInstOperands,
     /*  723488 */     // GIR_Coverage, 22144,
     /*  723488 */     GIR_EraseRootFromParent_Done,
     /*  723489 */   // Label 11437: @723489
     /*  723489 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(723564), // Rule ID 22145 //
     /*  723494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  723511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11202:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  723543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723562 */     GIR_RootConstrainSelectedInstOperands,
     /*  723563 */     // GIR_Coverage, 22145,
     /*  723563 */     GIR_EraseRootFromParent_Done,
     /*  723564 */   // Label 11438: @723564
     /*  723564 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(723639), // Rule ID 22148 //
     /*  723569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  723586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  723618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723637 */     GIR_RootConstrainSelectedInstOperands,
     /*  723638 */     // GIR_Coverage, 22148,
     /*  723638 */     GIR_EraseRootFromParent_Done,
     /*  723639 */   // Label 11439: @723639
     /*  723639 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(723714), // Rule ID 22149 //
     /*  723644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  723661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  723693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723712 */     GIR_RootConstrainSelectedInstOperands,
     /*  723713 */     // GIR_Coverage, 22149,
     /*  723713 */     GIR_EraseRootFromParent_Done,
     /*  723714 */   // Label 11440: @723714
     /*  723714 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(723789), // Rule ID 22152 //
     /*  723719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  723736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  723768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723787 */     GIR_RootConstrainSelectedInstOperands,
     /*  723788 */     // GIR_Coverage, 22152,
     /*  723788 */     GIR_EraseRootFromParent_Done,
     /*  723789 */   // Label 11441: @723789
     /*  723789 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(723864), // Rule ID 22153 //
     /*  723794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  723811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  723843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723862 */     GIR_RootConstrainSelectedInstOperands,
     /*  723863 */     // GIR_Coverage, 22153,
     /*  723863 */     GIR_EraseRootFromParent_Done,
     /*  723864 */   // Label 11442: @723864
     /*  723864 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(723939), // Rule ID 22156 //
     /*  723869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  723886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  723918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723937 */     GIR_RootConstrainSelectedInstOperands,
     /*  723938 */     // GIR_Coverage, 22156,
     /*  723938 */     GIR_EraseRootFromParent_Done,
     /*  723939 */   // Label 11443: @723939
     /*  723939 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(724014), // Rule ID 22157 //
     /*  723944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  723952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  723961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  723993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  723997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724012 */     GIR_RootConstrainSelectedInstOperands,
     /*  724013 */     // GIR_Coverage, 22157,
     /*  724013 */     GIR_EraseRootFromParent_Done,
     /*  724014 */   // Label 11444: @724014
     /*  724014 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(724089), // Rule ID 22160 //
     /*  724019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  724036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724065 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  724068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724087 */     GIR_RootConstrainSelectedInstOperands,
     /*  724088 */     // GIR_Coverage, 22160,
     /*  724088 */     GIR_EraseRootFromParent_Done,
     /*  724089 */   // Label 11445: @724089
     /*  724089 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(724164), // Rule ID 22161 //
     /*  724094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  724111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  724143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724162 */     GIR_RootConstrainSelectedInstOperands,
     /*  724163 */     // GIR_Coverage, 22161,
     /*  724163 */     GIR_EraseRootFromParent_Done,
     /*  724164 */   // Label 11446: @724164
     /*  724164 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(724239), // Rule ID 22164 //
     /*  724169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  724186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724215 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  724218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724237 */     GIR_RootConstrainSelectedInstOperands,
     /*  724238 */     // GIR_Coverage, 22164,
     /*  724238 */     GIR_EraseRootFromParent_Done,
     /*  724239 */   // Label 11447: @724239
     /*  724239 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(724314), // Rule ID 22165 //
     /*  724244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  724261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  724293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724312 */     GIR_RootConstrainSelectedInstOperands,
     /*  724313 */     // GIR_Coverage, 22165,
     /*  724313 */     GIR_EraseRootFromParent_Done,
     /*  724314 */   // Label 11448: @724314
     /*  724314 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(724389), // Rule ID 22168 //
     /*  724319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  724336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  724368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724387 */     GIR_RootConstrainSelectedInstOperands,
     /*  724388 */     // GIR_Coverage, 22168,
     /*  724388 */     GIR_EraseRootFromParent_Done,
     /*  724389 */   // Label 11449: @724389
     /*  724389 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(724464), // Rule ID 22169 //
     /*  724394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  724411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  724443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724462 */     GIR_RootConstrainSelectedInstOperands,
     /*  724463 */     // GIR_Coverage, 22169,
     /*  724463 */     GIR_EraseRootFromParent_Done,
     /*  724464 */   // Label 11450: @724464
     /*  724464 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(724539), // Rule ID 22172 //
     /*  724469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  724486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  724518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724537 */     GIR_RootConstrainSelectedInstOperands,
     /*  724538 */     // GIR_Coverage, 22172,
     /*  724538 */     GIR_EraseRootFromParent_Done,
     /*  724539 */   // Label 11451: @724539
     /*  724539 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(724614), // Rule ID 22173 //
     /*  724544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  724561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  724593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724612 */     GIR_RootConstrainSelectedInstOperands,
     /*  724613 */     // GIR_Coverage, 22173,
     /*  724613 */     GIR_EraseRootFromParent_Done,
     /*  724614 */   // Label 11452: @724614
     /*  724614 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(724689), // Rule ID 22176 //
     /*  724619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  724636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724665 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  724668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724687 */     GIR_RootConstrainSelectedInstOperands,
     /*  724688 */     // GIR_Coverage, 22176,
     /*  724688 */     GIR_EraseRootFromParent_Done,
     /*  724689 */   // Label 11453: @724689
     /*  724689 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(724764), // Rule ID 22177 //
     /*  724694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  724711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  724743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724762 */     GIR_RootConstrainSelectedInstOperands,
     /*  724763 */     // GIR_Coverage, 22177,
     /*  724763 */     GIR_EraseRootFromParent_Done,
     /*  724764 */   // Label 11454: @724764
     /*  724764 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(724839), // Rule ID 22180 //
     /*  724769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  724786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724815 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  724818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724837 */     GIR_RootConstrainSelectedInstOperands,
     /*  724838 */     // GIR_Coverage, 22180,
     /*  724838 */     GIR_EraseRootFromParent_Done,
     /*  724839 */   // Label 11455: @724839
     /*  724839 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(724914), // Rule ID 22181 //
     /*  724844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  724852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  724861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  724893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724912 */     GIR_RootConstrainSelectedInstOperands,
     /*  724913 */     // GIR_Coverage, 22181,
     /*  724913 */     GIR_EraseRootFromParent_Done,
     /*  724914 */   // Label 11456: @724914
     /*  724914 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(724989), // Rule ID 22184 //
     /*  724919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  724927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  724936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  724968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  724972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724987 */     GIR_RootConstrainSelectedInstOperands,
     /*  724988 */     // GIR_Coverage, 22184,
     /*  724988 */     GIR_EraseRootFromParent_Done,
     /*  724989 */   // Label 11457: @724989
     /*  724989 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(725064), // Rule ID 22185 //
     /*  724994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  725011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  725043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725062 */     GIR_RootConstrainSelectedInstOperands,
     /*  725063 */     // GIR_Coverage, 22185,
     /*  725063 */     GIR_EraseRootFromParent_Done,
     /*  725064 */   // Label 11458: @725064
     /*  725064 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(725139), // Rule ID 22188 //
     /*  725069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  725086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725115 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  725118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725137 */     GIR_RootConstrainSelectedInstOperands,
     /*  725138 */     // GIR_Coverage, 22188,
     /*  725138 */     GIR_EraseRootFromParent_Done,
     /*  725139 */   // Label 11459: @725139
     /*  725139 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(725214), // Rule ID 22189 //
     /*  725144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  725161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  725193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725212 */     GIR_RootConstrainSelectedInstOperands,
     /*  725213 */     // GIR_Coverage, 22189,
     /*  725213 */     GIR_EraseRootFromParent_Done,
     /*  725214 */   // Label 11460: @725214
     /*  725214 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(725289), // Rule ID 22192 //
     /*  725219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  725236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  725268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725287 */     GIR_RootConstrainSelectedInstOperands,
     /*  725288 */     // GIR_Coverage, 22192,
     /*  725288 */     GIR_EraseRootFromParent_Done,
     /*  725289 */   // Label 11461: @725289
     /*  725289 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(725364), // Rule ID 22193 //
     /*  725294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  725311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  725343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725362 */     GIR_RootConstrainSelectedInstOperands,
     /*  725363 */     // GIR_Coverage, 22193,
     /*  725363 */     GIR_EraseRootFromParent_Done,
     /*  725364 */   // Label 11462: @725364
     /*  725364 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(725439), // Rule ID 22196 //
     /*  725369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  725380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  725383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  725386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  725389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  725418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725437 */     GIR_RootConstrainSelectedInstOperands,
     /*  725438 */     // GIR_Coverage, 22196,
     /*  725438 */     GIR_EraseRootFromParent_Done,
     /*  725439 */   // Label 11463: @725439
     /*  725439 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(725514), // Rule ID 22197 //
     /*  725444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  725455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  725458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  725461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  725464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  725493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725512 */     GIR_RootConstrainSelectedInstOperands,
     /*  725513 */     // GIR_Coverage, 22197,
     /*  725513 */     GIR_EraseRootFromParent_Done,
     /*  725514 */   // Label 11464: @725514
     /*  725514 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(725589), // Rule ID 22200 //
     /*  725519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  725530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  725533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  725536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  725539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  725568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725587 */     GIR_RootConstrainSelectedInstOperands,
     /*  725588 */     // GIR_Coverage, 22200,
     /*  725588 */     GIR_EraseRootFromParent_Done,
     /*  725589 */   // Label 11465: @725589
     /*  725589 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(725664), // Rule ID 22201 //
     /*  725594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  725605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  725608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  725611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  725614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  725643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725662 */     GIR_RootConstrainSelectedInstOperands,
     /*  725663 */     // GIR_Coverage, 22201,
     /*  725663 */     GIR_EraseRootFromParent_Done,
     /*  725664 */   // Label 11466: @725664
     /*  725664 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(725739), // Rule ID 22204 //
     /*  725669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  725680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  725683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  725686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  725689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  725718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725737 */     GIR_RootConstrainSelectedInstOperands,
     /*  725738 */     // GIR_Coverage, 22204,
     /*  725738 */     GIR_EraseRootFromParent_Done,
     /*  725739 */   // Label 11467: @725739
     /*  725739 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(725814), // Rule ID 22205 //
     /*  725744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  725755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  725758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  725761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  725764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  725793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725812 */     GIR_RootConstrainSelectedInstOperands,
     /*  725813 */     // GIR_Coverage, 22205,
     /*  725813 */     GIR_EraseRootFromParent_Done,
     /*  725814 */   // Label 11468: @725814
     /*  725814 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(725889), // Rule ID 22208 //
     /*  725819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  725836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  725868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725887 */     GIR_RootConstrainSelectedInstOperands,
     /*  725888 */     // GIR_Coverage, 22208,
     /*  725888 */     GIR_EraseRootFromParent_Done,
     /*  725889 */   // Label 11469: @725889
     /*  725889 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(725964), // Rule ID 22209 //
     /*  725894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  725905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  725908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  725911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  725914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  725943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  725947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725962 */     GIR_RootConstrainSelectedInstOperands,
     /*  725963 */     // GIR_Coverage, 22209,
     /*  725963 */     GIR_EraseRootFromParent_Done,
     /*  725964 */   // Label 11470: @725964
     /*  725964 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(726039), // Rule ID 22212 //
     /*  725969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  725977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  725980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  725983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  725986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  725989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  726018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726037 */     GIR_RootConstrainSelectedInstOperands,
     /*  726038 */     // GIR_Coverage, 22212,
     /*  726038 */     GIR_EraseRootFromParent_Done,
     /*  726039 */   // Label 11471: @726039
     /*  726039 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(726114), // Rule ID 22213 //
     /*  726044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  726055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  726058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  726061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  726064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  726093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726112 */     GIR_RootConstrainSelectedInstOperands,
     /*  726113 */     // GIR_Coverage, 22213,
     /*  726113 */     GIR_EraseRootFromParent_Done,
     /*  726114 */   // Label 11472: @726114
     /*  726114 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(726189), // Rule ID 22216 //
     /*  726119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  726130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  726133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  726136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  726139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  726168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726187 */     GIR_RootConstrainSelectedInstOperands,
     /*  726188 */     // GIR_Coverage, 22216,
     /*  726188 */     GIR_EraseRootFromParent_Done,
     /*  726189 */   // Label 11473: @726189
     /*  726189 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(726264), // Rule ID 22217 //
     /*  726194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  726205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  726208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  726211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  726214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  726243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726262 */     GIR_RootConstrainSelectedInstOperands,
     /*  726263 */     // GIR_Coverage, 22217,
     /*  726263 */     GIR_EraseRootFromParent_Done,
     /*  726264 */   // Label 11474: @726264
     /*  726264 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(726339), // Rule ID 22220 //
     /*  726269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  726280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  726283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  726286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  726289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726315 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  726318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726337 */     GIR_RootConstrainSelectedInstOperands,
     /*  726338 */     // GIR_Coverage, 22220,
     /*  726338 */     GIR_EraseRootFromParent_Done,
     /*  726339 */   // Label 11475: @726339
     /*  726339 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(726414), // Rule ID 22221 //
     /*  726344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  726355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  726358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  726361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  726364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  726393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726412 */     GIR_RootConstrainSelectedInstOperands,
     /*  726413 */     // GIR_Coverage, 22221,
     /*  726413 */     GIR_EraseRootFromParent_Done,
     /*  726414 */   // Label 11476: @726414
     /*  726414 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(726489), // Rule ID 22224 //
     /*  726419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  726436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726465 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  726468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726487 */     GIR_RootConstrainSelectedInstOperands,
     /*  726488 */     // GIR_Coverage, 22224,
     /*  726488 */     GIR_EraseRootFromParent_Done,
     /*  726489 */   // Label 11477: @726489
     /*  726489 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(726564), // Rule ID 22225 //
     /*  726494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  726511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  726543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726562 */     GIR_RootConstrainSelectedInstOperands,
     /*  726563 */     // GIR_Coverage, 22225,
     /*  726563 */     GIR_EraseRootFromParent_Done,
     /*  726564 */   // Label 11478: @726564
     /*  726564 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(726639), // Rule ID 22228 //
     /*  726569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  726586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726615 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  726618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726637 */     GIR_RootConstrainSelectedInstOperands,
     /*  726638 */     // GIR_Coverage, 22228,
     /*  726638 */     GIR_EraseRootFromParent_Done,
     /*  726639 */   // Label 11479: @726639
     /*  726639 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(726714), // Rule ID 22229 //
     /*  726644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  726661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  726693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726712 */     GIR_RootConstrainSelectedInstOperands,
     /*  726713 */     // GIR_Coverage, 22229,
     /*  726713 */     GIR_EraseRootFromParent_Done,
     /*  726714 */   // Label 11480: @726714
     /*  726714 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(726789), // Rule ID 22232 //
     /*  726719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  726736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726765 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  726768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726787 */     GIR_RootConstrainSelectedInstOperands,
     /*  726788 */     // GIR_Coverage, 22232,
     /*  726788 */     GIR_EraseRootFromParent_Done,
     /*  726789 */   // Label 11481: @726789
     /*  726789 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(726864), // Rule ID 22233 //
     /*  726794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  726811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  726814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  726843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726862 */     GIR_RootConstrainSelectedInstOperands,
     /*  726863 */     // GIR_Coverage, 22233,
     /*  726863 */     GIR_EraseRootFromParent_Done,
     /*  726864 */   // Label 11482: @726864
     /*  726864 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(726939), // Rule ID 22236 //
     /*  726869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  726880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  726883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  726886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  726889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  726918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726937 */     GIR_RootConstrainSelectedInstOperands,
     /*  726938 */     // GIR_Coverage, 22236,
     /*  726938 */     GIR_EraseRootFromParent_Done,
     /*  726939 */   // Label 11483: @726939
     /*  726939 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(727014), // Rule ID 22237 //
     /*  726944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  726952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  726955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  726958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  726961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  726964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  726993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  726997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727012 */     GIR_RootConstrainSelectedInstOperands,
     /*  727013 */     // GIR_Coverage, 22237,
     /*  727013 */     GIR_EraseRootFromParent_Done,
     /*  727014 */   // Label 11484: @727014
     /*  727014 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(727089), // Rule ID 22240 //
     /*  727019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  727036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727065 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  727068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727087 */     GIR_RootConstrainSelectedInstOperands,
     /*  727088 */     // GIR_Coverage, 22240,
     /*  727088 */     GIR_EraseRootFromParent_Done,
     /*  727089 */   // Label 11485: @727089
     /*  727089 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(727164), // Rule ID 22241 //
     /*  727094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  727111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  727143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727162 */     GIR_RootConstrainSelectedInstOperands,
     /*  727163 */     // GIR_Coverage, 22241,
     /*  727163 */     GIR_EraseRootFromParent_Done,
     /*  727164 */   // Label 11486: @727164
     /*  727164 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(727239), // Rule ID 22244 //
     /*  727169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  727186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  727218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727237 */     GIR_RootConstrainSelectedInstOperands,
     /*  727238 */     // GIR_Coverage, 22244,
     /*  727238 */     GIR_EraseRootFromParent_Done,
     /*  727239 */   // Label 11487: @727239
     /*  727239 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(727314), // Rule ID 22245 //
     /*  727244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  727261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  727293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727312 */     GIR_RootConstrainSelectedInstOperands,
     /*  727313 */     // GIR_Coverage, 22245,
     /*  727313 */     GIR_EraseRootFromParent_Done,
     /*  727314 */   // Label 11488: @727314
     /*  727314 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(727389), // Rule ID 22248 //
     /*  727319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  727336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  727368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727387 */     GIR_RootConstrainSelectedInstOperands,
     /*  727388 */     // GIR_Coverage, 22248,
     /*  727388 */     GIR_EraseRootFromParent_Done,
     /*  727389 */   // Label 11489: @727389
     /*  727389 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(727464), // Rule ID 22249 //
     /*  727394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  727411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  727443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727462 */     GIR_RootConstrainSelectedInstOperands,
     /*  727463 */     // GIR_Coverage, 22249,
     /*  727463 */     GIR_EraseRootFromParent_Done,
     /*  727464 */   // Label 11490: @727464
     /*  727464 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(727539), // Rule ID 22252 //
     /*  727469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  727486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  727518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727537 */     GIR_RootConstrainSelectedInstOperands,
     /*  727538 */     // GIR_Coverage, 22252,
     /*  727538 */     GIR_EraseRootFromParent_Done,
     /*  727539 */   // Label 11491: @727539
     /*  727539 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(727614), // Rule ID 22253 //
     /*  727544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  727561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  727593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727612 */     GIR_RootConstrainSelectedInstOperands,
     /*  727613 */     // GIR_Coverage, 22253,
     /*  727613 */     GIR_EraseRootFromParent_Done,
     /*  727614 */   // Label 11492: @727614
     /*  727614 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(727689), // Rule ID 22256 //
     /*  727619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  727636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  727668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727687 */     GIR_RootConstrainSelectedInstOperands,
     /*  727688 */     // GIR_Coverage, 22256,
     /*  727688 */     GIR_EraseRootFromParent_Done,
     /*  727689 */   // Label 11493: @727689
     /*  727689 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(727764), // Rule ID 22257 //
     /*  727694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  727711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  727714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  727743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727762 */     GIR_RootConstrainSelectedInstOperands,
     /*  727763 */     // GIR_Coverage, 22257,
     /*  727763 */     GIR_EraseRootFromParent_Done,
     /*  727764 */   // Label 11494: @727764
     /*  727764 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(727839), // Rule ID 22260 //
     /*  727769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  727772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  727786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  727789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727815 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  727815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  727818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727837 */     GIR_RootConstrainSelectedInstOperands,
     /*  727838 */     // GIR_Coverage, 22260,
     /*  727838 */     GIR_EraseRootFromParent_Done,
     /*  727839 */   // Label 11495: @727839
     /*  727839 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(727914), // Rule ID 22261 //
     /*  727844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  727847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  727861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  727864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  727890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  727893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727912 */     GIR_RootConstrainSelectedInstOperands,
     /*  727913 */     // GIR_Coverage, 22261,
     /*  727913 */     GIR_EraseRootFromParent_Done,
     /*  727914 */   // Label 11496: @727914
     /*  727914 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(727989), // Rule ID 22264 //
     /*  727919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  727922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  727927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  727936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  727939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  727965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  727968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  727972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727987 */     GIR_RootConstrainSelectedInstOperands,
     /*  727988 */     // GIR_Coverage, 22264,
     /*  727988 */     GIR_EraseRootFromParent_Done,
     /*  727989 */   // Label 11497: @727989
     /*  727989 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(728064), // Rule ID 22265 //
     /*  727994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  727997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  728002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  728011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  728043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728062 */     GIR_RootConstrainSelectedInstOperands,
     /*  728063 */     // GIR_Coverage, 22265,
     /*  728063 */     GIR_EraseRootFromParent_Done,
     /*  728064 */   // Label 11498: @728064
     /*  728064 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(728139), // Rule ID 22268 //
     /*  728069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  728077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  728086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  728118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728137 */     GIR_RootConstrainSelectedInstOperands,
     /*  728138 */     // GIR_Coverage, 22268,
     /*  728138 */     GIR_EraseRootFromParent_Done,
     /*  728139 */   // Label 11499: @728139
     /*  728139 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(728214), // Rule ID 22269 //
     /*  728144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  728152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  728161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  728193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728212 */     GIR_RootConstrainSelectedInstOperands,
     /*  728213 */     // GIR_Coverage, 22269,
     /*  728213 */     GIR_EraseRootFromParent_Done,
     /*  728214 */   // Label 11500: @728214
     /*  728214 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(728289), // Rule ID 22272 //
     /*  728219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  728236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  728268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728287 */     GIR_RootConstrainSelectedInstOperands,
     /*  728288 */     // GIR_Coverage, 22272,
     /*  728288 */     GIR_EraseRootFromParent_Done,
     /*  728289 */   // Label 11501: @728289
     /*  728289 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(728364), // Rule ID 22273 //
     /*  728294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  728311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  728343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728362 */     GIR_RootConstrainSelectedInstOperands,
     /*  728363 */     // GIR_Coverage, 22273,
     /*  728363 */     GIR_EraseRootFromParent_Done,
     /*  728364 */   // Label 11502: @728364
     /*  728364 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(728439), // Rule ID 22276 //
     /*  728369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  728386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728415 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  728418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728437 */     GIR_RootConstrainSelectedInstOperands,
     /*  728438 */     // GIR_Coverage, 22276,
     /*  728438 */     GIR_EraseRootFromParent_Done,
     /*  728439 */   // Label 11503: @728439
     /*  728439 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(728514), // Rule ID 22277 //
     /*  728444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  728461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  728493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728512 */     GIR_RootConstrainSelectedInstOperands,
     /*  728513 */     // GIR_Coverage, 22277,
     /*  728513 */     GIR_EraseRootFromParent_Done,
     /*  728514 */   // Label 11504: @728514
     /*  728514 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(728589), // Rule ID 22280 //
     /*  728519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  728536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  728568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728587 */     GIR_RootConstrainSelectedInstOperands,
     /*  728588 */     // GIR_Coverage, 22280,
     /*  728588 */     GIR_EraseRootFromParent_Done,
     /*  728589 */   // Label 11505: @728589
     /*  728589 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(728664), // Rule ID 22281 //
     /*  728594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  728605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  728608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  728611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  728614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  728643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728662 */     GIR_RootConstrainSelectedInstOperands,
     /*  728663 */     // GIR_Coverage, 22281,
     /*  728663 */     GIR_EraseRootFromParent_Done,
     /*  728664 */   // Label 11506: @728664
     /*  728664 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(728739), // Rule ID 22284 //
     /*  728669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  728680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  728683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  728686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  728689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  728718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728737 */     GIR_RootConstrainSelectedInstOperands,
     /*  728738 */     // GIR_Coverage, 22284,
     /*  728738 */     GIR_EraseRootFromParent_Done,
     /*  728739 */   // Label 11507: @728739
     /*  728739 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(728814), // Rule ID 22285 //
     /*  728744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  728755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  728758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  728761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  728764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  728793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728812 */     GIR_RootConstrainSelectedInstOperands,
     /*  728813 */     // GIR_Coverage, 22285,
     /*  728813 */     GIR_EraseRootFromParent_Done,
     /*  728814 */   // Label 11508: @728814
     /*  728814 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(728889), // Rule ID 22288 //
     /*  728819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  728830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  728833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  728836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  728839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  728868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728887 */     GIR_RootConstrainSelectedInstOperands,
     /*  728888 */     // GIR_Coverage, 22288,
     /*  728888 */     GIR_EraseRootFromParent_Done,
     /*  728889 */   // Label 11509: @728889
     /*  728889 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(728964), // Rule ID 22289 //
     /*  728894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  728905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  728908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  728911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  728914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  728943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  728947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728962 */     GIR_RootConstrainSelectedInstOperands,
     /*  728963 */     // GIR_Coverage, 22289,
     /*  728963 */     GIR_EraseRootFromParent_Done,
     /*  728964 */   // Label 11510: @728964
     /*  728964 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(729039), // Rule ID 22292 //
     /*  728969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  728977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  728986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  728989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  729018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729037 */     GIR_RootConstrainSelectedInstOperands,
     /*  729038 */     // GIR_Coverage, 22292,
     /*  729038 */     GIR_EraseRootFromParent_Done,
     /*  729039 */   // Label 11511: @729039
     /*  729039 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(729114), // Rule ID 22293 //
     /*  729044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  729055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  729058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  729061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  729064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  729093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729112 */     GIR_RootConstrainSelectedInstOperands,
     /*  729113 */     // GIR_Coverage, 22293,
     /*  729113 */     GIR_EraseRootFromParent_Done,
     /*  729114 */   // Label 11512: @729114
     /*  729114 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(729189), // Rule ID 22296 //
     /*  729119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  729136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729165 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  729168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729187 */     GIR_RootConstrainSelectedInstOperands,
     /*  729188 */     // GIR_Coverage, 22296,
     /*  729188 */     GIR_EraseRootFromParent_Done,
     /*  729189 */   // Label 11513: @729189
     /*  729189 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(729264), // Rule ID 22297 //
     /*  729194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  729211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  729243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729262 */     GIR_RootConstrainSelectedInstOperands,
     /*  729263 */     // GIR_Coverage, 22297,
     /*  729263 */     GIR_EraseRootFromParent_Done,
     /*  729264 */   // Label 11514: @729264
     /*  729264 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(729339), // Rule ID 22300 //
     /*  729269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  729280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  729283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  729286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  729289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  729318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729337 */     GIR_RootConstrainSelectedInstOperands,
     /*  729338 */     // GIR_Coverage, 22300,
     /*  729338 */     GIR_EraseRootFromParent_Done,
     /*  729339 */   // Label 11515: @729339
     /*  729339 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(729414), // Rule ID 22301 //
     /*  729344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  729355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  729358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  729361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  729364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  729393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729412 */     GIR_RootConstrainSelectedInstOperands,
     /*  729413 */     // GIR_Coverage, 22301,
     /*  729413 */     GIR_EraseRootFromParent_Done,
     /*  729414 */   // Label 11516: @729414
     /*  729414 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(729489), // Rule ID 22304 //
     /*  729419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  729430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  729433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  729436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  729439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729465 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  729468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729487 */     GIR_RootConstrainSelectedInstOperands,
     /*  729488 */     // GIR_Coverage, 22304,
     /*  729488 */     GIR_EraseRootFromParent_Done,
     /*  729489 */   // Label 11517: @729489
     /*  729489 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(729564), // Rule ID 22305 //
     /*  729494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  729505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  729508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  729511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  729514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  729543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729562 */     GIR_RootConstrainSelectedInstOperands,
     /*  729563 */     // GIR_Coverage, 22305,
     /*  729563 */     GIR_EraseRootFromParent_Done,
     /*  729564 */   // Label 11518: @729564
     /*  729564 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(729639), // Rule ID 22308 //
     /*  729569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  729580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  729583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  729586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  729589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  729618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729637 */     GIR_RootConstrainSelectedInstOperands,
     /*  729638 */     // GIR_Coverage, 22308,
     /*  729638 */     GIR_EraseRootFromParent_Done,
     /*  729639 */   // Label 11519: @729639
     /*  729639 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(729714), // Rule ID 22309 //
     /*  729644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  729655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  729658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  729661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  729664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  729693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729712 */     GIR_RootConstrainSelectedInstOperands,
     /*  729713 */     // GIR_Coverage, 22309,
     /*  729713 */     GIR_EraseRootFromParent_Done,
     /*  729714 */   // Label 11520: @729714
     /*  729714 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(729789), // Rule ID 22312 //
     /*  729719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  729736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729765 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  729768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729787 */     GIR_RootConstrainSelectedInstOperands,
     /*  729788 */     // GIR_Coverage, 22312,
     /*  729788 */     GIR_EraseRootFromParent_Done,
     /*  729789 */   // Label 11521: @729789
     /*  729789 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(729864), // Rule ID 22313 //
     /*  729794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  729811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  729843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729862 */     GIR_RootConstrainSelectedInstOperands,
     /*  729863 */     // GIR_Coverage, 22313,
     /*  729863 */     GIR_EraseRootFromParent_Done,
     /*  729864 */   // Label 11522: @729864
     /*  729864 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(729939), // Rule ID 22316 //
     /*  729869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  729886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729915 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  729918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729937 */     GIR_RootConstrainSelectedInstOperands,
     /*  729938 */     // GIR_Coverage, 22316,
     /*  729938 */     GIR_EraseRootFromParent_Done,
     /*  729939 */   // Label 11523: @729939
     /*  729939 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(730014), // Rule ID 22317 //
     /*  729944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  729952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  729955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  729958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  729961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  729964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  729993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  729997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730012 */     GIR_RootConstrainSelectedInstOperands,
     /*  730013 */     // GIR_Coverage, 22317,
     /*  730013 */     GIR_EraseRootFromParent_Done,
     /*  730014 */   // Label 11524: @730014
     /*  730014 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(730089), // Rule ID 22320 //
     /*  730019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  730036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  730068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730087 */     GIR_RootConstrainSelectedInstOperands,
     /*  730088 */     // GIR_Coverage, 22320,
     /*  730088 */     GIR_EraseRootFromParent_Done,
     /*  730089 */   // Label 11525: @730089
     /*  730089 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(730164), // Rule ID 22321 //
     /*  730094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  730111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  730143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730162 */     GIR_RootConstrainSelectedInstOperands,
     /*  730163 */     // GIR_Coverage, 22321,
     /*  730163 */     GIR_EraseRootFromParent_Done,
     /*  730164 */   // Label 11526: @730164
     /*  730164 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(730239), // Rule ID 22324 //
     /*  730169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  730186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  730218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730237 */     GIR_RootConstrainSelectedInstOperands,
     /*  730238 */     // GIR_Coverage, 22324,
     /*  730238 */     GIR_EraseRootFromParent_Done,
     /*  730239 */   // Label 11527: @730239
     /*  730239 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(730314), // Rule ID 22325 //
     /*  730244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  730261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  730293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730312 */     GIR_RootConstrainSelectedInstOperands,
     /*  730313 */     // GIR_Coverage, 22325,
     /*  730313 */     GIR_EraseRootFromParent_Done,
     /*  730314 */   // Label 11528: @730314
     /*  730314 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(730389), // Rule ID 22328 //
     /*  730319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  730336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  730368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730387 */     GIR_RootConstrainSelectedInstOperands,
     /*  730388 */     // GIR_Coverage, 22328,
     /*  730388 */     GIR_EraseRootFromParent_Done,
     /*  730389 */   // Label 11529: @730389
     /*  730389 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(730464), // Rule ID 22329 //
     /*  730394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  730411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  730443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730462 */     GIR_RootConstrainSelectedInstOperands,
     /*  730463 */     // GIR_Coverage, 22329,
     /*  730463 */     GIR_EraseRootFromParent_Done,
     /*  730464 */   // Label 11530: @730464
     /*  730464 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(730539), // Rule ID 22332 //
     /*  730469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  730486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  730518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730537 */     GIR_RootConstrainSelectedInstOperands,
     /*  730538 */     // GIR_Coverage, 22332,
     /*  730538 */     GIR_EraseRootFromParent_Done,
     /*  730539 */   // Label 11531: @730539
     /*  730539 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(730614), // Rule ID 22333 //
     /*  730544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  730561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  730593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730612 */     GIR_RootConstrainSelectedInstOperands,
     /*  730613 */     // GIR_Coverage, 22333,
     /*  730613 */     GIR_EraseRootFromParent_Done,
     /*  730614 */   // Label 11532: @730614
     /*  730614 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(730689), // Rule ID 22336 //
     /*  730619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  730636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  730668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730687 */     GIR_RootConstrainSelectedInstOperands,
     /*  730688 */     // GIR_Coverage, 22336,
     /*  730688 */     GIR_EraseRootFromParent_Done,
     /*  730689 */   // Label 11533: @730689
     /*  730689 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(730764), // Rule ID 22337 //
     /*  730694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  730711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  730743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730762 */     GIR_RootConstrainSelectedInstOperands,
     /*  730763 */     // GIR_Coverage, 22337,
     /*  730763 */     GIR_EraseRootFromParent_Done,
     /*  730764 */   // Label 11534: @730764
     /*  730764 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(730839), // Rule ID 22340 //
     /*  730769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  730786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  730818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730837 */     GIR_RootConstrainSelectedInstOperands,
     /*  730838 */     // GIR_Coverage, 22340,
     /*  730838 */     GIR_EraseRootFromParent_Done,
     /*  730839 */   // Label 11535: @730839
     /*  730839 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(730914), // Rule ID 22341 //
     /*  730844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  730861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  730893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730912 */     GIR_RootConstrainSelectedInstOperands,
     /*  730913 */     // GIR_Coverage, 22341,
     /*  730913 */     GIR_EraseRootFromParent_Done,
     /*  730914 */   // Label 11536: @730914
     /*  730914 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(730989), // Rule ID 22344 //
     /*  730919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  730927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  730936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  730968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  730972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730987 */     GIR_RootConstrainSelectedInstOperands,
     /*  730988 */     // GIR_Coverage, 22344,
     /*  730988 */     GIR_EraseRootFromParent_Done,
     /*  730989 */   // Label 11537: @730989
     /*  730989 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(731064), // Rule ID 22345 //
     /*  730994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  731011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  731014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  731043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731062 */     GIR_RootConstrainSelectedInstOperands,
     /*  731063 */     // GIR_Coverage, 22345,
     /*  731063 */     GIR_EraseRootFromParent_Done,
     /*  731064 */   // Label 11538: @731064
     /*  731064 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(731139), // Rule ID 22348 //
     /*  731069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  731086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  731118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731137 */     GIR_RootConstrainSelectedInstOperands,
     /*  731138 */     // GIR_Coverage, 22348,
     /*  731138 */     GIR_EraseRootFromParent_Done,
     /*  731139 */   // Label 11539: @731139
     /*  731139 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(731214), // Rule ID 22349 //
     /*  731144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  731161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  731193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731212 */     GIR_RootConstrainSelectedInstOperands,
     /*  731213 */     // GIR_Coverage, 22349,
     /*  731213 */     GIR_EraseRootFromParent_Done,
     /*  731214 */   // Label 11540: @731214
     /*  731214 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(731289), // Rule ID 22352 //
     /*  731219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  731236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  731268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731287 */     GIR_RootConstrainSelectedInstOperands,
     /*  731288 */     // GIR_Coverage, 22352,
     /*  731288 */     GIR_EraseRootFromParent_Done,
     /*  731289 */   // Label 11541: @731289
     /*  731289 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(731364), // Rule ID 22353 //
     /*  731294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  731311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  731343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731362 */     GIR_RootConstrainSelectedInstOperands,
     /*  731363 */     // GIR_Coverage, 22353,
     /*  731363 */     GIR_EraseRootFromParent_Done,
     /*  731364 */   // Label 11542: @731364
     /*  731364 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(731439), // Rule ID 22356 //
     /*  731369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  731386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  731418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731437 */     GIR_RootConstrainSelectedInstOperands,
     /*  731438 */     // GIR_Coverage, 22356,
     /*  731438 */     GIR_EraseRootFromParent_Done,
     /*  731439 */   // Label 11543: @731439
     /*  731439 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(731514), // Rule ID 22357 //
     /*  731444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  731452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  731461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  731493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731512 */     GIR_RootConstrainSelectedInstOperands,
     /*  731513 */     // GIR_Coverage, 22357,
     /*  731513 */     GIR_EraseRootFromParent_Done,
     /*  731514 */   // Label 11544: @731514
     /*  731514 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(731589), // Rule ID 22360 //
     /*  731519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  731536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  731568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731587 */     GIR_RootConstrainSelectedInstOperands,
     /*  731588 */     // GIR_Coverage, 22360,
     /*  731588 */     GIR_EraseRootFromParent_Done,
     /*  731589 */   // Label 11545: @731589
     /*  731589 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(731664), // Rule ID 22361 //
     /*  731594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  731611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  731643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731662 */     GIR_RootConstrainSelectedInstOperands,
     /*  731663 */     // GIR_Coverage, 22361,
     /*  731663 */     GIR_EraseRootFromParent_Done,
     /*  731664 */   // Label 11546: @731664
     /*  731664 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(731739), // Rule ID 22364 //
     /*  731669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  731686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731715 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  731718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731737 */     GIR_RootConstrainSelectedInstOperands,
     /*  731738 */     // GIR_Coverage, 22364,
     /*  731738 */     GIR_EraseRootFromParent_Done,
     /*  731739 */   // Label 11547: @731739
     /*  731739 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(731814), // Rule ID 22365 //
     /*  731744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  731761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  731793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731812 */     GIR_RootConstrainSelectedInstOperands,
     /*  731813 */     // GIR_Coverage, 22365,
     /*  731813 */     GIR_EraseRootFromParent_Done,
     /*  731814 */   // Label 11548: @731814
     /*  731814 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(731889), // Rule ID 22368 //
     /*  731819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  731836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  731868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731887 */     GIR_RootConstrainSelectedInstOperands,
     /*  731888 */     // GIR_Coverage, 22368,
     /*  731888 */     GIR_EraseRootFromParent_Done,
     /*  731889 */   // Label 11549: @731889
     /*  731889 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(731964), // Rule ID 22369 //
     /*  731894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  731911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  731943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  731947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731962 */     GIR_RootConstrainSelectedInstOperands,
     /*  731963 */     // GIR_Coverage, 22369,
     /*  731963 */     GIR_EraseRootFromParent_Done,
     /*  731964 */   // Label 11550: @731964
     /*  731964 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(732039), // Rule ID 22372 //
     /*  731969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  731977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  731986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  731989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  732018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732037 */     GIR_RootConstrainSelectedInstOperands,
     /*  732038 */     // GIR_Coverage, 22372,
     /*  732038 */     GIR_EraseRootFromParent_Done,
     /*  732039 */   // Label 11551: @732039
     /*  732039 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(732114), // Rule ID 22373 //
     /*  732044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  732055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  732058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  732061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  732064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  732093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732112 */     GIR_RootConstrainSelectedInstOperands,
     /*  732113 */     // GIR_Coverage, 22373,
     /*  732113 */     GIR_EraseRootFromParent_Done,
     /*  732114 */   // Label 11552: @732114
     /*  732114 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(732189), // Rule ID 22376 //
     /*  732119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  732130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  732133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  732136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  732139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  732168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732187 */     GIR_RootConstrainSelectedInstOperands,
     /*  732188 */     // GIR_Coverage, 22376,
     /*  732188 */     GIR_EraseRootFromParent_Done,
     /*  732189 */   // Label 11553: @732189
     /*  732189 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(732264), // Rule ID 22377 //
     /*  732194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  732205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  732208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  732211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  732214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  732243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732262 */     GIR_RootConstrainSelectedInstOperands,
     /*  732263 */     // GIR_Coverage, 22377,
     /*  732263 */     GIR_EraseRootFromParent_Done,
     /*  732264 */   // Label 11554: @732264
     /*  732264 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(732339), // Rule ID 22380 //
     /*  732269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  732280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  732283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  732286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  732289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732315 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  732318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732337 */     GIR_RootConstrainSelectedInstOperands,
     /*  732338 */     // GIR_Coverage, 22380,
     /*  732338 */     GIR_EraseRootFromParent_Done,
     /*  732339 */   // Label 11555: @732339
     /*  732339 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(732414), // Rule ID 22381 //
     /*  732344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  732355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  732358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  732361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  732364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  732393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732412 */     GIR_RootConstrainSelectedInstOperands,
     /*  732413 */     // GIR_Coverage, 22381,
     /*  732413 */     GIR_EraseRootFromParent_Done,
     /*  732414 */   // Label 11556: @732414
     /*  732414 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(732489), // Rule ID 22384 //
     /*  732419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  732430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  732433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  732436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  732439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732465 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  732468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732487 */     GIR_RootConstrainSelectedInstOperands,
     /*  732488 */     // GIR_Coverage, 22384,
     /*  732488 */     GIR_EraseRootFromParent_Done,
     /*  732489 */   // Label 11557: @732489
     /*  732489 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(732564), // Rule ID 22385 //
     /*  732494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  732505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  732508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  732511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  732514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  732543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732562 */     GIR_RootConstrainSelectedInstOperands,
     /*  732563 */     // GIR_Coverage, 22385,
     /*  732563 */     GIR_EraseRootFromParent_Done,
     /*  732564 */   // Label 11558: @732564
     /*  732564 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(732639), // Rule ID 22388 //
     /*  732569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  732580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  732583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  732586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  732589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  732618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732637 */     GIR_RootConstrainSelectedInstOperands,
     /*  732638 */     // GIR_Coverage, 22388,
     /*  732638 */     GIR_EraseRootFromParent_Done,
     /*  732639 */   // Label 11559: @732639
     /*  732639 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(732714), // Rule ID 22389 //
     /*  732644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  732655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  732658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  732661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  732664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  732693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732712 */     GIR_RootConstrainSelectedInstOperands,
     /*  732713 */     // GIR_Coverage, 22389,
     /*  732713 */     GIR_EraseRootFromParent_Done,
     /*  732714 */   // Label 11560: @732714
     /*  732714 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(732789), // Rule ID 22392 //
     /*  732719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  732730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  732733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  732736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  732739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  732768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732787 */     GIR_RootConstrainSelectedInstOperands,
     /*  732788 */     // GIR_Coverage, 22392,
     /*  732788 */     GIR_EraseRootFromParent_Done,
     /*  732789 */   // Label 11561: @732789
     /*  732789 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(732864), // Rule ID 22393 //
     /*  732794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  732805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  732808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  732811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  732814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  732843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732862 */     GIR_RootConstrainSelectedInstOperands,
     /*  732863 */     // GIR_Coverage, 22393,
     /*  732863 */     GIR_EraseRootFromParent_Done,
     /*  732864 */   // Label 11562: @732864
     /*  732864 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(732939), // Rule ID 22396 //
     /*  732869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  732880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  732883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  732886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  732889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  732918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732937 */     GIR_RootConstrainSelectedInstOperands,
     /*  732938 */     // GIR_Coverage, 22396,
     /*  732938 */     GIR_EraseRootFromParent_Done,
     /*  732939 */   // Label 11563: @732939
     /*  732939 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(733014), // Rule ID 22397 //
     /*  732944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  732952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  732955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  732958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  732961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  732964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  732993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  732997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733012 */     GIR_RootConstrainSelectedInstOperands,
     /*  733013 */     // GIR_Coverage, 22397,
     /*  733013 */     GIR_EraseRootFromParent_Done,
     /*  733014 */   // Label 11564: @733014
     /*  733014 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(733089), // Rule ID 22400 //
     /*  733019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  733036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  733068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733087 */     GIR_RootConstrainSelectedInstOperands,
     /*  733088 */     // GIR_Coverage, 22400,
     /*  733088 */     GIR_EraseRootFromParent_Done,
     /*  733089 */   // Label 11565: @733089
     /*  733089 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(733164), // Rule ID 22401 //
     /*  733094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  733111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  733143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733162 */     GIR_RootConstrainSelectedInstOperands,
     /*  733163 */     // GIR_Coverage, 22401,
     /*  733163 */     GIR_EraseRootFromParent_Done,
     /*  733164 */   // Label 11566: @733164
     /*  733164 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(733239), // Rule ID 22404 //
     /*  733169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  733186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  733218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733237 */     GIR_RootConstrainSelectedInstOperands,
     /*  733238 */     // GIR_Coverage, 22404,
     /*  733238 */     GIR_EraseRootFromParent_Done,
     /*  733239 */   // Label 11567: @733239
     /*  733239 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(733314), // Rule ID 22405 //
     /*  733244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  733261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  733293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733312 */     GIR_RootConstrainSelectedInstOperands,
     /*  733313 */     // GIR_Coverage, 22405,
     /*  733313 */     GIR_EraseRootFromParent_Done,
     /*  733314 */   // Label 11568: @733314
     /*  733314 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(733389), // Rule ID 22408 //
     /*  733319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  733336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  733368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733387 */     GIR_RootConstrainSelectedInstOperands,
     /*  733388 */     // GIR_Coverage, 22408,
     /*  733388 */     GIR_EraseRootFromParent_Done,
     /*  733389 */   // Label 11569: @733389
     /*  733389 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(733464), // Rule ID 22409 //
     /*  733394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  733411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  733414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11192:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  733443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733462 */     GIR_RootConstrainSelectedInstOperands,
     /*  733463 */     // GIR_Coverage, 22409,
     /*  733463 */     GIR_EraseRootFromParent_Done,
     /*  733464 */   // Label 11570: @733464
     /*  733464 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(733539), // Rule ID 22412 //
     /*  733469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  733486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  733518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733537 */     GIR_RootConstrainSelectedInstOperands,
     /*  733538 */     // GIR_Coverage, 22412,
     /*  733538 */     GIR_EraseRootFromParent_Done,
     /*  733539 */   // Label 11571: @733539
     /*  733539 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(733614), // Rule ID 22413 //
     /*  733544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  733561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  733593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733612 */     GIR_RootConstrainSelectedInstOperands,
     /*  733613 */     // GIR_Coverage, 22413,
     /*  733613 */     GIR_EraseRootFromParent_Done,
     /*  733614 */   // Label 11572: @733614
     /*  733614 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(733689), // Rule ID 22416 //
     /*  733619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  733636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  733668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733687 */     GIR_RootConstrainSelectedInstOperands,
     /*  733688 */     // GIR_Coverage, 22416,
     /*  733688 */     GIR_EraseRootFromParent_Done,
     /*  733689 */   // Label 11573: @733689
     /*  733689 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(733764), // Rule ID 22417 //
     /*  733694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  733711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  733743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733762 */     GIR_RootConstrainSelectedInstOperands,
     /*  733763 */     // GIR_Coverage, 22417,
     /*  733763 */     GIR_EraseRootFromParent_Done,
     /*  733764 */   // Label 11574: @733764
     /*  733764 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(733839), // Rule ID 22420 //
     /*  733769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  733786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  733818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733837 */     GIR_RootConstrainSelectedInstOperands,
     /*  733838 */     // GIR_Coverage, 22420,
     /*  733838 */     GIR_EraseRootFromParent_Done,
     /*  733839 */   // Label 11575: @733839
     /*  733839 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(733914), // Rule ID 22421 //
     /*  733844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  733861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  733864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  733893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733912 */     GIR_RootConstrainSelectedInstOperands,
     /*  733913 */     // GIR_Coverage, 22421,
     /*  733913 */     GIR_EraseRootFromParent_Done,
     /*  733914 */   // Label 11576: @733914
     /*  733914 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(733989), // Rule ID 22424 //
     /*  733919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  733927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  733930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  733933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  733936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  733939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  733965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  733968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  733972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733987 */     GIR_RootConstrainSelectedInstOperands,
     /*  733988 */     // GIR_Coverage, 22424,
     /*  733988 */     GIR_EraseRootFromParent_Done,
     /*  733989 */   // Label 11577: @733989
     /*  733989 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(734064), // Rule ID 22425 //
     /*  733994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  734011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  734043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734062 */     GIR_RootConstrainSelectedInstOperands,
     /*  734063 */     // GIR_Coverage, 22425,
     /*  734063 */     GIR_EraseRootFromParent_Done,
     /*  734064 */   // Label 11578: @734064
     /*  734064 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(734139), // Rule ID 22428 //
     /*  734069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  734086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  734118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734137 */     GIR_RootConstrainSelectedInstOperands,
     /*  734138 */     // GIR_Coverage, 22428,
     /*  734138 */     GIR_EraseRootFromParent_Done,
     /*  734139 */   // Label 11579: @734139
     /*  734139 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(734214), // Rule ID 22429 //
     /*  734144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  734161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  734193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734212 */     GIR_RootConstrainSelectedInstOperands,
     /*  734213 */     // GIR_Coverage, 22429,
     /*  734213 */     GIR_EraseRootFromParent_Done,
     /*  734214 */   // Label 11580: @734214
     /*  734214 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(734289), // Rule ID 22432 //
     /*  734219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  734236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  734268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734287 */     GIR_RootConstrainSelectedInstOperands,
     /*  734288 */     // GIR_Coverage, 22432,
     /*  734288 */     GIR_EraseRootFromParent_Done,
     /*  734289 */   // Label 11581: @734289
     /*  734289 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(734364), // Rule ID 22433 //
     /*  734294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  734311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  734343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734362 */     GIR_RootConstrainSelectedInstOperands,
     /*  734363 */     // GIR_Coverage, 22433,
     /*  734363 */     GIR_EraseRootFromParent_Done,
     /*  734364 */   // Label 11582: @734364
     /*  734364 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(734439), // Rule ID 22436 //
     /*  734369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  734386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  734418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734437 */     GIR_RootConstrainSelectedInstOperands,
     /*  734438 */     // GIR_Coverage, 22436,
     /*  734438 */     GIR_EraseRootFromParent_Done,
     /*  734439 */   // Label 11583: @734439
     /*  734439 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(734514), // Rule ID 22437 //
     /*  734444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  734461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  734493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734512 */     GIR_RootConstrainSelectedInstOperands,
     /*  734513 */     // GIR_Coverage, 22437,
     /*  734513 */     GIR_EraseRootFromParent_Done,
     /*  734514 */   // Label 11584: @734514
     /*  734514 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(734589), // Rule ID 22440 //
     /*  734519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  734536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734565 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  734568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734587 */     GIR_RootConstrainSelectedInstOperands,
     /*  734588 */     // GIR_Coverage, 22440,
     /*  734588 */     GIR_EraseRootFromParent_Done,
     /*  734589 */   // Label 11585: @734589
     /*  734589 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(734664), // Rule ID 22441 //
     /*  734594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  734611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  734643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734662 */     GIR_RootConstrainSelectedInstOperands,
     /*  734663 */     // GIR_Coverage, 22441,
     /*  734663 */     GIR_EraseRootFromParent_Done,
     /*  734664 */   // Label 11586: @734664
     /*  734664 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(734739), // Rule ID 22444 //
     /*  734669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  734686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  734718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734737 */     GIR_RootConstrainSelectedInstOperands,
     /*  734738 */     // GIR_Coverage, 22444,
     /*  734738 */     GIR_EraseRootFromParent_Done,
     /*  734739 */   // Label 11587: @734739
     /*  734739 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(734814), // Rule ID 22445 //
     /*  734744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  734752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  734761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  734793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734812 */     GIR_RootConstrainSelectedInstOperands,
     /*  734813 */     // GIR_Coverage, 22445,
     /*  734813 */     GIR_EraseRootFromParent_Done,
     /*  734814 */   // Label 11588: @734814
     /*  734814 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(734889), // Rule ID 22448 //
     /*  734819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  734827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  734836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  734868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734887 */     GIR_RootConstrainSelectedInstOperands,
     /*  734888 */     // GIR_Coverage, 22448,
     /*  734888 */     GIR_EraseRootFromParent_Done,
     /*  734889 */   // Label 11589: @734889
     /*  734889 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(734964), // Rule ID 22449 //
     /*  734894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  734902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  734911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  734943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  734947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734962 */     GIR_RootConstrainSelectedInstOperands,
     /*  734963 */     // GIR_Coverage, 22449,
     /*  734963 */     GIR_EraseRootFromParent_Done,
     /*  734964 */   // Label 11590: @734964
     /*  734964 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(735039), // Rule ID 22452 //
     /*  734969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  734977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  734986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  735018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735037 */     GIR_RootConstrainSelectedInstOperands,
     /*  735038 */     // GIR_Coverage, 22452,
     /*  735038 */     GIR_EraseRootFromParent_Done,
     /*  735039 */   // Label 11591: @735039
     /*  735039 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(735114), // Rule ID 22453 //
     /*  735044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  735055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  735058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  735061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  735064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  735093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735112 */     GIR_RootConstrainSelectedInstOperands,
     /*  735113 */     // GIR_Coverage, 22453,
     /*  735113 */     GIR_EraseRootFromParent_Done,
     /*  735114 */   // Label 11592: @735114
     /*  735114 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(735189), // Rule ID 22456 //
     /*  735119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  735130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  735133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  735136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  735139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735165 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  735168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735187 */     GIR_RootConstrainSelectedInstOperands,
     /*  735188 */     // GIR_Coverage, 22456,
     /*  735188 */     GIR_EraseRootFromParent_Done,
     /*  735189 */   // Label 11593: @735189
     /*  735189 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(735264), // Rule ID 22457 //
     /*  735194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  735205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  735208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  735211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  735214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  735243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735262 */     GIR_RootConstrainSelectedInstOperands,
     /*  735263 */     // GIR_Coverage, 22457,
     /*  735263 */     GIR_EraseRootFromParent_Done,
     /*  735264 */   // Label 11594: @735264
     /*  735264 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(735339), // Rule ID 22460 //
     /*  735269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  735286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  735318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735337 */     GIR_RootConstrainSelectedInstOperands,
     /*  735338 */     // GIR_Coverage, 22460,
     /*  735338 */     GIR_EraseRootFromParent_Done,
     /*  735339 */   // Label 11595: @735339
     /*  735339 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(735414), // Rule ID 22461 //
     /*  735344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  735361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  735393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735412 */     GIR_RootConstrainSelectedInstOperands,
     /*  735413 */     // GIR_Coverage, 22461,
     /*  735413 */     GIR_EraseRootFromParent_Done,
     /*  735414 */   // Label 11596: @735414
     /*  735414 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(735489), // Rule ID 22464 //
     /*  735419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  735436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735465 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  735468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735487 */     GIR_RootConstrainSelectedInstOperands,
     /*  735488 */     // GIR_Coverage, 22464,
     /*  735488 */     GIR_EraseRootFromParent_Done,
     /*  735489 */   // Label 11597: @735489
     /*  735489 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(735564), // Rule ID 22465 //
     /*  735494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  735511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  735543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735562 */     GIR_RootConstrainSelectedInstOperands,
     /*  735563 */     // GIR_Coverage, 22465,
     /*  735563 */     GIR_EraseRootFromParent_Done,
     /*  735564 */   // Label 11598: @735564
     /*  735564 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(735639), // Rule ID 22468 //
     /*  735569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  735580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  735583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  735586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  735589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  735618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735637 */     GIR_RootConstrainSelectedInstOperands,
     /*  735638 */     // GIR_Coverage, 22468,
     /*  735638 */     GIR_EraseRootFromParent_Done,
     /*  735639 */   // Label 11599: @735639
     /*  735639 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(735714), // Rule ID 22469 //
     /*  735644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  735655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  735658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  735661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  735664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  735693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735712 */     GIR_RootConstrainSelectedInstOperands,
     /*  735713 */     // GIR_Coverage, 22469,
     /*  735713 */     GIR_EraseRootFromParent_Done,
     /*  735714 */   // Label 11600: @735714
     /*  735714 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(735789), // Rule ID 22472 //
     /*  735719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  735730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  735733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  735736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  735739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735765 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  735768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735787 */     GIR_RootConstrainSelectedInstOperands,
     /*  735788 */     // GIR_Coverage, 22472,
     /*  735788 */     GIR_EraseRootFromParent_Done,
     /*  735789 */   // Label 11601: @735789
     /*  735789 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(735864), // Rule ID 22473 //
     /*  735794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  735805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  735808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  735811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  735814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  735843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735862 */     GIR_RootConstrainSelectedInstOperands,
     /*  735863 */     // GIR_Coverage, 22473,
     /*  735863 */     GIR_EraseRootFromParent_Done,
     /*  735864 */   // Label 11602: @735864
     /*  735864 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(735939), // Rule ID 22476 //
     /*  735869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  735886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  735918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735937 */     GIR_RootConstrainSelectedInstOperands,
     /*  735938 */     // GIR_Coverage, 22476,
     /*  735938 */     GIR_EraseRootFromParent_Done,
     /*  735939 */   // Label 11603: @735939
     /*  735939 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(736014), // Rule ID 22477 //
     /*  735944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  735952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  735955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  735958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  735961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  735964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  735993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  735997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736012 */     GIR_RootConstrainSelectedInstOperands,
     /*  736013 */     // GIR_Coverage, 22477,
     /*  736013 */     GIR_EraseRootFromParent_Done,
     /*  736014 */   // Label 11604: @736014
     /*  736014 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(736089), // Rule ID 22480 //
     /*  736019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  736030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  736033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  736036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  736039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736065 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  736068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736087 */     GIR_RootConstrainSelectedInstOperands,
     /*  736088 */     // GIR_Coverage, 22480,
     /*  736088 */     GIR_EraseRootFromParent_Done,
     /*  736089 */   // Label 11605: @736089
     /*  736089 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(736164), // Rule ID 22481 //
     /*  736094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  736105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  736108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  736111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  736114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  736143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736162 */     GIR_RootConstrainSelectedInstOperands,
     /*  736163 */     // GIR_Coverage, 22481,
     /*  736163 */     GIR_EraseRootFromParent_Done,
     /*  736164 */   // Label 11606: @736164
     /*  736164 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(736239), // Rule ID 22484 //
     /*  736169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  736180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  736183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  736186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  736189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  736218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736237 */     GIR_RootConstrainSelectedInstOperands,
     /*  736238 */     // GIR_Coverage, 22484,
     /*  736238 */     GIR_EraseRootFromParent_Done,
     /*  736239 */   // Label 11607: @736239
     /*  736239 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(736314), // Rule ID 22485 //
     /*  736244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  736255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  736258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  736261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  736264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  736293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736312 */     GIR_RootConstrainSelectedInstOperands,
     /*  736313 */     // GIR_Coverage, 22485,
     /*  736313 */     GIR_EraseRootFromParent_Done,
     /*  736314 */   // Label 11608: @736314
     /*  736314 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(736389), // Rule ID 22488 //
     /*  736319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  736336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  736368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736387 */     GIR_RootConstrainSelectedInstOperands,
     /*  736388 */     // GIR_Coverage, 22488,
     /*  736388 */     GIR_EraseRootFromParent_Done,
     /*  736389 */   // Label 11609: @736389
     /*  736389 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(736464), // Rule ID 22489 //
     /*  736394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  736411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  736443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736462 */     GIR_RootConstrainSelectedInstOperands,
     /*  736463 */     // GIR_Coverage, 22489,
     /*  736463 */     GIR_EraseRootFromParent_Done,
     /*  736464 */   // Label 11610: @736464
     /*  736464 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(736539), // Rule ID 22492 //
     /*  736469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  736486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736515 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  736518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736537 */     GIR_RootConstrainSelectedInstOperands,
     /*  736538 */     // GIR_Coverage, 22492,
     /*  736538 */     GIR_EraseRootFromParent_Done,
     /*  736539 */   // Label 11611: @736539
     /*  736539 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(736614), // Rule ID 22493 //
     /*  736544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  736561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  736593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736612 */     GIR_RootConstrainSelectedInstOperands,
     /*  736613 */     // GIR_Coverage, 22493,
     /*  736613 */     GIR_EraseRootFromParent_Done,
     /*  736614 */   // Label 11612: @736614
     /*  736614 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(736689), // Rule ID 22496 //
     /*  736619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  736636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736665 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  736668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736687 */     GIR_RootConstrainSelectedInstOperands,
     /*  736688 */     // GIR_Coverage, 22496,
     /*  736688 */     GIR_EraseRootFromParent_Done,
     /*  736689 */   // Label 11613: @736689
     /*  736689 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(736764), // Rule ID 22497 //
     /*  736694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  736711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11190:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  736743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736762 */     GIR_RootConstrainSelectedInstOperands,
     /*  736763 */     // GIR_Coverage, 22497,
     /*  736763 */     GIR_EraseRootFromParent_Done,
     /*  736764 */   // Label 11614: @736764
     /*  736764 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(736839), // Rule ID 22500 //
     /*  736769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  736780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  736783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  736786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  736789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  736818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736837 */     GIR_RootConstrainSelectedInstOperands,
     /*  736838 */     // GIR_Coverage, 22500,
     /*  736838 */     GIR_EraseRootFromParent_Done,
     /*  736839 */   // Label 11615: @736839
     /*  736839 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(736914), // Rule ID 22501 //
     /*  736844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  736855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  736858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  736861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  736864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  736893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736912 */     GIR_RootConstrainSelectedInstOperands,
     /*  736913 */     // GIR_Coverage, 22501,
     /*  736913 */     GIR_EraseRootFromParent_Done,
     /*  736914 */   // Label 11616: @736914
     /*  736914 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(736989), // Rule ID 22504 //
     /*  736919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  736927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  736930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  736933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  736936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  736939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  736968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  736972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736987 */     GIR_RootConstrainSelectedInstOperands,
     /*  736988 */     // GIR_Coverage, 22504,
     /*  736988 */     GIR_EraseRootFromParent_Done,
     /*  736989 */   // Label 11617: @736989
     /*  736989 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(737064), // Rule ID 22505 //
     /*  736994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  737011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  737043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737062 */     GIR_RootConstrainSelectedInstOperands,
     /*  737063 */     // GIR_Coverage, 22505,
     /*  737063 */     GIR_EraseRootFromParent_Done,
     /*  737064 */   // Label 11618: @737064
     /*  737064 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(737139), // Rule ID 22508 //
     /*  737069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  737086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  737118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737137 */     GIR_RootConstrainSelectedInstOperands,
     /*  737138 */     // GIR_Coverage, 22508,
     /*  737138 */     GIR_EraseRootFromParent_Done,
     /*  737139 */   // Label 11619: @737139
     /*  737139 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(737214), // Rule ID 22509 //
     /*  737144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  737161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  737193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737212 */     GIR_RootConstrainSelectedInstOperands,
     /*  737213 */     // GIR_Coverage, 22509,
     /*  737213 */     GIR_EraseRootFromParent_Done,
     /*  737214 */   // Label 11620: @737214
     /*  737214 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(737289), // Rule ID 22512 //
     /*  737219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  737236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  737268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737287 */     GIR_RootConstrainSelectedInstOperands,
     /*  737288 */     // GIR_Coverage, 22512,
     /*  737288 */     GIR_EraseRootFromParent_Done,
     /*  737289 */   // Label 11621: @737289
     /*  737289 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(737364), // Rule ID 22513 //
     /*  737294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  737311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  737343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737362 */     GIR_RootConstrainSelectedInstOperands,
     /*  737363 */     // GIR_Coverage, 22513,
     /*  737363 */     GIR_EraseRootFromParent_Done,
     /*  737364 */   // Label 11622: @737364
     /*  737364 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(737439), // Rule ID 22516 //
     /*  737369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  737386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737415 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  737418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737437 */     GIR_RootConstrainSelectedInstOperands,
     /*  737438 */     // GIR_Coverage, 22516,
     /*  737438 */     GIR_EraseRootFromParent_Done,
     /*  737439 */   // Label 11623: @737439
     /*  737439 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(737514), // Rule ID 22517 //
     /*  737444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  737461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  737493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737512 */     GIR_RootConstrainSelectedInstOperands,
     /*  737513 */     // GIR_Coverage, 22517,
     /*  737513 */     GIR_EraseRootFromParent_Done,
     /*  737514 */   // Label 11624: @737514
     /*  737514 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(737589), // Rule ID 22520 //
     /*  737519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  737536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737565 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  737568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737587 */     GIR_RootConstrainSelectedInstOperands,
     /*  737588 */     // GIR_Coverage, 22520,
     /*  737588 */     GIR_EraseRootFromParent_Done,
     /*  737589 */   // Label 11625: @737589
     /*  737589 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(737664), // Rule ID 22521 //
     /*  737594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  737611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  737643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737662 */     GIR_RootConstrainSelectedInstOperands,
     /*  737663 */     // GIR_Coverage, 22521,
     /*  737663 */     GIR_EraseRootFromParent_Done,
     /*  737664 */   // Label 11626: @737664
     /*  737664 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(737739), // Rule ID 22524 //
     /*  737669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  737686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  737715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  737718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737737 */     GIR_RootConstrainSelectedInstOperands,
     /*  737738 */     // GIR_Coverage, 22524,
     /*  737738 */     GIR_EraseRootFromParent_Done,
     /*  737739 */   // Label 11627: @737739
     /*  737739 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(737814), // Rule ID 22525 //
     /*  737744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  737747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  737761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  737790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  737793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737812 */     GIR_RootConstrainSelectedInstOperands,
     /*  737813 */     // GIR_Coverage, 22525,
     /*  737813 */     GIR_EraseRootFromParent_Done,
     /*  737814 */   // Label 11628: @737814
     /*  737814 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(737889), // Rule ID 22528 //
     /*  737819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  737836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  737865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  737868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737887 */     GIR_RootConstrainSelectedInstOperands,
     /*  737888 */     // GIR_Coverage, 22528,
     /*  737888 */     GIR_EraseRootFromParent_Done,
     /*  737889 */   // Label 11629: @737889
     /*  737889 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(737964), // Rule ID 22529 //
     /*  737894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  737897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  737911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  737940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  737943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  737947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737962 */     GIR_RootConstrainSelectedInstOperands,
     /*  737963 */     // GIR_Coverage, 22529,
     /*  737963 */     GIR_EraseRootFromParent_Done,
     /*  737964 */   // Label 11630: @737964
     /*  737964 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(738039), // Rule ID 22532 //
     /*  737969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  737977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  737986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738015 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  738018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738037 */     GIR_RootConstrainSelectedInstOperands,
     /*  738038 */     // GIR_Coverage, 22532,
     /*  738038 */     GIR_EraseRootFromParent_Done,
     /*  738039 */   // Label 11631: @738039
     /*  738039 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(738114), // Rule ID 22533 //
     /*  738044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  738052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  738061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  738093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738112 */     GIR_RootConstrainSelectedInstOperands,
     /*  738113 */     // GIR_Coverage, 22533,
     /*  738113 */     GIR_EraseRootFromParent_Done,
     /*  738114 */   // Label 11632: @738114
     /*  738114 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(738189), // Rule ID 22536 //
     /*  738119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  738136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  738168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738187 */     GIR_RootConstrainSelectedInstOperands,
     /*  738188 */     // GIR_Coverage, 22536,
     /*  738188 */     GIR_EraseRootFromParent_Done,
     /*  738189 */   // Label 11633: @738189
     /*  738189 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(738264), // Rule ID 22537 //
     /*  738194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  738211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  738243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738262 */     GIR_RootConstrainSelectedInstOperands,
     /*  738263 */     // GIR_Coverage, 22537,
     /*  738263 */     GIR_EraseRootFromParent_Done,
     /*  738264 */   // Label 11634: @738264
     /*  738264 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(738339), // Rule ID 22540 //
     /*  738269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  738286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  738318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738337 */     GIR_RootConstrainSelectedInstOperands,
     /*  738338 */     // GIR_Coverage, 22540,
     /*  738338 */     GIR_EraseRootFromParent_Done,
     /*  738339 */   // Label 11635: @738339
     /*  738339 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(738414), // Rule ID 22541 //
     /*  738344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  738361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  738393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738412 */     GIR_RootConstrainSelectedInstOperands,
     /*  738413 */     // GIR_Coverage, 22541,
     /*  738413 */     GIR_EraseRootFromParent_Done,
     /*  738414 */   // Label 11636: @738414
     /*  738414 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(738489), // Rule ID 22544 //
     /*  738419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  738436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738465 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  738468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738487 */     GIR_RootConstrainSelectedInstOperands,
     /*  738488 */     // GIR_Coverage, 22544,
     /*  738488 */     GIR_EraseRootFromParent_Done,
     /*  738489 */   // Label 11637: @738489
     /*  738489 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(738564), // Rule ID 22545 //
     /*  738494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  738505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  738508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  738511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  738514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  738543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738562 */     GIR_RootConstrainSelectedInstOperands,
     /*  738563 */     // GIR_Coverage, 22545,
     /*  738563 */     GIR_EraseRootFromParent_Done,
     /*  738564 */   // Label 11638: @738564
     /*  738564 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(738639), // Rule ID 22548 //
     /*  738569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  738586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  738589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  738618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738637 */     GIR_RootConstrainSelectedInstOperands,
     /*  738638 */     // GIR_Coverage, 22548,
     /*  738638 */     GIR_EraseRootFromParent_Done,
     /*  738639 */   // Label 11639: @738639
     /*  738639 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(738714), // Rule ID 22549 //
     /*  738644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  738661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  738664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  738693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738712 */     GIR_RootConstrainSelectedInstOperands,
     /*  738713 */     // GIR_Coverage, 22549,
     /*  738713 */     GIR_EraseRootFromParent_Done,
     /*  738714 */   // Label 11640: @738714
     /*  738714 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(738789), // Rule ID 22552 //
     /*  738719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  738736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  738739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  738768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738787 */     GIR_RootConstrainSelectedInstOperands,
     /*  738788 */     // GIR_Coverage, 22552,
     /*  738788 */     GIR_EraseRootFromParent_Done,
     /*  738789 */   // Label 11641: @738789
     /*  738789 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(738864), // Rule ID 22553 //
     /*  738794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  738811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  738814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  738843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738862 */     GIR_RootConstrainSelectedInstOperands,
     /*  738863 */     // GIR_Coverage, 22553,
     /*  738863 */     GIR_EraseRootFromParent_Done,
     /*  738864 */   // Label 11642: @738864
     /*  738864 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(738939), // Rule ID 22556 //
     /*  738869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  738886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  738918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738937 */     GIR_RootConstrainSelectedInstOperands,
     /*  738938 */     // GIR_Coverage, 22556,
     /*  738938 */     GIR_EraseRootFromParent_Done,
     /*  738939 */   // Label 11643: @738939
     /*  738939 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(739014), // Rule ID 22557 //
     /*  738944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  738952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  738961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  738993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  738997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739012 */     GIR_RootConstrainSelectedInstOperands,
     /*  739013 */     // GIR_Coverage, 22557,
     /*  739013 */     GIR_EraseRootFromParent_Done,
     /*  739014 */   // Label 11644: @739014
     /*  739014 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(739089), // Rule ID 22560 //
     /*  739019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  739036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739065 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  739068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739087 */     GIR_RootConstrainSelectedInstOperands,
     /*  739088 */     // GIR_Coverage, 22560,
     /*  739088 */     GIR_EraseRootFromParent_Done,
     /*  739089 */   // Label 11645: @739089
     /*  739089 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(739164), // Rule ID 22561 //
     /*  739094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  739111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  739143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739162 */     GIR_RootConstrainSelectedInstOperands,
     /*  739163 */     // GIR_Coverage, 22561,
     /*  739163 */     GIR_EraseRootFromParent_Done,
     /*  739164 */   // Label 11646: @739164
     /*  739164 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(739239), // Rule ID 22564 //
     /*  739169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  739180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  739183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  739186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  739189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739215 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  739218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739237 */     GIR_RootConstrainSelectedInstOperands,
     /*  739238 */     // GIR_Coverage, 22564,
     /*  739238 */     GIR_EraseRootFromParent_Done,
     /*  739239 */   // Label 11647: @739239
     /*  739239 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(739314), // Rule ID 22565 //
     /*  739244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  739255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  739258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  739261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  739264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  739293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739312 */     GIR_RootConstrainSelectedInstOperands,
     /*  739313 */     // GIR_Coverage, 22565,
     /*  739313 */     GIR_EraseRootFromParent_Done,
     /*  739314 */   // Label 11648: @739314
     /*  739314 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(739389), // Rule ID 22568 //
     /*  739319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  739330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  739333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  739336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  739339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  739368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739387 */     GIR_RootConstrainSelectedInstOperands,
     /*  739388 */     // GIR_Coverage, 22568,
     /*  739388 */     GIR_EraseRootFromParent_Done,
     /*  739389 */   // Label 11649: @739389
     /*  739389 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(739464), // Rule ID 22569 //
     /*  739394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  739405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  739408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  739411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  739414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  739443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739462 */     GIR_RootConstrainSelectedInstOperands,
     /*  739463 */     // GIR_Coverage, 22569,
     /*  739463 */     GIR_EraseRootFromParent_Done,
     /*  739464 */   // Label 11650: @739464
     /*  739464 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(739539), // Rule ID 22572 //
     /*  739469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  739486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  739518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739537 */     GIR_RootConstrainSelectedInstOperands,
     /*  739538 */     // GIR_Coverage, 22572,
     /*  739538 */     GIR_EraseRootFromParent_Done,
     /*  739539 */   // Label 11651: @739539
     /*  739539 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(739614), // Rule ID 22573 //
     /*  739544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  739561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  739593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739612 */     GIR_RootConstrainSelectedInstOperands,
     /*  739613 */     // GIR_Coverage, 22573,
     /*  739613 */     GIR_EraseRootFromParent_Done,
     /*  739614 */   // Label 11652: @739614
     /*  739614 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(739689), // Rule ID 22576 //
     /*  739619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  739636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  739668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739687 */     GIR_RootConstrainSelectedInstOperands,
     /*  739688 */     // GIR_Coverage, 22576,
     /*  739688 */     GIR_EraseRootFromParent_Done,
     /*  739689 */   // Label 11653: @739689
     /*  739689 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(739764), // Rule ID 22577 //
     /*  739694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  739711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  739743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739762 */     GIR_RootConstrainSelectedInstOperands,
     /*  739763 */     // GIR_Coverage, 22577,
     /*  739763 */     GIR_EraseRootFromParent_Done,
     /*  739764 */   // Label 11654: @739764
     /*  739764 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(739839), // Rule ID 22580 //
     /*  739769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  739786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  739818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739837 */     GIR_RootConstrainSelectedInstOperands,
     /*  739838 */     // GIR_Coverage, 22580,
     /*  739838 */     GIR_EraseRootFromParent_Done,
     /*  739839 */   // Label 11655: @739839
     /*  739839 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(739914), // Rule ID 22581 //
     /*  739844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  739855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  739858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  739861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  739864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  739893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739912 */     GIR_RootConstrainSelectedInstOperands,
     /*  739913 */     // GIR_Coverage, 22581,
     /*  739913 */     GIR_EraseRootFromParent_Done,
     /*  739914 */   // Label 11656: @739914
     /*  739914 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(739989), // Rule ID 22584 //
     /*  739919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  739927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  739930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  739933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  739936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  739939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  739968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  739972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739987 */     GIR_RootConstrainSelectedInstOperands,
     /*  739988 */     // GIR_Coverage, 22584,
     /*  739988 */     GIR_EraseRootFromParent_Done,
     /*  739989 */   // Label 11657: @739989
     /*  739989 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(740064), // Rule ID 22585 //
     /*  739994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  740011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  740014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  740043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740062 */     GIR_RootConstrainSelectedInstOperands,
     /*  740063 */     // GIR_Coverage, 22585,
     /*  740063 */     GIR_EraseRootFromParent_Done,
     /*  740064 */   // Label 11658: @740064
     /*  740064 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(740139), // Rule ID 22588 //
     /*  740069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  740086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  740089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  740118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740137 */     GIR_RootConstrainSelectedInstOperands,
     /*  740138 */     // GIR_Coverage, 22588,
     /*  740138 */     GIR_EraseRootFromParent_Done,
     /*  740139 */   // Label 11659: @740139
     /*  740139 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(740214), // Rule ID 22589 //
     /*  740144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  740161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  740164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  740193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740212 */     GIR_RootConstrainSelectedInstOperands,
     /*  740213 */     // GIR_Coverage, 22589,
     /*  740213 */     GIR_EraseRootFromParent_Done,
     /*  740214 */   // Label 11660: @740214
     /*  740214 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(740289), // Rule ID 22592 //
     /*  740219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  740236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  740239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  740268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740287 */     GIR_RootConstrainSelectedInstOperands,
     /*  740288 */     // GIR_Coverage, 22592,
     /*  740288 */     GIR_EraseRootFromParent_Done,
     /*  740289 */   // Label 11661: @740289
     /*  740289 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(740364), // Rule ID 22593 //
     /*  740294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  740311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  740314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  740343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740362 */     GIR_RootConstrainSelectedInstOperands,
     /*  740363 */     // GIR_Coverage, 22593,
     /*  740363 */     GIR_EraseRootFromParent_Done,
     /*  740364 */   // Label 11662: @740364
     /*  740364 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(740439), // Rule ID 22596 //
     /*  740369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  740386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  740418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740437 */     GIR_RootConstrainSelectedInstOperands,
     /*  740438 */     // GIR_Coverage, 22596,
     /*  740438 */     GIR_EraseRootFromParent_Done,
     /*  740439 */   // Label 11663: @740439
     /*  740439 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(740514), // Rule ID 22597 //
     /*  740444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  740461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  740493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740512 */     GIR_RootConstrainSelectedInstOperands,
     /*  740513 */     // GIR_Coverage, 22597,
     /*  740513 */     GIR_EraseRootFromParent_Done,
     /*  740514 */   // Label 11664: @740514
     /*  740514 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(740589), // Rule ID 22600 //
     /*  740519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  740536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740565 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  740568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740587 */     GIR_RootConstrainSelectedInstOperands,
     /*  740588 */     // GIR_Coverage, 22600,
     /*  740588 */     GIR_EraseRootFromParent_Done,
     /*  740589 */   // Label 11665: @740589
     /*  740589 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(740664), // Rule ID 22601 //
     /*  740594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  740611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  740643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740662 */     GIR_RootConstrainSelectedInstOperands,
     /*  740663 */     // GIR_Coverage, 22601,
     /*  740663 */     GIR_EraseRootFromParent_Done,
     /*  740664 */   // Label 11666: @740664
     /*  740664 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(740739), // Rule ID 22604 //
     /*  740669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  740686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  740718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740737 */     GIR_RootConstrainSelectedInstOperands,
     /*  740738 */     // GIR_Coverage, 22604,
     /*  740738 */     GIR_EraseRootFromParent_Done,
     /*  740739 */   // Label 11667: @740739
     /*  740739 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(740814), // Rule ID 22605 //
     /*  740744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  740752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  740761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  740764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  740793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740812 */     GIR_RootConstrainSelectedInstOperands,
     /*  740813 */     // GIR_Coverage, 22605,
     /*  740813 */     GIR_EraseRootFromParent_Done,
     /*  740814 */   // Label 11668: @740814
     /*  740814 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(740889), // Rule ID 22608 //
     /*  740819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  740827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  740839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  740868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740887 */     GIR_RootConstrainSelectedInstOperands,
     /*  740888 */     // GIR_Coverage, 22608,
     /*  740888 */     GIR_EraseRootFromParent_Done,
     /*  740889 */   // Label 11669: @740889
     /*  740889 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(740964), // Rule ID 22609 //
     /*  740894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  740902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  740914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  740943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  740947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740962 */     GIR_RootConstrainSelectedInstOperands,
     /*  740963 */     // GIR_Coverage, 22609,
     /*  740963 */     GIR_EraseRootFromParent_Done,
     /*  740964 */   // Label 11670: @740964
     /*  740964 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(741039), // Rule ID 22612 //
     /*  740969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  740977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  740989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  741018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741037 */     GIR_RootConstrainSelectedInstOperands,
     /*  741038 */     // GIR_Coverage, 22612,
     /*  741038 */     GIR_EraseRootFromParent_Done,
     /*  741039 */   // Label 11671: @741039
     /*  741039 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(741114), // Rule ID 22613 //
     /*  741044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  741061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  741093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741112 */     GIR_RootConstrainSelectedInstOperands,
     /*  741113 */     // GIR_Coverage, 22613,
     /*  741113 */     GIR_EraseRootFromParent_Done,
     /*  741114 */   // Label 11672: @741114
     /*  741114 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(741189), // Rule ID 22616 //
     /*  741119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  741136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  741168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741187 */     GIR_RootConstrainSelectedInstOperands,
     /*  741188 */     // GIR_Coverage, 22616,
     /*  741188 */     GIR_EraseRootFromParent_Done,
     /*  741189 */   // Label 11673: @741189
     /*  741189 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(741264), // Rule ID 22617 //
     /*  741194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  741211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  741243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741262 */     GIR_RootConstrainSelectedInstOperands,
     /*  741263 */     // GIR_Coverage, 22617,
     /*  741263 */     GIR_EraseRootFromParent_Done,
     /*  741264 */   // Label 11674: @741264
     /*  741264 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(741339), // Rule ID 22620 //
     /*  741269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  741286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741315 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  741318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741337 */     GIR_RootConstrainSelectedInstOperands,
     /*  741338 */     // GIR_Coverage, 22620,
     /*  741338 */     GIR_EraseRootFromParent_Done,
     /*  741339 */   // Label 11675: @741339
     /*  741339 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(741414), // Rule ID 22621 //
     /*  741344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  741361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  741393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741412 */     GIR_RootConstrainSelectedInstOperands,
     /*  741413 */     // GIR_Coverage, 22621,
     /*  741413 */     GIR_EraseRootFromParent_Done,
     /*  741414 */   // Label 11676: @741414
     /*  741414 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(741489), // Rule ID 22624 //
     /*  741419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  741436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741465 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  741468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741487 */     GIR_RootConstrainSelectedInstOperands,
     /*  741488 */     // GIR_Coverage, 22624,
     /*  741488 */     GIR_EraseRootFromParent_Done,
     /*  741489 */   // Label 11677: @741489
     /*  741489 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(741564), // Rule ID 22625 //
     /*  741494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  741511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  741543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741562 */     GIR_RootConstrainSelectedInstOperands,
     /*  741563 */     // GIR_Coverage, 22625,
     /*  741563 */     GIR_EraseRootFromParent_Done,
     /*  741564 */   // Label 11678: @741564
     /*  741564 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(741639), // Rule ID 22628 //
     /*  741569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  741586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  741618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741637 */     GIR_RootConstrainSelectedInstOperands,
     /*  741638 */     // GIR_Coverage, 22628,
     /*  741638 */     GIR_EraseRootFromParent_Done,
     /*  741639 */   // Label 11679: @741639
     /*  741639 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(741714), // Rule ID 22629 //
     /*  741644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  741661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  741693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741712 */     GIR_RootConstrainSelectedInstOperands,
     /*  741713 */     // GIR_Coverage, 22629,
     /*  741713 */     GIR_EraseRootFromParent_Done,
     /*  741714 */   // Label 11680: @741714
     /*  741714 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(741789), // Rule ID 22632 //
     /*  741719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  741736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  741768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741787 */     GIR_RootConstrainSelectedInstOperands,
     /*  741788 */     // GIR_Coverage, 22632,
     /*  741788 */     GIR_EraseRootFromParent_Done,
     /*  741789 */   // Label 11681: @741789
     /*  741789 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(741864), // Rule ID 22633 //
     /*  741794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  741811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  741843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741862 */     GIR_RootConstrainSelectedInstOperands,
     /*  741863 */     // GIR_Coverage, 22633,
     /*  741863 */     GIR_EraseRootFromParent_Done,
     /*  741864 */   // Label 11682: @741864
     /*  741864 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(741939), // Rule ID 22636 //
     /*  741869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  741918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741937 */     GIR_RootConstrainSelectedInstOperands,
     /*  741938 */     // GIR_Coverage, 22636,
     /*  741938 */     GIR_EraseRootFromParent_Done,
     /*  741939 */   // Label 11683: @741939
     /*  741939 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(742014), // Rule ID 22637 //
     /*  741944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  741952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  741993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  741997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742012 */     GIR_RootConstrainSelectedInstOperands,
     /*  742013 */     // GIR_Coverage, 22637,
     /*  742013 */     GIR_EraseRootFromParent_Done,
     /*  742014 */   // Label 11684: @742014
     /*  742014 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(742089), // Rule ID 22640 //
     /*  742019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  742030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  742033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  742036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  742039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  742068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742087 */     GIR_RootConstrainSelectedInstOperands,
     /*  742088 */     // GIR_Coverage, 22640,
     /*  742088 */     GIR_EraseRootFromParent_Done,
     /*  742089 */   // Label 11685: @742089
     /*  742089 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(742164), // Rule ID 22641 //
     /*  742094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  742105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  742108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  742111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  742114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  742143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742162 */     GIR_RootConstrainSelectedInstOperands,
     /*  742163 */     // GIR_Coverage, 22641,
     /*  742163 */     GIR_EraseRootFromParent_Done,
     /*  742164 */   // Label 11686: @742164
     /*  742164 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(742239), // Rule ID 22644 //
     /*  742169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  742186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  742218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742237 */     GIR_RootConstrainSelectedInstOperands,
     /*  742238 */     // GIR_Coverage, 22644,
     /*  742238 */     GIR_EraseRootFromParent_Done,
     /*  742239 */   // Label 11687: @742239
     /*  742239 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(742314), // Rule ID 22645 //
     /*  742244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  742261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  742293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742312 */     GIR_RootConstrainSelectedInstOperands,
     /*  742313 */     // GIR_Coverage, 22645,
     /*  742313 */     GIR_EraseRootFromParent_Done,
     /*  742314 */   // Label 11688: @742314
     /*  742314 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(742389), // Rule ID 22648 //
     /*  742319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  742336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  742368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742387 */     GIR_RootConstrainSelectedInstOperands,
     /*  742388 */     // GIR_Coverage, 22648,
     /*  742388 */     GIR_EraseRootFromParent_Done,
     /*  742389 */   // Label 11689: @742389
     /*  742389 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(742464), // Rule ID 22649 //
     /*  742394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  742411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  742443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742462 */     GIR_RootConstrainSelectedInstOperands,
     /*  742463 */     // GIR_Coverage, 22649,
     /*  742463 */     GIR_EraseRootFromParent_Done,
     /*  742464 */   // Label 11690: @742464
     /*  742464 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(742539), // Rule ID 22652 //
     /*  742469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  742486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  742518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742537 */     GIR_RootConstrainSelectedInstOperands,
     /*  742538 */     // GIR_Coverage, 22652,
     /*  742538 */     GIR_EraseRootFromParent_Done,
     /*  742539 */   // Label 11691: @742539
     /*  742539 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(742614), // Rule ID 22653 //
     /*  742544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  742561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  742564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  742593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742612 */     GIR_RootConstrainSelectedInstOperands,
     /*  742613 */     // GIR_Coverage, 22653,
     /*  742613 */     GIR_EraseRootFromParent_Done,
     /*  742614 */   // Label 11692: @742614
     /*  742614 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(742689), // Rule ID 22656 //
     /*  742619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  742630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  742633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  742639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  742668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742687 */     GIR_RootConstrainSelectedInstOperands,
     /*  742688 */     // GIR_Coverage, 22656,
     /*  742688 */     GIR_EraseRootFromParent_Done,
     /*  742689 */   // Label 11693: @742689
     /*  742689 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(742764), // Rule ID 22657 //
     /*  742694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  742705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  742708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  742714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  742743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742762 */     GIR_RootConstrainSelectedInstOperands,
     /*  742763 */     // GIR_Coverage, 22657,
     /*  742763 */     GIR_EraseRootFromParent_Done,
     /*  742764 */   // Label 11694: @742764
     /*  742764 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(742839), // Rule ID 22660 //
     /*  742769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  742780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  742783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  742789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  742818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742837 */     GIR_RootConstrainSelectedInstOperands,
     /*  742838 */     // GIR_Coverage, 22660,
     /*  742838 */     GIR_EraseRootFromParent_Done,
     /*  742839 */   // Label 11695: @742839
     /*  742839 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(742914), // Rule ID 22661 //
     /*  742844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  742855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  742858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  742864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  742893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742912 */     GIR_RootConstrainSelectedInstOperands,
     /*  742913 */     // GIR_Coverage, 22661,
     /*  742913 */     GIR_EraseRootFromParent_Done,
     /*  742914 */   // Label 11696: @742914
     /*  742914 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(742989), // Rule ID 22664 //
     /*  742919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  742927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  742930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  742933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  742939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  742968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  742972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742987 */     GIR_RootConstrainSelectedInstOperands,
     /*  742988 */     // GIR_Coverage, 22664,
     /*  742988 */     GIR_EraseRootFromParent_Done,
     /*  742989 */   // Label 11697: @742989
     /*  742989 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(743064), // Rule ID 22665 //
     /*  742994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  743011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  743014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  743043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743062 */     GIR_RootConstrainSelectedInstOperands,
     /*  743063 */     // GIR_Coverage, 22665,
     /*  743063 */     GIR_EraseRootFromParent_Done,
     /*  743064 */   // Label 11698: @743064
     /*  743064 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(743139), // Rule ID 22668 //
     /*  743069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  743086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  743115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  743118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743137 */     GIR_RootConstrainSelectedInstOperands,
     /*  743138 */     // GIR_Coverage, 22668,
     /*  743138 */     GIR_EraseRootFromParent_Done,
     /*  743139 */   // Label 11699: @743139
     /*  743139 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(743214), // Rule ID 22669 //
     /*  743144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  743161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  743190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  743193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743212 */     GIR_RootConstrainSelectedInstOperands,
     /*  743213 */     // GIR_Coverage, 22669,
     /*  743213 */     GIR_EraseRootFromParent_Done,
     /*  743214 */   // Label 11700: @743214
     /*  743214 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(743289), // Rule ID 22672 //
     /*  743219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  743236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  743265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  743268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743287 */     GIR_RootConstrainSelectedInstOperands,
     /*  743288 */     // GIR_Coverage, 22672,
     /*  743288 */     GIR_EraseRootFromParent_Done,
     /*  743289 */   // Label 11701: @743289
     /*  743289 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(743364), // Rule ID 22673 //
     /*  743294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  743311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  743340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  743343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743362 */     GIR_RootConstrainSelectedInstOperands,
     /*  743363 */     // GIR_Coverage, 22673,
     /*  743363 */     GIR_EraseRootFromParent_Done,
     /*  743364 */   // Label 11702: @743364
     /*  743364 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(743439), // Rule ID 22676 //
     /*  743369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  743386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  743415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  743418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743437 */     GIR_RootConstrainSelectedInstOperands,
     /*  743438 */     // GIR_Coverage, 22676,
     /*  743438 */     GIR_EraseRootFromParent_Done,
     /*  743439 */   // Label 11703: @743439
     /*  743439 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(743514), // Rule ID 22677 //
     /*  743444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  743452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  743461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  743464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  743490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  743493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743512 */     GIR_RootConstrainSelectedInstOperands,
     /*  743513 */     // GIR_Coverage, 22677,
     /*  743513 */     GIR_EraseRootFromParent_Done,
     /*  743514 */   // Label 11704: @743514
     /*  743514 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(743589), // Rule ID 22796 //
     /*  743519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  743522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743565 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  743568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743587 */     GIR_RootConstrainSelectedInstOperands,
     /*  743588 */     // GIR_Coverage, 22796,
     /*  743588 */     GIR_EraseRootFromParent_Done,
     /*  743589 */   // Label 11705: @743589
     /*  743589 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(743664), // Rule ID 22797 //
     /*  743594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  743597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743640 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  743643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743662 */     GIR_RootConstrainSelectedInstOperands,
     /*  743663 */     // GIR_Coverage, 22797,
     /*  743663 */     GIR_EraseRootFromParent_Done,
     /*  743664 */   // Label 11706: @743664
     /*  743664 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(743739), // Rule ID 22800 //
     /*  743669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  743672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743715 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  743718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743737 */     GIR_RootConstrainSelectedInstOperands,
     /*  743738 */     // GIR_Coverage, 22800,
     /*  743738 */     GIR_EraseRootFromParent_Done,
     /*  743739 */   // Label 11707: @743739
     /*  743739 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(743814), // Rule ID 22801 //
     /*  743744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  743747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743790 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  743793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743812 */     GIR_RootConstrainSelectedInstOperands,
     /*  743813 */     // GIR_Coverage, 22801,
     /*  743813 */     GIR_EraseRootFromParent_Done,
     /*  743814 */   // Label 11708: @743814
     /*  743814 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(743889), // Rule ID 22804 //
     /*  743819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  743822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  743836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  743839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743865 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  743865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  743868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743887 */     GIR_RootConstrainSelectedInstOperands,
     /*  743888 */     // GIR_Coverage, 22804,
     /*  743888 */     GIR_EraseRootFromParent_Done,
     /*  743889 */   // Label 11709: @743889
     /*  743889 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(743964), // Rule ID 22805 //
     /*  743894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  743897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  743911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  743914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  743940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  743943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  743947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  743959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743962 */     GIR_RootConstrainSelectedInstOperands,
     /*  743963 */     // GIR_Coverage, 22805,
     /*  743963 */     GIR_EraseRootFromParent_Done,
     /*  743964 */   // Label 11710: @743964
     /*  743964 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(744039), // Rule ID 22808 //
     /*  743969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  743972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  743977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  743986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744015 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  744018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744037 */     GIR_RootConstrainSelectedInstOperands,
     /*  744038 */     // GIR_Coverage, 22808,
     /*  744038 */     GIR_EraseRootFromParent_Done,
     /*  744039 */   // Label 11711: @744039
     /*  744039 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(744114), // Rule ID 22809 //
     /*  744044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  744047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  744093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744112 */     GIR_RootConstrainSelectedInstOperands,
     /*  744113 */     // GIR_Coverage, 22809,
     /*  744113 */     GIR_EraseRootFromParent_Done,
     /*  744114 */   // Label 11712: @744114
     /*  744114 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(744189), // Rule ID 22812 //
     /*  744119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  744122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744165 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  744168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744187 */     GIR_RootConstrainSelectedInstOperands,
     /*  744188 */     // GIR_Coverage, 22812,
     /*  744188 */     GIR_EraseRootFromParent_Done,
     /*  744189 */   // Label 11713: @744189
     /*  744189 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(744264), // Rule ID 22813 //
     /*  744194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  744197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744240 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  744243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744262 */     GIR_RootConstrainSelectedInstOperands,
     /*  744263 */     // GIR_Coverage, 22813,
     /*  744263 */     GIR_EraseRootFromParent_Done,
     /*  744264 */   // Label 11714: @744264
     /*  744264 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(744339), // Rule ID 22816 //
     /*  744269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  744272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  744289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744315 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  744315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  744318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744337 */     GIR_RootConstrainSelectedInstOperands,
     /*  744338 */     // GIR_Coverage, 22816,
     /*  744338 */     GIR_EraseRootFromParent_Done,
     /*  744339 */   // Label 11715: @744339
     /*  744339 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(744414), // Rule ID 22817 //
     /*  744344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  744347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  744364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744390 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  744390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  744393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744412 */     GIR_RootConstrainSelectedInstOperands,
     /*  744413 */     // GIR_Coverage, 22817,
     /*  744413 */     GIR_EraseRootFromParent_Done,
     /*  744414 */   // Label 11716: @744414
     /*  744414 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(744489), // Rule ID 22820 //
     /*  744419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  744422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744465 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  744468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744487 */     GIR_RootConstrainSelectedInstOperands,
     /*  744488 */     // GIR_Coverage, 22820,
     /*  744488 */     GIR_EraseRootFromParent_Done,
     /*  744489 */   // Label 11717: @744489
     /*  744489 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(744564), // Rule ID 22821 //
     /*  744494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  744497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  744543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744562 */     GIR_RootConstrainSelectedInstOperands,
     /*  744563 */     // GIR_Coverage, 22821,
     /*  744563 */     GIR_EraseRootFromParent_Done,
     /*  744564 */   // Label 11718: @744564
     /*  744564 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(744639), // Rule ID 22824 //
     /*  744569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  744572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744615 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  744618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744637 */     GIR_RootConstrainSelectedInstOperands,
     /*  744638 */     // GIR_Coverage, 22824,
     /*  744638 */     GIR_EraseRootFromParent_Done,
     /*  744639 */   // Label 11719: @744639
     /*  744639 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(744714), // Rule ID 22825 //
     /*  744644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  744647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  744693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744712 */     GIR_RootConstrainSelectedInstOperands,
     /*  744713 */     // GIR_Coverage, 22825,
     /*  744713 */     GIR_EraseRootFromParent_Done,
     /*  744714 */   // Label 11720: @744714
     /*  744714 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(744789), // Rule ID 22828 //
     /*  744719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  744722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  744736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744765 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  744768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744787 */     GIR_RootConstrainSelectedInstOperands,
     /*  744788 */     // GIR_Coverage, 22828,
     /*  744788 */     GIR_EraseRootFromParent_Done,
     /*  744789 */   // Label 11721: @744789
     /*  744789 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(744864), // Rule ID 22829 //
     /*  744794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  744797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  744811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10946:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  744843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744862 */     GIR_RootConstrainSelectedInstOperands,
     /*  744863 */     // GIR_Coverage, 22829,
     /*  744863 */     GIR_EraseRootFromParent_Done,
     /*  744864 */   // Label 11722: @744864
     /*  744864 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(744939), // Rule ID 22832 //
     /*  744869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  744872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744915 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  744918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744937 */     GIR_RootConstrainSelectedInstOperands,
     /*  744938 */     // GIR_Coverage, 22832,
     /*  744938 */     GIR_EraseRootFromParent_Done,
     /*  744939 */   // Label 11723: @744939
     /*  744939 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(745014), // Rule ID 22833 //
     /*  744944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  744947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  744952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  744993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  744997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745012 */     GIR_RootConstrainSelectedInstOperands,
     /*  745013 */     // GIR_Coverage, 22833,
     /*  745013 */     GIR_EraseRootFromParent_Done,
     /*  745014 */   // Label 11724: @745014
     /*  745014 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(745089), // Rule ID 22836 //
     /*  745019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  745022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745065 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  745068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745087 */     GIR_RootConstrainSelectedInstOperands,
     /*  745088 */     // GIR_Coverage, 22836,
     /*  745088 */     GIR_EraseRootFromParent_Done,
     /*  745089 */   // Label 11725: @745089
     /*  745089 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(745164), // Rule ID 22837 //
     /*  745094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  745097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  745143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745162 */     GIR_RootConstrainSelectedInstOperands,
     /*  745163 */     // GIR_Coverage, 22837,
     /*  745163 */     GIR_EraseRootFromParent_Done,
     /*  745164 */   // Label 11726: @745164
     /*  745164 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(745239), // Rule ID 22840 //
     /*  745169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  745172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  745186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745215 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  745218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745237 */     GIR_RootConstrainSelectedInstOperands,
     /*  745238 */     // GIR_Coverage, 22840,
     /*  745238 */     GIR_EraseRootFromParent_Done,
     /*  745239 */   // Label 11727: @745239
     /*  745239 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(745314), // Rule ID 22841 //
     /*  745244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  745247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  745261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10946:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  745293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745312 */     GIR_RootConstrainSelectedInstOperands,
     /*  745313 */     // GIR_Coverage, 22841,
     /*  745313 */     GIR_EraseRootFromParent_Done,
     /*  745314 */   // Label 11728: @745314
     /*  745314 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(745389), // Rule ID 22844 //
     /*  745319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  745322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  745336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745365 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  745365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  745368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745387 */     GIR_RootConstrainSelectedInstOperands,
     /*  745388 */     // GIR_Coverage, 22844,
     /*  745388 */     GIR_EraseRootFromParent_Done,
     /*  745389 */   // Label 11729: @745389
     /*  745389 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(745464), // Rule ID 22845 //
     /*  745394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  745397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  745411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745440 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  745440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  745443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745462 */     GIR_RootConstrainSelectedInstOperands,
     /*  745463 */     // GIR_Coverage, 22845,
     /*  745463 */     GIR_EraseRootFromParent_Done,
     /*  745464 */   // Label 11730: @745464
     /*  745464 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(745539), // Rule ID 22848 //
     /*  745469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  745472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  745486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745515 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  745515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  745518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745537 */     GIR_RootConstrainSelectedInstOperands,
     /*  745538 */     // GIR_Coverage, 22848,
     /*  745538 */     GIR_EraseRootFromParent_Done,
     /*  745539 */   // Label 11731: @745539
     /*  745539 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(745614), // Rule ID 22849 //
     /*  745544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  745547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  745561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745590 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  745590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  745593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745612 */     GIR_RootConstrainSelectedInstOperands,
     /*  745613 */     // GIR_Coverage, 22849,
     /*  745613 */     GIR_EraseRootFromParent_Done,
     /*  745614 */   // Label 11732: @745614
     /*  745614 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(745689), // Rule ID 22852 //
     /*  745619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  745622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  745636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745665 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  745665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  745668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745687 */     GIR_RootConstrainSelectedInstOperands,
     /*  745688 */     // GIR_Coverage, 22852,
     /*  745688 */     GIR_EraseRootFromParent_Done,
     /*  745689 */   // Label 11733: @745689
     /*  745689 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(745764), // Rule ID 22853 //
     /*  745694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  745697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  745702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  745711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  745714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10946:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  745740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  745743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  745759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745762 */     GIR_RootConstrainSelectedInstOperands,
     /*  745763 */     // GIR_Coverage, 22853,
     /*  745763 */     GIR_EraseRootFromParent_Done,
     /*  745764 */   // Label 11734: @745764
     /*  745764 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(745839), // Rule ID 22856 //
     /*  745769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  745772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  745777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  745789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745815 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  745818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745837 */     GIR_RootConstrainSelectedInstOperands,
     /*  745838 */     // GIR_Coverage, 22856,
     /*  745838 */     GIR_EraseRootFromParent_Done,
     /*  745839 */   // Label 11735: @745839
     /*  745839 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(745914), // Rule ID 22857 //
     /*  745844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  745847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  745852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  745864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  745893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745912 */     GIR_RootConstrainSelectedInstOperands,
     /*  745913 */     // GIR_Coverage, 22857,
     /*  745913 */     GIR_EraseRootFromParent_Done,
     /*  745914 */   // Label 11736: @745914
     /*  745914 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(745989), // Rule ID 22860 //
     /*  745919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  745922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  745927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  745936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  745939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745965 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  745968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  745972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745987 */     GIR_RootConstrainSelectedInstOperands,
     /*  745988 */     // GIR_Coverage, 22860,
     /*  745988 */     GIR_EraseRootFromParent_Done,
     /*  745989 */   // Label 11737: @745989
     /*  745989 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(746064), // Rule ID 22861 //
     /*  745994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  745997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746040 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  746043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746062 */     GIR_RootConstrainSelectedInstOperands,
     /*  746063 */     // GIR_Coverage, 22861,
     /*  746063 */     GIR_EraseRootFromParent_Done,
     /*  746064 */   // Label 11738: @746064
     /*  746064 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(746139), // Rule ID 22864 //
     /*  746069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  746072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  746089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746115 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  746118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746137 */     GIR_RootConstrainSelectedInstOperands,
     /*  746138 */     // GIR_Coverage, 22864,
     /*  746138 */     GIR_EraseRootFromParent_Done,
     /*  746139 */   // Label 11739: @746139
     /*  746139 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(746214), // Rule ID 22865 //
     /*  746144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  746147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  746164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  746193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746212 */     GIR_RootConstrainSelectedInstOperands,
     /*  746213 */     // GIR_Coverage, 22865,
     /*  746213 */     GIR_EraseRootFromParent_Done,
     /*  746214 */   // Label 11740: @746214
     /*  746214 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(746289), // Rule ID 22868 //
     /*  746219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  746222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746265 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  746268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746287 */     GIR_RootConstrainSelectedInstOperands,
     /*  746288 */     // GIR_Coverage, 22868,
     /*  746288 */     GIR_EraseRootFromParent_Done,
     /*  746289 */   // Label 11741: @746289
     /*  746289 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(746364), // Rule ID 22869 //
     /*  746294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  746297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746340 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  746343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746362 */     GIR_RootConstrainSelectedInstOperands,
     /*  746363 */     // GIR_Coverage, 22869,
     /*  746363 */     GIR_EraseRootFromParent_Done,
     /*  746364 */   // Label 11742: @746364
     /*  746364 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(746439), // Rule ID 22872 //
     /*  746369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  746372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  746389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746415 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  746418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746437 */     GIR_RootConstrainSelectedInstOperands,
     /*  746438 */     // GIR_Coverage, 22872,
     /*  746438 */     GIR_EraseRootFromParent_Done,
     /*  746439 */   // Label 11743: @746439
     /*  746439 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(746514), // Rule ID 22873 //
     /*  746444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  746447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  746464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  746493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746512 */     GIR_RootConstrainSelectedInstOperands,
     /*  746513 */     // GIR_Coverage, 22873,
     /*  746513 */     GIR_EraseRootFromParent_Done,
     /*  746514 */   // Label 11744: @746514
     /*  746514 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(746589), // Rule ID 22876 //
     /*  746519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  746522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  746536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  746539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746565 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  746568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746587 */     GIR_RootConstrainSelectedInstOperands,
     /*  746588 */     // GIR_Coverage, 22876,
     /*  746588 */     GIR_EraseRootFromParent_Done,
     /*  746589 */   // Label 11745: @746589
     /*  746589 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(746664), // Rule ID 22877 //
     /*  746594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  746597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  746611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  746614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  746643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746662 */     GIR_RootConstrainSelectedInstOperands,
     /*  746663 */     // GIR_Coverage, 22877,
     /*  746663 */     GIR_EraseRootFromParent_Done,
     /*  746664 */   // Label 11746: @746664
     /*  746664 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(746739), // Rule ID 22880 //
     /*  746669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  746672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746715 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  746718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746737 */     GIR_RootConstrainSelectedInstOperands,
     /*  746738 */     // GIR_Coverage, 22880,
     /*  746738 */     GIR_EraseRootFromParent_Done,
     /*  746739 */   // Label 11747: @746739
     /*  746739 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(746814), // Rule ID 22881 //
     /*  746744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  746747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746790 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  746793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746812 */     GIR_RootConstrainSelectedInstOperands,
     /*  746813 */     // GIR_Coverage, 22881,
     /*  746813 */     GIR_EraseRootFromParent_Done,
     /*  746814 */   // Label 11748: @746814
     /*  746814 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(746889), // Rule ID 22884 //
     /*  746819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  746822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  746868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746887 */     GIR_RootConstrainSelectedInstOperands,
     /*  746888 */     // GIR_Coverage, 22884,
     /*  746888 */     GIR_EraseRootFromParent_Done,
     /*  746889 */   // Label 11749: @746889
     /*  746889 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(746964), // Rule ID 22885 //
     /*  746894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  746897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  746943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  746947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746962 */     GIR_RootConstrainSelectedInstOperands,
     /*  746963 */     // GIR_Coverage, 22885,
     /*  746963 */     GIR_EraseRootFromParent_Done,
     /*  746964 */   // Label 11750: @746964
     /*  746964 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(747039), // Rule ID 22888 //
     /*  746969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  746972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  746977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  746986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  746989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747015 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  747018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747037 */     GIR_RootConstrainSelectedInstOperands,
     /*  747038 */     // GIR_Coverage, 22888,
     /*  747038 */     GIR_EraseRootFromParent_Done,
     /*  747039 */   // Label 11751: @747039
     /*  747039 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(747114), // Rule ID 22889 //
     /*  747044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  747047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  747061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  747064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10944:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  747093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747112 */     GIR_RootConstrainSelectedInstOperands,
     /*  747113 */     // GIR_Coverage, 22889,
     /*  747113 */     GIR_EraseRootFromParent_Done,
     /*  747114 */   // Label 11752: @747114
     /*  747114 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(747189), // Rule ID 22892 //
     /*  747119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  747122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747165 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  747168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747187 */     GIR_RootConstrainSelectedInstOperands,
     /*  747188 */     // GIR_Coverage, 22892,
     /*  747188 */     GIR_EraseRootFromParent_Done,
     /*  747189 */   // Label 11753: @747189
     /*  747189 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(747264), // Rule ID 22893 //
     /*  747194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  747197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747240 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  747243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747262 */     GIR_RootConstrainSelectedInstOperands,
     /*  747263 */     // GIR_Coverage, 22893,
     /*  747263 */     GIR_EraseRootFromParent_Done,
     /*  747264 */   // Label 11754: @747264
     /*  747264 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(747339), // Rule ID 22896 //
     /*  747269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  747272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747315 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  747318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747337 */     GIR_RootConstrainSelectedInstOperands,
     /*  747338 */     // GIR_Coverage, 22896,
     /*  747338 */     GIR_EraseRootFromParent_Done,
     /*  747339 */   // Label 11755: @747339
     /*  747339 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(747414), // Rule ID 22897 //
     /*  747344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  747347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747390 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  747393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747412 */     GIR_RootConstrainSelectedInstOperands,
     /*  747413 */     // GIR_Coverage, 22897,
     /*  747413 */     GIR_EraseRootFromParent_Done,
     /*  747414 */   // Label 11756: @747414
     /*  747414 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(747489), // Rule ID 22900 //
     /*  747419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  747422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  747436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747465 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  747468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747487 */     GIR_RootConstrainSelectedInstOperands,
     /*  747488 */     // GIR_Coverage, 22900,
     /*  747488 */     GIR_EraseRootFromParent_Done,
     /*  747489 */   // Label 11757: @747489
     /*  747489 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(747564), // Rule ID 22901 //
     /*  747494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  747497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  747511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  747514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10944:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  747543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747562 */     GIR_RootConstrainSelectedInstOperands,
     /*  747563 */     // GIR_Coverage, 22901,
     /*  747563 */     GIR_EraseRootFromParent_Done,
     /*  747564 */   // Label 11758: @747564
     /*  747564 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(747639), // Rule ID 22904 //
     /*  747569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  747572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  747586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747615 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  747615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  747618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  747634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747637 */     GIR_RootConstrainSelectedInstOperands,
     /*  747638 */     // GIR_Coverage, 22904,
     /*  747638 */     GIR_EraseRootFromParent_Done,
     /*  747639 */   // Label 11759: @747639
     /*  747639 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(747714), // Rule ID 22905 //
     /*  747644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  747647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  747661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747690 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  747690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  747693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  747709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747712 */     GIR_RootConstrainSelectedInstOperands,
     /*  747713 */     // GIR_Coverage, 22905,
     /*  747713 */     GIR_EraseRootFromParent_Done,
     /*  747714 */   // Label 11760: @747714
     /*  747714 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(747789), // Rule ID 22908 //
     /*  747719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  747722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  747736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747765 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  747765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  747768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  747784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747787 */     GIR_RootConstrainSelectedInstOperands,
     /*  747788 */     // GIR_Coverage, 22908,
     /*  747788 */     GIR_EraseRootFromParent_Done,
     /*  747789 */   // Label 11761: @747789
     /*  747789 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(747864), // Rule ID 22909 //
     /*  747794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  747797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  747811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747840 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  747840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  747843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  747859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747862 */     GIR_RootConstrainSelectedInstOperands,
     /*  747863 */     // GIR_Coverage, 22909,
     /*  747863 */     GIR_EraseRootFromParent_Done,
     /*  747864 */   // Label 11762: @747864
     /*  747864 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(747939), // Rule ID 22912 //
     /*  747869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  747872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  747886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747915 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  747915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  747918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  747934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747937 */     GIR_RootConstrainSelectedInstOperands,
     /*  747938 */     // GIR_Coverage, 22912,
     /*  747938 */     GIR_EraseRootFromParent_Done,
     /*  747939 */   // Label 11763: @747939
     /*  747939 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(748014), // Rule ID 22913 //
     /*  747944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  747947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  747952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  747961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  747964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747990 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10944:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  747990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  747993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  747997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  748009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748012 */     GIR_RootConstrainSelectedInstOperands,
     /*  748013 */     // GIR_Coverage, 22913,
     /*  748013 */     GIR_EraseRootFromParent_Done,
     /*  748014 */   // Label 11764: @748014
     /*  748014 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(748089), // Rule ID 23194 //
     /*  748019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  748030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  748033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  748036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  748039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748065 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  748068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748087 */     GIR_RootConstrainSelectedInstOperands,
     /*  748088 */     // GIR_Coverage, 23194,
     /*  748088 */     GIR_EraseRootFromParent_Done,
     /*  748089 */   // Label 11765: @748089
     /*  748089 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(748164), // Rule ID 23195 //
     /*  748094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  748105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  748108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  748111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  748114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  748143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748162 */     GIR_RootConstrainSelectedInstOperands,
     /*  748163 */     // GIR_Coverage, 23195,
     /*  748163 */     GIR_EraseRootFromParent_Done,
     /*  748164 */   // Label 11766: @748164
     /*  748164 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(748239), // Rule ID 23198 //
     /*  748169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  748180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  748183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  748186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  748189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  748218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748237 */     GIR_RootConstrainSelectedInstOperands,
     /*  748238 */     // GIR_Coverage, 23198,
     /*  748238 */     GIR_EraseRootFromParent_Done,
     /*  748239 */   // Label 11767: @748239
     /*  748239 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(748314), // Rule ID 23199 //
     /*  748244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  748255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  748258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  748261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  748264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  748293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748312 */     GIR_RootConstrainSelectedInstOperands,
     /*  748313 */     // GIR_Coverage, 23199,
     /*  748313 */     GIR_EraseRootFromParent_Done,
     /*  748314 */   // Label 11768: @748314
     /*  748314 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(748389), // Rule ID 23202 //
     /*  748319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  748330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  748333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  748336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  748339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748365 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  748368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748387 */     GIR_RootConstrainSelectedInstOperands,
     /*  748388 */     // GIR_Coverage, 23202,
     /*  748388 */     GIR_EraseRootFromParent_Done,
     /*  748389 */   // Label 11769: @748389
     /*  748389 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(748464), // Rule ID 23203 //
     /*  748394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  748405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  748408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  748411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  748414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  748443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748462 */     GIR_RootConstrainSelectedInstOperands,
     /*  748463 */     // GIR_Coverage, 23203,
     /*  748463 */     GIR_EraseRootFromParent_Done,
     /*  748464 */   // Label 11770: @748464
     /*  748464 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(748539), // Rule ID 23206 //
     /*  748469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  748480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  748483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  748486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  748489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748515 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  748518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748537 */     GIR_RootConstrainSelectedInstOperands,
     /*  748538 */     // GIR_Coverage, 23206,
     /*  748538 */     GIR_EraseRootFromParent_Done,
     /*  748539 */   // Label 11771: @748539
     /*  748539 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(748614), // Rule ID 23207 //
     /*  748544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  748555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  748558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  748561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  748564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  748593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748612 */     GIR_RootConstrainSelectedInstOperands,
     /*  748613 */     // GIR_Coverage, 23207,
     /*  748613 */     GIR_EraseRootFromParent_Done,
     /*  748614 */   // Label 11772: @748614
     /*  748614 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(748689), // Rule ID 23210 //
     /*  748619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  748630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  748633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  748636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  748639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748665 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  748668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748687 */     GIR_RootConstrainSelectedInstOperands,
     /*  748688 */     // GIR_Coverage, 23210,
     /*  748688 */     GIR_EraseRootFromParent_Done,
     /*  748689 */   // Label 11773: @748689
     /*  748689 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(748764), // Rule ID 23211 //
     /*  748694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  748705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  748708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  748711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  748714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748740 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  748743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748762 */     GIR_RootConstrainSelectedInstOperands,
     /*  748763 */     // GIR_Coverage, 23211,
     /*  748763 */     GIR_EraseRootFromParent_Done,
     /*  748764 */   // Label 11774: @748764
     /*  748764 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(748839), // Rule ID 23214 //
     /*  748769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  748780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  748783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  748786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  748789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748815 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  748818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748837 */     GIR_RootConstrainSelectedInstOperands,
     /*  748838 */     // GIR_Coverage, 23214,
     /*  748838 */     GIR_EraseRootFromParent_Done,
     /*  748839 */   // Label 11775: @748839
     /*  748839 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(748914), // Rule ID 23215 //
     /*  748844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  748852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  748855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  748858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  748861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  748864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748890 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11134:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  748890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  748893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748912 */     GIR_RootConstrainSelectedInstOperands,
     /*  748913 */     // GIR_Coverage, 23215,
     /*  748913 */     GIR_EraseRootFromParent_Done,
     /*  748914 */   // Label 11776: @748914
     /*  748914 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(748989), // Rule ID 23218 //
     /*  748919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  748922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  748927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  748930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  748933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  748936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  748939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  748946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  748958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  748965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  748968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  748974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  748976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  748987 */     GIR_RootConstrainSelectedInstOperands,
     /*  748988 */     // GIR_Coverage, 23218,
     /*  748988 */     GIR_EraseRootFromParent_Done,
     /*  748989 */   // Label 11777: @748989
     /*  748989 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(749064), // Rule ID 23219 //
     /*  748994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  748997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  749005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  749008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  749011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  749014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  749043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749062 */     GIR_RootConstrainSelectedInstOperands,
     /*  749063 */     // GIR_Coverage, 23219,
     /*  749063 */     GIR_EraseRootFromParent_Done,
     /*  749064 */   // Label 11778: @749064
     /*  749064 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(749139), // Rule ID 23222 //
     /*  749069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  749080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  749083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  749086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  749089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749115 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  749118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749137 */     GIR_RootConstrainSelectedInstOperands,
     /*  749138 */     // GIR_Coverage, 23222,
     /*  749138 */     GIR_EraseRootFromParent_Done,
     /*  749139 */   // Label 11779: @749139
     /*  749139 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(749214), // Rule ID 23223 //
     /*  749144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  749155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  749158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  749161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  749164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  749193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749212 */     GIR_RootConstrainSelectedInstOperands,
     /*  749213 */     // GIR_Coverage, 23223,
     /*  749213 */     GIR_EraseRootFromParent_Done,
     /*  749214 */   // Label 11780: @749214
     /*  749214 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(749289), // Rule ID 23226 //
     /*  749219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  749230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  749233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  749236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  749239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749265 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  749268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749287 */     GIR_RootConstrainSelectedInstOperands,
     /*  749288 */     // GIR_Coverage, 23226,
     /*  749288 */     GIR_EraseRootFromParent_Done,
     /*  749289 */   // Label 11781: @749289
     /*  749289 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(749364), // Rule ID 23227 //
     /*  749294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  749305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  749308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  749311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  749314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  749343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749362 */     GIR_RootConstrainSelectedInstOperands,
     /*  749363 */     // GIR_Coverage, 23227,
     /*  749363 */     GIR_EraseRootFromParent_Done,
     /*  749364 */   // Label 11782: @749364
     /*  749364 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(749439), // Rule ID 23230 //
     /*  749369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  749380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  749383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  749386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  749389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  749418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749437 */     GIR_RootConstrainSelectedInstOperands,
     /*  749438 */     // GIR_Coverage, 23230,
     /*  749438 */     GIR_EraseRootFromParent_Done,
     /*  749439 */   // Label 11783: @749439
     /*  749439 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(749514), // Rule ID 23231 //
     /*  749444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  749455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  749458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  749461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  749464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  749493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749512 */     GIR_RootConstrainSelectedInstOperands,
     /*  749513 */     // GIR_Coverage, 23231,
     /*  749513 */     GIR_EraseRootFromParent_Done,
     /*  749514 */   // Label 11784: @749514
     /*  749514 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(749589), // Rule ID 23234 //
     /*  749519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  749530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  749533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  749536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  749539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  749568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749587 */     GIR_RootConstrainSelectedInstOperands,
     /*  749588 */     // GIR_Coverage, 23234,
     /*  749588 */     GIR_EraseRootFromParent_Done,
     /*  749589 */   // Label 11785: @749589
     /*  749589 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(749664), // Rule ID 23235 //
     /*  749594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  749605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  749608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  749611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  749614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749640 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  749643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749662 */     GIR_RootConstrainSelectedInstOperands,
     /*  749663 */     // GIR_Coverage, 23235,
     /*  749663 */     GIR_EraseRootFromParent_Done,
     /*  749664 */   // Label 11786: @749664
     /*  749664 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(749739), // Rule ID 23238 //
     /*  749669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  749680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  749683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  749686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  749689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749715 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  749718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749737 */     GIR_RootConstrainSelectedInstOperands,
     /*  749738 */     // GIR_Coverage, 23238,
     /*  749738 */     GIR_EraseRootFromParent_Done,
     /*  749739 */   // Label 11787: @749739
     /*  749739 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(749814), // Rule ID 23239 //
     /*  749744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  749755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  749758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  749761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  749764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749790 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  749793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749812 */     GIR_RootConstrainSelectedInstOperands,
     /*  749813 */     // GIR_Coverage, 23239,
     /*  749813 */     GIR_EraseRootFromParent_Done,
     /*  749814 */   // Label 11788: @749814
     /*  749814 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(749889), // Rule ID 23242 //
     /*  749819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  749830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  749833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  749836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  749839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749865 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  749865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  749868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749887 */     GIR_RootConstrainSelectedInstOperands,
     /*  749888 */     // GIR_Coverage, 23242,
     /*  749888 */     GIR_EraseRootFromParent_Done,
     /*  749889 */   // Label 11789: @749889
     /*  749889 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(749964), // Rule ID 23243 //
     /*  749894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  749897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  749902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  749905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  749908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  749911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  749914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  749933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749940 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11147:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  749940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  749943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  749949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  749951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  749962 */     GIR_RootConstrainSelectedInstOperands,
     /*  749963 */     // GIR_Coverage, 23243,
     /*  749963 */     GIR_EraseRootFromParent_Done,
     /*  749964 */   // Label 11790: @749964
     /*  749964 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(750039), // Rule ID 23246 //
     /*  749969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  749972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  749977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  749980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  749983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  749986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  749989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  749996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  750018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750037 */     GIR_RootConstrainSelectedInstOperands,
     /*  750038 */     // GIR_Coverage, 23246,
     /*  750038 */     GIR_EraseRootFromParent_Done,
     /*  750039 */   // Label 11791: @750039
     /*  750039 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(750114), // Rule ID 23247 //
     /*  750044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  750055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  750058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  750061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  750064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  750093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750112 */     GIR_RootConstrainSelectedInstOperands,
     /*  750113 */     // GIR_Coverage, 23247,
     /*  750113 */     GIR_EraseRootFromParent_Done,
     /*  750114 */   // Label 11792: @750114
     /*  750114 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(750189), // Rule ID 23250 //
     /*  750119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  750130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  750133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  750136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  750139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750165 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  750168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750187 */     GIR_RootConstrainSelectedInstOperands,
     /*  750188 */     // GIR_Coverage, 23250,
     /*  750188 */     GIR_EraseRootFromParent_Done,
     /*  750189 */   // Label 11793: @750189
     /*  750189 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(750264), // Rule ID 23251 //
     /*  750194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  750205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  750208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  750211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  750214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750240 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  750243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750262 */     GIR_RootConstrainSelectedInstOperands,
     /*  750263 */     // GIR_Coverage, 23251,
     /*  750263 */     GIR_EraseRootFromParent_Done,
     /*  750264 */   // Label 11794: @750264
     /*  750264 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(750339), // Rule ID 23254 //
     /*  750269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  750280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  750283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  750286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  750289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  750318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750337 */     GIR_RootConstrainSelectedInstOperands,
     /*  750338 */     // GIR_Coverage, 23254,
     /*  750338 */     GIR_EraseRootFromParent_Done,
     /*  750339 */   // Label 11795: @750339
     /*  750339 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(750414), // Rule ID 23255 //
     /*  750344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  750355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  750358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  750361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  750364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  750393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750412 */     GIR_RootConstrainSelectedInstOperands,
     /*  750413 */     // GIR_Coverage, 23255,
     /*  750413 */     GIR_EraseRootFromParent_Done,
     /*  750414 */   // Label 11796: @750414
     /*  750414 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(750489), // Rule ID 23258 //
     /*  750419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  750430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  750433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  750436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  750439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750465 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  750468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750487 */     GIR_RootConstrainSelectedInstOperands,
     /*  750488 */     // GIR_Coverage, 23258,
     /*  750488 */     GIR_EraseRootFromParent_Done,
     /*  750489 */   // Label 11797: @750489
     /*  750489 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(750564), // Rule ID 23259 //
     /*  750494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  750505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  750508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  750511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  750514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  750543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750562 */     GIR_RootConstrainSelectedInstOperands,
     /*  750563 */     // GIR_Coverage, 23259,
     /*  750563 */     GIR_EraseRootFromParent_Done,
     /*  750564 */   // Label 11798: @750564
     /*  750564 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(750639), // Rule ID 23262 //
     /*  750569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  750580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  750583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  750586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  750589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750615 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  750618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750637 */     GIR_RootConstrainSelectedInstOperands,
     /*  750638 */     // GIR_Coverage, 23262,
     /*  750638 */     GIR_EraseRootFromParent_Done,
     /*  750639 */   // Label 11799: @750639
     /*  750639 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(750714), // Rule ID 23263 //
     /*  750644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  750655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  750658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  750661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  750664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  750693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750712 */     GIR_RootConstrainSelectedInstOperands,
     /*  750713 */     // GIR_Coverage, 23263,
     /*  750713 */     GIR_EraseRootFromParent_Done,
     /*  750714 */   // Label 11800: @750714
     /*  750714 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(750789), // Rule ID 23266 //
     /*  750719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  750730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  750733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  750736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  750739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750765 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  750768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750787 */     GIR_RootConstrainSelectedInstOperands,
     /*  750788 */     // GIR_Coverage, 23266,
     /*  750788 */     GIR_EraseRootFromParent_Done,
     /*  750789 */   // Label 11801: @750789
     /*  750789 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(750864), // Rule ID 23267 //
     /*  750794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  750805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  750808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  750811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  750814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  750843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750862 */     GIR_RootConstrainSelectedInstOperands,
     /*  750863 */     // GIR_Coverage, 23267,
     /*  750863 */     GIR_EraseRootFromParent_Done,
     /*  750864 */   // Label 11802: @750864
     /*  750864 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(750939), // Rule ID 23270 //
     /*  750869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  750872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  750880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  750883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  750886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  750889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750915 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  750915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  750918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  750926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  750937 */     GIR_RootConstrainSelectedInstOperands,
     /*  750938 */     // GIR_Coverage, 23270,
     /*  750938 */     GIR_EraseRootFromParent_Done,
     /*  750939 */   // Label 11803: @750939
     /*  750939 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(751014), // Rule ID 23271 //
     /*  750944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  750947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  750952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  750955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  750958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  750961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  750964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  750971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  750983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750990 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11159:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  750990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  750993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  750999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  751001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  751012 */     GIR_RootConstrainSelectedInstOperands,
     /*  751013 */     // GIR_Coverage, 23271,
     /*  751013 */     GIR_EraseRootFromParent_Done,
     /*  751014 */   // Label 11804: @751014
     /*  751014 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(751089), // Rule ID 23812 //
     /*  751019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  751030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  751033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751065 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  751068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751087 */     GIR_RootConstrainSelectedInstOperands,
     /*  751088 */     // GIR_Coverage, 23812,
     /*  751088 */     GIR_EraseRootFromParent_Done,
     /*  751089 */   // Label 11805: @751089
     /*  751089 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(751164), // Rule ID 23813 //
     /*  751094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  751105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  751108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  751143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751162 */     GIR_RootConstrainSelectedInstOperands,
     /*  751163 */     // GIR_Coverage, 23813,
     /*  751163 */     GIR_EraseRootFromParent_Done,
     /*  751164 */   // Label 11806: @751164
     /*  751164 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(751239), // Rule ID 23816 //
     /*  751169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  751180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  751183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751215 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  751218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751237 */     GIR_RootConstrainSelectedInstOperands,
     /*  751238 */     // GIR_Coverage, 23816,
     /*  751238 */     GIR_EraseRootFromParent_Done,
     /*  751239 */   // Label 11807: @751239
     /*  751239 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(751314), // Rule ID 23817 //
     /*  751244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  751255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  751258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751290 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  751293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751312 */     GIR_RootConstrainSelectedInstOperands,
     /*  751313 */     // GIR_Coverage, 23817,
     /*  751313 */     GIR_EraseRootFromParent_Done,
     /*  751314 */   // Label 11808: @751314
     /*  751314 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(751389), // Rule ID 23820 //
     /*  751319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  751330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  751333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751365 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751387 */     GIR_RootConstrainSelectedInstOperands,
     /*  751388 */     // GIR_Coverage, 23820,
     /*  751388 */     GIR_EraseRootFromParent_Done,
     /*  751389 */   // Label 11809: @751389
     /*  751389 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(751464), // Rule ID 23821 //
     /*  751394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  751405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  751408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751462 */     GIR_RootConstrainSelectedInstOperands,
     /*  751463 */     // GIR_Coverage, 23821,
     /*  751463 */     GIR_EraseRootFromParent_Done,
     /*  751464 */   // Label 11810: @751464
     /*  751464 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(751539), // Rule ID 23824 //
     /*  751469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  751486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751515 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  751518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751537 */     GIR_RootConstrainSelectedInstOperands,
     /*  751538 */     // GIR_Coverage, 23824,
     /*  751538 */     GIR_EraseRootFromParent_Done,
     /*  751539 */   // Label 11811: @751539
     /*  751539 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(751614), // Rule ID 23825 //
     /*  751544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  751561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  751593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751612 */     GIR_RootConstrainSelectedInstOperands,
     /*  751613 */     // GIR_Coverage, 23825,
     /*  751613 */     GIR_EraseRootFromParent_Done,
     /*  751614 */   // Label 11812: @751614
     /*  751614 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(751689), // Rule ID 23828 //
     /*  751619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751665 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751687 */     GIR_RootConstrainSelectedInstOperands,
     /*  751688 */     // GIR_Coverage, 23828,
     /*  751688 */     GIR_EraseRootFromParent_Done,
     /*  751689 */   // Label 11813: @751689
     /*  751689 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(751764), // Rule ID 23829 //
     /*  751694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751762 */     GIR_RootConstrainSelectedInstOperands,
     /*  751763 */     // GIR_Coverage, 23829,
     /*  751763 */     GIR_EraseRootFromParent_Done,
     /*  751764 */   // Label 11814: @751764
     /*  751764 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(751839), // Rule ID 23832 //
     /*  751769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  751780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  751783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751815 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751837 */     GIR_RootConstrainSelectedInstOperands,
     /*  751838 */     // GIR_Coverage, 23832,
     /*  751838 */     GIR_EraseRootFromParent_Done,
     /*  751839 */   // Label 11815: @751839
     /*  751839 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(751914), // Rule ID 23833 //
     /*  751844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  751855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  751858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  751893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751912 */     GIR_RootConstrainSelectedInstOperands,
     /*  751913 */     // GIR_Coverage, 23833,
     /*  751913 */     GIR_EraseRootFromParent_Done,
     /*  751914 */   // Label 11816: @751914
     /*  751914 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(751989), // Rule ID 23836 //
     /*  751919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  751927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  751930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  751933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  751968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751987 */     GIR_RootConstrainSelectedInstOperands,
     /*  751988 */     // GIR_Coverage, 23836,
     /*  751988 */     GIR_EraseRootFromParent_Done,
     /*  751989 */   // Label 11817: @751989
     /*  751989 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(752064), // Rule ID 23837 //
     /*  751994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  752005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  752008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752062 */     GIR_RootConstrainSelectedInstOperands,
     /*  752063 */     // GIR_Coverage, 23837,
     /*  752063 */     GIR_EraseRootFromParent_Done,
     /*  752064 */   // Label 11818: @752064
     /*  752064 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(752139), // Rule ID 23840 //
     /*  752069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752137 */     GIR_RootConstrainSelectedInstOperands,
     /*  752138 */     // GIR_Coverage, 23840,
     /*  752138 */     GIR_EraseRootFromParent_Done,
     /*  752139 */   // Label 11819: @752139
     /*  752139 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(752214), // Rule ID 23841 //
     /*  752144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752212 */     GIR_RootConstrainSelectedInstOperands,
     /*  752213 */     // GIR_Coverage, 23841,
     /*  752213 */     GIR_EraseRootFromParent_Done,
     /*  752214 */   // Label 11820: @752214
     /*  752214 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(752289), // Rule ID 23844 //
     /*  752219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  752236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752287 */     GIR_RootConstrainSelectedInstOperands,
     /*  752288 */     // GIR_Coverage, 23844,
     /*  752288 */     GIR_EraseRootFromParent_Done,
     /*  752289 */   // Label 11821: @752289
     /*  752289 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(752364), // Rule ID 23845 //
     /*  752294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  752311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752362 */     GIR_RootConstrainSelectedInstOperands,
     /*  752363 */     // GIR_Coverage, 23845,
     /*  752363 */     GIR_EraseRootFromParent_Done,
     /*  752364 */   // Label 11822: @752364
     /*  752364 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(752439), // Rule ID 23848 //
     /*  752369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  752372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  752386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  752415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  752434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752437 */     GIR_RootConstrainSelectedInstOperands,
     /*  752438 */     // GIR_Coverage, 23848,
     /*  752438 */     GIR_EraseRootFromParent_Done,
     /*  752439 */   // Label 11823: @752439
     /*  752439 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(752514), // Rule ID 23849 //
     /*  752444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  752447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  752461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  752490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  752493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  752509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752512 */     GIR_RootConstrainSelectedInstOperands,
     /*  752513 */     // GIR_Coverage, 23849,
     /*  752513 */     GIR_EraseRootFromParent_Done,
     /*  752514 */   // Label 11824: @752514
     /*  752514 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(752589), // Rule ID 23852 //
     /*  752519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  752530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  752533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  752568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752587 */     GIR_RootConstrainSelectedInstOperands,
     /*  752588 */     // GIR_Coverage, 23852,
     /*  752588 */     GIR_EraseRootFromParent_Done,
     /*  752589 */   // Label 11825: @752589
     /*  752589 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(752664), // Rule ID 23853 //
     /*  752594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  752605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  752608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  752643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752662 */     GIR_RootConstrainSelectedInstOperands,
     /*  752663 */     // GIR_Coverage, 23853,
     /*  752663 */     GIR_EraseRootFromParent_Done,
     /*  752664 */   // Label 11826: @752664
     /*  752664 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(752739), // Rule ID 23856 //
     /*  752669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  752680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  752683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752715 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  752718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752737 */     GIR_RootConstrainSelectedInstOperands,
     /*  752738 */     // GIR_Coverage, 23856,
     /*  752738 */     GIR_EraseRootFromParent_Done,
     /*  752739 */   // Label 11827: @752739
     /*  752739 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(752814), // Rule ID 23857 //
     /*  752744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  752755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  752758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  752793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752812 */     GIR_RootConstrainSelectedInstOperands,
     /*  752813 */     // GIR_Coverage, 23857,
     /*  752813 */     GIR_EraseRootFromParent_Done,
     /*  752814 */   // Label 11828: @752814
     /*  752814 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(752889), // Rule ID 23860 //
     /*  752819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  752830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  752833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  752836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752865 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  752868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752887 */     GIR_RootConstrainSelectedInstOperands,
     /*  752888 */     // GIR_Coverage, 23860,
     /*  752888 */     GIR_EraseRootFromParent_Done,
     /*  752889 */   // Label 11829: @752889
     /*  752889 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(752964), // Rule ID 23861 //
     /*  752894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  752905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  752908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  752911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752940 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  752943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752962 */     GIR_RootConstrainSelectedInstOperands,
     /*  752963 */     // GIR_Coverage, 23861,
     /*  752963 */     GIR_EraseRootFromParent_Done,
     /*  752964 */   // Label 11830: @752964
     /*  752964 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(753039), // Rule ID 23864 //
     /*  752969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  752977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753037 */     GIR_RootConstrainSelectedInstOperands,
     /*  753038 */     // GIR_Coverage, 23864,
     /*  753038 */     GIR_EraseRootFromParent_Done,
     /*  753039 */   // Label 11831: @753039
     /*  753039 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(753114), // Rule ID 23865 //
     /*  753044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  753055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  753058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753112 */     GIR_RootConstrainSelectedInstOperands,
     /*  753113 */     // GIR_Coverage, 23865,
     /*  753113 */     GIR_EraseRootFromParent_Done,
     /*  753114 */   // Label 11832: @753114
     /*  753114 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(753189), // Rule ID 23868 //
     /*  753119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  753130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  753133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  753168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753187 */     GIR_RootConstrainSelectedInstOperands,
     /*  753188 */     // GIR_Coverage, 23868,
     /*  753188 */     GIR_EraseRootFromParent_Done,
     /*  753189 */   // Label 11833: @753189
     /*  753189 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(753264), // Rule ID 23869 //
     /*  753194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  753205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  753208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  753243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753262 */     GIR_RootConstrainSelectedInstOperands,
     /*  753263 */     // GIR_Coverage, 23869,
     /*  753263 */     GIR_EraseRootFromParent_Done,
     /*  753264 */   // Label 11834: @753264
     /*  753264 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(753339), // Rule ID 23872 //
     /*  753269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  753286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  753318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753337 */     GIR_RootConstrainSelectedInstOperands,
     /*  753338 */     // GIR_Coverage, 23872,
     /*  753338 */     GIR_EraseRootFromParent_Done,
     /*  753339 */   // Label 11835: @753339
     /*  753339 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(753414), // Rule ID 23873 //
     /*  753344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  753361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  753393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753412 */     GIR_RootConstrainSelectedInstOperands,
     /*  753413 */     // GIR_Coverage, 23873,
     /*  753413 */     GIR_EraseRootFromParent_Done,
     /*  753414 */   // Label 11836: @753414
     /*  753414 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(753489), // Rule ID 23876 //
     /*  753419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753487 */     GIR_RootConstrainSelectedInstOperands,
     /*  753488 */     // GIR_Coverage, 23876,
     /*  753488 */     GIR_EraseRootFromParent_Done,
     /*  753489 */   // Label 11837: @753489
     /*  753489 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(753564), // Rule ID 23877 //
     /*  753494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753562 */     GIR_RootConstrainSelectedInstOperands,
     /*  753563 */     // GIR_Coverage, 23877,
     /*  753563 */     GIR_EraseRootFromParent_Done,
     /*  753564 */   // Label 11838: @753564
     /*  753564 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(753639), // Rule ID 23880 //
     /*  753569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  753618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753637 */     GIR_RootConstrainSelectedInstOperands,
     /*  753638 */     // GIR_Coverage, 23880,
     /*  753638 */     GIR_EraseRootFromParent_Done,
     /*  753639 */   // Label 11839: @753639
     /*  753639 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(753714), // Rule ID 23881 //
     /*  753644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  753693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753712 */     GIR_RootConstrainSelectedInstOperands,
     /*  753713 */     // GIR_Coverage, 23881,
     /*  753713 */     GIR_EraseRootFromParent_Done,
     /*  753714 */   // Label 11840: @753714
     /*  753714 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(753789), // Rule ID 23884 //
     /*  753719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  753736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753765 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  753768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753787 */     GIR_RootConstrainSelectedInstOperands,
     /*  753788 */     // GIR_Coverage, 23884,
     /*  753788 */     GIR_EraseRootFromParent_Done,
     /*  753789 */   // Label 11841: @753789
     /*  753789 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(753864), // Rule ID 23885 //
     /*  753794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  753811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753840 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  753843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753862 */     GIR_RootConstrainSelectedInstOperands,
     /*  753863 */     // GIR_Coverage, 23885,
     /*  753863 */     GIR_EraseRootFromParent_Done,
     /*  753864 */   // Label 11842: @753864
     /*  753864 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(753939), // Rule ID 23888 //
     /*  753869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  753872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  753886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  753915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  753934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753937 */     GIR_RootConstrainSelectedInstOperands,
     /*  753938 */     // GIR_Coverage, 23888,
     /*  753938 */     GIR_EraseRootFromParent_Done,
     /*  753939 */   // Label 11843: @753939
     /*  753939 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(754014), // Rule ID 23889 //
     /*  753944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  753947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  753952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  753961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  753990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  753993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  754009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754012 */     GIR_RootConstrainSelectedInstOperands,
     /*  754013 */     // GIR_Coverage, 23889,
     /*  754013 */     GIR_EraseRootFromParent_Done,
     /*  754014 */   // Label 11844: @754014
     /*  754014 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(754089), // Rule ID 23892 //
     /*  754019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  754022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  754027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  754036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754065 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  754065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  754068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  754084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754087 */     GIR_RootConstrainSelectedInstOperands,
     /*  754088 */     // GIR_Coverage, 23892,
     /*  754088 */     GIR_EraseRootFromParent_Done,
     /*  754089 */   // Label 11845: @754089
     /*  754089 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(754164), // Rule ID 23893 //
     /*  754094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  754097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  754102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  754111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  754140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  754143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  754159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754162 */     GIR_RootConstrainSelectedInstOperands,
     /*  754163 */     // GIR_Coverage, 23893,
     /*  754163 */     GIR_EraseRootFromParent_Done,
     /*  754164 */   // Label 11846: @754164
     /*  754164 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(754239), // Rule ID 23896 //
     /*  754169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  754172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  754177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  754186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754215 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  754215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  754218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  754234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754237 */     GIR_RootConstrainSelectedInstOperands,
     /*  754238 */     // GIR_Coverage, 23896,
     /*  754238 */     GIR_EraseRootFromParent_Done,
     /*  754239 */   // Label 11847: @754239
     /*  754239 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(754314), // Rule ID 23897 //
     /*  754244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  754247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  754252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  754261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  754290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  754293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  754309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754312 */     GIR_RootConstrainSelectedInstOperands,
     /*  754313 */     // GIR_Coverage, 23897,
     /*  754313 */     GIR_EraseRootFromParent_Done,
     /*  754314 */   // Label 11848: @754314
     /*  754314 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(754389), // Rule ID 23900 //
     /*  754319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  754330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  754333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754365 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  754368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754387 */     GIR_RootConstrainSelectedInstOperands,
     /*  754388 */     // GIR_Coverage, 23900,
     /*  754388 */     GIR_EraseRootFromParent_Done,
     /*  754389 */   // Label 11849: @754389
     /*  754389 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(754464), // Rule ID 23901 //
     /*  754394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  754405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  754408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  754443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754462 */     GIR_RootConstrainSelectedInstOperands,
     /*  754463 */     // GIR_Coverage, 23901,
     /*  754463 */     GIR_EraseRootFromParent_Done,
     /*  754464 */   // Label 11850: @754464
     /*  754464 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(754539), // Rule ID 23904 //
     /*  754469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  754480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  754483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754515 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  754518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754537 */     GIR_RootConstrainSelectedInstOperands,
     /*  754538 */     // GIR_Coverage, 23904,
     /*  754538 */     GIR_EraseRootFromParent_Done,
     /*  754539 */   // Label 11851: @754539
     /*  754539 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(754614), // Rule ID 23905 //
     /*  754544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  754555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  754558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754590 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  754593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754612 */     GIR_RootConstrainSelectedInstOperands,
     /*  754613 */     // GIR_Coverage, 23905,
     /*  754613 */     GIR_EraseRootFromParent_Done,
     /*  754614 */   // Label 11852: @754614
     /*  754614 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(754689), // Rule ID 23908 //
     /*  754619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  754630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  754633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754665 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  754668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754687 */     GIR_RootConstrainSelectedInstOperands,
     /*  754688 */     // GIR_Coverage, 23908,
     /*  754688 */     GIR_EraseRootFromParent_Done,
     /*  754689 */   // Label 11853: @754689
     /*  754689 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(754764), // Rule ID 23909 //
     /*  754694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  754705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  754708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754740 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  754743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754762 */     GIR_RootConstrainSelectedInstOperands,
     /*  754763 */     // GIR_Coverage, 23909,
     /*  754763 */     GIR_EraseRootFromParent_Done,
     /*  754764 */   // Label 11854: @754764
     /*  754764 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(754839), // Rule ID 23912 //
     /*  754769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754815 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  754818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754837 */     GIR_RootConstrainSelectedInstOperands,
     /*  754838 */     // GIR_Coverage, 23912,
     /*  754838 */     GIR_EraseRootFromParent_Done,
     /*  754839 */   // Label 11855: @754839
     /*  754839 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(754914), // Rule ID 23913 //
     /*  754844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  754893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754912 */     GIR_RootConstrainSelectedInstOperands,
     /*  754913 */     // GIR_Coverage, 23913,
     /*  754913 */     GIR_EraseRootFromParent_Done,
     /*  754914 */   // Label 11856: @754914
     /*  754914 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(754989), // Rule ID 23916 //
     /*  754919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  754927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754965 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  754968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754987 */     GIR_RootConstrainSelectedInstOperands,
     /*  754988 */     // GIR_Coverage, 23916,
     /*  754988 */     GIR_EraseRootFromParent_Done,
     /*  754989 */   // Label 11857: @754989
     /*  754989 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(755064), // Rule ID 23917 //
     /*  754994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  755005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  755008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  755043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755062 */     GIR_RootConstrainSelectedInstOperands,
     /*  755063 */     // GIR_Coverage, 23917,
     /*  755063 */     GIR_EraseRootFromParent_Done,
     /*  755064 */   // Label 11858: @755064
     /*  755064 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(755139), // Rule ID 23920 //
     /*  755069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  755118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755137 */     GIR_RootConstrainSelectedInstOperands,
     /*  755138 */     // GIR_Coverage, 23920,
     /*  755138 */     GIR_EraseRootFromParent_Done,
     /*  755139 */   // Label 11859: @755139
     /*  755139 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(755214), // Rule ID 23921 //
     /*  755144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  755193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755212 */     GIR_RootConstrainSelectedInstOperands,
     /*  755213 */     // GIR_Coverage, 23921,
     /*  755213 */     GIR_EraseRootFromParent_Done,
     /*  755214 */   // Label 11860: @755214
     /*  755214 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(755289), // Rule ID 23924 //
     /*  755219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  755230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  755233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  755236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755287 */     GIR_RootConstrainSelectedInstOperands,
     /*  755288 */     // GIR_Coverage, 23924,
     /*  755288 */     GIR_EraseRootFromParent_Done,
     /*  755289 */   // Label 11861: @755289
     /*  755289 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(755364), // Rule ID 23925 //
     /*  755294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  755305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  755308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  755311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755362 */     GIR_RootConstrainSelectedInstOperands,
     /*  755363 */     // GIR_Coverage, 23925,
     /*  755363 */     GIR_EraseRootFromParent_Done,
     /*  755364 */   // Label 11862: @755364
     /*  755364 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(755439), // Rule ID 23928 //
     /*  755369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  755380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  755383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755437 */     GIR_RootConstrainSelectedInstOperands,
     /*  755438 */     // GIR_Coverage, 23928,
     /*  755438 */     GIR_EraseRootFromParent_Done,
     /*  755439 */   // Label 11863: @755439
     /*  755439 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(755514), // Rule ID 23929 //
     /*  755444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  755455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  755458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755512 */     GIR_RootConstrainSelectedInstOperands,
     /*  755513 */     // GIR_Coverage, 23929,
     /*  755513 */     GIR_EraseRootFromParent_Done,
     /*  755514 */   // Label 11864: @755514
     /*  755514 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(755589), // Rule ID 23932 //
     /*  755519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755565 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755587 */     GIR_RootConstrainSelectedInstOperands,
     /*  755588 */     // GIR_Coverage, 23932,
     /*  755588 */     GIR_EraseRootFromParent_Done,
     /*  755589 */   // Label 11865: @755589
     /*  755589 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(755664), // Rule ID 23933 //
     /*  755594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755662 */     GIR_RootConstrainSelectedInstOperands,
     /*  755663 */     // GIR_Coverage, 23933,
     /*  755663 */     GIR_EraseRootFromParent_Done,
     /*  755664 */   // Label 11866: @755664
     /*  755664 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(755739), // Rule ID 23936 //
     /*  755669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  755672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  755686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  755715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  755734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755737 */     GIR_RootConstrainSelectedInstOperands,
     /*  755738 */     // GIR_Coverage, 23936,
     /*  755738 */     GIR_EraseRootFromParent_Done,
     /*  755739 */   // Label 11867: @755739
     /*  755739 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(755814), // Rule ID 23937 //
     /*  755744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  755747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  755761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  755790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  755793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  755809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755812 */     GIR_RootConstrainSelectedInstOperands,
     /*  755813 */     // GIR_Coverage, 23937,
     /*  755813 */     GIR_EraseRootFromParent_Done,
     /*  755814 */   // Label 11868: @755814
     /*  755814 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(755889), // Rule ID 23940 //
     /*  755819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  755830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  755833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755865 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  755868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755887 */     GIR_RootConstrainSelectedInstOperands,
     /*  755888 */     // GIR_Coverage, 23940,
     /*  755888 */     GIR_EraseRootFromParent_Done,
     /*  755889 */   // Label 11869: @755889
     /*  755889 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(755964), // Rule ID 23941 //
     /*  755894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  755905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  755908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  755943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755962 */     GIR_RootConstrainSelectedInstOperands,
     /*  755963 */     // GIR_Coverage, 23941,
     /*  755963 */     GIR_EraseRootFromParent_Done,
     /*  755964 */   // Label 11870: @755964
     /*  755964 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(756039), // Rule ID 23944 //
     /*  755969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  755977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  755980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  755983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  755986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756015 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756037 */     GIR_RootConstrainSelectedInstOperands,
     /*  756038 */     // GIR_Coverage, 23944,
     /*  756038 */     GIR_EraseRootFromParent_Done,
     /*  756039 */   // Label 11871: @756039
     /*  756039 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(756114), // Rule ID 23945 //
     /*  756044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  756055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  756058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  756061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756090 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756112 */     GIR_RootConstrainSelectedInstOperands,
     /*  756113 */     // GIR_Coverage, 23945,
     /*  756113 */     GIR_EraseRootFromParent_Done,
     /*  756114 */   // Label 11872: @756114
     /*  756114 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(756189), // Rule ID 23948 //
     /*  756119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  756130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  756133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  756136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756165 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  756168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756187 */     GIR_RootConstrainSelectedInstOperands,
     /*  756188 */     // GIR_Coverage, 23948,
     /*  756188 */     GIR_EraseRootFromParent_Done,
     /*  756189 */   // Label 11873: @756189
     /*  756189 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(756264), // Rule ID 23949 //
     /*  756194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  756205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  756208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  756211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756240 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  756243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756262 */     GIR_RootConstrainSelectedInstOperands,
     /*  756263 */     // GIR_Coverage, 23949,
     /*  756263 */     GIR_EraseRootFromParent_Done,
     /*  756264 */   // Label 11874: @756264
     /*  756264 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(756339), // Rule ID 23952 //
     /*  756269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  756286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  756318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756337 */     GIR_RootConstrainSelectedInstOperands,
     /*  756338 */     // GIR_Coverage, 23952,
     /*  756338 */     GIR_EraseRootFromParent_Done,
     /*  756339 */   // Label 11875: @756339
     /*  756339 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(756414), // Rule ID 23953 //
     /*  756344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  756361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  756393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756412 */     GIR_RootConstrainSelectedInstOperands,
     /*  756413 */     // GIR_Coverage, 23953,
     /*  756413 */     GIR_EraseRootFromParent_Done,
     /*  756414 */   // Label 11876: @756414
     /*  756414 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(756489), // Rule ID 23956 //
     /*  756419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756465 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756487 */     GIR_RootConstrainSelectedInstOperands,
     /*  756488 */     // GIR_Coverage, 23956,
     /*  756488 */     GIR_EraseRootFromParent_Done,
     /*  756489 */   // Label 11877: @756489
     /*  756489 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(756564), // Rule ID 23957 //
     /*  756494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756562 */     GIR_RootConstrainSelectedInstOperands,
     /*  756563 */     // GIR_Coverage, 23957,
     /*  756563 */     GIR_EraseRootFromParent_Done,
     /*  756564 */   // Label 11878: @756564
     /*  756564 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(756639), // Rule ID 23960 //
     /*  756569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  756586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756615 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  756618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756637 */     GIR_RootConstrainSelectedInstOperands,
     /*  756638 */     // GIR_Coverage, 23960,
     /*  756638 */     GIR_EraseRootFromParent_Done,
     /*  756639 */   // Label 11879: @756639
     /*  756639 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(756714), // Rule ID 23961 //
     /*  756644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  756661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  756693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756712 */     GIR_RootConstrainSelectedInstOperands,
     /*  756713 */     // GIR_Coverage, 23961,
     /*  756713 */     GIR_EraseRootFromParent_Done,
     /*  756714 */   // Label 11880: @756714
     /*  756714 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(756789), // Rule ID 23964 //
     /*  756719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  756768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756787 */     GIR_RootConstrainSelectedInstOperands,
     /*  756788 */     // GIR_Coverage, 23964,
     /*  756788 */     GIR_EraseRootFromParent_Done,
     /*  756789 */   // Label 11881: @756789
     /*  756789 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(756864), // Rule ID 23965 //
     /*  756794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  756843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756862 */     GIR_RootConstrainSelectedInstOperands,
     /*  756863 */     // GIR_Coverage, 23965,
     /*  756863 */     GIR_EraseRootFromParent_Done,
     /*  756864 */   // Label 11882: @756864
     /*  756864 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(756939), // Rule ID 23968 //
     /*  756869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  756880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  756883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756937 */     GIR_RootConstrainSelectedInstOperands,
     /*  756938 */     // GIR_Coverage, 23968,
     /*  756938 */     GIR_EraseRootFromParent_Done,
     /*  756939 */   // Label 11883: @756939
     /*  756939 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(757014), // Rule ID 23969 //
     /*  756944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  756952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  756955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  756958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  756993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757012 */     GIR_RootConstrainSelectedInstOperands,
     /*  757013 */     // GIR_Coverage, 23969,
     /*  757013 */     GIR_EraseRootFromParent_Done,
     /*  757014 */   // Label 11884: @757014
     /*  757014 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(757089), // Rule ID 23972 //
     /*  757019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  757036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  757068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757087 */     GIR_RootConstrainSelectedInstOperands,
     /*  757088 */     // GIR_Coverage, 23972,
     /*  757088 */     GIR_EraseRootFromParent_Done,
     /*  757089 */   // Label 11885: @757089
     /*  757089 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(757164), // Rule ID 23973 //
     /*  757094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  757111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  757143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757162 */     GIR_RootConstrainSelectedInstOperands,
     /*  757163 */     // GIR_Coverage, 23973,
     /*  757163 */     GIR_EraseRootFromParent_Done,
     /*  757164 */   // Label 11886: @757164
     /*  757164 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(757239), // Rule ID 23976 //
     /*  757169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  757186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  757218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757237 */     GIR_RootConstrainSelectedInstOperands,
     /*  757238 */     // GIR_Coverage, 23976,
     /*  757238 */     GIR_EraseRootFromParent_Done,
     /*  757239 */   // Label 11887: @757239
     /*  757239 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(757314), // Rule ID 23977 //
     /*  757244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  757261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  757293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757312 */     GIR_RootConstrainSelectedInstOperands,
     /*  757313 */     // GIR_Coverage, 23977,
     /*  757313 */     GIR_EraseRootFromParent_Done,
     /*  757314 */   // Label 11888: @757314
     /*  757314 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(757389), // Rule ID 23980 //
     /*  757319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  757336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757365 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  757368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757387 */     GIR_RootConstrainSelectedInstOperands,
     /*  757388 */     // GIR_Coverage, 23980,
     /*  757388 */     GIR_EraseRootFromParent_Done,
     /*  757389 */   // Label 11889: @757389
     /*  757389 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(757464), // Rule ID 23981 //
     /*  757394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  757411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  757443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757462 */     GIR_RootConstrainSelectedInstOperands,
     /*  757463 */     // GIR_Coverage, 23981,
     /*  757463 */     GIR_EraseRootFromParent_Done,
     /*  757464 */   // Label 11890: @757464
     /*  757464 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(757539), // Rule ID 23984 //
     /*  757469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  757486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757515 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  757518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757537 */     GIR_RootConstrainSelectedInstOperands,
     /*  757538 */     // GIR_Coverage, 23984,
     /*  757538 */     GIR_EraseRootFromParent_Done,
     /*  757539 */   // Label 11891: @757539
     /*  757539 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(757614), // Rule ID 23985 //
     /*  757544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  757552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  757561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  757593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757612 */     GIR_RootConstrainSelectedInstOperands,
     /*  757613 */     // GIR_Coverage, 23985,
     /*  757613 */     GIR_EraseRootFromParent_Done,
     /*  757614 */   // Label 11892: @757614
     /*  757614 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(757689), // Rule ID 24228 //
     /*  757619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  757622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  757627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  757639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  757658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757665 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  757668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757687 */     GIR_RootConstrainSelectedInstOperands,
     /*  757688 */     // GIR_Coverage, 24228,
     /*  757688 */     GIR_EraseRootFromParent_Done,
     /*  757689 */   // Label 11893: @757689
     /*  757689 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(757764), // Rule ID 24229 //
     /*  757694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  757697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  757702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  757714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  757733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757740 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  757743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757762 */     GIR_RootConstrainSelectedInstOperands,
     /*  757763 */     // GIR_Coverage, 24229,
     /*  757763 */     GIR_EraseRootFromParent_Done,
     /*  757764 */   // Label 11894: @757764
     /*  757764 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(757839), // Rule ID 24232 //
     /*  757769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  757772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  757777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  757789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  757808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  757818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757837 */     GIR_RootConstrainSelectedInstOperands,
     /*  757838 */     // GIR_Coverage, 24232,
     /*  757838 */     GIR_EraseRootFromParent_Done,
     /*  757839 */   // Label 11895: @757839
     /*  757839 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(757914), // Rule ID 24233 //
     /*  757844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  757847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  757852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  757864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  757883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  757893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757912 */     GIR_RootConstrainSelectedInstOperands,
     /*  757913 */     // GIR_Coverage, 24233,
     /*  757913 */     GIR_EraseRootFromParent_Done,
     /*  757914 */   // Label 11896: @757914
     /*  757914 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(757989), // Rule ID 24236 //
     /*  757919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  757922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  757927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  757958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757965 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  757968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757987 */     GIR_RootConstrainSelectedInstOperands,
     /*  757988 */     // GIR_Coverage, 24236,
     /*  757988 */     GIR_EraseRootFromParent_Done,
     /*  757989 */   // Label 11897: @757989
     /*  757989 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(758064), // Rule ID 24237 //
     /*  757994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  757997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  758005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  758008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  758011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  758033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758040 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  758043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758062 */     GIR_RootConstrainSelectedInstOperands,
     /*  758063 */     // GIR_Coverage, 24237,
     /*  758063 */     GIR_EraseRootFromParent_Done,
     /*  758064 */   // Label 11898: @758064
     /*  758064 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(758139), // Rule ID 24240 //
     /*  758069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  758072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  758086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  758118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758137 */     GIR_RootConstrainSelectedInstOperands,
     /*  758138 */     // GIR_Coverage, 24240,
     /*  758138 */     GIR_EraseRootFromParent_Done,
     /*  758139 */   // Label 11899: @758139
     /*  758139 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(758214), // Rule ID 24241 //
     /*  758144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  758147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  758161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10964:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  758193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758212 */     GIR_RootConstrainSelectedInstOperands,
     /*  758213 */     // GIR_Coverage, 24241,
     /*  758213 */     GIR_EraseRootFromParent_Done,
     /*  758214 */   // Label 11900: @758214
     /*  758214 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(758289), // Rule ID 24244 //
     /*  758219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  758222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  758258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10964:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  758268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758287 */     GIR_RootConstrainSelectedInstOperands,
     /*  758288 */     // GIR_Coverage, 24244,
     /*  758288 */     GIR_EraseRootFromParent_Done,
     /*  758289 */   // Label 11901: @758289
     /*  758289 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(758364), // Rule ID 24245 //
     /*  758294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  758297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  758333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758340 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10964:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  758343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758362 */     GIR_RootConstrainSelectedInstOperands,
     /*  758363 */     // GIR_Coverage, 24245,
     /*  758363 */     GIR_EraseRootFromParent_Done,
     /*  758364 */   // Label 11902: @758364
     /*  758364 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(758439), // Rule ID 24248 //
     /*  758369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  758372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  758408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758415 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  758415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  758418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758437 */     GIR_RootConstrainSelectedInstOperands,
     /*  758438 */     // GIR_Coverage, 24248,
     /*  758438 */     GIR_EraseRootFromParent_Done,
     /*  758439 */   // Label 11903: @758439
     /*  758439 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(758514), // Rule ID 24249 //
     /*  758444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  758447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  758483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10964:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  758490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  758493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758512 */     GIR_RootConstrainSelectedInstOperands,
     /*  758513 */     // GIR_Coverage, 24249,
     /*  758513 */     GIR_EraseRootFromParent_Done,
     /*  758514 */   // Label 11904: @758514
     /*  758514 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(758589), // Rule ID 24252 //
     /*  758519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  758522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  758568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758587 */     GIR_RootConstrainSelectedInstOperands,
     /*  758588 */     // GIR_Coverage, 24252,
     /*  758588 */     GIR_EraseRootFromParent_Done,
     /*  758589 */   // Label 11905: @758589
     /*  758589 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(758664), // Rule ID 24253 //
     /*  758594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  758597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758640 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  758643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758662 */     GIR_RootConstrainSelectedInstOperands,
     /*  758663 */     // GIR_Coverage, 24253,
     /*  758663 */     GIR_EraseRootFromParent_Done,
     /*  758664 */   // Label 11906: @758664
     /*  758664 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(758739), // Rule ID 24256 //
     /*  758669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  758672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758715 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  758718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758737 */     GIR_RootConstrainSelectedInstOperands,
     /*  758738 */     // GIR_Coverage, 24256,
     /*  758738 */     GIR_EraseRootFromParent_Done,
     /*  758739 */   // Label 11907: @758739
     /*  758739 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(758814), // Rule ID 24257 //
     /*  758744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  758747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758790 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  758793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758812 */     GIR_RootConstrainSelectedInstOperands,
     /*  758813 */     // GIR_Coverage, 24257,
     /*  758813 */     GIR_EraseRootFromParent_Done,
     /*  758814 */   // Label 11908: @758814
     /*  758814 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(758889), // Rule ID 24260 //
     /*  758819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  758822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758865 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  758868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758887 */     GIR_RootConstrainSelectedInstOperands,
     /*  758888 */     // GIR_Coverage, 24260,
     /*  758888 */     GIR_EraseRootFromParent_Done,
     /*  758889 */   // Label 11909: @758889
     /*  758889 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(758964), // Rule ID 24261 //
     /*  758894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  758897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  758914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  758933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758940 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  758943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758962 */     GIR_RootConstrainSelectedInstOperands,
     /*  758963 */     // GIR_Coverage, 24261,
     /*  758963 */     GIR_EraseRootFromParent_Done,
     /*  758964 */   // Label 11910: @758964
     /*  758964 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(759039), // Rule ID 24264 //
     /*  758969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  758972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  758977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  759018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759037 */     GIR_RootConstrainSelectedInstOperands,
     /*  759038 */     // GIR_Coverage, 24264,
     /*  759038 */     GIR_EraseRootFromParent_Done,
     /*  759039 */   // Label 11911: @759039
     /*  759039 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(759114), // Rule ID 24265 //
     /*  759044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  759047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  759093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759112 */     GIR_RootConstrainSelectedInstOperands,
     /*  759113 */     // GIR_Coverage, 24265,
     /*  759113 */     GIR_EraseRootFromParent_Done,
     /*  759114 */   // Label 11912: @759114
     /*  759114 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(759189), // Rule ID 24268 //
     /*  759119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  759122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759165 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  759168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759187 */     GIR_RootConstrainSelectedInstOperands,
     /*  759188 */     // GIR_Coverage, 24268,
     /*  759188 */     GIR_EraseRootFromParent_Done,
     /*  759189 */   // Label 11913: @759189
     /*  759189 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(759264), // Rule ID 24269 //
     /*  759194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  759197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  759243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759262 */     GIR_RootConstrainSelectedInstOperands,
     /*  759263 */     // GIR_Coverage, 24269,
     /*  759263 */     GIR_EraseRootFromParent_Done,
     /*  759264 */   // Label 11914: @759264
     /*  759264 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(759339), // Rule ID 24272 //
     /*  759269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  759272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759315 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  759318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759337 */     GIR_RootConstrainSelectedInstOperands,
     /*  759338 */     // GIR_Coverage, 24272,
     /*  759338 */     GIR_EraseRootFromParent_Done,
     /*  759339 */   // Label 11915: @759339
     /*  759339 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(759414), // Rule ID 24273 //
     /*  759344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  759347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  759383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  759393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759412 */     GIR_RootConstrainSelectedInstOperands,
     /*  759413 */     // GIR_Coverage, 24273,
     /*  759413 */     GIR_EraseRootFromParent_Done,
     /*  759414 */   // Label 11916: @759414
     /*  759414 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(759489), // Rule ID 24276 //
     /*  759419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  759422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  759468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759487 */     GIR_RootConstrainSelectedInstOperands,
     /*  759488 */     // GIR_Coverage, 24276,
     /*  759488 */     GIR_EraseRootFromParent_Done,
     /*  759489 */   // Label 11917: @759489
     /*  759489 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(759564), // Rule ID 24277 //
     /*  759494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  759497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759540 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10964:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  759543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759562 */     GIR_RootConstrainSelectedInstOperands,
     /*  759563 */     // GIR_Coverage, 24277,
     /*  759563 */     GIR_EraseRootFromParent_Done,
     /*  759564 */   // Label 11918: @759564
     /*  759564 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(759639), // Rule ID 24280 //
     /*  759569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  759572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759615 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  759618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759637 */     GIR_RootConstrainSelectedInstOperands,
     /*  759638 */     // GIR_Coverage, 24280,
     /*  759638 */     GIR_EraseRootFromParent_Done,
     /*  759639 */   // Label 11919: @759639
     /*  759639 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(759714), // Rule ID 24281 //
     /*  759644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  759647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10964:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  759693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759712 */     GIR_RootConstrainSelectedInstOperands,
     /*  759713 */     // GIR_Coverage, 24281,
     /*  759713 */     GIR_EraseRootFromParent_Done,
     /*  759714 */   // Label 11920: @759714
     /*  759714 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(759789), // Rule ID 24284 //
     /*  759719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  759722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759765 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  759768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759787 */     GIR_RootConstrainSelectedInstOperands,
     /*  759788 */     // GIR_Coverage, 24284,
     /*  759788 */     GIR_EraseRootFromParent_Done,
     /*  759789 */   // Label 11921: @759789
     /*  759789 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(759864), // Rule ID 24285 //
     /*  759794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  759797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  759802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  759833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10964:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  759843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759862 */     GIR_RootConstrainSelectedInstOperands,
     /*  759863 */     // GIR_Coverage, 24285,
     /*  759863 */     GIR_EraseRootFromParent_Done,
     /*  759864 */   // Label 11922: @759864
     /*  759864 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(759939), // Rule ID 24288 //
     /*  759869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  759872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  759877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  759880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  759883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  759886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  759889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  759908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  759918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759937 */     GIR_RootConstrainSelectedInstOperands,
     /*  759938 */     // GIR_Coverage, 24288,
     /*  759938 */     GIR_EraseRootFromParent_Done,
     /*  759939 */   // Label 11923: @759939
     /*  759939 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(760014), // Rule ID 24289 //
     /*  759944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  759947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  759952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  759955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  759958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  759961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  759964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  759983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759990 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  759993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760012 */     GIR_RootConstrainSelectedInstOperands,
     /*  760013 */     // GIR_Coverage, 24289,
     /*  760013 */     GIR_EraseRootFromParent_Done,
     /*  760014 */   // Label 11924: @760014
     /*  760014 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(760089), // Rule ID 24292 //
     /*  760019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  760022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760065 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  760068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760087 */     GIR_RootConstrainSelectedInstOperands,
     /*  760088 */     // GIR_Coverage, 24292,
     /*  760088 */     GIR_EraseRootFromParent_Done,
     /*  760089 */   // Label 11925: @760089
     /*  760089 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(760164), // Rule ID 24293 //
     /*  760094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  760097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  760143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760162 */     GIR_RootConstrainSelectedInstOperands,
     /*  760163 */     // GIR_Coverage, 24293,
     /*  760163 */     GIR_EraseRootFromParent_Done,
     /*  760164 */   // Label 11926: @760164
     /*  760164 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(760239), // Rule ID 24296 //
     /*  760169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  760172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  760208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760215 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  760218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760237 */     GIR_RootConstrainSelectedInstOperands,
     /*  760238 */     // GIR_Coverage, 24296,
     /*  760238 */     GIR_EraseRootFromParent_Done,
     /*  760239 */   // Label 11927: @760239
     /*  760239 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(760314), // Rule ID 24297 //
     /*  760244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  760247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  760283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  760293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760312 */     GIR_RootConstrainSelectedInstOperands,
     /*  760313 */     // GIR_Coverage, 24297,
     /*  760313 */     GIR_EraseRootFromParent_Done,
     /*  760314 */   // Label 11928: @760314
     /*  760314 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(760389), // Rule ID 24300 //
     /*  760319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  760322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760365 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  760368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760387 */     GIR_RootConstrainSelectedInstOperands,
     /*  760388 */     // GIR_Coverage, 24300,
     /*  760388 */     GIR_EraseRootFromParent_Done,
     /*  760389 */   // Label 11929: @760389
     /*  760389 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(760464), // Rule ID 24301 //
     /*  760394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  760397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10962:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  760443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760462 */     GIR_RootConstrainSelectedInstOperands,
     /*  760463 */     // GIR_Coverage, 24301,
     /*  760463 */     GIR_EraseRootFromParent_Done,
     /*  760464 */   // Label 11930: @760464
     /*  760464 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(760539), // Rule ID 24304 //
     /*  760469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  760472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  760480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  760483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  760486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  760508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760515 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10962:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  760518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760537 */     GIR_RootConstrainSelectedInstOperands,
     /*  760538 */     // GIR_Coverage, 24304,
     /*  760538 */     GIR_EraseRootFromParent_Done,
     /*  760539 */   // Label 11931: @760539
     /*  760539 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(760614), // Rule ID 24305 //
     /*  760544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  760547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  760555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  760558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  760561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  760583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760590 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10962:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  760593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760612 */     GIR_RootConstrainSelectedInstOperands,
     /*  760613 */     // GIR_Coverage, 24305,
     /*  760613 */     GIR_EraseRootFromParent_Done,
     /*  760614 */   // Label 11932: @760614
     /*  760614 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(760689), // Rule ID 24308 //
     /*  760619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  760622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  760630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  760633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  760636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  760658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760665 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  760665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  760668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760687 */     GIR_RootConstrainSelectedInstOperands,
     /*  760688 */     // GIR_Coverage, 24308,
     /*  760688 */     GIR_EraseRootFromParent_Done,
     /*  760689 */   // Label 11933: @760689
     /*  760689 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(760764), // Rule ID 24309 //
     /*  760694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  760697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  760705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  760708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  760711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  760733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10962:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  760743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760762 */     GIR_RootConstrainSelectedInstOperands,
     /*  760763 */     // GIR_Coverage, 24309,
     /*  760763 */     GIR_EraseRootFromParent_Done,
     /*  760764 */   // Label 11934: @760764
     /*  760764 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(760839), // Rule ID 24312 //
     /*  760769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  760772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  760780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  760783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  760786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760815 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  760818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760837 */     GIR_RootConstrainSelectedInstOperands,
     /*  760838 */     // GIR_Coverage, 24312,
     /*  760838 */     GIR_EraseRootFromParent_Done,
     /*  760839 */   // Label 11935: @760839
     /*  760839 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(760914), // Rule ID 24313 //
     /*  760844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  760847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  760855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  760858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  760861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  760893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760912 */     GIR_RootConstrainSelectedInstOperands,
     /*  760913 */     // GIR_Coverage, 24313,
     /*  760913 */     GIR_EraseRootFromParent_Done,
     /*  760914 */   // Label 11936: @760914
     /*  760914 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(760989), // Rule ID 24316 //
     /*  760919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  760922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  760927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  760930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  760933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  760936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  760939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  760958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760965 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  760968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760987 */     GIR_RootConstrainSelectedInstOperands,
     /*  760988 */     // GIR_Coverage, 24316,
     /*  760988 */     GIR_EraseRootFromParent_Done,
     /*  760989 */   // Label 11937: @760989
     /*  760989 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(761064), // Rule ID 24317 //
     /*  760994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  760997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  761005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  761008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  761011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  761014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  761033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  761043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761062 */     GIR_RootConstrainSelectedInstOperands,
     /*  761063 */     // GIR_Coverage, 24317,
     /*  761063 */     GIR_EraseRootFromParent_Done,
     /*  761064 */   // Label 11938: @761064
     /*  761064 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(761139), // Rule ID 24320 //
     /*  761069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  761072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  761080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  761083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  761086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  761089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  761108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761115 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  761118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761137 */     GIR_RootConstrainSelectedInstOperands,
     /*  761138 */     // GIR_Coverage, 24320,
     /*  761138 */     GIR_EraseRootFromParent_Done,
     /*  761139 */   // Label 11939: @761139
     /*  761139 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(761214), // Rule ID 24321 //
     /*  761144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  761147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  761155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  761158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  761161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  761164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  761183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761190 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  761193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761212 */     GIR_RootConstrainSelectedInstOperands,
     /*  761213 */     // GIR_Coverage, 24321,
     /*  761213 */     GIR_EraseRootFromParent_Done,
     /*  761214 */   // Label 11940: @761214
     /*  761214 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(761289), // Rule ID 24324 //
     /*  761219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  761222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  761230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  761233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  761236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761265 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  761268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761287 */     GIR_RootConstrainSelectedInstOperands,
     /*  761288 */     // GIR_Coverage, 24324,
     /*  761288 */     GIR_EraseRootFromParent_Done,
     /*  761289 */   // Label 11941: @761289
     /*  761289 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(761364), // Rule ID 24325 //
     /*  761294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  761297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  761305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  761308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  761311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  761343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761362 */     GIR_RootConstrainSelectedInstOperands,
     /*  761363 */     // GIR_Coverage, 24325,
     /*  761363 */     GIR_EraseRootFromParent_Done,
     /*  761364 */   // Label 11942: @761364
     /*  761364 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(761439), // Rule ID 24328 //
     /*  761369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  761372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  761380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  761383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  761386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761415 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  761418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761437 */     GIR_RootConstrainSelectedInstOperands,
     /*  761438 */     // GIR_Coverage, 24328,
     /*  761438 */     GIR_EraseRootFromParent_Done,
     /*  761439 */   // Label 11943: @761439
     /*  761439 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(761514), // Rule ID 24329 //
     /*  761444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  761447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  761455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  761458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  761461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761490 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  761493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761512 */     GIR_RootConstrainSelectedInstOperands,
     /*  761513 */     // GIR_Coverage, 24329,
     /*  761513 */     GIR_EraseRootFromParent_Done,
     /*  761514 */   // Label 11944: @761514
     /*  761514 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(761589), // Rule ID 24332 //
     /*  761519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  761522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  761530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  761533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  761536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761565 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  761568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761587 */     GIR_RootConstrainSelectedInstOperands,
     /*  761588 */     // GIR_Coverage, 24332,
     /*  761588 */     GIR_EraseRootFromParent_Done,
     /*  761589 */   // Label 11945: @761589
     /*  761589 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(761664), // Rule ID 24333 //
     /*  761594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  761597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  761605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  761608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  761611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  761633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  761643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761662 */     GIR_RootConstrainSelectedInstOperands,
     /*  761663 */     // GIR_Coverage, 24333,
     /*  761663 */     GIR_EraseRootFromParent_Done,
     /*  761664 */   // Label 11946: @761664
     /*  761664 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(761739), // Rule ID 24336 //
     /*  761669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  761672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  761680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  761683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  761686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  761708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  761718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761737 */     GIR_RootConstrainSelectedInstOperands,
     /*  761738 */     // GIR_Coverage, 24336,
     /*  761738 */     GIR_EraseRootFromParent_Done,
     /*  761739 */   // Label 11947: @761739
     /*  761739 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(761814), // Rule ID 24337 //
     /*  761744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  761747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  761755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  761758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  761761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  761783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10962:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  761793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761812 */     GIR_RootConstrainSelectedInstOperands,
     /*  761813 */     // GIR_Coverage, 24337,
     /*  761813 */     GIR_EraseRootFromParent_Done,
     /*  761814 */   // Label 11948: @761814
     /*  761814 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(761889), // Rule ID 24340 //
     /*  761819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  761822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  761830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  761833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  761836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  761858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  761868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761887 */     GIR_RootConstrainSelectedInstOperands,
     /*  761888 */     // GIR_Coverage, 24340,
     /*  761888 */     GIR_EraseRootFromParent_Done,
     /*  761889 */   // Label 11949: @761889
     /*  761889 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(761964), // Rule ID 24341 //
     /*  761894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  761897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  761905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  761908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  761911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  761933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10962:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  761943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761962 */     GIR_RootConstrainSelectedInstOperands,
     /*  761963 */     // GIR_Coverage, 24341,
     /*  761963 */     GIR_EraseRootFromParent_Done,
     /*  761964 */   // Label 11950: @761964
     /*  761964 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(762039), // Rule ID 24344 //
     /*  761969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  761972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  761977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  761980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  761983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  761986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  762008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762015 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  762018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762037 */     GIR_RootConstrainSelectedInstOperands,
     /*  762038 */     // GIR_Coverage, 24344,
     /*  762038 */     GIR_EraseRootFromParent_Done,
     /*  762039 */   // Label 11951: @762039
     /*  762039 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(762114), // Rule ID 24345 //
     /*  762044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  762047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  762052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  762055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  762058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  762061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  762083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10962:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  762093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762112 */     GIR_RootConstrainSelectedInstOperands,
     /*  762113 */     // GIR_Coverage, 24345,
     /*  762113 */     GIR_EraseRootFromParent_Done,
     /*  762114 */   // Label 11952: @762114
     /*  762114 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(762189), // Rule ID 24348 //
     /*  762119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  762130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  762133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  762136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  762139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762165 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  762168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762187 */     GIR_RootConstrainSelectedInstOperands,
     /*  762188 */     // GIR_Coverage, 24348,
     /*  762188 */     GIR_EraseRootFromParent_Done,
     /*  762189 */   // Label 11953: @762189
     /*  762189 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(762264), // Rule ID 24349 //
     /*  762194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  762205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  762208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  762211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  762214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  762243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762262 */     GIR_RootConstrainSelectedInstOperands,
     /*  762263 */     // GIR_Coverage, 24349,
     /*  762263 */     GIR_EraseRootFromParent_Done,
     /*  762264 */   // Label 11954: @762264
     /*  762264 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(762339), // Rule ID 24352 //
     /*  762269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  762280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  762283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  762286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  762289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  762318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762337 */     GIR_RootConstrainSelectedInstOperands,
     /*  762338 */     // GIR_Coverage, 24352,
     /*  762338 */     GIR_EraseRootFromParent_Done,
     /*  762339 */   // Label 11955: @762339
     /*  762339 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(762414), // Rule ID 24353 //
     /*  762344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  762355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  762358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  762361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  762364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  762393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762412 */     GIR_RootConstrainSelectedInstOperands,
     /*  762413 */     // GIR_Coverage, 24353,
     /*  762413 */     GIR_EraseRootFromParent_Done,
     /*  762414 */   // Label 11956: @762414
     /*  762414 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(762489), // Rule ID 24356 //
     /*  762419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  762430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  762433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  762436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  762439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762465 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  762468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762487 */     GIR_RootConstrainSelectedInstOperands,
     /*  762488 */     // GIR_Coverage, 24356,
     /*  762488 */     GIR_EraseRootFromParent_Done,
     /*  762489 */   // Label 11957: @762489
     /*  762489 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(762564), // Rule ID 24357 //
     /*  762494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  762505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  762508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  762511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  762514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  762543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762562 */     GIR_RootConstrainSelectedInstOperands,
     /*  762563 */     // GIR_Coverage, 24357,
     /*  762563 */     GIR_EraseRootFromParent_Done,
     /*  762564 */   // Label 11958: @762564
     /*  762564 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(762639), // Rule ID 24360 //
     /*  762569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  762580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  762583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  762586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  762589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762615 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  762618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762637 */     GIR_RootConstrainSelectedInstOperands,
     /*  762638 */     // GIR_Coverage, 24360,
     /*  762638 */     GIR_EraseRootFromParent_Done,
     /*  762639 */   // Label 11959: @762639
     /*  762639 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(762714), // Rule ID 24361 //
     /*  762644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  762655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  762658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  762661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  762664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  762693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762712 */     GIR_RootConstrainSelectedInstOperands,
     /*  762713 */     // GIR_Coverage, 24361,
     /*  762713 */     GIR_EraseRootFromParent_Done,
     /*  762714 */   // Label 11960: @762714
     /*  762714 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(762789), // Rule ID 24364 //
     /*  762719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  762730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  762733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  762736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  762739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762765 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  762768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762787 */     GIR_RootConstrainSelectedInstOperands,
     /*  762788 */     // GIR_Coverage, 24364,
     /*  762788 */     GIR_EraseRootFromParent_Done,
     /*  762789 */   // Label 11961: @762789
     /*  762789 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(762864), // Rule ID 24365 //
     /*  762794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  762805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  762808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  762811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  762814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  762843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762862 */     GIR_RootConstrainSelectedInstOperands,
     /*  762863 */     // GIR_Coverage, 24365,
     /*  762863 */     GIR_EraseRootFromParent_Done,
     /*  762864 */   // Label 11962: @762864
     /*  762864 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(762939), // Rule ID 24368 //
     /*  762869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  762880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  762883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  762886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  762889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  762918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762937 */     GIR_RootConstrainSelectedInstOperands,
     /*  762938 */     // GIR_Coverage, 24368,
     /*  762938 */     GIR_EraseRootFromParent_Done,
     /*  762939 */   // Label 11963: @762939
     /*  762939 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(763014), // Rule ID 24369 //
     /*  762944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  762952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  762955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  762958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  762961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  762964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  762993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763012 */     GIR_RootConstrainSelectedInstOperands,
     /*  763013 */     // GIR_Coverage, 24369,
     /*  763013 */     GIR_EraseRootFromParent_Done,
     /*  763014 */   // Label 11964: @763014
     /*  763014 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(763089), // Rule ID 24372 //
     /*  763019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  763030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  763033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  763036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  763039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  763068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763087 */     GIR_RootConstrainSelectedInstOperands,
     /*  763088 */     // GIR_Coverage, 24372,
     /*  763088 */     GIR_EraseRootFromParent_Done,
     /*  763089 */   // Label 11965: @763089
     /*  763089 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(763164), // Rule ID 24373 //
     /*  763094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  763105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  763108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  763111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  763114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  763143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763162 */     GIR_RootConstrainSelectedInstOperands,
     /*  763163 */     // GIR_Coverage, 24373,
     /*  763163 */     GIR_EraseRootFromParent_Done,
     /*  763164 */   // Label 11966: @763164
     /*  763164 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(763239), // Rule ID 24376 //
     /*  763169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  763180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  763183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  763186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  763189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  763218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763237 */     GIR_RootConstrainSelectedInstOperands,
     /*  763238 */     // GIR_Coverage, 24376,
     /*  763238 */     GIR_EraseRootFromParent_Done,
     /*  763239 */   // Label 11967: @763239
     /*  763239 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(763314), // Rule ID 24377 //
     /*  763244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  763255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  763258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  763261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  763264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  763293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763312 */     GIR_RootConstrainSelectedInstOperands,
     /*  763313 */     // GIR_Coverage, 24377,
     /*  763313 */     GIR_EraseRootFromParent_Done,
     /*  763314 */   // Label 11968: @763314
     /*  763314 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(763389), // Rule ID 24380 //
     /*  763319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  763330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  763333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  763336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  763339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  763368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763387 */     GIR_RootConstrainSelectedInstOperands,
     /*  763388 */     // GIR_Coverage, 24380,
     /*  763388 */     GIR_EraseRootFromParent_Done,
     /*  763389 */   // Label 11969: @763389
     /*  763389 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(763464), // Rule ID 24381 //
     /*  763394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  763405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  763408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  763411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  763414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  763443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763462 */     GIR_RootConstrainSelectedInstOperands,
     /*  763463 */     // GIR_Coverage, 24381,
     /*  763463 */     GIR_EraseRootFromParent_Done,
     /*  763464 */   // Label 11970: @763464
     /*  763464 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(763539), // Rule ID 24384 //
     /*  763469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  763480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  763483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  763486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  763489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  763518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763537 */     GIR_RootConstrainSelectedInstOperands,
     /*  763538 */     // GIR_Coverage, 24384,
     /*  763538 */     GIR_EraseRootFromParent_Done,
     /*  763539 */   // Label 11971: @763539
     /*  763539 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(763614), // Rule ID 24385 //
     /*  763544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  763555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  763558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  763561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  763564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  763593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763612 */     GIR_RootConstrainSelectedInstOperands,
     /*  763613 */     // GIR_Coverage, 24385,
     /*  763613 */     GIR_EraseRootFromParent_Done,
     /*  763614 */   // Label 11972: @763614
     /*  763614 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(763689), // Rule ID 24388 //
     /*  763619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  763630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  763633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  763636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  763639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  763668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763687 */     GIR_RootConstrainSelectedInstOperands,
     /*  763688 */     // GIR_Coverage, 24388,
     /*  763688 */     GIR_EraseRootFromParent_Done,
     /*  763689 */   // Label 11973: @763689
     /*  763689 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(763764), // Rule ID 24389 //
     /*  763694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  763705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  763708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  763711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  763714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  763743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763762 */     GIR_RootConstrainSelectedInstOperands,
     /*  763763 */     // GIR_Coverage, 24389,
     /*  763763 */     GIR_EraseRootFromParent_Done,
     /*  763764 */   // Label 11974: @763764
     /*  763764 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(763839), // Rule ID 24392 //
     /*  763769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  763780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  763783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  763786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  763789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763815 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  763818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763837 */     GIR_RootConstrainSelectedInstOperands,
     /*  763838 */     // GIR_Coverage, 24392,
     /*  763838 */     GIR_EraseRootFromParent_Done,
     /*  763839 */   // Label 11975: @763839
     /*  763839 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(763914), // Rule ID 24393 //
     /*  763844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  763855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  763858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  763861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  763864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763890 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  763893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763912 */     GIR_RootConstrainSelectedInstOperands,
     /*  763913 */     // GIR_Coverage, 24393,
     /*  763913 */     GIR_EraseRootFromParent_Done,
     /*  763914 */   // Label 11976: @763914
     /*  763914 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(763989), // Rule ID 24396 //
     /*  763919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  763927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  763930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  763933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  763936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  763939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763965 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  763968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763987 */     GIR_RootConstrainSelectedInstOperands,
     /*  763988 */     // GIR_Coverage, 24396,
     /*  763988 */     GIR_EraseRootFromParent_Done,
     /*  763989 */   // Label 11977: @763989
     /*  763989 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(764064), // Rule ID 24397 //
     /*  763994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  764005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  764008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  764011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  764014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  764043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764062 */     GIR_RootConstrainSelectedInstOperands,
     /*  764063 */     // GIR_Coverage, 24397,
     /*  764063 */     GIR_EraseRootFromParent_Done,
     /*  764064 */   // Label 11978: @764064
     /*  764064 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(764139), // Rule ID 24400 //
     /*  764069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  764080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  764083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  764086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  764089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  764118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764137 */     GIR_RootConstrainSelectedInstOperands,
     /*  764138 */     // GIR_Coverage, 24400,
     /*  764138 */     GIR_EraseRootFromParent_Done,
     /*  764139 */   // Label 11979: @764139
     /*  764139 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(764214), // Rule ID 24401 //
     /*  764144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  764155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  764158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  764161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  764164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  764193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764212 */     GIR_RootConstrainSelectedInstOperands,
     /*  764213 */     // GIR_Coverage, 24401,
     /*  764213 */     GIR_EraseRootFromParent_Done,
     /*  764214 */   // Label 11980: @764214
     /*  764214 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(764289), // Rule ID 24404 //
     /*  764219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  764230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  764233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  764236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  764239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  764268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764287 */     GIR_RootConstrainSelectedInstOperands,
     /*  764288 */     // GIR_Coverage, 24404,
     /*  764288 */     GIR_EraseRootFromParent_Done,
     /*  764289 */   // Label 11981: @764289
     /*  764289 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(764364), // Rule ID 24405 //
     /*  764294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  764305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  764308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  764311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  764314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  764343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764362 */     GIR_RootConstrainSelectedInstOperands,
     /*  764363 */     // GIR_Coverage, 24405,
     /*  764363 */     GIR_EraseRootFromParent_Done,
     /*  764364 */   // Label 11982: @764364
     /*  764364 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(764439), // Rule ID 24408 //
     /*  764369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  764380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  764383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  764386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  764389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764415 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  764418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764437 */     GIR_RootConstrainSelectedInstOperands,
     /*  764438 */     // GIR_Coverage, 24408,
     /*  764438 */     GIR_EraseRootFromParent_Done,
     /*  764439 */   // Label 11983: @764439
     /*  764439 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(764514), // Rule ID 24409 //
     /*  764444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  764455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  764458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  764461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  764464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  764493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764512 */     GIR_RootConstrainSelectedInstOperands,
     /*  764513 */     // GIR_Coverage, 24409,
     /*  764513 */     GIR_EraseRootFromParent_Done,
     /*  764514 */   // Label 11984: @764514
     /*  764514 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(764589), // Rule ID 24412 //
     /*  764519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  764530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  764533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  764536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  764539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  764568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764587 */     GIR_RootConstrainSelectedInstOperands,
     /*  764588 */     // GIR_Coverage, 24412,
     /*  764588 */     GIR_EraseRootFromParent_Done,
     /*  764589 */   // Label 11985: @764589
     /*  764589 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(764664), // Rule ID 24413 //
     /*  764594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  764605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  764608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  764611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  764614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  764643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764662 */     GIR_RootConstrainSelectedInstOperands,
     /*  764663 */     // GIR_Coverage, 24413,
     /*  764663 */     GIR_EraseRootFromParent_Done,
     /*  764664 */   // Label 11986: @764664
     /*  764664 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(764739), // Rule ID 24416 //
     /*  764669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  764680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  764683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  764686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  764689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764715 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  764718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764737 */     GIR_RootConstrainSelectedInstOperands,
     /*  764738 */     // GIR_Coverage, 24416,
     /*  764738 */     GIR_EraseRootFromParent_Done,
     /*  764739 */   // Label 11987: @764739
     /*  764739 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(764814), // Rule ID 24417 //
     /*  764744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  764755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  764758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  764761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  764764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  764793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764812 */     GIR_RootConstrainSelectedInstOperands,
     /*  764813 */     // GIR_Coverage, 24417,
     /*  764813 */     GIR_EraseRootFromParent_Done,
     /*  764814 */   // Label 11988: @764814
     /*  764814 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(764889), // Rule ID 24420 //
     /*  764819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  764830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  764833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  764836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  764839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  764868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764887 */     GIR_RootConstrainSelectedInstOperands,
     /*  764888 */     // GIR_Coverage, 24420,
     /*  764888 */     GIR_EraseRootFromParent_Done,
     /*  764889 */   // Label 11989: @764889
     /*  764889 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(764964), // Rule ID 24421 //
     /*  764894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  764905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  764908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  764911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  764914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  764943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764962 */     GIR_RootConstrainSelectedInstOperands,
     /*  764963 */     // GIR_Coverage, 24421,
     /*  764963 */     GIR_EraseRootFromParent_Done,
     /*  764964 */   // Label 11990: @764964
     /*  764964 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(765039), // Rule ID 24424 //
     /*  764969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  764977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  764980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  764983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  764986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  764989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  765018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765037 */     GIR_RootConstrainSelectedInstOperands,
     /*  765038 */     // GIR_Coverage, 24424,
     /*  765038 */     GIR_EraseRootFromParent_Done,
     /*  765039 */   // Label 11991: @765039
     /*  765039 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(765114), // Rule ID 24425 //
     /*  765044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  765052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  765055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  765058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  765061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  765064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  765093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765112 */     GIR_RootConstrainSelectedInstOperands,
     /*  765113 */     // GIR_Coverage, 24425,
     /*  765113 */     GIR_EraseRootFromParent_Done,
     /*  765114 */   // Label 11992: @765114
     /*  765114 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(765189), // Rule ID 24428 //
     /*  765119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  765127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  765130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  765133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  765136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  765139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765165 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  765168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765187 */     GIR_RootConstrainSelectedInstOperands,
     /*  765188 */     // GIR_Coverage, 24428,
     /*  765188 */     GIR_EraseRootFromParent_Done,
     /*  765189 */   // Label 11993: @765189
     /*  765189 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(765264), // Rule ID 24429 //
     /*  765194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  765202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  765205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  765208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  765211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  765214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765240 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  765243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765262 */     GIR_RootConstrainSelectedInstOperands,
     /*  765263 */     // GIR_Coverage, 24429,
     /*  765263 */     GIR_EraseRootFromParent_Done,
     /*  765264 */   // Label 11994: @765264
     /*  765264 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(765339), // Rule ID 24432 //
     /*  765269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  765277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  765280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  765283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  765286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  765289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  765318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765337 */     GIR_RootConstrainSelectedInstOperands,
     /*  765338 */     // GIR_Coverage, 24432,
     /*  765338 */     GIR_EraseRootFromParent_Done,
     /*  765339 */   // Label 11995: @765339
     /*  765339 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(765414), // Rule ID 24433 //
     /*  765344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  765352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  765355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  765358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  765361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  765364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  765393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765412 */     GIR_RootConstrainSelectedInstOperands,
     /*  765413 */     // GIR_Coverage, 24433,
     /*  765413 */     GIR_EraseRootFromParent_Done,
     /*  765414 */   // Label 11996: @765414
     /*  765414 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(765489), // Rule ID 24436 //
     /*  765419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  765430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  765433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  765436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765465 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  765468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765487 */     GIR_RootConstrainSelectedInstOperands,
     /*  765488 */     // GIR_Coverage, 24436,
     /*  765488 */     GIR_EraseRootFromParent_Done,
     /*  765489 */   // Label 11997: @765489
     /*  765489 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(765564), // Rule ID 24437 //
     /*  765494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  765505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  765508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  765511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  765543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765562 */     GIR_RootConstrainSelectedInstOperands,
     /*  765563 */     // GIR_Coverage, 24437,
     /*  765563 */     GIR_EraseRootFromParent_Done,
     /*  765564 */   // Label 11998: @765564
     /*  765564 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(765639), // Rule ID 24440 //
     /*  765569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  765580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  765583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  765586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765615 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  765618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765637 */     GIR_RootConstrainSelectedInstOperands,
     /*  765638 */     // GIR_Coverage, 24440,
     /*  765638 */     GIR_EraseRootFromParent_Done,
     /*  765639 */   // Label 11999: @765639
     /*  765639 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(765714), // Rule ID 24441 //
     /*  765644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  765655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  765658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  765661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  765693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765712 */     GIR_RootConstrainSelectedInstOperands,
     /*  765713 */     // GIR_Coverage, 24441,
     /*  765713 */     GIR_EraseRootFromParent_Done,
     /*  765714 */   // Label 12000: @765714
     /*  765714 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(765789), // Rule ID 24444 //
     /*  765719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  765730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  765733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  765736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765765 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  765768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765787 */     GIR_RootConstrainSelectedInstOperands,
     /*  765788 */     // GIR_Coverage, 24444,
     /*  765788 */     GIR_EraseRootFromParent_Done,
     /*  765789 */   // Label 12001: @765789
     /*  765789 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(765864), // Rule ID 24445 //
     /*  765794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  765805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  765808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  765811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  765843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765862 */     GIR_RootConstrainSelectedInstOperands,
     /*  765863 */     // GIR_Coverage, 24445,
     /*  765863 */     GIR_EraseRootFromParent_Done,
     /*  765864 */   // Label 12002: @765864
     /*  765864 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(765939), // Rule ID 24448 //
     /*  765869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  765880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  765883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  765886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765915 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  765918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765937 */     GIR_RootConstrainSelectedInstOperands,
     /*  765938 */     // GIR_Coverage, 24448,
     /*  765938 */     GIR_EraseRootFromParent_Done,
     /*  765939 */   // Label 12003: @765939
     /*  765939 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(766014), // Rule ID 24449 //
     /*  765944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  765952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  765955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  765958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  765961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  765993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766012 */     GIR_RootConstrainSelectedInstOperands,
     /*  766013 */     // GIR_Coverage, 24449,
     /*  766013 */     GIR_EraseRootFromParent_Done,
     /*  766014 */   // Label 12004: @766014
     /*  766014 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(766089), // Rule ID 24452 //
     /*  766019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  766030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  766033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  766036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766065 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  766068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766087 */     GIR_RootConstrainSelectedInstOperands,
     /*  766088 */     // GIR_Coverage, 24452,
     /*  766088 */     GIR_EraseRootFromParent_Done,
     /*  766089 */   // Label 12005: @766089
     /*  766089 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(766164), // Rule ID 24453 //
     /*  766094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  766105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  766108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  766111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  766143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766162 */     GIR_RootConstrainSelectedInstOperands,
     /*  766163 */     // GIR_Coverage, 24453,
     /*  766163 */     GIR_EraseRootFromParent_Done,
     /*  766164 */   // Label 12006: @766164
     /*  766164 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(766239), // Rule ID 24456 //
     /*  766169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  766180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  766183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  766186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  766218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766237 */     GIR_RootConstrainSelectedInstOperands,
     /*  766238 */     // GIR_Coverage, 24456,
     /*  766238 */     GIR_EraseRootFromParent_Done,
     /*  766239 */   // Label 12007: @766239
     /*  766239 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(766314), // Rule ID 24457 //
     /*  766244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  766255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  766258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  766261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  766293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766312 */     GIR_RootConstrainSelectedInstOperands,
     /*  766313 */     // GIR_Coverage, 24457,
     /*  766313 */     GIR_EraseRootFromParent_Done,
     /*  766314 */   // Label 12008: @766314
     /*  766314 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(766389), // Rule ID 24460 //
     /*  766319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  766330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  766333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  766336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766387 */     GIR_RootConstrainSelectedInstOperands,
     /*  766388 */     // GIR_Coverage, 24460,
     /*  766388 */     GIR_EraseRootFromParent_Done,
     /*  766389 */   // Label 12009: @766389
     /*  766389 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(766464), // Rule ID 24461 //
     /*  766394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  766405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  766408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  766411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766462 */     GIR_RootConstrainSelectedInstOperands,
     /*  766463 */     // GIR_Coverage, 24461,
     /*  766463 */     GIR_EraseRootFromParent_Done,
     /*  766464 */   // Label 12010: @766464
     /*  766464 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(766539), // Rule ID 24464 //
     /*  766469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  766480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  766483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  766486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766537 */     GIR_RootConstrainSelectedInstOperands,
     /*  766538 */     // GIR_Coverage, 24464,
     /*  766538 */     GIR_EraseRootFromParent_Done,
     /*  766539 */   // Label 12011: @766539
     /*  766539 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(766614), // Rule ID 24465 //
     /*  766544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  766555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  766558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  766561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766612 */     GIR_RootConstrainSelectedInstOperands,
     /*  766613 */     // GIR_Coverage, 24465,
     /*  766613 */     GIR_EraseRootFromParent_Done,
     /*  766614 */   // Label 12012: @766614
     /*  766614 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(766689), // Rule ID 24468 //
     /*  766619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  766630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  766633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  766636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766687 */     GIR_RootConstrainSelectedInstOperands,
     /*  766688 */     // GIR_Coverage, 24468,
     /*  766688 */     GIR_EraseRootFromParent_Done,
     /*  766689 */   // Label 12013: @766689
     /*  766689 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(766764), // Rule ID 24469 //
     /*  766694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  766705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  766708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  766711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766762 */     GIR_RootConstrainSelectedInstOperands,
     /*  766763 */     // GIR_Coverage, 24469,
     /*  766763 */     GIR_EraseRootFromParent_Done,
     /*  766764 */   // Label 12014: @766764
     /*  766764 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(766839), // Rule ID 24472 //
     /*  766769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  766780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  766783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  766786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766815 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766837 */     GIR_RootConstrainSelectedInstOperands,
     /*  766838 */     // GIR_Coverage, 24472,
     /*  766838 */     GIR_EraseRootFromParent_Done,
     /*  766839 */   // Label 12015: @766839
     /*  766839 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(766914), // Rule ID 24473 //
     /*  766844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  766855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  766858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  766861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  766893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766912 */     GIR_RootConstrainSelectedInstOperands,
     /*  766913 */     // GIR_Coverage, 24473,
     /*  766913 */     GIR_EraseRootFromParent_Done,
     /*  766914 */   // Label 12016: @766914
     /*  766914 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(766989), // Rule ID 24476 //
     /*  766919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  766927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  766930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  766933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  766936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766965 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  766968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766987 */     GIR_RootConstrainSelectedInstOperands,
     /*  766988 */     // GIR_Coverage, 24476,
     /*  766988 */     GIR_EraseRootFromParent_Done,
     /*  766989 */   // Label 12017: @766989
     /*  766989 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(767064), // Rule ID 24477 //
     /*  766994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  767005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  767008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  767011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  767043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767062 */     GIR_RootConstrainSelectedInstOperands,
     /*  767063 */     // GIR_Coverage, 24477,
     /*  767063 */     GIR_EraseRootFromParent_Done,
     /*  767064 */   // Label 12018: @767064
     /*  767064 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(767139), // Rule ID 24480 //
     /*  767069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  767080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  767083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  767086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767115 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  767118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767137 */     GIR_RootConstrainSelectedInstOperands,
     /*  767138 */     // GIR_Coverage, 24480,
     /*  767138 */     GIR_EraseRootFromParent_Done,
     /*  767139 */   // Label 12019: @767139
     /*  767139 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(767214), // Rule ID 24481 //
     /*  767144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  767155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  767158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  767161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767190 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  767193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767212 */     GIR_RootConstrainSelectedInstOperands,
     /*  767213 */     // GIR_Coverage, 24481,
     /*  767213 */     GIR_EraseRootFromParent_Done,
     /*  767214 */   // Label 12020: @767214
     /*  767214 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(767289), // Rule ID 24484 //
     /*  767219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  767230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  767233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  767236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767265 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  767268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767287 */     GIR_RootConstrainSelectedInstOperands,
     /*  767288 */     // GIR_Coverage, 24484,
     /*  767288 */     GIR_EraseRootFromParent_Done,
     /*  767289 */   // Label 12021: @767289
     /*  767289 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(767364), // Rule ID 24485 //
     /*  767294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  767305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  767308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  767311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767340 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  767343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767362 */     GIR_RootConstrainSelectedInstOperands,
     /*  767363 */     // GIR_Coverage, 24485,
     /*  767363 */     GIR_EraseRootFromParent_Done,
     /*  767364 */   // Label 12022: @767364
     /*  767364 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(767439), // Rule ID 24488 //
     /*  767369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  767380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  767383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  767386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767415 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  767418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767437 */     GIR_RootConstrainSelectedInstOperands,
     /*  767438 */     // GIR_Coverage, 24488,
     /*  767438 */     GIR_EraseRootFromParent_Done,
     /*  767439 */   // Label 12023: @767439
     /*  767439 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(767514), // Rule ID 24489 //
     /*  767444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  767455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  767458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  767461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  767493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767512 */     GIR_RootConstrainSelectedInstOperands,
     /*  767513 */     // GIR_Coverage, 24489,
     /*  767513 */     GIR_EraseRootFromParent_Done,
     /*  767514 */   // Label 12024: @767514
     /*  767514 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(767589), // Rule ID 24492 //
     /*  767519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  767530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  767533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  767536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  767568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767587 */     GIR_RootConstrainSelectedInstOperands,
     /*  767588 */     // GIR_Coverage, 24492,
     /*  767588 */     GIR_EraseRootFromParent_Done,
     /*  767589 */   // Label 12025: @767589
     /*  767589 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(767664), // Rule ID 24493 //
     /*  767594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  767605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  767608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  767611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767640 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  767643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767662 */     GIR_RootConstrainSelectedInstOperands,
     /*  767663 */     // GIR_Coverage, 24493,
     /*  767663 */     GIR_EraseRootFromParent_Done,
     /*  767664 */   // Label 12026: @767664
     /*  767664 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(767739), // Rule ID 24496 //
     /*  767669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  767680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  767683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  767686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  767718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767737 */     GIR_RootConstrainSelectedInstOperands,
     /*  767738 */     // GIR_Coverage, 24496,
     /*  767738 */     GIR_EraseRootFromParent_Done,
     /*  767739 */   // Label 12027: @767739
     /*  767739 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(767814), // Rule ID 24497 //
     /*  767744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  767755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  767758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  767761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767790 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  767793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767812 */     GIR_RootConstrainSelectedInstOperands,
     /*  767813 */     // GIR_Coverage, 24497,
     /*  767813 */     GIR_EraseRootFromParent_Done,
     /*  767814 */   // Label 12028: @767814
     /*  767814 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(767889), // Rule ID 24500 //
     /*  767819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  767830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  767833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  767836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  767868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767887 */     GIR_RootConstrainSelectedInstOperands,
     /*  767888 */     // GIR_Coverage, 24500,
     /*  767888 */     GIR_EraseRootFromParent_Done,
     /*  767889 */   // Label 12029: @767889
     /*  767889 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(767964), // Rule ID 24501 //
     /*  767894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  767905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  767908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  767911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  767943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767962 */     GIR_RootConstrainSelectedInstOperands,
     /*  767963 */     // GIR_Coverage, 24501,
     /*  767963 */     GIR_EraseRootFromParent_Done,
     /*  767964 */   // Label 12030: @767964
     /*  767964 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(768039), // Rule ID 24504 //
     /*  767969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  767977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  767980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  767983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  767986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768015 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  768018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768037 */     GIR_RootConstrainSelectedInstOperands,
     /*  768038 */     // GIR_Coverage, 24504,
     /*  768038 */     GIR_EraseRootFromParent_Done,
     /*  768039 */   // Label 12031: @768039
     /*  768039 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(768114), // Rule ID 24505 //
     /*  768044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  768055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  768058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  768061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  768093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768112 */     GIR_RootConstrainSelectedInstOperands,
     /*  768113 */     // GIR_Coverage, 24505,
     /*  768113 */     GIR_EraseRootFromParent_Done,
     /*  768114 */   // Label 12032: @768114
     /*  768114 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(768189), // Rule ID 24508 //
     /*  768119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  768130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  768133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  768136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768165 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  768168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768187 */     GIR_RootConstrainSelectedInstOperands,
     /*  768188 */     // GIR_Coverage, 24508,
     /*  768188 */     GIR_EraseRootFromParent_Done,
     /*  768189 */   // Label 12033: @768189
     /*  768189 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(768264), // Rule ID 24509 //
     /*  768194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  768205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  768208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  768211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  768243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768262 */     GIR_RootConstrainSelectedInstOperands,
     /*  768263 */     // GIR_Coverage, 24509,
     /*  768263 */     GIR_EraseRootFromParent_Done,
     /*  768264 */   // Label 12034: @768264
     /*  768264 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(768339), // Rule ID 24512 //
     /*  768269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  768280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  768283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  768286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  768318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768337 */     GIR_RootConstrainSelectedInstOperands,
     /*  768338 */     // GIR_Coverage, 24512,
     /*  768338 */     GIR_EraseRootFromParent_Done,
     /*  768339 */   // Label 12035: @768339
     /*  768339 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(768414), // Rule ID 24513 //
     /*  768344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  768355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  768358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  768361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  768393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768412 */     GIR_RootConstrainSelectedInstOperands,
     /*  768413 */     // GIR_Coverage, 24513,
     /*  768413 */     GIR_EraseRootFromParent_Done,
     /*  768414 */   // Label 12036: @768414
     /*  768414 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(768489), // Rule ID 24516 //
     /*  768419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  768430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  768433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  768436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768465 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  768468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768487 */     GIR_RootConstrainSelectedInstOperands,
     /*  768488 */     // GIR_Coverage, 24516,
     /*  768488 */     GIR_EraseRootFromParent_Done,
     /*  768489 */   // Label 12037: @768489
     /*  768489 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(768564), // Rule ID 24517 //
     /*  768494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  768505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  768508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  768511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  768543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768562 */     GIR_RootConstrainSelectedInstOperands,
     /*  768563 */     // GIR_Coverage, 24517,
     /*  768563 */     GIR_EraseRootFromParent_Done,
     /*  768564 */   // Label 12038: @768564
     /*  768564 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(768639), // Rule ID 24520 //
     /*  768569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  768580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  768583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  768586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768615 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  768618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768637 */     GIR_RootConstrainSelectedInstOperands,
     /*  768638 */     // GIR_Coverage, 24520,
     /*  768638 */     GIR_EraseRootFromParent_Done,
     /*  768639 */   // Label 12039: @768639
     /*  768639 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(768714), // Rule ID 24521 //
     /*  768644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  768652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  768655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  768658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  768661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  768693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768712 */     GIR_RootConstrainSelectedInstOperands,
     /*  768713 */     // GIR_Coverage, 24521,
     /*  768713 */     GIR_EraseRootFromParent_Done,
     /*  768714 */   // Label 12040: @768714
     /*  768714 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(768789), // Rule ID 24612 //
     /*  768719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  768727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  768730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  768733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  768736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  768739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768765 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  768768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768787 */     GIR_RootConstrainSelectedInstOperands,
     /*  768788 */     // GIR_Coverage, 24612,
     /*  768788 */     GIR_EraseRootFromParent_Done,
     /*  768789 */   // Label 12041: @768789
     /*  768789 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(768864), // Rule ID 24613 //
     /*  768794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  768802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  768805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  768808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  768811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  768814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  768843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768862 */     GIR_RootConstrainSelectedInstOperands,
     /*  768863 */     // GIR_Coverage, 24613,
     /*  768863 */     GIR_EraseRootFromParent_Done,
     /*  768864 */   // Label 12042: @768864
     /*  768864 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(768939), // Rule ID 24616 //
     /*  768869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  768877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  768880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  768883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  768886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  768889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768915 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  768918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768937 */     GIR_RootConstrainSelectedInstOperands,
     /*  768938 */     // GIR_Coverage, 24616,
     /*  768938 */     GIR_EraseRootFromParent_Done,
     /*  768939 */   // Label 12043: @768939
     /*  768939 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(769014), // Rule ID 24617 //
     /*  768944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  768952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  768955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  768958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  768961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  768964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  768993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769012 */     GIR_RootConstrainSelectedInstOperands,
     /*  769013 */     // GIR_Coverage, 24617,
     /*  769013 */     GIR_EraseRootFromParent_Done,
     /*  769014 */   // Label 12044: @769014
     /*  769014 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(769089), // Rule ID 24620 //
     /*  769019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  769030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  769033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  769036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  769039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769065 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  769065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  769068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769087 */     GIR_RootConstrainSelectedInstOperands,
     /*  769088 */     // GIR_Coverage, 24620,
     /*  769088 */     GIR_EraseRootFromParent_Done,
     /*  769089 */   // Label 12045: @769089
     /*  769089 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(769164), // Rule ID 24621 //
     /*  769094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  769105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  769108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  769111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  769114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  769143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769162 */     GIR_RootConstrainSelectedInstOperands,
     /*  769163 */     // GIR_Coverage, 24621,
     /*  769163 */     GIR_EraseRootFromParent_Done,
     /*  769164 */   // Label 12046: @769164
     /*  769164 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(769239), // Rule ID 24624 //
     /*  769169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  769180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  769183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  769186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  769189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769215 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  769218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769237 */     GIR_RootConstrainSelectedInstOperands,
     /*  769238 */     // GIR_Coverage, 24624,
     /*  769238 */     GIR_EraseRootFromParent_Done,
     /*  769239 */   // Label 12047: @769239
     /*  769239 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(769314), // Rule ID 24625 //
     /*  769244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  769255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  769258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  769261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  769264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  769293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769312 */     GIR_RootConstrainSelectedInstOperands,
     /*  769313 */     // GIR_Coverage, 24625,
     /*  769313 */     GIR_EraseRootFromParent_Done,
     /*  769314 */   // Label 12048: @769314
     /*  769314 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(769389), // Rule ID 24628 //
     /*  769319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  769330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  769333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  769336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  769339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769365 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  769368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769387 */     GIR_RootConstrainSelectedInstOperands,
     /*  769388 */     // GIR_Coverage, 24628,
     /*  769388 */     GIR_EraseRootFromParent_Done,
     /*  769389 */   // Label 12049: @769389
     /*  769389 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(769464), // Rule ID 24629 //
     /*  769394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  769405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  769408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  769411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  769414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  769443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769462 */     GIR_RootConstrainSelectedInstOperands,
     /*  769463 */     // GIR_Coverage, 24629,
     /*  769463 */     GIR_EraseRootFromParent_Done,
     /*  769464 */   // Label 12050: @769464
     /*  769464 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(769539), // Rule ID 24632 //
     /*  769469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  769480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  769483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  769486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  769489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769515 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  769518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769537 */     GIR_RootConstrainSelectedInstOperands,
     /*  769538 */     // GIR_Coverage, 24632,
     /*  769538 */     GIR_EraseRootFromParent_Done,
     /*  769539 */   // Label 12051: @769539
     /*  769539 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(769614), // Rule ID 24633 //
     /*  769544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  769555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  769558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  769561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  769564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  769593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769612 */     GIR_RootConstrainSelectedInstOperands,
     /*  769613 */     // GIR_Coverage, 24633,
     /*  769613 */     GIR_EraseRootFromParent_Done,
     /*  769614 */   // Label 12052: @769614
     /*  769614 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(769689), // Rule ID 24636 //
     /*  769619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  769630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  769633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  769636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769665 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  769665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  769668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769687 */     GIR_RootConstrainSelectedInstOperands,
     /*  769688 */     // GIR_Coverage, 24636,
     /*  769688 */     GIR_EraseRootFromParent_Done,
     /*  769689 */   // Label 12053: @769689
     /*  769689 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(769764), // Rule ID 24637 //
     /*  769694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  769705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  769708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  769711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  769743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769762 */     GIR_RootConstrainSelectedInstOperands,
     /*  769763 */     // GIR_Coverage, 24637,
     /*  769763 */     GIR_EraseRootFromParent_Done,
     /*  769764 */   // Label 12054: @769764
     /*  769764 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(769839), // Rule ID 24640 //
     /*  769769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  769780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  769783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  769786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  769789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  769818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769837 */     GIR_RootConstrainSelectedInstOperands,
     /*  769838 */     // GIR_Coverage, 24640,
     /*  769838 */     GIR_EraseRootFromParent_Done,
     /*  769839 */   // Label 12055: @769839
     /*  769839 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(769914), // Rule ID 24641 //
     /*  769844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  769855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  769858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  769861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  769864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  769893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769912 */     GIR_RootConstrainSelectedInstOperands,
     /*  769913 */     // GIR_Coverage, 24641,
     /*  769913 */     GIR_EraseRootFromParent_Done,
     /*  769914 */   // Label 12056: @769914
     /*  769914 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(769989), // Rule ID 24644 //
     /*  769919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  769927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  769930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  769933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  769936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  769939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  769968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769987 */     GIR_RootConstrainSelectedInstOperands,
     /*  769988 */     // GIR_Coverage, 24644,
     /*  769988 */     GIR_EraseRootFromParent_Done,
     /*  769989 */   // Label 12057: @769989
     /*  769989 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(770064), // Rule ID 24645 //
     /*  769994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  770005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  770008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  770011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  770043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770062 */     GIR_RootConstrainSelectedInstOperands,
     /*  770063 */     // GIR_Coverage, 24645,
     /*  770063 */     GIR_EraseRootFromParent_Done,
     /*  770064 */   // Label 12058: @770064
     /*  770064 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(770139), // Rule ID 24648 //
     /*  770069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  770072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  770080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  770083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  770086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  770118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770137 */     GIR_RootConstrainSelectedInstOperands,
     /*  770138 */     // GIR_Coverage, 24648,
     /*  770138 */     GIR_EraseRootFromParent_Done,
     /*  770139 */   // Label 12059: @770139
     /*  770139 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(770214), // Rule ID 24649 //
     /*  770144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  770147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  770155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  770158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  770161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  770193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770212 */     GIR_RootConstrainSelectedInstOperands,
     /*  770213 */     // GIR_Coverage, 24649,
     /*  770213 */     GIR_EraseRootFromParent_Done,
     /*  770214 */   // Label 12060: @770214
     /*  770214 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(770289), // Rule ID 24652 //
     /*  770219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  770230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  770233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  770236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  770239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  770268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770287 */     GIR_RootConstrainSelectedInstOperands,
     /*  770288 */     // GIR_Coverage, 24652,
     /*  770288 */     GIR_EraseRootFromParent_Done,
     /*  770289 */   // Label 12061: @770289
     /*  770289 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(770364), // Rule ID 24653 //
     /*  770294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  770305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  770308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  770311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  770314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  770343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770362 */     GIR_RootConstrainSelectedInstOperands,
     /*  770363 */     // GIR_Coverage, 24653,
     /*  770363 */     GIR_EraseRootFromParent_Done,
     /*  770364 */   // Label 12062: @770364
     /*  770364 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(770439), // Rule ID 24656 //
     /*  770369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  770380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  770383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  770386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  770389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770415 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  770418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770437 */     GIR_RootConstrainSelectedInstOperands,
     /*  770438 */     // GIR_Coverage, 24656,
     /*  770438 */     GIR_EraseRootFromParent_Done,
     /*  770439 */   // Label 12063: @770439
     /*  770439 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(770514), // Rule ID 24657 //
     /*  770444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  770455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  770458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  770461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  770464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  770493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770512 */     GIR_RootConstrainSelectedInstOperands,
     /*  770513 */     // GIR_Coverage, 24657,
     /*  770513 */     GIR_EraseRootFromParent_Done,
     /*  770514 */   // Label 12064: @770514
     /*  770514 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(770589), // Rule ID 24660 //
     /*  770519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  770530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  770533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  770536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  770539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  770568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770587 */     GIR_RootConstrainSelectedInstOperands,
     /*  770588 */     // GIR_Coverage, 24660,
     /*  770588 */     GIR_EraseRootFromParent_Done,
     /*  770589 */   // Label 12065: @770589
     /*  770589 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(770664), // Rule ID 24661 //
     /*  770594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  770605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  770608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  770611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  770614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  770643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770662 */     GIR_RootConstrainSelectedInstOperands,
     /*  770663 */     // GIR_Coverage, 24661,
     /*  770663 */     GIR_EraseRootFromParent_Done,
     /*  770664 */   // Label 12066: @770664
     /*  770664 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(770739), // Rule ID 24664 //
     /*  770669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  770680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  770683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  770686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  770689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770715 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  770718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770737 */     GIR_RootConstrainSelectedInstOperands,
     /*  770738 */     // GIR_Coverage, 24664,
     /*  770738 */     GIR_EraseRootFromParent_Done,
     /*  770739 */   // Label 12067: @770739
     /*  770739 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(770814), // Rule ID 24665 //
     /*  770744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  770755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  770758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  770761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  770764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  770793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770812 */     GIR_RootConstrainSelectedInstOperands,
     /*  770813 */     // GIR_Coverage, 24665,
     /*  770813 */     GIR_EraseRootFromParent_Done,
     /*  770814 */   // Label 12068: @770814
     /*  770814 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(770889), // Rule ID 24668 //
     /*  770819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  770830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  770833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  770836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  770839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770865 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  770868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770887 */     GIR_RootConstrainSelectedInstOperands,
     /*  770888 */     // GIR_Coverage, 24668,
     /*  770888 */     GIR_EraseRootFromParent_Done,
     /*  770889 */   // Label 12069: @770889
     /*  770889 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(770964), // Rule ID 24669 //
     /*  770894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  770905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  770908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  770911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  770914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770940 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  770943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770962 */     GIR_RootConstrainSelectedInstOperands,
     /*  770963 */     // GIR_Coverage, 24669,
     /*  770963 */     GIR_EraseRootFromParent_Done,
     /*  770964 */   // Label 12070: @770964
     /*  770964 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(771039), // Rule ID 24672 //
     /*  770969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  770977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  770980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  770983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  770986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  770989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  771018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771037 */     GIR_RootConstrainSelectedInstOperands,
     /*  771038 */     // GIR_Coverage, 24672,
     /*  771038 */     GIR_EraseRootFromParent_Done,
     /*  771039 */   // Label 12071: @771039
     /*  771039 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(771114), // Rule ID 24673 //
     /*  771044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  771055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  771058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  771061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  771093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771112 */     GIR_RootConstrainSelectedInstOperands,
     /*  771113 */     // GIR_Coverage, 24673,
     /*  771113 */     GIR_EraseRootFromParent_Done,
     /*  771114 */   // Label 12072: @771114
     /*  771114 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(771189), // Rule ID 24676 //
     /*  771119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  771130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  771133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  771136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  771168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771187 */     GIR_RootConstrainSelectedInstOperands,
     /*  771188 */     // GIR_Coverage, 24676,
     /*  771188 */     GIR_EraseRootFromParent_Done,
     /*  771189 */   // Label 12073: @771189
     /*  771189 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(771264), // Rule ID 24677 //
     /*  771194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  771205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  771208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  771211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  771243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771262 */     GIR_RootConstrainSelectedInstOperands,
     /*  771263 */     // GIR_Coverage, 24677,
     /*  771263 */     GIR_EraseRootFromParent_Done,
     /*  771264 */   // Label 12074: @771264
     /*  771264 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(771339), // Rule ID 24680 //
     /*  771269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  771280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  771283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  771286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  771289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  771318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771337 */     GIR_RootConstrainSelectedInstOperands,
     /*  771338 */     // GIR_Coverage, 24680,
     /*  771338 */     GIR_EraseRootFromParent_Done,
     /*  771339 */   // Label 12075: @771339
     /*  771339 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(771414), // Rule ID 24681 //
     /*  771344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  771355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  771358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  771361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  771364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  771393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771412 */     GIR_RootConstrainSelectedInstOperands,
     /*  771413 */     // GIR_Coverage, 24681,
     /*  771413 */     GIR_EraseRootFromParent_Done,
     /*  771414 */   // Label 12076: @771414
     /*  771414 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(771489), // Rule ID 24684 //
     /*  771419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  771422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  771430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  771433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  771436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  771468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771487 */     GIR_RootConstrainSelectedInstOperands,
     /*  771488 */     // GIR_Coverage, 24684,
     /*  771488 */     GIR_EraseRootFromParent_Done,
     /*  771489 */   // Label 12077: @771489
     /*  771489 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(771564), // Rule ID 24685 //
     /*  771494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  771497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  771505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  771508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  771511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  771543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771562 */     GIR_RootConstrainSelectedInstOperands,
     /*  771563 */     // GIR_Coverage, 24685,
     /*  771563 */     GIR_EraseRootFromParent_Done,
     /*  771564 */   // Label 12078: @771564
     /*  771564 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(771639), // Rule ID 24688 //
     /*  771569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  771572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  771580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  771583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  771586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771615 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  771618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771637 */     GIR_RootConstrainSelectedInstOperands,
     /*  771638 */     // GIR_Coverage, 24688,
     /*  771638 */     GIR_EraseRootFromParent_Done,
     /*  771639 */   // Label 12079: @771639
     /*  771639 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(771714), // Rule ID 24689 //
     /*  771644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  771647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  771655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  771658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  771661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  771693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771712 */     GIR_RootConstrainSelectedInstOperands,
     /*  771713 */     // GIR_Coverage, 24689,
     /*  771713 */     GIR_EraseRootFromParent_Done,
     /*  771714 */   // Label 12080: @771714
     /*  771714 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(771789), // Rule ID 24692 //
     /*  771719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  771722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  771730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  771733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  771736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771765 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  771768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771787 */     GIR_RootConstrainSelectedInstOperands,
     /*  771788 */     // GIR_Coverage, 24692,
     /*  771788 */     GIR_EraseRootFromParent_Done,
     /*  771789 */   // Label 12081: @771789
     /*  771789 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(771864), // Rule ID 24693 //
     /*  771794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  771797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  771802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  771805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  771808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  771811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  771843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771862 */     GIR_RootConstrainSelectedInstOperands,
     /*  771863 */     // GIR_Coverage, 24693,
     /*  771863 */     GIR_EraseRootFromParent_Done,
     /*  771864 */   // Label 12082: @771864
     /*  771864 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(771939), // Rule ID 24696 //
     /*  771869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  771872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  771877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771915 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  771918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771937 */     GIR_RootConstrainSelectedInstOperands,
     /*  771938 */     // GIR_Coverage, 24696,
     /*  771938 */     GIR_EraseRootFromParent_Done,
     /*  771939 */   // Label 12083: @771939
     /*  771939 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(772014), // Rule ID 24697 //
     /*  771944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  771947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  771952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771990 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  771993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772012 */     GIR_RootConstrainSelectedInstOperands,
     /*  772013 */     // GIR_Coverage, 24697,
     /*  772013 */     GIR_EraseRootFromParent_Done,
     /*  772014 */   // Label 12084: @772014
     /*  772014 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(772089), // Rule ID 24700 //
     /*  772019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  772022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  772030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  772033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  772036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  772039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772065 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  772068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772087 */     GIR_RootConstrainSelectedInstOperands,
     /*  772088 */     // GIR_Coverage, 24700,
     /*  772088 */     GIR_EraseRootFromParent_Done,
     /*  772089 */   // Label 12085: @772089
     /*  772089 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(772164), // Rule ID 24701 //
     /*  772094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  772097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  772105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  772108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  772111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  772114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  772143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772162 */     GIR_RootConstrainSelectedInstOperands,
     /*  772163 */     // GIR_Coverage, 24701,
     /*  772163 */     GIR_EraseRootFromParent_Done,
     /*  772164 */   // Label 12086: @772164
     /*  772164 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(772239), // Rule ID 24704 //
     /*  772169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  772172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  772180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  772183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  772186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  772189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772215 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  772218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772237 */     GIR_RootConstrainSelectedInstOperands,
     /*  772238 */     // GIR_Coverage, 24704,
     /*  772238 */     GIR_EraseRootFromParent_Done,
     /*  772239 */   // Label 12087: @772239
     /*  772239 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(772314), // Rule ID 24705 //
     /*  772244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  772247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  772255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  772258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  772261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  772264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772290 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  772293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772312 */     GIR_RootConstrainSelectedInstOperands,
     /*  772313 */     // GIR_Coverage, 24705,
     /*  772313 */     GIR_EraseRootFromParent_Done,
     /*  772314 */   // Label 12088: @772314
     /*  772314 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(772389), // Rule ID 24708 //
     /*  772319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  772322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772365 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  772368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772387 */     GIR_RootConstrainSelectedInstOperands,
     /*  772388 */     // GIR_Coverage, 24708,
     /*  772388 */     GIR_EraseRootFromParent_Done,
     /*  772389 */   // Label 12089: @772389
     /*  772389 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(772464), // Rule ID 24709 //
     /*  772394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  772397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  772443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772462 */     GIR_RootConstrainSelectedInstOperands,
     /*  772463 */     // GIR_Coverage, 24709,
     /*  772463 */     GIR_EraseRootFromParent_Done,
     /*  772464 */   // Label 12090: @772464
     /*  772464 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(772539), // Rule ID 24712 //
     /*  772469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  772472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772515 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  772518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772537 */     GIR_RootConstrainSelectedInstOperands,
     /*  772538 */     // GIR_Coverage, 24712,
     /*  772538 */     GIR_EraseRootFromParent_Done,
     /*  772539 */   // Label 12091: @772539
     /*  772539 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(772614), // Rule ID 24713 //
     /*  772544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  772547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772590 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  772593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772612 */     GIR_RootConstrainSelectedInstOperands,
     /*  772613 */     // GIR_Coverage, 24713,
     /*  772613 */     GIR_EraseRootFromParent_Done,
     /*  772614 */   // Label 12092: @772614
     /*  772614 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(772689), // Rule ID 24716 //
     /*  772619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  772622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772665 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  772668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772687 */     GIR_RootConstrainSelectedInstOperands,
     /*  772688 */     // GIR_Coverage, 24716,
     /*  772688 */     GIR_EraseRootFromParent_Done,
     /*  772689 */   // Label 12093: @772689
     /*  772689 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(772764), // Rule ID 24717 //
     /*  772694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  772697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772740 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  772743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772762 */     GIR_RootConstrainSelectedInstOperands,
     /*  772763 */     // GIR_Coverage, 24717,
     /*  772763 */     GIR_EraseRootFromParent_Done,
     /*  772764 */   // Label 12094: @772764
     /*  772764 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(772839), // Rule ID 24720 //
     /*  772769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  772772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  772780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  772783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  772786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  772789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772815 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  772818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772837 */     GIR_RootConstrainSelectedInstOperands,
     /*  772838 */     // GIR_Coverage, 24720,
     /*  772838 */     GIR_EraseRootFromParent_Done,
     /*  772839 */   // Label 12095: @772839
     /*  772839 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(772914), // Rule ID 24721 //
     /*  772844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  772847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  772855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  772858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  772861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  772864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  772893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772912 */     GIR_RootConstrainSelectedInstOperands,
     /*  772913 */     // GIR_Coverage, 24721,
     /*  772913 */     GIR_EraseRootFromParent_Done,
     /*  772914 */   // Label 12096: @772914
     /*  772914 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(772989), // Rule ID 24724 //
     /*  772919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  772922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  772927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  772930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  772933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  772936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  772939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772965 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  772968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772987 */     GIR_RootConstrainSelectedInstOperands,
     /*  772988 */     // GIR_Coverage, 24724,
     /*  772988 */     GIR_EraseRootFromParent_Done,
     /*  772989 */   // Label 12097: @772989
     /*  772989 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(773064), // Rule ID 24725 //
     /*  772994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  772997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  773002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773040 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  773043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773062 */     GIR_RootConstrainSelectedInstOperands,
     /*  773063 */     // GIR_Coverage, 24725,
     /*  773063 */     GIR_EraseRootFromParent_Done,
     /*  773064 */   // Label 12098: @773064
     /*  773064 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(773139), // Rule ID 24728 //
     /*  773069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  773072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  773077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773115 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  773118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773137 */     GIR_RootConstrainSelectedInstOperands,
     /*  773138 */     // GIR_Coverage, 24728,
     /*  773138 */     GIR_EraseRootFromParent_Done,
     /*  773139 */   // Label 12099: @773139
     /*  773139 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(773214), // Rule ID 24729 //
     /*  773144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  773147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  773152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773190 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  773193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773212 */     GIR_RootConstrainSelectedInstOperands,
     /*  773213 */     // GIR_Coverage, 24729,
     /*  773213 */     GIR_EraseRootFromParent_Done,
     /*  773214 */   // Label 12100: @773214
     /*  773214 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(773289), // Rule ID 24732 //
     /*  773219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  773222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  773230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  773233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  773236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773265 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  773268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773287 */     GIR_RootConstrainSelectedInstOperands,
     /*  773288 */     // GIR_Coverage, 24732,
     /*  773288 */     GIR_EraseRootFromParent_Done,
     /*  773289 */   // Label 12101: @773289
     /*  773289 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(773364), // Rule ID 24733 //
     /*  773294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  773297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  773305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  773308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  773311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773340 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  773343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773362 */     GIR_RootConstrainSelectedInstOperands,
     /*  773363 */     // GIR_Coverage, 24733,
     /*  773363 */     GIR_EraseRootFromParent_Done,
     /*  773364 */   // Label 12102: @773364
     /*  773364 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(773439), // Rule ID 24736 //
     /*  773369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  773372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  773380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  773383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  773386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773415 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  773418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773437 */     GIR_RootConstrainSelectedInstOperands,
     /*  773438 */     // GIR_Coverage, 24736,
     /*  773438 */     GIR_EraseRootFromParent_Done,
     /*  773439 */   // Label 12103: @773439
     /*  773439 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(773514), // Rule ID 24737 //
     /*  773444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  773447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  773455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  773458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  773461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  773493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773512 */     GIR_RootConstrainSelectedInstOperands,
     /*  773513 */     // GIR_Coverage, 24737,
     /*  773513 */     GIR_EraseRootFromParent_Done,
     /*  773514 */   // Label 12104: @773514
     /*  773514 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(773589), // Rule ID 24740 //
     /*  773519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  773522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  773530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  773533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  773536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773565 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  773568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773587 */     GIR_RootConstrainSelectedInstOperands,
     /*  773588 */     // GIR_Coverage, 24740,
     /*  773588 */     GIR_EraseRootFromParent_Done,
     /*  773589 */   // Label 12105: @773589
     /*  773589 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(773664), // Rule ID 24741 //
     /*  773594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  773597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  773605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  773608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  773611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  773643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773662 */     GIR_RootConstrainSelectedInstOperands,
     /*  773663 */     // GIR_Coverage, 24741,
     /*  773663 */     GIR_EraseRootFromParent_Done,
     /*  773664 */   // Label 12106: @773664
     /*  773664 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(773739), // Rule ID 24744 //
     /*  773669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  773672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773715 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  773718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773737 */     GIR_RootConstrainSelectedInstOperands,
     /*  773738 */     // GIR_Coverage, 24744,
     /*  773738 */     GIR_EraseRootFromParent_Done,
     /*  773739 */   // Label 12107: @773739
     /*  773739 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(773814), // Rule ID 24745 //
     /*  773744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  773747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773790 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  773793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773812 */     GIR_RootConstrainSelectedInstOperands,
     /*  773813 */     // GIR_Coverage, 24745,
     /*  773813 */     GIR_EraseRootFromParent_Done,
     /*  773814 */   // Label 12108: @773814
     /*  773814 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(773889), // Rule ID 24748 //
     /*  773819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  773822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773865 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  773868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773887 */     GIR_RootConstrainSelectedInstOperands,
     /*  773888 */     // GIR_Coverage, 24748,
     /*  773888 */     GIR_EraseRootFromParent_Done,
     /*  773889 */   // Label 12109: @773889
     /*  773889 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(773964), // Rule ID 24749 //
     /*  773894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  773897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773940 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  773943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773962 */     GIR_RootConstrainSelectedInstOperands,
     /*  773963 */     // GIR_Coverage, 24749,
     /*  773963 */     GIR_EraseRootFromParent_Done,
     /*  773964 */   // Label 12110: @773964
     /*  773964 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(774039), // Rule ID 24752 //
     /*  773969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  773972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  773977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774015 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  774018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774037 */     GIR_RootConstrainSelectedInstOperands,
     /*  774038 */     // GIR_Coverage, 24752,
     /*  774038 */     GIR_EraseRootFromParent_Done,
     /*  774039 */   // Label 12111: @774039
     /*  774039 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(774114), // Rule ID 24753 //
     /*  774044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  774047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  774055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  774058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  774061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774090 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  774093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774112 */     GIR_RootConstrainSelectedInstOperands,
     /*  774113 */     // GIR_Coverage, 24753,
     /*  774113 */     GIR_EraseRootFromParent_Done,
     /*  774114 */   // Label 12112: @774114
     /*  774114 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(774189), // Rule ID 24756 //
     /*  774119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  774122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  774130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  774133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  774136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774165 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  774168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774187 */     GIR_RootConstrainSelectedInstOperands,
     /*  774188 */     // GIR_Coverage, 24756,
     /*  774188 */     GIR_EraseRootFromParent_Done,
     /*  774189 */   // Label 12113: @774189
     /*  774189 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(774264), // Rule ID 24757 //
     /*  774194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  774197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  774205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  774208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  774211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774240 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  774240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  774243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774262 */     GIR_RootConstrainSelectedInstOperands,
     /*  774263 */     // GIR_Coverage, 24757,
     /*  774263 */     GIR_EraseRootFromParent_Done,
     /*  774264 */   // Label 12114: @774264
     /*  774264 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(774339), // Rule ID 24760 //
     /*  774269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  774272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  774280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  774283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  774286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774315 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  774318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774337 */     GIR_RootConstrainSelectedInstOperands,
     /*  774338 */     // GIR_Coverage, 24760,
     /*  774338 */     GIR_EraseRootFromParent_Done,
     /*  774339 */   // Label 12115: @774339
     /*  774339 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(774414), // Rule ID 24761 //
     /*  774344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  774347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  774355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  774358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  774361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774390 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  774390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  774393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774412 */     GIR_RootConstrainSelectedInstOperands,
     /*  774413 */     // GIR_Coverage, 24761,
     /*  774413 */     GIR_EraseRootFromParent_Done,
     /*  774414 */   // Label 12116: @774414
     /*  774414 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(774489), // Rule ID 24764 //
     /*  774419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  774422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  774430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  774433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  774436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774465 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  774468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774487 */     GIR_RootConstrainSelectedInstOperands,
     /*  774488 */     // GIR_Coverage, 24764,
     /*  774488 */     GIR_EraseRootFromParent_Done,
     /*  774489 */   // Label 12117: @774489
     /*  774489 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(774564), // Rule ID 24765 //
     /*  774494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  774497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  774502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  774505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  774508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  774511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774540 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  774540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  774543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774562 */     GIR_RootConstrainSelectedInstOperands,
     /*  774563 */     // GIR_Coverage, 24765,
     /*  774563 */     GIR_EraseRootFromParent_Done,
     /*  774564 */   // Label 12118: @774564
     /*  774564 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(774639), // Rule ID 24804 //
     /*  774569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  774572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774615 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  774618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774637 */     GIR_RootConstrainSelectedInstOperands,
     /*  774638 */     // GIR_Coverage, 24804,
     /*  774638 */     GIR_EraseRootFromParent_Done,
     /*  774639 */   // Label 12119: @774639
     /*  774639 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(774714), // Rule ID 24805 //
     /*  774644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  774647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774690 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  774693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774712 */     GIR_RootConstrainSelectedInstOperands,
     /*  774713 */     // GIR_Coverage, 24805,
     /*  774713 */     GIR_EraseRootFromParent_Done,
     /*  774714 */   // Label 12120: @774714
     /*  774714 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(774789), // Rule ID 24808 //
     /*  774719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  774722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774765 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  774768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774787 */     GIR_RootConstrainSelectedInstOperands,
     /*  774788 */     // GIR_Coverage, 24808,
     /*  774788 */     GIR_EraseRootFromParent_Done,
     /*  774789 */   // Label 12121: @774789
     /*  774789 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(774864), // Rule ID 24809 //
     /*  774794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  774797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  774843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774862 */     GIR_RootConstrainSelectedInstOperands,
     /*  774863 */     // GIR_Coverage, 24809,
     /*  774863 */     GIR_EraseRootFromParent_Done,
     /*  774864 */   // Label 12122: @774864
     /*  774864 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(774939), // Rule ID 24812 //
     /*  774869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  774872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  774889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774915 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  774918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774937 */     GIR_RootConstrainSelectedInstOperands,
     /*  774938 */     // GIR_Coverage, 24812,
     /*  774938 */     GIR_EraseRootFromParent_Done,
     /*  774939 */   // Label 12123: @774939
     /*  774939 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(775014), // Rule ID 24813 //
     /*  774944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  774947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  774952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  774964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774990 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  774993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775012 */     GIR_RootConstrainSelectedInstOperands,
     /*  775013 */     // GIR_Coverage, 24813,
     /*  775013 */     GIR_EraseRootFromParent_Done,
     /*  775014 */   // Label 12124: @775014
     /*  775014 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(775089), // Rule ID 24816 //
     /*  775019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  775039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  775068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775087 */     GIR_RootConstrainSelectedInstOperands,
     /*  775088 */     // GIR_Coverage, 24816,
     /*  775088 */     GIR_EraseRootFromParent_Done,
     /*  775089 */   // Label 12125: @775089
     /*  775089 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(775164), // Rule ID 24817 //
     /*  775094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  775114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775140 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  775143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775162 */     GIR_RootConstrainSelectedInstOperands,
     /*  775163 */     // GIR_Coverage, 24817,
     /*  775163 */     GIR_EraseRootFromParent_Done,
     /*  775164 */   // Label 12126: @775164
     /*  775164 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(775239), // Rule ID 24820 //
     /*  775169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  775189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775215 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  775218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775237 */     GIR_RootConstrainSelectedInstOperands,
     /*  775238 */     // GIR_Coverage, 24820,
     /*  775238 */     GIR_EraseRootFromParent_Done,
     /*  775239 */   // Label 12127: @775239
     /*  775239 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(775314), // Rule ID 24821 //
     /*  775244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  775264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  775293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775312 */     GIR_RootConstrainSelectedInstOperands,
     /*  775313 */     // GIR_Coverage, 24821,
     /*  775313 */     GIR_EraseRootFromParent_Done,
     /*  775314 */   // Label 12128: @775314
     /*  775314 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(775389), // Rule ID 24824 //
     /*  775319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  775339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775365 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  775368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775387 */     GIR_RootConstrainSelectedInstOperands,
     /*  775388 */     // GIR_Coverage, 24824,
     /*  775388 */     GIR_EraseRootFromParent_Done,
     /*  775389 */   // Label 12129: @775389
     /*  775389 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(775464), // Rule ID 24825 //
     /*  775394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  775402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  775414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  775443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775462 */     GIR_RootConstrainSelectedInstOperands,
     /*  775463 */     // GIR_Coverage, 24825,
     /*  775463 */     GIR_EraseRootFromParent_Done,
     /*  775464 */   // Label 12130: @775464
     /*  775464 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(775539), // Rule ID 24828 //
     /*  775469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  775480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  775483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  775486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775515 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  775518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775537 */     GIR_RootConstrainSelectedInstOperands,
     /*  775538 */     // GIR_Coverage, 24828,
     /*  775538 */     GIR_EraseRootFromParent_Done,
     /*  775539 */   // Label 12131: @775539
     /*  775539 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(775614), // Rule ID 24829 //
     /*  775544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  775555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  775558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  775561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775590 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  775593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775612 */     GIR_RootConstrainSelectedInstOperands,
     /*  775613 */     // GIR_Coverage, 24829,
     /*  775613 */     GIR_EraseRootFromParent_Done,
     /*  775614 */   // Label 12132: @775614
     /*  775614 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(775689), // Rule ID 24832 //
     /*  775619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  775630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  775633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  775636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775665 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  775668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775687 */     GIR_RootConstrainSelectedInstOperands,
     /*  775688 */     // GIR_Coverage, 24832,
     /*  775688 */     GIR_EraseRootFromParent_Done,
     /*  775689 */   // Label 12133: @775689
     /*  775689 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(775764), // Rule ID 24833 //
     /*  775694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  775705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  775708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  775711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775740 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  775743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775762 */     GIR_RootConstrainSelectedInstOperands,
     /*  775763 */     // GIR_Coverage, 24833,
     /*  775763 */     GIR_EraseRootFromParent_Done,
     /*  775764 */   // Label 12134: @775764
     /*  775764 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(775839), // Rule ID 24836 //
     /*  775769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775815 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  775818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775837 */     GIR_RootConstrainSelectedInstOperands,
     /*  775838 */     // GIR_Coverage, 24836,
     /*  775838 */     GIR_EraseRootFromParent_Done,
     /*  775839 */   // Label 12135: @775839
     /*  775839 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(775914), // Rule ID 24837 //
     /*  775844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  775893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775912 */     GIR_RootConstrainSelectedInstOperands,
     /*  775913 */     // GIR_Coverage, 24837,
     /*  775913 */     GIR_EraseRootFromParent_Done,
     /*  775914 */   // Label 12136: @775914
     /*  775914 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(775989), // Rule ID 24840 //
     /*  775919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  775922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  775927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775965 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  775968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775987 */     GIR_RootConstrainSelectedInstOperands,
     /*  775988 */     // GIR_Coverage, 24840,
     /*  775988 */     GIR_EraseRootFromParent_Done,
     /*  775989 */   // Label 12137: @775989
     /*  775989 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(776064), // Rule ID 24841 //
     /*  775994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  775997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  776002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  776005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  776008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  776011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  776043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776062 */     GIR_RootConstrainSelectedInstOperands,
     /*  776063 */     // GIR_Coverage, 24841,
     /*  776063 */     GIR_EraseRootFromParent_Done,
     /*  776064 */   // Label 12138: @776064
     /*  776064 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(776139), // Rule ID 24844 //
     /*  776069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  776072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  776077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776115 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  776118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776137 */     GIR_RootConstrainSelectedInstOperands,
     /*  776138 */     // GIR_Coverage, 24844,
     /*  776138 */     GIR_EraseRootFromParent_Done,
     /*  776139 */   // Label 12139: @776139
     /*  776139 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(776214), // Rule ID 24845 //
     /*  776144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  776147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  776152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  776193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776212 */     GIR_RootConstrainSelectedInstOperands,
     /*  776213 */     // GIR_Coverage, 24845,
     /*  776213 */     GIR_EraseRootFromParent_Done,
     /*  776214 */   // Label 12140: @776214
     /*  776214 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(776289), // Rule ID 24848 //
     /*  776219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  776222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  776227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776265 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  776268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776287 */     GIR_RootConstrainSelectedInstOperands,
     /*  776288 */     // GIR_Coverage, 24848,
     /*  776288 */     GIR_EraseRootFromParent_Done,
     /*  776289 */   // Label 12141: @776289
     /*  776289 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(776364), // Rule ID 24849 //
     /*  776294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  776297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  776302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776340 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  776343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776362 */     GIR_RootConstrainSelectedInstOperands,
     /*  776363 */     // GIR_Coverage, 24849,
     /*  776363 */     GIR_EraseRootFromParent_Done,
     /*  776364 */   // Label 12142: @776364
     /*  776364 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(776439), // Rule ID 24876 //
     /*  776369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  776372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  776380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  776383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  776386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776415 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  776418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776437 */     GIR_RootConstrainSelectedInstOperands,
     /*  776438 */     // GIR_Coverage, 24876,
     /*  776438 */     GIR_EraseRootFromParent_Done,
     /*  776439 */   // Label 12143: @776439
     /*  776439 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(776514), // Rule ID 24877 //
     /*  776444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  776447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  776455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  776458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  776461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776490 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  776493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776512 */     GIR_RootConstrainSelectedInstOperands,
     /*  776513 */     // GIR_Coverage, 24877,
     /*  776513 */     GIR_EraseRootFromParent_Done,
     /*  776514 */   // Label 12144: @776514
     /*  776514 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(776589), // Rule ID 24880 //
     /*  776519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  776522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  776530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  776533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  776536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  776539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  776568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776587 */     GIR_RootConstrainSelectedInstOperands,
     /*  776588 */     // GIR_Coverage, 24880,
     /*  776588 */     GIR_EraseRootFromParent_Done,
     /*  776589 */   // Label 12145: @776589
     /*  776589 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(776664), // Rule ID 24881 //
     /*  776594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  776597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  776605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  776608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  776611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  776614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  776643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776662 */     GIR_RootConstrainSelectedInstOperands,
     /*  776663 */     // GIR_Coverage, 24881,
     /*  776663 */     GIR_EraseRootFromParent_Done,
     /*  776664 */   // Label 12146: @776664
     /*  776664 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(776739), // Rule ID 24884 //
     /*  776669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  776672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  776680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  776683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  776686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776715 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  776718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776737 */     GIR_RootConstrainSelectedInstOperands,
     /*  776738 */     // GIR_Coverage, 24884,
     /*  776738 */     GIR_EraseRootFromParent_Done,
     /*  776739 */   // Label 12147: @776739
     /*  776739 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(776814), // Rule ID 24885 //
     /*  776744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  776747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  776755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  776758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  776761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  776793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776812 */     GIR_RootConstrainSelectedInstOperands,
     /*  776813 */     // GIR_Coverage, 24885,
     /*  776813 */     GIR_EraseRootFromParent_Done,
     /*  776814 */   // Label 12148: @776814
     /*  776814 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(776889), // Rule ID 24888 //
     /*  776819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  776822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  776830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  776833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  776836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  776839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  776868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776887 */     GIR_RootConstrainSelectedInstOperands,
     /*  776888 */     // GIR_Coverage, 24888,
     /*  776888 */     GIR_EraseRootFromParent_Done,
     /*  776889 */   // Label 12149: @776889
     /*  776889 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(776964), // Rule ID 24889 //
     /*  776894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  776897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  776905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  776908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  776911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  776914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  776943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776962 */     GIR_RootConstrainSelectedInstOperands,
     /*  776963 */     // GIR_Coverage, 24889,
     /*  776963 */     GIR_EraseRootFromParent_Done,
     /*  776964 */   // Label 12150: @776964
     /*  776964 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(777039), // Rule ID 24892 //
     /*  776969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  776972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  776977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  776980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  776983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  776986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  776989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  777018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777037 */     GIR_RootConstrainSelectedInstOperands,
     /*  777038 */     // GIR_Coverage, 24892,
     /*  777038 */     GIR_EraseRootFromParent_Done,
     /*  777039 */   // Label 12151: @777039
     /*  777039 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(777114), // Rule ID 24893 //
     /*  777044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  777047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  777055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  777058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  777061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  777093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777112 */     GIR_RootConstrainSelectedInstOperands,
     /*  777113 */     // GIR_Coverage, 24893,
     /*  777113 */     GIR_EraseRootFromParent_Done,
     /*  777114 */   // Label 12152: @777114
     /*  777114 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(777189), // Rule ID 24896 //
     /*  777119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  777122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  777130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  777133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  777136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777165 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  777168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777187 */     GIR_RootConstrainSelectedInstOperands,
     /*  777188 */     // GIR_Coverage, 24896,
     /*  777188 */     GIR_EraseRootFromParent_Done,
     /*  777189 */   // Label 12153: @777189
     /*  777189 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(777264), // Rule ID 24897 //
     /*  777194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  777197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  777205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  777208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  777211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  777243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777262 */     GIR_RootConstrainSelectedInstOperands,
     /*  777263 */     // GIR_Coverage, 24897,
     /*  777263 */     GIR_EraseRootFromParent_Done,
     /*  777264 */   // Label 12154: @777264
     /*  777264 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(777339), // Rule ID 24900 //
     /*  777269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  777272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  777280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  777283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  777286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  777289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  777318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777337 */     GIR_RootConstrainSelectedInstOperands,
     /*  777338 */     // GIR_Coverage, 24900,
     /*  777338 */     GIR_EraseRootFromParent_Done,
     /*  777339 */   // Label 12155: @777339
     /*  777339 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(777414), // Rule ID 24901 //
     /*  777344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  777347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  777355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  777358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  777361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  777364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777390 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  777393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777412 */     GIR_RootConstrainSelectedInstOperands,
     /*  777413 */     // GIR_Coverage, 24901,
     /*  777413 */     GIR_EraseRootFromParent_Done,
     /*  777414 */   // Label 12156: @777414
     /*  777414 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(777489), // Rule ID 24904 //
     /*  777419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  777422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  777430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  777433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  777436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  777439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777465 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  777468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777487 */     GIR_RootConstrainSelectedInstOperands,
     /*  777488 */     // GIR_Coverage, 24904,
     /*  777488 */     GIR_EraseRootFromParent_Done,
     /*  777489 */   // Label 12157: @777489
     /*  777489 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(777564), // Rule ID 24905 //
     /*  777494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  777497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  777505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  777508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  777511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  777514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  777543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777562 */     GIR_RootConstrainSelectedInstOperands,
     /*  777563 */     // GIR_Coverage, 24905,
     /*  777563 */     GIR_EraseRootFromParent_Done,
     /*  777564 */   // Label 12158: @777564
     /*  777564 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(777639), // Rule ID 24908 //
     /*  777569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  777572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  777580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  777583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  777586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  777589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777615 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  777618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777637 */     GIR_RootConstrainSelectedInstOperands,
     /*  777638 */     // GIR_Coverage, 24908,
     /*  777638 */     GIR_EraseRootFromParent_Done,
     /*  777639 */   // Label 12159: @777639
     /*  777639 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(777714), // Rule ID 24909 //
     /*  777644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  777647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  777655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  777658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  777661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  777664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  777693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777712 */     GIR_RootConstrainSelectedInstOperands,
     /*  777713 */     // GIR_Coverage, 24909,
     /*  777713 */     GIR_EraseRootFromParent_Done,
     /*  777714 */   // Label 12160: @777714
     /*  777714 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(777789), // Rule ID 24912 //
     /*  777719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  777722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  777730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  777733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  777736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  777739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  777768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777787 */     GIR_RootConstrainSelectedInstOperands,
     /*  777788 */     // GIR_Coverage, 24912,
     /*  777788 */     GIR_EraseRootFromParent_Done,
     /*  777789 */   // Label 12161: @777789
     /*  777789 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(777864), // Rule ID 24913 //
     /*  777794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  777797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  777805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  777808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  777811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  777814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  777843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777862 */     GIR_RootConstrainSelectedInstOperands,
     /*  777863 */     // GIR_Coverage, 24913,
     /*  777863 */     GIR_EraseRootFromParent_Done,
     /*  777864 */   // Label 12162: @777864
     /*  777864 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(777939), // Rule ID 24916 //
     /*  777869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  777872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  777880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  777883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  777886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  777889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777915 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  777918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777937 */     GIR_RootConstrainSelectedInstOperands,
     /*  777938 */     // GIR_Coverage, 24916,
     /*  777938 */     GIR_EraseRootFromParent_Done,
     /*  777939 */   // Label 12163: @777939
     /*  777939 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(778014), // Rule ID 24917 //
     /*  777944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  777947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  777952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  777955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  777958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  777961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  777964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  777993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778012 */     GIR_RootConstrainSelectedInstOperands,
     /*  778013 */     // GIR_Coverage, 24917,
     /*  778013 */     GIR_EraseRootFromParent_Done,
     /*  778014 */   // Label 12164: @778014
     /*  778014 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(778089), // Rule ID 24920 //
     /*  778019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  778022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  778030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  778033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  778036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  778039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  778068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778087 */     GIR_RootConstrainSelectedInstOperands,
     /*  778088 */     // GIR_Coverage, 24920,
     /*  778088 */     GIR_EraseRootFromParent_Done,
     /*  778089 */   // Label 12165: @778089
     /*  778089 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(778164), // Rule ID 24921 //
     /*  778094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  778097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  778105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  778108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  778111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  778114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  778143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778162 */     GIR_RootConstrainSelectedInstOperands,
     /*  778163 */     // GIR_Coverage, 24921,
     /*  778163 */     GIR_EraseRootFromParent_Done,
     /*  778164 */   // Label 12166: @778164
     /*  778164 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(778239), // Rule ID 24924 //
     /*  778169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  778172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  778180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  778183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  778186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  778218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778237 */     GIR_RootConstrainSelectedInstOperands,
     /*  778238 */     // GIR_Coverage, 24924,
     /*  778238 */     GIR_EraseRootFromParent_Done,
     /*  778239 */   // Label 12167: @778239
     /*  778239 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(778314), // Rule ID 24925 //
     /*  778244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  778247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  778255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  778258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  778261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  778293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778312 */     GIR_RootConstrainSelectedInstOperands,
     /*  778313 */     // GIR_Coverage, 24925,
     /*  778313 */     GIR_EraseRootFromParent_Done,
     /*  778314 */   // Label 12168: @778314
     /*  778314 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(778389), // Rule ID 24928 //
     /*  778319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  778322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  778330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  778333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  778336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778365 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  778368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778387 */     GIR_RootConstrainSelectedInstOperands,
     /*  778388 */     // GIR_Coverage, 24928,
     /*  778388 */     GIR_EraseRootFromParent_Done,
     /*  778389 */   // Label 12169: @778389
     /*  778389 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(778464), // Rule ID 24929 //
     /*  778394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  778397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  778405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  778408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  778411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  778443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778462 */     GIR_RootConstrainSelectedInstOperands,
     /*  778463 */     // GIR_Coverage, 24929,
     /*  778463 */     GIR_EraseRootFromParent_Done,
     /*  778464 */   // Label 12170: @778464
     /*  778464 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(778539), // Rule ID 24932 //
     /*  778469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  778472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  778480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  778483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  778486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  778518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778537 */     GIR_RootConstrainSelectedInstOperands,
     /*  778538 */     // GIR_Coverage, 24932,
     /*  778538 */     GIR_EraseRootFromParent_Done,
     /*  778539 */   // Label 12171: @778539
     /*  778539 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(778614), // Rule ID 24933 //
     /*  778544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  778547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  778552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  778555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  778558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  778561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  778593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778612 */     GIR_RootConstrainSelectedInstOperands,
     /*  778613 */     // GIR_Coverage, 24933,
     /*  778613 */     GIR_EraseRootFromParent_Done,
     /*  778614 */   // Label 12172: @778614
     /*  778614 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(778686), // Rule ID 24936 //
     /*  778619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  778630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  778633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  778636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  778639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778665 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  778665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  778668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778684 */     GIR_RootConstrainSelectedInstOperands,
     /*  778685 */     // GIR_Coverage, 24936,
     /*  778685 */     GIR_EraseRootFromParent_Done,
     /*  778686 */   // Label 12173: @778686
     /*  778686 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(778758), // Rule ID 24937 //
     /*  778691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  778702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  778705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  778708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  778711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778737 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  778737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  778740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778756 */     GIR_RootConstrainSelectedInstOperands,
     /*  778757 */     // GIR_Coverage, 24937,
     /*  778757 */     GIR_EraseRootFromParent_Done,
     /*  778758 */   // Label 12174: @778758
     /*  778758 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(778830), // Rule ID 24938 //
     /*  778763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  778774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  778777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  778780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  778783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778809 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  778809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  778812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778828 */     GIR_RootConstrainSelectedInstOperands,
     /*  778829 */     // GIR_Coverage, 24938,
     /*  778829 */     GIR_EraseRootFromParent_Done,
     /*  778830 */   // Label 12175: @778830
     /*  778830 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(778902), // Rule ID 24939 //
     /*  778835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  778846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  778849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  778852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  778855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778881 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  778881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  778884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778900 */     GIR_RootConstrainSelectedInstOperands,
     /*  778901 */     // GIR_Coverage, 24939,
     /*  778901 */     GIR_EraseRootFromParent_Done,
     /*  778902 */   // Label 12176: @778902
     /*  778902 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(778974), // Rule ID 24940 //
     /*  778907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  778918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  778921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  778924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  778927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778953 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  778953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  778956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778972 */     GIR_RootConstrainSelectedInstOperands,
     /*  778973 */     // GIR_Coverage, 24940,
     /*  778973 */     GIR_EraseRootFromParent_Done,
     /*  778974 */   // Label 12177: @778974
     /*  778974 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(779046), // Rule ID 24941 //
     /*  778979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  778987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  778990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  778993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  778996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  778999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779025 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  779025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  779028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779044 */     GIR_RootConstrainSelectedInstOperands,
     /*  779045 */     // GIR_Coverage, 24941,
     /*  779045 */     GIR_EraseRootFromParent_Done,
     /*  779046 */   // Label 12178: @779046
     /*  779046 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(779118), // Rule ID 24942 //
     /*  779051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  779062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  779065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  779068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  779071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779097 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  779097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  779100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779116 */     GIR_RootConstrainSelectedInstOperands,
     /*  779117 */     // GIR_Coverage, 24942,
     /*  779117 */     GIR_EraseRootFromParent_Done,
     /*  779118 */   // Label 12179: @779118
     /*  779118 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(779190), // Rule ID 24943 //
     /*  779123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  779134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  779137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  779140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  779143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779169 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  779169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  779172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779188 */     GIR_RootConstrainSelectedInstOperands,
     /*  779189 */     // GIR_Coverage, 24943,
     /*  779189 */     GIR_EraseRootFromParent_Done,
     /*  779190 */   // Label 12180: @779190
     /*  779190 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(779262), // Rule ID 24944 //
     /*  779195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  779206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  779209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  779212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  779215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779241 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  779241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  779244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779260 */     GIR_RootConstrainSelectedInstOperands,
     /*  779261 */     // GIR_Coverage, 24944,
     /*  779261 */     GIR_EraseRootFromParent_Done,
     /*  779262 */   // Label 12181: @779262
     /*  779262 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(779334), // Rule ID 24945 //
     /*  779267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  779278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  779281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  779284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  779287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779313 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  779313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  779316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779332 */     GIR_RootConstrainSelectedInstOperands,
     /*  779333 */     // GIR_Coverage, 24945,
     /*  779333 */     GIR_EraseRootFromParent_Done,
     /*  779334 */   // Label 12182: @779334
     /*  779334 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(779406), // Rule ID 24946 //
     /*  779339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  779350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  779353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  779356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  779359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779385 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  779385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  779388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779404 */     GIR_RootConstrainSelectedInstOperands,
     /*  779405 */     // GIR_Coverage, 24946,
     /*  779405 */     GIR_EraseRootFromParent_Done,
     /*  779406 */   // Label 12183: @779406
     /*  779406 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(779478), // Rule ID 24947 //
     /*  779411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  779422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  779425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  779428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  779431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779457 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10865:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  779457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  779460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779476 */     GIR_RootConstrainSelectedInstOperands,
     /*  779477 */     // GIR_Coverage, 24947,
     /*  779477 */     GIR_EraseRootFromParent_Done,
     /*  779478 */   // Label 12184: @779478
     /*  779478 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(779550), // Rule ID 24948 //
     /*  779483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  779494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  779497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  779500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  779503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779529 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  779529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  779532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779548 */     GIR_RootConstrainSelectedInstOperands,
     /*  779549 */     // GIR_Coverage, 24948,
     /*  779549 */     GIR_EraseRootFromParent_Done,
     /*  779550 */   // Label 12185: @779550
     /*  779550 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(779622), // Rule ID 24949 //
     /*  779555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  779566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  779569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  779572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  779575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779601 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  779601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  779604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779620 */     GIR_RootConstrainSelectedInstOperands,
     /*  779621 */     // GIR_Coverage, 24949,
     /*  779621 */     GIR_EraseRootFromParent_Done,
     /*  779622 */   // Label 12186: @779622
     /*  779622 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(779694), // Rule ID 24950 //
     /*  779627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  779638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  779641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  779644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  779647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779673 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  779673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  779676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779692 */     GIR_RootConstrainSelectedInstOperands,
     /*  779693 */     // GIR_Coverage, 24950,
     /*  779693 */     GIR_EraseRootFromParent_Done,
     /*  779694 */   // Label 12187: @779694
     /*  779694 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(779766), // Rule ID 24951 //
     /*  779699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  779710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  779713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  779716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  779719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  779745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  779748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779764 */     GIR_RootConstrainSelectedInstOperands,
     /*  779765 */     // GIR_Coverage, 24951,
     /*  779765 */     GIR_EraseRootFromParent_Done,
     /*  779766 */   // Label 12188: @779766
     /*  779766 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(779838), // Rule ID 24952 //
     /*  779771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  779782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  779785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  779788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  779791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779817 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  779817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  779820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779836 */     GIR_RootConstrainSelectedInstOperands,
     /*  779837 */     // GIR_Coverage, 24952,
     /*  779837 */     GIR_EraseRootFromParent_Done,
     /*  779838 */   // Label 12189: @779838
     /*  779838 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(779910), // Rule ID 24953 //
     /*  779843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  779854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  779857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  779860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  779863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  779889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  779892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779908 */     GIR_RootConstrainSelectedInstOperands,
     /*  779909 */     // GIR_Coverage, 24953,
     /*  779909 */     GIR_EraseRootFromParent_Done,
     /*  779910 */   // Label 12190: @779910
     /*  779910 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(779982), // Rule ID 24954 //
     /*  779915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  779926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  779929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  779932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  779935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  779961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  779964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779980 */     GIR_RootConstrainSelectedInstOperands,
     /*  779981 */     // GIR_Coverage, 24954,
     /*  779981 */     GIR_EraseRootFromParent_Done,
     /*  779982 */   // Label 12191: @779982
     /*  779982 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(780054), // Rule ID 24955 //
     /*  779987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  779995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  779998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  780001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  780004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  780007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780033 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  780033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  780036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780052 */     GIR_RootConstrainSelectedInstOperands,
     /*  780053 */     // GIR_Coverage, 24955,
     /*  780053 */     GIR_EraseRootFromParent_Done,
     /*  780054 */   // Label 12192: @780054
     /*  780054 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(780126), // Rule ID 24956 //
     /*  780059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  780070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  780073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  780076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  780079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780105 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  780105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  780108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780124 */     GIR_RootConstrainSelectedInstOperands,
     /*  780125 */     // GIR_Coverage, 24956,
     /*  780125 */     GIR_EraseRootFromParent_Done,
     /*  780126 */   // Label 12193: @780126
     /*  780126 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(780198), // Rule ID 24957 //
     /*  780131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  780142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  780145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  780148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  780151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780177 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  780177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  780180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780196 */     GIR_RootConstrainSelectedInstOperands,
     /*  780197 */     // GIR_Coverage, 24957,
     /*  780197 */     GIR_EraseRootFromParent_Done,
     /*  780198 */   // Label 12194: @780198
     /*  780198 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(780270), // Rule ID 24958 //
     /*  780203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  780214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  780217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  780220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  780223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780249 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  780249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  780252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780268 */     GIR_RootConstrainSelectedInstOperands,
     /*  780269 */     // GIR_Coverage, 24958,
     /*  780269 */     GIR_EraseRootFromParent_Done,
     /*  780270 */   // Label 12195: @780270
     /*  780270 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(780342), // Rule ID 24959 //
     /*  780275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  780286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  780289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  780292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  780295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780321 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  780321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  780324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780340 */     GIR_RootConstrainSelectedInstOperands,
     /*  780341 */     // GIR_Coverage, 24959,
     /*  780341 */     GIR_EraseRootFromParent_Done,
     /*  780342 */   // Label 12196: @780342
     /*  780342 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(780414), // Rule ID 24960 //
     /*  780347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  780358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  780361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  780364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  780367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  780393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  780396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780412 */     GIR_RootConstrainSelectedInstOperands,
     /*  780413 */     // GIR_Coverage, 24960,
     /*  780413 */     GIR_EraseRootFromParent_Done,
     /*  780414 */   // Label 12197: @780414
     /*  780414 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(780486), // Rule ID 24961 //
     /*  780419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  780430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  780433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  780436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  780439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  780465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  780468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780484 */     GIR_RootConstrainSelectedInstOperands,
     /*  780485 */     // GIR_Coverage, 24961,
     /*  780485 */     GIR_EraseRootFromParent_Done,
     /*  780486 */   // Label 12198: @780486
     /*  780486 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(780558), // Rule ID 24962 //
     /*  780491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  780502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  780505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  780508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  780511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  780537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  780540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780556 */     GIR_RootConstrainSelectedInstOperands,
     /*  780557 */     // GIR_Coverage, 24962,
     /*  780557 */     GIR_EraseRootFromParent_Done,
     /*  780558 */   // Label 12199: @780558
     /*  780558 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(780630), // Rule ID 24963 //
     /*  780563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  780574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  780577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  780580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  780583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780609 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  780609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  780612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780628 */     GIR_RootConstrainSelectedInstOperands,
     /*  780629 */     // GIR_Coverage, 24963,
     /*  780629 */     GIR_EraseRootFromParent_Done,
     /*  780630 */   // Label 12200: @780630
     /*  780630 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(780702), // Rule ID 24964 //
     /*  780635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  780646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  780649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  780652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  780655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780681 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  780681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  780684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780700 */     GIR_RootConstrainSelectedInstOperands,
     /*  780701 */     // GIR_Coverage, 24964,
     /*  780701 */     GIR_EraseRootFromParent_Done,
     /*  780702 */   // Label 12201: @780702
     /*  780702 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(780774), // Rule ID 24965 //
     /*  780707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  780718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  780721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  780724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  780727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780753 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  780753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  780756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780772 */     GIR_RootConstrainSelectedInstOperands,
     /*  780773 */     // GIR_Coverage, 24965,
     /*  780773 */     GIR_EraseRootFromParent_Done,
     /*  780774 */   // Label 12202: @780774
     /*  780774 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(780846), // Rule ID 24966 //
     /*  780779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  780790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  780793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  780796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  780799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  780825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  780828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780844 */     GIR_RootConstrainSelectedInstOperands,
     /*  780845 */     // GIR_Coverage, 24966,
     /*  780845 */     GIR_EraseRootFromParent_Done,
     /*  780846 */   // Label 12203: @780846
     /*  780846 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(780918), // Rule ID 24967 //
     /*  780851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  780862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  780865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  780868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  780871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  780897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  780900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780916 */     GIR_RootConstrainSelectedInstOperands,
     /*  780917 */     // GIR_Coverage, 24967,
     /*  780917 */     GIR_EraseRootFromParent_Done,
     /*  780918 */   // Label 12204: @780918
     /*  780918 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(780990), // Rule ID 24968 //
     /*  780923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  780931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  780943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  780969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  780972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780988 */     GIR_RootConstrainSelectedInstOperands,
     /*  780989 */     // GIR_Coverage, 24968,
     /*  780989 */     GIR_EraseRootFromParent_Done,
     /*  780990 */   // Label 12205: @780990
     /*  780990 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(781062), // Rule ID 24969 //
     /*  780995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  781006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  781009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  781012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  781015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  781041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  781044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781060 */     GIR_RootConstrainSelectedInstOperands,
     /*  781061 */     // GIR_Coverage, 24969,
     /*  781061 */     GIR_EraseRootFromParent_Done,
     /*  781062 */   // Label 12206: @781062
     /*  781062 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(781134), // Rule ID 24970 //
     /*  781067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  781078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  781081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  781084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  781087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781113 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  781113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  781116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781132 */     GIR_RootConstrainSelectedInstOperands,
     /*  781133 */     // GIR_Coverage, 24970,
     /*  781133 */     GIR_EraseRootFromParent_Done,
     /*  781134 */   // Label 12207: @781134
     /*  781134 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(781206), // Rule ID 24971 //
     /*  781139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  781150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  781153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  781156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  781159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781185 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  781185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  781188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781204 */     GIR_RootConstrainSelectedInstOperands,
     /*  781205 */     // GIR_Coverage, 24971,
     /*  781205 */     GIR_EraseRootFromParent_Done,
     /*  781206 */   // Label 12208: @781206
     /*  781206 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(781278), // Rule ID 24972 //
     /*  781211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  781222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  781225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  781228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  781231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  781257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  781260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781276 */     GIR_RootConstrainSelectedInstOperands,
     /*  781277 */     // GIR_Coverage, 24972,
     /*  781277 */     GIR_EraseRootFromParent_Done,
     /*  781278 */   // Label 12209: @781278
     /*  781278 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(781350), // Rule ID 24973 //
     /*  781283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  781294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  781297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  781300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  781303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  781329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  781332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781348 */     GIR_RootConstrainSelectedInstOperands,
     /*  781349 */     // GIR_Coverage, 24973,
     /*  781349 */     GIR_EraseRootFromParent_Done,
     /*  781350 */   // Label 12210: @781350
     /*  781350 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(781422), // Rule ID 24974 //
     /*  781355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  781366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  781369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  781372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  781375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  781401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  781404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781420 */     GIR_RootConstrainSelectedInstOperands,
     /*  781421 */     // GIR_Coverage, 24974,
     /*  781421 */     GIR_EraseRootFromParent_Done,
     /*  781422 */   // Label 12211: @781422
     /*  781422 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(781494), // Rule ID 24975 //
     /*  781427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  781438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  781441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  781444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  781447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781473 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  781473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  781476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781492 */     GIR_RootConstrainSelectedInstOperands,
     /*  781493 */     // GIR_Coverage, 24975,
     /*  781493 */     GIR_EraseRootFromParent_Done,
     /*  781494 */   // Label 12212: @781494
     /*  781494 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(781566), // Rule ID 24976 //
     /*  781499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  781510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  781513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  781516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  781519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781545 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  781545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  781548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781564 */     GIR_RootConstrainSelectedInstOperands,
     /*  781565 */     // GIR_Coverage, 24976,
     /*  781565 */     GIR_EraseRootFromParent_Done,
     /*  781566 */   // Label 12213: @781566
     /*  781566 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(781638), // Rule ID 24977 //
     /*  781571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  781582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  781585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  781588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  781591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781617 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  781617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  781620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781636 */     GIR_RootConstrainSelectedInstOperands,
     /*  781637 */     // GIR_Coverage, 24977,
     /*  781637 */     GIR_EraseRootFromParent_Done,
     /*  781638 */   // Label 12214: @781638
     /*  781638 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(781710), // Rule ID 24978 //
     /*  781643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  781646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  781663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781689 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  781689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  781692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781708 */     GIR_RootConstrainSelectedInstOperands,
     /*  781709 */     // GIR_Coverage, 24978,
     /*  781709 */     GIR_EraseRootFromParent_Done,
     /*  781710 */   // Label 12215: @781710
     /*  781710 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(781782), // Rule ID 24979 //
     /*  781715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  781718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  781735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781761 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  781761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  781764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781780 */     GIR_RootConstrainSelectedInstOperands,
     /*  781781 */     // GIR_Coverage, 24979,
     /*  781781 */     GIR_EraseRootFromParent_Done,
     /*  781782 */   // Label 12216: @781782
     /*  781782 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(781854), // Rule ID 24980 //
     /*  781787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  781790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  781807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781833 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  781833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  781836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781852 */     GIR_RootConstrainSelectedInstOperands,
     /*  781853 */     // GIR_Coverage, 24980,
     /*  781853 */     GIR_EraseRootFromParent_Done,
     /*  781854 */   // Label 12217: @781854
     /*  781854 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(781926), // Rule ID 24981 //
     /*  781859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  781862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  781879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781905 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  781905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  781908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781924 */     GIR_RootConstrainSelectedInstOperands,
     /*  781925 */     // GIR_Coverage, 24981,
     /*  781925 */     GIR_EraseRootFromParent_Done,
     /*  781926 */   // Label 12218: @781926
     /*  781926 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(781998), // Rule ID 24982 //
     /*  781931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  781934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  781939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  781951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  781977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  781980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781996 */     GIR_RootConstrainSelectedInstOperands,
     /*  781997 */     // GIR_Coverage, 24982,
     /*  781997 */     GIR_EraseRootFromParent_Done,
     /*  781998 */   // Label 12219: @781998
     /*  781998 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(782070), // Rule ID 24983 //
     /*  782003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  782006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  782023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782049 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  782049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  782052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782068 */     GIR_RootConstrainSelectedInstOperands,
     /*  782069 */     // GIR_Coverage, 24983,
     /*  782069 */     GIR_EraseRootFromParent_Done,
     /*  782070 */   // Label 12220: @782070
     /*  782070 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(782142), // Rule ID 24984 //
     /*  782075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  782078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  782095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  782121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  782124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782140 */     GIR_RootConstrainSelectedInstOperands,
     /*  782141 */     // GIR_Coverage, 24984,
     /*  782141 */     GIR_EraseRootFromParent_Done,
     /*  782142 */   // Label 12221: @782142
     /*  782142 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(782214), // Rule ID 24985 //
     /*  782147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  782150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  782167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782193 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  782193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  782196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782212 */     GIR_RootConstrainSelectedInstOperands,
     /*  782213 */     // GIR_Coverage, 24985,
     /*  782213 */     GIR_EraseRootFromParent_Done,
     /*  782214 */   // Label 12222: @782214
     /*  782214 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(782286), // Rule ID 24986 //
     /*  782219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  782222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  782230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  782233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  782236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  782239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782265 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  782265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  782268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782284 */     GIR_RootConstrainSelectedInstOperands,
     /*  782285 */     // GIR_Coverage, 24986,
     /*  782285 */     GIR_EraseRootFromParent_Done,
     /*  782286 */   // Label 12223: @782286
     /*  782286 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(782358), // Rule ID 24987 //
     /*  782291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  782294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  782302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  782305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  782308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  782311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782337 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  782337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  782340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782356 */     GIR_RootConstrainSelectedInstOperands,
     /*  782357 */     // GIR_Coverage, 24987,
     /*  782357 */     GIR_EraseRootFromParent_Done,
     /*  782358 */   // Label 12224: @782358
     /*  782358 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(782430), // Rule ID 24988 //
     /*  782363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  782366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  782374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  782377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  782380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  782383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782409 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  782409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  782412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782428 */     GIR_RootConstrainSelectedInstOperands,
     /*  782429 */     // GIR_Coverage, 24988,
     /*  782429 */     GIR_EraseRootFromParent_Done,
     /*  782430 */   // Label 12225: @782430
     /*  782430 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(782502), // Rule ID 24989 //
     /*  782435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  782438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  782446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  782449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  782452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  782455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782481 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  782481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  782484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782500 */     GIR_RootConstrainSelectedInstOperands,
     /*  782501 */     // GIR_Coverage, 24989,
     /*  782501 */     GIR_EraseRootFromParent_Done,
     /*  782502 */   // Label 12226: @782502
     /*  782502 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(782574), // Rule ID 24990 //
     /*  782507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  782510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  782518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  782521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  782524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  782527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782553 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  782553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  782556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782572 */     GIR_RootConstrainSelectedInstOperands,
     /*  782573 */     // GIR_Coverage, 24990,
     /*  782573 */     GIR_EraseRootFromParent_Done,
     /*  782574 */   // Label 12227: @782574
     /*  782574 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(782646), // Rule ID 24991 //
     /*  782579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  782582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  782590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  782593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  782596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  782599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782625 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  782625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  782628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782644 */     GIR_RootConstrainSelectedInstOperands,
     /*  782645 */     // GIR_Coverage, 24991,
     /*  782645 */     GIR_EraseRootFromParent_Done,
     /*  782646 */   // Label 12228: @782646
     /*  782646 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(782718), // Rule ID 24992 //
     /*  782651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  782654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  782662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  782665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  782668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  782671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782697 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  782697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  782700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782716 */     GIR_RootConstrainSelectedInstOperands,
     /*  782717 */     // GIR_Coverage, 24992,
     /*  782717 */     GIR_EraseRootFromParent_Done,
     /*  782718 */   // Label 12229: @782718
     /*  782718 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(782790), // Rule ID 24993 //
     /*  782723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  782726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  782734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  782737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  782740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  782743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782769 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  782769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  782772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782788 */     GIR_RootConstrainSelectedInstOperands,
     /*  782789 */     // GIR_Coverage, 24993,
     /*  782789 */     GIR_EraseRootFromParent_Done,
     /*  782790 */   // Label 12230: @782790
     /*  782790 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(782862), // Rule ID 24994 //
     /*  782795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  782798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  782806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  782809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  782812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  782815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782841 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  782841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  782844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782860 */     GIR_RootConstrainSelectedInstOperands,
     /*  782861 */     // GIR_Coverage, 24994,
     /*  782861 */     GIR_EraseRootFromParent_Done,
     /*  782862 */   // Label 12231: @782862
     /*  782862 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(782934), // Rule ID 24995 //
     /*  782867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  782870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  782878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  782881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  782884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  782887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782913 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  782913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  782916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782932 */     GIR_RootConstrainSelectedInstOperands,
     /*  782933 */     // GIR_Coverage, 24995,
     /*  782933 */     GIR_EraseRootFromParent_Done,
     /*  782934 */   // Label 12232: @782934
     /*  782934 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(783006), // Rule ID 24996 //
     /*  782939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  782942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  782947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  782950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  782953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  782956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  782959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782985 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  782985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  782988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783004 */     GIR_RootConstrainSelectedInstOperands,
     /*  783005 */     // GIR_Coverage, 24996,
     /*  783005 */     GIR_EraseRootFromParent_Done,
     /*  783006 */   // Label 12233: @783006
     /*  783006 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(783078), // Rule ID 24997 //
     /*  783011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  783031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783057 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  783060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783076 */     GIR_RootConstrainSelectedInstOperands,
     /*  783077 */     // GIR_Coverage, 24997,
     /*  783077 */     GIR_EraseRootFromParent_Done,
     /*  783078 */   // Label 12234: @783078
     /*  783078 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(783150), // Rule ID 24998 //
     /*  783083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  783086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  783103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783129 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  783129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  783132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783148 */     GIR_RootConstrainSelectedInstOperands,
     /*  783149 */     // GIR_Coverage, 24998,
     /*  783149 */     GIR_EraseRootFromParent_Done,
     /*  783150 */   // Label 12235: @783150
     /*  783150 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(783222), // Rule ID 24999 //
     /*  783155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  783175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783201 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  783204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783220 */     GIR_RootConstrainSelectedInstOperands,
     /*  783221 */     // GIR_Coverage, 24999,
     /*  783221 */     GIR_EraseRootFromParent_Done,
     /*  783222 */   // Label 12236: @783222
     /*  783222 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(783294), // Rule ID 25000 //
     /*  783227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  783230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  783238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  783241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  783244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  783247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783273 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  783273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  783276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783292 */     GIR_RootConstrainSelectedInstOperands,
     /*  783293 */     // GIR_Coverage, 25000,
     /*  783293 */     GIR_EraseRootFromParent_Done,
     /*  783294 */   // Label 12237: @783294
     /*  783294 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(783366), // Rule ID 25001 //
     /*  783299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  783310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  783313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  783316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  783319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  783348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783364 */     GIR_RootConstrainSelectedInstOperands,
     /*  783365 */     // GIR_Coverage, 25001,
     /*  783365 */     GIR_EraseRootFromParent_Done,
     /*  783366 */   // Label 12238: @783366
     /*  783366 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(783438), // Rule ID 25002 //
     /*  783371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  783374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  783382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  783385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  783388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  783391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783417 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  783417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  783420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783436 */     GIR_RootConstrainSelectedInstOperands,
     /*  783437 */     // GIR_Coverage, 25002,
     /*  783437 */     GIR_EraseRootFromParent_Done,
     /*  783438 */   // Label 12239: @783438
     /*  783438 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(783510), // Rule ID 25003 //
     /*  783443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  783454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  783457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  783460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  783463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783489 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10865:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  783492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783508 */     GIR_RootConstrainSelectedInstOperands,
     /*  783509 */     // GIR_Coverage, 25003,
     /*  783509 */     GIR_EraseRootFromParent_Done,
     /*  783510 */   // Label 12240: @783510
     /*  783510 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(783582), // Rule ID 25004 //
     /*  783515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  783518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  783535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783561 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  783561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  783564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783580 */     GIR_RootConstrainSelectedInstOperands,
     /*  783581 */     // GIR_Coverage, 25004,
     /*  783581 */     GIR_EraseRootFromParent_Done,
     /*  783582 */   // Label 12241: @783582
     /*  783582 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(783654), // Rule ID 25005 //
     /*  783587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  783607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783633 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10865:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  783636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783652 */     GIR_RootConstrainSelectedInstOperands,
     /*  783653 */     // GIR_Coverage, 25005,
     /*  783653 */     GIR_EraseRootFromParent_Done,
     /*  783654 */   // Label 12242: @783654
     /*  783654 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(783726), // Rule ID 25006 //
     /*  783659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  783662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  783679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783705 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  783705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  783708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783724 */     GIR_RootConstrainSelectedInstOperands,
     /*  783725 */     // GIR_Coverage, 25006,
     /*  783725 */     GIR_EraseRootFromParent_Done,
     /*  783726 */   // Label 12243: @783726
     /*  783726 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(783798), // Rule ID 25007 //
     /*  783731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  783734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  783739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  783751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783777 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10865:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  783777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  783780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783796 */     GIR_RootConstrainSelectedInstOperands,
     /*  783797 */     // GIR_Coverage, 25007,
     /*  783797 */     GIR_EraseRootFromParent_Done,
     /*  783798 */   // Label 12244: @783798
     /*  783798 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(783873), // Rule ID 59886 //
     /*  783803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  783806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  783811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  783814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  783817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  783820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  783823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783849 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  783852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783871 */     GIR_RootConstrainSelectedInstOperands,
     /*  783872 */     // GIR_Coverage, 59886,
     /*  783872 */     GIR_EraseRootFromParent_Done,
     /*  783873 */   // Label 12245: @783873
     /*  783873 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(783948), // Rule ID 59887 //
     /*  783878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  783881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  783886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  783889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  783892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  783895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  783898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  783927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783946 */     GIR_RootConstrainSelectedInstOperands,
     /*  783947 */     // GIR_Coverage, 59887,
     /*  783947 */     GIR_EraseRootFromParent_Done,
     /*  783948 */   // Label 12246: @783948
     /*  783948 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(784023), // Rule ID 60244 //
     /*  783953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  783956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  783961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  783970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  783973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  783999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  784002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784021 */     GIR_RootConstrainSelectedInstOperands,
     /*  784022 */     // GIR_Coverage, 60244,
     /*  784022 */     GIR_EraseRootFromParent_Done,
     /*  784023 */   // Label 12247: @784023
     /*  784023 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(784098), // Rule ID 60245 //
     /*  784028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  784045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  784048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  784077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784096 */     GIR_RootConstrainSelectedInstOperands,
     /*  784097 */     // GIR_Coverage, 60245,
     /*  784097 */     GIR_EraseRootFromParent_Done,
     /*  784098 */   // Label 12248: @784098
     /*  784098 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(784173), // Rule ID 60248 //
     /*  784103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  784123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784149 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  784152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784171 */     GIR_RootConstrainSelectedInstOperands,
     /*  784172 */     // GIR_Coverage, 60248,
     /*  784172 */     GIR_EraseRootFromParent_Done,
     /*  784173 */   // Label 12249: @784173
     /*  784173 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(784248), // Rule ID 60249 //
     /*  784178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  784198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  784227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784246 */     GIR_RootConstrainSelectedInstOperands,
     /*  784247 */     // GIR_Coverage, 60249,
     /*  784247 */     GIR_EraseRootFromParent_Done,
     /*  784248 */   // Label 12250: @784248
     /*  784248 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(784323), // Rule ID 60252 //
     /*  784253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  784273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  784302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784321 */     GIR_RootConstrainSelectedInstOperands,
     /*  784322 */     // GIR_Coverage, 60252,
     /*  784322 */     GIR_EraseRootFromParent_Done,
     /*  784323 */   // Label 12251: @784323
     /*  784323 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(784398), // Rule ID 60253 //
     /*  784328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  784348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  784377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784396 */     GIR_RootConstrainSelectedInstOperands,
     /*  784397 */     // GIR_Coverage, 60253,
     /*  784397 */     GIR_EraseRootFromParent_Done,
     /*  784398 */   // Label 12252: @784398
     /*  784398 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(784473), // Rule ID 60256 //
     /*  784403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  784420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  784423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  784452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784471 */     GIR_RootConstrainSelectedInstOperands,
     /*  784472 */     // GIR_Coverage, 60256,
     /*  784472 */     GIR_EraseRootFromParent_Done,
     /*  784473 */   // Label 12253: @784473
     /*  784473 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(784548), // Rule ID 60257 //
     /*  784478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  784495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  784498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  784527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784546 */     GIR_RootConstrainSelectedInstOperands,
     /*  784547 */     // GIR_Coverage, 60257,
     /*  784547 */     GIR_EraseRootFromParent_Done,
     /*  784548 */   // Label 12254: @784548
     /*  784548 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(784623), // Rule ID 60260 //
     /*  784553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  784570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  784573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  784602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784621 */     GIR_RootConstrainSelectedInstOperands,
     /*  784622 */     // GIR_Coverage, 60260,
     /*  784622 */     GIR_EraseRootFromParent_Done,
     /*  784623 */   // Label 12255: @784623
     /*  784623 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(784698), // Rule ID 60261 //
     /*  784628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  784645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  784648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  784677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784696 */     GIR_RootConstrainSelectedInstOperands,
     /*  784697 */     // GIR_Coverage, 60261,
     /*  784697 */     GIR_EraseRootFromParent_Done,
     /*  784698 */   // Label 12256: @784698
     /*  784698 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(784773), // Rule ID 60264 //
     /*  784703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  784720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  784723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784749 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  784752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784771 */     GIR_RootConstrainSelectedInstOperands,
     /*  784772 */     // GIR_Coverage, 60264,
     /*  784772 */     GIR_EraseRootFromParent_Done,
     /*  784773 */   // Label 12257: @784773
     /*  784773 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(784848), // Rule ID 60265 //
     /*  784778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  784795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  784798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  784827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784846 */     GIR_RootConstrainSelectedInstOperands,
     /*  784847 */     // GIR_Coverage, 60265,
     /*  784847 */     GIR_EraseRootFromParent_Done,
     /*  784848 */   // Label 12258: @784848
     /*  784848 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(784923), // Rule ID 60268 //
     /*  784853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  784856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  784902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784921 */     GIR_RootConstrainSelectedInstOperands,
     /*  784922 */     // GIR_Coverage, 60268,
     /*  784922 */     GIR_EraseRootFromParent_Done,
     /*  784923 */   // Label 12259: @784923
     /*  784923 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(784998), // Rule ID 60269 //
     /*  784928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  784931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  784936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  784977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784996 */     GIR_RootConstrainSelectedInstOperands,
     /*  784997 */     // GIR_Coverage, 60269,
     /*  784997 */     GIR_EraseRootFromParent_Done,
     /*  784998 */   // Label 12260: @784998
     /*  784998 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(785073), // Rule ID 60272 //
     /*  785003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  785020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  785023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  785052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785071 */     GIR_RootConstrainSelectedInstOperands,
     /*  785072 */     // GIR_Coverage, 60272,
     /*  785072 */     GIR_EraseRootFromParent_Done,
     /*  785073 */   // Label 12261: @785073
     /*  785073 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(785148), // Rule ID 60273 //
     /*  785078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  785095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  785098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  785127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785146 */     GIR_RootConstrainSelectedInstOperands,
     /*  785147 */     // GIR_Coverage, 60273,
     /*  785147 */     GIR_EraseRootFromParent_Done,
     /*  785148 */   // Label 12262: @785148
     /*  785148 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(785223), // Rule ID 60276 //
     /*  785153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  785173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  785202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785221 */     GIR_RootConstrainSelectedInstOperands,
     /*  785222 */     // GIR_Coverage, 60276,
     /*  785222 */     GIR_EraseRootFromParent_Done,
     /*  785223 */   // Label 12263: @785223
     /*  785223 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(785298), // Rule ID 60277 //
     /*  785228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  785248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  785277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785296 */     GIR_RootConstrainSelectedInstOperands,
     /*  785297 */     // GIR_Coverage, 60277,
     /*  785297 */     GIR_EraseRootFromParent_Done,
     /*  785298 */   // Label 12264: @785298
     /*  785298 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(785373), // Rule ID 60280 //
     /*  785303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  785352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785371 */     GIR_RootConstrainSelectedInstOperands,
     /*  785372 */     // GIR_Coverage, 60280,
     /*  785372 */     GIR_EraseRootFromParent_Done,
     /*  785373 */   // Label 12265: @785373
     /*  785373 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(785448), // Rule ID 60281 //
     /*  785378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  785427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785446 */     GIR_RootConstrainSelectedInstOperands,
     /*  785447 */     // GIR_Coverage, 60281,
     /*  785447 */     GIR_EraseRootFromParent_Done,
     /*  785448 */   // Label 12266: @785448
     /*  785448 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(785523), // Rule ID 60284 //
     /*  785453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  785502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785521 */     GIR_RootConstrainSelectedInstOperands,
     /*  785522 */     // GIR_Coverage, 60284,
     /*  785522 */     GIR_EraseRootFromParent_Done,
     /*  785523 */   // Label 12267: @785523
     /*  785523 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(785598), // Rule ID 60285 //
     /*  785528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  785577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785596 */     GIR_RootConstrainSelectedInstOperands,
     /*  785597 */     // GIR_Coverage, 60285,
     /*  785597 */     GIR_EraseRootFromParent_Done,
     /*  785598 */   // Label 12268: @785598
     /*  785598 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(785673), // Rule ID 60288 //
     /*  785603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  785623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  785652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785671 */     GIR_RootConstrainSelectedInstOperands,
     /*  785672 */     // GIR_Coverage, 60288,
     /*  785672 */     GIR_EraseRootFromParent_Done,
     /*  785673 */   // Label 12269: @785673
     /*  785673 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(785748), // Rule ID 60289 //
     /*  785678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  785698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  785727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785746 */     GIR_RootConstrainSelectedInstOperands,
     /*  785747 */     // GIR_Coverage, 60289,
     /*  785747 */     GIR_EraseRootFromParent_Done,
     /*  785748 */   // Label 12270: @785748
     /*  785748 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(785823), // Rule ID 60292 //
     /*  785753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  785773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  785802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785821 */     GIR_RootConstrainSelectedInstOperands,
     /*  785822 */     // GIR_Coverage, 60292,
     /*  785822 */     GIR_EraseRootFromParent_Done,
     /*  785823 */   // Label 12271: @785823
     /*  785823 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(785898), // Rule ID 60293 //
     /*  785828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  785848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  785877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785896 */     GIR_RootConstrainSelectedInstOperands,
     /*  785897 */     // GIR_Coverage, 60293,
     /*  785897 */     GIR_EraseRootFromParent_Done,
     /*  785898 */   // Label 12272: @785898
     /*  785898 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(785973), // Rule ID 60296 //
     /*  785903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  785906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  785952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785971 */     GIR_RootConstrainSelectedInstOperands,
     /*  785972 */     // GIR_Coverage, 60296,
     /*  785972 */     GIR_EraseRootFromParent_Done,
     /*  785973 */   // Label 12273: @785973
     /*  785973 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(786048), // Rule ID 60297 //
     /*  785978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  785981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  785986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  786027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786046 */     GIR_RootConstrainSelectedInstOperands,
     /*  786047 */     // GIR_Coverage, 60297,
     /*  786047 */     GIR_EraseRootFromParent_Done,
     /*  786048 */   // Label 12274: @786048
     /*  786048 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(786123), // Rule ID 60300 //
     /*  786053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  786073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786099 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  786102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786121 */     GIR_RootConstrainSelectedInstOperands,
     /*  786122 */     // GIR_Coverage, 60300,
     /*  786122 */     GIR_EraseRootFromParent_Done,
     /*  786123 */   // Label 12275: @786123
     /*  786123 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(786198), // Rule ID 60301 //
     /*  786128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  786148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  786177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786196 */     GIR_RootConstrainSelectedInstOperands,
     /*  786197 */     // GIR_Coverage, 60301,
     /*  786197 */     GIR_EraseRootFromParent_Done,
     /*  786198 */   // Label 12276: @786198
     /*  786198 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(786273), // Rule ID 60304 //
     /*  786203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  786220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  786252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786271 */     GIR_RootConstrainSelectedInstOperands,
     /*  786272 */     // GIR_Coverage, 60304,
     /*  786272 */     GIR_EraseRootFromParent_Done,
     /*  786273 */   // Label 12277: @786273
     /*  786273 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(786348), // Rule ID 60305 //
     /*  786278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  786295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  786327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786346 */     GIR_RootConstrainSelectedInstOperands,
     /*  786347 */     // GIR_Coverage, 60305,
     /*  786347 */     GIR_EraseRootFromParent_Done,
     /*  786348 */   // Label 12278: @786348
     /*  786348 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(786423), // Rule ID 60312 //
     /*  786353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  786370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  786402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786421 */     GIR_RootConstrainSelectedInstOperands,
     /*  786422 */     // GIR_Coverage, 60312,
     /*  786422 */     GIR_EraseRootFromParent_Done,
     /*  786423 */   // Label 12279: @786423
     /*  786423 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(786498), // Rule ID 60313 //
     /*  786428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  786445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  786477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786496 */     GIR_RootConstrainSelectedInstOperands,
     /*  786497 */     // GIR_Coverage, 60313,
     /*  786497 */     GIR_EraseRootFromParent_Done,
     /*  786498 */   // Label 12280: @786498
     /*  786498 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(786573), // Rule ID 60320 //
     /*  786503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  786520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  786552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786571 */     GIR_RootConstrainSelectedInstOperands,
     /*  786572 */     // GIR_Coverage, 60320,
     /*  786572 */     GIR_EraseRootFromParent_Done,
     /*  786573 */   // Label 12281: @786573
     /*  786573 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(786648), // Rule ID 60321 //
     /*  786578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  786595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  786627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786646 */     GIR_RootConstrainSelectedInstOperands,
     /*  786647 */     // GIR_Coverage, 60321,
     /*  786647 */     GIR_EraseRootFromParent_Done,
     /*  786648 */   // Label 12282: @786648
     /*  786648 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(786723), // Rule ID 60328 //
     /*  786653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  786670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  786702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786721 */     GIR_RootConstrainSelectedInstOperands,
     /*  786722 */     // GIR_Coverage, 60328,
     /*  786722 */     GIR_EraseRootFromParent_Done,
     /*  786723 */   // Label 12283: @786723
     /*  786723 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(786798), // Rule ID 60329 //
     /*  786728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  786745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  786777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786796 */     GIR_RootConstrainSelectedInstOperands,
     /*  786797 */     // GIR_Coverage, 60329,
     /*  786797 */     GIR_EraseRootFromParent_Done,
     /*  786798 */   // Label 12284: @786798
     /*  786798 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(786873), // Rule ID 60336 //
     /*  786803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  786820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786849 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  786852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786871 */     GIR_RootConstrainSelectedInstOperands,
     /*  786872 */     // GIR_Coverage, 60336,
     /*  786872 */     GIR_EraseRootFromParent_Done,
     /*  786873 */   // Label 12285: @786873
     /*  786873 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(786948), // Rule ID 60337 //
     /*  786878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  786881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  786895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  786927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786946 */     GIR_RootConstrainSelectedInstOperands,
     /*  786947 */     // GIR_Coverage, 60337,
     /*  786947 */     GIR_EraseRootFromParent_Done,
     /*  786948 */   // Label 12286: @786948
     /*  786948 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(787023), // Rule ID 60344 //
     /*  786953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  786956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  786961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  786970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  787002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  787018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787021 */     GIR_RootConstrainSelectedInstOperands,
     /*  787022 */     // GIR_Coverage, 60344,
     /*  787022 */     GIR_EraseRootFromParent_Done,
     /*  787023 */   // Label 12287: @787023
     /*  787023 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(787098), // Rule ID 60345 //
     /*  787028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  787045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  787074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  787077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  787093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787096 */     GIR_RootConstrainSelectedInstOperands,
     /*  787097 */     // GIR_Coverage, 60345,
     /*  787097 */     GIR_EraseRootFromParent_Done,
     /*  787098 */   // Label 12288: @787098
     /*  787098 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(787173), // Rule ID 60352 //
     /*  787103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  787152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787171 */     GIR_RootConstrainSelectedInstOperands,
     /*  787172 */     // GIR_Coverage, 60352,
     /*  787172 */     GIR_EraseRootFromParent_Done,
     /*  787173 */   // Label 12289: @787173
     /*  787173 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(787248), // Rule ID 60353 //
     /*  787178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787224 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  787227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787246 */     GIR_RootConstrainSelectedInstOperands,
     /*  787247 */     // GIR_Coverage, 60353,
     /*  787247 */     GIR_EraseRootFromParent_Done,
     /*  787248 */   // Label 12290: @787248
     /*  787248 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(787323), // Rule ID 60360 //
     /*  787253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  787302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787321 */     GIR_RootConstrainSelectedInstOperands,
     /*  787322 */     // GIR_Coverage, 60360,
     /*  787322 */     GIR_EraseRootFromParent_Done,
     /*  787323 */   // Label 12291: @787323
     /*  787323 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(787398), // Rule ID 60361 //
     /*  787328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  787377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787396 */     GIR_RootConstrainSelectedInstOperands,
     /*  787397 */     // GIR_Coverage, 60361,
     /*  787397 */     GIR_EraseRootFromParent_Done,
     /*  787398 */   // Label 12292: @787398
     /*  787398 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(787473), // Rule ID 60368 //
     /*  787403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  787420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  787452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787471 */     GIR_RootConstrainSelectedInstOperands,
     /*  787472 */     // GIR_Coverage, 60368,
     /*  787472 */     GIR_EraseRootFromParent_Done,
     /*  787473 */   // Label 12293: @787473
     /*  787473 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(787548), // Rule ID 60369 //
     /*  787478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  787495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  787527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787546 */     GIR_RootConstrainSelectedInstOperands,
     /*  787547 */     // GIR_Coverage, 60369,
     /*  787547 */     GIR_EraseRootFromParent_Done,
     /*  787548 */   // Label 12294: @787548
     /*  787548 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(787623), // Rule ID 60376 //
     /*  787553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  787602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787621 */     GIR_RootConstrainSelectedInstOperands,
     /*  787622 */     // GIR_Coverage, 60376,
     /*  787622 */     GIR_EraseRootFromParent_Done,
     /*  787623 */   // Label 12295: @787623
     /*  787623 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(787698), // Rule ID 60377 //
     /*  787628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  787677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787696 */     GIR_RootConstrainSelectedInstOperands,
     /*  787697 */     // GIR_Coverage, 60377,
     /*  787697 */     GIR_EraseRootFromParent_Done,
     /*  787698 */   // Label 12296: @787698
     /*  787698 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(787773), // Rule ID 60384 //
     /*  787703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  787752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787771 */     GIR_RootConstrainSelectedInstOperands,
     /*  787772 */     // GIR_Coverage, 60384,
     /*  787772 */     GIR_EraseRootFromParent_Done,
     /*  787773 */   // Label 12297: @787773
     /*  787773 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(787848), // Rule ID 60385 //
     /*  787778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  787827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787846 */     GIR_RootConstrainSelectedInstOperands,
     /*  787847 */     // GIR_Coverage, 60385,
     /*  787847 */     GIR_EraseRootFromParent_Done,
     /*  787848 */   // Label 12298: @787848
     /*  787848 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(787923), // Rule ID 60392 //
     /*  787853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  787856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  787902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787921 */     GIR_RootConstrainSelectedInstOperands,
     /*  787922 */     // GIR_Coverage, 60392,
     /*  787922 */     GIR_EraseRootFromParent_Done,
     /*  787923 */   // Label 12299: @787923
     /*  787923 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(787998), // Rule ID 60393 //
     /*  787928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  787931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  787936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  787977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787996 */     GIR_RootConstrainSelectedInstOperands,
     /*  787997 */     // GIR_Coverage, 60393,
     /*  787997 */     GIR_EraseRootFromParent_Done,
     /*  787998 */   // Label 12300: @787998
     /*  787998 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(788073), // Rule ID 60400 //
     /*  788003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  788006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  788052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788071 */     GIR_RootConstrainSelectedInstOperands,
     /*  788072 */     // GIR_Coverage, 60400,
     /*  788072 */     GIR_EraseRootFromParent_Done,
     /*  788073 */   // Label 12301: @788073
     /*  788073 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(788148), // Rule ID 60401 //
     /*  788078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  788081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  788127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788146 */     GIR_RootConstrainSelectedInstOperands,
     /*  788147 */     // GIR_Coverage, 60401,
     /*  788147 */     GIR_EraseRootFromParent_Done,
     /*  788148 */   // Label 12302: @788148
     /*  788148 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(788223), // Rule ID 60408 //
     /*  788153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  788156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  788170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  788202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788221 */     GIR_RootConstrainSelectedInstOperands,
     /*  788222 */     // GIR_Coverage, 60408,
     /*  788222 */     GIR_EraseRootFromParent_Done,
     /*  788223 */   // Label 12303: @788223
     /*  788223 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(788298), // Rule ID 60409 //
     /*  788228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  788231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  788245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  788277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788296 */     GIR_RootConstrainSelectedInstOperands,
     /*  788297 */     // GIR_Coverage, 60409,
     /*  788297 */     GIR_EraseRootFromParent_Done,
     /*  788298 */   // Label 12304: @788298
     /*  788298 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(788373), // Rule ID 60416 //
     /*  788303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  788306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  788320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  788352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788371 */     GIR_RootConstrainSelectedInstOperands,
     /*  788372 */     // GIR_Coverage, 60416,
     /*  788372 */     GIR_EraseRootFromParent_Done,
     /*  788373 */   // Label 12305: @788373
     /*  788373 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(788448), // Rule ID 60417 //
     /*  788378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  788381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  788386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  788395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  788417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  788427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788446 */     GIR_RootConstrainSelectedInstOperands,
     /*  788447 */     // GIR_Coverage, 60417,
     /*  788447 */     GIR_EraseRootFromParent_Done,
     /*  788448 */   // Label 12306: @788448
     /*  788448 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(788523), // Rule ID 60424 //
     /*  788453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  788456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  788502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788521 */     GIR_RootConstrainSelectedInstOperands,
     /*  788522 */     // GIR_Coverage, 60424,
     /*  788522 */     GIR_EraseRootFromParent_Done,
     /*  788523 */   // Label 12307: @788523
     /*  788523 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(788598), // Rule ID 60425 //
     /*  788528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  788531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  788577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788596 */     GIR_RootConstrainSelectedInstOperands,
     /*  788597 */     // GIR_Coverage, 60425,
     /*  788597 */     GIR_EraseRootFromParent_Done,
     /*  788598 */   // Label 12308: @788598
     /*  788598 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(788673), // Rule ID 60428 //
     /*  788603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  788606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  788623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  788652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788671 */     GIR_RootConstrainSelectedInstOperands,
     /*  788672 */     // GIR_Coverage, 60428,
     /*  788672 */     GIR_EraseRootFromParent_Done,
     /*  788673 */   // Label 12309: @788673
     /*  788673 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(788748), // Rule ID 60429 //
     /*  788678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  788681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  788698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  788727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788746 */     GIR_RootConstrainSelectedInstOperands,
     /*  788747 */     // GIR_Coverage, 60429,
     /*  788747 */     GIR_EraseRootFromParent_Done,
     /*  788748 */   // Label 12310: @788748
     /*  788748 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(788823), // Rule ID 60432 //
     /*  788753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  788756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  788773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  788802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788821 */     GIR_RootConstrainSelectedInstOperands,
     /*  788822 */     // GIR_Coverage, 60432,
     /*  788822 */     GIR_EraseRootFromParent_Done,
     /*  788823 */   // Label 12311: @788823
     /*  788823 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(788898), // Rule ID 60433 //
     /*  788828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  788831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  788848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  788877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788896 */     GIR_RootConstrainSelectedInstOperands,
     /*  788897 */     // GIR_Coverage, 60433,
     /*  788897 */     GIR_EraseRootFromParent_Done,
     /*  788898 */   // Label 12312: @788898
     /*  788898 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(788973), // Rule ID 60436 //
     /*  788903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  788906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  788923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788949 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  788952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788971 */     GIR_RootConstrainSelectedInstOperands,
     /*  788972 */     // GIR_Coverage, 60436,
     /*  788972 */     GIR_EraseRootFromParent_Done,
     /*  788973 */   // Label 12313: @788973
     /*  788973 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(789048), // Rule ID 60437 //
     /*  788978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  788981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  788986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  788998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  789027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789046 */     GIR_RootConstrainSelectedInstOperands,
     /*  789047 */     // GIR_Coverage, 60437,
     /*  789047 */     GIR_EraseRootFromParent_Done,
     /*  789048 */   // Label 12314: @789048
     /*  789048 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(789123), // Rule ID 60440 //
     /*  789053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  789073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789099 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  789102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789121 */     GIR_RootConstrainSelectedInstOperands,
     /*  789122 */     // GIR_Coverage, 60440,
     /*  789122 */     GIR_EraseRootFromParent_Done,
     /*  789123 */   // Label 12315: @789123
     /*  789123 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(789198), // Rule ID 60441 //
     /*  789128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  789148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  789177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789196 */     GIR_RootConstrainSelectedInstOperands,
     /*  789197 */     // GIR_Coverage, 60441,
     /*  789197 */     GIR_EraseRootFromParent_Done,
     /*  789198 */   // Label 12316: @789198
     /*  789198 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(789273), // Rule ID 60444 //
     /*  789203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  789223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  789252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789271 */     GIR_RootConstrainSelectedInstOperands,
     /*  789272 */     // GIR_Coverage, 60444,
     /*  789272 */     GIR_EraseRootFromParent_Done,
     /*  789273 */   // Label 12317: @789273
     /*  789273 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(789348), // Rule ID 60445 //
     /*  789278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  789298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  789327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789346 */     GIR_RootConstrainSelectedInstOperands,
     /*  789347 */     // GIR_Coverage, 60445,
     /*  789347 */     GIR_EraseRootFromParent_Done,
     /*  789348 */   // Label 12318: @789348
     /*  789348 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(789423), // Rule ID 60448 //
     /*  789353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  789373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789399 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  789402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789421 */     GIR_RootConstrainSelectedInstOperands,
     /*  789422 */     // GIR_Coverage, 60448,
     /*  789422 */     GIR_EraseRootFromParent_Done,
     /*  789423 */   // Label 12319: @789423
     /*  789423 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(789498), // Rule ID 60449 //
     /*  789428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  789448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  789477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789496 */     GIR_RootConstrainSelectedInstOperands,
     /*  789497 */     // GIR_Coverage, 60449,
     /*  789497 */     GIR_EraseRootFromParent_Done,
     /*  789498 */   // Label 12320: @789498
     /*  789498 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(789573), // Rule ID 60452 //
     /*  789503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  789523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789549 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  789552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789571 */     GIR_RootConstrainSelectedInstOperands,
     /*  789572 */     // GIR_Coverage, 60452,
     /*  789572 */     GIR_EraseRootFromParent_Done,
     /*  789573 */   // Label 12321: @789573
     /*  789573 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(789648), // Rule ID 60453 //
     /*  789578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  789586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  789598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  789617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  789627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789646 */     GIR_RootConstrainSelectedInstOperands,
     /*  789647 */     // GIR_Coverage, 60453,
     /*  789647 */     GIR_EraseRootFromParent_Done,
     /*  789648 */   // Label 12322: @789648
     /*  789648 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(789723), // Rule ID 60456 //
     /*  789653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  789661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  789702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789721 */     GIR_RootConstrainSelectedInstOperands,
     /*  789722 */     // GIR_Coverage, 60456,
     /*  789722 */     GIR_EraseRootFromParent_Done,
     /*  789723 */   // Label 12323: @789723
     /*  789723 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(789798), // Rule ID 60457 //
     /*  789728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  789736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  789777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789796 */     GIR_RootConstrainSelectedInstOperands,
     /*  789797 */     // GIR_Coverage, 60457,
     /*  789797 */     GIR_EraseRootFromParent_Done,
     /*  789798 */   // Label 12324: @789798
     /*  789798 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(789873), // Rule ID 60460 //
     /*  789803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  789811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10861:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  789852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789871 */     GIR_RootConstrainSelectedInstOperands,
     /*  789872 */     // GIR_Coverage, 60460,
     /*  789872 */     GIR_EraseRootFromParent_Done,
     /*  789873 */   // Label 12325: @789873
     /*  789873 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(789948), // Rule ID 60461 //
     /*  789878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  789881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  789886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10861:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  789927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789946 */     GIR_RootConstrainSelectedInstOperands,
     /*  789947 */     // GIR_Coverage, 60461,
     /*  789947 */     GIR_EraseRootFromParent_Done,
     /*  789948 */   // Label 12326: @789948
     /*  789948 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(790023), // Rule ID 60464 //
     /*  789953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  789956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  789961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789999 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10861:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  790002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790021 */     GIR_RootConstrainSelectedInstOperands,
     /*  790022 */     // GIR_Coverage, 60464,
     /*  790022 */     GIR_EraseRootFromParent_Done,
     /*  790023 */   // Label 12327: @790023
     /*  790023 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(790098), // Rule ID 60465 //
     /*  790028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10861:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  790077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790096 */     GIR_RootConstrainSelectedInstOperands,
     /*  790097 */     // GIR_Coverage, 60465,
     /*  790097 */     GIR_EraseRootFromParent_Done,
     /*  790098 */   // Label 12328: @790098
     /*  790098 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(790173), // Rule ID 60468 //
     /*  790103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  790106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790149 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10861:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  790152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790171 */     GIR_RootConstrainSelectedInstOperands,
     /*  790172 */     // GIR_Coverage, 60468,
     /*  790172 */     GIR_EraseRootFromParent_Done,
     /*  790173 */   // Label 12329: @790173
     /*  790173 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(790248), // Rule ID 60469 //
     /*  790178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10861:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  790227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790246 */     GIR_RootConstrainSelectedInstOperands,
     /*  790247 */     // GIR_Coverage, 60469,
     /*  790247 */     GIR_EraseRootFromParent_Done,
     /*  790248 */   // Label 12330: @790248
     /*  790248 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(790323), // Rule ID 60472 //
     /*  790253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  790256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  790302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790321 */     GIR_RootConstrainSelectedInstOperands,
     /*  790322 */     // GIR_Coverage, 60472,
     /*  790322 */     GIR_EraseRootFromParent_Done,
     /*  790323 */   // Label 12331: @790323
     /*  790323 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(790398), // Rule ID 60473 //
     /*  790328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  790377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790396 */     GIR_RootConstrainSelectedInstOperands,
     /*  790397 */     // GIR_Coverage, 60473,
     /*  790397 */     GIR_EraseRootFromParent_Done,
     /*  790398 */   // Label 12332: @790398
     /*  790398 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(790473), // Rule ID 60476 //
     /*  790403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  790406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10861:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  790452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790471 */     GIR_RootConstrainSelectedInstOperands,
     /*  790472 */     // GIR_Coverage, 60476,
     /*  790472 */     GIR_EraseRootFromParent_Done,
     /*  790473 */   // Label 12333: @790473
     /*  790473 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(790548), // Rule ID 60477 //
     /*  790478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10861:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  790527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790546 */     GIR_RootConstrainSelectedInstOperands,
     /*  790547 */     // GIR_Coverage, 60477,
     /*  790547 */     GIR_EraseRootFromParent_Done,
     /*  790548 */   // Label 12334: @790548
     /*  790548 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(790623), // Rule ID 60480 //
     /*  790553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  790556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790599 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10861:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  790602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790621 */     GIR_RootConstrainSelectedInstOperands,
     /*  790622 */     // GIR_Coverage, 60480,
     /*  790622 */     GIR_EraseRootFromParent_Done,
     /*  790623 */   // Label 12335: @790623
     /*  790623 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(790698), // Rule ID 60481 //
     /*  790628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10861:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  790677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790696 */     GIR_RootConstrainSelectedInstOperands,
     /*  790697 */     // GIR_Coverage, 60481,
     /*  790697 */     GIR_EraseRootFromParent_Done,
     /*  790698 */   // Label 12336: @790698
     /*  790698 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(790773), // Rule ID 60484 //
     /*  790703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  790706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10861:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  790752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790771 */     GIR_RootConstrainSelectedInstOperands,
     /*  790772 */     // GIR_Coverage, 60484,
     /*  790772 */     GIR_EraseRootFromParent_Done,
     /*  790773 */   // Label 12337: @790773
     /*  790773 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(790848), // Rule ID 60485 //
     /*  790778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  790781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  790786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  790817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10861:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  790827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790846 */     GIR_RootConstrainSelectedInstOperands,
     /*  790847 */     // GIR_Coverage, 60485,
     /*  790847 */     GIR_EraseRootFromParent_Done,
     /*  790848 */   // Label 12338: @790848
     /*  790848 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(790923), // Rule ID 60488 //
     /*  790853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  790856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  790861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  790864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  790867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  790870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  790873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790899 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  790899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  790902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  790918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790921 */     GIR_RootConstrainSelectedInstOperands,
     /*  790922 */     // GIR_Coverage, 60488,
     /*  790922 */     GIR_EraseRootFromParent_Done,
     /*  790923 */   // Label 12339: @790923
     /*  790923 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(790998), // Rule ID 60489 //
     /*  790928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  790931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  790936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  790939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  790942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  790945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  790948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790974 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  790974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  790977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  790993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790996 */     GIR_RootConstrainSelectedInstOperands,
     /*  790997 */     // GIR_Coverage, 60489,
     /*  790997 */     GIR_EraseRootFromParent_Done,
     /*  790998 */   // Label 12340: @790998
     /*  790998 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(791073), // Rule ID 60492 //
     /*  791003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  791014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  791017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  791020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  791023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  791049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  791052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791071 */     GIR_RootConstrainSelectedInstOperands,
     /*  791072 */     // GIR_Coverage, 60492,
     /*  791072 */     GIR_EraseRootFromParent_Done,
     /*  791073 */   // Label 12341: @791073
     /*  791073 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(791148), // Rule ID 60493 //
     /*  791078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  791089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  791092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  791095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  791098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  791124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  791127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791146 */     GIR_RootConstrainSelectedInstOperands,
     /*  791147 */     // GIR_Coverage, 60493,
     /*  791147 */     GIR_EraseRootFromParent_Done,
     /*  791148 */   // Label 12342: @791148
     /*  791148 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(791223), // Rule ID 60496 //
     /*  791153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  791164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  791167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  791170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  791173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791199 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  791199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791221 */     GIR_RootConstrainSelectedInstOperands,
     /*  791222 */     // GIR_Coverage, 60496,
     /*  791222 */     GIR_EraseRootFromParent_Done,
     /*  791223 */   // Label 12343: @791223
     /*  791223 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(791298), // Rule ID 60497 //
     /*  791228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  791239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  791242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  791245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  791248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  791274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791296 */     GIR_RootConstrainSelectedInstOperands,
     /*  791297 */     // GIR_Coverage, 60497,
     /*  791297 */     GIR_EraseRootFromParent_Done,
     /*  791298 */   // Label 12344: @791298
     /*  791298 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(791373), // Rule ID 60500 //
     /*  791303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  791314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  791317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  791320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  791323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791349 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  791352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791371 */     GIR_RootConstrainSelectedInstOperands,
     /*  791372 */     // GIR_Coverage, 60500,
     /*  791372 */     GIR_EraseRootFromParent_Done,
     /*  791373 */   // Label 12345: @791373
     /*  791373 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(791448), // Rule ID 60501 //
     /*  791378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  791389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  791392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  791395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  791398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  791427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791446 */     GIR_RootConstrainSelectedInstOperands,
     /*  791447 */     // GIR_Coverage, 60501,
     /*  791447 */     GIR_EraseRootFromParent_Done,
     /*  791448 */   // Label 12346: @791448
     /*  791448 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(791523), // Rule ID 60504 //
     /*  791453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  791473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791521 */     GIR_RootConstrainSelectedInstOperands,
     /*  791522 */     // GIR_Coverage, 60504,
     /*  791522 */     GIR_EraseRootFromParent_Done,
     /*  791523 */   // Label 12347: @791523
     /*  791523 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(791598), // Rule ID 60505 //
     /*  791528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  791548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791574 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791596 */     GIR_RootConstrainSelectedInstOperands,
     /*  791597 */     // GIR_Coverage, 60505,
     /*  791597 */     GIR_EraseRootFromParent_Done,
     /*  791598 */   // Label 12348: @791598
     /*  791598 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(791673), // Rule ID 60508 //
     /*  791603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  791623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791649 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791671 */     GIR_RootConstrainSelectedInstOperands,
     /*  791672 */     // GIR_Coverage, 60508,
     /*  791672 */     GIR_EraseRootFromParent_Done,
     /*  791673 */   // Label 12349: @791673
     /*  791673 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(791748), // Rule ID 60509 //
     /*  791678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  791698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  791727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791746 */     GIR_RootConstrainSelectedInstOperands,
     /*  791747 */     // GIR_Coverage, 60509,
     /*  791747 */     GIR_EraseRootFromParent_Done,
     /*  791748 */   // Label 12350: @791748
     /*  791748 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(791823), // Rule ID 60512 //
     /*  791753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  791764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  791767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  791770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  791773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  791799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  791802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791821 */     GIR_RootConstrainSelectedInstOperands,
     /*  791822 */     // GIR_Coverage, 60512,
     /*  791822 */     GIR_EraseRootFromParent_Done,
     /*  791823 */   // Label 12351: @791823
     /*  791823 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(791898), // Rule ID 60513 //
     /*  791828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  791839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  791842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  791845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  791848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  791874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  791877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  791893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791896 */     GIR_RootConstrainSelectedInstOperands,
     /*  791897 */     // GIR_Coverage, 60513,
     /*  791897 */     GIR_EraseRootFromParent_Done,
     /*  791898 */   // Label 12352: @791898
     /*  791898 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(791973), // Rule ID 60516 //
     /*  791903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  791906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  791923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  791952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791971 */     GIR_RootConstrainSelectedInstOperands,
     /*  791972 */     // GIR_Coverage, 60516,
     /*  791972 */     GIR_EraseRootFromParent_Done,
     /*  791973 */   // Label 12353: @791973
     /*  791973 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(792048), // Rule ID 60517 //
     /*  791978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  791981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  791986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  791998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  792027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792046 */     GIR_RootConstrainSelectedInstOperands,
     /*  792047 */     // GIR_Coverage, 60517,
     /*  792047 */     GIR_EraseRootFromParent_Done,
     /*  792048 */   // Label 12354: @792048
     /*  792048 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(792123), // Rule ID 60520 //
     /*  792053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  792102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792121 */     GIR_RootConstrainSelectedInstOperands,
     /*  792122 */     // GIR_Coverage, 60520,
     /*  792122 */     GIR_EraseRootFromParent_Done,
     /*  792123 */   // Label 12355: @792123
     /*  792123 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(792198), // Rule ID 60521 //
     /*  792128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  792177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792196 */     GIR_RootConstrainSelectedInstOperands,
     /*  792197 */     // GIR_Coverage, 60521,
     /*  792197 */     GIR_EraseRootFromParent_Done,
     /*  792198 */   // Label 12356: @792198
     /*  792198 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(792273), // Rule ID 60524 //
     /*  792203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  792252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792271 */     GIR_RootConstrainSelectedInstOperands,
     /*  792272 */     // GIR_Coverage, 60524,
     /*  792272 */     GIR_EraseRootFromParent_Done,
     /*  792273 */   // Label 12357: @792273
     /*  792273 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(792348), // Rule ID 60525 //
     /*  792278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  792327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792346 */     GIR_RootConstrainSelectedInstOperands,
     /*  792347 */     // GIR_Coverage, 60525,
     /*  792347 */     GIR_EraseRootFromParent_Done,
     /*  792348 */   // Label 12358: @792348
     /*  792348 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(792423), // Rule ID 60528 //
     /*  792353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  792364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  792367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  792370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  792373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  792399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  792402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792421 */     GIR_RootConstrainSelectedInstOperands,
     /*  792422 */     // GIR_Coverage, 60528,
     /*  792422 */     GIR_EraseRootFromParent_Done,
     /*  792423 */   // Label 12359: @792423
     /*  792423 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(792498), // Rule ID 60529 //
     /*  792428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  792439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  792442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  792445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  792448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  792474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  792477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792496 */     GIR_RootConstrainSelectedInstOperands,
     /*  792497 */     // GIR_Coverage, 60529,
     /*  792497 */     GIR_EraseRootFromParent_Done,
     /*  792498 */   // Label 12360: @792498
     /*  792498 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(792573), // Rule ID 60532 //
     /*  792503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  792514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  792517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  792520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  792523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792549 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  792549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  792552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792571 */     GIR_RootConstrainSelectedInstOperands,
     /*  792572 */     // GIR_Coverage, 60532,
     /*  792572 */     GIR_EraseRootFromParent_Done,
     /*  792573 */   // Label 12361: @792573
     /*  792573 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(792648), // Rule ID 60533 //
     /*  792578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  792589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  792592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  792595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  792598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  792624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  792627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792646 */     GIR_RootConstrainSelectedInstOperands,
     /*  792647 */     // GIR_Coverage, 60533,
     /*  792647 */     GIR_EraseRootFromParent_Done,
     /*  792648 */   // Label 12362: @792648
     /*  792648 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(792723), // Rule ID 60536 //
     /*  792653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  792664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  792667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  792670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  792673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792699 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  792699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  792702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792721 */     GIR_RootConstrainSelectedInstOperands,
     /*  792722 */     // GIR_Coverage, 60536,
     /*  792722 */     GIR_EraseRootFromParent_Done,
     /*  792723 */   // Label 12363: @792723
     /*  792723 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(792798), // Rule ID 60537 //
     /*  792728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  792739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  792742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  792745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  792748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792774 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  792774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  792777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  792793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792796 */     GIR_RootConstrainSelectedInstOperands,
     /*  792797 */     // GIR_Coverage, 60537,
     /*  792797 */     GIR_EraseRootFromParent_Done,
     /*  792798 */   // Label 12364: @792798
     /*  792798 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(792873), // Rule ID 60540 //
     /*  792803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  792814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  792817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  792820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  792823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792849 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  792852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792871 */     GIR_RootConstrainSelectedInstOperands,
     /*  792872 */     // GIR_Coverage, 60540,
     /*  792872 */     GIR_EraseRootFromParent_Done,
     /*  792873 */   // Label 12365: @792873
     /*  792873 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(792948), // Rule ID 60541 //
     /*  792878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  792881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  792889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  792892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  792895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  792898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  792927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792946 */     GIR_RootConstrainSelectedInstOperands,
     /*  792947 */     // GIR_Coverage, 60541,
     /*  792947 */     GIR_EraseRootFromParent_Done,
     /*  792948 */   // Label 12366: @792948
     /*  792948 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(793023), // Rule ID 60544 //
     /*  792953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  792956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  792961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  792964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  792967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  792970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  792973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793021 */     GIR_RootConstrainSelectedInstOperands,
     /*  793022 */     // GIR_Coverage, 60544,
     /*  793022 */     GIR_EraseRootFromParent_Done,
     /*  793023 */   // Label 12367: @793023
     /*  793023 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(793098), // Rule ID 60545 //
     /*  793028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793096 */     GIR_RootConstrainSelectedInstOperands,
     /*  793097 */     // GIR_Coverage, 60545,
     /*  793097 */     GIR_EraseRootFromParent_Done,
     /*  793098 */   // Label 12368: @793098
     /*  793098 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(793173), // Rule ID 60548 //
     /*  793103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793149 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  793152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793171 */     GIR_RootConstrainSelectedInstOperands,
     /*  793172 */     // GIR_Coverage, 60548,
     /*  793172 */     GIR_EraseRootFromParent_Done,
     /*  793173 */   // Label 12369: @793173
     /*  793173 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(793248), // Rule ID 60549 //
     /*  793178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  793227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793246 */     GIR_RootConstrainSelectedInstOperands,
     /*  793247 */     // GIR_Coverage, 60549,
     /*  793247 */     GIR_EraseRootFromParent_Done,
     /*  793248 */   // Label 12370: @793248
     /*  793248 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(793323), // Rule ID 60552 //
     /*  793253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  793302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793321 */     GIR_RootConstrainSelectedInstOperands,
     /*  793322 */     // GIR_Coverage, 60552,
     /*  793322 */     GIR_EraseRootFromParent_Done,
     /*  793323 */   // Label 12371: @793323
     /*  793323 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(793398), // Rule ID 60553 //
     /*  793328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  793377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793396 */     GIR_RootConstrainSelectedInstOperands,
     /*  793397 */     // GIR_Coverage, 60553,
     /*  793397 */     GIR_EraseRootFromParent_Done,
     /*  793398 */   // Label 12372: @793398
     /*  793398 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(793473), // Rule ID 60556 //
     /*  793403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793471 */     GIR_RootConstrainSelectedInstOperands,
     /*  793472 */     // GIR_Coverage, 60556,
     /*  793472 */     GIR_EraseRootFromParent_Done,
     /*  793473 */   // Label 12373: @793473
     /*  793473 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(793548), // Rule ID 60557 //
     /*  793478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793546 */     GIR_RootConstrainSelectedInstOperands,
     /*  793547 */     // GIR_Coverage, 60557,
     /*  793547 */     GIR_EraseRootFromParent_Done,
     /*  793548 */   // Label 12374: @793548
     /*  793548 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(793623), // Rule ID 60560 //
     /*  793553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793599 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  793602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793621 */     GIR_RootConstrainSelectedInstOperands,
     /*  793622 */     // GIR_Coverage, 60560,
     /*  793622 */     GIR_EraseRootFromParent_Done,
     /*  793623 */   // Label 12375: @793623
     /*  793623 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(793698), // Rule ID 60561 //
     /*  793628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  793677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793696 */     GIR_RootConstrainSelectedInstOperands,
     /*  793697 */     // GIR_Coverage, 60561,
     /*  793697 */     GIR_EraseRootFromParent_Done,
     /*  793698 */   // Label 12376: @793698
     /*  793698 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(793773), // Rule ID 60564 //
     /*  793703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  793723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793749 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  793752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793771 */     GIR_RootConstrainSelectedInstOperands,
     /*  793772 */     // GIR_Coverage, 60564,
     /*  793772 */     GIR_EraseRootFromParent_Done,
     /*  793773 */   // Label 12377: @793773
     /*  793773 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(793848), // Rule ID 60565 //
     /*  793778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  793798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  793827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793846 */     GIR_RootConstrainSelectedInstOperands,
     /*  793847 */     // GIR_Coverage, 60565,
     /*  793847 */     GIR_EraseRootFromParent_Done,
     /*  793848 */   // Label 12378: @793848
     /*  793848 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(793923), // Rule ID 60568 //
     /*  793853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  793856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  793864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  793867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  793870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  793873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793899 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793921 */     GIR_RootConstrainSelectedInstOperands,
     /*  793922 */     // GIR_Coverage, 60568,
     /*  793922 */     GIR_EraseRootFromParent_Done,
     /*  793923 */   // Label 12379: @793923
     /*  793923 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(793998), // Rule ID 60569 //
     /*  793928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  793931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  793936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  793939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  793942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  793945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  793948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  793977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793996 */     GIR_RootConstrainSelectedInstOperands,
     /*  793997 */     // GIR_Coverage, 60569,
     /*  793997 */     GIR_EraseRootFromParent_Done,
     /*  793998 */   // Label 12380: @793998
     /*  793998 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(794073), // Rule ID 60572 //
     /*  794003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794049 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  794052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794071 */     GIR_RootConstrainSelectedInstOperands,
     /*  794072 */     // GIR_Coverage, 60572,
     /*  794072 */     GIR_EraseRootFromParent_Done,
     /*  794073 */   // Label 12381: @794073
     /*  794073 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(794148), // Rule ID 60573 //
     /*  794078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  794127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794146 */     GIR_RootConstrainSelectedInstOperands,
     /*  794147 */     // GIR_Coverage, 60573,
     /*  794147 */     GIR_EraseRootFromParent_Done,
     /*  794148 */   // Label 12382: @794148
     /*  794148 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(794223), // Rule ID 60576 //
     /*  794153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  794164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  794167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  794170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794199 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  794199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  794202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794221 */     GIR_RootConstrainSelectedInstOperands,
     /*  794222 */     // GIR_Coverage, 60576,
     /*  794222 */     GIR_EraseRootFromParent_Done,
     /*  794223 */   // Label 12383: @794223
     /*  794223 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(794298), // Rule ID 60577 //
     /*  794228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  794239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  794242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  794245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  794274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  794277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794296 */     GIR_RootConstrainSelectedInstOperands,
     /*  794297 */     // GIR_Coverage, 60577,
     /*  794297 */     GIR_EraseRootFromParent_Done,
     /*  794298 */   // Label 12384: @794298
     /*  794298 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(794373), // Rule ID 60580 //
     /*  794303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  794314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  794317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  794320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794349 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  794349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  794352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794371 */     GIR_RootConstrainSelectedInstOperands,
     /*  794372 */     // GIR_Coverage, 60580,
     /*  794372 */     GIR_EraseRootFromParent_Done,
     /*  794373 */   // Label 12385: @794373
     /*  794373 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(794448), // Rule ID 60581 //
     /*  794378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  794389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  794392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  794395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794424 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  794424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  794427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794446 */     GIR_RootConstrainSelectedInstOperands,
     /*  794447 */     // GIR_Coverage, 60581,
     /*  794447 */     GIR_EraseRootFromParent_Done,
     /*  794448 */   // Label 12386: @794448
     /*  794448 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(794523), // Rule ID 60584 //
     /*  794453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  794464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  794467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  794470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794499 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  794499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  794502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794521 */     GIR_RootConstrainSelectedInstOperands,
     /*  794522 */     // GIR_Coverage, 60584,
     /*  794522 */     GIR_EraseRootFromParent_Done,
     /*  794523 */   // Label 12387: @794523
     /*  794523 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(794598), // Rule ID 60585 //
     /*  794528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  794539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  794542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  794545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  794574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  794577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  794593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794596 */     GIR_RootConstrainSelectedInstOperands,
     /*  794597 */     // GIR_Coverage, 60585,
     /*  794597 */     GIR_EraseRootFromParent_Done,
     /*  794598 */   // Label 12388: @794598
     /*  794598 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(794673), // Rule ID 60588 //
     /*  794603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794649 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  794652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794671 */     GIR_RootConstrainSelectedInstOperands,
     /*  794672 */     // GIR_Coverage, 60588,
     /*  794672 */     GIR_EraseRootFromParent_Done,
     /*  794673 */   // Label 12389: @794673
     /*  794673 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(794748), // Rule ID 60589 //
     /*  794678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  794727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794746 */     GIR_RootConstrainSelectedInstOperands,
     /*  794747 */     // GIR_Coverage, 60589,
     /*  794747 */     GIR_EraseRootFromParent_Done,
     /*  794748 */   // Label 12390: @794748
     /*  794748 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(794823), // Rule ID 60592 //
     /*  794753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794799 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  794802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794821 */     GIR_RootConstrainSelectedInstOperands,
     /*  794822 */     // GIR_Coverage, 60592,
     /*  794822 */     GIR_EraseRootFromParent_Done,
     /*  794823 */   // Label 12391: @794823
     /*  794823 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(794898), // Rule ID 60593 //
     /*  794828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  794877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794896 */     GIR_RootConstrainSelectedInstOperands,
     /*  794897 */     // GIR_Coverage, 60593,
     /*  794897 */     GIR_EraseRootFromParent_Done,
     /*  794898 */   // Label 12392: @794898
     /*  794898 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(794973), // Rule ID 60596 //
     /*  794903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  794906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  794923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  794942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  794952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794971 */     GIR_RootConstrainSelectedInstOperands,
     /*  794972 */     // GIR_Coverage, 60596,
     /*  794972 */     GIR_EraseRootFromParent_Done,
     /*  794973 */   // Label 12393: @794973
     /*  794973 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(795048), // Rule ID 60597 //
     /*  794978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  794981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  794986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  795027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795046 */     GIR_RootConstrainSelectedInstOperands,
     /*  795047 */     // GIR_Coverage, 60597,
     /*  795047 */     GIR_EraseRootFromParent_Done,
     /*  795048 */   // Label 12394: @795048
     /*  795048 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(795123), // Rule ID 60600 //
     /*  795053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  795064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  795067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  795070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  795099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795121 */     GIR_RootConstrainSelectedInstOperands,
     /*  795122 */     // GIR_Coverage, 60600,
     /*  795122 */     GIR_EraseRootFromParent_Done,
     /*  795123 */   // Label 12395: @795123
     /*  795123 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(795198), // Rule ID 60601 //
     /*  795128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  795139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  795142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  795145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10849:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  795174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795196 */     GIR_RootConstrainSelectedInstOperands,
     /*  795197 */     // GIR_Coverage, 60601,
     /*  795197 */     GIR_EraseRootFromParent_Done,
     /*  795198 */   // Label 12396: @795198
     /*  795198 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(795273), // Rule ID 60604 //
     /*  795203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795271 */     GIR_RootConstrainSelectedInstOperands,
     /*  795272 */     // GIR_Coverage, 60604,
     /*  795272 */     GIR_EraseRootFromParent_Done,
     /*  795273 */   // Label 12397: @795273
     /*  795273 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(795348), // Rule ID 60605 //
     /*  795278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795346 */     GIR_RootConstrainSelectedInstOperands,
     /*  795347 */     // GIR_Coverage, 60605,
     /*  795347 */     GIR_EraseRootFromParent_Done,
     /*  795348 */   // Label 12398: @795348
     /*  795348 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(795423), // Rule ID 60608 //
     /*  795353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795421 */     GIR_RootConstrainSelectedInstOperands,
     /*  795422 */     // GIR_Coverage, 60608,
     /*  795422 */     GIR_EraseRootFromParent_Done,
     /*  795423 */   // Label 12399: @795423
     /*  795423 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(795498), // Rule ID 60609 //
     /*  795428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795496 */     GIR_RootConstrainSelectedInstOperands,
     /*  795497 */     // GIR_Coverage, 60609,
     /*  795497 */     GIR_EraseRootFromParent_Done,
     /*  795498 */   // Label 12400: @795498
     /*  795498 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(795573), // Rule ID 60612 //
     /*  795503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795571 */     GIR_RootConstrainSelectedInstOperands,
     /*  795572 */     // GIR_Coverage, 60612,
     /*  795572 */     GIR_EraseRootFromParent_Done,
     /*  795573 */   // Label 12401: @795573
     /*  795573 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(795648), // Rule ID 60613 //
     /*  795578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  795627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795646 */     GIR_RootConstrainSelectedInstOperands,
     /*  795647 */     // GIR_Coverage, 60613,
     /*  795647 */     GIR_EraseRootFromParent_Done,
     /*  795648 */   // Label 12402: @795648
     /*  795648 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(795723), // Rule ID 60616 //
     /*  795653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  795664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  795667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  795670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  795699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  795702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795721 */     GIR_RootConstrainSelectedInstOperands,
     /*  795722 */     // GIR_Coverage, 60616,
     /*  795722 */     GIR_EraseRootFromParent_Done,
     /*  795723 */   // Label 12403: @795723
     /*  795723 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(795798), // Rule ID 60617 //
     /*  795728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  795739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  795742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  795745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  795774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  795777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795796 */     GIR_RootConstrainSelectedInstOperands,
     /*  795797 */     // GIR_Coverage, 60617,
     /*  795797 */     GIR_EraseRootFromParent_Done,
     /*  795798 */   // Label 12404: @795798
     /*  795798 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(795873), // Rule ID 60620 //
     /*  795803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  795814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  795817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  795820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  795849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  795852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795871 */     GIR_RootConstrainSelectedInstOperands,
     /*  795872 */     // GIR_Coverage, 60620,
     /*  795872 */     GIR_EraseRootFromParent_Done,
     /*  795873 */   // Label 12405: @795873
     /*  795873 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(795948), // Rule ID 60621 //
     /*  795878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  795881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  795889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  795892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  795895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  795924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  795927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  795943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795946 */     GIR_RootConstrainSelectedInstOperands,
     /*  795947 */     // GIR_Coverage, 60621,
     /*  795947 */     GIR_EraseRootFromParent_Done,
     /*  795948 */   // Label 12406: @795948
     /*  795948 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(796023), // Rule ID 60624 //
     /*  795953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  795956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  795961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  795964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  795967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  795970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  795992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795999 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  795999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  796018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796021 */     GIR_RootConstrainSelectedInstOperands,
     /*  796022 */     // GIR_Coverage, 60624,
     /*  796022 */     GIR_EraseRootFromParent_Done,
     /*  796023 */   // Label 12407: @796023
     /*  796023 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(796098), // Rule ID 60625 //
     /*  796028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  796039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  796042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  796045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796074 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  796074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  796093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796096 */     GIR_RootConstrainSelectedInstOperands,
     /*  796097 */     // GIR_Coverage, 60625,
     /*  796097 */     GIR_EraseRootFromParent_Done,
     /*  796098 */   // Label 12408: @796098
     /*  796098 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(796173), // Rule ID 60628 //
     /*  796103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796149 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  796152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796171 */     GIR_RootConstrainSelectedInstOperands,
     /*  796172 */     // GIR_Coverage, 60628,
     /*  796172 */     GIR_EraseRootFromParent_Done,
     /*  796173 */   // Label 12409: @796173
     /*  796173 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(796248), // Rule ID 60629 //
     /*  796178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  796227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796246 */     GIR_RootConstrainSelectedInstOperands,
     /*  796247 */     // GIR_Coverage, 60629,
     /*  796247 */     GIR_EraseRootFromParent_Done,
     /*  796248 */   // Label 12410: @796248
     /*  796248 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(796323), // Rule ID 60632 //
     /*  796253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796299 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  796302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796321 */     GIR_RootConstrainSelectedInstOperands,
     /*  796322 */     // GIR_Coverage, 60632,
     /*  796322 */     GIR_EraseRootFromParent_Done,
     /*  796323 */   // Label 12411: @796323
     /*  796323 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(796398), // Rule ID 60633 //
     /*  796328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  796377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796396 */     GIR_RootConstrainSelectedInstOperands,
     /*  796397 */     // GIR_Coverage, 60633,
     /*  796397 */     GIR_EraseRootFromParent_Done,
     /*  796398 */   // Label 12412: @796398
     /*  796398 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(796473), // Rule ID 60636 //
     /*  796403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796449 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796471 */     GIR_RootConstrainSelectedInstOperands,
     /*  796472 */     // GIR_Coverage, 60636,
     /*  796472 */     GIR_EraseRootFromParent_Done,
     /*  796473 */   // Label 12413: @796473
     /*  796473 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(796548), // Rule ID 60637 //
     /*  796478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796546 */     GIR_RootConstrainSelectedInstOperands,
     /*  796547 */     // GIR_Coverage, 60637,
     /*  796547 */     GIR_EraseRootFromParent_Done,
     /*  796548 */   // Label 12414: @796548
     /*  796548 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(796623), // Rule ID 60640 //
     /*  796553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  796602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796621 */     GIR_RootConstrainSelectedInstOperands,
     /*  796622 */     // GIR_Coverage, 60640,
     /*  796622 */     GIR_EraseRootFromParent_Done,
     /*  796623 */   // Label 12415: @796623
     /*  796623 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(796698), // Rule ID 60641 //
     /*  796628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  796677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796696 */     GIR_RootConstrainSelectedInstOperands,
     /*  796697 */     // GIR_Coverage, 60641,
     /*  796697 */     GIR_EraseRootFromParent_Done,
     /*  796698 */   // Label 12416: @796698
     /*  796698 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(796773), // Rule ID 60644 //
     /*  796703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796749 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  796752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796771 */     GIR_RootConstrainSelectedInstOperands,
     /*  796772 */     // GIR_Coverage, 60644,
     /*  796772 */     GIR_EraseRootFromParent_Done,
     /*  796773 */   // Label 12417: @796773
     /*  796773 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(796848), // Rule ID 60645 //
     /*  796778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  796827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796846 */     GIR_RootConstrainSelectedInstOperands,
     /*  796847 */     // GIR_Coverage, 60645,
     /*  796847 */     GIR_EraseRootFromParent_Done,
     /*  796848 */   // Label 12418: @796848
     /*  796848 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(796923), // Rule ID 60648 //
     /*  796853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  796856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796899 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796921 */     GIR_RootConstrainSelectedInstOperands,
     /*  796922 */     // GIR_Coverage, 60648,
     /*  796922 */     GIR_EraseRootFromParent_Done,
     /*  796923 */   // Label 12419: @796923
     /*  796923 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(796998), // Rule ID 60649 //
     /*  796928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  796931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  796936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  796967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  796977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796996 */     GIR_RootConstrainSelectedInstOperands,
     /*  796997 */     // GIR_Coverage, 60649,
     /*  796997 */     GIR_EraseRootFromParent_Done,
     /*  796998 */   // Label 12420: @796998
     /*  796998 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(797073), // Rule ID 60652 //
     /*  797003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  797052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797071 */     GIR_RootConstrainSelectedInstOperands,
     /*  797072 */     // GIR_Coverage, 60652,
     /*  797072 */     GIR_EraseRootFromParent_Done,
     /*  797073 */   // Label 12421: @797073
     /*  797073 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(797148), // Rule ID 60653 //
     /*  797078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  797127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797146 */     GIR_RootConstrainSelectedInstOperands,
     /*  797147 */     // GIR_Coverage, 60653,
     /*  797147 */     GIR_EraseRootFromParent_Done,
     /*  797148 */   // Label 12422: @797148
     /*  797148 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(797223), // Rule ID 60656 //
     /*  797153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  797202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797221 */     GIR_RootConstrainSelectedInstOperands,
     /*  797222 */     // GIR_Coverage, 60656,
     /*  797222 */     GIR_EraseRootFromParent_Done,
     /*  797223 */   // Label 12423: @797223
     /*  797223 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(797298), // Rule ID 60657 //
     /*  797228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  797277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797296 */     GIR_RootConstrainSelectedInstOperands,
     /*  797297 */     // GIR_Coverage, 60657,
     /*  797297 */     GIR_EraseRootFromParent_Done,
     /*  797298 */   // Label 12424: @797298
     /*  797298 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(797373), // Rule ID 60660 //
     /*  797303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  797352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797371 */     GIR_RootConstrainSelectedInstOperands,
     /*  797372 */     // GIR_Coverage, 60660,
     /*  797372 */     GIR_EraseRootFromParent_Done,
     /*  797373 */   // Label 12425: @797373
     /*  797373 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(797448), // Rule ID 60661 //
     /*  797378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  797386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  797417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  797427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797446 */     GIR_RootConstrainSelectedInstOperands,
     /*  797447 */     // GIR_Coverage, 60661,
     /*  797447 */     GIR_EraseRootFromParent_Done,
     /*  797448 */   // Label 12426: @797448
     /*  797448 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(797523), // Rule ID 60840 //
     /*  797453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  797464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  797467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  797470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  797473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797499 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  797499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  797502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797521 */     GIR_RootConstrainSelectedInstOperands,
     /*  797522 */     // GIR_Coverage, 60840,
     /*  797522 */     GIR_EraseRootFromParent_Done,
     /*  797523 */   // Label 12427: @797523
     /*  797523 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(797598), // Rule ID 60841 //
     /*  797528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  797539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  797542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  797545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  797548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797574 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  797574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  797577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797596 */     GIR_RootConstrainSelectedInstOperands,
     /*  797597 */     // GIR_Coverage, 60841,
     /*  797597 */     GIR_EraseRootFromParent_Done,
     /*  797598 */   // Label 12428: @797598
     /*  797598 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(797673), // Rule ID 60844 //
     /*  797603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  797614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  797617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  797620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  797623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797649 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  797649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  797652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797671 */     GIR_RootConstrainSelectedInstOperands,
     /*  797672 */     // GIR_Coverage, 60844,
     /*  797672 */     GIR_EraseRootFromParent_Done,
     /*  797673 */   // Label 12429: @797673
     /*  797673 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(797748), // Rule ID 60845 //
     /*  797678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  797689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  797692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  797695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  797698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797724 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  797724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  797727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797746 */     GIR_RootConstrainSelectedInstOperands,
     /*  797747 */     // GIR_Coverage, 60845,
     /*  797747 */     GIR_EraseRootFromParent_Done,
     /*  797748 */   // Label 12430: @797748
     /*  797748 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(797823), // Rule ID 60848 //
     /*  797753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  797764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  797767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  797770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  797773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797799 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  797799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  797802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797821 */     GIR_RootConstrainSelectedInstOperands,
     /*  797822 */     // GIR_Coverage, 60848,
     /*  797822 */     GIR_EraseRootFromParent_Done,
     /*  797823 */   // Label 12431: @797823
     /*  797823 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(797898), // Rule ID 60849 //
     /*  797828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  797839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  797842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  797845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  797848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  797874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  797877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  797893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797896 */     GIR_RootConstrainSelectedInstOperands,
     /*  797897 */     // GIR_Coverage, 60849,
     /*  797897 */     GIR_EraseRootFromParent_Done,
     /*  797898 */   // Label 12432: @797898
     /*  797898 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(797973), // Rule ID 60852 //
     /*  797903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  797906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797949 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  797952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797971 */     GIR_RootConstrainSelectedInstOperands,
     /*  797972 */     // GIR_Coverage, 60852,
     /*  797972 */     GIR_EraseRootFromParent_Done,
     /*  797973 */   // Label 12433: @797973
     /*  797973 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(798048), // Rule ID 60853 //
     /*  797978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  797981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  797986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  798027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798046 */     GIR_RootConstrainSelectedInstOperands,
     /*  798047 */     // GIR_Coverage, 60853,
     /*  798047 */     GIR_EraseRootFromParent_Done,
     /*  798048 */   // Label 12434: @798048
     /*  798048 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(798123), // Rule ID 60856 //
     /*  798053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  798064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  798067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  798070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  798073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798099 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  798102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798121 */     GIR_RootConstrainSelectedInstOperands,
     /*  798122 */     // GIR_Coverage, 60856,
     /*  798122 */     GIR_EraseRootFromParent_Done,
     /*  798123 */   // Label 12435: @798123
     /*  798123 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(798198), // Rule ID 60857 //
     /*  798128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  798139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  798142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  798145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  798148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  798177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798196 */     GIR_RootConstrainSelectedInstOperands,
     /*  798197 */     // GIR_Coverage, 60857,
     /*  798197 */     GIR_EraseRootFromParent_Done,
     /*  798198 */   // Label 12436: @798198
     /*  798198 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(798273), // Rule ID 60860 //
     /*  798203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  798252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798271 */     GIR_RootConstrainSelectedInstOperands,
     /*  798272 */     // GIR_Coverage, 60860,
     /*  798272 */     GIR_EraseRootFromParent_Done,
     /*  798273 */   // Label 12437: @798273
     /*  798273 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(798348), // Rule ID 60861 //
     /*  798278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  798327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798346 */     GIR_RootConstrainSelectedInstOperands,
     /*  798347 */     // GIR_Coverage, 60861,
     /*  798347 */     GIR_EraseRootFromParent_Done,
     /*  798348 */   // Label 12438: @798348
     /*  798348 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(798423), // Rule ID 60864 //
     /*  798353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  798364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  798367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  798370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  798373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  798399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  798418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798421 */     GIR_RootConstrainSelectedInstOperands,
     /*  798422 */     // GIR_Coverage, 60864,
     /*  798422 */     GIR_EraseRootFromParent_Done,
     /*  798423 */   // Label 12439: @798423
     /*  798423 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(798498), // Rule ID 60865 //
     /*  798428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  798439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  798442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  798445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  798448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  798474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  798493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798496 */     GIR_RootConstrainSelectedInstOperands,
     /*  798497 */     // GIR_Coverage, 60865,
     /*  798497 */     GIR_EraseRootFromParent_Done,
     /*  798498 */   // Label 12440: @798498
     /*  798498 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(798573), // Rule ID 60868 //
     /*  798503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798571 */     GIR_RootConstrainSelectedInstOperands,
     /*  798572 */     // GIR_Coverage, 60868,
     /*  798572 */     GIR_EraseRootFromParent_Done,
     /*  798573 */   // Label 12441: @798573
     /*  798573 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(798648), // Rule ID 60869 //
     /*  798578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798646 */     GIR_RootConstrainSelectedInstOperands,
     /*  798647 */     // GIR_Coverage, 60869,
     /*  798647 */     GIR_EraseRootFromParent_Done,
     /*  798648 */   // Label 12442: @798648
     /*  798648 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(798723), // Rule ID 60872 //
     /*  798653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798721 */     GIR_RootConstrainSelectedInstOperands,
     /*  798722 */     // GIR_Coverage, 60872,
     /*  798722 */     GIR_EraseRootFromParent_Done,
     /*  798723 */   // Label 12443: @798723
     /*  798723 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(798798), // Rule ID 60873 //
     /*  798728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798796 */     GIR_RootConstrainSelectedInstOperands,
     /*  798797 */     // GIR_Coverage, 60873,
     /*  798797 */     GIR_EraseRootFromParent_Done,
     /*  798798 */   // Label 12444: @798798
     /*  798798 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(798873), // Rule ID 60876 //
     /*  798803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798871 */     GIR_RootConstrainSelectedInstOperands,
     /*  798872 */     // GIR_Coverage, 60876,
     /*  798872 */     GIR_EraseRootFromParent_Done,
     /*  798873 */   // Label 12445: @798873
     /*  798873 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(798948), // Rule ID 60877 //
     /*  798878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  798881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  798927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798946 */     GIR_RootConstrainSelectedInstOperands,
     /*  798947 */     // GIR_Coverage, 60877,
     /*  798947 */     GIR_EraseRootFromParent_Done,
     /*  798948 */   // Label 12446: @798948
     /*  798948 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(799023), // Rule ID 60880 //
     /*  798953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  798956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  798961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  798964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  798967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  798970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  798973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  798999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799021 */     GIR_RootConstrainSelectedInstOperands,
     /*  799022 */     // GIR_Coverage, 60880,
     /*  799022 */     GIR_EraseRootFromParent_Done,
     /*  799023 */   // Label 12447: @799023
     /*  799023 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(799098), // Rule ID 60881 //
     /*  799028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  799039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  799042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  799045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  799048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  799074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799096 */     GIR_RootConstrainSelectedInstOperands,
     /*  799097 */     // GIR_Coverage, 60881,
     /*  799097 */     GIR_EraseRootFromParent_Done,
     /*  799098 */   // Label 12448: @799098
     /*  799098 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(799173), // Rule ID 60884 //
     /*  799103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  799114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  799117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  799120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  799123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799149 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  799149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  799152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799171 */     GIR_RootConstrainSelectedInstOperands,
     /*  799172 */     // GIR_Coverage, 60884,
     /*  799172 */     GIR_EraseRootFromParent_Done,
     /*  799173 */   // Label 12449: @799173
     /*  799173 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(799248), // Rule ID 60885 //
     /*  799178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  799189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  799192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  799195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  799198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  799224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  799227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799246 */     GIR_RootConstrainSelectedInstOperands,
     /*  799247 */     // GIR_Coverage, 60885,
     /*  799247 */     GIR_EraseRootFromParent_Done,
     /*  799248 */   // Label 12450: @799248
     /*  799248 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(799323), // Rule ID 60888 //
     /*  799253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  799264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  799267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  799270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  799273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799299 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  799299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  799302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799321 */     GIR_RootConstrainSelectedInstOperands,
     /*  799322 */     // GIR_Coverage, 60888,
     /*  799322 */     GIR_EraseRootFromParent_Done,
     /*  799323 */   // Label 12451: @799323
     /*  799323 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(799398), // Rule ID 60889 //
     /*  799328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  799339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  799342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  799345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  799348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799374 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  799374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  799377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  799393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799396 */     GIR_RootConstrainSelectedInstOperands,
     /*  799397 */     // GIR_Coverage, 60889,
     /*  799397 */     GIR_EraseRootFromParent_Done,
     /*  799398 */   // Label 12452: @799398
     /*  799398 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(799473), // Rule ID 60892 //
     /*  799403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  799423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799471 */     GIR_RootConstrainSelectedInstOperands,
     /*  799472 */     // GIR_Coverage, 60892,
     /*  799472 */     GIR_EraseRootFromParent_Done,
     /*  799473 */   // Label 12453: @799473
     /*  799473 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(799548), // Rule ID 60893 //
     /*  799478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  799498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799546 */     GIR_RootConstrainSelectedInstOperands,
     /*  799547 */     // GIR_Coverage, 60893,
     /*  799547 */     GIR_EraseRootFromParent_Done,
     /*  799548 */   // Label 12454: @799548
     /*  799548 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(799623), // Rule ID 60896 //
     /*  799553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  799573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  799602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799621 */     GIR_RootConstrainSelectedInstOperands,
     /*  799622 */     // GIR_Coverage, 60896,
     /*  799622 */     GIR_EraseRootFromParent_Done,
     /*  799623 */   // Label 12455: @799623
     /*  799623 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(799698), // Rule ID 60897 //
     /*  799628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  799648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  799677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799696 */     GIR_RootConstrainSelectedInstOperands,
     /*  799697 */     // GIR_Coverage, 60897,
     /*  799697 */     GIR_EraseRootFromParent_Done,
     /*  799698 */   // Label 12456: @799698
     /*  799698 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(799773), // Rule ID 60900 //
     /*  799703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  799714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  799717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  799720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  799723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799749 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  799752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799771 */     GIR_RootConstrainSelectedInstOperands,
     /*  799772 */     // GIR_Coverage, 60900,
     /*  799772 */     GIR_EraseRootFromParent_Done,
     /*  799773 */   // Label 12457: @799773
     /*  799773 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(799848), // Rule ID 60901 //
     /*  799778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  799789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  799792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  799795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  799798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  799827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799846 */     GIR_RootConstrainSelectedInstOperands,
     /*  799847 */     // GIR_Coverage, 60901,
     /*  799847 */     GIR_EraseRootFromParent_Done,
     /*  799848 */   // Label 12458: @799848
     /*  799848 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(799923), // Rule ID 60904 //
     /*  799853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  799856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799921 */     GIR_RootConstrainSelectedInstOperands,
     /*  799922 */     // GIR_Coverage, 60904,
     /*  799922 */     GIR_EraseRootFromParent_Done,
     /*  799923 */   // Label 12459: @799923
     /*  799923 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(799998), // Rule ID 60905 //
     /*  799928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  799931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  799936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  799977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799996 */     GIR_RootConstrainSelectedInstOperands,
     /*  799997 */     // GIR_Coverage, 60905,
     /*  799997 */     GIR_EraseRootFromParent_Done,
     /*  799998 */   // Label 12460: @799998
     /*  799998 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(800073), // Rule ID 60908 //
     /*  800003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  800023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800049 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  800052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800071 */     GIR_RootConstrainSelectedInstOperands,
     /*  800072 */     // GIR_Coverage, 60908,
     /*  800072 */     GIR_EraseRootFromParent_Done,
     /*  800073 */   // Label 12461: @800073
     /*  800073 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(800148), // Rule ID 60909 //
     /*  800078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  800098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  800127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800146 */     GIR_RootConstrainSelectedInstOperands,
     /*  800147 */     // GIR_Coverage, 60909,
     /*  800147 */     GIR_EraseRootFromParent_Done,
     /*  800148 */   // Label 12462: @800148
     /*  800148 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(800223), // Rule ID 60912 //
     /*  800153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  800173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800199 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  800202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800221 */     GIR_RootConstrainSelectedInstOperands,
     /*  800222 */     // GIR_Coverage, 60912,
     /*  800222 */     GIR_EraseRootFromParent_Done,
     /*  800223 */   // Label 12463: @800223
     /*  800223 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(800298), // Rule ID 60913 //
     /*  800228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  800248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  800277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800296 */     GIR_RootConstrainSelectedInstOperands,
     /*  800297 */     // GIR_Coverage, 60913,
     /*  800297 */     GIR_EraseRootFromParent_Done,
     /*  800298 */   // Label 12464: @800298
     /*  800298 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(800373), // Rule ID 60916 //
     /*  800303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  800323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  800352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800371 */     GIR_RootConstrainSelectedInstOperands,
     /*  800372 */     // GIR_Coverage, 60916,
     /*  800372 */     GIR_EraseRootFromParent_Done,
     /*  800373 */   // Label 12465: @800373
     /*  800373 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(800448), // Rule ID 60917 //
     /*  800378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  800398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  800427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800446 */     GIR_RootConstrainSelectedInstOperands,
     /*  800447 */     // GIR_Coverage, 60917,
     /*  800447 */     GIR_EraseRootFromParent_Done,
     /*  800448 */   // Label 12466: @800448
     /*  800448 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(800523), // Rule ID 60920 //
     /*  800453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  800473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800499 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  800502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800521 */     GIR_RootConstrainSelectedInstOperands,
     /*  800522 */     // GIR_Coverage, 60920,
     /*  800522 */     GIR_EraseRootFromParent_Done,
     /*  800523 */   // Label 12467: @800523
     /*  800523 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(800598), // Rule ID 60921 //
     /*  800528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  800548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  800577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800596 */     GIR_RootConstrainSelectedInstOperands,
     /*  800597 */     // GIR_Coverage, 60921,
     /*  800597 */     GIR_EraseRootFromParent_Done,
     /*  800598 */   // Label 12468: @800598
     /*  800598 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(800673), // Rule ID 60924 //
     /*  800603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  800614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  800617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  800620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  800623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800649 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  800652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800671 */     GIR_RootConstrainSelectedInstOperands,
     /*  800672 */     // GIR_Coverage, 60924,
     /*  800672 */     GIR_EraseRootFromParent_Done,
     /*  800673 */   // Label 12469: @800673
     /*  800673 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(800748), // Rule ID 60925 //
     /*  800678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  800689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  800692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  800695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  800698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  800727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800746 */     GIR_RootConstrainSelectedInstOperands,
     /*  800747 */     // GIR_Coverage, 60925,
     /*  800747 */     GIR_EraseRootFromParent_Done,
     /*  800748 */   // Label 12470: @800748
     /*  800748 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(800823), // Rule ID 60928 //
     /*  800753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  800764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  800767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  800770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  800792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800799 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  800799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  800802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  800818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800821 */     GIR_RootConstrainSelectedInstOperands,
     /*  800822 */     // GIR_Coverage, 60928,
     /*  800822 */     GIR_EraseRootFromParent_Done,
     /*  800823 */   // Label 12471: @800823
     /*  800823 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(800898), // Rule ID 60929 //
     /*  800828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  800839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  800842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  800845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  800867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800874 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  800874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  800877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  800893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800896 */     GIR_RootConstrainSelectedInstOperands,
     /*  800897 */     // GIR_Coverage, 60929,
     /*  800897 */     GIR_EraseRootFromParent_Done,
     /*  800898 */   // Label 12472: @800898
     /*  800898 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(800973), // Rule ID 60932 //
     /*  800903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  800906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  800914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  800917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  800920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  800942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800949 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  800949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  800952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  800968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800971 */     GIR_RootConstrainSelectedInstOperands,
     /*  800972 */     // GIR_Coverage, 60932,
     /*  800972 */     GIR_EraseRootFromParent_Done,
     /*  800973 */   // Label 12473: @800973
     /*  800973 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(801048), // Rule ID 60933 //
     /*  800978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  800981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  800986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  800989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  800992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  800995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  801024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  801027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  801043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801046 */     GIR_RootConstrainSelectedInstOperands,
     /*  801047 */     // GIR_Coverage, 60933,
     /*  801047 */     GIR_EraseRootFromParent_Done,
     /*  801048 */   // Label 12474: @801048
     /*  801048 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(801123), // Rule ID 60936 //
     /*  801053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  801064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  801067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  801070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801099 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  801099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  801118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801121 */     GIR_RootConstrainSelectedInstOperands,
     /*  801122 */     // GIR_Coverage, 60936,
     /*  801122 */     GIR_EraseRootFromParent_Done,
     /*  801123 */   // Label 12475: @801123
     /*  801123 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(801198), // Rule ID 60937 //
     /*  801128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  801139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  801142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  801145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  801174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  801193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801196 */     GIR_RootConstrainSelectedInstOperands,
     /*  801197 */     // GIR_Coverage, 60937,
     /*  801197 */     GIR_EraseRootFromParent_Done,
     /*  801198 */   // Label 12476: @801198
     /*  801198 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(801273), // Rule ID 60940 //
     /*  801203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  801252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801271 */     GIR_RootConstrainSelectedInstOperands,
     /*  801272 */     // GIR_Coverage, 60940,
     /*  801272 */     GIR_EraseRootFromParent_Done,
     /*  801273 */   // Label 12477: @801273
     /*  801273 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(801348), // Rule ID 60941 //
     /*  801278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  801327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801346 */     GIR_RootConstrainSelectedInstOperands,
     /*  801347 */     // GIR_Coverage, 60941,
     /*  801347 */     GIR_EraseRootFromParent_Done,
     /*  801348 */   // Label 12478: @801348
     /*  801348 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(801423), // Rule ID 60944 //
     /*  801353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801421 */     GIR_RootConstrainSelectedInstOperands,
     /*  801422 */     // GIR_Coverage, 60944,
     /*  801422 */     GIR_EraseRootFromParent_Done,
     /*  801423 */   // Label 12479: @801423
     /*  801423 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(801498), // Rule ID 60945 //
     /*  801428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801496 */     GIR_RootConstrainSelectedInstOperands,
     /*  801497 */     // GIR_Coverage, 60945,
     /*  801497 */     GIR_EraseRootFromParent_Done,
     /*  801498 */   // Label 12480: @801498
     /*  801498 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(801573), // Rule ID 60948 //
     /*  801503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801571 */     GIR_RootConstrainSelectedInstOperands,
     /*  801572 */     // GIR_Coverage, 60948,
     /*  801572 */     GIR_EraseRootFromParent_Done,
     /*  801573 */   // Label 12481: @801573
     /*  801573 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(801648), // Rule ID 60949 //
     /*  801578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  801627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801646 */     GIR_RootConstrainSelectedInstOperands,
     /*  801647 */     // GIR_Coverage, 60949,
     /*  801647 */     GIR_EraseRootFromParent_Done,
     /*  801648 */   // Label 12482: @801648
     /*  801648 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(801723), // Rule ID 60952 //
     /*  801653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  801664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  801667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  801670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  801699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  801702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  801718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801721 */     GIR_RootConstrainSelectedInstOperands,
     /*  801722 */     // GIR_Coverage, 60952,
     /*  801722 */     GIR_EraseRootFromParent_Done,
     /*  801723 */   // Label 12483: @801723
     /*  801723 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(801798), // Rule ID 60953 //
     /*  801728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  801739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  801742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  801745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  801774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  801777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  801793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801796 */     GIR_RootConstrainSelectedInstOperands,
     /*  801797 */     // GIR_Coverage, 60953,
     /*  801797 */     GIR_EraseRootFromParent_Done,
     /*  801798 */   // Label 12484: @801798
     /*  801798 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(801873), // Rule ID 60956 //
     /*  801803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  801852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801871 */     GIR_RootConstrainSelectedInstOperands,
     /*  801872 */     // GIR_Coverage, 60956,
     /*  801872 */     GIR_EraseRootFromParent_Done,
     /*  801873 */   // Label 12485: @801873
     /*  801873 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(801948), // Rule ID 60957 //
     /*  801878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  801881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  801927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801946 */     GIR_RootConstrainSelectedInstOperands,
     /*  801947 */     // GIR_Coverage, 60957,
     /*  801947 */     GIR_EraseRootFromParent_Done,
     /*  801948 */   // Label 12486: @801948
     /*  801948 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(802023), // Rule ID 60960 //
     /*  801953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  801956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  801961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  801992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  802002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802021 */     GIR_RootConstrainSelectedInstOperands,
     /*  802022 */     // GIR_Coverage, 60960,
     /*  802022 */     GIR_EraseRootFromParent_Done,
     /*  802023 */   // Label 12487: @802023
     /*  802023 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(802098), // Rule ID 60961 //
     /*  802028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  802077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802096 */     GIR_RootConstrainSelectedInstOperands,
     /*  802097 */     // GIR_Coverage, 60961,
     /*  802097 */     GIR_EraseRootFromParent_Done,
     /*  802098 */   // Label 12488: @802098
     /*  802098 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(802173), // Rule ID 60964 //
     /*  802103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  802152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802171 */     GIR_RootConstrainSelectedInstOperands,
     /*  802172 */     // GIR_Coverage, 60964,
     /*  802172 */     GIR_EraseRootFromParent_Done,
     /*  802173 */   // Label 12489: @802173
     /*  802173 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(802248), // Rule ID 60965 //
     /*  802178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  802227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802246 */     GIR_RootConstrainSelectedInstOperands,
     /*  802247 */     // GIR_Coverage, 60965,
     /*  802247 */     GIR_EraseRootFromParent_Done,
     /*  802248 */   // Label 12490: @802248
     /*  802248 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(802323), // Rule ID 60968 //
     /*  802253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  802264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  802267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  802270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  802299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  802302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802321 */     GIR_RootConstrainSelectedInstOperands,
     /*  802322 */     // GIR_Coverage, 60968,
     /*  802322 */     GIR_EraseRootFromParent_Done,
     /*  802323 */   // Label 12491: @802323
     /*  802323 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(802398), // Rule ID 60969 //
     /*  802328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  802339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  802342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  802345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  802374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  802377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802396 */     GIR_RootConstrainSelectedInstOperands,
     /*  802397 */     // GIR_Coverage, 60969,
     /*  802397 */     GIR_EraseRootFromParent_Done,
     /*  802398 */   // Label 12492: @802398
     /*  802398 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(802473), // Rule ID 60972 //
     /*  802403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  802414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  802417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  802420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802449 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  802449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  802452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802471 */     GIR_RootConstrainSelectedInstOperands,
     /*  802472 */     // GIR_Coverage, 60972,
     /*  802472 */     GIR_EraseRootFromParent_Done,
     /*  802473 */   // Label 12493: @802473
     /*  802473 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(802548), // Rule ID 60973 //
     /*  802478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  802489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  802492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  802495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  802524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  802527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802546 */     GIR_RootConstrainSelectedInstOperands,
     /*  802547 */     // GIR_Coverage, 60973,
     /*  802547 */     GIR_EraseRootFromParent_Done,
     /*  802548 */   // Label 12494: @802548
     /*  802548 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(802623), // Rule ID 60976 //
     /*  802553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  802564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  802567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  802570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802599 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  802599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  802602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802621 */     GIR_RootConstrainSelectedInstOperands,
     /*  802622 */     // GIR_Coverage, 60976,
     /*  802622 */     GIR_EraseRootFromParent_Done,
     /*  802623 */   // Label 12495: @802623
     /*  802623 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(802698), // Rule ID 60977 //
     /*  802628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  802639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  802642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  802645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802674 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  802674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  802677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  802693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802696 */     GIR_RootConstrainSelectedInstOperands,
     /*  802697 */     // GIR_Coverage, 60977,
     /*  802697 */     GIR_EraseRootFromParent_Done,
     /*  802698 */   // Label 12496: @802698
     /*  802698 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(802773), // Rule ID 60980 //
     /*  802703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  802752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802771 */     GIR_RootConstrainSelectedInstOperands,
     /*  802772 */     // GIR_Coverage, 60980,
     /*  802772 */     GIR_EraseRootFromParent_Done,
     /*  802773 */   // Label 12497: @802773
     /*  802773 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(802848), // Rule ID 60981 //
     /*  802778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  802827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802846 */     GIR_RootConstrainSelectedInstOperands,
     /*  802847 */     // GIR_Coverage, 60981,
     /*  802847 */     GIR_EraseRootFromParent_Done,
     /*  802848 */   // Label 12498: @802848
     /*  802848 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(802923), // Rule ID 60984 //
     /*  802853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  802856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802899 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  802902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802921 */     GIR_RootConstrainSelectedInstOperands,
     /*  802922 */     // GIR_Coverage, 60984,
     /*  802922 */     GIR_EraseRootFromParent_Done,
     /*  802923 */   // Label 12499: @802923
     /*  802923 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(802998), // Rule ID 60985 //
     /*  802928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  802931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  802936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  802948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  802967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  802977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802996 */     GIR_RootConstrainSelectedInstOperands,
     /*  802997 */     // GIR_Coverage, 60985,
     /*  802997 */     GIR_EraseRootFromParent_Done,
     /*  802998 */   // Label 12500: @802998
     /*  802998 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(803073), // Rule ID 60988 //
     /*  803003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803049 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  803052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803071 */     GIR_RootConstrainSelectedInstOperands,
     /*  803072 */     // GIR_Coverage, 60988,
     /*  803072 */     GIR_EraseRootFromParent_Done,
     /*  803073 */   // Label 12501: @803073
     /*  803073 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(803148), // Rule ID 60989 //
     /*  803078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  803127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803146 */     GIR_RootConstrainSelectedInstOperands,
     /*  803147 */     // GIR_Coverage, 60989,
     /*  803147 */     GIR_EraseRootFromParent_Done,
     /*  803148 */   // Label 12502: @803148
     /*  803148 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(803223), // Rule ID 60992 //
     /*  803153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  803202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803221 */     GIR_RootConstrainSelectedInstOperands,
     /*  803222 */     // GIR_Coverage, 60992,
     /*  803222 */     GIR_EraseRootFromParent_Done,
     /*  803223 */   // Label 12503: @803223
     /*  803223 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(803298), // Rule ID 60993 //
     /*  803228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  803277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803296 */     GIR_RootConstrainSelectedInstOperands,
     /*  803297 */     // GIR_Coverage, 60993,
     /*  803297 */     GIR_EraseRootFromParent_Done,
     /*  803298 */   // Label 12504: @803298
     /*  803298 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(803373), // Rule ID 60996 //
     /*  803303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  803352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803371 */     GIR_RootConstrainSelectedInstOperands,
     /*  803372 */     // GIR_Coverage, 60996,
     /*  803372 */     GIR_EraseRootFromParent_Done,
     /*  803373 */   // Label 12505: @803373
     /*  803373 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(803448), // Rule ID 60997 //
     /*  803378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  803427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803446 */     GIR_RootConstrainSelectedInstOperands,
     /*  803447 */     // GIR_Coverage, 60997,
     /*  803447 */     GIR_EraseRootFromParent_Done,
     /*  803448 */   // Label 12506: @803448
     /*  803448 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(803523), // Rule ID 61000 //
     /*  803453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  803502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803521 */     GIR_RootConstrainSelectedInstOperands,
     /*  803522 */     // GIR_Coverage, 61000,
     /*  803522 */     GIR_EraseRootFromParent_Done,
     /*  803523 */   // Label 12507: @803523
     /*  803523 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(803598), // Rule ID 61001 //
     /*  803528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  803577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803596 */     GIR_RootConstrainSelectedInstOperands,
     /*  803597 */     // GIR_Coverage, 61001,
     /*  803597 */     GIR_EraseRootFromParent_Done,
     /*  803598 */   // Label 12508: @803598
     /*  803598 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(803673), // Rule ID 61004 //
     /*  803603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  803652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803671 */     GIR_RootConstrainSelectedInstOperands,
     /*  803672 */     // GIR_Coverage, 61004,
     /*  803672 */     GIR_EraseRootFromParent_Done,
     /*  803673 */   // Label 12509: @803673
     /*  803673 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(803748), // Rule ID 61005 //
     /*  803678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  803727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803746 */     GIR_RootConstrainSelectedInstOperands,
     /*  803747 */     // GIR_Coverage, 61005,
     /*  803747 */     GIR_EraseRootFromParent_Done,
     /*  803748 */   // Label 12510: @803748
     /*  803748 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(803823), // Rule ID 61008 //
     /*  803753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  803802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803821 */     GIR_RootConstrainSelectedInstOperands,
     /*  803822 */     // GIR_Coverage, 61008,
     /*  803822 */     GIR_EraseRootFromParent_Done,
     /*  803823 */   // Label 12511: @803823
     /*  803823 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(803898), // Rule ID 61009 //
     /*  803828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  803877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803896 */     GIR_RootConstrainSelectedInstOperands,
     /*  803897 */     // GIR_Coverage, 61009,
     /*  803897 */     GIR_EraseRootFromParent_Done,
     /*  803898 */   // Label 12512: @803898
     /*  803898 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(803973), // Rule ID 61012 //
     /*  803903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  803906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  803923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  803942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803949 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  803952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803971 */     GIR_RootConstrainSelectedInstOperands,
     /*  803972 */     // GIR_Coverage, 61012,
     /*  803972 */     GIR_EraseRootFromParent_Done,
     /*  803973 */   // Label 12513: @803973
     /*  803973 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(804048), // Rule ID 61013 //
     /*  803978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  803981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  803986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  804017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  804027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804046 */     GIR_RootConstrainSelectedInstOperands,
     /*  804047 */     // GIR_Coverage, 61013,
     /*  804047 */     GIR_EraseRootFromParent_Done,
     /*  804048 */   // Label 12514: @804048
     /*  804048 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(804123), // Rule ID 61100 //
     /*  804053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  804064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  804067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  804070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  804073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  804099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  804102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804121 */     GIR_RootConstrainSelectedInstOperands,
     /*  804122 */     // GIR_Coverage, 61100,
     /*  804122 */     GIR_EraseRootFromParent_Done,
     /*  804123 */   // Label 12515: @804123
     /*  804123 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(804198), // Rule ID 61101 //
     /*  804128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  804139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  804142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  804145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  804148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  804174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  804177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804196 */     GIR_RootConstrainSelectedInstOperands,
     /*  804197 */     // GIR_Coverage, 61101,
     /*  804197 */     GIR_EraseRootFromParent_Done,
     /*  804198 */   // Label 12516: @804198
     /*  804198 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(804273), // Rule ID 61104 //
     /*  804203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  804214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  804217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  804220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  804223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804249 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  804249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  804252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804271 */     GIR_RootConstrainSelectedInstOperands,
     /*  804272 */     // GIR_Coverage, 61104,
     /*  804272 */     GIR_EraseRootFromParent_Done,
     /*  804273 */   // Label 12517: @804273
     /*  804273 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(804348), // Rule ID 61105 //
     /*  804278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  804289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  804292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  804295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  804298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  804324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  804327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804346 */     GIR_RootConstrainSelectedInstOperands,
     /*  804347 */     // GIR_Coverage, 61105,
     /*  804347 */     GIR_EraseRootFromParent_Done,
     /*  804348 */   // Label 12518: @804348
     /*  804348 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(804423), // Rule ID 61108 //
     /*  804353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  804364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  804367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  804370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  804373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804399 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  804399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804421 */     GIR_RootConstrainSelectedInstOperands,
     /*  804422 */     // GIR_Coverage, 61108,
     /*  804422 */     GIR_EraseRootFromParent_Done,
     /*  804423 */   // Label 12519: @804423
     /*  804423 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(804498), // Rule ID 61109 //
     /*  804428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  804439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  804442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  804445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  804448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804474 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  804474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  804493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804496 */     GIR_RootConstrainSelectedInstOperands,
     /*  804497 */     // GIR_Coverage, 61109,
     /*  804497 */     GIR_EraseRootFromParent_Done,
     /*  804498 */   // Label 12520: @804498
     /*  804498 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(804573), // Rule ID 61112 //
     /*  804503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  804523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  804552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804571 */     GIR_RootConstrainSelectedInstOperands,
     /*  804572 */     // GIR_Coverage, 61112,
     /*  804572 */     GIR_EraseRootFromParent_Done,
     /*  804573 */   // Label 12521: @804573
     /*  804573 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(804648), // Rule ID 61113 //
     /*  804578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  804598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  804627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804646 */     GIR_RootConstrainSelectedInstOperands,
     /*  804647 */     // GIR_Coverage, 61113,
     /*  804647 */     GIR_EraseRootFromParent_Done,
     /*  804648 */   // Label 12522: @804648
     /*  804648 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(804723), // Rule ID 61116 //
     /*  804653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  804673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804699 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804721 */     GIR_RootConstrainSelectedInstOperands,
     /*  804722 */     // GIR_Coverage, 61116,
     /*  804722 */     GIR_EraseRootFromParent_Done,
     /*  804723 */   // Label 12523: @804723
     /*  804723 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(804798), // Rule ID 61117 //
     /*  804728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  804748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804796 */     GIR_RootConstrainSelectedInstOperands,
     /*  804797 */     // GIR_Coverage, 61117,
     /*  804797 */     GIR_EraseRootFromParent_Done,
     /*  804798 */   // Label 12524: @804798
     /*  804798 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(804873), // Rule ID 61120 //
     /*  804803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  804823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804849 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804871 */     GIR_RootConstrainSelectedInstOperands,
     /*  804872 */     // GIR_Coverage, 61120,
     /*  804872 */     GIR_EraseRootFromParent_Done,
     /*  804873 */   // Label 12525: @804873
     /*  804873 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(804948), // Rule ID 61121 //
     /*  804878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  804881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  804898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  804927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804946 */     GIR_RootConstrainSelectedInstOperands,
     /*  804947 */     // GIR_Coverage, 61121,
     /*  804947 */     GIR_EraseRootFromParent_Done,
     /*  804948 */   // Label 12526: @804948
     /*  804948 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(805023), // Rule ID 61124 //
     /*  804953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  804956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  804961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  804964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  804967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  804970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  804973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  804999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805021 */     GIR_RootConstrainSelectedInstOperands,
     /*  805022 */     // GIR_Coverage, 61124,
     /*  805022 */     GIR_EraseRootFromParent_Done,
     /*  805023 */   // Label 12527: @805023
     /*  805023 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(805098), // Rule ID 61125 //
     /*  805028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  805039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  805042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  805045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  805048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  805074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805096 */     GIR_RootConstrainSelectedInstOperands,
     /*  805097 */     // GIR_Coverage, 61125,
     /*  805097 */     GIR_EraseRootFromParent_Done,
     /*  805098 */   // Label 12528: @805098
     /*  805098 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(805173), // Rule ID 61128 //
     /*  805103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  805114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  805117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  805120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  805123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805171 */     GIR_RootConstrainSelectedInstOperands,
     /*  805172 */     // GIR_Coverage, 61128,
     /*  805172 */     GIR_EraseRootFromParent_Done,
     /*  805173 */   // Label 12529: @805173
     /*  805173 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(805248), // Rule ID 61129 //
     /*  805178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  805189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  805192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  805195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  805198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805246 */     GIR_RootConstrainSelectedInstOperands,
     /*  805247 */     // GIR_Coverage, 61129,
     /*  805247 */     GIR_EraseRootFromParent_Done,
     /*  805248 */   // Label 12530: @805248
     /*  805248 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(805323), // Rule ID 61132 //
     /*  805253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  805273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805321 */     GIR_RootConstrainSelectedInstOperands,
     /*  805322 */     // GIR_Coverage, 61132,
     /*  805322 */     GIR_EraseRootFromParent_Done,
     /*  805323 */   // Label 12531: @805323
     /*  805323 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(805398), // Rule ID 61133 //
     /*  805328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  805348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805396 */     GIR_RootConstrainSelectedInstOperands,
     /*  805397 */     // GIR_Coverage, 61133,
     /*  805397 */     GIR_EraseRootFromParent_Done,
     /*  805398 */   // Label 12532: @805398
     /*  805398 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(805473), // Rule ID 61136 //
     /*  805403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  805423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805471 */     GIR_RootConstrainSelectedInstOperands,
     /*  805472 */     // GIR_Coverage, 61136,
     /*  805472 */     GIR_EraseRootFromParent_Done,
     /*  805473 */   // Label 12533: @805473
     /*  805473 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(805548), // Rule ID 61137 //
     /*  805478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  805498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  805527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805546 */     GIR_RootConstrainSelectedInstOperands,
     /*  805547 */     // GIR_Coverage, 61137,
     /*  805547 */     GIR_EraseRootFromParent_Done,
     /*  805548 */   // Label 12534: @805548
     /*  805548 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(805623), // Rule ID 61140 //
     /*  805553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  805564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  805567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  805570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  805573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805599 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  805599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  805602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805621 */     GIR_RootConstrainSelectedInstOperands,
     /*  805622 */     // GIR_Coverage, 61140,
     /*  805622 */     GIR_EraseRootFromParent_Done,
     /*  805623 */   // Label 12535: @805623
     /*  805623 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(805698), // Rule ID 61141 //
     /*  805628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  805639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  805642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  805645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  805648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  805674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  805677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805696 */     GIR_RootConstrainSelectedInstOperands,
     /*  805697 */     // GIR_Coverage, 61141,
     /*  805697 */     GIR_EraseRootFromParent_Done,
     /*  805698 */   // Label 12536: @805698
     /*  805698 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(805773), // Rule ID 61144 //
     /*  805703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  805714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  805717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  805720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  805723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805749 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  805749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  805752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805771 */     GIR_RootConstrainSelectedInstOperands,
     /*  805772 */     // GIR_Coverage, 61144,
     /*  805772 */     GIR_EraseRootFromParent_Done,
     /*  805773 */   // Label 12537: @805773
     /*  805773 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(805848), // Rule ID 61145 //
     /*  805778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  805789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  805792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  805795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  805798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  805824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  805827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805846 */     GIR_RootConstrainSelectedInstOperands,
     /*  805847 */     // GIR_Coverage, 61145,
     /*  805847 */     GIR_EraseRootFromParent_Done,
     /*  805848 */   // Label 12538: @805848
     /*  805848 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(805923), // Rule ID 61148 //
     /*  805853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  805856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  805864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  805867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  805870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  805873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805899 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  805899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  805902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805921 */     GIR_RootConstrainSelectedInstOperands,
     /*  805922 */     // GIR_Coverage, 61148,
     /*  805922 */     GIR_EraseRootFromParent_Done,
     /*  805923 */   // Label 12539: @805923
     /*  805923 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(805998), // Rule ID 61149 //
     /*  805928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  805931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  805936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  805939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  805942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  805945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  805948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  805974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  805977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805996 */     GIR_RootConstrainSelectedInstOperands,
     /*  805997 */     // GIR_Coverage, 61149,
     /*  805997 */     GIR_EraseRootFromParent_Done,
     /*  805998 */   // Label 12540: @805998
     /*  805998 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(806073), // Rule ID 61152 //
     /*  806003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  806052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806071 */     GIR_RootConstrainSelectedInstOperands,
     /*  806072 */     // GIR_Coverage, 61152,
     /*  806072 */     GIR_EraseRootFromParent_Done,
     /*  806073 */   // Label 12541: @806073
     /*  806073 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(806148), // Rule ID 61153 //
     /*  806078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  806127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806146 */     GIR_RootConstrainSelectedInstOperands,
     /*  806147 */     // GIR_Coverage, 61153,
     /*  806147 */     GIR_EraseRootFromParent_Done,
     /*  806148 */   // Label 12542: @806148
     /*  806148 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(806223), // Rule ID 61156 //
     /*  806153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  806202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806221 */     GIR_RootConstrainSelectedInstOperands,
     /*  806222 */     // GIR_Coverage, 61156,
     /*  806222 */     GIR_EraseRootFromParent_Done,
     /*  806223 */   // Label 12543: @806223
     /*  806223 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(806298), // Rule ID 61157 //
     /*  806228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  806277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806296 */     GIR_RootConstrainSelectedInstOperands,
     /*  806297 */     // GIR_Coverage, 61157,
     /*  806297 */     GIR_EraseRootFromParent_Done,
     /*  806298 */   // Label 12544: @806298
     /*  806298 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(806373), // Rule ID 61160 //
     /*  806303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  806352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806371 */     GIR_RootConstrainSelectedInstOperands,
     /*  806372 */     // GIR_Coverage, 61160,
     /*  806372 */     GIR_EraseRootFromParent_Done,
     /*  806373 */   // Label 12545: @806373
     /*  806373 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(806448), // Rule ID 61161 //
     /*  806378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  806427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806446 */     GIR_RootConstrainSelectedInstOperands,
     /*  806447 */     // GIR_Coverage, 61161,
     /*  806447 */     GIR_EraseRootFromParent_Done,
     /*  806448 */   // Label 12546: @806448
     /*  806448 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(806523), // Rule ID 61164 //
     /*  806453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  806464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  806467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  806470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  806473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  806502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806521 */     GIR_RootConstrainSelectedInstOperands,
     /*  806522 */     // GIR_Coverage, 61164,
     /*  806522 */     GIR_EraseRootFromParent_Done,
     /*  806523 */   // Label 12547: @806523
     /*  806523 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(806598), // Rule ID 61165 //
     /*  806528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  806539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  806542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  806545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  806548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  806577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806596 */     GIR_RootConstrainSelectedInstOperands,
     /*  806597 */     // GIR_Coverage, 61165,
     /*  806597 */     GIR_EraseRootFromParent_Done,
     /*  806598 */   // Label 12548: @806598
     /*  806598 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(806673), // Rule ID 61168 //
     /*  806603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  806614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  806617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  806620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  806623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806649 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  806652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806671 */     GIR_RootConstrainSelectedInstOperands,
     /*  806672 */     // GIR_Coverage, 61168,
     /*  806672 */     GIR_EraseRootFromParent_Done,
     /*  806673 */   // Label 12549: @806673
     /*  806673 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(806748), // Rule ID 61169 //
     /*  806678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  806689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  806692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  806695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  806698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  806727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806746 */     GIR_RootConstrainSelectedInstOperands,
     /*  806747 */     // GIR_Coverage, 61169,
     /*  806747 */     GIR_EraseRootFromParent_Done,
     /*  806748 */   // Label 12550: @806748
     /*  806748 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(806823), // Rule ID 61172 //
     /*  806753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  806773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  806802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806821 */     GIR_RootConstrainSelectedInstOperands,
     /*  806822 */     // GIR_Coverage, 61172,
     /*  806822 */     GIR_EraseRootFromParent_Done,
     /*  806823 */   // Label 12551: @806823
     /*  806823 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(806898), // Rule ID 61173 //
     /*  806828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  806848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806874 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  806877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806896 */     GIR_RootConstrainSelectedInstOperands,
     /*  806897 */     // GIR_Coverage, 61173,
     /*  806897 */     GIR_EraseRootFromParent_Done,
     /*  806898 */   // Label 12552: @806898
     /*  806898 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(806973), // Rule ID 61176 //
     /*  806903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  806906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  806923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  806952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806971 */     GIR_RootConstrainSelectedInstOperands,
     /*  806972 */     // GIR_Coverage, 61176,
     /*  806972 */     GIR_EraseRootFromParent_Done,
     /*  806973 */   // Label 12553: @806973
     /*  806973 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(807048), // Rule ID 61177 //
     /*  806978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  806981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  806986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  806998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  807027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807046 */     GIR_RootConstrainSelectedInstOperands,
     /*  807047 */     // GIR_Coverage, 61177,
     /*  807047 */     GIR_EraseRootFromParent_Done,
     /*  807048 */   // Label 12554: @807048
     /*  807048 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(807123), // Rule ID 61180 //
     /*  807053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807099 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  807102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807121 */     GIR_RootConstrainSelectedInstOperands,
     /*  807122 */     // GIR_Coverage, 61180,
     /*  807122 */     GIR_EraseRootFromParent_Done,
     /*  807123 */   // Label 12555: @807123
     /*  807123 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(807198), // Rule ID 61181 //
     /*  807128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  807177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807196 */     GIR_RootConstrainSelectedInstOperands,
     /*  807197 */     // GIR_Coverage, 61181,
     /*  807197 */     GIR_EraseRootFromParent_Done,
     /*  807198 */   // Label 12556: @807198
     /*  807198 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(807273), // Rule ID 61184 //
     /*  807203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807249 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  807252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807271 */     GIR_RootConstrainSelectedInstOperands,
     /*  807272 */     // GIR_Coverage, 61184,
     /*  807272 */     GIR_EraseRootFromParent_Done,
     /*  807273 */   // Label 12557: @807273
     /*  807273 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(807348), // Rule ID 61185 //
     /*  807278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  807327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807346 */     GIR_RootConstrainSelectedInstOperands,
     /*  807347 */     // GIR_Coverage, 61185,
     /*  807347 */     GIR_EraseRootFromParent_Done,
     /*  807348 */   // Label 12558: @807348
     /*  807348 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(807423), // Rule ID 61188 //
     /*  807353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  807364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  807367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  807370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  807373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807399 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  807402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807421 */     GIR_RootConstrainSelectedInstOperands,
     /*  807422 */     // GIR_Coverage, 61188,
     /*  807422 */     GIR_EraseRootFromParent_Done,
     /*  807423 */   // Label 12559: @807423
     /*  807423 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(807498), // Rule ID 61189 //
     /*  807428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  807439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  807442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  807445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  807448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807474 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  807477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807496 */     GIR_RootConstrainSelectedInstOperands,
     /*  807497 */     // GIR_Coverage, 61189,
     /*  807497 */     GIR_EraseRootFromParent_Done,
     /*  807498 */   // Label 12560: @807498
     /*  807498 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(807573), // Rule ID 61192 //
     /*  807503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  807514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  807517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  807520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  807523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807549 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  807552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807571 */     GIR_RootConstrainSelectedInstOperands,
     /*  807572 */     // GIR_Coverage, 61192,
     /*  807572 */     GIR_EraseRootFromParent_Done,
     /*  807573 */   // Label 12561: @807573
     /*  807573 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(807648), // Rule ID 61193 //
     /*  807578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  807589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  807592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  807595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  807598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  807627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807646 */     GIR_RootConstrainSelectedInstOperands,
     /*  807647 */     // GIR_Coverage, 61193,
     /*  807647 */     GIR_EraseRootFromParent_Done,
     /*  807648 */   // Label 12562: @807648
     /*  807648 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(807723), // Rule ID 61196 //
     /*  807653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  807664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  807667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  807670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  807673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807699 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  807702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807721 */     GIR_RootConstrainSelectedInstOperands,
     /*  807722 */     // GIR_Coverage, 61196,
     /*  807722 */     GIR_EraseRootFromParent_Done,
     /*  807723 */   // Label 12563: @807723
     /*  807723 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(807798), // Rule ID 61197 //
     /*  807728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  807739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  807742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  807745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  807748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  807777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807796 */     GIR_RootConstrainSelectedInstOperands,
     /*  807797 */     // GIR_Coverage, 61197,
     /*  807797 */     GIR_EraseRootFromParent_Done,
     /*  807798 */   // Label 12564: @807798
     /*  807798 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(807873), // Rule ID 61200 //
     /*  807803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  807823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  807852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807871 */     GIR_RootConstrainSelectedInstOperands,
     /*  807872 */     // GIR_Coverage, 61200,
     /*  807872 */     GIR_EraseRootFromParent_Done,
     /*  807873 */   // Label 12565: @807873
     /*  807873 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(807948), // Rule ID 61201 //
     /*  807878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  807881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  807898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  807927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807946 */     GIR_RootConstrainSelectedInstOperands,
     /*  807947 */     // GIR_Coverage, 61201,
     /*  807947 */     GIR_EraseRootFromParent_Done,
     /*  807948 */   // Label 12566: @807948
     /*  807948 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(808023), // Rule ID 61204 //
     /*  807953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  807956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  807961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  807964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  807967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  807970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  807973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  807992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807999 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  808002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808021 */     GIR_RootConstrainSelectedInstOperands,
     /*  808022 */     // GIR_Coverage, 61204,
     /*  808022 */     GIR_EraseRootFromParent_Done,
     /*  808023 */   // Label 12567: @808023
     /*  808023 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(808098), // Rule ID 61205 //
     /*  808028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  808039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  808042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  808045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  808077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808096 */     GIR_RootConstrainSelectedInstOperands,
     /*  808097 */     // GIR_Coverage, 61205,
     /*  808097 */     GIR_EraseRootFromParent_Done,
     /*  808098 */   // Label 12568: @808098
     /*  808098 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(808173), // Rule ID 61208 //
     /*  808103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  808152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808171 */     GIR_RootConstrainSelectedInstOperands,
     /*  808172 */     // GIR_Coverage, 61208,
     /*  808172 */     GIR_EraseRootFromParent_Done,
     /*  808173 */   // Label 12569: @808173
     /*  808173 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(808248), // Rule ID 61209 //
     /*  808178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808224 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  808227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808246 */     GIR_RootConstrainSelectedInstOperands,
     /*  808247 */     // GIR_Coverage, 61209,
     /*  808247 */     GIR_EraseRootFromParent_Done,
     /*  808248 */   // Label 12570: @808248
     /*  808248 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(808323), // Rule ID 61212 //
     /*  808253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  808270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808321 */     GIR_RootConstrainSelectedInstOperands,
     /*  808322 */     // GIR_Coverage, 61212,
     /*  808322 */     GIR_EraseRootFromParent_Done,
     /*  808323 */   // Label 12571: @808323
     /*  808323 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(808398), // Rule ID 61213 //
     /*  808328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  808345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808396 */     GIR_RootConstrainSelectedInstOperands,
     /*  808397 */     // GIR_Coverage, 61213,
     /*  808397 */     GIR_EraseRootFromParent_Done,
     /*  808398 */   // Label 12572: @808398
     /*  808398 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(808473), // Rule ID 61216 //
     /*  808403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808471 */     GIR_RootConstrainSelectedInstOperands,
     /*  808472 */     // GIR_Coverage, 61216,
     /*  808472 */     GIR_EraseRootFromParent_Done,
     /*  808473 */   // Label 12573: @808473
     /*  808473 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(808548), // Rule ID 61217 //
     /*  808478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808546 */     GIR_RootConstrainSelectedInstOperands,
     /*  808547 */     // GIR_Coverage, 61217,
     /*  808547 */     GIR_EraseRootFromParent_Done,
     /*  808548 */   // Label 12574: @808548
     /*  808548 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(808623), // Rule ID 61220 //
     /*  808553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808621 */     GIR_RootConstrainSelectedInstOperands,
     /*  808622 */     // GIR_Coverage, 61220,
     /*  808622 */     GIR_EraseRootFromParent_Done,
     /*  808623 */   // Label 12575: @808623
     /*  808623 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(808698), // Rule ID 61221 //
     /*  808628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808696 */     GIR_RootConstrainSelectedInstOperands,
     /*  808697 */     // GIR_Coverage, 61221,
     /*  808697 */     GIR_EraseRootFromParent_Done,
     /*  808698 */   // Label 12576: @808698
     /*  808698 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(808773), // Rule ID 61224 //
     /*  808703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808771 */     GIR_RootConstrainSelectedInstOperands,
     /*  808772 */     // GIR_Coverage, 61224,
     /*  808772 */     GIR_EraseRootFromParent_Done,
     /*  808773 */   // Label 12577: @808773
     /*  808773 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(808848), // Rule ID 61225 //
     /*  808778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  808827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808846 */     GIR_RootConstrainSelectedInstOperands,
     /*  808847 */     // GIR_Coverage, 61225,
     /*  808847 */     GIR_EraseRootFromParent_Done,
     /*  808848 */   // Label 12578: @808848
     /*  808848 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(808923), // Rule ID 61228 //
     /*  808853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  808856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  808864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  808867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808899 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  808902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808921 */     GIR_RootConstrainSelectedInstOperands,
     /*  808922 */     // GIR_Coverage, 61228,
     /*  808922 */     GIR_EraseRootFromParent_Done,
     /*  808923 */   // Label 12579: @808923
     /*  808923 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(808998), // Rule ID 61229 //
     /*  808928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  808931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  808936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  808939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  808942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  808967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  808977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808996 */     GIR_RootConstrainSelectedInstOperands,
     /*  808997 */     // GIR_Coverage, 61229,
     /*  808997 */     GIR_EraseRootFromParent_Done,
     /*  808998 */   // Label 12580: @808998
     /*  808998 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(809073), // Rule ID 61232 //
     /*  809003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  809014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  809017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  809020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809049 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  809052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809071 */     GIR_RootConstrainSelectedInstOperands,
     /*  809072 */     // GIR_Coverage, 61232,
     /*  809072 */     GIR_EraseRootFromParent_Done,
     /*  809073 */   // Label 12581: @809073
     /*  809073 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(809148), // Rule ID 61233 //
     /*  809078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  809089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  809092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  809095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809124 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  809127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809146 */     GIR_RootConstrainSelectedInstOperands,
     /*  809147 */     // GIR_Coverage, 61233,
     /*  809147 */     GIR_EraseRootFromParent_Done,
     /*  809148 */   // Label 12582: @809148
     /*  809148 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(809223), // Rule ID 61236 //
     /*  809153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  809164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  809167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  809170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809199 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  809202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809221 */     GIR_RootConstrainSelectedInstOperands,
     /*  809222 */     // GIR_Coverage, 61236,
     /*  809222 */     GIR_EraseRootFromParent_Done,
     /*  809223 */   // Label 12583: @809223
     /*  809223 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(809298), // Rule ID 61237 //
     /*  809228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  809239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  809242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  809245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809274 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  809277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809296 */     GIR_RootConstrainSelectedInstOperands,
     /*  809297 */     // GIR_Coverage, 61237,
     /*  809297 */     GIR_EraseRootFromParent_Done,
     /*  809298 */   // Label 12584: @809298
     /*  809298 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(809373), // Rule ID 61240 //
     /*  809303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  809314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  809317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  809320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  809352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809371 */     GIR_RootConstrainSelectedInstOperands,
     /*  809372 */     // GIR_Coverage, 61240,
     /*  809372 */     GIR_EraseRootFromParent_Done,
     /*  809373 */   // Label 12585: @809373
     /*  809373 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(809448), // Rule ID 61241 //
     /*  809378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  809389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  809392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  809395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  809427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809446 */     GIR_RootConstrainSelectedInstOperands,
     /*  809447 */     // GIR_Coverage, 61241,
     /*  809447 */     GIR_EraseRootFromParent_Done,
     /*  809448 */   // Label 12586: @809448
     /*  809448 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(809523), // Rule ID 61244 //
     /*  809453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  809464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  809467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  809470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809499 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  809502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809521 */     GIR_RootConstrainSelectedInstOperands,
     /*  809522 */     // GIR_Coverage, 61244,
     /*  809522 */     GIR_EraseRootFromParent_Done,
     /*  809523 */   // Label 12587: @809523
     /*  809523 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(809598), // Rule ID 61245 //
     /*  809528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  809539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  809542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  809545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  809577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809596 */     GIR_RootConstrainSelectedInstOperands,
     /*  809597 */     // GIR_Coverage, 61245,
     /*  809597 */     GIR_EraseRootFromParent_Done,
     /*  809598 */   // Label 12588: @809598
     /*  809598 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(809673), // Rule ID 61248 //
     /*  809603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809649 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  809652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809671 */     GIR_RootConstrainSelectedInstOperands,
     /*  809672 */     // GIR_Coverage, 61248,
     /*  809672 */     GIR_EraseRootFromParent_Done,
     /*  809673 */   // Label 12589: @809673
     /*  809673 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(809748), // Rule ID 61249 //
     /*  809678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  809727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809746 */     GIR_RootConstrainSelectedInstOperands,
     /*  809747 */     // GIR_Coverage, 61249,
     /*  809747 */     GIR_EraseRootFromParent_Done,
     /*  809748 */   // Label 12590: @809748
     /*  809748 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(809823), // Rule ID 61252 //
     /*  809753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  809802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809821 */     GIR_RootConstrainSelectedInstOperands,
     /*  809822 */     // GIR_Coverage, 61252,
     /*  809822 */     GIR_EraseRootFromParent_Done,
     /*  809823 */   // Label 12591: @809823
     /*  809823 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(809898), // Rule ID 61253 //
     /*  809828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  809877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809896 */     GIR_RootConstrainSelectedInstOperands,
     /*  809897 */     // GIR_Coverage, 61253,
     /*  809897 */     GIR_EraseRootFromParent_Done,
     /*  809898 */   // Label 12592: @809898
     /*  809898 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(809973), // Rule ID 61256 //
     /*  809903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  809906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  809942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  809952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809971 */     GIR_RootConstrainSelectedInstOperands,
     /*  809972 */     // GIR_Coverage, 61256,
     /*  809972 */     GIR_EraseRootFromParent_Done,
     /*  809973 */   // Label 12593: @809973
     /*  809973 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(810048), // Rule ID 61257 //
     /*  809978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  809981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  809986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  810027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810046 */     GIR_RootConstrainSelectedInstOperands,
     /*  810047 */     // GIR_Coverage, 61257,
     /*  810047 */     GIR_EraseRootFromParent_Done,
     /*  810048 */   // Label 12594: @810048
     /*  810048 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(810123), // Rule ID 61260 //
     /*  810053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  810056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  810064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  810067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  810070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  810102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810121 */     GIR_RootConstrainSelectedInstOperands,
     /*  810122 */     // GIR_Coverage, 61260,
     /*  810122 */     GIR_EraseRootFromParent_Done,
     /*  810123 */   // Label 12595: @810123
     /*  810123 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(810198), // Rule ID 61261 //
     /*  810128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  810131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  810139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  810142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  810145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  810148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  810177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810196 */     GIR_RootConstrainSelectedInstOperands,
     /*  810197 */     // GIR_Coverage, 61261,
     /*  810197 */     GIR_EraseRootFromParent_Done,
     /*  810198 */   // Label 12596: @810198
     /*  810198 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(810273), // Rule ID 61264 //
     /*  810203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  810206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  810214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  810217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  810220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  810252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810271 */     GIR_RootConstrainSelectedInstOperands,
     /*  810272 */     // GIR_Coverage, 61264,
     /*  810272 */     GIR_EraseRootFromParent_Done,
     /*  810273 */   // Label 12597: @810273
     /*  810273 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(810348), // Rule ID 61265 //
     /*  810278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  810281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  810289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  810292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  810295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  810298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  810327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810346 */     GIR_RootConstrainSelectedInstOperands,
     /*  810347 */     // GIR_Coverage, 61265,
     /*  810347 */     GIR_EraseRootFromParent_Done,
     /*  810348 */   // Label 12598: @810348
     /*  810348 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(810423), // Rule ID 61268 //
     /*  810353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  810356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  810364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  810367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  810370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810399 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  810402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810421 */     GIR_RootConstrainSelectedInstOperands,
     /*  810422 */     // GIR_Coverage, 61268,
     /*  810422 */     GIR_EraseRootFromParent_Done,
     /*  810423 */   // Label 12599: @810423
     /*  810423 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(810498), // Rule ID 61269 //
     /*  810428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  810431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  810439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  810442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  810445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  810448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  810477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810496 */     GIR_RootConstrainSelectedInstOperands,
     /*  810497 */     // GIR_Coverage, 61269,
     /*  810497 */     GIR_EraseRootFromParent_Done,
     /*  810498 */   // Label 12600: @810498
     /*  810498 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(810573), // Rule ID 61272 //
     /*  810503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  810506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  810514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  810517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  810520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810549 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  810552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810571 */     GIR_RootConstrainSelectedInstOperands,
     /*  810572 */     // GIR_Coverage, 61272,
     /*  810572 */     GIR_EraseRootFromParent_Done,
     /*  810573 */   // Label 12601: @810573
     /*  810573 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(810648), // Rule ID 61273 //
     /*  810578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  810581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  810586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  810589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  810592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  810595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  810598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  810617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  810627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810646 */     GIR_RootConstrainSelectedInstOperands,
     /*  810647 */     // GIR_Coverage, 61273,
     /*  810647 */     GIR_EraseRootFromParent_Done,
     /*  810648 */   // Label 12602: @810648
     /*  810648 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(810723), // Rule ID 61716 //
     /*  810653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  810656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  810661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  810702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810721 */     GIR_RootConstrainSelectedInstOperands,
     /*  810722 */     // GIR_Coverage, 61716,
     /*  810722 */     GIR_EraseRootFromParent_Done,
     /*  810723 */   // Label 12603: @810723
     /*  810723 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(810798), // Rule ID 61717 //
     /*  810728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  810731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  810736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  810777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810796 */     GIR_RootConstrainSelectedInstOperands,
     /*  810797 */     // GIR_Coverage, 61717,
     /*  810797 */     GIR_EraseRootFromParent_Done,
     /*  810798 */   // Label 12604: @810798
     /*  810798 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(810873), // Rule ID 61718 //
     /*  810803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  810806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  810811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  810814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  810817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  810820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  810823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  810852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810871 */     GIR_RootConstrainSelectedInstOperands,
     /*  810872 */     // GIR_Coverage, 61718,
     /*  810872 */     GIR_EraseRootFromParent_Done,
     /*  810873 */   // Label 12605: @810873
     /*  810873 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(810948), // Rule ID 61719 //
     /*  810878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  810881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  810886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  810889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  810892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  810895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  810898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  810927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810946 */     GIR_RootConstrainSelectedInstOperands,
     /*  810947 */     // GIR_Coverage, 61719,
     /*  810947 */     GIR_EraseRootFromParent_Done,
     /*  810948 */   // Label 12606: @810948
     /*  810948 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(811023), // Rule ID 61720 //
     /*  810953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  810956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  810961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  810964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  810967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  810970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  810973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  811002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  811006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811021 */     GIR_RootConstrainSelectedInstOperands,
     /*  811022 */     // GIR_Coverage, 61720,
     /*  811022 */     GIR_EraseRootFromParent_Done,
     /*  811023 */   // Label 12607: @811023
     /*  811023 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(811098), // Rule ID 61721 //
     /*  811028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  811031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  811036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  811039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  811042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  811045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  811048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  811077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  811081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811096 */     GIR_RootConstrainSelectedInstOperands,
     /*  811097 */     // GIR_Coverage, 61721,
     /*  811097 */     GIR_EraseRootFromParent_Done,
     /*  811098 */   // Label 12608: @811098
     /*  811098 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(811173), // Rule ID 61722 //
     /*  811103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  811106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  811111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  811114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  811117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  811120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  811123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811149 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  811152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  811156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811171 */     GIR_RootConstrainSelectedInstOperands,
     /*  811172 */     // GIR_Coverage, 61722,
     /*  811172 */     GIR_EraseRootFromParent_Done,
     /*  811173 */   // Label 12609: @811173
     /*  811173 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(811248), // Rule ID 61723 //
     /*  811178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  811181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  811186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  811189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  811192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  811195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  811198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811224 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  811227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  811231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811246 */     GIR_RootConstrainSelectedInstOperands,
     /*  811247 */     // GIR_Coverage, 61723,
     /*  811247 */     GIR_EraseRootFromParent_Done,
     /*  811248 */   // Label 12610: @811248
     /*  811248 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(811312), // Rule ID 63831 //
     /*  811253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  811261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811289 */     // MIs[0] imm5
     /*  811289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811297 */     // (intrinsic_wo_chain:{ *:[i32] } 10699:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  811300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811308 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811310 */     GIR_RootConstrainSelectedInstOperands,
     /*  811311 */     // GIR_Coverage, 63831,
     /*  811311 */     GIR_EraseRootFromParent_Done,
     /*  811312 */   // Label 12611: @811312
     /*  811312 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(811376), // Rule ID 63832 //
     /*  811317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  811325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811353 */     // MIs[0] imm5
     /*  811353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811361 */     // (intrinsic_wo_chain:{ *:[i32] } 10695:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  811364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811372 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811374 */     GIR_RootConstrainSelectedInstOperands,
     /*  811375 */     // GIR_Coverage, 63832,
     /*  811375 */     GIR_EraseRootFromParent_Done,
     /*  811376 */   // Label 12612: @811376
     /*  811376 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(811440), // Rule ID 63833 //
     /*  811381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  811389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811417 */     // MIs[0] imm5
     /*  811417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811425 */     // (intrinsic_wo_chain:{ *:[i32] } 10697:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  811428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811436 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811438 */     GIR_RootConstrainSelectedInstOperands,
     /*  811439 */     // GIR_Coverage, 63833,
     /*  811439 */     GIR_EraseRootFromParent_Done,
     /*  811440 */   // Label 12613: @811440
     /*  811440 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(811504), // Rule ID 63834 //
     /*  811445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  811453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811481 */     // MIs[0] imm5
     /*  811481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811489 */     // (intrinsic_wo_chain:{ *:[i32] } 10693:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  811492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811500 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811502 */     GIR_RootConstrainSelectedInstOperands,
     /*  811503 */     // GIR_Coverage, 63834,
     /*  811503 */     GIR_EraseRootFromParent_Done,
     /*  811504 */   // Label 12614: @811504
     /*  811504 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(811568), // Rule ID 63835 //
     /*  811509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  811517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811545 */     // MIs[0] imm5
     /*  811545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811553 */     // (intrinsic_wo_chain:{ *:[i32] } 10700:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  811556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811564 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811566 */     GIR_RootConstrainSelectedInstOperands,
     /*  811567 */     // GIR_Coverage, 63835,
     /*  811567 */     GIR_EraseRootFromParent_Done,
     /*  811568 */   // Label 12615: @811568
     /*  811568 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(811632), // Rule ID 63836 //
     /*  811573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  811581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811609 */     // MIs[0] imm5
     /*  811609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811617 */     // (intrinsic_wo_chain:{ *:[i32] } 10696:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  811620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811628 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811630 */     GIR_RootConstrainSelectedInstOperands,
     /*  811631 */     // GIR_Coverage, 63836,
     /*  811631 */     GIR_EraseRootFromParent_Done,
     /*  811632 */   // Label 12616: @811632
     /*  811632 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(811696), // Rule ID 63837 //
     /*  811637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  811645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811673 */     // MIs[0] imm5
     /*  811673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811681 */     // (intrinsic_wo_chain:{ *:[i32] } 10698:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  811684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811692 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811694 */     GIR_RootConstrainSelectedInstOperands,
     /*  811695 */     // GIR_Coverage, 63837,
     /*  811695 */     GIR_EraseRootFromParent_Done,
     /*  811696 */   // Label 12617: @811696
     /*  811696 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(811760), // Rule ID 63838 //
     /*  811701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  811704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  811709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  811712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  811715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  811718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  811721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  811737 */     // MIs[0] imm5
     /*  811737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  811745 */     // (intrinsic_wo_chain:{ *:[i32] } 10694:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  811745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  811748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  811750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  811752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  811754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  811756 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  811758 */     GIR_RootConstrainSelectedInstOperands,
     /*  811759 */     // GIR_Coverage, 63838,
     /*  811759 */     GIR_EraseRootFromParent_Done,
     /*  811760 */   // Label 12618: @811760
     /*  811760 */   GIM_Reject,
     /*  811761 */ // Label 5772: @811761
     /*  811761 */ GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(1301234),
     /*  811766 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  811769 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(811852), // Rule ID 62167 //
     /*  811774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  811777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  811782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  811785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  811788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  811791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  811794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811798 */     // MIs[0] op1
     /*  811798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  811801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  811806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811814 */     // MIs[0] op4
     /*  811814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  811822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811829 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  811829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  811832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  811836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  811838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  811840 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  811842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811850 */     GIR_RootConstrainSelectedInstOperands,
     /*  811851 */     // GIR_Coverage, 62167,
     /*  811851 */     GIR_EraseRootFromParent_Done,
     /*  811852 */   // Label 12620: @811852
     /*  811852 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(811935), // Rule ID 62168 //
     /*  811857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  811860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  811865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  811868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  811871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  811874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  811877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811881 */     // MIs[0] op1
     /*  811881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  811884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  811889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811897 */     // MIs[0] op4
     /*  811897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  811905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811912 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  811912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  811915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811917 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  811919 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  811921 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  811923 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  811925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811933 */     GIR_RootConstrainSelectedInstOperands,
     /*  811934 */     // GIR_Coverage, 62168,
     /*  811934 */     GIR_EraseRootFromParent_Done,
     /*  811935 */   // Label 12621: @811935
     /*  811935 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(812018), // Rule ID 62211 //
     /*  811940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  811943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  811948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  811951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  811954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  811957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  811960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811964 */     // MIs[0] op1
     /*  811964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  811967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  811972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811980 */     // MIs[0] op4
     /*  811980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  811983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  811988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  811995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  811998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812000 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812002 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812004 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812006 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812016 */     GIR_RootConstrainSelectedInstOperands,
     /*  812017 */     // GIR_Coverage, 62211,
     /*  812017 */     GIR_EraseRootFromParent_Done,
     /*  812018 */   // Label 12622: @812018
     /*  812018 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(812101), // Rule ID 62212 //
     /*  812023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  812034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  812040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812047 */     // MIs[0] op1
     /*  812047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812063 */     // MIs[0] op4
     /*  812063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812078 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  812078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  812081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812083 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812085 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812087 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812089 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812099 */     GIR_RootConstrainSelectedInstOperands,
     /*  812100 */     // GIR_Coverage, 62212,
     /*  812100 */     GIR_EraseRootFromParent_Done,
     /*  812101 */   // Label 12623: @812101
     /*  812101 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(812184), // Rule ID 62255 //
     /*  812106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  812117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  812120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  812123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812130 */     // MIs[0] op1
     /*  812130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812146 */     // MIs[0] op4
     /*  812146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812161 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  812161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812172 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812182 */     GIR_RootConstrainSelectedInstOperands,
     /*  812183 */     // GIR_Coverage, 62255,
     /*  812183 */     GIR_EraseRootFromParent_Done,
     /*  812184 */   // Label 12624: @812184
     /*  812184 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(812267), // Rule ID 62256 //
     /*  812189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  812200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  812203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  812206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812213 */     // MIs[0] op1
     /*  812213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812229 */     // MIs[0] op4
     /*  812229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  812244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812249 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812251 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812253 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812255 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812265 */     GIR_RootConstrainSelectedInstOperands,
     /*  812266 */     // GIR_Coverage, 62256,
     /*  812266 */     GIR_EraseRootFromParent_Done,
     /*  812267 */   // Label 12625: @812267
     /*  812267 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(812350), // Rule ID 62299 //
     /*  812272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  812283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  812286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  812289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812296 */     // MIs[0] op1
     /*  812296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812312 */     // MIs[0] op4
     /*  812312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812327 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  812327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  812330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812338 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812348 */     GIR_RootConstrainSelectedInstOperands,
     /*  812349 */     // GIR_Coverage, 62299,
     /*  812349 */     GIR_EraseRootFromParent_Done,
     /*  812350 */   // Label 12626: @812350
     /*  812350 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(812433), // Rule ID 62300 //
     /*  812355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  812366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  812369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  812372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812379 */     // MIs[0] op1
     /*  812379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812395 */     // MIs[0] op4
     /*  812395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  812410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  812413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812415 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812417 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812419 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812421 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812431 */     GIR_RootConstrainSelectedInstOperands,
     /*  812432 */     // GIR_Coverage, 62300,
     /*  812432 */     GIR_EraseRootFromParent_Done,
     /*  812433 */   // Label 12627: @812433
     /*  812433 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(812516), // Rule ID 62355 //
     /*  812438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  812449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  812452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  812455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812462 */     // MIs[0] op1
     /*  812462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812478 */     // MIs[0] op4
     /*  812478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  812493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812504 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812514 */     GIR_RootConstrainSelectedInstOperands,
     /*  812515 */     // GIR_Coverage, 62355,
     /*  812515 */     GIR_EraseRootFromParent_Done,
     /*  812516 */   // Label 12628: @812516
     /*  812516 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(812599), // Rule ID 62356 //
     /*  812521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  812532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  812535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  812538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812545 */     // MIs[0] op1
     /*  812545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812561 */     // MIs[0] op4
     /*  812561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  812576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812587 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812597 */     GIR_RootConstrainSelectedInstOperands,
     /*  812598 */     // GIR_Coverage, 62356,
     /*  812598 */     GIR_EraseRootFromParent_Done,
     /*  812599 */   // Label 12629: @812599
     /*  812599 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(812682), // Rule ID 62411 //
     /*  812604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  812615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  812618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  812621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812628 */     // MIs[0] op1
     /*  812628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812644 */     // MIs[0] op4
     /*  812644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812659 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  812659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812664 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812666 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812668 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812670 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812680 */     GIR_RootConstrainSelectedInstOperands,
     /*  812681 */     // GIR_Coverage, 62411,
     /*  812681 */     GIR_EraseRootFromParent_Done,
     /*  812682 */   // Label 12630: @812682
     /*  812682 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(812765), // Rule ID 62412 //
     /*  812687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  812698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  812701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  812704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812711 */     // MIs[0] op1
     /*  812711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812727 */     // MIs[0] op4
     /*  812727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  812742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  812745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812747 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812749 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812751 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812753 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812763 */     GIR_RootConstrainSelectedInstOperands,
     /*  812764 */     // GIR_Coverage, 62412,
     /*  812764 */     GIR_EraseRootFromParent_Done,
     /*  812765 */   // Label 12631: @812765
     /*  812765 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(812848), // Rule ID 62467 //
     /*  812770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  812784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812794 */     // MIs[0] op1
     /*  812794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812810 */     // MIs[0] op4
     /*  812810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  812825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  812828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812836 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812846 */     GIR_RootConstrainSelectedInstOperands,
     /*  812847 */     // GIR_Coverage, 62467,
     /*  812847 */     GIR_EraseRootFromParent_Done,
     /*  812848 */   // Label 12632: @812848
     /*  812848 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(812931), // Rule ID 62468 //
     /*  812853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  812856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  812867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  812873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812877 */     // MIs[0] op1
     /*  812877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812893 */     // MIs[0] op4
     /*  812893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  812908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  812911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812913 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812915 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  812917 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  812919 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  812921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812929 */     GIR_RootConstrainSelectedInstOperands,
     /*  812930 */     // GIR_Coverage, 62468,
     /*  812930 */     GIR_EraseRootFromParent_Done,
     /*  812931 */   // Label 12633: @812931
     /*  812931 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(813014), // Rule ID 62511 //
     /*  812936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  812939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  812944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  812950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  812956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812960 */     // MIs[0] op1
     /*  812960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  812963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  812968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812976 */     // MIs[0] op4
     /*  812976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  812979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  812984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  812991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  812994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812996 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  812998 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813000 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813002 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813012 */     GIR_RootConstrainSelectedInstOperands,
     /*  813013 */     // GIR_Coverage, 62511,
     /*  813013 */     GIR_EraseRootFromParent_Done,
     /*  813014 */   // Label 12634: @813014
     /*  813014 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(813097), // Rule ID 62512 //
     /*  813019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813043 */     // MIs[0] op1
     /*  813043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813059 */     // MIs[0] op4
     /*  813059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  813074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  813077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813079 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813081 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813083 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813085 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813095 */     GIR_RootConstrainSelectedInstOperands,
     /*  813096 */     // GIR_Coverage, 62512,
     /*  813096 */     GIR_EraseRootFromParent_Done,
     /*  813097 */   // Label 12635: @813097
     /*  813097 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(813180), // Rule ID 62567 //
     /*  813102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813126 */     // MIs[0] op1
     /*  813126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813142 */     // MIs[0] op4
     /*  813142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  813157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  813160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813168 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813178 */     GIR_RootConstrainSelectedInstOperands,
     /*  813179 */     // GIR_Coverage, 62567,
     /*  813179 */     GIR_EraseRootFromParent_Done,
     /*  813180 */   // Label 12636: @813180
     /*  813180 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(813263), // Rule ID 62568 //
     /*  813185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813209 */     // MIs[0] op1
     /*  813209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813225 */     // MIs[0] op4
     /*  813225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  813240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  813243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813245 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813247 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813249 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813251 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813261 */     GIR_RootConstrainSelectedInstOperands,
     /*  813262 */     // GIR_Coverage, 62568,
     /*  813262 */     GIR_EraseRootFromParent_Done,
     /*  813263 */   // Label 12637: @813263
     /*  813263 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(813346), // Rule ID 62623 //
     /*  813268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  813282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813292 */     // MIs[0] op1
     /*  813292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813308 */     // MIs[0] op4
     /*  813308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813323 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  813323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  813326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813328 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813330 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813332 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813334 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813344 */     GIR_RootConstrainSelectedInstOperands,
     /*  813345 */     // GIR_Coverage, 62623,
     /*  813345 */     GIR_EraseRootFromParent_Done,
     /*  813346 */   // Label 12638: @813346
     /*  813346 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(813429), // Rule ID 62624 //
     /*  813351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  813365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813375 */     // MIs[0] op1
     /*  813375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813391 */     // MIs[0] op4
     /*  813391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  813406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  813409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813411 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813413 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813415 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813417 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813427 */     GIR_RootConstrainSelectedInstOperands,
     /*  813428 */     // GIR_Coverage, 62624,
     /*  813428 */     GIR_EraseRootFromParent_Done,
     /*  813429 */   // Label 12639: @813429
     /*  813429 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(813512), // Rule ID 62679 //
     /*  813434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  813445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  813448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  813451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813458 */     // MIs[0] op1
     /*  813458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813474 */     // MIs[0] op4
     /*  813474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813489 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  813489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  813492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813500 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813510 */     GIR_RootConstrainSelectedInstOperands,
     /*  813511 */     // GIR_Coverage, 62679,
     /*  813511 */     GIR_EraseRootFromParent_Done,
     /*  813512 */   // Label 12640: @813512
     /*  813512 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(813595), // Rule ID 62680 //
     /*  813517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  813528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  813531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  813534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813541 */     // MIs[0] op1
     /*  813541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813557 */     // MIs[0] op4
     /*  813557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  813572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  813575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813577 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813579 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813581 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813583 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813593 */     GIR_RootConstrainSelectedInstOperands,
     /*  813594 */     // GIR_Coverage, 62680,
     /*  813594 */     GIR_EraseRootFromParent_Done,
     /*  813595 */   // Label 12641: @813595
     /*  813595 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(813678), // Rule ID 62723 //
     /*  813600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  813611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  813614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  813617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813624 */     // MIs[0] op1
     /*  813624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813640 */     // MIs[0] op4
     /*  813640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813655 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  813655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  813658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813666 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813676 */     GIR_RootConstrainSelectedInstOperands,
     /*  813677 */     // GIR_Coverage, 62723,
     /*  813677 */     GIR_EraseRootFromParent_Done,
     /*  813678 */   // Label 12642: @813678
     /*  813678 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(813761), // Rule ID 62724 //
     /*  813683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  813694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  813697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  813700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813707 */     // MIs[0] op1
     /*  813707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813723 */     // MIs[0] op4
     /*  813723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813738 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  813738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  813741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813743 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813745 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813747 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813749 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813759 */     GIR_RootConstrainSelectedInstOperands,
     /*  813760 */     // GIR_Coverage, 62724,
     /*  813760 */     GIR_EraseRootFromParent_Done,
     /*  813761 */   // Label 12643: @813761
     /*  813761 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(813844), // Rule ID 62767 //
     /*  813766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  813777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  813780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  813783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813790 */     // MIs[0] op1
     /*  813790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813806 */     // MIs[0] op4
     /*  813806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813821 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  813821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  813824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813826 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813828 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813830 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813832 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813842 */     GIR_RootConstrainSelectedInstOperands,
     /*  813843 */     // GIR_Coverage, 62767,
     /*  813843 */     GIR_EraseRootFromParent_Done,
     /*  813844 */   // Label 12644: @813844
     /*  813844 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(813927), // Rule ID 62768 //
     /*  813849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  813852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  813860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  813863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  813866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  813869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813873 */     // MIs[0] op1
     /*  813873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813889 */     // MIs[0] op4
     /*  813889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813904 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  813904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  813907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813909 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813911 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813913 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813915 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  813917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813925 */     GIR_RootConstrainSelectedInstOperands,
     /*  813926 */     // GIR_Coverage, 62768,
     /*  813926 */     GIR_EraseRootFromParent_Done,
     /*  813927 */   // Label 12645: @813927
     /*  813927 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(814010), // Rule ID 62811 //
     /*  813932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  813935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  813940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  813943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  813946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  813949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  813952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813956 */     // MIs[0] op1
     /*  813956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  813959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  813964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813972 */     // MIs[0] op4
     /*  813972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  813975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  813980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  813987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  813990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813992 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  813994 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  813996 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  813998 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814008 */     GIR_RootConstrainSelectedInstOperands,
     /*  814009 */     // GIR_Coverage, 62811,
     /*  814009 */     GIR_EraseRootFromParent_Done,
     /*  814010 */   // Label 12646: @814010
     /*  814010 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(814093), // Rule ID 62812 //
     /*  814015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  814026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  814032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814039 */     // MIs[0] op1
     /*  814039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814055 */     // MIs[0] op4
     /*  814055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  814070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  814073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814075 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814077 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814079 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814081 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814091 */     GIR_RootConstrainSelectedInstOperands,
     /*  814092 */     // GIR_Coverage, 62812,
     /*  814092 */     GIR_EraseRootFromParent_Done,
     /*  814093 */   // Label 12647: @814093
     /*  814093 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(814176), // Rule ID 62867 //
     /*  814098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  814109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  814115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814122 */     // MIs[0] op1
     /*  814122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814138 */     // MIs[0] op4
     /*  814138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814153 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  814153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  814156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814158 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814160 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814162 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814164 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814174 */     GIR_RootConstrainSelectedInstOperands,
     /*  814175 */     // GIR_Coverage, 62867,
     /*  814175 */     GIR_EraseRootFromParent_Done,
     /*  814176 */   // Label 12648: @814176
     /*  814176 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(814259), // Rule ID 62868 //
     /*  814181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  814192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  814198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814205 */     // MIs[0] op1
     /*  814205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814221 */     // MIs[0] op4
     /*  814221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  814236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  814239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814241 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814243 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814245 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814247 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814257 */     GIR_RootConstrainSelectedInstOperands,
     /*  814258 */     // GIR_Coverage, 62868,
     /*  814258 */     GIR_EraseRootFromParent_Done,
     /*  814259 */   // Label 12649: @814259
     /*  814259 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(814342), // Rule ID 62923 //
     /*  814264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  814275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  814281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814288 */     // MIs[0] op1
     /*  814288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814304 */     // MIs[0] op4
     /*  814304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814319 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  814319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  814322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814324 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814326 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814328 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814330 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814340 */     GIR_RootConstrainSelectedInstOperands,
     /*  814341 */     // GIR_Coverage, 62923,
     /*  814341 */     GIR_EraseRootFromParent_Done,
     /*  814342 */   // Label 12650: @814342
     /*  814342 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(814425), // Rule ID 62924 //
     /*  814347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  814358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  814364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814371 */     // MIs[0] op1
     /*  814371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814387 */     // MIs[0] op4
     /*  814387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  814402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  814405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814407 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814409 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814411 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814413 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814423 */     GIR_RootConstrainSelectedInstOperands,
     /*  814424 */     // GIR_Coverage, 62924,
     /*  814424 */     GIR_EraseRootFromParent_Done,
     /*  814425 */   // Label 12651: @814425
     /*  814425 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(814508), // Rule ID 62979 //
     /*  814430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  814441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  814444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  814447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814454 */     // MIs[0] op1
     /*  814454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814470 */     // MIs[0] op4
     /*  814470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  814485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  814488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814490 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814492 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814494 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814496 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814506 */     GIR_RootConstrainSelectedInstOperands,
     /*  814507 */     // GIR_Coverage, 62979,
     /*  814507 */     GIR_EraseRootFromParent_Done,
     /*  814508 */   // Label 12652: @814508
     /*  814508 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(814591), // Rule ID 62980 //
     /*  814513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  814524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  814527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  814530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814537 */     // MIs[0] op1
     /*  814537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814553 */     // MIs[0] op4
     /*  814553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  814568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  814571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814573 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814575 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814577 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814579 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814589 */     GIR_RootConstrainSelectedInstOperands,
     /*  814590 */     // GIR_Coverage, 62980,
     /*  814590 */     GIR_EraseRootFromParent_Done,
     /*  814591 */   // Label 12653: @814591
     /*  814591 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(814674), // Rule ID 63035 //
     /*  814596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  814607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  814610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  814613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814620 */     // MIs[0] op1
     /*  814620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814636 */     // MIs[0] op4
     /*  814636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  814651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  814654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814656 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814658 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814660 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814662 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814672 */     GIR_RootConstrainSelectedInstOperands,
     /*  814673 */     // GIR_Coverage, 63035,
     /*  814673 */     GIR_EraseRootFromParent_Done,
     /*  814674 */   // Label 12654: @814674
     /*  814674 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(814757), // Rule ID 63036 //
     /*  814679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  814690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  814693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  814696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814703 */     // MIs[0] op1
     /*  814703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814719 */     // MIs[0] op4
     /*  814719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  814734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  814737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814739 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814741 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814743 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814745 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814755 */     GIR_RootConstrainSelectedInstOperands,
     /*  814756 */     // GIR_Coverage, 63036,
     /*  814756 */     GIR_EraseRootFromParent_Done,
     /*  814757 */   // Label 12655: @814757
     /*  814757 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(814840), // Rule ID 63091 //
     /*  814762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  814773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  814776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  814779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814786 */     // MIs[0] op1
     /*  814786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814802 */     // MIs[0] op4
     /*  814802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814817 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  814817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  814820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814828 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814838 */     GIR_RootConstrainSelectedInstOperands,
     /*  814839 */     // GIR_Coverage, 63091,
     /*  814839 */     GIR_EraseRootFromParent_Done,
     /*  814840 */   // Label 12656: @814840
     /*  814840 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(814923), // Rule ID 63092 //
     /*  814845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  814848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  814856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  814859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  814862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  814865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814869 */     // MIs[0] op1
     /*  814869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814885 */     // MIs[0] op4
     /*  814885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  814900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  814903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814905 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814907 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814909 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814911 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814921 */     GIR_RootConstrainSelectedInstOperands,
     /*  814922 */     // GIR_Coverage, 63092,
     /*  814922 */     GIR_EraseRootFromParent_Done,
     /*  814923 */   // Label 12657: @814923
     /*  814923 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(815006), // Rule ID 63147 //
     /*  814928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  814931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  814936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  814939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  814942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  814945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  814948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814952 */     // MIs[0] op1
     /*  814952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  814955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  814960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814968 */     // MIs[0] op4
     /*  814968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  814971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  814976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  814983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  814986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  814990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  814992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  814994 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  814996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815004 */     GIR_RootConstrainSelectedInstOperands,
     /*  815005 */     // GIR_Coverage, 63147,
     /*  815005 */     GIR_EraseRootFromParent_Done,
     /*  815006 */   // Label 12658: @815006
     /*  815006 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(815089), // Rule ID 63148 //
     /*  815011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  815019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  815022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  815028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815035 */     // MIs[0] op1
     /*  815035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815051 */     // MIs[0] op4
     /*  815051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  815066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  815069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815077 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815087 */     GIR_RootConstrainSelectedInstOperands,
     /*  815088 */     // GIR_Coverage, 63148,
     /*  815088 */     GIR_EraseRootFromParent_Done,
     /*  815089 */   // Label 12659: @815089
     /*  815089 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(815172), // Rule ID 63203 //
     /*  815094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  815102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  815105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  815111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815118 */     // MIs[0] op1
     /*  815118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815134 */     // MIs[0] op4
     /*  815134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  815149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  815152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815154 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815156 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815158 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815160 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815170 */     GIR_RootConstrainSelectedInstOperands,
     /*  815171 */     // GIR_Coverage, 63203,
     /*  815171 */     GIR_EraseRootFromParent_Done,
     /*  815172 */   // Label 12660: @815172
     /*  815172 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(815255), // Rule ID 63204 //
     /*  815177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  815185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  815188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  815194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815201 */     // MIs[0] op1
     /*  815201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815217 */     // MIs[0] op4
     /*  815217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  815232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  815235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815237 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815239 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815241 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815243 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815253 */     GIR_RootConstrainSelectedInstOperands,
     /*  815254 */     // GIR_Coverage, 63204,
     /*  815254 */     GIR_EraseRootFromParent_Done,
     /*  815255 */   // Label 12661: @815255
     /*  815255 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(815338), // Rule ID 63259 //
     /*  815260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  815268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  815271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  815277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815284 */     // MIs[0] op1
     /*  815284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815300 */     // MIs[0] op4
     /*  815300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  815315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  815318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815320 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815322 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815324 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815326 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815336 */     GIR_RootConstrainSelectedInstOperands,
     /*  815337 */     // GIR_Coverage, 63259,
     /*  815337 */     GIR_EraseRootFromParent_Done,
     /*  815338 */   // Label 12662: @815338
     /*  815338 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(815421), // Rule ID 63260 //
     /*  815343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  815351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  815354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  815360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815367 */     // MIs[0] op1
     /*  815367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815383 */     // MIs[0] op4
     /*  815383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10762:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  815398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  815401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815409 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815419 */     GIR_RootConstrainSelectedInstOperands,
     /*  815420 */     // GIR_Coverage, 63260,
     /*  815420 */     GIR_EraseRootFromParent_Done,
     /*  815421 */   // Label 12663: @815421
     /*  815421 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(815504), // Rule ID 63289 //
     /*  815426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  815437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  815440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  815443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815450 */     // MIs[0] op1
     /*  815450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815466 */     // MIs[0] op4
     /*  815466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815481 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  815481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  815484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815502 */     GIR_RootConstrainSelectedInstOperands,
     /*  815503 */     // GIR_Coverage, 63289,
     /*  815503 */     GIR_EraseRootFromParent_Done,
     /*  815504 */   // Label 12664: @815504
     /*  815504 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(815587), // Rule ID 63290 //
     /*  815509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  815520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  815523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  815526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815533 */     // MIs[0] op1
     /*  815533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815549 */     // MIs[0] op4
     /*  815549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  815564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  815567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815575 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815585 */     GIR_RootConstrainSelectedInstOperands,
     /*  815586 */     // GIR_Coverage, 63290,
     /*  815586 */     GIR_EraseRootFromParent_Done,
     /*  815587 */   // Label 12665: @815587
     /*  815587 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(815670), // Rule ID 63307 //
     /*  815592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  815603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  815606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  815609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815616 */     // MIs[0] op1
     /*  815616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815632 */     // MIs[0] op4
     /*  815632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815647 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  815647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  815650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815668 */     GIR_RootConstrainSelectedInstOperands,
     /*  815669 */     // GIR_Coverage, 63307,
     /*  815669 */     GIR_EraseRootFromParent_Done,
     /*  815670 */   // Label 12666: @815670
     /*  815670 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(815753), // Rule ID 63308 //
     /*  815675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  815686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  815689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  815692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815699 */     // MIs[0] op1
     /*  815699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815715 */     // MIs[0] op4
     /*  815715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  815730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  815733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815741 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815751 */     GIR_RootConstrainSelectedInstOperands,
     /*  815752 */     // GIR_Coverage, 63308,
     /*  815752 */     GIR_EraseRootFromParent_Done,
     /*  815753 */   // Label 12667: @815753
     /*  815753 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(815836), // Rule ID 63325 //
     /*  815758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  815772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  815775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815782 */     // MIs[0] op1
     /*  815782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815798 */     // MIs[0] op4
     /*  815798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  815813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  815816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815834 */     GIR_RootConstrainSelectedInstOperands,
     /*  815835 */     // GIR_Coverage, 63325,
     /*  815835 */     GIR_EraseRootFromParent_Done,
     /*  815836 */   // Label 12668: @815836
     /*  815836 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(815919), // Rule ID 63326 //
     /*  815841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  815844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  815855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  815858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  815861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815865 */     // MIs[0] op1
     /*  815865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815881 */     // MIs[0] op4
     /*  815881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  815896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  815899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815907 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815917 */     GIR_RootConstrainSelectedInstOperands,
     /*  815918 */     // GIR_Coverage, 63326,
     /*  815918 */     GIR_EraseRootFromParent_Done,
     /*  815919 */   // Label 12669: @815919
     /*  815919 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(816002), // Rule ID 63343 //
     /*  815924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  815927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  815932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  815935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  815944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815948 */     // MIs[0] op1
     /*  815948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  815951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  815956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815964 */     // MIs[0] op4
     /*  815964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  815967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  815972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815979 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  815979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  815982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  815986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  815988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  815990 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  815992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816000 */     GIR_RootConstrainSelectedInstOperands,
     /*  816001 */     // GIR_Coverage, 63343,
     /*  816001 */     GIR_EraseRootFromParent_Done,
     /*  816002 */   // Label 12670: @816002
     /*  816002 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(816085), // Rule ID 63344 //
     /*  816007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  816018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  816021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816031 */     // MIs[0] op1
     /*  816031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816047 */     // MIs[0] op4
     /*  816047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  816062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  816065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816073 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816083 */     GIR_RootConstrainSelectedInstOperands,
     /*  816084 */     // GIR_Coverage, 63344,
     /*  816084 */     GIR_EraseRootFromParent_Done,
     /*  816085 */   // Label 12671: @816085
     /*  816085 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(816168), // Rule ID 63361 //
     /*  816090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  816101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  816104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  816107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816114 */     // MIs[0] op1
     /*  816114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816130 */     // MIs[0] op4
     /*  816130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816145 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  816145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  816148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816166 */     GIR_RootConstrainSelectedInstOperands,
     /*  816167 */     // GIR_Coverage, 63361,
     /*  816167 */     GIR_EraseRootFromParent_Done,
     /*  816168 */   // Label 12672: @816168
     /*  816168 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(816251), // Rule ID 63362 //
     /*  816173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  816184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  816187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  816190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816197 */     // MIs[0] op1
     /*  816197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816213 */     // MIs[0] op4
     /*  816213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  816228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  816231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816239 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816249 */     GIR_RootConstrainSelectedInstOperands,
     /*  816250 */     // GIR_Coverage, 63362,
     /*  816250 */     GIR_EraseRootFromParent_Done,
     /*  816251 */   // Label 12673: @816251
     /*  816251 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(816334), // Rule ID 63379 //
     /*  816256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  816267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  816270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  816273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816280 */     // MIs[0] op1
     /*  816280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816296 */     // MIs[0] op4
     /*  816296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816311 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  816311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  816314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816332 */     GIR_RootConstrainSelectedInstOperands,
     /*  816333 */     // GIR_Coverage, 63379,
     /*  816333 */     GIR_EraseRootFromParent_Done,
     /*  816334 */   // Label 12674: @816334
     /*  816334 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(816417), // Rule ID 63380 //
     /*  816339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  816350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  816353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  816356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816363 */     // MIs[0] op1
     /*  816363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816379 */     // MIs[0] op4
     /*  816379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  816394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  816397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816405 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816415 */     GIR_RootConstrainSelectedInstOperands,
     /*  816416 */     // GIR_Coverage, 63380,
     /*  816416 */     GIR_EraseRootFromParent_Done,
     /*  816417 */   // Label 12675: @816417
     /*  816417 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(816500), // Rule ID 63397 //
     /*  816422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  816433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  816439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816446 */     // MIs[0] op1
     /*  816446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816462 */     // MIs[0] op4
     /*  816462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  816477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  816480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816488 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816498 */     GIR_RootConstrainSelectedInstOperands,
     /*  816499 */     // GIR_Coverage, 63397,
     /*  816499 */     GIR_EraseRootFromParent_Done,
     /*  816500 */   // Label 12676: @816500
     /*  816500 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(816583), // Rule ID 63398 //
     /*  816505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  816516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  816522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816529 */     // MIs[0] op1
     /*  816529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816545 */     // MIs[0] op4
     /*  816545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  816560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  816563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816571 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816581 */     GIR_RootConstrainSelectedInstOperands,
     /*  816582 */     // GIR_Coverage, 63398,
     /*  816582 */     GIR_EraseRootFromParent_Done,
     /*  816583 */   // Label 12677: @816583
     /*  816583 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(816666), // Rule ID 63421 //
     /*  816588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  816602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  816605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816612 */     // MIs[0] op1
     /*  816612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816628 */     // MIs[0] op4
     /*  816628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  816643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  816646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816648 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816650 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816652 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816654 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816664 */     GIR_RootConstrainSelectedInstOperands,
     /*  816665 */     // GIR_Coverage, 63421,
     /*  816665 */     GIR_EraseRootFromParent_Done,
     /*  816666 */   // Label 12678: @816666
     /*  816666 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(816749), // Rule ID 63422 //
     /*  816671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  816685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  816688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816695 */     // MIs[0] op1
     /*  816695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816711 */     // MIs[0] op4
     /*  816711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  816726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  816729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816737 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816747 */     GIR_RootConstrainSelectedInstOperands,
     /*  816748 */     // GIR_Coverage, 63422,
     /*  816748 */     GIR_EraseRootFromParent_Done,
     /*  816749 */   // Label 12679: @816749
     /*  816749 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(816832), // Rule ID 63445 //
     /*  816754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  816765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  816768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816778 */     // MIs[0] op1
     /*  816778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816794 */     // MIs[0] op4
     /*  816794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  816809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  816812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816830 */     GIR_RootConstrainSelectedInstOperands,
     /*  816831 */     // GIR_Coverage, 63445,
     /*  816831 */     GIR_EraseRootFromParent_Done,
     /*  816832 */   // Label 12680: @816832
     /*  816832 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(816915), // Rule ID 63446 //
     /*  816837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  816840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  816848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  816851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  816857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816861 */     // MIs[0] op1
     /*  816861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816877 */     // MIs[0] op4
     /*  816877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  816892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  816895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816897 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816899 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816901 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816903 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816913 */     GIR_RootConstrainSelectedInstOperands,
     /*  816914 */     // GIR_Coverage, 63446,
     /*  816914 */     GIR_EraseRootFromParent_Done,
     /*  816915 */   // Label 12681: @816915
     /*  816915 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(816998), // Rule ID 63469 //
     /*  816920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  816923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  816928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  816931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  816934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  816937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  816940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816944 */     // MIs[0] op1
     /*  816944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  816947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  816952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816960 */     // MIs[0] op4
     /*  816960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  816963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  816968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  816975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  816978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  816982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  816984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  816986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  816988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816996 */     GIR_RootConstrainSelectedInstOperands,
     /*  816997 */     // GIR_Coverage, 63469,
     /*  816997 */     GIR_EraseRootFromParent_Done,
     /*  816998 */   // Label 12682: @816998
     /*  816998 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(817081), // Rule ID 63470 //
     /*  817003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  817014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  817017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  817020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817027 */     // MIs[0] op1
     /*  817027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817043 */     // MIs[0] op4
     /*  817043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  817058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  817061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817069 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817079 */     GIR_RootConstrainSelectedInstOperands,
     /*  817080 */     // GIR_Coverage, 63470,
     /*  817080 */     GIR_EraseRootFromParent_Done,
     /*  817081 */   // Label 12683: @817081
     /*  817081 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(817164), // Rule ID 63493 //
     /*  817086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  817089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  817097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  817100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  817103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  817106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817110 */     // MIs[0] op1
     /*  817110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817126 */     // MIs[0] op4
     /*  817126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817141 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  817141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  817144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817162 */     GIR_RootConstrainSelectedInstOperands,
     /*  817163 */     // GIR_Coverage, 63493,
     /*  817163 */     GIR_EraseRootFromParent_Done,
     /*  817164 */   // Label 12684: @817164
     /*  817164 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(817247), // Rule ID 63494 //
     /*  817169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  817180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  817183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  817186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817193 */     // MIs[0] op1
     /*  817193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817209 */     // MIs[0] op4
     /*  817209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817224 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  817224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  817227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817229 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817231 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817233 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817235 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817245 */     GIR_RootConstrainSelectedInstOperands,
     /*  817246 */     // GIR_Coverage, 63494,
     /*  817246 */     GIR_EraseRootFromParent_Done,
     /*  817247 */   // Label 12685: @817247
     /*  817247 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(817330), // Rule ID 63517 //
     /*  817252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  817255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  817269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  817272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817276 */     // MIs[0] op1
     /*  817276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817292 */     // MIs[0] op4
     /*  817292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817307 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  817307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  817310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817318 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817328 */     GIR_RootConstrainSelectedInstOperands,
     /*  817329 */     // GIR_Coverage, 63517,
     /*  817329 */     GIR_EraseRootFromParent_Done,
     /*  817330 */   // Label 12686: @817330
     /*  817330 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(817413), // Rule ID 63518 //
     /*  817335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  817352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817359 */     // MIs[0] op1
     /*  817359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817375 */     // MIs[0] op4
     /*  817375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  817390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  817393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817395 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817397 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817399 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817401 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817411 */     GIR_RootConstrainSelectedInstOperands,
     /*  817412 */     // GIR_Coverage, 63518,
     /*  817412 */     GIR_EraseRootFromParent_Done,
     /*  817413 */   // Label 12687: @817413
     /*  817413 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(817496), // Rule ID 63541 //
     /*  817418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  817421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  817429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  817432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  817438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817442 */     // MIs[0] op1
     /*  817442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817458 */     // MIs[0] op4
     /*  817458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  817473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  817476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817494 */     GIR_RootConstrainSelectedInstOperands,
     /*  817495 */     // GIR_Coverage, 63541,
     /*  817495 */     GIR_EraseRootFromParent_Done,
     /*  817496 */   // Label 12688: @817496
     /*  817496 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(817579), // Rule ID 63542 //
     /*  817501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  817512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  817515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817525 */     // MIs[0] op1
     /*  817525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817541 */     // MIs[0] op4
     /*  817541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  817556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  817559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817561 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817563 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817565 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817567 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817577 */     GIR_RootConstrainSelectedInstOperands,
     /*  817578 */     // GIR_Coverage, 63542,
     /*  817578 */     GIR_EraseRootFromParent_Done,
     /*  817579 */   // Label 12689: @817579
     /*  817579 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(817662), // Rule ID 63565 //
     /*  817584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  817587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  817595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  817598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  817601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  817604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817608 */     // MIs[0] op1
     /*  817608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817624 */     // MIs[0] op4
     /*  817624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  817639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  817642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817660 */     GIR_RootConstrainSelectedInstOperands,
     /*  817661 */     // GIR_Coverage, 63565,
     /*  817661 */     GIR_EraseRootFromParent_Done,
     /*  817662 */   // Label 12690: @817662
     /*  817662 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(817745), // Rule ID 63566 //
     /*  817667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  817678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  817681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  817684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817691 */     // MIs[0] op1
     /*  817691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817707 */     // MIs[0] op4
     /*  817707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  817722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  817725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817733 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817743 */     GIR_RootConstrainSelectedInstOperands,
     /*  817744 */     // GIR_Coverage, 63566,
     /*  817744 */     GIR_EraseRootFromParent_Done,
     /*  817745 */   // Label 12691: @817745
     /*  817745 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(817828), // Rule ID 63589 //
     /*  817750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  817753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  817761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  817764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  817767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  817770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817774 */     // MIs[0] op1
     /*  817774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817790 */     // MIs[0] op4
     /*  817790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817805 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  817805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  817808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817816 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817826 */     GIR_RootConstrainSelectedInstOperands,
     /*  817827 */     // GIR_Coverage, 63589,
     /*  817827 */     GIR_EraseRootFromParent_Done,
     /*  817828 */   // Label 12692: @817828
     /*  817828 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(817911), // Rule ID 63590 //
     /*  817833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  817836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  817841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  817844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  817847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  817850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  817853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817857 */     // MIs[0] op1
     /*  817857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  817860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  817865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817873 */     // MIs[0] op4
     /*  817873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  817876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  817881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  817888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  817891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817893 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  817895 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  817897 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  817899 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  817901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817909 */     GIR_RootConstrainSelectedInstOperands,
     /*  817910 */     // GIR_Coverage, 63590,
     /*  817910 */     GIR_EraseRootFromParent_Done,
     /*  817911 */   // Label 12693: @817911
     /*  817911 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(817989), // Rule ID 59882 //
     /*  817916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  817919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  817924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  817927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  817930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817948 */     // MIs[0] rs2
     /*  817948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  817951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  817956 */     // MIs[0] policy
     /*  817956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  817959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  817966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  817969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  817971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  817987 */     GIR_RootConstrainSelectedInstOperands,
     /*  817988 */     // GIR_Coverage, 59882,
     /*  817988 */     GIR_EraseRootFromParent_Done,
     /*  817989 */   // Label 12694: @817989
     /*  817989 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(818067), // Rule ID 59883 //
     /*  817994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  817997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  818005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  818008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  818011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818026 */     // MIs[0] rs2
     /*  818026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818034 */     // MIs[0] policy
     /*  818034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  818047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818065 */     GIR_RootConstrainSelectedInstOperands,
     /*  818066 */     // GIR_Coverage, 59883,
     /*  818066 */     GIR_EraseRootFromParent_Done,
     /*  818067 */   // Label 12695: @818067
     /*  818067 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(818145), // Rule ID 61538 //
     /*  818072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  818075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  818089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818104 */     // MIs[0] rs2
     /*  818104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818112 */     // MIs[0] policy
     /*  818112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  818125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818143 */     GIR_RootConstrainSelectedInstOperands,
     /*  818144 */     // GIR_Coverage, 61538,
     /*  818144 */     GIR_EraseRootFromParent_Done,
     /*  818145 */   // Label 12696: @818145
     /*  818145 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(818223), // Rule ID 61539 //
     /*  818150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  818153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  818167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818182 */     // MIs[0] rs2
     /*  818182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818190 */     // MIs[0] policy
     /*  818190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  818203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818221 */     GIR_RootConstrainSelectedInstOperands,
     /*  818222 */     // GIR_Coverage, 61539,
     /*  818222 */     GIR_EraseRootFromParent_Done,
     /*  818223 */   // Label 12697: @818223
     /*  818223 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(818301), // Rule ID 61540 //
     /*  818228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  818231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  818239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  818242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818260 */     // MIs[0] rs2
     /*  818260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818268 */     // MIs[0] policy
     /*  818268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  818281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818299 */     GIR_RootConstrainSelectedInstOperands,
     /*  818300 */     // GIR_Coverage, 61540,
     /*  818300 */     GIR_EraseRootFromParent_Done,
     /*  818301 */   // Label 12698: @818301
     /*  818301 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(818379), // Rule ID 61541 //
     /*  818306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  818309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  818317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  818320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818338 */     // MIs[0] rs2
     /*  818338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818346 */     // MIs[0] policy
     /*  818346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  818359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818377 */     GIR_RootConstrainSelectedInstOperands,
     /*  818378 */     // GIR_Coverage, 61541,
     /*  818378 */     GIR_EraseRootFromParent_Done,
     /*  818379 */   // Label 12699: @818379
     /*  818379 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(818457), // Rule ID 61542 //
     /*  818384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  818387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  818395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  818398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818416 */     // MIs[0] rs2
     /*  818416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818424 */     // MIs[0] policy
     /*  818424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  818437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818455 */     GIR_RootConstrainSelectedInstOperands,
     /*  818456 */     // GIR_Coverage, 61542,
     /*  818456 */     GIR_EraseRootFromParent_Done,
     /*  818457 */   // Label 12700: @818457
     /*  818457 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(818535), // Rule ID 61543 //
     /*  818462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  818465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  818473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  818476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818494 */     // MIs[0] rs2
     /*  818494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818502 */     // MIs[0] policy
     /*  818502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  818515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818533 */     GIR_RootConstrainSelectedInstOperands,
     /*  818534 */     // GIR_Coverage, 61543,
     /*  818534 */     GIR_EraseRootFromParent_Done,
     /*  818535 */   // Label 12701: @818535
     /*  818535 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(818613), // Rule ID 61544 //
     /*  818540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  818543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  818551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  818554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818572 */     // MIs[0] rs2
     /*  818572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818580 */     // MIs[0] policy
     /*  818580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10845:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  818593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818611 */     GIR_RootConstrainSelectedInstOperands,
     /*  818612 */     // GIR_Coverage, 61544,
     /*  818612 */     GIR_EraseRootFromParent_Done,
     /*  818613 */   // Label 12702: @818613
     /*  818613 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(818691), // Rule ID 61545 //
     /*  818618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  818621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  818626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  818629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  818632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818650 */     // MIs[0] rs2
     /*  818650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818658 */     // MIs[0] policy
     /*  818658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10845:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  818671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818689 */     GIR_RootConstrainSelectedInstOperands,
     /*  818690 */     // GIR_Coverage, 61545,
     /*  818690 */     GIR_EraseRootFromParent_Done,
     /*  818691 */   // Label 12703: @818691
     /*  818691 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(818769), // Rule ID 61706 //
     /*  818696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  818699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  818704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  818707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  818710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  818713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818728 */     // MIs[0] rs2
     /*  818728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818736 */     // MIs[0] policy
     /*  818736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  818749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818767 */     GIR_RootConstrainSelectedInstOperands,
     /*  818768 */     // GIR_Coverage, 61706,
     /*  818768 */     GIR_EraseRootFromParent_Done,
     /*  818769 */   // Label 12704: @818769
     /*  818769 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(818847), // Rule ID 61707 //
     /*  818774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  818777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  818782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  818785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  818788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  818791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818806 */     // MIs[0] rs2
     /*  818806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818814 */     // MIs[0] policy
     /*  818814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  818827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818845 */     GIR_RootConstrainSelectedInstOperands,
     /*  818846 */     // GIR_Coverage, 61707,
     /*  818846 */     GIR_EraseRootFromParent_Done,
     /*  818847 */   // Label 12705: @818847
     /*  818847 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(818925), // Rule ID 61708 //
     /*  818852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  818855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  818860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  818869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818884 */     // MIs[0] rs2
     /*  818884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818892 */     // MIs[0] policy
     /*  818892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  818902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  818905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  818923 */     GIR_RootConstrainSelectedInstOperands,
     /*  818924 */     // GIR_Coverage, 61708,
     /*  818924 */     GIR_EraseRootFromParent_Done,
     /*  818925 */   // Label 12706: @818925
     /*  818925 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(819003), // Rule ID 61709 //
     /*  818930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  818933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  818938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  818947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818962 */     // MIs[0] rs2
     /*  818962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  818965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  818970 */     // MIs[0] policy
     /*  818970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  818973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  818980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  818983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  818985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819001 */     GIR_RootConstrainSelectedInstOperands,
     /*  819002 */     // GIR_Coverage, 61709,
     /*  819002 */     GIR_EraseRootFromParent_Done,
     /*  819003 */   // Label 12707: @819003
     /*  819003 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(819081), // Rule ID 61710 //
     /*  819008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  819011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  819019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  819022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  819025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819040 */     // MIs[0] rs2
     /*  819040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819048 */     // MIs[0] policy
     /*  819048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  819061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819079 */     GIR_RootConstrainSelectedInstOperands,
     /*  819080 */     // GIR_Coverage, 61710,
     /*  819080 */     GIR_EraseRootFromParent_Done,
     /*  819081 */   // Label 12708: @819081
     /*  819081 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(819159), // Rule ID 61711 //
     /*  819086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  819089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  819097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  819100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  819103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819118 */     // MIs[0] rs2
     /*  819118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819126 */     // MIs[0] policy
     /*  819126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  819139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819157 */     GIR_RootConstrainSelectedInstOperands,
     /*  819158 */     // GIR_Coverage, 61711,
     /*  819158 */     GIR_EraseRootFromParent_Done,
     /*  819159 */   // Label 12709: @819159
     /*  819159 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(819237), // Rule ID 61712 //
     /*  819164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  819167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  819175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  819178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819196 */     // MIs[0] rs2
     /*  819196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819204 */     // MIs[0] policy
     /*  819204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  819217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819235 */     GIR_RootConstrainSelectedInstOperands,
     /*  819236 */     // GIR_Coverage, 61712,
     /*  819236 */     GIR_EraseRootFromParent_Done,
     /*  819237 */   // Label 12710: @819237
     /*  819237 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(819315), // Rule ID 61713 //
     /*  819242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  819245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  819253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  819256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819274 */     // MIs[0] rs2
     /*  819274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819282 */     // MIs[0] policy
     /*  819282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  819295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819313 */     GIR_RootConstrainSelectedInstOperands,
     /*  819314 */     // GIR_Coverage, 61713,
     /*  819314 */     GIR_EraseRootFromParent_Done,
     /*  819315 */   // Label 12711: @819315
     /*  819315 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(819393), // Rule ID 61714 //
     /*  819320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  819323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  819331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  819334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819352 */     // MIs[0] rs2
     /*  819352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819360 */     // MIs[0] policy
     /*  819360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  819373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819391 */     GIR_RootConstrainSelectedInstOperands,
     /*  819392 */     // GIR_Coverage, 61714,
     /*  819392 */     GIR_EraseRootFromParent_Done,
     /*  819393 */   // Label 12712: @819393
     /*  819393 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(819471), // Rule ID 61715 //
     /*  819398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  819401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  819406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  819409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  819412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819430 */     // MIs[0] rs2
     /*  819430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  819433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  819438 */     // MIs[0] policy
     /*  819438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819448 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  819451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  819453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819469 */     GIR_RootConstrainSelectedInstOperands,
     /*  819470 */     // GIR_Coverage, 61715,
     /*  819470 */     GIR_EraseRootFromParent_Done,
     /*  819471 */   // Label 12713: @819471
     /*  819471 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(819559), // Rule ID 23548 //
     /*  819476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  819487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  819490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  819496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819523 */     // MIs[1] Operand 1
     /*  819523 */     // No operand predicates
     /*  819523 */     // MIs[0] policy
     /*  819523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  819538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819557 */     GIR_RootConstrainSelectedInstOperands,
     /*  819558 */     // GIR_Coverage, 23548,
     /*  819558 */     GIR_EraseRootFromParent_Done,
     /*  819559 */   // Label 12714: @819559
     /*  819559 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(819647), // Rule ID 23549 //
     /*  819564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  819575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  819578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  819584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819611 */     // MIs[1] Operand 1
     /*  819611 */     // No operand predicates
     /*  819611 */     // MIs[0] policy
     /*  819611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819623 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  819626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819645 */     GIR_RootConstrainSelectedInstOperands,
     /*  819646 */     // GIR_Coverage, 23549,
     /*  819646 */     GIR_EraseRootFromParent_Done,
     /*  819647 */   // Label 12715: @819647
     /*  819647 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(819735), // Rule ID 23552 //
     /*  819652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  819663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  819666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  819672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819699 */     // MIs[1] Operand 1
     /*  819699 */     // No operand predicates
     /*  819699 */     // MIs[0] policy
     /*  819699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819711 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  819714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819733 */     GIR_RootConstrainSelectedInstOperands,
     /*  819734 */     // GIR_Coverage, 23552,
     /*  819734 */     GIR_EraseRootFromParent_Done,
     /*  819735 */   // Label 12716: @819735
     /*  819735 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(819823), // Rule ID 23553 //
     /*  819740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  819751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  819754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  819760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819787 */     // MIs[1] Operand 1
     /*  819787 */     // No operand predicates
     /*  819787 */     // MIs[0] policy
     /*  819787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819799 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  819802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819821 */     GIR_RootConstrainSelectedInstOperands,
     /*  819822 */     // GIR_Coverage, 23553,
     /*  819822 */     GIR_EraseRootFromParent_Done,
     /*  819823 */   // Label 12717: @819823
     /*  819823 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(819911), // Rule ID 23556 //
     /*  819828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  819839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  819842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  819848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819875 */     // MIs[1] Operand 1
     /*  819875 */     // No operand predicates
     /*  819875 */     // MIs[0] policy
     /*  819875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819887 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  819887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  819890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819909 */     GIR_RootConstrainSelectedInstOperands,
     /*  819910 */     // GIR_Coverage, 23556,
     /*  819910 */     GIR_EraseRootFromParent_Done,
     /*  819911 */   // Label 12718: @819911
     /*  819911 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(819999), // Rule ID 23557 //
     /*  819916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  819924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  819927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  819930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  819936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  819955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  819959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  819963 */     // MIs[1] Operand 1
     /*  819963 */     // No operand predicates
     /*  819963 */     // MIs[0] policy
     /*  819963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  819966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  819968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819975 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  819975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  819978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  819987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  819997 */     GIR_RootConstrainSelectedInstOperands,
     /*  819998 */     // GIR_Coverage, 23557,
     /*  819998 */     GIR_EraseRootFromParent_Done,
     /*  819999 */   // Label 12719: @819999
     /*  819999 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(820087), // Rule ID 23560 //
     /*  820004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  820015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  820018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820051 */     // MIs[1] Operand 1
     /*  820051 */     // No operand predicates
     /*  820051 */     // MIs[0] policy
     /*  820051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820063 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  820066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820085 */     GIR_RootConstrainSelectedInstOperands,
     /*  820086 */     // GIR_Coverage, 23560,
     /*  820086 */     GIR_EraseRootFromParent_Done,
     /*  820087 */   // Label 12720: @820087
     /*  820087 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(820175), // Rule ID 23561 //
     /*  820092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  820103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  820106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820139 */     // MIs[1] Operand 1
     /*  820139 */     // No operand predicates
     /*  820139 */     // MIs[0] policy
     /*  820139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  820151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  820154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820173 */     GIR_RootConstrainSelectedInstOperands,
     /*  820174 */     // GIR_Coverage, 23561,
     /*  820174 */     GIR_EraseRootFromParent_Done,
     /*  820175 */   // Label 12721: @820175
     /*  820175 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(820263), // Rule ID 23564 //
     /*  820180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  820191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  820194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820227 */     // MIs[1] Operand 1
     /*  820227 */     // No operand predicates
     /*  820227 */     // MIs[0] policy
     /*  820227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820239 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  820242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820261 */     GIR_RootConstrainSelectedInstOperands,
     /*  820262 */     // GIR_Coverage, 23564,
     /*  820262 */     GIR_EraseRootFromParent_Done,
     /*  820263 */   // Label 12722: @820263
     /*  820263 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(820351), // Rule ID 23565 //
     /*  820268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  820279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  820282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820315 */     // MIs[1] Operand 1
     /*  820315 */     // No operand predicates
     /*  820315 */     // MIs[0] policy
     /*  820315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  820327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  820330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820349 */     GIR_RootConstrainSelectedInstOperands,
     /*  820350 */     // GIR_Coverage, 23565,
     /*  820350 */     GIR_EraseRootFromParent_Done,
     /*  820351 */   // Label 12723: @820351
     /*  820351 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(820439), // Rule ID 23568 //
     /*  820356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  820367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  820370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820403 */     // MIs[1] Operand 1
     /*  820403 */     // No operand predicates
     /*  820403 */     // MIs[0] policy
     /*  820403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820415 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  820418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820437 */     GIR_RootConstrainSelectedInstOperands,
     /*  820438 */     // GIR_Coverage, 23568,
     /*  820438 */     GIR_EraseRootFromParent_Done,
     /*  820439 */   // Label 12724: @820439
     /*  820439 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(820527), // Rule ID 23569 //
     /*  820444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  820455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  820458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820491 */     // MIs[1] Operand 1
     /*  820491 */     // No operand predicates
     /*  820491 */     // MIs[0] policy
     /*  820491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820503 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  820503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  820506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820525 */     GIR_RootConstrainSelectedInstOperands,
     /*  820526 */     // GIR_Coverage, 23569,
     /*  820526 */     GIR_EraseRootFromParent_Done,
     /*  820527 */   // Label 12725: @820527
     /*  820527 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(820615), // Rule ID 23572 //
     /*  820532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820579 */     // MIs[1] Operand 1
     /*  820579 */     // No operand predicates
     /*  820579 */     // MIs[0] policy
     /*  820579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820591 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  820594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820613 */     GIR_RootConstrainSelectedInstOperands,
     /*  820614 */     // GIR_Coverage, 23572,
     /*  820614 */     GIR_EraseRootFromParent_Done,
     /*  820615 */   // Label 12726: @820615
     /*  820615 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(820703), // Rule ID 23573 //
     /*  820620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820667 */     // MIs[1] Operand 1
     /*  820667 */     // No operand predicates
     /*  820667 */     // MIs[0] policy
     /*  820667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820679 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  820679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  820682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820701 */     GIR_RootConstrainSelectedInstOperands,
     /*  820702 */     // GIR_Coverage, 23573,
     /*  820702 */     GIR_EraseRootFromParent_Done,
     /*  820703 */   // Label 12727: @820703
     /*  820703 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(820791), // Rule ID 23576 //
     /*  820708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820755 */     // MIs[1] Operand 1
     /*  820755 */     // No operand predicates
     /*  820755 */     // MIs[0] policy
     /*  820755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820767 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  820770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820789 */     GIR_RootConstrainSelectedInstOperands,
     /*  820790 */     // GIR_Coverage, 23576,
     /*  820790 */     GIR_EraseRootFromParent_Done,
     /*  820791 */   // Label 12728: @820791
     /*  820791 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(820879), // Rule ID 23577 //
     /*  820796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820843 */     // MIs[1] Operand 1
     /*  820843 */     // No operand predicates
     /*  820843 */     // MIs[0] policy
     /*  820843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820855 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  820855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  820858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820877 */     GIR_RootConstrainSelectedInstOperands,
     /*  820878 */     // GIR_Coverage, 23577,
     /*  820878 */     GIR_EraseRootFromParent_Done,
     /*  820879 */   // Label 12729: @820879
     /*  820879 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(820967), // Rule ID 23580 //
     /*  820884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  820904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  820923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  820927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  820931 */     // MIs[1] Operand 1
     /*  820931 */     // No operand predicates
     /*  820931 */     // MIs[0] policy
     /*  820931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  820934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  820936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  820943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  820946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  820955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  820965 */     GIR_RootConstrainSelectedInstOperands,
     /*  820966 */     // GIR_Coverage, 23580,
     /*  820966 */     GIR_EraseRootFromParent_Done,
     /*  820967 */   // Label 12730: @820967
     /*  820967 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(821055), // Rule ID 23581 //
     /*  820972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  820980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  820992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821019 */     // MIs[1] Operand 1
     /*  821019 */     // No operand predicates
     /*  821019 */     // MIs[0] policy
     /*  821019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821031 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  821034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821053 */     GIR_RootConstrainSelectedInstOperands,
     /*  821054 */     // GIR_Coverage, 23581,
     /*  821054 */     GIR_EraseRootFromParent_Done,
     /*  821055 */   // Label 12731: @821055
     /*  821055 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(821143), // Rule ID 23584 //
     /*  821060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821107 */     // MIs[1] Operand 1
     /*  821107 */     // No operand predicates
     /*  821107 */     // MIs[0] policy
     /*  821107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821119 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  821122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821141 */     GIR_RootConstrainSelectedInstOperands,
     /*  821142 */     // GIR_Coverage, 23584,
     /*  821142 */     GIR_EraseRootFromParent_Done,
     /*  821143 */   // Label 12732: @821143
     /*  821143 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(821231), // Rule ID 23585 //
     /*  821148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  821168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821195 */     // MIs[1] Operand 1
     /*  821195 */     // No operand predicates
     /*  821195 */     // MIs[0] policy
     /*  821195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821207 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  821210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821229 */     GIR_RootConstrainSelectedInstOperands,
     /*  821230 */     // GIR_Coverage, 23585,
     /*  821230 */     GIR_EraseRootFromParent_Done,
     /*  821231 */   // Label 12733: @821231
     /*  821231 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(821319), // Rule ID 23588 //
     /*  821236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  821247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  821250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821283 */     // MIs[1] Operand 1
     /*  821283 */     // No operand predicates
     /*  821283 */     // MIs[0] policy
     /*  821283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  821298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821317 */     GIR_RootConstrainSelectedInstOperands,
     /*  821318 */     // GIR_Coverage, 23588,
     /*  821318 */     GIR_EraseRootFromParent_Done,
     /*  821319 */   // Label 12734: @821319
     /*  821319 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(821407), // Rule ID 23589 //
     /*  821324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  821335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  821338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  821344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821371 */     // MIs[1] Operand 1
     /*  821371 */     // No operand predicates
     /*  821371 */     // MIs[0] policy
     /*  821371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  821386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821405 */     GIR_RootConstrainSelectedInstOperands,
     /*  821406 */     // GIR_Coverage, 23589,
     /*  821406 */     GIR_EraseRootFromParent_Done,
     /*  821407 */   // Label 12735: @821407
     /*  821407 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(821495), // Rule ID 23592 //
     /*  821412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  821423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  821426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821459 */     // MIs[1] Operand 1
     /*  821459 */     // No operand predicates
     /*  821459 */     // MIs[0] policy
     /*  821459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  821474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821493 */     GIR_RootConstrainSelectedInstOperands,
     /*  821494 */     // GIR_Coverage, 23592,
     /*  821494 */     GIR_EraseRootFromParent_Done,
     /*  821495 */   // Label 12736: @821495
     /*  821495 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(821583), // Rule ID 23593 //
     /*  821500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  821511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  821514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  821520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821547 */     // MIs[1] Operand 1
     /*  821547 */     // No operand predicates
     /*  821547 */     // MIs[0] policy
     /*  821547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821559 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  821562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821581 */     GIR_RootConstrainSelectedInstOperands,
     /*  821582 */     // GIR_Coverage, 23593,
     /*  821582 */     GIR_EraseRootFromParent_Done,
     /*  821583 */   // Label 12737: @821583
     /*  821583 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(821671), // Rule ID 23596 //
     /*  821588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  821599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  821602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821635 */     // MIs[1] Operand 1
     /*  821635 */     // No operand predicates
     /*  821635 */     // MIs[0] policy
     /*  821635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821647 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  821650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821669 */     GIR_RootConstrainSelectedInstOperands,
     /*  821670 */     // GIR_Coverage, 23596,
     /*  821670 */     GIR_EraseRootFromParent_Done,
     /*  821671 */   // Label 12738: @821671
     /*  821671 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(821759), // Rule ID 23597 //
     /*  821676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  821687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  821690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  821696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821723 */     // MIs[1] Operand 1
     /*  821723 */     // No operand predicates
     /*  821723 */     // MIs[0] policy
     /*  821723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821735 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  821738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821757 */     GIR_RootConstrainSelectedInstOperands,
     /*  821758 */     // GIR_Coverage, 23597,
     /*  821758 */     GIR_EraseRootFromParent_Done,
     /*  821759 */   // Label 12739: @821759
     /*  821759 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(821847), // Rule ID 23600 //
     /*  821764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  821775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  821778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821811 */     // MIs[1] Operand 1
     /*  821811 */     // No operand predicates
     /*  821811 */     // MIs[0] policy
     /*  821811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  821826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821845 */     GIR_RootConstrainSelectedInstOperands,
     /*  821846 */     // GIR_Coverage, 23600,
     /*  821846 */     GIR_EraseRootFromParent_Done,
     /*  821847 */   // Label 12740: @821847
     /*  821847 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(821935), // Rule ID 23601 //
     /*  821852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  821863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  821866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  821872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821899 */     // MIs[1] Operand 1
     /*  821899 */     // No operand predicates
     /*  821899 */     // MIs[0] policy
     /*  821899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  821911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  821914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  821923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  821933 */     GIR_RootConstrainSelectedInstOperands,
     /*  821934 */     // GIR_Coverage, 23601,
     /*  821934 */     GIR_EraseRootFromParent_Done,
     /*  821935 */   // Label 12741: @821935
     /*  821935 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(822023), // Rule ID 23604 //
     /*  821940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  821948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  821951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  821954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  821960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  821979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  821983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  821987 */     // MIs[1] Operand 1
     /*  821987 */     // No operand predicates
     /*  821987 */     // MIs[0] policy
     /*  821987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  821990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  821992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  821999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  822002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822021 */     GIR_RootConstrainSelectedInstOperands,
     /*  822022 */     // GIR_Coverage, 23604,
     /*  822022 */     GIR_EraseRootFromParent_Done,
     /*  822023 */   // Label 12742: @822023
     /*  822023 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(822111), // Rule ID 23605 //
     /*  822028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  822039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  822042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  822045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822075 */     // MIs[1] Operand 1
     /*  822075 */     // No operand predicates
     /*  822075 */     // MIs[0] policy
     /*  822075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  822090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822109 */     GIR_RootConstrainSelectedInstOperands,
     /*  822110 */     // GIR_Coverage, 23605,
     /*  822110 */     GIR_EraseRootFromParent_Done,
     /*  822111 */   // Label 12743: @822111
     /*  822111 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(822199), // Rule ID 23608 //
     /*  822116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  822127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  822130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  822136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822163 */     // MIs[1] Operand 1
     /*  822163 */     // No operand predicates
     /*  822163 */     // MIs[0] policy
     /*  822163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822175 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  822175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  822178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822197 */     GIR_RootConstrainSelectedInstOperands,
     /*  822198 */     // GIR_Coverage, 23608,
     /*  822198 */     GIR_EraseRootFromParent_Done,
     /*  822199 */   // Label 12744: @822199
     /*  822199 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(822287), // Rule ID 23609 //
     /*  822204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  822215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  822218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822251 */     // MIs[1] Operand 1
     /*  822251 */     // No operand predicates
     /*  822251 */     // MIs[0] policy
     /*  822251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822263 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  822266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822285 */     GIR_RootConstrainSelectedInstOperands,
     /*  822286 */     // GIR_Coverage, 23609,
     /*  822286 */     GIR_EraseRootFromParent_Done,
     /*  822287 */   // Label 12745: @822287
     /*  822287 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(822375), // Rule ID 23612 //
     /*  822292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  822303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  822306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  822312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822339 */     // MIs[1] Operand 1
     /*  822339 */     // No operand predicates
     /*  822339 */     // MIs[0] policy
     /*  822339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  822351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  822354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822373 */     GIR_RootConstrainSelectedInstOperands,
     /*  822374 */     // GIR_Coverage, 23612,
     /*  822374 */     GIR_EraseRootFromParent_Done,
     /*  822375 */   // Label 12746: @822375
     /*  822375 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(822463), // Rule ID 23613 //
     /*  822380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  822391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  822394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822427 */     // MIs[1] Operand 1
     /*  822427 */     // No operand predicates
     /*  822427 */     // MIs[0] policy
     /*  822427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  822442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822461 */     GIR_RootConstrainSelectedInstOperands,
     /*  822462 */     // GIR_Coverage, 23613,
     /*  822462 */     GIR_EraseRootFromParent_Done,
     /*  822463 */   // Label 12747: @822463
     /*  822463 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(822551), // Rule ID 23616 //
     /*  822468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  822479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  822482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  822488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822515 */     // MIs[1] Operand 1
     /*  822515 */     // No operand predicates
     /*  822515 */     // MIs[0] policy
     /*  822515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  822527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  822530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822549 */     GIR_RootConstrainSelectedInstOperands,
     /*  822550 */     // GIR_Coverage, 23616,
     /*  822550 */     GIR_EraseRootFromParent_Done,
     /*  822551 */   // Label 12748: @822551
     /*  822551 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(822639), // Rule ID 23617 //
     /*  822556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  822567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  822570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822603 */     // MIs[1] Operand 1
     /*  822603 */     // No operand predicates
     /*  822603 */     // MIs[0] policy
     /*  822603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  822618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822637 */     GIR_RootConstrainSelectedInstOperands,
     /*  822638 */     // GIR_Coverage, 23617,
     /*  822638 */     GIR_EraseRootFromParent_Done,
     /*  822639 */   // Label 12749: @822639
     /*  822639 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(822727), // Rule ID 23620 //
     /*  822644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  822655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  822658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  822664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822691 */     // MIs[1] Operand 1
     /*  822691 */     // No operand predicates
     /*  822691 */     // MIs[0] policy
     /*  822691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822703 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  822703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  822706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822725 */     GIR_RootConstrainSelectedInstOperands,
     /*  822726 */     // GIR_Coverage, 23620,
     /*  822726 */     GIR_EraseRootFromParent_Done,
     /*  822727 */   // Label 12750: @822727
     /*  822727 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(822815), // Rule ID 23621 //
     /*  822732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  822743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  822746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822779 */     // MIs[1] Operand 1
     /*  822779 */     // No operand predicates
     /*  822779 */     // MIs[0] policy
     /*  822779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822791 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  822794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822813 */     GIR_RootConstrainSelectedInstOperands,
     /*  822814 */     // GIR_Coverage, 23621,
     /*  822814 */     GIR_EraseRootFromParent_Done,
     /*  822815 */   // Label 12751: @822815
     /*  822815 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(822903), // Rule ID 23624 //
     /*  822820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  822831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  822834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  822840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822867 */     // MIs[1] Operand 1
     /*  822867 */     // No operand predicates
     /*  822867 */     // MIs[0] policy
     /*  822867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822879 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  822879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  822882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822901 */     GIR_RootConstrainSelectedInstOperands,
     /*  822902 */     // GIR_Coverage, 23624,
     /*  822902 */     GIR_EraseRootFromParent_Done,
     /*  822903 */   // Label 12752: @822903
     /*  822903 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(822991), // Rule ID 23625 //
     /*  822908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  822916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  822919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  822922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  822928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  822947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  822951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  822955 */     // MIs[1] Operand 1
     /*  822955 */     // No operand predicates
     /*  822955 */     // MIs[0] policy
     /*  822955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  822958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  822960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822967 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  822967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  822970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  822979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  822989 */     GIR_RootConstrainSelectedInstOperands,
     /*  822990 */     // GIR_Coverage, 23625,
     /*  822990 */     GIR_EraseRootFromParent_Done,
     /*  822991 */   // Label 12753: @822991
     /*  822991 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(823079), // Rule ID 23628 //
     /*  822996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  823004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  823007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  823010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  823013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823043 */     // MIs[1] Operand 1
     /*  823043 */     // No operand predicates
     /*  823043 */     // MIs[0] policy
     /*  823043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823055 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  823058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823077 */     GIR_RootConstrainSelectedInstOperands,
     /*  823078 */     // GIR_Coverage, 23628,
     /*  823078 */     GIR_EraseRootFromParent_Done,
     /*  823079 */   // Label 12754: @823079
     /*  823079 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(823167), // Rule ID 23629 //
     /*  823084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  823092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  823095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  823098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  823101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823131 */     // MIs[1] Operand 1
     /*  823131 */     // No operand predicates
     /*  823131 */     // MIs[0] policy
     /*  823131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  823143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  823146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823165 */     GIR_RootConstrainSelectedInstOperands,
     /*  823166 */     // GIR_Coverage, 23629,
     /*  823166 */     GIR_EraseRootFromParent_Done,
     /*  823167 */   // Label 12755: @823167
     /*  823167 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(823255), // Rule ID 23632 //
     /*  823172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  823180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  823183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  823186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823219 */     // MIs[1] Operand 1
     /*  823219 */     // No operand predicates
     /*  823219 */     // MIs[0] policy
     /*  823219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  823234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823253 */     GIR_RootConstrainSelectedInstOperands,
     /*  823254 */     // GIR_Coverage, 23632,
     /*  823254 */     GIR_EraseRootFromParent_Done,
     /*  823255 */   // Label 12756: @823255
     /*  823255 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(823343), // Rule ID 23633 //
     /*  823260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  823268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  823271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  823274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823307 */     // MIs[1] Operand 1
     /*  823307 */     // No operand predicates
     /*  823307 */     // MIs[0] policy
     /*  823307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823319 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  823319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  823322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823341 */     GIR_RootConstrainSelectedInstOperands,
     /*  823342 */     // GIR_Coverage, 23633,
     /*  823342 */     GIR_EraseRootFromParent_Done,
     /*  823343 */   // Label 12757: @823343
     /*  823343 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(823431), // Rule ID 23724 //
     /*  823348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  823359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  823362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823395 */     // MIs[1] Operand 1
     /*  823395 */     // No operand predicates
     /*  823395 */     // MIs[0] policy
     /*  823395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823407 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  823410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823429 */     GIR_RootConstrainSelectedInstOperands,
     /*  823430 */     // GIR_Coverage, 23724,
     /*  823430 */     GIR_EraseRootFromParent_Done,
     /*  823431 */   // Label 12758: @823431
     /*  823431 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(823519), // Rule ID 23725 //
     /*  823436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  823447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  823450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823483 */     // MIs[1] Operand 1
     /*  823483 */     // No operand predicates
     /*  823483 */     // MIs[0] policy
     /*  823483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823495 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  823495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  823498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823517 */     GIR_RootConstrainSelectedInstOperands,
     /*  823518 */     // GIR_Coverage, 23725,
     /*  823518 */     GIR_EraseRootFromParent_Done,
     /*  823519 */   // Label 12759: @823519
     /*  823519 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(823607), // Rule ID 23728 //
     /*  823524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  823535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  823538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823571 */     // MIs[1] Operand 1
     /*  823571 */     // No operand predicates
     /*  823571 */     // MIs[0] policy
     /*  823571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823583 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  823586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823605 */     GIR_RootConstrainSelectedInstOperands,
     /*  823606 */     // GIR_Coverage, 23728,
     /*  823606 */     GIR_EraseRootFromParent_Done,
     /*  823607 */   // Label 12760: @823607
     /*  823607 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(823695), // Rule ID 23729 //
     /*  823612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  823623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  823626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823659 */     // MIs[1] Operand 1
     /*  823659 */     // No operand predicates
     /*  823659 */     // MIs[0] policy
     /*  823659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823671 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  823671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  823674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823693 */     GIR_RootConstrainSelectedInstOperands,
     /*  823694 */     // GIR_Coverage, 23729,
     /*  823694 */     GIR_EraseRootFromParent_Done,
     /*  823695 */   // Label 12761: @823695
     /*  823695 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(823783), // Rule ID 23732 //
     /*  823700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  823711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  823714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823747 */     // MIs[1] Operand 1
     /*  823747 */     // No operand predicates
     /*  823747 */     // MIs[0] policy
     /*  823747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  823762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823781 */     GIR_RootConstrainSelectedInstOperands,
     /*  823782 */     // GIR_Coverage, 23732,
     /*  823782 */     GIR_EraseRootFromParent_Done,
     /*  823783 */   // Label 12762: @823783
     /*  823783 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(823871), // Rule ID 23733 //
     /*  823788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  823799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  823802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823835 */     // MIs[1] Operand 1
     /*  823835 */     // No operand predicates
     /*  823835 */     // MIs[0] policy
     /*  823835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823847 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  823847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  823850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823869 */     GIR_RootConstrainSelectedInstOperands,
     /*  823870 */     // GIR_Coverage, 23733,
     /*  823870 */     GIR_EraseRootFromParent_Done,
     /*  823871 */   // Label 12763: @823871
     /*  823871 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(823959), // Rule ID 23736 //
     /*  823876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  823887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  823890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  823896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  823915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  823919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  823923 */     // MIs[1] Operand 1
     /*  823923 */     // No operand predicates
     /*  823923 */     // MIs[0] policy
     /*  823923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  823926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  823928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823935 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  823935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  823938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  823947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  823957 */     GIR_RootConstrainSelectedInstOperands,
     /*  823958 */     // GIR_Coverage, 23736,
     /*  823958 */     GIR_EraseRootFromParent_Done,
     /*  823959 */   // Label 12764: @823959
     /*  823959 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(824047), // Rule ID 23737 //
     /*  823964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  823972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  823975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  823978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  823984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824011 */     // MIs[1] Operand 1
     /*  824011 */     // No operand predicates
     /*  824011 */     // MIs[0] policy
     /*  824011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824023 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  824026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824045 */     GIR_RootConstrainSelectedInstOperands,
     /*  824046 */     // GIR_Coverage, 23737,
     /*  824046 */     GIR_EraseRootFromParent_Done,
     /*  824047 */   // Label 12765: @824047
     /*  824047 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(824135), // Rule ID 23740 //
     /*  824052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  824063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  824066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  824069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824099 */     // MIs[1] Operand 1
     /*  824099 */     // No operand predicates
     /*  824099 */     // MIs[0] policy
     /*  824099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  824114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824133 */     GIR_RootConstrainSelectedInstOperands,
     /*  824134 */     // GIR_Coverage, 23740,
     /*  824134 */     GIR_EraseRootFromParent_Done,
     /*  824135 */   // Label 12766: @824135
     /*  824135 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(824223), // Rule ID 23741 //
     /*  824140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  824151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  824154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  824157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  824160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824187 */     // MIs[1] Operand 1
     /*  824187 */     // No operand predicates
     /*  824187 */     // MIs[0] policy
     /*  824187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824199 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  824202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824221 */     GIR_RootConstrainSelectedInstOperands,
     /*  824222 */     // GIR_Coverage, 23741,
     /*  824222 */     GIR_EraseRootFromParent_Done,
     /*  824223 */   // Label 12767: @824223
     /*  824223 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(824311), // Rule ID 23744 //
     /*  824228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  824239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  824242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  824245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824275 */     // MIs[1] Operand 1
     /*  824275 */     // No operand predicates
     /*  824275 */     // MIs[0] policy
     /*  824275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824287 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  824290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824309 */     GIR_RootConstrainSelectedInstOperands,
     /*  824310 */     // GIR_Coverage, 23744,
     /*  824310 */     GIR_EraseRootFromParent_Done,
     /*  824311 */   // Label 12768: @824311
     /*  824311 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(824399), // Rule ID 23745 //
     /*  824316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  824327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  824330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  824333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  824336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824363 */     // MIs[1] Operand 1
     /*  824363 */     // No operand predicates
     /*  824363 */     // MIs[0] policy
     /*  824363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  824378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824397 */     GIR_RootConstrainSelectedInstOperands,
     /*  824398 */     // GIR_Coverage, 23745,
     /*  824398 */     GIR_EraseRootFromParent_Done,
     /*  824399 */   // Label 12769: @824399
     /*  824399 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(824487), // Rule ID 23748 //
     /*  824404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824451 */     // MIs[1] Operand 1
     /*  824451 */     // No operand predicates
     /*  824451 */     // MIs[0] policy
     /*  824451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824463 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824485 */     GIR_RootConstrainSelectedInstOperands,
     /*  824486 */     // GIR_Coverage, 23748,
     /*  824486 */     GIR_EraseRootFromParent_Done,
     /*  824487 */   // Label 12770: @824487
     /*  824487 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(824575), // Rule ID 23749 //
     /*  824492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  824512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824539 */     // MIs[1] Operand 1
     /*  824539 */     // No operand predicates
     /*  824539 */     // MIs[0] policy
     /*  824539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824551 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824573 */     GIR_RootConstrainSelectedInstOperands,
     /*  824574 */     // GIR_Coverage, 23749,
     /*  824574 */     GIR_EraseRootFromParent_Done,
     /*  824575 */   // Label 12771: @824575
     /*  824575 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(824663), // Rule ID 23752 //
     /*  824580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824627 */     // MIs[1] Operand 1
     /*  824627 */     // No operand predicates
     /*  824627 */     // MIs[0] policy
     /*  824627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824639 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824661 */     GIR_RootConstrainSelectedInstOperands,
     /*  824662 */     // GIR_Coverage, 23752,
     /*  824662 */     GIR_EraseRootFromParent_Done,
     /*  824663 */   // Label 12772: @824663
     /*  824663 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(824751), // Rule ID 23753 //
     /*  824668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  824688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824715 */     // MIs[1] Operand 1
     /*  824715 */     // No operand predicates
     /*  824715 */     // MIs[0] policy
     /*  824715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824749 */     GIR_RootConstrainSelectedInstOperands,
     /*  824750 */     // GIR_Coverage, 23753,
     /*  824750 */     GIR_EraseRootFromParent_Done,
     /*  824751 */   // Label 12773: @824751
     /*  824751 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(824839), // Rule ID 23756 //
     /*  824756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824803 */     // MIs[1] Operand 1
     /*  824803 */     // No operand predicates
     /*  824803 */     // MIs[0] policy
     /*  824803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824837 */     GIR_RootConstrainSelectedInstOperands,
     /*  824838 */     // GIR_Coverage, 23756,
     /*  824838 */     GIR_EraseRootFromParent_Done,
     /*  824839 */   // Label 12774: @824839
     /*  824839 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(824927), // Rule ID 23757 //
     /*  824844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  824864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824891 */     // MIs[1] Operand 1
     /*  824891 */     // No operand predicates
     /*  824891 */     // MIs[0] policy
     /*  824891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824903 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  824903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  824915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  824925 */     GIR_RootConstrainSelectedInstOperands,
     /*  824926 */     // GIR_Coverage, 23757,
     /*  824926 */     GIR_EraseRootFromParent_Done,
     /*  824927 */   // Label 12775: @824927
     /*  824927 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(825015), // Rule ID 23760 //
     /*  824932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  824940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  824952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  824971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  824975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  824979 */     // MIs[1] Operand 1
     /*  824979 */     // No operand predicates
     /*  824979 */     // MIs[0] policy
     /*  824979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  824982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  824984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  824991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  824994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825013 */     GIR_RootConstrainSelectedInstOperands,
     /*  825014 */     // GIR_Coverage, 23760,
     /*  825014 */     GIR_EraseRootFromParent_Done,
     /*  825015 */   // Label 12776: @825015
     /*  825015 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(825103), // Rule ID 23761 //
     /*  825020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  825037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825067 */     // MIs[1] Operand 1
     /*  825067 */     // No operand predicates
     /*  825067 */     // MIs[0] policy
     /*  825067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825079 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  825082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825101 */     GIR_RootConstrainSelectedInstOperands,
     /*  825102 */     // GIR_Coverage, 23761,
     /*  825102 */     GIR_EraseRootFromParent_Done,
     /*  825103 */   // Label 12777: @825103
     /*  825103 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(825191), // Rule ID 23764 //
     /*  825108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  825119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  825122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  825125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  825128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825155 */     // MIs[1] Operand 1
     /*  825155 */     // No operand predicates
     /*  825155 */     // MIs[0] policy
     /*  825155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825167 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  825167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  825170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825189 */     GIR_RootConstrainSelectedInstOperands,
     /*  825190 */     // GIR_Coverage, 23764,
     /*  825190 */     GIR_EraseRootFromParent_Done,
     /*  825191 */   // Label 12778: @825191
     /*  825191 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(825279), // Rule ID 23765 //
     /*  825196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  825207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  825210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  825213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825243 */     // MIs[1] Operand 1
     /*  825243 */     // No operand predicates
     /*  825243 */     // MIs[0] policy
     /*  825243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  825258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825277 */     GIR_RootConstrainSelectedInstOperands,
     /*  825278 */     // GIR_Coverage, 23765,
     /*  825278 */     GIR_EraseRootFromParent_Done,
     /*  825279 */   // Label 12779: @825279
     /*  825279 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(825367), // Rule ID 23768 //
     /*  825284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  825295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  825298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  825301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  825304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825331 */     // MIs[1] Operand 1
     /*  825331 */     // No operand predicates
     /*  825331 */     // MIs[0] policy
     /*  825331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  825343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  825346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825365 */     GIR_RootConstrainSelectedInstOperands,
     /*  825366 */     // GIR_Coverage, 23768,
     /*  825366 */     GIR_EraseRootFromParent_Done,
     /*  825367 */   // Label 12780: @825367
     /*  825367 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(825455), // Rule ID 23769 //
     /*  825372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  825383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  825386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  825389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825419 */     // MIs[1] Operand 1
     /*  825419 */     // No operand predicates
     /*  825419 */     // MIs[0] policy
     /*  825419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825431 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  825434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825453 */     GIR_RootConstrainSelectedInstOperands,
     /*  825454 */     // GIR_Coverage, 23769,
     /*  825454 */     GIR_EraseRootFromParent_Done,
     /*  825455 */   // Label 12781: @825455
     /*  825455 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(825543), // Rule ID 23772 //
     /*  825460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  825471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  825474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  825477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  825480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825507 */     // MIs[1] Operand 1
     /*  825507 */     // No operand predicates
     /*  825507 */     // MIs[0] policy
     /*  825507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825519 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  825519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  825522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825541 */     GIR_RootConstrainSelectedInstOperands,
     /*  825542 */     // GIR_Coverage, 23772,
     /*  825542 */     GIR_EraseRootFromParent_Done,
     /*  825543 */   // Label 12782: @825543
     /*  825543 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(825631), // Rule ID 23773 //
     /*  825548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  825559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  825562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  825565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825595 */     // MIs[1] Operand 1
     /*  825595 */     // No operand predicates
     /*  825595 */     // MIs[0] policy
     /*  825595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825607 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  825610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825629 */     GIR_RootConstrainSelectedInstOperands,
     /*  825630 */     // GIR_Coverage, 23773,
     /*  825630 */     GIR_EraseRootFromParent_Done,
     /*  825631 */   // Label 12783: @825631
     /*  825631 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(825719), // Rule ID 23776 //
     /*  825636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  825647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  825650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  825656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825683 */     // MIs[1] Operand 1
     /*  825683 */     // No operand predicates
     /*  825683 */     // MIs[0] policy
     /*  825683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825695 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  825695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  825698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825717 */     GIR_RootConstrainSelectedInstOperands,
     /*  825718 */     // GIR_Coverage, 23776,
     /*  825718 */     GIR_EraseRootFromParent_Done,
     /*  825719 */   // Label 12784: @825719
     /*  825719 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(825807), // Rule ID 23777 //
     /*  825724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  825735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  825738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825771 */     // MIs[1] Operand 1
     /*  825771 */     // No operand predicates
     /*  825771 */     // MIs[0] policy
     /*  825771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  825786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825805 */     GIR_RootConstrainSelectedInstOperands,
     /*  825806 */     // GIR_Coverage, 23777,
     /*  825806 */     GIR_EraseRootFromParent_Done,
     /*  825807 */   // Label 12785: @825807
     /*  825807 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(825895), // Rule ID 23780 //
     /*  825812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  825823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  825826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  825832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825859 */     // MIs[1] Operand 1
     /*  825859 */     // No operand predicates
     /*  825859 */     // MIs[0] policy
     /*  825859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  825871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  825874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825893 */     GIR_RootConstrainSelectedInstOperands,
     /*  825894 */     // GIR_Coverage, 23780,
     /*  825894 */     GIR_EraseRootFromParent_Done,
     /*  825895 */   // Label 12786: @825895
     /*  825895 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(825983), // Rule ID 23781 //
     /*  825900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  825911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  825914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  825920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  825939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  825943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  825947 */     // MIs[1] Operand 1
     /*  825947 */     // No operand predicates
     /*  825947 */     // MIs[0] policy
     /*  825947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  825950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  825952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  825959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  825962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  825971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  825981 */     GIR_RootConstrainSelectedInstOperands,
     /*  825982 */     // GIR_Coverage, 23781,
     /*  825982 */     GIR_EraseRootFromParent_Done,
     /*  825983 */   // Label 12787: @825983
     /*  825983 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(826071), // Rule ID 23784 //
     /*  825988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  825996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  825999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  826002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  826005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826035 */     // MIs[1] Operand 1
     /*  826035 */     // No operand predicates
     /*  826035 */     // MIs[0] policy
     /*  826035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826047 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  826050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826069 */     GIR_RootConstrainSelectedInstOperands,
     /*  826070 */     // GIR_Coverage, 23784,
     /*  826070 */     GIR_EraseRootFromParent_Done,
     /*  826071 */   // Label 12788: @826071
     /*  826071 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(826159), // Rule ID 23785 //
     /*  826076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  826087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  826090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  826093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826123 */     // MIs[1] Operand 1
     /*  826123 */     // No operand predicates
     /*  826123 */     // MIs[0] policy
     /*  826123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826135 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  826135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  826138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826157 */     GIR_RootConstrainSelectedInstOperands,
     /*  826158 */     // GIR_Coverage, 23785,
     /*  826158 */     GIR_EraseRootFromParent_Done,
     /*  826159 */   // Label 12789: @826159
     /*  826159 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(826247), // Rule ID 23788 //
     /*  826164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  826175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  826178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  826181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826211 */     // MIs[1] Operand 1
     /*  826211 */     // No operand predicates
     /*  826211 */     // MIs[0] policy
     /*  826211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  826226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826245 */     GIR_RootConstrainSelectedInstOperands,
     /*  826246 */     // GIR_Coverage, 23788,
     /*  826246 */     GIR_EraseRootFromParent_Done,
     /*  826247 */   // Label 12790: @826247
     /*  826247 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(826335), // Rule ID 23789 //
     /*  826252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  826263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  826266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  826269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826299 */     // MIs[1] Operand 1
     /*  826299 */     // No operand predicates
     /*  826299 */     // MIs[0] policy
     /*  826299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  826311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  826314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826333 */     GIR_RootConstrainSelectedInstOperands,
     /*  826334 */     // GIR_Coverage, 23789,
     /*  826334 */     GIR_EraseRootFromParent_Done,
     /*  826335 */   // Label 12791: @826335
     /*  826335 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(826423), // Rule ID 23792 //
     /*  826340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  826351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  826354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  826357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826387 */     // MIs[1] Operand 1
     /*  826387 */     // No operand predicates
     /*  826387 */     // MIs[0] policy
     /*  826387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826399 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  826402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826421 */     GIR_RootConstrainSelectedInstOperands,
     /*  826422 */     // GIR_Coverage, 23792,
     /*  826422 */     GIR_EraseRootFromParent_Done,
     /*  826423 */   // Label 12792: @826423
     /*  826423 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(826511), // Rule ID 23793 //
     /*  826428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  826439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  826442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  826445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826475 */     // MIs[1] Operand 1
     /*  826475 */     // No operand predicates
     /*  826475 */     // MIs[0] policy
     /*  826475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826487 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  826487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  826490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826509 */     GIR_RootConstrainSelectedInstOperands,
     /*  826510 */     // GIR_Coverage, 23793,
     /*  826510 */     GIR_EraseRootFromParent_Done,
     /*  826511 */   // Label 12793: @826511
     /*  826511 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(826599), // Rule ID 23796 //
     /*  826516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  826527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  826530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  826533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826563 */     // MIs[1] Operand 1
     /*  826563 */     // No operand predicates
     /*  826563 */     // MIs[0] policy
     /*  826563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  826578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826597 */     GIR_RootConstrainSelectedInstOperands,
     /*  826598 */     // GIR_Coverage, 23796,
     /*  826598 */     GIR_EraseRootFromParent_Done,
     /*  826599 */   // Label 12794: @826599
     /*  826599 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(826687), // Rule ID 23797 //
     /*  826604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  826615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  826618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  826621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826651 */     // MIs[1] Operand 1
     /*  826651 */     // No operand predicates
     /*  826651 */     // MIs[0] policy
     /*  826651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826663 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  826663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  826666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826685 */     GIR_RootConstrainSelectedInstOperands,
     /*  826686 */     // GIR_Coverage, 23797,
     /*  826686 */     GIR_EraseRootFromParent_Done,
     /*  826687 */   // Label 12795: @826687
     /*  826687 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(826775), // Rule ID 23800 //
     /*  826692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  826703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  826706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826739 */     // MIs[1] Operand 1
     /*  826739 */     // No operand predicates
     /*  826739 */     // MIs[0] policy
     /*  826739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  826754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826773 */     GIR_RootConstrainSelectedInstOperands,
     /*  826774 */     // GIR_Coverage, 23800,
     /*  826774 */     GIR_EraseRootFromParent_Done,
     /*  826775 */   // Label 12796: @826775
     /*  826775 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(826863), // Rule ID 23801 //
     /*  826780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  826791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  826794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826827 */     // MIs[1] Operand 1
     /*  826827 */     // No operand predicates
     /*  826827 */     // MIs[0] policy
     /*  826827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  826839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  826842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826861 */     GIR_RootConstrainSelectedInstOperands,
     /*  826862 */     // GIR_Coverage, 23801,
     /*  826862 */     GIR_EraseRootFromParent_Done,
     /*  826863 */   // Label 12797: @826863
     /*  826863 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(826951), // Rule ID 23804 //
     /*  826868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  826879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  826882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  826888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  826915 */     // MIs[1] Operand 1
     /*  826915 */     // No operand predicates
     /*  826915 */     // MIs[0] policy
     /*  826915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  826918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  826920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  826927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  826930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  826939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  826949 */     GIR_RootConstrainSelectedInstOperands,
     /*  826950 */     // GIR_Coverage, 23804,
     /*  826950 */     GIR_EraseRootFromParent_Done,
     /*  826951 */   // Label 12798: @826951
     /*  826951 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(827039), // Rule ID 23805 //
     /*  826956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  826964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  826967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  826970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  826976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  826995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  826999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827003 */     // MIs[1] Operand 1
     /*  827003 */     // No operand predicates
     /*  827003 */     // MIs[0] policy
     /*  827003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  827018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827037 */     GIR_RootConstrainSelectedInstOperands,
     /*  827038 */     // GIR_Coverage, 23805,
     /*  827038 */     GIR_EraseRootFromParent_Done,
     /*  827039 */   // Label 12799: @827039
     /*  827039 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(827127), // Rule ID 23808 //
     /*  827044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  827052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  827055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  827058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  827061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827091 */     // MIs[1] Operand 1
     /*  827091 */     // No operand predicates
     /*  827091 */     // MIs[0] policy
     /*  827091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827103 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  827106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827125 */     GIR_RootConstrainSelectedInstOperands,
     /*  827126 */     // GIR_Coverage, 23808,
     /*  827126 */     GIR_EraseRootFromParent_Done,
     /*  827127 */   // Label 12800: @827127
     /*  827127 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(827215), // Rule ID 23809 //
     /*  827132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  827140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  827143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  827146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  827149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  827152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827179 */     // MIs[1] Operand 1
     /*  827179 */     // No operand predicates
     /*  827179 */     // MIs[0] policy
     /*  827179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827191 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  827194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827213 */     GIR_RootConstrainSelectedInstOperands,
     /*  827214 */     // GIR_Coverage, 23809,
     /*  827214 */     GIR_EraseRootFromParent_Done,
     /*  827215 */   // Label 12801: @827215
     /*  827215 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(827303), // Rule ID 24048 //
     /*  827220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  827223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  827231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  827234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  827237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827267 */     // MIs[1] Operand 1
     /*  827267 */     // No operand predicates
     /*  827267 */     // MIs[0] policy
     /*  827267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827279 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  827282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827301 */     GIR_RootConstrainSelectedInstOperands,
     /*  827302 */     // GIR_Coverage, 24048,
     /*  827302 */     GIR_EraseRootFromParent_Done,
     /*  827303 */   // Label 12802: @827303
     /*  827303 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(827391), // Rule ID 24049 //
     /*  827308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  827311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  827319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  827322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  827325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  827328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827355 */     // MIs[1] Operand 1
     /*  827355 */     // No operand predicates
     /*  827355 */     // MIs[0] policy
     /*  827355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827367 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  827370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827389 */     GIR_RootConstrainSelectedInstOperands,
     /*  827390 */     // GIR_Coverage, 24049,
     /*  827390 */     GIR_EraseRootFromParent_Done,
     /*  827391 */   // Label 12803: @827391
     /*  827391 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(827479), // Rule ID 24052 //
     /*  827396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  827399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  827407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  827410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827443 */     // MIs[1] Operand 1
     /*  827443 */     // No operand predicates
     /*  827443 */     // MIs[0] policy
     /*  827443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827455 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  827458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827477 */     GIR_RootConstrainSelectedInstOperands,
     /*  827478 */     // GIR_Coverage, 24052,
     /*  827478 */     GIR_EraseRootFromParent_Done,
     /*  827479 */   // Label 12804: @827479
     /*  827479 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(827567), // Rule ID 24053 //
     /*  827484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  827487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  827495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  827498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  827504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827531 */     // MIs[1] Operand 1
     /*  827531 */     // No operand predicates
     /*  827531 */     // MIs[0] policy
     /*  827531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827543 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  827546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827565 */     GIR_RootConstrainSelectedInstOperands,
     /*  827566 */     // GIR_Coverage, 24053,
     /*  827566 */     GIR_EraseRootFromParent_Done,
     /*  827567 */   // Label 12805: @827567
     /*  827567 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(827655), // Rule ID 24056 //
     /*  827572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  827575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  827583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  827586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827619 */     // MIs[1] Operand 1
     /*  827619 */     // No operand predicates
     /*  827619 */     // MIs[0] policy
     /*  827619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827631 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  827634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827653 */     GIR_RootConstrainSelectedInstOperands,
     /*  827654 */     // GIR_Coverage, 24056,
     /*  827654 */     GIR_EraseRootFromParent_Done,
     /*  827655 */   // Label 12806: @827655
     /*  827655 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(827743), // Rule ID 24057 //
     /*  827660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  827663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  827671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  827674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  827680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827707 */     // MIs[1] Operand 1
     /*  827707 */     // No operand predicates
     /*  827707 */     // MIs[0] policy
     /*  827707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827719 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  827722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827741 */     GIR_RootConstrainSelectedInstOperands,
     /*  827742 */     // GIR_Coverage, 24057,
     /*  827742 */     GIR_EraseRootFromParent_Done,
     /*  827743 */   // Label 12807: @827743
     /*  827743 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(827831), // Rule ID 24060 //
     /*  827748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  827751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827795 */     // MIs[1] Operand 1
     /*  827795 */     // No operand predicates
     /*  827795 */     // MIs[0] policy
     /*  827795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  827810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827829 */     GIR_RootConstrainSelectedInstOperands,
     /*  827830 */     // GIR_Coverage, 24060,
     /*  827830 */     GIR_EraseRootFromParent_Done,
     /*  827831 */   // Label 12808: @827831
     /*  827831 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(827919), // Rule ID 24061 //
     /*  827836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  827839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  827856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827883 */     // MIs[1] Operand 1
     /*  827883 */     // No operand predicates
     /*  827883 */     // MIs[0] policy
     /*  827883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827895 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  827895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  827898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  827917 */     GIR_RootConstrainSelectedInstOperands,
     /*  827918 */     // GIR_Coverage, 24061,
     /*  827918 */     GIR_EraseRootFromParent_Done,
     /*  827919 */   // Label 12809: @827919
     /*  827919 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(828007), // Rule ID 24064 //
     /*  827924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  827927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  827932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  827944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  827963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  827967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  827971 */     // MIs[1] Operand 1
     /*  827971 */     // No operand predicates
     /*  827971 */     // MIs[0] policy
     /*  827971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  827974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  827976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827983 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  827983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  827986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  827995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828005 */     GIR_RootConstrainSelectedInstOperands,
     /*  828006 */     // GIR_Coverage, 24064,
     /*  828006 */     GIR_EraseRootFromParent_Done,
     /*  828007 */   // Label 12810: @828007
     /*  828007 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(828095), // Rule ID 24065 //
     /*  828012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  828015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  828029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828059 */     // MIs[1] Operand 1
     /*  828059 */     // No operand predicates
     /*  828059 */     // MIs[0] policy
     /*  828059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828071 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  828074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828093 */     GIR_RootConstrainSelectedInstOperands,
     /*  828094 */     // GIR_Coverage, 24065,
     /*  828094 */     GIR_EraseRootFromParent_Done,
     /*  828095 */   // Label 12811: @828095
     /*  828095 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(828183), // Rule ID 24068 //
     /*  828100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  828103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  828117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  828120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828147 */     // MIs[1] Operand 1
     /*  828147 */     // No operand predicates
     /*  828147 */     // MIs[0] policy
     /*  828147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828159 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  828159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  828162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828181 */     GIR_RootConstrainSelectedInstOperands,
     /*  828182 */     // GIR_Coverage, 24068,
     /*  828182 */     GIR_EraseRootFromParent_Done,
     /*  828183 */   // Label 12812: @828183
     /*  828183 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(828271), // Rule ID 24069 //
     /*  828188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  828191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  828205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828235 */     // MIs[1] Operand 1
     /*  828235 */     // No operand predicates
     /*  828235 */     // MIs[0] policy
     /*  828235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828247 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  828250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828269 */     GIR_RootConstrainSelectedInstOperands,
     /*  828270 */     // GIR_Coverage, 24069,
     /*  828270 */     GIR_EraseRootFromParent_Done,
     /*  828271 */   // Label 12813: @828271
     /*  828271 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(828359), // Rule ID 24072 //
     /*  828276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  828279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  828287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  828290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  828296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828323 */     // MIs[1] Operand 1
     /*  828323 */     // No operand predicates
     /*  828323 */     // MIs[0] policy
     /*  828323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828335 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  828335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  828338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828357 */     GIR_RootConstrainSelectedInstOperands,
     /*  828358 */     // GIR_Coverage, 24072,
     /*  828358 */     GIR_EraseRootFromParent_Done,
     /*  828359 */   // Label 12814: @828359
     /*  828359 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(828447), // Rule ID 24073 //
     /*  828364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  828367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  828375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  828378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828411 */     // MIs[1] Operand 1
     /*  828411 */     // No operand predicates
     /*  828411 */     // MIs[0] policy
     /*  828411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828423 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  828426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828445 */     GIR_RootConstrainSelectedInstOperands,
     /*  828446 */     // GIR_Coverage, 24073,
     /*  828446 */     GIR_EraseRootFromParent_Done,
     /*  828447 */   // Label 12815: @828447
     /*  828447 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(828535), // Rule ID 24076 //
     /*  828452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  828455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  828463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  828466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  828472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828499 */     // MIs[1] Operand 1
     /*  828499 */     // No operand predicates
     /*  828499 */     // MIs[0] policy
     /*  828499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828511 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  828511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  828514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828533 */     GIR_RootConstrainSelectedInstOperands,
     /*  828534 */     // GIR_Coverage, 24076,
     /*  828534 */     GIR_EraseRootFromParent_Done,
     /*  828535 */   // Label 12816: @828535
     /*  828535 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(828623), // Rule ID 24077 //
     /*  828540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  828543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  828551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  828554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828587 */     // MIs[1] Operand 1
     /*  828587 */     // No operand predicates
     /*  828587 */     // MIs[0] policy
     /*  828587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828599 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  828602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828621 */     GIR_RootConstrainSelectedInstOperands,
     /*  828622 */     // GIR_Coverage, 24077,
     /*  828622 */     GIR_EraseRootFromParent_Done,
     /*  828623 */   // Label 12817: @828623
     /*  828623 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(828711), // Rule ID 24080 //
     /*  828628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  828631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  828639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  828642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  828648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828675 */     // MIs[1] Operand 1
     /*  828675 */     // No operand predicates
     /*  828675 */     // MIs[0] policy
     /*  828675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828687 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  828687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  828690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828709 */     GIR_RootConstrainSelectedInstOperands,
     /*  828710 */     // GIR_Coverage, 24080,
     /*  828710 */     GIR_EraseRootFromParent_Done,
     /*  828711 */   // Label 12818: @828711
     /*  828711 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(828799), // Rule ID 24081 //
     /*  828716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  828719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  828727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  828730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828763 */     // MIs[1] Operand 1
     /*  828763 */     // No operand predicates
     /*  828763 */     // MIs[0] policy
     /*  828763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828775 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  828778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828797 */     GIR_RootConstrainSelectedInstOperands,
     /*  828798 */     // GIR_Coverage, 24081,
     /*  828798 */     GIR_EraseRootFromParent_Done,
     /*  828799 */   // Label 12819: @828799
     /*  828799 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(828887), // Rule ID 24084 //
     /*  828804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  828807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  828815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  828818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  828824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828851 */     // MIs[1] Operand 1
     /*  828851 */     // No operand predicates
     /*  828851 */     // MIs[0] policy
     /*  828851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828863 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  828863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  828866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828885 */     GIR_RootConstrainSelectedInstOperands,
     /*  828886 */     // GIR_Coverage, 24084,
     /*  828886 */     GIR_EraseRootFromParent_Done,
     /*  828887 */   // Label 12820: @828887
     /*  828887 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(828975), // Rule ID 24085 //
     /*  828892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  828895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  828903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  828906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  828912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  828931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  828935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  828939 */     // MIs[1] Operand 1
     /*  828939 */     // No operand predicates
     /*  828939 */     // MIs[0] policy
     /*  828939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  828942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  828944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828951 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  828951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  828954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  828963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  828973 */     GIR_RootConstrainSelectedInstOperands,
     /*  828974 */     // GIR_Coverage, 24085,
     /*  828974 */     GIR_EraseRootFromParent_Done,
     /*  828975 */   // Label 12821: @828975
     /*  828975 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(829063), // Rule ID 24088 //
     /*  828980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  828983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  828988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  828991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  828994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829027 */     // MIs[1] Operand 1
     /*  829027 */     // No operand predicates
     /*  829027 */     // MIs[0] policy
     /*  829027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829039 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  829042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829061 */     GIR_RootConstrainSelectedInstOperands,
     /*  829062 */     // GIR_Coverage, 24088,
     /*  829062 */     GIR_EraseRootFromParent_Done,
     /*  829063 */   // Label 12822: @829063
     /*  829063 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(829151), // Rule ID 24089 //
     /*  829068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  829071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  829079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  829082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829115 */     // MIs[1] Operand 1
     /*  829115 */     // No operand predicates
     /*  829115 */     // MIs[0] policy
     /*  829115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829127 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  829127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  829130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829149 */     GIR_RootConstrainSelectedInstOperands,
     /*  829150 */     // GIR_Coverage, 24089,
     /*  829150 */     GIR_EraseRootFromParent_Done,
     /*  829151 */   // Label 12823: @829151
     /*  829151 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(829239), // Rule ID 24092 //
     /*  829156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  829159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  829167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  829170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829203 */     // MIs[1] Operand 1
     /*  829203 */     // No operand predicates
     /*  829203 */     // MIs[0] policy
     /*  829203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829215 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  829218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829237 */     GIR_RootConstrainSelectedInstOperands,
     /*  829238 */     // GIR_Coverage, 24092,
     /*  829238 */     GIR_EraseRootFromParent_Done,
     /*  829239 */   // Label 12824: @829239
     /*  829239 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(829327), // Rule ID 24093 //
     /*  829244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  829247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  829255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  829258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829291 */     // MIs[1] Operand 1
     /*  829291 */     // No operand predicates
     /*  829291 */     // MIs[0] policy
     /*  829291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829303 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  829303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  829306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829325 */     GIR_RootConstrainSelectedInstOperands,
     /*  829326 */     // GIR_Coverage, 24093,
     /*  829326 */     GIR_EraseRootFromParent_Done,
     /*  829327 */   // Label 12825: @829327
     /*  829327 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(829415), // Rule ID 24096 //
     /*  829332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  829335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  829343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  829346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829379 */     // MIs[1] Operand 1
     /*  829379 */     // No operand predicates
     /*  829379 */     // MIs[0] policy
     /*  829379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829391 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  829394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829413 */     GIR_RootConstrainSelectedInstOperands,
     /*  829414 */     // GIR_Coverage, 24096,
     /*  829414 */     GIR_EraseRootFromParent_Done,
     /*  829415 */   // Label 12826: @829415
     /*  829415 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(829503), // Rule ID 24097 //
     /*  829420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  829423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  829431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  829434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829467 */     // MIs[1] Operand 1
     /*  829467 */     // No operand predicates
     /*  829467 */     // MIs[0] policy
     /*  829467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829479 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  829479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  829482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829501 */     GIR_RootConstrainSelectedInstOperands,
     /*  829502 */     // GIR_Coverage, 24097,
     /*  829502 */     GIR_EraseRootFromParent_Done,
     /*  829503 */   // Label 12827: @829503
     /*  829503 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(829591), // Rule ID 24100 //
     /*  829508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  829511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  829519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  829522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829555 */     // MIs[1] Operand 1
     /*  829555 */     // No operand predicates
     /*  829555 */     // MIs[0] policy
     /*  829555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829567 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  829570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829589 */     GIR_RootConstrainSelectedInstOperands,
     /*  829590 */     // GIR_Coverage, 24100,
     /*  829590 */     GIR_EraseRootFromParent_Done,
     /*  829591 */   // Label 12828: @829591
     /*  829591 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(829679), // Rule ID 24101 //
     /*  829596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  829599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  829607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  829610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829643 */     // MIs[1] Operand 1
     /*  829643 */     // No operand predicates
     /*  829643 */     // MIs[0] policy
     /*  829643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829655 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  829655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  829658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829677 */     GIR_RootConstrainSelectedInstOperands,
     /*  829678 */     // GIR_Coverage, 24101,
     /*  829678 */     GIR_EraseRootFromParent_Done,
     /*  829679 */   // Label 12829: @829679
     /*  829679 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(829767), // Rule ID 24104 //
     /*  829684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  829687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  829695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  829698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829731 */     // MIs[1] Operand 1
     /*  829731 */     // No operand predicates
     /*  829731 */     // MIs[0] policy
     /*  829731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829743 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  829746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829765 */     GIR_RootConstrainSelectedInstOperands,
     /*  829766 */     // GIR_Coverage, 24104,
     /*  829766 */     GIR_EraseRootFromParent_Done,
     /*  829767 */   // Label 12830: @829767
     /*  829767 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(829855), // Rule ID 24105 //
     /*  829772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  829775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  829780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  829783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  829786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829819 */     // MIs[1] Operand 1
     /*  829819 */     // No operand predicates
     /*  829819 */     // MIs[0] policy
     /*  829819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829831 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  829831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  829834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829853 */     GIR_RootConstrainSelectedInstOperands,
     /*  829854 */     // GIR_Coverage, 24105,
     /*  829854 */     GIR_EraseRootFromParent_Done,
     /*  829855 */   // Label 12831: @829855
     /*  829855 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(829943), // Rule ID 24168 //
     /*  829860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  829863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  829868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  829871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  829874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  829880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829907 */     // MIs[1] Operand 1
     /*  829907 */     // No operand predicates
     /*  829907 */     // MIs[0] policy
     /*  829907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  829912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829919 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  829919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  829922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  829931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  829941 */     GIR_RootConstrainSelectedInstOperands,
     /*  829942 */     // GIR_Coverage, 24168,
     /*  829942 */     GIR_EraseRootFromParent_Done,
     /*  829943 */   // Label 12832: @829943
     /*  829943 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(830031), // Rule ID 24169 //
     /*  829948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  829951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  829956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  829959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  829962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  829968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  829987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  829991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  829995 */     // MIs[1] Operand 1
     /*  829995 */     // No operand predicates
     /*  829995 */     // MIs[0] policy
     /*  829995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  829998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830007 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  830010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830029 */     GIR_RootConstrainSelectedInstOperands,
     /*  830030 */     // GIR_Coverage, 24169,
     /*  830030 */     GIR_EraseRootFromParent_Done,
     /*  830031 */   // Label 12833: @830031
     /*  830031 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(830119), // Rule ID 24172 //
     /*  830036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  830039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  830047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  830050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830083 */     // MIs[1] Operand 1
     /*  830083 */     // No operand predicates
     /*  830083 */     // MIs[0] policy
     /*  830083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830095 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  830098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830117 */     GIR_RootConstrainSelectedInstOperands,
     /*  830118 */     // GIR_Coverage, 24172,
     /*  830118 */     GIR_EraseRootFromParent_Done,
     /*  830119 */   // Label 12834: @830119
     /*  830119 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(830207), // Rule ID 24173 //
     /*  830124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  830127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  830135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  830138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  830144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830171 */     // MIs[1] Operand 1
     /*  830171 */     // No operand predicates
     /*  830171 */     // MIs[0] policy
     /*  830171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830183 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  830186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830205 */     GIR_RootConstrainSelectedInstOperands,
     /*  830206 */     // GIR_Coverage, 24173,
     /*  830206 */     GIR_EraseRootFromParent_Done,
     /*  830207 */   // Label 12835: @830207
     /*  830207 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(830295), // Rule ID 24176 //
     /*  830212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  830215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  830223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  830226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830259 */     // MIs[1] Operand 1
     /*  830259 */     // No operand predicates
     /*  830259 */     // MIs[0] policy
     /*  830259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830271 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  830274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830293 */     GIR_RootConstrainSelectedInstOperands,
     /*  830294 */     // GIR_Coverage, 24176,
     /*  830294 */     GIR_EraseRootFromParent_Done,
     /*  830295 */   // Label 12836: @830295
     /*  830295 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(830383), // Rule ID 24177 //
     /*  830300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  830303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  830311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  830314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  830320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830347 */     // MIs[1] Operand 1
     /*  830347 */     // No operand predicates
     /*  830347 */     // MIs[0] policy
     /*  830347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830359 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  830362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830381 */     GIR_RootConstrainSelectedInstOperands,
     /*  830382 */     // GIR_Coverage, 24177,
     /*  830382 */     GIR_EraseRootFromParent_Done,
     /*  830383 */   // Label 12837: @830383
     /*  830383 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(830471), // Rule ID 24180 //
     /*  830388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  830391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830435 */     // MIs[1] Operand 1
     /*  830435 */     // No operand predicates
     /*  830435 */     // MIs[0] policy
     /*  830435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830447 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830469 */     GIR_RootConstrainSelectedInstOperands,
     /*  830470 */     // GIR_Coverage, 24180,
     /*  830470 */     GIR_EraseRootFromParent_Done,
     /*  830471 */   // Label 12838: @830471
     /*  830471 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(830559), // Rule ID 24181 //
     /*  830476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  830479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  830496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830523 */     // MIs[1] Operand 1
     /*  830523 */     // No operand predicates
     /*  830523 */     // MIs[0] policy
     /*  830523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830535 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830557 */     GIR_RootConstrainSelectedInstOperands,
     /*  830558 */     // GIR_Coverage, 24181,
     /*  830558 */     GIR_EraseRootFromParent_Done,
     /*  830559 */   // Label 12839: @830559
     /*  830559 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(830647), // Rule ID 24184 //
     /*  830564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  830567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830611 */     // MIs[1] Operand 1
     /*  830611 */     // No operand predicates
     /*  830611 */     // MIs[0] policy
     /*  830611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830623 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830645 */     GIR_RootConstrainSelectedInstOperands,
     /*  830646 */     // GIR_Coverage, 24184,
     /*  830646 */     GIR_EraseRootFromParent_Done,
     /*  830647 */   // Label 12840: @830647
     /*  830647 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(830735), // Rule ID 24185 //
     /*  830652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  830655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  830672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830699 */     // MIs[1] Operand 1
     /*  830699 */     // No operand predicates
     /*  830699 */     // MIs[0] policy
     /*  830699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830711 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830733 */     GIR_RootConstrainSelectedInstOperands,
     /*  830734 */     // GIR_Coverage, 24185,
     /*  830734 */     GIR_EraseRootFromParent_Done,
     /*  830735 */   // Label 12841: @830735
     /*  830735 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(830823), // Rule ID 24188 //
     /*  830740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  830743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830787 */     // MIs[1] Operand 1
     /*  830787 */     // No operand predicates
     /*  830787 */     // MIs[0] policy
     /*  830787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830799 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830821 */     GIR_RootConstrainSelectedInstOperands,
     /*  830822 */     // GIR_Coverage, 24188,
     /*  830822 */     GIR_EraseRootFromParent_Done,
     /*  830823 */   // Label 12842: @830823
     /*  830823 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(830911), // Rule ID 24189 //
     /*  830828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  830831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  830848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830875 */     // MIs[1] Operand 1
     /*  830875 */     // No operand predicates
     /*  830875 */     // MIs[0] policy
     /*  830875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830887 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  830887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  830890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830909 */     GIR_RootConstrainSelectedInstOperands,
     /*  830910 */     // GIR_Coverage, 24189,
     /*  830910 */     GIR_EraseRootFromParent_Done,
     /*  830911 */   // Label 12843: @830911
     /*  830911 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(830999), // Rule ID 24192 //
     /*  830916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  830919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  830924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  830927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  830930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  830933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  830936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  830955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  830959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  830963 */     // MIs[1] Operand 1
     /*  830963 */     // No operand predicates
     /*  830963 */     // MIs[0] policy
     /*  830963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  830966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  830968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  830975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  830978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  830987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  830997 */     GIR_RootConstrainSelectedInstOperands,
     /*  830998 */     // GIR_Coverage, 24192,
     /*  830998 */     GIR_EraseRootFromParent_Done,
     /*  830999 */   // Label 12844: @830999
     /*  830999 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(831087), // Rule ID 24193 //
     /*  831004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  831007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  831015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  831018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831051 */     // MIs[1] Operand 1
     /*  831051 */     // No operand predicates
     /*  831051 */     // MIs[0] policy
     /*  831051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831063 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  831066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831085 */     GIR_RootConstrainSelectedInstOperands,
     /*  831086 */     // GIR_Coverage, 24193,
     /*  831086 */     GIR_EraseRootFromParent_Done,
     /*  831087 */   // Label 12845: @831087
     /*  831087 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(831175), // Rule ID 24196 //
     /*  831092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  831095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  831103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  831106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831139 */     // MIs[1] Operand 1
     /*  831139 */     // No operand predicates
     /*  831139 */     // MIs[0] policy
     /*  831139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831151 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  831151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  831154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831173 */     GIR_RootConstrainSelectedInstOperands,
     /*  831174 */     // GIR_Coverage, 24196,
     /*  831174 */     GIR_EraseRootFromParent_Done,
     /*  831175 */   // Label 12846: @831175
     /*  831175 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(831263), // Rule ID 24197 //
     /*  831180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  831183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  831191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  831194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831227 */     // MIs[1] Operand 1
     /*  831227 */     // No operand predicates
     /*  831227 */     // MIs[0] policy
     /*  831227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831239 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  831242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831261 */     GIR_RootConstrainSelectedInstOperands,
     /*  831262 */     // GIR_Coverage, 24197,
     /*  831262 */     GIR_EraseRootFromParent_Done,
     /*  831263 */   // Label 12847: @831263
     /*  831263 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(831351), // Rule ID 24200 //
     /*  831268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  831271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  831279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  831282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831315 */     // MIs[1] Operand 1
     /*  831315 */     // No operand predicates
     /*  831315 */     // MIs[0] policy
     /*  831315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831327 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  831327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  831330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831349 */     GIR_RootConstrainSelectedInstOperands,
     /*  831350 */     // GIR_Coverage, 24200,
     /*  831350 */     GIR_EraseRootFromParent_Done,
     /*  831351 */   // Label 12848: @831351
     /*  831351 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(831439), // Rule ID 24201 //
     /*  831356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  831359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  831367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  831370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831403 */     // MIs[1] Operand 1
     /*  831403 */     // No operand predicates
     /*  831403 */     // MIs[0] policy
     /*  831403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831415 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  831418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831437 */     GIR_RootConstrainSelectedInstOperands,
     /*  831438 */     // GIR_Coverage, 24201,
     /*  831438 */     GIR_EraseRootFromParent_Done,
     /*  831439 */   // Label 12849: @831439
     /*  831439 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(831527), // Rule ID 24204 //
     /*  831444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  831447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  831455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  831458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831491 */     // MIs[1] Operand 1
     /*  831491 */     // No operand predicates
     /*  831491 */     // MIs[0] policy
     /*  831491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831503 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  831503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  831506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831525 */     GIR_RootConstrainSelectedInstOperands,
     /*  831526 */     // GIR_Coverage, 24204,
     /*  831526 */     GIR_EraseRootFromParent_Done,
     /*  831527 */   // Label 12850: @831527
     /*  831527 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(831615), // Rule ID 24205 //
     /*  831532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  831535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  831543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  831546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831579 */     // MIs[1] Operand 1
     /*  831579 */     // No operand predicates
     /*  831579 */     // MIs[0] policy
     /*  831579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831591 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  831594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831613 */     GIR_RootConstrainSelectedInstOperands,
     /*  831614 */     // GIR_Coverage, 24205,
     /*  831614 */     GIR_EraseRootFromParent_Done,
     /*  831615 */   // Label 12851: @831615
     /*  831615 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(831703), // Rule ID 24208 //
     /*  831620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  831623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  831631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  831634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831667 */     // MIs[1] Operand 1
     /*  831667 */     // No operand predicates
     /*  831667 */     // MIs[0] policy
     /*  831667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831679 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  831679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  831682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831701 */     GIR_RootConstrainSelectedInstOperands,
     /*  831702 */     // GIR_Coverage, 24208,
     /*  831702 */     GIR_EraseRootFromParent_Done,
     /*  831703 */   // Label 12852: @831703
     /*  831703 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(831791), // Rule ID 24209 //
     /*  831708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  831711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  831719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  831722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831755 */     // MIs[1] Operand 1
     /*  831755 */     // No operand predicates
     /*  831755 */     // MIs[0] policy
     /*  831755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831767 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  831770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831789 */     GIR_RootConstrainSelectedInstOperands,
     /*  831790 */     // GIR_Coverage, 24209,
     /*  831790 */     GIR_EraseRootFromParent_Done,
     /*  831791 */   // Label 12853: @831791
     /*  831791 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(831879), // Rule ID 24212 //
     /*  831796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  831799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  831807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  831810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831843 */     // MIs[1] Operand 1
     /*  831843 */     // No operand predicates
     /*  831843 */     // MIs[0] policy
     /*  831843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831855 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  831855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  831858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831877 */     GIR_RootConstrainSelectedInstOperands,
     /*  831878 */     // GIR_Coverage, 24212,
     /*  831878 */     GIR_EraseRootFromParent_Done,
     /*  831879 */   // Label 12854: @831879
     /*  831879 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(831967), // Rule ID 24213 //
     /*  831884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  831887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  831895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  831898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  831904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  831923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  831927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  831931 */     // MIs[1] Operand 1
     /*  831931 */     // No operand predicates
     /*  831931 */     // MIs[0] policy
     /*  831931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  831934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  831936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831943 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  831943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  831946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  831955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  831965 */     GIR_RootConstrainSelectedInstOperands,
     /*  831966 */     // GIR_Coverage, 24213,
     /*  831966 */     GIR_EraseRootFromParent_Done,
     /*  831967 */   // Label 12855: @831967
     /*  831967 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(832055), // Rule ID 24216 //
     /*  831972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  831975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  831980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  831983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  831986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  831989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  831992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832019 */     // MIs[1] Operand 1
     /*  832019 */     // No operand predicates
     /*  832019 */     // MIs[0] policy
     /*  832019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832031 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  832031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  832034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832053 */     GIR_RootConstrainSelectedInstOperands,
     /*  832054 */     // GIR_Coverage, 24216,
     /*  832054 */     GIR_EraseRootFromParent_Done,
     /*  832055 */   // Label 12856: @832055
     /*  832055 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(832143), // Rule ID 24217 //
     /*  832060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  832063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  832068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  832071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  832074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832107 */     // MIs[1] Operand 1
     /*  832107 */     // No operand predicates
     /*  832107 */     // MIs[0] policy
     /*  832107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832119 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  832119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  832122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832141 */     GIR_RootConstrainSelectedInstOperands,
     /*  832142 */     // GIR_Coverage, 24217,
     /*  832142 */     GIR_EraseRootFromParent_Done,
     /*  832143 */   // Label 12857: @832143
     /*  832143 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(832231), // Rule ID 24220 //
     /*  832148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  832151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  832156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  832159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  832162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  832168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832195 */     // MIs[1] Operand 1
     /*  832195 */     // No operand predicates
     /*  832195 */     // MIs[0] policy
     /*  832195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832207 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  832207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  832210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832229 */     GIR_RootConstrainSelectedInstOperands,
     /*  832230 */     // GIR_Coverage, 24220,
     /*  832230 */     GIR_EraseRootFromParent_Done,
     /*  832231 */   // Label 12858: @832231
     /*  832231 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(832319), // Rule ID 24221 //
     /*  832236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  832239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  832244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  832247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  832250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832283 */     // MIs[1] Operand 1
     /*  832283 */     // No operand predicates
     /*  832283 */     // MIs[0] policy
     /*  832283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832295 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  832295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  832298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832317 */     GIR_RootConstrainSelectedInstOperands,
     /*  832318 */     // GIR_Coverage, 24221,
     /*  832318 */     GIR_EraseRootFromParent_Done,
     /*  832319 */   // Label 12859: @832319
     /*  832319 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(832407), // Rule ID 24224 //
     /*  832324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  832327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  832332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  832335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  832338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  832344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832371 */     // MIs[1] Operand 1
     /*  832371 */     // No operand predicates
     /*  832371 */     // MIs[0] policy
     /*  832371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832383 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  832383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  832386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832405 */     GIR_RootConstrainSelectedInstOperands,
     /*  832406 */     // GIR_Coverage, 24224,
     /*  832406 */     GIR_EraseRootFromParent_Done,
     /*  832407 */   // Label 12860: @832407
     /*  832407 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(832495), // Rule ID 24225 //
     /*  832412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  832415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  832420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  832423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  832426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832459 */     // MIs[1] Operand 1
     /*  832459 */     // No operand predicates
     /*  832459 */     // MIs[0] policy
     /*  832459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  832462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832471 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  832471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  832474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  832493 */     GIR_RootConstrainSelectedInstOperands,
     /*  832494 */     // GIR_Coverage, 24225,
     /*  832494 */     GIR_EraseRootFromParent_Done,
     /*  832495 */   // Label 12861: @832495
     /*  832495 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(832586), // Rule ID 15836 //
     /*  832500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  832511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  832514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  832520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  832523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832547 */     // MIs[1] Operand 1
     /*  832547 */     // No operand predicates
     /*  832547 */     // MIs[0] round
     /*  832547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  832550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832559 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  832562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  832566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  832573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832584 */     GIR_RootConstrainSelectedInstOperands,
     /*  832585 */     // GIR_Coverage, 15836,
     /*  832585 */     GIR_EraseRootFromParent_Done,
     /*  832586 */   // Label 12862: @832586
     /*  832586 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(832677), // Rule ID 15837 //
     /*  832591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  832602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  832605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  832614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832638 */     // MIs[1] Operand 1
     /*  832638 */     // No operand predicates
     /*  832638 */     // MIs[0] round
     /*  832638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  832641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  832653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  832657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  832664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832675 */     GIR_RootConstrainSelectedInstOperands,
     /*  832676 */     // GIR_Coverage, 15837,
     /*  832676 */     GIR_EraseRootFromParent_Done,
     /*  832677 */   // Label 12863: @832677
     /*  832677 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(832768), // Rule ID 15840 //
     /*  832682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  832693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  832696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  832702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  832705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832729 */     // MIs[1] Operand 1
     /*  832729 */     // No operand predicates
     /*  832729 */     // MIs[0] round
     /*  832729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  832732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832741 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  832744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  832748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  832755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832766 */     GIR_RootConstrainSelectedInstOperands,
     /*  832767 */     // GIR_Coverage, 15840,
     /*  832767 */     GIR_EraseRootFromParent_Done,
     /*  832768 */   // Label 12864: @832768
     /*  832768 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(832859), // Rule ID 15841 //
     /*  832773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  832784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  832787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  832796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832820 */     // MIs[1] Operand 1
     /*  832820 */     // No operand predicates
     /*  832820 */     // MIs[0] round
     /*  832820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  832823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832832 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  832835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  832839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832844 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  832846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832857 */     GIR_RootConstrainSelectedInstOperands,
     /*  832858 */     // GIR_Coverage, 15841,
     /*  832858 */     GIR_EraseRootFromParent_Done,
     /*  832859 */   // Label 12865: @832859
     /*  832859 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(832950), // Rule ID 15844 //
     /*  832864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  832875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  832878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  832884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  832887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  832911 */     // MIs[1] Operand 1
     /*  832911 */     // No operand predicates
     /*  832911 */     // MIs[0] round
     /*  832911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  832914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  832916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832923 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  832926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  832930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  832935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  832937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832948 */     GIR_RootConstrainSelectedInstOperands,
     /*  832949 */     // GIR_Coverage, 15844,
     /*  832949 */     GIR_EraseRootFromParent_Done,
     /*  832950 */   // Label 12866: @832950
     /*  832950 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(833041), // Rule ID 15845 //
     /*  832955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  832963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  832966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  832969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  832975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  832978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  832994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  832998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833002 */     // MIs[1] Operand 1
     /*  833002 */     // No operand predicates
     /*  833002 */     // MIs[0] round
     /*  833002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833014 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  833017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833026 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833039 */     GIR_RootConstrainSelectedInstOperands,
     /*  833040 */     // GIR_Coverage, 15845,
     /*  833040 */     GIR_EraseRootFromParent_Done,
     /*  833041 */   // Label 12867: @833041
     /*  833041 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(833132), // Rule ID 15848 //
     /*  833046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  833057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  833060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833093 */     // MIs[1] Operand 1
     /*  833093 */     // No operand predicates
     /*  833093 */     // MIs[0] round
     /*  833093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833105 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  833108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833130 */     GIR_RootConstrainSelectedInstOperands,
     /*  833131 */     // GIR_Coverage, 15848,
     /*  833131 */     GIR_EraseRootFromParent_Done,
     /*  833132 */   // Label 12868: @833132
     /*  833132 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(833223), // Rule ID 15849 //
     /*  833137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  833148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  833151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  833157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  833160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833184 */     // MIs[1] Operand 1
     /*  833184 */     // No operand predicates
     /*  833184 */     // MIs[0] round
     /*  833184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  833199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833208 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833221 */     GIR_RootConstrainSelectedInstOperands,
     /*  833222 */     // GIR_Coverage, 15849,
     /*  833222 */     GIR_EraseRootFromParent_Done,
     /*  833223 */   // Label 12869: @833223
     /*  833223 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(833314), // Rule ID 15852 //
     /*  833228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  833239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  833242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833275 */     // MIs[1] Operand 1
     /*  833275 */     // No operand predicates
     /*  833275 */     // MIs[0] round
     /*  833275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833287 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  833290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833312 */     GIR_RootConstrainSelectedInstOperands,
     /*  833313 */     // GIR_Coverage, 15852,
     /*  833313 */     GIR_EraseRootFromParent_Done,
     /*  833314 */   // Label 12870: @833314
     /*  833314 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(833405), // Rule ID 15853 //
     /*  833319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  833330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  833333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  833339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  833342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833366 */     // MIs[1] Operand 1
     /*  833366 */     // No operand predicates
     /*  833366 */     // MIs[0] round
     /*  833366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  833381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833403 */     GIR_RootConstrainSelectedInstOperands,
     /*  833404 */     // GIR_Coverage, 15853,
     /*  833404 */     GIR_EraseRootFromParent_Done,
     /*  833405 */   // Label 12871: @833405
     /*  833405 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(833496), // Rule ID 15856 //
     /*  833410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  833421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  833424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833457 */     // MIs[1] Operand 1
     /*  833457 */     // No operand predicates
     /*  833457 */     // MIs[0] round
     /*  833457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833469 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  833472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833494 */     GIR_RootConstrainSelectedInstOperands,
     /*  833495 */     // GIR_Coverage, 15856,
     /*  833495 */     GIR_EraseRootFromParent_Done,
     /*  833496 */   // Label 12872: @833496
     /*  833496 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(833587), // Rule ID 15857 //
     /*  833501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  833512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  833515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  833521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  833524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833548 */     // MIs[1] Operand 1
     /*  833548 */     // No operand predicates
     /*  833548 */     // MIs[0] round
     /*  833548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  833563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833585 */     GIR_RootConstrainSelectedInstOperands,
     /*  833586 */     // GIR_Coverage, 15857,
     /*  833586 */     GIR_EraseRootFromParent_Done,
     /*  833587 */   // Label 12873: @833587
     /*  833587 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(833678), // Rule ID 15860 //
     /*  833592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833639 */     // MIs[1] Operand 1
     /*  833639 */     // No operand predicates
     /*  833639 */     // MIs[0] round
     /*  833639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833651 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  833654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833676 */     GIR_RootConstrainSelectedInstOperands,
     /*  833677 */     // GIR_Coverage, 15860,
     /*  833677 */     GIR_EraseRootFromParent_Done,
     /*  833678 */   // Label 12874: @833678
     /*  833678 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(833769), // Rule ID 15861 //
     /*  833683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  833703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  833706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833730 */     // MIs[1] Operand 1
     /*  833730 */     // No operand predicates
     /*  833730 */     // MIs[0] round
     /*  833730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833742 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  833745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833767 */     GIR_RootConstrainSelectedInstOperands,
     /*  833768 */     // GIR_Coverage, 15861,
     /*  833768 */     GIR_EraseRootFromParent_Done,
     /*  833769 */   // Label 12875: @833769
     /*  833769 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(833860), // Rule ID 15864 //
     /*  833774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833821 */     // MIs[1] Operand 1
     /*  833821 */     // No operand predicates
     /*  833821 */     // MIs[0] round
     /*  833821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833833 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  833836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833858 */     GIR_RootConstrainSelectedInstOperands,
     /*  833859 */     // GIR_Coverage, 15864,
     /*  833859 */     GIR_EraseRootFromParent_Done,
     /*  833860 */   // Label 12876: @833860
     /*  833860 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(833951), // Rule ID 15865 //
     /*  833865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  833885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  833888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  833912 */     // MIs[1] Operand 1
     /*  833912 */     // No operand predicates
     /*  833912 */     // MIs[0] round
     /*  833912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  833915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  833917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  833927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  833931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  833936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  833938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833949 */     GIR_RootConstrainSelectedInstOperands,
     /*  833950 */     // GIR_Coverage, 15865,
     /*  833950 */     GIR_EraseRootFromParent_Done,
     /*  833951 */   // Label 12877: @833951
     /*  833951 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(834042), // Rule ID 15868 //
     /*  833956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  833964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  833976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  833979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  833995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  833999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834003 */     // MIs[1] Operand 1
     /*  834003 */     // No operand predicates
     /*  834003 */     // MIs[0] round
     /*  834003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  834018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834040 */     GIR_RootConstrainSelectedInstOperands,
     /*  834041 */     // GIR_Coverage, 15868,
     /*  834041 */     GIR_EraseRootFromParent_Done,
     /*  834042 */   // Label 12878: @834042
     /*  834042 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(834133), // Rule ID 15869 //
     /*  834047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834094 */     // MIs[1] Operand 1
     /*  834094 */     // No operand predicates
     /*  834094 */     // MIs[0] round
     /*  834094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  834109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834118 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834131 */     GIR_RootConstrainSelectedInstOperands,
     /*  834132 */     // GIR_Coverage, 15869,
     /*  834132 */     GIR_EraseRootFromParent_Done,
     /*  834133 */   // Label 12879: @834133
     /*  834133 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(834224), // Rule ID 15872 //
     /*  834138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  834141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  834158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  834161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834185 */     // MIs[1] Operand 1
     /*  834185 */     // No operand predicates
     /*  834185 */     // MIs[0] round
     /*  834185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834197 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  834197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  834200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834222 */     GIR_RootConstrainSelectedInstOperands,
     /*  834223 */     // GIR_Coverage, 15872,
     /*  834223 */     GIR_EraseRootFromParent_Done,
     /*  834224 */   // Label 12880: @834224
     /*  834224 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(834315), // Rule ID 15873 //
     /*  834229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  834232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834276 */     // MIs[1] Operand 1
     /*  834276 */     // No operand predicates
     /*  834276 */     // MIs[0] round
     /*  834276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  834288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  834291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834313 */     GIR_RootConstrainSelectedInstOperands,
     /*  834314 */     // GIR_Coverage, 15873,
     /*  834314 */     GIR_EraseRootFromParent_Done,
     /*  834315 */   // Label 12881: @834315
     /*  834315 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(834406), // Rule ID 15876 //
     /*  834320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  834331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  834334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  834340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  834343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834367 */     // MIs[1] Operand 1
     /*  834367 */     // No operand predicates
     /*  834367 */     // MIs[0] round
     /*  834367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834379 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  834382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834404 */     GIR_RootConstrainSelectedInstOperands,
     /*  834405 */     // GIR_Coverage, 15876,
     /*  834405 */     GIR_EraseRootFromParent_Done,
     /*  834406 */   // Label 12882: @834406
     /*  834406 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(834497), // Rule ID 15877 //
     /*  834411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  834422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  834425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834458 */     // MIs[1] Operand 1
     /*  834458 */     // No operand predicates
     /*  834458 */     // MIs[0] round
     /*  834458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  834473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834495 */     GIR_RootConstrainSelectedInstOperands,
     /*  834496 */     // GIR_Coverage, 15877,
     /*  834496 */     GIR_EraseRootFromParent_Done,
     /*  834497 */   // Label 12883: @834497
     /*  834497 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(834588), // Rule ID 15880 //
     /*  834502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  834513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  834516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  834522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  834525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834549 */     // MIs[1] Operand 1
     /*  834549 */     // No operand predicates
     /*  834549 */     // MIs[0] round
     /*  834549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834561 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  834564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834586 */     GIR_RootConstrainSelectedInstOperands,
     /*  834587 */     // GIR_Coverage, 15880,
     /*  834587 */     GIR_EraseRootFromParent_Done,
     /*  834588 */   // Label 12884: @834588
     /*  834588 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(834679), // Rule ID 15881 //
     /*  834593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  834604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  834607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834640 */     // MIs[1] Operand 1
     /*  834640 */     // No operand predicates
     /*  834640 */     // MIs[0] round
     /*  834640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  834655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834664 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834677 */     GIR_RootConstrainSelectedInstOperands,
     /*  834678 */     // GIR_Coverage, 15881,
     /*  834678 */     GIR_EraseRootFromParent_Done,
     /*  834679 */   // Label 12885: @834679
     /*  834679 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(834770), // Rule ID 15884 //
     /*  834684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  834695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  834698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  834704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  834707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834731 */     // MIs[1] Operand 1
     /*  834731 */     // No operand predicates
     /*  834731 */     // MIs[0] round
     /*  834731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834743 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  834746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834768 */     GIR_RootConstrainSelectedInstOperands,
     /*  834769 */     // GIR_Coverage, 15884,
     /*  834769 */     GIR_EraseRootFromParent_Done,
     /*  834770 */   // Label 12886: @834770
     /*  834770 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(834861), // Rule ID 15885 //
     /*  834775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  834786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  834789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834822 */     // MIs[1] Operand 1
     /*  834822 */     // No operand predicates
     /*  834822 */     // MIs[0] round
     /*  834822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  834837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834859 */     GIR_RootConstrainSelectedInstOperands,
     /*  834860 */     // GIR_Coverage, 15885,
     /*  834860 */     GIR_EraseRootFromParent_Done,
     /*  834861 */   // Label 12887: @834861
     /*  834861 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(834952), // Rule ID 15888 //
     /*  834866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  834877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  834880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  834886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  834889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  834909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  834913 */     // MIs[1] Operand 1
     /*  834913 */     // No operand predicates
     /*  834913 */     // MIs[0] round
     /*  834913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  834916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  834918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  834928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  834932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  834937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  834939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834950 */     GIR_RootConstrainSelectedInstOperands,
     /*  834951 */     // GIR_Coverage, 15888,
     /*  834951 */     GIR_EraseRootFromParent_Done,
     /*  834952 */   // Label 12888: @834952
     /*  834952 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(835043), // Rule ID 15889 //
     /*  834957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  834965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  834968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  834971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  834977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  834980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  834996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835004 */     // MIs[1] Operand 1
     /*  835004 */     // No operand predicates
     /*  835004 */     // MIs[0] round
     /*  835004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  835019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835028 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835041 */     GIR_RootConstrainSelectedInstOperands,
     /*  835042 */     // GIR_Coverage, 15889,
     /*  835042 */     GIR_EraseRootFromParent_Done,
     /*  835043 */   // Label 12889: @835043
     /*  835043 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(835134), // Rule ID 15892 //
     /*  835048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  835059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  835062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835095 */     // MIs[1] Operand 1
     /*  835095 */     // No operand predicates
     /*  835095 */     // MIs[0] round
     /*  835095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835107 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  835110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835132 */     GIR_RootConstrainSelectedInstOperands,
     /*  835133 */     // GIR_Coverage, 15892,
     /*  835133 */     GIR_EraseRootFromParent_Done,
     /*  835134 */   // Label 12890: @835134
     /*  835134 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(835225), // Rule ID 15893 //
     /*  835139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  835150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  835153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  835159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  835162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835186 */     // MIs[1] Operand 1
     /*  835186 */     // No operand predicates
     /*  835186 */     // MIs[0] round
     /*  835186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835198 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  835201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835210 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835223 */     GIR_RootConstrainSelectedInstOperands,
     /*  835224 */     // GIR_Coverage, 15893,
     /*  835224 */     GIR_EraseRootFromParent_Done,
     /*  835225 */   // Label 12891: @835225
     /*  835225 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(835316), // Rule ID 15896 //
     /*  835230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  835241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  835244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835277 */     // MIs[1] Operand 1
     /*  835277 */     // No operand predicates
     /*  835277 */     // MIs[0] round
     /*  835277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835289 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  835292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835314 */     GIR_RootConstrainSelectedInstOperands,
     /*  835315 */     // GIR_Coverage, 15896,
     /*  835315 */     GIR_EraseRootFromParent_Done,
     /*  835316 */   // Label 12892: @835316
     /*  835316 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(835407), // Rule ID 15897 //
     /*  835321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  835332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  835335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  835341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  835344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835368 */     // MIs[1] Operand 1
     /*  835368 */     // No operand predicates
     /*  835368 */     // MIs[0] round
     /*  835368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835380 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  835383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835392 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835405 */     GIR_RootConstrainSelectedInstOperands,
     /*  835406 */     // GIR_Coverage, 15897,
     /*  835406 */     GIR_EraseRootFromParent_Done,
     /*  835407 */   // Label 12893: @835407
     /*  835407 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(835498), // Rule ID 15900 //
     /*  835412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  835423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  835426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835459 */     // MIs[1] Operand 1
     /*  835459 */     // No operand predicates
     /*  835459 */     // MIs[0] round
     /*  835459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  835474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835496 */     GIR_RootConstrainSelectedInstOperands,
     /*  835497 */     // GIR_Coverage, 15900,
     /*  835497 */     GIR_EraseRootFromParent_Done,
     /*  835498 */   // Label 12894: @835498
     /*  835498 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(835589), // Rule ID 15901 //
     /*  835503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  835514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  835517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  835523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  835526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835550 */     // MIs[1] Operand 1
     /*  835550 */     // No operand predicates
     /*  835550 */     // MIs[0] round
     /*  835550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  835565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835587 */     GIR_RootConstrainSelectedInstOperands,
     /*  835588 */     // GIR_Coverage, 15901,
     /*  835588 */     GIR_EraseRootFromParent_Done,
     /*  835589 */   // Label 12895: @835589
     /*  835589 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(835680), // Rule ID 15904 //
     /*  835594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  835605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  835608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835641 */     // MIs[1] Operand 1
     /*  835641 */     // No operand predicates
     /*  835641 */     // MIs[0] round
     /*  835641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835653 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  835656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835678 */     GIR_RootConstrainSelectedInstOperands,
     /*  835679 */     // GIR_Coverage, 15904,
     /*  835679 */     GIR_EraseRootFromParent_Done,
     /*  835680 */   // Label 12896: @835680
     /*  835680 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(835771), // Rule ID 15905 //
     /*  835685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  835696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  835699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  835705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  835708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835732 */     // MIs[1] Operand 1
     /*  835732 */     // No operand predicates
     /*  835732 */     // MIs[0] round
     /*  835732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835744 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  835747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835769 */     GIR_RootConstrainSelectedInstOperands,
     /*  835770 */     // GIR_Coverage, 15905,
     /*  835770 */     GIR_EraseRootFromParent_Done,
     /*  835771 */   // Label 12897: @835771
     /*  835771 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(835862), // Rule ID 15908 //
     /*  835776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  835787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  835790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835823 */     // MIs[1] Operand 1
     /*  835823 */     // No operand predicates
     /*  835823 */     // MIs[0] round
     /*  835823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835835 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  835838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835860 */     GIR_RootConstrainSelectedInstOperands,
     /*  835861 */     // GIR_Coverage, 15908,
     /*  835861 */     GIR_EraseRootFromParent_Done,
     /*  835862 */   // Label 12898: @835862
     /*  835862 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(835953), // Rule ID 15909 //
     /*  835867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  835878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  835881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  835887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  835890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  835910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  835914 */     // MIs[1] Operand 1
     /*  835914 */     // No operand predicates
     /*  835914 */     // MIs[0] round
     /*  835914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  835917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  835919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  835929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  835933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  835938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  835940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835951 */     GIR_RootConstrainSelectedInstOperands,
     /*  835952 */     // GIR_Coverage, 15909,
     /*  835952 */     GIR_EraseRootFromParent_Done,
     /*  835953 */   // Label 12899: @835953
     /*  835953 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(836044), // Rule ID 15912 //
     /*  835958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  835961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  835966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  835969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  835972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  835975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  835978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  835981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  835997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836005 */     // MIs[1] Operand 1
     /*  836005 */     // No operand predicates
     /*  836005 */     // MIs[0] round
     /*  836005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  836020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836042 */     GIR_RootConstrainSelectedInstOperands,
     /*  836043 */     // GIR_Coverage, 15912,
     /*  836043 */     GIR_EraseRootFromParent_Done,
     /*  836044 */   // Label 12900: @836044
     /*  836044 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(836135), // Rule ID 15913 //
     /*  836049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  836057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  836060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  836063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  836066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836096 */     // MIs[1] Operand 1
     /*  836096 */     // No operand predicates
     /*  836096 */     // MIs[0] round
     /*  836096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  836111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836133 */     GIR_RootConstrainSelectedInstOperands,
     /*  836134 */     // GIR_Coverage, 15913,
     /*  836134 */     GIR_EraseRootFromParent_Done,
     /*  836135 */   // Label 12901: @836135
     /*  836135 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(836226), // Rule ID 15916 //
     /*  836140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  836148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  836151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  836154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  836160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  836163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836187 */     // MIs[1] Operand 1
     /*  836187 */     // No operand predicates
     /*  836187 */     // MIs[0] round
     /*  836187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  836202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836224 */     GIR_RootConstrainSelectedInstOperands,
     /*  836225 */     // GIR_Coverage, 15916,
     /*  836225 */     GIR_EraseRootFromParent_Done,
     /*  836226 */   // Label 12902: @836226
     /*  836226 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(836317), // Rule ID 15917 //
     /*  836231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  836239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  836242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  836245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836278 */     // MIs[1] Operand 1
     /*  836278 */     // No operand predicates
     /*  836278 */     // MIs[0] round
     /*  836278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  836293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836315 */     GIR_RootConstrainSelectedInstOperands,
     /*  836316 */     // GIR_Coverage, 15917,
     /*  836316 */     GIR_EraseRootFromParent_Done,
     /*  836317 */   // Label 12903: @836317
     /*  836317 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(836408), // Rule ID 15920 //
     /*  836322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  836330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  836333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  836336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  836342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  836345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836369 */     // MIs[1] Operand 1
     /*  836369 */     // No operand predicates
     /*  836369 */     // MIs[0] round
     /*  836369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836381 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  836384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836406 */     GIR_RootConstrainSelectedInstOperands,
     /*  836407 */     // GIR_Coverage, 15920,
     /*  836407 */     GIR_EraseRootFromParent_Done,
     /*  836408 */   // Label 12904: @836408
     /*  836408 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(836499), // Rule ID 15921 //
     /*  836413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  836421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  836424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  836427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836460 */     // MIs[1] Operand 1
     /*  836460 */     // No operand predicates
     /*  836460 */     // MIs[0] round
     /*  836460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  836475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836497 */     GIR_RootConstrainSelectedInstOperands,
     /*  836498 */     // GIR_Coverage, 15921,
     /*  836498 */     GIR_EraseRootFromParent_Done,
     /*  836499 */   // Label 12905: @836499
     /*  836499 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(836590), // Rule ID 16100 //
     /*  836504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  836515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  836518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  836524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  836527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836551 */     // MIs[1] Operand 1
     /*  836551 */     // No operand predicates
     /*  836551 */     // MIs[0] round
     /*  836551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836563 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  836566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836588 */     GIR_RootConstrainSelectedInstOperands,
     /*  836589 */     // GIR_Coverage, 16100,
     /*  836589 */     GIR_EraseRootFromParent_Done,
     /*  836590 */   // Label 12906: @836590
     /*  836590 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(836681), // Rule ID 16101 //
     /*  836595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  836606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  836609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836642 */     // MIs[1] Operand 1
     /*  836642 */     // No operand predicates
     /*  836642 */     // MIs[0] round
     /*  836642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  836657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836666 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836679 */     GIR_RootConstrainSelectedInstOperands,
     /*  836680 */     // GIR_Coverage, 16101,
     /*  836680 */     GIR_EraseRootFromParent_Done,
     /*  836681 */   // Label 12907: @836681
     /*  836681 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(836772), // Rule ID 16104 //
     /*  836686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  836697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  836700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  836706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  836709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836733 */     // MIs[1] Operand 1
     /*  836733 */     // No operand predicates
     /*  836733 */     // MIs[0] round
     /*  836733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836745 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  836748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836770 */     GIR_RootConstrainSelectedInstOperands,
     /*  836771 */     // GIR_Coverage, 16104,
     /*  836771 */     GIR_EraseRootFromParent_Done,
     /*  836772 */   // Label 12908: @836772
     /*  836772 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(836863), // Rule ID 16105 //
     /*  836777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  836788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  836791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836824 */     // MIs[1] Operand 1
     /*  836824 */     // No operand predicates
     /*  836824 */     // MIs[0] round
     /*  836824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  836839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836848 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836861 */     GIR_RootConstrainSelectedInstOperands,
     /*  836862 */     // GIR_Coverage, 16105,
     /*  836862 */     GIR_EraseRootFromParent_Done,
     /*  836863 */   // Label 12909: @836863
     /*  836863 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(836954), // Rule ID 16108 //
     /*  836868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  836879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  836882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  836888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  836891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  836911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  836915 */     // MIs[1] Operand 1
     /*  836915 */     // No operand predicates
     /*  836915 */     // MIs[0] round
     /*  836915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  836918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  836920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  836930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  836934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  836939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  836941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836952 */     GIR_RootConstrainSelectedInstOperands,
     /*  836953 */     // GIR_Coverage, 16108,
     /*  836953 */     GIR_EraseRootFromParent_Done,
     /*  836954 */   // Label 12910: @836954
     /*  836954 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(837045), // Rule ID 16109 //
     /*  836959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  836967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  836970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  836973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  836979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  836982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  836998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837006 */     // MIs[1] Operand 1
     /*  837006 */     // No operand predicates
     /*  837006 */     // MIs[0] round
     /*  837006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  837021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837043 */     GIR_RootConstrainSelectedInstOperands,
     /*  837044 */     // GIR_Coverage, 16109,
     /*  837044 */     GIR_EraseRootFromParent_Done,
     /*  837045 */   // Label 12911: @837045
     /*  837045 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(837136), // Rule ID 16112 //
     /*  837050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  837061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  837064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837097 */     // MIs[1] Operand 1
     /*  837097 */     // No operand predicates
     /*  837097 */     // MIs[0] round
     /*  837097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  837112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837134 */     GIR_RootConstrainSelectedInstOperands,
     /*  837135 */     // GIR_Coverage, 16112,
     /*  837135 */     GIR_EraseRootFromParent_Done,
     /*  837136 */   // Label 12912: @837136
     /*  837136 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(837227), // Rule ID 16113 //
     /*  837141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  837152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  837155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  837161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  837164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837188 */     // MIs[1] Operand 1
     /*  837188 */     // No operand predicates
     /*  837188 */     // MIs[0] round
     /*  837188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  837203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837225 */     GIR_RootConstrainSelectedInstOperands,
     /*  837226 */     // GIR_Coverage, 16113,
     /*  837226 */     GIR_EraseRootFromParent_Done,
     /*  837227 */   // Label 12913: @837227
     /*  837227 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(837318), // Rule ID 16116 //
     /*  837232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  837243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  837246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837279 */     // MIs[1] Operand 1
     /*  837279 */     // No operand predicates
     /*  837279 */     // MIs[0] round
     /*  837279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837291 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  837294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837316 */     GIR_RootConstrainSelectedInstOperands,
     /*  837317 */     // GIR_Coverage, 16116,
     /*  837317 */     GIR_EraseRootFromParent_Done,
     /*  837318 */   // Label 12914: @837318
     /*  837318 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(837409), // Rule ID 16117 //
     /*  837323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  837334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  837337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  837343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  837346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837370 */     // MIs[1] Operand 1
     /*  837370 */     // No operand predicates
     /*  837370 */     // MIs[0] round
     /*  837370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  837385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837407 */     GIR_RootConstrainSelectedInstOperands,
     /*  837408 */     // GIR_Coverage, 16117,
     /*  837408 */     GIR_EraseRootFromParent_Done,
     /*  837409 */   // Label 12915: @837409
     /*  837409 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(837500), // Rule ID 16120 //
     /*  837414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  837425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  837428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837461 */     // MIs[1] Operand 1
     /*  837461 */     // No operand predicates
     /*  837461 */     // MIs[0] round
     /*  837461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  837476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837498 */     GIR_RootConstrainSelectedInstOperands,
     /*  837499 */     // GIR_Coverage, 16120,
     /*  837499 */     GIR_EraseRootFromParent_Done,
     /*  837500 */   // Label 12916: @837500
     /*  837500 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(837591), // Rule ID 16121 //
     /*  837505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  837516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  837519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  837525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  837528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837552 */     // MIs[1] Operand 1
     /*  837552 */     // No operand predicates
     /*  837552 */     // MIs[0] round
     /*  837552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  837567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837589 */     GIR_RootConstrainSelectedInstOperands,
     /*  837590 */     // GIR_Coverage, 16121,
     /*  837590 */     GIR_EraseRootFromParent_Done,
     /*  837591 */   // Label 12917: @837591
     /*  837591 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(837682), // Rule ID 16124 //
     /*  837596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  837607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  837610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837643 */     // MIs[1] Operand 1
     /*  837643 */     // No operand predicates
     /*  837643 */     // MIs[0] round
     /*  837643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837655 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  837658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837680 */     GIR_RootConstrainSelectedInstOperands,
     /*  837681 */     // GIR_Coverage, 16124,
     /*  837681 */     GIR_EraseRootFromParent_Done,
     /*  837682 */   // Label 12918: @837682
     /*  837682 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(837773), // Rule ID 16125 //
     /*  837687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  837698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  837701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  837707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  837710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837734 */     // MIs[1] Operand 1
     /*  837734 */     // No operand predicates
     /*  837734 */     // MIs[0] round
     /*  837734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  837749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837771 */     GIR_RootConstrainSelectedInstOperands,
     /*  837772 */     // GIR_Coverage, 16125,
     /*  837772 */     GIR_EraseRootFromParent_Done,
     /*  837773 */   // Label 12919: @837773
     /*  837773 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(837864), // Rule ID 16128 //
     /*  837778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837825 */     // MIs[1] Operand 1
     /*  837825 */     // No operand predicates
     /*  837825 */     // MIs[0] round
     /*  837825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837837 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  837840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837862 */     GIR_RootConstrainSelectedInstOperands,
     /*  837863 */     // GIR_Coverage, 16128,
     /*  837863 */     GIR_EraseRootFromParent_Done,
     /*  837864 */   // Label 12920: @837864
     /*  837864 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(837955), // Rule ID 16129 //
     /*  837869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  837889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  837892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  837912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  837916 */     // MIs[1] Operand 1
     /*  837916 */     // No operand predicates
     /*  837916 */     // MIs[0] round
     /*  837916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  837919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  837921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  837931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  837935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  837940 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  837942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837953 */     GIR_RootConstrainSelectedInstOperands,
     /*  837954 */     // GIR_Coverage, 16129,
     /*  837954 */     GIR_EraseRootFromParent_Done,
     /*  837955 */   // Label 12921: @837955
     /*  837955 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(838046), // Rule ID 16132 //
     /*  837960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  837968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  837977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  837980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  837983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  837999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838007 */     // MIs[1] Operand 1
     /*  838007 */     // No operand predicates
     /*  838007 */     // MIs[0] round
     /*  838007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  838022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838044 */     GIR_RootConstrainSelectedInstOperands,
     /*  838045 */     // GIR_Coverage, 16132,
     /*  838045 */     GIR_EraseRootFromParent_Done,
     /*  838046 */   // Label 12922: @838046
     /*  838046 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(838137), // Rule ID 16133 //
     /*  838051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838098 */     // MIs[1] Operand 1
     /*  838098 */     // No operand predicates
     /*  838098 */     // MIs[0] round
     /*  838098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  838113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838135 */     GIR_RootConstrainSelectedInstOperands,
     /*  838136 */     // GIR_Coverage, 16133,
     /*  838136 */     GIR_EraseRootFromParent_Done,
     /*  838137 */   // Label 12923: @838137
     /*  838137 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(838228), // Rule ID 16136 //
     /*  838142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  838145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  838162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  838165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838189 */     // MIs[1] Operand 1
     /*  838189 */     // No operand predicates
     /*  838189 */     // MIs[0] round
     /*  838189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838201 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  838201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  838204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838226 */     GIR_RootConstrainSelectedInstOperands,
     /*  838227 */     // GIR_Coverage, 16136,
     /*  838227 */     GIR_EraseRootFromParent_Done,
     /*  838228 */   // Label 12924: @838228
     /*  838228 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(838319), // Rule ID 16137 //
     /*  838233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  838236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838280 */     // MIs[1] Operand 1
     /*  838280 */     // No operand predicates
     /*  838280 */     // MIs[0] round
     /*  838280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  838292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  838295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838317 */     GIR_RootConstrainSelectedInstOperands,
     /*  838318 */     // GIR_Coverage, 16137,
     /*  838318 */     GIR_EraseRootFromParent_Done,
     /*  838319 */   // Label 12925: @838319
     /*  838319 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(838410), // Rule ID 16140 //
     /*  838324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  838335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  838338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  838341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  838344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  838347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838371 */     // MIs[1] Operand 1
     /*  838371 */     // No operand predicates
     /*  838371 */     // MIs[0] round
     /*  838371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  838383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  838386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838408 */     GIR_RootConstrainSelectedInstOperands,
     /*  838409 */     // GIR_Coverage, 16140,
     /*  838409 */     GIR_EraseRootFromParent_Done,
     /*  838410 */   // Label 12926: @838410
     /*  838410 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(838501), // Rule ID 16141 //
     /*  838415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  838426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  838429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  838432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838462 */     // MIs[1] Operand 1
     /*  838462 */     // No operand predicates
     /*  838462 */     // MIs[0] round
     /*  838462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  838474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  838477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838499 */     GIR_RootConstrainSelectedInstOperands,
     /*  838500 */     // GIR_Coverage, 16141,
     /*  838500 */     GIR_EraseRootFromParent_Done,
     /*  838501 */   // Label 12927: @838501
     /*  838501 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(838592), // Rule ID 16144 //
     /*  838506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  838517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  838520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  838523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  838526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  838529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838553 */     // MIs[1] Operand 1
     /*  838553 */     // No operand predicates
     /*  838553 */     // MIs[0] round
     /*  838553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838565 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  838565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  838568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838590 */     GIR_RootConstrainSelectedInstOperands,
     /*  838591 */     // GIR_Coverage, 16144,
     /*  838591 */     GIR_EraseRootFromParent_Done,
     /*  838592 */   // Label 12928: @838592
     /*  838592 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(838683), // Rule ID 16145 //
     /*  838597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  838608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  838611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  838614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838644 */     // MIs[1] Operand 1
     /*  838644 */     // No operand predicates
     /*  838644 */     // MIs[0] round
     /*  838644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  838656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  838659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838668 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838681 */     GIR_RootConstrainSelectedInstOperands,
     /*  838682 */     // GIR_Coverage, 16145,
     /*  838682 */     GIR_EraseRootFromParent_Done,
     /*  838683 */   // Label 12929: @838683
     /*  838683 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(838774), // Rule ID 16148 //
     /*  838688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  838699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  838702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  838708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  838711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838735 */     // MIs[1] Operand 1
     /*  838735 */     // No operand predicates
     /*  838735 */     // MIs[0] round
     /*  838735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838747 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  838747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  838750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838772 */     GIR_RootConstrainSelectedInstOperands,
     /*  838773 */     // GIR_Coverage, 16148,
     /*  838773 */     GIR_EraseRootFromParent_Done,
     /*  838774 */   // Label 12930: @838774
     /*  838774 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(838865), // Rule ID 16149 //
     /*  838779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  838790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  838793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838826 */     // MIs[1] Operand 1
     /*  838826 */     // No operand predicates
     /*  838826 */     // MIs[0] round
     /*  838826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  838838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  838841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838850 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838863 */     GIR_RootConstrainSelectedInstOperands,
     /*  838864 */     // GIR_Coverage, 16149,
     /*  838864 */     GIR_EraseRootFromParent_Done,
     /*  838865 */   // Label 12931: @838865
     /*  838865 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(838956), // Rule ID 16152 //
     /*  838870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  838881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  838884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  838890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  838893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  838909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  838913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  838917 */     // MIs[1] Operand 1
     /*  838917 */     // No operand predicates
     /*  838917 */     // MIs[0] round
     /*  838917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  838920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  838922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  838932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  838936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  838941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  838943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838954 */     GIR_RootConstrainSelectedInstOperands,
     /*  838955 */     // GIR_Coverage, 16152,
     /*  838955 */     GIR_EraseRootFromParent_Done,
     /*  838956 */   // Label 12932: @838956
     /*  838956 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(839047), // Rule ID 16153 //
     /*  838961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  838969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  838972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  838975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  838981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  838984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839008 */     // MIs[1] Operand 1
     /*  839008 */     // No operand predicates
     /*  839008 */     // MIs[0] round
     /*  839008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  839023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839032 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839045 */     GIR_RootConstrainSelectedInstOperands,
     /*  839046 */     // GIR_Coverage, 16153,
     /*  839046 */     GIR_EraseRootFromParent_Done,
     /*  839047 */   // Label 12933: @839047
     /*  839047 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(839138), // Rule ID 16156 //
     /*  839052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  839063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  839066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839099 */     // MIs[1] Operand 1
     /*  839099 */     // No operand predicates
     /*  839099 */     // MIs[0] round
     /*  839099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839111 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  839114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839136 */     GIR_RootConstrainSelectedInstOperands,
     /*  839137 */     // GIR_Coverage, 16156,
     /*  839137 */     GIR_EraseRootFromParent_Done,
     /*  839138 */   // Label 12934: @839138
     /*  839138 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(839229), // Rule ID 16157 //
     /*  839143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  839154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  839157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  839163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  839166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839190 */     // MIs[1] Operand 1
     /*  839190 */     // No operand predicates
     /*  839190 */     // MIs[0] round
     /*  839190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  839205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839214 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839227 */     GIR_RootConstrainSelectedInstOperands,
     /*  839228 */     // GIR_Coverage, 16157,
     /*  839228 */     GIR_EraseRootFromParent_Done,
     /*  839229 */   // Label 12935: @839229
     /*  839229 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(839320), // Rule ID 16160 //
     /*  839234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  839245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  839248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839281 */     // MIs[1] Operand 1
     /*  839281 */     // No operand predicates
     /*  839281 */     // MIs[0] round
     /*  839281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839293 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  839296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839318 */     GIR_RootConstrainSelectedInstOperands,
     /*  839319 */     // GIR_Coverage, 16160,
     /*  839319 */     GIR_EraseRootFromParent_Done,
     /*  839320 */   // Label 12936: @839320
     /*  839320 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(839411), // Rule ID 16161 //
     /*  839325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  839336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  839339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  839345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  839348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839372 */     // MIs[1] Operand 1
     /*  839372 */     // No operand predicates
     /*  839372 */     // MIs[0] round
     /*  839372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  839387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839396 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839409 */     GIR_RootConstrainSelectedInstOperands,
     /*  839410 */     // GIR_Coverage, 16161,
     /*  839410 */     GIR_EraseRootFromParent_Done,
     /*  839411 */   // Label 12937: @839411
     /*  839411 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(839502), // Rule ID 16164 //
     /*  839416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  839427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  839430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839463 */     // MIs[1] Operand 1
     /*  839463 */     // No operand predicates
     /*  839463 */     // MIs[0] round
     /*  839463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  839478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839500 */     GIR_RootConstrainSelectedInstOperands,
     /*  839501 */     // GIR_Coverage, 16164,
     /*  839501 */     GIR_EraseRootFromParent_Done,
     /*  839502 */   // Label 12938: @839502
     /*  839502 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(839593), // Rule ID 16165 //
     /*  839507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  839518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  839521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  839527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  839530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839554 */     // MIs[1] Operand 1
     /*  839554 */     // No operand predicates
     /*  839554 */     // MIs[0] round
     /*  839554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  839569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839591 */     GIR_RootConstrainSelectedInstOperands,
     /*  839592 */     // GIR_Coverage, 16165,
     /*  839592 */     GIR_EraseRootFromParent_Done,
     /*  839593 */   // Label 12939: @839593
     /*  839593 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(839684), // Rule ID 16168 //
     /*  839598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  839609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  839612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839645 */     // MIs[1] Operand 1
     /*  839645 */     // No operand predicates
     /*  839645 */     // MIs[0] round
     /*  839645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839657 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  839660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839682 */     GIR_RootConstrainSelectedInstOperands,
     /*  839683 */     // GIR_Coverage, 16168,
     /*  839683 */     GIR_EraseRootFromParent_Done,
     /*  839684 */   // Label 12940: @839684
     /*  839684 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(839775), // Rule ID 16169 //
     /*  839689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  839700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  839703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  839709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  839712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839736 */     // MIs[1] Operand 1
     /*  839736 */     // No operand predicates
     /*  839736 */     // MIs[0] round
     /*  839736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  839751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839773 */     GIR_RootConstrainSelectedInstOperands,
     /*  839774 */     // GIR_Coverage, 16169,
     /*  839774 */     GIR_EraseRootFromParent_Done,
     /*  839775 */   // Label 12941: @839775
     /*  839775 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(839866), // Rule ID 16172 //
     /*  839780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  839791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  839794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839827 */     // MIs[1] Operand 1
     /*  839827 */     // No operand predicates
     /*  839827 */     // MIs[0] round
     /*  839827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  839842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839864 */     GIR_RootConstrainSelectedInstOperands,
     /*  839865 */     // GIR_Coverage, 16172,
     /*  839865 */     GIR_EraseRootFromParent_Done,
     /*  839866 */   // Label 12942: @839866
     /*  839866 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(839957), // Rule ID 16173 //
     /*  839871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  839882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  839885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  839891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  839894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  839910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  839914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  839918 */     // MIs[1] Operand 1
     /*  839918 */     // No operand predicates
     /*  839918 */     // MIs[0] round
     /*  839918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  839921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  839923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  839933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  839937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  839942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  839944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839955 */     GIR_RootConstrainSelectedInstOperands,
     /*  839956 */     // GIR_Coverage, 16173,
     /*  839956 */     GIR_EraseRootFromParent_Done,
     /*  839957 */   // Label 12943: @839957
     /*  839957 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(840048), // Rule ID 16176 //
     /*  839962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  839965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  839970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  839973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  839976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  839982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  839985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840009 */     // MIs[1] Operand 1
     /*  840009 */     // No operand predicates
     /*  840009 */     // MIs[0] round
     /*  840009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  840024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840046 */     GIR_RootConstrainSelectedInstOperands,
     /*  840047 */     // GIR_Coverage, 16176,
     /*  840047 */     GIR_EraseRootFromParent_Done,
     /*  840048 */   // Label 12944: @840048
     /*  840048 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(840139), // Rule ID 16177 //
     /*  840053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  840056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  840061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  840064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  840067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  840070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  840076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840100 */     // MIs[1] Operand 1
     /*  840100 */     // No operand predicates
     /*  840100 */     // MIs[0] round
     /*  840100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  840115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840137 */     GIR_RootConstrainSelectedInstOperands,
     /*  840138 */     // GIR_Coverage, 16177,
     /*  840138 */     GIR_EraseRootFromParent_Done,
     /*  840139 */   // Label 12945: @840139
     /*  840139 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(840230), // Rule ID 16180 //
     /*  840144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  840147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  840152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  840155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  840158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  840164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  840167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840191 */     // MIs[1] Operand 1
     /*  840191 */     // No operand predicates
     /*  840191 */     // MIs[0] round
     /*  840191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840203 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  840206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840228 */     GIR_RootConstrainSelectedInstOperands,
     /*  840229 */     // GIR_Coverage, 16180,
     /*  840229 */     GIR_EraseRootFromParent_Done,
     /*  840230 */   // Label 12946: @840230
     /*  840230 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(840321), // Rule ID 16181 //
     /*  840235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  840238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  840243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  840246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  840249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  840258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840282 */     // MIs[1] Operand 1
     /*  840282 */     // No operand predicates
     /*  840282 */     // MIs[0] round
     /*  840282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  840297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840319 */     GIR_RootConstrainSelectedInstOperands,
     /*  840320 */     // GIR_Coverage, 16181,
     /*  840320 */     GIR_EraseRootFromParent_Done,
     /*  840321 */   // Label 12947: @840321
     /*  840321 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(840412), // Rule ID 16184 //
     /*  840326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  840329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  840334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  840337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  840340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  840346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  840349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840373 */     // MIs[1] Operand 1
     /*  840373 */     // No operand predicates
     /*  840373 */     // MIs[0] round
     /*  840373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840385 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  840388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840410 */     GIR_RootConstrainSelectedInstOperands,
     /*  840411 */     // GIR_Coverage, 16184,
     /*  840411 */     GIR_EraseRootFromParent_Done,
     /*  840412 */   // Label 12948: @840412
     /*  840412 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(840503), // Rule ID 16185 //
     /*  840417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  840420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  840425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  840428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  840431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  840440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840464 */     // MIs[1] Operand 1
     /*  840464 */     // No operand predicates
     /*  840464 */     // MIs[0] round
     /*  840464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  840479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840501 */     GIR_RootConstrainSelectedInstOperands,
     /*  840502 */     // GIR_Coverage, 16185,
     /*  840502 */     GIR_EraseRootFromParent_Done,
     /*  840503 */   // Label 12949: @840503
     /*  840503 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(840597), // Rule ID 16308 //
     /*  840508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  840519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  840522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  840528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  840531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840555 */     // MIs[1] Operand 1
     /*  840555 */     // No operand predicates
     /*  840555 */     // MIs[0] round
     /*  840555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840567 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  840570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  840595 */     GIR_RootConstrainSelectedInstOperands,
     /*  840596 */     // GIR_Coverage, 16308,
     /*  840596 */     GIR_EraseRootFromParent_Done,
     /*  840597 */   // Label 12950: @840597
     /*  840597 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(840691), // Rule ID 16309 //
     /*  840602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  840613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  840616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  840625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840649 */     // MIs[1] Operand 1
     /*  840649 */     // No operand predicates
     /*  840649 */     // MIs[0] round
     /*  840649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840661 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  840664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  840689 */     GIR_RootConstrainSelectedInstOperands,
     /*  840690 */     // GIR_Coverage, 16309,
     /*  840690 */     GIR_EraseRootFromParent_Done,
     /*  840691 */   // Label 12951: @840691
     /*  840691 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(840785), // Rule ID 16312 //
     /*  840696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  840707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  840710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  840716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  840719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840743 */     // MIs[1] Operand 1
     /*  840743 */     // No operand predicates
     /*  840743 */     // MIs[0] round
     /*  840743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840755 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  840758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  840783 */     GIR_RootConstrainSelectedInstOperands,
     /*  840784 */     // GIR_Coverage, 16312,
     /*  840784 */     GIR_EraseRootFromParent_Done,
     /*  840785 */   // Label 12952: @840785
     /*  840785 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(840879), // Rule ID 16313 //
     /*  840790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  840801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  840804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  840813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840837 */     // MIs[1] Operand 1
     /*  840837 */     // No operand predicates
     /*  840837 */     // MIs[0] round
     /*  840837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840849 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  840852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  840877 */     GIR_RootConstrainSelectedInstOperands,
     /*  840878 */     // GIR_Coverage, 16313,
     /*  840878 */     GIR_EraseRootFromParent_Done,
     /*  840879 */   // Label 12953: @840879
     /*  840879 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(840973), // Rule ID 16316 //
     /*  840884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  840895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  840898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  840904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  840907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  840923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  840927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  840931 */     // MIs[1] Operand 1
     /*  840931 */     // No operand predicates
     /*  840931 */     // MIs[0] round
     /*  840931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  840934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  840936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840943 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  840946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  840950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  840955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  840957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  840971 */     GIR_RootConstrainSelectedInstOperands,
     /*  840972 */     // GIR_Coverage, 16316,
     /*  840972 */     GIR_EraseRootFromParent_Done,
     /*  840973 */   // Label 12954: @840973
     /*  840973 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(841067), // Rule ID 16317 //
     /*  840978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  840986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  840989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  840992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  840998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841025 */     // MIs[1] Operand 1
     /*  841025 */     // No operand predicates
     /*  841025 */     // MIs[0] round
     /*  841025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841037 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  841037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  841040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841065 */     GIR_RootConstrainSelectedInstOperands,
     /*  841066 */     // GIR_Coverage, 16317,
     /*  841066 */     GIR_EraseRootFromParent_Done,
     /*  841067 */   // Label 12955: @841067
     /*  841067 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(841161), // Rule ID 16320 //
     /*  841072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  841083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  841086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  841092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  841095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841119 */     // MIs[1] Operand 1
     /*  841119 */     // No operand predicates
     /*  841119 */     // MIs[0] round
     /*  841119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841131 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  841131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  841134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841159 */     GIR_RootConstrainSelectedInstOperands,
     /*  841160 */     // GIR_Coverage, 16320,
     /*  841160 */     GIR_EraseRootFromParent_Done,
     /*  841161 */   // Label 12956: @841161
     /*  841161 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(841255), // Rule ID 16321 //
     /*  841166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  841177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  841180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  841186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841213 */     // MIs[1] Operand 1
     /*  841213 */     // No operand predicates
     /*  841213 */     // MIs[0] round
     /*  841213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  841225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  841228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841253 */     GIR_RootConstrainSelectedInstOperands,
     /*  841254 */     // GIR_Coverage, 16321,
     /*  841254 */     GIR_EraseRootFromParent_Done,
     /*  841255 */   // Label 12957: @841255
     /*  841255 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(841349), // Rule ID 16324 //
     /*  841260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  841271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  841274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  841280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  841283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841307 */     // MIs[1] Operand 1
     /*  841307 */     // No operand predicates
     /*  841307 */     // MIs[0] round
     /*  841307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  841319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  841322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841347 */     GIR_RootConstrainSelectedInstOperands,
     /*  841348 */     // GIR_Coverage, 16324,
     /*  841348 */     GIR_EraseRootFromParent_Done,
     /*  841349 */   // Label 12958: @841349
     /*  841349 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(841443), // Rule ID 16325 //
     /*  841354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  841365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  841368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  841374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841401 */     // MIs[1] Operand 1
     /*  841401 */     // No operand predicates
     /*  841401 */     // MIs[0] round
     /*  841401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  841413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  841416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841441 */     GIR_RootConstrainSelectedInstOperands,
     /*  841442 */     // GIR_Coverage, 16325,
     /*  841442 */     GIR_EraseRootFromParent_Done,
     /*  841443 */   // Label 12959: @841443
     /*  841443 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(841537), // Rule ID 16328 //
     /*  841448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  841459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  841462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  841468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  841471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841495 */     // MIs[1] Operand 1
     /*  841495 */     // No operand predicates
     /*  841495 */     // MIs[0] round
     /*  841495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841507 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  841507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  841510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841535 */     GIR_RootConstrainSelectedInstOperands,
     /*  841536 */     // GIR_Coverage, 16328,
     /*  841536 */     GIR_EraseRootFromParent_Done,
     /*  841537 */   // Label 12960: @841537
     /*  841537 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(841631), // Rule ID 16329 //
     /*  841542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  841553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  841556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  841562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841589 */     // MIs[1] Operand 1
     /*  841589 */     // No operand predicates
     /*  841589 */     // MIs[0] round
     /*  841589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841601 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  841601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  841604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  841623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841629 */     GIR_RootConstrainSelectedInstOperands,
     /*  841630 */     // GIR_Coverage, 16329,
     /*  841630 */     GIR_EraseRootFromParent_Done,
     /*  841631 */   // Label 12961: @841631
     /*  841631 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(841725), // Rule ID 16332 //
     /*  841636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  841647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  841650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  841653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  841656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  841659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841683 */     // MIs[1] Operand 1
     /*  841683 */     // No operand predicates
     /*  841683 */     // MIs[0] round
     /*  841683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841695 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  841698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841723 */     GIR_RootConstrainSelectedInstOperands,
     /*  841724 */     // GIR_Coverage, 16332,
     /*  841724 */     GIR_EraseRootFromParent_Done,
     /*  841725 */   // Label 12962: @841725
     /*  841725 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(841819), // Rule ID 16333 //
     /*  841730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  841741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  841744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  841747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  841750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841777 */     // MIs[1] Operand 1
     /*  841777 */     // No operand predicates
     /*  841777 */     // MIs[0] round
     /*  841777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  841792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841817 */     GIR_RootConstrainSelectedInstOperands,
     /*  841818 */     // GIR_Coverage, 16333,
     /*  841818 */     GIR_EraseRootFromParent_Done,
     /*  841819 */   // Label 12963: @841819
     /*  841819 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(841913), // Rule ID 16336 //
     /*  841824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  841835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  841838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  841844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  841847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841871 */     // MIs[1] Operand 1
     /*  841871 */     // No operand predicates
     /*  841871 */     // MIs[0] round
     /*  841871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  841886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  841911 */     GIR_RootConstrainSelectedInstOperands,
     /*  841912 */     // GIR_Coverage, 16336,
     /*  841912 */     GIR_EraseRootFromParent_Done,
     /*  841913 */   // Label 12964: @841913
     /*  841913 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(842007), // Rule ID 16337 //
     /*  841918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  841926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  841929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  841932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  841938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  841941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  841957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  841961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  841965 */     // MIs[1] Operand 1
     /*  841965 */     // No operand predicates
     /*  841965 */     // MIs[0] round
     /*  841965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  841968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  841970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  841980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  841989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  841991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842005 */     GIR_RootConstrainSelectedInstOperands,
     /*  842006 */     // GIR_Coverage, 16337,
     /*  842006 */     GIR_EraseRootFromParent_Done,
     /*  842007 */   // Label 12965: @842007
     /*  842007 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(842101), // Rule ID 16340 //
     /*  842012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  842015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  842029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842059 */     // MIs[1] Operand 1
     /*  842059 */     // No operand predicates
     /*  842059 */     // MIs[0] round
     /*  842059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  842074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842099 */     GIR_RootConstrainSelectedInstOperands,
     /*  842100 */     // GIR_Coverage, 16340,
     /*  842100 */     GIR_EraseRootFromParent_Done,
     /*  842101 */   // Label 12966: @842101
     /*  842101 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(842195), // Rule ID 16341 //
     /*  842106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  842109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  842123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  842126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  842129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842153 */     // MIs[1] Operand 1
     /*  842153 */     // No operand predicates
     /*  842153 */     // MIs[0] round
     /*  842153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  842168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842193 */     GIR_RootConstrainSelectedInstOperands,
     /*  842194 */     // GIR_Coverage, 16341,
     /*  842194 */     GIR_EraseRootFromParent_Done,
     /*  842195 */   // Label 12967: @842195
     /*  842195 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(842289), // Rule ID 16344 //
     /*  842200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  842203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  842211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  842214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842247 */     // MIs[1] Operand 1
     /*  842247 */     // No operand predicates
     /*  842247 */     // MIs[0] round
     /*  842247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  842262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842287 */     GIR_RootConstrainSelectedInstOperands,
     /*  842288 */     // GIR_Coverage, 16344,
     /*  842288 */     GIR_EraseRootFromParent_Done,
     /*  842289 */   // Label 12968: @842289
     /*  842289 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(842383), // Rule ID 16345 //
     /*  842294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  842297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  842305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  842308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  842314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  842317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842341 */     // MIs[1] Operand 1
     /*  842341 */     // No operand predicates
     /*  842341 */     // MIs[0] round
     /*  842341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  842356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842381 */     GIR_RootConstrainSelectedInstOperands,
     /*  842382 */     // GIR_Coverage, 16345,
     /*  842382 */     GIR_EraseRootFromParent_Done,
     /*  842383 */   // Label 12969: @842383
     /*  842383 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(842477), // Rule ID 16348 //
     /*  842388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  842391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  842399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  842402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842435 */     // MIs[1] Operand 1
     /*  842435 */     // No operand predicates
     /*  842435 */     // MIs[0] round
     /*  842435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842447 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  842450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842475 */     GIR_RootConstrainSelectedInstOperands,
     /*  842476 */     // GIR_Coverage, 16348,
     /*  842476 */     GIR_EraseRootFromParent_Done,
     /*  842477 */   // Label 12970: @842477
     /*  842477 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(842571), // Rule ID 16349 //
     /*  842482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  842485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  842493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  842496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  842502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  842505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842529 */     // MIs[1] Operand 1
     /*  842529 */     // No operand predicates
     /*  842529 */     // MIs[0] round
     /*  842529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  842544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842569 */     GIR_RootConstrainSelectedInstOperands,
     /*  842570 */     // GIR_Coverage, 16349,
     /*  842570 */     GIR_EraseRootFromParent_Done,
     /*  842571 */   // Label 12971: @842571
     /*  842571 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(842665), // Rule ID 16352 //
     /*  842576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  842579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  842587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  842590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842623 */     // MIs[1] Operand 1
     /*  842623 */     // No operand predicates
     /*  842623 */     // MIs[0] round
     /*  842623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  842638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842663 */     GIR_RootConstrainSelectedInstOperands,
     /*  842664 */     // GIR_Coverage, 16352,
     /*  842664 */     GIR_EraseRootFromParent_Done,
     /*  842665 */   // Label 12972: @842665
     /*  842665 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(842759), // Rule ID 16353 //
     /*  842670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  842673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  842681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  842684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  842690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  842693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842717 */     // MIs[1] Operand 1
     /*  842717 */     // No operand predicates
     /*  842717 */     // MIs[0] round
     /*  842717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  842732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842757 */     GIR_RootConstrainSelectedInstOperands,
     /*  842758 */     // GIR_Coverage, 16353,
     /*  842758 */     GIR_EraseRootFromParent_Done,
     /*  842759 */   // Label 12973: @842759
     /*  842759 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(842853), // Rule ID 16356 //
     /*  842764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  842767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842811 */     // MIs[1] Operand 1
     /*  842811 */     // No operand predicates
     /*  842811 */     // MIs[0] round
     /*  842811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842823 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  842826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842851 */     GIR_RootConstrainSelectedInstOperands,
     /*  842852 */     // GIR_Coverage, 16356,
     /*  842852 */     GIR_EraseRootFromParent_Done,
     /*  842853 */   // Label 12974: @842853
     /*  842853 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(842947), // Rule ID 16357 //
     /*  842858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  842861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  842878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  842881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842905 */     // MIs[1] Operand 1
     /*  842905 */     // No operand predicates
     /*  842905 */     // MIs[0] round
     /*  842905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  842908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  842910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842917 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  842920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  842929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  842931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  842945 */     GIR_RootConstrainSelectedInstOperands,
     /*  842946 */     // GIR_Coverage, 16357,
     /*  842946 */     GIR_EraseRootFromParent_Done,
     /*  842947 */   // Label 12975: @842947
     /*  842947 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(843041), // Rule ID 16360 //
     /*  842952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  842955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  842960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  842963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  842966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  842972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  842975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  842991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  842995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  842999 */     // MIs[1] Operand 1
     /*  842999 */     // No operand predicates
     /*  842999 */     // MIs[0] round
     /*  842999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  843014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843039 */     GIR_RootConstrainSelectedInstOperands,
     /*  843040 */     // GIR_Coverage, 16360,
     /*  843040 */     GIR_EraseRootFromParent_Done,
     /*  843041 */   // Label 12976: @843041
     /*  843041 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(843135), // Rule ID 16361 //
     /*  843046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  843049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  843054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  843057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  843060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  843063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  843066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  843069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843093 */     // MIs[1] Operand 1
     /*  843093 */     // No operand predicates
     /*  843093 */     // MIs[0] round
     /*  843093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  843108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843133 */     GIR_RootConstrainSelectedInstOperands,
     /*  843134 */     // GIR_Coverage, 16361,
     /*  843134 */     GIR_EraseRootFromParent_Done,
     /*  843135 */   // Label 12977: @843135
     /*  843135 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(843229), // Rule ID 16364 //
     /*  843140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  843143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  843148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  843151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  843154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  843160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  843163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843187 */     // MIs[1] Operand 1
     /*  843187 */     // No operand predicates
     /*  843187 */     // MIs[0] round
     /*  843187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  843202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843227 */     GIR_RootConstrainSelectedInstOperands,
     /*  843228 */     // GIR_Coverage, 16364,
     /*  843228 */     GIR_EraseRootFromParent_Done,
     /*  843229 */   // Label 12978: @843229
     /*  843229 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(843323), // Rule ID 16365 //
     /*  843234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  843237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  843242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  843245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  843248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  843254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  843257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843281 */     // MIs[1] Operand 1
     /*  843281 */     // No operand predicates
     /*  843281 */     // MIs[0] round
     /*  843281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  843296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843321 */     GIR_RootConstrainSelectedInstOperands,
     /*  843322 */     // GIR_Coverage, 16365,
     /*  843322 */     GIR_EraseRootFromParent_Done,
     /*  843323 */   // Label 12979: @843323
     /*  843323 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(843417), // Rule ID 16488 //
     /*  843328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  843331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  843339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  843342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  843345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  843348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  843351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843375 */     // MIs[1] Operand 1
     /*  843375 */     // No operand predicates
     /*  843375 */     // MIs[0] round
     /*  843375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843387 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  843387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  843390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843415 */     GIR_RootConstrainSelectedInstOperands,
     /*  843416 */     // GIR_Coverage, 16488,
     /*  843416 */     GIR_EraseRootFromParent_Done,
     /*  843417 */   // Label 12980: @843417
     /*  843417 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(843511), // Rule ID 16489 //
     /*  843422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  843425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  843433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  843436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  843439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  843442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  843445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843469 */     // MIs[1] Operand 1
     /*  843469 */     // No operand predicates
     /*  843469 */     // MIs[0] round
     /*  843469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843481 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  843481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  843484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843509 */     GIR_RootConstrainSelectedInstOperands,
     /*  843510 */     // GIR_Coverage, 16489,
     /*  843510 */     GIR_EraseRootFromParent_Done,
     /*  843511 */   // Label 12981: @843511
     /*  843511 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(843605), // Rule ID 16492 //
     /*  843516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  843519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  843527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  843530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  843533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  843536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  843539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843563 */     // MIs[1] Operand 1
     /*  843563 */     // No operand predicates
     /*  843563 */     // MIs[0] round
     /*  843563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843575 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  843575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  843578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843603 */     GIR_RootConstrainSelectedInstOperands,
     /*  843604 */     // GIR_Coverage, 16492,
     /*  843604 */     GIR_EraseRootFromParent_Done,
     /*  843605 */   // Label 12982: @843605
     /*  843605 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(843699), // Rule ID 16493 //
     /*  843610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  843613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  843621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  843624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  843627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  843630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  843633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843657 */     // MIs[1] Operand 1
     /*  843657 */     // No operand predicates
     /*  843657 */     // MIs[0] round
     /*  843657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  843669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  843672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843697 */     GIR_RootConstrainSelectedInstOperands,
     /*  843698 */     // GIR_Coverage, 16493,
     /*  843698 */     GIR_EraseRootFromParent_Done,
     /*  843699 */   // Label 12983: @843699
     /*  843699 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(843793), // Rule ID 16496 //
     /*  843704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  843707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  843715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  843718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  843721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  843724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  843727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843751 */     // MIs[1] Operand 1
     /*  843751 */     // No operand predicates
     /*  843751 */     // MIs[0] round
     /*  843751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843763 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  843763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  843766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843791 */     GIR_RootConstrainSelectedInstOperands,
     /*  843792 */     // GIR_Coverage, 16496,
     /*  843792 */     GIR_EraseRootFromParent_Done,
     /*  843793 */   // Label 12984: @843793
     /*  843793 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(843887), // Rule ID 16497 //
     /*  843798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  843801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  843809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  843812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  843815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  843818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  843821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843845 */     // MIs[1] Operand 1
     /*  843845 */     // No operand predicates
     /*  843845 */     // MIs[0] round
     /*  843845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843857 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  843857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  843860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843885 */     GIR_RootConstrainSelectedInstOperands,
     /*  843886 */     // GIR_Coverage, 16497,
     /*  843886 */     GIR_EraseRootFromParent_Done,
     /*  843887 */   // Label 12985: @843887
     /*  843887 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(843981), // Rule ID 16500 //
     /*  843892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  843895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  843903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  843906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  843909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  843912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  843915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  843931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  843935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  843939 */     // MIs[1] Operand 1
     /*  843939 */     // No operand predicates
     /*  843939 */     // MIs[0] round
     /*  843939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  843942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  843944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843951 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  843951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  843954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  843963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  843965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  843973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  843979 */     GIR_RootConstrainSelectedInstOperands,
     /*  843980 */     // GIR_Coverage, 16500,
     /*  843980 */     GIR_EraseRootFromParent_Done,
     /*  843981 */   // Label 12986: @843981
     /*  843981 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(844075), // Rule ID 16501 //
     /*  843986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  843989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  843994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  843997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  844000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  844003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844033 */     // MIs[1] Operand 1
     /*  844033 */     // No operand predicates
     /*  844033 */     // MIs[0] round
     /*  844033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  844045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  844048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844073 */     GIR_RootConstrainSelectedInstOperands,
     /*  844074 */     // GIR_Coverage, 16501,
     /*  844074 */     GIR_EraseRootFromParent_Done,
     /*  844075 */   // Label 12987: @844075
     /*  844075 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(844169), // Rule ID 16504 //
     /*  844080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  844091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  844094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  844097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  844103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844127 */     // MIs[1] Operand 1
     /*  844127 */     // No operand predicates
     /*  844127 */     // MIs[0] round
     /*  844127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  844139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  844142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844167 */     GIR_RootConstrainSelectedInstOperands,
     /*  844168 */     // GIR_Coverage, 16504,
     /*  844168 */     GIR_EraseRootFromParent_Done,
     /*  844169 */   // Label 12988: @844169
     /*  844169 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(844263), // Rule ID 16505 //
     /*  844174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  844185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  844188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  844191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844221 */     // MIs[1] Operand 1
     /*  844221 */     // No operand predicates
     /*  844221 */     // MIs[0] round
     /*  844221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844233 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  844233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  844236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844261 */     GIR_RootConstrainSelectedInstOperands,
     /*  844262 */     // GIR_Coverage, 16505,
     /*  844262 */     GIR_EraseRootFromParent_Done,
     /*  844263 */   // Label 12989: @844263
     /*  844263 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(844357), // Rule ID 16508 //
     /*  844268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  844279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  844282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  844285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  844291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  844303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844315 */     // MIs[1] Operand 1
     /*  844315 */     // No operand predicates
     /*  844315 */     // MIs[0] round
     /*  844315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844327 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  844327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  844330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844355 */     GIR_RootConstrainSelectedInstOperands,
     /*  844356 */     // GIR_Coverage, 16508,
     /*  844356 */     GIR_EraseRootFromParent_Done,
     /*  844357 */   // Label 12990: @844357
     /*  844357 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(844451), // Rule ID 16509 //
     /*  844362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  844373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  844376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  844379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  844393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  844397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844409 */     // MIs[1] Operand 1
     /*  844409 */     // No operand predicates
     /*  844409 */     // MIs[0] round
     /*  844409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  844421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  844424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844449 */     GIR_RootConstrainSelectedInstOperands,
     /*  844450 */     // GIR_Coverage, 16509,
     /*  844450 */     GIR_EraseRootFromParent_Done,
     /*  844451 */   // Label 12991: @844451
     /*  844451 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(844545), // Rule ID 16512 //
     /*  844456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  844467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  844470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  844479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844503 */     // MIs[1] Operand 1
     /*  844503 */     // No operand predicates
     /*  844503 */     // MIs[0] round
     /*  844503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844515 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  844518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844543 */     GIR_RootConstrainSelectedInstOperands,
     /*  844544 */     // GIR_Coverage, 16512,
     /*  844544 */     GIR_EraseRootFromParent_Done,
     /*  844545 */   // Label 12992: @844545
     /*  844545 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(844639), // Rule ID 16513 //
     /*  844550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  844561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  844564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844597 */     // MIs[1] Operand 1
     /*  844597 */     // No operand predicates
     /*  844597 */     // MIs[0] round
     /*  844597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  844612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844637 */     GIR_RootConstrainSelectedInstOperands,
     /*  844638 */     // GIR_Coverage, 16513,
     /*  844638 */     GIR_EraseRootFromParent_Done,
     /*  844639 */   // Label 12993: @844639
     /*  844639 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(844733), // Rule ID 16516 //
     /*  844644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  844655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  844658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  844667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844691 */     // MIs[1] Operand 1
     /*  844691 */     // No operand predicates
     /*  844691 */     // MIs[0] round
     /*  844691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844703 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  844706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844731 */     GIR_RootConstrainSelectedInstOperands,
     /*  844732 */     // GIR_Coverage, 16516,
     /*  844732 */     GIR_EraseRootFromParent_Done,
     /*  844733 */   // Label 12994: @844733
     /*  844733 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(844827), // Rule ID 16517 //
     /*  844738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  844749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  844752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844785 */     // MIs[1] Operand 1
     /*  844785 */     // No operand predicates
     /*  844785 */     // MIs[0] round
     /*  844785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844797 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  844800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844825 */     GIR_RootConstrainSelectedInstOperands,
     /*  844826 */     // GIR_Coverage, 16517,
     /*  844826 */     GIR_EraseRootFromParent_Done,
     /*  844827 */   // Label 12995: @844827
     /*  844827 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(844921), // Rule ID 16520 //
     /*  844832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  844849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  844855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844879 */     // MIs[1] Operand 1
     /*  844879 */     // No operand predicates
     /*  844879 */     // MIs[0] round
     /*  844879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844891 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  844894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  844919 */     GIR_RootConstrainSelectedInstOperands,
     /*  844920 */     // GIR_Coverage, 16520,
     /*  844920 */     GIR_EraseRootFromParent_Done,
     /*  844921 */   // Label 12996: @844921
     /*  844921 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(845015), // Rule ID 16521 //
     /*  844926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  844934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  844943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  844949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  844965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  844969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  844973 */     // MIs[1] Operand 1
     /*  844973 */     // No operand predicates
     /*  844973 */     // MIs[0] round
     /*  844973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  844976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  844978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844985 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  844988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  844997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  844999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845013 */     GIR_RootConstrainSelectedInstOperands,
     /*  845014 */     // GIR_Coverage, 16521,
     /*  845014 */     GIR_EraseRootFromParent_Done,
     /*  845015 */   // Label 12997: @845015
     /*  845015 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(845109), // Rule ID 16524 //
     /*  845020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  845031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  845034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845067 */     // MIs[1] Operand 1
     /*  845067 */     // No operand predicates
     /*  845067 */     // MIs[0] round
     /*  845067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845079 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  845082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845107 */     GIR_RootConstrainSelectedInstOperands,
     /*  845108 */     // GIR_Coverage, 16524,
     /*  845108 */     GIR_EraseRootFromParent_Done,
     /*  845109 */   // Label 12998: @845109
     /*  845109 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(845203), // Rule ID 16525 //
     /*  845114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  845125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  845128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  845137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845161 */     // MIs[1] Operand 1
     /*  845161 */     // No operand predicates
     /*  845161 */     // MIs[0] round
     /*  845161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  845176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845201 */     GIR_RootConstrainSelectedInstOperands,
     /*  845202 */     // GIR_Coverage, 16525,
     /*  845202 */     GIR_EraseRootFromParent_Done,
     /*  845203 */   // Label 12999: @845203
     /*  845203 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(845297), // Rule ID 16528 //
     /*  845208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  845219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  845222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845255 */     // MIs[1] Operand 1
     /*  845255 */     // No operand predicates
     /*  845255 */     // MIs[0] round
     /*  845255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  845270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845295 */     GIR_RootConstrainSelectedInstOperands,
     /*  845296 */     // GIR_Coverage, 16528,
     /*  845296 */     GIR_EraseRootFromParent_Done,
     /*  845297 */   // Label 13000: @845297
     /*  845297 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(845391), // Rule ID 16529 //
     /*  845302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  845313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  845316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  845325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845349 */     // MIs[1] Operand 1
     /*  845349 */     // No operand predicates
     /*  845349 */     // MIs[0] round
     /*  845349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845361 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  845364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845389 */     GIR_RootConstrainSelectedInstOperands,
     /*  845390 */     // GIR_Coverage, 16529,
     /*  845390 */     GIR_EraseRootFromParent_Done,
     /*  845391 */   // Label 13001: @845391
     /*  845391 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(845485), // Rule ID 16532 //
     /*  845396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  845399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  845407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  845410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  845413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845443 */     // MIs[1] Operand 1
     /*  845443 */     // No operand predicates
     /*  845443 */     // MIs[0] round
     /*  845443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845455 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  845458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845483 */     GIR_RootConstrainSelectedInstOperands,
     /*  845484 */     // GIR_Coverage, 16532,
     /*  845484 */     GIR_EraseRootFromParent_Done,
     /*  845485 */   // Label 13002: @845485
     /*  845485 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(845579), // Rule ID 16533 //
     /*  845490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  845493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  845501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  845504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  845507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  845513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845537 */     // MIs[1] Operand 1
     /*  845537 */     // No operand predicates
     /*  845537 */     // MIs[0] round
     /*  845537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  845552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845577 */     GIR_RootConstrainSelectedInstOperands,
     /*  845578 */     // GIR_Coverage, 16533,
     /*  845578 */     GIR_EraseRootFromParent_Done,
     /*  845579 */   // Label 13003: @845579
     /*  845579 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(845673), // Rule ID 16536 //
     /*  845584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  845587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845631 */     // MIs[1] Operand 1
     /*  845631 */     // No operand predicates
     /*  845631 */     // MIs[0] round
     /*  845631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  845646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845671 */     GIR_RootConstrainSelectedInstOperands,
     /*  845672 */     // GIR_Coverage, 16536,
     /*  845672 */     GIR_EraseRootFromParent_Done,
     /*  845673 */   // Label 13004: @845673
     /*  845673 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(845767), // Rule ID 16537 //
     /*  845678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  845681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  845701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845725 */     // MIs[1] Operand 1
     /*  845725 */     // No operand predicates
     /*  845725 */     // MIs[0] round
     /*  845725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845737 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  845740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845765 */     GIR_RootConstrainSelectedInstOperands,
     /*  845766 */     // GIR_Coverage, 16537,
     /*  845766 */     GIR_EraseRootFromParent_Done,
     /*  845767 */   // Label 13005: @845767
     /*  845767 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(845861), // Rule ID 16540 //
     /*  845772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  845775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  845783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  845786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  845789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845819 */     // MIs[1] Operand 1
     /*  845819 */     // No operand predicates
     /*  845819 */     // MIs[0] round
     /*  845819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  845834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845859 */     GIR_RootConstrainSelectedInstOperands,
     /*  845860 */     // GIR_Coverage, 16540,
     /*  845860 */     GIR_EraseRootFromParent_Done,
     /*  845861 */   // Label 13006: @845861
     /*  845861 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(845955), // Rule ID 16541 //
     /*  845866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  845869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  845877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  845880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  845883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  845889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  845909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  845913 */     // MIs[1] Operand 1
     /*  845913 */     // No operand predicates
     /*  845913 */     // MIs[0] round
     /*  845913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  845916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  845918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  845928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  845937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  845939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  845953 */     GIR_RootConstrainSelectedInstOperands,
     /*  845954 */     // GIR_Coverage, 16541,
     /*  845954 */     GIR_EraseRootFromParent_Done,
     /*  845955 */   // Label 13007: @845955
     /*  845955 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(846049), // Rule ID 16544 //
     /*  845960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  845963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  845968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  845971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  845974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  845977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  845983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  845999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  846003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  846007 */     // MIs[1] Operand 1
     /*  846007 */     // No operand predicates
     /*  846007 */     // MIs[0] round
     /*  846007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  846022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  846031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  846047 */     GIR_RootConstrainSelectedInstOperands,
     /*  846048 */     // GIR_Coverage, 16544,
     /*  846048 */     GIR_EraseRootFromParent_Done,
     /*  846049 */   // Label 13008: @846049
     /*  846049 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(846143), // Rule ID 16545 //
     /*  846054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  846057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  846062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  846065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  846068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  846071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  846093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  846097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  846101 */     // MIs[1] Operand 1
     /*  846101 */     // No operand predicates
     /*  846101 */     // MIs[0] round
     /*  846101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846113 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  846116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  846125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  846141 */     GIR_RootConstrainSelectedInstOperands,
     /*  846142 */     // GIR_Coverage, 16545,
     /*  846142 */     GIR_EraseRootFromParent_Done,
     /*  846143 */   // Label 13009: @846143
     /*  846143 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(846227), // Rule ID 2620 //
     /*  846148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  846151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  846168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  846171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846191 */     // MIs[0] round
     /*  846191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846203 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  846203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  846206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846225 */     GIR_RootConstrainSelectedInstOperands,
     /*  846226 */     // GIR_Coverage, 2620,
     /*  846226 */     GIR_EraseRootFromParent_Done,
     /*  846227 */   // Label 13010: @846227
     /*  846227 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(846311), // Rule ID 2621 //
     /*  846232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  846235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  846252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846275 */     // MIs[0] round
     /*  846275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846287 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  846287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  846290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846309 */     GIR_RootConstrainSelectedInstOperands,
     /*  846310 */     // GIR_Coverage, 2621,
     /*  846310 */     GIR_EraseRootFromParent_Done,
     /*  846311 */   // Label 13011: @846311
     /*  846311 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(846395), // Rule ID 16992 //
     /*  846316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  846319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  846336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  846339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846359 */     // MIs[0] round
     /*  846359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846371 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  846371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  846374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846380 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846393 */     GIR_RootConstrainSelectedInstOperands,
     /*  846394 */     // GIR_Coverage, 16992,
     /*  846394 */     GIR_EraseRootFromParent_Done,
     /*  846395 */   // Label 13012: @846395
     /*  846395 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(846479), // Rule ID 16993 //
     /*  846400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  846403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  846420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846443 */     // MIs[0] round
     /*  846443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846455 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  846455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  846458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846477 */     GIR_RootConstrainSelectedInstOperands,
     /*  846478 */     // GIR_Coverage, 16993,
     /*  846478 */     GIR_EraseRootFromParent_Done,
     /*  846479 */   // Label 13013: @846479
     /*  846479 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(846563), // Rule ID 17002 //
     /*  846484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  846487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  846495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  846498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  846501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  846504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  846507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846527 */     // MIs[0] round
     /*  846527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846539 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  846539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  846542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846561 */     GIR_RootConstrainSelectedInstOperands,
     /*  846562 */     // GIR_Coverage, 17002,
     /*  846562 */     GIR_EraseRootFromParent_Done,
     /*  846563 */   // Label 13014: @846563
     /*  846563 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(846647), // Rule ID 17003 //
     /*  846568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  846571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  846579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  846582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  846585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  846588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846611 */     // MIs[0] round
     /*  846611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846623 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  846623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  846626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846645 */     GIR_RootConstrainSelectedInstOperands,
     /*  846646 */     // GIR_Coverage, 17003,
     /*  846646 */     GIR_EraseRootFromParent_Done,
     /*  846647 */   // Label 13015: @846647
     /*  846647 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(846731), // Rule ID 17012 //
     /*  846652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  846655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  846663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  846666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  846669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  846672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  846675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846695 */     // MIs[0] round
     /*  846695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846707 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  846707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  846710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846716 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846729 */     GIR_RootConstrainSelectedInstOperands,
     /*  846730 */     // GIR_Coverage, 17012,
     /*  846730 */     GIR_EraseRootFromParent_Done,
     /*  846731 */   // Label 13016: @846731
     /*  846731 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(846815), // Rule ID 17013 //
     /*  846736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  846739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  846747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  846750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  846753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  846756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846779 */     // MIs[0] round
     /*  846779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846791 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  846791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  846794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846813 */     GIR_RootConstrainSelectedInstOperands,
     /*  846814 */     // GIR_Coverage, 17013,
     /*  846814 */     GIR_EraseRootFromParent_Done,
     /*  846815 */   // Label 13017: @846815
     /*  846815 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(846899), // Rule ID 17022 //
     /*  846820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  846823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  846831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  846834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  846837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  846840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  846843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846863 */     // MIs[0] round
     /*  846863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846875 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  846875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  846878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846897 */     GIR_RootConstrainSelectedInstOperands,
     /*  846898 */     // GIR_Coverage, 17022,
     /*  846898 */     GIR_EraseRootFromParent_Done,
     /*  846899 */   // Label 13018: @846899
     /*  846899 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(846983), // Rule ID 17023 //
     /*  846904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  846907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  846915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  846918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  846921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  846924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  846927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  846935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  846939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846947 */     // MIs[0] round
     /*  846947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  846950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  846952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846959 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  846959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  846962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  846970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846981 */     GIR_RootConstrainSelectedInstOperands,
     /*  846982 */     // GIR_Coverage, 17023,
     /*  846982 */     GIR_EraseRootFromParent_Done,
     /*  846983 */   // Label 13019: @846983
     /*  846983 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(847067), // Rule ID 17032 //
     /*  846988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  846991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  846996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  847008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847031 */     // MIs[0] round
     /*  847031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847043 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  847043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  847046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847052 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847065 */     GIR_RootConstrainSelectedInstOperands,
     /*  847066 */     // GIR_Coverage, 17032,
     /*  847066 */     GIR_EraseRootFromParent_Done,
     /*  847067 */   // Label 13020: @847067
     /*  847067 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(847151), // Rule ID 17033 //
     /*  847072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  847075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  847083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  847092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847115 */     // MIs[0] round
     /*  847115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847127 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  847127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  847130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847149 */     GIR_RootConstrainSelectedInstOperands,
     /*  847150 */     // GIR_Coverage, 17033,
     /*  847150 */     GIR_EraseRootFromParent_Done,
     /*  847151 */   // Label 13021: @847151
     /*  847151 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(847235), // Rule ID 17042 //
     /*  847156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  847159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  847167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  847170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  847173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  847176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847199 */     // MIs[0] round
     /*  847199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847211 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  847211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  847214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847220 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847233 */     GIR_RootConstrainSelectedInstOperands,
     /*  847234 */     // GIR_Coverage, 17042,
     /*  847234 */     GIR_EraseRootFromParent_Done,
     /*  847235 */   // Label 13022: @847235
     /*  847235 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(847319), // Rule ID 17043 //
     /*  847240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  847243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  847251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  847254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  847257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  847260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847283 */     // MIs[0] round
     /*  847283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847295 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  847295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  847298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847317 */     GIR_RootConstrainSelectedInstOperands,
     /*  847318 */     // GIR_Coverage, 17043,
     /*  847318 */     GIR_EraseRootFromParent_Done,
     /*  847319 */   // Label 13023: @847319
     /*  847319 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(847403), // Rule ID 17052 //
     /*  847324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  847327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  847335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  847338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  847341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  847344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847367 */     // MIs[0] round
     /*  847367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847379 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  847379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  847382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847401 */     GIR_RootConstrainSelectedInstOperands,
     /*  847402 */     // GIR_Coverage, 17052,
     /*  847402 */     GIR_EraseRootFromParent_Done,
     /*  847403 */   // Label 13024: @847403
     /*  847403 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(847487), // Rule ID 17053 //
     /*  847408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  847411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  847419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  847422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  847425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  847428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847451 */     // MIs[0] round
     /*  847451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847463 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  847463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  847466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847485 */     GIR_RootConstrainSelectedInstOperands,
     /*  847486 */     // GIR_Coverage, 17053,
     /*  847486 */     GIR_EraseRootFromParent_Done,
     /*  847487 */   // Label 13025: @847487
     /*  847487 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(847571), // Rule ID 17062 //
     /*  847492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  847495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  847503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  847506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  847509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  847512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847535 */     // MIs[0] round
     /*  847535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847547 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  847547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  847550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847556 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847569 */     GIR_RootConstrainSelectedInstOperands,
     /*  847570 */     // GIR_Coverage, 17062,
     /*  847570 */     GIR_EraseRootFromParent_Done,
     /*  847571 */   // Label 13026: @847571
     /*  847571 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(847655), // Rule ID 17063 //
     /*  847576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  847579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  847584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  847587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  847590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  847593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  847596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847619 */     // MIs[0] round
     /*  847619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847631 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  847631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  847634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847640 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847653 */     GIR_RootConstrainSelectedInstOperands,
     /*  847654 */     // GIR_Coverage, 17063,
     /*  847654 */     GIR_EraseRootFromParent_Done,
     /*  847655 */   // Label 13027: @847655
     /*  847655 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(847739), // Rule ID 17108 //
     /*  847660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  847663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  847668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  847671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  847674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  847677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  847680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847703 */     // MIs[0] round
     /*  847703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847715 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  847715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  847718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847737 */     GIR_RootConstrainSelectedInstOperands,
     /*  847738 */     // GIR_Coverage, 17108,
     /*  847738 */     GIR_EraseRootFromParent_Done,
     /*  847739 */   // Label 13028: @847739
     /*  847739 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(847823), // Rule ID 17109 //
     /*  847744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  847747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  847752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  847755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  847758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  847761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  847764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847787 */     // MIs[0] round
     /*  847787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847799 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  847799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  847802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847821 */     GIR_RootConstrainSelectedInstOperands,
     /*  847822 */     // GIR_Coverage, 17109,
     /*  847822 */     GIR_EraseRootFromParent_Done,
     /*  847823 */   // Label 13029: @847823
     /*  847823 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(847907), // Rule ID 17118 //
     /*  847828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  847831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  847836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  847848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  847851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847871 */     // MIs[0] round
     /*  847871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847883 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  847883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  847886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847905 */     GIR_RootConstrainSelectedInstOperands,
     /*  847906 */     // GIR_Coverage, 17118,
     /*  847906 */     GIR_EraseRootFromParent_Done,
     /*  847907 */   // Label 13030: @847907
     /*  847907 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(847991), // Rule ID 17119 //
     /*  847912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  847915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  847920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  847932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  847935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  847943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  847947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847955 */     // MIs[0] round
     /*  847955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  847958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  847960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847967 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  847967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  847970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  847978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847989 */     GIR_RootConstrainSelectedInstOperands,
     /*  847990 */     // GIR_Coverage, 17119,
     /*  847990 */     GIR_EraseRootFromParent_Done,
     /*  847991 */   // Label 13031: @847991
     /*  847991 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(848075), // Rule ID 17128 //
     /*  847996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  847999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  848016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848039 */     // MIs[0] round
     /*  848039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848051 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  848051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  848054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848073 */     GIR_RootConstrainSelectedInstOperands,
     /*  848074 */     // GIR_Coverage, 17128,
     /*  848074 */     GIR_EraseRootFromParent_Done,
     /*  848075 */   // Label 13032: @848075
     /*  848075 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(848159), // Rule ID 17129 //
     /*  848080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  848083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  848100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848123 */     // MIs[0] round
     /*  848123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848135 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  848135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  848138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848157 */     GIR_RootConstrainSelectedInstOperands,
     /*  848158 */     // GIR_Coverage, 17129,
     /*  848158 */     GIR_EraseRootFromParent_Done,
     /*  848159 */   // Label 13033: @848159
     /*  848159 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(848243), // Rule ID 17138 //
     /*  848164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  848167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  848184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848207 */     // MIs[0] round
     /*  848207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848219 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  848219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  848222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848228 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848241 */     GIR_RootConstrainSelectedInstOperands,
     /*  848242 */     // GIR_Coverage, 17138,
     /*  848242 */     GIR_EraseRootFromParent_Done,
     /*  848243 */   // Label 13034: @848243
     /*  848243 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(848327), // Rule ID 17139 //
     /*  848248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  848251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  848268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848291 */     // MIs[0] round
     /*  848291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848303 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  848303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  848306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848312 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848325 */     GIR_RootConstrainSelectedInstOperands,
     /*  848326 */     // GIR_Coverage, 17139,
     /*  848326 */     GIR_EraseRootFromParent_Done,
     /*  848327 */   // Label 13035: @848327
     /*  848327 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(848411), // Rule ID 17148 //
     /*  848332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  848335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  848352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848375 */     // MIs[0] round
     /*  848375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848387 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  848387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  848390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848396 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848409 */     GIR_RootConstrainSelectedInstOperands,
     /*  848410 */     // GIR_Coverage, 17148,
     /*  848410 */     GIR_EraseRootFromParent_Done,
     /*  848411 */   // Label 13036: @848411
     /*  848411 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(848495), // Rule ID 17149 //
     /*  848416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  848419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  848436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848459 */     // MIs[0] round
     /*  848459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848471 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  848471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  848474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848493 */     GIR_RootConstrainSelectedInstOperands,
     /*  848494 */     // GIR_Coverage, 17149,
     /*  848494 */     GIR_EraseRootFromParent_Done,
     /*  848495 */   // Label 13037: @848495
     /*  848495 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(848579), // Rule ID 17158 //
     /*  848500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  848503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  848511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  848514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  848517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  848520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848543 */     // MIs[0] round
     /*  848543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848555 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  848555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  848558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848564 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848577 */     GIR_RootConstrainSelectedInstOperands,
     /*  848578 */     // GIR_Coverage, 17158,
     /*  848578 */     GIR_EraseRootFromParent_Done,
     /*  848579 */   // Label 13038: @848579
     /*  848579 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(848663), // Rule ID 17159 //
     /*  848584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  848587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  848595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  848598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  848601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  848604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848627 */     // MIs[0] round
     /*  848627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848639 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  848639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  848642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848648 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848661 */     GIR_RootConstrainSelectedInstOperands,
     /*  848662 */     // GIR_Coverage, 17159,
     /*  848662 */     GIR_EraseRootFromParent_Done,
     /*  848663 */   // Label 13039: @848663
     /*  848663 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(848747), // Rule ID 17168 //
     /*  848668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  848671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  848688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848711 */     // MIs[0] round
     /*  848711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848723 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  848723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  848726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848745 */     GIR_RootConstrainSelectedInstOperands,
     /*  848746 */     // GIR_Coverage, 17168,
     /*  848746 */     GIR_EraseRootFromParent_Done,
     /*  848747 */   // Label 13040: @848747
     /*  848747 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(848831), // Rule ID 17169 //
     /*  848752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  848755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  848772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848795 */     // MIs[0] round
     /*  848795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  848807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  848810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848829 */     GIR_RootConstrainSelectedInstOperands,
     /*  848830 */     // GIR_Coverage, 17169,
     /*  848830 */     GIR_EraseRootFromParent_Done,
     /*  848831 */   // Label 13041: @848831
     /*  848831 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(848915), // Rule ID 17178 //
     /*  848836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  848839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  848856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  848859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848879 */     // MIs[0] round
     /*  848879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848891 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  848891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  848894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848913 */     GIR_RootConstrainSelectedInstOperands,
     /*  848914 */     // GIR_Coverage, 17178,
     /*  848914 */     GIR_EraseRootFromParent_Done,
     /*  848915 */   // Label 13042: @848915
     /*  848915 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(848999), // Rule ID 17179 //
     /*  848920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  848923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  848928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  848940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  848943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  848951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  848955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848963 */     // MIs[0] round
     /*  848963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  848966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  848968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848975 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  848975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  848978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  848986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848997 */     GIR_RootConstrainSelectedInstOperands,
     /*  848998 */     // GIR_Coverage, 17179,
     /*  848998 */     GIR_EraseRootFromParent_Done,
     /*  848999 */   // Label 13043: @848999
     /*  848999 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(849083), // Rule ID 17188 //
     /*  849004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  849007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  849012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  849024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  849035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  849039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849047 */     // MIs[0] round
     /*  849047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  849050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  849052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849059 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  849059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  849062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  849070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849081 */     GIR_RootConstrainSelectedInstOperands,
     /*  849082 */     // GIR_Coverage, 17188,
     /*  849082 */     GIR_EraseRootFromParent_Done,
     /*  849083 */   // Label 13044: @849083
     /*  849083 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(849167), // Rule ID 17189 //
     /*  849088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  849091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  849096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  849108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  849119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  849123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849131 */     // MIs[0] round
     /*  849131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  849134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  849136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849143 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  849143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  849146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  849154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849165 */     GIR_RootConstrainSelectedInstOperands,
     /*  849166 */     // GIR_Coverage, 17189,
     /*  849166 */     GIR_EraseRootFromParent_Done,
     /*  849167 */   // Label 13045: @849167
     /*  849167 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(849249), // Rule ID 62143 //
     /*  849172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  849189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849199 */     // MIs[0] op1
     /*  849199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  849226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  849229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849237 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849247 */     GIR_RootConstrainSelectedInstOperands,
     /*  849248 */     // GIR_Coverage, 62143,
     /*  849248 */     GIR_EraseRootFromParent_Done,
     /*  849249 */   // Label 13046: @849249
     /*  849249 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(849331), // Rule ID 62144 //
     /*  849254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  849257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  849271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849281 */     // MIs[0] op1
     /*  849281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  849308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  849311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849313 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849315 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849317 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849319 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849329 */     GIR_RootConstrainSelectedInstOperands,
     /*  849330 */     // GIR_Coverage, 62144,
     /*  849330 */     GIR_EraseRootFromParent_Done,
     /*  849331 */   // Label 13047: @849331
     /*  849331 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(849413), // Rule ID 62173 //
     /*  849336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  849344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  849353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  849356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849363 */     // MIs[0] op1
     /*  849363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849390 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  849390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  849393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849395 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849397 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849399 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849401 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849411 */     GIR_RootConstrainSelectedInstOperands,
     /*  849412 */     // GIR_Coverage, 62173,
     /*  849412 */     GIR_EraseRootFromParent_Done,
     /*  849413 */   // Label 13048: @849413
     /*  849413 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(849495), // Rule ID 62174 //
     /*  849418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  849421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  849426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  849435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  849438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849445 */     // MIs[0] op1
     /*  849445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  849472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  849475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849477 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849479 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849481 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849483 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849493 */     GIR_RootConstrainSelectedInstOperands,
     /*  849494 */     // GIR_Coverage, 62174,
     /*  849494 */     GIR_EraseRootFromParent_Done,
     /*  849495 */   // Label 13049: @849495
     /*  849495 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(849577), // Rule ID 62205 //
     /*  849500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  849517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849527 */     // MIs[0] op1
     /*  849527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  849554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  849557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849559 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849561 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849563 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849565 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849575 */     GIR_RootConstrainSelectedInstOperands,
     /*  849576 */     // GIR_Coverage, 62205,
     /*  849576 */     GIR_EraseRootFromParent_Done,
     /*  849577 */   // Label 13050: @849577
     /*  849577 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(849659), // Rule ID 62206 //
     /*  849582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  849585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  849599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849609 */     // MIs[0] op1
     /*  849609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849636 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  849636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  849639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849641 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849643 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849645 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849647 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849657 */     GIR_RootConstrainSelectedInstOperands,
     /*  849658 */     // GIR_Coverage, 62206,
     /*  849658 */     GIR_EraseRootFromParent_Done,
     /*  849659 */   // Label 13051: @849659
     /*  849659 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(849741), // Rule ID 62217 //
     /*  849664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  849672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  849681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  849684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849691 */     // MIs[0] op1
     /*  849691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  849718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  849721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849723 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849725 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849727 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849729 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849739 */     GIR_RootConstrainSelectedInstOperands,
     /*  849740 */     // GIR_Coverage, 62217,
     /*  849740 */     GIR_EraseRootFromParent_Done,
     /*  849741 */   // Label 13052: @849741
     /*  849741 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(849823), // Rule ID 62218 //
     /*  849746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  849749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  849754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  849763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  849766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849773 */     // MIs[0] op1
     /*  849773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  849800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  849803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849811 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849821 */     GIR_RootConstrainSelectedInstOperands,
     /*  849822 */     // GIR_Coverage, 62218,
     /*  849822 */     GIR_EraseRootFromParent_Done,
     /*  849823 */   // Label 13053: @849823
     /*  849823 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(849905), // Rule ID 62249 //
     /*  849828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  849845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  849851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849855 */     // MIs[0] op1
     /*  849855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  849882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  849885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849887 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849889 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849891 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849893 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849903 */     GIR_RootConstrainSelectedInstOperands,
     /*  849904 */     // GIR_Coverage, 62249,
     /*  849904 */     GIR_EraseRootFromParent_Done,
     /*  849905 */   // Label 13054: @849905
     /*  849905 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(849987), // Rule ID 62250 //
     /*  849910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  849913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  849918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  849927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  849933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849937 */     // MIs[0] op1
     /*  849937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  849940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  849945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  849964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  849967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849969 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  849971 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  849973 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  849975 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  849977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849985 */     GIR_RootConstrainSelectedInstOperands,
     /*  849986 */     // GIR_Coverage, 62250,
     /*  849986 */     GIR_EraseRootFromParent_Done,
     /*  849987 */   // Label 13055: @849987
     /*  849987 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(850069), // Rule ID 62261 //
     /*  849992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  849995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  850003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  850006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  850009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  850012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850019 */     // MIs[0] op1
     /*  850019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  850046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  850049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850057 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850067 */     GIR_RootConstrainSelectedInstOperands,
     /*  850068 */     // GIR_Coverage, 62261,
     /*  850068 */     GIR_EraseRootFromParent_Done,
     /*  850069 */   // Label 13056: @850069
     /*  850069 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(850151), // Rule ID 62262 //
     /*  850074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  850085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  850088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  850091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  850094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850101 */     // MIs[0] op1
     /*  850101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  850128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  850131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850133 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850135 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850137 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850139 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850149 */     GIR_RootConstrainSelectedInstOperands,
     /*  850150 */     // GIR_Coverage, 62262,
     /*  850150 */     GIR_EraseRootFromParent_Done,
     /*  850151 */   // Label 13057: @850151
     /*  850151 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(850233), // Rule ID 62293 //
     /*  850156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  850164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850183 */     // MIs[0] op1
     /*  850183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  850210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  850213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850221 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850231 */     GIR_RootConstrainSelectedInstOperands,
     /*  850232 */     // GIR_Coverage, 62293,
     /*  850232 */     GIR_EraseRootFromParent_Done,
     /*  850233 */   // Label 13058: @850233
     /*  850233 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(850315), // Rule ID 62294 //
     /*  850238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  850246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850265 */     // MIs[0] op1
     /*  850265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  850292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  850295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850297 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850299 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850301 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850303 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850313 */     GIR_RootConstrainSelectedInstOperands,
     /*  850314 */     // GIR_Coverage, 62294,
     /*  850314 */     GIR_EraseRootFromParent_Done,
     /*  850315 */   // Label 13059: @850315
     /*  850315 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(850397), // Rule ID 62305 //
     /*  850320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  850340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850347 */     // MIs[0] op1
     /*  850347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  850374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  850377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850379 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850381 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850383 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850385 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850395 */     GIR_RootConstrainSelectedInstOperands,
     /*  850396 */     // GIR_Coverage, 62305,
     /*  850396 */     GIR_EraseRootFromParent_Done,
     /*  850397 */   // Label 13060: @850397
     /*  850397 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(850479), // Rule ID 62306 //
     /*  850402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  850422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850429 */     // MIs[0] op1
     /*  850429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  850456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  850459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850461 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850463 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850465 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850467 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850477 */     GIR_RootConstrainSelectedInstOperands,
     /*  850478 */     // GIR_Coverage, 62306,
     /*  850478 */     GIR_EraseRootFromParent_Done,
     /*  850479 */   // Label 13061: @850479
     /*  850479 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(850561), // Rule ID 62317 //
     /*  850484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  850492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  850504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850511 */     // MIs[0] op1
     /*  850511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  850519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  850531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850538 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  850538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  850541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850543 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850545 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850547 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850549 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850559 */     GIR_RootConstrainSelectedInstOperands,
     /*  850560 */     // GIR_Coverage, 62317,
     /*  850560 */     GIR_EraseRootFromParent_Done,
     /*  850561 */   // Label 13062: @850561
     /*  850561 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(850643), // Rule ID 62318 //
     /*  850566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  850574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  850577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  850580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  850583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  850586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850593 */     // MIs[0] op1
     /*  850593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  850601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  850613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  850620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  850623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850625 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850627 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850629 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850631 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850641 */     GIR_RootConstrainSelectedInstOperands,
     /*  850642 */     // GIR_Coverage, 62318,
     /*  850642 */     GIR_EraseRootFromParent_Done,
     /*  850643 */   // Label 13063: @850643
     /*  850643 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(850725), // Rule ID 62349 //
     /*  850648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  850656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  850659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  850662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  850665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850675 */     // MIs[0] op1
     /*  850675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850702 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  850702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  850705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850707 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850709 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850711 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850713 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850723 */     GIR_RootConstrainSelectedInstOperands,
     /*  850724 */     // GIR_Coverage, 62349,
     /*  850724 */     GIR_EraseRootFromParent_Done,
     /*  850725 */   // Label 13064: @850725
     /*  850725 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(850807), // Rule ID 62350 //
     /*  850730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  850738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  850741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  850744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  850747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850757 */     // MIs[0] op1
     /*  850757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  850784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  850787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850789 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850791 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850793 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850795 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850805 */     GIR_RootConstrainSelectedInstOperands,
     /*  850806 */     // GIR_Coverage, 62350,
     /*  850806 */     GIR_EraseRootFromParent_Done,
     /*  850807 */   // Label 13065: @850807
     /*  850807 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(850889), // Rule ID 62361 //
     /*  850812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  850823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  850826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  850829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  850832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850839 */     // MIs[0] op1
     /*  850839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  850866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  850869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850871 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850873 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850875 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850877 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850887 */     GIR_RootConstrainSelectedInstOperands,
     /*  850888 */     // GIR_Coverage, 62361,
     /*  850888 */     GIR_EraseRootFromParent_Done,
     /*  850889 */   // Label 13066: @850889
     /*  850889 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(850971), // Rule ID 62362 //
     /*  850894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  850897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  850902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  850905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  850908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  850911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  850914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  850917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850921 */     // MIs[0] op1
     /*  850921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  850924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  850929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850948 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  850948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  850951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  850955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  850957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  850959 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  850961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850969 */     GIR_RootConstrainSelectedInstOperands,
     /*  850970 */     // GIR_Coverage, 62362,
     /*  850970 */     GIR_EraseRootFromParent_Done,
     /*  850971 */   // Label 13067: @850971
     /*  850971 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(851053), // Rule ID 62373 //
     /*  850976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  850979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  850984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  850987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  850990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  850993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  850996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  850999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851003 */     // MIs[0] op1
     /*  851003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  851011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  851030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  851033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851035 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851037 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851039 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851041 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851051 */     GIR_RootConstrainSelectedInstOperands,
     /*  851052 */     // GIR_Coverage, 62373,
     /*  851052 */     GIR_EraseRootFromParent_Done,
     /*  851053 */   // Label 13068: @851053
     /*  851053 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(851135), // Rule ID 62374 //
     /*  851058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  851066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  851069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  851072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  851075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  851078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851085 */     // MIs[0] op1
     /*  851085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  851093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  851112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  851115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851117 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851119 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851121 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851123 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851133 */     GIR_RootConstrainSelectedInstOperands,
     /*  851134 */     // GIR_Coverage, 62374,
     /*  851134 */     GIR_EraseRootFromParent_Done,
     /*  851135 */   // Label 13069: @851135
     /*  851135 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(851217), // Rule ID 62405 //
     /*  851140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  851148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851167 */     // MIs[0] op1
     /*  851167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  851194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  851197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851205 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851215 */     GIR_RootConstrainSelectedInstOperands,
     /*  851216 */     // GIR_Coverage, 62405,
     /*  851216 */     GIR_EraseRootFromParent_Done,
     /*  851217 */   // Label 13070: @851217
     /*  851217 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(851299), // Rule ID 62406 //
     /*  851222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  851230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851249 */     // MIs[0] op1
     /*  851249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  851276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  851279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851281 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851283 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851285 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851287 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851297 */     GIR_RootConstrainSelectedInstOperands,
     /*  851298 */     // GIR_Coverage, 62406,
     /*  851298 */     GIR_EraseRootFromParent_Done,
     /*  851299 */   // Label 13071: @851299
     /*  851299 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(851381), // Rule ID 62417 //
     /*  851304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  851312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  851324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851331 */     // MIs[0] op1
     /*  851331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  851358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  851361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851369 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851379 */     GIR_RootConstrainSelectedInstOperands,
     /*  851380 */     // GIR_Coverage, 62417,
     /*  851380 */     GIR_EraseRootFromParent_Done,
     /*  851381 */   // Label 13072: @851381
     /*  851381 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(851463), // Rule ID 62418 //
     /*  851386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  851394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  851406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851413 */     // MIs[0] op1
     /*  851413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  851440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  851443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851445 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851447 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851449 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851451 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851461 */     GIR_RootConstrainSelectedInstOperands,
     /*  851462 */     // GIR_Coverage, 62418,
     /*  851462 */     GIR_EraseRootFromParent_Done,
     /*  851463 */   // Label 13073: @851463
     /*  851463 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(851545), // Rule ID 62429 //
     /*  851468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  851476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851495 */     // MIs[0] op1
     /*  851495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  851503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  851515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  851522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  851525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851533 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851543 */     GIR_RootConstrainSelectedInstOperands,
     /*  851544 */     // GIR_Coverage, 62429,
     /*  851544 */     GIR_EraseRootFromParent_Done,
     /*  851545 */   // Label 13074: @851545
     /*  851545 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(851627), // Rule ID 62430 //
     /*  851550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  851558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  851567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851577 */     // MIs[0] op1
     /*  851577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  851585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  851597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  851604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  851607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851609 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851611 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851613 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851615 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851625 */     GIR_RootConstrainSelectedInstOperands,
     /*  851626 */     // GIR_Coverage, 62430,
     /*  851626 */     GIR_EraseRootFromParent_Done,
     /*  851627 */   // Label 13075: @851627
     /*  851627 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(851709), // Rule ID 62461 //
     /*  851632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  851640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  851643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  851646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  851649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851659 */     // MIs[0] op1
     /*  851659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  851686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  851689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851691 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851693 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851695 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851697 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851707 */     GIR_RootConstrainSelectedInstOperands,
     /*  851708 */     // GIR_Coverage, 62461,
     /*  851708 */     GIR_EraseRootFromParent_Done,
     /*  851709 */   // Label 13076: @851709
     /*  851709 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(851791), // Rule ID 62462 //
     /*  851714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  851722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  851725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  851728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  851731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851741 */     // MIs[0] op1
     /*  851741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  851768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  851771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851773 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851775 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851777 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851779 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851789 */     GIR_RootConstrainSelectedInstOperands,
     /*  851790 */     // GIR_Coverage, 62462,
     /*  851790 */     GIR_EraseRootFromParent_Done,
     /*  851791 */   // Label 13077: @851791
     /*  851791 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(851873), // Rule ID 62473 //
     /*  851796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  851804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  851807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  851810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  851813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  851816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851823 */     // MIs[0] op1
     /*  851823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  851850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  851853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851855 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851857 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851859 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851861 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851871 */     GIR_RootConstrainSelectedInstOperands,
     /*  851872 */     // GIR_Coverage, 62473,
     /*  851872 */     GIR_EraseRootFromParent_Done,
     /*  851873 */   // Label 13078: @851873
     /*  851873 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(851955), // Rule ID 62474 //
     /*  851878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  851881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  851886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  851889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  851892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  851895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  851898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  851901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851905 */     // MIs[0] op1
     /*  851905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  851932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  851935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851937 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  851939 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  851941 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  851943 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  851945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851953 */     GIR_RootConstrainSelectedInstOperands,
     /*  851954 */     // GIR_Coverage, 62474,
     /*  851954 */     GIR_EraseRootFromParent_Done,
     /*  851955 */   // Label 13079: @851955
     /*  851955 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(852037), // Rule ID 62505 //
     /*  851960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  851963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  851968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  851971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  851974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  851977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  851983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851987 */     // MIs[0] op1
     /*  851987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  851990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  851995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  852014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  852017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852019 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852021 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852023 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852025 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852035 */     GIR_RootConstrainSelectedInstOperands,
     /*  852036 */     // GIR_Coverage, 62505,
     /*  852036 */     GIR_EraseRootFromParent_Done,
     /*  852037 */   // Label 13080: @852037
     /*  852037 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(852119), // Rule ID 62506 //
     /*  852042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  852050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  852059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852069 */     // MIs[0] op1
     /*  852069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  852096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  852099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852101 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852103 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852105 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852107 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852117 */     GIR_RootConstrainSelectedInstOperands,
     /*  852118 */     // GIR_Coverage, 62506,
     /*  852118 */     GIR_EraseRootFromParent_Done,
     /*  852119 */   // Label 13081: @852119
     /*  852119 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(852201), // Rule ID 62517 //
     /*  852124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  852132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  852141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  852144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852151 */     // MIs[0] op1
     /*  852151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852178 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  852178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  852181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852183 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852185 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852187 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852189 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852199 */     GIR_RootConstrainSelectedInstOperands,
     /*  852200 */     // GIR_Coverage, 62517,
     /*  852200 */     GIR_EraseRootFromParent_Done,
     /*  852201 */   // Label 13082: @852201
     /*  852201 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(852283), // Rule ID 62518 //
     /*  852206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  852214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  852223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  852226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852233 */     // MIs[0] op1
     /*  852233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  852260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  852263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852265 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852267 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852269 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852271 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852281 */     GIR_RootConstrainSelectedInstOperands,
     /*  852282 */     // GIR_Coverage, 62518,
     /*  852282 */     GIR_EraseRootFromParent_Done,
     /*  852283 */   // Label 13083: @852283
     /*  852283 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(852365), // Rule ID 62529 //
     /*  852288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  852296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  852305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  852308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852315 */     // MIs[0] op1
     /*  852315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  852323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  852342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  852345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852347 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852349 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852351 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852353 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852363 */     GIR_RootConstrainSelectedInstOperands,
     /*  852364 */     // GIR_Coverage, 62529,
     /*  852364 */     GIR_EraseRootFromParent_Done,
     /*  852365 */   // Label 13084: @852365
     /*  852365 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(852447), // Rule ID 62530 //
     /*  852370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  852378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  852387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  852390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852397 */     // MIs[0] op1
     /*  852397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  852405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  852424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  852427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852429 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852431 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852433 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852435 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852445 */     GIR_RootConstrainSelectedInstOperands,
     /*  852446 */     // GIR_Coverage, 62530,
     /*  852446 */     GIR_EraseRootFromParent_Done,
     /*  852447 */   // Label 13085: @852447
     /*  852447 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(852529), // Rule ID 62561 //
     /*  852452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  852460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852479 */     // MIs[0] op1
     /*  852479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  852506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  852509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852517 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852527 */     GIR_RootConstrainSelectedInstOperands,
     /*  852528 */     // GIR_Coverage, 62561,
     /*  852528 */     GIR_EraseRootFromParent_Done,
     /*  852529 */   // Label 13086: @852529
     /*  852529 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(852611), // Rule ID 62562 //
     /*  852534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  852542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852561 */     // MIs[0] op1
     /*  852561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  852588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  852591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852599 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852609 */     GIR_RootConstrainSelectedInstOperands,
     /*  852610 */     // GIR_Coverage, 62562,
     /*  852610 */     GIR_EraseRootFromParent_Done,
     /*  852611 */   // Label 13087: @852611
     /*  852611 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(852693), // Rule ID 62573 //
     /*  852616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  852624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  852636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852643 */     // MIs[0] op1
     /*  852643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  852670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  852673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852675 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852677 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852679 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852681 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852691 */     GIR_RootConstrainSelectedInstOperands,
     /*  852692 */     // GIR_Coverage, 62573,
     /*  852692 */     GIR_EraseRootFromParent_Done,
     /*  852693 */   // Label 13088: @852693
     /*  852693 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(852775), // Rule ID 62574 //
     /*  852698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  852706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  852718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852725 */     // MIs[0] op1
     /*  852725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  852752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  852755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852757 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852759 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852761 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852763 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852773 */     GIR_RootConstrainSelectedInstOperands,
     /*  852774 */     // GIR_Coverage, 62574,
     /*  852774 */     GIR_EraseRootFromParent_Done,
     /*  852775 */   // Label 13089: @852775
     /*  852775 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(852857), // Rule ID 62585 //
     /*  852780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  852788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852807 */     // MIs[0] op1
     /*  852807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  852815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  852834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  852837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852839 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852841 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852843 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852845 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852855 */     GIR_RootConstrainSelectedInstOperands,
     /*  852856 */     // GIR_Coverage, 62585,
     /*  852856 */     GIR_EraseRootFromParent_Done,
     /*  852857 */   // Label 13090: @852857
     /*  852857 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(852939), // Rule ID 62586 //
     /*  852862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  852865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  852870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  852879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  852885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852889 */     // MIs[0] op1
     /*  852889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  852897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  852916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  852919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852921 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  852923 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  852925 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  852927 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  852929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852937 */     GIR_RootConstrainSelectedInstOperands,
     /*  852938 */     // GIR_Coverage, 62586,
     /*  852938 */     GIR_EraseRootFromParent_Done,
     /*  852939 */   // Label 13091: @852939
     /*  852939 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(853021), // Rule ID 62617 //
     /*  852944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  852947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  852952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  852961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  852967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852971 */     // MIs[0] op1
     /*  852971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  852974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  852979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  852998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  853001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853003 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853005 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853007 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853009 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853019 */     GIR_RootConstrainSelectedInstOperands,
     /*  853020 */     // GIR_Coverage, 62617,
     /*  853020 */     GIR_EraseRootFromParent_Done,
     /*  853021 */   // Label 13092: @853021
     /*  853021 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(853103), // Rule ID 62618 //
     /*  853026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  853034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  853043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853053 */     // MIs[0] op1
     /*  853053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  853080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  853083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853085 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853087 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853089 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853091 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853101 */     GIR_RootConstrainSelectedInstOperands,
     /*  853102 */     // GIR_Coverage, 62618,
     /*  853102 */     GIR_EraseRootFromParent_Done,
     /*  853103 */   // Label 13093: @853103
     /*  853103 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(853185), // Rule ID 62629 //
     /*  853108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  853116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  853125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  853128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853135 */     // MIs[0] op1
     /*  853135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  853162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  853165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853167 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853169 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853171 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853173 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853183 */     GIR_RootConstrainSelectedInstOperands,
     /*  853184 */     // GIR_Coverage, 62629,
     /*  853184 */     GIR_EraseRootFromParent_Done,
     /*  853185 */   // Label 13094: @853185
     /*  853185 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(853267), // Rule ID 62630 //
     /*  853190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  853198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  853207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  853210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853217 */     // MIs[0] op1
     /*  853217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  853244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  853247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853249 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853251 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853253 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853255 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853265 */     GIR_RootConstrainSelectedInstOperands,
     /*  853266 */     // GIR_Coverage, 62630,
     /*  853266 */     GIR_EraseRootFromParent_Done,
     /*  853267 */   // Label 13095: @853267
     /*  853267 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(853349), // Rule ID 62641 //
     /*  853272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  853280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  853289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853299 */     // MIs[0] op1
     /*  853299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  853307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  853326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  853329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853331 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853333 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853335 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853337 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853347 */     GIR_RootConstrainSelectedInstOperands,
     /*  853348 */     // GIR_Coverage, 62641,
     /*  853348 */     GIR_EraseRootFromParent_Done,
     /*  853349 */   // Label 13096: @853349
     /*  853349 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(853431), // Rule ID 62642 //
     /*  853354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  853362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  853371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853381 */     // MIs[0] op1
     /*  853381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  853389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  853408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  853411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853413 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853415 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853417 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853419 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853429 */     GIR_RootConstrainSelectedInstOperands,
     /*  853430 */     // GIR_Coverage, 62642,
     /*  853430 */     GIR_EraseRootFromParent_Done,
     /*  853431 */   // Label 13097: @853431
     /*  853431 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(853513), // Rule ID 62673 //
     /*  853436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  853444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  853447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  853450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  853453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853463 */     // MIs[0] op1
     /*  853463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  853490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  853493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853495 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853497 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853499 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853501 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853511 */     GIR_RootConstrainSelectedInstOperands,
     /*  853512 */     // GIR_Coverage, 62673,
     /*  853512 */     GIR_EraseRootFromParent_Done,
     /*  853513 */   // Label 13098: @853513
     /*  853513 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(853595), // Rule ID 62674 //
     /*  853518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  853526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  853529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  853532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  853535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853545 */     // MIs[0] op1
     /*  853545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  853572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  853575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853577 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853579 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853581 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853583 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853593 */     GIR_RootConstrainSelectedInstOperands,
     /*  853594 */     // GIR_Coverage, 62674,
     /*  853594 */     GIR_EraseRootFromParent_Done,
     /*  853595 */   // Label 13099: @853595
     /*  853595 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(853677), // Rule ID 62685 //
     /*  853600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  853608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  853611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  853614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  853617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  853620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853627 */     // MIs[0] op1
     /*  853627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  853654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  853657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853665 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853675 */     GIR_RootConstrainSelectedInstOperands,
     /*  853676 */     // GIR_Coverage, 62685,
     /*  853676 */     GIR_EraseRootFromParent_Done,
     /*  853677 */   // Label 13100: @853677
     /*  853677 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(853759), // Rule ID 62686 //
     /*  853682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  853690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  853693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  853696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  853699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  853702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853709 */     // MIs[0] op1
     /*  853709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  853736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  853739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853741 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853743 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853745 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853747 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853757 */     GIR_RootConstrainSelectedInstOperands,
     /*  853758 */     // GIR_Coverage, 62686,
     /*  853758 */     GIR_EraseRootFromParent_Done,
     /*  853759 */   // Label 13101: @853759
     /*  853759 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(853841), // Rule ID 62717 //
     /*  853764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  853772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  853775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  853778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  853781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853791 */     // MIs[0] op1
     /*  853791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853818 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  853818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  853821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853823 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853825 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853827 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853829 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853839 */     GIR_RootConstrainSelectedInstOperands,
     /*  853840 */     // GIR_Coverage, 62717,
     /*  853840 */     GIR_EraseRootFromParent_Done,
     /*  853841 */   // Label 13102: @853841
     /*  853841 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(853923), // Rule ID 62718 //
     /*  853846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  853849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  853854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  853857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  853860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  853863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  853869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853873 */     // MIs[0] op1
     /*  853873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  853900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  853903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853905 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853907 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853909 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853911 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853921 */     GIR_RootConstrainSelectedInstOperands,
     /*  853922 */     // GIR_Coverage, 62718,
     /*  853922 */     GIR_EraseRootFromParent_Done,
     /*  853923 */   // Label 13103: @853923
     /*  853923 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(854005), // Rule ID 62729 //
     /*  853928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  853931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  853936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  853939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  853942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  853945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  853948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  853951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853955 */     // MIs[0] op1
     /*  853955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  853958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  853963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  853982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  853985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853987 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  853989 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  853991 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  853993 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  853995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854003 */     GIR_RootConstrainSelectedInstOperands,
     /*  854004 */     // GIR_Coverage, 62729,
     /*  854004 */     GIR_EraseRootFromParent_Done,
     /*  854005 */   // Label 13104: @854005
     /*  854005 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(854087), // Rule ID 62730 //
     /*  854010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  854018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  854021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  854024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  854027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  854030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854037 */     // MIs[0] op1
     /*  854037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854064 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  854064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  854067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854069 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854071 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854073 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854075 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854085 */     GIR_RootConstrainSelectedInstOperands,
     /*  854086 */     // GIR_Coverage, 62730,
     /*  854086 */     GIR_EraseRootFromParent_Done,
     /*  854087 */   // Label 13105: @854087
     /*  854087 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(854169), // Rule ID 62761 //
     /*  854092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  854100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  854109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854119 */     // MIs[0] op1
     /*  854119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  854146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  854149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854151 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854153 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854155 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854157 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854167 */     GIR_RootConstrainSelectedInstOperands,
     /*  854168 */     // GIR_Coverage, 62761,
     /*  854168 */     GIR_EraseRootFromParent_Done,
     /*  854169 */   // Label 13106: @854169
     /*  854169 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(854251), // Rule ID 62762 //
     /*  854174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  854182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  854191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854201 */     // MIs[0] op1
     /*  854201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  854228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  854231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854239 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854249 */     GIR_RootConstrainSelectedInstOperands,
     /*  854250 */     // GIR_Coverage, 62762,
     /*  854250 */     GIR_EraseRootFromParent_Done,
     /*  854251 */   // Label 13107: @854251
     /*  854251 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(854333), // Rule ID 62773 //
     /*  854256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  854264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  854273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  854276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854283 */     // MIs[0] op1
     /*  854283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854310 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  854310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  854313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854315 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854317 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854319 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854321 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854331 */     GIR_RootConstrainSelectedInstOperands,
     /*  854332 */     // GIR_Coverage, 62773,
     /*  854332 */     GIR_EraseRootFromParent_Done,
     /*  854333 */   // Label 13108: @854333
     /*  854333 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(854415), // Rule ID 62774 //
     /*  854338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  854346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  854355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  854358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854365 */     // MIs[0] op1
     /*  854365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  854392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  854395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854403 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854413 */     GIR_RootConstrainSelectedInstOperands,
     /*  854414 */     // GIR_Coverage, 62774,
     /*  854414 */     GIR_EraseRootFromParent_Done,
     /*  854415 */   // Label 13109: @854415
     /*  854415 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(854497), // Rule ID 62805 //
     /*  854420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  854428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854447 */     // MIs[0] op1
     /*  854447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  854474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  854477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854479 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854481 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854483 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854485 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854495 */     GIR_RootConstrainSelectedInstOperands,
     /*  854496 */     // GIR_Coverage, 62805,
     /*  854496 */     GIR_EraseRootFromParent_Done,
     /*  854497 */   // Label 13110: @854497
     /*  854497 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(854579), // Rule ID 62806 //
     /*  854502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  854510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854529 */     // MIs[0] op1
     /*  854529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  854556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  854559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854561 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854563 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854565 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854567 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854577 */     GIR_RootConstrainSelectedInstOperands,
     /*  854578 */     // GIR_Coverage, 62806,
     /*  854578 */     GIR_EraseRootFromParent_Done,
     /*  854579 */   // Label 13111: @854579
     /*  854579 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(854661), // Rule ID 62817 //
     /*  854584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  854592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  854604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854611 */     // MIs[0] op1
     /*  854611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  854638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  854641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854643 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854645 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854647 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854649 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854659 */     GIR_RootConstrainSelectedInstOperands,
     /*  854660 */     // GIR_Coverage, 62817,
     /*  854660 */     GIR_EraseRootFromParent_Done,
     /*  854661 */   // Label 13112: @854661
     /*  854661 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(854743), // Rule ID 62818 //
     /*  854666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  854674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  854686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854693 */     // MIs[0] op1
     /*  854693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  854720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  854723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854725 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854727 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854729 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854731 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854741 */     GIR_RootConstrainSelectedInstOperands,
     /*  854742 */     // GIR_Coverage, 62818,
     /*  854742 */     GIR_EraseRootFromParent_Done,
     /*  854743 */   // Label 13113: @854743
     /*  854743 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(854825), // Rule ID 62829 //
     /*  854748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  854756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  854768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854775 */     // MIs[0] op1
     /*  854775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  854783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  854802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  854805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854813 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854823 */     GIR_RootConstrainSelectedInstOperands,
     /*  854824 */     // GIR_Coverage, 62829,
     /*  854824 */     GIR_EraseRootFromParent_Done,
     /*  854825 */   // Label 13114: @854825
     /*  854825 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(854907), // Rule ID 62830 //
     /*  854830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  854838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  854847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  854850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  854853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854857 */     // MIs[0] op1
     /*  854857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  854865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  854884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  854887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854889 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854891 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854893 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854895 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854905 */     GIR_RootConstrainSelectedInstOperands,
     /*  854906 */     // GIR_Coverage, 62830,
     /*  854906 */     GIR_EraseRootFromParent_Done,
     /*  854907 */   // Label 13115: @854907
     /*  854907 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(854989), // Rule ID 62861 //
     /*  854912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  854915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  854920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  854929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  854935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854939 */     // MIs[0] op1
     /*  854939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  854942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  854947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  854966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  854969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854971 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  854973 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  854975 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  854977 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  854979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854987 */     GIR_RootConstrainSelectedInstOperands,
     /*  854988 */     // GIR_Coverage, 62861,
     /*  854988 */     GIR_EraseRootFromParent_Done,
     /*  854989 */   // Label 13116: @854989
     /*  854989 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(855071), // Rule ID 62862 //
     /*  854994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  854997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  855002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  855011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855021 */     // MIs[0] op1
     /*  855021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  855051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855059 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855069 */     GIR_RootConstrainSelectedInstOperands,
     /*  855070 */     // GIR_Coverage, 62862,
     /*  855070 */     GIR_EraseRootFromParent_Done,
     /*  855071 */   // Label 13117: @855071
     /*  855071 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(855153), // Rule ID 62873 //
     /*  855076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  855084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  855093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  855096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855103 */     // MIs[0] op1
     /*  855103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  855130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  855133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855135 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855137 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855139 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855141 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855151 */     GIR_RootConstrainSelectedInstOperands,
     /*  855152 */     // GIR_Coverage, 62873,
     /*  855152 */     GIR_EraseRootFromParent_Done,
     /*  855153 */   // Label 13118: @855153
     /*  855153 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(855235), // Rule ID 62874 //
     /*  855158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  855166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  855175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  855178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855185 */     // MIs[0] op1
     /*  855185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  855215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855223 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855233 */     GIR_RootConstrainSelectedInstOperands,
     /*  855234 */     // GIR_Coverage, 62874,
     /*  855234 */     GIR_EraseRootFromParent_Done,
     /*  855235 */   // Label 13119: @855235
     /*  855235 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(855317), // Rule ID 62885 //
     /*  855240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  855248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  855257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  855260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855267 */     // MIs[0] op1
     /*  855267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  855275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  855294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  855297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855299 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855301 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855303 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855305 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855315 */     GIR_RootConstrainSelectedInstOperands,
     /*  855316 */     // GIR_Coverage, 62885,
     /*  855316 */     GIR_EraseRootFromParent_Done,
     /*  855317 */   // Label 13120: @855317
     /*  855317 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(855399), // Rule ID 62886 //
     /*  855322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  855330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  855339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  855342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855349 */     // MIs[0] op1
     /*  855349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  855357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  855379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855387 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855397 */     GIR_RootConstrainSelectedInstOperands,
     /*  855398 */     // GIR_Coverage, 62886,
     /*  855398 */     GIR_EraseRootFromParent_Done,
     /*  855399 */   // Label 13121: @855399
     /*  855399 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(855481), // Rule ID 62917 //
     /*  855404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  855412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855431 */     // MIs[0] op1
     /*  855431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  855458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  855461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855463 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855465 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855467 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855469 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855479 */     GIR_RootConstrainSelectedInstOperands,
     /*  855480 */     // GIR_Coverage, 62917,
     /*  855480 */     GIR_EraseRootFromParent_Done,
     /*  855481 */   // Label 13122: @855481
     /*  855481 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(855563), // Rule ID 62918 //
     /*  855486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  855494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855513 */     // MIs[0] op1
     /*  855513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  855543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855545 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855547 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855549 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855551 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855561 */     GIR_RootConstrainSelectedInstOperands,
     /*  855562 */     // GIR_Coverage, 62918,
     /*  855562 */     GIR_EraseRootFromParent_Done,
     /*  855563 */   // Label 13123: @855563
     /*  855563 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(855645), // Rule ID 62929 //
     /*  855568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  855576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  855588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855595 */     // MIs[0] op1
     /*  855595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  855622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  855625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855627 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855629 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855631 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855633 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855643 */     GIR_RootConstrainSelectedInstOperands,
     /*  855644 */     // GIR_Coverage, 62929,
     /*  855644 */     GIR_EraseRootFromParent_Done,
     /*  855645 */   // Label 13124: @855645
     /*  855645 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(855727), // Rule ID 62930 //
     /*  855650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  855658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  855670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855677 */     // MIs[0] op1
     /*  855677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  855707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855709 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855711 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855713 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855715 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855725 */     GIR_RootConstrainSelectedInstOperands,
     /*  855726 */     // GIR_Coverage, 62930,
     /*  855726 */     GIR_EraseRootFromParent_Done,
     /*  855727 */   // Label 13125: @855727
     /*  855727 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(855809), // Rule ID 62941 //
     /*  855732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  855740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  855752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855759 */     // MIs[0] op1
     /*  855759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  855767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  855786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  855789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855791 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855793 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855795 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855797 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855807 */     GIR_RootConstrainSelectedInstOperands,
     /*  855808 */     // GIR_Coverage, 62941,
     /*  855808 */     GIR_EraseRootFromParent_Done,
     /*  855809 */   // Label 13126: @855809
     /*  855809 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(855891), // Rule ID 62942 //
     /*  855814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  855822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  855831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  855834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  855837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855841 */     // MIs[0] op1
     /*  855841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  855849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  855868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  855871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855873 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855875 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855877 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855879 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855889 */     GIR_RootConstrainSelectedInstOperands,
     /*  855890 */     // GIR_Coverage, 62942,
     /*  855890 */     GIR_EraseRootFromParent_Done,
     /*  855891 */   // Label 13127: @855891
     /*  855891 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(855973), // Rule ID 62973 //
     /*  855896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  855899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  855904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  855913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  855919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855923 */     // MIs[0] op1
     /*  855923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  855926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  855931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  855950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  855953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855955 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  855957 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  855959 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  855961 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  855963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855971 */     GIR_RootConstrainSelectedInstOperands,
     /*  855972 */     // GIR_Coverage, 62973,
     /*  855972 */     GIR_EraseRootFromParent_Done,
     /*  855973 */   // Label 13128: @855973
     /*  855973 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(856055), // Rule ID 62974 //
     /*  855978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  855981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  855986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  855995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856005 */     // MIs[0] op1
     /*  856005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  856025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  856035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856037 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856039 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856041 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856043 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856053 */     GIR_RootConstrainSelectedInstOperands,
     /*  856054 */     // GIR_Coverage, 62974,
     /*  856054 */     GIR_EraseRootFromParent_Done,
     /*  856055 */   // Label 13129: @856055
     /*  856055 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(856137), // Rule ID 62985 //
     /*  856060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  856068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  856077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  856080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856087 */     // MIs[0] op1
     /*  856087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  856117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856119 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856121 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856123 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856125 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856135 */     GIR_RootConstrainSelectedInstOperands,
     /*  856136 */     // GIR_Coverage, 62985,
     /*  856136 */     GIR_EraseRootFromParent_Done,
     /*  856137 */   // Label 13130: @856137
     /*  856137 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(856219), // Rule ID 62986 //
     /*  856142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  856150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  856159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  856162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856169 */     // MIs[0] op1
     /*  856169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  856199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856201 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856203 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856205 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856207 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856217 */     GIR_RootConstrainSelectedInstOperands,
     /*  856218 */     // GIR_Coverage, 62986,
     /*  856218 */     GIR_EraseRootFromParent_Done,
     /*  856219 */   // Label 13131: @856219
     /*  856219 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(856301), // Rule ID 62997 //
     /*  856224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  856232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  856241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856251 */     // MIs[0] op1
     /*  856251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  856259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  856281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856283 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856285 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856287 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856289 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856299 */     GIR_RootConstrainSelectedInstOperands,
     /*  856300 */     // GIR_Coverage, 62997,
     /*  856300 */     GIR_EraseRootFromParent_Done,
     /*  856301 */   // Label 13132: @856301
     /*  856301 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(856383), // Rule ID 62998 //
     /*  856306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  856314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  856323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856333 */     // MIs[0] op1
     /*  856333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  856341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  856363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856365 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856367 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856369 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856371 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856381 */     GIR_RootConstrainSelectedInstOperands,
     /*  856382 */     // GIR_Coverage, 62998,
     /*  856382 */     GIR_EraseRootFromParent_Done,
     /*  856383 */   // Label 13133: @856383
     /*  856383 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(856465), // Rule ID 63029 //
     /*  856388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  856396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856415 */     // MIs[0] op1
     /*  856415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  856435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  856445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856447 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856449 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856451 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856453 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856463 */     GIR_RootConstrainSelectedInstOperands,
     /*  856464 */     // GIR_Coverage, 63029,
     /*  856464 */     GIR_EraseRootFromParent_Done,
     /*  856465 */   // Label 13134: @856465
     /*  856465 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(856547), // Rule ID 63030 //
     /*  856470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  856478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856497 */     // MIs[0] op1
     /*  856497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  856517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  856527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856529 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856531 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856533 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856535 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856545 */     GIR_RootConstrainSelectedInstOperands,
     /*  856546 */     // GIR_Coverage, 63030,
     /*  856546 */     GIR_EraseRootFromParent_Done,
     /*  856547 */   // Label 13135: @856547
     /*  856547 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(856629), // Rule ID 63041 //
     /*  856552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  856560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  856572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856579 */     // MIs[0] op1
     /*  856579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  856609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856611 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856613 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856615 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856617 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856627 */     GIR_RootConstrainSelectedInstOperands,
     /*  856628 */     // GIR_Coverage, 63041,
     /*  856628 */     GIR_EraseRootFromParent_Done,
     /*  856629 */   // Label 13136: @856629
     /*  856629 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(856711), // Rule ID 63042 //
     /*  856634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  856642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  856654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856661 */     // MIs[0] op1
     /*  856661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856688 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  856691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856699 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856709 */     GIR_RootConstrainSelectedInstOperands,
     /*  856710 */     // GIR_Coverage, 63042,
     /*  856710 */     GIR_EraseRootFromParent_Done,
     /*  856711 */   // Label 13137: @856711
     /*  856711 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(856793), // Rule ID 63053 //
     /*  856716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  856724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856743 */     // MIs[0] op1
     /*  856743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  856751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856770 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  856773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856775 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856777 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856779 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856781 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856791 */     GIR_RootConstrainSelectedInstOperands,
     /*  856792 */     // GIR_Coverage, 63053,
     /*  856792 */     GIR_EraseRootFromParent_Done,
     /*  856793 */   // Label 13138: @856793
     /*  856793 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(856875), // Rule ID 63054 //
     /*  856798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  856806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  856815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856825 */     // MIs[0] op1
     /*  856825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  856833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  856852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  856855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856857 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856859 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856861 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856863 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856873 */     GIR_RootConstrainSelectedInstOperands,
     /*  856874 */     // GIR_Coverage, 63054,
     /*  856874 */     GIR_EraseRootFromParent_Done,
     /*  856875 */   // Label 13139: @856875
     /*  856875 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(856957), // Rule ID 63085 //
     /*  856880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  856883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  856888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  856897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  856903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856907 */     // MIs[0] op1
     /*  856907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  856927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  856934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  856937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856939 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  856941 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  856943 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  856945 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  856947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856955 */     GIR_RootConstrainSelectedInstOperands,
     /*  856956 */     // GIR_Coverage, 63085,
     /*  856956 */     GIR_EraseRootFromParent_Done,
     /*  856957 */   // Label 13140: @856957
     /*  856957 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(857039), // Rule ID 63086 //
     /*  856962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  856965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  856970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  856979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  856985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856989 */     // MIs[0] op1
     /*  856989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  856992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  856997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  857009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  857016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  857019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857021 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857023 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857025 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857027 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857037 */     GIR_RootConstrainSelectedInstOperands,
     /*  857038 */     // GIR_Coverage, 63086,
     /*  857038 */     GIR_EraseRootFromParent_Done,
     /*  857039 */   // Label 13141: @857039
     /*  857039 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(857121), // Rule ID 63097 //
     /*  857044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  857052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  857061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  857064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857071 */     // MIs[0] op1
     /*  857071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  857098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  857101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857103 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857105 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857107 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857109 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857119 */     GIR_RootConstrainSelectedInstOperands,
     /*  857120 */     // GIR_Coverage, 63097,
     /*  857120 */     GIR_EraseRootFromParent_Done,
     /*  857121 */   // Label 13142: @857121
     /*  857121 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(857203), // Rule ID 63098 //
     /*  857126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  857134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  857143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  857146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857153 */     // MIs[0] op1
     /*  857153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  857180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  857183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857185 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857187 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857189 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857191 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857201 */     GIR_RootConstrainSelectedInstOperands,
     /*  857202 */     // GIR_Coverage, 63098,
     /*  857202 */     GIR_EraseRootFromParent_Done,
     /*  857203 */   // Label 13143: @857203
     /*  857203 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(857285), // Rule ID 63109 //
     /*  857208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  857216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  857225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857235 */     // MIs[0] op1
     /*  857235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  857243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  857262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  857265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857267 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857269 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857271 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857273 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857283 */     GIR_RootConstrainSelectedInstOperands,
     /*  857284 */     // GIR_Coverage, 63109,
     /*  857284 */     GIR_EraseRootFromParent_Done,
     /*  857285 */   // Label 13144: @857285
     /*  857285 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(857367), // Rule ID 63110 //
     /*  857290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  857298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  857307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857317 */     // MIs[0] op1
     /*  857317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  857325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  857344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  857347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857349 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857351 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857353 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857355 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857365 */     GIR_RootConstrainSelectedInstOperands,
     /*  857366 */     // GIR_Coverage, 63110,
     /*  857366 */     GIR_EraseRootFromParent_Done,
     /*  857367 */   // Label 13145: @857367
     /*  857367 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(857449), // Rule ID 63141 //
     /*  857372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  857380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857399 */     // MIs[0] op1
     /*  857399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  857419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  857426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  857429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857431 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857433 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857435 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857437 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857447 */     GIR_RootConstrainSelectedInstOperands,
     /*  857448 */     // GIR_Coverage, 63141,
     /*  857448 */     GIR_EraseRootFromParent_Done,
     /*  857449 */   // Label 13146: @857449
     /*  857449 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(857531), // Rule ID 63142 //
     /*  857454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  857462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857481 */     // MIs[0] op1
     /*  857481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  857501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  857508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  857511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857519 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857529 */     GIR_RootConstrainSelectedInstOperands,
     /*  857530 */     // GIR_Coverage, 63142,
     /*  857530 */     GIR_EraseRootFromParent_Done,
     /*  857531 */   // Label 13147: @857531
     /*  857531 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(857613), // Rule ID 63153 //
     /*  857536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  857544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  857556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857563 */     // MIs[0] op1
     /*  857563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  857590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  857593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857595 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857597 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857599 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857601 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857611 */     GIR_RootConstrainSelectedInstOperands,
     /*  857612 */     // GIR_Coverage, 63153,
     /*  857612 */     GIR_EraseRootFromParent_Done,
     /*  857613 */   // Label 13148: @857613
     /*  857613 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(857695), // Rule ID 63154 //
     /*  857618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  857626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  857638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857645 */     // MIs[0] op1
     /*  857645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  857672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  857675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857683 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857693 */     GIR_RootConstrainSelectedInstOperands,
     /*  857694 */     // GIR_Coverage, 63154,
     /*  857694 */     GIR_EraseRootFromParent_Done,
     /*  857695 */   // Label 13149: @857695
     /*  857695 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(857777), // Rule ID 63165 //
     /*  857700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  857708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857727 */     // MIs[0] op1
     /*  857727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  857735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  857754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  857757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857759 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857761 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857763 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857765 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857775 */     GIR_RootConstrainSelectedInstOperands,
     /*  857776 */     // GIR_Coverage, 63165,
     /*  857776 */     GIR_EraseRootFromParent_Done,
     /*  857777 */   // Label 13150: @857777
     /*  857777 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(857859), // Rule ID 63166 //
     /*  857782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  857790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  857799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857809 */     // MIs[0] op1
     /*  857809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  857817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  857836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  857839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857847 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857857 */     GIR_RootConstrainSelectedInstOperands,
     /*  857858 */     // GIR_Coverage, 63166,
     /*  857858 */     GIR_EraseRootFromParent_Done,
     /*  857859 */   // Label 13151: @857859
     /*  857859 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(857941), // Rule ID 63197 //
     /*  857864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  857867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  857872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  857881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  857887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857891 */     // MIs[0] op1
     /*  857891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  857911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  857918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  857921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857923 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  857925 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  857927 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  857929 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  857931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857939 */     GIR_RootConstrainSelectedInstOperands,
     /*  857940 */     // GIR_Coverage, 63197,
     /*  857940 */     GIR_EraseRootFromParent_Done,
     /*  857941 */   // Label 13152: @857941
     /*  857941 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(858023), // Rule ID 63198 //
     /*  857946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  857949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  857954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  857963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  857969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857973 */     // MIs[0] op1
     /*  857973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  857976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  857981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  857993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  858003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858005 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858007 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858009 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858011 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858021 */     GIR_RootConstrainSelectedInstOperands,
     /*  858022 */     // GIR_Coverage, 63198,
     /*  858022 */     GIR_EraseRootFromParent_Done,
     /*  858023 */   // Label 13153: @858023
     /*  858023 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(858105), // Rule ID 63209 //
     /*  858028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  858036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  858039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  858042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  858045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  858048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858055 */     // MIs[0] op1
     /*  858055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  858082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  858085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858087 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858089 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858091 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858093 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858103 */     GIR_RootConstrainSelectedInstOperands,
     /*  858104 */     // GIR_Coverage, 63209,
     /*  858104 */     GIR_EraseRootFromParent_Done,
     /*  858105 */   // Label 13154: @858105
     /*  858105 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(858187), // Rule ID 63210 //
     /*  858110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  858118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  858121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  858124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  858127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  858130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858137 */     // MIs[0] op1
     /*  858137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  858167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858169 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858171 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858173 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858175 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858185 */     GIR_RootConstrainSelectedInstOperands,
     /*  858186 */     // GIR_Coverage, 63210,
     /*  858186 */     GIR_EraseRootFromParent_Done,
     /*  858187 */   // Label 13155: @858187
     /*  858187 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(858269), // Rule ID 63221 //
     /*  858192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  858200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  858203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  858206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  858209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858219 */     // MIs[0] op1
     /*  858219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  858227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  858246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  858249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858257 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858267 */     GIR_RootConstrainSelectedInstOperands,
     /*  858268 */     // GIR_Coverage, 63221,
     /*  858268 */     GIR_EraseRootFromParent_Done,
     /*  858269 */   // Label 13156: @858269
     /*  858269 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(858351), // Rule ID 63222 //
     /*  858274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  858282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  858285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  858288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  858291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858301 */     // MIs[0] op1
     /*  858301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  858309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  858331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858333 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858335 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858337 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858339 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858349 */     GIR_RootConstrainSelectedInstOperands,
     /*  858350 */     // GIR_Coverage, 63222,
     /*  858350 */     GIR_EraseRootFromParent_Done,
     /*  858351 */   // Label 13157: @858351
     /*  858351 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(858433), // Rule ID 63253 //
     /*  858356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  858364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858383 */     // MIs[0] op1
     /*  858383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  858403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  858410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  858413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858415 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858417 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858419 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858421 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858431 */     GIR_RootConstrainSelectedInstOperands,
     /*  858432 */     // GIR_Coverage, 63253,
     /*  858432 */     GIR_EraseRootFromParent_Done,
     /*  858433 */   // Label 13158: @858433
     /*  858433 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(858515), // Rule ID 63254 //
     /*  858438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  858446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858465 */     // MIs[0] op1
     /*  858465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  858485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  858495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858497 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858499 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858501 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858503 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858513 */     GIR_RootConstrainSelectedInstOperands,
     /*  858514 */     // GIR_Coverage, 63254,
     /*  858514 */     GIR_EraseRootFromParent_Done,
     /*  858515 */   // Label 13159: @858515
     /*  858515 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(858597), // Rule ID 63265 //
     /*  858520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  858528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  858540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858547 */     // MIs[0] op1
     /*  858547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  858574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  858577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858579 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858581 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858583 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858585 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858595 */     GIR_RootConstrainSelectedInstOperands,
     /*  858596 */     // GIR_Coverage, 63265,
     /*  858596 */     GIR_EraseRootFromParent_Done,
     /*  858597 */   // Label 13160: @858597
     /*  858597 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(858679), // Rule ID 63266 //
     /*  858602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  858610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  858622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858629 */     // MIs[0] op1
     /*  858629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858656 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  858659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858667 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858677 */     GIR_RootConstrainSelectedInstOperands,
     /*  858678 */     // GIR_Coverage, 63266,
     /*  858678 */     GIR_EraseRootFromParent_Done,
     /*  858679 */   // Label 13161: @858679
     /*  858679 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(858761), // Rule ID 63277 //
     /*  858684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  858692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858711 */     // MIs[0] op1
     /*  858711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  858719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  858738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  858741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858743 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858745 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858747 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858749 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858759 */     GIR_RootConstrainSelectedInstOperands,
     /*  858760 */     // GIR_Coverage, 63277,
     /*  858760 */     GIR_EraseRootFromParent_Done,
     /*  858761 */   // Label 13162: @858761
     /*  858761 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(858843), // Rule ID 63278 //
     /*  858766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  858774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  858783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858793 */     // MIs[0] op1
     /*  858793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  858801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10754:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  858820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  858823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858825 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858827 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858829 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858831 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858841 */     GIR_RootConstrainSelectedInstOperands,
     /*  858842 */     // GIR_Coverage, 63278,
     /*  858842 */     GIR_EraseRootFromParent_Done,
     /*  858843 */   // Label 13163: @858843
     /*  858843 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(858925), // Rule ID 63283 //
     /*  858848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  858851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  858856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  858865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  858871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858875 */     // MIs[0] op1
     /*  858875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  858895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  858902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  858905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858907 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858909 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858911 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858913 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858923 */     GIR_RootConstrainSelectedInstOperands,
     /*  858924 */     // GIR_Coverage, 63283,
     /*  858924 */     GIR_EraseRootFromParent_Done,
     /*  858925 */   // Label 13164: @858925
     /*  858925 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(859007), // Rule ID 63284 //
     /*  858930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  858933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  858938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  858947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  858953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858957 */     // MIs[0] op1
     /*  858957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  858960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  858965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  858977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  858984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  858987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  858991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  858993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  858995 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  858997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859005 */     GIR_RootConstrainSelectedInstOperands,
     /*  859006 */     // GIR_Coverage, 63284,
     /*  859006 */     GIR_EraseRootFromParent_Done,
     /*  859007 */   // Label 13165: @859007
     /*  859007 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(859089), // Rule ID 63295 //
     /*  859012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  859023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  859026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  859029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  859032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859039 */     // MIs[0] op1
     /*  859039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859066 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  859069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859077 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859087 */     GIR_RootConstrainSelectedInstOperands,
     /*  859088 */     // GIR_Coverage, 63295,
     /*  859088 */     GIR_EraseRootFromParent_Done,
     /*  859089 */   // Label 13166: @859089
     /*  859089 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(859171), // Rule ID 63296 //
     /*  859094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  859105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  859108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  859111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  859114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859121 */     // MIs[0] op1
     /*  859121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  859151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859153 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859155 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859157 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859159 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859169 */     GIR_RootConstrainSelectedInstOperands,
     /*  859170 */     // GIR_Coverage, 63296,
     /*  859170 */     GIR_EraseRootFromParent_Done,
     /*  859171 */   // Label 13167: @859171
     /*  859171 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(859253), // Rule ID 63301 //
     /*  859176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  859193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859203 */     // MIs[0] op1
     /*  859203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  859233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859241 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859251 */     GIR_RootConstrainSelectedInstOperands,
     /*  859252 */     // GIR_Coverage, 63301,
     /*  859252 */     GIR_EraseRootFromParent_Done,
     /*  859253 */   // Label 13168: @859253
     /*  859253 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(859335), // Rule ID 63302 //
     /*  859258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  859275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859285 */     // MIs[0] op1
     /*  859285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859312 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  859315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859317 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859319 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859321 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859323 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859333 */     GIR_RootConstrainSelectedInstOperands,
     /*  859334 */     // GIR_Coverage, 63302,
     /*  859334 */     GIR_EraseRootFromParent_Done,
     /*  859335 */   // Label 13169: @859335
     /*  859335 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(859417), // Rule ID 63313 //
     /*  859340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  859357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  859360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859367 */     // MIs[0] op1
     /*  859367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  859397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859405 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859415 */     GIR_RootConstrainSelectedInstOperands,
     /*  859416 */     // GIR_Coverage, 63313,
     /*  859416 */     GIR_EraseRootFromParent_Done,
     /*  859417 */   // Label 13170: @859417
     /*  859417 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(859499), // Rule ID 63314 //
     /*  859422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  859439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  859442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859449 */     // MIs[0] op1
     /*  859449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  859479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859481 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859483 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859485 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859487 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859497 */     GIR_RootConstrainSelectedInstOperands,
     /*  859498 */     // GIR_Coverage, 63314,
     /*  859498 */     GIR_EraseRootFromParent_Done,
     /*  859499 */   // Label 13171: @859499
     /*  859499 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(859581), // Rule ID 63319 //
     /*  859504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  859515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  859518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  859521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859531 */     // MIs[0] op1
     /*  859531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  859561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859563 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859565 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859567 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859569 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859579 */     GIR_RootConstrainSelectedInstOperands,
     /*  859580 */     // GIR_Coverage, 63319,
     /*  859580 */     GIR_EraseRootFromParent_Done,
     /*  859581 */   // Label 13172: @859581
     /*  859581 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(859663), // Rule ID 63320 //
     /*  859586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  859597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  859600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  859603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859613 */     // MIs[0] op1
     /*  859613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  859643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859645 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859647 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859649 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859651 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859661 */     GIR_RootConstrainSelectedInstOperands,
     /*  859662 */     // GIR_Coverage, 63320,
     /*  859662 */     GIR_EraseRootFromParent_Done,
     /*  859663 */   // Label 13173: @859663
     /*  859663 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(859745), // Rule ID 63331 //
     /*  859668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  859679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  859682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  859685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  859688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859695 */     // MIs[0] op1
     /*  859695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  859725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859733 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859743 */     GIR_RootConstrainSelectedInstOperands,
     /*  859744 */     // GIR_Coverage, 63331,
     /*  859744 */     GIR_EraseRootFromParent_Done,
     /*  859745 */   // Label 13174: @859745
     /*  859745 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(859827), // Rule ID 63332 //
     /*  859750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  859758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  859761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  859764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  859767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  859770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859777 */     // MIs[0] op1
     /*  859777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  859807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859809 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859811 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859813 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859815 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859825 */     GIR_RootConstrainSelectedInstOperands,
     /*  859826 */     // GIR_Coverage, 63332,
     /*  859826 */     GIR_EraseRootFromParent_Done,
     /*  859827 */   // Label 13175: @859827
     /*  859827 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(859909), // Rule ID 63337 //
     /*  859832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  859849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  859855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859859 */     // MIs[0] op1
     /*  859859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  859886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  859889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859891 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859893 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859895 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859897 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859907 */     GIR_RootConstrainSelectedInstOperands,
     /*  859908 */     // GIR_Coverage, 63337,
     /*  859908 */     GIR_EraseRootFromParent_Done,
     /*  859909 */   // Label 13176: @859909
     /*  859909 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(859991), // Rule ID 63338 //
     /*  859914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  859917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  859922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  859931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  859937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859941 */     // MIs[0] op1
     /*  859941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  859944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  859949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  859968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  859971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859973 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  859975 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  859977 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  859979 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  859981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859989 */     GIR_RootConstrainSelectedInstOperands,
     /*  859990 */     // GIR_Coverage, 63338,
     /*  859990 */     GIR_EraseRootFromParent_Done,
     /*  859991 */   // Label 13177: @859991
     /*  859991 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(860073), // Rule ID 63349 //
     /*  859996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  859999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  860007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  860010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  860013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  860016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860023 */     // MIs[0] op1
     /*  860023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  860050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  860053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860055 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860057 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860059 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860061 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860071 */     GIR_RootConstrainSelectedInstOperands,
     /*  860072 */     // GIR_Coverage, 63349,
     /*  860072 */     GIR_EraseRootFromParent_Done,
     /*  860073 */   // Label 13178: @860073
     /*  860073 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(860155), // Rule ID 63350 //
     /*  860078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  860089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  860092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  860095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  860098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860105 */     // MIs[0] op1
     /*  860105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  860132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  860135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860137 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860139 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860141 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860143 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860153 */     GIR_RootConstrainSelectedInstOperands,
     /*  860154 */     // GIR_Coverage, 63350,
     /*  860154 */     GIR_EraseRootFromParent_Done,
     /*  860155 */   // Label 13179: @860155
     /*  860155 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(860237), // Rule ID 63355 //
     /*  860160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  860171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  860174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  860177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860187 */     // MIs[0] op1
     /*  860187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  860214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  860217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860225 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860235 */     GIR_RootConstrainSelectedInstOperands,
     /*  860236 */     // GIR_Coverage, 63355,
     /*  860236 */     GIR_EraseRootFromParent_Done,
     /*  860237 */   // Label 13180: @860237
     /*  860237 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(860319), // Rule ID 63356 //
     /*  860242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  860253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  860256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  860259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860269 */     // MIs[0] op1
     /*  860269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  860296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  860299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860301 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860303 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860305 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860307 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860317 */     GIR_RootConstrainSelectedInstOperands,
     /*  860318 */     // GIR_Coverage, 63356,
     /*  860318 */     GIR_EraseRootFromParent_Done,
     /*  860319 */   // Label 13181: @860319
     /*  860319 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(860401), // Rule ID 63367 //
     /*  860324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  860335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  860338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  860341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  860344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860351 */     // MIs[0] op1
     /*  860351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860378 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  860378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  860381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860389 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860399 */     GIR_RootConstrainSelectedInstOperands,
     /*  860400 */     // GIR_Coverage, 63367,
     /*  860400 */     GIR_EraseRootFromParent_Done,
     /*  860401 */   // Label 13182: @860401
     /*  860401 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(860483), // Rule ID 63368 //
     /*  860406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  860417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  860420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  860423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  860426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860433 */     // MIs[0] op1
     /*  860433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  860460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  860463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860465 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860467 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860469 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860471 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860481 */     GIR_RootConstrainSelectedInstOperands,
     /*  860482 */     // GIR_Coverage, 63368,
     /*  860482 */     GIR_EraseRootFromParent_Done,
     /*  860483 */   // Label 13183: @860483
     /*  860483 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(860565), // Rule ID 63373 //
     /*  860488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  860499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  860502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  860505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860515 */     // MIs[0] op1
     /*  860515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  860542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  860545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860547 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860549 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860551 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860553 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860563 */     GIR_RootConstrainSelectedInstOperands,
     /*  860564 */     // GIR_Coverage, 63373,
     /*  860564 */     GIR_EraseRootFromParent_Done,
     /*  860565 */   // Label 13184: @860565
     /*  860565 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(860647), // Rule ID 63374 //
     /*  860570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  860581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  860584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  860587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860597 */     // MIs[0] op1
     /*  860597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  860624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  860627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860629 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860631 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860633 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860635 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860645 */     GIR_RootConstrainSelectedInstOperands,
     /*  860646 */     // GIR_Coverage, 63374,
     /*  860646 */     GIR_EraseRootFromParent_Done,
     /*  860647 */   // Label 13185: @860647
     /*  860647 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(860729), // Rule ID 63385 //
     /*  860652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  860663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  860666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  860669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  860672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860679 */     // MIs[0] op1
     /*  860679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  860706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  860709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860711 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860713 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860715 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860717 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860727 */     GIR_RootConstrainSelectedInstOperands,
     /*  860728 */     // GIR_Coverage, 63385,
     /*  860728 */     GIR_EraseRootFromParent_Done,
     /*  860729 */   // Label 13186: @860729
     /*  860729 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(860811), // Rule ID 63386 //
     /*  860734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  860745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  860748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  860751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  860754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860761 */     // MIs[0] op1
     /*  860761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860764 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  860788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  860791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860793 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860795 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860797 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860799 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860809 */     GIR_RootConstrainSelectedInstOperands,
     /*  860810 */     // GIR_Coverage, 63386,
     /*  860810 */     GIR_EraseRootFromParent_Done,
     /*  860811 */   // Label 13187: @860811
     /*  860811 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(860893), // Rule ID 63391 //
     /*  860816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  860839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860843 */     // MIs[0] op1
     /*  860843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  860870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  860873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860875 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860877 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860879 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860881 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860891 */     GIR_RootConstrainSelectedInstOperands,
     /*  860892 */     // GIR_Coverage, 63391,
     /*  860892 */     GIR_EraseRootFromParent_Done,
     /*  860893 */   // Label 13188: @860893
     /*  860893 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(860975), // Rule ID 63392 //
     /*  860898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  860901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  860906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  860921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860925 */     // MIs[0] op1
     /*  860925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  860928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  860933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  860952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  860955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860957 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  860959 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  860961 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  860963 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  860965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860973 */     GIR_RootConstrainSelectedInstOperands,
     /*  860974 */     // GIR_Coverage, 63392,
     /*  860974 */     GIR_EraseRootFromParent_Done,
     /*  860975 */   // Label 13189: @860975
     /*  860975 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(861057), // Rule ID 63403 //
     /*  860980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  860983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  860988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  861000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861007 */     // MIs[0] op1
     /*  861007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  861037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861039 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861041 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861043 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861045 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861055 */     GIR_RootConstrainSelectedInstOperands,
     /*  861056 */     // GIR_Coverage, 63403,
     /*  861056 */     GIR_EraseRootFromParent_Done,
     /*  861057 */   // Label 13190: @861057
     /*  861057 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(861139), // Rule ID 63404 //
     /*  861062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  861070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  861079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  861082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861089 */     // MIs[0] op1
     /*  861089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  861119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861121 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861123 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861125 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861127 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861137 */     GIR_RootConstrainSelectedInstOperands,
     /*  861138 */     // GIR_Coverage, 63404,
     /*  861138 */     GIR_EraseRootFromParent_Done,
     /*  861139 */   // Label 13191: @861139
     /*  861139 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(861221), // Rule ID 63409 //
     /*  861144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  861152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  861161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  861164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861171 */     // MIs[0] op1
     /*  861171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  861179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  861191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  861201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861203 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861205 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861207 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861209 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861219 */     GIR_RootConstrainSelectedInstOperands,
     /*  861220 */     // GIR_Coverage, 63409,
     /*  861220 */     GIR_EraseRootFromParent_Done,
     /*  861221 */   // Label 13192: @861221
     /*  861221 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(861303), // Rule ID 63410 //
     /*  861226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  861234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  861243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  861246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861253 */     // MIs[0] op1
     /*  861253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  861261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  861273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  861283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861291 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861301 */     GIR_RootConstrainSelectedInstOperands,
     /*  861302 */     // GIR_Coverage, 63410,
     /*  861302 */     GIR_EraseRootFromParent_Done,
     /*  861303 */   // Label 13193: @861303
     /*  861303 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(861385), // Rule ID 63415 //
     /*  861308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  861316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861335 */     // MIs[0] op1
     /*  861335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  861365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861373 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861383 */     GIR_RootConstrainSelectedInstOperands,
     /*  861384 */     // GIR_Coverage, 63415,
     /*  861384 */     GIR_EraseRootFromParent_Done,
     /*  861385 */   // Label 13194: @861385
     /*  861385 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(861467), // Rule ID 63416 //
     /*  861390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  861398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861417 */     // MIs[0] op1
     /*  861417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  861447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861449 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861451 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861453 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861455 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861465 */     GIR_RootConstrainSelectedInstOperands,
     /*  861466 */     // GIR_Coverage, 63416,
     /*  861466 */     GIR_EraseRootFromParent_Done,
     /*  861467 */   // Label 13195: @861467
     /*  861467 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(861549), // Rule ID 63427 //
     /*  861472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  861480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  861492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861499 */     // MIs[0] op1
     /*  861499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  861529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861537 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861547 */     GIR_RootConstrainSelectedInstOperands,
     /*  861548 */     // GIR_Coverage, 63427,
     /*  861548 */     GIR_EraseRootFromParent_Done,
     /*  861549 */   // Label 13196: @861549
     /*  861549 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(861631), // Rule ID 63428 //
     /*  861554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  861562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  861574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861581 */     // MIs[0] op1
     /*  861581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  861611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861613 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861615 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861617 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861619 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861629 */     GIR_RootConstrainSelectedInstOperands,
     /*  861630 */     // GIR_Coverage, 63428,
     /*  861630 */     GIR_EraseRootFromParent_Done,
     /*  861631 */   // Label 13197: @861631
     /*  861631 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(861713), // Rule ID 63433 //
     /*  861636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  861644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  861656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861663 */     // MIs[0] op1
     /*  861663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  861671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  861683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  861693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861701 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861711 */     GIR_RootConstrainSelectedInstOperands,
     /*  861712 */     // GIR_Coverage, 63433,
     /*  861712 */     GIR_EraseRootFromParent_Done,
     /*  861713 */   // Label 13198: @861713
     /*  861713 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(861795), // Rule ID 63434 //
     /*  861718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  861726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  861738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861745 */     // MIs[0] op1
     /*  861745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  861753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  861765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861772 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  861775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861777 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861779 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861781 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861783 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861793 */     GIR_RootConstrainSelectedInstOperands,
     /*  861794 */     // GIR_Coverage, 63434,
     /*  861794 */     GIR_EraseRootFromParent_Done,
     /*  861795 */   // Label 13199: @861795
     /*  861795 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(861877), // Rule ID 63439 //
     /*  861800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  861808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  861811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  861814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861827 */     // MIs[0] op1
     /*  861827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  861854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  861857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861859 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861861 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861863 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861865 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861875 */     GIR_RootConstrainSelectedInstOperands,
     /*  861876 */     // GIR_Coverage, 63439,
     /*  861876 */     GIR_EraseRootFromParent_Done,
     /*  861877 */   // Label 13200: @861877
     /*  861877 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(861959), // Rule ID 63440 //
     /*  861882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  861885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  861890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  861893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  861896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  861905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861909 */     // MIs[0] op1
     /*  861909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  861936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  861939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861941 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  861943 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  861945 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  861947 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  861949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861957 */     GIR_RootConstrainSelectedInstOperands,
     /*  861958 */     // GIR_Coverage, 63440,
     /*  861958 */     GIR_EraseRootFromParent_Done,
     /*  861959 */   // Label 13201: @861959
     /*  861959 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(862041), // Rule ID 63451 //
     /*  861964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  861967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  861972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  861975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  861978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  861984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  861987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861991 */     // MIs[0] op1
     /*  861991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  861994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  861999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  862021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862023 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862025 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862027 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862029 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862039 */     GIR_RootConstrainSelectedInstOperands,
     /*  862040 */     // GIR_Coverage, 63451,
     /*  862040 */     GIR_EraseRootFromParent_Done,
     /*  862041 */   // Label 13202: @862041
     /*  862041 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(862123), // Rule ID 63452 //
     /*  862046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  862054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  862063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  862066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862073 */     // MIs[0] op1
     /*  862073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  862103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862105 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862107 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862109 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862111 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862121 */     GIR_RootConstrainSelectedInstOperands,
     /*  862122 */     // GIR_Coverage, 63452,
     /*  862122 */     GIR_EraseRootFromParent_Done,
     /*  862123 */   // Label 13203: @862123
     /*  862123 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(862205), // Rule ID 63457 //
     /*  862128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  862136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  862145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  862148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862155 */     // MIs[0] op1
     /*  862155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  862163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  862175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  862185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862187 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862189 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862191 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862193 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862203 */     GIR_RootConstrainSelectedInstOperands,
     /*  862204 */     // GIR_Coverage, 63457,
     /*  862204 */     GIR_EraseRootFromParent_Done,
     /*  862205 */   // Label 13204: @862205
     /*  862205 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(862287), // Rule ID 63458 //
     /*  862210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  862218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  862227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  862230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862237 */     // MIs[0] op1
     /*  862237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  862245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  862257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  862267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862269 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862271 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862273 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862275 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862285 */     GIR_RootConstrainSelectedInstOperands,
     /*  862286 */     // GIR_Coverage, 63458,
     /*  862286 */     GIR_EraseRootFromParent_Done,
     /*  862287 */   // Label 13205: @862287
     /*  862287 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(862369), // Rule ID 63463 //
     /*  862292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  862300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862319 */     // MIs[0] op1
     /*  862319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  862349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862351 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862353 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862355 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862357 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862367 */     GIR_RootConstrainSelectedInstOperands,
     /*  862368 */     // GIR_Coverage, 63463,
     /*  862368 */     GIR_EraseRootFromParent_Done,
     /*  862369 */   // Label 13206: @862369
     /*  862369 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(862451), // Rule ID 63464 //
     /*  862374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  862382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862401 */     // MIs[0] op1
     /*  862401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  862431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862433 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862435 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862437 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862439 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862449 */     GIR_RootConstrainSelectedInstOperands,
     /*  862450 */     // GIR_Coverage, 63464,
     /*  862450 */     GIR_EraseRootFromParent_Done,
     /*  862451 */   // Label 13207: @862451
     /*  862451 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(862533), // Rule ID 63475 //
     /*  862456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  862464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  862476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862483 */     // MIs[0] op1
     /*  862483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  862513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862521 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862531 */     GIR_RootConstrainSelectedInstOperands,
     /*  862532 */     // GIR_Coverage, 63475,
     /*  862532 */     GIR_EraseRootFromParent_Done,
     /*  862533 */   // Label 13208: @862533
     /*  862533 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(862615), // Rule ID 63476 //
     /*  862538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  862546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  862558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862565 */     // MIs[0] op1
     /*  862565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  862595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862597 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862599 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862601 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862603 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862613 */     GIR_RootConstrainSelectedInstOperands,
     /*  862614 */     // GIR_Coverage, 63476,
     /*  862614 */     GIR_EraseRootFromParent_Done,
     /*  862615 */   // Label 13209: @862615
     /*  862615 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(862697), // Rule ID 63481 //
     /*  862620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  862628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  862640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862647 */     // MIs[0] op1
     /*  862647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  862655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  862667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  862677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862679 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862681 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862683 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862685 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862695 */     GIR_RootConstrainSelectedInstOperands,
     /*  862696 */     // GIR_Coverage, 63481,
     /*  862696 */     GIR_EraseRootFromParent_Done,
     /*  862697 */   // Label 13210: @862697
     /*  862697 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(862779), // Rule ID 63482 //
     /*  862702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  862710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  862722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862729 */     // MIs[0] op1
     /*  862729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  862737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  862749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  862759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862767 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862777 */     GIR_RootConstrainSelectedInstOperands,
     /*  862778 */     // GIR_Coverage, 63482,
     /*  862778 */     GIR_EraseRootFromParent_Done,
     /*  862779 */   // Label 13211: @862779
     /*  862779 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(862861), // Rule ID 63487 //
     /*  862784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  862792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862811 */     // MIs[0] op1
     /*  862811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  862838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  862841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862849 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862859 */     GIR_RootConstrainSelectedInstOperands,
     /*  862860 */     // GIR_Coverage, 63487,
     /*  862860 */     GIR_EraseRootFromParent_Done,
     /*  862861 */   // Label 13212: @862861
     /*  862861 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(862943), // Rule ID 63488 //
     /*  862866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  862869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  862874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  862889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862893 */     // MIs[0] op1
     /*  862893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  862920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  862923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862925 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  862927 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  862929 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  862931 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  862933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862941 */     GIR_RootConstrainSelectedInstOperands,
     /*  862942 */     // GIR_Coverage, 63488,
     /*  862942 */     GIR_EraseRootFromParent_Done,
     /*  862943 */   // Label 13213: @862943
     /*  862943 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(863025), // Rule ID 63499 //
     /*  862948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  862951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  862956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  862968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  862971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862975 */     // MIs[0] op1
     /*  862975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  862978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  862983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  863002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  863005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863007 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863009 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863011 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863013 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863023 */     GIR_RootConstrainSelectedInstOperands,
     /*  863024 */     // GIR_Coverage, 63499,
     /*  863024 */     GIR_EraseRootFromParent_Done,
     /*  863025 */   // Label 13214: @863025
     /*  863025 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(863107), // Rule ID 63500 //
     /*  863030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  863038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  863047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  863050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863057 */     // MIs[0] op1
     /*  863057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  863084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  863087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863089 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863091 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863093 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863095 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863105 */     GIR_RootConstrainSelectedInstOperands,
     /*  863106 */     // GIR_Coverage, 63500,
     /*  863106 */     GIR_EraseRootFromParent_Done,
     /*  863107 */   // Label 13215: @863107
     /*  863107 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(863189), // Rule ID 63505 //
     /*  863112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  863120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  863129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  863132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863139 */     // MIs[0] op1
     /*  863139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  863147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  863159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  863166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  863169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863171 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863173 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863175 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863177 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863187 */     GIR_RootConstrainSelectedInstOperands,
     /*  863188 */     // GIR_Coverage, 63505,
     /*  863188 */     GIR_EraseRootFromParent_Done,
     /*  863189 */   // Label 13216: @863189
     /*  863189 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(863271), // Rule ID 63506 //
     /*  863194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  863202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  863211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  863214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863221 */     // MIs[0] op1
     /*  863221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  863229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  863241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  863248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  863251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863253 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863255 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863257 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863259 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863269 */     GIR_RootConstrainSelectedInstOperands,
     /*  863270 */     // GIR_Coverage, 63506,
     /*  863270 */     GIR_EraseRootFromParent_Done,
     /*  863271 */   // Label 13217: @863271
     /*  863271 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(863353), // Rule ID 63511 //
     /*  863276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  863284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863303 */     // MIs[0] op1
     /*  863303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  863330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  863333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863335 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863337 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863339 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863341 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863351 */     GIR_RootConstrainSelectedInstOperands,
     /*  863352 */     // GIR_Coverage, 63511,
     /*  863352 */     GIR_EraseRootFromParent_Done,
     /*  863353 */   // Label 13218: @863353
     /*  863353 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(863435), // Rule ID 63512 //
     /*  863358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  863366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863385 */     // MIs[0] op1
     /*  863385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  863412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  863415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863417 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863419 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863421 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863423 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863433 */     GIR_RootConstrainSelectedInstOperands,
     /*  863434 */     // GIR_Coverage, 63512,
     /*  863434 */     GIR_EraseRootFromParent_Done,
     /*  863435 */   // Label 13219: @863435
     /*  863435 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(863517), // Rule ID 63523 //
     /*  863440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  863448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  863460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863467 */     // MIs[0] op1
     /*  863467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  863494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  863497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863499 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863501 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863503 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863505 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863515 */     GIR_RootConstrainSelectedInstOperands,
     /*  863516 */     // GIR_Coverage, 63523,
     /*  863516 */     GIR_EraseRootFromParent_Done,
     /*  863517 */   // Label 13220: @863517
     /*  863517 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(863599), // Rule ID 63524 //
     /*  863522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  863530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  863542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863549 */     // MIs[0] op1
     /*  863549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  863576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  863579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863587 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863597 */     GIR_RootConstrainSelectedInstOperands,
     /*  863598 */     // GIR_Coverage, 63524,
     /*  863598 */     GIR_EraseRootFromParent_Done,
     /*  863599 */   // Label 13221: @863599
     /*  863599 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(863681), // Rule ID 63529 //
     /*  863604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  863612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863631 */     // MIs[0] op1
     /*  863631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  863639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  863651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  863658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  863661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863663 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863665 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863667 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863669 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863679 */     GIR_RootConstrainSelectedInstOperands,
     /*  863680 */     // GIR_Coverage, 63529,
     /*  863680 */     GIR_EraseRootFromParent_Done,
     /*  863681 */   // Label 13222: @863681
     /*  863681 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(863763), // Rule ID 63530 //
     /*  863686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  863694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  863703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863713 */     // MIs[0] op1
     /*  863713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  863721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  863733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  863740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  863743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863745 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863747 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863749 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863751 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863761 */     GIR_RootConstrainSelectedInstOperands,
     /*  863762 */     // GIR_Coverage, 63530,
     /*  863762 */     GIR_EraseRootFromParent_Done,
     /*  863763 */   // Label 13223: @863763
     /*  863763 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(863845), // Rule ID 63535 //
     /*  863768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  863776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  863785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863795 */     // MIs[0] op1
     /*  863795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  863822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  863825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863827 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863829 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863831 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863833 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863843 */     GIR_RootConstrainSelectedInstOperands,
     /*  863844 */     // GIR_Coverage, 63535,
     /*  863844 */     GIR_EraseRootFromParent_Done,
     /*  863845 */   // Label 13224: @863845
     /*  863845 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(863927), // Rule ID 63536 //
     /*  863850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  863853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  863858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  863867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  863873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863877 */     // MIs[0] op1
     /*  863877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  863904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  863907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863909 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863911 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863913 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863915 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863925 */     GIR_RootConstrainSelectedInstOperands,
     /*  863926 */     // GIR_Coverage, 63536,
     /*  863926 */     GIR_EraseRootFromParent_Done,
     /*  863927 */   // Label 13225: @863927
     /*  863927 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(864009), // Rule ID 63547 //
     /*  863932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  863935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  863940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  863949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  863952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  863955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863959 */     // MIs[0] op1
     /*  863959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  863962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  863967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  863986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  863989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863991 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  863993 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  863995 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  863997 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  863999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864007 */     GIR_RootConstrainSelectedInstOperands,
     /*  864008 */     // GIR_Coverage, 63547,
     /*  864008 */     GIR_EraseRootFromParent_Done,
     /*  864009 */   // Label 13226: @864009
     /*  864009 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(864091), // Rule ID 63548 //
     /*  864014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  864022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  864025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  864028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  864031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  864034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864041 */     // MIs[0] op1
     /*  864041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  864071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864073 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864075 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864077 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864079 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864089 */     GIR_RootConstrainSelectedInstOperands,
     /*  864090 */     // GIR_Coverage, 63548,
     /*  864090 */     GIR_EraseRootFromParent_Done,
     /*  864091 */   // Label 13227: @864091
     /*  864091 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(864173), // Rule ID 63553 //
     /*  864096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  864104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  864107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  864110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  864113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864123 */     // MIs[0] op1
     /*  864123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  864131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  864143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  864153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864155 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864157 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864159 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864161 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864171 */     GIR_RootConstrainSelectedInstOperands,
     /*  864172 */     // GIR_Coverage, 63553,
     /*  864172 */     GIR_EraseRootFromParent_Done,
     /*  864173 */   // Label 13228: @864173
     /*  864173 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(864255), // Rule ID 63554 //
     /*  864178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  864186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  864189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  864192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  864195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864205 */     // MIs[0] op1
     /*  864205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  864213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  864225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  864235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864237 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864239 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864241 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864243 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864253 */     GIR_RootConstrainSelectedInstOperands,
     /*  864254 */     // GIR_Coverage, 63554,
     /*  864254 */     GIR_EraseRootFromParent_Done,
     /*  864255 */   // Label 13229: @864255
     /*  864255 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(864337), // Rule ID 63559 //
     /*  864260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  864268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864287 */     // MIs[0] op1
     /*  864287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  864317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864319 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864321 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864323 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864325 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864335 */     GIR_RootConstrainSelectedInstOperands,
     /*  864336 */     // GIR_Coverage, 63559,
     /*  864336 */     GIR_EraseRootFromParent_Done,
     /*  864337 */   // Label 13230: @864337
     /*  864337 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(864419), // Rule ID 63560 //
     /*  864342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  864350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864369 */     // MIs[0] op1
     /*  864369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  864399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864407 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864417 */     GIR_RootConstrainSelectedInstOperands,
     /*  864418 */     // GIR_Coverage, 63560,
     /*  864418 */     GIR_EraseRootFromParent_Done,
     /*  864419 */   // Label 13231: @864419
     /*  864419 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(864501), // Rule ID 63571 //
     /*  864424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  864432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  864444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864451 */     // MIs[0] op1
     /*  864451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  864481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864483 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864485 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864487 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864489 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864499 */     GIR_RootConstrainSelectedInstOperands,
     /*  864500 */     // GIR_Coverage, 63571,
     /*  864500 */     GIR_EraseRootFromParent_Done,
     /*  864501 */   // Label 13232: @864501
     /*  864501 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(864583), // Rule ID 63572 //
     /*  864506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  864514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  864526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864533 */     // MIs[0] op1
     /*  864533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  864563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864571 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864581 */     GIR_RootConstrainSelectedInstOperands,
     /*  864582 */     // GIR_Coverage, 63572,
     /*  864582 */     GIR_EraseRootFromParent_Done,
     /*  864583 */   // Label 13233: @864583
     /*  864583 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(864665), // Rule ID 63577 //
     /*  864588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  864596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864615 */     // MIs[0] op1
     /*  864615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  864623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  864635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  864645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864647 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864649 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864651 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864653 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864663 */     GIR_RootConstrainSelectedInstOperands,
     /*  864664 */     // GIR_Coverage, 63577,
     /*  864664 */     GIR_EraseRootFromParent_Done,
     /*  864665 */   // Label 13234: @864665
     /*  864665 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(864747), // Rule ID 63578 //
     /*  864670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  864678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  864681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  864684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  864687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864697 */     // MIs[0] op1
     /*  864697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  864705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  864717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  864727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864729 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864731 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864733 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864735 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864745 */     GIR_RootConstrainSelectedInstOperands,
     /*  864746 */     // GIR_Coverage, 63578,
     /*  864746 */     GIR_EraseRootFromParent_Done,
     /*  864747 */   // Label 13235: @864747
     /*  864747 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(864829), // Rule ID 63583 //
     /*  864752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  864760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  864763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  864766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  864769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864779 */     // MIs[0] op1
     /*  864779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  864809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864811 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864813 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864815 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864817 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864827 */     GIR_RootConstrainSelectedInstOperands,
     /*  864828 */     // GIR_Coverage, 63583,
     /*  864828 */     GIR_EraseRootFromParent_Done,
     /*  864829 */   // Label 13236: @864829
     /*  864829 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(864911), // Rule ID 63584 //
     /*  864834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  864837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  864842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  864845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  864848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  864851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  864857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864861 */     // MIs[0] op1
     /*  864861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  864888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  864891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864893 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864895 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864897 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864899 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864909 */     GIR_RootConstrainSelectedInstOperands,
     /*  864910 */     // GIR_Coverage, 63584,
     /*  864910 */     GIR_EraseRootFromParent_Done,
     /*  864911 */   // Label 13237: @864911
     /*  864911 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(864993), // Rule ID 63595 //
     /*  864916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  864919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  864924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  864927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  864930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  864933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  864936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  864939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864943 */     // MIs[0] op1
     /*  864943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  864946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  864951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  864970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  864973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864975 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  864977 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  864979 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  864981 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  864983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864991 */     GIR_RootConstrainSelectedInstOperands,
     /*  864992 */     // GIR_Coverage, 63595,
     /*  864992 */     GIR_EraseRootFromParent_Done,
     /*  864993 */   // Label 13238: @864993
     /*  864993 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(865075), // Rule ID 63596 //
     /*  864998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  865001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  865006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  865009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  865012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  865015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  865018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865025 */     // MIs[0] op1
     /*  865025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  865028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  865033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  865052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  865055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865057 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  865059 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  865061 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  865063 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  865065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865073 */     GIR_RootConstrainSelectedInstOperands,
     /*  865074 */     // GIR_Coverage, 63596,
     /*  865074 */     GIR_EraseRootFromParent_Done,
     /*  865075 */   // Label 13239: @865075
     /*  865075 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(865157), // Rule ID 63601 //
     /*  865080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  865083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  865088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  865091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  865094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  865097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  865103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865107 */     // MIs[0] op1
     /*  865107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  865110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  865115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  865127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  865134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  865137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865139 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  865141 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  865143 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  865145 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  865147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865155 */     GIR_RootConstrainSelectedInstOperands,
     /*  865156 */     // GIR_Coverage, 63601,
     /*  865156 */     GIR_EraseRootFromParent_Done,
     /*  865157 */   // Label 13240: @865157
     /*  865157 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(865239), // Rule ID 63602 //
     /*  865162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  865165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  865170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  865173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  865176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  865179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865189 */     // MIs[0] op1
     /*  865189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  865192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  865197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  865209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10756:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  865216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  865219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  865223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  865225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  865227 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  865229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865237 */     GIR_RootConstrainSelectedInstOperands,
     /*  865238 */     // GIR_Coverage, 63602,
     /*  865238 */     GIR_EraseRootFromParent_Done,
     /*  865239 */   // Label 13241: @865239
     /*  865239 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(865331), // Rule ID 5054 //
     /*  865244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  865255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  865258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  865261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  865267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  865270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865294 */     // MIs[1] Operand 1
     /*  865294 */     // No operand predicates
     /*  865294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865307 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  865307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  865310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865329 */     GIR_RootConstrainSelectedInstOperands,
     /*  865330 */     // GIR_Coverage, 5054,
     /*  865330 */     GIR_EraseRootFromParent_Done,
     /*  865331 */   // Label 13242: @865331
     /*  865331 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(865423), // Rule ID 5055 //
     /*  865336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  865347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  865350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  865353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  865359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865386 */     // MIs[1] Operand 1
     /*  865386 */     // No operand predicates
     /*  865386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865399 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  865399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  865402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865421 */     GIR_RootConstrainSelectedInstOperands,
     /*  865422 */     // GIR_Coverage, 5055,
     /*  865422 */     GIR_EraseRootFromParent_Done,
     /*  865423 */   // Label 13243: @865423
     /*  865423 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(865515), // Rule ID 5056 //
     /*  865428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  865439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  865442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  865445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  865451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  865454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865478 */     // MIs[1] Operand 1
     /*  865478 */     // No operand predicates
     /*  865478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  865491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  865494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865513 */     GIR_RootConstrainSelectedInstOperands,
     /*  865514 */     // GIR_Coverage, 5056,
     /*  865514 */     GIR_EraseRootFromParent_Done,
     /*  865515 */   // Label 13244: @865515
     /*  865515 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(865607), // Rule ID 5057 //
     /*  865520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  865531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  865534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  865537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  865543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865570 */     // MIs[1] Operand 1
     /*  865570 */     // No operand predicates
     /*  865570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865583 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  865583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  865586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865605 */     GIR_RootConstrainSelectedInstOperands,
     /*  865606 */     // GIR_Coverage, 5057,
     /*  865606 */     GIR_EraseRootFromParent_Done,
     /*  865607 */   // Label 13245: @865607
     /*  865607 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(865699), // Rule ID 5058 //
     /*  865612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  865623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  865626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  865629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  865635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  865638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865662 */     // MIs[1] Operand 1
     /*  865662 */     // No operand predicates
     /*  865662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865675 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  865675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  865678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865697 */     GIR_RootConstrainSelectedInstOperands,
     /*  865698 */     // GIR_Coverage, 5058,
     /*  865698 */     GIR_EraseRootFromParent_Done,
     /*  865699 */   // Label 13246: @865699
     /*  865699 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(865791), // Rule ID 5059 //
     /*  865704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  865715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  865718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  865721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  865727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865754 */     // MIs[1] Operand 1
     /*  865754 */     // No operand predicates
     /*  865754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865767 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  865767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  865770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865789 */     GIR_RootConstrainSelectedInstOperands,
     /*  865790 */     // GIR_Coverage, 5059,
     /*  865790 */     GIR_EraseRootFromParent_Done,
     /*  865791 */   // Label 13247: @865791
     /*  865791 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(865883), // Rule ID 5060 //
     /*  865796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  865807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  865810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  865813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  865819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  865822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865846 */     // MIs[1] Operand 1
     /*  865846 */     // No operand predicates
     /*  865846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865859 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  865859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  865862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865881 */     GIR_RootConstrainSelectedInstOperands,
     /*  865882 */     // GIR_Coverage, 5060,
     /*  865882 */     GIR_EraseRootFromParent_Done,
     /*  865883 */   // Label 13248: @865883
     /*  865883 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(865975), // Rule ID 5061 //
     /*  865888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  865899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  865902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  865905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  865911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  865914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  865918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  865930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  865934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  865938 */     // MIs[1] Operand 1
     /*  865938 */     // No operand predicates
     /*  865938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  865942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  865944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  865951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  865954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  865963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  865965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865973 */     GIR_RootConstrainSelectedInstOperands,
     /*  865974 */     // GIR_Coverage, 5061,
     /*  865974 */     GIR_EraseRootFromParent_Done,
     /*  865975 */   // Label 13249: @865975
     /*  865975 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(866067), // Rule ID 5062 //
     /*  865980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  865988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  865991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  865994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  865997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  866003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866030 */     // MIs[1] Operand 1
     /*  866030 */     // No operand predicates
     /*  866030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866043 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  866043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  866046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866065 */     GIR_RootConstrainSelectedInstOperands,
     /*  866066 */     // GIR_Coverage, 5062,
     /*  866066 */     GIR_EraseRootFromParent_Done,
     /*  866067 */   // Label 13250: @866067
     /*  866067 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(866159), // Rule ID 5063 //
     /*  866072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  866095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  866098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866122 */     // MIs[1] Operand 1
     /*  866122 */     // No operand predicates
     /*  866122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866135 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  866135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  866138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866157 */     GIR_RootConstrainSelectedInstOperands,
     /*  866158 */     // GIR_Coverage, 5063,
     /*  866158 */     GIR_EraseRootFromParent_Done,
     /*  866159 */   // Label 13251: @866159
     /*  866159 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(866251), // Rule ID 5064 //
     /*  866164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  866187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866214 */     // MIs[1] Operand 1
     /*  866214 */     // No operand predicates
     /*  866214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866227 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  866227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  866230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866249 */     GIR_RootConstrainSelectedInstOperands,
     /*  866250 */     // GIR_Coverage, 5064,
     /*  866250 */     GIR_EraseRootFromParent_Done,
     /*  866251 */   // Label 13252: @866251
     /*  866251 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(866343), // Rule ID 5065 //
     /*  866256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  866279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  866282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866306 */     // MIs[1] Operand 1
     /*  866306 */     // No operand predicates
     /*  866306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  866319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  866322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866341 */     GIR_RootConstrainSelectedInstOperands,
     /*  866342 */     // GIR_Coverage, 5065,
     /*  866342 */     GIR_EraseRootFromParent_Done,
     /*  866343 */   // Label 13253: @866343
     /*  866343 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(866435), // Rule ID 5066 //
     /*  866348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  866359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  866362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  866365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  866371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866398 */     // MIs[1] Operand 1
     /*  866398 */     // No operand predicates
     /*  866398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866411 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  866411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  866433 */     GIR_RootConstrainSelectedInstOperands,
     /*  866434 */     // GIR_Coverage, 5066,
     /*  866434 */     GIR_EraseRootFromParent_Done,
     /*  866435 */   // Label 13254: @866435
     /*  866435 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(866527), // Rule ID 5067 //
     /*  866440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  866451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  866454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  866457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  866463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  866466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866490 */     // MIs[1] Operand 1
     /*  866490 */     // No operand predicates
     /*  866490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866503 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  866503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  866525 */     GIR_RootConstrainSelectedInstOperands,
     /*  866526 */     // GIR_Coverage, 5067,
     /*  866526 */     GIR_EraseRootFromParent_Done,
     /*  866527 */   // Label 13255: @866527
     /*  866527 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(866619), // Rule ID 5068 //
     /*  866532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  866555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866582 */     // MIs[1] Operand 1
     /*  866582 */     // No operand predicates
     /*  866582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  866595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866617 */     GIR_RootConstrainSelectedInstOperands,
     /*  866618 */     // GIR_Coverage, 5068,
     /*  866618 */     GIR_EraseRootFromParent_Done,
     /*  866619 */   // Label 13256: @866619
     /*  866619 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(866711), // Rule ID 5069 //
     /*  866624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  866647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  866650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866674 */     // MIs[1] Operand 1
     /*  866674 */     // No operand predicates
     /*  866674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866687 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  866687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866709 */     GIR_RootConstrainSelectedInstOperands,
     /*  866710 */     // GIR_Coverage, 5069,
     /*  866710 */     GIR_EraseRootFromParent_Done,
     /*  866711 */   // Label 13257: @866711
     /*  866711 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(866803), // Rule ID 5070 //
     /*  866716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  866739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866766 */     // MIs[1] Operand 1
     /*  866766 */     // No operand predicates
     /*  866766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  866779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866801 */     GIR_RootConstrainSelectedInstOperands,
     /*  866802 */     // GIR_Coverage, 5070,
     /*  866802 */     GIR_EraseRootFromParent_Done,
     /*  866803 */   // Label 13258: @866803
     /*  866803 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(866895), // Rule ID 5071 //
     /*  866808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  866831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  866834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866858 */     // MIs[1] Operand 1
     /*  866858 */     // No operand predicates
     /*  866858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  866871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866893 */     GIR_RootConstrainSelectedInstOperands,
     /*  866894 */     // GIR_Coverage, 5071,
     /*  866894 */     GIR_EraseRootFromParent_Done,
     /*  866895 */   // Label 13259: @866895
     /*  866895 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(866987), // Rule ID 5072 //
     /*  866900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  866908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  866911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  866914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  866917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  866923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  866926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  866930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  866942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  866946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  866950 */     // MIs[1] Operand 1
     /*  866950 */     // No operand predicates
     /*  866950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  866954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  866956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866963 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  866963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  866966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  866975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  866977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866985 */     GIR_RootConstrainSelectedInstOperands,
     /*  866986 */     // GIR_Coverage, 5072,
     /*  866986 */     GIR_EraseRootFromParent_Done,
     /*  866987 */   // Label 13260: @866987
     /*  866987 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(867079), // Rule ID 5073 //
     /*  866992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  867015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  867022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867042 */     // MIs[1] Operand 1
     /*  867042 */     // No operand predicates
     /*  867042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867055 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  867055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  867058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867077 */     GIR_RootConstrainSelectedInstOperands,
     /*  867078 */     // GIR_Coverage, 5073,
     /*  867078 */     GIR_EraseRootFromParent_Done,
     /*  867079 */   // Label 13261: @867079
     /*  867079 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(867171), // Rule ID 5074 //
     /*  867084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  867095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  867098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  867101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  867107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  867110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  867114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867134 */     // MIs[1] Operand 1
     /*  867134 */     // No operand predicates
     /*  867134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  867147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  867150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867169 */     GIR_RootConstrainSelectedInstOperands,
     /*  867170 */     // GIR_Coverage, 5074,
     /*  867170 */     GIR_EraseRootFromParent_Done,
     /*  867171 */   // Label 13262: @867171
     /*  867171 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(867263), // Rule ID 5075 //
     /*  867176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  867187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  867190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  867193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  867199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  867206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867226 */     // MIs[1] Operand 1
     /*  867226 */     // No operand predicates
     /*  867226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  867239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  867242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867261 */     GIR_RootConstrainSelectedInstOperands,
     /*  867262 */     // GIR_Coverage, 5075,
     /*  867262 */     GIR_EraseRootFromParent_Done,
     /*  867263 */   // Label 13263: @867263
     /*  867263 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(867355), // Rule ID 5076 //
     /*  867268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  867279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  867282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  867285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  867291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  867294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  867298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867318 */     // MIs[1] Operand 1
     /*  867318 */     // No operand predicates
     /*  867318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867331 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  867331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  867334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867353 */     GIR_RootConstrainSelectedInstOperands,
     /*  867354 */     // GIR_Coverage, 5076,
     /*  867354 */     GIR_EraseRootFromParent_Done,
     /*  867355 */   // Label 13264: @867355
     /*  867355 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(867447), // Rule ID 5077 //
     /*  867360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  867371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  867374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  867377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  867383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  867390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867410 */     // MIs[1] Operand 1
     /*  867410 */     // No operand predicates
     /*  867410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867423 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  867423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  867426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867445 */     GIR_RootConstrainSelectedInstOperands,
     /*  867446 */     // GIR_Coverage, 5077,
     /*  867446 */     GIR_EraseRootFromParent_Done,
     /*  867447 */   // Label 13265: @867447
     /*  867447 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(867539), // Rule ID 5078 //
     /*  867452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  867463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  867466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  867469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  867475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  867478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  867482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867502 */     // MIs[1] Operand 1
     /*  867502 */     // No operand predicates
     /*  867502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867515 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  867515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  867518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867537 */     GIR_RootConstrainSelectedInstOperands,
     /*  867538 */     // GIR_Coverage, 5078,
     /*  867538 */     GIR_EraseRootFromParent_Done,
     /*  867539 */   // Label 13266: @867539
     /*  867539 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(867631), // Rule ID 5079 //
     /*  867544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  867555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  867558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  867561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  867567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  867574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867594 */     // MIs[1] Operand 1
     /*  867594 */     // No operand predicates
     /*  867594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867607 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  867607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  867610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867629 */     GIR_RootConstrainSelectedInstOperands,
     /*  867630 */     // GIR_Coverage, 5079,
     /*  867630 */     GIR_EraseRootFromParent_Done,
     /*  867631 */   // Label 13267: @867631
     /*  867631 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(867723), // Rule ID 5080 //
     /*  867636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  867659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  867662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  867666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867686 */     // MIs[1] Operand 1
     /*  867686 */     // No operand predicates
     /*  867686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  867699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  867702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867721 */     GIR_RootConstrainSelectedInstOperands,
     /*  867722 */     // GIR_Coverage, 5080,
     /*  867722 */     GIR_EraseRootFromParent_Done,
     /*  867723 */   // Label 13268: @867723
     /*  867723 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(867815), // Rule ID 5081 //
     /*  867728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  867751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  867758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867778 */     // MIs[1] Operand 1
     /*  867778 */     // No operand predicates
     /*  867778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  867791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  867794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867813 */     GIR_RootConstrainSelectedInstOperands,
     /*  867814 */     // GIR_Coverage, 5081,
     /*  867814 */     GIR_EraseRootFromParent_Done,
     /*  867815 */   // Label 13269: @867815
     /*  867815 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(867907), // Rule ID 5082 //
     /*  867820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  867843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  867846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  867850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867870 */     // MIs[1] Operand 1
     /*  867870 */     // No operand predicates
     /*  867870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867883 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  867883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  867886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867905 */     GIR_RootConstrainSelectedInstOperands,
     /*  867906 */     // GIR_Coverage, 5082,
     /*  867906 */     GIR_EraseRootFromParent_Done,
     /*  867907 */   // Label 13270: @867907
     /*  867907 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(867999), // Rule ID 5083 //
     /*  867912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  867920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  867935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  867938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  867942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  867954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  867958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  867962 */     // MIs[1] Operand 1
     /*  867962 */     // No operand predicates
     /*  867962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  867966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  867968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867975 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  867975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  867978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  867987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  867989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867997 */     GIR_RootConstrainSelectedInstOperands,
     /*  867998 */     // GIR_Coverage, 5083,
     /*  867998 */     GIR_EraseRootFromParent_Done,
     /*  867999 */   // Label 13271: @867999
     /*  867999 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(868091), // Rule ID 5084 //
     /*  868004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  868015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  868018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  868021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  868027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  868034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868054 */     // MIs[1] Operand 1
     /*  868054 */     // No operand predicates
     /*  868054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868067 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  868067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  868070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868089 */     GIR_RootConstrainSelectedInstOperands,
     /*  868090 */     // GIR_Coverage, 5084,
     /*  868090 */     GIR_EraseRootFromParent_Done,
     /*  868091 */   // Label 13272: @868091
     /*  868091 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(868183), // Rule ID 5085 //
     /*  868096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  868107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  868110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  868113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  868119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  868122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  868126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868146 */     // MIs[1] Operand 1
     /*  868146 */     // No operand predicates
     /*  868146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868159 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  868159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  868162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868181 */     GIR_RootConstrainSelectedInstOperands,
     /*  868182 */     // GIR_Coverage, 5085,
     /*  868182 */     GIR_EraseRootFromParent_Done,
     /*  868183 */   // Label 13273: @868183
     /*  868183 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(868275), // Rule ID 5086 //
     /*  868188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  868211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  868218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868238 */     // MIs[1] Operand 1
     /*  868238 */     // No operand predicates
     /*  868238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  868251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  868254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868273 */     GIR_RootConstrainSelectedInstOperands,
     /*  868274 */     // GIR_Coverage, 5086,
     /*  868274 */     GIR_EraseRootFromParent_Done,
     /*  868275 */   // Label 13274: @868275
     /*  868275 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(868367), // Rule ID 5087 //
     /*  868280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  868303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  868306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  868310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868330 */     // MIs[1] Operand 1
     /*  868330 */     // No operand predicates
     /*  868330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  868343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  868346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868365 */     GIR_RootConstrainSelectedInstOperands,
     /*  868366 */     // GIR_Coverage, 5087,
     /*  868366 */     GIR_EraseRootFromParent_Done,
     /*  868367 */   // Label 13275: @868367
     /*  868367 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(868459), // Rule ID 5088 //
     /*  868372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  868395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  868402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868422 */     // MIs[1] Operand 1
     /*  868422 */     // No operand predicates
     /*  868422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868435 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  868435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  868438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868457 */     GIR_RootConstrainSelectedInstOperands,
     /*  868458 */     // GIR_Coverage, 5088,
     /*  868458 */     GIR_EraseRootFromParent_Done,
     /*  868459 */   // Label 13276: @868459
     /*  868459 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(868551), // Rule ID 5089 //
     /*  868464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  868487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  868490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  868494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868514 */     // MIs[1] Operand 1
     /*  868514 */     // No operand predicates
     /*  868514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  868527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  868530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868549 */     GIR_RootConstrainSelectedInstOperands,
     /*  868550 */     // GIR_Coverage, 5089,
     /*  868550 */     GIR_EraseRootFromParent_Done,
     /*  868551 */   // Label 13277: @868551
     /*  868551 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(868643), // Rule ID 5090 //
     /*  868556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  868579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  868586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868606 */     // MIs[1] Operand 1
     /*  868606 */     // No operand predicates
     /*  868606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  868619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  868622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868641 */     GIR_RootConstrainSelectedInstOperands,
     /*  868642 */     // GIR_Coverage, 5090,
     /*  868642 */     GIR_EraseRootFromParent_Done,
     /*  868643 */   // Label 13278: @868643
     /*  868643 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(868735), // Rule ID 5091 //
     /*  868648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  868671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  868674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  868678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868698 */     // MIs[1] Operand 1
     /*  868698 */     // No operand predicates
     /*  868698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868711 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  868711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  868714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868733 */     GIR_RootConstrainSelectedInstOperands,
     /*  868734 */     // GIR_Coverage, 5091,
     /*  868734 */     GIR_EraseRootFromParent_Done,
     /*  868735 */   // Label 13279: @868735
     /*  868735 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(868827), // Rule ID 5092 //
     /*  868740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  868763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  868770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868790 */     // MIs[1] Operand 1
     /*  868790 */     // No operand predicates
     /*  868790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868803 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  868803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  868806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868825 */     GIR_RootConstrainSelectedInstOperands,
     /*  868826 */     // GIR_Coverage, 5092,
     /*  868826 */     GIR_EraseRootFromParent_Done,
     /*  868827 */   // Label 13280: @868827
     /*  868827 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(868919), // Rule ID 5093 //
     /*  868832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  868855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  868858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  868862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868882 */     // MIs[1] Operand 1
     /*  868882 */     // No operand predicates
     /*  868882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  868895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  868898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  868909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868917 */     GIR_RootConstrainSelectedInstOperands,
     /*  868918 */     // GIR_Coverage, 5093,
     /*  868918 */     GIR_EraseRootFromParent_Done,
     /*  868919 */   // Label 13281: @868919
     /*  868919 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(869011), // Rule ID 5094 //
     /*  868924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  868932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  868947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  868950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  868954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  868966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  868970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  868974 */     // MIs[1] Operand 1
     /*  868974 */     // No operand predicates
     /*  868974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  868978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  868980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868987 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  868987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  868990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  868999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869009 */     GIR_RootConstrainSelectedInstOperands,
     /*  869010 */     // GIR_Coverage, 5094,
     /*  869010 */     GIR_EraseRootFromParent_Done,
     /*  869011 */   // Label 13282: @869011
     /*  869011 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(869103), // Rule ID 5095 //
     /*  869016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  869019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  869024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  869027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  869030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  869033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  869039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  869046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869066 */     // MIs[1] Operand 1
     /*  869066 */     // No operand predicates
     /*  869066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869079 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  869079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  869082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869101 */     GIR_RootConstrainSelectedInstOperands,
     /*  869102 */     // GIR_Coverage, 5095,
     /*  869102 */     GIR_EraseRootFromParent_Done,
     /*  869103 */   // Label 13283: @869103
     /*  869103 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(869195), // Rule ID 5096 //
     /*  869108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  869111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  869116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  869119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  869122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  869125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  869131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  869134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  869138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869158 */     // MIs[1] Operand 1
     /*  869158 */     // No operand predicates
     /*  869158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869171 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  869171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  869174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869193 */     GIR_RootConstrainSelectedInstOperands,
     /*  869194 */     // GIR_Coverage, 5096,
     /*  869194 */     GIR_EraseRootFromParent_Done,
     /*  869195 */   // Label 13284: @869195
     /*  869195 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(869287), // Rule ID 5097 //
     /*  869200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  869203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  869208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  869211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  869214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  869217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  869223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  869230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869250 */     // MIs[1] Operand 1
     /*  869250 */     // No operand predicates
     /*  869250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869263 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  869263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  869266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869285 */     GIR_RootConstrainSelectedInstOperands,
     /*  869286 */     // GIR_Coverage, 5097,
     /*  869286 */     GIR_EraseRootFromParent_Done,
     /*  869287 */   // Label 13285: @869287
     /*  869287 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(869382), // Rule ID 7828 //
     /*  869292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  869303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  869306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  869309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  869315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  869318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869342 */     // MIs[1] Operand 1
     /*  869342 */     // No operand predicates
     /*  869342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  869355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  869358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869380 */     GIR_RootConstrainSelectedInstOperands,
     /*  869381 */     // GIR_Coverage, 7828,
     /*  869381 */     GIR_EraseRootFromParent_Done,
     /*  869382 */   // Label 13286: @869382
     /*  869382 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(869477), // Rule ID 7829 //
     /*  869387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  869398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  869401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  869404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  869410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869437 */     // MIs[1] Operand 1
     /*  869437 */     // No operand predicates
     /*  869437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869450 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  869450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  869453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869475 */     GIR_RootConstrainSelectedInstOperands,
     /*  869476 */     // GIR_Coverage, 7829,
     /*  869476 */     GIR_EraseRootFromParent_Done,
     /*  869477 */   // Label 13287: @869477
     /*  869477 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(869572), // Rule ID 7832 //
     /*  869482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  869493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  869496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  869499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  869505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  869508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869532 */     // MIs[1] Operand 1
     /*  869532 */     // No operand predicates
     /*  869532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  869545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  869548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869570 */     GIR_RootConstrainSelectedInstOperands,
     /*  869571 */     // GIR_Coverage, 7832,
     /*  869571 */     GIR_EraseRootFromParent_Done,
     /*  869572 */   // Label 13288: @869572
     /*  869572 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(869667), // Rule ID 7833 //
     /*  869577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  869588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  869591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  869594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  869600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869627 */     // MIs[1] Operand 1
     /*  869627 */     // No operand predicates
     /*  869627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  869640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  869643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869665 */     GIR_RootConstrainSelectedInstOperands,
     /*  869666 */     // GIR_Coverage, 7833,
     /*  869666 */     GIR_EraseRootFromParent_Done,
     /*  869667 */   // Label 13289: @869667
     /*  869667 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(869762), // Rule ID 7836 //
     /*  869672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  869683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  869686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  869689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  869695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  869698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869722 */     // MIs[1] Operand 1
     /*  869722 */     // No operand predicates
     /*  869722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869735 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  869735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  869738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869760 */     GIR_RootConstrainSelectedInstOperands,
     /*  869761 */     // GIR_Coverage, 7836,
     /*  869761 */     GIR_EraseRootFromParent_Done,
     /*  869762 */   // Label 13290: @869762
     /*  869762 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(869857), // Rule ID 7837 //
     /*  869767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  869778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  869781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  869784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  869790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869817 */     // MIs[1] Operand 1
     /*  869817 */     // No operand predicates
     /*  869817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  869830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  869833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  869852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869855 */     GIR_RootConstrainSelectedInstOperands,
     /*  869856 */     // GIR_Coverage, 7837,
     /*  869856 */     GIR_EraseRootFromParent_Done,
     /*  869857 */   // Label 13291: @869857
     /*  869857 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(869952), // Rule ID 7840 //
     /*  869862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  869873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  869876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  869885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  869888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  869908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  869912 */     // MIs[1] Operand 1
     /*  869912 */     // No operand predicates
     /*  869912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  869916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  869925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  869928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  869937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  869939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  869950 */     GIR_RootConstrainSelectedInstOperands,
     /*  869951 */     // GIR_Coverage, 7840,
     /*  869951 */     GIR_EraseRootFromParent_Done,
     /*  869952 */   // Label 13292: @869952
     /*  869952 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(870047), // Rule ID 7841 //
     /*  869957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  869965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  869968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  869971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  869980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  869983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  869999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870007 */     // MIs[1] Operand 1
     /*  870007 */     // No operand predicates
     /*  870007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  870020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  870023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870045 */     GIR_RootConstrainSelectedInstOperands,
     /*  870046 */     // GIR_Coverage, 7841,
     /*  870046 */     GIR_EraseRootFromParent_Done,
     /*  870047 */   // Label 13293: @870047
     /*  870047 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(870142), // Rule ID 7844 //
     /*  870052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  870063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  870066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  870075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  870078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870102 */     // MIs[1] Operand 1
     /*  870102 */     // No operand predicates
     /*  870102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870115 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  870115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  870118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870140 */     GIR_RootConstrainSelectedInstOperands,
     /*  870141 */     // GIR_Coverage, 7844,
     /*  870141 */     GIR_EraseRootFromParent_Done,
     /*  870142 */   // Label 13294: @870142
     /*  870142 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(870237), // Rule ID 7845 //
     /*  870147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  870158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  870161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  870170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  870173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870197 */     // MIs[1] Operand 1
     /*  870197 */     // No operand predicates
     /*  870197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  870210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  870213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870235 */     GIR_RootConstrainSelectedInstOperands,
     /*  870236 */     // GIR_Coverage, 7845,
     /*  870236 */     GIR_EraseRootFromParent_Done,
     /*  870237 */   // Label 13295: @870237
     /*  870237 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(870332), // Rule ID 7848 //
     /*  870242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  870253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  870256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  870265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  870268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870292 */     // MIs[1] Operand 1
     /*  870292 */     // No operand predicates
     /*  870292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  870305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  870308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870330 */     GIR_RootConstrainSelectedInstOperands,
     /*  870331 */     // GIR_Coverage, 7848,
     /*  870331 */     GIR_EraseRootFromParent_Done,
     /*  870332 */   // Label 13296: @870332
     /*  870332 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(870427), // Rule ID 7849 //
     /*  870337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  870348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  870351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  870360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  870363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870387 */     // MIs[1] Operand 1
     /*  870387 */     // No operand predicates
     /*  870387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  870400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  870403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870425 */     GIR_RootConstrainSelectedInstOperands,
     /*  870426 */     // GIR_Coverage, 7849,
     /*  870426 */     GIR_EraseRootFromParent_Done,
     /*  870427 */   // Label 13297: @870427
     /*  870427 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(870522), // Rule ID 7852 //
     /*  870432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  870443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  870446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  870449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  870455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  870458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870482 */     // MIs[1] Operand 1
     /*  870482 */     // No operand predicates
     /*  870482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  870495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  870517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870520 */     GIR_RootConstrainSelectedInstOperands,
     /*  870521 */     // GIR_Coverage, 7852,
     /*  870521 */     GIR_EraseRootFromParent_Done,
     /*  870522 */   // Label 13298: @870522
     /*  870522 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(870617), // Rule ID 7853 //
     /*  870527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  870538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  870541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  870544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  870550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  870553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870577 */     // MIs[1] Operand 1
     /*  870577 */     // No operand predicates
     /*  870577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  870590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  870612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870615 */     GIR_RootConstrainSelectedInstOperands,
     /*  870616 */     // GIR_Coverage, 7853,
     /*  870616 */     GIR_EraseRootFromParent_Done,
     /*  870617 */   // Label 13299: @870617
     /*  870617 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(870712), // Rule ID 7856 //
     /*  870622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  870633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  870636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  870639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  870645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  870648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870672 */     // MIs[1] Operand 1
     /*  870672 */     // No operand predicates
     /*  870672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870685 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  870685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870710 */     GIR_RootConstrainSelectedInstOperands,
     /*  870711 */     // GIR_Coverage, 7856,
     /*  870711 */     GIR_EraseRootFromParent_Done,
     /*  870712 */   // Label 13300: @870712
     /*  870712 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(870807), // Rule ID 7857 //
     /*  870717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  870728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  870731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  870734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  870740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  870743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870767 */     // MIs[1] Operand 1
     /*  870767 */     // No operand predicates
     /*  870767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870780 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  870780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870805 */     GIR_RootConstrainSelectedInstOperands,
     /*  870806 */     // GIR_Coverage, 7857,
     /*  870806 */     GIR_EraseRootFromParent_Done,
     /*  870807 */   // Label 13301: @870807
     /*  870807 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(870902), // Rule ID 7860 //
     /*  870812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  870823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  870826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  870835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  870838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870862 */     // MIs[1] Operand 1
     /*  870862 */     // No operand predicates
     /*  870862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  870875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870900 */     GIR_RootConstrainSelectedInstOperands,
     /*  870901 */     // GIR_Coverage, 7860,
     /*  870901 */     GIR_EraseRootFromParent_Done,
     /*  870902 */   // Label 13302: @870902
     /*  870902 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(870997), // Rule ID 7861 //
     /*  870907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  870915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  870918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  870921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  870930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  870933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  870949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  870953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  870957 */     // MIs[1] Operand 1
     /*  870957 */     // No operand predicates
     /*  870957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  870961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  870963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  870970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  870973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  870982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  870984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  870995 */     GIR_RootConstrainSelectedInstOperands,
     /*  870996 */     // GIR_Coverage, 7861,
     /*  870996 */     GIR_EraseRootFromParent_Done,
     /*  870997 */   // Label 13303: @870997
     /*  870997 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(871092), // Rule ID 7864 //
     /*  871002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  871005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  871013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  871016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  871025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871052 */     // MIs[1] Operand 1
     /*  871052 */     // No operand predicates
     /*  871052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871065 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  871065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  871068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871090 */     GIR_RootConstrainSelectedInstOperands,
     /*  871091 */     // GIR_Coverage, 7864,
     /*  871091 */     GIR_EraseRootFromParent_Done,
     /*  871092 */   // Label 13304: @871092
     /*  871092 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(871187), // Rule ID 7865 //
     /*  871097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  871100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  871108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  871111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  871120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  871123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871147 */     // MIs[1] Operand 1
     /*  871147 */     // No operand predicates
     /*  871147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  871160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  871163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871185 */     GIR_RootConstrainSelectedInstOperands,
     /*  871186 */     // GIR_Coverage, 7865,
     /*  871186 */     GIR_EraseRootFromParent_Done,
     /*  871187 */   // Label 13305: @871187
     /*  871187 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(871282), // Rule ID 7868 //
     /*  871192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  871203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  871206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  871209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  871215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871242 */     // MIs[1] Operand 1
     /*  871242 */     // No operand predicates
     /*  871242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  871255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  871258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871280 */     GIR_RootConstrainSelectedInstOperands,
     /*  871281 */     // GIR_Coverage, 7868,
     /*  871281 */     GIR_EraseRootFromParent_Done,
     /*  871282 */   // Label 13306: @871282
     /*  871282 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(871377), // Rule ID 7869 //
     /*  871287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  871298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  871301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  871304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  871310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  871313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871337 */     // MIs[1] Operand 1
     /*  871337 */     // No operand predicates
     /*  871337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  871350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  871353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871375 */     GIR_RootConstrainSelectedInstOperands,
     /*  871376 */     // GIR_Coverage, 7869,
     /*  871376 */     GIR_EraseRootFromParent_Done,
     /*  871377 */   // Label 13307: @871377
     /*  871377 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(871472), // Rule ID 7872 //
     /*  871382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  871393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  871396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  871399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  871405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871432 */     // MIs[1] Operand 1
     /*  871432 */     // No operand predicates
     /*  871432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871445 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  871445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  871448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871470 */     GIR_RootConstrainSelectedInstOperands,
     /*  871471 */     // GIR_Coverage, 7872,
     /*  871471 */     GIR_EraseRootFromParent_Done,
     /*  871472 */   // Label 13308: @871472
     /*  871472 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(871567), // Rule ID 7873 //
     /*  871477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  871488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  871491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  871494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  871500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  871503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871527 */     // MIs[1] Operand 1
     /*  871527 */     // No operand predicates
     /*  871527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  871540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  871543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871565 */     GIR_RootConstrainSelectedInstOperands,
     /*  871566 */     // GIR_Coverage, 7873,
     /*  871566 */     GIR_EraseRootFromParent_Done,
     /*  871567 */   // Label 13309: @871567
     /*  871567 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(871662), // Rule ID 7876 //
     /*  871572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  871583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  871586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  871589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  871595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871622 */     // MIs[1] Operand 1
     /*  871622 */     // No operand predicates
     /*  871622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871635 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  871635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  871638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871660 */     GIR_RootConstrainSelectedInstOperands,
     /*  871661 */     // GIR_Coverage, 7876,
     /*  871661 */     GIR_EraseRootFromParent_Done,
     /*  871662 */   // Label 13310: @871662
     /*  871662 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(871757), // Rule ID 7877 //
     /*  871667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  871678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  871681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  871684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  871690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  871693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871717 */     // MIs[1] Operand 1
     /*  871717 */     // No operand predicates
     /*  871717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871730 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  871730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  871733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  871752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871755 */     GIR_RootConstrainSelectedInstOperands,
     /*  871756 */     // GIR_Coverage, 7877,
     /*  871756 */     GIR_EraseRootFromParent_Done,
     /*  871757 */   // Label 13311: @871757
     /*  871757 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(871852), // Rule ID 7880 //
     /*  871762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  871773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  871776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  871785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871812 */     // MIs[1] Operand 1
     /*  871812 */     // No operand predicates
     /*  871812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871825 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  871825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  871828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871850 */     GIR_RootConstrainSelectedInstOperands,
     /*  871851 */     // GIR_Coverage, 7880,
     /*  871851 */     GIR_EraseRootFromParent_Done,
     /*  871852 */   // Label 13312: @871852
     /*  871852 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(871947), // Rule ID 7881 //
     /*  871857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  871868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  871871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  871880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  871883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  871907 */     // MIs[1] Operand 1
     /*  871907 */     // No operand predicates
     /*  871907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  871911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  871913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  871920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  871923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  871932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  871934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  871945 */     GIR_RootConstrainSelectedInstOperands,
     /*  871946 */     // GIR_Coverage, 7881,
     /*  871946 */     GIR_EraseRootFromParent_Done,
     /*  871947 */   // Label 13313: @871947
     /*  871947 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(872042), // Rule ID 7884 //
     /*  871952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  871960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  871963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  871966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  871975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  871978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  871994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872002 */     // MIs[1] Operand 1
     /*  872002 */     // No operand predicates
     /*  872002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872015 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  872015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  872018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872040 */     GIR_RootConstrainSelectedInstOperands,
     /*  872041 */     // GIR_Coverage, 7884,
     /*  872041 */     GIR_EraseRootFromParent_Done,
     /*  872042 */   // Label 13314: @872042
     /*  872042 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(872137), // Rule ID 7885 //
     /*  872047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  872058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  872061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  872064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  872070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  872073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872097 */     // MIs[1] Operand 1
     /*  872097 */     // No operand predicates
     /*  872097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872110 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  872110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  872113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872135 */     GIR_RootConstrainSelectedInstOperands,
     /*  872136 */     // GIR_Coverage, 7885,
     /*  872136 */     GIR_EraseRootFromParent_Done,
     /*  872137 */   // Label 13315: @872137
     /*  872137 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(872232), // Rule ID 7888 //
     /*  872142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  872153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  872156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  872165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  872168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872192 */     // MIs[1] Operand 1
     /*  872192 */     // No operand predicates
     /*  872192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872205 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  872205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  872208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872230 */     GIR_RootConstrainSelectedInstOperands,
     /*  872231 */     // GIR_Coverage, 7888,
     /*  872231 */     GIR_EraseRootFromParent_Done,
     /*  872232 */   // Label 13316: @872232
     /*  872232 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(872327), // Rule ID 7889 //
     /*  872237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  872248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  872251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  872260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  872263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872287 */     // MIs[1] Operand 1
     /*  872287 */     // No operand predicates
     /*  872287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872300 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  872300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  872303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872325 */     GIR_RootConstrainSelectedInstOperands,
     /*  872326 */     // GIR_Coverage, 7889,
     /*  872326 */     GIR_EraseRootFromParent_Done,
     /*  872327 */   // Label 13317: @872327
     /*  872327 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(872422), // Rule ID 7892 //
     /*  872332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  872343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  872346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  872355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  872358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872382 */     // MIs[1] Operand 1
     /*  872382 */     // No operand predicates
     /*  872382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872395 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  872395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  872398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872420 */     GIR_RootConstrainSelectedInstOperands,
     /*  872421 */     // GIR_Coverage, 7892,
     /*  872421 */     GIR_EraseRootFromParent_Done,
     /*  872422 */   // Label 13318: @872422
     /*  872422 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(872517), // Rule ID 7893 //
     /*  872427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  872438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  872441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  872450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  872453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872477 */     // MIs[1] Operand 1
     /*  872477 */     // No operand predicates
     /*  872477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  872490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  872493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872515 */     GIR_RootConstrainSelectedInstOperands,
     /*  872516 */     // GIR_Coverage, 7893,
     /*  872516 */     GIR_EraseRootFromParent_Done,
     /*  872517 */   // Label 13319: @872517
     /*  872517 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(872612), // Rule ID 7896 //
     /*  872522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  872533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  872536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  872545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  872548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872572 */     // MIs[1] Operand 1
     /*  872572 */     // No operand predicates
     /*  872572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872585 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  872585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  872588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872610 */     GIR_RootConstrainSelectedInstOperands,
     /*  872611 */     // GIR_Coverage, 7896,
     /*  872611 */     GIR_EraseRootFromParent_Done,
     /*  872612 */   // Label 13320: @872612
     /*  872612 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(872707), // Rule ID 7897 //
     /*  872617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  872628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  872631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  872640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  872643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872667 */     // MIs[1] Operand 1
     /*  872667 */     // No operand predicates
     /*  872667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  872680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  872683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872705 */     GIR_RootConstrainSelectedInstOperands,
     /*  872706 */     // GIR_Coverage, 7897,
     /*  872706 */     GIR_EraseRootFromParent_Done,
     /*  872707 */   // Label 13321: @872707
     /*  872707 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(872802), // Rule ID 7900 //
     /*  872712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  872723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  872726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  872735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  872738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872762 */     // MIs[1] Operand 1
     /*  872762 */     // No operand predicates
     /*  872762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872775 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  872775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  872778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872800 */     GIR_RootConstrainSelectedInstOperands,
     /*  872801 */     // GIR_Coverage, 7900,
     /*  872801 */     GIR_EraseRootFromParent_Done,
     /*  872802 */   // Label 13322: @872802
     /*  872802 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(872897), // Rule ID 7901 //
     /*  872807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  872818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  872821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  872830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  872833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872857 */     // MIs[1] Operand 1
     /*  872857 */     // No operand predicates
     /*  872857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  872870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  872873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872895 */     GIR_RootConstrainSelectedInstOperands,
     /*  872896 */     // GIR_Coverage, 7901,
     /*  872896 */     GIR_EraseRootFromParent_Done,
     /*  872897 */   // Label 13323: @872897
     /*  872897 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(872992), // Rule ID 7904 //
     /*  872902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  872905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  872910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  872913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  872916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  872925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  872928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  872944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  872948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  872952 */     // MIs[1] Operand 1
     /*  872952 */     // No operand predicates
     /*  872952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  872956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  872958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872965 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  872965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  872968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  872977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  872979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  872990 */     GIR_RootConstrainSelectedInstOperands,
     /*  872991 */     // GIR_Coverage, 7904,
     /*  872991 */     GIR_EraseRootFromParent_Done,
     /*  872992 */   // Label 13324: @872992
     /*  872992 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(873087), // Rule ID 7905 //
     /*  872997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  873000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  873005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  873008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  873011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  873014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  873020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873047 */     // MIs[1] Operand 1
     /*  873047 */     // No operand predicates
     /*  873047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  873060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  873063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873085 */     GIR_RootConstrainSelectedInstOperands,
     /*  873086 */     // GIR_Coverage, 7905,
     /*  873086 */     GIR_EraseRootFromParent_Done,
     /*  873087 */   // Label 13325: @873087
     /*  873087 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(873182), // Rule ID 7908 //
     /*  873092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  873095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  873100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  873103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  873106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  873115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  873118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873142 */     // MIs[1] Operand 1
     /*  873142 */     // No operand predicates
     /*  873142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873155 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  873155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  873158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873180 */     GIR_RootConstrainSelectedInstOperands,
     /*  873181 */     // GIR_Coverage, 7908,
     /*  873181 */     GIR_EraseRootFromParent_Done,
     /*  873182 */   // Label 13326: @873182
     /*  873182 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(873277), // Rule ID 7909 //
     /*  873187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  873190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  873195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  873198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  873201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  873210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873237 */     // MIs[1] Operand 1
     /*  873237 */     // No operand predicates
     /*  873237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  873250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  873253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873275 */     GIR_RootConstrainSelectedInstOperands,
     /*  873276 */     // GIR_Coverage, 7909,
     /*  873276 */     GIR_EraseRootFromParent_Done,
     /*  873277 */   // Label 13327: @873277
     /*  873277 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(873372), // Rule ID 7912 //
     /*  873282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  873285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  873290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  873293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  873296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  873305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  873308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873332 */     // MIs[1] Operand 1
     /*  873332 */     // No operand predicates
     /*  873332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  873345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  873348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873370 */     GIR_RootConstrainSelectedInstOperands,
     /*  873371 */     // GIR_Coverage, 7912,
     /*  873371 */     GIR_EraseRootFromParent_Done,
     /*  873372 */   // Label 13328: @873372
     /*  873372 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(873467), // Rule ID 7913 //
     /*  873377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  873380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  873385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  873388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  873391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  873400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873427 */     // MIs[1] Operand 1
     /*  873427 */     // No operand predicates
     /*  873427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  873440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  873443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873465 */     GIR_RootConstrainSelectedInstOperands,
     /*  873466 */     // GIR_Coverage, 7913,
     /*  873466 */     GIR_EraseRootFromParent_Done,
     /*  873467 */   // Label 13329: @873467
     /*  873467 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(873562), // Rule ID 8092 //
     /*  873472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  873483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  873486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  873489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  873495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  873498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873522 */     // MIs[1] Operand 1
     /*  873522 */     // No operand predicates
     /*  873522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873535 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  873535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  873538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873560 */     GIR_RootConstrainSelectedInstOperands,
     /*  873561 */     // GIR_Coverage, 8092,
     /*  873561 */     GIR_EraseRootFromParent_Done,
     /*  873562 */   // Label 13330: @873562
     /*  873562 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(873657), // Rule ID 8093 //
     /*  873567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  873578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  873581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  873584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  873590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873617 */     // MIs[1] Operand 1
     /*  873617 */     // No operand predicates
     /*  873617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  873630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  873633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873655 */     GIR_RootConstrainSelectedInstOperands,
     /*  873656 */     // GIR_Coverage, 8093,
     /*  873656 */     GIR_EraseRootFromParent_Done,
     /*  873657 */   // Label 13331: @873657
     /*  873657 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(873752), // Rule ID 8096 //
     /*  873662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  873673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  873676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  873685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  873688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873712 */     // MIs[1] Operand 1
     /*  873712 */     // No operand predicates
     /*  873712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873725 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  873725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  873728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873750 */     GIR_RootConstrainSelectedInstOperands,
     /*  873751 */     // GIR_Coverage, 8096,
     /*  873751 */     GIR_EraseRootFromParent_Done,
     /*  873752 */   // Label 13332: @873752
     /*  873752 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(873847), // Rule ID 8097 //
     /*  873757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  873768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  873771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  873780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873807 */     // MIs[1] Operand 1
     /*  873807 */     // No operand predicates
     /*  873807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  873820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  873823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873845 */     GIR_RootConstrainSelectedInstOperands,
     /*  873846 */     // GIR_Coverage, 8097,
     /*  873846 */     GIR_EraseRootFromParent_Done,
     /*  873847 */   // Label 13333: @873847
     /*  873847 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(873942), // Rule ID 8100 //
     /*  873852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  873863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  873866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  873875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  873878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873902 */     // MIs[1] Operand 1
     /*  873902 */     // No operand predicates
     /*  873902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  873906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873915 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  873915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  873918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  873927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  873929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  873940 */     GIR_RootConstrainSelectedInstOperands,
     /*  873941 */     // GIR_Coverage, 8100,
     /*  873941 */     GIR_EraseRootFromParent_Done,
     /*  873942 */   // Label 13334: @873942
     /*  873942 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(874037), // Rule ID 8101 //
     /*  873947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  873955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  873958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  873961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  873970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  873973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  873989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  873993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  873997 */     // MIs[1] Operand 1
     /*  873997 */     // No operand predicates
     /*  873997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874010 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  874010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  874013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874035 */     GIR_RootConstrainSelectedInstOperands,
     /*  874036 */     // GIR_Coverage, 8101,
     /*  874036 */     GIR_EraseRootFromParent_Done,
     /*  874037 */   // Label 13335: @874037
     /*  874037 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(874132), // Rule ID 8104 //
     /*  874042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  874053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  874056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  874065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  874068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874092 */     // MIs[1] Operand 1
     /*  874092 */     // No operand predicates
     /*  874092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874105 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  874105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  874108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874130 */     GIR_RootConstrainSelectedInstOperands,
     /*  874131 */     // GIR_Coverage, 8104,
     /*  874131 */     GIR_EraseRootFromParent_Done,
     /*  874132 */   // Label 13336: @874132
     /*  874132 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(874227), // Rule ID 8105 //
     /*  874137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  874148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  874151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  874160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  874163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874187 */     // MIs[1] Operand 1
     /*  874187 */     // No operand predicates
     /*  874187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  874200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  874203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874225 */     GIR_RootConstrainSelectedInstOperands,
     /*  874226 */     // GIR_Coverage, 8105,
     /*  874226 */     GIR_EraseRootFromParent_Done,
     /*  874227 */   // Label 13337: @874227
     /*  874227 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(874322), // Rule ID 8108 //
     /*  874232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  874243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  874246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  874255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  874258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874282 */     // MIs[1] Operand 1
     /*  874282 */     // No operand predicates
     /*  874282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874295 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  874295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  874298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874320 */     GIR_RootConstrainSelectedInstOperands,
     /*  874321 */     // GIR_Coverage, 8108,
     /*  874321 */     GIR_EraseRootFromParent_Done,
     /*  874322 */   // Label 13338: @874322
     /*  874322 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(874417), // Rule ID 8109 //
     /*  874327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  874338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  874341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  874350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  874353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874377 */     // MIs[1] Operand 1
     /*  874377 */     // No operand predicates
     /*  874377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  874390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  874393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874415 */     GIR_RootConstrainSelectedInstOperands,
     /*  874416 */     // GIR_Coverage, 8109,
     /*  874416 */     GIR_EraseRootFromParent_Done,
     /*  874417 */   // Label 13339: @874417
     /*  874417 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(874512), // Rule ID 8112 //
     /*  874422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  874433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  874436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  874445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  874448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874472 */     // MIs[1] Operand 1
     /*  874472 */     // No operand predicates
     /*  874472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874485 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  874485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  874488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874510 */     GIR_RootConstrainSelectedInstOperands,
     /*  874511 */     // GIR_Coverage, 8112,
     /*  874511 */     GIR_EraseRootFromParent_Done,
     /*  874512 */   // Label 13340: @874512
     /*  874512 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(874607), // Rule ID 8113 //
     /*  874517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  874528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  874531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  874540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  874543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874567 */     // MIs[1] Operand 1
     /*  874567 */     // No operand predicates
     /*  874567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  874580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  874583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874605 */     GIR_RootConstrainSelectedInstOperands,
     /*  874606 */     // GIR_Coverage, 8113,
     /*  874606 */     GIR_EraseRootFromParent_Done,
     /*  874607 */   // Label 13341: @874607
     /*  874607 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(874702), // Rule ID 8116 //
     /*  874612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  874623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  874626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  874635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  874638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874662 */     // MIs[1] Operand 1
     /*  874662 */     // No operand predicates
     /*  874662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  874675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  874678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874700 */     GIR_RootConstrainSelectedInstOperands,
     /*  874701 */     // GIR_Coverage, 8116,
     /*  874701 */     GIR_EraseRootFromParent_Done,
     /*  874702 */   // Label 13342: @874702
     /*  874702 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(874797), // Rule ID 8117 //
     /*  874707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  874718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  874721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  874730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  874733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874757 */     // MIs[1] Operand 1
     /*  874757 */     // No operand predicates
     /*  874757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  874770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  874773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874795 */     GIR_RootConstrainSelectedInstOperands,
     /*  874796 */     // GIR_Coverage, 8117,
     /*  874796 */     GIR_EraseRootFromParent_Done,
     /*  874797 */   // Label 13343: @874797
     /*  874797 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(874892), // Rule ID 8120 //
     /*  874802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  874813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  874816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  874825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  874828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874852 */     // MIs[1] Operand 1
     /*  874852 */     // No operand predicates
     /*  874852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874865 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  874865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  874868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874890 */     GIR_RootConstrainSelectedInstOperands,
     /*  874891 */     // GIR_Coverage, 8120,
     /*  874891 */     GIR_EraseRootFromParent_Done,
     /*  874892 */   // Label 13344: @874892
     /*  874892 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(874987), // Rule ID 8121 //
     /*  874897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  874905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  874908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  874911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  874920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  874923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  874939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  874943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  874947 */     // MIs[1] Operand 1
     /*  874947 */     // No operand predicates
     /*  874947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  874951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  874953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874960 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  874960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  874963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  874972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  874974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  874985 */     GIR_RootConstrainSelectedInstOperands,
     /*  874986 */     // GIR_Coverage, 8121,
     /*  874986 */     GIR_EraseRootFromParent_Done,
     /*  874987 */   // Label 13345: @874987
     /*  874987 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(875082), // Rule ID 8124 //
     /*  874992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  875003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  875006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  875015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875042 */     // MIs[1] Operand 1
     /*  875042 */     // No operand predicates
     /*  875042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875055 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  875055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  875058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875080 */     GIR_RootConstrainSelectedInstOperands,
     /*  875081 */     // GIR_Coverage, 8124,
     /*  875081 */     GIR_EraseRootFromParent_Done,
     /*  875082 */   // Label 13346: @875082
     /*  875082 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(875177), // Rule ID 8125 //
     /*  875087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  875098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  875101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  875107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  875110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  875113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875137 */     // MIs[1] Operand 1
     /*  875137 */     // No operand predicates
     /*  875137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  875150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  875153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875175 */     GIR_RootConstrainSelectedInstOperands,
     /*  875176 */     // GIR_Coverage, 8125,
     /*  875176 */     GIR_EraseRootFromParent_Done,
     /*  875177 */   // Label 13347: @875177
     /*  875177 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(875272), // Rule ID 8128 //
     /*  875182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  875193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  875196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  875205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875232 */     // MIs[1] Operand 1
     /*  875232 */     // No operand predicates
     /*  875232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875245 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  875245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  875248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875270 */     GIR_RootConstrainSelectedInstOperands,
     /*  875271 */     // GIR_Coverage, 8128,
     /*  875271 */     GIR_EraseRootFromParent_Done,
     /*  875272 */   // Label 13348: @875272
     /*  875272 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(875367), // Rule ID 8129 //
     /*  875277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  875288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  875291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  875297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  875300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  875303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875327 */     // MIs[1] Operand 1
     /*  875327 */     // No operand predicates
     /*  875327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  875340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  875343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875365 */     GIR_RootConstrainSelectedInstOperands,
     /*  875366 */     // GIR_Coverage, 8129,
     /*  875366 */     GIR_EraseRootFromParent_Done,
     /*  875367 */   // Label 13349: @875367
     /*  875367 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(875462), // Rule ID 8132 //
     /*  875372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  875383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  875386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  875389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  875395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875422 */     // MIs[1] Operand 1
     /*  875422 */     // No operand predicates
     /*  875422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  875435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  875438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875460 */     GIR_RootConstrainSelectedInstOperands,
     /*  875461 */     // GIR_Coverage, 8132,
     /*  875461 */     GIR_EraseRootFromParent_Done,
     /*  875462 */   // Label 13350: @875462
     /*  875462 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(875557), // Rule ID 8133 //
     /*  875467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  875478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  875481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  875484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  875487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  875490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  875493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875517 */     // MIs[1] Operand 1
     /*  875517 */     // No operand predicates
     /*  875517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  875530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  875533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875555 */     GIR_RootConstrainSelectedInstOperands,
     /*  875556 */     // GIR_Coverage, 8133,
     /*  875556 */     GIR_EraseRootFromParent_Done,
     /*  875557 */   // Label 13351: @875557
     /*  875557 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(875652), // Rule ID 8136 //
     /*  875562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  875573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  875576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  875579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  875585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875612 */     // MIs[1] Operand 1
     /*  875612 */     // No operand predicates
     /*  875612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875625 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  875625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  875628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875650 */     GIR_RootConstrainSelectedInstOperands,
     /*  875651 */     // GIR_Coverage, 8136,
     /*  875651 */     GIR_EraseRootFromParent_Done,
     /*  875652 */   // Label 13352: @875652
     /*  875652 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(875747), // Rule ID 8137 //
     /*  875657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  875668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  875671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  875674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  875677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  875680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  875683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875707 */     // MIs[1] Operand 1
     /*  875707 */     // No operand predicates
     /*  875707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  875720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  875723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875745 */     GIR_RootConstrainSelectedInstOperands,
     /*  875746 */     // GIR_Coverage, 8137,
     /*  875746 */     GIR_EraseRootFromParent_Done,
     /*  875747 */   // Label 13353: @875747
     /*  875747 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(875842), // Rule ID 8140 //
     /*  875752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  875763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  875766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  875775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875802 */     // MIs[1] Operand 1
     /*  875802 */     // No operand predicates
     /*  875802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875815 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  875815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  875818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875840 */     GIR_RootConstrainSelectedInstOperands,
     /*  875841 */     // GIR_Coverage, 8140,
     /*  875841 */     GIR_EraseRootFromParent_Done,
     /*  875842 */   // Label 13354: @875842
     /*  875842 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(875937), // Rule ID 8141 //
     /*  875847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  875858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  875861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  875867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  875870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  875873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875897 */     // MIs[1] Operand 1
     /*  875897 */     // No operand predicates
     /*  875897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875910 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  875910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  875913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  875922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  875924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  875935 */     GIR_RootConstrainSelectedInstOperands,
     /*  875936 */     // GIR_Coverage, 8141,
     /*  875936 */     GIR_EraseRootFromParent_Done,
     /*  875937 */   // Label 13355: @875937
     /*  875937 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(876032), // Rule ID 8144 //
     /*  875942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  875950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  875953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  875956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  875962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  875965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  875968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  875984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  875988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  875992 */     // MIs[1] Operand 1
     /*  875992 */     // No operand predicates
     /*  875992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  875996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  875998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876005 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  876005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  876008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876030 */     GIR_RootConstrainSelectedInstOperands,
     /*  876031 */     // GIR_Coverage, 8144,
     /*  876031 */     GIR_EraseRootFromParent_Done,
     /*  876032 */   // Label 13356: @876032
     /*  876032 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(876127), // Rule ID 8145 //
     /*  876037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  876048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  876051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  876054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  876057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  876060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  876063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876087 */     // MIs[1] Operand 1
     /*  876087 */     // No operand predicates
     /*  876087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  876100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  876103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876125 */     GIR_RootConstrainSelectedInstOperands,
     /*  876126 */     // GIR_Coverage, 8145,
     /*  876126 */     GIR_EraseRootFromParent_Done,
     /*  876127 */   // Label 13357: @876127
     /*  876127 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(876222), // Rule ID 8148 //
     /*  876132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  876143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  876146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  876149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  876152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  876155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  876158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876182 */     // MIs[1] Operand 1
     /*  876182 */     // No operand predicates
     /*  876182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  876195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  876198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876220 */     GIR_RootConstrainSelectedInstOperands,
     /*  876221 */     // GIR_Coverage, 8148,
     /*  876221 */     GIR_EraseRootFromParent_Done,
     /*  876222 */   // Label 13358: @876222
     /*  876222 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(876317), // Rule ID 8149 //
     /*  876227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  876238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  876241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  876244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  876247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  876250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  876253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876277 */     // MIs[1] Operand 1
     /*  876277 */     // No operand predicates
     /*  876277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876290 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  876290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  876293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876315 */     GIR_RootConstrainSelectedInstOperands,
     /*  876316 */     // GIR_Coverage, 8149,
     /*  876316 */     GIR_EraseRootFromParent_Done,
     /*  876317 */   // Label 13359: @876317
     /*  876317 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(876412), // Rule ID 8152 //
     /*  876322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  876333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  876336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  876339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  876342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  876345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  876348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876372 */     // MIs[1] Operand 1
     /*  876372 */     // No operand predicates
     /*  876372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876385 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  876385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  876388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876410 */     GIR_RootConstrainSelectedInstOperands,
     /*  876411 */     // GIR_Coverage, 8152,
     /*  876411 */     GIR_EraseRootFromParent_Done,
     /*  876412 */   // Label 13360: @876412
     /*  876412 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(876507), // Rule ID 8153 //
     /*  876417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  876428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  876431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  876434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  876437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  876440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  876443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876467 */     // MIs[1] Operand 1
     /*  876467 */     // No operand predicates
     /*  876467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876480 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  876480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  876483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876505 */     GIR_RootConstrainSelectedInstOperands,
     /*  876506 */     // GIR_Coverage, 8153,
     /*  876506 */     GIR_EraseRootFromParent_Done,
     /*  876507 */   // Label 13361: @876507
     /*  876507 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(876602), // Rule ID 8156 //
     /*  876512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  876523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  876526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  876529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  876532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  876535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  876538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876562 */     // MIs[1] Operand 1
     /*  876562 */     // No operand predicates
     /*  876562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876575 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  876575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  876578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876600 */     GIR_RootConstrainSelectedInstOperands,
     /*  876601 */     // GIR_Coverage, 8156,
     /*  876601 */     GIR_EraseRootFromParent_Done,
     /*  876602 */   // Label 13362: @876602
     /*  876602 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(876697), // Rule ID 8157 //
     /*  876607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  876618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  876621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  876624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  876627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  876630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  876633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876657 */     // MIs[1] Operand 1
     /*  876657 */     // No operand predicates
     /*  876657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  876670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  876673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876695 */     GIR_RootConstrainSelectedInstOperands,
     /*  876696 */     // GIR_Coverage, 8157,
     /*  876696 */     GIR_EraseRootFromParent_Done,
     /*  876697 */   // Label 13363: @876697
     /*  876697 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(876792), // Rule ID 8160 //
     /*  876702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  876713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  876716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  876722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  876725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  876728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876752 */     // MIs[1] Operand 1
     /*  876752 */     // No operand predicates
     /*  876752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876765 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  876765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  876768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876790 */     GIR_RootConstrainSelectedInstOperands,
     /*  876791 */     // GIR_Coverage, 8160,
     /*  876791 */     GIR_EraseRootFromParent_Done,
     /*  876792 */   // Label 13364: @876792
     /*  876792 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(876887), // Rule ID 8161 //
     /*  876797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  876808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  876811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  876817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  876820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  876823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876847 */     // MIs[1] Operand 1
     /*  876847 */     // No operand predicates
     /*  876847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876860 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  876860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  876863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876885 */     GIR_RootConstrainSelectedInstOperands,
     /*  876886 */     // GIR_Coverage, 8161,
     /*  876886 */     GIR_EraseRootFromParent_Done,
     /*  876887 */   // Label 13365: @876887
     /*  876887 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(876982), // Rule ID 8164 //
     /*  876892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  876903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  876906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  876912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  876915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  876918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  876934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  876938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  876942 */     // MIs[1] Operand 1
     /*  876942 */     // No operand predicates
     /*  876942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  876946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  876948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  876955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  876958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  876967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  876969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  876980 */     GIR_RootConstrainSelectedInstOperands,
     /*  876981 */     // GIR_Coverage, 8164,
     /*  876981 */     GIR_EraseRootFromParent_Done,
     /*  876982 */   // Label 13366: @876982
     /*  876982 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(877077), // Rule ID 8165 //
     /*  876987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  876995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  876998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  877001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  877004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  877010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877037 */     // MIs[1] Operand 1
     /*  877037 */     // No operand predicates
     /*  877037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  877050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  877053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877075 */     GIR_RootConstrainSelectedInstOperands,
     /*  877076 */     // GIR_Coverage, 8165,
     /*  877076 */     GIR_EraseRootFromParent_Done,
     /*  877077 */   // Label 13367: @877077
     /*  877077 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(877172), // Rule ID 8168 //
     /*  877082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  877093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  877096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  877102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  877105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  877108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877132 */     // MIs[1] Operand 1
     /*  877132 */     // No operand predicates
     /*  877132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877145 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  877145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  877148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877170 */     GIR_RootConstrainSelectedInstOperands,
     /*  877171 */     // GIR_Coverage, 8168,
     /*  877171 */     GIR_EraseRootFromParent_Done,
     /*  877172 */   // Label 13368: @877172
     /*  877172 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(877267), // Rule ID 8169 //
     /*  877177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  877188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  877191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  877200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877227 */     // MIs[1] Operand 1
     /*  877227 */     // No operand predicates
     /*  877227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877240 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  877240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  877243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877265 */     GIR_RootConstrainSelectedInstOperands,
     /*  877266 */     // GIR_Coverage, 8169,
     /*  877266 */     GIR_EraseRootFromParent_Done,
     /*  877267 */   // Label 13369: @877267
     /*  877267 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(877362), // Rule ID 8172 //
     /*  877272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  877283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  877286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  877289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  877292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  877295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  877298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877322 */     // MIs[1] Operand 1
     /*  877322 */     // No operand predicates
     /*  877322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877335 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  877335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  877338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877360 */     GIR_RootConstrainSelectedInstOperands,
     /*  877361 */     // GIR_Coverage, 8172,
     /*  877361 */     GIR_EraseRootFromParent_Done,
     /*  877362 */   // Label 13370: @877362
     /*  877362 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(877457), // Rule ID 8173 //
     /*  877367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  877378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  877381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  877384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  877390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877417 */     // MIs[1] Operand 1
     /*  877417 */     // No operand predicates
     /*  877417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  877430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  877433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877455 */     GIR_RootConstrainSelectedInstOperands,
     /*  877456 */     // GIR_Coverage, 8173,
     /*  877456 */     GIR_EraseRootFromParent_Done,
     /*  877457 */   // Label 13371: @877457
     /*  877457 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(877552), // Rule ID 8176 //
     /*  877462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  877473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  877476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  877479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  877482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  877485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  877488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877512 */     // MIs[1] Operand 1
     /*  877512 */     // No operand predicates
     /*  877512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  877525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  877528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877550 */     GIR_RootConstrainSelectedInstOperands,
     /*  877551 */     // GIR_Coverage, 8176,
     /*  877551 */     GIR_EraseRootFromParent_Done,
     /*  877552 */   // Label 13372: @877552
     /*  877552 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(877647), // Rule ID 8177 //
     /*  877557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  877565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  877568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  877571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  877574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  877580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877607 */     // MIs[1] Operand 1
     /*  877607 */     // No operand predicates
     /*  877607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  877620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  877623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877645 */     GIR_RootConstrainSelectedInstOperands,
     /*  877646 */     // GIR_Coverage, 8177,
     /*  877646 */     GIR_EraseRootFromParent_Done,
     /*  877647 */   // Label 13373: @877647
     /*  877647 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(877742), // Rule ID 8708 //
     /*  877652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  877660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  877663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  877666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  877669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  877672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  877675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  877678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877702 */     // MIs[1] Operand 1
     /*  877702 */     // No operand predicates
     /*  877702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877715 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  877715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  877718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877740 */     GIR_RootConstrainSelectedInstOperands,
     /*  877741 */     // GIR_Coverage, 8708,
     /*  877741 */     GIR_EraseRootFromParent_Done,
     /*  877742 */   // Label 13374: @877742
     /*  877742 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(877837), // Rule ID 8709 //
     /*  877747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  877755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  877758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  877761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  877764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  877770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877797 */     // MIs[1] Operand 1
     /*  877797 */     // No operand predicates
     /*  877797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  877810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  877813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877835 */     GIR_RootConstrainSelectedInstOperands,
     /*  877836 */     // GIR_Coverage, 8709,
     /*  877836 */     GIR_EraseRootFromParent_Done,
     /*  877837 */   // Label 13375: @877837
     /*  877837 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(877932), // Rule ID 8712 //
     /*  877842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  877850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  877853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  877856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  877859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  877862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  877865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  877868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877892 */     // MIs[1] Operand 1
     /*  877892 */     // No operand predicates
     /*  877892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877905 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  877905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  877908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  877917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  877919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  877930 */     GIR_RootConstrainSelectedInstOperands,
     /*  877931 */     // GIR_Coverage, 8712,
     /*  877931 */     GIR_EraseRootFromParent_Done,
     /*  877932 */   // Label 13376: @877932
     /*  877932 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(878027), // Rule ID 8713 //
     /*  877937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  877945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  877948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  877951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  877954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  877957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  877960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  877963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  877979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  877983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  877987 */     // MIs[1] Operand 1
     /*  877987 */     // No operand predicates
     /*  877987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  877991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  877993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  878000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  878003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878025 */     GIR_RootConstrainSelectedInstOperands,
     /*  878026 */     // GIR_Coverage, 8713,
     /*  878026 */     GIR_EraseRootFromParent_Done,
     /*  878027 */   // Label 13377: @878027
     /*  878027 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(878122), // Rule ID 8716 //
     /*  878032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  878043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  878046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  878052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  878055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  878058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878082 */     // MIs[1] Operand 1
     /*  878082 */     // No operand predicates
     /*  878082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878095 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  878095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878120 */     GIR_RootConstrainSelectedInstOperands,
     /*  878121 */     // GIR_Coverage, 8716,
     /*  878121 */     GIR_EraseRootFromParent_Done,
     /*  878122 */   // Label 13378: @878122
     /*  878122 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(878217), // Rule ID 8717 //
     /*  878127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  878138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  878141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  878147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  878150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  878153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878177 */     // MIs[1] Operand 1
     /*  878177 */     // No operand predicates
     /*  878177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  878190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878215 */     GIR_RootConstrainSelectedInstOperands,
     /*  878216 */     // GIR_Coverage, 8717,
     /*  878216 */     GIR_EraseRootFromParent_Done,
     /*  878217 */   // Label 13379: @878217
     /*  878217 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(878312), // Rule ID 8720 //
     /*  878222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  878233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  878236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  878239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  878242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  878245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  878248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878272 */     // MIs[1] Operand 1
     /*  878272 */     // No operand predicates
     /*  878272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  878285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  878288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878310 */     GIR_RootConstrainSelectedInstOperands,
     /*  878311 */     // GIR_Coverage, 8720,
     /*  878311 */     GIR_EraseRootFromParent_Done,
     /*  878312 */   // Label 13380: @878312
     /*  878312 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(878407), // Rule ID 8721 //
     /*  878317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  878328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  878331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  878334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  878337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  878340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  878343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878367 */     // MIs[1] Operand 1
     /*  878367 */     // No operand predicates
     /*  878367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  878380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  878383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878405 */     GIR_RootConstrainSelectedInstOperands,
     /*  878406 */     // GIR_Coverage, 8721,
     /*  878406 */     GIR_EraseRootFromParent_Done,
     /*  878407 */   // Label 13381: @878407
     /*  878407 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(878502), // Rule ID 8724 //
     /*  878412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  878423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  878426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  878429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  878432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  878435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  878438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878462 */     // MIs[1] Operand 1
     /*  878462 */     // No operand predicates
     /*  878462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878475 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  878475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878500 */     GIR_RootConstrainSelectedInstOperands,
     /*  878501 */     // GIR_Coverage, 8724,
     /*  878501 */     GIR_EraseRootFromParent_Done,
     /*  878502 */   // Label 13382: @878502
     /*  878502 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(878597), // Rule ID 8725 //
     /*  878507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  878518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  878521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  878524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  878527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  878530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  878533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878557 */     // MIs[1] Operand 1
     /*  878557 */     // No operand predicates
     /*  878557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  878570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878595 */     GIR_RootConstrainSelectedInstOperands,
     /*  878596 */     // GIR_Coverage, 8725,
     /*  878596 */     GIR_EraseRootFromParent_Done,
     /*  878597 */   // Label 13383: @878597
     /*  878597 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(878692), // Rule ID 8728 //
     /*  878602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  878613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  878616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  878622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  878625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  878628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878652 */     // MIs[1] Operand 1
     /*  878652 */     // No operand predicates
     /*  878652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  878665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878690 */     GIR_RootConstrainSelectedInstOperands,
     /*  878691 */     // GIR_Coverage, 8728,
     /*  878691 */     GIR_EraseRootFromParent_Done,
     /*  878692 */   // Label 13384: @878692
     /*  878692 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(878787), // Rule ID 8729 //
     /*  878697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  878708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  878711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  878717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  878720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  878723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878747 */     // MIs[1] Operand 1
     /*  878747 */     // No operand predicates
     /*  878747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  878760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  878763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878785 */     GIR_RootConstrainSelectedInstOperands,
     /*  878786 */     // GIR_Coverage, 8729,
     /*  878786 */     GIR_EraseRootFromParent_Done,
     /*  878787 */   // Label 13385: @878787
     /*  878787 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(878882), // Rule ID 8732 //
     /*  878792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  878803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  878806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  878812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  878815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  878818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878842 */     // MIs[1] Operand 1
     /*  878842 */     // No operand predicates
     /*  878842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  878855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  878858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878880 */     GIR_RootConstrainSelectedInstOperands,
     /*  878881 */     // GIR_Coverage, 8732,
     /*  878881 */     GIR_EraseRootFromParent_Done,
     /*  878882 */   // Label 13386: @878882
     /*  878882 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(878977), // Rule ID 8733 //
     /*  878887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  878898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  878901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  878907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  878910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  878913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  878929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  878933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  878937 */     // MIs[1] Operand 1
     /*  878937 */     // No operand predicates
     /*  878937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  878941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  878943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  878950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  878953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  878962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  878964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  878975 */     GIR_RootConstrainSelectedInstOperands,
     /*  878976 */     // GIR_Coverage, 8733,
     /*  878976 */     GIR_EraseRootFromParent_Done,
     /*  878977 */   // Label 13387: @878977
     /*  878977 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(879072), // Rule ID 8736 //
     /*  878982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  878990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  878993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  878996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  878999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  879005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879032 */     // MIs[1] Operand 1
     /*  879032 */     // No operand predicates
     /*  879032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879045 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  879045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879070 */     GIR_RootConstrainSelectedInstOperands,
     /*  879071 */     // GIR_Coverage, 8736,
     /*  879071 */     GIR_EraseRootFromParent_Done,
     /*  879072 */   // Label 13388: @879072
     /*  879072 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(879167), // Rule ID 8737 //
     /*  879077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  879088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  879091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  879097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  879100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  879103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879127 */     // MIs[1] Operand 1
     /*  879127 */     // No operand predicates
     /*  879127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  879140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879165 */     GIR_RootConstrainSelectedInstOperands,
     /*  879166 */     // GIR_Coverage, 8737,
     /*  879166 */     GIR_EraseRootFromParent_Done,
     /*  879167 */   // Label 13389: @879167
     /*  879167 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(879262), // Rule ID 8740 //
     /*  879172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  879183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  879186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  879189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  879195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879222 */     // MIs[1] Operand 1
     /*  879222 */     // No operand predicates
     /*  879222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879235 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  879235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879260 */     GIR_RootConstrainSelectedInstOperands,
     /*  879261 */     // GIR_Coverage, 8740,
     /*  879261 */     GIR_EraseRootFromParent_Done,
     /*  879262 */   // Label 13390: @879262
     /*  879262 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(879357), // Rule ID 8741 //
     /*  879267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  879278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  879281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  879284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  879287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  879290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  879293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879317 */     // MIs[1] Operand 1
     /*  879317 */     // No operand predicates
     /*  879317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  879330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879355 */     GIR_RootConstrainSelectedInstOperands,
     /*  879356 */     // GIR_Coverage, 8741,
     /*  879356 */     GIR_EraseRootFromParent_Done,
     /*  879357 */   // Label 13391: @879357
     /*  879357 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(879452), // Rule ID 8744 //
     /*  879362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  879373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  879376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  879379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  879385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879412 */     // MIs[1] Operand 1
     /*  879412 */     // No operand predicates
     /*  879412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879425 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  879425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879450 */     GIR_RootConstrainSelectedInstOperands,
     /*  879451 */     // GIR_Coverage, 8744,
     /*  879451 */     GIR_EraseRootFromParent_Done,
     /*  879452 */   // Label 13392: @879452
     /*  879452 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(879547), // Rule ID 8745 //
     /*  879457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  879468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  879471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  879474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  879477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  879480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  879483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879507 */     // MIs[1] Operand 1
     /*  879507 */     // No operand predicates
     /*  879507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  879520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  879523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879545 */     GIR_RootConstrainSelectedInstOperands,
     /*  879546 */     // GIR_Coverage, 8745,
     /*  879546 */     GIR_EraseRootFromParent_Done,
     /*  879547 */   // Label 13393: @879547
     /*  879547 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(879642), // Rule ID 8748 //
     /*  879552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  879563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  879566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  879575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879602 */     // MIs[1] Operand 1
     /*  879602 */     // No operand predicates
     /*  879602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879615 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  879615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  879618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879640 */     GIR_RootConstrainSelectedInstOperands,
     /*  879641 */     // GIR_Coverage, 8748,
     /*  879641 */     GIR_EraseRootFromParent_Done,
     /*  879642 */   // Label 13394: @879642
     /*  879642 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(879737), // Rule ID 8749 //
     /*  879647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  879658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  879661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  879667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  879670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  879673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879697 */     // MIs[1] Operand 1
     /*  879697 */     // No operand predicates
     /*  879697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  879710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  879713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879735 */     GIR_RootConstrainSelectedInstOperands,
     /*  879736 */     // GIR_Coverage, 8749,
     /*  879736 */     GIR_EraseRootFromParent_Done,
     /*  879737 */   // Label 13395: @879737
     /*  879737 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(879832), // Rule ID 8752 //
     /*  879742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  879753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  879756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  879765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879792 */     // MIs[1] Operand 1
     /*  879792 */     // No operand predicates
     /*  879792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  879805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  879808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879830 */     GIR_RootConstrainSelectedInstOperands,
     /*  879831 */     // GIR_Coverage, 8752,
     /*  879831 */     GIR_EraseRootFromParent_Done,
     /*  879832 */   // Label 13396: @879832
     /*  879832 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(879927), // Rule ID 8753 //
     /*  879837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  879848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  879851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  879857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  879860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  879863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879887 */     // MIs[1] Operand 1
     /*  879887 */     // No operand predicates
     /*  879887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879900 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  879900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  879903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  879912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  879914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  879925 */     GIR_RootConstrainSelectedInstOperands,
     /*  879926 */     // GIR_Coverage, 8753,
     /*  879926 */     GIR_EraseRootFromParent_Done,
     /*  879927 */   // Label 13397: @879927
     /*  879927 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(880022), // Rule ID 8756 //
     /*  879932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  879940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  879943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  879946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  879949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  879952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  879955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  879958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  879974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  879978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  879982 */     // MIs[1] Operand 1
     /*  879982 */     // No operand predicates
     /*  879982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  879986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  879988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879995 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  879995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  879998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880020 */     GIR_RootConstrainSelectedInstOperands,
     /*  880021 */     // GIR_Coverage, 8756,
     /*  880021 */     GIR_EraseRootFromParent_Done,
     /*  880022 */   // Label 13398: @880022
     /*  880022 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(880117), // Rule ID 8757 //
     /*  880027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  880038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  880041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  880044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  880050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  880053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880077 */     // MIs[1] Operand 1
     /*  880077 */     // No operand predicates
     /*  880077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880090 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  880090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  880093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880115 */     GIR_RootConstrainSelectedInstOperands,
     /*  880116 */     // GIR_Coverage, 8757,
     /*  880116 */     GIR_EraseRootFromParent_Done,
     /*  880117 */   // Label 13399: @880117
     /*  880117 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(880212), // Rule ID 8760 //
     /*  880122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  880125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  880133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  880136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  880145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  880148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880172 */     // MIs[1] Operand 1
     /*  880172 */     // No operand predicates
     /*  880172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  880185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  880188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880210 */     GIR_RootConstrainSelectedInstOperands,
     /*  880211 */     // GIR_Coverage, 8760,
     /*  880211 */     GIR_EraseRootFromParent_Done,
     /*  880212 */   // Label 13400: @880212
     /*  880212 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(880307), // Rule ID 8761 //
     /*  880217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  880228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  880231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  880240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  880243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880267 */     // MIs[1] Operand 1
     /*  880267 */     // No operand predicates
     /*  880267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  880280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  880283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880305 */     GIR_RootConstrainSelectedInstOperands,
     /*  880306 */     // GIR_Coverage, 8761,
     /*  880306 */     GIR_EraseRootFromParent_Done,
     /*  880307 */   // Label 13401: @880307
     /*  880307 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(880402), // Rule ID 8764 //
     /*  880312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  880315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  880323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  880326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  880335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  880338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880362 */     // MIs[1] Operand 1
     /*  880362 */     // No operand predicates
     /*  880362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880375 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  880375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  880378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880400 */     GIR_RootConstrainSelectedInstOperands,
     /*  880401 */     // GIR_Coverage, 8764,
     /*  880401 */     GIR_EraseRootFromParent_Done,
     /*  880402 */   // Label 13402: @880402
     /*  880402 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(880497), // Rule ID 8765 //
     /*  880407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  880418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  880421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  880430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  880433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880457 */     // MIs[1] Operand 1
     /*  880457 */     // No operand predicates
     /*  880457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  880470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  880473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880495 */     GIR_RootConstrainSelectedInstOperands,
     /*  880496 */     // GIR_Coverage, 8765,
     /*  880496 */     GIR_EraseRootFromParent_Done,
     /*  880497 */   // Label 13403: @880497
     /*  880497 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(880592), // Rule ID 8768 //
     /*  880502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  880505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  880513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  880516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  880519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  880525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  880528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880552 */     // MIs[1] Operand 1
     /*  880552 */     // No operand predicates
     /*  880552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880565 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  880565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  880568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880590 */     GIR_RootConstrainSelectedInstOperands,
     /*  880591 */     // GIR_Coverage, 8768,
     /*  880591 */     GIR_EraseRootFromParent_Done,
     /*  880592 */   // Label 13404: @880592
     /*  880592 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(880687), // Rule ID 8769 //
     /*  880597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  880608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  880611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  880614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  880620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  880623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880647 */     // MIs[1] Operand 1
     /*  880647 */     // No operand predicates
     /*  880647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880660 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  880660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  880663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880685 */     GIR_RootConstrainSelectedInstOperands,
     /*  880686 */     // GIR_Coverage, 8769,
     /*  880686 */     GIR_EraseRootFromParent_Done,
     /*  880687 */   // Label 13405: @880687
     /*  880687 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(880782), // Rule ID 8772 //
     /*  880692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  880695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  880703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  880706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  880715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  880718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880742 */     // MIs[1] Operand 1
     /*  880742 */     // No operand predicates
     /*  880742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880755 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  880755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  880758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880780 */     GIR_RootConstrainSelectedInstOperands,
     /*  880781 */     // GIR_Coverage, 8772,
     /*  880781 */     GIR_EraseRootFromParent_Done,
     /*  880782 */   // Label 13406: @880782
     /*  880782 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(880877), // Rule ID 8773 //
     /*  880787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  880798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  880801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  880810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  880813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880837 */     // MIs[1] Operand 1
     /*  880837 */     // No operand predicates
     /*  880837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  880850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  880853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880875 */     GIR_RootConstrainSelectedInstOperands,
     /*  880876 */     // GIR_Coverage, 8773,
     /*  880876 */     GIR_EraseRootFromParent_Done,
     /*  880877 */   // Label 13407: @880877
     /*  880877 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(880972), // Rule ID 8776 //
     /*  880882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  880885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  880893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  880896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  880905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  880908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  880924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  880928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  880932 */     // MIs[1] Operand 1
     /*  880932 */     // No operand predicates
     /*  880932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  880936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  880938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880945 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  880945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  880948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  880957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  880959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  880970 */     GIR_RootConstrainSelectedInstOperands,
     /*  880971 */     // GIR_Coverage, 8776,
     /*  880971 */     GIR_EraseRootFromParent_Done,
     /*  880972 */   // Label 13408: @880972
     /*  880972 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(881067), // Rule ID 8777 //
     /*  880977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  880980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  880985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  880988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  880991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  881000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881027 */     // MIs[1] Operand 1
     /*  881027 */     // No operand predicates
     /*  881027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  881040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  881043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881065 */     GIR_RootConstrainSelectedInstOperands,
     /*  881066 */     // GIR_Coverage, 8777,
     /*  881066 */     GIR_EraseRootFromParent_Done,
     /*  881067 */   // Label 13409: @881067
     /*  881067 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(881162), // Rule ID 8780 //
     /*  881072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  881075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  881083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  881086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  881089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  881095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  881098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881122 */     // MIs[1] Operand 1
     /*  881122 */     // No operand predicates
     /*  881122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  881135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  881138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881160 */     GIR_RootConstrainSelectedInstOperands,
     /*  881161 */     // GIR_Coverage, 8780,
     /*  881161 */     GIR_EraseRootFromParent_Done,
     /*  881162 */   // Label 13410: @881162
     /*  881162 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(881257), // Rule ID 8781 //
     /*  881167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  881170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  881178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  881181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  881184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  881190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881217 */     // MIs[1] Operand 1
     /*  881217 */     // No operand predicates
     /*  881217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  881230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  881233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881255 */     GIR_RootConstrainSelectedInstOperands,
     /*  881256 */     // GIR_Coverage, 8781,
     /*  881256 */     GIR_EraseRootFromParent_Done,
     /*  881257 */   // Label 13411: @881257
     /*  881257 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(881352), // Rule ID 8784 //
     /*  881262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  881265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  881273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  881276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  881279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  881285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  881288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881312 */     // MIs[1] Operand 1
     /*  881312 */     // No operand predicates
     /*  881312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881325 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  881325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  881328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881350 */     GIR_RootConstrainSelectedInstOperands,
     /*  881351 */     // GIR_Coverage, 8784,
     /*  881351 */     GIR_EraseRootFromParent_Done,
     /*  881352 */   // Label 13412: @881352
     /*  881352 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(881447), // Rule ID 8785 //
     /*  881357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  881360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  881368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  881371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  881374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  881380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881407 */     // MIs[1] Operand 1
     /*  881407 */     // No operand predicates
     /*  881407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  881420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  881423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881445 */     GIR_RootConstrainSelectedInstOperands,
     /*  881446 */     // GIR_Coverage, 8785,
     /*  881446 */     GIR_EraseRootFromParent_Done,
     /*  881447 */   // Label 13413: @881447
     /*  881447 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(881542), // Rule ID 8788 //
     /*  881452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  881455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  881463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  881466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  881469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  881475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  881478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881502 */     // MIs[1] Operand 1
     /*  881502 */     // No operand predicates
     /*  881502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881515 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  881515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  881518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881540 */     GIR_RootConstrainSelectedInstOperands,
     /*  881541 */     // GIR_Coverage, 8788,
     /*  881541 */     GIR_EraseRootFromParent_Done,
     /*  881542 */   // Label 13414: @881542
     /*  881542 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(881637), // Rule ID 8789 //
     /*  881547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  881550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  881558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  881561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  881564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  881570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881597 */     // MIs[1] Operand 1
     /*  881597 */     // No operand predicates
     /*  881597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  881610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  881613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881635 */     GIR_RootConstrainSelectedInstOperands,
     /*  881636 */     // GIR_Coverage, 8789,
     /*  881636 */     GIR_EraseRootFromParent_Done,
     /*  881637 */   // Label 13415: @881637
     /*  881637 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(881732), // Rule ID 8792 //
     /*  881642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  881645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  881653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  881656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  881665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  881668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881692 */     // MIs[1] Operand 1
     /*  881692 */     // No operand predicates
     /*  881692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881705 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  881705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  881708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881730 */     GIR_RootConstrainSelectedInstOperands,
     /*  881731 */     // GIR_Coverage, 8792,
     /*  881731 */     GIR_EraseRootFromParent_Done,
     /*  881732 */   // Label 13416: @881732
     /*  881732 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(881827), // Rule ID 8793 //
     /*  881737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  881740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  881745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  881748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  881751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  881760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881787 */     // MIs[1] Operand 1
     /*  881787 */     // No operand predicates
     /*  881787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  881800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  881803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881825 */     GIR_RootConstrainSelectedInstOperands,
     /*  881826 */     // GIR_Coverage, 8793,
     /*  881826 */     GIR_EraseRootFromParent_Done,
     /*  881827 */   // Label 13417: @881827
     /*  881827 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(881922), // Rule ID 8972 //
     /*  881832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  881835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  881840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  881843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  881846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  881855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  881858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881882 */     // MIs[1] Operand 1
     /*  881882 */     // No operand predicates
     /*  881882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  881895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  881898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  881907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  881909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  881920 */     GIR_RootConstrainSelectedInstOperands,
     /*  881921 */     // GIR_Coverage, 8972,
     /*  881921 */     GIR_EraseRootFromParent_Done,
     /*  881922 */   // Label 13418: @881922
     /*  881922 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(882017), // Rule ID 8973 //
     /*  881927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  881930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  881935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  881938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  881941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  881950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  881953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  881969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  881973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  881977 */     // MIs[1] Operand 1
     /*  881977 */     // No operand predicates
     /*  881977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  881981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  881983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  881990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  881993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882015 */     GIR_RootConstrainSelectedInstOperands,
     /*  882016 */     // GIR_Coverage, 8973,
     /*  882016 */     GIR_EraseRootFromParent_Done,
     /*  882017 */   // Label 13419: @882017
     /*  882017 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(882112), // Rule ID 8976 //
     /*  882022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  882033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  882036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  882045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882072 */     // MIs[1] Operand 1
     /*  882072 */     // No operand predicates
     /*  882072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882085 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  882085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  882088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882110 */     GIR_RootConstrainSelectedInstOperands,
     /*  882111 */     // GIR_Coverage, 8976,
     /*  882111 */     GIR_EraseRootFromParent_Done,
     /*  882112 */   // Label 13420: @882112
     /*  882112 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(882207), // Rule ID 8977 //
     /*  882117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  882120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  882128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  882131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  882140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  882143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882167 */     // MIs[1] Operand 1
     /*  882167 */     // No operand predicates
     /*  882167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  882180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  882183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882205 */     GIR_RootConstrainSelectedInstOperands,
     /*  882206 */     // GIR_Coverage, 8977,
     /*  882206 */     GIR_EraseRootFromParent_Done,
     /*  882207 */   // Label 13421: @882207
     /*  882207 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(882302), // Rule ID 8980 //
     /*  882212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  882223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  882226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  882235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882262 */     // MIs[1] Operand 1
     /*  882262 */     // No operand predicates
     /*  882262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  882275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882300 */     GIR_RootConstrainSelectedInstOperands,
     /*  882301 */     // GIR_Coverage, 8980,
     /*  882301 */     GIR_EraseRootFromParent_Done,
     /*  882302 */   // Label 13422: @882302
     /*  882302 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(882397), // Rule ID 8981 //
     /*  882307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  882310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  882318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  882321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  882330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  882333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882357 */     // MIs[1] Operand 1
     /*  882357 */     // No operand predicates
     /*  882357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  882370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882395 */     GIR_RootConstrainSelectedInstOperands,
     /*  882396 */     // GIR_Coverage, 8981,
     /*  882396 */     GIR_EraseRootFromParent_Done,
     /*  882397 */   // Label 13423: @882397
     /*  882397 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(882492), // Rule ID 8984 //
     /*  882402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  882413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  882416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  882419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  882425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882452 */     // MIs[1] Operand 1
     /*  882452 */     // No operand predicates
     /*  882452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  882465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  882468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882490 */     GIR_RootConstrainSelectedInstOperands,
     /*  882491 */     // GIR_Coverage, 8984,
     /*  882491 */     GIR_EraseRootFromParent_Done,
     /*  882492 */   // Label 13424: @882492
     /*  882492 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(882587), // Rule ID 8985 //
     /*  882497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  882500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  882508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  882511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  882514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  882520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  882523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882547 */     // MIs[1] Operand 1
     /*  882547 */     // No operand predicates
     /*  882547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  882560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  882563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882585 */     GIR_RootConstrainSelectedInstOperands,
     /*  882586 */     // GIR_Coverage, 8985,
     /*  882586 */     GIR_EraseRootFromParent_Done,
     /*  882587 */   // Label 13425: @882587
     /*  882587 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(882682), // Rule ID 8988 //
     /*  882592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  882603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  882606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  882615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882642 */     // MIs[1] Operand 1
     /*  882642 */     // No operand predicates
     /*  882642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882655 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  882655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882680 */     GIR_RootConstrainSelectedInstOperands,
     /*  882681 */     // GIR_Coverage, 8988,
     /*  882681 */     GIR_EraseRootFromParent_Done,
     /*  882682 */   // Label 13426: @882682
     /*  882682 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(882777), // Rule ID 8989 //
     /*  882687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  882690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  882698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  882701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  882710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  882713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882737 */     // MIs[1] Operand 1
     /*  882737 */     // No operand predicates
     /*  882737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  882750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882775 */     GIR_RootConstrainSelectedInstOperands,
     /*  882776 */     // GIR_Coverage, 8989,
     /*  882776 */     GIR_EraseRootFromParent_Done,
     /*  882777 */   // Label 13427: @882777
     /*  882777 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(882872), // Rule ID 8992 //
     /*  882782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  882793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  882796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  882805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882832 */     // MIs[1] Operand 1
     /*  882832 */     // No operand predicates
     /*  882832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882845 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  882845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882870 */     GIR_RootConstrainSelectedInstOperands,
     /*  882871 */     // GIR_Coverage, 8992,
     /*  882871 */     GIR_EraseRootFromParent_Done,
     /*  882872 */   // Label 13428: @882872
     /*  882872 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(882967), // Rule ID 8993 //
     /*  882877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  882880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  882888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  882891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  882900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  882903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  882919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  882923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  882927 */     // MIs[1] Operand 1
     /*  882927 */     // No operand predicates
     /*  882927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  882931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  882933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  882940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  882943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  882952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  882954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  882965 */     GIR_RootConstrainSelectedInstOperands,
     /*  882966 */     // GIR_Coverage, 8993,
     /*  882966 */     GIR_EraseRootFromParent_Done,
     /*  882967 */   // Label 13429: @882967
     /*  882967 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(883062), // Rule ID 8996 //
     /*  882972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  882975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  882980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  882983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  882986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  882989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  882995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  882998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883022 */     // MIs[1] Operand 1
     /*  883022 */     // No operand predicates
     /*  883022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883035 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  883035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883060 */     GIR_RootConstrainSelectedInstOperands,
     /*  883061 */     // GIR_Coverage, 8996,
     /*  883061 */     GIR_EraseRootFromParent_Done,
     /*  883062 */   // Label 13430: @883062
     /*  883062 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(883157), // Rule ID 8997 //
     /*  883067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  883070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  883078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  883081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  883084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  883090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  883093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883117 */     // MIs[1] Operand 1
     /*  883117 */     // No operand predicates
     /*  883117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  883130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883155 */     GIR_RootConstrainSelectedInstOperands,
     /*  883156 */     // GIR_Coverage, 8997,
     /*  883156 */     GIR_EraseRootFromParent_Done,
     /*  883157 */   // Label 13431: @883157
     /*  883157 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(883252), // Rule ID 9000 //
     /*  883162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  883165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  883173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  883176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  883185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  883188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883212 */     // MIs[1] Operand 1
     /*  883212 */     // No operand predicates
     /*  883212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  883225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883250 */     GIR_RootConstrainSelectedInstOperands,
     /*  883251 */     // GIR_Coverage, 9000,
     /*  883251 */     GIR_EraseRootFromParent_Done,
     /*  883252 */   // Label 13432: @883252
     /*  883252 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(883347), // Rule ID 9001 //
     /*  883257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  883260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  883268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  883271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  883280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  883283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883307 */     // MIs[1] Operand 1
     /*  883307 */     // No operand predicates
     /*  883307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  883320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883345 */     GIR_RootConstrainSelectedInstOperands,
     /*  883346 */     // GIR_Coverage, 9001,
     /*  883346 */     GIR_EraseRootFromParent_Done,
     /*  883347 */   // Label 13433: @883347
     /*  883347 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(883442), // Rule ID 9004 //
     /*  883352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  883355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  883363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  883366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  883369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  883375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  883378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883402 */     // MIs[1] Operand 1
     /*  883402 */     // No operand predicates
     /*  883402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883415 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  883415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883440 */     GIR_RootConstrainSelectedInstOperands,
     /*  883441 */     // GIR_Coverage, 9004,
     /*  883441 */     GIR_EraseRootFromParent_Done,
     /*  883442 */   // Label 13434: @883442
     /*  883442 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(883537), // Rule ID 9005 //
     /*  883447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  883450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  883458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  883461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  883464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  883470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  883473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883497 */     // MIs[1] Operand 1
     /*  883497 */     // No operand predicates
     /*  883497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  883510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883535 */     GIR_RootConstrainSelectedInstOperands,
     /*  883536 */     // GIR_Coverage, 9005,
     /*  883536 */     GIR_EraseRootFromParent_Done,
     /*  883537 */   // Label 13435: @883537
     /*  883537 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(883632), // Rule ID 9008 //
     /*  883542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  883545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  883553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  883556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  883565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  883568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883592 */     // MIs[1] Operand 1
     /*  883592 */     // No operand predicates
     /*  883592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  883605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883630 */     GIR_RootConstrainSelectedInstOperands,
     /*  883631 */     // GIR_Coverage, 9008,
     /*  883631 */     GIR_EraseRootFromParent_Done,
     /*  883632 */   // Label 13436: @883632
     /*  883632 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(883727), // Rule ID 9009 //
     /*  883637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  883640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  883648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  883651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  883660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  883663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883687 */     // MIs[1] Operand 1
     /*  883687 */     // No operand predicates
     /*  883687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  883700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  883703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883725 */     GIR_RootConstrainSelectedInstOperands,
     /*  883726 */     // GIR_Coverage, 9009,
     /*  883726 */     GIR_EraseRootFromParent_Done,
     /*  883727 */   // Label 13437: @883727
     /*  883727 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(883822), // Rule ID 9012 //
     /*  883732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  883735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  883743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  883746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  883749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  883755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  883758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883782 */     // MIs[1] Operand 1
     /*  883782 */     // No operand predicates
     /*  883782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  883795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  883798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883820 */     GIR_RootConstrainSelectedInstOperands,
     /*  883821 */     // GIR_Coverage, 9012,
     /*  883821 */     GIR_EraseRootFromParent_Done,
     /*  883822 */   // Label 13438: @883822
     /*  883822 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(883917), // Rule ID 9013 //
     /*  883827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  883830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  883838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  883841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  883844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  883850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  883853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883877 */     // MIs[1] Operand 1
     /*  883877 */     // No operand predicates
     /*  883877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883890 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  883890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  883893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  883915 */     GIR_RootConstrainSelectedInstOperands,
     /*  883916 */     // GIR_Coverage, 9013,
     /*  883916 */     GIR_EraseRootFromParent_Done,
     /*  883917 */   // Label 13439: @883917
     /*  883917 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(884012), // Rule ID 9016 //
     /*  883922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  883925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  883930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  883933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  883936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  883939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  883945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  883948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  883964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  883972 */     // MIs[1] Operand 1
     /*  883972 */     // No operand predicates
     /*  883972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  883976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  883978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883985 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  883985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  883988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  883997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  883999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884010 */     GIR_RootConstrainSelectedInstOperands,
     /*  884011 */     // GIR_Coverage, 9016,
     /*  884011 */     GIR_EraseRootFromParent_Done,
     /*  884012 */   // Label 13440: @884012
     /*  884012 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(884107), // Rule ID 9017 //
     /*  884017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  884028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  884031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  884034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  884040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884067 */     // MIs[1] Operand 1
     /*  884067 */     // No operand predicates
     /*  884067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  884080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  884083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884105 */     GIR_RootConstrainSelectedInstOperands,
     /*  884106 */     // GIR_Coverage, 9017,
     /*  884106 */     GIR_EraseRootFromParent_Done,
     /*  884107 */   // Label 13441: @884107
     /*  884107 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(884202), // Rule ID 9020 //
     /*  884112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  884115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  884123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  884126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  884129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  884135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  884138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884162 */     // MIs[1] Operand 1
     /*  884162 */     // No operand predicates
     /*  884162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884175 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  884175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  884178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884200 */     GIR_RootConstrainSelectedInstOperands,
     /*  884201 */     // GIR_Coverage, 9020,
     /*  884201 */     GIR_EraseRootFromParent_Done,
     /*  884202 */   // Label 13442: @884202
     /*  884202 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(884297), // Rule ID 9021 //
     /*  884207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  884218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  884221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  884224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  884230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884257 */     // MIs[1] Operand 1
     /*  884257 */     // No operand predicates
     /*  884257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884270 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  884270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  884273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884295 */     GIR_RootConstrainSelectedInstOperands,
     /*  884296 */     // GIR_Coverage, 9021,
     /*  884296 */     GIR_EraseRootFromParent_Done,
     /*  884297 */   // Label 13443: @884297
     /*  884297 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(884392), // Rule ID 9024 //
     /*  884302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  884305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  884313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  884316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  884319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  884325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  884328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884352 */     // MIs[1] Operand 1
     /*  884352 */     // No operand predicates
     /*  884352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884365 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  884365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  884368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884390 */     GIR_RootConstrainSelectedInstOperands,
     /*  884391 */     // GIR_Coverage, 9024,
     /*  884391 */     GIR_EraseRootFromParent_Done,
     /*  884392 */   // Label 13444: @884392
     /*  884392 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(884487), // Rule ID 9025 //
     /*  884397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  884408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  884411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  884414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  884420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884447 */     // MIs[1] Operand 1
     /*  884447 */     // No operand predicates
     /*  884447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  884460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  884463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884485 */     GIR_RootConstrainSelectedInstOperands,
     /*  884486 */     // GIR_Coverage, 9025,
     /*  884486 */     GIR_EraseRootFromParent_Done,
     /*  884487 */   // Label 13445: @884487
     /*  884487 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(884582), // Rule ID 9028 //
     /*  884492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  884495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  884503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  884506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  884509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  884515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  884518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884542 */     // MIs[1] Operand 1
     /*  884542 */     // No operand predicates
     /*  884542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884555 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  884555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  884558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884580 */     GIR_RootConstrainSelectedInstOperands,
     /*  884581 */     // GIR_Coverage, 9028,
     /*  884581 */     GIR_EraseRootFromParent_Done,
     /*  884582 */   // Label 13446: @884582
     /*  884582 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(884677), // Rule ID 9029 //
     /*  884587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  884598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  884601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  884604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  884610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884637 */     // MIs[1] Operand 1
     /*  884637 */     // No operand predicates
     /*  884637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  884650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  884653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884675 */     GIR_RootConstrainSelectedInstOperands,
     /*  884676 */     // GIR_Coverage, 9029,
     /*  884676 */     GIR_EraseRootFromParent_Done,
     /*  884677 */   // Label 13447: @884677
     /*  884677 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(884772), // Rule ID 9032 //
     /*  884682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  884685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  884693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  884696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  884699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  884705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  884708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884732 */     // MIs[1] Operand 1
     /*  884732 */     // No operand predicates
     /*  884732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884745 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  884745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  884748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884770 */     GIR_RootConstrainSelectedInstOperands,
     /*  884771 */     // GIR_Coverage, 9032,
     /*  884771 */     GIR_EraseRootFromParent_Done,
     /*  884772 */   // Label 13448: @884772
     /*  884772 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(884867), // Rule ID 9033 //
     /*  884777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  884788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  884791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  884794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  884800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884827 */     // MIs[1] Operand 1
     /*  884827 */     // No operand predicates
     /*  884827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  884840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  884843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  884862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884865 */     GIR_RootConstrainSelectedInstOperands,
     /*  884866 */     // GIR_Coverage, 9033,
     /*  884866 */     GIR_EraseRootFromParent_Done,
     /*  884867 */   // Label 13449: @884867
     /*  884867 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(884962), // Rule ID 9036 //
     /*  884872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  884875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  884883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  884886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  884895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  884898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  884914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  884918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  884922 */     // MIs[1] Operand 1
     /*  884922 */     // No operand predicates
     /*  884922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  884926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  884928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884935 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  884935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  884938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  884947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  884949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  884960 */     GIR_RootConstrainSelectedInstOperands,
     /*  884961 */     // GIR_Coverage, 9036,
     /*  884961 */     GIR_EraseRootFromParent_Done,
     /*  884962 */   // Label 13450: @884962
     /*  884962 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(885057), // Rule ID 9037 //
     /*  884967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  884970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  884975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  884978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  884981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  884990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  884993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885017 */     // MIs[1] Operand 1
     /*  885017 */     // No operand predicates
     /*  885017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  885030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  885033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885055 */     GIR_RootConstrainSelectedInstOperands,
     /*  885056 */     // GIR_Coverage, 9037,
     /*  885056 */     GIR_EraseRootFromParent_Done,
     /*  885057 */   // Label 13451: @885057
     /*  885057 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(885152), // Rule ID 9040 //
     /*  885062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  885065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  885073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  885076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  885079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  885085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  885088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885112 */     // MIs[1] Operand 1
     /*  885112 */     // No operand predicates
     /*  885112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  885125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  885128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885150 */     GIR_RootConstrainSelectedInstOperands,
     /*  885151 */     // GIR_Coverage, 9040,
     /*  885151 */     GIR_EraseRootFromParent_Done,
     /*  885152 */   // Label 13452: @885152
     /*  885152 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(885247), // Rule ID 9041 //
     /*  885157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  885160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  885168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  885171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  885174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  885180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  885183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885207 */     // MIs[1] Operand 1
     /*  885207 */     // No operand predicates
     /*  885207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  885220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  885223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885245 */     GIR_RootConstrainSelectedInstOperands,
     /*  885246 */     // GIR_Coverage, 9041,
     /*  885246 */     GIR_EraseRootFromParent_Done,
     /*  885247 */   // Label 13453: @885247
     /*  885247 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(885342), // Rule ID 9044 //
     /*  885252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  885255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  885263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  885266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  885269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  885275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  885278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885302 */     // MIs[1] Operand 1
     /*  885302 */     // No operand predicates
     /*  885302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  885315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  885318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885340 */     GIR_RootConstrainSelectedInstOperands,
     /*  885341 */     // GIR_Coverage, 9044,
     /*  885341 */     GIR_EraseRootFromParent_Done,
     /*  885342 */   // Label 13454: @885342
     /*  885342 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(885437), // Rule ID 9045 //
     /*  885347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  885350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  885358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  885361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  885364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  885370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  885373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885397 */     // MIs[1] Operand 1
     /*  885397 */     // No operand predicates
     /*  885397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  885410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  885413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885435 */     GIR_RootConstrainSelectedInstOperands,
     /*  885436 */     // GIR_Coverage, 9045,
     /*  885436 */     GIR_EraseRootFromParent_Done,
     /*  885437 */   // Label 13455: @885437
     /*  885437 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(885532), // Rule ID 9048 //
     /*  885442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  885445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  885453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  885456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  885465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  885468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885492 */     // MIs[1] Operand 1
     /*  885492 */     // No operand predicates
     /*  885492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885505 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  885505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  885508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885530 */     GIR_RootConstrainSelectedInstOperands,
     /*  885531 */     // GIR_Coverage, 9048,
     /*  885531 */     GIR_EraseRootFromParent_Done,
     /*  885532 */   // Label 13456: @885532
     /*  885532 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(885627), // Rule ID 9049 //
     /*  885537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  885540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  885548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  885551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  885560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  885563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885587 */     // MIs[1] Operand 1
     /*  885587 */     // No operand predicates
     /*  885587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  885600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  885603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885625 */     GIR_RootConstrainSelectedInstOperands,
     /*  885626 */     // GIR_Coverage, 9049,
     /*  885626 */     GIR_EraseRootFromParent_Done,
     /*  885627 */   // Label 13457: @885627
     /*  885627 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(885722), // Rule ID 9052 //
     /*  885632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  885635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  885643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  885646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  885655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  885658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885682 */     // MIs[1] Operand 1
     /*  885682 */     // No operand predicates
     /*  885682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885695 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  885695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  885698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885720 */     GIR_RootConstrainSelectedInstOperands,
     /*  885721 */     // GIR_Coverage, 9052,
     /*  885721 */     GIR_EraseRootFromParent_Done,
     /*  885722 */   // Label 13458: @885722
     /*  885722 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(885817), // Rule ID 9053 //
     /*  885727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  885730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  885738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  885741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  885750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  885753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885777 */     // MIs[1] Operand 1
     /*  885777 */     // No operand predicates
     /*  885777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885790 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  885790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  885793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885815 */     GIR_RootConstrainSelectedInstOperands,
     /*  885816 */     // GIR_Coverage, 9053,
     /*  885816 */     GIR_EraseRootFromParent_Done,
     /*  885817 */   // Label 13459: @885817
     /*  885817 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(885912), // Rule ID 9056 //
     /*  885822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  885825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  885833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  885836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  885845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  885848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885872 */     // MIs[1] Operand 1
     /*  885872 */     // No operand predicates
     /*  885872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885885 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  885885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  885888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  885910 */     GIR_RootConstrainSelectedInstOperands,
     /*  885911 */     // GIR_Coverage, 9056,
     /*  885911 */     GIR_EraseRootFromParent_Done,
     /*  885912 */   // Label 13460: @885912
     /*  885912 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(886007), // Rule ID 9057 //
     /*  885917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  885920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  885925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  885928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  885931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  885940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  885943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  885959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  885963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  885967 */     // MIs[1] Operand 1
     /*  885967 */     // No operand predicates
     /*  885967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  885971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  885980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  885983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  885992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  885994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886005 */     GIR_RootConstrainSelectedInstOperands,
     /*  886006 */     // GIR_Coverage, 9057,
     /*  886006 */     GIR_EraseRootFromParent_Done,
     /*  886007 */   // Label 13461: @886007
     /*  886007 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(886102), // Rule ID 9148 //
     /*  886012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  886023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  886026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  886029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  886035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886062 */     // MIs[1] Operand 1
     /*  886062 */     // No operand predicates
     /*  886062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  886075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  886078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886100 */     GIR_RootConstrainSelectedInstOperands,
     /*  886101 */     // GIR_Coverage, 9148,
     /*  886101 */     GIR_EraseRootFromParent_Done,
     /*  886102 */   // Label 13462: @886102
     /*  886102 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(886197), // Rule ID 9149 //
     /*  886107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  886110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  886118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  886121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  886124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  886130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  886133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886157 */     // MIs[1] Operand 1
     /*  886157 */     // No operand predicates
     /*  886157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  886170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  886173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886195 */     GIR_RootConstrainSelectedInstOperands,
     /*  886196 */     // GIR_Coverage, 9149,
     /*  886196 */     GIR_EraseRootFromParent_Done,
     /*  886197 */   // Label 13463: @886197
     /*  886197 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(886292), // Rule ID 9152 //
     /*  886202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  886213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  886216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  886219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  886225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886252 */     // MIs[1] Operand 1
     /*  886252 */     // No operand predicates
     /*  886252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886265 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  886265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  886268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886290 */     GIR_RootConstrainSelectedInstOperands,
     /*  886291 */     // GIR_Coverage, 9152,
     /*  886291 */     GIR_EraseRootFromParent_Done,
     /*  886292 */   // Label 13464: @886292
     /*  886292 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(886387), // Rule ID 9153 //
     /*  886297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  886300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  886308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  886311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  886314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  886320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  886323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886347 */     // MIs[1] Operand 1
     /*  886347 */     // No operand predicates
     /*  886347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  886360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  886363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886385 */     GIR_RootConstrainSelectedInstOperands,
     /*  886386 */     // GIR_Coverage, 9153,
     /*  886386 */     GIR_EraseRootFromParent_Done,
     /*  886387 */   // Label 13465: @886387
     /*  886387 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(886482), // Rule ID 9156 //
     /*  886392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  886403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  886406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  886415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886442 */     // MIs[1] Operand 1
     /*  886442 */     // No operand predicates
     /*  886442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886455 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  886455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  886458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886480 */     GIR_RootConstrainSelectedInstOperands,
     /*  886481 */     // GIR_Coverage, 9156,
     /*  886481 */     GIR_EraseRootFromParent_Done,
     /*  886482 */   // Label 13466: @886482
     /*  886482 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(886577), // Rule ID 9157 //
     /*  886487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  886490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  886498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  886501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  886510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  886513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886537 */     // MIs[1] Operand 1
     /*  886537 */     // No operand predicates
     /*  886537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  886550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  886553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886575 */     GIR_RootConstrainSelectedInstOperands,
     /*  886576 */     // GIR_Coverage, 9157,
     /*  886576 */     GIR_EraseRootFromParent_Done,
     /*  886577 */   // Label 13467: @886577
     /*  886577 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(886672), // Rule ID 9160 //
     /*  886582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  886593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  886596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  886605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886632 */     // MIs[1] Operand 1
     /*  886632 */     // No operand predicates
     /*  886632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886645 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  886645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  886648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886670 */     GIR_RootConstrainSelectedInstOperands,
     /*  886671 */     // GIR_Coverage, 9160,
     /*  886671 */     GIR_EraseRootFromParent_Done,
     /*  886672 */   // Label 13468: @886672
     /*  886672 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(886767), // Rule ID 9161 //
     /*  886677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  886680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  886688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  886691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  886700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  886703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886727 */     // MIs[1] Operand 1
     /*  886727 */     // No operand predicates
     /*  886727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  886740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  886743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886765 */     GIR_RootConstrainSelectedInstOperands,
     /*  886766 */     // GIR_Coverage, 9161,
     /*  886766 */     GIR_EraseRootFromParent_Done,
     /*  886767 */   // Label 13469: @886767
     /*  886767 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(886862), // Rule ID 9164 //
     /*  886772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  886783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  886786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  886795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886822 */     // MIs[1] Operand 1
     /*  886822 */     // No operand predicates
     /*  886822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  886835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  886838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886860 */     GIR_RootConstrainSelectedInstOperands,
     /*  886861 */     // GIR_Coverage, 9164,
     /*  886861 */     GIR_EraseRootFromParent_Done,
     /*  886862 */   // Label 13470: @886862
     /*  886862 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(886957), // Rule ID 9165 //
     /*  886867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  886870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  886878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  886881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  886890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  886893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  886909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  886913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  886917 */     // MIs[1] Operand 1
     /*  886917 */     // No operand predicates
     /*  886917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  886921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  886923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886930 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  886930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  886933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  886942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  886944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  886955 */     GIR_RootConstrainSelectedInstOperands,
     /*  886956 */     // GIR_Coverage, 9165,
     /*  886956 */     GIR_EraseRootFromParent_Done,
     /*  886957 */   // Label 13471: @886957
     /*  886957 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(887052), // Rule ID 9168 //
     /*  886962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  886965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  886970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  886973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  886976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  886985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  886988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887012 */     // MIs[1] Operand 1
     /*  887012 */     // No operand predicates
     /*  887012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887025 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  887025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  887028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887050 */     GIR_RootConstrainSelectedInstOperands,
     /*  887051 */     // GIR_Coverage, 9168,
     /*  887051 */     GIR_EraseRootFromParent_Done,
     /*  887052 */   // Label 13472: @887052
     /*  887052 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(887147), // Rule ID 9169 //
     /*  887057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  887060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  887068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  887071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  887074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  887080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  887083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887107 */     // MIs[1] Operand 1
     /*  887107 */     // No operand predicates
     /*  887107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  887120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  887123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887145 */     GIR_RootConstrainSelectedInstOperands,
     /*  887146 */     // GIR_Coverage, 9169,
     /*  887146 */     GIR_EraseRootFromParent_Done,
     /*  887147 */   // Label 13473: @887147
     /*  887147 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(887242), // Rule ID 9172 //
     /*  887152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  887155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  887163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  887166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  887169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  887175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  887178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887202 */     // MIs[1] Operand 1
     /*  887202 */     // No operand predicates
     /*  887202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887215 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  887215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887240 */     GIR_RootConstrainSelectedInstOperands,
     /*  887241 */     // GIR_Coverage, 9172,
     /*  887241 */     GIR_EraseRootFromParent_Done,
     /*  887242 */   // Label 13474: @887242
     /*  887242 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(887337), // Rule ID 9173 //
     /*  887247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  887250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  887258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  887261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  887264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  887270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  887273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887297 */     // MIs[1] Operand 1
     /*  887297 */     // No operand predicates
     /*  887297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  887310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887335 */     GIR_RootConstrainSelectedInstOperands,
     /*  887336 */     // GIR_Coverage, 9173,
     /*  887336 */     GIR_EraseRootFromParent_Done,
     /*  887337 */   // Label 13475: @887337
     /*  887337 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(887432), // Rule ID 9176 //
     /*  887342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  887345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  887353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  887356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  887359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  887365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  887368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887392 */     // MIs[1] Operand 1
     /*  887392 */     // No operand predicates
     /*  887392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887405 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  887405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887430 */     GIR_RootConstrainSelectedInstOperands,
     /*  887431 */     // GIR_Coverage, 9176,
     /*  887431 */     GIR_EraseRootFromParent_Done,
     /*  887432 */   // Label 13476: @887432
     /*  887432 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(887527), // Rule ID 9177 //
     /*  887437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  887440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  887448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  887451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  887454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  887460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  887463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887487 */     // MIs[1] Operand 1
     /*  887487 */     // No operand predicates
     /*  887487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  887500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887525 */     GIR_RootConstrainSelectedInstOperands,
     /*  887526 */     // GIR_Coverage, 9177,
     /*  887526 */     GIR_EraseRootFromParent_Done,
     /*  887527 */   // Label 13477: @887527
     /*  887527 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(887622), // Rule ID 9180 //
     /*  887532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  887535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  887543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  887546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  887549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  887555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  887558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887582 */     // MIs[1] Operand 1
     /*  887582 */     // No operand predicates
     /*  887582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  887595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887620 */     GIR_RootConstrainSelectedInstOperands,
     /*  887621 */     // GIR_Coverage, 9180,
     /*  887621 */     GIR_EraseRootFromParent_Done,
     /*  887622 */   // Label 13478: @887622
     /*  887622 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(887717), // Rule ID 9181 //
     /*  887627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  887630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  887638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  887641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  887644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  887650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  887653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887677 */     // MIs[1] Operand 1
     /*  887677 */     // No operand predicates
     /*  887677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  887690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887715 */     GIR_RootConstrainSelectedInstOperands,
     /*  887716 */     // GIR_Coverage, 9181,
     /*  887716 */     GIR_EraseRootFromParent_Done,
     /*  887717 */   // Label 13479: @887717
     /*  887717 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(887812), // Rule ID 9184 //
     /*  887722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  887725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  887733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  887736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  887745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  887748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887772 */     // MIs[1] Operand 1
     /*  887772 */     // No operand predicates
     /*  887772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  887785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887810 */     GIR_RootConstrainSelectedInstOperands,
     /*  887811 */     // GIR_Coverage, 9184,
     /*  887811 */     GIR_EraseRootFromParent_Done,
     /*  887812 */   // Label 13480: @887812
     /*  887812 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(887907), // Rule ID 9185 //
     /*  887817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  887820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  887828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  887831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  887840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  887843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887867 */     // MIs[1] Operand 1
     /*  887867 */     // No operand predicates
     /*  887867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887880 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  887880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  887883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  887905 */     GIR_RootConstrainSelectedInstOperands,
     /*  887906 */     // GIR_Coverage, 9185,
     /*  887906 */     GIR_EraseRootFromParent_Done,
     /*  887907 */   // Label 13481: @887907
     /*  887907 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(888002), // Rule ID 9188 //
     /*  887912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  887915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  887920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  887923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  887926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  887929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  887935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  887938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  887954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  887958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  887962 */     // MIs[1] Operand 1
     /*  887962 */     // No operand predicates
     /*  887962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  887966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  887968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887975 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  887975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  887978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  887987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  887989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888000 */     GIR_RootConstrainSelectedInstOperands,
     /*  888001 */     // GIR_Coverage, 9188,
     /*  888001 */     GIR_EraseRootFromParent_Done,
     /*  888002 */   // Label 13482: @888002
     /*  888002 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(888097), // Rule ID 9189 //
     /*  888007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  888018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  888021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  888024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  888030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888057 */     // MIs[1] Operand 1
     /*  888057 */     // No operand predicates
     /*  888057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  888070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  888073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888095 */     GIR_RootConstrainSelectedInstOperands,
     /*  888096 */     // GIR_Coverage, 9189,
     /*  888096 */     GIR_EraseRootFromParent_Done,
     /*  888097 */   // Label 13483: @888097
     /*  888097 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(888192), // Rule ID 9192 //
     /*  888102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  888105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  888113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  888116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  888119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  888125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  888128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888152 */     // MIs[1] Operand 1
     /*  888152 */     // No operand predicates
     /*  888152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888165 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  888165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  888168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888190 */     GIR_RootConstrainSelectedInstOperands,
     /*  888191 */     // GIR_Coverage, 9192,
     /*  888191 */     GIR_EraseRootFromParent_Done,
     /*  888192 */   // Label 13484: @888192
     /*  888192 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(888287), // Rule ID 9193 //
     /*  888197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  888208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  888211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  888214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  888220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888247 */     // MIs[1] Operand 1
     /*  888247 */     // No operand predicates
     /*  888247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  888260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  888263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888285 */     GIR_RootConstrainSelectedInstOperands,
     /*  888286 */     // GIR_Coverage, 9193,
     /*  888286 */     GIR_EraseRootFromParent_Done,
     /*  888287 */   // Label 13485: @888287
     /*  888287 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(888382), // Rule ID 9196 //
     /*  888292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  888295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  888303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  888306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  888309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  888315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  888318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888342 */     // MIs[1] Operand 1
     /*  888342 */     // No operand predicates
     /*  888342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888355 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  888355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  888358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888380 */     GIR_RootConstrainSelectedInstOperands,
     /*  888381 */     // GIR_Coverage, 9196,
     /*  888381 */     GIR_EraseRootFromParent_Done,
     /*  888382 */   // Label 13486: @888382
     /*  888382 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(888477), // Rule ID 9197 //
     /*  888387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  888398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  888401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  888404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  888410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888437 */     // MIs[1] Operand 1
     /*  888437 */     // No operand predicates
     /*  888437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888450 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  888450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  888453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888475 */     GIR_RootConstrainSelectedInstOperands,
     /*  888476 */     // GIR_Coverage, 9197,
     /*  888476 */     GIR_EraseRootFromParent_Done,
     /*  888477 */   // Label 13487: @888477
     /*  888477 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(888572), // Rule ID 9200 //
     /*  888482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  888485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  888493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  888496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  888499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  888505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  888508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888532 */     // MIs[1] Operand 1
     /*  888532 */     // No operand predicates
     /*  888532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888545 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  888545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  888548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888570 */     GIR_RootConstrainSelectedInstOperands,
     /*  888571 */     // GIR_Coverage, 9200,
     /*  888571 */     GIR_EraseRootFromParent_Done,
     /*  888572 */   // Label 13488: @888572
     /*  888572 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(888667), // Rule ID 9201 //
     /*  888577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  888588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  888591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  888594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  888600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888627 */     // MIs[1] Operand 1
     /*  888627 */     // No operand predicates
     /*  888627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  888640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  888643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888665 */     GIR_RootConstrainSelectedInstOperands,
     /*  888666 */     // GIR_Coverage, 9201,
     /*  888666 */     GIR_EraseRootFromParent_Done,
     /*  888667 */   // Label 13489: @888667
     /*  888667 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(888762), // Rule ID 9204 //
     /*  888672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  888675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  888683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  888686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  888689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  888695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  888698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888722 */     // MIs[1] Operand 1
     /*  888722 */     // No operand predicates
     /*  888722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888735 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  888735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  888738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888760 */     GIR_RootConstrainSelectedInstOperands,
     /*  888761 */     // GIR_Coverage, 9204,
     /*  888761 */     GIR_EraseRootFromParent_Done,
     /*  888762 */   // Label 13490: @888762
     /*  888762 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(888857), // Rule ID 9205 //
     /*  888767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  888778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  888781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  888784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  888790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888817 */     // MIs[1] Operand 1
     /*  888817 */     // No operand predicates
     /*  888817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  888830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  888833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888855 */     GIR_RootConstrainSelectedInstOperands,
     /*  888856 */     // GIR_Coverage, 9205,
     /*  888856 */     GIR_EraseRootFromParent_Done,
     /*  888857 */   // Label 13491: @888857
     /*  888857 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(888952), // Rule ID 9208 //
     /*  888862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  888865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  888873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  888876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  888879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  888885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  888888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  888908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  888912 */     // MIs[1] Operand 1
     /*  888912 */     // No operand predicates
     /*  888912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  888916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  888918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888925 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  888925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  888928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  888937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  888939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  888950 */     GIR_RootConstrainSelectedInstOperands,
     /*  888951 */     // GIR_Coverage, 9208,
     /*  888951 */     GIR_EraseRootFromParent_Done,
     /*  888952 */   // Label 13492: @888952
     /*  888952 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(889047), // Rule ID 9209 //
     /*  888957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  888960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  888965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  888968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  888971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  888974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  888980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  888983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  888999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889007 */     // MIs[1] Operand 1
     /*  889007 */     // No operand predicates
     /*  889007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889020 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  889020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  889023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889045 */     GIR_RootConstrainSelectedInstOperands,
     /*  889046 */     // GIR_Coverage, 9209,
     /*  889046 */     GIR_EraseRootFromParent_Done,
     /*  889047 */   // Label 13493: @889047
     /*  889047 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(889142), // Rule ID 9212 //
     /*  889052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  889055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  889063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  889066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  889069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  889075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  889078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889102 */     // MIs[1] Operand 1
     /*  889102 */     // No operand predicates
     /*  889102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  889115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  889118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889140 */     GIR_RootConstrainSelectedInstOperands,
     /*  889141 */     // GIR_Coverage, 9212,
     /*  889141 */     GIR_EraseRootFromParent_Done,
     /*  889142 */   // Label 13494: @889142
     /*  889142 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(889237), // Rule ID 9213 //
     /*  889147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  889150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  889158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  889161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  889164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  889170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  889173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889197 */     // MIs[1] Operand 1
     /*  889197 */     // No operand predicates
     /*  889197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  889210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  889213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889235 */     GIR_RootConstrainSelectedInstOperands,
     /*  889236 */     // GIR_Coverage, 9213,
     /*  889236 */     GIR_EraseRootFromParent_Done,
     /*  889237 */   // Label 13495: @889237
     /*  889237 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(889332), // Rule ID 9216 //
     /*  889242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  889245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  889253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  889256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  889259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  889265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  889268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889292 */     // MIs[1] Operand 1
     /*  889292 */     // No operand predicates
     /*  889292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  889305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  889308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889330 */     GIR_RootConstrainSelectedInstOperands,
     /*  889331 */     // GIR_Coverage, 9216,
     /*  889331 */     GIR_EraseRootFromParent_Done,
     /*  889332 */   // Label 13496: @889332
     /*  889332 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(889427), // Rule ID 9217 //
     /*  889337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  889340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  889348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  889351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  889354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  889360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  889363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889387 */     // MIs[1] Operand 1
     /*  889387 */     // No operand predicates
     /*  889387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  889400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  889403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889425 */     GIR_RootConstrainSelectedInstOperands,
     /*  889426 */     // GIR_Coverage, 9217,
     /*  889426 */     GIR_EraseRootFromParent_Done,
     /*  889427 */   // Label 13497: @889427
     /*  889427 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(889522), // Rule ID 9220 //
     /*  889432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  889435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  889443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  889446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  889449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  889455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  889458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889482 */     // MIs[1] Operand 1
     /*  889482 */     // No operand predicates
     /*  889482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  889495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  889498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889520 */     GIR_RootConstrainSelectedInstOperands,
     /*  889521 */     // GIR_Coverage, 9220,
     /*  889521 */     GIR_EraseRootFromParent_Done,
     /*  889522 */   // Label 13498: @889522
     /*  889522 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(889617), // Rule ID 9221 //
     /*  889527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  889530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  889538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  889541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  889544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  889550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  889553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889577 */     // MIs[1] Operand 1
     /*  889577 */     // No operand predicates
     /*  889577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  889590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  889593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889615 */     GIR_RootConstrainSelectedInstOperands,
     /*  889616 */     // GIR_Coverage, 9221,
     /*  889616 */     GIR_EraseRootFromParent_Done,
     /*  889617 */   // Label 13499: @889617
     /*  889617 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(889712), // Rule ID 9224 //
     /*  889622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  889625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  889633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  889636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  889639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  889645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  889648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889672 */     // MIs[1] Operand 1
     /*  889672 */     // No operand predicates
     /*  889672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  889685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  889688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889710 */     GIR_RootConstrainSelectedInstOperands,
     /*  889711 */     // GIR_Coverage, 9224,
     /*  889711 */     GIR_EraseRootFromParent_Done,
     /*  889712 */   // Label 13500: @889712
     /*  889712 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(889807), // Rule ID 9225 //
     /*  889717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  889720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  889728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  889731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  889734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  889740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  889743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889767 */     // MIs[1] Operand 1
     /*  889767 */     // No operand predicates
     /*  889767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  889780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  889783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889805 */     GIR_RootConstrainSelectedInstOperands,
     /*  889806 */     // GIR_Coverage, 9225,
     /*  889806 */     GIR_EraseRootFromParent_Done,
     /*  889807 */   // Label 13501: @889807
     /*  889807 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(889902), // Rule ID 9228 //
     /*  889812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  889815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  889823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  889826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  889829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  889835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  889838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889862 */     // MIs[1] Operand 1
     /*  889862 */     // No operand predicates
     /*  889862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889875 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  889875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  889878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889900 */     GIR_RootConstrainSelectedInstOperands,
     /*  889901 */     // GIR_Coverage, 9228,
     /*  889901 */     GIR_EraseRootFromParent_Done,
     /*  889902 */   // Label 13502: @889902
     /*  889902 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(889997), // Rule ID 9229 //
     /*  889907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  889910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  889915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  889918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  889921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  889924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  889930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  889933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  889949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  889953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  889957 */     // MIs[1] Operand 1
     /*  889957 */     // No operand predicates
     /*  889957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  889961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  889963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  889970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  889973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  889982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  889984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  889995 */     GIR_RootConstrainSelectedInstOperands,
     /*  889996 */     // GIR_Coverage, 9229,
     /*  889996 */     GIR_EraseRootFromParent_Done,
     /*  889997 */   // Label 13503: @889997
     /*  889997 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(890092), // Rule ID 9232 //
     /*  890002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  890005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  890010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  890013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  890016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  890019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  890025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890052 */     // MIs[1] Operand 1
     /*  890052 */     // No operand predicates
     /*  890052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890065 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  890065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  890068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890090 */     GIR_RootConstrainSelectedInstOperands,
     /*  890091 */     // GIR_Coverage, 9232,
     /*  890091 */     GIR_EraseRootFromParent_Done,
     /*  890092 */   // Label 13504: @890092
     /*  890092 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(890187), // Rule ID 9233 //
     /*  890097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  890100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  890105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  890108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  890111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  890114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  890120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  890123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890147 */     // MIs[1] Operand 1
     /*  890147 */     // No operand predicates
     /*  890147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  890160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  890163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890185 */     GIR_RootConstrainSelectedInstOperands,
     /*  890186 */     // GIR_Coverage, 9233,
     /*  890186 */     GIR_EraseRootFromParent_Done,
     /*  890187 */   // Label 13505: @890187
     /*  890187 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(890282), // Rule ID 9324 //
     /*  890192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  890195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  890203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  890206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  890209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  890215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890242 */     // MIs[1] Operand 1
     /*  890242 */     // No operand predicates
     /*  890242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890255 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  890255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  890258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890280 */     GIR_RootConstrainSelectedInstOperands,
     /*  890281 */     // GIR_Coverage, 9324,
     /*  890281 */     GIR_EraseRootFromParent_Done,
     /*  890282 */   // Label 13506: @890282
     /*  890282 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(890377), // Rule ID 9325 //
     /*  890287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  890290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  890298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  890301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  890304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  890310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  890313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890337 */     // MIs[1] Operand 1
     /*  890337 */     // No operand predicates
     /*  890337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  890350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  890353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890375 */     GIR_RootConstrainSelectedInstOperands,
     /*  890376 */     // GIR_Coverage, 9325,
     /*  890376 */     GIR_EraseRootFromParent_Done,
     /*  890377 */   // Label 13507: @890377
     /*  890377 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(890472), // Rule ID 9328 //
     /*  890382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  890385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  890393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  890396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  890399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  890405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890432 */     // MIs[1] Operand 1
     /*  890432 */     // No operand predicates
     /*  890432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890445 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  890445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  890448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890470 */     GIR_RootConstrainSelectedInstOperands,
     /*  890471 */     // GIR_Coverage, 9328,
     /*  890471 */     GIR_EraseRootFromParent_Done,
     /*  890472 */   // Label 13508: @890472
     /*  890472 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(890567), // Rule ID 9329 //
     /*  890477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  890480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  890488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  890491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  890494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  890500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  890503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890527 */     // MIs[1] Operand 1
     /*  890527 */     // No operand predicates
     /*  890527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  890540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  890543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890565 */     GIR_RootConstrainSelectedInstOperands,
     /*  890566 */     // GIR_Coverage, 9329,
     /*  890566 */     GIR_EraseRootFromParent_Done,
     /*  890567 */   // Label 13509: @890567
     /*  890567 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(890662), // Rule ID 9332 //
     /*  890572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  890575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  890583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  890586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  890589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  890595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890622 */     // MIs[1] Operand 1
     /*  890622 */     // No operand predicates
     /*  890622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  890635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  890638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890660 */     GIR_RootConstrainSelectedInstOperands,
     /*  890661 */     // GIR_Coverage, 9332,
     /*  890661 */     GIR_EraseRootFromParent_Done,
     /*  890662 */   // Label 13510: @890662
     /*  890662 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(890757), // Rule ID 9333 //
     /*  890667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  890670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  890678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  890681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  890684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  890690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  890693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890717 */     // MIs[1] Operand 1
     /*  890717 */     // No operand predicates
     /*  890717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  890730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  890733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890755 */     GIR_RootConstrainSelectedInstOperands,
     /*  890756 */     // GIR_Coverage, 9333,
     /*  890756 */     GIR_EraseRootFromParent_Done,
     /*  890757 */   // Label 13511: @890757
     /*  890757 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(890852), // Rule ID 9336 //
     /*  890762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  890765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  890773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  890776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  890779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  890785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890812 */     // MIs[1] Operand 1
     /*  890812 */     // No operand predicates
     /*  890812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890825 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  890825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  890828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890850 */     GIR_RootConstrainSelectedInstOperands,
     /*  890851 */     // GIR_Coverage, 9336,
     /*  890851 */     GIR_EraseRootFromParent_Done,
     /*  890852 */   // Label 13512: @890852
     /*  890852 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(890947), // Rule ID 9337 //
     /*  890857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  890860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  890868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  890871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  890874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  890880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  890883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  890907 */     // MIs[1] Operand 1
     /*  890907 */     // No operand predicates
     /*  890907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  890911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  890913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  890920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  890923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  890932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  890934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  890945 */     GIR_RootConstrainSelectedInstOperands,
     /*  890946 */     // GIR_Coverage, 9337,
     /*  890946 */     GIR_EraseRootFromParent_Done,
     /*  890947 */   // Label 13513: @890947
     /*  890947 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(891042), // Rule ID 9340 //
     /*  890952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  890955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  890960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  890963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  890966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  890969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  890975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  890978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  890994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  890998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891002 */     // MIs[1] Operand 1
     /*  891002 */     // No operand predicates
     /*  891002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  891015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  891018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891040 */     GIR_RootConstrainSelectedInstOperands,
     /*  891041 */     // GIR_Coverage, 9340,
     /*  891041 */     GIR_EraseRootFromParent_Done,
     /*  891042 */   // Label 13514: @891042
     /*  891042 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(891137), // Rule ID 9341 //
     /*  891047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  891050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  891058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  891061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  891064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  891070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  891073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891097 */     // MIs[1] Operand 1
     /*  891097 */     // No operand predicates
     /*  891097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891110 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  891110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  891113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891135 */     GIR_RootConstrainSelectedInstOperands,
     /*  891136 */     // GIR_Coverage, 9341,
     /*  891136 */     GIR_EraseRootFromParent_Done,
     /*  891137 */   // Label 13515: @891137
     /*  891137 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(891232), // Rule ID 9344 //
     /*  891142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  891145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  891153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  891156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  891159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  891165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  891168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891192 */     // MIs[1] Operand 1
     /*  891192 */     // No operand predicates
     /*  891192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891205 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  891205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  891208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891230 */     GIR_RootConstrainSelectedInstOperands,
     /*  891231 */     // GIR_Coverage, 9344,
     /*  891231 */     GIR_EraseRootFromParent_Done,
     /*  891232 */   // Label 13516: @891232
     /*  891232 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(891327), // Rule ID 9345 //
     /*  891237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  891240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  891248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  891251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  891254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  891260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  891263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891287 */     // MIs[1] Operand 1
     /*  891287 */     // No operand predicates
     /*  891287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891300 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  891300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  891303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891325 */     GIR_RootConstrainSelectedInstOperands,
     /*  891326 */     // GIR_Coverage, 9345,
     /*  891326 */     GIR_EraseRootFromParent_Done,
     /*  891327 */   // Label 13517: @891327
     /*  891327 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(891422), // Rule ID 9348 //
     /*  891332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  891335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  891343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  891346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  891349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  891355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  891358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891382 */     // MIs[1] Operand 1
     /*  891382 */     // No operand predicates
     /*  891382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  891395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891420 */     GIR_RootConstrainSelectedInstOperands,
     /*  891421 */     // GIR_Coverage, 9348,
     /*  891421 */     GIR_EraseRootFromParent_Done,
     /*  891422 */   // Label 13518: @891422
     /*  891422 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(891517), // Rule ID 9349 //
     /*  891427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  891430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  891438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  891441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  891444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  891450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  891453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891477 */     // MIs[1] Operand 1
     /*  891477 */     // No operand predicates
     /*  891477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  891490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891515 */     GIR_RootConstrainSelectedInstOperands,
     /*  891516 */     // GIR_Coverage, 9349,
     /*  891516 */     GIR_EraseRootFromParent_Done,
     /*  891517 */   // Label 13519: @891517
     /*  891517 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(891612), // Rule ID 9352 //
     /*  891522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  891525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  891533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  891536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  891539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  891545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  891548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891572 */     // MIs[1] Operand 1
     /*  891572 */     // No operand predicates
     /*  891572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891585 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  891585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891610 */     GIR_RootConstrainSelectedInstOperands,
     /*  891611 */     // GIR_Coverage, 9352,
     /*  891611 */     GIR_EraseRootFromParent_Done,
     /*  891612 */   // Label 13520: @891612
     /*  891612 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(891707), // Rule ID 9353 //
     /*  891617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  891620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  891628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  891631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  891634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  891640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  891643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891667 */     // MIs[1] Operand 1
     /*  891667 */     // No operand predicates
     /*  891667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  891680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891705 */     GIR_RootConstrainSelectedInstOperands,
     /*  891706 */     // GIR_Coverage, 9353,
     /*  891706 */     GIR_EraseRootFromParent_Done,
     /*  891707 */   // Label 13521: @891707
     /*  891707 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(891802), // Rule ID 9356 //
     /*  891712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  891715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  891723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  891726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  891729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  891735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  891738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891762 */     // MIs[1] Operand 1
     /*  891762 */     // No operand predicates
     /*  891762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  891775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891800 */     GIR_RootConstrainSelectedInstOperands,
     /*  891801 */     // GIR_Coverage, 9356,
     /*  891801 */     GIR_EraseRootFromParent_Done,
     /*  891802 */   // Label 13522: @891802
     /*  891802 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(891897), // Rule ID 9357 //
     /*  891807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  891810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  891818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  891821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  891824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  891830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  891833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891857 */     // MIs[1] Operand 1
     /*  891857 */     // No operand predicates
     /*  891857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  891870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891895 */     GIR_RootConstrainSelectedInstOperands,
     /*  891896 */     // GIR_Coverage, 9357,
     /*  891896 */     GIR_EraseRootFromParent_Done,
     /*  891897 */   // Label 13523: @891897
     /*  891897 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(891992), // Rule ID 9360 //
     /*  891902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  891905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  891910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  891913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  891916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  891919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  891925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  891928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  891944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  891948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  891952 */     // MIs[1] Operand 1
     /*  891952 */     // No operand predicates
     /*  891952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  891956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  891958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  891965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  891968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  891977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  891979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  891990 */     GIR_RootConstrainSelectedInstOperands,
     /*  891991 */     // GIR_Coverage, 9360,
     /*  891991 */     GIR_EraseRootFromParent_Done,
     /*  891992 */   // Label 13524: @891992
     /*  891992 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(892087), // Rule ID 9361 //
     /*  891997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  892000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  892008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  892011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  892014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  892020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892047 */     // MIs[1] Operand 1
     /*  892047 */     // No operand predicates
     /*  892047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  892060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  892063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892085 */     GIR_RootConstrainSelectedInstOperands,
     /*  892086 */     // GIR_Coverage, 9361,
     /*  892086 */     GIR_EraseRootFromParent_Done,
     /*  892087 */   // Label 13525: @892087
     /*  892087 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(892182), // Rule ID 9364 //
     /*  892092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  892095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  892103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  892106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  892109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  892115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  892118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892142 */     // MIs[1] Operand 1
     /*  892142 */     // No operand predicates
     /*  892142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  892155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  892158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892180 */     GIR_RootConstrainSelectedInstOperands,
     /*  892181 */     // GIR_Coverage, 9364,
     /*  892181 */     GIR_EraseRootFromParent_Done,
     /*  892182 */   // Label 13526: @892182
     /*  892182 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(892277), // Rule ID 9365 //
     /*  892187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  892190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  892198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  892201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  892204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  892210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892237 */     // MIs[1] Operand 1
     /*  892237 */     // No operand predicates
     /*  892237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  892250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  892253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892275 */     GIR_RootConstrainSelectedInstOperands,
     /*  892276 */     // GIR_Coverage, 9365,
     /*  892276 */     GIR_EraseRootFromParent_Done,
     /*  892277 */   // Label 13527: @892277
     /*  892277 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(892372), // Rule ID 9368 //
     /*  892282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  892285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  892293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  892296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  892299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  892305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  892308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892332 */     // MIs[1] Operand 1
     /*  892332 */     // No operand predicates
     /*  892332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892345 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  892345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  892348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892370 */     GIR_RootConstrainSelectedInstOperands,
     /*  892371 */     // GIR_Coverage, 9368,
     /*  892371 */     GIR_EraseRootFromParent_Done,
     /*  892372 */   // Label 13528: @892372
     /*  892372 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(892467), // Rule ID 9369 //
     /*  892377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  892380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  892388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  892391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  892394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  892400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892427 */     // MIs[1] Operand 1
     /*  892427 */     // No operand predicates
     /*  892427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892440 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  892440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  892443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892465 */     GIR_RootConstrainSelectedInstOperands,
     /*  892466 */     // GIR_Coverage, 9369,
     /*  892466 */     GIR_EraseRootFromParent_Done,
     /*  892467 */   // Label 13529: @892467
     /*  892467 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(892562), // Rule ID 9372 //
     /*  892472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  892475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  892483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  892486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  892489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  892495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  892498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892522 */     // MIs[1] Operand 1
     /*  892522 */     // No operand predicates
     /*  892522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892535 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  892535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  892538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892560 */     GIR_RootConstrainSelectedInstOperands,
     /*  892561 */     // GIR_Coverage, 9372,
     /*  892561 */     GIR_EraseRootFromParent_Done,
     /*  892562 */   // Label 13530: @892562
     /*  892562 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(892657), // Rule ID 9373 //
     /*  892567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  892570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  892578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  892581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  892584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  892590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892617 */     // MIs[1] Operand 1
     /*  892617 */     // No operand predicates
     /*  892617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892630 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  892630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  892633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892655 */     GIR_RootConstrainSelectedInstOperands,
     /*  892656 */     // GIR_Coverage, 9373,
     /*  892656 */     GIR_EraseRootFromParent_Done,
     /*  892657 */   // Label 13531: @892657
     /*  892657 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(892752), // Rule ID 9376 //
     /*  892662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  892665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  892673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  892676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  892679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  892685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  892688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892712 */     // MIs[1] Operand 1
     /*  892712 */     // No operand predicates
     /*  892712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892725 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  892725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  892728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892750 */     GIR_RootConstrainSelectedInstOperands,
     /*  892751 */     // GIR_Coverage, 9376,
     /*  892751 */     GIR_EraseRootFromParent_Done,
     /*  892752 */   // Label 13532: @892752
     /*  892752 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(892847), // Rule ID 9377 //
     /*  892757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  892760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  892768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  892771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  892774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  892780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892807 */     // MIs[1] Operand 1
     /*  892807 */     // No operand predicates
     /*  892807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  892820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  892823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892845 */     GIR_RootConstrainSelectedInstOperands,
     /*  892846 */     // GIR_Coverage, 9377,
     /*  892846 */     GIR_EraseRootFromParent_Done,
     /*  892847 */   // Label 13533: @892847
     /*  892847 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(892942), // Rule ID 9380 //
     /*  892852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  892855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  892863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  892866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  892869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  892875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  892878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892902 */     // MIs[1] Operand 1
     /*  892902 */     // No operand predicates
     /*  892902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  892906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  892908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  892915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  892918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  892927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  892929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  892940 */     GIR_RootConstrainSelectedInstOperands,
     /*  892941 */     // GIR_Coverage, 9380,
     /*  892941 */     GIR_EraseRootFromParent_Done,
     /*  892942 */   // Label 13534: @892942
     /*  892942 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(893037), // Rule ID 9381 //
     /*  892947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  892950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  892955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  892958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  892961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  892964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  892970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  892973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  892989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  892993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  892997 */     // MIs[1] Operand 1
     /*  892997 */     // No operand predicates
     /*  892997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  893010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  893013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893035 */     GIR_RootConstrainSelectedInstOperands,
     /*  893036 */     // GIR_Coverage, 9381,
     /*  893036 */     GIR_EraseRootFromParent_Done,
     /*  893037 */   // Label 13535: @893037
     /*  893037 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(893132), // Rule ID 9384 //
     /*  893042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  893045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  893053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  893056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  893059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  893065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  893068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893092 */     // MIs[1] Operand 1
     /*  893092 */     // No operand predicates
     /*  893092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893105 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  893105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  893108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893130 */     GIR_RootConstrainSelectedInstOperands,
     /*  893131 */     // GIR_Coverage, 9384,
     /*  893131 */     GIR_EraseRootFromParent_Done,
     /*  893132 */   // Label 13536: @893132
     /*  893132 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(893227), // Rule ID 9385 //
     /*  893137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  893140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  893148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  893151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  893154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  893160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  893163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893187 */     // MIs[1] Operand 1
     /*  893187 */     // No operand predicates
     /*  893187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893200 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  893200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  893203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893225 */     GIR_RootConstrainSelectedInstOperands,
     /*  893226 */     // GIR_Coverage, 9385,
     /*  893226 */     GIR_EraseRootFromParent_Done,
     /*  893227 */   // Label 13537: @893227
     /*  893227 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(893322), // Rule ID 9388 //
     /*  893232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  893235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  893243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  893246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  893249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  893255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  893258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893282 */     // MIs[1] Operand 1
     /*  893282 */     // No operand predicates
     /*  893282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  893295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  893298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893320 */     GIR_RootConstrainSelectedInstOperands,
     /*  893321 */     // GIR_Coverage, 9388,
     /*  893321 */     GIR_EraseRootFromParent_Done,
     /*  893322 */   // Label 13538: @893322
     /*  893322 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(893417), // Rule ID 9389 //
     /*  893327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  893330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  893338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  893341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  893344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  893350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  893353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893377 */     // MIs[1] Operand 1
     /*  893377 */     // No operand predicates
     /*  893377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  893390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  893393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893415 */     GIR_RootConstrainSelectedInstOperands,
     /*  893416 */     // GIR_Coverage, 9389,
     /*  893416 */     GIR_EraseRootFromParent_Done,
     /*  893417 */   // Label 13539: @893417
     /*  893417 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(893512), // Rule ID 9392 //
     /*  893422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  893425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  893433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  893436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  893439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  893445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  893448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893472 */     // MIs[1] Operand 1
     /*  893472 */     // No operand predicates
     /*  893472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893485 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  893485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  893488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893510 */     GIR_RootConstrainSelectedInstOperands,
     /*  893511 */     // GIR_Coverage, 9392,
     /*  893511 */     GIR_EraseRootFromParent_Done,
     /*  893512 */   // Label 13540: @893512
     /*  893512 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(893607), // Rule ID 9393 //
     /*  893517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  893520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  893528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  893531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  893534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  893540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  893543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893567 */     // MIs[1] Operand 1
     /*  893567 */     // No operand predicates
     /*  893567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  893580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  893583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893605 */     GIR_RootConstrainSelectedInstOperands,
     /*  893606 */     // GIR_Coverage, 9393,
     /*  893606 */     GIR_EraseRootFromParent_Done,
     /*  893607 */   // Label 13541: @893607
     /*  893607 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(893702), // Rule ID 9396 //
     /*  893612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  893615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  893623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  893626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  893629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  893635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  893638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893662 */     // MIs[1] Operand 1
     /*  893662 */     // No operand predicates
     /*  893662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  893675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  893678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893700 */     GIR_RootConstrainSelectedInstOperands,
     /*  893701 */     // GIR_Coverage, 9396,
     /*  893701 */     GIR_EraseRootFromParent_Done,
     /*  893702 */   // Label 13542: @893702
     /*  893702 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(893797), // Rule ID 9397 //
     /*  893707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  893710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  893718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  893721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  893724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  893730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  893733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893757 */     // MIs[1] Operand 1
     /*  893757 */     // No operand predicates
     /*  893757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  893770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  893773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893795 */     GIR_RootConstrainSelectedInstOperands,
     /*  893796 */     // GIR_Coverage, 9397,
     /*  893796 */     GIR_EraseRootFromParent_Done,
     /*  893797 */   // Label 13543: @893797
     /*  893797 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(893892), // Rule ID 9400 //
     /*  893802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  893805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  893813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  893816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  893819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  893825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  893828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893852 */     // MIs[1] Operand 1
     /*  893852 */     // No operand predicates
     /*  893852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893865 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  893865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  893868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893890 */     GIR_RootConstrainSelectedInstOperands,
     /*  893891 */     // GIR_Coverage, 9400,
     /*  893891 */     GIR_EraseRootFromParent_Done,
     /*  893892 */   // Label 13544: @893892
     /*  893892 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(893987), // Rule ID 9401 //
     /*  893897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  893900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  893905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  893908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  893911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  893914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  893920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  893923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  893939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  893943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  893947 */     // MIs[1] Operand 1
     /*  893947 */     // No operand predicates
     /*  893947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  893951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  893953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  893960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  893963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  893972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  893974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  893985 */     GIR_RootConstrainSelectedInstOperands,
     /*  893986 */     // GIR_Coverage, 9401,
     /*  893986 */     GIR_EraseRootFromParent_Done,
     /*  893987 */   // Label 13545: @893987
     /*  893987 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(894082), // Rule ID 9404 //
     /*  893992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  893995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  894000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  894003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  894006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  894015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894042 */     // MIs[1] Operand 1
     /*  894042 */     // No operand predicates
     /*  894042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  894055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  894058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  894080 */     GIR_RootConstrainSelectedInstOperands,
     /*  894081 */     // GIR_Coverage, 9404,
     /*  894081 */     GIR_EraseRootFromParent_Done,
     /*  894082 */   // Label 13546: @894082
     /*  894082 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(894177), // Rule ID 9405 //
     /*  894087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  894090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  894095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  894098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  894101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  894110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  894113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894137 */     // MIs[1] Operand 1
     /*  894137 */     // No operand predicates
     /*  894137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894150 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  894150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  894153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  894175 */     GIR_RootConstrainSelectedInstOperands,
     /*  894176 */     // GIR_Coverage, 9405,
     /*  894176 */     GIR_EraseRootFromParent_Done,
     /*  894177 */   // Label 13547: @894177
     /*  894177 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(894272), // Rule ID 9408 //
     /*  894182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  894185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  894190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  894193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  894196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  894199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  894205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894232 */     // MIs[1] Operand 1
     /*  894232 */     // No operand predicates
     /*  894232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894245 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  894245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  894248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  894270 */     GIR_RootConstrainSelectedInstOperands,
     /*  894271 */     // GIR_Coverage, 9408,
     /*  894271 */     GIR_EraseRootFromParent_Done,
     /*  894272 */   // Label 13548: @894272
     /*  894272 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(894367), // Rule ID 9409 //
     /*  894277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  894280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  894285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  894288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  894291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  894294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  894300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  894303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894327 */     // MIs[1] Operand 1
     /*  894327 */     // No operand predicates
     /*  894327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  894340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  894343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  894365 */     GIR_RootConstrainSelectedInstOperands,
     /*  894366 */     // GIR_Coverage, 9409,
     /*  894366 */     GIR_EraseRootFromParent_Done,
     /*  894367 */   // Label 13549: @894367
     /*  894367 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(894459), // Rule ID 13786 //
     /*  894372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  894375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  894383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  894386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  894389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  894395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894422 */     // MIs[1] Operand 1
     /*  894422 */     // No operand predicates
     /*  894422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894435 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  894435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  894438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894457 */     GIR_RootConstrainSelectedInstOperands,
     /*  894458 */     // GIR_Coverage, 13786,
     /*  894458 */     GIR_EraseRootFromParent_Done,
     /*  894459 */   // Label 13550: @894459
     /*  894459 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(894551), // Rule ID 13787 //
     /*  894464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  894467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  894475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  894478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  894481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  894487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  894490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894514 */     // MIs[1] Operand 1
     /*  894514 */     // No operand predicates
     /*  894514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  894527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  894530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894549 */     GIR_RootConstrainSelectedInstOperands,
     /*  894550 */     // GIR_Coverage, 13787,
     /*  894550 */     GIR_EraseRootFromParent_Done,
     /*  894551 */   // Label 13551: @894551
     /*  894551 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(894643), // Rule ID 13788 //
     /*  894556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  894559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  894567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  894570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  894573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  894579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894606 */     // MIs[1] Operand 1
     /*  894606 */     // No operand predicates
     /*  894606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894619 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  894619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  894622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894641 */     GIR_RootConstrainSelectedInstOperands,
     /*  894642 */     // GIR_Coverage, 13788,
     /*  894642 */     GIR_EraseRootFromParent_Done,
     /*  894643 */   // Label 13552: @894643
     /*  894643 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(894735), // Rule ID 13789 //
     /*  894648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  894651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  894659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  894662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  894665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  894671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  894674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894698 */     // MIs[1] Operand 1
     /*  894698 */     // No operand predicates
     /*  894698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894711 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  894711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  894714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894733 */     GIR_RootConstrainSelectedInstOperands,
     /*  894734 */     // GIR_Coverage, 13789,
     /*  894734 */     GIR_EraseRootFromParent_Done,
     /*  894735 */   // Label 13553: @894735
     /*  894735 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(894827), // Rule ID 13790 //
     /*  894740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  894743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  894751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  894754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  894757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  894763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894790 */     // MIs[1] Operand 1
     /*  894790 */     // No operand predicates
     /*  894790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894803 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  894803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  894806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894825 */     GIR_RootConstrainSelectedInstOperands,
     /*  894826 */     // GIR_Coverage, 13790,
     /*  894826 */     GIR_EraseRootFromParent_Done,
     /*  894827 */   // Label 13554: @894827
     /*  894827 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(894919), // Rule ID 13791 //
     /*  894832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  894835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  894843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  894846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  894849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  894855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  894858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894882 */     // MIs[1] Operand 1
     /*  894882 */     // No operand predicates
     /*  894882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894895 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  894895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  894898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  894909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894917 */     GIR_RootConstrainSelectedInstOperands,
     /*  894918 */     // GIR_Coverage, 13791,
     /*  894918 */     GIR_EraseRootFromParent_Done,
     /*  894919 */   // Label 13555: @894919
     /*  894919 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(895011), // Rule ID 13792 //
     /*  894924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  894927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  894932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  894935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  894938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  894941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  894947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  894950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  894954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  894966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  894970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  894974 */     // MIs[1] Operand 1
     /*  894974 */     // No operand predicates
     /*  894974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  894978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  894980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894987 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  894987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  894990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  894999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895009 */     GIR_RootConstrainSelectedInstOperands,
     /*  895010 */     // GIR_Coverage, 13792,
     /*  895010 */     GIR_EraseRootFromParent_Done,
     /*  895011 */   // Label 13556: @895011
     /*  895011 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(895103), // Rule ID 13793 //
     /*  895016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  895039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895066 */     // MIs[1] Operand 1
     /*  895066 */     // No operand predicates
     /*  895066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895079 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  895079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  895082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895101 */     GIR_RootConstrainSelectedInstOperands,
     /*  895102 */     // GIR_Coverage, 13793,
     /*  895102 */     GIR_EraseRootFromParent_Done,
     /*  895103 */   // Label 13557: @895103
     /*  895103 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(895195), // Rule ID 13794 //
     /*  895108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  895111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  895131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  895134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895158 */     // MIs[1] Operand 1
     /*  895158 */     // No operand predicates
     /*  895158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  895171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  895174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895193 */     GIR_RootConstrainSelectedInstOperands,
     /*  895194 */     // GIR_Coverage, 13794,
     /*  895194 */     GIR_EraseRootFromParent_Done,
     /*  895195 */   // Label 13558: @895195
     /*  895195 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(895287), // Rule ID 13795 //
     /*  895200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  895223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895250 */     // MIs[1] Operand 1
     /*  895250 */     // No operand predicates
     /*  895250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895263 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  895263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  895266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895285 */     GIR_RootConstrainSelectedInstOperands,
     /*  895286 */     // GIR_Coverage, 13795,
     /*  895286 */     GIR_EraseRootFromParent_Done,
     /*  895287 */   // Label 13559: @895287
     /*  895287 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(895379), // Rule ID 13796 //
     /*  895292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  895295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  895315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  895318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895342 */     // MIs[1] Operand 1
     /*  895342 */     // No operand predicates
     /*  895342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895355 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  895355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  895358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895377 */     GIR_RootConstrainSelectedInstOperands,
     /*  895378 */     // GIR_Coverage, 13796,
     /*  895378 */     GIR_EraseRootFromParent_Done,
     /*  895379 */   // Label 13560: @895379
     /*  895379 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(895471), // Rule ID 13797 //
     /*  895384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  895407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895434 */     // MIs[1] Operand 1
     /*  895434 */     // No operand predicates
     /*  895434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895447 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  895447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  895450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895469 */     GIR_RootConstrainSelectedInstOperands,
     /*  895470 */     // GIR_Coverage, 13797,
     /*  895470 */     GIR_EraseRootFromParent_Done,
     /*  895471 */   // Label 13561: @895471
     /*  895471 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(895563), // Rule ID 13798 //
     /*  895476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  895479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  895487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  895490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  895493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  895499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  895502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895526 */     // MIs[1] Operand 1
     /*  895526 */     // No operand predicates
     /*  895526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  895539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  895542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895561 */     GIR_RootConstrainSelectedInstOperands,
     /*  895562 */     // GIR_Coverage, 13798,
     /*  895562 */     GIR_EraseRootFromParent_Done,
     /*  895563 */   // Label 13562: @895563
     /*  895563 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(895655), // Rule ID 13799 //
     /*  895568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  895579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  895582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  895585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  895591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895618 */     // MIs[1] Operand 1
     /*  895618 */     // No operand predicates
     /*  895618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895631 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  895631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  895634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895653 */     GIR_RootConstrainSelectedInstOperands,
     /*  895654 */     // GIR_Coverage, 13799,
     /*  895654 */     GIR_EraseRootFromParent_Done,
     /*  895655 */   // Label 13563: @895655
     /*  895655 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(895747), // Rule ID 13800 //
     /*  895660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  895663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  895671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  895674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  895677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  895683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  895686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895710 */     // MIs[1] Operand 1
     /*  895710 */     // No operand predicates
     /*  895710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895723 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  895723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  895726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895745 */     GIR_RootConstrainSelectedInstOperands,
     /*  895746 */     // GIR_Coverage, 13800,
     /*  895746 */     GIR_EraseRootFromParent_Done,
     /*  895747 */   // Label 13564: @895747
     /*  895747 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(895839), // Rule ID 13801 //
     /*  895752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  895763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  895766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  895769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  895775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895802 */     // MIs[1] Operand 1
     /*  895802 */     // No operand predicates
     /*  895802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  895815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  895818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895837 */     GIR_RootConstrainSelectedInstOperands,
     /*  895838 */     // GIR_Coverage, 13801,
     /*  895838 */     GIR_EraseRootFromParent_Done,
     /*  895839 */   // Label 13565: @895839
     /*  895839 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(895931), // Rule ID 13802 //
     /*  895844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  895847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  895855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  895858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  895861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  895867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  895870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895894 */     // MIs[1] Operand 1
     /*  895894 */     // No operand predicates
     /*  895894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  895907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  895910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  895919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  895921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895929 */     GIR_RootConstrainSelectedInstOperands,
     /*  895930 */     // GIR_Coverage, 13802,
     /*  895930 */     GIR_EraseRootFromParent_Done,
     /*  895931 */   // Label 13566: @895931
     /*  895931 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(896023), // Rule ID 13803 //
     /*  895936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  895939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  895944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  895947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  895950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  895953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  895959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  895962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  895966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  895978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  895982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  895986 */     // MIs[1] Operand 1
     /*  895986 */     // No operand predicates
     /*  895986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  895990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  895992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  895999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  896002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896021 */     GIR_RootConstrainSelectedInstOperands,
     /*  896022 */     // GIR_Coverage, 13803,
     /*  896022 */     GIR_EraseRootFromParent_Done,
     /*  896023 */   // Label 13567: @896023
     /*  896023 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(896115), // Rule ID 13804 //
     /*  896028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  896031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  896051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  896058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896078 */     // MIs[1] Operand 1
     /*  896078 */     // No operand predicates
     /*  896078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  896091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  896094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896113 */     GIR_RootConstrainSelectedInstOperands,
     /*  896114 */     // GIR_Coverage, 13804,
     /*  896114 */     GIR_EraseRootFromParent_Done,
     /*  896115 */   // Label 13568: @896115
     /*  896115 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(896207), // Rule ID 13805 //
     /*  896120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  896123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  896143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  896146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  896150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896170 */     // MIs[1] Operand 1
     /*  896170 */     // No operand predicates
     /*  896170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  896183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  896186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896205 */     GIR_RootConstrainSelectedInstOperands,
     /*  896206 */     // GIR_Coverage, 13805,
     /*  896206 */     GIR_EraseRootFromParent_Done,
     /*  896207 */   // Label 13569: @896207
     /*  896207 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(896299), // Rule ID 13806 //
     /*  896212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  896215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  896235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  896242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896262 */     // MIs[1] Operand 1
     /*  896262 */     // No operand predicates
     /*  896262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  896275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  896278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896297 */     GIR_RootConstrainSelectedInstOperands,
     /*  896298 */     // GIR_Coverage, 13806,
     /*  896298 */     GIR_EraseRootFromParent_Done,
     /*  896299 */   // Label 13570: @896299
     /*  896299 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(896391), // Rule ID 13807 //
     /*  896304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  896307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  896327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  896330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  896334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896354 */     // MIs[1] Operand 1
     /*  896354 */     // No operand predicates
     /*  896354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  896367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  896370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896389 */     GIR_RootConstrainSelectedInstOperands,
     /*  896390 */     // GIR_Coverage, 13807,
     /*  896390 */     GIR_EraseRootFromParent_Done,
     /*  896391 */   // Label 13571: @896391
     /*  896391 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(896483), // Rule ID 13808 //
     /*  896396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  896399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  896419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  896426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896446 */     // MIs[1] Operand 1
     /*  896446 */     // No operand predicates
     /*  896446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  896459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  896462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896481 */     GIR_RootConstrainSelectedInstOperands,
     /*  896482 */     // GIR_Coverage, 13808,
     /*  896482 */     GIR_EraseRootFromParent_Done,
     /*  896483 */   // Label 13572: @896483
     /*  896483 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(896575), // Rule ID 13809 //
     /*  896488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  896491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  896511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  896514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  896518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896538 */     // MIs[1] Operand 1
     /*  896538 */     // No operand predicates
     /*  896538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  896551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  896554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896573 */     GIR_RootConstrainSelectedInstOperands,
     /*  896574 */     // GIR_Coverage, 13809,
     /*  896574 */     GIR_EraseRootFromParent_Done,
     /*  896575 */   // Label 13573: @896575
     /*  896575 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(896667), // Rule ID 13810 //
     /*  896580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  896583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  896603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  896610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896630 */     // MIs[1] Operand 1
     /*  896630 */     // No operand predicates
     /*  896630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896643 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  896643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  896646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896665 */     GIR_RootConstrainSelectedInstOperands,
     /*  896666 */     // GIR_Coverage, 13810,
     /*  896666 */     GIR_EraseRootFromParent_Done,
     /*  896667 */   // Label 13574: @896667
     /*  896667 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(896759), // Rule ID 13811 //
     /*  896672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  896675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  896695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  896698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  896702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896722 */     // MIs[1] Operand 1
     /*  896722 */     // No operand predicates
     /*  896722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896735 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  896735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  896738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896757 */     GIR_RootConstrainSelectedInstOperands,
     /*  896758 */     // GIR_Coverage, 13811,
     /*  896758 */     GIR_EraseRootFromParent_Done,
     /*  896759 */   // Label 13575: @896759
     /*  896759 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(896851), // Rule ID 13812 //
     /*  896764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  896767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  896775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  896778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  896781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  896787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  896794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896814 */     // MIs[1] Operand 1
     /*  896814 */     // No operand predicates
     /*  896814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  896827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  896830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896849 */     GIR_RootConstrainSelectedInstOperands,
     /*  896850 */     // GIR_Coverage, 13812,
     /*  896850 */     GIR_EraseRootFromParent_Done,
     /*  896851 */   // Label 13576: @896851
     /*  896851 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(896943), // Rule ID 13813 //
     /*  896856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  896859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  896867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  896870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  896873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  896879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  896882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  896886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896906 */     // MIs[1] Operand 1
     /*  896906 */     // No operand predicates
     /*  896906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  896910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  896912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896919 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  896919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  896922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  896931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  896933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896941 */     GIR_RootConstrainSelectedInstOperands,
     /*  896942 */     // GIR_Coverage, 13813,
     /*  896942 */     GIR_EraseRootFromParent_Done,
     /*  896943 */   // Label 13577: @896943
     /*  896943 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(897035), // Rule ID 13814 //
     /*  896948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  896951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  896956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  896959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  896962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  896965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  896971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  896974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  896978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  896990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  896994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  896998 */     // MIs[1] Operand 1
     /*  896998 */     // No operand predicates
     /*  896998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897011 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  897011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  897014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897033 */     GIR_RootConstrainSelectedInstOperands,
     /*  897034 */     // GIR_Coverage, 13814,
     /*  897034 */     GIR_EraseRootFromParent_Done,
     /*  897035 */   // Label 13578: @897035
     /*  897035 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(897127), // Rule ID 13815 //
     /*  897040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  897043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  897063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  897070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897090 */     // MIs[1] Operand 1
     /*  897090 */     // No operand predicates
     /*  897090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897103 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  897103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  897106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897125 */     GIR_RootConstrainSelectedInstOperands,
     /*  897126 */     // GIR_Coverage, 13815,
     /*  897126 */     GIR_EraseRootFromParent_Done,
     /*  897127 */   // Label 13579: @897127
     /*  897127 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(897219), // Rule ID 13816 //
     /*  897132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  897135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  897155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  897158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  897162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897182 */     // MIs[1] Operand 1
     /*  897182 */     // No operand predicates
     /*  897182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  897195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  897198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897217 */     GIR_RootConstrainSelectedInstOperands,
     /*  897218 */     // GIR_Coverage, 13816,
     /*  897218 */     GIR_EraseRootFromParent_Done,
     /*  897219 */   // Label 13580: @897219
     /*  897219 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(897311), // Rule ID 13817 //
     /*  897224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  897227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  897247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  897254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897274 */     // MIs[1] Operand 1
     /*  897274 */     // No operand predicates
     /*  897274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897287 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  897287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  897290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897309 */     GIR_RootConstrainSelectedInstOperands,
     /*  897310 */     // GIR_Coverage, 13817,
     /*  897310 */     GIR_EraseRootFromParent_Done,
     /*  897311 */   // Label 13581: @897311
     /*  897311 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(897403), // Rule ID 13818 //
     /*  897316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  897319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  897339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  897342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  897346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897366 */     // MIs[1] Operand 1
     /*  897366 */     // No operand predicates
     /*  897366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  897379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  897382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897401 */     GIR_RootConstrainSelectedInstOperands,
     /*  897402 */     // GIR_Coverage, 13818,
     /*  897402 */     GIR_EraseRootFromParent_Done,
     /*  897403 */   // Label 13582: @897403
     /*  897403 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(897495), // Rule ID 13819 //
     /*  897408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  897411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  897431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  897438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897458 */     // MIs[1] Operand 1
     /*  897458 */     // No operand predicates
     /*  897458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  897471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  897474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897493 */     GIR_RootConstrainSelectedInstOperands,
     /*  897494 */     // GIR_Coverage, 13819,
     /*  897494 */     GIR_EraseRootFromParent_Done,
     /*  897495 */   // Label 13583: @897495
     /*  897495 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(897587), // Rule ID 13820 //
     /*  897500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  897503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  897523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  897526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  897530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897550 */     // MIs[1] Operand 1
     /*  897550 */     // No operand predicates
     /*  897550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  897563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  897566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897585 */     GIR_RootConstrainSelectedInstOperands,
     /*  897586 */     // GIR_Coverage, 13820,
     /*  897586 */     GIR_EraseRootFromParent_Done,
     /*  897587 */   // Label 13584: @897587
     /*  897587 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(897679), // Rule ID 13821 //
     /*  897592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  897595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  897615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  897622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897642 */     // MIs[1] Operand 1
     /*  897642 */     // No operand predicates
     /*  897642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897655 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  897655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  897658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897677 */     GIR_RootConstrainSelectedInstOperands,
     /*  897678 */     // GIR_Coverage, 13821,
     /*  897678 */     GIR_EraseRootFromParent_Done,
     /*  897679 */   // Label 13585: @897679
     /*  897679 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(897771), // Rule ID 13822 //
     /*  897684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  897687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  897707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  897710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  897714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897734 */     // MIs[1] Operand 1
     /*  897734 */     // No operand predicates
     /*  897734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  897747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  897750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897769 */     GIR_RootConstrainSelectedInstOperands,
     /*  897770 */     // GIR_Coverage, 13822,
     /*  897770 */     GIR_EraseRootFromParent_Done,
     /*  897771 */   // Label 13586: @897771
     /*  897771 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(897863), // Rule ID 13823 //
     /*  897776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  897779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  897799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  897806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897826 */     // MIs[1] Operand 1
     /*  897826 */     // No operand predicates
     /*  897826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  897839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  897842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897861 */     GIR_RootConstrainSelectedInstOperands,
     /*  897862 */     // GIR_Coverage, 13823,
     /*  897862 */     GIR_EraseRootFromParent_Done,
     /*  897863 */   // Label 13587: @897863
     /*  897863 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(897955), // Rule ID 13824 //
     /*  897868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  897871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  897879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  897882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  897885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  897891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  897894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  897898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  897910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  897914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  897918 */     // MIs[1] Operand 1
     /*  897918 */     // No operand predicates
     /*  897918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  897922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  897924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  897931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  897934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  897943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  897945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897953 */     GIR_RootConstrainSelectedInstOperands,
     /*  897954 */     // GIR_Coverage, 13824,
     /*  897954 */     GIR_EraseRootFromParent_Done,
     /*  897955 */   // Label 13588: @897955
     /*  897955 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(898047), // Rule ID 13825 //
     /*  897960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  897963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  897968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  897971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  897974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  897977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  897983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  897986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  897990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  898002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  898006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  898010 */     // MIs[1] Operand 1
     /*  898010 */     // No operand predicates
     /*  898010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  898014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  898016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  898023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  898026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  898035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  898037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898045 */     GIR_RootConstrainSelectedInstOperands,
     /*  898046 */     // GIR_Coverage, 13825,
     /*  898046 */     GIR_EraseRootFromParent_Done,
     /*  898047 */   // Label 13589: @898047
     /*  898047 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(898139), // Rule ID 13826 //
     /*  898052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  898055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  898060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  898075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  898082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  898094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  898098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  898102 */     // MIs[1] Operand 1
     /*  898102 */     // No operand predicates
     /*  898102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  898106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  898108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898115 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  898115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  898118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  898127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  898129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898137 */     GIR_RootConstrainSelectedInstOperands,
     /*  898138 */     // GIR_Coverage, 13826,
     /*  898138 */     GIR_EraseRootFromParent_Done,
     /*  898139 */   // Label 13590: @898139
     /*  898139 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(898231), // Rule ID 13827 //
     /*  898144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  898147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  898152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  898167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  898174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  898186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  898190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  898194 */     // MIs[1] Operand 1
     /*  898194 */     // No operand predicates
     /*  898194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  898198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  898200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898207 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  898207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  898210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  898219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  898221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898229 */     GIR_RootConstrainSelectedInstOperands,
     /*  898230 */     // GIR_Coverage, 13827,
     /*  898230 */     GIR_EraseRootFromParent_Done,
     /*  898231 */   // Label 13591: @898231
     /*  898231 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(898323), // Rule ID 13828 //
     /*  898236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  898239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  898244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  898259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  898266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  898278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  898282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  898286 */     // MIs[1] Operand 1
     /*  898286 */     // No operand predicates
     /*  898286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  898290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  898292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  898299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  898302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  898311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  898313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898321 */     GIR_RootConstrainSelectedInstOperands,
     /*  898322 */     // GIR_Coverage, 13828,
     /*  898322 */     GIR_EraseRootFromParent_Done,
     /*  898323 */   // Label 13592: @898323
     /*  898323 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(898415), // Rule ID 13829 //
     /*  898328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  898331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  898336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  898351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  898358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  898370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  898374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  898378 */     // MIs[1] Operand 1
     /*  898378 */     // No operand predicates
     /*  898378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  898382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  898384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898391 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  898391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  898394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  898403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  898405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898413 */     GIR_RootConstrainSelectedInstOperands,
     /*  898414 */     // GIR_Coverage, 13829,
     /*  898414 */     GIR_EraseRootFromParent_Done,
     /*  898415 */   // Label 13593: @898415
     /*  898415 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(898491), // Rule ID 2624 //
     /*  898420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  898423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  898431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  898434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898448 */     // MIs[0] passthru
     /*  898448 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898457 */     // MIs[0] round
     /*  898457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898467 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  898470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898489 */     GIR_RootConstrainSelectedInstOperands,
     /*  898490 */     // GIR_Coverage, 2624,
     /*  898490 */     GIR_EraseRootFromParent_Done,
     /*  898491 */   // Label 13594: @898491
     /*  898491 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(898567), // Rule ID 2625 //
     /*  898496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  898499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  898507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  898510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898524 */     // MIs[0] passthru
     /*  898524 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898533 */     // MIs[0] round
     /*  898533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898543 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  898546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898565 */     GIR_RootConstrainSelectedInstOperands,
     /*  898566 */     // GIR_Coverage, 2625,
     /*  898566 */     GIR_EraseRootFromParent_Done,
     /*  898567 */   // Label 13595: @898567
     /*  898567 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(898643), // Rule ID 16996 //
     /*  898572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  898575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  898583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  898586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  898589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898600 */     // MIs[0] passthru
     /*  898600 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898609 */     // MIs[0] round
     /*  898609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  898622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898641 */     GIR_RootConstrainSelectedInstOperands,
     /*  898642 */     // GIR_Coverage, 16996,
     /*  898642 */     GIR_EraseRootFromParent_Done,
     /*  898643 */   // Label 13596: @898643
     /*  898643 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(898719), // Rule ID 16997 //
     /*  898648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  898651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  898659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  898662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  898665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898676 */     // MIs[0] passthru
     /*  898676 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898685 */     // MIs[0] round
     /*  898685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898695 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  898698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898717 */     GIR_RootConstrainSelectedInstOperands,
     /*  898718 */     // GIR_Coverage, 16997,
     /*  898718 */     GIR_EraseRootFromParent_Done,
     /*  898719 */   // Label 13597: @898719
     /*  898719 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(898795), // Rule ID 17006 //
     /*  898724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  898727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  898741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898752 */     // MIs[0] passthru
     /*  898752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898761 */     // MIs[0] round
     /*  898761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898771 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  898774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898793 */     GIR_RootConstrainSelectedInstOperands,
     /*  898794 */     // GIR_Coverage, 17006,
     /*  898794 */     GIR_EraseRootFromParent_Done,
     /*  898795 */   // Label 13598: @898795
     /*  898795 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(898871), // Rule ID 17007 //
     /*  898800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  898803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  898817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898828 */     // MIs[0] passthru
     /*  898828 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898837 */     // MIs[0] round
     /*  898837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898847 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  898850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898856 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898869 */     GIR_RootConstrainSelectedInstOperands,
     /*  898870 */     // GIR_Coverage, 17007,
     /*  898870 */     GIR_EraseRootFromParent_Done,
     /*  898871 */   // Label 13599: @898871
     /*  898871 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(898947), // Rule ID 17016 //
     /*  898876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  898879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  898893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  898896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898904 */     // MIs[0] passthru
     /*  898904 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898913 */     // MIs[0] round
     /*  898913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898923 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  898926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  898934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898945 */     GIR_RootConstrainSelectedInstOperands,
     /*  898946 */     // GIR_Coverage, 17016,
     /*  898946 */     GIR_EraseRootFromParent_Done,
     /*  898947 */   // Label 13600: @898947
     /*  898947 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(899023), // Rule ID 17017 //
     /*  898952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  898955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  898960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  898969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  898972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898980 */     // MIs[0] passthru
     /*  898980 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  898985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898989 */     // MIs[0] round
     /*  898989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  898992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898999 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  899002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899008 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899021 */     GIR_RootConstrainSelectedInstOperands,
     /*  899022 */     // GIR_Coverage, 17017,
     /*  899022 */     GIR_EraseRootFromParent_Done,
     /*  899023 */   // Label 13601: @899023
     /*  899023 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(899099), // Rule ID 17026 //
     /*  899028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  899031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  899039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  899042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  899045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899056 */     // MIs[0] passthru
     /*  899056 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899065 */     // MIs[0] round
     /*  899065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899075 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  899078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899097 */     GIR_RootConstrainSelectedInstOperands,
     /*  899098 */     // GIR_Coverage, 17026,
     /*  899098 */     GIR_EraseRootFromParent_Done,
     /*  899099 */   // Label 13602: @899099
     /*  899099 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(899175), // Rule ID 17027 //
     /*  899104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  899107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  899115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  899118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  899121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899132 */     // MIs[0] passthru
     /*  899132 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899141 */     // MIs[0] round
     /*  899141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899151 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  899154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899173 */     GIR_RootConstrainSelectedInstOperands,
     /*  899174 */     // GIR_Coverage, 17027,
     /*  899174 */     GIR_EraseRootFromParent_Done,
     /*  899175 */   // Label 13603: @899175
     /*  899175 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(899251), // Rule ID 17036 //
     /*  899180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  899183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899208 */     // MIs[0] passthru
     /*  899208 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899217 */     // MIs[0] round
     /*  899217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  899230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899249 */     GIR_RootConstrainSelectedInstOperands,
     /*  899250 */     // GIR_Coverage, 17036,
     /*  899250 */     GIR_EraseRootFromParent_Done,
     /*  899251 */   // Label 13604: @899251
     /*  899251 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(899327), // Rule ID 17037 //
     /*  899256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  899259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899284 */     // MIs[0] passthru
     /*  899284 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899293 */     // MIs[0] round
     /*  899293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899303 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  899306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899312 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899325 */     GIR_RootConstrainSelectedInstOperands,
     /*  899326 */     // GIR_Coverage, 17037,
     /*  899326 */     GIR_EraseRootFromParent_Done,
     /*  899327 */   // Label 13605: @899327
     /*  899327 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(899403), // Rule ID 17046 //
     /*  899332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  899335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  899343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  899346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899360 */     // MIs[0] passthru
     /*  899360 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899369 */     // MIs[0] round
     /*  899369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  899382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899401 */     GIR_RootConstrainSelectedInstOperands,
     /*  899402 */     // GIR_Coverage, 17046,
     /*  899402 */     GIR_EraseRootFromParent_Done,
     /*  899403 */   // Label 13606: @899403
     /*  899403 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(899479), // Rule ID 17047 //
     /*  899408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  899411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  899419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  899422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899436 */     // MIs[0] passthru
     /*  899436 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899445 */     // MIs[0] round
     /*  899445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899455 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  899458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899477 */     GIR_RootConstrainSelectedInstOperands,
     /*  899478 */     // GIR_Coverage, 17047,
     /*  899478 */     GIR_EraseRootFromParent_Done,
     /*  899479 */   // Label 13607: @899479
     /*  899479 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(899555), // Rule ID 17056 //
     /*  899484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  899487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  899495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  899498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  899501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899512 */     // MIs[0] passthru
     /*  899512 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899521 */     // MIs[0] round
     /*  899521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899531 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  899534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899553 */     GIR_RootConstrainSelectedInstOperands,
     /*  899554 */     // GIR_Coverage, 17056,
     /*  899554 */     GIR_EraseRootFromParent_Done,
     /*  899555 */   // Label 13608: @899555
     /*  899555 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(899631), // Rule ID 17057 //
     /*  899560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  899563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  899571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  899574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  899577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899588 */     // MIs[0] passthru
     /*  899588 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899597 */     // MIs[0] round
     /*  899597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899607 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  899610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899629 */     GIR_RootConstrainSelectedInstOperands,
     /*  899630 */     // GIR_Coverage, 17057,
     /*  899630 */     GIR_EraseRootFromParent_Done,
     /*  899631 */   // Label 13609: @899631
     /*  899631 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(899707), // Rule ID 17066 //
     /*  899636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  899639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  899647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  899650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  899653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899664 */     // MIs[0] passthru
     /*  899664 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899673 */     // MIs[0] round
     /*  899673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899683 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  899686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899692 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899705 */     GIR_RootConstrainSelectedInstOperands,
     /*  899706 */     // GIR_Coverage, 17066,
     /*  899706 */     GIR_EraseRootFromParent_Done,
     /*  899707 */   // Label 13610: @899707
     /*  899707 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(899783), // Rule ID 17067 //
     /*  899712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  899715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  899720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  899723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  899726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  899729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899740 */     // MIs[0] passthru
     /*  899740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899749 */     // MIs[0] round
     /*  899749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899759 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  899762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899768 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899781 */     GIR_RootConstrainSelectedInstOperands,
     /*  899782 */     // GIR_Coverage, 17067,
     /*  899782 */     GIR_EraseRootFromParent_Done,
     /*  899783 */   // Label 13611: @899783
     /*  899783 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(899859), // Rule ID 17112 //
     /*  899788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  899791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  899796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899816 */     // MIs[0] passthru
     /*  899816 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899825 */     // MIs[0] round
     /*  899825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899835 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  899838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899844 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899857 */     GIR_RootConstrainSelectedInstOperands,
     /*  899858 */     // GIR_Coverage, 17112,
     /*  899858 */     GIR_EraseRootFromParent_Done,
     /*  899859 */   // Label 13612: @899859
     /*  899859 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(899935), // Rule ID 17113 //
     /*  899864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  899867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  899872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  899884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899892 */     // MIs[0] passthru
     /*  899892 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899901 */     // MIs[0] round
     /*  899901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899911 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  899914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899933 */     GIR_RootConstrainSelectedInstOperands,
     /*  899934 */     // GIR_Coverage, 17113,
     /*  899934 */     GIR_EraseRootFromParent_Done,
     /*  899935 */   // Label 13613: @899935
     /*  899935 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(900011), // Rule ID 17122 //
     /*  899940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  899943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  899948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  899960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899968 */     // MIs[0] passthru
     /*  899968 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  899973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899977 */     // MIs[0] round
     /*  899977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  899980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899987 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  899990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899996 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  899998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900009 */     GIR_RootConstrainSelectedInstOperands,
     /*  900010 */     // GIR_Coverage, 17122,
     /*  900010 */     GIR_EraseRootFromParent_Done,
     /*  900011 */   // Label 13614: @900011
     /*  900011 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(900087), // Rule ID 17123 //
     /*  900016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  900019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  900033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900044 */     // MIs[0] passthru
     /*  900044 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900053 */     // MIs[0] round
     /*  900053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900063 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  900066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900085 */     GIR_RootConstrainSelectedInstOperands,
     /*  900086 */     // GIR_Coverage, 17123,
     /*  900086 */     GIR_EraseRootFromParent_Done,
     /*  900087 */   // Label 13615: @900087
     /*  900087 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(900163), // Rule ID 17132 //
     /*  900092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  900095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  900109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900120 */     // MIs[0] passthru
     /*  900120 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900129 */     // MIs[0] round
     /*  900129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  900142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900161 */     GIR_RootConstrainSelectedInstOperands,
     /*  900162 */     // GIR_Coverage, 17132,
     /*  900162 */     GIR_EraseRootFromParent_Done,
     /*  900163 */   // Label 13616: @900163
     /*  900163 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(900239), // Rule ID 17133 //
     /*  900168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  900171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  900185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900196 */     // MIs[0] passthru
     /*  900196 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900205 */     // MIs[0] round
     /*  900205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900215 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  900218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900237 */     GIR_RootConstrainSelectedInstOperands,
     /*  900238 */     // GIR_Coverage, 17133,
     /*  900238 */     GIR_EraseRootFromParent_Done,
     /*  900239 */   // Label 13617: @900239
     /*  900239 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(900315), // Rule ID 17142 //
     /*  900244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  900247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  900255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  900258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900272 */     // MIs[0] passthru
     /*  900272 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900281 */     // MIs[0] round
     /*  900281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  900294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900313 */     GIR_RootConstrainSelectedInstOperands,
     /*  900314 */     // GIR_Coverage, 17142,
     /*  900314 */     GIR_EraseRootFromParent_Done,
     /*  900315 */   // Label 13618: @900315
     /*  900315 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(900391), // Rule ID 17143 //
     /*  900320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  900323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  900331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  900334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900348 */     // MIs[0] passthru
     /*  900348 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900357 */     // MIs[0] round
     /*  900357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900367 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  900370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900376 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900389 */     GIR_RootConstrainSelectedInstOperands,
     /*  900390 */     // GIR_Coverage, 17143,
     /*  900390 */     GIR_EraseRootFromParent_Done,
     /*  900391 */   // Label 13619: @900391
     /*  900391 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(900467), // Rule ID 17152 //
     /*  900396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  900399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  900407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  900410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900424 */     // MIs[0] passthru
     /*  900424 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900433 */     // MIs[0] round
     /*  900433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900443 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  900446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900465 */     GIR_RootConstrainSelectedInstOperands,
     /*  900466 */     // GIR_Coverage, 17152,
     /*  900466 */     GIR_EraseRootFromParent_Done,
     /*  900467 */   // Label 13620: @900467
     /*  900467 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(900543), // Rule ID 17153 //
     /*  900472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  900475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  900483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  900486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900500 */     // MIs[0] passthru
     /*  900500 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900509 */     // MIs[0] round
     /*  900509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900519 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  900522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900541 */     GIR_RootConstrainSelectedInstOperands,
     /*  900542 */     // GIR_Coverage, 17153,
     /*  900542 */     GIR_EraseRootFromParent_Done,
     /*  900543 */   // Label 13621: @900543
     /*  900543 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(900619), // Rule ID 17162 //
     /*  900548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  900551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  900565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900576 */     // MIs[0] passthru
     /*  900576 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900585 */     // MIs[0] round
     /*  900585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900595 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  900598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900617 */     GIR_RootConstrainSelectedInstOperands,
     /*  900618 */     // GIR_Coverage, 17162,
     /*  900618 */     GIR_EraseRootFromParent_Done,
     /*  900619 */   // Label 13622: @900619
     /*  900619 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(900695), // Rule ID 17163 //
     /*  900624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  900627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  900641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900652 */     // MIs[0] passthru
     /*  900652 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900661 */     // MIs[0] round
     /*  900661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900671 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  900674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900680 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900693 */     GIR_RootConstrainSelectedInstOperands,
     /*  900694 */     // GIR_Coverage, 17163,
     /*  900694 */     GIR_EraseRootFromParent_Done,
     /*  900695 */   // Label 13623: @900695
     /*  900695 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(900771), // Rule ID 17172 //
     /*  900700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  900703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  900711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  900714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900728 */     // MIs[0] passthru
     /*  900728 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900737 */     // MIs[0] round
     /*  900737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900747 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  900750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900769 */     GIR_RootConstrainSelectedInstOperands,
     /*  900770 */     // GIR_Coverage, 17172,
     /*  900770 */     GIR_EraseRootFromParent_Done,
     /*  900771 */   // Label 13624: @900771
     /*  900771 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(900847), // Rule ID 17173 //
     /*  900776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  900779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  900787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  900790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900804 */     // MIs[0] passthru
     /*  900804 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900813 */     // MIs[0] round
     /*  900813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900823 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  900826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900832 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900845 */     GIR_RootConstrainSelectedInstOperands,
     /*  900846 */     // GIR_Coverage, 17173,
     /*  900846 */     GIR_EraseRootFromParent_Done,
     /*  900847 */   // Label 13625: @900847
     /*  900847 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(900923), // Rule ID 17182 //
     /*  900852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  900855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  900863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  900866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  900872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900880 */     // MIs[0] passthru
     /*  900880 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900889 */     // MIs[0] round
     /*  900889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900899 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  900902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900921 */     GIR_RootConstrainSelectedInstOperands,
     /*  900922 */     // GIR_Coverage, 17182,
     /*  900922 */     GIR_EraseRootFromParent_Done,
     /*  900923 */   // Label 13626: @900923
     /*  900923 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(900999), // Rule ID 17183 //
     /*  900928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  900931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  900936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  900939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  900942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  900948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900956 */     // MIs[0] passthru
     /*  900956 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  900961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900965 */     // MIs[0] round
     /*  900965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  900968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900975 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  900978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  900986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900997 */     GIR_RootConstrainSelectedInstOperands,
     /*  900998 */     // GIR_Coverage, 17183,
     /*  900998 */     GIR_EraseRootFromParent_Done,
     /*  900999 */   // Label 13627: @900999
     /*  900999 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(901075), // Rule ID 17192 //
     /*  901004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  901007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  901012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  901024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901032 */     // MIs[0] passthru
     /*  901032 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  901037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901041 */     // MIs[0] round
     /*  901041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  901044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901051 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  901054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  901062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901073 */     GIR_RootConstrainSelectedInstOperands,
     /*  901074 */     // GIR_Coverage, 17192,
     /*  901074 */     GIR_EraseRootFromParent_Done,
     /*  901075 */   // Label 13628: @901075
     /*  901075 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(901151), // Rule ID 17193 //
     /*  901080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  901083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  901088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  901100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901108 */     // MIs[0] passthru
     /*  901108 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  901113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901117 */     // MIs[0] round
     /*  901117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  901120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901127 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  901130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  901138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901149 */     GIR_RootConstrainSelectedInstOperands,
     /*  901150 */     // GIR_Coverage, 17193,
     /*  901150 */     GIR_EraseRootFromParent_Done,
     /*  901151 */   // Label 13629: @901151
     /*  901151 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(901228), // Rule ID 2554 //
     /*  901156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  901159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  901164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  901173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901195 */     // MIs[0] policy
     /*  901195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901205 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  901208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901226 */     GIR_RootConstrainSelectedInstOperands,
     /*  901227 */     // GIR_Coverage, 2554,
     /*  901227 */     GIR_EraseRootFromParent_Done,
     /*  901228 */   // Label 13630: @901228
     /*  901228 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(901305), // Rule ID 2555 //
     /*  901233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  901236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  901241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  901250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901272 */     // MIs[0] policy
     /*  901272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901282 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  901282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  901285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901303 */     GIR_RootConstrainSelectedInstOperands,
     /*  901304 */     // GIR_Coverage, 2555,
     /*  901304 */     GIR_EraseRootFromParent_Done,
     /*  901305 */   // Label 13631: @901305
     /*  901305 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(901382), // Rule ID 2558 //
     /*  901310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  901313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  901318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901349 */     // MIs[0] policy
     /*  901349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901359 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  901362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901380 */     GIR_RootConstrainSelectedInstOperands,
     /*  901381 */     // GIR_Coverage, 2558,
     /*  901381 */     GIR_EraseRootFromParent_Done,
     /*  901382 */   // Label 13632: @901382
     /*  901382 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(901459), // Rule ID 2559 //
     /*  901387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  901390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  901395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901426 */     // MIs[0] policy
     /*  901426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  901436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  901439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901457 */     GIR_RootConstrainSelectedInstOperands,
     /*  901458 */     // GIR_Coverage, 2559,
     /*  901458 */     GIR_EraseRootFromParent_Done,
     /*  901459 */   // Label 13633: @901459
     /*  901459 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(901536), // Rule ID 2562 //
     /*  901464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  901467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  901472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901503 */     // MIs[0] policy
     /*  901503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901513 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  901516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901534 */     GIR_RootConstrainSelectedInstOperands,
     /*  901535 */     // GIR_Coverage, 2562,
     /*  901535 */     GIR_EraseRootFromParent_Done,
     /*  901536 */   // Label 13634: @901536
     /*  901536 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(901613), // Rule ID 2563 //
     /*  901541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  901544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  901549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901580 */     // MIs[0] policy
     /*  901580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901590 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  901590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  901593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901611 */     GIR_RootConstrainSelectedInstOperands,
     /*  901612 */     // GIR_Coverage, 2563,
     /*  901612 */     GIR_EraseRootFromParent_Done,
     /*  901613 */   // Label 13635: @901613
     /*  901613 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(901690), // Rule ID 2598 //
     /*  901618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  901621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  901626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901657 */     // MIs[0] policy
     /*  901657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901667 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  901670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901688 */     GIR_RootConstrainSelectedInstOperands,
     /*  901689 */     // GIR_Coverage, 2598,
     /*  901689 */     GIR_EraseRootFromParent_Done,
     /*  901690 */   // Label 13636: @901690
     /*  901690 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(901767), // Rule ID 2599 //
     /*  901695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  901698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  901703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  901715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901734 */     // MIs[0] policy
     /*  901734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  901744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  901747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901765 */     GIR_RootConstrainSelectedInstOperands,
     /*  901766 */     // GIR_Coverage, 2599,
     /*  901766 */     GIR_EraseRootFromParent_Done,
     /*  901767 */   // Label 13637: @901767
     /*  901767 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(901844), // Rule ID 2630 //
     /*  901772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  901775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  901780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  901792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901811 */     // MIs[0] policy
     /*  901811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  901824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  901828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901842 */     GIR_RootConstrainSelectedInstOperands,
     /*  901843 */     // GIR_Coverage, 2630,
     /*  901843 */     GIR_EraseRootFromParent_Done,
     /*  901844 */   // Label 13638: @901844
     /*  901844 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(901921), // Rule ID 2631 //
     /*  901849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  901852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  901857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  901869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901888 */     // MIs[0] policy
     /*  901888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  901898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  901901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  901905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901919 */     GIR_RootConstrainSelectedInstOperands,
     /*  901920 */     // GIR_Coverage, 2631,
     /*  901920 */     GIR_EraseRootFromParent_Done,
     /*  901921 */   // Label 13639: @901921
     /*  901921 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(901998), // Rule ID 4750 //
     /*  901926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  901929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  901934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  901937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  901940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  901946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  901953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  901965 */     // MIs[0] policy
     /*  901965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  901968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901975 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  901975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  901978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  901984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  901986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  901996 */     GIR_RootConstrainSelectedInstOperands,
     /*  901997 */     // GIR_Coverage, 4750,
     /*  901997 */     GIR_EraseRootFromParent_Done,
     /*  901998 */   // Label 13640: @901998
     /*  901998 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(902075), // Rule ID 4751 //
     /*  902003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  902023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902042 */     // MIs[0] policy
     /*  902042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  902055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902073 */     GIR_RootConstrainSelectedInstOperands,
     /*  902074 */     // GIR_Coverage, 4751,
     /*  902074 */     GIR_EraseRootFromParent_Done,
     /*  902075 */   // Label 13641: @902075
     /*  902075 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(902152), // Rule ID 4754 //
     /*  902080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  902100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902119 */     // MIs[0] policy
     /*  902119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902129 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  902132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902150 */     GIR_RootConstrainSelectedInstOperands,
     /*  902151 */     // GIR_Coverage, 4754,
     /*  902151 */     GIR_EraseRootFromParent_Done,
     /*  902152 */   // Label 13642: @902152
     /*  902152 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(902229), // Rule ID 4755 //
     /*  902157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  902177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902196 */     // MIs[0] policy
     /*  902196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  902209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902227 */     GIR_RootConstrainSelectedInstOperands,
     /*  902228 */     // GIR_Coverage, 4755,
     /*  902228 */     GIR_EraseRootFromParent_Done,
     /*  902229 */   // Label 13643: @902229
     /*  902229 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(902306), // Rule ID 4758 //
     /*  902234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  902245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  902248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  902254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  902261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902273 */     // MIs[0] policy
     /*  902273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  902286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902304 */     GIR_RootConstrainSelectedInstOperands,
     /*  902305 */     // GIR_Coverage, 4758,
     /*  902305 */     GIR_EraseRootFromParent_Done,
     /*  902306 */   // Label 13644: @902306
     /*  902306 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(902383), // Rule ID 4759 //
     /*  902311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  902322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  902325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  902331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  902338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902350 */     // MIs[0] policy
     /*  902350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  902363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902381 */     GIR_RootConstrainSelectedInstOperands,
     /*  902382 */     // GIR_Coverage, 4759,
     /*  902382 */     GIR_EraseRootFromParent_Done,
     /*  902383 */   // Label 13645: @902383
     /*  902383 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(902460), // Rule ID 4762 //
     /*  902388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  902399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  902402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  902405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  902408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  902415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902427 */     // MIs[0] policy
     /*  902427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902437 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  902440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902458 */     GIR_RootConstrainSelectedInstOperands,
     /*  902459 */     // GIR_Coverage, 4762,
     /*  902459 */     GIR_EraseRootFromParent_Done,
     /*  902460 */   // Label 13646: @902460
     /*  902460 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(902537), // Rule ID 4763 //
     /*  902465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  902476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  902479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  902482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  902485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  902492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902504 */     // MIs[0] policy
     /*  902504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  902517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902535 */     GIR_RootConstrainSelectedInstOperands,
     /*  902536 */     // GIR_Coverage, 4763,
     /*  902536 */     GIR_EraseRootFromParent_Done,
     /*  902537 */   // Label 13647: @902537
     /*  902537 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(902614), // Rule ID 4766 //
     /*  902542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  902553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  902556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  902559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  902562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  902569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902581 */     // MIs[0] policy
     /*  902581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  902594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902612 */     GIR_RootConstrainSelectedInstOperands,
     /*  902613 */     // GIR_Coverage, 4766,
     /*  902613 */     GIR_EraseRootFromParent_Done,
     /*  902614 */   // Label 13648: @902614
     /*  902614 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(902691), // Rule ID 4767 //
     /*  902619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  902630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  902633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  902636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  902639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  902646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902658 */     // MIs[0] policy
     /*  902658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  902671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902689 */     GIR_RootConstrainSelectedInstOperands,
     /*  902690 */     // GIR_Coverage, 4767,
     /*  902690 */     GIR_EraseRootFromParent_Done,
     /*  902691 */   // Label 13649: @902691
     /*  902691 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(902768), // Rule ID 4770 //
     /*  902696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  902716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902735 */     // MIs[0] policy
     /*  902735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902745 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  902748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902766 */     GIR_RootConstrainSelectedInstOperands,
     /*  902767 */     // GIR_Coverage, 4770,
     /*  902767 */     GIR_EraseRootFromParent_Done,
     /*  902768 */   // Label 13650: @902768
     /*  902768 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(902845), // Rule ID 4771 //
     /*  902773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  902793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902812 */     // MIs[0] policy
     /*  902812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902822 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  902825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902843 */     GIR_RootConstrainSelectedInstOperands,
     /*  902844 */     // GIR_Coverage, 4771,
     /*  902844 */     GIR_EraseRootFromParent_Done,
     /*  902845 */   // Label 13651: @902845
     /*  902845 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(902922), // Rule ID 4774 //
     /*  902850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  902853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  902870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902889 */     // MIs[0] policy
     /*  902889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  902899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  902902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902920 */     GIR_RootConstrainSelectedInstOperands,
     /*  902921 */     // GIR_Coverage, 4774,
     /*  902921 */     GIR_EraseRootFromParent_Done,
     /*  902922 */   // Label 13652: @902922
     /*  902922 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(902999), // Rule ID 4775 //
     /*  902927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  902930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  902935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  902947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  902954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  902966 */     // MIs[0] policy
     /*  902966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  902969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  902976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  902979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  902985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  902987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  902997 */     GIR_RootConstrainSelectedInstOperands,
     /*  902998 */     // GIR_Coverage, 4775,
     /*  902998 */     GIR_EraseRootFromParent_Done,
     /*  902999 */   // Label 13653: @902999
     /*  902999 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(903076), // Rule ID 4778 //
     /*  903004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  903007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  903015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  903018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  903024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  903031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903043 */     // MIs[0] policy
     /*  903043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903053 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  903056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903074 */     GIR_RootConstrainSelectedInstOperands,
     /*  903075 */     // GIR_Coverage, 4778,
     /*  903075 */     GIR_EraseRootFromParent_Done,
     /*  903076 */   // Label 13654: @903076
     /*  903076 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(903153), // Rule ID 4779 //
     /*  903081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  903084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  903092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  903095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  903101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  903108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903120 */     // MIs[0] policy
     /*  903120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  903133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903151 */     GIR_RootConstrainSelectedInstOperands,
     /*  903152 */     // GIR_Coverage, 4779,
     /*  903152 */     GIR_EraseRootFromParent_Done,
     /*  903153 */   // Label 13655: @903153
     /*  903153 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(903230), // Rule ID 4782 //
     /*  903158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  903161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  903169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  903172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  903178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  903185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903197 */     // MIs[0] policy
     /*  903197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903207 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  903210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903228 */     GIR_RootConstrainSelectedInstOperands,
     /*  903229 */     // GIR_Coverage, 4782,
     /*  903229 */     GIR_EraseRootFromParent_Done,
     /*  903230 */   // Label 13656: @903230
     /*  903230 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(903307), // Rule ID 4783 //
     /*  903235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  903238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  903246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  903249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  903255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  903262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903274 */     // MIs[0] policy
     /*  903274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  903287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903305 */     GIR_RootConstrainSelectedInstOperands,
     /*  903306 */     // GIR_Coverage, 4783,
     /*  903306 */     GIR_EraseRootFromParent_Done,
     /*  903307 */   // Label 13657: @903307
     /*  903307 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(903384), // Rule ID 4786 //
     /*  903312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  903315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  903323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  903326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  903332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  903339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903351 */     // MIs[0] policy
     /*  903351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  903364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903382 */     GIR_RootConstrainSelectedInstOperands,
     /*  903383 */     // GIR_Coverage, 4786,
     /*  903383 */     GIR_EraseRootFromParent_Done,
     /*  903384 */   // Label 13658: @903384
     /*  903384 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(903461), // Rule ID 4787 //
     /*  903389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  903392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  903400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  903403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  903409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  903416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903428 */     // MIs[0] policy
     /*  903428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  903441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903459 */     GIR_RootConstrainSelectedInstOperands,
     /*  903460 */     // GIR_Coverage, 4787,
     /*  903460 */     GIR_EraseRootFromParent_Done,
     /*  903461 */   // Label 13659: @903461
     /*  903461 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(903538), // Rule ID 4790 //
     /*  903466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  903469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  903486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  903493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903505 */     // MIs[0] policy
     /*  903505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  903518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903536 */     GIR_RootConstrainSelectedInstOperands,
     /*  903537 */     // GIR_Coverage, 4790,
     /*  903537 */     GIR_EraseRootFromParent_Done,
     /*  903538 */   // Label 13660: @903538
     /*  903538 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(903615), // Rule ID 4791 //
     /*  903543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  903546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  903563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  903570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903582 */     // MIs[0] policy
     /*  903582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  903595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903613 */     GIR_RootConstrainSelectedInstOperands,
     /*  903614 */     // GIR_Coverage, 4791,
     /*  903614 */     GIR_EraseRootFromParent_Done,
     /*  903615 */   // Label 13661: @903615
     /*  903615 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(903692), // Rule ID 4794 //
     /*  903620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  903623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  903631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  903634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  903640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  903647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903659 */     // MIs[0] policy
     /*  903659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  903672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903690 */     GIR_RootConstrainSelectedInstOperands,
     /*  903691 */     // GIR_Coverage, 4794,
     /*  903691 */     GIR_EraseRootFromParent_Done,
     /*  903692 */   // Label 13662: @903692
     /*  903692 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(903769), // Rule ID 4795 //
     /*  903697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  903700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  903708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  903711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  903717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  903724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903736 */     // MIs[0] policy
     /*  903736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  903749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903767 */     GIR_RootConstrainSelectedInstOperands,
     /*  903768 */     // GIR_Coverage, 4795,
     /*  903768 */     GIR_EraseRootFromParent_Done,
     /*  903769 */   // Label 13663: @903769
     /*  903769 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(903846), // Rule ID 4798 //
     /*  903774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  903777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  903785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  903788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  903791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  903794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  903801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903813 */     // MIs[0] policy
     /*  903813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903823 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  903826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903844 */     GIR_RootConstrainSelectedInstOperands,
     /*  903845 */     // GIR_Coverage, 4798,
     /*  903845 */     GIR_EraseRootFromParent_Done,
     /*  903846 */   // Label 13664: @903846
     /*  903846 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(903923), // Rule ID 4799 //
     /*  903851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  903854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  903862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  903865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  903868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  903871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  903878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903890 */     // MIs[0] policy
     /*  903890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903900 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  903900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  903903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903921 */     GIR_RootConstrainSelectedInstOperands,
     /*  903922 */     // GIR_Coverage, 4799,
     /*  903922 */     GIR_EraseRootFromParent_Done,
     /*  903923 */   // Label 13665: @903923
     /*  903923 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(904000), // Rule ID 4802 //
     /*  903928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  903931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  903936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  903939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  903942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  903945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  903948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  903955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  903967 */     // MIs[0] policy
     /*  903967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  903970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  903977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  903980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  903986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  903988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  903998 */     GIR_RootConstrainSelectedInstOperands,
     /*  903999 */     // GIR_Coverage, 4802,
     /*  903999 */     GIR_EraseRootFromParent_Done,
     /*  904000 */   // Label 13666: @904000
     /*  904000 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(904077), // Rule ID 4803 //
     /*  904005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  904008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  904025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  904032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904044 */     // MIs[0] policy
     /*  904044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  904057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904075 */     GIR_RootConstrainSelectedInstOperands,
     /*  904076 */     // GIR_Coverage, 4803,
     /*  904076 */     GIR_EraseRootFromParent_Done,
     /*  904077 */   // Label 13667: @904077
     /*  904077 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(904154), // Rule ID 4806 //
     /*  904082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  904085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  904093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  904096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  904099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  904102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904121 */     // MIs[0] policy
     /*  904121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904131 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  904134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904152 */     GIR_RootConstrainSelectedInstOperands,
     /*  904153 */     // GIR_Coverage, 4806,
     /*  904153 */     GIR_EraseRootFromParent_Done,
     /*  904154 */   // Label 13668: @904154
     /*  904154 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(904231), // Rule ID 4807 //
     /*  904159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  904162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  904170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  904173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  904176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  904179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904198 */     // MIs[0] policy
     /*  904198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  904211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904229 */     GIR_RootConstrainSelectedInstOperands,
     /*  904230 */     // GIR_Coverage, 4807,
     /*  904230 */     GIR_EraseRootFromParent_Done,
     /*  904231 */   // Label 13669: @904231
     /*  904231 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(904308), // Rule ID 4810 //
     /*  904236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  904239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  904247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  904250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  904253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  904256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904275 */     // MIs[0] policy
     /*  904275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  904288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904306 */     GIR_RootConstrainSelectedInstOperands,
     /*  904307 */     // GIR_Coverage, 4810,
     /*  904307 */     GIR_EraseRootFromParent_Done,
     /*  904308 */   // Label 13670: @904308
     /*  904308 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(904385), // Rule ID 4811 //
     /*  904313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  904316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  904324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  904327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  904330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  904333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904352 */     // MIs[0] policy
     /*  904352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  904365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904383 */     GIR_RootConstrainSelectedInstOperands,
     /*  904384 */     // GIR_Coverage, 4811,
     /*  904384 */     GIR_EraseRootFromParent_Done,
     /*  904385 */   // Label 13671: @904385
     /*  904385 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(904462), // Rule ID 4814 //
     /*  904390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  904393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  904407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  904410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  904417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904429 */     // MIs[0] policy
     /*  904429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  904442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904460 */     GIR_RootConstrainSelectedInstOperands,
     /*  904461 */     // GIR_Coverage, 4814,
     /*  904461 */     GIR_EraseRootFromParent_Done,
     /*  904462 */   // Label 13672: @904462
     /*  904462 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(904539), // Rule ID 4815 //
     /*  904467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  904470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  904484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  904487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  904494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904506 */     // MIs[0] policy
     /*  904506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  904519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904537 */     GIR_RootConstrainSelectedInstOperands,
     /*  904538 */     // GIR_Coverage, 4815,
     /*  904538 */     GIR_EraseRootFromParent_Done,
     /*  904539 */   // Label 13673: @904539
     /*  904539 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(904616), // Rule ID 4818 //
     /*  904544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  904547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  904561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  904564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  904571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904583 */     // MIs[0] policy
     /*  904583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  904596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904614 */     GIR_RootConstrainSelectedInstOperands,
     /*  904615 */     // GIR_Coverage, 4818,
     /*  904615 */     GIR_EraseRootFromParent_Done,
     /*  904616 */   // Label 13674: @904616
     /*  904616 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(904693), // Rule ID 4819 //
     /*  904621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  904624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  904638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  904641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  904648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904660 */     // MIs[0] policy
     /*  904660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  904673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904691 */     GIR_RootConstrainSelectedInstOperands,
     /*  904692 */     // GIR_Coverage, 4819,
     /*  904692 */     GIR_EraseRootFromParent_Done,
     /*  904693 */   // Label 13675: @904693
     /*  904693 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(904770), // Rule ID 4822 //
     /*  904698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  904701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  904715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  904718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  904725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904737 */     // MIs[0] policy
     /*  904737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  904750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904768 */     GIR_RootConstrainSelectedInstOperands,
     /*  904769 */     // GIR_Coverage, 4822,
     /*  904769 */     GIR_EraseRootFromParent_Done,
     /*  904770 */   // Label 13676: @904770
     /*  904770 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(904847), // Rule ID 4823 //
     /*  904775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  904778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  904792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  904795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  904802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904814 */     // MIs[0] policy
     /*  904814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  904827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904845 */     GIR_RootConstrainSelectedInstOperands,
     /*  904846 */     // GIR_Coverage, 4823,
     /*  904846 */     GIR_EraseRootFromParent_Done,
     /*  904847 */   // Label 13677: @904847
     /*  904847 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(904924), // Rule ID 4826 //
     /*  904852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  904855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  904863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  904866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  904869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  904872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904891 */     // MIs[0] policy
     /*  904891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904901 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  904901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  904904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904922 */     GIR_RootConstrainSelectedInstOperands,
     /*  904923 */     // GIR_Coverage, 4826,
     /*  904923 */     GIR_EraseRootFromParent_Done,
     /*  904924 */   // Label 13678: @904924
     /*  904924 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(905001), // Rule ID 4827 //
     /*  904929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  904932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  904937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  904940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  904943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  904946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  904949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  904956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  904968 */     // MIs[0] policy
     /*  904968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  904971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  904978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  904981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  904987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  904989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  904999 */     GIR_RootConstrainSelectedInstOperands,
     /*  905000 */     // GIR_Coverage, 4827,
     /*  905000 */     GIR_EraseRootFromParent_Done,
     /*  905001 */   // Label 13679: @905001
     /*  905001 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(905078), // Rule ID 4830 //
     /*  905006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  905023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  905026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  905033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905045 */     // MIs[0] policy
     /*  905045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  905058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905076 */     GIR_RootConstrainSelectedInstOperands,
     /*  905077 */     // GIR_Coverage, 4830,
     /*  905077 */     GIR_EraseRootFromParent_Done,
     /*  905078 */   // Label 13680: @905078
     /*  905078 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(905155), // Rule ID 4831 //
     /*  905083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  905100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  905103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  905110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905122 */     // MIs[0] policy
     /*  905122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  905135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905153 */     GIR_RootConstrainSelectedInstOperands,
     /*  905154 */     // GIR_Coverage, 4831,
     /*  905154 */     GIR_EraseRootFromParent_Done,
     /*  905155 */   // Label 13681: @905155
     /*  905155 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(905232), // Rule ID 4834 //
     /*  905160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  905177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  905180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  905187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905199 */     // MIs[0] policy
     /*  905199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905209 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  905212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905230 */     GIR_RootConstrainSelectedInstOperands,
     /*  905231 */     // GIR_Coverage, 4834,
     /*  905231 */     GIR_EraseRootFromParent_Done,
     /*  905232 */   // Label 13682: @905232
     /*  905232 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(905309), // Rule ID 4835 //
     /*  905237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  905254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  905257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  905264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905276 */     // MIs[0] policy
     /*  905276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  905289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905307 */     GIR_RootConstrainSelectedInstOperands,
     /*  905308 */     // GIR_Coverage, 4835,
     /*  905308 */     GIR_EraseRootFromParent_Done,
     /*  905309 */   // Label 13683: @905309
     /*  905309 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(905386), // Rule ID 4838 //
     /*  905314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  905331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  905334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  905341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905353 */     // MIs[0] policy
     /*  905353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905363 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  905366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905384 */     GIR_RootConstrainSelectedInstOperands,
     /*  905385 */     // GIR_Coverage, 4838,
     /*  905385 */     GIR_EraseRootFromParent_Done,
     /*  905386 */   // Label 13684: @905386
     /*  905386 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(905463), // Rule ID 4839 //
     /*  905391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  905408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  905411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  905418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905430 */     // MIs[0] policy
     /*  905430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  905443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905461 */     GIR_RootConstrainSelectedInstOperands,
     /*  905462 */     // GIR_Coverage, 4839,
     /*  905462 */     GIR_EraseRootFromParent_Done,
     /*  905463 */   // Label 13685: @905463
     /*  905463 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(905540), // Rule ID 4842 //
     /*  905468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  905479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  905482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  905488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  905495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905507 */     // MIs[0] policy
     /*  905507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  905520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905538 */     GIR_RootConstrainSelectedInstOperands,
     /*  905539 */     // GIR_Coverage, 4842,
     /*  905539 */     GIR_EraseRootFromParent_Done,
     /*  905540 */   // Label 13686: @905540
     /*  905540 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(905617), // Rule ID 4843 //
     /*  905545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  905556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  905559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  905565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  905572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905584 */     // MIs[0] policy
     /*  905584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  905597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905615 */     GIR_RootConstrainSelectedInstOperands,
     /*  905616 */     // GIR_Coverage, 4843,
     /*  905616 */     GIR_EraseRootFromParent_Done,
     /*  905617 */   // Label 13687: @905617
     /*  905617 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(905694), // Rule ID 4846 //
     /*  905622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  905642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  905649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905661 */     // MIs[0] policy
     /*  905661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /*  905674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905692 */     GIR_RootConstrainSelectedInstOperands,
     /*  905693 */     // GIR_Coverage, 4846,
     /*  905693 */     GIR_EraseRootFromParent_Done,
     /*  905694 */   // Label 13688: @905694
     /*  905694 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(905771), // Rule ID 4847 //
     /*  905699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  905719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  905726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905738 */     // MIs[0] policy
     /*  905738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /*  905751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905769 */     GIR_RootConstrainSelectedInstOperands,
     /*  905770 */     // GIR_Coverage, 4847,
     /*  905770 */     GIR_EraseRootFromParent_Done,
     /*  905771 */   // Label 13689: @905771
     /*  905771 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(905848), // Rule ID 4850 //
     /*  905776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  905796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  905803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905815 */     // MIs[0] policy
     /*  905815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905825 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /*  905828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905846 */     GIR_RootConstrainSelectedInstOperands,
     /*  905847 */     // GIR_Coverage, 4850,
     /*  905847 */     GIR_EraseRootFromParent_Done,
     /*  905848 */   // Label 13690: @905848
     /*  905848 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(905925), // Rule ID 4851 //
     /*  905853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  905856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  905873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  905880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905892 */     // MIs[0] policy
     /*  905892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  905902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /*  905905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  905923 */     GIR_RootConstrainSelectedInstOperands,
     /*  905924 */     // GIR_Coverage, 4851,
     /*  905924 */     GIR_EraseRootFromParent_Done,
     /*  905925 */   // Label 13691: @905925
     /*  905925 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(906002), // Rule ID 4854 //
     /*  905930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  905933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  905938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  905947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  905950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  905957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  905969 */     // MIs[0] policy
     /*  905969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  905972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905979 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  905979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /*  905982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  905990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906000 */     GIR_RootConstrainSelectedInstOperands,
     /*  906001 */     // GIR_Coverage, 4854,
     /*  906001 */     GIR_EraseRootFromParent_Done,
     /*  906002 */   // Label 13692: @906002
     /*  906002 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(906079), // Rule ID 4855 //
     /*  906007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  906010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  906015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  906018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  906021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  906027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  906034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906046 */     // MIs[0] policy
     /*  906046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /*  906059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  906075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906077 */     GIR_RootConstrainSelectedInstOperands,
     /*  906078 */     // GIR_Coverage, 4855,
     /*  906078 */     GIR_EraseRootFromParent_Done,
     /*  906079 */   // Label 13693: @906079
     /*  906079 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(906156), // Rule ID 4858 //
     /*  906084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  906104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906123 */     // MIs[0] policy
     /*  906123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906133 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /*  906136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906154 */     GIR_RootConstrainSelectedInstOperands,
     /*  906155 */     // GIR_Coverage, 4858,
     /*  906155 */     GIR_EraseRootFromParent_Done,
     /*  906156 */   // Label 13694: @906156
     /*  906156 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(906233), // Rule ID 4859 //
     /*  906161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  906181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906200 */     // MIs[0] policy
     /*  906200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /*  906213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906231 */     GIR_RootConstrainSelectedInstOperands,
     /*  906232 */     // GIR_Coverage, 4859,
     /*  906232 */     GIR_EraseRootFromParent_Done,
     /*  906233 */   // Label 13695: @906233
     /*  906233 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(906310), // Rule ID 4862 //
     /*  906238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  906258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906277 */     // MIs[0] policy
     /*  906277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906287 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /*  906290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906308 */     GIR_RootConstrainSelectedInstOperands,
     /*  906309 */     // GIR_Coverage, 4862,
     /*  906309 */     GIR_EraseRootFromParent_Done,
     /*  906310 */   // Label 13696: @906310
     /*  906310 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(906387), // Rule ID 4863 //
     /*  906315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  906335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906354 */     // MIs[0] policy
     /*  906354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /*  906367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906385 */     GIR_RootConstrainSelectedInstOperands,
     /*  906386 */     // GIR_Coverage, 4863,
     /*  906386 */     GIR_EraseRootFromParent_Done,
     /*  906387 */   // Label 13697: @906387
     /*  906387 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(906464), // Rule ID 4866 //
     /*  906392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  906412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906431 */     // MIs[0] policy
     /*  906431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906441 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  906444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906462 */     GIR_RootConstrainSelectedInstOperands,
     /*  906463 */     // GIR_Coverage, 4866,
     /*  906463 */     GIR_EraseRootFromParent_Done,
     /*  906464 */   // Label 13698: @906464
     /*  906464 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(906541), // Rule ID 4867 //
     /*  906469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  906489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  906496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906508 */     // MIs[0] policy
     /*  906508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  906521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906539 */     GIR_RootConstrainSelectedInstOperands,
     /*  906540 */     // GIR_Coverage, 4867,
     /*  906540 */     GIR_EraseRootFromParent_Done,
     /*  906541 */   // Label 13699: @906541
     /*  906541 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(906618), // Rule ID 4870 //
     /*  906546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  906557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  906560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  906566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  906573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  906577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906585 */     // MIs[0] policy
     /*  906585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  906598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906616 */     GIR_RootConstrainSelectedInstOperands,
     /*  906617 */     // GIR_Coverage, 4870,
     /*  906617 */     GIR_EraseRootFromParent_Done,
     /*  906618 */   // Label 13700: @906618
     /*  906618 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(906695), // Rule ID 4871 //
     /*  906623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  906634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  906637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  906643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  906650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  906654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906662 */     // MIs[0] policy
     /*  906662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  906675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906693 */     GIR_RootConstrainSelectedInstOperands,
     /*  906694 */     // GIR_Coverage, 4871,
     /*  906694 */     GIR_EraseRootFromParent_Done,
     /*  906695 */   // Label 13701: @906695
     /*  906695 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(906772), // Rule ID 4874 //
     /*  906700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  906711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  906714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  906717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  906720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  906727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  906731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  906735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906739 */     // MIs[0] policy
     /*  906739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906749 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  906752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906770 */     GIR_RootConstrainSelectedInstOperands,
     /*  906771 */     // GIR_Coverage, 4874,
     /*  906771 */     GIR_EraseRootFromParent_Done,
     /*  906772 */   // Label 13702: @906772
     /*  906772 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(906849), // Rule ID 4875 //
     /*  906777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  906788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  906791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  906794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  906797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  906804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  906808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  906812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906816 */     // MIs[0] policy
     /*  906816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  906829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906847 */     GIR_RootConstrainSelectedInstOperands,
     /*  906848 */     // GIR_Coverage, 4875,
     /*  906848 */     GIR_EraseRootFromParent_Done,
     /*  906849 */   // Label 13703: @906849
     /*  906849 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(906926), // Rule ID 4878 //
     /*  906854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  906857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  906865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  906868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  906871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  906874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  906881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  906889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906893 */     // MIs[0] policy
     /*  906893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906903 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  906903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  906906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  906924 */     GIR_RootConstrainSelectedInstOperands,
     /*  906925 */     // GIR_Coverage, 4878,
     /*  906925 */     GIR_EraseRootFromParent_Done,
     /*  906926 */   // Label 13704: @906926
     /*  906926 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(907003), // Rule ID 4879 //
     /*  906931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  906934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  906939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  906942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  906945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  906948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  906951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  906958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  906966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  906970 */     // MIs[0] policy
     /*  906970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  906973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  906980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  906983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  906991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907001 */     GIR_RootConstrainSelectedInstOperands,
     /*  907002 */     // GIR_Coverage, 4879,
     /*  907002 */     GIR_EraseRootFromParent_Done,
     /*  907003 */   // Label 13705: @907003
     /*  907003 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(907080), // Rule ID 4882 //
     /*  907008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  907011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  907022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  907028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907047 */     // MIs[0] policy
     /*  907047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907057 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /*  907060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907078 */     GIR_RootConstrainSelectedInstOperands,
     /*  907079 */     // GIR_Coverage, 4882,
     /*  907079 */     GIR_EraseRootFromParent_Done,
     /*  907080 */   // Label 13706: @907080
     /*  907080 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(907157), // Rule ID 4883 //
     /*  907085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  907088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  907099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  907105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907124 */     // MIs[0] policy
     /*  907124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /*  907137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907155 */     GIR_RootConstrainSelectedInstOperands,
     /*  907156 */     // GIR_Coverage, 4883,
     /*  907156 */     GIR_EraseRootFromParent_Done,
     /*  907157 */   // Label 13707: @907157
     /*  907157 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(907234), // Rule ID 4886 //
     /*  907162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  907165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  907176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  907182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907201 */     // MIs[0] policy
     /*  907201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907211 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  907214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907232 */     GIR_RootConstrainSelectedInstOperands,
     /*  907233 */     // GIR_Coverage, 4886,
     /*  907233 */     GIR_EraseRootFromParent_Done,
     /*  907234 */   // Label 13708: @907234
     /*  907234 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(907311), // Rule ID 4887 //
     /*  907239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  907242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  907253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  907259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907278 */     // MIs[0] policy
     /*  907278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  907291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907309 */     GIR_RootConstrainSelectedInstOperands,
     /*  907310 */     // GIR_Coverage, 4887,
     /*  907310 */     GIR_EraseRootFromParent_Done,
     /*  907311 */   // Label 13709: @907311
     /*  907311 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(907388), // Rule ID 4890 //
     /*  907316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  907319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  907327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  907330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  907336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  907343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907355 */     // MIs[0] policy
     /*  907355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  907368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907386 */     GIR_RootConstrainSelectedInstOperands,
     /*  907387 */     // GIR_Coverage, 4890,
     /*  907387 */     GIR_EraseRootFromParent_Done,
     /*  907388 */   // Label 13710: @907388
     /*  907388 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(907465), // Rule ID 4891 //
     /*  907393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  907396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  907404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  907407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  907413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  907420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907432 */     // MIs[0] policy
     /*  907432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  907445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907463 */     GIR_RootConstrainSelectedInstOperands,
     /*  907464 */     // GIR_Coverage, 4891,
     /*  907464 */     GIR_EraseRootFromParent_Done,
     /*  907465 */   // Label 13711: @907465
     /*  907465 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(907542), // Rule ID 4894 //
     /*  907470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  907473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  907481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  907484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  907490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  907497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907509 */     // MIs[0] policy
     /*  907509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907519 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  907522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907540 */     GIR_RootConstrainSelectedInstOperands,
     /*  907541 */     // GIR_Coverage, 4894,
     /*  907541 */     GIR_EraseRootFromParent_Done,
     /*  907542 */   // Label 13712: @907542
     /*  907542 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(907619), // Rule ID 4895 //
     /*  907547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  907550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  907558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  907561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  907567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  907574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907586 */     // MIs[0] policy
     /*  907586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  907599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907617 */     GIR_RootConstrainSelectedInstOperands,
     /*  907618 */     // GIR_Coverage, 4895,
     /*  907618 */     GIR_EraseRootFromParent_Done,
     /*  907619 */   // Label 13713: @907619
     /*  907619 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(907696), // Rule ID 4898 //
     /*  907624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  907627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  907635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  907638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  907644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  907651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907663 */     // MIs[0] policy
     /*  907663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907673 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  907676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907694 */     GIR_RootConstrainSelectedInstOperands,
     /*  907695 */     // GIR_Coverage, 4898,
     /*  907695 */     GIR_EraseRootFromParent_Done,
     /*  907696 */   // Label 13714: @907696
     /*  907696 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(907773), // Rule ID 4899 //
     /*  907701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  907704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  907712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  907715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  907721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  907728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907740 */     // MIs[0] policy
     /*  907740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  907753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907771 */     GIR_RootConstrainSelectedInstOperands,
     /*  907772 */     // GIR_Coverage, 4899,
     /*  907772 */     GIR_EraseRootFromParent_Done,
     /*  907773 */   // Label 13715: @907773
     /*  907773 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(907850), // Rule ID 4902 //
     /*  907778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  907781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  907792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  907798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907817 */     // MIs[0] policy
     /*  907817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  907830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907848 */     GIR_RootConstrainSelectedInstOperands,
     /*  907849 */     // GIR_Coverage, 4902,
     /*  907849 */     GIR_EraseRootFromParent_Done,
     /*  907850 */   // Label 13716: @907850
     /*  907850 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(907927), // Rule ID 4903 //
     /*  907855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  907858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  907869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  907875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  907882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907894 */     // MIs[0] policy
     /*  907894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  907904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /*  907907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  907925 */     GIR_RootConstrainSelectedInstOperands,
     /*  907926 */     // GIR_Coverage, 4903,
     /*  907926 */     GIR_EraseRootFromParent_Done,
     /*  907927 */   // Label 13717: @907927
     /*  907927 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(908004), // Rule ID 4906 //
     /*  907932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  907935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  907940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  907943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  907946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  907952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  907959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  907971 */     // MIs[0] policy
     /*  907971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  907974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  907981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  907984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  907990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  907992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908002 */     GIR_RootConstrainSelectedInstOperands,
     /*  908003 */     // GIR_Coverage, 4906,
     /*  908003 */     GIR_EraseRootFromParent_Done,
     /*  908004 */   // Label 13718: @908004
     /*  908004 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(908081), // Rule ID 4907 //
     /*  908009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  908012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  908023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  908029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  908036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908048 */     // MIs[0] policy
     /*  908048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /*  908061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908079 */     GIR_RootConstrainSelectedInstOperands,
     /*  908080 */     // GIR_Coverage, 4907,
     /*  908080 */     GIR_EraseRootFromParent_Done,
     /*  908081 */   // Label 13719: @908081
     /*  908081 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(908158), // Rule ID 4910 //
     /*  908086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  908089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  908106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  908113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908125 */     // MIs[0] policy
     /*  908125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908135 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  908138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908156 */     GIR_RootConstrainSelectedInstOperands,
     /*  908157 */     // GIR_Coverage, 4910,
     /*  908157 */     GIR_EraseRootFromParent_Done,
     /*  908158 */   // Label 13720: @908158
     /*  908158 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(908235), // Rule ID 4911 //
     /*  908163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  908166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  908183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  908190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908202 */     // MIs[0] policy
     /*  908202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /*  908215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908233 */     GIR_RootConstrainSelectedInstOperands,
     /*  908234 */     // GIR_Coverage, 4911,
     /*  908234 */     GIR_EraseRootFromParent_Done,
     /*  908235 */   // Label 13721: @908235
     /*  908235 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(908312), // Rule ID 4914 //
     /*  908240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  908243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  908260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  908267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908279 */     // MIs[0] policy
     /*  908279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  908292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908310 */     GIR_RootConstrainSelectedInstOperands,
     /*  908311 */     // GIR_Coverage, 4914,
     /*  908311 */     GIR_EraseRootFromParent_Done,
     /*  908312 */   // Label 13722: @908312
     /*  908312 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(908389), // Rule ID 4915 //
     /*  908317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  908320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  908337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  908344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908356 */     // MIs[0] policy
     /*  908356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /*  908369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908387 */     GIR_RootConstrainSelectedInstOperands,
     /*  908388 */     // GIR_Coverage, 4915,
     /*  908388 */     GIR_EraseRootFromParent_Done,
     /*  908389 */   // Label 13723: @908389
     /*  908389 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(908466), // Rule ID 4918 //
     /*  908394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  908397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  908405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  908408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  908411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  908414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  908421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908433 */     // MIs[0] policy
     /*  908433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /*  908446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908464 */     GIR_RootConstrainSelectedInstOperands,
     /*  908465 */     // GIR_Coverage, 4918,
     /*  908465 */     GIR_EraseRootFromParent_Done,
     /*  908466 */   // Label 13724: @908466
     /*  908466 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(908543), // Rule ID 4919 //
     /*  908471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  908474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  908482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  908485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  908488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  908491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  908498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908510 */     // MIs[0] policy
     /*  908510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /*  908523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908541 */     GIR_RootConstrainSelectedInstOperands,
     /*  908542 */     // GIR_Coverage, 4919,
     /*  908542 */     GIR_EraseRootFromParent_Done,
     /*  908543 */   // Label 13725: @908543
     /*  908543 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(908620), // Rule ID 4922 //
     /*  908548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  908551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  908565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  908568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  908575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908587 */     // MIs[0] policy
     /*  908587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908597 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /*  908600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908618 */     GIR_RootConstrainSelectedInstOperands,
     /*  908619 */     // GIR_Coverage, 4922,
     /*  908619 */     GIR_EraseRootFromParent_Done,
     /*  908620 */   // Label 13726: @908620
     /*  908620 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(908697), // Rule ID 4923 //
     /*  908625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  908628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  908642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  908645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  908652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908664 */     // MIs[0] policy
     /*  908664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /*  908677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908695 */     GIR_RootConstrainSelectedInstOperands,
     /*  908696 */     // GIR_Coverage, 4923,
     /*  908696 */     GIR_EraseRootFromParent_Done,
     /*  908697 */   // Label 13727: @908697
     /*  908697 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(908774), // Rule ID 4926 //
     /*  908702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  908705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  908719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  908722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  908729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908741 */     // MIs[0] policy
     /*  908741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /*  908754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908772 */     GIR_RootConstrainSelectedInstOperands,
     /*  908773 */     // GIR_Coverage, 4926,
     /*  908773 */     GIR_EraseRootFromParent_Done,
     /*  908774 */   // Label 13728: @908774
     /*  908774 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(908851), // Rule ID 4927 //
     /*  908779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  908782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  908796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  908799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  908806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908818 */     // MIs[0] policy
     /*  908818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /*  908831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908849 */     GIR_RootConstrainSelectedInstOperands,
     /*  908850 */     // GIR_Coverage, 4927,
     /*  908850 */     GIR_EraseRootFromParent_Done,
     /*  908851 */   // Label 13729: @908851
     /*  908851 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(908928), // Rule ID 4930 //
     /*  908856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  908859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  908873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  908876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  908883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908895 */     // MIs[0] policy
     /*  908895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908905 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  908905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /*  908908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  908926 */     GIR_RootConstrainSelectedInstOperands,
     /*  908927 */     // GIR_Coverage, 4930,
     /*  908927 */     GIR_EraseRootFromParent_Done,
     /*  908928 */   // Label 13730: @908928
     /*  908928 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(909005), // Rule ID 4931 //
     /*  908933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  908936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  908941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  908950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  908953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  908960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  908972 */     // MIs[0] policy
     /*  908972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  908975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  908982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /*  908985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  908991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  908993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909003 */     GIR_RootConstrainSelectedInstOperands,
     /*  909004 */     // GIR_Coverage, 4931,
     /*  909004 */     GIR_EraseRootFromParent_Done,
     /*  909005 */   // Label 13731: @909005
     /*  909005 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(909082), // Rule ID 4934 //
     /*  909010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  909013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  909027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  909030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  909037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909049 */     // MIs[0] policy
     /*  909049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /*  909062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909080 */     GIR_RootConstrainSelectedInstOperands,
     /*  909081 */     // GIR_Coverage, 4934,
     /*  909081 */     GIR_EraseRootFromParent_Done,
     /*  909082 */   // Label 13732: @909082
     /*  909082 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(909159), // Rule ID 4935 //
     /*  909087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  909090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  909104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  909107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  909114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909126 */     // MIs[0] policy
     /*  909126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /*  909139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909157 */     GIR_RootConstrainSelectedInstOperands,
     /*  909158 */     // GIR_Coverage, 4935,
     /*  909158 */     GIR_EraseRootFromParent_Done,
     /*  909159 */   // Label 13733: @909159
     /*  909159 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(909236), // Rule ID 4938 //
     /*  909164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  909175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  909178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  909184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  909191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909203 */     // MIs[0] policy
     /*  909203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909213 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /*  909216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909234 */     GIR_RootConstrainSelectedInstOperands,
     /*  909235 */     // GIR_Coverage, 4938,
     /*  909235 */     GIR_EraseRootFromParent_Done,
     /*  909236 */   // Label 13734: @909236
     /*  909236 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(909313), // Rule ID 4939 //
     /*  909241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  909244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  909252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  909255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  909261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  909268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909280 */     // MIs[0] policy
     /*  909280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /*  909293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909311 */     GIR_RootConstrainSelectedInstOperands,
     /*  909312 */     // GIR_Coverage, 4939,
     /*  909312 */     GIR_EraseRootFromParent_Done,
     /*  909313 */   // Label 13735: @909313
     /*  909313 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(909390), // Rule ID 4942 //
     /*  909318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  909332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  909335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  909338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  909345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909357 */     // MIs[0] policy
     /*  909357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /*  909370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909388 */     GIR_RootConstrainSelectedInstOperands,
     /*  909389 */     // GIR_Coverage, 4942,
     /*  909389 */     GIR_EraseRootFromParent_Done,
     /*  909390 */   // Label 13736: @909390
     /*  909390 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(909467), // Rule ID 4943 //
     /*  909395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  909398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  909409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  909412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  909415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  909422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909434 */     // MIs[0] policy
     /*  909434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /*  909447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909465 */     GIR_RootConstrainSelectedInstOperands,
     /*  909466 */     // GIR_Coverage, 4943,
     /*  909466 */     GIR_EraseRootFromParent_Done,
     /*  909467 */   // Label 13737: @909467
     /*  909467 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(909544), // Rule ID 4946 //
     /*  909472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  909486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  909489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  909492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  909499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909511 */     // MIs[0] policy
     /*  909511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909521 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /*  909524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909542 */     GIR_RootConstrainSelectedInstOperands,
     /*  909543 */     // GIR_Coverage, 4946,
     /*  909543 */     GIR_EraseRootFromParent_Done,
     /*  909544 */   // Label 13738: @909544
     /*  909544 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(909621), // Rule ID 4947 //
     /*  909549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  909552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  909563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  909566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  909569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  909576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909588 */     // MIs[0] policy
     /*  909588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /*  909601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909619 */     GIR_RootConstrainSelectedInstOperands,
     /*  909620 */     // GIR_Coverage, 4947,
     /*  909620 */     GIR_EraseRootFromParent_Done,
     /*  909621 */   // Label 13739: @909621
     /*  909621 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(909698), // Rule ID 4950 //
     /*  909626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  909640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  909643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  909646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  909653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909665 */     // MIs[0] policy
     /*  909665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /*  909678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909696 */     GIR_RootConstrainSelectedInstOperands,
     /*  909697 */     // GIR_Coverage, 4950,
     /*  909697 */     GIR_EraseRootFromParent_Done,
     /*  909698 */   // Label 13740: @909698
     /*  909698 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(909775), // Rule ID 4951 //
     /*  909703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  909706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  909717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  909720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  909723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  909730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909742 */     // MIs[0] policy
     /*  909742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /*  909755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909773 */     GIR_RootConstrainSelectedInstOperands,
     /*  909774 */     // GIR_Coverage, 4951,
     /*  909774 */     GIR_EraseRootFromParent_Done,
     /*  909775 */   // Label 13741: @909775
     /*  909775 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(909852), // Rule ID 4954 //
     /*  909780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  909791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  909794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  909797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  909800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  909807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909819 */     // MIs[0] policy
     /*  909819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909829 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /*  909832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909850 */     GIR_RootConstrainSelectedInstOperands,
     /*  909851 */     // GIR_Coverage, 4954,
     /*  909851 */     GIR_EraseRootFromParent_Done,
     /*  909852 */   // Label 13742: @909852
     /*  909852 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(909929), // Rule ID 4955 //
     /*  909857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  909860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  909868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  909871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  909874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  909877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  909884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909896 */     // MIs[0] policy
     /*  909896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909906 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  909906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /*  909909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  909927 */     GIR_RootConstrainSelectedInstOperands,
     /*  909928 */     // GIR_Coverage, 4955,
     /*  909928 */     GIR_EraseRootFromParent_Done,
     /*  909929 */   // Label 13743: @909929
     /*  909929 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(910006), // Rule ID 4958 //
     /*  909934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  909937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  909942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  909948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  909951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  909954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  909961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  909973 */     // MIs[0] policy
     /*  909973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  909976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  909983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /*  909986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  909994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910004 */     GIR_RootConstrainSelectedInstOperands,
     /*  910005 */     // GIR_Coverage, 4958,
     /*  910005 */     GIR_EraseRootFromParent_Done,
     /*  910006 */   // Label 13744: @910006
     /*  910006 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(910083), // Rule ID 4959 //
     /*  910011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  910014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  910019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  910022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  910025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  910031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  910038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  910050 */     // MIs[0] policy
     /*  910050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /*  910063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  910067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  910069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  910071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910081 */     GIR_RootConstrainSelectedInstOperands,
     /*  910082 */     // GIR_Coverage, 4959,
     /*  910082 */     GIR_EraseRootFromParent_Done,
     /*  910083 */   // Label 13745: @910083
     /*  910083 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(910160), // Rule ID 4962 //
     /*  910088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  910091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  910096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  910099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  910102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  910108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  910115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  910127 */     // MIs[0] policy
     /*  910127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910137 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /*  910140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  910144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  910146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  910148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910158 */     GIR_RootConstrainSelectedInstOperands,
     /*  910159 */     // GIR_Coverage, 4962,
     /*  910159 */     GIR_EraseRootFromParent_Done,
     /*  910160 */   // Label 13746: @910160
     /*  910160 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(910237), // Rule ID 4963 //
     /*  910165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  910168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  910173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  910176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  910179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  910185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  910192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  910204 */     // MIs[0] policy
     /*  910204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /*  910217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  910221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  910223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  910225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910235 */     GIR_RootConstrainSelectedInstOperands,
     /*  910236 */     // GIR_Coverage, 4963,
     /*  910236 */     GIR_EraseRootFromParent_Done,
     /*  910237 */   // Label 13747: @910237
     /*  910237 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(910314), // Rule ID 4966 //
     /*  910242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  910245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  910250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  910256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  910259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  910262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  910269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  910281 */     // MIs[0] policy
     /*  910281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /*  910294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  910298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  910300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  910302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910312 */     GIR_RootConstrainSelectedInstOperands,
     /*  910313 */     // GIR_Coverage, 4966,
     /*  910313 */     GIR_EraseRootFromParent_Done,
     /*  910314 */   // Label 13748: @910314
     /*  910314 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(910391), // Rule ID 4967 //
     /*  910319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  910322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  910327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  910333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  910336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  910339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  910346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  910358 */     // MIs[0] policy
     /*  910358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /*  910371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  910375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  910377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  910379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910389 */     GIR_RootConstrainSelectedInstOperands,
     /*  910390 */     // GIR_Coverage, 4967,
     /*  910390 */     GIR_EraseRootFromParent_Done,
     /*  910391 */   // Label 13749: @910391
     /*  910391 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(910468), // Rule ID 12578 //
     /*  910396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  910399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  910410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910435 */     // MIs[0] policy
     /*  910435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*  910448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910466 */     GIR_RootConstrainSelectedInstOperands,
     /*  910467 */     // GIR_Coverage, 12578,
     /*  910467 */     GIR_EraseRootFromParent_Done,
     /*  910468 */   // Label 13750: @910468
     /*  910468 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(910545), // Rule ID 12579 //
     /*  910473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  910476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  910487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910512 */     // MIs[0] policy
     /*  910512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910522 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*  910525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910543 */     GIR_RootConstrainSelectedInstOperands,
     /*  910544 */     // GIR_Coverage, 12579,
     /*  910544 */     GIR_EraseRootFromParent_Done,
     /*  910545 */   // Label 13751: @910545
     /*  910545 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(910622), // Rule ID 12582 //
     /*  910550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  910553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  910564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910589 */     // MIs[0] policy
     /*  910589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910599 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  910602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910620 */     GIR_RootConstrainSelectedInstOperands,
     /*  910621 */     // GIR_Coverage, 12582,
     /*  910621 */     GIR_EraseRootFromParent_Done,
     /*  910622 */   // Label 13752: @910622
     /*  910622 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(910699), // Rule ID 12583 //
     /*  910627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  910630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  910641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910666 */     // MIs[0] policy
     /*  910666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910676 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  910679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910697 */     GIR_RootConstrainSelectedInstOperands,
     /*  910698 */     // GIR_Coverage, 12583,
     /*  910698 */     GIR_EraseRootFromParent_Done,
     /*  910699 */   // Label 13753: @910699
     /*  910699 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(910776), // Rule ID 12586 //
     /*  910704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  910707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  910718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910743 */     // MIs[0] policy
     /*  910743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910753 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*  910756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910774 */     GIR_RootConstrainSelectedInstOperands,
     /*  910775 */     // GIR_Coverage, 12586,
     /*  910775 */     GIR_EraseRootFromParent_Done,
     /*  910776 */   // Label 13754: @910776
     /*  910776 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(910853), // Rule ID 12587 //
     /*  910781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  910784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  910795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910820 */     // MIs[0] policy
     /*  910820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*  910833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910851 */     GIR_RootConstrainSelectedInstOperands,
     /*  910852 */     // GIR_Coverage, 12587,
     /*  910852 */     GIR_EraseRootFromParent_Done,
     /*  910853 */   // Label 13755: @910853
     /*  910853 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(910930), // Rule ID 12590 //
     /*  910858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  910861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  910872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  910881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910897 */     // MIs[0] policy
     /*  910897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  910907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  910910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  910928 */     GIR_RootConstrainSelectedInstOperands,
     /*  910929 */     // GIR_Coverage, 12590,
     /*  910929 */     GIR_EraseRootFromParent_Done,
     /*  910930 */   // Label 13756: @910930
     /*  910930 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(911007), // Rule ID 12591 //
     /*  910935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  910938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  910943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  910949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  910958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910974 */     // MIs[0] policy
     /*  910974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  910977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  910984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  910987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  910991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  910993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  910995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911005 */     GIR_RootConstrainSelectedInstOperands,
     /*  911006 */     // GIR_Coverage, 12591,
     /*  911006 */     GIR_EraseRootFromParent_Done,
     /*  911007 */   // Label 13757: @911007
     /*  911007 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(911084), // Rule ID 12594 //
     /*  911012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  911026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911051 */     // MIs[0] policy
     /*  911051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  911064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911082 */     GIR_RootConstrainSelectedInstOperands,
     /*  911083 */     // GIR_Coverage, 12594,
     /*  911083 */     GIR_EraseRootFromParent_Done,
     /*  911084 */   // Label 13758: @911084
     /*  911084 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(911161), // Rule ID 12595 //
     /*  911089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  911092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  911103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911128 */     // MIs[0] policy
     /*  911128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911138 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*  911141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911159 */     GIR_RootConstrainSelectedInstOperands,
     /*  911160 */     // GIR_Coverage, 12595,
     /*  911160 */     GIR_EraseRootFromParent_Done,
     /*  911161 */   // Label 13759: @911161
     /*  911161 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(911238), // Rule ID 12598 //
     /*  911166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  911180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911205 */     // MIs[0] policy
     /*  911205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911236 */     GIR_RootConstrainSelectedInstOperands,
     /*  911237 */     // GIR_Coverage, 12598,
     /*  911237 */     GIR_EraseRootFromParent_Done,
     /*  911238 */   // Label 13760: @911238
     /*  911238 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(911315), // Rule ID 12599 //
     /*  911243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  911246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  911257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911282 */     // MIs[0] policy
     /*  911282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911313 */     GIR_RootConstrainSelectedInstOperands,
     /*  911314 */     // GIR_Coverage, 12599,
     /*  911314 */     GIR_EraseRootFromParent_Done,
     /*  911315 */   // Label 13761: @911315
     /*  911315 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(911392), // Rule ID 12602 //
     /*  911320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  911334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911359 */     // MIs[0] policy
     /*  911359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911390 */     GIR_RootConstrainSelectedInstOperands,
     /*  911391 */     // GIR_Coverage, 12602,
     /*  911391 */     GIR_EraseRootFromParent_Done,
     /*  911392 */   // Label 13762: @911392
     /*  911392 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(911469), // Rule ID 12603 //
     /*  911397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  911400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  911411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911436 */     // MIs[0] policy
     /*  911436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911467 */     GIR_RootConstrainSelectedInstOperands,
     /*  911468 */     // GIR_Coverage, 12603,
     /*  911468 */     GIR_EraseRootFromParent_Done,
     /*  911469 */   // Label 13763: @911469
     /*  911469 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(911546), // Rule ID 12606 //
     /*  911474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  911488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911513 */     // MIs[0] policy
     /*  911513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911544 */     GIR_RootConstrainSelectedInstOperands,
     /*  911545 */     // GIR_Coverage, 12606,
     /*  911545 */     GIR_EraseRootFromParent_Done,
     /*  911546 */   // Label 13764: @911546
     /*  911546 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(911623), // Rule ID 12607 //
     /*  911551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  911554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  911565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911590 */     // MIs[0] policy
     /*  911590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911621 */     GIR_RootConstrainSelectedInstOperands,
     /*  911622 */     // GIR_Coverage, 12607,
     /*  911622 */     GIR_EraseRootFromParent_Done,
     /*  911623 */   // Label 13765: @911623
     /*  911623 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(911700), // Rule ID 12610 //
     /*  911628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  911631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  911642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911667 */     // MIs[0] policy
     /*  911667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911698 */     GIR_RootConstrainSelectedInstOperands,
     /*  911699 */     // GIR_Coverage, 12610,
     /*  911699 */     GIR_EraseRootFromParent_Done,
     /*  911700 */   // Label 13766: @911700
     /*  911700 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(911777), // Rule ID 12611 //
     /*  911705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  911708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  911719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911744 */     // MIs[0] policy
     /*  911744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*  911757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911775 */     GIR_RootConstrainSelectedInstOperands,
     /*  911776 */     // GIR_Coverage, 12611,
     /*  911776 */     GIR_EraseRootFromParent_Done,
     /*  911777 */   // Label 13767: @911777
     /*  911777 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(911854), // Rule ID 12614 //
     /*  911782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  911796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911821 */     // MIs[0] policy
     /*  911821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911831 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  911834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911852 */     GIR_RootConstrainSelectedInstOperands,
     /*  911853 */     // GIR_Coverage, 12614,
     /*  911853 */     GIR_EraseRootFromParent_Done,
     /*  911854 */   // Label 13768: @911854
     /*  911854 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(911931), // Rule ID 12615 //
     /*  911859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  911862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  911873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911898 */     // MIs[0] policy
     /*  911898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  911911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911929 */     GIR_RootConstrainSelectedInstOperands,
     /*  911930 */     // GIR_Coverage, 12615,
     /*  911930 */     GIR_EraseRootFromParent_Done,
     /*  911931 */   // Label 13769: @911931
     /*  911931 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(912008), // Rule ID 12618 //
     /*  911936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  911939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  911944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  911947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  911950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  911953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911975 */     // MIs[0] policy
     /*  911975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911985 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  911988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912006 */     GIR_RootConstrainSelectedInstOperands,
     /*  912007 */     // GIR_Coverage, 12618,
     /*  912007 */     GIR_EraseRootFromParent_Done,
     /*  912008 */   // Label 13770: @912008
     /*  912008 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(912085), // Rule ID 12619 //
     /*  912013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  912024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  912027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  912030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  912033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912052 */     // MIs[0] policy
     /*  912052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912062 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  912065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912083 */     GIR_RootConstrainSelectedInstOperands,
     /*  912084 */     // GIR_Coverage, 12619,
     /*  912084 */     GIR_EraseRootFromParent_Done,
     /*  912085 */   // Label 13771: @912085
     /*  912085 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(912162), // Rule ID 12622 //
     /*  912090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  912104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912129 */     // MIs[0] policy
     /*  912129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  912142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912160 */     GIR_RootConstrainSelectedInstOperands,
     /*  912161 */     // GIR_Coverage, 12622,
     /*  912161 */     GIR_EraseRootFromParent_Done,
     /*  912162 */   // Label 13772: @912162
     /*  912162 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(912239), // Rule ID 12623 //
     /*  912167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  912181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912206 */     // MIs[0] policy
     /*  912206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912216 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  912219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912237 */     GIR_RootConstrainSelectedInstOperands,
     /*  912238 */     // GIR_Coverage, 12623,
     /*  912238 */     GIR_EraseRootFromParent_Done,
     /*  912239 */   // Label 13773: @912239
     /*  912239 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(912316), // Rule ID 12626 //
     /*  912244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  912258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912283 */     // MIs[0] policy
     /*  912283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  912296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912314 */     GIR_RootConstrainSelectedInstOperands,
     /*  912315 */     // GIR_Coverage, 12626,
     /*  912315 */     GIR_EraseRootFromParent_Done,
     /*  912316 */   // Label 13774: @912316
     /*  912316 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(912393), // Rule ID 12627 //
     /*  912321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  912335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912360 */     // MIs[0] policy
     /*  912360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  912373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912391 */     GIR_RootConstrainSelectedInstOperands,
     /*  912392 */     // GIR_Coverage, 12627,
     /*  912392 */     GIR_EraseRootFromParent_Done,
     /*  912393 */   // Label 13775: @912393
     /*  912393 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(912470), // Rule ID 12630 //
     /*  912398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  912412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912437 */     // MIs[0] policy
     /*  912437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912447 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  912450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912468 */     GIR_RootConstrainSelectedInstOperands,
     /*  912469 */     // GIR_Coverage, 12630,
     /*  912469 */     GIR_EraseRootFromParent_Done,
     /*  912470 */   // Label 13776: @912470
     /*  912470 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(912547), // Rule ID 12631 //
     /*  912475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  912489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912514 */     // MIs[0] policy
     /*  912514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912524 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  912527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912545 */     GIR_RootConstrainSelectedInstOperands,
     /*  912546 */     // GIR_Coverage, 12631,
     /*  912546 */     GIR_EraseRootFromParent_Done,
     /*  912547 */   // Label 13777: @912547
     /*  912547 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(912624), // Rule ID 12634 //
     /*  912552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  912566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912591 */     // MIs[0] policy
     /*  912591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912601 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  912604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912622 */     GIR_RootConstrainSelectedInstOperands,
     /*  912623 */     // GIR_Coverage, 12634,
     /*  912623 */     GIR_EraseRootFromParent_Done,
     /*  912624 */   // Label 13778: @912624
     /*  912624 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(912701), // Rule ID 12635 //
     /*  912629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  912643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912668 */     // MIs[0] policy
     /*  912668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  912681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912699 */     GIR_RootConstrainSelectedInstOperands,
     /*  912700 */     // GIR_Coverage, 12635,
     /*  912700 */     GIR_EraseRootFromParent_Done,
     /*  912701 */   // Label 13779: @912701
     /*  912701 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(912778), // Rule ID 12638 //
     /*  912706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912745 */     // MIs[0] policy
     /*  912745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912755 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  912758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912776 */     GIR_RootConstrainSelectedInstOperands,
     /*  912777 */     // GIR_Coverage, 12638,
     /*  912777 */     GIR_EraseRootFromParent_Done,
     /*  912778 */   // Label 13780: @912778
     /*  912778 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(912855), // Rule ID 12639 //
     /*  912783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912822 */     // MIs[0] policy
     /*  912822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  912835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912853 */     GIR_RootConstrainSelectedInstOperands,
     /*  912854 */     // GIR_Coverage, 12639,
     /*  912854 */     GIR_EraseRootFromParent_Done,
     /*  912855 */   // Label 13781: @912855
     /*  912855 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(912932), // Rule ID 12642 //
     /*  912860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  912863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912899 */     // MIs[0] policy
     /*  912899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912909 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  912912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912930 */     GIR_RootConstrainSelectedInstOperands,
     /*  912931 */     // GIR_Coverage, 12642,
     /*  912931 */     GIR_EraseRootFromParent_Done,
     /*  912932 */   // Label 13782: @912932
     /*  912932 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(913009), // Rule ID 12643 //
     /*  912937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  912940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  912945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912976 */     // MIs[0] policy
     /*  912976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  912989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913007 */     GIR_RootConstrainSelectedInstOperands,
     /*  913008 */     // GIR_Coverage, 12643,
     /*  913008 */     GIR_EraseRootFromParent_Done,
     /*  913009 */   // Label 13783: @913009
     /*  913009 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(913086), // Rule ID 12646 //
     /*  913014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913053 */     // MIs[0] policy
     /*  913053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913063 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  913066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913084 */     GIR_RootConstrainSelectedInstOperands,
     /*  913085 */     // GIR_Coverage, 12646,
     /*  913085 */     GIR_EraseRootFromParent_Done,
     /*  913086 */   // Label 13784: @913086
     /*  913086 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(913163), // Rule ID 12647 //
     /*  913091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913130 */     // MIs[0] policy
     /*  913130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  913143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913161 */     GIR_RootConstrainSelectedInstOperands,
     /*  913162 */     // GIR_Coverage, 12647,
     /*  913162 */     GIR_EraseRootFromParent_Done,
     /*  913163 */   // Label 13785: @913163
     /*  913163 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(913240), // Rule ID 12650 //
     /*  913168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  913171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  913182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913207 */     // MIs[0] policy
     /*  913207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  913220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913238 */     GIR_RootConstrainSelectedInstOperands,
     /*  913239 */     // GIR_Coverage, 12650,
     /*  913239 */     GIR_EraseRootFromParent_Done,
     /*  913240 */   // Label 13786: @913240
     /*  913240 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(913317), // Rule ID 12651 //
     /*  913245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  913248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  913259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913284 */     // MIs[0] policy
     /*  913284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*  913297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913315 */     GIR_RootConstrainSelectedInstOperands,
     /*  913316 */     // GIR_Coverage, 12651,
     /*  913316 */     GIR_EraseRootFromParent_Done,
     /*  913317 */   // Label 13787: @913317
     /*  913317 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(913394), // Rule ID 12654 //
     /*  913322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  913325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  913336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913361 */     // MIs[0] policy
     /*  913361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  913374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913392 */     GIR_RootConstrainSelectedInstOperands,
     /*  913393 */     // GIR_Coverage, 12654,
     /*  913393 */     GIR_EraseRootFromParent_Done,
     /*  913394 */   // Label 13788: @913394
     /*  913394 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(913471), // Rule ID 12655 //
     /*  913399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  913402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  913413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913438 */     // MIs[0] policy
     /*  913438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*  913451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913469 */     GIR_RootConstrainSelectedInstOperands,
     /*  913470 */     // GIR_Coverage, 12655,
     /*  913470 */     GIR_EraseRootFromParent_Done,
     /*  913471 */   // Label 13789: @913471
     /*  913471 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(913548), // Rule ID 12658 //
     /*  913476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  913479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  913490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913515 */     // MIs[0] policy
     /*  913515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913525 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  913528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913546 */     GIR_RootConstrainSelectedInstOperands,
     /*  913547 */     // GIR_Coverage, 12658,
     /*  913547 */     GIR_EraseRootFromParent_Done,
     /*  913548 */   // Label 13790: @913548
     /*  913548 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(913625), // Rule ID 12659 //
     /*  913553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  913556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  913567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913592 */     // MIs[0] policy
     /*  913592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*  913605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913623 */     GIR_RootConstrainSelectedInstOperands,
     /*  913624 */     // GIR_Coverage, 12659,
     /*  913624 */     GIR_EraseRootFromParent_Done,
     /*  913625 */   // Label 13791: @913625
     /*  913625 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(913702), // Rule ID 12662 //
     /*  913630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  913647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  913665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913669 */     // MIs[0] policy
     /*  913669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913679 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /*  913682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913700 */     GIR_RootConstrainSelectedInstOperands,
     /*  913701 */     // GIR_Coverage, 12662,
     /*  913701 */     GIR_EraseRootFromParent_Done,
     /*  913702 */   // Label 13792: @913702
     /*  913702 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(913779), // Rule ID 12663 //
     /*  913707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  913724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  913742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913746 */     // MIs[0] policy
     /*  913746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /*  913759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913777 */     GIR_RootConstrainSelectedInstOperands,
     /*  913778 */     // GIR_Coverage, 12663,
     /*  913778 */     GIR_EraseRootFromParent_Done,
     /*  913779 */   // Label 13793: @913779
     /*  913779 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(913856), // Rule ID 12666 //
     /*  913784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  913795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  913798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  913801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  913819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913823 */     // MIs[0] policy
     /*  913823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913833 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /*  913836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913854 */     GIR_RootConstrainSelectedInstOperands,
     /*  913855 */     // GIR_Coverage, 12666,
     /*  913855 */     GIR_EraseRootFromParent_Done,
     /*  913856 */   // Label 13794: @913856
     /*  913856 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(913933), // Rule ID 12667 //
     /*  913861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  913872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  913875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  913878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  913896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913900 */     // MIs[0] policy
     /*  913900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913910 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /*  913913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913931 */     GIR_RootConstrainSelectedInstOperands,
     /*  913932 */     // GIR_Coverage, 12667,
     /*  913932 */     GIR_EraseRootFromParent_Done,
     /*  913933 */   // Label 13795: @913933
     /*  913933 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(914010), // Rule ID 12670 //
     /*  913938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  913946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  913949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  913952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  913955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  913958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  913973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913977 */     // MIs[0] policy
     /*  913977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913987 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  913990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914008 */     GIR_RootConstrainSelectedInstOperands,
     /*  914009 */     // GIR_Coverage, 12670,
     /*  914009 */     GIR_EraseRootFromParent_Done,
     /*  914010 */   // Label 13796: @914010
     /*  914010 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(914087), // Rule ID 12671 //
     /*  914015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  914035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914054 */     // MIs[0] policy
     /*  914054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  914067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914085 */     GIR_RootConstrainSelectedInstOperands,
     /*  914086 */     // GIR_Coverage, 12671,
     /*  914086 */     GIR_EraseRootFromParent_Done,
     /*  914087 */   // Label 13797: @914087
     /*  914087 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(914164), // Rule ID 12674 //
     /*  914092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914131 */     // MIs[0] policy
     /*  914131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914141 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /*  914144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914162 */     GIR_RootConstrainSelectedInstOperands,
     /*  914163 */     // GIR_Coverage, 12674,
     /*  914163 */     GIR_EraseRootFromParent_Done,
     /*  914164 */   // Label 13798: @914164
     /*  914164 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(914241), // Rule ID 12675 //
     /*  914169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914208 */     // MIs[0] policy
     /*  914208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /*  914221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914239 */     GIR_RootConstrainSelectedInstOperands,
     /*  914240 */     // GIR_Coverage, 12675,
     /*  914240 */     GIR_EraseRootFromParent_Done,
     /*  914241 */   // Label 13799: @914241
     /*  914241 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(914318), // Rule ID 12678 //
     /*  914246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914285 */     // MIs[0] policy
     /*  914285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914295 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  914298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914316 */     GIR_RootConstrainSelectedInstOperands,
     /*  914317 */     // GIR_Coverage, 12678,
     /*  914317 */     GIR_EraseRootFromParent_Done,
     /*  914318 */   // Label 13800: @914318
     /*  914318 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(914395), // Rule ID 12679 //
     /*  914323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914362 */     // MIs[0] policy
     /*  914362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  914375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914393 */     GIR_RootConstrainSelectedInstOperands,
     /*  914394 */     // GIR_Coverage, 12679,
     /*  914394 */     GIR_EraseRootFromParent_Done,
     /*  914395 */   // Label 13801: @914395
     /*  914395 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(914472), // Rule ID 12682 //
     /*  914400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  914420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914439 */     // MIs[0] policy
     /*  914439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  914452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914470 */     GIR_RootConstrainSelectedInstOperands,
     /*  914471 */     // GIR_Coverage, 12682,
     /*  914471 */     GIR_EraseRootFromParent_Done,
     /*  914472 */   // Label 13802: @914472
     /*  914472 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(914549), // Rule ID 12683 //
     /*  914477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  914497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914516 */     // MIs[0] policy
     /*  914516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /*  914529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914547 */     GIR_RootConstrainSelectedInstOperands,
     /*  914548 */     // GIR_Coverage, 12683,
     /*  914548 */     GIR_EraseRootFromParent_Done,
     /*  914549 */   // Label 13803: @914549
     /*  914549 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(914626), // Rule ID 12686 //
     /*  914554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914593 */     // MIs[0] policy
     /*  914593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914603 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914624 */     GIR_RootConstrainSelectedInstOperands,
     /*  914625 */     // GIR_Coverage, 12686,
     /*  914625 */     GIR_EraseRootFromParent_Done,
     /*  914626 */   // Label 13804: @914626
     /*  914626 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(914703), // Rule ID 12687 //
     /*  914631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914670 */     // MIs[0] policy
     /*  914670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914701 */     GIR_RootConstrainSelectedInstOperands,
     /*  914702 */     // GIR_Coverage, 12687,
     /*  914702 */     GIR_EraseRootFromParent_Done,
     /*  914703 */   // Label 13805: @914703
     /*  914703 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(914780), // Rule ID 12690 //
     /*  914708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  914722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  914728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914747 */     // MIs[0] policy
     /*  914747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914778 */     GIR_RootConstrainSelectedInstOperands,
     /*  914779 */     // GIR_Coverage, 12690,
     /*  914779 */     GIR_EraseRootFromParent_Done,
     /*  914780 */   // Label 13806: @914780
     /*  914780 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(914857), // Rule ID 12691 //
     /*  914785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  914799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  914805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914824 */     // MIs[0] policy
     /*  914824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914855 */     GIR_RootConstrainSelectedInstOperands,
     /*  914856 */     // GIR_Coverage, 12691,
     /*  914856 */     GIR_EraseRootFromParent_Done,
     /*  914857 */   // Label 13807: @914857
     /*  914857 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(914934), // Rule ID 12694 //
     /*  914862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  914876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  914879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  914882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914901 */     // MIs[0] policy
     /*  914901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914932 */     GIR_RootConstrainSelectedInstOperands,
     /*  914933 */     // GIR_Coverage, 12694,
     /*  914933 */     GIR_EraseRootFromParent_Done,
     /*  914934 */   // Label 13808: @914934
     /*  914934 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(915011), // Rule ID 12695 //
     /*  914939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  914947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  914953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  914956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  914959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  914974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914978 */     // MIs[0] policy
     /*  914978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  914991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915009 */     GIR_RootConstrainSelectedInstOperands,
     /*  915010 */     // GIR_Coverage, 12695,
     /*  915010 */     GIR_EraseRootFromParent_Done,
     /*  915011 */   // Label 13809: @915011
     /*  915011 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(915088), // Rule ID 12698 //
     /*  915016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  915019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  915036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915055 */     // MIs[0] policy
     /*  915055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  915068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915086 */     GIR_RootConstrainSelectedInstOperands,
     /*  915087 */     // GIR_Coverage, 12698,
     /*  915087 */     GIR_EraseRootFromParent_Done,
     /*  915088 */   // Label 13810: @915088
     /*  915088 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(915165), // Rule ID 12699 //
     /*  915093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  915096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  915113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915132 */     // MIs[0] policy
     /*  915132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /*  915145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915163 */     GIR_RootConstrainSelectedInstOperands,
     /*  915164 */     // GIR_Coverage, 12699,
     /*  915164 */     GIR_EraseRootFromParent_Done,
     /*  915165 */   // Label 13811: @915165
     /*  915165 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(915242), // Rule ID 12702 //
     /*  915170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  915190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915209 */     // MIs[0] policy
     /*  915209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  915222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915240 */     GIR_RootConstrainSelectedInstOperands,
     /*  915241 */     // GIR_Coverage, 12702,
     /*  915241 */     GIR_EraseRootFromParent_Done,
     /*  915242 */   // Label 13812: @915242
     /*  915242 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(915319), // Rule ID 12703 //
     /*  915247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  915267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915286 */     // MIs[0] policy
     /*  915286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  915299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915317 */     GIR_RootConstrainSelectedInstOperands,
     /*  915318 */     // GIR_Coverage, 12703,
     /*  915318 */     GIR_EraseRootFromParent_Done,
     /*  915319 */   // Label 13813: @915319
     /*  915319 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(915396), // Rule ID 12706 //
     /*  915324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  915344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915363 */     // MIs[0] policy
     /*  915363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915373 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  915376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915394 */     GIR_RootConstrainSelectedInstOperands,
     /*  915395 */     // GIR_Coverage, 12706,
     /*  915395 */     GIR_EraseRootFromParent_Done,
     /*  915396 */   // Label 13814: @915396
     /*  915396 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(915473), // Rule ID 12707 //
     /*  915401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  915421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915440 */     // MIs[0] policy
     /*  915440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  915453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915471 */     GIR_RootConstrainSelectedInstOperands,
     /*  915472 */     // GIR_Coverage, 12707,
     /*  915472 */     GIR_EraseRootFromParent_Done,
     /*  915473 */   // Label 13815: @915473
     /*  915473 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(915550), // Rule ID 12710 //
     /*  915478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  915489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  915492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  915498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915517 */     // MIs[0] policy
     /*  915517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915527 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  915530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915548 */     GIR_RootConstrainSelectedInstOperands,
     /*  915549 */     // GIR_Coverage, 12710,
     /*  915549 */     GIR_EraseRootFromParent_Done,
     /*  915550 */   // Label 13816: @915550
     /*  915550 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(915627), // Rule ID 12711 //
     /*  915555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  915566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  915569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  915575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915594 */     // MIs[0] policy
     /*  915594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  915607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915625 */     GIR_RootConstrainSelectedInstOperands,
     /*  915626 */     // GIR_Coverage, 12711,
     /*  915626 */     GIR_EraseRootFromParent_Done,
     /*  915627 */   // Label 13817: @915627
     /*  915627 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(915704), // Rule ID 12714 //
     /*  915632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  915643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  915646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915671 */     // MIs[0] policy
     /*  915671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  915684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915702 */     GIR_RootConstrainSelectedInstOperands,
     /*  915703 */     // GIR_Coverage, 12714,
     /*  915703 */     GIR_EraseRootFromParent_Done,
     /*  915704 */   // Label 13818: @915704
     /*  915704 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(915781), // Rule ID 12715 //
     /*  915709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  915720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  915723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915748 */     // MIs[0] policy
     /*  915748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  915761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915779 */     GIR_RootConstrainSelectedInstOperands,
     /*  915780 */     // GIR_Coverage, 12715,
     /*  915780 */     GIR_EraseRootFromParent_Done,
     /*  915781 */   // Label 13819: @915781
     /*  915781 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(915858), // Rule ID 12718 //
     /*  915786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  915797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  915800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915825 */     // MIs[0] policy
     /*  915825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915835 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  915838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915856 */     GIR_RootConstrainSelectedInstOperands,
     /*  915857 */     // GIR_Coverage, 12718,
     /*  915857 */     GIR_EraseRootFromParent_Done,
     /*  915858 */   // Label 13820: @915858
     /*  915858 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(915935), // Rule ID 12719 //
     /*  915863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  915874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  915877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  915880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915902 */     // MIs[0] policy
     /*  915902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  915915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  915923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915933 */     GIR_RootConstrainSelectedInstOperands,
     /*  915934 */     // GIR_Coverage, 12719,
     /*  915934 */     GIR_EraseRootFromParent_Done,
     /*  915935 */   // Label 13821: @915935
     /*  915935 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(916012), // Rule ID 12722 //
     /*  915940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  915948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  915951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  915954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  915957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  915960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  915975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915979 */     // MIs[0] policy
     /*  915979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  915992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916010 */     GIR_RootConstrainSelectedInstOperands,
     /*  916011 */     // GIR_Coverage, 12722,
     /*  916011 */     GIR_EraseRootFromParent_Done,
     /*  916012 */   // Label 13822: @916012
     /*  916012 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(916089), // Rule ID 12723 //
     /*  916017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  916037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916056 */     // MIs[0] policy
     /*  916056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  916069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916087 */     GIR_RootConstrainSelectedInstOperands,
     /*  916088 */     // GIR_Coverage, 12723,
     /*  916088 */     GIR_EraseRootFromParent_Done,
     /*  916089 */   // Label 13823: @916089
     /*  916089 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(916166), // Rule ID 12726 //
     /*  916094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  916114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916133 */     // MIs[0] policy
     /*  916133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  916146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916164 */     GIR_RootConstrainSelectedInstOperands,
     /*  916165 */     // GIR_Coverage, 12726,
     /*  916165 */     GIR_EraseRootFromParent_Done,
     /*  916166 */   // Label 13824: @916166
     /*  916166 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(916243), // Rule ID 12727 //
     /*  916171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  916191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916210 */     // MIs[0] policy
     /*  916210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  916223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916241 */     GIR_RootConstrainSelectedInstOperands,
     /*  916242 */     // GIR_Coverage, 12727,
     /*  916242 */     GIR_EraseRootFromParent_Done,
     /*  916243 */   // Label 13825: @916243
     /*  916243 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(916320), // Rule ID 12730 //
     /*  916248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916287 */     // MIs[0] policy
     /*  916287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916297 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  916300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916318 */     GIR_RootConstrainSelectedInstOperands,
     /*  916319 */     // GIR_Coverage, 12730,
     /*  916319 */     GIR_EraseRootFromParent_Done,
     /*  916320 */   // Label 13826: @916320
     /*  916320 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(916397), // Rule ID 12731 //
     /*  916325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916364 */     // MIs[0] policy
     /*  916364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  916377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916395 */     GIR_RootConstrainSelectedInstOperands,
     /*  916396 */     // GIR_Coverage, 12731,
     /*  916396 */     GIR_EraseRootFromParent_Done,
     /*  916397 */   // Label 13827: @916397
     /*  916397 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(916474), // Rule ID 12734 //
     /*  916402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  916422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916441 */     // MIs[0] policy
     /*  916441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916451 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  916454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916472 */     GIR_RootConstrainSelectedInstOperands,
     /*  916473 */     // GIR_Coverage, 12734,
     /*  916473 */     GIR_EraseRootFromParent_Done,
     /*  916474 */   // Label 13828: @916474
     /*  916474 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(916551), // Rule ID 12735 //
     /*  916479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  916499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916518 */     // MIs[0] policy
     /*  916518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  916531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916549 */     GIR_RootConstrainSelectedInstOperands,
     /*  916550 */     // GIR_Coverage, 12735,
     /*  916550 */     GIR_EraseRootFromParent_Done,
     /*  916551 */   // Label 13829: @916551
     /*  916551 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(916628), // Rule ID 12738 //
     /*  916556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  916559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  916567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  916570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  916576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916595 */     // MIs[0] policy
     /*  916595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  916608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916626 */     GIR_RootConstrainSelectedInstOperands,
     /*  916627 */     // GIR_Coverage, 12738,
     /*  916627 */     GIR_EraseRootFromParent_Done,
     /*  916628 */   // Label 13830: @916628
     /*  916628 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(916705), // Rule ID 12739 //
     /*  916633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  916644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  916647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  916653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916672 */     // MIs[0] policy
     /*  916672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916682 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /*  916685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916703 */     GIR_RootConstrainSelectedInstOperands,
     /*  916704 */     // GIR_Coverage, 12739,
     /*  916704 */     GIR_EraseRootFromParent_Done,
     /*  916705 */   // Label 13831: @916705
     /*  916705 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(916782), // Rule ID 12742 //
     /*  916710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  916713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  916721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  916724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  916730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916749 */     // MIs[0] policy
     /*  916749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  916762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916780 */     GIR_RootConstrainSelectedInstOperands,
     /*  916781 */     // GIR_Coverage, 12742,
     /*  916781 */     GIR_EraseRootFromParent_Done,
     /*  916782 */   // Label 13832: @916782
     /*  916782 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(916859), // Rule ID 12743 //
     /*  916787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  916798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  916801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  916807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916826 */     // MIs[0] policy
     /*  916826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916836 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /*  916839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916857 */     GIR_RootConstrainSelectedInstOperands,
     /*  916858 */     // GIR_Coverage, 12743,
     /*  916858 */     GIR_EraseRootFromParent_Done,
     /*  916859 */   // Label 13833: @916859
     /*  916859 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(916936), // Rule ID 12746 //
     /*  916864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  916867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  916875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  916878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  916881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  916884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916903 */     // MIs[0] policy
     /*  916903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916913 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  916916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916934 */     GIR_RootConstrainSelectedInstOperands,
     /*  916935 */     // GIR_Coverage, 12746,
     /*  916935 */     GIR_EraseRootFromParent_Done,
     /*  916936 */   // Label 13834: @916936
     /*  916936 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(917013), // Rule ID 12747 //
     /*  916941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  916949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  916952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  916955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  916958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  916961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  916976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916980 */     // MIs[0] policy
     /*  916980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /*  916993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917011 */     GIR_RootConstrainSelectedInstOperands,
     /*  917012 */     // GIR_Coverage, 12747,
     /*  917012 */     GIR_EraseRootFromParent_Done,
     /*  917013 */   // Label 13835: @917013
     /*  917013 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(917090), // Rule ID 12750 //
     /*  917018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  917038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917057 */     // MIs[0] policy
     /*  917057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917067 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*  917070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917088 */     GIR_RootConstrainSelectedInstOperands,
     /*  917089 */     // GIR_Coverage, 12750,
     /*  917089 */     GIR_EraseRootFromParent_Done,
     /*  917090 */   // Label 13836: @917090
     /*  917090 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(917167), // Rule ID 12751 //
     /*  917095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  917115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917134 */     // MIs[0] policy
     /*  917134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*  917147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917165 */     GIR_RootConstrainSelectedInstOperands,
     /*  917166 */     // GIR_Coverage, 12751,
     /*  917166 */     GIR_EraseRootFromParent_Done,
     /*  917167 */   // Label 13837: @917167
     /*  917167 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(917244), // Rule ID 12754 //
     /*  917172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  917192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917211 */     // MIs[0] policy
     /*  917211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*  917224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917242 */     GIR_RootConstrainSelectedInstOperands,
     /*  917243 */     // GIR_Coverage, 12754,
     /*  917243 */     GIR_EraseRootFromParent_Done,
     /*  917244 */   // Label 13838: @917244
     /*  917244 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(917321), // Rule ID 12755 //
     /*  917249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  917269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917288 */     // MIs[0] policy
     /*  917288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917298 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*  917301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917319 */     GIR_RootConstrainSelectedInstOperands,
     /*  917320 */     // GIR_Coverage, 12755,
     /*  917320 */     GIR_EraseRootFromParent_Done,
     /*  917321 */   // Label 13839: @917321
     /*  917321 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(917398), // Rule ID 12758 //
     /*  917326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  917337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  917340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  917343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  917346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917365 */     // MIs[0] policy
     /*  917365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917375 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917396 */     GIR_RootConstrainSelectedInstOperands,
     /*  917397 */     // GIR_Coverage, 12758,
     /*  917397 */     GIR_EraseRootFromParent_Done,
     /*  917398 */   // Label 13840: @917398
     /*  917398 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(917475), // Rule ID 12759 //
     /*  917403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  917414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  917417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  917420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  917423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917442 */     // MIs[0] policy
     /*  917442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917473 */     GIR_RootConstrainSelectedInstOperands,
     /*  917474 */     // GIR_Coverage, 12759,
     /*  917474 */     GIR_EraseRootFromParent_Done,
     /*  917475 */   // Label 13841: @917475
     /*  917475 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(917552), // Rule ID 12762 //
     /*  917480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  917491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  917494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  917497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  917500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917519 */     // MIs[0] policy
     /*  917519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*  917532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917550 */     GIR_RootConstrainSelectedInstOperands,
     /*  917551 */     // GIR_Coverage, 12762,
     /*  917551 */     GIR_EraseRootFromParent_Done,
     /*  917552 */   // Label 13842: @917552
     /*  917552 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(917629), // Rule ID 12763 //
     /*  917557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  917568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  917571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  917574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  917577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917596 */     // MIs[0] policy
     /*  917596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*  917609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917627 */     GIR_RootConstrainSelectedInstOperands,
     /*  917628 */     // GIR_Coverage, 12763,
     /*  917628 */     GIR_EraseRootFromParent_Done,
     /*  917629 */   // Label 13843: @917629
     /*  917629 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(917706), // Rule ID 12766 //
     /*  917634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  917645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  917648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  917651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  917654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917673 */     // MIs[0] policy
     /*  917673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917683 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917704 */     GIR_RootConstrainSelectedInstOperands,
     /*  917705 */     // GIR_Coverage, 12766,
     /*  917705 */     GIR_EraseRootFromParent_Done,
     /*  917706 */   // Label 13844: @917706
     /*  917706 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(917783), // Rule ID 12767 //
     /*  917711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  917722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  917725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  917728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  917731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917750 */     // MIs[0] policy
     /*  917750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917781 */     GIR_RootConstrainSelectedInstOperands,
     /*  917782 */     // GIR_Coverage, 12767,
     /*  917782 */     GIR_EraseRootFromParent_Done,
     /*  917783 */   // Label 13845: @917783
     /*  917783 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(917860), // Rule ID 12770 //
     /*  917788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  917799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  917802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  917805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  917808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917827 */     // MIs[0] policy
     /*  917827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917858 */     GIR_RootConstrainSelectedInstOperands,
     /*  917859 */     // GIR_Coverage, 12770,
     /*  917859 */     GIR_EraseRootFromParent_Done,
     /*  917860 */   // Label 13846: @917860
     /*  917860 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(917937), // Rule ID 12771 //
     /*  917865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  917876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  917879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  917882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  917885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917904 */     // MIs[0] policy
     /*  917904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*  917917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917935 */     GIR_RootConstrainSelectedInstOperands,
     /*  917936 */     // GIR_Coverage, 12771,
     /*  917936 */     GIR_EraseRootFromParent_Done,
     /*  917937 */   // Label 13847: @917937
     /*  917937 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(918014), // Rule ID 12774 //
     /*  917942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  917950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  917953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  917956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  917959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  917962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917981 */     // MIs[0] policy
     /*  917981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917991 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  917994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918012 */     GIR_RootConstrainSelectedInstOperands,
     /*  918013 */     // GIR_Coverage, 12774,
     /*  918013 */     GIR_EraseRootFromParent_Done,
     /*  918014 */   // Label 13848: @918014
     /*  918014 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(918091), // Rule ID 12775 //
     /*  918019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  918039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918058 */     // MIs[0] policy
     /*  918058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918089 */     GIR_RootConstrainSelectedInstOperands,
     /*  918090 */     // GIR_Coverage, 12775,
     /*  918090 */     GIR_EraseRootFromParent_Done,
     /*  918091 */   // Label 13849: @918091
     /*  918091 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(918168), // Rule ID 12778 //
     /*  918096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  918116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918135 */     // MIs[0] policy
     /*  918135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918166 */     GIR_RootConstrainSelectedInstOperands,
     /*  918167 */     // GIR_Coverage, 12778,
     /*  918167 */     GIR_EraseRootFromParent_Done,
     /*  918168 */   // Label 13850: @918168
     /*  918168 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(918245), // Rule ID 12779 //
     /*  918173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  918193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918212 */     // MIs[0] policy
     /*  918212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918243 */     GIR_RootConstrainSelectedInstOperands,
     /*  918244 */     // GIR_Coverage, 12779,
     /*  918244 */     GIR_EraseRootFromParent_Done,
     /*  918245 */   // Label 13851: @918245
     /*  918245 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(918322), // Rule ID 12782 //
     /*  918250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  918261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  918264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  918267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  918270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918289 */     // MIs[0] policy
     /*  918289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918320 */     GIR_RootConstrainSelectedInstOperands,
     /*  918321 */     // GIR_Coverage, 12782,
     /*  918321 */     GIR_EraseRootFromParent_Done,
     /*  918322 */   // Label 13852: @918322
     /*  918322 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(918399), // Rule ID 12783 //
     /*  918327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  918338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  918341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  918344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  918347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918366 */     // MIs[0] policy
     /*  918366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918397 */     GIR_RootConstrainSelectedInstOperands,
     /*  918398 */     // GIR_Coverage, 12783,
     /*  918398 */     GIR_EraseRootFromParent_Done,
     /*  918399 */   // Label 13853: @918399
     /*  918399 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(918476), // Rule ID 12786 //
     /*  918404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  918407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  918415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  918418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  918421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  918424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918443 */     // MIs[0] policy
     /*  918443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918453 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918474 */     GIR_RootConstrainSelectedInstOperands,
     /*  918475 */     // GIR_Coverage, 12786,
     /*  918475 */     GIR_EraseRootFromParent_Done,
     /*  918476 */   // Label 13854: @918476
     /*  918476 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(918553), // Rule ID 12787 //
     /*  918481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  918484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  918492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  918495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  918498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  918501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918520 */     // MIs[0] policy
     /*  918520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*  918533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918551 */     GIR_RootConstrainSelectedInstOperands,
     /*  918552 */     // GIR_Coverage, 12787,
     /*  918552 */     GIR_EraseRootFromParent_Done,
     /*  918553 */   // Label 13855: @918553
     /*  918553 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(918630), // Rule ID 12790 //
     /*  918558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  918569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  918572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  918575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  918578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918597 */     // MIs[0] policy
     /*  918597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918607 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  918610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918628 */     GIR_RootConstrainSelectedInstOperands,
     /*  918629 */     // GIR_Coverage, 12790,
     /*  918629 */     GIR_EraseRootFromParent_Done,
     /*  918630 */   // Label 13856: @918630
     /*  918630 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(918707), // Rule ID 12791 //
     /*  918635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  918646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  918649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  918652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  918655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  918674 */     // MIs[0] policy
     /*  918674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  918687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918705 */     GIR_RootConstrainSelectedInstOperands,
     /*  918706 */     // GIR_Coverage, 12791,
     /*  918706 */     GIR_EraseRootFromParent_Done,
     /*  918707 */   // Label 13857: @918707
     /*  918707 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(918784), // Rule ID 12794 //
     /*  918712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  918723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  918726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  918729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  918732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918751 */     // MIs[0] policy
     /*  918751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918761 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  918764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918782 */     GIR_RootConstrainSelectedInstOperands,
     /*  918783 */     // GIR_Coverage, 12794,
     /*  918783 */     GIR_EraseRootFromParent_Done,
     /*  918784 */   // Label 13858: @918784
     /*  918784 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(918861), // Rule ID 12795 //
     /*  918789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  918800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  918803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  918806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  918809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  918828 */     // MIs[0] policy
     /*  918828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  918841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918859 */     GIR_RootConstrainSelectedInstOperands,
     /*  918860 */     // GIR_Coverage, 12795,
     /*  918860 */     GIR_EraseRootFromParent_Done,
     /*  918861 */   // Label 13859: @918861
     /*  918861 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(918938), // Rule ID 12798 //
     /*  918866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  918877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  918880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  918883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  918886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918905 */     // MIs[0] policy
     /*  918905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918915 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  918918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  918926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918936 */     GIR_RootConstrainSelectedInstOperands,
     /*  918937 */     // GIR_Coverage, 12798,
     /*  918937 */     GIR_EraseRootFromParent_Done,
     /*  918938 */   // Label 13860: @918938
     /*  918938 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(919015), // Rule ID 12799 //
     /*  918943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  918951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  918954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  918957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  918960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  918963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918982 */     // MIs[0] policy
     /*  918982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  918995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919013 */     GIR_RootConstrainSelectedInstOperands,
     /*  919014 */     // GIR_Coverage, 12799,
     /*  919014 */     GIR_EraseRootFromParent_Done,
     /*  919015 */   // Label 13861: @919015
     /*  919015 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(919092), // Rule ID 12802 //
     /*  919020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  919031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  919034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  919037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  919040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919059 */     // MIs[0] policy
     /*  919059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  919072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919090 */     GIR_RootConstrainSelectedInstOperands,
     /*  919091 */     // GIR_Coverage, 12802,
     /*  919091 */     GIR_EraseRootFromParent_Done,
     /*  919092 */   // Label 13862: @919092
     /*  919092 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(919169), // Rule ID 12803 //
     /*  919097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  919108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  919111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  919114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  919117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919136 */     // MIs[0] policy
     /*  919136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  919149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919167 */     GIR_RootConstrainSelectedInstOperands,
     /*  919168 */     // GIR_Coverage, 12803,
     /*  919168 */     GIR_EraseRootFromParent_Done,
     /*  919169 */   // Label 13863: @919169
     /*  919169 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(919246), // Rule ID 12806 //
     /*  919174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  919185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  919188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  919191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  919194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919213 */     // MIs[0] policy
     /*  919213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919223 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  919226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919244 */     GIR_RootConstrainSelectedInstOperands,
     /*  919245 */     // GIR_Coverage, 12806,
     /*  919245 */     GIR_EraseRootFromParent_Done,
     /*  919246 */   // Label 13864: @919246
     /*  919246 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(919323), // Rule ID 12807 //
     /*  919251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  919262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  919265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  919268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  919271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919290 */     // MIs[0] policy
     /*  919290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  919303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919321 */     GIR_RootConstrainSelectedInstOperands,
     /*  919322 */     // GIR_Coverage, 12807,
     /*  919322 */     GIR_EraseRootFromParent_Done,
     /*  919323 */   // Label 13865: @919323
     /*  919323 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(919400), // Rule ID 12810 //
     /*  919328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  919339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  919342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  919345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  919348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919367 */     // MIs[0] policy
     /*  919367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  919380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919398 */     GIR_RootConstrainSelectedInstOperands,
     /*  919399 */     // GIR_Coverage, 12810,
     /*  919399 */     GIR_EraseRootFromParent_Done,
     /*  919400 */   // Label 13866: @919400
     /*  919400 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(919477), // Rule ID 12811 //
     /*  919405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  919416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  919419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  919422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  919425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919444 */     // MIs[0] policy
     /*  919444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  919457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919475 */     GIR_RootConstrainSelectedInstOperands,
     /*  919476 */     // GIR_Coverage, 12811,
     /*  919476 */     GIR_EraseRootFromParent_Done,
     /*  919477 */   // Label 13867: @919477
     /*  919477 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(919554), // Rule ID 12814 //
     /*  919482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  919493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  919496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  919499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  919502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919521 */     // MIs[0] policy
     /*  919521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  919534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919552 */     GIR_RootConstrainSelectedInstOperands,
     /*  919553 */     // GIR_Coverage, 12814,
     /*  919553 */     GIR_EraseRootFromParent_Done,
     /*  919554 */   // Label 13868: @919554
     /*  919554 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(919631), // Rule ID 12815 //
     /*  919559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  919570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  919573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  919576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  919579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919598 */     // MIs[0] policy
     /*  919598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  919611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919629 */     GIR_RootConstrainSelectedInstOperands,
     /*  919630 */     // GIR_Coverage, 12815,
     /*  919630 */     GIR_EraseRootFromParent_Done,
     /*  919631 */   // Label 13869: @919631
     /*  919631 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(919708), // Rule ID 12818 //
     /*  919636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  919647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  919650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  919653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  919656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919675 */     // MIs[0] policy
     /*  919675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919685 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  919688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919706 */     GIR_RootConstrainSelectedInstOperands,
     /*  919707 */     // GIR_Coverage, 12818,
     /*  919707 */     GIR_EraseRootFromParent_Done,
     /*  919708 */   // Label 13870: @919708
     /*  919708 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(919785), // Rule ID 12819 //
     /*  919713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  919724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  919727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  919730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  919733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919752 */     // MIs[0] policy
     /*  919752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  919765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919783 */     GIR_RootConstrainSelectedInstOperands,
     /*  919784 */     // GIR_Coverage, 12819,
     /*  919784 */     GIR_EraseRootFromParent_Done,
     /*  919785 */   // Label 13871: @919785
     /*  919785 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(919862), // Rule ID 12822 //
     /*  919790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  919801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  919804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  919807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  919810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919829 */     // MIs[0] policy
     /*  919829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  919842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919860 */     GIR_RootConstrainSelectedInstOperands,
     /*  919861 */     // GIR_Coverage, 12822,
     /*  919861 */     GIR_EraseRootFromParent_Done,
     /*  919862 */   // Label 13872: @919862
     /*  919862 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(919939), // Rule ID 12823 //
     /*  919867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  919878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  919881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  919884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  919887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919906 */     // MIs[0] policy
     /*  919906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  919919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  919927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919937 */     GIR_RootConstrainSelectedInstOperands,
     /*  919938 */     // GIR_Coverage, 12823,
     /*  919938 */     GIR_EraseRootFromParent_Done,
     /*  919939 */   // Label 13873: @919939
     /*  919939 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(920016), // Rule ID 12826 //
     /*  919944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  919952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  919955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  919958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  919961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  919964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919983 */     // MIs[0] policy
     /*  919983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  919996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920014 */     GIR_RootConstrainSelectedInstOperands,
     /*  920015 */     // GIR_Coverage, 12826,
     /*  920015 */     GIR_EraseRootFromParent_Done,
     /*  920016 */   // Label 13874: @920016
     /*  920016 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(920093), // Rule ID 12827 //
     /*  920021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  920024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  920032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  920035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  920038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  920041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920060 */     // MIs[0] policy
     /*  920060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*  920073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920091 */     GIR_RootConstrainSelectedInstOperands,
     /*  920092 */     // GIR_Coverage, 12827,
     /*  920092 */     GIR_EraseRootFromParent_Done,
     /*  920093 */   // Label 13875: @920093
     /*  920093 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(920170), // Rule ID 12830 //
     /*  920098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  920101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  920109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  920112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  920115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  920118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920137 */     // MIs[0] policy
     /*  920137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920147 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  920150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920168 */     GIR_RootConstrainSelectedInstOperands,
     /*  920169 */     // GIR_Coverage, 12830,
     /*  920169 */     GIR_EraseRootFromParent_Done,
     /*  920170 */   // Label 13876: @920170
     /*  920170 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(920247), // Rule ID 12831 //
     /*  920175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  920178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  920186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  920189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  920192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  920195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920214 */     // MIs[0] policy
     /*  920214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*  920227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920245 */     GIR_RootConstrainSelectedInstOperands,
     /*  920246 */     // GIR_Coverage, 12831,
     /*  920246 */     GIR_EraseRootFromParent_Done,
     /*  920247 */   // Label 13877: @920247
     /*  920247 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(920324), // Rule ID 12834 //
     /*  920252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  920255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  920263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  920266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  920269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  920272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920291 */     // MIs[0] policy
     /*  920291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920301 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  920304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920322 */     GIR_RootConstrainSelectedInstOperands,
     /*  920323 */     // GIR_Coverage, 12834,
     /*  920323 */     GIR_EraseRootFromParent_Done,
     /*  920324 */   // Label 13878: @920324
     /*  920324 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(920401), // Rule ID 12835 //
     /*  920329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  920332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  920340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  920343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  920346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  920349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920368 */     // MIs[0] policy
     /*  920368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920378 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*  920381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920399 */     GIR_RootConstrainSelectedInstOperands,
     /*  920400 */     // GIR_Coverage, 12835,
     /*  920400 */     GIR_EraseRootFromParent_Done,
     /*  920401 */   // Label 13879: @920401
     /*  920401 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(920478), // Rule ID 12838 //
     /*  920406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  920417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  920420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  920423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  920426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920445 */     // MIs[0] policy
     /*  920445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920455 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /*  920458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920476 */     GIR_RootConstrainSelectedInstOperands,
     /*  920477 */     // GIR_Coverage, 12838,
     /*  920477 */     GIR_EraseRootFromParent_Done,
     /*  920478 */   // Label 13880: @920478
     /*  920478 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(920555), // Rule ID 12839 //
     /*  920483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  920494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  920497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  920500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  920503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920522 */     // MIs[0] policy
     /*  920522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920532 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /*  920535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920553 */     GIR_RootConstrainSelectedInstOperands,
     /*  920554 */     // GIR_Coverage, 12839,
     /*  920554 */     GIR_EraseRootFromParent_Done,
     /*  920555 */   // Label 13881: @920555
     /*  920555 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(920632), // Rule ID 12842 //
     /*  920560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  920571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  920574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  920577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  920580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920599 */     // MIs[0] policy
     /*  920599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920609 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /*  920612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920630 */     GIR_RootConstrainSelectedInstOperands,
     /*  920631 */     // GIR_Coverage, 12842,
     /*  920631 */     GIR_EraseRootFromParent_Done,
     /*  920632 */   // Label 13882: @920632
     /*  920632 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(920709), // Rule ID 12843 //
     /*  920637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  920648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  920651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  920654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  920657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920676 */     // MIs[0] policy
     /*  920676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920686 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /*  920689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920707 */     GIR_RootConstrainSelectedInstOperands,
     /*  920708 */     // GIR_Coverage, 12843,
     /*  920708 */     GIR_EraseRootFromParent_Done,
     /*  920709 */   // Label 13883: @920709
     /*  920709 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(920786), // Rule ID 12846 //
     /*  920714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  920725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  920728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  920731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  920734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920753 */     // MIs[0] policy
     /*  920753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920763 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  920766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920784 */     GIR_RootConstrainSelectedInstOperands,
     /*  920785 */     // GIR_Coverage, 12846,
     /*  920785 */     GIR_EraseRootFromParent_Done,
     /*  920786 */   // Label 13884: @920786
     /*  920786 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(920863), // Rule ID 12847 //
     /*  920791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  920802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  920805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  920808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  920811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920830 */     // MIs[0] policy
     /*  920830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  920843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920861 */     GIR_RootConstrainSelectedInstOperands,
     /*  920862 */     // GIR_Coverage, 12847,
     /*  920862 */     GIR_EraseRootFromParent_Done,
     /*  920863 */   // Label 13885: @920863
     /*  920863 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(920940), // Rule ID 12850 //
     /*  920868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  920879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  920882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  920885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  920888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920907 */     // MIs[0] policy
     /*  920907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920917 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /*  920920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  920928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920938 */     GIR_RootConstrainSelectedInstOperands,
     /*  920939 */     // GIR_Coverage, 12850,
     /*  920939 */     GIR_EraseRootFromParent_Done,
     /*  920940 */   // Label 13886: @920940
     /*  920940 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(921017), // Rule ID 12851 //
     /*  920945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  920953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  920956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  920959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  920962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  920965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  920980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  920984 */     // MIs[0] policy
     /*  920984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /*  920997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921015 */     GIR_RootConstrainSelectedInstOperands,
     /*  921016 */     // GIR_Coverage, 12851,
     /*  921016 */     GIR_EraseRootFromParent_Done,
     /*  921017 */   // Label 13887: @921017
     /*  921017 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(921094), // Rule ID 12854 //
     /*  921022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  921042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921061 */     // MIs[0] policy
     /*  921061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  921074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921092 */     GIR_RootConstrainSelectedInstOperands,
     /*  921093 */     // GIR_Coverage, 12854,
     /*  921093 */     GIR_EraseRootFromParent_Done,
     /*  921094 */   // Label 13888: @921094
     /*  921094 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(921171), // Rule ID 12855 //
     /*  921099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  921119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921138 */     // MIs[0] policy
     /*  921138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  921151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921169 */     GIR_RootConstrainSelectedInstOperands,
     /*  921170 */     // GIR_Coverage, 12855,
     /*  921170 */     GIR_EraseRootFromParent_Done,
     /*  921171 */   // Label 13889: @921171
     /*  921171 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(921248), // Rule ID 12858 //
     /*  921176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  921196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921215 */     // MIs[0] policy
     /*  921215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  921228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921246 */     GIR_RootConstrainSelectedInstOperands,
     /*  921247 */     // GIR_Coverage, 12858,
     /*  921247 */     GIR_EraseRootFromParent_Done,
     /*  921248 */   // Label 13890: @921248
     /*  921248 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(921325), // Rule ID 12859 //
     /*  921253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  921273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921292 */     // MIs[0] policy
     /*  921292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /*  921305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921323 */     GIR_RootConstrainSelectedInstOperands,
     /*  921324 */     // GIR_Coverage, 12859,
     /*  921324 */     GIR_EraseRootFromParent_Done,
     /*  921325 */   // Label 13891: @921325
     /*  921325 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(921402), // Rule ID 12862 //
     /*  921330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  921341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  921344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  921350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921369 */     // MIs[0] policy
     /*  921369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921379 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921400 */     GIR_RootConstrainSelectedInstOperands,
     /*  921401 */     // GIR_Coverage, 12862,
     /*  921401 */     GIR_EraseRootFromParent_Done,
     /*  921402 */   // Label 13892: @921402
     /*  921402 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(921479), // Rule ID 12863 //
     /*  921407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  921418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  921421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  921427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921446 */     // MIs[0] policy
     /*  921446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921477 */     GIR_RootConstrainSelectedInstOperands,
     /*  921478 */     // GIR_Coverage, 12863,
     /*  921478 */     GIR_EraseRootFromParent_Done,
     /*  921479 */   // Label 13893: @921479
     /*  921479 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(921556), // Rule ID 12866 //
     /*  921484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  921495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  921498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  921504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921523 */     // MIs[0] policy
     /*  921523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921533 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921554 */     GIR_RootConstrainSelectedInstOperands,
     /*  921555 */     // GIR_Coverage, 12866,
     /*  921555 */     GIR_EraseRootFromParent_Done,
     /*  921556 */   // Label 13894: @921556
     /*  921556 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(921633), // Rule ID 12867 //
     /*  921561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  921572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  921575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  921581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921600 */     // MIs[0] policy
     /*  921600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921631 */     GIR_RootConstrainSelectedInstOperands,
     /*  921632 */     // GIR_Coverage, 12867,
     /*  921632 */     GIR_EraseRootFromParent_Done,
     /*  921633 */   // Label 13895: @921633
     /*  921633 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(921710), // Rule ID 12870 //
     /*  921638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  921649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  921652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  921658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921677 */     // MIs[0] policy
     /*  921677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921687 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921708 */     GIR_RootConstrainSelectedInstOperands,
     /*  921709 */     // GIR_Coverage, 12870,
     /*  921709 */     GIR_EraseRootFromParent_Done,
     /*  921710 */   // Label 13896: @921710
     /*  921710 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(921787), // Rule ID 12871 //
     /*  921715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  921726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  921729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  921735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921754 */     // MIs[0] policy
     /*  921754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921785 */     GIR_RootConstrainSelectedInstOperands,
     /*  921786 */     // GIR_Coverage, 12871,
     /*  921786 */     GIR_EraseRootFromParent_Done,
     /*  921787 */   // Label 13897: @921787
     /*  921787 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(921864), // Rule ID 12874 //
     /*  921792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  921803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  921806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  921812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921831 */     // MIs[0] policy
     /*  921831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921841 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921862 */     GIR_RootConstrainSelectedInstOperands,
     /*  921863 */     // GIR_Coverage, 12874,
     /*  921863 */     GIR_EraseRootFromParent_Done,
     /*  921864 */   // Label 13898: @921864
     /*  921864 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(921941), // Rule ID 12875 //
     /*  921869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  921880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  921883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  921886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  921889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921908 */     // MIs[0] policy
     /*  921908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /*  921921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  921929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921939 */     GIR_RootConstrainSelectedInstOperands,
     /*  921940 */     // GIR_Coverage, 12875,
     /*  921940 */     GIR_EraseRootFromParent_Done,
     /*  921941 */   // Label 13899: @921941
     /*  921941 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(922018), // Rule ID 12878 //
     /*  921946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  921954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  921957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  921960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  921963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  921966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  921981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921985 */     // MIs[0] policy
     /*  921985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  921998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922016 */     GIR_RootConstrainSelectedInstOperands,
     /*  922017 */     // GIR_Coverage, 12878,
     /*  922017 */     GIR_EraseRootFromParent_Done,
     /*  922018 */   // Label 13900: @922018
     /*  922018 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(922095), // Rule ID 12879 //
     /*  922023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  922034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  922037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  922043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922062 */     // MIs[0] policy
     /*  922062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  922075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922093 */     GIR_RootConstrainSelectedInstOperands,
     /*  922094 */     // GIR_Coverage, 12879,
     /*  922094 */     GIR_EraseRootFromParent_Done,
     /*  922095 */   // Label 13901: @922095
     /*  922095 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(922172), // Rule ID 12882 //
     /*  922100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  922111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  922114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  922120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922139 */     // MIs[0] policy
     /*  922139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922149 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  922152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922170 */     GIR_RootConstrainSelectedInstOperands,
     /*  922171 */     // GIR_Coverage, 12882,
     /*  922171 */     GIR_EraseRootFromParent_Done,
     /*  922172 */   // Label 13902: @922172
     /*  922172 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(922249), // Rule ID 12883 //
     /*  922177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  922188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  922191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  922197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922216 */     // MIs[0] policy
     /*  922216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922226 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  922229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922247 */     GIR_RootConstrainSelectedInstOperands,
     /*  922248 */     // GIR_Coverage, 12883,
     /*  922248 */     GIR_EraseRootFromParent_Done,
     /*  922249 */   // Label 13903: @922249
     /*  922249 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(922326), // Rule ID 12886 //
     /*  922254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  922265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  922268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  922274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922293 */     // MIs[0] policy
     /*  922293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922303 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  922306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922324 */     GIR_RootConstrainSelectedInstOperands,
     /*  922325 */     // GIR_Coverage, 12886,
     /*  922325 */     GIR_EraseRootFromParent_Done,
     /*  922326 */   // Label 13904: @922326
     /*  922326 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(922403), // Rule ID 12887 //
     /*  922331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  922342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  922345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  922351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922370 */     // MIs[0] policy
     /*  922370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922380 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  922383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922401 */     GIR_RootConstrainSelectedInstOperands,
     /*  922402 */     // GIR_Coverage, 12887,
     /*  922402 */     GIR_EraseRootFromParent_Done,
     /*  922403 */   // Label 13905: @922403
     /*  922403 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(922480), // Rule ID 12890 //
     /*  922408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  922428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922447 */     // MIs[0] policy
     /*  922447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  922460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922478 */     GIR_RootConstrainSelectedInstOperands,
     /*  922479 */     // GIR_Coverage, 12890,
     /*  922479 */     GIR_EraseRootFromParent_Done,
     /*  922480 */   // Label 13906: @922480
     /*  922480 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(922557), // Rule ID 12891 //
     /*  922485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  922505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922524 */     // MIs[0] policy
     /*  922524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  922537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922555 */     GIR_RootConstrainSelectedInstOperands,
     /*  922556 */     // GIR_Coverage, 12891,
     /*  922556 */     GIR_EraseRootFromParent_Done,
     /*  922557 */   // Label 13907: @922557
     /*  922557 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(922634), // Rule ID 12894 //
     /*  922562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  922582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922601 */     // MIs[0] policy
     /*  922601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  922614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922632 */     GIR_RootConstrainSelectedInstOperands,
     /*  922633 */     // GIR_Coverage, 12894,
     /*  922633 */     GIR_EraseRootFromParent_Done,
     /*  922634 */   // Label 13908: @922634
     /*  922634 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(922711), // Rule ID 12895 //
     /*  922639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  922659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922678 */     // MIs[0] policy
     /*  922678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  922691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922709 */     GIR_RootConstrainSelectedInstOperands,
     /*  922710 */     // GIR_Coverage, 12895,
     /*  922710 */     GIR_EraseRootFromParent_Done,
     /*  922711 */   // Label 13909: @922711
     /*  922711 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(922788), // Rule ID 12898 //
     /*  922716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  922727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  922730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  922736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922755 */     // MIs[0] policy
     /*  922755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922765 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  922768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922786 */     GIR_RootConstrainSelectedInstOperands,
     /*  922787 */     // GIR_Coverage, 12898,
     /*  922787 */     GIR_EraseRootFromParent_Done,
     /*  922788 */   // Label 13910: @922788
     /*  922788 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(922865), // Rule ID 12899 //
     /*  922793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  922804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  922807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  922813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922832 */     // MIs[0] policy
     /*  922832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  922845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922863 */     GIR_RootConstrainSelectedInstOperands,
     /*  922864 */     // GIR_Coverage, 12899,
     /*  922864 */     GIR_EraseRootFromParent_Done,
     /*  922865 */   // Label 13911: @922865
     /*  922865 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(922942), // Rule ID 12902 //
     /*  922870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  922881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  922884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  922887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  922890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922909 */     // MIs[0] policy
     /*  922909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  922922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  922930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922940 */     GIR_RootConstrainSelectedInstOperands,
     /*  922941 */     // GIR_Coverage, 12902,
     /*  922941 */     GIR_EraseRootFromParent_Done,
     /*  922942 */   // Label 13912: @922942
     /*  922942 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(923019), // Rule ID 12903 //
     /*  922947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  922955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  922958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  922961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  922964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  922967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  922982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922986 */     // MIs[0] policy
     /*  922986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  922999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923017 */     GIR_RootConstrainSelectedInstOperands,
     /*  923018 */     // GIR_Coverage, 12903,
     /*  923018 */     GIR_EraseRootFromParent_Done,
     /*  923019 */   // Label 13913: @923019
     /*  923019 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(923096), // Rule ID 12906 //
     /*  923024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  923041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  923044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923063 */     // MIs[0] policy
     /*  923063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923073 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  923076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923094 */     GIR_RootConstrainSelectedInstOperands,
     /*  923095 */     // GIR_Coverage, 12906,
     /*  923095 */     GIR_EraseRootFromParent_Done,
     /*  923096 */   // Label 13914: @923096
     /*  923096 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(923173), // Rule ID 12907 //
     /*  923101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  923118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  923121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923140 */     // MIs[0] policy
     /*  923140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  923153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923171 */     GIR_RootConstrainSelectedInstOperands,
     /*  923172 */     // GIR_Coverage, 12907,
     /*  923172 */     GIR_EraseRootFromParent_Done,
     /*  923173 */   // Label 13915: @923173
     /*  923173 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(923250), // Rule ID 12910 //
     /*  923178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  923195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  923198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923217 */     // MIs[0] policy
     /*  923217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  923230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923248 */     GIR_RootConstrainSelectedInstOperands,
     /*  923249 */     // GIR_Coverage, 12910,
     /*  923249 */     GIR_EraseRootFromParent_Done,
     /*  923250 */   // Label 13916: @923250
     /*  923250 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(923327), // Rule ID 12911 //
     /*  923255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  923272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  923275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923294 */     // MIs[0] policy
     /*  923294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  923307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923325 */     GIR_RootConstrainSelectedInstOperands,
     /*  923326 */     // GIR_Coverage, 12911,
     /*  923326 */     GIR_EraseRootFromParent_Done,
     /*  923327 */   // Label 13917: @923327
     /*  923327 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(923404), // Rule ID 12914 //
     /*  923332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  923349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  923352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923371 */     // MIs[0] policy
     /*  923371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  923384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923402 */     GIR_RootConstrainSelectedInstOperands,
     /*  923403 */     // GIR_Coverage, 12914,
     /*  923403 */     GIR_EraseRootFromParent_Done,
     /*  923404 */   // Label 13918: @923404
     /*  923404 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(923481), // Rule ID 12915 //
     /*  923409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  923426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  923429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923448 */     // MIs[0] policy
     /*  923448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /*  923461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923479 */     GIR_RootConstrainSelectedInstOperands,
     /*  923480 */     // GIR_Coverage, 12915,
     /*  923480 */     GIR_EraseRootFromParent_Done,
     /*  923481 */   // Label 13919: @923481
     /*  923481 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(923558), // Rule ID 12918 //
     /*  923486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  923503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  923506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923525 */     // MIs[0] policy
     /*  923525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923535 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  923538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923556 */     GIR_RootConstrainSelectedInstOperands,
     /*  923557 */     // GIR_Coverage, 12918,
     /*  923557 */     GIR_EraseRootFromParent_Done,
     /*  923558 */   // Label 13920: @923558
     /*  923558 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(923635), // Rule ID 12919 //
     /*  923563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  923580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  923583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923602 */     // MIs[0] policy
     /*  923602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /*  923615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923633 */     GIR_RootConstrainSelectedInstOperands,
     /*  923634 */     // GIR_Coverage, 12919,
     /*  923634 */     GIR_EraseRootFromParent_Done,
     /*  923635 */   // Label 13921: @923635
     /*  923635 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(923712), // Rule ID 12922 //
     /*  923640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  923651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  923654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  923657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  923660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923679 */     // MIs[0] policy
     /*  923679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  923692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923710 */     GIR_RootConstrainSelectedInstOperands,
     /*  923711 */     // GIR_Coverage, 12922,
     /*  923711 */     GIR_EraseRootFromParent_Done,
     /*  923712 */   // Label 13922: @923712
     /*  923712 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(923789), // Rule ID 12923 //
     /*  923717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /*  923725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  923728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  923731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  923734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  923737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  923752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923756 */     // MIs[0] policy
     /*  923756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /*  923769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923787 */     GIR_RootConstrainSelectedInstOperands,
     /*  923788 */     // GIR_Coverage, 12923,
     /*  923788 */     GIR_EraseRootFromParent_Done,
     /*  923789 */   // Label 13923: @923789
     /*  923789 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(923866), // Rule ID 12926 //
     /*  923794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  923802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  923805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  923808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  923811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  923814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923833 */     // MIs[0] policy
     /*  923833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923843 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /*  923846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923864 */     GIR_RootConstrainSelectedInstOperands,
     /*  923865 */     // GIR_Coverage, 12926,
     /*  923865 */     GIR_EraseRootFromParent_Done,
     /*  923866 */   // Label 13924: @923866
     /*  923866 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(923943), // Rule ID 12927 //
     /*  923871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  923879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  923882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  923885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  923888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  923891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923910 */     // MIs[0] policy
     /*  923910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /*  923923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  923931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923941 */     GIR_RootConstrainSelectedInstOperands,
     /*  923942 */     // GIR_Coverage, 12927,
     /*  923942 */     GIR_EraseRootFromParent_Done,
     /*  923943 */   // Label 13925: @923943
     /*  923943 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(924020), // Rule ID 12930 //
     /*  923948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  923956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  923959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  923962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  923965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  923968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923987 */     // MIs[0] policy
     /*  923987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923997 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /*  924000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924018 */     GIR_RootConstrainSelectedInstOperands,
     /*  924019 */     // GIR_Coverage, 12930,
     /*  924019 */     GIR_EraseRootFromParent_Done,
     /*  924020 */   // Label 13926: @924020
     /*  924020 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(924097), // Rule ID 12931 //
     /*  924025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  924036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  924039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  924042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  924045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924064 */     // MIs[0] policy
     /*  924064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /*  924077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924095 */     GIR_RootConstrainSelectedInstOperands,
     /*  924096 */     // GIR_Coverage, 12931,
     /*  924096 */     GIR_EraseRootFromParent_Done,
     /*  924097 */   // Label 13927: @924097
     /*  924097 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(924174), // Rule ID 12934 //
     /*  924102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  924113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  924116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  924119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  924122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924141 */     // MIs[0] policy
     /*  924141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924151 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924172 */     GIR_RootConstrainSelectedInstOperands,
     /*  924173 */     // GIR_Coverage, 12934,
     /*  924173 */     GIR_EraseRootFromParent_Done,
     /*  924174 */   // Label 13928: @924174
     /*  924174 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(924251), // Rule ID 12935 //
     /*  924179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  924190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  924193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  924196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  924199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924218 */     // MIs[0] policy
     /*  924218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924249 */     GIR_RootConstrainSelectedInstOperands,
     /*  924250 */     // GIR_Coverage, 12935,
     /*  924250 */     GIR_EraseRootFromParent_Done,
     /*  924251 */   // Label 13929: @924251
     /*  924251 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(924328), // Rule ID 12938 //
     /*  924256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  924276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924295 */     // MIs[0] policy
     /*  924295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924305 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /*  924308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924326 */     GIR_RootConstrainSelectedInstOperands,
     /*  924327 */     // GIR_Coverage, 12938,
     /*  924327 */     GIR_EraseRootFromParent_Done,
     /*  924328 */   // Label 13930: @924328
     /*  924328 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(924405), // Rule ID 12939 //
     /*  924333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  924353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924372 */     // MIs[0] policy
     /*  924372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /*  924385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924403 */     GIR_RootConstrainSelectedInstOperands,
     /*  924404 */     // GIR_Coverage, 12939,
     /*  924404 */     GIR_EraseRootFromParent_Done,
     /*  924405 */   // Label 13931: @924405
     /*  924405 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(924482), // Rule ID 12942 //
     /*  924410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  924430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924449 */     // MIs[0] policy
     /*  924449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924459 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924480 */     GIR_RootConstrainSelectedInstOperands,
     /*  924481 */     // GIR_Coverage, 12942,
     /*  924481 */     GIR_EraseRootFromParent_Done,
     /*  924482 */   // Label 13932: @924482
     /*  924482 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(924559), // Rule ID 12943 //
     /*  924487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  924507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924526 */     // MIs[0] policy
     /*  924526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924557 */     GIR_RootConstrainSelectedInstOperands,
     /*  924558 */     // GIR_Coverage, 12943,
     /*  924558 */     GIR_EraseRootFromParent_Done,
     /*  924559 */   // Label 13933: @924559
     /*  924559 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(924636), // Rule ID 12946 //
     /*  924564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  924584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924603 */     // MIs[0] policy
     /*  924603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924613 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924634 */     GIR_RootConstrainSelectedInstOperands,
     /*  924635 */     // GIR_Coverage, 12946,
     /*  924635 */     GIR_EraseRootFromParent_Done,
     /*  924636 */   // Label 13934: @924636
     /*  924636 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(924713), // Rule ID 12947 //
     /*  924641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  924661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924680 */     // MIs[0] policy
     /*  924680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /*  924693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924711 */     GIR_RootConstrainSelectedInstOperands,
     /*  924712 */     // GIR_Coverage, 12947,
     /*  924712 */     GIR_EraseRootFromParent_Done,
     /*  924713 */   // Label 13935: @924713
     /*  924713 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(924790), // Rule ID 12950 //
     /*  924718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  924729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  924732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  924735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  924738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924757 */     // MIs[0] policy
     /*  924757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924767 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  924770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924788 */     GIR_RootConstrainSelectedInstOperands,
     /*  924789 */     // GIR_Coverage, 12950,
     /*  924789 */     GIR_EraseRootFromParent_Done,
     /*  924790 */   // Label 13936: @924790
     /*  924790 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(924867), // Rule ID 12951 //
     /*  924795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  924806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  924809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  924812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  924815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924834 */     // MIs[0] policy
     /*  924834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  924847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  924863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924865 */     GIR_RootConstrainSelectedInstOperands,
     /*  924866 */     // GIR_Coverage, 12951,
     /*  924866 */     GIR_EraseRootFromParent_Done,
     /*  924867 */   // Label 13937: @924867
     /*  924867 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(924944), // Rule ID 12954 //
     /*  924872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  924892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924911 */     // MIs[0] policy
     /*  924911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  924924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  924932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924942 */     GIR_RootConstrainSelectedInstOperands,
     /*  924943 */     // GIR_Coverage, 12954,
     /*  924943 */     GIR_EraseRootFromParent_Done,
     /*  924944 */   // Label 13938: @924944
     /*  924944 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(925021), // Rule ID 12955 //
     /*  924949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  924957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  924969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924988 */     // MIs[0] policy
     /*  924988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  925001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925019 */     GIR_RootConstrainSelectedInstOperands,
     /*  925020 */     // GIR_Coverage, 12955,
     /*  925020 */     GIR_EraseRootFromParent_Done,
     /*  925021 */   // Label 13939: @925021
     /*  925021 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(925098), // Rule ID 12958 //
     /*  925026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  925046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925065 */     // MIs[0] policy
     /*  925065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  925078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925096 */     GIR_RootConstrainSelectedInstOperands,
     /*  925097 */     // GIR_Coverage, 12958,
     /*  925097 */     GIR_EraseRootFromParent_Done,
     /*  925098 */   // Label 13940: @925098
     /*  925098 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(925175), // Rule ID 12959 //
     /*  925103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  925123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925142 */     // MIs[0] policy
     /*  925142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  925155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925173 */     GIR_RootConstrainSelectedInstOperands,
     /*  925174 */     // GIR_Coverage, 12959,
     /*  925174 */     GIR_EraseRootFromParent_Done,
     /*  925175 */   // Label 13941: @925175
     /*  925175 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(925252), // Rule ID 12962 //
     /*  925180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  925200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925219 */     // MIs[0] policy
     /*  925219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  925232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925250 */     GIR_RootConstrainSelectedInstOperands,
     /*  925251 */     // GIR_Coverage, 12962,
     /*  925251 */     GIR_EraseRootFromParent_Done,
     /*  925252 */   // Label 13942: @925252
     /*  925252 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(925329), // Rule ID 12963 //
     /*  925257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  925277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925296 */     // MIs[0] policy
     /*  925296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /*  925309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925327 */     GIR_RootConstrainSelectedInstOperands,
     /*  925328 */     // GIR_Coverage, 12963,
     /*  925328 */     GIR_EraseRootFromParent_Done,
     /*  925329 */   // Label 13943: @925329
     /*  925329 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(925406), // Rule ID 12966 //
     /*  925334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  925345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  925348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  925351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  925354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925373 */     // MIs[0] policy
     /*  925373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  925386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925404 */     GIR_RootConstrainSelectedInstOperands,
     /*  925405 */     // GIR_Coverage, 12966,
     /*  925405 */     GIR_EraseRootFromParent_Done,
     /*  925406 */   // Label 13944: @925406
     /*  925406 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(925483), // Rule ID 12967 //
     /*  925411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  925422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  925425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  925428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  925431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925450 */     // MIs[0] policy
     /*  925450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  925463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925481 */     GIR_RootConstrainSelectedInstOperands,
     /*  925482 */     // GIR_Coverage, 12967,
     /*  925482 */     GIR_EraseRootFromParent_Done,
     /*  925483 */   // Label 13945: @925483
     /*  925483 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(925560), // Rule ID 12970 //
     /*  925488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  925499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  925502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  925505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  925508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925527 */     // MIs[0] policy
     /*  925527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925537 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  925540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925558 */     GIR_RootConstrainSelectedInstOperands,
     /*  925559 */     // GIR_Coverage, 12970,
     /*  925559 */     GIR_EraseRootFromParent_Done,
     /*  925560 */   // Label 13946: @925560
     /*  925560 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(925637), // Rule ID 12971 //
     /*  925565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  925576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  925579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  925582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  925585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925604 */     // MIs[0] policy
     /*  925604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  925617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925635 */     GIR_RootConstrainSelectedInstOperands,
     /*  925636 */     // GIR_Coverage, 12971,
     /*  925636 */     GIR_EraseRootFromParent_Done,
     /*  925637 */   // Label 13947: @925637
     /*  925637 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(925714), // Rule ID 12974 //
     /*  925642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  925653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  925656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  925659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  925662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925681 */     // MIs[0] policy
     /*  925681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925691 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  925694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925712 */     GIR_RootConstrainSelectedInstOperands,
     /*  925713 */     // GIR_Coverage, 12974,
     /*  925713 */     GIR_EraseRootFromParent_Done,
     /*  925714 */   // Label 13948: @925714
     /*  925714 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(925791), // Rule ID 12975 //
     /*  925719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  925730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  925733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  925736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  925739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925758 */     // MIs[0] policy
     /*  925758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  925771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  925787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925789 */     GIR_RootConstrainSelectedInstOperands,
     /*  925790 */     // GIR_Coverage, 12975,
     /*  925790 */     GIR_EraseRootFromParent_Done,
     /*  925791 */   // Label 13949: @925791
     /*  925791 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(925868), // Rule ID 12978 //
     /*  925796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  925816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925835 */     // MIs[0] policy
     /*  925835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  925848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925866 */     GIR_RootConstrainSelectedInstOperands,
     /*  925867 */     // GIR_Coverage, 12978,
     /*  925867 */     GIR_EraseRootFromParent_Done,
     /*  925868 */   // Label 13950: @925868
     /*  925868 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(925945), // Rule ID 12979 //
     /*  925873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  925893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925912 */     // MIs[0] policy
     /*  925912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  925925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  925933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925943 */     GIR_RootConstrainSelectedInstOperands,
     /*  925944 */     // GIR_Coverage, 12979,
     /*  925944 */     GIR_EraseRootFromParent_Done,
     /*  925945 */   // Label 13951: @925945
     /*  925945 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(926022), // Rule ID 12982 //
     /*  925950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  925958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  925970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925989 */     // MIs[0] policy
     /*  925989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  926002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926020 */     GIR_RootConstrainSelectedInstOperands,
     /*  926021 */     // GIR_Coverage, 12982,
     /*  926021 */     GIR_EraseRootFromParent_Done,
     /*  926022 */   // Label 13952: @926022
     /*  926022 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(926099), // Rule ID 12983 //
     /*  926027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  926047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926066 */     // MIs[0] policy
     /*  926066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  926079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926097 */     GIR_RootConstrainSelectedInstOperands,
     /*  926098 */     // GIR_Coverage, 12983,
     /*  926098 */     GIR_EraseRootFromParent_Done,
     /*  926099 */   // Label 13953: @926099
     /*  926099 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(926176), // Rule ID 12986 //
     /*  926104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  926124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926143 */     // MIs[0] policy
     /*  926143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926153 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  926156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926174 */     GIR_RootConstrainSelectedInstOperands,
     /*  926175 */     // GIR_Coverage, 12986,
     /*  926175 */     GIR_EraseRootFromParent_Done,
     /*  926176 */   // Label 13954: @926176
     /*  926176 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(926253), // Rule ID 12987 //
     /*  926181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  926201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926220 */     // MIs[0] policy
     /*  926220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  926233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926251 */     GIR_RootConstrainSelectedInstOperands,
     /*  926252 */     // GIR_Coverage, 12987,
     /*  926252 */     GIR_EraseRootFromParent_Done,
     /*  926253 */   // Label 13955: @926253
     /*  926253 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(926330), // Rule ID 12990 //
     /*  926258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  926278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926297 */     // MIs[0] policy
     /*  926297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  926310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926328 */     GIR_RootConstrainSelectedInstOperands,
     /*  926329 */     // GIR_Coverage, 12990,
     /*  926329 */     GIR_EraseRootFromParent_Done,
     /*  926330 */   // Label 13956: @926330
     /*  926330 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(926407), // Rule ID 12991 //
     /*  926335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  926355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926374 */     // MIs[0] policy
     /*  926374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  926387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926405 */     GIR_RootConstrainSelectedInstOperands,
     /*  926406 */     // GIR_Coverage, 12991,
     /*  926406 */     GIR_EraseRootFromParent_Done,
     /*  926407 */   // Label 13957: @926407
     /*  926407 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(926484), // Rule ID 12994 //
     /*  926412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  926432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926451 */     // MIs[0] policy
     /*  926451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  926464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926482 */     GIR_RootConstrainSelectedInstOperands,
     /*  926483 */     // GIR_Coverage, 12994,
     /*  926483 */     GIR_EraseRootFromParent_Done,
     /*  926484 */   // Label 13958: @926484
     /*  926484 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(926561), // Rule ID 12995 //
     /*  926489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  926509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926528 */     // MIs[0] policy
     /*  926528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  926541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926559 */     GIR_RootConstrainSelectedInstOperands,
     /*  926560 */     // GIR_Coverage, 12995,
     /*  926560 */     GIR_EraseRootFromParent_Done,
     /*  926561 */   // Label 13959: @926561
     /*  926561 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(926638), // Rule ID 12998 //
     /*  926566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  926586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926605 */     // MIs[0] policy
     /*  926605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  926618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926636 */     GIR_RootConstrainSelectedInstOperands,
     /*  926637 */     // GIR_Coverage, 12998,
     /*  926637 */     GIR_EraseRootFromParent_Done,
     /*  926638 */   // Label 13960: @926638
     /*  926638 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(926715), // Rule ID 12999 //
     /*  926643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  926663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926682 */     // MIs[0] policy
     /*  926682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  926695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926713 */     GIR_RootConstrainSelectedInstOperands,
     /*  926714 */     // GIR_Coverage, 12999,
     /*  926714 */     GIR_EraseRootFromParent_Done,
     /*  926715 */   // Label 13961: @926715
     /*  926715 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(926792), // Rule ID 13002 //
     /*  926720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  926740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926759 */     // MIs[0] policy
     /*  926759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  926772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926790 */     GIR_RootConstrainSelectedInstOperands,
     /*  926791 */     // GIR_Coverage, 13002,
     /*  926791 */     GIR_EraseRootFromParent_Done,
     /*  926792 */   // Label 13962: @926792
     /*  926792 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(926869), // Rule ID 13003 //
     /*  926797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  926817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926836 */     // MIs[0] policy
     /*  926836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /*  926849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926867 */     GIR_RootConstrainSelectedInstOperands,
     /*  926868 */     // GIR_Coverage, 13003,
     /*  926868 */     GIR_EraseRootFromParent_Done,
     /*  926869 */   // Label 13963: @926869
     /*  926869 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(926946), // Rule ID 13006 //
     /*  926874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  926894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926913 */     // MIs[0] policy
     /*  926913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  926926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  926934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926944 */     GIR_RootConstrainSelectedInstOperands,
     /*  926945 */     // GIR_Coverage, 13006,
     /*  926945 */     GIR_EraseRootFromParent_Done,
     /*  926946 */   // Label 13964: @926946
     /*  926946 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(927023), // Rule ID 13007 //
     /*  926951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  926959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  926971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926990 */     // MIs[0] policy
     /*  926990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /*  927003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927021 */     GIR_RootConstrainSelectedInstOperands,
     /*  927022 */     // GIR_Coverage, 13007,
     /*  927022 */     GIR_EraseRootFromParent_Done,
     /*  927023 */   // Label 13965: @927023
     /*  927023 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(927100), // Rule ID 13010 //
     /*  927028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  927031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  927048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927067 */     // MIs[0] policy
     /*  927067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  927080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927098 */     GIR_RootConstrainSelectedInstOperands,
     /*  927099 */     // GIR_Coverage, 13010,
     /*  927099 */     GIR_EraseRootFromParent_Done,
     /*  927100 */   // Label 13966: @927100
     /*  927100 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(927177), // Rule ID 13011 //
     /*  927105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  927108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  927125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927144 */     // MIs[0] policy
     /*  927144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927154 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /*  927157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927175 */     GIR_RootConstrainSelectedInstOperands,
     /*  927176 */     // GIR_Coverage, 13011,
     /*  927176 */     GIR_EraseRootFromParent_Done,
     /*  927177 */   // Label 13967: @927177
     /*  927177 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(927254), // Rule ID 13014 //
     /*  927182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  927202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927221 */     // MIs[0] policy
     /*  927221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927231 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /*  927234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927252 */     GIR_RootConstrainSelectedInstOperands,
     /*  927253 */     // GIR_Coverage, 13014,
     /*  927253 */     GIR_EraseRootFromParent_Done,
     /*  927254 */   // Label 13968: @927254
     /*  927254 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(927331), // Rule ID 13015 //
     /*  927259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  927276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  927279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927298 */     // MIs[0] policy
     /*  927298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /*  927311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927329 */     GIR_RootConstrainSelectedInstOperands,
     /*  927330 */     // GIR_Coverage, 13015,
     /*  927330 */     GIR_EraseRootFromParent_Done,
     /*  927331 */   // Label 13969: @927331
     /*  927331 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(927408), // Rule ID 13018 //
     /*  927336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  927356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927375 */     // MIs[0] policy
     /*  927375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927385 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /*  927388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927406 */     GIR_RootConstrainSelectedInstOperands,
     /*  927407 */     // GIR_Coverage, 13018,
     /*  927407 */     GIR_EraseRootFromParent_Done,
     /*  927408 */   // Label 13970: @927408
     /*  927408 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(927485), // Rule ID 13019 //
     /*  927413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  927430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  927433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927452 */     // MIs[0] policy
     /*  927452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927462 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /*  927465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927483 */     GIR_RootConstrainSelectedInstOperands,
     /*  927484 */     // GIR_Coverage, 13019,
     /*  927484 */     GIR_EraseRootFromParent_Done,
     /*  927485 */   // Label 13971: @927485
     /*  927485 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(927562), // Rule ID 13022 //
     /*  927490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  927510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927529 */     // MIs[0] policy
     /*  927529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  927542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927560 */     GIR_RootConstrainSelectedInstOperands,
     /*  927561 */     // GIR_Coverage, 13022,
     /*  927561 */     GIR_EraseRootFromParent_Done,
     /*  927562 */   // Label 13972: @927562
     /*  927562 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(927639), // Rule ID 13023 //
     /*  927567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  927584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  927587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927606 */     // MIs[0] policy
     /*  927606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  927619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927637 */     GIR_RootConstrainSelectedInstOperands,
     /*  927638 */     // GIR_Coverage, 13023,
     /*  927638 */     GIR_EraseRootFromParent_Done,
     /*  927639 */   // Label 13973: @927639
     /*  927639 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(927716), // Rule ID 13026 //
     /*  927644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  927664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927683 */     // MIs[0] policy
     /*  927683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /*  927696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927714 */     GIR_RootConstrainSelectedInstOperands,
     /*  927715 */     // GIR_Coverage, 13026,
     /*  927715 */     GIR_EraseRootFromParent_Done,
     /*  927716 */   // Label 13974: @927716
     /*  927716 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(927793), // Rule ID 13027 //
     /*  927721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  927738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  927741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927760 */     // MIs[0] policy
     /*  927760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927770 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /*  927773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927791 */     GIR_RootConstrainSelectedInstOperands,
     /*  927792 */     // GIR_Coverage, 13027,
     /*  927792 */     GIR_EraseRootFromParent_Done,
     /*  927793 */   // Label 13975: @927793
     /*  927793 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(927870), // Rule ID 13030 //
     /*  927798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  927818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927837 */     // MIs[0] policy
     /*  927837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927847 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  927850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927868 */     GIR_RootConstrainSelectedInstOperands,
     /*  927869 */     // GIR_Coverage, 13030,
     /*  927869 */     GIR_EraseRootFromParent_Done,
     /*  927870 */   // Label 13976: @927870
     /*  927870 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(927947), // Rule ID 13031 //
     /*  927875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  927892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  927895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927914 */     // MIs[0] policy
     /*  927914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  927927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  927935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927945 */     GIR_RootConstrainSelectedInstOperands,
     /*  927946 */     // GIR_Coverage, 13031,
     /*  927946 */     GIR_EraseRootFromParent_Done,
     /*  927947 */   // Label 13977: @927947
     /*  927947 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(928024), // Rule ID 13034 //
     /*  927952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  927960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  927969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  927972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  927987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927991 */     // MIs[0] policy
     /*  927991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928001 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  928004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928022 */     GIR_RootConstrainSelectedInstOperands,
     /*  928023 */     // GIR_Coverage, 13034,
     /*  928023 */     GIR_EraseRootFromParent_Done,
     /*  928024 */   // Label 13978: @928024
     /*  928024 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(928101), // Rule ID 13035 //
     /*  928029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  928049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928068 */     // MIs[0] policy
     /*  928068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /*  928081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928099 */     GIR_RootConstrainSelectedInstOperands,
     /*  928100 */     // GIR_Coverage, 13035,
     /*  928100 */     GIR_EraseRootFromParent_Done,
     /*  928101 */   // Label 13979: @928101
     /*  928101 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(928178), // Rule ID 13038 //
     /*  928106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  928126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928145 */     // MIs[0] policy
     /*  928145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928155 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928176 */     GIR_RootConstrainSelectedInstOperands,
     /*  928177 */     // GIR_Coverage, 13038,
     /*  928177 */     GIR_EraseRootFromParent_Done,
     /*  928178 */   // Label 13980: @928178
     /*  928178 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(928255), // Rule ID 13039 //
     /*  928183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  928203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928222 */     // MIs[0] policy
     /*  928222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928253 */     GIR_RootConstrainSelectedInstOperands,
     /*  928254 */     // GIR_Coverage, 13039,
     /*  928254 */     GIR_EraseRootFromParent_Done,
     /*  928255 */   // Label 13981: @928255
     /*  928255 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(928332), // Rule ID 13042 //
     /*  928260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  928280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928299 */     // MIs[0] policy
     /*  928299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928330 */     GIR_RootConstrainSelectedInstOperands,
     /*  928331 */     // GIR_Coverage, 13042,
     /*  928331 */     GIR_EraseRootFromParent_Done,
     /*  928332 */   // Label 13982: @928332
     /*  928332 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(928409), // Rule ID 13043 //
     /*  928337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  928357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928376 */     // MIs[0] policy
     /*  928376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928407 */     GIR_RootConstrainSelectedInstOperands,
     /*  928408 */     // GIR_Coverage, 13043,
     /*  928408 */     GIR_EraseRootFromParent_Done,
     /*  928409 */   // Label 13983: @928409
     /*  928409 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(928486), // Rule ID 13046 //
     /*  928414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  928434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928453 */     // MIs[0] policy
     /*  928453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928463 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928484 */     GIR_RootConstrainSelectedInstOperands,
     /*  928485 */     // GIR_Coverage, 13046,
     /*  928485 */     GIR_EraseRootFromParent_Done,
     /*  928486 */   // Label 13984: @928486
     /*  928486 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(928563), // Rule ID 13047 //
     /*  928491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  928511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928530 */     // MIs[0] policy
     /*  928530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928561 */     GIR_RootConstrainSelectedInstOperands,
     /*  928562 */     // GIR_Coverage, 13047,
     /*  928562 */     GIR_EraseRootFromParent_Done,
     /*  928563 */   // Label 13985: @928563
     /*  928563 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(928640), // Rule ID 13050 //
     /*  928568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  928571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  928588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928607 */     // MIs[0] policy
     /*  928607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928617 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928638 */     GIR_RootConstrainSelectedInstOperands,
     /*  928639 */     // GIR_Coverage, 13050,
     /*  928639 */     GIR_EraseRootFromParent_Done,
     /*  928640 */   // Label 13986: @928640
     /*  928640 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(928717), // Rule ID 13051 //
     /*  928645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  928648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  928665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928684 */     // MIs[0] policy
     /*  928684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /*  928697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928715 */     GIR_RootConstrainSelectedInstOperands,
     /*  928716 */     // GIR_Coverage, 13051,
     /*  928716 */     GIR_EraseRootFromParent_Done,
     /*  928717 */   // Label 13987: @928717
     /*  928717 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(928794), // Rule ID 13054 //
     /*  928722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  928742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928761 */     // MIs[0] policy
     /*  928761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  928774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928792 */     GIR_RootConstrainSelectedInstOperands,
     /*  928793 */     // GIR_Coverage, 13054,
     /*  928793 */     GIR_EraseRootFromParent_Done,
     /*  928794 */   // Label 13988: @928794
     /*  928794 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(928871), // Rule ID 13055 //
     /*  928799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  928819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928838 */     // MIs[0] policy
     /*  928838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928848 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  928851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928869 */     GIR_RootConstrainSelectedInstOperands,
     /*  928870 */     // GIR_Coverage, 13055,
     /*  928870 */     GIR_EraseRootFromParent_Done,
     /*  928871 */   // Label 13989: @928871
     /*  928871 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(928948), // Rule ID 13058 //
     /*  928876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  928893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  928896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928915 */     // MIs[0] policy
     /*  928915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928925 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  928928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  928936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928946 */     GIR_RootConstrainSelectedInstOperands,
     /*  928947 */     // GIR_Coverage, 13058,
     /*  928947 */     GIR_EraseRootFromParent_Done,
     /*  928948 */   // Label 13990: @928948
     /*  928948 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(929025), // Rule ID 13059 //
     /*  928953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  928961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  928970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  928973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  928988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928992 */     // MIs[0] policy
     /*  928992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  929005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929023 */     GIR_RootConstrainSelectedInstOperands,
     /*  929024 */     // GIR_Coverage, 13059,
     /*  929024 */     GIR_EraseRootFromParent_Done,
     /*  929025 */   // Label 13991: @929025
     /*  929025 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(929102), // Rule ID 13062 //
     /*  929030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  929050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929069 */     // MIs[0] policy
     /*  929069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929079 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  929082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929100 */     GIR_RootConstrainSelectedInstOperands,
     /*  929101 */     // GIR_Coverage, 13062,
     /*  929101 */     GIR_EraseRootFromParent_Done,
     /*  929102 */   // Label 13992: @929102
     /*  929102 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(929179), // Rule ID 13063 //
     /*  929107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  929127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929146 */     // MIs[0] policy
     /*  929146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929156 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  929159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929177 */     GIR_RootConstrainSelectedInstOperands,
     /*  929178 */     // GIR_Coverage, 13063,
     /*  929178 */     GIR_EraseRootFromParent_Done,
     /*  929179 */   // Label 13993: @929179
     /*  929179 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(929256), // Rule ID 13066 //
     /*  929184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  929204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929223 */     // MIs[0] policy
     /*  929223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  929236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929254 */     GIR_RootConstrainSelectedInstOperands,
     /*  929255 */     // GIR_Coverage, 13066,
     /*  929255 */     GIR_EraseRootFromParent_Done,
     /*  929256 */   // Label 13994: @929256
     /*  929256 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(929333), // Rule ID 13067 //
     /*  929261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  929281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929300 */     // MIs[0] policy
     /*  929300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  929313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929331 */     GIR_RootConstrainSelectedInstOperands,
     /*  929332 */     // GIR_Coverage, 13067,
     /*  929332 */     GIR_EraseRootFromParent_Done,
     /*  929333 */   // Label 13995: @929333
     /*  929333 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(929410), // Rule ID 13070 //
     /*  929338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  929358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929377 */     // MIs[0] policy
     /*  929377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929387 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  929390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929408 */     GIR_RootConstrainSelectedInstOperands,
     /*  929409 */     // GIR_Coverage, 13070,
     /*  929409 */     GIR_EraseRootFromParent_Done,
     /*  929410 */   // Label 13996: @929410
     /*  929410 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(929487), // Rule ID 13071 //
     /*  929415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  929435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929454 */     // MIs[0] policy
     /*  929454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  929467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929485 */     GIR_RootConstrainSelectedInstOperands,
     /*  929486 */     // GIR_Coverage, 13071,
     /*  929486 */     GIR_EraseRootFromParent_Done,
     /*  929487 */   // Label 13997: @929487
     /*  929487 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(929564), // Rule ID 13074 //
     /*  929492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  929512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929531 */     // MIs[0] policy
     /*  929531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929541 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  929544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929562 */     GIR_RootConstrainSelectedInstOperands,
     /*  929563 */     // GIR_Coverage, 13074,
     /*  929563 */     GIR_EraseRootFromParent_Done,
     /*  929564 */   // Label 13998: @929564
     /*  929564 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(929641), // Rule ID 13075 //
     /*  929569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  929589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929608 */     // MIs[0] policy
     /*  929608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  929621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929639 */     GIR_RootConstrainSelectedInstOperands,
     /*  929640 */     // GIR_Coverage, 13075,
     /*  929640 */     GIR_EraseRootFromParent_Done,
     /*  929641 */   // Label 13999: @929641
     /*  929641 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(929718), // Rule ID 13078 //
     /*  929646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  929666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929685 */     // MIs[0] policy
     /*  929685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929695 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  929698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929716 */     GIR_RootConstrainSelectedInstOperands,
     /*  929717 */     // GIR_Coverage, 13078,
     /*  929717 */     GIR_EraseRootFromParent_Done,
     /*  929718 */   // Label 14000: @929718
     /*  929718 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(929795), // Rule ID 13079 //
     /*  929723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  929743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929762 */     // MIs[0] policy
     /*  929762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  929775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929793 */     GIR_RootConstrainSelectedInstOperands,
     /*  929794 */     // GIR_Coverage, 13079,
     /*  929794 */     GIR_EraseRootFromParent_Done,
     /*  929795 */   // Label 14001: @929795
     /*  929795 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(929872), // Rule ID 13082 //
     /*  929800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  929820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929839 */     // MIs[0] policy
     /*  929839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  929852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929870 */     GIR_RootConstrainSelectedInstOperands,
     /*  929871 */     // GIR_Coverage, 13082,
     /*  929871 */     GIR_EraseRootFromParent_Done,
     /*  929872 */   // Label 14002: @929872
     /*  929872 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(929949), // Rule ID 13083 //
     /*  929877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  929894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  929897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929916 */     // MIs[0] policy
     /*  929916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  929929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  929937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929947 */     GIR_RootConstrainSelectedInstOperands,
     /*  929948 */     // GIR_Coverage, 13083,
     /*  929948 */     GIR_EraseRootFromParent_Done,
     /*  929949 */   // Label 14003: @929949
     /*  929949 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(930026), // Rule ID 13086 //
     /*  929954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  929962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  929965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  929968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  929971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  929974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  929989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929993 */     // MIs[0] policy
     /*  929993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930003 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  930006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930024 */     GIR_RootConstrainSelectedInstOperands,
     /*  930025 */     // GIR_Coverage, 13086,
     /*  930025 */     GIR_EraseRootFromParent_Done,
     /*  930026 */   // Label 14004: @930026
     /*  930026 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(930103), // Rule ID 13087 //
     /*  930031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  930048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  930051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930070 */     // MIs[0] policy
     /*  930070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  930083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930101 */     GIR_RootConstrainSelectedInstOperands,
     /*  930102 */     // GIR_Coverage, 13087,
     /*  930102 */     GIR_EraseRootFromParent_Done,
     /*  930103 */   // Label 14005: @930103
     /*  930103 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(930180), // Rule ID 13090 //
     /*  930108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  930125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  930128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930147 */     // MIs[0] policy
     /*  930147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  930160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930178 */     GIR_RootConstrainSelectedInstOperands,
     /*  930179 */     // GIR_Coverage, 13090,
     /*  930179 */     GIR_EraseRootFromParent_Done,
     /*  930180 */   // Label 14006: @930180
     /*  930180 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(930257), // Rule ID 13091 //
     /*  930185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  930202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  930205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930224 */     // MIs[0] policy
     /*  930224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /*  930237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930255 */     GIR_RootConstrainSelectedInstOperands,
     /*  930256 */     // GIR_Coverage, 13091,
     /*  930256 */     GIR_EraseRootFromParent_Done,
     /*  930257 */   // Label 14007: @930257
     /*  930257 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(930334), // Rule ID 13094 //
     /*  930262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  930279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  930282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930301 */     // MIs[0] policy
     /*  930301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  930314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930332 */     GIR_RootConstrainSelectedInstOperands,
     /*  930333 */     // GIR_Coverage, 13094,
     /*  930333 */     GIR_EraseRootFromParent_Done,
     /*  930334 */   // Label 14008: @930334
     /*  930334 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(930411), // Rule ID 13095 //
     /*  930339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  930356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  930359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930378 */     // MIs[0] policy
     /*  930378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /*  930391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930409 */     GIR_RootConstrainSelectedInstOperands,
     /*  930410 */     // GIR_Coverage, 13095,
     /*  930410 */     GIR_EraseRootFromParent_Done,
     /*  930411 */   // Label 14009: @930411
     /*  930411 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(930488), // Rule ID 13098 //
     /*  930416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  930433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  930436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930455 */     // MIs[0] policy
     /*  930455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930465 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  930468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930486 */     GIR_RootConstrainSelectedInstOperands,
     /*  930487 */     // GIR_Coverage, 13098,
     /*  930487 */     GIR_EraseRootFromParent_Done,
     /*  930488 */   // Label 14010: @930488
     /*  930488 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(930565), // Rule ID 13099 //
     /*  930493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /*  930501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  930510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  930513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  930528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930532 */     // MIs[0] policy
     /*  930532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /*  930545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930563 */     GIR_RootConstrainSelectedInstOperands,
     /*  930564 */     // GIR_Coverage, 13099,
     /*  930564 */     GIR_EraseRootFromParent_Done,
     /*  930565 */   // Label 14011: @930565
     /*  930565 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(930642), // Rule ID 13102 //
     /*  930570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  930590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930609 */     // MIs[0] policy
     /*  930609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /*  930622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930640 */     GIR_RootConstrainSelectedInstOperands,
     /*  930641 */     // GIR_Coverage, 13102,
     /*  930641 */     GIR_EraseRootFromParent_Done,
     /*  930642 */   // Label 14012: @930642
     /*  930642 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(930719), // Rule ID 13103 //
     /*  930647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  930667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930686 */     // MIs[0] policy
     /*  930686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /*  930699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930717 */     GIR_RootConstrainSelectedInstOperands,
     /*  930718 */     // GIR_Coverage, 13103,
     /*  930718 */     GIR_EraseRootFromParent_Done,
     /*  930719 */   // Label 14013: @930719
     /*  930719 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(930796), // Rule ID 13106 //
     /*  930724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  930744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930763 */     // MIs[0] policy
     /*  930763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930773 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /*  930776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930794 */     GIR_RootConstrainSelectedInstOperands,
     /*  930795 */     // GIR_Coverage, 13106,
     /*  930795 */     GIR_EraseRootFromParent_Done,
     /*  930796 */   // Label 14014: @930796
     /*  930796 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(930873), // Rule ID 13107 //
     /*  930801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  930821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930840 */     // MIs[0] policy
     /*  930840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /*  930853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930871 */     GIR_RootConstrainSelectedInstOperands,
     /*  930872 */     // GIR_Coverage, 13107,
     /*  930872 */     GIR_EraseRootFromParent_Done,
     /*  930873 */   // Label 14015: @930873
     /*  930873 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(930950), // Rule ID 13110 //
     /*  930878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  930889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  930892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  930895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  930898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930917 */     // MIs[0] policy
     /*  930917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  930930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  930938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930948 */     GIR_RootConstrainSelectedInstOperands,
     /*  930949 */     // GIR_Coverage, 13110,
     /*  930949 */     GIR_EraseRootFromParent_Done,
     /*  930950 */   // Label 14016: @930950
     /*  930950 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(931027), // Rule ID 13111 //
     /*  930955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  930963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  930966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  930969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  930972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  930975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930994 */     // MIs[0] policy
     /*  930994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  931007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931025 */     GIR_RootConstrainSelectedInstOperands,
     /*  931026 */     // GIR_Coverage, 13111,
     /*  931026 */     GIR_EraseRootFromParent_Done,
     /*  931027 */   // Label 14017: @931027
     /*  931027 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(931104), // Rule ID 13114 //
     /*  931032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  931052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931071 */     // MIs[0] policy
     /*  931071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /*  931084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931102 */     GIR_RootConstrainSelectedInstOperands,
     /*  931103 */     // GIR_Coverage, 13114,
     /*  931103 */     GIR_EraseRootFromParent_Done,
     /*  931104 */   // Label 14018: @931104
     /*  931104 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(931181), // Rule ID 13115 //
     /*  931109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  931129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931148 */     // MIs[0] policy
     /*  931148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931158 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /*  931161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931179 */     GIR_RootConstrainSelectedInstOperands,
     /*  931180 */     // GIR_Coverage, 13115,
     /*  931180 */     GIR_EraseRootFromParent_Done,
     /*  931181 */   // Label 14019: @931181
     /*  931181 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(931258), // Rule ID 13118 //
     /*  931186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  931206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931225 */     // MIs[0] policy
     /*  931225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931235 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  931238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931256 */     GIR_RootConstrainSelectedInstOperands,
     /*  931257 */     // GIR_Coverage, 13118,
     /*  931257 */     GIR_EraseRootFromParent_Done,
     /*  931258 */   // Label 14020: @931258
     /*  931258 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(931335), // Rule ID 13119 //
     /*  931263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  931283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931302 */     // MIs[0] policy
     /*  931302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931312 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  931315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931333 */     GIR_RootConstrainSelectedInstOperands,
     /*  931334 */     // GIR_Coverage, 13119,
     /*  931334 */     GIR_EraseRootFromParent_Done,
     /*  931335 */   // Label 14021: @931335
     /*  931335 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(931412), // Rule ID 13122 //
     /*  931340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  931360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931379 */     // MIs[0] policy
     /*  931379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  931392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931410 */     GIR_RootConstrainSelectedInstOperands,
     /*  931411 */     // GIR_Coverage, 13122,
     /*  931411 */     GIR_EraseRootFromParent_Done,
     /*  931412 */   // Label 14022: @931412
     /*  931412 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(931489), // Rule ID 13123 //
     /*  931417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  931437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931456 */     // MIs[0] policy
     /*  931456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /*  931469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931487 */     GIR_RootConstrainSelectedInstOperands,
     /*  931488 */     // GIR_Coverage, 13123,
     /*  931488 */     GIR_EraseRootFromParent_Done,
     /*  931489 */   // Label 14023: @931489
     /*  931489 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(931566), // Rule ID 13126 //
     /*  931494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  931514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931533 */     // MIs[0] policy
     /*  931533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931543 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931564 */     GIR_RootConstrainSelectedInstOperands,
     /*  931565 */     // GIR_Coverage, 13126,
     /*  931565 */     GIR_EraseRootFromParent_Done,
     /*  931566 */   // Label 14024: @931566
     /*  931566 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(931643), // Rule ID 13127 //
     /*  931571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  931591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931610 */     // MIs[0] policy
     /*  931610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931641 */     GIR_RootConstrainSelectedInstOperands,
     /*  931642 */     // GIR_Coverage, 13127,
     /*  931642 */     GIR_EraseRootFromParent_Done,
     /*  931643 */   // Label 14025: @931643
     /*  931643 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(931720), // Rule ID 13130 //
     /*  931648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  931659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  931662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  931665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  931668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931687 */     // MIs[0] policy
     /*  931687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931697 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931718 */     GIR_RootConstrainSelectedInstOperands,
     /*  931719 */     // GIR_Coverage, 13130,
     /*  931719 */     GIR_EraseRootFromParent_Done,
     /*  931720 */   // Label 14026: @931720
     /*  931720 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(931797), // Rule ID 13131 //
     /*  931725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  931736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  931739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  931742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  931745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931764 */     // MIs[0] policy
     /*  931764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931795 */     GIR_RootConstrainSelectedInstOperands,
     /*  931796 */     // GIR_Coverage, 13131,
     /*  931796 */     GIR_EraseRootFromParent_Done,
     /*  931797 */   // Label 14027: @931797
     /*  931797 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(931874), // Rule ID 13134 //
     /*  931802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  931813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  931816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  931819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  931822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931841 */     // MIs[0] policy
     /*  931841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931851 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  931851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931872 */     GIR_RootConstrainSelectedInstOperands,
     /*  931873 */     // GIR_Coverage, 13134,
     /*  931873 */     GIR_EraseRootFromParent_Done,
     /*  931874 */   // Label 14028: @931874
     /*  931874 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(931951), // Rule ID 13135 //
     /*  931879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  931890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  931893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  931896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  931899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  931902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931918 */     // MIs[0] policy
     /*  931918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  931928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  931931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  931935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  931939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  931949 */     GIR_RootConstrainSelectedInstOperands,
     /*  931950 */     // GIR_Coverage, 13135,
     /*  931950 */     GIR_EraseRootFromParent_Done,
     /*  931951 */   // Label 14029: @931951
     /*  931951 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(932028), // Rule ID 13138 //
     /*  931956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  931959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  931964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  931967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  931970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  931973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  931976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  931979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931995 */     // MIs[0] policy
     /*  931995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  931998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932005 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  932008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932026 */     GIR_RootConstrainSelectedInstOperands,
     /*  932027 */     // GIR_Coverage, 13138,
     /*  932027 */     GIR_EraseRootFromParent_Done,
     /*  932028 */   // Label 14030: @932028
     /*  932028 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(932105), // Rule ID 13139 //
     /*  932033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  932053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932072 */     // MIs[0] policy
     /*  932072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /*  932085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932103 */     GIR_RootConstrainSelectedInstOperands,
     /*  932104 */     // GIR_Coverage, 13139,
     /*  932104 */     GIR_EraseRootFromParent_Done,
     /*  932105 */   // Label 14031: @932105
     /*  932105 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(932182), // Rule ID 13142 //
     /*  932110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  932130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932149 */     // MIs[0] policy
     /*  932149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  932162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932180 */     GIR_RootConstrainSelectedInstOperands,
     /*  932181 */     // GIR_Coverage, 13142,
     /*  932181 */     GIR_EraseRootFromParent_Done,
     /*  932182 */   // Label 14032: @932182
     /*  932182 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(932259), // Rule ID 13143 //
     /*  932187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  932207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932226 */     // MIs[0] policy
     /*  932226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  932239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932257 */     GIR_RootConstrainSelectedInstOperands,
     /*  932258 */     // GIR_Coverage, 13143,
     /*  932258 */     GIR_EraseRootFromParent_Done,
     /*  932259 */   // Label 14033: @932259
     /*  932259 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(932336), // Rule ID 13146 //
     /*  932264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  932284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932303 */     // MIs[0] policy
     /*  932303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932313 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  932316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932334 */     GIR_RootConstrainSelectedInstOperands,
     /*  932335 */     // GIR_Coverage, 13146,
     /*  932335 */     GIR_EraseRootFromParent_Done,
     /*  932336 */   // Label 14034: @932336
     /*  932336 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(932413), // Rule ID 13147 //
     /*  932341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  932361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932380 */     // MIs[0] policy
     /*  932380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  932393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932411 */     GIR_RootConstrainSelectedInstOperands,
     /*  932412 */     // GIR_Coverage, 13147,
     /*  932412 */     GIR_EraseRootFromParent_Done,
     /*  932413 */   // Label 14035: @932413
     /*  932413 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(932490), // Rule ID 13150 //
     /*  932418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  932438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932457 */     // MIs[0] policy
     /*  932457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932467 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  932470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932488 */     GIR_RootConstrainSelectedInstOperands,
     /*  932489 */     // GIR_Coverage, 13150,
     /*  932489 */     GIR_EraseRootFromParent_Done,
     /*  932490 */   // Label 14036: @932490
     /*  932490 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(932567), // Rule ID 13151 //
     /*  932495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  932515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932534 */     // MIs[0] policy
     /*  932534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  932547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932565 */     GIR_RootConstrainSelectedInstOperands,
     /*  932566 */     // GIR_Coverage, 13151,
     /*  932566 */     GIR_EraseRootFromParent_Done,
     /*  932567 */   // Label 14037: @932567
     /*  932567 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(932644), // Rule ID 13154 //
     /*  932572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  932583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  932586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  932589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  932592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932611 */     // MIs[0] policy
     /*  932611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  932624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932642 */     GIR_RootConstrainSelectedInstOperands,
     /*  932643 */     // GIR_Coverage, 13154,
     /*  932643 */     GIR_EraseRootFromParent_Done,
     /*  932644 */   // Label 14038: @932644
     /*  932644 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(932721), // Rule ID 13155 //
     /*  932649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  932660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  932663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  932666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  932669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932688 */     // MIs[0] policy
     /*  932688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  932701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932719 */     GIR_RootConstrainSelectedInstOperands,
     /*  932720 */     // GIR_Coverage, 13155,
     /*  932720 */     GIR_EraseRootFromParent_Done,
     /*  932721 */   // Label 14039: @932721
     /*  932721 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(932798), // Rule ID 13158 //
     /*  932726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  932737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  932740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  932743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  932746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932765 */     // MIs[0] policy
     /*  932765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932775 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  932778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932796 */     GIR_RootConstrainSelectedInstOperands,
     /*  932797 */     // GIR_Coverage, 13158,
     /*  932797 */     GIR_EraseRootFromParent_Done,
     /*  932798 */   // Label 14040: @932798
     /*  932798 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(932875), // Rule ID 13159 //
     /*  932803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  932814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  932817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  932820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  932823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932842 */     // MIs[0] policy
     /*  932842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  932852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  932855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932873 */     GIR_RootConstrainSelectedInstOperands,
     /*  932874 */     // GIR_Coverage, 13159,
     /*  932874 */     GIR_EraseRootFromParent_Done,
     /*  932875 */   // Label 14041: @932875
     /*  932875 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(932952), // Rule ID 13162 //
     /*  932880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  932891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  932894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  932897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  932900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  932903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932919 */     // MIs[0] policy
     /*  932919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  932929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  932932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  932936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  932940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  932950 */     GIR_RootConstrainSelectedInstOperands,
     /*  932951 */     // GIR_Coverage, 13162,
     /*  932951 */     GIR_EraseRootFromParent_Done,
     /*  932952 */   // Label 14042: @932952
     /*  932952 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(933029), // Rule ID 13163 //
     /*  932957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  932965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  932968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  932971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  932974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  932977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  932980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932996 */     // MIs[0] policy
     /*  932996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  932999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  933009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933027 */     GIR_RootConstrainSelectedInstOperands,
     /*  933028 */     // GIR_Coverage, 13163,
     /*  933028 */     GIR_EraseRootFromParent_Done,
     /*  933029 */   // Label 14043: @933029
     /*  933029 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(933106), // Rule ID 13166 //
     /*  933034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  933054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933073 */     // MIs[0] policy
     /*  933073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  933086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933104 */     GIR_RootConstrainSelectedInstOperands,
     /*  933105 */     // GIR_Coverage, 13166,
     /*  933105 */     GIR_EraseRootFromParent_Done,
     /*  933106 */   // Label 14044: @933106
     /*  933106 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(933183), // Rule ID 13167 //
     /*  933111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  933131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933150 */     // MIs[0] policy
     /*  933150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  933163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933181 */     GIR_RootConstrainSelectedInstOperands,
     /*  933182 */     // GIR_Coverage, 13167,
     /*  933182 */     GIR_EraseRootFromParent_Done,
     /*  933183 */   // Label 14045: @933183
     /*  933183 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(933260), // Rule ID 13170 //
     /*  933188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  933208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933227 */     // MIs[0] policy
     /*  933227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933237 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  933240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933258 */     GIR_RootConstrainSelectedInstOperands,
     /*  933259 */     // GIR_Coverage, 13170,
     /*  933259 */     GIR_EraseRootFromParent_Done,
     /*  933260 */   // Label 14046: @933260
     /*  933260 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(933337), // Rule ID 13171 //
     /*  933265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  933285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933304 */     // MIs[0] policy
     /*  933304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  933317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933335 */     GIR_RootConstrainSelectedInstOperands,
     /*  933336 */     // GIR_Coverage, 13171,
     /*  933336 */     GIR_EraseRootFromParent_Done,
     /*  933337 */   // Label 14047: @933337
     /*  933337 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(933414), // Rule ID 13174 //
     /*  933342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  933353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  933356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  933359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  933362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933381 */     // MIs[0] policy
     /*  933381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933391 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  933394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933412 */     GIR_RootConstrainSelectedInstOperands,
     /*  933413 */     // GIR_Coverage, 13174,
     /*  933413 */     GIR_EraseRootFromParent_Done,
     /*  933414 */   // Label 14048: @933414
     /*  933414 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(933491), // Rule ID 13175 //
     /*  933419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  933430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  933433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  933436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  933439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933458 */     // MIs[0] policy
     /*  933458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  933471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933489 */     GIR_RootConstrainSelectedInstOperands,
     /*  933490 */     // GIR_Coverage, 13175,
     /*  933490 */     GIR_EraseRootFromParent_Done,
     /*  933491 */   // Label 14049: @933491
     /*  933491 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(933568), // Rule ID 13178 //
     /*  933496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  933507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  933510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  933513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  933516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933535 */     // MIs[0] policy
     /*  933535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933545 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  933548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933566 */     GIR_RootConstrainSelectedInstOperands,
     /*  933567 */     // GIR_Coverage, 13178,
     /*  933567 */     GIR_EraseRootFromParent_Done,
     /*  933568 */   // Label 14050: @933568
     /*  933568 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(933645), // Rule ID 13179 //
     /*  933573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  933584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  933587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  933590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  933593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933612 */     // MIs[0] policy
     /*  933612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /*  933625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933643 */     GIR_RootConstrainSelectedInstOperands,
     /*  933644 */     // GIR_Coverage, 13179,
     /*  933644 */     GIR_EraseRootFromParent_Done,
     /*  933645 */   // Label 14051: @933645
     /*  933645 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(933722), // Rule ID 13182 //
     /*  933650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  933661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  933664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  933667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  933670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933689 */     // MIs[0] policy
     /*  933689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  933702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933720 */     GIR_RootConstrainSelectedInstOperands,
     /*  933721 */     // GIR_Coverage, 13182,
     /*  933721 */     GIR_EraseRootFromParent_Done,
     /*  933722 */   // Label 14052: @933722
     /*  933722 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(933799), // Rule ID 13183 //
     /*  933727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  933738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  933741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  933744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  933747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933766 */     // MIs[0] policy
     /*  933766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /*  933779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933797 */     GIR_RootConstrainSelectedInstOperands,
     /*  933798 */     // GIR_Coverage, 13183,
     /*  933798 */     GIR_EraseRootFromParent_Done,
     /*  933799 */   // Label 14053: @933799
     /*  933799 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(933876), // Rule ID 13186 //
     /*  933804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  933815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  933818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  933821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  933824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933843 */     // MIs[0] policy
     /*  933843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933853 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  933853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  933856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933874 */     GIR_RootConstrainSelectedInstOperands,
     /*  933875 */     // GIR_Coverage, 13186,
     /*  933875 */     GIR_EraseRootFromParent_Done,
     /*  933876 */   // Label 14054: @933876
     /*  933876 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(933953), // Rule ID 13187 //
     /*  933881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  933892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  933895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  933898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  933901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  933904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933920 */     // MIs[0] policy
     /*  933920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  933923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  933930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /*  933933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  933937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  933941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  933951 */     GIR_RootConstrainSelectedInstOperands,
     /*  933952 */     // GIR_Coverage, 13187,
     /*  933952 */     GIR_EraseRootFromParent_Done,
     /*  933953 */   // Label 14055: @933953
     /*  933953 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(934030), // Rule ID 13190 //
     /*  933958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  933966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  933969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  933972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  933975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  933978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  933981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  933993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933997 */     // MIs[0] policy
     /*  933997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934007 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /*  934010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934028 */     GIR_RootConstrainSelectedInstOperands,
     /*  934029 */     // GIR_Coverage, 13190,
     /*  934029 */     GIR_EraseRootFromParent_Done,
     /*  934030 */   // Label 14056: @934030
     /*  934030 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(934107), // Rule ID 13191 //
     /*  934035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  934055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934074 */     // MIs[0] policy
     /*  934074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /*  934087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934105 */     GIR_RootConstrainSelectedInstOperands,
     /*  934106 */     // GIR_Coverage, 13191,
     /*  934106 */     GIR_EraseRootFromParent_Done,
     /*  934107 */   // Label 14057: @934107
     /*  934107 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(934184), // Rule ID 13194 //
     /*  934112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  934132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934151 */     // MIs[0] policy
     /*  934151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934161 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /*  934164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934182 */     GIR_RootConstrainSelectedInstOperands,
     /*  934183 */     // GIR_Coverage, 13194,
     /*  934183 */     GIR_EraseRootFromParent_Done,
     /*  934184 */   // Label 14058: @934184
     /*  934184 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(934261), // Rule ID 13195 //
     /*  934189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  934209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934228 */     // MIs[0] policy
     /*  934228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /*  934241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934259 */     GIR_RootConstrainSelectedInstOperands,
     /*  934260 */     // GIR_Coverage, 13195,
     /*  934260 */     GIR_EraseRootFromParent_Done,
     /*  934261 */   // Label 14059: @934261
     /*  934261 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(934338), // Rule ID 13198 //
     /*  934266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  934277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  934280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  934286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934305 */     // MIs[0] policy
     /*  934305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934315 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934336 */     GIR_RootConstrainSelectedInstOperands,
     /*  934337 */     // GIR_Coverage, 13198,
     /*  934337 */     GIR_EraseRootFromParent_Done,
     /*  934338 */   // Label 14060: @934338
     /*  934338 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(934415), // Rule ID 13199 //
     /*  934343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  934354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  934357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  934363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934382 */     // MIs[0] policy
     /*  934382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934413 */     GIR_RootConstrainSelectedInstOperands,
     /*  934414 */     // GIR_Coverage, 13199,
     /*  934414 */     GIR_EraseRootFromParent_Done,
     /*  934415 */   // Label 14061: @934415
     /*  934415 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(934492), // Rule ID 13202 //
     /*  934420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  934431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  934434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  934440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934459 */     // MIs[0] policy
     /*  934459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /*  934472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934490 */     GIR_RootConstrainSelectedInstOperands,
     /*  934491 */     // GIR_Coverage, 13202,
     /*  934491 */     GIR_EraseRootFromParent_Done,
     /*  934492 */   // Label 14062: @934492
     /*  934492 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(934569), // Rule ID 13203 //
     /*  934497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  934508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  934511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  934517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934536 */     // MIs[0] policy
     /*  934536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /*  934549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934567 */     GIR_RootConstrainSelectedInstOperands,
     /*  934568 */     // GIR_Coverage, 13203,
     /*  934568 */     GIR_EraseRootFromParent_Done,
     /*  934569 */   // Label 14063: @934569
     /*  934569 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(934646), // Rule ID 13206 //
     /*  934574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  934585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  934588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  934594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934613 */     // MIs[0] policy
     /*  934613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934644 */     GIR_RootConstrainSelectedInstOperands,
     /*  934645 */     // GIR_Coverage, 13206,
     /*  934645 */     GIR_EraseRootFromParent_Done,
     /*  934646 */   // Label 14064: @934646
     /*  934646 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(934723), // Rule ID 13207 //
     /*  934651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  934662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  934665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  934671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934690 */     // MIs[0] policy
     /*  934690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934721 */     GIR_RootConstrainSelectedInstOperands,
     /*  934722 */     // GIR_Coverage, 13207,
     /*  934722 */     GIR_EraseRootFromParent_Done,
     /*  934723 */   // Label 14065: @934723
     /*  934723 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(934800), // Rule ID 13210 //
     /*  934728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  934739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  934742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  934748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934767 */     // MIs[0] policy
     /*  934767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934798 */     GIR_RootConstrainSelectedInstOperands,
     /*  934799 */     // GIR_Coverage, 13210,
     /*  934799 */     GIR_EraseRootFromParent_Done,
     /*  934800 */   // Label 14066: @934800
     /*  934800 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(934877), // Rule ID 13211 //
     /*  934805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  934816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  934819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  934825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934844 */     // MIs[0] policy
     /*  934844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  934854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /*  934857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934875 */     GIR_RootConstrainSelectedInstOperands,
     /*  934876 */     // GIR_Coverage, 13211,
     /*  934876 */     GIR_EraseRootFromParent_Done,
     /*  934877 */   // Label 14067: @934877
     /*  934877 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(934954), // Rule ID 13214 //
     /*  934882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  934893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  934896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  934899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  934902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  934905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934921 */     // MIs[0] policy
     /*  934921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  934924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934931 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  934931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  934934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  934938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  934942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  934952 */     GIR_RootConstrainSelectedInstOperands,
     /*  934953 */     // GIR_Coverage, 13214,
     /*  934953 */     GIR_EraseRootFromParent_Done,
     /*  934954 */   // Label 14068: @934954
     /*  934954 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(935031), // Rule ID 13215 //
     /*  934959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  934967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  934970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  934973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  934976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  934979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  934982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  934994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934998 */     // MIs[0] policy
     /*  934998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935029 */     GIR_RootConstrainSelectedInstOperands,
     /*  935030 */     // GIR_Coverage, 13215,
     /*  935030 */     GIR_EraseRootFromParent_Done,
     /*  935031 */   // Label 14069: @935031
     /*  935031 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(935108), // Rule ID 13218 //
     /*  935036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  935047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  935050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  935056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935075 */     // MIs[0] policy
     /*  935075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935085 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935106 */     GIR_RootConstrainSelectedInstOperands,
     /*  935107 */     // GIR_Coverage, 13218,
     /*  935107 */     GIR_EraseRootFromParent_Done,
     /*  935108 */   // Label 14070: @935108
     /*  935108 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(935185), // Rule ID 13219 //
     /*  935113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  935124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  935127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  935133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935152 */     // MIs[0] policy
     /*  935152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935183 */     GIR_RootConstrainSelectedInstOperands,
     /*  935184 */     // GIR_Coverage, 13219,
     /*  935184 */     GIR_EraseRootFromParent_Done,
     /*  935185 */   // Label 14071: @935185
     /*  935185 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(935262), // Rule ID 13222 //
     /*  935190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  935201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  935204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  935210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935229 */     // MIs[0] policy
     /*  935229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935260 */     GIR_RootConstrainSelectedInstOperands,
     /*  935261 */     // GIR_Coverage, 13222,
     /*  935261 */     GIR_EraseRootFromParent_Done,
     /*  935262 */   // Label 14072: @935262
     /*  935262 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(935339), // Rule ID 13223 //
     /*  935267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  935278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  935281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  935287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935306 */     // MIs[0] policy
     /*  935306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935337 */     GIR_RootConstrainSelectedInstOperands,
     /*  935338 */     // GIR_Coverage, 13223,
     /*  935338 */     GIR_EraseRootFromParent_Done,
     /*  935339 */   // Label 14073: @935339
     /*  935339 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(935416), // Rule ID 13226 //
     /*  935344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  935347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  935355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  935358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  935364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935383 */     // MIs[0] policy
     /*  935383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935414 */     GIR_RootConstrainSelectedInstOperands,
     /*  935415 */     // GIR_Coverage, 13226,
     /*  935415 */     GIR_EraseRootFromParent_Done,
     /*  935416 */   // Label 14074: @935416
     /*  935416 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(935493), // Rule ID 13227 //
     /*  935421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  935424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  935432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  935435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  935441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935460 */     // MIs[0] policy
     /*  935460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /*  935473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935491 */     GIR_RootConstrainSelectedInstOperands,
     /*  935492 */     // GIR_Coverage, 13227,
     /*  935492 */     GIR_EraseRootFromParent_Done,
     /*  935493 */   // Label 14075: @935493
     /*  935493 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(935570), // Rule ID 13230 //
     /*  935498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  935518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935537 */     // MIs[0] policy
     /*  935537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935547 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  935550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935568 */     GIR_RootConstrainSelectedInstOperands,
     /*  935569 */     // GIR_Coverage, 13230,
     /*  935569 */     GIR_EraseRootFromParent_Done,
     /*  935570 */   // Label 14076: @935570
     /*  935570 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(935647), // Rule ID 13231 //
     /*  935575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  935595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935614 */     // MIs[0] policy
     /*  935614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  935627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935645 */     GIR_RootConstrainSelectedInstOperands,
     /*  935646 */     // GIR_Coverage, 13231,
     /*  935646 */     GIR_EraseRootFromParent_Done,
     /*  935647 */   // Label 14077: @935647
     /*  935647 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(935724), // Rule ID 13234 //
     /*  935652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  935672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935691 */     // MIs[0] policy
     /*  935691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935701 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  935704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935722 */     GIR_RootConstrainSelectedInstOperands,
     /*  935723 */     // GIR_Coverage, 13234,
     /*  935723 */     GIR_EraseRootFromParent_Done,
     /*  935724 */   // Label 14078: @935724
     /*  935724 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(935801), // Rule ID 13235 //
     /*  935729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  935749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935768 */     // MIs[0] policy
     /*  935768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935778 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  935781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935799 */     GIR_RootConstrainSelectedInstOperands,
     /*  935800 */     // GIR_Coverage, 13235,
     /*  935800 */     GIR_EraseRootFromParent_Done,
     /*  935801 */   // Label 14079: @935801
     /*  935801 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(935878), // Rule ID 13238 //
     /*  935806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  935817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  935820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  935826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935845 */     // MIs[0] policy
     /*  935845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935855 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  935855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  935858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935876 */     GIR_RootConstrainSelectedInstOperands,
     /*  935877 */     // GIR_Coverage, 13238,
     /*  935877 */     GIR_EraseRootFromParent_Done,
     /*  935878 */   // Label 14080: @935878
     /*  935878 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(935955), // Rule ID 13239 //
     /*  935883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  935894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  935897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  935900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  935903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  935906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935922 */     // MIs[0] policy
     /*  935922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  935925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935932 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  935932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  935935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  935939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  935943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  935953 */     GIR_RootConstrainSelectedInstOperands,
     /*  935954 */     // GIR_Coverage, 13239,
     /*  935954 */     GIR_EraseRootFromParent_Done,
     /*  935955 */   // Label 14081: @935955
     /*  935955 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(936032), // Rule ID 13242 //
     /*  935960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  935968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  935971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  935974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  935977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  935980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  935983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  935995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935999 */     // MIs[0] policy
     /*  935999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  936012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936030 */     GIR_RootConstrainSelectedInstOperands,
     /*  936031 */     // GIR_Coverage, 13242,
     /*  936031 */     GIR_EraseRootFromParent_Done,
     /*  936032 */   // Label 14082: @936032
     /*  936032 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(936109), // Rule ID 13243 //
     /*  936037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  936057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936076 */     // MIs[0] policy
     /*  936076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  936089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936107 */     GIR_RootConstrainSelectedInstOperands,
     /*  936108 */     // GIR_Coverage, 13243,
     /*  936108 */     GIR_EraseRootFromParent_Done,
     /*  936109 */   // Label 14083: @936109
     /*  936109 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(936186), // Rule ID 13246 //
     /*  936114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  936134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936153 */     // MIs[0] policy
     /*  936153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  936166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936184 */     GIR_RootConstrainSelectedInstOperands,
     /*  936185 */     // GIR_Coverage, 13246,
     /*  936185 */     GIR_EraseRootFromParent_Done,
     /*  936186 */   // Label 14084: @936186
     /*  936186 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(936263), // Rule ID 13247 //
     /*  936191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  936211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936230 */     // MIs[0] policy
     /*  936230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  936243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936261 */     GIR_RootConstrainSelectedInstOperands,
     /*  936262 */     // GIR_Coverage, 13247,
     /*  936262 */     GIR_EraseRootFromParent_Done,
     /*  936263 */   // Label 14085: @936263
     /*  936263 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(936340), // Rule ID 13250 //
     /*  936268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  936279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  936282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  936288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936307 */     // MIs[0] policy
     /*  936307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936317 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  936320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936338 */     GIR_RootConstrainSelectedInstOperands,
     /*  936339 */     // GIR_Coverage, 13250,
     /*  936339 */     GIR_EraseRootFromParent_Done,
     /*  936340 */   // Label 14086: @936340
     /*  936340 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(936417), // Rule ID 13251 //
     /*  936345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  936356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  936359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  936365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936384 */     // MIs[0] policy
     /*  936384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  936397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936415 */     GIR_RootConstrainSelectedInstOperands,
     /*  936416 */     // GIR_Coverage, 13251,
     /*  936416 */     GIR_EraseRootFromParent_Done,
     /*  936417 */   // Label 14087: @936417
     /*  936417 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(936494), // Rule ID 13254 //
     /*  936422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  936433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  936436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  936442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936461 */     // MIs[0] policy
     /*  936461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  936474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936492 */     GIR_RootConstrainSelectedInstOperands,
     /*  936493 */     // GIR_Coverage, 13254,
     /*  936493 */     GIR_EraseRootFromParent_Done,
     /*  936494 */   // Label 14088: @936494
     /*  936494 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(936571), // Rule ID 13255 //
     /*  936499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  936510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  936513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  936519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936538 */     // MIs[0] policy
     /*  936538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  936551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936569 */     GIR_RootConstrainSelectedInstOperands,
     /*  936570 */     // GIR_Coverage, 13255,
     /*  936570 */     GIR_EraseRootFromParent_Done,
     /*  936571 */   // Label 14089: @936571
     /*  936571 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(936648), // Rule ID 13258 //
     /*  936576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  936587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  936590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  936596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936615 */     // MIs[0] policy
     /*  936615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936625 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  936628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936646 */     GIR_RootConstrainSelectedInstOperands,
     /*  936647 */     // GIR_Coverage, 13258,
     /*  936647 */     GIR_EraseRootFromParent_Done,
     /*  936648 */   // Label 14090: @936648
     /*  936648 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(936725), // Rule ID 13259 //
     /*  936653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  936664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  936667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  936673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936692 */     // MIs[0] policy
     /*  936692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  936705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936723 */     GIR_RootConstrainSelectedInstOperands,
     /*  936724 */     // GIR_Coverage, 13259,
     /*  936724 */     GIR_EraseRootFromParent_Done,
     /*  936725 */   // Label 14091: @936725
     /*  936725 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(936802), // Rule ID 13262 //
     /*  936730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  936741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  936744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  936750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936769 */     // MIs[0] policy
     /*  936769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936779 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  936782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936800 */     GIR_RootConstrainSelectedInstOperands,
     /*  936801 */     // GIR_Coverage, 13262,
     /*  936801 */     GIR_EraseRootFromParent_Done,
     /*  936802 */   // Label 14092: @936802
     /*  936802 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(936879), // Rule ID 13263 //
     /*  936807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  936818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  936821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  936827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936846 */     // MIs[0] policy
     /*  936846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  936856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  936859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936877 */     GIR_RootConstrainSelectedInstOperands,
     /*  936878 */     // GIR_Coverage, 13263,
     /*  936878 */     GIR_EraseRootFromParent_Done,
     /*  936879 */   // Label 14093: @936879
     /*  936879 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(936956), // Rule ID 13266 //
     /*  936884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  936887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  936895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  936898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  936901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  936904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  936907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936923 */     // MIs[0] policy
     /*  936923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  936926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  936933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  936936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  936940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  936944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  936952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  936954 */     GIR_RootConstrainSelectedInstOperands,
     /*  936955 */     // GIR_Coverage, 13266,
     /*  936955 */     GIR_EraseRootFromParent_Done,
     /*  936956 */   // Label 14094: @936956
     /*  936956 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(937033), // Rule ID 13267 //
     /*  936961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  936964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  936969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  936972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  936975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  936978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  936981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  936984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  936996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937000 */     // MIs[0] policy
     /*  937000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /*  937013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  937029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937031 */     GIR_RootConstrainSelectedInstOperands,
     /*  937032 */     // GIR_Coverage, 13267,
     /*  937032 */     GIR_EraseRootFromParent_Done,
     /*  937033 */   // Label 14095: @937033
     /*  937033 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(937110), // Rule ID 13270 //
     /*  937038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  937041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  937046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  937049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  937052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  937055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  937058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  937073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937077 */     // MIs[0] policy
     /*  937077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937087 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  937090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  937106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937108 */     GIR_RootConstrainSelectedInstOperands,
     /*  937109 */     // GIR_Coverage, 13270,
     /*  937109 */     GIR_EraseRootFromParent_Done,
     /*  937110 */   // Label 14096: @937110
     /*  937110 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(937187), // Rule ID 13271 //
     /*  937115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  937118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  937123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  937126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  937129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  937132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  937135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  937150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937154 */     // MIs[0] policy
     /*  937154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /*  937167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  937183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937185 */     GIR_RootConstrainSelectedInstOperands,
     /*  937186 */     // GIR_Coverage, 13271,
     /*  937186 */     GIR_EraseRootFromParent_Done,
     /*  937187 */   // Label 14097: @937187
     /*  937187 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(937264), // Rule ID 13274 //
     /*  937192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  937195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  937200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  937203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  937206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  937209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  937212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  937227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937231 */     // MIs[0] policy
     /*  937231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937241 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  937244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  937260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937262 */     GIR_RootConstrainSelectedInstOperands,
     /*  937263 */     // GIR_Coverage, 13274,
     /*  937263 */     GIR_EraseRootFromParent_Done,
     /*  937264 */   // Label 14098: @937264
     /*  937264 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(937341), // Rule ID 13275 //
     /*  937269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  937272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /*  937277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  937280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  937283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  937286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  937289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  937304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937308 */     // MIs[0] policy
     /*  937308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /*  937321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  937337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937339 */     GIR_RootConstrainSelectedInstOperands,
     /*  937340 */     // GIR_Coverage, 13275,
     /*  937340 */     GIR_EraseRootFromParent_Done,
     /*  937341 */   // Label 14099: @937341
     /*  937341 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(937418), // Rule ID 13278 //
     /*  937346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  937357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  937360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  937363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  937366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937385 */     // MIs[0] policy
     /*  937385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*  937398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937416 */     GIR_RootConstrainSelectedInstOperands,
     /*  937417 */     // GIR_Coverage, 13278,
     /*  937417 */     GIR_EraseRootFromParent_Done,
     /*  937418 */   // Label 14100: @937418
     /*  937418 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(937495), // Rule ID 13279 //
     /*  937423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  937434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  937437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  937440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  937443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937462 */     // MIs[0] policy
     /*  937462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*  937475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937493 */     GIR_RootConstrainSelectedInstOperands,
     /*  937494 */     // GIR_Coverage, 13279,
     /*  937494 */     GIR_EraseRootFromParent_Done,
     /*  937495 */   // Label 14101: @937495
     /*  937495 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(937572), // Rule ID 13282 //
     /*  937500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  937511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  937514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  937517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  937520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937539 */     // MIs[0] policy
     /*  937539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*  937552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937570 */     GIR_RootConstrainSelectedInstOperands,
     /*  937571 */     // GIR_Coverage, 13282,
     /*  937571 */     GIR_EraseRootFromParent_Done,
     /*  937572 */   // Label 14102: @937572
     /*  937572 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(937649), // Rule ID 13283 //
     /*  937577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  937588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  937591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  937594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  937597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937616 */     // MIs[0] policy
     /*  937616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*  937629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937647 */     GIR_RootConstrainSelectedInstOperands,
     /*  937648 */     // GIR_Coverage, 13283,
     /*  937648 */     GIR_EraseRootFromParent_Done,
     /*  937649 */   // Label 14103: @937649
     /*  937649 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(937726), // Rule ID 13286 //
     /*  937654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  937665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  937668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  937671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  937674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937693 */     // MIs[0] policy
     /*  937693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937703 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  937706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937724 */     GIR_RootConstrainSelectedInstOperands,
     /*  937725 */     // GIR_Coverage, 13286,
     /*  937725 */     GIR_EraseRootFromParent_Done,
     /*  937726 */   // Label 14104: @937726
     /*  937726 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(937803), // Rule ID 13287 //
     /*  937731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  937742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  937745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  937748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  937751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937770 */     // MIs[0] policy
     /*  937770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  937783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937801 */     GIR_RootConstrainSelectedInstOperands,
     /*  937802 */     // GIR_Coverage, 13287,
     /*  937802 */     GIR_EraseRootFromParent_Done,
     /*  937803 */   // Label 14105: @937803
     /*  937803 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(937880), // Rule ID 13290 //
     /*  937808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  937825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  937828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937847 */     // MIs[0] policy
     /*  937847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  937857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  937860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937878 */     GIR_RootConstrainSelectedInstOperands,
     /*  937879 */     // GIR_Coverage, 13290,
     /*  937879 */     GIR_EraseRootFromParent_Done,
     /*  937880 */   // Label 14106: @937880
     /*  937880 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(937957), // Rule ID 13291 //
     /*  937885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  937902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  937905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  937908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937924 */     // MIs[0] policy
     /*  937924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  937927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  937934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  937937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  937941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  937945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  937955 */     GIR_RootConstrainSelectedInstOperands,
     /*  937956 */     // GIR_Coverage, 13291,
     /*  937956 */     GIR_EraseRootFromParent_Done,
     /*  937957 */   // Label 14107: @937957
     /*  937957 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(938034), // Rule ID 13294 //
     /*  937962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  937970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  937979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  937982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  937985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938001 */     // MIs[0] policy
     /*  938001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938011 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  938014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938032 */     GIR_RootConstrainSelectedInstOperands,
     /*  938033 */     // GIR_Coverage, 13294,
     /*  938033 */     GIR_EraseRootFromParent_Done,
     /*  938034 */   // Label 14108: @938034
     /*  938034 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(938111), // Rule ID 13295 //
     /*  938039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  938050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  938053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  938056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  938059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938078 */     // MIs[0] policy
     /*  938078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  938091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938109 */     GIR_RootConstrainSelectedInstOperands,
     /*  938110 */     // GIR_Coverage, 13295,
     /*  938110 */     GIR_EraseRootFromParent_Done,
     /*  938111 */   // Label 14109: @938111
     /*  938111 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(938188), // Rule ID 13298 //
     /*  938116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  938127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  938130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  938133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  938136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938155 */     // MIs[0] policy
     /*  938155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938165 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  938168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938186 */     GIR_RootConstrainSelectedInstOperands,
     /*  938187 */     // GIR_Coverage, 13298,
     /*  938187 */     GIR_EraseRootFromParent_Done,
     /*  938188 */   // Label 14110: @938188
     /*  938188 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(938265), // Rule ID 13299 //
     /*  938193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  938204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  938207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  938210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  938213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938232 */     // MIs[0] policy
     /*  938232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  938245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938263 */     GIR_RootConstrainSelectedInstOperands,
     /*  938264 */     // GIR_Coverage, 13299,
     /*  938264 */     GIR_EraseRootFromParent_Done,
     /*  938265 */   // Label 14111: @938265
     /*  938265 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(938342), // Rule ID 13302 //
     /*  938270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  938281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  938284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  938290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938309 */     // MIs[0] policy
     /*  938309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*  938322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938340 */     GIR_RootConstrainSelectedInstOperands,
     /*  938341 */     // GIR_Coverage, 13302,
     /*  938341 */     GIR_EraseRootFromParent_Done,
     /*  938342 */   // Label 14112: @938342
     /*  938342 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(938419), // Rule ID 13303 //
     /*  938347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  938358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  938361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  938367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938386 */     // MIs[0] policy
     /*  938386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*  938399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938417 */     GIR_RootConstrainSelectedInstOperands,
     /*  938418 */     // GIR_Coverage, 13303,
     /*  938418 */     GIR_EraseRootFromParent_Done,
     /*  938419 */   // Label 14113: @938419
     /*  938419 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(938496), // Rule ID 13306 //
     /*  938424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  938435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  938438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  938444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938463 */     // MIs[0] policy
     /*  938463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938473 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  938476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938494 */     GIR_RootConstrainSelectedInstOperands,
     /*  938495 */     // GIR_Coverage, 13306,
     /*  938495 */     GIR_EraseRootFromParent_Done,
     /*  938496 */   // Label 14114: @938496
     /*  938496 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(938573), // Rule ID 13307 //
     /*  938501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  938512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  938515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  938521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938540 */     // MIs[0] policy
     /*  938540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  938553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938571 */     GIR_RootConstrainSelectedInstOperands,
     /*  938572 */     // GIR_Coverage, 13307,
     /*  938572 */     GIR_EraseRootFromParent_Done,
     /*  938573 */   // Label 14115: @938573
     /*  938573 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(938650), // Rule ID 13310 //
     /*  938578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  938589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  938592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  938598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938617 */     // MIs[0] policy
     /*  938617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  938630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938648 */     GIR_RootConstrainSelectedInstOperands,
     /*  938649 */     // GIR_Coverage, 13310,
     /*  938649 */     GIR_EraseRootFromParent_Done,
     /*  938650 */   // Label 14116: @938650
     /*  938650 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(938727), // Rule ID 13311 //
     /*  938655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  938666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  938669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  938675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938694 */     // MIs[0] policy
     /*  938694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  938707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938725 */     GIR_RootConstrainSelectedInstOperands,
     /*  938726 */     // GIR_Coverage, 13311,
     /*  938726 */     GIR_EraseRootFromParent_Done,
     /*  938727 */   // Label 14117: @938727
     /*  938727 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(938804), // Rule ID 13314 //
     /*  938732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  938752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938771 */     // MIs[0] policy
     /*  938771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938781 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  938784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938802 */     GIR_RootConstrainSelectedInstOperands,
     /*  938803 */     // GIR_Coverage, 13314,
     /*  938803 */     GIR_EraseRootFromParent_Done,
     /*  938804 */   // Label 14118: @938804
     /*  938804 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(938881), // Rule ID 13315 //
     /*  938809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  938829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938848 */     // MIs[0] policy
     /*  938848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  938858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  938861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938879 */     GIR_RootConstrainSelectedInstOperands,
     /*  938880 */     // GIR_Coverage, 13315,
     /*  938880 */     GIR_EraseRootFromParent_Done,
     /*  938881 */   // Label 14119: @938881
     /*  938881 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(938958), // Rule ID 13318 //
     /*  938886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  938906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  938909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938925 */     // MIs[0] policy
     /*  938925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  938928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938935 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  938935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  938938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  938942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  938946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  938956 */     GIR_RootConstrainSelectedInstOperands,
     /*  938957 */     // GIR_Coverage, 13318,
     /*  938957 */     GIR_EraseRootFromParent_Done,
     /*  938958 */   // Label 14120: @938958
     /*  938958 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(939035), // Rule ID 13319 //
     /*  938963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  938971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  938983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  938986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939002 */     // MIs[0] policy
     /*  939002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  939015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939033 */     GIR_RootConstrainSelectedInstOperands,
     /*  939034 */     // GIR_Coverage, 13319,
     /*  939034 */     GIR_EraseRootFromParent_Done,
     /*  939035 */   // Label 14121: @939035
     /*  939035 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(939112), // Rule ID 13322 //
     /*  939040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  939051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  939054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  939060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939079 */     // MIs[0] policy
     /*  939079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  939092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939110 */     GIR_RootConstrainSelectedInstOperands,
     /*  939111 */     // GIR_Coverage, 13322,
     /*  939111 */     GIR_EraseRootFromParent_Done,
     /*  939112 */   // Label 14122: @939112
     /*  939112 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(939189), // Rule ID 13323 //
     /*  939117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  939128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  939131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  939137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939156 */     // MIs[0] policy
     /*  939156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*  939169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939187 */     GIR_RootConstrainSelectedInstOperands,
     /*  939188 */     // GIR_Coverage, 13323,
     /*  939188 */     GIR_EraseRootFromParent_Done,
     /*  939189 */   // Label 14123: @939189
     /*  939189 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(939266), // Rule ID 13326 //
     /*  939194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  939205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  939208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  939214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939233 */     // MIs[0] policy
     /*  939233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  939246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939264 */     GIR_RootConstrainSelectedInstOperands,
     /*  939265 */     // GIR_Coverage, 13326,
     /*  939265 */     GIR_EraseRootFromParent_Done,
     /*  939266 */   // Label 14124: @939266
     /*  939266 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(939343), // Rule ID 13327 //
     /*  939271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  939282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  939285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  939291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939310 */     // MIs[0] policy
     /*  939310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*  939323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939341 */     GIR_RootConstrainSelectedInstOperands,
     /*  939342 */     // GIR_Coverage, 13327,
     /*  939342 */     GIR_EraseRootFromParent_Done,
     /*  939343 */   // Label 14125: @939343
     /*  939343 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(939420), // Rule ID 13330 //
     /*  939348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  939359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  939362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  939368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939387 */     // MIs[0] policy
     /*  939387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  939400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939418 */     GIR_RootConstrainSelectedInstOperands,
     /*  939419 */     // GIR_Coverage, 13330,
     /*  939419 */     GIR_EraseRootFromParent_Done,
     /*  939420 */   // Label 14126: @939420
     /*  939420 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(939497), // Rule ID 13331 //
     /*  939425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  939436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  939439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  939445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939464 */     // MIs[0] policy
     /*  939464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*  939477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939495 */     GIR_RootConstrainSelectedInstOperands,
     /*  939496 */     // GIR_Coverage, 13331,
     /*  939496 */     GIR_EraseRootFromParent_Done,
     /*  939497 */   // Label 14127: @939497
     /*  939497 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(939574), // Rule ID 13334 //
     /*  939502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  939513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  939516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  939522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939541 */     // MIs[0] policy
     /*  939541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939551 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  939554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939572 */     GIR_RootConstrainSelectedInstOperands,
     /*  939573 */     // GIR_Coverage, 13334,
     /*  939573 */     GIR_EraseRootFromParent_Done,
     /*  939574 */   // Label 14128: @939574
     /*  939574 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(939651), // Rule ID 13335 //
     /*  939579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  939590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  939593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  939599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939618 */     // MIs[0] policy
     /*  939618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*  939631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939649 */     GIR_RootConstrainSelectedInstOperands,
     /*  939650 */     // GIR_Coverage, 13335,
     /*  939650 */     GIR_EraseRootFromParent_Done,
     /*  939651 */   // Label 14129: @939651
     /*  939651 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(939728), // Rule ID 13338 //
     /*  939656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  939673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  939676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  939691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939695 */     // MIs[0] policy
     /*  939695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939705 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /*  939708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939726 */     GIR_RootConstrainSelectedInstOperands,
     /*  939727 */     // GIR_Coverage, 13338,
     /*  939727 */     GIR_EraseRootFromParent_Done,
     /*  939728 */   // Label 14130: @939728
     /*  939728 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(939805), // Rule ID 13339 //
     /*  939733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  939750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  939753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  939768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939772 */     // MIs[0] policy
     /*  939772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /*  939785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939803 */     GIR_RootConstrainSelectedInstOperands,
     /*  939804 */     // GIR_Coverage, 13339,
     /*  939804 */     GIR_EraseRootFromParent_Done,
     /*  939805 */   // Label 14131: @939805
     /*  939805 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(939882), // Rule ID 13342 //
     /*  939810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  939827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  939830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  939845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939849 */     // MIs[0] policy
     /*  939849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  939859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /*  939862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939880 */     GIR_RootConstrainSelectedInstOperands,
     /*  939881 */     // GIR_Coverage, 13342,
     /*  939881 */     GIR_EraseRootFromParent_Done,
     /*  939882 */   // Label 14132: @939882
     /*  939882 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(939959), // Rule ID 13343 //
     /*  939887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  939904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  939907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  939910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  939922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939926 */     // MIs[0] policy
     /*  939926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  939929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  939936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /*  939939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  939943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  939947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  939957 */     GIR_RootConstrainSelectedInstOperands,
     /*  939958 */     // GIR_Coverage, 13343,
     /*  939958 */     GIR_EraseRootFromParent_Done,
     /*  939959 */   // Label 14133: @939959
     /*  939959 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(940036), // Rule ID 13346 //
     /*  939964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  939972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  939981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  939984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  939987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  939999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940003 */     // MIs[0] policy
     /*  940003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940013 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  940016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940034 */     GIR_RootConstrainSelectedInstOperands,
     /*  940035 */     // GIR_Coverage, 13346,
     /*  940035 */     GIR_EraseRootFromParent_Done,
     /*  940036 */   // Label 14134: @940036
     /*  940036 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(940113), // Rule ID 13347 //
     /*  940041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  940052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  940055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  940061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940080 */     // MIs[0] policy
     /*  940080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  940093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940111 */     GIR_RootConstrainSelectedInstOperands,
     /*  940112 */     // GIR_Coverage, 13347,
     /*  940112 */     GIR_EraseRootFromParent_Done,
     /*  940113 */   // Label 14135: @940113
     /*  940113 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(940190), // Rule ID 13350 //
     /*  940118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  940138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940157 */     // MIs[0] policy
     /*  940157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  940170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940188 */     GIR_RootConstrainSelectedInstOperands,
     /*  940189 */     // GIR_Coverage, 13350,
     /*  940189 */     GIR_EraseRootFromParent_Done,
     /*  940190 */   // Label 14136: @940190
     /*  940190 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(940267), // Rule ID 13351 //
     /*  940195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  940215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940234 */     // MIs[0] policy
     /*  940234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  940247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940265 */     GIR_RootConstrainSelectedInstOperands,
     /*  940266 */     // GIR_Coverage, 13351,
     /*  940266 */     GIR_EraseRootFromParent_Done,
     /*  940267 */   // Label 14137: @940267
     /*  940267 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(940344), // Rule ID 13354 //
     /*  940272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  940292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940311 */     // MIs[0] policy
     /*  940311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  940324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940342 */     GIR_RootConstrainSelectedInstOperands,
     /*  940343 */     // GIR_Coverage, 13354,
     /*  940343 */     GIR_EraseRootFromParent_Done,
     /*  940344 */   // Label 14138: @940344
     /*  940344 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(940421), // Rule ID 13355 //
     /*  940349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  940369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940388 */     // MIs[0] policy
     /*  940388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  940401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940419 */     GIR_RootConstrainSelectedInstOperands,
     /*  940420 */     // GIR_Coverage, 13355,
     /*  940420 */     GIR_EraseRootFromParent_Done,
     /*  940421 */   // Label 14139: @940421
     /*  940421 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(940498), // Rule ID 13358 //
     /*  940426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  940437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  940440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  940446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940465 */     // MIs[0] policy
     /*  940465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940475 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  940478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940496 */     GIR_RootConstrainSelectedInstOperands,
     /*  940497 */     // GIR_Coverage, 13358,
     /*  940497 */     GIR_EraseRootFromParent_Done,
     /*  940498 */   // Label 14140: @940498
     /*  940498 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(940575), // Rule ID 13359 //
     /*  940503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  940514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  940517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  940523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940542 */     // MIs[0] policy
     /*  940542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  940555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  940571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940573 */     GIR_RootConstrainSelectedInstOperands,
     /*  940574 */     // GIR_Coverage, 13359,
     /*  940574 */     GIR_EraseRootFromParent_Done,
     /*  940575 */   // Label 14141: @940575
     /*  940575 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(940652), // Rule ID 13362 //
     /*  940580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940619 */     // MIs[0] policy
     /*  940619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940629 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /*  940632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940650 */     GIR_RootConstrainSelectedInstOperands,
     /*  940651 */     // GIR_Coverage, 13362,
     /*  940651 */     GIR_EraseRootFromParent_Done,
     /*  940652 */   // Label 14142: @940652
     /*  940652 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(940729), // Rule ID 13363 //
     /*  940657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940696 */     // MIs[0] policy
     /*  940696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /*  940709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940727 */     GIR_RootConstrainSelectedInstOperands,
     /*  940728 */     // GIR_Coverage, 13363,
     /*  940728 */     GIR_EraseRootFromParent_Done,
     /*  940729 */   // Label 14143: @940729
     /*  940729 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(940806), // Rule ID 13366 //
     /*  940734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940773 */     // MIs[0] policy
     /*  940773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  940786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940804 */     GIR_RootConstrainSelectedInstOperands,
     /*  940805 */     // GIR_Coverage, 13366,
     /*  940805 */     GIR_EraseRootFromParent_Done,
     /*  940806 */   // Label 14144: @940806
     /*  940806 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(940883), // Rule ID 13367 //
     /*  940811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940850 */     // MIs[0] policy
     /*  940850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  940860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  940863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940881 */     GIR_RootConstrainSelectedInstOperands,
     /*  940882 */     // GIR_Coverage, 13367,
     /*  940882 */     GIR_EraseRootFromParent_Done,
     /*  940883 */   // Label 14145: @940883
     /*  940883 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(940960), // Rule ID 13370 //
     /*  940888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  940905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  940911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  940923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940927 */     // MIs[0] policy
     /*  940927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  940930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  940937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  940940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  940944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  940958 */     GIR_RootConstrainSelectedInstOperands,
     /*  940959 */     // GIR_Coverage, 13370,
     /*  940959 */     GIR_EraseRootFromParent_Done,
     /*  940960 */   // Label 14146: @940960
     /*  940960 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(941037), // Rule ID 13371 //
     /*  940965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  940973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  940982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  940988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941004 */     // MIs[0] policy
     /*  941004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  941017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941035 */     GIR_RootConstrainSelectedInstOperands,
     /*  941036 */     // GIR_Coverage, 13371,
     /*  941036 */     GIR_EraseRootFromParent_Done,
     /*  941037 */   // Label 14147: @941037
     /*  941037 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(941114), // Rule ID 13374 //
     /*  941042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941081 */     // MIs[0] policy
     /*  941081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  941094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941112 */     GIR_RootConstrainSelectedInstOperands,
     /*  941113 */     // GIR_Coverage, 13374,
     /*  941113 */     GIR_EraseRootFromParent_Done,
     /*  941114 */   // Label 14148: @941114
     /*  941114 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(941191), // Rule ID 13375 //
     /*  941119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941158 */     // MIs[0] policy
     /*  941158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  941171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941189 */     GIR_RootConstrainSelectedInstOperands,
     /*  941190 */     // GIR_Coverage, 13375,
     /*  941190 */     GIR_EraseRootFromParent_Done,
     /*  941191 */   // Label 14149: @941191
     /*  941191 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(941268), // Rule ID 13378 //
     /*  941196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941235 */     // MIs[0] policy
     /*  941235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  941248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941266 */     GIR_RootConstrainSelectedInstOperands,
     /*  941267 */     // GIR_Coverage, 13378,
     /*  941267 */     GIR_EraseRootFromParent_Done,
     /*  941268 */   // Label 14150: @941268
     /*  941268 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(941345), // Rule ID 13379 //
     /*  941273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941312 */     // MIs[0] policy
     /*  941312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  941325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941343 */     GIR_RootConstrainSelectedInstOperands,
     /*  941344 */     // GIR_Coverage, 13379,
     /*  941344 */     GIR_EraseRootFromParent_Done,
     /*  941345 */   // Label 14151: @941345
     /*  941345 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(941422), // Rule ID 13382 //
     /*  941350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941389 */     // MIs[0] policy
     /*  941389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  941402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941420 */     GIR_RootConstrainSelectedInstOperands,
     /*  941421 */     // GIR_Coverage, 13382,
     /*  941421 */     GIR_EraseRootFromParent_Done,
     /*  941422 */   // Label 14152: @941422
     /*  941422 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(941499), // Rule ID 13383 //
     /*  941427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941466 */     // MIs[0] policy
     /*  941466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /*  941479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941497 */     GIR_RootConstrainSelectedInstOperands,
     /*  941498 */     // GIR_Coverage, 13383,
     /*  941498 */     GIR_EraseRootFromParent_Done,
     /*  941499 */   // Label 14153: @941499
     /*  941499 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(941576), // Rule ID 13386 //
     /*  941504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941543 */     // MIs[0] policy
     /*  941543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941553 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  941556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941574 */     GIR_RootConstrainSelectedInstOperands,
     /*  941575 */     // GIR_Coverage, 13386,
     /*  941575 */     GIR_EraseRootFromParent_Done,
     /*  941576 */   // Label 14154: @941576
     /*  941576 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(941653), // Rule ID 13387 //
     /*  941581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941620 */     // MIs[0] policy
     /*  941620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /*  941633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941651 */     GIR_RootConstrainSelectedInstOperands,
     /*  941652 */     // GIR_Coverage, 13387,
     /*  941652 */     GIR_EraseRootFromParent_Done,
     /*  941653 */   // Label 14155: @941653
     /*  941653 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(941730), // Rule ID 13390 //
     /*  941658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941697 */     // MIs[0] policy
     /*  941697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941707 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  941710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941728 */     GIR_RootConstrainSelectedInstOperands,
     /*  941729 */     // GIR_Coverage, 13390,
     /*  941729 */     GIR_EraseRootFromParent_Done,
     /*  941730 */   // Label 14156: @941730
     /*  941730 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(941807), // Rule ID 13391 //
     /*  941735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941774 */     // MIs[0] policy
     /*  941774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /*  941787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941805 */     GIR_RootConstrainSelectedInstOperands,
     /*  941806 */     // GIR_Coverage, 13391,
     /*  941806 */     GIR_EraseRootFromParent_Done,
     /*  941807 */   // Label 14157: @941807
     /*  941807 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(941884), // Rule ID 13394 //
     /*  941812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  941829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941851 */     // MIs[0] policy
     /*  941851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  941861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  941864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941882 */     GIR_RootConstrainSelectedInstOperands,
     /*  941883 */     // GIR_Coverage, 13394,
     /*  941883 */     GIR_EraseRootFromParent_Done,
     /*  941884 */   // Label 14158: @941884
     /*  941884 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(941961), // Rule ID 13395 //
     /*  941889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /*  941897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  941906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  941912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  941924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941928 */     // MIs[0] policy
     /*  941928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  941931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  941938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /*  941941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  941945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  941959 */     GIR_RootConstrainSelectedInstOperands,
     /*  941960 */     // GIR_Coverage, 13395,
     /*  941960 */     GIR_EraseRootFromParent_Done,
     /*  941961 */   // Label 14159: @941961
     /*  941961 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(942038), // Rule ID 13398 //
     /*  941966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  941974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  941977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  941980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  941983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  941986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  941989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942005 */     // MIs[0] policy
     /*  942005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*  942018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942036 */     GIR_RootConstrainSelectedInstOperands,
     /*  942037 */     // GIR_Coverage, 13398,
     /*  942037 */     GIR_EraseRootFromParent_Done,
     /*  942038 */   // Label 14160: @942038
     /*  942038 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(942115), // Rule ID 13399 //
     /*  942043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  942054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  942057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  942060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  942063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942082 */     // MIs[0] policy
     /*  942082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*  942095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942113 */     GIR_RootConstrainSelectedInstOperands,
     /*  942114 */     // GIR_Coverage, 13399,
     /*  942114 */     GIR_EraseRootFromParent_Done,
     /*  942115 */   // Label 14161: @942115
     /*  942115 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(942192), // Rule ID 13402 //
     /*  942120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  942137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  942140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942159 */     // MIs[0] policy
     /*  942159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942169 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*  942172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942190 */     GIR_RootConstrainSelectedInstOperands,
     /*  942191 */     // GIR_Coverage, 13402,
     /*  942191 */     GIR_EraseRootFromParent_Done,
     /*  942192 */   // Label 14162: @942192
     /*  942192 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(942269), // Rule ID 13403 //
     /*  942197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  942214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  942217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942236 */     // MIs[0] policy
     /*  942236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*  942249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942267 */     GIR_RootConstrainSelectedInstOperands,
     /*  942268 */     // GIR_Coverage, 13403,
     /*  942268 */     GIR_EraseRootFromParent_Done,
     /*  942269 */   // Label 14163: @942269
     /*  942269 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(942346), // Rule ID 13406 //
     /*  942274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  942285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  942288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  942291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  942294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942313 */     // MIs[0] policy
     /*  942313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942323 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  942326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942344 */     GIR_RootConstrainSelectedInstOperands,
     /*  942345 */     // GIR_Coverage, 13406,
     /*  942345 */     GIR_EraseRootFromParent_Done,
     /*  942346 */   // Label 14164: @942346
     /*  942346 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(942423), // Rule ID 13407 //
     /*  942351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  942362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  942365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  942368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  942371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942390 */     // MIs[0] policy
     /*  942390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  942403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942421 */     GIR_RootConstrainSelectedInstOperands,
     /*  942422 */     // GIR_Coverage, 13407,
     /*  942422 */     GIR_EraseRootFromParent_Done,
     /*  942423 */   // Label 14165: @942423
     /*  942423 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(942500), // Rule ID 13410 //
     /*  942428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  942439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  942442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  942445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  942448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942467 */     // MIs[0] policy
     /*  942467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  942480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942498 */     GIR_RootConstrainSelectedInstOperands,
     /*  942499 */     // GIR_Coverage, 13410,
     /*  942499 */     GIR_EraseRootFromParent_Done,
     /*  942500 */   // Label 14166: @942500
     /*  942500 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(942577), // Rule ID 13411 //
     /*  942505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  942516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  942519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  942522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  942525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942544 */     // MIs[0] policy
     /*  942544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  942557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942575 */     GIR_RootConstrainSelectedInstOperands,
     /*  942576 */     // GIR_Coverage, 13411,
     /*  942576 */     GIR_EraseRootFromParent_Done,
     /*  942577 */   // Label 14167: @942577
     /*  942577 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(942654), // Rule ID 13414 //
     /*  942582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  942593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  942596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  942599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  942602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942621 */     // MIs[0] policy
     /*  942621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  942634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942652 */     GIR_RootConstrainSelectedInstOperands,
     /*  942653 */     // GIR_Coverage, 13414,
     /*  942653 */     GIR_EraseRootFromParent_Done,
     /*  942654 */   // Label 14168: @942654
     /*  942654 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(942731), // Rule ID 13415 //
     /*  942659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  942670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  942673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  942676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  942679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942698 */     // MIs[0] policy
     /*  942698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  942711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942729 */     GIR_RootConstrainSelectedInstOperands,
     /*  942730 */     // GIR_Coverage, 13415,
     /*  942730 */     GIR_EraseRootFromParent_Done,
     /*  942731 */   // Label 14169: @942731
     /*  942731 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(942808), // Rule ID 13418 //
     /*  942736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  942747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  942750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  942753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  942756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942775 */     // MIs[0] policy
     /*  942775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942785 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  942788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942806 */     GIR_RootConstrainSelectedInstOperands,
     /*  942807 */     // GIR_Coverage, 13418,
     /*  942807 */     GIR_EraseRootFromParent_Done,
     /*  942808 */   // Label 14170: @942808
     /*  942808 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(942885), // Rule ID 13419 //
     /*  942813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  942824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  942827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  942830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  942833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942852 */     // MIs[0] policy
     /*  942852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  942862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  942865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942883 */     GIR_RootConstrainSelectedInstOperands,
     /*  942884 */     // GIR_Coverage, 13419,
     /*  942884 */     GIR_EraseRootFromParent_Done,
     /*  942885 */   // Label 14171: @942885
     /*  942885 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(942962), // Rule ID 13422 //
     /*  942890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  942907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  942913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942929 */     // MIs[0] policy
     /*  942929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  942932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  942939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*  942942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  942946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  942960 */     GIR_RootConstrainSelectedInstOperands,
     /*  942961 */     // GIR_Coverage, 13422,
     /*  942961 */     GIR_EraseRootFromParent_Done,
     /*  942962 */   // Label 14172: @942962
     /*  942962 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(943039), // Rule ID 13423 //
     /*  942967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  942975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  942984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  942990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943006 */     // MIs[0] policy
     /*  943006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*  943019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943037 */     GIR_RootConstrainSelectedInstOperands,
     /*  943038 */     // GIR_Coverage, 13423,
     /*  943038 */     GIR_EraseRootFromParent_Done,
     /*  943039 */   // Label 14173: @943039
     /*  943039 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(943116), // Rule ID 13426 //
     /*  943044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  943061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  943064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943083 */     // MIs[0] policy
     /*  943083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  943096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943114 */     GIR_RootConstrainSelectedInstOperands,
     /*  943115 */     // GIR_Coverage, 13426,
     /*  943115 */     GIR_EraseRootFromParent_Done,
     /*  943116 */   // Label 14174: @943116
     /*  943116 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(943193), // Rule ID 13427 //
     /*  943121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  943138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  943141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943160 */     // MIs[0] policy
     /*  943160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  943173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943191 */     GIR_RootConstrainSelectedInstOperands,
     /*  943192 */     // GIR_Coverage, 13427,
     /*  943192 */     GIR_EraseRootFromParent_Done,
     /*  943193 */   // Label 14175: @943193
     /*  943193 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(943270), // Rule ID 13430 //
     /*  943198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  943209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  943212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  943215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  943218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943237 */     // MIs[0] policy
     /*  943237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  943250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943268 */     GIR_RootConstrainSelectedInstOperands,
     /*  943269 */     // GIR_Coverage, 13430,
     /*  943269 */     GIR_EraseRootFromParent_Done,
     /*  943270 */   // Label 14176: @943270
     /*  943270 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(943347), // Rule ID 13431 //
     /*  943275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  943286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  943289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  943292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  943295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943314 */     // MIs[0] policy
     /*  943314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  943327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943345 */     GIR_RootConstrainSelectedInstOperands,
     /*  943346 */     // GIR_Coverage, 13431,
     /*  943346 */     GIR_EraseRootFromParent_Done,
     /*  943347 */   // Label 14177: @943347
     /*  943347 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(943424), // Rule ID 13434 //
     /*  943352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  943369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943391 */     // MIs[0] policy
     /*  943391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943401 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  943404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943422 */     GIR_RootConstrainSelectedInstOperands,
     /*  943423 */     // GIR_Coverage, 13434,
     /*  943423 */     GIR_EraseRootFromParent_Done,
     /*  943424 */   // Label 14178: @943424
     /*  943424 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(943501), // Rule ID 13435 //
     /*  943429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  943446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943468 */     // MIs[0] policy
     /*  943468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  943481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943499 */     GIR_RootConstrainSelectedInstOperands,
     /*  943500 */     // GIR_Coverage, 13435,
     /*  943500 */     GIR_EraseRootFromParent_Done,
     /*  943501 */   // Label 14179: @943501
     /*  943501 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(943578), // Rule ID 13438 //
     /*  943506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  943523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943545 */     // MIs[0] policy
     /*  943545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943555 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  943558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943576 */     GIR_RootConstrainSelectedInstOperands,
     /*  943577 */     // GIR_Coverage, 13438,
     /*  943577 */     GIR_EraseRootFromParent_Done,
     /*  943578 */   // Label 14180: @943578
     /*  943578 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(943655), // Rule ID 13439 //
     /*  943583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  943600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943622 */     // MIs[0] policy
     /*  943622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  943635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943653 */     GIR_RootConstrainSelectedInstOperands,
     /*  943654 */     // GIR_Coverage, 13439,
     /*  943654 */     GIR_EraseRootFromParent_Done,
     /*  943655 */   // Label 14181: @943655
     /*  943655 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(943732), // Rule ID 13442 //
     /*  943660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  943677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943699 */     // MIs[0] policy
     /*  943699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  943712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943730 */     GIR_RootConstrainSelectedInstOperands,
     /*  943731 */     // GIR_Coverage, 13442,
     /*  943731 */     GIR_EraseRootFromParent_Done,
     /*  943732 */   // Label 14182: @943732
     /*  943732 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(943809), // Rule ID 13443 //
     /*  943737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  943754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943776 */     // MIs[0] policy
     /*  943776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*  943789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943807 */     GIR_RootConstrainSelectedInstOperands,
     /*  943808 */     // GIR_Coverage, 13443,
     /*  943808 */     GIR_EraseRootFromParent_Done,
     /*  943809 */   // Label 14183: @943809
     /*  943809 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(943886), // Rule ID 13446 //
     /*  943814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  943831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943853 */     // MIs[0] policy
     /*  943853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943863 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  943863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  943866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943884 */     GIR_RootConstrainSelectedInstOperands,
     /*  943885 */     // GIR_Coverage, 13446,
     /*  943885 */     GIR_EraseRootFromParent_Done,
     /*  943886 */   // Label 14184: @943886
     /*  943886 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(943963), // Rule ID 13447 //
     /*  943891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  943908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943930 */     // MIs[0] policy
     /*  943930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  943933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  943940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*  943943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  943947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  943961 */     GIR_RootConstrainSelectedInstOperands,
     /*  943962 */     // GIR_Coverage, 13447,
     /*  943962 */     GIR_EraseRootFromParent_Done,
     /*  943963 */   // Label 14185: @943963
     /*  943963 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(944040), // Rule ID 13450 //
     /*  943968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  943976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  943985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944007 */     // MIs[0] policy
     /*  944007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944017 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  944020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944038 */     GIR_RootConstrainSelectedInstOperands,
     /*  944039 */     // GIR_Coverage, 13450,
     /*  944039 */     GIR_EraseRootFromParent_Done,
     /*  944040 */   // Label 14186: @944040
     /*  944040 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(944117), // Rule ID 13451 //
     /*  944045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  944056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  944059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  944062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  944065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944084 */     // MIs[0] policy
     /*  944084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*  944097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944115 */     GIR_RootConstrainSelectedInstOperands,
     /*  944116 */     // GIR_Coverage, 13451,
     /*  944116 */     GIR_EraseRootFromParent_Done,
     /*  944117 */   // Label 14187: @944117
     /*  944117 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(944194), // Rule ID 13454 //
     /*  944122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  944125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  944133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  944136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  944142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944161 */     // MIs[0] policy
     /*  944161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944171 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  944174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944192 */     GIR_RootConstrainSelectedInstOperands,
     /*  944193 */     // GIR_Coverage, 13454,
     /*  944193 */     GIR_EraseRootFromParent_Done,
     /*  944194 */   // Label 14188: @944194
     /*  944194 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(944271), // Rule ID 13455 //
     /*  944199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  944210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  944213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  944219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944238 */     // MIs[0] policy
     /*  944238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*  944251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944269 */     GIR_RootConstrainSelectedInstOperands,
     /*  944270 */     // GIR_Coverage, 13455,
     /*  944270 */     GIR_EraseRootFromParent_Done,
     /*  944271 */   // Label 14189: @944271
     /*  944271 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(944348), // Rule ID 13458 //
     /*  944276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  944279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  944290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  944293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944315 */     // MIs[0] policy
     /*  944315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944325 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /*  944328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944346 */     GIR_RootConstrainSelectedInstOperands,
     /*  944347 */     // GIR_Coverage, 13458,
     /*  944347 */     GIR_EraseRootFromParent_Done,
     /*  944348 */   // Label 14190: @944348
     /*  944348 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(944425), // Rule ID 13459 //
     /*  944353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  944356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  944367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  944370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944392 */     // MIs[0] policy
     /*  944392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944402 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /*  944405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944423 */     GIR_RootConstrainSelectedInstOperands,
     /*  944424 */     // GIR_Coverage, 13459,
     /*  944424 */     GIR_EraseRootFromParent_Done,
     /*  944425 */   // Label 14191: @944425
     /*  944425 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(944502), // Rule ID 13462 //
     /*  944430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  944433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  944444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  944447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944469 */     // MIs[0] policy
     /*  944469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944479 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /*  944482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944500 */     GIR_RootConstrainSelectedInstOperands,
     /*  944501 */     // GIR_Coverage, 13462,
     /*  944501 */     GIR_EraseRootFromParent_Done,
     /*  944502 */   // Label 14192: @944502
     /*  944502 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(944579), // Rule ID 13463 //
     /*  944507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  944510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  944521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  944524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944546 */     // MIs[0] policy
     /*  944546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /*  944559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944577 */     GIR_RootConstrainSelectedInstOperands,
     /*  944578 */     // GIR_Coverage, 13463,
     /*  944578 */     GIR_EraseRootFromParent_Done,
     /*  944579 */   // Label 14193: @944579
     /*  944579 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(944656), // Rule ID 13466 //
     /*  944584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  944587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  944595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  944598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  944601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944623 */     // MIs[0] policy
     /*  944623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  944636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944654 */     GIR_RootConstrainSelectedInstOperands,
     /*  944655 */     // GIR_Coverage, 13466,
     /*  944655 */     GIR_EraseRootFromParent_Done,
     /*  944656 */   // Label 14194: @944656
     /*  944656 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(944733), // Rule ID 13467 //
     /*  944661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  944664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  944672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  944675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  944678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944700 */     // MIs[0] policy
     /*  944700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  944713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944731 */     GIR_RootConstrainSelectedInstOperands,
     /*  944732 */     // GIR_Coverage, 13467,
     /*  944732 */     GIR_EraseRootFromParent_Done,
     /*  944733 */   // Label 14195: @944733
     /*  944733 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(944810), // Rule ID 13470 //
     /*  944738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  944741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  944749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  944752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  944755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  944758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944777 */     // MIs[0] policy
     /*  944777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  944790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944808 */     GIR_RootConstrainSelectedInstOperands,
     /*  944809 */     // GIR_Coverage, 13470,
     /*  944809 */     GIR_EraseRootFromParent_Done,
     /*  944810 */   // Label 14196: @944810
     /*  944810 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(944887), // Rule ID 13471 //
     /*  944815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  944818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  944826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  944829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  944832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  944835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944854 */     // MIs[0] policy
     /*  944854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  944864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  944867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944885 */     GIR_RootConstrainSelectedInstOperands,
     /*  944886 */     // GIR_Coverage, 13471,
     /*  944886 */     GIR_EraseRootFromParent_Done,
     /*  944887 */   // Label 14197: @944887
     /*  944887 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(944964), // Rule ID 13474 //
     /*  944892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  944895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  944903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  944906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  944909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  944912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944931 */     // MIs[0] policy
     /*  944931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  944934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944941 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  944941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  944944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  944948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  944962 */     GIR_RootConstrainSelectedInstOperands,
     /*  944963 */     // GIR_Coverage, 13474,
     /*  944963 */     GIR_EraseRootFromParent_Done,
     /*  944964 */   // Label 14198: @944964
     /*  944964 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(945041), // Rule ID 13475 //
     /*  944969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  944972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  944977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  944980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  944983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  944986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  944989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945008 */     // MIs[0] policy
     /*  945008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  945021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945039 */     GIR_RootConstrainSelectedInstOperands,
     /*  945040 */     // GIR_Coverage, 13475,
     /*  945040 */     GIR_EraseRootFromParent_Done,
     /*  945041 */   // Label 14199: @945041
     /*  945041 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(945118), // Rule ID 13478 //
     /*  945046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  945057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  945060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  945066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945085 */     // MIs[0] policy
     /*  945085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945095 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  945098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945116 */     GIR_RootConstrainSelectedInstOperands,
     /*  945117 */     // GIR_Coverage, 13478,
     /*  945117 */     GIR_EraseRootFromParent_Done,
     /*  945118 */   // Label 14200: @945118
     /*  945118 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(945195), // Rule ID 13479 //
     /*  945123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  945134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  945137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  945143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945162 */     // MIs[0] policy
     /*  945162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  945175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945193 */     GIR_RootConstrainSelectedInstOperands,
     /*  945194 */     // GIR_Coverage, 13479,
     /*  945194 */     GIR_EraseRootFromParent_Done,
     /*  945195 */   // Label 14201: @945195
     /*  945195 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(945272), // Rule ID 13482 //
     /*  945200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945239 */     // MIs[0] policy
     /*  945239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /*  945252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945270 */     GIR_RootConstrainSelectedInstOperands,
     /*  945271 */     // GIR_Coverage, 13482,
     /*  945271 */     GIR_EraseRootFromParent_Done,
     /*  945272 */   // Label 14202: @945272
     /*  945272 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(945349), // Rule ID 13483 //
     /*  945277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945316 */     // MIs[0] policy
     /*  945316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /*  945329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945347 */     GIR_RootConstrainSelectedInstOperands,
     /*  945348 */     // GIR_Coverage, 13483,
     /*  945348 */     GIR_EraseRootFromParent_Done,
     /*  945349 */   // Label 14203: @945349
     /*  945349 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(945426), // Rule ID 13486 //
     /*  945354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  945365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  945368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945393 */     // MIs[0] policy
     /*  945393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945403 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  945406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945424 */     GIR_RootConstrainSelectedInstOperands,
     /*  945425 */     // GIR_Coverage, 13486,
     /*  945425 */     GIR_EraseRootFromParent_Done,
     /*  945426 */   // Label 14204: @945426
     /*  945426 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(945503), // Rule ID 13487 //
     /*  945431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  945442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  945445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945470 */     // MIs[0] policy
     /*  945470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  945483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945501 */     GIR_RootConstrainSelectedInstOperands,
     /*  945502 */     // GIR_Coverage, 13487,
     /*  945502 */     GIR_EraseRootFromParent_Done,
     /*  945503 */   // Label 14205: @945503
     /*  945503 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(945580), // Rule ID 13490 //
     /*  945508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  945519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  945522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  945528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945547 */     // MIs[0] policy
     /*  945547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  945560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945578 */     GIR_RootConstrainSelectedInstOperands,
     /*  945579 */     // GIR_Coverage, 13490,
     /*  945579 */     GIR_EraseRootFromParent_Done,
     /*  945580 */   // Label 14206: @945580
     /*  945580 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(945657), // Rule ID 13491 //
     /*  945585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  945596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  945599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  945605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945624 */     // MIs[0] policy
     /*  945624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  945637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945655 */     GIR_RootConstrainSelectedInstOperands,
     /*  945656 */     // GIR_Coverage, 13491,
     /*  945656 */     GIR_EraseRootFromParent_Done,
     /*  945657 */   // Label 14207: @945657
     /*  945657 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(945734), // Rule ID 13494 //
     /*  945662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  945673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  945676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  945682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945701 */     // MIs[0] policy
     /*  945701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  945714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945732 */     GIR_RootConstrainSelectedInstOperands,
     /*  945733 */     // GIR_Coverage, 13494,
     /*  945733 */     GIR_EraseRootFromParent_Done,
     /*  945734 */   // Label 14208: @945734
     /*  945734 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(945811), // Rule ID 13495 //
     /*  945739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  945750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  945753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  945759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945778 */     // MIs[0] policy
     /*  945778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  945791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945809 */     GIR_RootConstrainSelectedInstOperands,
     /*  945810 */     // GIR_Coverage, 13495,
     /*  945810 */     GIR_EraseRootFromParent_Done,
     /*  945811 */   // Label 14209: @945811
     /*  945811 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(945888), // Rule ID 13498 //
     /*  945816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  945819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945855 */     // MIs[0] policy
     /*  945855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  945865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  945868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945886 */     GIR_RootConstrainSelectedInstOperands,
     /*  945887 */     // GIR_Coverage, 13498,
     /*  945887 */     GIR_EraseRootFromParent_Done,
     /*  945888 */   // Label 14210: @945888
     /*  945888 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(945965), // Rule ID 13499 //
     /*  945893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  945896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  945910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945932 */     // MIs[0] policy
     /*  945932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  945935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  945942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  945945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  945949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  945963 */     GIR_RootConstrainSelectedInstOperands,
     /*  945964 */     // GIR_Coverage, 13499,
     /*  945964 */     GIR_EraseRootFromParent_Done,
     /*  945965 */   // Label 14211: @945965
     /*  945965 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(946042), // Rule ID 13502 //
     /*  945970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  945973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  945978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  945981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  945984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  945987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946009 */     // MIs[0] policy
     /*  946009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  946022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946040 */     GIR_RootConstrainSelectedInstOperands,
     /*  946041 */     // GIR_Coverage, 13502,
     /*  946041 */     GIR_EraseRootFromParent_Done,
     /*  946042 */   // Label 14212: @946042
     /*  946042 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(946119), // Rule ID 13503 //
     /*  946047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  946050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  946061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  946064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946086 */     // MIs[0] policy
     /*  946086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /*  946099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946117 */     GIR_RootConstrainSelectedInstOperands,
     /*  946118 */     // GIR_Coverage, 13503,
     /*  946118 */     GIR_EraseRootFromParent_Done,
     /*  946119 */   // Label 14213: @946119
     /*  946119 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(946196), // Rule ID 13506 //
     /*  946124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  946127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  946135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  946138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  946141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946163 */     // MIs[0] policy
     /*  946163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  946176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946194 */     GIR_RootConstrainSelectedInstOperands,
     /*  946195 */     // GIR_Coverage, 13506,
     /*  946195 */     GIR_EraseRootFromParent_Done,
     /*  946196 */   // Label 14214: @946196
     /*  946196 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(946273), // Rule ID 13507 //
     /*  946201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  946204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  946212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  946215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  946218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946240 */     // MIs[0] policy
     /*  946240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /*  946253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946271 */     GIR_RootConstrainSelectedInstOperands,
     /*  946272 */     // GIR_Coverage, 13507,
     /*  946272 */     GIR_EraseRootFromParent_Done,
     /*  946273 */   // Label 14215: @946273
     /*  946273 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(946350), // Rule ID 13510 //
     /*  946278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  946281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  946289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  946292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  946295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  946298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946317 */     // MIs[0] policy
     /*  946317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  946330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946348 */     GIR_RootConstrainSelectedInstOperands,
     /*  946349 */     // GIR_Coverage, 13510,
     /*  946349 */     GIR_EraseRootFromParent_Done,
     /*  946350 */   // Label 14216: @946350
     /*  946350 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(946427), // Rule ID 13511 //
     /*  946355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  946358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  946366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  946369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  946372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  946375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946394 */     // MIs[0] policy
     /*  946394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /*  946407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946425 */     GIR_RootConstrainSelectedInstOperands,
     /*  946426 */     // GIR_Coverage, 13511,
     /*  946426 */     GIR_EraseRootFromParent_Done,
     /*  946427 */   // Label 14217: @946427
     /*  946427 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(946504), // Rule ID 13514 //
     /*  946432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  946435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  946443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  946446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  946449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  946452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946471 */     // MIs[0] policy
     /*  946471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946481 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  946484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946502 */     GIR_RootConstrainSelectedInstOperands,
     /*  946503 */     // GIR_Coverage, 13514,
     /*  946503 */     GIR_EraseRootFromParent_Done,
     /*  946504 */   // Label 14218: @946504
     /*  946504 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(946581), // Rule ID 13515 //
     /*  946509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  946512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /*  946517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  946520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  946523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  946526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  946529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946548 */     // MIs[0] policy
     /*  946548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946558 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /*  946561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946579 */     GIR_RootConstrainSelectedInstOperands,
     /*  946580 */     // GIR_Coverage, 13515,
     /*  946580 */     GIR_EraseRootFromParent_Done,
     /*  946581 */   // Label 14219: @946581
     /*  946581 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(946658), // Rule ID 13518 //
     /*  946586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  946589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  946597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  946600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  946603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  946606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946625 */     // MIs[0] policy
     /*  946625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946635 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*  946638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946656 */     GIR_RootConstrainSelectedInstOperands,
     /*  946657 */     // GIR_Coverage, 13518,
     /*  946657 */     GIR_EraseRootFromParent_Done,
     /*  946658 */   // Label 14220: @946658
     /*  946658 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(946735), // Rule ID 13519 //
     /*  946663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  946666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  946674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  946677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  946680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  946683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946702 */     // MIs[0] policy
     /*  946702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*  946715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946733 */     GIR_RootConstrainSelectedInstOperands,
     /*  946734 */     // GIR_Coverage, 13519,
     /*  946734 */     GIR_EraseRootFromParent_Done,
     /*  946735 */   // Label 14221: @946735
     /*  946735 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(946812), // Rule ID 13522 //
     /*  946740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  946743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  946751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  946754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  946757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  946760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946779 */     // MIs[0] policy
     /*  946779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946789 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*  946792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946810 */     GIR_RootConstrainSelectedInstOperands,
     /*  946811 */     // GIR_Coverage, 13522,
     /*  946811 */     GIR_EraseRootFromParent_Done,
     /*  946812 */   // Label 14222: @946812
     /*  946812 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(946889), // Rule ID 13523 //
     /*  946817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  946820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  946828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  946831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  946834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  946837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946856 */     // MIs[0] policy
     /*  946856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  946866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*  946869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946887 */     GIR_RootConstrainSelectedInstOperands,
     /*  946888 */     // GIR_Coverage, 13523,
     /*  946888 */     GIR_EraseRootFromParent_Done,
     /*  946889 */   // Label 14223: @946889
     /*  946889 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(946966), // Rule ID 13526 //
     /*  946894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  946897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  946908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  946911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  946914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946933 */     // MIs[0] policy
     /*  946933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  946936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  946943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  946946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  946950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  946964 */     GIR_RootConstrainSelectedInstOperands,
     /*  946965 */     // GIR_Coverage, 13526,
     /*  946965 */     GIR_EraseRootFromParent_Done,
     /*  946966 */   // Label 14224: @946966
     /*  946966 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(947043), // Rule ID 13527 //
     /*  946971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  946974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  946979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  946985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  946988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  946991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947010 */     // MIs[0] policy
     /*  947010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  947023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947041 */     GIR_RootConstrainSelectedInstOperands,
     /*  947042 */     // GIR_Coverage, 13527,
     /*  947042 */     GIR_EraseRootFromParent_Done,
     /*  947043 */   // Label 14225: @947043
     /*  947043 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(947120), // Rule ID 13530 //
     /*  947048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  947059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  947062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  947065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  947068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947087 */     // MIs[0] policy
     /*  947087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  947100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947118 */     GIR_RootConstrainSelectedInstOperands,
     /*  947119 */     // GIR_Coverage, 13530,
     /*  947119 */     GIR_EraseRootFromParent_Done,
     /*  947120 */   // Label 14226: @947120
     /*  947120 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(947197), // Rule ID 13531 //
     /*  947125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  947136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  947139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  947142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  947145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947164 */     // MIs[0] policy
     /*  947164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  947177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947195 */     GIR_RootConstrainSelectedInstOperands,
     /*  947196 */     // GIR_Coverage, 13531,
     /*  947196 */     GIR_EraseRootFromParent_Done,
     /*  947197 */   // Label 14227: @947197
     /*  947197 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(947274), // Rule ID 13534 //
     /*  947202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  947213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  947216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947241 */     // MIs[0] policy
     /*  947241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947251 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  947254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947272 */     GIR_RootConstrainSelectedInstOperands,
     /*  947273 */     // GIR_Coverage, 13534,
     /*  947273 */     GIR_EraseRootFromParent_Done,
     /*  947274 */   // Label 14228: @947274
     /*  947274 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(947351), // Rule ID 13535 //
     /*  947279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  947290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  947293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947318 */     // MIs[0] policy
     /*  947318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  947331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947349 */     GIR_RootConstrainSelectedInstOperands,
     /*  947350 */     // GIR_Coverage, 13535,
     /*  947350 */     GIR_EraseRootFromParent_Done,
     /*  947351 */   // Label 14229: @947351
     /*  947351 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(947428), // Rule ID 13538 //
     /*  947356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  947367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  947370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947395 */     // MIs[0] policy
     /*  947395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947405 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  947408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947426 */     GIR_RootConstrainSelectedInstOperands,
     /*  947427 */     // GIR_Coverage, 13538,
     /*  947427 */     GIR_EraseRootFromParent_Done,
     /*  947428 */   // Label 14230: @947428
     /*  947428 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(947505), // Rule ID 13539 //
     /*  947433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  947444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  947447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947472 */     // MIs[0] policy
     /*  947472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  947485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947503 */     GIR_RootConstrainSelectedInstOperands,
     /*  947504 */     // GIR_Coverage, 13539,
     /*  947504 */     GIR_EraseRootFromParent_Done,
     /*  947505 */   // Label 14231: @947505
     /*  947505 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(947582), // Rule ID 13542 //
     /*  947510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  947521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  947524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  947527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  947530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947549 */     // MIs[0] policy
     /*  947549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947559 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*  947562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947580 */     GIR_RootConstrainSelectedInstOperands,
     /*  947581 */     // GIR_Coverage, 13542,
     /*  947581 */     GIR_EraseRootFromParent_Done,
     /*  947582 */   // Label 14232: @947582
     /*  947582 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(947659), // Rule ID 13543 //
     /*  947587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  947598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  947601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  947604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  947607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947626 */     // MIs[0] policy
     /*  947626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*  947639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947657 */     GIR_RootConstrainSelectedInstOperands,
     /*  947658 */     // GIR_Coverage, 13543,
     /*  947658 */     GIR_EraseRootFromParent_Done,
     /*  947659 */   // Label 14233: @947659
     /*  947659 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(947736), // Rule ID 13546 //
     /*  947664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  947678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  947681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  947684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947703 */     // MIs[0] policy
     /*  947703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947713 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  947716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947734 */     GIR_RootConstrainSelectedInstOperands,
     /*  947735 */     // GIR_Coverage, 13546,
     /*  947735 */     GIR_EraseRootFromParent_Done,
     /*  947736 */   // Label 14234: @947736
     /*  947736 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(947813), // Rule ID 13547 //
     /*  947741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  947755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  947758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  947761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947780 */     // MIs[0] policy
     /*  947780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  947793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947811 */     GIR_RootConstrainSelectedInstOperands,
     /*  947812 */     // GIR_Coverage, 13547,
     /*  947812 */     GIR_EraseRootFromParent_Done,
     /*  947813 */   // Label 14235: @947813
     /*  947813 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(947890), // Rule ID 13550 //
     /*  947818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  947829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  947832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947857 */     // MIs[0] policy
     /*  947857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  947867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  947870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947888 */     GIR_RootConstrainSelectedInstOperands,
     /*  947889 */     // GIR_Coverage, 13550,
     /*  947889 */     GIR_EraseRootFromParent_Done,
     /*  947890 */   // Label 14236: @947890
     /*  947890 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(947967), // Rule ID 13551 //
     /*  947895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  947898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  947906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  947909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947934 */     // MIs[0] policy
     /*  947934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  947937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  947944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  947947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  947951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  947965 */     GIR_RootConstrainSelectedInstOperands,
     /*  947966 */     // GIR_Coverage, 13551,
     /*  947966 */     GIR_EraseRootFromParent_Done,
     /*  947967 */   // Label 14237: @947967
     /*  947967 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(948044), // Rule ID 13554 //
     /*  947972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  947975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  947980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  947983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  947986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  947989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  947992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948011 */     // MIs[0] policy
     /*  948011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  948024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948042 */     GIR_RootConstrainSelectedInstOperands,
     /*  948043 */     // GIR_Coverage, 13554,
     /*  948043 */     GIR_EraseRootFromParent_Done,
     /*  948044 */   // Label 14238: @948044
     /*  948044 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(948121), // Rule ID 13555 //
     /*  948049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  948052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  948060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  948063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948088 */     // MIs[0] policy
     /*  948088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  948101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948119 */     GIR_RootConstrainSelectedInstOperands,
     /*  948120 */     // GIR_Coverage, 13555,
     /*  948120 */     GIR_EraseRootFromParent_Done,
     /*  948121 */   // Label 14239: @948121
     /*  948121 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(948198), // Rule ID 13558 //
     /*  948126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  948129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  948137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  948140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  948143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  948146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948165 */     // MIs[0] policy
     /*  948165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948175 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  948178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948196 */     GIR_RootConstrainSelectedInstOperands,
     /*  948197 */     // GIR_Coverage, 13558,
     /*  948197 */     GIR_EraseRootFromParent_Done,
     /*  948198 */   // Label 14240: @948198
     /*  948198 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(948275), // Rule ID 13559 //
     /*  948203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  948206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  948214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  948217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  948220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  948223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948242 */     // MIs[0] policy
     /*  948242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  948255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948273 */     GIR_RootConstrainSelectedInstOperands,
     /*  948274 */     // GIR_Coverage, 13559,
     /*  948274 */     GIR_EraseRootFromParent_Done,
     /*  948275 */   // Label 14241: @948275
     /*  948275 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(948352), // Rule ID 13562 //
     /*  948280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  948283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  948294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  948297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  948300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948319 */     // MIs[0] policy
     /*  948319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948329 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  948332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948350 */     GIR_RootConstrainSelectedInstOperands,
     /*  948351 */     // GIR_Coverage, 13562,
     /*  948351 */     GIR_EraseRootFromParent_Done,
     /*  948352 */   // Label 14242: @948352
     /*  948352 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(948429), // Rule ID 13563 //
     /*  948357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  948360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  948371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  948374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  948377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948396 */     // MIs[0] policy
     /*  948396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*  948409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948427 */     GIR_RootConstrainSelectedInstOperands,
     /*  948428 */     // GIR_Coverage, 13563,
     /*  948428 */     GIR_EraseRootFromParent_Done,
     /*  948429 */   // Label 14243: @948429
     /*  948429 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(948506), // Rule ID 13566 //
     /*  948434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  948437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  948445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  948448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  948451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  948454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948473 */     // MIs[0] policy
     /*  948473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  948486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948504 */     GIR_RootConstrainSelectedInstOperands,
     /*  948505 */     // GIR_Coverage, 13566,
     /*  948505 */     GIR_EraseRootFromParent_Done,
     /*  948506 */   // Label 14244: @948506
     /*  948506 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(948583), // Rule ID 13567 //
     /*  948511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  948514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  948522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  948525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  948528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  948531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948550 */     // MIs[0] policy
     /*  948550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*  948563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948581 */     GIR_RootConstrainSelectedInstOperands,
     /*  948582 */     // GIR_Coverage, 13567,
     /*  948582 */     GIR_EraseRootFromParent_Done,
     /*  948583 */   // Label 14245: @948583
     /*  948583 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(948660), // Rule ID 13570 //
     /*  948588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  948591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  948599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  948602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  948605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  948608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948627 */     // MIs[0] policy
     /*  948627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948637 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  948640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948658 */     GIR_RootConstrainSelectedInstOperands,
     /*  948659 */     // GIR_Coverage, 13570,
     /*  948659 */     GIR_EraseRootFromParent_Done,
     /*  948660 */   // Label 14246: @948660
     /*  948660 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(948737), // Rule ID 13571 //
     /*  948665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  948668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  948676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  948679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  948682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  948685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948704 */     // MIs[0] policy
     /*  948704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*  948717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948735 */     GIR_RootConstrainSelectedInstOperands,
     /*  948736 */     // GIR_Coverage, 13571,
     /*  948736 */     GIR_EraseRootFromParent_Done,
     /*  948737 */   // Label 14247: @948737
     /*  948737 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(948814), // Rule ID 13574 //
     /*  948742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  948745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  948753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  948756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  948759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  948762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948781 */     // MIs[0] policy
     /*  948781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948791 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  948794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948812 */     GIR_RootConstrainSelectedInstOperands,
     /*  948813 */     // GIR_Coverage, 13574,
     /*  948813 */     GIR_EraseRootFromParent_Done,
     /*  948814 */   // Label 14248: @948814
     /*  948814 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(948891), // Rule ID 13575 //
     /*  948819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  948822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  948830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  948833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  948836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  948839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948858 */     // MIs[0] policy
     /*  948858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  948868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*  948871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  948887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948889 */     GIR_RootConstrainSelectedInstOperands,
     /*  948890 */     // GIR_Coverage, 13575,
     /*  948890 */     GIR_EraseRootFromParent_Done,
     /*  948891 */   // Label 14249: @948891
     /*  948891 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(948968), // Rule ID 13578 //
     /*  948896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  948899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  948910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  948913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  948916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948935 */     // MIs[0] policy
     /*  948935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  948938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948945 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  948945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /*  948948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  948952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  948954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  948956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  948966 */     GIR_RootConstrainSelectedInstOperands,
     /*  948967 */     // GIR_Coverage, 13578,
     /*  948967 */     GIR_EraseRootFromParent_Done,
     /*  948968 */   // Label 14250: @948968
     /*  948968 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(949045), // Rule ID 13579 //
     /*  948973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  948976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  948981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  948987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  948990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  948993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949012 */     // MIs[0] policy
     /*  949012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /*  949025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949043 */     GIR_RootConstrainSelectedInstOperands,
     /*  949044 */     // GIR_Coverage, 13579,
     /*  949044 */     GIR_EraseRootFromParent_Done,
     /*  949045 */   // Label 14251: @949045
     /*  949045 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(949122), // Rule ID 13582 //
     /*  949050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  949064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  949070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949089 */     // MIs[0] policy
     /*  949089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949099 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /*  949102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949120 */     GIR_RootConstrainSelectedInstOperands,
     /*  949121 */     // GIR_Coverage, 13582,
     /*  949121 */     GIR_EraseRootFromParent_Done,
     /*  949122 */   // Label 14252: @949122
     /*  949122 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(949199), // Rule ID 13583 //
     /*  949127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  949141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  949147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949166 */     // MIs[0] policy
     /*  949166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /*  949179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949197 */     GIR_RootConstrainSelectedInstOperands,
     /*  949198 */     // GIR_Coverage, 13583,
     /*  949198 */     GIR_EraseRootFromParent_Done,
     /*  949199 */   // Label 14253: @949199
     /*  949199 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(949276), // Rule ID 13586 //
     /*  949204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  949215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  949218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  949224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949243 */     // MIs[0] policy
     /*  949243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949253 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  949256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949274 */     GIR_RootConstrainSelectedInstOperands,
     /*  949275 */     // GIR_Coverage, 13586,
     /*  949275 */     GIR_EraseRootFromParent_Done,
     /*  949276 */   // Label 14254: @949276
     /*  949276 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(949353), // Rule ID 13587 //
     /*  949281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  949292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  949295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  949301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949320 */     // MIs[0] policy
     /*  949320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  949333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949351 */     GIR_RootConstrainSelectedInstOperands,
     /*  949352 */     // GIR_Coverage, 13587,
     /*  949352 */     GIR_EraseRootFromParent_Done,
     /*  949353 */   // Label 14255: @949353
     /*  949353 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(949430), // Rule ID 13590 //
     /*  949358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  949372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949397 */     // MIs[0] policy
     /*  949397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  949410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949428 */     GIR_RootConstrainSelectedInstOperands,
     /*  949429 */     // GIR_Coverage, 13590,
     /*  949429 */     GIR_EraseRootFromParent_Done,
     /*  949430 */   // Label 14256: @949430
     /*  949430 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(949507), // Rule ID 13591 //
     /*  949435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  949449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949474 */     // MIs[0] policy
     /*  949474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  949487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949505 */     GIR_RootConstrainSelectedInstOperands,
     /*  949506 */     // GIR_Coverage, 13591,
     /*  949506 */     GIR_EraseRootFromParent_Done,
     /*  949507 */   // Label 14257: @949507
     /*  949507 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(949584), // Rule ID 13594 //
     /*  949512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  949526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  949532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949551 */     // MIs[0] policy
     /*  949551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949561 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  949564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949582 */     GIR_RootConstrainSelectedInstOperands,
     /*  949583 */     // GIR_Coverage, 13594,
     /*  949583 */     GIR_EraseRootFromParent_Done,
     /*  949584 */   // Label 14258: @949584
     /*  949584 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(949661), // Rule ID 13595 //
     /*  949589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  949603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  949609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949628 */     // MIs[0] policy
     /*  949628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  949641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949659 */     GIR_RootConstrainSelectedInstOperands,
     /*  949660 */     // GIR_Coverage, 13595,
     /*  949660 */     GIR_EraseRootFromParent_Done,
     /*  949661 */   // Label 14259: @949661
     /*  949661 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(949738), // Rule ID 13598 //
     /*  949666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  949680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  949686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949705 */     // MIs[0] policy
     /*  949705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  949718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949736 */     GIR_RootConstrainSelectedInstOperands,
     /*  949737 */     // GIR_Coverage, 13598,
     /*  949737 */     GIR_EraseRootFromParent_Done,
     /*  949738 */   // Label 14260: @949738
     /*  949738 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(949815), // Rule ID 13599 //
     /*  949743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  949757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  949763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949782 */     // MIs[0] policy
     /*  949782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  949795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949813 */     GIR_RootConstrainSelectedInstOperands,
     /*  949814 */     // GIR_Coverage, 13599,
     /*  949814 */     GIR_EraseRootFromParent_Done,
     /*  949815 */   // Label 14261: @949815
     /*  949815 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(949892), // Rule ID 13602 //
     /*  949820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  949834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  949840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949859 */     // MIs[0] policy
     /*  949859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  949869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /*  949872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949890 */     GIR_RootConstrainSelectedInstOperands,
     /*  949891 */     // GIR_Coverage, 13602,
     /*  949891 */     GIR_EraseRootFromParent_Done,
     /*  949892 */   // Label 14262: @949892
     /*  949892 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(949969), // Rule ID 13603 //
     /*  949897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  949900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  949911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  949914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  949917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949936 */     // MIs[0] policy
     /*  949936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  949939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  949946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /*  949949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  949953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  949955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  949957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  949967 */     GIR_RootConstrainSelectedInstOperands,
     /*  949968 */     // GIR_Coverage, 13603,
     /*  949968 */     GIR_EraseRootFromParent_Done,
     /*  949969 */   // Label 14263: @949969
     /*  949969 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(950046), // Rule ID 13606 //
     /*  949974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  949977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  949982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  949985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  949988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  949991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950013 */     // MIs[0] policy
     /*  950013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  950026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950044 */     GIR_RootConstrainSelectedInstOperands,
     /*  950045 */     // GIR_Coverage, 13606,
     /*  950045 */     GIR_EraseRootFromParent_Done,
     /*  950046 */   // Label 14264: @950046
     /*  950046 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(950123), // Rule ID 13607 //
     /*  950051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  950054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  950065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  950071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950090 */     // MIs[0] policy
     /*  950090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  950103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950121 */     GIR_RootConstrainSelectedInstOperands,
     /*  950122 */     // GIR_Coverage, 13607,
     /*  950122 */     GIR_EraseRootFromParent_Done,
     /*  950123 */   // Label 14265: @950123
     /*  950123 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(950200), // Rule ID 13610 //
     /*  950128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  950131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  950142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950167 */     // MIs[0] policy
     /*  950167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  950180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950198 */     GIR_RootConstrainSelectedInstOperands,
     /*  950199 */     // GIR_Coverage, 13610,
     /*  950199 */     GIR_EraseRootFromParent_Done,
     /*  950200 */   // Label 14266: @950200
     /*  950200 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(950277), // Rule ID 13611 //
     /*  950205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  950208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  950219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950244 */     // MIs[0] policy
     /*  950244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  950257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950275 */     GIR_RootConstrainSelectedInstOperands,
     /*  950276 */     // GIR_Coverage, 13611,
     /*  950276 */     GIR_EraseRootFromParent_Done,
     /*  950277 */   // Label 14267: @950277
     /*  950277 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(950354), // Rule ID 13614 //
     /*  950282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  950285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  950296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  950302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950321 */     // MIs[0] policy
     /*  950321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950331 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  950334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950352 */     GIR_RootConstrainSelectedInstOperands,
     /*  950353 */     // GIR_Coverage, 13614,
     /*  950353 */     GIR_EraseRootFromParent_Done,
     /*  950354 */   // Label 14268: @950354
     /*  950354 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(950431), // Rule ID 13615 //
     /*  950359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  950362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  950373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  950379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950398 */     // MIs[0] policy
     /*  950398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  950411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950429 */     GIR_RootConstrainSelectedInstOperands,
     /*  950430 */     // GIR_Coverage, 13615,
     /*  950430 */     GIR_EraseRootFromParent_Done,
     /*  950431 */   // Label 14269: @950431
     /*  950431 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(950508), // Rule ID 13618 //
     /*  950436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  950439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  950447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  950450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950475 */     // MIs[0] policy
     /*  950475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  950488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950506 */     GIR_RootConstrainSelectedInstOperands,
     /*  950507 */     // GIR_Coverage, 13618,
     /*  950507 */     GIR_EraseRootFromParent_Done,
     /*  950508 */   // Label 14270: @950508
     /*  950508 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(950585), // Rule ID 13619 //
     /*  950513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  950516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  950524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  950527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950552 */     // MIs[0] policy
     /*  950552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  950565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950583 */     GIR_RootConstrainSelectedInstOperands,
     /*  950584 */     // GIR_Coverage, 13619,
     /*  950584 */     GIR_EraseRootFromParent_Done,
     /*  950585 */   // Label 14271: @950585
     /*  950585 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(950662), // Rule ID 13622 //
     /*  950590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  950593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  950601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  950604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  950610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950629 */     // MIs[0] policy
     /*  950629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950639 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  950642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950660 */     GIR_RootConstrainSelectedInstOperands,
     /*  950661 */     // GIR_Coverage, 13622,
     /*  950661 */     GIR_EraseRootFromParent_Done,
     /*  950662 */   // Label 14272: @950662
     /*  950662 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(950739), // Rule ID 13623 //
     /*  950667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  950670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  950678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  950681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  950687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950706 */     // MIs[0] policy
     /*  950706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /*  950719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950737 */     GIR_RootConstrainSelectedInstOperands,
     /*  950738 */     // GIR_Coverage, 13623,
     /*  950738 */     GIR_EraseRootFromParent_Done,
     /*  950739 */   // Label 14273: @950739
     /*  950739 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(950816), // Rule ID 13626 //
     /*  950744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  950747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  950755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  950758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950783 */     // MIs[0] policy
     /*  950783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  950796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950814 */     GIR_RootConstrainSelectedInstOperands,
     /*  950815 */     // GIR_Coverage, 13626,
     /*  950815 */     GIR_EraseRootFromParent_Done,
     /*  950816 */   // Label 14274: @950816
     /*  950816 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(950893), // Rule ID 13627 //
     /*  950821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  950824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  950832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  950835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950860 */     // MIs[0] policy
     /*  950860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  950870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /*  950873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950891 */     GIR_RootConstrainSelectedInstOperands,
     /*  950892 */     // GIR_Coverage, 13627,
     /*  950892 */     GIR_EraseRootFromParent_Done,
     /*  950893 */   // Label 14275: @950893
     /*  950893 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(950970), // Rule ID 13630 //
     /*  950898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  950901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  950909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  950912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  950915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950937 */     // MIs[0] policy
     /*  950937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  950940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950947 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  950947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  950950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  950954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  950956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  950958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  950968 */     GIR_RootConstrainSelectedInstOperands,
     /*  950969 */     // GIR_Coverage, 13630,
     /*  950969 */     GIR_EraseRootFromParent_Done,
     /*  950970 */   // Label 14276: @950970
     /*  950970 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(951047), // Rule ID 13631 //
     /*  950975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  950978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  950983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  950986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  950989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  950992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951014 */     // MIs[0] policy
     /*  951014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /*  951027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951045 */     GIR_RootConstrainSelectedInstOperands,
     /*  951046 */     // GIR_Coverage, 13631,
     /*  951046 */     GIR_EraseRootFromParent_Done,
     /*  951047 */   // Label 14277: @951047
     /*  951047 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(951124), // Rule ID 13634 //
     /*  951052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  951055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  951060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  951063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  951066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951091 */     // MIs[0] policy
     /*  951091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951101 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  951104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951122 */     GIR_RootConstrainSelectedInstOperands,
     /*  951123 */     // GIR_Coverage, 13634,
     /*  951123 */     GIR_EraseRootFromParent_Done,
     /*  951124 */   // Label 14278: @951124
     /*  951124 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(951201), // Rule ID 13635 //
     /*  951129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  951132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /*  951137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  951140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  951143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951168 */     // MIs[0] policy
     /*  951168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951178 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /*  951181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951199 */     GIR_RootConstrainSelectedInstOperands,
     /*  951200 */     // GIR_Coverage, 13635,
     /*  951200 */     GIR_EraseRootFromParent_Done,
     /*  951201 */   // Label 14279: @951201
     /*  951201 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(951278), // Rule ID 13638 //
     /*  951206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  951217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  951220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  951226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951245 */     // MIs[0] policy
     /*  951245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951255 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /*  951258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951276 */     GIR_RootConstrainSelectedInstOperands,
     /*  951277 */     // GIR_Coverage, 13638,
     /*  951277 */     GIR_EraseRootFromParent_Done,
     /*  951278 */   // Label 14280: @951278
     /*  951278 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(951355), // Rule ID 13639 //
     /*  951283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  951286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  951294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  951297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  951303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951322 */     // MIs[0] policy
     /*  951322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /*  951335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951353 */     GIR_RootConstrainSelectedInstOperands,
     /*  951354 */     // GIR_Coverage, 13639,
     /*  951354 */     GIR_EraseRootFromParent_Done,
     /*  951355 */   // Label 14281: @951355
     /*  951355 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(951432), // Rule ID 13642 //
     /*  951360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  951371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  951374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  951380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951399 */     // MIs[0] policy
     /*  951399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951409 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /*  951412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951430 */     GIR_RootConstrainSelectedInstOperands,
     /*  951431 */     // GIR_Coverage, 13642,
     /*  951431 */     GIR_EraseRootFromParent_Done,
     /*  951432 */   // Label 14282: @951432
     /*  951432 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(951509), // Rule ID 13643 //
     /*  951437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  951440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  951448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  951451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  951457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951476 */     // MIs[0] policy
     /*  951476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /*  951489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951507 */     GIR_RootConstrainSelectedInstOperands,
     /*  951508 */     // GIR_Coverage, 13643,
     /*  951508 */     GIR_EraseRootFromParent_Done,
     /*  951509 */   // Label 14283: @951509
     /*  951509 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(951586), // Rule ID 13646 //
     /*  951514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  951525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  951528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  951534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951553 */     // MIs[0] policy
     /*  951553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951563 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  951566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951584 */     GIR_RootConstrainSelectedInstOperands,
     /*  951585 */     // GIR_Coverage, 13646,
     /*  951585 */     GIR_EraseRootFromParent_Done,
     /*  951586 */   // Label 14284: @951586
     /*  951586 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(951663), // Rule ID 13647 //
     /*  951591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  951594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  951602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  951605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  951611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951630 */     // MIs[0] policy
     /*  951630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  951643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951661 */     GIR_RootConstrainSelectedInstOperands,
     /*  951662 */     // GIR_Coverage, 13647,
     /*  951662 */     GIR_EraseRootFromParent_Done,
     /*  951663 */   // Label 14285: @951663
     /*  951663 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(951740), // Rule ID 13650 //
     /*  951668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  951679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  951682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  951688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951707 */     // MIs[0] policy
     /*  951707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  951720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951738 */     GIR_RootConstrainSelectedInstOperands,
     /*  951739 */     // GIR_Coverage, 13650,
     /*  951739 */     GIR_EraseRootFromParent_Done,
     /*  951740 */   // Label 14286: @951740
     /*  951740 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(951817), // Rule ID 13651 //
     /*  951745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  951748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  951756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  951759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  951765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951784 */     // MIs[0] policy
     /*  951784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  951797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951815 */     GIR_RootConstrainSelectedInstOperands,
     /*  951816 */     // GIR_Coverage, 13651,
     /*  951816 */     GIR_EraseRootFromParent_Done,
     /*  951817 */   // Label 14287: @951817
     /*  951817 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(951894), // Rule ID 13654 //
     /*  951822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  951833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  951836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951861 */     // MIs[0] policy
     /*  951861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  951871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  951874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951892 */     GIR_RootConstrainSelectedInstOperands,
     /*  951893 */     // GIR_Coverage, 13654,
     /*  951893 */     GIR_EraseRootFromParent_Done,
     /*  951894 */   // Label 14288: @951894
     /*  951894 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(951971), // Rule ID 13655 //
     /*  951899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  951902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  951910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  951913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  951916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951938 */     // MIs[0] policy
     /*  951938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  951941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  951948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  951951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  951955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  951957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  951959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  951969 */     GIR_RootConstrainSelectedInstOperands,
     /*  951970 */     // GIR_Coverage, 13655,
     /*  951970 */     GIR_EraseRootFromParent_Done,
     /*  951971 */   // Label 14289: @951971
     /*  951971 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(952048), // Rule ID 13658 //
     /*  951976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  951979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  951984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  951987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  951990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  951993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  951996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952015 */     // MIs[0] policy
     /*  952015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952025 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  952028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952046 */     GIR_RootConstrainSelectedInstOperands,
     /*  952047 */     // GIR_Coverage, 13658,
     /*  952047 */     GIR_EraseRootFromParent_Done,
     /*  952048 */   // Label 14290: @952048
     /*  952048 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(952125), // Rule ID 13659 //
     /*  952053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  952064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  952067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952092 */     // MIs[0] policy
     /*  952092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  952105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952123 */     GIR_RootConstrainSelectedInstOperands,
     /*  952124 */     // GIR_Coverage, 13659,
     /*  952124 */     GIR_EraseRootFromParent_Done,
     /*  952125 */   // Label 14291: @952125
     /*  952125 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(952202), // Rule ID 13662 //
     /*  952130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  952133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  952141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  952144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  952150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952169 */     // MIs[0] policy
     /*  952169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952179 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /*  952182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952200 */     GIR_RootConstrainSelectedInstOperands,
     /*  952201 */     // GIR_Coverage, 13662,
     /*  952201 */     GIR_EraseRootFromParent_Done,
     /*  952202 */   // Label 14292: @952202
     /*  952202 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(952279), // Rule ID 13663 //
     /*  952207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  952218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  952221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  952227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952246 */     // MIs[0] policy
     /*  952246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /*  952259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952277 */     GIR_RootConstrainSelectedInstOperands,
     /*  952278 */     // GIR_Coverage, 13663,
     /*  952278 */     GIR_EraseRootFromParent_Done,
     /*  952279 */   // Label 14293: @952279
     /*  952279 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(952356), // Rule ID 13666 //
     /*  952284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  952287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  952295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  952298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  952304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952323 */     // MIs[0] policy
     /*  952323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  952336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952354 */     GIR_RootConstrainSelectedInstOperands,
     /*  952355 */     // GIR_Coverage, 13666,
     /*  952355 */     GIR_EraseRootFromParent_Done,
     /*  952356 */   // Label 14294: @952356
     /*  952356 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(952433), // Rule ID 13667 //
     /*  952361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  952372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  952375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  952381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952400 */     // MIs[0] policy
     /*  952400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  952413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952431 */     GIR_RootConstrainSelectedInstOperands,
     /*  952432 */     // GIR_Coverage, 13667,
     /*  952432 */     GIR_EraseRootFromParent_Done,
     /*  952433 */   // Label 14295: @952433
     /*  952433 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(952510), // Rule ID 13670 //
     /*  952438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  952441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  952449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  952452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  952458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952477 */     // MIs[0] policy
     /*  952477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  952490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952508 */     GIR_RootConstrainSelectedInstOperands,
     /*  952509 */     // GIR_Coverage, 13670,
     /*  952509 */     GIR_EraseRootFromParent_Done,
     /*  952510 */   // Label 14296: @952510
     /*  952510 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(952587), // Rule ID 13671 //
     /*  952515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  952526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  952529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  952535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952554 */     // MIs[0] policy
     /*  952554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  952567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952585 */     GIR_RootConstrainSelectedInstOperands,
     /*  952586 */     // GIR_Coverage, 13671,
     /*  952586 */     GIR_EraseRootFromParent_Done,
     /*  952587 */   // Label 14297: @952587
     /*  952587 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(952664), // Rule ID 13674 //
     /*  952592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  952595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  952603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  952606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952631 */     // MIs[0] policy
     /*  952631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  952644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952662 */     GIR_RootConstrainSelectedInstOperands,
     /*  952663 */     // GIR_Coverage, 13674,
     /*  952663 */     GIR_EraseRootFromParent_Done,
     /*  952664 */   // Label 14298: @952664
     /*  952664 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(952741), // Rule ID 13675 //
     /*  952669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  952680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  952683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952708 */     // MIs[0] policy
     /*  952708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  952721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952739 */     GIR_RootConstrainSelectedInstOperands,
     /*  952740 */     // GIR_Coverage, 13675,
     /*  952740 */     GIR_EraseRootFromParent_Done,
     /*  952741 */   // Label 14299: @952741
     /*  952741 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(952818), // Rule ID 13678 //
     /*  952746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  952749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  952760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  952766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952785 */     // MIs[0] policy
     /*  952785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952795 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  952798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952816 */     GIR_RootConstrainSelectedInstOperands,
     /*  952817 */     // GIR_Coverage, 13678,
     /*  952817 */     GIR_EraseRootFromParent_Done,
     /*  952818 */   // Label 14300: @952818
     /*  952818 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(952895), // Rule ID 13679 //
     /*  952823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  952826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  952837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  952843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952862 */     // MIs[0] policy
     /*  952862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  952872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  952875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952893 */     GIR_RootConstrainSelectedInstOperands,
     /*  952894 */     // GIR_Coverage, 13679,
     /*  952894 */     GIR_EraseRootFromParent_Done,
     /*  952895 */   // Label 14301: @952895
     /*  952895 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(952972), // Rule ID 13682 //
     /*  952900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  952903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  952911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  952914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  952917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  952920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952939 */     // MIs[0] policy
     /*  952939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  952942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  952949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  952952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  952956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  952958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  952960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  952970 */     GIR_RootConstrainSelectedInstOperands,
     /*  952971 */     // GIR_Coverage, 13682,
     /*  952971 */     GIR_EraseRootFromParent_Done,
     /*  952972 */   // Label 14302: @952972
     /*  952972 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(953049), // Rule ID 13683 //
     /*  952977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  952980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  952985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  952988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  952991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  952994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  952997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953016 */     // MIs[0] policy
     /*  953016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /*  953029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953047 */     GIR_RootConstrainSelectedInstOperands,
     /*  953048 */     // GIR_Coverage, 13683,
     /*  953048 */     GIR_EraseRootFromParent_Done,
     /*  953049 */   // Label 14303: @953049
     /*  953049 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(953126), // Rule ID 13686 //
     /*  953054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  953057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  953065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  953068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  953071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  953074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953093 */     // MIs[0] policy
     /*  953093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  953106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953124 */     GIR_RootConstrainSelectedInstOperands,
     /*  953125 */     // GIR_Coverage, 13686,
     /*  953125 */     GIR_EraseRootFromParent_Done,
     /*  953126 */   // Label 14304: @953126
     /*  953126 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(953203), // Rule ID 13687 //
     /*  953131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  953134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  953142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  953145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  953148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  953151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953170 */     // MIs[0] policy
     /*  953170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /*  953183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953201 */     GIR_RootConstrainSelectedInstOperands,
     /*  953202 */     // GIR_Coverage, 13687,
     /*  953202 */     GIR_EraseRootFromParent_Done,
     /*  953203 */   // Label 14305: @953203
     /*  953203 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(953280), // Rule ID 13690 //
     /*  953208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  953211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  953222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  953225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  953228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953247 */     // MIs[0] policy
     /*  953247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953257 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  953260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953278 */     GIR_RootConstrainSelectedInstOperands,
     /*  953279 */     // GIR_Coverage, 13690,
     /*  953279 */     GIR_EraseRootFromParent_Done,
     /*  953280 */   // Label 14306: @953280
     /*  953280 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(953357), // Rule ID 13691 //
     /*  953285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  953288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  953299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  953302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  953305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953324 */     // MIs[0] policy
     /*  953324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /*  953337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953355 */     GIR_RootConstrainSelectedInstOperands,
     /*  953356 */     // GIR_Coverage, 13691,
     /*  953356 */     GIR_EraseRootFromParent_Done,
     /*  953357 */   // Label 14307: @953357
     /*  953357 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(953434), // Rule ID 13694 //
     /*  953362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  953365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  953376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  953379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  953382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953401 */     // MIs[0] policy
     /*  953401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  953414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953432 */     GIR_RootConstrainSelectedInstOperands,
     /*  953433 */     // GIR_Coverage, 13694,
     /*  953433 */     GIR_EraseRootFromParent_Done,
     /*  953434 */   // Label 14308: @953434
     /*  953434 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(953511), // Rule ID 13695 //
     /*  953439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  953442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /*  953447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  953453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  953456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  953459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953478 */     // MIs[0] policy
     /*  953478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953488 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /*  953491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  953495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  953497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  953499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953509 */     GIR_RootConstrainSelectedInstOperands,
     /*  953510 */     // GIR_Coverage, 13695,
     /*  953510 */     GIR_EraseRootFromParent_Done,
     /*  953511 */   // Label 14309: @953511
     /*  953511 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(953588), // Rule ID 18908 //
     /*  953516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  953519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  953530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  953536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953555 */     // MIs[0] policy
     /*  953555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /*  953568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953586 */     GIR_RootConstrainSelectedInstOperands,
     /*  953587 */     // GIR_Coverage, 18908,
     /*  953587 */     GIR_EraseRootFromParent_Done,
     /*  953588 */   // Label 14310: @953588
     /*  953588 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(953665), // Rule ID 18909 //
     /*  953593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  953596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  953607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  953613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953632 */     // MIs[0] policy
     /*  953632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953642 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /*  953645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953663 */     GIR_RootConstrainSelectedInstOperands,
     /*  953664 */     // GIR_Coverage, 18909,
     /*  953664 */     GIR_EraseRootFromParent_Done,
     /*  953665 */   // Label 14311: @953665
     /*  953665 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(953742), // Rule ID 18912 //
     /*  953670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  953673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  953681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  953684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  953687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  953690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953709 */     // MIs[0] policy
     /*  953709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953719 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /*  953722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953740 */     GIR_RootConstrainSelectedInstOperands,
     /*  953741 */     // GIR_Coverage, 18912,
     /*  953741 */     GIR_EraseRootFromParent_Done,
     /*  953742 */   // Label 14312: @953742
     /*  953742 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(953819), // Rule ID 18913 //
     /*  953747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  953750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  953758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  953761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  953764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  953767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953786 */     // MIs[0] policy
     /*  953786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /*  953799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  953815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953817 */     GIR_RootConstrainSelectedInstOperands,
     /*  953818 */     // GIR_Coverage, 18913,
     /*  953818 */     GIR_EraseRootFromParent_Done,
     /*  953819 */   // Label 14313: @953819
     /*  953819 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(953896), // Rule ID 18916 //
     /*  953824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  953827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  953838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  953844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953863 */     // MIs[0] policy
     /*  953863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953873 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  953873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /*  953876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953882 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953894 */     GIR_RootConstrainSelectedInstOperands,
     /*  953895 */     // GIR_Coverage, 18916,
     /*  953895 */     GIR_EraseRootFromParent_Done,
     /*  953896 */   // Label 14314: @953896
     /*  953896 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(953973), // Rule ID 18917 //
     /*  953901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  953904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  953915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  953921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  953928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  953940 */     // MIs[0] policy
     /*  953940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  953943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953950 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10953:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  953950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /*  953953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  953957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  953959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  953961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  953971 */     GIR_RootConstrainSelectedInstOperands,
     /*  953972 */     // GIR_Coverage, 18917,
     /*  953972 */     GIR_EraseRootFromParent_Done,
     /*  953973 */   // Label 14315: @953973
     /*  953973 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(954050), // Rule ID 18920 //
     /*  953978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  953981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  953986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  953989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  953992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  953995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  953998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  954005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954017 */     // MIs[0] policy
     /*  954017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954027 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10953:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /*  954030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954048 */     GIR_RootConstrainSelectedInstOperands,
     /*  954049 */     // GIR_Coverage, 18920,
     /*  954049 */     GIR_EraseRootFromParent_Done,
     /*  954050 */   // Label 14316: @954050
     /*  954050 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(954127), // Rule ID 18921 //
     /*  954055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  954058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  954066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  954069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  954072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  954075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  954082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954094 */     // MIs[0] policy
     /*  954094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10953:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /*  954107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954125 */     GIR_RootConstrainSelectedInstOperands,
     /*  954126 */     // GIR_Coverage, 18921,
     /*  954126 */     GIR_EraseRootFromParent_Done,
     /*  954127 */   // Label 14317: @954127
     /*  954127 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(954204), // Rule ID 18924 //
     /*  954132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  954135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  954143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  954146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  954149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  954152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  954159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954171 */     // MIs[0] policy
     /*  954171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954181 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /*  954184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  954200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954202 */     GIR_RootConstrainSelectedInstOperands,
     /*  954203 */     // GIR_Coverage, 18924,
     /*  954203 */     GIR_EraseRootFromParent_Done,
     /*  954204 */   // Label 14318: @954204
     /*  954204 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(954281), // Rule ID 18925 //
     /*  954209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  954212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  954220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  954223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  954226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  954229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  954236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954248 */     // MIs[0] policy
     /*  954248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954258 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10953:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /*  954261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  954277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954279 */     GIR_RootConstrainSelectedInstOperands,
     /*  954280 */     // GIR_Coverage, 18925,
     /*  954280 */     GIR_EraseRootFromParent_Done,
     /*  954281 */   // Label 14319: @954281
     /*  954281 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(954358), // Rule ID 18928 //
     /*  954286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  954289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  954300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  954306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  954313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954325 */     // MIs[0] policy
     /*  954325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954335 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /*  954338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954344 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954356 */     GIR_RootConstrainSelectedInstOperands,
     /*  954357 */     // GIR_Coverage, 18928,
     /*  954357 */     GIR_EraseRootFromParent_Done,
     /*  954358 */   // Label 14320: @954358
     /*  954358 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(954435), // Rule ID 18929 //
     /*  954363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  954366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  954377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  954383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  954390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954402 */     // MIs[0] policy
     /*  954402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /*  954415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954433 */     GIR_RootConstrainSelectedInstOperands,
     /*  954434 */     // GIR_Coverage, 18929,
     /*  954434 */     GIR_EraseRootFromParent_Done,
     /*  954435 */   // Label 14321: @954435
     /*  954435 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(954512), // Rule ID 18932 //
     /*  954440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  954443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  954454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  954460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  954467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954479 */     // MIs[0] policy
     /*  954479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954489 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /*  954492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954510 */     GIR_RootConstrainSelectedInstOperands,
     /*  954511 */     // GIR_Coverage, 18932,
     /*  954511 */     GIR_EraseRootFromParent_Done,
     /*  954512 */   // Label 14322: @954512
     /*  954512 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(954589), // Rule ID 18933 //
     /*  954517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  954520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  954531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  954537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  954544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954556 */     // MIs[0] policy
     /*  954556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954566 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /*  954569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954587 */     GIR_RootConstrainSelectedInstOperands,
     /*  954588 */     // GIR_Coverage, 18933,
     /*  954588 */     GIR_EraseRootFromParent_Done,
     /*  954589 */   // Label 14323: @954589
     /*  954589 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(954666), // Rule ID 18936 //
     /*  954594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  954597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  954608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  954614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  954621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954633 */     // MIs[0] policy
     /*  954633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954643 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /*  954646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954664 */     GIR_RootConstrainSelectedInstOperands,
     /*  954665 */     // GIR_Coverage, 18936,
     /*  954665 */     GIR_EraseRootFromParent_Done,
     /*  954666 */   // Label 14324: @954666
     /*  954666 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(954743), // Rule ID 18937 //
     /*  954671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  954674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  954685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  954691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  954698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954710 */     // MIs[0] policy
     /*  954710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954720 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /*  954723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954741 */     GIR_RootConstrainSelectedInstOperands,
     /*  954742 */     // GIR_Coverage, 18937,
     /*  954742 */     GIR_EraseRootFromParent_Done,
     /*  954743 */   // Label 14325: @954743
     /*  954743 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(954820), // Rule ID 18940 //
     /*  954748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  954751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  954762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  954768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  954775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954787 */     // MIs[0] policy
     /*  954787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954797 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /*  954800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954818 */     GIR_RootConstrainSelectedInstOperands,
     /*  954819 */     // GIR_Coverage, 18940,
     /*  954819 */     GIR_EraseRootFromParent_Done,
     /*  954820 */   // Label 14326: @954820
     /*  954820 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(954897), // Rule ID 18941 //
     /*  954825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  954828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  954839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  954845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  954852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954864 */     // MIs[0] policy
     /*  954864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  954874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /*  954877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954895 */     GIR_RootConstrainSelectedInstOperands,
     /*  954896 */     // GIR_Coverage, 18941,
     /*  954896 */     GIR_EraseRootFromParent_Done,
     /*  954897 */   // Label 14327: @954897
     /*  954897 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(954974), // Rule ID 18944 //
     /*  954902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  954905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  954916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  954922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  954929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  954941 */     // MIs[0] policy
     /*  954941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  954944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954951 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  954951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /*  954954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  954958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  954960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  954962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  954972 */     GIR_RootConstrainSelectedInstOperands,
     /*  954973 */     // GIR_Coverage, 18944,
     /*  954973 */     GIR_EraseRootFromParent_Done,
     /*  954974 */   // Label 14328: @954974
     /*  954974 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(955051), // Rule ID 18945 //
     /*  954979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  954982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  954987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  954993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  954999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  955006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955018 */     // MIs[0] policy
     /*  955018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955028 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /*  955031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955049 */     GIR_RootConstrainSelectedInstOperands,
     /*  955050 */     // GIR_Coverage, 18945,
     /*  955050 */     GIR_EraseRootFromParent_Done,
     /*  955051 */   // Label 14329: @955051
     /*  955051 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(955128), // Rule ID 18948 //
     /*  955056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  955059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  955070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  955076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  955083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955095 */     // MIs[0] policy
     /*  955095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955105 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /*  955108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955126 */     GIR_RootConstrainSelectedInstOperands,
     /*  955127 */     // GIR_Coverage, 18948,
     /*  955127 */     GIR_EraseRootFromParent_Done,
     /*  955128 */   // Label 14330: @955128
     /*  955128 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(955205), // Rule ID 18949 //
     /*  955133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  955136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  955147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  955153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  955160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955172 */     // MIs[0] policy
     /*  955172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /*  955185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955203 */     GIR_RootConstrainSelectedInstOperands,
     /*  955204 */     // GIR_Coverage, 18949,
     /*  955204 */     GIR_EraseRootFromParent_Done,
     /*  955205 */   // Label 14331: @955205
     /*  955205 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(955282), // Rule ID 18952 //
     /*  955210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  955213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  955224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  955230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  955237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955249 */     // MIs[0] policy
     /*  955249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955259 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /*  955262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955280 */     GIR_RootConstrainSelectedInstOperands,
     /*  955281 */     // GIR_Coverage, 18952,
     /*  955281 */     GIR_EraseRootFromParent_Done,
     /*  955282 */   // Label 14332: @955282
     /*  955282 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(955359), // Rule ID 18953 //
     /*  955287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  955290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  955301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  955307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  955314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955326 */     // MIs[0] policy
     /*  955326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10953:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /*  955339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955357 */     GIR_RootConstrainSelectedInstOperands,
     /*  955358 */     // GIR_Coverage, 18953,
     /*  955358 */     GIR_EraseRootFromParent_Done,
     /*  955359 */   // Label 14333: @955359
     /*  955359 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(955436), // Rule ID 18956 //
     /*  955364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  955367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  955375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  955378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  955381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  955384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  955391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955403 */     // MIs[0] policy
     /*  955403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955413 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /*  955416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955434 */     GIR_RootConstrainSelectedInstOperands,
     /*  955435 */     // GIR_Coverage, 18956,
     /*  955435 */     GIR_EraseRootFromParent_Done,
     /*  955436 */   // Label 14334: @955436
     /*  955436 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(955513), // Rule ID 18957 //
     /*  955441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  955444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  955452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  955455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  955458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  955461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  955468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955480 */     // MIs[0] policy
     /*  955480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955490 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10953:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /*  955493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955511 */     GIR_RootConstrainSelectedInstOperands,
     /*  955512 */     // GIR_Coverage, 18957,
     /*  955512 */     GIR_EraseRootFromParent_Done,
     /*  955513 */   // Label 14335: @955513
     /*  955513 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(955590), // Rule ID 18960 //
     /*  955518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  955521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  955529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  955532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  955535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  955538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  955545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955557 */     // MIs[0] policy
     /*  955557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955567 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /*  955570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955588 */     GIR_RootConstrainSelectedInstOperands,
     /*  955589 */     // GIR_Coverage, 18960,
     /*  955589 */     GIR_EraseRootFromParent_Done,
     /*  955590 */   // Label 14336: @955590
     /*  955590 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(955667), // Rule ID 18961 //
     /*  955595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  955598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  955603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  955606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  955609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  955612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  955615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  955622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955634 */     // MIs[0] policy
     /*  955634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10953:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /*  955647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955665 */     GIR_RootConstrainSelectedInstOperands,
     /*  955666 */     // GIR_Coverage, 18961,
     /*  955666 */     GIR_EraseRootFromParent_Done,
     /*  955667 */   // Label 14337: @955667
     /*  955667 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(955744), // Rule ID 20344 //
     /*  955672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  955675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  955680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  955683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  955686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  955689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  955692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  955699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955711 */     // MIs[0] policy
     /*  955711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955721 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /*  955724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955742 */     GIR_RootConstrainSelectedInstOperands,
     /*  955743 */     // GIR_Coverage, 20344,
     /*  955743 */     GIR_EraseRootFromParent_Done,
     /*  955744 */   // Label 14338: @955744
     /*  955744 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(955821), // Rule ID 20345 //
     /*  955749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  955752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  955757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  955760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  955763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  955766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  955769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  955776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955788 */     // MIs[0] policy
     /*  955788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /*  955801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955819 */     GIR_RootConstrainSelectedInstOperands,
     /*  955820 */     // GIR_Coverage, 20345,
     /*  955820 */     GIR_EraseRootFromParent_Done,
     /*  955821 */   // Label 14339: @955821
     /*  955821 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(955898), // Rule ID 20348 //
     /*  955826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  955829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  955834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  955840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  955846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  955853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955865 */     // MIs[0] policy
     /*  955865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955875 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  955875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /*  955878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955896 */     GIR_RootConstrainSelectedInstOperands,
     /*  955897 */     // GIR_Coverage, 20348,
     /*  955897 */     GIR_EraseRootFromParent_Done,
     /*  955898 */   // Label 14340: @955898
     /*  955898 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(955975), // Rule ID 20349 //
     /*  955903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  955906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  955911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  955917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  955923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  955930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  955942 */     // MIs[0] policy
     /*  955942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  955945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  955952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /*  955955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  955959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  955961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  955963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  955973 */     GIR_RootConstrainSelectedInstOperands,
     /*  955974 */     // GIR_Coverage, 20349,
     /*  955974 */     GIR_EraseRootFromParent_Done,
     /*  955975 */   // Label 14341: @955975
     /*  955975 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(956052), // Rule ID 20352 //
     /*  955980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  955983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  955988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  955991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  955994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  955997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  956000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956019 */     // MIs[0] policy
     /*  956019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956029 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956050 */     GIR_RootConstrainSelectedInstOperands,
     /*  956051 */     // GIR_Coverage, 20352,
     /*  956051 */     GIR_EraseRootFromParent_Done,
     /*  956052 */   // Label 14342: @956052
     /*  956052 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(956129), // Rule ID 20353 //
     /*  956057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  956060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  956068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  956071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  956074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  956077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956096 */     // MIs[0] policy
     /*  956096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956127 */     GIR_RootConstrainSelectedInstOperands,
     /*  956128 */     // GIR_Coverage, 20353,
     /*  956128 */     GIR_EraseRootFromParent_Done,
     /*  956129 */   // Label 14343: @956129
     /*  956129 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(956206), // Rule ID 20356 //
     /*  956134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  956137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  956148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  956154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956173 */     // MIs[0] policy
     /*  956173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  956202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956204 */     GIR_RootConstrainSelectedInstOperands,
     /*  956205 */     // GIR_Coverage, 20356,
     /*  956205 */     GIR_EraseRootFromParent_Done,
     /*  956206 */   // Label 14344: @956206
     /*  956206 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(956283), // Rule ID 20357 //
     /*  956211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  956214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  956225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  956231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956250 */     // MIs[0] policy
     /*  956250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  956279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956281 */     GIR_RootConstrainSelectedInstOperands,
     /*  956282 */     // GIR_Coverage, 20357,
     /*  956282 */     GIR_EraseRootFromParent_Done,
     /*  956283 */   // Label 14345: @956283
     /*  956283 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(956360), // Rule ID 20360 //
     /*  956288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  956291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  956299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  956302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  956305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  956308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956327 */     // MIs[0] policy
     /*  956327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956337 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956358 */     GIR_RootConstrainSelectedInstOperands,
     /*  956359 */     // GIR_Coverage, 20360,
     /*  956359 */     GIR_EraseRootFromParent_Done,
     /*  956360 */   // Label 14346: @956360
     /*  956360 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(956437), // Rule ID 20361 //
     /*  956365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  956368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  956376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  956379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  956382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  956385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  956392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956404 */     // MIs[0] policy
     /*  956404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /*  956417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956435 */     GIR_RootConstrainSelectedInstOperands,
     /*  956436 */     // GIR_Coverage, 20361,
     /*  956436 */     GIR_EraseRootFromParent_Done,
     /*  956437 */   // Label 14347: @956437
     /*  956437 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(956514), // Rule ID 20364 //
     /*  956442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  956445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  956453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  956456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  956459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  956462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  956469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956481 */     // MIs[0] policy
     /*  956481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  956494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956512 */     GIR_RootConstrainSelectedInstOperands,
     /*  956513 */     // GIR_Coverage, 20364,
     /*  956513 */     GIR_EraseRootFromParent_Done,
     /*  956514 */   // Label 14348: @956514
     /*  956514 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(956591), // Rule ID 20365 //
     /*  956519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  956522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  956530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  956533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  956536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  956539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  956546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956558 */     // MIs[0] policy
     /*  956558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  956571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956589 */     GIR_RootConstrainSelectedInstOperands,
     /*  956590 */     // GIR_Coverage, 20365,
     /*  956590 */     GIR_EraseRootFromParent_Done,
     /*  956591 */   // Label 14349: @956591
     /*  956591 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(956668), // Rule ID 20368 //
     /*  956596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  956599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  956607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  956610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  956613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  956616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  956623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956635 */     // MIs[0] policy
     /*  956635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956645 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  956648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956666 */     GIR_RootConstrainSelectedInstOperands,
     /*  956667 */     // GIR_Coverage, 20368,
     /*  956667 */     GIR_EraseRootFromParent_Done,
     /*  956668 */   // Label 14350: @956668
     /*  956668 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(956745), // Rule ID 20369 //
     /*  956673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  956676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  956684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  956687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  956690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  956693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  956700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956712 */     // MIs[0] policy
     /*  956712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  956725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956743 */     GIR_RootConstrainSelectedInstOperands,
     /*  956744 */     // GIR_Coverage, 20369,
     /*  956744 */     GIR_EraseRootFromParent_Done,
     /*  956745 */   // Label 14351: @956745
     /*  956745 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(956822), // Rule ID 20372 //
     /*  956750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  956753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  956761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  956764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  956767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  956770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  956777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956789 */     // MIs[0] policy
     /*  956789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  956802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956820 */     GIR_RootConstrainSelectedInstOperands,
     /*  956821 */     // GIR_Coverage, 20372,
     /*  956821 */     GIR_EraseRootFromParent_Done,
     /*  956822 */   // Label 14352: @956822
     /*  956822 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(956899), // Rule ID 20373 //
     /*  956827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  956830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  956838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  956841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  956844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  956847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  956854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956866 */     // MIs[0] policy
     /*  956866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  956876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  956879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956897 */     GIR_RootConstrainSelectedInstOperands,
     /*  956898 */     // GIR_Coverage, 20373,
     /*  956898 */     GIR_EraseRootFromParent_Done,
     /*  956899 */   // Label 14353: @956899
     /*  956899 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(956976), // Rule ID 20376 //
     /*  956904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  956907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  956918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  956924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  956931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  956943 */     // MIs[0] policy
     /*  956943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  956946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  956953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  956956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  956960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  956962 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  956964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  956972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  956974 */     GIR_RootConstrainSelectedInstOperands,
     /*  956975 */     // GIR_Coverage, 20376,
     /*  956975 */     GIR_EraseRootFromParent_Done,
     /*  956976 */   // Label 14354: @956976
     /*  956976 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(957053), // Rule ID 20377 //
     /*  956981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  956984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  956989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  956995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  957001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  957008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957020 */     // MIs[0] policy
     /*  957020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  957033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957051 */     GIR_RootConstrainSelectedInstOperands,
     /*  957052 */     // GIR_Coverage, 20377,
     /*  957052 */     GIR_EraseRootFromParent_Done,
     /*  957053 */   // Label 14355: @957053
     /*  957053 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(957130), // Rule ID 20380 //
     /*  957058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  957061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  957072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  957078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  957085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957097 */     // MIs[0] policy
     /*  957097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  957110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957128 */     GIR_RootConstrainSelectedInstOperands,
     /*  957129 */     // GIR_Coverage, 20380,
     /*  957129 */     GIR_EraseRootFromParent_Done,
     /*  957130 */   // Label 14356: @957130
     /*  957130 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(957207), // Rule ID 20381 //
     /*  957135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  957138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  957149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  957155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  957162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957174 */     // MIs[0] policy
     /*  957174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  957187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957205 */     GIR_RootConstrainSelectedInstOperands,
     /*  957206 */     // GIR_Coverage, 20381,
     /*  957206 */     GIR_EraseRootFromParent_Done,
     /*  957207 */   // Label 14357: @957207
     /*  957207 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(957284), // Rule ID 20384 //
     /*  957212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  957215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  957226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  957232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  957239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957251 */     // MIs[0] policy
     /*  957251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957261 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  957264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957270 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957282 */     GIR_RootConstrainSelectedInstOperands,
     /*  957283 */     // GIR_Coverage, 20384,
     /*  957283 */     GIR_EraseRootFromParent_Done,
     /*  957284 */   // Label 14358: @957284
     /*  957284 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(957361), // Rule ID 20385 //
     /*  957289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  957292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  957303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  957309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  957316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957328 */     // MIs[0] policy
     /*  957328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  957341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957359 */     GIR_RootConstrainSelectedInstOperands,
     /*  957360 */     // GIR_Coverage, 20385,
     /*  957360 */     GIR_EraseRootFromParent_Done,
     /*  957361 */   // Label 14359: @957361
     /*  957361 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(957438), // Rule ID 20388 //
     /*  957366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  957369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  957380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  957386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  957393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957405 */     // MIs[0] policy
     /*  957405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  957418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957436 */     GIR_RootConstrainSelectedInstOperands,
     /*  957437 */     // GIR_Coverage, 20388,
     /*  957437 */     GIR_EraseRootFromParent_Done,
     /*  957438 */   // Label 14360: @957438
     /*  957438 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(957515), // Rule ID 20389 //
     /*  957443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  957446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  957457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  957463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  957470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957482 */     // MIs[0] policy
     /*  957482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /*  957495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957513 */     GIR_RootConstrainSelectedInstOperands,
     /*  957514 */     // GIR_Coverage, 20389,
     /*  957514 */     GIR_EraseRootFromParent_Done,
     /*  957515 */   // Label 14361: @957515
     /*  957515 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(957592), // Rule ID 20392 //
     /*  957520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  957523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  957531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  957534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  957537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  957540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  957547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957559 */     // MIs[0] policy
     /*  957559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957569 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  957572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957578 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957590 */     GIR_RootConstrainSelectedInstOperands,
     /*  957591 */     // GIR_Coverage, 20392,
     /*  957591 */     GIR_EraseRootFromParent_Done,
     /*  957592 */   // Label 14362: @957592
     /*  957592 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(957669), // Rule ID 20393 //
     /*  957597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  957600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  957608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  957611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  957614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  957617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  957624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957636 */     // MIs[0] policy
     /*  957636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /*  957649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957667 */     GIR_RootConstrainSelectedInstOperands,
     /*  957668 */     // GIR_Coverage, 20393,
     /*  957668 */     GIR_EraseRootFromParent_Done,
     /*  957669 */   // Label 14363: @957669
     /*  957669 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(957746), // Rule ID 20396 //
     /*  957674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  957677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  957685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  957688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  957691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  957694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  957701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957713 */     // MIs[0] policy
     /*  957713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957723 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  957726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957744 */     GIR_RootConstrainSelectedInstOperands,
     /*  957745 */     // GIR_Coverage, 20396,
     /*  957745 */     GIR_EraseRootFromParent_Done,
     /*  957746 */   // Label 14364: @957746
     /*  957746 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(957823), // Rule ID 20397 //
     /*  957751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  957754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  957759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  957762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  957765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  957768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  957771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  957778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957790 */     // MIs[0] policy
     /*  957790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /*  957803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957821 */     GIR_RootConstrainSelectedInstOperands,
     /*  957822 */     // GIR_Coverage, 20397,
     /*  957822 */     GIR_EraseRootFromParent_Done,
     /*  957823 */   // Label 14365: @957823
     /*  957823 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(957900), // Rule ID 20722 //
     /*  957828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  957831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  957836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  957842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  957848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  957855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957867 */     // MIs[0] policy
     /*  957867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  957877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /*  957880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957898 */     GIR_RootConstrainSelectedInstOperands,
     /*  957899 */     // GIR_Coverage, 20722,
     /*  957899 */     GIR_EraseRootFromParent_Done,
     /*  957900 */   // Label 14366: @957900
     /*  957900 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(957977), // Rule ID 20723 //
     /*  957905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  957908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  957913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  957919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  957925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  957932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  957944 */     // MIs[0] policy
     /*  957944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  957947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  957954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /*  957957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  957961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  957963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  957965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  957975 */     GIR_RootConstrainSelectedInstOperands,
     /*  957976 */     // GIR_Coverage, 20723,
     /*  957976 */     GIR_EraseRootFromParent_Done,
     /*  957977 */   // Label 14367: @957977
     /*  957977 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(958054), // Rule ID 20726 //
     /*  957982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  957985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  957990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  957996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  958002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958021 */     // MIs[0] policy
     /*  958021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /*  958034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958040 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958052 */     GIR_RootConstrainSelectedInstOperands,
     /*  958053 */     // GIR_Coverage, 20726,
     /*  958053 */     GIR_EraseRootFromParent_Done,
     /*  958054 */   // Label 14368: @958054
     /*  958054 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(958131), // Rule ID 20727 //
     /*  958059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  958062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  958070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  958073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  958076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  958079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958098 */     // MIs[0] policy
     /*  958098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /*  958111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958129 */     GIR_RootConstrainSelectedInstOperands,
     /*  958130 */     // GIR_Coverage, 20727,
     /*  958130 */     GIR_EraseRootFromParent_Done,
     /*  958131 */   // Label 14369: @958131
     /*  958131 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(958208), // Rule ID 20730 //
     /*  958136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  958139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  958147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  958150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  958153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  958156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958175 */     // MIs[0] policy
     /*  958175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958185 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /*  958188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958206 */     GIR_RootConstrainSelectedInstOperands,
     /*  958207 */     // GIR_Coverage, 20730,
     /*  958207 */     GIR_EraseRootFromParent_Done,
     /*  958208 */   // Label 14370: @958208
     /*  958208 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(958285), // Rule ID 20731 //
     /*  958213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  958216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  958224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  958227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  958230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  958233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958252 */     // MIs[0] policy
     /*  958252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958262 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /*  958265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958283 */     GIR_RootConstrainSelectedInstOperands,
     /*  958284 */     // GIR_Coverage, 20731,
     /*  958284 */     GIR_EraseRootFromParent_Done,
     /*  958285 */   // Label 14371: @958285
     /*  958285 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(958362), // Rule ID 20734 //
     /*  958290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  958293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  958301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  958304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  958307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  958310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958329 */     // MIs[0] policy
     /*  958329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958339 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958360 */     GIR_RootConstrainSelectedInstOperands,
     /*  958361 */     // GIR_Coverage, 20734,
     /*  958361 */     GIR_EraseRootFromParent_Done,
     /*  958362 */   // Label 14372: @958362
     /*  958362 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(958439), // Rule ID 20735 //
     /*  958367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  958370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  958378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  958381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  958384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  958387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958406 */     // MIs[0] policy
     /*  958406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10887:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958437 */     GIR_RootConstrainSelectedInstOperands,
     /*  958438 */     // GIR_Coverage, 20735,
     /*  958438 */     GIR_EraseRootFromParent_Done,
     /*  958439 */   // Label 14373: @958439
     /*  958439 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(958516), // Rule ID 20738 //
     /*  958444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  958447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  958455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  958458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  958461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  958464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958483 */     // MIs[0] policy
     /*  958483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958502 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958514 */     GIR_RootConstrainSelectedInstOperands,
     /*  958515 */     // GIR_Coverage, 20738,
     /*  958515 */     GIR_EraseRootFromParent_Done,
     /*  958516 */   // Label 14374: @958516
     /*  958516 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(958593), // Rule ID 20739 //
     /*  958521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  958524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  958532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  958535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  958538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  958541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958560 */     // MIs[0] policy
     /*  958560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958591 */     GIR_RootConstrainSelectedInstOperands,
     /*  958592 */     // GIR_Coverage, 20739,
     /*  958592 */     GIR_EraseRootFromParent_Done,
     /*  958593 */   // Label 14375: @958593
     /*  958593 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(958670), // Rule ID 20742 //
     /*  958598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  958601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  958612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  958618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958637 */     // MIs[0] policy
     /*  958637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958647 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  958666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958668 */     GIR_RootConstrainSelectedInstOperands,
     /*  958669 */     // GIR_Coverage, 20742,
     /*  958669 */     GIR_EraseRootFromParent_Done,
     /*  958670 */   // Label 14376: @958670
     /*  958670 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(958747), // Rule ID 20743 //
     /*  958675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  958678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  958689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  958695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  958702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958714 */     // MIs[0] policy
     /*  958714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /*  958727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  958743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958745 */     GIR_RootConstrainSelectedInstOperands,
     /*  958746 */     // GIR_Coverage, 20743,
     /*  958746 */     GIR_EraseRootFromParent_Done,
     /*  958747 */   // Label 14377: @958747
     /*  958747 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(958824), // Rule ID 20746 //
     /*  958752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  958755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  958766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  958772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  958779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958791 */     // MIs[0] policy
     /*  958791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  958804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958810 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958822 */     GIR_RootConstrainSelectedInstOperands,
     /*  958823 */     // GIR_Coverage, 20746,
     /*  958823 */     GIR_EraseRootFromParent_Done,
     /*  958824 */   // Label 14378: @958824
     /*  958824 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(958901), // Rule ID 20747 //
     /*  958829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  958832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  958843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  958849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  958856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958868 */     // MIs[0] policy
     /*  958868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  958878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  958881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958899 */     GIR_RootConstrainSelectedInstOperands,
     /*  958900 */     // GIR_Coverage, 20747,
     /*  958900 */     GIR_EraseRootFromParent_Done,
     /*  958901 */   // Label 14379: @958901
     /*  958901 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(958978), // Rule ID 20750 //
     /*  958906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  958909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  958920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  958926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  958933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  958945 */     // MIs[0] policy
     /*  958945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  958948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958955 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  958955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  958958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  958962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  958964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  958966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  958976 */     GIR_RootConstrainSelectedInstOperands,
     /*  958977 */     // GIR_Coverage, 20750,
     /*  958977 */     GIR_EraseRootFromParent_Done,
     /*  958978 */   // Label 14380: @958978
     /*  958978 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(959055), // Rule ID 20751 //
     /*  958983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  958986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  958991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  958997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  959000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  959003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  959010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959022 */     // MIs[0] policy
     /*  959022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  959035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959053 */     GIR_RootConstrainSelectedInstOperands,
     /*  959054 */     // GIR_Coverage, 20751,
     /*  959054 */     GIR_EraseRootFromParent_Done,
     /*  959055 */   // Label 14381: @959055
     /*  959055 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(959132), // Rule ID 20754 //
     /*  959060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  959063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  959071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  959074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  959077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  959080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  959087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959099 */     // MIs[0] policy
     /*  959099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  959112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959130 */     GIR_RootConstrainSelectedInstOperands,
     /*  959131 */     // GIR_Coverage, 20754,
     /*  959131 */     GIR_EraseRootFromParent_Done,
     /*  959132 */   // Label 14382: @959132
     /*  959132 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(959209), // Rule ID 20755 //
     /*  959137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  959140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  959148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  959151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  959154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  959157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  959164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959176 */     // MIs[0] policy
     /*  959176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  959189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959207 */     GIR_RootConstrainSelectedInstOperands,
     /*  959208 */     // GIR_Coverage, 20755,
     /*  959208 */     GIR_EraseRootFromParent_Done,
     /*  959209 */   // Label 14383: @959209
     /*  959209 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(959286), // Rule ID 20758 //
     /*  959214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  959217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  959225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  959228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  959231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  959234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  959241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959253 */     // MIs[0] policy
     /*  959253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  959266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959272 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959284 */     GIR_RootConstrainSelectedInstOperands,
     /*  959285 */     // GIR_Coverage, 20758,
     /*  959285 */     GIR_EraseRootFromParent_Done,
     /*  959286 */   // Label 14384: @959286
     /*  959286 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(959363), // Rule ID 20759 //
     /*  959291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  959294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  959302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  959305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  959308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  959311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  959318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959330 */     // MIs[0] policy
     /*  959330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  959343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959361 */     GIR_RootConstrainSelectedInstOperands,
     /*  959362 */     // GIR_Coverage, 20759,
     /*  959362 */     GIR_EraseRootFromParent_Done,
     /*  959363 */   // Label 14385: @959363
     /*  959363 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(959440), // Rule ID 20762 //
     /*  959368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  959371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  959379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  959382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  959385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  959388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  959395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959407 */     // MIs[0] policy
     /*  959407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959417 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  959420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959426 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959438 */     GIR_RootConstrainSelectedInstOperands,
     /*  959439 */     // GIR_Coverage, 20762,
     /*  959439 */     GIR_EraseRootFromParent_Done,
     /*  959440 */   // Label 14386: @959440
     /*  959440 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(959517), // Rule ID 20763 //
     /*  959445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  959448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  959456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  959459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  959462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  959465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  959472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959484 */     // MIs[0] policy
     /*  959484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  959497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959515 */     GIR_RootConstrainSelectedInstOperands,
     /*  959516 */     // GIR_Coverage, 20763,
     /*  959516 */     GIR_EraseRootFromParent_Done,
     /*  959517 */   // Label 14387: @959517
     /*  959517 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(959594), // Rule ID 20766 //
     /*  959522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  959525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  959533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  959536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  959539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  959542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  959549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959561 */     // MIs[0] policy
     /*  959561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  959574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959592 */     GIR_RootConstrainSelectedInstOperands,
     /*  959593 */     // GIR_Coverage, 20766,
     /*  959593 */     GIR_EraseRootFromParent_Done,
     /*  959594 */   // Label 14388: @959594
     /*  959594 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(959671), // Rule ID 20767 //
     /*  959599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  959602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  959610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  959613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  959616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  959619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  959626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959638 */     // MIs[0] policy
     /*  959638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  959651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959669 */     GIR_RootConstrainSelectedInstOperands,
     /*  959670 */     // GIR_Coverage, 20767,
     /*  959670 */     GIR_EraseRootFromParent_Done,
     /*  959671 */   // Label 14389: @959671
     /*  959671 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(959748), // Rule ID 20770 //
     /*  959676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  959679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  959687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  959690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  959693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  959696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  959703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959715 */     // MIs[0] policy
     /*  959715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  959728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  959744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959746 */     GIR_RootConstrainSelectedInstOperands,
     /*  959747 */     // GIR_Coverage, 20770,
     /*  959747 */     GIR_EraseRootFromParent_Done,
     /*  959748 */   // Label 14390: @959748
     /*  959748 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(959825), // Rule ID 20771 //
     /*  959753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  959756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  959764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  959767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  959770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  959773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  959780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959792 */     // MIs[0] policy
     /*  959792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /*  959805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  959821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959823 */     GIR_RootConstrainSelectedInstOperands,
     /*  959824 */     // GIR_Coverage, 20771,
     /*  959824 */     GIR_EraseRootFromParent_Done,
     /*  959825 */   // Label 14391: @959825
     /*  959825 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(959902), // Rule ID 20774 //
     /*  959830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  959833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  959844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  959850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  959857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959869 */     // MIs[0] policy
     /*  959869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  959879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  959882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  959898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959900 */     GIR_RootConstrainSelectedInstOperands,
     /*  959901 */     // GIR_Coverage, 20774,
     /*  959901 */     GIR_EraseRootFromParent_Done,
     /*  959902 */   // Label 14392: @959902
     /*  959902 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(959979), // Rule ID 20775 //
     /*  959907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  959910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  959921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  959927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  959934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959946 */     // MIs[0] policy
     /*  959946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  959949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  959956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /*  959959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  959965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  959967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  959975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  959977 */     GIR_RootConstrainSelectedInstOperands,
     /*  959978 */     // GIR_Coverage, 20775,
     /*  959978 */     GIR_EraseRootFromParent_Done,
     /*  959979 */   // Label 14393: @959979
     /*  959979 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(960056), // Rule ID 20778 //
     /*  959984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  959987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  959992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  959998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  960001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  960004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  960011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960023 */     // MIs[0] policy
     /*  960023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  960036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  960052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960054 */     GIR_RootConstrainSelectedInstOperands,
     /*  960055 */     // GIR_Coverage, 20778,
     /*  960055 */     GIR_EraseRootFromParent_Done,
     /*  960056 */   // Label 14394: @960056
     /*  960056 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(960133), // Rule ID 20779 //
     /*  960061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  960064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /*  960069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  960072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  960075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  960078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  960081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  960088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960100 */     // MIs[0] policy
     /*  960100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960110 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /*  960113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  960129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960131 */     GIR_RootConstrainSelectedInstOperands,
     /*  960132 */     // GIR_Coverage, 20779,
     /*  960132 */     GIR_EraseRootFromParent_Done,
     /*  960133 */   // Label 14395: @960133
     /*  960133 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(960210), // Rule ID 20782 //
     /*  960138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  960141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  960158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960177 */     // MIs[0] policy
     /*  960177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960187 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /*  960190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960208 */     GIR_RootConstrainSelectedInstOperands,
     /*  960209 */     // GIR_Coverage, 20782,
     /*  960209 */     GIR_EraseRootFromParent_Done,
     /*  960210 */   // Label 14396: @960210
     /*  960210 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(960287), // Rule ID 20783 //
     /*  960215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  960218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  960235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960254 */     // MIs[0] policy
     /*  960254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /*  960267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960285 */     GIR_RootConstrainSelectedInstOperands,
     /*  960286 */     // GIR_Coverage, 20783,
     /*  960286 */     GIR_EraseRootFromParent_Done,
     /*  960287 */   // Label 14397: @960287
     /*  960287 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(960364), // Rule ID 20786 //
     /*  960292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  960295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  960312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960331 */     // MIs[0] policy
     /*  960331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /*  960344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960362 */     GIR_RootConstrainSelectedInstOperands,
     /*  960363 */     // GIR_Coverage, 20786,
     /*  960363 */     GIR_EraseRootFromParent_Done,
     /*  960364 */   // Label 14398: @960364
     /*  960364 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(960441), // Rule ID 20787 //
     /*  960369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  960372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  960389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960408 */     // MIs[0] policy
     /*  960408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /*  960421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960439 */     GIR_RootConstrainSelectedInstOperands,
     /*  960440 */     // GIR_Coverage, 20787,
     /*  960440 */     GIR_EraseRootFromParent_Done,
     /*  960441 */   // Label 14399: @960441
     /*  960441 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(960518), // Rule ID 20790 //
     /*  960446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  960449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  960466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960485 */     // MIs[0] policy
     /*  960485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960495 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /*  960498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960516 */     GIR_RootConstrainSelectedInstOperands,
     /*  960517 */     // GIR_Coverage, 20790,
     /*  960517 */     GIR_EraseRootFromParent_Done,
     /*  960518 */   // Label 14400: @960518
     /*  960518 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(960595), // Rule ID 20791 //
     /*  960523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  960526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  960543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960562 */     // MIs[0] policy
     /*  960562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /*  960575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960593 */     GIR_RootConstrainSelectedInstOperands,
     /*  960594 */     // GIR_Coverage, 20791,
     /*  960594 */     GIR_EraseRootFromParent_Done,
     /*  960595 */   // Label 14401: @960595
     /*  960595 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(960672), // Rule ID 20794 //
     /*  960600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  960603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  960620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960639 */     // MIs[0] policy
     /*  960639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  960652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960670 */     GIR_RootConstrainSelectedInstOperands,
     /*  960671 */     // GIR_Coverage, 20794,
     /*  960671 */     GIR_EraseRootFromParent_Done,
     /*  960672 */   // Label 14402: @960672
     /*  960672 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(960749), // Rule ID 20795 //
     /*  960677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  960680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  960697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960716 */     // MIs[0] policy
     /*  960716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  960729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960747 */     GIR_RootConstrainSelectedInstOperands,
     /*  960748 */     // GIR_Coverage, 20795,
     /*  960748 */     GIR_EraseRootFromParent_Done,
     /*  960749 */   // Label 14403: @960749
     /*  960749 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(960826), // Rule ID 20798 //
     /*  960754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  960757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  960765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  960768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  960771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  960774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960793 */     // MIs[0] policy
     /*  960793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  960806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960824 */     GIR_RootConstrainSelectedInstOperands,
     /*  960825 */     // GIR_Coverage, 20798,
     /*  960825 */     GIR_EraseRootFromParent_Done,
     /*  960826 */   // Label 14404: @960826
     /*  960826 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(960903), // Rule ID 20799 //
     /*  960831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  960834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  960842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  960845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  960848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  960851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960870 */     // MIs[0] policy
     /*  960870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  960880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  960883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960901 */     GIR_RootConstrainSelectedInstOperands,
     /*  960902 */     // GIR_Coverage, 20799,
     /*  960902 */     GIR_EraseRootFromParent_Done,
     /*  960903 */   // Label 14405: @960903
     /*  960903 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(960980), // Rule ID 20802 //
     /*  960908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  960911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  960919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  960922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  960925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  960928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960947 */     // MIs[0] policy
     /*  960947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  960950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960957 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  960957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  960960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  960966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  960968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  960976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  960978 */     GIR_RootConstrainSelectedInstOperands,
     /*  960979 */     // GIR_Coverage, 20802,
     /*  960979 */     GIR_EraseRootFromParent_Done,
     /*  960980 */   // Label 14406: @960980
     /*  960980 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(961057), // Rule ID 20803 //
     /*  960985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  960988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  960993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  960996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  960999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  961005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961024 */     // MIs[0] policy
     /*  961024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /*  961037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961055 */     GIR_RootConstrainSelectedInstOperands,
     /*  961056 */     // GIR_Coverage, 20803,
     /*  961056 */     GIR_EraseRootFromParent_Done,
     /*  961057 */   // Label 14407: @961057
     /*  961057 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(961134), // Rule ID 20806 //
     /*  961062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  961065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  961073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  961076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  961079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  961082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961101 */     // MIs[0] policy
     /*  961101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  961114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961132 */     GIR_RootConstrainSelectedInstOperands,
     /*  961133 */     // GIR_Coverage, 20806,
     /*  961133 */     GIR_EraseRootFromParent_Done,
     /*  961134 */   // Label 14408: @961134
     /*  961134 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(961211), // Rule ID 20807 //
     /*  961139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  961142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  961150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  961153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  961156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  961159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961178 */     // MIs[0] policy
     /*  961178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  961191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961209 */     GIR_RootConstrainSelectedInstOperands,
     /*  961210 */     // GIR_Coverage, 20807,
     /*  961210 */     GIR_EraseRootFromParent_Done,
     /*  961211 */   // Label 14409: @961211
     /*  961211 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(961288), // Rule ID 20810 //
     /*  961216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  961219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  961227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  961230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  961233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  961236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961255 */     // MIs[0] policy
     /*  961255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  961268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961286 */     GIR_RootConstrainSelectedInstOperands,
     /*  961287 */     // GIR_Coverage, 20810,
     /*  961287 */     GIR_EraseRootFromParent_Done,
     /*  961288 */   // Label 14410: @961288
     /*  961288 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(961365), // Rule ID 20811 //
     /*  961293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  961296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  961304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  961307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  961310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  961313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961332 */     // MIs[0] policy
     /*  961332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961342 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  961345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961363 */     GIR_RootConstrainSelectedInstOperands,
     /*  961364 */     // GIR_Coverage, 20811,
     /*  961364 */     GIR_EraseRootFromParent_Done,
     /*  961365 */   // Label 14411: @961365
     /*  961365 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(961442), // Rule ID 20814 //
     /*  961370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  961373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  961381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  961384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  961387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  961390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961409 */     // MIs[0] policy
     /*  961409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  961422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961440 */     GIR_RootConstrainSelectedInstOperands,
     /*  961441 */     // GIR_Coverage, 20814,
     /*  961441 */     GIR_EraseRootFromParent_Done,
     /*  961442 */   // Label 14412: @961442
     /*  961442 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(961519), // Rule ID 20815 //
     /*  961447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  961450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  961458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  961461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  961464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  961467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961486 */     // MIs[0] policy
     /*  961486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961496 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  961499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961517 */     GIR_RootConstrainSelectedInstOperands,
     /*  961518 */     // GIR_Coverage, 20815,
     /*  961518 */     GIR_EraseRootFromParent_Done,
     /*  961519 */   // Label 14413: @961519
     /*  961519 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(961596), // Rule ID 20818 //
     /*  961524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  961527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  961535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  961538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  961541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  961544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961563 */     // MIs[0] policy
     /*  961563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  961576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961594 */     GIR_RootConstrainSelectedInstOperands,
     /*  961595 */     // GIR_Coverage, 20818,
     /*  961595 */     GIR_EraseRootFromParent_Done,
     /*  961596 */   // Label 14414: @961596
     /*  961596 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(961673), // Rule ID 20819 //
     /*  961601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  961604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  961612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  961615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  961618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  961621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961640 */     // MIs[0] policy
     /*  961640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  961653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961671 */     GIR_RootConstrainSelectedInstOperands,
     /*  961672 */     // GIR_Coverage, 20819,
     /*  961672 */     GIR_EraseRootFromParent_Done,
     /*  961673 */   // Label 14415: @961673
     /*  961673 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(961750), // Rule ID 20822 //
     /*  961678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  961681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  961689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  961692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  961695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  961698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961717 */     // MIs[0] policy
     /*  961717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961727 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  961730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961748 */     GIR_RootConstrainSelectedInstOperands,
     /*  961749 */     // GIR_Coverage, 20822,
     /*  961749 */     GIR_EraseRootFromParent_Done,
     /*  961750 */   // Label 14416: @961750
     /*  961750 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(961827), // Rule ID 20823 //
     /*  961755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  961758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  961766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  961769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  961772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  961775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961794 */     // MIs[0] policy
     /*  961794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961804 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  961807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961825 */     GIR_RootConstrainSelectedInstOperands,
     /*  961826 */     // GIR_Coverage, 20823,
     /*  961826 */     GIR_EraseRootFromParent_Done,
     /*  961827 */   // Label 14417: @961827
     /*  961827 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(961904), // Rule ID 20826 //
     /*  961832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  961835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  961846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  961852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961871 */     // MIs[0] policy
     /*  961871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  961881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  961884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961902 */     GIR_RootConstrainSelectedInstOperands,
     /*  961903 */     // GIR_Coverage, 20826,
     /*  961903 */     GIR_EraseRootFromParent_Done,
     /*  961904 */   // Label 14418: @961904
     /*  961904 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(961981), // Rule ID 20827 //
     /*  961909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  961912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  961923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  961929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961948 */     // MIs[0] policy
     /*  961948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  961951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  961958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  961961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  961967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  961969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  961979 */     GIR_RootConstrainSelectedInstOperands,
     /*  961980 */     // GIR_Coverage, 20827,
     /*  961980 */     GIR_EraseRootFromParent_Done,
     /*  961981 */   // Label 14419: @961981
     /*  961981 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(962058), // Rule ID 20830 //
     /*  961986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  961989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  961994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  961997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  962000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  962006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962025 */     // MIs[0] policy
     /*  962025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  962038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962056 */     GIR_RootConstrainSelectedInstOperands,
     /*  962057 */     // GIR_Coverage, 20830,
     /*  962057 */     GIR_EraseRootFromParent_Done,
     /*  962058 */   // Label 14420: @962058
     /*  962058 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(962135), // Rule ID 20831 //
     /*  962063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  962066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  962071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  962077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  962083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962102 */     // MIs[0] policy
     /*  962102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /*  962115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962133 */     GIR_RootConstrainSelectedInstOperands,
     /*  962134 */     // GIR_Coverage, 20831,
     /*  962134 */     GIR_EraseRootFromParent_Done,
     /*  962135 */   // Label 14421: @962135
     /*  962135 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(962212), // Rule ID 20834 //
     /*  962140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  962143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  962148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  962154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  962160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962179 */     // MIs[0] policy
     /*  962179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962189 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  962192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962210 */     GIR_RootConstrainSelectedInstOperands,
     /*  962211 */     // GIR_Coverage, 20834,
     /*  962211 */     GIR_EraseRootFromParent_Done,
     /*  962212 */   // Label 14422: @962212
     /*  962212 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(962289), // Rule ID 20835 //
     /*  962217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  962220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  962225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  962231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  962237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962256 */     // MIs[0] policy
     /*  962256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /*  962269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962287 */     GIR_RootConstrainSelectedInstOperands,
     /*  962288 */     // GIR_Coverage, 20835,
     /*  962288 */     GIR_EraseRootFromParent_Done,
     /*  962289 */   // Label 14423: @962289
     /*  962289 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(962366), // Rule ID 20838 //
     /*  962294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  962297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  962302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  962305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  962308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  962311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  962314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962333 */     // MIs[0] policy
     /*  962333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  962346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962364 */     GIR_RootConstrainSelectedInstOperands,
     /*  962365 */     // GIR_Coverage, 20838,
     /*  962365 */     GIR_EraseRootFromParent_Done,
     /*  962366 */   // Label 14424: @962366
     /*  962366 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(962443), // Rule ID 20839 //
     /*  962371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  962374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /*  962379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  962382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  962385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  962388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  962391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962410 */     // MIs[0] policy
     /*  962410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962420 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /*  962423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962441 */     GIR_RootConstrainSelectedInstOperands,
     /*  962442 */     // GIR_Coverage, 20839,
     /*  962442 */     GIR_EraseRootFromParent_Done,
     /*  962443 */   // Label 14425: @962443
     /*  962443 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(962520), // Rule ID 21106 //
     /*  962448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  962451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  962459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  962462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  962465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  962468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  962475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962487 */     // MIs[0] policy
     /*  962487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962497 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10983:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /*  962500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962518 */     GIR_RootConstrainSelectedInstOperands,
     /*  962519 */     // GIR_Coverage, 21106,
     /*  962519 */     GIR_EraseRootFromParent_Done,
     /*  962520 */   // Label 14426: @962520
     /*  962520 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(962597), // Rule ID 21107 //
     /*  962525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  962528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  962536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  962539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  962542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  962545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  962552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962564 */     // MIs[0] policy
     /*  962564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10983:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /*  962577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962595 */     GIR_RootConstrainSelectedInstOperands,
     /*  962596 */     // GIR_Coverage, 21107,
     /*  962596 */     GIR_EraseRootFromParent_Done,
     /*  962597 */   // Label 14427: @962597
     /*  962597 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(962674), // Rule ID 21110 //
     /*  962602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  962605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  962613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  962616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  962619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  962622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  962629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962641 */     // MIs[0] policy
     /*  962641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10983:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /*  962654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962672 */     GIR_RootConstrainSelectedInstOperands,
     /*  962673 */     // GIR_Coverage, 21110,
     /*  962673 */     GIR_EraseRootFromParent_Done,
     /*  962674 */   // Label 14428: @962674
     /*  962674 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(962751), // Rule ID 21111 //
     /*  962679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  962682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  962690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  962693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  962696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  962699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  962706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962718 */     // MIs[0] policy
     /*  962718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10983:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /*  962731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962749 */     GIR_RootConstrainSelectedInstOperands,
     /*  962750 */     // GIR_Coverage, 21111,
     /*  962750 */     GIR_EraseRootFromParent_Done,
     /*  962751 */   // Label 14429: @962751
     /*  962751 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(962828), // Rule ID 21114 //
     /*  962756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  962759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  962773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  962776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962795 */     // MIs[0] policy
     /*  962795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10983:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /*  962808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962826 */     GIR_RootConstrainSelectedInstOperands,
     /*  962827 */     // GIR_Coverage, 21114,
     /*  962827 */     GIR_EraseRootFromParent_Done,
     /*  962828 */   // Label 14430: @962828
     /*  962828 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(962905), // Rule ID 21115 //
     /*  962833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  962836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  962850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  962853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962872 */     // MIs[0] policy
     /*  962872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10983:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  962882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /*  962885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962903 */     GIR_RootConstrainSelectedInstOperands,
     /*  962904 */     // GIR_Coverage, 21115,
     /*  962904 */     GIR_EraseRootFromParent_Done,
     /*  962905 */   // Label 14431: @962905
     /*  962905 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(962982), // Rule ID 21118 //
     /*  962910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  962913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  962930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962949 */     // MIs[0] policy
     /*  962949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  962952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962959 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10983:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  962959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /*  962962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  962968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  962970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  962980 */     GIR_RootConstrainSelectedInstOperands,
     /*  962981 */     // GIR_Coverage, 21118,
     /*  962981 */     GIR_EraseRootFromParent_Done,
     /*  962982 */   // Label 14432: @962982
     /*  962982 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(963059), // Rule ID 21119 //
     /*  962987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  962990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  962995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  963001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  963004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  963007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963026 */     // MIs[0] policy
     /*  963026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10983:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /*  963039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963057 */     GIR_RootConstrainSelectedInstOperands,
     /*  963058 */     // GIR_Coverage, 21119,
     /*  963058 */     GIR_EraseRootFromParent_Done,
     /*  963059 */   // Label 14433: @963059
     /*  963059 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(963136), // Rule ID 21122 //
     /*  963064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  963067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  963081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  963084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963103 */     // MIs[0] policy
     /*  963103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963113 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10983:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /*  963116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963134 */     GIR_RootConstrainSelectedInstOperands,
     /*  963135 */     // GIR_Coverage, 21122,
     /*  963135 */     GIR_EraseRootFromParent_Done,
     /*  963136 */   // Label 14434: @963136
     /*  963136 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(963213), // Rule ID 21123 //
     /*  963141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  963144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  963158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  963161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963180 */     // MIs[0] policy
     /*  963180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10983:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /*  963193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963211 */     GIR_RootConstrainSelectedInstOperands,
     /*  963212 */     // GIR_Coverage, 21123,
     /*  963212 */     GIR_EraseRootFromParent_Done,
     /*  963213 */   // Label 14435: @963213
     /*  963213 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(963290), // Rule ID 21126 //
     /*  963218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  963221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  963229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  963232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  963235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  963238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963257 */     // MIs[0] policy
     /*  963257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963267 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10983:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /*  963270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963288 */     GIR_RootConstrainSelectedInstOperands,
     /*  963289 */     // GIR_Coverage, 21126,
     /*  963289 */     GIR_EraseRootFromParent_Done,
     /*  963290 */   // Label 14436: @963290
     /*  963290 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(963367), // Rule ID 21127 //
     /*  963295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  963298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  963306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  963309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  963312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  963315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963334 */     // MIs[0] policy
     /*  963334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10983:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /*  963347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963365 */     GIR_RootConstrainSelectedInstOperands,
     /*  963366 */     // GIR_Coverage, 21127,
     /*  963366 */     GIR_EraseRootFromParent_Done,
     /*  963367 */   // Label 14437: @963367
     /*  963367 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(963444), // Rule ID 21130 //
     /*  963372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  963375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  963389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  963392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963411 */     // MIs[0] policy
     /*  963411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10983:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /*  963424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963442 */     GIR_RootConstrainSelectedInstOperands,
     /*  963443 */     // GIR_Coverage, 21130,
     /*  963443 */     GIR_EraseRootFromParent_Done,
     /*  963444 */   // Label 14438: @963444
     /*  963444 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(963521), // Rule ID 21131 //
     /*  963449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  963452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  963466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  963469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963488 */     // MIs[0] policy
     /*  963488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10983:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /*  963501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963519 */     GIR_RootConstrainSelectedInstOperands,
     /*  963520 */     // GIR_Coverage, 21131,
     /*  963520 */     GIR_EraseRootFromParent_Done,
     /*  963521 */   // Label 14439: @963521
     /*  963521 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(963598), // Rule ID 21134 //
     /*  963526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  963529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  963546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963565 */     // MIs[0] policy
     /*  963565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963575 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10983:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /*  963578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963596 */     GIR_RootConstrainSelectedInstOperands,
     /*  963597 */     // GIR_Coverage, 21134,
     /*  963597 */     GIR_EraseRootFromParent_Done,
     /*  963598 */   // Label 14440: @963598
     /*  963598 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(963675), // Rule ID 21135 //
     /*  963603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  963606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  963623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963642 */     // MIs[0] policy
     /*  963642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10983:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /*  963655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963673 */     GIR_RootConstrainSelectedInstOperands,
     /*  963674 */     // GIR_Coverage, 21135,
     /*  963674 */     GIR_EraseRootFromParent_Done,
     /*  963675 */   // Label 14441: @963675
     /*  963675 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(963752), // Rule ID 21138 //
     /*  963680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  963683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  963700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963719 */     // MIs[0] policy
     /*  963719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963729 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10983:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /*  963732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963750 */     GIR_RootConstrainSelectedInstOperands,
     /*  963751 */     // GIR_Coverage, 21138,
     /*  963751 */     GIR_EraseRootFromParent_Done,
     /*  963752 */   // Label 14442: @963752
     /*  963752 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(963829), // Rule ID 21139 //
     /*  963757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  963760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /*  963765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  963777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963796 */     // MIs[0] policy
     /*  963796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10983:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /*  963809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963827 */     GIR_RootConstrainSelectedInstOperands,
     /*  963828 */     // GIR_Coverage, 21139,
     /*  963828 */     GIR_EraseRootFromParent_Done,
     /*  963829 */   // Label 14443: @963829
     /*  963829 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(963906), // Rule ID 21142 //
     /*  963834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  963837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  963842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  963845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  963848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  963851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  963854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963873 */     // MIs[0] policy
     /*  963873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963883 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10981:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  963883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /*  963886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963904 */     GIR_RootConstrainSelectedInstOperands,
     /*  963905 */     // GIR_Coverage, 21142,
     /*  963905 */     GIR_EraseRootFromParent_Done,
     /*  963906 */   // Label 14444: @963906
     /*  963906 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(963983), // Rule ID 21143 //
     /*  963911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  963914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  963919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  963922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  963925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  963928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  963931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963950 */     // MIs[0] policy
     /*  963950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  963953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10981:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  963960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /*  963963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  963969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  963971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  963981 */     GIR_RootConstrainSelectedInstOperands,
     /*  963982 */     // GIR_Coverage, 21143,
     /*  963982 */     GIR_EraseRootFromParent_Done,
     /*  963983 */   // Label 14445: @963983
     /*  963983 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(964060), // Rule ID 21146 //
     /*  963988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  963991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  963996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  963999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  964002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  964008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964027 */     // MIs[0] policy
     /*  964027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964037 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10981:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /*  964040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964058 */     GIR_RootConstrainSelectedInstOperands,
     /*  964059 */     // GIR_Coverage, 21146,
     /*  964059 */     GIR_EraseRootFromParent_Done,
     /*  964060 */   // Label 14446: @964060
     /*  964060 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(964137), // Rule ID 21147 //
     /*  964065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  964068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  964076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  964079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  964085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964104 */     // MIs[0] policy
     /*  964104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10981:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /*  964117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964135 */     GIR_RootConstrainSelectedInstOperands,
     /*  964136 */     // GIR_Coverage, 21147,
     /*  964136 */     GIR_EraseRootFromParent_Done,
     /*  964137 */   // Label 14447: @964137
     /*  964137 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(964214), // Rule ID 21150 //
     /*  964142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  964145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  964153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  964156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  964162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  964169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964181 */     // MIs[0] policy
     /*  964181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10981:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /*  964194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964212 */     GIR_RootConstrainSelectedInstOperands,
     /*  964213 */     // GIR_Coverage, 21150,
     /*  964213 */     GIR_EraseRootFromParent_Done,
     /*  964214 */   // Label 14448: @964214
     /*  964214 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(964291), // Rule ID 21151 //
     /*  964219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  964222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  964230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  964233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  964239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  964246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964258 */     // MIs[0] policy
     /*  964258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10981:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /*  964271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964289 */     GIR_RootConstrainSelectedInstOperands,
     /*  964290 */     // GIR_Coverage, 21151,
     /*  964290 */     GIR_EraseRootFromParent_Done,
     /*  964291 */   // Label 14449: @964291
     /*  964291 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(964368), // Rule ID 21154 //
     /*  964296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  964299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  964307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  964310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  964313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  964316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  964323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  964327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964335 */     // MIs[0] policy
     /*  964335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964345 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10981:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /*  964348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964366 */     GIR_RootConstrainSelectedInstOperands,
     /*  964367 */     // GIR_Coverage, 21154,
     /*  964367 */     GIR_EraseRootFromParent_Done,
     /*  964368 */   // Label 14450: @964368
     /*  964368 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(964445), // Rule ID 21155 //
     /*  964373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  964376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  964384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  964387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  964390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  964393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  964400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  964404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964412 */     // MIs[0] policy
     /*  964412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10981:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /*  964425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964443 */     GIR_RootConstrainSelectedInstOperands,
     /*  964444 */     // GIR_Coverage, 21155,
     /*  964444 */     GIR_EraseRootFromParent_Done,
     /*  964445 */   // Label 14451: @964445
     /*  964445 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(964522), // Rule ID 21158 //
     /*  964450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  964453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  964461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  964464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  964467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  964470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  964477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  964485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964489 */     // MIs[0] policy
     /*  964489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10981:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /*  964502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964520 */     GIR_RootConstrainSelectedInstOperands,
     /*  964521 */     // GIR_Coverage, 21158,
     /*  964521 */     GIR_EraseRootFromParent_Done,
     /*  964522 */   // Label 14452: @964522
     /*  964522 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(964599), // Rule ID 21159 //
     /*  964527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  964530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  964538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  964541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  964544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  964547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  964554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  964562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964566 */     // MIs[0] policy
     /*  964566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10981:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /*  964579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964597 */     GIR_RootConstrainSelectedInstOperands,
     /*  964598 */     // GIR_Coverage, 21159,
     /*  964598 */     GIR_EraseRootFromParent_Done,
     /*  964599 */   // Label 14453: @964599
     /*  964599 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(964676), // Rule ID 21162 //
     /*  964604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  964607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  964615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  964618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  964624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964643 */     // MIs[0] policy
     /*  964643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964653 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10981:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /*  964656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964674 */     GIR_RootConstrainSelectedInstOperands,
     /*  964675 */     // GIR_Coverage, 21162,
     /*  964675 */     GIR_EraseRootFromParent_Done,
     /*  964676 */   // Label 14454: @964676
     /*  964676 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(964753), // Rule ID 21163 //
     /*  964681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  964684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  964692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  964695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  964701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964720 */     // MIs[0] policy
     /*  964720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10981:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /*  964733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964751 */     GIR_RootConstrainSelectedInstOperands,
     /*  964752 */     // GIR_Coverage, 21163,
     /*  964752 */     GIR_EraseRootFromParent_Done,
     /*  964753 */   // Label 14455: @964753
     /*  964753 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(964830), // Rule ID 21166 //
     /*  964758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  964761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  964769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  964772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  964778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  964785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964797 */     // MIs[0] policy
     /*  964797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10981:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /*  964810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964828 */     GIR_RootConstrainSelectedInstOperands,
     /*  964829 */     // GIR_Coverage, 21166,
     /*  964829 */     GIR_EraseRootFromParent_Done,
     /*  964830 */   // Label 14456: @964830
     /*  964830 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(964907), // Rule ID 21167 //
     /*  964835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  964838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  964846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  964849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  964855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  964858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  964862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964874 */     // MIs[0] policy
     /*  964874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10981:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  964884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /*  964887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964905 */     GIR_RootConstrainSelectedInstOperands,
     /*  964906 */     // GIR_Coverage, 21167,
     /*  964906 */     GIR_EraseRootFromParent_Done,
     /*  964907 */   // Label 14457: @964907
     /*  964907 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(964984), // Rule ID 21170 //
     /*  964912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  964915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  964923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  964926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  964929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  964932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  964935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  964939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  964943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  964947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964951 */     // MIs[0] policy
     /*  964951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  964954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10981:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  964961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /*  964964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  964970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  964972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  964982 */     GIR_RootConstrainSelectedInstOperands,
     /*  964983 */     // GIR_Coverage, 21170,
     /*  964983 */     GIR_EraseRootFromParent_Done,
     /*  964984 */   // Label 14458: @964984
     /*  964984 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(965061), // Rule ID 21171 //
     /*  964989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  964992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  964997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  965000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  965003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  965006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  965009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965028 */     // MIs[0] policy
     /*  965028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10981:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /*  965041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965059 */     GIR_RootConstrainSelectedInstOperands,
     /*  965060 */     // GIR_Coverage, 21171,
     /*  965060 */     GIR_EraseRootFromParent_Done,
     /*  965061 */   // Label 14459: @965061
     /*  965061 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(965138), // Rule ID 21174 //
     /*  965066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  965069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  965074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  965077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  965080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  965083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  965086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965105 */     // MIs[0] policy
     /*  965105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965115 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10981:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /*  965118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965136 */     GIR_RootConstrainSelectedInstOperands,
     /*  965137 */     // GIR_Coverage, 21174,
     /*  965137 */     GIR_EraseRootFromParent_Done,
     /*  965138 */   // Label 14460: @965138
     /*  965138 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(965215), // Rule ID 21175 //
     /*  965143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  965146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /*  965151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  965154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  965157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  965160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  965163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965182 */     // MIs[0] policy
     /*  965182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10981:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /*  965195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965213 */     GIR_RootConstrainSelectedInstOperands,
     /*  965214 */     // GIR_Coverage, 21175,
     /*  965214 */     GIR_EraseRootFromParent_Done,
     /*  965215 */   // Label 14461: @965215
     /*  965215 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(965292), // Rule ID 21178 //
     /*  965220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  965231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  965234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  965237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  965240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965259 */     // MIs[0] policy
     /*  965259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965269 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /*  965272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965290 */     GIR_RootConstrainSelectedInstOperands,
     /*  965291 */     // GIR_Coverage, 21178,
     /*  965291 */     GIR_EraseRootFromParent_Done,
     /*  965292 */   // Label 14462: @965292
     /*  965292 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(965369), // Rule ID 21179 //
     /*  965297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  965300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  965308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  965311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  965314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  965317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965336 */     // MIs[0] policy
     /*  965336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965346 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /*  965349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965367 */     GIR_RootConstrainSelectedInstOperands,
     /*  965368 */     // GIR_Coverage, 21179,
     /*  965368 */     GIR_EraseRootFromParent_Done,
     /*  965369 */   // Label 14463: @965369
     /*  965369 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(965446), // Rule ID 21182 //
     /*  965374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  965385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  965388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  965391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  965394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965413 */     // MIs[0] policy
     /*  965413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965423 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /*  965426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965444 */     GIR_RootConstrainSelectedInstOperands,
     /*  965445 */     // GIR_Coverage, 21182,
     /*  965445 */     GIR_EraseRootFromParent_Done,
     /*  965446 */   // Label 14464: @965446
     /*  965446 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(965523), // Rule ID 21183 //
     /*  965451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  965454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  965462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  965465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  965468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  965471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965490 */     // MIs[0] policy
     /*  965490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965500 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /*  965503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965521 */     GIR_RootConstrainSelectedInstOperands,
     /*  965522 */     // GIR_Coverage, 21183,
     /*  965522 */     GIR_EraseRootFromParent_Done,
     /*  965523 */   // Label 14465: @965523
     /*  965523 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(965600), // Rule ID 21186 //
     /*  965528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  965539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  965542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  965545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  965548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965567 */     // MIs[0] policy
     /*  965567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965577 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /*  965580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965598 */     GIR_RootConstrainSelectedInstOperands,
     /*  965599 */     // GIR_Coverage, 21186,
     /*  965599 */     GIR_EraseRootFromParent_Done,
     /*  965600 */   // Label 14466: @965600
     /*  965600 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(965677), // Rule ID 21187 //
     /*  965605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  965608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  965616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  965619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  965622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  965625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965644 */     // MIs[0] policy
     /*  965644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965654 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10979:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /*  965657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965675 */     GIR_RootConstrainSelectedInstOperands,
     /*  965676 */     // GIR_Coverage, 21187,
     /*  965676 */     GIR_EraseRootFromParent_Done,
     /*  965677 */   // Label 14467: @965677
     /*  965677 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(965754), // Rule ID 21190 //
     /*  965682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  965702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965721 */     // MIs[0] policy
     /*  965721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /*  965734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965752 */     GIR_RootConstrainSelectedInstOperands,
     /*  965753 */     // GIR_Coverage, 21190,
     /*  965753 */     GIR_EraseRootFromParent_Done,
     /*  965754 */   // Label 14468: @965754
     /*  965754 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(965831), // Rule ID 21191 //
     /*  965759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  965762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  965779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965798 */     // MIs[0] policy
     /*  965798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965808 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /*  965811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965829 */     GIR_RootConstrainSelectedInstOperands,
     /*  965830 */     // GIR_Coverage, 21191,
     /*  965830 */     GIR_EraseRootFromParent_Done,
     /*  965831 */   // Label 14469: @965831
     /*  965831 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(965908), // Rule ID 21194 //
     /*  965836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  965847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  965850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  965856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  965859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965875 */     // MIs[0] policy
     /*  965875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965885 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  965885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /*  965888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965906 */     GIR_RootConstrainSelectedInstOperands,
     /*  965907 */     // GIR_Coverage, 21194,
     /*  965907 */     GIR_EraseRootFromParent_Done,
     /*  965908 */   // Label 14470: @965908
     /*  965908 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(965985), // Rule ID 21195 //
     /*  965913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  965916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  965924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  965927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  965933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  965936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965952 */     // MIs[0] policy
     /*  965952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  965955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965962 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  965962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /*  965965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  965971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  965973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  965983 */     GIR_RootConstrainSelectedInstOperands,
     /*  965984 */     // GIR_Coverage, 21195,
     /*  965984 */     GIR_EraseRootFromParent_Done,
     /*  965985 */   // Label 14471: @965985
     /*  965985 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(966062), // Rule ID 21198 //
     /*  965990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  965993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  965998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  966010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966029 */     // MIs[0] policy
     /*  966029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966039 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /*  966042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966060 */     GIR_RootConstrainSelectedInstOperands,
     /*  966061 */     // GIR_Coverage, 21198,
     /*  966061 */     GIR_EraseRootFromParent_Done,
     /*  966062 */   // Label 14472: @966062
     /*  966062 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(966139), // Rule ID 21199 //
     /*  966067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  966070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  966087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966106 */     // MIs[0] policy
     /*  966106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966116 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /*  966119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966137 */     GIR_RootConstrainSelectedInstOperands,
     /*  966138 */     // GIR_Coverage, 21199,
     /*  966138 */     GIR_EraseRootFromParent_Done,
     /*  966139 */   // Label 14473: @966139
     /*  966139 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(966216), // Rule ID 21202 //
     /*  966144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  966147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  966155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  966158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  966161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  966164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  966171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966183 */     // MIs[0] policy
     /*  966183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966193 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /*  966196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966214 */     GIR_RootConstrainSelectedInstOperands,
     /*  966215 */     // GIR_Coverage, 21202,
     /*  966215 */     GIR_EraseRootFromParent_Done,
     /*  966216 */   // Label 14474: @966216
     /*  966216 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(966293), // Rule ID 21203 //
     /*  966221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  966224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  966232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  966235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  966238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  966241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  966248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966260 */     // MIs[0] policy
     /*  966260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966270 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /*  966273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966291 */     GIR_RootConstrainSelectedInstOperands,
     /*  966292 */     // GIR_Coverage, 21203,
     /*  966292 */     GIR_EraseRootFromParent_Done,
     /*  966293 */   // Label 14475: @966293
     /*  966293 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(966370), // Rule ID 21206 //
     /*  966298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  966301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  966309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  966312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  966315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  966318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  966325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966337 */     // MIs[0] policy
     /*  966337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966347 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10979:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /*  966350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966368 */     GIR_RootConstrainSelectedInstOperands,
     /*  966369 */     // GIR_Coverage, 21206,
     /*  966369 */     GIR_EraseRootFromParent_Done,
     /*  966370 */   // Label 14476: @966370
     /*  966370 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(966447), // Rule ID 21207 //
     /*  966375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  966378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  966386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  966389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  966392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  966395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  966402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966414 */     // MIs[0] policy
     /*  966414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10979:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /*  966427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966445 */     GIR_RootConstrainSelectedInstOperands,
     /*  966446 */     // GIR_Coverage, 21207,
     /*  966446 */     GIR_EraseRootFromParent_Done,
     /*  966447 */   // Label 14477: @966447
     /*  966447 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(966524), // Rule ID 21210 //
     /*  966452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  966455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  966469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  966472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966491 */     // MIs[0] policy
     /*  966491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966501 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /*  966504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966522 */     GIR_RootConstrainSelectedInstOperands,
     /*  966523 */     // GIR_Coverage, 21210,
     /*  966523 */     GIR_EraseRootFromParent_Done,
     /*  966524 */   // Label 14478: @966524
     /*  966524 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(966601), // Rule ID 21211 //
     /*  966529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  966532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  966546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  966549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966568 */     // MIs[0] policy
     /*  966568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966578 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /*  966581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966599 */     GIR_RootConstrainSelectedInstOperands,
     /*  966600 */     // GIR_Coverage, 21211,
     /*  966600 */     GIR_EraseRootFromParent_Done,
     /*  966601 */   // Label 14479: @966601
     /*  966601 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(966678), // Rule ID 21214 //
     /*  966606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  966609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  966626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966645 */     // MIs[0] policy
     /*  966645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966655 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /*  966658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966676 */     GIR_RootConstrainSelectedInstOperands,
     /*  966677 */     // GIR_Coverage, 21214,
     /*  966677 */     GIR_EraseRootFromParent_Done,
     /*  966678 */   // Label 14480: @966678
     /*  966678 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(966755), // Rule ID 21215 //
     /*  966683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  966686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  966703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966722 */     // MIs[0] policy
     /*  966722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966732 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /*  966735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966753 */     GIR_RootConstrainSelectedInstOperands,
     /*  966754 */     // GIR_Coverage, 21215,
     /*  966754 */     GIR_EraseRootFromParent_Done,
     /*  966755 */   // Label 14481: @966755
     /*  966755 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(966832), // Rule ID 21218 //
     /*  966760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  966763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  966780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966799 */     // MIs[0] policy
     /*  966799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966809 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /*  966812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966830 */     GIR_RootConstrainSelectedInstOperands,
     /*  966831 */     // GIR_Coverage, 21218,
     /*  966831 */     GIR_EraseRootFromParent_Done,
     /*  966832 */   // Label 14482: @966832
     /*  966832 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(966909), // Rule ID 21219 //
     /*  966837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  966840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  966857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  966860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966876 */     // MIs[0] policy
     /*  966876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  966886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /*  966889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966907 */     GIR_RootConstrainSelectedInstOperands,
     /*  966908 */     // GIR_Coverage, 21219,
     /*  966908 */     GIR_EraseRootFromParent_Done,
     /*  966909 */   // Label 14483: @966909
     /*  966909 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(966986), // Rule ID 21222 //
     /*  966914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  966917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  966925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  966928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  966931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  966934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  966937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  966941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966953 */     // MIs[0] policy
     /*  966953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  966956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966963 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  966963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /*  966966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  966972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  966974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  966984 */     GIR_RootConstrainSelectedInstOperands,
     /*  966985 */     // GIR_Coverage, 21222,
     /*  966985 */     GIR_EraseRootFromParent_Done,
     /*  966986 */   // Label 14484: @966986
     /*  966986 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(967063), // Rule ID 21223 //
     /*  966991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  966994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  966999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  967002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  967005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  967008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  967011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967030 */     // MIs[0] policy
     /*  967030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967040 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10979:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /*  967043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967061 */     GIR_RootConstrainSelectedInstOperands,
     /*  967062 */     // GIR_Coverage, 21223,
     /*  967062 */     GIR_EraseRootFromParent_Done,
     /*  967063 */   // Label 14485: @967063
     /*  967063 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(967140), // Rule ID 21226 //
     /*  967068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  967071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  967079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  967082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  967085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  967088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967107 */     // MIs[0] policy
     /*  967107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967117 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /*  967120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967138 */     GIR_RootConstrainSelectedInstOperands,
     /*  967139 */     // GIR_Coverage, 21226,
     /*  967139 */     GIR_EraseRootFromParent_Done,
     /*  967140 */   // Label 14486: @967140
     /*  967140 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(967217), // Rule ID 21227 //
     /*  967145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  967148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  967156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  967159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  967162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  967165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967184 */     // MIs[0] policy
     /*  967184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967194 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10979:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /*  967197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967215 */     GIR_RootConstrainSelectedInstOperands,
     /*  967216 */     // GIR_Coverage, 21227,
     /*  967216 */     GIR_EraseRootFromParent_Done,
     /*  967217 */   // Label 14487: @967217
     /*  967217 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(967294), // Rule ID 21230 //
     /*  967222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  967225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  967242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967261 */     // MIs[0] policy
     /*  967261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967271 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /*  967274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967292 */     GIR_RootConstrainSelectedInstOperands,
     /*  967293 */     // GIR_Coverage, 21230,
     /*  967293 */     GIR_EraseRootFromParent_Done,
     /*  967294 */   // Label 14488: @967294
     /*  967294 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(967371), // Rule ID 21231 //
     /*  967299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  967302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  967319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967338 */     // MIs[0] policy
     /*  967338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10979:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /*  967351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967369 */     GIR_RootConstrainSelectedInstOperands,
     /*  967370 */     // GIR_Coverage, 21231,
     /*  967370 */     GIR_EraseRootFromParent_Done,
     /*  967371 */   // Label 14489: @967371
     /*  967371 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(967448), // Rule ID 21234 //
     /*  967376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  967379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  967396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967415 */     // MIs[0] policy
     /*  967415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967425 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /*  967428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967446 */     GIR_RootConstrainSelectedInstOperands,
     /*  967447 */     // GIR_Coverage, 21234,
     /*  967447 */     GIR_EraseRootFromParent_Done,
     /*  967448 */   // Label 14490: @967448
     /*  967448 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(967525), // Rule ID 21235 //
     /*  967453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  967456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /*  967461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  967473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967492 */     // MIs[0] policy
     /*  967492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10979:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /*  967505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967523 */     GIR_RootConstrainSelectedInstOperands,
     /*  967524 */     // GIR_Coverage, 21235,
     /*  967524 */     GIR_EraseRootFromParent_Done,
     /*  967525 */   // Label 14491: @967525
     /*  967525 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(967602), // Rule ID 21238 //
     /*  967530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  967533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  967541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  967544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  967550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967569 */     // MIs[0] policy
     /*  967569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967579 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /*  967582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967600 */     GIR_RootConstrainSelectedInstOperands,
     /*  967601 */     // GIR_Coverage, 21238,
     /*  967601 */     GIR_EraseRootFromParent_Done,
     /*  967602 */   // Label 14492: @967602
     /*  967602 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(967679), // Rule ID 21239 //
     /*  967607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  967610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  967618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  967621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  967627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967646 */     // MIs[0] policy
     /*  967646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967656 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /*  967659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967677 */     GIR_RootConstrainSelectedInstOperands,
     /*  967678 */     // GIR_Coverage, 21239,
     /*  967678 */     GIR_EraseRootFromParent_Done,
     /*  967679 */   // Label 14493: @967679
     /*  967679 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(967756), // Rule ID 21242 //
     /*  967684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  967687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  967695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  967698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  967704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967723 */     // MIs[0] policy
     /*  967723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967733 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /*  967736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967754 */     GIR_RootConstrainSelectedInstOperands,
     /*  967755 */     // GIR_Coverage, 21242,
     /*  967755 */     GIR_EraseRootFromParent_Done,
     /*  967756 */   // Label 14494: @967756
     /*  967756 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(967833), // Rule ID 21243 //
     /*  967761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  967764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  967772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  967775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  967781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967800 */     // MIs[0] policy
     /*  967800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967810 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /*  967813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967831 */     GIR_RootConstrainSelectedInstOperands,
     /*  967832 */     // GIR_Coverage, 21243,
     /*  967832 */     GIR_EraseRootFromParent_Done,
     /*  967833 */   // Label 14495: @967833
     /*  967833 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(967910), // Rule ID 21246 //
     /*  967838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  967841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  967849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  967852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  967858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  967861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967877 */     // MIs[0] policy
     /*  967877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967887 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  967887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /*  967890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967908 */     GIR_RootConstrainSelectedInstOperands,
     /*  967909 */     // GIR_Coverage, 21246,
     /*  967909 */     GIR_EraseRootFromParent_Done,
     /*  967910 */   // Label 14496: @967910
     /*  967910 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(967987), // Rule ID 21247 //
     /*  967915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  967918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  967923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  967926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  967929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  967935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  967938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  967942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967954 */     // MIs[0] policy
     /*  967954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  967957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10977:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  967964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /*  967967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  967973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  967975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  967985 */     GIR_RootConstrainSelectedInstOperands,
     /*  967986 */     // GIR_Coverage, 21247,
     /*  967986 */     GIR_EraseRootFromParent_Done,
     /*  967987 */   // Label 14497: @967987
     /*  967987 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(968064), // Rule ID 21250 //
     /*  967992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  967995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  968003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  968006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  968012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  968019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968031 */     // MIs[0] policy
     /*  968031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /*  968044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968062 */     GIR_RootConstrainSelectedInstOperands,
     /*  968063 */     // GIR_Coverage, 21250,
     /*  968063 */     GIR_EraseRootFromParent_Done,
     /*  968064 */   // Label 14498: @968064
     /*  968064 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(968141), // Rule ID 21251 //
     /*  968069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  968072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  968080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  968083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  968089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  968096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968108 */     // MIs[0] policy
     /*  968108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /*  968121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968139 */     GIR_RootConstrainSelectedInstOperands,
     /*  968140 */     // GIR_Coverage, 21251,
     /*  968140 */     GIR_EraseRootFromParent_Done,
     /*  968141 */   // Label 14499: @968141
     /*  968141 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(968218), // Rule ID 21254 //
     /*  968146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  968149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  968157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  968160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  968163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  968166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  968173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968185 */     // MIs[0] policy
     /*  968185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968195 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /*  968198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968216 */     GIR_RootConstrainSelectedInstOperands,
     /*  968217 */     // GIR_Coverage, 21254,
     /*  968217 */     GIR_EraseRootFromParent_Done,
     /*  968218 */   // Label 14500: @968218
     /*  968218 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(968295), // Rule ID 21255 //
     /*  968223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  968226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  968234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  968237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  968240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  968243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  968250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968262 */     // MIs[0] policy
     /*  968262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968272 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /*  968275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968293 */     GIR_RootConstrainSelectedInstOperands,
     /*  968294 */     // GIR_Coverage, 21255,
     /*  968294 */     GIR_EraseRootFromParent_Done,
     /*  968295 */   // Label 14501: @968295
     /*  968295 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(968372), // Rule ID 21258 //
     /*  968300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  968303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  968311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  968314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  968317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  968320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  968327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968339 */     // MIs[0] policy
     /*  968339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968349 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /*  968352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968370 */     GIR_RootConstrainSelectedInstOperands,
     /*  968371 */     // GIR_Coverage, 21258,
     /*  968371 */     GIR_EraseRootFromParent_Done,
     /*  968372 */   // Label 14502: @968372
     /*  968372 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(968449), // Rule ID 21259 //
     /*  968377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  968380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  968388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  968391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  968394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  968397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  968404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968416 */     // MIs[0] policy
     /*  968416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968426 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /*  968429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968447 */     GIR_RootConstrainSelectedInstOperands,
     /*  968448 */     // GIR_Coverage, 21259,
     /*  968448 */     GIR_EraseRootFromParent_Done,
     /*  968449 */   // Label 14503: @968449
     /*  968449 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(968526), // Rule ID 21262 //
     /*  968454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  968457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  968465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  968468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  968474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  968481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968493 */     // MIs[0] policy
     /*  968493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968503 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /*  968506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968524 */     GIR_RootConstrainSelectedInstOperands,
     /*  968525 */     // GIR_Coverage, 21262,
     /*  968525 */     GIR_EraseRootFromParent_Done,
     /*  968526 */   // Label 14504: @968526
     /*  968526 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(968603), // Rule ID 21263 //
     /*  968531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  968534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  968542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  968545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  968551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  968558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968570 */     // MIs[0] policy
     /*  968570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968580 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /*  968583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968601 */     GIR_RootConstrainSelectedInstOperands,
     /*  968602 */     // GIR_Coverage, 21263,
     /*  968602 */     GIR_EraseRootFromParent_Done,
     /*  968603 */   // Label 14505: @968603
     /*  968603 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(968680), // Rule ID 21266 //
     /*  968608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  968611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  968619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  968622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  968628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  968635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968647 */     // MIs[0] policy
     /*  968647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968657 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10977:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /*  968660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968678 */     GIR_RootConstrainSelectedInstOperands,
     /*  968679 */     // GIR_Coverage, 21266,
     /*  968679 */     GIR_EraseRootFromParent_Done,
     /*  968680 */   // Label 14506: @968680
     /*  968680 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(968757), // Rule ID 21267 //
     /*  968685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  968688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  968696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  968699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  968705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  968712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968724 */     // MIs[0] policy
     /*  968724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10977:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /*  968737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968755 */     GIR_RootConstrainSelectedInstOperands,
     /*  968756 */     // GIR_Coverage, 21267,
     /*  968756 */     GIR_EraseRootFromParent_Done,
     /*  968757 */   // Label 14507: @968757
     /*  968757 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(968834), // Rule ID 21270 //
     /*  968762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  968765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  968773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  968776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  968782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  968789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968801 */     // MIs[0] policy
     /*  968801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968811 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /*  968814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968832 */     GIR_RootConstrainSelectedInstOperands,
     /*  968833 */     // GIR_Coverage, 21270,
     /*  968833 */     GIR_EraseRootFromParent_Done,
     /*  968834 */   // Label 14508: @968834
     /*  968834 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(968911), // Rule ID 21271 //
     /*  968839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  968842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  968850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  968853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  968859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  968862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  968866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968878 */     // MIs[0] policy
     /*  968878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968888 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  968888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /*  968891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968909 */     GIR_RootConstrainSelectedInstOperands,
     /*  968910 */     // GIR_Coverage, 21271,
     /*  968910 */     GIR_EraseRootFromParent_Done,
     /*  968911 */   // Label 14509: @968911
     /*  968911 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(968988), // Rule ID 21274 //
     /*  968916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  968919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  968924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  968927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  968930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  968933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  968936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  968939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  968943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  968951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968955 */     // MIs[0] policy
     /*  968955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  968958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968965 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  968965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /*  968968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  968974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  968976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  968986 */     GIR_RootConstrainSelectedInstOperands,
     /*  968987 */     // GIR_Coverage, 21274,
     /*  968987 */     GIR_EraseRootFromParent_Done,
     /*  968988 */   // Label 14510: @968988
     /*  968988 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(969065), // Rule ID 21275 //
     /*  968993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  968996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  969004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  969007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  969010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  969013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  969020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969032 */     // MIs[0] policy
     /*  969032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969042 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /*  969045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969063 */     GIR_RootConstrainSelectedInstOperands,
     /*  969064 */     // GIR_Coverage, 21275,
     /*  969064 */     GIR_EraseRootFromParent_Done,
     /*  969065 */   // Label 14511: @969065
     /*  969065 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(969142), // Rule ID 21278 //
     /*  969070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  969073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  969081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  969084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  969087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  969090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  969097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969109 */     // MIs[0] policy
     /*  969109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969119 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /*  969122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969140 */     GIR_RootConstrainSelectedInstOperands,
     /*  969141 */     // GIR_Coverage, 21278,
     /*  969141 */     GIR_EraseRootFromParent_Done,
     /*  969142 */   // Label 14512: @969142
     /*  969142 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(969219), // Rule ID 21279 //
     /*  969147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  969150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  969158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  969161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  969164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  969167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  969174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969186 */     // MIs[0] policy
     /*  969186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969196 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /*  969199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969217 */     GIR_RootConstrainSelectedInstOperands,
     /*  969218 */     // GIR_Coverage, 21279,
     /*  969218 */     GIR_EraseRootFromParent_Done,
     /*  969219 */   // Label 14513: @969219
     /*  969219 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(969296), // Rule ID 21282 //
     /*  969224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  969227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  969235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  969238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  969244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  969251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969263 */     // MIs[0] policy
     /*  969263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969273 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /*  969276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969294 */     GIR_RootConstrainSelectedInstOperands,
     /*  969295 */     // GIR_Coverage, 21282,
     /*  969295 */     GIR_EraseRootFromParent_Done,
     /*  969296 */   // Label 14514: @969296
     /*  969296 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(969373), // Rule ID 21283 //
     /*  969301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  969304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  969312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  969315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  969321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  969328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969340 */     // MIs[0] policy
     /*  969340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969350 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10977:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /*  969353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969371 */     GIR_RootConstrainSelectedInstOperands,
     /*  969372 */     // GIR_Coverage, 21283,
     /*  969372 */     GIR_EraseRootFromParent_Done,
     /*  969373 */   // Label 14515: @969373
     /*  969373 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(969450), // Rule ID 21286 //
     /*  969378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  969381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  969389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  969392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  969398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  969405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969417 */     // MIs[0] policy
     /*  969417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969427 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /*  969430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969448 */     GIR_RootConstrainSelectedInstOperands,
     /*  969449 */     // GIR_Coverage, 21286,
     /*  969449 */     GIR_EraseRootFromParent_Done,
     /*  969450 */   // Label 14516: @969450
     /*  969450 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(969527), // Rule ID 21287 //
     /*  969455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  969458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  969466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  969469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  969475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  969482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969494 */     // MIs[0] policy
     /*  969494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10977:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /*  969507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969525 */     GIR_RootConstrainSelectedInstOperands,
     /*  969526 */     // GIR_Coverage, 21287,
     /*  969526 */     GIR_EraseRootFromParent_Done,
     /*  969527 */   // Label 14517: @969527
     /*  969527 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(969604), // Rule ID 21290 //
     /*  969532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  969535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  969543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  969546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  969549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  969552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  969559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969571 */     // MIs[0] policy
     /*  969571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969581 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /*  969584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969602 */     GIR_RootConstrainSelectedInstOperands,
     /*  969603 */     // GIR_Coverage, 21290,
     /*  969603 */     GIR_EraseRootFromParent_Done,
     /*  969604 */   // Label 14518: @969604
     /*  969604 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(969681), // Rule ID 21291 //
     /*  969609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  969612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  969620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  969623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  969626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  969629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  969636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969648 */     // MIs[0] policy
     /*  969648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969658 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10977:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /*  969661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969679 */     GIR_RootConstrainSelectedInstOperands,
     /*  969680 */     // GIR_Coverage, 21291,
     /*  969680 */     GIR_EraseRootFromParent_Done,
     /*  969681 */   // Label 14519: @969681
     /*  969681 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(969758), // Rule ID 21294 //
     /*  969686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  969689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  969697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  969700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  969703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  969706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  969713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969725 */     // MIs[0] policy
     /*  969725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969735 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /*  969738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969756 */     GIR_RootConstrainSelectedInstOperands,
     /*  969757 */     // GIR_Coverage, 21294,
     /*  969757 */     GIR_EraseRootFromParent_Done,
     /*  969758 */   // Label 14520: @969758
     /*  969758 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(969835), // Rule ID 21295 //
     /*  969763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  969766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /*  969771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  969774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  969777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  969780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  969783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  969790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969802 */     // MIs[0] policy
     /*  969802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969812 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10977:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /*  969815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969833 */     GIR_RootConstrainSelectedInstOperands,
     /*  969834 */     // GIR_Coverage, 21295,
     /*  969834 */     GIR_EraseRootFromParent_Done,
     /*  969835 */   // Label 14521: @969835
     /*  969835 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(969912), // Rule ID 21298 //
     /*  969840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  969843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  969848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  969851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  969854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  969857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  969860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  969863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  969867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969879 */     // MIs[0] policy
     /*  969879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969889 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10975:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  969889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /*  969892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969910 */     GIR_RootConstrainSelectedInstOperands,
     /*  969911 */     // GIR_Coverage, 21298,
     /*  969911 */     GIR_EraseRootFromParent_Done,
     /*  969912 */   // Label 14522: @969912
     /*  969912 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(969989), // Rule ID 21299 //
     /*  969917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  969920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  969925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  969928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  969931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  969934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  969937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  969940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  969944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969956 */     // MIs[0] policy
     /*  969956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  969959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969966 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10975:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  969966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /*  969969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  969975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  969977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  969987 */     GIR_RootConstrainSelectedInstOperands,
     /*  969988 */     // GIR_Coverage, 21299,
     /*  969988 */     GIR_EraseRootFromParent_Done,
     /*  969989 */   // Label 14523: @969989
     /*  969989 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(970066), // Rule ID 21302 //
     /*  969994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  969997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  970005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  970008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  970011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  970014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  970021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970033 */     // MIs[0] policy
     /*  970033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970043 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10975:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /*  970046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970064 */     GIR_RootConstrainSelectedInstOperands,
     /*  970065 */     // GIR_Coverage, 21302,
     /*  970065 */     GIR_EraseRootFromParent_Done,
     /*  970066 */   // Label 14524: @970066
     /*  970066 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(970143), // Rule ID 21303 //
     /*  970071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  970074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  970082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  970085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  970088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  970091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  970098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970110 */     // MIs[0] policy
     /*  970110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970120 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10975:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /*  970123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970141 */     GIR_RootConstrainSelectedInstOperands,
     /*  970142 */     // GIR_Coverage, 21303,
     /*  970142 */     GIR_EraseRootFromParent_Done,
     /*  970143 */   // Label 14525: @970143
     /*  970143 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(970220), // Rule ID 21306 //
     /*  970148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  970151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  970159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  970162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  970165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  970168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  970175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970187 */     // MIs[0] policy
     /*  970187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970197 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10975:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /*  970200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970218 */     GIR_RootConstrainSelectedInstOperands,
     /*  970219 */     // GIR_Coverage, 21306,
     /*  970219 */     GIR_EraseRootFromParent_Done,
     /*  970220 */   // Label 14526: @970220
     /*  970220 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(970297), // Rule ID 21307 //
     /*  970225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  970228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  970236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  970239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  970242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  970245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  970252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970264 */     // MIs[0] policy
     /*  970264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970274 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10975:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /*  970277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970295 */     GIR_RootConstrainSelectedInstOperands,
     /*  970296 */     // GIR_Coverage, 21307,
     /*  970296 */     GIR_EraseRootFromParent_Done,
     /*  970297 */   // Label 14527: @970297
     /*  970297 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(970374), // Rule ID 21310 //
     /*  970302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  970305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  970313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  970316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  970322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  970329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970341 */     // MIs[0] policy
     /*  970341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970351 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10975:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /*  970354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970372 */     GIR_RootConstrainSelectedInstOperands,
     /*  970373 */     // GIR_Coverage, 21310,
     /*  970373 */     GIR_EraseRootFromParent_Done,
     /*  970374 */   // Label 14528: @970374
     /*  970374 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(970451), // Rule ID 21311 //
     /*  970379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  970382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  970390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  970393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  970399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  970406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970418 */     // MIs[0] policy
     /*  970418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970428 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10975:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /*  970431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970449 */     GIR_RootConstrainSelectedInstOperands,
     /*  970450 */     // GIR_Coverage, 21311,
     /*  970450 */     GIR_EraseRootFromParent_Done,
     /*  970451 */   // Label 14529: @970451
     /*  970451 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(970528), // Rule ID 21314 //
     /*  970456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  970459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  970467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  970470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  970476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  970483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970495 */     // MIs[0] policy
     /*  970495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970505 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10975:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /*  970508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970526 */     GIR_RootConstrainSelectedInstOperands,
     /*  970527 */     // GIR_Coverage, 21314,
     /*  970527 */     GIR_EraseRootFromParent_Done,
     /*  970528 */   // Label 14530: @970528
     /*  970528 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(970605), // Rule ID 21315 //
     /*  970533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  970536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  970544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  970547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  970553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  970560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970572 */     // MIs[0] policy
     /*  970572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970582 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10975:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /*  970585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970603 */     GIR_RootConstrainSelectedInstOperands,
     /*  970604 */     // GIR_Coverage, 21315,
     /*  970604 */     GIR_EraseRootFromParent_Done,
     /*  970605 */   // Label 14531: @970605
     /*  970605 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(970682), // Rule ID 21318 //
     /*  970610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  970613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  970621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  970624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  970627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  970630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  970637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970649 */     // MIs[0] policy
     /*  970649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970659 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10975:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /*  970662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970680 */     GIR_RootConstrainSelectedInstOperands,
     /*  970681 */     // GIR_Coverage, 21318,
     /*  970681 */     GIR_EraseRootFromParent_Done,
     /*  970682 */   // Label 14532: @970682
     /*  970682 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(970759), // Rule ID 21319 //
     /*  970687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  970690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  970698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  970701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  970704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  970707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  970714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970726 */     // MIs[0] policy
     /*  970726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10975:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /*  970739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970757 */     GIR_RootConstrainSelectedInstOperands,
     /*  970758 */     // GIR_Coverage, 21319,
     /*  970758 */     GIR_EraseRootFromParent_Done,
     /*  970759 */   // Label 14533: @970759
     /*  970759 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(970836), // Rule ID 21322 //
     /*  970764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  970767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  970775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  970778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  970781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  970784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  970791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970803 */     // MIs[0] policy
     /*  970803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10975:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /*  970816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970834 */     GIR_RootConstrainSelectedInstOperands,
     /*  970835 */     // GIR_Coverage, 21322,
     /*  970835 */     GIR_EraseRootFromParent_Done,
     /*  970836 */   // Label 14534: @970836
     /*  970836 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(970913), // Rule ID 21323 //
     /*  970841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  970844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  970852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  970855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  970858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  970861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  970864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  970868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970880 */     // MIs[0] policy
     /*  970880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10975:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  970890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /*  970893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970911 */     GIR_RootConstrainSelectedInstOperands,
     /*  970912 */     // GIR_Coverage, 21323,
     /*  970912 */     GIR_EraseRootFromParent_Done,
     /*  970913 */   // Label 14535: @970913
     /*  970913 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(970990), // Rule ID 21326 //
     /*  970918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  970921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  970926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  970929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  970932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  970938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  970941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  970945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970957 */     // MIs[0] policy
     /*  970957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  970960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970967 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10975:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  970967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /*  970970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  970976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  970978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  970988 */     GIR_RootConstrainSelectedInstOperands,
     /*  970989 */     // GIR_Coverage, 21326,
     /*  970989 */     GIR_EraseRootFromParent_Done,
     /*  970990 */   // Label 14536: @970990
     /*  970990 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(971067), // Rule ID 21327 //
     /*  970995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  970998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  971003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  971006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  971009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  971015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  971022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971034 */     // MIs[0] policy
     /*  971034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971044 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10975:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /*  971047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971065 */     GIR_RootConstrainSelectedInstOperands,
     /*  971066 */     // GIR_Coverage, 21327,
     /*  971066 */     GIR_EraseRootFromParent_Done,
     /*  971067 */   // Label 14537: @971067
     /*  971067 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(971144), // Rule ID 21330 //
     /*  971072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  971075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  971080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  971083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  971086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  971092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  971099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971111 */     // MIs[0] policy
     /*  971111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971121 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10975:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /*  971124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971142 */     GIR_RootConstrainSelectedInstOperands,
     /*  971143 */     // GIR_Coverage, 21330,
     /*  971143 */     GIR_EraseRootFromParent_Done,
     /*  971144 */   // Label 14538: @971144
     /*  971144 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(971221), // Rule ID 21331 //
     /*  971149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  971152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /*  971157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  971160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  971163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  971169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  971176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971188 */     // MIs[0] policy
     /*  971188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971198 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10975:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /*  971201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971219 */     GIR_RootConstrainSelectedInstOperands,
     /*  971220 */     // GIR_Coverage, 21331,
     /*  971220 */     GIR_EraseRootFromParent_Done,
     /*  971221 */   // Label 14539: @971221
     /*  971221 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(971298), // Rule ID 21574 //
     /*  971226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  971237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  971240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  971243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  971246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971265 */     // MIs[0] policy
     /*  971265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971275 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /*  971278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971296 */     GIR_RootConstrainSelectedInstOperands,
     /*  971297 */     // GIR_Coverage, 21574,
     /*  971297 */     GIR_EraseRootFromParent_Done,
     /*  971298 */   // Label 14540: @971298
     /*  971298 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(971375), // Rule ID 21575 //
     /*  971303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  971306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  971314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  971317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  971320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  971323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971342 */     // MIs[0] policy
     /*  971342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /*  971355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971373 */     GIR_RootConstrainSelectedInstOperands,
     /*  971374 */     // GIR_Coverage, 21575,
     /*  971374 */     GIR_EraseRootFromParent_Done,
     /*  971375 */   // Label 14541: @971375
     /*  971375 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(971452), // Rule ID 21578 //
     /*  971380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  971391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  971394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  971397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  971400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971419 */     // MIs[0] policy
     /*  971419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /*  971432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971450 */     GIR_RootConstrainSelectedInstOperands,
     /*  971451 */     // GIR_Coverage, 21578,
     /*  971451 */     GIR_EraseRootFromParent_Done,
     /*  971452 */   // Label 14542: @971452
     /*  971452 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(971529), // Rule ID 21579 //
     /*  971457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  971460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  971468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  971471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  971474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  971477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971496 */     // MIs[0] policy
     /*  971496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /*  971509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971527 */     GIR_RootConstrainSelectedInstOperands,
     /*  971528 */     // GIR_Coverage, 21579,
     /*  971528 */     GIR_EraseRootFromParent_Done,
     /*  971529 */   // Label 14543: @971529
     /*  971529 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(971606), // Rule ID 21582 //
     /*  971534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  971545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  971548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  971551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  971554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971573 */     // MIs[0] policy
     /*  971573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  971586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971604 */     GIR_RootConstrainSelectedInstOperands,
     /*  971605 */     // GIR_Coverage, 21582,
     /*  971605 */     GIR_EraseRootFromParent_Done,
     /*  971606 */   // Label 14544: @971606
     /*  971606 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(971683), // Rule ID 21583 //
     /*  971611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  971614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  971622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  971625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  971628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  971631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971650 */     // MIs[0] policy
     /*  971650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971660 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  971663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971681 */     GIR_RootConstrainSelectedInstOperands,
     /*  971682 */     // GIR_Coverage, 21583,
     /*  971682 */     GIR_EraseRootFromParent_Done,
     /*  971683 */   // Label 14545: @971683
     /*  971683 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(971760), // Rule ID 21586 //
     /*  971688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  971699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  971702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  971705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  971708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971727 */     // MIs[0] policy
     /*  971727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971737 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  971740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971758 */     GIR_RootConstrainSelectedInstOperands,
     /*  971759 */     // GIR_Coverage, 21586,
     /*  971759 */     GIR_EraseRootFromParent_Done,
     /*  971760 */   // Label 14546: @971760
     /*  971760 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(971837), // Rule ID 21587 //
     /*  971765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  971768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  971776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  971779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  971782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  971785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  971792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971804 */     // MIs[0] policy
     /*  971804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10925:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  971817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971835 */     GIR_RootConstrainSelectedInstOperands,
     /*  971836 */     // GIR_Coverage, 21587,
     /*  971836 */     GIR_EraseRootFromParent_Done,
     /*  971837 */   // Label 14547: @971837
     /*  971837 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(971914), // Rule ID 21590 //
     /*  971842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  971853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  971856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  971862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  971865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  971869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971881 */     // MIs[0] policy
     /*  971881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  971891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  971894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971912 */     GIR_RootConstrainSelectedInstOperands,
     /*  971913 */     // GIR_Coverage, 21590,
     /*  971913 */     GIR_EraseRootFromParent_Done,
     /*  971914 */   // Label 14548: @971914
     /*  971914 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(971991), // Rule ID 21591 //
     /*  971919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  971922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  971927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  971930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  971933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  971939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  971942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  971946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971958 */     // MIs[0] policy
     /*  971958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  971961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  971968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  971971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  971977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  971979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  971989 */     GIR_RootConstrainSelectedInstOperands,
     /*  971990 */     // GIR_Coverage, 21591,
     /*  971990 */     GIR_EraseRootFromParent_Done,
     /*  971991 */   // Label 14549: @971991
     /*  971991 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(972068), // Rule ID 21594 //
     /*  971996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  971999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  972007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  972010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  972013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  972016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  972023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972035 */     // MIs[0] policy
     /*  972035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972045 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  972048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972066 */     GIR_RootConstrainSelectedInstOperands,
     /*  972067 */     // GIR_Coverage, 21594,
     /*  972067 */     GIR_EraseRootFromParent_Done,
     /*  972068 */   // Label 14550: @972068
     /*  972068 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(972145), // Rule ID 21595 //
     /*  972073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  972076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  972084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  972087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  972090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  972093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  972100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972112 */     // MIs[0] policy
     /*  972112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  972125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972143 */     GIR_RootConstrainSelectedInstOperands,
     /*  972144 */     // GIR_Coverage, 21595,
     /*  972144 */     GIR_EraseRootFromParent_Done,
     /*  972145 */   // Label 14551: @972145
     /*  972145 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(972222), // Rule ID 21598 //
     /*  972150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  972153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  972161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  972164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  972170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972189 */     // MIs[0] policy
     /*  972189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972199 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /*  972202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972220 */     GIR_RootConstrainSelectedInstOperands,
     /*  972221 */     // GIR_Coverage, 21598,
     /*  972221 */     GIR_EraseRootFromParent_Done,
     /*  972222 */   // Label 14552: @972222
     /*  972222 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(972299), // Rule ID 21599 //
     /*  972227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  972230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  972238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  972241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  972247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972266 */     // MIs[0] policy
     /*  972266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /*  972279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972297 */     GIR_RootConstrainSelectedInstOperands,
     /*  972298 */     // GIR_Coverage, 21599,
     /*  972298 */     GIR_EraseRootFromParent_Done,
     /*  972299 */   // Label 14553: @972299
     /*  972299 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(972376), // Rule ID 21602 //
     /*  972304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  972307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  972315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  972318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  972321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  972324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972343 */     // MIs[0] policy
     /*  972343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972353 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  972356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972374 */     GIR_RootConstrainSelectedInstOperands,
     /*  972375 */     // GIR_Coverage, 21602,
     /*  972375 */     GIR_EraseRootFromParent_Done,
     /*  972376 */   // Label 14554: @972376
     /*  972376 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(972453), // Rule ID 21603 //
     /*  972381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  972384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  972392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  972395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  972398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  972401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972420 */     // MIs[0] policy
     /*  972420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  972433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972451 */     GIR_RootConstrainSelectedInstOperands,
     /*  972452 */     // GIR_Coverage, 21603,
     /*  972452 */     GIR_EraseRootFromParent_Done,
     /*  972453 */   // Label 14555: @972453
     /*  972453 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(972530), // Rule ID 21606 //
     /*  972458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  972461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  972469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  972472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  972475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  972478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972497 */     // MIs[0] policy
     /*  972497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  972510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972528 */     GIR_RootConstrainSelectedInstOperands,
     /*  972529 */     // GIR_Coverage, 21606,
     /*  972529 */     GIR_EraseRootFromParent_Done,
     /*  972530 */   // Label 14556: @972530
     /*  972530 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(972607), // Rule ID 21607 //
     /*  972535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  972538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  972546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  972549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  972552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  972555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972574 */     // MIs[0] policy
     /*  972574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10925:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  972587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972605 */     GIR_RootConstrainSelectedInstOperands,
     /*  972606 */     // GIR_Coverage, 21607,
     /*  972606 */     GIR_EraseRootFromParent_Done,
     /*  972607 */   // Label 14557: @972607
     /*  972607 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(972684), // Rule ID 21610 //
     /*  972612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  972615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  972623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  972626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  972629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  972632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  972639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972651 */     // MIs[0] policy
     /*  972651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  972664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972682 */     GIR_RootConstrainSelectedInstOperands,
     /*  972683 */     // GIR_Coverage, 21610,
     /*  972683 */     GIR_EraseRootFromParent_Done,
     /*  972684 */   // Label 14558: @972684
     /*  972684 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(972761), // Rule ID 21611 //
     /*  972689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  972692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  972700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  972703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  972706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  972709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  972716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972728 */     // MIs[0] policy
     /*  972728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  972741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972759 */     GIR_RootConstrainSelectedInstOperands,
     /*  972760 */     // GIR_Coverage, 21611,
     /*  972760 */     GIR_EraseRootFromParent_Done,
     /*  972761 */   // Label 14559: @972761
     /*  972761 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(972838), // Rule ID 21614 //
     /*  972766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  972769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  972777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  972780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  972783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  972786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  972793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972805 */     // MIs[0] policy
     /*  972805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  972818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972836 */     GIR_RootConstrainSelectedInstOperands,
     /*  972837 */     // GIR_Coverage, 21614,
     /*  972837 */     GIR_EraseRootFromParent_Done,
     /*  972838 */   // Label 14560: @972838
     /*  972838 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(972915), // Rule ID 21615 //
     /*  972843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  972846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  972854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  972857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  972860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  972863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  972866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  972870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972882 */     // MIs[0] policy
     /*  972882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  972892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  972895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972913 */     GIR_RootConstrainSelectedInstOperands,
     /*  972914 */     // GIR_Coverage, 21615,
     /*  972914 */     GIR_EraseRootFromParent_Done,
     /*  972915 */   // Label 14561: @972915
     /*  972915 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(972992), // Rule ID 21618 //
     /*  972920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  972923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  972928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  972931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  972934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  972937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  972940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  972943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  972947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972959 */     // MIs[0] policy
     /*  972959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  972962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  972969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  972972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  972978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  972980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  972990 */     GIR_RootConstrainSelectedInstOperands,
     /*  972991 */     // GIR_Coverage, 21618,
     /*  972991 */     GIR_EraseRootFromParent_Done,
     /*  972992 */   // Label 14562: @972992
     /*  972992 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(973069), // Rule ID 21619 //
     /*  972997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  973000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  973008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  973011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  973017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973036 */     // MIs[0] policy
     /*  973036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /*  973049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973067 */     GIR_RootConstrainSelectedInstOperands,
     /*  973068 */     // GIR_Coverage, 21619,
     /*  973068 */     GIR_EraseRootFromParent_Done,
     /*  973069 */   // Label 14563: @973069
     /*  973069 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(973146), // Rule ID 21622 //
     /*  973074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  973077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  973085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  973088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  973091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  973094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973113 */     // MIs[0] policy
     /*  973113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973123 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  973126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973144 */     GIR_RootConstrainSelectedInstOperands,
     /*  973145 */     // GIR_Coverage, 21622,
     /*  973145 */     GIR_EraseRootFromParent_Done,
     /*  973146 */   // Label 14564: @973146
     /*  973146 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(973223), // Rule ID 21623 //
     /*  973151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  973154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  973162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  973165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  973168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  973171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973190 */     // MIs[0] policy
     /*  973190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /*  973203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973221 */     GIR_RootConstrainSelectedInstOperands,
     /*  973222 */     // GIR_Coverage, 21623,
     /*  973222 */     GIR_EraseRootFromParent_Done,
     /*  973223 */   // Label 14565: @973223
     /*  973223 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(973300), // Rule ID 21626 //
     /*  973228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  973231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  973239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  973242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  973245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  973248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  973255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973267 */     // MIs[0] policy
     /*  973267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  973280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973298 */     GIR_RootConstrainSelectedInstOperands,
     /*  973299 */     // GIR_Coverage, 21626,
     /*  973299 */     GIR_EraseRootFromParent_Done,
     /*  973300 */   // Label 14566: @973300
     /*  973300 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(973377), // Rule ID 21627 //
     /*  973305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  973308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  973316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  973319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  973322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  973325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  973332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973344 */     // MIs[0] policy
     /*  973344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /*  973357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973375 */     GIR_RootConstrainSelectedInstOperands,
     /*  973376 */     // GIR_Coverage, 21627,
     /*  973376 */     GIR_EraseRootFromParent_Done,
     /*  973377 */   // Label 14567: @973377
     /*  973377 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(973454), // Rule ID 21630 //
     /*  973382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  973385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  973393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  973396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  973399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  973402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  973409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  973417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973421 */     // MIs[0] policy
     /*  973421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973431 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  973434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973452 */     GIR_RootConstrainSelectedInstOperands,
     /*  973453 */     // GIR_Coverage, 21630,
     /*  973453 */     GIR_EraseRootFromParent_Done,
     /*  973454 */   // Label 14568: @973454
     /*  973454 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(973531), // Rule ID 21631 //
     /*  973459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  973462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /*  973467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  973470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  973473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  973476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  973479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  973486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  973494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973498 */     // MIs[0] policy
     /*  973498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /*  973511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973529 */     GIR_RootConstrainSelectedInstOperands,
     /*  973530 */     // GIR_Coverage, 21631,
     /*  973530 */     GIR_EraseRootFromParent_Done,
     /*  973531 */   // Label 14569: @973531
     /*  973531 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(973608), // Rule ID 21634 //
     /*  973536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  973539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  973547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  973550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  973556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973575 */     // MIs[0] policy
     /*  973575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973585 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /*  973588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973606 */     GIR_RootConstrainSelectedInstOperands,
     /*  973607 */     // GIR_Coverage, 21634,
     /*  973607 */     GIR_EraseRootFromParent_Done,
     /*  973608 */   // Label 14570: @973608
     /*  973608 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(973685), // Rule ID 21635 //
     /*  973613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  973616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  973624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  973627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  973633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973652 */     // MIs[0] policy
     /*  973652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /*  973665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973683 */     GIR_RootConstrainSelectedInstOperands,
     /*  973684 */     // GIR_Coverage, 21635,
     /*  973684 */     GIR_EraseRootFromParent_Done,
     /*  973685 */   // Label 14571: @973685
     /*  973685 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(973762), // Rule ID 21638 //
     /*  973690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  973693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  973701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  973704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  973710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973729 */     // MIs[0] policy
     /*  973729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973739 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /*  973742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973760 */     GIR_RootConstrainSelectedInstOperands,
     /*  973761 */     // GIR_Coverage, 21638,
     /*  973761 */     GIR_EraseRootFromParent_Done,
     /*  973762 */   // Label 14572: @973762
     /*  973762 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(973839), // Rule ID 21639 //
     /*  973767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  973770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  973778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  973781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  973787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973806 */     // MIs[0] policy
     /*  973806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /*  973819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973837 */     GIR_RootConstrainSelectedInstOperands,
     /*  973838 */     // GIR_Coverage, 21639,
     /*  973838 */     GIR_EraseRootFromParent_Done,
     /*  973839 */   // Label 14573: @973839
     /*  973839 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(973916), // Rule ID 21642 //
     /*  973844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  973847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  973855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  973858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  973864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  973867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973883 */     // MIs[0] policy
     /*  973883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  973893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  973896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973914 */     GIR_RootConstrainSelectedInstOperands,
     /*  973915 */     // GIR_Coverage, 21642,
     /*  973915 */     GIR_EraseRootFromParent_Done,
     /*  973916 */   // Label 14574: @973916
     /*  973916 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(973993), // Rule ID 21643 //
     /*  973921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  973924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  973929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  973932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  973935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  973941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  973944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  973948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973960 */     // MIs[0] policy
     /*  973960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  973963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  973970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  973973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  973979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  973981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  973991 */     GIR_RootConstrainSelectedInstOperands,
     /*  973992 */     // GIR_Coverage, 21643,
     /*  973992 */     GIR_EraseRootFromParent_Done,
     /*  973993 */   // Label 14575: @973993
     /*  973993 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(974070), // Rule ID 21646 //
     /*  973998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  974001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  974009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  974012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  974018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974037 */     // MIs[0] policy
     /*  974037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974047 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  974050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974068 */     GIR_RootConstrainSelectedInstOperands,
     /*  974069 */     // GIR_Coverage, 21646,
     /*  974069 */     GIR_EraseRootFromParent_Done,
     /*  974070 */   // Label 14576: @974070
     /*  974070 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(974147), // Rule ID 21647 //
     /*  974075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  974078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  974086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  974089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  974095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974114 */     // MIs[0] policy
     /*  974114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10923:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  974127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974145 */     GIR_RootConstrainSelectedInstOperands,
     /*  974146 */     // GIR_Coverage, 21647,
     /*  974146 */     GIR_EraseRootFromParent_Done,
     /*  974147 */   // Label 14577: @974147
     /*  974147 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(974224), // Rule ID 21650 //
     /*  974152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  974155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  974163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  974166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  974172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  974179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974191 */     // MIs[0] policy
     /*  974191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  974204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974222 */     GIR_RootConstrainSelectedInstOperands,
     /*  974223 */     // GIR_Coverage, 21650,
     /*  974223 */     GIR_EraseRootFromParent_Done,
     /*  974224 */   // Label 14578: @974224
     /*  974224 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(974301), // Rule ID 21651 //
     /*  974229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  974232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  974240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  974243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  974249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  974256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974268 */     // MIs[0] policy
     /*  974268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  974281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974299 */     GIR_RootConstrainSelectedInstOperands,
     /*  974300 */     // GIR_Coverage, 21651,
     /*  974300 */     GIR_EraseRootFromParent_Done,
     /*  974301 */   // Label 14579: @974301
     /*  974301 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(974378), // Rule ID 21654 //
     /*  974306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  974309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  974317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  974320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  974326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  974333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974345 */     // MIs[0] policy
     /*  974345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974355 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  974358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974376 */     GIR_RootConstrainSelectedInstOperands,
     /*  974377 */     // GIR_Coverage, 21654,
     /*  974377 */     GIR_EraseRootFromParent_Done,
     /*  974378 */   // Label 14580: @974378
     /*  974378 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(974455), // Rule ID 21655 //
     /*  974383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  974386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  974394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  974397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  974403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  974410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974422 */     // MIs[0] policy
     /*  974422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  974435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974453 */     GIR_RootConstrainSelectedInstOperands,
     /*  974454 */     // GIR_Coverage, 21655,
     /*  974454 */     GIR_EraseRootFromParent_Done,
     /*  974455 */   // Label 14581: @974455
     /*  974455 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(974532), // Rule ID 21658 //
     /*  974460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  974463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  974471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  974474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  974477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  974480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974499 */     // MIs[0] policy
     /*  974499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /*  974512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974530 */     GIR_RootConstrainSelectedInstOperands,
     /*  974531 */     // GIR_Coverage, 21658,
     /*  974531 */     GIR_EraseRootFromParent_Done,
     /*  974532 */   // Label 14582: @974532
     /*  974532 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(974609), // Rule ID 21659 //
     /*  974537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  974540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  974548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  974551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  974554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  974557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974576 */     // MIs[0] policy
     /*  974576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /*  974589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974607 */     GIR_RootConstrainSelectedInstOperands,
     /*  974608 */     // GIR_Coverage, 21659,
     /*  974608 */     GIR_EraseRootFromParent_Done,
     /*  974609 */   // Label 14583: @974609
     /*  974609 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(974686), // Rule ID 21662 //
     /*  974614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  974617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  974625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  974628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  974634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974653 */     // MIs[0] policy
     /*  974653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974663 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  974666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974684 */     GIR_RootConstrainSelectedInstOperands,
     /*  974685 */     // GIR_Coverage, 21662,
     /*  974685 */     GIR_EraseRootFromParent_Done,
     /*  974686 */   // Label 14584: @974686
     /*  974686 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(974763), // Rule ID 21663 //
     /*  974691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  974694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  974702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  974705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  974711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974730 */     // MIs[0] policy
     /*  974730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  974743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974761 */     GIR_RootConstrainSelectedInstOperands,
     /*  974762 */     // GIR_Coverage, 21663,
     /*  974762 */     GIR_EraseRootFromParent_Done,
     /*  974763 */   // Label 14585: @974763
     /*  974763 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(974840), // Rule ID 21666 //
     /*  974768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  974771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  974779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  974782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  974788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974807 */     // MIs[0] policy
     /*  974807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974817 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  974820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974838 */     GIR_RootConstrainSelectedInstOperands,
     /*  974839 */     // GIR_Coverage, 21666,
     /*  974839 */     GIR_EraseRootFromParent_Done,
     /*  974840 */   // Label 14586: @974840
     /*  974840 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(974917), // Rule ID 21667 //
     /*  974845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  974848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  974856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  974859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  974865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  974868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  974872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974884 */     // MIs[0] policy
     /*  974884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10923:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  974894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  974897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974915 */     GIR_RootConstrainSelectedInstOperands,
     /*  974916 */     // GIR_Coverage, 21667,
     /*  974916 */     GIR_EraseRootFromParent_Done,
     /*  974917 */   // Label 14587: @974917
     /*  974917 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(974994), // Rule ID 21670 //
     /*  974922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  974925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  974930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  974933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  974936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  974939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  974942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  974945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  974949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974961 */     // MIs[0] policy
     /*  974961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  974964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  974971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  974974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  974980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  974982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  974992 */     GIR_RootConstrainSelectedInstOperands,
     /*  974993 */     // GIR_Coverage, 21670,
     /*  974993 */     GIR_EraseRootFromParent_Done,
     /*  974994 */   // Label 14588: @974994
     /*  974994 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(975071), // Rule ID 21671 //
     /*  974999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  975002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  975010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  975013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  975019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  975026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975038 */     // MIs[0] policy
     /*  975038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  975051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975069 */     GIR_RootConstrainSelectedInstOperands,
     /*  975070 */     // GIR_Coverage, 21671,
     /*  975070 */     GIR_EraseRootFromParent_Done,
     /*  975071 */   // Label 14589: @975071
     /*  975071 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(975148), // Rule ID 21674 //
     /*  975076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  975079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  975087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  975090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  975096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  975103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975115 */     // MIs[0] policy
     /*  975115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975125 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  975128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975146 */     GIR_RootConstrainSelectedInstOperands,
     /*  975147 */     // GIR_Coverage, 21674,
     /*  975147 */     GIR_EraseRootFromParent_Done,
     /*  975148 */   // Label 14590: @975148
     /*  975148 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(975225), // Rule ID 21675 //
     /*  975153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  975156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  975164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  975167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  975173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  975180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975192 */     // MIs[0] policy
     /*  975192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  975205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975223 */     GIR_RootConstrainSelectedInstOperands,
     /*  975224 */     // GIR_Coverage, 21675,
     /*  975224 */     GIR_EraseRootFromParent_Done,
     /*  975225 */   // Label 14591: @975225
     /*  975225 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(975302), // Rule ID 21678 //
     /*  975230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  975233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  975241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  975244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  975247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  975250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975269 */     // MIs[0] policy
     /*  975269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975279 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  975282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975300 */     GIR_RootConstrainSelectedInstOperands,
     /*  975301 */     // GIR_Coverage, 21678,
     /*  975301 */     GIR_EraseRootFromParent_Done,
     /*  975302 */   // Label 14592: @975302
     /*  975302 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(975379), // Rule ID 21679 //
     /*  975307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  975310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  975318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  975321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  975324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  975327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975346 */     // MIs[0] policy
     /*  975346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /*  975359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975377 */     GIR_RootConstrainSelectedInstOperands,
     /*  975378 */     // GIR_Coverage, 21679,
     /*  975378 */     GIR_EraseRootFromParent_Done,
     /*  975379 */   // Label 14593: @975379
     /*  975379 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(975456), // Rule ID 21682 //
     /*  975384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  975387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  975395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  975398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  975404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975423 */     // MIs[0] policy
     /*  975423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  975436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975454 */     GIR_RootConstrainSelectedInstOperands,
     /*  975455 */     // GIR_Coverage, 21682,
     /*  975455 */     GIR_EraseRootFromParent_Done,
     /*  975456 */   // Label 14594: @975456
     /*  975456 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(975533), // Rule ID 21683 //
     /*  975461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  975464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  975472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  975475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  975481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975500 */     // MIs[0] policy
     /*  975500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /*  975513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975531 */     GIR_RootConstrainSelectedInstOperands,
     /*  975532 */     // GIR_Coverage, 21683,
     /*  975532 */     GIR_EraseRootFromParent_Done,
     /*  975533 */   // Label 14595: @975533
     /*  975533 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(975610), // Rule ID 21686 //
     /*  975538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  975541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  975549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  975552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  975558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  975565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975577 */     // MIs[0] policy
     /*  975577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  975590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975608 */     GIR_RootConstrainSelectedInstOperands,
     /*  975609 */     // GIR_Coverage, 21686,
     /*  975609 */     GIR_EraseRootFromParent_Done,
     /*  975610 */   // Label 14596: @975610
     /*  975610 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(975687), // Rule ID 21687 //
     /*  975615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  975618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  975626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  975629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  975635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  975642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975654 */     // MIs[0] policy
     /*  975654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /*  975667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975685 */     GIR_RootConstrainSelectedInstOperands,
     /*  975686 */     // GIR_Coverage, 21687,
     /*  975686 */     GIR_EraseRootFromParent_Done,
     /*  975687 */   // Label 14597: @975687
     /*  975687 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(975764), // Rule ID 21690 //
     /*  975692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  975695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  975703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  975706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  975712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  975719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975731 */     // MIs[0] policy
     /*  975731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975741 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  975744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975762 */     GIR_RootConstrainSelectedInstOperands,
     /*  975763 */     // GIR_Coverage, 21690,
     /*  975763 */     GIR_EraseRootFromParent_Done,
     /*  975764 */   // Label 14598: @975764
     /*  975764 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(975841), // Rule ID 21691 //
     /*  975769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  975772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /*  975777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  975780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  975783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  975789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  975796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975808 */     // MIs[0] policy
     /*  975808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /*  975821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975839 */     GIR_RootConstrainSelectedInstOperands,
     /*  975840 */     // GIR_Coverage, 21691,
     /*  975840 */     GIR_EraseRootFromParent_Done,
     /*  975841 */   // Label 14599: @975841
     /*  975841 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(975918), // Rule ID 21802 //
     /*  975846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  975849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  975854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  975857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  975860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  975863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  975866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  975869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975885 */     // MIs[0] policy
     /*  975885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975895 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  975895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /*  975898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975916 */     GIR_RootConstrainSelectedInstOperands,
     /*  975917 */     // GIR_Coverage, 21802,
     /*  975917 */     GIR_EraseRootFromParent_Done,
     /*  975918 */   // Label 14600: @975918
     /*  975918 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(975995), // Rule ID 21803 //
     /*  975923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  975926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  975931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  975934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  975937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  975940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  975943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  975946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  975950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975962 */     // MIs[0] policy
     /*  975962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  975965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975972 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  975972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /*  975975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  975981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  975983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  975993 */     GIR_RootConstrainSelectedInstOperands,
     /*  975994 */     // GIR_Coverage, 21803,
     /*  975994 */     GIR_EraseRootFromParent_Done,
     /*  975995 */   // Label 14601: @975995
     /*  975995 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(976072), // Rule ID 21806 //
     /*  976000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  976003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  976011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  976014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  976017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  976020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976039 */     // MIs[0] policy
     /*  976039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976049 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /*  976052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976070 */     GIR_RootConstrainSelectedInstOperands,
     /*  976071 */     // GIR_Coverage, 21806,
     /*  976071 */     GIR_EraseRootFromParent_Done,
     /*  976072 */   // Label 14602: @976072
     /*  976072 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(976149), // Rule ID 21807 //
     /*  976077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  976080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  976088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  976091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  976094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  976097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976116 */     // MIs[0] policy
     /*  976116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976126 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /*  976129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976147 */     GIR_RootConstrainSelectedInstOperands,
     /*  976148 */     // GIR_Coverage, 21807,
     /*  976148 */     GIR_EraseRootFromParent_Done,
     /*  976149 */   // Label 14603: @976149
     /*  976149 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(976226), // Rule ID 21810 //
     /*  976154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  976157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  976165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  976168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  976171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  976174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976193 */     // MIs[0] policy
     /*  976193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976203 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /*  976206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976224 */     GIR_RootConstrainSelectedInstOperands,
     /*  976225 */     // GIR_Coverage, 21810,
     /*  976225 */     GIR_EraseRootFromParent_Done,
     /*  976226 */   // Label 14604: @976226
     /*  976226 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(976303), // Rule ID 21811 //
     /*  976231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  976234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  976242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  976245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  976248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  976251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976270 */     // MIs[0] policy
     /*  976270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10921:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /*  976283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976301 */     GIR_RootConstrainSelectedInstOperands,
     /*  976302 */     // GIR_Coverage, 21811,
     /*  976302 */     GIR_EraseRootFromParent_Done,
     /*  976303 */   // Label 14605: @976303
     /*  976303 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(976380), // Rule ID 21814 //
     /*  976308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  976311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  976319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  976322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  976325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  976328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  976335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976347 */     // MIs[0] policy
     /*  976347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976357 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10921:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /*  976360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976378 */     GIR_RootConstrainSelectedInstOperands,
     /*  976379 */     // GIR_Coverage, 21814,
     /*  976379 */     GIR_EraseRootFromParent_Done,
     /*  976380 */   // Label 14606: @976380
     /*  976380 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(976457), // Rule ID 21815 //
     /*  976385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  976388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  976396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  976399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  976402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  976405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  976412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976424 */     // MIs[0] policy
     /*  976424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10921:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /*  976437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976455 */     GIR_RootConstrainSelectedInstOperands,
     /*  976456 */     // GIR_Coverage, 21815,
     /*  976456 */     GIR_EraseRootFromParent_Done,
     /*  976457 */   // Label 14607: @976457
     /*  976457 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(976534), // Rule ID 21818 //
     /*  976462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  976465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  976473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  976476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  976479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  976482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  976489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976501 */     // MIs[0] policy
     /*  976501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976511 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10921:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /*  976514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976532 */     GIR_RootConstrainSelectedInstOperands,
     /*  976533 */     // GIR_Coverage, 21818,
     /*  976533 */     GIR_EraseRootFromParent_Done,
     /*  976534 */   // Label 14608: @976534
     /*  976534 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(976611), // Rule ID 21819 //
     /*  976539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  976542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  976550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  976553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  976556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  976559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  976566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976578 */     // MIs[0] policy
     /*  976578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976588 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10921:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /*  976591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976609 */     GIR_RootConstrainSelectedInstOperands,
     /*  976610 */     // GIR_Coverage, 21819,
     /*  976610 */     GIR_EraseRootFromParent_Done,
     /*  976611 */   // Label 14609: @976611
     /*  976611 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(976688), // Rule ID 21822 //
     /*  976616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  976619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  976627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  976630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  976633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  976636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976655 */     // MIs[0] policy
     /*  976655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976665 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /*  976668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976686 */     GIR_RootConstrainSelectedInstOperands,
     /*  976687 */     // GIR_Coverage, 21822,
     /*  976687 */     GIR_EraseRootFromParent_Done,
     /*  976688 */   // Label 14610: @976688
     /*  976688 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(976765), // Rule ID 21823 //
     /*  976693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  976696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  976704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  976707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  976710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  976713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976732 */     // MIs[0] policy
     /*  976732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976742 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /*  976745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976763 */     GIR_RootConstrainSelectedInstOperands,
     /*  976764 */     // GIR_Coverage, 21823,
     /*  976764 */     GIR_EraseRootFromParent_Done,
     /*  976765 */   // Label 14611: @976765
     /*  976765 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(976842), // Rule ID 21826 //
     /*  976770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  976773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  976781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  976784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  976790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976809 */     // MIs[0] policy
     /*  976809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /*  976822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976840 */     GIR_RootConstrainSelectedInstOperands,
     /*  976841 */     // GIR_Coverage, 21826,
     /*  976841 */     GIR_EraseRootFromParent_Done,
     /*  976842 */   // Label 14612: @976842
     /*  976842 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(976919), // Rule ID 21827 //
     /*  976847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  976850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  976858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  976861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  976867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  976870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  976874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976886 */     // MIs[0] policy
     /*  976886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  976896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /*  976899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976917 */     GIR_RootConstrainSelectedInstOperands,
     /*  976918 */     // GIR_Coverage, 21827,
     /*  976918 */     GIR_EraseRootFromParent_Done,
     /*  976919 */   // Label 14613: @976919
     /*  976919 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(976996), // Rule ID 21830 //
     /*  976924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  976927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  976932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  976935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  976938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  976941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  976944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  976947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  976951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976963 */     // MIs[0] policy
     /*  976963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  976966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976973 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10921:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  976973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /*  976976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  976982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  976984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  976994 */     GIR_RootConstrainSelectedInstOperands,
     /*  976995 */     // GIR_Coverage, 21830,
     /*  976995 */     GIR_EraseRootFromParent_Done,
     /*  976996 */   // Label 14614: @976996
     /*  976996 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(977073), // Rule ID 21831 //
     /*  977001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  977004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  977009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  977012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  977015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  977018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  977021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  977028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  977036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977040 */     // MIs[0] policy
     /*  977040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10921:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /*  977053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977071 */     GIR_RootConstrainSelectedInstOperands,
     /*  977072 */     // GIR_Coverage, 21831,
     /*  977072 */     GIR_EraseRootFromParent_Done,
     /*  977073 */   // Label 14615: @977073
     /*  977073 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(977150), // Rule ID 21834 //
     /*  977078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  977081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  977086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  977089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  977092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  977095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  977098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  977105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  977109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  977113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977117 */     // MIs[0] policy
     /*  977117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977127 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10921:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /*  977130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977148 */     GIR_RootConstrainSelectedInstOperands,
     /*  977149 */     // GIR_Coverage, 21834,
     /*  977149 */     GIR_EraseRootFromParent_Done,
     /*  977150 */   // Label 14616: @977150
     /*  977150 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(977227), // Rule ID 21835 //
     /*  977155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  977158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /*  977163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  977166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  977169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  977172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  977175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  977182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  977186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  977190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977194 */     // MIs[0] policy
     /*  977194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977204 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10921:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /*  977207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977225 */     GIR_RootConstrainSelectedInstOperands,
     /*  977226 */     // GIR_Coverage, 21835,
     /*  977226 */     GIR_EraseRootFromParent_Done,
     /*  977227 */   // Label 14617: @977227
     /*  977227 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(977304), // Rule ID 23274 //
     /*  977232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  977243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  977246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  977249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  977252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977271 */     // MIs[0] policy
     /*  977271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977281 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /*  977284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977302 */     GIR_RootConstrainSelectedInstOperands,
     /*  977303 */     // GIR_Coverage, 23274,
     /*  977303 */     GIR_EraseRootFromParent_Done,
     /*  977304 */   // Label 14618: @977304
     /*  977304 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(977381), // Rule ID 23275 //
     /*  977309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  977320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  977323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  977326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  977329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977348 */     // MIs[0] policy
     /*  977348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /*  977361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977379 */     GIR_RootConstrainSelectedInstOperands,
     /*  977380 */     // GIR_Coverage, 23275,
     /*  977380 */     GIR_EraseRootFromParent_Done,
     /*  977381 */   // Label 14619: @977381
     /*  977381 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(977458), // Rule ID 23278 //
     /*  977386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  977397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  977400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  977403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  977406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977425 */     // MIs[0] policy
     /*  977425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977435 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977456 */     GIR_RootConstrainSelectedInstOperands,
     /*  977457 */     // GIR_Coverage, 23278,
     /*  977457 */     GIR_EraseRootFromParent_Done,
     /*  977458 */   // Label 14620: @977458
     /*  977458 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(977535), // Rule ID 23279 //
     /*  977463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  977474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  977477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  977480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  977483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977502 */     // MIs[0] policy
     /*  977502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977533 */     GIR_RootConstrainSelectedInstOperands,
     /*  977534 */     // GIR_Coverage, 23279,
     /*  977534 */     GIR_EraseRootFromParent_Done,
     /*  977535 */   // Label 14621: @977535
     /*  977535 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(977612), // Rule ID 23282 //
     /*  977540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  977551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  977554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  977557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  977560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977579 */     // MIs[0] policy
     /*  977579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /*  977592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977610 */     GIR_RootConstrainSelectedInstOperands,
     /*  977611 */     // GIR_Coverage, 23282,
     /*  977611 */     GIR_EraseRootFromParent_Done,
     /*  977612 */   // Label 14622: @977612
     /*  977612 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(977689), // Rule ID 23283 //
     /*  977617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  977628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  977631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  977634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  977637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977656 */     // MIs[0] policy
     /*  977656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /*  977669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977687 */     GIR_RootConstrainSelectedInstOperands,
     /*  977688 */     // GIR_Coverage, 23283,
     /*  977688 */     GIR_EraseRootFromParent_Done,
     /*  977689 */   // Label 14623: @977689
     /*  977689 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(977766), // Rule ID 23286 //
     /*  977694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  977705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  977708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  977711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  977714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977733 */     // MIs[0] policy
     /*  977733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977764 */     GIR_RootConstrainSelectedInstOperands,
     /*  977765 */     // GIR_Coverage, 23286,
     /*  977765 */     GIR_EraseRootFromParent_Done,
     /*  977766 */   // Label 14624: @977766
     /*  977766 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(977843), // Rule ID 23287 //
     /*  977771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  977782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  977785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  977788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  977791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977810 */     // MIs[0] policy
     /*  977810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977841 */     GIR_RootConstrainSelectedInstOperands,
     /*  977842 */     // GIR_Coverage, 23287,
     /*  977842 */     GIR_EraseRootFromParent_Done,
     /*  977843 */   // Label 14625: @977843
     /*  977843 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(977920), // Rule ID 23290 //
     /*  977848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  977859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  977862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  977865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  977868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  977871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977887 */     // MIs[0] policy
     /*  977887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977897 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  977897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977918 */     GIR_RootConstrainSelectedInstOperands,
     /*  977919 */     // GIR_Coverage, 23290,
     /*  977919 */     GIR_EraseRootFromParent_Done,
     /*  977920 */   // Label 14626: @977920
     /*  977920 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(977997), // Rule ID 23291 //
     /*  977925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  977933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  977936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  977939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  977942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  977945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  977948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  977952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977964 */     // MIs[0] policy
     /*  977964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  977967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  977974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /*  977977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  977983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  977985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  977995 */     GIR_RootConstrainSelectedInstOperands,
     /*  977996 */     // GIR_Coverage, 23291,
     /*  977996 */     GIR_EraseRootFromParent_Done,
     /*  977997 */   // Label 14627: @977997
     /*  977997 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(978074), // Rule ID 23294 //
     /*  978002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  978013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  978016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  978019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  978022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978041 */     // MIs[0] policy
     /*  978041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978051 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978072 */     GIR_RootConstrainSelectedInstOperands,
     /*  978073 */     // GIR_Coverage, 23294,
     /*  978073 */     GIR_EraseRootFromParent_Done,
     /*  978074 */   // Label 14628: @978074
     /*  978074 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(978151), // Rule ID 23295 //
     /*  978079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  978090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  978093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  978096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  978099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978118 */     // MIs[0] policy
     /*  978118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978149 */     GIR_RootConstrainSelectedInstOperands,
     /*  978150 */     // GIR_Coverage, 23295,
     /*  978150 */     GIR_EraseRootFromParent_Done,
     /*  978151 */   // Label 14629: @978151
     /*  978151 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(978228), // Rule ID 23298 //
     /*  978156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  978167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  978170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  978173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  978176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978195 */     // MIs[0] policy
     /*  978195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978205 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978226 */     GIR_RootConstrainSelectedInstOperands,
     /*  978227 */     // GIR_Coverage, 23298,
     /*  978227 */     GIR_EraseRootFromParent_Done,
     /*  978228 */   // Label 14630: @978228
     /*  978228 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(978305), // Rule ID 23299 //
     /*  978233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  978244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  978247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  978250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  978253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978272 */     // MIs[0] policy
     /*  978272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978303 */     GIR_RootConstrainSelectedInstOperands,
     /*  978304 */     // GIR_Coverage, 23299,
     /*  978304 */     GIR_EraseRootFromParent_Done,
     /*  978305 */   // Label 14631: @978305
     /*  978305 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(978382), // Rule ID 23302 //
     /*  978310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  978321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  978324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  978327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  978330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978349 */     // MIs[0] policy
     /*  978349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978380 */     GIR_RootConstrainSelectedInstOperands,
     /*  978381 */     // GIR_Coverage, 23302,
     /*  978381 */     GIR_EraseRootFromParent_Done,
     /*  978382 */   // Label 14632: @978382
     /*  978382 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(978459), // Rule ID 23303 //
     /*  978387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  978398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  978401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  978404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  978407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978426 */     // MIs[0] policy
     /*  978426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978457 */     GIR_RootConstrainSelectedInstOperands,
     /*  978458 */     // GIR_Coverage, 23303,
     /*  978458 */     GIR_EraseRootFromParent_Done,
     /*  978459 */   // Label 14633: @978459
     /*  978459 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(978536), // Rule ID 23306 //
     /*  978464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  978467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  978475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  978478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  978481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  978484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978503 */     // MIs[0] policy
     /*  978503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978513 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978534 */     GIR_RootConstrainSelectedInstOperands,
     /*  978535 */     // GIR_Coverage, 23306,
     /*  978535 */     GIR_EraseRootFromParent_Done,
     /*  978536 */   // Label 14634: @978536
     /*  978536 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(978613), // Rule ID 23307 //
     /*  978541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  978544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  978552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  978555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  978558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  978561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  978568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978580 */     // MIs[0] policy
     /*  978580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /*  978593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978611 */     GIR_RootConstrainSelectedInstOperands,
     /*  978612 */     // GIR_Coverage, 23307,
     /*  978612 */     GIR_EraseRootFromParent_Done,
     /*  978613 */   // Label 14635: @978613
     /*  978613 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(978690), // Rule ID 23310 //
     /*  978618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  978629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  978632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  978635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  978638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  978645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978657 */     // MIs[0] policy
     /*  978657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  978670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978688 */     GIR_RootConstrainSelectedInstOperands,
     /*  978689 */     // GIR_Coverage, 23310,
     /*  978689 */     GIR_EraseRootFromParent_Done,
     /*  978690 */   // Label 14636: @978690
     /*  978690 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(978767), // Rule ID 23311 //
     /*  978695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  978706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  978709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  978712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  978715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  978722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978734 */     // MIs[0] policy
     /*  978734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  978747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978765 */     GIR_RootConstrainSelectedInstOperands,
     /*  978766 */     // GIR_Coverage, 23311,
     /*  978766 */     GIR_EraseRootFromParent_Done,
     /*  978767 */   // Label 14637: @978767
     /*  978767 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(978844), // Rule ID 23314 //
     /*  978772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  978783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  978786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  978789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  978792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  978799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978811 */     // MIs[0] policy
     /*  978811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  978824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978842 */     GIR_RootConstrainSelectedInstOperands,
     /*  978843 */     // GIR_Coverage, 23314,
     /*  978843 */     GIR_EraseRootFromParent_Done,
     /*  978844 */   // Label 14638: @978844
     /*  978844 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(978921), // Rule ID 23315 //
     /*  978849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  978860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  978863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  978866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  978869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  978872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  978876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978888 */     // MIs[0] policy
     /*  978888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  978898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  978901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978919 */     GIR_RootConstrainSelectedInstOperands,
     /*  978920 */     // GIR_Coverage, 23315,
     /*  978920 */     GIR_EraseRootFromParent_Done,
     /*  978921 */   // Label 14639: @978921
     /*  978921 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(978998), // Rule ID 23318 //
     /*  978926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  978934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  978937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  978940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  978943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  978946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  978949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  978953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978965 */     // MIs[0] policy
     /*  978965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  978968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978975 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  978975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  978978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  978984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  978986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  978996 */     GIR_RootConstrainSelectedInstOperands,
     /*  978997 */     // GIR_Coverage, 23318,
     /*  978997 */     GIR_EraseRootFromParent_Done,
     /*  978998 */   // Label 14640: @978998
     /*  978998 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(979075), // Rule ID 23319 //
     /*  979003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  979014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  979017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  979020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  979023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  979030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979042 */     // MIs[0] policy
     /*  979042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  979055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979073 */     GIR_RootConstrainSelectedInstOperands,
     /*  979074 */     // GIR_Coverage, 23319,
     /*  979074 */     GIR_EraseRootFromParent_Done,
     /*  979075 */   // Label 14641: @979075
     /*  979075 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(979152), // Rule ID 23322 //
     /*  979080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  979091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  979094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  979097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  979100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  979107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979119 */     // MIs[0] policy
     /*  979119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  979132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979150 */     GIR_RootConstrainSelectedInstOperands,
     /*  979151 */     // GIR_Coverage, 23322,
     /*  979151 */     GIR_EraseRootFromParent_Done,
     /*  979152 */   // Label 14642: @979152
     /*  979152 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(979229), // Rule ID 23323 //
     /*  979157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  979168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  979171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  979174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  979177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  979184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979196 */     // MIs[0] policy
     /*  979196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  979209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979227 */     GIR_RootConstrainSelectedInstOperands,
     /*  979228 */     // GIR_Coverage, 23323,
     /*  979228 */     GIR_EraseRootFromParent_Done,
     /*  979229 */   // Label 14643: @979229
     /*  979229 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(979306), // Rule ID 23326 //
     /*  979234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  979245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  979248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  979251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  979254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  979261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979273 */     // MIs[0] policy
     /*  979273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979283 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  979286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979304 */     GIR_RootConstrainSelectedInstOperands,
     /*  979305 */     // GIR_Coverage, 23326,
     /*  979305 */     GIR_EraseRootFromParent_Done,
     /*  979306 */   // Label 14644: @979306
     /*  979306 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(979383), // Rule ID 23327 //
     /*  979311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  979322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  979325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  979328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  979331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  979338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979350 */     // MIs[0] policy
     /*  979350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  979363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979381 */     GIR_RootConstrainSelectedInstOperands,
     /*  979382 */     // GIR_Coverage, 23327,
     /*  979382 */     GIR_EraseRootFromParent_Done,
     /*  979383 */   // Label 14645: @979383
     /*  979383 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(979460), // Rule ID 23330 //
     /*  979388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  979399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  979402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  979405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  979408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  979415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979427 */     // MIs[0] policy
     /*  979427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979437 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  979440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979458 */     GIR_RootConstrainSelectedInstOperands,
     /*  979459 */     // GIR_Coverage, 23330,
     /*  979459 */     GIR_EraseRootFromParent_Done,
     /*  979460 */   // Label 14646: @979460
     /*  979460 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(979537), // Rule ID 23331 //
     /*  979465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  979476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  979479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  979482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  979485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  979492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979504 */     // MIs[0] policy
     /*  979504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  979517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979535 */     GIR_RootConstrainSelectedInstOperands,
     /*  979536 */     // GIR_Coverage, 23331,
     /*  979536 */     GIR_EraseRootFromParent_Done,
     /*  979537 */   // Label 14647: @979537
     /*  979537 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(979614), // Rule ID 23334 //
     /*  979542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  979553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  979556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  979559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  979562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  979569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979581 */     // MIs[0] policy
     /*  979581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  979594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979612 */     GIR_RootConstrainSelectedInstOperands,
     /*  979613 */     // GIR_Coverage, 23334,
     /*  979613 */     GIR_EraseRootFromParent_Done,
     /*  979614 */   // Label 14648: @979614
     /*  979614 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(979691), // Rule ID 23335 //
     /*  979619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  979630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  979633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  979636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  979639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  979646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979658 */     // MIs[0] policy
     /*  979658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  979671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979689 */     GIR_RootConstrainSelectedInstOperands,
     /*  979690 */     // GIR_Coverage, 23335,
     /*  979690 */     GIR_EraseRootFromParent_Done,
     /*  979691 */   // Label 14649: @979691
     /*  979691 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(979768), // Rule ID 23338 //
     /*  979696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  979707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  979710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  979713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  979716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  979723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979735 */     // MIs[0] policy
     /*  979735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979745 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  979748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979766 */     GIR_RootConstrainSelectedInstOperands,
     /*  979767 */     // GIR_Coverage, 23338,
     /*  979767 */     GIR_EraseRootFromParent_Done,
     /*  979768 */   // Label 14650: @979768
     /*  979768 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(979845), // Rule ID 23339 //
     /*  979773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  979784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  979787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  979790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  979793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  979800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979812 */     // MIs[0] policy
     /*  979812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  979825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979843 */     GIR_RootConstrainSelectedInstOperands,
     /*  979844 */     // GIR_Coverage, 23339,
     /*  979844 */     GIR_EraseRootFromParent_Done,
     /*  979845 */   // Label 14651: @979845
     /*  979845 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(979922), // Rule ID 23342 //
     /*  979850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  979861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  979864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  979867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  979870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  979873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  979877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979889 */     // MIs[0] policy
     /*  979889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979899 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  979899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  979902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979920 */     GIR_RootConstrainSelectedInstOperands,
     /*  979921 */     // GIR_Coverage, 23342,
     /*  979921 */     GIR_EraseRootFromParent_Done,
     /*  979922 */   // Label 14652: @979922
     /*  979922 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(979999), // Rule ID 23343 //
     /*  979927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  979935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  979938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  979941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  979944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  979947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  979950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  979954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979966 */     // MIs[0] policy
     /*  979966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  979969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979976 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  979976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  979979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  979985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  979987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  979997 */     GIR_RootConstrainSelectedInstOperands,
     /*  979998 */     // GIR_Coverage, 23343,
     /*  979998 */     GIR_EraseRootFromParent_Done,
     /*  979999 */   // Label 14653: @979999
     /*  979999 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(980076), // Rule ID 23346 //
     /*  980004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  980015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  980018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  980021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  980024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  980031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980043 */     // MIs[0] policy
     /*  980043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  980056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980074 */     GIR_RootConstrainSelectedInstOperands,
     /*  980075 */     // GIR_Coverage, 23346,
     /*  980075 */     GIR_EraseRootFromParent_Done,
     /*  980076 */   // Label 14654: @980076
     /*  980076 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(980153), // Rule ID 23347 //
     /*  980081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  980092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  980095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  980098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  980101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  980108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980120 */     // MIs[0] policy
     /*  980120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /*  980133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980151 */     GIR_RootConstrainSelectedInstOperands,
     /*  980152 */     // GIR_Coverage, 23347,
     /*  980152 */     GIR_EraseRootFromParent_Done,
     /*  980153 */   // Label 14655: @980153
     /*  980153 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(980230), // Rule ID 23350 //
     /*  980158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  980169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  980172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  980175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  980178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  980185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980197 */     // MIs[0] policy
     /*  980197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980207 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  980210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980228 */     GIR_RootConstrainSelectedInstOperands,
     /*  980229 */     // GIR_Coverage, 23350,
     /*  980229 */     GIR_EraseRootFromParent_Done,
     /*  980230 */   // Label 14656: @980230
     /*  980230 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(980307), // Rule ID 23351 //
     /*  980235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  980246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  980249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  980252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  980255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  980262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980274 */     // MIs[0] policy
     /*  980274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /*  980287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980305 */     GIR_RootConstrainSelectedInstOperands,
     /*  980306 */     // GIR_Coverage, 23351,
     /*  980306 */     GIR_EraseRootFromParent_Done,
     /*  980307 */   // Label 14657: @980307
     /*  980307 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(980384), // Rule ID 23354 //
     /*  980312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  980323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  980326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  980329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  980332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  980339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980351 */     // MIs[0] policy
     /*  980351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  980364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980382 */     GIR_RootConstrainSelectedInstOperands,
     /*  980383 */     // GIR_Coverage, 23354,
     /*  980383 */     GIR_EraseRootFromParent_Done,
     /*  980384 */   // Label 14658: @980384
     /*  980384 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(980461), // Rule ID 23355 //
     /*  980389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  980397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  980400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  980403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  980406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  980409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  980416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980428 */     // MIs[0] policy
     /*  980428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980438 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /*  980441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  980447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  980449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980459 */     GIR_RootConstrainSelectedInstOperands,
     /*  980460 */     // GIR_Coverage, 23355,
     /*  980460 */     GIR_EraseRootFromParent_Done,
     /*  980461 */   // Label 14659: @980461
     /*  980461 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(980538), // Rule ID 23460 //
     /*  980466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  980477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  980480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980505 */     // MIs[0] policy
     /*  980505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980515 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /*  980518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980536 */     GIR_RootConstrainSelectedInstOperands,
     /*  980537 */     // GIR_Coverage, 23460,
     /*  980537 */     GIR_EraseRootFromParent_Done,
     /*  980538 */   // Label 14660: @980538
     /*  980538 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(980615), // Rule ID 23461 //
     /*  980543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  980554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  980557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980582 */     // MIs[0] policy
     /*  980582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980592 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /*  980595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980613 */     GIR_RootConstrainSelectedInstOperands,
     /*  980614 */     // GIR_Coverage, 23461,
     /*  980614 */     GIR_EraseRootFromParent_Done,
     /*  980615 */   // Label 14661: @980615
     /*  980615 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(980692), // Rule ID 23464 //
     /*  980620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  980631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  980634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980659 */     // MIs[0] policy
     /*  980659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  980672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980690 */     GIR_RootConstrainSelectedInstOperands,
     /*  980691 */     // GIR_Coverage, 23464,
     /*  980691 */     GIR_EraseRootFromParent_Done,
     /*  980692 */   // Label 14662: @980692
     /*  980692 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(980769), // Rule ID 23465 //
     /*  980697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  980708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  980711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980736 */     // MIs[0] policy
     /*  980736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  980749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980767 */     GIR_RootConstrainSelectedInstOperands,
     /*  980768 */     // GIR_Coverage, 23465,
     /*  980768 */     GIR_EraseRootFromParent_Done,
     /*  980769 */   // Label 14663: @980769
     /*  980769 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(980846), // Rule ID 23468 //
     /*  980774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  980785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  980788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980813 */     // MIs[0] policy
     /*  980813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980823 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  980826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980844 */     GIR_RootConstrainSelectedInstOperands,
     /*  980845 */     // GIR_Coverage, 23468,
     /*  980845 */     GIR_EraseRootFromParent_Done,
     /*  980846 */   // Label 14664: @980846
     /*  980846 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(980923), // Rule ID 23469 //
     /*  980851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  980862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  980865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  980874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980890 */     // MIs[0] policy
     /*  980890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980900 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  980900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  980903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980921 */     GIR_RootConstrainSelectedInstOperands,
     /*  980922 */     // GIR_Coverage, 23469,
     /*  980922 */     GIR_EraseRootFromParent_Done,
     /*  980923 */   // Label 14665: @980923
     /*  980923 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(981000), // Rule ID 23472 //
     /*  980928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  980936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  980939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  980942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  980951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  980967 */     // MIs[0] policy
     /*  980967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  980970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  980977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  980980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  980984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  980988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  980998 */     GIR_RootConstrainSelectedInstOperands,
     /*  980999 */     // GIR_Coverage, 23472,
     /*  980999 */     GIR_EraseRootFromParent_Done,
     /*  981000 */   // Label 14666: @981000
     /*  981000 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(981077), // Rule ID 23473 //
     /*  981005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  981016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  981019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981044 */     // MIs[0] policy
     /*  981044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  981057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981075 */     GIR_RootConstrainSelectedInstOperands,
     /*  981076 */     // GIR_Coverage, 23473,
     /*  981076 */     GIR_EraseRootFromParent_Done,
     /*  981077 */   // Label 14667: @981077
     /*  981077 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(981154), // Rule ID 23476 //
     /*  981082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  981093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  981096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981121 */     // MIs[0] policy
     /*  981121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981131 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  981134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981152 */     GIR_RootConstrainSelectedInstOperands,
     /*  981153 */     // GIR_Coverage, 23476,
     /*  981153 */     GIR_EraseRootFromParent_Done,
     /*  981154 */   // Label 14668: @981154
     /*  981154 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(981231), // Rule ID 23477 //
     /*  981159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  981170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  981173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981198 */     // MIs[0] policy
     /*  981198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  981211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981229 */     GIR_RootConstrainSelectedInstOperands,
     /*  981230 */     // GIR_Coverage, 23477,
     /*  981230 */     GIR_EraseRootFromParent_Done,
     /*  981231 */   // Label 14669: @981231
     /*  981231 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(981308), // Rule ID 23480 //
     /*  981236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  981247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  981250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981275 */     // MIs[0] policy
     /*  981275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981285 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  981288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981306 */     GIR_RootConstrainSelectedInstOperands,
     /*  981307 */     // GIR_Coverage, 23480,
     /*  981307 */     GIR_EraseRootFromParent_Done,
     /*  981308 */   // Label 14670: @981308
     /*  981308 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(981385), // Rule ID 23481 //
     /*  981313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  981324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  981327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981352 */     // MIs[0] policy
     /*  981352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  981365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981383 */     GIR_RootConstrainSelectedInstOperands,
     /*  981384 */     // GIR_Coverage, 23481,
     /*  981384 */     GIR_EraseRootFromParent_Done,
     /*  981385 */   // Label 14671: @981385
     /*  981385 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(981462), // Rule ID 23484 //
     /*  981390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  981401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  981404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981429 */     // MIs[0] policy
     /*  981429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981460 */     GIR_RootConstrainSelectedInstOperands,
     /*  981461 */     // GIR_Coverage, 23484,
     /*  981461 */     GIR_EraseRootFromParent_Done,
     /*  981462 */   // Label 14672: @981462
     /*  981462 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(981539), // Rule ID 23485 //
     /*  981467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  981478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  981481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981506 */     // MIs[0] policy
     /*  981506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11242:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981537 */     GIR_RootConstrainSelectedInstOperands,
     /*  981538 */     // GIR_Coverage, 23485,
     /*  981538 */     GIR_EraseRootFromParent_Done,
     /*  981539 */   // Label 14673: @981539
     /*  981539 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(981616), // Rule ID 23488 //
     /*  981544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  981555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  981558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981583 */     // MIs[0] policy
     /*  981583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981593 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981614 */     GIR_RootConstrainSelectedInstOperands,
     /*  981615 */     // GIR_Coverage, 23488,
     /*  981615 */     GIR_EraseRootFromParent_Done,
     /*  981616 */   // Label 14674: @981616
     /*  981616 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(981693), // Rule ID 23489 //
     /*  981621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  981632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  981635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981660 */     // MIs[0] policy
     /*  981660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981691 */     GIR_RootConstrainSelectedInstOperands,
     /*  981692 */     // GIR_Coverage, 23489,
     /*  981692 */     GIR_EraseRootFromParent_Done,
     /*  981693 */   // Label 14675: @981693
     /*  981693 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(981770), // Rule ID 23492 //
     /*  981698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  981709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  981712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981737 */     // MIs[0] policy
     /*  981737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981768 */     GIR_RootConstrainSelectedInstOperands,
     /*  981769 */     // GIR_Coverage, 23492,
     /*  981769 */     GIR_EraseRootFromParent_Done,
     /*  981770 */   // Label 14676: @981770
     /*  981770 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(981847), // Rule ID 23493 //
     /*  981775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  981786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  981789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981814 */     // MIs[0] policy
     /*  981814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981845 */     GIR_RootConstrainSelectedInstOperands,
     /*  981846 */     // GIR_Coverage, 23493,
     /*  981846 */     GIR_EraseRootFromParent_Done,
     /*  981847 */   // Label 14677: @981847
     /*  981847 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(981924), // Rule ID 23496 //
     /*  981852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  981855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  981863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  981866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  981875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981891 */     // MIs[0] policy
     /*  981891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981901 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  981901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981922 */     GIR_RootConstrainSelectedInstOperands,
     /*  981923 */     // GIR_Coverage, 23496,
     /*  981923 */     GIR_EraseRootFromParent_Done,
     /*  981924 */   // Label 14678: @981924
     /*  981924 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(982001), // Rule ID 23497 //
     /*  981929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  981932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  981937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  981940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  981943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  981952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  981968 */     // MIs[0] policy
     /*  981968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  981971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  981978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  981981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  981985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  981989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  981999 */     GIR_RootConstrainSelectedInstOperands,
     /*  982000 */     // GIR_Coverage, 23497,
     /*  982000 */     GIR_EraseRootFromParent_Done,
     /*  982001 */   // Label 14679: @982001
     /*  982001 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(982078), // Rule ID 23500 //
     /*  982006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  982017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  982020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982045 */     // MIs[0] policy
     /*  982045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  982058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982076 */     GIR_RootConstrainSelectedInstOperands,
     /*  982077 */     // GIR_Coverage, 23500,
     /*  982077 */     GIR_EraseRootFromParent_Done,
     /*  982078 */   // Label 14680: @982078
     /*  982078 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(982155), // Rule ID 23501 //
     /*  982083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  982094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  982097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982122 */     // MIs[0] policy
     /*  982122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  982135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982153 */     GIR_RootConstrainSelectedInstOperands,
     /*  982154 */     // GIR_Coverage, 23501,
     /*  982154 */     GIR_EraseRootFromParent_Done,
     /*  982155 */   // Label 14681: @982155
     /*  982155 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(982232), // Rule ID 23504 //
     /*  982160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  982171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  982174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982199 */     // MIs[0] policy
     /*  982199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982209 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  982212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982230 */     GIR_RootConstrainSelectedInstOperands,
     /*  982231 */     // GIR_Coverage, 23504,
     /*  982231 */     GIR_EraseRootFromParent_Done,
     /*  982232 */   // Label 14682: @982232
     /*  982232 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(982309), // Rule ID 23505 //
     /*  982237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  982248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  982251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982276 */     // MIs[0] policy
     /*  982276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  982289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982307 */     GIR_RootConstrainSelectedInstOperands,
     /*  982308 */     // GIR_Coverage, 23505,
     /*  982308 */     GIR_EraseRootFromParent_Done,
     /*  982309 */   // Label 14683: @982309
     /*  982309 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(982386), // Rule ID 23508 //
     /*  982314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  982325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  982328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982353 */     // MIs[0] policy
     /*  982353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982363 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  982366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982384 */     GIR_RootConstrainSelectedInstOperands,
     /*  982385 */     // GIR_Coverage, 23508,
     /*  982385 */     GIR_EraseRootFromParent_Done,
     /*  982386 */   // Label 14684: @982386
     /*  982386 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(982463), // Rule ID 23509 //
     /*  982391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  982402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  982405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982430 */     // MIs[0] policy
     /*  982430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982440 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  982443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982461 */     GIR_RootConstrainSelectedInstOperands,
     /*  982462 */     // GIR_Coverage, 23509,
     /*  982462 */     GIR_EraseRootFromParent_Done,
     /*  982463 */   // Label 14685: @982463
     /*  982463 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(982540), // Rule ID 23512 //
     /*  982468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  982479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  982482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982507 */     // MIs[0] policy
     /*  982507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  982520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982538 */     GIR_RootConstrainSelectedInstOperands,
     /*  982539 */     // GIR_Coverage, 23512,
     /*  982539 */     GIR_EraseRootFromParent_Done,
     /*  982540 */   // Label 14686: @982540
     /*  982540 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(982617), // Rule ID 23513 //
     /*  982545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  982556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  982559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982584 */     // MIs[0] policy
     /*  982584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  982597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982615 */     GIR_RootConstrainSelectedInstOperands,
     /*  982616 */     // GIR_Coverage, 23513,
     /*  982616 */     GIR_EraseRootFromParent_Done,
     /*  982617 */   // Label 14687: @982617
     /*  982617 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(982694), // Rule ID 23516 //
     /*  982622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  982633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  982636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982661 */     // MIs[0] policy
     /*  982661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  982674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982692 */     GIR_RootConstrainSelectedInstOperands,
     /*  982693 */     // GIR_Coverage, 23516,
     /*  982693 */     GIR_EraseRootFromParent_Done,
     /*  982694 */   // Label 14688: @982694
     /*  982694 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(982771), // Rule ID 23517 //
     /*  982699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  982710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  982713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982738 */     // MIs[0] policy
     /*  982738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  982751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982769 */     GIR_RootConstrainSelectedInstOperands,
     /*  982770 */     // GIR_Coverage, 23517,
     /*  982770 */     GIR_EraseRootFromParent_Done,
     /*  982771 */   // Label 14689: @982771
     /*  982771 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(982848), // Rule ID 23520 //
     /*  982776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  982787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  982790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982815 */     // MIs[0] policy
     /*  982815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982825 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  982828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982846 */     GIR_RootConstrainSelectedInstOperands,
     /*  982847 */     // GIR_Coverage, 23520,
     /*  982847 */     GIR_EraseRootFromParent_Done,
     /*  982848 */   // Label 14690: @982848
     /*  982848 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(982925), // Rule ID 23521 //
     /*  982853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  982864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  982867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  982876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982892 */     // MIs[0] policy
     /*  982892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  982902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  982905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  982923 */     GIR_RootConstrainSelectedInstOperands,
     /*  982924 */     // GIR_Coverage, 23521,
     /*  982924 */     GIR_EraseRootFromParent_Done,
     /*  982925 */   // Label 14691: @982925
     /*  982925 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(983002), // Rule ID 23524 //
     /*  982930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  982938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  982941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  982944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  982947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  982953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  982969 */     // MIs[0] policy
     /*  982969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  982972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  982979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  982982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  982986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  982990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983000 */     GIR_RootConstrainSelectedInstOperands,
     /*  983001 */     // GIR_Coverage, 23524,
     /*  983001 */     GIR_EraseRootFromParent_Done,
     /*  983002 */   // Label 14692: @983002
     /*  983002 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(983079), // Rule ID 23525 //
     /*  983007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  983018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  983021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983046 */     // MIs[0] policy
     /*  983046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  983059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983077 */     GIR_RootConstrainSelectedInstOperands,
     /*  983078 */     // GIR_Coverage, 23525,
     /*  983078 */     GIR_EraseRootFromParent_Done,
     /*  983079 */   // Label 14693: @983079
     /*  983079 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(983156), // Rule ID 23528 //
     /*  983084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  983095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  983098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983123 */     // MIs[0] policy
     /*  983123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983133 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  983136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983154 */     GIR_RootConstrainSelectedInstOperands,
     /*  983155 */     // GIR_Coverage, 23528,
     /*  983155 */     GIR_EraseRootFromParent_Done,
     /*  983156 */   // Label 14694: @983156
     /*  983156 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(983233), // Rule ID 23529 //
     /*  983161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  983172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  983175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983200 */     // MIs[0] policy
     /*  983200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983210 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  983213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983231 */     GIR_RootConstrainSelectedInstOperands,
     /*  983232 */     // GIR_Coverage, 23529,
     /*  983232 */     GIR_EraseRootFromParent_Done,
     /*  983233 */   // Label 14695: @983233
     /*  983233 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(983310), // Rule ID 23532 //
     /*  983238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  983249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  983252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983277 */     // MIs[0] policy
     /*  983277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983287 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  983290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983308 */     GIR_RootConstrainSelectedInstOperands,
     /*  983309 */     // GIR_Coverage, 23532,
     /*  983309 */     GIR_EraseRootFromParent_Done,
     /*  983310 */   // Label 14696: @983310
     /*  983310 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(983387), // Rule ID 23533 //
     /*  983315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  983326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  983329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983354 */     // MIs[0] policy
     /*  983354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  983367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983385 */     GIR_RootConstrainSelectedInstOperands,
     /*  983386 */     // GIR_Coverage, 23533,
     /*  983386 */     GIR_EraseRootFromParent_Done,
     /*  983387 */   // Label 14697: @983387
     /*  983387 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(983464), // Rule ID 23536 //
     /*  983392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  983403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  983406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983431 */     // MIs[0] policy
     /*  983431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  983444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983462 */     GIR_RootConstrainSelectedInstOperands,
     /*  983463 */     // GIR_Coverage, 23536,
     /*  983463 */     GIR_EraseRootFromParent_Done,
     /*  983464 */   // Label 14698: @983464
     /*  983464 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(983541), // Rule ID 23537 //
     /*  983469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  983480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  983483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983508 */     // MIs[0] policy
     /*  983508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  983521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983539 */     GIR_RootConstrainSelectedInstOperands,
     /*  983540 */     // GIR_Coverage, 23537,
     /*  983540 */     GIR_EraseRootFromParent_Done,
     /*  983541 */   // Label 14699: @983541
     /*  983541 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(983618), // Rule ID 23540 //
     /*  983546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  983557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  983560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983585 */     // MIs[0] policy
     /*  983585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983595 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  983598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983616 */     GIR_RootConstrainSelectedInstOperands,
     /*  983617 */     // GIR_Coverage, 23540,
     /*  983617 */     GIR_EraseRootFromParent_Done,
     /*  983618 */   // Label 14700: @983618
     /*  983618 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(983695), // Rule ID 23541 //
     /*  983623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  983634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  983637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983662 */     // MIs[0] policy
     /*  983662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  983675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983693 */     GIR_RootConstrainSelectedInstOperands,
     /*  983694 */     // GIR_Coverage, 23541,
     /*  983694 */     GIR_EraseRootFromParent_Done,
     /*  983695 */   // Label 14701: @983695
     /*  983695 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(983772), // Rule ID 23544 //
     /*  983700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  983711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  983714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  983717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983739 */     // MIs[0] policy
     /*  983739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  983752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983770 */     GIR_RootConstrainSelectedInstOperands,
     /*  983771 */     // GIR_Coverage, 23544,
     /*  983771 */     GIR_EraseRootFromParent_Done,
     /*  983772 */   // Label 14702: @983772
     /*  983772 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(983849), // Rule ID 23545 //
     /*  983777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  983785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  983788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  983791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  983794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983816 */     // MIs[0] policy
     /*  983816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983826 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  983829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983847 */     GIR_RootConstrainSelectedInstOperands,
     /*  983848 */     // GIR_Coverage, 23545,
     /*  983848 */     GIR_EraseRootFromParent_Done,
     /*  983849 */   // Label 14703: @983849
     /*  983849 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(983926), // Rule ID 23636 //
     /*  983854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  983862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  983865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  983868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  983871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  983877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983893 */     // MIs[0] policy
     /*  983893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983903 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  983903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /*  983906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  983924 */     GIR_RootConstrainSelectedInstOperands,
     /*  983925 */     // GIR_Coverage, 23636,
     /*  983925 */     GIR_EraseRootFromParent_Done,
     /*  983926 */   // Label 14704: @983926
     /*  983926 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(984003), // Rule ID 23637 //
     /*  983931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  983939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  983942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  983945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  983948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  983954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  983970 */     // MIs[0] policy
     /*  983970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  983973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  983980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /*  983983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  983987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  983991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984001 */     GIR_RootConstrainSelectedInstOperands,
     /*  984002 */     // GIR_Coverage, 23637,
     /*  984002 */     GIR_EraseRootFromParent_Done,
     /*  984003 */   // Label 14705: @984003
     /*  984003 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(984080), // Rule ID 23640 //
     /*  984008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  984019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  984022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984047 */     // MIs[0] policy
     /*  984047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984057 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  984060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984078 */     GIR_RootConstrainSelectedInstOperands,
     /*  984079 */     // GIR_Coverage, 23640,
     /*  984079 */     GIR_EraseRootFromParent_Done,
     /*  984080 */   // Label 14706: @984080
     /*  984080 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(984157), // Rule ID 23641 //
     /*  984085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  984096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  984099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984124 */     // MIs[0] policy
     /*  984124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  984137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984155 */     GIR_RootConstrainSelectedInstOperands,
     /*  984156 */     // GIR_Coverage, 23641,
     /*  984156 */     GIR_EraseRootFromParent_Done,
     /*  984157 */   // Label 14707: @984157
     /*  984157 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(984234), // Rule ID 23644 //
     /*  984162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  984173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  984176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984201 */     // MIs[0] policy
     /*  984201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984211 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984232 */     GIR_RootConstrainSelectedInstOperands,
     /*  984233 */     // GIR_Coverage, 23644,
     /*  984233 */     GIR_EraseRootFromParent_Done,
     /*  984234 */   // Label 14708: @984234
     /*  984234 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(984311), // Rule ID 23645 //
     /*  984239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  984250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  984253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984278 */     // MIs[0] policy
     /*  984278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984309 */     GIR_RootConstrainSelectedInstOperands,
     /*  984310 */     // GIR_Coverage, 23645,
     /*  984310 */     GIR_EraseRootFromParent_Done,
     /*  984311 */   // Label 14709: @984311
     /*  984311 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(984388), // Rule ID 23648 //
     /*  984316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  984327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  984330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984355 */     // MIs[0] policy
     /*  984355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984365 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  984368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984386 */     GIR_RootConstrainSelectedInstOperands,
     /*  984387 */     // GIR_Coverage, 23648,
     /*  984387 */     GIR_EraseRootFromParent_Done,
     /*  984388 */   // Label 14710: @984388
     /*  984388 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(984465), // Rule ID 23649 //
     /*  984393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  984404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  984407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984432 */     // MIs[0] policy
     /*  984432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984442 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  984445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984463 */     GIR_RootConstrainSelectedInstOperands,
     /*  984464 */     // GIR_Coverage, 23649,
     /*  984464 */     GIR_EraseRootFromParent_Done,
     /*  984465 */   // Label 14711: @984465
     /*  984465 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(984542), // Rule ID 23652 //
     /*  984470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  984481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  984484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  984487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984509 */     // MIs[0] policy
     /*  984509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984540 */     GIR_RootConstrainSelectedInstOperands,
     /*  984541 */     // GIR_Coverage, 23652,
     /*  984541 */     GIR_EraseRootFromParent_Done,
     /*  984542 */   // Label 14712: @984542
     /*  984542 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(984619), // Rule ID 23653 //
     /*  984547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  984558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  984561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  984564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984586 */     // MIs[0] policy
     /*  984586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984617 */     GIR_RootConstrainSelectedInstOperands,
     /*  984618 */     // GIR_Coverage, 23653,
     /*  984618 */     GIR_EraseRootFromParent_Done,
     /*  984619 */   // Label 14713: @984619
     /*  984619 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(984696), // Rule ID 23656 //
     /*  984624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  984635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  984638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  984641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984663 */     // MIs[0] policy
     /*  984663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984673 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984694 */     GIR_RootConstrainSelectedInstOperands,
     /*  984695 */     // GIR_Coverage, 23656,
     /*  984695 */     GIR_EraseRootFromParent_Done,
     /*  984696 */   // Label 14714: @984696
     /*  984696 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(984773), // Rule ID 23657 //
     /*  984701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  984712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  984715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  984718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984740 */     // MIs[0] policy
     /*  984740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  984753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984771 */     GIR_RootConstrainSelectedInstOperands,
     /*  984772 */     // GIR_Coverage, 23657,
     /*  984772 */     GIR_EraseRootFromParent_Done,
     /*  984773 */   // Label 14715: @984773
     /*  984773 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(984850), // Rule ID 23660 //
     /*  984778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  984789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  984792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  984795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984817 */     // MIs[0] policy
     /*  984817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  984830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984848 */     GIR_RootConstrainSelectedInstOperands,
     /*  984849 */     // GIR_Coverage, 23660,
     /*  984849 */     GIR_EraseRootFromParent_Done,
     /*  984850 */   // Label 14716: @984850
     /*  984850 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(984927), // Rule ID 23661 //
     /*  984855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  984866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  984869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  984872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  984878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984894 */     // MIs[0] policy
     /*  984894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  984904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  984907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  984925 */     GIR_RootConstrainSelectedInstOperands,
     /*  984926 */     // GIR_Coverage, 23661,
     /*  984926 */     GIR_EraseRootFromParent_Done,
     /*  984927 */   // Label 14717: @984927
     /*  984927 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(985004), // Rule ID 23664 //
     /*  984932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  984940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  984943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  984946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  984949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  984955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  984971 */     // MIs[0] policy
     /*  984971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  984974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  984981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  984984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  984988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  984992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985002 */     GIR_RootConstrainSelectedInstOperands,
     /*  985003 */     // GIR_Coverage, 23664,
     /*  985003 */     GIR_EraseRootFromParent_Done,
     /*  985004 */   // Label 14718: @985004
     /*  985004 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(985081), // Rule ID 23665 //
     /*  985009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  985020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  985023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985048 */     // MIs[0] policy
     /*  985048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  985061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985079 */     GIR_RootConstrainSelectedInstOperands,
     /*  985080 */     // GIR_Coverage, 23665,
     /*  985080 */     GIR_EraseRootFromParent_Done,
     /*  985081 */   // Label 14719: @985081
     /*  985081 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(985158), // Rule ID 23668 //
     /*  985086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  985097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  985100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985125 */     // MIs[0] policy
     /*  985125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985135 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  985138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985156 */     GIR_RootConstrainSelectedInstOperands,
     /*  985157 */     // GIR_Coverage, 23668,
     /*  985157 */     GIR_EraseRootFromParent_Done,
     /*  985158 */   // Label 14720: @985158
     /*  985158 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(985235), // Rule ID 23669 //
     /*  985163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  985174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  985177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985202 */     // MIs[0] policy
     /*  985202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  985215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985233 */     GIR_RootConstrainSelectedInstOperands,
     /*  985234 */     // GIR_Coverage, 23669,
     /*  985234 */     GIR_EraseRootFromParent_Done,
     /*  985235 */   // Label 14721: @985235
     /*  985235 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(985312), // Rule ID 23672 //
     /*  985240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  985243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  985251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  985254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985279 */     // MIs[0] policy
     /*  985279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985289 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  985292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985310 */     GIR_RootConstrainSelectedInstOperands,
     /*  985311 */     // GIR_Coverage, 23672,
     /*  985311 */     GIR_EraseRootFromParent_Done,
     /*  985312 */   // Label 14722: @985312
     /*  985312 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(985389), // Rule ID 23673 //
     /*  985317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  985320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  985328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  985331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985356 */     // MIs[0] policy
     /*  985356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  985369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985387 */     GIR_RootConstrainSelectedInstOperands,
     /*  985388 */     // GIR_Coverage, 23673,
     /*  985388 */     GIR_EraseRootFromParent_Done,
     /*  985389 */   // Label 14723: @985389
     /*  985389 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(985466), // Rule ID 23676 //
     /*  985394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  985405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  985408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  985411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985433 */     // MIs[0] policy
     /*  985433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  985446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985464 */     GIR_RootConstrainSelectedInstOperands,
     /*  985465 */     // GIR_Coverage, 23676,
     /*  985465 */     GIR_EraseRootFromParent_Done,
     /*  985466 */   // Label 14724: @985466
     /*  985466 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(985543), // Rule ID 23677 //
     /*  985471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  985482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  985485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  985488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985510 */     // MIs[0] policy
     /*  985510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  985523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985541 */     GIR_RootConstrainSelectedInstOperands,
     /*  985542 */     // GIR_Coverage, 23677,
     /*  985542 */     GIR_EraseRootFromParent_Done,
     /*  985543 */   // Label 14725: @985543
     /*  985543 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(985620), // Rule ID 23680 //
     /*  985548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  985559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  985562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  985565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985587 */     // MIs[0] policy
     /*  985587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985597 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  985600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985618 */     GIR_RootConstrainSelectedInstOperands,
     /*  985619 */     // GIR_Coverage, 23680,
     /*  985619 */     GIR_EraseRootFromParent_Done,
     /*  985620 */   // Label 14726: @985620
     /*  985620 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(985697), // Rule ID 23681 //
     /*  985625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  985636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  985639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  985642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  985660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985664 */     // MIs[0] policy
     /*  985664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  985677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985695 */     GIR_RootConstrainSelectedInstOperands,
     /*  985696 */     // GIR_Coverage, 23681,
     /*  985696 */     GIR_EraseRootFromParent_Done,
     /*  985697 */   // Label 14727: @985697
     /*  985697 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(985774), // Rule ID 23684 //
     /*  985702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  985713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  985716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  985719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985741 */     // MIs[0] policy
     /*  985741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985751 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  985754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985772 */     GIR_RootConstrainSelectedInstOperands,
     /*  985773 */     // GIR_Coverage, 23684,
     /*  985773 */     GIR_EraseRootFromParent_Done,
     /*  985774 */   // Label 14728: @985774
     /*  985774 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(985851), // Rule ID 23685 //
     /*  985779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  985790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  985793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  985796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985818 */     // MIs[0] policy
     /*  985818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985828 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  985831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985849 */     GIR_RootConstrainSelectedInstOperands,
     /*  985850 */     // GIR_Coverage, 23685,
     /*  985850 */     GIR_EraseRootFromParent_Done,
     /*  985851 */   // Label 14729: @985851
     /*  985851 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(985928), // Rule ID 23688 //
     /*  985856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  985867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  985870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  985873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  985879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985895 */     // MIs[0] policy
     /*  985895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  985905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  985908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  985926 */     GIR_RootConstrainSelectedInstOperands,
     /*  985927 */     // GIR_Coverage, 23688,
     /*  985927 */     GIR_EraseRootFromParent_Done,
     /*  985928 */   // Label 14730: @985928
     /*  985928 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(986005), // Rule ID 23689 //
     /*  985933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  985941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  985944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  985947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  985950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  985956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  985968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  985972 */     // MIs[0] policy
     /*  985972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  985975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  985982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  985985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  985989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  985993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986003 */     GIR_RootConstrainSelectedInstOperands,
     /*  986004 */     // GIR_Coverage, 23689,
     /*  986004 */     GIR_EraseRootFromParent_Done,
     /*  986005 */   // Label 14731: @986005
     /*  986005 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(986082), // Rule ID 23692 //
     /*  986010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  986021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  986024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986049 */     // MIs[0] policy
     /*  986049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  986062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986080 */     GIR_RootConstrainSelectedInstOperands,
     /*  986081 */     // GIR_Coverage, 23692,
     /*  986081 */     GIR_EraseRootFromParent_Done,
     /*  986082 */   // Label 14732: @986082
     /*  986082 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(986159), // Rule ID 23693 //
     /*  986087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  986098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  986101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986126 */     // MIs[0] policy
     /*  986126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  986139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986157 */     GIR_RootConstrainSelectedInstOperands,
     /*  986158 */     // GIR_Coverage, 23693,
     /*  986158 */     GIR_EraseRootFromParent_Done,
     /*  986159 */   // Label 14733: @986159
     /*  986159 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(986236), // Rule ID 23696 //
     /*  986164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  986175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  986178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  986181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986203 */     // MIs[0] policy
     /*  986203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986213 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  986216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986234 */     GIR_RootConstrainSelectedInstOperands,
     /*  986235 */     // GIR_Coverage, 23696,
     /*  986235 */     GIR_EraseRootFromParent_Done,
     /*  986236 */   // Label 14734: @986236
     /*  986236 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(986313), // Rule ID 23697 //
     /*  986241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  986252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  986255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  986258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986280 */     // MIs[0] policy
     /*  986280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986290 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  986293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986311 */     GIR_RootConstrainSelectedInstOperands,
     /*  986312 */     // GIR_Coverage, 23697,
     /*  986312 */     GIR_EraseRootFromParent_Done,
     /*  986313 */   // Label 14735: @986313
     /*  986313 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(986390), // Rule ID 23700 //
     /*  986318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  986329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  986332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  986335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986357 */     // MIs[0] policy
     /*  986357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  986370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986388 */     GIR_RootConstrainSelectedInstOperands,
     /*  986389 */     // GIR_Coverage, 23700,
     /*  986389 */     GIR_EraseRootFromParent_Done,
     /*  986390 */   // Label 14736: @986390
     /*  986390 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(986467), // Rule ID 23701 //
     /*  986395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  986406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  986409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  986412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986434 */     // MIs[0] policy
     /*  986434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  986447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986465 */     GIR_RootConstrainSelectedInstOperands,
     /*  986466 */     // GIR_Coverage, 23701,
     /*  986466 */     GIR_EraseRootFromParent_Done,
     /*  986467 */   // Label 14737: @986467
     /*  986467 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(986544), // Rule ID 23704 //
     /*  986472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  986483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  986486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  986489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986511 */     // MIs[0] policy
     /*  986511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  986524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986542 */     GIR_RootConstrainSelectedInstOperands,
     /*  986543 */     // GIR_Coverage, 23704,
     /*  986543 */     GIR_EraseRootFromParent_Done,
     /*  986544 */   // Label 14738: @986544
     /*  986544 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(986621), // Rule ID 23705 //
     /*  986549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  986560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  986563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  986566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986588 */     // MIs[0] policy
     /*  986588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  986601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986619 */     GIR_RootConstrainSelectedInstOperands,
     /*  986620 */     // GIR_Coverage, 23705,
     /*  986620 */     GIR_EraseRootFromParent_Done,
     /*  986621 */   // Label 14739: @986621
     /*  986621 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(986698), // Rule ID 23708 //
     /*  986626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  986637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  986640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  986643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986665 */     // MIs[0] policy
     /*  986665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986675 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  986678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986696 */     GIR_RootConstrainSelectedInstOperands,
     /*  986697 */     // GIR_Coverage, 23708,
     /*  986697 */     GIR_EraseRootFromParent_Done,
     /*  986698 */   // Label 14740: @986698
     /*  986698 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(986775), // Rule ID 23709 //
     /*  986703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  986714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  986717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  986720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986742 */     // MIs[0] policy
     /*  986742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  986755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986773 */     GIR_RootConstrainSelectedInstOperands,
     /*  986774 */     // GIR_Coverage, 23709,
     /*  986774 */     GIR_EraseRootFromParent_Done,
     /*  986775 */   // Label 14741: @986775
     /*  986775 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(986852), // Rule ID 23712 //
     /*  986780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  986791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  986794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  986797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986819 */     // MIs[0] policy
     /*  986819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  986832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986850 */     GIR_RootConstrainSelectedInstOperands,
     /*  986851 */     // GIR_Coverage, 23712,
     /*  986851 */     GIR_EraseRootFromParent_Done,
     /*  986852 */   // Label 14742: @986852
     /*  986852 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(986929), // Rule ID 23713 //
     /*  986857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  986868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  986871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  986874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  986880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986896 */     // MIs[0] policy
     /*  986896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  986906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  986909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  986927 */     GIR_RootConstrainSelectedInstOperands,
     /*  986928 */     // GIR_Coverage, 23713,
     /*  986928 */     GIR_EraseRootFromParent_Done,
     /*  986929 */   // Label 14743: @986929
     /*  986929 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(987006), // Rule ID 23716 //
     /*  986934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  986942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  986945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  986948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  986951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  986957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  986973 */     // MIs[0] policy
     /*  986973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  986976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986983 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  986983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  986986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  986990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  986994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987004 */     GIR_RootConstrainSelectedInstOperands,
     /*  987005 */     // GIR_Coverage, 23716,
     /*  987005 */     GIR_EraseRootFromParent_Done,
     /*  987006 */   // Label 14744: @987006
     /*  987006 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(987083), // Rule ID 23717 //
     /*  987011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  987019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  987022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  987025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  987028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987050 */     // MIs[0] policy
     /*  987050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  987063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987081 */     GIR_RootConstrainSelectedInstOperands,
     /*  987082 */     // GIR_Coverage, 23717,
     /*  987082 */     GIR_EraseRootFromParent_Done,
     /*  987083 */   // Label 14745: @987083
     /*  987083 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(987160), // Rule ID 23720 //
     /*  987088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  987091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  987096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  987099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  987102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  987105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987127 */     // MIs[0] policy
     /*  987127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987137 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  987140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987158 */     GIR_RootConstrainSelectedInstOperands,
     /*  987159 */     // GIR_Coverage, 23720,
     /*  987159 */     GIR_EraseRootFromParent_Done,
     /*  987160 */   // Label 14746: @987160
     /*  987160 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(987237), // Rule ID 23721 //
     /*  987165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  987173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  987176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  987179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  987182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987204 */     // MIs[0] policy
     /*  987204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  987217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987235 */     GIR_RootConstrainSelectedInstOperands,
     /*  987236 */     // GIR_Coverage, 23721,
     /*  987236 */     GIR_EraseRootFromParent_Done,
     /*  987237 */   // Label 14747: @987237
     /*  987237 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(987314), // Rule ID 23988 //
     /*  987242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  987245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  987253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  987256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  987259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987281 */     // MIs[0] policy
     /*  987281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987291 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  987294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987312 */     GIR_RootConstrainSelectedInstOperands,
     /*  987313 */     // GIR_Coverage, 23988,
     /*  987313 */     GIR_EraseRootFromParent_Done,
     /*  987314 */   // Label 14748: @987314
     /*  987314 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(987391), // Rule ID 23989 //
     /*  987319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  987322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  987330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  987333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  987336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987358 */     // MIs[0] policy
     /*  987358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987368 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /*  987371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987389 */     GIR_RootConstrainSelectedInstOperands,
     /*  987390 */     // GIR_Coverage, 23989,
     /*  987390 */     GIR_EraseRootFromParent_Done,
     /*  987391 */   // Label 14749: @987391
     /*  987391 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(987468), // Rule ID 23992 //
     /*  987396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  987399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  987407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  987410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  987413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987435 */     // MIs[0] policy
     /*  987435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987445 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  987448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987466 */     GIR_RootConstrainSelectedInstOperands,
     /*  987467 */     // GIR_Coverage, 23992,
     /*  987467 */     GIR_EraseRootFromParent_Done,
     /*  987468 */   // Label 14750: @987468
     /*  987468 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(987545), // Rule ID 23993 //
     /*  987473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  987476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  987484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  987487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  987490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987512 */     // MIs[0] policy
     /*  987512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987522 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  987525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987543 */     GIR_RootConstrainSelectedInstOperands,
     /*  987544 */     // GIR_Coverage, 23993,
     /*  987544 */     GIR_EraseRootFromParent_Done,
     /*  987545 */   // Label 14751: @987545
     /*  987545 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(987622), // Rule ID 23996 //
     /*  987550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  987553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  987561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  987564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  987567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987589 */     // MIs[0] policy
     /*  987589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987599 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  987602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987620 */     GIR_RootConstrainSelectedInstOperands,
     /*  987621 */     // GIR_Coverage, 23996,
     /*  987621 */     GIR_EraseRootFromParent_Done,
     /*  987622 */   // Label 14752: @987622
     /*  987622 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(987699), // Rule ID 23997 //
     /*  987627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  987630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  987638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  987641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  987644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987666 */     // MIs[0] policy
     /*  987666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /*  987679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987697 */     GIR_RootConstrainSelectedInstOperands,
     /*  987698 */     // GIR_Coverage, 23997,
     /*  987698 */     GIR_EraseRootFromParent_Done,
     /*  987699 */   // Label 14753: @987699
     /*  987699 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(987776), // Rule ID 24000 //
     /*  987704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  987707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  987715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  987718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  987721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987743 */     // MIs[0] policy
     /*  987743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987753 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  987756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987774 */     GIR_RootConstrainSelectedInstOperands,
     /*  987775 */     // GIR_Coverage, 24000,
     /*  987775 */     GIR_EraseRootFromParent_Done,
     /*  987776 */   // Label 14754: @987776
     /*  987776 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(987853), // Rule ID 24001 //
     /*  987781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  987784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  987792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  987795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  987798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987820 */     // MIs[0] policy
     /*  987820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987830 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  987833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987851 */     GIR_RootConstrainSelectedInstOperands,
     /*  987852 */     // GIR_Coverage, 24001,
     /*  987852 */     GIR_EraseRootFromParent_Done,
     /*  987853 */   // Label 14755: @987853
     /*  987853 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(987930), // Rule ID 24004 //
     /*  987858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  987861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  987869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  987872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  987875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  987881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987897 */     // MIs[0] policy
     /*  987897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987907 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  987907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  987910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  987928 */     GIR_RootConstrainSelectedInstOperands,
     /*  987929 */     // GIR_Coverage, 24004,
     /*  987929 */     GIR_EraseRootFromParent_Done,
     /*  987930 */   // Label 14756: @987930
     /*  987930 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(988007), // Rule ID 24005 //
     /*  987935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  987938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  987943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  987946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  987949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  987952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  987958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  987974 */     // MIs[0] policy
     /*  987974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  987977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  987984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  987987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  987991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  987995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988005 */     GIR_RootConstrainSelectedInstOperands,
     /*  988006 */     // GIR_Coverage, 24005,
     /*  988006 */     GIR_EraseRootFromParent_Done,
     /*  988007 */   // Label 14757: @988007
     /*  988007 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(988084), // Rule ID 24008 //
     /*  988012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  988015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  988023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  988026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  988029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988051 */     // MIs[0] policy
     /*  988051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988061 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  988064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988082 */     GIR_RootConstrainSelectedInstOperands,
     /*  988083 */     // GIR_Coverage, 24008,
     /*  988083 */     GIR_EraseRootFromParent_Done,
     /*  988084 */   // Label 14758: @988084
     /*  988084 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(988161), // Rule ID 24009 //
     /*  988089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  988092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  988100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  988103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  988106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988128 */     // MIs[0] policy
     /*  988128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /*  988141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988159 */     GIR_RootConstrainSelectedInstOperands,
     /*  988160 */     // GIR_Coverage, 24009,
     /*  988160 */     GIR_EraseRootFromParent_Done,
     /*  988161 */   // Label 14759: @988161
     /*  988161 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(988238), // Rule ID 24012 //
     /*  988166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  988169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  988177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  988180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  988183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988205 */     // MIs[0] policy
     /*  988205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988215 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  988218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988236 */     GIR_RootConstrainSelectedInstOperands,
     /*  988237 */     // GIR_Coverage, 24012,
     /*  988237 */     GIR_EraseRootFromParent_Done,
     /*  988238 */   // Label 14760: @988238
     /*  988238 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(988315), // Rule ID 24013 //
     /*  988243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  988246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  988254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  988257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  988260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988282 */     // MIs[0] policy
     /*  988282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  988295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988313 */     GIR_RootConstrainSelectedInstOperands,
     /*  988314 */     // GIR_Coverage, 24013,
     /*  988314 */     GIR_EraseRootFromParent_Done,
     /*  988315 */   // Label 14761: @988315
     /*  988315 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(988392), // Rule ID 24016 //
     /*  988320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  988323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  988331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  988334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  988337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988359 */     // MIs[0] policy
     /*  988359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988369 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  988372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988390 */     GIR_RootConstrainSelectedInstOperands,
     /*  988391 */     // GIR_Coverage, 24016,
     /*  988391 */     GIR_EraseRootFromParent_Done,
     /*  988392 */   // Label 14762: @988392
     /*  988392 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(988469), // Rule ID 24017 //
     /*  988397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  988400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  988408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  988411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  988414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988436 */     // MIs[0] policy
     /*  988436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988446 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  988449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988467 */     GIR_RootConstrainSelectedInstOperands,
     /*  988468 */     // GIR_Coverage, 24017,
     /*  988468 */     GIR_EraseRootFromParent_Done,
     /*  988469 */   // Label 14763: @988469
     /*  988469 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(988546), // Rule ID 24020 //
     /*  988474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  988477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  988485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  988488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  988491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988513 */     // MIs[0] policy
     /*  988513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988523 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  988526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988544 */     GIR_RootConstrainSelectedInstOperands,
     /*  988545 */     // GIR_Coverage, 24020,
     /*  988545 */     GIR_EraseRootFromParent_Done,
     /*  988546 */   // Label 14764: @988546
     /*  988546 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(988623), // Rule ID 24021 //
     /*  988551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  988554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  988562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  988565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  988568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988590 */     // MIs[0] policy
     /*  988590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988600 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  988603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988621 */     GIR_RootConstrainSelectedInstOperands,
     /*  988622 */     // GIR_Coverage, 24021,
     /*  988622 */     GIR_EraseRootFromParent_Done,
     /*  988623 */   // Label 14765: @988623
     /*  988623 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(988700), // Rule ID 24024 //
     /*  988628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  988631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  988639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  988642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988667 */     // MIs[0] policy
     /*  988667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  988680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988698 */     GIR_RootConstrainSelectedInstOperands,
     /*  988699 */     // GIR_Coverage, 24024,
     /*  988699 */     GIR_EraseRootFromParent_Done,
     /*  988700 */   // Label 14766: @988700
     /*  988700 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(988777), // Rule ID 24025 //
     /*  988705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  988708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  988716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  988719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988744 */     // MIs[0] policy
     /*  988744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988754 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  988757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988775 */     GIR_RootConstrainSelectedInstOperands,
     /*  988776 */     // GIR_Coverage, 24025,
     /*  988776 */     GIR_EraseRootFromParent_Done,
     /*  988777 */   // Label 14767: @988777
     /*  988777 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(988854), // Rule ID 24028 //
     /*  988782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  988785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  988793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  988796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988821 */     // MIs[0] policy
     /*  988821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988831 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  988834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988852 */     GIR_RootConstrainSelectedInstOperands,
     /*  988853 */     // GIR_Coverage, 24028,
     /*  988853 */     GIR_EraseRootFromParent_Done,
     /*  988854 */   // Label 14768: @988854
     /*  988854 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(988931), // Rule ID 24029 //
     /*  988859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  988862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  988870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  988873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  988882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988898 */     // MIs[0] policy
     /*  988898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988908 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  988908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  988911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  988929 */     GIR_RootConstrainSelectedInstOperands,
     /*  988930 */     // GIR_Coverage, 24029,
     /*  988930 */     GIR_EraseRootFromParent_Done,
     /*  988931 */   // Label 14769: @988931
     /*  988931 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(989008), // Rule ID 24032 //
     /*  988936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  988939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  988944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  988947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  988950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  988959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  988975 */     // MIs[0] policy
     /*  988975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  988978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988985 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  988985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  988988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  988992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  988996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989006 */     GIR_RootConstrainSelectedInstOperands,
     /*  989007 */     // GIR_Coverage, 24032,
     /*  989007 */     GIR_EraseRootFromParent_Done,
     /*  989008 */   // Label 14770: @989008
     /*  989008 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(989085), // Rule ID 24033 //
     /*  989013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  989016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  989024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  989027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  989030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989052 */     // MIs[0] policy
     /*  989052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989062 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  989065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989083 */     GIR_RootConstrainSelectedInstOperands,
     /*  989084 */     // GIR_Coverage, 24033,
     /*  989084 */     GIR_EraseRootFromParent_Done,
     /*  989085 */   // Label 14771: @989085
     /*  989085 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(989162), // Rule ID 24036 //
     /*  989090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  989093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  989101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  989104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  989107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989129 */     // MIs[0] policy
     /*  989129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989139 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  989142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989160 */     GIR_RootConstrainSelectedInstOperands,
     /*  989161 */     // GIR_Coverage, 24036,
     /*  989161 */     GIR_EraseRootFromParent_Done,
     /*  989162 */   // Label 14772: @989162
     /*  989162 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(989239), // Rule ID 24037 //
     /*  989167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  989170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  989178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  989181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  989184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  989202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989206 */     // MIs[0] policy
     /*  989206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989216 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /*  989219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989237 */     GIR_RootConstrainSelectedInstOperands,
     /*  989238 */     // GIR_Coverage, 24037,
     /*  989238 */     GIR_EraseRootFromParent_Done,
     /*  989239 */   // Label 14773: @989239
     /*  989239 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(989316), // Rule ID 24040 //
     /*  989244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  989247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  989255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  989258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  989261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989283 */     // MIs[0] policy
     /*  989283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989293 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  989296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989314 */     GIR_RootConstrainSelectedInstOperands,
     /*  989315 */     // GIR_Coverage, 24040,
     /*  989315 */     GIR_EraseRootFromParent_Done,
     /*  989316 */   // Label 14774: @989316
     /*  989316 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(989393), // Rule ID 24041 //
     /*  989321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  989324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  989332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  989335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  989338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  989356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989360 */     // MIs[0] policy
     /*  989360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989370 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /*  989373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989391 */     GIR_RootConstrainSelectedInstOperands,
     /*  989392 */     // GIR_Coverage, 24041,
     /*  989392 */     GIR_EraseRootFromParent_Done,
     /*  989393 */   // Label 14775: @989393
     /*  989393 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(989470), // Rule ID 24044 //
     /*  989398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  989401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  989409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  989412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989437 */     // MIs[0] policy
     /*  989437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989447 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  989450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989468 */     GIR_RootConstrainSelectedInstOperands,
     /*  989469 */     // GIR_Coverage, 24044,
     /*  989469 */     GIR_EraseRootFromParent_Done,
     /*  989470 */   // Label 14776: @989470
     /*  989470 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(989547), // Rule ID 24045 //
     /*  989475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  989478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  989483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  989486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  989489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989514 */     // MIs[0] policy
     /*  989514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989524 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /*  989527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989545 */     GIR_RootConstrainSelectedInstOperands,
     /*  989546 */     // GIR_Coverage, 24045,
     /*  989546 */     GIR_EraseRootFromParent_Done,
     /*  989547 */   // Label 14777: @989547
     /*  989547 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(989624), // Rule ID 24108 //
     /*  989552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  989555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989591 */     // MIs[0] policy
     /*  989591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989601 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  989604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989622 */     GIR_RootConstrainSelectedInstOperands,
     /*  989623 */     // GIR_Coverage, 24108,
     /*  989623 */     GIR_EraseRootFromParent_Done,
     /*  989624 */   // Label 14778: @989624
     /*  989624 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(989701), // Rule ID 24109 //
     /*  989629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  989632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989668 */     // MIs[0] policy
     /*  989668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989678 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /*  989681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989699 */     GIR_RootConstrainSelectedInstOperands,
     /*  989700 */     // GIR_Coverage, 24109,
     /*  989700 */     GIR_EraseRootFromParent_Done,
     /*  989701 */   // Label 14779: @989701
     /*  989701 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(989778), // Rule ID 24112 //
     /*  989706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  989709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989745 */     // MIs[0] policy
     /*  989745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989755 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  989758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989776 */     GIR_RootConstrainSelectedInstOperands,
     /*  989777 */     // GIR_Coverage, 24112,
     /*  989777 */     GIR_EraseRootFromParent_Done,
     /*  989778 */   // Label 14780: @989778
     /*  989778 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(989855), // Rule ID 24113 //
     /*  989783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  989786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989822 */     // MIs[0] policy
     /*  989822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989832 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  989835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989853 */     GIR_RootConstrainSelectedInstOperands,
     /*  989854 */     // GIR_Coverage, 24113,
     /*  989854 */     GIR_EraseRootFromParent_Done,
     /*  989855 */   // Label 14781: @989855
     /*  989855 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(989932), // Rule ID 24116 //
     /*  989860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  989863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  989883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989899 */     // MIs[0] policy
     /*  989899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989909 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  989909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  989912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  989930 */     GIR_RootConstrainSelectedInstOperands,
     /*  989931 */     // GIR_Coverage, 24116,
     /*  989931 */     GIR_EraseRootFromParent_Done,
     /*  989932 */   // Label 14782: @989932
     /*  989932 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(990009), // Rule ID 24117 //
     /*  989937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  989940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  989945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  989960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  989976 */     // MIs[0] policy
     /*  989976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  989979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989986 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  989986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /*  989989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  989993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  989997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990007 */     GIR_RootConstrainSelectedInstOperands,
     /*  990008 */     // GIR_Coverage, 24117,
     /*  990008 */     GIR_EraseRootFromParent_Done,
     /*  990009 */   // Label 14783: @990009
     /*  990009 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(990086), // Rule ID 24120 //
     /*  990014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  990017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990053 */     // MIs[0] policy
     /*  990053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990063 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990084 */     GIR_RootConstrainSelectedInstOperands,
     /*  990085 */     // GIR_Coverage, 24120,
     /*  990085 */     GIR_EraseRootFromParent_Done,
     /*  990086 */   // Label 14784: @990086
     /*  990086 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(990163), // Rule ID 24121 //
     /*  990091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  990094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990130 */     // MIs[0] policy
     /*  990130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990140 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990161 */     GIR_RootConstrainSelectedInstOperands,
     /*  990162 */     // GIR_Coverage, 24121,
     /*  990162 */     GIR_EraseRootFromParent_Done,
     /*  990163 */   // Label 14785: @990163
     /*  990163 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(990240), // Rule ID 24124 //
     /*  990168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  990171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990207 */     // MIs[0] policy
     /*  990207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990217 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990238 */     GIR_RootConstrainSelectedInstOperands,
     /*  990239 */     // GIR_Coverage, 24124,
     /*  990239 */     GIR_EraseRootFromParent_Done,
     /*  990240 */   // Label 14786: @990240
     /*  990240 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(990317), // Rule ID 24125 //
     /*  990245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  990248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990284 */     // MIs[0] policy
     /*  990284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990315 */     GIR_RootConstrainSelectedInstOperands,
     /*  990316 */     // GIR_Coverage, 24125,
     /*  990316 */     GIR_EraseRootFromParent_Done,
     /*  990317 */   // Label 14787: @990317
     /*  990317 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(990394), // Rule ID 24128 //
     /*  990322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  990325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990361 */     // MIs[0] policy
     /*  990361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990371 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990392 */     GIR_RootConstrainSelectedInstOperands,
     /*  990393 */     // GIR_Coverage, 24128,
     /*  990393 */     GIR_EraseRootFromParent_Done,
     /*  990394 */   // Label 14788: @990394
     /*  990394 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(990471), // Rule ID 24129 //
     /*  990399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  990402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990438 */     // MIs[0] policy
     /*  990438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990448 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /*  990451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990469 */     GIR_RootConstrainSelectedInstOperands,
     /*  990470 */     // GIR_Coverage, 24129,
     /*  990470 */     GIR_EraseRootFromParent_Done,
     /*  990471 */   // Label 14789: @990471
     /*  990471 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(990548), // Rule ID 24132 //
     /*  990476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  990479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  990487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  990490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990515 */     // MIs[0] policy
     /*  990515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  990528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990546 */     GIR_RootConstrainSelectedInstOperands,
     /*  990547 */     // GIR_Coverage, 24132,
     /*  990547 */     GIR_EraseRootFromParent_Done,
     /*  990548 */   // Label 14790: @990548
     /*  990548 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(990625), // Rule ID 24133 //
     /*  990553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  990556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  990564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  990567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990592 */     // MIs[0] policy
     /*  990592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990602 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  990605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990623 */     GIR_RootConstrainSelectedInstOperands,
     /*  990624 */     // GIR_Coverage, 24133,
     /*  990624 */     GIR_EraseRootFromParent_Done,
     /*  990625 */   // Label 14791: @990625
     /*  990625 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(990702), // Rule ID 24136 //
     /*  990630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  990633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  990641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  990644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  990647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990669 */     // MIs[0] policy
     /*  990669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990679 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  990682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990700 */     GIR_RootConstrainSelectedInstOperands,
     /*  990701 */     // GIR_Coverage, 24136,
     /*  990701 */     GIR_EraseRootFromParent_Done,
     /*  990702 */   // Label 14792: @990702
     /*  990702 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(990779), // Rule ID 24137 //
     /*  990707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  990710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  990718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  990721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  990724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990746 */     // MIs[0] policy
     /*  990746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990756 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  990759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990777 */     GIR_RootConstrainSelectedInstOperands,
     /*  990778 */     // GIR_Coverage, 24137,
     /*  990778 */     GIR_EraseRootFromParent_Done,
     /*  990779 */   // Label 14793: @990779
     /*  990779 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(990856), // Rule ID 24140 //
     /*  990784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  990787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  990795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  990798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  990801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990823 */     // MIs[0] policy
     /*  990823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990833 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  990836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990854 */     GIR_RootConstrainSelectedInstOperands,
     /*  990855 */     // GIR_Coverage, 24140,
     /*  990855 */     GIR_EraseRootFromParent_Done,
     /*  990856 */   // Label 14794: @990856
     /*  990856 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(990933), // Rule ID 24141 //
     /*  990861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  990864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  990872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  990875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  990878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  990884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990900 */     // MIs[0] policy
     /*  990900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990910 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  990910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  990913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  990931 */     GIR_RootConstrainSelectedInstOperands,
     /*  990932 */     // GIR_Coverage, 24141,
     /*  990932 */     GIR_EraseRootFromParent_Done,
     /*  990933 */   // Label 14795: @990933
     /*  990933 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(991010), // Rule ID 24144 //
     /*  990938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  990941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  990946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  990949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  990952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  990955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  990961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  990977 */     // MIs[0] policy
     /*  990977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  990980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990987 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  990987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  990990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  990994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  990998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991008 */     GIR_RootConstrainSelectedInstOperands,
     /*  991009 */     // GIR_Coverage, 24144,
     /*  991009 */     GIR_EraseRootFromParent_Done,
     /*  991010 */   // Label 14796: @991010
     /*  991010 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(991087), // Rule ID 24145 //
     /*  991015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  991018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991054 */     // MIs[0] policy
     /*  991054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  991067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991085 */     GIR_RootConstrainSelectedInstOperands,
     /*  991086 */     // GIR_Coverage, 24145,
     /*  991086 */     GIR_EraseRootFromParent_Done,
     /*  991087 */   // Label 14797: @991087
     /*  991087 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(991164), // Rule ID 24148 //
     /*  991092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  991095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991131 */     // MIs[0] policy
     /*  991131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991141 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  991144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991162 */     GIR_RootConstrainSelectedInstOperands,
     /*  991163 */     // GIR_Coverage, 24148,
     /*  991163 */     GIR_EraseRootFromParent_Done,
     /*  991164 */   // Label 14798: @991164
     /*  991164 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(991241), // Rule ID 24149 //
     /*  991169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  991172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991208 */     // MIs[0] policy
     /*  991208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991218 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  991221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991239 */     GIR_RootConstrainSelectedInstOperands,
     /*  991240 */     // GIR_Coverage, 24149,
     /*  991240 */     GIR_EraseRootFromParent_Done,
     /*  991241 */   // Label 14799: @991241
     /*  991241 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(991318), // Rule ID 24152 //
     /*  991246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  991249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  991257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  991260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991285 */     // MIs[0] policy
     /*  991285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991295 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  991298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991316 */     GIR_RootConstrainSelectedInstOperands,
     /*  991317 */     // GIR_Coverage, 24152,
     /*  991317 */     GIR_EraseRootFromParent_Done,
     /*  991318 */   // Label 14800: @991318
     /*  991318 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(991395), // Rule ID 24153 //
     /*  991323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  991326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  991334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  991337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991362 */     // MIs[0] policy
     /*  991362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991372 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  991375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991393 */     GIR_RootConstrainSelectedInstOperands,
     /*  991394 */     // GIR_Coverage, 24153,
     /*  991394 */     GIR_EraseRootFromParent_Done,
     /*  991395 */   // Label 14801: @991395
     /*  991395 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(991472), // Rule ID 24156 //
     /*  991400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  991403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  991411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  991414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  991417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991439 */     // MIs[0] policy
     /*  991439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991449 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  991452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991470 */     GIR_RootConstrainSelectedInstOperands,
     /*  991471 */     // GIR_Coverage, 24156,
     /*  991471 */     GIR_EraseRootFromParent_Done,
     /*  991472 */   // Label 14802: @991472
     /*  991472 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(991549), // Rule ID 24157 //
     /*  991477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  991480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  991488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  991491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  991494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991516 */     // MIs[0] policy
     /*  991516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991526 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /*  991529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991547 */     GIR_RootConstrainSelectedInstOperands,
     /*  991548 */     // GIR_Coverage, 24157,
     /*  991548 */     GIR_EraseRootFromParent_Done,
     /*  991549 */   // Label 14803: @991549
     /*  991549 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(991626), // Rule ID 24160 //
     /*  991554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  991557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  991565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  991568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  991571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991593 */     // MIs[0] policy
     /*  991593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991603 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  991606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991624 */     GIR_RootConstrainSelectedInstOperands,
     /*  991625 */     // GIR_Coverage, 24160,
     /*  991625 */     GIR_EraseRootFromParent_Done,
     /*  991626 */   // Label 14804: @991626
     /*  991626 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(991703), // Rule ID 24161 //
     /*  991631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  991634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  991642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  991645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  991648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991670 */     // MIs[0] policy
     /*  991670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991680 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /*  991683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991701 */     GIR_RootConstrainSelectedInstOperands,
     /*  991702 */     // GIR_Coverage, 24161,
     /*  991702 */     GIR_EraseRootFromParent_Done,
     /*  991703 */   // Label 14805: @991703
     /*  991703 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(991780), // Rule ID 24164 //
     /*  991708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  991711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  991719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  991722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  991725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991747 */     // MIs[0] policy
     /*  991747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991757 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  991760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991778 */     GIR_RootConstrainSelectedInstOperands,
     /*  991779 */     // GIR_Coverage, 24164,
     /*  991779 */     GIR_EraseRootFromParent_Done,
     /*  991780 */   // Label 14806: @991780
     /*  991780 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(991857), // Rule ID 24165 //
     /*  991785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  991788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  991793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  991796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  991799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  991802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  991824 */     // MIs[0] policy
     /*  991824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991834 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /*  991837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991855 */     GIR_RootConstrainSelectedInstOperands,
     /*  991856 */     // GIR_Coverage, 24165,
     /*  991856 */     GIR_EraseRootFromParent_Done,
     /*  991857 */   // Label 14807: @991857
     /*  991857 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(991934), // Rule ID 59880 //
     /*  991862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  991865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /*  991870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  991873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  991876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  991879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  991882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  991885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991901 */     // MIs[0] policy
     /*  991901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  991911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /*  991914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  991916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  991932 */     GIR_RootConstrainSelectedInstOperands,
     /*  991933 */     // GIR_Coverage, 59880,
     /*  991933 */     GIR_EraseRootFromParent_Done,
     /*  991934 */   // Label 14808: @991934
     /*  991934 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(992011), // Rule ID 59881 //
     /*  991939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  991942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /*  991947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  991950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  991953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  991956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  991959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  991962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991978 */     // MIs[0] policy
     /*  991978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  991981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991988 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  991988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /*  991991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  991993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  991995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  991999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992009 */     GIR_RootConstrainSelectedInstOperands,
     /*  992010 */     // GIR_Coverage, 59881,
     /*  992010 */     GIR_EraseRootFromParent_Done,
     /*  992011 */   // Label 14809: @992011
     /*  992011 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(992088), // Rule ID 59894 //
     /*  992016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992055 */     // MIs[0] policy
     /*  992055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992065 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /*  992068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992086 */     GIR_RootConstrainSelectedInstOperands,
     /*  992087 */     // GIR_Coverage, 59894,
     /*  992087 */     GIR_EraseRootFromParent_Done,
     /*  992088 */   // Label 14810: @992088
     /*  992088 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(992165), // Rule ID 59895 //
     /*  992093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992132 */     // MIs[0] policy
     /*  992132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992142 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /*  992145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992163 */     GIR_RootConstrainSelectedInstOperands,
     /*  992164 */     // GIR_Coverage, 59895,
     /*  992164 */     GIR_EraseRootFromParent_Done,
     /*  992165 */   // Label 14811: @992165
     /*  992165 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(992242), // Rule ID 59898 //
     /*  992170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  992190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992209 */     // MIs[0] policy
     /*  992209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992219 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /*  992222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992240 */     GIR_RootConstrainSelectedInstOperands,
     /*  992241 */     // GIR_Coverage, 59898,
     /*  992241 */     GIR_EraseRootFromParent_Done,
     /*  992242 */   // Label 14812: @992242
     /*  992242 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(992319), // Rule ID 59899 //
     /*  992247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  992267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992286 */     // MIs[0] policy
     /*  992286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /*  992299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992317 */     GIR_RootConstrainSelectedInstOperands,
     /*  992318 */     // GIR_Coverage, 59899,
     /*  992318 */     GIR_EraseRootFromParent_Done,
     /*  992319 */   // Label 14813: @992319
     /*  992319 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(992396), // Rule ID 59902 //
     /*  992324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  992335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  992338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  992341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  992344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992363 */     // MIs[0] policy
     /*  992363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992373 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992394 */     GIR_RootConstrainSelectedInstOperands,
     /*  992395 */     // GIR_Coverage, 59902,
     /*  992395 */     GIR_EraseRootFromParent_Done,
     /*  992396 */   // Label 14814: @992396
     /*  992396 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(992473), // Rule ID 59903 //
     /*  992401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  992412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  992415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  992418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  992421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992440 */     // MIs[0] policy
     /*  992440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992471 */     GIR_RootConstrainSelectedInstOperands,
     /*  992472 */     // GIR_Coverage, 59903,
     /*  992472 */     GIR_EraseRootFromParent_Done,
     /*  992473 */   // Label 14815: @992473
     /*  992473 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(992550), // Rule ID 59906 //
     /*  992478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  992489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  992492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  992495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992517 */     // MIs[0] policy
     /*  992517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992527 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /*  992530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992548 */     GIR_RootConstrainSelectedInstOperands,
     /*  992549 */     // GIR_Coverage, 59906,
     /*  992549 */     GIR_EraseRootFromParent_Done,
     /*  992550 */   // Label 14816: @992550
     /*  992550 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(992627), // Rule ID 59907 //
     /*  992555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  992566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  992569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  992572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992594 */     // MIs[0] policy
     /*  992594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /*  992607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992625 */     GIR_RootConstrainSelectedInstOperands,
     /*  992626 */     // GIR_Coverage, 59907,
     /*  992626 */     GIR_EraseRootFromParent_Done,
     /*  992627 */   // Label 14817: @992627
     /*  992627 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(992704), // Rule ID 59910 //
     /*  992632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  992643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  992646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  992649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  992652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992671 */     // MIs[0] policy
     /*  992671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992681 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992702 */     GIR_RootConstrainSelectedInstOperands,
     /*  992703 */     // GIR_Coverage, 59910,
     /*  992703 */     GIR_EraseRootFromParent_Done,
     /*  992704 */   // Label 14818: @992704
     /*  992704 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(992781), // Rule ID 59911 //
     /*  992709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  992720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  992723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  992726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  992729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992748 */     // MIs[0] policy
     /*  992748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992779 */     GIR_RootConstrainSelectedInstOperands,
     /*  992780 */     // GIR_Coverage, 59911,
     /*  992780 */     GIR_EraseRootFromParent_Done,
     /*  992781 */   // Label 14819: @992781
     /*  992781 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(992858), // Rule ID 59914 //
     /*  992786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  992803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992825 */     // MIs[0] policy
     /*  992825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992835 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992856 */     GIR_RootConstrainSelectedInstOperands,
     /*  992857 */     // GIR_Coverage, 59914,
     /*  992857 */     GIR_EraseRootFromParent_Done,
     /*  992858 */   // Label 14820: @992858
     /*  992858 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(992935), // Rule ID 59915 //
     /*  992863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  992866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  992880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  992883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  992886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992902 */     // MIs[0] policy
     /*  992902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  992912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /*  992915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  992923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  992933 */     GIR_RootConstrainSelectedInstOperands,
     /*  992934 */     // GIR_Coverage, 59915,
     /*  992934 */     GIR_EraseRootFromParent_Done,
     /*  992935 */   // Label 14821: @992935
     /*  992935 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(993012), // Rule ID 59918 //
     /*  992940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  992943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  992948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  992951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  992954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  992957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  992960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  992963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992979 */     // MIs[0] policy
     /*  992979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  992982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  992989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  992992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  992998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993010 */     GIR_RootConstrainSelectedInstOperands,
     /*  993011 */     // GIR_Coverage, 59918,
     /*  993011 */     GIR_EraseRootFromParent_Done,
     /*  993012 */   // Label 14822: @993012
     /*  993012 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(993089), // Rule ID 59919 //
     /*  993017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  993028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  993031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  993034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  993037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993056 */     // MIs[0] policy
     /*  993056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10856:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993087 */     GIR_RootConstrainSelectedInstOperands,
     /*  993088 */     // GIR_Coverage, 59919,
     /*  993088 */     GIR_EraseRootFromParent_Done,
     /*  993089 */   // Label 14823: @993089
     /*  993089 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(993166), // Rule ID 59922 //
     /*  993094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  993105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  993108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  993111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  993114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993133 */     // MIs[0] policy
     /*  993133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993164 */     GIR_RootConstrainSelectedInstOperands,
     /*  993165 */     // GIR_Coverage, 59922,
     /*  993165 */     GIR_EraseRootFromParent_Done,
     /*  993166 */   // Label 14824: @993166
     /*  993166 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(993243), // Rule ID 59923 //
     /*  993171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  993182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  993185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  993188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  993191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993210 */     // MIs[0] policy
     /*  993210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993241 */     GIR_RootConstrainSelectedInstOperands,
     /*  993242 */     // GIR_Coverage, 59923,
     /*  993242 */     GIR_EraseRootFromParent_Done,
     /*  993243 */   // Label 14825: @993243
     /*  993243 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(993320), // Rule ID 59926 //
     /*  993248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  993265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  993268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993287 */     // MIs[0] policy
     /*  993287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993297 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993318 */     GIR_RootConstrainSelectedInstOperands,
     /*  993319 */     // GIR_Coverage, 59926,
     /*  993319 */     GIR_EraseRootFromParent_Done,
     /*  993320 */   // Label 14826: @993320
     /*  993320 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(993397), // Rule ID 59927 //
     /*  993325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  993342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  993345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993364 */     // MIs[0] policy
     /*  993364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993395 */     GIR_RootConstrainSelectedInstOperands,
     /*  993396 */     // GIR_Coverage, 59927,
     /*  993396 */     GIR_EraseRootFromParent_Done,
     /*  993397 */   // Label 14827: @993397
     /*  993397 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(993474), // Rule ID 59930 //
     /*  993402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  993419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  993422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993441 */     // MIs[0] policy
     /*  993441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993472 */     GIR_RootConstrainSelectedInstOperands,
     /*  993473 */     // GIR_Coverage, 59930,
     /*  993473 */     GIR_EraseRootFromParent_Done,
     /*  993474 */   // Label 14828: @993474
     /*  993474 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(993551), // Rule ID 59931 //
     /*  993479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  993496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  993499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993518 */     // MIs[0] policy
     /*  993518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /*  993531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993549 */     GIR_RootConstrainSelectedInstOperands,
     /*  993550 */     // GIR_Coverage, 59931,
     /*  993550 */     GIR_EraseRootFromParent_Done,
     /*  993551 */   // Label 14829: @993551
     /*  993551 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(993628), // Rule ID 59934 //
     /*  993556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  993567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  993570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  993573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  993576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  993583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993595 */     // MIs[0] policy
     /*  993595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  993608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993626 */     GIR_RootConstrainSelectedInstOperands,
     /*  993627 */     // GIR_Coverage, 59934,
     /*  993627 */     GIR_EraseRootFromParent_Done,
     /*  993628 */   // Label 14830: @993628
     /*  993628 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(993705), // Rule ID 59935 //
     /*  993633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  993644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  993647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  993650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  993653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  993660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993672 */     // MIs[0] policy
     /*  993672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  993685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993703 */     GIR_RootConstrainSelectedInstOperands,
     /*  993704 */     // GIR_Coverage, 59935,
     /*  993704 */     GIR_EraseRootFromParent_Done,
     /*  993705 */   // Label 14831: @993705
     /*  993705 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(993782), // Rule ID 59938 //
     /*  993710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  993721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  993724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  993727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  993730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  993737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993749 */     // MIs[0] policy
     /*  993749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  993762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993780 */     GIR_RootConstrainSelectedInstOperands,
     /*  993781 */     // GIR_Coverage, 59938,
     /*  993781 */     GIR_EraseRootFromParent_Done,
     /*  993782 */   // Label 14832: @993782
     /*  993782 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(993859), // Rule ID 59939 //
     /*  993787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  993798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  993801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  993804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  993807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  993814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993826 */     // MIs[0] policy
     /*  993826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993836 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  993839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993857 */     GIR_RootConstrainSelectedInstOperands,
     /*  993858 */     // GIR_Coverage, 59939,
     /*  993858 */     GIR_EraseRootFromParent_Done,
     /*  993859 */   // Label 14833: @993859
     /*  993859 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(993936), // Rule ID 59942 //
     /*  993864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  993867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  993875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  993878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  993881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  993884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  993887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993903 */     // MIs[0] policy
     /*  993903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993913 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  993913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  993916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  993924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  993934 */     GIR_RootConstrainSelectedInstOperands,
     /*  993935 */     // GIR_Coverage, 59942,
     /*  993935 */     GIR_EraseRootFromParent_Done,
     /*  993936 */   // Label 14834: @993936
     /*  993936 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(994013), // Rule ID 59943 //
     /*  993941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  993944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  993949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  993952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  993955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  993958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  993961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  993964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993980 */     // MIs[0] policy
     /*  993980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  993983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  993990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  993993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  993999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994011 */     GIR_RootConstrainSelectedInstOperands,
     /*  994012 */     // GIR_Coverage, 59943,
     /*  994012 */     GIR_EraseRootFromParent_Done,
     /*  994013 */   // Label 14835: @994013
     /*  994013 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(994090), // Rule ID 59946 //
     /*  994018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  994029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  994032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  994035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  994038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994057 */     // MIs[0] policy
     /*  994057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  994070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994088 */     GIR_RootConstrainSelectedInstOperands,
     /*  994089 */     // GIR_Coverage, 59946,
     /*  994089 */     GIR_EraseRootFromParent_Done,
     /*  994090 */   // Label 14836: @994090
     /*  994090 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(994167), // Rule ID 59947 //
     /*  994095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  994106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  994109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  994112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  994115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994134 */     // MIs[0] policy
     /*  994134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  994147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994165 */     GIR_RootConstrainSelectedInstOperands,
     /*  994166 */     // GIR_Coverage, 59947,
     /*  994166 */     GIR_EraseRootFromParent_Done,
     /*  994167 */   // Label 14837: @994167
     /*  994167 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(994244), // Rule ID 59950 //
     /*  994172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  994183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  994186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  994189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  994192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994211 */     // MIs[0] policy
     /*  994211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994221 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  994224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994242 */     GIR_RootConstrainSelectedInstOperands,
     /*  994243 */     // GIR_Coverage, 59950,
     /*  994243 */     GIR_EraseRootFromParent_Done,
     /*  994244 */   // Label 14838: @994244
     /*  994244 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(994321), // Rule ID 59951 //
     /*  994249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  994260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  994263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  994266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  994269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994288 */     // MIs[0] policy
     /*  994288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994298 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  994301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994319 */     GIR_RootConstrainSelectedInstOperands,
     /*  994320 */     // GIR_Coverage, 59951,
     /*  994320 */     GIR_EraseRootFromParent_Done,
     /*  994321 */   // Label 14839: @994321
     /*  994321 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(994398), // Rule ID 59954 //
     /*  994326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  994337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  994340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  994343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  994346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994365 */     // MIs[0] policy
     /*  994365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994375 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  994378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994396 */     GIR_RootConstrainSelectedInstOperands,
     /*  994397 */     // GIR_Coverage, 59954,
     /*  994397 */     GIR_EraseRootFromParent_Done,
     /*  994398 */   // Label 14840: @994398
     /*  994398 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(994475), // Rule ID 59955 //
     /*  994403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  994414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  994417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  994420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  994423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994442 */     // MIs[0] policy
     /*  994442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  994455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994473 */     GIR_RootConstrainSelectedInstOperands,
     /*  994474 */     // GIR_Coverage, 59955,
     /*  994474 */     GIR_EraseRootFromParent_Done,
     /*  994475 */   // Label 14841: @994475
     /*  994475 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(994552), // Rule ID 59958 //
     /*  994480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  994497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  994500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994519 */     // MIs[0] policy
     /*  994519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  994532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994550 */     GIR_RootConstrainSelectedInstOperands,
     /*  994551 */     // GIR_Coverage, 59958,
     /*  994551 */     GIR_EraseRootFromParent_Done,
     /*  994552 */   // Label 14842: @994552
     /*  994552 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(994629), // Rule ID 59959 //
     /*  994557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  994574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  994577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994596 */     // MIs[0] policy
     /*  994596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  994609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994627 */     GIR_RootConstrainSelectedInstOperands,
     /*  994628 */     // GIR_Coverage, 59959,
     /*  994628 */     GIR_EraseRootFromParent_Done,
     /*  994629 */   // Label 14843: @994629
     /*  994629 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(994706), // Rule ID 59962 //
     /*  994634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  994651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  994654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994673 */     // MIs[0] policy
     /*  994673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994683 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  994686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994704 */     GIR_RootConstrainSelectedInstOperands,
     /*  994705 */     // GIR_Coverage, 59962,
     /*  994705 */     GIR_EraseRootFromParent_Done,
     /*  994706 */   // Label 14844: @994706
     /*  994706 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(994783), // Rule ID 59963 //
     /*  994711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  994728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  994731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994750 */     // MIs[0] policy
     /*  994750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  994763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994781 */     GIR_RootConstrainSelectedInstOperands,
     /*  994782 */     // GIR_Coverage, 59963,
     /*  994782 */     GIR_EraseRootFromParent_Done,
     /*  994783 */   // Label 14845: @994783
     /*  994783 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(994860), // Rule ID 59966 //
     /*  994788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  994805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  994808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994827 */     // MIs[0] policy
     /*  994827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994837 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  994840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994858 */     GIR_RootConstrainSelectedInstOperands,
     /*  994859 */     // GIR_Coverage, 59966,
     /*  994859 */     GIR_EraseRootFromParent_Done,
     /*  994860 */   // Label 14846: @994860
     /*  994860 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(994937), // Rule ID 59967 //
     /*  994865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  994868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  994882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  994885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  994888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994904 */     // MIs[0] policy
     /*  994904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  994914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  994917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  994923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  994925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  994935 */     GIR_RootConstrainSelectedInstOperands,
     /*  994936 */     // GIR_Coverage, 59967,
     /*  994936 */     GIR_EraseRootFromParent_Done,
     /*  994937 */   // Label 14847: @994937
     /*  994937 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(995014), // Rule ID 59970 //
     /*  994942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  994945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  994950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  994959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  994962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  994965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994981 */     // MIs[0] policy
     /*  994981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  994984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  994991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  994994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995012 */     GIR_RootConstrainSelectedInstOperands,
     /*  995013 */     // GIR_Coverage, 59970,
     /*  995013 */     GIR_EraseRootFromParent_Done,
     /*  995014 */   // Label 14848: @995014
     /*  995014 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(995091), // Rule ID 59971 //
     /*  995019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  995027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  995036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  995039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995058 */     // MIs[0] policy
     /*  995058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /*  995071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995089 */     GIR_RootConstrainSelectedInstOperands,
     /*  995090 */     // GIR_Coverage, 59971,
     /*  995090 */     GIR_EraseRootFromParent_Done,
     /*  995091 */   // Label 14849: @995091
     /*  995091 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(995168), // Rule ID 59974 //
     /*  995096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  995104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  995113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  995116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995135 */     // MIs[0] policy
     /*  995135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  995148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995166 */     GIR_RootConstrainSelectedInstOperands,
     /*  995167 */     // GIR_Coverage, 59974,
     /*  995167 */     GIR_EraseRootFromParent_Done,
     /*  995168 */   // Label 14850: @995168
     /*  995168 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(995245), // Rule ID 59975 //
     /*  995173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  995181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  995190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  995193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995212 */     // MIs[0] policy
     /*  995212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /*  995225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995243 */     GIR_RootConstrainSelectedInstOperands,
     /*  995244 */     // GIR_Coverage, 59975,
     /*  995244 */     GIR_EraseRootFromParent_Done,
     /*  995245 */   // Label 14851: @995245
     /*  995245 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(995322), // Rule ID 59978 //
     /*  995250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  995258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  995267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  995270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995289 */     // MIs[0] policy
     /*  995289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  995302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995320 */     GIR_RootConstrainSelectedInstOperands,
     /*  995321 */     // GIR_Coverage, 59978,
     /*  995321 */     GIR_EraseRootFromParent_Done,
     /*  995322 */   // Label 14852: @995322
     /*  995322 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(995399), // Rule ID 59979 //
     /*  995327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /*  995335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  995344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  995347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995366 */     // MIs[0] policy
     /*  995366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /*  995379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  995395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995397 */     GIR_RootConstrainSelectedInstOperands,
     /*  995398 */     // GIR_Coverage, 59979,
     /*  995398 */     GIR_EraseRootFromParent_Done,
     /*  995399 */   // Label 14853: @995399
     /*  995399 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(995476), // Rule ID 59982 //
     /*  995404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995443 */     // MIs[0] policy
     /*  995443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995453 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /*  995456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995474 */     GIR_RootConstrainSelectedInstOperands,
     /*  995475 */     // GIR_Coverage, 59982,
     /*  995475 */     GIR_EraseRootFromParent_Done,
     /*  995476 */   // Label 14854: @995476
     /*  995476 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(995553), // Rule ID 59983 //
     /*  995481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995520 */     // MIs[0] policy
     /*  995520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /*  995533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995551 */     GIR_RootConstrainSelectedInstOperands,
     /*  995552 */     // GIR_Coverage, 59983,
     /*  995552 */     GIR_EraseRootFromParent_Done,
     /*  995553 */   // Label 14855: @995553
     /*  995553 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(995630), // Rule ID 59986 //
     /*  995558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  995569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  995572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  995575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  995578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995597 */     // MIs[0] policy
     /*  995597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995607 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /*  995610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995628 */     GIR_RootConstrainSelectedInstOperands,
     /*  995629 */     // GIR_Coverage, 59986,
     /*  995629 */     GIR_EraseRootFromParent_Done,
     /*  995630 */   // Label 14856: @995630
     /*  995630 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(995707), // Rule ID 59987 //
     /*  995635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  995646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  995649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  995652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  995655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995674 */     // MIs[0] policy
     /*  995674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /*  995687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995705 */     GIR_RootConstrainSelectedInstOperands,
     /*  995706 */     // GIR_Coverage, 59987,
     /*  995706 */     GIR_EraseRootFromParent_Done,
     /*  995707 */   // Label 14857: @995707
     /*  995707 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(995784), // Rule ID 59990 //
     /*  995712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  995723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  995726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  995729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  995732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995751 */     // MIs[0] policy
     /*  995751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995761 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  995764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995782 */     GIR_RootConstrainSelectedInstOperands,
     /*  995783 */     // GIR_Coverage, 59990,
     /*  995783 */     GIR_EraseRootFromParent_Done,
     /*  995784 */   // Label 14858: @995784
     /*  995784 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(995861), // Rule ID 59991 //
     /*  995789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  995800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  995803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  995806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  995809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995828 */     // MIs[0] policy
     /*  995828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995838 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  995841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995859 */     GIR_RootConstrainSelectedInstOperands,
     /*  995860 */     // GIR_Coverage, 59991,
     /*  995860 */     GIR_EraseRootFromParent_Done,
     /*  995861 */   // Label 14859: @995861
     /*  995861 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(995938), // Rule ID 59994 //
     /*  995866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  995869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995905 */     // MIs[0] policy
     /*  995905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995915 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /*  995918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995936 */     GIR_RootConstrainSelectedInstOperands,
     /*  995937 */     // GIR_Coverage, 59994,
     /*  995937 */     GIR_EraseRootFromParent_Done,
     /*  995938 */   // Label 14860: @995938
     /*  995938 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(996015), // Rule ID 59995 //
     /*  995943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  995946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  995951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995982 */     // MIs[0] policy
     /*  995982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /*  995995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996013 */     GIR_RootConstrainSelectedInstOperands,
     /*  996014 */     // GIR_Coverage, 59995,
     /*  996014 */     GIR_EraseRootFromParent_Done,
     /*  996015 */   // Label 14861: @996015
     /*  996015 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(996092), // Rule ID 59998 //
     /*  996020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  996037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996059 */     // MIs[0] policy
     /*  996059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996069 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  996072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996090 */     GIR_RootConstrainSelectedInstOperands,
     /*  996091 */     // GIR_Coverage, 59998,
     /*  996091 */     GIR_EraseRootFromParent_Done,
     /*  996092 */   // Label 14862: @996092
     /*  996092 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(996169), // Rule ID 59999 //
     /*  996097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  996114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996136 */     // MIs[0] policy
     /*  996136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  996149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996167 */     GIR_RootConstrainSelectedInstOperands,
     /*  996168 */     // GIR_Coverage, 59999,
     /*  996168 */     GIR_EraseRootFromParent_Done,
     /*  996169 */   // Label 14863: @996169
     /*  996169 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(996246), // Rule ID 60002 //
     /*  996174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  996191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996213 */     // MIs[0] policy
     /*  996213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  996226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996244 */     GIR_RootConstrainSelectedInstOperands,
     /*  996245 */     // GIR_Coverage, 60002,
     /*  996245 */     GIR_EraseRootFromParent_Done,
     /*  996246 */   // Label 14864: @996246
     /*  996246 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(996323), // Rule ID 60003 //
     /*  996251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  996268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996290 */     // MIs[0] policy
     /*  996290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /*  996303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996321 */     GIR_RootConstrainSelectedInstOperands,
     /*  996322 */     // GIR_Coverage, 60003,
     /*  996322 */     GIR_EraseRootFromParent_Done,
     /*  996323 */   // Label 14865: @996323
     /*  996323 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(996400), // Rule ID 60006 //
     /*  996328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  996339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  996342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996367 */     // MIs[0] policy
     /*  996367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996398 */     GIR_RootConstrainSelectedInstOperands,
     /*  996399 */     // GIR_Coverage, 60006,
     /*  996399 */     GIR_EraseRootFromParent_Done,
     /*  996400 */   // Label 14866: @996400
     /*  996400 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(996477), // Rule ID 60007 //
     /*  996405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  996416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  996419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996444 */     // MIs[0] policy
     /*  996444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10864:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996475 */     GIR_RootConstrainSelectedInstOperands,
     /*  996476 */     // GIR_Coverage, 60007,
     /*  996476 */     GIR_EraseRootFromParent_Done,
     /*  996477 */   // Label 14867: @996477
     /*  996477 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(996554), // Rule ID 60010 //
     /*  996482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  996499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996521 */     // MIs[0] policy
     /*  996521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996531 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996552 */     GIR_RootConstrainSelectedInstOperands,
     /*  996553 */     // GIR_Coverage, 60010,
     /*  996553 */     GIR_EraseRootFromParent_Done,
     /*  996554 */   // Label 14868: @996554
     /*  996554 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(996631), // Rule ID 60011 //
     /*  996559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  996576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996598 */     // MIs[0] policy
     /*  996598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996629 */     GIR_RootConstrainSelectedInstOperands,
     /*  996630 */     // GIR_Coverage, 60011,
     /*  996630 */     GIR_EraseRootFromParent_Done,
     /*  996631 */   // Label 14869: @996631
     /*  996631 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(996708), // Rule ID 60014 //
     /*  996636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  996653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996675 */     // MIs[0] policy
     /*  996675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996685 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996706 */     GIR_RootConstrainSelectedInstOperands,
     /*  996707 */     // GIR_Coverage, 60014,
     /*  996707 */     GIR_EraseRootFromParent_Done,
     /*  996708 */   // Label 14870: @996708
     /*  996708 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(996785), // Rule ID 60015 //
     /*  996713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  996730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996752 */     // MIs[0] policy
     /*  996752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996783 */     GIR_RootConstrainSelectedInstOperands,
     /*  996784 */     // GIR_Coverage, 60015,
     /*  996784 */     GIR_EraseRootFromParent_Done,
     /*  996785 */   // Label 14871: @996785
     /*  996785 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(996862), // Rule ID 60018 //
     /*  996790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  996801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  996804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  996807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996829 */     // MIs[0] policy
     /*  996829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996839 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996860 */     GIR_RootConstrainSelectedInstOperands,
     /*  996861 */     // GIR_Coverage, 60018,
     /*  996861 */     GIR_EraseRootFromParent_Done,
     /*  996862 */   // Label 14872: @996862
     /*  996862 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(996939), // Rule ID 60019 //
     /*  996867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  996870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  996878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  996881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  996884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996906 */     // MIs[0] policy
     /*  996906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /*  996919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996937 */     GIR_RootConstrainSelectedInstOperands,
     /*  996938 */     // GIR_Coverage, 60019,
     /*  996938 */     GIR_EraseRootFromParent_Done,
     /*  996939 */   // Label 14873: @996939
     /*  996939 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(997016), // Rule ID 60022 //
     /*  996944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  996947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  996952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  996955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  996958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996983 */     // MIs[0] policy
     /*  996983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  996996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997014 */     GIR_RootConstrainSelectedInstOperands,
     /*  997015 */     // GIR_Coverage, 60022,
     /*  997015 */     GIR_EraseRootFromParent_Done,
     /*  997016 */   // Label 14874: @997016
     /*  997016 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(997093), // Rule ID 60023 //
     /*  997021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  997032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  997035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  997038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997060 */     // MIs[0] policy
     /*  997060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997070 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  997073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997091 */     GIR_RootConstrainSelectedInstOperands,
     /*  997092 */     // GIR_Coverage, 60023,
     /*  997092 */     GIR_EraseRootFromParent_Done,
     /*  997093 */   // Label 14875: @997093
     /*  997093 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(997170), // Rule ID 60026 //
     /*  997098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  997109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  997112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997137 */     // MIs[0] policy
     /*  997137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997147 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  997150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997168 */     GIR_RootConstrainSelectedInstOperands,
     /*  997169 */     // GIR_Coverage, 60026,
     /*  997169 */     GIR_EraseRootFromParent_Done,
     /*  997170 */   // Label 14876: @997170
     /*  997170 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(997247), // Rule ID 60027 //
     /*  997175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  997186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  997189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997214 */     // MIs[0] policy
     /*  997214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  997227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997245 */     GIR_RootConstrainSelectedInstOperands,
     /*  997246 */     // GIR_Coverage, 60027,
     /*  997246 */     GIR_EraseRootFromParent_Done,
     /*  997247 */   // Label 14877: @997247
     /*  997247 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(997324), // Rule ID 60030 //
     /*  997252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  997263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  997266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  997269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  997272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997291 */     // MIs[0] policy
     /*  997291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997301 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  997304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997322 */     GIR_RootConstrainSelectedInstOperands,
     /*  997323 */     // GIR_Coverage, 60030,
     /*  997323 */     GIR_EraseRootFromParent_Done,
     /*  997324 */   // Label 14878: @997324
     /*  997324 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(997401), // Rule ID 60031 //
     /*  997329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  997340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  997343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  997346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  997349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997368 */     // MIs[0] policy
     /*  997368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  997381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  997397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997399 */     GIR_RootConstrainSelectedInstOperands,
     /*  997400 */     // GIR_Coverage, 60031,
     /*  997400 */     GIR_EraseRootFromParent_Done,
     /*  997401 */   // Label 14879: @997401
     /*  997401 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(997478), // Rule ID 60034 //
     /*  997406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997445 */     // MIs[0] policy
     /*  997445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  997458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997476 */     GIR_RootConstrainSelectedInstOperands,
     /*  997477 */     // GIR_Coverage, 60034,
     /*  997477 */     GIR_EraseRootFromParent_Done,
     /*  997478 */   // Label 14880: @997478
     /*  997478 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(997555), // Rule ID 60035 //
     /*  997483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997522 */     // MIs[0] policy
     /*  997522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  997535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997553 */     GIR_RootConstrainSelectedInstOperands,
     /*  997554 */     // GIR_Coverage, 60035,
     /*  997554 */     GIR_EraseRootFromParent_Done,
     /*  997555 */   // Label 14881: @997555
     /*  997555 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(997632), // Rule ID 60038 //
     /*  997560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997599 */     // MIs[0] policy
     /*  997599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997609 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  997612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997630 */     GIR_RootConstrainSelectedInstOperands,
     /*  997631 */     // GIR_Coverage, 60038,
     /*  997631 */     GIR_EraseRootFromParent_Done,
     /*  997632 */   // Label 14882: @997632
     /*  997632 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(997709), // Rule ID 60039 //
     /*  997637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997676 */     // MIs[0] policy
     /*  997676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997686 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  997689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997707 */     GIR_RootConstrainSelectedInstOperands,
     /*  997708 */     // GIR_Coverage, 60039,
     /*  997708 */     GIR_EraseRootFromParent_Done,
     /*  997709 */   // Label 14883: @997709
     /*  997709 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(997786), // Rule ID 60042 //
     /*  997714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  997731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997753 */     // MIs[0] policy
     /*  997753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997763 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  997766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997784 */     GIR_RootConstrainSelectedInstOperands,
     /*  997785 */     // GIR_Coverage, 60042,
     /*  997785 */     GIR_EraseRootFromParent_Done,
     /*  997786 */   // Label 14884: @997786
     /*  997786 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(997863), // Rule ID 60043 //
     /*  997791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  997808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997830 */     // MIs[0] policy
     /*  997830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997840 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  997843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997861 */     GIR_RootConstrainSelectedInstOperands,
     /*  997862 */     // GIR_Coverage, 60043,
     /*  997862 */     GIR_EraseRootFromParent_Done,
     /*  997863 */   // Label 14885: @997863
     /*  997863 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(997940), // Rule ID 60046 //
     /*  997868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  997871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  997885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997907 */     // MIs[0] policy
     /*  997907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  997920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997938 */     GIR_RootConstrainSelectedInstOperands,
     /*  997939 */     // GIR_Coverage, 60046,
     /*  997939 */     GIR_EraseRootFromParent_Done,
     /*  997940 */   // Label 14886: @997940
     /*  997940 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(998017), // Rule ID 60047 //
     /*  997945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  997948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  997953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  997962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997984 */     // MIs[0] policy
     /*  997984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  997997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998015 */     GIR_RootConstrainSelectedInstOperands,
     /*  998016 */     // GIR_Coverage, 60047,
     /*  998016 */     GIR_EraseRootFromParent_Done,
     /*  998017 */   // Label 14887: @998017
     /*  998017 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(998094), // Rule ID 60050 //
     /*  998022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998061 */     // MIs[0] policy
     /*  998061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998071 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  998074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998092 */     GIR_RootConstrainSelectedInstOperands,
     /*  998093 */     // GIR_Coverage, 60050,
     /*  998093 */     GIR_EraseRootFromParent_Done,
     /*  998094 */   // Label 14888: @998094
     /*  998094 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(998171), // Rule ID 60051 //
     /*  998099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998138 */     // MIs[0] policy
     /*  998138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  998151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998169 */     GIR_RootConstrainSelectedInstOperands,
     /*  998170 */     // GIR_Coverage, 60051,
     /*  998170 */     GIR_EraseRootFromParent_Done,
     /*  998171 */   // Label 14889: @998171
     /*  998171 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(998248), // Rule ID 60054 //
     /*  998176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  998193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998215 */     // MIs[0] policy
     /*  998215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998225 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  998228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998246 */     GIR_RootConstrainSelectedInstOperands,
     /*  998247 */     // GIR_Coverage, 60054,
     /*  998247 */     GIR_EraseRootFromParent_Done,
     /*  998248 */   // Label 14890: @998248
     /*  998248 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(998325), // Rule ID 60055 //
     /*  998253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  998270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998292 */     // MIs[0] policy
     /*  998292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  998305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998323 */     GIR_RootConstrainSelectedInstOperands,
     /*  998324 */     // GIR_Coverage, 60055,
     /*  998324 */     GIR_EraseRootFromParent_Done,
     /*  998325 */   // Label 14891: @998325
     /*  998325 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(998402), // Rule ID 60058 //
     /*  998330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  998347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998369 */     // MIs[0] policy
     /*  998369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  998382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998400 */     GIR_RootConstrainSelectedInstOperands,
     /*  998401 */     // GIR_Coverage, 60058,
     /*  998401 */     GIR_EraseRootFromParent_Done,
     /*  998402 */   // Label 14892: @998402
     /*  998402 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(998479), // Rule ID 60059 //
     /*  998407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  998424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998446 */     // MIs[0] policy
     /*  998446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10864:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /*  998459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998477 */     GIR_RootConstrainSelectedInstOperands,
     /*  998478 */     // GIR_Coverage, 60059,
     /*  998478 */     GIR_EraseRootFromParent_Done,
     /*  998479 */   // Label 14893: @998479
     /*  998479 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(998556), // Rule ID 60062 //
     /*  998484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  998501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998523 */     // MIs[0] policy
     /*  998523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998533 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  998536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998554 */     GIR_RootConstrainSelectedInstOperands,
     /*  998555 */     // GIR_Coverage, 60062,
     /*  998555 */     GIR_EraseRootFromParent_Done,
     /*  998556 */   // Label 14894: @998556
     /*  998556 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(998633), // Rule ID 60063 //
     /*  998561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  998578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998600 */     // MIs[0] policy
     /*  998600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998610 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10864:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /*  998613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998631 */     GIR_RootConstrainSelectedInstOperands,
     /*  998632 */     // GIR_Coverage, 60063,
     /*  998632 */     GIR_EraseRootFromParent_Done,
     /*  998633 */   // Label 14895: @998633
     /*  998633 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(998710), // Rule ID 60066 //
     /*  998638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  998655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998677 */     // MIs[0] policy
     /*  998677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998687 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  998690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998708 */     GIR_RootConstrainSelectedInstOperands,
     /*  998709 */     // GIR_Coverage, 60066,
     /*  998709 */     GIR_EraseRootFromParent_Done,
     /*  998710 */   // Label 14896: @998710
     /*  998710 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(998787), // Rule ID 60067 //
     /*  998715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /*  998723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  998732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998754 */     // MIs[0] policy
     /*  998754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10864:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /*  998767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998785 */     GIR_RootConstrainSelectedInstOperands,
     /*  998786 */     // GIR_Coverage, 60067,
     /*  998786 */     GIR_EraseRootFromParent_Done,
     /*  998787 */   // Label 14897: @998787
     /*  998787 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(998864), // Rule ID 60070 //
     /*  998792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  998800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  998803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  998806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998831 */     // MIs[0] policy
     /*  998831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998841 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /*  998844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  998860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998862 */     GIR_RootConstrainSelectedInstOperands,
     /*  998863 */     // GIR_Coverage, 60070,
     /*  998863 */     GIR_EraseRootFromParent_Done,
     /*  998864 */   // Label 14898: @998864
     /*  998864 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(998941), // Rule ID 60071 //
     /*  998869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  998872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  998877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  998880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  998883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998908 */     // MIs[0] policy
     /*  998908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /*  998921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  998937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998939 */     GIR_RootConstrainSelectedInstOperands,
     /*  998940 */     // GIR_Coverage, 60071,
     /*  998940 */     GIR_EraseRootFromParent_Done,
     /*  998941 */   // Label 14899: @998941
     /*  998941 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(999018), // Rule ID 60074 //
     /*  998946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  998949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  998954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  998957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  998960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998985 */     // MIs[0] policy
     /*  998985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /*  998998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999016 */     GIR_RootConstrainSelectedInstOperands,
     /*  999017 */     // GIR_Coverage, 60074,
     /*  999017 */     GIR_EraseRootFromParent_Done,
     /*  999018 */   // Label 14900: @999018
     /*  999018 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(999095), // Rule ID 60075 //
     /*  999023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  999034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  999037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999062 */     // MIs[0] policy
     /*  999062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999072 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /*  999075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999093 */     GIR_RootConstrainSelectedInstOperands,
     /*  999094 */     // GIR_Coverage, 60075,
     /*  999094 */     GIR_EraseRootFromParent_Done,
     /*  999095 */   // Label 14901: @999095
     /*  999095 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(999172), // Rule ID 60078 //
     /*  999100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  999111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  999114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999139 */     // MIs[0] policy
     /*  999139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999149 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999170 */     GIR_RootConstrainSelectedInstOperands,
     /*  999171 */     // GIR_Coverage, 60078,
     /*  999171 */     GIR_EraseRootFromParent_Done,
     /*  999172 */   // Label 14902: @999172
     /*  999172 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(999249), // Rule ID 60079 //
     /*  999177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  999188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  999191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999216 */     // MIs[0] policy
     /*  999216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999247 */     GIR_RootConstrainSelectedInstOperands,
     /*  999248 */     // GIR_Coverage, 60079,
     /*  999248 */     GIR_EraseRootFromParent_Done,
     /*  999249 */   // Label 14903: @999249
     /*  999249 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(999326), // Rule ID 60082 //
     /*  999254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999293 */     // MIs[0] policy
     /*  999293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /*  999306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999324 */     GIR_RootConstrainSelectedInstOperands,
     /*  999325 */     // GIR_Coverage, 60082,
     /*  999325 */     GIR_EraseRootFromParent_Done,
     /*  999326 */   // Label 14904: @999326
     /*  999326 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(999403), // Rule ID 60083 //
     /*  999331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999370 */     // MIs[0] policy
     /*  999370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /*  999383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999401 */     GIR_RootConstrainSelectedInstOperands,
     /*  999402 */     // GIR_Coverage, 60083,
     /*  999402 */     GIR_EraseRootFromParent_Done,
     /*  999403 */   // Label 14905: @999403
     /*  999403 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(999480), // Rule ID 60086 //
     /*  999408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  999419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  999422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999447 */     // MIs[0] policy
     /*  999447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999457 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999478 */     GIR_RootConstrainSelectedInstOperands,
     /*  999479 */     // GIR_Coverage, 60086,
     /*  999479 */     GIR_EraseRootFromParent_Done,
     /*  999480 */   // Label 14906: @999480
     /*  999480 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(999557), // Rule ID 60087 //
     /*  999485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  999496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  999499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999524 */     // MIs[0] policy
     /*  999524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999555 */     GIR_RootConstrainSelectedInstOperands,
     /*  999556 */     // GIR_Coverage, 60087,
     /*  999556 */     GIR_EraseRootFromParent_Done,
     /*  999557 */   // Label 14907: @999557
     /*  999557 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(999634), // Rule ID 60090 //
     /*  999562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  999573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  999576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  999579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999601 */     // MIs[0] policy
     /*  999601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999611 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999632 */     GIR_RootConstrainSelectedInstOperands,
     /*  999633 */     // GIR_Coverage, 60090,
     /*  999633 */     GIR_EraseRootFromParent_Done,
     /*  999634 */   // Label 14908: @999634
     /*  999634 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(999711), // Rule ID 60091 //
     /*  999639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  999650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  999653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  999656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999678 */     // MIs[0] policy
     /*  999678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999688 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /*  999691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999709 */     GIR_RootConstrainSelectedInstOperands,
     /*  999710 */     // GIR_Coverage, 60091,
     /*  999710 */     GIR_EraseRootFromParent_Done,
     /*  999711 */   // Label 14909: @999711
     /*  999711 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(999788), // Rule ID 60094 //
     /*  999716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  999727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  999730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999755 */     // MIs[0] policy
     /*  999755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999765 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /*  999768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999786 */     GIR_RootConstrainSelectedInstOperands,
     /*  999787 */     // GIR_Coverage, 60094,
     /*  999787 */     GIR_EraseRootFromParent_Done,
     /*  999788 */   // Label 14910: @999788
     /*  999788 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(999865), // Rule ID 60095 //
     /*  999793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  999804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  999807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999832 */     // MIs[0] policy
     /*  999832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999842 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10871:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /*  999845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999863 */     GIR_RootConstrainSelectedInstOperands,
     /*  999864 */     // GIR_Coverage, 60095,
     /*  999864 */     GIR_EraseRootFromParent_Done,
     /*  999865 */   // Label 14911: @999865
     /*  999865 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(999942), // Rule ID 60098 //
     /*  999870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  999873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  999881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  999884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999909 */     // MIs[0] policy
     /*  999909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /*  999922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999940 */     GIR_RootConstrainSelectedInstOperands,
     /*  999941 */     // GIR_Coverage, 60098,
     /*  999941 */     GIR_EraseRootFromParent_Done,
     /*  999942 */   // Label 14912: @999942
     /*  999942 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1000019), // Rule ID 60099 //
     /*  999947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  999950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /*  999955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  999958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  999961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999986 */     // MIs[0] policy
     /*  999986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /*  999999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000018 */     // GIR_Coverage, 60099,
     /* 1000018 */     GIR_EraseRootFromParent_Done,
     /* 1000019 */   // Label 14913: @1000019
     /* 1000019 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1000096), // Rule ID 60102 //
     /* 1000024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1000035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1000038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1000041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000063 */     // MIs[0] policy
     /* 1000063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000073 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1000076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1000092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000095 */     // GIR_Coverage, 60102,
     /* 1000095 */     GIR_EraseRootFromParent_Done,
     /* 1000096 */   // Label 14914: @1000096
     /* 1000096 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1000173), // Rule ID 60103 //
     /* 1000101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1000112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1000115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1000118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000140 */     // MIs[0] policy
     /* 1000140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1000153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1000169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000172 */     // GIR_Coverage, 60103,
     /* 1000172 */     GIR_EraseRootFromParent_Done,
     /* 1000173 */   // Label 14915: @1000173
     /* 1000173 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1000250), // Rule ID 60106 //
     /* 1000178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1000195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000217 */     // MIs[0] policy
     /* 1000217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1000230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000249 */     // GIR_Coverage, 60106,
     /* 1000249 */     GIR_EraseRootFromParent_Done,
     /* 1000250 */   // Label 14916: @1000250
     /* 1000250 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1000327), // Rule ID 60107 //
     /* 1000255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1000272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000294 */     // MIs[0] policy
     /* 1000294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1000307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000326 */     // GIR_Coverage, 60107,
     /* 1000326 */     GIR_EraseRootFromParent_Done,
     /* 1000327 */   // Label 14917: @1000327
     /* 1000327 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1000404), // Rule ID 60110 //
     /* 1000332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1000343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1000346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000371 */     // MIs[0] policy
     /* 1000371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000381 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1000384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000403 */     // GIR_Coverage, 60110,
     /* 1000403 */     GIR_EraseRootFromParent_Done,
     /* 1000404 */   // Label 14918: @1000404
     /* 1000404 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1000481), // Rule ID 60111 //
     /* 1000409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1000420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1000423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000448 */     // MIs[0] policy
     /* 1000448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1000461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000480 */     // GIR_Coverage, 60111,
     /* 1000480 */     GIR_EraseRootFromParent_Done,
     /* 1000481 */   // Label 14919: @1000481
     /* 1000481 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1000558), // Rule ID 60114 //
     /* 1000486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1000497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1000500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000525 */     // MIs[0] policy
     /* 1000525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000535 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1000538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000557 */     // GIR_Coverage, 60114,
     /* 1000557 */     GIR_EraseRootFromParent_Done,
     /* 1000558 */   // Label 14920: @1000558
     /* 1000558 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1000635), // Rule ID 60115 //
     /* 1000563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1000574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1000577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000602 */     // MIs[0] policy
     /* 1000602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1000615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000634 */     // GIR_Coverage, 60115,
     /* 1000634 */     GIR_EraseRootFromParent_Done,
     /* 1000635 */   // Label 14921: @1000635
     /* 1000635 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1000712), // Rule ID 60118 //
     /* 1000640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1000651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1000654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1000657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1000660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000679 */     // MIs[0] policy
     /* 1000679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000689 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1000692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000711 */     // GIR_Coverage, 60118,
     /* 1000711 */     GIR_EraseRootFromParent_Done,
     /* 1000712 */   // Label 14922: @1000712
     /* 1000712 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1000789), // Rule ID 60119 //
     /* 1000717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1000728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1000731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1000734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1000737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000756 */     // MIs[0] policy
     /* 1000756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000766 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1000769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000788 */     // GIR_Coverage, 60119,
     /* 1000788 */     GIR_EraseRootFromParent_Done,
     /* 1000789 */   // Label 14923: @1000789
     /* 1000789 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1000866), // Rule ID 60122 //
     /* 1000794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000833 */     // MIs[0] policy
     /* 1000833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1000846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000865 */     // GIR_Coverage, 60122,
     /* 1000865 */     GIR_EraseRootFromParent_Done,
     /* 1000866 */   // Label 14924: @1000866
     /* 1000866 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1000943), // Rule ID 60123 //
     /* 1000871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1000874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000910 */     // MIs[0] policy
     /* 1000910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1000923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000942 */     // GIR_Coverage, 60123,
     /* 1000942 */     GIR_EraseRootFromParent_Done,
     /* 1000943 */   // Label 14925: @1000943
     /* 1000943 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1001020), // Rule ID 60126 //
     /* 1000948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1000951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1000956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1000965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000987 */     // MIs[0] policy
     /* 1000987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000997 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1001000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001019 */     // GIR_Coverage, 60126,
     /* 1001019 */     GIR_EraseRootFromParent_Done,
     /* 1001020 */   // Label 14926: @1001020
     /* 1001020 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1001097), // Rule ID 60127 //
     /* 1001025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001064 */     // MIs[0] policy
     /* 1001064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1001077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001096 */     // GIR_Coverage, 60127,
     /* 1001096 */     GIR_EraseRootFromParent_Done,
     /* 1001097 */   // Label 14927: @1001097
     /* 1001097 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1001174), // Rule ID 60130 //
     /* 1001102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1001119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001141 */     // MIs[0] policy
     /* 1001141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1001154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001173 */     // GIR_Coverage, 60130,
     /* 1001173 */     GIR_EraseRootFromParent_Done,
     /* 1001174 */   // Label 14928: @1001174
     /* 1001174 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1001251), // Rule ID 60131 //
     /* 1001179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1001196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001218 */     // MIs[0] policy
     /* 1001218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1001231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001250 */     // GIR_Coverage, 60131,
     /* 1001250 */     GIR_EraseRootFromParent_Done,
     /* 1001251 */   // Label 14929: @1001251
     /* 1001251 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1001328), // Rule ID 60134 //
     /* 1001256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1001273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001295 */     // MIs[0] policy
     /* 1001295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1001308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001327 */     // GIR_Coverage, 60134,
     /* 1001327 */     GIR_EraseRootFromParent_Done,
     /* 1001328 */   // Label 14930: @1001328
     /* 1001328 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1001405), // Rule ID 60135 //
     /* 1001333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1001350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001372 */     // MIs[0] policy
     /* 1001372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1001385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001404 */     // GIR_Coverage, 60135,
     /* 1001404 */     GIR_EraseRootFromParent_Done,
     /* 1001405 */   // Label 14931: @1001405
     /* 1001405 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1001482), // Rule ID 60138 //
     /* 1001410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1001427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001449 */     // MIs[0] policy
     /* 1001449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1001462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001481 */     // GIR_Coverage, 60138,
     /* 1001481 */     GIR_EraseRootFromParent_Done,
     /* 1001482 */   // Label 14932: @1001482
     /* 1001482 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1001559), // Rule ID 60139 //
     /* 1001487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1001504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001526 */     // MIs[0] policy
     /* 1001526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1001539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001558 */     // GIR_Coverage, 60139,
     /* 1001558 */     GIR_EraseRootFromParent_Done,
     /* 1001559 */   // Label 14933: @1001559
     /* 1001559 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1001636), // Rule ID 60142 //
     /* 1001564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1001581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001603 */     // MIs[0] policy
     /* 1001603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001613 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1001616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001635 */     // GIR_Coverage, 60142,
     /* 1001635 */     GIR_EraseRootFromParent_Done,
     /* 1001636 */   // Label 14934: @1001636
     /* 1001636 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1001713), // Rule ID 60143 //
     /* 1001641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1001658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001680 */     // MIs[0] policy
     /* 1001680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001690 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1001693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001712 */     // GIR_Coverage, 60143,
     /* 1001712 */     GIR_EraseRootFromParent_Done,
     /* 1001713 */   // Label 14935: @1001713
     /* 1001713 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1001790), // Rule ID 60146 //
     /* 1001718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1001735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001757 */     // MIs[0] policy
     /* 1001757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1001770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001789 */     // GIR_Coverage, 60146,
     /* 1001789 */     GIR_EraseRootFromParent_Done,
     /* 1001790 */   // Label 14936: @1001790
     /* 1001790 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1001867), // Rule ID 60147 //
     /* 1001795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1001812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001834 */     // MIs[0] policy
     /* 1001834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1001847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001866 */     // GIR_Coverage, 60147,
     /* 1001866 */     GIR_EraseRootFromParent_Done,
     /* 1001867 */   // Label 14937: @1001867
     /* 1001867 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1001944), // Rule ID 60150 //
     /* 1001872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1001875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1001883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1001886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1001889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001911 */     // MIs[0] policy
     /* 1001911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001921 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1001924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001943 */     // GIR_Coverage, 60150,
     /* 1001943 */     GIR_EraseRootFromParent_Done,
     /* 1001944 */   // Label 14938: @1001944
     /* 1001944 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1002021), // Rule ID 60151 //
     /* 1001949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1001952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1001957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1001960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1001963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1001966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001988 */     // MIs[0] policy
     /* 1001988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1002001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002020 */     // GIR_Coverage, 60151,
     /* 1002020 */     GIR_EraseRootFromParent_Done,
     /* 1002021 */   // Label 14939: @1002021
     /* 1002021 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1002098), // Rule ID 60154 //
     /* 1002026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1002034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1002043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002065 */     // MIs[0] policy
     /* 1002065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002075 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1002078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002097 */     // GIR_Coverage, 60154,
     /* 1002097 */     GIR_EraseRootFromParent_Done,
     /* 1002098 */   // Label 14940: @1002098
     /* 1002098 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1002175), // Rule ID 60155 //
     /* 1002103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1002111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1002120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002142 */     // MIs[0] policy
     /* 1002142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1002155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002174 */     // GIR_Coverage, 60155,
     /* 1002174 */     GIR_EraseRootFromParent_Done,
     /* 1002175 */   // Label 14941: @1002175
     /* 1002175 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1002252), // Rule ID 60158 //
     /* 1002180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1002191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1002194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002219 */     // MIs[0] policy
     /* 1002219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002229 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1002232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002251 */     // GIR_Coverage, 60158,
     /* 1002251 */     GIR_EraseRootFromParent_Done,
     /* 1002252 */   // Label 14942: @1002252
     /* 1002252 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1002329), // Rule ID 60159 //
     /* 1002257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1002268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1002271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002296 */     // MIs[0] policy
     /* 1002296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1002309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002328 */     // GIR_Coverage, 60159,
     /* 1002328 */     GIR_EraseRootFromParent_Done,
     /* 1002329 */   // Label 14943: @1002329
     /* 1002329 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1002406), // Rule ID 60162 //
     /* 1002334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1002345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1002348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002373 */     // MIs[0] policy
     /* 1002373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002383 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1002386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002405 */     // GIR_Coverage, 60162,
     /* 1002405 */     GIR_EraseRootFromParent_Done,
     /* 1002406 */   // Label 14944: @1002406
     /* 1002406 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1002483), // Rule ID 60163 //
     /* 1002411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1002422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1002425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002450 */     // MIs[0] policy
     /* 1002450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002460 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1002463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002482 */     // GIR_Coverage, 60163,
     /* 1002482 */     GIR_EraseRootFromParent_Done,
     /* 1002483 */   // Label 14945: @1002483
     /* 1002483 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1002560), // Rule ID 60166 //
     /* 1002488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1002499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1002502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002527 */     // MIs[0] policy
     /* 1002527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002537 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1002540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002559 */     // GIR_Coverage, 60166,
     /* 1002559 */     GIR_EraseRootFromParent_Done,
     /* 1002560 */   // Label 14946: @1002560
     /* 1002560 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1002637), // Rule ID 60167 //
     /* 1002565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1002576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1002579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002604 */     // MIs[0] policy
     /* 1002604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002614 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1002617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1002633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002636 */     // GIR_Coverage, 60167,
     /* 1002636 */     GIR_EraseRootFromParent_Done,
     /* 1002637 */   // Label 14947: @1002637
     /* 1002637 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1002714), // Rule ID 60170 //
     /* 1002642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1002653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1002656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1002659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002681 */     // MIs[0] policy
     /* 1002681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002691 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1002694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1002710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002713 */     // GIR_Coverage, 60170,
     /* 1002713 */     GIR_EraseRootFromParent_Done,
     /* 1002714 */   // Label 14948: @1002714
     /* 1002714 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1002791), // Rule ID 60171 //
     /* 1002719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1002730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1002733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1002736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002758 */     // MIs[0] policy
     /* 1002758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1002771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1002787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002790 */     // GIR_Coverage, 60171,
     /* 1002790 */     GIR_EraseRootFromParent_Done,
     /* 1002791 */   // Label 14949: @1002791
     /* 1002791 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1002868), // Rule ID 60174 //
     /* 1002796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1002807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1002810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002835 */     // MIs[0] policy
     /* 1002835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002845 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1002848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1002864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002867 */     // GIR_Coverage, 60174,
     /* 1002867 */     GIR_EraseRootFromParent_Done,
     /* 1002868 */   // Label 14950: @1002868
     /* 1002868 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1002945), // Rule ID 60175 //
     /* 1002873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1002876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1002884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1002887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002912 */     // MIs[0] policy
     /* 1002912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1002925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1002941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002944 */     // GIR_Coverage, 60175,
     /* 1002944 */     GIR_EraseRootFromParent_Done,
     /* 1002945 */   // Label 14951: @1002945
     /* 1002945 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1003022), // Rule ID 60178 //
     /* 1002950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1002953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1002958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002989 */     // MIs[0] policy
     /* 1002989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1003002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003021 */     // GIR_Coverage, 60178,
     /* 1003021 */     GIR_EraseRootFromParent_Done,
     /* 1003022 */   // Label 14952: @1003022
     /* 1003022 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1003099), // Rule ID 60179 //
     /* 1003027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1003038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1003041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1003044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003066 */     // MIs[0] policy
     /* 1003066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1003079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003098 */     // GIR_Coverage, 60179,
     /* 1003098 */     GIR_EraseRootFromParent_Done,
     /* 1003099 */   // Label 14953: @1003099
     /* 1003099 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1003176), // Rule ID 60182 //
     /* 1003104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1003115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1003118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003143 */     // MIs[0] policy
     /* 1003143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003153 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1003172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003175 */     // GIR_Coverage, 60182,
     /* 1003175 */     GIR_EraseRootFromParent_Done,
     /* 1003176 */   // Label 14954: @1003176
     /* 1003176 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1003253), // Rule ID 60183 //
     /* 1003181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1003192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1003195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003220 */     // MIs[0] policy
     /* 1003220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10869:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1003249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003252 */     // GIR_Coverage, 60183,
     /* 1003252 */     GIR_EraseRootFromParent_Done,
     /* 1003253 */   // Label 14955: @1003253
     /* 1003253 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1003330), // Rule ID 60186 //
     /* 1003258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1003269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1003272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003297 */     // MIs[0] policy
     /* 1003297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1003326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003329 */     // GIR_Coverage, 60186,
     /* 1003329 */     GIR_EraseRootFromParent_Done,
     /* 1003330 */   // Label 14956: @1003330
     /* 1003330 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1003407), // Rule ID 60187 //
     /* 1003335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1003346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1003349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003374 */     // MIs[0] policy
     /* 1003374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1003403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003406 */     // GIR_Coverage, 60187,
     /* 1003406 */     GIR_EraseRootFromParent_Done,
     /* 1003407 */   // Label 14957: @1003407
     /* 1003407 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1003484), // Rule ID 60190 //
     /* 1003412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1003429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003451 */     // MIs[0] policy
     /* 1003451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003461 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003483 */     // GIR_Coverage, 60190,
     /* 1003483 */     GIR_EraseRootFromParent_Done,
     /* 1003484 */   // Label 14958: @1003484
     /* 1003484 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1003561), // Rule ID 60191 //
     /* 1003489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1003506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003528 */     // MIs[0] policy
     /* 1003528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003560 */     // GIR_Coverage, 60191,
     /* 1003560 */     GIR_EraseRootFromParent_Done,
     /* 1003561 */   // Label 14959: @1003561
     /* 1003561 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1003638), // Rule ID 60194 //
     /* 1003566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1003583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003605 */     // MIs[0] policy
     /* 1003605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003637 */     // GIR_Coverage, 60194,
     /* 1003637 */     GIR_EraseRootFromParent_Done,
     /* 1003638 */   // Label 14960: @1003638
     /* 1003638 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1003715), // Rule ID 60195 //
     /* 1003643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1003660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003682 */     // MIs[0] policy
     /* 1003682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1003695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003714 */     // GIR_Coverage, 60195,
     /* 1003714 */     GIR_EraseRootFromParent_Done,
     /* 1003715 */   // Label 14961: @1003715
     /* 1003715 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1003792), // Rule ID 60198 //
     /* 1003720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1003731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1003734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003759 */     // MIs[0] policy
     /* 1003759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003769 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1003772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1003788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003791 */     // GIR_Coverage, 60198,
     /* 1003791 */     GIR_EraseRootFromParent_Done,
     /* 1003792 */   // Label 14962: @1003792
     /* 1003792 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1003869), // Rule ID 60199 //
     /* 1003797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1003808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1003811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003836 */     // MIs[0] policy
     /* 1003836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1003849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1003865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003868 */     // GIR_Coverage, 60199,
     /* 1003868 */     GIR_EraseRootFromParent_Done,
     /* 1003869 */   // Label 14963: @1003869
     /* 1003869 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1003946), // Rule ID 60202 //
     /* 1003874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1003877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1003885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1003888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1003891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1003894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003913 */     // MIs[0] policy
     /* 1003913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003923 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1003926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1003942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003945 */     // GIR_Coverage, 60202,
     /* 1003945 */     GIR_EraseRootFromParent_Done,
     /* 1003946 */   // Label 14964: @1003946
     /* 1003946 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1004023), // Rule ID 60203 //
     /* 1003951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1003954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1003959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1003962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1003965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1003968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1003971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003990 */     // MIs[0] policy
     /* 1003990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1004003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004022 */     // GIR_Coverage, 60203,
     /* 1004022 */     GIR_EraseRootFromParent_Done,
     /* 1004023 */   // Label 14965: @1004023
     /* 1004023 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1004100), // Rule ID 60206 //
     /* 1004028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1004039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1004042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1004045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1004048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004067 */     // MIs[0] policy
     /* 1004067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004077 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1004080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004099 */     // GIR_Coverage, 60206,
     /* 1004099 */     GIR_EraseRootFromParent_Done,
     /* 1004100 */   // Label 14966: @1004100
     /* 1004100 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1004177), // Rule ID 60207 //
     /* 1004105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1004116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1004119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1004122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1004125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004144 */     // MIs[0] policy
     /* 1004144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004154 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1004157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004176 */     // GIR_Coverage, 60207,
     /* 1004176 */     GIR_EraseRootFromParent_Done,
     /* 1004177 */   // Label 14967: @1004177
     /* 1004177 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1004254), // Rule ID 60210 //
     /* 1004182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004221 */     // MIs[0] policy
     /* 1004221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1004234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004253 */     // GIR_Coverage, 60210,
     /* 1004253 */     GIR_EraseRootFromParent_Done,
     /* 1004254 */   // Label 14968: @1004254
     /* 1004254 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1004331), // Rule ID 60211 //
     /* 1004259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004298 */     // MIs[0] policy
     /* 1004298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1004311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004330 */     // GIR_Coverage, 60211,
     /* 1004330 */     GIR_EraseRootFromParent_Done,
     /* 1004331 */   // Label 14969: @1004331
     /* 1004331 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1004408), // Rule ID 60214 //
     /* 1004336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1004347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1004350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1004353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1004356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004375 */     // MIs[0] policy
     /* 1004375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004385 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1004388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004407 */     // GIR_Coverage, 60214,
     /* 1004407 */     GIR_EraseRootFromParent_Done,
     /* 1004408 */   // Label 14970: @1004408
     /* 1004408 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1004485), // Rule ID 60215 //
     /* 1004413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1004424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1004427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1004430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1004433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004452 */     // MIs[0] policy
     /* 1004452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1004465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004484 */     // GIR_Coverage, 60215,
     /* 1004484 */     GIR_EraseRootFromParent_Done,
     /* 1004485 */   // Label 14971: @1004485
     /* 1004485 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1004562), // Rule ID 60218 //
     /* 1004490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1004501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1004504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1004507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1004510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004529 */     // MIs[0] policy
     /* 1004529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004539 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1004542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004561 */     // GIR_Coverage, 60218,
     /* 1004561 */     GIR_EraseRootFromParent_Done,
     /* 1004562 */   // Label 14972: @1004562
     /* 1004562 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1004639), // Rule ID 60219 //
     /* 1004567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1004578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1004581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1004584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1004587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004606 */     // MIs[0] policy
     /* 1004606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1004619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004638 */     // GIR_Coverage, 60219,
     /* 1004638 */     GIR_EraseRootFromParent_Done,
     /* 1004639 */   // Label 14973: @1004639
     /* 1004639 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1004716), // Rule ID 60222 //
     /* 1004644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1004655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1004658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1004661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004683 */     // MIs[0] policy
     /* 1004683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1004696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004715 */     // GIR_Coverage, 60222,
     /* 1004715 */     GIR_EraseRootFromParent_Done,
     /* 1004716 */   // Label 14974: @1004716
     /* 1004716 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1004793), // Rule ID 60223 //
     /* 1004721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1004732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1004735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1004738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004760 */     // MIs[0] policy
     /* 1004760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1004773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004792 */     // GIR_Coverage, 60223,
     /* 1004792 */     GIR_EraseRootFromParent_Done,
     /* 1004793 */   // Label 14975: @1004793
     /* 1004793 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1004870), // Rule ID 60226 //
     /* 1004798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1004809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1004812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1004815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004837 */     // MIs[0] policy
     /* 1004837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004847 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1004850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004869 */     // GIR_Coverage, 60226,
     /* 1004869 */     GIR_EraseRootFromParent_Done,
     /* 1004870 */   // Label 14976: @1004870
     /* 1004870 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1004947), // Rule ID 60227 //
     /* 1004875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1004878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1004886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1004889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1004892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004914 */     // MIs[0] policy
     /* 1004914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1004927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004946 */     // GIR_Coverage, 60227,
     /* 1004946 */     GIR_EraseRootFromParent_Done,
     /* 1004947 */   // Label 14977: @1004947
     /* 1004947 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1005024), // Rule ID 60230 //
     /* 1004952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1004955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1004960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1004963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1004966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1004969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1004972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004991 */     // MIs[0] policy
     /* 1004991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005001 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1005004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005023 */     // GIR_Coverage, 60230,
     /* 1005023 */     GIR_EraseRootFromParent_Done,
     /* 1005024 */   // Label 14978: @1005024
     /* 1005024 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1005101), // Rule ID 60231 //
     /* 1005029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1005032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1005040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1005043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1005046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005068 */     // MIs[0] policy
     /* 1005068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1005081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005100 */     // GIR_Coverage, 60231,
     /* 1005100 */     GIR_EraseRootFromParent_Done,
     /* 1005101 */   // Label 14979: @1005101
     /* 1005101 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1005178), // Rule ID 60234 //
     /* 1005106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1005109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1005117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1005120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1005123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005145 */     // MIs[0] policy
     /* 1005145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1005158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005177 */     // GIR_Coverage, 60234,
     /* 1005177 */     GIR_EraseRootFromParent_Done,
     /* 1005178 */   // Label 14980: @1005178
     /* 1005178 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1005255), // Rule ID 60235 //
     /* 1005183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1005186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1005194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1005197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1005200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005222 */     // MIs[0] policy
     /* 1005222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1005235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005254 */     // GIR_Coverage, 60235,
     /* 1005254 */     GIR_EraseRootFromParent_Done,
     /* 1005255 */   // Label 14981: @1005255
     /* 1005255 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1005332), // Rule ID 60238 //
     /* 1005260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1005263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1005271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1005274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1005277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005299 */     // MIs[0] policy
     /* 1005299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005309 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1005312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005331 */     // GIR_Coverage, 60238,
     /* 1005331 */     GIR_EraseRootFromParent_Done,
     /* 1005332 */   // Label 14982: @1005332
     /* 1005332 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1005409), // Rule ID 60239 //
     /* 1005337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1005340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1005348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1005351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1005354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005376 */     // MIs[0] policy
     /* 1005376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1005389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005408 */     // GIR_Coverage, 60239,
     /* 1005408 */     GIR_EraseRootFromParent_Done,
     /* 1005409 */   // Label 14983: @1005409
     /* 1005409 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1005486), // Rule ID 60242 //
     /* 1005414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1005417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1005431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005453 */     // MIs[0] policy
     /* 1005453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005463 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1005466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005485 */     // GIR_Coverage, 60242,
     /* 1005485 */     GIR_EraseRootFromParent_Done,
     /* 1005486 */   // Label 14984: @1005486
     /* 1005486 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1005563), // Rule ID 60243 //
     /* 1005491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1005494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1005499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1005508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005530 */     // MIs[0] policy
     /* 1005530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1005543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005562 */     // GIR_Coverage, 60243,
     /* 1005562 */     GIR_EraseRootFromParent_Done,
     /* 1005563 */   // Label 14985: @1005563
     /* 1005563 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1005640), // Rule ID 60666 //
     /* 1005568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1005571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1005579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1005582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1005585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005607 */     // MIs[0] policy
     /* 1005607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005617 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1005620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005639 */     // GIR_Coverage, 60666,
     /* 1005639 */     GIR_EraseRootFromParent_Done,
     /* 1005640 */   // Label 14986: @1005640
     /* 1005640 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1005717), // Rule ID 60667 //
     /* 1005645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1005648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1005656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1005659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1005662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005684 */     // MIs[0] policy
     /* 1005684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005694 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1005697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005716 */     // GIR_Coverage, 60667,
     /* 1005716 */     GIR_EraseRootFromParent_Done,
     /* 1005717 */   // Label 14987: @1005717
     /* 1005717 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1005794), // Rule ID 60670 //
     /* 1005722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1005725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005761 */     // MIs[0] policy
     /* 1005761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005771 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1005774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005793 */     // GIR_Coverage, 60670,
     /* 1005793 */     GIR_EraseRootFromParent_Done,
     /* 1005794 */   // Label 14988: @1005794
     /* 1005794 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1005871), // Rule ID 60671 //
     /* 1005799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1005802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005838 */     // MIs[0] policy
     /* 1005838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1005851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005870 */     // GIR_Coverage, 60671,
     /* 1005870 */     GIR_EraseRootFromParent_Done,
     /* 1005871 */   // Label 14989: @1005871
     /* 1005871 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1005948), // Rule ID 60674 //
     /* 1005876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1005879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005915 */     // MIs[0] policy
     /* 1005915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005925 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1005928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005947 */     // GIR_Coverage, 60674,
     /* 1005947 */     GIR_EraseRootFromParent_Done,
     /* 1005948 */   // Label 14990: @1005948
     /* 1005948 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1006025), // Rule ID 60675 //
     /* 1005953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1005956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1005961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005992 */     // MIs[0] policy
     /* 1005992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1006005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006024 */     // GIR_Coverage, 60675,
     /* 1006024 */     GIR_EraseRootFromParent_Done,
     /* 1006025 */   // Label 14991: @1006025
     /* 1006025 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1006102), // Rule ID 60678 //
     /* 1006030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1006041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1006044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1006047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006069 */     // MIs[0] policy
     /* 1006069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006079 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1006082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006101 */     // GIR_Coverage, 60678,
     /* 1006101 */     GIR_EraseRootFromParent_Done,
     /* 1006102 */   // Label 14992: @1006102
     /* 1006102 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1006179), // Rule ID 60679 //
     /* 1006107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1006118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1006121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1006124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006146 */     // MIs[0] policy
     /* 1006146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1006159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006178 */     // GIR_Coverage, 60679,
     /* 1006178 */     GIR_EraseRootFromParent_Done,
     /* 1006179 */   // Label 14993: @1006179
     /* 1006179 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1006256), // Rule ID 60682 //
     /* 1006184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1006195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1006198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1006201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006223 */     // MIs[0] policy
     /* 1006223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006233 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1006236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006255 */     // GIR_Coverage, 60682,
     /* 1006255 */     GIR_EraseRootFromParent_Done,
     /* 1006256 */   // Label 14994: @1006256
     /* 1006256 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1006333), // Rule ID 60683 //
     /* 1006261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1006272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1006275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1006278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006300 */     // MIs[0] policy
     /* 1006300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1006313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006332 */     // GIR_Coverage, 60683,
     /* 1006332 */     GIR_EraseRootFromParent_Done,
     /* 1006333 */   // Label 14995: @1006333
     /* 1006333 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1006410), // Rule ID 60686 //
     /* 1006338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006377 */     // MIs[0] policy
     /* 1006377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006387 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1006390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006409 */     // GIR_Coverage, 60686,
     /* 1006409 */     GIR_EraseRootFromParent_Done,
     /* 1006410 */   // Label 14996: @1006410
     /* 1006410 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1006487), // Rule ID 60687 //
     /* 1006415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006454 */     // MIs[0] policy
     /* 1006454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1006467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006486 */     // GIR_Coverage, 60687,
     /* 1006486 */     GIR_EraseRootFromParent_Done,
     /* 1006487 */   // Label 14997: @1006487
     /* 1006487 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1006564), // Rule ID 60690 //
     /* 1006492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006531 */     // MIs[0] policy
     /* 1006531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006541 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006563 */     // GIR_Coverage, 60690,
     /* 1006563 */     GIR_EraseRootFromParent_Done,
     /* 1006564 */   // Label 14998: @1006564
     /* 1006564 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1006641), // Rule ID 60691 //
     /* 1006569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006608 */     // MIs[0] policy
     /* 1006608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10858:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006640 */     // GIR_Coverage, 60691,
     /* 1006640 */     GIR_EraseRootFromParent_Done,
     /* 1006641 */   // Label 14999: @1006641
     /* 1006641 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1006718), // Rule ID 60694 //
     /* 1006646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006685 */     // MIs[0] policy
     /* 1006685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006717 */     // GIR_Coverage, 60694,
     /* 1006717 */     GIR_EraseRootFromParent_Done,
     /* 1006718 */   // Label 15000: @1006718
     /* 1006718 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1006795), // Rule ID 60695 //
     /* 1006723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006762 */     // MIs[0] policy
     /* 1006762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006794 */     // GIR_Coverage, 60695,
     /* 1006794 */     GIR_EraseRootFromParent_Done,
     /* 1006795 */   // Label 15001: @1006795
     /* 1006795 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1006872), // Rule ID 60698 //
     /* 1006800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006839 */     // MIs[0] policy
     /* 1006839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006871 */     // GIR_Coverage, 60698,
     /* 1006871 */     GIR_EraseRootFromParent_Done,
     /* 1006872 */   // Label 15002: @1006872
     /* 1006872 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1006949), // Rule ID 60699 //
     /* 1006877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1006880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006916 */     // MIs[0] policy
     /* 1006916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1006929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006948 */     // GIR_Coverage, 60699,
     /* 1006948 */     GIR_EraseRootFromParent_Done,
     /* 1006949 */   // Label 15003: @1006949
     /* 1006949 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1007026), // Rule ID 60702 //
     /* 1006954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1006957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1006962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006993 */     // MIs[0] policy
     /* 1006993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007003 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1007006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007025 */     // GIR_Coverage, 60702,
     /* 1007025 */     GIR_EraseRootFromParent_Done,
     /* 1007026 */   // Label 15004: @1007026
     /* 1007026 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1007103), // Rule ID 60703 //
     /* 1007031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1007042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1007045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1007048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1007051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1007058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007070 */     // MIs[0] policy
     /* 1007070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1007083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007102 */     // GIR_Coverage, 60703,
     /* 1007102 */     GIR_EraseRootFromParent_Done,
     /* 1007103 */   // Label 15005: @1007103
     /* 1007103 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1007180), // Rule ID 60706 //
     /* 1007108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1007119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1007122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007147 */     // MIs[0] policy
     /* 1007147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007157 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1007160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007179 */     // GIR_Coverage, 60706,
     /* 1007179 */     GIR_EraseRootFromParent_Done,
     /* 1007180 */   // Label 15006: @1007180
     /* 1007180 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1007257), // Rule ID 60707 //
     /* 1007185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1007196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1007199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007224 */     // MIs[0] policy
     /* 1007224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1007237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007256 */     // GIR_Coverage, 60707,
     /* 1007256 */     GIR_EraseRootFromParent_Done,
     /* 1007257 */   // Label 15007: @1007257
     /* 1007257 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1007334), // Rule ID 60710 //
     /* 1007262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1007273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1007276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1007279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1007282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007301 */     // MIs[0] policy
     /* 1007301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007311 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1007314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007333 */     // GIR_Coverage, 60710,
     /* 1007333 */     GIR_EraseRootFromParent_Done,
     /* 1007334 */   // Label 15008: @1007334
     /* 1007334 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1007411), // Rule ID 60711 //
     /* 1007339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1007350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1007353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1007356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1007359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007378 */     // MIs[0] policy
     /* 1007378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007388 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1007391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007410 */     // GIR_Coverage, 60711,
     /* 1007410 */     GIR_EraseRootFromParent_Done,
     /* 1007411 */   // Label 15009: @1007411
     /* 1007411 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1007488), // Rule ID 60714 //
     /* 1007416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1007427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1007430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1007433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1007436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007455 */     // MIs[0] policy
     /* 1007455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007465 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1007468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007487 */     // GIR_Coverage, 60714,
     /* 1007487 */     GIR_EraseRootFromParent_Done,
     /* 1007488 */   // Label 15010: @1007488
     /* 1007488 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1007565), // Rule ID 60715 //
     /* 1007493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1007504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1007507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1007510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1007513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007532 */     // MIs[0] policy
     /* 1007532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1007545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007564 */     // GIR_Coverage, 60715,
     /* 1007564 */     GIR_EraseRootFromParent_Done,
     /* 1007565 */   // Label 15011: @1007565
     /* 1007565 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1007642), // Rule ID 60718 //
     /* 1007570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007609 */     // MIs[0] policy
     /* 1007609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1007622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007641 */     // GIR_Coverage, 60718,
     /* 1007641 */     GIR_EraseRootFromParent_Done,
     /* 1007642 */   // Label 15012: @1007642
     /* 1007642 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1007719), // Rule ID 60719 //
     /* 1007647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007686 */     // MIs[0] policy
     /* 1007686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1007699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007718 */     // GIR_Coverage, 60719,
     /* 1007718 */     GIR_EraseRootFromParent_Done,
     /* 1007719 */   // Label 15013: @1007719
     /* 1007719 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1007796), // Rule ID 60722 //
     /* 1007724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007763 */     // MIs[0] policy
     /* 1007763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007773 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1007776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007795 */     // GIR_Coverage, 60722,
     /* 1007795 */     GIR_EraseRootFromParent_Done,
     /* 1007796 */   // Label 15014: @1007796
     /* 1007796 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1007873), // Rule ID 60723 //
     /* 1007801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007840 */     // MIs[0] policy
     /* 1007840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1007853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007872 */     // GIR_Coverage, 60723,
     /* 1007872 */     GIR_EraseRootFromParent_Done,
     /* 1007873 */   // Label 15015: @1007873
     /* 1007873 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1007950), // Rule ID 60726 //
     /* 1007878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1007881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1007898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007917 */     // MIs[0] policy
     /* 1007917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1007930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007949 */     // GIR_Coverage, 60726,
     /* 1007949 */     GIR_EraseRootFromParent_Done,
     /* 1007950 */   // Label 15016: @1007950
     /* 1007950 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1008027), // Rule ID 60727 //
     /* 1007955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1007958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1007963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1007975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007994 */     // MIs[0] policy
     /* 1007994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1008007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008026 */     // GIR_Coverage, 60727,
     /* 1008026 */     GIR_EraseRootFromParent_Done,
     /* 1008027 */   // Label 15017: @1008027
     /* 1008027 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1008104), // Rule ID 60730 //
     /* 1008032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1008043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1008046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1008049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008071 */     // MIs[0] policy
     /* 1008071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1008084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008103 */     // GIR_Coverage, 60730,
     /* 1008103 */     GIR_EraseRootFromParent_Done,
     /* 1008104 */   // Label 15018: @1008104
     /* 1008104 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1008181), // Rule ID 60731 //
     /* 1008109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1008120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1008123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1008126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008148 */     // MIs[0] policy
     /* 1008148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1008161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008180 */     // GIR_Coverage, 60731,
     /* 1008180 */     GIR_EraseRootFromParent_Done,
     /* 1008181 */   // Label 15019: @1008181
     /* 1008181 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1008258), // Rule ID 60734 //
     /* 1008186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1008197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1008200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1008203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008225 */     // MIs[0] policy
     /* 1008225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008235 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1008238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008257 */     // GIR_Coverage, 60734,
     /* 1008257 */     GIR_EraseRootFromParent_Done,
     /* 1008258 */   // Label 15020: @1008258
     /* 1008258 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1008335), // Rule ID 60735 //
     /* 1008263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1008274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1008277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1008280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008302 */     // MIs[0] policy
     /* 1008302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1008315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008334 */     // GIR_Coverage, 60735,
     /* 1008334 */     GIR_EraseRootFromParent_Done,
     /* 1008335 */   // Label 15021: @1008335
     /* 1008335 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1008412), // Rule ID 60738 //
     /* 1008340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1008351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1008354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1008357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1008360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008379 */     // MIs[0] policy
     /* 1008379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008389 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1008392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008411 */     // GIR_Coverage, 60738,
     /* 1008411 */     GIR_EraseRootFromParent_Done,
     /* 1008412 */   // Label 15022: @1008412
     /* 1008412 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1008489), // Rule ID 60739 //
     /* 1008417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1008428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1008431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1008434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1008437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008456 */     // MIs[0] policy
     /* 1008456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1008469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008488 */     // GIR_Coverage, 60739,
     /* 1008488 */     GIR_EraseRootFromParent_Done,
     /* 1008489 */   // Label 15023: @1008489
     /* 1008489 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1008566), // Rule ID 60742 //
     /* 1008494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008533 */     // MIs[0] policy
     /* 1008533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1008546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008565 */     // GIR_Coverage, 60742,
     /* 1008565 */     GIR_EraseRootFromParent_Done,
     /* 1008566 */   // Label 15024: @1008566
     /* 1008566 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1008643), // Rule ID 60743 //
     /* 1008571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008610 */     // MIs[0] policy
     /* 1008610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1008623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008642 */     // GIR_Coverage, 60743,
     /* 1008642 */     GIR_EraseRootFromParent_Done,
     /* 1008643 */   // Label 15025: @1008643
     /* 1008643 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1008720), // Rule ID 60746 //
     /* 1008648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008687 */     // MIs[0] policy
     /* 1008687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008697 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1008700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008719 */     // GIR_Coverage, 60746,
     /* 1008719 */     GIR_EraseRootFromParent_Done,
     /* 1008720 */   // Label 15026: @1008720
     /* 1008720 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1008797), // Rule ID 60747 //
     /* 1008725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008764 */     // MIs[0] policy
     /* 1008764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1008777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008796 */     // GIR_Coverage, 60747,
     /* 1008796 */     GIR_EraseRootFromParent_Done,
     /* 1008797 */   // Label 15027: @1008797
     /* 1008797 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1008874), // Rule ID 60750 //
     /* 1008802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008841 */     // MIs[0] policy
     /* 1008841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008851 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1008854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008873 */     // GIR_Coverage, 60750,
     /* 1008873 */     GIR_EraseRootFromParent_Done,
     /* 1008874 */   // Label 15028: @1008874
     /* 1008874 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1008951), // Rule ID 60751 //
     /* 1008879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1008882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1008887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008918 */     // MIs[0] policy
     /* 1008918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1008931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008950 */     // GIR_Coverage, 60751,
     /* 1008950 */     GIR_EraseRootFromParent_Done,
     /* 1008951 */   // Label 15029: @1008951
     /* 1008951 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1009028), // Rule ID 60754 //
     /* 1008956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1008959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1008964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1008973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1008976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1008983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008995 */     // MIs[0] policy
     /* 1008995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009005 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1009008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009027 */     // GIR_Coverage, 60754,
     /* 1009027 */     GIR_EraseRootFromParent_Done,
     /* 1009028 */   // Label 15030: @1009028
     /* 1009028 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1009105), // Rule ID 60755 //
     /* 1009033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1009044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1009047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1009050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1009053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009072 */     // MIs[0] policy
     /* 1009072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1009085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009104 */     // GIR_Coverage, 60755,
     /* 1009104 */     GIR_EraseRootFromParent_Done,
     /* 1009105 */   // Label 15031: @1009105
     /* 1009105 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1009182), // Rule ID 60758 //
     /* 1009110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1009121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1009124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1009127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1009130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009149 */     // MIs[0] policy
     /* 1009149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009159 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1009162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009181 */     // GIR_Coverage, 60758,
     /* 1009181 */     GIR_EraseRootFromParent_Done,
     /* 1009182 */   // Label 15032: @1009182
     /* 1009182 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1009259), // Rule ID 60759 //
     /* 1009187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1009198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1009201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1009204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1009207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009226 */     // MIs[0] policy
     /* 1009226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1009239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009258 */     // GIR_Coverage, 60759,
     /* 1009258 */     GIR_EraseRootFromParent_Done,
     /* 1009259 */   // Label 15033: @1009259
     /* 1009259 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1009336), // Rule ID 60762 //
     /* 1009264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1009275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1009278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1009281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1009284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009303 */     // MIs[0] policy
     /* 1009303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009313 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009335 */     // GIR_Coverage, 60762,
     /* 1009335 */     GIR_EraseRootFromParent_Done,
     /* 1009336 */   // Label 15034: @1009336
     /* 1009336 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1009413), // Rule ID 60763 //
     /* 1009341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1009352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1009355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1009358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1009361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009380 */     // MIs[0] policy
     /* 1009380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009412 */     // GIR_Coverage, 60763,
     /* 1009412 */     GIR_EraseRootFromParent_Done,
     /* 1009413 */   // Label 15035: @1009413
     /* 1009413 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1009490), // Rule ID 60766 //
     /* 1009418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1009435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1009438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009457 */     // MIs[0] policy
     /* 1009457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009467 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1009470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009489 */     // GIR_Coverage, 60766,
     /* 1009489 */     GIR_EraseRootFromParent_Done,
     /* 1009490 */   // Label 15036: @1009490
     /* 1009490 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1009567), // Rule ID 60767 //
     /* 1009495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1009512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1009515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009534 */     // MIs[0] policy
     /* 1009534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1009547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009566 */     // GIR_Coverage, 60767,
     /* 1009566 */     GIR_EraseRootFromParent_Done,
     /* 1009567 */   // Label 15037: @1009567
     /* 1009567 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1009644), // Rule ID 60770 //
     /* 1009572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1009592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009611 */     // MIs[0] policy
     /* 1009611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009621 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009643 */     // GIR_Coverage, 60770,
     /* 1009643 */     GIR_EraseRootFromParent_Done,
     /* 1009644 */   // Label 15038: @1009644
     /* 1009644 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1009721), // Rule ID 60771 //
     /* 1009649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1009669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009688 */     // MIs[0] policy
     /* 1009688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009720 */     // GIR_Coverage, 60771,
     /* 1009720 */     GIR_EraseRootFromParent_Done,
     /* 1009721 */   // Label 15039: @1009721
     /* 1009721 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1009798), // Rule ID 60774 //
     /* 1009726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1009746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009765 */     // MIs[0] policy
     /* 1009765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009775 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009797 */     // GIR_Coverage, 60774,
     /* 1009797 */     GIR_EraseRootFromParent_Done,
     /* 1009798 */   // Label 15040: @1009798
     /* 1009798 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1009875), // Rule ID 60775 //
     /* 1009803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1009823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009842 */     // MIs[0] policy
     /* 1009842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1009855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009874 */     // GIR_Coverage, 60775,
     /* 1009874 */     GIR_EraseRootFromParent_Done,
     /* 1009875 */   // Label 15041: @1009875
     /* 1009875 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1009952), // Rule ID 60778 //
     /* 1009880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1009883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1009900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009919 */     // MIs[0] policy
     /* 1009919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009929 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1009932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1009936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1009938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1009940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009951 */     // GIR_Coverage, 60778,
     /* 1009951 */     GIR_EraseRootFromParent_Done,
     /* 1009952 */   // Label 15042: @1009952
     /* 1009952 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1010029), // Rule ID 60779 //
     /* 1009957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1009960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1009965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1009977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1009984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1009996 */     // MIs[0] policy
     /* 1009996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010028 */     // GIR_Coverage, 60779,
     /* 1010028 */     GIR_EraseRootFromParent_Done,
     /* 1010029 */   // Label 15043: @1010029
     /* 1010029 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1010106), // Rule ID 60782 //
     /* 1010034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1010045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1010048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1010051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1010054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010073 */     // MIs[0] policy
     /* 1010073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010105 */     // GIR_Coverage, 60782,
     /* 1010105 */     GIR_EraseRootFromParent_Done,
     /* 1010106 */   // Label 15044: @1010106
     /* 1010106 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1010183), // Rule ID 60783 //
     /* 1010111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1010122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1010125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1010128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1010131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010150 */     // MIs[0] policy
     /* 1010150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010182 */     // GIR_Coverage, 60783,
     /* 1010182 */     GIR_EraseRootFromParent_Done,
     /* 1010183 */   // Label 15045: @1010183
     /* 1010183 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1010260), // Rule ID 60786 //
     /* 1010188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1010199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1010202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1010205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1010208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010227 */     // MIs[0] policy
     /* 1010227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010237 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010259 */     // GIR_Coverage, 60786,
     /* 1010259 */     GIR_EraseRootFromParent_Done,
     /* 1010260 */   // Label 15046: @1010260
     /* 1010260 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1010337), // Rule ID 60787 //
     /* 1010265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1010276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1010279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1010282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1010285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010304 */     // MIs[0] policy
     /* 1010304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010336 */     // GIR_Coverage, 60787,
     /* 1010336 */     GIR_EraseRootFromParent_Done,
     /* 1010337 */   // Label 15047: @1010337
     /* 1010337 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1010414), // Rule ID 60790 //
     /* 1010342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1010353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1010356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1010359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1010362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010381 */     // MIs[0] policy
     /* 1010381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010413 */     // GIR_Coverage, 60790,
     /* 1010413 */     GIR_EraseRootFromParent_Done,
     /* 1010414 */   // Label 15048: @1010414
     /* 1010414 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1010491), // Rule ID 60791 //
     /* 1010419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1010430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1010433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1010436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1010439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1010446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010458 */     // MIs[0] policy
     /* 1010458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1010471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010490 */     // GIR_Coverage, 60791,
     /* 1010490 */     GIR_EraseRootFromParent_Done,
     /* 1010491 */   // Label 15049: @1010491
     /* 1010491 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1010568), // Rule ID 60794 //
     /* 1010496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1010516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1010523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010535 */     // MIs[0] policy
     /* 1010535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010545 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1010548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010567 */     // GIR_Coverage, 60794,
     /* 1010567 */     GIR_EraseRootFromParent_Done,
     /* 1010568 */   // Label 15050: @1010568
     /* 1010568 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1010645), // Rule ID 60795 //
     /* 1010573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1010593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1010600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010612 */     // MIs[0] policy
     /* 1010612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1010625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010644 */     // GIR_Coverage, 60795,
     /* 1010644 */     GIR_EraseRootFromParent_Done,
     /* 1010645 */   // Label 15051: @1010645
     /* 1010645 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1010722), // Rule ID 60798 //
     /* 1010650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1010670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1010677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010689 */     // MIs[0] policy
     /* 1010689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010699 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1010702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010721 */     // GIR_Coverage, 60798,
     /* 1010721 */     GIR_EraseRootFromParent_Done,
     /* 1010722 */   // Label 15052: @1010722
     /* 1010722 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1010799), // Rule ID 60799 //
     /* 1010727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1010747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1010754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010766 */     // MIs[0] policy
     /* 1010766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1010779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010798 */     // GIR_Coverage, 60799,
     /* 1010798 */     GIR_EraseRootFromParent_Done,
     /* 1010799 */   // Label 15053: @1010799
     /* 1010799 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1010876), // Rule ID 60802 //
     /* 1010804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1010824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1010831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010843 */     // MIs[0] policy
     /* 1010843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010853 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1010856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010875 */     // GIR_Coverage, 60802,
     /* 1010875 */     GIR_EraseRootFromParent_Done,
     /* 1010876 */   // Label 15054: @1010876
     /* 1010876 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1010953), // Rule ID 60803 //
     /* 1010881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1010884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1010901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1010908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010920 */     // MIs[0] policy
     /* 1010920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1010933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1010937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1010939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1010941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010952 */     // GIR_Coverage, 60803,
     /* 1010952 */     GIR_EraseRootFromParent_Done,
     /* 1010953 */   // Label 15055: @1010953
     /* 1010953 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1011030), // Rule ID 60806 //
     /* 1010958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1010961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1010966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1010975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1010978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1010985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1010997 */     // MIs[0] policy
     /* 1010997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011007 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1011010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011029 */     // GIR_Coverage, 60806,
     /* 1011029 */     GIR_EraseRootFromParent_Done,
     /* 1011030 */   // Label 15056: @1011030
     /* 1011030 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1011107), // Rule ID 60807 //
     /* 1011035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1011046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1011049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1011052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1011055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1011062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011074 */     // MIs[0] policy
     /* 1011074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1011087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011106 */     // GIR_Coverage, 60807,
     /* 1011106 */     GIR_EraseRootFromParent_Done,
     /* 1011107 */   // Label 15057: @1011107
     /* 1011107 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1011184), // Rule ID 60810 //
     /* 1011112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1011123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1011126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1011129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1011132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1011139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011151 */     // MIs[0] policy
     /* 1011151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1011164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011183 */     // GIR_Coverage, 60810,
     /* 1011183 */     GIR_EraseRootFromParent_Done,
     /* 1011184 */   // Label 15058: @1011184
     /* 1011184 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1011261), // Rule ID 60811 //
     /* 1011189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1011200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1011203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1011206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1011209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1011216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011228 */     // MIs[0] policy
     /* 1011228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011238 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1011241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011260 */     // GIR_Coverage, 60811,
     /* 1011260 */     GIR_EraseRootFromParent_Done,
     /* 1011261 */   // Label 15059: @1011261
     /* 1011261 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1011338), // Rule ID 60814 //
     /* 1011266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1011277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1011280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1011283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1011286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1011293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011305 */     // MIs[0] policy
     /* 1011305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1011318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011337 */     // GIR_Coverage, 60814,
     /* 1011337 */     GIR_EraseRootFromParent_Done,
     /* 1011338 */   // Label 15060: @1011338
     /* 1011338 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1011415), // Rule ID 60815 //
     /* 1011343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1011354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1011357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1011360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1011363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1011370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011382 */     // MIs[0] policy
     /* 1011382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1011395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011414 */     // GIR_Coverage, 60815,
     /* 1011414 */     GIR_EraseRootFromParent_Done,
     /* 1011415 */   // Label 15061: @1011415
     /* 1011415 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1011492), // Rule ID 60818 //
     /* 1011420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1011437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1011440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1011447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011459 */     // MIs[0] policy
     /* 1011459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1011472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011491 */     // GIR_Coverage, 60818,
     /* 1011491 */     GIR_EraseRootFromParent_Done,
     /* 1011492 */   // Label 15062: @1011492
     /* 1011492 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1011569), // Rule ID 60819 //
     /* 1011497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1011514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1011517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1011524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011536 */     // MIs[0] policy
     /* 1011536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1011549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011568 */     // GIR_Coverage, 60819,
     /* 1011568 */     GIR_EraseRootFromParent_Done,
     /* 1011569 */   // Label 15063: @1011569
     /* 1011569 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1011646), // Rule ID 60822 //
     /* 1011574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1011594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1011601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011613 */     // MIs[0] policy
     /* 1011613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011623 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1011626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011645 */     // GIR_Coverage, 60822,
     /* 1011645 */     GIR_EraseRootFromParent_Done,
     /* 1011646 */   // Label 15064: @1011646
     /* 1011646 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1011723), // Rule ID 60823 //
     /* 1011651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1011671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1011678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011690 */     // MIs[0] policy
     /* 1011690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1011703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011722 */     // GIR_Coverage, 60823,
     /* 1011722 */     GIR_EraseRootFromParent_Done,
     /* 1011723 */   // Label 15065: @1011723
     /* 1011723 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1011800), // Rule ID 60826 //
     /* 1011728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1011748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1011755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011767 */     // MIs[0] policy
     /* 1011767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011777 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1011780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011799 */     // GIR_Coverage, 60826,
     /* 1011799 */     GIR_EraseRootFromParent_Done,
     /* 1011800 */   // Label 15066: @1011800
     /* 1011800 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1011877), // Rule ID 60827 //
     /* 1011805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1011825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1011832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011844 */     // MIs[0] policy
     /* 1011844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1011857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011876 */     // GIR_Coverage, 60827,
     /* 1011876 */     GIR_EraseRootFromParent_Done,
     /* 1011877 */   // Label 15067: @1011877
     /* 1011877 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1011954), // Rule ID 60830 //
     /* 1011882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1011885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1011902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1011909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011921 */     // MIs[0] policy
     /* 1011921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1011934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1011938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1011940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1011942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011953 */     // GIR_Coverage, 60830,
     /* 1011953 */     GIR_EraseRootFromParent_Done,
     /* 1011954 */   // Label 15068: @1011954
     /* 1011954 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1012031), // Rule ID 60831 //
     /* 1011959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1011962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1011967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1011979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1011986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1011998 */     // MIs[0] policy
     /* 1011998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012008 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1012011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1012015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1012017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1012019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012030 */     // GIR_Coverage, 60831,
     /* 1012030 */     GIR_EraseRootFromParent_Done,
     /* 1012031 */   // Label 15069: @1012031
     /* 1012031 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1012108), // Rule ID 60834 //
     /* 1012036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1012039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1012044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1012047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1012050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1012053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1012056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1012063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1012075 */     // MIs[0] policy
     /* 1012075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012085 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1012088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1012092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1012094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1012096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012107 */     // GIR_Coverage, 60834,
     /* 1012107 */     GIR_EraseRootFromParent_Done,
     /* 1012108 */   // Label 15070: @1012108
     /* 1012108 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1012185), // Rule ID 60835 //
     /* 1012113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1012116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1012121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1012124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1012127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1012130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1012133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1012140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1012152 */     // MIs[0] policy
     /* 1012152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1012165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1012169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1012171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1012173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012184 */     // GIR_Coverage, 60835,
     /* 1012184 */     GIR_EraseRootFromParent_Done,
     /* 1012185 */   // Label 15071: @1012185
     /* 1012185 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1012262), // Rule ID 60838 //
     /* 1012190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1012193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1012198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1012201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1012204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1012207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1012210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1012217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1012229 */     // MIs[0] policy
     /* 1012229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012239 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1012242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1012246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1012248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1012250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012261 */     // GIR_Coverage, 60838,
     /* 1012261 */     GIR_EraseRootFromParent_Done,
     /* 1012262 */   // Label 15072: @1012262
     /* 1012262 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1012339), // Rule ID 60839 //
     /* 1012267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1012270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1012275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1012278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1012281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1012284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1012287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1012294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1012306 */     // MIs[0] policy
     /* 1012306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1012319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1012323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1012325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1012327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012338 */     // GIR_Coverage, 60839,
     /* 1012338 */     GIR_EraseRootFromParent_Done,
     /* 1012339 */   // Label 15073: @1012339
     /* 1012339 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1012416), // Rule ID 61364 //
     /* 1012344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1012347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012383 */     // MIs[0] policy
     /* 1012383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1012396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012415 */     // GIR_Coverage, 61364,
     /* 1012415 */     GIR_EraseRootFromParent_Done,
     /* 1012416 */   // Label 15074: @1012416
     /* 1012416 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1012493), // Rule ID 61365 //
     /* 1012421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1012424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012460 */     // MIs[0] policy
     /* 1012460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1012473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012492 */     // GIR_Coverage, 61365,
     /* 1012492 */     GIR_EraseRootFromParent_Done,
     /* 1012493 */   // Label 15075: @1012493
     /* 1012493 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1012570), // Rule ID 61366 //
     /* 1012498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1012501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1012509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1012512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1012515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1012518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012537 */     // MIs[0] policy
     /* 1012537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1012550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012569 */     // GIR_Coverage, 61366,
     /* 1012569 */     GIR_EraseRootFromParent_Done,
     /* 1012570 */   // Label 15076: @1012570
     /* 1012570 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1012647), // Rule ID 61367 //
     /* 1012575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1012578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1012586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1012589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1012592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1012595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012614 */     // MIs[0] policy
     /* 1012614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1012627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012646 */     // GIR_Coverage, 61367,
     /* 1012646 */     GIR_EraseRootFromParent_Done,
     /* 1012647 */   // Label 15077: @1012647
     /* 1012647 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1012724), // Rule ID 61368 //
     /* 1012652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1012655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1012663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1012666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1012669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1012672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012691 */     // MIs[0] policy
     /* 1012691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012701 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1012704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012723 */     // GIR_Coverage, 61368,
     /* 1012723 */     GIR_EraseRootFromParent_Done,
     /* 1012724 */   // Label 15078: @1012724
     /* 1012724 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1012801), // Rule ID 61369 //
     /* 1012729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1012732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1012740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1012743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1012746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1012749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012768 */     // MIs[0] policy
     /* 1012768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1012781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012800 */     // GIR_Coverage, 61369,
     /* 1012800 */     GIR_EraseRootFromParent_Done,
     /* 1012801 */   // Label 15079: @1012801
     /* 1012801 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1012878), // Rule ID 61370 //
     /* 1012806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1012809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1012817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1012820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1012823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1012826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012845 */     // MIs[0] policy
     /* 1012845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012855 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1012858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012877 */     // GIR_Coverage, 61370,
     /* 1012877 */     GIR_EraseRootFromParent_Done,
     /* 1012878 */   // Label 15080: @1012878
     /* 1012878 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1012955), // Rule ID 61371 //
     /* 1012883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1012886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1012891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1012894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1012897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1012900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1012903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012922 */     // MIs[0] policy
     /* 1012922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1012935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1012937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012954 */     // GIR_Coverage, 61371,
     /* 1012954 */     GIR_EraseRootFromParent_Done,
     /* 1012955 */   // Label 15081: @1012955
     /* 1012955 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1013032), // Rule ID 61574 //
     /* 1012960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1012963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1012968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012999 */     // MIs[0] policy
     /* 1012999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1013012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013031 */     // GIR_Coverage, 61574,
     /* 1013031 */     GIR_EraseRootFromParent_Done,
     /* 1013032 */   // Label 15082: @1013032
     /* 1013032 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1013109), // Rule ID 61575 //
     /* 1013037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1013048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1013051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1013054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1013057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013076 */     // MIs[0] policy
     /* 1013076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1013089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013108 */     // GIR_Coverage, 61575,
     /* 1013108 */     GIR_EraseRootFromParent_Done,
     /* 1013109 */   // Label 15083: @1013109
     /* 1013109 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1013186), // Rule ID 61576 //
     /* 1013114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013153 */     // MIs[0] policy
     /* 1013153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013163 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1013166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013185 */     // GIR_Coverage, 61576,
     /* 1013185 */     GIR_EraseRootFromParent_Done,
     /* 1013186 */   // Label 15084: @1013186
     /* 1013186 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1013263), // Rule ID 61577 //
     /* 1013191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013230 */     // MIs[0] policy
     /* 1013230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1013243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013262 */     // GIR_Coverage, 61577,
     /* 1013262 */     GIR_EraseRootFromParent_Done,
     /* 1013263 */   // Label 15085: @1013263
     /* 1013263 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1013340), // Rule ID 61578 //
     /* 1013268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013307 */     // MIs[0] policy
     /* 1013307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1013320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013339 */     // GIR_Coverage, 61578,
     /* 1013339 */     GIR_EraseRootFromParent_Done,
     /* 1013340 */   // Label 15086: @1013340
     /* 1013340 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1013417), // Rule ID 61579 //
     /* 1013345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013384 */     // MIs[0] policy
     /* 1013384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1013397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013416 */     // GIR_Coverage, 61579,
     /* 1013416 */     GIR_EraseRootFromParent_Done,
     /* 1013417 */   // Label 15087: @1013417
     /* 1013417 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1013494), // Rule ID 61580 //
     /* 1013422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1013433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1013436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1013439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1013442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013461 */     // MIs[0] policy
     /* 1013461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1013474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013493 */     // GIR_Coverage, 61580,
     /* 1013493 */     GIR_EraseRootFromParent_Done,
     /* 1013494 */   // Label 15088: @1013494
     /* 1013494 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1013571), // Rule ID 61581 //
     /* 1013499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1013510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1013513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1013516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1013519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013538 */     // MIs[0] policy
     /* 1013538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1013551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013570 */     // GIR_Coverage, 61581,
     /* 1013570 */     GIR_EraseRootFromParent_Done,
     /* 1013571 */   // Label 15089: @1013571
     /* 1013571 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1013648), // Rule ID 61582 //
     /* 1013576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1013587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1013590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1013593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1013596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013615 */     // MIs[0] policy
     /* 1013615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013625 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1013628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013647 */     // GIR_Coverage, 61582,
     /* 1013647 */     GIR_EraseRootFromParent_Done,
     /* 1013648 */   // Label 15090: @1013648
     /* 1013648 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1013725), // Rule ID 61583 //
     /* 1013653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1013661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1013664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1013667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1013670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1013673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013692 */     // MIs[0] policy
     /* 1013692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1013705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013724 */     // GIR_Coverage, 61583,
     /* 1013724 */     GIR_EraseRootFromParent_Done,
     /* 1013725 */   // Label 15091: @1013725
     /* 1013725 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1013802), // Rule ID 61584 //
     /* 1013730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1013738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1013741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1013744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1013747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1013750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013769 */     // MIs[0] policy
     /* 1013769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013779 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1013782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013801 */     // GIR_Coverage, 61584,
     /* 1013801 */     GIR_EraseRootFromParent_Done,
     /* 1013802 */   // Label 15092: @1013802
     /* 1013802 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1013879), // Rule ID 61585 //
     /* 1013807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1013815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1013818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1013821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1013824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1013827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013846 */     // MIs[0] policy
     /* 1013846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1013859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013878 */     // GIR_Coverage, 61585,
     /* 1013878 */     GIR_EraseRootFromParent_Done,
     /* 1013879 */   // Label 15093: @1013879
     /* 1013879 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1013956), // Rule ID 61586 //
     /* 1013884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1013887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1013892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013923 */     // MIs[0] policy
     /* 1013923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1013936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1013938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013955 */     // GIR_Coverage, 61586,
     /* 1013955 */     GIR_EraseRootFromParent_Done,
     /* 1013956 */   // Label 15094: @1013956
     /* 1013956 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1014033), // Rule ID 61587 //
     /* 1013961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1013964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1013969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014000 */     // MIs[0] policy
     /* 1014000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1014013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014032 */     // GIR_Coverage, 61587,
     /* 1014032 */     GIR_EraseRootFromParent_Done,
     /* 1014033 */   // Label 15095: @1014033
     /* 1014033 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1014110), // Rule ID 61588 //
     /* 1014038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014077 */     // MIs[0] policy
     /* 1014077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1014090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014109 */     // GIR_Coverage, 61588,
     /* 1014109 */     GIR_EraseRootFromParent_Done,
     /* 1014110 */   // Label 15096: @1014110
     /* 1014110 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1014187), // Rule ID 61589 //
     /* 1014115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014154 */     // MIs[0] policy
     /* 1014154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1014167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014186 */     // GIR_Coverage, 61589,
     /* 1014186 */     GIR_EraseRootFromParent_Done,
     /* 1014187 */   // Label 15097: @1014187
     /* 1014187 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1014264), // Rule ID 61590 //
     /* 1014192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014231 */     // MIs[0] policy
     /* 1014231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014241 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1014244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014263 */     // GIR_Coverage, 61590,
     /* 1014263 */     GIR_EraseRootFromParent_Done,
     /* 1014264 */   // Label 15098: @1014264
     /* 1014264 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1014341), // Rule ID 61591 //
     /* 1014269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014308 */     // MIs[0] policy
     /* 1014308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1014321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014340 */     // GIR_Coverage, 61591,
     /* 1014340 */     GIR_EraseRootFromParent_Done,
     /* 1014341 */   // Label 15099: @1014341
     /* 1014341 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1014418), // Rule ID 61592 //
     /* 1014346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014385 */     // MIs[0] policy
     /* 1014385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014395 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1014398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014417 */     // GIR_Coverage, 61592,
     /* 1014417 */     GIR_EraseRootFromParent_Done,
     /* 1014418 */   // Label 15100: @1014418
     /* 1014418 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1014495), // Rule ID 61593 //
     /* 1014423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1014431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014462 */     // MIs[0] policy
     /* 1014462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1014475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014494 */     // GIR_Coverage, 61593,
     /* 1014494 */     GIR_EraseRootFromParent_Done,
     /* 1014495 */   // Label 15101: @1014495
     /* 1014495 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1014572), // Rule ID 61594 //
     /* 1014500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1014511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1014514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1014517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1014520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014539 */     // MIs[0] policy
     /* 1014539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1014552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014571 */     // GIR_Coverage, 61594,
     /* 1014571 */     GIR_EraseRootFromParent_Done,
     /* 1014572 */   // Label 15102: @1014572
     /* 1014572 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1014649), // Rule ID 61595 //
     /* 1014577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1014588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1014591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1014594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1014597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014616 */     // MIs[0] policy
     /* 1014616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014626 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1014629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014648 */     // GIR_Coverage, 61595,
     /* 1014648 */     GIR_EraseRootFromParent_Done,
     /* 1014649 */   // Label 15103: @1014649
     /* 1014649 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1014726), // Rule ID 61596 //
     /* 1014654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1014665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1014668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1014671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1014674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014693 */     // MIs[0] policy
     /* 1014693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014703 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1014706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014725 */     // GIR_Coverage, 61596,
     /* 1014725 */     GIR_EraseRootFromParent_Done,
     /* 1014726 */   // Label 15104: @1014726
     /* 1014726 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1014803), // Rule ID 61597 //
     /* 1014731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1014742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1014745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1014748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1014751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014770 */     // MIs[0] policy
     /* 1014770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1014783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014802 */     // GIR_Coverage, 61597,
     /* 1014802 */     GIR_EraseRootFromParent_Done,
     /* 1014803 */   // Label 15105: @1014803
     /* 1014803 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1014880), // Rule ID 61598 //
     /* 1014808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014847 */     // MIs[0] policy
     /* 1014847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014857 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1014860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014879 */     // GIR_Coverage, 61598,
     /* 1014879 */     GIR_EraseRootFromParent_Done,
     /* 1014880 */   // Label 15106: @1014880
     /* 1014880 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1014957), // Rule ID 61599 //
     /* 1014885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1014888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014924 */     // MIs[0] policy
     /* 1014924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1014937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1014939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014956 */     // GIR_Coverage, 61599,
     /* 1014956 */     GIR_EraseRootFromParent_Done,
     /* 1014957 */   // Label 15107: @1014957
     /* 1014957 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1015034), // Rule ID 61600 //
     /* 1014962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1014965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1014970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015001 */     // MIs[0] policy
     /* 1015001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1015014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015033 */     // GIR_Coverage, 61600,
     /* 1015033 */     GIR_EraseRootFromParent_Done,
     /* 1015034 */   // Label 15108: @1015034
     /* 1015034 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1015111), // Rule ID 61601 //
     /* 1015039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1015042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1015047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1015050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1015053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1015056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1015059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015078 */     // MIs[0] policy
     /* 1015078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1015091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015110 */     // GIR_Coverage, 61601,
     /* 1015110 */     GIR_EraseRootFromParent_Done,
     /* 1015111 */   // Label 15109: @1015111
     /* 1015111 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1015188), // Rule ID 61602 //
     /* 1015116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1015119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1015124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1015127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1015130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1015133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1015136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015155 */     // MIs[0] policy
     /* 1015155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015165 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1015168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015187 */     // GIR_Coverage, 61602,
     /* 1015187 */     GIR_EraseRootFromParent_Done,
     /* 1015188 */   // Label 15110: @1015188
     /* 1015188 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1015265), // Rule ID 61603 //
     /* 1015193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1015196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1015201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1015204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1015207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1015210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1015213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015232 */     // MIs[0] policy
     /* 1015232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1015245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015264 */     // GIR_Coverage, 61603,
     /* 1015264 */     GIR_EraseRootFromParent_Done,
     /* 1015265 */   // Label 15111: @1015265
     /* 1015265 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1015342), // Rule ID 61604 //
     /* 1015270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1015273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1015287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015309 */     // MIs[0] policy
     /* 1015309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1015322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015341 */     // GIR_Coverage, 61604,
     /* 1015341 */     GIR_EraseRootFromParent_Done,
     /* 1015342 */   // Label 15112: @1015342
     /* 1015342 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1015419), // Rule ID 61605 //
     /* 1015347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1015350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1015364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015386 */     // MIs[0] policy
     /* 1015386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1015399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015418 */     // GIR_Coverage, 61605,
     /* 1015418 */     GIR_EraseRootFromParent_Done,
     /* 1015419 */   // Label 15113: @1015419
     /* 1015419 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1015496), // Rule ID 61606 //
     /* 1015424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1015427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1015435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1015438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1015441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1015444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015463 */     // MIs[0] policy
     /* 1015463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015473 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1015476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015495 */     // GIR_Coverage, 61606,
     /* 1015495 */     GIR_EraseRootFromParent_Done,
     /* 1015496 */   // Label 15114: @1015496
     /* 1015496 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1015573), // Rule ID 61607 //
     /* 1015501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1015504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1015512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1015515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1015518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1015521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015540 */     // MIs[0] policy
     /* 1015540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1015553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015572 */     // GIR_Coverage, 61607,
     /* 1015572 */     GIR_EraseRootFromParent_Done,
     /* 1015573 */   // Label 15115: @1015573
     /* 1015573 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1015650), // Rule ID 61608 //
     /* 1015578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1015581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1015589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1015592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1015595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1015598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015617 */     // MIs[0] policy
     /* 1015617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1015630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015649 */     // GIR_Coverage, 61608,
     /* 1015649 */     GIR_EraseRootFromParent_Done,
     /* 1015650 */   // Label 15116: @1015650
     /* 1015650 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1015727), // Rule ID 61609 //
     /* 1015655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1015658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1015666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1015669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1015672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1015675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015694 */     // MIs[0] policy
     /* 1015694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1015707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015726 */     // GIR_Coverage, 61609,
     /* 1015726 */     GIR_EraseRootFromParent_Done,
     /* 1015727 */   // Label 15117: @1015727
     /* 1015727 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1015804), // Rule ID 61610 //
     /* 1015732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1015735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1015743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1015746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1015749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1015752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015771 */     // MIs[0] policy
     /* 1015771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015781 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1015784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015803 */     // GIR_Coverage, 61610,
     /* 1015803 */     GIR_EraseRootFromParent_Done,
     /* 1015804 */   // Label 15118: @1015804
     /* 1015804 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1015881), // Rule ID 61611 //
     /* 1015809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1015812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1015820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1015823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1015826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1015829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015848 */     // MIs[0] policy
     /* 1015848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1015861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015880 */     // GIR_Coverage, 61611,
     /* 1015880 */     GIR_EraseRootFromParent_Done,
     /* 1015881 */   // Label 15119: @1015881
     /* 1015881 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1015958), // Rule ID 61612 //
     /* 1015886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1015889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1015897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1015900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1015903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1015906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015925 */     // MIs[0] policy
     /* 1015925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015935 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1015938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1015940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015957 */     // GIR_Coverage, 61612,
     /* 1015957 */     GIR_EraseRootFromParent_Done,
     /* 1015958 */   // Label 15120: @1015958
     /* 1015958 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1016035), // Rule ID 61613 //
     /* 1015963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1015966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1015971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1015974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1015977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1015980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1015983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016002 */     // MIs[0] policy
     /* 1016002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1016015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016034 */     // GIR_Coverage, 61613,
     /* 1016034 */     GIR_EraseRootFromParent_Done,
     /* 1016035 */   // Label 15121: @1016035
     /* 1016035 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1016112), // Rule ID 61614 //
     /* 1016040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1016051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1016054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1016057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1016060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016079 */     // MIs[0] policy
     /* 1016079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016089 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1016092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016111 */     // GIR_Coverage, 61614,
     /* 1016111 */     GIR_EraseRootFromParent_Done,
     /* 1016112 */   // Label 15122: @1016112
     /* 1016112 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1016189), // Rule ID 61615 //
     /* 1016117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1016128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1016131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1016134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1016137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016156 */     // MIs[0] policy
     /* 1016156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1016169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016188 */     // GIR_Coverage, 61615,
     /* 1016188 */     GIR_EraseRootFromParent_Done,
     /* 1016189 */   // Label 15123: @1016189
     /* 1016189 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1016266), // Rule ID 61616 //
     /* 1016194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1016205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1016208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1016211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1016214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016233 */     // MIs[0] policy
     /* 1016233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1016246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016265 */     // GIR_Coverage, 61616,
     /* 1016265 */     GIR_EraseRootFromParent_Done,
     /* 1016266 */   // Label 15124: @1016266
     /* 1016266 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1016343), // Rule ID 61617 //
     /* 1016271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1016282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1016285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1016288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1016291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016310 */     // MIs[0] policy
     /* 1016310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1016323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016342 */     // GIR_Coverage, 61617,
     /* 1016342 */     GIR_EraseRootFromParent_Done,
     /* 1016343 */   // Label 15125: @1016343
     /* 1016343 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1016420), // Rule ID 61618 //
     /* 1016348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1016359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1016362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1016365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1016368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016387 */     // MIs[0] policy
     /* 1016387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1016400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016419 */     // GIR_Coverage, 61618,
     /* 1016419 */     GIR_EraseRootFromParent_Done,
     /* 1016420 */   // Label 15126: @1016420
     /* 1016420 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1016497), // Rule ID 61619 //
     /* 1016425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1016436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1016439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1016442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1016445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016464 */     // MIs[0] policy
     /* 1016464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1016477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016496 */     // GIR_Coverage, 61619,
     /* 1016496 */     GIR_EraseRootFromParent_Done,
     /* 1016497 */   // Label 15127: @1016497
     /* 1016497 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1016574), // Rule ID 61620 //
     /* 1016502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1016513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1016516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1016519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1016522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016541 */     // MIs[0] policy
     /* 1016541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016551 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1016554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016573 */     // GIR_Coverage, 61620,
     /* 1016573 */     GIR_EraseRootFromParent_Done,
     /* 1016574 */   // Label 15128: @1016574
     /* 1016574 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1016651), // Rule ID 61621 //
     /* 1016579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1016587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1016590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1016593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1016596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1016599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016618 */     // MIs[0] policy
     /* 1016618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1016631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016650 */     // GIR_Coverage, 61621,
     /* 1016650 */     GIR_EraseRootFromParent_Done,
     /* 1016651 */   // Label 15129: @1016651
     /* 1016651 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1016728), // Rule ID 61622 //
     /* 1016656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1016664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016695 */     // MIs[0] policy
     /* 1016695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016705 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1016708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016727 */     // GIR_Coverage, 61622,
     /* 1016727 */     GIR_EraseRootFromParent_Done,
     /* 1016728 */   // Label 15130: @1016728
     /* 1016728 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1016805), // Rule ID 61623 //
     /* 1016733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1016741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016772 */     // MIs[0] policy
     /* 1016772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1016785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016804 */     // GIR_Coverage, 61623,
     /* 1016804 */     GIR_EraseRootFromParent_Done,
     /* 1016805 */   // Label 15131: @1016805
     /* 1016805 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1016882), // Rule ID 61624 //
     /* 1016810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1016818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016849 */     // MIs[0] policy
     /* 1016849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1016862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016881 */     // GIR_Coverage, 61624,
     /* 1016881 */     GIR_EraseRootFromParent_Done,
     /* 1016882 */   // Label 15132: @1016882
     /* 1016882 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1016959), // Rule ID 61625 //
     /* 1016887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1016890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1016895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016926 */     // MIs[0] policy
     /* 1016926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1016939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1016941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016958 */     // GIR_Coverage, 61625,
     /* 1016958 */     GIR_EraseRootFromParent_Done,
     /* 1016959 */   // Label 15133: @1016959
     /* 1016959 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1017036), // Rule ID 61626 //
     /* 1016964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1016967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1016972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1016981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017003 */     // MIs[0] policy
     /* 1017003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017013 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1017016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017035 */     // GIR_Coverage, 61626,
     /* 1017035 */     GIR_EraseRootFromParent_Done,
     /* 1017036 */   // Label 15134: @1017036
     /* 1017036 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1017113), // Rule ID 61627 //
     /* 1017041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1017052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1017055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1017058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1017061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017080 */     // MIs[0] policy
     /* 1017080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1017093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017112 */     // GIR_Coverage, 61627,
     /* 1017112 */     GIR_EraseRootFromParent_Done,
     /* 1017113 */   // Label 15135: @1017113
     /* 1017113 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1017190), // Rule ID 61628 //
     /* 1017118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017157 */     // MIs[0] policy
     /* 1017157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1017170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017189 */     // GIR_Coverage, 61628,
     /* 1017189 */     GIR_EraseRootFromParent_Done,
     /* 1017190 */   // Label 15136: @1017190
     /* 1017190 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1017267), // Rule ID 61629 //
     /* 1017195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017234 */     // MIs[0] policy
     /* 1017234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1017247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017266 */     // GIR_Coverage, 61629,
     /* 1017266 */     GIR_EraseRootFromParent_Done,
     /* 1017267 */   // Label 15137: @1017267
     /* 1017267 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1017344), // Rule ID 61630 //
     /* 1017272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017311 */     // MIs[0] policy
     /* 1017311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1017324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017343 */     // GIR_Coverage, 61630,
     /* 1017343 */     GIR_EraseRootFromParent_Done,
     /* 1017344 */   // Label 15138: @1017344
     /* 1017344 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1017421), // Rule ID 61631 //
     /* 1017349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017388 */     // MIs[0] policy
     /* 1017388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1017401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017420 */     // GIR_Coverage, 61631,
     /* 1017420 */     GIR_EraseRootFromParent_Done,
     /* 1017421 */   // Label 15139: @1017421
     /* 1017421 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1017498), // Rule ID 61632 //
     /* 1017426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1017443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017465 */     // MIs[0] policy
     /* 1017465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017475 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1017478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017497 */     // GIR_Coverage, 61632,
     /* 1017497 */     GIR_EraseRootFromParent_Done,
     /* 1017498 */   // Label 15140: @1017498
     /* 1017498 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1017575), // Rule ID 61633 //
     /* 1017503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1017520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017542 */     // MIs[0] policy
     /* 1017542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1017555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017574 */     // GIR_Coverage, 61633,
     /* 1017574 */     GIR_EraseRootFromParent_Done,
     /* 1017575 */   // Label 15141: @1017575
     /* 1017575 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1017652), // Rule ID 61634 //
     /* 1017580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1017597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017619 */     // MIs[0] policy
     /* 1017619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1017632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017651 */     // GIR_Coverage, 61634,
     /* 1017651 */     GIR_EraseRootFromParent_Done,
     /* 1017652 */   // Label 15142: @1017652
     /* 1017652 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1017729), // Rule ID 61635 //
     /* 1017657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1017674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017696 */     // MIs[0] policy
     /* 1017696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1017709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017728 */     // GIR_Coverage, 61635,
     /* 1017728 */     GIR_EraseRootFromParent_Done,
     /* 1017729 */   // Label 15143: @1017729
     /* 1017729 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1017806), // Rule ID 61636 //
     /* 1017734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1017751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017773 */     // MIs[0] policy
     /* 1017773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017783 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1017786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017805 */     // GIR_Coverage, 61636,
     /* 1017805 */     GIR_EraseRootFromParent_Done,
     /* 1017806 */   // Label 15144: @1017806
     /* 1017806 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1017883), // Rule ID 61637 //
     /* 1017811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1017828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017850 */     // MIs[0] policy
     /* 1017850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1017863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017882 */     // GIR_Coverage, 61637,
     /* 1017882 */     GIR_EraseRootFromParent_Done,
     /* 1017883 */   // Label 15145: @1017883
     /* 1017883 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1017960), // Rule ID 61638 //
     /* 1017888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1017891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1017899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1017902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1017905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1017908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017927 */     // MIs[0] policy
     /* 1017927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017937 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1017940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1017942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017959 */     // GIR_Coverage, 61638,
     /* 1017959 */     GIR_EraseRootFromParent_Done,
     /* 1017960 */   // Label 15146: @1017960
     /* 1017960 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1018037), // Rule ID 61639 //
     /* 1017965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1017968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1017973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1017976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1017979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1017982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1017985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018004 */     // MIs[0] policy
     /* 1018004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1018017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018036 */     // GIR_Coverage, 61639,
     /* 1018036 */     GIR_EraseRootFromParent_Done,
     /* 1018037 */   // Label 15147: @1018037
     /* 1018037 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1018114), // Rule ID 61640 //
     /* 1018042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018081 */     // MIs[0] policy
     /* 1018081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1018094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018113 */     // GIR_Coverage, 61640,
     /* 1018113 */     GIR_EraseRootFromParent_Done,
     /* 1018114 */   // Label 15148: @1018114
     /* 1018114 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1018191), // Rule ID 61641 //
     /* 1018119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018158 */     // MIs[0] policy
     /* 1018158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1018171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018190 */     // GIR_Coverage, 61641,
     /* 1018190 */     GIR_EraseRootFromParent_Done,
     /* 1018191 */   // Label 15149: @1018191
     /* 1018191 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1018268), // Rule ID 61642 //
     /* 1018196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1018207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1018210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1018213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1018216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018235 */     // MIs[0] policy
     /* 1018235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1018248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018267 */     // GIR_Coverage, 61642,
     /* 1018267 */     GIR_EraseRootFromParent_Done,
     /* 1018268 */   // Label 15150: @1018268
     /* 1018268 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1018345), // Rule ID 61643 //
     /* 1018273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1018284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1018287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1018290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1018293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018312 */     // MIs[0] policy
     /* 1018312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1018325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018344 */     // GIR_Coverage, 61643,
     /* 1018344 */     GIR_EraseRootFromParent_Done,
     /* 1018345 */   // Label 15151: @1018345
     /* 1018345 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1018422), // Rule ID 61644 //
     /* 1018350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1018361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1018364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1018367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1018370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018389 */     // MIs[0] policy
     /* 1018389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1018402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018421 */     // GIR_Coverage, 61644,
     /* 1018421 */     GIR_EraseRootFromParent_Done,
     /* 1018422 */   // Label 15152: @1018422
     /* 1018422 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1018499), // Rule ID 61645 //
     /* 1018427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1018438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1018441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1018444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1018447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018466 */     // MIs[0] policy
     /* 1018466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1018479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018498 */     // GIR_Coverage, 61645,
     /* 1018498 */     GIR_EraseRootFromParent_Done,
     /* 1018499 */   // Label 15153: @1018499
     /* 1018499 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1018576), // Rule ID 61646 //
     /* 1018504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1018515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1018518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1018521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1018524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018543 */     // MIs[0] policy
     /* 1018543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1018556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018575 */     // GIR_Coverage, 61646,
     /* 1018575 */     GIR_EraseRootFromParent_Done,
     /* 1018576 */   // Label 15154: @1018576
     /* 1018576 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1018653), // Rule ID 61647 //
     /* 1018581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1018592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1018595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1018598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1018601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018620 */     // MIs[0] policy
     /* 1018620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1018633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018652 */     // GIR_Coverage, 61647,
     /* 1018652 */     GIR_EraseRootFromParent_Done,
     /* 1018653 */   // Label 15155: @1018653
     /* 1018653 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1018730), // Rule ID 61648 //
     /* 1018658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1018669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1018672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1018675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1018678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018697 */     // MIs[0] policy
     /* 1018697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018707 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1018710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018729 */     // GIR_Coverage, 61648,
     /* 1018729 */     GIR_EraseRootFromParent_Done,
     /* 1018730 */   // Label 15156: @1018730
     /* 1018730 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1018807), // Rule ID 61649 //
     /* 1018735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1018746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1018749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1018752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1018755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018774 */     // MIs[0] policy
     /* 1018774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1018787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018806 */     // GIR_Coverage, 61649,
     /* 1018806 */     GIR_EraseRootFromParent_Done,
     /* 1018807 */   // Label 15157: @1018807
     /* 1018807 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1018884), // Rule ID 61650 //
     /* 1018812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018851 */     // MIs[0] policy
     /* 1018851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1018864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018883 */     // GIR_Coverage, 61650,
     /* 1018883 */     GIR_EraseRootFromParent_Done,
     /* 1018884 */   // Label 15158: @1018884
     /* 1018884 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1018961), // Rule ID 61651 //
     /* 1018889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1018892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018928 */     // MIs[0] policy
     /* 1018928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1018941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1018943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018960 */     // GIR_Coverage, 61651,
     /* 1018960 */     GIR_EraseRootFromParent_Done,
     /* 1018961 */   // Label 15159: @1018961
     /* 1018961 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1019038), // Rule ID 61652 //
     /* 1018966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1018969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1018974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1018983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019005 */     // MIs[0] policy
     /* 1019005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1019018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019037 */     // GIR_Coverage, 61652,
     /* 1019037 */     GIR_EraseRootFromParent_Done,
     /* 1019038 */   // Label 15160: @1019038
     /* 1019038 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1019115), // Rule ID 61653 //
     /* 1019043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1019046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1019051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1019054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1019057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1019060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1019063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019082 */     // MIs[0] policy
     /* 1019082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1019095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019114 */     // GIR_Coverage, 61653,
     /* 1019114 */     GIR_EraseRootFromParent_Done,
     /* 1019115 */   // Label 15161: @1019115
     /* 1019115 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1019192), // Rule ID 61654 //
     /* 1019120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1019123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1019128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1019131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1019134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1019137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1019140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019159 */     // MIs[0] policy
     /* 1019159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019169 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1019172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019191 */     // GIR_Coverage, 61654,
     /* 1019191 */     GIR_EraseRootFromParent_Done,
     /* 1019192 */   // Label 15162: @1019192
     /* 1019192 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1019269), // Rule ID 61655 //
     /* 1019197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1019200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1019205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1019208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1019211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1019214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1019217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019236 */     // MIs[0] policy
     /* 1019236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1019249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019268 */     // GIR_Coverage, 61655,
     /* 1019268 */     GIR_EraseRootFromParent_Done,
     /* 1019269 */   // Label 15163: @1019269
     /* 1019269 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1019346), // Rule ID 61656 //
     /* 1019274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1019277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1019282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1019285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1019288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1019291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1019294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019313 */     // MIs[0] policy
     /* 1019313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1019326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019345 */     // GIR_Coverage, 61656,
     /* 1019345 */     GIR_EraseRootFromParent_Done,
     /* 1019346 */   // Label 15164: @1019346
     /* 1019346 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1019423), // Rule ID 61657 //
     /* 1019351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1019354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1019359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1019362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1019365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1019368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1019371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019390 */     // MIs[0] policy
     /* 1019390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1019403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1019405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019422 */     // GIR_Coverage, 61657,
     /* 1019422 */     GIR_EraseRootFromParent_Done,
     /* 1019423 */   // Label 15165: @1019423
     /* 1019423 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1019500), // Rule ID 61914 //
     /* 1019428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1019431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1019445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019467 */     // MIs[0] policy
     /* 1019467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1019480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019499 */     // GIR_Coverage, 61914,
     /* 1019499 */     GIR_EraseRootFromParent_Done,
     /* 1019500 */   // Label 15166: @1019500
     /* 1019500 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1019577), // Rule ID 61915 //
     /* 1019505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1019508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1019522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019544 */     // MIs[0] policy
     /* 1019544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1019557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019576 */     // GIR_Coverage, 61915,
     /* 1019576 */     GIR_EraseRootFromParent_Done,
     /* 1019577 */   // Label 15167: @1019577
     /* 1019577 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1019654), // Rule ID 61918 //
     /* 1019582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1019585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019621 */     // MIs[0] policy
     /* 1019621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1019634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019653 */     // GIR_Coverage, 61918,
     /* 1019653 */     GIR_EraseRootFromParent_Done,
     /* 1019654 */   // Label 15168: @1019654
     /* 1019654 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1019731), // Rule ID 61919 //
     /* 1019659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1019662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019698 */     // MIs[0] policy
     /* 1019698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1019711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019730 */     // GIR_Coverage, 61919,
     /* 1019730 */     GIR_EraseRootFromParent_Done,
     /* 1019731 */   // Label 15169: @1019731
     /* 1019731 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1019808), // Rule ID 61922 //
     /* 1019736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1019739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1019747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1019750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019775 */     // MIs[0] policy
     /* 1019775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1019788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019807 */     // GIR_Coverage, 61922,
     /* 1019807 */     GIR_EraseRootFromParent_Done,
     /* 1019808 */   // Label 15170: @1019808
     /* 1019808 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1019885), // Rule ID 61923 //
     /* 1019813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1019816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1019824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1019827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019852 */     // MIs[0] policy
     /* 1019852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1019865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019884 */     // GIR_Coverage, 61923,
     /* 1019884 */     GIR_EraseRootFromParent_Done,
     /* 1019885 */   // Label 15171: @1019885
     /* 1019885 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1019962), // Rule ID 61926 //
     /* 1019890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1019893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1019901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1019904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019929 */     // MIs[0] policy
     /* 1019929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1019942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019961 */     // GIR_Coverage, 61926,
     /* 1019961 */     GIR_EraseRootFromParent_Done,
     /* 1019962 */   // Label 15172: @1019962
     /* 1019962 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1020039), // Rule ID 61927 //
     /* 1019967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1019970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1019975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1019978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1019981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020006 */     // MIs[0] policy
     /* 1020006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1020019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020038 */     // GIR_Coverage, 61927,
     /* 1020038 */     GIR_EraseRootFromParent_Done,
     /* 1020039 */   // Label 15173: @1020039
     /* 1020039 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1020116), // Rule ID 61930 //
     /* 1020044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020083 */     // MIs[0] policy
     /* 1020083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1020096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020115 */     // GIR_Coverage, 61930,
     /* 1020115 */     GIR_EraseRootFromParent_Done,
     /* 1020116 */   // Label 15174: @1020116
     /* 1020116 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1020193), // Rule ID 61931 //
     /* 1020121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020160 */     // MIs[0] policy
     /* 1020160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1020173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020192 */     // GIR_Coverage, 61931,
     /* 1020192 */     GIR_EraseRootFromParent_Done,
     /* 1020193 */   // Label 15175: @1020193
     /* 1020193 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1020270), // Rule ID 61934 //
     /* 1020198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1020209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1020212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1020218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020237 */     // MIs[0] policy
     /* 1020237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020247 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1020250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020269 */     // GIR_Coverage, 61934,
     /* 1020269 */     GIR_EraseRootFromParent_Done,
     /* 1020270 */   // Label 15176: @1020270
     /* 1020270 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1020347), // Rule ID 61935 //
     /* 1020275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1020286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1020289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1020295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020314 */     // MIs[0] policy
     /* 1020314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1020327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020346 */     // GIR_Coverage, 61935,
     /* 1020346 */     GIR_EraseRootFromParent_Done,
     /* 1020347 */   // Label 15177: @1020347
     /* 1020347 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1020424), // Rule ID 61938 //
     /* 1020352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1020363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1020366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1020372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020391 */     // MIs[0] policy
     /* 1020391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1020404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020423 */     // GIR_Coverage, 61938,
     /* 1020423 */     GIR_EraseRootFromParent_Done,
     /* 1020424 */   // Label 15178: @1020424
     /* 1020424 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1020501), // Rule ID 61939 //
     /* 1020429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1020440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1020443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1020449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020468 */     // MIs[0] policy
     /* 1020468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1020481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020500 */     // GIR_Coverage, 61939,
     /* 1020500 */     GIR_EraseRootFromParent_Done,
     /* 1020501 */   // Label 15179: @1020501
     /* 1020501 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1020578), // Rule ID 61942 //
     /* 1020506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020545 */     // MIs[0] policy
     /* 1020545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1020558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020577 */     // GIR_Coverage, 61942,
     /* 1020577 */     GIR_EraseRootFromParent_Done,
     /* 1020578 */   // Label 15180: @1020578
     /* 1020578 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1020655), // Rule ID 61943 //
     /* 1020583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020622 */     // MIs[0] policy
     /* 1020622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1020635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020654 */     // GIR_Coverage, 61943,
     /* 1020654 */     GIR_EraseRootFromParent_Done,
     /* 1020655 */   // Label 15181: @1020655
     /* 1020655 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1020732), // Rule ID 61946 //
     /* 1020660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020699 */     // MIs[0] policy
     /* 1020699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020709 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1020712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020731 */     // GIR_Coverage, 61946,
     /* 1020731 */     GIR_EraseRootFromParent_Done,
     /* 1020732 */   // Label 15182: @1020732
     /* 1020732 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1020809), // Rule ID 61947 //
     /* 1020737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020776 */     // MIs[0] policy
     /* 1020776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1020789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020808 */     // GIR_Coverage, 61947,
     /* 1020808 */     GIR_EraseRootFromParent_Done,
     /* 1020809 */   // Label 15183: @1020809
     /* 1020809 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1020886), // Rule ID 61950 //
     /* 1020814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020853 */     // MIs[0] policy
     /* 1020853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020863 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1020866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020885 */     // GIR_Coverage, 61950,
     /* 1020885 */     GIR_EraseRootFromParent_Done,
     /* 1020886 */   // Label 15184: @1020886
     /* 1020886 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1020963), // Rule ID 61951 //
     /* 1020891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1020894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1020899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020930 */     // MIs[0] policy
     /* 1020930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1020943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020962 */     // GIR_Coverage, 61951,
     /* 1020962 */     GIR_EraseRootFromParent_Done,
     /* 1020963 */   // Label 15185: @1020963
     /* 1020963 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1021040), // Rule ID 61954 //
     /* 1020968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1020971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1020976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1020979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1020982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1020985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1020988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021007 */     // MIs[0] policy
     /* 1021007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021017 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1021020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021039 */     // GIR_Coverage, 61954,
     /* 1021039 */     GIR_EraseRootFromParent_Done,
     /* 1021040 */   // Label 15186: @1021040
     /* 1021040 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1021117), // Rule ID 61955 //
     /* 1021045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1021056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1021059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1021062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021084 */     // MIs[0] policy
     /* 1021084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1021097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021116 */     // GIR_Coverage, 61955,
     /* 1021116 */     GIR_EraseRootFromParent_Done,
     /* 1021117 */   // Label 15187: @1021117
     /* 1021117 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1021194), // Rule ID 61958 //
     /* 1021122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1021133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1021136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1021139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1021142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021161 */     // MIs[0] policy
     /* 1021161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1021174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021193 */     // GIR_Coverage, 61958,
     /* 1021193 */     GIR_EraseRootFromParent_Done,
     /* 1021194 */   // Label 15188: @1021194
     /* 1021194 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1021271), // Rule ID 61959 //
     /* 1021199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1021210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1021213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1021216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1021219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021238 */     // MIs[0] policy
     /* 1021238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1021251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021270 */     // GIR_Coverage, 61959,
     /* 1021270 */     GIR_EraseRootFromParent_Done,
     /* 1021271 */   // Label 15189: @1021271
     /* 1021271 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1021348), // Rule ID 61962 //
     /* 1021276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1021293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1021296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021315 */     // MIs[0] policy
     /* 1021315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1021328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021347 */     // GIR_Coverage, 61962,
     /* 1021347 */     GIR_EraseRootFromParent_Done,
     /* 1021348 */   // Label 15190: @1021348
     /* 1021348 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1021425), // Rule ID 61963 //
     /* 1021353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1021370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1021373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021392 */     // MIs[0] policy
     /* 1021392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1021405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021424 */     // GIR_Coverage, 61963,
     /* 1021424 */     GIR_EraseRootFromParent_Done,
     /* 1021425 */   // Label 15191: @1021425
     /* 1021425 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1021502), // Rule ID 61966 //
     /* 1021430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1021447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1021450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021469 */     // MIs[0] policy
     /* 1021469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1021482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021501 */     // GIR_Coverage, 61966,
     /* 1021501 */     GIR_EraseRootFromParent_Done,
     /* 1021502 */   // Label 15192: @1021502
     /* 1021502 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1021579), // Rule ID 61967 //
     /* 1021507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1021524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1021527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021546 */     // MIs[0] policy
     /* 1021546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1021559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021578 */     // GIR_Coverage, 61967,
     /* 1021578 */     GIR_EraseRootFromParent_Done,
     /* 1021579 */   // Label 15193: @1021579
     /* 1021579 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1021656), // Rule ID 61970 //
     /* 1021584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1021601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1021604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021623 */     // MIs[0] policy
     /* 1021623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021633 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1021636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021655 */     // GIR_Coverage, 61970,
     /* 1021655 */     GIR_EraseRootFromParent_Done,
     /* 1021656 */   // Label 15194: @1021656
     /* 1021656 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1021733), // Rule ID 61971 //
     /* 1021661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1021678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1021681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021700 */     // MIs[0] policy
     /* 1021700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1021713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021732 */     // GIR_Coverage, 61971,
     /* 1021732 */     GIR_EraseRootFromParent_Done,
     /* 1021733 */   // Label 15195: @1021733
     /* 1021733 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1021810), // Rule ID 61974 //
     /* 1021738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1021749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1021752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021777 */     // MIs[0] policy
     /* 1021777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021787 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1021790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021809 */     // GIR_Coverage, 61974,
     /* 1021809 */     GIR_EraseRootFromParent_Done,
     /* 1021810 */   // Label 15196: @1021810
     /* 1021810 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1021887), // Rule ID 61975 //
     /* 1021815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1021826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1021829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021854 */     // MIs[0] policy
     /* 1021854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021864 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1021867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021886 */     // GIR_Coverage, 61975,
     /* 1021886 */     GIR_EraseRootFromParent_Done,
     /* 1021887 */   // Label 15197: @1021887
     /* 1021887 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1021964), // Rule ID 61978 //
     /* 1021892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1021895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1021903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1021906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1021912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021931 */     // MIs[0] policy
     /* 1021931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021941 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1021944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021963 */     // GIR_Coverage, 61978,
     /* 1021963 */     GIR_EraseRootFromParent_Done,
     /* 1021964 */   // Label 15198: @1021964
     /* 1021964 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1022041), // Rule ID 61979 //
     /* 1021969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1021972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1021977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1021980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1021983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1021989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022008 */     // MIs[0] policy
     /* 1022008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1022021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022040 */     // GIR_Coverage, 61979,
     /* 1022040 */     GIR_EraseRootFromParent_Done,
     /* 1022041 */   // Label 15199: @1022041
     /* 1022041 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1022118), // Rule ID 61982 //
     /* 1022046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1022057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1022060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022085 */     // MIs[0] policy
     /* 1022085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1022098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022117 */     // GIR_Coverage, 61982,
     /* 1022117 */     GIR_EraseRootFromParent_Done,
     /* 1022118 */   // Label 15200: @1022118
     /* 1022118 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1022195), // Rule ID 61983 //
     /* 1022123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1022134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1022137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022162 */     // MIs[0] policy
     /* 1022162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1022175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022194 */     // GIR_Coverage, 61983,
     /* 1022194 */     GIR_EraseRootFromParent_Done,
     /* 1022195 */   // Label 15201: @1022195
     /* 1022195 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1022272), // Rule ID 61986 //
     /* 1022200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1022211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1022214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1022220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022239 */     // MIs[0] policy
     /* 1022239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022249 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1022252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022271 */     // GIR_Coverage, 61986,
     /* 1022271 */     GIR_EraseRootFromParent_Done,
     /* 1022272 */   // Label 15202: @1022272
     /* 1022272 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1022349), // Rule ID 61987 //
     /* 1022277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1022288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1022291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1022297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022316 */     // MIs[0] policy
     /* 1022316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022326 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1022329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022348 */     // GIR_Coverage, 61987,
     /* 1022348 */     GIR_EraseRootFromParent_Done,
     /* 1022349 */   // Label 15203: @1022349
     /* 1022349 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1022426), // Rule ID 61990 //
     /* 1022354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1022365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1022368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1022374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022393 */     // MIs[0] policy
     /* 1022393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1022406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022425 */     // GIR_Coverage, 61990,
     /* 1022425 */     GIR_EraseRootFromParent_Done,
     /* 1022426 */   // Label 15204: @1022426
     /* 1022426 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1022503), // Rule ID 61991 //
     /* 1022431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1022439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1022442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1022445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1022451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022470 */     // MIs[0] policy
     /* 1022470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1022483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022502 */     // GIR_Coverage, 61991,
     /* 1022502 */     GIR_EraseRootFromParent_Done,
     /* 1022503 */   // Label 15205: @1022503
     /* 1022503 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1022580), // Rule ID 61994 //
     /* 1022508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022547 */     // MIs[0] policy
     /* 1022547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022557 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1022560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022579 */     // GIR_Coverage, 61994,
     /* 1022579 */     GIR_EraseRootFromParent_Done,
     /* 1022580 */   // Label 15206: @1022580
     /* 1022580 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1022657), // Rule ID 61995 //
     /* 1022585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022624 */     // MIs[0] policy
     /* 1022624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1022637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022656 */     // GIR_Coverage, 61995,
     /* 1022656 */     GIR_EraseRootFromParent_Done,
     /* 1022657 */   // Label 15207: @1022657
     /* 1022657 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1022734), // Rule ID 61998 //
     /* 1022662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1022679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022701 */     // MIs[0] policy
     /* 1022701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1022714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022733 */     // GIR_Coverage, 61998,
     /* 1022733 */     GIR_EraseRootFromParent_Done,
     /* 1022734 */   // Label 15208: @1022734
     /* 1022734 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1022811), // Rule ID 61999 //
     /* 1022739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1022756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022778 */     // MIs[0] policy
     /* 1022778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1022791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022810 */     // GIR_Coverage, 61999,
     /* 1022810 */     GIR_EraseRootFromParent_Done,
     /* 1022811 */   // Label 15209: @1022811
     /* 1022811 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1022888), // Rule ID 62002 //
     /* 1022816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1022827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1022830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1022833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022855 */     // MIs[0] policy
     /* 1022855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1022868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022887 */     // GIR_Coverage, 62002,
     /* 1022887 */     GIR_EraseRootFromParent_Done,
     /* 1022888 */   // Label 15210: @1022888
     /* 1022888 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1022965), // Rule ID 62003 //
     /* 1022893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1022896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1022904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1022907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1022910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022932 */     // MIs[0] policy
     /* 1022932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1022945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022964 */     // GIR_Coverage, 62003,
     /* 1022964 */     GIR_EraseRootFromParent_Done,
     /* 1022965 */   // Label 15211: @1022965
     /* 1022965 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1023042), // Rule ID 62006 //
     /* 1022970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1022973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1022978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1022981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1022984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1022987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1022990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023009 */     // MIs[0] policy
     /* 1023009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1023022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023041 */     // GIR_Coverage, 62006,
     /* 1023041 */     GIR_EraseRootFromParent_Done,
     /* 1023042 */   // Label 15212: @1023042
     /* 1023042 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1023119), // Rule ID 62007 //
     /* 1023047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1023058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1023061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1023064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023086 */     // MIs[0] policy
     /* 1023086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1023099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023118 */     // GIR_Coverage, 62007,
     /* 1023118 */     GIR_EraseRootFromParent_Done,
     /* 1023119 */   // Label 15213: @1023119
     /* 1023119 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1023196), // Rule ID 62010 //
     /* 1023124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023163 */     // MIs[0] policy
     /* 1023163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023173 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1023176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023195 */     // GIR_Coverage, 62010,
     /* 1023195 */     GIR_EraseRootFromParent_Done,
     /* 1023196 */   // Label 15214: @1023196
     /* 1023196 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1023273), // Rule ID 62011 //
     /* 1023201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023240 */     // MIs[0] policy
     /* 1023240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1023253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023272 */     // GIR_Coverage, 62011,
     /* 1023272 */     GIR_EraseRootFromParent_Done,
     /* 1023273 */   // Label 15215: @1023273
     /* 1023273 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1023350), // Rule ID 62014 //
     /* 1023278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1023289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1023292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1023298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023317 */     // MIs[0] policy
     /* 1023317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023327 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1023330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023349 */     // GIR_Coverage, 62014,
     /* 1023349 */     GIR_EraseRootFromParent_Done,
     /* 1023350 */   // Label 15216: @1023350
     /* 1023350 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1023427), // Rule ID 62015 //
     /* 1023355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1023366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1023369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1023375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023394 */     // MIs[0] policy
     /* 1023394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1023407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023426 */     // GIR_Coverage, 62015,
     /* 1023426 */     GIR_EraseRootFromParent_Done,
     /* 1023427 */   // Label 15217: @1023427
     /* 1023427 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1023504), // Rule ID 62018 //
     /* 1023432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023471 */     // MIs[0] policy
     /* 1023471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023481 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1023484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023503 */     // GIR_Coverage, 62018,
     /* 1023503 */     GIR_EraseRootFromParent_Done,
     /* 1023504 */   // Label 15218: @1023504
     /* 1023504 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1023581), // Rule ID 62019 //
     /* 1023509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023548 */     // MIs[0] policy
     /* 1023548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1023561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023580 */     // GIR_Coverage, 62019,
     /* 1023580 */     GIR_EraseRootFromParent_Done,
     /* 1023581 */   // Label 15219: @1023581
     /* 1023581 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1023658), // Rule ID 62022 //
     /* 1023586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1023597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1023600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023625 */     // MIs[0] policy
     /* 1023625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023635 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1023638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023657 */     // GIR_Coverage, 62022,
     /* 1023657 */     GIR_EraseRootFromParent_Done,
     /* 1023658 */   // Label 15220: @1023658
     /* 1023658 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1023735), // Rule ID 62023 //
     /* 1023663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1023674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1023677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023702 */     // MIs[0] policy
     /* 1023702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1023715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023734 */     // GIR_Coverage, 62023,
     /* 1023734 */     GIR_EraseRootFromParent_Done,
     /* 1023735 */   // Label 15221: @1023735
     /* 1023735 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1023812), // Rule ID 62026 //
     /* 1023740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1023751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1023754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023779 */     // MIs[0] policy
     /* 1023779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1023792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023811 */     // GIR_Coverage, 62026,
     /* 1023811 */     GIR_EraseRootFromParent_Done,
     /* 1023812 */   // Label 15222: @1023812
     /* 1023812 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1023889), // Rule ID 62027 //
     /* 1023817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1023828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1023831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023856 */     // MIs[0] policy
     /* 1023856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1023869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023888 */     // GIR_Coverage, 62027,
     /* 1023888 */     GIR_EraseRootFromParent_Done,
     /* 1023889 */   // Label 15223: @1023889
     /* 1023889 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1023966), // Rule ID 62030 //
     /* 1023894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1023897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023933 */     // MIs[0] policy
     /* 1023933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1023946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023965 */     // GIR_Coverage, 62030,
     /* 1023965 */     GIR_EraseRootFromParent_Done,
     /* 1023966 */   // Label 15224: @1023966
     /* 1023966 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1024043), // Rule ID 62031 //
     /* 1023971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1023974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1023979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024010 */     // MIs[0] policy
     /* 1024010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1024023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024042 */     // GIR_Coverage, 62031,
     /* 1024042 */     GIR_EraseRootFromParent_Done,
     /* 1024043 */   // Label 15225: @1024043
     /* 1024043 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1024120), // Rule ID 62034 //
     /* 1024048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1024051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1024059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1024062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1024068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024087 */     // MIs[0] policy
     /* 1024087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024097 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1024100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024119 */     // GIR_Coverage, 62034,
     /* 1024119 */     GIR_EraseRootFromParent_Done,
     /* 1024120 */   // Label 15226: @1024120
     /* 1024120 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1024197), // Rule ID 62035 //
     /* 1024125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1024128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1024136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1024139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1024145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024164 */     // MIs[0] policy
     /* 1024164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1024177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024196 */     // GIR_Coverage, 62035,
     /* 1024196 */     GIR_EraseRootFromParent_Done,
     /* 1024197 */   // Label 15227: @1024197
     /* 1024197 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1024274), // Rule ID 62038 //
     /* 1024202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1024205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1024213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1024216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1024222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024241 */     // MIs[0] policy
     /* 1024241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024251 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1024254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024273 */     // GIR_Coverage, 62038,
     /* 1024273 */     GIR_EraseRootFromParent_Done,
     /* 1024274 */   // Label 15228: @1024274
     /* 1024274 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1024351), // Rule ID 62039 //
     /* 1024279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1024282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1024290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1024293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1024299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024318 */     // MIs[0] policy
     /* 1024318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1024331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024350 */     // GIR_Coverage, 62039,
     /* 1024350 */     GIR_EraseRootFromParent_Done,
     /* 1024351 */   // Label 15229: @1024351
     /* 1024351 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1024428), // Rule ID 62042 //
     /* 1024356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1024359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1024376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024395 */     // MIs[0] policy
     /* 1024395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1024408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024427 */     // GIR_Coverage, 62042,
     /* 1024427 */     GIR_EraseRootFromParent_Done,
     /* 1024428 */   // Label 15230: @1024428
     /* 1024428 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1024505), // Rule ID 62043 //
     /* 1024433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1024436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1024453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024472 */     // MIs[0] policy
     /* 1024472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1024485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024504 */     // GIR_Coverage, 62043,
     /* 1024504 */     GIR_EraseRootFromParent_Done,
     /* 1024505 */   // Label 15231: @1024505
     /* 1024505 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1024582), // Rule ID 62046 //
     /* 1024510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1024513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1024530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024549 */     // MIs[0] policy
     /* 1024549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1024562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024581 */     // GIR_Coverage, 62046,
     /* 1024581 */     GIR_EraseRootFromParent_Done,
     /* 1024582 */   // Label 15232: @1024582
     /* 1024582 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1024659), // Rule ID 62047 //
     /* 1024587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1024590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1024607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024626 */     // MIs[0] policy
     /* 1024626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1024639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024658 */     // GIR_Coverage, 62047,
     /* 1024658 */     GIR_EraseRootFromParent_Done,
     /* 1024659 */   // Label 15233: @1024659
     /* 1024659 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1024736), // Rule ID 62050 //
     /* 1024664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1024667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1024684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024703 */     // MIs[0] policy
     /* 1024703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024713 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1024716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024735 */     // GIR_Coverage, 62050,
     /* 1024735 */     GIR_EraseRootFromParent_Done,
     /* 1024736 */   // Label 15234: @1024736
     /* 1024736 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1024813), // Rule ID 62051 //
     /* 1024741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1024744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1024749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1024761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024780 */     // MIs[0] policy
     /* 1024780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1024793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024812 */     // GIR_Coverage, 62051,
     /* 1024812 */     GIR_EraseRootFromParent_Done,
     /* 1024813 */   // Label 15235: @1024813
     /* 1024813 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1024890), // Rule ID 62145 //
     /* 1024818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1024821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1024826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1024829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1024832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1024835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1024838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024857 */     // MIs[0] policy
     /* 1024857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024867 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1024870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024889 */     // GIR_Coverage, 62145,
     /* 1024889 */     GIR_EraseRootFromParent_Done,
     /* 1024890 */   // Label 15236: @1024890
     /* 1024890 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1024967), // Rule ID 62146 //
     /* 1024895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1024898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1024903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1024906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1024909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1024912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1024915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024934 */     // MIs[0] policy
     /* 1024934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1024947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024966 */     // GIR_Coverage, 62146,
     /* 1024966 */     GIR_EraseRootFromParent_Done,
     /* 1024967 */   // Label 15237: @1024967
     /* 1024967 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1025044), // Rule ID 63603 //
     /* 1024972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1024975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1024980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1024989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1024992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025011 */     // MIs[0] policy
     /* 1025011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1025024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025043 */     // GIR_Coverage, 63603,
     /* 1025043 */     GIR_EraseRootFromParent_Done,
     /* 1025044 */   // Label 15238: @1025044
     /* 1025044 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1025121), // Rule ID 63604 //
     /* 1025049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1025057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1025060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1025063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1025069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025088 */     // MIs[0] policy
     /* 1025088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1025101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025120 */     // GIR_Coverage, 63604,
     /* 1025120 */     GIR_EraseRootFromParent_Done,
     /* 1025121 */   // Label 15239: @1025121
     /* 1025121 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1025198), // Rule ID 63605 //
     /* 1025126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1025134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1025137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1025140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1025146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025165 */     // MIs[0] policy
     /* 1025165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025175 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1025178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025197 */     // GIR_Coverage, 63605,
     /* 1025197 */     GIR_EraseRootFromParent_Done,
     /* 1025198 */   // Label 15240: @1025198
     /* 1025198 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1025275), // Rule ID 63606 //
     /* 1025203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1025211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1025214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1025217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1025223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025242 */     // MIs[0] policy
     /* 1025242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1025255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025274 */     // GIR_Coverage, 63606,
     /* 1025274 */     GIR_EraseRootFromParent_Done,
     /* 1025275 */   // Label 15241: @1025275
     /* 1025275 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1025352), // Rule ID 63607 //
     /* 1025280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1025288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1025291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1025294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1025300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025319 */     // MIs[0] policy
     /* 1025319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025329 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1025332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025351 */     // GIR_Coverage, 63607,
     /* 1025351 */     GIR_EraseRootFromParent_Done,
     /* 1025352 */   // Label 15242: @1025352
     /* 1025352 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1025429), // Rule ID 63608 //
     /* 1025357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1025365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1025368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1025371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1025377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025396 */     // MIs[0] policy
     /* 1025396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1025409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025428 */     // GIR_Coverage, 63608,
     /* 1025428 */     GIR_EraseRootFromParent_Done,
     /* 1025429 */   // Label 15243: @1025429
     /* 1025429 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1025506), // Rule ID 63609 //
     /* 1025434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1025445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1025448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025473 */     // MIs[0] policy
     /* 1025473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025483 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1025486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025505 */     // GIR_Coverage, 63609,
     /* 1025505 */     GIR_EraseRootFromParent_Done,
     /* 1025506 */   // Label 15244: @1025506
     /* 1025506 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1025583), // Rule ID 63610 //
     /* 1025511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1025522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1025525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025550 */     // MIs[0] policy
     /* 1025550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1025563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025582 */     // GIR_Coverage, 63610,
     /* 1025582 */     GIR_EraseRootFromParent_Done,
     /* 1025583 */   // Label 15245: @1025583
     /* 1025583 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1025660), // Rule ID 63611 //
     /* 1025588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1025599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1025602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1025608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025627 */     // MIs[0] policy
     /* 1025627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1025640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025659 */     // GIR_Coverage, 63611,
     /* 1025659 */     GIR_EraseRootFromParent_Done,
     /* 1025660 */   // Label 15246: @1025660
     /* 1025660 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1025737), // Rule ID 63612 //
     /* 1025665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1025676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1025679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1025685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025704 */     // MIs[0] policy
     /* 1025704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1025717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025736 */     // GIR_Coverage, 63612,
     /* 1025736 */     GIR_EraseRootFromParent_Done,
     /* 1025737 */   // Label 15247: @1025737
     /* 1025737 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1025814), // Rule ID 63613 //
     /* 1025742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1025753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1025756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1025762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025781 */     // MIs[0] policy
     /* 1025781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1025794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025813 */     // GIR_Coverage, 63613,
     /* 1025813 */     GIR_EraseRootFromParent_Done,
     /* 1025814 */   // Label 15248: @1025814
     /* 1025814 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1025891), // Rule ID 63614 //
     /* 1025819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1025830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1025833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1025839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025858 */     // MIs[0] policy
     /* 1025858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1025871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025890 */     // GIR_Coverage, 63614,
     /* 1025890 */     GIR_EraseRootFromParent_Done,
     /* 1025891 */   // Label 15249: @1025891
     /* 1025891 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1025968), // Rule ID 63615 //
     /* 1025896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1025899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1025907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1025910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1025916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025935 */     // MIs[0] policy
     /* 1025935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025945 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1025948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025967 */     // GIR_Coverage, 63615,
     /* 1025967 */     GIR_EraseRootFromParent_Done,
     /* 1025968 */   // Label 15250: @1025968
     /* 1025968 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1026045), // Rule ID 63616 //
     /* 1025973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1025976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1025981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1025984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1025987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1025993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026012 */     // MIs[0] policy
     /* 1026012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1026025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026044 */     // GIR_Coverage, 63616,
     /* 1026044 */     GIR_EraseRootFromParent_Done,
     /* 1026045 */   // Label 15251: @1026045
     /* 1026045 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1026122), // Rule ID 63617 //
     /* 1026050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026089 */     // MIs[0] policy
     /* 1026089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1026102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026121 */     // GIR_Coverage, 63617,
     /* 1026121 */     GIR_EraseRootFromParent_Done,
     /* 1026122 */   // Label 15252: @1026122
     /* 1026122 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1026199), // Rule ID 63618 //
     /* 1026127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026166 */     // MIs[0] policy
     /* 1026166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1026179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026198 */     // GIR_Coverage, 63618,
     /* 1026198 */     GIR_EraseRootFromParent_Done,
     /* 1026199 */   // Label 15253: @1026199
     /* 1026199 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1026276), // Rule ID 63619 //
     /* 1026204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1026215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1026218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026243 */     // MIs[0] policy
     /* 1026243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1026256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026275 */     // GIR_Coverage, 63619,
     /* 1026275 */     GIR_EraseRootFromParent_Done,
     /* 1026276 */   // Label 15254: @1026276
     /* 1026276 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1026353), // Rule ID 63620 //
     /* 1026281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1026292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1026295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026320 */     // MIs[0] policy
     /* 1026320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1026333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026352 */     // GIR_Coverage, 63620,
     /* 1026352 */     GIR_EraseRootFromParent_Done,
     /* 1026353 */   // Label 15255: @1026353
     /* 1026353 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1026430), // Rule ID 63621 //
     /* 1026358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1026369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1026372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026397 */     // MIs[0] policy
     /* 1026397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026407 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1026410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026429 */     // GIR_Coverage, 63621,
     /* 1026429 */     GIR_EraseRootFromParent_Done,
     /* 1026430 */   // Label 15256: @1026430
     /* 1026430 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1026507), // Rule ID 63622 //
     /* 1026435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1026446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1026449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026474 */     // MIs[0] policy
     /* 1026474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1026487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026506 */     // GIR_Coverage, 63622,
     /* 1026506 */     GIR_EraseRootFromParent_Done,
     /* 1026507 */   // Label 15257: @1026507
     /* 1026507 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1026584), // Rule ID 63623 //
     /* 1026512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1026523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1026526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026551 */     // MIs[0] policy
     /* 1026551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026561 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1026564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026583 */     // GIR_Coverage, 63623,
     /* 1026583 */     GIR_EraseRootFromParent_Done,
     /* 1026584 */   // Label 15258: @1026584
     /* 1026584 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1026661), // Rule ID 63624 //
     /* 1026589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1026597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1026600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1026603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026628 */     // MIs[0] policy
     /* 1026628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1026641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026660 */     // GIR_Coverage, 63624,
     /* 1026660 */     GIR_EraseRootFromParent_Done,
     /* 1026661 */   // Label 15259: @1026661
     /* 1026661 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1026738), // Rule ID 63625 //
     /* 1026666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1026674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026705 */     // MIs[0] policy
     /* 1026705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1026718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026737 */     // GIR_Coverage, 63625,
     /* 1026737 */     GIR_EraseRootFromParent_Done,
     /* 1026738 */   // Label 15260: @1026738
     /* 1026738 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1026815), // Rule ID 63626 //
     /* 1026743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1026751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026782 */     // MIs[0] policy
     /* 1026782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1026795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026814 */     // GIR_Coverage, 63626,
     /* 1026814 */     GIR_EraseRootFromParent_Done,
     /* 1026815 */   // Label 15261: @1026815
     /* 1026815 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1026892), // Rule ID 63627 //
     /* 1026820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1026828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1026831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1026834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026859 */     // MIs[0] policy
     /* 1026859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1026872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026891 */     // GIR_Coverage, 63627,
     /* 1026891 */     GIR_EraseRootFromParent_Done,
     /* 1026892 */   // Label 15262: @1026892
     /* 1026892 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1026969), // Rule ID 63628 //
     /* 1026897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1026900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1026905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1026908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1026911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026936 */     // MIs[0] policy
     /* 1026936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1026949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026968 */     // GIR_Coverage, 63628,
     /* 1026968 */     GIR_EraseRootFromParent_Done,
     /* 1026969 */   // Label 15263: @1026969
     /* 1026969 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1027046), // Rule ID 63629 //
     /* 1026974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1026977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1026982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1026985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1026988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027013 */     // MIs[0] policy
     /* 1027013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1027026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027045 */     // GIR_Coverage, 63629,
     /* 1027045 */     GIR_EraseRootFromParent_Done,
     /* 1027046 */   // Label 15264: @1027046
     /* 1027046 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1027123), // Rule ID 63630 //
     /* 1027051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1027054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1027059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027090 */     // MIs[0] policy
     /* 1027090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1027103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027122 */     // GIR_Coverage, 63630,
     /* 1027122 */     GIR_EraseRootFromParent_Done,
     /* 1027123 */   // Label 15265: @1027123
     /* 1027123 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1027200), // Rule ID 63631 //
     /* 1027128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1027131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1027136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027167 */     // MIs[0] policy
     /* 1027167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1027180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027199 */     // GIR_Coverage, 63631,
     /* 1027199 */     GIR_EraseRootFromParent_Done,
     /* 1027200 */   // Label 15266: @1027200
     /* 1027200 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1027277), // Rule ID 63632 //
     /* 1027205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1027208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1027213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027244 */     // MIs[0] policy
     /* 1027244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1027257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027276 */     // GIR_Coverage, 63632,
     /* 1027276 */     GIR_EraseRootFromParent_Done,
     /* 1027277 */   // Label 15267: @1027277
     /* 1027277 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1027354), // Rule ID 63633 //
     /* 1027282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1027285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1027293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1027296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1027302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027321 */     // MIs[0] policy
     /* 1027321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1027334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027353 */     // GIR_Coverage, 63633,
     /* 1027353 */     GIR_EraseRootFromParent_Done,
     /* 1027354 */   // Label 15268: @1027354
     /* 1027354 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1027431), // Rule ID 63634 //
     /* 1027359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1027362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1027370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1027373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1027379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027398 */     // MIs[0] policy
     /* 1027398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1027411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027430 */     // GIR_Coverage, 63634,
     /* 1027430 */     GIR_EraseRootFromParent_Done,
     /* 1027431 */   // Label 15269: @1027431
     /* 1027431 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1027508), // Rule ID 63635 //
     /* 1027436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1027439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1027456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027475 */     // MIs[0] policy
     /* 1027475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1027488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027507 */     // GIR_Coverage, 63635,
     /* 1027507 */     GIR_EraseRootFromParent_Done,
     /* 1027508 */   // Label 15270: @1027508
     /* 1027508 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1027585), // Rule ID 63636 //
     /* 1027513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1027516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1027533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027552 */     // MIs[0] policy
     /* 1027552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1027565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027584 */     // GIR_Coverage, 63636,
     /* 1027584 */     GIR_EraseRootFromParent_Done,
     /* 1027585 */   // Label 15271: @1027585
     /* 1027585 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1027662), // Rule ID 63637 //
     /* 1027590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1027593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027629 */     // MIs[0] policy
     /* 1027629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027639 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1027642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027661 */     // GIR_Coverage, 63637,
     /* 1027661 */     GIR_EraseRootFromParent_Done,
     /* 1027662 */   // Label 15272: @1027662
     /* 1027662 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1027739), // Rule ID 63638 //
     /* 1027667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1027670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027706 */     // MIs[0] policy
     /* 1027706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1027719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027738 */     // GIR_Coverage, 63638,
     /* 1027738 */     GIR_EraseRootFromParent_Done,
     /* 1027739 */   // Label 15273: @1027739
     /* 1027739 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1027816), // Rule ID 63639 //
     /* 1027744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1027747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027783 */     // MIs[0] policy
     /* 1027783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1027796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027815 */     // GIR_Coverage, 63639,
     /* 1027815 */     GIR_EraseRootFromParent_Done,
     /* 1027816 */   // Label 15274: @1027816
     /* 1027816 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1027893), // Rule ID 63640 //
     /* 1027821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1027824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1027829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027860 */     // MIs[0] policy
     /* 1027860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1027873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027892 */     // GIR_Coverage, 63640,
     /* 1027892 */     GIR_EraseRootFromParent_Done,
     /* 1027893 */   // Label 15275: @1027893
     /* 1027893 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1027970), // Rule ID 63641 //
     /* 1027898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1027901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1027906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1027909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1027912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1027918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027937 */     // MIs[0] policy
     /* 1027937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027947 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1027950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027969 */     // GIR_Coverage, 63641,
     /* 1027969 */     GIR_EraseRootFromParent_Done,
     /* 1027970 */   // Label 15276: @1027970
     /* 1027970 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1028047), // Rule ID 63642 //
     /* 1027975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1027978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1027983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1027986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1027989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1027992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1027995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028014 */     // MIs[0] policy
     /* 1028014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1028027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028046 */     // GIR_Coverage, 63642,
     /* 1028046 */     GIR_EraseRootFromParent_Done,
     /* 1028047 */   // Label 15277: @1028047
     /* 1028047 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1028124), // Rule ID 63643 //
     /* 1028052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1028063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1028066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028091 */     // MIs[0] policy
     /* 1028091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1028104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028123 */     // GIR_Coverage, 63643,
     /* 1028123 */     GIR_EraseRootFromParent_Done,
     /* 1028124 */   // Label 15278: @1028124
     /* 1028124 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1028201), // Rule ID 63644 //
     /* 1028129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1028140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1028143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028168 */     // MIs[0] policy
     /* 1028168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1028181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028200 */     // GIR_Coverage, 63644,
     /* 1028200 */     GIR_EraseRootFromParent_Done,
     /* 1028201 */   // Label 15279: @1028201
     /* 1028201 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1028278), // Rule ID 63645 //
     /* 1028206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1028226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028245 */     // MIs[0] policy
     /* 1028245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028255 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1028258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028277 */     // GIR_Coverage, 63645,
     /* 1028277 */     GIR_EraseRootFromParent_Done,
     /* 1028278 */   // Label 15280: @1028278
     /* 1028278 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1028355), // Rule ID 63646 //
     /* 1028283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1028303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028322 */     // MIs[0] policy
     /* 1028322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1028335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028354 */     // GIR_Coverage, 63646,
     /* 1028354 */     GIR_EraseRootFromParent_Done,
     /* 1028355 */   // Label 15281: @1028355
     /* 1028355 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1028432), // Rule ID 63647 //
     /* 1028360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1028380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028399 */     // MIs[0] policy
     /* 1028399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028409 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1028412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028431 */     // GIR_Coverage, 63647,
     /* 1028431 */     GIR_EraseRootFromParent_Done,
     /* 1028432 */   // Label 15282: @1028432
     /* 1028432 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1028509), // Rule ID 63648 //
     /* 1028437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1028445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1028457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028476 */     // MIs[0] policy
     /* 1028476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1028489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028508 */     // GIR_Coverage, 63648,
     /* 1028508 */     GIR_EraseRootFromParent_Done,
     /* 1028509 */   // Label 15283: @1028509
     /* 1028509 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1028586), // Rule ID 63649 //
     /* 1028514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1028525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1028528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028553 */     // MIs[0] policy
     /* 1028553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1028566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028585 */     // GIR_Coverage, 63649,
     /* 1028585 */     GIR_EraseRootFromParent_Done,
     /* 1028586 */   // Label 15284: @1028586
     /* 1028586 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1028663), // Rule ID 63650 //
     /* 1028591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1028602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1028605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028630 */     // MIs[0] policy
     /* 1028630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1028643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028662 */     // GIR_Coverage, 63650,
     /* 1028662 */     GIR_EraseRootFromParent_Done,
     /* 1028663 */   // Label 15285: @1028663
     /* 1028663 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1028740), // Rule ID 63651 //
     /* 1028668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1028679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1028682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028707 */     // MIs[0] policy
     /* 1028707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1028720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028739 */     // GIR_Coverage, 63651,
     /* 1028739 */     GIR_EraseRootFromParent_Done,
     /* 1028740 */   // Label 15286: @1028740
     /* 1028740 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1028817), // Rule ID 63652 //
     /* 1028745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1028756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1028759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028784 */     // MIs[0] policy
     /* 1028784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1028797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028816 */     // GIR_Coverage, 63652,
     /* 1028816 */     GIR_EraseRootFromParent_Done,
     /* 1028817 */   // Label 15287: @1028817
     /* 1028817 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1028894), // Rule ID 63653 //
     /* 1028822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1028842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028861 */     // MIs[0] policy
     /* 1028861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1028874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028893 */     // GIR_Coverage, 63653,
     /* 1028893 */     GIR_EraseRootFromParent_Done,
     /* 1028894 */   // Label 15288: @1028894
     /* 1028894 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1028971), // Rule ID 63654 //
     /* 1028899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1028902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1028919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028938 */     // MIs[0] policy
     /* 1028938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1028951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028970 */     // GIR_Coverage, 63654,
     /* 1028970 */     GIR_EraseRootFromParent_Done,
     /* 1028971 */   // Label 15289: @1028971
     /* 1028971 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1029048), // Rule ID 63655 //
     /* 1028976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1028979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1028984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1028993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1028996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029015 */     // MIs[0] policy
     /* 1029015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1029028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029047 */     // GIR_Coverage, 63655,
     /* 1029047 */     GIR_EraseRootFromParent_Done,
     /* 1029048 */   // Label 15290: @1029048
     /* 1029048 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1029125), // Rule ID 63656 //
     /* 1029053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1029056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1029061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1029064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1029067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1029073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029092 */     // MIs[0] policy
     /* 1029092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1029105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029124 */     // GIR_Coverage, 63656,
     /* 1029124 */     GIR_EraseRootFromParent_Done,
     /* 1029125 */   // Label 15291: @1029125
     /* 1029125 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1029202), // Rule ID 63657 //
     /* 1029130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1029133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029169 */     // MIs[0] policy
     /* 1029169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029179 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1029182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029201 */     // GIR_Coverage, 63657,
     /* 1029201 */     GIR_EraseRootFromParent_Done,
     /* 1029202 */   // Label 15292: @1029202
     /* 1029202 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1029279), // Rule ID 63658 //
     /* 1029207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1029210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029246 */     // MIs[0] policy
     /* 1029246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1029259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029278 */     // GIR_Coverage, 63658,
     /* 1029278 */     GIR_EraseRootFromParent_Done,
     /* 1029279 */   // Label 15293: @1029279
     /* 1029279 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1029356), // Rule ID 63659 //
     /* 1029284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1029287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1029295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1029298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029323 */     // MIs[0] policy
     /* 1029323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1029336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029355 */     // GIR_Coverage, 63659,
     /* 1029355 */     GIR_EraseRootFromParent_Done,
     /* 1029356 */   // Label 15294: @1029356
     /* 1029356 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1029433), // Rule ID 63660 //
     /* 1029361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1029364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1029372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1029375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029400 */     // MIs[0] policy
     /* 1029400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1029413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029432 */     // GIR_Coverage, 63660,
     /* 1029432 */     GIR_EraseRootFromParent_Done,
     /* 1029433 */   // Label 15295: @1029433
     /* 1029433 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1029510), // Rule ID 63661 //
     /* 1029438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1029441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1029449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1029452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029477 */     // MIs[0] policy
     /* 1029477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029487 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1029490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029509 */     // GIR_Coverage, 63661,
     /* 1029509 */     GIR_EraseRootFromParent_Done,
     /* 1029510 */   // Label 15296: @1029510
     /* 1029510 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1029587), // Rule ID 63662 //
     /* 1029515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1029518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1029526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1029529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029554 */     // MIs[0] policy
     /* 1029554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1029567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029586 */     // GIR_Coverage, 63662,
     /* 1029586 */     GIR_EraseRootFromParent_Done,
     /* 1029587 */   // Label 15297: @1029587
     /* 1029587 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1029664), // Rule ID 63663 //
     /* 1029592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1029595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1029603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1029606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1029612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029631 */     // MIs[0] policy
     /* 1029631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029641 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1029644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029663 */     // GIR_Coverage, 63663,
     /* 1029663 */     GIR_EraseRootFromParent_Done,
     /* 1029664 */   // Label 15298: @1029664
     /* 1029664 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1029741), // Rule ID 63664 //
     /* 1029669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1029672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1029677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1029680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1029683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1029689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029708 */     // MIs[0] policy
     /* 1029708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1029721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029740 */     // GIR_Coverage, 63664,
     /* 1029740 */     GIR_EraseRootFromParent_Done,
     /* 1029741 */   // Label 15299: @1029741
     /* 1029741 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1029821), // Rule ID 2582 //
     /* 1029746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1029754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1029757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1029760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1029763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1029766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1029769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029785 */     // MIs[0] round
     /* 1029785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1029788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029795 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1029795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1029798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1029802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1029808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1029819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029820 */     // GIR_Coverage, 2582,
     /* 1029820 */     GIR_EraseRootFromParent_Done,
     /* 1029821 */   // Label 15300: @1029821
     /* 1029821 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1029901), // Rule ID 2583 //
     /* 1029826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1029834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1029837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1029840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1029843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1029846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1029849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029865 */     // MIs[0] round
     /* 1029865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1029868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029875 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1029875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1029878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1029882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1029888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1029899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029900 */     // GIR_Coverage, 2583,
     /* 1029900 */     GIR_EraseRootFromParent_Done,
     /* 1029901 */   // Label 15301: @1029901
     /* 1029901 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1029981), // Rule ID 2622 //
     /* 1029906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1029909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1029914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1029923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1029929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029945 */     // MIs[0] round
     /* 1029945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1029948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029955 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1029955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1029958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1029962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1029968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1029979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029980 */     // GIR_Coverage, 2622,
     /* 1029980 */     GIR_EraseRootFromParent_Done,
     /* 1029981 */   // Label 15302: @1029981
     /* 1029981 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1030061), // Rule ID 2623 //
     /* 1029986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1029989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1029994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1030000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1030003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1030006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030025 */     // MIs[0] round
     /* 1030025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030035 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1030038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030060 */     // GIR_Coverage, 2623,
     /* 1030060 */     GIR_EraseRootFromParent_Done,
     /* 1030061 */   // Label 15303: @1030061
     /* 1030061 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1030141), // Rule ID 2642 //
     /* 1030066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1030069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1030074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1030077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1030080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1030083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1030086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030105 */     // MIs[0] round
     /* 1030105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1030118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030140 */     // GIR_Coverage, 2642,
     /* 1030140 */     GIR_EraseRootFromParent_Done,
     /* 1030141 */   // Label 15304: @1030141
     /* 1030141 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1030221), // Rule ID 2643 //
     /* 1030146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1030149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1030154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1030157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1030160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1030163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1030166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030185 */     // MIs[0] round
     /* 1030185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030195 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1030198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030220 */     // GIR_Coverage, 2643,
     /* 1030220 */     GIR_EraseRootFromParent_Done,
     /* 1030221 */   // Label 15305: @1030221
     /* 1030221 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1030301), // Rule ID 14784 //
     /* 1030226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1030237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1030240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1030243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1030246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030265 */     // MIs[0] round
     /* 1030265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030275 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1030278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030300 */     // GIR_Coverage, 14784,
     /* 1030300 */     GIR_EraseRootFromParent_Done,
     /* 1030301 */   // Label 15306: @1030301
     /* 1030301 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1030381), // Rule ID 14785 //
     /* 1030306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1030317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1030320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1030323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1030326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030345 */     // MIs[0] round
     /* 1030345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030355 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1030358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030380 */     // GIR_Coverage, 14785,
     /* 1030380 */     GIR_EraseRootFromParent_Done,
     /* 1030381 */   // Label 15307: @1030381
     /* 1030381 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1030461), // Rule ID 14788 //
     /* 1030386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1030397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1030400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1030403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1030406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030425 */     // MIs[0] round
     /* 1030425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030435 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030460 */     // GIR_Coverage, 14788,
     /* 1030460 */     GIR_EraseRootFromParent_Done,
     /* 1030461 */   // Label 15308: @1030461
     /* 1030461 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1030541), // Rule ID 14789 //
     /* 1030466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1030477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1030480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1030483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1030486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030505 */     // MIs[0] round
     /* 1030505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030515 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030540 */     // GIR_Coverage, 14789,
     /* 1030540 */     GIR_EraseRootFromParent_Done,
     /* 1030541 */   // Label 15309: @1030541
     /* 1030541 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1030621), // Rule ID 14792 //
     /* 1030546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1030557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1030560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1030563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1030566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030585 */     // MIs[0] round
     /* 1030585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030595 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1030598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030620 */     // GIR_Coverage, 14792,
     /* 1030620 */     GIR_EraseRootFromParent_Done,
     /* 1030621 */   // Label 15310: @1030621
     /* 1030621 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1030701), // Rule ID 14793 //
     /* 1030626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1030637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1030640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1030643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1030646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030665 */     // MIs[0] round
     /* 1030665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030675 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1030678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030700 */     // GIR_Coverage, 14793,
     /* 1030700 */     GIR_EraseRootFromParent_Done,
     /* 1030701 */   // Label 15311: @1030701
     /* 1030701 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1030781), // Rule ID 14796 //
     /* 1030706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1030717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1030720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1030723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1030726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030745 */     // MIs[0] round
     /* 1030745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030755 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030780 */     // GIR_Coverage, 14796,
     /* 1030780 */     GIR_EraseRootFromParent_Done,
     /* 1030781 */   // Label 15312: @1030781
     /* 1030781 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1030861), // Rule ID 14797 //
     /* 1030786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1030797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1030800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1030803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1030806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030825 */     // MIs[0] round
     /* 1030825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030860 */     // GIR_Coverage, 14797,
     /* 1030860 */     GIR_EraseRootFromParent_Done,
     /* 1030861 */   // Label 15313: @1030861
     /* 1030861 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1030941), // Rule ID 14800 //
     /* 1030866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1030877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1030880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1030883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1030886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1030889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030905 */     // MIs[0] round
     /* 1030905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1030915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1030922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1030928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1030939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030940 */     // GIR_Coverage, 14800,
     /* 1030940 */     GIR_EraseRootFromParent_Done,
     /* 1030941 */   // Label 15314: @1030941
     /* 1030941 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1031021), // Rule ID 14801 //
     /* 1030946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1030954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1030957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1030960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1030963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1030966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1030969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030985 */     // MIs[0] round
     /* 1030985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1030988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1030995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1030998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031020 */     // GIR_Coverage, 14801,
     /* 1031020 */     GIR_EraseRootFromParent_Done,
     /* 1031021 */   // Label 15315: @1031021
     /* 1031021 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1031101), // Rule ID 14804 //
     /* 1031026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1031037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1031040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1031043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1031046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031065 */     // MIs[0] round
     /* 1031065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031075 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031100 */     // GIR_Coverage, 14804,
     /* 1031100 */     GIR_EraseRootFromParent_Done,
     /* 1031101 */   // Label 15316: @1031101
     /* 1031101 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1031181), // Rule ID 14805 //
     /* 1031106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1031117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1031120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1031123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1031126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031145 */     // MIs[0] round
     /* 1031145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031155 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031180 */     // GIR_Coverage, 14805,
     /* 1031180 */     GIR_EraseRootFromParent_Done,
     /* 1031181 */   // Label 15317: @1031181
     /* 1031181 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1031261), // Rule ID 14808 //
     /* 1031186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1031197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1031200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1031203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1031206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031225 */     // MIs[0] round
     /* 1031225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031235 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031260 */     // GIR_Coverage, 14808,
     /* 1031260 */     GIR_EraseRootFromParent_Done,
     /* 1031261 */   // Label 15318: @1031261
     /* 1031261 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1031341), // Rule ID 14809 //
     /* 1031266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1031277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1031280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1031283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1031286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031305 */     // MIs[0] round
     /* 1031305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031340 */     // GIR_Coverage, 14809,
     /* 1031340 */     GIR_EraseRootFromParent_Done,
     /* 1031341 */   // Label 15319: @1031341
     /* 1031341 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1031421), // Rule ID 14812 //
     /* 1031346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1031357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1031360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1031363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1031366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031385 */     // MIs[0] round
     /* 1031385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031420 */     // GIR_Coverage, 14812,
     /* 1031420 */     GIR_EraseRootFromParent_Done,
     /* 1031421 */   // Label 15320: @1031421
     /* 1031421 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1031501), // Rule ID 14813 //
     /* 1031426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1031437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1031440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1031443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1031446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031465 */     // MIs[0] round
     /* 1031465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031500 */     // GIR_Coverage, 14813,
     /* 1031500 */     GIR_EraseRootFromParent_Done,
     /* 1031501 */   // Label 15321: @1031501
     /* 1031501 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1031581), // Rule ID 14816 //
     /* 1031506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1031517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1031520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1031523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1031526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031545 */     // MIs[0] round
     /* 1031545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031555 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031580 */     // GIR_Coverage, 14816,
     /* 1031580 */     GIR_EraseRootFromParent_Done,
     /* 1031581 */   // Label 15322: @1031581
     /* 1031581 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1031661), // Rule ID 14817 //
     /* 1031586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1031597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1031600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1031603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1031606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031625 */     // MIs[0] round
     /* 1031625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031635 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1031638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031660 */     // GIR_Coverage, 14817,
     /* 1031660 */     GIR_EraseRootFromParent_Done,
     /* 1031661 */   // Label 15323: @1031661
     /* 1031661 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1031741), // Rule ID 14820 //
     /* 1031666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1031677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1031680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1031683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1031686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031705 */     // MIs[0] round
     /* 1031705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1031718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031740 */     // GIR_Coverage, 14820,
     /* 1031740 */     GIR_EraseRootFromParent_Done,
     /* 1031741 */   // Label 15324: @1031741
     /* 1031741 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1031821), // Rule ID 14821 //
     /* 1031746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1031757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1031760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1031763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1031766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031785 */     // MIs[0] round
     /* 1031785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1031798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031820 */     // GIR_Coverage, 14821,
     /* 1031820 */     GIR_EraseRootFromParent_Done,
     /* 1031821 */   // Label 15325: @1031821
     /* 1031821 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1031901), // Rule ID 14824 //
     /* 1031826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1031837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1031840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1031843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1031846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1031849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031865 */     // MIs[0] round
     /* 1031865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031875 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1031875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1031878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031900 */     // GIR_Coverage, 14824,
     /* 1031900 */     GIR_EraseRootFromParent_Done,
     /* 1031901 */   // Label 15326: @1031901
     /* 1031901 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1031981), // Rule ID 14825 //
     /* 1031906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1031917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1031920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1031923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1031926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1031929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031945 */     // MIs[0] round
     /* 1031945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1031948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1031955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1031958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1031962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1031968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1031979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031980 */     // GIR_Coverage, 14825,
     /* 1031980 */     GIR_EraseRootFromParent_Done,
     /* 1031981 */   // Label 15327: @1031981
     /* 1031981 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1032061), // Rule ID 14828 //
     /* 1031986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1031994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1031997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1032000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1032003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1032006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032025 */     // MIs[0] round
     /* 1032025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032035 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1032038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032060 */     // GIR_Coverage, 14828,
     /* 1032060 */     GIR_EraseRootFromParent_Done,
     /* 1032061 */   // Label 15328: @1032061
     /* 1032061 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1032141), // Rule ID 14829 //
     /* 1032066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1032077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1032080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1032083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1032086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032105 */     // MIs[0] round
     /* 1032105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032115 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1032118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032140 */     // GIR_Coverage, 14829,
     /* 1032140 */     GIR_EraseRootFromParent_Done,
     /* 1032141 */   // Label 15329: @1032141
     /* 1032141 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1032221), // Rule ID 14832 //
     /* 1032146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1032163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1032166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032185 */     // MIs[0] round
     /* 1032185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1032198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032220 */     // GIR_Coverage, 14832,
     /* 1032220 */     GIR_EraseRootFromParent_Done,
     /* 1032221 */   // Label 15330: @1032221
     /* 1032221 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1032301), // Rule ID 14833 //
     /* 1032226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1032243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1032246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032265 */     // MIs[0] round
     /* 1032265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1032278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032300 */     // GIR_Coverage, 14833,
     /* 1032300 */     GIR_EraseRootFromParent_Done,
     /* 1032301 */   // Label 15331: @1032301
     /* 1032301 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1032381), // Rule ID 14836 //
     /* 1032306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1032323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1032326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032345 */     // MIs[0] round
     /* 1032345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032355 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1032358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032380 */     // GIR_Coverage, 14836,
     /* 1032380 */     GIR_EraseRootFromParent_Done,
     /* 1032381 */   // Label 15332: @1032381
     /* 1032381 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1032461), // Rule ID 14837 //
     /* 1032386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1032403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1032406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032425 */     // MIs[0] round
     /* 1032425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1032438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032460 */     // GIR_Coverage, 14837,
     /* 1032460 */     GIR_EraseRootFromParent_Done,
     /* 1032461 */   // Label 15333: @1032461
     /* 1032461 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1032541), // Rule ID 14840 //
     /* 1032466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1032483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1032486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032505 */     // MIs[0] round
     /* 1032505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032515 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1032518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032540 */     // GIR_Coverage, 14840,
     /* 1032540 */     GIR_EraseRootFromParent_Done,
     /* 1032541 */   // Label 15334: @1032541
     /* 1032541 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1032621), // Rule ID 14841 //
     /* 1032546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1032563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1032566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032585 */     // MIs[0] round
     /* 1032585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1032598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032620 */     // GIR_Coverage, 14841,
     /* 1032620 */     GIR_EraseRootFromParent_Done,
     /* 1032621 */   // Label 15335: @1032621
     /* 1032621 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1032701), // Rule ID 14844 //
     /* 1032626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1032643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1032646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032665 */     // MIs[0] round
     /* 1032665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1032678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1032696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032700 */     // GIR_Coverage, 14844,
     /* 1032700 */     GIR_EraseRootFromParent_Done,
     /* 1032701 */   // Label 15336: @1032701
     /* 1032701 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1032781), // Rule ID 14845 //
     /* 1032706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1032723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1032726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032745 */     // MIs[0] round
     /* 1032745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032755 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1032758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1032776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032780 */     // GIR_Coverage, 14845,
     /* 1032780 */     GIR_EraseRootFromParent_Done,
     /* 1032781 */   // Label 15337: @1032781
     /* 1032781 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1032861), // Rule ID 14848 //
     /* 1032786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1032797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1032800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1032803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1032806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032825 */     // MIs[0] round
     /* 1032825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032835 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1032838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1032856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032860 */     // GIR_Coverage, 14848,
     /* 1032860 */     GIR_EraseRootFromParent_Done,
     /* 1032861 */   // Label 15338: @1032861
     /* 1032861 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1032941), // Rule ID 14849 //
     /* 1032866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1032877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1032880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1032883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1032886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1032889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032905 */     // MIs[0] round
     /* 1032905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1032915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1032918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1032922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1032928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1032936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1032939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032940 */     // GIR_Coverage, 14849,
     /* 1032940 */     GIR_EraseRootFromParent_Done,
     /* 1032941 */   // Label 15339: @1032941
     /* 1032941 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1033021), // Rule ID 14852 //
     /* 1032946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1032954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1032957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1032960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1032963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1032966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1032969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032985 */     // MIs[0] round
     /* 1032985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1032988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032995 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1032995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1032998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033020 */     // GIR_Coverage, 14852,
     /* 1033020 */     GIR_EraseRootFromParent_Done,
     /* 1033021 */   // Label 15340: @1033021
     /* 1033021 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1033101), // Rule ID 14853 //
     /* 1033026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1033043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1033046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033065 */     // MIs[0] round
     /* 1033065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1033078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033100 */     // GIR_Coverage, 14853,
     /* 1033100 */     GIR_EraseRootFromParent_Done,
     /* 1033101 */   // Label 15341: @1033101
     /* 1033101 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1033181), // Rule ID 14856 //
     /* 1033106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1033109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1033123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1033126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033145 */     // MIs[0] round
     /* 1033145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1033158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033180 */     // GIR_Coverage, 14856,
     /* 1033180 */     GIR_EraseRootFromParent_Done,
     /* 1033181 */   // Label 15342: @1033181
     /* 1033181 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1033261), // Rule ID 14857 //
     /* 1033186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1033189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1033203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1033206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033225 */     // MIs[0] round
     /* 1033225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1033238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033260 */     // GIR_Coverage, 14857,
     /* 1033260 */     GIR_EraseRootFromParent_Done,
     /* 1033261 */   // Label 15343: @1033261
     /* 1033261 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1033341), // Rule ID 14860 //
     /* 1033266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1033269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1033283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1033286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033305 */     // MIs[0] round
     /* 1033305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033315 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1033318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033340 */     // GIR_Coverage, 14860,
     /* 1033340 */     GIR_EraseRootFromParent_Done,
     /* 1033341 */   // Label 15344: @1033341
     /* 1033341 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1033421), // Rule ID 14861 //
     /* 1033346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1033349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1033363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1033366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033385 */     // MIs[0] round
     /* 1033385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033395 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1033398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033420 */     // GIR_Coverage, 14861,
     /* 1033420 */     GIR_EraseRootFromParent_Done,
     /* 1033421 */   // Label 15345: @1033421
     /* 1033421 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1033501), // Rule ID 14864 //
     /* 1033426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1033429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1033443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1033446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033465 */     // MIs[0] round
     /* 1033465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033475 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1033478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033500 */     // GIR_Coverage, 14864,
     /* 1033500 */     GIR_EraseRootFromParent_Done,
     /* 1033501 */   // Label 15346: @1033501
     /* 1033501 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1033581), // Rule ID 14865 //
     /* 1033506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1033509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1033523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1033526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033545 */     // MIs[0] round
     /* 1033545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1033558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033580 */     // GIR_Coverage, 14865,
     /* 1033580 */     GIR_EraseRootFromParent_Done,
     /* 1033581 */   // Label 15347: @1033581
     /* 1033581 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1033661), // Rule ID 14868 //
     /* 1033586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1033597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1033600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1033603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1033606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033625 */     // MIs[0] round
     /* 1033625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033635 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1033638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033660 */     // GIR_Coverage, 14868,
     /* 1033660 */     GIR_EraseRootFromParent_Done,
     /* 1033661 */   // Label 15348: @1033661
     /* 1033661 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1033741), // Rule ID 14869 //
     /* 1033666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1033677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1033680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1033683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1033686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033705 */     // MIs[0] round
     /* 1033705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033715 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1033718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033740 */     // GIR_Coverage, 14869,
     /* 1033740 */     GIR_EraseRootFromParent_Done,
     /* 1033741 */   // Label 15349: @1033741
     /* 1033741 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1033821), // Rule ID 14872 //
     /* 1033746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1033757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1033760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1033763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1033766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033785 */     // MIs[0] round
     /* 1033785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033795 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1033798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033820 */     // GIR_Coverage, 14872,
     /* 1033820 */     GIR_EraseRootFromParent_Done,
     /* 1033821 */   // Label 15350: @1033821
     /* 1033821 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1033901), // Rule ID 14873 //
     /* 1033826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1033837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1033840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1033843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1033846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1033849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033865 */     // MIs[0] round
     /* 1033865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033875 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1033875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1033878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033900 */     // GIR_Coverage, 14873,
     /* 1033900 */     GIR_EraseRootFromParent_Done,
     /* 1033901 */   // Label 15351: @1033901
     /* 1033901 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1033981), // Rule ID 14876 //
     /* 1033906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1033917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1033920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1033923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1033926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1033929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033945 */     // MIs[0] round
     /* 1033945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1033948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033955 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1033955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1033958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1033962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1033968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1033979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033980 */     // GIR_Coverage, 14876,
     /* 1033980 */     GIR_EraseRootFromParent_Done,
     /* 1033981 */   // Label 15352: @1033981
     /* 1033981 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1034061), // Rule ID 14877 //
     /* 1033986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1033994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1033997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1034000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1034003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034025 */     // MIs[0] round
     /* 1034025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034035 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1034038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034060 */     // GIR_Coverage, 14877,
     /* 1034060 */     GIR_EraseRootFromParent_Done,
     /* 1034061 */   // Label 15353: @1034061
     /* 1034061 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1034141), // Rule ID 14880 //
     /* 1034066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1034083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034105 */     // MIs[0] round
     /* 1034105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034115 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1034118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034140 */     // GIR_Coverage, 14880,
     /* 1034140 */     GIR_EraseRootFromParent_Done,
     /* 1034141 */   // Label 15354: @1034141
     /* 1034141 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1034221), // Rule ID 14881 //
     /* 1034146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1034163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034185 */     // MIs[0] round
     /* 1034185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1034198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034220 */     // GIR_Coverage, 14881,
     /* 1034220 */     GIR_EraseRootFromParent_Done,
     /* 1034221 */   // Label 15355: @1034221
     /* 1034221 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1034301), // Rule ID 14884 //
     /* 1034226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1034243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034265 */     // MIs[0] round
     /* 1034265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034275 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1034278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034300 */     // GIR_Coverage, 14884,
     /* 1034300 */     GIR_EraseRootFromParent_Done,
     /* 1034301 */   // Label 15356: @1034301
     /* 1034301 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1034381), // Rule ID 14885 //
     /* 1034306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1034323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034345 */     // MIs[0] round
     /* 1034345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034355 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1034358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034380 */     // GIR_Coverage, 14885,
     /* 1034380 */     GIR_EraseRootFromParent_Done,
     /* 1034381 */   // Label 15357: @1034381
     /* 1034381 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1034461), // Rule ID 14888 //
     /* 1034386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1034403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034425 */     // MIs[0] round
     /* 1034425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034435 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1034438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034460 */     // GIR_Coverage, 14888,
     /* 1034460 */     GIR_EraseRootFromParent_Done,
     /* 1034461 */   // Label 15358: @1034461
     /* 1034461 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1034541), // Rule ID 14889 //
     /* 1034466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1034483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034505 */     // MIs[0] round
     /* 1034505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034515 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1034518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034540 */     // GIR_Coverage, 14889,
     /* 1034540 */     GIR_EraseRootFromParent_Done,
     /* 1034541 */   // Label 15359: @1034541
     /* 1034541 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1034621), // Rule ID 14892 //
     /* 1034546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1034557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1034560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1034563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034585 */     // MIs[0] round
     /* 1034585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034620 */     // GIR_Coverage, 14892,
     /* 1034620 */     GIR_EraseRootFromParent_Done,
     /* 1034621 */   // Label 15360: @1034621
     /* 1034621 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1034701), // Rule ID 14893 //
     /* 1034626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1034637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1034640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1034643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034665 */     // MIs[0] round
     /* 1034665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10831:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034700 */     // GIR_Coverage, 14893,
     /* 1034700 */     GIR_EraseRootFromParent_Done,
     /* 1034701 */   // Label 15361: @1034701
     /* 1034701 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1034781), // Rule ID 14896 //
     /* 1034706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1034723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034745 */     // MIs[0] round
     /* 1034745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034780 */     // GIR_Coverage, 14896,
     /* 1034780 */     GIR_EraseRootFromParent_Done,
     /* 1034781 */   // Label 15362: @1034781
     /* 1034781 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1034861), // Rule ID 14897 //
     /* 1034786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1034803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034825 */     // MIs[0] round
     /* 1034825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034860 */     // GIR_Coverage, 14897,
     /* 1034860 */     GIR_EraseRootFromParent_Done,
     /* 1034861 */   // Label 15363: @1034861
     /* 1034861 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1034941), // Rule ID 14900 //
     /* 1034866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1034877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1034880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1034886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1034889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034905 */     // MIs[0] round
     /* 1034905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1034915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1034922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1034928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1034939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034940 */     // GIR_Coverage, 14900,
     /* 1034940 */     GIR_EraseRootFromParent_Done,
     /* 1034941 */   // Label 15364: @1034941
     /* 1034941 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1035021), // Rule ID 14901 //
     /* 1034946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1034954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1034957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1034960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1034966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1034969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034985 */     // MIs[0] round
     /* 1034985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1034988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1034995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1034998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035020 */     // GIR_Coverage, 14901,
     /* 1035020 */     GIR_EraseRootFromParent_Done,
     /* 1035021 */   // Label 15365: @1035021
     /* 1035021 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1035101), // Rule ID 14904 //
     /* 1035026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1035043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035065 */     // MIs[0] round
     /* 1035065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1035078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035100 */     // GIR_Coverage, 14904,
     /* 1035100 */     GIR_EraseRootFromParent_Done,
     /* 1035101 */   // Label 15366: @1035101
     /* 1035101 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1035181), // Rule ID 14905 //
     /* 1035106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1035123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035145 */     // MIs[0] round
     /* 1035145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1035158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035180 */     // GIR_Coverage, 14905,
     /* 1035180 */     GIR_EraseRootFromParent_Done,
     /* 1035181 */   // Label 15367: @1035181
     /* 1035181 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1035261), // Rule ID 14908 //
     /* 1035186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1035197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1035200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1035203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035225 */     // MIs[0] round
     /* 1035225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1035238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035260 */     // GIR_Coverage, 14908,
     /* 1035260 */     GIR_EraseRootFromParent_Done,
     /* 1035261 */   // Label 15368: @1035261
     /* 1035261 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1035341), // Rule ID 14909 //
     /* 1035266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1035277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1035280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1035283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035305 */     // MIs[0] round
     /* 1035305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1035318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035340 */     // GIR_Coverage, 14909,
     /* 1035340 */     GIR_EraseRootFromParent_Done,
     /* 1035341 */   // Label 15369: @1035341
     /* 1035341 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1035421), // Rule ID 14912 //
     /* 1035346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1035357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1035360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1035363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035385 */     // MIs[0] round
     /* 1035385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035395 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1035398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035420 */     // GIR_Coverage, 14912,
     /* 1035420 */     GIR_EraseRootFromParent_Done,
     /* 1035421 */   // Label 15370: @1035421
     /* 1035421 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1035501), // Rule ID 14913 //
     /* 1035426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1035437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1035440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1035443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035465 */     // MIs[0] round
     /* 1035465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035475 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1035478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035500 */     // GIR_Coverage, 14913,
     /* 1035500 */     GIR_EraseRootFromParent_Done,
     /* 1035501 */   // Label 15371: @1035501
     /* 1035501 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1035581), // Rule ID 14916 //
     /* 1035506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1035517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1035520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1035523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035545 */     // MIs[0] round
     /* 1035545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035555 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1035558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035580 */     // GIR_Coverage, 14916,
     /* 1035580 */     GIR_EraseRootFromParent_Done,
     /* 1035581 */   // Label 15372: @1035581
     /* 1035581 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1035661), // Rule ID 14917 //
     /* 1035586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1035597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1035600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1035603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035625 */     // MIs[0] round
     /* 1035625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1035638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035660 */     // GIR_Coverage, 14917,
     /* 1035660 */     GIR_EraseRootFromParent_Done,
     /* 1035661 */   // Label 15373: @1035661
     /* 1035661 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1035741), // Rule ID 14920 //
     /* 1035666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1035677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1035680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1035683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035705 */     // MIs[0] round
     /* 1035705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1035718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035740 */     // GIR_Coverage, 14920,
     /* 1035740 */     GIR_EraseRootFromParent_Done,
     /* 1035741 */   // Label 15374: @1035741
     /* 1035741 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1035821), // Rule ID 14921 //
     /* 1035746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1035757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1035760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1035763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035785 */     // MIs[0] round
     /* 1035785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1035798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035820 */     // GIR_Coverage, 14921,
     /* 1035820 */     GIR_EraseRootFromParent_Done,
     /* 1035821 */   // Label 15375: @1035821
     /* 1035821 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1035901), // Rule ID 14924 //
     /* 1035826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1035843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1035846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1035849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035865 */     // MIs[0] round
     /* 1035865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035875 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1035875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1035878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035900 */     // GIR_Coverage, 14924,
     /* 1035900 */     GIR_EraseRootFromParent_Done,
     /* 1035901 */   // Label 15376: @1035901
     /* 1035901 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1035981), // Rule ID 14925 //
     /* 1035906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1035923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1035926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1035929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035945 */     // MIs[0] round
     /* 1035945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1035948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035955 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1035955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1035958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1035962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1035968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1035979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035980 */     // GIR_Coverage, 14925,
     /* 1035980 */     GIR_EraseRootFromParent_Done,
     /* 1035981 */   // Label 15377: @1035981
     /* 1035981 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1036061), // Rule ID 14928 //
     /* 1035986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1035994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1035997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1036003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036025 */     // MIs[0] round
     /* 1036025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036035 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1036038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036060 */     // GIR_Coverage, 14928,
     /* 1036060 */     GIR_EraseRootFromParent_Done,
     /* 1036061 */   // Label 15378: @1036061
     /* 1036061 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1036141), // Rule ID 14929 //
     /* 1036066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1036083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036105 */     // MIs[0] round
     /* 1036105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036115 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1036118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036140 */     // GIR_Coverage, 14929,
     /* 1036140 */     GIR_EraseRootFromParent_Done,
     /* 1036141 */   // Label 15379: @1036141
     /* 1036141 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1036221), // Rule ID 14932 //
     /* 1036146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1036163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036185 */     // MIs[0] round
     /* 1036185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1036198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036220 */     // GIR_Coverage, 14932,
     /* 1036220 */     GIR_EraseRootFromParent_Done,
     /* 1036221 */   // Label 15380: @1036221
     /* 1036221 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1036301), // Rule ID 14933 //
     /* 1036226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1036243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036265 */     // MIs[0] round
     /* 1036265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1036278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036300 */     // GIR_Coverage, 14933,
     /* 1036300 */     GIR_EraseRootFromParent_Done,
     /* 1036301 */   // Label 15381: @1036301
     /* 1036301 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1036381), // Rule ID 14936 //
     /* 1036306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1036317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1036320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1036323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036345 */     // MIs[0] round
     /* 1036345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036355 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1036358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036380 */     // GIR_Coverage, 14936,
     /* 1036380 */     GIR_EraseRootFromParent_Done,
     /* 1036381 */   // Label 15382: @1036381
     /* 1036381 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1036461), // Rule ID 14937 //
     /* 1036386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1036397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1036400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1036403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036425 */     // MIs[0] round
     /* 1036425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036435 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1036438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036460 */     // GIR_Coverage, 14937,
     /* 1036460 */     GIR_EraseRootFromParent_Done,
     /* 1036461 */   // Label 15383: @1036461
     /* 1036461 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1036541), // Rule ID 14940 //
     /* 1036466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1036483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036505 */     // MIs[0] round
     /* 1036505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1036518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036540 */     // GIR_Coverage, 14940,
     /* 1036540 */     GIR_EraseRootFromParent_Done,
     /* 1036541 */   // Label 15384: @1036541
     /* 1036541 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1036621), // Rule ID 14941 //
     /* 1036546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1036563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036585 */     // MIs[0] round
     /* 1036585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1036598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036620 */     // GIR_Coverage, 14941,
     /* 1036620 */     GIR_EraseRootFromParent_Done,
     /* 1036621 */   // Label 15385: @1036621
     /* 1036621 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1036701), // Rule ID 14944 //
     /* 1036626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1036629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1036643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036665 */     // MIs[0] round
     /* 1036665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1036678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1036696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036700 */     // GIR_Coverage, 14944,
     /* 1036700 */     GIR_EraseRootFromParent_Done,
     /* 1036701 */   // Label 15386: @1036701
     /* 1036701 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1036781), // Rule ID 14945 //
     /* 1036706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1036709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1036723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036745 */     // MIs[0] round
     /* 1036745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1036758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1036776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036780 */     // GIR_Coverage, 14945,
     /* 1036780 */     GIR_EraseRootFromParent_Done,
     /* 1036781 */   // Label 15387: @1036781
     /* 1036781 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1036861), // Rule ID 14948 //
     /* 1036786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1036789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1036803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036825 */     // MIs[0] round
     /* 1036825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036835 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1036838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1036856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036860 */     // GIR_Coverage, 14948,
     /* 1036860 */     GIR_EraseRootFromParent_Done,
     /* 1036861 */   // Label 15388: @1036861
     /* 1036861 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1036941), // Rule ID 14949 //
     /* 1036866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1036869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1036883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1036886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1036889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036905 */     // MIs[0] round
     /* 1036905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036915 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1036915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1036918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1036922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1036928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1036936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1036939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036940 */     // GIR_Coverage, 14949,
     /* 1036940 */     GIR_EraseRootFromParent_Done,
     /* 1036941 */   // Label 15389: @1036941
     /* 1036941 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1037021), // Rule ID 14952 //
     /* 1036946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1036949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1036954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1036963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1036966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1036969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036985 */     // MIs[0] round
     /* 1036985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1036988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1036995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1036998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1037016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037020 */     // GIR_Coverage, 14952,
     /* 1037020 */     GIR_EraseRootFromParent_Done,
     /* 1037021 */   // Label 15390: @1037021
     /* 1037021 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1037101), // Rule ID 14953 //
     /* 1037026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1037029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1037034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1037037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1037040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1037043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1037046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1037065 */     // MIs[0] round
     /* 1037065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037075 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10831:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1037078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1037096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037100 */     // GIR_Coverage, 14953,
     /* 1037100 */     GIR_EraseRootFromParent_Done,
     /* 1037101 */   // Label 15391: @1037101
     /* 1037101 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1037181), // Rule ID 14956 //
     /* 1037106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1037117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1037120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1037123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037145 */     // MIs[0] round
     /* 1037145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037155 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1037158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037180 */     // GIR_Coverage, 14956,
     /* 1037180 */     GIR_EraseRootFromParent_Done,
     /* 1037181 */   // Label 15392: @1037181
     /* 1037181 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1037261), // Rule ID 14957 //
     /* 1037186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1037197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1037200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1037203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037225 */     // MIs[0] round
     /* 1037225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1037238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037260 */     // GIR_Coverage, 14957,
     /* 1037260 */     GIR_EraseRootFromParent_Done,
     /* 1037261 */   // Label 15393: @1037261
     /* 1037261 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1037341), // Rule ID 14960 //
     /* 1037266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1037277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1037280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1037283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1037286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037305 */     // MIs[0] round
     /* 1037305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1037318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037340 */     // GIR_Coverage, 14960,
     /* 1037340 */     GIR_EraseRootFromParent_Done,
     /* 1037341 */   // Label 15394: @1037341
     /* 1037341 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1037421), // Rule ID 14961 //
     /* 1037346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1037357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1037360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1037363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1037366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037385 */     // MIs[0] round
     /* 1037385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1037398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037420 */     // GIR_Coverage, 14961,
     /* 1037420 */     GIR_EraseRootFromParent_Done,
     /* 1037421 */   // Label 15395: @1037421
     /* 1037421 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1037501), // Rule ID 14964 //
     /* 1037426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1037437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1037440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037465 */     // MIs[0] round
     /* 1037465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037475 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1037478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037500 */     // GIR_Coverage, 14964,
     /* 1037500 */     GIR_EraseRootFromParent_Done,
     /* 1037501 */   // Label 15396: @1037501
     /* 1037501 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1037581), // Rule ID 14965 //
     /* 1037506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1037517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1037520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037545 */     // MIs[0] round
     /* 1037545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037555 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1037558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037580 */     // GIR_Coverage, 14965,
     /* 1037580 */     GIR_EraseRootFromParent_Done,
     /* 1037581 */   // Label 15397: @1037581
     /* 1037581 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1037661), // Rule ID 14968 //
     /* 1037586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037625 */     // MIs[0] round
     /* 1037625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037635 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1037638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037660 */     // GIR_Coverage, 14968,
     /* 1037660 */     GIR_EraseRootFromParent_Done,
     /* 1037661 */   // Label 15398: @1037661
     /* 1037661 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1037741), // Rule ID 14969 //
     /* 1037666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037705 */     // MIs[0] round
     /* 1037705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037715 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1037718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037740 */     // GIR_Coverage, 14969,
     /* 1037740 */     GIR_EraseRootFromParent_Done,
     /* 1037741 */   // Label 15399: @1037741
     /* 1037741 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1037821), // Rule ID 14972 //
     /* 1037746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1037757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1037760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037785 */     // MIs[0] round
     /* 1037785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037795 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1037798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037820 */     // GIR_Coverage, 14972,
     /* 1037820 */     GIR_EraseRootFromParent_Done,
     /* 1037821 */   // Label 15400: @1037821
     /* 1037821 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1037901), // Rule ID 14973 //
     /* 1037826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1037837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1037840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1037849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037865 */     // MIs[0] round
     /* 1037865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1037875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1037878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037900 */     // GIR_Coverage, 14973,
     /* 1037900 */     GIR_EraseRootFromParent_Done,
     /* 1037901 */   // Label 15401: @1037901
     /* 1037901 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1037981), // Rule ID 14976 //
     /* 1037906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1037929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037945 */     // MIs[0] round
     /* 1037945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1037948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1037955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1037958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1037962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1037968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1037979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037980 */     // GIR_Coverage, 14976,
     /* 1037980 */     GIR_EraseRootFromParent_Done,
     /* 1037981 */   // Label 15402: @1037981
     /* 1037981 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1038061), // Rule ID 14977 //
     /* 1037986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1037994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1038000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038025 */     // MIs[0] round
     /* 1038025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038035 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1038038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038060 */     // GIR_Coverage, 14977,
     /* 1038060 */     GIR_EraseRootFromParent_Done,
     /* 1038061 */   // Label 15403: @1038061
     /* 1038061 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1038141), // Rule ID 14980 //
     /* 1038066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1038077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1038080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1038083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038105 */     // MIs[0] round
     /* 1038105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038115 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038140 */     // GIR_Coverage, 14980,
     /* 1038140 */     GIR_EraseRootFromParent_Done,
     /* 1038141 */   // Label 15404: @1038141
     /* 1038141 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1038221), // Rule ID 14981 //
     /* 1038146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1038157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1038160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1038163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038185 */     // MIs[0] round
     /* 1038185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038195 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038220 */     // GIR_Coverage, 14981,
     /* 1038220 */     GIR_EraseRootFromParent_Done,
     /* 1038221 */   // Label 15405: @1038221
     /* 1038221 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1038301), // Rule ID 14984 //
     /* 1038226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038265 */     // MIs[0] round
     /* 1038265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038300 */     // GIR_Coverage, 14984,
     /* 1038300 */     GIR_EraseRootFromParent_Done,
     /* 1038301 */   // Label 15406: @1038301
     /* 1038301 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1038381), // Rule ID 14985 //
     /* 1038306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038345 */     // MIs[0] round
     /* 1038345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038355 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038380 */     // GIR_Coverage, 14985,
     /* 1038380 */     GIR_EraseRootFromParent_Done,
     /* 1038381 */   // Label 15407: @1038381
     /* 1038381 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1038461), // Rule ID 14988 //
     /* 1038386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1038397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1038400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038425 */     // MIs[0] round
     /* 1038425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038460 */     // GIR_Coverage, 14988,
     /* 1038460 */     GIR_EraseRootFromParent_Done,
     /* 1038461 */   // Label 15408: @1038461
     /* 1038461 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1038541), // Rule ID 14989 //
     /* 1038466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1038477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1038480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038505 */     // MIs[0] round
     /* 1038505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038540 */     // GIR_Coverage, 14989,
     /* 1038540 */     GIR_EraseRootFromParent_Done,
     /* 1038541 */   // Label 15409: @1038541
     /* 1038541 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1038621), // Rule ID 14992 //
     /* 1038546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1038549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1038563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1038566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038585 */     // MIs[0] round
     /* 1038585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1038616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038620 */     // GIR_Coverage, 14992,
     /* 1038620 */     GIR_EraseRootFromParent_Done,
     /* 1038621 */   // Label 15410: @1038621
     /* 1038621 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1038701), // Rule ID 14993 //
     /* 1038626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1038629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1038643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1038646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038665 */     // MIs[0] round
     /* 1038665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1038678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1038696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038700 */     // GIR_Coverage, 14993,
     /* 1038700 */     GIR_EraseRootFromParent_Done,
     /* 1038701 */   // Label 15411: @1038701
     /* 1038701 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1038781), // Rule ID 14996 //
     /* 1038706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1038717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1038720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1038723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038745 */     // MIs[0] round
     /* 1038745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038755 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1038758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038780 */     // GIR_Coverage, 14996,
     /* 1038780 */     GIR_EraseRootFromParent_Done,
     /* 1038781 */   // Label 15412: @1038781
     /* 1038781 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1038861), // Rule ID 14997 //
     /* 1038786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1038797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1038800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1038803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038825 */     // MIs[0] round
     /* 1038825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1038838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038860 */     // GIR_Coverage, 14997,
     /* 1038860 */     GIR_EraseRootFromParent_Done,
     /* 1038861 */   // Label 15413: @1038861
     /* 1038861 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1038941), // Rule ID 15000 //
     /* 1038866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1038877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1038880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1038883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1038889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038905 */     // MIs[0] round
     /* 1038905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038915 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1038915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1038918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1038922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1038928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1038939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038940 */     // GIR_Coverage, 15000,
     /* 1038940 */     GIR_EraseRootFromParent_Done,
     /* 1038941 */   // Label 15414: @1038941
     /* 1038941 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1039021), // Rule ID 15001 //
     /* 1038946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1038954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1038957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1038960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1038963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1038969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038985 */     // MIs[0] round
     /* 1038985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1038988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038995 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1038995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1038998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039020 */     // GIR_Coverage, 15001,
     /* 1039020 */     GIR_EraseRootFromParent_Done,
     /* 1039021 */   // Label 15415: @1039021
     /* 1039021 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1039101), // Rule ID 15004 //
     /* 1039026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1039037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1039040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1039043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1039046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039065 */     // MIs[0] round
     /* 1039065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039075 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1039078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039100 */     // GIR_Coverage, 15004,
     /* 1039100 */     GIR_EraseRootFromParent_Done,
     /* 1039101 */   // Label 15416: @1039101
     /* 1039101 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1039181), // Rule ID 15005 //
     /* 1039106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1039117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1039120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1039123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1039126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039145 */     // MIs[0] round
     /* 1039145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039155 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1039158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039180 */     // GIR_Coverage, 15005,
     /* 1039180 */     GIR_EraseRootFromParent_Done,
     /* 1039181 */   // Label 15417: @1039181
     /* 1039181 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1039261), // Rule ID 15008 //
     /* 1039186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1039203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039225 */     // MIs[0] round
     /* 1039225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1039238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039260 */     // GIR_Coverage, 15008,
     /* 1039260 */     GIR_EraseRootFromParent_Done,
     /* 1039261 */   // Label 15418: @1039261
     /* 1039261 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1039341), // Rule ID 15009 //
     /* 1039266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1039283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039305 */     // MIs[0] round
     /* 1039305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1039318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039340 */     // GIR_Coverage, 15009,
     /* 1039340 */     GIR_EraseRootFromParent_Done,
     /* 1039341 */   // Label 15419: @1039341
     /* 1039341 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1039421), // Rule ID 15012 //
     /* 1039346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1039363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039385 */     // MIs[0] round
     /* 1039385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039395 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1039398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039420 */     // GIR_Coverage, 15012,
     /* 1039420 */     GIR_EraseRootFromParent_Done,
     /* 1039421 */   // Label 15420: @1039421
     /* 1039421 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1039501), // Rule ID 15013 //
     /* 1039426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1039443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039465 */     // MIs[0] round
     /* 1039465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1039478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039500 */     // GIR_Coverage, 15013,
     /* 1039500 */     GIR_EraseRootFromParent_Done,
     /* 1039501 */   // Label 15421: @1039501
     /* 1039501 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1039581), // Rule ID 15016 //
     /* 1039506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1039523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1039526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039545 */     // MIs[0] round
     /* 1039545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039555 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1039558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039580 */     // GIR_Coverage, 15016,
     /* 1039580 */     GIR_EraseRootFromParent_Done,
     /* 1039581 */   // Label 15422: @1039581
     /* 1039581 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1039661), // Rule ID 15017 //
     /* 1039586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1039603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1039606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039625 */     // MIs[0] round
     /* 1039625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039635 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1039638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039660 */     // GIR_Coverage, 15017,
     /* 1039660 */     GIR_EraseRootFromParent_Done,
     /* 1039661 */   // Label 15423: @1039661
     /* 1039661 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1039741), // Rule ID 15020 //
     /* 1039666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1039683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039705 */     // MIs[0] round
     /* 1039705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1039718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039740 */     // GIR_Coverage, 15020,
     /* 1039740 */     GIR_EraseRootFromParent_Done,
     /* 1039741 */   // Label 15424: @1039741
     /* 1039741 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1039821), // Rule ID 15021 //
     /* 1039746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1039763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039785 */     // MIs[0] round
     /* 1039785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1039798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039820 */     // GIR_Coverage, 15021,
     /* 1039820 */     GIR_EraseRootFromParent_Done,
     /* 1039821 */   // Label 15425: @1039821
     /* 1039821 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1039901), // Rule ID 15024 //
     /* 1039826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1039843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1039849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039865 */     // MIs[0] round
     /* 1039865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039875 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1039875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1039878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039900 */     // GIR_Coverage, 15024,
     /* 1039900 */     GIR_EraseRootFromParent_Done,
     /* 1039901 */   // Label 15426: @1039901
     /* 1039901 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1039981), // Rule ID 15025 //
     /* 1039906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1039923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1039929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039945 */     // MIs[0] round
     /* 1039945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1039948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1039955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1039958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1039962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1039968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1039979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039980 */     // GIR_Coverage, 15025,
     /* 1039980 */     GIR_EraseRootFromParent_Done,
     /* 1039981 */   // Label 15427: @1039981
     /* 1039981 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1040061), // Rule ID 15028 //
     /* 1039986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1039994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1040003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1040006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040025 */     // MIs[0] round
     /* 1040025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040035 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1040038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040060 */     // GIR_Coverage, 15028,
     /* 1040060 */     GIR_EraseRootFromParent_Done,
     /* 1040061 */   // Label 15428: @1040061
     /* 1040061 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1040141), // Rule ID 15029 //
     /* 1040066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1040083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1040086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040105 */     // MIs[0] round
     /* 1040105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1040118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040140 */     // GIR_Coverage, 15029,
     /* 1040140 */     GIR_EraseRootFromParent_Done,
     /* 1040141 */   // Label 15429: @1040141
     /* 1040141 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1040221), // Rule ID 15032 //
     /* 1040146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1040149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1040163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1040166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040185 */     // MIs[0] round
     /* 1040185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1040198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040220 */     // GIR_Coverage, 15032,
     /* 1040220 */     GIR_EraseRootFromParent_Done,
     /* 1040221 */   // Label 15430: @1040221
     /* 1040221 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1040301), // Rule ID 15033 //
     /* 1040226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1040229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1040243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1040246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040265 */     // MIs[0] round
     /* 1040265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1040278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040300 */     // GIR_Coverage, 15033,
     /* 1040300 */     GIR_EraseRootFromParent_Done,
     /* 1040301 */   // Label 15431: @1040301
     /* 1040301 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1040381), // Rule ID 15036 //
     /* 1040306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1040309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1040323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1040326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040345 */     // MIs[0] round
     /* 1040345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040355 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1040358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040380 */     // GIR_Coverage, 15036,
     /* 1040380 */     GIR_EraseRootFromParent_Done,
     /* 1040381 */   // Label 15432: @1040381
     /* 1040381 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1040461), // Rule ID 15037 //
     /* 1040386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1040389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1040403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1040406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040425 */     // MIs[0] round
     /* 1040425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040435 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1040438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040460 */     // GIR_Coverage, 15037,
     /* 1040460 */     GIR_EraseRootFromParent_Done,
     /* 1040461 */   // Label 15433: @1040461
     /* 1040461 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1040541), // Rule ID 15040 //
     /* 1040466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1040469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1040483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1040486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040505 */     // MIs[0] round
     /* 1040505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040515 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1040518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040540 */     // GIR_Coverage, 15040,
     /* 1040540 */     GIR_EraseRootFromParent_Done,
     /* 1040541 */   // Label 15434: @1040541
     /* 1040541 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1040621), // Rule ID 15041 //
     /* 1040546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1040549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1040563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1040566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040585 */     // MIs[0] round
     /* 1040585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040595 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1040598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1040616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040620 */     // GIR_Coverage, 15041,
     /* 1040620 */     GIR_EraseRootFromParent_Done,
     /* 1040621 */   // Label 15435: @1040621
     /* 1040621 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1040701), // Rule ID 15044 //
     /* 1040626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1040637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1040640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1040646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040665 */     // MIs[0] round
     /* 1040665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040675 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1040678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040700 */     // GIR_Coverage, 15044,
     /* 1040700 */     GIR_EraseRootFromParent_Done,
     /* 1040701 */   // Label 15436: @1040701
     /* 1040701 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1040781), // Rule ID 15045 //
     /* 1040706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1040717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1040720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1040726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040745 */     // MIs[0] round
     /* 1040745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040755 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1040758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040780 */     // GIR_Coverage, 15045,
     /* 1040780 */     GIR_EraseRootFromParent_Done,
     /* 1040781 */   // Label 15437: @1040781
     /* 1040781 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1040861), // Rule ID 15048 //
     /* 1040786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1040797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1040800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1040806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040825 */     // MIs[0] round
     /* 1040825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040835 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1040838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040860 */     // GIR_Coverage, 15048,
     /* 1040860 */     GIR_EraseRootFromParent_Done,
     /* 1040861 */   // Label 15438: @1040861
     /* 1040861 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1040941), // Rule ID 15049 //
     /* 1040866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1040877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1040880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1040886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1040889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040905 */     // MIs[0] round
     /* 1040905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040915 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1040915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1040918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1040922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1040928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1040939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040940 */     // GIR_Coverage, 15049,
     /* 1040940 */     GIR_EraseRootFromParent_Done,
     /* 1040941 */   // Label 15439: @1040941
     /* 1040941 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1041021), // Rule ID 15052 //
     /* 1040946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1040954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1040957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1040960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1040966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1040969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040985 */     // MIs[0] round
     /* 1040985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1040988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040995 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1040995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1040998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041020 */     // GIR_Coverage, 15052,
     /* 1041020 */     GIR_EraseRootFromParent_Done,
     /* 1041021 */   // Label 15440: @1041021
     /* 1041021 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1041101), // Rule ID 15053 //
     /* 1041026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1041037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1041040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041065 */     // MIs[0] round
     /* 1041065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041075 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1041078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041100 */     // GIR_Coverage, 15053,
     /* 1041100 */     GIR_EraseRootFromParent_Done,
     /* 1041101 */   // Label 15441: @1041101
     /* 1041101 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1041181), // Rule ID 15056 //
     /* 1041106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041145 */     // MIs[0] round
     /* 1041145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041155 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1041158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041180 */     // GIR_Coverage, 15056,
     /* 1041180 */     GIR_EraseRootFromParent_Done,
     /* 1041181 */   // Label 15442: @1041181
     /* 1041181 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1041261), // Rule ID 15057 //
     /* 1041186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041225 */     // MIs[0] round
     /* 1041225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041235 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1041238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041260 */     // GIR_Coverage, 15057,
     /* 1041260 */     GIR_EraseRootFromParent_Done,
     /* 1041261 */   // Label 15443: @1041261
     /* 1041261 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1041341), // Rule ID 15060 //
     /* 1041266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041305 */     // MIs[0] round
     /* 1041305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1041318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041340 */     // GIR_Coverage, 15060,
     /* 1041340 */     GIR_EraseRootFromParent_Done,
     /* 1041341 */   // Label 15444: @1041341
     /* 1041341 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1041421), // Rule ID 15061 //
     /* 1041346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041385 */     // MIs[0] round
     /* 1041385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041395 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1041398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041420 */     // GIR_Coverage, 15061,
     /* 1041420 */     GIR_EraseRootFromParent_Done,
     /* 1041421 */   // Label 15445: @1041421
     /* 1041421 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1041501), // Rule ID 15064 //
     /* 1041426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041465 */     // MIs[0] round
     /* 1041465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1041478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041500 */     // GIR_Coverage, 15064,
     /* 1041500 */     GIR_EraseRootFromParent_Done,
     /* 1041501 */   // Label 15446: @1041501
     /* 1041501 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1041581), // Rule ID 15065 //
     /* 1041506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041545 */     // MIs[0] round
     /* 1041545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041555 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1041558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041580 */     // GIR_Coverage, 15065,
     /* 1041580 */     GIR_EraseRootFromParent_Done,
     /* 1041581 */   // Label 15447: @1041581
     /* 1041581 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1041661), // Rule ID 15068 //
     /* 1041586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1041597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1041600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041625 */     // MIs[0] round
     /* 1041625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041635 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1041638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041660 */     // GIR_Coverage, 15068,
     /* 1041660 */     GIR_EraseRootFromParent_Done,
     /* 1041661 */   // Label 15448: @1041661
     /* 1041661 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1041741), // Rule ID 15069 //
     /* 1041666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1041677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1041680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041705 */     // MIs[0] round
     /* 1041705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041715 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10853:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1041718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041740 */     // GIR_Coverage, 15069,
     /* 1041740 */     GIR_EraseRootFromParent_Done,
     /* 1041741 */   // Label 15449: @1041741
     /* 1041741 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1041821), // Rule ID 15072 //
     /* 1041746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041785 */     // MIs[0] round
     /* 1041785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1041798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041820 */     // GIR_Coverage, 15072,
     /* 1041820 */     GIR_EraseRootFromParent_Done,
     /* 1041821 */   // Label 15450: @1041821
     /* 1041821 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1041901), // Rule ID 15073 //
     /* 1041826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1041846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1041849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041865 */     // MIs[0] round
     /* 1041865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1041875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1041878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041900 */     // GIR_Coverage, 15073,
     /* 1041900 */     GIR_EraseRootFromParent_Done,
     /* 1041901 */   // Label 15451: @1041901
     /* 1041901 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1041981), // Rule ID 15076 //
     /* 1041906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1041923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1041926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1041929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041945 */     // MIs[0] round
     /* 1041945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1041948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1041955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1041958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1041962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1041968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1041979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041980 */     // GIR_Coverage, 15076,
     /* 1041980 */     GIR_EraseRootFromParent_Done,
     /* 1041981 */   // Label 15452: @1041981
     /* 1041981 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1042061), // Rule ID 15077 //
     /* 1041986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1041994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042025 */     // MIs[0] round
     /* 1042025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1042038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042060 */     // GIR_Coverage, 15077,
     /* 1042060 */     GIR_EraseRootFromParent_Done,
     /* 1042061 */   // Label 15453: @1042061
     /* 1042061 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1042141), // Rule ID 15080 //
     /* 1042066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1042069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1042083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042105 */     // MIs[0] round
     /* 1042105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1042118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1042136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042140 */     // GIR_Coverage, 15080,
     /* 1042140 */     GIR_EraseRootFromParent_Done,
     /* 1042141 */   // Label 15454: @1042141
     /* 1042141 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1042221), // Rule ID 15081 //
     /* 1042146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1042149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1042163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042185 */     // MIs[0] round
     /* 1042185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1042198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1042216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042220 */     // GIR_Coverage, 15081,
     /* 1042220 */     GIR_EraseRootFromParent_Done,
     /* 1042221 */   // Label 15455: @1042221
     /* 1042221 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1042301), // Rule ID 15084 //
     /* 1042226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1042237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1042240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042265 */     // MIs[0] round
     /* 1042265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1042278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042300 */     // GIR_Coverage, 15084,
     /* 1042300 */     GIR_EraseRootFromParent_Done,
     /* 1042301 */   // Label 15456: @1042301
     /* 1042301 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1042381), // Rule ID 15085 //
     /* 1042306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1042317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1042320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042345 */     // MIs[0] round
     /* 1042345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1042358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042380 */     // GIR_Coverage, 15085,
     /* 1042380 */     GIR_EraseRootFromParent_Done,
     /* 1042381 */   // Label 15457: @1042381
     /* 1042381 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1042461), // Rule ID 15088 //
     /* 1042386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1042397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1042400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042425 */     // MIs[0] round
     /* 1042425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042435 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1042438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042460 */     // GIR_Coverage, 15088,
     /* 1042460 */     GIR_EraseRootFromParent_Done,
     /* 1042461 */   // Label 15458: @1042461
     /* 1042461 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1042541), // Rule ID 15089 //
     /* 1042466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1042477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1042480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042505 */     // MIs[0] round
     /* 1042505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042515 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1042518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042540 */     // GIR_Coverage, 15089,
     /* 1042540 */     GIR_EraseRootFromParent_Done,
     /* 1042541 */   // Label 15459: @1042541
     /* 1042541 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1042621), // Rule ID 15092 //
     /* 1042546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1042557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1042560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1042563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042585 */     // MIs[0] round
     /* 1042585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042595 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1042598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042620 */     // GIR_Coverage, 15092,
     /* 1042620 */     GIR_EraseRootFromParent_Done,
     /* 1042621 */   // Label 15460: @1042621
     /* 1042621 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1042701), // Rule ID 15093 //
     /* 1042626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1042637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1042640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1042643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042665 */     // MIs[0] round
     /* 1042665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042675 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1042678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042700 */     // GIR_Coverage, 15093,
     /* 1042700 */     GIR_EraseRootFromParent_Done,
     /* 1042701 */   // Label 15461: @1042701
     /* 1042701 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1042781), // Rule ID 15096 //
     /* 1042706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1042717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1042720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042745 */     // MIs[0] round
     /* 1042745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042755 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1042758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042780 */     // GIR_Coverage, 15096,
     /* 1042780 */     GIR_EraseRootFromParent_Done,
     /* 1042781 */   // Label 15462: @1042781
     /* 1042781 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1042861), // Rule ID 15097 //
     /* 1042786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1042797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1042800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042825 */     // MIs[0] round
     /* 1042825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1042838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042860 */     // GIR_Coverage, 15097,
     /* 1042860 */     GIR_EraseRootFromParent_Done,
     /* 1042861 */   // Label 15463: @1042861
     /* 1042861 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1042941), // Rule ID 15100 //
     /* 1042866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1042886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1042889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042905 */     // MIs[0] round
     /* 1042905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1042915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1042918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1042922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1042928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1042939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042940 */     // GIR_Coverage, 15100,
     /* 1042940 */     GIR_EraseRootFromParent_Done,
     /* 1042941 */   // Label 15464: @1042941
     /* 1042941 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1043021), // Rule ID 15101 //
     /* 1042946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1042954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1042966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1042969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042985 */     // MIs[0] round
     /* 1042985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1042988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042995 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1042995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1042998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043020 */     // GIR_Coverage, 15101,
     /* 1043020 */     GIR_EraseRootFromParent_Done,
     /* 1043021 */   // Label 15465: @1043021
     /* 1043021 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1043101), // Rule ID 15104 //
     /* 1043026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1043043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043065 */     // MIs[0] round
     /* 1043065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043075 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1043078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043100 */     // GIR_Coverage, 15104,
     /* 1043100 */     GIR_EraseRootFromParent_Done,
     /* 1043101 */   // Label 15466: @1043101
     /* 1043101 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1043181), // Rule ID 15105 //
     /* 1043106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1043123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043145 */     // MIs[0] round
     /* 1043145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043155 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1043158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043180 */     // GIR_Coverage, 15105,
     /* 1043180 */     GIR_EraseRootFromParent_Done,
     /* 1043181 */   // Label 15467: @1043181
     /* 1043181 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1043261), // Rule ID 15108 //
     /* 1043186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043225 */     // MIs[0] round
     /* 1043225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1043238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043260 */     // GIR_Coverage, 15108,
     /* 1043260 */     GIR_EraseRootFromParent_Done,
     /* 1043261 */   // Label 15468: @1043261
     /* 1043261 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1043341), // Rule ID 15109 //
     /* 1043266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043305 */     // MIs[0] round
     /* 1043305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1043318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043340 */     // GIR_Coverage, 15109,
     /* 1043340 */     GIR_EraseRootFromParent_Done,
     /* 1043341 */   // Label 15469: @1043341
     /* 1043341 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1043421), // Rule ID 15112 //
     /* 1043346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043385 */     // MIs[0] round
     /* 1043385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1043398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043420 */     // GIR_Coverage, 15112,
     /* 1043420 */     GIR_EraseRootFromParent_Done,
     /* 1043421 */   // Label 15470: @1043421
     /* 1043421 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1043501), // Rule ID 15113 //
     /* 1043426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043465 */     // MIs[0] round
     /* 1043465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043475 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1043478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043500 */     // GIR_Coverage, 15113,
     /* 1043500 */     GIR_EraseRootFromParent_Done,
     /* 1043501 */   // Label 15471: @1043501
     /* 1043501 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1043581), // Rule ID 15116 //
     /* 1043506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1043517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1043520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1043523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043545 */     // MIs[0] round
     /* 1043545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043555 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1043558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043580 */     // GIR_Coverage, 15116,
     /* 1043580 */     GIR_EraseRootFromParent_Done,
     /* 1043581 */   // Label 15472: @1043581
     /* 1043581 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1043661), // Rule ID 15117 //
     /* 1043586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1043597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1043600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1043603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043625 */     // MIs[0] round
     /* 1043625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043635 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1043638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043660 */     // GIR_Coverage, 15117,
     /* 1043660 */     GIR_EraseRootFromParent_Done,
     /* 1043661 */   // Label 15473: @1043661
     /* 1043661 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1043741), // Rule ID 15120 //
     /* 1043666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1043669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1043683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043705 */     // MIs[0] round
     /* 1043705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1043718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1043736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043740 */     // GIR_Coverage, 15120,
     /* 1043740 */     GIR_EraseRootFromParent_Done,
     /* 1043741 */   // Label 15474: @1043741
     /* 1043741 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1043821), // Rule ID 15121 //
     /* 1043746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1043749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1043763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043785 */     // MIs[0] round
     /* 1043785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043795 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1043798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1043816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043820 */     // GIR_Coverage, 15121,
     /* 1043820 */     GIR_EraseRootFromParent_Done,
     /* 1043821 */   // Label 15475: @1043821
     /* 1043821 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1043901), // Rule ID 15124 //
     /* 1043826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1043829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1043843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1043846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1043849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043865 */     // MIs[0] round
     /* 1043865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043875 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1043875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1043878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1043896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043900 */     // GIR_Coverage, 15124,
     /* 1043900 */     GIR_EraseRootFromParent_Done,
     /* 1043901 */   // Label 15476: @1043901
     /* 1043901 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1043981), // Rule ID 15125 //
     /* 1043906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1043909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1043923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1043926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1043929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043945 */     // MIs[0] round
     /* 1043945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1043948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043955 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1043955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1043958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1043962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1043968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1043976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1043979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043980 */     // GIR_Coverage, 15125,
     /* 1043980 */     GIR_EraseRootFromParent_Done,
     /* 1043981 */   // Label 15477: @1043981
     /* 1043981 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1044061), // Rule ID 15128 //
     /* 1043986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1043989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1043994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1044003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1044006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044025 */     // MIs[0] round
     /* 1044025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044035 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1044038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1044056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044060 */     // GIR_Coverage, 15128,
     /* 1044060 */     GIR_EraseRootFromParent_Done,
     /* 1044061 */   // Label 15478: @1044061
     /* 1044061 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1044141), // Rule ID 15129 //
     /* 1044066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1044069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1044074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1044083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1044086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044105 */     // MIs[0] round
     /* 1044105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044115 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1044118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1044136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044140 */     // GIR_Coverage, 15129,
     /* 1044140 */     GIR_EraseRootFromParent_Done,
     /* 1044141 */   // Label 15479: @1044141
     /* 1044141 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1044221), // Rule ID 15132 //
     /* 1044146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1044157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1044160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044185 */     // MIs[0] round
     /* 1044185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044195 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1044198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044220 */     // GIR_Coverage, 15132,
     /* 1044220 */     GIR_EraseRootFromParent_Done,
     /* 1044221 */   // Label 15480: @1044221
     /* 1044221 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1044301), // Rule ID 15133 //
     /* 1044226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1044237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1044240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044265 */     // MIs[0] round
     /* 1044265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044275 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1044278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044300 */     // GIR_Coverage, 15133,
     /* 1044300 */     GIR_EraseRootFromParent_Done,
     /* 1044301 */   // Label 15481: @1044301
     /* 1044301 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1044381), // Rule ID 15136 //
     /* 1044306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1044317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1044320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1044323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044345 */     // MIs[0] round
     /* 1044345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044355 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1044358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044380 */     // GIR_Coverage, 15136,
     /* 1044380 */     GIR_EraseRootFromParent_Done,
     /* 1044381 */   // Label 15482: @1044381
     /* 1044381 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1044461), // Rule ID 15137 //
     /* 1044386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1044397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1044400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1044403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044425 */     // MIs[0] round
     /* 1044425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044435 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1044438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044460 */     // GIR_Coverage, 15137,
     /* 1044460 */     GIR_EraseRootFromParent_Done,
     /* 1044461 */   // Label 15483: @1044461
     /* 1044461 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1044541), // Rule ID 15140 //
     /* 1044466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1044477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1044480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1044483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044505 */     // MIs[0] round
     /* 1044505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044515 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1044518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044540 */     // GIR_Coverage, 15140,
     /* 1044540 */     GIR_EraseRootFromParent_Done,
     /* 1044541 */   // Label 15484: @1044541
     /* 1044541 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1044621), // Rule ID 15141 //
     /* 1044546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1044557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1044560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1044563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044585 */     // MIs[0] round
     /* 1044585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044595 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1044598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044620 */     // GIR_Coverage, 15141,
     /* 1044620 */     GIR_EraseRootFromParent_Done,
     /* 1044621 */   // Label 15485: @1044621
     /* 1044621 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1044701), // Rule ID 15144 //
     /* 1044626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1044643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044665 */     // MIs[0] round
     /* 1044665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044675 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1044678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044700 */     // GIR_Coverage, 15144,
     /* 1044700 */     GIR_EraseRootFromParent_Done,
     /* 1044701 */   // Label 15486: @1044701
     /* 1044701 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1044781), // Rule ID 15145 //
     /* 1044706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1044723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044745 */     // MIs[0] round
     /* 1044745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044755 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1044758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044780 */     // GIR_Coverage, 15145,
     /* 1044780 */     GIR_EraseRootFromParent_Done,
     /* 1044781 */   // Label 15487: @1044781
     /* 1044781 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1044861), // Rule ID 15148 //
     /* 1044786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1044797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1044803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044825 */     // MIs[0] round
     /* 1044825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1044838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044860 */     // GIR_Coverage, 15148,
     /* 1044860 */     GIR_EraseRootFromParent_Done,
     /* 1044861 */   // Label 15488: @1044861
     /* 1044861 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1044941), // Rule ID 15149 //
     /* 1044866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1044877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1044883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1044889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044905 */     // MIs[0] round
     /* 1044905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044915 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1044915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1044918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1044922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1044928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1044939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044940 */     // GIR_Coverage, 15149,
     /* 1044940 */     GIR_EraseRootFromParent_Done,
     /* 1044941 */   // Label 15489: @1044941
     /* 1044941 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1045021), // Rule ID 15152 //
     /* 1044946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1044954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1044963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1044969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044985 */     // MIs[0] round
     /* 1044985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1044988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1044995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1044998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045020 */     // GIR_Coverage, 15152,
     /* 1045020 */     GIR_EraseRootFromParent_Done,
     /* 1045021 */   // Label 15490: @1045021
     /* 1045021 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1045101), // Rule ID 15153 //
     /* 1045026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1045037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1045040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1045043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045065 */     // MIs[0] round
     /* 1045065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045075 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1045078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045100 */     // GIR_Coverage, 15153,
     /* 1045100 */     GIR_EraseRootFromParent_Done,
     /* 1045101 */   // Label 15491: @1045101
     /* 1045101 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1045181), // Rule ID 15156 //
     /* 1045106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1045117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1045120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045145 */     // MIs[0] round
     /* 1045145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045155 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045180 */     // GIR_Coverage, 15156,
     /* 1045180 */     GIR_EraseRootFromParent_Done,
     /* 1045181 */   // Label 15492: @1045181
     /* 1045181 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1045261), // Rule ID 15157 //
     /* 1045186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1045197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1045200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045225 */     // MIs[0] round
     /* 1045225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045235 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045260 */     // GIR_Coverage, 15157,
     /* 1045260 */     GIR_EraseRootFromParent_Done,
     /* 1045261 */   // Label 15493: @1045261
     /* 1045261 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1045341), // Rule ID 15160 //
     /* 1045266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1045283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045305 */     // MIs[0] round
     /* 1045305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045340 */     // GIR_Coverage, 15160,
     /* 1045340 */     GIR_EraseRootFromParent_Done,
     /* 1045341 */   // Label 15494: @1045341
     /* 1045341 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1045421), // Rule ID 15161 //
     /* 1045346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1045363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045385 */     // MIs[0] round
     /* 1045385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045420 */     // GIR_Coverage, 15161,
     /* 1045420 */     GIR_EraseRootFromParent_Done,
     /* 1045421 */   // Label 15495: @1045421
     /* 1045421 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1045501), // Rule ID 15164 //
     /* 1045426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1045443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045465 */     // MIs[0] round
     /* 1045465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045500 */     // GIR_Coverage, 15164,
     /* 1045500 */     GIR_EraseRootFromParent_Done,
     /* 1045501 */   // Label 15496: @1045501
     /* 1045501 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1045581), // Rule ID 15165 //
     /* 1045506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1045523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045545 */     // MIs[0] round
     /* 1045545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045580 */     // GIR_Coverage, 15165,
     /* 1045580 */     GIR_EraseRootFromParent_Done,
     /* 1045581 */   // Label 15497: @1045581
     /* 1045581 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1045661), // Rule ID 15168 //
     /* 1045586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1045589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1045603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1045606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045625 */     // MIs[0] round
     /* 1045625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045635 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1045656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045660 */     // GIR_Coverage, 15168,
     /* 1045660 */     GIR_EraseRootFromParent_Done,
     /* 1045661 */   // Label 15498: @1045661
     /* 1045661 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1045741), // Rule ID 15169 //
     /* 1045666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1045669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1045683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1045686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045705 */     // MIs[0] round
     /* 1045705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1045718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1045736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045740 */     // GIR_Coverage, 15169,
     /* 1045740 */     GIR_EraseRootFromParent_Done,
     /* 1045741 */   // Label 15499: @1045741
     /* 1045741 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1045821), // Rule ID 15172 //
     /* 1045746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1045757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1045760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045785 */     // MIs[0] round
     /* 1045785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1045798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045820 */     // GIR_Coverage, 15172,
     /* 1045820 */     GIR_EraseRootFromParent_Done,
     /* 1045821 */   // Label 15500: @1045821
     /* 1045821 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1045901), // Rule ID 15173 //
     /* 1045826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1045837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1045840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1045849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045865 */     // MIs[0] round
     /* 1045865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1045875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1045878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045900 */     // GIR_Coverage, 15173,
     /* 1045900 */     GIR_EraseRootFromParent_Done,
     /* 1045901 */   // Label 15501: @1045901
     /* 1045901 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1045981), // Rule ID 15176 //
     /* 1045906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1045917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1045920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1045923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1045929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045945 */     // MIs[0] round
     /* 1045945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1045948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1045955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1045958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1045962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1045968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1045979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045980 */     // GIR_Coverage, 15176,
     /* 1045980 */     GIR_EraseRootFromParent_Done,
     /* 1045981 */   // Label 15502: @1045981
     /* 1045981 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1046061), // Rule ID 15177 //
     /* 1045986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1045994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1045997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1046000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1046003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046025 */     // MIs[0] round
     /* 1046025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046035 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1046038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046060 */     // GIR_Coverage, 15177,
     /* 1046060 */     GIR_EraseRootFromParent_Done,
     /* 1046061 */   // Label 15503: @1046061
     /* 1046061 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1046141), // Rule ID 15180 //
     /* 1046066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1046077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1046080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1046083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1046086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046105 */     // MIs[0] round
     /* 1046105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046115 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1046118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046140 */     // GIR_Coverage, 15180,
     /* 1046140 */     GIR_EraseRootFromParent_Done,
     /* 1046141 */   // Label 15504: @1046141
     /* 1046141 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1046221), // Rule ID 15181 //
     /* 1046146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1046157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1046160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1046163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1046166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046185 */     // MIs[0] round
     /* 1046185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046195 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1046198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046220 */     // GIR_Coverage, 15181,
     /* 1046220 */     GIR_EraseRootFromParent_Done,
     /* 1046221 */   // Label 15505: @1046221
     /* 1046221 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1046301), // Rule ID 15184 //
     /* 1046226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046265 */     // MIs[0] round
     /* 1046265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1046278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046300 */     // GIR_Coverage, 15184,
     /* 1046300 */     GIR_EraseRootFromParent_Done,
     /* 1046301 */   // Label 15506: @1046301
     /* 1046301 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1046381), // Rule ID 15185 //
     /* 1046306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046345 */     // MIs[0] round
     /* 1046345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1046358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046380 */     // GIR_Coverage, 15185,
     /* 1046380 */     GIR_EraseRootFromParent_Done,
     /* 1046381 */   // Label 15507: @1046381
     /* 1046381 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1046461), // Rule ID 15188 //
     /* 1046386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046425 */     // MIs[0] round
     /* 1046425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1046438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046460 */     // GIR_Coverage, 15188,
     /* 1046460 */     GIR_EraseRootFromParent_Done,
     /* 1046461 */   // Label 15508: @1046461
     /* 1046461 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1046541), // Rule ID 15189 //
     /* 1046466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046505 */     // MIs[0] round
     /* 1046505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046515 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1046518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046540 */     // GIR_Coverage, 15189,
     /* 1046540 */     GIR_EraseRootFromParent_Done,
     /* 1046541 */   // Label 15509: @1046541
     /* 1046541 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1046621), // Rule ID 15192 //
     /* 1046546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1046563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1046566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046585 */     // MIs[0] round
     /* 1046585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1046598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046620 */     // GIR_Coverage, 15192,
     /* 1046620 */     GIR_EraseRootFromParent_Done,
     /* 1046621 */   // Label 15510: @1046621
     /* 1046621 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1046701), // Rule ID 15193 //
     /* 1046626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1046643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1046646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046665 */     // MIs[0] round
     /* 1046665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046675 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1046678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046700 */     // GIR_Coverage, 15193,
     /* 1046700 */     GIR_EraseRootFromParent_Done,
     /* 1046701 */   // Label 15511: @1046701
     /* 1046701 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1046781), // Rule ID 15196 //
     /* 1046706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046745 */     // MIs[0] round
     /* 1046745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046755 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1046758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046780 */     // GIR_Coverage, 15196,
     /* 1046780 */     GIR_EraseRootFromParent_Done,
     /* 1046781 */   // Label 15512: @1046781
     /* 1046781 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1046861), // Rule ID 15197 //
     /* 1046786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046825 */     // MIs[0] round
     /* 1046825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1046838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046860 */     // GIR_Coverage, 15197,
     /* 1046860 */     GIR_EraseRootFromParent_Done,
     /* 1046861 */   // Label 15513: @1046861
     /* 1046861 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1046941), // Rule ID 15200 //
     /* 1046866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1046883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1046889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046905 */     // MIs[0] round
     /* 1046905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1046915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1046918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1046922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1046928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1046939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046940 */     // GIR_Coverage, 15200,
     /* 1046940 */     GIR_EraseRootFromParent_Done,
     /* 1046941 */   // Label 15514: @1046941
     /* 1046941 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1047021), // Rule ID 15201 //
     /* 1046946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1046954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1046963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1046969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046985 */     // MIs[0] round
     /* 1046985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1046988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046995 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1046995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1046998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047020 */     // GIR_Coverage, 15201,
     /* 1047020 */     GIR_EraseRootFromParent_Done,
     /* 1047021 */   // Label 15515: @1047021
     /* 1047021 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1047101), // Rule ID 15204 //
     /* 1047026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1047043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1047046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047065 */     // MIs[0] round
     /* 1047065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1047078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047100 */     // GIR_Coverage, 15204,
     /* 1047100 */     GIR_EraseRootFromParent_Done,
     /* 1047101 */   // Label 15516: @1047101
     /* 1047101 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1047181), // Rule ID 15205 //
     /* 1047106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1047123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1047126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047145 */     // MIs[0] round
     /* 1047145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047155 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1047158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047180 */     // GIR_Coverage, 15205,
     /* 1047180 */     GIR_EraseRootFromParent_Done,
     /* 1047181 */   // Label 15517: @1047181
     /* 1047181 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1047261), // Rule ID 15208 //
     /* 1047186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1047189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1047203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1047206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047225 */     // MIs[0] round
     /* 1047225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1047238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047260 */     // GIR_Coverage, 15208,
     /* 1047260 */     GIR_EraseRootFromParent_Done,
     /* 1047261 */   // Label 15518: @1047261
     /* 1047261 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1047341), // Rule ID 15209 //
     /* 1047266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1047269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1047283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1047286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047305 */     // MIs[0] round
     /* 1047305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1047318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047340 */     // GIR_Coverage, 15209,
     /* 1047340 */     GIR_EraseRootFromParent_Done,
     /* 1047341 */   // Label 15519: @1047341
     /* 1047341 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1047421), // Rule ID 15212 //
     /* 1047346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1047349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1047363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1047366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047385 */     // MIs[0] round
     /* 1047385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047395 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1047398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047420 */     // GIR_Coverage, 15212,
     /* 1047420 */     GIR_EraseRootFromParent_Done,
     /* 1047421 */   // Label 15520: @1047421
     /* 1047421 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1047501), // Rule ID 15213 //
     /* 1047426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1047429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1047443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1047446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047465 */     // MIs[0] round
     /* 1047465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047475 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1047478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047500 */     // GIR_Coverage, 15213,
     /* 1047500 */     GIR_EraseRootFromParent_Done,
     /* 1047501 */   // Label 15521: @1047501
     /* 1047501 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1047581), // Rule ID 15216 //
     /* 1047506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1047509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1047523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1047526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047545 */     // MIs[0] round
     /* 1047545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1047558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047580 */     // GIR_Coverage, 15216,
     /* 1047580 */     GIR_EraseRootFromParent_Done,
     /* 1047581 */   // Label 15522: @1047581
     /* 1047581 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1047661), // Rule ID 15217 //
     /* 1047586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1047589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1047603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1047606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047625 */     // MIs[0] round
     /* 1047625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047635 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1047638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1047656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047660 */     // GIR_Coverage, 15217,
     /* 1047660 */     GIR_EraseRootFromParent_Done,
     /* 1047661 */   // Label 15523: @1047661
     /* 1047661 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1047741), // Rule ID 15220 //
     /* 1047666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1047677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1047680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1047683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1047686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047705 */     // MIs[0] round
     /* 1047705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047715 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1047718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047740 */     // GIR_Coverage, 15220,
     /* 1047740 */     GIR_EraseRootFromParent_Done,
     /* 1047741 */   // Label 15524: @1047741
     /* 1047741 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1047821), // Rule ID 15221 //
     /* 1047746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1047757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1047760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1047763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1047766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047785 */     // MIs[0] round
     /* 1047785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047795 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1047798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047820 */     // GIR_Coverage, 15221,
     /* 1047820 */     GIR_EraseRootFromParent_Done,
     /* 1047821 */   // Label 15525: @1047821
     /* 1047821 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1047901), // Rule ID 15224 //
     /* 1047826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1047837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1047840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1047843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1047846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1047849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047865 */     // MIs[0] round
     /* 1047865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047875 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1047875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1047878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047900 */     // GIR_Coverage, 15224,
     /* 1047900 */     GIR_EraseRootFromParent_Done,
     /* 1047901 */   // Label 15526: @1047901
     /* 1047901 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1047981), // Rule ID 15225 //
     /* 1047906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1047917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1047920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1047923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1047926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1047929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047945 */     // MIs[0] round
     /* 1047945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1047948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047955 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1047955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1047958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1047968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1047979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047980 */     // GIR_Coverage, 15225,
     /* 1047980 */     GIR_EraseRootFromParent_Done,
     /* 1047981 */   // Label 15527: @1047981
     /* 1047981 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1048061), // Rule ID 15228 //
     /* 1047986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1047994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1047997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1048000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1048003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048025 */     // MIs[0] round
     /* 1048025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048035 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048060 */     // GIR_Coverage, 15228,
     /* 1048060 */     GIR_EraseRootFromParent_Done,
     /* 1048061 */   // Label 15528: @1048061
     /* 1048061 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1048141), // Rule ID 15229 //
     /* 1048066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1048077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1048080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1048083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048105 */     // MIs[0] round
     /* 1048105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048115 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048140 */     // GIR_Coverage, 15229,
     /* 1048140 */     GIR_EraseRootFromParent_Done,
     /* 1048141 */   // Label 15529: @1048141
     /* 1048141 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1048221), // Rule ID 15232 //
     /* 1048146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1048157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1048160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1048163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048185 */     // MIs[0] round
     /* 1048185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1048198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048220 */     // GIR_Coverage, 15232,
     /* 1048220 */     GIR_EraseRootFromParent_Done,
     /* 1048221 */   // Label 15530: @1048221
     /* 1048221 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1048301), // Rule ID 15233 //
     /* 1048226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1048237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1048240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1048243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048265 */     // MIs[0] round
     /* 1048265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048275 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1048278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048300 */     // GIR_Coverage, 15233,
     /* 1048300 */     GIR_EraseRootFromParent_Done,
     /* 1048301 */   // Label 15531: @1048301
     /* 1048301 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1048381), // Rule ID 15236 //
     /* 1048306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048345 */     // MIs[0] round
     /* 1048345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048355 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048380 */     // GIR_Coverage, 15236,
     /* 1048380 */     GIR_EraseRootFromParent_Done,
     /* 1048381 */   // Label 15532: @1048381
     /* 1048381 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1048461), // Rule ID 15237 //
     /* 1048386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048425 */     // MIs[0] round
     /* 1048425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048435 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048460 */     // GIR_Coverage, 15237,
     /* 1048460 */     GIR_EraseRootFromParent_Done,
     /* 1048461 */   // Label 15533: @1048461
     /* 1048461 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1048541), // Rule ID 15240 //
     /* 1048466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048505 */     // MIs[0] round
     /* 1048505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048515 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048540 */     // GIR_Coverage, 15240,
     /* 1048540 */     GIR_EraseRootFromParent_Done,
     /* 1048541 */   // Label 15534: @1048541
     /* 1048541 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1048621), // Rule ID 15241 //
     /* 1048546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048585 */     // MIs[0] round
     /* 1048585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1048598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048620 */     // GIR_Coverage, 15241,
     /* 1048620 */     GIR_EraseRootFromParent_Done,
     /* 1048621 */   // Label 15535: @1048621
     /* 1048621 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1048701), // Rule ID 15244 //
     /* 1048626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1048637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1048640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1048643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048665 */     // MIs[0] round
     /* 1048665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1048678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048700 */     // GIR_Coverage, 15244,
     /* 1048700 */     GIR_EraseRootFromParent_Done,
     /* 1048701 */   // Label 15536: @1048701
     /* 1048701 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1048781), // Rule ID 15245 //
     /* 1048706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1048717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1048720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1048723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048745 */     // MIs[0] round
     /* 1048745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048755 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10851:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1048758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048780 */     // GIR_Coverage, 15245,
     /* 1048780 */     GIR_EraseRootFromParent_Done,
     /* 1048781 */   // Label 15537: @1048781
     /* 1048781 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1048861), // Rule ID 15248 //
     /* 1048786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048825 */     // MIs[0] round
     /* 1048825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1048838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048860 */     // GIR_Coverage, 15248,
     /* 1048860 */     GIR_EraseRootFromParent_Done,
     /* 1048861 */   // Label 15538: @1048861
     /* 1048861 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1048941), // Rule ID 15249 //
     /* 1048866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1048886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1048889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048905 */     // MIs[0] round
     /* 1048905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1048915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1048918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1048928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1048939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048940 */     // GIR_Coverage, 15249,
     /* 1048940 */     GIR_EraseRootFromParent_Done,
     /* 1048941 */   // Label 15539: @1048941
     /* 1048941 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1049021), // Rule ID 15252 //
     /* 1048946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1048954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1048966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1048969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048985 */     // MIs[0] round
     /* 1048985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1048988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1048995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1048998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049020 */     // GIR_Coverage, 15252,
     /* 1049020 */     GIR_EraseRootFromParent_Done,
     /* 1049021 */   // Label 15540: @1049021
     /* 1049021 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1049101), // Rule ID 15253 //
     /* 1049026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1049037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1049040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1049043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049065 */     // MIs[0] round
     /* 1049065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1049078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049100 */     // GIR_Coverage, 15253,
     /* 1049100 */     GIR_EraseRootFromParent_Done,
     /* 1049101 */   // Label 15541: @1049101
     /* 1049101 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1049181), // Rule ID 15256 //
     /* 1049106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1049109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049145 */     // MIs[0] round
     /* 1049145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1049158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049180 */     // GIR_Coverage, 15256,
     /* 1049180 */     GIR_EraseRootFromParent_Done,
     /* 1049181 */   // Label 15542: @1049181
     /* 1049181 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1049261), // Rule ID 15257 //
     /* 1049186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1049189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049225 */     // MIs[0] round
     /* 1049225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1049238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049260 */     // GIR_Coverage, 15257,
     /* 1049260 */     GIR_EraseRootFromParent_Done,
     /* 1049261 */   // Label 15543: @1049261
     /* 1049261 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1049341), // Rule ID 15260 //
     /* 1049266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1049277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1049280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1049283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049305 */     // MIs[0] round
     /* 1049305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1049318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049340 */     // GIR_Coverage, 15260,
     /* 1049340 */     GIR_EraseRootFromParent_Done,
     /* 1049341 */   // Label 15544: @1049341
     /* 1049341 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1049421), // Rule ID 15261 //
     /* 1049346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1049357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1049360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1049363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049385 */     // MIs[0] round
     /* 1049385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049395 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1049398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049420 */     // GIR_Coverage, 15261,
     /* 1049420 */     GIR_EraseRootFromParent_Done,
     /* 1049421 */   // Label 15545: @1049421
     /* 1049421 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1049501), // Rule ID 15264 //
     /* 1049426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1049437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1049440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1049443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049465 */     // MIs[0] round
     /* 1049465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049475 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1049478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049500 */     // GIR_Coverage, 15264,
     /* 1049500 */     GIR_EraseRootFromParent_Done,
     /* 1049501 */   // Label 15546: @1049501
     /* 1049501 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1049581), // Rule ID 15265 //
     /* 1049506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1049517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1049520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1049523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049545 */     // MIs[0] round
     /* 1049545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049555 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1049558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049580 */     // GIR_Coverage, 15265,
     /* 1049580 */     GIR_EraseRootFromParent_Done,
     /* 1049581 */   // Label 15547: @1049581
     /* 1049581 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1049661), // Rule ID 15268 //
     /* 1049586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1049597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1049600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1049603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049625 */     // MIs[0] round
     /* 1049625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1049638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049660 */     // GIR_Coverage, 15268,
     /* 1049660 */     GIR_EraseRootFromParent_Done,
     /* 1049661 */   // Label 15548: @1049661
     /* 1049661 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1049741), // Rule ID 15269 //
     /* 1049666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1049677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1049680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1049683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049705 */     // MIs[0] round
     /* 1049705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049715 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1049718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049740 */     // GIR_Coverage, 15269,
     /* 1049740 */     GIR_EraseRootFromParent_Done,
     /* 1049741 */   // Label 15549: @1049741
     /* 1049741 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1049821), // Rule ID 15272 //
     /* 1049746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049785 */     // MIs[0] round
     /* 1049785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1049798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049820 */     // GIR_Coverage, 15272,
     /* 1049820 */     GIR_EraseRootFromParent_Done,
     /* 1049821 */   // Label 15550: @1049821
     /* 1049821 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1049901), // Rule ID 15273 //
     /* 1049826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1049846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1049849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049865 */     // MIs[0] round
     /* 1049865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1049875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1049878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049900 */     // GIR_Coverage, 15273,
     /* 1049900 */     GIR_EraseRootFromParent_Done,
     /* 1049901 */   // Label 15551: @1049901
     /* 1049901 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1049981), // Rule ID 15276 //
     /* 1049906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1049920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1049923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1049926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1049929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049945 */     // MIs[0] round
     /* 1049945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1049948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049955 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1049955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1049958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1049968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1049979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049980 */     // GIR_Coverage, 15276,
     /* 1049980 */     GIR_EraseRootFromParent_Done,
     /* 1049981 */   // Label 15552: @1049981
     /* 1049981 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1050061), // Rule ID 15277 //
     /* 1049986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1049994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1050003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050025 */     // MIs[0] round
     /* 1050025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050035 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1050038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050060 */     // GIR_Coverage, 15277,
     /* 1050060 */     GIR_EraseRootFromParent_Done,
     /* 1050061 */   // Label 15553: @1050061
     /* 1050061 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1050141), // Rule ID 15280 //
     /* 1050066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1050083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050105 */     // MIs[0] round
     /* 1050105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050115 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1050118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050140 */     // GIR_Coverage, 15280,
     /* 1050140 */     GIR_EraseRootFromParent_Done,
     /* 1050141 */   // Label 15554: @1050141
     /* 1050141 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1050221), // Rule ID 15281 //
     /* 1050146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1050163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050185 */     // MIs[0] round
     /* 1050185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1050198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050220 */     // GIR_Coverage, 15281,
     /* 1050220 */     GIR_EraseRootFromParent_Done,
     /* 1050221 */   // Label 15555: @1050221
     /* 1050221 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1050301), // Rule ID 15284 //
     /* 1050226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1050243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050265 */     // MIs[0] round
     /* 1050265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1050278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050300 */     // GIR_Coverage, 15284,
     /* 1050300 */     GIR_EraseRootFromParent_Done,
     /* 1050301 */   // Label 15556: @1050301
     /* 1050301 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1050381), // Rule ID 15285 //
     /* 1050306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1050323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050345 */     // MIs[0] round
     /* 1050345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1050358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050380 */     // GIR_Coverage, 15285,
     /* 1050380 */     GIR_EraseRootFromParent_Done,
     /* 1050381 */   // Label 15557: @1050381
     /* 1050381 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1050461), // Rule ID 15288 //
     /* 1050386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1050403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050425 */     // MIs[0] round
     /* 1050425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050435 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1050438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050460 */     // GIR_Coverage, 15288,
     /* 1050460 */     GIR_EraseRootFromParent_Done,
     /* 1050461 */   // Label 15558: @1050461
     /* 1050461 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1050541), // Rule ID 15289 //
     /* 1050466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1050483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050505 */     // MIs[0] round
     /* 1050505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050515 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1050518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050540 */     // GIR_Coverage, 15289,
     /* 1050540 */     GIR_EraseRootFromParent_Done,
     /* 1050541 */   // Label 15559: @1050541
     /* 1050541 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1050621), // Rule ID 15292 //
     /* 1050546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1050563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050585 */     // MIs[0] round
     /* 1050585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1050598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050620 */     // GIR_Coverage, 15292,
     /* 1050620 */     GIR_EraseRootFromParent_Done,
     /* 1050621 */   // Label 15560: @1050621
     /* 1050621 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1050701), // Rule ID 15293 //
     /* 1050626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1050643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050665 */     // MIs[0] round
     /* 1050665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050675 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1050678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050700 */     // GIR_Coverage, 15293,
     /* 1050700 */     GIR_EraseRootFromParent_Done,
     /* 1050701 */   // Label 15561: @1050701
     /* 1050701 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1050781), // Rule ID 15296 //
     /* 1050706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1050709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050745 */     // MIs[0] round
     /* 1050745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1050758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050780 */     // GIR_Coverage, 15296,
     /* 1050780 */     GIR_EraseRootFromParent_Done,
     /* 1050781 */   // Label 15562: @1050781
     /* 1050781 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1050861), // Rule ID 15297 //
     /* 1050786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1050789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050825 */     // MIs[0] round
     /* 1050825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1050838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050860 */     // GIR_Coverage, 15297,
     /* 1050860 */     GIR_EraseRootFromParent_Done,
     /* 1050861 */   // Label 15563: @1050861
     /* 1050861 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1050941), // Rule ID 15300 //
     /* 1050866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1050869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1050886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1050889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050905 */     // MIs[0] round
     /* 1050905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050915 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1050915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1050918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1050928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1050939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050940 */     // GIR_Coverage, 15300,
     /* 1050940 */     GIR_EraseRootFromParent_Done,
     /* 1050941 */   // Label 15564: @1050941
     /* 1050941 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1051021), // Rule ID 15301 //
     /* 1050946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1050949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1050954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1050966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1050969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050985 */     // MIs[0] round
     /* 1050985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1050988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050995 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1050995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1050998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051020 */     // GIR_Coverage, 15301,
     /* 1051020 */     GIR_EraseRootFromParent_Done,
     /* 1051021 */   // Label 15565: @1051021
     /* 1051021 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1051101), // Rule ID 15304 //
     /* 1051026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1051029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1051034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1051043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1051046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051065 */     // MIs[0] round
     /* 1051065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051075 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1051078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051100 */     // GIR_Coverage, 15304,
     /* 1051100 */     GIR_EraseRootFromParent_Done,
     /* 1051101 */   // Label 15566: @1051101
     /* 1051101 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1051181), // Rule ID 15305 //
     /* 1051106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1051109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1051114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1051123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1051126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051145 */     // MIs[0] round
     /* 1051145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051155 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1051158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051180 */     // GIR_Coverage, 15305,
     /* 1051180 */     GIR_EraseRootFromParent_Done,
     /* 1051181 */   // Label 15567: @1051181
     /* 1051181 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1051261), // Rule ID 15308 //
     /* 1051186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1051197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1051200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1051203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1051206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051225 */     // MIs[0] round
     /* 1051225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1051238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051260 */     // GIR_Coverage, 15308,
     /* 1051260 */     GIR_EraseRootFromParent_Done,
     /* 1051261 */   // Label 15568: @1051261
     /* 1051261 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1051341), // Rule ID 15309 //
     /* 1051266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1051277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1051280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1051283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1051286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051305 */     // MIs[0] round
     /* 1051305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051315 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1051318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051340 */     // GIR_Coverage, 15309,
     /* 1051340 */     GIR_EraseRootFromParent_Done,
     /* 1051341 */   // Label 15569: @1051341
     /* 1051341 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1051421), // Rule ID 15312 //
     /* 1051346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1051357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1051360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1051363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1051366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051385 */     // MIs[0] round
     /* 1051385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1051398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051420 */     // GIR_Coverage, 15312,
     /* 1051420 */     GIR_EraseRootFromParent_Done,
     /* 1051421 */   // Label 15570: @1051421
     /* 1051421 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1051501), // Rule ID 15313 //
     /* 1051426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1051437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1051440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1051443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1051446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051465 */     // MIs[0] round
     /* 1051465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1051478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051500 */     // GIR_Coverage, 15313,
     /* 1051500 */     GIR_EraseRootFromParent_Done,
     /* 1051501 */   // Label 15571: @1051501
     /* 1051501 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1051581), // Rule ID 15316 //
     /* 1051506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1051517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1051520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1051523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1051526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051545 */     // MIs[0] round
     /* 1051545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051555 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1051558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051580 */     // GIR_Coverage, 15316,
     /* 1051580 */     GIR_EraseRootFromParent_Done,
     /* 1051581 */   // Label 15572: @1051581
     /* 1051581 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1051661), // Rule ID 15317 //
     /* 1051586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1051597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1051600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1051603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1051606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051625 */     // MIs[0] round
     /* 1051625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1051638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1051656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051660 */     // GIR_Coverage, 15317,
     /* 1051660 */     GIR_EraseRootFromParent_Done,
     /* 1051661 */   // Label 15573: @1051661
     /* 1051661 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1051741), // Rule ID 15320 //
     /* 1051666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1051677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1051680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1051683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1051686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051705 */     // MIs[0] round
     /* 1051705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051715 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1051718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051740 */     // GIR_Coverage, 15320,
     /* 1051740 */     GIR_EraseRootFromParent_Done,
     /* 1051741 */   // Label 15574: @1051741
     /* 1051741 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1051821), // Rule ID 15321 //
     /* 1051746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1051757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1051760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1051763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1051766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051785 */     // MIs[0] round
     /* 1051785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051795 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1051798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051820 */     // GIR_Coverage, 15321,
     /* 1051820 */     GIR_EraseRootFromParent_Done,
     /* 1051821 */   // Label 15575: @1051821
     /* 1051821 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1051901), // Rule ID 15324 //
     /* 1051826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1051846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1051849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051865 */     // MIs[0] round
     /* 1051865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1051875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1051878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051900 */     // GIR_Coverage, 15324,
     /* 1051900 */     GIR_EraseRootFromParent_Done,
     /* 1051901 */   // Label 15576: @1051901
     /* 1051901 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1051981), // Rule ID 15325 //
     /* 1051906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1051926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1051929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051945 */     // MIs[0] round
     /* 1051945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1051948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051955 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1051955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1051958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1051968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1051979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051980 */     // GIR_Coverage, 15325,
     /* 1051980 */     GIR_EraseRootFromParent_Done,
     /* 1051981 */   // Label 15577: @1051981
     /* 1051981 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1052061), // Rule ID 15328 //
     /* 1051986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1051989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1051994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1051997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1052006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052025 */     // MIs[0] round
     /* 1052025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052035 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1052038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052060 */     // GIR_Coverage, 15328,
     /* 1052060 */     GIR_EraseRootFromParent_Done,
     /* 1052061 */   // Label 15578: @1052061
     /* 1052061 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1052141), // Rule ID 15329 //
     /* 1052066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1052069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1052086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052105 */     // MIs[0] round
     /* 1052105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1052118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052140 */     // GIR_Coverage, 15329,
     /* 1052140 */     GIR_EraseRootFromParent_Done,
     /* 1052141 */   // Label 15579: @1052141
     /* 1052141 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1052221), // Rule ID 15332 //
     /* 1052146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1052149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1052157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1052160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1052163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1052166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052185 */     // MIs[0] round
     /* 1052185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052195 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1052216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052220 */     // GIR_Coverage, 15332,
     /* 1052220 */     GIR_EraseRootFromParent_Done,
     /* 1052221 */   // Label 15580: @1052221
     /* 1052221 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1052301), // Rule ID 15333 //
     /* 1052226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1052229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1052237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1052240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1052243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1052246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052265 */     // MIs[0] round
     /* 1052265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052275 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1052296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052300 */     // GIR_Coverage, 15333,
     /* 1052300 */     GIR_EraseRootFromParent_Done,
     /* 1052301 */   // Label 15581: @1052301
     /* 1052301 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1052381), // Rule ID 15336 //
     /* 1052306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1052309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1052326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052345 */     // MIs[0] round
     /* 1052345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052355 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052380 */     // GIR_Coverage, 15336,
     /* 1052380 */     GIR_EraseRootFromParent_Done,
     /* 1052381 */   // Label 15582: @1052381
     /* 1052381 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1052461), // Rule ID 15337 //
     /* 1052386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1052389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1052406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052425 */     // MIs[0] round
     /* 1052425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052435 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052460 */     // GIR_Coverage, 15337,
     /* 1052460 */     GIR_EraseRootFromParent_Done,
     /* 1052461 */   // Label 15583: @1052461
     /* 1052461 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1052541), // Rule ID 15340 //
     /* 1052466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1052469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1052486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052505 */     // MIs[0] round
     /* 1052505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052540 */     // GIR_Coverage, 15340,
     /* 1052540 */     GIR_EraseRootFromParent_Done,
     /* 1052541 */   // Label 15584: @1052541
     /* 1052541 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1052621), // Rule ID 15341 //
     /* 1052546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1052549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1052566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052585 */     // MIs[0] round
     /* 1052585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052620 */     // GIR_Coverage, 15341,
     /* 1052620 */     GIR_EraseRootFromParent_Done,
     /* 1052621 */   // Label 15585: @1052621
     /* 1052621 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1052701), // Rule ID 15344 //
     /* 1052626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1052629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1052646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052665 */     // MIs[0] round
     /* 1052665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052700 */     // GIR_Coverage, 15344,
     /* 1052700 */     GIR_EraseRootFromParent_Done,
     /* 1052701 */   // Label 15586: @1052701
     /* 1052701 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1052781), // Rule ID 15345 //
     /* 1052706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1052709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1052726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052745 */     // MIs[0] round
     /* 1052745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052755 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1052758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052780 */     // GIR_Coverage, 15345,
     /* 1052780 */     GIR_EraseRootFromParent_Done,
     /* 1052781 */   // Label 15587: @1052781
     /* 1052781 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1052861), // Rule ID 15348 //
     /* 1052786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1052789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1052797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1052800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1052803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1052806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052825 */     // MIs[0] round
     /* 1052825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1052838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1052856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052860 */     // GIR_Coverage, 15348,
     /* 1052860 */     GIR_EraseRootFromParent_Done,
     /* 1052861 */   // Label 15588: @1052861
     /* 1052861 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1052941), // Rule ID 15349 //
     /* 1052866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1052869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1052877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1052880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1052883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1052886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1052889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052905 */     // MIs[0] round
     /* 1052905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052915 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1052915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1052918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1052924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1052926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1052928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1052936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1052939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052940 */     // GIR_Coverage, 15349,
     /* 1052940 */     GIR_EraseRootFromParent_Done,
     /* 1052941 */   // Label 15589: @1052941
     /* 1052941 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1053021), // Rule ID 15352 //
     /* 1052946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1052949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1052954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1052957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1052960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1052963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1052966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1052969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052985 */     // MIs[0] round
     /* 1052985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1052988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052995 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1052995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1052998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1053016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053020 */     // GIR_Coverage, 15352,
     /* 1053020 */     GIR_EraseRootFromParent_Done,
     /* 1053021 */   // Label 15590: @1053021
     /* 1053021 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1053101), // Rule ID 15353 //
     /* 1053026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1053037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1053040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1053043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1053046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053065 */     // MIs[0] round
     /* 1053065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053075 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1053078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1053096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053100 */     // GIR_Coverage, 15353,
     /* 1053100 */     GIR_EraseRootFromParent_Done,
     /* 1053101 */   // Label 15591: @1053101
     /* 1053101 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1053181), // Rule ID 15356 //
     /* 1053106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1053117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1053120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1053123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1053126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053145 */     // MIs[0] round
     /* 1053145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053155 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1053158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1053176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053180 */     // GIR_Coverage, 15356,
     /* 1053180 */     GIR_EraseRootFromParent_Done,
     /* 1053181 */   // Label 15592: @1053181
     /* 1053181 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1053261), // Rule ID 15357 //
     /* 1053186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1053197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1053200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1053203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1053206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053225 */     // MIs[0] round
     /* 1053225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053235 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1053238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1053256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053260 */     // GIR_Coverage, 15357,
     /* 1053260 */     GIR_EraseRootFromParent_Done,
     /* 1053261 */   // Label 15593: @1053261
     /* 1053261 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1053341), // Rule ID 15360 //
     /* 1053266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1053286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053305 */     // MIs[0] round
     /* 1053305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1053318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053340 */     // GIR_Coverage, 15360,
     /* 1053340 */     GIR_EraseRootFromParent_Done,
     /* 1053341 */   // Label 15594: @1053341
     /* 1053341 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1053421), // Rule ID 15361 //
     /* 1053346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1053366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053385 */     // MIs[0] round
     /* 1053385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1053398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053420 */     // GIR_Coverage, 15361,
     /* 1053420 */     GIR_EraseRootFromParent_Done,
     /* 1053421 */   // Label 15595: @1053421
     /* 1053421 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1053501), // Rule ID 15364 //
     /* 1053426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1053446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053465 */     // MIs[0] round
     /* 1053465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1053478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053500 */     // GIR_Coverage, 15364,
     /* 1053500 */     GIR_EraseRootFromParent_Done,
     /* 1053501 */   // Label 15596: @1053501
     /* 1053501 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1053581), // Rule ID 15365 //
     /* 1053506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1053526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053545 */     // MIs[0] round
     /* 1053545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053555 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1053558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053580 */     // GIR_Coverage, 15365,
     /* 1053580 */     GIR_EraseRootFromParent_Done,
     /* 1053581 */   // Label 15597: @1053581
     /* 1053581 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1053661), // Rule ID 15368 //
     /* 1053586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1053606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053625 */     // MIs[0] round
     /* 1053625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053635 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1053638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053660 */     // GIR_Coverage, 15368,
     /* 1053660 */     GIR_EraseRootFromParent_Done,
     /* 1053661 */   // Label 15598: @1053661
     /* 1053661 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1053741), // Rule ID 15369 //
     /* 1053666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1053686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053705 */     // MIs[0] round
     /* 1053705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1053718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053740 */     // GIR_Coverage, 15369,
     /* 1053740 */     GIR_EraseRootFromParent_Done,
     /* 1053741 */   // Label 15599: @1053741
     /* 1053741 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1053821), // Rule ID 15372 //
     /* 1053746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1053766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053785 */     // MIs[0] round
     /* 1053785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1053798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053820 */     // GIR_Coverage, 15372,
     /* 1053820 */     GIR_EraseRootFromParent_Done,
     /* 1053821 */   // Label 15600: @1053821
     /* 1053821 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1053901), // Rule ID 15373 //
     /* 1053826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1053846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1053849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053865 */     // MIs[0] round
     /* 1053865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1053875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1053878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053900 */     // GIR_Coverage, 15373,
     /* 1053900 */     GIR_EraseRootFromParent_Done,
     /* 1053901 */   // Label 15601: @1053901
     /* 1053901 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1053981), // Rule ID 15376 //
     /* 1053906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1053909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1053926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1053929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053945 */     // MIs[0] round
     /* 1053945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1053948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1053955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1053958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1053964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1053966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1053968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1053979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053980 */     // GIR_Coverage, 15376,
     /* 1053980 */     GIR_EraseRootFromParent_Done,
     /* 1053981 */   // Label 15602: @1053981
     /* 1053981 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1054061), // Rule ID 15377 //
     /* 1053986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1053989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1053994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1054000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1054003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1054006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054025 */     // MIs[0] round
     /* 1054025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054035 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1054038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054060 */     // GIR_Coverage, 15377,
     /* 1054060 */     GIR_EraseRootFromParent_Done,
     /* 1054061 */   // Label 15603: @1054061
     /* 1054061 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1054141), // Rule ID 15380 //
     /* 1054066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1054069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1054086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054105 */     // MIs[0] round
     /* 1054105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1054118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054140 */     // GIR_Coverage, 15380,
     /* 1054140 */     GIR_EraseRootFromParent_Done,
     /* 1054141 */   // Label 15604: @1054141
     /* 1054141 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1054221), // Rule ID 15381 //
     /* 1054146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1054149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1054166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054185 */     // MIs[0] round
     /* 1054185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1054198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054220 */     // GIR_Coverage, 15381,
     /* 1054220 */     GIR_EraseRootFromParent_Done,
     /* 1054221 */   // Label 15605: @1054221
     /* 1054221 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1054301), // Rule ID 15384 //
     /* 1054226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1054229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1054246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054265 */     // MIs[0] round
     /* 1054265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1054278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054300 */     // GIR_Coverage, 15384,
     /* 1054300 */     GIR_EraseRootFromParent_Done,
     /* 1054301 */   // Label 15606: @1054301
     /* 1054301 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1054381), // Rule ID 15385 //
     /* 1054306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1054309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1054326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054345 */     // MIs[0] round
     /* 1054345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1054358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054380 */     // GIR_Coverage, 15385,
     /* 1054380 */     GIR_EraseRootFromParent_Done,
     /* 1054381 */   // Label 15607: @1054381
     /* 1054381 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1054461), // Rule ID 15388 //
     /* 1054386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1054389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1054406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054425 */     // MIs[0] round
     /* 1054425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054435 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1054438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054460 */     // GIR_Coverage, 15388,
     /* 1054460 */     GIR_EraseRootFromParent_Done,
     /* 1054461 */   // Label 15608: @1054461
     /* 1054461 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1054541), // Rule ID 15389 //
     /* 1054466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1054469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1054486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054505 */     // MIs[0] round
     /* 1054505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1054518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054540 */     // GIR_Coverage, 15389,
     /* 1054540 */     GIR_EraseRootFromParent_Done,
     /* 1054541 */   // Label 15609: @1054541
     /* 1054541 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1054621), // Rule ID 15392 //
     /* 1054546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1054549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1054566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054585 */     // MIs[0] round
     /* 1054585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054595 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1054598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054620 */     // GIR_Coverage, 15392,
     /* 1054620 */     GIR_EraseRootFromParent_Done,
     /* 1054621 */   // Label 15610: @1054621
     /* 1054621 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1054701), // Rule ID 15393 //
     /* 1054626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1054629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1054646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054665 */     // MIs[0] round
     /* 1054665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1054678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054700 */     // GIR_Coverage, 15393,
     /* 1054700 */     GIR_EraseRootFromParent_Done,
     /* 1054701 */   // Label 15611: @1054701
     /* 1054701 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1054781), // Rule ID 15396 //
     /* 1054706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1054709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1054717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1054720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1054723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1054726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1054745 */     // MIs[0] round
     /* 1054745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054755 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1054758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1054776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054780 */     // GIR_Coverage, 15396,
     /* 1054780 */     GIR_EraseRootFromParent_Done,
     /* 1054781 */   // Label 15612: @1054781
     /* 1054781 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1054861), // Rule ID 15397 //
     /* 1054786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1054789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1054797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1054800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1054803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1054806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1054825 */     // MIs[0] round
     /* 1054825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054835 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1054838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1054856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054860 */     // GIR_Coverage, 15397,
     /* 1054860 */     GIR_EraseRootFromParent_Done,
     /* 1054861 */   // Label 15613: @1054861
     /* 1054861 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1054941), // Rule ID 15400 //
     /* 1054866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1054869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1054877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1054880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1054883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1054886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1054889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1054905 */     // MIs[0] round
     /* 1054905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054915 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1054915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1054918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1054924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1054926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1054928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1054936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1054939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054940 */     // GIR_Coverage, 15400,
     /* 1054940 */     GIR_EraseRootFromParent_Done,
     /* 1054941 */   // Label 15614: @1054941
     /* 1054941 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1055021), // Rule ID 15401 //
     /* 1054946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1054949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1054954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1054957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1054960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1054963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1054966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1054969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1054985 */     // MIs[0] round
     /* 1054985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1054988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1054995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1054998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1055016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055020 */     // GIR_Coverage, 15401,
     /* 1055020 */     GIR_EraseRootFromParent_Done,
     /* 1055021 */   // Label 15615: @1055021
     /* 1055021 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1055101), // Rule ID 15404 //
     /* 1055026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1055037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1055040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1055043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055065 */     // MIs[0] round
     /* 1055065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055075 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1055096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055100 */     // GIR_Coverage, 15404,
     /* 1055100 */     GIR_EraseRootFromParent_Done,
     /* 1055101 */   // Label 15616: @1055101
     /* 1055101 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1055181), // Rule ID 15405 //
     /* 1055106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1055117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1055120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1055123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055145 */     // MIs[0] round
     /* 1055145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055155 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1055176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055180 */     // GIR_Coverage, 15405,
     /* 1055180 */     GIR_EraseRootFromParent_Done,
     /* 1055181 */   // Label 15617: @1055181
     /* 1055181 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1055261), // Rule ID 15408 //
     /* 1055186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055225 */     // MIs[0] round
     /* 1055225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055235 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1055238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055260 */     // GIR_Coverage, 15408,
     /* 1055260 */     GIR_EraseRootFromParent_Done,
     /* 1055261 */   // Label 15618: @1055261
     /* 1055261 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1055341), // Rule ID 15409 //
     /* 1055266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055305 */     // MIs[0] round
     /* 1055305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1055318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055340 */     // GIR_Coverage, 15409,
     /* 1055340 */     GIR_EraseRootFromParent_Done,
     /* 1055341 */   // Label 15619: @1055341
     /* 1055341 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1055421), // Rule ID 15412 //
     /* 1055346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055385 */     // MIs[0] round
     /* 1055385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055395 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055420 */     // GIR_Coverage, 15412,
     /* 1055420 */     GIR_EraseRootFromParent_Done,
     /* 1055421 */   // Label 15620: @1055421
     /* 1055421 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1055501), // Rule ID 15413 //
     /* 1055426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055465 */     // MIs[0] round
     /* 1055465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055475 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055500 */     // GIR_Coverage, 15413,
     /* 1055500 */     GIR_EraseRootFromParent_Done,
     /* 1055501 */   // Label 15621: @1055501
     /* 1055501 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1055581), // Rule ID 15416 //
     /* 1055506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055545 */     // MIs[0] round
     /* 1055545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055555 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055580 */     // GIR_Coverage, 15416,
     /* 1055580 */     GIR_EraseRootFromParent_Done,
     /* 1055581 */   // Label 15622: @1055581
     /* 1055581 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1055661), // Rule ID 15417 //
     /* 1055586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055625 */     // MIs[0] round
     /* 1055625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1055638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055660 */     // GIR_Coverage, 15417,
     /* 1055660 */     GIR_EraseRootFromParent_Done,
     /* 1055661 */   // Label 15623: @1055661
     /* 1055661 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1055741), // Rule ID 15420 //
     /* 1055666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1055677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1055680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1055683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055705 */     // MIs[0] round
     /* 1055705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055715 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1055718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1055736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055740 */     // GIR_Coverage, 15420,
     /* 1055740 */     GIR_EraseRootFromParent_Done,
     /* 1055741 */   // Label 15624: @1055741
     /* 1055741 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1055821), // Rule ID 15421 //
     /* 1055746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1055757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1055760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1055763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055785 */     // MIs[0] round
     /* 1055785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10829:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1055798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1055816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055820 */     // GIR_Coverage, 15421,
     /* 1055820 */     GIR_EraseRootFromParent_Done,
     /* 1055821 */   // Label 15625: @1055821
     /* 1055821 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1055901), // Rule ID 15424 //
     /* 1055826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1055846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1055849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055865 */     // MIs[0] round
     /* 1055865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1055875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1055878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055900 */     // GIR_Coverage, 15424,
     /* 1055900 */     GIR_EraseRootFromParent_Done,
     /* 1055901 */   // Label 15626: @1055901
     /* 1055901 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1055981), // Rule ID 15425 //
     /* 1055906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1055909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1055926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1055929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1055945 */     // MIs[0] round
     /* 1055945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1055948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10829:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1055955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1055958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1055964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1055966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1055968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1055979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055980 */     // GIR_Coverage, 15425,
     /* 1055980 */     GIR_EraseRootFromParent_Done,
     /* 1055981 */   // Label 15627: @1055981
     /* 1055981 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1056061), // Rule ID 15428 //
     /* 1055986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1055989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1055994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056025 */     // MIs[0] round
     /* 1056025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1056038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056060 */     // GIR_Coverage, 15428,
     /* 1056060 */     GIR_EraseRootFromParent_Done,
     /* 1056061 */   // Label 15628: @1056061
     /* 1056061 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1056141), // Rule ID 15429 //
     /* 1056066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1056069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056105 */     // MIs[0] round
     /* 1056105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10829:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1056118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056140 */     // GIR_Coverage, 15429,
     /* 1056140 */     GIR_EraseRootFromParent_Done,
     /* 1056141 */   // Label 15629: @1056141
     /* 1056141 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1056221), // Rule ID 15432 //
     /* 1056146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1056149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056185 */     // MIs[0] round
     /* 1056185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1056198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056220 */     // GIR_Coverage, 15432,
     /* 1056220 */     GIR_EraseRootFromParent_Done,
     /* 1056221 */   // Label 15630: @1056221
     /* 1056221 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1056301), // Rule ID 15433 //
     /* 1056226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1056229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056265 */     // MIs[0] round
     /* 1056265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056275 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10829:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1056278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056300 */     // GIR_Coverage, 15433,
     /* 1056300 */     GIR_EraseRootFromParent_Done,
     /* 1056301 */   // Label 15631: @1056301
     /* 1056301 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1056381), // Rule ID 15436 //
     /* 1056306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1056309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1056317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1056320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1056323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056345 */     // MIs[0] round
     /* 1056345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1056358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056380 */     // GIR_Coverage, 15436,
     /* 1056380 */     GIR_EraseRootFromParent_Done,
     /* 1056381 */   // Label 15632: @1056381
     /* 1056381 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1056461), // Rule ID 15437 //
     /* 1056386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1056389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1056397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1056400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1056403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056425 */     // MIs[0] round
     /* 1056425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056435 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1056438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056460 */     // GIR_Coverage, 15437,
     /* 1056460 */     GIR_EraseRootFromParent_Done,
     /* 1056461 */   // Label 15633: @1056461
     /* 1056461 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1056541), // Rule ID 15440 //
     /* 1056466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1056469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1056477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1056480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1056483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056505 */     // MIs[0] round
     /* 1056505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056515 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1056518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056540 */     // GIR_Coverage, 15440,
     /* 1056540 */     GIR_EraseRootFromParent_Done,
     /* 1056541 */   // Label 15634: @1056541
     /* 1056541 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1056621), // Rule ID 15441 //
     /* 1056546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1056549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1056557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1056560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1056563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056585 */     // MIs[0] round
     /* 1056585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056595 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1056598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056620 */     // GIR_Coverage, 15441,
     /* 1056620 */     GIR_EraseRootFromParent_Done,
     /* 1056621 */   // Label 15635: @1056621
     /* 1056621 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1056701), // Rule ID 15444 //
     /* 1056626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1056629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1056637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1056640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1056643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056665 */     // MIs[0] round
     /* 1056665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056675 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1056678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056700 */     // GIR_Coverage, 15444,
     /* 1056700 */     GIR_EraseRootFromParent_Done,
     /* 1056701 */   // Label 15636: @1056701
     /* 1056701 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1056781), // Rule ID 15445 //
     /* 1056706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1056709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1056717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1056720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1056723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056745 */     // MIs[0] round
     /* 1056745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056755 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1056758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1056776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056780 */     // GIR_Coverage, 15445,
     /* 1056780 */     GIR_EraseRootFromParent_Done,
     /* 1056781 */   // Label 15637: @1056781
     /* 1056781 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1056861), // Rule ID 15448 //
     /* 1056786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1056789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1056797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1056800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056825 */     // MIs[0] round
     /* 1056825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1056838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056860 */     // GIR_Coverage, 15448,
     /* 1056860 */     GIR_EraseRootFromParent_Done,
     /* 1056861 */   // Label 15638: @1056861
     /* 1056861 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1056941), // Rule ID 15449 //
     /* 1056866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1056869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1056877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1056880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1056886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1056889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056905 */     // MIs[0] round
     /* 1056905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1056915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1056918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1056924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1056926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1056928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1056939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056940 */     // GIR_Coverage, 15449,
     /* 1056940 */     GIR_EraseRootFromParent_Done,
     /* 1056941 */   // Label 15639: @1056941
     /* 1056941 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1057021), // Rule ID 15452 //
     /* 1056946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1056949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1056954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1056957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1056960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1056966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1056969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1056985 */     // MIs[0] round
     /* 1056985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1056988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056995 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1056995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1056998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057020 */     // GIR_Coverage, 15452,
     /* 1057020 */     GIR_EraseRootFromParent_Done,
     /* 1057021 */   // Label 15640: @1057021
     /* 1057021 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1057101), // Rule ID 15453 //
     /* 1057026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1057029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1057037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1057040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057065 */     // MIs[0] round
     /* 1057065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057075 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1057078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057100 */     // GIR_Coverage, 15453,
     /* 1057100 */     GIR_EraseRootFromParent_Done,
     /* 1057101 */   // Label 15641: @1057101
     /* 1057101 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1057181), // Rule ID 15456 //
     /* 1057106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1057109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057145 */     // MIs[0] round
     /* 1057145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057155 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1057158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057180 */     // GIR_Coverage, 15456,
     /* 1057180 */     GIR_EraseRootFromParent_Done,
     /* 1057181 */   // Label 15642: @1057181
     /* 1057181 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1057261), // Rule ID 15457 //
     /* 1057186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1057189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057225 */     // MIs[0] round
     /* 1057225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057235 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1057238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057260 */     // GIR_Coverage, 15457,
     /* 1057260 */     GIR_EraseRootFromParent_Done,
     /* 1057261 */   // Label 15643: @1057261
     /* 1057261 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1057341), // Rule ID 15460 //
     /* 1057266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1057269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057305 */     // MIs[0] round
     /* 1057305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1057318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057340 */     // GIR_Coverage, 15460,
     /* 1057340 */     GIR_EraseRootFromParent_Done,
     /* 1057341 */   // Label 15644: @1057341
     /* 1057341 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1057421), // Rule ID 15461 //
     /* 1057346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1057349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057385 */     // MIs[0] round
     /* 1057385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1057398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057420 */     // GIR_Coverage, 15461,
     /* 1057420 */     GIR_EraseRootFromParent_Done,
     /* 1057421 */   // Label 15645: @1057421
     /* 1057421 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1057501), // Rule ID 15464 //
     /* 1057426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1057429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057465 */     // MIs[0] round
     /* 1057465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057475 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1057478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057500 */     // GIR_Coverage, 15464,
     /* 1057500 */     GIR_EraseRootFromParent_Done,
     /* 1057501 */   // Label 15646: @1057501
     /* 1057501 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1057581), // Rule ID 15465 //
     /* 1057506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1057509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057545 */     // MIs[0] round
     /* 1057545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1057558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057580 */     // GIR_Coverage, 15465,
     /* 1057580 */     GIR_EraseRootFromParent_Done,
     /* 1057581 */   // Label 15647: @1057581
     /* 1057581 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1057661), // Rule ID 15468 //
     /* 1057586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1057589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057625 */     // MIs[0] round
     /* 1057625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057635 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1057638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057660 */     // GIR_Coverage, 15468,
     /* 1057660 */     GIR_EraseRootFromParent_Done,
     /* 1057661 */   // Label 15648: @1057661
     /* 1057661 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1057741), // Rule ID 15469 //
     /* 1057666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1057669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057705 */     // MIs[0] round
     /* 1057705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1057718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057740 */     // GIR_Coverage, 15469,
     /* 1057740 */     GIR_EraseRootFromParent_Done,
     /* 1057741 */   // Label 15649: @1057741
     /* 1057741 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1057821), // Rule ID 15472 //
     /* 1057746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1057749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1057763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057785 */     // MIs[0] round
     /* 1057785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057795 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1057798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057820 */     // GIR_Coverage, 15472,
     /* 1057820 */     GIR_EraseRootFromParent_Done,
     /* 1057821 */   // Label 15650: @1057821
     /* 1057821 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1057901), // Rule ID 15473 //
     /* 1057826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1057829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1057843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1057846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1057849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057865 */     // MIs[0] round
     /* 1057865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10829:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1057875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1057878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057900 */     // GIR_Coverage, 15473,
     /* 1057900 */     GIR_EraseRootFromParent_Done,
     /* 1057901 */   // Label 15651: @1057901
     /* 1057901 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1057981), // Rule ID 15476 //
     /* 1057906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1057909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1057923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1057926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1057929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1057945 */     // MIs[0] round
     /* 1057945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1057948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057955 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1057955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1057958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1057964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1057966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1057968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1057979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057980 */     // GIR_Coverage, 15476,
     /* 1057980 */     GIR_EraseRootFromParent_Done,
     /* 1057981 */   // Label 15652: @1057981
     /* 1057981 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1058061), // Rule ID 15477 //
     /* 1057986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1057989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1057994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1058003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1058006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1058025 */     // MIs[0] round
     /* 1058025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058035 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10829:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1058038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058060 */     // GIR_Coverage, 15477,
     /* 1058060 */     GIR_EraseRootFromParent_Done,
     /* 1058061 */   // Label 15653: @1058061
     /* 1058061 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1058141), // Rule ID 15480 //
     /* 1058066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1058069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1058074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1058086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1058105 */     // MIs[0] round
     /* 1058105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058115 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1058118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058140 */     // GIR_Coverage, 15480,
     /* 1058140 */     GIR_EraseRootFromParent_Done,
     /* 1058141 */   // Label 15654: @1058141
     /* 1058141 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1058221), // Rule ID 15481 //
     /* 1058146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1058149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1058154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1058166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1058185 */     // MIs[0] round
     /* 1058185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058195 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10829:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1058198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058220 */     // GIR_Coverage, 15481,
     /* 1058220 */     GIR_EraseRootFromParent_Done,
     /* 1058221 */   // Label 15655: @1058221
     /* 1058221 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1058304), // Rule ID 15484 //
     /* 1058226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1058229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1058237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1058240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1058243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1058246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058265 */     // MIs[0] round
     /* 1058265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058275 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1058278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058303 */     // GIR_Coverage, 15484,
     /* 1058303 */     GIR_EraseRootFromParent_Done,
     /* 1058304 */   // Label 15656: @1058304
     /* 1058304 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1058387), // Rule ID 15485 //
     /* 1058309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1058312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1058320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1058323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1058326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1058329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058348 */     // MIs[0] round
     /* 1058348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1058361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058386 */     // GIR_Coverage, 15485,
     /* 1058386 */     GIR_EraseRootFromParent_Done,
     /* 1058387 */   // Label 15657: @1058387
     /* 1058387 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1058470), // Rule ID 15488 //
     /* 1058392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1058395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1058403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1058406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1058409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1058412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058431 */     // MIs[0] round
     /* 1058431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058441 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1058444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058469 */     // GIR_Coverage, 15488,
     /* 1058469 */     GIR_EraseRootFromParent_Done,
     /* 1058470 */   // Label 15658: @1058470
     /* 1058470 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1058553), // Rule ID 15489 //
     /* 1058475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1058478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1058486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1058489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1058492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1058495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058514 */     // MIs[0] round
     /* 1058514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058524 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1058527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058552 */     // GIR_Coverage, 15489,
     /* 1058552 */     GIR_EraseRootFromParent_Done,
     /* 1058553 */   // Label 15659: @1058553
     /* 1058553 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1058636), // Rule ID 15492 //
     /* 1058558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1058561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1058569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1058572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1058575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1058578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058597 */     // MIs[0] round
     /* 1058597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058607 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1058610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058635 */     // GIR_Coverage, 15492,
     /* 1058635 */     GIR_EraseRootFromParent_Done,
     /* 1058636 */   // Label 15660: @1058636
     /* 1058636 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1058719), // Rule ID 15493 //
     /* 1058641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1058644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1058652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1058655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1058658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1058661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058680 */     // MIs[0] round
     /* 1058680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058690 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1058693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1058711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058718 */     // GIR_Coverage, 15493,
     /* 1058718 */     GIR_EraseRootFromParent_Done,
     /* 1058719 */   // Label 15661: @1058719
     /* 1058719 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1058802), // Rule ID 15496 //
     /* 1058724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1058727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1058744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058763 */     // MIs[0] round
     /* 1058763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1058776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058801 */     // GIR_Coverage, 15496,
     /* 1058801 */     GIR_EraseRootFromParent_Done,
     /* 1058802 */   // Label 15662: @1058802
     /* 1058802 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1058885), // Rule ID 15497 //
     /* 1058807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1058810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1058827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058846 */     // MIs[0] round
     /* 1058846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1058856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1058859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058884 */     // GIR_Coverage, 15497,
     /* 1058884 */     GIR_EraseRootFromParent_Done,
     /* 1058885 */   // Label 15663: @1058885
     /* 1058885 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1058968), // Rule ID 15500 //
     /* 1058890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1058893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1058910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1058913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058929 */     // MIs[0] round
     /* 1058929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1058932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1058939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1058942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1058948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1058950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1058952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1058963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1058966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058967 */     // GIR_Coverage, 15500,
     /* 1058967 */     GIR_EraseRootFromParent_Done,
     /* 1058968 */   // Label 15664: @1058968
     /* 1058968 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1059051), // Rule ID 15501 //
     /* 1058973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1058976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1058981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1058993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1058996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059012 */     // MIs[0] round
     /* 1059012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1059025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059050 */     // GIR_Coverage, 15501,
     /* 1059050 */     GIR_EraseRootFromParent_Done,
     /* 1059051 */   // Label 15665: @1059051
     /* 1059051 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1059134), // Rule ID 15504 //
     /* 1059056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1059067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1059070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1059076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059095 */     // MIs[0] round
     /* 1059095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059105 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1059108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059116 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059133 */     // GIR_Coverage, 15504,
     /* 1059133 */     GIR_EraseRootFromParent_Done,
     /* 1059134 */   // Label 15666: @1059134
     /* 1059134 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1059217), // Rule ID 15505 //
     /* 1059139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1059150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1059153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1059159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059178 */     // MIs[0] round
     /* 1059178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1059191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059216 */     // GIR_Coverage, 15505,
     /* 1059216 */     GIR_EraseRootFromParent_Done,
     /* 1059217 */   // Label 15667: @1059217
     /* 1059217 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1059300), // Rule ID 15508 //
     /* 1059222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1059233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1059236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1059239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1059242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059261 */     // MIs[0] round
     /* 1059261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059299 */     // GIR_Coverage, 15508,
     /* 1059299 */     GIR_EraseRootFromParent_Done,
     /* 1059300 */   // Label 15668: @1059300
     /* 1059300 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1059383), // Rule ID 15509 //
     /* 1059305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1059316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1059319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1059322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1059325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059344 */     // MIs[0] round
     /* 1059344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059382 */     // GIR_Coverage, 15509,
     /* 1059382 */     GIR_EraseRootFromParent_Done,
     /* 1059383 */   // Label 15669: @1059383
     /* 1059383 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1059466), // Rule ID 15512 //
     /* 1059388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1059408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059427 */     // MIs[0] round
     /* 1059427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059437 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059465 */     // GIR_Coverage, 15512,
     /* 1059465 */     GIR_EraseRootFromParent_Done,
     /* 1059466 */   // Label 15670: @1059466
     /* 1059466 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1059549), // Rule ID 15513 //
     /* 1059471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1059491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059510 */     // MIs[0] round
     /* 1059510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059548 */     // GIR_Coverage, 15513,
     /* 1059548 */     GIR_EraseRootFromParent_Done,
     /* 1059549 */   // Label 15671: @1059549
     /* 1059549 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1059632), // Rule ID 15516 //
     /* 1059554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1059574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059593 */     // MIs[0] round
     /* 1059593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059603 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059631 */     // GIR_Coverage, 15516,
     /* 1059631 */     GIR_EraseRootFromParent_Done,
     /* 1059632 */   // Label 15672: @1059632
     /* 1059632 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1059715), // Rule ID 15517 //
     /* 1059637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1059657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059676 */     // MIs[0] round
     /* 1059676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1059689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059714 */     // GIR_Coverage, 15517,
     /* 1059714 */     GIR_EraseRootFromParent_Done,
     /* 1059715 */   // Label 15673: @1059715
     /* 1059715 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1059798), // Rule ID 15520 //
     /* 1059720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1059731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1059734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1059737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1059740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059759 */     // MIs[0] round
     /* 1059759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059769 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1059772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059797 */     // GIR_Coverage, 15520,
     /* 1059797 */     GIR_EraseRootFromParent_Done,
     /* 1059798 */   // Label 15674: @1059798
     /* 1059798 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1059881), // Rule ID 15521 //
     /* 1059803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1059814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1059817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1059820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1059823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059842 */     // MIs[0] round
     /* 1059842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1059852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1059855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059880 */     // GIR_Coverage, 15521,
     /* 1059880 */     GIR_EraseRootFromParent_Done,
     /* 1059881 */   // Label 15675: @1059881
     /* 1059881 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1059964), // Rule ID 15524 //
     /* 1059886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1059889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1059897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1059900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1059903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1059906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1059909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059925 */     // MIs[0] round
     /* 1059925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1059928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059935 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1059935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1059938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1059944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1059946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1059948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1059959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1059962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059963 */     // GIR_Coverage, 15524,
     /* 1059963 */     GIR_EraseRootFromParent_Done,
     /* 1059964 */   // Label 15676: @1059964
     /* 1059964 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1060047), // Rule ID 15525 //
     /* 1059969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1059972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1059977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1059980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1059983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1059986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1059989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1059992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060008 */     // MIs[0] round
     /* 1060008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1060021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060046 */     // GIR_Coverage, 15525,
     /* 1060046 */     GIR_EraseRootFromParent_Done,
     /* 1060047 */   // Label 15677: @1060047
     /* 1060047 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1060130), // Rule ID 15528 //
     /* 1060052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1060063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1060066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1060069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1060072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060091 */     // MIs[0] round
     /* 1060091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1060104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060129 */     // GIR_Coverage, 15528,
     /* 1060129 */     GIR_EraseRootFromParent_Done,
     /* 1060130 */   // Label 15678: @1060130
     /* 1060130 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1060213), // Rule ID 15529 //
     /* 1060135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1060146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1060149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1060152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1060155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060174 */     // MIs[0] round
     /* 1060174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060184 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1060187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060212 */     // GIR_Coverage, 15529,
     /* 1060212 */     GIR_EraseRootFromParent_Done,
     /* 1060213 */   // Label 15679: @1060213
     /* 1060213 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1060296), // Rule ID 15532 //
     /* 1060218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1060235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1060238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060257 */     // MIs[0] round
     /* 1060257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1060270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060295 */     // GIR_Coverage, 15532,
     /* 1060295 */     GIR_EraseRootFromParent_Done,
     /* 1060296 */   // Label 15680: @1060296
     /* 1060296 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1060379), // Rule ID 15533 //
     /* 1060301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1060318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1060321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060340 */     // MIs[0] round
     /* 1060340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1060353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060378 */     // GIR_Coverage, 15533,
     /* 1060378 */     GIR_EraseRootFromParent_Done,
     /* 1060379 */   // Label 15681: @1060379
     /* 1060379 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1060462), // Rule ID 15536 //
     /* 1060384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1060401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1060404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060423 */     // MIs[0] round
     /* 1060423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060433 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1060436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060461 */     // GIR_Coverage, 15536,
     /* 1060461 */     GIR_EraseRootFromParent_Done,
     /* 1060462 */   // Label 15682: @1060462
     /* 1060462 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1060545), // Rule ID 15537 //
     /* 1060467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1060484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1060487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060506 */     // MIs[0] round
     /* 1060506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1060519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060544 */     // GIR_Coverage, 15537,
     /* 1060544 */     GIR_EraseRootFromParent_Done,
     /* 1060545 */   // Label 15683: @1060545
     /* 1060545 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1060628), // Rule ID 15540 //
     /* 1060550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1060567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1060570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060589 */     // MIs[0] round
     /* 1060589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060599 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1060602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060627 */     // GIR_Coverage, 15540,
     /* 1060627 */     GIR_EraseRootFromParent_Done,
     /* 1060628 */   // Label 15684: @1060628
     /* 1060628 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1060711), // Rule ID 15541 //
     /* 1060633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1060650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1060653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060672 */     // MIs[0] round
     /* 1060672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060682 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1060685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060710 */     // GIR_Coverage, 15541,
     /* 1060710 */     GIR_EraseRootFromParent_Done,
     /* 1060711 */   // Label 15685: @1060711
     /* 1060711 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1060794), // Rule ID 15544 //
     /* 1060716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1060733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1060736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060755 */     // MIs[0] round
     /* 1060755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1060768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060776 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060793 */     // GIR_Coverage, 15544,
     /* 1060793 */     GIR_EraseRootFromParent_Done,
     /* 1060794 */   // Label 15686: @1060794
     /* 1060794 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1060877), // Rule ID 15545 //
     /* 1060799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1060816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1060819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060838 */     // MIs[0] round
     /* 1060838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1060848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1060851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060876 */     // GIR_Coverage, 15545,
     /* 1060876 */     GIR_EraseRootFromParent_Done,
     /* 1060877 */   // Label 15687: @1060877
     /* 1060877 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1060960), // Rule ID 15548 //
     /* 1060882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1060885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1060902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1060905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060921 */     // MIs[0] round
     /* 1060921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1060924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1060931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1060934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1060940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1060942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1060944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1060955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1060958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060959 */     // GIR_Coverage, 15548,
     /* 1060959 */     GIR_EraseRootFromParent_Done,
     /* 1060960 */   // Label 15688: @1060960
     /* 1060960 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1061043), // Rule ID 15549 //
     /* 1060965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1060968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1060973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1060985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1060988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061004 */     // MIs[0] round
     /* 1061004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1061017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061042 */     // GIR_Coverage, 15549,
     /* 1061042 */     GIR_EraseRootFromParent_Done,
     /* 1061043 */   // Label 15689: @1061043
     /* 1061043 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1061126), // Rule ID 15552 //
     /* 1061048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1061065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1061068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061087 */     // MIs[0] round
     /* 1061087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061097 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1061100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061108 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061125 */     // GIR_Coverage, 15552,
     /* 1061125 */     GIR_EraseRootFromParent_Done,
     /* 1061126 */   // Label 15690: @1061126
     /* 1061126 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1061209), // Rule ID 15553 //
     /* 1061131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1061148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1061151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061170 */     // MIs[0] round
     /* 1061170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1061183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061208 */     // GIR_Coverage, 15553,
     /* 1061208 */     GIR_EraseRootFromParent_Done,
     /* 1061209 */   // Label 15691: @1061209
     /* 1061209 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1061292), // Rule ID 15556 //
     /* 1061214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1061225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1061228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1061234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061253 */     // MIs[0] round
     /* 1061253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061263 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1061266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061274 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061291 */     // GIR_Coverage, 15556,
     /* 1061291 */     GIR_EraseRootFromParent_Done,
     /* 1061292 */   // Label 15692: @1061292
     /* 1061292 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1061375), // Rule ID 15557 //
     /* 1061297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1061308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1061311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1061317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061336 */     // MIs[0] round
     /* 1061336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1061349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061374 */     // GIR_Coverage, 15557,
     /* 1061374 */     GIR_EraseRootFromParent_Done,
     /* 1061375 */   // Label 15693: @1061375
     /* 1061375 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1061458), // Rule ID 15560 //
     /* 1061380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1061391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1061394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1061397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1061400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061419 */     // MIs[0] round
     /* 1061419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1061432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061440 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061457 */     // GIR_Coverage, 15560,
     /* 1061457 */     GIR_EraseRootFromParent_Done,
     /* 1061458 */   // Label 15694: @1061458
     /* 1061458 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1061541), // Rule ID 15561 //
     /* 1061463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1061474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1061477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1061480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1061483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061502 */     // MIs[0] round
     /* 1061502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061512 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1061515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061540 */     // GIR_Coverage, 15561,
     /* 1061540 */     GIR_EraseRootFromParent_Done,
     /* 1061541 */   // Label 15695: @1061541
     /* 1061541 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1061624), // Rule ID 15564 //
     /* 1061546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1061557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1061560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1061563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1061566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061585 */     // MIs[0] round
     /* 1061585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061595 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1061598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061623 */     // GIR_Coverage, 15564,
     /* 1061623 */     GIR_EraseRootFromParent_Done,
     /* 1061624 */   // Label 15696: @1061624
     /* 1061624 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1061707), // Rule ID 15565 //
     /* 1061629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1061640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1061643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1061646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1061649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061668 */     // MIs[0] round
     /* 1061668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061678 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1061681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061706 */     // GIR_Coverage, 15565,
     /* 1061706 */     GIR_EraseRootFromParent_Done,
     /* 1061707 */   // Label 15697: @1061707
     /* 1061707 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1061790), // Rule ID 15568 //
     /* 1061712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1061732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061751 */     // MIs[0] round
     /* 1061751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1061764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061772 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061789 */     // GIR_Coverage, 15568,
     /* 1061789 */     GIR_EraseRootFromParent_Done,
     /* 1061790 */   // Label 15698: @1061790
     /* 1061790 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1061873), // Rule ID 15569 //
     /* 1061795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1061815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061834 */     // MIs[0] round
     /* 1061834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1061844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1061847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061872 */     // GIR_Coverage, 15569,
     /* 1061872 */     GIR_EraseRootFromParent_Done,
     /* 1061873 */   // Label 15699: @1061873
     /* 1061873 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1061956), // Rule ID 15572 //
     /* 1061878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1061881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1061889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1061892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1061898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1061901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1061917 */     // MIs[0] round
     /* 1061917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1061920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1061927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1061930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1061936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1061938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1061940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1061951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1061954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061955 */     // GIR_Coverage, 15572,
     /* 1061955 */     GIR_EraseRootFromParent_Done,
     /* 1061956 */   // Label 15700: @1061956
     /* 1061956 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1062039), // Rule ID 15573 //
     /* 1061961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1061964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1061969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1061972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1061975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1061981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1061984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062000 */     // MIs[0] round
     /* 1062000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062010 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1062013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062038 */     // GIR_Coverage, 15573,
     /* 1062038 */     GIR_EraseRootFromParent_Done,
     /* 1062039 */   // Label 15701: @1062039
     /* 1062039 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1062122), // Rule ID 15576 //
     /* 1062044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062083 */     // MIs[0] round
     /* 1062083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1062096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062121 */     // GIR_Coverage, 15576,
     /* 1062121 */     GIR_EraseRootFromParent_Done,
     /* 1062122 */   // Label 15702: @1062122
     /* 1062122 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1062205), // Rule ID 15577 //
     /* 1062127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062166 */     // MIs[0] round
     /* 1062166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1062179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062204 */     // GIR_Coverage, 15577,
     /* 1062204 */     GIR_EraseRootFromParent_Done,
     /* 1062205 */   // Label 15703: @1062205
     /* 1062205 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1062288), // Rule ID 15580 //
     /* 1062210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1062221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1062224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062249 */     // MIs[0] round
     /* 1062249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062287 */     // GIR_Coverage, 15580,
     /* 1062287 */     GIR_EraseRootFromParent_Done,
     /* 1062288 */   // Label 15704: @1062288
     /* 1062288 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1062371), // Rule ID 15581 //
     /* 1062293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1062304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1062307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062332 */     // MIs[0] round
     /* 1062332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062342 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062370 */     // GIR_Coverage, 15581,
     /* 1062370 */     GIR_EraseRootFromParent_Done,
     /* 1062371 */   // Label 15705: @1062371
     /* 1062371 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1062454), // Rule ID 15584 //
     /* 1062376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062415 */     // MIs[0] round
     /* 1062415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062453 */     // GIR_Coverage, 15584,
     /* 1062453 */     GIR_EraseRootFromParent_Done,
     /* 1062454 */   // Label 15706: @1062454
     /* 1062454 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1062537), // Rule ID 15585 //
     /* 1062459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062498 */     // MIs[0] round
     /* 1062498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062536 */     // GIR_Coverage, 15585,
     /* 1062536 */     GIR_EraseRootFromParent_Done,
     /* 1062537 */   // Label 15707: @1062537
     /* 1062537 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1062620), // Rule ID 15588 //
     /* 1062542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1062559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062581 */     // MIs[0] round
     /* 1062581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062591 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062619 */     // GIR_Coverage, 15588,
     /* 1062619 */     GIR_EraseRootFromParent_Done,
     /* 1062620 */   // Label 15708: @1062620
     /* 1062620 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1062703), // Rule ID 15589 //
     /* 1062625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1062642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062664 */     // MIs[0] round
     /* 1062664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1062677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062702 */     // GIR_Coverage, 15589,
     /* 1062702 */     GIR_EraseRootFromParent_Done,
     /* 1062703 */   // Label 15709: @1062703
     /* 1062703 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1062786), // Rule ID 15592 //
     /* 1062708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1062719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1062722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062747 */     // MIs[0] round
     /* 1062747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1062760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062768 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062785 */     // GIR_Coverage, 15592,
     /* 1062785 */     GIR_EraseRootFromParent_Done,
     /* 1062786 */   // Label 15710: @1062786
     /* 1062786 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1062869), // Rule ID 15593 //
     /* 1062791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1062802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1062805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062830 */     // MIs[0] round
     /* 1062830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1062840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1062843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062868 */     // GIR_Coverage, 15593,
     /* 1062868 */     GIR_EraseRootFromParent_Done,
     /* 1062869 */   // Label 15711: @1062869
     /* 1062869 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1062952), // Rule ID 15596 //
     /* 1062874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1062877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1062885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1062888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1062894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1062897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062913 */     // MIs[0] round
     /* 1062913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062923 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1062923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1062926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1062932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1062934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1062936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1062947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1062950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062951 */     // GIR_Coverage, 15596,
     /* 1062951 */     GIR_EraseRootFromParent_Done,
     /* 1062952 */   // Label 15712: @1062952
     /* 1062952 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1063035), // Rule ID 15597 //
     /* 1062957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1062960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1062965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1062968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1062971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1062977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1062980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1062996 */     // MIs[0] round
     /* 1062996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1062999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1063009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063034 */     // GIR_Coverage, 15597,
     /* 1063034 */     GIR_EraseRootFromParent_Done,
     /* 1063035 */   // Label 15713: @1063035
     /* 1063035 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1063118), // Rule ID 15600 //
     /* 1063040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1063051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1063054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1063057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063079 */     // MIs[0] round
     /* 1063079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063089 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1063092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063117 */     // GIR_Coverage, 15600,
     /* 1063117 */     GIR_EraseRootFromParent_Done,
     /* 1063118 */   // Label 15714: @1063118
     /* 1063118 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1063201), // Rule ID 15601 //
     /* 1063123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1063134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1063137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1063140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063162 */     // MIs[0] round
     /* 1063162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1063175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063200 */     // GIR_Coverage, 15601,
     /* 1063200 */     GIR_EraseRootFromParent_Done,
     /* 1063201 */   // Label 15715: @1063201
     /* 1063201 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1063284), // Rule ID 15604 //
     /* 1063206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1063217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1063220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063245 */     // MIs[0] round
     /* 1063245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063255 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1063258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063283 */     // GIR_Coverage, 15604,
     /* 1063283 */     GIR_EraseRootFromParent_Done,
     /* 1063284 */   // Label 15716: @1063284
     /* 1063284 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1063367), // Rule ID 15605 //
     /* 1063289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1063300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1063303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063328 */     // MIs[0] round
     /* 1063328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1063341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063366 */     // GIR_Coverage, 15605,
     /* 1063366 */     GIR_EraseRootFromParent_Done,
     /* 1063367 */   // Label 15717: @1063367
     /* 1063367 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1063450), // Rule ID 15608 //
     /* 1063372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063411 */     // MIs[0] round
     /* 1063411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063421 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1063424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063449 */     // GIR_Coverage, 15608,
     /* 1063449 */     GIR_EraseRootFromParent_Done,
     /* 1063450 */   // Label 15718: @1063450
     /* 1063450 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1063533), // Rule ID 15609 //
     /* 1063455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063494 */     // MIs[0] round
     /* 1063494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1063507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063532 */     // GIR_Coverage, 15609,
     /* 1063532 */     GIR_EraseRootFromParent_Done,
     /* 1063533 */   // Label 15719: @1063533
     /* 1063533 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1063616), // Rule ID 15612 //
     /* 1063538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1063555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063577 */     // MIs[0] round
     /* 1063577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063587 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1063590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063598 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063615 */     // GIR_Coverage, 15612,
     /* 1063615 */     GIR_EraseRootFromParent_Done,
     /* 1063616 */   // Label 15720: @1063616
     /* 1063616 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1063699), // Rule ID 15613 //
     /* 1063621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1063638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063660 */     // MIs[0] round
     /* 1063660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063670 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1063673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063698 */     // GIR_Coverage, 15613,
     /* 1063698 */     GIR_EraseRootFromParent_Done,
     /* 1063699 */   // Label 15721: @1063699
     /* 1063699 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1063782), // Rule ID 15616 //
     /* 1063704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063743 */     // MIs[0] round
     /* 1063743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1063756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063781 */     // GIR_Coverage, 15616,
     /* 1063781 */     GIR_EraseRootFromParent_Done,
     /* 1063782 */   // Label 15722: @1063782
     /* 1063782 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1063865), // Rule ID 15617 //
     /* 1063787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063826 */     // MIs[0] round
     /* 1063826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1063836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1063839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063864 */     // GIR_Coverage, 15617,
     /* 1063864 */     GIR_EraseRootFromParent_Done,
     /* 1063865 */   // Label 15723: @1063865
     /* 1063865 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1063948), // Rule ID 15620 //
     /* 1063870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1063873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1063890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1063893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063909 */     // MIs[0] round
     /* 1063909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063919 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1063919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1063922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1063928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1063930 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1063932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1063943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1063946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063947 */     // GIR_Coverage, 15620,
     /* 1063947 */     GIR_EraseRootFromParent_Done,
     /* 1063948 */   // Label 15724: @1063948
     /* 1063948 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1064031), // Rule ID 15621 //
     /* 1063953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1063956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1063961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1063973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1063976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1063992 */     // MIs[0] round
     /* 1063992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1063995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1064005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064030 */     // GIR_Coverage, 15621,
     /* 1064030 */     GIR_EraseRootFromParent_Done,
     /* 1064031 */   // Label 15725: @1064031
     /* 1064031 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1064114), // Rule ID 15624 //
     /* 1064036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1064039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1064053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1064056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1064075 */     // MIs[0] round
     /* 1064075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064085 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1064088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064113 */     // GIR_Coverage, 15624,
     /* 1064113 */     GIR_EraseRootFromParent_Done,
     /* 1064114 */   // Label 15726: @1064114
     /* 1064114 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1064197), // Rule ID 15625 //
     /* 1064119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1064122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1064136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1064139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1064158 */     // MIs[0] round
     /* 1064158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1064171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064196 */     // GIR_Coverage, 15625,
     /* 1064196 */     GIR_EraseRootFromParent_Done,
     /* 1064197 */   // Label 15727: @1064197
     /* 1064197 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1064280), // Rule ID 15628 //
     /* 1064202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1064205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1064219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1064222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064241 */     // MIs[0] round
     /* 1064241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1064254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064279 */     // GIR_Coverage, 15628,
     /* 1064279 */     GIR_EraseRootFromParent_Done,
     /* 1064280 */   // Label 15728: @1064280
     /* 1064280 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1064363), // Rule ID 15629 //
     /* 1064285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1064288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1064302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1064305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064324 */     // MIs[0] round
     /* 1064324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1064337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064362 */     // GIR_Coverage, 15629,
     /* 1064362 */     GIR_EraseRootFromParent_Done,
     /* 1064363 */   // Label 15729: @1064363
     /* 1064363 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1064446), // Rule ID 15632 //
     /* 1064368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1064371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1064385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1064388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064407 */     // MIs[0] round
     /* 1064407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1064420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064445 */     // GIR_Coverage, 15632,
     /* 1064445 */     GIR_EraseRootFromParent_Done,
     /* 1064446 */   // Label 15730: @1064446
     /* 1064446 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1064529), // Rule ID 15633 //
     /* 1064451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1064454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1064468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1064471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064490 */     // MIs[0] round
     /* 1064490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1064503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064528 */     // GIR_Coverage, 15633,
     /* 1064528 */     GIR_EraseRootFromParent_Done,
     /* 1064529 */   // Label 15731: @1064529
     /* 1064529 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1064612), // Rule ID 15636 //
     /* 1064534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1064537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1064551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1064554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064573 */     // MIs[0] round
     /* 1064573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064583 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1064586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064594 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064611 */     // GIR_Coverage, 15636,
     /* 1064611 */     GIR_EraseRootFromParent_Done,
     /* 1064612 */   // Label 15732: @1064612
     /* 1064612 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1064695), // Rule ID 15637 //
     /* 1064617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1064620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1064634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1064637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064656 */     // MIs[0] round
     /* 1064656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1064669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064694 */     // GIR_Coverage, 15637,
     /* 1064694 */     GIR_EraseRootFromParent_Done,
     /* 1064695 */   // Label 15733: @1064695
     /* 1064695 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1064778), // Rule ID 15640 //
     /* 1064700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1064703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1064717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1064720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064739 */     // MIs[0] round
     /* 1064739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1064752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064777 */     // GIR_Coverage, 15640,
     /* 1064777 */     GIR_EraseRootFromParent_Done,
     /* 1064778 */   // Label 15734: @1064778
     /* 1064778 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1064861), // Rule ID 15641 //
     /* 1064783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1064786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1064800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1064803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064822 */     // MIs[0] round
     /* 1064822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064832 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1064835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064860 */     // GIR_Coverage, 15641,
     /* 1064860 */     GIR_EraseRootFromParent_Done,
     /* 1064861 */   // Label 15735: @1064861
     /* 1064861 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1064944), // Rule ID 15644 //
     /* 1064866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1064869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1064883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1064886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1064889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1064905 */     // MIs[0] round
     /* 1064905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1064915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1064918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1064924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1064926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1064928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1064936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1064939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1064942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064943 */     // GIR_Coverage, 15644,
     /* 1064943 */     GIR_EraseRootFromParent_Done,
     /* 1064944 */   // Label 15736: @1064944
     /* 1064944 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1065027), // Rule ID 15645 //
     /* 1064949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1064952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1064957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1064966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1064969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1064972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1064988 */     // MIs[0] round
     /* 1064988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1064991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1064998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1065001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065026 */     // GIR_Coverage, 15645,
     /* 1065026 */     GIR_EraseRootFromParent_Done,
     /* 1065027 */   // Label 15737: @1065027
     /* 1065027 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1065110), // Rule ID 15648 //
     /* 1065032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1065035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1065049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1065052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065071 */     // MIs[0] round
     /* 1065071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1065084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065092 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065109 */     // GIR_Coverage, 15648,
     /* 1065109 */     GIR_EraseRootFromParent_Done,
     /* 1065110 */   // Label 15738: @1065110
     /* 1065110 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1065193), // Rule ID 15649 //
     /* 1065115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1065118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1065132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1065135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065154 */     // MIs[0] round
     /* 1065154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1065167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065192 */     // GIR_Coverage, 15649,
     /* 1065192 */     GIR_EraseRootFromParent_Done,
     /* 1065193 */   // Label 15739: @1065193
     /* 1065193 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1065276), // Rule ID 15652 //
     /* 1065198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1065201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1065215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1065218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065237 */     // MIs[0] round
     /* 1065237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065247 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1065250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065275 */     // GIR_Coverage, 15652,
     /* 1065275 */     GIR_EraseRootFromParent_Done,
     /* 1065276 */   // Label 15740: @1065276
     /* 1065276 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1065359), // Rule ID 15653 //
     /* 1065281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1065284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1065298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1065301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065320 */     // MIs[0] round
     /* 1065320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1065333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065358 */     // GIR_Coverage, 15653,
     /* 1065358 */     GIR_EraseRootFromParent_Done,
     /* 1065359 */   // Label 15741: @1065359
     /* 1065359 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1065442), // Rule ID 15656 //
     /* 1065364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1065367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1065381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1065384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065403 */     // MIs[0] round
     /* 1065403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065413 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1065416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065441 */     // GIR_Coverage, 15656,
     /* 1065441 */     GIR_EraseRootFromParent_Done,
     /* 1065442 */   // Label 15742: @1065442
     /* 1065442 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1065525), // Rule ID 15657 //
     /* 1065447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1065450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1065455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1065464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1065467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1065486 */     // MIs[0] round
     /* 1065486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1065499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1065517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1065523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065524 */     // GIR_Coverage, 15657,
     /* 1065524 */     GIR_EraseRootFromParent_Done,
     /* 1065525 */   // Label 15743: @1065525
     /* 1065525 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1065605), // Rule ID 15660 //
     /* 1065530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1065533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1065550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065569 */     // MIs[0] round
     /* 1065569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065579 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1065582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065604 */     // GIR_Coverage, 15660,
     /* 1065604 */     GIR_EraseRootFromParent_Done,
     /* 1065605 */   // Label 15744: @1065605
     /* 1065605 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1065685), // Rule ID 15661 //
     /* 1065610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1065613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1065630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065649 */     // MIs[0] round
     /* 1065649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1065662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065684 */     // GIR_Coverage, 15661,
     /* 1065684 */     GIR_EraseRootFromParent_Done,
     /* 1065685 */   // Label 15745: @1065685
     /* 1065685 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1065765), // Rule ID 15664 //
     /* 1065690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1065693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1065707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1065710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065729 */     // MIs[0] round
     /* 1065729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065739 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1065742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065764 */     // GIR_Coverage, 15664,
     /* 1065764 */     GIR_EraseRootFromParent_Done,
     /* 1065765 */   // Label 15746: @1065765
     /* 1065765 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1065845), // Rule ID 15665 //
     /* 1065770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1065773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1065787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1065790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065809 */     // MIs[0] round
     /* 1065809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065819 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1065822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065844 */     // GIR_Coverage, 15665,
     /* 1065844 */     GIR_EraseRootFromParent_Done,
     /* 1065845 */   // Label 15747: @1065845
     /* 1065845 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1065925), // Rule ID 15668 //
     /* 1065850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1065853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1065867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1065870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1065873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065889 */     // MIs[0] round
     /* 1065889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065899 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1065899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1065902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1065923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065924 */     // GIR_Coverage, 15668,
     /* 1065924 */     GIR_EraseRootFromParent_Done,
     /* 1065925 */   // Label 15748: @1065925
     /* 1065925 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1066005), // Rule ID 15669 //
     /* 1065930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1065933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1065938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1065947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1065950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1065953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065969 */     // MIs[0] round
     /* 1065969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1065972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065979 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1065979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1065982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1065988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1065990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1065992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066004 */     // GIR_Coverage, 15669,
     /* 1066004 */     GIR_EraseRootFromParent_Done,
     /* 1066005 */   // Label 15749: @1066005
     /* 1066005 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1066085), // Rule ID 15672 //
     /* 1066010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1066030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066049 */     // MIs[0] round
     /* 1066049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1066062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066084 */     // GIR_Coverage, 15672,
     /* 1066084 */     GIR_EraseRootFromParent_Done,
     /* 1066085 */   // Label 15750: @1066085
     /* 1066085 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1066165), // Rule ID 15673 //
     /* 1066090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1066110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066129 */     // MIs[0] round
     /* 1066129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1066142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066164 */     // GIR_Coverage, 15673,
     /* 1066164 */     GIR_EraseRootFromParent_Done,
     /* 1066165 */   // Label 15751: @1066165
     /* 1066165 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1066245), // Rule ID 15676 //
     /* 1066170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1066190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066209 */     // MIs[0] round
     /* 1066209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1066222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066244 */     // GIR_Coverage, 15676,
     /* 1066244 */     GIR_EraseRootFromParent_Done,
     /* 1066245 */   // Label 15752: @1066245
     /* 1066245 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1066325), // Rule ID 15677 //
     /* 1066250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1066270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066289 */     // MIs[0] round
     /* 1066289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066299 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1066302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066324 */     // GIR_Coverage, 15677,
     /* 1066324 */     GIR_EraseRootFromParent_Done,
     /* 1066325 */   // Label 15753: @1066325
     /* 1066325 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1066405), // Rule ID 15680 //
     /* 1066330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1066350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066369 */     // MIs[0] round
     /* 1066369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1066382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066404 */     // GIR_Coverage, 15680,
     /* 1066404 */     GIR_EraseRootFromParent_Done,
     /* 1066405 */   // Label 15754: @1066405
     /* 1066405 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1066485), // Rule ID 15681 //
     /* 1066410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1066430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066449 */     // MIs[0] round
     /* 1066449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1066462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066484 */     // GIR_Coverage, 15681,
     /* 1066484 */     GIR_EraseRootFromParent_Done,
     /* 1066485 */   // Label 15755: @1066485
     /* 1066485 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1066565), // Rule ID 15684 //
     /* 1066490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1066510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066529 */     // MIs[0] round
     /* 1066529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066564 */     // GIR_Coverage, 15684,
     /* 1066564 */     GIR_EraseRootFromParent_Done,
     /* 1066565 */   // Label 15756: @1066565
     /* 1066565 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1066645), // Rule ID 15685 //
     /* 1066570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1066590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066609 */     // MIs[0] round
     /* 1066609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066644 */     // GIR_Coverage, 15685,
     /* 1066644 */     GIR_EraseRootFromParent_Done,
     /* 1066645 */   // Label 15757: @1066645
     /* 1066645 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1066725), // Rule ID 15688 //
     /* 1066650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1066670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066689 */     // MIs[0] round
     /* 1066689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066724 */     // GIR_Coverage, 15688,
     /* 1066724 */     GIR_EraseRootFromParent_Done,
     /* 1066725 */   // Label 15758: @1066725
     /* 1066725 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1066805), // Rule ID 15689 //
     /* 1066730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1066750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066769 */     // MIs[0] round
     /* 1066769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066804 */     // GIR_Coverage, 15689,
     /* 1066804 */     GIR_EraseRootFromParent_Done,
     /* 1066805 */   // Label 15759: @1066805
     /* 1066805 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1066885), // Rule ID 15692 //
     /* 1066810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1066813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1066830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066849 */     // MIs[0] round
     /* 1066849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066859 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1066859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066884 */     // GIR_Coverage, 15692,
     /* 1066884 */     GIR_EraseRootFromParent_Done,
     /* 1066885 */   // Label 15760: @1066885
     /* 1066885 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1066965), // Rule ID 15693 //
     /* 1066890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1066893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1066910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1066913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066929 */     // MIs[0] round
     /* 1066929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1066932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1066939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1066942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1066948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1066950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1066952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1066963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066964 */     // GIR_Coverage, 15693,
     /* 1066964 */     GIR_EraseRootFromParent_Done,
     /* 1066965 */   // Label 15761: @1066965
     /* 1066965 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1067045), // Rule ID 15696 //
     /* 1066970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1066973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1066978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1066981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1066984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1066987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1066990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1066993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067009 */     // MIs[0] round
     /* 1067009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1067022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1067040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067044 */     // GIR_Coverage, 15696,
     /* 1067044 */     GIR_EraseRootFromParent_Done,
     /* 1067045 */   // Label 15762: @1067045
     /* 1067045 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1067125), // Rule ID 15697 //
     /* 1067050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1067053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1067061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1067064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1067070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067089 */     // MIs[0] round
     /* 1067089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067099 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1067102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1067120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067124 */     // GIR_Coverage, 15697,
     /* 1067124 */     GIR_EraseRootFromParent_Done,
     /* 1067125 */   // Label 15763: @1067125
     /* 1067125 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1067205), // Rule ID 15700 //
     /* 1067130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1067141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1067144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1067147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1067150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067169 */     // MIs[0] round
     /* 1067169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1067182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067204 */     // GIR_Coverage, 15700,
     /* 1067204 */     GIR_EraseRootFromParent_Done,
     /* 1067205 */   // Label 15764: @1067205
     /* 1067205 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1067285), // Rule ID 15701 //
     /* 1067210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1067213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1067221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1067224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1067227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1067230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067249 */     // MIs[0] round
     /* 1067249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1067262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067284 */     // GIR_Coverage, 15701,
     /* 1067284 */     GIR_EraseRootFromParent_Done,
     /* 1067285 */   // Label 15765: @1067285
     /* 1067285 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1067365), // Rule ID 15704 //
     /* 1067290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1067301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1067304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1067307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1067310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067329 */     // MIs[0] round
     /* 1067329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067339 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1067342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067364 */     // GIR_Coverage, 15704,
     /* 1067364 */     GIR_EraseRootFromParent_Done,
     /* 1067365 */   // Label 15766: @1067365
     /* 1067365 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1067445), // Rule ID 15705 //
     /* 1067370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1067373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1067381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1067384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1067387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1067390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067409 */     // MIs[0] round
     /* 1067409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067419 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1067422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067444 */     // GIR_Coverage, 15705,
     /* 1067444 */     GIR_EraseRootFromParent_Done,
     /* 1067445 */   // Label 15767: @1067445
     /* 1067445 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1067525), // Rule ID 15708 //
     /* 1067450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1067461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1067464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1067467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1067470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067489 */     // MIs[0] round
     /* 1067489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067499 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1067502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067524 */     // GIR_Coverage, 15708,
     /* 1067524 */     GIR_EraseRootFromParent_Done,
     /* 1067525 */   // Label 15768: @1067525
     /* 1067525 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1067605), // Rule ID 15709 //
     /* 1067530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1067533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1067541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1067544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1067547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1067550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067569 */     // MIs[0] round
     /* 1067569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067579 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1067582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067604 */     // GIR_Coverage, 15709,
     /* 1067604 */     GIR_EraseRootFromParent_Done,
     /* 1067605 */   // Label 15769: @1067605
     /* 1067605 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1067685), // Rule ID 15712 //
     /* 1067610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1067630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067649 */     // MIs[0] round
     /* 1067649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1067662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067684 */     // GIR_Coverage, 15712,
     /* 1067684 */     GIR_EraseRootFromParent_Done,
     /* 1067685 */   // Label 15770: @1067685
     /* 1067685 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1067765), // Rule ID 15713 //
     /* 1067690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1067693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1067710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067729 */     // MIs[0] round
     /* 1067729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1067742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067764 */     // GIR_Coverage, 15713,
     /* 1067764 */     GIR_EraseRootFromParent_Done,
     /* 1067765 */   // Label 15771: @1067765
     /* 1067765 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1067845), // Rule ID 15716 //
     /* 1067770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1067790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067809 */     // MIs[0] round
     /* 1067809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067819 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1067822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067844 */     // GIR_Coverage, 15716,
     /* 1067844 */     GIR_EraseRootFromParent_Done,
     /* 1067845 */   // Label 15772: @1067845
     /* 1067845 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1067925), // Rule ID 15717 //
     /* 1067850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1067853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1067870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1067873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067889 */     // MIs[0] round
     /* 1067889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067899 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1067899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1067902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1067923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067924 */     // GIR_Coverage, 15717,
     /* 1067924 */     GIR_EraseRootFromParent_Done,
     /* 1067925 */   // Label 15773: @1067925
     /* 1067925 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1068005), // Rule ID 15720 //
     /* 1067930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1067933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1067938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1067941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1067944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1067947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1067950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1067953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067969 */     // MIs[0] round
     /* 1067969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1067972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067979 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1067979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1067982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1067988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1067990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1067992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068004 */     // GIR_Coverage, 15720,
     /* 1068004 */     GIR_EraseRootFromParent_Done,
     /* 1068005 */   // Label 15774: @1068005
     /* 1068005 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1068085), // Rule ID 15721 //
     /* 1068010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1068013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1068021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1068024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1068030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068049 */     // MIs[0] round
     /* 1068049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068059 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1068062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068084 */     // GIR_Coverage, 15721,
     /* 1068084 */     GIR_EraseRootFromParent_Done,
     /* 1068085 */   // Label 15775: @1068085
     /* 1068085 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1068165), // Rule ID 15724 //
     /* 1068090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1068093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1068107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1068110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068129 */     // MIs[0] round
     /* 1068129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1068142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068164 */     // GIR_Coverage, 15724,
     /* 1068164 */     GIR_EraseRootFromParent_Done,
     /* 1068165 */   // Label 15776: @1068165
     /* 1068165 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1068245), // Rule ID 15725 //
     /* 1068170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1068173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1068187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1068190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068209 */     // MIs[0] round
     /* 1068209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1068222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068244 */     // GIR_Coverage, 15725,
     /* 1068244 */     GIR_EraseRootFromParent_Done,
     /* 1068245 */   // Label 15777: @1068245
     /* 1068245 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1068325), // Rule ID 15728 //
     /* 1068250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1068253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1068270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068289 */     // MIs[0] round
     /* 1068289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068299 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1068302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068324 */     // GIR_Coverage, 15728,
     /* 1068324 */     GIR_EraseRootFromParent_Done,
     /* 1068325 */   // Label 15778: @1068325
     /* 1068325 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1068405), // Rule ID 15729 //
     /* 1068330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1068333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1068350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068369 */     // MIs[0] round
     /* 1068369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1068382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068404 */     // GIR_Coverage, 15729,
     /* 1068404 */     GIR_EraseRootFromParent_Done,
     /* 1068405 */   // Label 15779: @1068405
     /* 1068405 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1068485), // Rule ID 15732 //
     /* 1068410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1068413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1068427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1068430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068449 */     // MIs[0] round
     /* 1068449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1068462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068484 */     // GIR_Coverage, 15732,
     /* 1068484 */     GIR_EraseRootFromParent_Done,
     /* 1068485 */   // Label 15780: @1068485
     /* 1068485 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1068565), // Rule ID 15733 //
     /* 1068490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1068493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1068507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1068510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068529 */     // MIs[0] round
     /* 1068529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1068542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068564 */     // GIR_Coverage, 15733,
     /* 1068564 */     GIR_EraseRootFromParent_Done,
     /* 1068565 */   // Label 15781: @1068565
     /* 1068565 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1068645), // Rule ID 15736 //
     /* 1068570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1068573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1068581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1068584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1068587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1068590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068609 */     // MIs[0] round
     /* 1068609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1068622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1068640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068644 */     // GIR_Coverage, 15736,
     /* 1068644 */     GIR_EraseRootFromParent_Done,
     /* 1068645 */   // Label 15782: @1068645
     /* 1068645 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1068725), // Rule ID 15737 //
     /* 1068650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1068653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1068661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1068664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1068667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1068670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068689 */     // MIs[0] round
     /* 1068689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1068702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1068720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068724 */     // GIR_Coverage, 15737,
     /* 1068724 */     GIR_EraseRootFromParent_Done,
     /* 1068725 */   // Label 15783: @1068725
     /* 1068725 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1068805), // Rule ID 15740 //
     /* 1068730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1068733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1068741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1068744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1068750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068769 */     // MIs[0] round
     /* 1068769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068779 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1068782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1068800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068804 */     // GIR_Coverage, 15740,
     /* 1068804 */     GIR_EraseRootFromParent_Done,
     /* 1068805 */   // Label 15784: @1068805
     /* 1068805 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1068885), // Rule ID 15741 //
     /* 1068810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1068813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1068821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1068824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1068830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068849 */     // MIs[0] round
     /* 1068849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1068859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1068862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1068880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068884 */     // GIR_Coverage, 15741,
     /* 1068884 */     GIR_EraseRootFromParent_Done,
     /* 1068885 */   // Label 15785: @1068885
     /* 1068885 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1068965), // Rule ID 15744 //
     /* 1068890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1068893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1068901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1068904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1068910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1068913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068929 */     // MIs[0] round
     /* 1068929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1068932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1068939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1068942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1068948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1068950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1068952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1068960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1068963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068964 */     // GIR_Coverage, 15744,
     /* 1068964 */     GIR_EraseRootFromParent_Done,
     /* 1068965 */   // Label 15786: @1068965
     /* 1068965 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1069045), // Rule ID 15745 //
     /* 1068970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1068973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1068978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1068981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1068984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1068990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1068993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069009 */     // MIs[0] round
     /* 1069009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1069022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1069040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069044 */     // GIR_Coverage, 15745,
     /* 1069044 */     GIR_EraseRootFromParent_Done,
     /* 1069045 */   // Label 15787: @1069045
     /* 1069045 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1069125), // Rule ID 15748 //
     /* 1069050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1069067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069089 */     // MIs[0] round
     /* 1069089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1069102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069124 */     // GIR_Coverage, 15748,
     /* 1069124 */     GIR_EraseRootFromParent_Done,
     /* 1069125 */   // Label 15788: @1069125
     /* 1069125 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1069205), // Rule ID 15749 //
     /* 1069130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1069147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069169 */     // MIs[0] round
     /* 1069169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069179 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1069182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069204 */     // GIR_Coverage, 15749,
     /* 1069204 */     GIR_EraseRootFromParent_Done,
     /* 1069205 */   // Label 15789: @1069205
     /* 1069205 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1069285), // Rule ID 15752 //
     /* 1069210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1069227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069249 */     // MIs[0] round
     /* 1069249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069259 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1069262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069284 */     // GIR_Coverage, 15752,
     /* 1069284 */     GIR_EraseRootFromParent_Done,
     /* 1069285 */   // Label 15790: @1069285
     /* 1069285 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1069365), // Rule ID 15753 //
     /* 1069290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1069307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069329 */     // MIs[0] round
     /* 1069329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069339 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1069342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069364 */     // GIR_Coverage, 15753,
     /* 1069364 */     GIR_EraseRootFromParent_Done,
     /* 1069365 */   // Label 15791: @1069365
     /* 1069365 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1069445), // Rule ID 15756 //
     /* 1069370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1069387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069409 */     // MIs[0] round
     /* 1069409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069444 */     // GIR_Coverage, 15756,
     /* 1069444 */     GIR_EraseRootFromParent_Done,
     /* 1069445 */   // Label 15792: @1069445
     /* 1069445 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1069525), // Rule ID 15757 //
     /* 1069450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1069467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069489 */     // MIs[0] round
     /* 1069489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069499 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069524 */     // GIR_Coverage, 15757,
     /* 1069524 */     GIR_EraseRootFromParent_Done,
     /* 1069525 */   // Label 15793: @1069525
     /* 1069525 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1069605), // Rule ID 15760 //
     /* 1069530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069569 */     // MIs[0] round
     /* 1069569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1069582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069604 */     // GIR_Coverage, 15760,
     /* 1069604 */     GIR_EraseRootFromParent_Done,
     /* 1069605 */   // Label 15794: @1069605
     /* 1069605 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1069685), // Rule ID 15761 //
     /* 1069610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069649 */     // MIs[0] round
     /* 1069649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1069662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069684 */     // GIR_Coverage, 15761,
     /* 1069684 */     GIR_EraseRootFromParent_Done,
     /* 1069685 */   // Label 15795: @1069685
     /* 1069685 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1069765), // Rule ID 15764 //
     /* 1069690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069729 */     // MIs[0] round
     /* 1069729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069764 */     // GIR_Coverage, 15764,
     /* 1069764 */     GIR_EraseRootFromParent_Done,
     /* 1069765 */   // Label 15796: @1069765
     /* 1069765 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1069845), // Rule ID 15765 //
     /* 1069770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069809 */     // MIs[0] round
     /* 1069809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069844 */     // GIR_Coverage, 15765,
     /* 1069844 */     GIR_EraseRootFromParent_Done,
     /* 1069845 */   // Label 15797: @1069845
     /* 1069845 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1069925), // Rule ID 15768 //
     /* 1069850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1069853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1069870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1069873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069889 */     // MIs[0] round
     /* 1069889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1069899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1069923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069924 */     // GIR_Coverage, 15768,
     /* 1069924 */     GIR_EraseRootFromParent_Done,
     /* 1069925 */   // Label 15798: @1069925
     /* 1069925 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1070005), // Rule ID 15769 //
     /* 1069930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1069933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1069938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1069950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1069953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1069969 */     // MIs[0] round
     /* 1069969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1069972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1069979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1069982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1069988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1069990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1069992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070004 */     // GIR_Coverage, 15769,
     /* 1070004 */     GIR_EraseRootFromParent_Done,
     /* 1070005 */   // Label 15799: @1070005
     /* 1070005 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1070085), // Rule ID 15772 //
     /* 1070010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1070021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1070024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1070027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070049 */     // MIs[0] round
     /* 1070049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070084 */     // GIR_Coverage, 15772,
     /* 1070084 */     GIR_EraseRootFromParent_Done,
     /* 1070085 */   // Label 15800: @1070085
     /* 1070085 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1070165), // Rule ID 15773 //
     /* 1070090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1070093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1070101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1070104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1070107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070129 */     // MIs[0] round
     /* 1070129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070139 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070164 */     // GIR_Coverage, 15773,
     /* 1070164 */     GIR_EraseRootFromParent_Done,
     /* 1070165 */   // Label 15801: @1070165
     /* 1070165 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1070245), // Rule ID 15776 //
     /* 1070170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1070187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070209 */     // MIs[0] round
     /* 1070209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070219 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070244 */     // GIR_Coverage, 15776,
     /* 1070244 */     GIR_EraseRootFromParent_Done,
     /* 1070245 */   // Label 15802: @1070245
     /* 1070245 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1070325), // Rule ID 15777 //
     /* 1070250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1070253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1070267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070289 */     // MIs[0] round
     /* 1070289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070324 */     // GIR_Coverage, 15777,
     /* 1070324 */     GIR_EraseRootFromParent_Done,
     /* 1070325 */   // Label 15803: @1070325
     /* 1070325 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1070405), // Rule ID 15780 //
     /* 1070330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070369 */     // MIs[0] round
     /* 1070369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070404 */     // GIR_Coverage, 15780,
     /* 1070404 */     GIR_EraseRootFromParent_Done,
     /* 1070405 */   // Label 15804: @1070405
     /* 1070405 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1070485), // Rule ID 15781 //
     /* 1070410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1070413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070449 */     // MIs[0] round
     /* 1070449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070484 */     // GIR_Coverage, 15781,
     /* 1070484 */     GIR_EraseRootFromParent_Done,
     /* 1070485 */   // Label 15805: @1070485
     /* 1070485 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1070565), // Rule ID 15784 //
     /* 1070490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1070493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1070501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1070504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070529 */     // MIs[0] round
     /* 1070529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070539 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1070560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070564 */     // GIR_Coverage, 15784,
     /* 1070564 */     GIR_EraseRootFromParent_Done,
     /* 1070565 */   // Label 15806: @1070565
     /* 1070565 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1070645), // Rule ID 15785 //
     /* 1070570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1070573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1070581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1070584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070609 */     // MIs[0] round
     /* 1070609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070619 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1070622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1070640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070644 */     // GIR_Coverage, 15785,
     /* 1070644 */     GIR_EraseRootFromParent_Done,
     /* 1070645 */   // Label 15807: @1070645
     /* 1070645 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1070725), // Rule ID 15788 //
     /* 1070650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1070667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070689 */     // MIs[0] round
     /* 1070689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1070702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070724 */     // GIR_Coverage, 15788,
     /* 1070724 */     GIR_EraseRootFromParent_Done,
     /* 1070725 */   // Label 15808: @1070725
     /* 1070725 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1070805), // Rule ID 15789 //
     /* 1070730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1070733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1070747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070769 */     // MIs[0] round
     /* 1070769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070779 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1070782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070804 */     // GIR_Coverage, 15789,
     /* 1070804 */     GIR_EraseRootFromParent_Done,
     /* 1070805 */   // Label 15809: @1070805
     /* 1070805 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1070885), // Rule ID 15792 //
     /* 1070810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1070827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070849 */     // MIs[0] round
     /* 1070849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070859 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1070859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1070862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070884 */     // GIR_Coverage, 15792,
     /* 1070884 */     GIR_EraseRootFromParent_Done,
     /* 1070885 */   // Label 15810: @1070885
     /* 1070885 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1070965), // Rule ID 15793 //
     /* 1070890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1070893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1070907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1070910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1070913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1070929 */     // MIs[0] round
     /* 1070929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1070932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070939 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1070939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1070942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1070948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1070950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1070952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1070963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070964 */     // GIR_Coverage, 15793,
     /* 1070964 */     GIR_EraseRootFromParent_Done,
     /* 1070965 */   // Label 15811: @1070965
     /* 1070965 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1071045), // Rule ID 15796 //
     /* 1070970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1070973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1070978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1070981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1070984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1070987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1070990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1070993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071009 */     // MIs[0] round
     /* 1071009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071019 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1071022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071044 */     // GIR_Coverage, 15796,
     /* 1071044 */     GIR_EraseRootFromParent_Done,
     /* 1071045 */   // Label 15812: @1071045
     /* 1071045 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1071125), // Rule ID 15797 //
     /* 1071050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1071061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1071064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1071067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071089 */     // MIs[0] round
     /* 1071089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1071102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071124 */     // GIR_Coverage, 15797,
     /* 1071124 */     GIR_EraseRootFromParent_Done,
     /* 1071125 */   // Label 15813: @1071125
     /* 1071125 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1071205), // Rule ID 15800 //
     /* 1071130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1071147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071169 */     // MIs[0] round
     /* 1071169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1071182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071204 */     // GIR_Coverage, 15800,
     /* 1071204 */     GIR_EraseRootFromParent_Done,
     /* 1071205 */   // Label 15814: @1071205
     /* 1071205 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1071285), // Rule ID 15801 //
     /* 1071210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1071227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071249 */     // MIs[0] round
     /* 1071249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1071262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071284 */     // GIR_Coverage, 15801,
     /* 1071284 */     GIR_EraseRootFromParent_Done,
     /* 1071285 */   // Label 15815: @1071285
     /* 1071285 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1071365), // Rule ID 15804 //
     /* 1071290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1071307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071329 */     // MIs[0] round
     /* 1071329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071339 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1071342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071364 */     // GIR_Coverage, 15804,
     /* 1071364 */     GIR_EraseRootFromParent_Done,
     /* 1071365 */   // Label 15816: @1071365
     /* 1071365 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1071445), // Rule ID 15805 //
     /* 1071370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1071387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071409 */     // MIs[0] round
     /* 1071409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1071422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071444 */     // GIR_Coverage, 15805,
     /* 1071444 */     GIR_EraseRootFromParent_Done,
     /* 1071445 */   // Label 15817: @1071445
     /* 1071445 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1071525), // Rule ID 15808 //
     /* 1071450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1071461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1071464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1071467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071489 */     // MIs[0] round
     /* 1071489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1071502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071524 */     // GIR_Coverage, 15808,
     /* 1071524 */     GIR_EraseRootFromParent_Done,
     /* 1071525 */   // Label 15818: @1071525
     /* 1071525 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1071605), // Rule ID 15809 //
     /* 1071530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1071541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1071544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1071547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071569 */     // MIs[0] round
     /* 1071569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071579 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1071582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071604 */     // GIR_Coverage, 15809,
     /* 1071604 */     GIR_EraseRootFromParent_Done,
     /* 1071605 */   // Label 15819: @1071605
     /* 1071605 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1071685), // Rule ID 15812 //
     /* 1071610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071649 */     // MIs[0] round
     /* 1071649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1071662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071684 */     // GIR_Coverage, 15812,
     /* 1071684 */     GIR_EraseRootFromParent_Done,
     /* 1071685 */   // Label 15820: @1071685
     /* 1071685 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1071765), // Rule ID 15813 //
     /* 1071690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071729 */     // MIs[0] round
     /* 1071729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1071742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071764 */     // GIR_Coverage, 15813,
     /* 1071764 */     GIR_EraseRootFromParent_Done,
     /* 1071765 */   // Label 15821: @1071765
     /* 1071765 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1071845), // Rule ID 15816 //
     /* 1071770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071809 */     // MIs[0] round
     /* 1071809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1071822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071844 */     // GIR_Coverage, 15816,
     /* 1071844 */     GIR_EraseRootFromParent_Done,
     /* 1071845 */   // Label 15822: @1071845
     /* 1071845 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1071925), // Rule ID 15817 //
     /* 1071850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1071870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1071873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071889 */     // MIs[0] round
     /* 1071889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071899 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1071899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1071902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1071923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071924 */     // GIR_Coverage, 15817,
     /* 1071924 */     GIR_EraseRootFromParent_Done,
     /* 1071925 */   // Label 15823: @1071925
     /* 1071925 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1072005), // Rule ID 15820 //
     /* 1071930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1071938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1071941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1071944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1071950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1071953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1071969 */     // MIs[0] round
     /* 1071969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1071972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071979 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1071979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1071982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1071988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1071990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1071992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072004 */     // GIR_Coverage, 15820,
     /* 1072004 */     GIR_EraseRootFromParent_Done,
     /* 1072005 */   // Label 15824: @1072005
     /* 1072005 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1072085), // Rule ID 15821 //
     /* 1072010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1072021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1072024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1072027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1072030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072049 */     // MIs[0] round
     /* 1072049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1072062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072084 */     // GIR_Coverage, 15821,
     /* 1072084 */     GIR_EraseRootFromParent_Done,
     /* 1072085 */   // Label 15825: @1072085
     /* 1072085 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1072165), // Rule ID 15824 //
     /* 1072090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1072101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1072104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1072107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1072110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072129 */     // MIs[0] round
     /* 1072129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1072142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072164 */     // GIR_Coverage, 15824,
     /* 1072164 */     GIR_EraseRootFromParent_Done,
     /* 1072165 */   // Label 15826: @1072165
     /* 1072165 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1072245), // Rule ID 15825 //
     /* 1072170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1072181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1072184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1072187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1072190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072209 */     // MIs[0] round
     /* 1072209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1072222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072244 */     // GIR_Coverage, 15825,
     /* 1072244 */     GIR_EraseRootFromParent_Done,
     /* 1072245 */   // Label 15827: @1072245
     /* 1072245 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1072325), // Rule ID 15828 //
     /* 1072250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1072261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1072264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1072267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1072270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072289 */     // MIs[0] round
     /* 1072289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1072302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072324 */     // GIR_Coverage, 15828,
     /* 1072324 */     GIR_EraseRootFromParent_Done,
     /* 1072325 */   // Label 15828: @1072325
     /* 1072325 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1072405), // Rule ID 15829 //
     /* 1072330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1072341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1072344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1072347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1072350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072369 */     // MIs[0] round
     /* 1072369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1072382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072404 */     // GIR_Coverage, 15829,
     /* 1072404 */     GIR_EraseRootFromParent_Done,
     /* 1072405 */   // Label 15829: @1072405
     /* 1072405 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1072485), // Rule ID 15832 //
     /* 1072410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1072421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1072424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1072427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1072430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072449 */     // MIs[0] round
     /* 1072449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072459 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1072462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072484 */     // GIR_Coverage, 15832,
     /* 1072484 */     GIR_EraseRootFromParent_Done,
     /* 1072485 */   // Label 15830: @1072485
     /* 1072485 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1072565), // Rule ID 15833 //
     /* 1072490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1072498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1072501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1072504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1072507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1072510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1072529 */     // MIs[0] round
     /* 1072529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1072542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072564 */     // GIR_Coverage, 15833,
     /* 1072564 */     GIR_EraseRootFromParent_Done,
     /* 1072565 */   // Label 15831: @1072565
     /* 1072565 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1072645), // Rule ID 15924 //
     /* 1072570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1072581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1072584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1072587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1072590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072609 */     // MIs[0] round
     /* 1072609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1072622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072644 */     // GIR_Coverage, 15924,
     /* 1072644 */     GIR_EraseRootFromParent_Done,
     /* 1072645 */   // Label 15832: @1072645
     /* 1072645 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1072725), // Rule ID 15925 //
     /* 1072650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1072661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1072664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1072667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1072670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072689 */     // MIs[0] round
     /* 1072689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072699 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1072702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072724 */     // GIR_Coverage, 15925,
     /* 1072724 */     GIR_EraseRootFromParent_Done,
     /* 1072725 */   // Label 15833: @1072725
     /* 1072725 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1072805), // Rule ID 15928 //
     /* 1072730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1072747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1072750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072769 */     // MIs[0] round
     /* 1072769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072779 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1072782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072804 */     // GIR_Coverage, 15928,
     /* 1072804 */     GIR_EraseRootFromParent_Done,
     /* 1072805 */   // Label 15834: @1072805
     /* 1072805 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1072885), // Rule ID 15929 //
     /* 1072810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1072827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1072830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072849 */     // MIs[0] round
     /* 1072849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072859 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1072859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1072862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072884 */     // GIR_Coverage, 15929,
     /* 1072884 */     GIR_EraseRootFromParent_Done,
     /* 1072885 */   // Label 15835: @1072885
     /* 1072885 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1072965), // Rule ID 15932 //
     /* 1072890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1072907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1072910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1072913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072929 */     // MIs[0] round
     /* 1072929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1072932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1072939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1072942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1072948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1072950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1072952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1072963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072964 */     // GIR_Coverage, 15932,
     /* 1072964 */     GIR_EraseRootFromParent_Done,
     /* 1072965 */   // Label 15836: @1072965
     /* 1072965 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1073045), // Rule ID 15933 //
     /* 1072970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1072978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1072987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1072990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1072993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073009 */     // MIs[0] round
     /* 1073009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1073022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073044 */     // GIR_Coverage, 15933,
     /* 1073044 */     GIR_EraseRootFromParent_Done,
     /* 1073045 */   // Label 15837: @1073045
     /* 1073045 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1073125), // Rule ID 15936 //
     /* 1073050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1073061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1073064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1073067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1073070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073089 */     // MIs[0] round
     /* 1073089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073099 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1073102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073124 */     // GIR_Coverage, 15936,
     /* 1073124 */     GIR_EraseRootFromParent_Done,
     /* 1073125 */   // Label 15838: @1073125
     /* 1073125 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1073205), // Rule ID 15937 //
     /* 1073130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1073141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1073144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1073147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1073150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073169 */     // MIs[0] round
     /* 1073169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073179 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1073182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073204 */     // GIR_Coverage, 15937,
     /* 1073204 */     GIR_EraseRootFromParent_Done,
     /* 1073205 */   // Label 15839: @1073205
     /* 1073205 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1073285), // Rule ID 15940 //
     /* 1073210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1073221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1073224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1073227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1073230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073249 */     // MIs[0] round
     /* 1073249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1073262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073284 */     // GIR_Coverage, 15940,
     /* 1073284 */     GIR_EraseRootFromParent_Done,
     /* 1073285 */   // Label 15840: @1073285
     /* 1073285 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1073365), // Rule ID 15941 //
     /* 1073290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1073301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1073304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1073307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1073310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073329 */     // MIs[0] round
     /* 1073329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1073342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073364 */     // GIR_Coverage, 15941,
     /* 1073364 */     GIR_EraseRootFromParent_Done,
     /* 1073365 */   // Label 15841: @1073365
     /* 1073365 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1073445), // Rule ID 15944 //
     /* 1073370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1073387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1073390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073409 */     // MIs[0] round
     /* 1073409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1073422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073444 */     // GIR_Coverage, 15944,
     /* 1073444 */     GIR_EraseRootFromParent_Done,
     /* 1073445 */   // Label 15842: @1073445
     /* 1073445 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1073525), // Rule ID 15945 //
     /* 1073450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1073467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1073470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073489 */     // MIs[0] round
     /* 1073489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1073502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073524 */     // GIR_Coverage, 15945,
     /* 1073524 */     GIR_EraseRootFromParent_Done,
     /* 1073525 */   // Label 15843: @1073525
     /* 1073525 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1073605), // Rule ID 15948 //
     /* 1073530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1073541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1073544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1073547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1073550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073569 */     // MIs[0] round
     /* 1073569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073579 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073604 */     // GIR_Coverage, 15948,
     /* 1073604 */     GIR_EraseRootFromParent_Done,
     /* 1073605 */   // Label 15844: @1073605
     /* 1073605 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1073685), // Rule ID 15949 //
     /* 1073610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1073621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1073624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1073627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1073630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073649 */     // MIs[0] round
     /* 1073649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073684 */     // GIR_Coverage, 15949,
     /* 1073684 */     GIR_EraseRootFromParent_Done,
     /* 1073685 */   // Label 15845: @1073685
     /* 1073685 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1073765), // Rule ID 15952 //
     /* 1073690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1073707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1073710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073729 */     // MIs[0] round
     /* 1073729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073764 */     // GIR_Coverage, 15952,
     /* 1073764 */     GIR_EraseRootFromParent_Done,
     /* 1073765 */   // Label 15846: @1073765
     /* 1073765 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1073845), // Rule ID 15953 //
     /* 1073770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1073787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1073790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073809 */     // MIs[0] round
     /* 1073809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073819 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073844 */     // GIR_Coverage, 15953,
     /* 1073844 */     GIR_EraseRootFromParent_Done,
     /* 1073845 */   // Label 15847: @1073845
     /* 1073845 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1073925), // Rule ID 15956 //
     /* 1073850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1073867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1073870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1073873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073889 */     // MIs[0] round
     /* 1073889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1073899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1073923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073924 */     // GIR_Coverage, 15956,
     /* 1073924 */     GIR_EraseRootFromParent_Done,
     /* 1073925 */   // Label 15848: @1073925
     /* 1073925 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1074005), // Rule ID 15957 //
     /* 1073930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1073938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1073947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1073950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1073953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073969 */     // MIs[0] round
     /* 1073969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1073972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073979 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1073979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1073982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1073988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1073990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1073992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074004 */     // GIR_Coverage, 15957,
     /* 1074004 */     GIR_EraseRootFromParent_Done,
     /* 1074005 */   // Label 15849: @1074005
     /* 1074005 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1074085), // Rule ID 15960 //
     /* 1074010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1074021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1074024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1074030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074049 */     // MIs[0] round
     /* 1074049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1074062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074084 */     // GIR_Coverage, 15960,
     /* 1074084 */     GIR_EraseRootFromParent_Done,
     /* 1074085 */   // Label 15850: @1074085
     /* 1074085 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1074165), // Rule ID 15961 //
     /* 1074090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1074101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1074104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1074110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074129 */     // MIs[0] round
     /* 1074129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074139 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1074142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074164 */     // GIR_Coverage, 15961,
     /* 1074164 */     GIR_EraseRootFromParent_Done,
     /* 1074165 */   // Label 15851: @1074165
     /* 1074165 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1074245), // Rule ID 15964 //
     /* 1074170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1074181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1074184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1074187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1074190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074209 */     // MIs[0] round
     /* 1074209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1074222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074244 */     // GIR_Coverage, 15964,
     /* 1074244 */     GIR_EraseRootFromParent_Done,
     /* 1074245 */   // Label 15852: @1074245
     /* 1074245 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1074325), // Rule ID 15965 //
     /* 1074250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1074261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1074264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1074267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1074270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074289 */     // MIs[0] round
     /* 1074289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1074302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074324 */     // GIR_Coverage, 15965,
     /* 1074324 */     GIR_EraseRootFromParent_Done,
     /* 1074325 */   // Label 15853: @1074325
     /* 1074325 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1074405), // Rule ID 15968 //
     /* 1074330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1074341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1074344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1074347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1074350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074369 */     // MIs[0] round
     /* 1074369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074379 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1074382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074404 */     // GIR_Coverage, 15968,
     /* 1074404 */     GIR_EraseRootFromParent_Done,
     /* 1074405 */   // Label 15854: @1074405
     /* 1074405 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1074485), // Rule ID 15969 //
     /* 1074410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1074421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1074424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1074427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1074430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074449 */     // MIs[0] round
     /* 1074449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1074462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074484 */     // GIR_Coverage, 15969,
     /* 1074484 */     GIR_EraseRootFromParent_Done,
     /* 1074485 */   // Label 15855: @1074485
     /* 1074485 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1074565), // Rule ID 15972 //
     /* 1074490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1074501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1074504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1074507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1074510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074529 */     // MIs[0] round
     /* 1074529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074539 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1074542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074564 */     // GIR_Coverage, 15972,
     /* 1074564 */     GIR_EraseRootFromParent_Done,
     /* 1074565 */   // Label 15856: @1074565
     /* 1074565 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1074645), // Rule ID 15973 //
     /* 1074570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1074581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1074584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1074587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1074590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074609 */     // MIs[0] round
     /* 1074609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074619 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1074622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074644 */     // GIR_Coverage, 15973,
     /* 1074644 */     GIR_EraseRootFromParent_Done,
     /* 1074645 */   // Label 15857: @1074645
     /* 1074645 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1074725), // Rule ID 15976 //
     /* 1074650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1074667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1074670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074689 */     // MIs[0] round
     /* 1074689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1074702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074724 */     // GIR_Coverage, 15976,
     /* 1074724 */     GIR_EraseRootFromParent_Done,
     /* 1074725 */   // Label 15858: @1074725
     /* 1074725 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1074805), // Rule ID 15977 //
     /* 1074730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1074747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1074750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074769 */     // MIs[0] round
     /* 1074769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074779 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1074782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074804 */     // GIR_Coverage, 15977,
     /* 1074804 */     GIR_EraseRootFromParent_Done,
     /* 1074805 */   // Label 15859: @1074805
     /* 1074805 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1074885), // Rule ID 15980 //
     /* 1074810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1074827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1074830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074849 */     // MIs[0] round
     /* 1074849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074859 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1074859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1074862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074884 */     // GIR_Coverage, 15980,
     /* 1074884 */     GIR_EraseRootFromParent_Done,
     /* 1074885 */   // Label 15860: @1074885
     /* 1074885 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1074965), // Rule ID 15981 //
     /* 1074890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1074907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1074910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1074913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074929 */     // MIs[0] round
     /* 1074929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1074932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1074939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1074942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1074952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1074963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074964 */     // GIR_Coverage, 15981,
     /* 1074964 */     GIR_EraseRootFromParent_Done,
     /* 1074965 */   // Label 15861: @1074965
     /* 1074965 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1075045), // Rule ID 15984 //
     /* 1074970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1074978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1074981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1074984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1074987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1074990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1074993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075009 */     // MIs[0] round
     /* 1075009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075019 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1075022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075044 */     // GIR_Coverage, 15984,
     /* 1075044 */     GIR_EraseRootFromParent_Done,
     /* 1075045 */   // Label 15862: @1075045
     /* 1075045 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1075125), // Rule ID 15985 //
     /* 1075050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1075061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1075064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1075067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1075070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075089 */     // MIs[0] round
     /* 1075089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1075102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075124 */     // GIR_Coverage, 15985,
     /* 1075124 */     GIR_EraseRootFromParent_Done,
     /* 1075125 */   // Label 15863: @1075125
     /* 1075125 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1075205), // Rule ID 15988 //
     /* 1075130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1075147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1075150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075169 */     // MIs[0] round
     /* 1075169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1075182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075204 */     // GIR_Coverage, 15988,
     /* 1075204 */     GIR_EraseRootFromParent_Done,
     /* 1075205 */   // Label 15864: @1075205
     /* 1075205 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1075285), // Rule ID 15989 //
     /* 1075210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1075227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1075230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075249 */     // MIs[0] round
     /* 1075249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1075262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075284 */     // GIR_Coverage, 15989,
     /* 1075284 */     GIR_EraseRootFromParent_Done,
     /* 1075285 */   // Label 15865: @1075285
     /* 1075285 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1075365), // Rule ID 15992 //
     /* 1075290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1075307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1075310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075329 */     // MIs[0] round
     /* 1075329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075339 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1075342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075364 */     // GIR_Coverage, 15992,
     /* 1075364 */     GIR_EraseRootFromParent_Done,
     /* 1075365 */   // Label 15866: @1075365
     /* 1075365 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1075445), // Rule ID 15993 //
     /* 1075370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1075387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1075390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075409 */     // MIs[0] round
     /* 1075409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075419 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1075422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075444 */     // GIR_Coverage, 15993,
     /* 1075444 */     GIR_EraseRootFromParent_Done,
     /* 1075445 */   // Label 15867: @1075445
     /* 1075445 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1075525), // Rule ID 15996 //
     /* 1075450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1075461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1075464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1075467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1075470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075489 */     // MIs[0] round
     /* 1075489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1075502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075524 */     // GIR_Coverage, 15996,
     /* 1075524 */     GIR_EraseRootFromParent_Done,
     /* 1075525 */   // Label 15868: @1075525
     /* 1075525 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1075605), // Rule ID 15997 //
     /* 1075530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1075541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1075544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1075547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1075550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075569 */     // MIs[0] round
     /* 1075569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1075582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075604 */     // GIR_Coverage, 15997,
     /* 1075604 */     GIR_EraseRootFromParent_Done,
     /* 1075605 */   // Label 15869: @1075605
     /* 1075605 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1075685), // Rule ID 16000 //
     /* 1075610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1075621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1075624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1075630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075649 */     // MIs[0] round
     /* 1075649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1075662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075684 */     // GIR_Coverage, 16000,
     /* 1075684 */     GIR_EraseRootFromParent_Done,
     /* 1075685 */   // Label 15870: @1075685
     /* 1075685 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1075765), // Rule ID 16001 //
     /* 1075690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1075701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1075704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1075710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075729 */     // MIs[0] round
     /* 1075729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1075742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075764 */     // GIR_Coverage, 16001,
     /* 1075764 */     GIR_EraseRootFromParent_Done,
     /* 1075765 */   // Label 15871: @1075765
     /* 1075765 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1075845), // Rule ID 16004 //
     /* 1075770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1075790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075809 */     // MIs[0] round
     /* 1075809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075819 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1075822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075844 */     // GIR_Coverage, 16004,
     /* 1075844 */     GIR_EraseRootFromParent_Done,
     /* 1075845 */   // Label 15872: @1075845
     /* 1075845 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1075925), // Rule ID 16005 //
     /* 1075850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1075870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1075873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075889 */     // MIs[0] round
     /* 1075889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075899 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1075899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1075902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1075923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075924 */     // GIR_Coverage, 16005,
     /* 1075924 */     GIR_EraseRootFromParent_Done,
     /* 1075925 */   // Label 15873: @1075925
     /* 1075925 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1076005), // Rule ID 16008 //
     /* 1075930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1075938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1075941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1075944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1075947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1075950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1075953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075969 */     // MIs[0] round
     /* 1075969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1075972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075979 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1075979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1075982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1075992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076004 */     // GIR_Coverage, 16008,
     /* 1076004 */     GIR_EraseRootFromParent_Done,
     /* 1076005 */   // Label 15874: @1076005
     /* 1076005 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1076085), // Rule ID 16009 //
     /* 1076010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1076021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1076024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1076027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1076030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076049 */     // MIs[0] round
     /* 1076049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1076062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076084 */     // GIR_Coverage, 16009,
     /* 1076084 */     GIR_EraseRootFromParent_Done,
     /* 1076085 */   // Label 15875: @1076085
     /* 1076085 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1076165), // Rule ID 16012 //
     /* 1076090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1076101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1076104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1076107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076129 */     // MIs[0] round
     /* 1076129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1076142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076164 */     // GIR_Coverage, 16012,
     /* 1076164 */     GIR_EraseRootFromParent_Done,
     /* 1076165 */   // Label 15876: @1076165
     /* 1076165 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1076245), // Rule ID 16013 //
     /* 1076170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1076181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1076184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1076187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076209 */     // MIs[0] round
     /* 1076209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1076222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076244 */     // GIR_Coverage, 16013,
     /* 1076244 */     GIR_EraseRootFromParent_Done,
     /* 1076245 */   // Label 15877: @1076245
     /* 1076245 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1076325), // Rule ID 16016 //
     /* 1076250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1076261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1076264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1076267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076289 */     // MIs[0] round
     /* 1076289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076299 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1076302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076324 */     // GIR_Coverage, 16016,
     /* 1076324 */     GIR_EraseRootFromParent_Done,
     /* 1076325 */   // Label 15878: @1076325
     /* 1076325 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1076405), // Rule ID 16017 //
     /* 1076330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1076341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1076344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1076347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076369 */     // MIs[0] round
     /* 1076369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076379 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1076382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076404 */     // GIR_Coverage, 16017,
     /* 1076404 */     GIR_EraseRootFromParent_Done,
     /* 1076405 */   // Label 15879: @1076405
     /* 1076405 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1076485), // Rule ID 16020 //
     /* 1076410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1076421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1076424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1076427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076449 */     // MIs[0] round
     /* 1076449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076459 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1076462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076484 */     // GIR_Coverage, 16020,
     /* 1076484 */     GIR_EraseRootFromParent_Done,
     /* 1076485 */   // Label 15880: @1076485
     /* 1076485 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1076565), // Rule ID 16021 //
     /* 1076490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1076501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1076504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1076507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076529 */     // MIs[0] round
     /* 1076529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1076542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076564 */     // GIR_Coverage, 16021,
     /* 1076564 */     GIR_EraseRootFromParent_Done,
     /* 1076565 */   // Label 15881: @1076565
     /* 1076565 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1076645), // Rule ID 16024 //
     /* 1076570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1076581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1076584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1076587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076609 */     // MIs[0] round
     /* 1076609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076619 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1076622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076644 */     // GIR_Coverage, 16024,
     /* 1076644 */     GIR_EraseRootFromParent_Done,
     /* 1076645 */   // Label 15882: @1076645
     /* 1076645 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1076725), // Rule ID 16025 //
     /* 1076650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1076661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1076664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1076667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076689 */     // MIs[0] round
     /* 1076689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076699 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1076702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076724 */     // GIR_Coverage, 16025,
     /* 1076724 */     GIR_EraseRootFromParent_Done,
     /* 1076725 */   // Label 15883: @1076725
     /* 1076725 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1076805), // Rule ID 16028 //
     /* 1076730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1076747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076769 */     // MIs[0] round
     /* 1076769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076779 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1076782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076804 */     // GIR_Coverage, 16028,
     /* 1076804 */     GIR_EraseRootFromParent_Done,
     /* 1076805 */   // Label 15884: @1076805
     /* 1076805 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1076885), // Rule ID 16029 //
     /* 1076810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1076827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076849 */     // MIs[0] round
     /* 1076849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1076859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1076862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076884 */     // GIR_Coverage, 16029,
     /* 1076884 */     GIR_EraseRootFromParent_Done,
     /* 1076885 */   // Label 15885: @1076885
     /* 1076885 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1076965), // Rule ID 16032 //
     /* 1076890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1076913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076929 */     // MIs[0] round
     /* 1076929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1076932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1076939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1076942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1076952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1076963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076964 */     // GIR_Coverage, 16032,
     /* 1076964 */     GIR_EraseRootFromParent_Done,
     /* 1076965 */   // Label 15886: @1076965
     /* 1076965 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1077045), // Rule ID 16033 //
     /* 1076970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1076978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1076993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077009 */     // MIs[0] round
     /* 1077009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1077022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077044 */     // GIR_Coverage, 16033,
     /* 1077044 */     GIR_EraseRootFromParent_Done,
     /* 1077045 */   // Label 15887: @1077045
     /* 1077045 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1077125), // Rule ID 16036 //
     /* 1077050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1077061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1077064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1077067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077089 */     // MIs[0] round
     /* 1077089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077124 */     // GIR_Coverage, 16036,
     /* 1077124 */     GIR_EraseRootFromParent_Done,
     /* 1077125 */   // Label 15888: @1077125
     /* 1077125 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1077205), // Rule ID 16037 //
     /* 1077130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1077141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1077144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1077147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077169 */     // MIs[0] round
     /* 1077169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077179 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077204 */     // GIR_Coverage, 16037,
     /* 1077204 */     GIR_EraseRootFromParent_Done,
     /* 1077205 */   // Label 15889: @1077205
     /* 1077205 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1077285), // Rule ID 16040 //
     /* 1077210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1077221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1077224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1077227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077249 */     // MIs[0] round
     /* 1077249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077259 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077284 */     // GIR_Coverage, 16040,
     /* 1077284 */     GIR_EraseRootFromParent_Done,
     /* 1077285 */   // Label 15890: @1077285
     /* 1077285 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1077365), // Rule ID 16041 //
     /* 1077290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1077301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1077304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1077307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077329 */     // MIs[0] round
     /* 1077329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077339 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077364 */     // GIR_Coverage, 16041,
     /* 1077364 */     GIR_EraseRootFromParent_Done,
     /* 1077365 */   // Label 15891: @1077365
     /* 1077365 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1077445), // Rule ID 16044 //
     /* 1077370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1077381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1077384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1077387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077409 */     // MIs[0] round
     /* 1077409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077444 */     // GIR_Coverage, 16044,
     /* 1077444 */     GIR_EraseRootFromParent_Done,
     /* 1077445 */   // Label 15892: @1077445
     /* 1077445 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1077525), // Rule ID 16045 //
     /* 1077450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1077461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1077464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1077467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077489 */     // MIs[0] round
     /* 1077489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077524 */     // GIR_Coverage, 16045,
     /* 1077524 */     GIR_EraseRootFromParent_Done,
     /* 1077525 */   // Label 15893: @1077525
     /* 1077525 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1077605), // Rule ID 16048 //
     /* 1077530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1077541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1077544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1077547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077569 */     // MIs[0] round
     /* 1077569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077579 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077604 */     // GIR_Coverage, 16048,
     /* 1077604 */     GIR_EraseRootFromParent_Done,
     /* 1077605 */   // Label 15894: @1077605
     /* 1077605 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1077685), // Rule ID 16049 //
     /* 1077610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1077621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1077624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1077627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077649 */     // MIs[0] round
     /* 1077649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077659 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1077662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077684 */     // GIR_Coverage, 16049,
     /* 1077684 */     GIR_EraseRootFromParent_Done,
     /* 1077685 */   // Label 15895: @1077685
     /* 1077685 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1077765), // Rule ID 16052 //
     /* 1077690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1077701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1077704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1077707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077729 */     // MIs[0] round
     /* 1077729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1077742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077764 */     // GIR_Coverage, 16052,
     /* 1077764 */     GIR_EraseRootFromParent_Done,
     /* 1077765 */   // Label 15896: @1077765
     /* 1077765 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1077845), // Rule ID 16053 //
     /* 1077770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1077781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1077784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1077787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077809 */     // MIs[0] round
     /* 1077809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1077822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077844 */     // GIR_Coverage, 16053,
     /* 1077844 */     GIR_EraseRootFromParent_Done,
     /* 1077845 */   // Label 15897: @1077845
     /* 1077845 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1077925), // Rule ID 16056 //
     /* 1077850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1077873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077889 */     // MIs[0] round
     /* 1077889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077899 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1077899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1077902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1077923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077924 */     // GIR_Coverage, 16056,
     /* 1077924 */     GIR_EraseRootFromParent_Done,
     /* 1077925 */   // Label 15898: @1077925
     /* 1077925 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1078005), // Rule ID 16057 //
     /* 1077930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1077938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1077953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077969 */     // MIs[0] round
     /* 1077969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1077972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077979 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1077979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1077982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1077992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078004 */     // GIR_Coverage, 16057,
     /* 1078004 */     GIR_EraseRootFromParent_Done,
     /* 1078005 */   // Label 15899: @1078005
     /* 1078005 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1078085), // Rule ID 16060 //
     /* 1078010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1078021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1078024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1078027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078049 */     // MIs[0] round
     /* 1078049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078059 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1078062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078084 */     // GIR_Coverage, 16060,
     /* 1078084 */     GIR_EraseRootFromParent_Done,
     /* 1078085 */   // Label 15900: @1078085
     /* 1078085 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1078165), // Rule ID 16061 //
     /* 1078090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1078101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1078104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1078107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078129 */     // MIs[0] round
     /* 1078129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1078142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078164 */     // GIR_Coverage, 16061,
     /* 1078164 */     GIR_EraseRootFromParent_Done,
     /* 1078165 */   // Label 15901: @1078165
     /* 1078165 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1078245), // Rule ID 16064 //
     /* 1078170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1078181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1078184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1078187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078209 */     // MIs[0] round
     /* 1078209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1078222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078244 */     // GIR_Coverage, 16064,
     /* 1078244 */     GIR_EraseRootFromParent_Done,
     /* 1078245 */   // Label 15902: @1078245
     /* 1078245 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1078325), // Rule ID 16065 //
     /* 1078250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1078261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1078264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1078267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078289 */     // MIs[0] round
     /* 1078289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1078302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078324 */     // GIR_Coverage, 16065,
     /* 1078324 */     GIR_EraseRootFromParent_Done,
     /* 1078325 */   // Label 15903: @1078325
     /* 1078325 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1078405), // Rule ID 16068 //
     /* 1078330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1078341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1078344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1078347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078369 */     // MIs[0] round
     /* 1078369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078379 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1078382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078404 */     // GIR_Coverage, 16068,
     /* 1078404 */     GIR_EraseRootFromParent_Done,
     /* 1078405 */   // Label 15904: @1078405
     /* 1078405 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1078485), // Rule ID 16069 //
     /* 1078410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1078421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1078424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1078427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078449 */     // MIs[0] round
     /* 1078449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1078462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078484 */     // GIR_Coverage, 16069,
     /* 1078484 */     GIR_EraseRootFromParent_Done,
     /* 1078485 */   // Label 15905: @1078485
     /* 1078485 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1078565), // Rule ID 16072 //
     /* 1078490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1078501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1078504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1078507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078529 */     // MIs[0] round
     /* 1078529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078539 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1078542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078564 */     // GIR_Coverage, 16072,
     /* 1078564 */     GIR_EraseRootFromParent_Done,
     /* 1078565 */   // Label 15906: @1078565
     /* 1078565 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1078645), // Rule ID 16073 //
     /* 1078570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1078581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1078584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1078587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078609 */     // MIs[0] round
     /* 1078609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078619 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1078622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078644 */     // GIR_Coverage, 16073,
     /* 1078644 */     GIR_EraseRootFromParent_Done,
     /* 1078645 */   // Label 15907: @1078645
     /* 1078645 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1078725), // Rule ID 16076 //
     /* 1078650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1078661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1078664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1078667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078689 */     // MIs[0] round
     /* 1078689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1078702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078724 */     // GIR_Coverage, 16076,
     /* 1078724 */     GIR_EraseRootFromParent_Done,
     /* 1078725 */   // Label 15908: @1078725
     /* 1078725 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1078805), // Rule ID 16077 //
     /* 1078730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1078741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1078744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1078747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078769 */     // MIs[0] round
     /* 1078769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1078782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078804 */     // GIR_Coverage, 16077,
     /* 1078804 */     GIR_EraseRootFromParent_Done,
     /* 1078805 */   // Label 15909: @1078805
     /* 1078805 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1078885), // Rule ID 16080 //
     /* 1078810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1078827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078849 */     // MIs[0] round
     /* 1078849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078859 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1078859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1078862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078884 */     // GIR_Coverage, 16080,
     /* 1078884 */     GIR_EraseRootFromParent_Done,
     /* 1078885 */   // Label 15910: @1078885
     /* 1078885 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1078965), // Rule ID 16081 //
     /* 1078890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1078907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1078913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078929 */     // MIs[0] round
     /* 1078929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1078932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1078939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1078942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1078952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1078963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078964 */     // GIR_Coverage, 16081,
     /* 1078964 */     GIR_EraseRootFromParent_Done,
     /* 1078965 */   // Label 15911: @1078965
     /* 1078965 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1079045), // Rule ID 16084 //
     /* 1078970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1078978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1078987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1078993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079009 */     // MIs[0] round
     /* 1079009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079019 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1079022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079044 */     // GIR_Coverage, 16084,
     /* 1079044 */     GIR_EraseRootFromParent_Done,
     /* 1079045 */   // Label 15912: @1079045
     /* 1079045 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1079125), // Rule ID 16085 //
     /* 1079050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1079061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1079064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1079067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079089 */     // MIs[0] round
     /* 1079089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1079102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079124 */     // GIR_Coverage, 16085,
     /* 1079124 */     GIR_EraseRootFromParent_Done,
     /* 1079125 */   // Label 15913: @1079125
     /* 1079125 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1079205), // Rule ID 16088 //
     /* 1079130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1079141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1079144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1079147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079169 */     // MIs[0] round
     /* 1079169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1079182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079204 */     // GIR_Coverage, 16088,
     /* 1079204 */     GIR_EraseRootFromParent_Done,
     /* 1079205 */   // Label 15914: @1079205
     /* 1079205 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1079285), // Rule ID 16089 //
     /* 1079210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1079221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1079224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1079227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079249 */     // MIs[0] round
     /* 1079249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1079262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079284 */     // GIR_Coverage, 16089,
     /* 1079284 */     GIR_EraseRootFromParent_Done,
     /* 1079285 */   // Label 15915: @1079285
     /* 1079285 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1079365), // Rule ID 16092 //
     /* 1079290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1079301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1079304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1079307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079329 */     // MIs[0] round
     /* 1079329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079339 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1079342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079364 */     // GIR_Coverage, 16092,
     /* 1079364 */     GIR_EraseRootFromParent_Done,
     /* 1079365 */   // Label 15916: @1079365
     /* 1079365 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1079445), // Rule ID 16093 //
     /* 1079370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1079381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1079384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1079387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079409 */     // MIs[0] round
     /* 1079409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079419 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1079422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079444 */     // GIR_Coverage, 16093,
     /* 1079444 */     GIR_EraseRootFromParent_Done,
     /* 1079445 */   // Label 15917: @1079445
     /* 1079445 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1079525), // Rule ID 16096 //
     /* 1079450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1079461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1079464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1079467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079489 */     // MIs[0] round
     /* 1079489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079499 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1079502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079524 */     // GIR_Coverage, 16096,
     /* 1079524 */     GIR_EraseRootFromParent_Done,
     /* 1079525 */   // Label 15918: @1079525
     /* 1079525 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1079605), // Rule ID 16097 //
     /* 1079530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1079538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1079541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1079544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1079547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079569 */     // MIs[0] round
     /* 1079569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079579 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1079582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079604 */     // GIR_Coverage, 16097,
     /* 1079604 */     GIR_EraseRootFromParent_Done,
     /* 1079605 */   // Label 15919: @1079605
     /* 1079605 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1079688), // Rule ID 16188 //
     /* 1079610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1079618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1079621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1079624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1079630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079649 */     // MIs[0] round
     /* 1079649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1079662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1079686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079687 */     // GIR_Coverage, 16188,
     /* 1079687 */     GIR_EraseRootFromParent_Done,
     /* 1079688 */   // Label 15920: @1079688
     /* 1079688 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1079771), // Rule ID 16189 //
     /* 1079693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1079701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1079704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1079707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1079713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079732 */     // MIs[0] round
     /* 1079732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079742 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1079745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1079769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079770 */     // GIR_Coverage, 16189,
     /* 1079770 */     GIR_EraseRootFromParent_Done,
     /* 1079771 */   // Label 15921: @1079771
     /* 1079771 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1079854), // Rule ID 16192 //
     /* 1079776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1079784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1079787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1079790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1079796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079815 */     // MIs[0] round
     /* 1079815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079825 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1079828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079836 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1079852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079853 */     // GIR_Coverage, 16192,
     /* 1079853 */     GIR_EraseRootFromParent_Done,
     /* 1079854 */   // Label 15922: @1079854
     /* 1079854 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1079937), // Rule ID 16193 //
     /* 1079859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1079867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1079870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1079873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1079879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1079882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079898 */     // MIs[0] round
     /* 1079898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1079908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1079911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1079921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1079932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1079935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079936 */     // GIR_Coverage, 16193,
     /* 1079936 */     GIR_EraseRootFromParent_Done,
     /* 1079937 */   // Label 15923: @1079937
     /* 1079937 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1080020), // Rule ID 16196 //
     /* 1079942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1079950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1079962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1079965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079981 */     // MIs[0] round
     /* 1079981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1079984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079991 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1079991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1079994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1079998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080019 */     // GIR_Coverage, 16196,
     /* 1080019 */     GIR_EraseRootFromParent_Done,
     /* 1080020 */   // Label 15924: @1080020
     /* 1080020 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1080103), // Rule ID 16197 //
     /* 1080025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1080036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1080039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1080042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1080045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080064 */     // MIs[0] round
     /* 1080064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080074 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1080077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080102 */     // GIR_Coverage, 16197,
     /* 1080102 */     GIR_EraseRootFromParent_Done,
     /* 1080103 */   // Label 15925: @1080103
     /* 1080103 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1080186), // Rule ID 16200 //
     /* 1080108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1080119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1080122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1080128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080147 */     // MIs[0] round
     /* 1080147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1080160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080168 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080185 */     // GIR_Coverage, 16200,
     /* 1080185 */     GIR_EraseRootFromParent_Done,
     /* 1080186 */   // Label 15926: @1080186
     /* 1080186 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1080269), // Rule ID 16201 //
     /* 1080191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1080202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1080205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1080211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080230 */     // MIs[0] round
     /* 1080230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1080243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080268 */     // GIR_Coverage, 16201,
     /* 1080268 */     GIR_EraseRootFromParent_Done,
     /* 1080269 */   // Label 15927: @1080269
     /* 1080269 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1080352), // Rule ID 16204 //
     /* 1080274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1080294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080313 */     // MIs[0] round
     /* 1080313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1080326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080351 */     // GIR_Coverage, 16204,
     /* 1080351 */     GIR_EraseRootFromParent_Done,
     /* 1080352 */   // Label 15928: @1080352
     /* 1080352 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1080435), // Rule ID 16205 //
     /* 1080357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1080377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080396 */     // MIs[0] round
     /* 1080396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1080409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080434 */     // GIR_Coverage, 16205,
     /* 1080434 */     GIR_EraseRootFromParent_Done,
     /* 1080435 */   // Label 15929: @1080435
     /* 1080435 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1080518), // Rule ID 16208 //
     /* 1080440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1080460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080479 */     // MIs[0] round
     /* 1080479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1080492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080500 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080517 */     // GIR_Coverage, 16208,
     /* 1080517 */     GIR_EraseRootFromParent_Done,
     /* 1080518 */   // Label 15930: @1080518
     /* 1080518 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1080601), // Rule ID 16209 //
     /* 1080523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1080543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080562 */     // MIs[0] round
     /* 1080562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080572 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1080575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080600 */     // GIR_Coverage, 16209,
     /* 1080600 */     GIR_EraseRootFromParent_Done,
     /* 1080601 */   // Label 15931: @1080601
     /* 1080601 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1080684), // Rule ID 16212 //
     /* 1080606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1080617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1080620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1080623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1080626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080645 */     // MIs[0] round
     /* 1080645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080655 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1080658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080666 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080683 */     // GIR_Coverage, 16212,
     /* 1080683 */     GIR_EraseRootFromParent_Done,
     /* 1080684 */   // Label 15932: @1080684
     /* 1080684 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1080767), // Rule ID 16213 //
     /* 1080689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1080700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1080703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1080706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1080709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080728 */     // MIs[0] round
     /* 1080728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080738 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1080741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080766 */     // GIR_Coverage, 16213,
     /* 1080766 */     GIR_EraseRootFromParent_Done,
     /* 1080767 */   // Label 15933: @1080767
     /* 1080767 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1080850), // Rule ID 16216 //
     /* 1080772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1080783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1080786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1080792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080811 */     // MIs[0] round
     /* 1080811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080821 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1080824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080832 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080849 */     // GIR_Coverage, 16216,
     /* 1080849 */     GIR_EraseRootFromParent_Done,
     /* 1080850 */   // Label 15934: @1080850
     /* 1080850 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1080933), // Rule ID 16217 //
     /* 1080855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1080866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1080869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1080875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1080878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080894 */     // MIs[0] round
     /* 1080894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1080904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1080907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1080917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1080928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1080931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080932 */     // GIR_Coverage, 16217,
     /* 1080932 */     GIR_EraseRootFromParent_Done,
     /* 1080933 */   // Label 15935: @1080933
     /* 1080933 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1081016), // Rule ID 16220 //
     /* 1080938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1080946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1080949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1080952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1080958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1080961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080977 */     // MIs[0] round
     /* 1080977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1080980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080987 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1080987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1080990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1080994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080998 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081015 */     // GIR_Coverage, 16220,
     /* 1081015 */     GIR_EraseRootFromParent_Done,
     /* 1081016 */   // Label 15936: @1081016
     /* 1081016 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1081099), // Rule ID 16221 //
     /* 1081021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1081032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1081035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1081041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081060 */     // MIs[0] round
     /* 1081060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1081073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081098 */     // GIR_Coverage, 16221,
     /* 1081098 */     GIR_EraseRootFromParent_Done,
     /* 1081099 */   // Label 15937: @1081099
     /* 1081099 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1081182), // Rule ID 16224 //
     /* 1081104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1081115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1081118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1081124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081143 */     // MIs[0] round
     /* 1081143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081153 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1081156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081181 */     // GIR_Coverage, 16224,
     /* 1081181 */     GIR_EraseRootFromParent_Done,
     /* 1081182 */   // Label 15938: @1081182
     /* 1081182 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1081265), // Rule ID 16225 //
     /* 1081187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1081198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1081201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1081207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081226 */     // MIs[0] round
     /* 1081226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1081239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081264 */     // GIR_Coverage, 16225,
     /* 1081264 */     GIR_EraseRootFromParent_Done,
     /* 1081265 */   // Label 15939: @1081265
     /* 1081265 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1081348), // Rule ID 16228 //
     /* 1081270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1081281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1081284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1081290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081309 */     // MIs[0] round
     /* 1081309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081319 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1081322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081330 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081347 */     // GIR_Coverage, 16228,
     /* 1081347 */     GIR_EraseRootFromParent_Done,
     /* 1081348 */   // Label 15940: @1081348
     /* 1081348 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1081431), // Rule ID 16229 //
     /* 1081353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1081364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1081367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1081373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081392 */     // MIs[0] round
     /* 1081392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1081405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081430 */     // GIR_Coverage, 16229,
     /* 1081430 */     GIR_EraseRootFromParent_Done,
     /* 1081431 */   // Label 15941: @1081431
     /* 1081431 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1081514), // Rule ID 16232 //
     /* 1081436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1081439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1081453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1081456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081475 */     // MIs[0] round
     /* 1081475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081485 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1081488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081496 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081513 */     // GIR_Coverage, 16232,
     /* 1081513 */     GIR_EraseRootFromParent_Done,
     /* 1081514 */   // Label 15942: @1081514
     /* 1081514 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1081597), // Rule ID 16233 //
     /* 1081519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1081522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1081536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1081539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081558 */     // MIs[0] round
     /* 1081558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1081571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081596 */     // GIR_Coverage, 16233,
     /* 1081596 */     GIR_EraseRootFromParent_Done,
     /* 1081597 */   // Label 15943: @1081597
     /* 1081597 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1081680), // Rule ID 16236 //
     /* 1081602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1081605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1081613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1081616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1081622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081641 */     // MIs[0] round
     /* 1081641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1081654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081679 */     // GIR_Coverage, 16236,
     /* 1081679 */     GIR_EraseRootFromParent_Done,
     /* 1081680 */   // Label 15944: @1081680
     /* 1081680 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1081763), // Rule ID 16237 //
     /* 1081685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1081688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1081696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1081699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1081705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081724 */     // MIs[0] round
     /* 1081724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1081737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081762 */     // GIR_Coverage, 16237,
     /* 1081762 */     GIR_EraseRootFromParent_Done,
     /* 1081763 */   // Label 15945: @1081763
     /* 1081763 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1081846), // Rule ID 16240 //
     /* 1081768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1081771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1081788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081807 */     // MIs[0] round
     /* 1081807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1081820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081828 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081845 */     // GIR_Coverage, 16240,
     /* 1081845 */     GIR_EraseRootFromParent_Done,
     /* 1081846 */   // Label 15946: @1081846
     /* 1081846 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1081929), // Rule ID 16241 //
     /* 1081851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1081854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1081871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1081874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081890 */     // MIs[0] round
     /* 1081890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1081900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1081903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1081924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1081927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081928 */     // GIR_Coverage, 16241,
     /* 1081928 */     GIR_EraseRootFromParent_Done,
     /* 1081929 */   // Label 15947: @1081929
     /* 1081929 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1082012), // Rule ID 16244 //
     /* 1081934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1081937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1081942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1081954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1081957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081973 */     // MIs[0] round
     /* 1081973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1081976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081983 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1081983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1081986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1081990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081994 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1081996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082011 */     // GIR_Coverage, 16244,
     /* 1082011 */     GIR_EraseRootFromParent_Done,
     /* 1082012 */   // Label 15948: @1082012
     /* 1082012 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1082095), // Rule ID 16245 //
     /* 1082017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1082020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1082028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1082031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1082034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1082037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082056 */     // MIs[0] round
     /* 1082056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1082069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082094 */     // GIR_Coverage, 16245,
     /* 1082094 */     GIR_EraseRootFromParent_Done,
     /* 1082095 */   // Label 15949: @1082095
     /* 1082095 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1082178), // Rule ID 16248 //
     /* 1082100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082139 */     // MIs[0] round
     /* 1082139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1082152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082177 */     // GIR_Coverage, 16248,
     /* 1082177 */     GIR_EraseRootFromParent_Done,
     /* 1082178 */   // Label 15950: @1082178
     /* 1082178 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1082261), // Rule ID 16249 //
     /* 1082183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082222 */     // MIs[0] round
     /* 1082222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082232 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1082235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082260 */     // GIR_Coverage, 16249,
     /* 1082260 */     GIR_EraseRootFromParent_Done,
     /* 1082261 */   // Label 15951: @1082261
     /* 1082261 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1082344), // Rule ID 16252 //
     /* 1082266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082305 */     // MIs[0] round
     /* 1082305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1082318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082343 */     // GIR_Coverage, 16252,
     /* 1082343 */     GIR_EraseRootFromParent_Done,
     /* 1082344 */   // Label 15952: @1082344
     /* 1082344 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1082427), // Rule ID 16253 //
     /* 1082349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082388 */     // MIs[0] round
     /* 1082388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1082401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082426 */     // GIR_Coverage, 16253,
     /* 1082426 */     GIR_EraseRootFromParent_Done,
     /* 1082427 */   // Label 15953: @1082427
     /* 1082427 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1082510), // Rule ID 16256 //
     /* 1082432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082471 */     // MIs[0] round
     /* 1082471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082481 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1082484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082492 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082509 */     // GIR_Coverage, 16256,
     /* 1082509 */     GIR_EraseRootFromParent_Done,
     /* 1082510 */   // Label 15954: @1082510
     /* 1082510 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1082593), // Rule ID 16257 //
     /* 1082515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082554 */     // MIs[0] round
     /* 1082554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1082567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082592 */     // GIR_Coverage, 16257,
     /* 1082592 */     GIR_EraseRootFromParent_Done,
     /* 1082593 */   // Label 15955: @1082593
     /* 1082593 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1082676), // Rule ID 16260 //
     /* 1082598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1082609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1082612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082637 */     // MIs[0] round
     /* 1082637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082647 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1082650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082658 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082675 */     // GIR_Coverage, 16260,
     /* 1082675 */     GIR_EraseRootFromParent_Done,
     /* 1082676 */   // Label 15956: @1082676
     /* 1082676 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1082759), // Rule ID 16261 //
     /* 1082681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1082692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1082695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082720 */     // MIs[0] round
     /* 1082720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1082733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082758 */     // GIR_Coverage, 16261,
     /* 1082758 */     GIR_EraseRootFromParent_Done,
     /* 1082759 */   // Label 15957: @1082759
     /* 1082759 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1082842), // Rule ID 16264 //
     /* 1082764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1082775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1082778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082803 */     // MIs[0] round
     /* 1082803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082813 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1082816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082841 */     // GIR_Coverage, 16264,
     /* 1082841 */     GIR_EraseRootFromParent_Done,
     /* 1082842 */   // Label 15958: @1082842
     /* 1082842 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1082925), // Rule ID 16265 //
     /* 1082847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1082858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1082861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1082870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082886 */     // MIs[0] round
     /* 1082886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1082896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1082899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1082920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1082923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082924 */     // GIR_Coverage, 16265,
     /* 1082924 */     GIR_EraseRootFromParent_Done,
     /* 1082925 */   // Label 15959: @1082925
     /* 1082925 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1083008), // Rule ID 16268 //
     /* 1082930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1082938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1082941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1082944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1082953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082969 */     // MIs[0] round
     /* 1082969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1082972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082979 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1082979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1082982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1082986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1082992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083007 */     // GIR_Coverage, 16268,
     /* 1083007 */     GIR_EraseRootFromParent_Done,
     /* 1083008 */   // Label 15960: @1083008
     /* 1083008 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1083091), // Rule ID 16269 //
     /* 1083013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1083024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1083027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1083030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083052 */     // MIs[0] round
     /* 1083052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083062 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1083065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083090 */     // GIR_Coverage, 16269,
     /* 1083090 */     GIR_EraseRootFromParent_Done,
     /* 1083091 */   // Label 15961: @1083091
     /* 1083091 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1083174), // Rule ID 16272 //
     /* 1083096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1083113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083135 */     // MIs[0] round
     /* 1083135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083145 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1083148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083156 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083173 */     // GIR_Coverage, 16272,
     /* 1083173 */     GIR_EraseRootFromParent_Done,
     /* 1083174 */   // Label 15962: @1083174
     /* 1083174 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1083257), // Rule ID 16273 //
     /* 1083179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1083196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083218 */     // MIs[0] round
     /* 1083218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1083231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083256 */     // GIR_Coverage, 16273,
     /* 1083256 */     GIR_EraseRootFromParent_Done,
     /* 1083257 */   // Label 15963: @1083257
     /* 1083257 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1083340), // Rule ID 16276 //
     /* 1083262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1083273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1083276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083301 */     // MIs[0] round
     /* 1083301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1083314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083322 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083339 */     // GIR_Coverage, 16276,
     /* 1083339 */     GIR_EraseRootFromParent_Done,
     /* 1083340 */   // Label 15964: @1083340
     /* 1083340 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1083423), // Rule ID 16277 //
     /* 1083345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1083356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1083359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083384 */     // MIs[0] round
     /* 1083384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1083397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083422 */     // GIR_Coverage, 16277,
     /* 1083422 */     GIR_EraseRootFromParent_Done,
     /* 1083423 */   // Label 15965: @1083423
     /* 1083423 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1083506), // Rule ID 16280 //
     /* 1083428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083467 */     // MIs[0] round
     /* 1083467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1083480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083505 */     // GIR_Coverage, 16280,
     /* 1083505 */     GIR_EraseRootFromParent_Done,
     /* 1083506 */   // Label 15966: @1083506
     /* 1083506 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1083589), // Rule ID 16281 //
     /* 1083511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083550 */     // MIs[0] round
     /* 1083550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1083563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083588 */     // GIR_Coverage, 16281,
     /* 1083588 */     GIR_EraseRootFromParent_Done,
     /* 1083589 */   // Label 15967: @1083589
     /* 1083589 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1083672), // Rule ID 16284 //
     /* 1083594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083633 */     // MIs[0] round
     /* 1083633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1083646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083654 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083671 */     // GIR_Coverage, 16284,
     /* 1083671 */     GIR_EraseRootFromParent_Done,
     /* 1083672 */   // Label 15968: @1083672
     /* 1083672 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1083755), // Rule ID 16285 //
     /* 1083677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083716 */     // MIs[0] round
     /* 1083716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1083729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083754 */     // GIR_Coverage, 16285,
     /* 1083754 */     GIR_EraseRootFromParent_Done,
     /* 1083755 */   // Label 15969: @1083755
     /* 1083755 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1083838), // Rule ID 16288 //
     /* 1083760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083799 */     // MIs[0] round
     /* 1083799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083809 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1083812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083820 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083837 */     // GIR_Coverage, 16288,
     /* 1083837 */     GIR_EraseRootFromParent_Done,
     /* 1083838 */   // Label 15970: @1083838
     /* 1083838 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1083921), // Rule ID 16289 //
     /* 1083843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1083866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083882 */     // MIs[0] round
     /* 1083882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1083892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1083895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1083919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083920 */     // GIR_Coverage, 16289,
     /* 1083920 */     GIR_EraseRootFromParent_Done,
     /* 1083921 */   // Label 15971: @1083921
     /* 1083921 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1084004), // Rule ID 16292 //
     /* 1083926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1083929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1083934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1083937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1083940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1083943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1083949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083965 */     // MIs[0] round
     /* 1083965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1083968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083975 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1083975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1083978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1083982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1083988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1083999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084003 */     // GIR_Coverage, 16292,
     /* 1084003 */     GIR_EraseRootFromParent_Done,
     /* 1084004 */   // Label 15972: @1084004
     /* 1084004 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1084087), // Rule ID 16293 //
     /* 1084009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1084012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084048 */     // MIs[0] round
     /* 1084048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1084061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084086 */     // GIR_Coverage, 16293,
     /* 1084086 */     GIR_EraseRootFromParent_Done,
     /* 1084087 */   // Label 15973: @1084087
     /* 1084087 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1084170), // Rule ID 16296 //
     /* 1084092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1084095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1084109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084131 */     // MIs[0] round
     /* 1084131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1084144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084169 */     // GIR_Coverage, 16296,
     /* 1084169 */     GIR_EraseRootFromParent_Done,
     /* 1084170 */   // Label 15974: @1084170
     /* 1084170 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1084253), // Rule ID 16297 //
     /* 1084175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1084178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1084192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084214 */     // MIs[0] round
     /* 1084214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1084227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084252 */     // GIR_Coverage, 16297,
     /* 1084252 */     GIR_EraseRootFromParent_Done,
     /* 1084253 */   // Label 15975: @1084253
     /* 1084253 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1084336), // Rule ID 16300 //
     /* 1084258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1084261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084297 */     // MIs[0] round
     /* 1084297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1084310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084335 */     // GIR_Coverage, 16300,
     /* 1084335 */     GIR_EraseRootFromParent_Done,
     /* 1084336 */   // Label 15976: @1084336
     /* 1084336 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1084419), // Rule ID 16301 //
     /* 1084341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1084344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084380 */     // MIs[0] round
     /* 1084380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1084393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084418 */     // GIR_Coverage, 16301,
     /* 1084418 */     GIR_EraseRootFromParent_Done,
     /* 1084419 */   // Label 15977: @1084419
     /* 1084419 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1084502), // Rule ID 16304 //
     /* 1084424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1084427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084463 */     // MIs[0] round
     /* 1084463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084473 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1084476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084501 */     // GIR_Coverage, 16304,
     /* 1084501 */     GIR_EraseRootFromParent_Done,
     /* 1084502 */   // Label 15978: @1084502
     /* 1084502 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1084585), // Rule ID 16305 //
     /* 1084507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1084510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1084515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084546 */     // MIs[0] round
     /* 1084546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1084559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084584 */     // GIR_Coverage, 16305,
     /* 1084584 */     GIR_EraseRootFromParent_Done,
     /* 1084585 */   // Label 15979: @1084585
     /* 1084585 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1084668), // Rule ID 16368 //
     /* 1084590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1084598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1084601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1084604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1084610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084629 */     // MIs[0] round
     /* 1084629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084639 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1084642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084650 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084667 */     // GIR_Coverage, 16368,
     /* 1084667 */     GIR_EraseRootFromParent_Done,
     /* 1084668 */   // Label 15980: @1084668
     /* 1084668 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1084751), // Rule ID 16369 //
     /* 1084673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1084681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1084684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1084687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1084693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084712 */     // MIs[0] round
     /* 1084712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084722 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1084725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084750 */     // GIR_Coverage, 16369,
     /* 1084750 */     GIR_EraseRootFromParent_Done,
     /* 1084751 */   // Label 15981: @1084751
     /* 1084751 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1084834), // Rule ID 16372 //
     /* 1084756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1084764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1084767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1084770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1084776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084795 */     // MIs[0] round
     /* 1084795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084805 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1084808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084833 */     // GIR_Coverage, 16372,
     /* 1084833 */     GIR_EraseRootFromParent_Done,
     /* 1084834 */   // Label 15982: @1084834
     /* 1084834 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1084917), // Rule ID 16373 //
     /* 1084839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1084847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1084850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1084853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1084859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1084862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084878 */     // MIs[0] round
     /* 1084878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084888 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1084888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1084891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084916 */     // GIR_Coverage, 16373,
     /* 1084916 */     GIR_EraseRootFromParent_Done,
     /* 1084917 */   // Label 15983: @1084917
     /* 1084917 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1085000), // Rule ID 16376 //
     /* 1084922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1084930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1084933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1084936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1084942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1084945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084961 */     // MIs[0] round
     /* 1084961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1084964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1084971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1084974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1084978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1084984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1084995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1084998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084999 */     // GIR_Coverage, 16376,
     /* 1084999 */     GIR_EraseRootFromParent_Done,
     /* 1085000 */   // Label 15984: @1085000
     /* 1085000 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1085083), // Rule ID 16377 //
     /* 1085005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1085016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1085019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1085022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1085025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085044 */     // MIs[0] round
     /* 1085044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085054 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1085057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085082 */     // GIR_Coverage, 16377,
     /* 1085082 */     GIR_EraseRootFromParent_Done,
     /* 1085083 */   // Label 15985: @1085083
     /* 1085083 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1085166), // Rule ID 16380 //
     /* 1085088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1085099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1085102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1085108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085127 */     // MIs[0] round
     /* 1085127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085137 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1085140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085165 */     // GIR_Coverage, 16380,
     /* 1085165 */     GIR_EraseRootFromParent_Done,
     /* 1085166 */   // Label 15986: @1085166
     /* 1085166 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1085249), // Rule ID 16381 //
     /* 1085171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1085182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1085185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1085191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085210 */     // MIs[0] round
     /* 1085210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1085223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085248 */     // GIR_Coverage, 16381,
     /* 1085248 */     GIR_EraseRootFromParent_Done,
     /* 1085249 */   // Label 15987: @1085249
     /* 1085249 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1085332), // Rule ID 16384 //
     /* 1085254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1085265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1085268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1085274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085293 */     // MIs[0] round
     /* 1085293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085303 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1085306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085314 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085331 */     // GIR_Coverage, 16384,
     /* 1085331 */     GIR_EraseRootFromParent_Done,
     /* 1085332 */   // Label 15988: @1085332
     /* 1085332 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1085415), // Rule ID 16385 //
     /* 1085337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1085348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1085351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1085357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085376 */     // MIs[0] round
     /* 1085376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1085389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085414 */     // GIR_Coverage, 16385,
     /* 1085414 */     GIR_EraseRootFromParent_Done,
     /* 1085415 */   // Label 15989: @1085415
     /* 1085415 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1085498), // Rule ID 16388 //
     /* 1085420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1085431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1085434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1085440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085459 */     // MIs[0] round
     /* 1085459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1085472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085497 */     // GIR_Coverage, 16388,
     /* 1085497 */     GIR_EraseRootFromParent_Done,
     /* 1085498 */   // Label 15990: @1085498
     /* 1085498 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1085581), // Rule ID 16389 //
     /* 1085503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1085514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1085517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1085523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085542 */     // MIs[0] round
     /* 1085542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1085555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085580 */     // GIR_Coverage, 16389,
     /* 1085580 */     GIR_EraseRootFromParent_Done,
     /* 1085581 */   // Label 15991: @1085581
     /* 1085581 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1085664), // Rule ID 16392 //
     /* 1085586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1085606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085625 */     // MIs[0] round
     /* 1085625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085635 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1085638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085663 */     // GIR_Coverage, 16392,
     /* 1085663 */     GIR_EraseRootFromParent_Done,
     /* 1085664 */   // Label 15992: @1085664
     /* 1085664 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1085747), // Rule ID 16393 //
     /* 1085669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1085689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085708 */     // MIs[0] round
     /* 1085708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1085721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085746 */     // GIR_Coverage, 16393,
     /* 1085746 */     GIR_EraseRootFromParent_Done,
     /* 1085747 */   // Label 15993: @1085747
     /* 1085747 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1085830), // Rule ID 16396 //
     /* 1085752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1085772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085791 */     // MIs[0] round
     /* 1085791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1085804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085829 */     // GIR_Coverage, 16396,
     /* 1085829 */     GIR_EraseRootFromParent_Done,
     /* 1085830 */   // Label 15994: @1085830
     /* 1085830 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1085913), // Rule ID 16397 //
     /* 1085835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1085855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1085858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085874 */     // MIs[0] round
     /* 1085874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1085884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1085887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085912 */     // GIR_Coverage, 16397,
     /* 1085912 */     GIR_EraseRootFromParent_Done,
     /* 1085913 */   // Label 15995: @1085913
     /* 1085913 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1085996), // Rule ID 16400 //
     /* 1085918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1085926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1085929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1085932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1085938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1085941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085957 */     // MIs[0] round
     /* 1085957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1085960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085967 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1085967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1085970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1085980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1085991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1085994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085995 */     // GIR_Coverage, 16400,
     /* 1085995 */     GIR_EraseRootFromParent_Done,
     /* 1085996 */   // Label 15996: @1085996
     /* 1085996 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1086079), // Rule ID 16401 //
     /* 1086001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1086012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1086015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1086018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1086021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086040 */     // MIs[0] round
     /* 1086040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1086053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086078 */     // GIR_Coverage, 16401,
     /* 1086078 */     GIR_EraseRootFromParent_Done,
     /* 1086079 */   // Label 15997: @1086079
     /* 1086079 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1086162), // Rule ID 16404 //
     /* 1086084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1086087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1086101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1086104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086123 */     // MIs[0] round
     /* 1086123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086133 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1086136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086161 */     // GIR_Coverage, 16404,
     /* 1086161 */     GIR_EraseRootFromParent_Done,
     /* 1086162 */   // Label 15998: @1086162
     /* 1086162 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1086245), // Rule ID 16405 //
     /* 1086167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1086184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1086187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086206 */     // MIs[0] round
     /* 1086206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1086219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086244 */     // GIR_Coverage, 16405,
     /* 1086244 */     GIR_EraseRootFromParent_Done,
     /* 1086245 */   // Label 15999: @1086245
     /* 1086245 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1086328), // Rule ID 16408 //
     /* 1086250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1086253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1086270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086289 */     // MIs[0] round
     /* 1086289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086299 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1086302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086327 */     // GIR_Coverage, 16408,
     /* 1086327 */     GIR_EraseRootFromParent_Done,
     /* 1086328 */   // Label 16000: @1086328
     /* 1086328 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1086411), // Rule ID 16409 //
     /* 1086333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1086353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086372 */     // MIs[0] round
     /* 1086372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1086385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086410 */     // GIR_Coverage, 16409,
     /* 1086410 */     GIR_EraseRootFromParent_Done,
     /* 1086411 */   // Label 16001: @1086411
     /* 1086411 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1086494), // Rule ID 16412 //
     /* 1086416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1086419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086455 */     // MIs[0] round
     /* 1086455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1086468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086493 */     // GIR_Coverage, 16412,
     /* 1086493 */     GIR_EraseRootFromParent_Done,
     /* 1086494 */   // Label 16002: @1086494
     /* 1086494 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1086577), // Rule ID 16413 //
     /* 1086499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1086502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086538 */     // MIs[0] round
     /* 1086538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1086551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086576 */     // GIR_Coverage, 16413,
     /* 1086576 */     GIR_EraseRootFromParent_Done,
     /* 1086577 */   // Label 16003: @1086577
     /* 1086577 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1086660), // Rule ID 16416 //
     /* 1086582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1086585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1086602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086621 */     // MIs[0] round
     /* 1086621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1086634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086659 */     // GIR_Coverage, 16416,
     /* 1086659 */     GIR_EraseRootFromParent_Done,
     /* 1086660 */   // Label 16004: @1086660
     /* 1086660 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1086743), // Rule ID 16417 //
     /* 1086665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1086668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1086685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086704 */     // MIs[0] round
     /* 1086704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1086717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086742 */     // GIR_Coverage, 16417,
     /* 1086742 */     GIR_EraseRootFromParent_Done,
     /* 1086743 */   // Label 16005: @1086743
     /* 1086743 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1086826), // Rule ID 16420 //
     /* 1086748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1086751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1086768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086787 */     // MIs[0] round
     /* 1086787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086797 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1086800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086825 */     // GIR_Coverage, 16420,
     /* 1086825 */     GIR_EraseRootFromParent_Done,
     /* 1086826 */   // Label 16006: @1086826
     /* 1086826 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1086909), // Rule ID 16421 //
     /* 1086831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1086834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1086851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1086854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086870 */     // MIs[0] round
     /* 1086870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1086880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1086883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086908 */     // GIR_Coverage, 16421,
     /* 1086908 */     GIR_EraseRootFromParent_Done,
     /* 1086909 */   // Label 16007: @1086909
     /* 1086909 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1086992), // Rule ID 16424 //
     /* 1086914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1086917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1086922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1086925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1086928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1086934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1086937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086953 */     // MIs[0] round
     /* 1086953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1086956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1086963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1086966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086974 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1086976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1086987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1086990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086991 */     // GIR_Coverage, 16424,
     /* 1086991 */     GIR_EraseRootFromParent_Done,
     /* 1086992 */   // Label 16008: @1086992
     /* 1086992 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1087075), // Rule ID 16425 //
     /* 1086997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1087000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1087008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1087011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1087014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1087017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087036 */     // MIs[0] round
     /* 1087036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1087049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087074 */     // GIR_Coverage, 16425,
     /* 1087074 */     GIR_EraseRootFromParent_Done,
     /* 1087075 */   // Label 16009: @1087075
     /* 1087075 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1087158), // Rule ID 16428 //
     /* 1087080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1087091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1087094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087119 */     // MIs[0] round
     /* 1087119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087129 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1087132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087157 */     // GIR_Coverage, 16428,
     /* 1087157 */     GIR_EraseRootFromParent_Done,
     /* 1087158 */   // Label 16010: @1087158
     /* 1087158 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1087241), // Rule ID 16429 //
     /* 1087163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1087174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1087177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087202 */     // MIs[0] round
     /* 1087202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1087215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087240 */     // GIR_Coverage, 16429,
     /* 1087240 */     GIR_EraseRootFromParent_Done,
     /* 1087241 */   // Label 16011: @1087241
     /* 1087241 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1087324), // Rule ID 16432 //
     /* 1087246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087285 */     // MIs[0] round
     /* 1087285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087295 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1087298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087323 */     // GIR_Coverage, 16432,
     /* 1087323 */     GIR_EraseRootFromParent_Done,
     /* 1087324 */   // Label 16012: @1087324
     /* 1087324 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1087407), // Rule ID 16433 //
     /* 1087329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087368 */     // MIs[0] round
     /* 1087368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087378 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1087381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087406 */     // GIR_Coverage, 16433,
     /* 1087406 */     GIR_EraseRootFromParent_Done,
     /* 1087407 */   // Label 16013: @1087407
     /* 1087407 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1087490), // Rule ID 16436 //
     /* 1087412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087451 */     // MIs[0] round
     /* 1087451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087461 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1087464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087489 */     // GIR_Coverage, 16436,
     /* 1087489 */     GIR_EraseRootFromParent_Done,
     /* 1087490 */   // Label 16014: @1087490
     /* 1087490 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1087573), // Rule ID 16437 //
     /* 1087495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087534 */     // MIs[0] round
     /* 1087534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1087547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087572 */     // GIR_Coverage, 16437,
     /* 1087572 */     GIR_EraseRootFromParent_Done,
     /* 1087573 */   // Label 16015: @1087573
     /* 1087573 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1087656), // Rule ID 16440 //
     /* 1087578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1087595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087617 */     // MIs[0] round
     /* 1087617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1087630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087655 */     // GIR_Coverage, 16440,
     /* 1087655 */     GIR_EraseRootFromParent_Done,
     /* 1087656 */   // Label 16016: @1087656
     /* 1087656 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1087739), // Rule ID 16441 //
     /* 1087661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1087678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087700 */     // MIs[0] round
     /* 1087700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1087713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087738 */     // GIR_Coverage, 16441,
     /* 1087738 */     GIR_EraseRootFromParent_Done,
     /* 1087739 */   // Label 16017: @1087739
     /* 1087739 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1087822), // Rule ID 16444 //
     /* 1087744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1087761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087783 */     // MIs[0] round
     /* 1087783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1087796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087821 */     // GIR_Coverage, 16444,
     /* 1087821 */     GIR_EraseRootFromParent_Done,
     /* 1087822 */   // Label 16018: @1087822
     /* 1087822 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1087905), // Rule ID 16445 //
     /* 1087827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1087844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1087850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087866 */     // MIs[0] round
     /* 1087866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1087876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1087879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087904 */     // GIR_Coverage, 16445,
     /* 1087904 */     GIR_EraseRootFromParent_Done,
     /* 1087905 */   // Label 16019: @1087905
     /* 1087905 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1087988), // Rule ID 16448 //
     /* 1087910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1087913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1087918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1087921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1087924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1087927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1087933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087949 */     // MIs[0] round
     /* 1087949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1087952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087959 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1087959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1087962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1087972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1087983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1087986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087987 */     // GIR_Coverage, 16448,
     /* 1087987 */     GIR_EraseRootFromParent_Done,
     /* 1087988 */   // Label 16020: @1087988
     /* 1087988 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1088071), // Rule ID 16449 //
     /* 1087993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1087996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088032 */     // MIs[0] round
     /* 1088032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088042 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1088045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088070 */     // GIR_Coverage, 16449,
     /* 1088070 */     GIR_EraseRootFromParent_Done,
     /* 1088071 */   // Label 16021: @1088071
     /* 1088071 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1088154), // Rule ID 16452 //
     /* 1088076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1088079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1088087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1088090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088115 */     // MIs[0] round
     /* 1088115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088125 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1088128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088153 */     // GIR_Coverage, 16452,
     /* 1088153 */     GIR_EraseRootFromParent_Done,
     /* 1088154 */   // Label 16022: @1088154
     /* 1088154 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1088237), // Rule ID 16453 //
     /* 1088159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1088162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1088170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1088173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088198 */     // MIs[0] round
     /* 1088198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1088211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088236 */     // GIR_Coverage, 16453,
     /* 1088236 */     GIR_EraseRootFromParent_Done,
     /* 1088237 */   // Label 16023: @1088237
     /* 1088237 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1088320), // Rule ID 16456 //
     /* 1088242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1088245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1088253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1088256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088281 */     // MIs[0] round
     /* 1088281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088291 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1088294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088319 */     // GIR_Coverage, 16456,
     /* 1088319 */     GIR_EraseRootFromParent_Done,
     /* 1088320 */   // Label 16024: @1088320
     /* 1088320 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1088403), // Rule ID 16457 //
     /* 1088325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1088328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1088336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1088339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088364 */     // MIs[0] round
     /* 1088364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1088377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088402 */     // GIR_Coverage, 16457,
     /* 1088402 */     GIR_EraseRootFromParent_Done,
     /* 1088403 */   // Label 16025: @1088403
     /* 1088403 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1088486), // Rule ID 16460 //
     /* 1088408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1088411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088447 */     // MIs[0] round
     /* 1088447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1088460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088485 */     // GIR_Coverage, 16460,
     /* 1088485 */     GIR_EraseRootFromParent_Done,
     /* 1088486 */   // Label 16026: @1088486
     /* 1088486 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1088569), // Rule ID 16461 //
     /* 1088491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1088494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088530 */     // MIs[0] round
     /* 1088530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1088543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088568 */     // GIR_Coverage, 16461,
     /* 1088568 */     GIR_EraseRootFromParent_Done,
     /* 1088569 */   // Label 16027: @1088569
     /* 1088569 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1088652), // Rule ID 16464 //
     /* 1088574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1088577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1088591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088613 */     // MIs[0] round
     /* 1088613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1088626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088651 */     // GIR_Coverage, 16464,
     /* 1088651 */     GIR_EraseRootFromParent_Done,
     /* 1088652 */   // Label 16028: @1088652
     /* 1088652 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1088735), // Rule ID 16465 //
     /* 1088657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1088660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1088674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088696 */     // MIs[0] round
     /* 1088696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1088709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088734 */     // GIR_Coverage, 16465,
     /* 1088734 */     GIR_EraseRootFromParent_Done,
     /* 1088735 */   // Label 16029: @1088735
     /* 1088735 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1088818), // Rule ID 16468 //
     /* 1088740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1088743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1088757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088779 */     // MIs[0] round
     /* 1088779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1088792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088817 */     // GIR_Coverage, 16468,
     /* 1088817 */     GIR_EraseRootFromParent_Done,
     /* 1088818 */   // Label 16030: @1088818
     /* 1088818 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1088901), // Rule ID 16469 //
     /* 1088823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1088826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1088840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1088846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088862 */     // MIs[0] round
     /* 1088862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088872 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1088872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1088875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088900 */     // GIR_Coverage, 16469,
     /* 1088900 */     GIR_EraseRootFromParent_Done,
     /* 1088901 */   // Label 16031: @1088901
     /* 1088901 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1088984), // Rule ID 16472 //
     /* 1088906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1088909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1088917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1088920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1088929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088945 */     // MIs[0] round
     /* 1088945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1088948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1088955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1088958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1088968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1088979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1088982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088983 */     // GIR_Coverage, 16472,
     /* 1088983 */     GIR_EraseRootFromParent_Done,
     /* 1088984 */   // Label 16032: @1088984
     /* 1088984 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1089067), // Rule ID 16473 //
     /* 1088989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1088992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1088997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1089000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1089003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1089006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089028 */     // MIs[0] round
     /* 1089028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1089041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089066 */     // GIR_Coverage, 16473,
     /* 1089066 */     GIR_EraseRootFromParent_Done,
     /* 1089067 */   // Label 16033: @1089067
     /* 1089067 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1089150), // Rule ID 16476 //
     /* 1089072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1089075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1089083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1089086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089111 */     // MIs[0] round
     /* 1089111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089121 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1089124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089149 */     // GIR_Coverage, 16476,
     /* 1089149 */     GIR_EraseRootFromParent_Done,
     /* 1089150 */   // Label 16034: @1089150
     /* 1089150 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1089233), // Rule ID 16477 //
     /* 1089155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1089158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1089166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1089169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089194 */     // MIs[0] round
     /* 1089194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1089207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089232 */     // GIR_Coverage, 16477,
     /* 1089232 */     GIR_EraseRootFromParent_Done,
     /* 1089233 */   // Label 16035: @1089233
     /* 1089233 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1089316), // Rule ID 16480 //
     /* 1089238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1089241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089277 */     // MIs[0] round
     /* 1089277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1089290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089315 */     // GIR_Coverage, 16480,
     /* 1089315 */     GIR_EraseRootFromParent_Done,
     /* 1089316 */   // Label 16036: @1089316
     /* 1089316 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1089399), // Rule ID 16481 //
     /* 1089321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1089324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089360 */     // MIs[0] round
     /* 1089360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1089373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089398 */     // GIR_Coverage, 16481,
     /* 1089398 */     GIR_EraseRootFromParent_Done,
     /* 1089399 */   // Label 16037: @1089399
     /* 1089399 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1089482), // Rule ID 16484 //
     /* 1089404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1089407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089443 */     // MIs[0] round
     /* 1089443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089453 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1089456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089481 */     // GIR_Coverage, 16484,
     /* 1089481 */     GIR_EraseRootFromParent_Done,
     /* 1089482 */   // Label 16038: @1089482
     /* 1089482 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1089565), // Rule ID 16485 //
     /* 1089487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1089490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1089495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089526 */     // MIs[0] round
     /* 1089526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1089539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1089563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089564 */     // GIR_Coverage, 16485,
     /* 1089564 */     GIR_EraseRootFromParent_Done,
     /* 1089565 */   // Label 16039: @1089565
     /* 1089565 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1089645), // Rule ID 16548 //
     /* 1089570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1089573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1089581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1089584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1089587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1089590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089609 */     // MIs[0] round
     /* 1089609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089619 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1089622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089644 */     // GIR_Coverage, 16548,
     /* 1089644 */     GIR_EraseRootFromParent_Done,
     /* 1089645 */   // Label 16040: @1089645
     /* 1089645 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1089725), // Rule ID 16549 //
     /* 1089650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1089653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1089661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1089664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1089667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1089670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089689 */     // MIs[0] round
     /* 1089689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089699 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1089702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089724 */     // GIR_Coverage, 16549,
     /* 1089724 */     GIR_EraseRootFromParent_Done,
     /* 1089725 */   // Label 16041: @1089725
     /* 1089725 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1089805), // Rule ID 16552 //
     /* 1089730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1089733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1089741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1089744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1089747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1089750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089769 */     // MIs[0] round
     /* 1089769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089779 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1089782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089804 */     // GIR_Coverage, 16552,
     /* 1089804 */     GIR_EraseRootFromParent_Done,
     /* 1089805 */   // Label 16042: @1089805
     /* 1089805 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1089885), // Rule ID 16553 //
     /* 1089810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1089813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1089821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1089824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1089827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1089830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089849 */     // MIs[0] round
     /* 1089849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089859 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1089859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1089862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089884 */     // GIR_Coverage, 16553,
     /* 1089884 */     GIR_EraseRootFromParent_Done,
     /* 1089885 */   // Label 16043: @1089885
     /* 1089885 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1089965), // Rule ID 16556 //
     /* 1089890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1089901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1089904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1089907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1089910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1089913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089929 */     // MIs[0] round
     /* 1089929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1089932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089939 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1089939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1089942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1089952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1089963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089964 */     // GIR_Coverage, 16556,
     /* 1089964 */     GIR_EraseRootFromParent_Done,
     /* 1089965 */   // Label 16044: @1089965
     /* 1089965 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1090045), // Rule ID 16557 //
     /* 1089970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1089978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1089981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1089984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1089987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1089990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1089993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090009 */     // MIs[0] round
     /* 1090009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090019 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1090022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090044 */     // GIR_Coverage, 16557,
     /* 1090044 */     GIR_EraseRootFromParent_Done,
     /* 1090045 */   // Label 16045: @1090045
     /* 1090045 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1090125), // Rule ID 16560 //
     /* 1090050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1090053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1090070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090089 */     // MIs[0] round
     /* 1090089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090099 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1090102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090124 */     // GIR_Coverage, 16560,
     /* 1090124 */     GIR_EraseRootFromParent_Done,
     /* 1090125 */   // Label 16046: @1090125
     /* 1090125 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1090205), // Rule ID 16561 //
     /* 1090130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1090133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1090150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090169 */     // MIs[0] round
     /* 1090169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090179 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1090182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090204 */     // GIR_Coverage, 16561,
     /* 1090204 */     GIR_EraseRootFromParent_Done,
     /* 1090205 */   // Label 16047: @1090205
     /* 1090205 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1090285), // Rule ID 16564 //
     /* 1090210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1090213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1090221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1090224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1090227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1090230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090249 */     // MIs[0] round
     /* 1090249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090259 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1090262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090284 */     // GIR_Coverage, 16564,
     /* 1090284 */     GIR_EraseRootFromParent_Done,
     /* 1090285 */   // Label 16048: @1090285
     /* 1090285 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1090365), // Rule ID 16565 //
     /* 1090290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1090293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1090301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1090304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1090307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1090310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090329 */     // MIs[0] round
     /* 1090329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1090342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090364 */     // GIR_Coverage, 16565,
     /* 1090364 */     GIR_EraseRootFromParent_Done,
     /* 1090365 */   // Label 16049: @1090365
     /* 1090365 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1090445), // Rule ID 16568 //
     /* 1090370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1090373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1090381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1090384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1090387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1090390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090409 */     // MIs[0] round
     /* 1090409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090419 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1090422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090444 */     // GIR_Coverage, 16568,
     /* 1090444 */     GIR_EraseRootFromParent_Done,
     /* 1090445 */   // Label 16050: @1090445
     /* 1090445 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1090525), // Rule ID 16569 //
     /* 1090450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1090453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1090461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1090464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1090467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1090470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090489 */     // MIs[0] round
     /* 1090489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1090502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090524 */     // GIR_Coverage, 16569,
     /* 1090524 */     GIR_EraseRootFromParent_Done,
     /* 1090525 */   // Label 16051: @1090525
     /* 1090525 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1090605), // Rule ID 16572 //
     /* 1090530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1090533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1090541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1090544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1090547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1090550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090569 */     // MIs[0] round
     /* 1090569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1090582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090604 */     // GIR_Coverage, 16572,
     /* 1090604 */     GIR_EraseRootFromParent_Done,
     /* 1090605 */   // Label 16052: @1090605
     /* 1090605 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1090685), // Rule ID 16573 //
     /* 1090610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1090613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1090621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1090624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1090627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1090630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090649 */     // MIs[0] round
     /* 1090649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090659 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1090662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090684 */     // GIR_Coverage, 16573,
     /* 1090684 */     GIR_EraseRootFromParent_Done,
     /* 1090685 */   // Label 16053: @1090685
     /* 1090685 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1090765), // Rule ID 16576 //
     /* 1090690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1090693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1090701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1090704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1090707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1090710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090729 */     // MIs[0] round
     /* 1090729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090739 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1090742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090764 */     // GIR_Coverage, 16576,
     /* 1090764 */     GIR_EraseRootFromParent_Done,
     /* 1090765 */   // Label 16054: @1090765
     /* 1090765 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1090845), // Rule ID 16577 //
     /* 1090770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1090773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1090781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1090784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1090787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1090790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090809 */     // MIs[0] round
     /* 1090809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090819 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1090822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090844 */     // GIR_Coverage, 16577,
     /* 1090844 */     GIR_EraseRootFromParent_Done,
     /* 1090845 */   // Label 16055: @1090845
     /* 1090845 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1090925), // Rule ID 16580 //
     /* 1090850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1090853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1090861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1090864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1090867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1090870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1090873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090889 */     // MIs[0] round
     /* 1090889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090899 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1090899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1090902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1090923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090924 */     // GIR_Coverage, 16580,
     /* 1090924 */     GIR_EraseRootFromParent_Done,
     /* 1090925 */   // Label 16056: @1090925
     /* 1090925 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1091005), // Rule ID 16581 //
     /* 1090930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1090933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1090938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1090941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1090944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1090947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1090950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1090953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090969 */     // MIs[0] round
     /* 1090969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1090972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090979 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1090979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1090982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1090992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091004 */     // GIR_Coverage, 16581,
     /* 1091004 */     GIR_EraseRootFromParent_Done,
     /* 1091005 */   // Label 16057: @1091005
     /* 1091005 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1091085), // Rule ID 16584 //
     /* 1091010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1091013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1091021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1091024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1091027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1091030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091049 */     // MIs[0] round
     /* 1091049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1091062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091084 */     // GIR_Coverage, 16584,
     /* 1091084 */     GIR_EraseRootFromParent_Done,
     /* 1091085 */   // Label 16058: @1091085
     /* 1091085 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1091165), // Rule ID 16585 //
     /* 1091090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1091093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1091101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1091104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1091107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1091110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091129 */     // MIs[0] round
     /* 1091129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1091142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091164 */     // GIR_Coverage, 16585,
     /* 1091164 */     GIR_EraseRootFromParent_Done,
     /* 1091165 */   // Label 16059: @1091165
     /* 1091165 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1091245), // Rule ID 16588 //
     /* 1091170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1091173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1091181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1091184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1091187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1091190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091209 */     // MIs[0] round
     /* 1091209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091219 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1091222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091244 */     // GIR_Coverage, 16588,
     /* 1091244 */     GIR_EraseRootFromParent_Done,
     /* 1091245 */   // Label 16060: @1091245
     /* 1091245 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1091325), // Rule ID 16589 //
     /* 1091250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1091253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1091261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1091264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1091267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1091270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091289 */     // MIs[0] round
     /* 1091289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091299 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1091302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091324 */     // GIR_Coverage, 16589,
     /* 1091324 */     GIR_EraseRootFromParent_Done,
     /* 1091325 */   // Label 16061: @1091325
     /* 1091325 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1091405), // Rule ID 16592 //
     /* 1091330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1091333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1091341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1091344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1091347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1091350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091369 */     // MIs[0] round
     /* 1091369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091379 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1091382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091404 */     // GIR_Coverage, 16592,
     /* 1091404 */     GIR_EraseRootFromParent_Done,
     /* 1091405 */   // Label 16062: @1091405
     /* 1091405 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1091485), // Rule ID 16593 //
     /* 1091410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1091413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1091421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1091424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1091427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1091430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091449 */     // MIs[0] round
     /* 1091449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091459 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1091462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091484 */     // GIR_Coverage, 16593,
     /* 1091484 */     GIR_EraseRootFromParent_Done,
     /* 1091485 */   // Label 16063: @1091485
     /* 1091485 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1091565), // Rule ID 16596 //
     /* 1091490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1091493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1091501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1091504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1091507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1091510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091529 */     // MIs[0] round
     /* 1091529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1091542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091564 */     // GIR_Coverage, 16596,
     /* 1091564 */     GIR_EraseRootFromParent_Done,
     /* 1091565 */   // Label 16064: @1091565
     /* 1091565 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1091645), // Rule ID 16597 //
     /* 1091570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1091573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1091581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1091584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1091587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1091590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091609 */     // MIs[0] round
     /* 1091609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1091622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091644 */     // GIR_Coverage, 16597,
     /* 1091644 */     GIR_EraseRootFromParent_Done,
     /* 1091645 */   // Label 16065: @1091645
     /* 1091645 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1091725), // Rule ID 16600 //
     /* 1091650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1091653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1091661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1091664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1091667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1091670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091689 */     // MIs[0] round
     /* 1091689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091699 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1091702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091724 */     // GIR_Coverage, 16600,
     /* 1091724 */     GIR_EraseRootFromParent_Done,
     /* 1091725 */   // Label 16066: @1091725
     /* 1091725 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1091805), // Rule ID 16601 //
     /* 1091730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1091733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1091741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1091744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1091747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1091750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091769 */     // MIs[0] round
     /* 1091769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091779 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1091782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091804 */     // GIR_Coverage, 16601,
     /* 1091804 */     GIR_EraseRootFromParent_Done,
     /* 1091805 */   // Label 16067: @1091805
     /* 1091805 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1091885), // Rule ID 16604 //
     /* 1091810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1091813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1091821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1091824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1091827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1091830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091849 */     // MIs[0] round
     /* 1091849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091859 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1091859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1091862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091884 */     // GIR_Coverage, 16604,
     /* 1091884 */     GIR_EraseRootFromParent_Done,
     /* 1091885 */   // Label 16068: @1091885
     /* 1091885 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1091965), // Rule ID 16605 //
     /* 1091890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1091893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1091901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1091904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1091907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1091910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1091913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091929 */     // MIs[0] round
     /* 1091929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1091932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091939 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1091939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1091942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1091948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1091950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1091952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1091963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091964 */     // GIR_Coverage, 16605,
     /* 1091964 */     GIR_EraseRootFromParent_Done,
     /* 1091965 */   // Label 16069: @1091965
     /* 1091965 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1092045), // Rule ID 16608 //
     /* 1091970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1091973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1091978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1091981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1091984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1091987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1091990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1091993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092009 */     // MIs[0] round
     /* 1092009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092019 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1092022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092044 */     // GIR_Coverage, 16608,
     /* 1092044 */     GIR_EraseRootFromParent_Done,
     /* 1092045 */   // Label 16070: @1092045
     /* 1092045 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1092125), // Rule ID 16609 //
     /* 1092050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1092053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1092061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1092064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1092067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092089 */     // MIs[0] round
     /* 1092089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092099 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1092102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092124 */     // GIR_Coverage, 16609,
     /* 1092124 */     GIR_EraseRootFromParent_Done,
     /* 1092125 */   // Label 16071: @1092125
     /* 1092125 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1092205), // Rule ID 16612 //
     /* 1092130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1092133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1092141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1092144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1092147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092169 */     // MIs[0] round
     /* 1092169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092179 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1092182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092204 */     // GIR_Coverage, 16612,
     /* 1092204 */     GIR_EraseRootFromParent_Done,
     /* 1092205 */   // Label 16072: @1092205
     /* 1092205 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1092285), // Rule ID 16613 //
     /* 1092210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1092213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1092221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1092224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1092227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092249 */     // MIs[0] round
     /* 1092249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092259 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1092262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092284 */     // GIR_Coverage, 16613,
     /* 1092284 */     GIR_EraseRootFromParent_Done,
     /* 1092285 */   // Label 16073: @1092285
     /* 1092285 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1092365), // Rule ID 16616 //
     /* 1092290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1092293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1092301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1092304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1092307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1092310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1092329 */     // MIs[0] round
     /* 1092329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092339 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1092342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092364 */     // GIR_Coverage, 16616,
     /* 1092364 */     GIR_EraseRootFromParent_Done,
     /* 1092365 */   // Label 16074: @1092365
     /* 1092365 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1092445), // Rule ID 16617 //
     /* 1092370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1092373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1092381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1092384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1092387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1092390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1092409 */     // MIs[0] round
     /* 1092409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092419 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1092422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092444 */     // GIR_Coverage, 16617,
     /* 1092444 */     GIR_EraseRootFromParent_Done,
     /* 1092445 */   // Label 16075: @1092445
     /* 1092445 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1092525), // Rule ID 16620 //
     /* 1092450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1092453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1092461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1092464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1092467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092489 */     // MIs[0] round
     /* 1092489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092499 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1092502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092524 */     // GIR_Coverage, 16620,
     /* 1092524 */     GIR_EraseRootFromParent_Done,
     /* 1092525 */   // Label 16076: @1092525
     /* 1092525 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1092605), // Rule ID 16621 //
     /* 1092530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1092533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1092541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1092544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1092547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092569 */     // MIs[0] round
     /* 1092569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092579 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1092582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092604 */     // GIR_Coverage, 16621,
     /* 1092604 */     GIR_EraseRootFromParent_Done,
     /* 1092605 */   // Label 16077: @1092605
     /* 1092605 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1092685), // Rule ID 16624 //
     /* 1092610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1092613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1092621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1092624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1092627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1092630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1092649 */     // MIs[0] round
     /* 1092649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1092662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092684 */     // GIR_Coverage, 16624,
     /* 1092684 */     GIR_EraseRootFromParent_Done,
     /* 1092685 */   // Label 16078: @1092685
     /* 1092685 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1092765), // Rule ID 16625 //
     /* 1092690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1092693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1092701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1092704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1092707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1092710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1092729 */     // MIs[0] round
     /* 1092729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1092742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092764 */     // GIR_Coverage, 16625,
     /* 1092764 */     GIR_EraseRootFromParent_Done,
     /* 1092765 */   // Label 16079: @1092765
     /* 1092765 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1092845), // Rule ID 16628 //
     /* 1092770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1092773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1092781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1092784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1092787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1092790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1092809 */     // MIs[0] round
     /* 1092809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092819 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1092822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092844 */     // GIR_Coverage, 16628,
     /* 1092844 */     GIR_EraseRootFromParent_Done,
     /* 1092845 */   // Label 16080: @1092845
     /* 1092845 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1092925), // Rule ID 16629 //
     /* 1092850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1092853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1092861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1092864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1092867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1092870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1092873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1092889 */     // MIs[0] round
     /* 1092889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1092899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1092902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1092923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092924 */     // GIR_Coverage, 16629,
     /* 1092924 */     GIR_EraseRootFromParent_Done,
     /* 1092925 */   // Label 16081: @1092925
     /* 1092925 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1093005), // Rule ID 16632 //
     /* 1092930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1092933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1092938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1092950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1092953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1092969 */     // MIs[0] round
     /* 1092969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1092972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1092979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1092982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1092988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1092990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1092992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093004 */     // GIR_Coverage, 16632,
     /* 1093004 */     GIR_EraseRootFromParent_Done,
     /* 1093005 */   // Label 16082: @1093005
     /* 1093005 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1093085), // Rule ID 16633 //
     /* 1093010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1093013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1093021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1093024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1093027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1093030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1093049 */     // MIs[0] round
     /* 1093049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1093062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093084 */     // GIR_Coverage, 16633,
     /* 1093084 */     GIR_EraseRootFromParent_Done,
     /* 1093085 */   // Label 16083: @1093085
     /* 1093085 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1093165), // Rule ID 16636 //
     /* 1093090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1093093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1093101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1093104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1093107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1093110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1093129 */     // MIs[0] round
     /* 1093129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093139 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1093142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093164 */     // GIR_Coverage, 16636,
     /* 1093164 */     GIR_EraseRootFromParent_Done,
     /* 1093165 */   // Label 16084: @1093165
     /* 1093165 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1093245), // Rule ID 16637 //
     /* 1093170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1093173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1093181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1093184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1093187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1093190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1093209 */     // MIs[0] round
     /* 1093209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093219 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1093222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093244 */     // GIR_Coverage, 16637,
     /* 1093244 */     GIR_EraseRootFromParent_Done,
     /* 1093245 */   // Label 16085: @1093245
     /* 1093245 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1093325), // Rule ID 16640 //
     /* 1093250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1093253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1093261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1093264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1093267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1093270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1093289 */     // MIs[0] round
     /* 1093289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093299 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1093302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093324 */     // GIR_Coverage, 16640,
     /* 1093324 */     GIR_EraseRootFromParent_Done,
     /* 1093325 */   // Label 16086: @1093325
     /* 1093325 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1093405), // Rule ID 16641 //
     /* 1093330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1093333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1093341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1093344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1093347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1093350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1093369 */     // MIs[0] round
     /* 1093369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093379 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1093382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093404 */     // GIR_Coverage, 16641,
     /* 1093404 */     GIR_EraseRootFromParent_Done,
     /* 1093405 */   // Label 16087: @1093405
     /* 1093405 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1093485), // Rule ID 16644 //
     /* 1093410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1093413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1093421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1093424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1093427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093449 */     // MIs[0] round
     /* 1093449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1093462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093484 */     // GIR_Coverage, 16644,
     /* 1093484 */     GIR_EraseRootFromParent_Done,
     /* 1093485 */   // Label 16088: @1093485
     /* 1093485 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1093565), // Rule ID 16645 //
     /* 1093490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1093493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1093501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1093504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1093507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093529 */     // MIs[0] round
     /* 1093529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093539 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1093542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093564 */     // GIR_Coverage, 16645,
     /* 1093564 */     GIR_EraseRootFromParent_Done,
     /* 1093565 */   // Label 16089: @1093565
     /* 1093565 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1093645), // Rule ID 16648 //
     /* 1093570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1093573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1093581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1093584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1093587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093609 */     // MIs[0] round
     /* 1093609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093619 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1093622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093644 */     // GIR_Coverage, 16648,
     /* 1093644 */     GIR_EraseRootFromParent_Done,
     /* 1093645 */   // Label 16090: @1093645
     /* 1093645 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1093725), // Rule ID 16649 //
     /* 1093650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1093653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1093661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1093664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1093667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093689 */     // MIs[0] round
     /* 1093689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093699 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1093702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093724 */     // GIR_Coverage, 16649,
     /* 1093724 */     GIR_EraseRootFromParent_Done,
     /* 1093725 */   // Label 16091: @1093725
     /* 1093725 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1093805), // Rule ID 16652 //
     /* 1093730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1093733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093769 */     // MIs[0] round
     /* 1093769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093779 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1093782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093804 */     // GIR_Coverage, 16652,
     /* 1093804 */     GIR_EraseRootFromParent_Done,
     /* 1093805 */   // Label 16092: @1093805
     /* 1093805 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1093885), // Rule ID 16653 //
     /* 1093810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1093813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1093830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1093849 */     // MIs[0] round
     /* 1093849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093859 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1093859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1093862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093884 */     // GIR_Coverage, 16653,
     /* 1093884 */     GIR_EraseRootFromParent_Done,
     /* 1093885 */   // Label 16093: @1093885
     /* 1093885 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1093965), // Rule ID 16656 //
     /* 1093890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1093893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1093910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1093913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1093929 */     // MIs[0] round
     /* 1093929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1093932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1093939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1093942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1093948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1093950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1093952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1093963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093964 */     // GIR_Coverage, 16656,
     /* 1093964 */     GIR_EraseRootFromParent_Done,
     /* 1093965 */   // Label 16094: @1093965
     /* 1093965 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1094045), // Rule ID 16657 //
     /* 1093970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1093973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1093978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1093990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1093993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1094009 */     // MIs[0] round
     /* 1094009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094019 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1094022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094044 */     // GIR_Coverage, 16657,
     /* 1094044 */     GIR_EraseRootFromParent_Done,
     /* 1094045 */   // Label 16095: @1094045
     /* 1094045 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1094125), // Rule ID 16660 //
     /* 1094050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1094053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1094058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1094061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1094064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1094067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1094070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1094089 */     // MIs[0] round
     /* 1094089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094099 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1094102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094124 */     // GIR_Coverage, 16660,
     /* 1094124 */     GIR_EraseRootFromParent_Done,
     /* 1094125 */   // Label 16096: @1094125
     /* 1094125 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1094205), // Rule ID 16661 //
     /* 1094130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1094133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1094138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1094141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1094144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1094147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1094150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1094169 */     // MIs[0] round
     /* 1094169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094179 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1094182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094204 */     // GIR_Coverage, 16661,
     /* 1094204 */     GIR_EraseRootFromParent_Done,
     /* 1094205 */   // Label 16097: @1094205
     /* 1094205 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1094285), // Rule ID 16664 //
     /* 1094210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1094213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1094218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1094221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1094224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1094227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1094230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1094249 */     // MIs[0] round
     /* 1094249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094259 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1094262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094284 */     // GIR_Coverage, 16664,
     /* 1094284 */     GIR_EraseRootFromParent_Done,
     /* 1094285 */   // Label 16098: @1094285
     /* 1094285 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1094365), // Rule ID 16665 //
     /* 1094290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1094293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1094298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1094301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1094304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1094307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1094310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1094329 */     // MIs[0] round
     /* 1094329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094339 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1094342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094364 */     // GIR_Coverage, 16665,
     /* 1094364 */     GIR_EraseRootFromParent_Done,
     /* 1094365 */   // Label 16099: @1094365
     /* 1094365 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1094445), // Rule ID 16668 //
     /* 1094370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1094373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1094390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094409 */     // MIs[0] round
     /* 1094409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094419 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1094422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094444 */     // GIR_Coverage, 16668,
     /* 1094444 */     GIR_EraseRootFromParent_Done,
     /* 1094445 */   // Label 16100: @1094445
     /* 1094445 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1094525), // Rule ID 16669 //
     /* 1094450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1094453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1094470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094489 */     // MIs[0] round
     /* 1094489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094499 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1094502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094524 */     // GIR_Coverage, 16669,
     /* 1094524 */     GIR_EraseRootFromParent_Done,
     /* 1094525 */   // Label 16101: @1094525
     /* 1094525 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1094605), // Rule ID 16672 //
     /* 1094530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1094533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1094550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094569 */     // MIs[0] round
     /* 1094569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094579 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1094582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094604 */     // GIR_Coverage, 16672,
     /* 1094604 */     GIR_EraseRootFromParent_Done,
     /* 1094605 */   // Label 16102: @1094605
     /* 1094605 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1094685), // Rule ID 16673 //
     /* 1094610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1094613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1094630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094649 */     // MIs[0] round
     /* 1094649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094659 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1094662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094684 */     // GIR_Coverage, 16673,
     /* 1094684 */     GIR_EraseRootFromParent_Done,
     /* 1094685 */   // Label 16103: @1094685
     /* 1094685 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1094765), // Rule ID 16676 //
     /* 1094690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1094693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1094710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094729 */     // MIs[0] round
     /* 1094729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094739 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1094742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094764 */     // GIR_Coverage, 16676,
     /* 1094764 */     GIR_EraseRootFromParent_Done,
     /* 1094765 */   // Label 16104: @1094765
     /* 1094765 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1094845), // Rule ID 16677 //
     /* 1094770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1094773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1094790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094809 */     // MIs[0] round
     /* 1094809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094819 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1094822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094844 */     // GIR_Coverage, 16677,
     /* 1094844 */     GIR_EraseRootFromParent_Done,
     /* 1094845 */   // Label 16105: @1094845
     /* 1094845 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1094925), // Rule ID 16680 //
     /* 1094850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1094853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1094870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1094873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094889 */     // MIs[0] round
     /* 1094889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1094899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1094902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1094923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094924 */     // GIR_Coverage, 16680,
     /* 1094924 */     GIR_EraseRootFromParent_Done,
     /* 1094925 */   // Label 16106: @1094925
     /* 1094925 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1095005), // Rule ID 16681 //
     /* 1094930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1094933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1094938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1094950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1094953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094969 */     // MIs[0] round
     /* 1094969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1094972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094979 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1094979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1094982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1094988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1094990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1094992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095004 */     // GIR_Coverage, 16681,
     /* 1095004 */     GIR_EraseRootFromParent_Done,
     /* 1095005 */   // Label 16107: @1095005
     /* 1095005 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1095085), // Rule ID 16684 //
     /* 1095010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1095013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1095021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1095024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1095027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1095030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095049 */     // MIs[0] round
     /* 1095049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095059 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1095062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095084 */     // GIR_Coverage, 16684,
     /* 1095084 */     GIR_EraseRootFromParent_Done,
     /* 1095085 */   // Label 16108: @1095085
     /* 1095085 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1095165), // Rule ID 16685 //
     /* 1095090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1095093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1095101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1095104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1095107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1095110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095129 */     // MIs[0] round
     /* 1095129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1095142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095164 */     // GIR_Coverage, 16685,
     /* 1095164 */     GIR_EraseRootFromParent_Done,
     /* 1095165 */   // Label 16109: @1095165
     /* 1095165 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1095245), // Rule ID 16688 //
     /* 1095170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1095173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1095190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095209 */     // MIs[0] round
     /* 1095209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095219 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1095222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095244 */     // GIR_Coverage, 16688,
     /* 1095244 */     GIR_EraseRootFromParent_Done,
     /* 1095245 */   // Label 16110: @1095245
     /* 1095245 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1095325), // Rule ID 16689 //
     /* 1095250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1095253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1095270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095289 */     // MIs[0] round
     /* 1095289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095299 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1095302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095324 */     // GIR_Coverage, 16689,
     /* 1095324 */     GIR_EraseRootFromParent_Done,
     /* 1095325 */   // Label 16111: @1095325
     /* 1095325 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1095405), // Rule ID 16692 //
     /* 1095330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1095333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1095350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095369 */     // MIs[0] round
     /* 1095369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095379 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1095382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095404 */     // GIR_Coverage, 16692,
     /* 1095404 */     GIR_EraseRootFromParent_Done,
     /* 1095405 */   // Label 16112: @1095405
     /* 1095405 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1095485), // Rule ID 16693 //
     /* 1095410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1095413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1095430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095449 */     // MIs[0] round
     /* 1095449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095459 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1095462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095484 */     // GIR_Coverage, 16693,
     /* 1095484 */     GIR_EraseRootFromParent_Done,
     /* 1095485 */   // Label 16113: @1095485
     /* 1095485 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1095565), // Rule ID 16696 //
     /* 1095490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1095493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1095510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095529 */     // MIs[0] round
     /* 1095529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095539 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1095542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095564 */     // GIR_Coverage, 16696,
     /* 1095564 */     GIR_EraseRootFromParent_Done,
     /* 1095565 */   // Label 16114: @1095565
     /* 1095565 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1095645), // Rule ID 16697 //
     /* 1095570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1095573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1095590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095609 */     // MIs[0] round
     /* 1095609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095619 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1095622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095644 */     // GIR_Coverage, 16697,
     /* 1095644 */     GIR_EraseRootFromParent_Done,
     /* 1095645 */   // Label 16115: @1095645
     /* 1095645 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1095725), // Rule ID 16700 //
     /* 1095650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1095653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1095670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095689 */     // MIs[0] round
     /* 1095689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095699 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1095702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095724 */     // GIR_Coverage, 16700,
     /* 1095724 */     GIR_EraseRootFromParent_Done,
     /* 1095725 */   // Label 16116: @1095725
     /* 1095725 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1095805), // Rule ID 16701 //
     /* 1095730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1095733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1095750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095769 */     // MIs[0] round
     /* 1095769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095779 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1095782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095804 */     // GIR_Coverage, 16701,
     /* 1095804 */     GIR_EraseRootFromParent_Done,
     /* 1095805 */   // Label 16117: @1095805
     /* 1095805 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1095885), // Rule ID 16704 //
     /* 1095810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1095813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1095830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095849 */     // MIs[0] round
     /* 1095849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1095859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1095862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095884 */     // GIR_Coverage, 16704,
     /* 1095884 */     GIR_EraseRootFromParent_Done,
     /* 1095885 */   // Label 16118: @1095885
     /* 1095885 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1095965), // Rule ID 16705 //
     /* 1095890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1095893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1095910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1095913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095929 */     // MIs[0] round
     /* 1095929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1095932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1095939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1095942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1095948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1095950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1095952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1095963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095964 */     // GIR_Coverage, 16705,
     /* 1095964 */     GIR_EraseRootFromParent_Done,
     /* 1095965 */   // Label 16119: @1095965
     /* 1095965 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1096045), // Rule ID 16708 //
     /* 1095970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1095973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1095978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1095990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1095993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096009 */     // MIs[0] round
     /* 1096009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096019 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1096022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096044 */     // GIR_Coverage, 16708,
     /* 1096044 */     GIR_EraseRootFromParent_Done,
     /* 1096045 */   // Label 16120: @1096045
     /* 1096045 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1096125), // Rule ID 16709 //
     /* 1096050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1096053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1096070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096089 */     // MIs[0] round
     /* 1096089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1096102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096124 */     // GIR_Coverage, 16709,
     /* 1096124 */     GIR_EraseRootFromParent_Done,
     /* 1096125 */   // Label 16121: @1096125
     /* 1096125 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1096205), // Rule ID 16712 //
     /* 1096130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1096133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1096150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096169 */     // MIs[0] round
     /* 1096169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096179 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1096182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096204 */     // GIR_Coverage, 16712,
     /* 1096204 */     GIR_EraseRootFromParent_Done,
     /* 1096205 */   // Label 16122: @1096205
     /* 1096205 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1096285), // Rule ID 16713 //
     /* 1096210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1096213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1096230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096249 */     // MIs[0] round
     /* 1096249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096259 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1096262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096284 */     // GIR_Coverage, 16713,
     /* 1096284 */     GIR_EraseRootFromParent_Done,
     /* 1096285 */   // Label 16123: @1096285
     /* 1096285 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1096365), // Rule ID 16716 //
     /* 1096290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1096293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1096310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096329 */     // MIs[0] round
     /* 1096329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096339 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1096342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096364 */     // GIR_Coverage, 16716,
     /* 1096364 */     GIR_EraseRootFromParent_Done,
     /* 1096365 */   // Label 16124: @1096365
     /* 1096365 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1096445), // Rule ID 16717 //
     /* 1096370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1096373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1096390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096409 */     // MIs[0] round
     /* 1096409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096419 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1096422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096444 */     // GIR_Coverage, 16717,
     /* 1096444 */     GIR_EraseRootFromParent_Done,
     /* 1096445 */   // Label 16125: @1096445
     /* 1096445 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1096525), // Rule ID 16720 //
     /* 1096450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1096453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1096470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096489 */     // MIs[0] round
     /* 1096489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096499 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1096502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096524 */     // GIR_Coverage, 16720,
     /* 1096524 */     GIR_EraseRootFromParent_Done,
     /* 1096525 */   // Label 16126: @1096525
     /* 1096525 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1096605), // Rule ID 16721 //
     /* 1096530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1096533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1096550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096569 */     // MIs[0] round
     /* 1096569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096579 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1096582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096604 */     // GIR_Coverage, 16721,
     /* 1096604 */     GIR_EraseRootFromParent_Done,
     /* 1096605 */   // Label 16127: @1096605
     /* 1096605 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1096685), // Rule ID 16724 //
     /* 1096610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1096613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1096630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096649 */     // MIs[0] round
     /* 1096649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096659 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1096662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096684 */     // GIR_Coverage, 16724,
     /* 1096684 */     GIR_EraseRootFromParent_Done,
     /* 1096685 */   // Label 16128: @1096685
     /* 1096685 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1096765), // Rule ID 16725 //
     /* 1096690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1096693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1096710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096729 */     // MIs[0] round
     /* 1096729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096739 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1096742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096764 */     // GIR_Coverage, 16725,
     /* 1096764 */     GIR_EraseRootFromParent_Done,
     /* 1096765 */   // Label 16129: @1096765
     /* 1096765 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1096845), // Rule ID 16728 //
     /* 1096770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1096773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1096781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1096784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1096787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1096790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1096809 */     // MIs[0] round
     /* 1096809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096819 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1096822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096844 */     // GIR_Coverage, 16728,
     /* 1096844 */     GIR_EraseRootFromParent_Done,
     /* 1096845 */   // Label 16130: @1096845
     /* 1096845 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1096925), // Rule ID 16729 //
     /* 1096850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1096853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1096861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1096864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1096867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1096870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1096873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1096889 */     // MIs[0] round
     /* 1096889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096899 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1096899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1096902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1096923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096924 */     // GIR_Coverage, 16729,
     /* 1096924 */     GIR_EraseRootFromParent_Done,
     /* 1096925 */   // Label 16131: @1096925
     /* 1096925 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1097005), // Rule ID 16732 //
     /* 1096930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1096933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1096938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1096941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1096944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1096947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1096950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1096953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1096969 */     // MIs[0] round
     /* 1096969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1096972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096979 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1096979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1096982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1096988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1096990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1096992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097004 */     // GIR_Coverage, 16732,
     /* 1097004 */     GIR_EraseRootFromParent_Done,
     /* 1097005 */   // Label 16132: @1097005
     /* 1097005 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1097085), // Rule ID 16733 //
     /* 1097010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1097013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097049 */     // MIs[0] round
     /* 1097049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097059 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1097062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097084 */     // GIR_Coverage, 16733,
     /* 1097084 */     GIR_EraseRootFromParent_Done,
     /* 1097085 */   // Label 16133: @1097085
     /* 1097085 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1097165), // Rule ID 16736 //
     /* 1097090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1097093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1097110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1097129 */     // MIs[0] round
     /* 1097129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097139 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1097142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097164 */     // GIR_Coverage, 16736,
     /* 1097164 */     GIR_EraseRootFromParent_Done,
     /* 1097165 */   // Label 16134: @1097165
     /* 1097165 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1097245), // Rule ID 16737 //
     /* 1097170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1097173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1097190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1097209 */     // MIs[0] round
     /* 1097209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097219 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1097222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097244 */     // GIR_Coverage, 16737,
     /* 1097244 */     GIR_EraseRootFromParent_Done,
     /* 1097245 */   // Label 16135: @1097245
     /* 1097245 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1097325), // Rule ID 16740 //
     /* 1097250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1097253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097289 */     // MIs[0] round
     /* 1097289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1097302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097324 */     // GIR_Coverage, 16740,
     /* 1097324 */     GIR_EraseRootFromParent_Done,
     /* 1097325 */   // Label 16136: @1097325
     /* 1097325 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1097405), // Rule ID 16741 //
     /* 1097330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1097333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097369 */     // MIs[0] round
     /* 1097369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097379 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10968:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1097382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097404 */     // GIR_Coverage, 16741,
     /* 1097404 */     GIR_EraseRootFromParent_Done,
     /* 1097405 */   // Label 16137: @1097405
     /* 1097405 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1097485), // Rule ID 16744 //
     /* 1097410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1097413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1097430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1097449 */     // MIs[0] round
     /* 1097449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1097462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097484 */     // GIR_Coverage, 16744,
     /* 1097484 */     GIR_EraseRootFromParent_Done,
     /* 1097485 */   // Label 16138: @1097485
     /* 1097485 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1097565), // Rule ID 16745 //
     /* 1097490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1097493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1097510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1097529 */     // MIs[0] round
     /* 1097529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10968:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1097542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097564 */     // GIR_Coverage, 16745,
     /* 1097564 */     GIR_EraseRootFromParent_Done,
     /* 1097565 */   // Label 16139: @1097565
     /* 1097565 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1097645), // Rule ID 16748 //
     /* 1097570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1097573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1097590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1097609 */     // MIs[0] round
     /* 1097609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097619 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1097622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097644 */     // GIR_Coverage, 16748,
     /* 1097644 */     GIR_EraseRootFromParent_Done,
     /* 1097645 */   // Label 16140: @1097645
     /* 1097645 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1097725), // Rule ID 16749 //
     /* 1097650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1097653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1097670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1097689 */     // MIs[0] round
     /* 1097689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097699 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10968:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1097702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097724 */     // GIR_Coverage, 16749,
     /* 1097724 */     GIR_EraseRootFromParent_Done,
     /* 1097725 */   // Label 16141: @1097725
     /* 1097725 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1097805), // Rule ID 16752 //
     /* 1097730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1097733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1097741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1097744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1097747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097769 */     // MIs[0] round
     /* 1097769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097779 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1097782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097804 */     // GIR_Coverage, 16752,
     /* 1097804 */     GIR_EraseRootFromParent_Done,
     /* 1097805 */   // Label 16142: @1097805
     /* 1097805 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1097885), // Rule ID 16753 //
     /* 1097810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1097813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1097821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1097824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1097827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097849 */     // MIs[0] round
     /* 1097849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097859 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1097859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1097862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097884 */     // GIR_Coverage, 16753,
     /* 1097884 */     GIR_EraseRootFromParent_Done,
     /* 1097885 */   // Label 16143: @1097885
     /* 1097885 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1097965), // Rule ID 16756 //
     /* 1097890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1097893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1097901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1097904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1097907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1097913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1097929 */     // MIs[0] round
     /* 1097929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1097932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097939 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1097939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1097942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1097948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1097950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1097952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1097963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097964 */     // GIR_Coverage, 16756,
     /* 1097964 */     GIR_EraseRootFromParent_Done,
     /* 1097965 */   // Label 16144: @1097965
     /* 1097965 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1098045), // Rule ID 16757 //
     /* 1097970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1097973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1097978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1097981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1097984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1097987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1097990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1097993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1098009 */     // MIs[0] round
     /* 1098009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098019 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1098022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098044 */     // GIR_Coverage, 16757,
     /* 1098044 */     GIR_EraseRootFromParent_Done,
     /* 1098045 */   // Label 16145: @1098045
     /* 1098045 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1098125), // Rule ID 16760 //
     /* 1098050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1098053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1098070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1098089 */     // MIs[0] round
     /* 1098089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098099 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1098102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098124 */     // GIR_Coverage, 16760,
     /* 1098124 */     GIR_EraseRootFromParent_Done,
     /* 1098125 */   // Label 16146: @1098125
     /* 1098125 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1098205), // Rule ID 16761 //
     /* 1098130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1098133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1098150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1098169 */     // MIs[0] round
     /* 1098169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098179 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1098182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098204 */     // GIR_Coverage, 16761,
     /* 1098204 */     GIR_EraseRootFromParent_Done,
     /* 1098205 */   // Label 16147: @1098205
     /* 1098205 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1098285), // Rule ID 16764 //
     /* 1098210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1098213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1098221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1098224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1098227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098249 */     // MIs[0] round
     /* 1098249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098259 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1098262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098284 */     // GIR_Coverage, 16764,
     /* 1098284 */     GIR_EraseRootFromParent_Done,
     /* 1098285 */   // Label 16148: @1098285
     /* 1098285 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1098365), // Rule ID 16765 //
     /* 1098290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1098293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1098301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1098304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1098307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098329 */     // MIs[0] round
     /* 1098329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1098342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098364 */     // GIR_Coverage, 16765,
     /* 1098364 */     GIR_EraseRootFromParent_Done,
     /* 1098365 */   // Label 16149: @1098365
     /* 1098365 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1098445), // Rule ID 16768 //
     /* 1098370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1098373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1098381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1098384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1098387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098409 */     // MIs[0] round
     /* 1098409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098419 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1098422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098444 */     // GIR_Coverage, 16768,
     /* 1098444 */     GIR_EraseRootFromParent_Done,
     /* 1098445 */   // Label 16150: @1098445
     /* 1098445 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1098525), // Rule ID 16769 //
     /* 1098450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1098453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1098461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1098464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1098467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098489 */     // MIs[0] round
     /* 1098489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098499 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1098502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098524 */     // GIR_Coverage, 16769,
     /* 1098524 */     GIR_EraseRootFromParent_Done,
     /* 1098525 */   // Label 16151: @1098525
     /* 1098525 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1098605), // Rule ID 16772 //
     /* 1098530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1098533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1098541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1098544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1098547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098569 */     // MIs[0] round
     /* 1098569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098579 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1098582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098604 */     // GIR_Coverage, 16772,
     /* 1098604 */     GIR_EraseRootFromParent_Done,
     /* 1098605 */   // Label 16152: @1098605
     /* 1098605 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1098685), // Rule ID 16773 //
     /* 1098610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1098613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1098621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1098624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1098627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1098630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1098649 */     // MIs[0] round
     /* 1098649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098659 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1098662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098684 */     // GIR_Coverage, 16773,
     /* 1098684 */     GIR_EraseRootFromParent_Done,
     /* 1098685 */   // Label 16153: @1098685
     /* 1098685 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1098765), // Rule ID 16776 //
     /* 1098690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1098693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1098701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1098704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1098707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1098710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1098729 */     // MIs[0] round
     /* 1098729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098739 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1098742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098764 */     // GIR_Coverage, 16776,
     /* 1098764 */     GIR_EraseRootFromParent_Done,
     /* 1098765 */   // Label 16154: @1098765
     /* 1098765 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1098845), // Rule ID 16777 //
     /* 1098770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1098773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1098781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1098784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1098787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1098790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1098809 */     // MIs[0] round
     /* 1098809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098819 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10968:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1098822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098844 */     // GIR_Coverage, 16777,
     /* 1098844 */     GIR_EraseRootFromParent_Done,
     /* 1098845 */   // Label 16155: @1098845
     /* 1098845 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1098925), // Rule ID 16780 //
     /* 1098850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1098853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1098861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1098864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1098867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1098870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1098873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1098889 */     // MIs[0] round
     /* 1098889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098899 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1098899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1098902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1098923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098924 */     // GIR_Coverage, 16780,
     /* 1098924 */     GIR_EraseRootFromParent_Done,
     /* 1098925 */   // Label 16156: @1098925
     /* 1098925 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1099005), // Rule ID 16781 //
     /* 1098930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1098933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1098938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1098941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1098944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1098947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1098950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1098953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1098969 */     // MIs[0] round
     /* 1098969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1098972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098979 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10968:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1098979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1098982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1098988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1098990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1098992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099004 */     // GIR_Coverage, 16781,
     /* 1099004 */     GIR_EraseRootFromParent_Done,
     /* 1099005 */   // Label 16157: @1099005
     /* 1099005 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1099085), // Rule ID 16784 //
     /* 1099010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1099013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1099018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1099030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1099049 */     // MIs[0] round
     /* 1099049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099059 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1099062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099084 */     // GIR_Coverage, 16784,
     /* 1099084 */     GIR_EraseRootFromParent_Done,
     /* 1099085 */   // Label 16158: @1099085
     /* 1099085 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1099165), // Rule ID 16785 //
     /* 1099090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1099093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1099098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1099110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1099129 */     // MIs[0] round
     /* 1099129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099139 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10968:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1099142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099164 */     // GIR_Coverage, 16785,
     /* 1099164 */     GIR_EraseRootFromParent_Done,
     /* 1099165 */   // Label 16159: @1099165
     /* 1099165 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1099245), // Rule ID 16788 //
     /* 1099170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1099173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1099181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1099184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1099187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099209 */     // MIs[0] round
     /* 1099209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099219 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1099222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099244 */     // GIR_Coverage, 16788,
     /* 1099244 */     GIR_EraseRootFromParent_Done,
     /* 1099245 */   // Label 16160: @1099245
     /* 1099245 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1099325), // Rule ID 16789 //
     /* 1099250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1099253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1099261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1099264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1099267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099289 */     // MIs[0] round
     /* 1099289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099299 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1099302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099324 */     // GIR_Coverage, 16789,
     /* 1099324 */     GIR_EraseRootFromParent_Done,
     /* 1099325 */   // Label 16161: @1099325
     /* 1099325 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1099405), // Rule ID 16792 //
     /* 1099330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1099333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1099341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1099344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1099347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099369 */     // MIs[0] round
     /* 1099369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099379 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1099382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099404 */     // GIR_Coverage, 16792,
     /* 1099404 */     GIR_EraseRootFromParent_Done,
     /* 1099405 */   // Label 16162: @1099405
     /* 1099405 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1099485), // Rule ID 16793 //
     /* 1099410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1099413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1099421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1099424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1099427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099449 */     // MIs[0] round
     /* 1099449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099459 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1099462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099484 */     // GIR_Coverage, 16793,
     /* 1099484 */     GIR_EraseRootFromParent_Done,
     /* 1099485 */   // Label 16163: @1099485
     /* 1099485 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1099565), // Rule ID 16796 //
     /* 1099490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1099493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1099501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1099504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1099507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1099510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1099529 */     // MIs[0] round
     /* 1099529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099539 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1099542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099564 */     // GIR_Coverage, 16796,
     /* 1099564 */     GIR_EraseRootFromParent_Done,
     /* 1099565 */   // Label 16164: @1099565
     /* 1099565 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1099645), // Rule ID 16797 //
     /* 1099570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1099573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1099581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1099584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1099587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1099590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1099609 */     // MIs[0] round
     /* 1099609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099619 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1099622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099644 */     // GIR_Coverage, 16797,
     /* 1099644 */     GIR_EraseRootFromParent_Done,
     /* 1099645 */   // Label 16165: @1099645
     /* 1099645 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1099725), // Rule ID 16800 //
     /* 1099650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1099653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1099661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1099664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1099667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099689 */     // MIs[0] round
     /* 1099689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099699 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1099702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099724 */     // GIR_Coverage, 16800,
     /* 1099724 */     GIR_EraseRootFromParent_Done,
     /* 1099725 */   // Label 16166: @1099725
     /* 1099725 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1099805), // Rule ID 16801 //
     /* 1099730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1099733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1099741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1099744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1099747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1099750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1099769 */     // MIs[0] round
     /* 1099769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099779 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10954:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1099782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099804 */     // GIR_Coverage, 16801,
     /* 1099804 */     GIR_EraseRootFromParent_Done,
     /* 1099805 */   // Label 16167: @1099805
     /* 1099805 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1099885), // Rule ID 16804 //
     /* 1099810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1099813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1099821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1099824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1099827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1099830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1099849 */     // MIs[0] round
     /* 1099849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099859 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10954:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1099859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1099862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099884 */     // GIR_Coverage, 16804,
     /* 1099884 */     GIR_EraseRootFromParent_Done,
     /* 1099885 */   // Label 16168: @1099885
     /* 1099885 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1099965), // Rule ID 16805 //
     /* 1099890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1099893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1099901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1099904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1099907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1099910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1099913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1099929 */     // MIs[0] round
     /* 1099929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1099932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099939 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10954:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1099939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1099942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1099948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1099950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1099952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1099963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099964 */     // GIR_Coverage, 16805,
     /* 1099964 */     GIR_EraseRootFromParent_Done,
     /* 1099965 */   // Label 16169: @1099965
     /* 1099965 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1100045), // Rule ID 16808 //
     /* 1099970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1099973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1099978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1099981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1099984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1099987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1099990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1099993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1100009 */     // MIs[0] round
     /* 1100009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1100022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100044 */     // GIR_Coverage, 16808,
     /* 1100044 */     GIR_EraseRootFromParent_Done,
     /* 1100045 */   // Label 16170: @1100045
     /* 1100045 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1100125), // Rule ID 16809 //
     /* 1100050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1100053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1100061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1100064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1100067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1100070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1100089 */     // MIs[0] round
     /* 1100089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10954:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1100102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100124 */     // GIR_Coverage, 16809,
     /* 1100124 */     GIR_EraseRootFromParent_Done,
     /* 1100125 */   // Label 16171: @1100125
     /* 1100125 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1100205), // Rule ID 16812 //
     /* 1100130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1100133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1100141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1100144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1100147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100169 */     // MIs[0] round
     /* 1100169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100179 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1100182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100204 */     // GIR_Coverage, 16812,
     /* 1100204 */     GIR_EraseRootFromParent_Done,
     /* 1100205 */   // Label 16172: @1100205
     /* 1100205 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1100285), // Rule ID 16813 //
     /* 1100210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1100213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1100221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1100224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1100227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100249 */     // MIs[0] round
     /* 1100249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100259 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1100262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100284 */     // GIR_Coverage, 16813,
     /* 1100284 */     GIR_EraseRootFromParent_Done,
     /* 1100285 */   // Label 16173: @1100285
     /* 1100285 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1100365), // Rule ID 16816 //
     /* 1100290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1100293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1100301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1100304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1100307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100329 */     // MIs[0] round
     /* 1100329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100339 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1100342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100364 */     // GIR_Coverage, 16816,
     /* 1100364 */     GIR_EraseRootFromParent_Done,
     /* 1100365 */   // Label 16174: @1100365
     /* 1100365 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1100445), // Rule ID 16817 //
     /* 1100370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1100373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1100381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1100384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1100387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100409 */     // MIs[0] round
     /* 1100409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100419 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1100422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100444 */     // GIR_Coverage, 16817,
     /* 1100444 */     GIR_EraseRootFromParent_Done,
     /* 1100445 */   // Label 16175: @1100445
     /* 1100445 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1100525), // Rule ID 16820 //
     /* 1100450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1100453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1100461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1100464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1100467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100489 */     // MIs[0] round
     /* 1100489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100499 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1100502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100524 */     // GIR_Coverage, 16820,
     /* 1100524 */     GIR_EraseRootFromParent_Done,
     /* 1100525 */   // Label 16176: @1100525
     /* 1100525 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1100605), // Rule ID 16821 //
     /* 1100530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1100533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1100541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1100544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1100547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1100550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1100569 */     // MIs[0] round
     /* 1100569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100579 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1100582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100604 */     // GIR_Coverage, 16821,
     /* 1100604 */     GIR_EraseRootFromParent_Done,
     /* 1100605 */   // Label 16177: @1100605
     /* 1100605 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1100685), // Rule ID 16824 //
     /* 1100610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1100613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1100621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1100624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1100627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1100630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1100649 */     // MIs[0] round
     /* 1100649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100659 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1100662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100684 */     // GIR_Coverage, 16824,
     /* 1100684 */     GIR_EraseRootFromParent_Done,
     /* 1100685 */   // Label 16178: @1100685
     /* 1100685 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1100765), // Rule ID 16825 //
     /* 1100690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1100693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1100701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1100704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1100707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1100710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1100729 */     // MIs[0] round
     /* 1100729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1100742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100764 */     // GIR_Coverage, 16825,
     /* 1100764 */     GIR_EraseRootFromParent_Done,
     /* 1100765 */   // Label 16179: @1100765
     /* 1100765 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1100845), // Rule ID 16828 //
     /* 1100770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1100773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1100781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1100784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1100787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1100790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1100809 */     // MIs[0] round
     /* 1100809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100819 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1100822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100844 */     // GIR_Coverage, 16828,
     /* 1100844 */     GIR_EraseRootFromParent_Done,
     /* 1100845 */   // Label 16180: @1100845
     /* 1100845 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1100925), // Rule ID 16829 //
     /* 1100850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1100853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1100861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1100864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1100867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1100870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1100873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1100889 */     // MIs[0] round
     /* 1100889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100899 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1100899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1100902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1100923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100924 */     // GIR_Coverage, 16829,
     /* 1100924 */     GIR_EraseRootFromParent_Done,
     /* 1100925 */   // Label 16181: @1100925
     /* 1100925 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1101005), // Rule ID 16832 //
     /* 1100930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1100933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1100938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1100941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1100944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1100947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1100950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1100953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1100969 */     // MIs[0] round
     /* 1100969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1100972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100979 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1100979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1100982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1100988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1100990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1100992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101004 */     // GIR_Coverage, 16832,
     /* 1101004 */     GIR_EraseRootFromParent_Done,
     /* 1101005 */   // Label 16182: @1101005
     /* 1101005 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1101085), // Rule ID 16833 //
     /* 1101010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1101013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1101021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1101024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1101027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1101030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1101049 */     // MIs[0] round
     /* 1101049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101059 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1101062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101084 */     // GIR_Coverage, 16833,
     /* 1101084 */     GIR_EraseRootFromParent_Done,
     /* 1101085 */   // Label 16183: @1101085
     /* 1101085 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1101165), // Rule ID 16836 //
     /* 1101090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1101093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1101101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1101104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1101107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101129 */     // MIs[0] round
     /* 1101129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101139 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1101142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101164 */     // GIR_Coverage, 16836,
     /* 1101164 */     GIR_EraseRootFromParent_Done,
     /* 1101165 */   // Label 16184: @1101165
     /* 1101165 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1101245), // Rule ID 16837 //
     /* 1101170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1101173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1101181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1101184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1101187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101209 */     // MIs[0] round
     /* 1101209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101219 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10954:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1101222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101244 */     // GIR_Coverage, 16837,
     /* 1101244 */     GIR_EraseRootFromParent_Done,
     /* 1101245 */   // Label 16185: @1101245
     /* 1101245 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1101325), // Rule ID 16840 //
     /* 1101250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1101253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1101261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1101264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1101267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101289 */     // MIs[0] round
     /* 1101289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1101302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101324 */     // GIR_Coverage, 16840,
     /* 1101324 */     GIR_EraseRootFromParent_Done,
     /* 1101325 */   // Label 16186: @1101325
     /* 1101325 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1101405), // Rule ID 16841 //
     /* 1101330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1101333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1101341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1101344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1101347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101369 */     // MIs[0] round
     /* 1101369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101379 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10954:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1101382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101404 */     // GIR_Coverage, 16841,
     /* 1101404 */     GIR_EraseRootFromParent_Done,
     /* 1101405 */   // Label 16187: @1101405
     /* 1101405 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1101485), // Rule ID 16844 //
     /* 1101410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1101413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1101421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1101424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1101427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101449 */     // MIs[0] round
     /* 1101449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101459 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1101462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101484 */     // GIR_Coverage, 16844,
     /* 1101484 */     GIR_EraseRootFromParent_Done,
     /* 1101485 */   // Label 16188: @1101485
     /* 1101485 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1101565), // Rule ID 16845 //
     /* 1101490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1101493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1101498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1101501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1101504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1101507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1101510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1101529 */     // MIs[0] round
     /* 1101529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101539 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10954:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1101542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101564 */     // GIR_Coverage, 16845,
     /* 1101564 */     GIR_EraseRootFromParent_Done,
     /* 1101565 */   // Label 16189: @1101565
     /* 1101565 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1101645), // Rule ID 16848 //
     /* 1101570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1101573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1101587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1101590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101609 */     // MIs[0] round
     /* 1101609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101619 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1101622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101644 */     // GIR_Coverage, 16848,
     /* 1101644 */     GIR_EraseRootFromParent_Done,
     /* 1101645 */   // Label 16190: @1101645
     /* 1101645 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1101725), // Rule ID 16849 //
     /* 1101650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1101653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1101667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1101670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101689 */     // MIs[0] round
     /* 1101689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101699 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1101702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101724 */     // GIR_Coverage, 16849,
     /* 1101724 */     GIR_EraseRootFromParent_Done,
     /* 1101725 */   // Label 16191: @1101725
     /* 1101725 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1101805), // Rule ID 16852 //
     /* 1101730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1101733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1101750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101769 */     // MIs[0] round
     /* 1101769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101779 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1101782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101804 */     // GIR_Coverage, 16852,
     /* 1101804 */     GIR_EraseRootFromParent_Done,
     /* 1101805 */   // Label 16192: @1101805
     /* 1101805 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1101885), // Rule ID 16853 //
     /* 1101810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1101813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1101830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101849 */     // MIs[0] round
     /* 1101849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101859 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1101859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1101862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101884 */     // GIR_Coverage, 16853,
     /* 1101884 */     GIR_EraseRootFromParent_Done,
     /* 1101885 */   // Label 16193: @1101885
     /* 1101885 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1101965), // Rule ID 16856 //
     /* 1101890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1101893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1101901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1101904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1101910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1101913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101929 */     // MIs[0] round
     /* 1101929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1101932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1101939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1101942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1101948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1101950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1101952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1101963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101964 */     // GIR_Coverage, 16856,
     /* 1101964 */     GIR_EraseRootFromParent_Done,
     /* 1101965 */   // Label 16194: @1101965
     /* 1101965 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1102045), // Rule ID 16857 //
     /* 1101970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1101973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1101978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1101981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1101984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1101990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1101993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102009 */     // MIs[0] round
     /* 1102009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102019 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1102022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102044 */     // GIR_Coverage, 16857,
     /* 1102044 */     GIR_EraseRootFromParent_Done,
     /* 1102045 */   // Label 16195: @1102045
     /* 1102045 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1102125), // Rule ID 16860 //
     /* 1102050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1102053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1102070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102089 */     // MIs[0] round
     /* 1102089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1102102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102124 */     // GIR_Coverage, 16860,
     /* 1102124 */     GIR_EraseRootFromParent_Done,
     /* 1102125 */   // Label 16196: @1102125
     /* 1102125 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1102205), // Rule ID 16861 //
     /* 1102130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1102133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1102150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102169 */     // MIs[0] round
     /* 1102169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102179 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1102182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102204 */     // GIR_Coverage, 16861,
     /* 1102204 */     GIR_EraseRootFromParent_Done,
     /* 1102205 */   // Label 16197: @1102205
     /* 1102205 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1102285), // Rule ID 16864 //
     /* 1102210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1102213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1102230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102249 */     // MIs[0] round
     /* 1102249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102259 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1102262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102284 */     // GIR_Coverage, 16864,
     /* 1102284 */     GIR_EraseRootFromParent_Done,
     /* 1102285 */   // Label 16198: @1102285
     /* 1102285 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1102365), // Rule ID 16865 //
     /* 1102290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1102293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1102310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102329 */     // MIs[0] round
     /* 1102329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102339 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1102342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102364 */     // GIR_Coverage, 16865,
     /* 1102364 */     GIR_EraseRootFromParent_Done,
     /* 1102365 */   // Label 16199: @1102365
     /* 1102365 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1102445), // Rule ID 16868 //
     /* 1102370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1102373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1102381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1102384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1102387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1102390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102409 */     // MIs[0] round
     /* 1102409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102419 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1102422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102444 */     // GIR_Coverage, 16868,
     /* 1102444 */     GIR_EraseRootFromParent_Done,
     /* 1102445 */   // Label 16200: @1102445
     /* 1102445 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1102525), // Rule ID 16869 //
     /* 1102450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1102453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1102461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1102464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1102467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1102470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102489 */     // MIs[0] round
     /* 1102489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1102502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102524 */     // GIR_Coverage, 16869,
     /* 1102524 */     GIR_EraseRootFromParent_Done,
     /* 1102525 */   // Label 16201: @1102525
     /* 1102525 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1102605), // Rule ID 16872 //
     /* 1102530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1102533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1102547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1102550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102569 */     // MIs[0] round
     /* 1102569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102579 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1102582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102604 */     // GIR_Coverage, 16872,
     /* 1102604 */     GIR_EraseRootFromParent_Done,
     /* 1102605 */   // Label 16202: @1102605
     /* 1102605 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1102685), // Rule ID 16873 //
     /* 1102610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1102613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1102627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1102630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102649 */     // MIs[0] round
     /* 1102649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102659 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1102662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102684 */     // GIR_Coverage, 16873,
     /* 1102684 */     GIR_EraseRootFromParent_Done,
     /* 1102685 */   // Label 16203: @1102685
     /* 1102685 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1102765), // Rule ID 16876 //
     /* 1102690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1102693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1102701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1102704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1102710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102729 */     // MIs[0] round
     /* 1102729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102739 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1102742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102764 */     // GIR_Coverage, 16876,
     /* 1102764 */     GIR_EraseRootFromParent_Done,
     /* 1102765 */   // Label 16204: @1102765
     /* 1102765 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1102845), // Rule ID 16877 //
     /* 1102770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1102773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1102781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1102784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1102790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102809 */     // MIs[0] round
     /* 1102809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102819 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1102822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102844 */     // GIR_Coverage, 16877,
     /* 1102844 */     GIR_EraseRootFromParent_Done,
     /* 1102845 */   // Label 16205: @1102845
     /* 1102845 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1102925), // Rule ID 16880 //
     /* 1102850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1102853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1102861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1102864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1102870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1102873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102889 */     // MIs[0] round
     /* 1102889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102899 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1102899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1102902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1102923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102924 */     // GIR_Coverage, 16880,
     /* 1102924 */     GIR_EraseRootFromParent_Done,
     /* 1102925 */   // Label 16206: @1102925
     /* 1102925 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1103005), // Rule ID 16881 //
     /* 1102930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1102933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1102938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1102941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1102944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1102950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1102953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102969 */     // MIs[0] round
     /* 1102969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1102972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102979 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1102979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1102982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1102988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1102990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1102992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103004 */     // GIR_Coverage, 16881,
     /* 1103004 */     GIR_EraseRootFromParent_Done,
     /* 1103005 */   // Label 16207: @1103005
     /* 1103005 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1103085), // Rule ID 16884 //
     /* 1103010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1103013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1103021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1103024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103049 */     // MIs[0] round
     /* 1103049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103059 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1103062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103084 */     // GIR_Coverage, 16884,
     /* 1103084 */     GIR_EraseRootFromParent_Done,
     /* 1103085 */   // Label 16208: @1103085
     /* 1103085 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1103165), // Rule ID 16885 //
     /* 1103090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1103093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1103101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1103104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103129 */     // MIs[0] round
     /* 1103129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103139 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1103142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103164 */     // GIR_Coverage, 16885,
     /* 1103164 */     GIR_EraseRootFromParent_Done,
     /* 1103165 */   // Label 16209: @1103165
     /* 1103165 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1103245), // Rule ID 16888 //
     /* 1103170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1103173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1103181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1103184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103209 */     // MIs[0] round
     /* 1103209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1103222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103244 */     // GIR_Coverage, 16888,
     /* 1103244 */     GIR_EraseRootFromParent_Done,
     /* 1103245 */   // Label 16210: @1103245
     /* 1103245 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1103325), // Rule ID 16889 //
     /* 1103250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1103253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1103261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1103264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103289 */     // MIs[0] round
     /* 1103289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10970:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1103302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103324 */     // GIR_Coverage, 16889,
     /* 1103324 */     GIR_EraseRootFromParent_Done,
     /* 1103325 */   // Label 16211: @1103325
     /* 1103325 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1103405), // Rule ID 16892 //
     /* 1103330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1103333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1103341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1103344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1103347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103369 */     // MIs[0] round
     /* 1103369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103379 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1103382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103404 */     // GIR_Coverage, 16892,
     /* 1103404 */     GIR_EraseRootFromParent_Done,
     /* 1103405 */   // Label 16212: @1103405
     /* 1103405 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1103485), // Rule ID 16893 //
     /* 1103410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1103413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1103421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1103424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1103427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103449 */     // MIs[0] round
     /* 1103449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1103462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103484 */     // GIR_Coverage, 16893,
     /* 1103484 */     GIR_EraseRootFromParent_Done,
     /* 1103485 */   // Label 16213: @1103485
     /* 1103485 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1103565), // Rule ID 16896 //
     /* 1103490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1103493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1103507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103529 */     // MIs[0] round
     /* 1103529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103539 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1103542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103564 */     // GIR_Coverage, 16896,
     /* 1103564 */     GIR_EraseRootFromParent_Done,
     /* 1103565 */   // Label 16214: @1103565
     /* 1103565 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1103645), // Rule ID 16897 //
     /* 1103570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1103573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1103587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103609 */     // MIs[0] round
     /* 1103609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103619 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1103622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103644 */     // GIR_Coverage, 16897,
     /* 1103644 */     GIR_EraseRootFromParent_Done,
     /* 1103645 */   // Label 16215: @1103645
     /* 1103645 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1103725), // Rule ID 16900 //
     /* 1103650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1103653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1103667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103689 */     // MIs[0] round
     /* 1103689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103699 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1103702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103724 */     // GIR_Coverage, 16900,
     /* 1103724 */     GIR_EraseRootFromParent_Done,
     /* 1103725 */   // Label 16216: @1103725
     /* 1103725 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1103805), // Rule ID 16901 //
     /* 1103730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1103733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1103747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1103750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1103769 */     // MIs[0] round
     /* 1103769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103779 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1103782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103804 */     // GIR_Coverage, 16901,
     /* 1103804 */     GIR_EraseRootFromParent_Done,
     /* 1103805 */   // Label 16217: @1103805
     /* 1103805 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1103885), // Rule ID 16904 //
     /* 1103810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1103813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1103821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1103824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1103827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1103830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1103849 */     // MIs[0] round
     /* 1103849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1103859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1103862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103884 */     // GIR_Coverage, 16904,
     /* 1103884 */     GIR_EraseRootFromParent_Done,
     /* 1103885 */   // Label 16218: @1103885
     /* 1103885 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1103965), // Rule ID 16905 //
     /* 1103890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1103893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1103901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1103904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1103907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1103910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1103913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1103929 */     // MIs[0] round
     /* 1103929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1103932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10970:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1103939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1103942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1103948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1103950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1103952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1103963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103964 */     // GIR_Coverage, 16905,
     /* 1103964 */     GIR_EraseRootFromParent_Done,
     /* 1103965 */   // Label 16219: @1103965
     /* 1103965 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1104045), // Rule ID 16908 //
     /* 1103970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1103973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1103978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1103987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1103990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1103993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104009 */     // MIs[0] round
     /* 1104009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104019 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1104022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104044 */     // GIR_Coverage, 16908,
     /* 1104044 */     GIR_EraseRootFromParent_Done,
     /* 1104045 */   // Label 16220: @1104045
     /* 1104045 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1104125), // Rule ID 16909 //
     /* 1104050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1104053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1104058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1104061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1104064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1104070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104089 */     // MIs[0] round
     /* 1104089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104099 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10970:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1104102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104124 */     // GIR_Coverage, 16909,
     /* 1104124 */     GIR_EraseRootFromParent_Done,
     /* 1104125 */   // Label 16221: @1104125
     /* 1104125 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1104205), // Rule ID 16912 //
     /* 1104130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1104133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1104138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1104141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1104144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1104147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1104150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104169 */     // MIs[0] round
     /* 1104169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104179 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1104182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104204 */     // GIR_Coverage, 16912,
     /* 1104204 */     GIR_EraseRootFromParent_Done,
     /* 1104205 */   // Label 16222: @1104205
     /* 1104205 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1104285), // Rule ID 16913 //
     /* 1104210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1104213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1104218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1104221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1104224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1104227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1104230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104249 */     // MIs[0] round
     /* 1104249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104259 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10970:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1104262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104284 */     // GIR_Coverage, 16913,
     /* 1104284 */     GIR_EraseRootFromParent_Done,
     /* 1104285 */   // Label 16223: @1104285
     /* 1104285 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1104365), // Rule ID 16916 //
     /* 1104290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1104293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1104298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1104301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1104304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1104307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1104310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104329 */     // MIs[0] round
     /* 1104329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104339 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1104342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104364 */     // GIR_Coverage, 16916,
     /* 1104364 */     GIR_EraseRootFromParent_Done,
     /* 1104365 */   // Label 16224: @1104365
     /* 1104365 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1104445), // Rule ID 16917 //
     /* 1104370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1104373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1104378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1104381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1104384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1104387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1104390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1104409 */     // MIs[0] round
     /* 1104409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104419 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10970:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1104422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104444 */     // GIR_Coverage, 16917,
     /* 1104444 */     GIR_EraseRootFromParent_Done,
     /* 1104445 */   // Label 16225: @1104445
     /* 1104445 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1104525), // Rule ID 16920 //
     /* 1104450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1104453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1104470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104489 */     // MIs[0] round
     /* 1104489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104499 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1104502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104524 */     // GIR_Coverage, 16920,
     /* 1104524 */     GIR_EraseRootFromParent_Done,
     /* 1104525 */   // Label 16226: @1104525
     /* 1104525 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1104605), // Rule ID 16921 //
     /* 1104530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1104533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1104550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104569 */     // MIs[0] round
     /* 1104569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104579 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1104582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104604 */     // GIR_Coverage, 16921,
     /* 1104604 */     GIR_EraseRootFromParent_Done,
     /* 1104605 */   // Label 16227: @1104605
     /* 1104605 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1104685), // Rule ID 16924 //
     /* 1104610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1104613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1104630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104649 */     // MIs[0] round
     /* 1104649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1104662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104684 */     // GIR_Coverage, 16924,
     /* 1104684 */     GIR_EraseRootFromParent_Done,
     /* 1104685 */   // Label 16228: @1104685
     /* 1104685 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1104765), // Rule ID 16925 //
     /* 1104690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1104693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1104710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104729 */     // MIs[0] round
     /* 1104729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1104742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104764 */     // GIR_Coverage, 16925,
     /* 1104764 */     GIR_EraseRootFromParent_Done,
     /* 1104765 */   // Label 16229: @1104765
     /* 1104765 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1104845), // Rule ID 16928 //
     /* 1104770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1104773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1104781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1104784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1104790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104809 */     // MIs[0] round
     /* 1104809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1104822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104844 */     // GIR_Coverage, 16928,
     /* 1104844 */     GIR_EraseRootFromParent_Done,
     /* 1104845 */   // Label 16230: @1104845
     /* 1104845 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1104925), // Rule ID 16929 //
     /* 1104850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1104853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1104861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1104864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1104870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1104873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104889 */     // MIs[0] round
     /* 1104889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1104923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104924 */     // GIR_Coverage, 16929,
     /* 1104924 */     GIR_EraseRootFromParent_Done,
     /* 1104925 */   // Label 16231: @1104925
     /* 1104925 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1105005), // Rule ID 16932 //
     /* 1104930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1104933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1104938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1104941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1104944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1104947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1104950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1104953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104969 */     // MIs[0] round
     /* 1104969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1104972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104979 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1104979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1104982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1104988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1104990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1104992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105004 */     // GIR_Coverage, 16932,
     /* 1105004 */     GIR_EraseRootFromParent_Done,
     /* 1105005 */   // Label 16232: @1105005
     /* 1105005 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1105085), // Rule ID 16933 //
     /* 1105010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1105013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1105021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1105024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1105030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105049 */     // MIs[0] round
     /* 1105049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105059 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1105062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105084 */     // GIR_Coverage, 16933,
     /* 1105084 */     GIR_EraseRootFromParent_Done,
     /* 1105085 */   // Label 16233: @1105085
     /* 1105085 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1105165), // Rule ID 16936 //
     /* 1105090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1105093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1105101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1105104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1105110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105129 */     // MIs[0] round
     /* 1105129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105139 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1105142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105164 */     // GIR_Coverage, 16936,
     /* 1105164 */     GIR_EraseRootFromParent_Done,
     /* 1105165 */   // Label 16234: @1105165
     /* 1105165 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1105245), // Rule ID 16937 //
     /* 1105170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1105173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1105181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1105184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1105190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105209 */     // MIs[0] round
     /* 1105209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105219 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1105222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105244 */     // GIR_Coverage, 16937,
     /* 1105244 */     GIR_EraseRootFromParent_Done,
     /* 1105245 */   // Label 16235: @1105245
     /* 1105245 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1105325), // Rule ID 16940 //
     /* 1105250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1105253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1105267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1105270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105289 */     // MIs[0] round
     /* 1105289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105299 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1105302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105324 */     // GIR_Coverage, 16940,
     /* 1105324 */     GIR_EraseRootFromParent_Done,
     /* 1105325 */   // Label 16236: @1105325
     /* 1105325 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1105405), // Rule ID 16941 //
     /* 1105330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1105333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1105347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1105350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105369 */     // MIs[0] round
     /* 1105369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105379 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1105382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105404 */     // GIR_Coverage, 16941,
     /* 1105404 */     GIR_EraseRootFromParent_Done,
     /* 1105405 */   // Label 16237: @1105405
     /* 1105405 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1105485), // Rule ID 16944 //
     /* 1105410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1105413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1105421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1105424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1105430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105449 */     // MIs[0] round
     /* 1105449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105459 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1105462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105484 */     // GIR_Coverage, 16944,
     /* 1105484 */     GIR_EraseRootFromParent_Done,
     /* 1105485 */   // Label 16238: @1105485
     /* 1105485 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1105565), // Rule ID 16945 //
     /* 1105490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1105493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1105501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1105504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1105510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105529 */     // MIs[0] round
     /* 1105529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1105542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105564 */     // GIR_Coverage, 16945,
     /* 1105564 */     GIR_EraseRootFromParent_Done,
     /* 1105565 */   // Label 16239: @1105565
     /* 1105565 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1105645), // Rule ID 16948 //
     /* 1105570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1105573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1105581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1105584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1105590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105609 */     // MIs[0] round
     /* 1105609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105619 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1105622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105644 */     // GIR_Coverage, 16948,
     /* 1105644 */     GIR_EraseRootFromParent_Done,
     /* 1105645 */   // Label 16240: @1105645
     /* 1105645 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1105725), // Rule ID 16949 //
     /* 1105650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1105653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1105661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1105664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1105670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105689 */     // MIs[0] round
     /* 1105689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105699 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1105702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105724 */     // GIR_Coverage, 16949,
     /* 1105724 */     GIR_EraseRootFromParent_Done,
     /* 1105725 */   // Label 16241: @1105725
     /* 1105725 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1105805), // Rule ID 16952 //
     /* 1105730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1105733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1105741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1105744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1105750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105769 */     // MIs[0] round
     /* 1105769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105779 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1105782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105804 */     // GIR_Coverage, 16952,
     /* 1105804 */     GIR_EraseRootFromParent_Done,
     /* 1105805 */   // Label 16242: @1105805
     /* 1105805 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1105885), // Rule ID 16953 //
     /* 1105810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1105813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1105821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1105824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1105830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105849 */     // MIs[0] round
     /* 1105849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105859 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1105859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1105862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105884 */     // GIR_Coverage, 16953,
     /* 1105884 */     GIR_EraseRootFromParent_Done,
     /* 1105885 */   // Label 16243: @1105885
     /* 1105885 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1105965), // Rule ID 16956 //
     /* 1105890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1105893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1105901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1105904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1105907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1105910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1105913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1105929 */     // MIs[0] round
     /* 1105929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1105932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105939 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1105939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1105942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1105948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1105950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1105952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1105963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105964 */     // GIR_Coverage, 16956,
     /* 1105964 */     GIR_EraseRootFromParent_Done,
     /* 1105965 */   // Label 16244: @1105965
     /* 1105965 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1106045), // Rule ID 16957 //
     /* 1105970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1105973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1105978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1105981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1105984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1105987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1105990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1105993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106009 */     // MIs[0] round
     /* 1106009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106019 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1106022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106044 */     // GIR_Coverage, 16957,
     /* 1106044 */     GIR_EraseRootFromParent_Done,
     /* 1106045 */   // Label 16245: @1106045
     /* 1106045 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1106125), // Rule ID 16960 //
     /* 1106050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1106053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1106067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106089 */     // MIs[0] round
     /* 1106089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1106102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106124 */     // GIR_Coverage, 16960,
     /* 1106124 */     GIR_EraseRootFromParent_Done,
     /* 1106125 */   // Label 16246: @1106125
     /* 1106125 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1106205), // Rule ID 16961 //
     /* 1106130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1106133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1106147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106169 */     // MIs[0] round
     /* 1106169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106179 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1106182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106204 */     // GIR_Coverage, 16961,
     /* 1106204 */     GIR_EraseRootFromParent_Done,
     /* 1106205 */   // Label 16247: @1106205
     /* 1106205 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1106285), // Rule ID 16964 //
     /* 1106210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1106213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1106227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106249 */     // MIs[0] round
     /* 1106249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106259 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1106262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106284 */     // GIR_Coverage, 16964,
     /* 1106284 */     GIR_EraseRootFromParent_Done,
     /* 1106285 */   // Label 16248: @1106285
     /* 1106285 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1106365), // Rule ID 16965 //
     /* 1106290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1106293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1106307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106329 */     // MIs[0] round
     /* 1106329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1106342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106364 */     // GIR_Coverage, 16965,
     /* 1106364 */     GIR_EraseRootFromParent_Done,
     /* 1106365 */   // Label 16249: @1106365
     /* 1106365 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1106445), // Rule ID 16968 //
     /* 1106370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1106373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1106387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106409 */     // MIs[0] round
     /* 1106409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106419 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1106422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106444 */     // GIR_Coverage, 16968,
     /* 1106444 */     GIR_EraseRootFromParent_Done,
     /* 1106445 */   // Label 16250: @1106445
     /* 1106445 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1106525), // Rule ID 16969 //
     /* 1106450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1106453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1106467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106489 */     // MIs[0] round
     /* 1106489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106499 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1106502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106524 */     // GIR_Coverage, 16969,
     /* 1106524 */     GIR_EraseRootFromParent_Done,
     /* 1106525 */   // Label 16251: @1106525
     /* 1106525 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1106605), // Rule ID 16972 //
     /* 1106530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1106533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106569 */     // MIs[0] round
     /* 1106569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106579 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1106582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106604 */     // GIR_Coverage, 16972,
     /* 1106604 */     GIR_EraseRootFromParent_Done,
     /* 1106605 */   // Label 16252: @1106605
     /* 1106605 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1106685), // Rule ID 16973 //
     /* 1106610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1106613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1106630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1106649 */     // MIs[0] round
     /* 1106649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106659 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1106662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106684 */     // GIR_Coverage, 16973,
     /* 1106684 */     GIR_EraseRootFromParent_Done,
     /* 1106685 */   // Label 16253: @1106685
     /* 1106685 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1106765), // Rule ID 16976 //
     /* 1106690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1106693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1106701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1106704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1106707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1106710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1106729 */     // MIs[0] round
     /* 1106729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106739 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1106742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106764 */     // GIR_Coverage, 16976,
     /* 1106764 */     GIR_EraseRootFromParent_Done,
     /* 1106765 */   // Label 16254: @1106765
     /* 1106765 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1106845), // Rule ID 16977 //
     /* 1106770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1106773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1106781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1106784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1106787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1106790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1106809 */     // MIs[0] round
     /* 1106809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106819 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1106822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106844 */     // GIR_Coverage, 16977,
     /* 1106844 */     GIR_EraseRootFromParent_Done,
     /* 1106845 */   // Label 16255: @1106845
     /* 1106845 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1106925), // Rule ID 16980 //
     /* 1106850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1106853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1106870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1106873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1106889 */     // MIs[0] round
     /* 1106889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1106899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1106902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1106923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106924 */     // GIR_Coverage, 16980,
     /* 1106924 */     GIR_EraseRootFromParent_Done,
     /* 1106925 */   // Label 16256: @1106925
     /* 1106925 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1107005), // Rule ID 16981 //
     /* 1106930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1106933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1106938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1106950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1106953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1106969 */     // MIs[0] round
     /* 1106969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1106972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1106979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1106982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1106992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107004 */     // GIR_Coverage, 16981,
     /* 1107004 */     GIR_EraseRootFromParent_Done,
     /* 1107005 */   // Label 16257: @1107005
     /* 1107005 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1107085), // Rule ID 16984 //
     /* 1107010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1107013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1107018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1107021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1107024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1107030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1107049 */     // MIs[0] round
     /* 1107049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107059 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1107062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107084 */     // GIR_Coverage, 16984,
     /* 1107084 */     GIR_EraseRootFromParent_Done,
     /* 1107085 */   // Label 16258: @1107085
     /* 1107085 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1107165), // Rule ID 16985 //
     /* 1107090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1107093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1107098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1107101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1107104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1107110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1107129 */     // MIs[0] round
     /* 1107129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107139 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1107142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107164 */     // GIR_Coverage, 16985,
     /* 1107164 */     GIR_EraseRootFromParent_Done,
     /* 1107165 */   // Label 16259: @1107165
     /* 1107165 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1107245), // Rule ID 16988 //
     /* 1107170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1107173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1107178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1107190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1107209 */     // MIs[0] round
     /* 1107209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107219 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1107222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107244 */     // GIR_Coverage, 16988,
     /* 1107244 */     GIR_EraseRootFromParent_Done,
     /* 1107245 */   // Label 16260: @1107245
     /* 1107245 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1107325), // Rule ID 16989 //
     /* 1107250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1107253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1107258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1107270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1107289 */     // MIs[0] round
     /* 1107289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107299 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1107302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107324 */     // GIR_Coverage, 16989,
     /* 1107324 */     GIR_EraseRootFromParent_Done,
     /* 1107325 */   // Label 16261: @1107325
     /* 1107325 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1107405), // Rule ID 16994 //
     /* 1107330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1107333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1107350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107369 */     // MIs[0] round
     /* 1107369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107379 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1107382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107404 */     // GIR_Coverage, 16994,
     /* 1107404 */     GIR_EraseRootFromParent_Done,
     /* 1107405 */   // Label 16262: @1107405
     /* 1107405 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1107485), // Rule ID 16995 //
     /* 1107410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1107413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1107430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107449 */     // MIs[0] round
     /* 1107449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1107462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107484 */     // GIR_Coverage, 16995,
     /* 1107484 */     GIR_EraseRootFromParent_Done,
     /* 1107485 */   // Label 16263: @1107485
     /* 1107485 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1107565), // Rule ID 17004 //
     /* 1107490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1107493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1107510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107529 */     // MIs[0] round
     /* 1107529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107539 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1107542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107564 */     // GIR_Coverage, 17004,
     /* 1107564 */     GIR_EraseRootFromParent_Done,
     /* 1107565 */   // Label 16264: @1107565
     /* 1107565 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1107645), // Rule ID 17005 //
     /* 1107570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1107573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1107590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107609 */     // MIs[0] round
     /* 1107609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107619 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1107622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107644 */     // GIR_Coverage, 17005,
     /* 1107644 */     GIR_EraseRootFromParent_Done,
     /* 1107645 */   // Label 16265: @1107645
     /* 1107645 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1107725), // Rule ID 17014 //
     /* 1107650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1107653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1107670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107689 */     // MIs[0] round
     /* 1107689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107699 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1107702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107724 */     // GIR_Coverage, 17014,
     /* 1107724 */     GIR_EraseRootFromParent_Done,
     /* 1107725 */   // Label 16266: @1107725
     /* 1107725 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1107805), // Rule ID 17015 //
     /* 1107730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1107733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1107750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107769 */     // MIs[0] round
     /* 1107769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107779 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1107782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107804 */     // GIR_Coverage, 17015,
     /* 1107804 */     GIR_EraseRootFromParent_Done,
     /* 1107805 */   // Label 16267: @1107805
     /* 1107805 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1107885), // Rule ID 17024 //
     /* 1107810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1107813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1107830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107849 */     // MIs[0] round
     /* 1107849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107859 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1107859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1107862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107884 */     // GIR_Coverage, 17024,
     /* 1107884 */     GIR_EraseRootFromParent_Done,
     /* 1107885 */   // Label 16268: @1107885
     /* 1107885 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1107965), // Rule ID 17025 //
     /* 1107890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1107893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1107910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1107913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107929 */     // MIs[0] round
     /* 1107929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1107932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107939 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1107939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1107942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1107952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1107963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107964 */     // GIR_Coverage, 17025,
     /* 1107964 */     GIR_EraseRootFromParent_Done,
     /* 1107965 */   // Label 16269: @1107965
     /* 1107965 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1108045), // Rule ID 17034 //
     /* 1107970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1107973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1107978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1107981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1107984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1107987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1107993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108009 */     // MIs[0] round
     /* 1108009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1108022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108044 */     // GIR_Coverage, 17034,
     /* 1108044 */     GIR_EraseRootFromParent_Done,
     /* 1108045 */   // Label 16270: @1108045
     /* 1108045 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1108125), // Rule ID 17035 //
     /* 1108050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1108053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1108061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1108064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1108067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108089 */     // MIs[0] round
     /* 1108089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1108102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108124 */     // GIR_Coverage, 17035,
     /* 1108124 */     GIR_EraseRootFromParent_Done,
     /* 1108125 */   // Label 16271: @1108125
     /* 1108125 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1108205), // Rule ID 17044 //
     /* 1108130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1108133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1108141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1108144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1108147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108169 */     // MIs[0] round
     /* 1108169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108179 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1108182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108204 */     // GIR_Coverage, 17044,
     /* 1108204 */     GIR_EraseRootFromParent_Done,
     /* 1108205 */   // Label 16272: @1108205
     /* 1108205 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1108285), // Rule ID 17045 //
     /* 1108210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1108213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1108221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1108224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1108227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108249 */     // MIs[0] round
     /* 1108249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108259 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1108262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108284 */     // GIR_Coverage, 17045,
     /* 1108284 */     GIR_EraseRootFromParent_Done,
     /* 1108285 */   // Label 16273: @1108285
     /* 1108285 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1108365), // Rule ID 17054 //
     /* 1108290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1108293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1108301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1108304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1108307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108329 */     // MIs[0] round
     /* 1108329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108339 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1108342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108364 */     // GIR_Coverage, 17054,
     /* 1108364 */     GIR_EraseRootFromParent_Done,
     /* 1108365 */   // Label 16274: @1108365
     /* 1108365 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1108445), // Rule ID 17055 //
     /* 1108370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1108373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1108381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1108384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1108387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108409 */     // MIs[0] round
     /* 1108409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108419 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1108422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108444 */     // GIR_Coverage, 17055,
     /* 1108444 */     GIR_EraseRootFromParent_Done,
     /* 1108445 */   // Label 16275: @1108445
     /* 1108445 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1108525), // Rule ID 17064 //
     /* 1108450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1108453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1108461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1108464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1108467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108489 */     // MIs[0] round
     /* 1108489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108499 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1108502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108524 */     // GIR_Coverage, 17064,
     /* 1108524 */     GIR_EraseRootFromParent_Done,
     /* 1108525 */   // Label 16276: @1108525
     /* 1108525 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1108605), // Rule ID 17065 //
     /* 1108530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1108533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1108541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1108544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1108547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108569 */     // MIs[0] round
     /* 1108569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108579 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1108582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108604 */     // GIR_Coverage, 17065,
     /* 1108604 */     GIR_EraseRootFromParent_Done,
     /* 1108605 */   // Label 16277: @1108605
     /* 1108605 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1108685), // Rule ID 17072 //
     /* 1108610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1108613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1108630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1108649 */     // MIs[0] round
     /* 1108649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108659 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1108662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108684 */     // GIR_Coverage, 17072,
     /* 1108684 */     GIR_EraseRootFromParent_Done,
     /* 1108685 */   // Label 16278: @1108685
     /* 1108685 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1108765), // Rule ID 17073 //
     /* 1108690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1108693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1108710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1108729 */     // MIs[0] round
     /* 1108729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108739 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1108742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108764 */     // GIR_Coverage, 17073,
     /* 1108764 */     GIR_EraseRootFromParent_Done,
     /* 1108765 */   // Label 16279: @1108765
     /* 1108765 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1108845), // Rule ID 17076 //
     /* 1108770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1108773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1108790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1108809 */     // MIs[0] round
     /* 1108809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1108822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108844 */     // GIR_Coverage, 17076,
     /* 1108844 */     GIR_EraseRootFromParent_Done,
     /* 1108845 */   // Label 16280: @1108845
     /* 1108845 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1108925), // Rule ID 17077 //
     /* 1108850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1108853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1108870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1108873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1108889 */     // MIs[0] round
     /* 1108889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108899 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10972:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1108899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1108902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1108923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108924 */     // GIR_Coverage, 17077,
     /* 1108924 */     GIR_EraseRootFromParent_Done,
     /* 1108925 */   // Label 16281: @1108925
     /* 1108925 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1109005), // Rule ID 17080 //
     /* 1108930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1108933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1108938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1108950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1108953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1108969 */     // MIs[0] round
     /* 1108969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1108972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108979 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1108979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1108982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1108992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109004 */     // GIR_Coverage, 17080,
     /* 1109004 */     GIR_EraseRootFromParent_Done,
     /* 1109005 */   // Label 16282: @1109005
     /* 1109005 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1109085), // Rule ID 17081 //
     /* 1109010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1109013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1109030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1109049 */     // MIs[0] round
     /* 1109049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1109062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109084 */     // GIR_Coverage, 17081,
     /* 1109084 */     GIR_EraseRootFromParent_Done,
     /* 1109085 */   // Label 16283: @1109085
     /* 1109085 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1109165), // Rule ID 17084 //
     /* 1109090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1109093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1109110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1109129 */     // MIs[0] round
     /* 1109129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109139 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1109142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109164 */     // GIR_Coverage, 17084,
     /* 1109164 */     GIR_EraseRootFromParent_Done,
     /* 1109165 */   // Label 16284: @1109165
     /* 1109165 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1109245), // Rule ID 17085 //
     /* 1109170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1109173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1109190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1109209 */     // MIs[0] round
     /* 1109209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109219 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1109222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109244 */     // GIR_Coverage, 17085,
     /* 1109244 */     GIR_EraseRootFromParent_Done,
     /* 1109245 */   // Label 16285: @1109245
     /* 1109245 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1109325), // Rule ID 17088 //
     /* 1109250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1109253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1109270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1109289 */     // MIs[0] round
     /* 1109289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109299 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1109302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109324 */     // GIR_Coverage, 17088,
     /* 1109324 */     GIR_EraseRootFromParent_Done,
     /* 1109325 */   // Label 16286: @1109325
     /* 1109325 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1109405), // Rule ID 17089 //
     /* 1109330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1109333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1109350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1109369 */     // MIs[0] round
     /* 1109369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109379 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1109382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109404 */     // GIR_Coverage, 17089,
     /* 1109404 */     GIR_EraseRootFromParent_Done,
     /* 1109405 */   // Label 16287: @1109405
     /* 1109405 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1109485), // Rule ID 17092 //
     /* 1109410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1109413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1109427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109449 */     // MIs[0] round
     /* 1109449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109459 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1109462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109484 */     // GIR_Coverage, 17092,
     /* 1109484 */     GIR_EraseRootFromParent_Done,
     /* 1109485 */   // Label 16288: @1109485
     /* 1109485 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1109565), // Rule ID 17093 //
     /* 1109490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1109493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1109507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109529 */     // MIs[0] round
     /* 1109529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109539 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10972:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1109542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109564 */     // GIR_Coverage, 17093,
     /* 1109564 */     GIR_EraseRootFromParent_Done,
     /* 1109565 */   // Label 16289: @1109565
     /* 1109565 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1109645), // Rule ID 17096 //
     /* 1109570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1109573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1109581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1109584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1109587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109609 */     // MIs[0] round
     /* 1109609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1109622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109644 */     // GIR_Coverage, 17096,
     /* 1109644 */     GIR_EraseRootFromParent_Done,
     /* 1109645 */   // Label 16290: @1109645
     /* 1109645 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1109725), // Rule ID 17097 //
     /* 1109650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1109653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1109661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1109664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1109667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109689 */     // MIs[0] round
     /* 1109689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109699 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10972:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1109702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109724 */     // GIR_Coverage, 17097,
     /* 1109724 */     GIR_EraseRootFromParent_Done,
     /* 1109725 */   // Label 16291: @1109725
     /* 1109725 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1109805), // Rule ID 17100 //
     /* 1109730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1109733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1109741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1109744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1109747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109769 */     // MIs[0] round
     /* 1109769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109779 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1109782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109804 */     // GIR_Coverage, 17100,
     /* 1109804 */     GIR_EraseRootFromParent_Done,
     /* 1109805 */   // Label 16292: @1109805
     /* 1109805 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1109885), // Rule ID 17101 //
     /* 1109810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1109813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1109821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1109824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1109827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109849 */     // MIs[0] round
     /* 1109849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109859 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10972:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1109859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1109862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109884 */     // GIR_Coverage, 17101,
     /* 1109884 */     GIR_EraseRootFromParent_Done,
     /* 1109885 */   // Label 16293: @1109885
     /* 1109885 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1109965), // Rule ID 17104 //
     /* 1109890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1109893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1109901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1109904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1109907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1109913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1109929 */     // MIs[0] round
     /* 1109929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1109932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109939 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1109939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1109942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1109952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1109963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109964 */     // GIR_Coverage, 17104,
     /* 1109964 */     GIR_EraseRootFromParent_Done,
     /* 1109965 */   // Label 16294: @1109965
     /* 1109965 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1110045), // Rule ID 17105 //
     /* 1109970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1109973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1109978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1109981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1109984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1109987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1109990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1109993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1110009 */     // MIs[0] round
     /* 1110009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110019 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10972:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1110022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110044 */     // GIR_Coverage, 17105,
     /* 1110044 */     GIR_EraseRootFromParent_Done,
     /* 1110045 */   // Label 16295: @1110045
     /* 1110045 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1110125), // Rule ID 17110 //
     /* 1110050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1110053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1110070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110089 */     // MIs[0] round
     /* 1110089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110099 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1110102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110124 */     // GIR_Coverage, 17110,
     /* 1110124 */     GIR_EraseRootFromParent_Done,
     /* 1110125 */   // Label 16296: @1110125
     /* 1110125 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1110205), // Rule ID 17111 //
     /* 1110130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1110133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1110150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110169 */     // MIs[0] round
     /* 1110169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110179 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1110182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110204 */     // GIR_Coverage, 17111,
     /* 1110204 */     GIR_EraseRootFromParent_Done,
     /* 1110205 */   // Label 16297: @1110205
     /* 1110205 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1110285), // Rule ID 17120 //
     /* 1110210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1110213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1110230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110249 */     // MIs[0] round
     /* 1110249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110259 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1110262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110284 */     // GIR_Coverage, 17120,
     /* 1110284 */     GIR_EraseRootFromParent_Done,
     /* 1110285 */   // Label 16298: @1110285
     /* 1110285 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1110365), // Rule ID 17121 //
     /* 1110290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1110293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1110310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110329 */     // MIs[0] round
     /* 1110329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1110342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110364 */     // GIR_Coverage, 17121,
     /* 1110364 */     GIR_EraseRootFromParent_Done,
     /* 1110365 */   // Label 16299: @1110365
     /* 1110365 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1110445), // Rule ID 17130 //
     /* 1110370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1110373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1110390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110409 */     // MIs[0] round
     /* 1110409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1110422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110444 */     // GIR_Coverage, 17130,
     /* 1110444 */     GIR_EraseRootFromParent_Done,
     /* 1110445 */   // Label 16300: @1110445
     /* 1110445 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1110525), // Rule ID 17131 //
     /* 1110450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1110453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1110470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110489 */     // MIs[0] round
     /* 1110489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1110502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110524 */     // GIR_Coverage, 17131,
     /* 1110524 */     GIR_EraseRootFromParent_Done,
     /* 1110525 */   // Label 16301: @1110525
     /* 1110525 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1110605), // Rule ID 17140 //
     /* 1110530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1110533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1110550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110569 */     // MIs[0] round
     /* 1110569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110579 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1110582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110604 */     // GIR_Coverage, 17140,
     /* 1110604 */     GIR_EraseRootFromParent_Done,
     /* 1110605 */   // Label 16302: @1110605
     /* 1110605 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1110685), // Rule ID 17141 //
     /* 1110610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1110613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1110630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110649 */     // MIs[0] round
     /* 1110649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110659 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1110662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110684 */     // GIR_Coverage, 17141,
     /* 1110684 */     GIR_EraseRootFromParent_Done,
     /* 1110685 */   // Label 16303: @1110685
     /* 1110685 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1110765), // Rule ID 17150 //
     /* 1110690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1110693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1110710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110729 */     // MIs[0] round
     /* 1110729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110739 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1110742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110764 */     // GIR_Coverage, 17150,
     /* 1110764 */     GIR_EraseRootFromParent_Done,
     /* 1110765 */   // Label 16304: @1110765
     /* 1110765 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1110845), // Rule ID 17151 //
     /* 1110770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1110773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1110790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110809 */     // MIs[0] round
     /* 1110809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1110822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1110840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110844 */     // GIR_Coverage, 17151,
     /* 1110844 */     GIR_EraseRootFromParent_Done,
     /* 1110845 */   // Label 16305: @1110845
     /* 1110845 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1110925), // Rule ID 17160 //
     /* 1110850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1110853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1110873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110889 */     // MIs[0] round
     /* 1110889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1110899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1110902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1110923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110924 */     // GIR_Coverage, 17160,
     /* 1110924 */     GIR_EraseRootFromParent_Done,
     /* 1110925 */   // Label 16306: @1110925
     /* 1110925 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1111005), // Rule ID 17161 //
     /* 1110930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1110933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1110938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1110953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110969 */     // MIs[0] round
     /* 1110969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1110972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110979 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1110979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1110982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1110992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111004 */     // GIR_Coverage, 17161,
     /* 1111004 */     GIR_EraseRootFromParent_Done,
     /* 1111005 */   // Label 16307: @1111005
     /* 1111005 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1111085), // Rule ID 17170 //
     /* 1111010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1111013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111049 */     // MIs[0] round
     /* 1111049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1111062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111084 */     // GIR_Coverage, 17170,
     /* 1111084 */     GIR_EraseRootFromParent_Done,
     /* 1111085 */   // Label 16308: @1111085
     /* 1111085 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1111165), // Rule ID 17171 //
     /* 1111090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1111093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111129 */     // MIs[0] round
     /* 1111129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111139 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1111142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111164 */     // GIR_Coverage, 17171,
     /* 1111164 */     GIR_EraseRootFromParent_Done,
     /* 1111165 */   // Label 16309: @1111165
     /* 1111165 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1111245), // Rule ID 17180 //
     /* 1111170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1111173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111209 */     // MIs[0] round
     /* 1111209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111219 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1111222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111244 */     // GIR_Coverage, 17180,
     /* 1111244 */     GIR_EraseRootFromParent_Done,
     /* 1111245 */   // Label 16310: @1111245
     /* 1111245 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1111325), // Rule ID 17181 //
     /* 1111250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1111253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111289 */     // MIs[0] round
     /* 1111289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1111302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111324 */     // GIR_Coverage, 17181,
     /* 1111324 */     GIR_EraseRootFromParent_Done,
     /* 1111325 */   // Label 16311: @1111325
     /* 1111325 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1111405), // Rule ID 17190 //
     /* 1111330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1111333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111369 */     // MIs[0] round
     /* 1111369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111379 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1111382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111404 */     // GIR_Coverage, 17190,
     /* 1111404 */     GIR_EraseRootFromParent_Done,
     /* 1111405 */   // Label 16312: @1111405
     /* 1111405 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1111485), // Rule ID 17191 //
     /* 1111410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1111413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111449 */     // MIs[0] round
     /* 1111449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111459 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1111462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111484 */     // GIR_Coverage, 17191,
     /* 1111484 */     GIR_EraseRootFromParent_Done,
     /* 1111485 */   // Label 16313: @1111485
     /* 1111485 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1111565), // Rule ID 17198 //
     /* 1111490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1111493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111529 */     // MIs[0] round
     /* 1111529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111539 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1111542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111564 */     // GIR_Coverage, 17198,
     /* 1111564 */     GIR_EraseRootFromParent_Done,
     /* 1111565 */   // Label 16314: @1111565
     /* 1111565 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1111645), // Rule ID 17199 //
     /* 1111570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1111573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111609 */     // MIs[0] round
     /* 1111609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111619 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1111622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111644 */     // GIR_Coverage, 17199,
     /* 1111644 */     GIR_EraseRootFromParent_Done,
     /* 1111645 */   // Label 16315: @1111645
     /* 1111645 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1111725), // Rule ID 17202 //
     /* 1111650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1111653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111689 */     // MIs[0] round
     /* 1111689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1111702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111724 */     // GIR_Coverage, 17202,
     /* 1111724 */     GIR_EraseRootFromParent_Done,
     /* 1111725 */   // Label 16316: @1111725
     /* 1111725 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1111805), // Rule ID 17203 //
     /* 1111730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1111733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111769 */     // MIs[0] round
     /* 1111769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111779 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1111782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111804 */     // GIR_Coverage, 17203,
     /* 1111804 */     GIR_EraseRootFromParent_Done,
     /* 1111805 */   // Label 16317: @1111805
     /* 1111805 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1111885), // Rule ID 17206 //
     /* 1111810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1111813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111849 */     // MIs[0] round
     /* 1111849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1111859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1111862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111884 */     // GIR_Coverage, 17206,
     /* 1111884 */     GIR_EraseRootFromParent_Done,
     /* 1111885 */   // Label 16318: @1111885
     /* 1111885 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1111965), // Rule ID 17207 //
     /* 1111890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1111893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1111913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1111929 */     // MIs[0] round
     /* 1111929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1111932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1111939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1111942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1111944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1111946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1111952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1111960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1111963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111964 */     // GIR_Coverage, 17207,
     /* 1111964 */     GIR_EraseRootFromParent_Done,
     /* 1111965 */   // Label 16319: @1111965
     /* 1111965 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1112045), // Rule ID 17210 //
     /* 1111970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1111973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1111978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1111990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1111993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1112009 */     // MIs[0] round
     /* 1112009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112019 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1112022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1112040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112044 */     // GIR_Coverage, 17210,
     /* 1112044 */     GIR_EraseRootFromParent_Done,
     /* 1112045 */   // Label 16320: @1112045
     /* 1112045 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1112125), // Rule ID 17211 //
     /* 1112050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1112053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1112070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1112089 */     // MIs[0] round
     /* 1112089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1112102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1112120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112124 */     // GIR_Coverage, 17211,
     /* 1112124 */     GIR_EraseRootFromParent_Done,
     /* 1112125 */   // Label 16321: @1112125
     /* 1112125 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1112205), // Rule ID 17214 //
     /* 1112130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1112133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1112150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1112169 */     // MIs[0] round
     /* 1112169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112179 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1112182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1112200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112204 */     // GIR_Coverage, 17214,
     /* 1112204 */     GIR_EraseRootFromParent_Done,
     /* 1112205 */   // Label 16322: @1112205
     /* 1112205 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1112285), // Rule ID 17215 //
     /* 1112210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1112213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1112230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1112249 */     // MIs[0] round
     /* 1112249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112259 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1112262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1112280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112284 */     // GIR_Coverage, 17215,
     /* 1112284 */     GIR_EraseRootFromParent_Done,
     /* 1112285 */   // Label 16323: @1112285
     /* 1112285 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1112365), // Rule ID 17218 //
     /* 1112290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1112293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112329 */     // MIs[0] round
     /* 1112329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112339 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1112342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112364 */     // GIR_Coverage, 17218,
     /* 1112364 */     GIR_EraseRootFromParent_Done,
     /* 1112365 */   // Label 16324: @1112365
     /* 1112365 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1112445), // Rule ID 17219 //
     /* 1112370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1112373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112409 */     // MIs[0] round
     /* 1112409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112419 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1112422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112444 */     // GIR_Coverage, 17219,
     /* 1112444 */     GIR_EraseRootFromParent_Done,
     /* 1112445 */   // Label 16325: @1112445
     /* 1112445 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1112525), // Rule ID 17222 //
     /* 1112450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1112453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112489 */     // MIs[0] round
     /* 1112489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112499 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1112502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112524 */     // GIR_Coverage, 17222,
     /* 1112524 */     GIR_EraseRootFromParent_Done,
     /* 1112525 */   // Label 16326: @1112525
     /* 1112525 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1112605), // Rule ID 17223 //
     /* 1112530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1112533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112569 */     // MIs[0] round
     /* 1112569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112579 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1112582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112604 */     // GIR_Coverage, 17223,
     /* 1112604 */     GIR_EraseRootFromParent_Done,
     /* 1112605 */   // Label 16327: @1112605
     /* 1112605 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1112685), // Rule ID 17226 //
     /* 1112610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1112613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112649 */     // MIs[0] round
     /* 1112649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112659 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1112662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112684 */     // GIR_Coverage, 17226,
     /* 1112684 */     GIR_EraseRootFromParent_Done,
     /* 1112685 */   // Label 16328: @1112685
     /* 1112685 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1112765), // Rule ID 17227 //
     /* 1112690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1112693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112729 */     // MIs[0] round
     /* 1112729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112739 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1112742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112764 */     // GIR_Coverage, 17227,
     /* 1112764 */     GIR_EraseRootFromParent_Done,
     /* 1112765 */   // Label 16329: @1112765
     /* 1112765 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1112845), // Rule ID 17230 //
     /* 1112770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1112773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112809 */     // MIs[0] round
     /* 1112809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112819 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1112822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112844 */     // GIR_Coverage, 17230,
     /* 1112844 */     GIR_EraseRootFromParent_Done,
     /* 1112845 */   // Label 16330: @1112845
     /* 1112845 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1112925), // Rule ID 17231 //
     /* 1112850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1112853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1112858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1112870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1112873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1112889 */     // MIs[0] round
     /* 1112889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112899 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1112899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1112902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1112923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112924 */     // GIR_Coverage, 17231,
     /* 1112924 */     GIR_EraseRootFromParent_Done,
     /* 1112925 */   // Label 16331: @1112925
     /* 1112925 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1113005), // Rule ID 17234 //
     /* 1112930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1112933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1112938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1112941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1112944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1112947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1112950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1112953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112969 */     // MIs[0] round
     /* 1112969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1112972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112979 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1112979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1112982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1112984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1112986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1112992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113004 */     // GIR_Coverage, 17234,
     /* 1113004 */     GIR_EraseRootFromParent_Done,
     /* 1113005 */   // Label 16332: @1113005
     /* 1113005 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1113085), // Rule ID 17235 //
     /* 1113010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1113013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1113021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1113024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1113027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1113030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113049 */     // MIs[0] round
     /* 1113049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113059 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1113062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113084 */     // GIR_Coverage, 17235,
     /* 1113084 */     GIR_EraseRootFromParent_Done,
     /* 1113085 */   // Label 16333: @1113085
     /* 1113085 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1113165), // Rule ID 17238 //
     /* 1113090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1113093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1113101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1113104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1113107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1113110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113129 */     // MIs[0] round
     /* 1113129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113139 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1113142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113164 */     // GIR_Coverage, 17238,
     /* 1113164 */     GIR_EraseRootFromParent_Done,
     /* 1113165 */   // Label 16334: @1113165
     /* 1113165 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1113245), // Rule ID 17239 //
     /* 1113170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1113173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1113181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1113184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1113187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1113190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113209 */     // MIs[0] round
     /* 1113209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113219 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1113222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113244 */     // GIR_Coverage, 17239,
     /* 1113244 */     GIR_EraseRootFromParent_Done,
     /* 1113245 */   // Label 16335: @1113245
     /* 1113245 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1113325), // Rule ID 17242 //
     /* 1113250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1113253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113289 */     // MIs[0] round
     /* 1113289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113299 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1113302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113324 */     // GIR_Coverage, 17242,
     /* 1113324 */     GIR_EraseRootFromParent_Done,
     /* 1113325 */   // Label 16336: @1113325
     /* 1113325 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1113405), // Rule ID 17243 //
     /* 1113330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1113333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113369 */     // MIs[0] round
     /* 1113369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113379 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1113382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113404 */     // GIR_Coverage, 17243,
     /* 1113404 */     GIR_EraseRootFromParent_Done,
     /* 1113405 */   // Label 16337: @1113405
     /* 1113405 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1113485), // Rule ID 17246 //
     /* 1113410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1113413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1113421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1113424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1113427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1113430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113449 */     // MIs[0] round
     /* 1113449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113459 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1113462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113484 */     // GIR_Coverage, 17246,
     /* 1113484 */     GIR_EraseRootFromParent_Done,
     /* 1113485 */   // Label 16338: @1113485
     /* 1113485 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1113565), // Rule ID 17247 //
     /* 1113490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1113493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1113501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1113504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1113507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1113510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113529 */     // MIs[0] round
     /* 1113529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113539 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1113542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113564 */     // GIR_Coverage, 17247,
     /* 1113564 */     GIR_EraseRootFromParent_Done,
     /* 1113565 */   // Label 16339: @1113565
     /* 1113565 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1113645), // Rule ID 17250 //
     /* 1113570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1113573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113609 */     // MIs[0] round
     /* 1113609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1113622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113644 */     // GIR_Coverage, 17250,
     /* 1113644 */     GIR_EraseRootFromParent_Done,
     /* 1113645 */   // Label 16340: @1113645
     /* 1113645 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1113725), // Rule ID 17251 //
     /* 1113650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1113653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113689 */     // MIs[0] round
     /* 1113689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1113702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113724 */     // GIR_Coverage, 17251,
     /* 1113724 */     GIR_EraseRootFromParent_Done,
     /* 1113725 */   // Label 16341: @1113725
     /* 1113725 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1113805), // Rule ID 17254 //
     /* 1113730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1113733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113769 */     // MIs[0] round
     /* 1113769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113779 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1113782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113804 */     // GIR_Coverage, 17254,
     /* 1113804 */     GIR_EraseRootFromParent_Done,
     /* 1113805 */   // Label 16342: @1113805
     /* 1113805 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1113885), // Rule ID 17255 //
     /* 1113810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1113813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113849 */     // MIs[0] round
     /* 1113849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1113859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1113862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113884 */     // GIR_Coverage, 17255,
     /* 1113884 */     GIR_EraseRootFromParent_Done,
     /* 1113885 */   // Label 16343: @1113885
     /* 1113885 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1113965), // Rule ID 17258 //
     /* 1113890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1113893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1113901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1113904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1113907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1113910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1113913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113929 */     // MIs[0] round
     /* 1113929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1113932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113939 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1113939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1113942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1113946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1113952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1113960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1113963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113964 */     // GIR_Coverage, 17258,
     /* 1113964 */     GIR_EraseRootFromParent_Done,
     /* 1113965 */   // Label 16344: @1113965
     /* 1113965 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1114045), // Rule ID 17259 //
     /* 1113970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1113973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1113978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1113981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1113984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1113987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1113990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1113993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114009 */     // MIs[0] round
     /* 1114009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114019 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1114022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1114040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114044 */     // GIR_Coverage, 17259,
     /* 1114044 */     GIR_EraseRootFromParent_Done,
     /* 1114045 */   // Label 16345: @1114045
     /* 1114045 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1114125), // Rule ID 17262 //
     /* 1114050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1114053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1114061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1114064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1114067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1114070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114089 */     // MIs[0] round
     /* 1114089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114099 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1114102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1114120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114124 */     // GIR_Coverage, 17262,
     /* 1114124 */     GIR_EraseRootFromParent_Done,
     /* 1114125 */   // Label 16346: @1114125
     /* 1114125 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1114205), // Rule ID 17263 //
     /* 1114130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1114133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1114141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1114144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1114147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1114150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114169 */     // MIs[0] round
     /* 1114169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114179 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1114182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1114200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114204 */     // GIR_Coverage, 17263,
     /* 1114204 */     GIR_EraseRootFromParent_Done,
     /* 1114205 */   // Label 16347: @1114205
     /* 1114205 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1114285), // Rule ID 17266 //
     /* 1114210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1114213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1114221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1114224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1114227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1114230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114249 */     // MIs[0] round
     /* 1114249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114259 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1114262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1114280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114284 */     // GIR_Coverage, 17266,
     /* 1114284 */     GIR_EraseRootFromParent_Done,
     /* 1114285 */   // Label 16348: @1114285
     /* 1114285 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1114365), // Rule ID 17267 //
     /* 1114290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1114293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1114301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1114304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1114307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1114310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114329 */     // MIs[0] round
     /* 1114329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114339 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1114342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1114360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114364 */     // GIR_Coverage, 17267,
     /* 1114364 */     GIR_EraseRootFromParent_Done,
     /* 1114365 */   // Label 16349: @1114365
     /* 1114365 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1114445), // Rule ID 17270 //
     /* 1114370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1114373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1114387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1114390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114409 */     // MIs[0] round
     /* 1114409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1114422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114444 */     // GIR_Coverage, 17270,
     /* 1114444 */     GIR_EraseRootFromParent_Done,
     /* 1114445 */   // Label 16350: @1114445
     /* 1114445 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1114525), // Rule ID 17271 //
     /* 1114450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1114453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1114467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1114470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114489 */     // MIs[0] round
     /* 1114489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1114502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114524 */     // GIR_Coverage, 17271,
     /* 1114524 */     GIR_EraseRootFromParent_Done,
     /* 1114525 */   // Label 16351: @1114525
     /* 1114525 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1114605), // Rule ID 17274 //
     /* 1114530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1114533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114569 */     // MIs[0] round
     /* 1114569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114579 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1114582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114604 */     // GIR_Coverage, 17274,
     /* 1114604 */     GIR_EraseRootFromParent_Done,
     /* 1114605 */   // Label 16352: @1114605
     /* 1114605 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1114685), // Rule ID 17275 //
     /* 1114610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1114613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114649 */     // MIs[0] round
     /* 1114649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114659 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1114662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114684 */     // GIR_Coverage, 17275,
     /* 1114684 */     GIR_EraseRootFromParent_Done,
     /* 1114685 */   // Label 16353: @1114685
     /* 1114685 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1114765), // Rule ID 17278 //
     /* 1114690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1114693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114729 */     // MIs[0] round
     /* 1114729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114739 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1114742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114764 */     // GIR_Coverage, 17278,
     /* 1114764 */     GIR_EraseRootFromParent_Done,
     /* 1114765 */   // Label 16354: @1114765
     /* 1114765 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1114845), // Rule ID 17279 //
     /* 1114770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1114773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114809 */     // MIs[0] round
     /* 1114809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1114822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114844 */     // GIR_Coverage, 17279,
     /* 1114844 */     GIR_EraseRootFromParent_Done,
     /* 1114845 */   // Label 16355: @1114845
     /* 1114845 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1114925), // Rule ID 17282 //
     /* 1114850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1114853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1114873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114889 */     // MIs[0] round
     /* 1114889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1114899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1114902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1114923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114924 */     // GIR_Coverage, 17282,
     /* 1114924 */     GIR_EraseRootFromParent_Done,
     /* 1114925 */   // Label 16356: @1114925
     /* 1114925 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1115005), // Rule ID 17283 //
     /* 1114930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1114933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1114938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1114953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114969 */     // MIs[0] round
     /* 1114969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1114972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1114979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1114982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1114986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1114992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115004 */     // GIR_Coverage, 17283,
     /* 1115004 */     GIR_EraseRootFromParent_Done,
     /* 1115005 */   // Label 16357: @1115005
     /* 1115005 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1115085), // Rule ID 17286 //
     /* 1115010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1115013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1115021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1115024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1115027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1115030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115049 */     // MIs[0] round
     /* 1115049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115059 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1115062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115084 */     // GIR_Coverage, 17286,
     /* 1115084 */     GIR_EraseRootFromParent_Done,
     /* 1115085 */   // Label 16358: @1115085
     /* 1115085 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1115165), // Rule ID 17287 //
     /* 1115090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1115093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1115101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1115104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1115107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1115110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115129 */     // MIs[0] round
     /* 1115129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115139 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1115142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115164 */     // GIR_Coverage, 17287,
     /* 1115164 */     GIR_EraseRootFromParent_Done,
     /* 1115165 */   // Label 16359: @1115165
     /* 1115165 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1115245), // Rule ID 17290 //
     /* 1115170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1115173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1115181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1115184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1115187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1115190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115209 */     // MIs[0] round
     /* 1115209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115219 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1115222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115244 */     // GIR_Coverage, 17290,
     /* 1115244 */     GIR_EraseRootFromParent_Done,
     /* 1115245 */   // Label 16360: @1115245
     /* 1115245 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1115325), // Rule ID 17291 //
     /* 1115250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1115253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1115261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1115264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1115267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1115270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115289 */     // MIs[0] round
     /* 1115289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115299 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1115302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115324 */     // GIR_Coverage, 17291,
     /* 1115324 */     GIR_EraseRootFromParent_Done,
     /* 1115325 */   // Label 16361: @1115325
     /* 1115325 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1115405), // Rule ID 17294 //
     /* 1115330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1115333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1115341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1115344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1115347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115369 */     // MIs[0] round
     /* 1115369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115379 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1115382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115404 */     // GIR_Coverage, 17294,
     /* 1115404 */     GIR_EraseRootFromParent_Done,
     /* 1115405 */   // Label 16362: @1115405
     /* 1115405 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1115485), // Rule ID 17295 //
     /* 1115410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1115413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1115421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1115424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1115427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115449 */     // MIs[0] round
     /* 1115449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115459 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1115462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115484 */     // GIR_Coverage, 17295,
     /* 1115484 */     GIR_EraseRootFromParent_Done,
     /* 1115485 */   // Label 16363: @1115485
     /* 1115485 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1115565), // Rule ID 17298 //
     /* 1115490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1115493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1115501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1115504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1115507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115529 */     // MIs[0] round
     /* 1115529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115539 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1115542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115564 */     // GIR_Coverage, 17298,
     /* 1115564 */     GIR_EraseRootFromParent_Done,
     /* 1115565 */   // Label 16364: @1115565
     /* 1115565 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1115645), // Rule ID 17299 //
     /* 1115570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1115573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1115581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1115584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1115587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115609 */     // MIs[0] round
     /* 1115609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115619 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1115622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115644 */     // GIR_Coverage, 17299,
     /* 1115644 */     GIR_EraseRootFromParent_Done,
     /* 1115645 */   // Label 16365: @1115645
     /* 1115645 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1115725), // Rule ID 17302 //
     /* 1115650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1115653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1115667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1115670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1115689 */     // MIs[0] round
     /* 1115689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115699 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1115702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115724 */     // GIR_Coverage, 17302,
     /* 1115724 */     GIR_EraseRootFromParent_Done,
     /* 1115725 */   // Label 16366: @1115725
     /* 1115725 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1115805), // Rule ID 17303 //
     /* 1115730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1115733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1115747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1115750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1115769 */     // MIs[0] round
     /* 1115769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115779 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1115782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115804 */     // GIR_Coverage, 17303,
     /* 1115804 */     GIR_EraseRootFromParent_Done,
     /* 1115805 */   // Label 16367: @1115805
     /* 1115805 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1115885), // Rule ID 17306 //
     /* 1115810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1115813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1115821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1115824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1115827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115849 */     // MIs[0] round
     /* 1115849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115859 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1115859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1115862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115884 */     // GIR_Coverage, 17306,
     /* 1115884 */     GIR_EraseRootFromParent_Done,
     /* 1115885 */   // Label 16368: @1115885
     /* 1115885 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1115965), // Rule ID 17307 //
     /* 1115890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1115893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1115901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1115904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1115907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1115910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1115913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1115929 */     // MIs[0] round
     /* 1115929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1115932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115939 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10909:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1115939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1115942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1115946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1115952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1115960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1115963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115964 */     // GIR_Coverage, 17307,
     /* 1115964 */     GIR_EraseRootFromParent_Done,
     /* 1115965 */   // Label 16369: @1115965
     /* 1115965 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1116045), // Rule ID 17310 //
     /* 1115970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1115973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1115978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1115987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1115990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1115993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1116009 */     // MIs[0] round
     /* 1116009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116019 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1116022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116044 */     // GIR_Coverage, 17310,
     /* 1116044 */     GIR_EraseRootFromParent_Done,
     /* 1116045 */   // Label 16370: @1116045
     /* 1116045 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1116125), // Rule ID 17311 //
     /* 1116050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1116053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1116067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1116070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1116089 */     // MIs[0] round
     /* 1116089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10909:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1116102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116124 */     // GIR_Coverage, 17311,
     /* 1116124 */     GIR_EraseRootFromParent_Done,
     /* 1116125 */   // Label 16371: @1116125
     /* 1116125 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1116205), // Rule ID 17314 //
     /* 1116130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1116133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1116150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1116169 */     // MIs[0] round
     /* 1116169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1116182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116204 */     // GIR_Coverage, 17314,
     /* 1116204 */     GIR_EraseRootFromParent_Done,
     /* 1116205 */   // Label 16372: @1116205
     /* 1116205 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1116285), // Rule ID 17315 //
     /* 1116210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1116213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1116230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1116249 */     // MIs[0] round
     /* 1116249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116259 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10909:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1116262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116284 */     // GIR_Coverage, 17315,
     /* 1116284 */     GIR_EraseRootFromParent_Done,
     /* 1116285 */   // Label 16373: @1116285
     /* 1116285 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1116365), // Rule ID 17318 //
     /* 1116290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1116293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1116301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1116304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1116307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116329 */     // MIs[0] round
     /* 1116329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116339 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1116342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116364 */     // GIR_Coverage, 17318,
     /* 1116364 */     GIR_EraseRootFromParent_Done,
     /* 1116365 */   // Label 16374: @1116365
     /* 1116365 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1116445), // Rule ID 17319 //
     /* 1116370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1116373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1116381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1116384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1116387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116409 */     // MIs[0] round
     /* 1116409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116419 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1116422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116444 */     // GIR_Coverage, 17319,
     /* 1116444 */     GIR_EraseRootFromParent_Done,
     /* 1116445 */   // Label 16375: @1116445
     /* 1116445 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1116525), // Rule ID 17322 //
     /* 1116450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1116453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1116461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1116464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1116467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116489 */     // MIs[0] round
     /* 1116489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116499 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1116502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116524 */     // GIR_Coverage, 17322,
     /* 1116524 */     GIR_EraseRootFromParent_Done,
     /* 1116525 */   // Label 16376: @1116525
     /* 1116525 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1116605), // Rule ID 17323 //
     /* 1116530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1116533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1116541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1116544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1116547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116569 */     // MIs[0] round
     /* 1116569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116579 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1116582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116604 */     // GIR_Coverage, 17323,
     /* 1116604 */     GIR_EraseRootFromParent_Done,
     /* 1116605 */   // Label 16377: @1116605
     /* 1116605 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1116685), // Rule ID 17326 //
     /* 1116610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1116613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1116621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1116624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1116627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116649 */     // MIs[0] round
     /* 1116649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116659 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1116662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116684 */     // GIR_Coverage, 17326,
     /* 1116684 */     GIR_EraseRootFromParent_Done,
     /* 1116685 */   // Label 16378: @1116685
     /* 1116685 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1116765), // Rule ID 17327 //
     /* 1116690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1116693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1116701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1116704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1116707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1116710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1116729 */     // MIs[0] round
     /* 1116729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116739 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1116742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1116760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116764 */     // GIR_Coverage, 17327,
     /* 1116764 */     GIR_EraseRootFromParent_Done,
     /* 1116765 */   // Label 16379: @1116765
     /* 1116765 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1116845), // Rule ID 17330 //
     /* 1116770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1116773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1116790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1116809 */     // MIs[0] round
     /* 1116809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1116822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116844 */     // GIR_Coverage, 17330,
     /* 1116844 */     GIR_EraseRootFromParent_Done,
     /* 1116845 */   // Label 16380: @1116845
     /* 1116845 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1116925), // Rule ID 17331 //
     /* 1116850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1116853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1116870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1116873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1116889 */     // MIs[0] round
     /* 1116889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1116899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1116902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1116923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116924 */     // GIR_Coverage, 17331,
     /* 1116924 */     GIR_EraseRootFromParent_Done,
     /* 1116925 */   // Label 16381: @1116925
     /* 1116925 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1117005), // Rule ID 17334 //
     /* 1116930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1116933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1116938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1116947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1116950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1116953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1116969 */     // MIs[0] round
     /* 1116969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1116972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116979 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1116979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1116982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1116986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1116992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117004 */     // GIR_Coverage, 17334,
     /* 1117004 */     GIR_EraseRootFromParent_Done,
     /* 1117005 */   // Label 16382: @1117005
     /* 1117005 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1117085), // Rule ID 17335 //
     /* 1117010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1117013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1117027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1117030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1117049 */     // MIs[0] round
     /* 1117049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117059 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1117062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117084 */     // GIR_Coverage, 17335,
     /* 1117084 */     GIR_EraseRootFromParent_Done,
     /* 1117085 */   // Label 16383: @1117085
     /* 1117085 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1117165), // Rule ID 17338 //
     /* 1117090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1117093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1117110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1117129 */     // MIs[0] round
     /* 1117129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117139 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1117142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117164 */     // GIR_Coverage, 17338,
     /* 1117164 */     GIR_EraseRootFromParent_Done,
     /* 1117165 */   // Label 16384: @1117165
     /* 1117165 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1117245), // Rule ID 17339 //
     /* 1117170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1117173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1117190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1117209 */     // MIs[0] round
     /* 1117209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117219 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1117222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117244 */     // GIR_Coverage, 17339,
     /* 1117244 */     GIR_EraseRootFromParent_Done,
     /* 1117245 */   // Label 16385: @1117245
     /* 1117245 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1117325), // Rule ID 17342 //
     /* 1117250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1117253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117289 */     // MIs[0] round
     /* 1117289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117299 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1117302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117324 */     // GIR_Coverage, 17342,
     /* 1117324 */     GIR_EraseRootFromParent_Done,
     /* 1117325 */   // Label 16386: @1117325
     /* 1117325 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1117405), // Rule ID 17343 //
     /* 1117330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1117333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117369 */     // MIs[0] round
     /* 1117369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10909:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1117382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117404 */     // GIR_Coverage, 17343,
     /* 1117404 */     GIR_EraseRootFromParent_Done,
     /* 1117405 */   // Label 16387: @1117405
     /* 1117405 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1117485), // Rule ID 17346 //
     /* 1117410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1117413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117449 */     // MIs[0] round
     /* 1117449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117459 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1117462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117484 */     // GIR_Coverage, 17346,
     /* 1117484 */     GIR_EraseRootFromParent_Done,
     /* 1117485 */   // Label 16388: @1117485
     /* 1117485 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1117565), // Rule ID 17347 //
     /* 1117490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1117493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117529 */     // MIs[0] round
     /* 1117529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117539 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10909:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1117542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117564 */     // GIR_Coverage, 17347,
     /* 1117564 */     GIR_EraseRootFromParent_Done,
     /* 1117565 */   // Label 16389: @1117565
     /* 1117565 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1117645), // Rule ID 17350 //
     /* 1117570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1117573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117609 */     // MIs[0] round
     /* 1117609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117619 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1117622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117644 */     // GIR_Coverage, 17350,
     /* 1117644 */     GIR_EraseRootFromParent_Done,
     /* 1117645 */   // Label 16390: @1117645
     /* 1117645 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1117725), // Rule ID 17351 //
     /* 1117650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1117653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1117658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1117670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1117689 */     // MIs[0] round
     /* 1117689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10909:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1117702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117724 */     // GIR_Coverage, 17351,
     /* 1117724 */     GIR_EraseRootFromParent_Done,
     /* 1117725 */   // Label 16391: @1117725
     /* 1117725 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1117805), // Rule ID 17354 //
     /* 1117730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1117733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1117738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1117741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1117744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1117747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1117750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117769 */     // MIs[0] round
     /* 1117769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117779 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1117782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1117800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117804 */     // GIR_Coverage, 17354,
     /* 1117804 */     GIR_EraseRootFromParent_Done,
     /* 1117805 */   // Label 16392: @1117805
     /* 1117805 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1117885), // Rule ID 17355 //
     /* 1117810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1117813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1117818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1117821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1117824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1117827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1117830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117849 */     // MIs[0] round
     /* 1117849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117859 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1117859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1117862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1117880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117884 */     // GIR_Coverage, 17355,
     /* 1117884 */     GIR_EraseRootFromParent_Done,
     /* 1117885 */   // Label 16393: @1117885
     /* 1117885 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1117965), // Rule ID 17358 //
     /* 1117890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1117893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1117898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1117901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1117904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1117907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1117910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1117913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117929 */     // MIs[0] round
     /* 1117929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1117932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117939 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1117939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1117942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1117946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1117952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1117960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1117963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117964 */     // GIR_Coverage, 17358,
     /* 1117964 */     GIR_EraseRootFromParent_Done,
     /* 1117965 */   // Label 16394: @1117965
     /* 1117965 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1118045), // Rule ID 17359 //
     /* 1117970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1117973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1117978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1117981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1117984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1117987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1117990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1117993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118009 */     // MIs[0] round
     /* 1118009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118019 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1118022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118044 */     // GIR_Coverage, 17359,
     /* 1118044 */     GIR_EraseRootFromParent_Done,
     /* 1118045 */   // Label 16395: @1118045
     /* 1118045 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1118125), // Rule ID 17362 //
     /* 1118050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1118053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1118067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1118070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118089 */     // MIs[0] round
     /* 1118089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118099 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1118102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118124 */     // GIR_Coverage, 17362,
     /* 1118124 */     GIR_EraseRootFromParent_Done,
     /* 1118125 */   // Label 16396: @1118125
     /* 1118125 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1118205), // Rule ID 17363 //
     /* 1118130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1118133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1118147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1118150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118169 */     // MIs[0] round
     /* 1118169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118179 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1118182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118204 */     // GIR_Coverage, 17363,
     /* 1118204 */     GIR_EraseRootFromParent_Done,
     /* 1118205 */   // Label 16397: @1118205
     /* 1118205 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1118285), // Rule ID 17366 //
     /* 1118210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1118213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1118221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1118224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1118227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1118230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118249 */     // MIs[0] round
     /* 1118249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1118262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118284 */     // GIR_Coverage, 17366,
     /* 1118284 */     GIR_EraseRootFromParent_Done,
     /* 1118285 */   // Label 16398: @1118285
     /* 1118285 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1118365), // Rule ID 17367 //
     /* 1118290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1118293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1118301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1118304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1118307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1118310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118329 */     // MIs[0] round
     /* 1118329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118339 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1118342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118364 */     // GIR_Coverage, 17367,
     /* 1118364 */     GIR_EraseRootFromParent_Done,
     /* 1118365 */   // Label 16399: @1118365
     /* 1118365 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1118445), // Rule ID 17370 //
     /* 1118370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1118373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1118387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1118390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118409 */     // MIs[0] round
     /* 1118409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1118422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118444 */     // GIR_Coverage, 17370,
     /* 1118444 */     GIR_EraseRootFromParent_Done,
     /* 1118445 */   // Label 16400: @1118445
     /* 1118445 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1118525), // Rule ID 17371 //
     /* 1118450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1118453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1118467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1118470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118489 */     // MIs[0] round
     /* 1118489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1118502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118524 */     // GIR_Coverage, 17371,
     /* 1118524 */     GIR_EraseRootFromParent_Done,
     /* 1118525 */   // Label 16401: @1118525
     /* 1118525 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1118605), // Rule ID 17374 //
     /* 1118530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1118533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1118541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1118544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1118547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1118550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118569 */     // MIs[0] round
     /* 1118569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1118582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1118600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118604 */     // GIR_Coverage, 17374,
     /* 1118604 */     GIR_EraseRootFromParent_Done,
     /* 1118605 */   // Label 16402: @1118605
     /* 1118605 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1118685), // Rule ID 17375 //
     /* 1118610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1118613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1118621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1118624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1118627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1118630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118649 */     // MIs[0] round
     /* 1118649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118659 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1118662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1118680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118684 */     // GIR_Coverage, 17375,
     /* 1118684 */     GIR_EraseRootFromParent_Done,
     /* 1118685 */   // Label 16403: @1118685
     /* 1118685 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1118765), // Rule ID 17378 //
     /* 1118690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1118693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1118701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1118704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1118707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1118710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118729 */     // MIs[0] round
     /* 1118729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1118742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118764 */     // GIR_Coverage, 17378,
     /* 1118764 */     GIR_EraseRootFromParent_Done,
     /* 1118765 */   // Label 16404: @1118765
     /* 1118765 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1118845), // Rule ID 17379 //
     /* 1118770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1118773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1118781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1118784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1118787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1118790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118809 */     // MIs[0] round
     /* 1118809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118819 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1118822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118844 */     // GIR_Coverage, 17379,
     /* 1118844 */     GIR_EraseRootFromParent_Done,
     /* 1118845 */   // Label 16405: @1118845
     /* 1118845 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1118925), // Rule ID 17382 //
     /* 1118850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1118853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1118861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1118864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1118867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1118870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1118873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118889 */     // MIs[0] round
     /* 1118889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1118899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1118902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1118920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1118923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118924 */     // GIR_Coverage, 17382,
     /* 1118924 */     GIR_EraseRootFromParent_Done,
     /* 1118925 */   // Label 16406: @1118925
     /* 1118925 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1119005), // Rule ID 17383 //
     /* 1118930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1118933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1118938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1118941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1118944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1118947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1118950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1118953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118969 */     // MIs[0] round
     /* 1118969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1118972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118979 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1118979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1118982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1118986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1118992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1119000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119004 */     // GIR_Coverage, 17383,
     /* 1119004 */     GIR_EraseRootFromParent_Done,
     /* 1119005 */   // Label 16407: @1119005
     /* 1119005 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1119085), // Rule ID 17386 //
     /* 1119010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1119013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1119021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1119024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1119027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1119030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119049 */     // MIs[0] round
     /* 1119049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119059 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1119062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1119080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119084 */     // GIR_Coverage, 17386,
     /* 1119084 */     GIR_EraseRootFromParent_Done,
     /* 1119085 */   // Label 16408: @1119085
     /* 1119085 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1119165), // Rule ID 17387 //
     /* 1119090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1119093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1119101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1119104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1119107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1119110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119129 */     // MIs[0] round
     /* 1119129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119139 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1119142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1119160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119164 */     // GIR_Coverage, 17387,
     /* 1119164 */     GIR_EraseRootFromParent_Done,
     /* 1119165 */   // Label 16409: @1119165
     /* 1119165 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1119245), // Rule ID 17390 //
     /* 1119170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1119173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1119187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1119190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119209 */     // MIs[0] round
     /* 1119209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119219 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1119222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119244 */     // GIR_Coverage, 17390,
     /* 1119244 */     GIR_EraseRootFromParent_Done,
     /* 1119245 */   // Label 16410: @1119245
     /* 1119245 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1119325), // Rule ID 17391 //
     /* 1119250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1119253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1119267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1119270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119289 */     // MIs[0] round
     /* 1119289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1119302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119324 */     // GIR_Coverage, 17391,
     /* 1119324 */     GIR_EraseRootFromParent_Done,
     /* 1119325 */   // Label 16411: @1119325
     /* 1119325 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1119405), // Rule ID 17394 //
     /* 1119330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1119333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1119347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1119350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119369 */     // MIs[0] round
     /* 1119369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119379 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1119382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119404 */     // GIR_Coverage, 17394,
     /* 1119404 */     GIR_EraseRootFromParent_Done,
     /* 1119405 */   // Label 16412: @1119405
     /* 1119405 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1119485), // Rule ID 17395 //
     /* 1119410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1119413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1119427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1119430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119449 */     // MIs[0] round
     /* 1119449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119459 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1119462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119484 */     // GIR_Coverage, 17395,
     /* 1119484 */     GIR_EraseRootFromParent_Done,
     /* 1119485 */   // Label 16413: @1119485
     /* 1119485 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1119565), // Rule ID 17398 //
     /* 1119490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1119493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1119507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1119510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119529 */     // MIs[0] round
     /* 1119529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119539 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1119542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119564 */     // GIR_Coverage, 17398,
     /* 1119564 */     GIR_EraseRootFromParent_Done,
     /* 1119565 */   // Label 16414: @1119565
     /* 1119565 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1119645), // Rule ID 17399 //
     /* 1119570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1119573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1119587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1119590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119609 */     // MIs[0] round
     /* 1119609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119619 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1119622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119644 */     // GIR_Coverage, 17399,
     /* 1119644 */     GIR_EraseRootFromParent_Done,
     /* 1119645 */   // Label 16415: @1119645
     /* 1119645 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1119725), // Rule ID 17402 //
     /* 1119650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1119653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1119661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1119664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1119667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1119670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119689 */     // MIs[0] round
     /* 1119689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119699 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1119702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1119720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119724 */     // GIR_Coverage, 17402,
     /* 1119724 */     GIR_EraseRootFromParent_Done,
     /* 1119725 */   // Label 16416: @1119725
     /* 1119725 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1119805), // Rule ID 17403 //
     /* 1119730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1119733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1119741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1119744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1119747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1119750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119769 */     // MIs[0] round
     /* 1119769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119779 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1119782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1119800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119804 */     // GIR_Coverage, 17403,
     /* 1119804 */     GIR_EraseRootFromParent_Done,
     /* 1119805 */   // Label 16417: @1119805
     /* 1119805 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1119885), // Rule ID 17406 //
     /* 1119810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1119813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1119821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1119824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1119827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1119830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119849 */     // MIs[0] round
     /* 1119849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119859 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1119859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1119862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1119880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119884 */     // GIR_Coverage, 17406,
     /* 1119884 */     GIR_EraseRootFromParent_Done,
     /* 1119885 */   // Label 16418: @1119885
     /* 1119885 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1119965), // Rule ID 17407 //
     /* 1119890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1119893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1119901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1119904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1119907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1119910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1119913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119929 */     // MIs[0] round
     /* 1119929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1119932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119939 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1119939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1119942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1119946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1119952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1119960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1119963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119964 */     // GIR_Coverage, 17407,
     /* 1119964 */     GIR_EraseRootFromParent_Done,
     /* 1119965 */   // Label 16419: @1119965
     /* 1119965 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1120045), // Rule ID 17410 //
     /* 1119970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1119973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1119978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1119981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1119984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1119987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1119990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1119993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120009 */     // MIs[0] round
     /* 1120009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120019 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1120022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1120040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120044 */     // GIR_Coverage, 17410,
     /* 1120044 */     GIR_EraseRootFromParent_Done,
     /* 1120045 */   // Label 16420: @1120045
     /* 1120045 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1120125), // Rule ID 17411 //
     /* 1120050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1120053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1120061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1120064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1120067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1120070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120089 */     // MIs[0] round
     /* 1120089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120099 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1120102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1120120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120124 */     // GIR_Coverage, 17411,
     /* 1120124 */     GIR_EraseRootFromParent_Done,
     /* 1120125 */   // Label 16421: @1120125
     /* 1120125 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1120205), // Rule ID 17414 //
     /* 1120130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1120133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1120141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1120144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1120147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120169 */     // MIs[0] round
     /* 1120169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120179 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1120182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120204 */     // GIR_Coverage, 17414,
     /* 1120204 */     GIR_EraseRootFromParent_Done,
     /* 1120205 */   // Label 16422: @1120205
     /* 1120205 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1120285), // Rule ID 17415 //
     /* 1120210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1120213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1120221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1120224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1120227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120249 */     // MIs[0] round
     /* 1120249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120259 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1120262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120284 */     // GIR_Coverage, 17415,
     /* 1120284 */     GIR_EraseRootFromParent_Done,
     /* 1120285 */   // Label 16423: @1120285
     /* 1120285 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1120365), // Rule ID 17418 //
     /* 1120290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1120293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1120301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1120304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1120307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120329 */     // MIs[0] round
     /* 1120329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120339 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1120342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120364 */     // GIR_Coverage, 17418,
     /* 1120364 */     GIR_EraseRootFromParent_Done,
     /* 1120365 */   // Label 16424: @1120365
     /* 1120365 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1120445), // Rule ID 17419 //
     /* 1120370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1120373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1120381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1120384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1120387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120409 */     // MIs[0] round
     /* 1120409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120419 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1120422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120444 */     // GIR_Coverage, 17419,
     /* 1120444 */     GIR_EraseRootFromParent_Done,
     /* 1120445 */   // Label 16425: @1120445
     /* 1120445 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1120525), // Rule ID 17422 //
     /* 1120450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1120453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1120467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1120470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1120489 */     // MIs[0] round
     /* 1120489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120499 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1120502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120524 */     // GIR_Coverage, 17422,
     /* 1120524 */     GIR_EraseRootFromParent_Done,
     /* 1120525 */   // Label 16426: @1120525
     /* 1120525 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1120605), // Rule ID 17423 //
     /* 1120530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1120533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1120547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1120550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1120569 */     // MIs[0] round
     /* 1120569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120579 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1120582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120604 */     // GIR_Coverage, 17423,
     /* 1120604 */     GIR_EraseRootFromParent_Done,
     /* 1120605 */   // Label 16427: @1120605
     /* 1120605 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1120685), // Rule ID 17426 //
     /* 1120610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1120613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1120621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1120624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1120627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120649 */     // MIs[0] round
     /* 1120649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120659 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1120662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120684 */     // GIR_Coverage, 17426,
     /* 1120684 */     GIR_EraseRootFromParent_Done,
     /* 1120685 */   // Label 16428: @1120685
     /* 1120685 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1120765), // Rule ID 17427 //
     /* 1120690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1120693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1120701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1120704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1120707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1120710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1120729 */     // MIs[0] round
     /* 1120729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120739 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1120742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1120760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120764 */     // GIR_Coverage, 17427,
     /* 1120764 */     GIR_EraseRootFromParent_Done,
     /* 1120765 */   // Label 16429: @1120765
     /* 1120765 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1120845), // Rule ID 17430 //
     /* 1120770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1120773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1120787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1120790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1120809 */     // MIs[0] round
     /* 1120809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1120822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120844 */     // GIR_Coverage, 17430,
     /* 1120844 */     GIR_EraseRootFromParent_Done,
     /* 1120845 */   // Label 16430: @1120845
     /* 1120845 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1120925), // Rule ID 17431 //
     /* 1120850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1120853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1120867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1120870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1120873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1120889 */     // MIs[0] round
     /* 1120889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120899 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1120899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1120902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1120923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120924 */     // GIR_Coverage, 17431,
     /* 1120924 */     GIR_EraseRootFromParent_Done,
     /* 1120925 */   // Label 16431: @1120925
     /* 1120925 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1121005), // Rule ID 17434 //
     /* 1120930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1120933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1120938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1120941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1120944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1120947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1120950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1120953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1120969 */     // MIs[0] round
     /* 1120969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1120972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120979 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1120979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1120982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1120986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1120992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1121000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121004 */     // GIR_Coverage, 17434,
     /* 1121004 */     GIR_EraseRootFromParent_Done,
     /* 1121005 */   // Label 16432: @1121005
     /* 1121005 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1121085), // Rule ID 17435 //
     /* 1121010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1121013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1121021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1121024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1121027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1121030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1121049 */     // MIs[0] round
     /* 1121049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121059 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1121062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1121080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121084 */     // GIR_Coverage, 17435,
     /* 1121084 */     GIR_EraseRootFromParent_Done,
     /* 1121085 */   // Label 16433: @1121085
     /* 1121085 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1121165), // Rule ID 17438 //
     /* 1121090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1121093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1121101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1121104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1121107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121129 */     // MIs[0] round
     /* 1121129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121139 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1121142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121164 */     // GIR_Coverage, 17438,
     /* 1121164 */     GIR_EraseRootFromParent_Done,
     /* 1121165 */   // Label 16434: @1121165
     /* 1121165 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1121245), // Rule ID 17439 //
     /* 1121170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1121173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1121181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1121184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1121187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121209 */     // MIs[0] round
     /* 1121209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121219 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1121222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121244 */     // GIR_Coverage, 17439,
     /* 1121244 */     GIR_EraseRootFromParent_Done,
     /* 1121245 */   // Label 16435: @1121245
     /* 1121245 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1121325), // Rule ID 17442 //
     /* 1121250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1121253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1121261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1121264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1121267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121289 */     // MIs[0] round
     /* 1121289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121299 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1121302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121324 */     // GIR_Coverage, 17442,
     /* 1121324 */     GIR_EraseRootFromParent_Done,
     /* 1121325 */   // Label 16436: @1121325
     /* 1121325 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1121405), // Rule ID 17443 //
     /* 1121330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1121333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1121341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1121344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1121347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121369 */     // MIs[0] round
     /* 1121369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121379 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1121382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121404 */     // GIR_Coverage, 17443,
     /* 1121404 */     GIR_EraseRootFromParent_Done,
     /* 1121405 */   // Label 16437: @1121405
     /* 1121405 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1121485), // Rule ID 17446 //
     /* 1121410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1121413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1121421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1121424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1121427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121449 */     // MIs[0] round
     /* 1121449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121459 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1121462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121484 */     // GIR_Coverage, 17446,
     /* 1121484 */     GIR_EraseRootFromParent_Done,
     /* 1121485 */   // Label 16438: @1121485
     /* 1121485 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1121565), // Rule ID 17447 //
     /* 1121490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1121493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1121501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1121504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1121507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1121510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1121529 */     // MIs[0] round
     /* 1121529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121539 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1121542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1121560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121564 */     // GIR_Coverage, 17447,
     /* 1121564 */     GIR_EraseRootFromParent_Done,
     /* 1121565 */   // Label 16439: @1121565
     /* 1121565 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1121645), // Rule ID 17450 //
     /* 1121570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1121573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1121587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1121609 */     // MIs[0] round
     /* 1121609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121619 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1121622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121644 */     // GIR_Coverage, 17450,
     /* 1121644 */     GIR_EraseRootFromParent_Done,
     /* 1121645 */   // Label 16440: @1121645
     /* 1121645 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1121725), // Rule ID 17451 //
     /* 1121650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1121653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1121667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1121689 */     // MIs[0] round
     /* 1121689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1121702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121724 */     // GIR_Coverage, 17451,
     /* 1121724 */     GIR_EraseRootFromParent_Done,
     /* 1121725 */   // Label 16441: @1121725
     /* 1121725 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1121805), // Rule ID 17454 //
     /* 1121730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1121733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1121747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1121769 */     // MIs[0] round
     /* 1121769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121779 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1121782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121804 */     // GIR_Coverage, 17454,
     /* 1121804 */     GIR_EraseRootFromParent_Done,
     /* 1121805 */   // Label 16442: @1121805
     /* 1121805 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1121885), // Rule ID 17455 //
     /* 1121810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1121813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1121827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1121849 */     // MIs[0] round
     /* 1121849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121859 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1121859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1121862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121884 */     // GIR_Coverage, 17455,
     /* 1121884 */     GIR_EraseRootFromParent_Done,
     /* 1121885 */   // Label 16443: @1121885
     /* 1121885 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1121965), // Rule ID 17458 //
     /* 1121890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1121893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1121907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1121913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1121929 */     // MIs[0] round
     /* 1121929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1121932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121939 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1121939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1121942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1121946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1121952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1121963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121964 */     // GIR_Coverage, 17458,
     /* 1121964 */     GIR_EraseRootFromParent_Done,
     /* 1121965 */   // Label 16444: @1121965
     /* 1121965 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1122045), // Rule ID 17459 //
     /* 1121970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1121973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1121978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1121987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1121990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1121993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1122009 */     // MIs[0] round
     /* 1122009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122019 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1122022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122044 */     // GIR_Coverage, 17459,
     /* 1122044 */     GIR_EraseRootFromParent_Done,
     /* 1122045 */   // Label 16445: @1122045
     /* 1122045 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1122125), // Rule ID 17462 //
     /* 1122050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1122053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1122061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1122064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1122067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122089 */     // MIs[0] round
     /* 1122089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122099 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1122102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122124 */     // GIR_Coverage, 17462,
     /* 1122124 */     GIR_EraseRootFromParent_Done,
     /* 1122125 */   // Label 16446: @1122125
     /* 1122125 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1122205), // Rule ID 17463 //
     /* 1122130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1122133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1122141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1122144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1122147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122169 */     // MIs[0] round
     /* 1122169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122179 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1122182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122204 */     // GIR_Coverage, 17463,
     /* 1122204 */     GIR_EraseRootFromParent_Done,
     /* 1122205 */   // Label 16447: @1122205
     /* 1122205 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1122285), // Rule ID 17466 //
     /* 1122210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1122213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1122221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1122224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1122227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122249 */     // MIs[0] round
     /* 1122249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122259 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1122262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122284 */     // GIR_Coverage, 17466,
     /* 1122284 */     GIR_EraseRootFromParent_Done,
     /* 1122285 */   // Label 16448: @1122285
     /* 1122285 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1122365), // Rule ID 17467 //
     /* 1122290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1122293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1122301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1122304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1122307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122329 */     // MIs[0] round
     /* 1122329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122339 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1122342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122364 */     // GIR_Coverage, 17467,
     /* 1122364 */     GIR_EraseRootFromParent_Done,
     /* 1122365 */   // Label 16449: @1122365
     /* 1122365 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1122445), // Rule ID 17470 //
     /* 1122370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1122373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1122381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1122384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1122387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122409 */     // MIs[0] round
     /* 1122409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122419 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1122422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122444 */     // GIR_Coverage, 17470,
     /* 1122444 */     GIR_EraseRootFromParent_Done,
     /* 1122445 */   // Label 16450: @1122445
     /* 1122445 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1122525), // Rule ID 17471 //
     /* 1122450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1122453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1122458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1122461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1122464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1122467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1122470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1122489 */     // MIs[0] round
     /* 1122489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122499 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1122502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1122520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122524 */     // GIR_Coverage, 17471,
     /* 1122524 */     GIR_EraseRootFromParent_Done,
     /* 1122525 */   // Label 16451: @1122525
     /* 1122525 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1122605), // Rule ID 17474 //
     /* 1122530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1122533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1122541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1122544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1122547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1122550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1122569 */     // MIs[0] round
     /* 1122569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122579 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1122582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1122600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122604 */     // GIR_Coverage, 17474,
     /* 1122604 */     GIR_EraseRootFromParent_Done,
     /* 1122605 */   // Label 16452: @1122605
     /* 1122605 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1122685), // Rule ID 17475 //
     /* 1122610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1122613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1122621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1122624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1122627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1122630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1122649 */     // MIs[0] round
     /* 1122649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122659 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1122662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1122680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122684 */     // GIR_Coverage, 17475,
     /* 1122684 */     GIR_EraseRootFromParent_Done,
     /* 1122685 */   // Label 16453: @1122685
     /* 1122685 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1122765), // Rule ID 17478 //
     /* 1122690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1122693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1122701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1122704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1122707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1122710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1122729 */     // MIs[0] round
     /* 1122729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122739 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1122742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1122760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122764 */     // GIR_Coverage, 17478,
     /* 1122764 */     GIR_EraseRootFromParent_Done,
     /* 1122765 */   // Label 16454: @1122765
     /* 1122765 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1122845), // Rule ID 17479 //
     /* 1122770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1122773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1122781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1122784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1122787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1122790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1122809 */     // MIs[0] round
     /* 1122809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122819 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1122822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1122840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122844 */     // GIR_Coverage, 17479,
     /* 1122844 */     GIR_EraseRootFromParent_Done,
     /* 1122845 */   // Label 16455: @1122845
     /* 1122845 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1122925), // Rule ID 17482 //
     /* 1122850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1122853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1122867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1122870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1122873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1122889 */     // MIs[0] round
     /* 1122889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1122899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1122902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1122923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122924 */     // GIR_Coverage, 17482,
     /* 1122924 */     GIR_EraseRootFromParent_Done,
     /* 1122925 */   // Label 16456: @1122925
     /* 1122925 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1123005), // Rule ID 17483 //
     /* 1122930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1122933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1122938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1122947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1122950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1122953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1122969 */     // MIs[0] round
     /* 1122969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1122972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1122979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1122982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1122986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1122992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1123000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123004 */     // GIR_Coverage, 17483,
     /* 1123004 */     GIR_EraseRootFromParent_Done,
     /* 1123005 */   // Label 16457: @1123005
     /* 1123005 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1123085), // Rule ID 17486 //
     /* 1123010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1123013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1123021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1123024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1123027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123049 */     // MIs[0] round
     /* 1123049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1123062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123084 */     // GIR_Coverage, 17486,
     /* 1123084 */     GIR_EraseRootFromParent_Done,
     /* 1123085 */   // Label 16458: @1123085
     /* 1123085 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1123165), // Rule ID 17487 //
     /* 1123090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1123093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1123101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1123104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1123107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123129 */     // MIs[0] round
     /* 1123129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123139 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10940:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1123142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123164 */     // GIR_Coverage, 17487,
     /* 1123164 */     GIR_EraseRootFromParent_Done,
     /* 1123165 */   // Label 16459: @1123165
     /* 1123165 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1123245), // Rule ID 17490 //
     /* 1123170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1123173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1123187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1123190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1123209 */     // MIs[0] round
     /* 1123209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10940:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1123222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1123240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123244 */     // GIR_Coverage, 17490,
     /* 1123244 */     GIR_EraseRootFromParent_Done,
     /* 1123245 */   // Label 16460: @1123245
     /* 1123245 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1123325), // Rule ID 17491 //
     /* 1123250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1123253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1123267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1123270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1123289 */     // MIs[0] round
     /* 1123289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10940:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1123302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1123320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123324 */     // GIR_Coverage, 17491,
     /* 1123324 */     GIR_EraseRootFromParent_Done,
     /* 1123325 */   // Label 16461: @1123325
     /* 1123325 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1123405), // Rule ID 17494 //
     /* 1123330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1123333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1123341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1123344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1123347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1123350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1123369 */     // MIs[0] round
     /* 1123369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123379 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1123382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1123400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123404 */     // GIR_Coverage, 17494,
     /* 1123404 */     GIR_EraseRootFromParent_Done,
     /* 1123405 */   // Label 16462: @1123405
     /* 1123405 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1123485), // Rule ID 17495 //
     /* 1123410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1123413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1123421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1123424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1123427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1123430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1123449 */     // MIs[0] round
     /* 1123449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123459 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10940:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1123462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1123480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123484 */     // GIR_Coverage, 17495,
     /* 1123484 */     GIR_EraseRootFromParent_Done,
     /* 1123485 */   // Label 16463: @1123485
     /* 1123485 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1123565), // Rule ID 17498 //
     /* 1123490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1123493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1123501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1123504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1123507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123529 */     // MIs[0] round
     /* 1123529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123539 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1123542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123564 */     // GIR_Coverage, 17498,
     /* 1123564 */     GIR_EraseRootFromParent_Done,
     /* 1123565 */   // Label 16464: @1123565
     /* 1123565 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1123645), // Rule ID 17499 //
     /* 1123570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1123573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1123581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1123584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1123587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123609 */     // MIs[0] round
     /* 1123609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123619 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1123622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123644 */     // GIR_Coverage, 17499,
     /* 1123644 */     GIR_EraseRootFromParent_Done,
     /* 1123645 */   // Label 16465: @1123645
     /* 1123645 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1123725), // Rule ID 17502 //
     /* 1123650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1123653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1123661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1123664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1123667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123689 */     // MIs[0] round
     /* 1123689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123699 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1123702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123724 */     // GIR_Coverage, 17502,
     /* 1123724 */     GIR_EraseRootFromParent_Done,
     /* 1123725 */   // Label 16466: @1123725
     /* 1123725 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1123805), // Rule ID 17503 //
     /* 1123730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1123733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1123741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1123744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1123747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123769 */     // MIs[0] round
     /* 1123769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123779 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1123782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123804 */     // GIR_Coverage, 17503,
     /* 1123804 */     GIR_EraseRootFromParent_Done,
     /* 1123805 */   // Label 16467: @1123805
     /* 1123805 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1123885), // Rule ID 17506 //
     /* 1123810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1123813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1123821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1123824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1123827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123849 */     // MIs[0] round
     /* 1123849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123859 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1123862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123884 */     // GIR_Coverage, 17506,
     /* 1123884 */     GIR_EraseRootFromParent_Done,
     /* 1123885 */   // Label 16468: @1123885
     /* 1123885 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1123965), // Rule ID 17507 //
     /* 1123890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1123893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1123901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1123904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1123907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1123910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1123929 */     // MIs[0] round
     /* 1123929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123939 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1123942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123964 */     // GIR_Coverage, 17507,
     /* 1123964 */     GIR_EraseRootFromParent_Done,
     /* 1123965 */   // Label 16469: @1123965
     /* 1123965 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1124045), // Rule ID 17510 //
     /* 1123970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1123973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1123978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1123987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1123990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124009 */     // MIs[0] round
     /* 1124009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124019 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1124022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124044 */     // GIR_Coverage, 17510,
     /* 1124044 */     GIR_EraseRootFromParent_Done,
     /* 1124045 */   // Label 16470: @1124045
     /* 1124045 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1124125), // Rule ID 17511 //
     /* 1124050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1124053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1124067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1124070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124089 */     // MIs[0] round
     /* 1124089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124099 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1124102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124124 */     // GIR_Coverage, 17511,
     /* 1124124 */     GIR_EraseRootFromParent_Done,
     /* 1124125 */   // Label 16471: @1124125
     /* 1124125 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1124205), // Rule ID 17514 //
     /* 1124130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1124133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1124147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1124150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124169 */     // MIs[0] round
     /* 1124169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124179 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1124182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124204 */     // GIR_Coverage, 17514,
     /* 1124204 */     GIR_EraseRootFromParent_Done,
     /* 1124205 */   // Label 16472: @1124205
     /* 1124205 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1124285), // Rule ID 17515 //
     /* 1124210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1124213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1124227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1124230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124249 */     // MIs[0] round
     /* 1124249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124259 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1124262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124284 */     // GIR_Coverage, 17515,
     /* 1124284 */     GIR_EraseRootFromParent_Done,
     /* 1124285 */   // Label 16473: @1124285
     /* 1124285 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1124365), // Rule ID 17518 //
     /* 1124290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1124293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1124307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1124310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124329 */     // MIs[0] round
     /* 1124329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124339 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1124342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124364 */     // GIR_Coverage, 17518,
     /* 1124364 */     GIR_EraseRootFromParent_Done,
     /* 1124365 */   // Label 16474: @1124365
     /* 1124365 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1124445), // Rule ID 17519 //
     /* 1124370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1124373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1124387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1124390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1124409 */     // MIs[0] round
     /* 1124409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124419 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1124422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124444 */     // GIR_Coverage, 17519,
     /* 1124444 */     GIR_EraseRootFromParent_Done,
     /* 1124445 */   // Label 16475: @1124445
     /* 1124445 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1124525), // Rule ID 17522 //
     /* 1124450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1124453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1124461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1124464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1124467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124489 */     // MIs[0] round
     /* 1124489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124499 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1124502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124524 */     // GIR_Coverage, 17522,
     /* 1124524 */     GIR_EraseRootFromParent_Done,
     /* 1124525 */   // Label 16476: @1124525
     /* 1124525 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1124605), // Rule ID 17523 //
     /* 1124530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1124533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1124541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1124544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1124547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124569 */     // MIs[0] round
     /* 1124569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124579 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10940:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1124582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124604 */     // GIR_Coverage, 17523,
     /* 1124604 */     GIR_EraseRootFromParent_Done,
     /* 1124605 */   // Label 16477: @1124605
     /* 1124605 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1124685), // Rule ID 17526 //
     /* 1124610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1124613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1124621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1124624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1124627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124649 */     // MIs[0] round
     /* 1124649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124659 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1124662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124684 */     // GIR_Coverage, 17526,
     /* 1124684 */     GIR_EraseRootFromParent_Done,
     /* 1124685 */   // Label 16478: @1124685
     /* 1124685 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1124765), // Rule ID 17527 //
     /* 1124690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1124693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1124701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1124704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1124707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124729 */     // MIs[0] round
     /* 1124729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124739 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10940:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1124742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124764 */     // GIR_Coverage, 17527,
     /* 1124764 */     GIR_EraseRootFromParent_Done,
     /* 1124765 */   // Label 16479: @1124765
     /* 1124765 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1124845), // Rule ID 17530 //
     /* 1124770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1124773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1124781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1124784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1124787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124809 */     // MIs[0] round
     /* 1124809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124819 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1124822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124844 */     // GIR_Coverage, 17530,
     /* 1124844 */     GIR_EraseRootFromParent_Done,
     /* 1124845 */   // Label 16480: @1124845
     /* 1124845 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1124925), // Rule ID 17531 //
     /* 1124850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1124853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1124858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1124861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1124864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1124867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1124870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1124889 */     // MIs[0] round
     /* 1124889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124899 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10940:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1124902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124924 */     // GIR_Coverage, 17531,
     /* 1124924 */     GIR_EraseRootFromParent_Done,
     /* 1124925 */   // Label 16481: @1124925
     /* 1124925 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1125005), // Rule ID 17534 //
     /* 1124930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1124933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1124938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1124947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1124950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124969 */     // MIs[0] round
     /* 1124969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1124982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125004 */     // GIR_Coverage, 17534,
     /* 1125004 */     GIR_EraseRootFromParent_Done,
     /* 1125005 */   // Label 16482: @1125005
     /* 1125005 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1125085), // Rule ID 17535 //
     /* 1125010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1125013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1125021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1125024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1125027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1125030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125049 */     // MIs[0] round
     /* 1125049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125059 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1125062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125084 */     // GIR_Coverage, 17535,
     /* 1125084 */     GIR_EraseRootFromParent_Done,
     /* 1125085 */   // Label 16483: @1125085
     /* 1125085 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1125165), // Rule ID 17538 //
     /* 1125090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1125093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1125107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1125110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125129 */     // MIs[0] round
     /* 1125129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1125142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125164 */     // GIR_Coverage, 17538,
     /* 1125164 */     GIR_EraseRootFromParent_Done,
     /* 1125165 */   // Label 16484: @1125165
     /* 1125165 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1125245), // Rule ID 17539 //
     /* 1125170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1125173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1125187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1125190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125209 */     // MIs[0] round
     /* 1125209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1125222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125244 */     // GIR_Coverage, 17539,
     /* 1125244 */     GIR_EraseRootFromParent_Done,
     /* 1125245 */   // Label 16485: @1125245
     /* 1125245 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1125325), // Rule ID 17542 //
     /* 1125250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1125253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125289 */     // MIs[0] round
     /* 1125289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1125302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125324 */     // GIR_Coverage, 17542,
     /* 1125324 */     GIR_EraseRootFromParent_Done,
     /* 1125325 */   // Label 16486: @1125325
     /* 1125325 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1125405), // Rule ID 17543 //
     /* 1125330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1125333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125369 */     // MIs[0] round
     /* 1125369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125379 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1125382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125404 */     // GIR_Coverage, 17543,
     /* 1125404 */     GIR_EraseRootFromParent_Done,
     /* 1125405 */   // Label 16487: @1125405
     /* 1125405 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1125485), // Rule ID 17546 //
     /* 1125410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1125413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125449 */     // MIs[0] round
     /* 1125449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125459 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1125462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125484 */     // GIR_Coverage, 17546,
     /* 1125484 */     GIR_EraseRootFromParent_Done,
     /* 1125485 */   // Label 16488: @1125485
     /* 1125485 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1125565), // Rule ID 17547 //
     /* 1125490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1125493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125529 */     // MIs[0] round
     /* 1125529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125539 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1125542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125564 */     // GIR_Coverage, 17547,
     /* 1125564 */     GIR_EraseRootFromParent_Done,
     /* 1125565 */   // Label 16489: @1125565
     /* 1125565 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1125645), // Rule ID 17550 //
     /* 1125570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1125573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125609 */     // MIs[0] round
     /* 1125609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125619 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1125622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125644 */     // GIR_Coverage, 17550,
     /* 1125644 */     GIR_EraseRootFromParent_Done,
     /* 1125645 */   // Label 16490: @1125645
     /* 1125645 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1125725), // Rule ID 17551 //
     /* 1125650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1125653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125689 */     // MIs[0] round
     /* 1125689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125699 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1125702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125724 */     // GIR_Coverage, 17551,
     /* 1125724 */     GIR_EraseRootFromParent_Done,
     /* 1125725 */   // Label 16491: @1125725
     /* 1125725 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1125805), // Rule ID 17554 //
     /* 1125730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1125733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1125747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1125750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125769 */     // MIs[0] round
     /* 1125769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125779 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1125782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125804 */     // GIR_Coverage, 17554,
     /* 1125804 */     GIR_EraseRootFromParent_Done,
     /* 1125805 */   // Label 16492: @1125805
     /* 1125805 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1125885), // Rule ID 17555 //
     /* 1125810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1125813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1125827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1125830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125849 */     // MIs[0] round
     /* 1125849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1125862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125884 */     // GIR_Coverage, 17555,
     /* 1125884 */     GIR_EraseRootFromParent_Done,
     /* 1125885 */   // Label 16493: @1125885
     /* 1125885 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1125965), // Rule ID 17558 //
     /* 1125890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1125893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1125907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1125910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125929 */     // MIs[0] round
     /* 1125929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1125942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125964 */     // GIR_Coverage, 17558,
     /* 1125964 */     GIR_EraseRootFromParent_Done,
     /* 1125965 */   // Label 16494: @1125965
     /* 1125965 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1126045), // Rule ID 17559 //
     /* 1125970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1125973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1125978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1125987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1125990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126009 */     // MIs[0] round
     /* 1126009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126019 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1126022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126044 */     // GIR_Coverage, 17559,
     /* 1126044 */     GIR_EraseRootFromParent_Done,
     /* 1126045 */   // Label 16495: @1126045
     /* 1126045 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1126125), // Rule ID 17562 //
     /* 1126050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1126053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1126067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1126070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126089 */     // MIs[0] round
     /* 1126089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126099 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1126102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126124 */     // GIR_Coverage, 17562,
     /* 1126124 */     GIR_EraseRootFromParent_Done,
     /* 1126125 */   // Label 16496: @1126125
     /* 1126125 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1126205), // Rule ID 17563 //
     /* 1126130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1126133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1126147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1126150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126169 */     // MIs[0] round
     /* 1126169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126179 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1126182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126204 */     // GIR_Coverage, 17563,
     /* 1126204 */     GIR_EraseRootFromParent_Done,
     /* 1126205 */   // Label 16497: @1126205
     /* 1126205 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1126285), // Rule ID 17566 //
     /* 1126210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1126213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1126227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1126230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126249 */     // MIs[0] round
     /* 1126249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126259 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1126262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126284 */     // GIR_Coverage, 17566,
     /* 1126284 */     GIR_EraseRootFromParent_Done,
     /* 1126285 */   // Label 16498: @1126285
     /* 1126285 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1126365), // Rule ID 17567 //
     /* 1126290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1126293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1126307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1126310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126329 */     // MIs[0] round
     /* 1126329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126339 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1126342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126364 */     // GIR_Coverage, 17567,
     /* 1126364 */     GIR_EraseRootFromParent_Done,
     /* 1126365 */   // Label 16499: @1126365
     /* 1126365 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1126445), // Rule ID 17570 //
     /* 1126370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1126373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1126387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126409 */     // MIs[0] round
     /* 1126409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126419 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1126422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126444 */     // GIR_Coverage, 17570,
     /* 1126444 */     GIR_EraseRootFromParent_Done,
     /* 1126445 */   // Label 16500: @1126445
     /* 1126445 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1126525), // Rule ID 17571 //
     /* 1126450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1126453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1126467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126489 */     // MIs[0] round
     /* 1126489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126499 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1126502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126524 */     // GIR_Coverage, 17571,
     /* 1126524 */     GIR_EraseRootFromParent_Done,
     /* 1126525 */   // Label 16501: @1126525
     /* 1126525 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1126605), // Rule ID 17574 //
     /* 1126530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1126533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1126547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126569 */     // MIs[0] round
     /* 1126569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1126582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126604 */     // GIR_Coverage, 17574,
     /* 1126604 */     GIR_EraseRootFromParent_Done,
     /* 1126605 */   // Label 16502: @1126605
     /* 1126605 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1126685), // Rule ID 17575 //
     /* 1126610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1126613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1126627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126649 */     // MIs[0] round
     /* 1126649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10996:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1126662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126684 */     // GIR_Coverage, 17575,
     /* 1126684 */     GIR_EraseRootFromParent_Done,
     /* 1126685 */   // Label 16503: @1126685
     /* 1126685 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1126765), // Rule ID 17578 //
     /* 1126690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1126693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126729 */     // MIs[0] round
     /* 1126729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1126742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126764 */     // GIR_Coverage, 17578,
     /* 1126764 */     GIR_EraseRootFromParent_Done,
     /* 1126765 */   // Label 16504: @1126765
     /* 1126765 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1126845), // Rule ID 17579 //
     /* 1126770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1126773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126809 */     // MIs[0] round
     /* 1126809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1126822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126844 */     // GIR_Coverage, 17579,
     /* 1126844 */     GIR_EraseRootFromParent_Done,
     /* 1126845 */   // Label 16505: @1126845
     /* 1126845 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1126925), // Rule ID 17582 //
     /* 1126850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1126853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126889 */     // MIs[0] round
     /* 1126889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126899 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1126902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126924 */     // GIR_Coverage, 17582,
     /* 1126924 */     GIR_EraseRootFromParent_Done,
     /* 1126925 */   // Label 16506: @1126925
     /* 1126925 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1127005), // Rule ID 17583 //
     /* 1126930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1126933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1126938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1126950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1126969 */     // MIs[0] round
     /* 1126969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126979 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1126982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1127000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127004 */     // GIR_Coverage, 17583,
     /* 1127004 */     GIR_EraseRootFromParent_Done,
     /* 1127005 */   // Label 16507: @1127005
     /* 1127005 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1127085), // Rule ID 17586 //
     /* 1127010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1127013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1127030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1127049 */     // MIs[0] round
     /* 1127049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127059 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1127062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1127080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127084 */     // GIR_Coverage, 17586,
     /* 1127084 */     GIR_EraseRootFromParent_Done,
     /* 1127085 */   // Label 16508: @1127085
     /* 1127085 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1127165), // Rule ID 17587 //
     /* 1127090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1127093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1127110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1127129 */     // MIs[0] round
     /* 1127129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127139 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1127142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1127160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127164 */     // GIR_Coverage, 17587,
     /* 1127164 */     GIR_EraseRootFromParent_Done,
     /* 1127165 */   // Label 16509: @1127165
     /* 1127165 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1127245), // Rule ID 17590 //
     /* 1127170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1127173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1127187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127209 */     // MIs[0] round
     /* 1127209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127219 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1127222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127244 */     // GIR_Coverage, 17590,
     /* 1127244 */     GIR_EraseRootFromParent_Done,
     /* 1127245 */   // Label 16510: @1127245
     /* 1127245 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1127325), // Rule ID 17591 //
     /* 1127250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1127253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1127267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127289 */     // MIs[0] round
     /* 1127289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127299 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10996:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1127302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127324 */     // GIR_Coverage, 17591,
     /* 1127324 */     GIR_EraseRootFromParent_Done,
     /* 1127325 */   // Label 16511: @1127325
     /* 1127325 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1127405), // Rule ID 17594 //
     /* 1127330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1127333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1127347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127369 */     // MIs[0] round
     /* 1127369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1127382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127404 */     // GIR_Coverage, 17594,
     /* 1127404 */     GIR_EraseRootFromParent_Done,
     /* 1127405 */   // Label 16512: @1127405
     /* 1127405 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1127485), // Rule ID 17595 //
     /* 1127410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1127413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1127427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127449 */     // MIs[0] round
     /* 1127449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127459 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10996:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1127462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127484 */     // GIR_Coverage, 17595,
     /* 1127484 */     GIR_EraseRootFromParent_Done,
     /* 1127485 */   // Label 16513: @1127485
     /* 1127485 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1127565), // Rule ID 17598 //
     /* 1127490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1127493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1127507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127529 */     // MIs[0] round
     /* 1127529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127539 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1127542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127564 */     // GIR_Coverage, 17598,
     /* 1127564 */     GIR_EraseRootFromParent_Done,
     /* 1127565 */   // Label 16514: @1127565
     /* 1127565 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1127645), // Rule ID 17599 //
     /* 1127570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1127573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1127587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127609 */     // MIs[0] round
     /* 1127609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127619 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10996:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1127622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127644 */     // GIR_Coverage, 17599,
     /* 1127644 */     GIR_EraseRootFromParent_Done,
     /* 1127645 */   // Label 16515: @1127645
     /* 1127645 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1127725), // Rule ID 17602 //
     /* 1127650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1127653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1127667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127689 */     // MIs[0] round
     /* 1127689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1127702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127724 */     // GIR_Coverage, 17602,
     /* 1127724 */     GIR_EraseRootFromParent_Done,
     /* 1127725 */   // Label 16516: @1127725
     /* 1127725 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1127805), // Rule ID 17603 //
     /* 1127730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1127733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1127738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1127747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1127769 */     // MIs[0] round
     /* 1127769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127779 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10996:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1127782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127804 */     // GIR_Coverage, 17603,
     /* 1127804 */     GIR_EraseRootFromParent_Done,
     /* 1127805 */   // Label 16517: @1127805
     /* 1127805 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1127885), // Rule ID 22680 //
     /* 1127810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1127813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1127818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1127821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1127824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1127827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127849 */     // MIs[0] round
     /* 1127849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127859 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1127862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1127880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127884 */     // GIR_Coverage, 22680,
     /* 1127884 */     GIR_EraseRootFromParent_Done,
     /* 1127885 */   // Label 16518: @1127885
     /* 1127885 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1127965), // Rule ID 22681 //
     /* 1127890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1127893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1127898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1127901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1127904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1127907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127929 */     // MIs[0] round
     /* 1127929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127939 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1127942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1127960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127964 */     // GIR_Coverage, 22681,
     /* 1127964 */     GIR_EraseRootFromParent_Done,
     /* 1127965 */   // Label 16519: @1127965
     /* 1127965 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1128045), // Rule ID 22684 //
     /* 1127970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1127973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1127978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1127987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1127990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128009 */     // MIs[0] round
     /* 1128009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128019 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1128022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128044 */     // GIR_Coverage, 22684,
     /* 1128044 */     GIR_EraseRootFromParent_Done,
     /* 1128045 */   // Label 16520: @1128045
     /* 1128045 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1128125), // Rule ID 22685 //
     /* 1128050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1128053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1128070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128089 */     // MIs[0] round
     /* 1128089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1128102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128124 */     // GIR_Coverage, 22685,
     /* 1128124 */     GIR_EraseRootFromParent_Done,
     /* 1128125 */   // Label 16521: @1128125
     /* 1128125 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1128205), // Rule ID 22688 //
     /* 1128130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128169 */     // MIs[0] round
     /* 1128169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128179 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1128182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128204 */     // GIR_Coverage, 22688,
     /* 1128204 */     GIR_EraseRootFromParent_Done,
     /* 1128205 */   // Label 16522: @1128205
     /* 1128205 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1128285), // Rule ID 22689 //
     /* 1128210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128249 */     // MIs[0] round
     /* 1128249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1128262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128284 */     // GIR_Coverage, 22689,
     /* 1128284 */     GIR_EraseRootFromParent_Done,
     /* 1128285 */   // Label 16523: @1128285
     /* 1128285 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1128365), // Rule ID 22692 //
     /* 1128290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1128293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1128307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1128310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128329 */     // MIs[0] round
     /* 1128329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1128342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128364 */     // GIR_Coverage, 22692,
     /* 1128364 */     GIR_EraseRootFromParent_Done,
     /* 1128365 */   // Label 16524: @1128365
     /* 1128365 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1128445), // Rule ID 22693 //
     /* 1128370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1128373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1128387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1128390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128409 */     // MIs[0] round
     /* 1128409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1128422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128444 */     // GIR_Coverage, 22693,
     /* 1128444 */     GIR_EraseRootFromParent_Done,
     /* 1128445 */   // Label 16525: @1128445
     /* 1128445 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1128525), // Rule ID 22696 //
     /* 1128450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1128453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1128467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1128470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128489 */     // MIs[0] round
     /* 1128489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1128502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128524 */     // GIR_Coverage, 22696,
     /* 1128524 */     GIR_EraseRootFromParent_Done,
     /* 1128525 */   // Label 16526: @1128525
     /* 1128525 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1128605), // Rule ID 22697 //
     /* 1128530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1128533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1128547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1128550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128569 */     // MIs[0] round
     /* 1128569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1128582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128604 */     // GIR_Coverage, 22697,
     /* 1128604 */     GIR_EraseRootFromParent_Done,
     /* 1128605 */   // Label 16527: @1128605
     /* 1128605 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1128685), // Rule ID 22700 //
     /* 1128610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128649 */     // MIs[0] round
     /* 1128649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128659 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1128662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128684 */     // GIR_Coverage, 22700,
     /* 1128684 */     GIR_EraseRootFromParent_Done,
     /* 1128685 */   // Label 16528: @1128685
     /* 1128685 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1128765), // Rule ID 22701 //
     /* 1128690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128729 */     // MIs[0] round
     /* 1128729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128739 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1128742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128764 */     // GIR_Coverage, 22701,
     /* 1128764 */     GIR_EraseRootFromParent_Done,
     /* 1128765 */   // Label 16529: @1128765
     /* 1128765 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1128845), // Rule ID 22704 //
     /* 1128770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128809 */     // MIs[0] round
     /* 1128809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128819 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1128822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128844 */     // GIR_Coverage, 22704,
     /* 1128844 */     GIR_EraseRootFromParent_Done,
     /* 1128845 */   // Label 16530: @1128845
     /* 1128845 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1128925), // Rule ID 22705 //
     /* 1128850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128889 */     // MIs[0] round
     /* 1128889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1128902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128924 */     // GIR_Coverage, 22705,
     /* 1128924 */     GIR_EraseRootFromParent_Done,
     /* 1128925 */   // Label 16531: @1128925
     /* 1128925 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1129005), // Rule ID 22708 //
     /* 1128930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128969 */     // MIs[0] round
     /* 1128969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128979 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1128982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129004 */     // GIR_Coverage, 22708,
     /* 1129004 */     GIR_EraseRootFromParent_Done,
     /* 1129005 */   // Label 16532: @1129005
     /* 1129005 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1129085), // Rule ID 22709 //
     /* 1129010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1129013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1129027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129049 */     // MIs[0] round
     /* 1129049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10948:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1129062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129084 */     // GIR_Coverage, 22709,
     /* 1129084 */     GIR_EraseRootFromParent_Done,
     /* 1129085 */   // Label 16533: @1129085
     /* 1129085 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1129165), // Rule ID 22712 //
     /* 1129090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1129093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1129107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129129 */     // MIs[0] round
     /* 1129129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1129142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129164 */     // GIR_Coverage, 22712,
     /* 1129164 */     GIR_EraseRootFromParent_Done,
     /* 1129165 */   // Label 16534: @1129165
     /* 1129165 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1129245), // Rule ID 22713 //
     /* 1129170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1129173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1129187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129209 */     // MIs[0] round
     /* 1129209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1129222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129244 */     // GIR_Coverage, 22713,
     /* 1129244 */     GIR_EraseRootFromParent_Done,
     /* 1129245 */   // Label 16535: @1129245
     /* 1129245 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1129325), // Rule ID 22716 //
     /* 1129250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1129253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1129267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129289 */     // MIs[0] round
     /* 1129289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1129302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129324 */     // GIR_Coverage, 22716,
     /* 1129324 */     GIR_EraseRootFromParent_Done,
     /* 1129325 */   // Label 16536: @1129325
     /* 1129325 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1129405), // Rule ID 22717 //
     /* 1129330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1129333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1129347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129369 */     // MIs[0] round
     /* 1129369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129379 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1129382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129404 */     // GIR_Coverage, 22717,
     /* 1129404 */     GIR_EraseRootFromParent_Done,
     /* 1129405 */   // Label 16537: @1129405
     /* 1129405 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1129485), // Rule ID 22720 //
     /* 1129410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1129413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1129427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129449 */     // MIs[0] round
     /* 1129449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1129462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129484 */     // GIR_Coverage, 22720,
     /* 1129484 */     GIR_EraseRootFromParent_Done,
     /* 1129485 */   // Label 16538: @1129485
     /* 1129485 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1129565), // Rule ID 22721 //
     /* 1129490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1129493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1129507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129529 */     // MIs[0] round
     /* 1129529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10948:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1129542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129564 */     // GIR_Coverage, 22721,
     /* 1129564 */     GIR_EraseRootFromParent_Done,
     /* 1129565 */   // Label 16539: @1129565
     /* 1129565 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1129645), // Rule ID 22724 //
     /* 1129570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1129573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1129587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129609 */     // MIs[0] round
     /* 1129609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129619 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1129622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129644 */     // GIR_Coverage, 22724,
     /* 1129644 */     GIR_EraseRootFromParent_Done,
     /* 1129645 */   // Label 16540: @1129645
     /* 1129645 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1129725), // Rule ID 22725 //
     /* 1129650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1129653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1129667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129689 */     // MIs[0] round
     /* 1129689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129699 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1129702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129724 */     // GIR_Coverage, 22725,
     /* 1129724 */     GIR_EraseRootFromParent_Done,
     /* 1129725 */   // Label 16541: @1129725
     /* 1129725 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1129805), // Rule ID 22728 //
     /* 1129730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1129733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1129747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129769 */     // MIs[0] round
     /* 1129769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129779 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1129782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129804 */     // GIR_Coverage, 22728,
     /* 1129804 */     GIR_EraseRootFromParent_Done,
     /* 1129805 */   // Label 16542: @1129805
     /* 1129805 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1129885), // Rule ID 22729 //
     /* 1129810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1129813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1129827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129849 */     // MIs[0] round
     /* 1129849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1129862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129884 */     // GIR_Coverage, 22729,
     /* 1129884 */     GIR_EraseRootFromParent_Done,
     /* 1129885 */   // Label 16543: @1129885
     /* 1129885 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1129965), // Rule ID 22732 //
     /* 1129890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1129893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1129907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129929 */     // MIs[0] round
     /* 1129929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1129942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129964 */     // GIR_Coverage, 22732,
     /* 1129964 */     GIR_EraseRootFromParent_Done,
     /* 1129965 */   // Label 16544: @1129965
     /* 1129965 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1130045), // Rule ID 22733 //
     /* 1129970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1129973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1129987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130009 */     // MIs[0] round
     /* 1130009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10948:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1130022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130044 */     // GIR_Coverage, 22733,
     /* 1130044 */     GIR_EraseRootFromParent_Done,
     /* 1130045 */   // Label 16545: @1130045
     /* 1130045 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1130125), // Rule ID 22736 //
     /* 1130050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1130053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1130067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130089 */     // MIs[0] round
     /* 1130089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130099 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1130102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130124 */     // GIR_Coverage, 22736,
     /* 1130124 */     GIR_EraseRootFromParent_Done,
     /* 1130125 */   // Label 16546: @1130125
     /* 1130125 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1130205), // Rule ID 22737 //
     /* 1130130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1130133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1130147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130169 */     // MIs[0] round
     /* 1130169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130179 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1130182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130204 */     // GIR_Coverage, 22737,
     /* 1130204 */     GIR_EraseRootFromParent_Done,
     /* 1130205 */   // Label 16547: @1130205
     /* 1130205 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1130285), // Rule ID 22740 //
     /* 1130210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1130213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1130227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130249 */     // MIs[0] round
     /* 1130249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1130262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130284 */     // GIR_Coverage, 22740,
     /* 1130284 */     GIR_EraseRootFromParent_Done,
     /* 1130285 */   // Label 16548: @1130285
     /* 1130285 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1130365), // Rule ID 22741 //
     /* 1130290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1130293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1130307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130329 */     // MIs[0] round
     /* 1130329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130339 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1130342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130364 */     // GIR_Coverage, 22741,
     /* 1130364 */     GIR_EraseRootFromParent_Done,
     /* 1130365 */   // Label 16549: @1130365
     /* 1130365 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1130445), // Rule ID 22744 //
     /* 1130370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1130373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1130387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130409 */     // MIs[0] round
     /* 1130409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1130422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130444 */     // GIR_Coverage, 22744,
     /* 1130444 */     GIR_EraseRootFromParent_Done,
     /* 1130445 */   // Label 16550: @1130445
     /* 1130445 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1130525), // Rule ID 22745 //
     /* 1130450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1130453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1130467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130489 */     // MIs[0] round
     /* 1130489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1130502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130524 */     // GIR_Coverage, 22745,
     /* 1130524 */     GIR_EraseRootFromParent_Done,
     /* 1130525 */   // Label 16551: @1130525
     /* 1130525 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1130605), // Rule ID 22748 //
     /* 1130530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1130533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130569 */     // MIs[0] round
     /* 1130569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130579 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1130582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130604 */     // GIR_Coverage, 22748,
     /* 1130604 */     GIR_EraseRootFromParent_Done,
     /* 1130605 */   // Label 16552: @1130605
     /* 1130605 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1130685), // Rule ID 22749 //
     /* 1130610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1130613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130649 */     // MIs[0] round
     /* 1130649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130659 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1130662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130684 */     // GIR_Coverage, 22749,
     /* 1130684 */     GIR_EraseRootFromParent_Done,
     /* 1130685 */   // Label 16553: @1130685
     /* 1130685 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1130765), // Rule ID 22752 //
     /* 1130690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1130693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130729 */     // MIs[0] round
     /* 1130729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1130742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130764 */     // GIR_Coverage, 22752,
     /* 1130764 */     GIR_EraseRootFromParent_Done,
     /* 1130765 */   // Label 16554: @1130765
     /* 1130765 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1130845), // Rule ID 22753 //
     /* 1130770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1130773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130809 */     // MIs[0] round
     /* 1130809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1130822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130844 */     // GIR_Coverage, 22753,
     /* 1130844 */     GIR_EraseRootFromParent_Done,
     /* 1130845 */   // Label 16555: @1130845
     /* 1130845 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1130925), // Rule ID 22756 //
     /* 1130850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1130853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130889 */     // MIs[0] round
     /* 1130889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1130902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130924 */     // GIR_Coverage, 22756,
     /* 1130924 */     GIR_EraseRootFromParent_Done,
     /* 1130925 */   // Label 16556: @1130925
     /* 1130925 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1131005), // Rule ID 22757 //
     /* 1130930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1130933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1130938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130969 */     // MIs[0] round
     /* 1130969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130979 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1130982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131004 */     // GIR_Coverage, 22757,
     /* 1131004 */     GIR_EraseRootFromParent_Done,
     /* 1131005 */   // Label 16557: @1131005
     /* 1131005 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1131085), // Rule ID 22760 //
     /* 1131010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1131013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131049 */     // MIs[0] round
     /* 1131049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1131062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131084 */     // GIR_Coverage, 22760,
     /* 1131084 */     GIR_EraseRootFromParent_Done,
     /* 1131085 */   // Label 16558: @1131085
     /* 1131085 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1131165), // Rule ID 22761 //
     /* 1131090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1131093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131129 */     // MIs[0] round
     /* 1131129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131139 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1131142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131164 */     // GIR_Coverage, 22761,
     /* 1131164 */     GIR_EraseRootFromParent_Done,
     /* 1131165 */   // Label 16559: @1131165
     /* 1131165 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1131245), // Rule ID 22764 //
     /* 1131170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1131173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131209 */     // MIs[0] round
     /* 1131209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131219 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1131222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131244 */     // GIR_Coverage, 22764,
     /* 1131244 */     GIR_EraseRootFromParent_Done,
     /* 1131245 */   // Label 16560: @1131245
     /* 1131245 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1131325), // Rule ID 22765 //
     /* 1131250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1131253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131289 */     // MIs[0] round
     /* 1131289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1131302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131324 */     // GIR_Coverage, 22765,
     /* 1131324 */     GIR_EraseRootFromParent_Done,
     /* 1131325 */   // Label 16561: @1131325
     /* 1131325 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1131405), // Rule ID 22768 //
     /* 1131330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1131333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131369 */     // MIs[0] round
     /* 1131369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131379 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1131382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131404 */     // GIR_Coverage, 22768,
     /* 1131404 */     GIR_EraseRootFromParent_Done,
     /* 1131405 */   // Label 16562: @1131405
     /* 1131405 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1131485), // Rule ID 22769 //
     /* 1131410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1131413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1131421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1131424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131449 */     // MIs[0] round
     /* 1131449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131459 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10950:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1131462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131484 */     // GIR_Coverage, 22769,
     /* 1131484 */     GIR_EraseRootFromParent_Done,
     /* 1131485 */   // Label 16563: @1131485
     /* 1131485 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1131565), // Rule ID 22772 //
     /* 1131490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1131493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131529 */     // MIs[0] round
     /* 1131529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1131542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131564 */     // GIR_Coverage, 22772,
     /* 1131564 */     GIR_EraseRootFromParent_Done,
     /* 1131565 */   // Label 16564: @1131565
     /* 1131565 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1131645), // Rule ID 22773 //
     /* 1131570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1131573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131609 */     // MIs[0] round
     /* 1131609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1131622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131644 */     // GIR_Coverage, 22773,
     /* 1131644 */     GIR_EraseRootFromParent_Done,
     /* 1131645 */   // Label 16565: @1131645
     /* 1131645 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1131725), // Rule ID 22776 //
     /* 1131650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1131653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131689 */     // MIs[0] round
     /* 1131689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1131702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131724 */     // GIR_Coverage, 22776,
     /* 1131724 */     GIR_EraseRootFromParent_Done,
     /* 1131725 */   // Label 16566: @1131725
     /* 1131725 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1131805), // Rule ID 22777 //
     /* 1131730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1131733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131769 */     // MIs[0] round
     /* 1131769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131779 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1131782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131804 */     // GIR_Coverage, 22777,
     /* 1131804 */     GIR_EraseRootFromParent_Done,
     /* 1131805 */   // Label 16567: @1131805
     /* 1131805 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1131885), // Rule ID 22780 //
     /* 1131810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1131813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131849 */     // MIs[0] round
     /* 1131849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131859 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1131862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131884 */     // GIR_Coverage, 22780,
     /* 1131884 */     GIR_EraseRootFromParent_Done,
     /* 1131885 */   // Label 16568: @1131885
     /* 1131885 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1131965), // Rule ID 22781 //
     /* 1131890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1131893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1131901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1131910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131929 */     // MIs[0] round
     /* 1131929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131939 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10950:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1131942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131964 */     // GIR_Coverage, 22781,
     /* 1131964 */     GIR_EraseRootFromParent_Done,
     /* 1131965 */   // Label 16569: @1131965
     /* 1131965 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1132045), // Rule ID 22784 //
     /* 1131970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1131973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1131978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1131981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1131984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1131990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132009 */     // MIs[0] round
     /* 1132009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1132022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132044 */     // GIR_Coverage, 22784,
     /* 1132044 */     GIR_EraseRootFromParent_Done,
     /* 1132045 */   // Label 16570: @1132045
     /* 1132045 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1132125), // Rule ID 22785 //
     /* 1132050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1132053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1132058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1132067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132089 */     // MIs[0] round
     /* 1132089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1132102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132124 */     // GIR_Coverage, 22785,
     /* 1132124 */     GIR_EraseRootFromParent_Done,
     /* 1132125 */   // Label 16571: @1132125
     /* 1132125 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1132205), // Rule ID 22788 //
     /* 1132130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1132133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1132138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132169 */     // MIs[0] round
     /* 1132169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1132182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132204 */     // GIR_Coverage, 22788,
     /* 1132204 */     GIR_EraseRootFromParent_Done,
     /* 1132205 */   // Label 16572: @1132205
     /* 1132205 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1132285), // Rule ID 22789 //
     /* 1132210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1132213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1132218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132249 */     // MIs[0] round
     /* 1132249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132259 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1132262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132284 */     // GIR_Coverage, 22789,
     /* 1132284 */     GIR_EraseRootFromParent_Done,
     /* 1132285 */   // Label 16573: @1132285
     /* 1132285 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1132365), // Rule ID 22792 //
     /* 1132290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1132293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1132298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132329 */     // MIs[0] round
     /* 1132329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132339 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1132342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132364 */     // GIR_Coverage, 22792,
     /* 1132364 */     GIR_EraseRootFromParent_Done,
     /* 1132365 */   // Label 16574: @1132365
     /* 1132365 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1132445), // Rule ID 22793 //
     /* 1132370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1132373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1132378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132409 */     // MIs[0] round
     /* 1132409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132419 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10950:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1132422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132444 */     // GIR_Coverage, 22793,
     /* 1132444 */     GIR_EraseRootFromParent_Done,
     /* 1132445 */   // Label 16575: @1132445
     /* 1132445 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1132525), // Rule ID 22916 //
     /* 1132450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1132453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132489 */     // MIs[0] round
     /* 1132489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1132502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132524 */     // GIR_Coverage, 22916,
     /* 1132524 */     GIR_EraseRootFromParent_Done,
     /* 1132525 */   // Label 16576: @1132525
     /* 1132525 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1132605), // Rule ID 22917 //
     /* 1132530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1132533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132569 */     // MIs[0] round
     /* 1132569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1132582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132604 */     // GIR_Coverage, 22917,
     /* 1132604 */     GIR_EraseRootFromParent_Done,
     /* 1132605 */   // Label 16577: @1132605
     /* 1132605 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1132685), // Rule ID 22920 //
     /* 1132610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1132613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132649 */     // MIs[0] round
     /* 1132649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1132662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132684 */     // GIR_Coverage, 22920,
     /* 1132684 */     GIR_EraseRootFromParent_Done,
     /* 1132685 */   // Label 16578: @1132685
     /* 1132685 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1132765), // Rule ID 22921 //
     /* 1132690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1132693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132729 */     // MIs[0] round
     /* 1132729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1132742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132764 */     // GIR_Coverage, 22921,
     /* 1132764 */     GIR_EraseRootFromParent_Done,
     /* 1132765 */   // Label 16579: @1132765
     /* 1132765 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1132845), // Rule ID 22924 //
     /* 1132770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1132773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132809 */     // MIs[0] round
     /* 1132809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132819 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1132822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132844 */     // GIR_Coverage, 22924,
     /* 1132844 */     GIR_EraseRootFromParent_Done,
     /* 1132845 */   // Label 16580: @1132845
     /* 1132845 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1132925), // Rule ID 22925 //
     /* 1132850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1132853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132889 */     // MIs[0] round
     /* 1132889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1132902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132924 */     // GIR_Coverage, 22925,
     /* 1132924 */     GIR_EraseRootFromParent_Done,
     /* 1132925 */   // Label 16581: @1132925
     /* 1132925 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1133005), // Rule ID 22928 //
     /* 1132930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1132933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1132938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1132947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132969 */     // MIs[0] round
     /* 1132969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132979 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1132982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133004 */     // GIR_Coverage, 22928,
     /* 1133004 */     GIR_EraseRootFromParent_Done,
     /* 1133005 */   // Label 16582: @1133005
     /* 1133005 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1133085), // Rule ID 22929 //
     /* 1133010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1133013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133049 */     // MIs[0] round
     /* 1133049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133059 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1133062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133084 */     // GIR_Coverage, 22929,
     /* 1133084 */     GIR_EraseRootFromParent_Done,
     /* 1133085 */   // Label 16583: @1133085
     /* 1133085 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1133165), // Rule ID 22932 //
     /* 1133090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1133093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133129 */     // MIs[0] round
     /* 1133129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133139 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1133142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133164 */     // GIR_Coverage, 22932,
     /* 1133164 */     GIR_EraseRootFromParent_Done,
     /* 1133165 */   // Label 16584: @1133165
     /* 1133165 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1133245), // Rule ID 22933 //
     /* 1133170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1133173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133209 */     // MIs[0] round
     /* 1133209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133219 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1133222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133244 */     // GIR_Coverage, 22933,
     /* 1133244 */     GIR_EraseRootFromParent_Done,
     /* 1133245 */   // Label 16585: @1133245
     /* 1133245 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1133325), // Rule ID 22936 //
     /* 1133250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1133253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1133267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133289 */     // MIs[0] round
     /* 1133289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1133302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133324 */     // GIR_Coverage, 22936,
     /* 1133324 */     GIR_EraseRootFromParent_Done,
     /* 1133325 */   // Label 16586: @1133325
     /* 1133325 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1133405), // Rule ID 22937 //
     /* 1133330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1133333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1133347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133369 */     // MIs[0] round
     /* 1133369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133379 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1133382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133404 */     // GIR_Coverage, 22937,
     /* 1133404 */     GIR_EraseRootFromParent_Done,
     /* 1133405 */   // Label 16587: @1133405
     /* 1133405 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1133485), // Rule ID 22940 //
     /* 1133410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1133413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1133427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133449 */     // MIs[0] round
     /* 1133449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1133462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133484 */     // GIR_Coverage, 22940,
     /* 1133484 */     GIR_EraseRootFromParent_Done,
     /* 1133485 */   // Label 16588: @1133485
     /* 1133485 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1133565), // Rule ID 22941 //
     /* 1133490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1133493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1133507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133529 */     // MIs[0] round
     /* 1133529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1133542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133564 */     // GIR_Coverage, 22941,
     /* 1133564 */     GIR_EraseRootFromParent_Done,
     /* 1133565 */   // Label 16589: @1133565
     /* 1133565 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1133645), // Rule ID 22944 //
     /* 1133570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1133573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1133587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133609 */     // MIs[0] round
     /* 1133609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1133622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133644 */     // GIR_Coverage, 22944,
     /* 1133644 */     GIR_EraseRootFromParent_Done,
     /* 1133645 */   // Label 16590: @1133645
     /* 1133645 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1133725), // Rule ID 22945 //
     /* 1133650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1133653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1133667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133689 */     // MIs[0] round
     /* 1133689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11004:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1133702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133724 */     // GIR_Coverage, 22945,
     /* 1133724 */     GIR_EraseRootFromParent_Done,
     /* 1133725 */   // Label 16591: @1133725
     /* 1133725 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1133805), // Rule ID 22948 //
     /* 1133730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1133733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1133747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133769 */     // MIs[0] round
     /* 1133769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133779 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1133782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133804 */     // GIR_Coverage, 22948,
     /* 1133804 */     GIR_EraseRootFromParent_Done,
     /* 1133805 */   // Label 16592: @1133805
     /* 1133805 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1133885), // Rule ID 22949 //
     /* 1133810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1133813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1133827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133849 */     // MIs[0] round
     /* 1133849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1133862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133884 */     // GIR_Coverage, 22949,
     /* 1133884 */     GIR_EraseRootFromParent_Done,
     /* 1133885 */   // Label 16593: @1133885
     /* 1133885 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1133965), // Rule ID 22952 //
     /* 1133890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1133893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1133907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133929 */     // MIs[0] round
     /* 1133929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1133942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1133946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133964 */     // GIR_Coverage, 22952,
     /* 1133964 */     GIR_EraseRootFromParent_Done,
     /* 1133965 */   // Label 16594: @1133965
     /* 1133965 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1134045), // Rule ID 22953 //
     /* 1133970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1133973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1133978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1133987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134009 */     // MIs[0] round
     /* 1134009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1134022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134044 */     // GIR_Coverage, 22953,
     /* 1134044 */     GIR_EraseRootFromParent_Done,
     /* 1134045 */   // Label 16595: @1134045
     /* 1134045 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1134125), // Rule ID 22956 //
     /* 1134050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1134053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1134058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1134067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134089 */     // MIs[0] round
     /* 1134089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1134102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134124 */     // GIR_Coverage, 22956,
     /* 1134124 */     GIR_EraseRootFromParent_Done,
     /* 1134125 */   // Label 16596: @1134125
     /* 1134125 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1134205), // Rule ID 22957 //
     /* 1134130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1134133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1134138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1134147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134169 */     // MIs[0] round
     /* 1134169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11004:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1134182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134204 */     // GIR_Coverage, 22957,
     /* 1134204 */     GIR_EraseRootFromParent_Done,
     /* 1134205 */   // Label 16597: @1134205
     /* 1134205 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1134285), // Rule ID 22960 //
     /* 1134210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1134213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1134227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134249 */     // MIs[0] round
     /* 1134249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134259 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1134262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134284 */     // GIR_Coverage, 22960,
     /* 1134284 */     GIR_EraseRootFromParent_Done,
     /* 1134285 */   // Label 16598: @1134285
     /* 1134285 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1134365), // Rule ID 22961 //
     /* 1134290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1134293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1134307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134329 */     // MIs[0] round
     /* 1134329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1134342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134364 */     // GIR_Coverage, 22961,
     /* 1134364 */     GIR_EraseRootFromParent_Done,
     /* 1134365 */   // Label 16599: @1134365
     /* 1134365 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1134445), // Rule ID 22964 //
     /* 1134370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1134373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1134387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134409 */     // MIs[0] round
     /* 1134409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1134422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134444 */     // GIR_Coverage, 22964,
     /* 1134444 */     GIR_EraseRootFromParent_Done,
     /* 1134445 */   // Label 16600: @1134445
     /* 1134445 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1134525), // Rule ID 22965 //
     /* 1134450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1134453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1134467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134489 */     // MIs[0] round
     /* 1134489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1134502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134524 */     // GIR_Coverage, 22965,
     /* 1134524 */     GIR_EraseRootFromParent_Done,
     /* 1134525 */   // Label 16601: @1134525
     /* 1134525 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1134605), // Rule ID 22968 //
     /* 1134530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1134533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1134547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134569 */     // MIs[0] round
     /* 1134569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1134582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134604 */     // GIR_Coverage, 22968,
     /* 1134604 */     GIR_EraseRootFromParent_Done,
     /* 1134605 */   // Label 16602: @1134605
     /* 1134605 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1134685), // Rule ID 22969 //
     /* 1134610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1134613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1134627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134649 */     // MIs[0] round
     /* 1134649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134659 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1134662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134684 */     // GIR_Coverage, 22969,
     /* 1134684 */     GIR_EraseRootFromParent_Done,
     /* 1134685 */   // Label 16603: @1134685
     /* 1134685 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1134765), // Rule ID 22972 //
     /* 1134690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1134693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1134707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134729 */     // MIs[0] round
     /* 1134729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1134742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134764 */     // GIR_Coverage, 22972,
     /* 1134764 */     GIR_EraseRootFromParent_Done,
     /* 1134765 */   // Label 16604: @1134765
     /* 1134765 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1134845), // Rule ID 22973 //
     /* 1134770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1134773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1134781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1134784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1134787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1134790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134809 */     // MIs[0] round
     /* 1134809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1134822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134844 */     // GIR_Coverage, 22973,
     /* 1134844 */     GIR_EraseRootFromParent_Done,
     /* 1134845 */   // Label 16605: @1134845
     /* 1134845 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1134925), // Rule ID 22976 //
     /* 1134850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1134853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1134867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134889 */     // MIs[0] round
     /* 1134889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1134902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134924 */     // GIR_Coverage, 22976,
     /* 1134924 */     GIR_EraseRootFromParent_Done,
     /* 1134925 */   // Label 16606: @1134925
     /* 1134925 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1135005), // Rule ID 22977 //
     /* 1134930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1134933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1134938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1134947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134969 */     // MIs[0] round
     /* 1134969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134979 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1134982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1134986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135004 */     // GIR_Coverage, 22977,
     /* 1135004 */     GIR_EraseRootFromParent_Done,
     /* 1135005 */   // Label 16607: @1135005
     /* 1135005 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1135085), // Rule ID 22980 //
     /* 1135010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1135013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1135027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135049 */     // MIs[0] round
     /* 1135049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135059 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1135062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135084 */     // GIR_Coverage, 22980,
     /* 1135084 */     GIR_EraseRootFromParent_Done,
     /* 1135085 */   // Label 16608: @1135085
     /* 1135085 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1135165), // Rule ID 22981 //
     /* 1135090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1135093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1135107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135129 */     // MIs[0] round
     /* 1135129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1135142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135164 */     // GIR_Coverage, 22981,
     /* 1135164 */     GIR_EraseRootFromParent_Done,
     /* 1135165 */   // Label 16609: @1135165
     /* 1135165 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1135245), // Rule ID 22984 //
     /* 1135170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1135173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1135187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135209 */     // MIs[0] round
     /* 1135209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1135222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135244 */     // GIR_Coverage, 22984,
     /* 1135244 */     GIR_EraseRootFromParent_Done,
     /* 1135245 */   // Label 16610: @1135245
     /* 1135245 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1135325), // Rule ID 22985 //
     /* 1135250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1135253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1135267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135289 */     // MIs[0] round
     /* 1135289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1135302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135324 */     // GIR_Coverage, 22985,
     /* 1135324 */     GIR_EraseRootFromParent_Done,
     /* 1135325 */   // Label 16611: @1135325
     /* 1135325 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1135405), // Rule ID 22988 //
     /* 1135330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1135333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135369 */     // MIs[0] round
     /* 1135369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135379 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1135382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135404 */     // GIR_Coverage, 22988,
     /* 1135404 */     GIR_EraseRootFromParent_Done,
     /* 1135405 */   // Label 16612: @1135405
     /* 1135405 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1135485), // Rule ID 22989 //
     /* 1135410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1135413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1135430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135449 */     // MIs[0] round
     /* 1135449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11002:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1135462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135484 */     // GIR_Coverage, 22989,
     /* 1135484 */     GIR_EraseRootFromParent_Done,
     /* 1135485 */   // Label 16613: @1135485
     /* 1135485 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1135565), // Rule ID 22992 //
     /* 1135490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1135493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135529 */     // MIs[0] round
     /* 1135529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135539 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1135542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135564 */     // GIR_Coverage, 22992,
     /* 1135564 */     GIR_EraseRootFromParent_Done,
     /* 1135565 */   // Label 16614: @1135565
     /* 1135565 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1135645), // Rule ID 22993 //
     /* 1135570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1135573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135609 */     // MIs[0] round
     /* 1135609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135619 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1135622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135644 */     // GIR_Coverage, 22993,
     /* 1135644 */     GIR_EraseRootFromParent_Done,
     /* 1135645 */   // Label 16615: @1135645
     /* 1135645 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1135725), // Rule ID 22996 //
     /* 1135650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1135653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135689 */     // MIs[0] round
     /* 1135689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135699 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1135702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135724 */     // GIR_Coverage, 22996,
     /* 1135724 */     GIR_EraseRootFromParent_Done,
     /* 1135725 */   // Label 16616: @1135725
     /* 1135725 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1135805), // Rule ID 22997 //
     /* 1135730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1135733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135769 */     // MIs[0] round
     /* 1135769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135779 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1135782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135804 */     // GIR_Coverage, 22997,
     /* 1135804 */     GIR_EraseRootFromParent_Done,
     /* 1135805 */   // Label 16617: @1135805
     /* 1135805 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1135885), // Rule ID 23000 //
     /* 1135810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1135813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135849 */     // MIs[0] round
     /* 1135849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135859 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1135862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135884 */     // GIR_Coverage, 23000,
     /* 1135884 */     GIR_EraseRootFromParent_Done,
     /* 1135885 */   // Label 16618: @1135885
     /* 1135885 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1135965), // Rule ID 23001 //
     /* 1135890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1135893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1135898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1135910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135929 */     // MIs[0] round
     /* 1135929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11002:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1135942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1135946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135964 */     // GIR_Coverage, 23001,
     /* 1135964 */     GIR_EraseRootFromParent_Done,
     /* 1135965 */   // Label 16619: @1135965
     /* 1135965 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1136045), // Rule ID 63665 //
     /* 1135970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1135973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1135978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1135987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136009 */     // MIs[0] round
     /* 1136009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1136022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136044 */     // GIR_Coverage, 63665,
     /* 1136044 */     GIR_EraseRootFromParent_Done,
     /* 1136045 */   // Label 16620: @1136045
     /* 1136045 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1136125), // Rule ID 63666 //
     /* 1136050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136089 */     // MIs[0] round
     /* 1136089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1136102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136124 */     // GIR_Coverage, 63666,
     /* 1136124 */     GIR_EraseRootFromParent_Done,
     /* 1136125 */   // Label 16621: @1136125
     /* 1136125 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1136205), // Rule ID 63669 //
     /* 1136130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136169 */     // MIs[0] round
     /* 1136169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136179 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1136182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136204 */     // GIR_Coverage, 63669,
     /* 1136204 */     GIR_EraseRootFromParent_Done,
     /* 1136205 */   // Label 16622: @1136205
     /* 1136205 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1136285), // Rule ID 63670 //
     /* 1136210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136249 */     // MIs[0] round
     /* 1136249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136259 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1136262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136284 */     // GIR_Coverage, 63670,
     /* 1136284 */     GIR_EraseRootFromParent_Done,
     /* 1136285 */   // Label 16623: @1136285
     /* 1136285 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1136365), // Rule ID 63673 //
     /* 1136290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1136307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136329 */     // MIs[0] round
     /* 1136329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136339 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1136342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136364 */     // GIR_Coverage, 63673,
     /* 1136364 */     GIR_EraseRootFromParent_Done,
     /* 1136365 */   // Label 16624: @1136365
     /* 1136365 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1136445), // Rule ID 63674 //
     /* 1136370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1136387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136409 */     // MIs[0] round
     /* 1136409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1136422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136444 */     // GIR_Coverage, 63674,
     /* 1136444 */     GIR_EraseRootFromParent_Done,
     /* 1136445 */   // Label 16625: @1136445
     /* 1136445 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1136525), // Rule ID 63677 //
     /* 1136450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1136467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136489 */     // MIs[0] round
     /* 1136489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1136502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136524 */     // GIR_Coverage, 63677,
     /* 1136524 */     GIR_EraseRootFromParent_Done,
     /* 1136525 */   // Label 16626: @1136525
     /* 1136525 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1136605), // Rule ID 63678 //
     /* 1136530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1136547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136569 */     // MIs[0] round
     /* 1136569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136579 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1136582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136604 */     // GIR_Coverage, 63678,
     /* 1136604 */     GIR_EraseRootFromParent_Done,
     /* 1136605 */   // Label 16627: @1136605
     /* 1136605 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1136685), // Rule ID 63681 //
     /* 1136610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1136621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1136624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1136627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136649 */     // MIs[0] round
     /* 1136649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1136662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136684 */     // GIR_Coverage, 63681,
     /* 1136684 */     GIR_EraseRootFromParent_Done,
     /* 1136685 */   // Label 16628: @1136685
     /* 1136685 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1136765), // Rule ID 63682 //
     /* 1136690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1136698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1136701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1136704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1136707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136729 */     // MIs[0] round
     /* 1136729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1136742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136764 */     // GIR_Coverage, 63682,
     /* 1136764 */     GIR_EraseRootFromParent_Done,
     /* 1136765 */   // Label 16629: @1136765
     /* 1136765 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1136845), // Rule ID 63685 //
     /* 1136770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1136778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136809 */     // MIs[0] round
     /* 1136809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1136822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136844 */     // GIR_Coverage, 63685,
     /* 1136844 */     GIR_EraseRootFromParent_Done,
     /* 1136845 */   // Label 16630: @1136845
     /* 1136845 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1136925), // Rule ID 63686 //
     /* 1136850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1136853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1136858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136889 */     // MIs[0] round
     /* 1136889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136899 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1136902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136924 */     // GIR_Coverage, 63686,
     /* 1136924 */     GIR_EraseRootFromParent_Done,
     /* 1136925 */   // Label 16631: @1136925
     /* 1136925 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1137005), // Rule ID 63689 //
     /* 1136930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1136933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1136938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1136969 */     // MIs[0] round
     /* 1136969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136979 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1136982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137004 */     // GIR_Coverage, 63689,
     /* 1137004 */     GIR_EraseRootFromParent_Done,
     /* 1137005 */   // Label 16632: @1137005
     /* 1137005 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1137085), // Rule ID 63690 //
     /* 1137010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1137013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1137021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1137024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137049 */     // MIs[0] round
     /* 1137049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137059 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1137062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137084 */     // GIR_Coverage, 63690,
     /* 1137084 */     GIR_EraseRootFromParent_Done,
     /* 1137085 */   // Label 16633: @1137085
     /* 1137085 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1137165), // Rule ID 63693 //
     /* 1137090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1137093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1137101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1137104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1137107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137129 */     // MIs[0] round
     /* 1137129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1137142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137164 */     // GIR_Coverage, 63693,
     /* 1137164 */     GIR_EraseRootFromParent_Done,
     /* 1137165 */   // Label 16634: @1137165
     /* 1137165 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1137245), // Rule ID 63694 //
     /* 1137170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1137173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1137181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1137184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1137187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137209 */     // MIs[0] round
     /* 1137209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1137222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137244 */     // GIR_Coverage, 63694,
     /* 1137244 */     GIR_EraseRootFromParent_Done,
     /* 1137245 */   // Label 16635: @1137245
     /* 1137245 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1137325), // Rule ID 63697 //
     /* 1137250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1137253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1137267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137289 */     // MIs[0] round
     /* 1137289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1137302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137324 */     // GIR_Coverage, 63697,
     /* 1137324 */     GIR_EraseRootFromParent_Done,
     /* 1137325 */   // Label 16636: @1137325
     /* 1137325 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1137405), // Rule ID 63698 //
     /* 1137330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1137333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1137347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137369 */     // MIs[0] round
     /* 1137369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137379 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1137382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137404 */     // GIR_Coverage, 63698,
     /* 1137404 */     GIR_EraseRootFromParent_Done,
     /* 1137405 */   // Label 16637: @1137405
     /* 1137405 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1137485), // Rule ID 63701 //
     /* 1137410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1137413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1137427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137449 */     // MIs[0] round
     /* 1137449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1137462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137484 */     // GIR_Coverage, 63701,
     /* 1137484 */     GIR_EraseRootFromParent_Done,
     /* 1137485 */   // Label 16638: @1137485
     /* 1137485 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1137565), // Rule ID 63702 //
     /* 1137490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1137493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1137498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1137507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1137529 */     // MIs[0] round
     /* 1137529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1137542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137564 */     // GIR_Coverage, 63702,
     /* 1137564 */     GIR_EraseRootFromParent_Done,
     /* 1137565 */   // Label 16639: @1137565
     /* 1137565 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1137649), // Rule ID 2576 //
     /* 1137570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1137578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1137581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1137584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1137587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1137590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1137593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1137616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1137623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1137626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1137636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1137647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137648 */     // GIR_Coverage, 2576,
     /* 1137648 */     GIR_EraseRootFromParent_Done,
     /* 1137649 */   // Label 16640: @1137649
     /* 1137649 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1137733), // Rule ID 2577 //
     /* 1137654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1137662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1137665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1137668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1137671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1137674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1137677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1137700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1137707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1137710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1137720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1137731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137732 */     // GIR_Coverage, 2577,
     /* 1137732 */     GIR_EraseRootFromParent_Done,
     /* 1137733 */   // Label 16641: @1137733
     /* 1137733 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1137817), // Rule ID 2588 //
     /* 1137738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1137746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1137749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1137752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1137755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1137758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1137761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1137784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137791 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1137791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1137794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1137800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1137802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1137804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1137815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137816 */     // GIR_Coverage, 2588,
     /* 1137816 */     GIR_EraseRootFromParent_Done,
     /* 1137817 */   // Label 16642: @1137817
     /* 1137817 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1137901), // Rule ID 2589 //
     /* 1137822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1137830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1137833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1137836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1137839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1137842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1137845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1137868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1137875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1137878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1137884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1137886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1137888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1137899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137900 */     // GIR_Coverage, 2589,
     /* 1137900 */     GIR_EraseRootFromParent_Done,
     /* 1137901 */   // Label 16643: @1137901
     /* 1137901 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1137982), // Rule ID 2590 //
     /* 1137906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1137914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1137917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1137920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1137923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1137926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1137929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1137936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1137952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1137959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1137962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1137972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137981 */     // GIR_Coverage, 2590,
     /* 1137981 */     GIR_EraseRootFromParent_Done,
     /* 1137982 */   // Label 16644: @1137982
     /* 1137982 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1138063), // Rule ID 2591 //
     /* 1137987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1137995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1137998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1138001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1138007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138040 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1138040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1138043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138062 */     // GIR_Coverage, 2591,
     /* 1138062 */     GIR_EraseRootFromParent_Done,
     /* 1138063 */   // Label 16645: @1138063
     /* 1138063 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1138147), // Rule ID 2640 //
     /* 1138068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1138076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1138079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1138082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1138088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138121 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1138124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1138128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138146 */     // GIR_Coverage, 2640,
     /* 1138146 */     GIR_EraseRootFromParent_Done,
     /* 1138147 */   // Label 16646: @1138147
     /* 1138147 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1138231), // Rule ID 2641 //
     /* 1138152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1138160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1138163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1138166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1138172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138205 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1138208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1138212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138230 */     // GIR_Coverage, 2641,
     /* 1138230 */     GIR_EraseRootFromParent_Done,
     /* 1138231 */   // Label 16647: @1138231
     /* 1138231 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1138312), // Rule ID 4968 //
     /* 1138236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1138247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1138250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1138253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1138256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1138259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1138289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1138292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138311 */     // GIR_Coverage, 4968,
     /* 1138311 */     GIR_EraseRootFromParent_Done,
     /* 1138312 */   // Label 16648: @1138312
     /* 1138312 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1138393), // Rule ID 4969 //
     /* 1138317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1138328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1138331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1138334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1138337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1138340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138370 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1138370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1138373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138392 */     // GIR_Coverage, 4969,
     /* 1138392 */     GIR_EraseRootFromParent_Done,
     /* 1138393 */   // Label 16649: @1138393
     /* 1138393 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1138474), // Rule ID 4970 //
     /* 1138398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1138409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1138412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1138415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1138418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1138421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138451 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1138451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1138454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138473 */     // GIR_Coverage, 4970,
     /* 1138473 */     GIR_EraseRootFromParent_Done,
     /* 1138474 */   // Label 16650: @1138474
     /* 1138474 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1138555), // Rule ID 4971 //
     /* 1138479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1138490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1138493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1138496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1138499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1138502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1138532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1138535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138554 */     // GIR_Coverage, 4971,
     /* 1138554 */     GIR_EraseRootFromParent_Done,
     /* 1138555 */   // Label 16651: @1138555
     /* 1138555 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1138636), // Rule ID 4972 //
     /* 1138560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1138571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1138574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1138577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1138580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138613 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1138613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1138616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138635 */     // GIR_Coverage, 4972,
     /* 1138635 */     GIR_EraseRootFromParent_Done,
     /* 1138636 */   // Label 16652: @1138636
     /* 1138636 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1138717), // Rule ID 4973 //
     /* 1138641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1138652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1138655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1138658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1138661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1138694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1138697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138716 */     // GIR_Coverage, 4973,
     /* 1138716 */     GIR_EraseRootFromParent_Done,
     /* 1138717 */   // Label 16653: @1138717
     /* 1138717 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1138798), // Rule ID 4974 //
     /* 1138722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1138733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1138736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1138739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1138742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1138745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138775 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1138775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1138778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138797 */     // GIR_Coverage, 4974,
     /* 1138797 */     GIR_EraseRootFromParent_Done,
     /* 1138798 */   // Label 16654: @1138798
     /* 1138798 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1138879), // Rule ID 4975 //
     /* 1138803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1138814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1138817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1138820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1138823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1138826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1138856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1138859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138878 */     // GIR_Coverage, 4975,
     /* 1138878 */     GIR_EraseRootFromParent_Done,
     /* 1138879 */   // Label 16655: @1138879
     /* 1138879 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1138960), // Rule ID 4976 //
     /* 1138884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1138895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1138898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1138901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1138904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1138930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1138937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1138940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1138950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138959 */     // GIR_Coverage, 4976,
     /* 1138959 */     GIR_EraseRootFromParent_Done,
     /* 1138960 */   // Label 16656: @1138960
     /* 1138960 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1139041), // Rule ID 4977 //
     /* 1138965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1138973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1138976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1138979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1138982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1138985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1138988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1138995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1139018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1139021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139040 */     // GIR_Coverage, 4977,
     /* 1139040 */     GIR_EraseRootFromParent_Done,
     /* 1139041 */   // Label 16657: @1139041
     /* 1139041 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1139122), // Rule ID 4978 //
     /* 1139046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1139066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1139069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1139099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139121 */     // GIR_Coverage, 4978,
     /* 1139121 */     GIR_EraseRootFromParent_Done,
     /* 1139122 */   // Label 16658: @1139122
     /* 1139122 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1139203), // Rule ID 4979 //
     /* 1139127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1139147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1139150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139180 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1139180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139202 */     // GIR_Coverage, 4979,
     /* 1139202 */     GIR_EraseRootFromParent_Done,
     /* 1139203 */   // Label 16659: @1139203
     /* 1139203 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1139284), // Rule ID 4980 //
     /* 1139208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1139219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1139222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1139225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1139228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1139231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1139261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139283 */     // GIR_Coverage, 4980,
     /* 1139283 */     GIR_EraseRootFromParent_Done,
     /* 1139284 */   // Label 16660: @1139284
     /* 1139284 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1139365), // Rule ID 4981 //
     /* 1139289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1139300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1139303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1139306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1139309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1139312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1139342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139364 */     // GIR_Coverage, 4981,
     /* 1139364 */     GIR_EraseRootFromParent_Done,
     /* 1139365 */   // Label 16661: @1139365
     /* 1139365 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1139446), // Rule ID 4982 //
     /* 1139370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1139381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1139384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1139387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1139390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1139393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139423 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1139423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139445 */     // GIR_Coverage, 4982,
     /* 1139445 */     GIR_EraseRootFromParent_Done,
     /* 1139446 */   // Label 16662: @1139446
     /* 1139446 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1139527), // Rule ID 4983 //
     /* 1139451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1139462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1139465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1139468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1139471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1139474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1139504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139526 */     // GIR_Coverage, 4983,
     /* 1139526 */     GIR_EraseRootFromParent_Done,
     /* 1139527 */   // Label 16663: @1139527
     /* 1139527 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1139608), // Rule ID 4984 //
     /* 1139532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1139543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1139546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1139549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1139552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1139555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139585 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1139585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139607 */     // GIR_Coverage, 4984,
     /* 1139607 */     GIR_EraseRootFromParent_Done,
     /* 1139608 */   // Label 16664: @1139608
     /* 1139608 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1139689), // Rule ID 4985 //
     /* 1139613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1139624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1139627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1139630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1139633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1139636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1139643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1139666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1139669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139688 */     // GIR_Coverage, 4985,
     /* 1139688 */     GIR_EraseRootFromParent_Done,
     /* 1139689 */   // Label 16665: @1139689
     /* 1139689 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1139770), // Rule ID 4986 //
     /* 1139694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1139705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1139708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1139711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1139714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1139717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1139724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1139747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1139750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139769 */     // GIR_Coverage, 4986,
     /* 1139769 */     GIR_EraseRootFromParent_Done,
     /* 1139770 */   // Label 16666: @1139770
     /* 1139770 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1139851), // Rule ID 4987 //
     /* 1139775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1139786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1139789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1139792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1139795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1139798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1139805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1139828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1139831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139850 */     // GIR_Coverage, 4987,
     /* 1139850 */     GIR_EraseRootFromParent_Done,
     /* 1139851 */   // Label 16667: @1139851
     /* 1139851 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1139932), // Rule ID 4988 //
     /* 1139856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1139867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1139870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1139873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1139876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1139879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1139886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1139922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139931 */     // GIR_Coverage, 4988,
     /* 1139931 */     GIR_EraseRootFromParent_Done,
     /* 1139932 */   // Label 16668: @1139932
     /* 1139932 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1140013), // Rule ID 4989 //
     /* 1139937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1139945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1139948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1139951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1139954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1139957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1139960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1139967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1139983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1139990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1139993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140012 */     // GIR_Coverage, 4989,
     /* 1140012 */     GIR_EraseRootFromParent_Done,
     /* 1140013 */   // Label 16669: @1140013
     /* 1140013 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1140094), // Rule ID 4990 //
     /* 1140018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1140029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1140032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1140035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1140038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1140041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1140048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1140071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1140074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140093 */     // GIR_Coverage, 4990,
     /* 1140093 */     GIR_EraseRootFromParent_Done,
     /* 1140094 */   // Label 16670: @1140094
     /* 1140094 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1140175), // Rule ID 4991 //
     /* 1140099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1140110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1140113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1140116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1140119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1140122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1140129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1140152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1140155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140174 */     // GIR_Coverage, 4991,
     /* 1140174 */     GIR_EraseRootFromParent_Done,
     /* 1140175 */   // Label 16671: @1140175
     /* 1140175 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1140256), // Rule ID 4992 //
     /* 1140180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1140191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1140194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1140197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1140200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1140203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1140210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1140233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1140236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140255 */     // GIR_Coverage, 4992,
     /* 1140255 */     GIR_EraseRootFromParent_Done,
     /* 1140256 */   // Label 16672: @1140256
     /* 1140256 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1140337), // Rule ID 4993 //
     /* 1140261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1140272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1140275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1140278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1140281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1140284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1140291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1140314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1140317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140336 */     // GIR_Coverage, 4993,
     /* 1140336 */     GIR_EraseRootFromParent_Done,
     /* 1140337 */   // Label 16673: @1140337
     /* 1140337 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1140418), // Rule ID 4994 //
     /* 1140342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1140353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1140356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1140359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1140362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1140365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1140372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140395 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1140395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1140398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140417 */     // GIR_Coverage, 4994,
     /* 1140417 */     GIR_EraseRootFromParent_Done,
     /* 1140418 */   // Label 16674: @1140418
     /* 1140418 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1140499), // Rule ID 4995 //
     /* 1140423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1140434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1140437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1140440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1140443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1140446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1140453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1140476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1140479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140498 */     // GIR_Coverage, 4995,
     /* 1140498 */     GIR_EraseRootFromParent_Done,
     /* 1140499 */   // Label 16675: @1140499
     /* 1140499 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1140580), // Rule ID 4996 //
     /* 1140504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1140515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1140518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1140521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1140524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1140527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1140534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140557 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1140557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1140560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140579 */     // GIR_Coverage, 4996,
     /* 1140579 */     GIR_EraseRootFromParent_Done,
     /* 1140580 */   // Label 16676: @1140580
     /* 1140580 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1140661), // Rule ID 4997 //
     /* 1140585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1140596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1140599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1140602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1140605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1140608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1140615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1140638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1140641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140660 */     // GIR_Coverage, 4997,
     /* 1140660 */     GIR_EraseRootFromParent_Done,
     /* 1140661 */   // Label 16677: @1140661
     /* 1140661 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1140742), // Rule ID 4998 //
     /* 1140666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1140677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1140680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1140683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1140686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1140689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1140696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1140719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1140722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140741 */     // GIR_Coverage, 4998,
     /* 1140741 */     GIR_EraseRootFromParent_Done,
     /* 1140742 */   // Label 16678: @1140742
     /* 1140742 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1140823), // Rule ID 4999 //
     /* 1140747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1140758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1140761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1140764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1140767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1140770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1140777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1140800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1140803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140822 */     // GIR_Coverage, 4999,
     /* 1140822 */     GIR_EraseRootFromParent_Done,
     /* 1140823 */   // Label 16679: @1140823
     /* 1140823 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1140904), // Rule ID 5000 //
     /* 1140828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1140839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1140842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1140845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1140848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1140851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1140858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1140881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1140884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140903 */     // GIR_Coverage, 5000,
     /* 1140903 */     GIR_EraseRootFromParent_Done,
     /* 1140904 */   // Label 16680: @1140904
     /* 1140904 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1140985), // Rule ID 5001 //
     /* 1140909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1140920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1140923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1140926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1140929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1140932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1140939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1140955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1140962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1140965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1140975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140984 */     // GIR_Coverage, 5001,
     /* 1140984 */     GIR_EraseRootFromParent_Done,
     /* 1140985 */   // Label 16681: @1140985
     /* 1140985 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1141066), // Rule ID 5002 //
     /* 1140990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1140998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1141001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1141004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1141007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1141010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1141013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1141020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141043 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1141043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1141046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141065 */     // GIR_Coverage, 5002,
     /* 1141065 */     GIR_EraseRootFromParent_Done,
     /* 1141066 */   // Label 16682: @1141066
     /* 1141066 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1141147), // Rule ID 5003 //
     /* 1141071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1141082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1141085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1141088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1141091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1141094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1141101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1141124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1141127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141146 */     // GIR_Coverage, 5003,
     /* 1141146 */     GIR_EraseRootFromParent_Done,
     /* 1141147 */   // Label 16683: @1141147
     /* 1141147 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1141228), // Rule ID 5004 //
     /* 1141152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1141169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1141172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1141175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1141182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1141205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1141208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141227 */     // GIR_Coverage, 5004,
     /* 1141227 */     GIR_EraseRootFromParent_Done,
     /* 1141228 */   // Label 16684: @1141228
     /* 1141228 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1141309), // Rule ID 5005 //
     /* 1141233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1141250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1141253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1141256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1141263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1141286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1141289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141308 */     // GIR_Coverage, 5005,
     /* 1141308 */     GIR_EraseRootFromParent_Done,
     /* 1141309 */   // Label 16685: @1141309
     /* 1141309 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1141390), // Rule ID 5006 //
     /* 1141314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1141325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1141328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1141331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1141334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1141337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1141344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1141367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1141370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141389 */     // GIR_Coverage, 5006,
     /* 1141389 */     GIR_EraseRootFromParent_Done,
     /* 1141390 */   // Label 16686: @1141390
     /* 1141390 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1141471), // Rule ID 5007 //
     /* 1141395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1141406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1141409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1141412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1141415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1141418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1141425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1141448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1141451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141470 */     // GIR_Coverage, 5007,
     /* 1141470 */     GIR_EraseRootFromParent_Done,
     /* 1141471 */   // Label 16687: @1141471
     /* 1141471 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1141552), // Rule ID 5008 //
     /* 1141476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1141487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1141490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1141493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1141496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1141499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1141506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141529 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1141529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1141532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141551 */     // GIR_Coverage, 5008,
     /* 1141551 */     GIR_EraseRootFromParent_Done,
     /* 1141552 */   // Label 16688: @1141552
     /* 1141552 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1141633), // Rule ID 5009 //
     /* 1141557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1141568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1141571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1141574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1141577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1141580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1141587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1141610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1141613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141632 */     // GIR_Coverage, 5009,
     /* 1141632 */     GIR_EraseRootFromParent_Done,
     /* 1141633 */   // Label 16689: @1141633
     /* 1141633 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1141714), // Rule ID 5010 //
     /* 1141638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1141649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1141652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1141655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1141661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1141668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141691 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1141691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1141694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141713 */     // GIR_Coverage, 5010,
     /* 1141713 */     GIR_EraseRootFromParent_Done,
     /* 1141714 */   // Label 16690: @1141714
     /* 1141714 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1141795), // Rule ID 5011 //
     /* 1141719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1141730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1141733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1141736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1141742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1141749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1141772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1141775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141794 */     // GIR_Coverage, 5011,
     /* 1141794 */     GIR_EraseRootFromParent_Done,
     /* 1141795 */   // Label 16691: @1141795
     /* 1141795 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1141876), // Rule ID 5012 //
     /* 1141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1141811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1141814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1141817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1141823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1141830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1141853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1141856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141875 */     // GIR_Coverage, 5012,
     /* 1141875 */     GIR_EraseRootFromParent_Done,
     /* 1141876 */   // Label 16692: @1141876
     /* 1141876 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1141957), // Rule ID 5013 //
     /* 1141881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1141892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1141895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1141898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1141904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1141911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1141927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1141934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1141937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1141947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141956 */     // GIR_Coverage, 5013,
     /* 1141956 */     GIR_EraseRootFromParent_Done,
     /* 1141957 */   // Label 16693: @1141957
     /* 1141957 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1142038), // Rule ID 5014 //
     /* 1141962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1141970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1141973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1141976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1141979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1141985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1141992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142015 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1142015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142037 */     // GIR_Coverage, 5014,
     /* 1142037 */     GIR_EraseRootFromParent_Done,
     /* 1142038 */   // Label 16694: @1142038
     /* 1142038 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1142119), // Rule ID 5015 //
     /* 1142043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1142054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1142057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1142060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1142066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1142096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142118 */     // GIR_Coverage, 5015,
     /* 1142118 */     GIR_EraseRootFromParent_Done,
     /* 1142119 */   // Label 16695: @1142119
     /* 1142119 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1142200), // Rule ID 5016 //
     /* 1142124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1142147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1142177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1142180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142199 */     // GIR_Coverage, 5016,
     /* 1142199 */     GIR_EraseRootFromParent_Done,
     /* 1142200 */   // Label 16696: @1142200
     /* 1142200 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1142281), // Rule ID 5017 //
     /* 1142205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1142228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1142258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1142261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142280 */     // GIR_Coverage, 5017,
     /* 1142280 */     GIR_EraseRootFromParent_Done,
     /* 1142281 */   // Label 16697: @1142281
     /* 1142281 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1142362), // Rule ID 5018 //
     /* 1142286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1142297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1142300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1142303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1142309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1142339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142361 */     // GIR_Coverage, 5018,
     /* 1142361 */     GIR_EraseRootFromParent_Done,
     /* 1142362 */   // Label 16698: @1142362
     /* 1142362 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1142443), // Rule ID 5019 //
     /* 1142367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1142378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1142381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1142384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1142390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1142420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142442 */     // GIR_Coverage, 5019,
     /* 1142442 */     GIR_EraseRootFromParent_Done,
     /* 1142443 */   // Label 16699: @1142443
     /* 1142443 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1142524), // Rule ID 5020 //
     /* 1142448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1142459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1142462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1142465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1142471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1142501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142523 */     // GIR_Coverage, 5020,
     /* 1142523 */     GIR_EraseRootFromParent_Done,
     /* 1142524 */   // Label 16700: @1142524
     /* 1142524 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1142605), // Rule ID 5021 //
     /* 1142529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1142540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1142543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1142546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1142552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142582 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1142582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1142585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142604 */     // GIR_Coverage, 5021,
     /* 1142604 */     GIR_EraseRootFromParent_Done,
     /* 1142605 */   // Label 16701: @1142605
     /* 1142605 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1142686), // Rule ID 5022 //
     /* 1142610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1142621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1142624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1142627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1142633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1142663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1142666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142685 */     // GIR_Coverage, 5022,
     /* 1142685 */     GIR_EraseRootFromParent_Done,
     /* 1142686 */   // Label 16702: @1142686
     /* 1142686 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1142767), // Rule ID 5023 //
     /* 1142691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1142702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1142705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1142708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1142714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10833:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1142744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1142747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142766 */     // GIR_Coverage, 5023,
     /* 1142766 */     GIR_EraseRootFromParent_Done,
     /* 1142767 */   // Label 16703: @1142767
     /* 1142767 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1142848), // Rule ID 5024 //
     /* 1142772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1142783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1142786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1142789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1142795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1142825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1142828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142847 */     // GIR_Coverage, 5024,
     /* 1142847 */     GIR_EraseRootFromParent_Done,
     /* 1142848 */   // Label 16704: @1142848
     /* 1142848 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1142929), // Rule ID 5025 //
     /* 1142853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1142864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1142867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1142870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1142876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1142906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1142909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1142919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142928 */     // GIR_Coverage, 5025,
     /* 1142928 */     GIR_EraseRootFromParent_Done,
     /* 1142929 */   // Label 16705: @1142929
     /* 1142929 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1143010), // Rule ID 5026 //
     /* 1142934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1142942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1142945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1142948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1142951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1142957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1142964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1142980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142987 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1142987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1142990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143009 */     // GIR_Coverage, 5026,
     /* 1143009 */     GIR_EraseRootFromParent_Done,
     /* 1143010 */   // Label 16706: @1143010
     /* 1143010 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1143091), // Rule ID 5027 //
     /* 1143015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1143026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1143029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1143032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1143038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1143045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1143068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1143071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143090 */     // GIR_Coverage, 5027,
     /* 1143090 */     GIR_EraseRootFromParent_Done,
     /* 1143091 */   // Label 16707: @1143091
     /* 1143091 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1143172), // Rule ID 5028 //
     /* 1143096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1143099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1143119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1143126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1143149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1143152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143171 */     // GIR_Coverage, 5028,
     /* 1143171 */     GIR_EraseRootFromParent_Done,
     /* 1143172 */   // Label 16708: @1143172
     /* 1143172 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1143253), // Rule ID 5029 //
     /* 1143177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1143180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1143200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1143207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1143230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1143233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143252 */     // GIR_Coverage, 5029,
     /* 1143252 */     GIR_EraseRootFromParent_Done,
     /* 1143253 */   // Label 16709: @1143253
     /* 1143253 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1143334), // Rule ID 5030 //
     /* 1143258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1143269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1143272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1143275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1143281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1143288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1143311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1143314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143333 */     // GIR_Coverage, 5030,
     /* 1143333 */     GIR_EraseRootFromParent_Done,
     /* 1143334 */   // Label 16710: @1143334
     /* 1143334 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1143415), // Rule ID 5031 //
     /* 1143339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1143350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1143353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1143356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1143362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1143369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1143392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1143395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143414 */     // GIR_Coverage, 5031,
     /* 1143414 */     GIR_EraseRootFromParent_Done,
     /* 1143415 */   // Label 16711: @1143415
     /* 1143415 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1143496), // Rule ID 5032 //
     /* 1143420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1143431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1143434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1143437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1143443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1143450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1143473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1143476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143495 */     // GIR_Coverage, 5032,
     /* 1143495 */     GIR_EraseRootFromParent_Done,
     /* 1143496 */   // Label 16712: @1143496
     /* 1143496 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1143577), // Rule ID 5033 //
     /* 1143501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1143512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1143515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1143518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1143524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1143531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1143554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1143557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143576 */     // GIR_Coverage, 5033,
     /* 1143576 */     GIR_EraseRootFromParent_Done,
     /* 1143577 */   // Label 16713: @1143577
     /* 1143577 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1143658), // Rule ID 5034 //
     /* 1143582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1143593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1143596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1143599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1143605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1143612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1143635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1143638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143657 */     // GIR_Coverage, 5034,
     /* 1143657 */     GIR_EraseRootFromParent_Done,
     /* 1143658 */   // Label 16714: @1143658
     /* 1143658 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1143739), // Rule ID 5035 //
     /* 1143663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1143674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1143677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1143680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1143686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1143693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143716 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1143716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1143719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143738 */     // GIR_Coverage, 5035,
     /* 1143738 */     GIR_EraseRootFromParent_Done,
     /* 1143739 */   // Label 16715: @1143739
     /* 1143739 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1143820), // Rule ID 5036 //
     /* 1143744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1143755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1143758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1143761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1143767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1143774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1143797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1143800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143819 */     // GIR_Coverage, 5036,
     /* 1143819 */     GIR_EraseRootFromParent_Done,
     /* 1143820 */   // Label 16716: @1143820
     /* 1143820 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1143901), // Rule ID 5037 //
     /* 1143825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1143836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1143839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1143842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1143848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1143855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1143878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1143881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143900 */     // GIR_Coverage, 5037,
     /* 1143900 */     GIR_EraseRootFromParent_Done,
     /* 1143901 */   // Label 16717: @1143901
     /* 1143901 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1143982), // Rule ID 5038 //
     /* 1143906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1143917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1143920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1143923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1143929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1143936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1143952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1143959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1143962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1143972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143981 */     // GIR_Coverage, 5038,
     /* 1143981 */     GIR_EraseRootFromParent_Done,
     /* 1143982 */   // Label 16718: @1143982
     /* 1143982 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1144063), // Rule ID 5039 //
     /* 1143987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1143995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1143998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1144001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1144004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1144010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1144017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1144040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1144043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144062 */     // GIR_Coverage, 5039,
     /* 1144062 */     GIR_EraseRootFromParent_Done,
     /* 1144063 */   // Label 16719: @1144063
     /* 1144063 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1144144), // Rule ID 5040 //
     /* 1144068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1144079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1144082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1144085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1144091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1144098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1144121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1144124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144143 */     // GIR_Coverage, 5040,
     /* 1144143 */     GIR_EraseRootFromParent_Done,
     /* 1144144 */   // Label 16720: @1144144
     /* 1144144 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1144225), // Rule ID 5041 //
     /* 1144149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1144160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1144163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1144166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1144172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1144179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1144202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1144205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144224 */     // GIR_Coverage, 5041,
     /* 1144224 */     GIR_EraseRootFromParent_Done,
     /* 1144225 */   // Label 16721: @1144225
     /* 1144225 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1144306), // Rule ID 5042 //
     /* 1144230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1144241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1144244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1144247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1144253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1144260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1144283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1144286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144305 */     // GIR_Coverage, 5042,
     /* 1144305 */     GIR_EraseRootFromParent_Done,
     /* 1144306 */   // Label 16722: @1144306
     /* 1144306 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1144387), // Rule ID 5043 //
     /* 1144311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1144322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1144325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1144328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1144334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1144341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1144364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1144367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144386 */     // GIR_Coverage, 5043,
     /* 1144386 */     GIR_EraseRootFromParent_Done,
     /* 1144387 */   // Label 16723: @1144387
     /* 1144387 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1144468), // Rule ID 5044 //
     /* 1144392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1144403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1144406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1144409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1144415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1144422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144445 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1144445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1144448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144467 */     // GIR_Coverage, 5044,
     /* 1144467 */     GIR_EraseRootFromParent_Done,
     /* 1144468 */   // Label 16724: @1144468
     /* 1144468 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1144549), // Rule ID 5045 //
     /* 1144473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1144484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1144487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1144490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1144496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1144503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1144526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1144529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144548 */     // GIR_Coverage, 5045,
     /* 1144548 */     GIR_EraseRootFromParent_Done,
     /* 1144549 */   // Label 16725: @1144549
     /* 1144549 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1144630), // Rule ID 5046 //
     /* 1144554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1144565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1144568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1144571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1144577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1144584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144607 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1144607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1144610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144629 */     // GIR_Coverage, 5046,
     /* 1144629 */     GIR_EraseRootFromParent_Done,
     /* 1144630 */   // Label 16726: @1144630
     /* 1144630 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1144711), // Rule ID 5047 //
     /* 1144635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1144646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1144649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1144652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1144658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1144665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1144688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1144691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144710 */     // GIR_Coverage, 5047,
     /* 1144710 */     GIR_EraseRootFromParent_Done,
     /* 1144711 */   // Label 16727: @1144711
     /* 1144711 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1144792), // Rule ID 5048 //
     /* 1144716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1144727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1144730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1144733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1144739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1144746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1144769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1144772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144791 */     // GIR_Coverage, 5048,
     /* 1144791 */     GIR_EraseRootFromParent_Done,
     /* 1144792 */   // Label 16728: @1144792
     /* 1144792 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1144873), // Rule ID 5049 //
     /* 1144797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1144808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1144811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1144814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1144820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1144827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1144850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1144853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144872 */     // GIR_Coverage, 5049,
     /* 1144872 */     GIR_EraseRootFromParent_Done,
     /* 1144873 */   // Label 16729: @1144873
     /* 1144873 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1144954), // Rule ID 5050 //
     /* 1144878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1144889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1144892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1144895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1144901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1144908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1144924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144931 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1144931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1144934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1144944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144953 */     // GIR_Coverage, 5050,
     /* 1144953 */     GIR_EraseRootFromParent_Done,
     /* 1144954 */   // Label 16730: @1144954
     /* 1144954 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1145035), // Rule ID 5051 //
     /* 1144959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1144967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1144970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1144973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1144976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1144982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1144989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1145012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1145015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145034 */     // GIR_Coverage, 5051,
     /* 1145034 */     GIR_EraseRootFromParent_Done,
     /* 1145035 */   // Label 16731: @1145035
     /* 1145035 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1145116), // Rule ID 5052 //
     /* 1145040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1145048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1145051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1145054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1145057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1145063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1145070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1145093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1145096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145115 */     // GIR_Coverage, 5052,
     /* 1145115 */     GIR_EraseRootFromParent_Done,
     /* 1145116 */   // Label 16732: @1145116
     /* 1145116 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1145197), // Rule ID 5053 //
     /* 1145121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1145129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1145132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1145135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1145138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1145144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1145151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10833:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1145174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1145177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145196 */     // GIR_Coverage, 5053,
     /* 1145196 */     GIR_EraseRootFromParent_Done,
     /* 1145197 */   // Label 16733: @1145197
     /* 1145197 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1145278), // Rule ID 5358 //
     /* 1145202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1145219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1145222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1145225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1145255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1145258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145277 */     // GIR_Coverage, 5358,
     /* 1145277 */     GIR_EraseRootFromParent_Done,
     /* 1145278 */   // Label 16734: @1145278
     /* 1145278 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1145359), // Rule ID 5359 //
     /* 1145283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1145300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1145303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1145306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1145336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1145339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145358 */     // GIR_Coverage, 5359,
     /* 1145358 */     GIR_EraseRootFromParent_Done,
     /* 1145359 */   // Label 16735: @1145359
     /* 1145359 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1145440), // Rule ID 5360 //
     /* 1145364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1145375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1145378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1145381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1145384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1145387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1145417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1145420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145439 */     // GIR_Coverage, 5360,
     /* 1145439 */     GIR_EraseRootFromParent_Done,
     /* 1145440 */   // Label 16736: @1145440
     /* 1145440 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1145521), // Rule ID 5361 //
     /* 1145445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1145456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1145459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1145462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1145465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1145468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1145498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1145501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145520 */     // GIR_Coverage, 5361,
     /* 1145520 */     GIR_EraseRootFromParent_Done,
     /* 1145521 */   // Label 16737: @1145521
     /* 1145521 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1145602), // Rule ID 5362 //
     /* 1145526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1145537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1145540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1145543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1145546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1145549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1145579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1145582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145601 */     // GIR_Coverage, 5362,
     /* 1145601 */     GIR_EraseRootFromParent_Done,
     /* 1145602 */   // Label 16738: @1145602
     /* 1145602 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1145683), // Rule ID 5363 //
     /* 1145607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1145618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1145621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1145624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1145627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1145630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145660 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1145660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1145663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145682 */     // GIR_Coverage, 5363,
     /* 1145682 */     GIR_EraseRootFromParent_Done,
     /* 1145683 */   // Label 16739: @1145683
     /* 1145683 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1145764), // Rule ID 5364 //
     /* 1145688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1145699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1145702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1145705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1145708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1145711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1145741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1145744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145763 */     // GIR_Coverage, 5364,
     /* 1145763 */     GIR_EraseRootFromParent_Done,
     /* 1145764 */   // Label 16740: @1145764
     /* 1145764 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1145845), // Rule ID 5365 //
     /* 1145769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1145780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1145783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1145786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1145789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1145792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1145822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1145825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145844 */     // GIR_Coverage, 5365,
     /* 1145844 */     GIR_EraseRootFromParent_Done,
     /* 1145845 */   // Label 16741: @1145845
     /* 1145845 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1145926), // Rule ID 5366 //
     /* 1145850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1145861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1145864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1145867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1145870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1145873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145903 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1145903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1145906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145925 */     // GIR_Coverage, 5366,
     /* 1145925 */     GIR_EraseRootFromParent_Done,
     /* 1145926 */   // Label 16742: @1145926
     /* 1145926 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1146007), // Rule ID 5367 //
     /* 1145931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1145939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1145942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1145945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1145948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1145951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1145954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1145961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1145977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1145984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1145987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1145997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146006 */     // GIR_Coverage, 5367,
     /* 1146006 */     GIR_EraseRootFromParent_Done,
     /* 1146007 */   // Label 16743: @1146007
     /* 1146007 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1146088), // Rule ID 5368 //
     /* 1146012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1146023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1146026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1146029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1146032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1146035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146065 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1146065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1146068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146087 */     // GIR_Coverage, 5368,
     /* 1146087 */     GIR_EraseRootFromParent_Done,
     /* 1146088 */   // Label 16744: @1146088
     /* 1146088 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1146169), // Rule ID 5369 //
     /* 1146093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1146104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1146107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1146110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1146113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1146116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1146146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1146149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146168 */     // GIR_Coverage, 5369,
     /* 1146168 */     GIR_EraseRootFromParent_Done,
     /* 1146169 */   // Label 16745: @1146169
     /* 1146169 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1146250), // Rule ID 5370 //
     /* 1146174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1146194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1146197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1146227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146249 */     // GIR_Coverage, 5370,
     /* 1146249 */     GIR_EraseRootFromParent_Done,
     /* 1146250 */   // Label 16746: @1146250
     /* 1146250 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1146331), // Rule ID 5371 //
     /* 1146255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1146275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1146278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1146308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146330 */     // GIR_Coverage, 5371,
     /* 1146330 */     GIR_EraseRootFromParent_Done,
     /* 1146331 */   // Label 16747: @1146331
     /* 1146331 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1146412), // Rule ID 5372 //
     /* 1146336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1146347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1146350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1146353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1146356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1146359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1146389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146411 */     // GIR_Coverage, 5372,
     /* 1146411 */     GIR_EraseRootFromParent_Done,
     /* 1146412 */   // Label 16748: @1146412
     /* 1146412 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1146493), // Rule ID 5373 //
     /* 1146417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1146428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1146431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1146434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1146437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1146440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1146470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146492 */     // GIR_Coverage, 5373,
     /* 1146492 */     GIR_EraseRootFromParent_Done,
     /* 1146493 */   // Label 16749: @1146493
     /* 1146493 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1146574), // Rule ID 5374 //
     /* 1146498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1146509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1146512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1146515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1146518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1146521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146551 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1146551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146573 */     // GIR_Coverage, 5374,
     /* 1146573 */     GIR_EraseRootFromParent_Done,
     /* 1146574 */   // Label 16750: @1146574
     /* 1146574 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1146655), // Rule ID 5375 //
     /* 1146579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1146590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1146593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1146596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1146599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1146602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1146632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146654 */     // GIR_Coverage, 5375,
     /* 1146654 */     GIR_EraseRootFromParent_Done,
     /* 1146655 */   // Label 16751: @1146655
     /* 1146655 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1146736), // Rule ID 5376 //
     /* 1146660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1146671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1146674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1146677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1146680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1146683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1146713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146735 */     // GIR_Coverage, 5376,
     /* 1146735 */     GIR_EraseRootFromParent_Done,
     /* 1146736 */   // Label 16752: @1146736
     /* 1146736 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1146817), // Rule ID 5377 //
     /* 1146741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1146752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1146755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1146758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1146761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1146764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1146771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1146794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1146797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146816 */     // GIR_Coverage, 5377,
     /* 1146816 */     GIR_EraseRootFromParent_Done,
     /* 1146817 */   // Label 16753: @1146817
     /* 1146817 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1146898), // Rule ID 5378 //
     /* 1146822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1146833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1146836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1146839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1146842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1146845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1146852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1146875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1146878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146897 */     // GIR_Coverage, 5378,
     /* 1146897 */     GIR_EraseRootFromParent_Done,
     /* 1146898 */   // Label 16754: @1146898
     /* 1146898 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1146979), // Rule ID 5379 //
     /* 1146903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1146914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1146917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1146920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1146923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1146926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1146933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1146949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1146956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1146959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1146969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146978 */     // GIR_Coverage, 5379,
     /* 1146978 */     GIR_EraseRootFromParent_Done,
     /* 1146979 */   // Label 16755: @1146979
     /* 1146979 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1147060), // Rule ID 5380 //
     /* 1146984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1146992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1146995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1146998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1147001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1147004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1147007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1147014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147037 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1147037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1147040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147059 */     // GIR_Coverage, 5380,
     /* 1147059 */     GIR_EraseRootFromParent_Done,
     /* 1147060 */   // Label 16756: @1147060
     /* 1147060 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1147141), // Rule ID 5381 //
     /* 1147065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1147076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1147079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1147082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1147085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1147088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1147095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1147118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1147121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147140 */     // GIR_Coverage, 5381,
     /* 1147140 */     GIR_EraseRootFromParent_Done,
     /* 1147141 */   // Label 16757: @1147141
     /* 1147141 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1147222), // Rule ID 5382 //
     /* 1147146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1147166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1147169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1147176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147199 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1147199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1147202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147221 */     // GIR_Coverage, 5382,
     /* 1147221 */     GIR_EraseRootFromParent_Done,
     /* 1147222 */   // Label 16758: @1147222
     /* 1147222 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1147303), // Rule ID 5383 //
     /* 1147227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1147247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1147250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1147257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147280 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1147280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1147283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147302 */     // GIR_Coverage, 5383,
     /* 1147302 */     GIR_EraseRootFromParent_Done,
     /* 1147303 */   // Label 16759: @1147303
     /* 1147303 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1147384), // Rule ID 5384 //
     /* 1147308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1147319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1147322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1147325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1147328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1147331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1147338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1147361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1147364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147383 */     // GIR_Coverage, 5384,
     /* 1147383 */     GIR_EraseRootFromParent_Done,
     /* 1147384 */   // Label 16760: @1147384
     /* 1147384 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1147465), // Rule ID 5385 //
     /* 1147389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1147400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1147403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1147406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1147409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1147412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1147419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1147442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1147445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147464 */     // GIR_Coverage, 5385,
     /* 1147464 */     GIR_EraseRootFromParent_Done,
     /* 1147465 */   // Label 16761: @1147465
     /* 1147465 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1147546), // Rule ID 5386 //
     /* 1147470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1147481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1147484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1147487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1147490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1147493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1147500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147523 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1147523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1147526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147545 */     // GIR_Coverage, 5386,
     /* 1147545 */     GIR_EraseRootFromParent_Done,
     /* 1147546 */   // Label 16762: @1147546
     /* 1147546 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1147627), // Rule ID 5387 //
     /* 1147551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1147562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1147565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1147568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1147571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1147574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1147581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147604 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1147604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1147607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147626 */     // GIR_Coverage, 5387,
     /* 1147626 */     GIR_EraseRootFromParent_Done,
     /* 1147627 */   // Label 16763: @1147627
     /* 1147627 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1147708), // Rule ID 5388 //
     /* 1147632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1147643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1147646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1147649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1147652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1147655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1147662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147685 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1147685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1147688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147707 */     // GIR_Coverage, 5388,
     /* 1147707 */     GIR_EraseRootFromParent_Done,
     /* 1147708 */   // Label 16764: @1147708
     /* 1147708 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1147789), // Rule ID 5389 //
     /* 1147713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1147724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1147727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1147730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1147733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1147736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1147743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1147766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1147769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147788 */     // GIR_Coverage, 5389,
     /* 1147788 */     GIR_EraseRootFromParent_Done,
     /* 1147789 */   // Label 16765: @1147789
     /* 1147789 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1147870), // Rule ID 5390 //
     /* 1147794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1147805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1147808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1147811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1147814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1147817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1147824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1147847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1147850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147869 */     // GIR_Coverage, 5390,
     /* 1147869 */     GIR_EraseRootFromParent_Done,
     /* 1147870 */   // Label 16766: @1147870
     /* 1147870 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1147951), // Rule ID 5391 //
     /* 1147875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1147886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1147889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1147892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1147895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1147898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1147905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1147921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1147928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1147931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1147941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147950 */     // GIR_Coverage, 5391,
     /* 1147950 */     GIR_EraseRootFromParent_Done,
     /* 1147951 */   // Label 16767: @1147951
     /* 1147951 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1148032), // Rule ID 5392 //
     /* 1147956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1147964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1147967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1147970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1147973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1147976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1147979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1147986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1148009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1148012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148031 */     // GIR_Coverage, 5392,
     /* 1148031 */     GIR_EraseRootFromParent_Done,
     /* 1148032 */   // Label 16768: @1148032
     /* 1148032 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1148113), // Rule ID 5393 //
     /* 1148037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1148048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1148051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1148054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1148057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1148060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1148067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1148090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1148093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148112 */     // GIR_Coverage, 5393,
     /* 1148112 */     GIR_EraseRootFromParent_Done,
     /* 1148113 */   // Label 16769: @1148113
     /* 1148113 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1148194), // Rule ID 5394 //
     /* 1148118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1148129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1148132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1148135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1148138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1148141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1148148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1148171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1148174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148193 */     // GIR_Coverage, 5394,
     /* 1148193 */     GIR_EraseRootFromParent_Done,
     /* 1148194 */   // Label 16770: @1148194
     /* 1148194 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1148275), // Rule ID 5395 //
     /* 1148199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1148210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1148213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1148216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1148219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1148222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1148229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1148252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1148255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148274 */     // GIR_Coverage, 5395,
     /* 1148274 */     GIR_EraseRootFromParent_Done,
     /* 1148275 */   // Label 16771: @1148275
     /* 1148275 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1148356), // Rule ID 5396 //
     /* 1148280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1148291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1148294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1148297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1148300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1148303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1148310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1148333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1148336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148355 */     // GIR_Coverage, 5396,
     /* 1148355 */     GIR_EraseRootFromParent_Done,
     /* 1148356 */   // Label 16772: @1148356
     /* 1148356 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1148437), // Rule ID 5397 //
     /* 1148361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1148372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1148375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1148378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1148381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1148384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1148391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1148414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1148417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148436 */     // GIR_Coverage, 5397,
     /* 1148436 */     GIR_EraseRootFromParent_Done,
     /* 1148437 */   // Label 16773: @1148437
     /* 1148437 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1148518), // Rule ID 5398 //
     /* 1148442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1148453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1148456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1148459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1148462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1148465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1148472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148495 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1148495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1148498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148517 */     // GIR_Coverage, 5398,
     /* 1148517 */     GIR_EraseRootFromParent_Done,
     /* 1148518 */   // Label 16774: @1148518
     /* 1148518 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1148599), // Rule ID 5399 //
     /* 1148523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1148534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1148537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1148540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1148543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1148546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1148553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1148576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1148579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148598 */     // GIR_Coverage, 5399,
     /* 1148598 */     GIR_EraseRootFromParent_Done,
     /* 1148599 */   // Label 16775: @1148599
     /* 1148599 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1148680), // Rule ID 5400 //
     /* 1148604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1148615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1148618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1148621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1148624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1148627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1148634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148657 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1148657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1148660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148679 */     // GIR_Coverage, 5400,
     /* 1148679 */     GIR_EraseRootFromParent_Done,
     /* 1148680 */   // Label 16776: @1148680
     /* 1148680 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1148761), // Rule ID 5401 //
     /* 1148685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1148696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1148699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1148702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1148705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1148708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1148715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1148738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1148741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148760 */     // GIR_Coverage, 5401,
     /* 1148760 */     GIR_EraseRootFromParent_Done,
     /* 1148761 */   // Label 16777: @1148761
     /* 1148761 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1148842), // Rule ID 5402 //
     /* 1148766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1148777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1148780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1148783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1148789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1148796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1148819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1148822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148841 */     // GIR_Coverage, 5402,
     /* 1148841 */     GIR_EraseRootFromParent_Done,
     /* 1148842 */   // Label 16778: @1148842
     /* 1148842 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1148923), // Rule ID 5403 //
     /* 1148847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1148858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1148861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1148864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1148870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1148877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148900 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1148900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1148903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148922 */     // GIR_Coverage, 5403,
     /* 1148922 */     GIR_EraseRootFromParent_Done,
     /* 1148923 */   // Label 16779: @1148923
     /* 1148923 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1149004), // Rule ID 5404 //
     /* 1148928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1148936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1148939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1148942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1148945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1148951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1148958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1148974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148981 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1148981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1148984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1148994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149003 */     // GIR_Coverage, 5404,
     /* 1149003 */     GIR_EraseRootFromParent_Done,
     /* 1149004 */   // Label 16780: @1149004
     /* 1149004 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1149085), // Rule ID 5405 //
     /* 1149009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1149032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1149062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1149065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149084 */     // GIR_Coverage, 5405,
     /* 1149084 */     GIR_EraseRootFromParent_Done,
     /* 1149085 */   // Label 16781: @1149085
     /* 1149085 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1149166), // Rule ID 5406 //
     /* 1149090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1149101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1149104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1149107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1149113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149143 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1149143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149165 */     // GIR_Coverage, 5406,
     /* 1149165 */     GIR_EraseRootFromParent_Done,
     /* 1149166 */   // Label 16782: @1149166
     /* 1149166 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1149247), // Rule ID 5407 //
     /* 1149171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1149182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1149185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1149188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1149194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1149224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149246 */     // GIR_Coverage, 5407,
     /* 1149246 */     GIR_EraseRootFromParent_Done,
     /* 1149247 */   // Label 16783: @1149247
     /* 1149247 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1149328), // Rule ID 5408 //
     /* 1149252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1149269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1149275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149305 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1149305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1149308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149327 */     // GIR_Coverage, 5408,
     /* 1149327 */     GIR_EraseRootFromParent_Done,
     /* 1149328 */   // Label 16784: @1149328
     /* 1149328 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1149409), // Rule ID 5409 //
     /* 1149333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1149350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1149356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1149386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1149389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149408 */     // GIR_Coverage, 5409,
     /* 1149408 */     GIR_EraseRootFromParent_Done,
     /* 1149409 */   // Label 16785: @1149409
     /* 1149409 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1149490), // Rule ID 5410 //
     /* 1149414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1149425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1149428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1149431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1149437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1149467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149489 */     // GIR_Coverage, 5410,
     /* 1149489 */     GIR_EraseRootFromParent_Done,
     /* 1149490 */   // Label 16786: @1149490
     /* 1149490 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1149571), // Rule ID 5411 //
     /* 1149495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1149506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1149509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1149512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1149518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1149548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149570 */     // GIR_Coverage, 5411,
     /* 1149570 */     GIR_EraseRootFromParent_Done,
     /* 1149571 */   // Label 16787: @1149571
     /* 1149571 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1149652), // Rule ID 5412 //
     /* 1149576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1149587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1149590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1149593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1149599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149629 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1149629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149651 */     // GIR_Coverage, 5412,
     /* 1149651 */     GIR_EraseRootFromParent_Done,
     /* 1149652 */   // Label 16788: @1149652
     /* 1149652 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1149733), // Rule ID 5413 //
     /* 1149657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1149668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1149671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1149674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1149680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1149710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1149713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149732 */     // GIR_Coverage, 5413,
     /* 1149732 */     GIR_EraseRootFromParent_Done,
     /* 1149733 */   // Label 16789: @1149733
     /* 1149733 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1149814), // Rule ID 5414 //
     /* 1149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1149749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1149752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1149755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1149761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149791 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1149791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1149794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149813 */     // GIR_Coverage, 5414,
     /* 1149813 */     GIR_EraseRootFromParent_Done,
     /* 1149814 */   // Label 16790: @1149814
     /* 1149814 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1149895), // Rule ID 5415 //
     /* 1149819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1149830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1149833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1149836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1149842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1149872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1149875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149894 */     // GIR_Coverage, 5415,
     /* 1149894 */     GIR_EraseRootFromParent_Done,
     /* 1149895 */   // Label 16791: @1149895
     /* 1149895 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1149976), // Rule ID 5416 //
     /* 1149900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1149911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1149914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1149917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1149923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1149930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1149946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149953 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1149953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1149956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1149966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149975 */     // GIR_Coverage, 5416,
     /* 1149975 */     GIR_EraseRootFromParent_Done,
     /* 1149976 */   // Label 16792: @1149976
     /* 1149976 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1150057), // Rule ID 5417 //
     /* 1149981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1149989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1149992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1149995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1149998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1150004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1150011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1150034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1150037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150056 */     // GIR_Coverage, 5417,
     /* 1150056 */     GIR_EraseRootFromParent_Done,
     /* 1150057 */   // Label 16793: @1150057
     /* 1150057 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1150138), // Rule ID 5418 //
     /* 1150062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1150073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1150076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1150079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1150085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1150092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1150115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1150118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150137 */     // GIR_Coverage, 5418,
     /* 1150137 */     GIR_EraseRootFromParent_Done,
     /* 1150138 */   // Label 16794: @1150138
     /* 1150138 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1150219), // Rule ID 5419 //
     /* 1150143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1150154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1150157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1150160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1150166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1150173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1150196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1150199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150218 */     // GIR_Coverage, 5419,
     /* 1150218 */     GIR_EraseRootFromParent_Done,
     /* 1150219 */   // Label 16795: @1150219
     /* 1150219 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1150300), // Rule ID 5420 //
     /* 1150224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1150227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1150247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1150254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1150277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1150280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150299 */     // GIR_Coverage, 5420,
     /* 1150299 */     GIR_EraseRootFromParent_Done,
     /* 1150300 */   // Label 16796: @1150300
     /* 1150300 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1150381), // Rule ID 5421 //
     /* 1150305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1150308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1150328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1150335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1150358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1150361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150380 */     // GIR_Coverage, 5421,
     /* 1150380 */     GIR_EraseRootFromParent_Done,
     /* 1150381 */   // Label 16797: @1150381
     /* 1150381 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1150462), // Rule ID 5422 //
     /* 1150386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1150397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1150400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1150403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1150409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1150416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1150439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1150442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150461 */     // GIR_Coverage, 5422,
     /* 1150461 */     GIR_EraseRootFromParent_Done,
     /* 1150462 */   // Label 16798: @1150462
     /* 1150462 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1150543), // Rule ID 5423 //
     /* 1150467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1150478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1150481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1150484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1150490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1150497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1150520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1150523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150542 */     // GIR_Coverage, 5423,
     /* 1150542 */     GIR_EraseRootFromParent_Done,
     /* 1150543 */   // Label 16799: @1150543
     /* 1150543 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1150624), // Rule ID 5424 //
     /* 1150548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1150559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1150562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1150565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1150571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1150578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150601 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1150601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1150604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150623 */     // GIR_Coverage, 5424,
     /* 1150623 */     GIR_EraseRootFromParent_Done,
     /* 1150624 */   // Label 16800: @1150624
     /* 1150624 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1150705), // Rule ID 5425 //
     /* 1150629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1150640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1150643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1150646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1150652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1150659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150682 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1150682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1150685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150704 */     // GIR_Coverage, 5425,
     /* 1150704 */     GIR_EraseRootFromParent_Done,
     /* 1150705 */   // Label 16801: @1150705
     /* 1150705 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1150786), // Rule ID 5426 //
     /* 1150710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1150721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1150724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1150727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1150733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1150740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150763 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1150763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1150766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150785 */     // GIR_Coverage, 5426,
     /* 1150785 */     GIR_EraseRootFromParent_Done,
     /* 1150786 */   // Label 16802: @1150786
     /* 1150786 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1150867), // Rule ID 5427 //
     /* 1150791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1150802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1150805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1150808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1150814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1150821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1150844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1150847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150866 */     // GIR_Coverage, 5427,
     /* 1150866 */     GIR_EraseRootFromParent_Done,
     /* 1150867 */   // Label 16803: @1150867
     /* 1150867 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1150948), // Rule ID 5428 //
     /* 1150872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1150883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1150886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1150889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1150895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1150902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1150925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1150928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1150938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150947 */     // GIR_Coverage, 5428,
     /* 1150947 */     GIR_EraseRootFromParent_Done,
     /* 1150948 */   // Label 16804: @1150948
     /* 1150948 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1151029), // Rule ID 5429 //
     /* 1150953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1150961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1150964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1150967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1150970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1150976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1150983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1150999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1151006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1151009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151028 */     // GIR_Coverage, 5429,
     /* 1151028 */     GIR_EraseRootFromParent_Done,
     /* 1151029 */   // Label 16805: @1151029
     /* 1151029 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1151110), // Rule ID 5430 //
     /* 1151034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1151045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1151048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1151051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1151057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1151064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1151087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1151090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151109 */     // GIR_Coverage, 5430,
     /* 1151109 */     GIR_EraseRootFromParent_Done,
     /* 1151110 */   // Label 16806: @1151110
     /* 1151110 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1151191), // Rule ID 5431 //
     /* 1151115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1151126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1151129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1151132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1151138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1151145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1151168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1151171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151190 */     // GIR_Coverage, 5431,
     /* 1151190 */     GIR_EraseRootFromParent_Done,
     /* 1151191 */   // Label 16807: @1151191
     /* 1151191 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1151272), // Rule ID 5432 //
     /* 1151196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1151219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1151226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1151249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1151252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151271 */     // GIR_Coverage, 5432,
     /* 1151271 */     GIR_EraseRootFromParent_Done,
     /* 1151272 */   // Label 16808: @1151272
     /* 1151272 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1151353), // Rule ID 5433 //
     /* 1151277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1151300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1151307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1151330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1151333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151352 */     // GIR_Coverage, 5433,
     /* 1151352 */     GIR_EraseRootFromParent_Done,
     /* 1151353 */   // Label 16809: @1151353
     /* 1151353 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1151434), // Rule ID 5434 //
     /* 1151358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1151369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1151372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1151375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1151381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1151388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1151411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1151414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151433 */     // GIR_Coverage, 5434,
     /* 1151433 */     GIR_EraseRootFromParent_Done,
     /* 1151434 */   // Label 16810: @1151434
     /* 1151434 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1151515), // Rule ID 5435 //
     /* 1151439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1151450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1151453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1151456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1151462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1151469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1151492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1151495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151514 */     // GIR_Coverage, 5435,
     /* 1151514 */     GIR_EraseRootFromParent_Done,
     /* 1151515 */   // Label 16811: @1151515
     /* 1151515 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1151596), // Rule ID 5436 //
     /* 1151520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1151531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1151534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1151537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1151543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1151550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1151573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1151576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151595 */     // GIR_Coverage, 5436,
     /* 1151595 */     GIR_EraseRootFromParent_Done,
     /* 1151596 */   // Label 16812: @1151596
     /* 1151596 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1151677), // Rule ID 5437 //
     /* 1151601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1151612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1151615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1151618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1151624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1151631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1151654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1151657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151676 */     // GIR_Coverage, 5437,
     /* 1151676 */     GIR_EraseRootFromParent_Done,
     /* 1151677 */   // Label 16813: @1151677
     /* 1151677 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1151758), // Rule ID 5438 //
     /* 1151682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1151693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1151696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1151699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1151705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1151712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1151735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1151738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151757 */     // GIR_Coverage, 5438,
     /* 1151757 */     GIR_EraseRootFromParent_Done,
     /* 1151758 */   // Label 16814: @1151758
     /* 1151758 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1151839), // Rule ID 5439 //
     /* 1151763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1151774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1151777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1151780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1151786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1151793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1151816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1151819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151838 */     // GIR_Coverage, 5439,
     /* 1151838 */     GIR_EraseRootFromParent_Done,
     /* 1151839 */   // Label 16815: @1151839
     /* 1151839 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1151920), // Rule ID 5440 //
     /* 1151844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1151855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1151858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1151861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1151867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1151874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151897 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1151897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1151900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151919 */     // GIR_Coverage, 5440,
     /* 1151919 */     GIR_EraseRootFromParent_Done,
     /* 1151920 */   // Label 16816: @1151920
     /* 1151920 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1152001), // Rule ID 5441 //
     /* 1151925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1151933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1151936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1151939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1151942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1151948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1151955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1151971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1151978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1151981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1151991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152000 */     // GIR_Coverage, 5441,
     /* 1152000 */     GIR_EraseRootFromParent_Done,
     /* 1152001 */   // Label 16817: @1152001
     /* 1152001 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1152082), // Rule ID 5442 //
     /* 1152006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1152014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1152029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1152036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1152059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1152062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152081 */     // GIR_Coverage, 5442,
     /* 1152081 */     GIR_EraseRootFromParent_Done,
     /* 1152082 */   // Label 16818: @1152082
     /* 1152082 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1152163), // Rule ID 5443 //
     /* 1152087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1152095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1152110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1152117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1152140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1152143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152162 */     // GIR_Coverage, 5443,
     /* 1152162 */     GIR_EraseRootFromParent_Done,
     /* 1152163 */   // Label 16819: @1152163
     /* 1152163 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1152244), // Rule ID 5444 //
     /* 1152168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1152176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1152179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1152182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1152185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1152191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1152198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1152221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1152224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152243 */     // GIR_Coverage, 5444,
     /* 1152243 */     GIR_EraseRootFromParent_Done,
     /* 1152244 */   // Label 16820: @1152244
     /* 1152244 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1152325), // Rule ID 5445 //
     /* 1152249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1152257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1152260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1152263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1152266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1152272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1152279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1152302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1152305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152324 */     // GIR_Coverage, 5445,
     /* 1152324 */     GIR_EraseRootFromParent_Done,
     /* 1152325 */   // Label 16821: @1152325
     /* 1152325 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1152409), // Rule ID 7656 //
     /* 1152330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1152341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1152344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1152347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1152350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1152353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152383 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1152383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1152386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152408 */     // GIR_Coverage, 7656,
     /* 1152408 */     GIR_EraseRootFromParent_Done,
     /* 1152409 */   // Label 16822: @1152409
     /* 1152409 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1152493), // Rule ID 7657 //
     /* 1152414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1152425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1152428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1152431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1152434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1152437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152467 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1152467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1152470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152492 */     // GIR_Coverage, 7657,
     /* 1152492 */     GIR_EraseRootFromParent_Done,
     /* 1152493 */   // Label 16823: @1152493
     /* 1152493 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1152577), // Rule ID 7660 //
     /* 1152498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1152509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1152512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1152515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1152518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1152521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152551 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1152551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1152554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152576 */     // GIR_Coverage, 7660,
     /* 1152576 */     GIR_EraseRootFromParent_Done,
     /* 1152577 */   // Label 16824: @1152577
     /* 1152577 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1152661), // Rule ID 7661 //
     /* 1152582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1152593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1152596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1152599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1152602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1152605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1152635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1152638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152660 */     // GIR_Coverage, 7661,
     /* 1152660 */     GIR_EraseRootFromParent_Done,
     /* 1152661 */   // Label 16825: @1152661
     /* 1152661 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1152745), // Rule ID 7664 //
     /* 1152666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1152677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1152680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1152683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1152686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1152689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152719 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1152719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1152722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152744 */     // GIR_Coverage, 7664,
     /* 1152744 */     GIR_EraseRootFromParent_Done,
     /* 1152745 */   // Label 16826: @1152745
     /* 1152745 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1152829), // Rule ID 7665 //
     /* 1152750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1152761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1152764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1152767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1152770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1152773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1152803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1152806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152828 */     // GIR_Coverage, 7665,
     /* 1152828 */     GIR_EraseRootFromParent_Done,
     /* 1152829 */   // Label 16827: @1152829
     /* 1152829 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1152913), // Rule ID 7668 //
     /* 1152834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1152845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1152848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1152851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1152854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1152857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1152887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1152890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152912 */     // GIR_Coverage, 7668,
     /* 1152912 */     GIR_EraseRootFromParent_Done,
     /* 1152913 */   // Label 16828: @1152913
     /* 1152913 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1152997), // Rule ID 7669 //
     /* 1152918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1152926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1152929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1152932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1152935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1152938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1152941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1152964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152971 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1152971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1152974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1152984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1152995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152996 */     // GIR_Coverage, 7669,
     /* 1152996 */     GIR_EraseRootFromParent_Done,
     /* 1152997 */   // Label 16829: @1152997
     /* 1152997 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1153081), // Rule ID 7672 //
     /* 1153002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1153013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1153016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1153019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1153022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1153025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153055 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1153058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153080 */     // GIR_Coverage, 7672,
     /* 1153080 */     GIR_EraseRootFromParent_Done,
     /* 1153081 */   // Label 16830: @1153081
     /* 1153081 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1153165), // Rule ID 7673 //
     /* 1153086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1153097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1153100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1153103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1153106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1153109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1153142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153164 */     // GIR_Coverage, 7673,
     /* 1153164 */     GIR_EraseRootFromParent_Done,
     /* 1153165 */   // Label 16831: @1153165
     /* 1153165 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1153249), // Rule ID 7676 //
     /* 1153170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1153181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1153184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1153187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1153190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1153193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153223 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153248 */     // GIR_Coverage, 7676,
     /* 1153248 */     GIR_EraseRootFromParent_Done,
     /* 1153249 */   // Label 16832: @1153249
     /* 1153249 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1153333), // Rule ID 7677 //
     /* 1153254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1153265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1153268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1153271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1153274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1153277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153332 */     // GIR_Coverage, 7677,
     /* 1153332 */     GIR_EraseRootFromParent_Done,
     /* 1153333 */   // Label 16833: @1153333
     /* 1153333 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1153417), // Rule ID 7680 //
     /* 1153338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1153349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1153352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1153355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1153358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1153361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153416 */     // GIR_Coverage, 7680,
     /* 1153416 */     GIR_EraseRootFromParent_Done,
     /* 1153417 */   // Label 16834: @1153417
     /* 1153417 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1153501), // Rule ID 7681 //
     /* 1153422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1153433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1153436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1153439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1153442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1153445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153475 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153500 */     // GIR_Coverage, 7681,
     /* 1153500 */     GIR_EraseRootFromParent_Done,
     /* 1153501 */   // Label 16835: @1153501
     /* 1153501 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1153585), // Rule ID 7684 //
     /* 1153506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1153517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1153520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1153523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1153526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1153529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153584 */     // GIR_Coverage, 7684,
     /* 1153584 */     GIR_EraseRootFromParent_Done,
     /* 1153585 */   // Label 16836: @1153585
     /* 1153585 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1153669), // Rule ID 7685 //
     /* 1153590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1153601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1153604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1153607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1153610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1153613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153668 */     // GIR_Coverage, 7685,
     /* 1153668 */     GIR_EraseRootFromParent_Done,
     /* 1153669 */   // Label 16837: @1153669
     /* 1153669 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1153753), // Rule ID 7688 //
     /* 1153674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1153685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1153688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1153691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1153694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1153697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153727 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153752 */     // GIR_Coverage, 7688,
     /* 1153752 */     GIR_EraseRootFromParent_Done,
     /* 1153753 */   // Label 16838: @1153753
     /* 1153753 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1153837), // Rule ID 7689 //
     /* 1153758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1153769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1153772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1153775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1153778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1153781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1153814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153836 */     // GIR_Coverage, 7689,
     /* 1153836 */     GIR_EraseRootFromParent_Done,
     /* 1153837 */   // Label 16839: @1153837
     /* 1153837 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1153921), // Rule ID 7692 //
     /* 1153842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1153853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1153856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1153859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1153862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1153865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1153895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1153898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1153919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153920 */     // GIR_Coverage, 7692,
     /* 1153920 */     GIR_EraseRootFromParent_Done,
     /* 1153921 */   // Label 16840: @1153921
     /* 1153921 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1154005), // Rule ID 7693 //
     /* 1153926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1153934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1153937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1153940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1153943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1153946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1153949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1153972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153979 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1153979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1153982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1153992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154004 */     // GIR_Coverage, 7693,
     /* 1154004 */     GIR_EraseRootFromParent_Done,
     /* 1154005 */   // Label 16841: @1154005
     /* 1154005 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1154089), // Rule ID 7696 //
     /* 1154010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1154021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1154024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1154027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1154030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1154033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154063 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1154066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154088 */     // GIR_Coverage, 7696,
     /* 1154088 */     GIR_EraseRootFromParent_Done,
     /* 1154089 */   // Label 16842: @1154089
     /* 1154089 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1154173), // Rule ID 7697 //
     /* 1154094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1154105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1154108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1154111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1154114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1154117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154147 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1154150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154172 */     // GIR_Coverage, 7697,
     /* 1154172 */     GIR_EraseRootFromParent_Done,
     /* 1154173 */   // Label 16843: @1154173
     /* 1154173 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1154257), // Rule ID 7700 //
     /* 1154178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1154189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1154192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1154195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1154198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1154201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154231 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1154234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154256 */     // GIR_Coverage, 7700,
     /* 1154256 */     GIR_EraseRootFromParent_Done,
     /* 1154257 */   // Label 16844: @1154257
     /* 1154257 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1154341), // Rule ID 7701 //
     /* 1154262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1154273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1154276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1154279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1154282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1154285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154315 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1154318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154340 */     // GIR_Coverage, 7701,
     /* 1154340 */     GIR_EraseRootFromParent_Done,
     /* 1154341 */   // Label 16845: @1154341
     /* 1154341 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1154425), // Rule ID 7704 //
     /* 1154346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1154357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1154360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1154363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1154366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1154369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154399 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1154402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154424 */     // GIR_Coverage, 7704,
     /* 1154424 */     GIR_EraseRootFromParent_Done,
     /* 1154425 */   // Label 16846: @1154425
     /* 1154425 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1154509), // Rule ID 7705 //
     /* 1154430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1154441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1154444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1154447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1154450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1154453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1154486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154508 */     // GIR_Coverage, 7705,
     /* 1154508 */     GIR_EraseRootFromParent_Done,
     /* 1154509 */   // Label 16847: @1154509
     /* 1154509 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1154593), // Rule ID 7708 //
     /* 1154514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1154525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1154528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1154531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1154534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1154537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154567 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1154570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154592 */     // GIR_Coverage, 7708,
     /* 1154592 */     GIR_EraseRootFromParent_Done,
     /* 1154593 */   // Label 16848: @1154593
     /* 1154593 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1154677), // Rule ID 7709 //
     /* 1154598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1154609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1154612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1154615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1154618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1154621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1154654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154676 */     // GIR_Coverage, 7709,
     /* 1154676 */     GIR_EraseRootFromParent_Done,
     /* 1154677 */   // Label 16849: @1154677
     /* 1154677 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1154761), // Rule ID 7712 //
     /* 1154682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1154693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1154696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1154699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1154702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1154705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154735 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1154738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154760 */     // GIR_Coverage, 7712,
     /* 1154760 */     GIR_EraseRootFromParent_Done,
     /* 1154761 */   // Label 16850: @1154761
     /* 1154761 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1154845), // Rule ID 7713 //
     /* 1154766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1154777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1154780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1154783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1154786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1154789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154819 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1154822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154844 */     // GIR_Coverage, 7713,
     /* 1154844 */     GIR_EraseRootFromParent_Done,
     /* 1154845 */   // Label 16851: @1154845
     /* 1154845 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1154929), // Rule ID 7716 //
     /* 1154850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1154861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1154864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1154867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1154870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1154873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1154903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1154906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1154916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1154927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154928 */     // GIR_Coverage, 7716,
     /* 1154928 */     GIR_EraseRootFromParent_Done,
     /* 1154929 */   // Label 16852: @1154929
     /* 1154929 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1155013), // Rule ID 7717 //
     /* 1154934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1154942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1154945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1154948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1154951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1154954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1154957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1154980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154987 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1154987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1154990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155012 */     // GIR_Coverage, 7717,
     /* 1155012 */     GIR_EraseRootFromParent_Done,
     /* 1155013 */   // Label 16853: @1155013
     /* 1155013 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1155097), // Rule ID 7720 //
     /* 1155018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1155029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1155032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1155035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1155038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1155041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155071 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1155074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155096 */     // GIR_Coverage, 7720,
     /* 1155096 */     GIR_EraseRootFromParent_Done,
     /* 1155097 */   // Label 16854: @1155097
     /* 1155097 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1155181), // Rule ID 7721 //
     /* 1155102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1155113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1155116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1155119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1155122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1155125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155155 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1155158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155180 */     // GIR_Coverage, 7721,
     /* 1155180 */     GIR_EraseRootFromParent_Done,
     /* 1155181 */   // Label 16855: @1155181
     /* 1155181 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1155265), // Rule ID 7724 //
     /* 1155186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1155197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1155200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1155203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1155206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1155209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155239 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1155242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155264 */     // GIR_Coverage, 7724,
     /* 1155264 */     GIR_EraseRootFromParent_Done,
     /* 1155265 */   // Label 16856: @1155265
     /* 1155265 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1155349), // Rule ID 7725 //
     /* 1155270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1155281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1155284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1155287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1155290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1155293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1155326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155348 */     // GIR_Coverage, 7725,
     /* 1155348 */     GIR_EraseRootFromParent_Done,
     /* 1155349 */   // Label 16857: @1155349
     /* 1155349 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1155433), // Rule ID 7728 //
     /* 1155354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1155365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1155368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1155371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1155374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1155377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155407 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1155410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155432 */     // GIR_Coverage, 7728,
     /* 1155432 */     GIR_EraseRootFromParent_Done,
     /* 1155433 */   // Label 16858: @1155433
     /* 1155433 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1155517), // Rule ID 7729 //
     /* 1155438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1155449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1155452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1155455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1155458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1155461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155491 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1155494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155516 */     // GIR_Coverage, 7729,
     /* 1155516 */     GIR_EraseRootFromParent_Done,
     /* 1155517 */   // Label 16859: @1155517
     /* 1155517 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1155601), // Rule ID 7732 //
     /* 1155522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1155533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1155536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1155539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1155542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1155545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155575 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1155578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155600 */     // GIR_Coverage, 7732,
     /* 1155600 */     GIR_EraseRootFromParent_Done,
     /* 1155601 */   // Label 16860: @1155601
     /* 1155601 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1155685), // Rule ID 7733 //
     /* 1155606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1155617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1155620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1155623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1155626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1155629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1155662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155684 */     // GIR_Coverage, 7733,
     /* 1155684 */     GIR_EraseRootFromParent_Done,
     /* 1155685 */   // Label 16861: @1155685
     /* 1155685 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1155769), // Rule ID 7736 //
     /* 1155690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1155701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1155704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1155707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1155710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1155713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155743 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1155746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155768 */     // GIR_Coverage, 7736,
     /* 1155768 */     GIR_EraseRootFromParent_Done,
     /* 1155769 */   // Label 16862: @1155769
     /* 1155769 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1155853), // Rule ID 7737 //
     /* 1155774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1155785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1155788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1155791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1155794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1155797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1155830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155852 */     // GIR_Coverage, 7737,
     /* 1155852 */     GIR_EraseRootFromParent_Done,
     /* 1155853 */   // Label 16863: @1155853
     /* 1155853 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1155937), // Rule ID 7740 //
     /* 1155858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1155869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1155872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1155875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1155881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155911 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1155911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1155914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1155924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1155935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155936 */     // GIR_Coverage, 7740,
     /* 1155936 */     GIR_EraseRootFromParent_Done,
     /* 1155937 */   // Label 16864: @1155937
     /* 1155937 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1156021), // Rule ID 7741 //
     /* 1155942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1155950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1155953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1155956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1155959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1155965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1155988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155995 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1155995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1155998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156020 */     // GIR_Coverage, 7741,
     /* 1156020 */     GIR_EraseRootFromParent_Done,
     /* 1156021 */   // Label 16865: @1156021
     /* 1156021 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1156105), // Rule ID 7744 //
     /* 1156026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1156037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1156040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1156049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156079 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1156082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156104 */     // GIR_Coverage, 7744,
     /* 1156104 */     GIR_EraseRootFromParent_Done,
     /* 1156105 */   // Label 16866: @1156105
     /* 1156105 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1156189), // Rule ID 7745 //
     /* 1156110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1156121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1156124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1156133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156163 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1156163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1156166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156188 */     // GIR_Coverage, 7745,
     /* 1156188 */     GIR_EraseRootFromParent_Done,
     /* 1156189 */   // Label 16867: @1156189
     /* 1156189 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1156273), // Rule ID 7748 //
     /* 1156194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1156205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1156208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1156211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1156217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156272 */     // GIR_Coverage, 7748,
     /* 1156272 */     GIR_EraseRootFromParent_Done,
     /* 1156273 */   // Label 16868: @1156273
     /* 1156273 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1156357), // Rule ID 7749 //
     /* 1156278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1156289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1156292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1156295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1156301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156331 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1156331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156356 */     // GIR_Coverage, 7749,
     /* 1156356 */     GIR_EraseRootFromParent_Done,
     /* 1156357 */   // Label 16869: @1156357
     /* 1156357 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1156441), // Rule ID 7752 //
     /* 1156362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1156373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1156376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1156379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1156385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156415 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1156418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156440 */     // GIR_Coverage, 7752,
     /* 1156440 */     GIR_EraseRootFromParent_Done,
     /* 1156441 */   // Label 16870: @1156441
     /* 1156441 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1156525), // Rule ID 7753 //
     /* 1156446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1156457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1156460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1156463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1156469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156499 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1156499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1156502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156524 */     // GIR_Coverage, 7753,
     /* 1156524 */     GIR_EraseRootFromParent_Done,
     /* 1156525 */   // Label 16871: @1156525
     /* 1156525 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1156609), // Rule ID 7756 //
     /* 1156530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1156541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1156544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1156547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1156553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156583 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156608 */     // GIR_Coverage, 7756,
     /* 1156608 */     GIR_EraseRootFromParent_Done,
     /* 1156609 */   // Label 16872: @1156609
     /* 1156609 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1156693), // Rule ID 7757 //
     /* 1156614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1156625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1156628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1156631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1156637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1156667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156692 */     // GIR_Coverage, 7757,
     /* 1156692 */     GIR_EraseRootFromParent_Done,
     /* 1156693 */   // Label 16873: @1156693
     /* 1156693 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1156777), // Rule ID 7760 //
     /* 1156698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1156709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1156712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1156715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1156721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156751 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156776 */     // GIR_Coverage, 7760,
     /* 1156776 */     GIR_EraseRootFromParent_Done,
     /* 1156777 */   // Label 16874: @1156777
     /* 1156777 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1156861), // Rule ID 7761 //
     /* 1156782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1156793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1156796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1156799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1156805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156835 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1156835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1156838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156860 */     // GIR_Coverage, 7761,
     /* 1156860 */     GIR_EraseRootFromParent_Done,
     /* 1156861 */   // Label 16875: @1156861
     /* 1156861 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1156945), // Rule ID 7764 //
     /* 1156866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1156877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1156880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1156883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1156889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1156919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1156922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1156932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1156943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156944 */     // GIR_Coverage, 7764,
     /* 1156944 */     GIR_EraseRootFromParent_Done,
     /* 1156945 */   // Label 16876: @1156945
     /* 1156945 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1157029), // Rule ID 7765 //
     /* 1156950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1156958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1156961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1156964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1156967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1156973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1156996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157003 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157028 */     // GIR_Coverage, 7765,
     /* 1157028 */     GIR_EraseRootFromParent_Done,
     /* 1157029 */   // Label 16877: @1157029
     /* 1157029 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1157113), // Rule ID 7768 //
     /* 1157034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1157045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1157048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1157057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157112 */     // GIR_Coverage, 7768,
     /* 1157112 */     GIR_EraseRootFromParent_Done,
     /* 1157113 */   // Label 16878: @1157113
     /* 1157113 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1157197), // Rule ID 7769 //
     /* 1157118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1157129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1157132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1157141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157171 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157196 */     // GIR_Coverage, 7769,
     /* 1157196 */     GIR_EraseRootFromParent_Done,
     /* 1157197 */   // Label 16879: @1157197
     /* 1157197 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1157281), // Rule ID 7772 //
     /* 1157202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1157213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1157216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1157219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1157225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157255 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157280 */     // GIR_Coverage, 7772,
     /* 1157280 */     GIR_EraseRootFromParent_Done,
     /* 1157281 */   // Label 16880: @1157281
     /* 1157281 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1157365), // Rule ID 7773 //
     /* 1157286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1157297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1157300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1157303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1157309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157339 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157364 */     // GIR_Coverage, 7773,
     /* 1157364 */     GIR_EraseRootFromParent_Done,
     /* 1157365 */   // Label 16881: @1157365
     /* 1157365 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1157449), // Rule ID 7776 //
     /* 1157370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1157373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1157381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1157384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1157387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1157393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157423 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157448 */     // GIR_Coverage, 7776,
     /* 1157448 */     GIR_EraseRootFromParent_Done,
     /* 1157449 */   // Label 16882: @1157449
     /* 1157449 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1157533), // Rule ID 7777 //
     /* 1157454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1157465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1157468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1157471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1157477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157507 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1157510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157532 */     // GIR_Coverage, 7777,
     /* 1157532 */     GIR_EraseRootFromParent_Done,
     /* 1157533 */   // Label 16883: @1157533
     /* 1157533 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1157617), // Rule ID 7780 //
     /* 1157538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1157549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1157552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1157555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1157561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1157594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157616 */     // GIR_Coverage, 7780,
     /* 1157616 */     GIR_EraseRootFromParent_Done,
     /* 1157617 */   // Label 16884: @1157617
     /* 1157617 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1157701), // Rule ID 7781 //
     /* 1157622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1157633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1157636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1157639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1157645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1157678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157700 */     // GIR_Coverage, 7781,
     /* 1157700 */     GIR_EraseRootFromParent_Done,
     /* 1157701 */   // Label 16885: @1157701
     /* 1157701 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1157785), // Rule ID 7784 //
     /* 1157706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1157717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1157720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1157723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1157729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157759 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1157762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157784 */     // GIR_Coverage, 7784,
     /* 1157784 */     GIR_EraseRootFromParent_Done,
     /* 1157785 */   // Label 16886: @1157785
     /* 1157785 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1157869), // Rule ID 7785 //
     /* 1157790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1157801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1157804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1157807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1157813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157843 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1157843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1157846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157868 */     // GIR_Coverage, 7785,
     /* 1157868 */     GIR_EraseRootFromParent_Done,
     /* 1157869 */   // Label 16887: @1157869
     /* 1157869 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1157953), // Rule ID 7788 //
     /* 1157874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1157885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1157888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1157891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1157897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1157920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157927 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1157927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1157930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1157940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1157951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157952 */     // GIR_Coverage, 7788,
     /* 1157952 */     GIR_EraseRootFromParent_Done,
     /* 1157953 */   // Label 16888: @1157953
     /* 1157953 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1158037), // Rule ID 7789 //
     /* 1157958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1157966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1157969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1157972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1157975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1157981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158011 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1158014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158036 */     // GIR_Coverage, 7789,
     /* 1158036 */     GIR_EraseRootFromParent_Done,
     /* 1158037 */   // Label 16889: @1158037
     /* 1158037 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1158121), // Rule ID 7792 //
     /* 1158042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1158053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1158056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1158065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1158098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158120 */     // GIR_Coverage, 7792,
     /* 1158120 */     GIR_EraseRootFromParent_Done,
     /* 1158121 */   // Label 16890: @1158121
     /* 1158121 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1158205), // Rule ID 7793 //
     /* 1158126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1158137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1158140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1158149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1158182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158204 */     // GIR_Coverage, 7793,
     /* 1158204 */     GIR_EraseRootFromParent_Done,
     /* 1158205 */   // Label 16891: @1158205
     /* 1158205 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1158289), // Rule ID 7796 //
     /* 1158210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1158221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1158224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1158233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158263 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1158266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158288 */     // GIR_Coverage, 7796,
     /* 1158288 */     GIR_EraseRootFromParent_Done,
     /* 1158289 */   // Label 16892: @1158289
     /* 1158289 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1158373), // Rule ID 7797 //
     /* 1158294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1158305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1158308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1158317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158347 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1158350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158372 */     // GIR_Coverage, 7797,
     /* 1158372 */     GIR_EraseRootFromParent_Done,
     /* 1158373 */   // Label 16893: @1158373
     /* 1158373 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1158457), // Rule ID 7800 //
     /* 1158378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1158389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1158392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1158395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1158401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158431 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1158434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158456 */     // GIR_Coverage, 7800,
     /* 1158456 */     GIR_EraseRootFromParent_Done,
     /* 1158457 */   // Label 16894: @1158457
     /* 1158457 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1158541), // Rule ID 7801 //
     /* 1158462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1158473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1158476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1158479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1158485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158515 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1158518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158540 */     // GIR_Coverage, 7801,
     /* 1158540 */     GIR_EraseRootFromParent_Done,
     /* 1158541 */   // Label 16895: @1158541
     /* 1158541 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1158625), // Rule ID 7804 //
     /* 1158546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1158557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1158560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1158563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1158569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158599 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1158602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158624 */     // GIR_Coverage, 7804,
     /* 1158624 */     GIR_EraseRootFromParent_Done,
     /* 1158625 */   // Label 16896: @1158625
     /* 1158625 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1158709), // Rule ID 7805 //
     /* 1158630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1158641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1158644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1158647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1158653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1158686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158708 */     // GIR_Coverage, 7805,
     /* 1158708 */     GIR_EraseRootFromParent_Done,
     /* 1158709 */   // Label 16897: @1158709
     /* 1158709 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1158793), // Rule ID 7808 //
     /* 1158714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1158725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1158728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1158731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1158737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158767 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1158770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158792 */     // GIR_Coverage, 7808,
     /* 1158792 */     GIR_EraseRootFromParent_Done,
     /* 1158793 */   // Label 16898: @1158793
     /* 1158793 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1158877), // Rule ID 7809 //
     /* 1158798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1158809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1158812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1158815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1158821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1158851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1158854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158876 */     // GIR_Coverage, 7809,
     /* 1158876 */     GIR_EraseRootFromParent_Done,
     /* 1158877 */   // Label 16899: @1158877
     /* 1158877 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1158961), // Rule ID 7812 //
     /* 1158882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1158893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1158896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1158899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1158905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1158928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158935 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1158935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1158938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1158948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1158959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158960 */     // GIR_Coverage, 7812,
     /* 1158960 */     GIR_EraseRootFromParent_Done,
     /* 1158961 */   // Label 16900: @1158961
     /* 1158961 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1159045), // Rule ID 7813 //
     /* 1158966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1158974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1158977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1158980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1158983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1158989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159019 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1159022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159044 */     // GIR_Coverage, 7813,
     /* 1159044 */     GIR_EraseRootFromParent_Done,
     /* 1159045 */   // Label 16901: @1159045
     /* 1159045 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1159129), // Rule ID 7816 //
     /* 1159050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1159053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1159061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1159064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1159067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1159073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159103 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1159106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159128 */     // GIR_Coverage, 7816,
     /* 1159128 */     GIR_EraseRootFromParent_Done,
     /* 1159129 */   // Label 16902: @1159129
     /* 1159129 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1159213), // Rule ID 7817 //
     /* 1159134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1159137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1159145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1159148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1159151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1159157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159187 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1159190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159212 */     // GIR_Coverage, 7817,
     /* 1159212 */     GIR_EraseRootFromParent_Done,
     /* 1159213 */   // Label 16903: @1159213
     /* 1159213 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1159297), // Rule ID 7820 //
     /* 1159218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1159221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1159229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1159232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1159235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1159241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159271 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1159274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159296 */     // GIR_Coverage, 7820,
     /* 1159296 */     GIR_EraseRootFromParent_Done,
     /* 1159297 */   // Label 16904: @1159297
     /* 1159297 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1159381), // Rule ID 7821 //
     /* 1159302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1159305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1159313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1159316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1159319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1159325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1159358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159380 */     // GIR_Coverage, 7821,
     /* 1159380 */     GIR_EraseRootFromParent_Done,
     /* 1159381 */   // Label 16905: @1159381
     /* 1159381 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1159465), // Rule ID 7824 //
     /* 1159386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1159389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1159397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1159400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1159403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1159409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1159442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159464 */     // GIR_Coverage, 7824,
     /* 1159464 */     GIR_EraseRootFromParent_Done,
     /* 1159465 */   // Label 16906: @1159465
     /* 1159465 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1159549), // Rule ID 7825 //
     /* 1159470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1159473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1159478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1159481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1159484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1159487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1159493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159523 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1159526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159548 */     // GIR_Coverage, 7825,
     /* 1159548 */     GIR_EraseRootFromParent_Done,
     /* 1159549 */   // Label 16907: @1159549
     /* 1159549 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1159633), // Rule ID 7916 //
     /* 1159554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1159565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1159568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1159574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1159577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159607 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1159610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159632 */     // GIR_Coverage, 7916,
     /* 1159632 */     GIR_EraseRootFromParent_Done,
     /* 1159633 */   // Label 16908: @1159633
     /* 1159633 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1159717), // Rule ID 7917 //
     /* 1159638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1159649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1159652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1159658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1159661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159691 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1159694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159716 */     // GIR_Coverage, 7917,
     /* 1159716 */     GIR_EraseRootFromParent_Done,
     /* 1159717 */   // Label 16909: @1159717
     /* 1159717 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1159801), // Rule ID 7920 //
     /* 1159722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1159733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1159736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1159742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1159745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1159778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159800 */     // GIR_Coverage, 7920,
     /* 1159800 */     GIR_EraseRootFromParent_Done,
     /* 1159801 */   // Label 16910: @1159801
     /* 1159801 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1159885), // Rule ID 7921 //
     /* 1159806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1159817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1159820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1159826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1159829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159859 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1159859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1159862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159884 */     // GIR_Coverage, 7921,
     /* 1159884 */     GIR_EraseRootFromParent_Done,
     /* 1159885 */   // Label 16911: @1159885
     /* 1159885 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1159969), // Rule ID 7924 //
     /* 1159890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1159901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1159904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1159910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1159913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1159936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1159943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1159946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1159956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1159967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159968 */     // GIR_Coverage, 7924,
     /* 1159968 */     GIR_EraseRootFromParent_Done,
     /* 1159969 */   // Label 16912: @1159969
     /* 1159969 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1160053), // Rule ID 7925 //
     /* 1159974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1159982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1159985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1159988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1159994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1159997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160027 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1160030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160052 */     // GIR_Coverage, 7925,
     /* 1160052 */     GIR_EraseRootFromParent_Done,
     /* 1160053 */   // Label 16913: @1160053
     /* 1160053 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1160137), // Rule ID 7928 //
     /* 1160058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1160069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1160072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1160078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1160081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1160114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160136 */     // GIR_Coverage, 7928,
     /* 1160136 */     GIR_EraseRootFromParent_Done,
     /* 1160137 */   // Label 16914: @1160137
     /* 1160137 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1160221), // Rule ID 7929 //
     /* 1160142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1160153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1160156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1160162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1160165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160195 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1160198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160220 */     // GIR_Coverage, 7929,
     /* 1160220 */     GIR_EraseRootFromParent_Done,
     /* 1160221 */   // Label 16915: @1160221
     /* 1160221 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1160305), // Rule ID 7932 //
     /* 1160226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1160237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1160240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1160246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1160249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1160282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160304 */     // GIR_Coverage, 7932,
     /* 1160304 */     GIR_EraseRootFromParent_Done,
     /* 1160305 */   // Label 16916: @1160305
     /* 1160305 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1160389), // Rule ID 7933 //
     /* 1160310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1160321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1160324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1160330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1160333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1160366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160388 */     // GIR_Coverage, 7933,
     /* 1160388 */     GIR_EraseRootFromParent_Done,
     /* 1160389 */   // Label 16917: @1160389
     /* 1160389 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1160473), // Rule ID 7936 //
     /* 1160394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1160405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1160408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1160414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1160417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160447 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1160450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160472 */     // GIR_Coverage, 7936,
     /* 1160472 */     GIR_EraseRootFromParent_Done,
     /* 1160473 */   // Label 16918: @1160473
     /* 1160473 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1160557), // Rule ID 7937 //
     /* 1160478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1160489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1160492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1160498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1160501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1160534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160556 */     // GIR_Coverage, 7937,
     /* 1160556 */     GIR_EraseRootFromParent_Done,
     /* 1160557 */   // Label 16919: @1160557
     /* 1160557 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1160641), // Rule ID 7940 //
     /* 1160562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1160573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1160576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1160582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1160585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1160618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160640 */     // GIR_Coverage, 7940,
     /* 1160640 */     GIR_EraseRootFromParent_Done,
     /* 1160641 */   // Label 16920: @1160641
     /* 1160641 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1160725), // Rule ID 7941 //
     /* 1160646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1160657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1160660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1160666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1160669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1160702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160724 */     // GIR_Coverage, 7941,
     /* 1160724 */     GIR_EraseRootFromParent_Done,
     /* 1160725 */   // Label 16921: @1160725
     /* 1160725 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1160809), // Rule ID 7944 //
     /* 1160730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1160741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1160744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1160750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1160753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1160786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160808 */     // GIR_Coverage, 7944,
     /* 1160808 */     GIR_EraseRootFromParent_Done,
     /* 1160809 */   // Label 16922: @1160809
     /* 1160809 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1160893), // Rule ID 7945 //
     /* 1160814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1160825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1160828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1160834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1160837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160867 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1160867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1160870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160892 */     // GIR_Coverage, 7945,
     /* 1160892 */     GIR_EraseRootFromParent_Done,
     /* 1160893 */   // Label 16923: @1160893
     /* 1160893 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1160977), // Rule ID 7948 //
     /* 1160898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1160909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1160912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1160918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1160921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1160944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1160951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1160954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1160964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1160975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160976 */     // GIR_Coverage, 7948,
     /* 1160976 */     GIR_EraseRootFromParent_Done,
     /* 1160977 */   // Label 16924: @1160977
     /* 1160977 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1161061), // Rule ID 7949 //
     /* 1160982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1160990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1160993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1160996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1161002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1161005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1161038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161060 */     // GIR_Coverage, 7949,
     /* 1161060 */     GIR_EraseRootFromParent_Done,
     /* 1161061 */   // Label 16925: @1161061
     /* 1161061 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1161145), // Rule ID 7952 //
     /* 1161066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1161069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1161077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1161080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1161083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1161086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1161089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161119 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1161122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1161140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161144 */     // GIR_Coverage, 7952,
     /* 1161144 */     GIR_EraseRootFromParent_Done,
     /* 1161145 */   // Label 16926: @1161145
     /* 1161145 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1161229), // Rule ID 7953 //
     /* 1161150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1161153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1161161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1161164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1161167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1161170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1161173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1161206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1161224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161228 */     // GIR_Coverage, 7953,
     /* 1161228 */     GIR_EraseRootFromParent_Done,
     /* 1161229 */   // Label 16927: @1161229
     /* 1161229 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1161313), // Rule ID 7956 //
     /* 1161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1161248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1161254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1161257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1161290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161312 */     // GIR_Coverage, 7956,
     /* 1161312 */     GIR_EraseRootFromParent_Done,
     /* 1161313 */   // Label 16928: @1161313
     /* 1161313 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1161397), // Rule ID 7957 //
     /* 1161318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1161329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1161332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1161338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1161341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161371 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1161374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161396 */     // GIR_Coverage, 7957,
     /* 1161396 */     GIR_EraseRootFromParent_Done,
     /* 1161397 */   // Label 16929: @1161397
     /* 1161397 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1161481), // Rule ID 7960 //
     /* 1161402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1161413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1161416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1161422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1161425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161455 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1161458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161480 */     // GIR_Coverage, 7960,
     /* 1161480 */     GIR_EraseRootFromParent_Done,
     /* 1161481 */   // Label 16930: @1161481
     /* 1161481 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1161565), // Rule ID 7961 //
     /* 1161486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1161497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1161500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1161506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1161509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161539 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1161542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161564 */     // GIR_Coverage, 7961,
     /* 1161564 */     GIR_EraseRootFromParent_Done,
     /* 1161565 */   // Label 16931: @1161565
     /* 1161565 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1161649), // Rule ID 7964 //
     /* 1161570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1161581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1161584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1161590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1161593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161623 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1161626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161648 */     // GIR_Coverage, 7964,
     /* 1161648 */     GIR_EraseRootFromParent_Done,
     /* 1161649 */   // Label 16932: @1161649
     /* 1161649 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1161733), // Rule ID 7965 //
     /* 1161654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1161665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1161668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1161674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1161677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161707 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1161710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161732 */     // GIR_Coverage, 7965,
     /* 1161732 */     GIR_EraseRootFromParent_Done,
     /* 1161733 */   // Label 16933: @1161733
     /* 1161733 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1161817), // Rule ID 7968 //
     /* 1161738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1161749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1161752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1161758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1161761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1161794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161816 */     // GIR_Coverage, 7968,
     /* 1161816 */     GIR_EraseRootFromParent_Done,
     /* 1161817 */   // Label 16934: @1161817
     /* 1161817 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1161901), // Rule ID 7969 //
     /* 1161822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1161833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1161836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1161842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1161845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1161875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1161878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161900 */     // GIR_Coverage, 7969,
     /* 1161900 */     GIR_EraseRootFromParent_Done,
     /* 1161901 */   // Label 16935: @1161901
     /* 1161901 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1161985), // Rule ID 7972 //
     /* 1161906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1161917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1161920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1161926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1161929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1161952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1161959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1161962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1161972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1161983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161984 */     // GIR_Coverage, 7972,
     /* 1161984 */     GIR_EraseRootFromParent_Done,
     /* 1161985 */   // Label 16936: @1161985
     /* 1161985 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1162069), // Rule ID 7973 //
     /* 1161990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1161998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1162001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1162004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1162010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1162013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1162046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162068 */     // GIR_Coverage, 7973,
     /* 1162068 */     GIR_EraseRootFromParent_Done,
     /* 1162069 */   // Label 16937: @1162069
     /* 1162069 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1162153), // Rule ID 7976 //
     /* 1162074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1162085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1162088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1162094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1162097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162127 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1162130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162152 */     // GIR_Coverage, 7976,
     /* 1162152 */     GIR_EraseRootFromParent_Done,
     /* 1162153 */   // Label 16938: @1162153
     /* 1162153 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1162237), // Rule ID 7977 //
     /* 1162158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1162169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1162172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1162178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1162181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1162214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162236 */     // GIR_Coverage, 7977,
     /* 1162236 */     GIR_EraseRootFromParent_Done,
     /* 1162237 */   // Label 16939: @1162237
     /* 1162237 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1162321), // Rule ID 7980 //
     /* 1162242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1162253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1162256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1162262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1162265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1162298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162320 */     // GIR_Coverage, 7980,
     /* 1162320 */     GIR_EraseRootFromParent_Done,
     /* 1162321 */   // Label 16940: @1162321
     /* 1162321 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1162405), // Rule ID 7981 //
     /* 1162326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1162337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1162340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1162346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1162349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162379 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1162382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162404 */     // GIR_Coverage, 7981,
     /* 1162404 */     GIR_EraseRootFromParent_Done,
     /* 1162405 */   // Label 16941: @1162405
     /* 1162405 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1162489), // Rule ID 7984 //
     /* 1162410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1162421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1162424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1162430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1162433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1162466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162488 */     // GIR_Coverage, 7984,
     /* 1162488 */     GIR_EraseRootFromParent_Done,
     /* 1162489 */   // Label 16942: @1162489
     /* 1162489 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1162573), // Rule ID 7985 //
     /* 1162494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1162508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1162514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1162517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1162550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162572 */     // GIR_Coverage, 7985,
     /* 1162572 */     GIR_EraseRootFromParent_Done,
     /* 1162573 */   // Label 16943: @1162573
     /* 1162573 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1162657), // Rule ID 7988 //
     /* 1162578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1162589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1162592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1162598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1162601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162631 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1162634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162656 */     // GIR_Coverage, 7988,
     /* 1162656 */     GIR_EraseRootFromParent_Done,
     /* 1162657 */   // Label 16944: @1162657
     /* 1162657 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1162741), // Rule ID 7989 //
     /* 1162662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1162673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1162676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1162682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1162685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162715 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1162718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162740 */     // GIR_Coverage, 7989,
     /* 1162740 */     GIR_EraseRootFromParent_Done,
     /* 1162741 */   // Label 16945: @1162741
     /* 1162741 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1162825), // Rule ID 7992 //
     /* 1162746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1162749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1162757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1162760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1162769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162799 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1162802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162824 */     // GIR_Coverage, 7992,
     /* 1162824 */     GIR_EraseRootFromParent_Done,
     /* 1162825 */   // Label 16946: @1162825
     /* 1162825 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1162909), // Rule ID 7993 //
     /* 1162830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1162833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1162841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1162844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1162853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162883 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1162883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1162886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162908 */     // GIR_Coverage, 7993,
     /* 1162908 */     GIR_EraseRootFromParent_Done,
     /* 1162909 */   // Label 16947: @1162909
     /* 1162909 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1162993), // Rule ID 7996 //
     /* 1162914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1162917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1162922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1162925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1162928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1162931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1162934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1162937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1162960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1162967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1162970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1162980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1162991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162992 */     // GIR_Coverage, 7996,
     /* 1162992 */     GIR_EraseRootFromParent_Done,
     /* 1162993 */   // Label 16948: @1162993
     /* 1162993 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1163077), // Rule ID 7997 //
     /* 1162998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1163001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1163009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1163012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1163021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163051 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1163054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163076 */     // GIR_Coverage, 7997,
     /* 1163076 */     GIR_EraseRootFromParent_Done,
     /* 1163077 */   // Label 16949: @1163077
     /* 1163077 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1163161), // Rule ID 8000 //
     /* 1163082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1163085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1163093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1163096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1163105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163135 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1163138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163160 */     // GIR_Coverage, 8000,
     /* 1163160 */     GIR_EraseRootFromParent_Done,
     /* 1163161 */   // Label 16950: @1163161
     /* 1163161 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1163245), // Rule ID 8001 //
     /* 1163166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1163169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1163177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1163180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1163189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1163222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163244 */     // GIR_Coverage, 8001,
     /* 1163244 */     GIR_EraseRootFromParent_Done,
     /* 1163245 */   // Label 16951: @1163245
     /* 1163245 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1163329), // Rule ID 8004 //
     /* 1163250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1163261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1163264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1163273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163303 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1163306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163328 */     // GIR_Coverage, 8004,
     /* 1163328 */     GIR_EraseRootFromParent_Done,
     /* 1163329 */   // Label 16952: @1163329
     /* 1163329 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1163413), // Rule ID 8005 //
     /* 1163334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1163345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1163348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1163357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1163390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163412 */     // GIR_Coverage, 8005,
     /* 1163412 */     GIR_EraseRootFromParent_Done,
     /* 1163413 */   // Label 16953: @1163413
     /* 1163413 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1163497), // Rule ID 8008 //
     /* 1163418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1163429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1163432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1163441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163471 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1163474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163496 */     // GIR_Coverage, 8008,
     /* 1163496 */     GIR_EraseRootFromParent_Done,
     /* 1163497 */   // Label 16954: @1163497
     /* 1163497 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1163581), // Rule ID 8009 //
     /* 1163502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1163513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1163516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1163525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1163558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163580 */     // GIR_Coverage, 8009,
     /* 1163580 */     GIR_EraseRootFromParent_Done,
     /* 1163581 */   // Label 16955: @1163581
     /* 1163581 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1163665), // Rule ID 8012 //
     /* 1163586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1163597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1163600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1163603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1163609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163639 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1163642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163664 */     // GIR_Coverage, 8012,
     /* 1163664 */     GIR_EraseRootFromParent_Done,
     /* 1163665 */   // Label 16956: @1163665
     /* 1163665 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1163749), // Rule ID 8013 //
     /* 1163670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1163681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1163684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1163687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1163693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163723 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1163726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163748 */     // GIR_Coverage, 8013,
     /* 1163748 */     GIR_EraseRootFromParent_Done,
     /* 1163749 */   // Label 16957: @1163749
     /* 1163749 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1163833), // Rule ID 8016 //
     /* 1163754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1163765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1163768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1163771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1163777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163807 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1163810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163832 */     // GIR_Coverage, 8016,
     /* 1163832 */     GIR_EraseRootFromParent_Done,
     /* 1163833 */   // Label 16958: @1163833
     /* 1163833 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1163917), // Rule ID 8017 //
     /* 1163838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1163849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1163852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1163855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1163861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163891 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1163891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1163894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163916 */     // GIR_Coverage, 8017,
     /* 1163916 */     GIR_EraseRootFromParent_Done,
     /* 1163917 */   // Label 16959: @1163917
     /* 1163917 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1164001), // Rule ID 8020 //
     /* 1163922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1163930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1163933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1163936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1163939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1163945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1163968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1163975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1163978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1163988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1163999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164000 */     // GIR_Coverage, 8020,
     /* 1164000 */     GIR_EraseRootFromParent_Done,
     /* 1164001 */   // Label 16960: @1164001
     /* 1164001 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1164085), // Rule ID 8021 //
     /* 1164006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1164017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1164020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1164029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1164062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164084 */     // GIR_Coverage, 8021,
     /* 1164084 */     GIR_EraseRootFromParent_Done,
     /* 1164085 */   // Label 16961: @1164085
     /* 1164085 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1164169), // Rule ID 8024 //
     /* 1164090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1164101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1164104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1164113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164143 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1164146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164168 */     // GIR_Coverage, 8024,
     /* 1164168 */     GIR_EraseRootFromParent_Done,
     /* 1164169 */   // Label 16962: @1164169
     /* 1164169 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1164253), // Rule ID 8025 //
     /* 1164174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1164185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1164188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1164197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1164230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164252 */     // GIR_Coverage, 8025,
     /* 1164252 */     GIR_EraseRootFromParent_Done,
     /* 1164253 */   // Label 16963: @1164253
     /* 1164253 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1164337), // Rule ID 8028 //
     /* 1164258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1164269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1164272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1164281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164336 */     // GIR_Coverage, 8028,
     /* 1164336 */     GIR_EraseRootFromParent_Done,
     /* 1164337 */   // Label 16964: @1164337
     /* 1164337 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1164421), // Rule ID 8029 //
     /* 1164342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1164353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1164356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1164365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164420 */     // GIR_Coverage, 8029,
     /* 1164420 */     GIR_EraseRootFromParent_Done,
     /* 1164421 */   // Label 16965: @1164421
     /* 1164421 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1164505), // Rule ID 8032 //
     /* 1164426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1164437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1164440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1164449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164479 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164504 */     // GIR_Coverage, 8032,
     /* 1164504 */     GIR_EraseRootFromParent_Done,
     /* 1164505 */   // Label 16966: @1164505
     /* 1164505 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1164589), // Rule ID 8033 //
     /* 1164510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1164521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1164524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1164533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164588 */     // GIR_Coverage, 8033,
     /* 1164588 */     GIR_EraseRootFromParent_Done,
     /* 1164589 */   // Label 16967: @1164589
     /* 1164589 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1164673), // Rule ID 8036 //
     /* 1164594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1164605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1164608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1164611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1164617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164672 */     // GIR_Coverage, 8036,
     /* 1164672 */     GIR_EraseRootFromParent_Done,
     /* 1164673 */   // Label 16968: @1164673
     /* 1164673 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1164757), // Rule ID 8037 //
     /* 1164678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1164689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1164692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1164695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1164701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164731 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164756 */     // GIR_Coverage, 8037,
     /* 1164756 */     GIR_EraseRootFromParent_Done,
     /* 1164757 */   // Label 16969: @1164757
     /* 1164757 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1164841), // Rule ID 8040 //
     /* 1164762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1164765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1164773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1164776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1164779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1164785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164815 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164840 */     // GIR_Coverage, 8040,
     /* 1164840 */     GIR_EraseRootFromParent_Done,
     /* 1164841 */   // Label 16970: @1164841
     /* 1164841 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1164925), // Rule ID 8041 //
     /* 1164846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1164849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1164857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1164860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1164863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1164869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164899 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1164899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1164902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1164923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164924 */     // GIR_Coverage, 8041,
     /* 1164924 */     GIR_EraseRootFromParent_Done,
     /* 1164925 */   // Label 16971: @1164925
     /* 1164925 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1165009), // Rule ID 8044 //
     /* 1164930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1164938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1164941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1164944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1164947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1164953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1164976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1164983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1164986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1164996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165008 */     // GIR_Coverage, 8044,
     /* 1165008 */     GIR_EraseRootFromParent_Done,
     /* 1165009 */   // Label 16972: @1165009
     /* 1165009 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1165093), // Rule ID 8045 //
     /* 1165014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1165025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1165028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1165037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1165070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165092 */     // GIR_Coverage, 8045,
     /* 1165092 */     GIR_EraseRootFromParent_Done,
     /* 1165093 */   // Label 16973: @1165093
     /* 1165093 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1165177), // Rule ID 8048 //
     /* 1165098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1165109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1165112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1165121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165151 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1165154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165176 */     // GIR_Coverage, 8048,
     /* 1165176 */     GIR_EraseRootFromParent_Done,
     /* 1165177 */   // Label 16974: @1165177
     /* 1165177 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1165261), // Rule ID 8049 //
     /* 1165182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1165193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1165196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1165205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165235 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1165238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165260 */     // GIR_Coverage, 8049,
     /* 1165260 */     GIR_EraseRootFromParent_Done,
     /* 1165261 */   // Label 16975: @1165261
     /* 1165261 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1165345), // Rule ID 8052 //
     /* 1165266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1165277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1165280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1165289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165319 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1165322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165344 */     // GIR_Coverage, 8052,
     /* 1165344 */     GIR_EraseRootFromParent_Done,
     /* 1165345 */   // Label 16976: @1165345
     /* 1165345 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1165429), // Rule ID 8053 //
     /* 1165350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1165361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1165364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1165373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165403 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1165406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165428 */     // GIR_Coverage, 8053,
     /* 1165428 */     GIR_EraseRootFromParent_Done,
     /* 1165429 */   // Label 16977: @1165429
     /* 1165429 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1165513), // Rule ID 8056 //
     /* 1165434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1165445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1165448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1165457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1165490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165512 */     // GIR_Coverage, 8056,
     /* 1165512 */     GIR_EraseRootFromParent_Done,
     /* 1165513 */   // Label 16978: @1165513
     /* 1165513 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1165597), // Rule ID 8057 //
     /* 1165518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1165529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1165532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1165541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1165574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165596 */     // GIR_Coverage, 8057,
     /* 1165596 */     GIR_EraseRootFromParent_Done,
     /* 1165597 */   // Label 16979: @1165597
     /* 1165597 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1165681), // Rule ID 8060 //
     /* 1165602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1165613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1165616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1165625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165655 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1165658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165680 */     // GIR_Coverage, 8060,
     /* 1165680 */     GIR_EraseRootFromParent_Done,
     /* 1165681 */   // Label 16980: @1165681
     /* 1165681 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1165765), // Rule ID 8061 //
     /* 1165686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1165697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1165700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1165709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1165742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165764 */     // GIR_Coverage, 8061,
     /* 1165764 */     GIR_EraseRootFromParent_Done,
     /* 1165765 */   // Label 16981: @1165765
     /* 1165765 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1165849), // Rule ID 8064 //
     /* 1165770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1165781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1165784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1165787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1165793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165823 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1165826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165848 */     // GIR_Coverage, 8064,
     /* 1165848 */     GIR_EraseRootFromParent_Done,
     /* 1165849 */   // Label 16982: @1165849
     /* 1165849 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1165933), // Rule ID 8065 //
     /* 1165854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1165865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1165868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1165871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1165877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165907 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1165907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1165910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1165920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1165931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165932 */     // GIR_Coverage, 8065,
     /* 1165932 */     GIR_EraseRootFromParent_Done,
     /* 1165933 */   // Label 16983: @1165933
     /* 1165933 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1166017), // Rule ID 8068 //
     /* 1165938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1165946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1165949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1165952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1165955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1165961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1165984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165991 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1165991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1165994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166016 */     // GIR_Coverage, 8068,
     /* 1166016 */     GIR_EraseRootFromParent_Done,
     /* 1166017 */   // Label 16984: @1166017
     /* 1166017 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1166101), // Rule ID 8069 //
     /* 1166022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1166033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1166036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1166045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1166078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166100 */     // GIR_Coverage, 8069,
     /* 1166100 */     GIR_EraseRootFromParent_Done,
     /* 1166101 */   // Label 16985: @1166101
     /* 1166101 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1166185), // Rule ID 8072 //
     /* 1166106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1166117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1166120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1166129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166159 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1166162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166184 */     // GIR_Coverage, 8072,
     /* 1166184 */     GIR_EraseRootFromParent_Done,
     /* 1166185 */   // Label 16986: @1166185
     /* 1166185 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1166269), // Rule ID 8073 //
     /* 1166190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1166201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1166204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1166213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166243 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1166246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166268 */     // GIR_Coverage, 8073,
     /* 1166268 */     GIR_EraseRootFromParent_Done,
     /* 1166269 */   // Label 16987: @1166269
     /* 1166269 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1166353), // Rule ID 8076 //
     /* 1166274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1166285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1166288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1166297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166327 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1166330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166352 */     // GIR_Coverage, 8076,
     /* 1166352 */     GIR_EraseRootFromParent_Done,
     /* 1166353 */   // Label 16988: @1166353
     /* 1166353 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1166437), // Rule ID 8077 //
     /* 1166358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1166369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1166372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1166381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166411 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1166414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166436 */     // GIR_Coverage, 8077,
     /* 1166436 */     GIR_EraseRootFromParent_Done,
     /* 1166437 */   // Label 16989: @1166437
     /* 1166437 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1166521), // Rule ID 8080 //
     /* 1166442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1166453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1166456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1166465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166495 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1166498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166520 */     // GIR_Coverage, 8080,
     /* 1166520 */     GIR_EraseRootFromParent_Done,
     /* 1166521 */   // Label 16990: @1166521
     /* 1166521 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1166605), // Rule ID 8081 //
     /* 1166526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1166537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1166540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1166549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1166582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166604 */     // GIR_Coverage, 8081,
     /* 1166604 */     GIR_EraseRootFromParent_Done,
     /* 1166605 */   // Label 16991: @1166605
     /* 1166605 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1166689), // Rule ID 8084 //
     /* 1166610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1166621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1166624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1166633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166663 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1166666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166688 */     // GIR_Coverage, 8084,
     /* 1166688 */     GIR_EraseRootFromParent_Done,
     /* 1166689 */   // Label 16992: @1166689
     /* 1166689 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1166773), // Rule ID 8085 //
     /* 1166694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1166705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1166708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1166717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166747 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1166750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166772 */     // GIR_Coverage, 8085,
     /* 1166772 */     GIR_EraseRootFromParent_Done,
     /* 1166773 */   // Label 16993: @1166773
     /* 1166773 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1166857), // Rule ID 8088 //
     /* 1166778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1166789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1166792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1166795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1166801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1166834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166856 */     // GIR_Coverage, 8088,
     /* 1166856 */     GIR_EraseRootFromParent_Done,
     /* 1166857 */   // Label 16994: @1166857
     /* 1166857 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1166941), // Rule ID 8089 //
     /* 1166862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1166870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1166873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1166876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1166879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1166885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1166915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1166918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1166928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1166939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166940 */     // GIR_Coverage, 8089,
     /* 1166940 */     GIR_EraseRootFromParent_Done,
     /* 1166941 */   // Label 16995: @1166941
     /* 1166941 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1167025), // Rule ID 8180 //
     /* 1166946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1166954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1166957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1166960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1166963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1166966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1166969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1166992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1166999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1167002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167024 */     // GIR_Coverage, 8180,
     /* 1167024 */     GIR_EraseRootFromParent_Done,
     /* 1167025 */   // Label 16996: @1167025
     /* 1167025 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1167109), // Rule ID 8181 //
     /* 1167030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1167041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1167044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1167050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1167053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167083 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1167086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167108 */     // GIR_Coverage, 8181,
     /* 1167108 */     GIR_EraseRootFromParent_Done,
     /* 1167109 */   // Label 16997: @1167109
     /* 1167109 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1167193), // Rule ID 8184 //
     /* 1167114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1167125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1167128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1167134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1167137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167167 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1167167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1167170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167192 */     // GIR_Coverage, 8184,
     /* 1167192 */     GIR_EraseRootFromParent_Done,
     /* 1167193 */   // Label 16998: @1167193
     /* 1167193 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1167277), // Rule ID 8185 //
     /* 1167198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1167209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1167212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1167218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1167221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167251 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1167254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167276 */     // GIR_Coverage, 8185,
     /* 1167276 */     GIR_EraseRootFromParent_Done,
     /* 1167277 */   // Label 16999: @1167277
     /* 1167277 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1167361), // Rule ID 8188 //
     /* 1167282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1167293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1167296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1167302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1167305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167335 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1167335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167360 */     // GIR_Coverage, 8188,
     /* 1167360 */     GIR_EraseRootFromParent_Done,
     /* 1167361 */   // Label 17000: @1167361
     /* 1167361 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1167445), // Rule ID 8189 //
     /* 1167366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1167377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1167380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1167386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1167389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167419 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167444 */     // GIR_Coverage, 8189,
     /* 1167444 */     GIR_EraseRootFromParent_Done,
     /* 1167445 */   // Label 17001: @1167445
     /* 1167445 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1167529), // Rule ID 8192 //
     /* 1167450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1167461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1167464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1167467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1167470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1167473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167503 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1167503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1167506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167528 */     // GIR_Coverage, 8192,
     /* 1167528 */     GIR_EraseRootFromParent_Done,
     /* 1167529 */   // Label 17002: @1167529
     /* 1167529 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1167613), // Rule ID 8193 //
     /* 1167534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1167545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1167548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1167551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1167554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1167557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1167590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167612 */     // GIR_Coverage, 8193,
     /* 1167612 */     GIR_EraseRootFromParent_Done,
     /* 1167613 */   // Label 17003: @1167613
     /* 1167613 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1167697), // Rule ID 8196 //
     /* 1167618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1167629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1167632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1167635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1167638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1167641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167671 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1167671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167696 */     // GIR_Coverage, 8196,
     /* 1167696 */     GIR_EraseRootFromParent_Done,
     /* 1167697 */   // Label 17004: @1167697
     /* 1167697 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1167781), // Rule ID 8197 //
     /* 1167702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1167713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1167716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1167719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1167722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1167725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167780 */     // GIR_Coverage, 8197,
     /* 1167780 */     GIR_EraseRootFromParent_Done,
     /* 1167781 */   // Label 17005: @1167781
     /* 1167781 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1167865), // Rule ID 8200 //
     /* 1167786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1167797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1167800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1167803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1167806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1167809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167839 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1167839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167864 */     // GIR_Coverage, 8200,
     /* 1167864 */     GIR_EraseRootFromParent_Done,
     /* 1167865 */   // Label 17006: @1167865
     /* 1167865 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1167949), // Rule ID 8201 //
     /* 1167870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1167881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1167884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1167887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1167890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1167893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1167916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167923 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1167923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1167926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1167936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1167947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167948 */     // GIR_Coverage, 8201,
     /* 1167948 */     GIR_EraseRootFromParent_Done,
     /* 1167949 */   // Label 17007: @1167949
     /* 1167949 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1168033), // Rule ID 8204 //
     /* 1167954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1167962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1167965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1167968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1167971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1167974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1167977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168032 */     // GIR_Coverage, 8204,
     /* 1168032 */     GIR_EraseRootFromParent_Done,
     /* 1168033 */   // Label 17008: @1168033
     /* 1168033 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1168117), // Rule ID 8205 //
     /* 1168038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1168049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1168052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1168058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1168061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168116 */     // GIR_Coverage, 8205,
     /* 1168116 */     GIR_EraseRootFromParent_Done,
     /* 1168117 */   // Label 17009: @1168117
     /* 1168117 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1168201), // Rule ID 8208 //
     /* 1168122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1168133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1168136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1168142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1168145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168175 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168200 */     // GIR_Coverage, 8208,
     /* 1168200 */     GIR_EraseRootFromParent_Done,
     /* 1168201 */   // Label 17010: @1168201
     /* 1168201 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1168285), // Rule ID 8209 //
     /* 1168206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1168217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1168220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1168226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1168229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168259 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168284 */     // GIR_Coverage, 8209,
     /* 1168284 */     GIR_EraseRootFromParent_Done,
     /* 1168285 */   // Label 17011: @1168285
     /* 1168285 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1168369), // Rule ID 8212 //
     /* 1168290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1168301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1168304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1168310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1168313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168343 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168368 */     // GIR_Coverage, 8212,
     /* 1168368 */     GIR_EraseRootFromParent_Done,
     /* 1168369 */   // Label 17012: @1168369
     /* 1168369 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1168453), // Rule ID 8213 //
     /* 1168374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1168385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1168388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1168394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1168397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168452 */     // GIR_Coverage, 8213,
     /* 1168452 */     GIR_EraseRootFromParent_Done,
     /* 1168453 */   // Label 17013: @1168453
     /* 1168453 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1168537), // Rule ID 8216 //
     /* 1168458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1168461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1168469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1168472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1168475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1168478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1168481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168511 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168536 */     // GIR_Coverage, 8216,
     /* 1168536 */     GIR_EraseRootFromParent_Done,
     /* 1168537 */   // Label 17014: @1168537
     /* 1168537 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1168621), // Rule ID 8217 //
     /* 1168542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1168545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1168553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1168556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1168559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1168562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1168565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1168598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168620 */     // GIR_Coverage, 8217,
     /* 1168620 */     GIR_EraseRootFromParent_Done,
     /* 1168621 */   // Label 17015: @1168621
     /* 1168621 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1168705), // Rule ID 8220 //
     /* 1168626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1168637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1168640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1168646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1168649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1168682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168704 */     // GIR_Coverage, 8220,
     /* 1168704 */     GIR_EraseRootFromParent_Done,
     /* 1168705 */   // Label 17016: @1168705
     /* 1168705 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1168789), // Rule ID 8221 //
     /* 1168710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1168721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1168724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1168730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1168733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168763 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1168766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168788 */     // GIR_Coverage, 8221,
     /* 1168788 */     GIR_EraseRootFromParent_Done,
     /* 1168789 */   // Label 17017: @1168789
     /* 1168789 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1168873), // Rule ID 8224 //
     /* 1168794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1168805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1168808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1168811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1168814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1168817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168847 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1168847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1168850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168872 */     // GIR_Coverage, 8224,
     /* 1168872 */     GIR_EraseRootFromParent_Done,
     /* 1168873 */   // Label 17018: @1168873
     /* 1168873 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1168957), // Rule ID 8225 //
     /* 1168878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1168889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1168892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1168895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1168898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1168901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1168924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168931 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1168931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1168934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1168944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1168955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168956 */     // GIR_Coverage, 8225,
     /* 1168956 */     GIR_EraseRootFromParent_Done,
     /* 1168957 */   // Label 17019: @1168957
     /* 1168957 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1169041), // Rule ID 8228 //
     /* 1168962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1168970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1168973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1168976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1168979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1168982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1168985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169015 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1169018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169040 */     // GIR_Coverage, 8228,
     /* 1169040 */     GIR_EraseRootFromParent_Done,
     /* 1169041 */   // Label 17020: @1169041
     /* 1169041 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1169125), // Rule ID 8229 //
     /* 1169046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1169057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1169060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1169066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1169069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169099 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1169102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169124 */     // GIR_Coverage, 8229,
     /* 1169124 */     GIR_EraseRootFromParent_Done,
     /* 1169125 */   // Label 17021: @1169125
     /* 1169125 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1169209), // Rule ID 8232 //
     /* 1169130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1169141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1169144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1169150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1169153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169183 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1169186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169208 */     // GIR_Coverage, 8232,
     /* 1169208 */     GIR_EraseRootFromParent_Done,
     /* 1169209 */   // Label 17022: @1169209
     /* 1169209 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1169293), // Rule ID 8233 //
     /* 1169214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1169225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1169228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1169234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1169237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1169270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169292 */     // GIR_Coverage, 8233,
     /* 1169292 */     GIR_EraseRootFromParent_Done,
     /* 1169293 */   // Label 17023: @1169293
     /* 1169293 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1169377), // Rule ID 8236 //
     /* 1169298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1169309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1169312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1169318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1169321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169351 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1169354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169376 */     // GIR_Coverage, 8236,
     /* 1169376 */     GIR_EraseRootFromParent_Done,
     /* 1169377 */   // Label 17024: @1169377
     /* 1169377 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1169461), // Rule ID 8237 //
     /* 1169382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1169393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1169396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1169402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1169405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1169438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169460 */     // GIR_Coverage, 8237,
     /* 1169460 */     GIR_EraseRootFromParent_Done,
     /* 1169461 */   // Label 17025: @1169461
     /* 1169461 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1169545), // Rule ID 8240 //
     /* 1169466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1169477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1169480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1169483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1169486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1169489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169519 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1169522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169544 */     // GIR_Coverage, 8240,
     /* 1169544 */     GIR_EraseRootFromParent_Done,
     /* 1169545 */   // Label 17026: @1169545
     /* 1169545 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1169629), // Rule ID 8241 //
     /* 1169550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1169561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1169564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1169567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1169570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1169573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169603 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1169606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169628 */     // GIR_Coverage, 8241,
     /* 1169628 */     GIR_EraseRootFromParent_Done,
     /* 1169629 */   // Label 17027: @1169629
     /* 1169629 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1169713), // Rule ID 8244 //
     /* 1169634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1169645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1169648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1169654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1169657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169687 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1169690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169712 */     // GIR_Coverage, 8244,
     /* 1169712 */     GIR_EraseRootFromParent_Done,
     /* 1169713 */   // Label 17028: @1169713
     /* 1169713 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1169797), // Rule ID 8245 //
     /* 1169718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1169729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1169732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1169738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1169741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169771 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1169774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169796 */     // GIR_Coverage, 8245,
     /* 1169796 */     GIR_EraseRootFromParent_Done,
     /* 1169797 */   // Label 17029: @1169797
     /* 1169797 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1169881), // Rule ID 8248 //
     /* 1169802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1169813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1169816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1169819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1169822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1169825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1169855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1169858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169880 */     // GIR_Coverage, 8248,
     /* 1169880 */     GIR_EraseRootFromParent_Done,
     /* 1169881 */   // Label 17030: @1169881
     /* 1169881 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1169965), // Rule ID 8249 //
     /* 1169886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1169897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1169900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1169903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1169906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1169909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1169932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169939 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1169939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1169942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1169952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1169963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169964 */     // GIR_Coverage, 8249,
     /* 1169964 */     GIR_EraseRootFromParent_Done,
     /* 1169965 */   // Label 17031: @1169965
     /* 1169965 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1170049), // Rule ID 8252 //
     /* 1169970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1169978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1169981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1169984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1169987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1169990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1169993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170023 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1170026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170048 */     // GIR_Coverage, 8252,
     /* 1170048 */     GIR_EraseRootFromParent_Done,
     /* 1170049 */   // Label 17032: @1170049
     /* 1170049 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1170133), // Rule ID 8253 //
     /* 1170054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1170065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1170068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1170074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1170077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1170110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170132 */     // GIR_Coverage, 8253,
     /* 1170132 */     GIR_EraseRootFromParent_Done,
     /* 1170133 */   // Label 17033: @1170133
     /* 1170133 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1170217), // Rule ID 8256 //
     /* 1170138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1170149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1170152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1170158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1170161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1170194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170216 */     // GIR_Coverage, 8256,
     /* 1170216 */     GIR_EraseRootFromParent_Done,
     /* 1170217 */   // Label 17034: @1170217
     /* 1170217 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1170301), // Rule ID 8257 //
     /* 1170222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1170233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1170236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1170242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1170245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170275 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1170278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170300 */     // GIR_Coverage, 8257,
     /* 1170300 */     GIR_EraseRootFromParent_Done,
     /* 1170301 */   // Label 17035: @1170301
     /* 1170301 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1170385), // Rule ID 8260 //
     /* 1170306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1170317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1170320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1170326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1170329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1170362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170384 */     // GIR_Coverage, 8260,
     /* 1170384 */     GIR_EraseRootFromParent_Done,
     /* 1170385 */   // Label 17036: @1170385
     /* 1170385 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1170469), // Rule ID 8261 //
     /* 1170390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1170401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1170404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1170410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1170413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1170446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170468 */     // GIR_Coverage, 8261,
     /* 1170468 */     GIR_EraseRootFromParent_Done,
     /* 1170469 */   // Label 17037: @1170469
     /* 1170469 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1170553), // Rule ID 8264 //
     /* 1170474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1170485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1170488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1170494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1170497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1170530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170552 */     // GIR_Coverage, 8264,
     /* 1170552 */     GIR_EraseRootFromParent_Done,
     /* 1170553 */   // Label 17038: @1170553
     /* 1170553 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1170637), // Rule ID 8265 //
     /* 1170558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1170569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1170572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1170578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1170581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1170614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170636 */     // GIR_Coverage, 8265,
     /* 1170636 */     GIR_EraseRootFromParent_Done,
     /* 1170637 */   // Label 17039: @1170637
     /* 1170637 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1170721), // Rule ID 8268 //
     /* 1170642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1170653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1170656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1170659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1170665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170695 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1170698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170720 */     // GIR_Coverage, 8268,
     /* 1170720 */     GIR_EraseRootFromParent_Done,
     /* 1170721 */   // Label 17040: @1170721
     /* 1170721 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1170805), // Rule ID 8269 //
     /* 1170726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1170737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1170740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1170743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1170749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170779 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1170782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170804 */     // GIR_Coverage, 8269,
     /* 1170804 */     GIR_EraseRootFromParent_Done,
     /* 1170805 */   // Label 17041: @1170805
     /* 1170805 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1170889), // Rule ID 8272 //
     /* 1170810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1170821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1170824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1170827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1170833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170863 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1170863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1170866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170888 */     // GIR_Coverage, 8272,
     /* 1170888 */     GIR_EraseRootFromParent_Done,
     /* 1170889 */   // Label 17042: @1170889
     /* 1170889 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1170973), // Rule ID 8273 //
     /* 1170894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1170905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1170908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1170911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1170917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1170940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170947 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1170947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1170950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1170960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1170971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170972 */     // GIR_Coverage, 8273,
     /* 1170972 */     GIR_EraseRootFromParent_Done,
     /* 1170973 */   // Label 17043: @1170973
     /* 1170973 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1171057), // Rule ID 8276 //
     /* 1170978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1170986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1170989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1170992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1170995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1171001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171031 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171056 */     // GIR_Coverage, 8276,
     /* 1171056 */     GIR_EraseRootFromParent_Done,
     /* 1171057 */   // Label 17044: @1171057
     /* 1171057 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1171141), // Rule ID 8277 //
     /* 1171062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1171073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1171076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1171085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171140 */     // GIR_Coverage, 8277,
     /* 1171140 */     GIR_EraseRootFromParent_Done,
     /* 1171141 */   // Label 17045: @1171141
     /* 1171141 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1171225), // Rule ID 8280 //
     /* 1171146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1171157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1171160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1171169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1171202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171224 */     // GIR_Coverage, 8280,
     /* 1171224 */     GIR_EraseRootFromParent_Done,
     /* 1171225 */   // Label 17046: @1171225
     /* 1171225 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1171309), // Rule ID 8281 //
     /* 1171230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1171241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1171244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1171253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1171286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171308 */     // GIR_Coverage, 8281,
     /* 1171308 */     GIR_EraseRootFromParent_Done,
     /* 1171309 */   // Label 17047: @1171309
     /* 1171309 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1171393), // Rule ID 8284 //
     /* 1171314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1171325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1171328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1171337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171367 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171392 */     // GIR_Coverage, 8284,
     /* 1171392 */     GIR_EraseRootFromParent_Done,
     /* 1171393 */   // Label 17048: @1171393
     /* 1171393 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1171477), // Rule ID 8285 //
     /* 1171398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1171409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1171412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1171421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171451 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171476 */     // GIR_Coverage, 8285,
     /* 1171476 */     GIR_EraseRootFromParent_Done,
     /* 1171477 */   // Label 17049: @1171477
     /* 1171477 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1171561), // Rule ID 8288 //
     /* 1171482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1171493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1171496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1171505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171535 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171560 */     // GIR_Coverage, 8288,
     /* 1171560 */     GIR_EraseRootFromParent_Done,
     /* 1171561 */   // Label 17050: @1171561
     /* 1171561 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1171645), // Rule ID 8289 //
     /* 1171566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1171577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1171580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1171589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171619 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1171622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171644 */     // GIR_Coverage, 8289,
     /* 1171644 */     GIR_EraseRootFromParent_Done,
     /* 1171645 */   // Label 17051: @1171645
     /* 1171645 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1171729), // Rule ID 8292 //
     /* 1171650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1171661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1171664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1171667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1171673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171703 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1171706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171728 */     // GIR_Coverage, 8292,
     /* 1171728 */     GIR_EraseRootFromParent_Done,
     /* 1171729 */   // Label 17052: @1171729
     /* 1171729 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1171813), // Rule ID 8293 //
     /* 1171734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1171745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1171748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1171751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1171757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171787 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1171790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171812 */     // GIR_Coverage, 8293,
     /* 1171812 */     GIR_EraseRootFromParent_Done,
     /* 1171813 */   // Label 17053: @1171813
     /* 1171813 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1171897), // Rule ID 8296 //
     /* 1171818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1171829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1171832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1171835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1171841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171871 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1171871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1171874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171896 */     // GIR_Coverage, 8296,
     /* 1171896 */     GIR_EraseRootFromParent_Done,
     /* 1171897 */   // Label 17054: @1171897
     /* 1171897 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1171981), // Rule ID 8297 //
     /* 1171902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1171913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1171916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1171919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1171925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1171948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1171955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1171958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1171968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1171979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171980 */     // GIR_Coverage, 8297,
     /* 1171980 */     GIR_EraseRootFromParent_Done,
     /* 1171981 */   // Label 17055: @1171981
     /* 1171981 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1172065), // Rule ID 8300 //
     /* 1171986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1171994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1171997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1172000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1172009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1172042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172064 */     // GIR_Coverage, 8300,
     /* 1172064 */     GIR_EraseRootFromParent_Done,
     /* 1172065 */   // Label 17056: @1172065
     /* 1172065 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1172149), // Rule ID 8301 //
     /* 1172070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1172081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1172084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1172093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172123 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1172126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172148 */     // GIR_Coverage, 8301,
     /* 1172148 */     GIR_EraseRootFromParent_Done,
     /* 1172149 */   // Label 17057: @1172149
     /* 1172149 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1172233), // Rule ID 8304 //
     /* 1172154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1172157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1172165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1172168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1172177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172207 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172232 */     // GIR_Coverage, 8304,
     /* 1172232 */     GIR_EraseRootFromParent_Done,
     /* 1172233 */   // Label 17058: @1172233
     /* 1172233 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1172317), // Rule ID 8305 //
     /* 1172238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1172241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1172249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1172252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1172261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172291 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1172294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172316 */     // GIR_Coverage, 8305,
     /* 1172316 */     GIR_EraseRootFromParent_Done,
     /* 1172317 */   // Label 17059: @1172317
     /* 1172317 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1172401), // Rule ID 8308 //
     /* 1172322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1172333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1172336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1172345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172375 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1172378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172400 */     // GIR_Coverage, 8308,
     /* 1172400 */     GIR_EraseRootFromParent_Done,
     /* 1172401 */   // Label 17060: @1172401
     /* 1172401 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1172485), // Rule ID 8309 //
     /* 1172406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1172417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1172420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1172429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172459 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1172462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172484 */     // GIR_Coverage, 8309,
     /* 1172484 */     GIR_EraseRootFromParent_Done,
     /* 1172485 */   // Label 17061: @1172485
     /* 1172485 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1172569), // Rule ID 8312 //
     /* 1172490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1172501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1172504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1172513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172543 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1172546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172568 */     // GIR_Coverage, 8312,
     /* 1172568 */     GIR_EraseRootFromParent_Done,
     /* 1172569 */   // Label 17062: @1172569
     /* 1172569 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1172653), // Rule ID 8313 //
     /* 1172574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1172585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1172588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1172597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172627 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1172630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172652 */     // GIR_Coverage, 8313,
     /* 1172652 */     GIR_EraseRootFromParent_Done,
     /* 1172653 */   // Label 17063: @1172653
     /* 1172653 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1172737), // Rule ID 8316 //
     /* 1172658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1172669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1172672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1172675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1172681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172711 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1172714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172736 */     // GIR_Coverage, 8316,
     /* 1172736 */     GIR_EraseRootFromParent_Done,
     /* 1172737 */   // Label 17064: @1172737
     /* 1172737 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1172821), // Rule ID 8317 //
     /* 1172742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1172753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1172756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1172759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1172765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172795 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1172798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172820 */     // GIR_Coverage, 8317,
     /* 1172820 */     GIR_EraseRootFromParent_Done,
     /* 1172821 */   // Label 17065: @1172821
     /* 1172821 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1172905), // Rule ID 8320 //
     /* 1172826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1172837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1172840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1172849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1172879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1172882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172904 */     // GIR_Coverage, 8320,
     /* 1172904 */     GIR_EraseRootFromParent_Done,
     /* 1172905 */   // Label 17066: @1172905
     /* 1172905 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1172989), // Rule ID 8321 //
     /* 1172910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1172918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1172921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1172924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1172933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1172956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172963 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1172963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1172966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1172976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1172987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172988 */     // GIR_Coverage, 8321,
     /* 1172988 */     GIR_EraseRootFromParent_Done,
     /* 1172989 */   // Label 17067: @1172989
     /* 1172989 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1173073), // Rule ID 8324 //
     /* 1172994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1173005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1173008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1173017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173047 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1173050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173072 */     // GIR_Coverage, 8324,
     /* 1173072 */     GIR_EraseRootFromParent_Done,
     /* 1173073 */   // Label 17068: @1173073
     /* 1173073 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1173157), // Rule ID 8325 //
     /* 1173078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1173089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1173092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1173101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173131 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1173134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173156 */     // GIR_Coverage, 8325,
     /* 1173156 */     GIR_EraseRootFromParent_Done,
     /* 1173157 */   // Label 17069: @1173157
     /* 1173157 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1173241), // Rule ID 8328 //
     /* 1173162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1173173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1173176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1173185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173215 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1173218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173240 */     // GIR_Coverage, 8328,
     /* 1173240 */     GIR_EraseRootFromParent_Done,
     /* 1173241 */   // Label 17070: @1173241
     /* 1173241 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1173325), // Rule ID 8329 //
     /* 1173246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1173257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1173260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1173269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173299 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1173302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173324 */     // GIR_Coverage, 8329,
     /* 1173324 */     GIR_EraseRootFromParent_Done,
     /* 1173325 */   // Label 17071: @1173325
     /* 1173325 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1173409), // Rule ID 8332 //
     /* 1173330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1173341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1173344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1173353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1173386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173408 */     // GIR_Coverage, 8332,
     /* 1173408 */     GIR_EraseRootFromParent_Done,
     /* 1173409 */   // Label 17072: @1173409
     /* 1173409 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1173493), // Rule ID 8333 //
     /* 1173414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1173425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1173428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1173437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173467 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1173470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173492 */     // GIR_Coverage, 8333,
     /* 1173492 */     GIR_EraseRootFromParent_Done,
     /* 1173493 */   // Label 17073: @1173493
     /* 1173493 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1173577), // Rule ID 8336 //
     /* 1173498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1173509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1173512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1173521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173551 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1173554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173576 */     // GIR_Coverage, 8336,
     /* 1173576 */     GIR_EraseRootFromParent_Done,
     /* 1173577 */   // Label 17074: @1173577
     /* 1173577 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1173661), // Rule ID 8337 //
     /* 1173582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1173593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1173596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1173605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173635 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1173638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173660 */     // GIR_Coverage, 8337,
     /* 1173660 */     GIR_EraseRootFromParent_Done,
     /* 1173661 */   // Label 17075: @1173661
     /* 1173661 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1173745), // Rule ID 8340 //
     /* 1173666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1173677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1173680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1173683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1173689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173719 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1173722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173744 */     // GIR_Coverage, 8340,
     /* 1173744 */     GIR_EraseRootFromParent_Done,
     /* 1173745 */   // Label 17076: @1173745
     /* 1173745 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1173829), // Rule ID 8341 //
     /* 1173750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1173761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1173764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1173767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1173773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173803 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1173806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173828 */     // GIR_Coverage, 8341,
     /* 1173828 */     GIR_EraseRootFromParent_Done,
     /* 1173829 */   // Label 17077: @1173829
     /* 1173829 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1173913), // Rule ID 8344 //
     /* 1173834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1173845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1173848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1173857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1173887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1173890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173912 */     // GIR_Coverage, 8344,
     /* 1173912 */     GIR_EraseRootFromParent_Done,
     /* 1173913 */   // Label 17078: @1173913
     /* 1173913 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1173997), // Rule ID 8345 //
     /* 1173918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1173926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1173929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1173932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1173941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1173964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173971 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1173971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1173974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1173984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1173995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173996 */     // GIR_Coverage, 8345,
     /* 1173996 */     GIR_EraseRootFromParent_Done,
     /* 1173997 */   // Label 17079: @1173997
     /* 1173997 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1174081), // Rule ID 8348 //
     /* 1174002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1174010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1174013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1174016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1174025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1174058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174080 */     // GIR_Coverage, 8348,
     /* 1174080 */     GIR_EraseRootFromParent_Done,
     /* 1174081 */   // Label 17080: @1174081
     /* 1174081 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1174165), // Rule ID 8349 //
     /* 1174086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1174094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1174097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1174100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1174109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1174142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174164 */     // GIR_Coverage, 8349,
     /* 1174164 */     GIR_EraseRootFromParent_Done,
     /* 1174165 */   // Label 17081: @1174165
     /* 1174165 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1174249), // Rule ID 8352 //
     /* 1174170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1174178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1174181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1174184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1174193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174223 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1174226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174248 */     // GIR_Coverage, 8352,
     /* 1174248 */     GIR_EraseRootFromParent_Done,
     /* 1174249 */   // Label 17082: @1174249
     /* 1174249 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1174333), // Rule ID 8353 //
     /* 1174254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1174262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1174265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1174268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1174277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1174310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174332 */     // GIR_Coverage, 8353,
     /* 1174332 */     GIR_EraseRootFromParent_Done,
     /* 1174333 */   // Label 17083: @1174333
     /* 1174333 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1174417), // Rule ID 8356 //
     /* 1174338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1174349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1174352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1174358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1174361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174391 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1174394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174416 */     // GIR_Coverage, 8356,
     /* 1174416 */     GIR_EraseRootFromParent_Done,
     /* 1174417 */   // Label 17084: @1174417
     /* 1174417 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1174501), // Rule ID 8357 //
     /* 1174422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1174433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1174436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1174442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1174445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174475 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1174478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174500 */     // GIR_Coverage, 8357,
     /* 1174500 */     GIR_EraseRootFromParent_Done,
     /* 1174501 */   // Label 17085: @1174501
     /* 1174501 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1174585), // Rule ID 8360 //
     /* 1174506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1174517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1174520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1174526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1174529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1174562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174584 */     // GIR_Coverage, 8360,
     /* 1174584 */     GIR_EraseRootFromParent_Done,
     /* 1174585 */   // Label 17086: @1174585
     /* 1174585 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1174669), // Rule ID 8361 //
     /* 1174590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1174601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1174604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1174610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1174613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1174646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174668 */     // GIR_Coverage, 8361,
     /* 1174668 */     GIR_EraseRootFromParent_Done,
     /* 1174669 */   // Label 17087: @1174669
     /* 1174669 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1174753), // Rule ID 8364 //
     /* 1174674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1174685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1174688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1174694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1174697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1174730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174752 */     // GIR_Coverage, 8364,
     /* 1174752 */     GIR_EraseRootFromParent_Done,
     /* 1174753 */   // Label 17088: @1174753
     /* 1174753 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1174837), // Rule ID 8365 //
     /* 1174758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1174769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1174772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1174778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1174781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174811 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1174814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174836 */     // GIR_Coverage, 8365,
     /* 1174836 */     GIR_EraseRootFromParent_Done,
     /* 1174837 */   // Label 17089: @1174837
     /* 1174837 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1174921), // Rule ID 8368 //
     /* 1174842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1174853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1174856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1174859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1174862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1174865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1174895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1174898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1174919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174920 */     // GIR_Coverage, 8368,
     /* 1174920 */     GIR_EraseRootFromParent_Done,
     /* 1174921 */   // Label 17090: @1174921
     /* 1174921 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1175005), // Rule ID 8369 //
     /* 1174926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1174934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1174937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1174940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1174943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1174946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1174949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1174972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174979 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1174979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1174982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1174992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175004 */     // GIR_Coverage, 8369,
     /* 1175004 */     GIR_EraseRootFromParent_Done,
     /* 1175005 */   // Label 17091: @1175005
     /* 1175005 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1175089), // Rule ID 8372 //
     /* 1175010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1175021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1175024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1175030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1175033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1175066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175088 */     // GIR_Coverage, 8372,
     /* 1175088 */     GIR_EraseRootFromParent_Done,
     /* 1175089 */   // Label 17092: @1175089
     /* 1175089 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1175173), // Rule ID 8373 //
     /* 1175094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1175105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1175108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1175114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1175117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175147 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1175150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175172 */     // GIR_Coverage, 8373,
     /* 1175172 */     GIR_EraseRootFromParent_Done,
     /* 1175173 */   // Label 17093: @1175173
     /* 1175173 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1175257), // Rule ID 8376 //
     /* 1175178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1175189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1175192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1175201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175231 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1175234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175256 */     // GIR_Coverage, 8376,
     /* 1175256 */     GIR_EraseRootFromParent_Done,
     /* 1175257 */   // Label 17094: @1175257
     /* 1175257 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1175341), // Rule ID 8377 //
     /* 1175262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1175273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1175276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1175285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1175318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175340 */     // GIR_Coverage, 8377,
     /* 1175340 */     GIR_EraseRootFromParent_Done,
     /* 1175341 */   // Label 17095: @1175341
     /* 1175341 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1175425), // Rule ID 8380 //
     /* 1175346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1175357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1175360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1175366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1175369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175399 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175424 */     // GIR_Coverage, 8380,
     /* 1175424 */     GIR_EraseRootFromParent_Done,
     /* 1175425 */   // Label 17096: @1175425
     /* 1175425 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1175509), // Rule ID 8381 //
     /* 1175430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1175441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1175444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1175450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1175453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175508 */     // GIR_Coverage, 8381,
     /* 1175508 */     GIR_EraseRootFromParent_Done,
     /* 1175509 */   // Label 17097: @1175509
     /* 1175509 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1175593), // Rule ID 8384 //
     /* 1175514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1175525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1175528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1175534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1175537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175567 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175592 */     // GIR_Coverage, 8384,
     /* 1175592 */     GIR_EraseRootFromParent_Done,
     /* 1175593 */   // Label 17098: @1175593
     /* 1175593 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1175677), // Rule ID 8385 //
     /* 1175598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1175609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1175612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1175618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1175621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175651 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175676 */     // GIR_Coverage, 8385,
     /* 1175676 */     GIR_EraseRootFromParent_Done,
     /* 1175677 */   // Label 17099: @1175677
     /* 1175677 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1175761), // Rule ID 8388 //
     /* 1175682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1175693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1175696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1175702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1175705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175760 */     // GIR_Coverage, 8388,
     /* 1175760 */     GIR_EraseRootFromParent_Done,
     /* 1175761 */   // Label 17100: @1175761
     /* 1175761 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1175845), // Rule ID 8389 //
     /* 1175766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1175777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1175780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1175786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1175789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175844 */     // GIR_Coverage, 8389,
     /* 1175844 */     GIR_EraseRootFromParent_Done,
     /* 1175845 */   // Label 17101: @1175845
     /* 1175845 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1175929), // Rule ID 8392 //
     /* 1175850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1175853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1175861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1175864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1175870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1175873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175903 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1175903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1175916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1175927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175928 */     // GIR_Coverage, 8392,
     /* 1175928 */     GIR_EraseRootFromParent_Done,
     /* 1175929 */   // Label 17102: @1175929
     /* 1175929 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1176013), // Rule ID 8393 //
     /* 1175934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1175937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1175942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1175945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1175948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1175954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1175957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1175980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1175987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1175990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176012 */     // GIR_Coverage, 8393,
     /* 1176012 */     GIR_EraseRootFromParent_Done,
     /* 1176013 */   // Label 17103: @1176013
     /* 1176013 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1176097), // Rule ID 8396 //
     /* 1176018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1176029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1176032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1176038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1176041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176071 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1176074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176096 */     // GIR_Coverage, 8396,
     /* 1176096 */     GIR_EraseRootFromParent_Done,
     /* 1176097 */   // Label 17104: @1176097
     /* 1176097 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1176181), // Rule ID 8397 //
     /* 1176102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1176113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1176116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1176122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1176125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1176158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176180 */     // GIR_Coverage, 8397,
     /* 1176180 */     GIR_EraseRootFromParent_Done,
     /* 1176181 */   // Label 17105: @1176181
     /* 1176181 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1176265), // Rule ID 8400 //
     /* 1176186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1176197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1176200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1176206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1176209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176239 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1176242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176264 */     // GIR_Coverage, 8400,
     /* 1176264 */     GIR_EraseRootFromParent_Done,
     /* 1176265 */   // Label 17106: @1176265
     /* 1176265 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1176349), // Rule ID 8401 //
     /* 1176270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1176281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1176284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1176290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1176293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176323 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1176326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176348 */     // GIR_Coverage, 8401,
     /* 1176348 */     GIR_EraseRootFromParent_Done,
     /* 1176349 */   // Label 17107: @1176349
     /* 1176349 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1176433), // Rule ID 8404 //
     /* 1176354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1176365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1176368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1176374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1176377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176407 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1176410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176432 */     // GIR_Coverage, 8404,
     /* 1176432 */     GIR_EraseRootFromParent_Done,
     /* 1176433 */   // Label 17108: @1176433
     /* 1176433 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1176517), // Rule ID 8405 //
     /* 1176438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1176449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1176452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1176458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1176461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176491 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1176494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176516 */     // GIR_Coverage, 8405,
     /* 1176516 */     GIR_EraseRootFromParent_Done,
     /* 1176517 */   // Label 17109: @1176517
     /* 1176517 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1176601), // Rule ID 8408 //
     /* 1176522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1176533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1176536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1176542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1176545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1176578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176600 */     // GIR_Coverage, 8408,
     /* 1176600 */     GIR_EraseRootFromParent_Done,
     /* 1176601 */   // Label 17110: @1176601
     /* 1176601 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1176685), // Rule ID 8409 //
     /* 1176606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1176617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1176620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1176626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1176629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1176662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176684 */     // GIR_Coverage, 8409,
     /* 1176684 */     GIR_EraseRootFromParent_Done,
     /* 1176685 */   // Label 17111: @1176685
     /* 1176685 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1176769), // Rule ID 8412 //
     /* 1176690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1176701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1176704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1176710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1176713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1176746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176768 */     // GIR_Coverage, 8412,
     /* 1176768 */     GIR_EraseRootFromParent_Done,
     /* 1176769 */   // Label 17112: @1176769
     /* 1176769 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1176853), // Rule ID 8413 //
     /* 1176774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1176785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1176788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1176794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1176797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1176830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176852 */     // GIR_Coverage, 8413,
     /* 1176852 */     GIR_EraseRootFromParent_Done,
     /* 1176853 */   // Label 17113: @1176853
     /* 1176853 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1176937), // Rule ID 8416 //
     /* 1176858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1176869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1176872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1176878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1176881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176911 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1176911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1176914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1176924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1176935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176936 */     // GIR_Coverage, 8416,
     /* 1176936 */     GIR_EraseRootFromParent_Done,
     /* 1176937 */   // Label 17114: @1176937
     /* 1176937 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1177021), // Rule ID 8417 //
     /* 1176942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1176950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1176953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1176956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1176962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1176965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1176988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176995 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1176995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1176998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177020 */     // GIR_Coverage, 8417,
     /* 1177020 */     GIR_EraseRootFromParent_Done,
     /* 1177021 */   // Label 17115: @1177021
     /* 1177021 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1177105), // Rule ID 8420 //
     /* 1177026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1177037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1177040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1177046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1177049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177079 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1177082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177104 */     // GIR_Coverage, 8420,
     /* 1177104 */     GIR_EraseRootFromParent_Done,
     /* 1177105 */   // Label 17116: @1177105
     /* 1177105 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1177189), // Rule ID 8421 //
     /* 1177110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1177121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1177124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1177130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1177133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177163 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1177163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1177166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177188 */     // GIR_Coverage, 8421,
     /* 1177188 */     GIR_EraseRootFromParent_Done,
     /* 1177189 */   // Label 17117: @1177189
     /* 1177189 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1177273), // Rule ID 8424 //
     /* 1177194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1177205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1177208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1177214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1177217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177247 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1177250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177272 */     // GIR_Coverage, 8424,
     /* 1177272 */     GIR_EraseRootFromParent_Done,
     /* 1177273 */   // Label 17118: @1177273
     /* 1177273 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1177357), // Rule ID 8425 //
     /* 1177278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1177289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1177292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1177298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1177301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177331 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1177331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1177334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177356 */     // GIR_Coverage, 8425,
     /* 1177356 */     GIR_EraseRootFromParent_Done,
     /* 1177357 */   // Label 17119: @1177357
     /* 1177357 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1177441), // Rule ID 8428 //
     /* 1177362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1177373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1177376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1177382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1177385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1177418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177440 */     // GIR_Coverage, 8428,
     /* 1177440 */     GIR_EraseRootFromParent_Done,
     /* 1177441 */   // Label 17120: @1177441
     /* 1177441 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1177525), // Rule ID 8429 //
     /* 1177446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1177457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1177460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1177466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1177469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177499 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1177499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1177502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177524 */     // GIR_Coverage, 8429,
     /* 1177524 */     GIR_EraseRootFromParent_Done,
     /* 1177525 */   // Label 17121: @1177525
     /* 1177525 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1177609), // Rule ID 8432 //
     /* 1177530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1177541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1177544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1177550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1177553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177583 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1177586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177608 */     // GIR_Coverage, 8432,
     /* 1177608 */     GIR_EraseRootFromParent_Done,
     /* 1177609 */   // Label 17122: @1177609
     /* 1177609 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1177693), // Rule ID 8433 //
     /* 1177614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1177625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1177628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1177634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1177637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1177667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1177670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177692 */     // GIR_Coverage, 8433,
     /* 1177692 */     GIR_EraseRootFromParent_Done,
     /* 1177693 */   // Label 17123: @1177693
     /* 1177693 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1177777), // Rule ID 8436 //
     /* 1177698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1177709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1177712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1177718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1177721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177751 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1177754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177776 */     // GIR_Coverage, 8436,
     /* 1177776 */     GIR_EraseRootFromParent_Done,
     /* 1177777 */   // Label 17124: @1177777
     /* 1177777 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1177861), // Rule ID 8437 //
     /* 1177782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1177793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1177796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1177802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1177805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1177835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1177838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177860 */     // GIR_Coverage, 8437,
     /* 1177860 */     GIR_EraseRootFromParent_Done,
     /* 1177861 */   // Label 17125: @1177861
     /* 1177861 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1177945), // Rule ID 8440 //
     /* 1177866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1177877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1177880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1177883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1177886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1177889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1177919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1177922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1177932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1177943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177944 */     // GIR_Coverage, 8440,
     /* 1177944 */     GIR_EraseRootFromParent_Done,
     /* 1177945 */   // Label 17126: @1177945
     /* 1177945 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1178029), // Rule ID 8441 //
     /* 1177950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1177958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1177961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1177964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1177967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1177970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1177973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1177996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178003 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1178006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178028 */     // GIR_Coverage, 8441,
     /* 1178028 */     GIR_EraseRootFromParent_Done,
     /* 1178029 */   // Label 17127: @1178029
     /* 1178029 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1178113), // Rule ID 8444 //
     /* 1178034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1178051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1178090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178112 */     // GIR_Coverage, 8444,
     /* 1178112 */     GIR_EraseRootFromParent_Done,
     /* 1178113 */   // Label 17128: @1178113
     /* 1178113 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1178197), // Rule ID 8445 //
     /* 1178118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1178135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178171 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1178174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178196 */     // GIR_Coverage, 8445,
     /* 1178196 */     GIR_EraseRootFromParent_Done,
     /* 1178197 */   // Label 17129: @1178197
     /* 1178197 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1178281), // Rule ID 8448 //
     /* 1178202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1178213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1178216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1178219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1178225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178255 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1178258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178280 */     // GIR_Coverage, 8448,
     /* 1178280 */     GIR_EraseRootFromParent_Done,
     /* 1178281 */   // Label 17130: @1178281
     /* 1178281 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1178365), // Rule ID 8449 //
     /* 1178286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1178297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1178300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1178303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1178309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178339 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1178342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178364 */     // GIR_Coverage, 8449,
     /* 1178364 */     GIR_EraseRootFromParent_Done,
     /* 1178365 */   // Label 17131: @1178365
     /* 1178365 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1178449), // Rule ID 8452 //
     /* 1178370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1178381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1178384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1178387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1178393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1178426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178448 */     // GIR_Coverage, 8452,
     /* 1178448 */     GIR_EraseRootFromParent_Done,
     /* 1178449 */   // Label 17132: @1178449
     /* 1178449 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1178533), // Rule ID 8453 //
     /* 1178454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1178465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1178468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1178471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1178477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178507 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1178510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178532 */     // GIR_Coverage, 8453,
     /* 1178532 */     GIR_EraseRootFromParent_Done,
     /* 1178533 */   // Label 17133: @1178533
     /* 1178533 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1178617), // Rule ID 8456 //
     /* 1178538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178591 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1178594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178616 */     // GIR_Coverage, 8456,
     /* 1178616 */     GIR_EraseRootFromParent_Done,
     /* 1178617 */   // Label 17134: @1178617
     /* 1178617 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1178701), // Rule ID 8457 //
     /* 1178622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1178678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178700 */     // GIR_Coverage, 8457,
     /* 1178700 */     GIR_EraseRootFromParent_Done,
     /* 1178701 */   // Label 17135: @1178701
     /* 1178701 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1178785), // Rule ID 8460 //
     /* 1178706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1178717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1178720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1178729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178759 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1178762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178784 */     // GIR_Coverage, 8460,
     /* 1178784 */     GIR_EraseRootFromParent_Done,
     /* 1178785 */   // Label 17136: @1178785
     /* 1178785 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1178869), // Rule ID 8461 //
     /* 1178790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1178801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1178804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1178813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1178843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1178846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178868 */     // GIR_Coverage, 8461,
     /* 1178868 */     GIR_EraseRootFromParent_Done,
     /* 1178869 */   // Label 17137: @1178869
     /* 1178869 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1178953), // Rule ID 8464 //
     /* 1178874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1178891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1178920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1178927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1178930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1178940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1178951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178952 */     // GIR_Coverage, 8464,
     /* 1178952 */     GIR_EraseRootFromParent_Done,
     /* 1178953 */   // Label 17138: @1178953
     /* 1178953 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1179037), // Rule ID 8465 //
     /* 1178958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1178966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1178969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1178972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1178975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1178981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179011 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1179014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179036 */     // GIR_Coverage, 8465,
     /* 1179036 */     GIR_EraseRootFromParent_Done,
     /* 1179037 */   // Label 17139: @1179037
     /* 1179037 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1179121), // Rule ID 8468 //
     /* 1179042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1179059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1179065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179120 */     // GIR_Coverage, 8468,
     /* 1179120 */     GIR_EraseRootFromParent_Done,
     /* 1179121 */   // Label 17140: @1179121
     /* 1179121 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1179205), // Rule ID 8469 //
     /* 1179126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1179137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1179140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1179143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1179149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179204 */     // GIR_Coverage, 8469,
     /* 1179204 */     GIR_EraseRootFromParent_Done,
     /* 1179205 */   // Label 17141: @1179205
     /* 1179205 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1179289), // Rule ID 8472 //
     /* 1179210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1179221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1179224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1179233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179263 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179288 */     // GIR_Coverage, 8472,
     /* 1179288 */     GIR_EraseRootFromParent_Done,
     /* 1179289 */   // Label 17142: @1179289
     /* 1179289 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1179373), // Rule ID 8473 //
     /* 1179294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1179305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1179308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1179317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179347 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179372 */     // GIR_Coverage, 8473,
     /* 1179372 */     GIR_EraseRootFromParent_Done,
     /* 1179373 */   // Label 17143: @1179373
     /* 1179373 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1179457), // Rule ID 8476 //
     /* 1179378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1179389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1179392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1179401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179456 */     // GIR_Coverage, 8476,
     /* 1179456 */     GIR_EraseRootFromParent_Done,
     /* 1179457 */   // Label 17144: @1179457
     /* 1179457 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1179541), // Rule ID 8477 //
     /* 1179462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1179473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1179476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1179485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179515 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179540 */     // GIR_Coverage, 8477,
     /* 1179540 */     GIR_EraseRootFromParent_Done,
     /* 1179541 */   // Label 17145: @1179541
     /* 1179541 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1179625), // Rule ID 8480 //
     /* 1179546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1179549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1179557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1179560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1179563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1179569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179599 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1179620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179624 */     // GIR_Coverage, 8480,
     /* 1179624 */     GIR_EraseRootFromParent_Done,
     /* 1179625 */   // Label 17146: @1179625
     /* 1179625 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1179709), // Rule ID 8481 //
     /* 1179630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1179633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1179641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1179644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1179647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1179653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1179686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1179704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179708 */     // GIR_Coverage, 8481,
     /* 1179708 */     GIR_EraseRootFromParent_Done,
     /* 1179709 */   // Label 17147: @1179709
     /* 1179709 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1179793), // Rule ID 8484 //
     /* 1179714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1179725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1179728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1179731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1179737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179767 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1179770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179792 */     // GIR_Coverage, 8484,
     /* 1179792 */     GIR_EraseRootFromParent_Done,
     /* 1179793 */   // Label 17148: @1179793
     /* 1179793 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1179877), // Rule ID 8485 //
     /* 1179798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1179809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1179812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1179815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1179821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179851 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1179851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1179854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179876 */     // GIR_Coverage, 8485,
     /* 1179876 */     GIR_EraseRootFromParent_Done,
     /* 1179877 */   // Label 17149: @1179877
     /* 1179877 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1179961), // Rule ID 8488 //
     /* 1179882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1179893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1179896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1179899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1179905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1179928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179935 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1179935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1179938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1179948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1179959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179960 */     // GIR_Coverage, 8488,
     /* 1179960 */     GIR_EraseRootFromParent_Done,
     /* 1179961 */   // Label 17150: @1179961
     /* 1179961 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1180045), // Rule ID 8489 //
     /* 1179966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1179974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1179977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1179980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1179983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1179989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180019 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1180022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180044 */     // GIR_Coverage, 8489,
     /* 1180044 */     GIR_EraseRootFromParent_Done,
     /* 1180045 */   // Label 17151: @1180045
     /* 1180045 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1180129), // Rule ID 8492 //
     /* 1180050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1180061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1180064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1180067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1180073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180103 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1180106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180128 */     // GIR_Coverage, 8492,
     /* 1180128 */     GIR_EraseRootFromParent_Done,
     /* 1180129 */   // Label 17152: @1180129
     /* 1180129 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1180213), // Rule ID 8493 //
     /* 1180134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1180145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1180148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1180151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1180157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180187 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1180190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180212 */     // GIR_Coverage, 8493,
     /* 1180212 */     GIR_EraseRootFromParent_Done,
     /* 1180213 */   // Label 17153: @1180213
     /* 1180213 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1180297), // Rule ID 8496 //
     /* 1180218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1180229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1180232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1180241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1180274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180296 */     // GIR_Coverage, 8496,
     /* 1180296 */     GIR_EraseRootFromParent_Done,
     /* 1180297 */   // Label 17154: @1180297
     /* 1180297 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1180381), // Rule ID 8497 //
     /* 1180302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1180313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1180316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1180325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1180358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180380 */     // GIR_Coverage, 8497,
     /* 1180380 */     GIR_EraseRootFromParent_Done,
     /* 1180381 */   // Label 17155: @1180381
     /* 1180381 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1180465), // Rule ID 8500 //
     /* 1180386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1180397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1180400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1180403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1180409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180439 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1180442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180464 */     // GIR_Coverage, 8500,
     /* 1180464 */     GIR_EraseRootFromParent_Done,
     /* 1180465 */   // Label 17156: @1180465
     /* 1180465 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1180549), // Rule ID 8501 //
     /* 1180470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1180481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1180484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1180487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1180493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180523 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1180526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180548 */     // GIR_Coverage, 8501,
     /* 1180548 */     GIR_EraseRootFromParent_Done,
     /* 1180549 */   // Label 17157: @1180549
     /* 1180549 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1180633), // Rule ID 8504 //
     /* 1180554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1180565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1180568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1180571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1180577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180607 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1180610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180632 */     // GIR_Coverage, 8504,
     /* 1180632 */     GIR_EraseRootFromParent_Done,
     /* 1180633 */   // Label 17158: @1180633
     /* 1180633 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1180717), // Rule ID 8505 //
     /* 1180638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1180649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1180652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1180655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1180661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1180694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180716 */     // GIR_Coverage, 8505,
     /* 1180716 */     GIR_EraseRootFromParent_Done,
     /* 1180717 */   // Label 17159: @1180717
     /* 1180717 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1180801), // Rule ID 8508 //
     /* 1180722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1180733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1180736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1180739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1180745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1180778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180800 */     // GIR_Coverage, 8508,
     /* 1180800 */     GIR_EraseRootFromParent_Done,
     /* 1180801 */   // Label 17160: @1180801
     /* 1180801 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1180885), // Rule ID 8509 //
     /* 1180806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1180817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1180820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1180823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1180829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180859 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1180859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1180862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180884 */     // GIR_Coverage, 8509,
     /* 1180884 */     GIR_EraseRootFromParent_Done,
     /* 1180885 */   // Label 17161: @1180885
     /* 1180885 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1180969), // Rule ID 8512 //
     /* 1180890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1180901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1180904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1180913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1180936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1180943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1180946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1180956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1180967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180968 */     // GIR_Coverage, 8512,
     /* 1180968 */     GIR_EraseRootFromParent_Done,
     /* 1180969 */   // Label 17162: @1180969
     /* 1180969 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1181053), // Rule ID 8513 //
     /* 1180974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1180982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1180985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1180988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1180997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1181030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181052 */     // GIR_Coverage, 8513,
     /* 1181052 */     GIR_EraseRootFromParent_Done,
     /* 1181053 */   // Label 17163: @1181053
     /* 1181053 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1181137), // Rule ID 8516 //
     /* 1181058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1181069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1181072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1181075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1181081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181111 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1181114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181136 */     // GIR_Coverage, 8516,
     /* 1181136 */     GIR_EraseRootFromParent_Done,
     /* 1181137 */   // Label 17164: @1181137
     /* 1181137 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1181221), // Rule ID 8517 //
     /* 1181142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1181153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1181156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1181159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1181165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1181198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181220 */     // GIR_Coverage, 8517,
     /* 1181220 */     GIR_EraseRootFromParent_Done,
     /* 1181221 */   // Label 17165: @1181221
     /* 1181221 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1181305), // Rule ID 8520 //
     /* 1181226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1181237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1181240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1181243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1181249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1181282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181304 */     // GIR_Coverage, 8520,
     /* 1181304 */     GIR_EraseRootFromParent_Done,
     /* 1181305 */   // Label 17166: @1181305
     /* 1181305 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1181389), // Rule ID 8521 //
     /* 1181310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1181321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1181324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1181327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1181333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1181366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181388 */     // GIR_Coverage, 8521,
     /* 1181388 */     GIR_EraseRootFromParent_Done,
     /* 1181389 */   // Label 17167: @1181389
     /* 1181389 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1181473), // Rule ID 8524 //
     /* 1181394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1181405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1181408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1181411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1181417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1181450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181472 */     // GIR_Coverage, 8524,
     /* 1181472 */     GIR_EraseRootFromParent_Done,
     /* 1181473 */   // Label 17168: @1181473
     /* 1181473 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1181557), // Rule ID 8525 //
     /* 1181478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1181489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1181492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1181495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1181501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181531 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1181534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181556 */     // GIR_Coverage, 8525,
     /* 1181556 */     GIR_EraseRootFromParent_Done,
     /* 1181557 */   // Label 17169: @1181557
     /* 1181557 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1181641), // Rule ID 8528 //
     /* 1181562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1181573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1181576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1181585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1181618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181640 */     // GIR_Coverage, 8528,
     /* 1181640 */     GIR_EraseRootFromParent_Done,
     /* 1181641 */   // Label 17170: @1181641
     /* 1181641 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1181725), // Rule ID 8529 //
     /* 1181646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1181654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1181657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1181660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1181669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1181702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181724 */     // GIR_Coverage, 8529,
     /* 1181724 */     GIR_EraseRootFromParent_Done,
     /* 1181725 */   // Label 17171: @1181725
     /* 1181725 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1181809), // Rule ID 8532 //
     /* 1181730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1181747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1181750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1181753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181783 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1181786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181808 */     // GIR_Coverage, 8532,
     /* 1181808 */     GIR_EraseRootFromParent_Done,
     /* 1181809 */   // Label 17172: @1181809
     /* 1181809 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1181893), // Rule ID 8533 //
     /* 1181814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1181822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1181825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1181828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1181831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1181834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1181837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181867 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1181867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1181870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181892 */     // GIR_Coverage, 8533,
     /* 1181892 */     GIR_EraseRootFromParent_Done,
     /* 1181893 */   // Label 17173: @1181893
     /* 1181893 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1181977), // Rule ID 8536 //
     /* 1181898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1181906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1181909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1181912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1181915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1181918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1181921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1181944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1181951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1181954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1181964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1181975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181976 */     // GIR_Coverage, 8536,
     /* 1181976 */     GIR_EraseRootFromParent_Done,
     /* 1181977 */   // Label 17174: @1181977
     /* 1181977 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1182061), // Rule ID 8537 //
     /* 1181982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1181990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1181993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1181996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1181999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1182002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1182005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1182038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182060 */     // GIR_Coverage, 8537,
     /* 1182060 */     GIR_EraseRootFromParent_Done,
     /* 1182061 */   // Label 17175: @1182061
     /* 1182061 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1182145), // Rule ID 8540 //
     /* 1182066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1182077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1182080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1182083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1182086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1182089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182119 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182144 */     // GIR_Coverage, 8540,
     /* 1182144 */     GIR_EraseRootFromParent_Done,
     /* 1182145 */   // Label 17176: @1182145
     /* 1182145 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1182229), // Rule ID 8541 //
     /* 1182150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1182161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1182164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1182167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1182170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1182173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182228 */     // GIR_Coverage, 8541,
     /* 1182228 */     GIR_EraseRootFromParent_Done,
     /* 1182229 */   // Label 17177: @1182229
     /* 1182229 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1182313), // Rule ID 8544 //
     /* 1182234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1182245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1182248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1182254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1182257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182287 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1182290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182312 */     // GIR_Coverage, 8544,
     /* 1182312 */     GIR_EraseRootFromParent_Done,
     /* 1182313 */   // Label 17178: @1182313
     /* 1182313 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1182397), // Rule ID 8545 //
     /* 1182318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1182329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1182332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1182338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1182341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182371 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1182374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182396 */     // GIR_Coverage, 8545,
     /* 1182396 */     GIR_EraseRootFromParent_Done,
     /* 1182397 */   // Label 17179: @1182397
     /* 1182397 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1182481), // Rule ID 8548 //
     /* 1182402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1182413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1182416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1182419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1182422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1182425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182480 */     // GIR_Coverage, 8548,
     /* 1182480 */     GIR_EraseRootFromParent_Done,
     /* 1182481 */   // Label 17180: @1182481
     /* 1182481 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1182565), // Rule ID 8549 //
     /* 1182486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1182497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1182500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1182503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1182506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1182509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182564 */     // GIR_Coverage, 8549,
     /* 1182564 */     GIR_EraseRootFromParent_Done,
     /* 1182565 */   // Label 17181: @1182565
     /* 1182565 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1182649), // Rule ID 8552 //
     /* 1182570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1182581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1182584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1182590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1182593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182648 */     // GIR_Coverage, 8552,
     /* 1182648 */     GIR_EraseRootFromParent_Done,
     /* 1182649 */   // Label 17182: @1182649
     /* 1182649 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1182733), // Rule ID 8553 //
     /* 1182654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1182665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1182668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1182674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1182677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1182710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182732 */     // GIR_Coverage, 8553,
     /* 1182732 */     GIR_EraseRootFromParent_Done,
     /* 1182733 */   // Label 17183: @1182733
     /* 1182733 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1182817), // Rule ID 8556 //
     /* 1182738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1182749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1182752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1182755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1182758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1182761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1182794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182816 */     // GIR_Coverage, 8556,
     /* 1182816 */     GIR_EraseRootFromParent_Done,
     /* 1182817 */   // Label 17184: @1182817
     /* 1182817 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1182901), // Rule ID 8557 //
     /* 1182822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1182833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1182836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1182839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1182842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1182845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1182875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1182878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182900 */     // GIR_Coverage, 8557,
     /* 1182900 */     GIR_EraseRootFromParent_Done,
     /* 1182901 */   // Label 17185: @1182901
     /* 1182901 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1182985), // Rule ID 8560 //
     /* 1182906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1182917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1182920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1182923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1182926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1182929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1182952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1182959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1182962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1182972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1182983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182984 */     // GIR_Coverage, 8560,
     /* 1182984 */     GIR_EraseRootFromParent_Done,
     /* 1182985 */   // Label 17186: @1182985
     /* 1182985 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1183069), // Rule ID 8561 //
     /* 1182990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1182998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1183001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1183004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1183010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1183013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183043 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1183046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183068 */     // GIR_Coverage, 8561,
     /* 1183068 */     GIR_EraseRootFromParent_Done,
     /* 1183069 */   // Label 17187: @1183069
     /* 1183069 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1183153), // Rule ID 8564 //
     /* 1183074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1183085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1183088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1183091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1183094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1183097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183127 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1183130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183152 */     // GIR_Coverage, 8564,
     /* 1183152 */     GIR_EraseRootFromParent_Done,
     /* 1183153 */   // Label 17188: @1183153
     /* 1183153 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1183237), // Rule ID 8565 //
     /* 1183158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1183169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1183172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1183175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1183178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1183181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183211 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1183214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183236 */     // GIR_Coverage, 8565,
     /* 1183236 */     GIR_EraseRootFromParent_Done,
     /* 1183237 */   // Label 17189: @1183237
     /* 1183237 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1183321), // Rule ID 8568 //
     /* 1183242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1183245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1183253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1183256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1183262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1183265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183295 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1183298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1183316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183320 */     // GIR_Coverage, 8568,
     /* 1183320 */     GIR_EraseRootFromParent_Done,
     /* 1183321 */   // Label 17190: @1183321
     /* 1183321 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1183405), // Rule ID 8569 //
     /* 1183326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1183329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1183337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1183340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1183346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1183349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1183382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1183400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183404 */     // GIR_Coverage, 8569,
     /* 1183404 */     GIR_EraseRootFromParent_Done,
     /* 1183405 */   // Label 17191: @1183405
     /* 1183405 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1183489), // Rule ID 8572 //
     /* 1183410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1183421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1183424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1183427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1183433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183463 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1183466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183488 */     // GIR_Coverage, 8572,
     /* 1183488 */     GIR_EraseRootFromParent_Done,
     /* 1183489 */   // Label 17192: @1183489
     /* 1183489 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1183573), // Rule ID 8573 //
     /* 1183494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1183505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1183508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1183511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1183517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183547 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1183550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183572 */     // GIR_Coverage, 8573,
     /* 1183572 */     GIR_EraseRootFromParent_Done,
     /* 1183573 */   // Label 17193: @1183573
     /* 1183573 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1183657), // Rule ID 8576 //
     /* 1183578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1183589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1183592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1183595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1183598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1183601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183631 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1183634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183656 */     // GIR_Coverage, 8576,
     /* 1183656 */     GIR_EraseRootFromParent_Done,
     /* 1183657 */   // Label 17194: @1183657
     /* 1183657 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1183741), // Rule ID 8577 //
     /* 1183662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1183673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1183676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1183679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1183682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1183685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183715 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1183718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183740 */     // GIR_Coverage, 8577,
     /* 1183740 */     GIR_EraseRootFromParent_Done,
     /* 1183741 */   // Label 17195: @1183741
     /* 1183741 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1183825), // Rule ID 8580 //
     /* 1183746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1183757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1183760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1183763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1183766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1183769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183799 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1183802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183824 */     // GIR_Coverage, 8580,
     /* 1183824 */     GIR_EraseRootFromParent_Done,
     /* 1183825 */   // Label 17196: @1183825
     /* 1183825 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1183909), // Rule ID 8581 //
     /* 1183830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1183841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1183844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1183847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1183850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1183853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183883 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1183883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1183886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183908 */     // GIR_Coverage, 8581,
     /* 1183908 */     GIR_EraseRootFromParent_Done,
     /* 1183909 */   // Label 17197: @1183909
     /* 1183909 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1183993), // Rule ID 8584 //
     /* 1183914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1183922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1183925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1183928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1183934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1183937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1183960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1183967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1183970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1183980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1183991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183992 */     // GIR_Coverage, 8584,
     /* 1183992 */     GIR_EraseRootFromParent_Done,
     /* 1183993 */   // Label 17198: @1183993
     /* 1183993 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1184077), // Rule ID 8585 //
     /* 1183998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1184009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1184012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1184021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184051 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1184054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184076 */     // GIR_Coverage, 8585,
     /* 1184076 */     GIR_EraseRootFromParent_Done,
     /* 1184077 */   // Label 17199: @1184077
     /* 1184077 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1184161), // Rule ID 8588 //
     /* 1184082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1184093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1184096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1184105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1184138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184160 */     // GIR_Coverage, 8588,
     /* 1184160 */     GIR_EraseRootFromParent_Done,
     /* 1184161 */   // Label 17200: @1184161
     /* 1184161 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1184245), // Rule ID 8589 //
     /* 1184166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1184177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1184180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1184189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184219 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1184222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184244 */     // GIR_Coverage, 8589,
     /* 1184244 */     GIR_EraseRootFromParent_Done,
     /* 1184245 */   // Label 17201: @1184245
     /* 1184245 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1184329), // Rule ID 8592 //
     /* 1184250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1184261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1184264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1184270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1184273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184303 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1184306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184328 */     // GIR_Coverage, 8592,
     /* 1184328 */     GIR_EraseRootFromParent_Done,
     /* 1184329 */   // Label 17202: @1184329
     /* 1184329 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1184413), // Rule ID 8593 //
     /* 1184334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1184345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1184348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1184354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1184357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184387 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1184390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184412 */     // GIR_Coverage, 8593,
     /* 1184412 */     GIR_EraseRootFromParent_Done,
     /* 1184413 */   // Label 17203: @1184413
     /* 1184413 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1184497), // Rule ID 8596 //
     /* 1184418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1184429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1184432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1184441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1184474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184496 */     // GIR_Coverage, 8596,
     /* 1184496 */     GIR_EraseRootFromParent_Done,
     /* 1184497 */   // Label 17204: @1184497
     /* 1184497 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1184581), // Rule ID 8597 //
     /* 1184502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1184513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1184516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1184525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1184558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184580 */     // GIR_Coverage, 8597,
     /* 1184580 */     GIR_EraseRootFromParent_Done,
     /* 1184581 */   // Label 17205: @1184581
     /* 1184581 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1184665), // Rule ID 8600 //
     /* 1184586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1184597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1184600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1184606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1184609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1184642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184664 */     // GIR_Coverage, 8600,
     /* 1184664 */     GIR_EraseRootFromParent_Done,
     /* 1184665 */   // Label 17206: @1184665
     /* 1184665 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1184749), // Rule ID 8601 //
     /* 1184670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1184681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1184684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1184690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1184693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1184726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184748 */     // GIR_Coverage, 8601,
     /* 1184748 */     GIR_EraseRootFromParent_Done,
     /* 1184749 */   // Label 17207: @1184749
     /* 1184749 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1184833), // Rule ID 8604 //
     /* 1184754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1184765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1184768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1184774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1184777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1184810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184832 */     // GIR_Coverage, 8604,
     /* 1184832 */     GIR_EraseRootFromParent_Done,
     /* 1184833 */   // Label 17208: @1184833
     /* 1184833 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1184917), // Rule ID 8605 //
     /* 1184838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1184849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1184852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1184858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1184861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184891 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1184891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1184894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184916 */     // GIR_Coverage, 8605,
     /* 1184916 */     GIR_EraseRootFromParent_Done,
     /* 1184917 */   // Label 17209: @1184917
     /* 1184917 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1185001), // Rule ID 8608 //
     /* 1184922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1184925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1184930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1184933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1184936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1184939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1184942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1184945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1184968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1184975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1184978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1184988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1184996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1184999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185000 */     // GIR_Coverage, 8608,
     /* 1185000 */     GIR_EraseRootFromParent_Done,
     /* 1185001 */   // Label 17210: @1185001
     /* 1185001 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1185085), // Rule ID 8609 //
     /* 1185006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1185009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1185017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1185020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1185026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1185029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1185062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185084 */     // GIR_Coverage, 8609,
     /* 1185084 */     GIR_EraseRootFromParent_Done,
     /* 1185085 */   // Label 17211: @1185085
     /* 1185085 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1185169), // Rule ID 8612 //
     /* 1185090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1185093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1185101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1185104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1185110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1185113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185143 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1185146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185168 */     // GIR_Coverage, 8612,
     /* 1185168 */     GIR_EraseRootFromParent_Done,
     /* 1185169 */   // Label 17212: @1185169
     /* 1185169 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1185253), // Rule ID 8613 //
     /* 1185174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1185177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1185185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1185188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1185194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1185197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185227 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1185230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185252 */     // GIR_Coverage, 8613,
     /* 1185252 */     GIR_EraseRootFromParent_Done,
     /* 1185253 */   // Label 17213: @1185253
     /* 1185253 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1185337), // Rule ID 8616 //
     /* 1185258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1185261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1185269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1185272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1185278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1185281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1185314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185336 */     // GIR_Coverage, 8616,
     /* 1185336 */     GIR_EraseRootFromParent_Done,
     /* 1185337 */   // Label 17214: @1185337
     /* 1185337 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1185421), // Rule ID 8617 //
     /* 1185342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1185345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1185353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1185356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1185362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1185365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1185398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185420 */     // GIR_Coverage, 8617,
     /* 1185420 */     GIR_EraseRootFromParent_Done,
     /* 1185421 */   // Label 17215: @1185421
     /* 1185421 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1185505), // Rule ID 8620 //
     /* 1185426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1185437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1185440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1185443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1185449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1185482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185504 */     // GIR_Coverage, 8620,
     /* 1185504 */     GIR_EraseRootFromParent_Done,
     /* 1185505 */   // Label 17216: @1185505
     /* 1185505 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1185589), // Rule ID 8621 //
     /* 1185510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1185521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1185524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1185527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1185533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1185566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185588 */     // GIR_Coverage, 8621,
     /* 1185588 */     GIR_EraseRootFromParent_Done,
     /* 1185589 */   // Label 17217: @1185589
     /* 1185589 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1185673), // Rule ID 8624 //
     /* 1185594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1185605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1185608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1185611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1185617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1185650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185672 */     // GIR_Coverage, 8624,
     /* 1185672 */     GIR_EraseRootFromParent_Done,
     /* 1185673 */   // Label 17218: @1185673
     /* 1185673 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1185757), // Rule ID 8625 //
     /* 1185678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1185689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1185692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1185695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1185701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185731 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1185734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185756 */     // GIR_Coverage, 8625,
     /* 1185756 */     GIR_EraseRootFromParent_Done,
     /* 1185757 */   // Label 17219: @1185757
     /* 1185757 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1185841), // Rule ID 8628 //
     /* 1185762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1185773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1185776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1185779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1185785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185815 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1185818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185840 */     // GIR_Coverage, 8628,
     /* 1185840 */     GIR_EraseRootFromParent_Done,
     /* 1185841 */   // Label 17220: @1185841
     /* 1185841 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1185925), // Rule ID 8629 //
     /* 1185846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1185857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1185860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1185863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1185869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1185899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1185902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1185923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185924 */     // GIR_Coverage, 8629,
     /* 1185924 */     GIR_EraseRootFromParent_Done,
     /* 1185925 */   // Label 17221: @1185925
     /* 1185925 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1186009), // Rule ID 8632 //
     /* 1185930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1185938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1185941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1185944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1185953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1185976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1185983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1185986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1185996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186008 */     // GIR_Coverage, 8632,
     /* 1186008 */     GIR_EraseRootFromParent_Done,
     /* 1186009 */   // Label 17222: @1186009
     /* 1186009 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1186093), // Rule ID 8633 //
     /* 1186014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1186025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1186028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1186031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1186037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1186070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186092 */     // GIR_Coverage, 8633,
     /* 1186092 */     GIR_EraseRootFromParent_Done,
     /* 1186093 */   // Label 17223: @1186093
     /* 1186093 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1186177), // Rule ID 8636 //
     /* 1186098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1186109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1186112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1186121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1186154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186176 */     // GIR_Coverage, 8636,
     /* 1186176 */     GIR_EraseRootFromParent_Done,
     /* 1186177 */   // Label 17224: @1186177
     /* 1186177 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1186261), // Rule ID 8637 //
     /* 1186182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1186193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1186196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1186205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186235 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1186238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186260 */     // GIR_Coverage, 8637,
     /* 1186260 */     GIR_EraseRootFromParent_Done,
     /* 1186261 */   // Label 17225: @1186261
     /* 1186261 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1186345), // Rule ID 8640 //
     /* 1186266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1186277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1186280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1186289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186319 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1186322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186344 */     // GIR_Coverage, 8640,
     /* 1186344 */     GIR_EraseRootFromParent_Done,
     /* 1186345 */   // Label 17226: @1186345
     /* 1186345 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1186429), // Rule ID 8641 //
     /* 1186350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1186361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1186364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1186373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1186406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186428 */     // GIR_Coverage, 8641,
     /* 1186428 */     GIR_EraseRootFromParent_Done,
     /* 1186429 */   // Label 17227: @1186429
     /* 1186429 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1186513), // Rule ID 8644 //
     /* 1186434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1186445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1186448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1186451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1186457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186512 */     // GIR_Coverage, 8644,
     /* 1186512 */     GIR_EraseRootFromParent_Done,
     /* 1186513 */   // Label 17228: @1186513
     /* 1186513 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1186597), // Rule ID 8645 //
     /* 1186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1186529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1186532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1186535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1186541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186596 */     // GIR_Coverage, 8645,
     /* 1186596 */     GIR_EraseRootFromParent_Done,
     /* 1186597 */   // Label 17229: @1186597
     /* 1186597 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1186681), // Rule ID 8648 //
     /* 1186602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1186613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1186616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1186625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186655 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186680 */     // GIR_Coverage, 8648,
     /* 1186680 */     GIR_EraseRootFromParent_Done,
     /* 1186681 */   // Label 17230: @1186681
     /* 1186681 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1186765), // Rule ID 8649 //
     /* 1186686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1186697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1186700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1186709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186739 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186764 */     // GIR_Coverage, 8649,
     /* 1186764 */     GIR_EraseRootFromParent_Done,
     /* 1186765 */   // Label 17231: @1186765
     /* 1186765 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1186849), // Rule ID 8652 //
     /* 1186770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1186781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1186784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1186793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186823 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186848 */     // GIR_Coverage, 8652,
     /* 1186848 */     GIR_EraseRootFromParent_Done,
     /* 1186849 */   // Label 17232: @1186849
     /* 1186849 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1186933), // Rule ID 8653 //
     /* 1186854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1186865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1186868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1186877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186907 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1186907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1186920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1186931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186932 */     // GIR_Coverage, 8653,
     /* 1186932 */     GIR_EraseRootFromParent_Done,
     /* 1186933 */   // Label 17233: @1186933
     /* 1186933 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1187017), // Rule ID 8656 //
     /* 1186938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1186941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1186946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1186949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1186952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1186955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1186961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1186984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186991 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1186991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1186994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1187012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187016 */     // GIR_Coverage, 8656,
     /* 1187016 */     GIR_EraseRootFromParent_Done,
     /* 1187017 */   // Label 17234: @1187017
     /* 1187017 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1187101), // Rule ID 8657 //
     /* 1187022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1187025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1187033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1187036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1187045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1187078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1187096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187100 */     // GIR_Coverage, 8657,
     /* 1187100 */     GIR_EraseRootFromParent_Done,
     /* 1187101 */   // Label 17235: @1187101
     /* 1187101 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1187185), // Rule ID 8660 //
     /* 1187106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1187117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1187120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1187123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1187129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187159 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1187162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187184 */     // GIR_Coverage, 8660,
     /* 1187184 */     GIR_EraseRootFromParent_Done,
     /* 1187185 */   // Label 17236: @1187185
     /* 1187185 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1187269), // Rule ID 8661 //
     /* 1187190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1187201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1187204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1187207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1187213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187243 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1187246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187268 */     // GIR_Coverage, 8661,
     /* 1187268 */     GIR_EraseRootFromParent_Done,
     /* 1187269 */   // Label 17237: @1187269
     /* 1187269 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1187353), // Rule ID 8664 //
     /* 1187274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1187285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1187288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1187291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1187297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187327 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1187330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187352 */     // GIR_Coverage, 8664,
     /* 1187352 */     GIR_EraseRootFromParent_Done,
     /* 1187353 */   // Label 17238: @1187353
     /* 1187353 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1187437), // Rule ID 8665 //
     /* 1187358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1187369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1187372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1187375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1187381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187411 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1187414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187436 */     // GIR_Coverage, 8665,
     /* 1187436 */     GIR_EraseRootFromParent_Done,
     /* 1187437 */   // Label 17239: @1187437
     /* 1187437 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1187521), // Rule ID 8668 //
     /* 1187442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1187453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1187456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1187459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1187465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187495 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1187498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187520 */     // GIR_Coverage, 8668,
     /* 1187520 */     GIR_EraseRootFromParent_Done,
     /* 1187521 */   // Label 17240: @1187521
     /* 1187521 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1187605), // Rule ID 8669 //
     /* 1187526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1187537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1187540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1187543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1187549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187579 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1187582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187604 */     // GIR_Coverage, 8669,
     /* 1187604 */     GIR_EraseRootFromParent_Done,
     /* 1187605 */   // Label 17241: @1187605
     /* 1187605 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1187689), // Rule ID 8672 //
     /* 1187610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1187621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1187624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1187627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1187633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187663 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1187666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187688 */     // GIR_Coverage, 8672,
     /* 1187688 */     GIR_EraseRootFromParent_Done,
     /* 1187689 */   // Label 17242: @1187689
     /* 1187689 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1187773), // Rule ID 8673 //
     /* 1187694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1187705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1187708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1187711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1187717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187747 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1187750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187772 */     // GIR_Coverage, 8673,
     /* 1187772 */     GIR_EraseRootFromParent_Done,
     /* 1187773 */   // Label 17243: @1187773
     /* 1187773 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1187857), // Rule ID 8676 //
     /* 1187778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1187789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1187792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1187795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1187801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187831 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1187834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187856 */     // GIR_Coverage, 8676,
     /* 1187856 */     GIR_EraseRootFromParent_Done,
     /* 1187857 */   // Label 17244: @1187857
     /* 1187857 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1187941), // Rule ID 8677 //
     /* 1187862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1187873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1187876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1187879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1187885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1187915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1187918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1187928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1187939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187940 */     // GIR_Coverage, 8677,
     /* 1187940 */     GIR_EraseRootFromParent_Done,
     /* 1187941 */   // Label 17245: @1187941
     /* 1187941 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1188025), // Rule ID 8680 //
     /* 1187946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1187954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1187957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1187960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1187969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1187992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187999 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1187999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1188002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188024 */     // GIR_Coverage, 8680,
     /* 1188024 */     GIR_EraseRootFromParent_Done,
     /* 1188025 */   // Label 17246: @1188025
     /* 1188025 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1188109), // Rule ID 8681 //
     /* 1188030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1188041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1188044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1188047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1188053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188083 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1188086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188108 */     // GIR_Coverage, 8681,
     /* 1188108 */     GIR_EraseRootFromParent_Done,
     /* 1188109 */   // Label 17247: @1188109
     /* 1188109 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1188193), // Rule ID 8684 //
     /* 1188114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1188125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1188128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1188131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1188137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1188167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1188170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188192 */     // GIR_Coverage, 8684,
     /* 1188192 */     GIR_EraseRootFromParent_Done,
     /* 1188193 */   // Label 17248: @1188193
     /* 1188193 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1188277), // Rule ID 8685 //
     /* 1188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1188215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1188221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188251 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1188254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188276 */     // GIR_Coverage, 8685,
     /* 1188276 */     GIR_EraseRootFromParent_Done,
     /* 1188277 */   // Label 17249: @1188277
     /* 1188277 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1188361), // Rule ID 8688 //
     /* 1188282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1188293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1188296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1188299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1188305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1188335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1188338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188360 */     // GIR_Coverage, 8688,
     /* 1188360 */     GIR_EraseRootFromParent_Done,
     /* 1188361 */   // Label 17250: @1188361
     /* 1188361 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1188445), // Rule ID 8689 //
     /* 1188366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1188377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1188380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1188383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1188389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188419 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1188422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188444 */     // GIR_Coverage, 8689,
     /* 1188444 */     GIR_EraseRootFromParent_Done,
     /* 1188445 */   // Label 17251: @1188445
     /* 1188445 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1188529), // Rule ID 8692 //
     /* 1188450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1188461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1188464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1188467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1188473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1188503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1188506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188528 */     // GIR_Coverage, 8692,
     /* 1188528 */     GIR_EraseRootFromParent_Done,
     /* 1188529 */   // Label 17252: @1188529
     /* 1188529 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1188613), // Rule ID 8693 //
     /* 1188534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1188545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1188548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1188551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1188557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1188590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188612 */     // GIR_Coverage, 8693,
     /* 1188612 */     GIR_EraseRootFromParent_Done,
     /* 1188613 */   // Label 17253: @1188613
     /* 1188613 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1188697), // Rule ID 8696 //
     /* 1188618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1188621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1188629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1188632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1188641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188671 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1188671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1188674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188696 */     // GIR_Coverage, 8696,
     /* 1188696 */     GIR_EraseRootFromParent_Done,
     /* 1188697 */   // Label 17254: @1188697
     /* 1188697 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1188781), // Rule ID 8697 //
     /* 1188702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1188705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1188713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1188716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1188725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1188758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188780 */     // GIR_Coverage, 8697,
     /* 1188780 */     GIR_EraseRootFromParent_Done,
     /* 1188781 */   // Label 17255: @1188781
     /* 1188781 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1188865), // Rule ID 8700 //
     /* 1188786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1188789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1188797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1188800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1188809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1188839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1188842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188864 */     // GIR_Coverage, 8700,
     /* 1188864 */     GIR_EraseRootFromParent_Done,
     /* 1188865 */   // Label 17256: @1188865
     /* 1188865 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1188949), // Rule ID 8701 //
     /* 1188870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1188873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1188881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1188884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1188893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1188916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188923 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1188923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1188926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1188936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1188947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188948 */     // GIR_Coverage, 8701,
     /* 1188948 */     GIR_EraseRootFromParent_Done,
     /* 1188949 */   // Label 17257: @1188949
     /* 1188949 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1189033), // Rule ID 8704 //
     /* 1188954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1188957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1188962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1188965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1188968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1188977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1189010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189032 */     // GIR_Coverage, 8704,
     /* 1189032 */     GIR_EraseRootFromParent_Done,
     /* 1189033 */   // Label 17258: @1189033
     /* 1189033 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1189117), // Rule ID 8705 //
     /* 1189038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1189041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1189046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1189049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1189052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1189055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1189058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1189061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1189094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189116 */     // GIR_Coverage, 8705,
     /* 1189116 */     GIR_EraseRootFromParent_Done,
     /* 1189117 */   // Label 17259: @1189117
     /* 1189117 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1189201), // Rule ID 8796 //
     /* 1189122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1189133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1189136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1189139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1189142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1189145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189175 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1189178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189200 */     // GIR_Coverage, 8796,
     /* 1189200 */     GIR_EraseRootFromParent_Done,
     /* 1189201 */   // Label 17260: @1189201
     /* 1189201 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1189285), // Rule ID 8797 //
     /* 1189206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1189217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1189220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1189223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1189226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1189229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189259 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1189262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189284 */     // GIR_Coverage, 8797,
     /* 1189284 */     GIR_EraseRootFromParent_Done,
     /* 1189285 */   // Label 17261: @1189285
     /* 1189285 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1189369), // Rule ID 8800 //
     /* 1189290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1189301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1189304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1189307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1189310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1189313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189343 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1189346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189368 */     // GIR_Coverage, 8800,
     /* 1189368 */     GIR_EraseRootFromParent_Done,
     /* 1189369 */   // Label 17262: @1189369
     /* 1189369 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1189453), // Rule ID 8801 //
     /* 1189374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1189385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1189388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1189391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1189394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1189397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1189430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189452 */     // GIR_Coverage, 8801,
     /* 1189452 */     GIR_EraseRootFromParent_Done,
     /* 1189453 */   // Label 17263: @1189453
     /* 1189453 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1189537), // Rule ID 8804 //
     /* 1189458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1189469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1189472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1189475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1189478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1189481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189511 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1189514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189536 */     // GIR_Coverage, 8804,
     /* 1189536 */     GIR_EraseRootFromParent_Done,
     /* 1189537 */   // Label 17264: @1189537
     /* 1189537 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1189621), // Rule ID 8805 //
     /* 1189542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1189553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1189556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1189559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1189562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1189565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1189598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189620 */     // GIR_Coverage, 8805,
     /* 1189620 */     GIR_EraseRootFromParent_Done,
     /* 1189621 */   // Label 17265: @1189621
     /* 1189621 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1189705), // Rule ID 8808 //
     /* 1189626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1189637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1189640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1189643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1189646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1189649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189679 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1189682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189704 */     // GIR_Coverage, 8808,
     /* 1189704 */     GIR_EraseRootFromParent_Done,
     /* 1189705 */   // Label 17266: @1189705
     /* 1189705 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1189789), // Rule ID 8809 //
     /* 1189710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1189721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1189724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1189727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1189730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1189733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189763 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1189766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189788 */     // GIR_Coverage, 8809,
     /* 1189788 */     GIR_EraseRootFromParent_Done,
     /* 1189789 */   // Label 17267: @1189789
     /* 1189789 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1189873), // Rule ID 8812 //
     /* 1189794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1189805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1189808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1189811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1189814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1189817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189847 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1189847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1189850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189872 */     // GIR_Coverage, 8812,
     /* 1189872 */     GIR_EraseRootFromParent_Done,
     /* 1189873 */   // Label 17268: @1189873
     /* 1189873 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1189957), // Rule ID 8813 //
     /* 1189878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1189889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1189892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1189895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1189898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1189901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1189924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189931 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1189931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1189934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1189944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1189955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189956 */     // GIR_Coverage, 8813,
     /* 1189956 */     GIR_EraseRootFromParent_Done,
     /* 1189957 */   // Label 17269: @1189957
     /* 1189957 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1190041), // Rule ID 8816 //
     /* 1189962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1189970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1189973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1189976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1189979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1189982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1189985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1190018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190040 */     // GIR_Coverage, 8816,
     /* 1190040 */     GIR_EraseRootFromParent_Done,
     /* 1190041 */   // Label 17270: @1190041
     /* 1190041 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1190125), // Rule ID 8817 //
     /* 1190046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1190057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1190060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1190066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1190069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190099 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1190102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190124 */     // GIR_Coverage, 8817,
     /* 1190124 */     GIR_EraseRootFromParent_Done,
     /* 1190125 */   // Label 17271: @1190125
     /* 1190125 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1190209), // Rule ID 8820 //
     /* 1190130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1190141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1190144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1190147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1190150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1190153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190183 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190208 */     // GIR_Coverage, 8820,
     /* 1190208 */     GIR_EraseRootFromParent_Done,
     /* 1190209 */   // Label 17272: @1190209
     /* 1190209 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1190293), // Rule ID 8821 //
     /* 1190214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1190225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1190228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1190231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1190234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1190237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190292 */     // GIR_Coverage, 8821,
     /* 1190292 */     GIR_EraseRootFromParent_Done,
     /* 1190293 */   // Label 17273: @1190293
     /* 1190293 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1190377), // Rule ID 8824 //
     /* 1190298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1190309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1190312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1190315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1190318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1190321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190351 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190376 */     // GIR_Coverage, 8824,
     /* 1190376 */     GIR_EraseRootFromParent_Done,
     /* 1190377 */   // Label 17274: @1190377
     /* 1190377 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1190461), // Rule ID 8825 //
     /* 1190382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1190393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1190396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1190399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1190402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1190405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190460 */     // GIR_Coverage, 8825,
     /* 1190460 */     GIR_EraseRootFromParent_Done,
     /* 1190461 */   // Label 17275: @1190461
     /* 1190461 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1190545), // Rule ID 8828 //
     /* 1190466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1190477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1190480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1190486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1190489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190544 */     // GIR_Coverage, 8828,
     /* 1190544 */     GIR_EraseRootFromParent_Done,
     /* 1190545 */   // Label 17276: @1190545
     /* 1190545 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1190629), // Rule ID 8829 //
     /* 1190550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1190561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1190564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1190570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1190573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190603 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190628 */     // GIR_Coverage, 8829,
     /* 1190628 */     GIR_EraseRootFromParent_Done,
     /* 1190629 */   // Label 17277: @1190629
     /* 1190629 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1190713), // Rule ID 8832 //
     /* 1190634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1190637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1190645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1190648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1190651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1190654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1190657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190712 */     // GIR_Coverage, 8832,
     /* 1190712 */     GIR_EraseRootFromParent_Done,
     /* 1190713 */   // Label 17278: @1190713
     /* 1190713 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1190797), // Rule ID 8833 //
     /* 1190718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1190721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1190729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1190732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1190735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1190738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1190741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1190774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190796 */     // GIR_Coverage, 8833,
     /* 1190796 */     GIR_EraseRootFromParent_Done,
     /* 1190797 */   // Label 17279: @1190797
     /* 1190797 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1190881), // Rule ID 8836 //
     /* 1190802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1190813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1190816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1190819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1190822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1190825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190855 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1190855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1190858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190880 */     // GIR_Coverage, 8836,
     /* 1190880 */     GIR_EraseRootFromParent_Done,
     /* 1190881 */   // Label 17280: @1190881
     /* 1190881 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1190965), // Rule ID 8837 //
     /* 1190886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1190897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1190900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1190903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1190906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1190909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1190932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190939 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1190939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1190942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1190952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1190963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190964 */     // GIR_Coverage, 8837,
     /* 1190964 */     GIR_EraseRootFromParent_Done,
     /* 1190965 */   // Label 17281: @1190965
     /* 1190965 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1191049), // Rule ID 8840 //
     /* 1190970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1190978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1190981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1190984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1190987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1190990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1190993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191023 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1191026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1191044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191048 */     // GIR_Coverage, 8840,
     /* 1191048 */     GIR_EraseRootFromParent_Done,
     /* 1191049 */   // Label 17282: @1191049
     /* 1191049 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1191133), // Rule ID 8841 //
     /* 1191054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1191065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1191068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1191071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1191074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1191077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191107 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1191110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1191128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191132 */     // GIR_Coverage, 8841,
     /* 1191132 */     GIR_EraseRootFromParent_Done,
     /* 1191133 */   // Label 17283: @1191133
     /* 1191133 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1191217), // Rule ID 8844 //
     /* 1191138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1191149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1191152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1191155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1191158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1191161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191191 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1191194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1191212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191216 */     // GIR_Coverage, 8844,
     /* 1191216 */     GIR_EraseRootFromParent_Done,
     /* 1191217 */   // Label 17284: @1191217
     /* 1191217 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1191301), // Rule ID 8845 //
     /* 1191222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1191233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1191236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1191239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1191242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1191245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191275 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1191278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1191296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191300 */     // GIR_Coverage, 8845,
     /* 1191300 */     GIR_EraseRootFromParent_Done,
     /* 1191301 */   // Label 17285: @1191301
     /* 1191301 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1191385), // Rule ID 8848 //
     /* 1191306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1191317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1191320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1191326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1191329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1191362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191384 */     // GIR_Coverage, 8848,
     /* 1191384 */     GIR_EraseRootFromParent_Done,
     /* 1191385 */   // Label 17286: @1191385
     /* 1191385 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1191469), // Rule ID 8849 //
     /* 1191390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1191401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1191404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1191410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1191413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1191446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191468 */     // GIR_Coverage, 8849,
     /* 1191468 */     GIR_EraseRootFromParent_Done,
     /* 1191469 */   // Label 17287: @1191469
     /* 1191469 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1191553), // Rule ID 8852 //
     /* 1191474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1191485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1191488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1191494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1191497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191527 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1191530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191552 */     // GIR_Coverage, 8852,
     /* 1191552 */     GIR_EraseRootFromParent_Done,
     /* 1191553 */   // Label 17288: @1191553
     /* 1191553 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1191637), // Rule ID 8853 //
     /* 1191558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1191569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1191572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1191578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1191581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191611 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1191614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191636 */     // GIR_Coverage, 8853,
     /* 1191636 */     GIR_EraseRootFromParent_Done,
     /* 1191637 */   // Label 17289: @1191637
     /* 1191637 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1191721), // Rule ID 8856 //
     /* 1191642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1191653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1191656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1191662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1191665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191695 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1191698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191720 */     // GIR_Coverage, 8856,
     /* 1191720 */     GIR_EraseRootFromParent_Done,
     /* 1191721 */   // Label 17290: @1191721
     /* 1191721 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1191805), // Rule ID 8857 //
     /* 1191726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1191737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1191740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1191746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1191749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191779 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1191782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191804 */     // GIR_Coverage, 8857,
     /* 1191804 */     GIR_EraseRootFromParent_Done,
     /* 1191805 */   // Label 17291: @1191805
     /* 1191805 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1191889), // Rule ID 8860 //
     /* 1191810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1191821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1191824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1191830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1191833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1191863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1191866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191888 */     // GIR_Coverage, 8860,
     /* 1191888 */     GIR_EraseRootFromParent_Done,
     /* 1191889 */   // Label 17292: @1191889
     /* 1191889 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1191973), // Rule ID 8861 //
     /* 1191894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1191905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1191908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1191914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1191917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1191940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191947 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1191947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1191950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1191960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1191971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191972 */     // GIR_Coverage, 8861,
     /* 1191972 */     GIR_EraseRootFromParent_Done,
     /* 1191973 */   // Label 17293: @1191973
     /* 1191973 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1192057), // Rule ID 8864 //
     /* 1191978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1191986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1191989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1191992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1191995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1191998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1192001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192031 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1192034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192056 */     // GIR_Coverage, 8864,
     /* 1192056 */     GIR_EraseRootFromParent_Done,
     /* 1192057 */   // Label 17294: @1192057
     /* 1192057 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1192141), // Rule ID 8865 //
     /* 1192062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1192065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1192073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1192076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1192082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1192085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192115 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1192118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192140 */     // GIR_Coverage, 8865,
     /* 1192140 */     GIR_EraseRootFromParent_Done,
     /* 1192141 */   // Label 17295: @1192141
     /* 1192141 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1192225), // Rule ID 8868 //
     /* 1192146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1192149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1192157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1192160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1192166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1192169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192199 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1192202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192224 */     // GIR_Coverage, 8868,
     /* 1192224 */     GIR_EraseRootFromParent_Done,
     /* 1192225 */   // Label 17296: @1192225
     /* 1192225 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1192309), // Rule ID 8869 //
     /* 1192230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1192233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1192241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1192244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1192250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1192253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1192286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192308 */     // GIR_Coverage, 8869,
     /* 1192308 */     GIR_EraseRootFromParent_Done,
     /* 1192309 */   // Label 17297: @1192309
     /* 1192309 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1192393), // Rule ID 8872 //
     /* 1192314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1192317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1192325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1192328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1192334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1192337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192367 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1192370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192392 */     // GIR_Coverage, 8872,
     /* 1192392 */     GIR_EraseRootFromParent_Done,
     /* 1192393 */   // Label 17298: @1192393
     /* 1192393 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1192477), // Rule ID 8873 //
     /* 1192398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1192401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1192409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1192412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1192418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1192421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192451 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1192454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192476 */     // GIR_Coverage, 8873,
     /* 1192476 */     GIR_EraseRootFromParent_Done,
     /* 1192477 */   // Label 17299: @1192477
     /* 1192477 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1192561), // Rule ID 8876 //
     /* 1192482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1192485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1192493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1192496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1192502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1192505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1192538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192560 */     // GIR_Coverage, 8876,
     /* 1192560 */     GIR_EraseRootFromParent_Done,
     /* 1192561 */   // Label 17300: @1192561
     /* 1192561 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1192645), // Rule ID 8877 //
     /* 1192566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1192569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1192577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1192580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1192586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1192589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1192622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192644 */     // GIR_Coverage, 8877,
     /* 1192644 */     GIR_EraseRootFromParent_Done,
     /* 1192645 */   // Label 17301: @1192645
     /* 1192645 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1192729), // Rule ID 8880 //
     /* 1192650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1192653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1192661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1192664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1192670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1192673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192703 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1192706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192728 */     // GIR_Coverage, 8880,
     /* 1192728 */     GIR_EraseRootFromParent_Done,
     /* 1192729 */   // Label 17302: @1192729
     /* 1192729 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1192813), // Rule ID 8881 //
     /* 1192734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1192737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1192745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1192748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1192754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1192757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192787 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1192790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192812 */     // GIR_Coverage, 8881,
     /* 1192812 */     GIR_EraseRootFromParent_Done,
     /* 1192813 */   // Label 17303: @1192813
     /* 1192813 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1192897), // Rule ID 8884 //
     /* 1192818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1192821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1192829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1192832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1192835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1192841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1192860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192871 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1192871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1192874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1192892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192896 */     // GIR_Coverage, 8884,
     /* 1192896 */     GIR_EraseRootFromParent_Done,
     /* 1192897 */   // Label 17304: @1192897
     /* 1192897 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1192981), // Rule ID 8885 //
     /* 1192902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1192905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1192913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1192916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1192919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1192925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1192944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1192948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192955 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1192955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1192958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1192968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1192976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1192979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192980 */     // GIR_Coverage, 8885,
     /* 1192980 */     GIR_EraseRootFromParent_Done,
     /* 1192981 */   // Label 17305: @1192981
     /* 1192981 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1193065), // Rule ID 8888 //
     /* 1192986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1192989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1192994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1192997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1193000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1193003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1193009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1193042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193064 */     // GIR_Coverage, 8888,
     /* 1193064 */     GIR_EraseRootFromParent_Done,
     /* 1193065 */   // Label 17306: @1193065
     /* 1193065 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1193149), // Rule ID 8889 //
     /* 1193070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1193081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1193084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1193087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1193093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193123 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1193126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193148 */     // GIR_Coverage, 8889,
     /* 1193148 */     GIR_EraseRootFromParent_Done,
     /* 1193149 */   // Label 17307: @1193149
     /* 1193149 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1193233), // Rule ID 8892 //
     /* 1193154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1193165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1193168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1193171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1193177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193232 */     // GIR_Coverage, 8892,
     /* 1193232 */     GIR_EraseRootFromParent_Done,
     /* 1193233 */   // Label 17308: @1193233
     /* 1193233 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1193317), // Rule ID 8893 //
     /* 1193238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1193249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1193252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1193255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1193261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193316 */     // GIR_Coverage, 8893,
     /* 1193316 */     GIR_EraseRootFromParent_Done,
     /* 1193317 */   // Label 17309: @1193317
     /* 1193317 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1193401), // Rule ID 8896 //
     /* 1193322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1193333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1193336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1193345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193375 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1193378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193400 */     // GIR_Coverage, 8896,
     /* 1193400 */     GIR_EraseRootFromParent_Done,
     /* 1193401 */   // Label 17310: @1193401
     /* 1193401 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1193485), // Rule ID 8897 //
     /* 1193406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1193417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1193420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1193429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193459 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1193462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193484 */     // GIR_Coverage, 8897,
     /* 1193484 */     GIR_EraseRootFromParent_Done,
     /* 1193485 */   // Label 17311: @1193485
     /* 1193485 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1193569), // Rule ID 8900 //
     /* 1193490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1193501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1193504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1193513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193543 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193568 */     // GIR_Coverage, 8900,
     /* 1193568 */     GIR_EraseRootFromParent_Done,
     /* 1193569 */   // Label 17312: @1193569
     /* 1193569 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1193653), // Rule ID 8901 //
     /* 1193574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1193585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1193588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1193597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193652 */     // GIR_Coverage, 8901,
     /* 1193652 */     GIR_EraseRootFromParent_Done,
     /* 1193653 */   // Label 17313: @1193653
     /* 1193653 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1193737), // Rule ID 8904 //
     /* 1193658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1193669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1193672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1193681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193711 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193736 */     // GIR_Coverage, 8904,
     /* 1193736 */     GIR_EraseRootFromParent_Done,
     /* 1193737 */   // Label 17314: @1193737
     /* 1193737 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1193821), // Rule ID 8905 //
     /* 1193742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1193753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1193756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1193765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193795 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1193798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193820 */     // GIR_Coverage, 8905,
     /* 1193820 */     GIR_EraseRootFromParent_Done,
     /* 1193821 */   // Label 17315: @1193821
     /* 1193821 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1193905), // Rule ID 8908 //
     /* 1193826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1193837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1193840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1193843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1193849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1193879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1193882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193904 */     // GIR_Coverage, 8908,
     /* 1193904 */     GIR_EraseRootFromParent_Done,
     /* 1193905 */   // Label 17316: @1193905
     /* 1193905 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1193989), // Rule ID 8909 //
     /* 1193910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1193913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1193918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1193921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1193924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1193927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1193933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1193952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1193956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193963 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1193963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1193966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1193976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1193984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1193987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193988 */     // GIR_Coverage, 8909,
     /* 1193988 */     GIR_EraseRootFromParent_Done,
     /* 1193989 */   // Label 17317: @1193989
     /* 1193989 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1194073), // Rule ID 8912 //
     /* 1193994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1193997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1194005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1194008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1194011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1194017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194072 */     // GIR_Coverage, 8912,
     /* 1194072 */     GIR_EraseRootFromParent_Done,
     /* 1194073 */   // Label 17318: @1194073
     /* 1194073 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1194157), // Rule ID 8913 //
     /* 1194078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1194081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1194089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1194092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1194095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1194101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194156 */     // GIR_Coverage, 8913,
     /* 1194156 */     GIR_EraseRootFromParent_Done,
     /* 1194157 */   // Label 17319: @1194157
     /* 1194157 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1194241), // Rule ID 8916 //
     /* 1194162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1194165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1194173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1194176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1194185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194215 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194240 */     // GIR_Coverage, 8916,
     /* 1194240 */     GIR_EraseRootFromParent_Done,
     /* 1194241 */   // Label 17320: @1194241
     /* 1194241 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1194325), // Rule ID 8917 //
     /* 1194246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1194249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1194257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1194260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1194269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194299 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194324 */     // GIR_Coverage, 8917,
     /* 1194324 */     GIR_EraseRootFromParent_Done,
     /* 1194325 */   // Label 17321: @1194325
     /* 1194325 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1194409), // Rule ID 8920 //
     /* 1194330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1194333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1194341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1194344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1194353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194408 */     // GIR_Coverage, 8920,
     /* 1194408 */     GIR_EraseRootFromParent_Done,
     /* 1194409 */   // Label 17322: @1194409
     /* 1194409 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1194493), // Rule ID 8921 //
     /* 1194414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1194417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1194425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1194428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1194437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1194470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194492 */     // GIR_Coverage, 8921,
     /* 1194492 */     GIR_EraseRootFromParent_Done,
     /* 1194493 */   // Label 17323: @1194493
     /* 1194493 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1194577), // Rule ID 8924 //
     /* 1194498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1194501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1194509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1194512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1194515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1194521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194551 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1194554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194576 */     // GIR_Coverage, 8924,
     /* 1194576 */     GIR_EraseRootFromParent_Done,
     /* 1194577 */   // Label 17324: @1194577
     /* 1194577 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1194661), // Rule ID 8925 //
     /* 1194582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1194585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1194593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1194596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1194599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1194605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1194638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194660 */     // GIR_Coverage, 8925,
     /* 1194660 */     GIR_EraseRootFromParent_Done,
     /* 1194661 */   // Label 17325: @1194661
     /* 1194661 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1194745), // Rule ID 8928 //
     /* 1194666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1194669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1194677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1194680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1194683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1194689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194719 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1194722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194744 */     // GIR_Coverage, 8928,
     /* 1194744 */     GIR_EraseRootFromParent_Done,
     /* 1194745 */   // Label 17326: @1194745
     /* 1194745 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1194829), // Rule ID 8929 //
     /* 1194750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1194753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1194761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1194764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1194767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1194773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194803 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1194806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194828 */     // GIR_Coverage, 8929,
     /* 1194828 */     GIR_EraseRootFromParent_Done,
     /* 1194829 */   // Label 17327: @1194829
     /* 1194829 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1194913), // Rule ID 8932 //
     /* 1194834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1194837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1194845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1194848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1194851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1194857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194887 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1194887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1194890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194912 */     // GIR_Coverage, 8932,
     /* 1194912 */     GIR_EraseRootFromParent_Done,
     /* 1194913 */   // Label 17328: @1194913
     /* 1194913 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1194997), // Rule ID 8933 //
     /* 1194918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1194921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1194926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1194929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1194932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1194935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1194941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1194960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1194964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194971 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1194971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1194974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1194984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1194992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1194995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194996 */     // GIR_Coverage, 8933,
     /* 1194996 */     GIR_EraseRootFromParent_Done,
     /* 1194997 */   // Label 17329: @1194997
     /* 1194997 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1195081), // Rule ID 8936 //
     /* 1195002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1195013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1195016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1195025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195055 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1195058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195080 */     // GIR_Coverage, 8936,
     /* 1195080 */     GIR_EraseRootFromParent_Done,
     /* 1195081 */   // Label 17330: @1195081
     /* 1195081 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1195165), // Rule ID 8937 //
     /* 1195086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1195097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1195100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1195109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1195142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195164 */     // GIR_Coverage, 8937,
     /* 1195164 */     GIR_EraseRootFromParent_Done,
     /* 1195165 */   // Label 17331: @1195165
     /* 1195165 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1195249), // Rule ID 8940 //
     /* 1195170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1195181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1195184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1195187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1195193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195223 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1195226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195248 */     // GIR_Coverage, 8940,
     /* 1195248 */     GIR_EraseRootFromParent_Done,
     /* 1195249 */   // Label 17332: @1195249
     /* 1195249 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1195333), // Rule ID 8941 //
     /* 1195254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1195265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1195268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1195271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1195277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195307 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1195310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195332 */     // GIR_Coverage, 8941,
     /* 1195332 */     GIR_EraseRootFromParent_Done,
     /* 1195333 */   // Label 17333: @1195333
     /* 1195333 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1195417), // Rule ID 8944 //
     /* 1195338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1195349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1195352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1195355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1195361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195391 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1195394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195416 */     // GIR_Coverage, 8944,
     /* 1195416 */     GIR_EraseRootFromParent_Done,
     /* 1195417 */   // Label 17334: @1195417
     /* 1195417 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1195501), // Rule ID 8945 //
     /* 1195422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1195433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1195436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1195439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1195445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195475 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1195478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195500 */     // GIR_Coverage, 8945,
     /* 1195500 */     GIR_EraseRootFromParent_Done,
     /* 1195501 */   // Label 17335: @1195501
     /* 1195501 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1195585), // Rule ID 8948 //
     /* 1195506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1195517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1195520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1195523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1195529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195559 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1195562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195584 */     // GIR_Coverage, 8948,
     /* 1195584 */     GIR_EraseRootFromParent_Done,
     /* 1195585 */   // Label 17336: @1195585
     /* 1195585 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1195669), // Rule ID 8949 //
     /* 1195590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1195601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1195604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1195607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1195613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195643 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1195646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195668 */     // GIR_Coverage, 8949,
     /* 1195668 */     GIR_EraseRootFromParent_Done,
     /* 1195669 */   // Label 17337: @1195669
     /* 1195669 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1195753), // Rule ID 8952 //
     /* 1195674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1195685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1195688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1195697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1195730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195752 */     // GIR_Coverage, 8952,
     /* 1195752 */     GIR_EraseRootFromParent_Done,
     /* 1195753 */   // Label 17338: @1195753
     /* 1195753 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1195837), // Rule ID 8953 //
     /* 1195758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1195769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1195772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1195781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195811 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1195814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195836 */     // GIR_Coverage, 8953,
     /* 1195836 */     GIR_EraseRootFromParent_Done,
     /* 1195837 */   // Label 17339: @1195837
     /* 1195837 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1195921), // Rule ID 8956 //
     /* 1195842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1195845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1195853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1195856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1195865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1195895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1195898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1195919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195920 */     // GIR_Coverage, 8956,
     /* 1195920 */     GIR_EraseRootFromParent_Done,
     /* 1195921 */   // Label 17340: @1195921
     /* 1195921 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1196005), // Rule ID 8957 //
     /* 1195926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1195929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1195934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1195937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1195940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1195949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1195968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1195972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195979 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1195979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1195982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1195992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196004 */     // GIR_Coverage, 8957,
     /* 1196004 */     GIR_EraseRootFromParent_Done,
     /* 1196005 */   // Label 17341: @1196005
     /* 1196005 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1196089), // Rule ID 8960 //
     /* 1196010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1196013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1196021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1196024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1196027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1196033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1196066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196088 */     // GIR_Coverage, 8960,
     /* 1196088 */     GIR_EraseRootFromParent_Done,
     /* 1196089 */   // Label 17342: @1196089
     /* 1196089 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1196173), // Rule ID 8961 //
     /* 1196094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1196097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1196105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1196108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1196111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1196117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196147 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1196150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196172 */     // GIR_Coverage, 8961,
     /* 1196172 */     GIR_EraseRootFromParent_Done,
     /* 1196173 */   // Label 17343: @1196173
     /* 1196173 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1196257), // Rule ID 8964 //
     /* 1196178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1196181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1196189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1196192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1196195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1196201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196231 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1196234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196256 */     // GIR_Coverage, 8964,
     /* 1196256 */     GIR_EraseRootFromParent_Done,
     /* 1196257 */   // Label 17344: @1196257
     /* 1196257 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1196341), // Rule ID 8965 //
     /* 1196262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1196265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1196273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1196276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1196279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1196285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1196318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196340 */     // GIR_Coverage, 8965,
     /* 1196340 */     GIR_EraseRootFromParent_Done,
     /* 1196341 */   // Label 17345: @1196341
     /* 1196341 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1196425), // Rule ID 8968 //
     /* 1196346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1196349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1196357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1196360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1196363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1196369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196399 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1196402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196424 */     // GIR_Coverage, 8968,
     /* 1196424 */     GIR_EraseRootFromParent_Done,
     /* 1196425 */   // Label 17346: @1196425
     /* 1196425 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1196509), // Rule ID 8969 //
     /* 1196430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1196433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1196438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1196441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1196444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1196447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1196453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1196486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196508 */     // GIR_Coverage, 8969,
     /* 1196508 */     GIR_EraseRootFromParent_Done,
     /* 1196509 */   // Label 17347: @1196509
     /* 1196509 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1196593), // Rule ID 9060 //
     /* 1196514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1196517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1196525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1196528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1196531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1196537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196567 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1196570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1196588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196592 */     // GIR_Coverage, 9060,
     /* 1196592 */     GIR_EraseRootFromParent_Done,
     /* 1196593 */   // Label 17348: @1196593
     /* 1196593 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1196677), // Rule ID 9061 //
     /* 1196598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1196601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1196609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1196612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1196615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1196621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196651 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1196654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1196672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196676 */     // GIR_Coverage, 9061,
     /* 1196676 */     GIR_EraseRootFromParent_Done,
     /* 1196677 */   // Label 17349: @1196677
     /* 1196677 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1196761), // Rule ID 9064 //
     /* 1196682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1196685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1196693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1196696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1196699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1196705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1196738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1196756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196760 */     // GIR_Coverage, 9064,
     /* 1196760 */     GIR_EraseRootFromParent_Done,
     /* 1196761 */   // Label 17350: @1196761
     /* 1196761 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1196845), // Rule ID 9065 //
     /* 1196766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1196769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1196777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1196780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1196783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1196789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1196822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1196840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196844 */     // GIR_Coverage, 9065,
     /* 1196844 */     GIR_EraseRootFromParent_Done,
     /* 1196845 */   // Label 17351: @1196845
     /* 1196845 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1196929), // Rule ID 9068 //
     /* 1196850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1196853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1196861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1196864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1196867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1196873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1196903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1196906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1196916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1196924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1196927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196928 */     // GIR_Coverage, 9068,
     /* 1196928 */     GIR_EraseRootFromParent_Done,
     /* 1196929 */   // Label 17352: @1196929
     /* 1196929 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1197013), // Rule ID 9069 //
     /* 1196934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1196937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1196942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1196945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1196948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1196951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1196957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1196976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1196980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196987 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1196987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1196990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1197008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197012 */     // GIR_Coverage, 9069,
     /* 1197012 */     GIR_EraseRootFromParent_Done,
     /* 1197013 */   // Label 17353: @1197013
     /* 1197013 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1197097), // Rule ID 9072 //
     /* 1197018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1197029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1197032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1197041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197071 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1197074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197096 */     // GIR_Coverage, 9072,
     /* 1197096 */     GIR_EraseRootFromParent_Done,
     /* 1197097 */   // Label 17354: @1197097
     /* 1197097 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1197181), // Rule ID 9073 //
     /* 1197102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1197113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1197116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1197125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1197158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197180 */     // GIR_Coverage, 9073,
     /* 1197180 */     GIR_EraseRootFromParent_Done,
     /* 1197181 */   // Label 17355: @1197181
     /* 1197181 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1197265), // Rule ID 9076 //
     /* 1197186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1197197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1197200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1197209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1197242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197264 */     // GIR_Coverage, 9076,
     /* 1197264 */     GIR_EraseRootFromParent_Done,
     /* 1197265 */   // Label 17356: @1197265
     /* 1197265 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1197349), // Rule ID 9077 //
     /* 1197270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1197281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1197284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1197293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197323 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1197326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197348 */     // GIR_Coverage, 9077,
     /* 1197348 */     GIR_EraseRootFromParent_Done,
     /* 1197349 */   // Label 17357: @1197349
     /* 1197349 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1197433), // Rule ID 9080 //
     /* 1197354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1197365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1197368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1197377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1197410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197432 */     // GIR_Coverage, 9080,
     /* 1197432 */     GIR_EraseRootFromParent_Done,
     /* 1197433 */   // Label 17358: @1197433
     /* 1197433 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1197517), // Rule ID 9081 //
     /* 1197438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1197449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1197452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1197461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1197494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197516 */     // GIR_Coverage, 9081,
     /* 1197516 */     GIR_EraseRootFromParent_Done,
     /* 1197517 */   // Label 17359: @1197517
     /* 1197517 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1197601), // Rule ID 9084 //
     /* 1197522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1197533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1197536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1197539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1197545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1197596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197600 */     // GIR_Coverage, 9084,
     /* 1197600 */     GIR_EraseRootFromParent_Done,
     /* 1197601 */   // Label 17360: @1197601
     /* 1197601 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1197685), // Rule ID 9085 //
     /* 1197606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1197617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1197620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1197623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1197629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1197680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197684 */     // GIR_Coverage, 9085,
     /* 1197684 */     GIR_EraseRootFromParent_Done,
     /* 1197685 */   // Label 17361: @1197685
     /* 1197685 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1197769), // Rule ID 9088 //
     /* 1197690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1197701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1197704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1197713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197743 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197768 */     // GIR_Coverage, 9088,
     /* 1197768 */     GIR_EraseRootFromParent_Done,
     /* 1197769 */   // Label 17362: @1197769
     /* 1197769 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1197853), // Rule ID 9089 //
     /* 1197774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1197785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1197788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1197797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197827 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197852 */     // GIR_Coverage, 9089,
     /* 1197852 */     GIR_EraseRootFromParent_Done,
     /* 1197853 */   // Label 17363: @1197853
     /* 1197853 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1197937), // Rule ID 9092 //
     /* 1197858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1197861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1197869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1197872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1197881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1197911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1197924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1197935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197936 */     // GIR_Coverage, 9092,
     /* 1197936 */     GIR_EraseRootFromParent_Done,
     /* 1197937 */   // Label 17364: @1197937
     /* 1197937 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1198021), // Rule ID 9093 //
     /* 1197942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1197945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1197950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1197953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1197956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1197965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1197984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1197988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1197995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1197998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198020 */     // GIR_Coverage, 9093,
     /* 1198020 */     GIR_EraseRootFromParent_Done,
     /* 1198021 */   // Label 17365: @1198021
     /* 1198021 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1198105), // Rule ID 9096 //
     /* 1198026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1198029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1198037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1198040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1198049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198079 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1198082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198104 */     // GIR_Coverage, 9096,
     /* 1198104 */     GIR_EraseRootFromParent_Done,
     /* 1198105 */   // Label 17366: @1198105
     /* 1198105 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1198189), // Rule ID 9097 //
     /* 1198110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1198113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1198121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1198124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1198133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198163 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1198163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1198166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198188 */     // GIR_Coverage, 9097,
     /* 1198188 */     GIR_EraseRootFromParent_Done,
     /* 1198189 */   // Label 17367: @1198189
     /* 1198189 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1198273), // Rule ID 9100 //
     /* 1198194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1198197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1198205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1198208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1198211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1198217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1198250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198272 */     // GIR_Coverage, 9100,
     /* 1198272 */     GIR_EraseRootFromParent_Done,
     /* 1198273 */   // Label 17368: @1198273
     /* 1198273 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1198357), // Rule ID 9101 //
     /* 1198278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1198281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1198289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1198292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1198295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1198301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198331 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1198331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1198334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198356 */     // GIR_Coverage, 9101,
     /* 1198356 */     GIR_EraseRootFromParent_Done,
     /* 1198357 */   // Label 17369: @1198357
     /* 1198357 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1198441), // Rule ID 9104 //
     /* 1198362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1198365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1198373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1198376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1198379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1198385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198415 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1198418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198440 */     // GIR_Coverage, 9104,
     /* 1198440 */     GIR_EraseRootFromParent_Done,
     /* 1198441 */   // Label 17370: @1198441
     /* 1198441 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1198525), // Rule ID 9105 //
     /* 1198446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1198449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1198457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1198460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1198463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1198469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198499 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1198499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1198502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198524 */     // GIR_Coverage, 9105,
     /* 1198524 */     GIR_EraseRootFromParent_Done,
     /* 1198525 */   // Label 17371: @1198525
     /* 1198525 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1198609), // Rule ID 9108 //
     /* 1198530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1198533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1198541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1198544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1198547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1198553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198583 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1198586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198608 */     // GIR_Coverage, 9108,
     /* 1198608 */     GIR_EraseRootFromParent_Done,
     /* 1198609 */   // Label 17372: @1198609
     /* 1198609 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1198693), // Rule ID 9109 //
     /* 1198614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1198617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1198625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1198628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1198631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1198637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198667 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1198667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1198670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1198688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198692 */     // GIR_Coverage, 9109,
     /* 1198692 */     GIR_EraseRootFromParent_Done,
     /* 1198693 */   // Label 17373: @1198693
     /* 1198693 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1198777), // Rule ID 9112 //
     /* 1198698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1198701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1198709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1198712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1198721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198751 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1198754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198776 */     // GIR_Coverage, 9112,
     /* 1198776 */     GIR_EraseRootFromParent_Done,
     /* 1198777 */   // Label 17374: @1198777
     /* 1198777 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1198861), // Rule ID 9113 //
     /* 1198782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1198785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1198793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1198796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1198805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198835 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1198835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1198838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198860 */     // GIR_Coverage, 9113,
     /* 1198860 */     GIR_EraseRootFromParent_Done,
     /* 1198861 */   // Label 17375: @1198861
     /* 1198861 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1198945), // Rule ID 9116 //
     /* 1198866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1198869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1198877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1198880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1198889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1198919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1198922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1198932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1198943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198944 */     // GIR_Coverage, 9116,
     /* 1198944 */     GIR_EraseRootFromParent_Done,
     /* 1198945 */   // Label 17376: @1198945
     /* 1198945 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1199029), // Rule ID 9117 //
     /* 1198950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1198953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1198958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1198961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1198964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1198973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1198992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1198996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199003 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1199006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199028 */     // GIR_Coverage, 9117,
     /* 1199028 */     GIR_EraseRootFromParent_Done,
     /* 1199029 */   // Label 17377: @1199029
     /* 1199029 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1199113), // Rule ID 9120 //
     /* 1199034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1199037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1199045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1199048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1199057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199087 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1199090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199112 */     // GIR_Coverage, 9120,
     /* 1199112 */     GIR_EraseRootFromParent_Done,
     /* 1199113 */   // Label 17378: @1199113
     /* 1199113 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1199197), // Rule ID 9121 //
     /* 1199118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1199121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1199129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1199132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1199141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199171 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1199174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199196 */     // GIR_Coverage, 9121,
     /* 1199196 */     GIR_EraseRootFromParent_Done,
     /* 1199197 */   // Label 17379: @1199197
     /* 1199197 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1199281), // Rule ID 9124 //
     /* 1199202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1199205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1199213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1199216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1199225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199255 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1199258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199280 */     // GIR_Coverage, 9124,
     /* 1199280 */     GIR_EraseRootFromParent_Done,
     /* 1199281 */   // Label 17380: @1199281
     /* 1199281 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1199365), // Rule ID 9125 //
     /* 1199286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1199289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1199297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1199300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1199309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1199342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199364 */     // GIR_Coverage, 9125,
     /* 1199364 */     GIR_EraseRootFromParent_Done,
     /* 1199365 */   // Label 17381: @1199365
     /* 1199365 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1199449), // Rule ID 9128 //
     /* 1199370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1199373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1199381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1199384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1199393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199423 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1199426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199448 */     // GIR_Coverage, 9128,
     /* 1199448 */     GIR_EraseRootFromParent_Done,
     /* 1199449 */   // Label 17382: @1199449
     /* 1199449 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1199533), // Rule ID 9129 //
     /* 1199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1199457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1199465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1199468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1199477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199507 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1199510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199532 */     // GIR_Coverage, 9129,
     /* 1199532 */     GIR_EraseRootFromParent_Done,
     /* 1199533 */   // Label 17383: @1199533
     /* 1199533 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1199617), // Rule ID 9132 //
     /* 1199538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1199541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1199549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1199552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1199561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1199594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199616 */     // GIR_Coverage, 9132,
     /* 1199616 */     GIR_EraseRootFromParent_Done,
     /* 1199617 */   // Label 17384: @1199617
     /* 1199617 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1199701), // Rule ID 9133 //
     /* 1199622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1199625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1199633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1199636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1199645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1199678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199700 */     // GIR_Coverage, 9133,
     /* 1199700 */     GIR_EraseRootFromParent_Done,
     /* 1199701 */   // Label 17385: @1199701
     /* 1199701 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1199785), // Rule ID 9136 //
     /* 1199706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1199709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1199717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1199720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1199729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199759 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1199762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199784 */     // GIR_Coverage, 9136,
     /* 1199784 */     GIR_EraseRootFromParent_Done,
     /* 1199785 */   // Label 17386: @1199785
     /* 1199785 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1199869), // Rule ID 9137 //
     /* 1199790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1199793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1199801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1199804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1199813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1199843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1199846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199868 */     // GIR_Coverage, 9137,
     /* 1199868 */     GIR_EraseRootFromParent_Done,
     /* 1199869 */   // Label 17387: @1199869
     /* 1199869 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1199953), // Rule ID 9140 //
     /* 1199874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1199877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1199885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1199888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1199897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1199916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1199920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199927 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1199927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1199930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1199940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1199951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199952 */     // GIR_Coverage, 9140,
     /* 1199952 */     GIR_EraseRootFromParent_Done,
     /* 1199953 */   // Label 17388: @1199953
     /* 1199953 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1200037), // Rule ID 9141 //
     /* 1199958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1199961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1199966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1199969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1199972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1199981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1200014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200036 */     // GIR_Coverage, 9141,
     /* 1200036 */     GIR_EraseRootFromParent_Done,
     /* 1200037 */   // Label 17389: @1200037
     /* 1200037 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1200121), // Rule ID 9144 //
     /* 1200042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1200045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1200050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1200053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1200056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1200065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1200098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200120 */     // GIR_Coverage, 9144,
     /* 1200120 */     GIR_EraseRootFromParent_Done,
     /* 1200121 */   // Label 17390: @1200121
     /* 1200121 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1200205), // Rule ID 9145 //
     /* 1200126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1200129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1200134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1200137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1200140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1200149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1200182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200204 */     // GIR_Coverage, 9145,
     /* 1200204 */     GIR_EraseRootFromParent_Done,
     /* 1200205 */   // Label 17391: @1200205
     /* 1200205 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1200289), // Rule ID 9236 //
     /* 1200210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1200213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1200221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1200224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1200227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1200233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200263 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1200266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200288 */     // GIR_Coverage, 9236,
     /* 1200288 */     GIR_EraseRootFromParent_Done,
     /* 1200289 */   // Label 17392: @1200289
     /* 1200289 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1200373), // Rule ID 9237 //
     /* 1200294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1200297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1200305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1200308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1200311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1200317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200347 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1200350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200372 */     // GIR_Coverage, 9237,
     /* 1200372 */     GIR_EraseRootFromParent_Done,
     /* 1200373 */   // Label 17393: @1200373
     /* 1200373 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1200457), // Rule ID 9240 //
     /* 1200378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1200381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1200389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1200392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1200395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1200401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1200434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200456 */     // GIR_Coverage, 9240,
     /* 1200456 */     GIR_EraseRootFromParent_Done,
     /* 1200457 */   // Label 17394: @1200457
     /* 1200457 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1200541), // Rule ID 9241 //
     /* 1200462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1200465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1200473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1200476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1200479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1200485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200515 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1200518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200540 */     // GIR_Coverage, 9241,
     /* 1200540 */     GIR_EraseRootFromParent_Done,
     /* 1200541 */   // Label 17395: @1200541
     /* 1200541 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1200625), // Rule ID 9244 //
     /* 1200546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1200549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1200557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1200560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1200563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1200569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200599 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1200602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200624 */     // GIR_Coverage, 9244,
     /* 1200624 */     GIR_EraseRootFromParent_Done,
     /* 1200625 */   // Label 17396: @1200625
     /* 1200625 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1200709), // Rule ID 9245 //
     /* 1200630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1200633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1200641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1200644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1200647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1200653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1200686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1200704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200708 */     // GIR_Coverage, 9245,
     /* 1200708 */     GIR_EraseRootFromParent_Done,
     /* 1200709 */   // Label 17397: @1200709
     /* 1200709 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1200793), // Rule ID 9248 //
     /* 1200714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1200717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1200725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1200728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1200737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200767 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1200770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200792 */     // GIR_Coverage, 9248,
     /* 1200792 */     GIR_EraseRootFromParent_Done,
     /* 1200793 */   // Label 17398: @1200793
     /* 1200793 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1200877), // Rule ID 9249 //
     /* 1200798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1200801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1200809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1200812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1200821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200851 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1200851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1200854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200876 */     // GIR_Coverage, 9249,
     /* 1200876 */     GIR_EraseRootFromParent_Done,
     /* 1200877 */   // Label 17399: @1200877
     /* 1200877 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1200961), // Rule ID 9252 //
     /* 1200882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1200885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1200893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1200896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1200905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1200924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1200928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200935 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1200935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1200938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1200948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1200959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200960 */     // GIR_Coverage, 9252,
     /* 1200960 */     GIR_EraseRootFromParent_Done,
     /* 1200961 */   // Label 17400: @1200961
     /* 1200961 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1201045), // Rule ID 9253 //
     /* 1200966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1200969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1200974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1200977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1200980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1200989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201019 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1201022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201044 */     // GIR_Coverage, 9253,
     /* 1201044 */     GIR_EraseRootFromParent_Done,
     /* 1201045 */   // Label 17401: @1201045
     /* 1201045 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1201129), // Rule ID 9256 //
     /* 1201050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1201053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1201061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1201064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1201073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1201106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201128 */     // GIR_Coverage, 9256,
     /* 1201128 */     GIR_EraseRootFromParent_Done,
     /* 1201129 */   // Label 17402: @1201129
     /* 1201129 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1201213), // Rule ID 9257 //
     /* 1201134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1201137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1201145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1201148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1201157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1201190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201212 */     // GIR_Coverage, 9257,
     /* 1201212 */     GIR_EraseRootFromParent_Done,
     /* 1201213 */   // Label 17403: @1201213
     /* 1201213 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1201297), // Rule ID 9260 //
     /* 1201218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1201221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1201229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1201232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1201235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1201241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1201292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201296 */     // GIR_Coverage, 9260,
     /* 1201296 */     GIR_EraseRootFromParent_Done,
     /* 1201297 */   // Label 17404: @1201297
     /* 1201297 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1201381), // Rule ID 9261 //
     /* 1201302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1201305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1201313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1201316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1201319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1201325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1201376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201380 */     // GIR_Coverage, 9261,
     /* 1201380 */     GIR_EraseRootFromParent_Done,
     /* 1201381 */   // Label 17405: @1201381
     /* 1201381 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1201465), // Rule ID 9264 //
     /* 1201386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1201389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1201397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1201400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1201409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201439 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201464 */     // GIR_Coverage, 9264,
     /* 1201464 */     GIR_EraseRootFromParent_Done,
     /* 1201465 */   // Label 17406: @1201465
     /* 1201465 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1201549), // Rule ID 9265 //
     /* 1201470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1201473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1201481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1201484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1201493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201523 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201548 */     // GIR_Coverage, 9265,
     /* 1201548 */     GIR_EraseRootFromParent_Done,
     /* 1201549 */   // Label 17407: @1201549
     /* 1201549 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1201633), // Rule ID 9268 //
     /* 1201554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1201557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1201565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1201568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1201577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201632 */     // GIR_Coverage, 9268,
     /* 1201632 */     GIR_EraseRootFromParent_Done,
     /* 1201633 */   // Label 17408: @1201633
     /* 1201633 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1201717), // Rule ID 9269 //
     /* 1201638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1201641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1201649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1201652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1201661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201691 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201716 */     // GIR_Coverage, 9269,
     /* 1201716 */     GIR_EraseRootFromParent_Done,
     /* 1201717 */   // Label 17409: @1201717
     /* 1201717 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1201801), // Rule ID 9272 //
     /* 1201722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1201725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1201733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1201736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1201739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1201745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201775 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201800 */     // GIR_Coverage, 9272,
     /* 1201800 */     GIR_EraseRootFromParent_Done,
     /* 1201801 */   // Label 17410: @1201801
     /* 1201801 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1201885), // Rule ID 9273 //
     /* 1201806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1201809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1201817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1201820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1201823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1201829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1201859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1201862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201884 */     // GIR_Coverage, 9273,
     /* 1201884 */     GIR_EraseRootFromParent_Done,
     /* 1201885 */   // Label 17411: @1201885
     /* 1201885 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1201969), // Rule ID 9276 //
     /* 1201890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1201893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1201901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1201904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1201907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1201913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1201932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1201936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201943 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1201943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1201946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1201956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1201964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1201967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201968 */     // GIR_Coverage, 9276,
     /* 1201968 */     GIR_EraseRootFromParent_Done,
     /* 1201969 */   // Label 17412: @1201969
     /* 1201969 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1202053), // Rule ID 9277 //
     /* 1201974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1201977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1201982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1201985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1201988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1201991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1201997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1202030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1202048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202052 */     // GIR_Coverage, 9277,
     /* 1202052 */     GIR_EraseRootFromParent_Done,
     /* 1202053 */   // Label 17413: @1202053
     /* 1202053 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1202137), // Rule ID 9280 //
     /* 1202058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1202069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1202072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1202075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1202081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1202114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1202132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202136 */     // GIR_Coverage, 9280,
     /* 1202136 */     GIR_EraseRootFromParent_Done,
     /* 1202137 */   // Label 17414: @1202137
     /* 1202137 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1202221), // Rule ID 9281 //
     /* 1202142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1202153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1202156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1202159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1202165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202195 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1202198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1202216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202220 */     // GIR_Coverage, 9281,
     /* 1202220 */     GIR_EraseRootFromParent_Done,
     /* 1202221 */   // Label 17415: @1202221
     /* 1202221 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1202305), // Rule ID 9284 //
     /* 1202226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1202237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1202240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1202243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1202249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202279 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1202282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1202300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202304 */     // GIR_Coverage, 9284,
     /* 1202304 */     GIR_EraseRootFromParent_Done,
     /* 1202305 */   // Label 17416: @1202305
     /* 1202305 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1202389), // Rule ID 9285 //
     /* 1202310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1202321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1202324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1202327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1202333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202363 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1202366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1202384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202388 */     // GIR_Coverage, 9285,
     /* 1202388 */     GIR_EraseRootFromParent_Done,
     /* 1202389 */   // Label 17417: @1202389
     /* 1202389 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1202473), // Rule ID 9288 //
     /* 1202394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1202405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1202408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1202417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1202450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202472 */     // GIR_Coverage, 9288,
     /* 1202472 */     GIR_EraseRootFromParent_Done,
     /* 1202473 */   // Label 17418: @1202473
     /* 1202473 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1202557), // Rule ID 9289 //
     /* 1202478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1202489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1202492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1202501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202531 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1202534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202556 */     // GIR_Coverage, 9289,
     /* 1202556 */     GIR_EraseRootFromParent_Done,
     /* 1202557 */   // Label 17419: @1202557
     /* 1202557 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1202641), // Rule ID 9292 //
     /* 1202562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1202573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1202576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1202585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202615 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1202618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202640 */     // GIR_Coverage, 9292,
     /* 1202640 */     GIR_EraseRootFromParent_Done,
     /* 1202641 */   // Label 17420: @1202641
     /* 1202641 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1202725), // Rule ID 9293 //
     /* 1202646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1202657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1202660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1202669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202699 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1202702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202724 */     // GIR_Coverage, 9293,
     /* 1202724 */     GIR_EraseRootFromParent_Done,
     /* 1202725 */   // Label 17421: @1202725
     /* 1202725 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1202809), // Rule ID 9296 //
     /* 1202730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1202741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1202744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1202747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1202753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202783 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1202786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202808 */     // GIR_Coverage, 9296,
     /* 1202808 */     GIR_EraseRootFromParent_Done,
     /* 1202809 */   // Label 17422: @1202809
     /* 1202809 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1202893), // Rule ID 9297 //
     /* 1202814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1202825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1202828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1202831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1202837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202867 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1202867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1202870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202892 */     // GIR_Coverage, 9297,
     /* 1202892 */     GIR_EraseRootFromParent_Done,
     /* 1202893 */   // Label 17423: @1202893
     /* 1202893 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1202977), // Rule ID 9300 //
     /* 1202898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1202901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1202909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1202912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1202921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1202940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1202944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1202951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1202954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1202964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1202975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202976 */     // GIR_Coverage, 9300,
     /* 1202976 */     GIR_EraseRootFromParent_Done,
     /* 1202977 */   // Label 17424: @1202977
     /* 1202977 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1203061), // Rule ID 9301 //
     /* 1202982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1202985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1202990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1202993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1202996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1203005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1203038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203060 */     // GIR_Coverage, 9301,
     /* 1203060 */     GIR_EraseRootFromParent_Done,
     /* 1203061 */   // Label 17425: @1203061
     /* 1203061 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1203145), // Rule ID 9304 //
     /* 1203066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1203069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1203077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1203080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1203089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1203122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203144 */     // GIR_Coverage, 9304,
     /* 1203144 */     GIR_EraseRootFromParent_Done,
     /* 1203145 */   // Label 17426: @1203145
     /* 1203145 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1203229), // Rule ID 9305 //
     /* 1203150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1203153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1203161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1203164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1203173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203203 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1203206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203228 */     // GIR_Coverage, 9305,
     /* 1203228 */     GIR_EraseRootFromParent_Done,
     /* 1203229 */   // Label 17427: @1203229
     /* 1203229 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1203313), // Rule ID 9308 //
     /* 1203234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1203237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1203245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1203248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1203257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1203290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203312 */     // GIR_Coverage, 9308,
     /* 1203312 */     GIR_EraseRootFromParent_Done,
     /* 1203313 */   // Label 17428: @1203313
     /* 1203313 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1203397), // Rule ID 9309 //
     /* 1203318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1203321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1203329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1203332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1203341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203371 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1203374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203396 */     // GIR_Coverage, 9309,
     /* 1203396 */     GIR_EraseRootFromParent_Done,
     /* 1203397 */   // Label 17429: @1203397
     /* 1203397 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1203481), // Rule ID 9312 //
     /* 1203402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1203405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1203413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1203416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1203425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1203458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203480 */     // GIR_Coverage, 9312,
     /* 1203480 */     GIR_EraseRootFromParent_Done,
     /* 1203481 */   // Label 17430: @1203481
     /* 1203481 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1203565), // Rule ID 9313 //
     /* 1203486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1203489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1203497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1203500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1203509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1203542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203564 */     // GIR_Coverage, 9313,
     /* 1203564 */     GIR_EraseRootFromParent_Done,
     /* 1203565 */   // Label 17431: @1203565
     /* 1203565 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1203649), // Rule ID 9316 //
     /* 1203570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1203573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1203581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1203584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1203593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203623 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1203626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203648 */     // GIR_Coverage, 9316,
     /* 1203648 */     GIR_EraseRootFromParent_Done,
     /* 1203649 */   // Label 17432: @1203649
     /* 1203649 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1203733), // Rule ID 9317 //
     /* 1203654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1203657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1203665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1203668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1203677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203707 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1203710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203732 */     // GIR_Coverage, 9317,
     /* 1203732 */     GIR_EraseRootFromParent_Done,
     /* 1203733 */   // Label 17433: @1203733
     /* 1203733 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1203817), // Rule ID 9320 //
     /* 1203738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1203741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1203749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1203752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1203761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1203794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203816 */     // GIR_Coverage, 9320,
     /* 1203816 */     GIR_EraseRootFromParent_Done,
     /* 1203817 */   // Label 17434: @1203817
     /* 1203817 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1203901), // Rule ID 9321 //
     /* 1203822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1203825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1203830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1203833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1203836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1203845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1203864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1203875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1203878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203900 */     // GIR_Coverage, 9321,
     /* 1203900 */     GIR_EraseRootFromParent_Done,
     /* 1203901 */   // Label 17435: @1203901
     /* 1203901 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1203985), // Rule ID 9412 //
     /* 1203906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1203909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1203914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1203917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1203920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1203923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1203926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1203929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1203952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203959 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1203959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1203962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1203968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1203970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1203972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1203980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1203983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203984 */     // GIR_Coverage, 9412,
     /* 1203984 */     GIR_EraseRootFromParent_Done,
     /* 1203985 */   // Label 17436: @1203985
     /* 1203985 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1204069), // Rule ID 9413 //
     /* 1203990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1203993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1203998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1204001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1204004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1204007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1204010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1204013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204043 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1204046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1204064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204068 */     // GIR_Coverage, 9413,
     /* 1204068 */     GIR_EraseRootFromParent_Done,
     /* 1204069 */   // Label 17437: @1204069
     /* 1204069 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1204153), // Rule ID 9416 //
     /* 1204074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1204085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1204088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1204091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1204094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1204097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1204148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204152 */     // GIR_Coverage, 9416,
     /* 1204152 */     GIR_EraseRootFromParent_Done,
     /* 1204153 */   // Label 17438: @1204153
     /* 1204153 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1204237), // Rule ID 9417 //
     /* 1204158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1204161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1204169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1204172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1204175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1204178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1204181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204211 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1204232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204236 */     // GIR_Coverage, 9417,
     /* 1204236 */     GIR_EraseRootFromParent_Done,
     /* 1204237 */   // Label 17439: @1204237
     /* 1204237 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1204321), // Rule ID 9420 //
     /* 1204242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1204253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1204256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1204262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1204265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204295 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1204298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204320 */     // GIR_Coverage, 9420,
     /* 1204320 */     GIR_EraseRootFromParent_Done,
     /* 1204321 */   // Label 17440: @1204321
     /* 1204321 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1204405), // Rule ID 9421 //
     /* 1204326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1204329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1204337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1204340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1204346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1204349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1204382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204404 */     // GIR_Coverage, 9421,
     /* 1204404 */     GIR_EraseRootFromParent_Done,
     /* 1204405 */   // Label 17441: @1204405
     /* 1204405 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1204489), // Rule ID 9424 //
     /* 1204410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1204421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1204424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1204433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204463 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204488 */     // GIR_Coverage, 9424,
     /* 1204488 */     GIR_EraseRootFromParent_Done,
     /* 1204489 */   // Label 17442: @1204489
     /* 1204489 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1204573), // Rule ID 9425 //
     /* 1204494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1204497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1204505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1204508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1204517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204572 */     // GIR_Coverage, 9425,
     /* 1204572 */     GIR_EraseRootFromParent_Done,
     /* 1204573 */   // Label 17443: @1204573
     /* 1204573 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1204657), // Rule ID 9428 //
     /* 1204578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1204589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1204592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1204601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204631 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204656 */     // GIR_Coverage, 9428,
     /* 1204656 */     GIR_EraseRootFromParent_Done,
     /* 1204657 */   // Label 17444: @1204657
     /* 1204657 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1204741), // Rule ID 9429 //
     /* 1204662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1204665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1204673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1204676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1204685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204715 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1204718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204740 */     // GIR_Coverage, 9429,
     /* 1204740 */     GIR_EraseRootFromParent_Done,
     /* 1204741 */   // Label 17445: @1204741
     /* 1204741 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1204825), // Rule ID 9432 //
     /* 1204746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1204757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1204760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1204763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1204766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1204769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1204802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1204820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204824 */     // GIR_Coverage, 9432,
     /* 1204824 */     GIR_EraseRootFromParent_Done,
     /* 1204825 */   // Label 17446: @1204825
     /* 1204825 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1204909), // Rule ID 9433 //
     /* 1204830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1204833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1204841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1204844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1204847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1204850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1204853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204883 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1204883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1204886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1204904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204908 */     // GIR_Coverage, 9433,
     /* 1204908 */     GIR_EraseRootFromParent_Done,
     /* 1204909 */   // Label 17447: @1204909
     /* 1204909 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1204993), // Rule ID 9436 //
     /* 1204914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1204917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1204922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1204925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1204928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1204934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1204937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1204960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1204967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1204970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1204976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1204978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1204980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1204991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204992 */     // GIR_Coverage, 9436,
     /* 1204992 */     GIR_EraseRootFromParent_Done,
     /* 1204993 */   // Label 17448: @1204993
     /* 1204993 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1205077), // Rule ID 9437 //
     /* 1204998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1205001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1205009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1205012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1205018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1205021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205051 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1205054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205076 */     // GIR_Coverage, 9437,
     /* 1205076 */     GIR_EraseRootFromParent_Done,
     /* 1205077 */   // Label 17449: @1205077
     /* 1205077 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1205161), // Rule ID 9440 //
     /* 1205082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1205085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1205093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1205096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1205102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1205105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205135 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1205138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205160 */     // GIR_Coverage, 9440,
     /* 1205160 */     GIR_EraseRootFromParent_Done,
     /* 1205161 */   // Label 17450: @1205161
     /* 1205161 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1205245), // Rule ID 9441 //
     /* 1205166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1205169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1205177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1205180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1205186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1205189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1205222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205244 */     // GIR_Coverage, 9441,
     /* 1205244 */     GIR_EraseRootFromParent_Done,
     /* 1205245 */   // Label 17451: @1205245
     /* 1205245 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1205329), // Rule ID 9444 //
     /* 1205250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1205253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1205261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1205264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1205267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1205270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1205273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205303 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1205306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1205324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205328 */     // GIR_Coverage, 9444,
     /* 1205328 */     GIR_EraseRootFromParent_Done,
     /* 1205329 */   // Label 17452: @1205329
     /* 1205329 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1205413), // Rule ID 9445 //
     /* 1205334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1205337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1205345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1205348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1205351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1205354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1205357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1205390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1205408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205412 */     // GIR_Coverage, 9445,
     /* 1205412 */     GIR_EraseRootFromParent_Done,
     /* 1205413 */   // Label 17453: @1205413
     /* 1205413 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1205497), // Rule ID 9448 //
     /* 1205418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1205421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1205429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1205432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1205435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1205438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1205441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205471 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1205474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205496 */     // GIR_Coverage, 9448,
     /* 1205496 */     GIR_EraseRootFromParent_Done,
     /* 1205497 */   // Label 17454: @1205497
     /* 1205497 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1205581), // Rule ID 9449 //
     /* 1205502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1205505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1205513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1205516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1205519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1205522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1205525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205555 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1205558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205580 */     // GIR_Coverage, 9449,
     /* 1205580 */     GIR_EraseRootFromParent_Done,
     /* 1205581 */   // Label 17455: @1205581
     /* 1205581 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1205665), // Rule ID 9452 //
     /* 1205586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1205589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1205597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1205600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1205603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1205606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1205609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205639 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1205642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205664 */     // GIR_Coverage, 9452,
     /* 1205664 */     GIR_EraseRootFromParent_Done,
     /* 1205665 */   // Label 17456: @1205665
     /* 1205665 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1205749), // Rule ID 9453 //
     /* 1205670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1205673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1205681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1205684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1205687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1205690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1205693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205723 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1205726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205748 */     // GIR_Coverage, 9453,
     /* 1205748 */     GIR_EraseRootFromParent_Done,
     /* 1205749 */   // Label 17457: @1205749
     /* 1205749 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1205833), // Rule ID 9456 //
     /* 1205754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1205757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1205765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1205768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1205771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1205774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1205777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205807 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1205810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205832 */     // GIR_Coverage, 9456,
     /* 1205832 */     GIR_EraseRootFromParent_Done,
     /* 1205833 */   // Label 17458: @1205833
     /* 1205833 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1205917), // Rule ID 9457 //
     /* 1205838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1205841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1205849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1205852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1205855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1205858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1205861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205891 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1205891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1205894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1205912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205916 */     // GIR_Coverage, 9457,
     /* 1205916 */     GIR_EraseRootFromParent_Done,
     /* 1205917 */   // Label 17459: @1205917
     /* 1205917 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1206001), // Rule ID 9460 //
     /* 1205922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1205925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1205930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1205933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1205936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1205942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1205945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1205968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205975 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1205975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1205978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1205984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1205986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1205988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1205999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206000 */     // GIR_Coverage, 9460,
     /* 1206000 */     GIR_EraseRootFromParent_Done,
     /* 1206001 */   // Label 17460: @1206001
     /* 1206001 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1206085), // Rule ID 9461 //
     /* 1206006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1206017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1206020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1206023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1206029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206059 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1206062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206084 */     // GIR_Coverage, 9461,
     /* 1206084 */     GIR_EraseRootFromParent_Done,
     /* 1206085 */   // Label 17461: @1206085
     /* 1206085 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1206169), // Rule ID 9464 //
     /* 1206090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1206093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1206101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1206104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1206107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1206113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206143 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1206146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206168 */     // GIR_Coverage, 9464,
     /* 1206168 */     GIR_EraseRootFromParent_Done,
     /* 1206169 */   // Label 17462: @1206169
     /* 1206169 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1206253), // Rule ID 9465 //
     /* 1206174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1206185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1206188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1206191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1206197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206227 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1206230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206252 */     // GIR_Coverage, 9465,
     /* 1206252 */     GIR_EraseRootFromParent_Done,
     /* 1206253 */   // Label 17463: @1206253
     /* 1206253 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1206337), // Rule ID 9468 //
     /* 1206258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1206261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1206269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1206272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1206275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1206278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1206281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206311 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1206314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206336 */     // GIR_Coverage, 9468,
     /* 1206336 */     GIR_EraseRootFromParent_Done,
     /* 1206337 */   // Label 17464: @1206337
     /* 1206337 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1206421), // Rule ID 9469 //
     /* 1206342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1206353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1206356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1206359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1206362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1206365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206395 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1206398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206420 */     // GIR_Coverage, 9469,
     /* 1206420 */     GIR_EraseRootFromParent_Done,
     /* 1206421 */   // Label 17465: @1206421
     /* 1206421 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1206505), // Rule ID 9472 //
     /* 1206426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1206429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1206437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1206440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1206449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206479 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1206482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206504 */     // GIR_Coverage, 9472,
     /* 1206504 */     GIR_EraseRootFromParent_Done,
     /* 1206505 */   // Label 17466: @1206505
     /* 1206505 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1206589), // Rule ID 9473 //
     /* 1206510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1206521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1206524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1206533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1206566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206588 */     // GIR_Coverage, 9473,
     /* 1206588 */     GIR_EraseRootFromParent_Done,
     /* 1206589 */   // Label 17467: @1206589
     /* 1206589 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1206673), // Rule ID 9476 //
     /* 1206594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1206597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1206605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1206608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1206614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1206617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206647 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1206650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206672 */     // GIR_Coverage, 9476,
     /* 1206672 */     GIR_EraseRootFromParent_Done,
     /* 1206673 */   // Label 17468: @1206673
     /* 1206673 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1206757), // Rule ID 9477 //
     /* 1206678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1206689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1206692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1206698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1206701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206731 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1206734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206756 */     // GIR_Coverage, 9477,
     /* 1206756 */     GIR_EraseRootFromParent_Done,
     /* 1206757 */   // Label 17469: @1206757
     /* 1206757 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1206841), // Rule ID 9480 //
     /* 1206762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1206765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1206773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1206776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1206782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1206785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1206818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206840 */     // GIR_Coverage, 9480,
     /* 1206840 */     GIR_EraseRootFromParent_Done,
     /* 1206841 */   // Label 17470: @1206841
     /* 1206841 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1206925), // Rule ID 9481 //
     /* 1206846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1206849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1206857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1206860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1206866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1206869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206899 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1206899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1206902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1206923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206924 */     // GIR_Coverage, 9481,
     /* 1206924 */     GIR_EraseRootFromParent_Done,
     /* 1206925 */   // Label 17471: @1206925
     /* 1206925 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1207009), // Rule ID 9484 //
     /* 1206930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1206933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1206938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1206941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1206944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1206950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1206953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1206976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206983 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1206983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1206986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1206992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1206994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1206996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207008 */     // GIR_Coverage, 9484,
     /* 1207008 */     GIR_EraseRootFromParent_Done,
     /* 1207009 */   // Label 17472: @1207009
     /* 1207009 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1207093), // Rule ID 9485 //
     /* 1207014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1207017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1207022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1207025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1207028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1207034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1207037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207067 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1207070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207092 */     // GIR_Coverage, 9485,
     /* 1207092 */     GIR_EraseRootFromParent_Done,
     /* 1207093 */   // Label 17473: @1207093
     /* 1207093 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1207177), // Rule ID 9488 //
     /* 1207098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1207101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1207106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1207109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1207112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1207118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1207121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1207154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207176 */     // GIR_Coverage, 9488,
     /* 1207176 */     GIR_EraseRootFromParent_Done,
     /* 1207177 */   // Label 17474: @1207177
     /* 1207177 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1207261), // Rule ID 9489 //
     /* 1207182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1207185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1207190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1207193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1207196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1207202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1207205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207235 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1207238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207260 */     // GIR_Coverage, 9489,
     /* 1207260 */     GIR_EraseRootFromParent_Done,
     /* 1207261 */   // Label 17475: @1207261
     /* 1207261 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1207345), // Rule ID 9492 //
     /* 1207266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1207269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1207274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1207277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1207280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1207286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1207289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207319 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1207322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207344 */     // GIR_Coverage, 9492,
     /* 1207344 */     GIR_EraseRootFromParent_Done,
     /* 1207345 */   // Label 17476: @1207345
     /* 1207345 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1207429), // Rule ID 9493 //
     /* 1207350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1207353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1207358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1207361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1207364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1207370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1207373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207403 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11145:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1207406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207428 */     // GIR_Coverage, 9493,
     /* 1207428 */     GIR_EraseRootFromParent_Done,
     /* 1207429 */   // Label 17477: @1207429
     /* 1207429 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1207513), // Rule ID 9496 //
     /* 1207434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1207437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1207445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1207448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1207451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1207454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1207457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207487 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1207490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207512 */     // GIR_Coverage, 9496,
     /* 1207512 */     GIR_EraseRootFromParent_Done,
     /* 1207513 */   // Label 17478: @1207513
     /* 1207513 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1207597), // Rule ID 9497 //
     /* 1207518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1207521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1207529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1207532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1207535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1207538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1207541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207571 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1207574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207596 */     // GIR_Coverage, 9497,
     /* 1207596 */     GIR_EraseRootFromParent_Done,
     /* 1207597 */   // Label 17479: @1207597
     /* 1207597 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1207681), // Rule ID 9500 //
     /* 1207602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1207605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1207613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1207616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1207619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1207622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1207625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207655 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1207658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207680 */     // GIR_Coverage, 9500,
     /* 1207680 */     GIR_EraseRootFromParent_Done,
     /* 1207681 */   // Label 17480: @1207681
     /* 1207681 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1207765), // Rule ID 9501 //
     /* 1207686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1207689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1207697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1207700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1207703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1207706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1207709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207739 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1207742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207764 */     // GIR_Coverage, 9501,
     /* 1207764 */     GIR_EraseRootFromParent_Done,
     /* 1207765 */   // Label 17481: @1207765
     /* 1207765 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1207849), // Rule ID 9504 //
     /* 1207770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1207773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1207781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1207784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1207787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1207790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1207793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1207826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207848 */     // GIR_Coverage, 9504,
     /* 1207848 */     GIR_EraseRootFromParent_Done,
     /* 1207849 */   // Label 17482: @1207849
     /* 1207849 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1207933), // Rule ID 9505 //
     /* 1207854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1207857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1207865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1207868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1207871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1207874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1207877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1207907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1207910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1207916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1207918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1207920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1207928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1207931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207932 */     // GIR_Coverage, 9505,
     /* 1207932 */     GIR_EraseRootFromParent_Done,
     /* 1207933 */   // Label 17483: @1207933
     /* 1207933 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1208017), // Rule ID 9508 //
     /* 1207938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1207941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1207946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1207949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1207952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1207955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1207958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1207961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1207984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207991 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1207991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1207994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208016 */     // GIR_Coverage, 9508,
     /* 1208016 */     GIR_EraseRootFromParent_Done,
     /* 1208017 */   // Label 17484: @1208017
     /* 1208017 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1208101), // Rule ID 9509 //
     /* 1208022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1208033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1208036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1208039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1208045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1208078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208100 */     // GIR_Coverage, 9509,
     /* 1208100 */     GIR_EraseRootFromParent_Done,
     /* 1208101 */   // Label 17485: @1208101
     /* 1208101 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1208185), // Rule ID 9512 //
     /* 1208106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1208109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1208117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1208120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1208123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1208129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208159 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1208162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208184 */     // GIR_Coverage, 9512,
     /* 1208184 */     GIR_EraseRootFromParent_Done,
     /* 1208185 */   // Label 17486: @1208185
     /* 1208185 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1208269), // Rule ID 9513 //
     /* 1208190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1208201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1208204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1208207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1208213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208243 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1208246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208268 */     // GIR_Coverage, 9513,
     /* 1208268 */     GIR_EraseRootFromParent_Done,
     /* 1208269 */   // Label 17487: @1208269
     /* 1208269 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1208353), // Rule ID 9516 //
     /* 1208274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1208277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1208285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1208288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1208294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1208297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1208330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208352 */     // GIR_Coverage, 9516,
     /* 1208352 */     GIR_EraseRootFromParent_Done,
     /* 1208353 */   // Label 17488: @1208353
     /* 1208353 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1208437), // Rule ID 9517 //
     /* 1208358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1208369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1208372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1208378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1208381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208411 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1208414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208436 */     // GIR_Coverage, 9517,
     /* 1208436 */     GIR_EraseRootFromParent_Done,
     /* 1208437 */   // Label 17489: @1208437
     /* 1208437 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1208521), // Rule ID 9520 //
     /* 1208442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1208445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1208453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1208456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1208459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1208462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1208465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1208516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208520 */     // GIR_Coverage, 9520,
     /* 1208520 */     GIR_EraseRootFromParent_Done,
     /* 1208521 */   // Label 17490: @1208521
     /* 1208521 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1208605), // Rule ID 9521 //
     /* 1208526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1208537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1208540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1208543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1208546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1208549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208579 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1208600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208604 */     // GIR_Coverage, 9521,
     /* 1208604 */     GIR_EraseRootFromParent_Done,
     /* 1208605 */   // Label 17491: @1208605
     /* 1208605 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1208689), // Rule ID 9524 //
     /* 1208610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1208613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1208621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1208624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1208627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1208633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208663 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208688 */     // GIR_Coverage, 9524,
     /* 1208688 */     GIR_EraseRootFromParent_Done,
     /* 1208689 */   // Label 17492: @1208689
     /* 1208689 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1208773), // Rule ID 9525 //
     /* 1208694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1208705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1208708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1208711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1208717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208747 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208772 */     // GIR_Coverage, 9525,
     /* 1208772 */     GIR_EraseRootFromParent_Done,
     /* 1208773 */   // Label 17493: @1208773
     /* 1208773 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1208857), // Rule ID 9528 //
     /* 1208778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1208781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1208789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1208792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1208798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1208801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208831 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208856 */     // GIR_Coverage, 9528,
     /* 1208856 */     GIR_EraseRootFromParent_Done,
     /* 1208857 */   // Label 17494: @1208857
     /* 1208857 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1208941), // Rule ID 9529 //
     /* 1208862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1208865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1208873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1208876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1208882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1208885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208915 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1208915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1208918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1208924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1208926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1208928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1208939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208940 */     // GIR_Coverage, 9529,
     /* 1208940 */     GIR_EraseRootFromParent_Done,
     /* 1208941 */   // Label 17495: @1208941
     /* 1208941 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1209025), // Rule ID 9532 //
     /* 1208946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1208949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1208954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1208957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1208960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1208966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1208969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1208992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1208999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1209002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1209020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209024 */     // GIR_Coverage, 9532,
     /* 1209024 */     GIR_EraseRootFromParent_Done,
     /* 1209025 */   // Label 17496: @1209025
     /* 1209025 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1209109), // Rule ID 9533 //
     /* 1209030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1209033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1209041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1209044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1209050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1209053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209083 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1209086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1209104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209108 */     // GIR_Coverage, 9533,
     /* 1209108 */     GIR_EraseRootFromParent_Done,
     /* 1209109 */   // Label 17497: @1209109
     /* 1209109 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1209193), // Rule ID 9536 //
     /* 1209114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1209125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1209128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1209131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1209134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1209137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209167 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1209167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1209170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209192 */     // GIR_Coverage, 9536,
     /* 1209192 */     GIR_EraseRootFromParent_Done,
     /* 1209193 */   // Label 17498: @1209193
     /* 1209193 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1209277), // Rule ID 9537 //
     /* 1209198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1209201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1209209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1209212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1209215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1209218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1209221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209251 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1209254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209276 */     // GIR_Coverage, 9537,
     /* 1209276 */     GIR_EraseRootFromParent_Done,
     /* 1209277 */   // Label 17499: @1209277
     /* 1209277 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1209361), // Rule ID 9540 //
     /* 1209282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1209293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1209296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1209299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1209302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1209305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209335 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1209335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1209338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209360 */     // GIR_Coverage, 9540,
     /* 1209360 */     GIR_EraseRootFromParent_Done,
     /* 1209361 */   // Label 17500: @1209361
     /* 1209361 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1209445), // Rule ID 9541 //
     /* 1209366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1209369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1209377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1209380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1209383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1209386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1209389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209419 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1209422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209444 */     // GIR_Coverage, 9541,
     /* 1209444 */     GIR_EraseRootFromParent_Done,
     /* 1209445 */   // Label 17501: @1209445
     /* 1209445 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1209529), // Rule ID 9544 //
     /* 1209450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1209461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1209464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1209467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1209470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1209473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209503 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1209503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1209506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209528 */     // GIR_Coverage, 9544,
     /* 1209528 */     GIR_EraseRootFromParent_Done,
     /* 1209529 */   // Label 17502: @1209529
     /* 1209529 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1209613), // Rule ID 9545 //
     /* 1209534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1209537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1209545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1209548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1209551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1209554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1209557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209587 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1209590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1209608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209612 */     // GIR_Coverage, 9545,
     /* 1209612 */     GIR_EraseRootFromParent_Done,
     /* 1209613 */   // Label 17503: @1209613
     /* 1209613 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1209697), // Rule ID 9548 //
     /* 1209618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1209629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1209632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1209635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1209641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1209671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1209674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209696 */     // GIR_Coverage, 9548,
     /* 1209696 */     GIR_EraseRootFromParent_Done,
     /* 1209697 */   // Label 17504: @1209697
     /* 1209697 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1209781), // Rule ID 9549 //
     /* 1209702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1209705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1209713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1209716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1209719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1209725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1209758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209780 */     // GIR_Coverage, 9549,
     /* 1209780 */     GIR_EraseRootFromParent_Done,
     /* 1209781 */   // Label 17505: @1209781
     /* 1209781 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1209865), // Rule ID 9552 //
     /* 1209786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1209797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1209800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1209803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1209809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209839 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1209839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1209842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209864 */     // GIR_Coverage, 9552,
     /* 1209864 */     GIR_EraseRootFromParent_Done,
     /* 1209865 */   // Label 17506: @1209865
     /* 1209865 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1209949), // Rule ID 9553 //
     /* 1209870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1209873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1209881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1209884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1209887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1209893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1209916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209923 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1209923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1209926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1209932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1209934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1209936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1209947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209948 */     // GIR_Coverage, 9553,
     /* 1209948 */     GIR_EraseRootFromParent_Done,
     /* 1209949 */   // Label 17507: @1209949
     /* 1209949 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1210033), // Rule ID 9556 //
     /* 1209954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1209957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1209962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1209965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1209968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1209971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1209974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1209977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210007 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1210010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210032 */     // GIR_Coverage, 9556,
     /* 1210032 */     GIR_EraseRootFromParent_Done,
     /* 1210033 */   // Label 17508: @1210033
     /* 1210033 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1210117), // Rule ID 9557 //
     /* 1210038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1210041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1210049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1210052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1210055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1210058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1210061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210091 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1210094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210116 */     // GIR_Coverage, 9557,
     /* 1210116 */     GIR_EraseRootFromParent_Done,
     /* 1210117 */   // Label 17509: @1210117
     /* 1210117 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1210201), // Rule ID 9560 //
     /* 1210122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1210125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1210133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1210136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1210145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210175 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1210178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210200 */     // GIR_Coverage, 9560,
     /* 1210200 */     GIR_EraseRootFromParent_Done,
     /* 1210201 */   // Label 17510: @1210201
     /* 1210201 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1210285), // Rule ID 9561 //
     /* 1210206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1210209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1210217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1210220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1210229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210259 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1210262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210284 */     // GIR_Coverage, 9561,
     /* 1210284 */     GIR_EraseRootFromParent_Done,
     /* 1210285 */   // Label 17511: @1210285
     /* 1210285 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1210369), // Rule ID 9564 //
     /* 1210290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1210293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1210301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1210304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1210313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210343 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1210346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210368 */     // GIR_Coverage, 9564,
     /* 1210368 */     GIR_EraseRootFromParent_Done,
     /* 1210369 */   // Label 17512: @1210369
     /* 1210369 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1210453), // Rule ID 9565 //
     /* 1210374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1210377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1210385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1210388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1210397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210427 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1210430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210452 */     // GIR_Coverage, 9565,
     /* 1210452 */     GIR_EraseRootFromParent_Done,
     /* 1210453 */   // Label 17513: @1210453
     /* 1210453 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1210537), // Rule ID 9568 //
     /* 1210458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1210461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1210469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1210472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1210478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1210481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210511 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1210514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210536 */     // GIR_Coverage, 9568,
     /* 1210536 */     GIR_EraseRootFromParent_Done,
     /* 1210537 */   // Label 17514: @1210537
     /* 1210537 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1210621), // Rule ID 9569 //
     /* 1210542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1210545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1210553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1210556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1210562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1210565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210595 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1210598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210620 */     // GIR_Coverage, 9569,
     /* 1210620 */     GIR_EraseRootFromParent_Done,
     /* 1210621 */   // Label 17515: @1210621
     /* 1210621 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1210705), // Rule ID 9572 //
     /* 1210626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1210629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1210637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1210640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1210646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1210649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210679 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1210682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210704 */     // GIR_Coverage, 9572,
     /* 1210704 */     GIR_EraseRootFromParent_Done,
     /* 1210705 */   // Label 17516: @1210705
     /* 1210705 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1210789), // Rule ID 9573 //
     /* 1210710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1210713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1210721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1210724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1210730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1210733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210763 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1210766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210788 */     // GIR_Coverage, 9573,
     /* 1210788 */     GIR_EraseRootFromParent_Done,
     /* 1210789 */   // Label 17517: @1210789
     /* 1210789 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1210873), // Rule ID 9576 //
     /* 1210794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1210797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1210805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1210808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1210814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1210817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1210847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1210850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210872 */     // GIR_Coverage, 9576,
     /* 1210872 */     GIR_EraseRootFromParent_Done,
     /* 1210873 */   // Label 17518: @1210873
     /* 1210873 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1210957), // Rule ID 9577 //
     /* 1210878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1210881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1210889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1210892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1210898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1210901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1210924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210931 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1210931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1210934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1210940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1210942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1210944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1210955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210956 */     // GIR_Coverage, 9577,
     /* 1210956 */     GIR_EraseRootFromParent_Done,
     /* 1210957 */   // Label 17519: @1210957
     /* 1210957 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1211041), // Rule ID 9580 //
     /* 1210962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1210965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1210970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1210973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1210976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1210982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1210985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211015 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1211018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211040 */     // GIR_Coverage, 9580,
     /* 1211040 */     GIR_EraseRootFromParent_Done,
     /* 1211041 */   // Label 17520: @1211041
     /* 1211041 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1211125), // Rule ID 9581 //
     /* 1211046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1211049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1211054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1211057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1211060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1211066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1211069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1211102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211124 */     // GIR_Coverage, 9581,
     /* 1211124 */     GIR_EraseRootFromParent_Done,
     /* 1211125 */   // Label 17521: @1211125
     /* 1211125 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1211209), // Rule ID 9584 //
     /* 1211130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1211141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1211144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1211147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1211150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1211153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211183 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1211186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211208 */     // GIR_Coverage, 9584,
     /* 1211208 */     GIR_EraseRootFromParent_Done,
     /* 1211209 */   // Label 17522: @1211209
     /* 1211209 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1211293), // Rule ID 9585 //
     /* 1211214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1211217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1211225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1211228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1211231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1211234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1211237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1211270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211292 */     // GIR_Coverage, 9585,
     /* 1211292 */     GIR_EraseRootFromParent_Done,
     /* 1211293 */   // Label 17523: @1211293
     /* 1211293 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1211377), // Rule ID 9588 //
     /* 1211298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1211309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1211312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1211315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1211318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1211321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1211354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211376 */     // GIR_Coverage, 9588,
     /* 1211376 */     GIR_EraseRootFromParent_Done,
     /* 1211377 */   // Label 17524: @1211377
     /* 1211377 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1211461), // Rule ID 9589 //
     /* 1211382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1211385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1211393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1211396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1211399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1211402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1211405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211435 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1211438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211460 */     // GIR_Coverage, 9589,
     /* 1211460 */     GIR_EraseRootFromParent_Done,
     /* 1211461 */   // Label 17525: @1211461
     /* 1211461 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1211545), // Rule ID 9592 //
     /* 1211466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1211477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1211480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1211483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1211486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1211489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211519 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1211522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211544 */     // GIR_Coverage, 9592,
     /* 1211544 */     GIR_EraseRootFromParent_Done,
     /* 1211545 */   // Label 17526: @1211545
     /* 1211545 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1211629), // Rule ID 9593 //
     /* 1211550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1211553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1211561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1211564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1211567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1211570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1211573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211603 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1211606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1211624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211628 */     // GIR_Coverage, 9593,
     /* 1211628 */     GIR_EraseRootFromParent_Done,
     /* 1211629 */   // Label 17527: @1211629
     /* 1211629 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1211713), // Rule ID 9596 //
     /* 1211634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1211645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1211648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1211657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1211690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211712 */     // GIR_Coverage, 9596,
     /* 1211712 */     GIR_EraseRootFromParent_Done,
     /* 1211713 */   // Label 17528: @1211713
     /* 1211713 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1211797), // Rule ID 9597 //
     /* 1211718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1211721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1211729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1211732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1211741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1211774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211796 */     // GIR_Coverage, 9597,
     /* 1211796 */     GIR_EraseRootFromParent_Done,
     /* 1211797 */   // Label 17529: @1211797
     /* 1211797 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1211881), // Rule ID 9600 //
     /* 1211802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1211813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1211816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1211825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211855 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1211855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1211858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211880 */     // GIR_Coverage, 9600,
     /* 1211880 */     GIR_EraseRootFromParent_Done,
     /* 1211881 */   // Label 17530: @1211881
     /* 1211881 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1211965), // Rule ID 9601 //
     /* 1211886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1211889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1211897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1211900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1211909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1211932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211939 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1211939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1211942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1211948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1211950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1211952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1211963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211964 */     // GIR_Coverage, 9601,
     /* 1211964 */     GIR_EraseRootFromParent_Done,
     /* 1211965 */   // Label 17531: @1211965
     /* 1211965 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1212049), // Rule ID 9604 //
     /* 1211970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1211973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1211978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1211981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1211984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1211993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1212026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212048 */     // GIR_Coverage, 9604,
     /* 1212048 */     GIR_EraseRootFromParent_Done,
     /* 1212049 */   // Label 17532: @1212049
     /* 1212049 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1212133), // Rule ID 9605 //
     /* 1212054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1212057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1212065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1212068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1212077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212107 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1212110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212132 */     // GIR_Coverage, 9605,
     /* 1212132 */     GIR_EraseRootFromParent_Done,
     /* 1212133 */   // Label 17533: @1212133
     /* 1212133 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1212217), // Rule ID 9608 //
     /* 1212138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1212141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1212149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1212152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1212155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1212158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1212161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212191 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1212212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212216 */     // GIR_Coverage, 9608,
     /* 1212216 */     GIR_EraseRootFromParent_Done,
     /* 1212217 */   // Label 17534: @1212217
     /* 1212217 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1212301), // Rule ID 9609 //
     /* 1212222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1212225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1212233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1212236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1212239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1212242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1212245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1212296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212300 */     // GIR_Coverage, 9609,
     /* 1212300 */     GIR_EraseRootFromParent_Done,
     /* 1212301 */   // Label 17535: @1212301
     /* 1212301 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1212385), // Rule ID 9612 //
     /* 1212306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1212309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1212317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1212320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1212329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212384 */     // GIR_Coverage, 9612,
     /* 1212384 */     GIR_EraseRootFromParent_Done,
     /* 1212385 */   // Label 17536: @1212385
     /* 1212385 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1212469), // Rule ID 9613 //
     /* 1212390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1212393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1212401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1212404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1212413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212468 */     // GIR_Coverage, 9613,
     /* 1212468 */     GIR_EraseRootFromParent_Done,
     /* 1212469 */   // Label 17537: @1212469
     /* 1212469 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1212553), // Rule ID 9616 //
     /* 1212474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1212477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1212485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1212488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1212497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212527 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212552 */     // GIR_Coverage, 9616,
     /* 1212552 */     GIR_EraseRootFromParent_Done,
     /* 1212553 */   // Label 17538: @1212553
     /* 1212553 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1212637), // Rule ID 9617 //
     /* 1212558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1212561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1212569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1212572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1212581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212636 */     // GIR_Coverage, 9617,
     /* 1212636 */     GIR_EraseRootFromParent_Done,
     /* 1212637 */   // Label 17539: @1212637
     /* 1212637 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1212721), // Rule ID 9620 //
     /* 1212642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1212645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1212653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1212656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1212665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212695 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212720 */     // GIR_Coverage, 9620,
     /* 1212720 */     GIR_EraseRootFromParent_Done,
     /* 1212721 */   // Label 17540: @1212721
     /* 1212721 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1212805), // Rule ID 9621 //
     /* 1212726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1212729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1212737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1212740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1212749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212779 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1212782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212804 */     // GIR_Coverage, 9621,
     /* 1212804 */     GIR_EraseRootFromParent_Done,
     /* 1212805 */   // Label 17541: @1212805
     /* 1212805 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1212889), // Rule ID 9624 //
     /* 1212810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1212813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1212821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1212824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1212827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1212830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1212833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1212863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1212866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1212884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212888 */     // GIR_Coverage, 9624,
     /* 1212888 */     GIR_EraseRootFromParent_Done,
     /* 1212889 */   // Label 17542: @1212889
     /* 1212889 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1212973), // Rule ID 9625 //
     /* 1212894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1212897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1212905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1212908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1212911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1212914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1212917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1212940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1212947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1212950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1212956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1212958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1212960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1212968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1212971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212972 */     // GIR_Coverage, 9625,
     /* 1212972 */     GIR_EraseRootFromParent_Done,
     /* 1212973 */   // Label 17543: @1212973
     /* 1212973 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1213057), // Rule ID 9628 //
     /* 1212978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1212981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1212986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1212989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1212992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1212995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1212998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1213001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213031 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1213034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1213052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213056 */     // GIR_Coverage, 9628,
     /* 1213056 */     GIR_EraseRootFromParent_Done,
     /* 1213057 */   // Label 17544: @1213057
     /* 1213057 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1213141), // Rule ID 9629 //
     /* 1213062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1213073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1213076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1213079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1213082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1213085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213115 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1213118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1213136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213140 */     // GIR_Coverage, 9629,
     /* 1213140 */     GIR_EraseRootFromParent_Done,
     /* 1213141 */   // Label 17545: @1213141
     /* 1213141 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1213225), // Rule ID 9632 //
     /* 1213146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1213157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1213160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1213163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1213166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1213169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213199 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1213202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1213220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213224 */     // GIR_Coverage, 9632,
     /* 1213224 */     GIR_EraseRootFromParent_Done,
     /* 1213225 */   // Label 17546: @1213225
     /* 1213225 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1213309), // Rule ID 9633 //
     /* 1213230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1213241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1213244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1213247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1213250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1213253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213283 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1213286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1213304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213308 */     // GIR_Coverage, 9633,
     /* 1213308 */     GIR_EraseRootFromParent_Done,
     /* 1213309 */   // Label 17547: @1213309
     /* 1213309 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1213393), // Rule ID 9636 //
     /* 1213314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1213325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1213328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1213331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1213334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1213337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1213370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213392 */     // GIR_Coverage, 9636,
     /* 1213392 */     GIR_EraseRootFromParent_Done,
     /* 1213393 */   // Label 17548: @1213393
     /* 1213393 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1213477), // Rule ID 9637 //
     /* 1213398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1213409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1213412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1213415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1213418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1213421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213451 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1213454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213476 */     // GIR_Coverage, 9637,
     /* 1213476 */     GIR_EraseRootFromParent_Done,
     /* 1213477 */   // Label 17549: @1213477
     /* 1213477 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1213561), // Rule ID 9640 //
     /* 1213482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1213493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1213496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1213505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213535 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1213538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213560 */     // GIR_Coverage, 9640,
     /* 1213560 */     GIR_EraseRootFromParent_Done,
     /* 1213561 */   // Label 17550: @1213561
     /* 1213561 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1213645), // Rule ID 9641 //
     /* 1213566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1213577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1213580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1213589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213619 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1213622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213644 */     // GIR_Coverage, 9641,
     /* 1213644 */     GIR_EraseRootFromParent_Done,
     /* 1213645 */   // Label 17551: @1213645
     /* 1213645 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1213729), // Rule ID 9644 //
     /* 1213650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1213661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1213664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1213673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213703 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1213706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213728 */     // GIR_Coverage, 9644,
     /* 1213728 */     GIR_EraseRootFromParent_Done,
     /* 1213729 */   // Label 17552: @1213729
     /* 1213729 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1213813), // Rule ID 9645 //
     /* 1213734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1213745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1213748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1213757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213787 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1213790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213812 */     // GIR_Coverage, 9645,
     /* 1213812 */     GIR_EraseRootFromParent_Done,
     /* 1213813 */   // Label 17553: @1213813
     /* 1213813 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1213897), // Rule ID 9648 //
     /* 1213818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1213829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1213832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1213841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213871 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1213871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1213874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213896 */     // GIR_Coverage, 9648,
     /* 1213896 */     GIR_EraseRootFromParent_Done,
     /* 1213897 */   // Label 17554: @1213897
     /* 1213897 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1213981), // Rule ID 9649 //
     /* 1213902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1213905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1213913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1213916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1213925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1213948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1213955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1213958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1213964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1213966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1213968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1213979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213980 */     // GIR_Coverage, 9649,
     /* 1213980 */     GIR_EraseRootFromParent_Done,
     /* 1213981 */   // Label 17555: @1213981
     /* 1213981 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1214065), // Rule ID 9652 //
     /* 1213986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1213989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1213994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1213997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1214000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1214003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1214006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1214009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214039 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1214042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214064 */     // GIR_Coverage, 9652,
     /* 1214064 */     GIR_EraseRootFromParent_Done,
     /* 1214065 */   // Label 17556: @1214065
     /* 1214065 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1214149), // Rule ID 9653 //
     /* 1214070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1214073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1214081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1214084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1214087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1214090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1214093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214123 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1214126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214148 */     // GIR_Coverage, 9653,
     /* 1214148 */     GIR_EraseRootFromParent_Done,
     /* 1214149 */   // Label 17557: @1214149
     /* 1214149 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1214233), // Rule ID 9656 //
     /* 1214154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1214157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1214165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1214168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1214171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1214174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1214177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214207 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1214210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214232 */     // GIR_Coverage, 9656,
     /* 1214232 */     GIR_EraseRootFromParent_Done,
     /* 1214233 */   // Label 17558: @1214233
     /* 1214233 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1214317), // Rule ID 9657 //
     /* 1214238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1214241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1214249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1214252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1214255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1214258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1214261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214291 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1214294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214316 */     // GIR_Coverage, 9657,
     /* 1214316 */     GIR_EraseRootFromParent_Done,
     /* 1214317 */   // Label 17559: @1214317
     /* 1214317 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1214401), // Rule ID 9660 //
     /* 1214322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1214325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1214333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1214336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1214339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1214342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1214345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214375 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1214378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214400 */     // GIR_Coverage, 9660,
     /* 1214400 */     GIR_EraseRootFromParent_Done,
     /* 1214401 */   // Label 17560: @1214401
     /* 1214401 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1214485), // Rule ID 9661 //
     /* 1214406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1214409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1214417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1214420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1214423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1214426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1214429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214459 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1214462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214484 */     // GIR_Coverage, 9661,
     /* 1214484 */     GIR_EraseRootFromParent_Done,
     /* 1214485 */   // Label 17561: @1214485
     /* 1214485 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1214569), // Rule ID 9664 //
     /* 1214490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1214493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1214501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1214504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1214513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214543 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1214546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214568 */     // GIR_Coverage, 9664,
     /* 1214568 */     GIR_EraseRootFromParent_Done,
     /* 1214569 */   // Label 17562: @1214569
     /* 1214569 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1214653), // Rule ID 9665 //
     /* 1214574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1214577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1214585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1214588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1214597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1214630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214652 */     // GIR_Coverage, 9665,
     /* 1214652 */     GIR_EraseRootFromParent_Done,
     /* 1214653 */   // Label 17563: @1214653
     /* 1214653 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1214737), // Rule ID 9668 //
     /* 1214658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1214661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1214669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1214672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1214681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214711 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1214714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214736 */     // GIR_Coverage, 9668,
     /* 1214736 */     GIR_EraseRootFromParent_Done,
     /* 1214737 */   // Label 17564: @1214737
     /* 1214737 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1214821), // Rule ID 9669 //
     /* 1214742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1214745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1214750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1214753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1214756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1214765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214795 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1214798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214820 */     // GIR_Coverage, 9669,
     /* 1214820 */     GIR_EraseRootFromParent_Done,
     /* 1214821 */   // Label 17565: @1214821
     /* 1214821 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1214905), // Rule ID 9672 //
     /* 1214826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1214829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1214834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1214837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1214840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1214843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1214846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1214849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214879 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1214879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1214882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1214900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214904 */     // GIR_Coverage, 9672,
     /* 1214904 */     GIR_EraseRootFromParent_Done,
     /* 1214905 */   // Label 17566: @1214905
     /* 1214905 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1214989), // Rule ID 9673 //
     /* 1214910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1214913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1214918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1214921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1214924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1214927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1214930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1214933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1214956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214963 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1214963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1214966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1214972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1214974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1214976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1214984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1214987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214988 */     // GIR_Coverage, 9673,
     /* 1214988 */     GIR_EraseRootFromParent_Done,
     /* 1214989 */   // Label 17567: @1214989
     /* 1214989 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1215073), // Rule ID 9676 //
     /* 1214994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1214997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1215005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1215008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1215011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1215014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1215017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215047 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1215050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215072 */     // GIR_Coverage, 9676,
     /* 1215072 */     GIR_EraseRootFromParent_Done,
     /* 1215073 */   // Label 17568: @1215073
     /* 1215073 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1215157), // Rule ID 9677 //
     /* 1215078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1215089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1215092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1215095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1215098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1215101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1215134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215156 */     // GIR_Coverage, 9677,
     /* 1215156 */     GIR_EraseRootFromParent_Done,
     /* 1215157 */   // Label 17569: @1215157
     /* 1215157 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1215241), // Rule ID 9680 //
     /* 1215162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1215165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1215173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1215176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1215179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1215182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1215185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215240 */     // GIR_Coverage, 9680,
     /* 1215240 */     GIR_EraseRootFromParent_Done,
     /* 1215241 */   // Label 17570: @1215241
     /* 1215241 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1215325), // Rule ID 9681 //
     /* 1215246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1215257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1215260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1215263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1215266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1215269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215299 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215324 */     // GIR_Coverage, 9681,
     /* 1215324 */     GIR_EraseRootFromParent_Done,
     /* 1215325 */   // Label 17571: @1215325
     /* 1215325 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1215409), // Rule ID 9684 //
     /* 1215330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1215333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1215341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1215344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1215347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1215350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1215353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1215386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215408 */     // GIR_Coverage, 9684,
     /* 1215408 */     GIR_EraseRootFromParent_Done,
     /* 1215409 */   // Label 17572: @1215409
     /* 1215409 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1215493), // Rule ID 9685 //
     /* 1215414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1215425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1215428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1215431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1215434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1215437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1215470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215492 */     // GIR_Coverage, 9685,
     /* 1215492 */     GIR_EraseRootFromParent_Done,
     /* 1215493 */   // Label 17573: @1215493
     /* 1215493 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1215577), // Rule ID 9688 //
     /* 1215498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1215501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1215509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1215512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1215515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1215518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1215521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215551 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215576 */     // GIR_Coverage, 9688,
     /* 1215576 */     GIR_EraseRootFromParent_Done,
     /* 1215577 */   // Label 17574: @1215577
     /* 1215577 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1215661), // Rule ID 9689 //
     /* 1215582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1215593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1215596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1215599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1215602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1215605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215660 */     // GIR_Coverage, 9689,
     /* 1215660 */     GIR_EraseRootFromParent_Done,
     /* 1215661 */   // Label 17575: @1215661
     /* 1215661 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1215745), // Rule ID 9692 //
     /* 1215666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1215669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1215677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1215680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1215683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1215686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1215689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215719 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215744 */     // GIR_Coverage, 9692,
     /* 1215744 */     GIR_EraseRootFromParent_Done,
     /* 1215745 */   // Label 17576: @1215745
     /* 1215745 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1215829), // Rule ID 9693 //
     /* 1215750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1215761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1215764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1215767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1215770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1215773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1215806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215828 */     // GIR_Coverage, 9693,
     /* 1215828 */     GIR_EraseRootFromParent_Done,
     /* 1215829 */   // Label 17577: @1215829
     /* 1215829 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1215913), // Rule ID 9696 //
     /* 1215834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1215837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1215845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1215848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1215851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1215854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1215857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215887 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1215887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1215890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215912 */     // GIR_Coverage, 9696,
     /* 1215912 */     GIR_EraseRootFromParent_Done,
     /* 1215913 */   // Label 17578: @1215913
     /* 1215913 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1215997), // Rule ID 9697 //
     /* 1215918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1215921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1215926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1215929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1215932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1215935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1215938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1215941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1215964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215971 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1215971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1215974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1215980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1215982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1215984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1215992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1215995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215996 */     // GIR_Coverage, 9697,
     /* 1215996 */     GIR_EraseRootFromParent_Done,
     /* 1215997 */   // Label 17579: @1215997
     /* 1215997 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1216081), // Rule ID 9700 //
     /* 1216002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1216005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1216013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1216016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1216025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216080 */     // GIR_Coverage, 9700,
     /* 1216080 */     GIR_EraseRootFromParent_Done,
     /* 1216081 */   // Label 17580: @1216081
     /* 1216081 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1216165), // Rule ID 9701 //
     /* 1216086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1216089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1216097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1216100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1216109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216164 */     // GIR_Coverage, 9701,
     /* 1216164 */     GIR_EraseRootFromParent_Done,
     /* 1216165 */   // Label 17581: @1216165
     /* 1216165 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1216249), // Rule ID 9704 //
     /* 1216170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1216173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1216181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1216184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1216193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216223 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216248 */     // GIR_Coverage, 9704,
     /* 1216248 */     GIR_EraseRootFromParent_Done,
     /* 1216249 */   // Label 17582: @1216249
     /* 1216249 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1216333), // Rule ID 9705 //
     /* 1216254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1216257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1216265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1216268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1216277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216332 */     // GIR_Coverage, 9705,
     /* 1216332 */     GIR_EraseRootFromParent_Done,
     /* 1216333 */   // Label 17583: @1216333
     /* 1216333 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1216417), // Rule ID 9708 //
     /* 1216338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1216341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1216349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1216352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1216361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216391 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216416 */     // GIR_Coverage, 9708,
     /* 1216416 */     GIR_EraseRootFromParent_Done,
     /* 1216417 */   // Label 17584: @1216417
     /* 1216417 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1216501), // Rule ID 9709 //
     /* 1216422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1216425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1216433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1216436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1216445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216475 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1216478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216500 */     // GIR_Coverage, 9709,
     /* 1216500 */     GIR_EraseRootFromParent_Done,
     /* 1216501 */   // Label 17585: @1216501
     /* 1216501 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1216585), // Rule ID 9712 //
     /* 1216506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1216509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1216517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1216520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1216523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1216526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1216529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216559 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1216562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1216580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216584 */     // GIR_Coverage, 9712,
     /* 1216584 */     GIR_EraseRootFromParent_Done,
     /* 1216585 */   // Label 17586: @1216585
     /* 1216585 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1216669), // Rule ID 9713 //
     /* 1216590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1216593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1216601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1216604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1216607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1216610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1216613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1216646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1216664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216668 */     // GIR_Coverage, 9713,
     /* 1216668 */     GIR_EraseRootFromParent_Done,
     /* 1216669 */   // Label 17587: @1216669
     /* 1216669 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1216753), // Rule ID 9716 //
     /* 1216674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1216677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1216685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1216688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1216691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1216694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1216697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216727 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1216730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1216748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216752 */     // GIR_Coverage, 9716,
     /* 1216752 */     GIR_EraseRootFromParent_Done,
     /* 1216753 */   // Label 17588: @1216753
     /* 1216753 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1216837), // Rule ID 9717 //
     /* 1216758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1216761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1216769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1216772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1216775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1216778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1216781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216811 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1216814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1216832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216836 */     // GIR_Coverage, 9717,
     /* 1216836 */     GIR_EraseRootFromParent_Done,
     /* 1216837 */   // Label 17589: @1216837
     /* 1216837 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1216921), // Rule ID 9720 //
     /* 1216842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1216845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1216853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1216856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1216859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1216862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1216865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216895 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1216895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1216898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1216916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1216919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216920 */     // GIR_Coverage, 9720,
     /* 1216920 */     GIR_EraseRootFromParent_Done,
     /* 1216921 */   // Label 17590: @1216921
     /* 1216921 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1217005), // Rule ID 9721 //
     /* 1216926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1216929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1216934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1216937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1216940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1216943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1216946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1216949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1216972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216979 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1216979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1216982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1216988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1216990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1216992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1217000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217004 */     // GIR_Coverage, 9721,
     /* 1217004 */     GIR_EraseRootFromParent_Done,
     /* 1217005 */   // Label 17591: @1217005
     /* 1217005 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1217089), // Rule ID 9724 //
     /* 1217010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1217021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1217024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1217033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217063 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1217066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217088 */     // GIR_Coverage, 9724,
     /* 1217088 */     GIR_EraseRootFromParent_Done,
     /* 1217089 */   // Label 17592: @1217089
     /* 1217089 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1217173), // Rule ID 9725 //
     /* 1217094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1217105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1217108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1217117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1217150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217172 */     // GIR_Coverage, 9725,
     /* 1217172 */     GIR_EraseRootFromParent_Done,
     /* 1217173 */   // Label 17593: @1217173
     /* 1217173 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1217257), // Rule ID 9728 //
     /* 1217178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1217189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1217192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1217201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1217234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217256 */     // GIR_Coverage, 9728,
     /* 1217256 */     GIR_EraseRootFromParent_Done,
     /* 1217257 */   // Label 17594: @1217257
     /* 1217257 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1217341), // Rule ID 9729 //
     /* 1217262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1217273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1217276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1217285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1217318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217340 */     // GIR_Coverage, 9729,
     /* 1217340 */     GIR_EraseRootFromParent_Done,
     /* 1217341 */   // Label 17595: @1217341
     /* 1217341 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1217425), // Rule ID 9732 //
     /* 1217346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1217357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1217360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1217369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217399 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1217402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217424 */     // GIR_Coverage, 9732,
     /* 1217424 */     GIR_EraseRootFromParent_Done,
     /* 1217425 */   // Label 17596: @1217425
     /* 1217425 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1217509), // Rule ID 9733 //
     /* 1217430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1217441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1217444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1217453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217483 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1217486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217508 */     // GIR_Coverage, 9733,
     /* 1217508 */     GIR_EraseRootFromParent_Done,
     /* 1217509 */   // Label 17597: @1217509
     /* 1217509 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1217593), // Rule ID 9736 //
     /* 1217514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1217525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1217528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1217537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217567 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1217570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217592 */     // GIR_Coverage, 9736,
     /* 1217592 */     GIR_EraseRootFromParent_Done,
     /* 1217593 */   // Label 17598: @1217593
     /* 1217593 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1217677), // Rule ID 9737 //
     /* 1217598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1217609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1217612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1217621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217651 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1217654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217676 */     // GIR_Coverage, 9737,
     /* 1217676 */     GIR_EraseRootFromParent_Done,
     /* 1217677 */   // Label 17599: @1217677
     /* 1217677 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1217761), // Rule ID 9740 //
     /* 1217682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1217693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1217696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1217705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217735 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1217738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217760 */     // GIR_Coverage, 9740,
     /* 1217760 */     GIR_EraseRootFromParent_Done,
     /* 1217761 */   // Label 17600: @1217761
     /* 1217761 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1217845), // Rule ID 9741 //
     /* 1217766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1217777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1217780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1217789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1217822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217844 */     // GIR_Coverage, 9741,
     /* 1217844 */     GIR_EraseRootFromParent_Done,
     /* 1217845 */   // Label 17601: @1217845
     /* 1217845 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1217929), // Rule ID 9744 //
     /* 1217850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1217853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1217861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1217864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1217873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217903 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1217903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1217906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1217916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1217927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217928 */     // GIR_Coverage, 9744,
     /* 1217928 */     GIR_EraseRootFromParent_Done,
     /* 1217929 */   // Label 17602: @1217929
     /* 1217929 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1218013), // Rule ID 9745 //
     /* 1217934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1217937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1217942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1217945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1217948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1217957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1217980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217987 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1217987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1217990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1217996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1217998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218012 */     // GIR_Coverage, 9745,
     /* 1218012 */     GIR_EraseRootFromParent_Done,
     /* 1218013 */   // Label 17603: @1218013
     /* 1218013 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1218097), // Rule ID 9748 //
     /* 1218018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1218021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1218029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1218032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1218041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218071 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1218071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1218074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218096 */     // GIR_Coverage, 9748,
     /* 1218096 */     GIR_EraseRootFromParent_Done,
     /* 1218097 */   // Label 17604: @1218097
     /* 1218097 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1218181), // Rule ID 9749 //
     /* 1218102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1218105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1218113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1218116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1218125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1218155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1218158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218180 */     // GIR_Coverage, 9749,
     /* 1218180 */     GIR_EraseRootFromParent_Done,
     /* 1218181 */   // Label 17605: @1218181
     /* 1218181 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1218265), // Rule ID 9752 //
     /* 1218186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1218189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1218197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1218200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1218209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218239 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1218239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1218242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218264 */     // GIR_Coverage, 9752,
     /* 1218264 */     GIR_EraseRootFromParent_Done,
     /* 1218265 */   // Label 17606: @1218265
     /* 1218265 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1218349), // Rule ID 9753 //
     /* 1218270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1218273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1218281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1218284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1218293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218323 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1218323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1218326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218348 */     // GIR_Coverage, 9753,
     /* 1218348 */     GIR_EraseRootFromParent_Done,
     /* 1218349 */   // Label 17607: @1218349
     /* 1218349 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1218433), // Rule ID 9756 //
     /* 1218354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1218357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1218365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1218368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1218377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218407 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1218407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1218410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218432 */     // GIR_Coverage, 9756,
     /* 1218432 */     GIR_EraseRootFromParent_Done,
     /* 1218433 */   // Label 17608: @1218433
     /* 1218433 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1218517), // Rule ID 9757 //
     /* 1218438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1218441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1218446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1218449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1218452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1218461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218491 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1218491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1218494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1218500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1218502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1218515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218516 */     // GIR_Coverage, 9757,
     /* 1218516 */     GIR_EraseRootFromParent_Done,
     /* 1218517 */   // Label 17609: @1218517
     /* 1218517 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1218598), // Rule ID 13698 //
     /* 1218522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1218525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1218533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1218536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1218539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1218542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1218545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218575 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1218575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1218578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1218596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218597 */     // GIR_Coverage, 13698,
     /* 1218597 */     GIR_EraseRootFromParent_Done,
     /* 1218598 */   // Label 17610: @1218598
     /* 1218598 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1218679), // Rule ID 13699 //
     /* 1218603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1218606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1218614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1218617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1218620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1218623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1218626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1218656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1218659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1218677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218678 */     // GIR_Coverage, 13699,
     /* 1218678 */     GIR_EraseRootFromParent_Done,
     /* 1218679 */   // Label 17611: @1218679
     /* 1218679 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1218760), // Rule ID 13700 //
     /* 1218684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1218687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1218695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1218698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1218701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1218704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1218707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218737 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1218737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1218740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1218758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218759 */     // GIR_Coverage, 13700,
     /* 1218759 */     GIR_EraseRootFromParent_Done,
     /* 1218760 */   // Label 17612: @1218760
     /* 1218760 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1218841), // Rule ID 13701 //
     /* 1218765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1218768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1218776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1218779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1218782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1218785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1218788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218818 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1218818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1218821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1218839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218840 */     // GIR_Coverage, 13701,
     /* 1218840 */     GIR_EraseRootFromParent_Done,
     /* 1218841 */   // Label 17613: @1218841
     /* 1218841 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1218922), // Rule ID 13702 //
     /* 1218846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1218849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1218857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1218860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1218863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1218866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1218869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218899 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1218899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1218902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1218920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218921 */     // GIR_Coverage, 13702,
     /* 1218921 */     GIR_EraseRootFromParent_Done,
     /* 1218922 */   // Label 17614: @1218922
     /* 1218922 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1219003), // Rule ID 13703 //
     /* 1218927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1218930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1218935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1218938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1218941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1218944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1218947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1218950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1218957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1218973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218980 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1218980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1218983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1218993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1219001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219002 */     // GIR_Coverage, 13703,
     /* 1219002 */     GIR_EraseRootFromParent_Done,
     /* 1219003 */   // Label 17615: @1219003
     /* 1219003 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1219084), // Rule ID 13704 //
     /* 1219008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1219028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1219031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219061 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1219061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1219064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219083 */     // GIR_Coverage, 13704,
     /* 1219083 */     GIR_EraseRootFromParent_Done,
     /* 1219084 */   // Label 17616: @1219084
     /* 1219084 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1219165), // Rule ID 13705 //
     /* 1219089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1219109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1219112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1219142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1219145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219164 */     // GIR_Coverage, 13705,
     /* 1219164 */     GIR_EraseRootFromParent_Done,
     /* 1219165 */   // Label 17617: @1219165
     /* 1219165 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1219246), // Rule ID 13706 //
     /* 1219170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1219190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1219193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1219223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1219226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219245 */     // GIR_Coverage, 13706,
     /* 1219245 */     GIR_EraseRootFromParent_Done,
     /* 1219246 */   // Label 17618: @1219246
     /* 1219246 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1219327), // Rule ID 13707 //
     /* 1219251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1219271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1219274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1219304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1219307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219326 */     // GIR_Coverage, 13707,
     /* 1219326 */     GIR_EraseRootFromParent_Done,
     /* 1219327 */   // Label 17619: @1219327
     /* 1219327 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1219408), // Rule ID 13708 //
     /* 1219332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1219352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1219355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219385 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1219385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1219388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219407 */     // GIR_Coverage, 13708,
     /* 1219407 */     GIR_EraseRootFromParent_Done,
     /* 1219408 */   // Label 17620: @1219408
     /* 1219408 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1219489), // Rule ID 13709 //
     /* 1219413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1219433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1219436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1219466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1219469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219488 */     // GIR_Coverage, 13709,
     /* 1219488 */     GIR_EraseRootFromParent_Done,
     /* 1219489 */   // Label 17621: @1219489
     /* 1219489 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1219570), // Rule ID 13710 //
     /* 1219494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1219505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1219508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1219511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1219514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1219517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219547 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1219547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1219568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219569 */     // GIR_Coverage, 13710,
     /* 1219569 */     GIR_EraseRootFromParent_Done,
     /* 1219570 */   // Label 17622: @1219570
     /* 1219570 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1219651), // Rule ID 13711 //
     /* 1219575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1219586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1219589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1219592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1219595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1219598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1219628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1219649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219650 */     // GIR_Coverage, 13711,
     /* 1219650 */     GIR_EraseRootFromParent_Done,
     /* 1219651 */   // Label 17623: @1219651
     /* 1219651 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1219732), // Rule ID 13712 //
     /* 1219656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1219676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1219679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219709 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1219709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219731 */     // GIR_Coverage, 13712,
     /* 1219731 */     GIR_EraseRootFromParent_Done,
     /* 1219732 */   // Label 17624: @1219732
     /* 1219732 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1219813), // Rule ID 13713 //
     /* 1219737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1219757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1219760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1219790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219812 */     // GIR_Coverage, 13713,
     /* 1219812 */     GIR_EraseRootFromParent_Done,
     /* 1219813 */   // Label 17625: @1219813
     /* 1219813 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1219894), // Rule ID 13714 //
     /* 1219818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1219821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1219838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1219841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1219871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219893 */     // GIR_Coverage, 13714,
     /* 1219893 */     GIR_EraseRootFromParent_Done,
     /* 1219894 */   // Label 17626: @1219894
     /* 1219894 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1219975), // Rule ID 13715 //
     /* 1219899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1219902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1219919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1219922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1219929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1219945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1219952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1219955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1219965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219974 */     // GIR_Coverage, 13715,
     /* 1219974 */     GIR_EraseRootFromParent_Done,
     /* 1219975 */   // Label 17627: @1219975
     /* 1219975 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1220056), // Rule ID 13716 //
     /* 1219980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1219983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1219988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1220000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1220003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1220010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1220033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1220036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220055 */     // GIR_Coverage, 13716,
     /* 1220055 */     GIR_EraseRootFromParent_Done,
     /* 1220056 */   // Label 17628: @1220056
     /* 1220056 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1220137), // Rule ID 13717 //
     /* 1220061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1220064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1220072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1220075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1220078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1220081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1220084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1220091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1220114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1220117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220136 */     // GIR_Coverage, 13717,
     /* 1220136 */     GIR_EraseRootFromParent_Done,
     /* 1220137 */   // Label 17629: @1220137
     /* 1220137 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1220218), // Rule ID 13718 //
     /* 1220142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1220153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1220156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1220159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1220162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1220165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1220172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220195 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1220195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1220198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220217 */     // GIR_Coverage, 13718,
     /* 1220217 */     GIR_EraseRootFromParent_Done,
     /* 1220218 */   // Label 17630: @1220218
     /* 1220218 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1220299), // Rule ID 13719 //
     /* 1220223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1220226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1220234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1220237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1220240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1220243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1220246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1220253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1220276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1220279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220298 */     // GIR_Coverage, 13719,
     /* 1220298 */     GIR_EraseRootFromParent_Done,
     /* 1220299 */   // Label 17631: @1220299
     /* 1220299 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1220380), // Rule ID 13720 //
     /* 1220304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1220315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1220318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1220321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1220324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1220327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1220334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220357 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1220357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1220360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220379 */     // GIR_Coverage, 13720,
     /* 1220379 */     GIR_EraseRootFromParent_Done,
     /* 1220380 */   // Label 17632: @1220380
     /* 1220380 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1220461), // Rule ID 13721 //
     /* 1220385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1220388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1220396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1220399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1220402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1220405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1220408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1220415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1220438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1220441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220460 */     // GIR_Coverage, 13721,
     /* 1220460 */     GIR_EraseRootFromParent_Done,
     /* 1220461 */   // Label 17633: @1220461
     /* 1220461 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1220542), // Rule ID 13722 //
     /* 1220466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1220477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1220480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1220483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1220486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1220489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1220496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220519 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1220519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1220522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220541 */     // GIR_Coverage, 13722,
     /* 1220541 */     GIR_EraseRootFromParent_Done,
     /* 1220542 */   // Label 17634: @1220542
     /* 1220542 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1220623), // Rule ID 13723 //
     /* 1220547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1220550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1220558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1220561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1220564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1220567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1220570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1220577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1220621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220622 */     // GIR_Coverage, 13723,
     /* 1220622 */     GIR_EraseRootFromParent_Done,
     /* 1220623 */   // Label 17635: @1220623
     /* 1220623 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1220704), // Rule ID 13724 //
     /* 1220628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1220648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1220651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1220658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1220681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1220684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220703 */     // GIR_Coverage, 13724,
     /* 1220703 */     GIR_EraseRootFromParent_Done,
     /* 1220704 */   // Label 17636: @1220704
     /* 1220704 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1220785), // Rule ID 13725 //
     /* 1220709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1220712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1220729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1220732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1220739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1220762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1220765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220784 */     // GIR_Coverage, 13725,
     /* 1220784 */     GIR_EraseRootFromParent_Done,
     /* 1220785 */   // Label 17637: @1220785
     /* 1220785 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1220866), // Rule ID 13726 //
     /* 1220790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1220810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1220813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1220820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220843 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1220843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1220846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220865 */     // GIR_Coverage, 13726,
     /* 1220865 */     GIR_EraseRootFromParent_Done,
     /* 1220866 */   // Label 17638: @1220866
     /* 1220866 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1220947), // Rule ID 13727 //
     /* 1220871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1220874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1220891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1220894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1220901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1220924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1220927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1220937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220946 */     // GIR_Coverage, 13727,
     /* 1220946 */     GIR_EraseRootFromParent_Done,
     /* 1220947 */   // Label 17639: @1220947
     /* 1220947 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1221028), // Rule ID 13728 //
     /* 1220952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1220955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1220960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1220972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1220975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1220982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1220998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221005 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1221005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1221008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221027 */     // GIR_Coverage, 13728,
     /* 1221027 */     GIR_EraseRootFromParent_Done,
     /* 1221028 */   // Label 17640: @1221028
     /* 1221028 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1221109), // Rule ID 13729 //
     /* 1221033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1221036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1221044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1221047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1221050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1221053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1221056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1221063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221086 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1221086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1221089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221108 */     // GIR_Coverage, 13729,
     /* 1221108 */     GIR_EraseRootFromParent_Done,
     /* 1221109 */   // Label 17641: @1221109
     /* 1221109 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1221190), // Rule ID 13730 //
     /* 1221114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1221117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1221125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1221128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1221134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1221137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1221144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1221167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1221170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221189 */     // GIR_Coverage, 13730,
     /* 1221189 */     GIR_EraseRootFromParent_Done,
     /* 1221190 */   // Label 17642: @1221190
     /* 1221190 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1221271), // Rule ID 13731 //
     /* 1221195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1221198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1221206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1221209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1221215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1221218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1221225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1221248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1221251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221270 */     // GIR_Coverage, 13731,
     /* 1221270 */     GIR_EraseRootFromParent_Done,
     /* 1221271 */   // Label 17643: @1221271
     /* 1221271 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1221352), // Rule ID 13732 //
     /* 1221276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1221279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1221287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1221290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1221296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1221299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1221306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221329 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1221329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1221332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221351 */     // GIR_Coverage, 13732,
     /* 1221351 */     GIR_EraseRootFromParent_Done,
     /* 1221352 */   // Label 17644: @1221352
     /* 1221352 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1221433), // Rule ID 13733 //
     /* 1221357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1221360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1221368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1221371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1221377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1221380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1221387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1221410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1221413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221432 */     // GIR_Coverage, 13733,
     /* 1221432 */     GIR_EraseRootFromParent_Done,
     /* 1221433 */   // Label 17645: @1221433
     /* 1221433 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1221514), // Rule ID 13734 //
     /* 1221438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1221441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1221449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1221458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1221461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1221468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1221491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1221494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221513 */     // GIR_Coverage, 13734,
     /* 1221513 */     GIR_EraseRootFromParent_Done,
     /* 1221514 */   // Label 17646: @1221514
     /* 1221514 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1221595), // Rule ID 13735 //
     /* 1221519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1221522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1221530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1221539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1221542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1221549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221572 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1221572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1221575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221594 */     // GIR_Coverage, 13735,
     /* 1221594 */     GIR_EraseRootFromParent_Done,
     /* 1221595 */   // Label 17647: @1221595
     /* 1221595 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1221676), // Rule ID 13736 //
     /* 1221600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1221603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1221620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1221623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1221630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1221653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1221656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221675 */     // GIR_Coverage, 13736,
     /* 1221675 */     GIR_EraseRootFromParent_Done,
     /* 1221676 */   // Label 17648: @1221676
     /* 1221676 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1221757), // Rule ID 13737 //
     /* 1221681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1221684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1221701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1221704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1221711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1221734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1221737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221756 */     // GIR_Coverage, 13737,
     /* 1221756 */     GIR_EraseRootFromParent_Done,
     /* 1221757 */   // Label 17649: @1221757
     /* 1221757 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1221838), // Rule ID 13738 //
     /* 1221762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1221765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1221782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1221785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1221792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221815 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1221815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1221818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221837 */     // GIR_Coverage, 13738,
     /* 1221837 */     GIR_EraseRootFromParent_Done,
     /* 1221838 */   // Label 17650: @1221838
     /* 1221838 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1221919), // Rule ID 13739 //
     /* 1221843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1221846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1221863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1221866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1221873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1221896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1221899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221918 */     // GIR_Coverage, 13739,
     /* 1221918 */     GIR_EraseRootFromParent_Done,
     /* 1221919 */   // Label 17651: @1221919
     /* 1221919 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1222000), // Rule ID 13740 //
     /* 1221924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1221927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1221932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1221944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1221947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1221954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1221970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1221977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1221980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1221990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221999 */     // GIR_Coverage, 13740,
     /* 1221999 */     GIR_EraseRootFromParent_Done,
     /* 1222000 */   // Label 17652: @1222000
     /* 1222000 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1222081), // Rule ID 13741 //
     /* 1222005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1222008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1222016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1222019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1222022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1222025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1222028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1222035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222058 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1222058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1222061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222080 */     // GIR_Coverage, 13741,
     /* 1222080 */     GIR_EraseRootFromParent_Done,
     /* 1222081 */   // Label 17653: @1222081
     /* 1222081 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1222162), // Rule ID 13742 //
     /* 1222086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1222097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1222100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1222103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1222109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1222139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1222142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222161 */     // GIR_Coverage, 13742,
     /* 1222161 */     GIR_EraseRootFromParent_Done,
     /* 1222162 */   // Label 17654: @1222162
     /* 1222162 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1222243), // Rule ID 13743 //
     /* 1222167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1222178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1222181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1222184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1222190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1222220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1222223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222242 */     // GIR_Coverage, 13743,
     /* 1222242 */     GIR_EraseRootFromParent_Done,
     /* 1222243 */   // Label 17655: @1222243
     /* 1222243 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1222324), // Rule ID 13744 //
     /* 1222248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1222259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1222262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1222265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1222271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222301 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1222301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1222304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222323 */     // GIR_Coverage, 13744,
     /* 1222323 */     GIR_EraseRootFromParent_Done,
     /* 1222324 */   // Label 17656: @1222324
     /* 1222324 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1222405), // Rule ID 13745 //
     /* 1222329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1222340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1222343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1222346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1222352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1222382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1222385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222404 */     // GIR_Coverage, 13745,
     /* 1222404 */     GIR_EraseRootFromParent_Done,
     /* 1222405 */   // Label 17657: @1222405
     /* 1222405 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1222486), // Rule ID 13746 //
     /* 1222410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1222421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1222424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1222427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1222433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222463 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1222463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1222466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222485 */     // GIR_Coverage, 13746,
     /* 1222485 */     GIR_EraseRootFromParent_Done,
     /* 1222486 */   // Label 17658: @1222486
     /* 1222486 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1222567), // Rule ID 13747 //
     /* 1222491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1222502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1222505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1222508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1222514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1222544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1222547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1222565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222566 */     // GIR_Coverage, 13747,
     /* 1222566 */     GIR_EraseRootFromParent_Done,
     /* 1222567 */   // Label 17659: @1222567
     /* 1222567 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1222648), // Rule ID 13748 //
     /* 1222572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1222583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1222586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1222589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1222595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222625 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1222625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1222628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222647 */     // GIR_Coverage, 13748,
     /* 1222647 */     GIR_EraseRootFromParent_Done,
     /* 1222648 */   // Label 17660: @1222648
     /* 1222648 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1222729), // Rule ID 13749 //
     /* 1222653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1222664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1222667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1222670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1222676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1222706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1222709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222728 */     // GIR_Coverage, 13749,
     /* 1222728 */     GIR_EraseRootFromParent_Done,
     /* 1222729 */   // Label 17661: @1222729
     /* 1222729 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1222810), // Rule ID 13750 //
     /* 1222734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1222745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1222748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1222751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1222757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222787 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1222787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1222790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222809 */     // GIR_Coverage, 13750,
     /* 1222809 */     GIR_EraseRootFromParent_Done,
     /* 1222810 */   // Label 17662: @1222810
     /* 1222810 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1222891), // Rule ID 13751 //
     /* 1222815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1222826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1222829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1222832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1222838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1222868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1222871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222890 */     // GIR_Coverage, 13751,
     /* 1222890 */     GIR_EraseRootFromParent_Done,
     /* 1222891 */   // Label 17663: @1222891
     /* 1222891 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1222972), // Rule ID 13752 //
     /* 1222896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1222899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1222907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1222910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1222913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1222919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1222926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1222938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1222942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1222949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1222952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1222962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222971 */     // GIR_Coverage, 13752,
     /* 1222971 */     GIR_EraseRootFromParent_Done,
     /* 1222972 */   // Label 17664: @1222972
     /* 1222972 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1223053), // Rule ID 13753 //
     /* 1222977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1222980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1222985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1222988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1222991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1222994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1223000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1223030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1223033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223052 */     // GIR_Coverage, 13753,
     /* 1223052 */     GIR_EraseRootFromParent_Done,
     /* 1223053 */   // Label 17665: @1223053
     /* 1223053 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1223134), // Rule ID 13754 //
     /* 1223058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1223061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1223069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1223072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1223075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1223081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223111 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1223111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1223132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223133 */     // GIR_Coverage, 13754,
     /* 1223133 */     GIR_EraseRootFromParent_Done,
     /* 1223134 */   // Label 17666: @1223134
     /* 1223134 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1223215), // Rule ID 13755 //
     /* 1223139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1223142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1223150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1223153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1223156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1223162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1223192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1223213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223214 */     // GIR_Coverage, 13755,
     /* 1223214 */     GIR_EraseRootFromParent_Done,
     /* 1223215 */   // Label 17667: @1223215
     /* 1223215 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1223296), // Rule ID 13756 //
     /* 1223220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1223223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1223231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1223234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1223243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1223273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223295 */     // GIR_Coverage, 13756,
     /* 1223295 */     GIR_EraseRootFromParent_Done,
     /* 1223296 */   // Label 17668: @1223296
     /* 1223296 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1223377), // Rule ID 13757 //
     /* 1223301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1223304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1223312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1223315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1223324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223354 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1223354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223376 */     // GIR_Coverage, 13757,
     /* 1223376 */     GIR_EraseRootFromParent_Done,
     /* 1223377 */   // Label 17669: @1223377
     /* 1223377 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1223458), // Rule ID 13758 //
     /* 1223382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1223385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1223399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1223405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1223435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223457 */     // GIR_Coverage, 13758,
     /* 1223457 */     GIR_EraseRootFromParent_Done,
     /* 1223458 */   // Label 17670: @1223458
     /* 1223458 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1223539), // Rule ID 13759 //
     /* 1223463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1223466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1223480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1223486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1223516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223538 */     // GIR_Coverage, 13759,
     /* 1223538 */     GIR_EraseRootFromParent_Done,
     /* 1223539 */   // Label 17671: @1223539
     /* 1223539 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1223620), // Rule ID 13760 //
     /* 1223544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1223547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1223561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1223567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223597 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1223597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223619 */     // GIR_Coverage, 13760,
     /* 1223619 */     GIR_EraseRootFromParent_Done,
     /* 1223620 */   // Label 17672: @1223620
     /* 1223620 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1223701), // Rule ID 13761 //
     /* 1223625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1223628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1223642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1223648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1223655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1223678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1223681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223700 */     // GIR_Coverage, 13761,
     /* 1223700 */     GIR_EraseRootFromParent_Done,
     /* 1223701 */   // Label 17673: @1223701
     /* 1223701 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1223782), // Rule ID 13762 //
     /* 1223706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1223709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1223717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1223720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1223723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1223729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1223736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1223759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1223762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1223780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223781 */     // GIR_Coverage, 13762,
     /* 1223781 */     GIR_EraseRootFromParent_Done,
     /* 1223782 */   // Label 17674: @1223782
     /* 1223782 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1223863), // Rule ID 13763 //
     /* 1223787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1223790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1223798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1223801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1223804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1223810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1223817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1223840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1223843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1223861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223862 */     // GIR_Coverage, 13763,
     /* 1223862 */     GIR_EraseRootFromParent_Done,
     /* 1223863 */   // Label 17675: @1223863
     /* 1223863 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1223944), // Rule ID 13764 //
     /* 1223868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1223871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1223879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1223882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1223885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1223891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1223898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1223921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1223924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1223934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1223942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223943 */     // GIR_Coverage, 13764,
     /* 1223943 */     GIR_EraseRootFromParent_Done,
     /* 1223944 */   // Label 17676: @1223944
     /* 1223944 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1224025), // Rule ID 13765 //
     /* 1223949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1223952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1223957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1223960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1223963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1223966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1223972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1223979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1223991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1223995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1224002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1224005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1224023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224024 */     // GIR_Coverage, 13765,
     /* 1224024 */     GIR_EraseRootFromParent_Done,
     /* 1224025 */   // Label 17677: @1224025
     /* 1224025 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1224106), // Rule ID 13766 //
     /* 1224030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1224041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1224044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1224047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1224053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1224060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224083 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1224083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1224086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1224104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224105 */     // GIR_Coverage, 13766,
     /* 1224105 */     GIR_EraseRootFromParent_Done,
     /* 1224106 */   // Label 17678: @1224106
     /* 1224106 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1224187), // Rule ID 13767 //
     /* 1224111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1224122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1224125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1224128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1224134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1224141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1224164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1224167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1224185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224186 */     // GIR_Coverage, 13767,
     /* 1224186 */     GIR_EraseRootFromParent_Done,
     /* 1224187 */   // Label 17679: @1224187
     /* 1224187 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1224268), // Rule ID 13768 //
     /* 1224192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1224203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1224206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1224215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1224222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1224245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1224248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224267 */     // GIR_Coverage, 13768,
     /* 1224267 */     GIR_EraseRootFromParent_Done,
     /* 1224268 */   // Label 17680: @1224268
     /* 1224268 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1224349), // Rule ID 13769 //
     /* 1224273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1224284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1224287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1224296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1224303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1224326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1224329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224348 */     // GIR_Coverage, 13769,
     /* 1224348 */     GIR_EraseRootFromParent_Done,
     /* 1224349 */   // Label 17681: @1224349
     /* 1224349 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1224430), // Rule ID 13770 //
     /* 1224354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1224365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1224368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1224377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1224384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224407 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1224407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1224410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224429 */     // GIR_Coverage, 13770,
     /* 1224429 */     GIR_EraseRootFromParent_Done,
     /* 1224430 */   // Label 17682: @1224430
     /* 1224430 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1224511), // Rule ID 13771 //
     /* 1224435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1224446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1224449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1224458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1224465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1224488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1224491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224510 */     // GIR_Coverage, 13771,
     /* 1224510 */     GIR_EraseRootFromParent_Done,
     /* 1224511 */   // Label 17683: @1224511
     /* 1224511 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1224592), // Rule ID 13772 //
     /* 1224516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1224527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1224530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1224533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1224539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1224546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224569 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1224569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1224572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224591 */     // GIR_Coverage, 13772,
     /* 1224591 */     GIR_EraseRootFromParent_Done,
     /* 1224592 */   // Label 17684: @1224592
     /* 1224592 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1224673), // Rule ID 13773 //
     /* 1224597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1224608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1224611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1224614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1224620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1224627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1224650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1224653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224672 */     // GIR_Coverage, 13773,
     /* 1224672 */     GIR_EraseRootFromParent_Done,
     /* 1224673 */   // Label 17685: @1224673
     /* 1224673 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1224754), // Rule ID 13774 //
     /* 1224678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1224701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1224708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1224731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1224734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224753 */     // GIR_Coverage, 13774,
     /* 1224753 */     GIR_EraseRootFromParent_Done,
     /* 1224754 */   // Label 17686: @1224754
     /* 1224754 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1224835), // Rule ID 13775 //
     /* 1224759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1224782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1224789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1224812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1224815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224834 */     // GIR_Coverage, 13775,
     /* 1224834 */     GIR_EraseRootFromParent_Done,
     /* 1224835 */   // Label 17687: @1224835
     /* 1224835 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1224916), // Rule ID 13776 //
     /* 1224840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1224843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1224863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1224870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224893 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1224893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1224896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224915 */     // GIR_Coverage, 13776,
     /* 1224915 */     GIR_EraseRootFromParent_Done,
     /* 1224916 */   // Label 17688: @1224916
     /* 1224916 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1224997), // Rule ID 13777 //
     /* 1224921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1224924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1224929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1224944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1224951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1224963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1224967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224974 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1224974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1224977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1224987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224996 */     // GIR_Coverage, 13777,
     /* 1224996 */     GIR_EraseRootFromParent_Done,
     /* 1224997 */   // Label 17689: @1224997
     /* 1224997 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1225078), // Rule ID 13778 //
     /* 1225002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1225005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1225019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1225025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1225032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225055 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1225055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1225058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225077 */     // GIR_Coverage, 13778,
     /* 1225077 */     GIR_EraseRootFromParent_Done,
     /* 1225078 */   // Label 17690: @1225078
     /* 1225078 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1225159), // Rule ID 13779 //
     /* 1225083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1225086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1225100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1225106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1225113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1225136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1225139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225158 */     // GIR_Coverage, 13779,
     /* 1225158 */     GIR_EraseRootFromParent_Done,
     /* 1225159 */   // Label 17691: @1225159
     /* 1225159 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1225240), // Rule ID 13780 //
     /* 1225164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1225167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1225181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1225187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1225194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1225217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1225220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225239 */     // GIR_Coverage, 13780,
     /* 1225239 */     GIR_EraseRootFromParent_Done,
     /* 1225240 */   // Label 17692: @1225240
     /* 1225240 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1225321), // Rule ID 13781 //
     /* 1225245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1225248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1225262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1225268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1225275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1225298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1225301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225320 */     // GIR_Coverage, 13781,
     /* 1225320 */     GIR_EraseRootFromParent_Done,
     /* 1225321 */   // Label 17693: @1225321
     /* 1225321 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1225402), // Rule ID 13782 //
     /* 1225326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1225329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1225343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1225349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1225356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1225379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1225382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225401 */     // GIR_Coverage, 13782,
     /* 1225401 */     GIR_EraseRootFromParent_Done,
     /* 1225402 */   // Label 17694: @1225402
     /* 1225402 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1225483), // Rule ID 13783 //
     /* 1225407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1225410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1225424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1225430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1225437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1225460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1225463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225482 */     // GIR_Coverage, 13783,
     /* 1225482 */     GIR_EraseRootFromParent_Done,
     /* 1225483 */   // Label 17695: @1225483
     /* 1225483 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1225564), // Rule ID 13784 //
     /* 1225488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1225491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1225505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1225511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1225518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225541 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1225541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1225544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225563 */     // GIR_Coverage, 13784,
     /* 1225563 */     GIR_EraseRootFromParent_Done,
     /* 1225564 */   // Label 17696: @1225564
     /* 1225564 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1225645), // Rule ID 13785 //
     /* 1225569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1225572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1225577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1225586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1225592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1225599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1225611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1225622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1225625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225644 */     // GIR_Coverage, 13785,
     /* 1225644 */     GIR_EraseRootFromParent_Done,
     /* 1225645 */   // Label 17697: @1225645
     /* 1225645 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1225729), // Rule ID 19624 //
     /* 1225650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1225658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1225661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1225664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1225670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1225673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225703 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1225703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1225706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1225727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225728 */     // GIR_Coverage, 19624,
     /* 1225728 */     GIR_EraseRootFromParent_Done,
     /* 1225729 */   // Label 17698: @1225729
     /* 1225729 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1225813), // Rule ID 19625 //
     /* 1225734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1225742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1225745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1225748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1225754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1225757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1225787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1225790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1225811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225812 */     // GIR_Coverage, 19625,
     /* 1225812 */     GIR_EraseRootFromParent_Done,
     /* 1225813 */   // Label 17699: @1225813
     /* 1225813 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1225897), // Rule ID 19628 //
     /* 1225818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1225826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1225829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1225832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1225838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1225841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225871 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1225871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1225874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1225895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225896 */     // GIR_Coverage, 19628,
     /* 1225896 */     GIR_EraseRootFromParent_Done,
     /* 1225897 */   // Label 17700: @1225897
     /* 1225897 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1225981), // Rule ID 19629 //
     /* 1225902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1225910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1225913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1225916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1225922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1225925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1225948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225955 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1225955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1225958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1225968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1225979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225980 */     // GIR_Coverage, 19629,
     /* 1225980 */     GIR_EraseRootFromParent_Done,
     /* 1225981 */   // Label 17701: @1225981
     /* 1225981 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1226065), // Rule ID 19632 //
     /* 1225986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1225994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1225997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1226000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1226006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1226009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226039 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1226042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226064 */     // GIR_Coverage, 19632,
     /* 1226064 */     GIR_EraseRootFromParent_Done,
     /* 1226065 */   // Label 17702: @1226065
     /* 1226065 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1226149), // Rule ID 19633 //
     /* 1226070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1226081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1226084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1226090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1226093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226123 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1226126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226148 */     // GIR_Coverage, 19633,
     /* 1226148 */     GIR_EraseRootFromParent_Done,
     /* 1226149 */   // Label 17703: @1226149
     /* 1226149 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1226233), // Rule ID 19636 //
     /* 1226154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1226165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1226168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1226177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226232 */     // GIR_Coverage, 19636,
     /* 1226232 */     GIR_EraseRootFromParent_Done,
     /* 1226233 */   // Label 17704: @1226233
     /* 1226233 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1226317), // Rule ID 19637 //
     /* 1226238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1226249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1226252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1226261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226316 */     // GIR_Coverage, 19637,
     /* 1226316 */     GIR_EraseRootFromParent_Done,
     /* 1226317 */   // Label 17705: @1226317
     /* 1226317 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1226401), // Rule ID 19640 //
     /* 1226322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1226333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1226336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1226345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226375 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226400 */     // GIR_Coverage, 19640,
     /* 1226400 */     GIR_EraseRootFromParent_Done,
     /* 1226401 */   // Label 17706: @1226401
     /* 1226401 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1226485), // Rule ID 19641 //
     /* 1226406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1226417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1226420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1226429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226459 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226484 */     // GIR_Coverage, 19641,
     /* 1226484 */     GIR_EraseRootFromParent_Done,
     /* 1226485 */   // Label 17707: @1226485
     /* 1226485 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1226569), // Rule ID 19644 //
     /* 1226490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1226493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1226501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1226504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1226507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1226513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226568 */     // GIR_Coverage, 19644,
     /* 1226568 */     GIR_EraseRootFromParent_Done,
     /* 1226569 */   // Label 17708: @1226569
     /* 1226569 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1226653), // Rule ID 19645 //
     /* 1226574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1226577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1226585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1226588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1226591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1226597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1226630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226652 */     // GIR_Coverage, 19645,
     /* 1226652 */     GIR_EraseRootFromParent_Done,
     /* 1226653 */   // Label 17709: @1226653
     /* 1226653 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1226737), // Rule ID 19648 //
     /* 1226658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1226669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1226672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1226675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1226678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1226681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226711 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1226714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226736 */     // GIR_Coverage, 19648,
     /* 1226736 */     GIR_EraseRootFromParent_Done,
     /* 1226737 */   // Label 17710: @1226737
     /* 1226737 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1226821), // Rule ID 19649 //
     /* 1226742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1226753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1226756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1226759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1226762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1226765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226795 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1226798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226820 */     // GIR_Coverage, 19649,
     /* 1226820 */     GIR_EraseRootFromParent_Done,
     /* 1226821 */   // Label 17711: @1226821
     /* 1226821 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1226905), // Rule ID 19652 //
     /* 1226826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1226837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1226840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1226846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1226849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1226879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1226882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226904 */     // GIR_Coverage, 19652,
     /* 1226904 */     GIR_EraseRootFromParent_Done,
     /* 1226905 */   // Label 17712: @1226905
     /* 1226905 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1226989), // Rule ID 19653 //
     /* 1226910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1226918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1226921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1226924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1226930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1226933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1226956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226963 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1226963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1226966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1226976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1226987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226988 */     // GIR_Coverage, 19653,
     /* 1226988 */     GIR_EraseRootFromParent_Done,
     /* 1226989 */   // Label 17713: @1226989
     /* 1226989 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1227073), // Rule ID 19656 //
     /* 1226994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1227005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1227008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1227014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1227017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227047 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1227050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227072 */     // GIR_Coverage, 19656,
     /* 1227072 */     GIR_EraseRootFromParent_Done,
     /* 1227073 */   // Label 17714: @1227073
     /* 1227073 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1227157), // Rule ID 19657 //
     /* 1227078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1227089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1227092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1227098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1227101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227131 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1227134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227156 */     // GIR_Coverage, 19657,
     /* 1227156 */     GIR_EraseRootFromParent_Done,
     /* 1227157 */   // Label 17715: @1227157
     /* 1227157 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1227241), // Rule ID 19660 //
     /* 1227162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1227173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1227176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1227182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1227185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1227218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227240 */     // GIR_Coverage, 19660,
     /* 1227240 */     GIR_EraseRootFromParent_Done,
     /* 1227241 */   // Label 17716: @1227241
     /* 1227241 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1227325), // Rule ID 19661 //
     /* 1227246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1227257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1227260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1227266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1227269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227299 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1227302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227324 */     // GIR_Coverage, 19661,
     /* 1227324 */     GIR_EraseRootFromParent_Done,
     /* 1227325 */   // Label 17717: @1227325
     /* 1227325 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1227409), // Rule ID 19664 //
     /* 1227330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1227341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1227344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1227350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1227353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1227386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227408 */     // GIR_Coverage, 19664,
     /* 1227408 */     GIR_EraseRootFromParent_Done,
     /* 1227409 */   // Label 17718: @1227409
     /* 1227409 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1227493), // Rule ID 19665 //
     /* 1227414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1227425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1227428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1227434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1227437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227467 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1227470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227492 */     // GIR_Coverage, 19665,
     /* 1227492 */     GIR_EraseRootFromParent_Done,
     /* 1227493 */   // Label 17719: @1227493
     /* 1227493 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1227577), // Rule ID 19668 //
     /* 1227498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1227509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1227512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1227518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1227521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227551 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1227554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227576 */     // GIR_Coverage, 19668,
     /* 1227576 */     GIR_EraseRootFromParent_Done,
     /* 1227577 */   // Label 17720: @1227577
     /* 1227577 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1227661), // Rule ID 19669 //
     /* 1227582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1227593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1227596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1227602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1227605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1227638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227660 */     // GIR_Coverage, 19669,
     /* 1227660 */     GIR_EraseRootFromParent_Done,
     /* 1227661 */   // Label 17721: @1227661
     /* 1227661 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1227745), // Rule ID 19672 //
     /* 1227666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1227677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1227680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1227683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1227686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1227689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227719 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1227722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227744 */     // GIR_Coverage, 19672,
     /* 1227744 */     GIR_EraseRootFromParent_Done,
     /* 1227745 */   // Label 17722: @1227745
     /* 1227745 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1227829), // Rule ID 19673 //
     /* 1227750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1227761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1227764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1227767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1227770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1227773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227803 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1227806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227828 */     // GIR_Coverage, 19673,
     /* 1227828 */     GIR_EraseRootFromParent_Done,
     /* 1227829 */   // Label 17723: @1227829
     /* 1227829 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1227913), // Rule ID 19676 //
     /* 1227834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1227845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1227848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1227851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1227854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1227857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1227887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1227890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227912 */     // GIR_Coverage, 19676,
     /* 1227912 */     GIR_EraseRootFromParent_Done,
     /* 1227913 */   // Label 17724: @1227913
     /* 1227913 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1227997), // Rule ID 19677 //
     /* 1227918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1227926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1227929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1227932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1227935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1227938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1227941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1227964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227971 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1227971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1227974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1227984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1227995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227996 */     // GIR_Coverage, 19677,
     /* 1227996 */     GIR_EraseRootFromParent_Done,
     /* 1227997 */   // Label 17725: @1227997
     /* 1227997 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1228081), // Rule ID 19680 //
     /* 1228002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1228013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1228016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1228022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1228025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228055 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1228058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228080 */     // GIR_Coverage, 19680,
     /* 1228080 */     GIR_EraseRootFromParent_Done,
     /* 1228081 */   // Label 17726: @1228081
     /* 1228081 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1228165), // Rule ID 19681 //
     /* 1228086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1228097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1228100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1228106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1228109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1228142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228164 */     // GIR_Coverage, 19681,
     /* 1228164 */     GIR_EraseRootFromParent_Done,
     /* 1228165 */   // Label 17727: @1228165
     /* 1228165 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1228249), // Rule ID 19684 //
     /* 1228170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1228181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1228184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1228193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228223 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1228226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228248 */     // GIR_Coverage, 19684,
     /* 1228248 */     GIR_EraseRootFromParent_Done,
     /* 1228249 */   // Label 17728: @1228249
     /* 1228249 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1228333), // Rule ID 19685 //
     /* 1228254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1228265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1228268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1228277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228307 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1228310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228332 */     // GIR_Coverage, 19685,
     /* 1228332 */     GIR_EraseRootFromParent_Done,
     /* 1228333 */   // Label 17729: @1228333
     /* 1228333 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1228417), // Rule ID 19688 //
     /* 1228338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1228349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1228352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1228361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1228394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228416 */     // GIR_Coverage, 19688,
     /* 1228416 */     GIR_EraseRootFromParent_Done,
     /* 1228417 */   // Label 17730: @1228417
     /* 1228417 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1228501), // Rule ID 19689 //
     /* 1228422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1228433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1228436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1228445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228475 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1228478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228500 */     // GIR_Coverage, 19689,
     /* 1228500 */     GIR_EraseRootFromParent_Done,
     /* 1228501 */   // Label 17731: @1228501
     /* 1228501 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1228585), // Rule ID 19692 //
     /* 1228506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1228517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1228520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1228526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1228529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1228548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1228562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228584 */     // GIR_Coverage, 19692,
     /* 1228584 */     GIR_EraseRootFromParent_Done,
     /* 1228585 */   // Label 17732: @1228585
     /* 1228585 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1228669), // Rule ID 19693 //
     /* 1228590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1228601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1228604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1228610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1228613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1228632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228643 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1228646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228668 */     // GIR_Coverage, 19693,
     /* 1228668 */     GIR_EraseRootFromParent_Done,
     /* 1228669 */   // Label 17733: @1228669
     /* 1228669 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1228753), // Rule ID 19696 //
     /* 1228674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1228685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1228688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1228697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1228730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228752 */     // GIR_Coverage, 19696,
     /* 1228752 */     GIR_EraseRootFromParent_Done,
     /* 1228753 */   // Label 17734: @1228753
     /* 1228753 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1228837), // Rule ID 19697 //
     /* 1228758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1228769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1228772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1228781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228811 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1228814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228836 */     // GIR_Coverage, 19697,
     /* 1228836 */     GIR_EraseRootFromParent_Done,
     /* 1228837 */   // Label 17735: @1228837
     /* 1228837 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1228921), // Rule ID 19700 //
     /* 1228842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1228853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1228856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1228862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1228865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1228884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1228895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1228898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1228919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228920 */     // GIR_Coverage, 19700,
     /* 1228920 */     GIR_EraseRootFromParent_Done,
     /* 1228921 */   // Label 17736: @1228921
     /* 1228921 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1229005), // Rule ID 19701 //
     /* 1228926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1228934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1228937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1228940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1228946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1228949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1228968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1228972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228979 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1228979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1228982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1228992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229004 */     // GIR_Coverage, 19701,
     /* 1229004 */     GIR_EraseRootFromParent_Done,
     /* 1229005 */   // Label 17737: @1229005
     /* 1229005 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1229089), // Rule ID 19704 //
     /* 1229010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1229021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1229024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1229030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1229033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1229052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229063 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1229066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229088 */     // GIR_Coverage, 19704,
     /* 1229088 */     GIR_EraseRootFromParent_Done,
     /* 1229089 */   // Label 17738: @1229089
     /* 1229089 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1229173), // Rule ID 19705 //
     /* 1229094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1229105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1229108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1229114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1229117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1229136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229147 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1229150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229172 */     // GIR_Coverage, 19705,
     /* 1229172 */     GIR_EraseRootFromParent_Done,
     /* 1229173 */   // Label 17739: @1229173
     /* 1229173 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1229257), // Rule ID 19708 //
     /* 1229178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1229189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1229192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1229201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229231 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1229234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229256 */     // GIR_Coverage, 19708,
     /* 1229256 */     GIR_EraseRootFromParent_Done,
     /* 1229257 */   // Label 17740: @1229257
     /* 1229257 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1229341), // Rule ID 19709 //
     /* 1229262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1229273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1229276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1229285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229315 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1229318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229340 */     // GIR_Coverage, 19709,
     /* 1229340 */     GIR_EraseRootFromParent_Done,
     /* 1229341 */   // Label 17741: @1229341
     /* 1229341 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1229425), // Rule ID 19712 //
     /* 1229346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1229357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1229360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1229369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229399 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1229402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229424 */     // GIR_Coverage, 19712,
     /* 1229424 */     GIR_EraseRootFromParent_Done,
     /* 1229425 */   // Label 17742: @1229425
     /* 1229425 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1229509), // Rule ID 19713 //
     /* 1229430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1229441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1229444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1229453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229483 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1229486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229508 */     // GIR_Coverage, 19713,
     /* 1229508 */     GIR_EraseRootFromParent_Done,
     /* 1229509 */   // Label 17743: @1229509
     /* 1229509 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1229593), // Rule ID 19716 //
     /* 1229514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1229525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1229528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1229537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229567 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1229570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229592 */     // GIR_Coverage, 19716,
     /* 1229592 */     GIR_EraseRootFromParent_Done,
     /* 1229593 */   // Label 17744: @1229593
     /* 1229593 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1229677), // Rule ID 19717 //
     /* 1229598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1229609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1229612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1229621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229651 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1229654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229676 */     // GIR_Coverage, 19717,
     /* 1229676 */     GIR_EraseRootFromParent_Done,
     /* 1229677 */   // Label 17745: @1229677
     /* 1229677 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1229761), // Rule ID 19720 //
     /* 1229682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1229693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1229696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1229705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229735 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1229738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229760 */     // GIR_Coverage, 19720,
     /* 1229760 */     GIR_EraseRootFromParent_Done,
     /* 1229761 */   // Label 17746: @1229761
     /* 1229761 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1229845), // Rule ID 19721 //
     /* 1229766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1229777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1229780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1229789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1229822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229844 */     // GIR_Coverage, 19721,
     /* 1229844 */     GIR_EraseRootFromParent_Done,
     /* 1229845 */   // Label 17747: @1229845
     /* 1229845 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1229929), // Rule ID 19724 //
     /* 1229850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1229861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1229864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1229873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229903 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1229903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1229906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1229916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1229927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229928 */     // GIR_Coverage, 19724,
     /* 1229928 */     GIR_EraseRootFromParent_Done,
     /* 1229929 */   // Label 17748: @1229929
     /* 1229929 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1230013), // Rule ID 19725 //
     /* 1229934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1229942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1229945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1229948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1229957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1229980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229987 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1229987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1229990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230012 */     // GIR_Coverage, 19725,
     /* 1230012 */     GIR_EraseRootFromParent_Done,
     /* 1230013 */   // Label 17749: @1230013
     /* 1230013 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1230097), // Rule ID 19728 //
     /* 1230018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1230029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1230032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1230041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230071 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1230074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230096 */     // GIR_Coverage, 19728,
     /* 1230096 */     GIR_EraseRootFromParent_Done,
     /* 1230097 */   // Label 17750: @1230097
     /* 1230097 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1230181), // Rule ID 19729 //
     /* 1230102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1230113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1230116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1230125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1230158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230180 */     // GIR_Coverage, 19729,
     /* 1230180 */     GIR_EraseRootFromParent_Done,
     /* 1230181 */   // Label 17751: @1230181
     /* 1230181 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1230265), // Rule ID 19732 //
     /* 1230186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1230197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1230200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1230209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1230242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230264 */     // GIR_Coverage, 19732,
     /* 1230264 */     GIR_EraseRootFromParent_Done,
     /* 1230265 */   // Label 17752: @1230265
     /* 1230265 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1230349), // Rule ID 19733 //
     /* 1230270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1230281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1230284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1230293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230323 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1230326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230348 */     // GIR_Coverage, 19733,
     /* 1230348 */     GIR_EraseRootFromParent_Done,
     /* 1230349 */   // Label 17753: @1230349
     /* 1230349 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1230433), // Rule ID 19736 //
     /* 1230354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1230365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1230368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1230377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1230410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230432 */     // GIR_Coverage, 19736,
     /* 1230432 */     GIR_EraseRootFromParent_Done,
     /* 1230433 */   // Label 17754: @1230433
     /* 1230433 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1230517), // Rule ID 19737 //
     /* 1230438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1230449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1230452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1230461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230491 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1230494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230516 */     // GIR_Coverage, 19737,
     /* 1230516 */     GIR_EraseRootFromParent_Done,
     /* 1230517 */   // Label 17755: @1230517
     /* 1230517 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1230601), // Rule ID 19740 //
     /* 1230522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1230533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1230536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1230545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1230578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230600 */     // GIR_Coverage, 19740,
     /* 1230600 */     GIR_EraseRootFromParent_Done,
     /* 1230601 */   // Label 17756: @1230601
     /* 1230601 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1230685), // Rule ID 19741 //
     /* 1230606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1230614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1230617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1230620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1230626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1230629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1230648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1230662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230684 */     // GIR_Coverage, 19741,
     /* 1230684 */     GIR_EraseRootFromParent_Done,
     /* 1230685 */   // Label 17757: @1230685
     /* 1230685 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1230769), // Rule ID 19744 //
     /* 1230690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1230698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1230701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1230704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1230707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1230710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1230713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230743 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1230746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230768 */     // GIR_Coverage, 19744,
     /* 1230768 */     GIR_EraseRootFromParent_Done,
     /* 1230769 */   // Label 17758: @1230769
     /* 1230769 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1230853), // Rule ID 19745 //
     /* 1230774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1230782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1230785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1230788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1230791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1230794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1230797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230827 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1230830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230852 */     // GIR_Coverage, 19745,
     /* 1230852 */     GIR_EraseRootFromParent_Done,
     /* 1230853 */   // Label 17759: @1230853
     /* 1230853 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1230937), // Rule ID 19748 //
     /* 1230858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1230866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1230869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1230872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1230878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1230881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1230911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1230914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1230924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1230935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230936 */     // GIR_Coverage, 19748,
     /* 1230936 */     GIR_EraseRootFromParent_Done,
     /* 1230937 */   // Label 17760: @1230937
     /* 1230937 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1231021), // Rule ID 19749 //
     /* 1230942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1230950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1230953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1230956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1230962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1230965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1230988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1230995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1230998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231020 */     // GIR_Coverage, 19749,
     /* 1231020 */     GIR_EraseRootFromParent_Done,
     /* 1231021 */   // Label 17761: @1231021
     /* 1231021 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1231105), // Rule ID 19752 //
     /* 1231026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1231046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231079 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1231082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231104 */     // GIR_Coverage, 19752,
     /* 1231104 */     GIR_EraseRootFromParent_Done,
     /* 1231105 */   // Label 17762: @1231105
     /* 1231105 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1231189), // Rule ID 19753 //
     /* 1231110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1231130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231163 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1231166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231188 */     // GIR_Coverage, 19753,
     /* 1231188 */     GIR_EraseRootFromParent_Done,
     /* 1231189 */   // Label 17763: @1231189
     /* 1231189 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1231273), // Rule ID 19756 //
     /* 1231194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1231205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1231208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1231217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231272 */     // GIR_Coverage, 19756,
     /* 1231272 */     GIR_EraseRootFromParent_Done,
     /* 1231273 */   // Label 17764: @1231273
     /* 1231273 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1231357), // Rule ID 19757 //
     /* 1231278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1231289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1231292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1231301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231331 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231356 */     // GIR_Coverage, 19757,
     /* 1231356 */     GIR_EraseRootFromParent_Done,
     /* 1231357 */   // Label 17765: @1231357
     /* 1231357 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1231441), // Rule ID 19760 //
     /* 1231362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1231373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1231376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1231385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231415 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231440 */     // GIR_Coverage, 19760,
     /* 1231440 */     GIR_EraseRootFromParent_Done,
     /* 1231441 */   // Label 17766: @1231441
     /* 1231441 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1231525), // Rule ID 19761 //
     /* 1231446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1231457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1231460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1231469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231499 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231524 */     // GIR_Coverage, 19761,
     /* 1231524 */     GIR_EraseRootFromParent_Done,
     /* 1231525 */   // Label 17767: @1231525
     /* 1231525 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1231609), // Rule ID 19764 //
     /* 1231530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1231547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231583 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231608 */     // GIR_Coverage, 19764,
     /* 1231608 */     GIR_EraseRootFromParent_Done,
     /* 1231609 */   // Label 17768: @1231609
     /* 1231609 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1231693), // Rule ID 19765 //
     /* 1231614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1231631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231667 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1231670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231692 */     // GIR_Coverage, 19765,
     /* 1231692 */     GIR_EraseRootFromParent_Done,
     /* 1231693 */   // Label 17769: @1231693
     /* 1231693 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1231777), // Rule ID 19768 //
     /* 1231698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1231709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1231712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1231718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1231721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231751 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1231754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231776 */     // GIR_Coverage, 19768,
     /* 1231776 */     GIR_EraseRootFromParent_Done,
     /* 1231777 */   // Label 17770: @1231777
     /* 1231777 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1231861), // Rule ID 19769 //
     /* 1231782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1231793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1231796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1231802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1231805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231835 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1231838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231860 */     // GIR_Coverage, 19769,
     /* 1231860 */     GIR_EraseRootFromParent_Done,
     /* 1231861 */   // Label 17771: @1231861
     /* 1231861 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1231945), // Rule ID 19772 //
     /* 1231866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1231877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1231880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1231886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1231889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1231922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231944 */     // GIR_Coverage, 19772,
     /* 1231944 */     GIR_EraseRootFromParent_Done,
     /* 1231945 */   // Label 17772: @1231945
     /* 1231945 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1232029), // Rule ID 19773 //
     /* 1231950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1231958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1231961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1231964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1231970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1231973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232003 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1232006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232028 */     // GIR_Coverage, 19773,
     /* 1232028 */     GIR_EraseRootFromParent_Done,
     /* 1232029 */   // Label 17773: @1232029
     /* 1232029 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1232113), // Rule ID 19776 //
     /* 1232034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1232045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1232048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1232054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1232057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232087 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1232090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232112 */     // GIR_Coverage, 19776,
     /* 1232112 */     GIR_EraseRootFromParent_Done,
     /* 1232113 */   // Label 17774: @1232113
     /* 1232113 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1232197), // Rule ID 19777 //
     /* 1232118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1232129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1232132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1232138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1232141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232171 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1232174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232196 */     // GIR_Coverage, 19777,
     /* 1232196 */     GIR_EraseRootFromParent_Done,
     /* 1232197 */   // Label 17775: @1232197
     /* 1232197 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1232281), // Rule ID 19780 //
     /* 1232202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1232213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1232216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1232222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232255 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1232258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232280 */     // GIR_Coverage, 19780,
     /* 1232280 */     GIR_EraseRootFromParent_Done,
     /* 1232281 */   // Label 17776: @1232281
     /* 1232281 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1232365), // Rule ID 19781 //
     /* 1232286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1232297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1232300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1232306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1232342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232364 */     // GIR_Coverage, 19781,
     /* 1232364 */     GIR_EraseRootFromParent_Done,
     /* 1232365 */   // Label 17777: @1232365
     /* 1232365 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1232449), // Rule ID 19784 //
     /* 1232370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1232381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1232384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1232390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1232393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232423 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1232426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232448 */     // GIR_Coverage, 19784,
     /* 1232448 */     GIR_EraseRootFromParent_Done,
     /* 1232449 */   // Label 17778: @1232449
     /* 1232449 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1232533), // Rule ID 19785 //
     /* 1232454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1232465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1232468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1232474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1232477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232507 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1232510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232532 */     // GIR_Coverage, 19785,
     /* 1232532 */     GIR_EraseRootFromParent_Done,
     /* 1232533 */   // Label 17779: @1232533
     /* 1232533 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1232617), // Rule ID 19788 //
     /* 1232538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1232549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1232552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1232558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1232561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1232594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232616 */     // GIR_Coverage, 19788,
     /* 1232616 */     GIR_EraseRootFromParent_Done,
     /* 1232617 */   // Label 17780: @1232617
     /* 1232617 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1232701), // Rule ID 19789 //
     /* 1232622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1232633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1232636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1232642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1232645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1232678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232700 */     // GIR_Coverage, 19789,
     /* 1232700 */     GIR_EraseRootFromParent_Done,
     /* 1232701 */   // Label 17781: @1232701
     /* 1232701 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1232785), // Rule ID 19792 //
     /* 1232706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1232709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1232717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1232720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1232723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1232726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232759 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1232762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232784 */     // GIR_Coverage, 19792,
     /* 1232784 */     GIR_EraseRootFromParent_Done,
     /* 1232785 */   // Label 17782: @1232785
     /* 1232785 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1232869), // Rule ID 19793 //
     /* 1232790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1232793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1232801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1232804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1232807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1232810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1232843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1232846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232868 */     // GIR_Coverage, 19793,
     /* 1232868 */     GIR_EraseRootFromParent_Done,
     /* 1232869 */   // Label 17783: @1232869
     /* 1232869 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1232953), // Rule ID 19796 //
     /* 1232874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1232877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1232885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1232888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1232891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1232894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232927 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1232927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1232930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1232951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232952 */     // GIR_Coverage, 19796,
     /* 1232952 */     GIR_EraseRootFromParent_Done,
     /* 1232953 */   // Label 17784: @1232953
     /* 1232953 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1233037), // Rule ID 19797 //
     /* 1232958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1232961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1232966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1232969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1232972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1232975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1232978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1233014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233036 */     // GIR_Coverage, 19797,
     /* 1233036 */     GIR_EraseRootFromParent_Done,
     /* 1233037 */   // Label 17785: @1233037
     /* 1233037 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1233121), // Rule ID 19800 //
     /* 1233042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1233045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1233053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1233056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1233059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1233062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1233065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1233098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233120 */     // GIR_Coverage, 19800,
     /* 1233120 */     GIR_EraseRootFromParent_Done,
     /* 1233121 */   // Label 17786: @1233121
     /* 1233121 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1233205), // Rule ID 19801 //
     /* 1233126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1233129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1233137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1233140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1233143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1233146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1233149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1233182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233204 */     // GIR_Coverage, 19801,
     /* 1233204 */     GIR_EraseRootFromParent_Done,
     /* 1233205 */   // Label 17787: @1233205
     /* 1233205 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1233289), // Rule ID 19804 //
     /* 1233210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1233221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1233224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233263 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1233266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233288 */     // GIR_Coverage, 19804,
     /* 1233288 */     GIR_EraseRootFromParent_Done,
     /* 1233289 */   // Label 17788: @1233289
     /* 1233289 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1233373), // Rule ID 19805 //
     /* 1233294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1233305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1233308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233347 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1233350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233372 */     // GIR_Coverage, 19805,
     /* 1233372 */     GIR_EraseRootFromParent_Done,
     /* 1233373 */   // Label 17789: @1233373
     /* 1233373 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1233457), // Rule ID 19808 //
     /* 1233378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1233389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1233392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1233434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233456 */     // GIR_Coverage, 19808,
     /* 1233456 */     GIR_EraseRootFromParent_Done,
     /* 1233457 */   // Label 17790: @1233457
     /* 1233457 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1233541), // Rule ID 19809 //
     /* 1233462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1233473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1233476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233515 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1233518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233540 */     // GIR_Coverage, 19809,
     /* 1233540 */     GIR_EraseRootFromParent_Done,
     /* 1233541 */   // Label 17791: @1233541
     /* 1233541 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1233625), // Rule ID 19812 //
     /* 1233546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1233557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1233560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1233566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1233588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233599 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1233602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233624 */     // GIR_Coverage, 19812,
     /* 1233624 */     GIR_EraseRootFromParent_Done,
     /* 1233625 */   // Label 17792: @1233625
     /* 1233625 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1233709), // Rule ID 19813 //
     /* 1233630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1233641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1233644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1233650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1233672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1233686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233708 */     // GIR_Coverage, 19813,
     /* 1233708 */     GIR_EraseRootFromParent_Done,
     /* 1233709 */   // Label 17793: @1233709
     /* 1233709 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1233793), // Rule ID 19816 //
     /* 1233714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1233725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1233728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1233737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233767 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1233770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233792 */     // GIR_Coverage, 19816,
     /* 1233792 */     GIR_EraseRootFromParent_Done,
     /* 1233793 */   // Label 17794: @1233793
     /* 1233793 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1233877), // Rule ID 19817 //
     /* 1233798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1233809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1233812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1233818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1233821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1233840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1233851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1233854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233876 */     // GIR_Coverage, 19817,
     /* 1233876 */     GIR_EraseRootFromParent_Done,
     /* 1233877 */   // Label 17795: @1233877
     /* 1233877 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1233961), // Rule ID 19820 //
     /* 1233882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1233893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1233896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1233902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1233924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233935 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1233935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1233938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1233959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233960 */     // GIR_Coverage, 19820,
     /* 1233960 */     GIR_EraseRootFromParent_Done,
     /* 1233961 */   // Label 17796: @1233961
     /* 1233961 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1234045), // Rule ID 19821 //
     /* 1233966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1233974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1233977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1233980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1233986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234019 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1234022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234044 */     // GIR_Coverage, 19821,
     /* 1234044 */     GIR_EraseRootFromParent_Done,
     /* 1234045 */   // Label 17797: @1234045
     /* 1234045 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1234129), // Rule ID 19824 //
     /* 1234050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1234053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1234061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1234064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1234067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1234070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1234073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1234092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1234106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234128 */     // GIR_Coverage, 19824,
     /* 1234128 */     GIR_EraseRootFromParent_Done,
     /* 1234129 */   // Label 17798: @1234129
     /* 1234129 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1234213), // Rule ID 19825 //
     /* 1234134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1234137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1234145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1234148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1234151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1234154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1234157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1234176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1234190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234212 */     // GIR_Coverage, 19825,
     /* 1234212 */     GIR_EraseRootFromParent_Done,
     /* 1234213 */   // Label 17799: @1234213
     /* 1234213 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1234297), // Rule ID 19828 //
     /* 1234218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1234229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1234232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1234274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234296 */     // GIR_Coverage, 19828,
     /* 1234296 */     GIR_EraseRootFromParent_Done,
     /* 1234297 */   // Label 17800: @1234297
     /* 1234297 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1234381), // Rule ID 19829 //
     /* 1234302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1234313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1234316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1234358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234380 */     // GIR_Coverage, 19829,
     /* 1234380 */     GIR_EraseRootFromParent_Done,
     /* 1234381 */   // Label 17801: @1234381
     /* 1234381 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1234465), // Rule ID 19832 //
     /* 1234386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1234397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1234400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234439 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1234442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234464 */     // GIR_Coverage, 19832,
     /* 1234464 */     GIR_EraseRootFromParent_Done,
     /* 1234465 */   // Label 17802: @1234465
     /* 1234465 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1234549), // Rule ID 19833 //
     /* 1234470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1234481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1234484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234523 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1234526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234548 */     // GIR_Coverage, 19833,
     /* 1234548 */     GIR_EraseRootFromParent_Done,
     /* 1234549 */   // Label 17803: @1234549
     /* 1234549 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1234633), // Rule ID 19836 //
     /* 1234554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1234565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1234568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1234577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234607 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1234610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234632 */     // GIR_Coverage, 19836,
     /* 1234632 */     GIR_EraseRootFromParent_Done,
     /* 1234633 */   // Label 17804: @1234633
     /* 1234633 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1234717), // Rule ID 19837 //
     /* 1234638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1234649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1234652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1234658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1234661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1234680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1234694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234716 */     // GIR_Coverage, 19837,
     /* 1234716 */     GIR_EraseRootFromParent_Done,
     /* 1234717 */   // Label 17805: @1234717
     /* 1234717 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1234801), // Rule ID 19840 //
     /* 1234722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1234733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1234736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1234745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1234778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234800 */     // GIR_Coverage, 19840,
     /* 1234800 */     GIR_EraseRootFromParent_Done,
     /* 1234801 */   // Label 17806: @1234801
     /* 1234801 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1234885), // Rule ID 19841 //
     /* 1234806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1234817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1234820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1234829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234859 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1234859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1234862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234884 */     // GIR_Coverage, 19841,
     /* 1234884 */     GIR_EraseRootFromParent_Done,
     /* 1234885 */   // Label 17807: @1234885
     /* 1234885 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1234969), // Rule ID 19844 //
     /* 1234890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1234901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1234904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1234943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1234946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1234967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234968 */     // GIR_Coverage, 19844,
     /* 1234968 */     GIR_EraseRootFromParent_Done,
     /* 1234969 */   // Label 17808: @1234969
     /* 1234969 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1235053), // Rule ID 19845 //
     /* 1234974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1234982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1234985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1234988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1235030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235052 */     // GIR_Coverage, 19845,
     /* 1235052 */     GIR_EraseRootFromParent_Done,
     /* 1235053 */   // Label 17809: @1235053
     /* 1235053 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1235137), // Rule ID 19848 //
     /* 1235058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1235061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1235069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1235072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1235081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235111 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1235114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235136 */     // GIR_Coverage, 19848,
     /* 1235136 */     GIR_EraseRootFromParent_Done,
     /* 1235137 */   // Label 17810: @1235137
     /* 1235137 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1235221), // Rule ID 19849 //
     /* 1235142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1235145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1235153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1235156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1235165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1235198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235220 */     // GIR_Coverage, 19849,
     /* 1235220 */     GIR_EraseRootFromParent_Done,
     /* 1235221 */   // Label 17811: @1235221
     /* 1235221 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1235305), // Rule ID 19852 //
     /* 1235226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1235229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1235237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1235240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1235243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1235282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235304 */     // GIR_Coverage, 19852,
     /* 1235304 */     GIR_EraseRootFromParent_Done,
     /* 1235305 */   // Label 17812: @1235305
     /* 1235305 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1235389), // Rule ID 19853 //
     /* 1235310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1235313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1235321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1235324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1235327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1235366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235388 */     // GIR_Coverage, 19853,
     /* 1235388 */     GIR_EraseRootFromParent_Done,
     /* 1235389 */   // Label 17813: @1235389
     /* 1235389 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1235473), // Rule ID 19856 //
     /* 1235394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1235397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1235405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1235408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1235411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1235450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235472 */     // GIR_Coverage, 19856,
     /* 1235472 */     GIR_EraseRootFromParent_Done,
     /* 1235473 */   // Label 17814: @1235473
     /* 1235473 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1235557), // Rule ID 19857 //
     /* 1235478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1235481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1235489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1235492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1235495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235531 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1235534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235556 */     // GIR_Coverage, 19857,
     /* 1235556 */     GIR_EraseRootFromParent_Done,
     /* 1235557 */   // Label 17815: @1235557
     /* 1235557 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1235641), // Rule ID 19860 //
     /* 1235562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1235565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1235573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1235576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1235579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1235585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235615 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1235618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235640 */     // GIR_Coverage, 19860,
     /* 1235640 */     GIR_EraseRootFromParent_Done,
     /* 1235641 */   // Label 17816: @1235641
     /* 1235641 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1235725), // Rule ID 19861 //
     /* 1235646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1235649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1235654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1235657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1235660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1235663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1235669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1235688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1235702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235724 */     // GIR_Coverage, 19861,
     /* 1235724 */     GIR_EraseRootFromParent_Done,
     /* 1235725 */   // Label 17817: @1235725
     /* 1235725 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1235809), // Rule ID 19864 //
     /* 1235730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1235738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1235741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1235744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1235747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1235750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235783 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1235786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235808 */     // GIR_Coverage, 19864,
     /* 1235808 */     GIR_EraseRootFromParent_Done,
     /* 1235809 */   // Label 17818: @1235809
     /* 1235809 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1235893), // Rule ID 19865 //
     /* 1235814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1235822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1235825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1235828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1235831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1235834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235867 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1235870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235892 */     // GIR_Coverage, 19865,
     /* 1235892 */     GIR_EraseRootFromParent_Done,
     /* 1235893 */   // Label 17819: @1235893
     /* 1235893 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1235977), // Rule ID 19868 //
     /* 1235898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1235906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1235909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1235912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1235915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1235918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1235954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235976 */     // GIR_Coverage, 19868,
     /* 1235976 */     GIR_EraseRootFromParent_Done,
     /* 1235977 */   // Label 17820: @1235977
     /* 1235977 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1236061), // Rule ID 19869 //
     /* 1235982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1235990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1235993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1235996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1235999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1236002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1236038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236060 */     // GIR_Coverage, 19869,
     /* 1236060 */     GIR_EraseRootFromParent_Done,
     /* 1236061 */   // Label 17821: @1236061
     /* 1236061 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1236145), // Rule ID 19872 //
     /* 1236066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1236077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1236080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1236083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1236086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236119 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1236122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236144 */     // GIR_Coverage, 19872,
     /* 1236144 */     GIR_EraseRootFromParent_Done,
     /* 1236145 */   // Label 17822: @1236145
     /* 1236145 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1236229), // Rule ID 19873 //
     /* 1236150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1236153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1236161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1236164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1236167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1236170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1236206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236228 */     // GIR_Coverage, 19873,
     /* 1236228 */     GIR_EraseRootFromParent_Done,
     /* 1236229 */   // Label 17823: @1236229
     /* 1236229 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1236313), // Rule ID 19876 //
     /* 1236234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1236237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1236245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1236248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1236254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236287 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236312 */     // GIR_Coverage, 19876,
     /* 1236312 */     GIR_EraseRootFromParent_Done,
     /* 1236313 */   // Label 17824: @1236313
     /* 1236313 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1236397), // Rule ID 19877 //
     /* 1236318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1236329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1236332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1236338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236371 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236396 */     // GIR_Coverage, 19877,
     /* 1236396 */     GIR_EraseRootFromParent_Done,
     /* 1236397 */   // Label 17825: @1236397
     /* 1236397 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1236481), // Rule ID 19880 //
     /* 1236402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1236413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1236416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236480 */     // GIR_Coverage, 19880,
     /* 1236480 */     GIR_EraseRootFromParent_Done,
     /* 1236481 */   // Label 17826: @1236481
     /* 1236481 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1236565), // Rule ID 19881 //
     /* 1236486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1236489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1236497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1236500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236564 */     // GIR_Coverage, 19881,
     /* 1236564 */     GIR_EraseRootFromParent_Done,
     /* 1236565 */   // Label 17827: @1236565
     /* 1236565 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1236649), // Rule ID 19884 //
     /* 1236570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1236573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1236581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1236584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1236587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236623 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1236644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236648 */     // GIR_Coverage, 19884,
     /* 1236648 */     GIR_EraseRootFromParent_Done,
     /* 1236649 */   // Label 17828: @1236649
     /* 1236649 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1236733), // Rule ID 19885 //
     /* 1236654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1236657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1236665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1236668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1236671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1236710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1236728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236732 */     // GIR_Coverage, 19885,
     /* 1236732 */     GIR_EraseRootFromParent_Done,
     /* 1236733 */   // Label 17829: @1236733
     /* 1236733 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1236817), // Rule ID 19888 //
     /* 1236738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1236741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1236749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1236752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1236758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1236761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1236794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236816 */     // GIR_Coverage, 19888,
     /* 1236816 */     GIR_EraseRootFromParent_Done,
     /* 1236817 */   // Label 17830: @1236817
     /* 1236817 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1236901), // Rule ID 19889 //
     /* 1236822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1236833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1236836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1236842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1236845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1236878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236900 */     // GIR_Coverage, 19889,
     /* 1236900 */     GIR_EraseRootFromParent_Done,
     /* 1236901 */   // Label 17831: @1236901
     /* 1236901 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1236985), // Rule ID 19892 //
     /* 1236906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1236909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1236917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1236920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1236923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1236926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1236929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1236962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236984 */     // GIR_Coverage, 19892,
     /* 1236984 */     GIR_EraseRootFromParent_Done,
     /* 1236985 */   // Label 17832: @1236985
     /* 1236985 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1237069), // Rule ID 19893 //
     /* 1236990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1236998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1237001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1237004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1237010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1237046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237068 */     // GIR_Coverage, 19893,
     /* 1237068 */     GIR_EraseRootFromParent_Done,
     /* 1237069 */   // Label 17833: @1237069
     /* 1237069 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1237153), // Rule ID 19896 //
     /* 1237074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1237077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1237085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1237088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1237094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1237097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237127 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1237130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237152 */     // GIR_Coverage, 19896,
     /* 1237152 */     GIR_EraseRootFromParent_Done,
     /* 1237153 */   // Label 17834: @1237153
     /* 1237153 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1237237), // Rule ID 19897 //
     /* 1237158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1237161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1237169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1237172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1237178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1237181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1237214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237236 */     // GIR_Coverage, 19897,
     /* 1237236 */     GIR_EraseRootFromParent_Done,
     /* 1237237 */   // Label 17835: @1237237
     /* 1237237 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1237321), // Rule ID 19900 //
     /* 1237242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1237245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1237253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1237256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1237259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1237262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1237265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1237298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237320 */     // GIR_Coverage, 19900,
     /* 1237320 */     GIR_EraseRootFromParent_Done,
     /* 1237321 */   // Label 17836: @1237321
     /* 1237321 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1237405), // Rule ID 19901 //
     /* 1237326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1237337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1237340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1237343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1237346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1237349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237379 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1237382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237404 */     // GIR_Coverage, 19901,
     /* 1237404 */     GIR_EraseRootFromParent_Done,
     /* 1237405 */   // Label 17837: @1237405
     /* 1237405 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1237489), // Rule ID 19904 //
     /* 1237410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1237413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1237421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1237424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1237427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1237430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1237466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237488 */     // GIR_Coverage, 19904,
     /* 1237488 */     GIR_EraseRootFromParent_Done,
     /* 1237489 */   // Label 17838: @1237489
     /* 1237489 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1237573), // Rule ID 19905 //
     /* 1237494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1237505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1237508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1237511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1237514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1237550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237572 */     // GIR_Coverage, 19905,
     /* 1237572 */     GIR_EraseRootFromParent_Done,
     /* 1237573 */   // Label 17839: @1237573
     /* 1237573 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1237657), // Rule ID 19908 //
     /* 1237578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1237581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1237589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1237592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1237595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1237598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237631 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1237634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237656 */     // GIR_Coverage, 19908,
     /* 1237656 */     GIR_EraseRootFromParent_Done,
     /* 1237657 */   // Label 17840: @1237657
     /* 1237657 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1237741), // Rule ID 19909 //
     /* 1237662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1237673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1237676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1237679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1237682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237715 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1237718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237740 */     // GIR_Coverage, 19909,
     /* 1237740 */     GIR_EraseRootFromParent_Done,
     /* 1237741 */   // Label 17841: @1237741
     /* 1237741 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1237825), // Rule ID 19912 //
     /* 1237746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1237749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1237757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1237760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1237763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1237766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1237769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237799 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1237802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237824 */     // GIR_Coverage, 19912,
     /* 1237824 */     GIR_EraseRootFromParent_Done,
     /* 1237825 */   // Label 17842: @1237825
     /* 1237825 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1237909), // Rule ID 19913 //
     /* 1237830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1237833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1237841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1237844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1237847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1237850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1237853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237883 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1237883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1237886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237908 */     // GIR_Coverage, 19913,
     /* 1237908 */     GIR_EraseRootFromParent_Done,
     /* 1237909 */   // Label 17843: @1237909
     /* 1237909 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1237993), // Rule ID 19916 //
     /* 1237914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1237917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1237922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1237925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1237928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1237931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1237934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1237937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1237967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1237970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1237991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237992 */     // GIR_Coverage, 19916,
     /* 1237992 */     GIR_EraseRootFromParent_Done,
     /* 1237993 */   // Label 17844: @1237993
     /* 1237993 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1238077), // Rule ID 19917 //
     /* 1237998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1238001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1238009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1238012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1238015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1238018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238051 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1238054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238076 */     // GIR_Coverage, 19917,
     /* 1238076 */     GIR_EraseRootFromParent_Done,
     /* 1238077 */   // Label 17845: @1238077
     /* 1238077 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1238161), // Rule ID 19920 //
     /* 1238082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1238085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1238093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1238096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1238099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1238102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238135 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1238138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238160 */     // GIR_Coverage, 19920,
     /* 1238160 */     GIR_EraseRootFromParent_Done,
     /* 1238161 */   // Label 17846: @1238161
     /* 1238161 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1238245), // Rule ID 19921 //
     /* 1238166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1238169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1238177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1238180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1238183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1238186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1238222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238244 */     // GIR_Coverage, 19921,
     /* 1238244 */     GIR_EraseRootFromParent_Done,
     /* 1238245 */   // Label 17847: @1238245
     /* 1238245 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1238329), // Rule ID 19924 //
     /* 1238250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1238253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1238267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238303 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1238306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238328 */     // GIR_Coverage, 19924,
     /* 1238328 */     GIR_EraseRootFromParent_Done,
     /* 1238329 */   // Label 17848: @1238329
     /* 1238329 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1238413), // Rule ID 19925 //
     /* 1238334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1238337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1238351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1238390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238412 */     // GIR_Coverage, 19925,
     /* 1238412 */     GIR_EraseRootFromParent_Done,
     /* 1238413 */   // Label 17849: @1238413
     /* 1238413 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1238497), // Rule ID 19928 //
     /* 1238418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1238421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1238429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1238432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1238435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238471 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1238474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238496 */     // GIR_Coverage, 19928,
     /* 1238496 */     GIR_EraseRootFromParent_Done,
     /* 1238497 */   // Label 17850: @1238497
     /* 1238497 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1238581), // Rule ID 19929 //
     /* 1238502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1238505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1238513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1238516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1238519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1238558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238580 */     // GIR_Coverage, 19929,
     /* 1238580 */     GIR_EraseRootFromParent_Done,
     /* 1238581 */   // Label 17851: @1238581
     /* 1238581 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1238665), // Rule ID 19932 //
     /* 1238586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1238589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1238603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238639 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1238642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238664 */     // GIR_Coverage, 19932,
     /* 1238664 */     GIR_EraseRootFromParent_Done,
     /* 1238665 */   // Label 17852: @1238665
     /* 1238665 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1238749), // Rule ID 19933 //
     /* 1238670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1238673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1238687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238723 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1238726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238748 */     // GIR_Coverage, 19933,
     /* 1238748 */     GIR_EraseRootFromParent_Done,
     /* 1238749 */   // Label 17853: @1238749
     /* 1238749 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1238833), // Rule ID 19936 //
     /* 1238754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1238757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1238765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1238768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1238771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238807 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1238810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238832 */     // GIR_Coverage, 19936,
     /* 1238832 */     GIR_EraseRootFromParent_Done,
     /* 1238833 */   // Label 17854: @1238833
     /* 1238833 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1238917), // Rule ID 19937 //
     /* 1238838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1238841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1238849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1238852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1238855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1238858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1238880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238891 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1238894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238916 */     // GIR_Coverage, 19937,
     /* 1238916 */     GIR_EraseRootFromParent_Done,
     /* 1238917 */   // Label 17855: @1238917
     /* 1238917 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1239001), // Rule ID 19940 //
     /* 1238922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1238925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1238930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1238933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1238936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1238939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1238978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239000 */     // GIR_Coverage, 19940,
     /* 1239000 */     GIR_EraseRootFromParent_Done,
     /* 1239001 */   // Label 17856: @1239001
     /* 1239001 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1239085), // Rule ID 19941 //
     /* 1239006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1239009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1239017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1239020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1239062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239084 */     // GIR_Coverage, 19941,
     /* 1239084 */     GIR_EraseRootFromParent_Done,
     /* 1239085 */   // Label 17857: @1239085
     /* 1239085 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1239169), // Rule ID 19944 //
     /* 1239090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1239093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1239101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1239104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1239107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1239110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1239132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239143 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1239146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239168 */     // GIR_Coverage, 19944,
     /* 1239168 */     GIR_EraseRootFromParent_Done,
     /* 1239169 */   // Label 17858: @1239169
     /* 1239169 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1239253), // Rule ID 19945 //
     /* 1239174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1239177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1239185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1239188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1239191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1239194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1239216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1239230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239252 */     // GIR_Coverage, 19945,
     /* 1239252 */     GIR_EraseRootFromParent_Done,
     /* 1239253 */   // Label 17859: @1239253
     /* 1239253 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1239337), // Rule ID 19948 //
     /* 1239258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1239261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1239269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1239272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1239275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1239314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239336 */     // GIR_Coverage, 19948,
     /* 1239336 */     GIR_EraseRootFromParent_Done,
     /* 1239337 */   // Label 17860: @1239337
     /* 1239337 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1239421), // Rule ID 19949 //
     /* 1239342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1239345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1239353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1239356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1239359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1239398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239420 */     // GIR_Coverage, 19949,
     /* 1239420 */     GIR_EraseRootFromParent_Done,
     /* 1239421 */   // Label 17861: @1239421
     /* 1239421 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1239505), // Rule ID 19952 //
     /* 1239426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1239429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1239437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1239440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1239443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1239449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239479 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1239482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239504 */     // GIR_Coverage, 19952,
     /* 1239504 */     GIR_EraseRootFromParent_Done,
     /* 1239505 */   // Label 17862: @1239505
     /* 1239505 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1239589), // Rule ID 19953 //
     /* 1239510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1239513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1239521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1239524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1239527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1239533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239563 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1239566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239588 */     // GIR_Coverage, 19953,
     /* 1239588 */     GIR_EraseRootFromParent_Done,
     /* 1239589 */   // Label 17863: @1239589
     /* 1239589 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1239673), // Rule ID 19956 //
     /* 1239594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1239597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1239605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1239608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1239611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1239617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239647 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1239650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239672 */     // GIR_Coverage, 19956,
     /* 1239672 */     GIR_EraseRootFromParent_Done,
     /* 1239673 */   // Label 17864: @1239673
     /* 1239673 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1239757), // Rule ID 19957 //
     /* 1239678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1239681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1239689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1239692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1239695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1239698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1239701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1239720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239731 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1239734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239756 */     // GIR_Coverage, 19957,
     /* 1239756 */     GIR_EraseRootFromParent_Done,
     /* 1239757 */   // Label 17865: @1239757
     /* 1239757 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1239841), // Rule ID 19960 //
     /* 1239762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1239765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1239773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1239776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1239779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239815 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1239818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239840 */     // GIR_Coverage, 19960,
     /* 1239840 */     GIR_EraseRootFromParent_Done,
     /* 1239841 */   // Label 17866: @1239841
     /* 1239841 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1239925), // Rule ID 19961 //
     /* 1239846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1239849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1239857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1239860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1239863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1239899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1239902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1239923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239924 */     // GIR_Coverage, 19961,
     /* 1239924 */     GIR_EraseRootFromParent_Done,
     /* 1239925 */   // Label 17867: @1239925
     /* 1239925 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1240009), // Rule ID 19964 //
     /* 1239930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1239933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1239938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1239941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1239944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1239947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239983 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1239983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1239986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240008 */     // GIR_Coverage, 19964,
     /* 1240008 */     GIR_EraseRootFromParent_Done,
     /* 1240009 */   // Label 17868: @1240009
     /* 1240009 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1240093), // Rule ID 19965 //
     /* 1240014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1240017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1240025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1240028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1240031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240067 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1240070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240092 */     // GIR_Coverage, 19965,
     /* 1240092 */     GIR_EraseRootFromParent_Done,
     /* 1240093 */   // Label 17869: @1240093
     /* 1240093 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1240177), // Rule ID 19968 //
     /* 1240098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1240101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1240109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1240112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1240115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240151 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1240154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240176 */     // GIR_Coverage, 19968,
     /* 1240176 */     GIR_EraseRootFromParent_Done,
     /* 1240177 */   // Label 17870: @1240177
     /* 1240177 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1240261), // Rule ID 19969 //
     /* 1240182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1240185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1240193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1240196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1240199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1240238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240260 */     // GIR_Coverage, 19969,
     /* 1240260 */     GIR_EraseRootFromParent_Done,
     /* 1240261 */   // Label 17871: @1240261
     /* 1240261 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1240345), // Rule ID 19972 //
     /* 1240266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1240269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1240277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1240280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1240283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1240322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240344 */     // GIR_Coverage, 19972,
     /* 1240344 */     GIR_EraseRootFromParent_Done,
     /* 1240345 */   // Label 17872: @1240345
     /* 1240345 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1240429), // Rule ID 19973 //
     /* 1240350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1240353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1240361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1240364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1240367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240403 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1240406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240428 */     // GIR_Coverage, 19973,
     /* 1240428 */     GIR_EraseRootFromParent_Done,
     /* 1240429 */   // Label 17873: @1240429
     /* 1240429 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1240513), // Rule ID 19976 //
     /* 1240434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1240437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1240445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1240448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1240451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240487 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1240490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240512 */     // GIR_Coverage, 19976,
     /* 1240512 */     GIR_EraseRootFromParent_Done,
     /* 1240513 */   // Label 17874: @1240513
     /* 1240513 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1240597), // Rule ID 19977 //
     /* 1240518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1240521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1240529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1240532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1240535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1240574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240596 */     // GIR_Coverage, 19977,
     /* 1240596 */     GIR_EraseRootFromParent_Done,
     /* 1240597 */   // Label 17875: @1240597
     /* 1240597 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1240681), // Rule ID 19980 //
     /* 1240602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1240605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1240613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1240616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1240619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240655 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1240658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240680 */     // GIR_Coverage, 19980,
     /* 1240680 */     GIR_EraseRootFromParent_Done,
     /* 1240681 */   // Label 17876: @1240681
     /* 1240681 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1240765), // Rule ID 19981 //
     /* 1240686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1240689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1240694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1240697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1240700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1240703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1240728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1240742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240764 */     // GIR_Coverage, 19981,
     /* 1240764 */     GIR_EraseRootFromParent_Done,
     /* 1240765 */   // Label 17877: @1240765
     /* 1240765 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1240849), // Rule ID 19984 //
     /* 1240770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1240773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1240778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1240781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1240784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1240790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1240826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240848 */     // GIR_Coverage, 19984,
     /* 1240848 */     GIR_EraseRootFromParent_Done,
     /* 1240849 */   // Label 17878: @1240849
     /* 1240849 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1240933), // Rule ID 19985 //
     /* 1240854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1240857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1240862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1240865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1240868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1240874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240907 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1240907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1240910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1240931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240932 */     // GIR_Coverage, 19985,
     /* 1240932 */     GIR_EraseRootFromParent_Done,
     /* 1240933 */   // Label 17879: @1240933
     /* 1240933 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1241017), // Rule ID 19988 //
     /* 1240938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1240941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1240946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1240949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1240952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1240955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1240958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1240991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1240994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241016 */     // GIR_Coverage, 19988,
     /* 1241016 */     GIR_EraseRootFromParent_Done,
     /* 1241017 */   // Label 17880: @1241017
     /* 1241017 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1241101), // Rule ID 19989 //
     /* 1241022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1241025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1241033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1241036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1241039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1241042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241075 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1241078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241100 */     // GIR_Coverage, 19989,
     /* 1241100 */     GIR_EraseRootFromParent_Done,
     /* 1241101 */   // Label 17881: @1241101
     /* 1241101 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1241185), // Rule ID 19992 //
     /* 1241106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1241109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1241123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1241126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241159 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1241162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241184 */     // GIR_Coverage, 19992,
     /* 1241184 */     GIR_EraseRootFromParent_Done,
     /* 1241185 */   // Label 17882: @1241185
     /* 1241185 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1241269), // Rule ID 19993 //
     /* 1241190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1241193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1241207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1241210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1241246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241268 */     // GIR_Coverage, 19993,
     /* 1241268 */     GIR_EraseRootFromParent_Done,
     /* 1241269 */   // Label 17883: @1241269
     /* 1241269 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1241353), // Rule ID 19996 //
     /* 1241274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1241277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1241285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1241288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1241294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241327 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241352 */     // GIR_Coverage, 19996,
     /* 1241352 */     GIR_EraseRootFromParent_Done,
     /* 1241353 */   // Label 17884: @1241353
     /* 1241353 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1241437), // Rule ID 19997 //
     /* 1241358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1241361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1241369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1241372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1241378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241411 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241436 */     // GIR_Coverage, 19997,
     /* 1241436 */     GIR_EraseRootFromParent_Done,
     /* 1241437 */   // Label 17885: @1241437
     /* 1241437 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1241521), // Rule ID 20000 //
     /* 1241442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1241445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1241453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1241456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1241459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1241462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241495 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241520 */     // GIR_Coverage, 20000,
     /* 1241520 */     GIR_EraseRootFromParent_Done,
     /* 1241521 */   // Label 17886: @1241521
     /* 1241521 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1241605), // Rule ID 20001 //
     /* 1241526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1241529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1241537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1241540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1241543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1241546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241604 */     // GIR_Coverage, 20001,
     /* 1241604 */     GIR_EraseRootFromParent_Done,
     /* 1241605 */   // Label 17887: @1241605
     /* 1241605 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1241689), // Rule ID 20004 //
     /* 1241610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1241613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1241627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1241630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241663 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241688 */     // GIR_Coverage, 20004,
     /* 1241688 */     GIR_EraseRootFromParent_Done,
     /* 1241689 */   // Label 17888: @1241689
     /* 1241689 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1241773), // Rule ID 20005 //
     /* 1241694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1241697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1241711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1241714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241747 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1241750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241772 */     // GIR_Coverage, 20005,
     /* 1241772 */     GIR_EraseRootFromParent_Done,
     /* 1241773 */   // Label 17889: @1241773
     /* 1241773 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1241857), // Rule ID 20008 //
     /* 1241778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1241781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1241789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1241792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1241834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241856 */     // GIR_Coverage, 20008,
     /* 1241856 */     GIR_EraseRootFromParent_Done,
     /* 1241857 */   // Label 17890: @1241857
     /* 1241857 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1241941), // Rule ID 20009 //
     /* 1241862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1241865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1241873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1241876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1241915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1241918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241940 */     // GIR_Coverage, 20009,
     /* 1241940 */     GIR_EraseRootFromParent_Done,
     /* 1241941 */   // Label 17891: @1241941
     /* 1241941 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1242025), // Rule ID 20012 //
     /* 1241946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1241949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1241954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1241957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1241960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241999 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1242002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242024 */     // GIR_Coverage, 20012,
     /* 1242024 */     GIR_EraseRootFromParent_Done,
     /* 1242025 */   // Label 17892: @1242025
     /* 1242025 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1242109), // Rule ID 20013 //
     /* 1242030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1242033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1242041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1242044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1242047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1242050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1242086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242108 */     // GIR_Coverage, 20013,
     /* 1242108 */     GIR_EraseRootFromParent_Done,
     /* 1242109 */   // Label 17893: @1242109
     /* 1242109 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1242193), // Rule ID 20016 //
     /* 1242114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1242117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1242125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1242128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1242131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1242134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1242137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242167 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1242170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242192 */     // GIR_Coverage, 20016,
     /* 1242192 */     GIR_EraseRootFromParent_Done,
     /* 1242193 */   // Label 17894: @1242193
     /* 1242193 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1242277), // Rule ID 20017 //
     /* 1242198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1242201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1242209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1242212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1242215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1242218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1242221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242251 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1242254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242276 */     // GIR_Coverage, 20017,
     /* 1242276 */     GIR_EraseRootFromParent_Done,
     /* 1242277 */   // Label 17895: @1242277
     /* 1242277 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1242361), // Rule ID 20020 //
     /* 1242282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1242285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1242293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1242296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1242299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1242302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242335 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1242338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242360 */     // GIR_Coverage, 20020,
     /* 1242360 */     GIR_EraseRootFromParent_Done,
     /* 1242361 */   // Label 17896: @1242361
     /* 1242361 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1242445), // Rule ID 20021 //
     /* 1242366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1242369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1242377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1242380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1242383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1242386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242419 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1242422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242444 */     // GIR_Coverage, 20021,
     /* 1242444 */     GIR_EraseRootFromParent_Done,
     /* 1242445 */   // Label 17897: @1242445
     /* 1242445 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1242529), // Rule ID 20024 //
     /* 1242450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1242453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1242461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1242464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1242467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1242470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242503 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1242506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242528 */     // GIR_Coverage, 20024,
     /* 1242528 */     GIR_EraseRootFromParent_Done,
     /* 1242529 */   // Label 17898: @1242529
     /* 1242529 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1242613), // Rule ID 20025 //
     /* 1242534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1242537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1242545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1242548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1242551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1242554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242587 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1242590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242612 */     // GIR_Coverage, 20025,
     /* 1242612 */     GIR_EraseRootFromParent_Done,
     /* 1242613 */   // Label 17899: @1242613
     /* 1242613 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1242697), // Rule ID 20028 //
     /* 1242618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1242621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1242629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1242632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242671 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1242674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242696 */     // GIR_Coverage, 20028,
     /* 1242696 */     GIR_EraseRootFromParent_Done,
     /* 1242697 */   // Label 17900: @1242697
     /* 1242697 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1242781), // Rule ID 20029 //
     /* 1242702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1242705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1242713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1242716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1242758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242780 */     // GIR_Coverage, 20029,
     /* 1242780 */     GIR_EraseRootFromParent_Done,
     /* 1242781 */   // Label 17901: @1242781
     /* 1242781 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1242865), // Rule ID 20032 //
     /* 1242786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1242789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1242797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1242800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1242842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242864 */     // GIR_Coverage, 20032,
     /* 1242864 */     GIR_EraseRootFromParent_Done,
     /* 1242865 */   // Label 17902: @1242865
     /* 1242865 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1242949), // Rule ID 20033 //
     /* 1242870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1242873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1242881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1242884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1242926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242948 */     // GIR_Coverage, 20033,
     /* 1242948 */     GIR_EraseRootFromParent_Done,
     /* 1242949 */   // Label 17903: @1242949
     /* 1242949 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1243033), // Rule ID 20036 //
     /* 1242954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1242957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1242962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1242965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1242968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1243010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243032 */     // GIR_Coverage, 20036,
     /* 1243032 */     GIR_EraseRootFromParent_Done,
     /* 1243033 */   // Label 17904: @1243033
     /* 1243033 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1243117), // Rule ID 20037 //
     /* 1243038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1243041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1243049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1243052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1243055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1243058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243091 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1243094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243116 */     // GIR_Coverage, 20037,
     /* 1243116 */     GIR_EraseRootFromParent_Done,
     /* 1243117 */   // Label 17905: @1243117
     /* 1243117 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1243201), // Rule ID 20040 //
     /* 1243122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1243125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1243133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1243136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1243139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1243142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243175 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1243178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243200 */     // GIR_Coverage, 20040,
     /* 1243200 */     GIR_EraseRootFromParent_Done,
     /* 1243201 */   // Label 17906: @1243201
     /* 1243201 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1243285), // Rule ID 20041 //
     /* 1243206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1243209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1243217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1243220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1243223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1243226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1243262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243284 */     // GIR_Coverage, 20041,
     /* 1243284 */     GIR_EraseRootFromParent_Done,
     /* 1243285 */   // Label 17907: @1243285
     /* 1243285 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1243369), // Rule ID 20044 //
     /* 1243290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1243293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1243301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1243304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1243346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243368 */     // GIR_Coverage, 20044,
     /* 1243368 */     GIR_EraseRootFromParent_Done,
     /* 1243369 */   // Label 17908: @1243369
     /* 1243369 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1243453), // Rule ID 20045 //
     /* 1243374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1243377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1243385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1243388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1243430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243452 */     // GIR_Coverage, 20045,
     /* 1243452 */     GIR_EraseRootFromParent_Done,
     /* 1243453 */   // Label 17909: @1243453
     /* 1243453 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1243537), // Rule ID 20048 //
     /* 1243458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1243461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1243469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1243472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243511 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1243514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243536 */     // GIR_Coverage, 20048,
     /* 1243536 */     GIR_EraseRootFromParent_Done,
     /* 1243537 */   // Label 17910: @1243537
     /* 1243537 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1243621), // Rule ID 20049 //
     /* 1243542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1243545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1243553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1243556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1243598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243620 */     // GIR_Coverage, 20049,
     /* 1243620 */     GIR_EraseRootFromParent_Done,
     /* 1243621 */   // Label 17911: @1243621
     /* 1243621 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1243705), // Rule ID 20052 //
     /* 1243626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1243629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1243637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1243640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1243668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243679 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1243682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243704 */     // GIR_Coverage, 20052,
     /* 1243704 */     GIR_EraseRootFromParent_Done,
     /* 1243705 */   // Label 17912: @1243705
     /* 1243705 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1243789), // Rule ID 20053 //
     /* 1243710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1243713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1243721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1243724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1243752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243763 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1243766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243788 */     // GIR_Coverage, 20053,
     /* 1243788 */     GIR_EraseRootFromParent_Done,
     /* 1243789 */   // Label 17913: @1243789
     /* 1243789 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1243873), // Rule ID 20056 //
     /* 1243794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1243797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1243805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1243808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1243847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1243850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243872 */     // GIR_Coverage, 20056,
     /* 1243872 */     GIR_EraseRootFromParent_Done,
     /* 1243873 */   // Label 17914: @1243873
     /* 1243873 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1243957), // Rule ID 20057 //
     /* 1243878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1243881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1243889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1243892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1243898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1243920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243931 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1243931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1243934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1243955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243956 */     // GIR_Coverage, 20057,
     /* 1243956 */     GIR_EraseRootFromParent_Done,
     /* 1243957 */   // Label 17915: @1243957
     /* 1243957 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1244041), // Rule ID 20060 //
     /* 1243962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1243965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1243970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1243973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1243976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1244004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1244018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244040 */     // GIR_Coverage, 20060,
     /* 1244040 */     GIR_EraseRootFromParent_Done,
     /* 1244041 */   // Label 17916: @1244041
     /* 1244041 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1244125), // Rule ID 20061 //
     /* 1244046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1244049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1244057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1244060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1244063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1244088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1244102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244124 */     // GIR_Coverage, 20061,
     /* 1244124 */     GIR_EraseRootFromParent_Done,
     /* 1244125 */   // Label 17917: @1244125
     /* 1244125 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1244209), // Rule ID 20064 //
     /* 1244130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1244133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1244141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1244144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1244172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244183 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1244186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244208 */     // GIR_Coverage, 20064,
     /* 1244208 */     GIR_EraseRootFromParent_Done,
     /* 1244209 */   // Label 17918: @1244209
     /* 1244209 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1244293), // Rule ID 20065 //
     /* 1244214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1244217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1244225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1244228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1244256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1244270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244292 */     // GIR_Coverage, 20065,
     /* 1244292 */     GIR_EraseRootFromParent_Done,
     /* 1244293 */   // Label 17919: @1244293
     /* 1244293 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1244377), // Rule ID 20068 //
     /* 1244298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1244301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1244309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1244312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244351 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1244354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244376 */     // GIR_Coverage, 20068,
     /* 1244376 */     GIR_EraseRootFromParent_Done,
     /* 1244377 */   // Label 17920: @1244377
     /* 1244377 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1244461), // Rule ID 20069 //
     /* 1244382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1244385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1244393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1244396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1244438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244460 */     // GIR_Coverage, 20069,
     /* 1244460 */     GIR_EraseRootFromParent_Done,
     /* 1244461 */   // Label 17921: @1244461
     /* 1244461 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1244545), // Rule ID 20072 //
     /* 1244466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1244469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1244477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1244480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244519 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1244522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244544 */     // GIR_Coverage, 20072,
     /* 1244544 */     GIR_EraseRootFromParent_Done,
     /* 1244545 */   // Label 17922: @1244545
     /* 1244545 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1244629), // Rule ID 20073 //
     /* 1244550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1244553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1244561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1244564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244603 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1244606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244628 */     // GIR_Coverage, 20073,
     /* 1244628 */     GIR_EraseRootFromParent_Done,
     /* 1244629 */   // Label 17923: @1244629
     /* 1244629 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1244713), // Rule ID 20076 //
     /* 1244634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1244637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1244645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1244648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244687 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1244690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244712 */     // GIR_Coverage, 20076,
     /* 1244712 */     GIR_EraseRootFromParent_Done,
     /* 1244713 */   // Label 17924: @1244713
     /* 1244713 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1244797), // Rule ID 20077 //
     /* 1244718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1244721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1244729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1244732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1244738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1244760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244771 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1244774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244796 */     // GIR_Coverage, 20077,
     /* 1244796 */     GIR_EraseRootFromParent_Done,
     /* 1244797 */   // Label 17925: @1244797
     /* 1244797 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1244881), // Rule ID 20080 //
     /* 1244802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1244805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1244813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1244816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1244844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244855 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1244855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1244858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244880 */     // GIR_Coverage, 20080,
     /* 1244880 */     GIR_EraseRootFromParent_Done,
     /* 1244881 */   // Label 17926: @1244881
     /* 1244881 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1244965), // Rule ID 20081 //
     /* 1244886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1244889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1244897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1244900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1244928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244939 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1244939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1244942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1244963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244964 */     // GIR_Coverage, 20081,
     /* 1244964 */     GIR_EraseRootFromParent_Done,
     /* 1244965 */   // Label 17927: @1244965
     /* 1244965 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1245049), // Rule ID 20084 //
     /* 1244970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1244973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1244978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1244981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1244984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1244987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1245012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245023 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1245026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245048 */     // GIR_Coverage, 20084,
     /* 1245048 */     GIR_EraseRootFromParent_Done,
     /* 1245049 */   // Label 17928: @1245049
     /* 1245049 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1245133), // Rule ID 20085 //
     /* 1245054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1245057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1245065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1245068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1245096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1245110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245132 */     // GIR_Coverage, 20085,
     /* 1245132 */     GIR_EraseRootFromParent_Done,
     /* 1245133 */   // Label 17929: @1245133
     /* 1245133 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1245217), // Rule ID 20088 //
     /* 1245138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1245141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1245149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1245152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1245180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245191 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1245194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245216 */     // GIR_Coverage, 20088,
     /* 1245216 */     GIR_EraseRootFromParent_Done,
     /* 1245217 */   // Label 17930: @1245217
     /* 1245217 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1245301), // Rule ID 20089 //
     /* 1245222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1245225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1245233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1245236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1245264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245275 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1245278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245300 */     // GIR_Coverage, 20089,
     /* 1245300 */     GIR_EraseRootFromParent_Done,
     /* 1245301 */   // Label 17931: @1245301
     /* 1245301 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1245385), // Rule ID 20092 //
     /* 1245306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1245309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1245317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1245320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1245362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245384 */     // GIR_Coverage, 20092,
     /* 1245384 */     GIR_EraseRootFromParent_Done,
     /* 1245385 */   // Label 17932: @1245385
     /* 1245385 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1245469), // Rule ID 20093 //
     /* 1245390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1245393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1245401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1245404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245443 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1245446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245468 */     // GIR_Coverage, 20093,
     /* 1245468 */     GIR_EraseRootFromParent_Done,
     /* 1245469 */   // Label 17933: @1245469
     /* 1245469 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1245553), // Rule ID 20096 //
     /* 1245474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1245477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1245485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1245488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245527 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1245530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245552 */     // GIR_Coverage, 20096,
     /* 1245552 */     GIR_EraseRootFromParent_Done,
     /* 1245553 */   // Label 17934: @1245553
     /* 1245553 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1245637), // Rule ID 20097 //
     /* 1245558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1245561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1245569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1245572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245611 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1245614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245636 */     // GIR_Coverage, 20097,
     /* 1245636 */     GIR_EraseRootFromParent_Done,
     /* 1245637 */   // Label 17935: @1245637
     /* 1245637 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1245721), // Rule ID 20100 //
     /* 1245642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1245645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1245653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1245656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245695 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1245698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245720 */     // GIR_Coverage, 20100,
     /* 1245720 */     GIR_EraseRootFromParent_Done,
     /* 1245721 */   // Label 17936: @1245721
     /* 1245721 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1245805), // Rule ID 20101 //
     /* 1245726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1245729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1245734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1245737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1245740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1245768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1245782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245804 */     // GIR_Coverage, 20101,
     /* 1245804 */     GIR_EraseRootFromParent_Done,
     /* 1245805 */   // Label 17937: @1245805
     /* 1245805 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1245889), // Rule ID 20104 //
     /* 1245810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1245813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1245818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1245821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1245824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1245827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1245830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1245852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245863 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1245863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1245866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245888 */     // GIR_Coverage, 20104,
     /* 1245888 */     GIR_EraseRootFromParent_Done,
     /* 1245889 */   // Label 17938: @1245889
     /* 1245889 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1245973), // Rule ID 20105 //
     /* 1245894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1245897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1245902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1245905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1245908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1245911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1245914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1245936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245947 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1245947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1245950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1245971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245972 */     // GIR_Coverage, 20105,
     /* 1245972 */     GIR_EraseRootFromParent_Done,
     /* 1245973 */   // Label 17939: @1245973
     /* 1245973 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1246057), // Rule ID 20108 //
     /* 1245978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1245981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1245986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1245989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1245992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1245995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1245998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246031 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1246034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246056 */     // GIR_Coverage, 20108,
     /* 1246056 */     GIR_EraseRootFromParent_Done,
     /* 1246057 */   // Label 17940: @1246057
     /* 1246057 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1246141), // Rule ID 20109 //
     /* 1246062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1246065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1246082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246115 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1246118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246140 */     // GIR_Coverage, 20109,
     /* 1246140 */     GIR_EraseRootFromParent_Done,
     /* 1246141 */   // Label 17941: @1246141
     /* 1246141 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1246225), // Rule ID 20112 //
     /* 1246146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1246149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1246188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1246202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246224 */     // GIR_Coverage, 20112,
     /* 1246224 */     GIR_EraseRootFromParent_Done,
     /* 1246225 */   // Label 17942: @1246225
     /* 1246225 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1246309), // Rule ID 20113 //
     /* 1246230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1246233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1246272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246283 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1246286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246308 */     // GIR_Coverage, 20113,
     /* 1246308 */     GIR_EraseRootFromParent_Done,
     /* 1246309 */   // Label 17943: @1246309
     /* 1246309 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1246393), // Rule ID 20116 //
     /* 1246314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1246317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1246325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1246328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1246334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246367 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1246370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246392 */     // GIR_Coverage, 20116,
     /* 1246392 */     GIR_EraseRootFromParent_Done,
     /* 1246393 */   // Label 17944: @1246393
     /* 1246393 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1246477), // Rule ID 20117 //
     /* 1246398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1246401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1246409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1246412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1246418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246451 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1246454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246476 */     // GIR_Coverage, 20117,
     /* 1246476 */     GIR_EraseRootFromParent_Done,
     /* 1246477 */   // Label 17945: @1246477
     /* 1246477 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1246561), // Rule ID 20120 //
     /* 1246482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1246485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1246499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1246524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246535 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1246538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246560 */     // GIR_Coverage, 20120,
     /* 1246560 */     GIR_EraseRootFromParent_Done,
     /* 1246561 */   // Label 17946: @1246561
     /* 1246561 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1246645), // Rule ID 20121 //
     /* 1246566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1246569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1246583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1246608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1246622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246644 */     // GIR_Coverage, 20121,
     /* 1246644 */     GIR_EraseRootFromParent_Done,
     /* 1246645 */   // Label 17947: @1246645
     /* 1246645 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1246729), // Rule ID 20124 //
     /* 1246650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1246653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1246667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1246692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246703 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1246706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246728 */     // GIR_Coverage, 20124,
     /* 1246728 */     GIR_EraseRootFromParent_Done,
     /* 1246729 */   // Label 17948: @1246729
     /* 1246729 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1246813), // Rule ID 20125 //
     /* 1246734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1246737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1246751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1246776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1246790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246812 */     // GIR_Coverage, 20125,
     /* 1246812 */     GIR_EraseRootFromParent_Done,
     /* 1246813 */   // Label 17949: @1246813
     /* 1246813 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1246897), // Rule ID 20128 //
     /* 1246818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1246821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1246829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1246832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1246835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1246838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1246874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246896 */     // GIR_Coverage, 20128,
     /* 1246896 */     GIR_EraseRootFromParent_Done,
     /* 1246897 */   // Label 17950: @1246897
     /* 1246897 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1246981), // Rule ID 20129 //
     /* 1246902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1246905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1246913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1246916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1246919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1246922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1246944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246955 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1246958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246980 */     // GIR_Coverage, 20129,
     /* 1246980 */     GIR_EraseRootFromParent_Done,
     /* 1246981 */   // Label 17951: @1246981
     /* 1246981 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1247065), // Rule ID 20132 //
     /* 1246986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1246989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1246994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1246997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1247003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1247006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1247028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247039 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1247042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247064 */     // GIR_Coverage, 20132,
     /* 1247064 */     GIR_EraseRootFromParent_Done,
     /* 1247065 */   // Label 17952: @1247065
     /* 1247065 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1247149), // Rule ID 20133 //
     /* 1247070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1247073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1247081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1247087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1247090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1247112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247123 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1247126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247148 */     // GIR_Coverage, 20133,
     /* 1247148 */     GIR_EraseRootFromParent_Done,
     /* 1247149 */   // Label 17953: @1247149
     /* 1247149 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1247233), // Rule ID 20136 //
     /* 1247154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1247157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1247165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1247168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1247171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1247174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1247196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247207 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1247210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247232 */     // GIR_Coverage, 20136,
     /* 1247232 */     GIR_EraseRootFromParent_Done,
     /* 1247233 */   // Label 17954: @1247233
     /* 1247233 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1247317), // Rule ID 20137 //
     /* 1247238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1247241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1247249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1247252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1247255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1247258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1247280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247291 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1247294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247316 */     // GIR_Coverage, 20137,
     /* 1247316 */     GIR_EraseRootFromParent_Done,
     /* 1247317 */   // Label 17955: @1247317
     /* 1247317 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1247401), // Rule ID 20140 //
     /* 1247322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1247325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1247333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1247336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1247339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247375 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1247378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247400 */     // GIR_Coverage, 20140,
     /* 1247400 */     GIR_EraseRootFromParent_Done,
     /* 1247401 */   // Label 17956: @1247401
     /* 1247401 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1247485), // Rule ID 20141 //
     /* 1247406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1247409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1247417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1247420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1247423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247459 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1247462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247484 */     // GIR_Coverage, 20141,
     /* 1247484 */     GIR_EraseRootFromParent_Done,
     /* 1247485 */   // Label 17957: @1247485
     /* 1247485 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1247569), // Rule ID 20144 //
     /* 1247490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1247493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1247501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1247504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1247507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247543 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1247546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247568 */     // GIR_Coverage, 20144,
     /* 1247568 */     GIR_EraseRootFromParent_Done,
     /* 1247569 */   // Label 17958: @1247569
     /* 1247569 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1247653), // Rule ID 20145 //
     /* 1247574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1247577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1247585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1247588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1247591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247627 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1247630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247652 */     // GIR_Coverage, 20145,
     /* 1247652 */     GIR_EraseRootFromParent_Done,
     /* 1247653 */   // Label 17959: @1247653
     /* 1247653 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1247737), // Rule ID 20148 //
     /* 1247658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1247661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1247669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1247675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247711 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1247714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247736 */     // GIR_Coverage, 20148,
     /* 1247736 */     GIR_EraseRootFromParent_Done,
     /* 1247737 */   // Label 17960: @1247737
     /* 1247737 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1247821), // Rule ID 20149 //
     /* 1247742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1247745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1247753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1247759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1247784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1247798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247820 */     // GIR_Coverage, 20149,
     /* 1247820 */     GIR_EraseRootFromParent_Done,
     /* 1247821 */   // Label 17961: @1247821
     /* 1247821 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1247905), // Rule ID 20152 //
     /* 1247826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1247829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1247837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1247840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1247843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1247868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247879 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1247882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247904 */     // GIR_Coverage, 20152,
     /* 1247904 */     GIR_EraseRootFromParent_Done,
     /* 1247905 */   // Label 17962: @1247905
     /* 1247905 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1247989), // Rule ID 20153 //
     /* 1247910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1247913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1247918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1247921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1247924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1247927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1247952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1247966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247988 */     // GIR_Coverage, 20153,
     /* 1247988 */     GIR_EraseRootFromParent_Done,
     /* 1247989 */   // Label 17963: @1247989
     /* 1247989 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1248073), // Rule ID 20156 //
     /* 1247994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1247997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1248002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1248011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1248036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1248050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248072 */     // GIR_Coverage, 20156,
     /* 1248072 */     GIR_EraseRootFromParent_Done,
     /* 1248073 */   // Label 17964: @1248073
     /* 1248073 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1248157), // Rule ID 20157 //
     /* 1248078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1248081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1248086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1248095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1248120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1248134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248156 */     // GIR_Coverage, 20157,
     /* 1248156 */     GIR_EraseRootFromParent_Done,
     /* 1248157 */   // Label 17965: @1248157
     /* 1248157 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1248241), // Rule ID 20160 //
     /* 1248162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1248165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1248170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1248176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1248179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1248204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248215 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1248218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248240 */     // GIR_Coverage, 20160,
     /* 1248240 */     GIR_EraseRootFromParent_Done,
     /* 1248241 */   // Label 17966: @1248241
     /* 1248241 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1248325), // Rule ID 20161 //
     /* 1248246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1248249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1248254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1248260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1248263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1248288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1248302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248324 */     // GIR_Coverage, 20161,
     /* 1248324 */     GIR_EraseRootFromParent_Done,
     /* 1248325 */   // Label 17967: @1248325
     /* 1248325 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1248409), // Rule ID 20164 //
     /* 1248330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1248333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1248341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1248344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1248347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1248386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248408 */     // GIR_Coverage, 20164,
     /* 1248408 */     GIR_EraseRootFromParent_Done,
     /* 1248409 */   // Label 17968: @1248409
     /* 1248409 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1248493), // Rule ID 20165 //
     /* 1248414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1248417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1248425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1248428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1248431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1248470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248492 */     // GIR_Coverage, 20165,
     /* 1248492 */     GIR_EraseRootFromParent_Done,
     /* 1248493 */   // Label 17969: @1248493
     /* 1248493 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1248577), // Rule ID 20168 //
     /* 1248498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1248501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1248509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1248512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1248515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248551 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1248554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248576 */     // GIR_Coverage, 20168,
     /* 1248576 */     GIR_EraseRootFromParent_Done,
     /* 1248577 */   // Label 17970: @1248577
     /* 1248577 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1248661), // Rule ID 20169 //
     /* 1248582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1248585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1248593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1248596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1248599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1248638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248660 */     // GIR_Coverage, 20169,
     /* 1248660 */     GIR_EraseRootFromParent_Done,
     /* 1248661 */   // Label 17971: @1248661
     /* 1248661 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1248745), // Rule ID 20172 //
     /* 1248666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1248669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1248677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1248680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1248683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1248708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248719 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1248722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248744 */     // GIR_Coverage, 20172,
     /* 1248744 */     GIR_EraseRootFromParent_Done,
     /* 1248745 */   // Label 17972: @1248745
     /* 1248745 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1248829), // Rule ID 20173 //
     /* 1248750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1248753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1248761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1248764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1248767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1248792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1248806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248828 */     // GIR_Coverage, 20173,
     /* 1248828 */     GIR_EraseRootFromParent_Done,
     /* 1248829 */   // Label 17973: @1248829
     /* 1248829 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1248913), // Rule ID 20176 //
     /* 1248834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1248837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1248851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1248890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248912 */     // GIR_Coverage, 20176,
     /* 1248912 */     GIR_EraseRootFromParent_Done,
     /* 1248913 */   // Label 17974: @1248913
     /* 1248913 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1248997), // Rule ID 20177 //
     /* 1248918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1248921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1248926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1248935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1248938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1248960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248971 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1248974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248996 */     // GIR_Coverage, 20177,
     /* 1248996 */     GIR_EraseRootFromParent_Done,
     /* 1248997 */   // Label 17975: @1248997
     /* 1248997 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1249081), // Rule ID 20180 //
     /* 1249002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1249005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1249013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1249016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1249019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1249044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249055 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1249058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249080 */     // GIR_Coverage, 20180,
     /* 1249080 */     GIR_EraseRootFromParent_Done,
     /* 1249081 */   // Label 17976: @1249081
     /* 1249081 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1249165), // Rule ID 20181 //
     /* 1249086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1249089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1249097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1249100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1249103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1249128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1249142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249164 */     // GIR_Coverage, 20181,
     /* 1249164 */     GIR_EraseRootFromParent_Done,
     /* 1249165 */   // Label 17977: @1249165
     /* 1249165 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1249249), // Rule ID 20184 //
     /* 1249170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1249173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1249181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1249184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1249187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1249212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249223 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1249226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249248 */     // GIR_Coverage, 20184,
     /* 1249248 */     GIR_EraseRootFromParent_Done,
     /* 1249249 */   // Label 17978: @1249249
     /* 1249249 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1249333), // Rule ID 20185 //
     /* 1249254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1249257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1249265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1249268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1249271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1249296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249307 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1249310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249332 */     // GIR_Coverage, 20185,
     /* 1249332 */     GIR_EraseRootFromParent_Done,
     /* 1249333 */   // Label 17979: @1249333
     /* 1249333 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1249417), // Rule ID 20188 //
     /* 1249338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1249341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1249349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1249352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1249355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249391 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1249394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249416 */     // GIR_Coverage, 20188,
     /* 1249416 */     GIR_EraseRootFromParent_Done,
     /* 1249417 */   // Label 17980: @1249417
     /* 1249417 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1249501), // Rule ID 20189 //
     /* 1249422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1249425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1249433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1249436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1249439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1249478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249500 */     // GIR_Coverage, 20189,
     /* 1249500 */     GIR_EraseRootFromParent_Done,
     /* 1249501 */   // Label 17981: @1249501
     /* 1249501 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1249585), // Rule ID 20192 //
     /* 1249506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1249509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1249517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1249520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1249523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249559 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1249562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249584 */     // GIR_Coverage, 20192,
     /* 1249584 */     GIR_EraseRootFromParent_Done,
     /* 1249585 */   // Label 17982: @1249585
     /* 1249585 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1249669), // Rule ID 20193 //
     /* 1249590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1249593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1249601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1249604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1249607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1249646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249668 */     // GIR_Coverage, 20193,
     /* 1249668 */     GIR_EraseRootFromParent_Done,
     /* 1249669 */   // Label 17983: @1249669
     /* 1249669 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1249753), // Rule ID 20196 //
     /* 1249674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1249677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1249685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1249688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1249691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1249697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249727 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1249730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249752 */     // GIR_Coverage, 20196,
     /* 1249752 */     GIR_EraseRootFromParent_Done,
     /* 1249753 */   // Label 17984: @1249753
     /* 1249753 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1249837), // Rule ID 20197 //
     /* 1249758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1249761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1249769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1249772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1249775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1249778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1249781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1249800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249811 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1249814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249836 */     // GIR_Coverage, 20197,
     /* 1249836 */     GIR_EraseRootFromParent_Done,
     /* 1249837 */   // Label 17985: @1249837
     /* 1249837 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1249921), // Rule ID 20200 //
     /* 1249842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1249845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1249853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1249856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1249859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1249884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1249898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249920 */     // GIR_Coverage, 20200,
     /* 1249920 */     GIR_EraseRootFromParent_Done,
     /* 1249921 */   // Label 17986: @1249921
     /* 1249921 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1250005), // Rule ID 20201 //
     /* 1249926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1249929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1249934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1249937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1249940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1249943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1249968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1249982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250004 */     // GIR_Coverage, 20201,
     /* 1250004 */     GIR_EraseRootFromParent_Done,
     /* 1250005 */   // Label 17987: @1250005
     /* 1250005 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1250089), // Rule ID 20204 //
     /* 1250010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1250013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1250027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1250052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250063 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1250066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250088 */     // GIR_Coverage, 20204,
     /* 1250088 */     GIR_EraseRootFromParent_Done,
     /* 1250089 */   // Label 17988: @1250089
     /* 1250089 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1250173), // Rule ID 20205 //
     /* 1250094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1250097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1250111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1250136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1250150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250172 */     // GIR_Coverage, 20205,
     /* 1250172 */     GIR_EraseRootFromParent_Done,
     /* 1250173 */   // Label 17989: @1250173
     /* 1250173 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1250257), // Rule ID 20208 //
     /* 1250178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1250181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1250189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1250192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1250195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1250220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1250234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250256 */     // GIR_Coverage, 20208,
     /* 1250256 */     GIR_EraseRootFromParent_Done,
     /* 1250257 */   // Label 17990: @1250257
     /* 1250257 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1250341), // Rule ID 20209 //
     /* 1250262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1250265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1250273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1250276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1250279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1250304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1250318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250340 */     // GIR_Coverage, 20209,
     /* 1250340 */     GIR_EraseRootFromParent_Done,
     /* 1250341 */   // Label 17991: @1250341
     /* 1250341 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1250425), // Rule ID 20212 //
     /* 1250346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1250349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1250363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1250402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250424 */     // GIR_Coverage, 20212,
     /* 1250424 */     GIR_EraseRootFromParent_Done,
     /* 1250425 */   // Label 17992: @1250425
     /* 1250425 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1250509), // Rule ID 20213 //
     /* 1250430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1250433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1250447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250483 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1250486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250508 */     // GIR_Coverage, 20213,
     /* 1250508 */     GIR_EraseRootFromParent_Done,
     /* 1250509 */   // Label 17993: @1250509
     /* 1250509 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1250593), // Rule ID 20216 //
     /* 1250514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1250517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1250531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250567 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1250570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250592 */     // GIR_Coverage, 20216,
     /* 1250592 */     GIR_EraseRootFromParent_Done,
     /* 1250593 */   // Label 17994: @1250593
     /* 1250593 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1250677), // Rule ID 20217 //
     /* 1250598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1250601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1250615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250651 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1250654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250676 */     // GIR_Coverage, 20217,
     /* 1250676 */     GIR_EraseRootFromParent_Done,
     /* 1250677 */   // Label 17995: @1250677
     /* 1250677 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1250761), // Rule ID 20220 //
     /* 1250682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1250685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1250699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250735 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1250738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250760 */     // GIR_Coverage, 20220,
     /* 1250760 */     GIR_EraseRootFromParent_Done,
     /* 1250761 */   // Label 17996: @1250761
     /* 1250761 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1250845), // Rule ID 20221 //
     /* 1250766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1250769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1250774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1250783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1250808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1250822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250844 */     // GIR_Coverage, 20221,
     /* 1250844 */     GIR_EraseRootFromParent_Done,
     /* 1250845 */   // Label 17997: @1250845
     /* 1250845 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1250929), // Rule ID 20224 //
     /* 1250850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1250853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1250858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1250870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250903 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1250906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1250912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1250914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250928 */     // GIR_Coverage, 20224,
     /* 1250928 */     GIR_EraseRootFromParent_Done,
     /* 1250929 */   // Label 17998: @1250929
     /* 1250929 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1251013), // Rule ID 20225 //
     /* 1250934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1250937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1250942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1250954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1250990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1250996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1250998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251012 */     // GIR_Coverage, 20225,
     /* 1251012 */     GIR_EraseRootFromParent_Done,
     /* 1251013 */   // Label 17999: @1251013
     /* 1251013 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1251097), // Rule ID 20228 //
     /* 1251018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1251021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1251035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1251038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251071 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1251074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251096 */     // GIR_Coverage, 20228,
     /* 1251096 */     GIR_EraseRootFromParent_Done,
     /* 1251097 */   // Label 18000: @1251097
     /* 1251097 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1251181), // Rule ID 20229 //
     /* 1251102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1251105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1251119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1251122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1251158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251180 */     // GIR_Coverage, 20229,
     /* 1251180 */     GIR_EraseRootFromParent_Done,
     /* 1251181 */   // Label 18001: @1251181
     /* 1251181 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1251265), // Rule ID 20232 //
     /* 1251186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1251189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1251203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1251206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1251242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251264 */     // GIR_Coverage, 20232,
     /* 1251264 */     GIR_EraseRootFromParent_Done,
     /* 1251265 */   // Label 18002: @1251265
     /* 1251265 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1251349), // Rule ID 20233 //
     /* 1251270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1251273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1251287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1251290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251323 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1251326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251348 */     // GIR_Coverage, 20233,
     /* 1251348 */     GIR_EraseRootFromParent_Done,
     /* 1251349 */   // Label 18003: @1251349
     /* 1251349 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1251433), // Rule ID 20236 //
     /* 1251354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1251357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1251365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1251368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1251371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1251374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251432 */     // GIR_Coverage, 20236,
     /* 1251432 */     GIR_EraseRootFromParent_Done,
     /* 1251433 */   // Label 18004: @1251433
     /* 1251433 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1251517), // Rule ID 20237 //
     /* 1251438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1251441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1251449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1251452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1251455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1251458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251491 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251516 */     // GIR_Coverage, 20237,
     /* 1251516 */     GIR_EraseRootFromParent_Done,
     /* 1251517 */   // Label 18005: @1251517
     /* 1251517 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1251601), // Rule ID 20240 //
     /* 1251522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1251525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1251542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251600 */     // GIR_Coverage, 20240,
     /* 1251600 */     GIR_EraseRootFromParent_Done,
     /* 1251601 */   // Label 18006: @1251601
     /* 1251601 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1251685), // Rule ID 20241 //
     /* 1251606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1251609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1251626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251684 */     // GIR_Coverage, 20241,
     /* 1251684 */     GIR_EraseRootFromParent_Done,
     /* 1251685 */   // Label 18007: @1251685
     /* 1251685 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1251769), // Rule ID 20244 //
     /* 1251690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1251693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1251710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251743 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251768 */     // GIR_Coverage, 20244,
     /* 1251768 */     GIR_EraseRootFromParent_Done,
     /* 1251769 */   // Label 18008: @1251769
     /* 1251769 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1251853), // Rule ID 20245 //
     /* 1251774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1251777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1251794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251827 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1251830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251852 */     // GIR_Coverage, 20245,
     /* 1251852 */     GIR_EraseRootFromParent_Done,
     /* 1251853 */   // Label 18009: @1251853
     /* 1251853 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1251937), // Rule ID 20248 //
     /* 1251858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1251861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1251869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1251872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1251878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1251914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1251920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1251922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251936 */     // GIR_Coverage, 20248,
     /* 1251936 */     GIR_EraseRootFromParent_Done,
     /* 1251937 */   // Label 18010: @1251937
     /* 1251937 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1252021), // Rule ID 20249 //
     /* 1251942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1251945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1251950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1251953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1251956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1251962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251995 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1251998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252020 */     // GIR_Coverage, 20249,
     /* 1252020 */     GIR_EraseRootFromParent_Done,
     /* 1252021 */   // Label 18011: @1252021
     /* 1252021 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1252105), // Rule ID 20252 //
     /* 1252026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1252029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1252046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1252082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252104 */     // GIR_Coverage, 20252,
     /* 1252104 */     GIR_EraseRootFromParent_Done,
     /* 1252105 */   // Label 18012: @1252105
     /* 1252105 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1252189), // Rule ID 20253 //
     /* 1252110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1252113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1252130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252163 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1252166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252188 */     // GIR_Coverage, 20253,
     /* 1252188 */     GIR_EraseRootFromParent_Done,
     /* 1252189 */   // Label 18013: @1252189
     /* 1252189 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1252273), // Rule ID 20256 //
     /* 1252194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1252197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1252214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252247 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1252250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252272 */     // GIR_Coverage, 20256,
     /* 1252272 */     GIR_EraseRootFromParent_Done,
     /* 1252273 */   // Label 18014: @1252273
     /* 1252273 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1252357), // Rule ID 20257 //
     /* 1252278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1252281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1252298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252331 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1252334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252356 */     // GIR_Coverage, 20257,
     /* 1252356 */     GIR_EraseRootFromParent_Done,
     /* 1252357 */   // Label 18015: @1252357
     /* 1252357 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1252441), // Rule ID 20260 //
     /* 1252362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1252365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1252382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1252418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252440 */     // GIR_Coverage, 20260,
     /* 1252440 */     GIR_EraseRootFromParent_Done,
     /* 1252441 */   // Label 18016: @1252441
     /* 1252441 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1252525), // Rule ID 20261 //
     /* 1252446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1252449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1252466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1252502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252524 */     // GIR_Coverage, 20261,
     /* 1252524 */     GIR_EraseRootFromParent_Done,
     /* 1252525 */   // Label 18017: @1252525
     /* 1252525 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1252609), // Rule ID 20264 //
     /* 1252530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1252533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1252550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252583 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1252586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252608 */     // GIR_Coverage, 20264,
     /* 1252608 */     GIR_EraseRootFromParent_Done,
     /* 1252609 */   // Label 18018: @1252609
     /* 1252609 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1252693), // Rule ID 20265 //
     /* 1252614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1252617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1252634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252667 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1252670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252692 */     // GIR_Coverage, 20265,
     /* 1252692 */     GIR_EraseRootFromParent_Done,
     /* 1252693 */   // Label 18019: @1252693
     /* 1252693 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1252777), // Rule ID 20268 //
     /* 1252698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1252701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1252718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252751 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1252754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252776 */     // GIR_Coverage, 20268,
     /* 1252776 */     GIR_EraseRootFromParent_Done,
     /* 1252777 */   // Label 18020: @1252777
     /* 1252777 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1252861), // Rule ID 20269 //
     /* 1252782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1252785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1252802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252835 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1252838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252860 */     // GIR_Coverage, 20269,
     /* 1252860 */     GIR_EraseRootFromParent_Done,
     /* 1252861 */   // Label 18021: @1252861
     /* 1252861 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1252945), // Rule ID 20272 //
     /* 1252866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1252869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1252886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252919 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1252922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1252928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1252930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252944 */     // GIR_Coverage, 20272,
     /* 1252944 */     GIR_EraseRootFromParent_Done,
     /* 1252945 */   // Label 18022: @1252945
     /* 1252945 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1253029), // Rule ID 20273 //
     /* 1252950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1252953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1252958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1252970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1253006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253028 */     // GIR_Coverage, 20273,
     /* 1253028 */     GIR_EraseRootFromParent_Done,
     /* 1253029 */   // Label 18023: @1253029
     /* 1253029 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1253113), // Rule ID 20276 //
     /* 1253034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1253037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1253042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1253054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1253090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253112 */     // GIR_Coverage, 20276,
     /* 1253112 */     GIR_EraseRootFromParent_Done,
     /* 1253113 */   // Label 18024: @1253113
     /* 1253113 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1253197), // Rule ID 20277 //
     /* 1253118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1253121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1253126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1253138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253171 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1253174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253196 */     // GIR_Coverage, 20277,
     /* 1253196 */     GIR_EraseRootFromParent_Done,
     /* 1253197 */   // Label 18025: @1253197
     /* 1253197 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1253281), // Rule ID 20280 //
     /* 1253202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1253205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1253210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1253222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253255 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1253258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253280 */     // GIR_Coverage, 20280,
     /* 1253280 */     GIR_EraseRootFromParent_Done,
     /* 1253281 */   // Label 18026: @1253281
     /* 1253281 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1253365), // Rule ID 20281 //
     /* 1253286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1253289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1253294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1253306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253339 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1253342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253364 */     // GIR_Coverage, 20281,
     /* 1253364 */     GIR_EraseRootFromParent_Done,
     /* 1253365 */   // Label 18027: @1253365
     /* 1253365 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1253449), // Rule ID 20284 //
     /* 1253370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1253373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253423 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1253426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253448 */     // GIR_Coverage, 20284,
     /* 1253448 */     GIR_EraseRootFromParent_Done,
     /* 1253449 */   // Label 18028: @1253449
     /* 1253449 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1253533), // Rule ID 20285 //
     /* 1253454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1253457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253507 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1253510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253532 */     // GIR_Coverage, 20285,
     /* 1253532 */     GIR_EraseRootFromParent_Done,
     /* 1253533 */   // Label 18029: @1253533
     /* 1253533 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1253617), // Rule ID 20288 //
     /* 1253538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1253541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253591 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1253594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253616 */     // GIR_Coverage, 20288,
     /* 1253616 */     GIR_EraseRootFromParent_Done,
     /* 1253617 */   // Label 18030: @1253617
     /* 1253617 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1253701), // Rule ID 20289 //
     /* 1253622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1253625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253675 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1253678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253700 */     // GIR_Coverage, 20289,
     /* 1253700 */     GIR_EraseRootFromParent_Done,
     /* 1253701 */   // Label 18031: @1253701
     /* 1253701 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1253785), // Rule ID 20292 //
     /* 1253706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1253709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1253762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253784 */     // GIR_Coverage, 20292,
     /* 1253784 */     GIR_EraseRootFromParent_Done,
     /* 1253785 */   // Label 18032: @1253785
     /* 1253785 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1253869), // Rule ID 20293 //
     /* 1253790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1253793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253843 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1253846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253868 */     // GIR_Coverage, 20293,
     /* 1253868 */     GIR_EraseRootFromParent_Done,
     /* 1253869 */   // Label 18033: @1253869
     /* 1253869 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1253953), // Rule ID 20296 //
     /* 1253874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1253877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253927 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1253930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1253936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1253938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253952 */     // GIR_Coverage, 20296,
     /* 1253952 */     GIR_EraseRootFromParent_Done,
     /* 1253953 */   // Label 18034: @1253953
     /* 1253953 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1254037), // Rule ID 20297 //
     /* 1253958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1253961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1253966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1254014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254036 */     // GIR_Coverage, 20297,
     /* 1254036 */     GIR_EraseRootFromParent_Done,
     /* 1254037 */   // Label 18035: @1254037
     /* 1254037 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1254121), // Rule ID 20300 //
     /* 1254042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1254045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254095 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1254098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254120 */     // GIR_Coverage, 20300,
     /* 1254120 */     GIR_EraseRootFromParent_Done,
     /* 1254121 */   // Label 18036: @1254121
     /* 1254121 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1254205), // Rule ID 20301 //
     /* 1254126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1254129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254179 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1254182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254204 */     // GIR_Coverage, 20301,
     /* 1254204 */     GIR_EraseRootFromParent_Done,
     /* 1254205 */   // Label 18037: @1254205
     /* 1254205 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1254289), // Rule ID 20304 //
     /* 1254210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1254213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254263 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1254266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254288 */     // GIR_Coverage, 20304,
     /* 1254288 */     GIR_EraseRootFromParent_Done,
     /* 1254289 */   // Label 18038: @1254289
     /* 1254289 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1254373), // Rule ID 20305 //
     /* 1254294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1254297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254347 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1254350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254372 */     // GIR_Coverage, 20305,
     /* 1254372 */     GIR_EraseRootFromParent_Done,
     /* 1254373 */   // Label 18039: @1254373
     /* 1254373 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1254457), // Rule ID 20308 //
     /* 1254378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1254381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254431 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1254434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254456 */     // GIR_Coverage, 20308,
     /* 1254456 */     GIR_EraseRootFromParent_Done,
     /* 1254457 */   // Label 18040: @1254457
     /* 1254457 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1254541), // Rule ID 20309 //
     /* 1254462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1254465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1254518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254540 */     // GIR_Coverage, 20309,
     /* 1254540 */     GIR_EraseRootFromParent_Done,
     /* 1254541 */   // Label 18041: @1254541
     /* 1254541 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1254625), // Rule ID 20312 //
     /* 1254546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1254549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1254563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1254566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254599 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1254602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254624 */     // GIR_Coverage, 20312,
     /* 1254624 */     GIR_EraseRootFromParent_Done,
     /* 1254625 */   // Label 18042: @1254625
     /* 1254625 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1254709), // Rule ID 20313 //
     /* 1254630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1254633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1254647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1254650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254683 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1254686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254708 */     // GIR_Coverage, 20313,
     /* 1254708 */     GIR_EraseRootFromParent_Done,
     /* 1254709 */   // Label 18043: @1254709
     /* 1254709 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1254793), // Rule ID 20316 //
     /* 1254714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1254717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1254731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1254734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254767 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1254770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254792 */     // GIR_Coverage, 20316,
     /* 1254792 */     GIR_EraseRootFromParent_Done,
     /* 1254793 */   // Label 18044: @1254793
     /* 1254793 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1254877), // Rule ID 20317 //
     /* 1254798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1254801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1254815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1254818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254851 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1254854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254876 */     // GIR_Coverage, 20317,
     /* 1254876 */     GIR_EraseRootFromParent_Done,
     /* 1254877 */   // Label 18045: @1254877
     /* 1254877 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1254961), // Rule ID 20320 //
     /* 1254882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1254885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1254899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1254902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254935 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1254938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1254944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1254946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254960 */     // GIR_Coverage, 20320,
     /* 1254960 */     GIR_EraseRootFromParent_Done,
     /* 1254961 */   // Label 18046: @1254961
     /* 1254961 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1255045), // Rule ID 20321 //
     /* 1254966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1254969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1254974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1254983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1254986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255019 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1255022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255044 */     // GIR_Coverage, 20321,
     /* 1255044 */     GIR_EraseRootFromParent_Done,
     /* 1255045 */   // Label 18047: @1255045
     /* 1255045 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1255129), // Rule ID 20324 //
     /* 1255050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1255053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255103 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1255106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255128 */     // GIR_Coverage, 20324,
     /* 1255128 */     GIR_EraseRootFromParent_Done,
     /* 1255129 */   // Label 18048: @1255129
     /* 1255129 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1255213), // Rule ID 20325 //
     /* 1255134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1255137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1255190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255212 */     // GIR_Coverage, 20325,
     /* 1255212 */     GIR_EraseRootFromParent_Done,
     /* 1255213 */   // Label 18049: @1255213
     /* 1255213 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1255297), // Rule ID 20328 //
     /* 1255218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1255221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255271 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1255274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255296 */     // GIR_Coverage, 20328,
     /* 1255296 */     GIR_EraseRootFromParent_Done,
     /* 1255297 */   // Label 18050: @1255297
     /* 1255297 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1255381), // Rule ID 20329 //
     /* 1255302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1255305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255355 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1255358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255380 */     // GIR_Coverage, 20329,
     /* 1255380 */     GIR_EraseRootFromParent_Done,
     /* 1255381 */   // Label 18051: @1255381
     /* 1255381 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1255465), // Rule ID 20332 //
     /* 1255386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1255389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1255442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255464 */     // GIR_Coverage, 20332,
     /* 1255464 */     GIR_EraseRootFromParent_Done,
     /* 1255465 */   // Label 18052: @1255465
     /* 1255465 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1255549), // Rule ID 20333 //
     /* 1255470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1255473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255523 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1255526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255548 */     // GIR_Coverage, 20333,
     /* 1255548 */     GIR_EraseRootFromParent_Done,
     /* 1255549 */   // Label 18053: @1255549
     /* 1255549 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1255633), // Rule ID 20336 //
     /* 1255554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1255557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1255571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1255574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1255610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255632 */     // GIR_Coverage, 20336,
     /* 1255632 */     GIR_EraseRootFromParent_Done,
     /* 1255633 */   // Label 18054: @1255633
     /* 1255633 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1255717), // Rule ID 20337 //
     /* 1255638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1255641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1255655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1255658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255691 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1255694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255716 */     // GIR_Coverage, 20337,
     /* 1255716 */     GIR_EraseRootFromParent_Done,
     /* 1255717 */   // Label 18055: @1255717
     /* 1255717 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1255801), // Rule ID 20340 //
     /* 1255722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1255725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1255739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1255742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255775 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1255778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255800 */     // GIR_Coverage, 20340,
     /* 1255800 */     GIR_EraseRootFromParent_Done,
     /* 1255801 */   // Label 18056: @1255801
     /* 1255801 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1255885), // Rule ID 20341 //
     /* 1255806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1255809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1255814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1255823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1255826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1255862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1255868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1255870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255884 */     // GIR_Coverage, 20341,
     /* 1255884 */     GIR_EraseRootFromParent_Done,
     /* 1255885 */   // Label 18057: @1255885
     /* 1255885 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1255966), // Rule ID 20398 //
     /* 1255890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1255893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1255898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1255901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1255904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1255907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1255910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1255920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255943 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1255943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1255946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255965 */     // GIR_Coverage, 20398,
     /* 1255965 */     GIR_EraseRootFromParent_Done,
     /* 1255966 */   // Label 18058: @1255966
     /* 1255966 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1256047), // Rule ID 20399 //
     /* 1255971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1255974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1255979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1255982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1255985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1255988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1255991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256024 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1256024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1256027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256046 */     // GIR_Coverage, 20399,
     /* 1256046 */     GIR_EraseRootFromParent_Done,
     /* 1256047 */   // Label 18059: @1256047
     /* 1256047 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1256128), // Rule ID 20400 //
     /* 1256052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1256055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1256063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1256066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1256072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1256094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256105 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1256105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1256108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256127 */     // GIR_Coverage, 20400,
     /* 1256127 */     GIR_EraseRootFromParent_Done,
     /* 1256128 */   // Label 18060: @1256128
     /* 1256128 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1256209), // Rule ID 20401 //
     /* 1256133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1256136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1256144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1256147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1256153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1256175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1256186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1256189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256208 */     // GIR_Coverage, 20401,
     /* 1256208 */     GIR_EraseRootFromParent_Done,
     /* 1256209 */   // Label 18061: @1256209
     /* 1256209 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1256290), // Rule ID 20402 //
     /* 1256214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1256217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1256225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1256228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1256231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1256234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256267 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1256267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1256270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256289 */     // GIR_Coverage, 20402,
     /* 1256289 */     GIR_EraseRootFromParent_Done,
     /* 1256290 */   // Label 18062: @1256290
     /* 1256290 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1256371), // Rule ID 20403 //
     /* 1256295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1256298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1256306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1256309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1256312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1256315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256348 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1256348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1256351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256370 */     // GIR_Coverage, 20403,
     /* 1256370 */     GIR_EraseRootFromParent_Done,
     /* 1256371 */   // Label 18063: @1256371
     /* 1256371 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1256452), // Rule ID 20404 //
     /* 1256376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1256379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1256387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1256390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1256393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1256396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1256418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256429 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1256429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1256432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256451 */     // GIR_Coverage, 20404,
     /* 1256451 */     GIR_EraseRootFromParent_Done,
     /* 1256452 */   // Label 18064: @1256452
     /* 1256452 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1256533), // Rule ID 20405 //
     /* 1256457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1256460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1256468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1256471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1256474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1256477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1256499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256510 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1256510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1256513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256532 */     // GIR_Coverage, 20405,
     /* 1256532 */     GIR_EraseRootFromParent_Done,
     /* 1256533 */   // Label 18065: @1256533
     /* 1256533 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1256614), // Rule ID 20406 //
     /* 1256538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1256541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1256549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1256552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1256555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1256558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256591 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1256591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1256594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256613 */     // GIR_Coverage, 20406,
     /* 1256613 */     GIR_EraseRootFromParent_Done,
     /* 1256614 */   // Label 18066: @1256614
     /* 1256614 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1256695), // Rule ID 20407 //
     /* 1256619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1256622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1256630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1256633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1256636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1256639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256672 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1256672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1256675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256694 */     // GIR_Coverage, 20407,
     /* 1256694 */     GIR_EraseRootFromParent_Done,
     /* 1256695 */   // Label 18067: @1256695
     /* 1256695 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1256776), // Rule ID 20408 //
     /* 1256700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1256703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1256711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1256714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1256717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1256742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256753 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1256753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1256756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256775 */     // GIR_Coverage, 20408,
     /* 1256775 */     GIR_EraseRootFromParent_Done,
     /* 1256776 */   // Label 18068: @1256776
     /* 1256776 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1256857), // Rule ID 20409 //
     /* 1256781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1256784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1256789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1256792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1256795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1256798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1256823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256834 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1256834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1256837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256856 */     // GIR_Coverage, 20409,
     /* 1256856 */     GIR_EraseRootFromParent_Done,
     /* 1256857 */   // Label 18069: @1256857
     /* 1256857 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1256938), // Rule ID 20410 //
     /* 1256862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1256865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1256873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1256876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1256879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1256882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256915 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1256915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1256918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256937 */     // GIR_Coverage, 20410,
     /* 1256937 */     GIR_EraseRootFromParent_Done,
     /* 1256938 */   // Label 18070: @1256938
     /* 1256938 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1257019), // Rule ID 20411 //
     /* 1256943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1256946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1256951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1256954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1256957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1256960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1256963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1256973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1256996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1256999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257018 */     // GIR_Coverage, 20411,
     /* 1257018 */     GIR_EraseRootFromParent_Done,
     /* 1257019 */   // Label 18071: @1257019
     /* 1257019 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1257100), // Rule ID 20412 //
     /* 1257024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1257027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1257035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1257038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1257044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1257066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257077 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1257077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1257080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257099 */     // GIR_Coverage, 20412,
     /* 1257099 */     GIR_EraseRootFromParent_Done,
     /* 1257100 */   // Label 18072: @1257100
     /* 1257100 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1257181), // Rule ID 20413 //
     /* 1257105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1257108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1257116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1257119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1257125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1257147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10902:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1257158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1257161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257180 */     // GIR_Coverage, 20413,
     /* 1257180 */     GIR_EraseRootFromParent_Done,
     /* 1257181 */   // Label 18073: @1257181
     /* 1257181 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1257262), // Rule ID 20414 //
     /* 1257186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1257189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1257197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1257200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1257206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257239 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1257239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1257242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257261 */     // GIR_Coverage, 20414,
     /* 1257261 */     GIR_EraseRootFromParent_Done,
     /* 1257262 */   // Label 18074: @1257262
     /* 1257262 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1257343), // Rule ID 20415 //
     /* 1257267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1257270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1257278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1257281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1257287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1257320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1257323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257342 */     // GIR_Coverage, 20415,
     /* 1257342 */     GIR_EraseRootFromParent_Done,
     /* 1257343 */   // Label 18075: @1257343
     /* 1257343 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1257424), // Rule ID 20416 //
     /* 1257348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1257351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1257359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1257362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1257390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257401 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1257401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1257404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257423 */     // GIR_Coverage, 20416,
     /* 1257423 */     GIR_EraseRootFromParent_Done,
     /* 1257424 */   // Label 18076: @1257424
     /* 1257424 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1257505), // Rule ID 20417 //
     /* 1257429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1257432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1257440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1257443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1257471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257482 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1257482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1257485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257504 */     // GIR_Coverage, 20417,
     /* 1257504 */     GIR_EraseRootFromParent_Done,
     /* 1257505 */   // Label 18077: @1257505
     /* 1257505 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1257586), // Rule ID 20418 //
     /* 1257510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1257513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1257521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1257524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1257530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257563 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1257563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1257566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257585 */     // GIR_Coverage, 20418,
     /* 1257585 */     GIR_EraseRootFromParent_Done,
     /* 1257586 */   // Label 18078: @1257586
     /* 1257586 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1257667), // Rule ID 20419 //
     /* 1257591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1257594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1257602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1257605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1257611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1257644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1257647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257666 */     // GIR_Coverage, 20419,
     /* 1257666 */     GIR_EraseRootFromParent_Done,
     /* 1257667 */   // Label 18079: @1257667
     /* 1257667 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1257748), // Rule ID 20420 //
     /* 1257672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1257675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1257683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1257686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1257714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257725 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1257725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1257728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257747 */     // GIR_Coverage, 20420,
     /* 1257747 */     GIR_EraseRootFromParent_Done,
     /* 1257748 */   // Label 18080: @1257748
     /* 1257748 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1257829), // Rule ID 20421 //
     /* 1257753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1257756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1257761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1257764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1257767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1257783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1257795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257806 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1257806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1257809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257828 */     // GIR_Coverage, 20421,
     /* 1257828 */     GIR_EraseRootFromParent_Done,
     /* 1257829 */   // Label 18081: @1257829
     /* 1257829 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1257910), // Rule ID 20422 //
     /* 1257834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1257837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1257845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1257848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1257851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1257854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1257864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257887 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1257887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1257890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257909 */     // GIR_Coverage, 20422,
     /* 1257909 */     GIR_EraseRootFromParent_Done,
     /* 1257910 */   // Label 18082: @1257910
     /* 1257910 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1257991), // Rule ID 20423 //
     /* 1257915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1257918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1257923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1257926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1257929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1257932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1257935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1257945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1257968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1257971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257990 */     // GIR_Coverage, 20423,
     /* 1257990 */     GIR_EraseRootFromParent_Done,
     /* 1257991 */   // Label 18083: @1257991
     /* 1257991 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1258072), // Rule ID 20424 //
     /* 1257996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1257999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1258007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1258010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1258026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258049 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1258049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1258052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258071 */     // GIR_Coverage, 20424,
     /* 1258071 */     GIR_EraseRootFromParent_Done,
     /* 1258072 */   // Label 18084: @1258072
     /* 1258072 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1258153), // Rule ID 20425 //
     /* 1258077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1258080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1258088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1258091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1258107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258130 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1258130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1258133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258152 */     // GIR_Coverage, 20425,
     /* 1258152 */     GIR_EraseRootFromParent_Done,
     /* 1258153 */   // Label 18085: @1258153
     /* 1258153 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1258234), // Rule ID 20426 //
     /* 1258158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1258161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1258169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1258172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1258178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1258188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258211 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1258211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1258214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258233 */     // GIR_Coverage, 20426,
     /* 1258233 */     GIR_EraseRootFromParent_Done,
     /* 1258234 */   // Label 18086: @1258234
     /* 1258234 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1258315), // Rule ID 20427 //
     /* 1258239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1258242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1258250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1258253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1258259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1258269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258292 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1258292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1258295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258314 */     // GIR_Coverage, 20427,
     /* 1258314 */     GIR_EraseRootFromParent_Done,
     /* 1258315 */   // Label 18087: @1258315
     /* 1258315 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1258396), // Rule ID 20428 //
     /* 1258320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1258323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1258331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1258334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1258350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258373 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1258373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1258376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258395 */     // GIR_Coverage, 20428,
     /* 1258395 */     GIR_EraseRootFromParent_Done,
     /* 1258396 */   // Label 18088: @1258396
     /* 1258396 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1258477), // Rule ID 20429 //
     /* 1258401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1258404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1258412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1258415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1258431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258454 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1258454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1258457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258476 */     // GIR_Coverage, 20429,
     /* 1258476 */     GIR_EraseRootFromParent_Done,
     /* 1258477 */   // Label 18089: @1258477
     /* 1258477 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1258558), // Rule ID 20430 //
     /* 1258482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1258485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1258493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1258496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1258502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1258512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258535 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1258535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1258538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258557 */     // GIR_Coverage, 20430,
     /* 1258557 */     GIR_EraseRootFromParent_Done,
     /* 1258558 */   // Label 18090: @1258558
     /* 1258558 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1258639), // Rule ID 20431 //
     /* 1258563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1258566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1258574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1258577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1258583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1258593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258616 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1258616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1258619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258638 */     // GIR_Coverage, 20431,
     /* 1258638 */     GIR_EraseRootFromParent_Done,
     /* 1258639 */   // Label 18091: @1258639
     /* 1258639 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1258720), // Rule ID 20432 //
     /* 1258644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1258647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1258655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1258658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1258674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258697 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1258697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1258700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258719 */     // GIR_Coverage, 20432,
     /* 1258719 */     GIR_EraseRootFromParent_Done,
     /* 1258720 */   // Label 18092: @1258720
     /* 1258720 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1258801), // Rule ID 20433 //
     /* 1258725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1258728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1258736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1258739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1258745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1258755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1258767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258778 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1258778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1258781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258800 */     // GIR_Coverage, 20433,
     /* 1258800 */     GIR_EraseRootFromParent_Done,
     /* 1258801 */   // Label 18093: @1258801
     /* 1258801 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1258882), // Rule ID 20434 //
     /* 1258806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1258809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1258817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1258820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1258823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1258826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1258836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1258859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1258862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258881 */     // GIR_Coverage, 20434,
     /* 1258881 */     GIR_EraseRootFromParent_Done,
     /* 1258882 */   // Label 18094: @1258882
     /* 1258882 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1258963), // Rule ID 20435 //
     /* 1258887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1258890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1258895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1258898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1258901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1258904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1258907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1258917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258940 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1258940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1258943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258962 */     // GIR_Coverage, 20435,
     /* 1258962 */     GIR_EraseRootFromParent_Done,
     /* 1258963 */   // Label 18095: @1258963
     /* 1258963 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1259044), // Rule ID 20436 //
     /* 1258968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1258971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1258976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1258979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1258982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1258985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1258998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259021 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1259021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1259024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259043 */     // GIR_Coverage, 20436,
     /* 1259043 */     GIR_EraseRootFromParent_Done,
     /* 1259044 */   // Label 18096: @1259044
     /* 1259044 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1259125), // Rule ID 20437 //
     /* 1259049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1259052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1259060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1259063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1259079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259102 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1259102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1259105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259124 */     // GIR_Coverage, 20437,
     /* 1259124 */     GIR_EraseRootFromParent_Done,
     /* 1259125 */   // Label 18097: @1259125
     /* 1259125 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1259206), // Rule ID 20438 //
     /* 1259130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1259133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1259141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1259144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1259150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1259160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259183 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1259183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1259186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259205 */     // GIR_Coverage, 20438,
     /* 1259205 */     GIR_EraseRootFromParent_Done,
     /* 1259206 */   // Label 18098: @1259206
     /* 1259206 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1259287), // Rule ID 20439 //
     /* 1259211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1259214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1259222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1259225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1259231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1259241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259264 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1259264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1259267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259286 */     // GIR_Coverage, 20439,
     /* 1259286 */     GIR_EraseRootFromParent_Done,
     /* 1259287 */   // Label 18099: @1259287
     /* 1259287 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1259368), // Rule ID 20440 //
     /* 1259292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1259295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1259303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1259306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1259322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259345 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1259345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1259348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259367 */     // GIR_Coverage, 20440,
     /* 1259367 */     GIR_EraseRootFromParent_Done,
     /* 1259368 */   // Label 18100: @1259368
     /* 1259368 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1259449), // Rule ID 20441 //
     /* 1259373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1259376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1259384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1259387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1259403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259426 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1259426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1259429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259448 */     // GIR_Coverage, 20441,
     /* 1259448 */     GIR_EraseRootFromParent_Done,
     /* 1259449 */   // Label 18101: @1259449
     /* 1259449 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1259530), // Rule ID 20442 //
     /* 1259454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1259457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1259465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1259468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1259474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1259484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1259507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1259510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259529 */     // GIR_Coverage, 20442,
     /* 1259529 */     GIR_EraseRootFromParent_Done,
     /* 1259530 */   // Label 18102: @1259530
     /* 1259530 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1259611), // Rule ID 20443 //
     /* 1259535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1259538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1259546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1259549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1259555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1259565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259588 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1259588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1259591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259610 */     // GIR_Coverage, 20443,
     /* 1259610 */     GIR_EraseRootFromParent_Done,
     /* 1259611 */   // Label 18103: @1259611
     /* 1259611 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1259692), // Rule ID 20444 //
     /* 1259616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1259619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1259627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1259630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1259646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259669 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1259669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1259672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259691 */     // GIR_Coverage, 20444,
     /* 1259691 */     GIR_EraseRootFromParent_Done,
     /* 1259692 */   // Label 18104: @1259692
     /* 1259692 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1259773), // Rule ID 20445 //
     /* 1259697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1259700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1259708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1259711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1259727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1259739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259750 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1259750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1259753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259772 */     // GIR_Coverage, 20445,
     /* 1259772 */     GIR_EraseRootFromParent_Done,
     /* 1259773 */   // Label 18105: @1259773
     /* 1259773 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1259854), // Rule ID 20446 //
     /* 1259778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1259781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1259789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1259792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1259798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1259808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259831 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1259831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1259834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259853 */     // GIR_Coverage, 20446,
     /* 1259853 */     GIR_EraseRootFromParent_Done,
     /* 1259854 */   // Label 18106: @1259854
     /* 1259854 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1259935), // Rule ID 20447 //
     /* 1259859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1259862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1259867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1259870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1259873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1259879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1259889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259912 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1259912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1259915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259934 */     // GIR_Coverage, 20447,
     /* 1259934 */     GIR_EraseRootFromParent_Done,
     /* 1259935 */   // Label 18107: @1259935
     /* 1259935 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1260016), // Rule ID 20448 //
     /* 1259940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1259943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1259948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1259951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1259954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1259970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1259982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1259993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1259996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260015 */     // GIR_Coverage, 20448,
     /* 1260015 */     GIR_EraseRootFromParent_Done,
     /* 1260016 */   // Label 18108: @1260016
     /* 1260016 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1260097), // Rule ID 20449 //
     /* 1260021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1260024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1260029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1260032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1260035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1260051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1260063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1260074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1260077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260096 */     // GIR_Coverage, 20449,
     /* 1260096 */     GIR_EraseRootFromParent_Done,
     /* 1260097 */   // Label 18109: @1260097
     /* 1260097 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1260178), // Rule ID 20450 //
     /* 1260102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1260105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1260110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1260113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1260116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1260122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1260132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260155 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1260155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1260158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260177 */     // GIR_Coverage, 20450,
     /* 1260177 */     GIR_EraseRootFromParent_Done,
     /* 1260178 */   // Label 18110: @1260178
     /* 1260178 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1260259), // Rule ID 20451 //
     /* 1260183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1260186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1260191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1260194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1260197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1260203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1260213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260236 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1260236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1260239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260258 */     // GIR_Coverage, 20451,
     /* 1260258 */     GIR_EraseRootFromParent_Done,
     /* 1260259 */   // Label 18111: @1260259
     /* 1260259 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1260340), // Rule ID 20452 //
     /* 1260264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1260267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1260272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1260275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1260278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1260294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1260306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260317 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1260317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1260320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260339 */     // GIR_Coverage, 20452,
     /* 1260339 */     GIR_EraseRootFromParent_Done,
     /* 1260340 */   // Label 18112: @1260340
     /* 1260340 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1260421), // Rule ID 20453 //
     /* 1260345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1260348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1260353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1260356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1260359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1260375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1260387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260398 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1260398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1260401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260420 */     // GIR_Coverage, 20453,
     /* 1260420 */     GIR_EraseRootFromParent_Done,
     /* 1260421 */   // Label 18113: @1260421
     /* 1260421 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1260502), // Rule ID 20454 //
     /* 1260426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1260429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1260434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1260437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1260440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1260446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1260456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260479 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1260479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1260482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260501 */     // GIR_Coverage, 20454,
     /* 1260501 */     GIR_EraseRootFromParent_Done,
     /* 1260502 */   // Label 18114: @1260502
     /* 1260502 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1260583), // Rule ID 20455 //
     /* 1260507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1260510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1260515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1260518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1260521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1260527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1260537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260560 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1260560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1260563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260582 */     // GIR_Coverage, 20455,
     /* 1260582 */     GIR_EraseRootFromParent_Done,
     /* 1260583 */   // Label 18115: @1260583
     /* 1260583 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1260664), // Rule ID 20456 //
     /* 1260588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1260591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1260596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1260599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1260602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1260618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1260630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260641 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1260641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1260644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260663 */     // GIR_Coverage, 20456,
     /* 1260663 */     GIR_EraseRootFromParent_Done,
     /* 1260664 */   // Label 18116: @1260664
     /* 1260664 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1260745), // Rule ID 20457 //
     /* 1260669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1260672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1260677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1260680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1260683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1260699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1260711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260722 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1260722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1260725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260744 */     // GIR_Coverage, 20457,
     /* 1260744 */     GIR_EraseRootFromParent_Done,
     /* 1260745 */   // Label 18117: @1260745
     /* 1260745 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1260829), // Rule ID 21838 //
     /* 1260750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1260758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1260761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1260764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1260770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1260780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260803 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1260803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1260806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1260810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1260827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260828 */     // GIR_Coverage, 21838,
     /* 1260828 */     GIR_EraseRootFromParent_Done,
     /* 1260829 */   // Label 18118: @1260829
     /* 1260829 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1260913), // Rule ID 21839 //
     /* 1260834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1260842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1260845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1260848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1260854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1260864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260887 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1260887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1260890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1260894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1260911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260912 */     // GIR_Coverage, 21839,
     /* 1260912 */     GIR_EraseRootFromParent_Done,
     /* 1260913 */   // Label 18119: @1260913
     /* 1260913 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1260997), // Rule ID 21842 //
     /* 1260918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1260926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1260929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1260932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1260938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1260948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1260971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1260974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1260978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1260995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260996 */     // GIR_Coverage, 21842,
     /* 1260996 */     GIR_EraseRootFromParent_Done,
     /* 1260997 */   // Label 18120: @1260997
     /* 1260997 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1261081), // Rule ID 21843 //
     /* 1261002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1261013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1261016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1261019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261055 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1261058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261080 */     // GIR_Coverage, 21843,
     /* 1261080 */     GIR_EraseRootFromParent_Done,
     /* 1261081 */   // Label 18121: @1261081
     /* 1261081 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1261165), // Rule ID 21846 //
     /* 1261086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261139 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1261142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261164 */     // GIR_Coverage, 21846,
     /* 1261164 */     GIR_EraseRootFromParent_Done,
     /* 1261165 */   // Label 18122: @1261165
     /* 1261165 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1261249), // Rule ID 21847 //
     /* 1261170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261223 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1261226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261248 */     // GIR_Coverage, 21847,
     /* 1261248 */     GIR_EraseRootFromParent_Done,
     /* 1261249 */   // Label 18123: @1261249
     /* 1261249 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1261333), // Rule ID 21850 //
     /* 1261254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1261310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261332 */     // GIR_Coverage, 21850,
     /* 1261332 */     GIR_EraseRootFromParent_Done,
     /* 1261333 */   // Label 18124: @1261333
     /* 1261333 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1261417), // Rule ID 21851 //
     /* 1261338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1261394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261416 */     // GIR_Coverage, 21851,
     /* 1261416 */     GIR_EraseRootFromParent_Done,
     /* 1261417 */   // Label 18125: @1261417
     /* 1261417 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1261501), // Rule ID 21854 //
     /* 1261422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1261433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1261436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1261478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261500 */     // GIR_Coverage, 21854,
     /* 1261500 */     GIR_EraseRootFromParent_Done,
     /* 1261501 */   // Label 18126: @1261501
     /* 1261501 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1261585), // Rule ID 21855 //
     /* 1261506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1261517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1261520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1261562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261584 */     // GIR_Coverage, 21855,
     /* 1261584 */     GIR_EraseRootFromParent_Done,
     /* 1261585 */   // Label 18127: @1261585
     /* 1261585 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1261669), // Rule ID 21858 //
     /* 1261590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1261601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1261604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261643 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1261646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261668 */     // GIR_Coverage, 21858,
     /* 1261668 */     GIR_EraseRootFromParent_Done,
     /* 1261669 */   // Label 18128: @1261669
     /* 1261669 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1261753), // Rule ID 21859 //
     /* 1261674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1261685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1261688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1261730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261752 */     // GIR_Coverage, 21859,
     /* 1261752 */     GIR_EraseRootFromParent_Done,
     /* 1261753 */   // Label 18129: @1261753
     /* 1261753 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1261837), // Rule ID 21862 //
     /* 1261758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261811 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1261814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261836 */     // GIR_Coverage, 21862,
     /* 1261836 */     GIR_EraseRootFromParent_Done,
     /* 1261837 */   // Label 18130: @1261837
     /* 1261837 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1261921), // Rule ID 21863 //
     /* 1261842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1261853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1261856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1261895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1261898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1261919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261920 */     // GIR_Coverage, 21863,
     /* 1261920 */     GIR_EraseRootFromParent_Done,
     /* 1261921 */   // Label 18131: @1261921
     /* 1261921 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1262005), // Rule ID 21866 //
     /* 1261926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1261934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1261937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1261940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1261956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261979 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1261979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1261982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1261986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262004 */     // GIR_Coverage, 21866,
     /* 1262004 */     GIR_EraseRootFromParent_Done,
     /* 1262005 */   // Label 18132: @1262005
     /* 1262005 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1262089), // Rule ID 21867 //
     /* 1262010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1262021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1262024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1262027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1262030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262063 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1262066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262088 */     // GIR_Coverage, 21867,
     /* 1262088 */     GIR_EraseRootFromParent_Done,
     /* 1262089 */   // Label 18133: @1262089
     /* 1262089 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1262173), // Rule ID 21870 //
     /* 1262094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1262097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1262105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1262108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262147 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1262150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262172 */     // GIR_Coverage, 21870,
     /* 1262172 */     GIR_EraseRootFromParent_Done,
     /* 1262173 */   // Label 18134: @1262173
     /* 1262173 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1262257), // Rule ID 21871 //
     /* 1262178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1262181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1262189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1262192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262231 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1262234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262256 */     // GIR_Coverage, 21871,
     /* 1262256 */     GIR_EraseRootFromParent_Done,
     /* 1262257 */   // Label 18135: @1262257
     /* 1262257 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1262341), // Rule ID 21874 //
     /* 1262262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1262318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262340 */     // GIR_Coverage, 21874,
     /* 1262340 */     GIR_EraseRootFromParent_Done,
     /* 1262341 */   // Label 18136: @1262341
     /* 1262341 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1262425), // Rule ID 21875 //
     /* 1262346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1262402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262424 */     // GIR_Coverage, 21875,
     /* 1262424 */     GIR_EraseRootFromParent_Done,
     /* 1262425 */   // Label 18137: @1262425
     /* 1262425 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1262509), // Rule ID 21878 //
     /* 1262430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262483 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1262486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262508 */     // GIR_Coverage, 21878,
     /* 1262508 */     GIR_EraseRootFromParent_Done,
     /* 1262509 */   // Label 18138: @1262509
     /* 1262509 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1262593), // Rule ID 21879 //
     /* 1262514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262567 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1262570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262592 */     // GIR_Coverage, 21879,
     /* 1262592 */     GIR_EraseRootFromParent_Done,
     /* 1262593 */   // Label 18139: @1262593
     /* 1262593 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1262677), // Rule ID 21882 //
     /* 1262598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262651 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1262654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262676 */     // GIR_Coverage, 21882,
     /* 1262676 */     GIR_EraseRootFromParent_Done,
     /* 1262677 */   // Label 18140: @1262677
     /* 1262677 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1262761), // Rule ID 21883 //
     /* 1262682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1262693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1262696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1262702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262735 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11201:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1262738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262760 */     // GIR_Coverage, 21883,
     /* 1262760 */     GIR_EraseRootFromParent_Done,
     /* 1262761 */   // Label 18141: @1262761
     /* 1262761 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1262845), // Rule ID 21886 //
     /* 1262766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1262777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1262780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1262786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262819 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1262822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262844 */     // GIR_Coverage, 21886,
     /* 1262844 */     GIR_EraseRootFromParent_Done,
     /* 1262845 */   // Label 18142: @1262845
     /* 1262845 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1262929), // Rule ID 21887 //
     /* 1262850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1262861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1262864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1262870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262903 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1262903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1262906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1262927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262928 */     // GIR_Coverage, 21887,
     /* 1262928 */     GIR_EraseRootFromParent_Done,
     /* 1262929 */   // Label 18143: @1262929
     /* 1262929 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1263013), // Rule ID 21890 //
     /* 1262934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1262942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1262945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1262948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1262954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1262964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262987 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1262987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1262990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1262994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263012 */     // GIR_Coverage, 21890,
     /* 1263012 */     GIR_EraseRootFromParent_Done,
     /* 1263013 */   // Label 18144: @1263013
     /* 1263013 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1263097), // Rule ID 21891 //
     /* 1263018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1263029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1263032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1263035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1263038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1263074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263096 */     // GIR_Coverage, 21891,
     /* 1263096 */     GIR_EraseRootFromParent_Done,
     /* 1263097 */   // Label 18145: @1263097
     /* 1263097 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1263181), // Rule ID 21894 //
     /* 1263102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1263113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1263116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1263122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263155 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1263158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263180 */     // GIR_Coverage, 21894,
     /* 1263180 */     GIR_EraseRootFromParent_Done,
     /* 1263181 */   // Label 18146: @1263181
     /* 1263181 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1263265), // Rule ID 21895 //
     /* 1263186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1263197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1263200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1263206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1263242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263264 */     // GIR_Coverage, 21895,
     /* 1263264 */     GIR_EraseRootFromParent_Done,
     /* 1263265 */   // Label 18147: @1263265
     /* 1263265 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1263349), // Rule ID 21898 //
     /* 1263270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263323 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1263326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263348 */     // GIR_Coverage, 21898,
     /* 1263348 */     GIR_EraseRootFromParent_Done,
     /* 1263349 */   // Label 18148: @1263349
     /* 1263349 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1263433), // Rule ID 21899 //
     /* 1263354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1263410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263432 */     // GIR_Coverage, 21899,
     /* 1263432 */     GIR_EraseRootFromParent_Done,
     /* 1263433 */   // Label 18149: @1263433
     /* 1263433 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1263517), // Rule ID 21902 //
     /* 1263438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263491 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1263494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263516 */     // GIR_Coverage, 21902,
     /* 1263516 */     GIR_EraseRootFromParent_Done,
     /* 1263517 */   // Label 18150: @1263517
     /* 1263517 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1263601), // Rule ID 21903 //
     /* 1263522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1263578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263600 */     // GIR_Coverage, 21903,
     /* 1263600 */     GIR_EraseRootFromParent_Done,
     /* 1263601 */   // Label 18151: @1263601
     /* 1263601 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1263685), // Rule ID 21906 //
     /* 1263606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1263662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263684 */     // GIR_Coverage, 21906,
     /* 1263684 */     GIR_EraseRootFromParent_Done,
     /* 1263685 */   // Label 18152: @1263685
     /* 1263685 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1263769), // Rule ID 21907 //
     /* 1263690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1263701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1263704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1263710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1263746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263768 */     // GIR_Coverage, 21907,
     /* 1263768 */     GIR_EraseRootFromParent_Done,
     /* 1263769 */   // Label 18153: @1263769
     /* 1263769 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1263853), // Rule ID 21910 //
     /* 1263774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1263785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1263788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1263794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1263830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263852 */     // GIR_Coverage, 21910,
     /* 1263852 */     GIR_EraseRootFromParent_Done,
     /* 1263853 */   // Label 18154: @1263853
     /* 1263853 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1263937), // Rule ID 21911 //
     /* 1263858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1263869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1263872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1263878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263911 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1263911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1263914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1263918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1263935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263936 */     // GIR_Coverage, 21911,
     /* 1263936 */     GIR_EraseRootFromParent_Done,
     /* 1263937 */   // Label 18155: @1263937
     /* 1263937 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1264021), // Rule ID 21914 //
     /* 1263942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1263950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1263953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1263956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1263962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1263972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263995 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1263995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1263998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264020 */     // GIR_Coverage, 21914,
     /* 1264020 */     GIR_EraseRootFromParent_Done,
     /* 1264021 */   // Label 18156: @1264021
     /* 1264021 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1264105), // Rule ID 21915 //
     /* 1264026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1264034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1264037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1264040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1264043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1264046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264079 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1264082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264104 */     // GIR_Coverage, 21915,
     /* 1264104 */     GIR_EraseRootFromParent_Done,
     /* 1264105 */   // Label 18157: @1264105
     /* 1264105 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1264189), // Rule ID 21918 //
     /* 1264110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1264118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1264121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1264124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1264130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264163 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1264163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1264166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264188 */     // GIR_Coverage, 21918,
     /* 1264188 */     GIR_EraseRootFromParent_Done,
     /* 1264189 */   // Label 18158: @1264189
     /* 1264189 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1264273), // Rule ID 21919 //
     /* 1264194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1264202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1264205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1264208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1264214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264247 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1264250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264272 */     // GIR_Coverage, 21919,
     /* 1264272 */     GIR_EraseRootFromParent_Done,
     /* 1264273 */   // Label 18159: @1264273
     /* 1264273 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1264357), // Rule ID 21922 //
     /* 1264278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264331 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1264331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1264334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264356 */     // GIR_Coverage, 21922,
     /* 1264356 */     GIR_EraseRootFromParent_Done,
     /* 1264357 */   // Label 18160: @1264357
     /* 1264357 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1264441), // Rule ID 21923 //
     /* 1264362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264415 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1264418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264440 */     // GIR_Coverage, 21923,
     /* 1264440 */     GIR_EraseRootFromParent_Done,
     /* 1264441 */   // Label 18161: @1264441
     /* 1264441 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1264525), // Rule ID 21926 //
     /* 1264446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1264499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1264502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264524 */     // GIR_Coverage, 21926,
     /* 1264524 */     GIR_EraseRootFromParent_Done,
     /* 1264525 */   // Label 18162: @1264525
     /* 1264525 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1264609), // Rule ID 21927 //
     /* 1264530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264583 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1264586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264608 */     // GIR_Coverage, 21927,
     /* 1264608 */     GIR_EraseRootFromParent_Done,
     /* 1264609 */   // Label 18163: @1264609
     /* 1264609 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1264693), // Rule ID 21930 //
     /* 1264614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264667 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1264667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1264670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264692 */     // GIR_Coverage, 21930,
     /* 1264692 */     GIR_EraseRootFromParent_Done,
     /* 1264693 */   // Label 18164: @1264693
     /* 1264693 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1264777), // Rule ID 21931 //
     /* 1264698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1264709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1264712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264751 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1264754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264776 */     // GIR_Coverage, 21931,
     /* 1264776 */     GIR_EraseRootFromParent_Done,
     /* 1264777 */   // Label 18165: @1264777
     /* 1264777 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1264861), // Rule ID 21934 //
     /* 1264782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1264793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1264796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1264802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1264835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1264838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264860 */     // GIR_Coverage, 21934,
     /* 1264860 */     GIR_EraseRootFromParent_Done,
     /* 1264861 */   // Label 18166: @1264861
     /* 1264861 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1264945), // Rule ID 21935 //
     /* 1264866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1264877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1264880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1264886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1264919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1264922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1264926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1264943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264944 */     // GIR_Coverage, 21935,
     /* 1264944 */     GIR_EraseRootFromParent_Done,
     /* 1264945 */   // Label 18167: @1264945
     /* 1264945 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1265029), // Rule ID 21938 //
     /* 1264950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1264958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1264961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1264964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1264970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1264980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265003 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1265006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265028 */     // GIR_Coverage, 21938,
     /* 1265028 */     GIR_EraseRootFromParent_Done,
     /* 1265029 */   // Label 18168: @1265029
     /* 1265029 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1265113), // Rule ID 21939 //
     /* 1265034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1265045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1265048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1265051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1265054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265087 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1265090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265112 */     // GIR_Coverage, 21939,
     /* 1265112 */     GIR_EraseRootFromParent_Done,
     /* 1265113 */   // Label 18169: @1265113
     /* 1265113 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1265197), // Rule ID 21942 //
     /* 1265118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1265129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1265132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1265174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265196 */     // GIR_Coverage, 21942,
     /* 1265196 */     GIR_EraseRootFromParent_Done,
     /* 1265197 */   // Label 18170: @1265197
     /* 1265197 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1265281), // Rule ID 21943 //
     /* 1265202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1265213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1265216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265255 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1265258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265280 */     // GIR_Coverage, 21943,
     /* 1265280 */     GIR_EraseRootFromParent_Done,
     /* 1265281 */   // Label 18171: @1265281
     /* 1265281 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1265365), // Rule ID 21946 //
     /* 1265286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1265297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1265300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1265306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1265342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265364 */     // GIR_Coverage, 21946,
     /* 1265364 */     GIR_EraseRootFromParent_Done,
     /* 1265365 */   // Label 18172: @1265365
     /* 1265365 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1265449), // Rule ID 21947 //
     /* 1265370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1265381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1265384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1265390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265423 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1265426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265448 */     // GIR_Coverage, 21947,
     /* 1265448 */     GIR_EraseRootFromParent_Done,
     /* 1265449 */   // Label 18173: @1265449
     /* 1265449 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1265533), // Rule ID 21950 //
     /* 1265454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1265465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1265468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1265474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1265510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265532 */     // GIR_Coverage, 21950,
     /* 1265532 */     GIR_EraseRootFromParent_Done,
     /* 1265533 */   // Label 18174: @1265533
     /* 1265533 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1265617), // Rule ID 21951 //
     /* 1265538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1265549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1265552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1265558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265591 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1265594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265616 */     // GIR_Coverage, 21951,
     /* 1265616 */     GIR_EraseRootFromParent_Done,
     /* 1265617 */   // Label 18175: @1265617
     /* 1265617 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1265701), // Rule ID 21954 //
     /* 1265622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1265633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1265636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1265678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265700 */     // GIR_Coverage, 21954,
     /* 1265700 */     GIR_EraseRootFromParent_Done,
     /* 1265701 */   // Label 18176: @1265701
     /* 1265701 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1265785), // Rule ID 21955 //
     /* 1265706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1265717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1265720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1265762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265784 */     // GIR_Coverage, 21955,
     /* 1265784 */     GIR_EraseRootFromParent_Done,
     /* 1265785 */   // Label 18177: @1265785
     /* 1265785 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1265869), // Rule ID 21958 //
     /* 1265790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1265801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1265804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1265810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1265843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1265846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265868 */     // GIR_Coverage, 21958,
     /* 1265868 */     GIR_EraseRootFromParent_Done,
     /* 1265869 */   // Label 18178: @1265869
     /* 1265869 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1265953), // Rule ID 21959 //
     /* 1265874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1265885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1265888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1265894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1265927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1265930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1265934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1265951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265952 */     // GIR_Coverage, 21959,
     /* 1265952 */     GIR_EraseRootFromParent_Done,
     /* 1265953 */   // Label 18179: @1265953
     /* 1265953 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1266037), // Rule ID 21962 //
     /* 1265958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1265966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1265969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1265972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1265978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1265988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1266014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266036 */     // GIR_Coverage, 21962,
     /* 1266036 */     GIR_EraseRootFromParent_Done,
     /* 1266037 */   // Label 18180: @1266037
     /* 1266037 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1266121), // Rule ID 21963 //
     /* 1266042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1266053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1266056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1266059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266095 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1266098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266120 */     // GIR_Coverage, 21963,
     /* 1266120 */     GIR_EraseRootFromParent_Done,
     /* 1266121 */   // Label 18181: @1266121
     /* 1266121 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1266205), // Rule ID 21966 //
     /* 1266126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1266137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1266140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266179 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1266182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266204 */     // GIR_Coverage, 21966,
     /* 1266204 */     GIR_EraseRootFromParent_Done,
     /* 1266205 */   // Label 18182: @1266205
     /* 1266205 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1266289), // Rule ID 21967 //
     /* 1266210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1266221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1266224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266263 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1266266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266288 */     // GIR_Coverage, 21967,
     /* 1266288 */     GIR_EraseRootFromParent_Done,
     /* 1266289 */   // Label 18183: @1266289
     /* 1266289 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1266373), // Rule ID 21970 //
     /* 1266294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1266305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1266308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266347 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1266350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266372 */     // GIR_Coverage, 21970,
     /* 1266372 */     GIR_EraseRootFromParent_Done,
     /* 1266373 */   // Label 18184: @1266373
     /* 1266373 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1266457), // Rule ID 21971 //
     /* 1266378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1266389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1266392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266431 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1266434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266456 */     // GIR_Coverage, 21971,
     /* 1266456 */     GIR_EraseRootFromParent_Done,
     /* 1266457 */   // Label 18185: @1266457
     /* 1266457 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1266541), // Rule ID 21974 //
     /* 1266462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1266518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266540 */     // GIR_Coverage, 21974,
     /* 1266540 */     GIR_EraseRootFromParent_Done,
     /* 1266541 */   // Label 18186: @1266541
     /* 1266541 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1266625), // Rule ID 21975 //
     /* 1266546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1266602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266624 */     // GIR_Coverage, 21975,
     /* 1266624 */     GIR_EraseRootFromParent_Done,
     /* 1266625 */   // Label 18187: @1266625
     /* 1266625 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1266709), // Rule ID 21978 //
     /* 1266630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1266686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266708 */     // GIR_Coverage, 21978,
     /* 1266708 */     GIR_EraseRootFromParent_Done,
     /* 1266709 */   // Label 18188: @1266709
     /* 1266709 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1266793), // Rule ID 21979 //
     /* 1266714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266767 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1266770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266792 */     // GIR_Coverage, 21979,
     /* 1266792 */     GIR_EraseRootFromParent_Done,
     /* 1266793 */   // Label 18189: @1266793
     /* 1266793 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1266877), // Rule ID 21982 //
     /* 1266798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1266851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1266854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266876 */     // GIR_Coverage, 21982,
     /* 1266876 */     GIR_EraseRootFromParent_Done,
     /* 1266877 */   // Label 18190: @1266877
     /* 1266877 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1266961), // Rule ID 21983 //
     /* 1266882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1266893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1266896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266935 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1266935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1266938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1266942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1266959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266960 */     // GIR_Coverage, 21983,
     /* 1266960 */     GIR_EraseRootFromParent_Done,
     /* 1266961 */   // Label 18191: @1266961
     /* 1266961 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1267045), // Rule ID 21986 //
     /* 1266966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1266974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1266977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1266980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1266986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1266996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1267022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267044 */     // GIR_Coverage, 21986,
     /* 1267044 */     GIR_EraseRootFromParent_Done,
     /* 1267045 */   // Label 18192: @1267045
     /* 1267045 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1267129), // Rule ID 21987 //
     /* 1267050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1267061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1267064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1267067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1267070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267103 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1267106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267128 */     // GIR_Coverage, 21987,
     /* 1267128 */     GIR_EraseRootFromParent_Done,
     /* 1267129 */   // Label 18193: @1267129
     /* 1267129 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1267213), // Rule ID 21990 //
     /* 1267134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1267145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1267148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1267154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267187 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1267190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267212 */     // GIR_Coverage, 21990,
     /* 1267212 */     GIR_EraseRootFromParent_Done,
     /* 1267213 */   // Label 18194: @1267213
     /* 1267213 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1267297), // Rule ID 21991 //
     /* 1267218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1267229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1267232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1267238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1267274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267296 */     // GIR_Coverage, 21991,
     /* 1267296 */     GIR_EraseRootFromParent_Done,
     /* 1267297 */   // Label 18195: @1267297
     /* 1267297 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1267381), // Rule ID 21994 //
     /* 1267302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1267313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1267316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1267322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1267358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267380 */     // GIR_Coverage, 21994,
     /* 1267380 */     GIR_EraseRootFromParent_Done,
     /* 1267381 */   // Label 18196: @1267381
     /* 1267381 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1267465), // Rule ID 21995 //
     /* 1267386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1267397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1267400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1267406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267439 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1267442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267464 */     // GIR_Coverage, 21995,
     /* 1267464 */     GIR_EraseRootFromParent_Done,
     /* 1267465 */   // Label 18197: @1267465
     /* 1267465 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1267549), // Rule ID 21998 //
     /* 1267470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267523 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1267526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267548 */     // GIR_Coverage, 21998,
     /* 1267548 */     GIR_EraseRootFromParent_Done,
     /* 1267549 */   // Label 18198: @1267549
     /* 1267549 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1267633), // Rule ID 21999 //
     /* 1267554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1267610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267632 */     // GIR_Coverage, 21999,
     /* 1267632 */     GIR_EraseRootFromParent_Done,
     /* 1267633 */   // Label 18199: @1267633
     /* 1267633 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1267717), // Rule ID 22002 //
     /* 1267638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1267694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267716 */     // GIR_Coverage, 22002,
     /* 1267716 */     GIR_EraseRootFromParent_Done,
     /* 1267717 */   // Label 18200: @1267717
     /* 1267717 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1267801), // Rule ID 22003 //
     /* 1267722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1267778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267800 */     // GIR_Coverage, 22003,
     /* 1267800 */     GIR_EraseRootFromParent_Done,
     /* 1267801 */   // Label 18201: @1267801
     /* 1267801 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1267885), // Rule ID 22006 //
     /* 1267806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267859 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1267859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1267862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267884 */     // GIR_Coverage, 22006,
     /* 1267884 */     GIR_EraseRootFromParent_Done,
     /* 1267885 */   // Label 18202: @1267885
     /* 1267885 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1267969), // Rule ID 22007 //
     /* 1267890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1267898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1267901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1267904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1267910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1267920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1267943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1267946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1267950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1267967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267968 */     // GIR_Coverage, 22007,
     /* 1267968 */     GIR_EraseRootFromParent_Done,
     /* 1267969 */   // Label 18203: @1267969
     /* 1267969 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1268053), // Rule ID 22010 //
     /* 1267974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1267982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1267985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1267988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1267994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1268030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268052 */     // GIR_Coverage, 22010,
     /* 1268052 */     GIR_EraseRootFromParent_Done,
     /* 1268053 */   // Label 18204: @1268053
     /* 1268053 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1268137), // Rule ID 22011 //
     /* 1268058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1268075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268111 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1268114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268136 */     // GIR_Coverage, 22011,
     /* 1268136 */     GIR_EraseRootFromParent_Done,
     /* 1268137 */   // Label 18205: @1268137
     /* 1268137 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1268221), // Rule ID 22014 //
     /* 1268142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268195 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1268198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268220 */     // GIR_Coverage, 22014,
     /* 1268220 */     GIR_EraseRootFromParent_Done,
     /* 1268221 */   // Label 18206: @1268221
     /* 1268221 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1268305), // Rule ID 22015 //
     /* 1268226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268279 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1268282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268304 */     // GIR_Coverage, 22015,
     /* 1268304 */     GIR_EraseRootFromParent_Done,
     /* 1268305 */   // Label 18207: @1268305
     /* 1268305 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1268389), // Rule ID 22018 //
     /* 1268310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268363 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1268366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268388 */     // GIR_Coverage, 22018,
     /* 1268388 */     GIR_EraseRootFromParent_Done,
     /* 1268389 */   // Label 18208: @1268389
     /* 1268389 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1268473), // Rule ID 22019 //
     /* 1268394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268447 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1268450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268472 */     // GIR_Coverage, 22019,
     /* 1268472 */     GIR_EraseRootFromParent_Done,
     /* 1268473 */   // Label 18209: @1268473
     /* 1268473 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1268557), // Rule ID 22022 //
     /* 1268478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1268489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1268492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268531 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1268534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268556 */     // GIR_Coverage, 22022,
     /* 1268556 */     GIR_EraseRootFromParent_Done,
     /* 1268557 */   // Label 18210: @1268557
     /* 1268557 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1268641), // Rule ID 22023 //
     /* 1268562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1268573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1268576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1268618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268640 */     // GIR_Coverage, 22023,
     /* 1268640 */     GIR_EraseRootFromParent_Done,
     /* 1268641 */   // Label 18211: @1268641
     /* 1268641 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1268725), // Rule ID 22026 //
     /* 1268646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1268657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1268660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1268702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268724 */     // GIR_Coverage, 22026,
     /* 1268724 */     GIR_EraseRootFromParent_Done,
     /* 1268725 */   // Label 18212: @1268725
     /* 1268725 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1268809), // Rule ID 22027 //
     /* 1268730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1268741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1268744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1268786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268808 */     // GIR_Coverage, 22027,
     /* 1268808 */     GIR_EraseRootFromParent_Done,
     /* 1268809 */   // Label 18213: @1268809
     /* 1268809 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1268893), // Rule ID 22030 //
     /* 1268814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1268825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1268828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268867 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1268867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1268870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268892 */     // GIR_Coverage, 22030,
     /* 1268892 */     GIR_EraseRootFromParent_Done,
     /* 1268893 */   // Label 18214: @1268893
     /* 1268893 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1268977), // Rule ID 22031 //
     /* 1268898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1268909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1268912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1268928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1268951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1268954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1268958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1268975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268976 */     // GIR_Coverage, 22031,
     /* 1268976 */     GIR_EraseRootFromParent_Done,
     /* 1268977 */   // Label 18215: @1268977
     /* 1268977 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1269061), // Rule ID 22034 //
     /* 1268982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1268990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1268993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1268996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269035 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1269038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269060 */     // GIR_Coverage, 22034,
     /* 1269060 */     GIR_EraseRootFromParent_Done,
     /* 1269061 */   // Label 18216: @1269061
     /* 1269061 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1269145), // Rule ID 22035 //
     /* 1269066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1269077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1269080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1269122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269144 */     // GIR_Coverage, 22035,
     /* 1269144 */     GIR_EraseRootFromParent_Done,
     /* 1269145 */   // Label 18217: @1269145
     /* 1269145 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1269229), // Rule ID 22038 //
     /* 1269150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1269161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1269164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269203 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1269206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269228 */     // GIR_Coverage, 22038,
     /* 1269228 */     GIR_EraseRootFromParent_Done,
     /* 1269229 */   // Label 18218: @1269229
     /* 1269229 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1269313), // Rule ID 22039 //
     /* 1269234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1269245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1269248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269287 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1269290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269312 */     // GIR_Coverage, 22039,
     /* 1269312 */     GIR_EraseRootFromParent_Done,
     /* 1269313 */   // Label 18219: @1269313
     /* 1269313 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1269397), // Rule ID 22042 //
     /* 1269318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1269329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1269332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1269374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269396 */     // GIR_Coverage, 22042,
     /* 1269396 */     GIR_EraseRootFromParent_Done,
     /* 1269397 */   // Label 18220: @1269397
     /* 1269397 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1269481), // Rule ID 22043 //
     /* 1269402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1269413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1269416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269455 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1269458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269480 */     // GIR_Coverage, 22043,
     /* 1269480 */     GIR_EraseRootFromParent_Done,
     /* 1269481 */   // Label 18221: @1269481
     /* 1269481 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1269565), // Rule ID 22046 //
     /* 1269486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1269489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1269497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1269500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269539 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1269542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269564 */     // GIR_Coverage, 22046,
     /* 1269564 */     GIR_EraseRootFromParent_Done,
     /* 1269565 */   // Label 18222: @1269565
     /* 1269565 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1269649), // Rule ID 22047 //
     /* 1269570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1269581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1269584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269623 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1269626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269648 */     // GIR_Coverage, 22047,
     /* 1269648 */     GIR_EraseRootFromParent_Done,
     /* 1269649 */   // Label 18223: @1269649
     /* 1269649 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1269733), // Rule ID 22050 //
     /* 1269654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1269665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1269668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269707 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1269710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269732 */     // GIR_Coverage, 22050,
     /* 1269732 */     GIR_EraseRootFromParent_Done,
     /* 1269733 */   // Label 18224: @1269733
     /* 1269733 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1269817), // Rule ID 22051 //
     /* 1269738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1269749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1269752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269791 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1269794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269816 */     // GIR_Coverage, 22051,
     /* 1269816 */     GIR_EraseRootFromParent_Done,
     /* 1269817 */   // Label 18225: @1269817
     /* 1269817 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1269901), // Rule ID 22054 //
     /* 1269822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1269833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1269836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269875 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1269875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1269878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269900 */     // GIR_Coverage, 22054,
     /* 1269900 */     GIR_EraseRootFromParent_Done,
     /* 1269901 */   // Label 18226: @1269901
     /* 1269901 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1269985), // Rule ID 22055 //
     /* 1269906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1269917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1269920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1269936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1269959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1269962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1269966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1269983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269984 */     // GIR_Coverage, 22055,
     /* 1269984 */     GIR_EraseRootFromParent_Done,
     /* 1269985 */   // Label 18227: @1269985
     /* 1269985 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1270069), // Rule ID 22058 //
     /* 1269990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1269998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1270001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1270004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1270010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270043 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1270046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270068 */     // GIR_Coverage, 22058,
     /* 1270068 */     GIR_EraseRootFromParent_Done,
     /* 1270069 */   // Label 18228: @1270069
     /* 1270069 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1270153), // Rule ID 22059 //
     /* 1270074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1270085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1270088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1270094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1270130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270152 */     // GIR_Coverage, 22059,
     /* 1270152 */     GIR_EraseRootFromParent_Done,
     /* 1270153 */   // Label 18229: @1270153
     /* 1270153 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1270237), // Rule ID 22062 //
     /* 1270158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1270214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270236 */     // GIR_Coverage, 22062,
     /* 1270236 */     GIR_EraseRootFromParent_Done,
     /* 1270237 */   // Label 18230: @1270237
     /* 1270237 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1270321), // Rule ID 22063 //
     /* 1270242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1270298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270320 */     // GIR_Coverage, 22063,
     /* 1270320 */     GIR_EraseRootFromParent_Done,
     /* 1270321 */   // Label 18231: @1270321
     /* 1270321 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1270405), // Rule ID 22066 //
     /* 1270326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270379 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1270382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270404 */     // GIR_Coverage, 22066,
     /* 1270404 */     GIR_EraseRootFromParent_Done,
     /* 1270405 */   // Label 18232: @1270405
     /* 1270405 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1270489), // Rule ID 22067 //
     /* 1270410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270463 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1270466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270488 */     // GIR_Coverage, 22067,
     /* 1270488 */     GIR_EraseRootFromParent_Done,
     /* 1270489 */   // Label 18233: @1270489
     /* 1270489 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1270573), // Rule ID 22070 //
     /* 1270494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270547 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1270550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270572 */     // GIR_Coverage, 22070,
     /* 1270572 */     GIR_EraseRootFromParent_Done,
     /* 1270573 */   // Label 18234: @1270573
     /* 1270573 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1270657), // Rule ID 22071 //
     /* 1270578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1270589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1270592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1270598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270631 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1270634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270656 */     // GIR_Coverage, 22071,
     /* 1270656 */     GIR_EraseRootFromParent_Done,
     /* 1270657 */   // Label 18235: @1270657
     /* 1270657 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1270741), // Rule ID 22074 //
     /* 1270662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1270673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1270676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1270682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1270718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270740 */     // GIR_Coverage, 22074,
     /* 1270740 */     GIR_EraseRootFromParent_Done,
     /* 1270741 */   // Label 18236: @1270741
     /* 1270741 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1270825), // Rule ID 22075 //
     /* 1270746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1270757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1270760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1270766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1270802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270824 */     // GIR_Coverage, 22075,
     /* 1270824 */     GIR_EraseRootFromParent_Done,
     /* 1270825 */   // Label 18237: @1270825
     /* 1270825 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1270909), // Rule ID 22078 //
     /* 1270830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1270841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1270844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1270850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1270883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1270886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270908 */     // GIR_Coverage, 22078,
     /* 1270908 */     GIR_EraseRootFromParent_Done,
     /* 1270909 */   // Label 18238: @1270909
     /* 1270909 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1270993), // Rule ID 22079 //
     /* 1270914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1270922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1270925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1270928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1270934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1270944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270967 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1270967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1270970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1270974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1270991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270992 */     // GIR_Coverage, 22079,
     /* 1270992 */     GIR_EraseRootFromParent_Done,
     /* 1270993 */   // Label 18239: @1270993
     /* 1270993 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1271077), // Rule ID 22082 //
     /* 1270998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1271009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1271012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1271018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271051 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1271054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271076 */     // GIR_Coverage, 22082,
     /* 1271076 */     GIR_EraseRootFromParent_Done,
     /* 1271077 */   // Label 18240: @1271077
     /* 1271077 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1271161), // Rule ID 22083 //
     /* 1271082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1271093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1271096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1271102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271135 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1271138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271160 */     // GIR_Coverage, 22083,
     /* 1271160 */     GIR_EraseRootFromParent_Done,
     /* 1271161 */   // Label 18241: @1271161
     /* 1271161 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1271245), // Rule ID 22086 //
     /* 1271166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271219 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1271222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271244 */     // GIR_Coverage, 22086,
     /* 1271244 */     GIR_EraseRootFromParent_Done,
     /* 1271245 */   // Label 18242: @1271245
     /* 1271245 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1271329), // Rule ID 22087 //
     /* 1271250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271303 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1271306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271328 */     // GIR_Coverage, 22087,
     /* 1271328 */     GIR_EraseRootFromParent_Done,
     /* 1271329 */   // Label 18243: @1271329
     /* 1271329 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1271413), // Rule ID 22090 //
     /* 1271334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271387 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1271390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271412 */     // GIR_Coverage, 22090,
     /* 1271412 */     GIR_EraseRootFromParent_Done,
     /* 1271413 */   // Label 18244: @1271413
     /* 1271413 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1271497), // Rule ID 22091 //
     /* 1271418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271471 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1271474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271496 */     // GIR_Coverage, 22091,
     /* 1271496 */     GIR_EraseRootFromParent_Done,
     /* 1271497 */   // Label 18245: @1271497
     /* 1271497 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1271581), // Rule ID 22094 //
     /* 1271502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271555 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1271558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271580 */     // GIR_Coverage, 22094,
     /* 1271580 */     GIR_EraseRootFromParent_Done,
     /* 1271581 */   // Label 18246: @1271581
     /* 1271581 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1271665), // Rule ID 22095 //
     /* 1271586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1271594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1271597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1271600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1271606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271639 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1271642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271664 */     // GIR_Coverage, 22095,
     /* 1271664 */     GIR_EraseRootFromParent_Done,
     /* 1271665 */   // Label 18247: @1271665
     /* 1271665 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1271749), // Rule ID 22098 //
     /* 1271670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1271678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1271681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1271684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1271690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271723 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1271726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271748 */     // GIR_Coverage, 22098,
     /* 1271748 */     GIR_EraseRootFromParent_Done,
     /* 1271749 */   // Label 18248: @1271749
     /* 1271749 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1271833), // Rule ID 22099 //
     /* 1271754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1271762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1271765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1271768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1271774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1271810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271832 */     // GIR_Coverage, 22099,
     /* 1271832 */     GIR_EraseRootFromParent_Done,
     /* 1271833 */   // Label 18249: @1271833
     /* 1271833 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1271917), // Rule ID 22102 //
     /* 1271838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1271846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1271849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1271852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1271858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271891 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1271891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1271894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271916 */     // GIR_Coverage, 22102,
     /* 1271916 */     GIR_EraseRootFromParent_Done,
     /* 1271917 */   // Label 18250: @1271917
     /* 1271917 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1272001), // Rule ID 22103 //
     /* 1271922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1271930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1271933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1271936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1271942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1271952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271975 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1271975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1271978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1271982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1271999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272000 */     // GIR_Coverage, 22103,
     /* 1272000 */     GIR_EraseRootFromParent_Done,
     /* 1272001 */   // Label 18251: @1272001
     /* 1272001 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1272085), // Rule ID 22106 //
     /* 1272006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1272017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1272020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1272062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272084 */     // GIR_Coverage, 22106,
     /* 1272084 */     GIR_EraseRootFromParent_Done,
     /* 1272085 */   // Label 18252: @1272085
     /* 1272085 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1272169), // Rule ID 22107 //
     /* 1272090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1272101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1272104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272143 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1272146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272168 */     // GIR_Coverage, 22107,
     /* 1272168 */     GIR_EraseRootFromParent_Done,
     /* 1272169 */   // Label 18253: @1272169
     /* 1272169 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1272253), // Rule ID 22110 //
     /* 1272174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1272230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272252 */     // GIR_Coverage, 22110,
     /* 1272252 */     GIR_EraseRootFromParent_Done,
     /* 1272253 */   // Label 18254: @1272253
     /* 1272253 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1272337), // Rule ID 22111 //
     /* 1272258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1272314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272336 */     // GIR_Coverage, 22111,
     /* 1272336 */     GIR_EraseRootFromParent_Done,
     /* 1272337 */   // Label 18255: @1272337
     /* 1272337 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1272421), // Rule ID 22114 //
     /* 1272342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1272398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272420 */     // GIR_Coverage, 22114,
     /* 1272420 */     GIR_EraseRootFromParent_Done,
     /* 1272421 */   // Label 18256: @1272421
     /* 1272421 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1272505), // Rule ID 22115 //
     /* 1272426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272479 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1272482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272504 */     // GIR_Coverage, 22115,
     /* 1272504 */     GIR_EraseRootFromParent_Done,
     /* 1272505 */   // Label 18257: @1272505
     /* 1272505 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1272589), // Rule ID 22118 //
     /* 1272510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1272521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1272524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1272530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1272566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272588 */     // GIR_Coverage, 22118,
     /* 1272588 */     GIR_EraseRootFromParent_Done,
     /* 1272589 */   // Label 18258: @1272589
     /* 1272589 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1272673), // Rule ID 22119 //
     /* 1272594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1272605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1272608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1272614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1272650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272672 */     // GIR_Coverage, 22119,
     /* 1272672 */     GIR_EraseRootFromParent_Done,
     /* 1272673 */   // Label 18259: @1272673
     /* 1272673 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1272757), // Rule ID 22122 //
     /* 1272678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1272689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1272692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272731 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1272734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272756 */     // GIR_Coverage, 22122,
     /* 1272756 */     GIR_EraseRootFromParent_Done,
     /* 1272757 */   // Label 18260: @1272757
     /* 1272757 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1272841), // Rule ID 22123 //
     /* 1272762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1272773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1272776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272815 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1272818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272840 */     // GIR_Coverage, 22123,
     /* 1272840 */     GIR_EraseRootFromParent_Done,
     /* 1272841 */   // Label 18261: @1272841
     /* 1272841 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1272925), // Rule ID 22126 //
     /* 1272846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1272899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1272902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1272923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272924 */     // GIR_Coverage, 22126,
     /* 1272924 */     GIR_EraseRootFromParent_Done,
     /* 1272925 */   // Label 18262: @1272925
     /* 1272925 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1273009), // Rule ID 22127 //
     /* 1272930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1272938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1272941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1272944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1272960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1272983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1272986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1272990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273008 */     // GIR_Coverage, 22127,
     /* 1273008 */     GIR_EraseRootFromParent_Done,
     /* 1273009 */   // Label 18263: @1273009
     /* 1273009 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1273093), // Rule ID 22130 //
     /* 1273014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1273025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1273028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1273034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1273070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273092 */     // GIR_Coverage, 22130,
     /* 1273092 */     GIR_EraseRootFromParent_Done,
     /* 1273093 */   // Label 18264: @1273093
     /* 1273093 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1273177), // Rule ID 22131 //
     /* 1273098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1273109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1273112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1273118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273151 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1273154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273176 */     // GIR_Coverage, 22131,
     /* 1273176 */     GIR_EraseRootFromParent_Done,
     /* 1273177 */   // Label 18265: @1273177
     /* 1273177 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1273261), // Rule ID 22134 //
     /* 1273182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1273185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1273193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1273196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1273202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1273238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273260 */     // GIR_Coverage, 22134,
     /* 1273260 */     GIR_EraseRootFromParent_Done,
     /* 1273261 */   // Label 18266: @1273261
     /* 1273261 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1273345), // Rule ID 22135 //
     /* 1273266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1273269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1273277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1273280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1273286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273319 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1273322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273344 */     // GIR_Coverage, 22135,
     /* 1273344 */     GIR_EraseRootFromParent_Done,
     /* 1273345 */   // Label 18267: @1273345
     /* 1273345 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1273429), // Rule ID 22138 //
     /* 1273350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273403 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1273406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273428 */     // GIR_Coverage, 22138,
     /* 1273428 */     GIR_EraseRootFromParent_Done,
     /* 1273429 */   // Label 18268: @1273429
     /* 1273429 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1273513), // Rule ID 22139 //
     /* 1273434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273487 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1273490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273512 */     // GIR_Coverage, 22139,
     /* 1273512 */     GIR_EraseRootFromParent_Done,
     /* 1273513 */   // Label 18269: @1273513
     /* 1273513 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1273597), // Rule ID 22142 //
     /* 1273518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1273574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273596 */     // GIR_Coverage, 22142,
     /* 1273596 */     GIR_EraseRootFromParent_Done,
     /* 1273597 */   // Label 18270: @1273597
     /* 1273597 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1273681), // Rule ID 22143 //
     /* 1273602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273655 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1273658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273680 */     // GIR_Coverage, 22143,
     /* 1273680 */     GIR_EraseRootFromParent_Done,
     /* 1273681 */   // Label 18271: @1273681
     /* 1273681 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1273765), // Rule ID 22146 //
     /* 1273686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273739 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1273742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273764 */     // GIR_Coverage, 22146,
     /* 1273764 */     GIR_EraseRootFromParent_Done,
     /* 1273765 */   // Label 18272: @1273765
     /* 1273765 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1273849), // Rule ID 22147 //
     /* 1273770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1273781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1273784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273823 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1273826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273848 */     // GIR_Coverage, 22147,
     /* 1273848 */     GIR_EraseRootFromParent_Done,
     /* 1273849 */   // Label 18273: @1273849
     /* 1273849 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1273933), // Rule ID 22150 //
     /* 1273854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1273865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1273868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1273874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1273907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1273910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1273931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273932 */     // GIR_Coverage, 22150,
     /* 1273932 */     GIR_EraseRootFromParent_Done,
     /* 1273933 */   // Label 18274: @1273933
     /* 1273933 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1274017), // Rule ID 22151 //
     /* 1273938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1273946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1273949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1273952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1273958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1273968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1273991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1273994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1273998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274016 */     // GIR_Coverage, 22151,
     /* 1274016 */     GIR_EraseRootFromParent_Done,
     /* 1274017 */   // Label 18275: @1274017
     /* 1274017 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1274101), // Rule ID 22154 //
     /* 1274022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1274033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1274036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1274042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1274078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274100 */     // GIR_Coverage, 22154,
     /* 1274100 */     GIR_EraseRootFromParent_Done,
     /* 1274101 */   // Label 18276: @1274101
     /* 1274101 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1274185), // Rule ID 22155 //
     /* 1274106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1274117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1274120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1274126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274159 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1274162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274184 */     // GIR_Coverage, 22155,
     /* 1274184 */     GIR_EraseRootFromParent_Done,
     /* 1274185 */   // Label 18277: @1274185
     /* 1274185 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1274269), // Rule ID 22158 //
     /* 1274190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1274201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1274204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1274210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1274246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274268 */     // GIR_Coverage, 22158,
     /* 1274268 */     GIR_EraseRootFromParent_Done,
     /* 1274269 */   // Label 18278: @1274269
     /* 1274269 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1274353), // Rule ID 22159 //
     /* 1274274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1274285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1274288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1274294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1274330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274352 */     // GIR_Coverage, 22159,
     /* 1274352 */     GIR_EraseRootFromParent_Done,
     /* 1274353 */   // Label 18279: @1274353
     /* 1274353 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1274437), // Rule ID 22162 //
     /* 1274358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1274414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274436 */     // GIR_Coverage, 22162,
     /* 1274436 */     GIR_EraseRootFromParent_Done,
     /* 1274437 */   // Label 18280: @1274437
     /* 1274437 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1274521), // Rule ID 22163 //
     /* 1274442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274495 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1274498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274520 */     // GIR_Coverage, 22163,
     /* 1274520 */     GIR_EraseRootFromParent_Done,
     /* 1274521 */   // Label 18281: @1274521
     /* 1274521 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1274605), // Rule ID 22166 //
     /* 1274526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274579 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1274582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274604 */     // GIR_Coverage, 22166,
     /* 1274604 */     GIR_EraseRootFromParent_Done,
     /* 1274605 */   // Label 18282: @1274605
     /* 1274605 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1274689), // Rule ID 22167 //
     /* 1274610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274663 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1274666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274688 */     // GIR_Coverage, 22167,
     /* 1274688 */     GIR_EraseRootFromParent_Done,
     /* 1274689 */   // Label 18283: @1274689
     /* 1274689 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1274773), // Rule ID 22170 //
     /* 1274694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1274750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274772 */     // GIR_Coverage, 22170,
     /* 1274772 */     GIR_EraseRootFromParent_Done,
     /* 1274773 */   // Label 18284: @1274773
     /* 1274773 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1274857), // Rule ID 22171 //
     /* 1274778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1274789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1274792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1274834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274856 */     // GIR_Coverage, 22171,
     /* 1274856 */     GIR_EraseRootFromParent_Done,
     /* 1274857 */   // Label 18285: @1274857
     /* 1274857 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1274941), // Rule ID 22174 //
     /* 1274862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1274873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1274876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1274882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1274915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1274918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1274922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1274939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274940 */     // GIR_Coverage, 22174,
     /* 1274940 */     GIR_EraseRootFromParent_Done,
     /* 1274941 */   // Label 18286: @1274941
     /* 1274941 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1275025), // Rule ID 22175 //
     /* 1274946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1274954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1274957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1274960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1274966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1274976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1274999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1275002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275024 */     // GIR_Coverage, 22175,
     /* 1275024 */     GIR_EraseRootFromParent_Done,
     /* 1275025 */   // Label 18287: @1275025
     /* 1275025 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1275109), // Rule ID 22178 //
     /* 1275030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1275038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1275041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1275044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1275050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1275086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275108 */     // GIR_Coverage, 22178,
     /* 1275108 */     GIR_EraseRootFromParent_Done,
     /* 1275109 */   // Label 18288: @1275109
     /* 1275109 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1275193), // Rule ID 22179 //
     /* 1275114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1275122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1275125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1275128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1275134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275167 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1275167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1275170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275192 */     // GIR_Coverage, 22179,
     /* 1275192 */     GIR_EraseRootFromParent_Done,
     /* 1275193 */   // Label 18289: @1275193
     /* 1275193 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1275277), // Rule ID 22182 //
     /* 1275198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1275206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1275209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1275212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1275218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1275254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275276 */     // GIR_Coverage, 22182,
     /* 1275276 */     GIR_EraseRootFromParent_Done,
     /* 1275277 */   // Label 18290: @1275277
     /* 1275277 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1275361), // Rule ID 22183 //
     /* 1275282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1275290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1275293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1275296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1275302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275335 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1275335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1275338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275360 */     // GIR_Coverage, 22183,
     /* 1275360 */     GIR_EraseRootFromParent_Done,
     /* 1275361 */   // Label 18291: @1275361
     /* 1275361 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1275445), // Rule ID 22186 //
     /* 1275366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1275422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275444 */     // GIR_Coverage, 22186,
     /* 1275444 */     GIR_EraseRootFromParent_Done,
     /* 1275445 */   // Label 18292: @1275445
     /* 1275445 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1275529), // Rule ID 22187 //
     /* 1275450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275503 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1275503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1275506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275528 */     // GIR_Coverage, 22187,
     /* 1275528 */     GIR_EraseRootFromParent_Done,
     /* 1275529 */   // Label 18293: @1275529
     /* 1275529 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1275613), // Rule ID 22190 //
     /* 1275534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275587 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1275590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275612 */     // GIR_Coverage, 22190,
     /* 1275612 */     GIR_EraseRootFromParent_Done,
     /* 1275613 */   // Label 18294: @1275613
     /* 1275613 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1275697), // Rule ID 22191 //
     /* 1275618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1275671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1275674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275696 */     // GIR_Coverage, 22191,
     /* 1275696 */     GIR_EraseRootFromParent_Done,
     /* 1275697 */   // Label 18295: @1275697
     /* 1275697 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1275781), // Rule ID 22194 //
     /* 1275702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275755 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1275758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275780 */     // GIR_Coverage, 22194,
     /* 1275780 */     GIR_EraseRootFromParent_Done,
     /* 1275781 */   // Label 18296: @1275781
     /* 1275781 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1275865), // Rule ID 22195 //
     /* 1275786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1275797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1275800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275839 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1275839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1275842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275864 */     // GIR_Coverage, 22195,
     /* 1275864 */     GIR_EraseRootFromParent_Done,
     /* 1275865 */   // Label 18297: @1275865
     /* 1275865 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1275949), // Rule ID 22198 //
     /* 1275870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1275881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1275884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1275890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275923 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1275923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1275926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1275930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1275947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275948 */     // GIR_Coverage, 22198,
     /* 1275948 */     GIR_EraseRootFromParent_Done,
     /* 1275949 */   // Label 18298: @1275949
     /* 1275949 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1276033), // Rule ID 22199 //
     /* 1275954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1275962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1275965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1275968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1275974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1275984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276007 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1276010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276032 */     // GIR_Coverage, 22199,
     /* 1276032 */     GIR_EraseRootFromParent_Done,
     /* 1276033 */   // Label 18299: @1276033
     /* 1276033 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1276117), // Rule ID 22202 //
     /* 1276038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1276049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1276052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1276094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276116 */     // GIR_Coverage, 22202,
     /* 1276116 */     GIR_EraseRootFromParent_Done,
     /* 1276117 */   // Label 18300: @1276117
     /* 1276117 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1276201), // Rule ID 22203 //
     /* 1276122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1276133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1276136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1276178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276200 */     // GIR_Coverage, 22203,
     /* 1276200 */     GIR_EraseRootFromParent_Done,
     /* 1276201 */   // Label 18301: @1276201
     /* 1276201 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1276285), // Rule ID 22206 //
     /* 1276206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1276217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1276220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1276262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276284 */     // GIR_Coverage, 22206,
     /* 1276284 */     GIR_EraseRootFromParent_Done,
     /* 1276285 */   // Label 18302: @1276285
     /* 1276285 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1276369), // Rule ID 22207 //
     /* 1276290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1276301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1276304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1276346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276368 */     // GIR_Coverage, 22207,
     /* 1276368 */     GIR_EraseRootFromParent_Done,
     /* 1276369 */   // Label 18303: @1276369
     /* 1276369 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1276453), // Rule ID 22210 //
     /* 1276374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1276385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1276388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1276430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276452 */     // GIR_Coverage, 22210,
     /* 1276452 */     GIR_EraseRootFromParent_Done,
     /* 1276453 */   // Label 18304: @1276453
     /* 1276453 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1276537), // Rule ID 22211 //
     /* 1276458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1276469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1276472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276511 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1276514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276536 */     // GIR_Coverage, 22211,
     /* 1276536 */     GIR_EraseRootFromParent_Done,
     /* 1276537 */   // Label 18305: @1276537
     /* 1276537 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1276621), // Rule ID 22214 //
     /* 1276542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1276553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1276556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1276598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276620 */     // GIR_Coverage, 22214,
     /* 1276620 */     GIR_EraseRootFromParent_Done,
     /* 1276621 */   // Label 18306: @1276621
     /* 1276621 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1276705), // Rule ID 22215 //
     /* 1276626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1276637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1276640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276679 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1276682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276704 */     // GIR_Coverage, 22215,
     /* 1276704 */     GIR_EraseRootFromParent_Done,
     /* 1276705 */   // Label 18307: @1276705
     /* 1276705 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1276789), // Rule ID 22218 //
     /* 1276710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1276721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1276724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276763 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1276766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276788 */     // GIR_Coverage, 22218,
     /* 1276788 */     GIR_EraseRootFromParent_Done,
     /* 1276789 */   // Label 18308: @1276789
     /* 1276789 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1276873), // Rule ID 22219 //
     /* 1276794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1276805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1276808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1276847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1276850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276872 */     // GIR_Coverage, 22219,
     /* 1276872 */     GIR_EraseRootFromParent_Done,
     /* 1276873 */   // Label 18309: @1276873
     /* 1276873 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1276957), // Rule ID 22222 //
     /* 1276878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1276889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1276892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1276931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1276934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1276938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1276955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276956 */     // GIR_Coverage, 22222,
     /* 1276956 */     GIR_EraseRootFromParent_Done,
     /* 1276957 */   // Label 18310: @1276957
     /* 1276957 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1277041), // Rule ID 22223 //
     /* 1276962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1276970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1276973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1276976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1276992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277015 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1277018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1277036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277040 */     // GIR_Coverage, 22223,
     /* 1277040 */     GIR_EraseRootFromParent_Done,
     /* 1277041 */   // Label 18311: @1277041
     /* 1277041 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1277125), // Rule ID 22226 //
     /* 1277046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1277102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277124 */     // GIR_Coverage, 22226,
     /* 1277124 */     GIR_EraseRootFromParent_Done,
     /* 1277125 */   // Label 18312: @1277125
     /* 1277125 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1277209), // Rule ID 22227 //
     /* 1277130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1277186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277208 */     // GIR_Coverage, 22227,
     /* 1277208 */     GIR_EraseRootFromParent_Done,
     /* 1277209 */   // Label 18313: @1277209
     /* 1277209 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1277293), // Rule ID 22230 //
     /* 1277214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277267 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1277270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277292 */     // GIR_Coverage, 22230,
     /* 1277292 */     GIR_EraseRootFromParent_Done,
     /* 1277293 */   // Label 18314: @1277293
     /* 1277293 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1277377), // Rule ID 22231 //
     /* 1277298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277351 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1277354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277376 */     // GIR_Coverage, 22231,
     /* 1277376 */     GIR_EraseRootFromParent_Done,
     /* 1277377 */   // Label 18315: @1277377
     /* 1277377 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1277461), // Rule ID 22234 //
     /* 1277382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277435 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1277438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277460 */     // GIR_Coverage, 22234,
     /* 1277460 */     GIR_EraseRootFromParent_Done,
     /* 1277461 */   // Label 18316: @1277461
     /* 1277461 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1277545), // Rule ID 22235 //
     /* 1277466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1277477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1277480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1277486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1277522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277544 */     // GIR_Coverage, 22235,
     /* 1277544 */     GIR_EraseRootFromParent_Done,
     /* 1277545 */   // Label 18317: @1277545
     /* 1277545 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1277629), // Rule ID 22238 //
     /* 1277550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277603 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1277606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277628 */     // GIR_Coverage, 22238,
     /* 1277628 */     GIR_EraseRootFromParent_Done,
     /* 1277629 */   // Label 18318: @1277629
     /* 1277629 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1277713), // Rule ID 22239 //
     /* 1277634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277687 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1277690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277712 */     // GIR_Coverage, 22239,
     /* 1277712 */     GIR_EraseRootFromParent_Done,
     /* 1277713 */   // Label 18319: @1277713
     /* 1277713 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1277797), // Rule ID 22242 //
     /* 1277718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277771 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1277774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277796 */     // GIR_Coverage, 22242,
     /* 1277796 */     GIR_EraseRootFromParent_Done,
     /* 1277797 */   // Label 18320: @1277797
     /* 1277797 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1277881), // Rule ID 22243 //
     /* 1277802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277855 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1277855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1277858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277880 */     // GIR_Coverage, 22243,
     /* 1277880 */     GIR_EraseRootFromParent_Done,
     /* 1277881 */   // Label 18321: @1277881
     /* 1277881 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1277965), // Rule ID 22246 //
     /* 1277886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1277916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277939 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1277939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1277942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1277946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1277963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277964 */     // GIR_Coverage, 22246,
     /* 1277964 */     GIR_EraseRootFromParent_Done,
     /* 1277965 */   // Label 18322: @1277965
     /* 1277965 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1278049), // Rule ID 22247 //
     /* 1277970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1277978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1277981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1277984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1277990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1278026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278048 */     // GIR_Coverage, 22247,
     /* 1278048 */     GIR_EraseRootFromParent_Done,
     /* 1278049 */   // Label 18323: @1278049
     /* 1278049 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1278133), // Rule ID 22250 //
     /* 1278054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1278110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278132 */     // GIR_Coverage, 22250,
     /* 1278132 */     GIR_EraseRootFromParent_Done,
     /* 1278133 */   // Label 18324: @1278133
     /* 1278133 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1278217), // Rule ID 22251 //
     /* 1278138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278191 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1278194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278216 */     // GIR_Coverage, 22251,
     /* 1278216 */     GIR_EraseRootFromParent_Done,
     /* 1278217 */   // Label 18325: @1278217
     /* 1278217 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1278301), // Rule ID 22254 //
     /* 1278222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1278278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278300 */     // GIR_Coverage, 22254,
     /* 1278300 */     GIR_EraseRootFromParent_Done,
     /* 1278301 */   // Label 18326: @1278301
     /* 1278301 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1278385), // Rule ID 22255 //
     /* 1278306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1278362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278384 */     // GIR_Coverage, 22255,
     /* 1278384 */     GIR_EraseRootFromParent_Done,
     /* 1278385 */   // Label 18327: @1278385
     /* 1278385 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1278469), // Rule ID 22258 //
     /* 1278390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278443 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1278446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278468 */     // GIR_Coverage, 22258,
     /* 1278468 */     GIR_EraseRootFromParent_Done,
     /* 1278469 */   // Label 18328: @1278469
     /* 1278469 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1278553), // Rule ID 22259 //
     /* 1278474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1278485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1278488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1278494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1278530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278552 */     // GIR_Coverage, 22259,
     /* 1278552 */     GIR_EraseRootFromParent_Done,
     /* 1278553 */   // Label 18329: @1278553
     /* 1278553 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1278637), // Rule ID 22262 //
     /* 1278558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1278614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278636 */     // GIR_Coverage, 22262,
     /* 1278636 */     GIR_EraseRootFromParent_Done,
     /* 1278637 */   // Label 18330: @1278637
     /* 1278637 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1278721), // Rule ID 22263 //
     /* 1278642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278695 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1278698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278720 */     // GIR_Coverage, 22263,
     /* 1278720 */     GIR_EraseRootFromParent_Done,
     /* 1278721 */   // Label 18331: @1278721
     /* 1278721 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1278805), // Rule ID 22266 //
     /* 1278726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278779 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1278782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278804 */     // GIR_Coverage, 22266,
     /* 1278804 */     GIR_EraseRootFromParent_Done,
     /* 1278805 */   // Label 18332: @1278805
     /* 1278805 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1278889), // Rule ID 22267 //
     /* 1278810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1278863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1278866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278888 */     // GIR_Coverage, 22267,
     /* 1278888 */     GIR_EraseRootFromParent_Done,
     /* 1278889 */   // Label 18333: @1278889
     /* 1278889 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1278973), // Rule ID 22270 //
     /* 1278894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1278924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1278947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1278950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1278954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1278971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278972 */     // GIR_Coverage, 22270,
     /* 1278972 */     GIR_EraseRootFromParent_Done,
     /* 1278973 */   // Label 18334: @1278973
     /* 1278973 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1279057), // Rule ID 22271 //
     /* 1278978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1278986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1278989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1278992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1278998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1279034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279056 */     // GIR_Coverage, 22271,
     /* 1279056 */     GIR_EraseRootFromParent_Done,
     /* 1279057 */   // Label 18335: @1279057
     /* 1279057 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1279141), // Rule ID 22274 //
     /* 1279062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279115 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1279118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279140 */     // GIR_Coverage, 22274,
     /* 1279140 */     GIR_EraseRootFromParent_Done,
     /* 1279141 */   // Label 18336: @1279141
     /* 1279141 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1279225), // Rule ID 22275 //
     /* 1279146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1279202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279224 */     // GIR_Coverage, 22275,
     /* 1279224 */     GIR_EraseRootFromParent_Done,
     /* 1279225 */   // Label 18337: @1279225
     /* 1279225 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1279309), // Rule ID 22278 //
     /* 1279230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279283 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1279286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279308 */     // GIR_Coverage, 22278,
     /* 1279308 */     GIR_EraseRootFromParent_Done,
     /* 1279309 */   // Label 18338: @1279309
     /* 1279309 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1279393), // Rule ID 22279 //
     /* 1279314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279367 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1279370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279392 */     // GIR_Coverage, 22279,
     /* 1279392 */     GIR_EraseRootFromParent_Done,
     /* 1279393 */   // Label 18339: @1279393
     /* 1279393 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1279477), // Rule ID 22282 //
     /* 1279398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279451 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1279454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279476 */     // GIR_Coverage, 22282,
     /* 1279476 */     GIR_EraseRootFromParent_Done,
     /* 1279477 */   // Label 18340: @1279477
     /* 1279477 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1279561), // Rule ID 22283 //
     /* 1279482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1279493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1279496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279535 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1279538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279560 */     // GIR_Coverage, 22283,
     /* 1279560 */     GIR_EraseRootFromParent_Done,
     /* 1279561 */   // Label 18341: @1279561
     /* 1279561 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1279645), // Rule ID 22286 //
     /* 1279566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1279577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1279580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279619 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1279622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279644 */     // GIR_Coverage, 22286,
     /* 1279644 */     GIR_EraseRootFromParent_Done,
     /* 1279645 */   // Label 18342: @1279645
     /* 1279645 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1279729), // Rule ID 22287 //
     /* 1279650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1279661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1279664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279703 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1279706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279728 */     // GIR_Coverage, 22287,
     /* 1279728 */     GIR_EraseRootFromParent_Done,
     /* 1279729 */   // Label 18343: @1279729
     /* 1279729 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1279813), // Rule ID 22290 //
     /* 1279734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1279745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1279748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279787 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1279790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279812 */     // GIR_Coverage, 22290,
     /* 1279812 */     GIR_EraseRootFromParent_Done,
     /* 1279813 */   // Label 18344: @1279813
     /* 1279813 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1279897), // Rule ID 22291 //
     /* 1279818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1279829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1279832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279871 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1279871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1279874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279896 */     // GIR_Coverage, 22291,
     /* 1279896 */     GIR_EraseRootFromParent_Done,
     /* 1279897 */   // Label 18345: @1279897
     /* 1279897 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1279981), // Rule ID 22294 //
     /* 1279902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1279913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1279916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1279922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1279932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1279955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1279958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1279962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1279979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279980 */     // GIR_Coverage, 22294,
     /* 1279980 */     GIR_EraseRootFromParent_Done,
     /* 1279981 */   // Label 18346: @1279981
     /* 1279981 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1280065), // Rule ID 22295 //
     /* 1279986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1279994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1279997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1280000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1280003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1280006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1280042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280064 */     // GIR_Coverage, 22295,
     /* 1280064 */     GIR_EraseRootFromParent_Done,
     /* 1280065 */   // Label 18347: @1280065
     /* 1280065 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1280149), // Rule ID 22298 //
     /* 1280070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1280081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1280084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280123 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1280126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280148 */     // GIR_Coverage, 22298,
     /* 1280148 */     GIR_EraseRootFromParent_Done,
     /* 1280149 */   // Label 18348: @1280149
     /* 1280149 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1280233), // Rule ID 22299 //
     /* 1280154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1280165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1280168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1280210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280232 */     // GIR_Coverage, 22299,
     /* 1280232 */     GIR_EraseRootFromParent_Done,
     /* 1280233 */   // Label 18349: @1280233
     /* 1280233 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1280317), // Rule ID 22302 //
     /* 1280238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1280249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1280252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1280258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1280294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280316 */     // GIR_Coverage, 22302,
     /* 1280316 */     GIR_EraseRootFromParent_Done,
     /* 1280317 */   // Label 18350: @1280317
     /* 1280317 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1280401), // Rule ID 22303 //
     /* 1280322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1280333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1280336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1280342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1280378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280400 */     // GIR_Coverage, 22303,
     /* 1280400 */     GIR_EraseRootFromParent_Done,
     /* 1280401 */   // Label 18351: @1280401
     /* 1280401 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1280485), // Rule ID 22306 //
     /* 1280406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1280417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1280420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1280426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1280462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280484 */     // GIR_Coverage, 22306,
     /* 1280484 */     GIR_EraseRootFromParent_Done,
     /* 1280485 */   // Label 18352: @1280485
     /* 1280485 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1280569), // Rule ID 22307 //
     /* 1280490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1280501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1280504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1280510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280543 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1280546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280568 */     // GIR_Coverage, 22307,
     /* 1280568 */     GIR_EraseRootFromParent_Done,
     /* 1280569 */   // Label 18353: @1280569
     /* 1280569 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1280653), // Rule ID 22310 //
     /* 1280574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1280585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1280588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1280594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1280630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280652 */     // GIR_Coverage, 22310,
     /* 1280652 */     GIR_EraseRootFromParent_Done,
     /* 1280653 */   // Label 18354: @1280653
     /* 1280653 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1280737), // Rule ID 22311 //
     /* 1280658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1280669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1280672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1280678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280711 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1280714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280736 */     // GIR_Coverage, 22311,
     /* 1280736 */     GIR_EraseRootFromParent_Done,
     /* 1280737 */   // Label 18355: @1280737
     /* 1280737 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1280821), // Rule ID 22314 //
     /* 1280742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1280753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1280756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1280798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280820 */     // GIR_Coverage, 22314,
     /* 1280820 */     GIR_EraseRootFromParent_Done,
     /* 1280821 */   // Label 18356: @1280821
     /* 1280821 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1280905), // Rule ID 22315 //
     /* 1280826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1280837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1280840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280879 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1280879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1280882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280904 */     // GIR_Coverage, 22315,
     /* 1280904 */     GIR_EraseRootFromParent_Done,
     /* 1280905 */   // Label 18357: @1280905
     /* 1280905 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1280989), // Rule ID 22318 //
     /* 1280910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1280918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1280921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1280924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1280940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280963 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1280963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1280966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1280970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1280987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280988 */     // GIR_Coverage, 22318,
     /* 1280988 */     GIR_EraseRootFromParent_Done,
     /* 1280989 */   // Label 18358: @1280989
     /* 1280989 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1281073), // Rule ID 22319 //
     /* 1280994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1281005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1281008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1281011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1281014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281047 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1281050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281072 */     // GIR_Coverage, 22319,
     /* 1281072 */     GIR_EraseRootFromParent_Done,
     /* 1281073 */   // Label 18359: @1281073
     /* 1281073 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1281157), // Rule ID 22322 //
     /* 1281078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1281089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1281092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1281098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281131 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1281134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281156 */     // GIR_Coverage, 22322,
     /* 1281156 */     GIR_EraseRootFromParent_Done,
     /* 1281157 */   // Label 18360: @1281157
     /* 1281157 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1281241), // Rule ID 22323 //
     /* 1281162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1281173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1281176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1281182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1281218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281240 */     // GIR_Coverage, 22323,
     /* 1281240 */     GIR_EraseRootFromParent_Done,
     /* 1281241 */   // Label 18361: @1281241
     /* 1281241 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1281325), // Rule ID 22326 //
     /* 1281246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1281302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281324 */     // GIR_Coverage, 22326,
     /* 1281324 */     GIR_EraseRootFromParent_Done,
     /* 1281325 */   // Label 18362: @1281325
     /* 1281325 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1281409), // Rule ID 22327 //
     /* 1281330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281383 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1281386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281408 */     // GIR_Coverage, 22327,
     /* 1281408 */     GIR_EraseRootFromParent_Done,
     /* 1281409 */   // Label 18363: @1281409
     /* 1281409 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1281493), // Rule ID 22330 //
     /* 1281414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281467 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1281470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281492 */     // GIR_Coverage, 22330,
     /* 1281492 */     GIR_EraseRootFromParent_Done,
     /* 1281493 */   // Label 18364: @1281493
     /* 1281493 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1281577), // Rule ID 22331 //
     /* 1281498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281551 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1281554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281576 */     // GIR_Coverage, 22331,
     /* 1281576 */     GIR_EraseRootFromParent_Done,
     /* 1281577 */   // Label 18365: @1281577
     /* 1281577 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1281661), // Rule ID 22334 //
     /* 1281582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281635 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1281638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281660 */     // GIR_Coverage, 22334,
     /* 1281660 */     GIR_EraseRootFromParent_Done,
     /* 1281661 */   // Label 18366: @1281661
     /* 1281661 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1281745), // Rule ID 22335 //
     /* 1281666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1281677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1281680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1281722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281744 */     // GIR_Coverage, 22335,
     /* 1281744 */     GIR_EraseRootFromParent_Done,
     /* 1281745 */   // Label 18367: @1281745
     /* 1281745 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1281829), // Rule ID 22338 //
     /* 1281750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1281761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1281764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1281770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1281806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281828 */     // GIR_Coverage, 22338,
     /* 1281828 */     GIR_EraseRootFromParent_Done,
     /* 1281829 */   // Label 18368: @1281829
     /* 1281829 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1281913), // Rule ID 22339 //
     /* 1281834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1281845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1281848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1281854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281887 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1281887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1281890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281912 */     // GIR_Coverage, 22339,
     /* 1281912 */     GIR_EraseRootFromParent_Done,
     /* 1281913 */   // Label 18369: @1281913
     /* 1281913 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1281997), // Rule ID 22342 //
     /* 1281918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1281926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1281929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1281932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1281938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1281948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1281971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1281974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1281978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1281995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281996 */     // GIR_Coverage, 22342,
     /* 1281996 */     GIR_EraseRootFromParent_Done,
     /* 1281997 */   // Label 18370: @1281997
     /* 1281997 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1282081), // Rule ID 22343 //
     /* 1282002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1282013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1282016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1282019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1282022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1282058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282080 */     // GIR_Coverage, 22343,
     /* 1282080 */     GIR_EraseRootFromParent_Done,
     /* 1282081 */   // Label 18371: @1282081
     /* 1282081 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1282165), // Rule ID 22346 //
     /* 1282086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1282097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1282100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1282106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1282142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282164 */     // GIR_Coverage, 22346,
     /* 1282164 */     GIR_EraseRootFromParent_Done,
     /* 1282165 */   // Label 18372: @1282165
     /* 1282165 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1282249), // Rule ID 22347 //
     /* 1282170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1282181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1282184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1282190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282223 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1282226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282248 */     // GIR_Coverage, 22347,
     /* 1282248 */     GIR_EraseRootFromParent_Done,
     /* 1282249 */   // Label 18373: @1282249
     /* 1282249 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1282333), // Rule ID 22350 //
     /* 1282254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282307 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1282310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282332 */     // GIR_Coverage, 22350,
     /* 1282332 */     GIR_EraseRootFromParent_Done,
     /* 1282333 */   // Label 18374: @1282333
     /* 1282333 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1282417), // Rule ID 22351 //
     /* 1282338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1282394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282416 */     // GIR_Coverage, 22351,
     /* 1282416 */     GIR_EraseRootFromParent_Done,
     /* 1282417 */   // Label 18375: @1282417
     /* 1282417 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1282501), // Rule ID 22354 //
     /* 1282422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1282478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282500 */     // GIR_Coverage, 22354,
     /* 1282500 */     GIR_EraseRootFromParent_Done,
     /* 1282501 */   // Label 18376: @1282501
     /* 1282501 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1282585), // Rule ID 22355 //
     /* 1282506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282559 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1282562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282584 */     // GIR_Coverage, 22355,
     /* 1282584 */     GIR_EraseRootFromParent_Done,
     /* 1282585 */   // Label 18377: @1282585
     /* 1282585 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1282669), // Rule ID 22358 //
     /* 1282590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1282646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282668 */     // GIR_Coverage, 22358,
     /* 1282668 */     GIR_EraseRootFromParent_Done,
     /* 1282669 */   // Label 18378: @1282669
     /* 1282669 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1282753), // Rule ID 22359 //
     /* 1282674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1282682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1282685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1282688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1282694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1282730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282752 */     // GIR_Coverage, 22359,
     /* 1282752 */     GIR_EraseRootFromParent_Done,
     /* 1282753 */   // Label 18379: @1282753
     /* 1282753 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1282837), // Rule ID 22362 //
     /* 1282758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1282766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1282769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1282772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1282778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282811 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1282814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282836 */     // GIR_Coverage, 22362,
     /* 1282836 */     GIR_EraseRootFromParent_Done,
     /* 1282837 */   // Label 18380: @1282837
     /* 1282837 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1282921), // Rule ID 22363 //
     /* 1282842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1282850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1282853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1282856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1282862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282895 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1282895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1282898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1282919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282920 */     // GIR_Coverage, 22363,
     /* 1282920 */     GIR_EraseRootFromParent_Done,
     /* 1282921 */   // Label 18381: @1282921
     /* 1282921 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1283005), // Rule ID 22366 //
     /* 1282926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1282934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1282937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1282940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1282946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1282956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282979 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1282979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1282982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1282986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283004 */     // GIR_Coverage, 22366,
     /* 1283004 */     GIR_EraseRootFromParent_Done,
     /* 1283005 */   // Label 18382: @1283005
     /* 1283005 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1283089), // Rule ID 22367 //
     /* 1283010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1283021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1283024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1283027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283063 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1283066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283088 */     // GIR_Coverage, 22367,
     /* 1283088 */     GIR_EraseRootFromParent_Done,
     /* 1283089 */   // Label 18383: @1283089
     /* 1283089 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1283173), // Rule ID 22370 //
     /* 1283094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1283105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1283108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283147 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1283150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283172 */     // GIR_Coverage, 22370,
     /* 1283172 */     GIR_EraseRootFromParent_Done,
     /* 1283173 */   // Label 18384: @1283173
     /* 1283173 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1283257), // Rule ID 22371 //
     /* 1283178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1283189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1283192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283231 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1283234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283256 */     // GIR_Coverage, 22371,
     /* 1283256 */     GIR_EraseRootFromParent_Done,
     /* 1283257 */   // Label 18385: @1283257
     /* 1283257 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1283341), // Rule ID 22374 //
     /* 1283262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1283273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1283276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1283318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283340 */     // GIR_Coverage, 22374,
     /* 1283340 */     GIR_EraseRootFromParent_Done,
     /* 1283341 */   // Label 18386: @1283341
     /* 1283341 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1283425), // Rule ID 22375 //
     /* 1283346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1283357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1283360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1283402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283424 */     // GIR_Coverage, 22375,
     /* 1283424 */     GIR_EraseRootFromParent_Done,
     /* 1283425 */   // Label 18387: @1283425
     /* 1283425 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1283509), // Rule ID 22378 //
     /* 1283430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1283441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1283444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1283486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283508 */     // GIR_Coverage, 22378,
     /* 1283508 */     GIR_EraseRootFromParent_Done,
     /* 1283509 */   // Label 18388: @1283509
     /* 1283509 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1283593), // Rule ID 22379 //
     /* 1283514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1283525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1283528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283567 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1283570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283592 */     // GIR_Coverage, 22379,
     /* 1283592 */     GIR_EraseRootFromParent_Done,
     /* 1283593 */   // Label 18389: @1283593
     /* 1283593 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1283677), // Rule ID 22382 //
     /* 1283598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1283609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1283612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1283654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283676 */     // GIR_Coverage, 22382,
     /* 1283676 */     GIR_EraseRootFromParent_Done,
     /* 1283677 */   // Label 18390: @1283677
     /* 1283677 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1283761), // Rule ID 22383 //
     /* 1283682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1283693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1283696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283735 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1283738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283760 */     // GIR_Coverage, 22383,
     /* 1283760 */     GIR_EraseRootFromParent_Done,
     /* 1283761 */   // Label 18391: @1283761
     /* 1283761 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1283845), // Rule ID 22386 //
     /* 1283766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1283777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1283780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1283822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283844 */     // GIR_Coverage, 22386,
     /* 1283844 */     GIR_EraseRootFromParent_Done,
     /* 1283845 */   // Label 18392: @1283845
     /* 1283845 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1283929), // Rule ID 22387 //
     /* 1283850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1283861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1283864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283903 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1283903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1283906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1283927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283928 */     // GIR_Coverage, 22387,
     /* 1283928 */     GIR_EraseRootFromParent_Done,
     /* 1283929 */   // Label 18393: @1283929
     /* 1283929 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1284013), // Rule ID 22390 //
     /* 1283934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1283942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1283945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1283948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1283964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283987 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1283987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1283990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1283994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284012 */     // GIR_Coverage, 22390,
     /* 1284012 */     GIR_EraseRootFromParent_Done,
     /* 1284013 */   // Label 18394: @1284013
     /* 1284013 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1284097), // Rule ID 22391 //
     /* 1284018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1284029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1284032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1284035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1284038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1284074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284096 */     // GIR_Coverage, 22391,
     /* 1284096 */     GIR_EraseRootFromParent_Done,
     /* 1284097 */   // Label 18395: @1284097
     /* 1284097 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1284181), // Rule ID 22394 //
     /* 1284102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1284113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1284116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284155 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1284158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284180 */     // GIR_Coverage, 22394,
     /* 1284180 */     GIR_EraseRootFromParent_Done,
     /* 1284181 */   // Label 18396: @1284181
     /* 1284181 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1284265), // Rule ID 22395 //
     /* 1284186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1284197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1284200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1284242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284264 */     // GIR_Coverage, 22395,
     /* 1284264 */     GIR_EraseRootFromParent_Done,
     /* 1284265 */   // Label 18397: @1284265
     /* 1284265 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1284349), // Rule ID 22398 //
     /* 1284270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1284273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1284281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1284284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284323 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1284326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284348 */     // GIR_Coverage, 22398,
     /* 1284348 */     GIR_EraseRootFromParent_Done,
     /* 1284349 */   // Label 18398: @1284349
     /* 1284349 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1284433), // Rule ID 22399 //
     /* 1284354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1284357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1284365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1284368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284407 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1284410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284432 */     // GIR_Coverage, 22399,
     /* 1284432 */     GIR_EraseRootFromParent_Done,
     /* 1284433 */   // Label 18399: @1284433
     /* 1284433 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1284517), // Rule ID 22402 //
     /* 1284438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284491 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1284494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284516 */     // GIR_Coverage, 22402,
     /* 1284516 */     GIR_EraseRootFromParent_Done,
     /* 1284517 */   // Label 18400: @1284517
     /* 1284517 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1284601), // Rule ID 22403 //
     /* 1284522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284575 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1284578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284600 */     // GIR_Coverage, 22403,
     /* 1284600 */     GIR_EraseRootFromParent_Done,
     /* 1284601 */   // Label 18401: @1284601
     /* 1284601 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1284685), // Rule ID 22406 //
     /* 1284606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1284662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284684 */     // GIR_Coverage, 22406,
     /* 1284684 */     GIR_EraseRootFromParent_Done,
     /* 1284685 */   // Label 18402: @1284685
     /* 1284685 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1284769), // Rule ID 22407 //
     /* 1284690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284743 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1284746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284768 */     // GIR_Coverage, 22407,
     /* 1284768 */     GIR_EraseRootFromParent_Done,
     /* 1284769 */   // Label 18403: @1284769
     /* 1284769 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1284853), // Rule ID 22410 //
     /* 1284774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1284830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284852 */     // GIR_Coverage, 22410,
     /* 1284852 */     GIR_EraseRootFromParent_Done,
     /* 1284853 */   // Label 18404: @1284853
     /* 1284853 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1284937), // Rule ID 22411 //
     /* 1284858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1284869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1284872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284911 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1284911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1284914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1284918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1284935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284936 */     // GIR_Coverage, 22411,
     /* 1284936 */     GIR_EraseRootFromParent_Done,
     /* 1284937 */   // Label 18405: @1284937
     /* 1284937 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1285021), // Rule ID 22414 //
     /* 1284942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1284950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1284953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1284956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1284962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1284972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1284995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1284998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285020 */     // GIR_Coverage, 22414,
     /* 1285020 */     GIR_EraseRootFromParent_Done,
     /* 1285021 */   // Label 18406: @1285021
     /* 1285021 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1285105), // Rule ID 22415 //
     /* 1285026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1285037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1285040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1285043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1285046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285079 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1285082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285104 */     // GIR_Coverage, 22415,
     /* 1285104 */     GIR_EraseRootFromParent_Done,
     /* 1285105 */   // Label 18407: @1285105
     /* 1285105 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1285189), // Rule ID 22418 //
     /* 1285110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1285121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1285124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1285130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285163 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1285163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1285166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285188 */     // GIR_Coverage, 22418,
     /* 1285188 */     GIR_EraseRootFromParent_Done,
     /* 1285189 */   // Label 18408: @1285189
     /* 1285189 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1285273), // Rule ID 22419 //
     /* 1285194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1285205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1285208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1285214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285247 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1285250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285272 */     // GIR_Coverage, 22419,
     /* 1285272 */     GIR_EraseRootFromParent_Done,
     /* 1285273 */   // Label 18409: @1285273
     /* 1285273 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1285357), // Rule ID 22422 //
     /* 1285278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1285289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1285292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1285298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285331 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1285331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1285334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285356 */     // GIR_Coverage, 22422,
     /* 1285356 */     GIR_EraseRootFromParent_Done,
     /* 1285357 */   // Label 18410: @1285357
     /* 1285357 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1285441), // Rule ID 22423 //
     /* 1285362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1285373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1285376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1285382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1285418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285440 */     // GIR_Coverage, 22423,
     /* 1285440 */     GIR_EraseRootFromParent_Done,
     /* 1285441 */   // Label 18411: @1285441
     /* 1285441 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1285525), // Rule ID 22426 //
     /* 1285446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1285499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1285502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285524 */     // GIR_Coverage, 22426,
     /* 1285524 */     GIR_EraseRootFromParent_Done,
     /* 1285525 */   // Label 18412: @1285525
     /* 1285525 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1285609), // Rule ID 22427 //
     /* 1285530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1285586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285608 */     // GIR_Coverage, 22427,
     /* 1285608 */     GIR_EraseRootFromParent_Done,
     /* 1285609 */   // Label 18413: @1285609
     /* 1285609 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1285693), // Rule ID 22430 //
     /* 1285614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1285667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1285670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285692 */     // GIR_Coverage, 22430,
     /* 1285692 */     GIR_EraseRootFromParent_Done,
     /* 1285693 */   // Label 18414: @1285693
     /* 1285693 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1285777), // Rule ID 22431 //
     /* 1285698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285751 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1285754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285776 */     // GIR_Coverage, 22431,
     /* 1285776 */     GIR_EraseRootFromParent_Done,
     /* 1285777 */   // Label 18415: @1285777
     /* 1285777 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1285861), // Rule ID 22434 //
     /* 1285782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285835 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1285835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1285838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285860 */     // GIR_Coverage, 22434,
     /* 1285860 */     GIR_EraseRootFromParent_Done,
     /* 1285861 */   // Label 18416: @1285861
     /* 1285861 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1285945), // Rule ID 22435 //
     /* 1285866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1285877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1285880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1285886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1285919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1285922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1285926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1285943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285944 */     // GIR_Coverage, 22435,
     /* 1285944 */     GIR_EraseRootFromParent_Done,
     /* 1285945 */   // Label 18417: @1285945
     /* 1285945 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1286029), // Rule ID 22438 //
     /* 1285950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1285958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1285961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1285964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1285970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1285980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286003 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1286006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286028 */     // GIR_Coverage, 22438,
     /* 1286028 */     GIR_EraseRootFromParent_Done,
     /* 1286029 */   // Label 18418: @1286029
     /* 1286029 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1286113), // Rule ID 22439 //
     /* 1286034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1286042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1286045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1286048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1286051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1286054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286087 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1286090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286112 */     // GIR_Coverage, 22439,
     /* 1286112 */     GIR_EraseRootFromParent_Done,
     /* 1286113 */   // Label 18419: @1286113
     /* 1286113 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1286197), // Rule ID 22442 //
     /* 1286118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1286126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1286129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1286132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1286138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1286174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286196 */     // GIR_Coverage, 22442,
     /* 1286196 */     GIR_EraseRootFromParent_Done,
     /* 1286197 */   // Label 18420: @1286197
     /* 1286197 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1286281), // Rule ID 22443 //
     /* 1286202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1286210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1286213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1286216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1286222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286255 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1286258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286280 */     // GIR_Coverage, 22443,
     /* 1286280 */     GIR_EraseRootFromParent_Done,
     /* 1286281 */   // Label 18421: @1286281
     /* 1286281 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1286365), // Rule ID 22446 //
     /* 1286286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1286294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1286297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1286300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1286306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1286342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286364 */     // GIR_Coverage, 22446,
     /* 1286364 */     GIR_EraseRootFromParent_Done,
     /* 1286365 */   // Label 18422: @1286365
     /* 1286365 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1286449), // Rule ID 22447 //
     /* 1286370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1286378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1286381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1286384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1286390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286423 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1286426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286448 */     // GIR_Coverage, 22447,
     /* 1286448 */     GIR_EraseRootFromParent_Done,
     /* 1286449 */   // Label 18423: @1286449
     /* 1286449 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1286533), // Rule ID 22450 //
     /* 1286454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1286510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286532 */     // GIR_Coverage, 22450,
     /* 1286532 */     GIR_EraseRootFromParent_Done,
     /* 1286533 */   // Label 18424: @1286533
     /* 1286533 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1286617), // Rule ID 22451 //
     /* 1286538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286591 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1286594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286616 */     // GIR_Coverage, 22451,
     /* 1286616 */     GIR_EraseRootFromParent_Done,
     /* 1286617 */   // Label 18425: @1286617
     /* 1286617 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1286701), // Rule ID 22454 //
     /* 1286622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1286678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286700 */     // GIR_Coverage, 22454,
     /* 1286700 */     GIR_EraseRootFromParent_Done,
     /* 1286701 */   // Label 18426: @1286701
     /* 1286701 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1286785), // Rule ID 22455 //
     /* 1286706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1286762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286784 */     // GIR_Coverage, 22455,
     /* 1286784 */     GIR_EraseRootFromParent_Done,
     /* 1286785 */   // Label 18427: @1286785
     /* 1286785 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1286869), // Rule ID 22458 //
     /* 1286790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286843 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1286843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1286846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286868 */     // GIR_Coverage, 22458,
     /* 1286868 */     GIR_EraseRootFromParent_Done,
     /* 1286869 */   // Label 18428: @1286869
     /* 1286869 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1286953), // Rule ID 22459 //
     /* 1286874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1286885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1286888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1286894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1286927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1286930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1286934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1286951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286952 */     // GIR_Coverage, 22459,
     /* 1286952 */     GIR_EraseRootFromParent_Done,
     /* 1286953 */   // Label 18429: @1286953
     /* 1286953 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1287037), // Rule ID 22462 //
     /* 1286958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1286966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1286969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1286972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1286978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1286988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287011 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1287014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287036 */     // GIR_Coverage, 22462,
     /* 1287036 */     GIR_EraseRootFromParent_Done,
     /* 1287037 */   // Label 18430: @1287037
     /* 1287037 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1287121), // Rule ID 22463 //
     /* 1287042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1287053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1287056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1287059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287095 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1287098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287120 */     // GIR_Coverage, 22463,
     /* 1287120 */     GIR_EraseRootFromParent_Done,
     /* 1287121 */   // Label 18431: @1287121
     /* 1287121 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1287205), // Rule ID 22466 //
     /* 1287126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1287137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1287140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287179 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1287182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287204 */     // GIR_Coverage, 22466,
     /* 1287204 */     GIR_EraseRootFromParent_Done,
     /* 1287205 */   // Label 18432: @1287205
     /* 1287205 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1287289), // Rule ID 22467 //
     /* 1287210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1287221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1287224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287263 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1287266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287288 */     // GIR_Coverage, 22467,
     /* 1287288 */     GIR_EraseRootFromParent_Done,
     /* 1287289 */   // Label 18433: @1287289
     /* 1287289 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1287373), // Rule ID 22470 //
     /* 1287294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1287305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1287308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1287350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287372 */     // GIR_Coverage, 22470,
     /* 1287372 */     GIR_EraseRootFromParent_Done,
     /* 1287373 */   // Label 18434: @1287373
     /* 1287373 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1287457), // Rule ID 22471 //
     /* 1287378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1287389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1287392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287431 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1287434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287456 */     // GIR_Coverage, 22471,
     /* 1287456 */     GIR_EraseRootFromParent_Done,
     /* 1287457 */   // Label 18435: @1287457
     /* 1287457 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1287541), // Rule ID 22474 //
     /* 1287462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1287473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1287476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1287482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287515 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1287518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287540 */     // GIR_Coverage, 22474,
     /* 1287540 */     GIR_EraseRootFromParent_Done,
     /* 1287541 */   // Label 18436: @1287541
     /* 1287541 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1287625), // Rule ID 22475 //
     /* 1287546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1287557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1287560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1287566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1287602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287624 */     // GIR_Coverage, 22475,
     /* 1287624 */     GIR_EraseRootFromParent_Done,
     /* 1287625 */   // Label 18437: @1287625
     /* 1287625 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1287709), // Rule ID 22478 //
     /* 1287630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1287641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1287644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1287686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287708 */     // GIR_Coverage, 22478,
     /* 1287708 */     GIR_EraseRootFromParent_Done,
     /* 1287709 */   // Label 18438: @1287709
     /* 1287709 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1287793), // Rule ID 22479 //
     /* 1287714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1287725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1287728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287767 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1287770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287792 */     // GIR_Coverage, 22479,
     /* 1287792 */     GIR_EraseRootFromParent_Done,
     /* 1287793 */   // Label 18439: @1287793
     /* 1287793 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1287877), // Rule ID 22482 //
     /* 1287798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1287809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1287812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287851 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1287851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1287854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287876 */     // GIR_Coverage, 22482,
     /* 1287876 */     GIR_EraseRootFromParent_Done,
     /* 1287877 */   // Label 18440: @1287877
     /* 1287877 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1287961), // Rule ID 22483 //
     /* 1287882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1287893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1287896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287935 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1287935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1287938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1287942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1287959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287960 */     // GIR_Coverage, 22483,
     /* 1287960 */     GIR_EraseRootFromParent_Done,
     /* 1287961 */   // Label 18441: @1287961
     /* 1287961 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1288045), // Rule ID 22486 //
     /* 1287966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1287974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1287977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1287980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1287986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1287996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1288022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288044 */     // GIR_Coverage, 22486,
     /* 1288044 */     GIR_EraseRootFromParent_Done,
     /* 1288045 */   // Label 18442: @1288045
     /* 1288045 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1288129), // Rule ID 22487 //
     /* 1288050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1288053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1288061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1288064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1288067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1288070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1288106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288128 */     // GIR_Coverage, 22487,
     /* 1288128 */     GIR_EraseRootFromParent_Done,
     /* 1288129 */   // Label 18443: @1288129
     /* 1288129 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1288213), // Rule ID 22490 //
     /* 1288134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288187 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1288190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288212 */     // GIR_Coverage, 22490,
     /* 1288212 */     GIR_EraseRootFromParent_Done,
     /* 1288213 */   // Label 18444: @1288213
     /* 1288213 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1288297), // Rule ID 22491 //
     /* 1288218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1288274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288296 */     // GIR_Coverage, 22491,
     /* 1288296 */     GIR_EraseRootFromParent_Done,
     /* 1288297 */   // Label 18445: @1288297
     /* 1288297 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1288381), // Rule ID 22494 //
     /* 1288302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288355 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1288358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288380 */     // GIR_Coverage, 22494,
     /* 1288380 */     GIR_EraseRootFromParent_Done,
     /* 1288381 */   // Label 18446: @1288381
     /* 1288381 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1288465), // Rule ID 22495 //
     /* 1288386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288439 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1288442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288464 */     // GIR_Coverage, 22495,
     /* 1288464 */     GIR_EraseRootFromParent_Done,
     /* 1288465 */   // Label 18447: @1288465
     /* 1288465 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1288549), // Rule ID 22498 //
     /* 1288470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288523 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1288526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288548 */     // GIR_Coverage, 22498,
     /* 1288548 */     GIR_EraseRootFromParent_Done,
     /* 1288549 */   // Label 18448: @1288549
     /* 1288549 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1288633), // Rule ID 22499 //
     /* 1288554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1288565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1288568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11191:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1288610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288632 */     // GIR_Coverage, 22499,
     /* 1288632 */     GIR_EraseRootFromParent_Done,
     /* 1288633 */   // Label 18449: @1288633
     /* 1288633 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1288717), // Rule ID 22502 //
     /* 1288638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1288649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1288652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288691 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1288694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288716 */     // GIR_Coverage, 22502,
     /* 1288716 */     GIR_EraseRootFromParent_Done,
     /* 1288717 */   // Label 18450: @1288717
     /* 1288717 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1288801), // Rule ID 22503 //
     /* 1288722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1288733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1288736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1288778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288800 */     // GIR_Coverage, 22503,
     /* 1288800 */     GIR_EraseRootFromParent_Done,
     /* 1288801 */   // Label 18451: @1288801
     /* 1288801 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1288885), // Rule ID 22506 //
     /* 1288806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1288817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1288820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288859 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1288859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1288862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288884 */     // GIR_Coverage, 22506,
     /* 1288884 */     GIR_EraseRootFromParent_Done,
     /* 1288885 */   // Label 18452: @1288885
     /* 1288885 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1288969), // Rule ID 22507 //
     /* 1288890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1288901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1288904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1288920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1288943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1288946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1288950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1288967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288968 */     // GIR_Coverage, 22507,
     /* 1288968 */     GIR_EraseRootFromParent_Done,
     /* 1288969 */   // Label 18453: @1288969
     /* 1288969 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1289053), // Rule ID 22510 //
     /* 1288974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1288982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1288985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1288988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1289030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289052 */     // GIR_Coverage, 22510,
     /* 1289052 */     GIR_EraseRootFromParent_Done,
     /* 1289053 */   // Label 18454: @1289053
     /* 1289053 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1289137), // Rule ID 22511 //
     /* 1289058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1289069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1289072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1289075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1289078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289111 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1289114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289136 */     // GIR_Coverage, 22511,
     /* 1289136 */     GIR_EraseRootFromParent_Done,
     /* 1289137 */   // Label 18455: @1289137
     /* 1289137 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1289221), // Rule ID 22514 //
     /* 1289142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289195 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1289198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289220 */     // GIR_Coverage, 22514,
     /* 1289220 */     GIR_EraseRootFromParent_Done,
     /* 1289221 */   // Label 18456: @1289221
     /* 1289221 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1289305), // Rule ID 22515 //
     /* 1289226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289279 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1289282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289304 */     // GIR_Coverage, 22515,
     /* 1289304 */     GIR_EraseRootFromParent_Done,
     /* 1289305 */   // Label 18457: @1289305
     /* 1289305 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1289389), // Rule ID 22518 //
     /* 1289310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289363 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1289366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289388 */     // GIR_Coverage, 22518,
     /* 1289388 */     GIR_EraseRootFromParent_Done,
     /* 1289389 */   // Label 18458: @1289389
     /* 1289389 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1289473), // Rule ID 22519 //
     /* 1289394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289447 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1289450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289472 */     // GIR_Coverage, 22519,
     /* 1289472 */     GIR_EraseRootFromParent_Done,
     /* 1289473 */   // Label 18459: @1289473
     /* 1289473 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1289557), // Rule ID 22522 //
     /* 1289478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289531 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1289534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289556 */     // GIR_Coverage, 22522,
     /* 1289556 */     GIR_EraseRootFromParent_Done,
     /* 1289557 */   // Label 18460: @1289557
     /* 1289557 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1289641), // Rule ID 22523 //
     /* 1289562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1289573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1289576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1289582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1289618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289640 */     // GIR_Coverage, 22523,
     /* 1289640 */     GIR_EraseRootFromParent_Done,
     /* 1289641 */   // Label 18461: @1289641
     /* 1289641 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1289725), // Rule ID 22526 //
     /* 1289646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1289657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1289660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1289666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1289702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289724 */     // GIR_Coverage, 22526,
     /* 1289724 */     GIR_EraseRootFromParent_Done,
     /* 1289725 */   // Label 18462: @1289725
     /* 1289725 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1289809), // Rule ID 22527 //
     /* 1289730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1289741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1289744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1289750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1289786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289808 */     // GIR_Coverage, 22527,
     /* 1289808 */     GIR_EraseRootFromParent_Done,
     /* 1289809 */   // Label 18463: @1289809
     /* 1289809 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1289893), // Rule ID 22530 //
     /* 1289814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1289825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1289828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1289834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289867 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1289867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1289870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289892 */     // GIR_Coverage, 22530,
     /* 1289892 */     GIR_EraseRootFromParent_Done,
     /* 1289893 */   // Label 18464: @1289893
     /* 1289893 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1289977), // Rule ID 22531 //
     /* 1289898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1289909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1289912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1289918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1289928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1289951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1289954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1289958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1289975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289976 */     // GIR_Coverage, 22531,
     /* 1289976 */     GIR_EraseRootFromParent_Done,
     /* 1289977 */   // Label 18465: @1289977
     /* 1289977 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1290061), // Rule ID 22534 //
     /* 1289982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1289990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1289993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1289996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1290002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290035 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1290038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290060 */     // GIR_Coverage, 22534,
     /* 1290060 */     GIR_EraseRootFromParent_Done,
     /* 1290061 */   // Label 18466: @1290061
     /* 1290061 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1290145), // Rule ID 22535 //
     /* 1290066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1290074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1290077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1290080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1290086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290119 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1290122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290144 */     // GIR_Coverage, 22535,
     /* 1290144 */     GIR_EraseRootFromParent_Done,
     /* 1290145 */   // Label 18467: @1290145
     /* 1290145 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1290229), // Rule ID 22538 //
     /* 1290150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290203 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1290206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290228 */     // GIR_Coverage, 22538,
     /* 1290228 */     GIR_EraseRootFromParent_Done,
     /* 1290229 */   // Label 18468: @1290229
     /* 1290229 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1290313), // Rule ID 22539 //
     /* 1290234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290287 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1290290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290312 */     // GIR_Coverage, 22539,
     /* 1290312 */     GIR_EraseRootFromParent_Done,
     /* 1290313 */   // Label 18469: @1290313
     /* 1290313 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1290397), // Rule ID 22542 //
     /* 1290318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290371 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1290374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290396 */     // GIR_Coverage, 22542,
     /* 1290396 */     GIR_EraseRootFromParent_Done,
     /* 1290397 */   // Label 18470: @1290397
     /* 1290397 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1290481), // Rule ID 22543 //
     /* 1290402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290455 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1290458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290480 */     // GIR_Coverage, 22543,
     /* 1290480 */     GIR_EraseRootFromParent_Done,
     /* 1290481 */   // Label 18471: @1290481
     /* 1290481 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1290565), // Rule ID 22546 //
     /* 1290486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290539 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1290542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290564 */     // GIR_Coverage, 22546,
     /* 1290564 */     GIR_EraseRootFromParent_Done,
     /* 1290565 */   // Label 18472: @1290565
     /* 1290565 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1290649), // Rule ID 22547 //
     /* 1290570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1290581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1290584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1290626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290648 */     // GIR_Coverage, 22547,
     /* 1290648 */     GIR_EraseRootFromParent_Done,
     /* 1290649 */   // Label 18473: @1290649
     /* 1290649 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1290733), // Rule ID 22550 //
     /* 1290654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1290665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1290668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1290710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290732 */     // GIR_Coverage, 22550,
     /* 1290732 */     GIR_EraseRootFromParent_Done,
     /* 1290733 */   // Label 18474: @1290733
     /* 1290733 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1290817), // Rule ID 22551 //
     /* 1290738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1290749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1290752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290791 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1290794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290816 */     // GIR_Coverage, 22551,
     /* 1290816 */     GIR_EraseRootFromParent_Done,
     /* 1290817 */   // Label 18475: @1290817
     /* 1290817 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1290901), // Rule ID 22554 //
     /* 1290822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1290833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1290836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290875 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1290875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1290878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290900 */     // GIR_Coverage, 22554,
     /* 1290900 */     GIR_EraseRootFromParent_Done,
     /* 1290901 */   // Label 18476: @1290901
     /* 1290901 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1290985), // Rule ID 22555 //
     /* 1290906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1290917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1290920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1290936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1290959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1290962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1290966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1290983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290984 */     // GIR_Coverage, 22555,
     /* 1290984 */     GIR_EraseRootFromParent_Done,
     /* 1290985 */   // Label 18477: @1290985
     /* 1290985 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1291069), // Rule ID 22558 //
     /* 1290990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1290998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1291001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1291004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1291046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291068 */     // GIR_Coverage, 22558,
     /* 1291068 */     GIR_EraseRootFromParent_Done,
     /* 1291069 */   // Label 18478: @1291069
     /* 1291069 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1291153), // Rule ID 22559 //
     /* 1291074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1291085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1291088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1291130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291152 */     // GIR_Coverage, 22559,
     /* 1291152 */     GIR_EraseRootFromParent_Done,
     /* 1291153 */   // Label 18479: @1291153
     /* 1291153 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1291237), // Rule ID 22562 //
     /* 1291158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1291214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291236 */     // GIR_Coverage, 22562,
     /* 1291236 */     GIR_EraseRootFromParent_Done,
     /* 1291237 */   // Label 18480: @1291237
     /* 1291237 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1291321), // Rule ID 22563 //
     /* 1291242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1291298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291320 */     // GIR_Coverage, 22563,
     /* 1291320 */     GIR_EraseRootFromParent_Done,
     /* 1291321 */   // Label 18481: @1291321
     /* 1291321 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1291405), // Rule ID 22566 //
     /* 1291326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1291337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1291340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1291382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291404 */     // GIR_Coverage, 22566,
     /* 1291404 */     GIR_EraseRootFromParent_Done,
     /* 1291405 */   // Label 18482: @1291405
     /* 1291405 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1291489), // Rule ID 22567 //
     /* 1291410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1291421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1291424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291463 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1291466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291488 */     // GIR_Coverage, 22567,
     /* 1291488 */     GIR_EraseRootFromParent_Done,
     /* 1291489 */   // Label 18483: @1291489
     /* 1291489 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1291573), // Rule ID 22570 //
     /* 1291494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1291505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1291508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291547 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1291550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291572 */     // GIR_Coverage, 22570,
     /* 1291572 */     GIR_EraseRootFromParent_Done,
     /* 1291573 */   // Label 18484: @1291573
     /* 1291573 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1291657), // Rule ID 22571 //
     /* 1291578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1291589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1291592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291631 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1291634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291656 */     // GIR_Coverage, 22571,
     /* 1291656 */     GIR_EraseRootFromParent_Done,
     /* 1291657 */   // Label 18485: @1291657
     /* 1291657 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1291741), // Rule ID 22574 //
     /* 1291662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1291718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291740 */     // GIR_Coverage, 22574,
     /* 1291740 */     GIR_EraseRootFromParent_Done,
     /* 1291741 */   // Label 18486: @1291741
     /* 1291741 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1291825), // Rule ID 22575 //
     /* 1291746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1291802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291824 */     // GIR_Coverage, 22575,
     /* 1291824 */     GIR_EraseRootFromParent_Done,
     /* 1291825 */   // Label 18487: @1291825
     /* 1291825 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1291909), // Rule ID 22578 //
     /* 1291830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1291883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1291886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291908 */     // GIR_Coverage, 22578,
     /* 1291908 */     GIR_EraseRootFromParent_Done,
     /* 1291909 */   // Label 18488: @1291909
     /* 1291909 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1291993), // Rule ID 22579 //
     /* 1291914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1291922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1291925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1291928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1291944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291967 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1291967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1291970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1291974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1291991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291992 */     // GIR_Coverage, 22579,
     /* 1291992 */     GIR_EraseRootFromParent_Done,
     /* 1291993 */   // Label 18489: @1291993
     /* 1291993 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1292077), // Rule ID 22582 //
     /* 1291998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1292009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1292012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1292018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1292054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292076 */     // GIR_Coverage, 22582,
     /* 1292076 */     GIR_EraseRootFromParent_Done,
     /* 1292077 */   // Label 18490: @1292077
     /* 1292077 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1292161), // Rule ID 22583 //
     /* 1292082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1292093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1292096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1292102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292135 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1292138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292160 */     // GIR_Coverage, 22583,
     /* 1292160 */     GIR_EraseRootFromParent_Done,
     /* 1292161 */   // Label 18491: @1292161
     /* 1292161 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1292245), // Rule ID 22586 //
     /* 1292166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1292222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292244 */     // GIR_Coverage, 22586,
     /* 1292244 */     GIR_EraseRootFromParent_Done,
     /* 1292245 */   // Label 18492: @1292245
     /* 1292245 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1292329), // Rule ID 22587 //
     /* 1292250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1292306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292328 */     // GIR_Coverage, 22587,
     /* 1292328 */     GIR_EraseRootFromParent_Done,
     /* 1292329 */   // Label 18493: @1292329
     /* 1292329 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1292413), // Rule ID 22590 //
     /* 1292334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1292390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292412 */     // GIR_Coverage, 22590,
     /* 1292412 */     GIR_EraseRootFromParent_Done,
     /* 1292413 */   // Label 18494: @1292413
     /* 1292413 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1292497), // Rule ID 22591 //
     /* 1292418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1292474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292496 */     // GIR_Coverage, 22591,
     /* 1292496 */     GIR_EraseRootFromParent_Done,
     /* 1292497 */   // Label 18495: @1292497
     /* 1292497 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1292581), // Rule ID 22594 //
     /* 1292502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1292558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292580 */     // GIR_Coverage, 22594,
     /* 1292580 */     GIR_EraseRootFromParent_Done,
     /* 1292581 */   // Label 18496: @1292581
     /* 1292581 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1292665), // Rule ID 22595 //
     /* 1292586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1292597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1292600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1292606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1292642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292664 */     // GIR_Coverage, 22595,
     /* 1292664 */     GIR_EraseRootFromParent_Done,
     /* 1292665 */   // Label 18497: @1292665
     /* 1292665 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1292749), // Rule ID 22598 //
     /* 1292670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1292681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1292684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1292690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292723 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1292726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292748 */     // GIR_Coverage, 22598,
     /* 1292748 */     GIR_EraseRootFromParent_Done,
     /* 1292749 */   // Label 18498: @1292749
     /* 1292749 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1292833), // Rule ID 22599 //
     /* 1292754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1292765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1292768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1292774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292807 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1292810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292832 */     // GIR_Coverage, 22599,
     /* 1292832 */     GIR_EraseRootFromParent_Done,
     /* 1292833 */   // Label 18499: @1292833
     /* 1292833 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1292917), // Rule ID 22602 //
     /* 1292838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1292849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1292852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1292858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292891 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1292891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1292894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292916 */     // GIR_Coverage, 22602,
     /* 1292916 */     GIR_EraseRootFromParent_Done,
     /* 1292917 */   // Label 18500: @1292917
     /* 1292917 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1293001), // Rule ID 22603 //
     /* 1292922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1292930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1292933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1292936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1292942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1292952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1292975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1292978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1292982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1292999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293000 */     // GIR_Coverage, 22603,
     /* 1293000 */     GIR_EraseRootFromParent_Done,
     /* 1293001 */   // Label 18501: @1293001
     /* 1293001 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1293085), // Rule ID 22606 //
     /* 1293006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1293014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1293017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1293020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1293026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1293062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293084 */     // GIR_Coverage, 22606,
     /* 1293084 */     GIR_EraseRootFromParent_Done,
     /* 1293085 */   // Label 18502: @1293085
     /* 1293085 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1293169), // Rule ID 22607 //
     /* 1293090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1293098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1293101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1293104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1293110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1293146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293168 */     // GIR_Coverage, 22607,
     /* 1293168 */     GIR_EraseRootFromParent_Done,
     /* 1293169 */   // Label 18503: @1293169
     /* 1293169 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1293253), // Rule ID 22610 //
     /* 1293174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1293230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293252 */     // GIR_Coverage, 22610,
     /* 1293252 */     GIR_EraseRootFromParent_Done,
     /* 1293253 */   // Label 18504: @1293253
     /* 1293253 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1293337), // Rule ID 22611 //
     /* 1293258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1293314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293336 */     // GIR_Coverage, 22611,
     /* 1293336 */     GIR_EraseRootFromParent_Done,
     /* 1293337 */   // Label 18505: @1293337
     /* 1293337 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1293421), // Rule ID 22614 //
     /* 1293342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1293398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293420 */     // GIR_Coverage, 22614,
     /* 1293420 */     GIR_EraseRootFromParent_Done,
     /* 1293421 */   // Label 18506: @1293421
     /* 1293421 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1293505), // Rule ID 22615 //
     /* 1293426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293479 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1293482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293504 */     // GIR_Coverage, 22615,
     /* 1293504 */     GIR_EraseRootFromParent_Done,
     /* 1293505 */   // Label 18507: @1293505
     /* 1293505 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1293589), // Rule ID 22618 //
     /* 1293510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293563 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1293566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293588 */     // GIR_Coverage, 22618,
     /* 1293588 */     GIR_EraseRootFromParent_Done,
     /* 1293589 */   // Label 18508: @1293589
     /* 1293589 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1293673), // Rule ID 22619 //
     /* 1293594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1293605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1293608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1293614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293647 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1293650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293672 */     // GIR_Coverage, 22619,
     /* 1293672 */     GIR_EraseRootFromParent_Done,
     /* 1293673 */   // Label 18509: @1293673
     /* 1293673 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1293757), // Rule ID 22622 //
     /* 1293678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1293689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1293692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1293698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293731 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1293734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293756 */     // GIR_Coverage, 22622,
     /* 1293756 */     GIR_EraseRootFromParent_Done,
     /* 1293757 */   // Label 18510: @1293757
     /* 1293757 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1293841), // Rule ID 22623 //
     /* 1293762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1293773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1293776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1293782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1293818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293840 */     // GIR_Coverage, 22623,
     /* 1293840 */     GIR_EraseRootFromParent_Done,
     /* 1293841 */   // Label 18511: @1293841
     /* 1293841 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1293925), // Rule ID 22626 //
     /* 1293846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1293857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1293860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1293863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1293866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1293899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1293902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1293923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293924 */     // GIR_Coverage, 22626,
     /* 1293924 */     GIR_EraseRootFromParent_Done,
     /* 1293925 */   // Label 18512: @1293925
     /* 1293925 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1294009), // Rule ID 22627 //
     /* 1293930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1293938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1293941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1293944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1293947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1293950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1293960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1293983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1293986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1293990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294008 */     // GIR_Coverage, 22627,
     /* 1294008 */     GIR_EraseRootFromParent_Done,
     /* 1294009 */   // Label 18513: @1294009
     /* 1294009 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1294093), // Rule ID 22630 //
     /* 1294014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1294025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1294028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1294034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294067 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1294070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294092 */     // GIR_Coverage, 22630,
     /* 1294092 */     GIR_EraseRootFromParent_Done,
     /* 1294093 */   // Label 18514: @1294093
     /* 1294093 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1294177), // Rule ID 22631 //
     /* 1294098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1294109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1294112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1294118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294151 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1294154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294176 */     // GIR_Coverage, 22631,
     /* 1294176 */     GIR_EraseRootFromParent_Done,
     /* 1294177 */   // Label 18515: @1294177
     /* 1294177 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1294261), // Rule ID 22634 //
     /* 1294182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294235 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1294238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294260 */     // GIR_Coverage, 22634,
     /* 1294260 */     GIR_EraseRootFromParent_Done,
     /* 1294261 */   // Label 18516: @1294261
     /* 1294261 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1294345), // Rule ID 22635 //
     /* 1294266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294319 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1294322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294344 */     // GIR_Coverage, 22635,
     /* 1294344 */     GIR_EraseRootFromParent_Done,
     /* 1294345 */   // Label 18517: @1294345
     /* 1294345 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1294429), // Rule ID 22638 //
     /* 1294350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1294361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1294364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1294370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294403 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1294406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294428 */     // GIR_Coverage, 22638,
     /* 1294428 */     GIR_EraseRootFromParent_Done,
     /* 1294429 */   // Label 18518: @1294429
     /* 1294429 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1294513), // Rule ID 22639 //
     /* 1294434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1294445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1294448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1294454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294487 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1294490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294512 */     // GIR_Coverage, 22639,
     /* 1294512 */     GIR_EraseRootFromParent_Done,
     /* 1294513 */   // Label 18519: @1294513
     /* 1294513 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1294597), // Rule ID 22642 //
     /* 1294518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1294529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1294532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1294538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1294574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294596 */     // GIR_Coverage, 22642,
     /* 1294596 */     GIR_EraseRootFromParent_Done,
     /* 1294597 */   // Label 18520: @1294597
     /* 1294597 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1294681), // Rule ID 22643 //
     /* 1294602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1294613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1294616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1294622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294655 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1294658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294680 */     // GIR_Coverage, 22643,
     /* 1294680 */     GIR_EraseRootFromParent_Done,
     /* 1294681 */   // Label 18521: @1294681
     /* 1294681 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1294765), // Rule ID 22646 //
     /* 1294686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1294703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1294709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1294724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1294742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294764 */     // GIR_Coverage, 22646,
     /* 1294764 */     GIR_EraseRootFromParent_Done,
     /* 1294765 */   // Label 18522: @1294765
     /* 1294765 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1294849), // Rule ID 22647 //
     /* 1294770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1294787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1294793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1294808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294823 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1294826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294848 */     // GIR_Coverage, 22647,
     /* 1294848 */     GIR_EraseRootFromParent_Done,
     /* 1294849 */   // Label 18523: @1294849
     /* 1294849 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1294933), // Rule ID 22650 //
     /* 1294854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1294871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1294877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1294892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1294907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1294910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1294931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294932 */     // GIR_Coverage, 22650,
     /* 1294932 */     GIR_EraseRootFromParent_Done,
     /* 1294933 */   // Label 18524: @1294933
     /* 1294933 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1295017), // Rule ID 22651 //
     /* 1294938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1294946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1294949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1294952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1294955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1294961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1294968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1294976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1294991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1294994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1294998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295016 */     // GIR_Coverage, 22651,
     /* 1295016 */     GIR_EraseRootFromParent_Done,
     /* 1295017 */   // Label 18525: @1295017
     /* 1295017 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1295101), // Rule ID 22654 //
     /* 1295022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1295033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1295036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1295042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1295078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295100 */     // GIR_Coverage, 22654,
     /* 1295100 */     GIR_EraseRootFromParent_Done,
     /* 1295101 */   // Label 18526: @1295101
     /* 1295101 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1295185), // Rule ID 22655 //
     /* 1295106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1295117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1295120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1295126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295159 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1295162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295184 */     // GIR_Coverage, 22655,
     /* 1295184 */     GIR_EraseRootFromParent_Done,
     /* 1295185 */   // Label 18527: @1295185
     /* 1295185 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1295269), // Rule ID 22658 //
     /* 1295190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1295246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295268 */     // GIR_Coverage, 22658,
     /* 1295268 */     GIR_EraseRootFromParent_Done,
     /* 1295269 */   // Label 18528: @1295269
     /* 1295269 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1295353), // Rule ID 22659 //
     /* 1295274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1295330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295352 */     // GIR_Coverage, 22659,
     /* 1295352 */     GIR_EraseRootFromParent_Done,
     /* 1295353 */   // Label 18529: @1295353
     /* 1295353 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1295437), // Rule ID 22662 //
     /* 1295358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1295414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295436 */     // GIR_Coverage, 22662,
     /* 1295436 */     GIR_EraseRootFromParent_Done,
     /* 1295437 */   // Label 18530: @1295437
     /* 1295437 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1295521), // Rule ID 22663 //
     /* 1295442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295495 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1295498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295520 */     // GIR_Coverage, 22663,
     /* 1295520 */     GIR_EraseRootFromParent_Done,
     /* 1295521 */   // Label 18531: @1295521
     /* 1295521 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1295605), // Rule ID 22666 //
     /* 1295526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295579 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1295582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295604 */     // GIR_Coverage, 22666,
     /* 1295604 */     GIR_EraseRootFromParent_Done,
     /* 1295605 */   // Label 18532: @1295605
     /* 1295605 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1295689), // Rule ID 22667 //
     /* 1295610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1295621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1295624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1295630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295663 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1295666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295688 */     // GIR_Coverage, 22667,
     /* 1295688 */     GIR_EraseRootFromParent_Done,
     /* 1295689 */   // Label 18533: @1295689
     /* 1295689 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1295773), // Rule ID 22670 //
     /* 1295694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1295705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1295708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1295711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1295714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295747 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1295750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295772 */     // GIR_Coverage, 22670,
     /* 1295772 */     GIR_EraseRootFromParent_Done,
     /* 1295773 */   // Label 18534: @1295773
     /* 1295773 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1295857), // Rule ID 22671 //
     /* 1295778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1295789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1295792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1295795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1295798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295831 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1295834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295856 */     // GIR_Coverage, 22671,
     /* 1295856 */     GIR_EraseRootFromParent_Done,
     /* 1295857 */   // Label 18535: @1295857
     /* 1295857 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1295941), // Rule ID 22674 //
     /* 1295862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1295873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1295876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1295879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1295882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1295915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1295918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1295922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1295939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295940 */     // GIR_Coverage, 22674,
     /* 1295940 */     GIR_EraseRootFromParent_Done,
     /* 1295941 */   // Label 18536: @1295941
     /* 1295941 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1296025), // Rule ID 22675 //
     /* 1295946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1295954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1295957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1295960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1295963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1295966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1295976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1295999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1296002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296024 */     // GIR_Coverage, 22675,
     /* 1296024 */     GIR_EraseRootFromParent_Done,
     /* 1296025 */   // Label 18537: @1296025
     /* 1296025 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1296109), // Rule ID 22678 //
     /* 1296030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1296038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1296041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1296044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1296050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1296086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296108 */     // GIR_Coverage, 22678,
     /* 1296108 */     GIR_EraseRootFromParent_Done,
     /* 1296109 */   // Label 18538: @1296109
     /* 1296109 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1296193), // Rule ID 22679 //
     /* 1296114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1296122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1296125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1296128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1296134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296167 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1296167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1296170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296192 */     // GIR_Coverage, 22679,
     /* 1296192 */     GIR_EraseRootFromParent_Done,
     /* 1296193 */   // Label 18539: @1296193
     /* 1296193 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1296277), // Rule ID 22798 //
     /* 1296198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1296201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1296215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296251 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1296254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296276 */     // GIR_Coverage, 22798,
     /* 1296276 */     GIR_EraseRootFromParent_Done,
     /* 1296277 */   // Label 18540: @1296277
     /* 1296277 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1296361), // Rule ID 22799 //
     /* 1296282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1296285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1296299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296335 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1296335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1296338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296360 */     // GIR_Coverage, 22799,
     /* 1296360 */     GIR_EraseRootFromParent_Done,
     /* 1296361 */   // Label 18541: @1296361
     /* 1296361 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1296445), // Rule ID 22802 //
     /* 1296366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1296369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1296383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296419 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1296422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296444 */     // GIR_Coverage, 22802,
     /* 1296444 */     GIR_EraseRootFromParent_Done,
     /* 1296445 */   // Label 18542: @1296445
     /* 1296445 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1296529), // Rule ID 22803 //
     /* 1296450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1296453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1296467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296503 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1296503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1296506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296528 */     // GIR_Coverage, 22803,
     /* 1296528 */     GIR_EraseRootFromParent_Done,
     /* 1296529 */   // Label 18543: @1296529
     /* 1296529 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1296613), // Rule ID 22806 //
     /* 1296534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1296537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1296545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1296548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1296551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1296554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1296590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296612 */     // GIR_Coverage, 22806,
     /* 1296612 */     GIR_EraseRootFromParent_Done,
     /* 1296613 */   // Label 18544: @1296613
     /* 1296613 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1296697), // Rule ID 22807 //
     /* 1296618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1296621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1296629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1296632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1296635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1296638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296671 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1296671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1296674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296696 */     // GIR_Coverage, 22807,
     /* 1296696 */     GIR_EraseRootFromParent_Done,
     /* 1296697 */   // Label 18545: @1296697
     /* 1296697 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1296781), // Rule ID 22810 //
     /* 1296702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1296705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1296719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296755 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1296758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296780 */     // GIR_Coverage, 22810,
     /* 1296780 */     GIR_EraseRootFromParent_Done,
     /* 1296781 */   // Label 18546: @1296781
     /* 1296781 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1296865), // Rule ID 22811 //
     /* 1296786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1296789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1296797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1296800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1296803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1296806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296839 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1296839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1296842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296864 */     // GIR_Coverage, 22811,
     /* 1296864 */     GIR_EraseRootFromParent_Done,
     /* 1296865 */   // Label 18547: @1296865
     /* 1296865 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1296949), // Rule ID 22814 //
     /* 1296870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1296873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1296881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1296884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1296887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1296890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296923 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1296923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1296926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1296930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1296947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296948 */     // GIR_Coverage, 22814,
     /* 1296948 */     GIR_EraseRootFromParent_Done,
     /* 1296949 */   // Label 18548: @1296949
     /* 1296949 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1297033), // Rule ID 22815 //
     /* 1296954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1296957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1296962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1296965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1296968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1296971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1296974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1296984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297007 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1297010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297032 */     // GIR_Coverage, 22815,
     /* 1297032 */     GIR_EraseRootFromParent_Done,
     /* 1297033 */   // Label 18549: @1297033
     /* 1297033 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1297117), // Rule ID 22818 //
     /* 1297038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1297041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1297049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1297052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1297055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1297058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297091 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1297094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297116 */     // GIR_Coverage, 22818,
     /* 1297116 */     GIR_EraseRootFromParent_Done,
     /* 1297117 */   // Label 18550: @1297117
     /* 1297117 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1297201), // Rule ID 22819 //
     /* 1297122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1297125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1297133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1297136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1297139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1297142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297175 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1297178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297200 */     // GIR_Coverage, 22819,
     /* 1297200 */     GIR_EraseRootFromParent_Done,
     /* 1297201 */   // Label 18551: @1297201
     /* 1297201 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1297285), // Rule ID 22822 //
     /* 1297206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1297209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1297223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1297262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297284 */     // GIR_Coverage, 22822,
     /* 1297284 */     GIR_EraseRootFromParent_Done,
     /* 1297285 */   // Label 18552: @1297285
     /* 1297285 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1297369), // Rule ID 22823 //
     /* 1297290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1297293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1297307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297343 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1297346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297368 */     // GIR_Coverage, 22823,
     /* 1297368 */     GIR_EraseRootFromParent_Done,
     /* 1297369 */   // Label 18553: @1297369
     /* 1297369 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1297453), // Rule ID 22826 //
     /* 1297374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1297377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1297391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1297430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297452 */     // GIR_Coverage, 22826,
     /* 1297452 */     GIR_EraseRootFromParent_Done,
     /* 1297453 */   // Label 18554: @1297453
     /* 1297453 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1297537), // Rule ID 22827 //
     /* 1297458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1297461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1297475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297511 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1297514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297536 */     // GIR_Coverage, 22827,
     /* 1297536 */     GIR_EraseRootFromParent_Done,
     /* 1297537 */   // Label 18555: @1297537
     /* 1297537 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1297621), // Rule ID 22830 //
     /* 1297542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1297545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1297559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1297565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1297598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297620 */     // GIR_Coverage, 22830,
     /* 1297620 */     GIR_EraseRootFromParent_Done,
     /* 1297621 */   // Label 18556: @1297621
     /* 1297621 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1297705), // Rule ID 22831 //
     /* 1297626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1297629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1297637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1297640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1297643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1297646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1297649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297679 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10947:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1297682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297704 */     // GIR_Coverage, 22831,
     /* 1297704 */     GIR_EraseRootFromParent_Done,
     /* 1297705 */   // Label 18557: @1297705
     /* 1297705 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1297789), // Rule ID 22834 //
     /* 1297710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1297713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1297721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1297724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1297727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1297730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297763 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1297766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297788 */     // GIR_Coverage, 22834,
     /* 1297788 */     GIR_EraseRootFromParent_Done,
     /* 1297789 */   // Label 18558: @1297789
     /* 1297789 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1297873), // Rule ID 22835 //
     /* 1297794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1297797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1297805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1297808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1297811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1297814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297847 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1297847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1297850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297872 */     // GIR_Coverage, 22835,
     /* 1297872 */     GIR_EraseRootFromParent_Done,
     /* 1297873 */   // Label 18559: @1297873
     /* 1297873 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1297957), // Rule ID 22838 //
     /* 1297878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1297881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1297889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1297892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1297895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1297898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297931 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1297931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1297934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1297938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1297955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297956 */     // GIR_Coverage, 22838,
     /* 1297956 */     GIR_EraseRootFromParent_Done,
     /* 1297957 */   // Label 18560: @1297957
     /* 1297957 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1298041), // Rule ID 22839 //
     /* 1297962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1297965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1297970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1297973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1297976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1297979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1297982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1297992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1298018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298040 */     // GIR_Coverage, 22839,
     /* 1298040 */     GIR_EraseRootFromParent_Done,
     /* 1298041 */   // Label 18561: @1298041
     /* 1298041 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1298125), // Rule ID 22842 //
     /* 1298046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1298049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1298057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1298060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1298063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1298066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1298102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298124 */     // GIR_Coverage, 22842,
     /* 1298124 */     GIR_EraseRootFromParent_Done,
     /* 1298125 */   // Label 18562: @1298125
     /* 1298125 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1298209), // Rule ID 22843 //
     /* 1298130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1298133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1298141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1298144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1298147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1298150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298183 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10947:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1298186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298208 */     // GIR_Coverage, 22843,
     /* 1298208 */     GIR_EraseRootFromParent_Done,
     /* 1298209 */   // Label 18563: @1298209
     /* 1298209 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1298293), // Rule ID 22846 //
     /* 1298214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1298217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1298231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298267 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1298270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298292 */     // GIR_Coverage, 22846,
     /* 1298292 */     GIR_EraseRootFromParent_Done,
     /* 1298293 */   // Label 18564: @1298293
     /* 1298293 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1298377), // Rule ID 22847 //
     /* 1298298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1298301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1298315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298351 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1298354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298376 */     // GIR_Coverage, 22847,
     /* 1298376 */     GIR_EraseRootFromParent_Done,
     /* 1298377 */   // Label 18565: @1298377
     /* 1298377 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1298461), // Rule ID 22850 //
     /* 1298382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1298385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1298399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298435 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1298438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298460 */     // GIR_Coverage, 22850,
     /* 1298460 */     GIR_EraseRootFromParent_Done,
     /* 1298461 */   // Label 18566: @1298461
     /* 1298461 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1298545), // Rule ID 22851 //
     /* 1298466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1298469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1298483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298519 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1298522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298544 */     // GIR_Coverage, 22851,
     /* 1298544 */     GIR_EraseRootFromParent_Done,
     /* 1298545 */   // Label 18567: @1298545
     /* 1298545 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1298629), // Rule ID 22854 //
     /* 1298550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1298553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1298567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298603 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1298606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298628 */     // GIR_Coverage, 22854,
     /* 1298628 */     GIR_EraseRootFromParent_Done,
     /* 1298629 */   // Label 18568: @1298629
     /* 1298629 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1298713), // Rule ID 22855 //
     /* 1298634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1298637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1298642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1298645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1298648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1298651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1298654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298687 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10947:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1298690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298712 */     // GIR_Coverage, 22855,
     /* 1298712 */     GIR_EraseRootFromParent_Done,
     /* 1298713 */   // Label 18569: @1298713
     /* 1298713 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1298797), // Rule ID 22858 //
     /* 1298718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1298721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1298726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1298729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1298732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298771 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1298774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298796 */     // GIR_Coverage, 22858,
     /* 1298796 */     GIR_EraseRootFromParent_Done,
     /* 1298797 */   // Label 18570: @1298797
     /* 1298797 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1298881), // Rule ID 22859 //
     /* 1298802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1298805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1298810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1298813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1298816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298855 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1298855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1298858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298880 */     // GIR_Coverage, 22859,
     /* 1298880 */     GIR_EraseRootFromParent_Done,
     /* 1298881 */   // Label 18571: @1298881
     /* 1298881 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1298965), // Rule ID 22862 //
     /* 1298886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1298889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1298894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1298897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1298900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1298916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298939 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1298939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1298942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1298946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1298963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298964 */     // GIR_Coverage, 22862,
     /* 1298964 */     GIR_EraseRootFromParent_Done,
     /* 1298965 */   // Label 18572: @1298965
     /* 1298965 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1299049), // Rule ID 22863 //
     /* 1298970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1298973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1298978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1298981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1298984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299023 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1299026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299048 */     // GIR_Coverage, 22863,
     /* 1299048 */     GIR_EraseRootFromParent_Done,
     /* 1299049 */   // Label 18573: @1299049
     /* 1299049 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1299133), // Rule ID 22866 //
     /* 1299054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1299057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1299065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1299068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1299071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1299074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299107 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1299110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299132 */     // GIR_Coverage, 22866,
     /* 1299132 */     GIR_EraseRootFromParent_Done,
     /* 1299133 */   // Label 18574: @1299133
     /* 1299133 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1299217), // Rule ID 22867 //
     /* 1299138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1299141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1299149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1299152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1299155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1299158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299191 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1299194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299216 */     // GIR_Coverage, 22867,
     /* 1299216 */     GIR_EraseRootFromParent_Done,
     /* 1299217 */   // Label 18575: @1299217
     /* 1299217 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1299301), // Rule ID 22870 //
     /* 1299222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1299225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1299239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299275 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1299278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299300 */     // GIR_Coverage, 22870,
     /* 1299300 */     GIR_EraseRootFromParent_Done,
     /* 1299301 */   // Label 18576: @1299301
     /* 1299301 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1299385), // Rule ID 22871 //
     /* 1299306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1299309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1299323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299359 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1299362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299384 */     // GIR_Coverage, 22871,
     /* 1299384 */     GIR_EraseRootFromParent_Done,
     /* 1299385 */   // Label 18577: @1299385
     /* 1299385 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1299469), // Rule ID 22874 //
     /* 1299390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1299393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1299401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1299404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1299407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1299410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299443 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1299446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299468 */     // GIR_Coverage, 22874,
     /* 1299468 */     GIR_EraseRootFromParent_Done,
     /* 1299469 */   // Label 18578: @1299469
     /* 1299469 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1299553), // Rule ID 22875 //
     /* 1299474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1299477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1299485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1299488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1299491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1299494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299527 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1299530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299552 */     // GIR_Coverage, 22875,
     /* 1299552 */     GIR_EraseRootFromParent_Done,
     /* 1299553 */   // Label 18579: @1299553
     /* 1299553 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1299637), // Rule ID 22878 //
     /* 1299558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1299561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1299569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1299572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1299578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299611 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1299614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299636 */     // GIR_Coverage, 22878,
     /* 1299636 */     GIR_EraseRootFromParent_Done,
     /* 1299637 */   // Label 18580: @1299637
     /* 1299637 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1299721), // Rule ID 22879 //
     /* 1299642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1299645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1299653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1299656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1299662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299695 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1299698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299720 */     // GIR_Coverage, 22879,
     /* 1299720 */     GIR_EraseRootFromParent_Done,
     /* 1299721 */   // Label 18581: @1299721
     /* 1299721 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1299805), // Rule ID 22882 //
     /* 1299726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1299729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299779 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1299782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299804 */     // GIR_Coverage, 22882,
     /* 1299804 */     GIR_EraseRootFromParent_Done,
     /* 1299805 */   // Label 18582: @1299805
     /* 1299805 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1299889), // Rule ID 22883 //
     /* 1299810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1299813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299863 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1299863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1299866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299888 */     // GIR_Coverage, 22883,
     /* 1299888 */     GIR_EraseRootFromParent_Done,
     /* 1299889 */   // Label 18583: @1299889
     /* 1299889 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1299973), // Rule ID 22886 //
     /* 1299894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1299897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1299924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299947 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1299947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1299950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1299954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1299971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299972 */     // GIR_Coverage, 22886,
     /* 1299972 */     GIR_EraseRootFromParent_Done,
     /* 1299973 */   // Label 18584: @1299973
     /* 1299973 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1300057), // Rule ID 22887 //
     /* 1299978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1299981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1299986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1299989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1299992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1299998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300031 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1300034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300056 */     // GIR_Coverage, 22887,
     /* 1300056 */     GIR_EraseRootFromParent_Done,
     /* 1300057 */   // Label 18585: @1300057
     /* 1300057 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1300141), // Rule ID 22890 //
     /* 1300062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1300065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1300073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1300076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1300082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1300118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300140 */     // GIR_Coverage, 22890,
     /* 1300140 */     GIR_EraseRootFromParent_Done,
     /* 1300141 */   // Label 18586: @1300141
     /* 1300141 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1300225), // Rule ID 22891 //
     /* 1300146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1300149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1300157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1300160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1300166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300199 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10945:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1300202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300224 */     // GIR_Coverage, 22891,
     /* 1300224 */     GIR_EraseRootFromParent_Done,
     /* 1300225 */   // Label 18587: @1300225
     /* 1300225 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1300309), // Rule ID 22894 //
     /* 1300230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1300233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300283 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1300286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300308 */     // GIR_Coverage, 22894,
     /* 1300308 */     GIR_EraseRootFromParent_Done,
     /* 1300309 */   // Label 18588: @1300309
     /* 1300309 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1300393), // Rule ID 22895 //
     /* 1300314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1300317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300367 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1300370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300392 */     // GIR_Coverage, 22895,
     /* 1300392 */     GIR_EraseRootFromParent_Done,
     /* 1300393 */   // Label 18589: @1300393
     /* 1300393 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1300477), // Rule ID 22898 //
     /* 1300398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1300401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300451 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1300454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300476 */     // GIR_Coverage, 22898,
     /* 1300476 */     GIR_EraseRootFromParent_Done,
     /* 1300477 */   // Label 18590: @1300477
     /* 1300477 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1300561), // Rule ID 22899 //
     /* 1300482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1300485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300535 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1300538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300560 */     // GIR_Coverage, 22899,
     /* 1300560 */     GIR_EraseRootFromParent_Done,
     /* 1300561 */   // Label 18591: @1300561
     /* 1300561 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1300645), // Rule ID 22902 //
     /* 1300566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1300569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1300622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300644 */     // GIR_Coverage, 22902,
     /* 1300644 */     GIR_EraseRootFromParent_Done,
     /* 1300645 */   // Label 18592: @1300645
     /* 1300645 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1300729), // Rule ID 22903 //
     /* 1300650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1300653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1300661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1300664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1300670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300703 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10945:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1300706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300728 */     // GIR_Coverage, 22903,
     /* 1300728 */     GIR_EraseRootFromParent_Done,
     /* 1300729 */   // Label 18593: @1300729
     /* 1300729 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1300813), // Rule ID 22906 //
     /* 1300734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1300737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1300745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1300748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1300754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300787 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1300790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300812 */     // GIR_Coverage, 22906,
     /* 1300812 */     GIR_EraseRootFromParent_Done,
     /* 1300813 */   // Label 18594: @1300813
     /* 1300813 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1300897), // Rule ID 22907 //
     /* 1300818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1300821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1300829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1300832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1300838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300871 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1300871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1300874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300896 */     // GIR_Coverage, 22907,
     /* 1300896 */     GIR_EraseRootFromParent_Done,
     /* 1300897 */   // Label 18595: @1300897
     /* 1300897 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1300981), // Rule ID 22910 //
     /* 1300902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1300905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1300913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1300916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1300922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1300932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300955 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1300955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1300958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1300962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1300979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300980 */     // GIR_Coverage, 22910,
     /* 1300980 */     GIR_EraseRootFromParent_Done,
     /* 1300981 */   // Label 18596: @1300981
     /* 1300981 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1301065), // Rule ID 22911 //
     /* 1300986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1300989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1300994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1300997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1301000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1301003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1301006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301039 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1301039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1301042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1301046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1301063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301064 */     // GIR_Coverage, 22911,
     /* 1301064 */     GIR_EraseRootFromParent_Done,
     /* 1301065 */   // Label 18597: @1301065
     /* 1301065 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1301149), // Rule ID 22914 //
     /* 1301070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1301073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1301078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1301081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1301084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1301090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301123 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1301123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1301126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1301130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1301147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301148 */     // GIR_Coverage, 22914,
     /* 1301148 */     GIR_EraseRootFromParent_Done,
     /* 1301149 */   // Label 18598: @1301149
     /* 1301149 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1301233), // Rule ID 22915 //
     /* 1301154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1301157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1301162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1301165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1301168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1301174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301207 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10945:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1301207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1301210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1301214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1301231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301232 */     // GIR_Coverage, 22915,
     /* 1301232 */     GIR_EraseRootFromParent_Done,
     /* 1301233 */   // Label 18599: @1301233
     /* 1301233 */   GIM_Reject,
     /* 1301234 */ // Label 12619: @1301234
     /* 1301234 */ GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1910391),
     /* 1301239 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1301242 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1301328), // Rule ID 7208 //
     /* 1301247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1301258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1301261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301293 */     // MIs[0] policy
     /* 1301293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301303 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1301303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1301306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301327 */     // GIR_Coverage, 7208,
     /* 1301327 */     GIR_EraseRootFromParent_Done,
     /* 1301328 */   // Label 18601: @1301328
     /* 1301328 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1301414), // Rule ID 7209 //
     /* 1301333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1301344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1301347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301379 */     // MIs[0] policy
     /* 1301379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301389 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1301389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1301392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301413 */     // GIR_Coverage, 7209,
     /* 1301413 */     GIR_EraseRootFromParent_Done,
     /* 1301414 */   // Label 18602: @1301414
     /* 1301414 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1301500), // Rule ID 7212 //
     /* 1301419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1301430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1301433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301465 */     // MIs[0] policy
     /* 1301465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1301475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1301478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301499 */     // GIR_Coverage, 7212,
     /* 1301499 */     GIR_EraseRootFromParent_Done,
     /* 1301500 */   // Label 18603: @1301500
     /* 1301500 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1301586), // Rule ID 7213 //
     /* 1301505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1301516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1301519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301551 */     // MIs[0] policy
     /* 1301551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301561 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1301561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1301564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301585 */     // GIR_Coverage, 7213,
     /* 1301585 */     GIR_EraseRootFromParent_Done,
     /* 1301586 */   // Label 18604: @1301586
     /* 1301586 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1301672), // Rule ID 7216 //
     /* 1301591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1301602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1301605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301637 */     // MIs[0] policy
     /* 1301637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301647 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1301647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1301650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301671 */     // GIR_Coverage, 7216,
     /* 1301671 */     GIR_EraseRootFromParent_Done,
     /* 1301672 */   // Label 18605: @1301672
     /* 1301672 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1301758), // Rule ID 7217 //
     /* 1301677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1301688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1301691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301723 */     // MIs[0] policy
     /* 1301723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301733 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1301733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1301736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301757 */     // GIR_Coverage, 7217,
     /* 1301757 */     GIR_EraseRootFromParent_Done,
     /* 1301758 */   // Label 18606: @1301758
     /* 1301758 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1301844), // Rule ID 7220 //
     /* 1301763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1301774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1301777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301809 */     // MIs[0] policy
     /* 1301809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301819 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1301819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1301822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301843 */     // GIR_Coverage, 7220,
     /* 1301843 */     GIR_EraseRootFromParent_Done,
     /* 1301844 */   // Label 18607: @1301844
     /* 1301844 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1301930), // Rule ID 7221 //
     /* 1301849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1301860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1301863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301895 */     // MIs[0] policy
     /* 1301895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301905 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1301905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1301908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1301928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301929 */     // GIR_Coverage, 7221,
     /* 1301929 */     GIR_EraseRootFromParent_Done,
     /* 1301930 */   // Label 18608: @1301930
     /* 1301930 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1302016), // Rule ID 7224 //
     /* 1301935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1301943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1301946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1301949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1301965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1301977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301981 */     // MIs[0] policy
     /* 1301981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1301984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1301991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1301994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302015 */     // GIR_Coverage, 7224,
     /* 1302015 */     GIR_EraseRootFromParent_Done,
     /* 1302016 */   // Label 18609: @1302016
     /* 1302016 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1302102), // Rule ID 7225 //
     /* 1302021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1302032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1302035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1302038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302067 */     // MIs[0] policy
     /* 1302067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1302080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302101 */     // GIR_Coverage, 7225,
     /* 1302101 */     GIR_EraseRootFromParent_Done,
     /* 1302102 */   // Label 18610: @1302102
     /* 1302102 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1302188), // Rule ID 7228 //
     /* 1302107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1302118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1302121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302153 */     // MIs[0] policy
     /* 1302153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302163 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1302163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1302166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302187 */     // GIR_Coverage, 7228,
     /* 1302187 */     GIR_EraseRootFromParent_Done,
     /* 1302188 */   // Label 18611: @1302188
     /* 1302188 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1302274), // Rule ID 7229 //
     /* 1302193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1302204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1302207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302239 */     // MIs[0] policy
     /* 1302239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1302252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302273 */     // GIR_Coverage, 7229,
     /* 1302273 */     GIR_EraseRootFromParent_Done,
     /* 1302274 */   // Label 18612: @1302274
     /* 1302274 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1302360), // Rule ID 7232 //
     /* 1302279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1302290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1302293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302325 */     // MIs[0] policy
     /* 1302325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302335 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1302335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302359 */     // GIR_Coverage, 7232,
     /* 1302359 */     GIR_EraseRootFromParent_Done,
     /* 1302360 */   // Label 18613: @1302360
     /* 1302360 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1302446), // Rule ID 7233 //
     /* 1302365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1302376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1302379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302411 */     // MIs[0] policy
     /* 1302411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302421 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302445 */     // GIR_Coverage, 7233,
     /* 1302445 */     GIR_EraseRootFromParent_Done,
     /* 1302446 */   // Label 18614: @1302446
     /* 1302446 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1302532), // Rule ID 7236 //
     /* 1302451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1302462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1302465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302497 */     // MIs[0] policy
     /* 1302497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1302507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302531 */     // GIR_Coverage, 7236,
     /* 1302531 */     GIR_EraseRootFromParent_Done,
     /* 1302532 */   // Label 18615: @1302532
     /* 1302532 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1302618), // Rule ID 7237 //
     /* 1302537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1302548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1302551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302583 */     // MIs[0] policy
     /* 1302583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302593 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302617 */     // GIR_Coverage, 7237,
     /* 1302617 */     GIR_EraseRootFromParent_Done,
     /* 1302618 */   // Label 18616: @1302618
     /* 1302618 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1302704), // Rule ID 7240 //
     /* 1302623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1302634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1302637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302669 */     // MIs[0] policy
     /* 1302669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1302679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302703 */     // GIR_Coverage, 7240,
     /* 1302703 */     GIR_EraseRootFromParent_Done,
     /* 1302704 */   // Label 18617: @1302704
     /* 1302704 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1302790), // Rule ID 7241 //
     /* 1302709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1302720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1302723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302755 */     // MIs[0] policy
     /* 1302755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302789 */     // GIR_Coverage, 7241,
     /* 1302789 */     GIR_EraseRootFromParent_Done,
     /* 1302790 */   // Label 18618: @1302790
     /* 1302790 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1302876), // Rule ID 7244 //
     /* 1302795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1302806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1302809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302841 */     // MIs[0] policy
     /* 1302841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1302851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302875 */     // GIR_Coverage, 7244,
     /* 1302875 */     GIR_EraseRootFromParent_Done,
     /* 1302876 */   // Label 18619: @1302876
     /* 1302876 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1302962), // Rule ID 7245 //
     /* 1302881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1302892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1302895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1302911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1302923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302927 */     // MIs[0] policy
     /* 1302927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1302930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302937 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1302937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1302940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1302960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302961 */     // GIR_Coverage, 7245,
     /* 1302961 */     GIR_EraseRootFromParent_Done,
     /* 1302962 */   // Label 18620: @1302962
     /* 1302962 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1303048), // Rule ID 7248 //
     /* 1302967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1302975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1302978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1302981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1302997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303013 */     // MIs[0] policy
     /* 1303013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303023 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1303026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303047 */     // GIR_Coverage, 7248,
     /* 1303047 */     GIR_EraseRootFromParent_Done,
     /* 1303048 */   // Label 18621: @1303048
     /* 1303048 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1303134), // Rule ID 7249 //
     /* 1303053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1303064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1303067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1303070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1303083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303099 */     // MIs[0] policy
     /* 1303099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1303112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303133 */     // GIR_Coverage, 7249,
     /* 1303133 */     GIR_EraseRootFromParent_Done,
     /* 1303134 */   // Label 18622: @1303134
     /* 1303134 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1303220), // Rule ID 7252 //
     /* 1303139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1303150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1303153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1303169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303185 */     // MIs[0] policy
     /* 1303185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303195 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1303198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303219 */     // GIR_Coverage, 7252,
     /* 1303219 */     GIR_EraseRootFromParent_Done,
     /* 1303220 */   // Label 18623: @1303220
     /* 1303220 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1303306), // Rule ID 7253 //
     /* 1303225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1303236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1303239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1303255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303271 */     // MIs[0] policy
     /* 1303271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303281 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1303284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303305 */     // GIR_Coverage, 7253,
     /* 1303305 */     GIR_EraseRootFromParent_Done,
     /* 1303306 */   // Label 18624: @1303306
     /* 1303306 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1303392), // Rule ID 7256 //
     /* 1303311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1303322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1303325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1303341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303357 */     // MIs[0] policy
     /* 1303357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303367 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1303370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303391 */     // GIR_Coverage, 7256,
     /* 1303391 */     GIR_EraseRootFromParent_Done,
     /* 1303392 */   // Label 18625: @1303392
     /* 1303392 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1303478), // Rule ID 7257 //
     /* 1303397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1303408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1303411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1303427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303443 */     // MIs[0] policy
     /* 1303443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303453 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1303456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303477 */     // GIR_Coverage, 7257,
     /* 1303477 */     GIR_EraseRootFromParent_Done,
     /* 1303478 */   // Label 18626: @1303478
     /* 1303478 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1303564), // Rule ID 7260 //
     /* 1303483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1303494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1303497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1303513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303529 */     // MIs[0] policy
     /* 1303529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1303542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303563 */     // GIR_Coverage, 7260,
     /* 1303563 */     GIR_EraseRootFromParent_Done,
     /* 1303564 */   // Label 18627: @1303564
     /* 1303564 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1303650), // Rule ID 7261 //
     /* 1303569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1303580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1303583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1303599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303615 */     // MIs[0] policy
     /* 1303615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1303628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303649 */     // GIR_Coverage, 7261,
     /* 1303649 */     GIR_EraseRootFromParent_Done,
     /* 1303650 */   // Label 18628: @1303650
     /* 1303650 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1303736), // Rule ID 7264 //
     /* 1303655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1303666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1303669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1303685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303701 */     // MIs[0] policy
     /* 1303701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1303714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303735 */     // GIR_Coverage, 7264,
     /* 1303735 */     GIR_EraseRootFromParent_Done,
     /* 1303736 */   // Label 18629: @1303736
     /* 1303736 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1303822), // Rule ID 7265 //
     /* 1303741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1303752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1303755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1303771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303787 */     // MIs[0] policy
     /* 1303787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303797 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1303800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303821 */     // GIR_Coverage, 7265,
     /* 1303821 */     GIR_EraseRootFromParent_Done,
     /* 1303822 */   // Label 18630: @1303822
     /* 1303822 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1303908), // Rule ID 7268 //
     /* 1303827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1303838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1303841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1303857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303873 */     // MIs[0] policy
     /* 1303873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303883 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1303883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1303886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303907 */     // GIR_Coverage, 7268,
     /* 1303907 */     GIR_EraseRootFromParent_Done,
     /* 1303908 */   // Label 18631: @1303908
     /* 1303908 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1303994), // Rule ID 7269 //
     /* 1303913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1303921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1303924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1303927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1303943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1303955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303959 */     // MIs[0] policy
     /* 1303959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1303962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1303969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1303972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1303992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303993 */     // GIR_Coverage, 7269,
     /* 1303993 */     GIR_EraseRootFromParent_Done,
     /* 1303994 */   // Label 18632: @1303994
     /* 1303994 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1304080), // Rule ID 7272 //
     /* 1303999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1304010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1304013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1304029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304045 */     // MIs[0] policy
     /* 1304045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1304058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304079 */     // GIR_Coverage, 7272,
     /* 1304079 */     GIR_EraseRootFromParent_Done,
     /* 1304080 */   // Label 18633: @1304080
     /* 1304080 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1304166), // Rule ID 7273 //
     /* 1304085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1304096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1304099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1304115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304131 */     // MIs[0] policy
     /* 1304131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1304141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1304144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304165 */     // GIR_Coverage, 7273,
     /* 1304165 */     GIR_EraseRootFromParent_Done,
     /* 1304166 */   // Label 18634: @1304166
     /* 1304166 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1304252), // Rule ID 7276 //
     /* 1304171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1304182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1304185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1304201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304217 */     // MIs[0] policy
     /* 1304217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1304230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304251 */     // GIR_Coverage, 7276,
     /* 1304251 */     GIR_EraseRootFromParent_Done,
     /* 1304252 */   // Label 18635: @1304252
     /* 1304252 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1304338), // Rule ID 7277 //
     /* 1304257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1304268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1304271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1304287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304303 */     // MIs[0] policy
     /* 1304303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1304313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1304316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304337 */     // GIR_Coverage, 7277,
     /* 1304337 */     GIR_EraseRootFromParent_Done,
     /* 1304338 */   // Label 18636: @1304338
     /* 1304338 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1304424), // Rule ID 7280 //
     /* 1304343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1304354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1304357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1304373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304389 */     // MIs[0] policy
     /* 1304389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304399 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1304402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304423 */     // GIR_Coverage, 7280,
     /* 1304423 */     GIR_EraseRootFromParent_Done,
     /* 1304424 */   // Label 18637: @1304424
     /* 1304424 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1304510), // Rule ID 7281 //
     /* 1304429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1304440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1304443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1304459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304475 */     // MIs[0] policy
     /* 1304475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1304485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1304488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304509 */     // GIR_Coverage, 7281,
     /* 1304509 */     GIR_EraseRootFromParent_Done,
     /* 1304510 */   // Label 18638: @1304510
     /* 1304510 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1304596), // Rule ID 7284 //
     /* 1304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1304526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1304529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1304545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304561 */     // MIs[0] policy
     /* 1304561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1304574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304595 */     // GIR_Coverage, 7284,
     /* 1304595 */     GIR_EraseRootFromParent_Done,
     /* 1304596 */   // Label 18639: @1304596
     /* 1304596 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1304682), // Rule ID 7285 //
     /* 1304601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1304612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1304615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1304631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304647 */     // MIs[0] policy
     /* 1304647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1304657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1304660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304681 */     // GIR_Coverage, 7285,
     /* 1304681 */     GIR_EraseRootFromParent_Done,
     /* 1304682 */   // Label 18640: @1304682
     /* 1304682 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1304768), // Rule ID 7288 //
     /* 1304687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1304698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1304701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1304717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304733 */     // MIs[0] policy
     /* 1304733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304743 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1304746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304767 */     // GIR_Coverage, 7288,
     /* 1304767 */     GIR_EraseRootFromParent_Done,
     /* 1304768 */   // Label 18641: @1304768
     /* 1304768 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1304854), // Rule ID 7289 //
     /* 1304773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1304784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1304787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1304803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304819 */     // MIs[0] policy
     /* 1304819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304829 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1304829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1304832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304853 */     // GIR_Coverage, 7289,
     /* 1304853 */     GIR_EraseRootFromParent_Done,
     /* 1304854 */   // Label 18642: @1304854
     /* 1304854 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1304940), // Rule ID 7292 //
     /* 1304859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1304870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1304873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1304889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304905 */     // MIs[0] policy
     /* 1304905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304915 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1304915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1304918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1304938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304939 */     // GIR_Coverage, 7292,
     /* 1304939 */     GIR_EraseRootFromParent_Done,
     /* 1304940 */   // Label 18643: @1304940
     /* 1304940 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1305026), // Rule ID 7293 //
     /* 1304945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1304953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1304956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1304959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1304975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1304987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304991 */     // MIs[0] policy
     /* 1304991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1304994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1305004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305025 */     // GIR_Coverage, 7293,
     /* 1305025 */     GIR_EraseRootFromParent_Done,
     /* 1305026 */   // Label 18644: @1305026
     /* 1305026 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1305114), // Rule ID 2606 //
     /* 1305031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1305034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1305042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1305045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1305051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305070 */     // MIs[0] Operand 5
     /* 1305070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305081 */     // MIs[0] policy
     /* 1305081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305091 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1305094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305113 */     // GIR_Coverage, 2606,
     /* 1305113 */     GIR_EraseRootFromParent_Done,
     /* 1305114 */   // Label 18645: @1305114
     /* 1305114 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1305202), // Rule ID 2607 //
     /* 1305119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1305122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1305130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1305133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1305139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305158 */     // MIs[0] Operand 5
     /* 1305158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305169 */     // MIs[0] policy
     /* 1305169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305179 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1305182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305201 */     // GIR_Coverage, 2607,
     /* 1305201 */     GIR_EraseRootFromParent_Done,
     /* 1305202 */   // Label 18646: @1305202
     /* 1305202 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1305290), // Rule ID 20490 //
     /* 1305207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1305210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1305218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1305221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1305227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305246 */     // MIs[0] Operand 5
     /* 1305246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305257 */     // MIs[0] policy
     /* 1305257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1305270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305289 */     // GIR_Coverage, 20490,
     /* 1305289 */     GIR_EraseRootFromParent_Done,
     /* 1305290 */   // Label 18647: @1305290
     /* 1305290 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1305378), // Rule ID 20491 //
     /* 1305295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1305298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1305306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1305309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1305315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305334 */     // MIs[0] Operand 5
     /* 1305334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305345 */     // MIs[0] policy
     /* 1305345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305355 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1305358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305377 */     // GIR_Coverage, 20491,
     /* 1305377 */     GIR_EraseRootFromParent_Done,
     /* 1305378 */   // Label 18648: @1305378
     /* 1305378 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1305466), // Rule ID 20494 //
     /* 1305383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1305386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1305394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1305397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1305403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305422 */     // MIs[0] Operand 5
     /* 1305422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305433 */     // MIs[0] policy
     /* 1305433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1305446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305465 */     // GIR_Coverage, 20494,
     /* 1305465 */     GIR_EraseRootFromParent_Done,
     /* 1305466 */   // Label 18649: @1305466
     /* 1305466 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1305554), // Rule ID 20495 //
     /* 1305471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1305474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1305482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1305485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1305491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305510 */     // MIs[0] Operand 5
     /* 1305510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305521 */     // MIs[0] policy
     /* 1305521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305531 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1305534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305553 */     // GIR_Coverage, 20495,
     /* 1305553 */     GIR_EraseRootFromParent_Done,
     /* 1305554 */   // Label 18650: @1305554
     /* 1305554 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1305642), // Rule ID 20498 //
     /* 1305559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1305562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1305570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1305573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1305579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305598 */     // MIs[0] Operand 5
     /* 1305598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305609 */     // MIs[0] policy
     /* 1305609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305619 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1305622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305641 */     // GIR_Coverage, 20498,
     /* 1305641 */     GIR_EraseRootFromParent_Done,
     /* 1305642 */   // Label 18651: @1305642
     /* 1305642 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1305730), // Rule ID 20499 //
     /* 1305647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1305650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1305658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1305661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1305667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305686 */     // MIs[0] Operand 5
     /* 1305686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305697 */     // MIs[0] policy
     /* 1305697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305707 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1305710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305729 */     // GIR_Coverage, 20499,
     /* 1305729 */     GIR_EraseRootFromParent_Done,
     /* 1305730 */   // Label 18652: @1305730
     /* 1305730 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1305818), // Rule ID 20502 //
     /* 1305735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1305738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1305746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1305749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1305755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305774 */     // MIs[0] Operand 5
     /* 1305774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305785 */     // MIs[0] policy
     /* 1305785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1305798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305817 */     // GIR_Coverage, 20502,
     /* 1305817 */     GIR_EraseRootFromParent_Done,
     /* 1305818 */   // Label 18653: @1305818
     /* 1305818 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1305906), // Rule ID 20503 //
     /* 1305823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1305826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1305834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1305837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1305843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305862 */     // MIs[0] Operand 5
     /* 1305862 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305873 */     // MIs[0] policy
     /* 1305873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1305883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1305886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305905 */     // GIR_Coverage, 20503,
     /* 1305905 */     GIR_EraseRootFromParent_Done,
     /* 1305906 */   // Label 18654: @1305906
     /* 1305906 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1305994), // Rule ID 20506 //
     /* 1305911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1305914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1305919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1305922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1305925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1305928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1305931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1305938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305950 */     // MIs[0] Operand 5
     /* 1305950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1305961 */     // MIs[0] policy
     /* 1305961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1305964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305971 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1305971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1305974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1305982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1305992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305993 */     // GIR_Coverage, 20506,
     /* 1305993 */     GIR_EraseRootFromParent_Done,
     /* 1305994 */   // Label 18655: @1305994
     /* 1305994 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1306082), // Rule ID 20507 //
     /* 1305999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1306002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1306010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1306013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1306019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1306026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306038 */     // MIs[0] Operand 5
     /* 1306038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306049 */     // MIs[0] policy
     /* 1306049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1306062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306081 */     // GIR_Coverage, 20507,
     /* 1306081 */     GIR_EraseRootFromParent_Done,
     /* 1306082 */   // Label 18656: @1306082
     /* 1306082 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1306170), // Rule ID 20510 //
     /* 1306087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1306090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1306098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1306101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1306107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1306114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306126 */     // MIs[0] Operand 5
     /* 1306126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306137 */     // MIs[0] policy
     /* 1306137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1306147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1306150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306169 */     // GIR_Coverage, 20510,
     /* 1306169 */     GIR_EraseRootFromParent_Done,
     /* 1306170 */   // Label 18657: @1306170
     /* 1306170 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1306258), // Rule ID 20511 //
     /* 1306175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1306178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1306186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1306189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1306195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1306202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306214 */     // MIs[0] Operand 5
     /* 1306214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306225 */     // MIs[0] policy
     /* 1306225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1306238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306257 */     // GIR_Coverage, 20511,
     /* 1306257 */     GIR_EraseRootFromParent_Done,
     /* 1306258 */   // Label 18658: @1306258
     /* 1306258 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1306346), // Rule ID 20514 //
     /* 1306263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1306266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1306274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1306277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1306283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1306290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306302 */     // MIs[0] Operand 5
     /* 1306302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306313 */     // MIs[0] policy
     /* 1306313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306323 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1306323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1306326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306345 */     // GIR_Coverage, 20514,
     /* 1306345 */     GIR_EraseRootFromParent_Done,
     /* 1306346 */   // Label 18659: @1306346
     /* 1306346 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1306434), // Rule ID 20515 //
     /* 1306351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1306354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1306362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1306365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1306371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1306378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306390 */     // MIs[0] Operand 5
     /* 1306390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306401 */     // MIs[0] policy
     /* 1306401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306411 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1306414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306433 */     // GIR_Coverage, 20515,
     /* 1306433 */     GIR_EraseRootFromParent_Done,
     /* 1306434 */   // Label 18660: @1306434
     /* 1306434 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1306522), // Rule ID 20518 //
     /* 1306439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1306442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1306450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1306453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1306459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1306466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306478 */     // MIs[0] Operand 5
     /* 1306478 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306489 */     // MIs[0] policy
     /* 1306489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1306499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1306502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306521 */     // GIR_Coverage, 20518,
     /* 1306521 */     GIR_EraseRootFromParent_Done,
     /* 1306522 */   // Label 18661: @1306522
     /* 1306522 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1306610), // Rule ID 20519 //
     /* 1306527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1306530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1306538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1306541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1306547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1306554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306566 */     // MIs[0] Operand 5
     /* 1306566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306577 */     // MIs[0] policy
     /* 1306577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306587 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1306590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306609 */     // GIR_Coverage, 20519,
     /* 1306609 */     GIR_EraseRootFromParent_Done,
     /* 1306610 */   // Label 18662: @1306610
     /* 1306610 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1306698), // Rule ID 20522 //
     /* 1306615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1306618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1306626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1306629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1306632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1306635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1306642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306654 */     // MIs[0] Operand 5
     /* 1306654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306665 */     // MIs[0] policy
     /* 1306665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1306675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1306678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306697 */     // GIR_Coverage, 20522,
     /* 1306697 */     GIR_EraseRootFromParent_Done,
     /* 1306698 */   // Label 18663: @1306698
     /* 1306698 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1306786), // Rule ID 20523 //
     /* 1306703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1306706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1306714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1306717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1306720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1306723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1306730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306742 */     // MIs[0] Operand 5
     /* 1306742 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306753 */     // MIs[0] policy
     /* 1306753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306763 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1306766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306785 */     // GIR_Coverage, 20523,
     /* 1306785 */     GIR_EraseRootFromParent_Done,
     /* 1306786 */   // Label 18664: @1306786
     /* 1306786 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1306874), // Rule ID 20526 //
     /* 1306791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1306794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1306802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1306805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1306808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1306811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1306818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306830 */     // MIs[0] Operand 5
     /* 1306830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306841 */     // MIs[0] policy
     /* 1306841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1306851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1306854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306873 */     // GIR_Coverage, 20526,
     /* 1306873 */     GIR_EraseRootFromParent_Done,
     /* 1306874 */   // Label 18665: @1306874
     /* 1306874 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1306962), // Rule ID 20527 //
     /* 1306879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1306882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1306890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1306893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1306896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1306899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1306906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306918 */     // MIs[0] Operand 5
     /* 1306918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1306929 */     // MIs[0] policy
     /* 1306929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1306932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1306939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1306942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1306950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1306960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306961 */     // GIR_Coverage, 20527,
     /* 1306961 */     GIR_EraseRootFromParent_Done,
     /* 1306962 */   // Label 18666: @1306962
     /* 1306962 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1307050), // Rule ID 20530 //
     /* 1306967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1306970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1306975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1306978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1306981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1306984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1306987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1306994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307006 */     // MIs[0] Operand 5
     /* 1307006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307017 */     // MIs[0] policy
     /* 1307017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1307030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307049 */     // GIR_Coverage, 20530,
     /* 1307049 */     GIR_EraseRootFromParent_Done,
     /* 1307050 */   // Label 18667: @1307050
     /* 1307050 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1307138), // Rule ID 20531 //
     /* 1307055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1307058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1307066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1307069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1307075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1307082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307094 */     // MIs[0] Operand 5
     /* 1307094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307105 */     // MIs[0] policy
     /* 1307105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1307118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307137 */     // GIR_Coverage, 20531,
     /* 1307137 */     GIR_EraseRootFromParent_Done,
     /* 1307138 */   // Label 18668: @1307138
     /* 1307138 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1307226), // Rule ID 20534 //
     /* 1307143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1307146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1307154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1307157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1307163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1307170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307182 */     // MIs[0] Operand 5
     /* 1307182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307193 */     // MIs[0] policy
     /* 1307193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1307206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307225 */     // GIR_Coverage, 20534,
     /* 1307225 */     GIR_EraseRootFromParent_Done,
     /* 1307226 */   // Label 18669: @1307226
     /* 1307226 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1307314), // Rule ID 20535 //
     /* 1307231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1307234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1307242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1307245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1307251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1307258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307270 */     // MIs[0] Operand 5
     /* 1307270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307281 */     // MIs[0] policy
     /* 1307281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1307294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307313 */     // GIR_Coverage, 20535,
     /* 1307313 */     GIR_EraseRootFromParent_Done,
     /* 1307314 */   // Label 18670: @1307314
     /* 1307314 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1307402), // Rule ID 20538 //
     /* 1307319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1307322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1307330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1307333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1307339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1307346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307358 */     // MIs[0] Operand 5
     /* 1307358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307369 */     // MIs[0] policy
     /* 1307369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307379 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1307382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307401 */     // GIR_Coverage, 20538,
     /* 1307401 */     GIR_EraseRootFromParent_Done,
     /* 1307402 */   // Label 18671: @1307402
     /* 1307402 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1307490), // Rule ID 20539 //
     /* 1307407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1307410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1307418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1307421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1307427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1307434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307446 */     // MIs[0] Operand 5
     /* 1307446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307457 */     // MIs[0] policy
     /* 1307457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307467 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1307470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307489 */     // GIR_Coverage, 20539,
     /* 1307489 */     GIR_EraseRootFromParent_Done,
     /* 1307490 */   // Label 18672: @1307490
     /* 1307490 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1307578), // Rule ID 20542 //
     /* 1307495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1307498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1307506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1307509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1307515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1307522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307534 */     // MIs[0] Operand 5
     /* 1307534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307545 */     // MIs[0] policy
     /* 1307545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1307558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307577 */     // GIR_Coverage, 20542,
     /* 1307577 */     GIR_EraseRootFromParent_Done,
     /* 1307578 */   // Label 18673: @1307578
     /* 1307578 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1307666), // Rule ID 20543 //
     /* 1307583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1307586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1307591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1307594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1307597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1307603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1307610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307622 */     // MIs[0] Operand 5
     /* 1307622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307633 */     // MIs[0] policy
     /* 1307633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1307646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307665 */     // GIR_Coverage, 20543,
     /* 1307665 */     GIR_EraseRootFromParent_Done,
     /* 1307666 */   // Label 18674: @1307666
     /* 1307666 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1307754), // Rule ID 20546 //
     /* 1307671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1307674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1307679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1307682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1307685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1307688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1307691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1307698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307710 */     // MIs[0] Operand 5
     /* 1307710 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307721 */     // MIs[0] policy
     /* 1307721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307731 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1307734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307753 */     // GIR_Coverage, 20546,
     /* 1307753 */     GIR_EraseRootFromParent_Done,
     /* 1307754 */   // Label 18675: @1307754
     /* 1307754 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1307842), // Rule ID 20547 //
     /* 1307759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1307762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1307767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1307770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1307773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1307776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1307779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1307786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307798 */     // MIs[0] Operand 5
     /* 1307798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307809 */     // MIs[0] policy
     /* 1307809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307819 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1307822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307841 */     // GIR_Coverage, 20547,
     /* 1307841 */     GIR_EraseRootFromParent_Done,
     /* 1307842 */   // Label 18676: @1307842
     /* 1307842 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1307930), // Rule ID 20550 //
     /* 1307847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1307850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1307855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1307858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1307861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1307864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1307867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1307874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307886 */     // MIs[0] Operand 5
     /* 1307886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307897 */     // MIs[0] policy
     /* 1307897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1307907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1307910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1307918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1307928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307929 */     // GIR_Coverage, 20550,
     /* 1307929 */     GIR_EraseRootFromParent_Done,
     /* 1307930 */   // Label 18677: @1307930
     /* 1307930 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1308018), // Rule ID 20551 //
     /* 1307935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1307938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1307943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1307946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1307949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1307952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1307955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1307962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307974 */     // MIs[0] Operand 5
     /* 1307974 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1307985 */     // MIs[0] policy
     /* 1307985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1307988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307995 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1307995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1307998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308017 */     // GIR_Coverage, 20551,
     /* 1308017 */     GIR_EraseRootFromParent_Done,
     /* 1308018 */   // Label 18678: @1308018
     /* 1308018 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1308106), // Rule ID 20554 //
     /* 1308023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1308026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1308034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1308037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1308043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308062 */     // MIs[0] Operand 5
     /* 1308062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308073 */     // MIs[0] policy
     /* 1308073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1308086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308105 */     // GIR_Coverage, 20554,
     /* 1308105 */     GIR_EraseRootFromParent_Done,
     /* 1308106 */   // Label 18679: @1308106
     /* 1308106 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1308194), // Rule ID 20555 //
     /* 1308111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1308114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1308122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1308125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1308131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308150 */     // MIs[0] Operand 5
     /* 1308150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308161 */     // MIs[0] policy
     /* 1308161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1308171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1308174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308193 */     // GIR_Coverage, 20555,
     /* 1308193 */     GIR_EraseRootFromParent_Done,
     /* 1308194 */   // Label 18680: @1308194
     /* 1308194 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1308282), // Rule ID 20558 //
     /* 1308199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1308202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1308210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1308213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1308216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1308219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308238 */     // MIs[0] Operand 5
     /* 1308238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308249 */     // MIs[0] policy
     /* 1308249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308259 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308281 */     // GIR_Coverage, 20558,
     /* 1308281 */     GIR_EraseRootFromParent_Done,
     /* 1308282 */   // Label 18681: @1308282
     /* 1308282 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1308370), // Rule ID 20559 //
     /* 1308287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1308290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1308298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1308301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1308304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1308307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308326 */     // MIs[0] Operand 5
     /* 1308326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308337 */     // MIs[0] policy
     /* 1308337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1308347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308369 */     // GIR_Coverage, 20559,
     /* 1308369 */     GIR_EraseRootFromParent_Done,
     /* 1308370 */   // Label 18682: @1308370
     /* 1308370 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1308458), // Rule ID 20562 //
     /* 1308375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1308378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1308386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1308389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1308392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1308395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308414 */     // MIs[0] Operand 5
     /* 1308414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308425 */     // MIs[0] policy
     /* 1308425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308457 */     // GIR_Coverage, 20562,
     /* 1308457 */     GIR_EraseRootFromParent_Done,
     /* 1308458 */   // Label 18683: @1308458
     /* 1308458 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1308546), // Rule ID 20563 //
     /* 1308463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1308466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1308474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1308477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1308480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1308483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308502 */     // MIs[0] Operand 5
     /* 1308502 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308513 */     // MIs[0] policy
     /* 1308513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1308523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308545 */     // GIR_Coverage, 20563,
     /* 1308545 */     GIR_EraseRootFromParent_Done,
     /* 1308546 */   // Label 18684: @1308546
     /* 1308546 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1308634), // Rule ID 20566 //
     /* 1308551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1308554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1308562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1308565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1308568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1308571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308590 */     // MIs[0] Operand 5
     /* 1308590 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308601 */     // MIs[0] policy
     /* 1308601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308633 */     // GIR_Coverage, 20566,
     /* 1308633 */     GIR_EraseRootFromParent_Done,
     /* 1308634 */   // Label 18685: @1308634
     /* 1308634 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1308722), // Rule ID 20567 //
     /* 1308639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1308642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1308650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1308653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1308656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1308659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1308666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308678 */     // MIs[0] Operand 5
     /* 1308678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308689 */     // MIs[0] policy
     /* 1308689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1308699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1308702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308721 */     // GIR_Coverage, 20567,
     /* 1308721 */     GIR_EraseRootFromParent_Done,
     /* 1308722 */   // Label 18686: @1308722
     /* 1308722 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1308810), // Rule ID 20570 //
     /* 1308727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1308730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1308738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1308741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1308744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1308747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1308754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308766 */     // MIs[0] Operand 5
     /* 1308766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308777 */     // MIs[0] policy
     /* 1308777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1308790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308809 */     // GIR_Coverage, 20570,
     /* 1308809 */     GIR_EraseRootFromParent_Done,
     /* 1308810 */   // Label 18687: @1308810
     /* 1308810 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1308898), // Rule ID 20571 //
     /* 1308815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1308818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1308826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1308829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1308832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1308835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1308842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308854 */     // MIs[0] Operand 5
     /* 1308854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308865 */     // MIs[0] policy
     /* 1308865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1308875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1308878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308897 */     // GIR_Coverage, 20571,
     /* 1308897 */     GIR_EraseRootFromParent_Done,
     /* 1308898 */   // Label 18688: @1308898
     /* 1308898 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1308986), // Rule ID 20574 //
     /* 1308903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1308906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1308914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1308917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1308920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1308923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1308930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308942 */     // MIs[0] Operand 5
     /* 1308942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1308953 */     // MIs[0] policy
     /* 1308953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1308956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308963 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1308963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1308966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1308974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1308984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308985 */     // GIR_Coverage, 20574,
     /* 1308985 */     GIR_EraseRootFromParent_Done,
     /* 1308986 */   // Label 18689: @1308986
     /* 1308986 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1309074), // Rule ID 20575 //
     /* 1308991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1308994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1308999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1309002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1309005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1309008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1309011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1309018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309030 */     // MIs[0] Operand 5
     /* 1309030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309041 */     // MIs[0] policy
     /* 1309041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309051 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1309054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309073 */     // GIR_Coverage, 20575,
     /* 1309073 */     GIR_EraseRootFromParent_Done,
     /* 1309074 */   // Label 18690: @1309074
     /* 1309074 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1309162), // Rule ID 20578 //
     /* 1309079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1309082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1309090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1309093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1309096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1309099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1309106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309118 */     // MIs[0] Operand 5
     /* 1309118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309129 */     // MIs[0] policy
     /* 1309129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309139 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1309139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1309142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309161 */     // GIR_Coverage, 20578,
     /* 1309161 */     GIR_EraseRootFromParent_Done,
     /* 1309162 */   // Label 18691: @1309162
     /* 1309162 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1309250), // Rule ID 20579 //
     /* 1309167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1309170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1309178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1309181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1309184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1309187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1309194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309206 */     // MIs[0] Operand 5
     /* 1309206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309217 */     // MIs[0] policy
     /* 1309217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309227 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1309230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309249 */     // GIR_Coverage, 20579,
     /* 1309249 */     GIR_EraseRootFromParent_Done,
     /* 1309250 */   // Label 18692: @1309250
     /* 1309250 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1309338), // Rule ID 20582 //
     /* 1309255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1309258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1309266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1309269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1309272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1309275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1309282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309294 */     // MIs[0] Operand 5
     /* 1309294 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309305 */     // MIs[0] policy
     /* 1309305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1309315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1309318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309337 */     // GIR_Coverage, 20582,
     /* 1309337 */     GIR_EraseRootFromParent_Done,
     /* 1309338 */   // Label 18693: @1309338
     /* 1309338 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1309426), // Rule ID 20583 //
     /* 1309343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1309346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1309354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1309357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1309360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1309363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1309370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309382 */     // MIs[0] Operand 5
     /* 1309382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309393 */     // MIs[0] policy
     /* 1309393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1309406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309425 */     // GIR_Coverage, 20583,
     /* 1309425 */     GIR_EraseRootFromParent_Done,
     /* 1309426 */   // Label 18694: @1309426
     /* 1309426 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1309514), // Rule ID 20586 //
     /* 1309431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1309434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1309442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1309445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1309448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1309451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1309458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309470 */     // MIs[0] Operand 5
     /* 1309470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309481 */     // MIs[0] policy
     /* 1309481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309491 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1309491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1309494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309513 */     // GIR_Coverage, 20586,
     /* 1309513 */     GIR_EraseRootFromParent_Done,
     /* 1309514 */   // Label 18695: @1309514
     /* 1309514 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1309602), // Rule ID 20587 //
     /* 1309519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1309522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1309530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1309533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1309536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1309539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1309546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309558 */     // MIs[0] Operand 5
     /* 1309558 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309569 */     // MIs[0] policy
     /* 1309569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309579 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1309582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309601 */     // GIR_Coverage, 20587,
     /* 1309601 */     GIR_EraseRootFromParent_Done,
     /* 1309602 */   // Label 18696: @1309602
     /* 1309602 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1309690), // Rule ID 20590 //
     /* 1309607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1309610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1309618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1309621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1309624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1309627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1309634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309646 */     // MIs[0] Operand 5
     /* 1309646 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309657 */     // MIs[0] policy
     /* 1309657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309667 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1309667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1309670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309689 */     // GIR_Coverage, 20590,
     /* 1309689 */     GIR_EraseRootFromParent_Done,
     /* 1309690 */   // Label 18697: @1309690
     /* 1309690 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1309778), // Rule ID 20591 //
     /* 1309695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1309698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1309706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1309709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1309712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1309715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1309722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309734 */     // MIs[0] Operand 5
     /* 1309734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309745 */     // MIs[0] policy
     /* 1309745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309755 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1309758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309777 */     // GIR_Coverage, 20591,
     /* 1309777 */     GIR_EraseRootFromParent_Done,
     /* 1309778 */   // Label 18698: @1309778
     /* 1309778 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1309866), // Rule ID 20594 //
     /* 1309783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1309786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1309794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1309797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1309800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1309803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1309810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309822 */     // MIs[0] Operand 5
     /* 1309822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309833 */     // MIs[0] policy
     /* 1309833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1309843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1309846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309865 */     // GIR_Coverage, 20594,
     /* 1309865 */     GIR_EraseRootFromParent_Done,
     /* 1309866 */   // Label 18699: @1309866
     /* 1309866 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1309954), // Rule ID 20595 //
     /* 1309871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1309874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1309882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1309885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1309888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1309891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1309898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309910 */     // MIs[0] Operand 5
     /* 1309910 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1309921 */     // MIs[0] policy
     /* 1309921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1309924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1309931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1309934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1309942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1309952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309953 */     // GIR_Coverage, 20595,
     /* 1309953 */     GIR_EraseRootFromParent_Done,
     /* 1309954 */   // Label 18700: @1309954
     /* 1309954 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1310042), // Rule ID 20598 //
     /* 1309959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1309962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1309967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1309970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1309973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1309976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1309979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1309986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309998 */     // MIs[0] Operand 5
     /* 1309998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310009 */     // MIs[0] policy
     /* 1310009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1310022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310041 */     // GIR_Coverage, 20598,
     /* 1310041 */     GIR_EraseRootFromParent_Done,
     /* 1310042 */   // Label 18701: @1310042
     /* 1310042 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1310130), // Rule ID 20599 //
     /* 1310047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1310050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1310055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1310058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1310061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1310064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1310067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1310074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310086 */     // MIs[0] Operand 5
     /* 1310086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310097 */     // MIs[0] policy
     /* 1310097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310107 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1310110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310129 */     // GIR_Coverage, 20599,
     /* 1310129 */     GIR_EraseRootFromParent_Done,
     /* 1310130 */   // Label 18702: @1310130
     /* 1310130 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1310218), // Rule ID 20602 //
     /* 1310135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1310138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1310143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1310146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1310149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1310152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1310155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1310162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310174 */     // MIs[0] Operand 5
     /* 1310174 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310185 */     // MIs[0] policy
     /* 1310185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310195 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1310198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310217 */     // GIR_Coverage, 20602,
     /* 1310217 */     GIR_EraseRootFromParent_Done,
     /* 1310218 */   // Label 18703: @1310218
     /* 1310218 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1310306), // Rule ID 20603 //
     /* 1310223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1310226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1310231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1310234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1310237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1310240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1310243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1310250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310262 */     // MIs[0] Operand 5
     /* 1310262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310273 */     // MIs[0] policy
     /* 1310273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1310286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310305 */     // GIR_Coverage, 20603,
     /* 1310305 */     GIR_EraseRootFromParent_Done,
     /* 1310306 */   // Label 18704: @1310306
     /* 1310306 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1310394), // Rule ID 20962 //
     /* 1310311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1310314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1310322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1310325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1310328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1310331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1310338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310350 */     // MIs[0] Operand 5
     /* 1310350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310361 */     // MIs[0] policy
     /* 1310361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1310374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310393 */     // GIR_Coverage, 20962,
     /* 1310393 */     GIR_EraseRootFromParent_Done,
     /* 1310394 */   // Label 18705: @1310394
     /* 1310394 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1310482), // Rule ID 20963 //
     /* 1310399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1310402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1310410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1310413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1310416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1310419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1310426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310438 */     // MIs[0] Operand 5
     /* 1310438 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310449 */     // MIs[0] policy
     /* 1310449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1310462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310481 */     // GIR_Coverage, 20963,
     /* 1310481 */     GIR_EraseRootFromParent_Done,
     /* 1310482 */   // Label 18706: @1310482
     /* 1310482 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1310570), // Rule ID 20966 //
     /* 1310487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1310490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1310498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1310501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1310504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1310507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1310514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310526 */     // MIs[0] Operand 5
     /* 1310526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310537 */     // MIs[0] policy
     /* 1310537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1310550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310569 */     // GIR_Coverage, 20966,
     /* 1310569 */     GIR_EraseRootFromParent_Done,
     /* 1310570 */   // Label 18707: @1310570
     /* 1310570 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1310658), // Rule ID 20967 //
     /* 1310575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1310578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1310586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1310589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1310592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1310595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1310602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310614 */     // MIs[0] Operand 5
     /* 1310614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310625 */     // MIs[0] policy
     /* 1310625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310635 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1310638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310657 */     // GIR_Coverage, 20967,
     /* 1310657 */     GIR_EraseRootFromParent_Done,
     /* 1310658 */   // Label 18708: @1310658
     /* 1310658 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1310746), // Rule ID 20970 //
     /* 1310663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1310666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1310674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1310677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1310680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1310683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1310690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310702 */     // MIs[0] Operand 5
     /* 1310702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310713 */     // MIs[0] policy
     /* 1310713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1310726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310745 */     // GIR_Coverage, 20970,
     /* 1310745 */     GIR_EraseRootFromParent_Done,
     /* 1310746 */   // Label 18709: @1310746
     /* 1310746 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1310834), // Rule ID 20971 //
     /* 1310751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1310754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1310762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1310765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1310768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1310771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1310778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310790 */     // MIs[0] Operand 5
     /* 1310790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310801 */     // MIs[0] policy
     /* 1310801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1310814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310833 */     // GIR_Coverage, 20971,
     /* 1310833 */     GIR_EraseRootFromParent_Done,
     /* 1310834 */   // Label 18710: @1310834
     /* 1310834 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1310922), // Rule ID 20974 //
     /* 1310839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1310842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1310850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1310853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1310859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1310866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310878 */     // MIs[0] Operand 5
     /* 1310878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310889 */     // MIs[0] policy
     /* 1310889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310899 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1310899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1310902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1310920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310921 */     // GIR_Coverage, 20974,
     /* 1310921 */     GIR_EraseRootFromParent_Done,
     /* 1310922 */   // Label 18711: @1310922
     /* 1310922 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1311010), // Rule ID 20975 //
     /* 1310927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1310930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1310935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1310938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1310941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1310947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1310954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310966 */     // MIs[0] Operand 5
     /* 1310966 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1310977 */     // MIs[0] policy
     /* 1310977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1310980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310987 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1310987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1310990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1310998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311009 */     // GIR_Coverage, 20975,
     /* 1311009 */     GIR_EraseRootFromParent_Done,
     /* 1311010 */   // Label 18712: @1311010
     /* 1311010 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1311098), // Rule ID 20978 //
     /* 1311015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1311018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1311026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1311029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1311035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1311042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311054 */     // MIs[0] Operand 5
     /* 1311054 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311065 */     // MIs[0] policy
     /* 1311065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1311078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311097 */     // GIR_Coverage, 20978,
     /* 1311097 */     GIR_EraseRootFromParent_Done,
     /* 1311098 */   // Label 18713: @1311098
     /* 1311098 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1311186), // Rule ID 20979 //
     /* 1311103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1311106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1311114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1311117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1311123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1311130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311142 */     // MIs[0] Operand 5
     /* 1311142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311153 */     // MIs[0] policy
     /* 1311153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1311163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1311166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311185 */     // GIR_Coverage, 20979,
     /* 1311185 */     GIR_EraseRootFromParent_Done,
     /* 1311186 */   // Label 18714: @1311186
     /* 1311186 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1311274), // Rule ID 20982 //
     /* 1311191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1311194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1311202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1311205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1311208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1311211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1311218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311230 */     // MIs[0] Operand 5
     /* 1311230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311241 */     // MIs[0] policy
     /* 1311241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1311254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311273 */     // GIR_Coverage, 20982,
     /* 1311273 */     GIR_EraseRootFromParent_Done,
     /* 1311274 */   // Label 18715: @1311274
     /* 1311274 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1311362), // Rule ID 20983 //
     /* 1311279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1311282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1311290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1311293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1311296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1311299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1311306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311318 */     // MIs[0] Operand 5
     /* 1311318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311329 */     // MIs[0] policy
     /* 1311329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1311339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1311342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311361 */     // GIR_Coverage, 20983,
     /* 1311361 */     GIR_EraseRootFromParent_Done,
     /* 1311362 */   // Label 18716: @1311362
     /* 1311362 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1311450), // Rule ID 20986 //
     /* 1311367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1311370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1311378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1311381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1311384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1311387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1311394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311406 */     // MIs[0] Operand 5
     /* 1311406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311417 */     // MIs[0] policy
     /* 1311417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1311430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311449 */     // GIR_Coverage, 20986,
     /* 1311449 */     GIR_EraseRootFromParent_Done,
     /* 1311450 */   // Label 18717: @1311450
     /* 1311450 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1311538), // Rule ID 20987 //
     /* 1311455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1311458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1311466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1311469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1311472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1311475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1311482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311494 */     // MIs[0] Operand 5
     /* 1311494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311505 */     // MIs[0] policy
     /* 1311505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1311515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1311518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311537 */     // GIR_Coverage, 20987,
     /* 1311537 */     GIR_EraseRootFromParent_Done,
     /* 1311538 */   // Label 18718: @1311538
     /* 1311538 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1311626), // Rule ID 20990 //
     /* 1311543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1311546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1311554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1311557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1311563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1311570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311582 */     // MIs[0] Operand 5
     /* 1311582 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311593 */     // MIs[0] policy
     /* 1311593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311603 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1311606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311625 */     // GIR_Coverage, 20990,
     /* 1311625 */     GIR_EraseRootFromParent_Done,
     /* 1311626 */   // Label 18719: @1311626
     /* 1311626 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1311714), // Rule ID 20991 //
     /* 1311631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1311634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1311642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1311645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1311651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1311658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311670 */     // MIs[0] Operand 5
     /* 1311670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311681 */     // MIs[0] policy
     /* 1311681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1311691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1311694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311713 */     // GIR_Coverage, 20991,
     /* 1311713 */     GIR_EraseRootFromParent_Done,
     /* 1311714 */   // Label 18720: @1311714
     /* 1311714 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1311802), // Rule ID 20994 //
     /* 1311719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1311722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1311730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1311733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1311739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1311746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311758 */     // MIs[0] Operand 5
     /* 1311758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311769 */     // MIs[0] policy
     /* 1311769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311779 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1311782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311801 */     // GIR_Coverage, 20994,
     /* 1311801 */     GIR_EraseRootFromParent_Done,
     /* 1311802 */   // Label 18721: @1311802
     /* 1311802 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1311890), // Rule ID 20995 //
     /* 1311807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1311810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1311815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1311818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1311821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1311827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1311834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311846 */     // MIs[0] Operand 5
     /* 1311846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311857 */     // MIs[0] policy
     /* 1311857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311867 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1311867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1311870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311889 */     // GIR_Coverage, 20995,
     /* 1311889 */     GIR_EraseRootFromParent_Done,
     /* 1311890 */   // Label 18722: @1311890
     /* 1311890 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1311978), // Rule ID 20998 //
     /* 1311895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1311898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1311903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1311906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1311909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1311912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1311915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1311922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311934 */     // MIs[0] Operand 5
     /* 1311934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1311945 */     // MIs[0] policy
     /* 1311945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1311948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1311955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1311958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1311966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1311976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311977 */     // GIR_Coverage, 20998,
     /* 1311977 */     GIR_EraseRootFromParent_Done,
     /* 1311978 */   // Label 18723: @1311978
     /* 1311978 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1312066), // Rule ID 20999 //
     /* 1311983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1311986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1311991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1311994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1311997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1312003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312022 */     // MIs[0] Operand 5
     /* 1312022 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312033 */     // MIs[0] policy
     /* 1312033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1312046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312065 */     // GIR_Coverage, 20999,
     /* 1312065 */     GIR_EraseRootFromParent_Done,
     /* 1312066 */   // Label 18724: @1312066
     /* 1312066 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1312154), // Rule ID 21002 //
     /* 1312071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1312074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1312082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1312085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1312091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312110 */     // MIs[0] Operand 5
     /* 1312110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312121 */     // MIs[0] policy
     /* 1312121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312131 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1312131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1312134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312153 */     // GIR_Coverage, 21002,
     /* 1312153 */     GIR_EraseRootFromParent_Done,
     /* 1312154 */   // Label 18725: @1312154
     /* 1312154 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1312242), // Rule ID 21003 //
     /* 1312159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1312162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1312170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1312173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1312179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312198 */     // MIs[0] Operand 5
     /* 1312198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312209 */     // MIs[0] policy
     /* 1312209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1312222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312241 */     // GIR_Coverage, 21003,
     /* 1312241 */     GIR_EraseRootFromParent_Done,
     /* 1312242 */   // Label 18726: @1312242
     /* 1312242 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1312330), // Rule ID 21006 //
     /* 1312247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1312250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1312258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1312261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1312267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1312274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312286 */     // MIs[0] Operand 5
     /* 1312286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312297 */     // MIs[0] policy
     /* 1312297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1312307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1312310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312329 */     // GIR_Coverage, 21006,
     /* 1312329 */     GIR_EraseRootFromParent_Done,
     /* 1312330 */   // Label 18727: @1312330
     /* 1312330 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1312418), // Rule ID 21007 //
     /* 1312335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1312338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1312346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1312349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1312355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1312362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312374 */     // MIs[0] Operand 5
     /* 1312374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312385 */     // MIs[0] policy
     /* 1312385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1312398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312417 */     // GIR_Coverage, 21007,
     /* 1312417 */     GIR_EraseRootFromParent_Done,
     /* 1312418 */   // Label 18728: @1312418
     /* 1312418 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1312506), // Rule ID 21010 //
     /* 1312423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1312426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1312434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1312437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1312440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1312443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1312450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312462 */     // MIs[0] Operand 5
     /* 1312462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312473 */     // MIs[0] policy
     /* 1312473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312483 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1312483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1312486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312505 */     // GIR_Coverage, 21010,
     /* 1312505 */     GIR_EraseRootFromParent_Done,
     /* 1312506 */   // Label 18729: @1312506
     /* 1312506 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1312594), // Rule ID 21011 //
     /* 1312511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1312514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1312522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1312525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1312528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1312531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1312538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312550 */     // MIs[0] Operand 5
     /* 1312550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312561 */     // MIs[0] policy
     /* 1312561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312571 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1312574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312593 */     // GIR_Coverage, 21011,
     /* 1312593 */     GIR_EraseRootFromParent_Done,
     /* 1312594 */   // Label 18730: @1312594
     /* 1312594 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1312682), // Rule ID 21014 //
     /* 1312599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1312602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1312610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1312613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1312616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1312619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1312626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312638 */     // MIs[0] Operand 5
     /* 1312638 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312649 */     // MIs[0] policy
     /* 1312649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312659 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1312659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1312662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312681 */     // GIR_Coverage, 21014,
     /* 1312681 */     GIR_EraseRootFromParent_Done,
     /* 1312682 */   // Label 18731: @1312682
     /* 1312682 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1312770), // Rule ID 21015 //
     /* 1312687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1312690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1312698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1312701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1312704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1312707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1312714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312726 */     // MIs[0] Operand 5
     /* 1312726 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312737 */     // MIs[0] policy
     /* 1312737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1312750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312769 */     // GIR_Coverage, 21015,
     /* 1312769 */     GIR_EraseRootFromParent_Done,
     /* 1312770 */   // Label 18732: @1312770
     /* 1312770 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1312858), // Rule ID 21018 //
     /* 1312775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1312778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1312786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1312789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1312795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312814 */     // MIs[0] Operand 5
     /* 1312814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312825 */     // MIs[0] policy
     /* 1312825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312835 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1312835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1312838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312857 */     // GIR_Coverage, 21018,
     /* 1312857 */     GIR_EraseRootFromParent_Done,
     /* 1312858 */   // Label 18733: @1312858
     /* 1312858 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1312946), // Rule ID 21019 //
     /* 1312863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1312866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1312874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1312877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1312883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312902 */     // MIs[0] Operand 5
     /* 1312902 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1312913 */     // MIs[0] policy
     /* 1312913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1312916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312923 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1312923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1312926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1312934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1312944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312945 */     // GIR_Coverage, 21019,
     /* 1312945 */     GIR_EraseRootFromParent_Done,
     /* 1312946 */   // Label 18734: @1312946
     /* 1312946 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1313034), // Rule ID 21022 //
     /* 1312951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1312954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1312959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1312962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1312965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1312968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1312971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1312978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312990 */     // MIs[0] Operand 5
     /* 1312990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313001 */     // MIs[0] policy
     /* 1313001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1313014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313033 */     // GIR_Coverage, 21022,
     /* 1313033 */     GIR_EraseRootFromParent_Done,
     /* 1313034 */   // Label 18735: @1313034
     /* 1313034 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1313122), // Rule ID 21023 //
     /* 1313039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1313042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1313047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1313050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1313053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1313059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1313066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313078 */     // MIs[0] Operand 5
     /* 1313078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313089 */     // MIs[0] policy
     /* 1313089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313099 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1313102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313121 */     // GIR_Coverage, 21023,
     /* 1313121 */     GIR_EraseRootFromParent_Done,
     /* 1313122 */   // Label 18736: @1313122
     /* 1313122 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1313210), // Rule ID 21026 //
     /* 1313127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1313130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1313135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1313138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1313141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1313144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1313147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1313154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313166 */     // MIs[0] Operand 5
     /* 1313166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313177 */     // MIs[0] policy
     /* 1313177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1313190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313209 */     // GIR_Coverage, 21026,
     /* 1313209 */     GIR_EraseRootFromParent_Done,
     /* 1313210 */   // Label 18737: @1313210
     /* 1313210 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1313298), // Rule ID 21027 //
     /* 1313215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1313218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1313223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1313226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1313229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1313232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1313235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1313242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313254 */     // MIs[0] Operand 5
     /* 1313254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313265 */     // MIs[0] policy
     /* 1313265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313275 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1313278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313297 */     // GIR_Coverage, 21027,
     /* 1313297 */     GIR_EraseRootFromParent_Done,
     /* 1313298 */   // Label 18738: @1313298
     /* 1313298 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1313386), // Rule ID 21030 //
     /* 1313303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1313306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1313311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1313314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1313317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1313320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1313323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1313330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313342 */     // MIs[0] Operand 5
     /* 1313342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313353 */     // MIs[0] policy
     /* 1313353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313363 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1313366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313385 */     // GIR_Coverage, 21030,
     /* 1313385 */     GIR_EraseRootFromParent_Done,
     /* 1313386 */   // Label 18739: @1313386
     /* 1313386 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1313474), // Rule ID 21031 //
     /* 1313391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1313394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1313399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1313402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1313405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1313408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1313411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1313418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313430 */     // MIs[0] Operand 5
     /* 1313430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313441 */     // MIs[0] policy
     /* 1313441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1313454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313473 */     // GIR_Coverage, 21031,
     /* 1313473 */     GIR_EraseRootFromParent_Done,
     /* 1313474 */   // Label 18740: @1313474
     /* 1313474 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1313562), // Rule ID 21334 //
     /* 1313479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1313482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1313490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1313493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1313496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1313499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313518 */     // MIs[0] Operand 5
     /* 1313518 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313529 */     // MIs[0] policy
     /* 1313529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1313542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313561 */     // GIR_Coverage, 21334,
     /* 1313561 */     GIR_EraseRootFromParent_Done,
     /* 1313562 */   // Label 18741: @1313562
     /* 1313562 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1313650), // Rule ID 21335 //
     /* 1313567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1313570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1313578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1313581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1313584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1313587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313606 */     // MIs[0] Operand 5
     /* 1313606 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313617 */     // MIs[0] policy
     /* 1313617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1313630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313649 */     // GIR_Coverage, 21335,
     /* 1313649 */     GIR_EraseRootFromParent_Done,
     /* 1313650 */   // Label 18742: @1313650
     /* 1313650 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1313738), // Rule ID 21338 //
     /* 1313655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1313658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1313666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1313669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1313675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313694 */     // MIs[0] Operand 5
     /* 1313694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313705 */     // MIs[0] policy
     /* 1313705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313715 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1313718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313737 */     // GIR_Coverage, 21338,
     /* 1313737 */     GIR_EraseRootFromParent_Done,
     /* 1313738 */   // Label 18743: @1313738
     /* 1313738 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1313826), // Rule ID 21339 //
     /* 1313743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1313746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1313754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1313757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1313763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313782 */     // MIs[0] Operand 5
     /* 1313782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313793 */     // MIs[0] policy
     /* 1313793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313803 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1313806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313825 */     // GIR_Coverage, 21339,
     /* 1313825 */     GIR_EraseRootFromParent_Done,
     /* 1313826 */   // Label 18744: @1313826
     /* 1313826 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1313914), // Rule ID 21342 //
     /* 1313831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1313834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1313842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1313845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1313851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313870 */     // MIs[0] Operand 5
     /* 1313870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313881 */     // MIs[0] policy
     /* 1313881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313891 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1313891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1313894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1313912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313913 */     // GIR_Coverage, 21342,
     /* 1313913 */     GIR_EraseRootFromParent_Done,
     /* 1313914 */   // Label 18745: @1313914
     /* 1313914 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1314002), // Rule ID 21343 //
     /* 1313919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1313922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1313927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1313930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1313933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1313939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313958 */     // MIs[0] Operand 5
     /* 1313958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1313969 */     // MIs[0] policy
     /* 1313969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1313972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313979 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1313979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1313982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1313990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314001 */     // GIR_Coverage, 21343,
     /* 1314001 */     GIR_EraseRootFromParent_Done,
     /* 1314002 */   // Label 18746: @1314002
     /* 1314002 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1314090), // Rule ID 21346 //
     /* 1314007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1314010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1314018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1314021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1314027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314046 */     // MIs[0] Operand 5
     /* 1314046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314057 */     // MIs[0] policy
     /* 1314057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314067 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1314070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314089 */     // GIR_Coverage, 21346,
     /* 1314089 */     GIR_EraseRootFromParent_Done,
     /* 1314090 */   // Label 18747: @1314090
     /* 1314090 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1314178), // Rule ID 21347 //
     /* 1314095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1314098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1314106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1314109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1314115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314134 */     // MIs[0] Operand 5
     /* 1314134 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314145 */     // MIs[0] policy
     /* 1314145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314155 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1314155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1314158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314177 */     // GIR_Coverage, 21347,
     /* 1314177 */     GIR_EraseRootFromParent_Done,
     /* 1314178 */   // Label 18748: @1314178
     /* 1314178 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1314266), // Rule ID 21350 //
     /* 1314183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1314186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1314194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1314197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1314203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314222 */     // MIs[0] Operand 5
     /* 1314222 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314233 */     // MIs[0] policy
     /* 1314233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314243 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1314246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314265 */     // GIR_Coverage, 21350,
     /* 1314265 */     GIR_EraseRootFromParent_Done,
     /* 1314266 */   // Label 18749: @1314266
     /* 1314266 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1314354), // Rule ID 21351 //
     /* 1314271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1314274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1314282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1314285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1314291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314310 */     // MIs[0] Operand 5
     /* 1314310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314321 */     // MIs[0] policy
     /* 1314321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1314331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1314334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314353 */     // GIR_Coverage, 21351,
     /* 1314353 */     GIR_EraseRootFromParent_Done,
     /* 1314354 */   // Label 18750: @1314354
     /* 1314354 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1314442), // Rule ID 21354 //
     /* 1314359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1314362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1314370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1314373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1314379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314398 */     // MIs[0] Operand 5
     /* 1314398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314409 */     // MIs[0] policy
     /* 1314409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314419 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1314422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314441 */     // GIR_Coverage, 21354,
     /* 1314441 */     GIR_EraseRootFromParent_Done,
     /* 1314442 */   // Label 18751: @1314442
     /* 1314442 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1314530), // Rule ID 21355 //
     /* 1314447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1314450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1314458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1314461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1314467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314486 */     // MIs[0] Operand 5
     /* 1314486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314497 */     // MIs[0] policy
     /* 1314497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314507 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1314507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1314510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314529 */     // GIR_Coverage, 21355,
     /* 1314529 */     GIR_EraseRootFromParent_Done,
     /* 1314530 */   // Label 18752: @1314530
     /* 1314530 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1314618), // Rule ID 21358 //
     /* 1314535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1314538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1314546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1314549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1314552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1314555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314574 */     // MIs[0] Operand 5
     /* 1314574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314585 */     // MIs[0] policy
     /* 1314585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314595 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1314598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314617 */     // GIR_Coverage, 21358,
     /* 1314617 */     GIR_EraseRootFromParent_Done,
     /* 1314618 */   // Label 18753: @1314618
     /* 1314618 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1314706), // Rule ID 21359 //
     /* 1314623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1314626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1314634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1314637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1314640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1314643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314662 */     // MIs[0] Operand 5
     /* 1314662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314673 */     // MIs[0] policy
     /* 1314673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314683 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1314683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1314686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314705 */     // GIR_Coverage, 21359,
     /* 1314705 */     GIR_EraseRootFromParent_Done,
     /* 1314706 */   // Label 18754: @1314706
     /* 1314706 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1314794), // Rule ID 21362 //
     /* 1314711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1314714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1314722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1314725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1314728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1314731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314750 */     // MIs[0] Operand 5
     /* 1314750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314761 */     // MIs[0] policy
     /* 1314761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1314774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314793 */     // GIR_Coverage, 21362,
     /* 1314793 */     GIR_EraseRootFromParent_Done,
     /* 1314794 */   // Label 18755: @1314794
     /* 1314794 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1314882), // Rule ID 21363 //
     /* 1314799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1314802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1314810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1314813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1314816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1314819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314838 */     // MIs[0] Operand 5
     /* 1314838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314849 */     // MIs[0] policy
     /* 1314849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314859 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1314859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1314862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314881 */     // GIR_Coverage, 21363,
     /* 1314881 */     GIR_EraseRootFromParent_Done,
     /* 1314882 */   // Label 18756: @1314882
     /* 1314882 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1314970), // Rule ID 21366 //
     /* 1314887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1314890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1314898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1314901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1314907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1314914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314926 */     // MIs[0] Operand 5
     /* 1314926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1314937 */     // MIs[0] policy
     /* 1314937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1314940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314947 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1314947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1314950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1314958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1314968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314969 */     // GIR_Coverage, 21366,
     /* 1314969 */     GIR_EraseRootFromParent_Done,
     /* 1314970 */   // Label 18757: @1314970
     /* 1314970 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1315058), // Rule ID 21367 //
     /* 1314975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1314978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1314983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1314986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1314989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1314995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1315002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315014 */     // MIs[0] Operand 5
     /* 1315014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315025 */     // MIs[0] policy
     /* 1315025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315035 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1315038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315057 */     // GIR_Coverage, 21367,
     /* 1315057 */     GIR_EraseRootFromParent_Done,
     /* 1315058 */   // Label 18758: @1315058
     /* 1315058 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1315146), // Rule ID 21370 //
     /* 1315063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1315066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1315074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1315077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1315083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315102 */     // MIs[0] Operand 5
     /* 1315102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315113 */     // MIs[0] policy
     /* 1315113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1315123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1315126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315145 */     // GIR_Coverage, 21370,
     /* 1315145 */     GIR_EraseRootFromParent_Done,
     /* 1315146 */   // Label 18759: @1315146
     /* 1315146 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1315234), // Rule ID 21371 //
     /* 1315151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1315154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1315162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1315165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1315171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315190 */     // MIs[0] Operand 5
     /* 1315190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315201 */     // MIs[0] policy
     /* 1315201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1315214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315233 */     // GIR_Coverage, 21371,
     /* 1315233 */     GIR_EraseRootFromParent_Done,
     /* 1315234 */   // Label 18760: @1315234
     /* 1315234 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1315322), // Rule ID 21374 //
     /* 1315239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1315242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1315250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1315253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1315259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315278 */     // MIs[0] Operand 5
     /* 1315278 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315289 */     // MIs[0] policy
     /* 1315289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315299 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1315299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1315302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315321 */     // GIR_Coverage, 21374,
     /* 1315321 */     GIR_EraseRootFromParent_Done,
     /* 1315322 */   // Label 18761: @1315322
     /* 1315322 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1315410), // Rule ID 21375 //
     /* 1315327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1315330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1315338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1315341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1315347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315366 */     // MIs[0] Operand 5
     /* 1315366 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315377 */     // MIs[0] policy
     /* 1315377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315387 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1315390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315409 */     // GIR_Coverage, 21375,
     /* 1315409 */     GIR_EraseRootFromParent_Done,
     /* 1315410 */   // Label 18762: @1315410
     /* 1315410 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1315498), // Rule ID 21378 //
     /* 1315415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1315418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1315426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1315429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1315432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1315435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1315442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315454 */     // MIs[0] Operand 5
     /* 1315454 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315465 */     // MIs[0] policy
     /* 1315465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1315475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1315478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315497 */     // GIR_Coverage, 21378,
     /* 1315497 */     GIR_EraseRootFromParent_Done,
     /* 1315498 */   // Label 18763: @1315498
     /* 1315498 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1315586), // Rule ID 21379 //
     /* 1315503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1315506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1315514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1315517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1315520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1315523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1315530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315542 */     // MIs[0] Operand 5
     /* 1315542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315553 */     // MIs[0] policy
     /* 1315553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315563 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1315566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315585 */     // GIR_Coverage, 21379,
     /* 1315585 */     GIR_EraseRootFromParent_Done,
     /* 1315586 */   // Label 18764: @1315586
     /* 1315586 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1315674), // Rule ID 21382 //
     /* 1315591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1315594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1315602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1315605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1315611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1315618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315630 */     // MIs[0] Operand 5
     /* 1315630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315641 */     // MIs[0] policy
     /* 1315641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1315651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1315654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315673 */     // GIR_Coverage, 21382,
     /* 1315673 */     GIR_EraseRootFromParent_Done,
     /* 1315674 */   // Label 18765: @1315674
     /* 1315674 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1315762), // Rule ID 21383 //
     /* 1315679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1315682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1315690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1315693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1315699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1315706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315718 */     // MIs[0] Operand 5
     /* 1315718 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315729 */     // MIs[0] policy
     /* 1315729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1315742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315761 */     // GIR_Coverage, 21383,
     /* 1315761 */     GIR_EraseRootFromParent_Done,
     /* 1315762 */   // Label 18766: @1315762
     /* 1315762 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1315850), // Rule ID 21386 //
     /* 1315767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1315770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1315778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1315781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1315787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315806 */     // MIs[0] Operand 5
     /* 1315806 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315817 */     // MIs[0] policy
     /* 1315817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1315827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1315830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315849 */     // GIR_Coverage, 21386,
     /* 1315849 */     GIR_EraseRootFromParent_Done,
     /* 1315850 */   // Label 18767: @1315850
     /* 1315850 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1315938), // Rule ID 21387 //
     /* 1315855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1315858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1315866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1315869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1315875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315894 */     // MIs[0] Operand 5
     /* 1315894 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315905 */     // MIs[0] policy
     /* 1315905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1315915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1315918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1315926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1315936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315937 */     // GIR_Coverage, 21387,
     /* 1315937 */     GIR_EraseRootFromParent_Done,
     /* 1315938 */   // Label 18768: @1315938
     /* 1315938 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1316026), // Rule ID 21390 //
     /* 1315943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1315946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1315951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1315954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1315957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1315963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315982 */     // MIs[0] Operand 5
     /* 1315982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1315993 */     // MIs[0] policy
     /* 1315993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1315996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316003 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1316006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316025 */     // GIR_Coverage, 21390,
     /* 1316025 */     GIR_EraseRootFromParent_Done,
     /* 1316026 */   // Label 18769: @1316026
     /* 1316026 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1316114), // Rule ID 21391 //
     /* 1316031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1316034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1316039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1316042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1316045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1316048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1316051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1316058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316070 */     // MIs[0] Operand 5
     /* 1316070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316081 */     // MIs[0] policy
     /* 1316081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1316094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316113 */     // GIR_Coverage, 21391,
     /* 1316113 */     GIR_EraseRootFromParent_Done,
     /* 1316114 */   // Label 18770: @1316114
     /* 1316114 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1316202), // Rule ID 21394 //
     /* 1316119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1316122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1316130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1316133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1316139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316158 */     // MIs[0] Operand 5
     /* 1316158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316169 */     // MIs[0] policy
     /* 1316169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316179 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1316182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316201 */     // GIR_Coverage, 21394,
     /* 1316201 */     GIR_EraseRootFromParent_Done,
     /* 1316202 */   // Label 18771: @1316202
     /* 1316202 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1316290), // Rule ID 21395 //
     /* 1316207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1316210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1316218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1316221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1316227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316246 */     // MIs[0] Operand 5
     /* 1316246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316257 */     // MIs[0] policy
     /* 1316257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316267 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1316270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316289 */     // GIR_Coverage, 21395,
     /* 1316289 */     GIR_EraseRootFromParent_Done,
     /* 1316290 */   // Label 18772: @1316290
     /* 1316290 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1316378), // Rule ID 21398 //
     /* 1316295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1316298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1316306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1316309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1316315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316334 */     // MIs[0] Operand 5
     /* 1316334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316345 */     // MIs[0] policy
     /* 1316345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316355 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1316358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316377 */     // GIR_Coverage, 21398,
     /* 1316377 */     GIR_EraseRootFromParent_Done,
     /* 1316378 */   // Label 18773: @1316378
     /* 1316378 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1316466), // Rule ID 21399 //
     /* 1316383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1316386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1316394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1316397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1316403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316422 */     // MIs[0] Operand 5
     /* 1316422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316433 */     // MIs[0] policy
     /* 1316433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1316446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316465 */     // GIR_Coverage, 21399,
     /* 1316465 */     GIR_EraseRootFromParent_Done,
     /* 1316466 */   // Label 18774: @1316466
     /* 1316466 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1316554), // Rule ID 21402 //
     /* 1316471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1316474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1316482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1316485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1316491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316510 */     // MIs[0] Operand 5
     /* 1316510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316521 */     // MIs[0] policy
     /* 1316521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316531 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1316534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316553 */     // GIR_Coverage, 21402,
     /* 1316553 */     GIR_EraseRootFromParent_Done,
     /* 1316554 */   // Label 18775: @1316554
     /* 1316554 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1316642), // Rule ID 21403 //
     /* 1316559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1316562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1316570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1316573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1316579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316598 */     // MIs[0] Operand 5
     /* 1316598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316609 */     // MIs[0] policy
     /* 1316609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1316622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316641 */     // GIR_Coverage, 21403,
     /* 1316641 */     GIR_EraseRootFromParent_Done,
     /* 1316642 */   // Label 18776: @1316642
     /* 1316642 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1316730), // Rule ID 21406 //
     /* 1316647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1316650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1316658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1316661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1316664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1316667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316686 */     // MIs[0] Operand 5
     /* 1316686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316697 */     // MIs[0] policy
     /* 1316697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316707 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1316710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316729 */     // GIR_Coverage, 21406,
     /* 1316729 */     GIR_EraseRootFromParent_Done,
     /* 1316730 */   // Label 18777: @1316730
     /* 1316730 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1316818), // Rule ID 21407 //
     /* 1316735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1316738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1316746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1316749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1316752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1316755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316774 */     // MIs[0] Operand 5
     /* 1316774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316785 */     // MIs[0] policy
     /* 1316785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1316798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316817 */     // GIR_Coverage, 21407,
     /* 1316817 */     GIR_EraseRootFromParent_Done,
     /* 1316818 */   // Label 18778: @1316818
     /* 1316818 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1316906), // Rule ID 21410 //
     /* 1316823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1316826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1316834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1316837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1316840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1316843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1316850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316862 */     // MIs[0] Operand 5
     /* 1316862 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316873 */     // MIs[0] policy
     /* 1316873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316883 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1316883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1316886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316905 */     // GIR_Coverage, 21410,
     /* 1316905 */     GIR_EraseRootFromParent_Done,
     /* 1316906 */   // Label 18779: @1316906
     /* 1316906 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1316994), // Rule ID 21411 //
     /* 1316911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1316914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1316919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1316922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1316925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1316928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1316931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1316938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316950 */     // MIs[0] Operand 5
     /* 1316950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1316961 */     // MIs[0] policy
     /* 1316961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1316964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1316971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1316974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1316982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1316992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316993 */     // GIR_Coverage, 21411,
     /* 1316993 */     GIR_EraseRootFromParent_Done,
     /* 1316994 */   // Label 18780: @1316994
     /* 1316994 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1317082), // Rule ID 21414 //
     /* 1316999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1317002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1317010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1317013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1317019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317038 */     // MIs[0] Operand 5
     /* 1317038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317049 */     // MIs[0] policy
     /* 1317049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317059 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1317062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317081 */     // GIR_Coverage, 21414,
     /* 1317081 */     GIR_EraseRootFromParent_Done,
     /* 1317082 */   // Label 18781: @1317082
     /* 1317082 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1317170), // Rule ID 21415 //
     /* 1317087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1317090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1317098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1317101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1317107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317126 */     // MIs[0] Operand 5
     /* 1317126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317137 */     // MIs[0] policy
     /* 1317137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317147 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1317147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1317150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317169 */     // GIR_Coverage, 21415,
     /* 1317169 */     GIR_EraseRootFromParent_Done,
     /* 1317170 */   // Label 18782: @1317170
     /* 1317170 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1317258), // Rule ID 21418 //
     /* 1317175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1317178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1317186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1317189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1317192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1317195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317214 */     // MIs[0] Operand 5
     /* 1317214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317225 */     // MIs[0] policy
     /* 1317225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317235 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1317238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317257 */     // GIR_Coverage, 21418,
     /* 1317257 */     GIR_EraseRootFromParent_Done,
     /* 1317258 */   // Label 18783: @1317258
     /* 1317258 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1317346), // Rule ID 21419 //
     /* 1317263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1317266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1317274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1317277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1317280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1317283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317302 */     // MIs[0] Operand 5
     /* 1317302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317313 */     // MIs[0] policy
     /* 1317313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1317323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1317326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317345 */     // GIR_Coverage, 21419,
     /* 1317345 */     GIR_EraseRootFromParent_Done,
     /* 1317346 */   // Label 18784: @1317346
     /* 1317346 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1317434), // Rule ID 21422 //
     /* 1317351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1317354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1317362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1317365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1317371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317390 */     // MIs[0] Operand 5
     /* 1317390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317401 */     // MIs[0] policy
     /* 1317401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1317414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317433 */     // GIR_Coverage, 21422,
     /* 1317433 */     GIR_EraseRootFromParent_Done,
     /* 1317434 */   // Label 18785: @1317434
     /* 1317434 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1317522), // Rule ID 21423 //
     /* 1317439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1317442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1317450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1317453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1317459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317478 */     // MIs[0] Operand 5
     /* 1317478 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317489 */     // MIs[0] policy
     /* 1317489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1317499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1317502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317521 */     // GIR_Coverage, 21423,
     /* 1317521 */     GIR_EraseRootFromParent_Done,
     /* 1317522 */   // Label 18786: @1317522
     /* 1317522 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1317610), // Rule ID 21426 //
     /* 1317527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1317530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1317544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1317547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317566 */     // MIs[0] Operand 5
     /* 1317566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317577 */     // MIs[0] policy
     /* 1317577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317587 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1317590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317609 */     // GIR_Coverage, 21426,
     /* 1317609 */     GIR_EraseRootFromParent_Done,
     /* 1317610 */   // Label 18787: @1317610
     /* 1317610 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1317698), // Rule ID 21427 //
     /* 1317615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1317618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1317632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1317635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317654 */     // MIs[0] Operand 5
     /* 1317654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317665 */     // MIs[0] policy
     /* 1317665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1317675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1317678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317697 */     // GIR_Coverage, 21427,
     /* 1317697 */     GIR_EraseRootFromParent_Done,
     /* 1317698 */   // Label 18788: @1317698
     /* 1317698 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1317786), // Rule ID 21430 //
     /* 1317703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1317706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1317714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1317717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1317720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1317723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1317730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317742 */     // MIs[0] Operand 5
     /* 1317742 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317753 */     // MIs[0] policy
     /* 1317753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1317766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317785 */     // GIR_Coverage, 21430,
     /* 1317785 */     GIR_EraseRootFromParent_Done,
     /* 1317786 */   // Label 18789: @1317786
     /* 1317786 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1317874), // Rule ID 21431 //
     /* 1317791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1317794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1317802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1317805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1317808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1317811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1317818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317830 */     // MIs[0] Operand 5
     /* 1317830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317841 */     // MIs[0] policy
     /* 1317841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1317851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1317854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317873 */     // GIR_Coverage, 21431,
     /* 1317873 */     GIR_EraseRootFromParent_Done,
     /* 1317874 */   // Label 18790: @1317874
     /* 1317874 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1317962), // Rule ID 21434 //
     /* 1317879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1317882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1317890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1317893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1317896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1317899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317918 */     // MIs[0] Operand 5
     /* 1317918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1317929 */     // MIs[0] policy
     /* 1317929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1317932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1317939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1317942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1317950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1317960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317961 */     // GIR_Coverage, 21434,
     /* 1317961 */     GIR_EraseRootFromParent_Done,
     /* 1317962 */   // Label 18791: @1317962
     /* 1317962 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1318050), // Rule ID 21435 //
     /* 1317967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1317970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1317975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1317978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1317981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1317984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1317987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318006 */     // MIs[0] Operand 5
     /* 1318006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318017 */     // MIs[0] policy
     /* 1318017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1318030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318049 */     // GIR_Coverage, 21435,
     /* 1318049 */     GIR_EraseRootFromParent_Done,
     /* 1318050 */   // Label 18792: @1318050
     /* 1318050 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1318138), // Rule ID 21438 //
     /* 1318055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1318058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1318066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1318069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1318072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1318075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318094 */     // MIs[0] Operand 5
     /* 1318094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318105 */     // MIs[0] policy
     /* 1318105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1318115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1318118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318137 */     // GIR_Coverage, 21438,
     /* 1318137 */     GIR_EraseRootFromParent_Done,
     /* 1318138 */   // Label 18793: @1318138
     /* 1318138 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1318226), // Rule ID 21439 //
     /* 1318143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1318146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1318154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1318157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1318160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1318163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318182 */     // MIs[0] Operand 5
     /* 1318182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318193 */     // MIs[0] policy
     /* 1318193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318203 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1318206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318225 */     // GIR_Coverage, 21439,
     /* 1318225 */     GIR_EraseRootFromParent_Done,
     /* 1318226 */   // Label 18794: @1318226
     /* 1318226 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1318314), // Rule ID 21442 //
     /* 1318231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1318234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1318242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1318245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1318251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318270 */     // MIs[0] Operand 5
     /* 1318270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318281 */     // MIs[0] policy
     /* 1318281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318291 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1318291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1318294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318313 */     // GIR_Coverage, 21442,
     /* 1318313 */     GIR_EraseRootFromParent_Done,
     /* 1318314 */   // Label 18795: @1318314
     /* 1318314 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1318402), // Rule ID 21443 //
     /* 1318319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1318322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1318330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1318333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1318339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318358 */     // MIs[0] Operand 5
     /* 1318358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318369 */     // MIs[0] policy
     /* 1318369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1318382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318401 */     // GIR_Coverage, 21443,
     /* 1318401 */     GIR_EraseRootFromParent_Done,
     /* 1318402 */   // Label 18796: @1318402
     /* 1318402 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1318490), // Rule ID 21446 //
     /* 1318407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1318410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1318418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1318421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1318427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318446 */     // MIs[0] Operand 5
     /* 1318446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318457 */     // MIs[0] policy
     /* 1318457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1318467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1318470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318489 */     // GIR_Coverage, 21446,
     /* 1318489 */     GIR_EraseRootFromParent_Done,
     /* 1318490 */   // Label 18797: @1318490
     /* 1318490 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1318578), // Rule ID 21447 //
     /* 1318495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1318498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1318506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1318509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1318515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318534 */     // MIs[0] Operand 5
     /* 1318534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318545 */     // MIs[0] policy
     /* 1318545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1318558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318577 */     // GIR_Coverage, 21447,
     /* 1318577 */     GIR_EraseRootFromParent_Done,
     /* 1318578 */   // Label 18798: @1318578
     /* 1318578 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1318666), // Rule ID 21450 //
     /* 1318583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1318586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1318594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1318597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1318603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318622 */     // MIs[0] Operand 5
     /* 1318622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318633 */     // MIs[0] policy
     /* 1318633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1318643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1318646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318665 */     // GIR_Coverage, 21450,
     /* 1318665 */     GIR_EraseRootFromParent_Done,
     /* 1318666 */   // Label 18799: @1318666
     /* 1318666 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1318754), // Rule ID 21451 //
     /* 1318671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1318674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1318679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1318682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1318685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1318691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318710 */     // MIs[0] Operand 5
     /* 1318710 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1318721 */     // MIs[0] policy
     /* 1318721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1318734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1318742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318753 */     // GIR_Coverage, 21451,
     /* 1318753 */     GIR_EraseRootFromParent_Done,
     /* 1318754 */   // Label 18800: @1318754
     /* 1318754 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1318853), // Rule ID 2656 //
     /* 1318759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1318767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1318770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1318773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1318776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1318782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1318801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1318805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1318809 */     // MIs[1] Operand 1
     /* 1318809 */     // No operand predicates
     /* 1318809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318813 */     // MIs[0] policy
     /* 1318813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1318818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318825 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1318825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1318828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318834 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1318839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318852 */     // GIR_Coverage, 2656,
     /* 1318852 */     GIR_EraseRootFromParent_Done,
     /* 1318853 */   // Label 18801: @1318853
     /* 1318853 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1318952), // Rule ID 2657 //
     /* 1318858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1318866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1318869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1318872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1318875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1318881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1318900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1318904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1318908 */     // MIs[1] Operand 1
     /* 1318908 */     // No operand predicates
     /* 1318908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318912 */     // MIs[0] policy
     /* 1318912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1318915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1318917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1318924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1318927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318933 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1318938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1318950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318951 */     // GIR_Coverage, 2657,
     /* 1318951 */     GIR_EraseRootFromParent_Done,
     /* 1318952 */   // Label 18802: @1318952
     /* 1318952 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1319051), // Rule ID 2664 //
     /* 1318957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1318965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1318968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1318971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1318974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1318999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319007 */     // MIs[1] Operand 1
     /* 1319007 */     // No operand predicates
     /* 1319007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319011 */     // MIs[0] policy
     /* 1319011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319023 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1319023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1319026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319032 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319050 */     // GIR_Coverage, 2664,
     /* 1319050 */     GIR_EraseRootFromParent_Done,
     /* 1319051 */   // Label 18803: @1319051
     /* 1319051 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1319150), // Rule ID 2665 //
     /* 1319056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319106 */     // MIs[1] Operand 1
     /* 1319106 */     // No operand predicates
     /* 1319106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319110 */     // MIs[0] policy
     /* 1319110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1319122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1319125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319131 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319149 */     // GIR_Coverage, 2665,
     /* 1319149 */     GIR_EraseRootFromParent_Done,
     /* 1319150 */   // Label 18804: @1319150
     /* 1319150 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1319249), // Rule ID 2672 //
     /* 1319155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319205 */     // MIs[1] Operand 1
     /* 1319205 */     // No operand predicates
     /* 1319205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319209 */     // MIs[0] policy
     /* 1319209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319221 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1319221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319230 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319248 */     // GIR_Coverage, 2672,
     /* 1319248 */     GIR_EraseRootFromParent_Done,
     /* 1319249 */   // Label 18805: @1319249
     /* 1319249 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1319348), // Rule ID 2673 //
     /* 1319254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319304 */     // MIs[1] Operand 1
     /* 1319304 */     // No operand predicates
     /* 1319304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319308 */     // MIs[0] policy
     /* 1319308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1319320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319329 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319347 */     // GIR_Coverage, 2673,
     /* 1319347 */     GIR_EraseRootFromParent_Done,
     /* 1319348 */   // Label 18806: @1319348
     /* 1319348 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1319447), // Rule ID 2680 //
     /* 1319353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319403 */     // MIs[1] Operand 1
     /* 1319403 */     // No operand predicates
     /* 1319403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319407 */     // MIs[0] policy
     /* 1319407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1319419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1319422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319428 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319446 */     // GIR_Coverage, 2680,
     /* 1319446 */     GIR_EraseRootFromParent_Done,
     /* 1319447 */   // Label 18807: @1319447
     /* 1319447 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1319546), // Rule ID 2681 //
     /* 1319452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319502 */     // MIs[1] Operand 1
     /* 1319502 */     // No operand predicates
     /* 1319502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319506 */     // MIs[0] policy
     /* 1319506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1319518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1319521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319527 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319545 */     // GIR_Coverage, 2681,
     /* 1319545 */     GIR_EraseRootFromParent_Done,
     /* 1319546 */   // Label 18808: @1319546
     /* 1319546 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1319645), // Rule ID 2688 //
     /* 1319551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319601 */     // MIs[1] Operand 1
     /* 1319601 */     // No operand predicates
     /* 1319601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319605 */     // MIs[0] policy
     /* 1319605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319617 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1319617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319626 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319644 */     // GIR_Coverage, 2688,
     /* 1319644 */     GIR_EraseRootFromParent_Done,
     /* 1319645 */   // Label 18809: @1319645
     /* 1319645 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1319744), // Rule ID 2689 //
     /* 1319650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319700 */     // MIs[1] Operand 1
     /* 1319700 */     // No operand predicates
     /* 1319700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319704 */     // MIs[0] policy
     /* 1319704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1319716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319725 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319743 */     // GIR_Coverage, 2689,
     /* 1319743 */     GIR_EraseRootFromParent_Done,
     /* 1319744 */   // Label 18810: @1319744
     /* 1319744 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1319843), // Rule ID 2696 //
     /* 1319749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319799 */     // MIs[1] Operand 1
     /* 1319799 */     // No operand predicates
     /* 1319799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319803 */     // MIs[0] policy
     /* 1319803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319815 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1319815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319824 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319842 */     // GIR_Coverage, 2696,
     /* 1319842 */     GIR_EraseRootFromParent_Done,
     /* 1319843 */   // Label 18811: @1319843
     /* 1319843 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1319942), // Rule ID 2697 //
     /* 1319848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319898 */     // MIs[1] Operand 1
     /* 1319898 */     // No operand predicates
     /* 1319898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319902 */     // MIs[0] policy
     /* 1319902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1319905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1319914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1319917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319923 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1319928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1319940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319941 */     // GIR_Coverage, 2697,
     /* 1319941 */     GIR_EraseRootFromParent_Done,
     /* 1319942 */   // Label 18812: @1319942
     /* 1319942 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1320041), // Rule ID 2704 //
     /* 1319947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1319955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1319958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1319961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1319964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1319989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1319993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1319997 */     // MIs[1] Operand 1
     /* 1319997 */     // No operand predicates
     /* 1319997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320001 */     // MIs[0] policy
     /* 1320001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320013 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1320013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320022 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320040 */     // GIR_Coverage, 2704,
     /* 1320040 */     GIR_EraseRootFromParent_Done,
     /* 1320041 */   // Label 18813: @1320041
     /* 1320041 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1320140), // Rule ID 2705 //
     /* 1320046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320096 */     // MIs[1] Operand 1
     /* 1320096 */     // No operand predicates
     /* 1320096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320100 */     // MIs[0] policy
     /* 1320100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1320112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320121 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320139 */     // GIR_Coverage, 2705,
     /* 1320139 */     GIR_EraseRootFromParent_Done,
     /* 1320140 */   // Label 18814: @1320140
     /* 1320140 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1320239), // Rule ID 2712 //
     /* 1320145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320195 */     // MIs[1] Operand 1
     /* 1320195 */     // No operand predicates
     /* 1320195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320199 */     // MIs[0] policy
     /* 1320199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1320211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320220 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320238 */     // GIR_Coverage, 2712,
     /* 1320238 */     GIR_EraseRootFromParent_Done,
     /* 1320239 */   // Label 18815: @1320239
     /* 1320239 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1320338), // Rule ID 2713 //
     /* 1320244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320294 */     // MIs[1] Operand 1
     /* 1320294 */     // No operand predicates
     /* 1320294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320298 */     // MIs[0] policy
     /* 1320298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1320310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320319 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320337 */     // GIR_Coverage, 2713,
     /* 1320337 */     GIR_EraseRootFromParent_Done,
     /* 1320338 */   // Label 18816: @1320338
     /* 1320338 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1320437), // Rule ID 2720 //
     /* 1320343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320393 */     // MIs[1] Operand 1
     /* 1320393 */     // No operand predicates
     /* 1320393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320397 */     // MIs[0] policy
     /* 1320397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320409 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1320409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320418 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320436 */     // GIR_Coverage, 2720,
     /* 1320436 */     GIR_EraseRootFromParent_Done,
     /* 1320437 */   // Label 18817: @1320437
     /* 1320437 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1320536), // Rule ID 2721 //
     /* 1320442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320492 */     // MIs[1] Operand 1
     /* 1320492 */     // No operand predicates
     /* 1320492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320496 */     // MIs[0] policy
     /* 1320496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1320508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320517 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320535 */     // GIR_Coverage, 2721,
     /* 1320535 */     GIR_EraseRootFromParent_Done,
     /* 1320536 */   // Label 18818: @1320536
     /* 1320536 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1320635), // Rule ID 2728 //
     /* 1320541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320591 */     // MIs[1] Operand 1
     /* 1320591 */     // No operand predicates
     /* 1320591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320595 */     // MIs[0] policy
     /* 1320595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1320607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320616 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320634 */     // GIR_Coverage, 2728,
     /* 1320634 */     GIR_EraseRootFromParent_Done,
     /* 1320635 */   // Label 18819: @1320635
     /* 1320635 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1320734), // Rule ID 2729 //
     /* 1320640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320690 */     // MIs[1] Operand 1
     /* 1320690 */     // No operand predicates
     /* 1320690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320694 */     // MIs[0] policy
     /* 1320694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1320706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1320709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320715 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320733 */     // GIR_Coverage, 2729,
     /* 1320733 */     GIR_EraseRootFromParent_Done,
     /* 1320734 */   // Label 18820: @1320734
     /* 1320734 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1320833), // Rule ID 2736 //
     /* 1320739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320789 */     // MIs[1] Operand 1
     /* 1320789 */     // No operand predicates
     /* 1320789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320793 */     // MIs[0] policy
     /* 1320793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320805 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1320805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1320808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320814 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320832 */     // GIR_Coverage, 2736,
     /* 1320832 */     GIR_EraseRootFromParent_Done,
     /* 1320833 */   // Label 18821: @1320833
     /* 1320833 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1320932), // Rule ID 2737 //
     /* 1320838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320888 */     // MIs[1] Operand 1
     /* 1320888 */     // No operand predicates
     /* 1320888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320892 */     // MIs[0] policy
     /* 1320892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1320904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1320907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320913 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1320918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1320930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320931 */     // GIR_Coverage, 2737,
     /* 1320931 */     GIR_EraseRootFromParent_Done,
     /* 1320932 */   // Label 18822: @1320932
     /* 1320932 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1321031), // Rule ID 2744 //
     /* 1320937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1320945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1320948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1320951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1320954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1320979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1320983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1320987 */     // MIs[1] Operand 1
     /* 1320987 */     // No operand predicates
     /* 1320987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320991 */     // MIs[0] policy
     /* 1320991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1320994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1320996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321003 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1321006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321012 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321030 */     // GIR_Coverage, 2744,
     /* 1321030 */     GIR_EraseRootFromParent_Done,
     /* 1321031 */   // Label 18823: @1321031
     /* 1321031 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1321130), // Rule ID 2745 //
     /* 1321036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1321047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1321050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321086 */     // MIs[1] Operand 1
     /* 1321086 */     // No operand predicates
     /* 1321086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321090 */     // MIs[0] policy
     /* 1321090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321102 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1321102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1321105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321111 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321129 */     // GIR_Coverage, 2745,
     /* 1321129 */     GIR_EraseRootFromParent_Done,
     /* 1321130 */   // Label 18824: @1321130
     /* 1321130 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1321229), // Rule ID 2752 //
     /* 1321135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321185 */     // MIs[1] Operand 1
     /* 1321185 */     // No operand predicates
     /* 1321185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321189 */     // MIs[0] policy
     /* 1321189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321201 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1321204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321210 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321228 */     // GIR_Coverage, 2752,
     /* 1321228 */     GIR_EraseRootFromParent_Done,
     /* 1321229 */   // Label 18825: @1321229
     /* 1321229 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1321328), // Rule ID 2753 //
     /* 1321234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321284 */     // MIs[1] Operand 1
     /* 1321284 */     // No operand predicates
     /* 1321284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321288 */     // MIs[0] policy
     /* 1321288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321300 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1321300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1321303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321309 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321327 */     // GIR_Coverage, 2753,
     /* 1321327 */     GIR_EraseRootFromParent_Done,
     /* 1321328 */   // Label 18826: @1321328
     /* 1321328 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1321427), // Rule ID 2760 //
     /* 1321333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321383 */     // MIs[1] Operand 1
     /* 1321383 */     // No operand predicates
     /* 1321383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321387 */     // MIs[0] policy
     /* 1321387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1321402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321408 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321426 */     // GIR_Coverage, 2760,
     /* 1321426 */     GIR_EraseRootFromParent_Done,
     /* 1321427 */   // Label 18827: @1321427
     /* 1321427 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1321526), // Rule ID 2761 //
     /* 1321432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321482 */     // MIs[1] Operand 1
     /* 1321482 */     // No operand predicates
     /* 1321482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321486 */     // MIs[0] policy
     /* 1321486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1321498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1321501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321507 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321525 */     // GIR_Coverage, 2761,
     /* 1321525 */     GIR_EraseRootFromParent_Done,
     /* 1321526 */   // Label 18828: @1321526
     /* 1321526 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1321625), // Rule ID 2768 //
     /* 1321531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321581 */     // MIs[1] Operand 1
     /* 1321581 */     // No operand predicates
     /* 1321581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321585 */     // MIs[0] policy
     /* 1321585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321597 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1321600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321606 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321624 */     // GIR_Coverage, 2768,
     /* 1321624 */     GIR_EraseRootFromParent_Done,
     /* 1321625 */   // Label 18829: @1321625
     /* 1321625 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1321724), // Rule ID 2769 //
     /* 1321630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321680 */     // MIs[1] Operand 1
     /* 1321680 */     // No operand predicates
     /* 1321680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321684 */     // MIs[0] policy
     /* 1321684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1321696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1321699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321705 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321723 */     // GIR_Coverage, 2769,
     /* 1321723 */     GIR_EraseRootFromParent_Done,
     /* 1321724 */   // Label 18830: @1321724
     /* 1321724 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1321823), // Rule ID 2776 //
     /* 1321729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321779 */     // MIs[1] Operand 1
     /* 1321779 */     // No operand predicates
     /* 1321779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321783 */     // MIs[0] policy
     /* 1321783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321795 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1321798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321804 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321822 */     // GIR_Coverage, 2776,
     /* 1321822 */     GIR_EraseRootFromParent_Done,
     /* 1321823 */   // Label 18831: @1321823
     /* 1321823 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1321922), // Rule ID 2777 //
     /* 1321828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321878 */     // MIs[1] Operand 1
     /* 1321878 */     // No operand predicates
     /* 1321878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321882 */     // MIs[0] policy
     /* 1321882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1321894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1321897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321903 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1321908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1321920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321921 */     // GIR_Coverage, 2777,
     /* 1321921 */     GIR_EraseRootFromParent_Done,
     /* 1321922 */   // Label 18832: @1321922
     /* 1321922 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1322021), // Rule ID 2784 //
     /* 1321927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1321935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1321938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1321941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1321969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1321973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1321977 */     // MIs[1] Operand 1
     /* 1321977 */     // No operand predicates
     /* 1321977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321981 */     // MIs[0] policy
     /* 1321981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1321984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1321986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1321993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1321996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322002 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322020 */     // GIR_Coverage, 2784,
     /* 1322020 */     GIR_EraseRootFromParent_Done,
     /* 1322021 */   // Label 18833: @1322021
     /* 1322021 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1322120), // Rule ID 2785 //
     /* 1322026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322076 */     // MIs[1] Operand 1
     /* 1322076 */     // No operand predicates
     /* 1322076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322080 */     // MIs[0] policy
     /* 1322080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1322092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1322095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322101 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322119 */     // GIR_Coverage, 2785,
     /* 1322119 */     GIR_EraseRootFromParent_Done,
     /* 1322120 */   // Label 18834: @1322120
     /* 1322120 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1322219), // Rule ID 2792 //
     /* 1322125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322175 */     // MIs[1] Operand 1
     /* 1322175 */     // No operand predicates
     /* 1322175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322179 */     // MIs[0] policy
     /* 1322179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1322191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1322194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322200 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322218 */     // GIR_Coverage, 2792,
     /* 1322218 */     GIR_EraseRootFromParent_Done,
     /* 1322219 */   // Label 18835: @1322219
     /* 1322219 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1322318), // Rule ID 2793 //
     /* 1322224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322274 */     // MIs[1] Operand 1
     /* 1322274 */     // No operand predicates
     /* 1322274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322278 */     // MIs[0] policy
     /* 1322278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1322290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1322293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322299 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322317 */     // GIR_Coverage, 2793,
     /* 1322317 */     GIR_EraseRootFromParent_Done,
     /* 1322318 */   // Label 18836: @1322318
     /* 1322318 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1322417), // Rule ID 2800 //
     /* 1322323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322373 */     // MIs[1] Operand 1
     /* 1322373 */     // No operand predicates
     /* 1322373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322377 */     // MIs[0] policy
     /* 1322377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322389 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1322389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1322392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322398 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322416 */     // GIR_Coverage, 2800,
     /* 1322416 */     GIR_EraseRootFromParent_Done,
     /* 1322417 */   // Label 18837: @1322417
     /* 1322417 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1322516), // Rule ID 2801 //
     /* 1322422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322472 */     // MIs[1] Operand 1
     /* 1322472 */     // No operand predicates
     /* 1322472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322476 */     // MIs[0] policy
     /* 1322476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322488 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1322488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1322491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322497 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322515 */     // GIR_Coverage, 2801,
     /* 1322515 */     GIR_EraseRootFromParent_Done,
     /* 1322516 */   // Label 18838: @1322516
     /* 1322516 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1322615), // Rule ID 2808 //
     /* 1322521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322571 */     // MIs[1] Operand 1
     /* 1322571 */     // No operand predicates
     /* 1322571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322575 */     // MIs[0] policy
     /* 1322575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1322587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1322590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322596 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322614 */     // GIR_Coverage, 2808,
     /* 1322614 */     GIR_EraseRootFromParent_Done,
     /* 1322615 */   // Label 18839: @1322615
     /* 1322615 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1322714), // Rule ID 2809 //
     /* 1322620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322670 */     // MIs[1] Operand 1
     /* 1322670 */     // No operand predicates
     /* 1322670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322674 */     // MIs[0] policy
     /* 1322674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1322686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1322689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322695 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322713 */     // GIR_Coverage, 2809,
     /* 1322713 */     GIR_EraseRootFromParent_Done,
     /* 1322714 */   // Label 18840: @1322714
     /* 1322714 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1322813), // Rule ID 2816 //
     /* 1322719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322769 */     // MIs[1] Operand 1
     /* 1322769 */     // No operand predicates
     /* 1322769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322773 */     // MIs[0] policy
     /* 1322773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1322785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1322788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322812 */     // GIR_Coverage, 2816,
     /* 1322812 */     GIR_EraseRootFromParent_Done,
     /* 1322813 */   // Label 18841: @1322813
     /* 1322813 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1322912), // Rule ID 2817 //
     /* 1322818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322868 */     // MIs[1] Operand 1
     /* 1322868 */     // No operand predicates
     /* 1322868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322872 */     // MIs[0] policy
     /* 1322872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1322884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1322887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322893 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1322910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322911 */     // GIR_Coverage, 2817,
     /* 1322911 */     GIR_EraseRootFromParent_Done,
     /* 1322912 */   // Label 18842: @1322912
     /* 1322912 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1323011), // Rule ID 2824 //
     /* 1322917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1322925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1322959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1322963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1322967 */     // MIs[1] Operand 1
     /* 1322967 */     // No operand predicates
     /* 1322967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322971 */     // MIs[0] policy
     /* 1322971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1322974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1322976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1322983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1322986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322992 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1322997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323010 */     // GIR_Coverage, 2824,
     /* 1323010 */     GIR_EraseRootFromParent_Done,
     /* 1323011 */   // Label 18843: @1323011
     /* 1323011 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1323110), // Rule ID 2825 //
     /* 1323016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1323019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1323024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1323027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1323030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1323033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1323046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1323066 */     // MIs[1] Operand 1
     /* 1323066 */     // No operand predicates
     /* 1323066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323070 */     // MIs[0] policy
     /* 1323070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1323082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1323085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323091 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1323096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323109 */     // GIR_Coverage, 2825,
     /* 1323109 */     GIR_EraseRootFromParent_Done,
     /* 1323110 */   // Label 18844: @1323110
     /* 1323110 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1323207), // Rule ID 3000 //
     /* 1323115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323165 */     // MIs[1] Operand 1
     /* 1323165 */     // No operand predicates
     /* 1323165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323169 */     // MIs[0] policy
     /* 1323169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323181 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1323181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1323184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323206 */     // GIR_Coverage, 3000,
     /* 1323206 */     GIR_EraseRootFromParent_Done,
     /* 1323207 */   // Label 18845: @1323207
     /* 1323207 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1323304), // Rule ID 3001 //
     /* 1323212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323262 */     // MIs[1] Operand 1
     /* 1323262 */     // No operand predicates
     /* 1323262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323266 */     // MIs[0] policy
     /* 1323266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323278 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1323278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1323281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323303 */     // GIR_Coverage, 3001,
     /* 1323303 */     GIR_EraseRootFromParent_Done,
     /* 1323304 */   // Label 18846: @1323304
     /* 1323304 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1323401), // Rule ID 3004 //
     /* 1323309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323359 */     // MIs[1] Operand 1
     /* 1323359 */     // No operand predicates
     /* 1323359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323363 */     // MIs[0] policy
     /* 1323363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323375 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1323375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1323378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323400 */     // GIR_Coverage, 3004,
     /* 1323400 */     GIR_EraseRootFromParent_Done,
     /* 1323401 */   // Label 18847: @1323401
     /* 1323401 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1323498), // Rule ID 3005 //
     /* 1323406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323456 */     // MIs[1] Operand 1
     /* 1323456 */     // No operand predicates
     /* 1323456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323460 */     // MIs[0] policy
     /* 1323460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323472 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1323472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1323475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323497 */     // GIR_Coverage, 3005,
     /* 1323497 */     GIR_EraseRootFromParent_Done,
     /* 1323498 */   // Label 18848: @1323498
     /* 1323498 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1323595), // Rule ID 3008 //
     /* 1323503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323553 */     // MIs[1] Operand 1
     /* 1323553 */     // No operand predicates
     /* 1323553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323557 */     // MIs[0] policy
     /* 1323557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323569 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1323569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1323572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323594 */     // GIR_Coverage, 3008,
     /* 1323594 */     GIR_EraseRootFromParent_Done,
     /* 1323595 */   // Label 18849: @1323595
     /* 1323595 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1323692), // Rule ID 3009 //
     /* 1323600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323650 */     // MIs[1] Operand 1
     /* 1323650 */     // No operand predicates
     /* 1323650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323654 */     // MIs[0] policy
     /* 1323654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1323666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1323669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323691 */     // GIR_Coverage, 3009,
     /* 1323691 */     GIR_EraseRootFromParent_Done,
     /* 1323692 */   // Label 18850: @1323692
     /* 1323692 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1323789), // Rule ID 3012 //
     /* 1323697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323747 */     // MIs[1] Operand 1
     /* 1323747 */     // No operand predicates
     /* 1323747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323751 */     // MIs[0] policy
     /* 1323751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323763 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1323763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1323766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323788 */     // GIR_Coverage, 3012,
     /* 1323788 */     GIR_EraseRootFromParent_Done,
     /* 1323789 */   // Label 18851: @1323789
     /* 1323789 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1323886), // Rule ID 3013 //
     /* 1323794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323844 */     // MIs[1] Operand 1
     /* 1323844 */     // No operand predicates
     /* 1323844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323848 */     // MIs[0] policy
     /* 1323848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323860 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1323860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1323863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323885 */     // GIR_Coverage, 3013,
     /* 1323885 */     GIR_EraseRootFromParent_Done,
     /* 1323886 */   // Label 18852: @1323886
     /* 1323886 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1323983), // Rule ID 3016 //
     /* 1323891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1323933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1323937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1323941 */     // MIs[1] Operand 1
     /* 1323941 */     // No operand predicates
     /* 1323941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323945 */     // MIs[0] policy
     /* 1323945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1323948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1323957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1323960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1323969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1323981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323982 */     // GIR_Coverage, 3016,
     /* 1323982 */     GIR_EraseRootFromParent_Done,
     /* 1323983 */   // Label 18853: @1323983
     /* 1323983 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1324080), // Rule ID 3017 //
     /* 1323988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1323996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1324002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1324005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324038 */     // MIs[1] Operand 1
     /* 1324038 */     // No operand predicates
     /* 1324038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324042 */     // MIs[0] policy
     /* 1324042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1324054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1324057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324079 */     // GIR_Coverage, 3017,
     /* 1324079 */     GIR_EraseRootFromParent_Done,
     /* 1324080 */   // Label 18854: @1324080
     /* 1324080 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1324177), // Rule ID 3020 //
     /* 1324085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1324096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1324099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1324102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324135 */     // MIs[1] Operand 1
     /* 1324135 */     // No operand predicates
     /* 1324135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324139 */     // MIs[0] policy
     /* 1324139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1324151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1324154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324176 */     // GIR_Coverage, 3020,
     /* 1324176 */     GIR_EraseRootFromParent_Done,
     /* 1324177 */   // Label 18855: @1324177
     /* 1324177 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1324274), // Rule ID 3021 //
     /* 1324182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1324193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1324196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1324199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324232 */     // MIs[1] Operand 1
     /* 1324232 */     // No operand predicates
     /* 1324232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324236 */     // MIs[0] policy
     /* 1324236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1324248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1324251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324273 */     // GIR_Coverage, 3021,
     /* 1324273 */     GIR_EraseRootFromParent_Done,
     /* 1324274 */   // Label 18856: @1324274
     /* 1324274 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1324371), // Rule ID 3024 //
     /* 1324279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324329 */     // MIs[1] Operand 1
     /* 1324329 */     // No operand predicates
     /* 1324329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324333 */     // MIs[0] policy
     /* 1324333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1324345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324370 */     // GIR_Coverage, 3024,
     /* 1324370 */     GIR_EraseRootFromParent_Done,
     /* 1324371 */   // Label 18857: @1324371
     /* 1324371 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1324468), // Rule ID 3025 //
     /* 1324376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324426 */     // MIs[1] Operand 1
     /* 1324426 */     // No operand predicates
     /* 1324426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324430 */     // MIs[0] policy
     /* 1324430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1324442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324467 */     // GIR_Coverage, 3025,
     /* 1324467 */     GIR_EraseRootFromParent_Done,
     /* 1324468 */   // Label 18858: @1324468
     /* 1324468 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1324565), // Rule ID 3028 //
     /* 1324473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324523 */     // MIs[1] Operand 1
     /* 1324523 */     // No operand predicates
     /* 1324523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324527 */     // MIs[0] policy
     /* 1324527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324539 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1324539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324564 */     // GIR_Coverage, 3028,
     /* 1324564 */     GIR_EraseRootFromParent_Done,
     /* 1324565 */   // Label 18859: @1324565
     /* 1324565 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1324662), // Rule ID 3029 //
     /* 1324570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324620 */     // MIs[1] Operand 1
     /* 1324620 */     // No operand predicates
     /* 1324620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324624 */     // MIs[0] policy
     /* 1324624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1324636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324661 */     // GIR_Coverage, 3029,
     /* 1324661 */     GIR_EraseRootFromParent_Done,
     /* 1324662 */   // Label 18860: @1324662
     /* 1324662 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1324759), // Rule ID 3032 //
     /* 1324667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324717 */     // MIs[1] Operand 1
     /* 1324717 */     // No operand predicates
     /* 1324717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324721 */     // MIs[0] policy
     /* 1324721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1324733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324758 */     // GIR_Coverage, 3032,
     /* 1324758 */     GIR_EraseRootFromParent_Done,
     /* 1324759 */   // Label 18861: @1324759
     /* 1324759 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1324856), // Rule ID 3033 //
     /* 1324764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324814 */     // MIs[1] Operand 1
     /* 1324814 */     // No operand predicates
     /* 1324814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324818 */     // MIs[0] policy
     /* 1324818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1324830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324855 */     // GIR_Coverage, 3033,
     /* 1324855 */     GIR_EraseRootFromParent_Done,
     /* 1324856 */   // Label 18862: @1324856
     /* 1324856 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1324953), // Rule ID 3036 //
     /* 1324861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1324903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1324907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1324911 */     // MIs[1] Operand 1
     /* 1324911 */     // No operand predicates
     /* 1324911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324915 */     // MIs[0] policy
     /* 1324915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1324918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1324920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1324927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1324930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1324939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1324951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324952 */     // GIR_Coverage, 3036,
     /* 1324952 */     GIR_EraseRootFromParent_Done,
     /* 1324953 */   // Label 18863: @1324953
     /* 1324953 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1325050), // Rule ID 3037 //
     /* 1324958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1324966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325008 */     // MIs[1] Operand 1
     /* 1325008 */     // No operand predicates
     /* 1325008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325012 */     // MIs[0] policy
     /* 1325012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1325027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325049 */     // GIR_Coverage, 3037,
     /* 1325049 */     GIR_EraseRootFromParent_Done,
     /* 1325050 */   // Label 18864: @1325050
     /* 1325050 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1325147), // Rule ID 3040 //
     /* 1325055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1325066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1325069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1325072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325105 */     // MIs[1] Operand 1
     /* 1325105 */     // No operand predicates
     /* 1325105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325109 */     // MIs[0] policy
     /* 1325109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325121 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1325121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1325124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325146 */     // GIR_Coverage, 3040,
     /* 1325146 */     GIR_EraseRootFromParent_Done,
     /* 1325147 */   // Label 18865: @1325147
     /* 1325147 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1325244), // Rule ID 3041 //
     /* 1325152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1325163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1325166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1325169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325202 */     // MIs[1] Operand 1
     /* 1325202 */     // No operand predicates
     /* 1325202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325206 */     // MIs[0] policy
     /* 1325206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1325221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325243 */     // GIR_Coverage, 3041,
     /* 1325243 */     GIR_EraseRootFromParent_Done,
     /* 1325244 */   // Label 18866: @1325244
     /* 1325244 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1325341), // Rule ID 3044 //
     /* 1325249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1325260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1325263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1325266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325299 */     // MIs[1] Operand 1
     /* 1325299 */     // No operand predicates
     /* 1325299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325303 */     // MIs[0] policy
     /* 1325303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325315 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1325315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1325318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325340 */     // GIR_Coverage, 3044,
     /* 1325340 */     GIR_EraseRootFromParent_Done,
     /* 1325341 */   // Label 18867: @1325341
     /* 1325341 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1325438), // Rule ID 3045 //
     /* 1325346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1325357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1325360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1325363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325396 */     // MIs[1] Operand 1
     /* 1325396 */     // No operand predicates
     /* 1325396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325400 */     // MIs[0] policy
     /* 1325400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325412 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1325415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325437 */     // GIR_Coverage, 3045,
     /* 1325437 */     GIR_EraseRootFromParent_Done,
     /* 1325438 */   // Label 18868: @1325438
     /* 1325438 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1325535), // Rule ID 3048 //
     /* 1325443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1325454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1325457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1325460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1325466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325493 */     // MIs[1] Operand 1
     /* 1325493 */     // No operand predicates
     /* 1325493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325497 */     // MIs[0] policy
     /* 1325497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325509 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1325509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1325512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325534 */     // GIR_Coverage, 3048,
     /* 1325534 */     GIR_EraseRootFromParent_Done,
     /* 1325535 */   // Label 18869: @1325535
     /* 1325535 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1325632), // Rule ID 3049 //
     /* 1325540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1325551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1325554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1325557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1325563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325590 */     // MIs[1] Operand 1
     /* 1325590 */     // No operand predicates
     /* 1325590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325594 */     // MIs[0] policy
     /* 1325594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325606 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1325609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325631 */     // GIR_Coverage, 3049,
     /* 1325631 */     GIR_EraseRootFromParent_Done,
     /* 1325632 */   // Label 18870: @1325632
     /* 1325632 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1325729), // Rule ID 3052 //
     /* 1325637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325687 */     // MIs[1] Operand 1
     /* 1325687 */     // No operand predicates
     /* 1325687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325691 */     // MIs[0] policy
     /* 1325691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1325703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1325706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325728 */     // GIR_Coverage, 3052,
     /* 1325728 */     GIR_EraseRootFromParent_Done,
     /* 1325729 */   // Label 18871: @1325729
     /* 1325729 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1325826), // Rule ID 3053 //
     /* 1325734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325784 */     // MIs[1] Operand 1
     /* 1325784 */     // No operand predicates
     /* 1325784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325788 */     // MIs[0] policy
     /* 1325788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1325803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325825 */     // GIR_Coverage, 3053,
     /* 1325825 */     GIR_EraseRootFromParent_Done,
     /* 1325826 */   // Label 18872: @1325826
     /* 1325826 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1325923), // Rule ID 3056 //
     /* 1325831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325881 */     // MIs[1] Operand 1
     /* 1325881 */     // No operand predicates
     /* 1325881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325885 */     // MIs[0] policy
     /* 1325885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325897 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1325897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1325900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1325909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1325921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325922 */     // GIR_Coverage, 3056,
     /* 1325922 */     GIR_EraseRootFromParent_Done,
     /* 1325923 */   // Label 18873: @1325923
     /* 1325923 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1326020), // Rule ID 3057 //
     /* 1325928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1325936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1325970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1325974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1325978 */     // MIs[1] Operand 1
     /* 1325978 */     // No operand predicates
     /* 1325978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325982 */     // MIs[0] policy
     /* 1325982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1325985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325994 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1325994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1325997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326019 */     // GIR_Coverage, 3057,
     /* 1326019 */     GIR_EraseRootFromParent_Done,
     /* 1326020 */   // Label 18874: @1326020
     /* 1326020 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1326117), // Rule ID 3060 //
     /* 1326025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1326036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1326039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1326042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1326048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326075 */     // MIs[1] Operand 1
     /* 1326075 */     // No operand predicates
     /* 1326075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326079 */     // MIs[0] policy
     /* 1326079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326091 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1326091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1326094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326116 */     // GIR_Coverage, 3060,
     /* 1326116 */     GIR_EraseRootFromParent_Done,
     /* 1326117 */   // Label 18875: @1326117
     /* 1326117 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1326214), // Rule ID 3061 //
     /* 1326122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1326133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1326136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1326139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1326145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326172 */     // MIs[1] Operand 1
     /* 1326172 */     // No operand predicates
     /* 1326172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326176 */     // MIs[0] policy
     /* 1326176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326188 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1326188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1326191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326213 */     // GIR_Coverage, 3061,
     /* 1326213 */     GIR_EraseRootFromParent_Done,
     /* 1326214 */   // Label 18876: @1326214
     /* 1326214 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1326311), // Rule ID 3064 //
     /* 1326219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1326230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1326233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1326236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326269 */     // MIs[1] Operand 1
     /* 1326269 */     // No operand predicates
     /* 1326269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326273 */     // MIs[0] policy
     /* 1326273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1326285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1326288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326310 */     // GIR_Coverage, 3064,
     /* 1326310 */     GIR_EraseRootFromParent_Done,
     /* 1326311 */   // Label 18877: @1326311
     /* 1326311 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1326408), // Rule ID 3065 //
     /* 1326316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1326327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1326330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1326333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326366 */     // MIs[1] Operand 1
     /* 1326366 */     // No operand predicates
     /* 1326366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326370 */     // MIs[0] policy
     /* 1326370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1326382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1326385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326407 */     // GIR_Coverage, 3065,
     /* 1326407 */     GIR_EraseRootFromParent_Done,
     /* 1326408 */   // Label 18878: @1326408
     /* 1326408 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1326505), // Rule ID 3068 //
     /* 1326413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1326424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1326427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1326430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326463 */     // MIs[1] Operand 1
     /* 1326463 */     // No operand predicates
     /* 1326463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326467 */     // MIs[0] policy
     /* 1326467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1326479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1326482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326504 */     // GIR_Coverage, 3068,
     /* 1326504 */     GIR_EraseRootFromParent_Done,
     /* 1326505 */   // Label 18879: @1326505
     /* 1326505 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1326602), // Rule ID 3069 //
     /* 1326510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1326521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1326524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1326527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326560 */     // MIs[1] Operand 1
     /* 1326560 */     // No operand predicates
     /* 1326560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326564 */     // MIs[0] policy
     /* 1326564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1326576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1326579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326601 */     // GIR_Coverage, 3069,
     /* 1326601 */     GIR_EraseRootFromParent_Done,
     /* 1326602 */   // Label 18880: @1326602
     /* 1326602 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1326699), // Rule ID 3072 //
     /* 1326607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1326618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1326621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326657 */     // MIs[1] Operand 1
     /* 1326657 */     // No operand predicates
     /* 1326657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326661 */     // MIs[0] policy
     /* 1326661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326673 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1326673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1326676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326698 */     // GIR_Coverage, 3072,
     /* 1326698 */     GIR_EraseRootFromParent_Done,
     /* 1326699 */   // Label 18881: @1326699
     /* 1326699 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1326796), // Rule ID 3073 //
     /* 1326704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1326715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1326718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326754 */     // MIs[1] Operand 1
     /* 1326754 */     // No operand predicates
     /* 1326754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326758 */     // MIs[0] policy
     /* 1326758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1326770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1326773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326795 */     // GIR_Coverage, 3073,
     /* 1326795 */     GIR_EraseRootFromParent_Done,
     /* 1326796 */   // Label 18882: @1326796
     /* 1326796 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1326893), // Rule ID 3076 //
     /* 1326801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326851 */     // MIs[1] Operand 1
     /* 1326851 */     // No operand predicates
     /* 1326851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326855 */     // MIs[0] policy
     /* 1326855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1326867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1326870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326892 */     // GIR_Coverage, 3076,
     /* 1326892 */     GIR_EraseRootFromParent_Done,
     /* 1326893 */   // Label 18883: @1326893
     /* 1326893 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1326990), // Rule ID 3077 //
     /* 1326898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1326906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1326940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1326944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1326948 */     // MIs[1] Operand 1
     /* 1326948 */     // No operand predicates
     /* 1326948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326952 */     // MIs[0] policy
     /* 1326952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1326955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1326957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1326964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1326967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1326976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1326988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326989 */     // GIR_Coverage, 3077,
     /* 1326989 */     GIR_EraseRootFromParent_Done,
     /* 1326990 */   // Label 18884: @1326990
     /* 1326990 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1327087), // Rule ID 3080 //
     /* 1326995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1327003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1327006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1327009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1327012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1327025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327045 */     // MIs[1] Operand 1
     /* 1327045 */     // No operand predicates
     /* 1327045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327049 */     // MIs[0] policy
     /* 1327049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1327061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1327064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327086 */     // GIR_Coverage, 3080,
     /* 1327086 */     GIR_EraseRootFromParent_Done,
     /* 1327087 */   // Label 18885: @1327087
     /* 1327087 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1327184), // Rule ID 3081 //
     /* 1327092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1327095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1327100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1327103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1327106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1327109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1327122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327142 */     // MIs[1] Operand 1
     /* 1327142 */     // No operand predicates
     /* 1327142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327146 */     // MIs[0] policy
     /* 1327146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327158 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1327158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1327161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327183 */     // GIR_Coverage, 3081,
     /* 1327183 */     GIR_EraseRootFromParent_Done,
     /* 1327184 */   // Label 18886: @1327184
     /* 1327184 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1327281), // Rule ID 3084 //
     /* 1327189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1327192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1327197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1327200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1327203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1327206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1327219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327239 */     // MIs[1] Operand 1
     /* 1327239 */     // No operand predicates
     /* 1327239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327243 */     // MIs[0] policy
     /* 1327243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327255 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1327255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1327258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327280 */     // GIR_Coverage, 3084,
     /* 1327280 */     GIR_EraseRootFromParent_Done,
     /* 1327281 */   // Label 18887: @1327281
     /* 1327281 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1327378), // Rule ID 3085 //
     /* 1327286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1327289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1327294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1327297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1327300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1327303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1327316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327336 */     // MIs[1] Operand 1
     /* 1327336 */     // No operand predicates
     /* 1327336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327340 */     // MIs[0] policy
     /* 1327340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1327352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1327355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327377 */     // GIR_Coverage, 3085,
     /* 1327377 */     GIR_EraseRootFromParent_Done,
     /* 1327378 */   // Label 18888: @1327378
     /* 1327378 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1327475), // Rule ID 3352 //
     /* 1327383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1327394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1327397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1327400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327433 */     // MIs[1] Operand 1
     /* 1327433 */     // No operand predicates
     /* 1327433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327437 */     // MIs[0] policy
     /* 1327437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327449 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1327449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1327452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327474 */     // GIR_Coverage, 3352,
     /* 1327474 */     GIR_EraseRootFromParent_Done,
     /* 1327475 */   // Label 18889: @1327475
     /* 1327475 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1327572), // Rule ID 3353 //
     /* 1327480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1327491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1327494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1327497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327530 */     // MIs[1] Operand 1
     /* 1327530 */     // No operand predicates
     /* 1327530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327534 */     // MIs[0] policy
     /* 1327534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1327546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1327549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327571 */     // GIR_Coverage, 3353,
     /* 1327571 */     GIR_EraseRootFromParent_Done,
     /* 1327572 */   // Label 18890: @1327572
     /* 1327572 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1327669), // Rule ID 3356 //
     /* 1327577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1327588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1327591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1327594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327627 */     // MIs[1] Operand 1
     /* 1327627 */     // No operand predicates
     /* 1327627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327631 */     // MIs[0] policy
     /* 1327631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1327643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1327646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327668 */     // GIR_Coverage, 3356,
     /* 1327668 */     GIR_EraseRootFromParent_Done,
     /* 1327669 */   // Label 18891: @1327669
     /* 1327669 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1327766), // Rule ID 3357 //
     /* 1327674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1327685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1327688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1327691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327724 */     // MIs[1] Operand 1
     /* 1327724 */     // No operand predicates
     /* 1327724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327728 */     // MIs[0] policy
     /* 1327728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327740 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1327740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1327743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327765 */     // GIR_Coverage, 3357,
     /* 1327765 */     GIR_EraseRootFromParent_Done,
     /* 1327766 */   // Label 18892: @1327766
     /* 1327766 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1327863), // Rule ID 3360 //
     /* 1327771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1327782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1327785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1327788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327821 */     // MIs[1] Operand 1
     /* 1327821 */     // No operand predicates
     /* 1327821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327825 */     // MIs[0] policy
     /* 1327825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327837 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1327837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1327840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327862 */     // GIR_Coverage, 3360,
     /* 1327862 */     GIR_EraseRootFromParent_Done,
     /* 1327863 */   // Label 18893: @1327863
     /* 1327863 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1327960), // Rule ID 3361 //
     /* 1327868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1327879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1327882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1327885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1327910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1327914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1327918 */     // MIs[1] Operand 1
     /* 1327918 */     // No operand predicates
     /* 1327918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327922 */     // MIs[0] policy
     /* 1327922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1327925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1327927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1327934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1327937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1327946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1327958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327959 */     // GIR_Coverage, 3361,
     /* 1327959 */     GIR_EraseRootFromParent_Done,
     /* 1327960 */   // Label 18894: @1327960
     /* 1327960 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1328057), // Rule ID 3364 //
     /* 1327965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1327973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1327976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1327979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1327982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328015 */     // MIs[1] Operand 1
     /* 1328015 */     // No operand predicates
     /* 1328015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328019 */     // MIs[0] policy
     /* 1328019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328031 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1328031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1328034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328056 */     // GIR_Coverage, 3364,
     /* 1328056 */     GIR_EraseRootFromParent_Done,
     /* 1328057 */   // Label 18895: @1328057
     /* 1328057 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1328154), // Rule ID 3365 //
     /* 1328062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1328073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1328076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328112 */     // MIs[1] Operand 1
     /* 1328112 */     // No operand predicates
     /* 1328112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328116 */     // MIs[0] policy
     /* 1328116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1328128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1328131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328153 */     // GIR_Coverage, 3365,
     /* 1328153 */     GIR_EraseRootFromParent_Done,
     /* 1328154 */   // Label 18896: @1328154
     /* 1328154 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1328251), // Rule ID 3368 //
     /* 1328159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1328170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1328173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328209 */     // MIs[1] Operand 1
     /* 1328209 */     // No operand predicates
     /* 1328209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328213 */     // MIs[0] policy
     /* 1328213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328225 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1328225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1328228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328250 */     // GIR_Coverage, 3368,
     /* 1328250 */     GIR_EraseRootFromParent_Done,
     /* 1328251 */   // Label 18897: @1328251
     /* 1328251 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1328348), // Rule ID 3369 //
     /* 1328256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1328267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1328270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328306 */     // MIs[1] Operand 1
     /* 1328306 */     // No operand predicates
     /* 1328306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328310 */     // MIs[0] policy
     /* 1328310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328322 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1328322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1328325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328347 */     // GIR_Coverage, 3369,
     /* 1328347 */     GIR_EraseRootFromParent_Done,
     /* 1328348 */   // Label 18898: @1328348
     /* 1328348 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1328445), // Rule ID 3372 //
     /* 1328353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1328364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1328367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1328370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328403 */     // MIs[1] Operand 1
     /* 1328403 */     // No operand predicates
     /* 1328403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328407 */     // MIs[0] policy
     /* 1328407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1328419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1328422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328444 */     // GIR_Coverage, 3372,
     /* 1328444 */     GIR_EraseRootFromParent_Done,
     /* 1328445 */   // Label 18899: @1328445
     /* 1328445 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1328542), // Rule ID 3373 //
     /* 1328450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1328461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1328464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1328467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328500 */     // MIs[1] Operand 1
     /* 1328500 */     // No operand predicates
     /* 1328500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328504 */     // MIs[0] policy
     /* 1328504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1328516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1328519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328541 */     // GIR_Coverage, 3373,
     /* 1328541 */     GIR_EraseRootFromParent_Done,
     /* 1328542 */   // Label 18900: @1328542
     /* 1328542 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1328639), // Rule ID 3376 //
     /* 1328547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1328558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1328561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1328564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328597 */     // MIs[1] Operand 1
     /* 1328597 */     // No operand predicates
     /* 1328597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328601 */     // MIs[0] policy
     /* 1328601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328613 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1328613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1328616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328638 */     // GIR_Coverage, 3376,
     /* 1328638 */     GIR_EraseRootFromParent_Done,
     /* 1328639 */   // Label 18901: @1328639
     /* 1328639 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1328736), // Rule ID 3377 //
     /* 1328644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1328655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1328658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1328661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328694 */     // MIs[1] Operand 1
     /* 1328694 */     // No operand predicates
     /* 1328694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328698 */     // MIs[0] policy
     /* 1328698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1328710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1328713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328735 */     // GIR_Coverage, 3377,
     /* 1328735 */     GIR_EraseRootFromParent_Done,
     /* 1328736 */   // Label 18902: @1328736
     /* 1328736 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1328833), // Rule ID 3380 //
     /* 1328741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1328752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1328755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1328758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328791 */     // MIs[1] Operand 1
     /* 1328791 */     // No operand predicates
     /* 1328791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328795 */     // MIs[0] policy
     /* 1328795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1328807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1328810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328832 */     // GIR_Coverage, 3380,
     /* 1328832 */     GIR_EraseRootFromParent_Done,
     /* 1328833 */   // Label 18903: @1328833
     /* 1328833 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1328930), // Rule ID 3381 //
     /* 1328838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1328849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1328852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1328855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328888 */     // MIs[1] Operand 1
     /* 1328888 */     // No operand predicates
     /* 1328888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328892 */     // MIs[0] policy
     /* 1328892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1328904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1328907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1328916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1328928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328929 */     // GIR_Coverage, 3381,
     /* 1328929 */     GIR_EraseRootFromParent_Done,
     /* 1328930 */   // Label 18904: @1328930
     /* 1328930 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1329027), // Rule ID 3384 //
     /* 1328935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1328943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1328946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1328949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1328952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1328965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1328977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1328981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1328985 */     // MIs[1] Operand 1
     /* 1328985 */     // No operand predicates
     /* 1328985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328989 */     // MIs[0] policy
     /* 1328989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1328992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1328994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1329004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329026 */     // GIR_Coverage, 3384,
     /* 1329026 */     GIR_EraseRootFromParent_Done,
     /* 1329027 */   // Label 18905: @1329027
     /* 1329027 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1329124), // Rule ID 3385 //
     /* 1329032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1329043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1329046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1329062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329082 */     // MIs[1] Operand 1
     /* 1329082 */     // No operand predicates
     /* 1329082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329086 */     // MIs[0] policy
     /* 1329086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1329098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1329101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329123 */     // GIR_Coverage, 3385,
     /* 1329123 */     GIR_EraseRootFromParent_Done,
     /* 1329124 */   // Label 18906: @1329124
     /* 1329124 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1329221), // Rule ID 3388 //
     /* 1329129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1329132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1329140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1329143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1329159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329179 */     // MIs[1] Operand 1
     /* 1329179 */     // No operand predicates
     /* 1329179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329183 */     // MIs[0] policy
     /* 1329183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1329198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329220 */     // GIR_Coverage, 3388,
     /* 1329220 */     GIR_EraseRootFromParent_Done,
     /* 1329221 */   // Label 18907: @1329221
     /* 1329221 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1329318), // Rule ID 3389 //
     /* 1329226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1329229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1329237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1329240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1329256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329276 */     // MIs[1] Operand 1
     /* 1329276 */     // No operand predicates
     /* 1329276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329280 */     // MIs[0] policy
     /* 1329280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1329292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1329295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329317 */     // GIR_Coverage, 3389,
     /* 1329317 */     GIR_EraseRootFromParent_Done,
     /* 1329318 */   // Label 18908: @1329318
     /* 1329318 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1329415), // Rule ID 3392 //
     /* 1329323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1329334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1329337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1329340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329373 */     // MIs[1] Operand 1
     /* 1329373 */     // No operand predicates
     /* 1329373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329377 */     // MIs[0] policy
     /* 1329377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329389 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1329392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329414 */     // GIR_Coverage, 3392,
     /* 1329414 */     GIR_EraseRootFromParent_Done,
     /* 1329415 */   // Label 18909: @1329415
     /* 1329415 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1329512), // Rule ID 3393 //
     /* 1329420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1329431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1329434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1329437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329470 */     // MIs[1] Operand 1
     /* 1329470 */     // No operand predicates
     /* 1329470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329474 */     // MIs[0] policy
     /* 1329474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1329486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1329489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329511 */     // GIR_Coverage, 3393,
     /* 1329511 */     GIR_EraseRootFromParent_Done,
     /* 1329512 */   // Label 18910: @1329512
     /* 1329512 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1329609), // Rule ID 3396 //
     /* 1329517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1329528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1329531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1329534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1329540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329567 */     // MIs[1] Operand 1
     /* 1329567 */     // No operand predicates
     /* 1329567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329571 */     // MIs[0] policy
     /* 1329571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329583 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1329586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329608 */     // GIR_Coverage, 3396,
     /* 1329608 */     GIR_EraseRootFromParent_Done,
     /* 1329609 */   // Label 18911: @1329609
     /* 1329609 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1329706), // Rule ID 3397 //
     /* 1329614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1329625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1329628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1329631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1329637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329664 */     // MIs[1] Operand 1
     /* 1329664 */     // No operand predicates
     /* 1329664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329668 */     // MIs[0] policy
     /* 1329668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1329680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1329683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329705 */     // GIR_Coverage, 3397,
     /* 1329705 */     GIR_EraseRootFromParent_Done,
     /* 1329706 */   // Label 18912: @1329706
     /* 1329706 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1329803), // Rule ID 3400 //
     /* 1329711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1329722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1329725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1329728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1329734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329761 */     // MIs[1] Operand 1
     /* 1329761 */     // No operand predicates
     /* 1329761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329765 */     // MIs[0] policy
     /* 1329765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329777 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1329780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329802 */     // GIR_Coverage, 3400,
     /* 1329802 */     GIR_EraseRootFromParent_Done,
     /* 1329803 */   // Label 18913: @1329803
     /* 1329803 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1329900), // Rule ID 3401 //
     /* 1329808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1329819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1329822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1329825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1329831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329858 */     // MIs[1] Operand 1
     /* 1329858 */     // No operand predicates
     /* 1329858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329862 */     // MIs[0] policy
     /* 1329862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1329874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1329877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1329896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329899 */     // GIR_Coverage, 3401,
     /* 1329899 */     GIR_EraseRootFromParent_Done,
     /* 1329900 */   // Label 18914: @1329900
     /* 1329900 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1329997), // Rule ID 3404 //
     /* 1329905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1329913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1329916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1329919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1329947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1329951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1329955 */     // MIs[1] Operand 1
     /* 1329955 */     // No operand predicates
     /* 1329955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329959 */     // MIs[0] policy
     /* 1329959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1329962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1329964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1329971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1329974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1329983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1329995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329996 */     // GIR_Coverage, 3404,
     /* 1329996 */     GIR_EraseRootFromParent_Done,
     /* 1329997 */   // Label 18915: @1329997
     /* 1329997 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1330094), // Rule ID 3405 //
     /* 1330002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1330013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1330016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1330032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330052 */     // MIs[1] Operand 1
     /* 1330052 */     // No operand predicates
     /* 1330052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330056 */     // MIs[0] policy
     /* 1330056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1330068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1330071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330093 */     // GIR_Coverage, 3405,
     /* 1330093 */     GIR_EraseRootFromParent_Done,
     /* 1330094 */   // Label 18916: @1330094
     /* 1330094 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1330191), // Rule ID 3408 //
     /* 1330099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1330102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1330110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1330113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1330129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330149 */     // MIs[1] Operand 1
     /* 1330149 */     // No operand predicates
     /* 1330149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330153 */     // MIs[0] policy
     /* 1330153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1330165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1330168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330190 */     // GIR_Coverage, 3408,
     /* 1330190 */     GIR_EraseRootFromParent_Done,
     /* 1330191 */   // Label 18917: @1330191
     /* 1330191 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1330288), // Rule ID 3409 //
     /* 1330196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1330207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1330210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1330226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330246 */     // MIs[1] Operand 1
     /* 1330246 */     // No operand predicates
     /* 1330246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330250 */     // MIs[0] policy
     /* 1330250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330262 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1330262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1330265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330287 */     // GIR_Coverage, 3409,
     /* 1330287 */     GIR_EraseRootFromParent_Done,
     /* 1330288 */   // Label 18918: @1330288
     /* 1330288 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1330385), // Rule ID 3412 //
     /* 1330293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1330296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1330304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1330307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1330323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330343 */     // MIs[1] Operand 1
     /* 1330343 */     // No operand predicates
     /* 1330343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330347 */     // MIs[0] policy
     /* 1330347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330359 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1330359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1330362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330384 */     // GIR_Coverage, 3412,
     /* 1330384 */     GIR_EraseRootFromParent_Done,
     /* 1330385 */   // Label 18919: @1330385
     /* 1330385 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1330482), // Rule ID 3413 //
     /* 1330390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1330401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1330404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1330420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330440 */     // MIs[1] Operand 1
     /* 1330440 */     // No operand predicates
     /* 1330440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330444 */     // MIs[0] policy
     /* 1330444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330456 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1330456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1330459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330481 */     // GIR_Coverage, 3413,
     /* 1330481 */     GIR_EraseRootFromParent_Done,
     /* 1330482 */   // Label 18920: @1330482
     /* 1330482 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1330579), // Rule ID 3416 //
     /* 1330487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1330490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1330498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1330501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1330517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330537 */     // MIs[1] Operand 1
     /* 1330537 */     // No operand predicates
     /* 1330537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330541 */     // MIs[0] policy
     /* 1330541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1330553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1330556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330578 */     // GIR_Coverage, 3416,
     /* 1330578 */     GIR_EraseRootFromParent_Done,
     /* 1330579 */   // Label 18921: @1330579
     /* 1330579 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1330676), // Rule ID 3417 //
     /* 1330584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1330595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1330598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1330614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330634 */     // MIs[1] Operand 1
     /* 1330634 */     // No operand predicates
     /* 1330634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330638 */     // MIs[0] policy
     /* 1330638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1330650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1330653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330675 */     // GIR_Coverage, 3417,
     /* 1330675 */     GIR_EraseRootFromParent_Done,
     /* 1330676 */   // Label 18922: @1330676
     /* 1330676 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1330773), // Rule ID 3420 //
     /* 1330681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1330684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1330692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1330695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1330711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330731 */     // MIs[1] Operand 1
     /* 1330731 */     // No operand predicates
     /* 1330731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330735 */     // MIs[0] policy
     /* 1330735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330747 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1330747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1330750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330772 */     // GIR_Coverage, 3420,
     /* 1330772 */     GIR_EraseRootFromParent_Done,
     /* 1330773 */   // Label 18923: @1330773
     /* 1330773 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1330870), // Rule ID 3421 //
     /* 1330778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1330789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1330792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1330808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330828 */     // MIs[1] Operand 1
     /* 1330828 */     // No operand predicates
     /* 1330828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330832 */     // MIs[0] policy
     /* 1330832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1330844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1330847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330869 */     // GIR_Coverage, 3421,
     /* 1330869 */     GIR_EraseRootFromParent_Done,
     /* 1330870 */   // Label 18924: @1330870
     /* 1330870 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1330967), // Rule ID 3424 //
     /* 1330875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1330878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1330886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1330889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1330905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1330917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1330921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1330925 */     // MIs[1] Operand 1
     /* 1330925 */     // No operand predicates
     /* 1330925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330929 */     // MIs[0] policy
     /* 1330929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1330932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1330934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330941 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1330941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1330944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1330953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1330965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330966 */     // GIR_Coverage, 3424,
     /* 1330966 */     GIR_EraseRootFromParent_Done,
     /* 1330967 */   // Label 18925: @1330967
     /* 1330967 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1331064), // Rule ID 3425 //
     /* 1330972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1330975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1330980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1330983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1330986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1331002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331022 */     // MIs[1] Operand 1
     /* 1331022 */     // No operand predicates
     /* 1331022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331026 */     // MIs[0] policy
     /* 1331026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1331038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1331041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331063 */     // GIR_Coverage, 3425,
     /* 1331063 */     GIR_EraseRootFromParent_Done,
     /* 1331064 */   // Label 18926: @1331064
     /* 1331064 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1331161), // Rule ID 3428 //
     /* 1331069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1331072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1331080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1331083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1331099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331119 */     // MIs[1] Operand 1
     /* 1331119 */     // No operand predicates
     /* 1331119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331123 */     // MIs[0] policy
     /* 1331123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1331135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1331138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331160 */     // GIR_Coverage, 3428,
     /* 1331160 */     GIR_EraseRootFromParent_Done,
     /* 1331161 */   // Label 18927: @1331161
     /* 1331161 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1331258), // Rule ID 3429 //
     /* 1331166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1331169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1331177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1331180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1331196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331216 */     // MIs[1] Operand 1
     /* 1331216 */     // No operand predicates
     /* 1331216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331220 */     // MIs[0] policy
     /* 1331220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1331232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1331235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331257 */     // GIR_Coverage, 3429,
     /* 1331257 */     GIR_EraseRootFromParent_Done,
     /* 1331258 */   // Label 18928: @1331258
     /* 1331258 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1331355), // Rule ID 3432 //
     /* 1331263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1331266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1331274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1331277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1331293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331313 */     // MIs[1] Operand 1
     /* 1331313 */     // No operand predicates
     /* 1331313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331317 */     // MIs[0] policy
     /* 1331317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331329 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1331329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1331332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331354 */     // GIR_Coverage, 3432,
     /* 1331354 */     GIR_EraseRootFromParent_Done,
     /* 1331355 */   // Label 18929: @1331355
     /* 1331355 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1331452), // Rule ID 3433 //
     /* 1331360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1331363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1331371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1331374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1331390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331410 */     // MIs[1] Operand 1
     /* 1331410 */     // No operand predicates
     /* 1331410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331414 */     // MIs[0] policy
     /* 1331414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1331426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1331429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331451 */     // GIR_Coverage, 3433,
     /* 1331451 */     GIR_EraseRootFromParent_Done,
     /* 1331452 */   // Label 18930: @1331452
     /* 1331452 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1331549), // Rule ID 3436 //
     /* 1331457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1331460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1331468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1331471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1331487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331507 */     // MIs[1] Operand 1
     /* 1331507 */     // No operand predicates
     /* 1331507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331511 */     // MIs[0] policy
     /* 1331511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331523 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1331523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1331526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331548 */     // GIR_Coverage, 3436,
     /* 1331548 */     GIR_EraseRootFromParent_Done,
     /* 1331549 */   // Label 18931: @1331549
     /* 1331549 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1331646), // Rule ID 3437 //
     /* 1331554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1331557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1331562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1331565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1331568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1331584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331604 */     // MIs[1] Operand 1
     /* 1331604 */     // No operand predicates
     /* 1331604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331608 */     // MIs[0] policy
     /* 1331608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1331620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1331623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331645 */     // GIR_Coverage, 3437,
     /* 1331645 */     GIR_EraseRootFromParent_Done,
     /* 1331646 */   // Label 18932: @1331646
     /* 1331646 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1331743), // Rule ID 5800 //
     /* 1331651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1331654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1331659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1331662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1331665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1331668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1331681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331701 */     // MIs[1] Operand 1
     /* 1331701 */     // No operand predicates
     /* 1331701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331705 */     // MIs[0] policy
     /* 1331705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331717 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1331717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1331720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1331739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331742 */     // GIR_Coverage, 5800,
     /* 1331742 */     GIR_EraseRootFromParent_Done,
     /* 1331743 */   // Label 18933: @1331743
     /* 1331743 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1331840), // Rule ID 5801 //
     /* 1331748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1331751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1331756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1331759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1331762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1331765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1331778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331798 */     // MIs[1] Operand 1
     /* 1331798 */     // No operand predicates
     /* 1331798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331802 */     // MIs[0] policy
     /* 1331802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331814 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1331814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1331817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1331836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331839 */     // GIR_Coverage, 5801,
     /* 1331839 */     GIR_EraseRootFromParent_Done,
     /* 1331840 */   // Label 18934: @1331840
     /* 1331840 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1331937), // Rule ID 5804 //
     /* 1331845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1331848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1331853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1331856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1331859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1331862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1331875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331895 */     // MIs[1] Operand 1
     /* 1331895 */     // No operand predicates
     /* 1331895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331899 */     // MIs[0] policy
     /* 1331899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1331904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331911 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1331911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1331914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1331923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1331933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1331935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331936 */     // GIR_Coverage, 5804,
     /* 1331936 */     GIR_EraseRootFromParent_Done,
     /* 1331937 */   // Label 18935: @1331937
     /* 1331937 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1332034), // Rule ID 5805 //
     /* 1331942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1331945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1331950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1331953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1331956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1331959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1331972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1331984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1331988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1331992 */     // MIs[1] Operand 1
     /* 1331992 */     // No operand predicates
     /* 1331992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331996 */     // MIs[0] policy
     /* 1331996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1331999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1332011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1332030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332033 */     // GIR_Coverage, 5805,
     /* 1332033 */     GIR_EraseRootFromParent_Done,
     /* 1332034 */   // Label 18936: @1332034
     /* 1332034 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1332131), // Rule ID 5808 //
     /* 1332039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1332042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1332050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1332053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1332056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332089 */     // MIs[1] Operand 1
     /* 1332089 */     // No operand predicates
     /* 1332089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332093 */     // MIs[0] policy
     /* 1332093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332105 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1332105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1332127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332130 */     // GIR_Coverage, 5808,
     /* 1332130 */     GIR_EraseRootFromParent_Done,
     /* 1332131 */   // Label 18937: @1332131
     /* 1332131 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1332228), // Rule ID 5809 //
     /* 1332136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1332139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1332147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1332150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1332153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332186 */     // MIs[1] Operand 1
     /* 1332186 */     // No operand predicates
     /* 1332186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332190 */     // MIs[0] policy
     /* 1332190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332202 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1332224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332227 */     // GIR_Coverage, 5809,
     /* 1332227 */     GIR_EraseRootFromParent_Done,
     /* 1332228 */   // Label 18938: @1332228
     /* 1332228 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1332325), // Rule ID 5812 //
     /* 1332233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1332236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1332244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1332247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332283 */     // MIs[1] Operand 1
     /* 1332283 */     // No operand predicates
     /* 1332283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332287 */     // MIs[0] policy
     /* 1332287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332299 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1332299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1332302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332324 */     // GIR_Coverage, 5812,
     /* 1332324 */     GIR_EraseRootFromParent_Done,
     /* 1332325 */   // Label 18939: @1332325
     /* 1332325 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1332422), // Rule ID 5813 //
     /* 1332330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1332333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1332341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1332344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332380 */     // MIs[1] Operand 1
     /* 1332380 */     // No operand predicates
     /* 1332380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332384 */     // MIs[0] policy
     /* 1332384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1332399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332421 */     // GIR_Coverage, 5813,
     /* 1332421 */     GIR_EraseRootFromParent_Done,
     /* 1332422 */   // Label 18940: @1332422
     /* 1332422 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1332519), // Rule ID 5816 //
     /* 1332427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1332430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1332438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1332441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332477 */     // MIs[1] Operand 1
     /* 1332477 */     // No operand predicates
     /* 1332477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332481 */     // MIs[0] policy
     /* 1332481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1332493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332518 */     // GIR_Coverage, 5816,
     /* 1332518 */     GIR_EraseRootFromParent_Done,
     /* 1332519 */   // Label 18941: @1332519
     /* 1332519 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1332616), // Rule ID 5817 //
     /* 1332524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1332527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1332535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1332538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332574 */     // MIs[1] Operand 1
     /* 1332574 */     // No operand predicates
     /* 1332574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332578 */     // MIs[0] policy
     /* 1332578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332615 */     // GIR_Coverage, 5817,
     /* 1332615 */     GIR_EraseRootFromParent_Done,
     /* 1332616 */   // Label 18942: @1332616
     /* 1332616 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1332713), // Rule ID 5820 //
     /* 1332621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1332624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1332632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1332635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332671 */     // MIs[1] Operand 1
     /* 1332671 */     // No operand predicates
     /* 1332671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332675 */     // MIs[0] policy
     /* 1332675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332687 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1332687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332712 */     // GIR_Coverage, 5820,
     /* 1332712 */     GIR_EraseRootFromParent_Done,
     /* 1332713 */   // Label 18943: @1332713
     /* 1332713 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1332810), // Rule ID 5821 //
     /* 1332718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1332721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1332729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1332732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332768 */     // MIs[1] Operand 1
     /* 1332768 */     // No operand predicates
     /* 1332768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332772 */     // MIs[0] policy
     /* 1332772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1332787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332809 */     // GIR_Coverage, 5821,
     /* 1332809 */     GIR_EraseRootFromParent_Done,
     /* 1332810 */   // Label 18944: @1332810
     /* 1332810 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1332907), // Rule ID 5824 //
     /* 1332815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1332818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1332826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1332829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1332832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332865 */     // MIs[1] Operand 1
     /* 1332865 */     // No operand predicates
     /* 1332865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332869 */     // MIs[0] policy
     /* 1332869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332881 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1332881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1332884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1332903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1332905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332906 */     // GIR_Coverage, 5824,
     /* 1332906 */     GIR_EraseRootFromParent_Done,
     /* 1332907 */   // Label 18945: @1332907
     /* 1332907 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1333004), // Rule ID 5825 //
     /* 1332912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1332915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1332920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1332923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1332926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1332929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1332942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1332954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1332958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1332962 */     // MIs[1] Operand 1
     /* 1332962 */     // No operand predicates
     /* 1332962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332966 */     // MIs[0] policy
     /* 1332966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1332969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1332971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1332978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1332981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1332990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1333000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333003 */     // GIR_Coverage, 5825,
     /* 1333003 */     GIR_EraseRootFromParent_Done,
     /* 1333004 */   // Label 18946: @1333004
     /* 1333004 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1333101), // Rule ID 5828 //
     /* 1333009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1333012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1333020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1333023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1333026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333059 */     // MIs[1] Operand 1
     /* 1333059 */     // No operand predicates
     /* 1333059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333063 */     // MIs[0] policy
     /* 1333063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1333075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333100 */     // GIR_Coverage, 5828,
     /* 1333100 */     GIR_EraseRootFromParent_Done,
     /* 1333101 */   // Label 18947: @1333101
     /* 1333101 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1333198), // Rule ID 5829 //
     /* 1333106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1333109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1333117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1333120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1333123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333156 */     // MIs[1] Operand 1
     /* 1333156 */     // No operand predicates
     /* 1333156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333160 */     // MIs[0] policy
     /* 1333160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1333172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333197 */     // GIR_Coverage, 5829,
     /* 1333197 */     GIR_EraseRootFromParent_Done,
     /* 1333198 */   // Label 18948: @1333198
     /* 1333198 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1333295), // Rule ID 5832 //
     /* 1333203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1333206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1333214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1333217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1333220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333253 */     // MIs[1] Operand 1
     /* 1333253 */     // No operand predicates
     /* 1333253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333257 */     // MIs[0] policy
     /* 1333257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333269 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1333269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333294 */     // GIR_Coverage, 5832,
     /* 1333294 */     GIR_EraseRootFromParent_Done,
     /* 1333295 */   // Label 18949: @1333295
     /* 1333295 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1333392), // Rule ID 5833 //
     /* 1333300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1333303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1333311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1333314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1333317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333350 */     // MIs[1] Operand 1
     /* 1333350 */     // No operand predicates
     /* 1333350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333354 */     // MIs[0] policy
     /* 1333354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1333366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333391 */     // GIR_Coverage, 5833,
     /* 1333391 */     GIR_EraseRootFromParent_Done,
     /* 1333392 */   // Label 18950: @1333392
     /* 1333392 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1333489), // Rule ID 5836 //
     /* 1333397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1333400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1333408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1333411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1333414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333447 */     // MIs[1] Operand 1
     /* 1333447 */     // No operand predicates
     /* 1333447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333451 */     // MIs[0] policy
     /* 1333451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333463 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1333463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333488 */     // GIR_Coverage, 5836,
     /* 1333488 */     GIR_EraseRootFromParent_Done,
     /* 1333489 */   // Label 18951: @1333489
     /* 1333489 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1333586), // Rule ID 5837 //
     /* 1333494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1333497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1333505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1333508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1333511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1333524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333544 */     // MIs[1] Operand 1
     /* 1333544 */     // No operand predicates
     /* 1333544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333548 */     // MIs[0] policy
     /* 1333548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1333560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1333563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333585 */     // GIR_Coverage, 5837,
     /* 1333585 */     GIR_EraseRootFromParent_Done,
     /* 1333586 */   // Label 18952: @1333586
     /* 1333586 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1333683), // Rule ID 5840 //
     /* 1333591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1333594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1333602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1333605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1333608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1333621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333641 */     // MIs[1] Operand 1
     /* 1333641 */     // No operand predicates
     /* 1333641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333645 */     // MIs[0] policy
     /* 1333645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333657 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1333657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1333660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1333679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333682 */     // GIR_Coverage, 5840,
     /* 1333682 */     GIR_EraseRootFromParent_Done,
     /* 1333683 */   // Label 18953: @1333683
     /* 1333683 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1333780), // Rule ID 5841 //
     /* 1333688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1333691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1333699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1333702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1333705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1333718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333738 */     // MIs[1] Operand 1
     /* 1333738 */     // No operand predicates
     /* 1333738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333742 */     // MIs[0] policy
     /* 1333742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1333754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1333757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1333776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333779 */     // GIR_Coverage, 5841,
     /* 1333779 */     GIR_EraseRootFromParent_Done,
     /* 1333780 */   // Label 18954: @1333780
     /* 1333780 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1333877), // Rule ID 5844 //
     /* 1333785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1333788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1333796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1333799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1333802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1333815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333835 */     // MIs[1] Operand 1
     /* 1333835 */     // No operand predicates
     /* 1333835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333839 */     // MIs[0] policy
     /* 1333839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1333851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1333854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1333873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333876 */     // GIR_Coverage, 5844,
     /* 1333876 */     GIR_EraseRootFromParent_Done,
     /* 1333877 */   // Label 18955: @1333877
     /* 1333877 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1333974), // Rule ID 5845 //
     /* 1333882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1333885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1333893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1333896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1333899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1333912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1333924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1333928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1333932 */     // MIs[1] Operand 1
     /* 1333932 */     // No operand predicates
     /* 1333932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333936 */     // MIs[0] policy
     /* 1333936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1333939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333948 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1333948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1333951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1333960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1333970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1333972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333973 */     // GIR_Coverage, 5845,
     /* 1333973 */     GIR_EraseRootFromParent_Done,
     /* 1333974 */   // Label 18956: @1333974
     /* 1333974 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1334071), // Rule ID 5848 //
     /* 1333979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1333982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1333987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1333990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1333993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1333996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1334002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1334009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334029 */     // MIs[1] Operand 1
     /* 1334029 */     // No operand predicates
     /* 1334029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334033 */     // MIs[0] policy
     /* 1334033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334045 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1334045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1334048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1334067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334070 */     // GIR_Coverage, 5848,
     /* 1334070 */     GIR_EraseRootFromParent_Done,
     /* 1334071 */   // Label 18957: @1334071
     /* 1334071 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1334168), // Rule ID 5849 //
     /* 1334076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1334079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1334087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1334090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1334093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1334099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1334106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334126 */     // MIs[1] Operand 1
     /* 1334126 */     // No operand predicates
     /* 1334126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334130 */     // MIs[0] policy
     /* 1334130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334142 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1334142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1334145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1334164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334167 */     // GIR_Coverage, 5849,
     /* 1334167 */     GIR_EraseRootFromParent_Done,
     /* 1334168 */   // Label 18958: @1334168
     /* 1334168 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1334265), // Rule ID 5852 //
     /* 1334173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1334176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1334184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1334187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1334203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334223 */     // MIs[1] Operand 1
     /* 1334223 */     // No operand predicates
     /* 1334223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334227 */     // MIs[0] policy
     /* 1334227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334239 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1334239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1334242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334264 */     // GIR_Coverage, 5852,
     /* 1334264 */     GIR_EraseRootFromParent_Done,
     /* 1334265 */   // Label 18959: @1334265
     /* 1334265 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1334362), // Rule ID 5853 //
     /* 1334270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1334273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1334281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1334284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1334300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334320 */     // MIs[1] Operand 1
     /* 1334320 */     // No operand predicates
     /* 1334320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334324 */     // MIs[0] policy
     /* 1334324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1334336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1334339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334361 */     // GIR_Coverage, 5853,
     /* 1334361 */     GIR_EraseRootFromParent_Done,
     /* 1334362 */   // Label 18960: @1334362
     /* 1334362 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1334459), // Rule ID 5856 //
     /* 1334367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1334370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1334378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1334381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1334397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334417 */     // MIs[1] Operand 1
     /* 1334417 */     // No operand predicates
     /* 1334417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334421 */     // MIs[0] policy
     /* 1334421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334433 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1334433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1334436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334458 */     // GIR_Coverage, 5856,
     /* 1334458 */     GIR_EraseRootFromParent_Done,
     /* 1334459 */   // Label 18961: @1334459
     /* 1334459 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1334556), // Rule ID 5857 //
     /* 1334464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1334467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1334475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1334478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1334494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334514 */     // MIs[1] Operand 1
     /* 1334514 */     // No operand predicates
     /* 1334514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334518 */     // MIs[0] policy
     /* 1334518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1334530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1334533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334555 */     // GIR_Coverage, 5857,
     /* 1334555 */     GIR_EraseRootFromParent_Done,
     /* 1334556 */   // Label 18962: @1334556
     /* 1334556 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1334653), // Rule ID 5860 //
     /* 1334561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1334564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1334572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1334575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1334578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1334584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1334591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334611 */     // MIs[1] Operand 1
     /* 1334611 */     // No operand predicates
     /* 1334611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334615 */     // MIs[0] policy
     /* 1334615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334627 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1334627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1334630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334652 */     // GIR_Coverage, 5860,
     /* 1334652 */     GIR_EraseRootFromParent_Done,
     /* 1334653 */   // Label 18963: @1334653
     /* 1334653 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1334750), // Rule ID 5861 //
     /* 1334658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1334661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1334669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1334672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1334675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1334681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1334688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334708 */     // MIs[1] Operand 1
     /* 1334708 */     // No operand predicates
     /* 1334708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334712 */     // MIs[0] policy
     /* 1334712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1334724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1334727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334749 */     // GIR_Coverage, 5861,
     /* 1334749 */     GIR_EraseRootFromParent_Done,
     /* 1334750 */   // Label 18964: @1334750
     /* 1334750 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1334847), // Rule ID 5864 //
     /* 1334755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1334758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1334766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1334769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1334772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1334785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334805 */     // MIs[1] Operand 1
     /* 1334805 */     // No operand predicates
     /* 1334805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334809 */     // MIs[0] policy
     /* 1334809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1334821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1334824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334846 */     // GIR_Coverage, 5864,
     /* 1334846 */     GIR_EraseRootFromParent_Done,
     /* 1334847 */   // Label 18965: @1334847
     /* 1334847 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1334944), // Rule ID 5865 //
     /* 1334852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1334855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1334863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1334866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1334869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1334882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334902 */     // MIs[1] Operand 1
     /* 1334902 */     // No operand predicates
     /* 1334902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334906 */     // MIs[0] policy
     /* 1334906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1334909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1334918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1334921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1334930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1334942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334943 */     // GIR_Coverage, 5865,
     /* 1334943 */     GIR_EraseRootFromParent_Done,
     /* 1334944 */   // Label 18966: @1334944
     /* 1334944 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1335041), // Rule ID 5868 //
     /* 1334949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1334952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1334957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1334960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1334963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1334966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1334979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1334991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1334995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1334999 */     // MIs[1] Operand 1
     /* 1334999 */     // No operand predicates
     /* 1334999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335003 */     // MIs[0] policy
     /* 1335003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335015 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1335018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335040 */     // GIR_Coverage, 5868,
     /* 1335040 */     GIR_EraseRootFromParent_Done,
     /* 1335041 */   // Label 18967: @1335041
     /* 1335041 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1335138), // Rule ID 5869 //
     /* 1335046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1335049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1335057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1335060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1335076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335096 */     // MIs[1] Operand 1
     /* 1335096 */     // No operand predicates
     /* 1335096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335100 */     // MIs[0] policy
     /* 1335100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1335112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1335115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335137 */     // GIR_Coverage, 5869,
     /* 1335137 */     GIR_EraseRootFromParent_Done,
     /* 1335138 */   // Label 18968: @1335138
     /* 1335138 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1335235), // Rule ID 5872 //
     /* 1335143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1335146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1335154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1335157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1335173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335193 */     // MIs[1] Operand 1
     /* 1335193 */     // No operand predicates
     /* 1335193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335197 */     // MIs[0] policy
     /* 1335197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1335212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335234 */     // GIR_Coverage, 5872,
     /* 1335234 */     GIR_EraseRootFromParent_Done,
     /* 1335235 */   // Label 18969: @1335235
     /* 1335235 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1335332), // Rule ID 5873 //
     /* 1335240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1335243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1335251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1335254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1335270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335290 */     // MIs[1] Operand 1
     /* 1335290 */     // No operand predicates
     /* 1335290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335294 */     // MIs[0] policy
     /* 1335294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335306 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1335306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1335309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335331 */     // GIR_Coverage, 5873,
     /* 1335331 */     GIR_EraseRootFromParent_Done,
     /* 1335332 */   // Label 18970: @1335332
     /* 1335332 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1335429), // Rule ID 5876 //
     /* 1335337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1335340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1335348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1335351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1335367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335387 */     // MIs[1] Operand 1
     /* 1335387 */     // No operand predicates
     /* 1335387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335391 */     // MIs[0] policy
     /* 1335391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1335406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335428 */     // GIR_Coverage, 5876,
     /* 1335428 */     GIR_EraseRootFromParent_Done,
     /* 1335429 */   // Label 18971: @1335429
     /* 1335429 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1335526), // Rule ID 5877 //
     /* 1335434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1335437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1335445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1335448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1335464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335484 */     // MIs[1] Operand 1
     /* 1335484 */     // No operand predicates
     /* 1335484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335488 */     // MIs[0] policy
     /* 1335488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1335500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1335503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335525 */     // GIR_Coverage, 5877,
     /* 1335525 */     GIR_EraseRootFromParent_Done,
     /* 1335526 */   // Label 18972: @1335526
     /* 1335526 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1335623), // Rule ID 5880 //
     /* 1335531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1335534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1335542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1335545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1335561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335581 */     // MIs[1] Operand 1
     /* 1335581 */     // No operand predicates
     /* 1335581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335585 */     // MIs[0] policy
     /* 1335585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335597 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1335600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335622 */     // GIR_Coverage, 5880,
     /* 1335622 */     GIR_EraseRootFromParent_Done,
     /* 1335623 */   // Label 18973: @1335623
     /* 1335623 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1335720), // Rule ID 5881 //
     /* 1335628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1335631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1335639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1335642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1335658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335678 */     // MIs[1] Operand 1
     /* 1335678 */     // No operand predicates
     /* 1335678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335682 */     // MIs[0] policy
     /* 1335682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1335694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1335697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335719 */     // GIR_Coverage, 5881,
     /* 1335719 */     GIR_EraseRootFromParent_Done,
     /* 1335720 */   // Label 18974: @1335720
     /* 1335720 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1335817), // Rule ID 5884 //
     /* 1335725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1335728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1335736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1335739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1335742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1335755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335775 */     // MIs[1] Operand 1
     /* 1335775 */     // No operand predicates
     /* 1335775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335779 */     // MIs[0] policy
     /* 1335779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335791 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1335794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335816 */     // GIR_Coverage, 5884,
     /* 1335816 */     GIR_EraseRootFromParent_Done,
     /* 1335817 */   // Label 18975: @1335817
     /* 1335817 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1335914), // Rule ID 5885 //
     /* 1335822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1335825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1335830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1335833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1335836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1335839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1335852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335872 */     // MIs[1] Operand 1
     /* 1335872 */     // No operand predicates
     /* 1335872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335876 */     // MIs[0] policy
     /* 1335876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1335888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1335891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1335912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335913 */     // GIR_Coverage, 5885,
     /* 1335913 */     GIR_EraseRootFromParent_Done,
     /* 1335914 */   // Label 18976: @1335914
     /* 1335914 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1336011), // Rule ID 6064 //
     /* 1335919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1335922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1335927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1335930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1335933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1335936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1335949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1335961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1335965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1335969 */     // MIs[1] Operand 1
     /* 1335969 */     // No operand predicates
     /* 1335969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335973 */     // MIs[0] policy
     /* 1335973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1335976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1335978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335985 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1335985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1335988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1335997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336010 */     // GIR_Coverage, 6064,
     /* 1336010 */     GIR_EraseRootFromParent_Done,
     /* 1336011 */   // Label 18977: @1336011
     /* 1336011 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1336108), // Rule ID 6065 //
     /* 1336016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1336027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1336030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1336033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336066 */     // MIs[1] Operand 1
     /* 1336066 */     // No operand predicates
     /* 1336066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336070 */     // MIs[0] policy
     /* 1336070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1336082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1336085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336107 */     // GIR_Coverage, 6065,
     /* 1336107 */     GIR_EraseRootFromParent_Done,
     /* 1336108 */   // Label 18978: @1336108
     /* 1336108 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1336205), // Rule ID 6068 //
     /* 1336113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1336116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1336124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1336127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1336130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336163 */     // MIs[1] Operand 1
     /* 1336163 */     // No operand predicates
     /* 1336163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336167 */     // MIs[0] policy
     /* 1336167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336179 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1336179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1336182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336204 */     // GIR_Coverage, 6068,
     /* 1336204 */     GIR_EraseRootFromParent_Done,
     /* 1336205 */   // Label 18979: @1336205
     /* 1336205 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1336302), // Rule ID 6069 //
     /* 1336210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1336221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1336224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1336227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336260 */     // MIs[1] Operand 1
     /* 1336260 */     // No operand predicates
     /* 1336260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336264 */     // MIs[0] policy
     /* 1336264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1336276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1336279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336301 */     // GIR_Coverage, 6069,
     /* 1336301 */     GIR_EraseRootFromParent_Done,
     /* 1336302 */   // Label 18980: @1336302
     /* 1336302 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1336399), // Rule ID 6072 //
     /* 1336307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1336310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1336318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1336321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1336324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336357 */     // MIs[1] Operand 1
     /* 1336357 */     // No operand predicates
     /* 1336357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336361 */     // MIs[0] policy
     /* 1336361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336373 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1336373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1336376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336398 */     // GIR_Coverage, 6072,
     /* 1336398 */     GIR_EraseRootFromParent_Done,
     /* 1336399 */   // Label 18981: @1336399
     /* 1336399 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1336496), // Rule ID 6073 //
     /* 1336404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1336415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1336418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1336421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336454 */     // MIs[1] Operand 1
     /* 1336454 */     // No operand predicates
     /* 1336454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336458 */     // MIs[0] policy
     /* 1336458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1336470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1336473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1336492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336495 */     // GIR_Coverage, 6073,
     /* 1336495 */     GIR_EraseRootFromParent_Done,
     /* 1336496 */   // Label 18982: @1336496
     /* 1336496 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1336593), // Rule ID 6076 //
     /* 1336501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1336504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1336512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1336515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336551 */     // MIs[1] Operand 1
     /* 1336551 */     // No operand predicates
     /* 1336551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336555 */     // MIs[0] policy
     /* 1336555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336567 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1336567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1336570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336592 */     // GIR_Coverage, 6076,
     /* 1336592 */     GIR_EraseRootFromParent_Done,
     /* 1336593 */   // Label 18983: @1336593
     /* 1336593 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1336690), // Rule ID 6077 //
     /* 1336598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1336609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1336612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336648 */     // MIs[1] Operand 1
     /* 1336648 */     // No operand predicates
     /* 1336648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336652 */     // MIs[0] policy
     /* 1336652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1336664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1336667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336689 */     // GIR_Coverage, 6077,
     /* 1336689 */     GIR_EraseRootFromParent_Done,
     /* 1336690 */   // Label 18984: @1336690
     /* 1336690 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1336787), // Rule ID 6080 //
     /* 1336695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1336698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1336706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1336709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336745 */     // MIs[1] Operand 1
     /* 1336745 */     // No operand predicates
     /* 1336745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336749 */     // MIs[0] policy
     /* 1336749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336761 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1336761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1336764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336786 */     // GIR_Coverage, 6080,
     /* 1336786 */     GIR_EraseRootFromParent_Done,
     /* 1336787 */   // Label 18985: @1336787
     /* 1336787 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1336884), // Rule ID 6081 //
     /* 1336792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1336803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1336806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336842 */     // MIs[1] Operand 1
     /* 1336842 */     // No operand predicates
     /* 1336842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336846 */     // MIs[0] policy
     /* 1336846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1336858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1336861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336883 */     // GIR_Coverage, 6081,
     /* 1336883 */     GIR_EraseRootFromParent_Done,
     /* 1336884 */   // Label 18986: @1336884
     /* 1336884 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1336981), // Rule ID 6084 //
     /* 1336889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1336892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1336900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1336903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1336919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1336931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1336935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1336939 */     // MIs[1] Operand 1
     /* 1336939 */     // No operand predicates
     /* 1336939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336943 */     // MIs[0] policy
     /* 1336943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1336946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1336948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1336955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1336958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1336967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1336979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336980 */     // GIR_Coverage, 6084,
     /* 1336980 */     GIR_EraseRootFromParent_Done,
     /* 1336981 */   // Label 18987: @1336981
     /* 1336981 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1337078), // Rule ID 6085 //
     /* 1336986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1336989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1336994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1336997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1337000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337036 */     // MIs[1] Operand 1
     /* 1337036 */     // No operand predicates
     /* 1337036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337040 */     // MIs[0] policy
     /* 1337040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1337052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1337055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337077 */     // GIR_Coverage, 6085,
     /* 1337077 */     GIR_EraseRootFromParent_Done,
     /* 1337078 */   // Label 18988: @1337078
     /* 1337078 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1337175), // Rule ID 6088 //
     /* 1337083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1337086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1337094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1337097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1337100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337133 */     // MIs[1] Operand 1
     /* 1337133 */     // No operand predicates
     /* 1337133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337137 */     // MIs[0] policy
     /* 1337137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337149 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1337149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1337171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337174 */     // GIR_Coverage, 6088,
     /* 1337174 */     GIR_EraseRootFromParent_Done,
     /* 1337175 */   // Label 18989: @1337175
     /* 1337175 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1337272), // Rule ID 6089 //
     /* 1337180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1337183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1337191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1337194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1337197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337230 */     // MIs[1] Operand 1
     /* 1337230 */     // No operand predicates
     /* 1337230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337234 */     // MIs[0] policy
     /* 1337234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337246 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1337246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1337268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337271 */     // GIR_Coverage, 6089,
     /* 1337271 */     GIR_EraseRootFromParent_Done,
     /* 1337272 */   // Label 18990: @1337272
     /* 1337272 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1337369), // Rule ID 6092 //
     /* 1337277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1337280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1337288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1337291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337327 */     // MIs[1] Operand 1
     /* 1337327 */     // No operand predicates
     /* 1337327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337331 */     // MIs[0] policy
     /* 1337331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1337343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337368 */     // GIR_Coverage, 6092,
     /* 1337368 */     GIR_EraseRootFromParent_Done,
     /* 1337369 */   // Label 18991: @1337369
     /* 1337369 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1337466), // Rule ID 6093 //
     /* 1337374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1337377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1337385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1337388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337424 */     // MIs[1] Operand 1
     /* 1337424 */     // No operand predicates
     /* 1337424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337428 */     // MIs[0] policy
     /* 1337428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1337440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337465 */     // GIR_Coverage, 6093,
     /* 1337465 */     GIR_EraseRootFromParent_Done,
     /* 1337466 */   // Label 18992: @1337466
     /* 1337466 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1337563), // Rule ID 6096 //
     /* 1337471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1337474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1337482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1337485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337521 */     // MIs[1] Operand 1
     /* 1337521 */     // No operand predicates
     /* 1337521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337525 */     // MIs[0] policy
     /* 1337525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337537 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1337537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337562 */     // GIR_Coverage, 6096,
     /* 1337562 */     GIR_EraseRootFromParent_Done,
     /* 1337563 */   // Label 18993: @1337563
     /* 1337563 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1337660), // Rule ID 6097 //
     /* 1337568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1337571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1337579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1337582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337618 */     // MIs[1] Operand 1
     /* 1337618 */     // No operand predicates
     /* 1337618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337622 */     // MIs[0] policy
     /* 1337622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1337634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337659 */     // GIR_Coverage, 6097,
     /* 1337659 */     GIR_EraseRootFromParent_Done,
     /* 1337660 */   // Label 18994: @1337660
     /* 1337660 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1337757), // Rule ID 6100 //
     /* 1337665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1337668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1337676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1337679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337715 */     // MIs[1] Operand 1
     /* 1337715 */     // No operand predicates
     /* 1337715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337719 */     // MIs[0] policy
     /* 1337719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1337731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337756 */     // GIR_Coverage, 6100,
     /* 1337756 */     GIR_EraseRootFromParent_Done,
     /* 1337757 */   // Label 18995: @1337757
     /* 1337757 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1337854), // Rule ID 6101 //
     /* 1337762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1337765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1337773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1337776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1337792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337812 */     // MIs[1] Operand 1
     /* 1337812 */     // No operand predicates
     /* 1337812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337816 */     // MIs[0] policy
     /* 1337816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1337828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1337831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337853 */     // GIR_Coverage, 6101,
     /* 1337853 */     GIR_EraseRootFromParent_Done,
     /* 1337854 */   // Label 18996: @1337854
     /* 1337854 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1337951), // Rule ID 6104 //
     /* 1337859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1337862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1337870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1337873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1337876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1337889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1337905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1337909 */     // MIs[1] Operand 1
     /* 1337909 */     // No operand predicates
     /* 1337909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337913 */     // MIs[0] policy
     /* 1337913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1337916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1337918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1337925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1337928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1337937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1337947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1337949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337950 */     // GIR_Coverage, 6104,
     /* 1337950 */     GIR_EraseRootFromParent_Done,
     /* 1337951 */   // Label 18997: @1337951
     /* 1337951 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1338048), // Rule ID 6105 //
     /* 1337956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1337959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1337964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1337967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1337970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1337973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1337986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1337998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338006 */     // MIs[1] Operand 1
     /* 1338006 */     // No operand predicates
     /* 1338006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338010 */     // MIs[0] policy
     /* 1338010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1338025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1338044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338047 */     // GIR_Coverage, 6105,
     /* 1338047 */     GIR_EraseRootFromParent_Done,
     /* 1338048 */   // Label 18998: @1338048
     /* 1338048 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1338145), // Rule ID 6108 //
     /* 1338053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1338056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1338064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1338067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1338070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1338083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338103 */     // MIs[1] Operand 1
     /* 1338103 */     // No operand predicates
     /* 1338103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338107 */     // MIs[0] policy
     /* 1338107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338119 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1338119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1338122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1338141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338144 */     // GIR_Coverage, 6108,
     /* 1338144 */     GIR_EraseRootFromParent_Done,
     /* 1338145 */   // Label 18999: @1338145
     /* 1338145 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1338242), // Rule ID 6109 //
     /* 1338150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1338153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1338161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1338164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1338167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1338180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338200 */     // MIs[1] Operand 1
     /* 1338200 */     // No operand predicates
     /* 1338200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338204 */     // MIs[0] policy
     /* 1338204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1338219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1338238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338241 */     // GIR_Coverage, 6109,
     /* 1338241 */     GIR_EraseRootFromParent_Done,
     /* 1338242 */   // Label 19000: @1338242
     /* 1338242 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1338339), // Rule ID 6112 //
     /* 1338247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1338250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1338258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1338261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1338264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1338270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1338277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338297 */     // MIs[1] Operand 1
     /* 1338297 */     // No operand predicates
     /* 1338297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338301 */     // MIs[0] policy
     /* 1338301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338313 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1338313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1338316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1338335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338338 */     // GIR_Coverage, 6112,
     /* 1338338 */     GIR_EraseRootFromParent_Done,
     /* 1338339 */   // Label 19001: @1338339
     /* 1338339 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1338436), // Rule ID 6113 //
     /* 1338344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1338347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1338355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1338358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1338361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1338367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1338374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338394 */     // MIs[1] Operand 1
     /* 1338394 */     // No operand predicates
     /* 1338394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338398 */     // MIs[0] policy
     /* 1338398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338410 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1338413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1338432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338435 */     // GIR_Coverage, 6113,
     /* 1338435 */     GIR_EraseRootFromParent_Done,
     /* 1338436 */   // Label 19002: @1338436
     /* 1338436 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1338533), // Rule ID 6116 //
     /* 1338441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1338444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1338452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1338455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1338471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338491 */     // MIs[1] Operand 1
     /* 1338491 */     // No operand predicates
     /* 1338491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338495 */     // MIs[0] policy
     /* 1338495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338507 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1338507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1338510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338532 */     // GIR_Coverage, 6116,
     /* 1338532 */     GIR_EraseRootFromParent_Done,
     /* 1338533 */   // Label 19003: @1338533
     /* 1338533 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1338630), // Rule ID 6117 //
     /* 1338538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1338541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1338549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1338552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1338568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338588 */     // MIs[1] Operand 1
     /* 1338588 */     // No operand predicates
     /* 1338588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338592 */     // MIs[0] policy
     /* 1338592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1338607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338629 */     // GIR_Coverage, 6117,
     /* 1338629 */     GIR_EraseRootFromParent_Done,
     /* 1338630 */   // Label 19004: @1338630
     /* 1338630 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1338727), // Rule ID 6120 //
     /* 1338635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1338638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1338646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1338649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1338665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338685 */     // MIs[1] Operand 1
     /* 1338685 */     // No operand predicates
     /* 1338685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338689 */     // MIs[0] policy
     /* 1338689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1338701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1338704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338726 */     // GIR_Coverage, 6120,
     /* 1338726 */     GIR_EraseRootFromParent_Done,
     /* 1338727 */   // Label 19005: @1338727
     /* 1338727 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1338824), // Rule ID 6121 //
     /* 1338732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1338735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1338743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1338746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1338762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338782 */     // MIs[1] Operand 1
     /* 1338782 */     // No operand predicates
     /* 1338782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338786 */     // MIs[0] policy
     /* 1338786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1338801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338823 */     // GIR_Coverage, 6121,
     /* 1338823 */     GIR_EraseRootFromParent_Done,
     /* 1338824 */   // Label 19006: @1338824
     /* 1338824 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1338921), // Rule ID 6124 //
     /* 1338829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1338832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1338840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1338843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1338859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338879 */     // MIs[1] Operand 1
     /* 1338879 */     // No operand predicates
     /* 1338879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338883 */     // MIs[0] policy
     /* 1338883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338895 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1338895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1338898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1338907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1338919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338920 */     // GIR_Coverage, 6124,
     /* 1338920 */     GIR_EraseRootFromParent_Done,
     /* 1338921 */   // Label 19007: @1338921
     /* 1338921 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1339018), // Rule ID 6125 //
     /* 1338926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1338929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1338934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1338937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1338940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1338956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1338968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1338972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1338976 */     // MIs[1] Operand 1
     /* 1338976 */     // No operand predicates
     /* 1338976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338980 */     // MIs[0] policy
     /* 1338980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1338983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1338985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338992 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1338992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1338995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339017 */     // GIR_Coverage, 6125,
     /* 1339017 */     GIR_EraseRootFromParent_Done,
     /* 1339018 */   // Label 19008: @1339018
     /* 1339018 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1339115), // Rule ID 6128 //
     /* 1339023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1339026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1339034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1339037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1339040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1339053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339073 */     // MIs[1] Operand 1
     /* 1339073 */     // No operand predicates
     /* 1339073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339077 */     // MIs[0] policy
     /* 1339077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339089 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1339089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1339092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339114 */     // GIR_Coverage, 6128,
     /* 1339114 */     GIR_EraseRootFromParent_Done,
     /* 1339115 */   // Label 19009: @1339115
     /* 1339115 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1339212), // Rule ID 6129 //
     /* 1339120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1339123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1339131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1339134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1339137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1339150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339170 */     // MIs[1] Operand 1
     /* 1339170 */     // No operand predicates
     /* 1339170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339174 */     // MIs[0] policy
     /* 1339174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1339186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1339189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339211 */     // GIR_Coverage, 6129,
     /* 1339211 */     GIR_EraseRootFromParent_Done,
     /* 1339212 */   // Label 19010: @1339212
     /* 1339212 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1339309), // Rule ID 6132 //
     /* 1339217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1339220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1339228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1339231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1339234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1339247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339267 */     // MIs[1] Operand 1
     /* 1339267 */     // No operand predicates
     /* 1339267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339271 */     // MIs[0] policy
     /* 1339271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1339283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1339286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339308 */     // GIR_Coverage, 6132,
     /* 1339308 */     GIR_EraseRootFromParent_Done,
     /* 1339309 */   // Label 19011: @1339309
     /* 1339309 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1339406), // Rule ID 6133 //
     /* 1339314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1339317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1339325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1339328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1339331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1339344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339364 */     // MIs[1] Operand 1
     /* 1339364 */     // No operand predicates
     /* 1339364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339368 */     // MIs[0] policy
     /* 1339368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1339380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1339383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339405 */     // GIR_Coverage, 6133,
     /* 1339405 */     GIR_EraseRootFromParent_Done,
     /* 1339406 */   // Label 19012: @1339406
     /* 1339406 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1339503), // Rule ID 6136 //
     /* 1339411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1339414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1339422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1339425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1339441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339461 */     // MIs[1] Operand 1
     /* 1339461 */     // No operand predicates
     /* 1339461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339465 */     // MIs[0] policy
     /* 1339465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1339477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1339480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339502 */     // GIR_Coverage, 6136,
     /* 1339502 */     GIR_EraseRootFromParent_Done,
     /* 1339503 */   // Label 19013: @1339503
     /* 1339503 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1339600), // Rule ID 6137 //
     /* 1339508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1339511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1339519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1339522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1339538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339558 */     // MIs[1] Operand 1
     /* 1339558 */     // No operand predicates
     /* 1339558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339562 */     // MIs[0] policy
     /* 1339562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1339574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1339577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339599 */     // GIR_Coverage, 6137,
     /* 1339599 */     GIR_EraseRootFromParent_Done,
     /* 1339600 */   // Label 19014: @1339600
     /* 1339600 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1339697), // Rule ID 6140 //
     /* 1339605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1339608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1339616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1339619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1339635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339655 */     // MIs[1] Operand 1
     /* 1339655 */     // No operand predicates
     /* 1339655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339659 */     // MIs[0] policy
     /* 1339659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1339671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1339674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339696 */     // GIR_Coverage, 6140,
     /* 1339696 */     GIR_EraseRootFromParent_Done,
     /* 1339697 */   // Label 19015: @1339697
     /* 1339697 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1339794), // Rule ID 6141 //
     /* 1339702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1339705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1339713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1339716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1339732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339752 */     // MIs[1] Operand 1
     /* 1339752 */     // No operand predicates
     /* 1339752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339756 */     // MIs[0] policy
     /* 1339756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1339768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1339771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339793 */     // GIR_Coverage, 6141,
     /* 1339793 */     GIR_EraseRootFromParent_Done,
     /* 1339794 */   // Label 19016: @1339794
     /* 1339794 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1339891), // Rule ID 6144 //
     /* 1339799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1339802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1339810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1339813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1339829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339849 */     // MIs[1] Operand 1
     /* 1339849 */     // No operand predicates
     /* 1339849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339853 */     // MIs[0] policy
     /* 1339853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339865 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1339865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1339868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339890 */     // GIR_Coverage, 6144,
     /* 1339890 */     GIR_EraseRootFromParent_Done,
     /* 1339891 */   // Label 19017: @1339891
     /* 1339891 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1339988), // Rule ID 6145 //
     /* 1339896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1339899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1339904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1339907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1339910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1339926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1339938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1339942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1339946 */     // MIs[1] Operand 1
     /* 1339946 */     // No operand predicates
     /* 1339946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339950 */     // MIs[0] policy
     /* 1339950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1339953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1339955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1339962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1339965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1339974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1339986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339987 */     // GIR_Coverage, 6145,
     /* 1339987 */     GIR_EraseRootFromParent_Done,
     /* 1339988 */   // Label 19018: @1339988
     /* 1339988 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1340085), // Rule ID 6148 //
     /* 1339993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1339996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1340001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1340004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1340007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1340010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1340023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340043 */     // MIs[1] Operand 1
     /* 1340043 */     // No operand predicates
     /* 1340043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340047 */     // MIs[0] policy
     /* 1340047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1340059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1340062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340084 */     // GIR_Coverage, 6148,
     /* 1340084 */     GIR_EraseRootFromParent_Done,
     /* 1340085 */   // Label 19019: @1340085
     /* 1340085 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1340182), // Rule ID 6149 //
     /* 1340090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1340093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1340098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1340101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1340104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1340107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1340120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340140 */     // MIs[1] Operand 1
     /* 1340140 */     // No operand predicates
     /* 1340140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340144 */     // MIs[0] policy
     /* 1340144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1340156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1340159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340181 */     // GIR_Coverage, 6149,
     /* 1340181 */     GIR_EraseRootFromParent_Done,
     /* 1340182 */   // Label 19020: @1340182
     /* 1340182 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1340279), // Rule ID 6328 //
     /* 1340187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1340190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1340198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1340201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1340204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340237 */     // MIs[1] Operand 1
     /* 1340237 */     // No operand predicates
     /* 1340237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340241 */     // MIs[0] policy
     /* 1340241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340253 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1340253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1340256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340278 */     // GIR_Coverage, 6328,
     /* 1340278 */     GIR_EraseRootFromParent_Done,
     /* 1340279 */   // Label 19021: @1340279
     /* 1340279 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1340376), // Rule ID 6329 //
     /* 1340284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1340287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1340295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1340298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1340301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340334 */     // MIs[1] Operand 1
     /* 1340334 */     // No operand predicates
     /* 1340334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340338 */     // MIs[0] policy
     /* 1340338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340350 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1340350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1340353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340375 */     // GIR_Coverage, 6329,
     /* 1340375 */     GIR_EraseRootFromParent_Done,
     /* 1340376 */   // Label 19022: @1340376
     /* 1340376 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1340473), // Rule ID 6332 //
     /* 1340381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1340384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1340392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1340395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1340398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340431 */     // MIs[1] Operand 1
     /* 1340431 */     // No operand predicates
     /* 1340431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340435 */     // MIs[0] policy
     /* 1340435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340447 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1340447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1340450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340472 */     // GIR_Coverage, 6332,
     /* 1340472 */     GIR_EraseRootFromParent_Done,
     /* 1340473 */   // Label 19023: @1340473
     /* 1340473 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1340570), // Rule ID 6333 //
     /* 1340478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1340481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1340489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1340492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1340495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340528 */     // MIs[1] Operand 1
     /* 1340528 */     // No operand predicates
     /* 1340528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340532 */     // MIs[0] policy
     /* 1340532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1340544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1340547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340569 */     // GIR_Coverage, 6333,
     /* 1340569 */     GIR_EraseRootFromParent_Done,
     /* 1340570 */   // Label 19024: @1340570
     /* 1340570 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1340667), // Rule ID 6336 //
     /* 1340575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1340578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1340586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1340589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1340592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340625 */     // MIs[1] Operand 1
     /* 1340625 */     // No operand predicates
     /* 1340625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340629 */     // MIs[0] policy
     /* 1340629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340641 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1340641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1340644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340666 */     // GIR_Coverage, 6336,
     /* 1340666 */     GIR_EraseRootFromParent_Done,
     /* 1340667 */   // Label 19025: @1340667
     /* 1340667 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1340764), // Rule ID 6337 //
     /* 1340672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1340675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1340683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1340686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1340689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340722 */     // MIs[1] Operand 1
     /* 1340722 */     // No operand predicates
     /* 1340722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340726 */     // MIs[0] policy
     /* 1340726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340738 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1340738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1340741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1340760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340763 */     // GIR_Coverage, 6337,
     /* 1340763 */     GIR_EraseRootFromParent_Done,
     /* 1340764 */   // Label 19026: @1340764
     /* 1340764 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1340861), // Rule ID 6340 //
     /* 1340769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1340772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1340780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1340783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1340786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340819 */     // MIs[1] Operand 1
     /* 1340819 */     // No operand predicates
     /* 1340819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340823 */     // MIs[0] policy
     /* 1340823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340835 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1340835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1340838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340860 */     // GIR_Coverage, 6340,
     /* 1340860 */     GIR_EraseRootFromParent_Done,
     /* 1340861 */   // Label 19027: @1340861
     /* 1340861 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1340958), // Rule ID 6341 //
     /* 1340866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1340869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1340877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1340880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1340883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1340908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1340912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1340916 */     // MIs[1] Operand 1
     /* 1340916 */     // No operand predicates
     /* 1340916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340920 */     // MIs[0] policy
     /* 1340920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1340923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1340925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1340932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1340935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1340944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1340956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340957 */     // GIR_Coverage, 6341,
     /* 1340957 */     GIR_EraseRootFromParent_Done,
     /* 1340958 */   // Label 19028: @1340958
     /* 1340958 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1341055), // Rule ID 6344 //
     /* 1340963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1340966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1340971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1340974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1340977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1340980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1340993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341013 */     // MIs[1] Operand 1
     /* 1341013 */     // No operand predicates
     /* 1341013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341017 */     // MIs[0] policy
     /* 1341017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341029 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1341032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341054 */     // GIR_Coverage, 6344,
     /* 1341054 */     GIR_EraseRootFromParent_Done,
     /* 1341055 */   // Label 19029: @1341055
     /* 1341055 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1341152), // Rule ID 6345 //
     /* 1341060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1341063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1341071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1341074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341110 */     // MIs[1] Operand 1
     /* 1341110 */     // No operand predicates
     /* 1341110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341114 */     // MIs[0] policy
     /* 1341114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1341126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1341129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341151 */     // GIR_Coverage, 6345,
     /* 1341151 */     GIR_EraseRootFromParent_Done,
     /* 1341152 */   // Label 19030: @1341152
     /* 1341152 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1341249), // Rule ID 6348 //
     /* 1341157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1341160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1341168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1341171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341207 */     // MIs[1] Operand 1
     /* 1341207 */     // No operand predicates
     /* 1341207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341211 */     // MIs[0] policy
     /* 1341211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1341226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341248 */     // GIR_Coverage, 6348,
     /* 1341248 */     GIR_EraseRootFromParent_Done,
     /* 1341249 */   // Label 19031: @1341249
     /* 1341249 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1341346), // Rule ID 6349 //
     /* 1341254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1341257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1341265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1341268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341304 */     // MIs[1] Operand 1
     /* 1341304 */     // No operand predicates
     /* 1341304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341308 */     // MIs[0] policy
     /* 1341308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1341320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1341323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341345 */     // GIR_Coverage, 6349,
     /* 1341345 */     GIR_EraseRootFromParent_Done,
     /* 1341346 */   // Label 19032: @1341346
     /* 1341346 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1341443), // Rule ID 6352 //
     /* 1341351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1341354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1341362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1341365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1341368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341401 */     // MIs[1] Operand 1
     /* 1341401 */     // No operand predicates
     /* 1341401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341405 */     // MIs[0] policy
     /* 1341405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341417 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1341439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341442 */     // GIR_Coverage, 6352,
     /* 1341442 */     GIR_EraseRootFromParent_Done,
     /* 1341443 */   // Label 19033: @1341443
     /* 1341443 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1341540), // Rule ID 6353 //
     /* 1341448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1341451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1341459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1341462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1341465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341498 */     // MIs[1] Operand 1
     /* 1341498 */     // No operand predicates
     /* 1341498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341502 */     // MIs[0] policy
     /* 1341502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1341514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1341536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341539 */     // GIR_Coverage, 6353,
     /* 1341539 */     GIR_EraseRootFromParent_Done,
     /* 1341540 */   // Label 19034: @1341540
     /* 1341540 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1341637), // Rule ID 6356 //
     /* 1341545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1341548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1341556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1341559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341595 */     // MIs[1] Operand 1
     /* 1341595 */     // No operand predicates
     /* 1341595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341599 */     // MIs[0] policy
     /* 1341599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341636 */     // GIR_Coverage, 6356,
     /* 1341636 */     GIR_EraseRootFromParent_Done,
     /* 1341637 */   // Label 19035: @1341637
     /* 1341637 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1341734), // Rule ID 6357 //
     /* 1341642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1341645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1341653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1341656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341692 */     // MIs[1] Operand 1
     /* 1341692 */     // No operand predicates
     /* 1341692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341696 */     // MIs[0] policy
     /* 1341696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1341708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341733 */     // GIR_Coverage, 6357,
     /* 1341733 */     GIR_EraseRootFromParent_Done,
     /* 1341734 */   // Label 19036: @1341734
     /* 1341734 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1341831), // Rule ID 6360 //
     /* 1341739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1341742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1341750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1341753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1341756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341789 */     // MIs[1] Operand 1
     /* 1341789 */     // No operand predicates
     /* 1341789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341793 */     // MIs[0] policy
     /* 1341793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341805 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341830 */     // GIR_Coverage, 6360,
     /* 1341830 */     GIR_EraseRootFromParent_Done,
     /* 1341831 */   // Label 19037: @1341831
     /* 1341831 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1341928), // Rule ID 6361 //
     /* 1341836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1341839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1341847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1341850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1341853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341886 */     // MIs[1] Operand 1
     /* 1341886 */     // No operand predicates
     /* 1341886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341890 */     // MIs[0] policy
     /* 1341890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1341902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1341905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1341914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1341926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341927 */     // GIR_Coverage, 6361,
     /* 1341927 */     GIR_EraseRootFromParent_Done,
     /* 1341928 */   // Label 19038: @1341928
     /* 1341928 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1342025), // Rule ID 6364 //
     /* 1341933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1341936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1341941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1341944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1341947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1341950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1341963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1341975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1341979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1341983 */     // MIs[1] Operand 1
     /* 1341983 */     // No operand predicates
     /* 1341983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341987 */     // MIs[0] policy
     /* 1341987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1341990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1341992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1341999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1342002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342024 */     // GIR_Coverage, 6364,
     /* 1342024 */     GIR_EraseRootFromParent_Done,
     /* 1342025 */   // Label 19039: @1342025
     /* 1342025 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1342122), // Rule ID 6365 //
     /* 1342030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1342033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1342041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1342044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1342060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342080 */     // MIs[1] Operand 1
     /* 1342080 */     // No operand predicates
     /* 1342080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342084 */     // MIs[0] policy
     /* 1342084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1342096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1342099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342121 */     // GIR_Coverage, 6365,
     /* 1342121 */     GIR_EraseRootFromParent_Done,
     /* 1342122 */   // Label 19040: @1342122
     /* 1342122 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1342219), // Rule ID 6368 //
     /* 1342127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1342130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1342138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1342141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1342144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1342157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342177 */     // MIs[1] Operand 1
     /* 1342177 */     // No operand predicates
     /* 1342177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342181 */     // MIs[0] policy
     /* 1342181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1342193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1342196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342218 */     // GIR_Coverage, 6368,
     /* 1342218 */     GIR_EraseRootFromParent_Done,
     /* 1342219 */   // Label 19041: @1342219
     /* 1342219 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1342316), // Rule ID 6369 //
     /* 1342224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1342227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1342235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1342238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1342241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1342254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342274 */     // MIs[1] Operand 1
     /* 1342274 */     // No operand predicates
     /* 1342274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342278 */     // MIs[0] policy
     /* 1342278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1342290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1342293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342315 */     // GIR_Coverage, 6369,
     /* 1342315 */     GIR_EraseRootFromParent_Done,
     /* 1342316 */   // Label 19042: @1342316
     /* 1342316 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1342413), // Rule ID 6372 //
     /* 1342321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1342324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1342332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1342335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1342338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1342351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342371 */     // MIs[1] Operand 1
     /* 1342371 */     // No operand predicates
     /* 1342371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342375 */     // MIs[0] policy
     /* 1342375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342387 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1342387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1342390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342412 */     // GIR_Coverage, 6372,
     /* 1342412 */     GIR_EraseRootFromParent_Done,
     /* 1342413 */   // Label 19043: @1342413
     /* 1342413 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1342510), // Rule ID 6373 //
     /* 1342418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1342421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1342429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1342432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1342435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1342448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342468 */     // MIs[1] Operand 1
     /* 1342468 */     // No operand predicates
     /* 1342468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342472 */     // MIs[0] policy
     /* 1342472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1342484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1342487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342509 */     // GIR_Coverage, 6373,
     /* 1342509 */     GIR_EraseRootFromParent_Done,
     /* 1342510 */   // Label 19044: @1342510
     /* 1342510 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1342607), // Rule ID 6376 //
     /* 1342515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1342518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1342526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1342529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1342532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1342538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1342545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342565 */     // MIs[1] Operand 1
     /* 1342565 */     // No operand predicates
     /* 1342565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342569 */     // MIs[0] policy
     /* 1342569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342581 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1342581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1342584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342606 */     // GIR_Coverage, 6376,
     /* 1342606 */     GIR_EraseRootFromParent_Done,
     /* 1342607 */   // Label 19045: @1342607
     /* 1342607 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1342704), // Rule ID 6377 //
     /* 1342612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1342615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1342623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1342626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1342629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1342635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1342642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342662 */     // MIs[1] Operand 1
     /* 1342662 */     // No operand predicates
     /* 1342662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342666 */     // MIs[0] policy
     /* 1342666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1342678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1342681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1342700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342703 */     // GIR_Coverage, 6377,
     /* 1342703 */     GIR_EraseRootFromParent_Done,
     /* 1342704 */   // Label 19046: @1342704
     /* 1342704 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1342801), // Rule ID 6380 //
     /* 1342709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1342712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1342720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1342723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1342739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342759 */     // MIs[1] Operand 1
     /* 1342759 */     // No operand predicates
     /* 1342759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342763 */     // MIs[0] policy
     /* 1342763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1342775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1342778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342800 */     // GIR_Coverage, 6380,
     /* 1342800 */     GIR_EraseRootFromParent_Done,
     /* 1342801 */   // Label 19047: @1342801
     /* 1342801 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1342898), // Rule ID 6381 //
     /* 1342806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1342809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1342817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1342820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1342836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342856 */     // MIs[1] Operand 1
     /* 1342856 */     // No operand predicates
     /* 1342856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342860 */     // MIs[0] policy
     /* 1342860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1342872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1342875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342897 */     // GIR_Coverage, 6381,
     /* 1342897 */     GIR_EraseRootFromParent_Done,
     /* 1342898 */   // Label 19048: @1342898
     /* 1342898 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1342995), // Rule ID 6384 //
     /* 1342903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1342906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1342911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1342914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1342917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1342933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1342945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1342949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1342953 */     // MIs[1] Operand 1
     /* 1342953 */     // No operand predicates
     /* 1342953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342957 */     // MIs[0] policy
     /* 1342957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1342960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342969 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1342969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1342972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1342981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1342993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342994 */     // GIR_Coverage, 6384,
     /* 1342994 */     GIR_EraseRootFromParent_Done,
     /* 1342995 */   // Label 19049: @1342995
     /* 1342995 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1343092), // Rule ID 6385 //
     /* 1343000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1343003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1343011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1343014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1343017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1343030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343050 */     // MIs[1] Operand 1
     /* 1343050 */     // No operand predicates
     /* 1343050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343054 */     // MIs[0] policy
     /* 1343054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1343066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1343069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343091 */     // GIR_Coverage, 6385,
     /* 1343091 */     GIR_EraseRootFromParent_Done,
     /* 1343092 */   // Label 19050: @1343092
     /* 1343092 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1343189), // Rule ID 6388 //
     /* 1343097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1343100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1343108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1343111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1343127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343147 */     // MIs[1] Operand 1
     /* 1343147 */     // No operand predicates
     /* 1343147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343151 */     // MIs[0] policy
     /* 1343151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343163 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1343163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1343166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343188 */     // GIR_Coverage, 6388,
     /* 1343188 */     GIR_EraseRootFromParent_Done,
     /* 1343189 */   // Label 19051: @1343189
     /* 1343189 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1343286), // Rule ID 6389 //
     /* 1343194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1343197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1343205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1343208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1343224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343244 */     // MIs[1] Operand 1
     /* 1343244 */     // No operand predicates
     /* 1343244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343248 */     // MIs[0] policy
     /* 1343248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1343260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1343263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343285 */     // GIR_Coverage, 6389,
     /* 1343285 */     GIR_EraseRootFromParent_Done,
     /* 1343286 */   // Label 19052: @1343286
     /* 1343286 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1343383), // Rule ID 6392 //
     /* 1343291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1343294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1343302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1343305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1343321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343341 */     // MIs[1] Operand 1
     /* 1343341 */     // No operand predicates
     /* 1343341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343345 */     // MIs[0] policy
     /* 1343345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1343357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1343360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343382 */     // GIR_Coverage, 6392,
     /* 1343382 */     GIR_EraseRootFromParent_Done,
     /* 1343383 */   // Label 19053: @1343383
     /* 1343383 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1343480), // Rule ID 6393 //
     /* 1343388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1343391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1343399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1343402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1343418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343438 */     // MIs[1] Operand 1
     /* 1343438 */     // No operand predicates
     /* 1343438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343442 */     // MIs[0] policy
     /* 1343442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1343454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1343457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343479 */     // GIR_Coverage, 6393,
     /* 1343479 */     GIR_EraseRootFromParent_Done,
     /* 1343480 */   // Label 19054: @1343480
     /* 1343480 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1343577), // Rule ID 6396 //
     /* 1343485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1343488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1343496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1343499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1343515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343535 */     // MIs[1] Operand 1
     /* 1343535 */     // No operand predicates
     /* 1343535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343539 */     // MIs[0] policy
     /* 1343539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1343551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1343554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343576 */     // GIR_Coverage, 6396,
     /* 1343576 */     GIR_EraseRootFromParent_Done,
     /* 1343577 */   // Label 19055: @1343577
     /* 1343577 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1343674), // Rule ID 6397 //
     /* 1343582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1343585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1343593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1343596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1343612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343632 */     // MIs[1] Operand 1
     /* 1343632 */     // No operand predicates
     /* 1343632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343636 */     // MIs[0] policy
     /* 1343636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1343648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1343651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343673 */     // GIR_Coverage, 6397,
     /* 1343673 */     GIR_EraseRootFromParent_Done,
     /* 1343674 */   // Label 19056: @1343674
     /* 1343674 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1343771), // Rule ID 6400 //
     /* 1343679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1343682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1343690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1343693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1343709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343729 */     // MIs[1] Operand 1
     /* 1343729 */     // No operand predicates
     /* 1343729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343733 */     // MIs[0] policy
     /* 1343733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1343745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1343748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343770 */     // GIR_Coverage, 6400,
     /* 1343770 */     GIR_EraseRootFromParent_Done,
     /* 1343771 */   // Label 19057: @1343771
     /* 1343771 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1343868), // Rule ID 6401 //
     /* 1343776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1343779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1343787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1343790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1343806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343826 */     // MIs[1] Operand 1
     /* 1343826 */     // No operand predicates
     /* 1343826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343830 */     // MIs[0] policy
     /* 1343830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1343842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1343845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343867 */     // GIR_Coverage, 6401,
     /* 1343867 */     GIR_EraseRootFromParent_Done,
     /* 1343868 */   // Label 19058: @1343868
     /* 1343868 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1343965), // Rule ID 6404 //
     /* 1343873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1343876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1343884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1343887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1343903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1343915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1343919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1343923 */     // MIs[1] Operand 1
     /* 1343923 */     // No operand predicates
     /* 1343923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343927 */     // MIs[0] policy
     /* 1343927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1343930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1343932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1343939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1343942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1343951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1343963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343964 */     // GIR_Coverage, 6404,
     /* 1343964 */     GIR_EraseRootFromParent_Done,
     /* 1343965 */   // Label 19059: @1343965
     /* 1343965 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1344062), // Rule ID 6405 //
     /* 1343970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1343973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1343978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1343981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1343984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1344000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1344020 */     // MIs[1] Operand 1
     /* 1344020 */     // No operand predicates
     /* 1344020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344024 */     // MIs[0] policy
     /* 1344024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1344036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1344039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344061 */     // GIR_Coverage, 6405,
     /* 1344061 */     GIR_EraseRootFromParent_Done,
     /* 1344062 */   // Label 19060: @1344062
     /* 1344062 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1344159), // Rule ID 6408 //
     /* 1344067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1344070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1344075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1344078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1344081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1344097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1344117 */     // MIs[1] Operand 1
     /* 1344117 */     // No operand predicates
     /* 1344117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344121 */     // MIs[0] policy
     /* 1344121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1344133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1344136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344158 */     // GIR_Coverage, 6408,
     /* 1344158 */     GIR_EraseRootFromParent_Done,
     /* 1344159 */   // Label 19061: @1344159
     /* 1344159 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1344256), // Rule ID 6409 //
     /* 1344164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1344167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1344172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1344175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1344178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1344194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1344214 */     // MIs[1] Operand 1
     /* 1344214 */     // No operand predicates
     /* 1344214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344218 */     // MIs[0] policy
     /* 1344218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344230 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1344230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1344233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344255 */     // GIR_Coverage, 6409,
     /* 1344255 */     GIR_EraseRootFromParent_Done,
     /* 1344256 */   // Label 19062: @1344256
     /* 1344256 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1344353), // Rule ID 6412 //
     /* 1344261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1344264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1344269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1344272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1344275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1344291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1344311 */     // MIs[1] Operand 1
     /* 1344311 */     // No operand predicates
     /* 1344311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344315 */     // MIs[0] policy
     /* 1344315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344327 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1344327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1344330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344352 */     // GIR_Coverage, 6412,
     /* 1344352 */     GIR_EraseRootFromParent_Done,
     /* 1344353 */   // Label 19063: @1344353
     /* 1344353 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1344450), // Rule ID 6413 //
     /* 1344358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1344361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1344366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1344369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1344372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1344388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1344408 */     // MIs[1] Operand 1
     /* 1344408 */     // No operand predicates
     /* 1344408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344412 */     // MIs[0] policy
     /* 1344412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1344424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1344427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344449 */     // GIR_Coverage, 6413,
     /* 1344449 */     GIR_EraseRootFromParent_Done,
     /* 1344450 */   // Label 19064: @1344450
     /* 1344450 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1344547), // Rule ID 6592 //
     /* 1344455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1344458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1344466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1344469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1344472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344505 */     // MIs[1] Operand 1
     /* 1344505 */     // No operand predicates
     /* 1344505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344509 */     // MIs[0] policy
     /* 1344509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344521 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1344521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1344524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1344543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344546 */     // GIR_Coverage, 6592,
     /* 1344546 */     GIR_EraseRootFromParent_Done,
     /* 1344547 */   // Label 19065: @1344547
     /* 1344547 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1344644), // Rule ID 6593 //
     /* 1344552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1344555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1344563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1344566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1344569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344602 */     // MIs[1] Operand 1
     /* 1344602 */     // No operand predicates
     /* 1344602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344606 */     // MIs[0] policy
     /* 1344606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1344618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1344621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1344640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344643 */     // GIR_Coverage, 6593,
     /* 1344643 */     GIR_EraseRootFromParent_Done,
     /* 1344644 */   // Label 19066: @1344644
     /* 1344644 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1344741), // Rule ID 6596 //
     /* 1344649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1344652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1344660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1344663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1344666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344699 */     // MIs[1] Operand 1
     /* 1344699 */     // No operand predicates
     /* 1344699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344703 */     // MIs[0] policy
     /* 1344703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344715 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1344715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1344718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1344737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344740 */     // GIR_Coverage, 6596,
     /* 1344740 */     GIR_EraseRootFromParent_Done,
     /* 1344741 */   // Label 19067: @1344741
     /* 1344741 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1344838), // Rule ID 6597 //
     /* 1344746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1344749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1344757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1344760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1344763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344796 */     // MIs[1] Operand 1
     /* 1344796 */     // No operand predicates
     /* 1344796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344800 */     // MIs[0] policy
     /* 1344800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1344812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1344815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1344834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344837 */     // GIR_Coverage, 6597,
     /* 1344837 */     GIR_EraseRootFromParent_Done,
     /* 1344838 */   // Label 19068: @1344838
     /* 1344838 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1344935), // Rule ID 6600 //
     /* 1344843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1344846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1344854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1344857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1344860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344893 */     // MIs[1] Operand 1
     /* 1344893 */     // No operand predicates
     /* 1344893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344897 */     // MIs[0] policy
     /* 1344897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344909 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1344909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1344912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1344921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1344931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1344933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344934 */     // GIR_Coverage, 6600,
     /* 1344934 */     GIR_EraseRootFromParent_Done,
     /* 1344935 */   // Label 19069: @1344935
     /* 1344935 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1345032), // Rule ID 6601 //
     /* 1344940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1344943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1344948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1344951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1344954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1344957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1344970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1344982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1344986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1344990 */     // MIs[1] Operand 1
     /* 1344990 */     // No operand predicates
     /* 1344990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344994 */     // MIs[0] policy
     /* 1344994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1344997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1344999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1345009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1345028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345031 */     // GIR_Coverage, 6601,
     /* 1345031 */     GIR_EraseRootFromParent_Done,
     /* 1345032 */   // Label 19070: @1345032
     /* 1345032 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1345129), // Rule ID 6604 //
     /* 1345037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1345040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1345048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1345051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1345054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345087 */     // MIs[1] Operand 1
     /* 1345087 */     // No operand predicates
     /* 1345087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345091 */     // MIs[0] policy
     /* 1345091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345103 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1345103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1345106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345128 */     // GIR_Coverage, 6604,
     /* 1345128 */     GIR_EraseRootFromParent_Done,
     /* 1345129 */   // Label 19071: @1345129
     /* 1345129 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1345226), // Rule ID 6605 //
     /* 1345134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1345137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1345145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1345148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1345151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345184 */     // MIs[1] Operand 1
     /* 1345184 */     // No operand predicates
     /* 1345184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345188 */     // MIs[0] policy
     /* 1345188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1345203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345225 */     // GIR_Coverage, 6605,
     /* 1345225 */     GIR_EraseRootFromParent_Done,
     /* 1345226 */   // Label 19072: @1345226
     /* 1345226 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1345323), // Rule ID 6608 //
     /* 1345231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1345234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1345242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1345245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1345248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345281 */     // MIs[1] Operand 1
     /* 1345281 */     // No operand predicates
     /* 1345281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345285 */     // MIs[0] policy
     /* 1345285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1345297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1345300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345322 */     // GIR_Coverage, 6608,
     /* 1345322 */     GIR_EraseRootFromParent_Done,
     /* 1345323 */   // Label 19073: @1345323
     /* 1345323 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1345420), // Rule ID 6609 //
     /* 1345328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1345331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1345339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1345342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1345345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345378 */     // MIs[1] Operand 1
     /* 1345378 */     // No operand predicates
     /* 1345378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345382 */     // MIs[0] policy
     /* 1345382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1345397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345419 */     // GIR_Coverage, 6609,
     /* 1345419 */     GIR_EraseRootFromParent_Done,
     /* 1345420 */   // Label 19074: @1345420
     /* 1345420 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1345517), // Rule ID 6612 //
     /* 1345425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1345428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1345436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1345439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345475 */     // MIs[1] Operand 1
     /* 1345475 */     // No operand predicates
     /* 1345475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345479 */     // MIs[0] policy
     /* 1345479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1345491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1345494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345516 */     // GIR_Coverage, 6612,
     /* 1345516 */     GIR_EraseRootFromParent_Done,
     /* 1345517 */   // Label 19075: @1345517
     /* 1345517 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1345614), // Rule ID 6613 //
     /* 1345522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1345525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1345533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1345536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345572 */     // MIs[1] Operand 1
     /* 1345572 */     // No operand predicates
     /* 1345572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345576 */     // MIs[0] policy
     /* 1345576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1345591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345613 */     // GIR_Coverage, 6613,
     /* 1345613 */     GIR_EraseRootFromParent_Done,
     /* 1345614 */   // Label 19076: @1345614
     /* 1345614 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1345711), // Rule ID 6616 //
     /* 1345619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1345622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1345630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1345633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1345636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345669 */     // MIs[1] Operand 1
     /* 1345669 */     // No operand predicates
     /* 1345669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345673 */     // MIs[0] policy
     /* 1345673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345685 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1345685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1345688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1345707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345710 */     // GIR_Coverage, 6616,
     /* 1345710 */     GIR_EraseRootFromParent_Done,
     /* 1345711 */   // Label 19077: @1345711
     /* 1345711 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1345808), // Rule ID 6617 //
     /* 1345716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1345719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1345727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1345730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1345733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345766 */     // MIs[1] Operand 1
     /* 1345766 */     // No operand predicates
     /* 1345766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345770 */     // MIs[0] policy
     /* 1345770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1345785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1345804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345807 */     // GIR_Coverage, 6617,
     /* 1345807 */     GIR_EraseRootFromParent_Done,
     /* 1345808 */   // Label 19078: @1345808
     /* 1345808 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1345905), // Rule ID 6620 //
     /* 1345813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1345816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1345824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1345827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345863 */     // MIs[1] Operand 1
     /* 1345863 */     // No operand predicates
     /* 1345863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345867 */     // MIs[0] policy
     /* 1345867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345879 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1345879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1345882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1345903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345904 */     // GIR_Coverage, 6620,
     /* 1345904 */     GIR_EraseRootFromParent_Done,
     /* 1345905 */   // Label 19079: @1345905
     /* 1345905 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1346002), // Rule ID 6621 //
     /* 1345910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1345913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1345918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1345921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1345924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1345940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1345952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1345956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1345960 */     // MIs[1] Operand 1
     /* 1345960 */     // No operand predicates
     /* 1345960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345964 */     // MIs[0] policy
     /* 1345964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1345967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1345969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1345976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1345979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1345988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346001 */     // GIR_Coverage, 6621,
     /* 1346001 */     GIR_EraseRootFromParent_Done,
     /* 1346002 */   // Label 19080: @1346002
     /* 1346002 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1346099), // Rule ID 6624 //
     /* 1346007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1346010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1346018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1346021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1346024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1346037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346057 */     // MIs[1] Operand 1
     /* 1346057 */     // No operand predicates
     /* 1346057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346061 */     // MIs[0] policy
     /* 1346061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346073 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1346073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1346076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346098 */     // GIR_Coverage, 6624,
     /* 1346098 */     GIR_EraseRootFromParent_Done,
     /* 1346099 */   // Label 19081: @1346099
     /* 1346099 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1346196), // Rule ID 6625 //
     /* 1346104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1346107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1346115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1346118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1346121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1346134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346154 */     // MIs[1] Operand 1
     /* 1346154 */     // No operand predicates
     /* 1346154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346158 */     // MIs[0] policy
     /* 1346158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1346170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1346173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346195 */     // GIR_Coverage, 6625,
     /* 1346195 */     GIR_EraseRootFromParent_Done,
     /* 1346196 */   // Label 19082: @1346196
     /* 1346196 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1346293), // Rule ID 6628 //
     /* 1346201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1346204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1346212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1346215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1346218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1346231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346251 */     // MIs[1] Operand 1
     /* 1346251 */     // No operand predicates
     /* 1346251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346255 */     // MIs[0] policy
     /* 1346255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346267 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1346267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1346270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346292 */     // GIR_Coverage, 6628,
     /* 1346292 */     GIR_EraseRootFromParent_Done,
     /* 1346293 */   // Label 19083: @1346293
     /* 1346293 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1346390), // Rule ID 6629 //
     /* 1346298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1346301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1346309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1346312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1346315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1346328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346348 */     // MIs[1] Operand 1
     /* 1346348 */     // No operand predicates
     /* 1346348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346352 */     // MIs[0] policy
     /* 1346352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346364 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1346364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1346367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346389 */     // GIR_Coverage, 6629,
     /* 1346389 */     GIR_EraseRootFromParent_Done,
     /* 1346390 */   // Label 19084: @1346390
     /* 1346390 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1346487), // Rule ID 6632 //
     /* 1346395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1346398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1346406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1346409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1346412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1346425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346445 */     // MIs[1] Operand 1
     /* 1346445 */     // No operand predicates
     /* 1346445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346449 */     // MIs[0] policy
     /* 1346449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1346461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1346464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346486 */     // GIR_Coverage, 6632,
     /* 1346486 */     GIR_EraseRootFromParent_Done,
     /* 1346487 */   // Label 19085: @1346487
     /* 1346487 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1346584), // Rule ID 6633 //
     /* 1346492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1346495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1346503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1346506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1346509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1346522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346542 */     // MIs[1] Operand 1
     /* 1346542 */     // No operand predicates
     /* 1346542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346546 */     // MIs[0] policy
     /* 1346546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1346558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1346561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346583 */     // GIR_Coverage, 6633,
     /* 1346583 */     GIR_EraseRootFromParent_Done,
     /* 1346584 */   // Label 19086: @1346584
     /* 1346584 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1346681), // Rule ID 6636 //
     /* 1346589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1346592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1346600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1346603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1346606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1346619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346639 */     // MIs[1] Operand 1
     /* 1346639 */     // No operand predicates
     /* 1346639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346643 */     // MIs[0] policy
     /* 1346643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346655 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1346655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1346658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346680 */     // GIR_Coverage, 6636,
     /* 1346680 */     GIR_EraseRootFromParent_Done,
     /* 1346681 */   // Label 19087: @1346681
     /* 1346681 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1346778), // Rule ID 6637 //
     /* 1346686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1346689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1346697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1346700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1346703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1346716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346736 */     // MIs[1] Operand 1
     /* 1346736 */     // No operand predicates
     /* 1346736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346740 */     // MIs[0] policy
     /* 1346740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1346752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1346755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346777 */     // GIR_Coverage, 6637,
     /* 1346777 */     GIR_EraseRootFromParent_Done,
     /* 1346778 */   // Label 19088: @1346778
     /* 1346778 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1346875), // Rule ID 6640 //
     /* 1346783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1346786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1346794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1346797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1346800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1346806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1346813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346833 */     // MIs[1] Operand 1
     /* 1346833 */     // No operand predicates
     /* 1346833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346837 */     // MIs[0] policy
     /* 1346837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346849 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1346849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1346852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346874 */     // GIR_Coverage, 6640,
     /* 1346874 */     GIR_EraseRootFromParent_Done,
     /* 1346875 */   // Label 19089: @1346875
     /* 1346875 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1346972), // Rule ID 6641 //
     /* 1346880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1346883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1346891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1346894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1346897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1346903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1346910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1346922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1346926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1346930 */     // MIs[1] Operand 1
     /* 1346930 */     // No operand predicates
     /* 1346930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346934 */     // MIs[0] policy
     /* 1346934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1346937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1346939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1346946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1346949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1346958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1346968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1346970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346971 */     // GIR_Coverage, 6641,
     /* 1346971 */     GIR_EraseRootFromParent_Done,
     /* 1346972 */   // Label 19090: @1346972
     /* 1346972 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1347069), // Rule ID 6644 //
     /* 1346977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1346980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1346985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1346988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1346991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1346994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1347007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347027 */     // MIs[1] Operand 1
     /* 1347027 */     // No operand predicates
     /* 1347027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347031 */     // MIs[0] policy
     /* 1347031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1347043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1347046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347068 */     // GIR_Coverage, 6644,
     /* 1347068 */     GIR_EraseRootFromParent_Done,
     /* 1347069 */   // Label 19091: @1347069
     /* 1347069 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1347166), // Rule ID 6645 //
     /* 1347074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1347077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1347085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1347088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1347104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347124 */     // MIs[1] Operand 1
     /* 1347124 */     // No operand predicates
     /* 1347124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347128 */     // MIs[0] policy
     /* 1347128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1347140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1347143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347165 */     // GIR_Coverage, 6645,
     /* 1347165 */     GIR_EraseRootFromParent_Done,
     /* 1347166 */   // Label 19092: @1347166
     /* 1347166 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1347263), // Rule ID 6648 //
     /* 1347171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1347174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1347182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1347185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1347201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347221 */     // MIs[1] Operand 1
     /* 1347221 */     // No operand predicates
     /* 1347221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347225 */     // MIs[0] policy
     /* 1347225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1347237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1347240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347262 */     // GIR_Coverage, 6648,
     /* 1347262 */     GIR_EraseRootFromParent_Done,
     /* 1347263 */   // Label 19093: @1347263
     /* 1347263 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1347360), // Rule ID 6649 //
     /* 1347268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1347271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1347279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1347282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1347298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347318 */     // MIs[1] Operand 1
     /* 1347318 */     // No operand predicates
     /* 1347318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347322 */     // MIs[0] policy
     /* 1347322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1347334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1347337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347359 */     // GIR_Coverage, 6649,
     /* 1347359 */     GIR_EraseRootFromParent_Done,
     /* 1347360 */   // Label 19094: @1347360
     /* 1347360 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1347457), // Rule ID 6652 //
     /* 1347365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1347368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1347376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1347379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1347395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347415 */     // MIs[1] Operand 1
     /* 1347415 */     // No operand predicates
     /* 1347415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347419 */     // MIs[0] policy
     /* 1347419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347431 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1347431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1347434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347456 */     // GIR_Coverage, 6652,
     /* 1347456 */     GIR_EraseRootFromParent_Done,
     /* 1347457 */   // Label 19095: @1347457
     /* 1347457 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1347554), // Rule ID 6653 //
     /* 1347462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1347465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1347473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1347476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1347492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347512 */     // MIs[1] Operand 1
     /* 1347512 */     // No operand predicates
     /* 1347512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347516 */     // MIs[0] policy
     /* 1347516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1347528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1347531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347553 */     // GIR_Coverage, 6653,
     /* 1347553 */     GIR_EraseRootFromParent_Done,
     /* 1347554 */   // Label 19096: @1347554
     /* 1347554 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1347651), // Rule ID 6656 //
     /* 1347559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1347562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1347570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1347573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1347589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347609 */     // MIs[1] Operand 1
     /* 1347609 */     // No operand predicates
     /* 1347609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347613 */     // MIs[0] policy
     /* 1347613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1347625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1347628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347650 */     // GIR_Coverage, 6656,
     /* 1347650 */     GIR_EraseRootFromParent_Done,
     /* 1347651 */   // Label 19097: @1347651
     /* 1347651 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1347748), // Rule ID 6657 //
     /* 1347656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1347659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1347667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1347670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1347686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347706 */     // MIs[1] Operand 1
     /* 1347706 */     // No operand predicates
     /* 1347706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347710 */     // MIs[0] policy
     /* 1347710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1347722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1347725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347747 */     // GIR_Coverage, 6657,
     /* 1347747 */     GIR_EraseRootFromParent_Done,
     /* 1347748 */   // Label 19098: @1347748
     /* 1347748 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1347845), // Rule ID 6660 //
     /* 1347753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1347756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1347764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1347767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1347770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1347783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347803 */     // MIs[1] Operand 1
     /* 1347803 */     // No operand predicates
     /* 1347803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347807 */     // MIs[0] policy
     /* 1347807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1347819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1347822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347844 */     // GIR_Coverage, 6660,
     /* 1347844 */     GIR_EraseRootFromParent_Done,
     /* 1347845 */   // Label 19099: @1347845
     /* 1347845 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1347942), // Rule ID 6661 //
     /* 1347850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1347853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1347861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1347864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1347867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1347880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347900 */     // MIs[1] Operand 1
     /* 1347900 */     // No operand predicates
     /* 1347900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347904 */     // MIs[0] policy
     /* 1347904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1347907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1347909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1347916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1347919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1347928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1347940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347941 */     // GIR_Coverage, 6661,
     /* 1347941 */     GIR_EraseRootFromParent_Done,
     /* 1347942 */   // Label 19100: @1347942
     /* 1347942 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1348039), // Rule ID 6664 //
     /* 1347947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1347950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1347955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1347958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1347961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1347964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1347977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1347989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1347993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1347997 */     // MIs[1] Operand 1
     /* 1347997 */     // No operand predicates
     /* 1347997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348001 */     // MIs[0] policy
     /* 1348001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348013 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1348016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348038 */     // GIR_Coverage, 6664,
     /* 1348038 */     GIR_EraseRootFromParent_Done,
     /* 1348039 */   // Label 19101: @1348039
     /* 1348039 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1348136), // Rule ID 6665 //
     /* 1348044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1348047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1348055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1348058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1348074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348094 */     // MIs[1] Operand 1
     /* 1348094 */     // No operand predicates
     /* 1348094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348098 */     // MIs[0] policy
     /* 1348098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348110 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1348110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1348113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348135 */     // GIR_Coverage, 6665,
     /* 1348135 */     GIR_EraseRootFromParent_Done,
     /* 1348136 */   // Label 19102: @1348136
     /* 1348136 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1348233), // Rule ID 6668 //
     /* 1348141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1348144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1348152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1348155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1348171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348191 */     // MIs[1] Operand 1
     /* 1348191 */     // No operand predicates
     /* 1348191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348195 */     // MIs[0] policy
     /* 1348195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1348210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348232 */     // GIR_Coverage, 6668,
     /* 1348232 */     GIR_EraseRootFromParent_Done,
     /* 1348233 */   // Label 19103: @1348233
     /* 1348233 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1348330), // Rule ID 6669 //
     /* 1348238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1348241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1348249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1348252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1348268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348288 */     // MIs[1] Operand 1
     /* 1348288 */     // No operand predicates
     /* 1348288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348292 */     // MIs[0] policy
     /* 1348292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1348304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1348307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348329 */     // GIR_Coverage, 6669,
     /* 1348329 */     GIR_EraseRootFromParent_Done,
     /* 1348330 */   // Label 19104: @1348330
     /* 1348330 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1348427), // Rule ID 6672 //
     /* 1348335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1348338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1348346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1348349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1348365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348385 */     // MIs[1] Operand 1
     /* 1348385 */     // No operand predicates
     /* 1348385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348389 */     // MIs[0] policy
     /* 1348389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1348404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348426 */     // GIR_Coverage, 6672,
     /* 1348426 */     GIR_EraseRootFromParent_Done,
     /* 1348427 */   // Label 19105: @1348427
     /* 1348427 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1348524), // Rule ID 6673 //
     /* 1348432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1348435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1348443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1348446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1348462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348482 */     // MIs[1] Operand 1
     /* 1348482 */     // No operand predicates
     /* 1348482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348486 */     // MIs[0] policy
     /* 1348486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1348498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1348501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348523 */     // GIR_Coverage, 6673,
     /* 1348523 */     GIR_EraseRootFromParent_Done,
     /* 1348524 */   // Label 19106: @1348524
     /* 1348524 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1348621), // Rule ID 6676 //
     /* 1348529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1348532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1348540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1348543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1348559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348579 */     // MIs[1] Operand 1
     /* 1348579 */     // No operand predicates
     /* 1348579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348583 */     // MIs[0] policy
     /* 1348583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348595 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1348598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348620 */     // GIR_Coverage, 6676,
     /* 1348620 */     GIR_EraseRootFromParent_Done,
     /* 1348621 */   // Label 19107: @1348621
     /* 1348621 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1348718), // Rule ID 6677 //
     /* 1348626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1348629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1348634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1348637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1348640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1348656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348676 */     // MIs[1] Operand 1
     /* 1348676 */     // No operand predicates
     /* 1348676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348680 */     // MIs[0] policy
     /* 1348680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1348692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1348695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348717 */     // GIR_Coverage, 6677,
     /* 1348717 */     GIR_EraseRootFromParent_Done,
     /* 1348718 */   // Label 19108: @1348718
     /* 1348718 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1348815), // Rule ID 6856 //
     /* 1348723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1348726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1348731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1348734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1348737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1348740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1348753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348773 */     // MIs[1] Operand 1
     /* 1348773 */     // No operand predicates
     /* 1348773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348777 */     // MIs[0] policy
     /* 1348777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348789 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1348792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1348811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348814 */     // GIR_Coverage, 6856,
     /* 1348814 */     GIR_EraseRootFromParent_Done,
     /* 1348815 */   // Label 19109: @1348815
     /* 1348815 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1348912), // Rule ID 6857 //
     /* 1348820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1348823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1348828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1348831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1348834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1348837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1348850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348870 */     // MIs[1] Operand 1
     /* 1348870 */     // No operand predicates
     /* 1348870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348874 */     // MIs[0] policy
     /* 1348874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348886 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1348886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1348889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1348908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1348910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348911 */     // GIR_Coverage, 6857,
     /* 1348911 */     GIR_EraseRootFromParent_Done,
     /* 1348912 */   // Label 19110: @1348912
     /* 1348912 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1349009), // Rule ID 6860 //
     /* 1348917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1348920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1348925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1348928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1348931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1348934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1348947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1348959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1348963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1348967 */     // MIs[1] Operand 1
     /* 1348967 */     // No operand predicates
     /* 1348967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348971 */     // MIs[0] policy
     /* 1348971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1348974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1348976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1348983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1348986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1348995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1349005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349008 */     // GIR_Coverage, 6860,
     /* 1349008 */     GIR_EraseRootFromParent_Done,
     /* 1349009 */   // Label 19111: @1349009
     /* 1349009 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1349106), // Rule ID 6861 //
     /* 1349014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1349025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1349028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1349031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349064 */     // MIs[1] Operand 1
     /* 1349064 */     // No operand predicates
     /* 1349064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349068 */     // MIs[0] policy
     /* 1349068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1349080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1349083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1349102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349105 */     // GIR_Coverage, 6861,
     /* 1349105 */     GIR_EraseRootFromParent_Done,
     /* 1349106 */   // Label 19112: @1349106
     /* 1349106 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1349203), // Rule ID 6864 //
     /* 1349111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1349114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1349122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1349125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1349128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349161 */     // MIs[1] Operand 1
     /* 1349161 */     // No operand predicates
     /* 1349161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349165 */     // MIs[0] policy
     /* 1349165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349177 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1349177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1349199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349202 */     // GIR_Coverage, 6864,
     /* 1349202 */     GIR_EraseRootFromParent_Done,
     /* 1349203 */   // Label 19113: @1349203
     /* 1349203 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1349300), // Rule ID 6865 //
     /* 1349208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1349219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1349222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1349225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349258 */     // MIs[1] Operand 1
     /* 1349258 */     // No operand predicates
     /* 1349258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349262 */     // MIs[0] policy
     /* 1349262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1349274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1349296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349299 */     // GIR_Coverage, 6865,
     /* 1349299 */     GIR_EraseRootFromParent_Done,
     /* 1349300 */   // Label 19114: @1349300
     /* 1349300 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1349397), // Rule ID 6868 //
     /* 1349305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1349308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1349316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1349319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349355 */     // MIs[1] Operand 1
     /* 1349355 */     // No operand predicates
     /* 1349355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349359 */     // MIs[0] policy
     /* 1349359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349371 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1349371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1349374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349396 */     // GIR_Coverage, 6868,
     /* 1349396 */     GIR_EraseRootFromParent_Done,
     /* 1349397 */   // Label 19115: @1349397
     /* 1349397 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1349494), // Rule ID 6869 //
     /* 1349402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1349413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1349416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349452 */     // MIs[1] Operand 1
     /* 1349452 */     // No operand predicates
     /* 1349452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349456 */     // MIs[0] policy
     /* 1349456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1349468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1349471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349493 */     // GIR_Coverage, 6869,
     /* 1349493 */     GIR_EraseRootFromParent_Done,
     /* 1349494 */   // Label 19116: @1349494
     /* 1349494 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1349591), // Rule ID 6872 //
     /* 1349499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1349502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1349510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1349513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349549 */     // MIs[1] Operand 1
     /* 1349549 */     // No operand predicates
     /* 1349549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349553 */     // MIs[0] policy
     /* 1349553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349565 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1349565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349590 */     // GIR_Coverage, 6872,
     /* 1349590 */     GIR_EraseRootFromParent_Done,
     /* 1349591 */   // Label 19117: @1349591
     /* 1349591 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1349688), // Rule ID 6873 //
     /* 1349596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1349607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1349610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349646 */     // MIs[1] Operand 1
     /* 1349646 */     // No operand predicates
     /* 1349646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349650 */     // MIs[0] policy
     /* 1349650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1349662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349687 */     // GIR_Coverage, 6873,
     /* 1349687 */     GIR_EraseRootFromParent_Done,
     /* 1349688 */   // Label 19118: @1349688
     /* 1349688 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1349785), // Rule ID 6876 //
     /* 1349693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1349696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1349704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1349707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349743 */     // MIs[1] Operand 1
     /* 1349743 */     // No operand predicates
     /* 1349743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349747 */     // MIs[0] policy
     /* 1349747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349759 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1349759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349784 */     // GIR_Coverage, 6876,
     /* 1349784 */     GIR_EraseRootFromParent_Done,
     /* 1349785 */   // Label 19119: @1349785
     /* 1349785 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1349882), // Rule ID 6877 //
     /* 1349790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1349801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1349804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349840 */     // MIs[1] Operand 1
     /* 1349840 */     // No operand predicates
     /* 1349840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349844 */     // MIs[0] policy
     /* 1349844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1349856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1349859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349881 */     // GIR_Coverage, 6877,
     /* 1349881 */     GIR_EraseRootFromParent_Done,
     /* 1349882 */   // Label 19120: @1349882
     /* 1349882 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1349979), // Rule ID 6880 //
     /* 1349887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1349890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1349898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1349901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1349904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1349929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1349933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1349937 */     // MIs[1] Operand 1
     /* 1349937 */     // No operand predicates
     /* 1349937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349941 */     // MIs[0] policy
     /* 1349941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1349944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1349946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349953 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1349953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1349956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1349965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1349975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1349977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349978 */     // GIR_Coverage, 6880,
     /* 1349978 */     GIR_EraseRootFromParent_Done,
     /* 1349979 */   // Label 19121: @1349979
     /* 1349979 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1350076), // Rule ID 6881 //
     /* 1349984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1349987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1349992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1349995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1349998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1350001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350034 */     // MIs[1] Operand 1
     /* 1350034 */     // No operand predicates
     /* 1350034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350038 */     // MIs[0] policy
     /* 1350038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1350050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1350072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350075 */     // GIR_Coverage, 6881,
     /* 1350075 */     GIR_EraseRootFromParent_Done,
     /* 1350076 */   // Label 19122: @1350076
     /* 1350076 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1350173), // Rule ID 6884 //
     /* 1350081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1350084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1350092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1350095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350131 */     // MIs[1] Operand 1
     /* 1350131 */     // No operand predicates
     /* 1350131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350135 */     // MIs[0] policy
     /* 1350135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350147 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1350147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350172 */     // GIR_Coverage, 6884,
     /* 1350172 */     GIR_EraseRootFromParent_Done,
     /* 1350173 */   // Label 19123: @1350173
     /* 1350173 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1350270), // Rule ID 6885 //
     /* 1350178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1350181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1350189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1350192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350228 */     // MIs[1] Operand 1
     /* 1350228 */     // No operand predicates
     /* 1350228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350232 */     // MIs[0] policy
     /* 1350232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1350244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350269 */     // GIR_Coverage, 6885,
     /* 1350269 */     GIR_EraseRootFromParent_Done,
     /* 1350270 */   // Label 19124: @1350270
     /* 1350270 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1350367), // Rule ID 6888 //
     /* 1350275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1350278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1350286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1350289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350325 */     // MIs[1] Operand 1
     /* 1350325 */     // No operand predicates
     /* 1350325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350329 */     // MIs[0] policy
     /* 1350329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350341 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1350341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350366 */     // GIR_Coverage, 6888,
     /* 1350366 */     GIR_EraseRootFromParent_Done,
     /* 1350367 */   // Label 19125: @1350367
     /* 1350367 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1350464), // Rule ID 6889 //
     /* 1350372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1350375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1350383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1350386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350422 */     // MIs[1] Operand 1
     /* 1350422 */     // No operand predicates
     /* 1350422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350426 */     // MIs[0] policy
     /* 1350426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350438 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1350438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350463 */     // GIR_Coverage, 6889,
     /* 1350463 */     GIR_EraseRootFromParent_Done,
     /* 1350464 */   // Label 19126: @1350464
     /* 1350464 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1350561), // Rule ID 6892 //
     /* 1350469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1350472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1350480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1350483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350519 */     // MIs[1] Operand 1
     /* 1350519 */     // No operand predicates
     /* 1350519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350523 */     // MIs[0] policy
     /* 1350523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350535 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1350535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350560 */     // GIR_Coverage, 6892,
     /* 1350560 */     GIR_EraseRootFromParent_Done,
     /* 1350561 */   // Label 19127: @1350561
     /* 1350561 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1350658), // Rule ID 6893 //
     /* 1350566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1350569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1350577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1350580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350616 */     // MIs[1] Operand 1
     /* 1350616 */     // No operand predicates
     /* 1350616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350620 */     // MIs[0] policy
     /* 1350620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1350632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1350635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350657 */     // GIR_Coverage, 6893,
     /* 1350657 */     GIR_EraseRootFromParent_Done,
     /* 1350658 */   // Label 19128: @1350658
     /* 1350658 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1350755), // Rule ID 6896 //
     /* 1350663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1350666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1350674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1350677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1350680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1350693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350713 */     // MIs[1] Operand 1
     /* 1350713 */     // No operand predicates
     /* 1350713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350717 */     // MIs[0] policy
     /* 1350717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350729 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1350729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1350732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1350751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350754 */     // GIR_Coverage, 6896,
     /* 1350754 */     GIR_EraseRootFromParent_Done,
     /* 1350755 */   // Label 19129: @1350755
     /* 1350755 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1350852), // Rule ID 6897 //
     /* 1350760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1350763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1350771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1350774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1350777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1350790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350810 */     // MIs[1] Operand 1
     /* 1350810 */     // No operand predicates
     /* 1350810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350814 */     // MIs[0] policy
     /* 1350814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1350826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1350829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1350848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350851 */     // GIR_Coverage, 6897,
     /* 1350851 */     GIR_EraseRootFromParent_Done,
     /* 1350852 */   // Label 19130: @1350852
     /* 1350852 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1350949), // Rule ID 6900 //
     /* 1350857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1350860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1350868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1350871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1350874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1350887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1350903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1350907 */     // MIs[1] Operand 1
     /* 1350907 */     // No operand predicates
     /* 1350907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350911 */     // MIs[0] policy
     /* 1350911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1350914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1350916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350923 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1350923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1350926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1350935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1350945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1350947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350948 */     // GIR_Coverage, 6900,
     /* 1350948 */     GIR_EraseRootFromParent_Done,
     /* 1350949 */   // Label 19131: @1350949
     /* 1350949 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1351046), // Rule ID 6901 //
     /* 1350954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1350957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1350962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1350965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1350968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1350971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1350984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1350996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351004 */     // MIs[1] Operand 1
     /* 1351004 */     // No operand predicates
     /* 1351004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351008 */     // MIs[0] policy
     /* 1351008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1351023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1351042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351045 */     // GIR_Coverage, 6901,
     /* 1351045 */     GIR_EraseRootFromParent_Done,
     /* 1351046 */   // Label 19132: @1351046
     /* 1351046 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1351143), // Rule ID 6904 //
     /* 1351051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1351054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1351062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1351065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1351068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1351074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1351081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351101 */     // MIs[1] Operand 1
     /* 1351101 */     // No operand predicates
     /* 1351101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351105 */     // MIs[0] policy
     /* 1351105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351117 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1351117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1351120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1351139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351142 */     // GIR_Coverage, 6904,
     /* 1351142 */     GIR_EraseRootFromParent_Done,
     /* 1351143 */   // Label 19133: @1351143
     /* 1351143 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1351240), // Rule ID 6905 //
     /* 1351148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1351151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1351159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1351162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1351165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1351171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1351178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351198 */     // MIs[1] Operand 1
     /* 1351198 */     // No operand predicates
     /* 1351198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351202 */     // MIs[0] policy
     /* 1351202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351214 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1351217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1351236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351239 */     // GIR_Coverage, 6905,
     /* 1351239 */     GIR_EraseRootFromParent_Done,
     /* 1351240 */   // Label 19134: @1351240
     /* 1351240 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1351337), // Rule ID 6908 //
     /* 1351245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1351248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351295 */     // MIs[1] Operand 1
     /* 1351295 */     // No operand predicates
     /* 1351295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351299 */     // MIs[0] policy
     /* 1351299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1351311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1351314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351336 */     // GIR_Coverage, 6908,
     /* 1351336 */     GIR_EraseRootFromParent_Done,
     /* 1351337 */   // Label 19135: @1351337
     /* 1351337 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1351434), // Rule ID 6909 //
     /* 1351342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1351345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351392 */     // MIs[1] Operand 1
     /* 1351392 */     // No operand predicates
     /* 1351392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351396 */     // MIs[0] policy
     /* 1351396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1351411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351433 */     // GIR_Coverage, 6909,
     /* 1351433 */     GIR_EraseRootFromParent_Done,
     /* 1351434 */   // Label 19136: @1351434
     /* 1351434 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1351531), // Rule ID 6912 //
     /* 1351439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1351442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1351450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1351453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1351456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1351469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351489 */     // MIs[1] Operand 1
     /* 1351489 */     // No operand predicates
     /* 1351489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351493 */     // MIs[0] policy
     /* 1351493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351505 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1351505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1351508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351530 */     // GIR_Coverage, 6912,
     /* 1351530 */     GIR_EraseRootFromParent_Done,
     /* 1351531 */   // Label 19137: @1351531
     /* 1351531 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1351628), // Rule ID 6913 //
     /* 1351536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1351539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1351547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1351550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1351553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1351566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351586 */     // MIs[1] Operand 1
     /* 1351586 */     // No operand predicates
     /* 1351586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351590 */     // MIs[0] policy
     /* 1351590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1351605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351627 */     // GIR_Coverage, 6913,
     /* 1351627 */     GIR_EraseRootFromParent_Done,
     /* 1351628 */   // Label 19138: @1351628
     /* 1351628 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1351725), // Rule ID 6916 //
     /* 1351633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1351636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1351644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1351647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1351650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1351656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1351663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351683 */     // MIs[1] Operand 1
     /* 1351683 */     // No operand predicates
     /* 1351683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351687 */     // MIs[0] policy
     /* 1351687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351699 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1351699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1351702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351724 */     // GIR_Coverage, 6916,
     /* 1351724 */     GIR_EraseRootFromParent_Done,
     /* 1351725 */   // Label 19139: @1351725
     /* 1351725 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1351822), // Rule ID 6917 //
     /* 1351730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1351733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1351741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1351744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1351747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1351753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1351760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351780 */     // MIs[1] Operand 1
     /* 1351780 */     // No operand predicates
     /* 1351780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351784 */     // MIs[0] policy
     /* 1351784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1351799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351821 */     // GIR_Coverage, 6917,
     /* 1351821 */     GIR_EraseRootFromParent_Done,
     /* 1351822 */   // Label 19140: @1351822
     /* 1351822 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1351919), // Rule ID 6920 //
     /* 1351827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1351830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1351838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1351841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1351844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351877 */     // MIs[1] Operand 1
     /* 1351877 */     // No operand predicates
     /* 1351877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351881 */     // MIs[0] policy
     /* 1351881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1351893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1351896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1351905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1351917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351918 */     // GIR_Coverage, 6920,
     /* 1351918 */     GIR_EraseRootFromParent_Done,
     /* 1351919 */   // Label 19141: @1351919
     /* 1351919 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1352016), // Rule ID 6921 //
     /* 1351924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1351927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1351932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1351935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1351938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1351941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1351966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1351970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1351974 */     // MIs[1] Operand 1
     /* 1351974 */     // No operand predicates
     /* 1351974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351978 */     // MIs[0] policy
     /* 1351978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1351981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1351983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1351990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1351993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352015 */     // GIR_Coverage, 6921,
     /* 1352015 */     GIR_EraseRootFromParent_Done,
     /* 1352016 */   // Label 19142: @1352016
     /* 1352016 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1352113), // Rule ID 6924 //
     /* 1352021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1352024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1352032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1352035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1352038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352071 */     // MIs[1] Operand 1
     /* 1352071 */     // No operand predicates
     /* 1352071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352075 */     // MIs[0] policy
     /* 1352075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352087 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1352087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1352090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352112 */     // GIR_Coverage, 6924,
     /* 1352112 */     GIR_EraseRootFromParent_Done,
     /* 1352113 */   // Label 19143: @1352113
     /* 1352113 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1352210), // Rule ID 6925 //
     /* 1352118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1352121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1352129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1352132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1352135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352168 */     // MIs[1] Operand 1
     /* 1352168 */     // No operand predicates
     /* 1352168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352172 */     // MIs[0] policy
     /* 1352172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1352184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1352187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352209 */     // GIR_Coverage, 6925,
     /* 1352209 */     GIR_EraseRootFromParent_Done,
     /* 1352210 */   // Label 19144: @1352210
     /* 1352210 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1352307), // Rule ID 6928 //
     /* 1352215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1352218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1352226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1352229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1352232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352265 */     // MIs[1] Operand 1
     /* 1352265 */     // No operand predicates
     /* 1352265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352269 */     // MIs[0] policy
     /* 1352269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352281 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1352281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1352284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352306 */     // GIR_Coverage, 6928,
     /* 1352306 */     GIR_EraseRootFromParent_Done,
     /* 1352307 */   // Label 19145: @1352307
     /* 1352307 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1352404), // Rule ID 6929 //
     /* 1352312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1352315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1352323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1352326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1352329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352362 */     // MIs[1] Operand 1
     /* 1352362 */     // No operand predicates
     /* 1352362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352366 */     // MIs[0] policy
     /* 1352366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1352378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1352381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352403 */     // GIR_Coverage, 6929,
     /* 1352403 */     GIR_EraseRootFromParent_Done,
     /* 1352404 */   // Label 19146: @1352404
     /* 1352404 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1352501), // Rule ID 6932 //
     /* 1352409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1352412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1352420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1352423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1352426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352459 */     // MIs[1] Operand 1
     /* 1352459 */     // No operand predicates
     /* 1352459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352463 */     // MIs[0] policy
     /* 1352463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1352475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1352478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352500 */     // GIR_Coverage, 6932,
     /* 1352500 */     GIR_EraseRootFromParent_Done,
     /* 1352501 */   // Label 19147: @1352501
     /* 1352501 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1352598), // Rule ID 6933 //
     /* 1352506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1352509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1352517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1352520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1352523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352556 */     // MIs[1] Operand 1
     /* 1352556 */     // No operand predicates
     /* 1352556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352560 */     // MIs[0] policy
     /* 1352560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1352572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1352575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352597 */     // GIR_Coverage, 6933,
     /* 1352597 */     GIR_EraseRootFromParent_Done,
     /* 1352598 */   // Label 19148: @1352598
     /* 1352598 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1352695), // Rule ID 6936 //
     /* 1352603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1352606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1352614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1352617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1352620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352653 */     // MIs[1] Operand 1
     /* 1352653 */     // No operand predicates
     /* 1352653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352657 */     // MIs[0] policy
     /* 1352657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352669 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1352669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1352672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352694 */     // GIR_Coverage, 6936,
     /* 1352694 */     GIR_EraseRootFromParent_Done,
     /* 1352695 */   // Label 19149: @1352695
     /* 1352695 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1352792), // Rule ID 6937 //
     /* 1352700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1352703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1352711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1352714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1352717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352750 */     // MIs[1] Operand 1
     /* 1352750 */     // No operand predicates
     /* 1352750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352754 */     // MIs[0] policy
     /* 1352754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1352766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1352769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352791 */     // GIR_Coverage, 6937,
     /* 1352791 */     GIR_EraseRootFromParent_Done,
     /* 1352792 */   // Label 19150: @1352792
     /* 1352792 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1352889), // Rule ID 6940 //
     /* 1352797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1352800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1352808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1352811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1352814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352847 */     // MIs[1] Operand 1
     /* 1352847 */     // No operand predicates
     /* 1352847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352851 */     // MIs[0] policy
     /* 1352851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352863 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1352863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1352866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352888 */     // GIR_Coverage, 6940,
     /* 1352888 */     GIR_EraseRootFromParent_Done,
     /* 1352889 */   // Label 19151: @1352889
     /* 1352889 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1352986), // Rule ID 6941 //
     /* 1352894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1352897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1352902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1352905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1352908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1352911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1352936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1352940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1352944 */     // MIs[1] Operand 1
     /* 1352944 */     // No operand predicates
     /* 1352944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352948 */     // MIs[0] policy
     /* 1352948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1352951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1352953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1352960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1352963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1352972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1352984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352985 */     // GIR_Coverage, 6941,
     /* 1352985 */     GIR_EraseRootFromParent_Done,
     /* 1352986 */   // Label 19152: @1352986
     /* 1352986 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1353083), // Rule ID 7120 //
     /* 1352991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1352994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1352999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1353002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1353005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1353008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353041 */     // MIs[1] Operand 1
     /* 1353041 */     // No operand predicates
     /* 1353041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353045 */     // MIs[0] policy
     /* 1353045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353057 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1353057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1353060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353082 */     // GIR_Coverage, 7120,
     /* 1353082 */     GIR_EraseRootFromParent_Done,
     /* 1353083 */   // Label 19153: @1353083
     /* 1353083 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1353180), // Rule ID 7121 //
     /* 1353088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1353091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1353099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1353102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1353105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353138 */     // MIs[1] Operand 1
     /* 1353138 */     // No operand predicates
     /* 1353138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353142 */     // MIs[0] policy
     /* 1353142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1353154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1353157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353179 */     // GIR_Coverage, 7121,
     /* 1353179 */     GIR_EraseRootFromParent_Done,
     /* 1353180 */   // Label 19154: @1353180
     /* 1353180 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1353277), // Rule ID 7124 //
     /* 1353185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1353188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1353196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1353199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1353202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353235 */     // MIs[1] Operand 1
     /* 1353235 */     // No operand predicates
     /* 1353235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353239 */     // MIs[0] policy
     /* 1353239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353251 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1353251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1353254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353276 */     // GIR_Coverage, 7124,
     /* 1353276 */     GIR_EraseRootFromParent_Done,
     /* 1353277 */   // Label 19155: @1353277
     /* 1353277 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1353374), // Rule ID 7125 //
     /* 1353282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1353285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1353293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1353296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1353299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353332 */     // MIs[1] Operand 1
     /* 1353332 */     // No operand predicates
     /* 1353332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353336 */     // MIs[0] policy
     /* 1353336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1353348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1353351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353373 */     // GIR_Coverage, 7125,
     /* 1353373 */     GIR_EraseRootFromParent_Done,
     /* 1353374 */   // Label 19156: @1353374
     /* 1353374 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1353471), // Rule ID 7128 //
     /* 1353379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1353382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1353390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1353393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1353396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353429 */     // MIs[1] Operand 1
     /* 1353429 */     // No operand predicates
     /* 1353429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353433 */     // MIs[0] policy
     /* 1353433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353445 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1353445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1353448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353470 */     // GIR_Coverage, 7128,
     /* 1353470 */     GIR_EraseRootFromParent_Done,
     /* 1353471 */   // Label 19157: @1353471
     /* 1353471 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1353568), // Rule ID 7129 //
     /* 1353476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1353479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1353487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1353490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1353493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353526 */     // MIs[1] Operand 1
     /* 1353526 */     // No operand predicates
     /* 1353526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353530 */     // MIs[0] policy
     /* 1353530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1353542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1353545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1353564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353567 */     // GIR_Coverage, 7129,
     /* 1353567 */     GIR_EraseRootFromParent_Done,
     /* 1353568 */   // Label 19158: @1353568
     /* 1353568 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1353665), // Rule ID 7132 //
     /* 1353573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1353576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1353584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1353587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353623 */     // MIs[1] Operand 1
     /* 1353623 */     // No operand predicates
     /* 1353623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353627 */     // MIs[0] policy
     /* 1353627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353639 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1353639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1353642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353664 */     // GIR_Coverage, 7132,
     /* 1353664 */     GIR_EraseRootFromParent_Done,
     /* 1353665 */   // Label 19159: @1353665
     /* 1353665 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1353762), // Rule ID 7133 //
     /* 1353670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1353673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1353681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1353684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353720 */     // MIs[1] Operand 1
     /* 1353720 */     // No operand predicates
     /* 1353720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353724 */     // MIs[0] policy
     /* 1353724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1353736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1353739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353761 */     // GIR_Coverage, 7133,
     /* 1353761 */     GIR_EraseRootFromParent_Done,
     /* 1353762 */   // Label 19160: @1353762
     /* 1353762 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1353859), // Rule ID 7136 //
     /* 1353767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1353770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1353778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1353781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1353784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353817 */     // MIs[1] Operand 1
     /* 1353817 */     // No operand predicates
     /* 1353817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353821 */     // MIs[0] policy
     /* 1353821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1353833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1353836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353858 */     // GIR_Coverage, 7136,
     /* 1353858 */     GIR_EraseRootFromParent_Done,
     /* 1353859 */   // Label 19161: @1353859
     /* 1353859 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1353956), // Rule ID 7137 //
     /* 1353864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1353867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1353875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1353878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1353881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1353906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1353910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1353914 */     // MIs[1] Operand 1
     /* 1353914 */     // No operand predicates
     /* 1353914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353918 */     // MIs[0] policy
     /* 1353918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1353921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1353930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1353933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1353942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1353954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353955 */     // GIR_Coverage, 7137,
     /* 1353955 */     GIR_EraseRootFromParent_Done,
     /* 1353956 */   // Label 19162: @1353956
     /* 1353956 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1354053), // Rule ID 7140 //
     /* 1353961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1353964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1353969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1353972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1353975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1353978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1353991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354011 */     // MIs[1] Operand 1
     /* 1354011 */     // No operand predicates
     /* 1354011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354015 */     // MIs[0] policy
     /* 1354015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1354030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354052 */     // GIR_Coverage, 7140,
     /* 1354052 */     GIR_EraseRootFromParent_Done,
     /* 1354053 */   // Label 19163: @1354053
     /* 1354053 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1354150), // Rule ID 7141 //
     /* 1354058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1354069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1354072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354108 */     // MIs[1] Operand 1
     /* 1354108 */     // No operand predicates
     /* 1354108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354112 */     // MIs[0] policy
     /* 1354112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1354124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1354127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354149 */     // GIR_Coverage, 7141,
     /* 1354149 */     GIR_EraseRootFromParent_Done,
     /* 1354150 */   // Label 19164: @1354150
     /* 1354150 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1354247), // Rule ID 7144 //
     /* 1354155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1354172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354205 */     // MIs[1] Operand 1
     /* 1354205 */     // No operand predicates
     /* 1354205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354209 */     // MIs[0] policy
     /* 1354209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354221 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354246 */     // GIR_Coverage, 7144,
     /* 1354246 */     GIR_EraseRootFromParent_Done,
     /* 1354247 */   // Label 19165: @1354247
     /* 1354247 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1354344), // Rule ID 7145 //
     /* 1354252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1354269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354302 */     // MIs[1] Operand 1
     /* 1354302 */     // No operand predicates
     /* 1354302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354306 */     // MIs[0] policy
     /* 1354306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1354318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354343 */     // GIR_Coverage, 7145,
     /* 1354343 */     GIR_EraseRootFromParent_Done,
     /* 1354344 */   // Label 19166: @1354344
     /* 1354344 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1354441), // Rule ID 7148 //
     /* 1354349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1354360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1354363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354399 */     // MIs[1] Operand 1
     /* 1354399 */     // No operand predicates
     /* 1354399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354403 */     // MIs[0] policy
     /* 1354403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354440 */     // GIR_Coverage, 7148,
     /* 1354440 */     GIR_EraseRootFromParent_Done,
     /* 1354441 */   // Label 19167: @1354441
     /* 1354441 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1354538), // Rule ID 7149 //
     /* 1354446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1354457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1354460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354496 */     // MIs[1] Operand 1
     /* 1354496 */     // No operand predicates
     /* 1354496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354500 */     // MIs[0] policy
     /* 1354500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1354512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354537 */     // GIR_Coverage, 7149,
     /* 1354537 */     GIR_EraseRootFromParent_Done,
     /* 1354538 */   // Label 19168: @1354538
     /* 1354538 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1354635), // Rule ID 7152 //
     /* 1354543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1354554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1354557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354593 */     // MIs[1] Operand 1
     /* 1354593 */     // No operand predicates
     /* 1354593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354597 */     // MIs[0] policy
     /* 1354597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354609 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354634 */     // GIR_Coverage, 7152,
     /* 1354634 */     GIR_EraseRootFromParent_Done,
     /* 1354635 */   // Label 19169: @1354635
     /* 1354635 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1354732), // Rule ID 7153 //
     /* 1354640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1354651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1354654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354690 */     // MIs[1] Operand 1
     /* 1354690 */     // No operand predicates
     /* 1354690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354694 */     // MIs[0] policy
     /* 1354694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1354706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354731 */     // GIR_Coverage, 7153,
     /* 1354731 */     GIR_EraseRootFromParent_Done,
     /* 1354732 */   // Label 19170: @1354732
     /* 1354732 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1354829), // Rule ID 7156 //
     /* 1354737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1354740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1354748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1354751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354787 */     // MIs[1] Operand 1
     /* 1354787 */     // No operand predicates
     /* 1354787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354791 */     // MIs[0] policy
     /* 1354791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354803 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354828 */     // GIR_Coverage, 7156,
     /* 1354828 */     GIR_EraseRootFromParent_Done,
     /* 1354829 */   // Label 19171: @1354829
     /* 1354829 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1354926), // Rule ID 7157 //
     /* 1354834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1354837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1354845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1354848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354884 */     // MIs[1] Operand 1
     /* 1354884 */     // No operand predicates
     /* 1354884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354888 */     // MIs[0] policy
     /* 1354888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1354900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1354903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1354912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1354924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354925 */     // GIR_Coverage, 7157,
     /* 1354925 */     GIR_EraseRootFromParent_Done,
     /* 1354926 */   // Label 19172: @1354926
     /* 1354926 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1355023), // Rule ID 7160 //
     /* 1354931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1354939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1354942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1354945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1354948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1354954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1354961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1354973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1354977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1354981 */     // MIs[1] Operand 1
     /* 1354981 */     // No operand predicates
     /* 1354981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354985 */     // MIs[0] policy
     /* 1354985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1354988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1354990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1354997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1355000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355022 */     // GIR_Coverage, 7160,
     /* 1355022 */     GIR_EraseRootFromParent_Done,
     /* 1355023 */   // Label 19173: @1355023
     /* 1355023 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1355120), // Rule ID 7161 //
     /* 1355028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1355039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1355042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1355045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1355058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355078 */     // MIs[1] Operand 1
     /* 1355078 */     // No operand predicates
     /* 1355078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355082 */     // MIs[0] policy
     /* 1355082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1355094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1355097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355119 */     // GIR_Coverage, 7161,
     /* 1355119 */     GIR_EraseRootFromParent_Done,
     /* 1355120 */   // Label 19174: @1355120
     /* 1355120 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1355217), // Rule ID 7164 //
     /* 1355125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1355136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1355139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1355142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1355155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355175 */     // MIs[1] Operand 1
     /* 1355175 */     // No operand predicates
     /* 1355175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355179 */     // MIs[0] policy
     /* 1355179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355191 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1355191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1355194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355216 */     // GIR_Coverage, 7164,
     /* 1355216 */     GIR_EraseRootFromParent_Done,
     /* 1355217 */   // Label 19175: @1355217
     /* 1355217 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1355314), // Rule ID 7165 //
     /* 1355222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1355233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1355236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1355239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1355252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355272 */     // MIs[1] Operand 1
     /* 1355272 */     // No operand predicates
     /* 1355272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355276 */     // MIs[0] policy
     /* 1355276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1355288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1355291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355313 */     // GIR_Coverage, 7165,
     /* 1355313 */     GIR_EraseRootFromParent_Done,
     /* 1355314 */   // Label 19176: @1355314
     /* 1355314 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1355411), // Rule ID 7168 //
     /* 1355319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1355330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1355333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1355336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1355342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1355349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355369 */     // MIs[1] Operand 1
     /* 1355369 */     // No operand predicates
     /* 1355369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355373 */     // MIs[0] policy
     /* 1355373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355385 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1355385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1355388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355410 */     // GIR_Coverage, 7168,
     /* 1355410 */     GIR_EraseRootFromParent_Done,
     /* 1355411 */   // Label 19177: @1355411
     /* 1355411 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1355508), // Rule ID 7169 //
     /* 1355416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1355427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1355430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1355433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1355439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1355446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355466 */     // MIs[1] Operand 1
     /* 1355466 */     // No operand predicates
     /* 1355466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355470 */     // MIs[0] policy
     /* 1355470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355482 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1355482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1355485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355507 */     // GIR_Coverage, 7169,
     /* 1355507 */     GIR_EraseRootFromParent_Done,
     /* 1355508 */   // Label 19178: @1355508
     /* 1355508 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1355605), // Rule ID 7172 //
     /* 1355513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1355524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1355527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1355543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355563 */     // MIs[1] Operand 1
     /* 1355563 */     // No operand predicates
     /* 1355563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355567 */     // MIs[0] policy
     /* 1355567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1355579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1355582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355604 */     // GIR_Coverage, 7172,
     /* 1355604 */     GIR_EraseRootFromParent_Done,
     /* 1355605 */   // Label 19179: @1355605
     /* 1355605 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1355702), // Rule ID 7173 //
     /* 1355610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1355621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1355624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1355640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355660 */     // MIs[1] Operand 1
     /* 1355660 */     // No operand predicates
     /* 1355660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355664 */     // MIs[0] policy
     /* 1355664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1355676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1355679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355701 */     // GIR_Coverage, 7173,
     /* 1355701 */     GIR_EraseRootFromParent_Done,
     /* 1355702 */   // Label 19180: @1355702
     /* 1355702 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1355799), // Rule ID 7176 //
     /* 1355707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1355718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1355721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1355737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355757 */     // MIs[1] Operand 1
     /* 1355757 */     // No operand predicates
     /* 1355757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355761 */     // MIs[0] policy
     /* 1355761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355773 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1355773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1355776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355798 */     // GIR_Coverage, 7176,
     /* 1355798 */     GIR_EraseRootFromParent_Done,
     /* 1355799 */   // Label 19181: @1355799
     /* 1355799 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1355896), // Rule ID 7177 //
     /* 1355804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1355815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1355818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1355834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355854 */     // MIs[1] Operand 1
     /* 1355854 */     // No operand predicates
     /* 1355854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355858 */     // MIs[0] policy
     /* 1355858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1355870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1355873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355895 */     // GIR_Coverage, 7177,
     /* 1355895 */     GIR_EraseRootFromParent_Done,
     /* 1355896 */   // Label 19182: @1355896
     /* 1355896 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1355993), // Rule ID 7180 //
     /* 1355901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1355909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1355912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1355915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1355931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1355943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1355947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1355951 */     // MIs[1] Operand 1
     /* 1355951 */     // No operand predicates
     /* 1355951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355955 */     // MIs[0] policy
     /* 1355955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1355958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1355960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355967 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1355967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1355970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1355979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1355991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355992 */     // GIR_Coverage, 7180,
     /* 1355992 */     GIR_EraseRootFromParent_Done,
     /* 1355993 */   // Label 19183: @1355993
     /* 1355993 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1356090), // Rule ID 7181 //
     /* 1355998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1356009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1356012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356048 */     // MIs[1] Operand 1
     /* 1356048 */     // No operand predicates
     /* 1356048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356052 */     // MIs[0] policy
     /* 1356052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1356064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1356067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356089 */     // GIR_Coverage, 7181,
     /* 1356089 */     GIR_EraseRootFromParent_Done,
     /* 1356090 */   // Label 19184: @1356090
     /* 1356090 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1356187), // Rule ID 7184 //
     /* 1356095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1356106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1356109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1356112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356145 */     // MIs[1] Operand 1
     /* 1356145 */     // No operand predicates
     /* 1356145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356149 */     // MIs[0] policy
     /* 1356149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1356161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1356164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356186 */     // GIR_Coverage, 7184,
     /* 1356186 */     GIR_EraseRootFromParent_Done,
     /* 1356187 */   // Label 19185: @1356187
     /* 1356187 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1356284), // Rule ID 7185 //
     /* 1356192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1356203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1356206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1356209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356242 */     // MIs[1] Operand 1
     /* 1356242 */     // No operand predicates
     /* 1356242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356246 */     // MIs[0] policy
     /* 1356246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1356258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1356261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356283 */     // GIR_Coverage, 7185,
     /* 1356283 */     GIR_EraseRootFromParent_Done,
     /* 1356284 */   // Label 19186: @1356284
     /* 1356284 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1356381), // Rule ID 7188 //
     /* 1356289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1356300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1356303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356339 */     // MIs[1] Operand 1
     /* 1356339 */     // No operand predicates
     /* 1356339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356343 */     // MIs[0] policy
     /* 1356343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356355 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1356355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1356358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356380 */     // GIR_Coverage, 7188,
     /* 1356380 */     GIR_EraseRootFromParent_Done,
     /* 1356381 */   // Label 19187: @1356381
     /* 1356381 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1356478), // Rule ID 7189 //
     /* 1356386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1356397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1356400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356436 */     // MIs[1] Operand 1
     /* 1356436 */     // No operand predicates
     /* 1356436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356440 */     // MIs[0] policy
     /* 1356440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1356452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1356455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356477 */     // GIR_Coverage, 7189,
     /* 1356477 */     GIR_EraseRootFromParent_Done,
     /* 1356478 */   // Label 19188: @1356478
     /* 1356478 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1356575), // Rule ID 7192 //
     /* 1356483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1356494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1356497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356533 */     // MIs[1] Operand 1
     /* 1356533 */     // No operand predicates
     /* 1356533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356537 */     // MIs[0] policy
     /* 1356537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356549 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1356549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1356552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356574 */     // GIR_Coverage, 7192,
     /* 1356574 */     GIR_EraseRootFromParent_Done,
     /* 1356575 */   // Label 19189: @1356575
     /* 1356575 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1356672), // Rule ID 7193 //
     /* 1356580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1356591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1356594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356630 */     // MIs[1] Operand 1
     /* 1356630 */     // No operand predicates
     /* 1356630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356634 */     // MIs[0] policy
     /* 1356634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1356646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1356649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356671 */     // GIR_Coverage, 7193,
     /* 1356671 */     GIR_EraseRootFromParent_Done,
     /* 1356672 */   // Label 19190: @1356672
     /* 1356672 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1356769), // Rule ID 7196 //
     /* 1356677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1356680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1356688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1356691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356727 */     // MIs[1] Operand 1
     /* 1356727 */     // No operand predicates
     /* 1356727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356731 */     // MIs[0] policy
     /* 1356731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1356743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1356746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356768 */     // GIR_Coverage, 7196,
     /* 1356768 */     GIR_EraseRootFromParent_Done,
     /* 1356769 */   // Label 19191: @1356769
     /* 1356769 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1356866), // Rule ID 7197 //
     /* 1356774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1356777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1356785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1356788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356824 */     // MIs[1] Operand 1
     /* 1356824 */     // No operand predicates
     /* 1356824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356828 */     // MIs[0] policy
     /* 1356828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1356840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1356843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356865 */     // GIR_Coverage, 7197,
     /* 1356865 */     GIR_EraseRootFromParent_Done,
     /* 1356866 */   // Label 19192: @1356866
     /* 1356866 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1356963), // Rule ID 7200 //
     /* 1356871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1356874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1356882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1356885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1356913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1356917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1356921 */     // MIs[1] Operand 1
     /* 1356921 */     // No operand predicates
     /* 1356921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356925 */     // MIs[0] policy
     /* 1356925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1356928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1356930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356937 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1356937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1356940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1356949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1356961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356962 */     // GIR_Coverage, 7200,
     /* 1356962 */     GIR_EraseRootFromParent_Done,
     /* 1356963 */   // Label 19193: @1356963
     /* 1356963 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1357060), // Rule ID 7201 //
     /* 1356968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1356971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1356976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1356979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1356982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1356988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357018 */     // MIs[1] Operand 1
     /* 1357018 */     // No operand predicates
     /* 1357018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357022 */     // MIs[0] policy
     /* 1357022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1357034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1357037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357059 */     // GIR_Coverage, 7201,
     /* 1357059 */     GIR_EraseRootFromParent_Done,
     /* 1357060 */   // Label 19194: @1357060
     /* 1357060 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1357157), // Rule ID 7204 //
     /* 1357065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1357068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1357073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1357076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1357079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1357082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1357085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357115 */     // MIs[1] Operand 1
     /* 1357115 */     // No operand predicates
     /* 1357115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357119 */     // MIs[0] policy
     /* 1357119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1357131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1357134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357156 */     // GIR_Coverage, 7204,
     /* 1357156 */     GIR_EraseRootFromParent_Done,
     /* 1357157 */   // Label 19195: @1357157
     /* 1357157 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1357254), // Rule ID 7205 //
     /* 1357162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1357165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1357170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1357173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1357176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1357179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357212 */     // MIs[1] Operand 1
     /* 1357212 */     // No operand predicates
     /* 1357212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357216 */     // MIs[0] policy
     /* 1357216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1357228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1357231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357253 */     // GIR_Coverage, 7205,
     /* 1357253 */     GIR_EraseRootFromParent_Done,
     /* 1357254 */   // Label 19196: @1357254
     /* 1357254 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1357351), // Rule ID 7416 //
     /* 1357259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1357270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1357273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1357279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357309 */     // MIs[1] Operand 1
     /* 1357309 */     // No operand predicates
     /* 1357309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357313 */     // MIs[0] policy
     /* 1357313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357325 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1357325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1357328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357350 */     // GIR_Coverage, 7416,
     /* 1357350 */     GIR_EraseRootFromParent_Done,
     /* 1357351 */   // Label 19197: @1357351
     /* 1357351 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1357448), // Rule ID 7417 //
     /* 1357356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1357367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1357370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357406 */     // MIs[1] Operand 1
     /* 1357406 */     // No operand predicates
     /* 1357406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357410 */     // MIs[0] policy
     /* 1357410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1357422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1357425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357447 */     // GIR_Coverage, 7417,
     /* 1357447 */     GIR_EraseRootFromParent_Done,
     /* 1357448 */   // Label 19198: @1357448
     /* 1357448 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1357545), // Rule ID 7420 //
     /* 1357453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1357464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1357467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1357473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357503 */     // MIs[1] Operand 1
     /* 1357503 */     // No operand predicates
     /* 1357503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357507 */     // MIs[0] policy
     /* 1357507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357519 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1357519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1357522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357544 */     // GIR_Coverage, 7420,
     /* 1357544 */     GIR_EraseRootFromParent_Done,
     /* 1357545 */   // Label 19199: @1357545
     /* 1357545 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1357642), // Rule ID 7421 //
     /* 1357550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1357561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1357564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357600 */     // MIs[1] Operand 1
     /* 1357600 */     // No operand predicates
     /* 1357600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357604 */     // MIs[0] policy
     /* 1357604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1357616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1357619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357641 */     // GIR_Coverage, 7421,
     /* 1357641 */     GIR_EraseRootFromParent_Done,
     /* 1357642 */   // Label 19200: @1357642
     /* 1357642 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1357739), // Rule ID 7424 //
     /* 1357647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1357658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1357661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1357667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357697 */     // MIs[1] Operand 1
     /* 1357697 */     // No operand predicates
     /* 1357697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357701 */     // MIs[0] policy
     /* 1357701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357713 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1357713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1357716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357738 */     // GIR_Coverage, 7424,
     /* 1357738 */     GIR_EraseRootFromParent_Done,
     /* 1357739 */   // Label 19201: @1357739
     /* 1357739 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1357836), // Rule ID 7425 //
     /* 1357744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1357755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1357758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357794 */     // MIs[1] Operand 1
     /* 1357794 */     // No operand predicates
     /* 1357794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357798 */     // MIs[0] policy
     /* 1357798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1357810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1357813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357835 */     // GIR_Coverage, 7425,
     /* 1357835 */     GIR_EraseRootFromParent_Done,
     /* 1357836 */   // Label 19202: @1357836
     /* 1357836 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1357933), // Rule ID 7428 //
     /* 1357841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1357852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1357855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1357858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1357861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357891 */     // MIs[1] Operand 1
     /* 1357891 */     // No operand predicates
     /* 1357891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357895 */     // MIs[0] policy
     /* 1357895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357907 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1357907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1357910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1357919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1357929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1357931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357932 */     // GIR_Coverage, 7428,
     /* 1357932 */     GIR_EraseRootFromParent_Done,
     /* 1357933 */   // Label 19203: @1357933
     /* 1357933 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1358030), // Rule ID 7429 //
     /* 1357938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1357946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1357949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1357952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1357955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1357980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1357984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1357988 */     // MIs[1] Operand 1
     /* 1357988 */     // No operand predicates
     /* 1357988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357992 */     // MIs[0] policy
     /* 1357992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1357995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1358007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358029 */     // GIR_Coverage, 7429,
     /* 1358029 */     GIR_EraseRootFromParent_Done,
     /* 1358030 */   // Label 19204: @1358030
     /* 1358030 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1358127), // Rule ID 7432 //
     /* 1358035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1358046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1358049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358085 */     // MIs[1] Operand 1
     /* 1358085 */     // No operand predicates
     /* 1358085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358089 */     // MIs[0] policy
     /* 1358089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1358101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1358104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358126 */     // GIR_Coverage, 7432,
     /* 1358126 */     GIR_EraseRootFromParent_Done,
     /* 1358127 */   // Label 19205: @1358127
     /* 1358127 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1358224), // Rule ID 7433 //
     /* 1358132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1358143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1358146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358182 */     // MIs[1] Operand 1
     /* 1358182 */     // No operand predicates
     /* 1358182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358186 */     // MIs[0] policy
     /* 1358186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1358201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358223 */     // GIR_Coverage, 7433,
     /* 1358223 */     GIR_EraseRootFromParent_Done,
     /* 1358224 */   // Label 19206: @1358224
     /* 1358224 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1358321), // Rule ID 7436 //
     /* 1358229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1358240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1358243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1358246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1358252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358279 */     // MIs[1] Operand 1
     /* 1358279 */     // No operand predicates
     /* 1358279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358283 */     // MIs[0] policy
     /* 1358283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358295 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1358295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1358298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358320 */     // GIR_Coverage, 7436,
     /* 1358320 */     GIR_EraseRootFromParent_Done,
     /* 1358321 */   // Label 19207: @1358321
     /* 1358321 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1358418), // Rule ID 7437 //
     /* 1358326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1358337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1358340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1358343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1358349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358376 */     // MIs[1] Operand 1
     /* 1358376 */     // No operand predicates
     /* 1358376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358380 */     // MIs[0] policy
     /* 1358380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1358395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358417 */     // GIR_Coverage, 7437,
     /* 1358417 */     GIR_EraseRootFromParent_Done,
     /* 1358418 */   // Label 19208: @1358418
     /* 1358418 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1358515), // Rule ID 7440 //
     /* 1358423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1358434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1358437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1358440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358473 */     // MIs[1] Operand 1
     /* 1358473 */     // No operand predicates
     /* 1358473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358477 */     // MIs[0] policy
     /* 1358477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1358489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1358492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358514 */     // GIR_Coverage, 7440,
     /* 1358514 */     GIR_EraseRootFromParent_Done,
     /* 1358515 */   // Label 19209: @1358515
     /* 1358515 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1358612), // Rule ID 7441 //
     /* 1358520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1358531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1358534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1358537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358570 */     // MIs[1] Operand 1
     /* 1358570 */     // No operand predicates
     /* 1358570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358574 */     // MIs[0] policy
     /* 1358574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1358589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358611 */     // GIR_Coverage, 7441,
     /* 1358611 */     GIR_EraseRootFromParent_Done,
     /* 1358612 */   // Label 19210: @1358612
     /* 1358612 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1358709), // Rule ID 7444 //
     /* 1358617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1358628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1358631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358667 */     // MIs[1] Operand 1
     /* 1358667 */     // No operand predicates
     /* 1358667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358671 */     // MIs[0] policy
     /* 1358671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358683 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1358683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1358686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358708 */     // GIR_Coverage, 7444,
     /* 1358708 */     GIR_EraseRootFromParent_Done,
     /* 1358709 */   // Label 19211: @1358709
     /* 1358709 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1358806), // Rule ID 7445 //
     /* 1358714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1358725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1358728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358764 */     // MIs[1] Operand 1
     /* 1358764 */     // No operand predicates
     /* 1358764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358768 */     // MIs[0] policy
     /* 1358768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1358783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358805 */     // GIR_Coverage, 7445,
     /* 1358805 */     GIR_EraseRootFromParent_Done,
     /* 1358806 */   // Label 19212: @1358806
     /* 1358806 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1358903), // Rule ID 7448 //
     /* 1358811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1358828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358861 */     // MIs[1] Operand 1
     /* 1358861 */     // No operand predicates
     /* 1358861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358865 */     // MIs[0] policy
     /* 1358865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1358877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1358880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358902 */     // GIR_Coverage, 7448,
     /* 1358902 */     GIR_EraseRootFromParent_Done,
     /* 1358903 */   // Label 19213: @1358903
     /* 1358903 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1359000), // Rule ID 7449 //
     /* 1358908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1358916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1358925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1358950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1358954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1358958 */     // MIs[1] Operand 1
     /* 1358958 */     // No operand predicates
     /* 1358958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358962 */     // MIs[0] policy
     /* 1358962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1358965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1358967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1358974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1358977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1358986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1358998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358999 */     // GIR_Coverage, 7449,
     /* 1358999 */     GIR_EraseRootFromParent_Done,
     /* 1359000 */   // Label 19214: @1359000
     /* 1359000 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1359097), // Rule ID 7452 //
     /* 1359005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1359016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1359019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359055 */     // MIs[1] Operand 1
     /* 1359055 */     // No operand predicates
     /* 1359055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359059 */     // MIs[0] policy
     /* 1359059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1359071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1359074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359096 */     // GIR_Coverage, 7452,
     /* 1359096 */     GIR_EraseRootFromParent_Done,
     /* 1359097 */   // Label 19215: @1359097
     /* 1359097 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1359194), // Rule ID 7453 //
     /* 1359102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1359113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1359116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359152 */     // MIs[1] Operand 1
     /* 1359152 */     // No operand predicates
     /* 1359152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359156 */     // MIs[0] policy
     /* 1359156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1359168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1359171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359193 */     // GIR_Coverage, 7453,
     /* 1359193 */     GIR_EraseRootFromParent_Done,
     /* 1359194 */   // Label 19216: @1359194
     /* 1359194 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1359291), // Rule ID 7456 //
     /* 1359199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359249 */     // MIs[1] Operand 1
     /* 1359249 */     // No operand predicates
     /* 1359249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359253 */     // MIs[0] policy
     /* 1359253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1359265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1359268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359290 */     // GIR_Coverage, 7456,
     /* 1359290 */     GIR_EraseRootFromParent_Done,
     /* 1359291 */   // Label 19217: @1359291
     /* 1359291 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1359388), // Rule ID 7457 //
     /* 1359296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359346 */     // MIs[1] Operand 1
     /* 1359346 */     // No operand predicates
     /* 1359346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359350 */     // MIs[0] policy
     /* 1359350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1359362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1359365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359387 */     // GIR_Coverage, 7457,
     /* 1359387 */     GIR_EraseRootFromParent_Done,
     /* 1359388 */   // Label 19218: @1359388
     /* 1359388 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1359485), // Rule ID 7460 //
     /* 1359393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1359396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1359404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1359407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1359410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359443 */     // MIs[1] Operand 1
     /* 1359443 */     // No operand predicates
     /* 1359443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359447 */     // MIs[0] policy
     /* 1359447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1359459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1359462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359484 */     // GIR_Coverage, 7460,
     /* 1359484 */     GIR_EraseRootFromParent_Done,
     /* 1359485 */   // Label 19219: @1359485
     /* 1359485 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1359582), // Rule ID 7461 //
     /* 1359490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1359493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1359501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1359504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1359507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359540 */     // MIs[1] Operand 1
     /* 1359540 */     // No operand predicates
     /* 1359540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359544 */     // MIs[0] policy
     /* 1359544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1359556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1359559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359581 */     // GIR_Coverage, 7461,
     /* 1359581 */     GIR_EraseRootFromParent_Done,
     /* 1359582 */   // Label 19220: @1359582
     /* 1359582 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1359679), // Rule ID 7464 //
     /* 1359587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1359590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1359604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359637 */     // MIs[1] Operand 1
     /* 1359637 */     // No operand predicates
     /* 1359637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359641 */     // MIs[0] policy
     /* 1359641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1359653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1359656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359678 */     // GIR_Coverage, 7464,
     /* 1359678 */     GIR_EraseRootFromParent_Done,
     /* 1359679 */   // Label 19221: @1359679
     /* 1359679 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1359776), // Rule ID 7465 //
     /* 1359684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1359687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1359701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359734 */     // MIs[1] Operand 1
     /* 1359734 */     // No operand predicates
     /* 1359734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359738 */     // MIs[0] policy
     /* 1359738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1359750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1359753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359775 */     // GIR_Coverage, 7465,
     /* 1359775 */     GIR_EraseRootFromParent_Done,
     /* 1359776 */   // Label 19222: @1359776
     /* 1359776 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1359873), // Rule ID 7468 //
     /* 1359781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1359784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1359798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359831 */     // MIs[1] Operand 1
     /* 1359831 */     // No operand predicates
     /* 1359831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359835 */     // MIs[0] policy
     /* 1359835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1359847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1359850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359872 */     // GIR_Coverage, 7468,
     /* 1359872 */     GIR_EraseRootFromParent_Done,
     /* 1359873 */   // Label 19223: @1359873
     /* 1359873 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1359970), // Rule ID 7469 //
     /* 1359878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1359881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1359895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1359920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1359924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1359928 */     // MIs[1] Operand 1
     /* 1359928 */     // No operand predicates
     /* 1359928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359932 */     // MIs[0] policy
     /* 1359932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1359935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1359937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1359944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1359947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1359956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1359968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359969 */     // GIR_Coverage, 7469,
     /* 1359969 */     GIR_EraseRootFromParent_Done,
     /* 1359970 */   // Label 19224: @1359970
     /* 1359970 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1360067), // Rule ID 7472 //
     /* 1359975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1359978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1359983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1359992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1359995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360025 */     // MIs[1] Operand 1
     /* 1360025 */     // No operand predicates
     /* 1360025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360029 */     // MIs[0] policy
     /* 1360029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1360041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1360044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360066 */     // GIR_Coverage, 7472,
     /* 1360066 */     GIR_EraseRootFromParent_Done,
     /* 1360067 */   // Label 19225: @1360067
     /* 1360067 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1360164), // Rule ID 7473 //
     /* 1360072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1360075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1360080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360122 */     // MIs[1] Operand 1
     /* 1360122 */     // No operand predicates
     /* 1360122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360126 */     // MIs[0] policy
     /* 1360126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1360138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1360141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360163 */     // GIR_Coverage, 7473,
     /* 1360163 */     GIR_EraseRootFromParent_Done,
     /* 1360164 */   // Label 19226: @1360164
     /* 1360164 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1360261), // Rule ID 7596 //
     /* 1360169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1360180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1360183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360219 */     // MIs[1] Operand 1
     /* 1360219 */     // No operand predicates
     /* 1360219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360223 */     // MIs[0] policy
     /* 1360223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1360235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1360238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360260 */     // GIR_Coverage, 7596,
     /* 1360260 */     GIR_EraseRootFromParent_Done,
     /* 1360261 */   // Label 19227: @1360261
     /* 1360261 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1360358), // Rule ID 7597 //
     /* 1360266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1360277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1360280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360316 */     // MIs[1] Operand 1
     /* 1360316 */     // No operand predicates
     /* 1360316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360320 */     // MIs[0] policy
     /* 1360320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360332 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1360332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1360335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360357 */     // GIR_Coverage, 7597,
     /* 1360357 */     GIR_EraseRootFromParent_Done,
     /* 1360358 */   // Label 19228: @1360358
     /* 1360358 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1360455), // Rule ID 7600 //
     /* 1360363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1360374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1360377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360413 */     // MIs[1] Operand 1
     /* 1360413 */     // No operand predicates
     /* 1360413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360417 */     // MIs[0] policy
     /* 1360417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1360429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1360432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360454 */     // GIR_Coverage, 7600,
     /* 1360454 */     GIR_EraseRootFromParent_Done,
     /* 1360455 */   // Label 19229: @1360455
     /* 1360455 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1360552), // Rule ID 7601 //
     /* 1360460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1360471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1360474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360510 */     // MIs[1] Operand 1
     /* 1360510 */     // No operand predicates
     /* 1360510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360514 */     // MIs[0] policy
     /* 1360514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1360526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1360529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360551 */     // GIR_Coverage, 7601,
     /* 1360551 */     GIR_EraseRootFromParent_Done,
     /* 1360552 */   // Label 19230: @1360552
     /* 1360552 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1360649), // Rule ID 7604 //
     /* 1360557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1360568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1360571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1360574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360607 */     // MIs[1] Operand 1
     /* 1360607 */     // No operand predicates
     /* 1360607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360611 */     // MIs[0] policy
     /* 1360611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1360623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1360626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360648 */     // GIR_Coverage, 7604,
     /* 1360648 */     GIR_EraseRootFromParent_Done,
     /* 1360649 */   // Label 19231: @1360649
     /* 1360649 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1360746), // Rule ID 7605 //
     /* 1360654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1360665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1360668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1360671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360704 */     // MIs[1] Operand 1
     /* 1360704 */     // No operand predicates
     /* 1360704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360708 */     // MIs[0] policy
     /* 1360708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1360720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1360723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360745 */     // GIR_Coverage, 7605,
     /* 1360745 */     GIR_EraseRootFromParent_Done,
     /* 1360746 */   // Label 19232: @1360746
     /* 1360746 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1360843), // Rule ID 7608 //
     /* 1360751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1360768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360801 */     // MIs[1] Operand 1
     /* 1360801 */     // No operand predicates
     /* 1360801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360805 */     // MIs[0] policy
     /* 1360805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360817 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1360817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1360820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360842 */     // GIR_Coverage, 7608,
     /* 1360842 */     GIR_EraseRootFromParent_Done,
     /* 1360843 */   // Label 19233: @1360843
     /* 1360843 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1360940), // Rule ID 7609 //
     /* 1360848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1360865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360898 */     // MIs[1] Operand 1
     /* 1360898 */     // No operand predicates
     /* 1360898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360902 */     // MIs[0] policy
     /* 1360902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1360905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1360907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1360914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1360917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1360926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1360938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360939 */     // GIR_Coverage, 7609,
     /* 1360939 */     GIR_EraseRootFromParent_Done,
     /* 1360940 */   // Label 19234: @1360940
     /* 1360940 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1361037), // Rule ID 7612 //
     /* 1360945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1360953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1360956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1360959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1360962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1360987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1360991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1360995 */     // MIs[1] Operand 1
     /* 1360995 */     // No operand predicates
     /* 1360995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360999 */     // MIs[0] policy
     /* 1360999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1361014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361036 */     // GIR_Coverage, 7612,
     /* 1361036 */     GIR_EraseRootFromParent_Done,
     /* 1361037 */   // Label 19235: @1361037
     /* 1361037 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1361134), // Rule ID 7613 //
     /* 1361042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1361053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1361056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1361059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1361072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361092 */     // MIs[1] Operand 1
     /* 1361092 */     // No operand predicates
     /* 1361092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361096 */     // MIs[0] policy
     /* 1361096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361108 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1361108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1361111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361133 */     // GIR_Coverage, 7613,
     /* 1361133 */     GIR_EraseRootFromParent_Done,
     /* 1361134 */   // Label 19236: @1361134
     /* 1361134 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1361231), // Rule ID 7616 //
     /* 1361139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1361150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1361153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1361156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1361162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361189 */     // MIs[1] Operand 1
     /* 1361189 */     // No operand predicates
     /* 1361189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361193 */     // MIs[0] policy
     /* 1361193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361205 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1361208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361230 */     // GIR_Coverage, 7616,
     /* 1361230 */     GIR_EraseRootFromParent_Done,
     /* 1361231 */   // Label 19237: @1361231
     /* 1361231 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1361328), // Rule ID 7617 //
     /* 1361236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1361247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1361250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1361253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1361259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361286 */     // MIs[1] Operand 1
     /* 1361286 */     // No operand predicates
     /* 1361286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361290 */     // MIs[0] policy
     /* 1361290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1361302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1361305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361327 */     // GIR_Coverage, 7617,
     /* 1361327 */     GIR_EraseRootFromParent_Done,
     /* 1361328 */   // Label 19238: @1361328
     /* 1361328 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1361425), // Rule ID 7620 //
     /* 1361333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1361344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1361347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361383 */     // MIs[1] Operand 1
     /* 1361383 */     // No operand predicates
     /* 1361383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361387 */     // MIs[0] policy
     /* 1361387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361399 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1361402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361424 */     // GIR_Coverage, 7620,
     /* 1361424 */     GIR_EraseRootFromParent_Done,
     /* 1361425 */   // Label 19239: @1361425
     /* 1361425 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1361522), // Rule ID 7621 //
     /* 1361430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1361441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1361444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361480 */     // MIs[1] Operand 1
     /* 1361480 */     // No operand predicates
     /* 1361480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361484 */     // MIs[0] policy
     /* 1361484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1361496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1361499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361521 */     // GIR_Coverage, 7621,
     /* 1361521 */     GIR_EraseRootFromParent_Done,
     /* 1361522 */   // Label 19240: @1361522
     /* 1361522 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1361619), // Rule ID 7624 //
     /* 1361527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1361538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1361541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361577 */     // MIs[1] Operand 1
     /* 1361577 */     // No operand predicates
     /* 1361577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361581 */     // MIs[0] policy
     /* 1361581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1361596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361618 */     // GIR_Coverage, 7624,
     /* 1361618 */     GIR_EraseRootFromParent_Done,
     /* 1361619 */   // Label 19241: @1361619
     /* 1361619 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1361716), // Rule ID 7625 //
     /* 1361624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1361635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1361638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361674 */     // MIs[1] Operand 1
     /* 1361674 */     // No operand predicates
     /* 1361674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361678 */     // MIs[0] policy
     /* 1361678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361690 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1361690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1361693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361715 */     // GIR_Coverage, 7625,
     /* 1361715 */     GIR_EraseRootFromParent_Done,
     /* 1361716 */   // Label 19242: @1361716
     /* 1361716 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1361813), // Rule ID 7628 //
     /* 1361721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1361738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361771 */     // MIs[1] Operand 1
     /* 1361771 */     // No operand predicates
     /* 1361771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361775 */     // MIs[0] policy
     /* 1361775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361787 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1361790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361812 */     // GIR_Coverage, 7628,
     /* 1361812 */     GIR_EraseRootFromParent_Done,
     /* 1361813 */   // Label 19243: @1361813
     /* 1361813 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1361910), // Rule ID 7629 //
     /* 1361818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1361835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361868 */     // MIs[1] Operand 1
     /* 1361868 */     // No operand predicates
     /* 1361868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361872 */     // MIs[0] policy
     /* 1361872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1361884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1361887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1361908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361909 */     // GIR_Coverage, 7629,
     /* 1361909 */     GIR_EraseRootFromParent_Done,
     /* 1361910 */   // Label 19244: @1361910
     /* 1361910 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1362007), // Rule ID 7632 //
     /* 1361915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1361923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1361926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1361929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1361932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1361945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1361957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1361961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1361965 */     // MIs[1] Operand 1
     /* 1361965 */     // No operand predicates
     /* 1361965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361969 */     // MIs[0] policy
     /* 1361969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1361972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1361974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1361981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1361984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1361993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362006 */     // GIR_Coverage, 7632,
     /* 1362006 */     GIR_EraseRootFromParent_Done,
     /* 1362007 */   // Label 19245: @1362007
     /* 1362007 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1362104), // Rule ID 7633 //
     /* 1362012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1362023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1362026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1362029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1362032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362062 */     // MIs[1] Operand 1
     /* 1362062 */     // No operand predicates
     /* 1362062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362066 */     // MIs[0] policy
     /* 1362066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1362078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1362081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362103 */     // GIR_Coverage, 7633,
     /* 1362103 */     GIR_EraseRootFromParent_Done,
     /* 1362104 */   // Label 19246: @1362104
     /* 1362104 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1362201), // Rule ID 7636 //
     /* 1362109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1362126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362159 */     // MIs[1] Operand 1
     /* 1362159 */     // No operand predicates
     /* 1362159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362163 */     // MIs[0] policy
     /* 1362163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362175 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1362175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1362178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362200 */     // GIR_Coverage, 7636,
     /* 1362200 */     GIR_EraseRootFromParent_Done,
     /* 1362201 */   // Label 19247: @1362201
     /* 1362201 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1362298), // Rule ID 7637 //
     /* 1362206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1362223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1362226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362256 */     // MIs[1] Operand 1
     /* 1362256 */     // No operand predicates
     /* 1362256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362260 */     // MIs[0] policy
     /* 1362260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1362272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1362275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362297 */     // GIR_Coverage, 7637,
     /* 1362297 */     GIR_EraseRootFromParent_Done,
     /* 1362298 */   // Label 19248: @1362298
     /* 1362298 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1362395), // Rule ID 7640 //
     /* 1362303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1362306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1362314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1362317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362353 */     // MIs[1] Operand 1
     /* 1362353 */     // No operand predicates
     /* 1362353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362357 */     // MIs[0] policy
     /* 1362357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1362369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1362372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362394 */     // GIR_Coverage, 7640,
     /* 1362394 */     GIR_EraseRootFromParent_Done,
     /* 1362395 */   // Label 19249: @1362395
     /* 1362395 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1362492), // Rule ID 7641 //
     /* 1362400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1362403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1362411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1362414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1362420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362450 */     // MIs[1] Operand 1
     /* 1362450 */     // No operand predicates
     /* 1362450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362454 */     // MIs[0] policy
     /* 1362454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1362466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1362469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362491 */     // GIR_Coverage, 7641,
     /* 1362491 */     GIR_EraseRootFromParent_Done,
     /* 1362492 */   // Label 19250: @1362492
     /* 1362492 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1362589), // Rule ID 7644 //
     /* 1362497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1362500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1362514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362547 */     // MIs[1] Operand 1
     /* 1362547 */     // No operand predicates
     /* 1362547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362551 */     // MIs[0] policy
     /* 1362551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1362563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1362566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362588 */     // GIR_Coverage, 7644,
     /* 1362588 */     GIR_EraseRootFromParent_Done,
     /* 1362589 */   // Label 19251: @1362589
     /* 1362589 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1362686), // Rule ID 7645 //
     /* 1362594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1362597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1362611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1362614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362644 */     // MIs[1] Operand 1
     /* 1362644 */     // No operand predicates
     /* 1362644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362648 */     // MIs[0] policy
     /* 1362648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1362660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1362663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362685 */     // GIR_Coverage, 7645,
     /* 1362685 */     GIR_EraseRootFromParent_Done,
     /* 1362686 */   // Label 19252: @1362686
     /* 1362686 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1362783), // Rule ID 7648 //
     /* 1362691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1362694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1362702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1362705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1362708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362741 */     // MIs[1] Operand 1
     /* 1362741 */     // No operand predicates
     /* 1362741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362745 */     // MIs[0] policy
     /* 1362745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1362757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1362760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362782 */     // GIR_Coverage, 7648,
     /* 1362782 */     GIR_EraseRootFromParent_Done,
     /* 1362783 */   // Label 19253: @1362783
     /* 1362783 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1362880), // Rule ID 7649 //
     /* 1362788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1362791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1362799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1362802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1362805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1362808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362838 */     // MIs[1] Operand 1
     /* 1362838 */     // No operand predicates
     /* 1362838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362842 */     // MIs[0] policy
     /* 1362842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1362854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1362857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362879 */     // GIR_Coverage, 7649,
     /* 1362879 */     GIR_EraseRootFromParent_Done,
     /* 1362880 */   // Label 19254: @1362880
     /* 1362880 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1362977), // Rule ID 7652 //
     /* 1362885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1362888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1362896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1362899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1362902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1362927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1362931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1362935 */     // MIs[1] Operand 1
     /* 1362935 */     // No operand predicates
     /* 1362935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362939 */     // MIs[0] policy
     /* 1362939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1362942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1362951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1362954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1362963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1362975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362976 */     // GIR_Coverage, 7652,
     /* 1362976 */     GIR_EraseRootFromParent_Done,
     /* 1362977 */   // Label 19255: @1362977
     /* 1362977 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1363074), // Rule ID 7653 //
     /* 1362982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1362985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1362990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1362993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1362996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1362999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1363012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1363032 */     // MIs[1] Operand 1
     /* 1363032 */     // No operand predicates
     /* 1363032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363036 */     // MIs[0] policy
     /* 1363036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1363048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1363051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363073 */     // GIR_Coverage, 7653,
     /* 1363073 */     GIR_EraseRootFromParent_Done,
     /* 1363074 */   // Label 19256: @1363074
     /* 1363074 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1363174), // Rule ID 14082 //
     /* 1363079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1363090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1363093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1363096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1363099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363129 */     // MIs[1] Operand 1
     /* 1363129 */     // No operand predicates
     /* 1363129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363133 */     // MIs[0] policy
     /* 1363133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363145 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1363145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1363148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363173 */     // GIR_Coverage, 14082,
     /* 1363173 */     GIR_EraseRootFromParent_Done,
     /* 1363174 */   // Label 19257: @1363174
     /* 1363174 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1363274), // Rule ID 14083 //
     /* 1363179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1363190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1363193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1363196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363229 */     // MIs[1] Operand 1
     /* 1363229 */     // No operand predicates
     /* 1363229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363233 */     // MIs[0] policy
     /* 1363233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363245 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1363245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1363248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363273 */     // GIR_Coverage, 14083,
     /* 1363273 */     GIR_EraseRootFromParent_Done,
     /* 1363274 */   // Label 19258: @1363274
     /* 1363274 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1363374), // Rule ID 14086 //
     /* 1363279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1363290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1363293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1363296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1363299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363329 */     // MIs[1] Operand 1
     /* 1363329 */     // No operand predicates
     /* 1363329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363333 */     // MIs[0] policy
     /* 1363333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363345 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1363345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1363348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363373 */     // GIR_Coverage, 14086,
     /* 1363373 */     GIR_EraseRootFromParent_Done,
     /* 1363374 */   // Label 19259: @1363374
     /* 1363374 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1363474), // Rule ID 14087 //
     /* 1363379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1363390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1363393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1363396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363429 */     // MIs[1] Operand 1
     /* 1363429 */     // No operand predicates
     /* 1363429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363433 */     // MIs[0] policy
     /* 1363433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1363445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1363448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363473 */     // GIR_Coverage, 14087,
     /* 1363473 */     GIR_EraseRootFromParent_Done,
     /* 1363474 */   // Label 19260: @1363474
     /* 1363474 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1363574), // Rule ID 14090 //
     /* 1363479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1363490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1363493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1363496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1363499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363529 */     // MIs[1] Operand 1
     /* 1363529 */     // No operand predicates
     /* 1363529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363533 */     // MIs[0] policy
     /* 1363533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363545 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1363545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1363548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363573 */     // GIR_Coverage, 14090,
     /* 1363573 */     GIR_EraseRootFromParent_Done,
     /* 1363574 */   // Label 19261: @1363574
     /* 1363574 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1363674), // Rule ID 14091 //
     /* 1363579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1363590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1363593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1363596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363629 */     // MIs[1] Operand 1
     /* 1363629 */     // No operand predicates
     /* 1363629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363633 */     // MIs[0] policy
     /* 1363633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363645 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1363645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1363648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363673 */     // GIR_Coverage, 14091,
     /* 1363673 */     GIR_EraseRootFromParent_Done,
     /* 1363674 */   // Label 19262: @1363674
     /* 1363674 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1363774), // Rule ID 14094 //
     /* 1363679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1363690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1363693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1363696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1363699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363729 */     // MIs[1] Operand 1
     /* 1363729 */     // No operand predicates
     /* 1363729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363733 */     // MIs[0] policy
     /* 1363733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363745 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1363745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1363748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363773 */     // GIR_Coverage, 14094,
     /* 1363773 */     GIR_EraseRootFromParent_Done,
     /* 1363774 */   // Label 19263: @1363774
     /* 1363774 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1363874), // Rule ID 14095 //
     /* 1363779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1363790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1363793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1363796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363829 */     // MIs[1] Operand 1
     /* 1363829 */     // No operand predicates
     /* 1363829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363833 */     // MIs[0] policy
     /* 1363833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363845 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1363845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1363848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363873 */     // GIR_Coverage, 14095,
     /* 1363873 */     GIR_EraseRootFromParent_Done,
     /* 1363874 */   // Label 19264: @1363874
     /* 1363874 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1363974), // Rule ID 14098 //
     /* 1363879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1363890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1363893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1363896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1363899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1363921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1363925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1363929 */     // MIs[1] Operand 1
     /* 1363929 */     // No operand predicates
     /* 1363929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363933 */     // MIs[0] policy
     /* 1363933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1363936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1363938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363945 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1363945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1363948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1363957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1363969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1363972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363973 */     // GIR_Coverage, 14098,
     /* 1363973 */     GIR_EraseRootFromParent_Done,
     /* 1363974 */   // Label 19265: @1363974
     /* 1363974 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1364074), // Rule ID 14099 //
     /* 1363979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1363987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1363990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1363993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1363996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364029 */     // MIs[1] Operand 1
     /* 1364029 */     // No operand predicates
     /* 1364029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364033 */     // MIs[0] policy
     /* 1364033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364045 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1364045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1364048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364073 */     // GIR_Coverage, 14099,
     /* 1364073 */     GIR_EraseRootFromParent_Done,
     /* 1364074 */   // Label 19266: @1364074
     /* 1364074 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1364174), // Rule ID 14102 //
     /* 1364079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1364090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1364093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1364096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364129 */     // MIs[1] Operand 1
     /* 1364129 */     // No operand predicates
     /* 1364129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364133 */     // MIs[0] policy
     /* 1364133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364145 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1364145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1364148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364173 */     // GIR_Coverage, 14102,
     /* 1364173 */     GIR_EraseRootFromParent_Done,
     /* 1364174 */   // Label 19267: @1364174
     /* 1364174 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1364274), // Rule ID 14103 //
     /* 1364179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1364190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1364193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1364196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364229 */     // MIs[1] Operand 1
     /* 1364229 */     // No operand predicates
     /* 1364229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364233 */     // MIs[0] policy
     /* 1364233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364245 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1364245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1364248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364273 */     // GIR_Coverage, 14103,
     /* 1364273 */     GIR_EraseRootFromParent_Done,
     /* 1364274 */   // Label 19268: @1364274
     /* 1364274 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1364374), // Rule ID 14106 //
     /* 1364279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1364296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364329 */     // MIs[1] Operand 1
     /* 1364329 */     // No operand predicates
     /* 1364329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364333 */     // MIs[0] policy
     /* 1364333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364345 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1364345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364373 */     // GIR_Coverage, 14106,
     /* 1364373 */     GIR_EraseRootFromParent_Done,
     /* 1364374 */   // Label 19269: @1364374
     /* 1364374 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1364474), // Rule ID 14107 //
     /* 1364379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1364396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364429 */     // MIs[1] Operand 1
     /* 1364429 */     // No operand predicates
     /* 1364429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364433 */     // MIs[0] policy
     /* 1364433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364445 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1364445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364473 */     // GIR_Coverage, 14107,
     /* 1364473 */     GIR_EraseRootFromParent_Done,
     /* 1364474 */   // Label 19270: @1364474
     /* 1364474 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1364574), // Rule ID 14110 //
     /* 1364479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1364496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364529 */     // MIs[1] Operand 1
     /* 1364529 */     // No operand predicates
     /* 1364529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364533 */     // MIs[0] policy
     /* 1364533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364545 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1364545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364573 */     // GIR_Coverage, 14110,
     /* 1364573 */     GIR_EraseRootFromParent_Done,
     /* 1364574 */   // Label 19271: @1364574
     /* 1364574 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1364674), // Rule ID 14111 //
     /* 1364579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1364596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364629 */     // MIs[1] Operand 1
     /* 1364629 */     // No operand predicates
     /* 1364629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364633 */     // MIs[0] policy
     /* 1364633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1364645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364673 */     // GIR_Coverage, 14111,
     /* 1364673 */     GIR_EraseRootFromParent_Done,
     /* 1364674 */   // Label 19272: @1364674
     /* 1364674 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1364774), // Rule ID 14114 //
     /* 1364679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1364696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364729 */     // MIs[1] Operand 1
     /* 1364729 */     // No operand predicates
     /* 1364729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364733 */     // MIs[0] policy
     /* 1364733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1364745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364773 */     // GIR_Coverage, 14114,
     /* 1364773 */     GIR_EraseRootFromParent_Done,
     /* 1364774 */   // Label 19273: @1364774
     /* 1364774 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1364874), // Rule ID 14115 //
     /* 1364779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1364796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364829 */     // MIs[1] Operand 1
     /* 1364829 */     // No operand predicates
     /* 1364829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364833 */     // MIs[0] policy
     /* 1364833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1364845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364873 */     // GIR_Coverage, 14115,
     /* 1364873 */     GIR_EraseRootFromParent_Done,
     /* 1364874 */   // Label 19274: @1364874
     /* 1364874 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1364974), // Rule ID 14118 //
     /* 1364879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1364896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1364921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1364925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1364929 */     // MIs[1] Operand 1
     /* 1364929 */     // No operand predicates
     /* 1364929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364933 */     // MIs[0] policy
     /* 1364933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1364936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1364938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364945 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1364945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1364948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1364957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1364969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1364972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364973 */     // GIR_Coverage, 14118,
     /* 1364973 */     GIR_EraseRootFromParent_Done,
     /* 1364974 */   // Label 19275: @1364974
     /* 1364974 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1365074), // Rule ID 14119 //
     /* 1364979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1364987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1364996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365029 */     // MIs[1] Operand 1
     /* 1365029 */     // No operand predicates
     /* 1365029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365033 */     // MIs[0] policy
     /* 1365033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365045 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1365045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1365048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365073 */     // GIR_Coverage, 14119,
     /* 1365073 */     GIR_EraseRootFromParent_Done,
     /* 1365074 */   // Label 19276: @1365074
     /* 1365074 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1365174), // Rule ID 14122 //
     /* 1365079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1365090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1365093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1365096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1365102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1365109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365129 */     // MIs[1] Operand 1
     /* 1365129 */     // No operand predicates
     /* 1365129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365133 */     // MIs[0] policy
     /* 1365133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1365145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1365148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365173 */     // GIR_Coverage, 14122,
     /* 1365173 */     GIR_EraseRootFromParent_Done,
     /* 1365174 */   // Label 19277: @1365174
     /* 1365174 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1365274), // Rule ID 14123 //
     /* 1365179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1365190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1365193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1365196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1365199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1365202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1365209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365229 */     // MIs[1] Operand 1
     /* 1365229 */     // No operand predicates
     /* 1365229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365233 */     // MIs[0] policy
     /* 1365233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1365245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1365248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365273 */     // GIR_Coverage, 14123,
     /* 1365273 */     GIR_EraseRootFromParent_Done,
     /* 1365274 */   // Label 19278: @1365274
     /* 1365274 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1365374), // Rule ID 14126 //
     /* 1365279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1365290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1365293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1365296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1365302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1365309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365329 */     // MIs[1] Operand 1
     /* 1365329 */     // No operand predicates
     /* 1365329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365333 */     // MIs[0] policy
     /* 1365333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365345 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1365345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1365348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365373 */     // GIR_Coverage, 14126,
     /* 1365373 */     GIR_EraseRootFromParent_Done,
     /* 1365374 */   // Label 19279: @1365374
     /* 1365374 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1365474), // Rule ID 14127 //
     /* 1365379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1365390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1365393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1365396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1365399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1365402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1365409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365429 */     // MIs[1] Operand 1
     /* 1365429 */     // No operand predicates
     /* 1365429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365433 */     // MIs[0] policy
     /* 1365433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365445 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1365445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1365448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365473 */     // GIR_Coverage, 14127,
     /* 1365473 */     GIR_EraseRootFromParent_Done,
     /* 1365474 */   // Label 19280: @1365474
     /* 1365474 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1365574), // Rule ID 14130 //
     /* 1365479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1365490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1365493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1365496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1365502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1365509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365529 */     // MIs[1] Operand 1
     /* 1365529 */     // No operand predicates
     /* 1365529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365533 */     // MIs[0] policy
     /* 1365533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365545 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1365545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1365548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365573 */     // GIR_Coverage, 14130,
     /* 1365573 */     GIR_EraseRootFromParent_Done,
     /* 1365574 */   // Label 19281: @1365574
     /* 1365574 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1365674), // Rule ID 14131 //
     /* 1365579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1365590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1365593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1365596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1365599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1365602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1365609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365629 */     // MIs[1] Operand 1
     /* 1365629 */     // No operand predicates
     /* 1365629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365633 */     // MIs[0] policy
     /* 1365633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1365645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1365648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365673 */     // GIR_Coverage, 14131,
     /* 1365673 */     GIR_EraseRootFromParent_Done,
     /* 1365674 */   // Label 19282: @1365674
     /* 1365674 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1365774), // Rule ID 14134 //
     /* 1365679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1365690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1365693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1365696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1365709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365729 */     // MIs[1] Operand 1
     /* 1365729 */     // No operand predicates
     /* 1365729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365733 */     // MIs[0] policy
     /* 1365733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1365745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1365748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365773 */     // GIR_Coverage, 14134,
     /* 1365773 */     GIR_EraseRootFromParent_Done,
     /* 1365774 */   // Label 19283: @1365774
     /* 1365774 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1365874), // Rule ID 14135 //
     /* 1365779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1365790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1365793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1365796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1365799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1365809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365829 */     // MIs[1] Operand 1
     /* 1365829 */     // No operand predicates
     /* 1365829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365833 */     // MIs[0] policy
     /* 1365833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1365845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1365848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365873 */     // GIR_Coverage, 14135,
     /* 1365873 */     GIR_EraseRootFromParent_Done,
     /* 1365874 */   // Label 19284: @1365874
     /* 1365874 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1365974), // Rule ID 14138 //
     /* 1365879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1365890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1365893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1365896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1365902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1365909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1365921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1365925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1365929 */     // MIs[1] Operand 1
     /* 1365929 */     // No operand predicates
     /* 1365929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365933 */     // MIs[0] policy
     /* 1365933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1365936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1365938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365945 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1365945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1365948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1365957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1365969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1365972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365973 */     // GIR_Coverage, 14138,
     /* 1365973 */     GIR_EraseRootFromParent_Done,
     /* 1365974 */   // Label 19285: @1365974
     /* 1365974 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1366074), // Rule ID 14139 //
     /* 1365979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1365987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1365990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1365993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1365996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1365999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1366009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366029 */     // MIs[1] Operand 1
     /* 1366029 */     // No operand predicates
     /* 1366029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366033 */     // MIs[0] policy
     /* 1366033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366045 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1366045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1366048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366073 */     // GIR_Coverage, 14139,
     /* 1366073 */     GIR_EraseRootFromParent_Done,
     /* 1366074 */   // Label 19286: @1366074
     /* 1366074 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1366174), // Rule ID 14142 //
     /* 1366079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1366090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1366093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1366096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1366099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1366109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366129 */     // MIs[1] Operand 1
     /* 1366129 */     // No operand predicates
     /* 1366129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366133 */     // MIs[0] policy
     /* 1366133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366145 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1366145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1366148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366173 */     // GIR_Coverage, 14142,
     /* 1366173 */     GIR_EraseRootFromParent_Done,
     /* 1366174 */   // Label 19287: @1366174
     /* 1366174 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1366274), // Rule ID 14143 //
     /* 1366179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1366190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1366193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1366196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1366199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1366209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366229 */     // MIs[1] Operand 1
     /* 1366229 */     // No operand predicates
     /* 1366229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366233 */     // MIs[0] policy
     /* 1366233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1366245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1366248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366273 */     // GIR_Coverage, 14143,
     /* 1366273 */     GIR_EraseRootFromParent_Done,
     /* 1366274 */   // Label 19288: @1366274
     /* 1366274 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1366374), // Rule ID 14146 //
     /* 1366279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1366290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1366293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1366296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1366299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1366309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366329 */     // MIs[1] Operand 1
     /* 1366329 */     // No operand predicates
     /* 1366329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366333 */     // MIs[0] policy
     /* 1366333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1366345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1366348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366373 */     // GIR_Coverage, 14146,
     /* 1366373 */     GIR_EraseRootFromParent_Done,
     /* 1366374 */   // Label 19289: @1366374
     /* 1366374 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1366474), // Rule ID 14147 //
     /* 1366379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1366390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1366393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1366396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1366399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1366409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366429 */     // MIs[1] Operand 1
     /* 1366429 */     // No operand predicates
     /* 1366429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366433 */     // MIs[0] policy
     /* 1366433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1366445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1366448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366473 */     // GIR_Coverage, 14147,
     /* 1366473 */     GIR_EraseRootFromParent_Done,
     /* 1366474 */   // Label 19290: @1366474
     /* 1366474 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1366574), // Rule ID 14150 //
     /* 1366479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1366490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1366493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1366496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1366499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1366509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366529 */     // MIs[1] Operand 1
     /* 1366529 */     // No operand predicates
     /* 1366529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366533 */     // MIs[0] policy
     /* 1366533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366545 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1366545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1366548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366573 */     // GIR_Coverage, 14150,
     /* 1366573 */     GIR_EraseRootFromParent_Done,
     /* 1366574 */   // Label 19291: @1366574
     /* 1366574 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1366674), // Rule ID 14151 //
     /* 1366579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1366590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1366593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1366596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1366599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1366609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366629 */     // MIs[1] Operand 1
     /* 1366629 */     // No operand predicates
     /* 1366629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366633 */     // MIs[0] policy
     /* 1366633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1366645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1366648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366673 */     // GIR_Coverage, 14151,
     /* 1366673 */     GIR_EraseRootFromParent_Done,
     /* 1366674 */   // Label 19292: @1366674
     /* 1366674 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1366774), // Rule ID 14154 //
     /* 1366679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1366690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1366693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1366696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1366699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1366709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366729 */     // MIs[1] Operand 1
     /* 1366729 */     // No operand predicates
     /* 1366729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366733 */     // MIs[0] policy
     /* 1366733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1366745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1366748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366773 */     // GIR_Coverage, 14154,
     /* 1366773 */     GIR_EraseRootFromParent_Done,
     /* 1366774 */   // Label 19293: @1366774
     /* 1366774 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1366874), // Rule ID 14155 //
     /* 1366779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1366790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1366793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1366796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1366799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1366809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366829 */     // MIs[1] Operand 1
     /* 1366829 */     // No operand predicates
     /* 1366829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366833 */     // MIs[0] policy
     /* 1366833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366845 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1366845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1366848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366873 */     // GIR_Coverage, 14155,
     /* 1366873 */     GIR_EraseRootFromParent_Done,
     /* 1366874 */   // Label 19294: @1366874
     /* 1366874 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1366974), // Rule ID 14158 //
     /* 1366879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1366890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1366893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1366896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1366899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1366909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1366921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1366925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1366929 */     // MIs[1] Operand 1
     /* 1366929 */     // No operand predicates
     /* 1366929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366933 */     // MIs[0] policy
     /* 1366933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1366936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1366938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1366945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1366948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1366952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1366957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1366969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1366972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366973 */     // GIR_Coverage, 14158,
     /* 1366973 */     GIR_EraseRootFromParent_Done,
     /* 1366974 */   // Label 19295: @1366974
     /* 1366974 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1367074), // Rule ID 14159 //
     /* 1366979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1366987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1366990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1366993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1366996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1366999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1367009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367029 */     // MIs[1] Operand 1
     /* 1367029 */     // No operand predicates
     /* 1367029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367033 */     // MIs[0] policy
     /* 1367033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1367045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1367048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367073 */     // GIR_Coverage, 14159,
     /* 1367073 */     GIR_EraseRootFromParent_Done,
     /* 1367074 */   // Label 19296: @1367074
     /* 1367074 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1367174), // Rule ID 14162 //
     /* 1367079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1367087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1367090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1367093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1367096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1367099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1367109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367129 */     // MIs[1] Operand 1
     /* 1367129 */     // No operand predicates
     /* 1367129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367133 */     // MIs[0] policy
     /* 1367133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1367145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1367148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367173 */     // GIR_Coverage, 14162,
     /* 1367173 */     GIR_EraseRootFromParent_Done,
     /* 1367174 */   // Label 19297: @1367174
     /* 1367174 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1367274), // Rule ID 14163 //
     /* 1367179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1367182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1367187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1367190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1367193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1367196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1367199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1367209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367229 */     // MIs[1] Operand 1
     /* 1367229 */     // No operand predicates
     /* 1367229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367233 */     // MIs[0] policy
     /* 1367233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367245 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1367245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1367248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367273 */     // GIR_Coverage, 14163,
     /* 1367273 */     GIR_EraseRootFromParent_Done,
     /* 1367274 */   // Label 19298: @1367274
     /* 1367274 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1367374), // Rule ID 14166 //
     /* 1367279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1367287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1367290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1367293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1367296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1367299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1367309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367329 */     // MIs[1] Operand 1
     /* 1367329 */     // No operand predicates
     /* 1367329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367333 */     // MIs[0] policy
     /* 1367333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367345 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1367345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1367348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367373 */     // GIR_Coverage, 14166,
     /* 1367373 */     GIR_EraseRootFromParent_Done,
     /* 1367374 */   // Label 19299: @1367374
     /* 1367374 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1367474), // Rule ID 14167 //
     /* 1367379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1367382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1367387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1367390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1367393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1367396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1367399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1367409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367429 */     // MIs[1] Operand 1
     /* 1367429 */     // No operand predicates
     /* 1367429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367433 */     // MIs[0] policy
     /* 1367433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367445 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1367445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1367448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367473 */     // GIR_Coverage, 14167,
     /* 1367473 */     GIR_EraseRootFromParent_Done,
     /* 1367474 */   // Label 19300: @1367474
     /* 1367474 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1367574), // Rule ID 14346 //
     /* 1367479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1367490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1367493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1367496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1367499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367529 */     // MIs[1] Operand 1
     /* 1367529 */     // No operand predicates
     /* 1367529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367533 */     // MIs[0] policy
     /* 1367533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1367545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1367548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367573 */     // GIR_Coverage, 14346,
     /* 1367573 */     GIR_EraseRootFromParent_Done,
     /* 1367574 */   // Label 19301: @1367574
     /* 1367574 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1367674), // Rule ID 14347 //
     /* 1367579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1367590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1367593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1367596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1367599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367629 */     // MIs[1] Operand 1
     /* 1367629 */     // No operand predicates
     /* 1367629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367633 */     // MIs[0] policy
     /* 1367633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367645 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1367645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1367648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367673 */     // GIR_Coverage, 14347,
     /* 1367673 */     GIR_EraseRootFromParent_Done,
     /* 1367674 */   // Label 19302: @1367674
     /* 1367674 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1367774), // Rule ID 14350 //
     /* 1367679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1367690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1367693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1367696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1367699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367729 */     // MIs[1] Operand 1
     /* 1367729 */     // No operand predicates
     /* 1367729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367733 */     // MIs[0] policy
     /* 1367733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367745 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1367745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1367748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367773 */     // GIR_Coverage, 14350,
     /* 1367773 */     GIR_EraseRootFromParent_Done,
     /* 1367774 */   // Label 19303: @1367774
     /* 1367774 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1367874), // Rule ID 14351 //
     /* 1367779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1367790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1367793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1367796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1367799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367829 */     // MIs[1] Operand 1
     /* 1367829 */     // No operand predicates
     /* 1367829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367833 */     // MIs[0] policy
     /* 1367833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367845 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1367845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1367848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367873 */     // GIR_Coverage, 14351,
     /* 1367873 */     GIR_EraseRootFromParent_Done,
     /* 1367874 */   // Label 19304: @1367874
     /* 1367874 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1367974), // Rule ID 14354 //
     /* 1367879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1367890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1367893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1367896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1367899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1367921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1367925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1367929 */     // MIs[1] Operand 1
     /* 1367929 */     // No operand predicates
     /* 1367929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367933 */     // MIs[0] policy
     /* 1367933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1367936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1367938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367945 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1367945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1367948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1367952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1367957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1367969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1367972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367973 */     // GIR_Coverage, 14354,
     /* 1367973 */     GIR_EraseRootFromParent_Done,
     /* 1367974 */   // Label 19305: @1367974
     /* 1367974 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1368074), // Rule ID 14355 //
     /* 1367979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1367987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1367990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1367993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1367996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1367999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368029 */     // MIs[1] Operand 1
     /* 1368029 */     // No operand predicates
     /* 1368029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368033 */     // MIs[0] policy
     /* 1368033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368045 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1368045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1368048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368073 */     // GIR_Coverage, 14355,
     /* 1368073 */     GIR_EraseRootFromParent_Done,
     /* 1368074 */   // Label 19306: @1368074
     /* 1368074 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1368174), // Rule ID 14358 //
     /* 1368079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1368090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1368093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1368096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1368099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368129 */     // MIs[1] Operand 1
     /* 1368129 */     // No operand predicates
     /* 1368129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368133 */     // MIs[0] policy
     /* 1368133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368145 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1368145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1368148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368173 */     // GIR_Coverage, 14358,
     /* 1368173 */     GIR_EraseRootFromParent_Done,
     /* 1368174 */   // Label 19307: @1368174
     /* 1368174 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1368274), // Rule ID 14359 //
     /* 1368179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1368190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1368193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1368196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1368199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368229 */     // MIs[1] Operand 1
     /* 1368229 */     // No operand predicates
     /* 1368229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368233 */     // MIs[0] policy
     /* 1368233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368245 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1368245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1368248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368273 */     // GIR_Coverage, 14359,
     /* 1368273 */     GIR_EraseRootFromParent_Done,
     /* 1368274 */   // Label 19308: @1368274
     /* 1368274 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1368374), // Rule ID 14362 //
     /* 1368279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1368290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1368293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1368296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1368299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368329 */     // MIs[1] Operand 1
     /* 1368329 */     // No operand predicates
     /* 1368329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368333 */     // MIs[0] policy
     /* 1368333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368345 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1368345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1368348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368373 */     // GIR_Coverage, 14362,
     /* 1368373 */     GIR_EraseRootFromParent_Done,
     /* 1368374 */   // Label 19309: @1368374
     /* 1368374 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1368474), // Rule ID 14363 //
     /* 1368379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1368390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1368393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1368396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1368399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368429 */     // MIs[1] Operand 1
     /* 1368429 */     // No operand predicates
     /* 1368429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368433 */     // MIs[0] policy
     /* 1368433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1368445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1368448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368473 */     // GIR_Coverage, 14363,
     /* 1368473 */     GIR_EraseRootFromParent_Done,
     /* 1368474 */   // Label 19310: @1368474
     /* 1368474 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1368574), // Rule ID 14366 //
     /* 1368479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1368490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1368493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1368496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1368499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368529 */     // MIs[1] Operand 1
     /* 1368529 */     // No operand predicates
     /* 1368529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368533 */     // MIs[0] policy
     /* 1368533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368545 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1368545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1368548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368573 */     // GIR_Coverage, 14366,
     /* 1368573 */     GIR_EraseRootFromParent_Done,
     /* 1368574 */   // Label 19311: @1368574
     /* 1368574 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1368674), // Rule ID 14367 //
     /* 1368579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1368590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1368593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1368596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1368599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368629 */     // MIs[1] Operand 1
     /* 1368629 */     // No operand predicates
     /* 1368629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368633 */     // MIs[0] policy
     /* 1368633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368645 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1368645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1368648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368673 */     // GIR_Coverage, 14367,
     /* 1368673 */     GIR_EraseRootFromParent_Done,
     /* 1368674 */   // Label 19312: @1368674
     /* 1368674 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1368774), // Rule ID 14370 //
     /* 1368679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1368696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1368699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368729 */     // MIs[1] Operand 1
     /* 1368729 */     // No operand predicates
     /* 1368729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368733 */     // MIs[0] policy
     /* 1368733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1368745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1368748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368773 */     // GIR_Coverage, 14370,
     /* 1368773 */     GIR_EraseRootFromParent_Done,
     /* 1368774 */   // Label 19313: @1368774
     /* 1368774 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1368874), // Rule ID 14371 //
     /* 1368779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1368796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1368799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368829 */     // MIs[1] Operand 1
     /* 1368829 */     // No operand predicates
     /* 1368829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368833 */     // MIs[0] policy
     /* 1368833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1368845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1368848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368873 */     // GIR_Coverage, 14371,
     /* 1368873 */     GIR_EraseRootFromParent_Done,
     /* 1368874 */   // Label 19314: @1368874
     /* 1368874 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1368974), // Rule ID 14374 //
     /* 1368879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1368896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1368899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1368921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1368925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1368929 */     // MIs[1] Operand 1
     /* 1368929 */     // No operand predicates
     /* 1368929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368933 */     // MIs[0] policy
     /* 1368933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1368936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1368938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1368945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1368948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1368952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1368957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1368969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1368972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368973 */     // GIR_Coverage, 14374,
     /* 1368973 */     GIR_EraseRootFromParent_Done,
     /* 1368974 */   // Label 19315: @1368974
     /* 1368974 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1369074), // Rule ID 14375 //
     /* 1368979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1368987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1368996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1368999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369029 */     // MIs[1] Operand 1
     /* 1369029 */     // No operand predicates
     /* 1369029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369033 */     // MIs[0] policy
     /* 1369033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1369045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1369048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369073 */     // GIR_Coverage, 14375,
     /* 1369073 */     GIR_EraseRootFromParent_Done,
     /* 1369074 */   // Label 19316: @1369074
     /* 1369074 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1369174), // Rule ID 14378 //
     /* 1369079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1369099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369129 */     // MIs[1] Operand 1
     /* 1369129 */     // No operand predicates
     /* 1369129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369133 */     // MIs[0] policy
     /* 1369133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1369145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1369148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369173 */     // GIR_Coverage, 14378,
     /* 1369173 */     GIR_EraseRootFromParent_Done,
     /* 1369174 */   // Label 19317: @1369174
     /* 1369174 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1369274), // Rule ID 14379 //
     /* 1369179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1369199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369229 */     // MIs[1] Operand 1
     /* 1369229 */     // No operand predicates
     /* 1369229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369233 */     // MIs[0] policy
     /* 1369233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1369245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1369248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369273 */     // GIR_Coverage, 14379,
     /* 1369273 */     GIR_EraseRootFromParent_Done,
     /* 1369274 */   // Label 19318: @1369274
     /* 1369274 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1369374), // Rule ID 14382 //
     /* 1369279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1369296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1369299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369329 */     // MIs[1] Operand 1
     /* 1369329 */     // No operand predicates
     /* 1369329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369333 */     // MIs[0] policy
     /* 1369333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369345 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1369345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1369348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369373 */     // GIR_Coverage, 14382,
     /* 1369373 */     GIR_EraseRootFromParent_Done,
     /* 1369374 */   // Label 19319: @1369374
     /* 1369374 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1369474), // Rule ID 14383 //
     /* 1369379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1369396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1369399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369429 */     // MIs[1] Operand 1
     /* 1369429 */     // No operand predicates
     /* 1369429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369433 */     // MIs[0] policy
     /* 1369433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369445 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1369445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1369448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369473 */     // GIR_Coverage, 14383,
     /* 1369473 */     GIR_EraseRootFromParent_Done,
     /* 1369474 */   // Label 19320: @1369474
     /* 1369474 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1369574), // Rule ID 14386 //
     /* 1369479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1369490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1369493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1369496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1369499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1369502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1369509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369529 */     // MIs[1] Operand 1
     /* 1369529 */     // No operand predicates
     /* 1369529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369533 */     // MIs[0] policy
     /* 1369533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369545 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1369545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1369548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369573 */     // GIR_Coverage, 14386,
     /* 1369573 */     GIR_EraseRootFromParent_Done,
     /* 1369574 */   // Label 19321: @1369574
     /* 1369574 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1369674), // Rule ID 14387 //
     /* 1369579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1369590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1369593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1369596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1369599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1369602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1369609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369629 */     // MIs[1] Operand 1
     /* 1369629 */     // No operand predicates
     /* 1369629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369633 */     // MIs[0] policy
     /* 1369633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369645 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1369645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1369648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369673 */     // GIR_Coverage, 14387,
     /* 1369673 */     GIR_EraseRootFromParent_Done,
     /* 1369674 */   // Label 19322: @1369674
     /* 1369674 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1369774), // Rule ID 14390 //
     /* 1369679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1369690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1369693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1369696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1369699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1369702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1369709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369729 */     // MIs[1] Operand 1
     /* 1369729 */     // No operand predicates
     /* 1369729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369733 */     // MIs[0] policy
     /* 1369733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369745 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1369745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1369748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369773 */     // GIR_Coverage, 14390,
     /* 1369773 */     GIR_EraseRootFromParent_Done,
     /* 1369774 */   // Label 19323: @1369774
     /* 1369774 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1369874), // Rule ID 14391 //
     /* 1369779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1369790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1369793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1369796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1369799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1369802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1369809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369829 */     // MIs[1] Operand 1
     /* 1369829 */     // No operand predicates
     /* 1369829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369833 */     // MIs[0] policy
     /* 1369833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369845 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1369845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1369848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369873 */     // GIR_Coverage, 14391,
     /* 1369873 */     GIR_EraseRootFromParent_Done,
     /* 1369874 */   // Label 19324: @1369874
     /* 1369874 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1369974), // Rule ID 14394 //
     /* 1369879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1369890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1369893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1369896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1369899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1369902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1369909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1369921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1369925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1369929 */     // MIs[1] Operand 1
     /* 1369929 */     // No operand predicates
     /* 1369929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369933 */     // MIs[0] policy
     /* 1369933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1369936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1369938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369945 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1369945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1369948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1369952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1369957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1369969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1369972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369973 */     // GIR_Coverage, 14394,
     /* 1369973 */     GIR_EraseRootFromParent_Done,
     /* 1369974 */   // Label 19325: @1369974
     /* 1369974 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1370074), // Rule ID 14395 //
     /* 1369979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1369987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1369990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1369993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1369996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1369999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1370009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370029 */     // MIs[1] Operand 1
     /* 1370029 */     // No operand predicates
     /* 1370029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370033 */     // MIs[0] policy
     /* 1370033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370045 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1370045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1370048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370073 */     // GIR_Coverage, 14395,
     /* 1370073 */     GIR_EraseRootFromParent_Done,
     /* 1370074 */   // Label 19326: @1370074
     /* 1370074 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1370174), // Rule ID 14398 //
     /* 1370079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1370090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1370093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1370099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1370109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370129 */     // MIs[1] Operand 1
     /* 1370129 */     // No operand predicates
     /* 1370129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370133 */     // MIs[0] policy
     /* 1370133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370145 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1370145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1370148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370173 */     // GIR_Coverage, 14398,
     /* 1370173 */     GIR_EraseRootFromParent_Done,
     /* 1370174 */   // Label 19327: @1370174
     /* 1370174 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1370274), // Rule ID 14399 //
     /* 1370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1370190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1370193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1370199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1370209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370229 */     // MIs[1] Operand 1
     /* 1370229 */     // No operand predicates
     /* 1370229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370233 */     // MIs[0] policy
     /* 1370233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1370245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1370248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370273 */     // GIR_Coverage, 14399,
     /* 1370273 */     GIR_EraseRootFromParent_Done,
     /* 1370274 */   // Label 19328: @1370274
     /* 1370274 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1370374), // Rule ID 14402 //
     /* 1370279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1370290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1370293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1370299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1370309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370329 */     // MIs[1] Operand 1
     /* 1370329 */     // No operand predicates
     /* 1370329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370333 */     // MIs[0] policy
     /* 1370333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370345 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1370345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1370348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370373 */     // GIR_Coverage, 14402,
     /* 1370373 */     GIR_EraseRootFromParent_Done,
     /* 1370374 */   // Label 19329: @1370374
     /* 1370374 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1370474), // Rule ID 14403 //
     /* 1370379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1370390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1370393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1370399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1370409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370429 */     // MIs[1] Operand 1
     /* 1370429 */     // No operand predicates
     /* 1370429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370433 */     // MIs[0] policy
     /* 1370433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370445 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1370445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1370448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370473 */     // GIR_Coverage, 14403,
     /* 1370473 */     GIR_EraseRootFromParent_Done,
     /* 1370474 */   // Label 19330: @1370474
     /* 1370474 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1370574), // Rule ID 14406 //
     /* 1370479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1370490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1370493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1370496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1370499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1370509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370529 */     // MIs[1] Operand 1
     /* 1370529 */     // No operand predicates
     /* 1370529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370533 */     // MIs[0] policy
     /* 1370533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370545 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1370545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1370548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370573 */     // GIR_Coverage, 14406,
     /* 1370573 */     GIR_EraseRootFromParent_Done,
     /* 1370574 */   // Label 19331: @1370574
     /* 1370574 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1370674), // Rule ID 14407 //
     /* 1370579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1370590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1370593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1370596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1370599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1370609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370629 */     // MIs[1] Operand 1
     /* 1370629 */     // No operand predicates
     /* 1370629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370633 */     // MIs[0] policy
     /* 1370633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1370645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1370648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370673 */     // GIR_Coverage, 14407,
     /* 1370673 */     GIR_EraseRootFromParent_Done,
     /* 1370674 */   // Label 19332: @1370674
     /* 1370674 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1370774), // Rule ID 14410 //
     /* 1370679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1370690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1370693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1370696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1370699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1370709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370729 */     // MIs[1] Operand 1
     /* 1370729 */     // No operand predicates
     /* 1370729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370733 */     // MIs[0] policy
     /* 1370733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1370745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1370748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370773 */     // GIR_Coverage, 14410,
     /* 1370773 */     GIR_EraseRootFromParent_Done,
     /* 1370774 */   // Label 19333: @1370774
     /* 1370774 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1370874), // Rule ID 14411 //
     /* 1370779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1370790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1370793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1370796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1370799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1370809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370829 */     // MIs[1] Operand 1
     /* 1370829 */     // No operand predicates
     /* 1370829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370833 */     // MIs[0] policy
     /* 1370833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1370845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1370848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370873 */     // GIR_Coverage, 14411,
     /* 1370873 */     GIR_EraseRootFromParent_Done,
     /* 1370874 */   // Label 19334: @1370874
     /* 1370874 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1370974), // Rule ID 14414 //
     /* 1370879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1370890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1370893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1370896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1370899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1370909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1370921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1370925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1370929 */     // MIs[1] Operand 1
     /* 1370929 */     // No operand predicates
     /* 1370929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370933 */     // MIs[0] policy
     /* 1370933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1370936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1370938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370945 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1370945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1370948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1370952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1370957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1370969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1370972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370973 */     // GIR_Coverage, 14414,
     /* 1370973 */     GIR_EraseRootFromParent_Done,
     /* 1370974 */   // Label 19335: @1370974
     /* 1370974 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1371074), // Rule ID 14415 //
     /* 1370979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1370987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1370990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1370993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1370996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1370999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1371009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371029 */     // MIs[1] Operand 1
     /* 1371029 */     // No operand predicates
     /* 1371029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371033 */     // MIs[0] policy
     /* 1371033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371045 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1371045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1371048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371073 */     // GIR_Coverage, 14415,
     /* 1371073 */     GIR_EraseRootFromParent_Done,
     /* 1371074 */   // Label 19336: @1371074
     /* 1371074 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1371174), // Rule ID 14418 //
     /* 1371079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1371090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1371093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1371099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1371109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371129 */     // MIs[1] Operand 1
     /* 1371129 */     // No operand predicates
     /* 1371129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371133 */     // MIs[0] policy
     /* 1371133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371145 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1371145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1371148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371173 */     // GIR_Coverage, 14418,
     /* 1371173 */     GIR_EraseRootFromParent_Done,
     /* 1371174 */   // Label 19337: @1371174
     /* 1371174 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1371274), // Rule ID 14419 //
     /* 1371179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1371190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1371193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1371199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1371209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371229 */     // MIs[1] Operand 1
     /* 1371229 */     // No operand predicates
     /* 1371229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371233 */     // MIs[0] policy
     /* 1371233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1371245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1371248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371273 */     // GIR_Coverage, 14419,
     /* 1371273 */     GIR_EraseRootFromParent_Done,
     /* 1371274 */   // Label 19338: @1371274
     /* 1371274 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1371374), // Rule ID 14422 //
     /* 1371279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1371290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1371293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1371299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1371309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371329 */     // MIs[1] Operand 1
     /* 1371329 */     // No operand predicates
     /* 1371329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371333 */     // MIs[0] policy
     /* 1371333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1371345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1371348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371373 */     // GIR_Coverage, 14422,
     /* 1371373 */     GIR_EraseRootFromParent_Done,
     /* 1371374 */   // Label 19339: @1371374
     /* 1371374 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1371474), // Rule ID 14423 //
     /* 1371379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1371390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1371393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1371399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1371409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371429 */     // MIs[1] Operand 1
     /* 1371429 */     // No operand predicates
     /* 1371429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371433 */     // MIs[0] policy
     /* 1371433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1371445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1371448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371473 */     // GIR_Coverage, 14423,
     /* 1371473 */     GIR_EraseRootFromParent_Done,
     /* 1371474 */   // Label 19340: @1371474
     /* 1371474 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1371574), // Rule ID 14426 //
     /* 1371479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1371490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1371493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1371499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1371509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371529 */     // MIs[1] Operand 1
     /* 1371529 */     // No operand predicates
     /* 1371529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371533 */     // MIs[0] policy
     /* 1371533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371545 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1371545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1371548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371573 */     // GIR_Coverage, 14426,
     /* 1371573 */     GIR_EraseRootFromParent_Done,
     /* 1371574 */   // Label 19341: @1371574
     /* 1371574 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1371674), // Rule ID 14427 //
     /* 1371579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1371590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1371593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1371599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1371609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371629 */     // MIs[1] Operand 1
     /* 1371629 */     // No operand predicates
     /* 1371629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371633 */     // MIs[0] policy
     /* 1371633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371645 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1371645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1371648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371673 */     // GIR_Coverage, 14427,
     /* 1371673 */     GIR_EraseRootFromParent_Done,
     /* 1371674 */   // Label 19342: @1371674
     /* 1371674 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1371774), // Rule ID 14430 //
     /* 1371679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1371690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1371693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1371696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1371699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1371709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371729 */     // MIs[1] Operand 1
     /* 1371729 */     // No operand predicates
     /* 1371729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371733 */     // MIs[0] policy
     /* 1371733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371745 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1371745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1371748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371773 */     // GIR_Coverage, 14430,
     /* 1371773 */     GIR_EraseRootFromParent_Done,
     /* 1371774 */   // Label 19343: @1371774
     /* 1371774 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1371874), // Rule ID 14431 //
     /* 1371779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1371787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1371790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1371793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1371796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1371799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1371809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1371829 */     // MIs[1] Operand 1
     /* 1371829 */     // No operand predicates
     /* 1371829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371833 */     // MIs[0] policy
     /* 1371833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371845 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1371845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1371848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1371852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1371872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371873 */     // GIR_Coverage, 14431,
     /* 1371873 */     GIR_EraseRootFromParent_Done,
     /* 1371874 */   // Label 19344: @1371874
     /* 1371874 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1371971), // Rule ID 23550 //
     /* 1371879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1371887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1371890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1371893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1371896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1371899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1371902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1371921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1371925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1371929 */     // MIs[1] Operand 1
     /* 1371929 */     // No operand predicates
     /* 1371929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371933 */     // MIs[0] policy
     /* 1371933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1371936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1371938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371945 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1371945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1371948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1371957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1371969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371970 */     // GIR_Coverage, 23550,
     /* 1371970 */     GIR_EraseRootFromParent_Done,
     /* 1371971 */   // Label 19345: @1371971
     /* 1371971 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1372068), // Rule ID 23551 //
     /* 1371976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1371984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1371987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1371990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1371993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1371996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1371999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372026 */     // MIs[1] Operand 1
     /* 1372026 */     // No operand predicates
     /* 1372026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372030 */     // MIs[0] policy
     /* 1372030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372042 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1372042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1372045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372067 */     // GIR_Coverage, 23551,
     /* 1372067 */     GIR_EraseRootFromParent_Done,
     /* 1372068 */   // Label 19346: @1372068
     /* 1372068 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1372165), // Rule ID 23554 //
     /* 1372073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1372084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1372087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1372093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372123 */     // MIs[1] Operand 1
     /* 1372123 */     // No operand predicates
     /* 1372123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372127 */     // MIs[0] policy
     /* 1372127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1372139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1372142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372164 */     // GIR_Coverage, 23554,
     /* 1372164 */     GIR_EraseRootFromParent_Done,
     /* 1372165 */   // Label 19347: @1372165
     /* 1372165 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1372262), // Rule ID 23555 //
     /* 1372170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1372181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1372184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1372190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372220 */     // MIs[1] Operand 1
     /* 1372220 */     // No operand predicates
     /* 1372220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372224 */     // MIs[0] policy
     /* 1372224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1372236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1372239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372261 */     // GIR_Coverage, 23555,
     /* 1372261 */     GIR_EraseRootFromParent_Done,
     /* 1372262 */   // Label 19348: @1372262
     /* 1372262 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1372359), // Rule ID 23558 //
     /* 1372267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1372278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1372281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1372287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372317 */     // MIs[1] Operand 1
     /* 1372317 */     // No operand predicates
     /* 1372317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372321 */     // MIs[0] policy
     /* 1372321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372333 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1372333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1372336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372358 */     // GIR_Coverage, 23558,
     /* 1372358 */     GIR_EraseRootFromParent_Done,
     /* 1372359 */   // Label 19349: @1372359
     /* 1372359 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1372456), // Rule ID 23559 //
     /* 1372364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1372375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1372378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1372384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372414 */     // MIs[1] Operand 1
     /* 1372414 */     // No operand predicates
     /* 1372414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372418 */     // MIs[0] policy
     /* 1372418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1372430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1372433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372455 */     // GIR_Coverage, 23559,
     /* 1372455 */     GIR_EraseRootFromParent_Done,
     /* 1372456 */   // Label 19350: @1372456
     /* 1372456 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1372553), // Rule ID 23562 //
     /* 1372461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1372472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1372475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1372481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372511 */     // MIs[1] Operand 1
     /* 1372511 */     // No operand predicates
     /* 1372511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372515 */     // MIs[0] policy
     /* 1372515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372527 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1372527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1372530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372552 */     // GIR_Coverage, 23562,
     /* 1372552 */     GIR_EraseRootFromParent_Done,
     /* 1372553 */   // Label 19351: @1372553
     /* 1372553 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1372650), // Rule ID 23563 //
     /* 1372558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1372569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1372572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1372578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372608 */     // MIs[1] Operand 1
     /* 1372608 */     // No operand predicates
     /* 1372608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372612 */     // MIs[0] policy
     /* 1372612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1372624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1372627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372649 */     // GIR_Coverage, 23563,
     /* 1372649 */     GIR_EraseRootFromParent_Done,
     /* 1372650 */   // Label 19352: @1372650
     /* 1372650 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1372747), // Rule ID 23566 //
     /* 1372655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1372666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1372669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1372675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372705 */     // MIs[1] Operand 1
     /* 1372705 */     // No operand predicates
     /* 1372705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372709 */     // MIs[0] policy
     /* 1372709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372721 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1372721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1372724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372746 */     // GIR_Coverage, 23566,
     /* 1372746 */     GIR_EraseRootFromParent_Done,
     /* 1372747 */   // Label 19353: @1372747
     /* 1372747 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1372844), // Rule ID 23567 //
     /* 1372752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1372763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1372766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1372772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372802 */     // MIs[1] Operand 1
     /* 1372802 */     // No operand predicates
     /* 1372802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372806 */     // MIs[0] policy
     /* 1372806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1372818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1372821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372843 */     // GIR_Coverage, 23567,
     /* 1372843 */     GIR_EraseRootFromParent_Done,
     /* 1372844 */   // Label 19354: @1372844
     /* 1372844 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1372941), // Rule ID 23570 //
     /* 1372849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1372860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1372863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1372866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1372869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372899 */     // MIs[1] Operand 1
     /* 1372899 */     // No operand predicates
     /* 1372899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372903 */     // MIs[0] policy
     /* 1372903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1372906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1372908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1372915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1372918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1372927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1372939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372940 */     // GIR_Coverage, 23570,
     /* 1372940 */     GIR_EraseRootFromParent_Done,
     /* 1372941 */   // Label 19355: @1372941
     /* 1372941 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1373038), // Rule ID 23571 //
     /* 1372946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1372954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1372957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1372960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1372963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1372966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1372988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1372992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1372996 */     // MIs[1] Operand 1
     /* 1372996 */     // No operand predicates
     /* 1372996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373000 */     // MIs[0] policy
     /* 1373000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1373015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373037 */     // GIR_Coverage, 23571,
     /* 1373037 */     GIR_EraseRootFromParent_Done,
     /* 1373038 */   // Label 19356: @1373038
     /* 1373038 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1373135), // Rule ID 23574 //
     /* 1373043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1373063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373093 */     // MIs[1] Operand 1
     /* 1373093 */     // No operand predicates
     /* 1373093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373097 */     // MIs[0] policy
     /* 1373097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373109 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1373109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373134 */     // GIR_Coverage, 23574,
     /* 1373134 */     GIR_EraseRootFromParent_Done,
     /* 1373135 */   // Label 19357: @1373135
     /* 1373135 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1373232), // Rule ID 23575 //
     /* 1373140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1373160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373190 */     // MIs[1] Operand 1
     /* 1373190 */     // No operand predicates
     /* 1373190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373194 */     // MIs[0] policy
     /* 1373194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373231 */     // GIR_Coverage, 23575,
     /* 1373231 */     GIR_EraseRootFromParent_Done,
     /* 1373232 */   // Label 19358: @1373232
     /* 1373232 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1373329), // Rule ID 23578 //
     /* 1373237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1373257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373287 */     // MIs[1] Operand 1
     /* 1373287 */     // No operand predicates
     /* 1373287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373291 */     // MIs[0] policy
     /* 1373291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373303 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1373303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373328 */     // GIR_Coverage, 23578,
     /* 1373328 */     GIR_EraseRootFromParent_Done,
     /* 1373329 */   // Label 19359: @1373329
     /* 1373329 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1373426), // Rule ID 23579 //
     /* 1373334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1373354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373384 */     // MIs[1] Operand 1
     /* 1373384 */     // No operand predicates
     /* 1373384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373388 */     // MIs[0] policy
     /* 1373388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373425 */     // GIR_Coverage, 23579,
     /* 1373425 */     GIR_EraseRootFromParent_Done,
     /* 1373426 */   // Label 19360: @1373426
     /* 1373426 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1373523), // Rule ID 23582 //
     /* 1373431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1373451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373481 */     // MIs[1] Operand 1
     /* 1373481 */     // No operand predicates
     /* 1373481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373485 */     // MIs[0] policy
     /* 1373485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373497 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1373497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373522 */     // GIR_Coverage, 23582,
     /* 1373522 */     GIR_EraseRootFromParent_Done,
     /* 1373523 */   // Label 19361: @1373523
     /* 1373523 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1373620), // Rule ID 23583 //
     /* 1373528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1373548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373578 */     // MIs[1] Operand 1
     /* 1373578 */     // No operand predicates
     /* 1373578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373582 */     // MIs[0] policy
     /* 1373582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373619 */     // GIR_Coverage, 23583,
     /* 1373619 */     GIR_EraseRootFromParent_Done,
     /* 1373620 */   // Label 19362: @1373620
     /* 1373620 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1373717), // Rule ID 23586 //
     /* 1373625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1373645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373675 */     // MIs[1] Operand 1
     /* 1373675 */     // No operand predicates
     /* 1373675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373679 */     // MIs[0] policy
     /* 1373679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1373691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373716 */     // GIR_Coverage, 23586,
     /* 1373716 */     GIR_EraseRootFromParent_Done,
     /* 1373717 */   // Label 19363: @1373717
     /* 1373717 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1373814), // Rule ID 23587 //
     /* 1373722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1373742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373772 */     // MIs[1] Operand 1
     /* 1373772 */     // No operand predicates
     /* 1373772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373776 */     // MIs[0] policy
     /* 1373776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1373791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373813 */     // GIR_Coverage, 23587,
     /* 1373813 */     GIR_EraseRootFromParent_Done,
     /* 1373814 */   // Label 19364: @1373814
     /* 1373814 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1373911), // Rule ID 23590 //
     /* 1373819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1373830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1373833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1373839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1373849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373869 */     // MIs[1] Operand 1
     /* 1373869 */     // No operand predicates
     /* 1373869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373873 */     // MIs[0] policy
     /* 1373873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373885 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1373885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1373888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1373909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373910 */     // GIR_Coverage, 23590,
     /* 1373910 */     GIR_EraseRootFromParent_Done,
     /* 1373911 */   // Label 19365: @1373911
     /* 1373911 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1374008), // Rule ID 23591 //
     /* 1373916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1373924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1373927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1373930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1373936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1373946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1373958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1373962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1373966 */     // MIs[1] Operand 1
     /* 1373966 */     // No operand predicates
     /* 1373966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373970 */     // MIs[0] policy
     /* 1373970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1373973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1373975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1373982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1373985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1373994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374007 */     // GIR_Coverage, 23591,
     /* 1374007 */     GIR_EraseRootFromParent_Done,
     /* 1374008 */   // Label 19366: @1374008
     /* 1374008 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1374105), // Rule ID 23594 //
     /* 1374013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1374024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1374027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1374033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1374043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374063 */     // MIs[1] Operand 1
     /* 1374063 */     // No operand predicates
     /* 1374063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374067 */     // MIs[0] policy
     /* 1374067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374079 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1374079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1374082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374104 */     // GIR_Coverage, 23594,
     /* 1374104 */     GIR_EraseRootFromParent_Done,
     /* 1374105 */   // Label 19367: @1374105
     /* 1374105 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1374202), // Rule ID 23595 //
     /* 1374110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1374121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1374124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1374130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1374140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374160 */     // MIs[1] Operand 1
     /* 1374160 */     // No operand predicates
     /* 1374160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374164 */     // MIs[0] policy
     /* 1374164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1374176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1374179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374201 */     // GIR_Coverage, 23595,
     /* 1374201 */     GIR_EraseRootFromParent_Done,
     /* 1374202 */   // Label 19368: @1374202
     /* 1374202 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1374299), // Rule ID 23598 //
     /* 1374207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1374218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1374221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1374227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1374237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374257 */     // MIs[1] Operand 1
     /* 1374257 */     // No operand predicates
     /* 1374257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374261 */     // MIs[0] policy
     /* 1374261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374273 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1374273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1374276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374298 */     // GIR_Coverage, 23598,
     /* 1374298 */     GIR_EraseRootFromParent_Done,
     /* 1374299 */   // Label 19369: @1374299
     /* 1374299 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1374396), // Rule ID 23599 //
     /* 1374304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1374315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1374318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1374324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1374334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374354 */     // MIs[1] Operand 1
     /* 1374354 */     // No operand predicates
     /* 1374354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374358 */     // MIs[0] policy
     /* 1374358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374370 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1374370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1374373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374395 */     // GIR_Coverage, 23599,
     /* 1374395 */     GIR_EraseRootFromParent_Done,
     /* 1374396 */   // Label 19370: @1374396
     /* 1374396 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1374493), // Rule ID 23602 //
     /* 1374401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1374412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1374415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1374421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1374431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374451 */     // MIs[1] Operand 1
     /* 1374451 */     // No operand predicates
     /* 1374451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374455 */     // MIs[0] policy
     /* 1374455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1374467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1374470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374492 */     // GIR_Coverage, 23602,
     /* 1374492 */     GIR_EraseRootFromParent_Done,
     /* 1374493 */   // Label 19371: @1374493
     /* 1374493 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1374590), // Rule ID 23603 //
     /* 1374498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1374509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1374512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1374518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1374528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374548 */     // MIs[1] Operand 1
     /* 1374548 */     // No operand predicates
     /* 1374548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374552 */     // MIs[0] policy
     /* 1374552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1374564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1374567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374589 */     // GIR_Coverage, 23603,
     /* 1374589 */     GIR_EraseRootFromParent_Done,
     /* 1374590 */   // Label 19372: @1374590
     /* 1374590 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1374687), // Rule ID 23606 //
     /* 1374595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1374606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1374609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1374615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1374625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374645 */     // MIs[1] Operand 1
     /* 1374645 */     // No operand predicates
     /* 1374645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374649 */     // MIs[0] policy
     /* 1374649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374661 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1374661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1374664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374686 */     // GIR_Coverage, 23606,
     /* 1374686 */     GIR_EraseRootFromParent_Done,
     /* 1374687 */   // Label 19373: @1374687
     /* 1374687 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1374784), // Rule ID 23607 //
     /* 1374692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1374703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1374706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1374712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1374722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374742 */     // MIs[1] Operand 1
     /* 1374742 */     // No operand predicates
     /* 1374742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374746 */     // MIs[0] policy
     /* 1374746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1374758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1374761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374783 */     // GIR_Coverage, 23607,
     /* 1374783 */     GIR_EraseRootFromParent_Done,
     /* 1374784 */   // Label 19374: @1374784
     /* 1374784 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1374881), // Rule ID 23610 //
     /* 1374789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1374800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1374803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1374809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1374819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374839 */     // MIs[1] Operand 1
     /* 1374839 */     // No operand predicates
     /* 1374839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374843 */     // MIs[0] policy
     /* 1374843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374855 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1374855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1374858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374880 */     // GIR_Coverage, 23610,
     /* 1374880 */     GIR_EraseRootFromParent_Done,
     /* 1374881 */   // Label 19375: @1374881
     /* 1374881 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1374978), // Rule ID 23611 //
     /* 1374886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1374897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1374900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1374906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1374916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1374928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1374932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1374936 */     // MIs[1] Operand 1
     /* 1374936 */     // No operand predicates
     /* 1374936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374940 */     // MIs[0] policy
     /* 1374940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1374943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1374952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1374955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1374964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1374976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374977 */     // GIR_Coverage, 23611,
     /* 1374977 */     GIR_EraseRootFromParent_Done,
     /* 1374978 */   // Label 19376: @1374978
     /* 1374978 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1375075), // Rule ID 23614 //
     /* 1374983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1374991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1374994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1374997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1375013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375033 */     // MIs[1] Operand 1
     /* 1375033 */     // No operand predicates
     /* 1375033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375037 */     // MIs[0] policy
     /* 1375037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1375049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1375052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375074 */     // GIR_Coverage, 23614,
     /* 1375074 */     GIR_EraseRootFromParent_Done,
     /* 1375075 */   // Label 19377: @1375075
     /* 1375075 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1375172), // Rule ID 23615 //
     /* 1375080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1375091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1375094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1375100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1375110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375130 */     // MIs[1] Operand 1
     /* 1375130 */     // No operand predicates
     /* 1375130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375134 */     // MIs[0] policy
     /* 1375134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1375146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1375149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375171 */     // GIR_Coverage, 23615,
     /* 1375171 */     GIR_EraseRootFromParent_Done,
     /* 1375172 */   // Label 19378: @1375172
     /* 1375172 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1375269), // Rule ID 23618 //
     /* 1375177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1375188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1375191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1375207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375227 */     // MIs[1] Operand 1
     /* 1375227 */     // No operand predicates
     /* 1375227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375231 */     // MIs[0] policy
     /* 1375231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1375243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1375246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375268 */     // GIR_Coverage, 23618,
     /* 1375268 */     GIR_EraseRootFromParent_Done,
     /* 1375269 */   // Label 19379: @1375269
     /* 1375269 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1375366), // Rule ID 23619 //
     /* 1375274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1375285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1375288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1375294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1375304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375324 */     // MIs[1] Operand 1
     /* 1375324 */     // No operand predicates
     /* 1375324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375328 */     // MIs[0] policy
     /* 1375328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1375340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1375343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375365 */     // GIR_Coverage, 23619,
     /* 1375365 */     GIR_EraseRootFromParent_Done,
     /* 1375366 */   // Label 19380: @1375366
     /* 1375366 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1375463), // Rule ID 23622 //
     /* 1375371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1375382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1375385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1375401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375421 */     // MIs[1] Operand 1
     /* 1375421 */     // No operand predicates
     /* 1375421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375425 */     // MIs[0] policy
     /* 1375425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375437 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1375437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1375440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375462 */     // GIR_Coverage, 23622,
     /* 1375462 */     GIR_EraseRootFromParent_Done,
     /* 1375463 */   // Label 19381: @1375463
     /* 1375463 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1375560), // Rule ID 23623 //
     /* 1375468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1375479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1375482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1375488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1375498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375518 */     // MIs[1] Operand 1
     /* 1375518 */     // No operand predicates
     /* 1375518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375522 */     // MIs[0] policy
     /* 1375522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1375534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1375537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375559 */     // GIR_Coverage, 23623,
     /* 1375559 */     GIR_EraseRootFromParent_Done,
     /* 1375560 */   // Label 19382: @1375560
     /* 1375560 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1375657), // Rule ID 23626 //
     /* 1375565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1375576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1375579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1375595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375615 */     // MIs[1] Operand 1
     /* 1375615 */     // No operand predicates
     /* 1375615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375619 */     // MIs[0] policy
     /* 1375619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1375631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1375634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375656 */     // GIR_Coverage, 23626,
     /* 1375656 */     GIR_EraseRootFromParent_Done,
     /* 1375657 */   // Label 19383: @1375657
     /* 1375657 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1375754), // Rule ID 23627 //
     /* 1375662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1375673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1375676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1375682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1375692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375712 */     // MIs[1] Operand 1
     /* 1375712 */     // No operand predicates
     /* 1375712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375716 */     // MIs[0] policy
     /* 1375716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1375728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1375731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375753 */     // GIR_Coverage, 23627,
     /* 1375753 */     GIR_EraseRootFromParent_Done,
     /* 1375754 */   // Label 19384: @1375754
     /* 1375754 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1375851), // Rule ID 23630 //
     /* 1375759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1375770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1375773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1375789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375809 */     // MIs[1] Operand 1
     /* 1375809 */     // No operand predicates
     /* 1375809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375813 */     // MIs[0] policy
     /* 1375813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375825 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1375825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1375828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375850 */     // GIR_Coverage, 23630,
     /* 1375850 */     GIR_EraseRootFromParent_Done,
     /* 1375851 */   // Label 19385: @1375851
     /* 1375851 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1375948), // Rule ID 23631 //
     /* 1375856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1375867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1375870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1375876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1375886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1375906 */     // MIs[1] Operand 1
     /* 1375906 */     // No operand predicates
     /* 1375906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375910 */     // MIs[0] policy
     /* 1375910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1375913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1375915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1375922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1375925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1375934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1375946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375947 */     // GIR_Coverage, 23631,
     /* 1375947 */     GIR_EraseRootFromParent_Done,
     /* 1375948 */   // Label 19386: @1375948
     /* 1375948 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1376045), // Rule ID 23634 //
     /* 1375953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1375961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1375964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1375967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1375973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1375983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1375995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1375999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376003 */     // MIs[1] Operand 1
     /* 1376003 */     // No operand predicates
     /* 1376003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376007 */     // MIs[0] policy
     /* 1376007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1376022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376044 */     // GIR_Coverage, 23634,
     /* 1376044 */     GIR_EraseRootFromParent_Done,
     /* 1376045 */   // Label 19387: @1376045
     /* 1376045 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1376142), // Rule ID 23635 //
     /* 1376050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1376058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1376061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1376064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1376070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1376080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376100 */     // MIs[1] Operand 1
     /* 1376100 */     // No operand predicates
     /* 1376100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376104 */     // MIs[0] policy
     /* 1376104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1376116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1376119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376141 */     // GIR_Coverage, 23635,
     /* 1376141 */     GIR_EraseRootFromParent_Done,
     /* 1376142 */   // Label 19388: @1376142
     /* 1376142 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1376239), // Rule ID 23726 //
     /* 1376147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1376158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1376161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1376167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376197 */     // MIs[1] Operand 1
     /* 1376197 */     // No operand predicates
     /* 1376197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376201 */     // MIs[0] policy
     /* 1376201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376213 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1376216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376238 */     // GIR_Coverage, 23726,
     /* 1376238 */     GIR_EraseRootFromParent_Done,
     /* 1376239 */   // Label 19389: @1376239
     /* 1376239 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1376336), // Rule ID 23727 //
     /* 1376244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1376255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1376258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1376264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376294 */     // MIs[1] Operand 1
     /* 1376294 */     // No operand predicates
     /* 1376294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376298 */     // MIs[0] policy
     /* 1376298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376310 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1376310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1376313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376335 */     // GIR_Coverage, 23727,
     /* 1376335 */     GIR_EraseRootFromParent_Done,
     /* 1376336 */   // Label 19390: @1376336
     /* 1376336 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1376433), // Rule ID 23730 //
     /* 1376341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1376352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1376355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1376361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376391 */     // MIs[1] Operand 1
     /* 1376391 */     // No operand predicates
     /* 1376391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376395 */     // MIs[0] policy
     /* 1376395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376407 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1376410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376432 */     // GIR_Coverage, 23730,
     /* 1376432 */     GIR_EraseRootFromParent_Done,
     /* 1376433 */   // Label 19391: @1376433
     /* 1376433 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1376530), // Rule ID 23731 //
     /* 1376438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1376449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1376452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1376458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376488 */     // MIs[1] Operand 1
     /* 1376488 */     // No operand predicates
     /* 1376488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376492 */     // MIs[0] policy
     /* 1376492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376504 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1376504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1376507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376529 */     // GIR_Coverage, 23731,
     /* 1376529 */     GIR_EraseRootFromParent_Done,
     /* 1376530 */   // Label 19392: @1376530
     /* 1376530 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1376627), // Rule ID 23734 //
     /* 1376535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1376546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1376549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1376555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376585 */     // MIs[1] Operand 1
     /* 1376585 */     // No operand predicates
     /* 1376585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376589 */     // MIs[0] policy
     /* 1376589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376601 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1376604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376626 */     // GIR_Coverage, 23734,
     /* 1376626 */     GIR_EraseRootFromParent_Done,
     /* 1376627 */   // Label 19393: @1376627
     /* 1376627 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1376724), // Rule ID 23735 //
     /* 1376632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1376643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1376646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1376652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376682 */     // MIs[1] Operand 1
     /* 1376682 */     // No operand predicates
     /* 1376682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376686 */     // MIs[0] policy
     /* 1376686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1376698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1376701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376723 */     // GIR_Coverage, 23735,
     /* 1376723 */     GIR_EraseRootFromParent_Done,
     /* 1376724 */   // Label 19394: @1376724
     /* 1376724 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1376821), // Rule ID 23738 //
     /* 1376729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1376740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1376743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1376749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376779 */     // MIs[1] Operand 1
     /* 1376779 */     // No operand predicates
     /* 1376779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376783 */     // MIs[0] policy
     /* 1376783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376795 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1376798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376820 */     // GIR_Coverage, 23738,
     /* 1376820 */     GIR_EraseRootFromParent_Done,
     /* 1376821 */   // Label 19395: @1376821
     /* 1376821 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1376918), // Rule ID 23739 //
     /* 1376826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1376837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1376840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1376846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376876 */     // MIs[1] Operand 1
     /* 1376876 */     // No operand predicates
     /* 1376876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376880 */     // MIs[0] policy
     /* 1376880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1376892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1376895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1376904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1376916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376917 */     // GIR_Coverage, 23739,
     /* 1376917 */     GIR_EraseRootFromParent_Done,
     /* 1376918 */   // Label 19396: @1376918
     /* 1376918 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1377015), // Rule ID 23742 //
     /* 1376923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1376931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1376934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1376937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1376943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1376965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1376969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1376973 */     // MIs[1] Operand 1
     /* 1376973 */     // No operand predicates
     /* 1376973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376977 */     // MIs[0] policy
     /* 1376977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1376980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1376982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376989 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1376989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1376992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377014 */     // GIR_Coverage, 23742,
     /* 1377014 */     GIR_EraseRootFromParent_Done,
     /* 1377015 */   // Label 19397: @1377015
     /* 1377015 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1377112), // Rule ID 23743 //
     /* 1377020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1377031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1377034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1377040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377070 */     // MIs[1] Operand 1
     /* 1377070 */     // No operand predicates
     /* 1377070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377074 */     // MIs[0] policy
     /* 1377074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1377086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1377089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377111 */     // GIR_Coverage, 23743,
     /* 1377111 */     GIR_EraseRootFromParent_Done,
     /* 1377112 */   // Label 19398: @1377112
     /* 1377112 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1377209), // Rule ID 23746 //
     /* 1377117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1377128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1377131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1377137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377167 */     // MIs[1] Operand 1
     /* 1377167 */     // No operand predicates
     /* 1377167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377171 */     // MIs[0] policy
     /* 1377171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1377183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1377186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377208 */     // GIR_Coverage, 23746,
     /* 1377208 */     GIR_EraseRootFromParent_Done,
     /* 1377209 */   // Label 19399: @1377209
     /* 1377209 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1377306), // Rule ID 23747 //
     /* 1377214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1377225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1377228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1377234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377264 */     // MIs[1] Operand 1
     /* 1377264 */     // No operand predicates
     /* 1377264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377268 */     // MIs[0] policy
     /* 1377268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377305 */     // GIR_Coverage, 23747,
     /* 1377305 */     GIR_EraseRootFromParent_Done,
     /* 1377306 */   // Label 19400: @1377306
     /* 1377306 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1377403), // Rule ID 23750 //
     /* 1377311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1377331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377361 */     // MIs[1] Operand 1
     /* 1377361 */     // No operand predicates
     /* 1377361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377365 */     // MIs[0] policy
     /* 1377365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1377377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377402 */     // GIR_Coverage, 23750,
     /* 1377402 */     GIR_EraseRootFromParent_Done,
     /* 1377403 */   // Label 19401: @1377403
     /* 1377403 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1377500), // Rule ID 23751 //
     /* 1377408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1377428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377458 */     // MIs[1] Operand 1
     /* 1377458 */     // No operand predicates
     /* 1377458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377462 */     // MIs[0] policy
     /* 1377462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1377474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377499 */     // GIR_Coverage, 23751,
     /* 1377499 */     GIR_EraseRootFromParent_Done,
     /* 1377500 */   // Label 19402: @1377500
     /* 1377500 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1377597), // Rule ID 23754 //
     /* 1377505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1377525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377555 */     // MIs[1] Operand 1
     /* 1377555 */     // No operand predicates
     /* 1377555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377559 */     // MIs[0] policy
     /* 1377559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377571 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1377571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377596 */     // GIR_Coverage, 23754,
     /* 1377596 */     GIR_EraseRootFromParent_Done,
     /* 1377597 */   // Label 19403: @1377597
     /* 1377597 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1377694), // Rule ID 23755 //
     /* 1377602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1377622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377652 */     // MIs[1] Operand 1
     /* 1377652 */     // No operand predicates
     /* 1377652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377656 */     // MIs[0] policy
     /* 1377656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1377668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377693 */     // GIR_Coverage, 23755,
     /* 1377693 */     GIR_EraseRootFromParent_Done,
     /* 1377694 */   // Label 19404: @1377694
     /* 1377694 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1377791), // Rule ID 23758 //
     /* 1377699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1377719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377749 */     // MIs[1] Operand 1
     /* 1377749 */     // No operand predicates
     /* 1377749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377753 */     // MIs[0] policy
     /* 1377753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1377765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377790 */     // GIR_Coverage, 23758,
     /* 1377790 */     GIR_EraseRootFromParent_Done,
     /* 1377791 */   // Label 19405: @1377791
     /* 1377791 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1377888), // Rule ID 23759 //
     /* 1377796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1377816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377846 */     // MIs[1] Operand 1
     /* 1377846 */     // No operand predicates
     /* 1377846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377850 */     // MIs[0] policy
     /* 1377850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1377862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377887 */     // GIR_Coverage, 23759,
     /* 1377887 */     GIR_EraseRootFromParent_Done,
     /* 1377888 */   // Label 19406: @1377888
     /* 1377888 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1377985), // Rule ID 23762 //
     /* 1377893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1377913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1377935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1377939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1377943 */     // MIs[1] Operand 1
     /* 1377943 */     // No operand predicates
     /* 1377943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377947 */     // MIs[0] policy
     /* 1377947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1377950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1377952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377959 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1377959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1377962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1377971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1377983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377984 */     // GIR_Coverage, 23762,
     /* 1377984 */     GIR_EraseRootFromParent_Done,
     /* 1377985 */   // Label 19407: @1377985
     /* 1377985 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1378082), // Rule ID 23763 //
     /* 1377990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1377998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1378001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1378004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1378007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378040 */     // MIs[1] Operand 1
     /* 1378040 */     // No operand predicates
     /* 1378040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378044 */     // MIs[0] policy
     /* 1378044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1378056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1378059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1378078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378081 */     // GIR_Coverage, 23763,
     /* 1378081 */     GIR_EraseRootFromParent_Done,
     /* 1378082 */   // Label 19408: @1378082
     /* 1378082 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1378179), // Rule ID 23766 //
     /* 1378087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1378098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1378101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1378107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1378117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378137 */     // MIs[1] Operand 1
     /* 1378137 */     // No operand predicates
     /* 1378137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378141 */     // MIs[0] policy
     /* 1378141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378153 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1378153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1378156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378178 */     // GIR_Coverage, 23766,
     /* 1378178 */     GIR_EraseRootFromParent_Done,
     /* 1378179 */   // Label 19409: @1378179
     /* 1378179 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1378276), // Rule ID 23767 //
     /* 1378184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1378195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1378198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1378214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378234 */     // MIs[1] Operand 1
     /* 1378234 */     // No operand predicates
     /* 1378234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378238 */     // MIs[0] policy
     /* 1378238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1378250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1378253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378275 */     // GIR_Coverage, 23767,
     /* 1378275 */     GIR_EraseRootFromParent_Done,
     /* 1378276 */   // Label 19410: @1378276
     /* 1378276 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1378373), // Rule ID 23770 //
     /* 1378281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1378292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1378295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1378301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1378311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378331 */     // MIs[1] Operand 1
     /* 1378331 */     // No operand predicates
     /* 1378331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378335 */     // MIs[0] policy
     /* 1378335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378347 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1378347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1378350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378372 */     // GIR_Coverage, 23770,
     /* 1378372 */     GIR_EraseRootFromParent_Done,
     /* 1378373 */   // Label 19411: @1378373
     /* 1378373 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1378470), // Rule ID 23771 //
     /* 1378378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1378389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1378392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1378408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378428 */     // MIs[1] Operand 1
     /* 1378428 */     // No operand predicates
     /* 1378428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378432 */     // MIs[0] policy
     /* 1378432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1378444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1378447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378469 */     // GIR_Coverage, 23771,
     /* 1378469 */     GIR_EraseRootFromParent_Done,
     /* 1378470 */   // Label 19412: @1378470
     /* 1378470 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1378567), // Rule ID 23774 //
     /* 1378475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1378486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1378489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1378495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1378505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378525 */     // MIs[1] Operand 1
     /* 1378525 */     // No operand predicates
     /* 1378525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378529 */     // MIs[0] policy
     /* 1378529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378541 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1378541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1378544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378566 */     // GIR_Coverage, 23774,
     /* 1378566 */     GIR_EraseRootFromParent_Done,
     /* 1378567 */   // Label 19413: @1378567
     /* 1378567 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1378664), // Rule ID 23775 //
     /* 1378572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1378583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1378586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1378602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378622 */     // MIs[1] Operand 1
     /* 1378622 */     // No operand predicates
     /* 1378622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378626 */     // MIs[0] policy
     /* 1378626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378638 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1378638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1378641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378663 */     // GIR_Coverage, 23775,
     /* 1378663 */     GIR_EraseRootFromParent_Done,
     /* 1378664 */   // Label 19414: @1378664
     /* 1378664 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1378761), // Rule ID 23778 //
     /* 1378669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1378680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1378683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1378689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1378699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378719 */     // MIs[1] Operand 1
     /* 1378719 */     // No operand predicates
     /* 1378719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378723 */     // MIs[0] policy
     /* 1378723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378735 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1378735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1378738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378760 */     // GIR_Coverage, 23778,
     /* 1378760 */     GIR_EraseRootFromParent_Done,
     /* 1378761 */   // Label 19415: @1378761
     /* 1378761 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1378858), // Rule ID 23779 //
     /* 1378766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1378777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1378780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1378796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378816 */     // MIs[1] Operand 1
     /* 1378816 */     // No operand predicates
     /* 1378816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378820 */     // MIs[0] policy
     /* 1378820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1378832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1378835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378857 */     // GIR_Coverage, 23779,
     /* 1378857 */     GIR_EraseRootFromParent_Done,
     /* 1378858 */   // Label 19416: @1378858
     /* 1378858 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1378955), // Rule ID 23782 //
     /* 1378863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1378874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1378877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1378883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1378893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1378905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1378909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1378913 */     // MIs[1] Operand 1
     /* 1378913 */     // No operand predicates
     /* 1378913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378917 */     // MIs[0] policy
     /* 1378917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1378920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1378922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378929 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1378929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1378932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1378941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1378953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378954 */     // GIR_Coverage, 23782,
     /* 1378954 */     GIR_EraseRootFromParent_Done,
     /* 1378955 */   // Label 19417: @1378955
     /* 1378955 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1379052), // Rule ID 23783 //
     /* 1378960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1378968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1378971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1378974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1378980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1378990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379010 */     // MIs[1] Operand 1
     /* 1379010 */     // No operand predicates
     /* 1379010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379014 */     // MIs[0] policy
     /* 1379014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1379029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379051 */     // GIR_Coverage, 23783,
     /* 1379051 */     GIR_EraseRootFromParent_Done,
     /* 1379052 */   // Label 19418: @1379052
     /* 1379052 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1379149), // Rule ID 23786 //
     /* 1379057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1379068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1379071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1379077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1379087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379107 */     // MIs[1] Operand 1
     /* 1379107 */     // No operand predicates
     /* 1379107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379111 */     // MIs[0] policy
     /* 1379111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379123 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1379123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1379126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379148 */     // GIR_Coverage, 23786,
     /* 1379148 */     GIR_EraseRootFromParent_Done,
     /* 1379149 */   // Label 19419: @1379149
     /* 1379149 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1379246), // Rule ID 23787 //
     /* 1379154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1379165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1379168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1379174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1379184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379204 */     // MIs[1] Operand 1
     /* 1379204 */     // No operand predicates
     /* 1379204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379208 */     // MIs[0] policy
     /* 1379208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1379223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379245 */     // GIR_Coverage, 23787,
     /* 1379245 */     GIR_EraseRootFromParent_Done,
     /* 1379246 */   // Label 19420: @1379246
     /* 1379246 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1379343), // Rule ID 23790 //
     /* 1379251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1379262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1379265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1379271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1379281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379301 */     // MIs[1] Operand 1
     /* 1379301 */     // No operand predicates
     /* 1379301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379305 */     // MIs[0] policy
     /* 1379305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1379317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1379320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379342 */     // GIR_Coverage, 23790,
     /* 1379342 */     GIR_EraseRootFromParent_Done,
     /* 1379343 */   // Label 19421: @1379343
     /* 1379343 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1379440), // Rule ID 23791 //
     /* 1379348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1379359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1379362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1379368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1379378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379398 */     // MIs[1] Operand 1
     /* 1379398 */     // No operand predicates
     /* 1379398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379402 */     // MIs[0] policy
     /* 1379402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1379417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379439 */     // GIR_Coverage, 23791,
     /* 1379439 */     GIR_EraseRootFromParent_Done,
     /* 1379440 */   // Label 19422: @1379440
     /* 1379440 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1379537), // Rule ID 23794 //
     /* 1379445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1379456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1379459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1379465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1379475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379495 */     // MIs[1] Operand 1
     /* 1379495 */     // No operand predicates
     /* 1379495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379499 */     // MIs[0] policy
     /* 1379499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379511 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1379511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1379514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379536 */     // GIR_Coverage, 23794,
     /* 1379536 */     GIR_EraseRootFromParent_Done,
     /* 1379537 */   // Label 19423: @1379537
     /* 1379537 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1379634), // Rule ID 23795 //
     /* 1379542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1379553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1379556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1379562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1379572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379592 */     // MIs[1] Operand 1
     /* 1379592 */     // No operand predicates
     /* 1379592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379596 */     // MIs[0] policy
     /* 1379596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1379611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379633 */     // GIR_Coverage, 23795,
     /* 1379633 */     GIR_EraseRootFromParent_Done,
     /* 1379634 */   // Label 19424: @1379634
     /* 1379634 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1379731), // Rule ID 23798 //
     /* 1379639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1379650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1379653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1379659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1379669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379689 */     // MIs[1] Operand 1
     /* 1379689 */     // No operand predicates
     /* 1379689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379693 */     // MIs[0] policy
     /* 1379693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379705 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1379705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1379708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379730 */     // GIR_Coverage, 23798,
     /* 1379730 */     GIR_EraseRootFromParent_Done,
     /* 1379731 */   // Label 19425: @1379731
     /* 1379731 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1379828), // Rule ID 23799 //
     /* 1379736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1379747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1379750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1379756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1379766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379786 */     // MIs[1] Operand 1
     /* 1379786 */     // No operand predicates
     /* 1379786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379790 */     // MIs[0] policy
     /* 1379790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1379805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379827 */     // GIR_Coverage, 23799,
     /* 1379827 */     GIR_EraseRootFromParent_Done,
     /* 1379828 */   // Label 19426: @1379828
     /* 1379828 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1379925), // Rule ID 23802 //
     /* 1379833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1379844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1379847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1379853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1379863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379883 */     // MIs[1] Operand 1
     /* 1379883 */     // No operand predicates
     /* 1379883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379887 */     // MIs[0] policy
     /* 1379887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1379899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1379902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1379911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1379923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379924 */     // GIR_Coverage, 23802,
     /* 1379924 */     GIR_EraseRootFromParent_Done,
     /* 1379925 */   // Label 19427: @1379925
     /* 1379925 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1380022), // Rule ID 23803 //
     /* 1379930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1379938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1379941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1379944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1379950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1379960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1379972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1379976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1379980 */     // MIs[1] Operand 1
     /* 1379980 */     // No operand predicates
     /* 1379980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379984 */     // MIs[0] policy
     /* 1379984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1379987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1379989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1379996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1379999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380021 */     // GIR_Coverage, 23803,
     /* 1380021 */     GIR_EraseRootFromParent_Done,
     /* 1380022 */   // Label 19428: @1380022
     /* 1380022 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1380119), // Rule ID 23806 //
     /* 1380027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1380035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1380038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1380041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1380047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1380057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380077 */     // MIs[1] Operand 1
     /* 1380077 */     // No operand predicates
     /* 1380077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380081 */     // MIs[0] policy
     /* 1380081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1380093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1380096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380118 */     // GIR_Coverage, 23806,
     /* 1380118 */     GIR_EraseRootFromParent_Done,
     /* 1380119 */   // Label 19429: @1380119
     /* 1380119 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1380216), // Rule ID 23807 //
     /* 1380124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1380132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1380135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1380138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1380144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1380154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380174 */     // MIs[1] Operand 1
     /* 1380174 */     // No operand predicates
     /* 1380174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380178 */     // MIs[0] policy
     /* 1380178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1380190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1380193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380215 */     // GIR_Coverage, 23807,
     /* 1380215 */     GIR_EraseRootFromParent_Done,
     /* 1380216 */   // Label 19430: @1380216
     /* 1380216 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1380313), // Rule ID 23810 //
     /* 1380221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1380229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1380232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1380235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1380241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1380251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380271 */     // MIs[1] Operand 1
     /* 1380271 */     // No operand predicates
     /* 1380271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380275 */     // MIs[0] policy
     /* 1380275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380287 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1380287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1380290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380312 */     // GIR_Coverage, 23810,
     /* 1380312 */     GIR_EraseRootFromParent_Done,
     /* 1380313 */   // Label 19431: @1380313
     /* 1380313 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1380410), // Rule ID 23811 //
     /* 1380318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1380326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1380329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1380332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1380338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1380348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380368 */     // MIs[1] Operand 1
     /* 1380368 */     // No operand predicates
     /* 1380368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380372 */     // MIs[0] policy
     /* 1380372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1380384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1380387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380409 */     // GIR_Coverage, 23811,
     /* 1380409 */     GIR_EraseRootFromParent_Done,
     /* 1380410 */   // Label 19432: @1380410
     /* 1380410 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1380507), // Rule ID 24050 //
     /* 1380415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1380418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1380426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1380429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1380435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380465 */     // MIs[1] Operand 1
     /* 1380465 */     // No operand predicates
     /* 1380465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380469 */     // MIs[0] policy
     /* 1380469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380481 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1380481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1380484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380506 */     // GIR_Coverage, 24050,
     /* 1380506 */     GIR_EraseRootFromParent_Done,
     /* 1380507 */   // Label 19433: @1380507
     /* 1380507 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1380604), // Rule ID 24051 //
     /* 1380512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1380515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1380523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1380526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1380532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380562 */     // MIs[1] Operand 1
     /* 1380562 */     // No operand predicates
     /* 1380562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380566 */     // MIs[0] policy
     /* 1380566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380578 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1380578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1380581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380603 */     // GIR_Coverage, 24051,
     /* 1380603 */     GIR_EraseRootFromParent_Done,
     /* 1380604 */   // Label 19434: @1380604
     /* 1380604 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1380701), // Rule ID 24054 //
     /* 1380609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1380612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1380620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1380623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1380629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380659 */     // MIs[1] Operand 1
     /* 1380659 */     // No operand predicates
     /* 1380659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380663 */     // MIs[0] policy
     /* 1380663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380675 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1380675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1380678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380700 */     // GIR_Coverage, 24054,
     /* 1380700 */     GIR_EraseRootFromParent_Done,
     /* 1380701 */   // Label 19435: @1380701
     /* 1380701 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1380798), // Rule ID 24055 //
     /* 1380706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1380709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1380717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1380720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1380726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380756 */     // MIs[1] Operand 1
     /* 1380756 */     // No operand predicates
     /* 1380756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380760 */     // MIs[0] policy
     /* 1380760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380772 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1380772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1380775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380797 */     // GIR_Coverage, 24055,
     /* 1380797 */     GIR_EraseRootFromParent_Done,
     /* 1380798 */   // Label 19436: @1380798
     /* 1380798 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1380895), // Rule ID 24058 //
     /* 1380803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1380806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1380814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1380817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1380823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380853 */     // MIs[1] Operand 1
     /* 1380853 */     // No operand predicates
     /* 1380853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380857 */     // MIs[0] policy
     /* 1380857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380869 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1380869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1380872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380894 */     // GIR_Coverage, 24058,
     /* 1380894 */     GIR_EraseRootFromParent_Done,
     /* 1380895 */   // Label 19437: @1380895
     /* 1380895 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1380992), // Rule ID 24059 //
     /* 1380900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1380903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1380908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1380911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1380914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1380920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1380942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1380946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1380950 */     // MIs[1] Operand 1
     /* 1380950 */     // No operand predicates
     /* 1380950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380954 */     // MIs[0] policy
     /* 1380954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1380957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1380959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380966 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1380966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1380969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1380978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1380990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380991 */     // GIR_Coverage, 24059,
     /* 1380991 */     GIR_EraseRootFromParent_Done,
     /* 1380992 */   // Label 19438: @1380992
     /* 1380992 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1381089), // Rule ID 24062 //
     /* 1380997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1381000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381047 */     // MIs[1] Operand 1
     /* 1381047 */     // No operand predicates
     /* 1381047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381051 */     // MIs[0] policy
     /* 1381051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381063 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1381063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381088 */     // GIR_Coverage, 24062,
     /* 1381088 */     GIR_EraseRootFromParent_Done,
     /* 1381089 */   // Label 19439: @1381089
     /* 1381089 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1381186), // Rule ID 24063 //
     /* 1381094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1381097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1381114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381144 */     // MIs[1] Operand 1
     /* 1381144 */     // No operand predicates
     /* 1381144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381148 */     // MIs[0] policy
     /* 1381148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1381160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381185 */     // GIR_Coverage, 24063,
     /* 1381185 */     GIR_EraseRootFromParent_Done,
     /* 1381186 */   // Label 19440: @1381186
     /* 1381186 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1381283), // Rule ID 24066 //
     /* 1381191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1381194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381241 */     // MIs[1] Operand 1
     /* 1381241 */     // No operand predicates
     /* 1381241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381245 */     // MIs[0] policy
     /* 1381245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381257 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1381257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381282 */     // GIR_Coverage, 24066,
     /* 1381282 */     GIR_EraseRootFromParent_Done,
     /* 1381283 */   // Label 19441: @1381283
     /* 1381283 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1381380), // Rule ID 24067 //
     /* 1381288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1381291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1381308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381338 */     // MIs[1] Operand 1
     /* 1381338 */     // No operand predicates
     /* 1381338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381342 */     // MIs[0] policy
     /* 1381342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381354 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1381354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381379 */     // GIR_Coverage, 24067,
     /* 1381379 */     GIR_EraseRootFromParent_Done,
     /* 1381380 */   // Label 19442: @1381380
     /* 1381380 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1381477), // Rule ID 24070 //
     /* 1381385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1381388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381435 */     // MIs[1] Operand 1
     /* 1381435 */     // No operand predicates
     /* 1381435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381439 */     // MIs[0] policy
     /* 1381439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381451 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1381451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381476 */     // GIR_Coverage, 24070,
     /* 1381476 */     GIR_EraseRootFromParent_Done,
     /* 1381477 */   // Label 19443: @1381477
     /* 1381477 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1381574), // Rule ID 24071 //
     /* 1381482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1381485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1381502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381532 */     // MIs[1] Operand 1
     /* 1381532 */     // No operand predicates
     /* 1381532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381536 */     // MIs[0] policy
     /* 1381536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1381548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1381551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381573 */     // GIR_Coverage, 24071,
     /* 1381573 */     GIR_EraseRootFromParent_Done,
     /* 1381574 */   // Label 19444: @1381574
     /* 1381574 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1381671), // Rule ID 24074 //
     /* 1381579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1381582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1381590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1381593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1381609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381629 */     // MIs[1] Operand 1
     /* 1381629 */     // No operand predicates
     /* 1381629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381633 */     // MIs[0] policy
     /* 1381633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381645 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1381645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1381648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381670 */     // GIR_Coverage, 24074,
     /* 1381670 */     GIR_EraseRootFromParent_Done,
     /* 1381671 */   // Label 19445: @1381671
     /* 1381671 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1381768), // Rule ID 24075 //
     /* 1381676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1381679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1381687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1381690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1381696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1381706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381726 */     // MIs[1] Operand 1
     /* 1381726 */     // No operand predicates
     /* 1381726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381730 */     // MIs[0] policy
     /* 1381730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381742 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1381742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1381745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381767 */     // GIR_Coverage, 24075,
     /* 1381767 */     GIR_EraseRootFromParent_Done,
     /* 1381768 */   // Label 19446: @1381768
     /* 1381768 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1381865), // Rule ID 24078 //
     /* 1381773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1381776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1381784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1381787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1381803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381823 */     // MIs[1] Operand 1
     /* 1381823 */     // No operand predicates
     /* 1381823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381827 */     // MIs[0] policy
     /* 1381827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381839 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1381839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1381842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381864 */     // GIR_Coverage, 24078,
     /* 1381864 */     GIR_EraseRootFromParent_Done,
     /* 1381865 */   // Label 19447: @1381865
     /* 1381865 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1381962), // Rule ID 24079 //
     /* 1381870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1381873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1381881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1381884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1381890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1381900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1381912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1381916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1381920 */     // MIs[1] Operand 1
     /* 1381920 */     // No operand predicates
     /* 1381920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381924 */     // MIs[0] policy
     /* 1381924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1381927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1381929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381936 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1381936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1381939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1381948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1381960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381961 */     // GIR_Coverage, 24079,
     /* 1381961 */     GIR_EraseRootFromParent_Done,
     /* 1381962 */   // Label 19448: @1381962
     /* 1381962 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1382059), // Rule ID 24082 //
     /* 1381967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1381970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1381975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1381978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1381981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1381984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1381987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1381997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382017 */     // MIs[1] Operand 1
     /* 1382017 */     // No operand predicates
     /* 1382017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382021 */     // MIs[0] policy
     /* 1382021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382033 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1382033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1382036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382058 */     // GIR_Coverage, 24082,
     /* 1382058 */     GIR_EraseRootFromParent_Done,
     /* 1382059 */   // Label 19449: @1382059
     /* 1382059 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1382156), // Rule ID 24083 //
     /* 1382064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1382067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1382075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1382078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1382084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1382094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382114 */     // MIs[1] Operand 1
     /* 1382114 */     // No operand predicates
     /* 1382114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382118 */     // MIs[0] policy
     /* 1382118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382130 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1382130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1382133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382155 */     // GIR_Coverage, 24083,
     /* 1382155 */     GIR_EraseRootFromParent_Done,
     /* 1382156 */   // Label 19450: @1382156
     /* 1382156 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1382253), // Rule ID 24086 //
     /* 1382161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1382164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1382172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1382175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1382181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1382191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382211 */     // MIs[1] Operand 1
     /* 1382211 */     // No operand predicates
     /* 1382211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382215 */     // MIs[0] policy
     /* 1382215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1382227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1382230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382252 */     // GIR_Coverage, 24086,
     /* 1382252 */     GIR_EraseRootFromParent_Done,
     /* 1382253 */   // Label 19451: @1382253
     /* 1382253 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1382350), // Rule ID 24087 //
     /* 1382258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1382261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1382269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1382272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1382278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1382288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382308 */     // MIs[1] Operand 1
     /* 1382308 */     // No operand predicates
     /* 1382308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382312 */     // MIs[0] policy
     /* 1382312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1382324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1382327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382349 */     // GIR_Coverage, 24087,
     /* 1382349 */     GIR_EraseRootFromParent_Done,
     /* 1382350 */   // Label 19452: @1382350
     /* 1382350 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1382447), // Rule ID 24090 //
     /* 1382355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1382358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1382366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1382369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1382375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1382385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382405 */     // MIs[1] Operand 1
     /* 1382405 */     // No operand predicates
     /* 1382405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382409 */     // MIs[0] policy
     /* 1382409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382421 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1382421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1382424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382446 */     // GIR_Coverage, 24090,
     /* 1382446 */     GIR_EraseRootFromParent_Done,
     /* 1382447 */   // Label 19453: @1382447
     /* 1382447 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1382544), // Rule ID 24091 //
     /* 1382452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1382455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1382463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1382466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1382472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1382482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382502 */     // MIs[1] Operand 1
     /* 1382502 */     // No operand predicates
     /* 1382502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382506 */     // MIs[0] policy
     /* 1382506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382518 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1382518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1382521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382543 */     // GIR_Coverage, 24091,
     /* 1382543 */     GIR_EraseRootFromParent_Done,
     /* 1382544 */   // Label 19454: @1382544
     /* 1382544 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1382641), // Rule ID 24094 //
     /* 1382549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1382552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1382560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1382563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1382569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1382579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382599 */     // MIs[1] Operand 1
     /* 1382599 */     // No operand predicates
     /* 1382599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382603 */     // MIs[0] policy
     /* 1382603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382615 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1382615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1382618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382640 */     // GIR_Coverage, 24094,
     /* 1382640 */     GIR_EraseRootFromParent_Done,
     /* 1382641 */   // Label 19455: @1382641
     /* 1382641 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1382738), // Rule ID 24095 //
     /* 1382646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1382649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1382657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1382660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1382666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1382676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382696 */     // MIs[1] Operand 1
     /* 1382696 */     // No operand predicates
     /* 1382696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382700 */     // MIs[0] policy
     /* 1382700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382712 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1382712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1382715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382737 */     // GIR_Coverage, 24095,
     /* 1382737 */     GIR_EraseRootFromParent_Done,
     /* 1382738 */   // Label 19456: @1382738
     /* 1382738 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1382835), // Rule ID 24098 //
     /* 1382743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1382746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1382754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1382757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1382763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1382773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382793 */     // MIs[1] Operand 1
     /* 1382793 */     // No operand predicates
     /* 1382793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382797 */     // MIs[0] policy
     /* 1382797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382809 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1382809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1382812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382834 */     // GIR_Coverage, 24098,
     /* 1382834 */     GIR_EraseRootFromParent_Done,
     /* 1382835 */   // Label 19457: @1382835
     /* 1382835 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1382932), // Rule ID 24099 //
     /* 1382840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1382843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1382851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1382854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1382860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1382870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382890 */     // MIs[1] Operand 1
     /* 1382890 */     // No operand predicates
     /* 1382890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382894 */     // MIs[0] policy
     /* 1382894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1382906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1382909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1382918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1382930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382931 */     // GIR_Coverage, 24099,
     /* 1382931 */     GIR_EraseRootFromParent_Done,
     /* 1382932 */   // Label 19458: @1382932
     /* 1382932 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1383029), // Rule ID 24102 //
     /* 1382937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1382940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1382945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1382948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1382951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1382954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1382957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1382967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1382979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1382983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1382987 */     // MIs[1] Operand 1
     /* 1382987 */     // No operand predicates
     /* 1382987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382991 */     // MIs[0] policy
     /* 1382991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1382994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383003 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1383006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383028 */     // GIR_Coverage, 24102,
     /* 1383028 */     GIR_EraseRootFromParent_Done,
     /* 1383029 */   // Label 19459: @1383029
     /* 1383029 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1383126), // Rule ID 24103 //
     /* 1383034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1383037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1383042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1383045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1383048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1383054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1383064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383084 */     // MIs[1] Operand 1
     /* 1383084 */     // No operand predicates
     /* 1383084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383088 */     // MIs[0] policy
     /* 1383088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1383100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1383103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383125 */     // GIR_Coverage, 24103,
     /* 1383125 */     GIR_EraseRootFromParent_Done,
     /* 1383126 */   // Label 19460: @1383126
     /* 1383126 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1383223), // Rule ID 24106 //
     /* 1383131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1383134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1383139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1383142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1383145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1383151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1383161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383181 */     // MIs[1] Operand 1
     /* 1383181 */     // No operand predicates
     /* 1383181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383185 */     // MIs[0] policy
     /* 1383185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383197 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1383200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383222 */     // GIR_Coverage, 24106,
     /* 1383222 */     GIR_EraseRootFromParent_Done,
     /* 1383223 */   // Label 19461: @1383223
     /* 1383223 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1383320), // Rule ID 24107 //
     /* 1383228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1383231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1383236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1383239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1383242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1383248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1383258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383278 */     // MIs[1] Operand 1
     /* 1383278 */     // No operand predicates
     /* 1383278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383282 */     // MIs[0] policy
     /* 1383282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1383294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1383297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383319 */     // GIR_Coverage, 24107,
     /* 1383319 */     GIR_EraseRootFromParent_Done,
     /* 1383320 */   // Label 19462: @1383320
     /* 1383320 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1383417), // Rule ID 24170 //
     /* 1383325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1383328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1383336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1383339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1383345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383375 */     // MIs[1] Operand 1
     /* 1383375 */     // No operand predicates
     /* 1383375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383379 */     // MIs[0] policy
     /* 1383379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383391 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1383394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383416 */     // GIR_Coverage, 24170,
     /* 1383416 */     GIR_EraseRootFromParent_Done,
     /* 1383417 */   // Label 19463: @1383417
     /* 1383417 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1383514), // Rule ID 24171 //
     /* 1383422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1383425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1383433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1383436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1383442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383472 */     // MIs[1] Operand 1
     /* 1383472 */     // No operand predicates
     /* 1383472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383476 */     // MIs[0] policy
     /* 1383476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383488 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1383488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1383491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383513 */     // GIR_Coverage, 24171,
     /* 1383513 */     GIR_EraseRootFromParent_Done,
     /* 1383514 */   // Label 19464: @1383514
     /* 1383514 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1383611), // Rule ID 24174 //
     /* 1383519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1383522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1383530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1383533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1383536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1383539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383569 */     // MIs[1] Operand 1
     /* 1383569 */     // No operand predicates
     /* 1383569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383573 */     // MIs[0] policy
     /* 1383573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383585 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1383588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383610 */     // GIR_Coverage, 24174,
     /* 1383610 */     GIR_EraseRootFromParent_Done,
     /* 1383611 */   // Label 19465: @1383611
     /* 1383611 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1383708), // Rule ID 24175 //
     /* 1383616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1383619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1383627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1383630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1383633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1383636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383666 */     // MIs[1] Operand 1
     /* 1383666 */     // No operand predicates
     /* 1383666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383670 */     // MIs[0] policy
     /* 1383670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1383682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1383685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383707 */     // GIR_Coverage, 24175,
     /* 1383707 */     GIR_EraseRootFromParent_Done,
     /* 1383708 */   // Label 19466: @1383708
     /* 1383708 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1383805), // Rule ID 24178 //
     /* 1383713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1383716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1383724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1383727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1383730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1383733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383763 */     // MIs[1] Operand 1
     /* 1383763 */     // No operand predicates
     /* 1383763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383767 */     // MIs[0] policy
     /* 1383767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383779 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1383782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383804 */     // GIR_Coverage, 24178,
     /* 1383804 */     GIR_EraseRootFromParent_Done,
     /* 1383805 */   // Label 19467: @1383805
     /* 1383805 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1383902), // Rule ID 24179 //
     /* 1383810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1383813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1383821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1383824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1383827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1383830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383860 */     // MIs[1] Operand 1
     /* 1383860 */     // No operand predicates
     /* 1383860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383864 */     // MIs[0] policy
     /* 1383864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383876 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1383876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1383879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383901 */     // GIR_Coverage, 24179,
     /* 1383901 */     GIR_EraseRootFromParent_Done,
     /* 1383902 */   // Label 19468: @1383902
     /* 1383902 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1383999), // Rule ID 24182 //
     /* 1383907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1383910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1383915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1383924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1383927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1383949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1383953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1383957 */     // MIs[1] Operand 1
     /* 1383957 */     // No operand predicates
     /* 1383957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383961 */     // MIs[0] policy
     /* 1383961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1383964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1383966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383973 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1383973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1383976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1383985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1383997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383998 */     // GIR_Coverage, 24182,
     /* 1383998 */     GIR_EraseRootFromParent_Done,
     /* 1383999 */   // Label 19469: @1383999
     /* 1383999 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1384096), // Rule ID 24183 //
     /* 1384004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1384007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384054 */     // MIs[1] Operand 1
     /* 1384054 */     // No operand predicates
     /* 1384054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384058 */     // MIs[0] policy
     /* 1384058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384070 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1384070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1384073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384095 */     // GIR_Coverage, 24183,
     /* 1384095 */     GIR_EraseRootFromParent_Done,
     /* 1384096 */   // Label 19470: @1384096
     /* 1384096 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1384193), // Rule ID 24186 //
     /* 1384101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1384104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1384121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384151 */     // MIs[1] Operand 1
     /* 1384151 */     // No operand predicates
     /* 1384151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384155 */     // MIs[0] policy
     /* 1384155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384167 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1384167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1384170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384192 */     // GIR_Coverage, 24186,
     /* 1384192 */     GIR_EraseRootFromParent_Done,
     /* 1384193 */   // Label 19471: @1384193
     /* 1384193 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1384290), // Rule ID 24187 //
     /* 1384198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1384201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384248 */     // MIs[1] Operand 1
     /* 1384248 */     // No operand predicates
     /* 1384248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384252 */     // MIs[0] policy
     /* 1384252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1384264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1384267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384289 */     // GIR_Coverage, 24187,
     /* 1384289 */     GIR_EraseRootFromParent_Done,
     /* 1384290 */   // Label 19472: @1384290
     /* 1384290 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1384387), // Rule ID 24190 //
     /* 1384295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1384298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1384315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384345 */     // MIs[1] Operand 1
     /* 1384345 */     // No operand predicates
     /* 1384345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384349 */     // MIs[0] policy
     /* 1384349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384361 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1384361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1384364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384386 */     // GIR_Coverage, 24190,
     /* 1384386 */     GIR_EraseRootFromParent_Done,
     /* 1384387 */   // Label 19473: @1384387
     /* 1384387 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1384484), // Rule ID 24191 //
     /* 1384392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1384395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384442 */     // MIs[1] Operand 1
     /* 1384442 */     // No operand predicates
     /* 1384442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384446 */     // MIs[0] policy
     /* 1384446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384458 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1384458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1384461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384483 */     // GIR_Coverage, 24191,
     /* 1384483 */     GIR_EraseRootFromParent_Done,
     /* 1384484 */   // Label 19474: @1384484
     /* 1384484 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1384581), // Rule ID 24194 //
     /* 1384489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1384492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1384500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1384503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1384506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1384509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1384519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384539 */     // MIs[1] Operand 1
     /* 1384539 */     // No operand predicates
     /* 1384539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384543 */     // MIs[0] policy
     /* 1384543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384555 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1384555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1384558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384580 */     // GIR_Coverage, 24194,
     /* 1384580 */     GIR_EraseRootFromParent_Done,
     /* 1384581 */   // Label 19475: @1384581
     /* 1384581 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1384678), // Rule ID 24195 //
     /* 1384586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1384589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1384597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1384600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1384603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1384616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384636 */     // MIs[1] Operand 1
     /* 1384636 */     // No operand predicates
     /* 1384636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384640 */     // MIs[0] policy
     /* 1384640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1384652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1384655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384677 */     // GIR_Coverage, 24195,
     /* 1384677 */     GIR_EraseRootFromParent_Done,
     /* 1384678 */   // Label 19476: @1384678
     /* 1384678 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1384775), // Rule ID 24198 //
     /* 1384683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1384686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1384694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1384697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1384700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1384703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1384713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384733 */     // MIs[1] Operand 1
     /* 1384733 */     // No operand predicates
     /* 1384733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384737 */     // MIs[0] policy
     /* 1384737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384749 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1384749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1384752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384774 */     // GIR_Coverage, 24198,
     /* 1384774 */     GIR_EraseRootFromParent_Done,
     /* 1384775 */   // Label 19477: @1384775
     /* 1384775 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1384872), // Rule ID 24199 //
     /* 1384780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1384783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1384791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1384794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1384797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1384810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384830 */     // MIs[1] Operand 1
     /* 1384830 */     // No operand predicates
     /* 1384830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384834 */     // MIs[0] policy
     /* 1384834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384846 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1384846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1384849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384871 */     // GIR_Coverage, 24199,
     /* 1384871 */     GIR_EraseRootFromParent_Done,
     /* 1384872 */   // Label 19478: @1384872
     /* 1384872 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1384969), // Rule ID 24202 //
     /* 1384877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1384880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1384888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1384891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1384894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1384897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1384900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1384907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1384919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1384923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1384927 */     // MIs[1] Operand 1
     /* 1384927 */     // No operand predicates
     /* 1384927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384931 */     // MIs[0] policy
     /* 1384931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1384934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1384936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384943 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1384943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1384946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1384955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1384967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384968 */     // GIR_Coverage, 24202,
     /* 1384968 */     GIR_EraseRootFromParent_Done,
     /* 1384969 */   // Label 19479: @1384969
     /* 1384969 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1385066), // Rule ID 24203 //
     /* 1384974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1384977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1384982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1384985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1384988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1384991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1384994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1384997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1385004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385024 */     // MIs[1] Operand 1
     /* 1385024 */     // No operand predicates
     /* 1385024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385028 */     // MIs[0] policy
     /* 1385028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385040 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1385040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1385043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385065 */     // GIR_Coverage, 24203,
     /* 1385065 */     GIR_EraseRootFromParent_Done,
     /* 1385066 */   // Label 19480: @1385066
     /* 1385066 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1385163), // Rule ID 24206 //
     /* 1385071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1385074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1385082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1385085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1385088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1385091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1385101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385121 */     // MIs[1] Operand 1
     /* 1385121 */     // No operand predicates
     /* 1385121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385125 */     // MIs[0] policy
     /* 1385125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385137 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1385137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1385140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385162 */     // GIR_Coverage, 24206,
     /* 1385162 */     GIR_EraseRootFromParent_Done,
     /* 1385163 */   // Label 19481: @1385163
     /* 1385163 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1385260), // Rule ID 24207 //
     /* 1385168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1385171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1385179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1385182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1385185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1385188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1385198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385218 */     // MIs[1] Operand 1
     /* 1385218 */     // No operand predicates
     /* 1385218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385222 */     // MIs[0] policy
     /* 1385222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385234 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1385234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1385237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385259 */     // GIR_Coverage, 24207,
     /* 1385259 */     GIR_EraseRootFromParent_Done,
     /* 1385260 */   // Label 19482: @1385260
     /* 1385260 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1385357), // Rule ID 24210 //
     /* 1385265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1385268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1385276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1385279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1385282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1385285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1385295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385315 */     // MIs[1] Operand 1
     /* 1385315 */     // No operand predicates
     /* 1385315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385319 */     // MIs[0] policy
     /* 1385319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385331 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1385331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1385334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385356 */     // GIR_Coverage, 24210,
     /* 1385356 */     GIR_EraseRootFromParent_Done,
     /* 1385357 */   // Label 19483: @1385357
     /* 1385357 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1385454), // Rule ID 24211 //
     /* 1385362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1385365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1385373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1385376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1385379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1385382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1385392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385412 */     // MIs[1] Operand 1
     /* 1385412 */     // No operand predicates
     /* 1385412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385416 */     // MIs[0] policy
     /* 1385416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385428 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1385428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1385431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385453 */     // GIR_Coverage, 24211,
     /* 1385453 */     GIR_EraseRootFromParent_Done,
     /* 1385454 */   // Label 19484: @1385454
     /* 1385454 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1385551), // Rule ID 24214 //
     /* 1385459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1385462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1385470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1385473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1385476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1385479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1385489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385509 */     // MIs[1] Operand 1
     /* 1385509 */     // No operand predicates
     /* 1385509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385513 */     // MIs[0] policy
     /* 1385513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1385525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1385528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385550 */     // GIR_Coverage, 24214,
     /* 1385550 */     GIR_EraseRootFromParent_Done,
     /* 1385551 */   // Label 19485: @1385551
     /* 1385551 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1385648), // Rule ID 24215 //
     /* 1385556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1385559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1385567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1385570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1385573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1385576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1385586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385606 */     // MIs[1] Operand 1
     /* 1385606 */     // No operand predicates
     /* 1385606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385610 */     // MIs[0] policy
     /* 1385610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385622 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1385622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1385625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385647 */     // GIR_Coverage, 24215,
     /* 1385647 */     GIR_EraseRootFromParent_Done,
     /* 1385648 */   // Label 19486: @1385648
     /* 1385648 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1385745), // Rule ID 24218 //
     /* 1385653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1385656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1385664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1385667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1385670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1385673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1385683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385703 */     // MIs[1] Operand 1
     /* 1385703 */     // No operand predicates
     /* 1385703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385707 */     // MIs[0] policy
     /* 1385707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385719 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1385719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1385722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385744 */     // GIR_Coverage, 24218,
     /* 1385744 */     GIR_EraseRootFromParent_Done,
     /* 1385745 */   // Label 19487: @1385745
     /* 1385745 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1385842), // Rule ID 24219 //
     /* 1385750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1385753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1385761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1385764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1385767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1385770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1385780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385800 */     // MIs[1] Operand 1
     /* 1385800 */     // No operand predicates
     /* 1385800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385804 */     // MIs[0] policy
     /* 1385804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385816 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1385816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1385819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385841 */     // GIR_Coverage, 24219,
     /* 1385841 */     GIR_EraseRootFromParent_Done,
     /* 1385842 */   // Label 19488: @1385842
     /* 1385842 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1385939), // Rule ID 24222 //
     /* 1385847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1385850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1385858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1385861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1385864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1385867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1385877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385897 */     // MIs[1] Operand 1
     /* 1385897 */     // No operand predicates
     /* 1385897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385901 */     // MIs[0] policy
     /* 1385901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1385904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1385906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385913 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1385913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1385916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1385925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1385937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385938 */     // GIR_Coverage, 24222,
     /* 1385938 */     GIR_EraseRootFromParent_Done,
     /* 1385939 */   // Label 19489: @1385939
     /* 1385939 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1386036), // Rule ID 24223 //
     /* 1385944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1385947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1385952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1385955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1385958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1385961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1385964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1385974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1385986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1385990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1385994 */     // MIs[1] Operand 1
     /* 1385994 */     // No operand predicates
     /* 1385994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385998 */     // MIs[0] policy
     /* 1385998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386010 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1386013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386035 */     // GIR_Coverage, 24223,
     /* 1386035 */     GIR_EraseRootFromParent_Done,
     /* 1386036 */   // Label 19490: @1386036
     /* 1386036 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1386133), // Rule ID 24226 //
     /* 1386041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1386044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1386049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1386052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1386055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1386061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1386071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386091 */     // MIs[1] Operand 1
     /* 1386091 */     // No operand predicates
     /* 1386091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386095 */     // MIs[0] policy
     /* 1386095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386107 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1386107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1386110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386132 */     // GIR_Coverage, 24226,
     /* 1386132 */     GIR_EraseRootFromParent_Done,
     /* 1386133 */   // Label 19491: @1386133
     /* 1386133 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1386230), // Rule ID 24227 //
     /* 1386138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1386141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1386146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1386149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1386152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1386158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1386168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386188 */     // MIs[1] Operand 1
     /* 1386188 */     // No operand predicates
     /* 1386188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386192 */     // MIs[0] policy
     /* 1386192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386204 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1386207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386229 */     // GIR_Coverage, 24227,
     /* 1386229 */     GIR_EraseRootFromParent_Done,
     /* 1386230 */   // Label 19492: @1386230
     /* 1386230 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1386327), // Rule ID 24526 //
     /* 1386235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1386246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1386249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1386252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1386255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386285 */     // MIs[1] Operand 1
     /* 1386285 */     // No operand predicates
     /* 1386285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386289 */     // MIs[0] policy
     /* 1386289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1386301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1386304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386326 */     // GIR_Coverage, 24526,
     /* 1386326 */     GIR_EraseRootFromParent_Done,
     /* 1386327 */   // Label 19493: @1386327
     /* 1386327 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1386424), // Rule ID 24527 //
     /* 1386332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1386343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1386346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1386349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1386352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386382 */     // MIs[1] Operand 1
     /* 1386382 */     // No operand predicates
     /* 1386382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386386 */     // MIs[0] policy
     /* 1386386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1386401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386423 */     // GIR_Coverage, 24527,
     /* 1386423 */     GIR_EraseRootFromParent_Done,
     /* 1386424 */   // Label 19494: @1386424
     /* 1386424 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1386521), // Rule ID 24530 //
     /* 1386429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1386440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1386443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1386446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1386449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386479 */     // MIs[1] Operand 1
     /* 1386479 */     // No operand predicates
     /* 1386479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386483 */     // MIs[0] policy
     /* 1386483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386495 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1386495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1386498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386520 */     // GIR_Coverage, 24530,
     /* 1386520 */     GIR_EraseRootFromParent_Done,
     /* 1386521 */   // Label 19495: @1386521
     /* 1386521 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1386618), // Rule ID 24531 //
     /* 1386526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1386537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1386540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1386543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1386546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386576 */     // MIs[1] Operand 1
     /* 1386576 */     // No operand predicates
     /* 1386576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386580 */     // MIs[0] policy
     /* 1386580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1386595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386617 */     // GIR_Coverage, 24531,
     /* 1386617 */     GIR_EraseRootFromParent_Done,
     /* 1386618 */   // Label 19496: @1386618
     /* 1386618 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1386715), // Rule ID 24534 //
     /* 1386623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1386634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1386637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1386640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1386643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386673 */     // MIs[1] Operand 1
     /* 1386673 */     // No operand predicates
     /* 1386673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386677 */     // MIs[0] policy
     /* 1386677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386689 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1386689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1386692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386714 */     // GIR_Coverage, 24534,
     /* 1386714 */     GIR_EraseRootFromParent_Done,
     /* 1386715 */   // Label 19497: @1386715
     /* 1386715 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1386812), // Rule ID 24535 //
     /* 1386720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1386731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1386734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1386737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1386740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386770 */     // MIs[1] Operand 1
     /* 1386770 */     // No operand predicates
     /* 1386770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386774 */     // MIs[0] policy
     /* 1386774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1386789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386811 */     // GIR_Coverage, 24535,
     /* 1386811 */     GIR_EraseRootFromParent_Done,
     /* 1386812 */   // Label 19498: @1386812
     /* 1386812 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1386909), // Rule ID 24538 //
     /* 1386817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1386828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1386831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1386834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1386837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386867 */     // MIs[1] Operand 1
     /* 1386867 */     // No operand predicates
     /* 1386867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386871 */     // MIs[0] policy
     /* 1386871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386883 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1386883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1386886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1386907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386908 */     // GIR_Coverage, 24538,
     /* 1386908 */     GIR_EraseRootFromParent_Done,
     /* 1386909 */   // Label 19499: @1386909
     /* 1386909 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1387006), // Rule ID 24539 //
     /* 1386914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1386922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1386925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1386928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1386931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1386934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1386956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1386960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1386964 */     // MIs[1] Operand 1
     /* 1386964 */     // No operand predicates
     /* 1386964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386968 */     // MIs[0] policy
     /* 1386968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1386971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1386973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386980 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1386980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1386983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1386987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1386992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387005 */     // GIR_Coverage, 24539,
     /* 1387005 */     GIR_EraseRootFromParent_Done,
     /* 1387006 */   // Label 19500: @1387006
     /* 1387006 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1387103), // Rule ID 24542 //
     /* 1387011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1387022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1387025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1387031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387061 */     // MIs[1] Operand 1
     /* 1387061 */     // No operand predicates
     /* 1387061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387065 */     // MIs[0] policy
     /* 1387065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1387077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1387080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387102 */     // GIR_Coverage, 24542,
     /* 1387102 */     GIR_EraseRootFromParent_Done,
     /* 1387103 */   // Label 19501: @1387103
     /* 1387103 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1387200), // Rule ID 24543 //
     /* 1387108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1387119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1387122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1387128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387158 */     // MIs[1] Operand 1
     /* 1387158 */     // No operand predicates
     /* 1387158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387162 */     // MIs[0] policy
     /* 1387162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1387174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1387177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387199 */     // GIR_Coverage, 24543,
     /* 1387199 */     GIR_EraseRootFromParent_Done,
     /* 1387200 */   // Label 19502: @1387200
     /* 1387200 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1387297), // Rule ID 24546 //
     /* 1387205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1387216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1387219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1387225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387255 */     // MIs[1] Operand 1
     /* 1387255 */     // No operand predicates
     /* 1387255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387259 */     // MIs[0] policy
     /* 1387259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1387271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1387274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387296 */     // GIR_Coverage, 24546,
     /* 1387296 */     GIR_EraseRootFromParent_Done,
     /* 1387297 */   // Label 19503: @1387297
     /* 1387297 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1387394), // Rule ID 24547 //
     /* 1387302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1387313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1387316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1387322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387352 */     // MIs[1] Operand 1
     /* 1387352 */     // No operand predicates
     /* 1387352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387356 */     // MIs[0] policy
     /* 1387356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1387368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1387371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387393 */     // GIR_Coverage, 24547,
     /* 1387393 */     GIR_EraseRootFromParent_Done,
     /* 1387394 */   // Label 19504: @1387394
     /* 1387394 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1387491), // Rule ID 24550 //
     /* 1387399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1387416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1387419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387449 */     // MIs[1] Operand 1
     /* 1387449 */     // No operand predicates
     /* 1387449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387453 */     // MIs[0] policy
     /* 1387453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387465 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1387465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387490 */     // GIR_Coverage, 24550,
     /* 1387490 */     GIR_EraseRootFromParent_Done,
     /* 1387491 */   // Label 19505: @1387491
     /* 1387491 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1387588), // Rule ID 24551 //
     /* 1387496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1387513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1387516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387546 */     // MIs[1] Operand 1
     /* 1387546 */     // No operand predicates
     /* 1387546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387550 */     // MIs[0] policy
     /* 1387550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387562 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1387562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387587 */     // GIR_Coverage, 24551,
     /* 1387587 */     GIR_EraseRootFromParent_Done,
     /* 1387588 */   // Label 19506: @1387588
     /* 1387588 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1387685), // Rule ID 24554 //
     /* 1387593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1387610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1387613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387643 */     // MIs[1] Operand 1
     /* 1387643 */     // No operand predicates
     /* 1387643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387647 */     // MIs[0] policy
     /* 1387647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387659 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1387659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387684 */     // GIR_Coverage, 24554,
     /* 1387684 */     GIR_EraseRootFromParent_Done,
     /* 1387685 */   // Label 19507: @1387685
     /* 1387685 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1387782), // Rule ID 24555 //
     /* 1387690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1387707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1387710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387740 */     // MIs[1] Operand 1
     /* 1387740 */     // No operand predicates
     /* 1387740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387744 */     // MIs[0] policy
     /* 1387744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1387756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387781 */     // GIR_Coverage, 24555,
     /* 1387781 */     GIR_EraseRootFromParent_Done,
     /* 1387782 */   // Label 19508: @1387782
     /* 1387782 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1387879), // Rule ID 24558 //
     /* 1387787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1387804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1387807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387837 */     // MIs[1] Operand 1
     /* 1387837 */     // No operand predicates
     /* 1387837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387841 */     // MIs[0] policy
     /* 1387841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387853 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1387853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387878 */     // GIR_Coverage, 24558,
     /* 1387878 */     GIR_EraseRootFromParent_Done,
     /* 1387879 */   // Label 19509: @1387879
     /* 1387879 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1387976), // Rule ID 24559 //
     /* 1387884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1387901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1387904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1387926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1387930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1387934 */     // MIs[1] Operand 1
     /* 1387934 */     // No operand predicates
     /* 1387934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387938 */     // MIs[0] policy
     /* 1387938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1387941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1387943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1387950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1387953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1387957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1387962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1387974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387975 */     // GIR_Coverage, 24559,
     /* 1387975 */     GIR_EraseRootFromParent_Done,
     /* 1387976 */   // Label 19510: @1387976
     /* 1387976 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1388073), // Rule ID 24562 //
     /* 1387981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1387989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1387998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388031 */     // MIs[1] Operand 1
     /* 1388031 */     // No operand predicates
     /* 1388031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388035 */     // MIs[0] policy
     /* 1388035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1388047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1388050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388072 */     // GIR_Coverage, 24562,
     /* 1388072 */     GIR_EraseRootFromParent_Done,
     /* 1388073 */   // Label 19511: @1388073
     /* 1388073 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1388170), // Rule ID 24563 //
     /* 1388078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1388098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388128 */     // MIs[1] Operand 1
     /* 1388128 */     // No operand predicates
     /* 1388128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388132 */     // MIs[0] policy
     /* 1388132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1388144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1388147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388169 */     // GIR_Coverage, 24563,
     /* 1388169 */     GIR_EraseRootFromParent_Done,
     /* 1388170 */   // Label 19512: @1388170
     /* 1388170 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1388267), // Rule ID 24566 //
     /* 1388175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1388186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1388189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1388205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388225 */     // MIs[1] Operand 1
     /* 1388225 */     // No operand predicates
     /* 1388225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388229 */     // MIs[0] policy
     /* 1388229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1388241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1388244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388266 */     // GIR_Coverage, 24566,
     /* 1388266 */     GIR_EraseRootFromParent_Done,
     /* 1388267 */   // Label 19513: @1388267
     /* 1388267 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1388364), // Rule ID 24567 //
     /* 1388272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1388283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1388286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1388292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1388302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388322 */     // MIs[1] Operand 1
     /* 1388322 */     // No operand predicates
     /* 1388322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388326 */     // MIs[0] policy
     /* 1388326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388338 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1388338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1388341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388363 */     // GIR_Coverage, 24567,
     /* 1388363 */     GIR_EraseRootFromParent_Done,
     /* 1388364 */   // Label 19514: @1388364
     /* 1388364 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1388461), // Rule ID 24570 //
     /* 1388369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1388380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1388383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1388399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388419 */     // MIs[1] Operand 1
     /* 1388419 */     // No operand predicates
     /* 1388419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388423 */     // MIs[0] policy
     /* 1388423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388435 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1388435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1388438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388460 */     // GIR_Coverage, 24570,
     /* 1388460 */     GIR_EraseRootFromParent_Done,
     /* 1388461 */   // Label 19515: @1388461
     /* 1388461 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1388558), // Rule ID 24571 //
     /* 1388466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1388477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1388480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1388486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1388496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388516 */     // MIs[1] Operand 1
     /* 1388516 */     // No operand predicates
     /* 1388516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388520 */     // MIs[0] policy
     /* 1388520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1388532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1388535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388557 */     // GIR_Coverage, 24571,
     /* 1388557 */     GIR_EraseRootFromParent_Done,
     /* 1388558 */   // Label 19516: @1388558
     /* 1388558 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1388655), // Rule ID 24574 //
     /* 1388563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1388574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1388577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1388580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1388586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1388593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388613 */     // MIs[1] Operand 1
     /* 1388613 */     // No operand predicates
     /* 1388613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388617 */     // MIs[0] policy
     /* 1388617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388629 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1388629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1388632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388654 */     // GIR_Coverage, 24574,
     /* 1388654 */     GIR_EraseRootFromParent_Done,
     /* 1388655 */   // Label 19517: @1388655
     /* 1388655 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1388752), // Rule ID 24575 //
     /* 1388660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1388671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1388674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1388677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1388680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1388683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1388690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388710 */     // MIs[1] Operand 1
     /* 1388710 */     // No operand predicates
     /* 1388710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388714 */     // MIs[0] policy
     /* 1388714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1388726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1388729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388751 */     // GIR_Coverage, 24575,
     /* 1388751 */     GIR_EraseRootFromParent_Done,
     /* 1388752 */   // Label 19518: @1388752
     /* 1388752 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1388849), // Rule ID 24578 //
     /* 1388757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1388768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1388771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1388774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1388787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388807 */     // MIs[1] Operand 1
     /* 1388807 */     // No operand predicates
     /* 1388807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388811 */     // MIs[0] policy
     /* 1388811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1388823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1388826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388848 */     // GIR_Coverage, 24578,
     /* 1388848 */     GIR_EraseRootFromParent_Done,
     /* 1388849 */   // Label 19519: @1388849
     /* 1388849 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1388946), // Rule ID 24579 //
     /* 1388854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1388865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1388868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1388871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1388874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1388884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1388904 */     // MIs[1] Operand 1
     /* 1388904 */     // No operand predicates
     /* 1388904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388908 */     // MIs[0] policy
     /* 1388908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1388911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1388913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1388920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1388923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1388927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1388932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1388944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388945 */     // GIR_Coverage, 24579,
     /* 1388945 */     GIR_EraseRootFromParent_Done,
     /* 1388946 */   // Label 19520: @1388946
     /* 1388946 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1389043), // Rule ID 24582 //
     /* 1388951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1388959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1388962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1388965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1388968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1388971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1388981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1388993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1388997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389001 */     // MIs[1] Operand 1
     /* 1389001 */     // No operand predicates
     /* 1389001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389005 */     // MIs[0] policy
     /* 1389005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1389020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389042 */     // GIR_Coverage, 24582,
     /* 1389042 */     GIR_EraseRootFromParent_Done,
     /* 1389043 */   // Label 19521: @1389043
     /* 1389043 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1389140), // Rule ID 24583 //
     /* 1389048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1389059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1389062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1389068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1389078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389098 */     // MIs[1] Operand 1
     /* 1389098 */     // No operand predicates
     /* 1389098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389102 */     // MIs[0] policy
     /* 1389102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1389114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1389117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389139 */     // GIR_Coverage, 24583,
     /* 1389139 */     GIR_EraseRootFromParent_Done,
     /* 1389140 */   // Label 19522: @1389140
     /* 1389140 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1389237), // Rule ID 24586 //
     /* 1389145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1389156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1389159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1389165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1389175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389195 */     // MIs[1] Operand 1
     /* 1389195 */     // No operand predicates
     /* 1389195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389199 */     // MIs[0] policy
     /* 1389199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389211 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1389214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389236 */     // GIR_Coverage, 24586,
     /* 1389236 */     GIR_EraseRootFromParent_Done,
     /* 1389237 */   // Label 19523: @1389237
     /* 1389237 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1389334), // Rule ID 24587 //
     /* 1389242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1389253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1389256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1389262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1389272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389292 */     // MIs[1] Operand 1
     /* 1389292 */     // No operand predicates
     /* 1389292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389296 */     // MIs[0] policy
     /* 1389296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1389308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1389311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389333 */     // GIR_Coverage, 24587,
     /* 1389333 */     GIR_EraseRootFromParent_Done,
     /* 1389334 */   // Label 19524: @1389334
     /* 1389334 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1389431), // Rule ID 24590 //
     /* 1389339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1389350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1389353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1389359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1389369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389389 */     // MIs[1] Operand 1
     /* 1389389 */     // No operand predicates
     /* 1389389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389393 */     // MIs[0] policy
     /* 1389393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1389408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389430 */     // GIR_Coverage, 24590,
     /* 1389430 */     GIR_EraseRootFromParent_Done,
     /* 1389431 */   // Label 19525: @1389431
     /* 1389431 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1389528), // Rule ID 24591 //
     /* 1389436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1389447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1389450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1389456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1389466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389486 */     // MIs[1] Operand 1
     /* 1389486 */     // No operand predicates
     /* 1389486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389490 */     // MIs[0] policy
     /* 1389490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1389502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1389505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389527 */     // GIR_Coverage, 24591,
     /* 1389527 */     GIR_EraseRootFromParent_Done,
     /* 1389528 */   // Label 19526: @1389528
     /* 1389528 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1389625), // Rule ID 24594 //
     /* 1389533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1389544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1389547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1389553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1389563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389583 */     // MIs[1] Operand 1
     /* 1389583 */     // No operand predicates
     /* 1389583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389587 */     // MIs[0] policy
     /* 1389587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1389602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389624 */     // GIR_Coverage, 24594,
     /* 1389624 */     GIR_EraseRootFromParent_Done,
     /* 1389625 */   // Label 19527: @1389625
     /* 1389625 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1389722), // Rule ID 24595 //
     /* 1389630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1389641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1389644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1389650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1389660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389680 */     // MIs[1] Operand 1
     /* 1389680 */     // No operand predicates
     /* 1389680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389684 */     // MIs[0] policy
     /* 1389684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1389696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1389699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389721 */     // GIR_Coverage, 24595,
     /* 1389721 */     GIR_EraseRootFromParent_Done,
     /* 1389722 */   // Label 19528: @1389722
     /* 1389722 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1389819), // Rule ID 24598 //
     /* 1389727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1389738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1389741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1389744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1389747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1389757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389777 */     // MIs[1] Operand 1
     /* 1389777 */     // No operand predicates
     /* 1389777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389781 */     // MIs[0] policy
     /* 1389781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1389796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389818 */     // GIR_Coverage, 24598,
     /* 1389818 */     GIR_EraseRootFromParent_Done,
     /* 1389819 */   // Label 19529: @1389819
     /* 1389819 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1389916), // Rule ID 24599 //
     /* 1389824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1389835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1389838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1389841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1389844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1389854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389874 */     // MIs[1] Operand 1
     /* 1389874 */     // No operand predicates
     /* 1389874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389878 */     // MIs[0] policy
     /* 1389878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1389890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1389893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1389914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389915 */     // GIR_Coverage, 24599,
     /* 1389915 */     GIR_EraseRootFromParent_Done,
     /* 1389916 */   // Label 19530: @1389916
     /* 1389916 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1390013), // Rule ID 24602 //
     /* 1389921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1389924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1389929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1389932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1389935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1389938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1389941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1389944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1389951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1389963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1389967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1389971 */     // MIs[1] Operand 1
     /* 1389971 */     // No operand predicates
     /* 1389971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389975 */     // MIs[0] policy
     /* 1389975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1389978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1389980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1389987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1389990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1389994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1389999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390012 */     // GIR_Coverage, 24602,
     /* 1390012 */     GIR_EraseRootFromParent_Done,
     /* 1390013 */   // Label 19531: @1390013
     /* 1390013 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1390110), // Rule ID 24603 //
     /* 1390018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1390029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1390032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1390038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1390048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390068 */     // MIs[1] Operand 1
     /* 1390068 */     // No operand predicates
     /* 1390068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390072 */     // MIs[0] policy
     /* 1390072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1390084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1390087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390109 */     // GIR_Coverage, 24603,
     /* 1390109 */     GIR_EraseRootFromParent_Done,
     /* 1390110 */   // Label 19532: @1390110
     /* 1390110 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1390207), // Rule ID 24606 //
     /* 1390115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1390126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1390129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1390135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1390145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390165 */     // MIs[1] Operand 1
     /* 1390165 */     // No operand predicates
     /* 1390165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390169 */     // MIs[0] policy
     /* 1390169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1390181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1390184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390206 */     // GIR_Coverage, 24606,
     /* 1390206 */     GIR_EraseRootFromParent_Done,
     /* 1390207 */   // Label 19533: @1390207
     /* 1390207 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1390304), // Rule ID 24607 //
     /* 1390212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1390223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1390226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1390232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1390242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390262 */     // MIs[1] Operand 1
     /* 1390262 */     // No operand predicates
     /* 1390262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390266 */     // MIs[0] policy
     /* 1390266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1390278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1390281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390303 */     // GIR_Coverage, 24607,
     /* 1390303 */     GIR_EraseRootFromParent_Done,
     /* 1390304 */   // Label 19534: @1390304
     /* 1390304 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1390401), // Rule ID 24610 //
     /* 1390309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1390320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1390323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1390329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1390339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390359 */     // MIs[1] Operand 1
     /* 1390359 */     // No operand predicates
     /* 1390359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390363 */     // MIs[0] policy
     /* 1390363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390375 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1390375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1390378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390400 */     // GIR_Coverage, 24610,
     /* 1390400 */     GIR_EraseRootFromParent_Done,
     /* 1390401 */   // Label 19535: @1390401
     /* 1390401 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1390498), // Rule ID 24611 //
     /* 1390406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1390417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1390420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1390426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1390436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390456 */     // MIs[1] Operand 1
     /* 1390456 */     // No operand predicates
     /* 1390456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390460 */     // MIs[0] policy
     /* 1390460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1390472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1390475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390497 */     // GIR_Coverage, 24611,
     /* 1390497 */     GIR_EraseRootFromParent_Done,
     /* 1390498 */   // Label 19536: @1390498
     /* 1390498 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1390595), // Rule ID 24770 //
     /* 1390503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1390506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1390514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1390517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1390520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1390523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390553 */     // MIs[1] Operand 1
     /* 1390553 */     // No operand predicates
     /* 1390553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390557 */     // MIs[0] policy
     /* 1390557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390569 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1390569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1390572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390594 */     // GIR_Coverage, 24770,
     /* 1390594 */     GIR_EraseRootFromParent_Done,
     /* 1390595 */   // Label 19537: @1390595
     /* 1390595 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1390692), // Rule ID 24771 //
     /* 1390600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1390603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1390611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1390614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1390617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1390620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390650 */     // MIs[1] Operand 1
     /* 1390650 */     // No operand predicates
     /* 1390650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390654 */     // MIs[0] policy
     /* 1390654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390666 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1390666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1390669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390691 */     // GIR_Coverage, 24771,
     /* 1390691 */     GIR_EraseRootFromParent_Done,
     /* 1390692 */   // Label 19538: @1390692
     /* 1390692 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1390789), // Rule ID 24774 //
     /* 1390697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1390700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1390714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1390717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390747 */     // MIs[1] Operand 1
     /* 1390747 */     // No operand predicates
     /* 1390747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390751 */     // MIs[0] policy
     /* 1390751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390763 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1390763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1390766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390788 */     // GIR_Coverage, 24774,
     /* 1390788 */     GIR_EraseRootFromParent_Done,
     /* 1390789 */   // Label 19539: @1390789
     /* 1390789 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1390886), // Rule ID 24775 //
     /* 1390794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1390797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1390811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1390814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390844 */     // MIs[1] Operand 1
     /* 1390844 */     // No operand predicates
     /* 1390844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390848 */     // MIs[0] policy
     /* 1390848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1390860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1390863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390885 */     // GIR_Coverage, 24775,
     /* 1390885 */     GIR_EraseRootFromParent_Done,
     /* 1390886 */   // Label 19540: @1390886
     /* 1390886 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1390983), // Rule ID 24778 //
     /* 1390891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1390894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1390908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1390911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1390933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1390937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1390941 */     // MIs[1] Operand 1
     /* 1390941 */     // No operand predicates
     /* 1390941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390945 */     // MIs[0] policy
     /* 1390945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1390948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1390950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390957 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1390957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1390960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1390964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1390969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1390981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390982 */     // GIR_Coverage, 24778,
     /* 1390982 */     GIR_EraseRootFromParent_Done,
     /* 1390983 */   // Label 19541: @1390983
     /* 1390983 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1391080), // Rule ID 24779 //
     /* 1390988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1390991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1390996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1391005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391038 */     // MIs[1] Operand 1
     /* 1391038 */     // No operand predicates
     /* 1391038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391042 */     // MIs[0] policy
     /* 1391042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391054 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1391054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1391057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391079 */     // GIR_Coverage, 24779,
     /* 1391079 */     GIR_EraseRootFromParent_Done,
     /* 1391080 */   // Label 19542: @1391080
     /* 1391080 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1391177), // Rule ID 24782 //
     /* 1391085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1391096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1391099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1391102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1391105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1391115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391135 */     // MIs[1] Operand 1
     /* 1391135 */     // No operand predicates
     /* 1391135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391139 */     // MIs[0] policy
     /* 1391139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1391151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1391154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391176 */     // GIR_Coverage, 24782,
     /* 1391176 */     GIR_EraseRootFromParent_Done,
     /* 1391177 */   // Label 19543: @1391177
     /* 1391177 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1391274), // Rule ID 24783 //
     /* 1391182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1391185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1391193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1391196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1391199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1391212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391232 */     // MIs[1] Operand 1
     /* 1391232 */     // No operand predicates
     /* 1391232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391236 */     // MIs[0] policy
     /* 1391236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391248 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1391248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1391251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391273 */     // GIR_Coverage, 24783,
     /* 1391273 */     GIR_EraseRootFromParent_Done,
     /* 1391274 */   // Label 19544: @1391274
     /* 1391274 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1391371), // Rule ID 24786 //
     /* 1391279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1391290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1391293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1391299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1391309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391329 */     // MIs[1] Operand 1
     /* 1391329 */     // No operand predicates
     /* 1391329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391333 */     // MIs[0] policy
     /* 1391333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391345 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1391345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1391348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391370 */     // GIR_Coverage, 24786,
     /* 1391370 */     GIR_EraseRootFromParent_Done,
     /* 1391371 */   // Label 19545: @1391371
     /* 1391371 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1391468), // Rule ID 24787 //
     /* 1391376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1391379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1391387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1391390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1391406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391426 */     // MIs[1] Operand 1
     /* 1391426 */     // No operand predicates
     /* 1391426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391430 */     // MIs[0] policy
     /* 1391430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391442 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1391442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1391445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391467 */     // GIR_Coverage, 24787,
     /* 1391467 */     GIR_EraseRootFromParent_Done,
     /* 1391468 */   // Label 19546: @1391468
     /* 1391468 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1391565), // Rule ID 24790 //
     /* 1391473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1391484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1391487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1391490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1391493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1391503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391523 */     // MIs[1] Operand 1
     /* 1391523 */     // No operand predicates
     /* 1391523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391527 */     // MIs[0] policy
     /* 1391527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391539 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1391539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1391542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391564 */     // GIR_Coverage, 24790,
     /* 1391564 */     GIR_EraseRootFromParent_Done,
     /* 1391565 */   // Label 19547: @1391565
     /* 1391565 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1391662), // Rule ID 24791 //
     /* 1391570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1391573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1391581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1391584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1391587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1391600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391620 */     // MIs[1] Operand 1
     /* 1391620 */     // No operand predicates
     /* 1391620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391624 */     // MIs[0] policy
     /* 1391624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391636 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1391636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1391639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391661 */     // GIR_Coverage, 24791,
     /* 1391661 */     GIR_EraseRootFromParent_Done,
     /* 1391662 */   // Label 19548: @1391662
     /* 1391662 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1391759), // Rule ID 24794 //
     /* 1391667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1391670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1391678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1391681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1391684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1391687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1391697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391717 */     // MIs[1] Operand 1
     /* 1391717 */     // No operand predicates
     /* 1391717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391721 */     // MIs[0] policy
     /* 1391721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391733 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1391733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1391736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391758 */     // GIR_Coverage, 24794,
     /* 1391758 */     GIR_EraseRootFromParent_Done,
     /* 1391759 */   // Label 19549: @1391759
     /* 1391759 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1391856), // Rule ID 24795 //
     /* 1391764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1391767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1391775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1391778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1391781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1391794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391814 */     // MIs[1] Operand 1
     /* 1391814 */     // No operand predicates
     /* 1391814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391818 */     // MIs[0] policy
     /* 1391818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1391830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1391833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391855 */     // GIR_Coverage, 24795,
     /* 1391855 */     GIR_EraseRootFromParent_Done,
     /* 1391856 */   // Label 19550: @1391856
     /* 1391856 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1391953), // Rule ID 24798 //
     /* 1391861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1391864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1391872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1391875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1391878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1391881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1391891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1391903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1391907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1391911 */     // MIs[1] Operand 1
     /* 1391911 */     // No operand predicates
     /* 1391911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391915 */     // MIs[0] policy
     /* 1391915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1391918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1391927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1391930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1391934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1391939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1391951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391952 */     // GIR_Coverage, 24798,
     /* 1391952 */     GIR_EraseRootFromParent_Done,
     /* 1391953 */   // Label 19551: @1391953
     /* 1391953 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1392050), // Rule ID 24799 //
     /* 1391958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1391961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1391966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1391969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1391972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1391975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1391978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1391988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392008 */     // MIs[1] Operand 1
     /* 1392008 */     // No operand predicates
     /* 1392008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392012 */     // MIs[0] policy
     /* 1392012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392024 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1392027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392049 */     // GIR_Coverage, 24799,
     /* 1392049 */     GIR_EraseRootFromParent_Done,
     /* 1392050 */   // Label 19552: @1392050
     /* 1392050 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1392147), // Rule ID 24802 //
     /* 1392055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1392058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1392066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1392069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1392072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1392075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1392085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392105 */     // MIs[1] Operand 1
     /* 1392105 */     // No operand predicates
     /* 1392105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392109 */     // MIs[0] policy
     /* 1392109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392121 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1392121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1392124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392146 */     // GIR_Coverage, 24802,
     /* 1392146 */     GIR_EraseRootFromParent_Done,
     /* 1392147 */   // Label 19553: @1392147
     /* 1392147 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1392244), // Rule ID 24803 //
     /* 1392152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1392155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1392163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1392166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1392169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1392172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1392182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392202 */     // MIs[1] Operand 1
     /* 1392202 */     // No operand predicates
     /* 1392202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392206 */     // MIs[0] policy
     /* 1392206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392218 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1392221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392243 */     // GIR_Coverage, 24803,
     /* 1392243 */     GIR_EraseRootFromParent_Done,
     /* 1392244 */   // Label 19554: @1392244
     /* 1392244 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1392341), // Rule ID 24854 //
     /* 1392249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1392252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1392260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1392263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1392266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1392269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392299 */     // MIs[1] Operand 1
     /* 1392299 */     // No operand predicates
     /* 1392299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392303 */     // MIs[0] policy
     /* 1392303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392315 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1392315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1392318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392340 */     // GIR_Coverage, 24854,
     /* 1392340 */     GIR_EraseRootFromParent_Done,
     /* 1392341 */   // Label 19555: @1392341
     /* 1392341 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1392438), // Rule ID 24855 //
     /* 1392346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1392349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1392357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1392360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1392363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1392366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392396 */     // MIs[1] Operand 1
     /* 1392396 */     // No operand predicates
     /* 1392396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392400 */     // MIs[0] policy
     /* 1392400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392412 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1392415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392437 */     // GIR_Coverage, 24855,
     /* 1392437 */     GIR_EraseRootFromParent_Done,
     /* 1392438 */   // Label 19556: @1392438
     /* 1392438 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1392535), // Rule ID 24858 //
     /* 1392443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1392446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1392454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1392457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1392463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392493 */     // MIs[1] Operand 1
     /* 1392493 */     // No operand predicates
     /* 1392493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392497 */     // MIs[0] policy
     /* 1392497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392509 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1392509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1392512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392534 */     // GIR_Coverage, 24858,
     /* 1392534 */     GIR_EraseRootFromParent_Done,
     /* 1392535 */   // Label 19557: @1392535
     /* 1392535 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1392632), // Rule ID 24859 //
     /* 1392540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1392543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1392551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1392554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1392560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392590 */     // MIs[1] Operand 1
     /* 1392590 */     // No operand predicates
     /* 1392590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392594 */     // MIs[0] policy
     /* 1392594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392606 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1392609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392631 */     // GIR_Coverage, 24859,
     /* 1392631 */     GIR_EraseRootFromParent_Done,
     /* 1392632 */   // Label 19558: @1392632
     /* 1392632 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1392729), // Rule ID 24862 //
     /* 1392637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1392640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1392657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392687 */     // MIs[1] Operand 1
     /* 1392687 */     // No operand predicates
     /* 1392687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392691 */     // MIs[0] policy
     /* 1392691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392703 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1392703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1392706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392728 */     // GIR_Coverage, 24862,
     /* 1392728 */     GIR_EraseRootFromParent_Done,
     /* 1392729 */   // Label 19559: @1392729
     /* 1392729 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1392826), // Rule ID 24863 //
     /* 1392734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1392737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1392754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392784 */     // MIs[1] Operand 1
     /* 1392784 */     // No operand predicates
     /* 1392784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392788 */     // MIs[0] policy
     /* 1392788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1392803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392825 */     // GIR_Coverage, 24863,
     /* 1392825 */     GIR_EraseRootFromParent_Done,
     /* 1392826 */   // Label 19560: @1392826
     /* 1392826 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1392923), // Rule ID 24866 //
     /* 1392831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1392834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1392842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1392845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1392851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1392861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392881 */     // MIs[1] Operand 1
     /* 1392881 */     // No operand predicates
     /* 1392881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392885 */     // MIs[0] policy
     /* 1392885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392897 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1392897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1392900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1392904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1392909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1392921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392922 */     // GIR_Coverage, 24866,
     /* 1392922 */     GIR_EraseRootFromParent_Done,
     /* 1392923 */   // Label 19561: @1392923
     /* 1392923 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1393020), // Rule ID 24867 //
     /* 1392928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1392931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1392936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1392939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1392942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1392948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1392958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1392970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1392974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1392978 */     // MIs[1] Operand 1
     /* 1392978 */     // No operand predicates
     /* 1392978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392982 */     // MIs[0] policy
     /* 1392982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1392985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1392987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392994 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1392994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1392997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393019 */     // GIR_Coverage, 24867,
     /* 1393019 */     GIR_EraseRootFromParent_Done,
     /* 1393020 */   // Label 19562: @1393020
     /* 1393020 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1393117), // Rule ID 24870 //
     /* 1393025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1393028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1393033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1393036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1393039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1393045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1393055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393075 */     // MIs[1] Operand 1
     /* 1393075 */     // No operand predicates
     /* 1393075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393079 */     // MIs[0] policy
     /* 1393079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393091 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1393091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1393094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393116 */     // GIR_Coverage, 24870,
     /* 1393116 */     GIR_EraseRootFromParent_Done,
     /* 1393117 */   // Label 19563: @1393117
     /* 1393117 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1393214), // Rule ID 24871 //
     /* 1393122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1393125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1393130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1393133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1393136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1393142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1393152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393172 */     // MIs[1] Operand 1
     /* 1393172 */     // No operand predicates
     /* 1393172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393176 */     // MIs[0] policy
     /* 1393176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393188 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1393188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1393191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393213 */     // GIR_Coverage, 24871,
     /* 1393213 */     GIR_EraseRootFromParent_Done,
     /* 1393214 */   // Label 19564: @1393214
     /* 1393214 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1393311), // Rule ID 24874 //
     /* 1393219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1393222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1393227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1393230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1393233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1393239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1393249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393269 */     // MIs[1] Operand 1
     /* 1393269 */     // No operand predicates
     /* 1393269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393273 */     // MIs[0] policy
     /* 1393273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393285 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1393285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1393288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393310 */     // GIR_Coverage, 24874,
     /* 1393310 */     GIR_EraseRootFromParent_Done,
     /* 1393311 */   // Label 19565: @1393311
     /* 1393311 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1393408), // Rule ID 24875 //
     /* 1393316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1393319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1393324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1393327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1393330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1393336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1393346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393366 */     // MIs[1] Operand 1
     /* 1393366 */     // No operand predicates
     /* 1393366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393370 */     // MIs[0] policy
     /* 1393370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393382 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1393382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1393385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393407 */     // GIR_Coverage, 24875,
     /* 1393407 */     GIR_EraseRootFromParent_Done,
     /* 1393408 */   // Label 19566: @1393408
     /* 1393408 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1393505), // Rule ID 60310 //
     /* 1393413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1393416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1393424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1393427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1393433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393463 */     // MIs[1] Operand 1
     /* 1393463 */     // No operand predicates
     /* 1393463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393467 */     // MIs[0] policy
     /* 1393467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393479 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1393479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1393482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393504 */     // GIR_Coverage, 60310,
     /* 1393504 */     GIR_EraseRootFromParent_Done,
     /* 1393505 */   // Label 19567: @1393505
     /* 1393505 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1393602), // Rule ID 60311 //
     /* 1393510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1393513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1393521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1393524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1393530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393560 */     // MIs[1] Operand 1
     /* 1393560 */     // No operand predicates
     /* 1393560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393564 */     // MIs[0] policy
     /* 1393564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1393576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1393579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393601 */     // GIR_Coverage, 60311,
     /* 1393601 */     GIR_EraseRootFromParent_Done,
     /* 1393602 */   // Label 19568: @1393602
     /* 1393602 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1393699), // Rule ID 60318 //
     /* 1393607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1393610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1393618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1393621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1393627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393657 */     // MIs[1] Operand 1
     /* 1393657 */     // No operand predicates
     /* 1393657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393661 */     // MIs[0] policy
     /* 1393661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393673 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1393673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1393676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393698 */     // GIR_Coverage, 60318,
     /* 1393698 */     GIR_EraseRootFromParent_Done,
     /* 1393699 */   // Label 19569: @1393699
     /* 1393699 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1393796), // Rule ID 60319 //
     /* 1393704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1393707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1393715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1393718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1393724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393754 */     // MIs[1] Operand 1
     /* 1393754 */     // No operand predicates
     /* 1393754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393758 */     // MIs[0] policy
     /* 1393758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1393770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1393773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393795 */     // GIR_Coverage, 60319,
     /* 1393795 */     GIR_EraseRootFromParent_Done,
     /* 1393796 */   // Label 19570: @1393796
     /* 1393796 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1393893), // Rule ID 60326 //
     /* 1393801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1393804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1393818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1393821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393851 */     // MIs[1] Operand 1
     /* 1393851 */     // No operand predicates
     /* 1393851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393855 */     // MIs[0] policy
     /* 1393855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393867 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1393867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1393870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393892 */     // GIR_Coverage, 60326,
     /* 1393892 */     GIR_EraseRootFromParent_Done,
     /* 1393893 */   // Label 19571: @1393893
     /* 1393893 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1393990), // Rule ID 60327 //
     /* 1393898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1393901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1393906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1393915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1393918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1393940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1393944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1393948 */     // MIs[1] Operand 1
     /* 1393948 */     // No operand predicates
     /* 1393948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393952 */     // MIs[0] policy
     /* 1393952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1393955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1393957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1393964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1393967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1393971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1393976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1393988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393989 */     // GIR_Coverage, 60327,
     /* 1393989 */     GIR_EraseRootFromParent_Done,
     /* 1393990 */   // Label 19572: @1393990
     /* 1393990 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1394087), // Rule ID 60334 //
     /* 1393995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1393998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1394006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1394009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1394025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394045 */     // MIs[1] Operand 1
     /* 1394045 */     // No operand predicates
     /* 1394045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394049 */     // MIs[0] policy
     /* 1394049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1394061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1394064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394086 */     // GIR_Coverage, 60334,
     /* 1394086 */     GIR_EraseRootFromParent_Done,
     /* 1394087 */   // Label 19573: @1394087
     /* 1394087 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1394184), // Rule ID 60335 //
     /* 1394092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1394095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1394103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1394106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1394112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1394122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394142 */     // MIs[1] Operand 1
     /* 1394142 */     // No operand predicates
     /* 1394142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394146 */     // MIs[0] policy
     /* 1394146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1394158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1394161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394183 */     // GIR_Coverage, 60335,
     /* 1394183 */     GIR_EraseRootFromParent_Done,
     /* 1394184 */   // Label 19574: @1394184
     /* 1394184 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1394281), // Rule ID 60342 //
     /* 1394189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1394192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1394200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1394203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1394206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1394219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394239 */     // MIs[1] Operand 1
     /* 1394239 */     // No operand predicates
     /* 1394239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394243 */     // MIs[0] policy
     /* 1394243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1394255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1394258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394280 */     // GIR_Coverage, 60342,
     /* 1394280 */     GIR_EraseRootFromParent_Done,
     /* 1394281 */   // Label 19575: @1394281
     /* 1394281 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1394378), // Rule ID 60343 //
     /* 1394286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1394289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1394297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1394300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1394303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1394306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1394316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394336 */     // MIs[1] Operand 1
     /* 1394336 */     // No operand predicates
     /* 1394336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394340 */     // MIs[0] policy
     /* 1394340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1394352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1394355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394377 */     // GIR_Coverage, 60343,
     /* 1394377 */     GIR_EraseRootFromParent_Done,
     /* 1394378 */   // Label 19576: @1394378
     /* 1394378 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1394475), // Rule ID 60350 //
     /* 1394383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1394386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1394394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1394397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1394400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1394406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1394413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394433 */     // MIs[1] Operand 1
     /* 1394433 */     // No operand predicates
     /* 1394433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394437 */     // MIs[0] policy
     /* 1394437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394449 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1394449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1394452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394474 */     // GIR_Coverage, 60350,
     /* 1394474 */     GIR_EraseRootFromParent_Done,
     /* 1394475 */   // Label 19577: @1394475
     /* 1394475 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1394572), // Rule ID 60351 //
     /* 1394480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1394483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1394491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1394494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1394497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1394500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1394503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1394510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394530 */     // MIs[1] Operand 1
     /* 1394530 */     // No operand predicates
     /* 1394530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394534 */     // MIs[0] policy
     /* 1394534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1394546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1394549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394571 */     // GIR_Coverage, 60351,
     /* 1394571 */     GIR_EraseRootFromParent_Done,
     /* 1394572 */   // Label 19578: @1394572
     /* 1394572 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1394669), // Rule ID 60358 //
     /* 1394577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1394580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1394588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1394591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394627 */     // MIs[1] Operand 1
     /* 1394627 */     // No operand predicates
     /* 1394627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394631 */     // MIs[0] policy
     /* 1394631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1394643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1394646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394668 */     // GIR_Coverage, 60358,
     /* 1394668 */     GIR_EraseRootFromParent_Done,
     /* 1394669 */   // Label 19579: @1394669
     /* 1394669 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1394766), // Rule ID 60359 //
     /* 1394674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1394677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1394685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1394688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1394694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394724 */     // MIs[1] Operand 1
     /* 1394724 */     // No operand predicates
     /* 1394724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394728 */     // MIs[0] policy
     /* 1394728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1394740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1394743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394765 */     // GIR_Coverage, 60359,
     /* 1394765 */     GIR_EraseRootFromParent_Done,
     /* 1394766 */   // Label 19580: @1394766
     /* 1394766 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1394863), // Rule ID 60366 //
     /* 1394771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1394774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394821 */     // MIs[1] Operand 1
     /* 1394821 */     // No operand predicates
     /* 1394821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394825 */     // MIs[0] policy
     /* 1394825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1394837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1394840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394862 */     // GIR_Coverage, 60366,
     /* 1394862 */     GIR_EraseRootFromParent_Done,
     /* 1394863 */   // Label 19581: @1394863
     /* 1394863 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1394960), // Rule ID 60367 //
     /* 1394868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1394871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1394888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1394910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1394914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1394918 */     // MIs[1] Operand 1
     /* 1394918 */     // No operand predicates
     /* 1394918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394922 */     // MIs[0] policy
     /* 1394922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1394925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1394927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1394934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1394937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1394941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1394946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1394958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394959 */     // GIR_Coverage, 60367,
     /* 1394959 */     GIR_EraseRootFromParent_Done,
     /* 1394960 */   // Label 19582: @1394960
     /* 1394960 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1395057), // Rule ID 60374 //
     /* 1394965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1394968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1394973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1394976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1394979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1394985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1394995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395015 */     // MIs[1] Operand 1
     /* 1395015 */     // No operand predicates
     /* 1395015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395019 */     // MIs[0] policy
     /* 1395019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1395034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395056 */     // GIR_Coverage, 60374,
     /* 1395056 */     GIR_EraseRootFromParent_Done,
     /* 1395057 */   // Label 19583: @1395057
     /* 1395057 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1395154), // Rule ID 60375 //
     /* 1395062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1395065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1395073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1395076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1395092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395112 */     // MIs[1] Operand 1
     /* 1395112 */     // No operand predicates
     /* 1395112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395116 */     // MIs[0] policy
     /* 1395116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1395131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395153 */     // GIR_Coverage, 60375,
     /* 1395153 */     GIR_EraseRootFromParent_Done,
     /* 1395154 */   // Label 19584: @1395154
     /* 1395154 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1395251), // Rule ID 60382 //
     /* 1395159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1395162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1395170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1395173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1395189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395209 */     // MIs[1] Operand 1
     /* 1395209 */     // No operand predicates
     /* 1395209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395213 */     // MIs[0] policy
     /* 1395213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395225 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1395228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395250 */     // GIR_Coverage, 60382,
     /* 1395250 */     GIR_EraseRootFromParent_Done,
     /* 1395251 */   // Label 19585: @1395251
     /* 1395251 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1395348), // Rule ID 60383 //
     /* 1395256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1395259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1395267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1395270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1395286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395306 */     // MIs[1] Operand 1
     /* 1395306 */     // No operand predicates
     /* 1395306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395310 */     // MIs[0] policy
     /* 1395310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1395325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395347 */     // GIR_Coverage, 60383,
     /* 1395347 */     GIR_EraseRootFromParent_Done,
     /* 1395348 */   // Label 19586: @1395348
     /* 1395348 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1395445), // Rule ID 60390 //
     /* 1395353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1395356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1395364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1395367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1395383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395403 */     // MIs[1] Operand 1
     /* 1395403 */     // No operand predicates
     /* 1395403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395407 */     // MIs[0] policy
     /* 1395407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1395422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395444 */     // GIR_Coverage, 60390,
     /* 1395444 */     GIR_EraseRootFromParent_Done,
     /* 1395445 */   // Label 19587: @1395445
     /* 1395445 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1395542), // Rule ID 60391 //
     /* 1395450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1395453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1395461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1395464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1395480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395500 */     // MIs[1] Operand 1
     /* 1395500 */     // No operand predicates
     /* 1395500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395504 */     // MIs[0] policy
     /* 1395504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1395519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395541 */     // GIR_Coverage, 60391,
     /* 1395541 */     GIR_EraseRootFromParent_Done,
     /* 1395542 */   // Label 19588: @1395542
     /* 1395542 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1395639), // Rule ID 60398 //
     /* 1395547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1395550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395597 */     // MIs[1] Operand 1
     /* 1395597 */     // No operand predicates
     /* 1395597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395601 */     // MIs[0] policy
     /* 1395601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395613 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1395616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395638 */     // GIR_Coverage, 60398,
     /* 1395638 */     GIR_EraseRootFromParent_Done,
     /* 1395639 */   // Label 19589: @1395639
     /* 1395639 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1395736), // Rule ID 60399 //
     /* 1395644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1395647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395694 */     // MIs[1] Operand 1
     /* 1395694 */     // No operand predicates
     /* 1395694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395698 */     // MIs[0] policy
     /* 1395698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1395713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395735 */     // GIR_Coverage, 60399,
     /* 1395735 */     GIR_EraseRootFromParent_Done,
     /* 1395736 */   // Label 19590: @1395736
     /* 1395736 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1395833), // Rule ID 60406 //
     /* 1395741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1395744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1395752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1395755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1395771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395791 */     // MIs[1] Operand 1
     /* 1395791 */     // No operand predicates
     /* 1395791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395795 */     // MIs[0] policy
     /* 1395795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1395810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395832 */     // GIR_Coverage, 60406,
     /* 1395832 */     GIR_EraseRootFromParent_Done,
     /* 1395833 */   // Label 19591: @1395833
     /* 1395833 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1395930), // Rule ID 60407 //
     /* 1395838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1395841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1395849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1395852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1395868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395888 */     // MIs[1] Operand 1
     /* 1395888 */     // No operand predicates
     /* 1395888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395892 */     // MIs[0] policy
     /* 1395892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1395907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1395916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395929 */     // GIR_Coverage, 60407,
     /* 1395929 */     GIR_EraseRootFromParent_Done,
     /* 1395930 */   // Label 19592: @1395930
     /* 1395930 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1396027), // Rule ID 60414 //
     /* 1395935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1395938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1395943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1395946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1395949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1395952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1395965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1395977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1395981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1395985 */     // MIs[1] Operand 1
     /* 1395985 */     // No operand predicates
     /* 1395985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395989 */     // MIs[0] policy
     /* 1395989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1395994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396001 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1396004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396026 */     // GIR_Coverage, 60414,
     /* 1396026 */     GIR_EraseRootFromParent_Done,
     /* 1396027 */   // Label 19593: @1396027
     /* 1396027 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1396124), // Rule ID 60415 //
     /* 1396032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1396035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1396040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1396043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1396046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1396062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1396082 */     // MIs[1] Operand 1
     /* 1396082 */     // No operand predicates
     /* 1396082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396086 */     // MIs[0] policy
     /* 1396086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1396101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396123 */     // GIR_Coverage, 60415,
     /* 1396123 */     GIR_EraseRootFromParent_Done,
     /* 1396124 */   // Label 19594: @1396124
     /* 1396124 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1396221), // Rule ID 60422 //
     /* 1396129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1396132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1396137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1396140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1396143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1396159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1396179 */     // MIs[1] Operand 1
     /* 1396179 */     // No operand predicates
     /* 1396179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396183 */     // MIs[0] policy
     /* 1396183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396195 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1396198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396220 */     // GIR_Coverage, 60422,
     /* 1396220 */     GIR_EraseRootFromParent_Done,
     /* 1396221 */   // Label 19595: @1396221
     /* 1396221 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1396318), // Rule ID 60423 //
     /* 1396226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1396229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1396234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1396237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1396240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1396256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1396276 */     // MIs[1] Operand 1
     /* 1396276 */     // No operand predicates
     /* 1396276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396280 */     // MIs[0] policy
     /* 1396280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1396295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396317 */     // GIR_Coverage, 60423,
     /* 1396317 */     GIR_EraseRootFromParent_Done,
     /* 1396318 */   // Label 19596: @1396318
     /* 1396318 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1396415), // Rule ID 61278 //
     /* 1396323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1396326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1396334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1396337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1396340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396373 */     // MIs[1] Operand 1
     /* 1396373 */     // No operand predicates
     /* 1396373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396377 */     // MIs[0] policy
     /* 1396377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396389 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1396392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396414 */     // GIR_Coverage, 61278,
     /* 1396414 */     GIR_EraseRootFromParent_Done,
     /* 1396415 */   // Label 19597: @1396415
     /* 1396415 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1396512), // Rule ID 61279 //
     /* 1396420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1396423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1396431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1396434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1396437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396470 */     // MIs[1] Operand 1
     /* 1396470 */     // No operand predicates
     /* 1396470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396474 */     // MIs[0] policy
     /* 1396474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396486 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1396489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396511 */     // GIR_Coverage, 61279,
     /* 1396511 */     GIR_EraseRootFromParent_Done,
     /* 1396512 */   // Label 19598: @1396512
     /* 1396512 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1396609), // Rule ID 61282 //
     /* 1396517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1396520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1396528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1396531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1396534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396567 */     // MIs[1] Operand 1
     /* 1396567 */     // No operand predicates
     /* 1396567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396571 */     // MIs[0] policy
     /* 1396571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396583 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1396586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396608 */     // GIR_Coverage, 61282,
     /* 1396608 */     GIR_EraseRootFromParent_Done,
     /* 1396609 */   // Label 19599: @1396609
     /* 1396609 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1396706), // Rule ID 61283 //
     /* 1396614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1396617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1396625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1396628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1396631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396664 */     // MIs[1] Operand 1
     /* 1396664 */     // No operand predicates
     /* 1396664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396668 */     // MIs[0] policy
     /* 1396668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1396683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396705 */     // GIR_Coverage, 61283,
     /* 1396705 */     GIR_EraseRootFromParent_Done,
     /* 1396706 */   // Label 19600: @1396706
     /* 1396706 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1396803), // Rule ID 61286 //
     /* 1396711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1396714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1396722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1396725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1396728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396761 */     // MIs[1] Operand 1
     /* 1396761 */     // No operand predicates
     /* 1396761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396765 */     // MIs[0] policy
     /* 1396765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396777 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1396780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396802 */     // GIR_Coverage, 61286,
     /* 1396802 */     GIR_EraseRootFromParent_Done,
     /* 1396803 */   // Label 19601: @1396803
     /* 1396803 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1396900), // Rule ID 61287 //
     /* 1396808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1396811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1396819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1396822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1396825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396858 */     // MIs[1] Operand 1
     /* 1396858 */     // No operand predicates
     /* 1396858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396862 */     // MIs[0] policy
     /* 1396862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1396877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396899 */     // GIR_Coverage, 61287,
     /* 1396899 */     GIR_EraseRootFromParent_Done,
     /* 1396900 */   // Label 19602: @1396900
     /* 1396900 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1396997), // Rule ID 61290 //
     /* 1396905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1396908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1396913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1396916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1396919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1396947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1396951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1396955 */     // MIs[1] Operand 1
     /* 1396955 */     // No operand predicates
     /* 1396955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396959 */     // MIs[0] policy
     /* 1396959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1396964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396971 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1396974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1396983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396996 */     // GIR_Coverage, 61290,
     /* 1396996 */     GIR_EraseRootFromParent_Done,
     /* 1396997 */   // Label 19603: @1396997
     /* 1396997 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1397094), // Rule ID 61291 //
     /* 1397002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1397013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1397016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397052 */     // MIs[1] Operand 1
     /* 1397052 */     // No operand predicates
     /* 1397052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397056 */     // MIs[0] policy
     /* 1397056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1397071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397093 */     // GIR_Coverage, 61291,
     /* 1397093 */     GIR_EraseRootFromParent_Done,
     /* 1397094 */   // Label 19604: @1397094
     /* 1397094 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1397191), // Rule ID 61294 //
     /* 1397099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1397102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1397110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1397113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397149 */     // MIs[1] Operand 1
     /* 1397149 */     // No operand predicates
     /* 1397149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397153 */     // MIs[0] policy
     /* 1397153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397165 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1397168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397190 */     // GIR_Coverage, 61294,
     /* 1397190 */     GIR_EraseRootFromParent_Done,
     /* 1397191 */   // Label 19605: @1397191
     /* 1397191 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1397288), // Rule ID 61295 //
     /* 1397196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1397207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1397210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397246 */     // MIs[1] Operand 1
     /* 1397246 */     // No operand predicates
     /* 1397246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397250 */     // MIs[0] policy
     /* 1397250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397262 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1397265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397287 */     // GIR_Coverage, 61295,
     /* 1397287 */     GIR_EraseRootFromParent_Done,
     /* 1397288 */   // Label 19606: @1397288
     /* 1397288 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1397385), // Rule ID 61298 //
     /* 1397293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1397296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1397304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1397307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397343 */     // MIs[1] Operand 1
     /* 1397343 */     // No operand predicates
     /* 1397343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397347 */     // MIs[0] policy
     /* 1397347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397359 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1397362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397384 */     // GIR_Coverage, 61298,
     /* 1397384 */     GIR_EraseRootFromParent_Done,
     /* 1397385 */   // Label 19607: @1397385
     /* 1397385 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1397482), // Rule ID 61299 //
     /* 1397390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1397401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1397404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397440 */     // MIs[1] Operand 1
     /* 1397440 */     // No operand predicates
     /* 1397440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397444 */     // MIs[0] policy
     /* 1397444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1397459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397481 */     // GIR_Coverage, 61299,
     /* 1397481 */     GIR_EraseRootFromParent_Done,
     /* 1397482 */   // Label 19608: @1397482
     /* 1397482 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1397579), // Rule ID 61302 //
     /* 1397487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1397490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1397498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1397501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1397504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397537 */     // MIs[1] Operand 1
     /* 1397537 */     // No operand predicates
     /* 1397537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397541 */     // MIs[0] policy
     /* 1397541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397553 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1397556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397578 */     // GIR_Coverage, 61302,
     /* 1397578 */     GIR_EraseRootFromParent_Done,
     /* 1397579 */   // Label 19609: @1397579
     /* 1397579 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1397676), // Rule ID 61303 //
     /* 1397584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1397595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1397598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1397601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397634 */     // MIs[1] Operand 1
     /* 1397634 */     // No operand predicates
     /* 1397634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397638 */     // MIs[0] policy
     /* 1397638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1397653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397675 */     // GIR_Coverage, 61303,
     /* 1397675 */     GIR_EraseRootFromParent_Done,
     /* 1397676 */   // Label 19610: @1397676
     /* 1397676 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1397773), // Rule ID 61306 //
     /* 1397681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1397684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397731 */     // MIs[1] Operand 1
     /* 1397731 */     // No operand predicates
     /* 1397731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397735 */     // MIs[0] policy
     /* 1397735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397747 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1397750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397772 */     // GIR_Coverage, 61306,
     /* 1397772 */     GIR_EraseRootFromParent_Done,
     /* 1397773 */   // Label 19611: @1397773
     /* 1397773 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1397870), // Rule ID 61307 //
     /* 1397778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397828 */     // MIs[1] Operand 1
     /* 1397828 */     // No operand predicates
     /* 1397828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397832 */     // MIs[0] policy
     /* 1397832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1397847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397869 */     // GIR_Coverage, 61307,
     /* 1397869 */     GIR_EraseRootFromParent_Done,
     /* 1397870 */   // Label 19612: @1397870
     /* 1397870 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1397967), // Rule ID 61310 //
     /* 1397875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1397878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1397917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1397925 */     // MIs[1] Operand 1
     /* 1397925 */     // No operand predicates
     /* 1397925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397929 */     // MIs[0] policy
     /* 1397929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1397934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397941 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1397944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1397953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397966 */     // GIR_Coverage, 61310,
     /* 1397966 */     GIR_EraseRootFromParent_Done,
     /* 1397967 */   // Label 19613: @1397967
     /* 1397967 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1398064), // Rule ID 61311 //
     /* 1397972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1397975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1397980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398022 */     // MIs[1] Operand 1
     /* 1398022 */     // No operand predicates
     /* 1398022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398026 */     // MIs[0] policy
     /* 1398026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1398041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398063 */     // GIR_Coverage, 61311,
     /* 1398063 */     GIR_EraseRootFromParent_Done,
     /* 1398064 */   // Label 19614: @1398064
     /* 1398064 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1398161), // Rule ID 61314 //
     /* 1398069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1398072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1398086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398119 */     // MIs[1] Operand 1
     /* 1398119 */     // No operand predicates
     /* 1398119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398123 */     // MIs[0] policy
     /* 1398123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398135 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1398138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398160 */     // GIR_Coverage, 61314,
     /* 1398160 */     GIR_EraseRootFromParent_Done,
     /* 1398161 */   // Label 19615: @1398161
     /* 1398161 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1398258), // Rule ID 61315 //
     /* 1398166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1398169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1398183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398216 */     // MIs[1] Operand 1
     /* 1398216 */     // No operand predicates
     /* 1398216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398220 */     // MIs[0] policy
     /* 1398220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1398235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398257 */     // GIR_Coverage, 61315,
     /* 1398257 */     GIR_EraseRootFromParent_Done,
     /* 1398258 */   // Label 19616: @1398258
     /* 1398258 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1398355), // Rule ID 61318 //
     /* 1398263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1398266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1398274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1398277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1398280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398313 */     // MIs[1] Operand 1
     /* 1398313 */     // No operand predicates
     /* 1398313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398317 */     // MIs[0] policy
     /* 1398317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1398332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398354 */     // GIR_Coverage, 61318,
     /* 1398354 */     GIR_EraseRootFromParent_Done,
     /* 1398355 */   // Label 19617: @1398355
     /* 1398355 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1398452), // Rule ID 61319 //
     /* 1398360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1398363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1398371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1398374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1398377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398410 */     // MIs[1] Operand 1
     /* 1398410 */     // No operand predicates
     /* 1398410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398414 */     // MIs[0] policy
     /* 1398414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1398429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398451 */     // GIR_Coverage, 61319,
     /* 1398451 */     GIR_EraseRootFromParent_Done,
     /* 1398452 */   // Label 19618: @1398452
     /* 1398452 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1398549), // Rule ID 61322 //
     /* 1398457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1398460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1398468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1398471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1398474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398507 */     // MIs[1] Operand 1
     /* 1398507 */     // No operand predicates
     /* 1398507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398511 */     // MIs[0] policy
     /* 1398511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398523 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1398526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398548 */     // GIR_Coverage, 61322,
     /* 1398548 */     GIR_EraseRootFromParent_Done,
     /* 1398549 */   // Label 19619: @1398549
     /* 1398549 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1398646), // Rule ID 61323 //
     /* 1398554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1398557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1398565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1398568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1398571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398604 */     // MIs[1] Operand 1
     /* 1398604 */     // No operand predicates
     /* 1398604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398608 */     // MIs[0] policy
     /* 1398608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1398623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398645 */     // GIR_Coverage, 61323,
     /* 1398645 */     GIR_EraseRootFromParent_Done,
     /* 1398646 */   // Label 19620: @1398646
     /* 1398646 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1398743), // Rule ID 61326 //
     /* 1398651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1398654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1398662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1398665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1398668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1398674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398701 */     // MIs[1] Operand 1
     /* 1398701 */     // No operand predicates
     /* 1398701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398705 */     // MIs[0] policy
     /* 1398705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398717 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1398720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398742 */     // GIR_Coverage, 61326,
     /* 1398742 */     GIR_EraseRootFromParent_Done,
     /* 1398743 */   // Label 19621: @1398743
     /* 1398743 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1398840), // Rule ID 61327 //
     /* 1398748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1398751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1398759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1398762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1398765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1398771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398798 */     // MIs[1] Operand 1
     /* 1398798 */     // No operand predicates
     /* 1398798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398802 */     // MIs[0] policy
     /* 1398802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1398817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398839 */     // GIR_Coverage, 61327,
     /* 1398839 */     GIR_EraseRootFromParent_Done,
     /* 1398840 */   // Label 19622: @1398840
     /* 1398840 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1398937), // Rule ID 61330 //
     /* 1398845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1398848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1398856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1398859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398895 */     // MIs[1] Operand 1
     /* 1398895 */     // No operand predicates
     /* 1398895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398899 */     // MIs[0] policy
     /* 1398899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1398904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1398914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1398923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398936 */     // GIR_Coverage, 61330,
     /* 1398936 */     GIR_EraseRootFromParent_Done,
     /* 1398937 */   // Label 19623: @1398937
     /* 1398937 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1399034), // Rule ID 61331 //
     /* 1398942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1398945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1398950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1398953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1398956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1398984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1398988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1398992 */     // MIs[1] Operand 1
     /* 1398992 */     // No operand predicates
     /* 1398992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398996 */     // MIs[0] policy
     /* 1398996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1399011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399033 */     // GIR_Coverage, 61331,
     /* 1399033 */     GIR_EraseRootFromParent_Done,
     /* 1399034 */   // Label 19624: @1399034
     /* 1399034 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1399131), // Rule ID 61334 //
     /* 1399039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1399042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1399050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1399053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1399056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1399069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399089 */     // MIs[1] Operand 1
     /* 1399089 */     // No operand predicates
     /* 1399089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399093 */     // MIs[0] policy
     /* 1399093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399105 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1399108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399130 */     // GIR_Coverage, 61334,
     /* 1399130 */     GIR_EraseRootFromParent_Done,
     /* 1399131 */   // Label 19625: @1399131
     /* 1399131 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1399228), // Rule ID 61335 //
     /* 1399136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1399139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1399147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1399150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1399153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1399166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399186 */     // MIs[1] Operand 1
     /* 1399186 */     // No operand predicates
     /* 1399186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399190 */     // MIs[0] policy
     /* 1399190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1399205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399227 */     // GIR_Coverage, 61335,
     /* 1399227 */     GIR_EraseRootFromParent_Done,
     /* 1399228 */   // Label 19626: @1399228
     /* 1399228 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1399325), // Rule ID 61338 //
     /* 1399233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1399236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1399244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1399247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1399250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1399263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399283 */     // MIs[1] Operand 1
     /* 1399283 */     // No operand predicates
     /* 1399283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399287 */     // MIs[0] policy
     /* 1399287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1399302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399324 */     // GIR_Coverage, 61338,
     /* 1399324 */     GIR_EraseRootFromParent_Done,
     /* 1399325 */   // Label 19627: @1399325
     /* 1399325 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1399422), // Rule ID 61339 //
     /* 1399330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1399333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1399341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1399344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1399347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1399360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399380 */     // MIs[1] Operand 1
     /* 1399380 */     // No operand predicates
     /* 1399380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399384 */     // MIs[0] policy
     /* 1399384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1399399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399421 */     // GIR_Coverage, 61339,
     /* 1399421 */     GIR_EraseRootFromParent_Done,
     /* 1399422 */   // Label 19628: @1399422
     /* 1399422 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1399519), // Rule ID 61342 //
     /* 1399427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1399430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1399438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1399441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1399444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1399457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399477 */     // MIs[1] Operand 1
     /* 1399477 */     // No operand predicates
     /* 1399477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399481 */     // MIs[0] policy
     /* 1399481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1399496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399518 */     // GIR_Coverage, 61342,
     /* 1399518 */     GIR_EraseRootFromParent_Done,
     /* 1399519 */   // Label 19629: @1399519
     /* 1399519 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1399616), // Rule ID 61343 //
     /* 1399524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1399527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1399535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1399538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1399541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1399554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399574 */     // MIs[1] Operand 1
     /* 1399574 */     // No operand predicates
     /* 1399574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399578 */     // MIs[0] policy
     /* 1399578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1399593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399615 */     // GIR_Coverage, 61343,
     /* 1399615 */     GIR_EraseRootFromParent_Done,
     /* 1399616 */   // Label 19630: @1399616
     /* 1399616 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1399713), // Rule ID 61346 //
     /* 1399621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1399624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1399632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1399635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1399638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1399651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399671 */     // MIs[1] Operand 1
     /* 1399671 */     // No operand predicates
     /* 1399671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399675 */     // MIs[0] policy
     /* 1399675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399687 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1399690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399712 */     // GIR_Coverage, 61346,
     /* 1399712 */     GIR_EraseRootFromParent_Done,
     /* 1399713 */   // Label 19631: @1399713
     /* 1399713 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1399810), // Rule ID 61347 //
     /* 1399718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1399721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1399729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1399732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1399735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1399748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399768 */     // MIs[1] Operand 1
     /* 1399768 */     // No operand predicates
     /* 1399768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399772 */     // MIs[0] policy
     /* 1399772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1399787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399809 */     // GIR_Coverage, 61347,
     /* 1399809 */     GIR_EraseRootFromParent_Done,
     /* 1399810 */   // Label 19632: @1399810
     /* 1399810 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1399907), // Rule ID 61350 //
     /* 1399815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1399818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1399826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1399829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1399845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399865 */     // MIs[1] Operand 1
     /* 1399865 */     // No operand predicates
     /* 1399865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399869 */     // MIs[0] policy
     /* 1399869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1399884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399906 */     // GIR_Coverage, 61350,
     /* 1399906 */     GIR_EraseRootFromParent_Done,
     /* 1399907 */   // Label 19633: @1399907
     /* 1399907 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1400004), // Rule ID 61351 //
     /* 1399912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1399915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1399920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1399923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1399926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1399942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1399954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1399958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1399962 */     // MIs[1] Operand 1
     /* 1399962 */     // No operand predicates
     /* 1399962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399966 */     // MIs[0] policy
     /* 1399966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1399971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1399981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1399990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400003 */     // GIR_Coverage, 61351,
     /* 1400003 */     GIR_EraseRootFromParent_Done,
     /* 1400004 */   // Label 19634: @1400004
     /* 1400004 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1400101), // Rule ID 61354 //
     /* 1400009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1400012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1400020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1400023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1400026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1400039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400059 */     // MIs[1] Operand 1
     /* 1400059 */     // No operand predicates
     /* 1400059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400063 */     // MIs[0] policy
     /* 1400063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400075 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1400078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400100 */     // GIR_Coverage, 61354,
     /* 1400100 */     GIR_EraseRootFromParent_Done,
     /* 1400101 */   // Label 19635: @1400101
     /* 1400101 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1400198), // Rule ID 61355 //
     /* 1400106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1400109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1400117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1400120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1400123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1400136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400156 */     // MIs[1] Operand 1
     /* 1400156 */     // No operand predicates
     /* 1400156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400160 */     // MIs[0] policy
     /* 1400160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1400175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400197 */     // GIR_Coverage, 61355,
     /* 1400197 */     GIR_EraseRootFromParent_Done,
     /* 1400198 */   // Label 19636: @1400198
     /* 1400198 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1400295), // Rule ID 61358 //
     /* 1400203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1400206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1400214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1400217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1400220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400253 */     // MIs[1] Operand 1
     /* 1400253 */     // No operand predicates
     /* 1400253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400257 */     // MIs[0] policy
     /* 1400257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400269 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1400272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400294 */     // GIR_Coverage, 61358,
     /* 1400294 */     GIR_EraseRootFromParent_Done,
     /* 1400295 */   // Label 19637: @1400295
     /* 1400295 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1400392), // Rule ID 61359 //
     /* 1400300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1400303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1400311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1400314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1400317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400350 */     // MIs[1] Operand 1
     /* 1400350 */     // No operand predicates
     /* 1400350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400354 */     // MIs[0] policy
     /* 1400354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400366 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1400369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400391 */     // GIR_Coverage, 61359,
     /* 1400391 */     GIR_EraseRootFromParent_Done,
     /* 1400392 */   // Label 19638: @1400392
     /* 1400392 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1400489), // Rule ID 61362 //
     /* 1400397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1400400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1400408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1400411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1400414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400447 */     // MIs[1] Operand 1
     /* 1400447 */     // No operand predicates
     /* 1400447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400451 */     // MIs[0] policy
     /* 1400451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400463 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1400466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400488 */     // GIR_Coverage, 61362,
     /* 1400488 */     GIR_EraseRootFromParent_Done,
     /* 1400489 */   // Label 19639: @1400489
     /* 1400489 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1400586), // Rule ID 61363 //
     /* 1400494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1400497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1400502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1400505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1400508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1400511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1400536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1400540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1400544 */     // MIs[1] Operand 1
     /* 1400544 */     // No operand predicates
     /* 1400544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400548 */     // MIs[0] policy
     /* 1400548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1400553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1400563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1400572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400585 */     // GIR_Coverage, 61363,
     /* 1400585 */     GIR_EraseRootFromParent_Done,
     /* 1400586 */   // Label 19640: @1400586
     /* 1400586 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1400668), // Rule ID 2566 //
     /* 1400591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1400599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1400611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400630 */     // MIs[0] round
     /* 1400630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1400633 */     // MIs[0] policy
     /* 1400633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400643 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1400646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400654 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1400656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400667 */     // GIR_Coverage, 2566,
     /* 1400667 */     GIR_EraseRootFromParent_Done,
     /* 1400668 */   // Label 19641: @1400668
     /* 1400668 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1400750), // Rule ID 2567 //
     /* 1400673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1400681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1400693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400712 */     // MIs[0] round
     /* 1400712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1400715 */     // MIs[0] policy
     /* 1400715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400725 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1400728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1400738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400749 */     // GIR_Coverage, 2567,
     /* 1400749 */     GIR_EraseRootFromParent_Done,
     /* 1400750 */   // Label 19642: @1400750
     /* 1400750 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1400832), // Rule ID 2602 //
     /* 1400755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1400758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1400775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400794 */     // MIs[0] round
     /* 1400794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1400797 */     // MIs[0] policy
     /* 1400797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400807 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1400810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400818 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1400820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400831 */     // GIR_Coverage, 2602,
     /* 1400831 */     GIR_EraseRootFromParent_Done,
     /* 1400832 */   // Label 19643: @1400832
     /* 1400832 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1400914), // Rule ID 2603 //
     /* 1400837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1400840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1400857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400876 */     // MIs[0] round
     /* 1400876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1400879 */     // MIs[0] policy
     /* 1400879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1400892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1400902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400913 */     // GIR_Coverage, 2603,
     /* 1400913 */     GIR_EraseRootFromParent_Done,
     /* 1400914 */   // Label 19644: @1400914
     /* 1400914 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1400996), // Rule ID 2634 //
     /* 1400919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1400927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1400939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400958 */     // MIs[0] round
     /* 1400958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1400961 */     // MIs[0] policy
     /* 1400961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400971 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1400974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1400984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400995 */     // GIR_Coverage, 2634,
     /* 1400995 */     GIR_EraseRootFromParent_Done,
     /* 1400996 */   // Label 19645: @1400996
     /* 1400996 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1401078), // Rule ID 2635 //
     /* 1401001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1401012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1401015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1401018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1401021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401040 */     // MIs[0] round
     /* 1401040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401043 */     // MIs[0] policy
     /* 1401043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401053 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1401056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401064 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401077 */     // GIR_Coverage, 2635,
     /* 1401077 */     GIR_EraseRootFromParent_Done,
     /* 1401078 */   // Label 19646: @1401078
     /* 1401078 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1401160), // Rule ID 17606 //
     /* 1401083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1401094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1401097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1401100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1401103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401122 */     // MIs[0] round
     /* 1401122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401125 */     // MIs[0] policy
     /* 1401125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401135 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1401138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401159 */     // GIR_Coverage, 17606,
     /* 1401159 */     GIR_EraseRootFromParent_Done,
     /* 1401160 */   // Label 19647: @1401160
     /* 1401160 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1401242), // Rule ID 17607 //
     /* 1401165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1401176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1401179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1401182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1401185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401204 */     // MIs[0] round
     /* 1401204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401207 */     // MIs[0] policy
     /* 1401207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401217 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1401220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401228 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401241 */     // GIR_Coverage, 17607,
     /* 1401241 */     GIR_EraseRootFromParent_Done,
     /* 1401242 */   // Label 19648: @1401242
     /* 1401242 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1401324), // Rule ID 17610 //
     /* 1401247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1401258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1401261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1401264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1401267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401286 */     // MIs[0] round
     /* 1401286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401289 */     // MIs[0] policy
     /* 1401289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401299 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1401302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401323 */     // GIR_Coverage, 17610,
     /* 1401323 */     GIR_EraseRootFromParent_Done,
     /* 1401324 */   // Label 19649: @1401324
     /* 1401324 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1401406), // Rule ID 17611 //
     /* 1401329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1401340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1401343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1401346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1401349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401368 */     // MIs[0] round
     /* 1401368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401371 */     // MIs[0] policy
     /* 1401371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401381 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1401384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401392 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401405 */     // GIR_Coverage, 17611,
     /* 1401405 */     GIR_EraseRootFromParent_Done,
     /* 1401406 */   // Label 19650: @1401406
     /* 1401406 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1401488), // Rule ID 17614 //
     /* 1401411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1401428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401450 */     // MIs[0] round
     /* 1401450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401453 */     // MIs[0] policy
     /* 1401453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401463 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1401466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401474 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401487 */     // GIR_Coverage, 17614,
     /* 1401487 */     GIR_EraseRootFromParent_Done,
     /* 1401488 */   // Label 19651: @1401488
     /* 1401488 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1401570), // Rule ID 17615 //
     /* 1401493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1401510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401532 */     // MIs[0] round
     /* 1401532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401535 */     // MIs[0] policy
     /* 1401535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401545 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1401548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401556 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401569 */     // GIR_Coverage, 17615,
     /* 1401569 */     GIR_EraseRootFromParent_Done,
     /* 1401570 */   // Label 19652: @1401570
     /* 1401570 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1401652), // Rule ID 17618 //
     /* 1401575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1401592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401614 */     // MIs[0] round
     /* 1401614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401617 */     // MIs[0] policy
     /* 1401617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401627 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1401630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401651 */     // GIR_Coverage, 17618,
     /* 1401651 */     GIR_EraseRootFromParent_Done,
     /* 1401652 */   // Label 19653: @1401652
     /* 1401652 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1401734), // Rule ID 17619 //
     /* 1401657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1401674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401696 */     // MIs[0] round
     /* 1401696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401699 */     // MIs[0] policy
     /* 1401699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401709 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1401712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401733 */     // GIR_Coverage, 17619,
     /* 1401733 */     GIR_EraseRootFromParent_Done,
     /* 1401734 */   // Label 19654: @1401734
     /* 1401734 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1401816), // Rule ID 17622 //
     /* 1401739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401778 */     // MIs[0] round
     /* 1401778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401781 */     // MIs[0] policy
     /* 1401781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401791 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1401794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401815 */     // GIR_Coverage, 17622,
     /* 1401815 */     GIR_EraseRootFromParent_Done,
     /* 1401816 */   // Label 19655: @1401816
     /* 1401816 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1401898), // Rule ID 17623 //
     /* 1401821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401860 */     // MIs[0] round
     /* 1401860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401863 */     // MIs[0] policy
     /* 1401863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401873 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1401876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401897 */     // GIR_Coverage, 17623,
     /* 1401897 */     GIR_EraseRootFromParent_Done,
     /* 1401898 */   // Label 19656: @1401898
     /* 1401898 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1401980), // Rule ID 17626 //
     /* 1401903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1401914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1401917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1401920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1401923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401942 */     // MIs[0] round
     /* 1401942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1401945 */     // MIs[0] policy
     /* 1401945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401955 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1401958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1401968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401979 */     // GIR_Coverage, 17626,
     /* 1401979 */     GIR_EraseRootFromParent_Done,
     /* 1401980 */   // Label 19657: @1401980
     /* 1401980 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1402062), // Rule ID 17627 //
     /* 1401985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1401993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1401996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1401999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1402002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1402005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402024 */     // MIs[0] round
     /* 1402024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402027 */     // MIs[0] policy
     /* 1402027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402037 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1402040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402048 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402061 */     // GIR_Coverage, 17627,
     /* 1402061 */     GIR_EraseRootFromParent_Done,
     /* 1402062 */   // Label 19658: @1402062
     /* 1402062 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1402144), // Rule ID 17630 //
     /* 1402067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1402070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1402078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1402081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1402084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1402087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402106 */     // MIs[0] round
     /* 1402106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402109 */     // MIs[0] policy
     /* 1402109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402119 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1402122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402143 */     // GIR_Coverage, 17630,
     /* 1402143 */     GIR_EraseRootFromParent_Done,
     /* 1402144 */   // Label 19659: @1402144
     /* 1402144 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1402226), // Rule ID 17631 //
     /* 1402149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1402152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1402160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1402163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1402166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1402169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402188 */     // MIs[0] round
     /* 1402188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402191 */     // MIs[0] policy
     /* 1402191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402201 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1402204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402225 */     // GIR_Coverage, 17631,
     /* 1402225 */     GIR_EraseRootFromParent_Done,
     /* 1402226 */   // Label 19660: @1402226
     /* 1402226 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1402308), // Rule ID 17634 //
     /* 1402231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1402234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1402242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1402245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1402248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1402251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402270 */     // MIs[0] round
     /* 1402270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402273 */     // MIs[0] policy
     /* 1402273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402283 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1402286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402307 */     // GIR_Coverage, 17634,
     /* 1402307 */     GIR_EraseRootFromParent_Done,
     /* 1402308 */   // Label 19661: @1402308
     /* 1402308 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1402390), // Rule ID 17635 //
     /* 1402313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1402316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1402324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1402327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1402330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1402333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402352 */     // MIs[0] round
     /* 1402352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402355 */     // MIs[0] policy
     /* 1402355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402365 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1402368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402376 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402389 */     // GIR_Coverage, 17635,
     /* 1402389 */     GIR_EraseRootFromParent_Done,
     /* 1402390 */   // Label 19662: @1402390
     /* 1402390 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1402472), // Rule ID 17638 //
     /* 1402395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1402406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1402409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1402415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402434 */     // MIs[0] round
     /* 1402434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402437 */     // MIs[0] policy
     /* 1402437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402447 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1402450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402458 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402471 */     // GIR_Coverage, 17638,
     /* 1402471 */     GIR_EraseRootFromParent_Done,
     /* 1402472 */   // Label 19663: @1402472
     /* 1402472 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1402554), // Rule ID 17639 //
     /* 1402477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1402488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1402491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1402497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402516 */     // MIs[0] round
     /* 1402516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402519 */     // MIs[0] policy
     /* 1402519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1402532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402553 */     // GIR_Coverage, 17639,
     /* 1402553 */     GIR_EraseRootFromParent_Done,
     /* 1402554 */   // Label 19664: @1402554
     /* 1402554 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1402636), // Rule ID 17642 //
     /* 1402559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1402570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1402573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1402579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402598 */     // MIs[0] round
     /* 1402598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402601 */     // MIs[0] policy
     /* 1402601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402611 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1402614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402635 */     // GIR_Coverage, 17642,
     /* 1402635 */     GIR_EraseRootFromParent_Done,
     /* 1402636 */   // Label 19665: @1402636
     /* 1402636 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1402718), // Rule ID 17643 //
     /* 1402641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1402652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1402655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1402661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402680 */     // MIs[0] round
     /* 1402680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402683 */     // MIs[0] policy
     /* 1402683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402693 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1402696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402717 */     // GIR_Coverage, 17643,
     /* 1402717 */     GIR_EraseRootFromParent_Done,
     /* 1402718 */   // Label 19666: @1402718
     /* 1402718 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1402800), // Rule ID 17646 //
     /* 1402723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1402734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1402737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1402743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402762 */     // MIs[0] round
     /* 1402762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402765 */     // MIs[0] policy
     /* 1402765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402775 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1402778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402786 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402799 */     // GIR_Coverage, 17646,
     /* 1402799 */     GIR_EraseRootFromParent_Done,
     /* 1402800 */   // Label 19667: @1402800
     /* 1402800 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1402882), // Rule ID 17647 //
     /* 1402805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1402816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1402819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1402825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402844 */     // MIs[0] round
     /* 1402844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402847 */     // MIs[0] policy
     /* 1402847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402857 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1402860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402868 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402881 */     // GIR_Coverage, 17647,
     /* 1402881 */     GIR_EraseRootFromParent_Done,
     /* 1402882 */   // Label 19668: @1402882
     /* 1402882 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1402964), // Rule ID 17650 //
     /* 1402887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1402898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1402901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1402907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402926 */     // MIs[0] round
     /* 1402926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1402929 */     // MIs[0] policy
     /* 1402929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1402942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1402952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402963 */     // GIR_Coverage, 17650,
     /* 1402963 */     GIR_EraseRootFromParent_Done,
     /* 1402964 */   // Label 19669: @1402964
     /* 1402964 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1403046), // Rule ID 17651 //
     /* 1402969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1402977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1402980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1402983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1402989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403008 */     // MIs[0] round
     /* 1403008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403011 */     // MIs[0] policy
     /* 1403011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403021 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1403024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403032 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403045 */     // GIR_Coverage, 17651,
     /* 1403045 */     GIR_EraseRootFromParent_Done,
     /* 1403046 */   // Label 19670: @1403046
     /* 1403046 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1403128), // Rule ID 17654 //
     /* 1403051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1403054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1403062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1403065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1403068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1403071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403090 */     // MIs[0] round
     /* 1403090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403093 */     // MIs[0] policy
     /* 1403093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403103 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1403106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403114 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403127 */     // GIR_Coverage, 17654,
     /* 1403127 */     GIR_EraseRootFromParent_Done,
     /* 1403128 */   // Label 19671: @1403128
     /* 1403128 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1403210), // Rule ID 17655 //
     /* 1403133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1403136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1403144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1403147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1403150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1403153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403172 */     // MIs[0] round
     /* 1403172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403175 */     // MIs[0] policy
     /* 1403175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403185 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1403188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403196 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403209 */     // GIR_Coverage, 17655,
     /* 1403209 */     GIR_EraseRootFromParent_Done,
     /* 1403210 */   // Label 19672: @1403210
     /* 1403210 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1403292), // Rule ID 17658 //
     /* 1403215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1403218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1403226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1403229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1403232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1403235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403254 */     // MIs[0] round
     /* 1403254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403257 */     // MIs[0] policy
     /* 1403257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403267 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1403270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403291 */     // GIR_Coverage, 17658,
     /* 1403291 */     GIR_EraseRootFromParent_Done,
     /* 1403292 */   // Label 19673: @1403292
     /* 1403292 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1403374), // Rule ID 17659 //
     /* 1403297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1403300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1403308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1403311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1403314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1403317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403336 */     // MIs[0] round
     /* 1403336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403339 */     // MIs[0] policy
     /* 1403339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403349 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1403352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403373 */     // GIR_Coverage, 17659,
     /* 1403373 */     GIR_EraseRootFromParent_Done,
     /* 1403374 */   // Label 19674: @1403374
     /* 1403374 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1403456), // Rule ID 17662 //
     /* 1403379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1403390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1403393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1403399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403418 */     // MIs[0] round
     /* 1403418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403421 */     // MIs[0] policy
     /* 1403421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403431 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1403434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403455 */     // GIR_Coverage, 17662,
     /* 1403455 */     GIR_EraseRootFromParent_Done,
     /* 1403456 */   // Label 19675: @1403456
     /* 1403456 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1403538), // Rule ID 17663 //
     /* 1403461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1403472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1403475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1403481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403500 */     // MIs[0] round
     /* 1403500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403503 */     // MIs[0] policy
     /* 1403503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403513 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1403516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403524 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403537 */     // GIR_Coverage, 17663,
     /* 1403537 */     GIR_EraseRootFromParent_Done,
     /* 1403538 */   // Label 19676: @1403538
     /* 1403538 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1403620), // Rule ID 17666 //
     /* 1403543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1403554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1403557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1403563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403582 */     // MIs[0] round
     /* 1403582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403585 */     // MIs[0] policy
     /* 1403585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403595 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1403598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403619 */     // GIR_Coverage, 17666,
     /* 1403619 */     GIR_EraseRootFromParent_Done,
     /* 1403620 */   // Label 19677: @1403620
     /* 1403620 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1403702), // Rule ID 17667 //
     /* 1403625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1403636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1403639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1403645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403664 */     // MIs[0] round
     /* 1403664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403667 */     // MIs[0] policy
     /* 1403667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403677 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1403680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403688 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403701 */     // GIR_Coverage, 17667,
     /* 1403701 */     GIR_EraseRootFromParent_Done,
     /* 1403702 */   // Label 19678: @1403702
     /* 1403702 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1403784), // Rule ID 17670 //
     /* 1403707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1403710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1403724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1403727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1403742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403746 */     // MIs[0] round
     /* 1403746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403749 */     // MIs[0] policy
     /* 1403749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403759 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1403762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403783 */     // GIR_Coverage, 17670,
     /* 1403783 */     GIR_EraseRootFromParent_Done,
     /* 1403784 */   // Label 19679: @1403784
     /* 1403784 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1403866), // Rule ID 17671 //
     /* 1403789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1403792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1403806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1403809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1403824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403828 */     // MIs[0] round
     /* 1403828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403831 */     // MIs[0] policy
     /* 1403831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403841 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1403844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403852 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403865 */     // GIR_Coverage, 17671,
     /* 1403865 */     GIR_EraseRootFromParent_Done,
     /* 1403866 */   // Label 19680: @1403866
     /* 1403866 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1403948), // Rule ID 17674 //
     /* 1403871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403910 */     // MIs[0] round
     /* 1403910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403913 */     // MIs[0] policy
     /* 1403913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403923 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1403926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1403936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403947 */     // GIR_Coverage, 17674,
     /* 1403947 */     GIR_EraseRootFromParent_Done,
     /* 1403948 */   // Label 19681: @1403948
     /* 1403948 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1404030), // Rule ID 17675 //
     /* 1403953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1403961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1403970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1403988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403992 */     // MIs[0] round
     /* 1403992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1403995 */     // MIs[0] policy
     /* 1403995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404005 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10896:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1404008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404016 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404029 */     // GIR_Coverage, 17675,
     /* 1404029 */     GIR_EraseRootFromParent_Done,
     /* 1404030 */   // Label 19682: @1404030
     /* 1404030 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1404112), // Rule ID 17678 //
     /* 1404035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1404038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1404052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1404070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404074 */     // MIs[0] round
     /* 1404074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404077 */     // MIs[0] policy
     /* 1404077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404087 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1404090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404111 */     // GIR_Coverage, 17678,
     /* 1404111 */     GIR_EraseRootFromParent_Done,
     /* 1404112 */   // Label 19683: @1404112
     /* 1404112 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1404194), // Rule ID 17679 //
     /* 1404117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1404120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1404134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1404152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404156 */     // MIs[0] round
     /* 1404156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404159 */     // MIs[0] policy
     /* 1404159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404169 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1404172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404180 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404193 */     // GIR_Coverage, 17679,
     /* 1404193 */     GIR_EraseRootFromParent_Done,
     /* 1404194 */   // Label 19684: @1404194
     /* 1404194 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1404276), // Rule ID 17682 //
     /* 1404199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1404202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1404210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1404213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1404216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1404219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1404234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404238 */     // MIs[0] round
     /* 1404238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404241 */     // MIs[0] policy
     /* 1404241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404251 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1404254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404275 */     // GIR_Coverage, 17682,
     /* 1404275 */     GIR_EraseRootFromParent_Done,
     /* 1404276 */   // Label 19685: @1404276
     /* 1404276 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1404358), // Rule ID 17683 //
     /* 1404281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1404284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1404292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1404295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1404298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1404301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1404316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404320 */     // MIs[0] round
     /* 1404320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404323 */     // MIs[0] policy
     /* 1404323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404333 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1404336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404344 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404357 */     // GIR_Coverage, 17683,
     /* 1404357 */     GIR_EraseRootFromParent_Done,
     /* 1404358 */   // Label 19686: @1404358
     /* 1404358 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1404440), // Rule ID 17686 //
     /* 1404363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1404383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404402 */     // MIs[0] round
     /* 1404402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404405 */     // MIs[0] policy
     /* 1404405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1404418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404439 */     // GIR_Coverage, 17686,
     /* 1404439 */     GIR_EraseRootFromParent_Done,
     /* 1404440 */   // Label 19687: @1404440
     /* 1404440 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1404522), // Rule ID 17687 //
     /* 1404445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1404465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404484 */     // MIs[0] round
     /* 1404484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404487 */     // MIs[0] policy
     /* 1404487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404497 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1404500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404508 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404521 */     // GIR_Coverage, 17687,
     /* 1404521 */     GIR_EraseRootFromParent_Done,
     /* 1404522 */   // Label 19688: @1404522
     /* 1404522 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1404604), // Rule ID 17690 //
     /* 1404527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1404547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404566 */     // MIs[0] round
     /* 1404566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404569 */     // MIs[0] policy
     /* 1404569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404579 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1404582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404603 */     // GIR_Coverage, 17690,
     /* 1404603 */     GIR_EraseRootFromParent_Done,
     /* 1404604 */   // Label 19689: @1404604
     /* 1404604 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1404686), // Rule ID 17691 //
     /* 1404609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1404629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404648 */     // MIs[0] round
     /* 1404648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404651 */     // MIs[0] policy
     /* 1404651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404661 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1404664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404672 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404685 */     // GIR_Coverage, 17691,
     /* 1404685 */     GIR_EraseRootFromParent_Done,
     /* 1404686 */   // Label 19690: @1404686
     /* 1404686 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1404768), // Rule ID 17694 //
     /* 1404691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1404711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404730 */     // MIs[0] round
     /* 1404730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404733 */     // MIs[0] policy
     /* 1404733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404743 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1404746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404767 */     // GIR_Coverage, 17694,
     /* 1404767 */     GIR_EraseRootFromParent_Done,
     /* 1404768 */   // Label 19691: @1404768
     /* 1404768 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1404850), // Rule ID 17695 //
     /* 1404773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1404790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1404793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1404808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404812 */     // MIs[0] round
     /* 1404812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404815 */     // MIs[0] policy
     /* 1404815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1404828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404836 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404849 */     // GIR_Coverage, 17695,
     /* 1404849 */     GIR_EraseRootFromParent_Done,
     /* 1404850 */   // Label 19692: @1404850
     /* 1404850 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1404932), // Rule ID 17698 //
     /* 1404855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1404858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1404872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1404875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1404890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404894 */     // MIs[0] round
     /* 1404894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404897 */     // MIs[0] policy
     /* 1404897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404907 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1404910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1404920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404931 */     // GIR_Coverage, 17698,
     /* 1404931 */     GIR_EraseRootFromParent_Done,
     /* 1404932 */   // Label 19693: @1404932
     /* 1404932 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1405014), // Rule ID 17699 //
     /* 1404937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1404940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1404945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1404954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1404957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1404972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404976 */     // MIs[0] round
     /* 1404976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1404979 */     // MIs[0] policy
     /* 1404979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404989 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1404992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405000 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405013 */     // GIR_Coverage, 17699,
     /* 1405013 */     GIR_EraseRootFromParent_Done,
     /* 1405014 */   // Label 19694: @1405014
     /* 1405014 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1405096), // Rule ID 17702 //
     /* 1405019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1405022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1405036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1405039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1405054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405058 */     // MIs[0] round
     /* 1405058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405061 */     // MIs[0] policy
     /* 1405061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405071 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1405074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405095 */     // GIR_Coverage, 17702,
     /* 1405095 */     GIR_EraseRootFromParent_Done,
     /* 1405096 */   // Label 19695: @1405096
     /* 1405096 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1405178), // Rule ID 17703 //
     /* 1405101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1405104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1405118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1405121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1405136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405140 */     // MIs[0] round
     /* 1405140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405143 */     // MIs[0] policy
     /* 1405143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405153 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1405156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405177 */     // GIR_Coverage, 17703,
     /* 1405177 */     GIR_EraseRootFromParent_Done,
     /* 1405178 */   // Label 19696: @1405178
     /* 1405178 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1405260), // Rule ID 17706 //
     /* 1405183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1405186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1405200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1405203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1405218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405222 */     // MIs[0] round
     /* 1405222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405225 */     // MIs[0] policy
     /* 1405225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405235 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1405238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405259 */     // GIR_Coverage, 17706,
     /* 1405259 */     GIR_EraseRootFromParent_Done,
     /* 1405260 */   // Label 19697: @1405260
     /* 1405260 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1405342), // Rule ID 17707 //
     /* 1405265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1405268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1405282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1405285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1405300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405304 */     // MIs[0] round
     /* 1405304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405307 */     // MIs[0] policy
     /* 1405307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405317 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1405320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405328 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405341 */     // GIR_Coverage, 17707,
     /* 1405341 */     GIR_EraseRootFromParent_Done,
     /* 1405342 */   // Label 19698: @1405342
     /* 1405342 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1405424), // Rule ID 17710 //
     /* 1405347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1405367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405386 */     // MIs[0] round
     /* 1405386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405389 */     // MIs[0] policy
     /* 1405389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1405402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405423 */     // GIR_Coverage, 17710,
     /* 1405423 */     GIR_EraseRootFromParent_Done,
     /* 1405424 */   // Label 19699: @1405424
     /* 1405424 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1405506), // Rule ID 17711 //
     /* 1405429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1405449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405468 */     // MIs[0] round
     /* 1405468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405471 */     // MIs[0] policy
     /* 1405471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405481 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1405484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405492 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405505 */     // GIR_Coverage, 17711,
     /* 1405505 */     GIR_EraseRootFromParent_Done,
     /* 1405506 */   // Label 19700: @1405506
     /* 1405506 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1405588), // Rule ID 17714 //
     /* 1405511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1405531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405550 */     // MIs[0] round
     /* 1405550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405553 */     // MIs[0] policy
     /* 1405553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405563 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1405566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405587 */     // GIR_Coverage, 17714,
     /* 1405587 */     GIR_EraseRootFromParent_Done,
     /* 1405588 */   // Label 19701: @1405588
     /* 1405588 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1405670), // Rule ID 17715 //
     /* 1405593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1405613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405632 */     // MIs[0] round
     /* 1405632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405635 */     // MIs[0] policy
     /* 1405635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405645 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1405648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405656 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405669 */     // GIR_Coverage, 17715,
     /* 1405669 */     GIR_EraseRootFromParent_Done,
     /* 1405670 */   // Label 19702: @1405670
     /* 1405670 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1405752), // Rule ID 17718 //
     /* 1405675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1405695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405714 */     // MIs[0] round
     /* 1405714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405717 */     // MIs[0] policy
     /* 1405717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405727 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1405730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405738 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405751 */     // GIR_Coverage, 17718,
     /* 1405751 */     GIR_EraseRootFromParent_Done,
     /* 1405752 */   // Label 19703: @1405752
     /* 1405752 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1405834), // Rule ID 17719 //
     /* 1405757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1405765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1405774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1405777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1405792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405796 */     // MIs[0] round
     /* 1405796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405799 */     // MIs[0] policy
     /* 1405799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405809 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1405812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405820 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405833 */     // GIR_Coverage, 17719,
     /* 1405833 */     GIR_EraseRootFromParent_Done,
     /* 1405834 */   // Label 19704: @1405834
     /* 1405834 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1405916), // Rule ID 17722 //
     /* 1405839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1405842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1405847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1405859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405878 */     // MIs[0] round
     /* 1405878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405881 */     // MIs[0] policy
     /* 1405881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405891 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1405894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405915 */     // GIR_Coverage, 17722,
     /* 1405915 */     GIR_EraseRootFromParent_Done,
     /* 1405916 */   // Label 19705: @1405916
     /* 1405916 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1405998), // Rule ID 17723 //
     /* 1405921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1405924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1405929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1405941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405960 */     // MIs[0] round
     /* 1405960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1405963 */     // MIs[0] policy
     /* 1405963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405973 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1405976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1405986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405997 */     // GIR_Coverage, 17723,
     /* 1405997 */     GIR_EraseRootFromParent_Done,
     /* 1405998 */   // Label 19706: @1405998
     /* 1405998 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1406080), // Rule ID 17726 //
     /* 1406003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1406006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1406023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406042 */     // MIs[0] round
     /* 1406042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406045 */     // MIs[0] policy
     /* 1406045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406055 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1406058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406066 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406079 */     // GIR_Coverage, 17726,
     /* 1406079 */     GIR_EraseRootFromParent_Done,
     /* 1406080 */   // Label 19707: @1406080
     /* 1406080 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1406162), // Rule ID 17727 //
     /* 1406085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1406088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1406105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406124 */     // MIs[0] round
     /* 1406124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406127 */     // MIs[0] policy
     /* 1406127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406137 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1406140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406161 */     // GIR_Coverage, 17727,
     /* 1406161 */     GIR_EraseRootFromParent_Done,
     /* 1406162 */   // Label 19708: @1406162
     /* 1406162 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1406244), // Rule ID 17730 //
     /* 1406167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1406170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1406187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406206 */     // MIs[0] round
     /* 1406206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406209 */     // MIs[0] policy
     /* 1406209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406219 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1406222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406243 */     // GIR_Coverage, 17730,
     /* 1406243 */     GIR_EraseRootFromParent_Done,
     /* 1406244 */   // Label 19709: @1406244
     /* 1406244 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1406326), // Rule ID 17731 //
     /* 1406249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1406252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1406269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406288 */     // MIs[0] round
     /* 1406288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406291 */     // MIs[0] policy
     /* 1406291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406301 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1406304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406312 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406325 */     // GIR_Coverage, 17731,
     /* 1406325 */     GIR_EraseRootFromParent_Done,
     /* 1406326 */   // Label 19710: @1406326
     /* 1406326 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1406408), // Rule ID 17734 //
     /* 1406331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1406334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1406351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406370 */     // MIs[0] round
     /* 1406370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406373 */     // MIs[0] policy
     /* 1406373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406383 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1406386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406407 */     // GIR_Coverage, 17734,
     /* 1406407 */     GIR_EraseRootFromParent_Done,
     /* 1406408 */   // Label 19711: @1406408
     /* 1406408 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1406490), // Rule ID 17735 //
     /* 1406413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1406416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1406433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406452 */     // MIs[0] round
     /* 1406452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406455 */     // MIs[0] policy
     /* 1406455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406465 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1406468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406489 */     // GIR_Coverage, 17735,
     /* 1406489 */     GIR_EraseRootFromParent_Done,
     /* 1406490 */   // Label 19712: @1406490
     /* 1406490 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1406572), // Rule ID 17738 //
     /* 1406495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1406498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1406515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406534 */     // MIs[0] round
     /* 1406534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406537 */     // MIs[0] policy
     /* 1406537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406547 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1406550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406558 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406571 */     // GIR_Coverage, 17738,
     /* 1406571 */     GIR_EraseRootFromParent_Done,
     /* 1406572 */   // Label 19713: @1406572
     /* 1406572 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1406654), // Rule ID 17739 //
     /* 1406577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1406580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1406597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406616 */     // MIs[0] round
     /* 1406616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406619 */     // MIs[0] policy
     /* 1406619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406629 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1406632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406640 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406653 */     // GIR_Coverage, 17739,
     /* 1406653 */     GIR_EraseRootFromParent_Done,
     /* 1406654 */   // Label 19714: @1406654
     /* 1406654 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1406736), // Rule ID 17742 //
     /* 1406659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1406662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1406679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406698 */     // MIs[0] round
     /* 1406698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406701 */     // MIs[0] policy
     /* 1406701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406711 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1406714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406722 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406735 */     // GIR_Coverage, 17742,
     /* 1406735 */     GIR_EraseRootFromParent_Done,
     /* 1406736 */   // Label 19715: @1406736
     /* 1406736 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1406818), // Rule ID 17743 //
     /* 1406741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1406744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1406761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406780 */     // MIs[0] round
     /* 1406780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406783 */     // MIs[0] policy
     /* 1406783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406793 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1406796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406817 */     // GIR_Coverage, 17743,
     /* 1406817 */     GIR_EraseRootFromParent_Done,
     /* 1406818 */   // Label 19716: @1406818
     /* 1406818 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1406900), // Rule ID 17746 //
     /* 1406823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1406826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1406843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406862 */     // MIs[0] round
     /* 1406862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406865 */     // MIs[0] policy
     /* 1406865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406875 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1406878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406899 */     // GIR_Coverage, 17746,
     /* 1406899 */     GIR_EraseRootFromParent_Done,
     /* 1406900 */   // Label 19717: @1406900
     /* 1406900 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1406982), // Rule ID 17747 //
     /* 1406905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1406908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1406925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406944 */     // MIs[0] round
     /* 1406944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1406947 */     // MIs[0] policy
     /* 1406947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406957 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1406960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1406964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1406968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1406970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406981 */     // GIR_Coverage, 17747,
     /* 1406981 */     GIR_EraseRootFromParent_Done,
     /* 1406982 */   // Label 19718: @1406982
     /* 1406982 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1407064), // Rule ID 17750 //
     /* 1406987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1406990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1406995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1406998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1407007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407026 */     // MIs[0] round
     /* 1407026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407029 */     // MIs[0] policy
     /* 1407029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407039 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1407042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407050 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407063 */     // GIR_Coverage, 17750,
     /* 1407063 */     GIR_EraseRootFromParent_Done,
     /* 1407064 */   // Label 19719: @1407064
     /* 1407064 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1407146), // Rule ID 17751 //
     /* 1407069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1407072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1407089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407108 */     // MIs[0] round
     /* 1407108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407111 */     // MIs[0] policy
     /* 1407111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407121 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1407124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407145 */     // GIR_Coverage, 17751,
     /* 1407145 */     GIR_EraseRootFromParent_Done,
     /* 1407146 */   // Label 19720: @1407146
     /* 1407146 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1407228), // Rule ID 17754 //
     /* 1407151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1407154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1407171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407190 */     // MIs[0] round
     /* 1407190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407193 */     // MIs[0] policy
     /* 1407193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407203 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1407206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407214 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407227 */     // GIR_Coverage, 17754,
     /* 1407227 */     GIR_EraseRootFromParent_Done,
     /* 1407228 */   // Label 19721: @1407228
     /* 1407228 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1407310), // Rule ID 17755 //
     /* 1407233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1407236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1407253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407272 */     // MIs[0] round
     /* 1407272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407275 */     // MIs[0] policy
     /* 1407275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407285 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1407288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407309 */     // GIR_Coverage, 17755,
     /* 1407309 */     GIR_EraseRootFromParent_Done,
     /* 1407310 */   // Label 19722: @1407310
     /* 1407310 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1407392), // Rule ID 17758 //
     /* 1407315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1407318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1407335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407354 */     // MIs[0] round
     /* 1407354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407357 */     // MIs[0] policy
     /* 1407357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407367 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1407370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407391 */     // GIR_Coverage, 17758,
     /* 1407391 */     GIR_EraseRootFromParent_Done,
     /* 1407392 */   // Label 19723: @1407392
     /* 1407392 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1407474), // Rule ID 17759 //
     /* 1407397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1407400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1407417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407436 */     // MIs[0] round
     /* 1407436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407439 */     // MIs[0] policy
     /* 1407439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1407452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407473 */     // GIR_Coverage, 17759,
     /* 1407473 */     GIR_EraseRootFromParent_Done,
     /* 1407474 */   // Label 19724: @1407474
     /* 1407474 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1407556), // Rule ID 17762 //
     /* 1407479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1407482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1407499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407518 */     // MIs[0] round
     /* 1407518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407521 */     // MIs[0] policy
     /* 1407521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407531 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1407534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407555 */     // GIR_Coverage, 17762,
     /* 1407555 */     GIR_EraseRootFromParent_Done,
     /* 1407556 */   // Label 19725: @1407556
     /* 1407556 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1407638), // Rule ID 17763 //
     /* 1407561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1407564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1407581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407600 */     // MIs[0] round
     /* 1407600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407603 */     // MIs[0] policy
     /* 1407603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407613 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1407616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407624 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407637 */     // GIR_Coverage, 17763,
     /* 1407637 */     GIR_EraseRootFromParent_Done,
     /* 1407638 */   // Label 19726: @1407638
     /* 1407638 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1407720), // Rule ID 17766 //
     /* 1407643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1407646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1407663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407682 */     // MIs[0] round
     /* 1407682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407685 */     // MIs[0] policy
     /* 1407685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407695 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1407698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407719 */     // GIR_Coverage, 17766,
     /* 1407719 */     GIR_EraseRootFromParent_Done,
     /* 1407720 */   // Label 19727: @1407720
     /* 1407720 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1407802), // Rule ID 17767 //
     /* 1407725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1407728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1407745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407764 */     // MIs[0] round
     /* 1407764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407767 */     // MIs[0] policy
     /* 1407767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407777 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1407780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407801 */     // GIR_Coverage, 17767,
     /* 1407801 */     GIR_EraseRootFromParent_Done,
     /* 1407802 */   // Label 19728: @1407802
     /* 1407802 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1407884), // Rule ID 17770 //
     /* 1407807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1407810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1407827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407846 */     // MIs[0] round
     /* 1407846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407849 */     // MIs[0] policy
     /* 1407849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407859 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1407862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407883 */     // GIR_Coverage, 17770,
     /* 1407883 */     GIR_EraseRootFromParent_Done,
     /* 1407884 */   // Label 19729: @1407884
     /* 1407884 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1407966), // Rule ID 17771 //
     /* 1407889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1407892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1407909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407928 */     // MIs[0] round
     /* 1407928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1407931 */     // MIs[0] policy
     /* 1407931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407941 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1407944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1407948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1407952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1407954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407965 */     // GIR_Coverage, 17771,
     /* 1407965 */     GIR_EraseRootFromParent_Done,
     /* 1407966 */   // Label 19730: @1407966
     /* 1407966 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1408048), // Rule ID 17774 //
     /* 1407971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1407974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1407979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1407988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1407991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408010 */     // MIs[0] round
     /* 1408010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408013 */     // MIs[0] policy
     /* 1408013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408023 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1408026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408034 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408047 */     // GIR_Coverage, 17774,
     /* 1408047 */     GIR_EraseRootFromParent_Done,
     /* 1408048 */   // Label 19731: @1408048
     /* 1408048 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1408130), // Rule ID 17775 //
     /* 1408053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1408056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1408073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408092 */     // MIs[0] round
     /* 1408092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408095 */     // MIs[0] policy
     /* 1408095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408105 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1408108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408116 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408129 */     // GIR_Coverage, 17775,
     /* 1408129 */     GIR_EraseRootFromParent_Done,
     /* 1408130 */   // Label 19732: @1408130
     /* 1408130 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1408212), // Rule ID 17778 //
     /* 1408135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1408138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1408155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408174 */     // MIs[0] round
     /* 1408174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408177 */     // MIs[0] policy
     /* 1408177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408187 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1408190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408198 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408211 */     // GIR_Coverage, 17778,
     /* 1408211 */     GIR_EraseRootFromParent_Done,
     /* 1408212 */   // Label 19733: @1408212
     /* 1408212 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1408294), // Rule ID 17779 //
     /* 1408217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1408220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1408237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408256 */     // MIs[0] round
     /* 1408256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408259 */     // MIs[0] policy
     /* 1408259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408269 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1408272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408280 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408293 */     // GIR_Coverage, 17779,
     /* 1408293 */     GIR_EraseRootFromParent_Done,
     /* 1408294 */   // Label 19734: @1408294
     /* 1408294 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1408376), // Rule ID 17782 //
     /* 1408299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1408302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1408319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408338 */     // MIs[0] round
     /* 1408338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408341 */     // MIs[0] policy
     /* 1408341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408351 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1408354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408362 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408375 */     // GIR_Coverage, 17782,
     /* 1408375 */     GIR_EraseRootFromParent_Done,
     /* 1408376 */   // Label 19735: @1408376
     /* 1408376 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1408458), // Rule ID 17783 //
     /* 1408381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1408384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1408401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408420 */     // MIs[0] round
     /* 1408420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408423 */     // MIs[0] policy
     /* 1408423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408433 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1408436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408457 */     // GIR_Coverage, 17783,
     /* 1408457 */     GIR_EraseRootFromParent_Done,
     /* 1408458 */   // Label 19736: @1408458
     /* 1408458 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1408540), // Rule ID 17786 //
     /* 1408463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1408466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1408483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408502 */     // MIs[0] round
     /* 1408502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408505 */     // MIs[0] policy
     /* 1408505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408515 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1408518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408539 */     // GIR_Coverage, 17786,
     /* 1408539 */     GIR_EraseRootFromParent_Done,
     /* 1408540 */   // Label 19737: @1408540
     /* 1408540 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1408622), // Rule ID 17787 //
     /* 1408545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1408548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1408565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408584 */     // MIs[0] round
     /* 1408584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408587 */     // MIs[0] policy
     /* 1408587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408597 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1408600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408621 */     // GIR_Coverage, 17787,
     /* 1408621 */     GIR_EraseRootFromParent_Done,
     /* 1408622 */   // Label 19738: @1408622
     /* 1408622 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1408704), // Rule ID 17790 //
     /* 1408627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1408630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1408644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1408647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1408662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408666 */     // MIs[0] round
     /* 1408666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408669 */     // MIs[0] policy
     /* 1408669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408679 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1408682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408690 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408703 */     // GIR_Coverage, 17790,
     /* 1408703 */     GIR_EraseRootFromParent_Done,
     /* 1408704 */   // Label 19739: @1408704
     /* 1408704 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1408786), // Rule ID 17791 //
     /* 1408709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1408712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1408726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1408729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1408744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408748 */     // MIs[0] round
     /* 1408748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408751 */     // MIs[0] policy
     /* 1408751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408761 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1408764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408772 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408785 */     // GIR_Coverage, 17791,
     /* 1408785 */     GIR_EraseRootFromParent_Done,
     /* 1408786 */   // Label 19740: @1408786
     /* 1408786 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1408868), // Rule ID 17794 //
     /* 1408791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1408794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1408811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408830 */     // MIs[0] round
     /* 1408830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408833 */     // MIs[0] policy
     /* 1408833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408843 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1408846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408854 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408867 */     // GIR_Coverage, 17794,
     /* 1408867 */     GIR_EraseRootFromParent_Done,
     /* 1408868 */   // Label 19741: @1408868
     /* 1408868 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1408950), // Rule ID 17795 //
     /* 1408873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1408876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1408890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1408893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1408908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408912 */     // MIs[0] round
     /* 1408912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408915 */     // MIs[0] policy
     /* 1408915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408925 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10932:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1408928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1408932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1408936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1408938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408949 */     // GIR_Coverage, 17795,
     /* 1408949 */     GIR_EraseRootFromParent_Done,
     /* 1408950 */   // Label 19742: @1408950
     /* 1408950 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1409032), // Rule ID 17798 //
     /* 1408955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1408958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1408963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1408972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1408975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1408990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408994 */     // MIs[0] round
     /* 1408994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1408997 */     // MIs[0] policy
     /* 1408997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409007 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1409010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409018 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409031 */     // GIR_Coverage, 17798,
     /* 1409031 */     GIR_EraseRootFromParent_Done,
     /* 1409032 */   // Label 19743: @1409032
     /* 1409032 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1409114), // Rule ID 17799 //
     /* 1409037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1409040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1409054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1409057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1409072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409076 */     // MIs[0] round
     /* 1409076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409079 */     // MIs[0] policy
     /* 1409079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409089 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10932:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1409092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409113 */     // GIR_Coverage, 17799,
     /* 1409113 */     GIR_EraseRootFromParent_Done,
     /* 1409114 */   // Label 19744: @1409114
     /* 1409114 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1409196), // Rule ID 17802 //
     /* 1409119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1409122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1409136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1409139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1409154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409158 */     // MIs[0] round
     /* 1409158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409161 */     // MIs[0] policy
     /* 1409161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409171 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1409174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409182 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409195 */     // GIR_Coverage, 17802,
     /* 1409195 */     GIR_EraseRootFromParent_Done,
     /* 1409196 */   // Label 19745: @1409196
     /* 1409196 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1409278), // Rule ID 17803 //
     /* 1409201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1409204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1409218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1409221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1409236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409240 */     // MIs[0] round
     /* 1409240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409243 */     // MIs[0] policy
     /* 1409243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409253 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10932:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1409256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409277 */     // GIR_Coverage, 17803,
     /* 1409277 */     GIR_EraseRootFromParent_Done,
     /* 1409278 */   // Label 19746: @1409278
     /* 1409278 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1409360), // Rule ID 17806 //
     /* 1409283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1409286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1409303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409322 */     // MIs[0] round
     /* 1409322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409325 */     // MIs[0] policy
     /* 1409325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409335 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1409338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409346 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409359 */     // GIR_Coverage, 17806,
     /* 1409359 */     GIR_EraseRootFromParent_Done,
     /* 1409360 */   // Label 19747: @1409360
     /* 1409360 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1409442), // Rule ID 17807 //
     /* 1409365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1409368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1409385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409404 */     // MIs[0] round
     /* 1409404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409407 */     // MIs[0] policy
     /* 1409407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409417 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1409420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409441 */     // GIR_Coverage, 17807,
     /* 1409441 */     GIR_EraseRootFromParent_Done,
     /* 1409442 */   // Label 19748: @1409442
     /* 1409442 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1409524), // Rule ID 17810 //
     /* 1409447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1409450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1409467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409486 */     // MIs[0] round
     /* 1409486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409489 */     // MIs[0] policy
     /* 1409489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409499 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1409502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409523 */     // GIR_Coverage, 17810,
     /* 1409523 */     GIR_EraseRootFromParent_Done,
     /* 1409524 */   // Label 19749: @1409524
     /* 1409524 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1409606), // Rule ID 17811 //
     /* 1409529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1409532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1409549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409568 */     // MIs[0] round
     /* 1409568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409571 */     // MIs[0] policy
     /* 1409571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409581 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1409584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409605 */     // GIR_Coverage, 17811,
     /* 1409605 */     GIR_EraseRootFromParent_Done,
     /* 1409606 */   // Label 19750: @1409606
     /* 1409606 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1409688), // Rule ID 17814 //
     /* 1409611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1409614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1409631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409650 */     // MIs[0] round
     /* 1409650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409653 */     // MIs[0] policy
     /* 1409653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409663 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1409666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409674 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409687 */     // GIR_Coverage, 17814,
     /* 1409687 */     GIR_EraseRootFromParent_Done,
     /* 1409688 */   // Label 19751: @1409688
     /* 1409688 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1409770), // Rule ID 17815 //
     /* 1409693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1409696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1409710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1409713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1409728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409732 */     // MIs[0] round
     /* 1409732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409735 */     // MIs[0] policy
     /* 1409735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409745 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1409748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409769 */     // GIR_Coverage, 17815,
     /* 1409769 */     GIR_EraseRootFromParent_Done,
     /* 1409770 */   // Label 19752: @1409770
     /* 1409770 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1409852), // Rule ID 17818 //
     /* 1409775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1409778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1409792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1409795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1409810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409814 */     // MIs[0] round
     /* 1409814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409817 */     // MIs[0] policy
     /* 1409817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1409830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409838 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409851 */     // GIR_Coverage, 17818,
     /* 1409851 */     GIR_EraseRootFromParent_Done,
     /* 1409852 */   // Label 19753: @1409852
     /* 1409852 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1409934), // Rule ID 17819 //
     /* 1409857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1409860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1409874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1409877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1409892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409896 */     // MIs[0] round
     /* 1409896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409899 */     // MIs[0] policy
     /* 1409899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409909 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1409912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1409920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1409922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409933 */     // GIR_Coverage, 17819,
     /* 1409933 */     GIR_EraseRootFromParent_Done,
     /* 1409934 */   // Label 19754: @1409934
     /* 1409934 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1410016), // Rule ID 17822 //
     /* 1409939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1409942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1409947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1409956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1409959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1409974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409978 */     // MIs[0] round
     /* 1409978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1409981 */     // MIs[0] policy
     /* 1409981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409991 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1409994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1409998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410015 */     // GIR_Coverage, 17822,
     /* 1410015 */     GIR_EraseRootFromParent_Done,
     /* 1410016 */   // Label 19755: @1410016
     /* 1410016 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1410098), // Rule ID 17823 //
     /* 1410021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1410024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1410038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1410041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1410056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410060 */     // MIs[0] round
     /* 1410060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410063 */     // MIs[0] policy
     /* 1410063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410073 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1410076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410097 */     // GIR_Coverage, 17823,
     /* 1410097 */     GIR_EraseRootFromParent_Done,
     /* 1410098 */   // Label 19756: @1410098
     /* 1410098 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1410180), // Rule ID 17826 //
     /* 1410103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1410106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1410120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1410123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1410138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410142 */     // MIs[0] round
     /* 1410142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410145 */     // MIs[0] policy
     /* 1410145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410155 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1410158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410179 */     // GIR_Coverage, 17826,
     /* 1410179 */     GIR_EraseRootFromParent_Done,
     /* 1410180 */   // Label 19757: @1410180
     /* 1410180 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1410262), // Rule ID 17827 //
     /* 1410185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1410188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1410202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1410205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1410220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410224 */     // MIs[0] round
     /* 1410224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410227 */     // MIs[0] policy
     /* 1410227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410237 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1410240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410261 */     // GIR_Coverage, 17827,
     /* 1410261 */     GIR_EraseRootFromParent_Done,
     /* 1410262 */   // Label 19758: @1410262
     /* 1410262 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1410344), // Rule ID 17830 //
     /* 1410267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1410270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1410287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410306 */     // MIs[0] round
     /* 1410306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410309 */     // MIs[0] policy
     /* 1410309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410319 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1410322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410330 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410343 */     // GIR_Coverage, 17830,
     /* 1410343 */     GIR_EraseRootFromParent_Done,
     /* 1410344 */   // Label 19759: @1410344
     /* 1410344 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1410426), // Rule ID 17831 //
     /* 1410349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1410352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1410369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410388 */     // MIs[0] round
     /* 1410388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410391 */     // MIs[0] policy
     /* 1410391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410401 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10932:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1410404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410425 */     // GIR_Coverage, 17831,
     /* 1410425 */     GIR_EraseRootFromParent_Done,
     /* 1410426 */   // Label 19760: @1410426
     /* 1410426 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1410508), // Rule ID 17834 //
     /* 1410431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1410434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1410451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410470 */     // MIs[0] round
     /* 1410470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410473 */     // MIs[0] policy
     /* 1410473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410483 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1410486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410494 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410507 */     // GIR_Coverage, 17834,
     /* 1410507 */     GIR_EraseRootFromParent_Done,
     /* 1410508 */   // Label 19761: @1410508
     /* 1410508 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1410590), // Rule ID 17835 //
     /* 1410513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1410516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1410533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410552 */     // MIs[0] round
     /* 1410552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410555 */     // MIs[0] policy
     /* 1410555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410565 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10932:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1410568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410589 */     // GIR_Coverage, 17835,
     /* 1410589 */     GIR_EraseRootFromParent_Done,
     /* 1410590 */   // Label 19762: @1410590
     /* 1410590 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1410672), // Rule ID 17838 //
     /* 1410595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1410598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1410615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410634 */     // MIs[0] round
     /* 1410634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410637 */     // MIs[0] policy
     /* 1410637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410647 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1410650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410658 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410671 */     // GIR_Coverage, 17838,
     /* 1410671 */     GIR_EraseRootFromParent_Done,
     /* 1410672 */   // Label 19763: @1410672
     /* 1410672 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1410754), // Rule ID 17839 //
     /* 1410677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1410680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1410685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1410694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1410697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1410712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410716 */     // MIs[0] round
     /* 1410716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410719 */     // MIs[0] policy
     /* 1410719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410729 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10932:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1410732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410740 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410753 */     // GIR_Coverage, 17839,
     /* 1410753 */     GIR_EraseRootFromParent_Done,
     /* 1410754 */   // Label 19764: @1410754
     /* 1410754 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1410836), // Rule ID 17842 //
     /* 1410759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1410762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1410767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1410770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1410773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1410779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410798 */     // MIs[0] round
     /* 1410798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410801 */     // MIs[0] policy
     /* 1410801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410811 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1410814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410835 */     // GIR_Coverage, 17842,
     /* 1410835 */     GIR_EraseRootFromParent_Done,
     /* 1410836 */   // Label 19765: @1410836
     /* 1410836 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1410918), // Rule ID 17843 //
     /* 1410841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1410844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1410849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1410852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1410855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1410861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410880 */     // MIs[0] round
     /* 1410880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410883 */     // MIs[0] policy
     /* 1410883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410893 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1410896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410917 */     // GIR_Coverage, 17843,
     /* 1410917 */     GIR_EraseRootFromParent_Done,
     /* 1410918 */   // Label 19766: @1410918
     /* 1410918 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1411000), // Rule ID 17846 //
     /* 1410923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1410926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1410931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1410934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1410937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1410943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410962 */     // MIs[0] round
     /* 1410962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1410965 */     // MIs[0] policy
     /* 1410965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410975 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1410978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1410982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1410984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1410986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1410988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410999 */     // GIR_Coverage, 17846,
     /* 1410999 */     GIR_EraseRootFromParent_Done,
     /* 1411000 */   // Label 19767: @1411000
     /* 1411000 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1411082), // Rule ID 17847 //
     /* 1411005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1411008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1411016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1411019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1411025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411044 */     // MIs[0] round
     /* 1411044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411047 */     // MIs[0] policy
     /* 1411047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411057 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1411060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411081 */     // GIR_Coverage, 17847,
     /* 1411081 */     GIR_EraseRootFromParent_Done,
     /* 1411082 */   // Label 19768: @1411082
     /* 1411082 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1411164), // Rule ID 17850 //
     /* 1411087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1411090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1411107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411126 */     // MIs[0] round
     /* 1411126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411129 */     // MIs[0] policy
     /* 1411129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411139 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1411142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411163 */     // GIR_Coverage, 17850,
     /* 1411163 */     GIR_EraseRootFromParent_Done,
     /* 1411164 */   // Label 19769: @1411164
     /* 1411164 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1411246), // Rule ID 17851 //
     /* 1411169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1411172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1411189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411208 */     // MIs[0] round
     /* 1411208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411211 */     // MIs[0] policy
     /* 1411211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411221 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1411224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411245 */     // GIR_Coverage, 17851,
     /* 1411245 */     GIR_EraseRootFromParent_Done,
     /* 1411246 */   // Label 19770: @1411246
     /* 1411246 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1411328), // Rule ID 17854 //
     /* 1411251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1411254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1411262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1411265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1411271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411290 */     // MIs[0] round
     /* 1411290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411293 */     // MIs[0] policy
     /* 1411293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411303 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1411306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411314 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411327 */     // GIR_Coverage, 17854,
     /* 1411327 */     GIR_EraseRootFromParent_Done,
     /* 1411328 */   // Label 19771: @1411328
     /* 1411328 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1411410), // Rule ID 17855 //
     /* 1411333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1411336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1411344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1411347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1411353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411372 */     // MIs[0] round
     /* 1411372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411375 */     // MIs[0] policy
     /* 1411375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411385 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1411388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411396 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411409 */     // GIR_Coverage, 17855,
     /* 1411409 */     GIR_EraseRootFromParent_Done,
     /* 1411410 */   // Label 19772: @1411410
     /* 1411410 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1411492), // Rule ID 17858 //
     /* 1411415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1411418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1411435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411454 */     // MIs[0] round
     /* 1411454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411457 */     // MIs[0] policy
     /* 1411457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411467 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1411470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411478 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411491 */     // GIR_Coverage, 17858,
     /* 1411491 */     GIR_EraseRootFromParent_Done,
     /* 1411492 */   // Label 19773: @1411492
     /* 1411492 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1411574), // Rule ID 17859 //
     /* 1411497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1411500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1411517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411536 */     // MIs[0] round
     /* 1411536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411539 */     // MIs[0] policy
     /* 1411539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411549 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1411552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411560 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411573 */     // GIR_Coverage, 17859,
     /* 1411573 */     GIR_EraseRootFromParent_Done,
     /* 1411574 */   // Label 19774: @1411574
     /* 1411574 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1411656), // Rule ID 17862 //
     /* 1411579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1411582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1411596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1411599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411618 */     // MIs[0] round
     /* 1411618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411621 */     // MIs[0] policy
     /* 1411621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411631 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1411634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411655 */     // GIR_Coverage, 17862,
     /* 1411655 */     GIR_EraseRootFromParent_Done,
     /* 1411656 */   // Label 19775: @1411656
     /* 1411656 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1411738), // Rule ID 17863 //
     /* 1411661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1411664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1411678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1411681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411700 */     // MIs[0] round
     /* 1411700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411703 */     // MIs[0] policy
     /* 1411703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411713 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1411716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411737 */     // GIR_Coverage, 17863,
     /* 1411737 */     GIR_EraseRootFromParent_Done,
     /* 1411738 */   // Label 19776: @1411738
     /* 1411738 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1411820), // Rule ID 17866 //
     /* 1411743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1411746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1411754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1411757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1411763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411782 */     // MIs[0] round
     /* 1411782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411785 */     // MIs[0] policy
     /* 1411785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1411798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411819 */     // GIR_Coverage, 17866,
     /* 1411819 */     GIR_EraseRootFromParent_Done,
     /* 1411820 */   // Label 19777: @1411820
     /* 1411820 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1411902), // Rule ID 17867 //
     /* 1411825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1411828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1411836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1411839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1411845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411864 */     // MIs[0] round
     /* 1411864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411867 */     // MIs[0] policy
     /* 1411867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1411880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411888 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411901 */     // GIR_Coverage, 17867,
     /* 1411901 */     GIR_EraseRootFromParent_Done,
     /* 1411902 */   // Label 19778: @1411902
     /* 1411902 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1411984), // Rule ID 17870 //
     /* 1411907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1411910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1411918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1411921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1411927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411946 */     // MIs[0] round
     /* 1411946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1411949 */     // MIs[0] policy
     /* 1411949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411959 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1411962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1411966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1411968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1411970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1411972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411983 */     // GIR_Coverage, 17870,
     /* 1411983 */     GIR_EraseRootFromParent_Done,
     /* 1411984 */   // Label 19779: @1411984
     /* 1411984 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1412066), // Rule ID 17871 //
     /* 1411989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1411992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1411997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1412000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1412003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1412006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1412009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412028 */     // MIs[0] round
     /* 1412028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412031 */     // MIs[0] policy
     /* 1412031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412041 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1412044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412052 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412065 */     // GIR_Coverage, 17871,
     /* 1412065 */     GIR_EraseRootFromParent_Done,
     /* 1412066 */   // Label 19780: @1412066
     /* 1412066 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1412148), // Rule ID 17874 //
     /* 1412071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1412074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1412082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1412085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1412088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1412091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412110 */     // MIs[0] round
     /* 1412110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412113 */     // MIs[0] policy
     /* 1412113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412123 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1412126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412134 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412147 */     // GIR_Coverage, 17874,
     /* 1412147 */     GIR_EraseRootFromParent_Done,
     /* 1412148 */   // Label 19781: @1412148
     /* 1412148 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1412230), // Rule ID 17875 //
     /* 1412153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1412156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1412164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1412167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1412170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1412173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412192 */     // MIs[0] round
     /* 1412192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412195 */     // MIs[0] policy
     /* 1412195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412205 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1412208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412216 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412229 */     // GIR_Coverage, 17875,
     /* 1412229 */     GIR_EraseRootFromParent_Done,
     /* 1412230 */   // Label 19782: @1412230
     /* 1412230 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1412312), // Rule ID 17878 //
     /* 1412235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1412238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1412255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412274 */     // MIs[0] round
     /* 1412274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412277 */     // MIs[0] policy
     /* 1412277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412287 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1412290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412311 */     // GIR_Coverage, 17878,
     /* 1412311 */     GIR_EraseRootFromParent_Done,
     /* 1412312 */   // Label 19783: @1412312
     /* 1412312 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1412394), // Rule ID 17879 //
     /* 1412317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1412320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1412337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412356 */     // MIs[0] round
     /* 1412356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412359 */     // MIs[0] policy
     /* 1412359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412369 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1412372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412380 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412393 */     // GIR_Coverage, 17879,
     /* 1412393 */     GIR_EraseRootFromParent_Done,
     /* 1412394 */   // Label 19784: @1412394
     /* 1412394 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1412476), // Rule ID 17882 //
     /* 1412399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1412402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1412419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412438 */     // MIs[0] round
     /* 1412438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412441 */     // MIs[0] policy
     /* 1412441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412451 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1412454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412475 */     // GIR_Coverage, 17882,
     /* 1412475 */     GIR_EraseRootFromParent_Done,
     /* 1412476 */   // Label 19785: @1412476
     /* 1412476 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1412558), // Rule ID 17883 //
     /* 1412481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1412484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1412501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412520 */     // MIs[0] round
     /* 1412520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412523 */     // MIs[0] policy
     /* 1412523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412533 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1412536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412544 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412557 */     // GIR_Coverage, 17883,
     /* 1412557 */     GIR_EraseRootFromParent_Done,
     /* 1412558 */   // Label 19786: @1412558
     /* 1412558 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1412640), // Rule ID 17886 //
     /* 1412563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1412566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1412574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1412577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1412580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1412583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412602 */     // MIs[0] round
     /* 1412602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412605 */     // MIs[0] policy
     /* 1412605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412615 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1412618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412639 */     // GIR_Coverage, 17886,
     /* 1412639 */     GIR_EraseRootFromParent_Done,
     /* 1412640 */   // Label 19787: @1412640
     /* 1412640 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1412722), // Rule ID 17887 //
     /* 1412645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1412648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1412656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1412659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1412662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1412665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412684 */     // MIs[0] round
     /* 1412684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412687 */     // MIs[0] policy
     /* 1412687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412697 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1412700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412708 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412721 */     // GIR_Coverage, 17887,
     /* 1412721 */     GIR_EraseRootFromParent_Done,
     /* 1412722 */   // Label 19788: @1412722
     /* 1412722 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1412804), // Rule ID 17890 //
     /* 1412727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1412730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1412744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1412747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412766 */     // MIs[0] round
     /* 1412766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412769 */     // MIs[0] policy
     /* 1412769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412779 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1412782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1412800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412803 */     // GIR_Coverage, 17890,
     /* 1412803 */     GIR_EraseRootFromParent_Done,
     /* 1412804 */   // Label 19789: @1412804
     /* 1412804 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1412886), // Rule ID 17891 //
     /* 1412809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1412812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1412826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1412829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412848 */     // MIs[0] round
     /* 1412848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412851 */     // MIs[0] policy
     /* 1412851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1412864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412872 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1412882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412885 */     // GIR_Coverage, 17891,
     /* 1412885 */     GIR_EraseRootFromParent_Done,
     /* 1412886 */   // Label 19790: @1412886
     /* 1412886 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1412968), // Rule ID 17894 //
     /* 1412891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1412894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1412908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1412911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412930 */     // MIs[0] round
     /* 1412930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1412933 */     // MIs[0] policy
     /* 1412933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412943 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1412946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1412950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1412954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1412956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1412964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412967 */     // GIR_Coverage, 17894,
     /* 1412967 */     GIR_EraseRootFromParent_Done,
     /* 1412968 */   // Label 19791: @1412968
     /* 1412968 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1413050), // Rule ID 17895 //
     /* 1412973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1412976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1412981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1412990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1412993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413012 */     // MIs[0] round
     /* 1413012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413015 */     // MIs[0] policy
     /* 1413015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413025 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1413028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413036 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1413046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413049 */     // GIR_Coverage, 17895,
     /* 1413049 */     GIR_EraseRootFromParent_Done,
     /* 1413050 */   // Label 19792: @1413050
     /* 1413050 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1413132), // Rule ID 17898 //
     /* 1413055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1413058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1413072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1413075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413094 */     // MIs[0] round
     /* 1413094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413097 */     // MIs[0] policy
     /* 1413097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413107 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1413110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413118 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1413128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413131 */     // GIR_Coverage, 17898,
     /* 1413131 */     GIR_EraseRootFromParent_Done,
     /* 1413132 */   // Label 19793: @1413132
     /* 1413132 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1413214), // Rule ID 17899 //
     /* 1413137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1413140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1413154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1413157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413176 */     // MIs[0] round
     /* 1413176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413179 */     // MIs[0] policy
     /* 1413179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413189 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1413192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1413210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413213 */     // GIR_Coverage, 17899,
     /* 1413213 */     GIR_EraseRootFromParent_Done,
     /* 1413214 */   // Label 19794: @1413214
     /* 1413214 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1413296), // Rule ID 17902 //
     /* 1413219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1413222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1413230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1413233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1413239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413258 */     // MIs[0] round
     /* 1413258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413261 */     // MIs[0] policy
     /* 1413261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413271 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1413274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413295 */     // GIR_Coverage, 17902,
     /* 1413295 */     GIR_EraseRootFromParent_Done,
     /* 1413296 */   // Label 19795: @1413296
     /* 1413296 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1413378), // Rule ID 17903 //
     /* 1413301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1413304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1413312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1413315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1413321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413340 */     // MIs[0] round
     /* 1413340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413343 */     // MIs[0] policy
     /* 1413343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413353 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1413356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413364 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413377 */     // GIR_Coverage, 17903,
     /* 1413377 */     GIR_EraseRootFromParent_Done,
     /* 1413378 */   // Label 19796: @1413378
     /* 1413378 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1413460), // Rule ID 17906 //
     /* 1413383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1413386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1413394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1413397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1413403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413422 */     // MIs[0] round
     /* 1413422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413425 */     // MIs[0] policy
     /* 1413425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413435 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1413438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413459 */     // GIR_Coverage, 17906,
     /* 1413459 */     GIR_EraseRootFromParent_Done,
     /* 1413460 */   // Label 19797: @1413460
     /* 1413460 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1413542), // Rule ID 17907 //
     /* 1413465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1413468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1413476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1413479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1413485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413504 */     // MIs[0] round
     /* 1413504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413507 */     // MIs[0] policy
     /* 1413507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413517 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1413520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413541 */     // GIR_Coverage, 17907,
     /* 1413541 */     GIR_EraseRootFromParent_Done,
     /* 1413542 */   // Label 19798: @1413542
     /* 1413542 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1413624), // Rule ID 17910 //
     /* 1413547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1413550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1413564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1413567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1413582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413586 */     // MIs[0] round
     /* 1413586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413589 */     // MIs[0] policy
     /* 1413589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413599 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1413602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413623 */     // GIR_Coverage, 17910,
     /* 1413623 */     GIR_EraseRootFromParent_Done,
     /* 1413624 */   // Label 19799: @1413624
     /* 1413624 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1413706), // Rule ID 17911 //
     /* 1413629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1413632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1413646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1413649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1413664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413668 */     // MIs[0] round
     /* 1413668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413671 */     // MIs[0] policy
     /* 1413671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413681 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1413684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413692 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413705 */     // GIR_Coverage, 17911,
     /* 1413705 */     GIR_EraseRootFromParent_Done,
     /* 1413706 */   // Label 19800: @1413706
     /* 1413706 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1413788), // Rule ID 17914 //
     /* 1413711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1413714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1413722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1413725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1413731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413750 */     // MIs[0] round
     /* 1413750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413753 */     // MIs[0] policy
     /* 1413753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413763 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1413766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413774 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413787 */     // GIR_Coverage, 17914,
     /* 1413787 */     GIR_EraseRootFromParent_Done,
     /* 1413788 */   // Label 19801: @1413788
     /* 1413788 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1413870), // Rule ID 17915 //
     /* 1413793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1413796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1413804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1413807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1413810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1413813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1413828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413832 */     // MIs[0] round
     /* 1413832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413835 */     // MIs[0] policy
     /* 1413835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10905:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1413848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413856 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413869 */     // GIR_Coverage, 17915,
     /* 1413869 */     GIR_EraseRootFromParent_Done,
     /* 1413870 */   // Label 19802: @1413870
     /* 1413870 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1413952), // Rule ID 17918 //
     /* 1413875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1413878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1413892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1413895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1413910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413914 */     // MIs[0] round
     /* 1413914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413917 */     // MIs[0] policy
     /* 1413917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413927 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1413930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1413934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1413938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1413940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413951 */     // GIR_Coverage, 17918,
     /* 1413951 */     GIR_EraseRootFromParent_Done,
     /* 1413952 */   // Label 19803: @1413952
     /* 1413952 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1414034), // Rule ID 17919 //
     /* 1413957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1413960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1413965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1413974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1413977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1413992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413996 */     // MIs[0] round
     /* 1413996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1413999 */     // MIs[0] policy
     /* 1413999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414009 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10905:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1414012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414020 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414033 */     // GIR_Coverage, 17919,
     /* 1414033 */     GIR_EraseRootFromParent_Done,
     /* 1414034 */   // Label 19804: @1414034
     /* 1414034 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1414116), // Rule ID 17922 //
     /* 1414039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1414042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1414050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1414053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1414056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1414059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1414074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414078 */     // MIs[0] round
     /* 1414078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414081 */     // MIs[0] policy
     /* 1414081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414091 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1414094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414102 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414115 */     // GIR_Coverage, 17922,
     /* 1414115 */     GIR_EraseRootFromParent_Done,
     /* 1414116 */   // Label 19805: @1414116
     /* 1414116 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1414198), // Rule ID 17923 //
     /* 1414121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1414124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1414132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1414135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1414138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1414141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1414156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414160 */     // MIs[0] round
     /* 1414160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414163 */     // MIs[0] policy
     /* 1414163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414173 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10905:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1414176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414184 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414197 */     // GIR_Coverage, 17923,
     /* 1414197 */     GIR_EraseRootFromParent_Done,
     /* 1414198 */   // Label 19806: @1414198
     /* 1414198 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1414280), // Rule ID 17926 //
     /* 1414203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1414206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1414214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1414217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1414223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414242 */     // MIs[0] round
     /* 1414242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414245 */     // MIs[0] policy
     /* 1414245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1414258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414279 */     // GIR_Coverage, 17926,
     /* 1414279 */     GIR_EraseRootFromParent_Done,
     /* 1414280 */   // Label 19807: @1414280
     /* 1414280 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1414362), // Rule ID 17927 //
     /* 1414285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1414288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1414296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1414299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1414305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414324 */     // MIs[0] round
     /* 1414324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414327 */     // MIs[0] policy
     /* 1414327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414337 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1414340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414348 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414361 */     // GIR_Coverage, 17927,
     /* 1414361 */     GIR_EraseRootFromParent_Done,
     /* 1414362 */   // Label 19808: @1414362
     /* 1414362 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1414444), // Rule ID 17930 //
     /* 1414367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1414370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1414378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1414381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1414387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414406 */     // MIs[0] round
     /* 1414406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414409 */     // MIs[0] policy
     /* 1414409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414419 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1414422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414443 */     // GIR_Coverage, 17930,
     /* 1414443 */     GIR_EraseRootFromParent_Done,
     /* 1414444 */   // Label 19809: @1414444
     /* 1414444 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1414526), // Rule ID 17931 //
     /* 1414449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1414452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1414460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1414463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1414469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414488 */     // MIs[0] round
     /* 1414488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414491 */     // MIs[0] policy
     /* 1414491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414501 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1414504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414512 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414525 */     // GIR_Coverage, 17931,
     /* 1414525 */     GIR_EraseRootFromParent_Done,
     /* 1414526 */   // Label 19810: @1414526
     /* 1414526 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1414608), // Rule ID 17934 //
     /* 1414531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1414534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1414542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1414545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1414551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414570 */     // MIs[0] round
     /* 1414570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414573 */     // MIs[0] policy
     /* 1414573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1414586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414594 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414607 */     // GIR_Coverage, 17934,
     /* 1414607 */     GIR_EraseRootFromParent_Done,
     /* 1414608 */   // Label 19811: @1414608
     /* 1414608 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1414690), // Rule ID 17935 //
     /* 1414613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1414616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1414624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1414627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1414630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1414633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1414648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414652 */     // MIs[0] round
     /* 1414652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414655 */     // MIs[0] policy
     /* 1414655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414665 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1414668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414676 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414689 */     // GIR_Coverage, 17935,
     /* 1414689 */     GIR_EraseRootFromParent_Done,
     /* 1414690 */   // Label 19812: @1414690
     /* 1414690 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1414772), // Rule ID 17938 //
     /* 1414695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1414698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1414706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1414709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1414712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1414715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1414730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414734 */     // MIs[0] round
     /* 1414734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414737 */     // MIs[0] policy
     /* 1414737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414747 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1414750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414771 */     // GIR_Coverage, 17938,
     /* 1414771 */     GIR_EraseRootFromParent_Done,
     /* 1414772 */   // Label 19813: @1414772
     /* 1414772 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1414854), // Rule ID 17939 //
     /* 1414777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1414780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1414788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1414791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1414794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1414797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1414812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414816 */     // MIs[0] round
     /* 1414816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414819 */     // MIs[0] policy
     /* 1414819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414829 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1414832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414840 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414853 */     // GIR_Coverage, 17939,
     /* 1414853 */     GIR_EraseRootFromParent_Done,
     /* 1414854 */   // Label 19814: @1414854
     /* 1414854 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1414936), // Rule ID 17942 //
     /* 1414859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1414862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1414870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1414873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1414876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1414879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1414894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414898 */     // MIs[0] round
     /* 1414898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414901 */     // MIs[0] policy
     /* 1414901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414911 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1414914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1414918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1414922 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1414924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414935 */     // GIR_Coverage, 17942,
     /* 1414935 */     GIR_EraseRootFromParent_Done,
     /* 1414936 */   // Label 19815: @1414936
     /* 1414936 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1415018), // Rule ID 17943 //
     /* 1414941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1414944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1414949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1414952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1414955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1414958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1414961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1414976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414980 */     // MIs[0] round
     /* 1414980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1414983 */     // MIs[0] policy
     /* 1414983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414993 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1414996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415004 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415017 */     // GIR_Coverage, 17943,
     /* 1415017 */     GIR_EraseRootFromParent_Done,
     /* 1415018 */   // Label 19816: @1415018
     /* 1415018 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1415100), // Rule ID 17946 //
     /* 1415023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1415026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1415034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1415037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1415040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1415043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1415058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415062 */     // MIs[0] round
     /* 1415062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415065 */     // MIs[0] policy
     /* 1415065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415075 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1415078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415099 */     // GIR_Coverage, 17946,
     /* 1415099 */     GIR_EraseRootFromParent_Done,
     /* 1415100 */   // Label 19817: @1415100
     /* 1415100 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1415182), // Rule ID 17947 //
     /* 1415105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1415108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1415116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1415119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1415122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1415125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1415140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415144 */     // MIs[0] round
     /* 1415144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415147 */     // MIs[0] policy
     /* 1415147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415157 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1415160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415168 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415181 */     // GIR_Coverage, 17947,
     /* 1415181 */     GIR_EraseRootFromParent_Done,
     /* 1415182 */   // Label 19818: @1415182
     /* 1415182 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1415264), // Rule ID 17950 //
     /* 1415187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1415190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1415198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1415201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1415207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415226 */     // MIs[0] round
     /* 1415226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415229 */     // MIs[0] policy
     /* 1415229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415239 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1415242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415263 */     // GIR_Coverage, 17950,
     /* 1415263 */     GIR_EraseRootFromParent_Done,
     /* 1415264 */   // Label 19819: @1415264
     /* 1415264 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1415346), // Rule ID 17951 //
     /* 1415269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1415272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1415280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1415283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1415289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415308 */     // MIs[0] round
     /* 1415308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415311 */     // MIs[0] policy
     /* 1415311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10905:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1415324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415332 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415345 */     // GIR_Coverage, 17951,
     /* 1415345 */     GIR_EraseRootFromParent_Done,
     /* 1415346 */   // Label 19820: @1415346
     /* 1415346 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1415428), // Rule ID 17954 //
     /* 1415351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1415354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1415362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1415365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1415371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415390 */     // MIs[0] round
     /* 1415390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415393 */     // MIs[0] policy
     /* 1415393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415403 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1415406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415427 */     // GIR_Coverage, 17954,
     /* 1415427 */     GIR_EraseRootFromParent_Done,
     /* 1415428 */   // Label 19821: @1415428
     /* 1415428 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1415510), // Rule ID 17955 //
     /* 1415433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1415436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1415444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1415447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1415453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415472 */     // MIs[0] round
     /* 1415472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415475 */     // MIs[0] policy
     /* 1415475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415485 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10905:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1415488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415496 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415509 */     // GIR_Coverage, 17955,
     /* 1415509 */     GIR_EraseRootFromParent_Done,
     /* 1415510 */   // Label 19822: @1415510
     /* 1415510 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1415592), // Rule ID 17958 //
     /* 1415515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1415518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1415526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1415529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1415535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415554 */     // MIs[0] round
     /* 1415554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415557 */     // MIs[0] policy
     /* 1415557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415567 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1415570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415591 */     // GIR_Coverage, 17958,
     /* 1415591 */     GIR_EraseRootFromParent_Done,
     /* 1415592 */   // Label 19823: @1415592
     /* 1415592 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1415674), // Rule ID 17959 //
     /* 1415597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1415600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1415605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1415608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1415611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1415614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1415617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1415632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415636 */     // MIs[0] round
     /* 1415636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415639 */     // MIs[0] policy
     /* 1415639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415649 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10905:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1415652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415660 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1415670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415673 */     // GIR_Coverage, 17959,
     /* 1415673 */     GIR_EraseRootFromParent_Done,
     /* 1415674 */   // Label 19824: @1415674
     /* 1415674 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1415756), // Rule ID 17962 //
     /* 1415679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1415682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1415687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1415696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1415699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415718 */     // MIs[0] round
     /* 1415718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415721 */     // MIs[0] policy
     /* 1415721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415731 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1415734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415755 */     // GIR_Coverage, 17962,
     /* 1415755 */     GIR_EraseRootFromParent_Done,
     /* 1415756 */   // Label 19825: @1415756
     /* 1415756 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1415838), // Rule ID 17963 //
     /* 1415761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1415764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1415769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1415778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1415781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415800 */     // MIs[0] round
     /* 1415800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415803 */     // MIs[0] policy
     /* 1415803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415813 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1415816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415837 */     // GIR_Coverage, 17963,
     /* 1415837 */     GIR_EraseRootFromParent_Done,
     /* 1415838 */   // Label 19826: @1415838
     /* 1415838 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1415920), // Rule ID 17966 //
     /* 1415843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1415846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1415851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1415860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1415863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415882 */     // MIs[0] round
     /* 1415882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415885 */     // MIs[0] policy
     /* 1415885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415895 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1415898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415919 */     // GIR_Coverage, 17966,
     /* 1415919 */     GIR_EraseRootFromParent_Done,
     /* 1415920 */   // Label 19827: @1415920
     /* 1415920 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1416002), // Rule ID 17967 //
     /* 1415925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1415928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1415933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1415942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1415945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415964 */     // MIs[0] round
     /* 1415964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1415967 */     // MIs[0] policy
     /* 1415967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415977 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1415980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1415984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1415988 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1415990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416001 */     // GIR_Coverage, 17967,
     /* 1416001 */     GIR_EraseRootFromParent_Done,
     /* 1416002 */   // Label 19828: @1416002
     /* 1416002 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1416084), // Rule ID 17970 //
     /* 1416007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1416010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1416024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1416027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416046 */     // MIs[0] round
     /* 1416046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416049 */     // MIs[0] policy
     /* 1416049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416059 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1416062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416083 */     // GIR_Coverage, 17970,
     /* 1416083 */     GIR_EraseRootFromParent_Done,
     /* 1416084 */   // Label 19829: @1416084
     /* 1416084 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1416166), // Rule ID 17971 //
     /* 1416089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1416092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1416106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1416109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416128 */     // MIs[0] round
     /* 1416128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416131 */     // MIs[0] policy
     /* 1416131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416141 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1416144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416165 */     // GIR_Coverage, 17971,
     /* 1416165 */     GIR_EraseRootFromParent_Done,
     /* 1416166 */   // Label 19830: @1416166
     /* 1416166 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1416248), // Rule ID 17974 //
     /* 1416171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1416174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1416182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1416185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1416191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416210 */     // MIs[0] round
     /* 1416210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416213 */     // MIs[0] policy
     /* 1416213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416223 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1416226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416234 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416247 */     // GIR_Coverage, 17974,
     /* 1416247 */     GIR_EraseRootFromParent_Done,
     /* 1416248 */   // Label 19831: @1416248
     /* 1416248 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1416330), // Rule ID 17975 //
     /* 1416253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1416256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1416264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1416267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1416273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416292 */     // MIs[0] round
     /* 1416292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416295 */     // MIs[0] policy
     /* 1416295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416305 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1416308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416316 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416329 */     // GIR_Coverage, 17975,
     /* 1416329 */     GIR_EraseRootFromParent_Done,
     /* 1416330 */   // Label 19832: @1416330
     /* 1416330 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1416412), // Rule ID 17978 //
     /* 1416335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1416338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1416352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1416355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416374 */     // MIs[0] round
     /* 1416374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416377 */     // MIs[0] policy
     /* 1416377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416387 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1416390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416398 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416411 */     // GIR_Coverage, 17978,
     /* 1416411 */     GIR_EraseRootFromParent_Done,
     /* 1416412 */   // Label 19833: @1416412
     /* 1416412 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1416494), // Rule ID 17979 //
     /* 1416417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1416420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1416434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1416437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416456 */     // MIs[0] round
     /* 1416456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416459 */     // MIs[0] policy
     /* 1416459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416469 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1416472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416493 */     // GIR_Coverage, 17979,
     /* 1416493 */     GIR_EraseRootFromParent_Done,
     /* 1416494 */   // Label 19834: @1416494
     /* 1416494 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1416576), // Rule ID 17982 //
     /* 1416499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1416502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1416510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1416513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1416519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416538 */     // MIs[0] round
     /* 1416538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416541 */     // MIs[0] policy
     /* 1416541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416551 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1416554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416562 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416575 */     // GIR_Coverage, 17982,
     /* 1416575 */     GIR_EraseRootFromParent_Done,
     /* 1416576 */   // Label 19835: @1416576
     /* 1416576 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1416658), // Rule ID 17983 //
     /* 1416581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1416584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1416592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1416595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1416601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416620 */     // MIs[0] round
     /* 1416620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416623 */     // MIs[0] policy
     /* 1416623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1416636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416644 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416657 */     // GIR_Coverage, 17983,
     /* 1416657 */     GIR_EraseRootFromParent_Done,
     /* 1416658 */   // Label 19836: @1416658
     /* 1416658 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1416740), // Rule ID 17986 //
     /* 1416663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1416666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1416680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1416683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416702 */     // MIs[0] round
     /* 1416702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416705 */     // MIs[0] policy
     /* 1416705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416715 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1416718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416739 */     // GIR_Coverage, 17986,
     /* 1416739 */     GIR_EraseRootFromParent_Done,
     /* 1416740 */   // Label 19837: @1416740
     /* 1416740 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1416822), // Rule ID 17987 //
     /* 1416745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1416748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1416762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1416765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416784 */     // MIs[0] round
     /* 1416784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416787 */     // MIs[0] policy
     /* 1416787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1416800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416821 */     // GIR_Coverage, 17987,
     /* 1416821 */     GIR_EraseRootFromParent_Done,
     /* 1416822 */   // Label 19838: @1416822
     /* 1416822 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1416904), // Rule ID 17990 //
     /* 1416827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1416830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1416844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1416847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416866 */     // MIs[0] round
     /* 1416866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416869 */     // MIs[0] policy
     /* 1416869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416879 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1416882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416903 */     // GIR_Coverage, 17990,
     /* 1416903 */     GIR_EraseRootFromParent_Done,
     /* 1416904 */   // Label 19839: @1416904
     /* 1416904 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1416986), // Rule ID 17991 //
     /* 1416909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1416912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1416926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1416929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416948 */     // MIs[0] round
     /* 1416948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1416951 */     // MIs[0] policy
     /* 1416951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416961 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1416964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1416968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1416972 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1416974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416985 */     // GIR_Coverage, 17991,
     /* 1416985 */     GIR_EraseRootFromParent_Done,
     /* 1416986 */   // Label 19840: @1416986
     /* 1416986 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1417068), // Rule ID 17994 //
     /* 1416991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1416994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1416999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1417002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1417005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1417011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417030 */     // MIs[0] round
     /* 1417030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417033 */     // MIs[0] policy
     /* 1417033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417043 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1417046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417054 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417067 */     // GIR_Coverage, 17994,
     /* 1417067 */     GIR_EraseRootFromParent_Done,
     /* 1417068 */   // Label 19841: @1417068
     /* 1417068 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1417150), // Rule ID 17995 //
     /* 1417073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1417076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1417084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1417087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1417093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417112 */     // MIs[0] round
     /* 1417112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417115 */     // MIs[0] policy
     /* 1417115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417125 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1417128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417149 */     // GIR_Coverage, 17995,
     /* 1417149 */     GIR_EraseRootFromParent_Done,
     /* 1417150 */   // Label 19842: @1417150
     /* 1417150 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1417232), // Rule ID 17998 //
     /* 1417155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1417158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1417166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1417169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1417172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1417175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417194 */     // MIs[0] round
     /* 1417194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417197 */     // MIs[0] policy
     /* 1417197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1417210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417218 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417231 */     // GIR_Coverage, 17998,
     /* 1417231 */     GIR_EraseRootFromParent_Done,
     /* 1417232 */   // Label 19843: @1417232
     /* 1417232 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1417314), // Rule ID 17999 //
     /* 1417237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1417240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1417248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1417251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1417254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1417257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417276 */     // MIs[0] round
     /* 1417276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417279 */     // MIs[0] policy
     /* 1417279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417289 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1417292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417313 */     // GIR_Coverage, 17999,
     /* 1417313 */     GIR_EraseRootFromParent_Done,
     /* 1417314 */   // Label 19844: @1417314
     /* 1417314 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1417396), // Rule ID 18002 //
     /* 1417319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1417322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1417330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1417333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1417336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1417339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417358 */     // MIs[0] round
     /* 1417358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417361 */     // MIs[0] policy
     /* 1417361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417371 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1417374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417382 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417395 */     // GIR_Coverage, 18002,
     /* 1417395 */     GIR_EraseRootFromParent_Done,
     /* 1417396 */   // Label 19845: @1417396
     /* 1417396 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1417478), // Rule ID 18003 //
     /* 1417401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1417404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1417412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1417415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1417418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1417421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417440 */     // MIs[0] round
     /* 1417440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417443 */     // MIs[0] policy
     /* 1417443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417453 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1417456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417477 */     // GIR_Coverage, 18003,
     /* 1417477 */     GIR_EraseRootFromParent_Done,
     /* 1417478 */   // Label 19846: @1417478
     /* 1417478 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1417560), // Rule ID 18006 //
     /* 1417483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1417486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1417494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1417497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1417500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1417503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417522 */     // MIs[0] round
     /* 1417522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417525 */     // MIs[0] policy
     /* 1417525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417535 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1417538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417546 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417559 */     // GIR_Coverage, 18006,
     /* 1417559 */     GIR_EraseRootFromParent_Done,
     /* 1417560 */   // Label 19847: @1417560
     /* 1417560 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1417642), // Rule ID 18007 //
     /* 1417565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1417568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1417576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1417579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1417582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1417585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417604 */     // MIs[0] round
     /* 1417604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417607 */     // MIs[0] policy
     /* 1417607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417617 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1417620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417641 */     // GIR_Coverage, 18007,
     /* 1417641 */     GIR_EraseRootFromParent_Done,
     /* 1417642 */   // Label 19848: @1417642
     /* 1417642 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1417724), // Rule ID 18010 //
     /* 1417647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1417650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1417658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1417661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1417664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1417667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417686 */     // MIs[0] round
     /* 1417686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417689 */     // MIs[0] policy
     /* 1417689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417699 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1417702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1417720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417723 */     // GIR_Coverage, 18010,
     /* 1417723 */     GIR_EraseRootFromParent_Done,
     /* 1417724 */   // Label 19849: @1417724
     /* 1417724 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1417806), // Rule ID 18011 //
     /* 1417729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1417732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1417740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1417743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1417746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1417749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417768 */     // MIs[0] round
     /* 1417768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417771 */     // MIs[0] policy
     /* 1417771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1417784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1417802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417805 */     // GIR_Coverage, 18011,
     /* 1417805 */     GIR_EraseRootFromParent_Done,
     /* 1417806 */   // Label 19850: @1417806
     /* 1417806 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1417888), // Rule ID 18014 //
     /* 1417811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1417814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1417822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1417825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1417828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1417831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417850 */     // MIs[0] round
     /* 1417850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417853 */     // MIs[0] policy
     /* 1417853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417863 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1417866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417874 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1417884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417887 */     // GIR_Coverage, 18014,
     /* 1417887 */     GIR_EraseRootFromParent_Done,
     /* 1417888 */   // Label 19851: @1417888
     /* 1417888 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1417970), // Rule ID 18015 //
     /* 1417893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1417896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1417904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1417907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1417910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1417913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417932 */     // MIs[0] round
     /* 1417932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1417935 */     // MIs[0] policy
     /* 1417935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417945 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1417948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1417952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1417956 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1417958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1417966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417969 */     // GIR_Coverage, 18015,
     /* 1417969 */     GIR_EraseRootFromParent_Done,
     /* 1417970 */   // Label 19852: @1417970
     /* 1417970 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1418052), // Rule ID 18018 //
     /* 1417975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1417978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1417983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1417986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1417989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1417992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1417995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418014 */     // MIs[0] round
     /* 1418014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418017 */     // MIs[0] policy
     /* 1418017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418027 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1418030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418051 */     // GIR_Coverage, 18018,
     /* 1418051 */     GIR_EraseRootFromParent_Done,
     /* 1418052 */   // Label 19853: @1418052
     /* 1418052 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1418134), // Rule ID 18019 //
     /* 1418057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1418060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1418068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1418071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1418074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1418077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418096 */     // MIs[0] round
     /* 1418096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418099 */     // MIs[0] policy
     /* 1418099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418109 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1418112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418133 */     // GIR_Coverage, 18019,
     /* 1418133 */     GIR_EraseRootFromParent_Done,
     /* 1418134 */   // Label 19854: @1418134
     /* 1418134 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1418216), // Rule ID 18022 //
     /* 1418139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1418142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1418159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418178 */     // MIs[0] round
     /* 1418178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418181 */     // MIs[0] policy
     /* 1418181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418191 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1418194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418202 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418215 */     // GIR_Coverage, 18022,
     /* 1418215 */     GIR_EraseRootFromParent_Done,
     /* 1418216 */   // Label 19855: @1418216
     /* 1418216 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1418298), // Rule ID 18023 //
     /* 1418221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1418224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1418241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418260 */     // MIs[0] round
     /* 1418260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418263 */     // MIs[0] policy
     /* 1418263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418273 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1418276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418297 */     // GIR_Coverage, 18023,
     /* 1418297 */     GIR_EraseRootFromParent_Done,
     /* 1418298 */   // Label 19856: @1418298
     /* 1418298 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1418380), // Rule ID 18026 //
     /* 1418303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1418306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1418323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418342 */     // MIs[0] round
     /* 1418342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418345 */     // MIs[0] policy
     /* 1418345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418355 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1418358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418379 */     // GIR_Coverage, 18026,
     /* 1418379 */     GIR_EraseRootFromParent_Done,
     /* 1418380 */   // Label 19857: @1418380
     /* 1418380 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1418462), // Rule ID 18027 //
     /* 1418385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1418388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1418405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418424 */     // MIs[0] round
     /* 1418424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418427 */     // MIs[0] policy
     /* 1418427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418437 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1418440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418461 */     // GIR_Coverage, 18027,
     /* 1418461 */     GIR_EraseRootFromParent_Done,
     /* 1418462 */   // Label 19858: @1418462
     /* 1418462 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1418544), // Rule ID 18030 //
     /* 1418467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1418470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1418484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1418487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1418502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418506 */     // MIs[0] round
     /* 1418506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418509 */     // MIs[0] policy
     /* 1418509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418519 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1418522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418530 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418543 */     // GIR_Coverage, 18030,
     /* 1418543 */     GIR_EraseRootFromParent_Done,
     /* 1418544 */   // Label 19859: @1418544
     /* 1418544 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1418626), // Rule ID 18031 //
     /* 1418549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1418552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1418566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1418569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1418584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418588 */     // MIs[0] round
     /* 1418588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418591 */     // MIs[0] policy
     /* 1418591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418601 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1418604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418612 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418625 */     // GIR_Coverage, 18031,
     /* 1418625 */     GIR_EraseRootFromParent_Done,
     /* 1418626 */   // Label 19860: @1418626
     /* 1418626 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1418708), // Rule ID 18034 //
     /* 1418631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1418634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1418651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418670 */     // MIs[0] round
     /* 1418670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418673 */     // MIs[0] policy
     /* 1418673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418683 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1418686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418707 */     // GIR_Coverage, 18034,
     /* 1418707 */     GIR_EraseRootFromParent_Done,
     /* 1418708 */   // Label 19861: @1418708
     /* 1418708 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1418790), // Rule ID 18035 //
     /* 1418713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1418716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1418730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1418733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1418748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418752 */     // MIs[0] round
     /* 1418752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418755 */     // MIs[0] policy
     /* 1418755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418765 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10936:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1418768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418776 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418789 */     // GIR_Coverage, 18035,
     /* 1418789 */     GIR_EraseRootFromParent_Done,
     /* 1418790 */   // Label 19862: @1418790
     /* 1418790 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1418872), // Rule ID 18038 //
     /* 1418795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1418798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1418812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1418815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1418830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418834 */     // MIs[0] round
     /* 1418834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418837 */     // MIs[0] policy
     /* 1418837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418847 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1418850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418858 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418871 */     // GIR_Coverage, 18038,
     /* 1418871 */     GIR_EraseRootFromParent_Done,
     /* 1418872 */   // Label 19863: @1418872
     /* 1418872 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1418954), // Rule ID 18039 //
     /* 1418877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1418880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1418894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1418897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1418912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418916 */     // MIs[0] round
     /* 1418916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1418919 */     // MIs[0] policy
     /* 1418919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418929 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10936:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1418932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1418936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1418940 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1418942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418953 */     // GIR_Coverage, 18039,
     /* 1418953 */     GIR_EraseRootFromParent_Done,
     /* 1418954 */   // Label 19864: @1418954
     /* 1418954 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1419036), // Rule ID 18042 //
     /* 1418959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1418962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1418967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1418970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1418973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1418976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1418979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1418994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418998 */     // MIs[0] round
     /* 1418998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419001 */     // MIs[0] policy
     /* 1419001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419011 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1419014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419022 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1419032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419035 */     // GIR_Coverage, 18042,
     /* 1419035 */     GIR_EraseRootFromParent_Done,
     /* 1419036 */   // Label 19865: @1419036
     /* 1419036 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1419118), // Rule ID 18043 //
     /* 1419041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1419044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1419052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1419055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1419058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1419061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1419076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419080 */     // MIs[0] round
     /* 1419080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419083 */     // MIs[0] policy
     /* 1419083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419093 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10936:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1419096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1419114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419117 */     // GIR_Coverage, 18043,
     /* 1419117 */     GIR_EraseRootFromParent_Done,
     /* 1419118 */   // Label 19866: @1419118
     /* 1419118 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1419200), // Rule ID 18046 //
     /* 1419123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1419126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1419143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419162 */     // MIs[0] round
     /* 1419162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419165 */     // MIs[0] policy
     /* 1419165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419175 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1419178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419186 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419199 */     // GIR_Coverage, 18046,
     /* 1419199 */     GIR_EraseRootFromParent_Done,
     /* 1419200 */   // Label 19867: @1419200
     /* 1419200 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1419282), // Rule ID 18047 //
     /* 1419205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1419208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1419225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419244 */     // MIs[0] round
     /* 1419244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419247 */     // MIs[0] policy
     /* 1419247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1419260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419281 */     // GIR_Coverage, 18047,
     /* 1419281 */     GIR_EraseRootFromParent_Done,
     /* 1419282 */   // Label 19868: @1419282
     /* 1419282 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1419364), // Rule ID 18050 //
     /* 1419287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1419290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1419307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419326 */     // MIs[0] round
     /* 1419326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419329 */     // MIs[0] policy
     /* 1419329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419339 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1419342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419363 */     // GIR_Coverage, 18050,
     /* 1419363 */     GIR_EraseRootFromParent_Done,
     /* 1419364 */   // Label 19869: @1419364
     /* 1419364 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1419446), // Rule ID 18051 //
     /* 1419369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1419372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1419389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419408 */     // MIs[0] round
     /* 1419408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419411 */     // MIs[0] policy
     /* 1419411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419421 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1419424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419445 */     // GIR_Coverage, 18051,
     /* 1419445 */     GIR_EraseRootFromParent_Done,
     /* 1419446 */   // Label 19870: @1419446
     /* 1419446 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1419528), // Rule ID 18054 //
     /* 1419451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1419454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1419462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1419465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1419471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419490 */     // MIs[0] round
     /* 1419490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419493 */     // MIs[0] policy
     /* 1419493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419503 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1419506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419514 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419527 */     // GIR_Coverage, 18054,
     /* 1419527 */     GIR_EraseRootFromParent_Done,
     /* 1419528 */   // Label 19871: @1419528
     /* 1419528 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1419610), // Rule ID 18055 //
     /* 1419533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1419536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1419544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1419547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1419550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1419553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1419568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419572 */     // MIs[0] round
     /* 1419572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419575 */     // MIs[0] policy
     /* 1419575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419585 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1419588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419596 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419609 */     // GIR_Coverage, 18055,
     /* 1419609 */     GIR_EraseRootFromParent_Done,
     /* 1419610 */   // Label 19872: @1419610
     /* 1419610 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1419692), // Rule ID 18058 //
     /* 1419615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1419618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1419632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1419635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1419650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419654 */     // MIs[0] round
     /* 1419654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419657 */     // MIs[0] policy
     /* 1419657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419667 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1419670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419678 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419691 */     // GIR_Coverage, 18058,
     /* 1419691 */     GIR_EraseRootFromParent_Done,
     /* 1419692 */   // Label 19873: @1419692
     /* 1419692 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1419774), // Rule ID 18059 //
     /* 1419697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1419700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1419714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1419717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1419732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419736 */     // MIs[0] round
     /* 1419736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419739 */     // MIs[0] policy
     /* 1419739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419749 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1419752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419773 */     // GIR_Coverage, 18059,
     /* 1419773 */     GIR_EraseRootFromParent_Done,
     /* 1419774 */   // Label 19874: @1419774
     /* 1419774 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1419856), // Rule ID 18062 //
     /* 1419779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1419782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1419796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1419799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1419814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419818 */     // MIs[0] round
     /* 1419818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419821 */     // MIs[0] policy
     /* 1419821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419831 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1419834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419842 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419855 */     // GIR_Coverage, 18062,
     /* 1419855 */     GIR_EraseRootFromParent_Done,
     /* 1419856 */   // Label 19875: @1419856
     /* 1419856 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1419938), // Rule ID 18063 //
     /* 1419861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1419864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1419878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1419881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1419896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419900 */     // MIs[0] round
     /* 1419900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419903 */     // MIs[0] policy
     /* 1419903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419913 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1419916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1419920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1419924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1419926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419937 */     // GIR_Coverage, 18063,
     /* 1419937 */     GIR_EraseRootFromParent_Done,
     /* 1419938 */   // Label 19876: @1419938
     /* 1419938 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1420020), // Rule ID 18066 //
     /* 1419943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1419946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1419951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1419954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1419957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1419960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1419963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1419978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419982 */     // MIs[0] round
     /* 1419982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1419985 */     // MIs[0] policy
     /* 1419985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419995 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1419998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420019 */     // GIR_Coverage, 18066,
     /* 1420019 */     GIR_EraseRootFromParent_Done,
     /* 1420020 */   // Label 19877: @1420020
     /* 1420020 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1420102), // Rule ID 18067 //
     /* 1420025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1420028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1420036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1420039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1420042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1420045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1420060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420064 */     // MIs[0] round
     /* 1420064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420067 */     // MIs[0] policy
     /* 1420067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420077 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1420080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420101 */     // GIR_Coverage, 18067,
     /* 1420101 */     GIR_EraseRootFromParent_Done,
     /* 1420102 */   // Label 19878: @1420102
     /* 1420102 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1420184), // Rule ID 18070 //
     /* 1420107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1420110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1420127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420146 */     // MIs[0] round
     /* 1420146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420149 */     // MIs[0] policy
     /* 1420149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420159 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1420162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420170 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420183 */     // GIR_Coverage, 18070,
     /* 1420183 */     GIR_EraseRootFromParent_Done,
     /* 1420184 */   // Label 19879: @1420184
     /* 1420184 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1420266), // Rule ID 18071 //
     /* 1420189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1420192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1420209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420228 */     // MIs[0] round
     /* 1420228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420231 */     // MIs[0] policy
     /* 1420231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420241 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10936:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1420244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420265 */     // GIR_Coverage, 18071,
     /* 1420265 */     GIR_EraseRootFromParent_Done,
     /* 1420266 */   // Label 19880: @1420266
     /* 1420266 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1420348), // Rule ID 18074 //
     /* 1420271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1420274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1420282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1420285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1420291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420310 */     // MIs[0] round
     /* 1420310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420313 */     // MIs[0] policy
     /* 1420313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420323 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1420326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420347 */     // GIR_Coverage, 18074,
     /* 1420347 */     GIR_EraseRootFromParent_Done,
     /* 1420348 */   // Label 19881: @1420348
     /* 1420348 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1420430), // Rule ID 18075 //
     /* 1420353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1420356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1420364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1420367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1420373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420392 */     // MIs[0] round
     /* 1420392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420395 */     // MIs[0] policy
     /* 1420395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420405 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10936:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1420408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420429 */     // GIR_Coverage, 18075,
     /* 1420429 */     GIR_EraseRootFromParent_Done,
     /* 1420430 */   // Label 19882: @1420430
     /* 1420430 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1420512), // Rule ID 18078 //
     /* 1420435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1420438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1420446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1420449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1420455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420474 */     // MIs[0] round
     /* 1420474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420477 */     // MIs[0] policy
     /* 1420477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420487 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1420490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420498 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420511 */     // GIR_Coverage, 18078,
     /* 1420511 */     GIR_EraseRootFromParent_Done,
     /* 1420512 */   // Label 19883: @1420512
     /* 1420512 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1420594), // Rule ID 18079 //
     /* 1420517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1420520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1420525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1420528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1420531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1420534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1420537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1420552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420556 */     // MIs[0] round
     /* 1420556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420559 */     // MIs[0] policy
     /* 1420559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420569 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10936:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1420572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420593 */     // GIR_Coverage, 18079,
     /* 1420593 */     GIR_EraseRootFromParent_Done,
     /* 1420594 */   // Label 19884: @1420594
     /* 1420594 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1420676), // Rule ID 18082 //
     /* 1420599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1420602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1420607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1420619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420638 */     // MIs[0] round
     /* 1420638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420641 */     // MIs[0] policy
     /* 1420641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420651 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1420654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420675 */     // GIR_Coverage, 18082,
     /* 1420675 */     GIR_EraseRootFromParent_Done,
     /* 1420676 */   // Label 19885: @1420676
     /* 1420676 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1420758), // Rule ID 18083 //
     /* 1420681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1420684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1420689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1420701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420720 */     // MIs[0] round
     /* 1420720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420723 */     // MIs[0] policy
     /* 1420723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420733 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1420736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420757 */     // GIR_Coverage, 18083,
     /* 1420757 */     GIR_EraseRootFromParent_Done,
     /* 1420758 */   // Label 19886: @1420758
     /* 1420758 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1420840), // Rule ID 18086 //
     /* 1420763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1420766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1420771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1420783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420802 */     // MIs[0] round
     /* 1420802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420805 */     // MIs[0] policy
     /* 1420805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1420818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420826 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420839 */     // GIR_Coverage, 18086,
     /* 1420839 */     GIR_EraseRootFromParent_Done,
     /* 1420840 */   // Label 19887: @1420840
     /* 1420840 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1420922), // Rule ID 18087 //
     /* 1420845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1420848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1420853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1420865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420884 */     // MIs[0] round
     /* 1420884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420887 */     // MIs[0] policy
     /* 1420887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420897 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1420900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420921 */     // GIR_Coverage, 18087,
     /* 1420921 */     GIR_EraseRootFromParent_Done,
     /* 1420922 */   // Label 19888: @1420922
     /* 1420922 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1421004), // Rule ID 18090 //
     /* 1420927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1420930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1420935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1420947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420966 */     // MIs[0] round
     /* 1420966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1420969 */     // MIs[0] policy
     /* 1420969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1420982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1420986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1420990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1420992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421003 */     // GIR_Coverage, 18090,
     /* 1421003 */     GIR_EraseRootFromParent_Done,
     /* 1421004 */   // Label 19889: @1421004
     /* 1421004 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1421086), // Rule ID 18091 //
     /* 1421009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1421012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1421020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1421023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1421026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1421029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421048 */     // MIs[0] round
     /* 1421048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421051 */     // MIs[0] policy
     /* 1421051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421061 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1421064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421085 */     // GIR_Coverage, 18091,
     /* 1421085 */     GIR_EraseRootFromParent_Done,
     /* 1421086 */   // Label 19890: @1421086
     /* 1421086 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1421168), // Rule ID 18094 //
     /* 1421091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1421094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1421111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421130 */     // MIs[0] round
     /* 1421130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421133 */     // MIs[0] policy
     /* 1421133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421143 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1421146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421154 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421167 */     // GIR_Coverage, 18094,
     /* 1421167 */     GIR_EraseRootFromParent_Done,
     /* 1421168 */   // Label 19891: @1421168
     /* 1421168 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1421250), // Rule ID 18095 //
     /* 1421173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1421176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1421193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421212 */     // MIs[0] round
     /* 1421212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421215 */     // MIs[0] policy
     /* 1421215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421225 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1421228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421249 */     // GIR_Coverage, 18095,
     /* 1421249 */     GIR_EraseRootFromParent_Done,
     /* 1421250 */   // Label 19892: @1421250
     /* 1421250 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1421332), // Rule ID 18098 //
     /* 1421255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1421258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1421275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421294 */     // MIs[0] round
     /* 1421294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421297 */     // MIs[0] policy
     /* 1421297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421307 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1421310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421331 */     // GIR_Coverage, 18098,
     /* 1421331 */     GIR_EraseRootFromParent_Done,
     /* 1421332 */   // Label 19893: @1421332
     /* 1421332 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1421414), // Rule ID 18099 //
     /* 1421337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1421340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1421357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421376 */     // MIs[0] round
     /* 1421376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421379 */     // MIs[0] policy
     /* 1421379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421389 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1421392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421400 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421413 */     // GIR_Coverage, 18099,
     /* 1421413 */     GIR_EraseRootFromParent_Done,
     /* 1421414 */   // Label 19894: @1421414
     /* 1421414 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1421496), // Rule ID 18102 //
     /* 1421419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1421422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1421439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421458 */     // MIs[0] round
     /* 1421458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421461 */     // MIs[0] policy
     /* 1421461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421471 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1421474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421495 */     // GIR_Coverage, 18102,
     /* 1421495 */     GIR_EraseRootFromParent_Done,
     /* 1421496 */   // Label 19895: @1421496
     /* 1421496 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1421578), // Rule ID 18103 //
     /* 1421501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1421504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1421521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421540 */     // MIs[0] round
     /* 1421540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421543 */     // MIs[0] policy
     /* 1421543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421553 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1421556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421564 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421577 */     // GIR_Coverage, 18103,
     /* 1421577 */     GIR_EraseRootFromParent_Done,
     /* 1421578 */   // Label 19896: @1421578
     /* 1421578 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1421660), // Rule ID 18106 //
     /* 1421583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1421586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1421603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421622 */     // MIs[0] round
     /* 1421622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421625 */     // MIs[0] policy
     /* 1421625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421635 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1421638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421659 */     // GIR_Coverage, 18106,
     /* 1421659 */     GIR_EraseRootFromParent_Done,
     /* 1421660 */   // Label 19897: @1421660
     /* 1421660 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1421742), // Rule ID 18107 //
     /* 1421665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1421668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1421685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421704 */     // MIs[0] round
     /* 1421704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421707 */     // MIs[0] policy
     /* 1421707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421717 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1421720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421741 */     // GIR_Coverage, 18107,
     /* 1421741 */     GIR_EraseRootFromParent_Done,
     /* 1421742 */   // Label 19898: @1421742
     /* 1421742 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1421824), // Rule ID 18110 //
     /* 1421747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1421750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1421758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1421761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1421764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1421767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421786 */     // MIs[0] round
     /* 1421786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421789 */     // MIs[0] policy
     /* 1421789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421799 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1421802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421810 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421823 */     // GIR_Coverage, 18110,
     /* 1421823 */     GIR_EraseRootFromParent_Done,
     /* 1421824 */   // Label 19899: @1421824
     /* 1421824 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1421906), // Rule ID 18111 //
     /* 1421829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1421832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1421840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1421843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1421846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1421849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421868 */     // MIs[0] round
     /* 1421868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421871 */     // MIs[0] policy
     /* 1421871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421881 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1421884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421905 */     // GIR_Coverage, 18111,
     /* 1421905 */     GIR_EraseRootFromParent_Done,
     /* 1421906 */   // Label 19900: @1421906
     /* 1421906 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1421988), // Rule ID 18114 //
     /* 1421911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1421914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1421919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1421922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1421925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1421928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1421931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421950 */     // MIs[0] round
     /* 1421950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1421953 */     // MIs[0] policy
     /* 1421953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1421966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1421970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1421974 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1421976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421987 */     // GIR_Coverage, 18114,
     /* 1421987 */     GIR_EraseRootFromParent_Done,
     /* 1421988 */   // Label 19901: @1421988
     /* 1421988 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1422070), // Rule ID 18115 //
     /* 1421993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1421996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1422013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422032 */     // MIs[0] round
     /* 1422032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422035 */     // MIs[0] policy
     /* 1422035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422045 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1422048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422056 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422069 */     // GIR_Coverage, 18115,
     /* 1422069 */     GIR_EraseRootFromParent_Done,
     /* 1422070 */   // Label 19902: @1422070
     /* 1422070 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1422152), // Rule ID 18118 //
     /* 1422075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1422078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1422095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422114 */     // MIs[0] round
     /* 1422114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422117 */     // MIs[0] policy
     /* 1422117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422127 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1422130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422138 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422151 */     // GIR_Coverage, 18118,
     /* 1422151 */     GIR_EraseRootFromParent_Done,
     /* 1422152 */   // Label 19903: @1422152
     /* 1422152 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1422234), // Rule ID 18119 //
     /* 1422157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1422160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1422177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422196 */     // MIs[0] round
     /* 1422196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422199 */     // MIs[0] policy
     /* 1422199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1422212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422220 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422233 */     // GIR_Coverage, 18119,
     /* 1422233 */     GIR_EraseRootFromParent_Done,
     /* 1422234 */   // Label 19904: @1422234
     /* 1422234 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1422316), // Rule ID 18122 //
     /* 1422239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1422242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1422259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422278 */     // MIs[0] round
     /* 1422278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422281 */     // MIs[0] policy
     /* 1422281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1422294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422315 */     // GIR_Coverage, 18122,
     /* 1422315 */     GIR_EraseRootFromParent_Done,
     /* 1422316 */   // Label 19905: @1422316
     /* 1422316 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1422398), // Rule ID 18123 //
     /* 1422321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1422324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1422341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422360 */     // MIs[0] round
     /* 1422360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422363 */     // MIs[0] policy
     /* 1422363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422373 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1422376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422384 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422397 */     // GIR_Coverage, 18123,
     /* 1422397 */     GIR_EraseRootFromParent_Done,
     /* 1422398 */   // Label 19906: @1422398
     /* 1422398 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1422480), // Rule ID 18126 //
     /* 1422403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1422406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1422423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422442 */     // MIs[0] round
     /* 1422442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422445 */     // MIs[0] policy
     /* 1422445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422455 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1422458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422466 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422479 */     // GIR_Coverage, 18126,
     /* 1422479 */     GIR_EraseRootFromParent_Done,
     /* 1422480 */   // Label 19907: @1422480
     /* 1422480 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1422562), // Rule ID 18127 //
     /* 1422485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1422488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1422505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422524 */     // MIs[0] round
     /* 1422524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422527 */     // MIs[0] policy
     /* 1422527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422537 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1422540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422561 */     // GIR_Coverage, 18127,
     /* 1422561 */     GIR_EraseRootFromParent_Done,
     /* 1422562 */   // Label 19908: @1422562
     /* 1422562 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1422644), // Rule ID 18130 //
     /* 1422567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1422570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1422578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1422581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1422584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1422587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422606 */     // MIs[0] round
     /* 1422606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422609 */     // MIs[0] policy
     /* 1422609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1422622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1422640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422643 */     // GIR_Coverage, 18130,
     /* 1422643 */     GIR_EraseRootFromParent_Done,
     /* 1422644 */   // Label 19909: @1422644
     /* 1422644 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1422726), // Rule ID 18131 //
     /* 1422649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1422652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1422660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1422663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1422666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1422669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422688 */     // MIs[0] round
     /* 1422688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422691 */     // MIs[0] policy
     /* 1422691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422701 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1422704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422712 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1422722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422725 */     // GIR_Coverage, 18131,
     /* 1422725 */     GIR_EraseRootFromParent_Done,
     /* 1422726 */   // Label 19910: @1422726
     /* 1422726 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1422808), // Rule ID 18134 //
     /* 1422731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1422734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1422742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1422745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1422748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1422751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422770 */     // MIs[0] round
     /* 1422770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422773 */     // MIs[0] policy
     /* 1422773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422783 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1422786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422794 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1422804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422807 */     // GIR_Coverage, 18134,
     /* 1422807 */     GIR_EraseRootFromParent_Done,
     /* 1422808 */   // Label 19911: @1422808
     /* 1422808 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1422890), // Rule ID 18135 //
     /* 1422813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1422816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1422824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1422827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1422830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1422833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422852 */     // MIs[0] round
     /* 1422852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422855 */     // MIs[0] policy
     /* 1422855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1422868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422876 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1422886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422889 */     // GIR_Coverage, 18135,
     /* 1422889 */     GIR_EraseRootFromParent_Done,
     /* 1422890 */   // Label 19912: @1422890
     /* 1422890 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1422972), // Rule ID 18138 //
     /* 1422895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1422898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1422906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1422909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1422912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1422915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422934 */     // MIs[0] round
     /* 1422934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1422937 */     // MIs[0] policy
     /* 1422937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422947 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1422950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1422954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1422958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1422960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1422968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422971 */     // GIR_Coverage, 18138,
     /* 1422971 */     GIR_EraseRootFromParent_Done,
     /* 1422972 */   // Label 19913: @1422972
     /* 1422972 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1423054), // Rule ID 18139 //
     /* 1422977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1422980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1422985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1422988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1422991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1422994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1422997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423016 */     // MIs[0] round
     /* 1423016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423019 */     // MIs[0] policy
     /* 1423019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423029 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1423032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423040 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423053 */     // GIR_Coverage, 18139,
     /* 1423053 */     GIR_EraseRootFromParent_Done,
     /* 1423054 */   // Label 19914: @1423054
     /* 1423054 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1423136), // Rule ID 18142 //
     /* 1423059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1423062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1423070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1423073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1423079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423098 */     // MIs[0] round
     /* 1423098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423101 */     // MIs[0] policy
     /* 1423101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423111 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1423114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423135 */     // GIR_Coverage, 18142,
     /* 1423135 */     GIR_EraseRootFromParent_Done,
     /* 1423136 */   // Label 19915: @1423136
     /* 1423136 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1423218), // Rule ID 18143 //
     /* 1423141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1423144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1423152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1423155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1423161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423180 */     // MIs[0] round
     /* 1423180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423183 */     // MIs[0] policy
     /* 1423183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423193 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1423196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423204 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423217 */     // GIR_Coverage, 18143,
     /* 1423217 */     GIR_EraseRootFromParent_Done,
     /* 1423218 */   // Label 19916: @1423218
     /* 1423218 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1423300), // Rule ID 18146 //
     /* 1423223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1423226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1423234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1423237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1423243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423262 */     // MIs[0] round
     /* 1423262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423265 */     // MIs[0] policy
     /* 1423265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423275 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1423278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423299 */     // GIR_Coverage, 18146,
     /* 1423299 */     GIR_EraseRootFromParent_Done,
     /* 1423300 */   // Label 19917: @1423300
     /* 1423300 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1423382), // Rule ID 18147 //
     /* 1423305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1423308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1423316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1423319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1423325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423344 */     // MIs[0] round
     /* 1423344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423347 */     // MIs[0] policy
     /* 1423347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423357 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1423360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423368 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423381 */     // GIR_Coverage, 18147,
     /* 1423381 */     GIR_EraseRootFromParent_Done,
     /* 1423382 */   // Label 19918: @1423382
     /* 1423382 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1423464), // Rule ID 18150 //
     /* 1423387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1423390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1423398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1423401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1423404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1423407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1423422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423426 */     // MIs[0] round
     /* 1423426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423429 */     // MIs[0] policy
     /* 1423429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423439 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1423442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423463 */     // GIR_Coverage, 18150,
     /* 1423463 */     GIR_EraseRootFromParent_Done,
     /* 1423464 */   // Label 19919: @1423464
     /* 1423464 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1423546), // Rule ID 18151 //
     /* 1423469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1423472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1423480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1423483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1423486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1423489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1423504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423508 */     // MIs[0] round
     /* 1423508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423511 */     // MIs[0] policy
     /* 1423511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423521 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1423524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423545 */     // GIR_Coverage, 18151,
     /* 1423545 */     GIR_EraseRootFromParent_Done,
     /* 1423546 */   // Label 19920: @1423546
     /* 1423546 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1423628), // Rule ID 18154 //
     /* 1423551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1423554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1423562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1423565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1423571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423590 */     // MIs[0] round
     /* 1423590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423593 */     // MIs[0] policy
     /* 1423593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423603 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1423606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423627 */     // GIR_Coverage, 18154,
     /* 1423627 */     GIR_EraseRootFromParent_Done,
     /* 1423628 */   // Label 19921: @1423628
     /* 1423628 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1423710), // Rule ID 18155 //
     /* 1423633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1423636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1423644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1423647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1423650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1423653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1423668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423672 */     // MIs[0] round
     /* 1423672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423675 */     // MIs[0] policy
     /* 1423675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423685 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10898:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1423688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423696 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423709 */     // GIR_Coverage, 18155,
     /* 1423709 */     GIR_EraseRootFromParent_Done,
     /* 1423710 */   // Label 19922: @1423710
     /* 1423710 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1423792), // Rule ID 18158 //
     /* 1423715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1423718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1423726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1423729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1423732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1423735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1423750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423754 */     // MIs[0] round
     /* 1423754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423757 */     // MIs[0] policy
     /* 1423757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423767 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1423770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423791 */     // GIR_Coverage, 18158,
     /* 1423791 */     GIR_EraseRootFromParent_Done,
     /* 1423792 */   // Label 19923: @1423792
     /* 1423792 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1423874), // Rule ID 18159 //
     /* 1423797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1423800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1423808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1423811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1423814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1423817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1423832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423836 */     // MIs[0] round
     /* 1423836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423839 */     // MIs[0] policy
     /* 1423839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423849 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1423852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423860 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423873 */     // GIR_Coverage, 18159,
     /* 1423873 */     GIR_EraseRootFromParent_Done,
     /* 1423874 */   // Label 19924: @1423874
     /* 1423874 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1423956), // Rule ID 18162 //
     /* 1423879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1423882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1423896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1423899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1423914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423918 */     // MIs[0] round
     /* 1423918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1423921 */     // MIs[0] policy
     /* 1423921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423931 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1423934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1423938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1423942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1423944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423955 */     // GIR_Coverage, 18162,
     /* 1423955 */     GIR_EraseRootFromParent_Done,
     /* 1423956 */   // Label 19925: @1423956
     /* 1423956 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1424038), // Rule ID 18163 //
     /* 1423961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1423964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1423969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1423978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1423981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1423996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424000 */     // MIs[0] round
     /* 1424000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424003 */     // MIs[0] policy
     /* 1424003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424013 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1424016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424024 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1424034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424037 */     // GIR_Coverage, 18163,
     /* 1424037 */     GIR_EraseRootFromParent_Done,
     /* 1424038 */   // Label 19926: @1424038
     /* 1424038 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1424120), // Rule ID 18166 //
     /* 1424043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1424046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1424054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1424057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1424063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424082 */     // MIs[0] round
     /* 1424082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424085 */     // MIs[0] policy
     /* 1424085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424095 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1424098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424119 */     // GIR_Coverage, 18166,
     /* 1424119 */     GIR_EraseRootFromParent_Done,
     /* 1424120 */   // Label 19927: @1424120
     /* 1424120 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1424202), // Rule ID 18167 //
     /* 1424125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1424128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1424136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1424139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1424145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424164 */     // MIs[0] round
     /* 1424164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424167 */     // MIs[0] policy
     /* 1424167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424177 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1424180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424188 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424201 */     // GIR_Coverage, 18167,
     /* 1424201 */     GIR_EraseRootFromParent_Done,
     /* 1424202 */   // Label 19928: @1424202
     /* 1424202 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1424284), // Rule ID 18170 //
     /* 1424207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1424210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1424218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1424221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1424227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424246 */     // MIs[0] round
     /* 1424246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424249 */     // MIs[0] policy
     /* 1424249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424259 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1424262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424283 */     // GIR_Coverage, 18170,
     /* 1424283 */     GIR_EraseRootFromParent_Done,
     /* 1424284 */   // Label 19929: @1424284
     /* 1424284 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1424366), // Rule ID 18171 //
     /* 1424289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1424292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1424300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1424303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1424309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424328 */     // MIs[0] round
     /* 1424328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424331 */     // MIs[0] policy
     /* 1424331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424341 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1424344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424352 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424365 */     // GIR_Coverage, 18171,
     /* 1424365 */     GIR_EraseRootFromParent_Done,
     /* 1424366 */   // Label 19930: @1424366
     /* 1424366 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1424448), // Rule ID 18174 //
     /* 1424371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1424374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1424391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424410 */     // MIs[0] round
     /* 1424410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424413 */     // MIs[0] policy
     /* 1424413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424423 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1424426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424447 */     // GIR_Coverage, 18174,
     /* 1424447 */     GIR_EraseRootFromParent_Done,
     /* 1424448 */   // Label 19931: @1424448
     /* 1424448 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1424530), // Rule ID 18175 //
     /* 1424453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1424456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1424470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1424473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1424488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424492 */     // MIs[0] round
     /* 1424492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424495 */     // MIs[0] policy
     /* 1424495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1424508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424516 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424529 */     // GIR_Coverage, 18175,
     /* 1424529 */     GIR_EraseRootFromParent_Done,
     /* 1424530 */   // Label 19932: @1424530
     /* 1424530 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1424612), // Rule ID 18178 //
     /* 1424535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1424538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1424555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424574 */     // MIs[0] round
     /* 1424574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424577 */     // MIs[0] policy
     /* 1424577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424587 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1424590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424598 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424611 */     // GIR_Coverage, 18178,
     /* 1424611 */     GIR_EraseRootFromParent_Done,
     /* 1424612 */   // Label 19933: @1424612
     /* 1424612 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1424694), // Rule ID 18179 //
     /* 1424617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1424620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1424637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424656 */     // MIs[0] round
     /* 1424656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424659 */     // MIs[0] policy
     /* 1424659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424669 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1424672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424680 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424693 */     // GIR_Coverage, 18179,
     /* 1424693 */     GIR_EraseRootFromParent_Done,
     /* 1424694 */   // Label 19934: @1424694
     /* 1424694 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1424776), // Rule ID 18182 //
     /* 1424699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1424702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1424719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424738 */     // MIs[0] round
     /* 1424738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424741 */     // MIs[0] policy
     /* 1424741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424751 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1424754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424775 */     // GIR_Coverage, 18182,
     /* 1424775 */     GIR_EraseRootFromParent_Done,
     /* 1424776 */   // Label 19935: @1424776
     /* 1424776 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1424858), // Rule ID 18183 //
     /* 1424781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1424784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1424801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424820 */     // MIs[0] round
     /* 1424820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424823 */     // MIs[0] policy
     /* 1424823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1424836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424844 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424857 */     // GIR_Coverage, 18183,
     /* 1424857 */     GIR_EraseRootFromParent_Done,
     /* 1424858 */   // Label 19936: @1424858
     /* 1424858 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1424940), // Rule ID 18186 //
     /* 1424863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1424866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1424883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424902 */     // MIs[0] round
     /* 1424902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424905 */     // MIs[0] policy
     /* 1424905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424915 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1424918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1424922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1424926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1424928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424939 */     // GIR_Coverage, 18186,
     /* 1424939 */     GIR_EraseRootFromParent_Done,
     /* 1424940 */   // Label 19937: @1424940
     /* 1424940 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1425022), // Rule ID 18187 //
     /* 1424945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1424948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1424953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1424962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1424965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1424980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424984 */     // MIs[0] round
     /* 1424984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1424987 */     // MIs[0] policy
     /* 1424987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424997 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1425000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425008 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425021 */     // GIR_Coverage, 18187,
     /* 1425021 */     GIR_EraseRootFromParent_Done,
     /* 1425022 */   // Label 19938: @1425022
     /* 1425022 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1425104), // Rule ID 18190 //
     /* 1425027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1425030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1425038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1425041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1425047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425066 */     // MIs[0] round
     /* 1425066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425069 */     // MIs[0] policy
     /* 1425069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1425082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425090 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425103 */     // GIR_Coverage, 18190,
     /* 1425103 */     GIR_EraseRootFromParent_Done,
     /* 1425104 */   // Label 19939: @1425104
     /* 1425104 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1425186), // Rule ID 18191 //
     /* 1425109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1425112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1425120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1425123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1425129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425148 */     // MIs[0] round
     /* 1425148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425151 */     // MIs[0] policy
     /* 1425151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425161 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1425164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425185 */     // GIR_Coverage, 18191,
     /* 1425185 */     GIR_EraseRootFromParent_Done,
     /* 1425186 */   // Label 19940: @1425186
     /* 1425186 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1425268), // Rule ID 18194 //
     /* 1425191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1425194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1425211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425230 */     // MIs[0] round
     /* 1425230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425233 */     // MIs[0] policy
     /* 1425233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425243 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1425246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425267 */     // GIR_Coverage, 18194,
     /* 1425267 */     GIR_EraseRootFromParent_Done,
     /* 1425268 */   // Label 19941: @1425268
     /* 1425268 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1425350), // Rule ID 18195 //
     /* 1425273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1425276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1425293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425312 */     // MIs[0] round
     /* 1425312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425315 */     // MIs[0] policy
     /* 1425315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1425328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425336 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425349 */     // GIR_Coverage, 18195,
     /* 1425349 */     GIR_EraseRootFromParent_Done,
     /* 1425350 */   // Label 19942: @1425350
     /* 1425350 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1425432), // Rule ID 18198 //
     /* 1425355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1425358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1425375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425394 */     // MIs[0] round
     /* 1425394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425397 */     // MIs[0] policy
     /* 1425397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425407 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1425410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425431 */     // GIR_Coverage, 18198,
     /* 1425431 */     GIR_EraseRootFromParent_Done,
     /* 1425432 */   // Label 19943: @1425432
     /* 1425432 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1425514), // Rule ID 18199 //
     /* 1425437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1425440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1425445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1425454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1425457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1425472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425476 */     // MIs[0] round
     /* 1425476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425479 */     // MIs[0] policy
     /* 1425479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425489 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1425492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425500 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425513 */     // GIR_Coverage, 18199,
     /* 1425513 */     GIR_EraseRootFromParent_Done,
     /* 1425514 */   // Label 19944: @1425514
     /* 1425514 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1425596), // Rule ID 18202 //
     /* 1425519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1425522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1425530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1425533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1425536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1425539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425558 */     // MIs[0] round
     /* 1425558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425561 */     // MIs[0] policy
     /* 1425561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425571 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1425574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425595 */     // GIR_Coverage, 18202,
     /* 1425595 */     GIR_EraseRootFromParent_Done,
     /* 1425596 */   // Label 19945: @1425596
     /* 1425596 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1425678), // Rule ID 18203 //
     /* 1425601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1425604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1425612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1425615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1425618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1425621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425640 */     // MIs[0] round
     /* 1425640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425643 */     // MIs[0] policy
     /* 1425643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425653 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1425656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425664 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425677 */     // GIR_Coverage, 18203,
     /* 1425677 */     GIR_EraseRootFromParent_Done,
     /* 1425678 */   // Label 19946: @1425678
     /* 1425678 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1425760), // Rule ID 18206 //
     /* 1425683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1425686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1425694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1425697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1425700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1425703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425722 */     // MIs[0] round
     /* 1425722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425725 */     // MIs[0] policy
     /* 1425725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425735 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1425738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425759 */     // GIR_Coverage, 18206,
     /* 1425759 */     GIR_EraseRootFromParent_Done,
     /* 1425760 */   // Label 19947: @1425760
     /* 1425760 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1425842), // Rule ID 18207 //
     /* 1425765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1425768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1425776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1425779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1425782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1425785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425804 */     // MIs[0] round
     /* 1425804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425807 */     // MIs[0] policy
     /* 1425807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425817 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1425820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425828 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425841 */     // GIR_Coverage, 18207,
     /* 1425841 */     GIR_EraseRootFromParent_Done,
     /* 1425842 */   // Label 19948: @1425842
     /* 1425842 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1425924), // Rule ID 18210 //
     /* 1425847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1425850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1425867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425886 */     // MIs[0] round
     /* 1425886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425889 */     // MIs[0] policy
     /* 1425889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1425902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425923 */     // GIR_Coverage, 18210,
     /* 1425923 */     GIR_EraseRootFromParent_Done,
     /* 1425924 */   // Label 19949: @1425924
     /* 1425924 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1426006), // Rule ID 18211 //
     /* 1425929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1425932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1425937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1425949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425968 */     // MIs[0] round
     /* 1425968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1425971 */     // MIs[0] policy
     /* 1425971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425981 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1425984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1425988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1425992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1425994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426005 */     // GIR_Coverage, 18211,
     /* 1426005 */     GIR_EraseRootFromParent_Done,
     /* 1426006 */   // Label 19950: @1426006
     /* 1426006 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1426088), // Rule ID 18214 //
     /* 1426011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1426014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1426022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1426025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1426028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1426031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426050 */     // MIs[0] round
     /* 1426050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426053 */     // MIs[0] policy
     /* 1426053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426063 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1426066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426087 */     // GIR_Coverage, 18214,
     /* 1426087 */     GIR_EraseRootFromParent_Done,
     /* 1426088 */   // Label 19951: @1426088
     /* 1426088 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1426170), // Rule ID 18215 //
     /* 1426093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1426096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1426104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1426107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1426110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1426113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426132 */     // MIs[0] round
     /* 1426132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426135 */     // MIs[0] policy
     /* 1426135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426145 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1426148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426156 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426169 */     // GIR_Coverage, 18215,
     /* 1426169 */     GIR_EraseRootFromParent_Done,
     /* 1426170 */   // Label 19952: @1426170
     /* 1426170 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1426252), // Rule ID 18218 //
     /* 1426175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1426178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1426186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1426189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1426192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1426195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426214 */     // MIs[0] round
     /* 1426214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426217 */     // MIs[0] policy
     /* 1426217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426227 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1426230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426238 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426251 */     // GIR_Coverage, 18218,
     /* 1426251 */     GIR_EraseRootFromParent_Done,
     /* 1426252 */   // Label 19953: @1426252
     /* 1426252 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1426334), // Rule ID 18219 //
     /* 1426257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1426260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1426268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1426271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1426274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1426277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426296 */     // MIs[0] round
     /* 1426296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426299 */     // MIs[0] policy
     /* 1426299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426309 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1426312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426320 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426333 */     // GIR_Coverage, 18219,
     /* 1426333 */     GIR_EraseRootFromParent_Done,
     /* 1426334 */   // Label 19954: @1426334
     /* 1426334 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1426416), // Rule ID 18222 //
     /* 1426339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1426342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1426350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1426353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1426356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1426359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426378 */     // MIs[0] round
     /* 1426378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426381 */     // MIs[0] policy
     /* 1426381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426391 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1426394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426402 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1426412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426415 */     // GIR_Coverage, 18222,
     /* 1426415 */     GIR_EraseRootFromParent_Done,
     /* 1426416 */   // Label 19955: @1426416
     /* 1426416 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1426498), // Rule ID 18223 //
     /* 1426421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1426424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1426432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1426435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1426438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1426441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426460 */     // MIs[0] round
     /* 1426460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426463 */     // MIs[0] policy
     /* 1426463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426473 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1426476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1426494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426497 */     // GIR_Coverage, 18223,
     /* 1426497 */     GIR_EraseRootFromParent_Done,
     /* 1426498 */   // Label 19956: @1426498
     /* 1426498 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1426580), // Rule ID 18226 //
     /* 1426503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1426506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1426523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426542 */     // MIs[0] round
     /* 1426542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426545 */     // MIs[0] policy
     /* 1426545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426555 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1426558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426579 */     // GIR_Coverage, 18226,
     /* 1426579 */     GIR_EraseRootFromParent_Done,
     /* 1426580 */   // Label 19957: @1426580
     /* 1426580 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1426662), // Rule ID 18227 //
     /* 1426585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1426588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1426605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426624 */     // MIs[0] round
     /* 1426624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426627 */     // MIs[0] policy
     /* 1426627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426637 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1426640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426648 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426661 */     // GIR_Coverage, 18227,
     /* 1426661 */     GIR_EraseRootFromParent_Done,
     /* 1426662 */   // Label 19958: @1426662
     /* 1426662 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1426744), // Rule ID 18230 //
     /* 1426667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1426670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1426687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426706 */     // MIs[0] round
     /* 1426706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426709 */     // MIs[0] policy
     /* 1426709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426719 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1426722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426743 */     // GIR_Coverage, 18230,
     /* 1426743 */     GIR_EraseRootFromParent_Done,
     /* 1426744 */   // Label 19959: @1426744
     /* 1426744 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1426826), // Rule ID 18231 //
     /* 1426749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1426752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1426769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426788 */     // MIs[0] round
     /* 1426788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426791 */     // MIs[0] policy
     /* 1426791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426801 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1426804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426825 */     // GIR_Coverage, 18231,
     /* 1426825 */     GIR_EraseRootFromParent_Done,
     /* 1426826 */   // Label 19960: @1426826
     /* 1426826 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1426908), // Rule ID 18234 //
     /* 1426831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1426834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1426851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426870 */     // MIs[0] round
     /* 1426870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426873 */     // MIs[0] policy
     /* 1426873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1426886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426894 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426907 */     // GIR_Coverage, 18234,
     /* 1426907 */     GIR_EraseRootFromParent_Done,
     /* 1426908 */   // Label 19961: @1426908
     /* 1426908 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1426990), // Rule ID 18235 //
     /* 1426913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1426916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1426921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1426933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426952 */     // MIs[0] round
     /* 1426952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1426955 */     // MIs[0] policy
     /* 1426955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426965 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1426968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1426972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1426976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1426978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426989 */     // GIR_Coverage, 18235,
     /* 1426989 */     GIR_EraseRootFromParent_Done,
     /* 1426990 */   // Label 19962: @1426990
     /* 1426990 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1427072), // Rule ID 18238 //
     /* 1426995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1426998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1427015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427034 */     // MIs[0] round
     /* 1427034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427037 */     // MIs[0] policy
     /* 1427037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427047 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1427050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427058 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427071 */     // GIR_Coverage, 18238,
     /* 1427071 */     GIR_EraseRootFromParent_Done,
     /* 1427072 */   // Label 19963: @1427072
     /* 1427072 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1427154), // Rule ID 18239 //
     /* 1427077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1427080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1427097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427116 */     // MIs[0] round
     /* 1427116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427119 */     // MIs[0] policy
     /* 1427119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427129 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1427132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427153 */     // GIR_Coverage, 18239,
     /* 1427153 */     GIR_EraseRootFromParent_Done,
     /* 1427154 */   // Label 19964: @1427154
     /* 1427154 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1427236), // Rule ID 18242 //
     /* 1427159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1427162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1427179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427198 */     // MIs[0] round
     /* 1427198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427201 */     // MIs[0] policy
     /* 1427201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427211 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1427214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427222 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427235 */     // GIR_Coverage, 18242,
     /* 1427235 */     GIR_EraseRootFromParent_Done,
     /* 1427236 */   // Label 19965: @1427236
     /* 1427236 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1427318), // Rule ID 18243 //
     /* 1427241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1427244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1427261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427280 */     // MIs[0] round
     /* 1427280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427283 */     // MIs[0] policy
     /* 1427283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427293 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1427296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427317 */     // GIR_Coverage, 18243,
     /* 1427317 */     GIR_EraseRootFromParent_Done,
     /* 1427318 */   // Label 19966: @1427318
     /* 1427318 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1427400), // Rule ID 18246 //
     /* 1427323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1427326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1427343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427362 */     // MIs[0] round
     /* 1427362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427365 */     // MIs[0] policy
     /* 1427365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427375 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1427378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427399 */     // GIR_Coverage, 18246,
     /* 1427399 */     GIR_EraseRootFromParent_Done,
     /* 1427400 */   // Label 19967: @1427400
     /* 1427400 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1427482), // Rule ID 18247 //
     /* 1427405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1427408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1427425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427444 */     // MIs[0] round
     /* 1427444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427447 */     // MIs[0] policy
     /* 1427447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427457 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1427460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427481 */     // GIR_Coverage, 18247,
     /* 1427481 */     GIR_EraseRootFromParent_Done,
     /* 1427482 */   // Label 19968: @1427482
     /* 1427482 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1427564), // Rule ID 18250 //
     /* 1427487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1427490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1427507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427526 */     // MIs[0] round
     /* 1427526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427529 */     // MIs[0] policy
     /* 1427529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1427542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427563 */     // GIR_Coverage, 18250,
     /* 1427563 */     GIR_EraseRootFromParent_Done,
     /* 1427564 */   // Label 19969: @1427564
     /* 1427564 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1427646), // Rule ID 18251 //
     /* 1427569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1427572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1427589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427608 */     // MIs[0] round
     /* 1427608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427611 */     // MIs[0] policy
     /* 1427611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427621 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1427624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427645 */     // GIR_Coverage, 18251,
     /* 1427645 */     GIR_EraseRootFromParent_Done,
     /* 1427646 */   // Label 19970: @1427646
     /* 1427646 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1427728), // Rule ID 18254 //
     /* 1427651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1427654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1427671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427690 */     // MIs[0] round
     /* 1427690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427693 */     // MIs[0] policy
     /* 1427693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427703 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1427706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427714 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427727 */     // GIR_Coverage, 18254,
     /* 1427727 */     GIR_EraseRootFromParent_Done,
     /* 1427728 */   // Label 19971: @1427728
     /* 1427728 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1427810), // Rule ID 18255 //
     /* 1427733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1427736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1427753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427772 */     // MIs[0] round
     /* 1427772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427775 */     // MIs[0] policy
     /* 1427775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427785 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1427788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427809 */     // GIR_Coverage, 18255,
     /* 1427809 */     GIR_EraseRootFromParent_Done,
     /* 1427810 */   // Label 19972: @1427810
     /* 1427810 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1427892), // Rule ID 18258 //
     /* 1427815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1427818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1427835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427854 */     // MIs[0] round
     /* 1427854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427857 */     // MIs[0] policy
     /* 1427857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427867 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1427870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427878 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427891 */     // GIR_Coverage, 18258,
     /* 1427891 */     GIR_EraseRootFromParent_Done,
     /* 1427892 */   // Label 19973: @1427892
     /* 1427892 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1427974), // Rule ID 18259 //
     /* 1427897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1427900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1427917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427936 */     // MIs[0] round
     /* 1427936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1427939 */     // MIs[0] policy
     /* 1427939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1427952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1427956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1427960 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1427962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427973 */     // GIR_Coverage, 18259,
     /* 1427973 */     GIR_EraseRootFromParent_Done,
     /* 1427974 */   // Label 19974: @1427974
     /* 1427974 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1428056), // Rule ID 18262 //
     /* 1427979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1427982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1427987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1427990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1427993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1427996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1427999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428018 */     // MIs[0] round
     /* 1428018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428021 */     // MIs[0] policy
     /* 1428021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428031 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1428034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428042 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428055 */     // GIR_Coverage, 18262,
     /* 1428055 */     GIR_EraseRootFromParent_Done,
     /* 1428056 */   // Label 19975: @1428056
     /* 1428056 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1428138), // Rule ID 18263 //
     /* 1428061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1428064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1428081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428100 */     // MIs[0] round
     /* 1428100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428103 */     // MIs[0] policy
     /* 1428103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428113 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1428116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428137 */     // GIR_Coverage, 18263,
     /* 1428137 */     GIR_EraseRootFromParent_Done,
     /* 1428138 */   // Label 19976: @1428138
     /* 1428138 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1428220), // Rule ID 18266 //
     /* 1428143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1428146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1428163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428182 */     // MIs[0] round
     /* 1428182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428185 */     // MIs[0] policy
     /* 1428185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428195 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1428198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428219 */     // GIR_Coverage, 18266,
     /* 1428219 */     GIR_EraseRootFromParent_Done,
     /* 1428220 */   // Label 19977: @1428220
     /* 1428220 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1428302), // Rule ID 18267 //
     /* 1428225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1428228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1428245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428264 */     // MIs[0] round
     /* 1428264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428267 */     // MIs[0] policy
     /* 1428267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428277 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1428280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428288 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428301 */     // GIR_Coverage, 18267,
     /* 1428301 */     GIR_EraseRootFromParent_Done,
     /* 1428302 */   // Label 19978: @1428302
     /* 1428302 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1428384), // Rule ID 18270 //
     /* 1428307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1428310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1428324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1428327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1428342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428346 */     // MIs[0] round
     /* 1428346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428349 */     // MIs[0] policy
     /* 1428349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428359 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1428362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428370 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428383 */     // GIR_Coverage, 18270,
     /* 1428383 */     GIR_EraseRootFromParent_Done,
     /* 1428384 */   // Label 19979: @1428384
     /* 1428384 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1428466), // Rule ID 18271 //
     /* 1428389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1428392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1428406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1428409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1428424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428428 */     // MIs[0] round
     /* 1428428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428431 */     // MIs[0] policy
     /* 1428431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428441 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1428444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428465 */     // GIR_Coverage, 18271,
     /* 1428465 */     GIR_EraseRootFromParent_Done,
     /* 1428466 */   // Label 19980: @1428466
     /* 1428466 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1428548), // Rule ID 18274 //
     /* 1428471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1428474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1428482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1428485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1428491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428510 */     // MIs[0] round
     /* 1428510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428513 */     // MIs[0] policy
     /* 1428513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428523 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1428526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428534 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428547 */     // GIR_Coverage, 18274,
     /* 1428547 */     GIR_EraseRootFromParent_Done,
     /* 1428548 */   // Label 19981: @1428548
     /* 1428548 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1428630), // Rule ID 18275 //
     /* 1428553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1428556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1428564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1428567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1428573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428592 */     // MIs[0] round
     /* 1428592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428595 */     // MIs[0] policy
     /* 1428595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428605 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10934:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1428608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428629 */     // GIR_Coverage, 18275,
     /* 1428629 */     GIR_EraseRootFromParent_Done,
     /* 1428630 */   // Label 19982: @1428630
     /* 1428630 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1428712), // Rule ID 18278 //
     /* 1428635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1428638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1428646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1428649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1428652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1428655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1428670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428674 */     // MIs[0] round
     /* 1428674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428677 */     // MIs[0] policy
     /* 1428677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428687 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1428690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428698 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428711 */     // GIR_Coverage, 18278,
     /* 1428711 */     GIR_EraseRootFromParent_Done,
     /* 1428712 */   // Label 19983: @1428712
     /* 1428712 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1428794), // Rule ID 18279 //
     /* 1428717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1428720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1428728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1428731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1428734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1428737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1428752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428756 */     // MIs[0] round
     /* 1428756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428759 */     // MIs[0] policy
     /* 1428759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428769 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10934:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1428772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428793 */     // GIR_Coverage, 18279,
     /* 1428793 */     GIR_EraseRootFromParent_Done,
     /* 1428794 */   // Label 19984: @1428794
     /* 1428794 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1428876), // Rule ID 18282 //
     /* 1428799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1428802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1428810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1428813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1428816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1428819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1428834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428838 */     // MIs[0] round
     /* 1428838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428841 */     // MIs[0] policy
     /* 1428841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428851 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1428854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428862 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428875 */     // GIR_Coverage, 18282,
     /* 1428875 */     GIR_EraseRootFromParent_Done,
     /* 1428876 */   // Label 19985: @1428876
     /* 1428876 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1428958), // Rule ID 18283 //
     /* 1428881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1428884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1428892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1428895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1428898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1428901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1428916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428920 */     // MIs[0] round
     /* 1428920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1428923 */     // MIs[0] policy
     /* 1428923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428933 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10934:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1428936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1428940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1428944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1428946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428957 */     // GIR_Coverage, 18283,
     /* 1428957 */     GIR_EraseRootFromParent_Done,
     /* 1428958 */   // Label 19986: @1428958
     /* 1428958 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1429040), // Rule ID 18286 //
     /* 1428963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1428966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1428971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1428974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1428977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1428980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1428983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1428998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429002 */     // MIs[0] round
     /* 1429002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429005 */     // MIs[0] policy
     /* 1429005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1429018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429026 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429039 */     // GIR_Coverage, 18286,
     /* 1429039 */     GIR_EraseRootFromParent_Done,
     /* 1429040 */   // Label 19987: @1429040
     /* 1429040 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1429122), // Rule ID 18287 //
     /* 1429045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1429048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1429056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1429059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1429062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1429065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1429080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429084 */     // MIs[0] round
     /* 1429084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429087 */     // MIs[0] policy
     /* 1429087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429097 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1429100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429108 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429121 */     // GIR_Coverage, 18287,
     /* 1429121 */     GIR_EraseRootFromParent_Done,
     /* 1429122 */   // Label 19988: @1429122
     /* 1429122 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1429204), // Rule ID 18290 //
     /* 1429127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1429130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1429138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1429141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1429144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1429147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1429162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429166 */     // MIs[0] round
     /* 1429166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429169 */     // MIs[0] policy
     /* 1429169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429179 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1429182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429203 */     // GIR_Coverage, 18290,
     /* 1429203 */     GIR_EraseRootFromParent_Done,
     /* 1429204 */   // Label 19989: @1429204
     /* 1429204 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1429286), // Rule ID 18291 //
     /* 1429209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1429212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1429220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1429223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1429226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1429229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1429244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429248 */     // MIs[0] round
     /* 1429248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429251 */     // MIs[0] policy
     /* 1429251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429261 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1429264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429272 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429285 */     // GIR_Coverage, 18291,
     /* 1429285 */     GIR_EraseRootFromParent_Done,
     /* 1429286 */   // Label 19990: @1429286
     /* 1429286 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1429368), // Rule ID 18294 //
     /* 1429291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1429294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1429302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1429305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1429308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1429311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1429326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429330 */     // MIs[0] round
     /* 1429330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429333 */     // MIs[0] policy
     /* 1429333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429343 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1429346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429367 */     // GIR_Coverage, 18294,
     /* 1429367 */     GIR_EraseRootFromParent_Done,
     /* 1429368 */   // Label 19991: @1429368
     /* 1429368 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1429450), // Rule ID 18295 //
     /* 1429373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1429376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1429384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1429387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1429390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1429393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1429408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429412 */     // MIs[0] round
     /* 1429412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429415 */     // MIs[0] policy
     /* 1429415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429425 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1429428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429449 */     // GIR_Coverage, 18295,
     /* 1429449 */     GIR_EraseRootFromParent_Done,
     /* 1429450 */   // Label 19992: @1429450
     /* 1429450 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1429532), // Rule ID 18298 //
     /* 1429455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1429458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1429466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1429469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1429475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429494 */     // MIs[0] round
     /* 1429494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429497 */     // MIs[0] policy
     /* 1429497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429507 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1429510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429518 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429531 */     // GIR_Coverage, 18298,
     /* 1429531 */     GIR_EraseRootFromParent_Done,
     /* 1429532 */   // Label 19993: @1429532
     /* 1429532 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1429614), // Rule ID 18299 //
     /* 1429537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1429540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1429548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1429551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1429557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429576 */     // MIs[0] round
     /* 1429576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429579 */     // MIs[0] policy
     /* 1429579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429589 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1429592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429613 */     // GIR_Coverage, 18299,
     /* 1429613 */     GIR_EraseRootFromParent_Done,
     /* 1429614 */   // Label 19994: @1429614
     /* 1429614 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1429696), // Rule ID 18302 //
     /* 1429619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1429622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1429630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1429633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1429639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429658 */     // MIs[0] round
     /* 1429658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429661 */     // MIs[0] policy
     /* 1429661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429671 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1429674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429682 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429695 */     // GIR_Coverage, 18302,
     /* 1429695 */     GIR_EraseRootFromParent_Done,
     /* 1429696 */   // Label 19995: @1429696
     /* 1429696 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1429778), // Rule ID 18303 //
     /* 1429701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1429704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1429712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1429715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1429721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429740 */     // MIs[0] round
     /* 1429740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429743 */     // MIs[0] policy
     /* 1429743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429753 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1429756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429777 */     // GIR_Coverage, 18303,
     /* 1429777 */     GIR_EraseRootFromParent_Done,
     /* 1429778 */   // Label 19996: @1429778
     /* 1429778 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1429860), // Rule ID 18306 //
     /* 1429783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1429786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1429803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429822 */     // MIs[0] round
     /* 1429822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429825 */     // MIs[0] policy
     /* 1429825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429835 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1429838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429859 */     // GIR_Coverage, 18306,
     /* 1429859 */     GIR_EraseRootFromParent_Done,
     /* 1429860 */   // Label 19997: @1429860
     /* 1429860 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1429942), // Rule ID 18307 //
     /* 1429865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1429868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1429882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1429885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1429900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429904 */     // MIs[0] round
     /* 1429904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429907 */     // MIs[0] policy
     /* 1429907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429917 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1429920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1429924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1429928 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1429930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429941 */     // GIR_Coverage, 18307,
     /* 1429941 */     GIR_EraseRootFromParent_Done,
     /* 1429942 */   // Label 19998: @1429942
     /* 1429942 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1430024), // Rule ID 18310 //
     /* 1429947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1429950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1429955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1429958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1429961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1429964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1429967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1429982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429986 */     // MIs[0] round
     /* 1429986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1429989 */     // MIs[0] policy
     /* 1429989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429999 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1430002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430010 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430023 */     // GIR_Coverage, 18310,
     /* 1430023 */     GIR_EraseRootFromParent_Done,
     /* 1430024 */   // Label 19999: @1430024
     /* 1430024 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1430106), // Rule ID 18311 //
     /* 1430029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1430032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1430037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1430040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1430043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1430046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1430049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1430064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430068 */     // MIs[0] round
     /* 1430068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430071 */     // MIs[0] policy
     /* 1430071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430081 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10934:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1430084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430092 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430105 */     // GIR_Coverage, 18311,
     /* 1430105 */     GIR_EraseRootFromParent_Done,
     /* 1430106 */   // Label 20000: @1430106
     /* 1430106 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1430188), // Rule ID 18314 //
     /* 1430111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1430114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1430119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1430122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1430125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1430128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1430131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1430146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430150 */     // MIs[0] round
     /* 1430150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430153 */     // MIs[0] policy
     /* 1430153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430163 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1430166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430187 */     // GIR_Coverage, 18314,
     /* 1430187 */     GIR_EraseRootFromParent_Done,
     /* 1430188 */   // Label 20001: @1430188
     /* 1430188 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1430270), // Rule ID 18315 //
     /* 1430193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1430196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1430201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1430204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1430207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1430210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1430213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1430228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430232 */     // MIs[0] round
     /* 1430232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430235 */     // MIs[0] policy
     /* 1430235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430245 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10934:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1430248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430269 */     // GIR_Coverage, 18315,
     /* 1430269 */     GIR_EraseRootFromParent_Done,
     /* 1430270 */   // Label 20002: @1430270
     /* 1430270 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1430352), // Rule ID 18318 //
     /* 1430275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1430278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1430283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1430286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1430289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1430292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1430295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1430310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430314 */     // MIs[0] round
     /* 1430314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430317 */     // MIs[0] policy
     /* 1430317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1430330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430338 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430351 */     // GIR_Coverage, 18318,
     /* 1430351 */     GIR_EraseRootFromParent_Done,
     /* 1430352 */   // Label 20003: @1430352
     /* 1430352 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1430434), // Rule ID 18319 //
     /* 1430357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1430360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1430365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1430368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1430371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1430374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1430377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1430392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430396 */     // MIs[0] round
     /* 1430396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430399 */     // MIs[0] policy
     /* 1430399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430409 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10934:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1430412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430433 */     // GIR_Coverage, 18319,
     /* 1430433 */     GIR_EraseRootFromParent_Done,
     /* 1430434 */   // Label 20004: @1430434
     /* 1430434 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1430516), // Rule ID 18322 //
     /* 1430439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1430442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1430459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430478 */     // MIs[0] round
     /* 1430478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430481 */     // MIs[0] policy
     /* 1430481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430491 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1430494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430502 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430515 */     // GIR_Coverage, 18322,
     /* 1430515 */     GIR_EraseRootFromParent_Done,
     /* 1430516 */   // Label 20005: @1430516
     /* 1430516 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1430598), // Rule ID 18323 //
     /* 1430521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1430524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1430541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430560 */     // MIs[0] round
     /* 1430560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430563 */     // MIs[0] policy
     /* 1430563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430573 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1430576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430597 */     // GIR_Coverage, 18323,
     /* 1430597 */     GIR_EraseRootFromParent_Done,
     /* 1430598 */   // Label 20006: @1430598
     /* 1430598 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1430680), // Rule ID 18326 //
     /* 1430603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1430606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1430623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430642 */     // MIs[0] round
     /* 1430642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430645 */     // MIs[0] policy
     /* 1430645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430655 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1430658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430666 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430679 */     // GIR_Coverage, 18326,
     /* 1430679 */     GIR_EraseRootFromParent_Done,
     /* 1430680 */   // Label 20007: @1430680
     /* 1430680 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1430762), // Rule ID 18327 //
     /* 1430685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1430688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1430705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430724 */     // MIs[0] round
     /* 1430724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430727 */     // MIs[0] policy
     /* 1430727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430737 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1430740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430748 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430761 */     // GIR_Coverage, 18327,
     /* 1430761 */     GIR_EraseRootFromParent_Done,
     /* 1430762 */   // Label 20008: @1430762
     /* 1430762 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1430844), // Rule ID 18330 //
     /* 1430767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1430770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1430787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430806 */     // MIs[0] round
     /* 1430806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430809 */     // MIs[0] policy
     /* 1430809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430819 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1430822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430843 */     // GIR_Coverage, 18330,
     /* 1430843 */     GIR_EraseRootFromParent_Done,
     /* 1430844 */   // Label 20009: @1430844
     /* 1430844 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1430926), // Rule ID 18331 //
     /* 1430849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1430852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1430869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430888 */     // MIs[0] round
     /* 1430888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430891 */     // MIs[0] policy
     /* 1430891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430901 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1430904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430925 */     // GIR_Coverage, 18331,
     /* 1430925 */     GIR_EraseRootFromParent_Done,
     /* 1430926 */   // Label 20010: @1430926
     /* 1430926 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1431008), // Rule ID 18334 //
     /* 1430931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1430934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1430939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1430942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1430945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1430948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1430951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430970 */     // MIs[0] round
     /* 1430970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1430973 */     // MIs[0] policy
     /* 1430973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430983 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1430986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1430990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1430994 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1430996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431007 */     // GIR_Coverage, 18334,
     /* 1431007 */     GIR_EraseRootFromParent_Done,
     /* 1431008 */   // Label 20011: @1431008
     /* 1431008 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1431090), // Rule ID 18335 //
     /* 1431013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1431016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1431024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1431027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1431030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1431033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431052 */     // MIs[0] round
     /* 1431052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431055 */     // MIs[0] policy
     /* 1431055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431065 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1431068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431076 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431089 */     // GIR_Coverage, 18335,
     /* 1431089 */     GIR_EraseRootFromParent_Done,
     /* 1431090 */   // Label 20012: @1431090
     /* 1431090 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1431172), // Rule ID 18338 //
     /* 1431095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1431098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1431115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431134 */     // MIs[0] round
     /* 1431134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431137 */     // MIs[0] policy
     /* 1431137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431147 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1431150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431158 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431171 */     // GIR_Coverage, 18338,
     /* 1431171 */     GIR_EraseRootFromParent_Done,
     /* 1431172 */   // Label 20013: @1431172
     /* 1431172 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1431254), // Rule ID 18339 //
     /* 1431177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1431180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1431197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431216 */     // MIs[0] round
     /* 1431216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431219 */     // MIs[0] policy
     /* 1431219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431229 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1431232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431253 */     // GIR_Coverage, 18339,
     /* 1431253 */     GIR_EraseRootFromParent_Done,
     /* 1431254 */   // Label 20014: @1431254
     /* 1431254 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1431336), // Rule ID 18342 //
     /* 1431259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1431262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1431279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431298 */     // MIs[0] round
     /* 1431298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431301 */     // MIs[0] policy
     /* 1431301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431311 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1431314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431322 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431335 */     // GIR_Coverage, 18342,
     /* 1431335 */     GIR_EraseRootFromParent_Done,
     /* 1431336 */   // Label 20015: @1431336
     /* 1431336 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1431418), // Rule ID 18343 //
     /* 1431341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1431344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1431361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431380 */     // MIs[0] round
     /* 1431380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431383 */     // MIs[0] policy
     /* 1431383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431393 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1431396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431404 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431417 */     // GIR_Coverage, 18343,
     /* 1431417 */     GIR_EraseRootFromParent_Done,
     /* 1431418 */   // Label 20016: @1431418
     /* 1431418 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1431500), // Rule ID 18346 //
     /* 1431423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1431426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1431434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1431437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1431440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1431443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431462 */     // MIs[0] round
     /* 1431462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431465 */     // MIs[0] policy
     /* 1431465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1431478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431499 */     // GIR_Coverage, 18346,
     /* 1431499 */     GIR_EraseRootFromParent_Done,
     /* 1431500 */   // Label 20017: @1431500
     /* 1431500 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1431582), // Rule ID 18347 //
     /* 1431505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1431508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1431516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1431519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1431522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1431525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431544 */     // MIs[0] round
     /* 1431544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431547 */     // MIs[0] policy
     /* 1431547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431557 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1431560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431581 */     // GIR_Coverage, 18347,
     /* 1431581 */     GIR_EraseRootFromParent_Done,
     /* 1431582 */   // Label 20018: @1431582
     /* 1431582 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1431664), // Rule ID 18350 //
     /* 1431587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1431590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1431607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431626 */     // MIs[0] round
     /* 1431626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431629 */     // MIs[0] policy
     /* 1431629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431639 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1431642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431650 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431663 */     // GIR_Coverage, 18350,
     /* 1431663 */     GIR_EraseRootFromParent_Done,
     /* 1431664 */   // Label 20019: @1431664
     /* 1431664 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1431746), // Rule ID 18351 //
     /* 1431669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1431672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1431689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431708 */     // MIs[0] round
     /* 1431708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431711 */     // MIs[0] policy
     /* 1431711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431721 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1431724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431745 */     // GIR_Coverage, 18351,
     /* 1431745 */     GIR_EraseRootFromParent_Done,
     /* 1431746 */   // Label 20020: @1431746
     /* 1431746 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1431828), // Rule ID 18354 //
     /* 1431751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1431754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1431771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431790 */     // MIs[0] round
     /* 1431790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431793 */     // MIs[0] policy
     /* 1431793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431803 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1431806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431827 */     // GIR_Coverage, 18354,
     /* 1431827 */     GIR_EraseRootFromParent_Done,
     /* 1431828 */   // Label 20021: @1431828
     /* 1431828 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1431910), // Rule ID 18355 //
     /* 1431833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1431836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1431853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431872 */     // MIs[0] round
     /* 1431872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431875 */     // MIs[0] policy
     /* 1431875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431885 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1431888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431896 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431909 */     // GIR_Coverage, 18355,
     /* 1431909 */     GIR_EraseRootFromParent_Done,
     /* 1431910 */   // Label 20022: @1431910
     /* 1431910 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1431992), // Rule ID 18358 //
     /* 1431915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1431918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1431923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1431935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431954 */     // MIs[0] round
     /* 1431954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1431957 */     // MIs[0] policy
     /* 1431957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431967 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1431970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1431974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1431978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1431980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431991 */     // GIR_Coverage, 18358,
     /* 1431991 */     GIR_EraseRootFromParent_Done,
     /* 1431992 */   // Label 20023: @1431992
     /* 1431992 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1432074), // Rule ID 18359 //
     /* 1431997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1432000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1432008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1432011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1432014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1432017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432036 */     // MIs[0] round
     /* 1432036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432039 */     // MIs[0] policy
     /* 1432039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432049 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1432052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432073 */     // GIR_Coverage, 18359,
     /* 1432073 */     GIR_EraseRootFromParent_Done,
     /* 1432074 */   // Label 20024: @1432074
     /* 1432074 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1432156), // Rule ID 18362 //
     /* 1432079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1432082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1432090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1432093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1432096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1432099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432118 */     // MIs[0] round
     /* 1432118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432121 */     // MIs[0] policy
     /* 1432121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432131 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1432134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432142 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432155 */     // GIR_Coverage, 18362,
     /* 1432155 */     GIR_EraseRootFromParent_Done,
     /* 1432156 */   // Label 20025: @1432156
     /* 1432156 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1432238), // Rule ID 18363 //
     /* 1432161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1432164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1432172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1432175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1432178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1432181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432200 */     // MIs[0] round
     /* 1432200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432203 */     // MIs[0] policy
     /* 1432203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432213 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1432216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432237 */     // GIR_Coverage, 18363,
     /* 1432237 */     GIR_EraseRootFromParent_Done,
     /* 1432238 */   // Label 20026: @1432238
     /* 1432238 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1432320), // Rule ID 18366 //
     /* 1432243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1432246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1432254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1432257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1432260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1432263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432282 */     // MIs[0] round
     /* 1432282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432285 */     // MIs[0] policy
     /* 1432285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432295 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1432298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432319 */     // GIR_Coverage, 18366,
     /* 1432319 */     GIR_EraseRootFromParent_Done,
     /* 1432320 */   // Label 20027: @1432320
     /* 1432320 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1432402), // Rule ID 18367 //
     /* 1432325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1432328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1432336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1432339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1432342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1432345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432364 */     // MIs[0] round
     /* 1432364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432367 */     // MIs[0] policy
     /* 1432367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1432380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432401 */     // GIR_Coverage, 18367,
     /* 1432401 */     GIR_EraseRootFromParent_Done,
     /* 1432402 */   // Label 20028: @1432402
     /* 1432402 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1432484), // Rule ID 18370 //
     /* 1432407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1432410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1432427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432446 */     // MIs[0] round
     /* 1432446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432449 */     // MIs[0] policy
     /* 1432449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432459 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1432462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432483 */     // GIR_Coverage, 18370,
     /* 1432483 */     GIR_EraseRootFromParent_Done,
     /* 1432484 */   // Label 20029: @1432484
     /* 1432484 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1432566), // Rule ID 18371 //
     /* 1432489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1432492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1432509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432528 */     // MIs[0] round
     /* 1432528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432531 */     // MIs[0] policy
     /* 1432531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1432544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432565 */     // GIR_Coverage, 18371,
     /* 1432565 */     GIR_EraseRootFromParent_Done,
     /* 1432566 */   // Label 20030: @1432566
     /* 1432566 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1432648), // Rule ID 18374 //
     /* 1432571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1432574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1432591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432610 */     // MIs[0] round
     /* 1432610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432613 */     // MIs[0] policy
     /* 1432613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432623 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1432626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432647 */     // GIR_Coverage, 18374,
     /* 1432647 */     GIR_EraseRootFromParent_Done,
     /* 1432648 */   // Label 20031: @1432648
     /* 1432648 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1432730), // Rule ID 18375 //
     /* 1432653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1432656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1432673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432692 */     // MIs[0] round
     /* 1432692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432695 */     // MIs[0] policy
     /* 1432695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432705 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1432708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432716 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432729 */     // GIR_Coverage, 18375,
     /* 1432729 */     GIR_EraseRootFromParent_Done,
     /* 1432730 */   // Label 20032: @1432730
     /* 1432730 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1432812), // Rule ID 18378 //
     /* 1432735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1432738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1432755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432774 */     // MIs[0] round
     /* 1432774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432777 */     // MIs[0] policy
     /* 1432777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432787 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1432790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432811 */     // GIR_Coverage, 18378,
     /* 1432811 */     GIR_EraseRootFromParent_Done,
     /* 1432812 */   // Label 20033: @1432812
     /* 1432812 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1432894), // Rule ID 18379 //
     /* 1432817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1432820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1432837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432856 */     // MIs[0] round
     /* 1432856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432859 */     // MIs[0] policy
     /* 1432859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432869 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1432872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432880 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432893 */     // GIR_Coverage, 18379,
     /* 1432893 */     GIR_EraseRootFromParent_Done,
     /* 1432894 */   // Label 20034: @1432894
     /* 1432894 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1432976), // Rule ID 18382 //
     /* 1432899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1432902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1432916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1432919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1432934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432938 */     // MIs[0] round
     /* 1432938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1432941 */     // MIs[0] policy
     /* 1432941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432951 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1432954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1432958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1432962 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1432964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432975 */     // GIR_Coverage, 18382,
     /* 1432975 */     GIR_EraseRootFromParent_Done,
     /* 1432976 */   // Label 20035: @1432976
     /* 1432976 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1433058), // Rule ID 18383 //
     /* 1432981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1432984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1432989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1432998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1433001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433020 */     // MIs[0] round
     /* 1433020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433023 */     // MIs[0] policy
     /* 1433023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433033 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1433036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433044 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433057 */     // GIR_Coverage, 18383,
     /* 1433057 */     GIR_EraseRootFromParent_Done,
     /* 1433058 */   // Label 20036: @1433058
     /* 1433058 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1433140), // Rule ID 18386 //
     /* 1433063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1433066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1433083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433102 */     // MIs[0] round
     /* 1433102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433105 */     // MIs[0] policy
     /* 1433105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433115 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1433118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433139 */     // GIR_Coverage, 18386,
     /* 1433139 */     GIR_EraseRootFromParent_Done,
     /* 1433140 */   // Label 20037: @1433140
     /* 1433140 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1433222), // Rule ID 18387 //
     /* 1433145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1433148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1433165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433184 */     // MIs[0] round
     /* 1433184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433187 */     // MIs[0] policy
     /* 1433187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433197 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1433200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433208 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433221 */     // GIR_Coverage, 18387,
     /* 1433221 */     GIR_EraseRootFromParent_Done,
     /* 1433222 */   // Label 20038: @1433222
     /* 1433222 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1433304), // Rule ID 18390 //
     /* 1433227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1433230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1433244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1433247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1433262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433266 */     // MIs[0] round
     /* 1433266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433269 */     // MIs[0] policy
     /* 1433269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433279 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1433282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433290 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433303 */     // GIR_Coverage, 18390,
     /* 1433303 */     GIR_EraseRootFromParent_Done,
     /* 1433304 */   // Label 20039: @1433304
     /* 1433304 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1433386), // Rule ID 18391 //
     /* 1433309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1433312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1433326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1433329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1433344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433348 */     // MIs[0] round
     /* 1433348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433351 */     // MIs[0] policy
     /* 1433351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433361 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1433364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433372 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433385 */     // GIR_Coverage, 18391,
     /* 1433385 */     GIR_EraseRootFromParent_Done,
     /* 1433386 */   // Label 20040: @1433386
     /* 1433386 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1433468), // Rule ID 18394 //
     /* 1433391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1433394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1433411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433430 */     // MIs[0] round
     /* 1433430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433433 */     // MIs[0] policy
     /* 1433433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433443 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1433446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433467 */     // GIR_Coverage, 18394,
     /* 1433467 */     GIR_EraseRootFromParent_Done,
     /* 1433468 */   // Label 20041: @1433468
     /* 1433468 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1433550), // Rule ID 18395 //
     /* 1433473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1433476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1433493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433512 */     // MIs[0] round
     /* 1433512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433515 */     // MIs[0] policy
     /* 1433515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433525 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10907:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1433528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433549 */     // GIR_Coverage, 18395,
     /* 1433549 */     GIR_EraseRootFromParent_Done,
     /* 1433550 */   // Label 20042: @1433550
     /* 1433550 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1433632), // Rule ID 18398 //
     /* 1433555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1433558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1433572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1433575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1433590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433594 */     // MIs[0] round
     /* 1433594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433597 */     // MIs[0] policy
     /* 1433597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433607 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1433610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433631 */     // GIR_Coverage, 18398,
     /* 1433631 */     GIR_EraseRootFromParent_Done,
     /* 1433632 */   // Label 20043: @1433632
     /* 1433632 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1433714), // Rule ID 18399 //
     /* 1433637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1433640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1433654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1433657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1433672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433676 */     // MIs[0] round
     /* 1433676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433679 */     // MIs[0] policy
     /* 1433679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433689 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1433692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433700 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433713 */     // GIR_Coverage, 18399,
     /* 1433713 */     GIR_EraseRootFromParent_Done,
     /* 1433714 */   // Label 20044: @1433714
     /* 1433714 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1433796), // Rule ID 18402 //
     /* 1433719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1433722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1433736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1433739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1433754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433758 */     // MIs[0] round
     /* 1433758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433761 */     // MIs[0] policy
     /* 1433761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433771 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1433774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433782 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433795 */     // GIR_Coverage, 18402,
     /* 1433795 */     GIR_EraseRootFromParent_Done,
     /* 1433796 */   // Label 20045: @1433796
     /* 1433796 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1433878), // Rule ID 18403 //
     /* 1433801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1433804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1433818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1433821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1433836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433840 */     // MIs[0] round
     /* 1433840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433843 */     // MIs[0] policy
     /* 1433843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433853 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1433856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433864 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433877 */     // GIR_Coverage, 18403,
     /* 1433877 */     GIR_EraseRootFromParent_Done,
     /* 1433878 */   // Label 20046: @1433878
     /* 1433878 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1433960), // Rule ID 18406 //
     /* 1433883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1433886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1433894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1433897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1433903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1433918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433922 */     // MIs[0] round
     /* 1433922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1433925 */     // MIs[0] policy
     /* 1433925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433935 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1433938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1433942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1433946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1433948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433959 */     // GIR_Coverage, 18406,
     /* 1433959 */     GIR_EraseRootFromParent_Done,
     /* 1433960 */   // Label 20047: @1433960
     /* 1433960 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1434042), // Rule ID 18407 //
     /* 1433965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1433968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1433973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1433976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1433979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1433982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1433985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1434000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434004 */     // MIs[0] round
     /* 1434004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434007 */     // MIs[0] policy
     /* 1434007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1434020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434028 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434041 */     // GIR_Coverage, 18407,
     /* 1434041 */     GIR_EraseRootFromParent_Done,
     /* 1434042 */   // Label 20048: @1434042
     /* 1434042 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1434124), // Rule ID 18410 //
     /* 1434047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1434050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1434064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1434067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1434082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434086 */     // MIs[0] round
     /* 1434086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434089 */     // MIs[0] policy
     /* 1434089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434099 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1434102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434123 */     // GIR_Coverage, 18410,
     /* 1434123 */     GIR_EraseRootFromParent_Done,
     /* 1434124 */   // Label 20049: @1434124
     /* 1434124 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1434206), // Rule ID 18411 //
     /* 1434129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1434132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1434146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1434149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1434164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434168 */     // MIs[0] round
     /* 1434168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434171 */     // MIs[0] policy
     /* 1434171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434181 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1434184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434192 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434205 */     // GIR_Coverage, 18411,
     /* 1434205 */     GIR_EraseRootFromParent_Done,
     /* 1434206 */   // Label 20050: @1434206
     /* 1434206 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1434288), // Rule ID 18414 //
     /* 1434211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1434214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1434222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1434225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1434228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1434231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1434246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434250 */     // MIs[0] round
     /* 1434250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434253 */     // MIs[0] policy
     /* 1434253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434263 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1434266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434274 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434287 */     // GIR_Coverage, 18414,
     /* 1434287 */     GIR_EraseRootFromParent_Done,
     /* 1434288 */   // Label 20051: @1434288
     /* 1434288 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1434370), // Rule ID 18415 //
     /* 1434293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1434296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1434304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1434307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1434310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1434313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1434328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434332 */     // MIs[0] round
     /* 1434332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434335 */     // MIs[0] policy
     /* 1434335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1434348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434356 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434369 */     // GIR_Coverage, 18415,
     /* 1434369 */     GIR_EraseRootFromParent_Done,
     /* 1434370 */   // Label 20052: @1434370
     /* 1434370 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1434452), // Rule ID 18418 //
     /* 1434375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1434378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1434386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1434389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1434395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434414 */     // MIs[0] round
     /* 1434414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434417 */     // MIs[0] policy
     /* 1434417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434427 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1434430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434451 */     // GIR_Coverage, 18418,
     /* 1434451 */     GIR_EraseRootFromParent_Done,
     /* 1434452 */   // Label 20053: @1434452
     /* 1434452 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1434534), // Rule ID 18419 //
     /* 1434457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1434460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1434468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1434471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1434477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434496 */     // MIs[0] round
     /* 1434496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434499 */     // MIs[0] policy
     /* 1434499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434509 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1434512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434520 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434533 */     // GIR_Coverage, 18419,
     /* 1434533 */     GIR_EraseRootFromParent_Done,
     /* 1434534 */   // Label 20054: @1434534
     /* 1434534 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1434616), // Rule ID 18422 //
     /* 1434539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1434542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1434550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1434553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1434559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434578 */     // MIs[0] round
     /* 1434578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434581 */     // MIs[0] policy
     /* 1434581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434591 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1434594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434615 */     // GIR_Coverage, 18422,
     /* 1434615 */     GIR_EraseRootFromParent_Done,
     /* 1434616 */   // Label 20055: @1434616
     /* 1434616 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1434698), // Rule ID 18423 //
     /* 1434621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1434624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1434632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1434635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1434641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434660 */     // MIs[0] round
     /* 1434660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434663 */     // MIs[0] policy
     /* 1434663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434673 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1434676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434684 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434697 */     // GIR_Coverage, 18423,
     /* 1434697 */     GIR_EraseRootFromParent_Done,
     /* 1434698 */   // Label 20056: @1434698
     /* 1434698 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1434780), // Rule ID 18426 //
     /* 1434703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1434706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1434714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1434717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1434723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434742 */     // MIs[0] round
     /* 1434742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434745 */     // MIs[0] policy
     /* 1434745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434755 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1434758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434779 */     // GIR_Coverage, 18426,
     /* 1434779 */     GIR_EraseRootFromParent_Done,
     /* 1434780 */   // Label 20057: @1434780
     /* 1434780 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1434862), // Rule ID 18427 //
     /* 1434785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1434788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1434796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1434799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1434802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1434805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1434820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434824 */     // MIs[0] round
     /* 1434824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434827 */     // MIs[0] policy
     /* 1434827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434837 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1434840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434848 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434861 */     // GIR_Coverage, 18427,
     /* 1434861 */     GIR_EraseRootFromParent_Done,
     /* 1434862 */   // Label 20058: @1434862
     /* 1434862 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1434944), // Rule ID 18430 //
     /* 1434867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1434870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1434878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1434881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1434884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1434887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1434902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434906 */     // MIs[0] round
     /* 1434906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434909 */     // MIs[0] policy
     /* 1434909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1434922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1434926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1434930 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1434932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434943 */     // GIR_Coverage, 18430,
     /* 1434943 */     GIR_EraseRootFromParent_Done,
     /* 1434944 */   // Label 20059: @1434944
     /* 1434944 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1435026), // Rule ID 18431 //
     /* 1434949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1434952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1434957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1434960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1434963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1434966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1434969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1434984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434988 */     // MIs[0] round
     /* 1434988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1434991 */     // MIs[0] policy
     /* 1434991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435001 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1435004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435012 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435025 */     // GIR_Coverage, 18431,
     /* 1435025 */     GIR_EraseRootFromParent_Done,
     /* 1435026 */   // Label 20060: @1435026
     /* 1435026 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1435108), // Rule ID 18434 //
     /* 1435031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1435034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1435039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1435042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1435045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1435048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1435051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1435066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435070 */     // MIs[0] round
     /* 1435070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435073 */     // MIs[0] policy
     /* 1435073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435083 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1435086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435107 */     // GIR_Coverage, 18434,
     /* 1435107 */     GIR_EraseRootFromParent_Done,
     /* 1435108 */   // Label 20061: @1435108
     /* 1435108 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1435190), // Rule ID 18435 //
     /* 1435113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1435116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1435121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1435124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1435127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1435130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1435133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1435148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435152 */     // MIs[0] round
     /* 1435152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435155 */     // MIs[0] policy
     /* 1435155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435165 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1435168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435176 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435189 */     // GIR_Coverage, 18435,
     /* 1435189 */     GIR_EraseRootFromParent_Done,
     /* 1435190 */   // Label 20062: @1435190
     /* 1435190 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1435272), // Rule ID 18438 //
     /* 1435195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1435198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1435203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1435206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1435209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1435212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1435215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1435230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435234 */     // MIs[0] round
     /* 1435234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435237 */     // MIs[0] policy
     /* 1435237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435247 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1435250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435271 */     // GIR_Coverage, 18438,
     /* 1435271 */     GIR_EraseRootFromParent_Done,
     /* 1435272 */   // Label 20063: @1435272
     /* 1435272 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1435354), // Rule ID 18439 //
     /* 1435277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1435280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1435285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1435288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1435291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1435294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1435297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1435312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435316 */     // MIs[0] round
     /* 1435316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435319 */     // MIs[0] policy
     /* 1435319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435329 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1435332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435340 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435353 */     // GIR_Coverage, 18439,
     /* 1435353 */     GIR_EraseRootFromParent_Done,
     /* 1435354 */   // Label 20064: @1435354
     /* 1435354 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1435436), // Rule ID 18442 //
     /* 1435359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1435362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1435370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1435373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1435376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1435379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435398 */     // MIs[0] round
     /* 1435398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435401 */     // MIs[0] policy
     /* 1435401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435411 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1435414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435435 */     // GIR_Coverage, 18442,
     /* 1435435 */     GIR_EraseRootFromParent_Done,
     /* 1435436 */   // Label 20065: @1435436
     /* 1435436 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1435518), // Rule ID 18443 //
     /* 1435441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1435444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1435452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1435455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1435458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1435461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435480 */     // MIs[0] round
     /* 1435480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435483 */     // MIs[0] policy
     /* 1435483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435493 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1435496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435504 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435517 */     // GIR_Coverage, 18443,
     /* 1435517 */     GIR_EraseRootFromParent_Done,
     /* 1435518 */   // Label 20066: @1435518
     /* 1435518 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1435600), // Rule ID 18446 //
     /* 1435523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1435526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1435534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1435537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1435540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1435543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435562 */     // MIs[0] round
     /* 1435562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435565 */     // MIs[0] policy
     /* 1435565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435575 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1435578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435586 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435599 */     // GIR_Coverage, 18446,
     /* 1435599 */     GIR_EraseRootFromParent_Done,
     /* 1435600 */   // Label 20067: @1435600
     /* 1435600 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1435682), // Rule ID 18447 //
     /* 1435605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1435608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1435616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1435619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1435622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1435625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435644 */     // MIs[0] round
     /* 1435644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435647 */     // MIs[0] policy
     /* 1435647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435657 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1435660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435668 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435681 */     // GIR_Coverage, 18447,
     /* 1435681 */     GIR_EraseRootFromParent_Done,
     /* 1435682 */   // Label 20068: @1435682
     /* 1435682 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1435764), // Rule ID 18450 //
     /* 1435687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1435690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1435707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435726 */     // MIs[0] round
     /* 1435726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435729 */     // MIs[0] policy
     /* 1435729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435739 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1435742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435763 */     // GIR_Coverage, 18450,
     /* 1435763 */     GIR_EraseRootFromParent_Done,
     /* 1435764 */   // Label 20069: @1435764
     /* 1435764 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1435846), // Rule ID 18451 //
     /* 1435769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1435772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1435789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435808 */     // MIs[0] round
     /* 1435808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435811 */     // MIs[0] policy
     /* 1435811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1435824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435832 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435845 */     // GIR_Coverage, 18451,
     /* 1435845 */     GIR_EraseRootFromParent_Done,
     /* 1435846 */   // Label 20070: @1435846
     /* 1435846 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1435928), // Rule ID 18454 //
     /* 1435851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1435854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1435871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435890 */     // MIs[0] round
     /* 1435890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435893 */     // MIs[0] policy
     /* 1435893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435903 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1435906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435927 */     // GIR_Coverage, 18454,
     /* 1435927 */     GIR_EraseRootFromParent_Done,
     /* 1435928 */   // Label 20071: @1435928
     /* 1435928 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1436010), // Rule ID 18455 //
     /* 1435933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1435936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1435941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1435953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435972 */     // MIs[0] round
     /* 1435972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1435975 */     // MIs[0] policy
     /* 1435975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435985 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1435988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1435992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1435996 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1435998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436009 */     // GIR_Coverage, 18455,
     /* 1436009 */     GIR_EraseRootFromParent_Done,
     /* 1436010 */   // Label 20072: @1436010
     /* 1436010 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1436092), // Rule ID 18458 //
     /* 1436015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1436018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1436026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1436029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1436032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1436035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436054 */     // MIs[0] round
     /* 1436054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436057 */     // MIs[0] policy
     /* 1436057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436067 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1436070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436091 */     // GIR_Coverage, 18458,
     /* 1436091 */     GIR_EraseRootFromParent_Done,
     /* 1436092 */   // Label 20073: @1436092
     /* 1436092 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1436174), // Rule ID 18459 //
     /* 1436097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1436100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1436108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1436111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1436114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1436117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436136 */     // MIs[0] round
     /* 1436136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436139 */     // MIs[0] policy
     /* 1436139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1436152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436173 */     // GIR_Coverage, 18459,
     /* 1436173 */     GIR_EraseRootFromParent_Done,
     /* 1436174 */   // Label 20074: @1436174
     /* 1436174 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1436256), // Rule ID 18462 //
     /* 1436179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1436182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1436190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1436193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1436196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1436199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436218 */     // MIs[0] round
     /* 1436218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436221 */     // MIs[0] policy
     /* 1436221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436231 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1436234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436242 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436255 */     // GIR_Coverage, 18462,
     /* 1436255 */     GIR_EraseRootFromParent_Done,
     /* 1436256 */   // Label 20075: @1436256
     /* 1436256 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1436338), // Rule ID 18463 //
     /* 1436261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1436264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1436272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1436275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1436278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1436281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436300 */     // MIs[0] round
     /* 1436300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436303 */     // MIs[0] policy
     /* 1436303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436313 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1436316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436324 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436337 */     // GIR_Coverage, 18463,
     /* 1436337 */     GIR_EraseRootFromParent_Done,
     /* 1436338 */   // Label 20076: @1436338
     /* 1436338 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1436420), // Rule ID 18466 //
     /* 1436343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1436346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1436363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436382 */     // MIs[0] round
     /* 1436382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436385 */     // MIs[0] policy
     /* 1436385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1436398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436419 */     // GIR_Coverage, 18466,
     /* 1436419 */     GIR_EraseRootFromParent_Done,
     /* 1436420 */   // Label 20077: @1436420
     /* 1436420 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1436502), // Rule ID 18467 //
     /* 1436425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1436428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1436445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436464 */     // MIs[0] round
     /* 1436464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436467 */     // MIs[0] policy
     /* 1436467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436477 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1436480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436501 */     // GIR_Coverage, 18467,
     /* 1436501 */     GIR_EraseRootFromParent_Done,
     /* 1436502 */   // Label 20078: @1436502
     /* 1436502 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1436584), // Rule ID 18470 //
     /* 1436507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1436510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1436527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436546 */     // MIs[0] round
     /* 1436546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436549 */     // MIs[0] policy
     /* 1436549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436559 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1436562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436570 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436583 */     // GIR_Coverage, 18470,
     /* 1436583 */     GIR_EraseRootFromParent_Done,
     /* 1436584 */   // Label 20079: @1436584
     /* 1436584 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1436666), // Rule ID 18471 //
     /* 1436589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1436592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1436609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436628 */     // MIs[0] round
     /* 1436628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436631 */     // MIs[0] policy
     /* 1436631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436641 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1436644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436652 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436665 */     // GIR_Coverage, 18471,
     /* 1436665 */     GIR_EraseRootFromParent_Done,
     /* 1436666 */   // Label 20080: @1436666
     /* 1436666 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1436748), // Rule ID 18474 //
     /* 1436671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1436674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1436682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1436685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1436688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1436691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436710 */     // MIs[0] round
     /* 1436710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436713 */     // MIs[0] policy
     /* 1436713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436723 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1436726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436734 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436747 */     // GIR_Coverage, 18474,
     /* 1436747 */     GIR_EraseRootFromParent_Done,
     /* 1436748 */   // Label 20081: @1436748
     /* 1436748 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1436830), // Rule ID 18475 //
     /* 1436753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1436756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1436764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1436767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1436770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1436773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436792 */     // MIs[0] round
     /* 1436792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436795 */     // MIs[0] policy
     /* 1436795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436805 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1436808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436829 */     // GIR_Coverage, 18475,
     /* 1436829 */     GIR_EraseRootFromParent_Done,
     /* 1436830 */   // Label 20082: @1436830
     /* 1436830 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1436912), // Rule ID 18478 //
     /* 1436835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1436838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1436846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1436849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1436852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1436855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436874 */     // MIs[0] round
     /* 1436874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436877 */     // MIs[0] policy
     /* 1436877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1436890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436911 */     // GIR_Coverage, 18478,
     /* 1436911 */     GIR_EraseRootFromParent_Done,
     /* 1436912 */   // Label 20083: @1436912
     /* 1436912 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1436994), // Rule ID 18479 //
     /* 1436917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1436920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1436925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1436928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1436931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1436934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1436937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436956 */     // MIs[0] round
     /* 1436956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1436959 */     // MIs[0] policy
     /* 1436959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436969 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1436972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1436976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1436980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1436982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436993 */     // GIR_Coverage, 18479,
     /* 1436993 */     GIR_EraseRootFromParent_Done,
     /* 1436994 */   // Label 20084: @1436994
     /* 1436994 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1437076), // Rule ID 18482 //
     /* 1436999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1437002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1437019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437038 */     // MIs[0] round
     /* 1437038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437041 */     // MIs[0] policy
     /* 1437041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437051 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1437054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437062 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437075 */     // GIR_Coverage, 18482,
     /* 1437075 */     GIR_EraseRootFromParent_Done,
     /* 1437076 */   // Label 20085: @1437076
     /* 1437076 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1437158), // Rule ID 18483 //
     /* 1437081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1437084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1437101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437120 */     // MIs[0] round
     /* 1437120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437123 */     // MIs[0] policy
     /* 1437123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437133 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1437136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437157 */     // GIR_Coverage, 18483,
     /* 1437157 */     GIR_EraseRootFromParent_Done,
     /* 1437158 */   // Label 20086: @1437158
     /* 1437158 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1437240), // Rule ID 18486 //
     /* 1437163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1437166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1437183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437202 */     // MIs[0] round
     /* 1437202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437205 */     // MIs[0] policy
     /* 1437205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437215 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1437218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437226 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437239 */     // GIR_Coverage, 18486,
     /* 1437239 */     GIR_EraseRootFromParent_Done,
     /* 1437240 */   // Label 20087: @1437240
     /* 1437240 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1437322), // Rule ID 18487 //
     /* 1437245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1437248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1437265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437284 */     // MIs[0] round
     /* 1437284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437287 */     // MIs[0] policy
     /* 1437287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437297 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1437300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437308 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437321 */     // GIR_Coverage, 18487,
     /* 1437321 */     GIR_EraseRootFromParent_Done,
     /* 1437322 */   // Label 20088: @1437322
     /* 1437322 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1437404), // Rule ID 18490 //
     /* 1437327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1437330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1437347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437366 */     // MIs[0] round
     /* 1437366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437369 */     // MIs[0] policy
     /* 1437369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1437382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437403 */     // GIR_Coverage, 18490,
     /* 1437403 */     GIR_EraseRootFromParent_Done,
     /* 1437404 */   // Label 20089: @1437404
     /* 1437404 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1437486), // Rule ID 18491 //
     /* 1437409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1437412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1437429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437448 */     // MIs[0] round
     /* 1437448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437451 */     // MIs[0] policy
     /* 1437451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437461 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1437464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437485 */     // GIR_Coverage, 18491,
     /* 1437485 */     GIR_EraseRootFromParent_Done,
     /* 1437486 */   // Label 20090: @1437486
     /* 1437486 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1437568), // Rule ID 18494 //
     /* 1437491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1437494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1437502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1437505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1437508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1437511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437530 */     // MIs[0] round
     /* 1437530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437533 */     // MIs[0] policy
     /* 1437533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437543 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1437546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437554 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437567 */     // GIR_Coverage, 18494,
     /* 1437567 */     GIR_EraseRootFromParent_Done,
     /* 1437568 */   // Label 20091: @1437568
     /* 1437568 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1437650), // Rule ID 18495 //
     /* 1437573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1437576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1437584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1437587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1437590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1437593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437612 */     // MIs[0] round
     /* 1437612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437615 */     // MIs[0] policy
     /* 1437615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437625 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1437628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437649 */     // GIR_Coverage, 18495,
     /* 1437649 */     GIR_EraseRootFromParent_Done,
     /* 1437650 */   // Label 20092: @1437650
     /* 1437650 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1437732), // Rule ID 18498 //
     /* 1437655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1437658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1437666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1437669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1437672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1437675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437694 */     // MIs[0] round
     /* 1437694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437697 */     // MIs[0] policy
     /* 1437697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437707 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1437710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437731 */     // GIR_Coverage, 18498,
     /* 1437731 */     GIR_EraseRootFromParent_Done,
     /* 1437732 */   // Label 20093: @1437732
     /* 1437732 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1437814), // Rule ID 18499 //
     /* 1437737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1437740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1437748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1437751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1437754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1437757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437776 */     // MIs[0] round
     /* 1437776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437779 */     // MIs[0] policy
     /* 1437779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437789 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1437792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437813 */     // GIR_Coverage, 18499,
     /* 1437813 */     GIR_EraseRootFromParent_Done,
     /* 1437814 */   // Label 20094: @1437814
     /* 1437814 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1437896), // Rule ID 18502 //
     /* 1437819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1437822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1437836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1437839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1437854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437858 */     // MIs[0] round
     /* 1437858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437861 */     // MIs[0] policy
     /* 1437861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437871 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1437874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437882 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437895 */     // GIR_Coverage, 18502,
     /* 1437895 */     GIR_EraseRootFromParent_Done,
     /* 1437896 */   // Label 20095: @1437896
     /* 1437896 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1437978), // Rule ID 18503 //
     /* 1437901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1437904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1437918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1437921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1437936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437940 */     // MIs[0] round
     /* 1437940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1437943 */     // MIs[0] policy
     /* 1437943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437953 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1437956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1437960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1437964 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1437966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437977 */     // GIR_Coverage, 18503,
     /* 1437977 */     GIR_EraseRootFromParent_Done,
     /* 1437978 */   // Label 20096: @1437978
     /* 1437978 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1438060), // Rule ID 18506 //
     /* 1437983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1437986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1437991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1438003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438022 */     // MIs[0] round
     /* 1438022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438025 */     // MIs[0] policy
     /* 1438025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438035 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1438038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438059 */     // GIR_Coverage, 18506,
     /* 1438059 */     GIR_EraseRootFromParent_Done,
     /* 1438060 */   // Label 20097: @1438060
     /* 1438060 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1438142), // Rule ID 18507 //
     /* 1438065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1438068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1438076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1438079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1438085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438104 */     // MIs[0] round
     /* 1438104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438107 */     // MIs[0] policy
     /* 1438107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438117 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1438120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438128 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438141 */     // GIR_Coverage, 18507,
     /* 1438141 */     GIR_EraseRootFromParent_Done,
     /* 1438142 */   // Label 20098: @1438142
     /* 1438142 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1438224), // Rule ID 18510 //
     /* 1438147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1438150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1438158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1438161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1438164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1438167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1438182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438186 */     // MIs[0] round
     /* 1438186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438189 */     // MIs[0] policy
     /* 1438189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438199 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1438202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438210 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438223 */     // GIR_Coverage, 18510,
     /* 1438223 */     GIR_EraseRootFromParent_Done,
     /* 1438224 */   // Label 20099: @1438224
     /* 1438224 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1438306), // Rule ID 18511 //
     /* 1438229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1438232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1438240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1438243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1438246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1438249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1438264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438268 */     // MIs[0] round
     /* 1438268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438271 */     // MIs[0] policy
     /* 1438271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438281 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1438284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438292 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438305 */     // GIR_Coverage, 18511,
     /* 1438305 */     GIR_EraseRootFromParent_Done,
     /* 1438306 */   // Label 20100: @1438306
     /* 1438306 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1438388), // Rule ID 18514 //
     /* 1438311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1438314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1438331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438350 */     // MIs[0] round
     /* 1438350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438353 */     // MIs[0] policy
     /* 1438353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438363 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1438366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438374 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438387 */     // GIR_Coverage, 18514,
     /* 1438387 */     GIR_EraseRootFromParent_Done,
     /* 1438388 */   // Label 20101: @1438388
     /* 1438388 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1438470), // Rule ID 18515 //
     /* 1438393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1438396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1438413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438432 */     // MIs[0] round
     /* 1438432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438435 */     // MIs[0] policy
     /* 1438435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438445 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10938:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1438448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438456 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438469 */     // GIR_Coverage, 18515,
     /* 1438469 */     GIR_EraseRootFromParent_Done,
     /* 1438470 */   // Label 20102: @1438470
     /* 1438470 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1438552), // Rule ID 18518 //
     /* 1438475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1438478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1438492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1438495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1438510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438514 */     // MIs[0] round
     /* 1438514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438517 */     // MIs[0] policy
     /* 1438517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438527 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1438530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438538 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438551 */     // GIR_Coverage, 18518,
     /* 1438551 */     GIR_EraseRootFromParent_Done,
     /* 1438552 */   // Label 20103: @1438552
     /* 1438552 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1438634), // Rule ID 18519 //
     /* 1438557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1438560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1438574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1438577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1438592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438596 */     // MIs[0] round
     /* 1438596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438599 */     // MIs[0] policy
     /* 1438599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438609 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10938:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1438612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438620 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438633 */     // GIR_Coverage, 18519,
     /* 1438633 */     GIR_EraseRootFromParent_Done,
     /* 1438634 */   // Label 20104: @1438634
     /* 1438634 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1438716), // Rule ID 18522 //
     /* 1438639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1438642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1438656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1438659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1438674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438678 */     // MIs[0] round
     /* 1438678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438681 */     // MIs[0] policy
     /* 1438681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438691 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1438694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438702 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438715 */     // GIR_Coverage, 18522,
     /* 1438715 */     GIR_EraseRootFromParent_Done,
     /* 1438716 */   // Label 20105: @1438716
     /* 1438716 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1438798), // Rule ID 18523 //
     /* 1438721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1438724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1438738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1438741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1438756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438760 */     // MIs[0] round
     /* 1438760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438763 */     // MIs[0] policy
     /* 1438763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438773 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10938:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1438776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438797 */     // GIR_Coverage, 18523,
     /* 1438797 */     GIR_EraseRootFromParent_Done,
     /* 1438798 */   // Label 20106: @1438798
     /* 1438798 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1438880), // Rule ID 18526 //
     /* 1438803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1438806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1438823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438842 */     // MIs[0] round
     /* 1438842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438845 */     // MIs[0] policy
     /* 1438845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438855 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1438858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438866 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438879 */     // GIR_Coverage, 18526,
     /* 1438879 */     GIR_EraseRootFromParent_Done,
     /* 1438880 */   // Label 20107: @1438880
     /* 1438880 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1438962), // Rule ID 18527 //
     /* 1438885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1438888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1438905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1438920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438924 */     // MIs[0] round
     /* 1438924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1438927 */     // MIs[0] policy
     /* 1438927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438937 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1438940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1438944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1438948 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1438950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438961 */     // GIR_Coverage, 18527,
     /* 1438961 */     GIR_EraseRootFromParent_Done,
     /* 1438962 */   // Label 20108: @1438962
     /* 1438962 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1439044), // Rule ID 18530 //
     /* 1438967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1438970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1438975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1438978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1438981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1438984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1438987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1439002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439006 */     // MIs[0] round
     /* 1439006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439009 */     // MIs[0] policy
     /* 1439009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439019 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1439022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439043 */     // GIR_Coverage, 18530,
     /* 1439043 */     GIR_EraseRootFromParent_Done,
     /* 1439044 */   // Label 20109: @1439044
     /* 1439044 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1439126), // Rule ID 18531 //
     /* 1439049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1439052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1439066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1439069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1439084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439088 */     // MIs[0] round
     /* 1439088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439091 */     // MIs[0] policy
     /* 1439091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439101 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1439104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439125 */     // GIR_Coverage, 18531,
     /* 1439125 */     GIR_EraseRootFromParent_Done,
     /* 1439126 */   // Label 20110: @1439126
     /* 1439126 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1439208), // Rule ID 18534 //
     /* 1439131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1439134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1439148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1439151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1439166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439170 */     // MIs[0] round
     /* 1439170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439173 */     // MIs[0] policy
     /* 1439173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439183 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1439186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439194 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439207 */     // GIR_Coverage, 18534,
     /* 1439207 */     GIR_EraseRootFromParent_Done,
     /* 1439208 */   // Label 20111: @1439208
     /* 1439208 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1439290), // Rule ID 18535 //
     /* 1439213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1439216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1439230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1439233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1439248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439252 */     // MIs[0] round
     /* 1439252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439255 */     // MIs[0] policy
     /* 1439255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439265 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1439268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439276 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439289 */     // GIR_Coverage, 18535,
     /* 1439289 */     GIR_EraseRootFromParent_Done,
     /* 1439290 */   // Label 20112: @1439290
     /* 1439290 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1439372), // Rule ID 18538 //
     /* 1439295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1439298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1439315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439334 */     // MIs[0] round
     /* 1439334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439337 */     // MIs[0] policy
     /* 1439337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439347 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1439350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439358 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439371 */     // GIR_Coverage, 18538,
     /* 1439371 */     GIR_EraseRootFromParent_Done,
     /* 1439372 */   // Label 20113: @1439372
     /* 1439372 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1439454), // Rule ID 18539 //
     /* 1439377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1439380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1439397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439416 */     // MIs[0] round
     /* 1439416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439419 */     // MIs[0] policy
     /* 1439419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439429 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1439432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439440 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439453 */     // GIR_Coverage, 18539,
     /* 1439453 */     GIR_EraseRootFromParent_Done,
     /* 1439454 */   // Label 20114: @1439454
     /* 1439454 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1439536), // Rule ID 18542 //
     /* 1439459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1439462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1439479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439498 */     // MIs[0] round
     /* 1439498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439501 */     // MIs[0] policy
     /* 1439501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439511 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1439514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439522 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439535 */     // GIR_Coverage, 18542,
     /* 1439535 */     GIR_EraseRootFromParent_Done,
     /* 1439536 */   // Label 20115: @1439536
     /* 1439536 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1439618), // Rule ID 18543 //
     /* 1439541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1439544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1439561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439580 */     // MIs[0] round
     /* 1439580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439583 */     // MIs[0] policy
     /* 1439583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439593 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1439596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439617 */     // GIR_Coverage, 18543,
     /* 1439617 */     GIR_EraseRootFromParent_Done,
     /* 1439618 */   // Label 20116: @1439618
     /* 1439618 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1439700), // Rule ID 18546 //
     /* 1439623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1439626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1439643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439662 */     // MIs[0] round
     /* 1439662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439665 */     // MIs[0] policy
     /* 1439665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439675 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1439678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439699 */     // GIR_Coverage, 18546,
     /* 1439699 */     GIR_EraseRootFromParent_Done,
     /* 1439700 */   // Label 20117: @1439700
     /* 1439700 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1439782), // Rule ID 18547 //
     /* 1439705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1439708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1439722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1439725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1439740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439744 */     // MIs[0] round
     /* 1439744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439747 */     // MIs[0] policy
     /* 1439747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1439760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439768 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439781 */     // GIR_Coverage, 18547,
     /* 1439781 */     GIR_EraseRootFromParent_Done,
     /* 1439782 */   // Label 20118: @1439782
     /* 1439782 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1439864), // Rule ID 18550 //
     /* 1439787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1439790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1439798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1439801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1439804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1439807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1439822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439826 */     // MIs[0] round
     /* 1439826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439829 */     // MIs[0] policy
     /* 1439829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439839 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1439842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439850 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1439860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439863 */     // GIR_Coverage, 18550,
     /* 1439863 */     GIR_EraseRootFromParent_Done,
     /* 1439864 */   // Label 20119: @1439864
     /* 1439864 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1439946), // Rule ID 18551 //
     /* 1439869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1439872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1439880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1439883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1439886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1439889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1439904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439908 */     // MIs[0] round
     /* 1439908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439911 */     // MIs[0] policy
     /* 1439911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10938:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1439924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1439928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1439932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1439934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1439942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439945 */     // GIR_Coverage, 18551,
     /* 1439945 */     GIR_EraseRootFromParent_Done,
     /* 1439946 */   // Label 20120: @1439946
     /* 1439946 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1440028), // Rule ID 18554 //
     /* 1439951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1439954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1439959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1439962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1439965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1439968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1439971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1439986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439990 */     // MIs[0] round
     /* 1439990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1439993 */     // MIs[0] policy
     /* 1439993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440003 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1440006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440014 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440027 */     // GIR_Coverage, 18554,
     /* 1440027 */     GIR_EraseRootFromParent_Done,
     /* 1440028 */   // Label 20121: @1440028
     /* 1440028 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1440110), // Rule ID 18555 //
     /* 1440033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1440036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1440041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1440050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1440053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1440068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440072 */     // MIs[0] round
     /* 1440072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440075 */     // MIs[0] policy
     /* 1440075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10938:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1440088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440109 */     // GIR_Coverage, 18555,
     /* 1440109 */     GIR_EraseRootFromParent_Done,
     /* 1440110 */   // Label 20122: @1440110
     /* 1440110 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1440192), // Rule ID 18558 //
     /* 1440115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1440118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1440123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1440132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1440135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1440150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440154 */     // MIs[0] round
     /* 1440154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440157 */     // MIs[0] policy
     /* 1440157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440167 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1440170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440178 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440191 */     // GIR_Coverage, 18558,
     /* 1440191 */     GIR_EraseRootFromParent_Done,
     /* 1440192 */   // Label 20123: @1440192
     /* 1440192 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1440274), // Rule ID 18559 //
     /* 1440197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1440200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1440205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1440214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1440217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1440232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440236 */     // MIs[0] round
     /* 1440236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440239 */     // MIs[0] policy
     /* 1440239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440249 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10938:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1440252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440273 */     // GIR_Coverage, 18559,
     /* 1440273 */     GIR_EraseRootFromParent_Done,
     /* 1440274 */   // Label 20124: @1440274
     /* 1440274 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1440356), // Rule ID 18562 //
     /* 1440279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1440282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1440290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1440293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1440296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1440299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440318 */     // MIs[0] round
     /* 1440318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440321 */     // MIs[0] policy
     /* 1440321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440331 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1440334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440342 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440355 */     // GIR_Coverage, 18562,
     /* 1440355 */     GIR_EraseRootFromParent_Done,
     /* 1440356 */   // Label 20125: @1440356
     /* 1440356 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1440438), // Rule ID 18563 //
     /* 1440361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1440364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1440372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1440375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1440378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1440381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440400 */     // MIs[0] round
     /* 1440400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440403 */     // MIs[0] policy
     /* 1440403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440413 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1440416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440437 */     // GIR_Coverage, 18563,
     /* 1440437 */     GIR_EraseRootFromParent_Done,
     /* 1440438 */   // Label 20126: @1440438
     /* 1440438 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1440520), // Rule ID 18566 //
     /* 1440443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1440446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1440454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1440457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1440460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1440463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440482 */     // MIs[0] round
     /* 1440482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440485 */     // MIs[0] policy
     /* 1440485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1440498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440506 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440519 */     // GIR_Coverage, 18566,
     /* 1440519 */     GIR_EraseRootFromParent_Done,
     /* 1440520 */   // Label 20127: @1440520
     /* 1440520 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1440602), // Rule ID 18567 //
     /* 1440525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1440528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1440536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1440539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1440542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1440545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440564 */     // MIs[0] round
     /* 1440564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440567 */     // MIs[0] policy
     /* 1440567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1440580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440588 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440601 */     // GIR_Coverage, 18567,
     /* 1440601 */     GIR_EraseRootFromParent_Done,
     /* 1440602 */   // Label 20128: @1440602
     /* 1440602 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1440684), // Rule ID 18570 //
     /* 1440607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1440610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1440618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1440621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1440624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1440627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440646 */     // MIs[0] round
     /* 1440646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440649 */     // MIs[0] policy
     /* 1440649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440659 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1440662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440683 */     // GIR_Coverage, 18570,
     /* 1440683 */     GIR_EraseRootFromParent_Done,
     /* 1440684 */   // Label 20129: @1440684
     /* 1440684 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1440766), // Rule ID 18571 //
     /* 1440689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1440692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1440700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1440703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1440706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1440709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440728 */     // MIs[0] round
     /* 1440728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440731 */     // MIs[0] policy
     /* 1440731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440741 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1440744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440752 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440765 */     // GIR_Coverage, 18571,
     /* 1440765 */     GIR_EraseRootFromParent_Done,
     /* 1440766 */   // Label 20130: @1440766
     /* 1440766 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1440848), // Rule ID 18574 //
     /* 1440771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1440774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1440788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1440791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440810 */     // MIs[0] round
     /* 1440810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440813 */     // MIs[0] policy
     /* 1440813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440823 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1440826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440834 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440847 */     // GIR_Coverage, 18574,
     /* 1440847 */     GIR_EraseRootFromParent_Done,
     /* 1440848 */   // Label 20131: @1440848
     /* 1440848 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1440930), // Rule ID 18575 //
     /* 1440853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1440856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1440870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1440873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440892 */     // MIs[0] round
     /* 1440892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440895 */     // MIs[0] policy
     /* 1440895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440905 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1440908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1440918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440929 */     // GIR_Coverage, 18575,
     /* 1440929 */     GIR_EraseRootFromParent_Done,
     /* 1440930 */   // Label 20132: @1440930
     /* 1440930 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1441012), // Rule ID 18578 //
     /* 1440935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1440938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1440943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1440952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1440955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440974 */     // MIs[0] round
     /* 1440974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1440977 */     // MIs[0] policy
     /* 1440977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440987 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1440990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1440994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1440998 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441011 */     // GIR_Coverage, 18578,
     /* 1441011 */     GIR_EraseRootFromParent_Done,
     /* 1441012 */   // Label 20133: @1441012
     /* 1441012 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1441094), // Rule ID 18579 //
     /* 1441017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1441020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1441028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1441031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1441034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1441037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441056 */     // MIs[0] round
     /* 1441056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441059 */     // MIs[0] policy
     /* 1441059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441069 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1441072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441093 */     // GIR_Coverage, 18579,
     /* 1441093 */     GIR_EraseRootFromParent_Done,
     /* 1441094 */   // Label 20134: @1441094
     /* 1441094 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1441176), // Rule ID 18582 //
     /* 1441099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1441102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1441110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1441113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1441119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441138 */     // MIs[0] round
     /* 1441138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441141 */     // MIs[0] policy
     /* 1441141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441151 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1441154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441162 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441175 */     // GIR_Coverage, 18582,
     /* 1441175 */     GIR_EraseRootFromParent_Done,
     /* 1441176 */   // Label 20135: @1441176
     /* 1441176 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1441258), // Rule ID 18583 //
     /* 1441181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1441184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1441192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1441195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1441201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441220 */     // MIs[0] round
     /* 1441220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441223 */     // MIs[0] policy
     /* 1441223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441233 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1441236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441257 */     // GIR_Coverage, 18583,
     /* 1441257 */     GIR_EraseRootFromParent_Done,
     /* 1441258 */   // Label 20136: @1441258
     /* 1441258 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1441340), // Rule ID 18586 //
     /* 1441263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1441266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1441274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1441277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1441280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1441283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441302 */     // MIs[0] round
     /* 1441302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441305 */     // MIs[0] policy
     /* 1441305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441315 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1441318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441339 */     // GIR_Coverage, 18586,
     /* 1441339 */     GIR_EraseRootFromParent_Done,
     /* 1441340 */   // Label 20137: @1441340
     /* 1441340 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1441422), // Rule ID 18587 //
     /* 1441345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1441348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1441356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1441359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1441362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1441365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441384 */     // MIs[0] round
     /* 1441384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441387 */     // MIs[0] policy
     /* 1441387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1441400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441408 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441421 */     // GIR_Coverage, 18587,
     /* 1441421 */     GIR_EraseRootFromParent_Done,
     /* 1441422 */   // Label 20138: @1441422
     /* 1441422 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1441504), // Rule ID 18590 //
     /* 1441427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1441430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1441438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1441441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1441447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441466 */     // MIs[0] round
     /* 1441466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441469 */     // MIs[0] policy
     /* 1441469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441479 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1441482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441490 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441503 */     // GIR_Coverage, 18590,
     /* 1441503 */     GIR_EraseRootFromParent_Done,
     /* 1441504 */   // Label 20139: @1441504
     /* 1441504 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1441586), // Rule ID 18591 //
     /* 1441509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1441512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1441520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1441523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1441529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441548 */     // MIs[0] round
     /* 1441548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441551 */     // MIs[0] policy
     /* 1441551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441561 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1441564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441585 */     // GIR_Coverage, 18591,
     /* 1441585 */     GIR_EraseRootFromParent_Done,
     /* 1441586 */   // Label 20140: @1441586
     /* 1441586 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1441668), // Rule ID 18594 //
     /* 1441591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1441594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1441602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1441605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1441611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441630 */     // MIs[0] round
     /* 1441630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441633 */     // MIs[0] policy
     /* 1441633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441643 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1441646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441654 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441667 */     // GIR_Coverage, 18594,
     /* 1441667 */     GIR_EraseRootFromParent_Done,
     /* 1441668 */   // Label 20141: @1441668
     /* 1441668 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1441750), // Rule ID 18595 //
     /* 1441673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1441676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1441684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1441687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1441693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441712 */     // MIs[0] round
     /* 1441712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441715 */     // MIs[0] policy
     /* 1441715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441725 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1441728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441749 */     // GIR_Coverage, 18595,
     /* 1441749 */     GIR_EraseRootFromParent_Done,
     /* 1441750 */   // Label 20142: @1441750
     /* 1441750 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1441832), // Rule ID 18598 //
     /* 1441755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1441758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1441772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1441775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1441790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441794 */     // MIs[0] round
     /* 1441794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441797 */     // MIs[0] policy
     /* 1441797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441807 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1441810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441818 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441831 */     // GIR_Coverage, 18598,
     /* 1441831 */     GIR_EraseRootFromParent_Done,
     /* 1441832 */   // Label 20143: @1441832
     /* 1441832 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1441914), // Rule ID 18599 //
     /* 1441837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1441840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1441854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1441857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1441872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441876 */     // MIs[0] round
     /* 1441876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441879 */     // MIs[0] policy
     /* 1441879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441889 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1441892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441913 */     // GIR_Coverage, 18599,
     /* 1441913 */     GIR_EraseRootFromParent_Done,
     /* 1441914 */   // Label 20144: @1441914
     /* 1441914 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1441996), // Rule ID 18602 //
     /* 1441919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1441922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1441927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1441930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1441933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1441936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1441939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1441954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441958 */     // MIs[0] round
     /* 1441958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1441961 */     // MIs[0] policy
     /* 1441961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1441974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1441978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1441982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1441984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441995 */     // GIR_Coverage, 18602,
     /* 1441995 */     GIR_EraseRootFromParent_Done,
     /* 1441996 */   // Label 20145: @1441996
     /* 1441996 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1442078), // Rule ID 18603 //
     /* 1442001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1442004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1442021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442040 */     // MIs[0] round
     /* 1442040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442043 */     // MIs[0] policy
     /* 1442043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442053 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10990:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1442056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442064 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442077 */     // GIR_Coverage, 18603,
     /* 1442077 */     GIR_EraseRootFromParent_Done,
     /* 1442078 */   // Label 20146: @1442078
     /* 1442078 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1442160), // Rule ID 18606 //
     /* 1442083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1442086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1442094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1442097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1442103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442122 */     // MIs[0] round
     /* 1442122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442125 */     // MIs[0] policy
     /* 1442125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442135 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1442138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442159 */     // GIR_Coverage, 18606,
     /* 1442159 */     GIR_EraseRootFromParent_Done,
     /* 1442160 */   // Label 20147: @1442160
     /* 1442160 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1442242), // Rule ID 18607 //
     /* 1442165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1442168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1442176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1442179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1442185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442204 */     // MIs[0] round
     /* 1442204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442207 */     // MIs[0] policy
     /* 1442207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442217 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1442220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442228 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442241 */     // GIR_Coverage, 18607,
     /* 1442241 */     GIR_EraseRootFromParent_Done,
     /* 1442242 */   // Label 20148: @1442242
     /* 1442242 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1442324), // Rule ID 18610 //
     /* 1442247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1442250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1442258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1442261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1442267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442286 */     // MIs[0] round
     /* 1442286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442289 */     // MIs[0] policy
     /* 1442289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442299 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1442302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442323 */     // GIR_Coverage, 18610,
     /* 1442323 */     GIR_EraseRootFromParent_Done,
     /* 1442324 */   // Label 20149: @1442324
     /* 1442324 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1442406), // Rule ID 18611 //
     /* 1442329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1442332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1442340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1442343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1442349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442368 */     // MIs[0] round
     /* 1442368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442371 */     // MIs[0] policy
     /* 1442371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442381 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1442384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442392 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442405 */     // GIR_Coverage, 18611,
     /* 1442405 */     GIR_EraseRootFromParent_Done,
     /* 1442406 */   // Label 20150: @1442406
     /* 1442406 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1442488), // Rule ID 18614 //
     /* 1442411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1442414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1442422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1442425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1442431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442450 */     // MIs[0] round
     /* 1442450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442453 */     // MIs[0] policy
     /* 1442453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442463 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1442466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442474 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442487 */     // GIR_Coverage, 18614,
     /* 1442487 */     GIR_EraseRootFromParent_Done,
     /* 1442488 */   // Label 20151: @1442488
     /* 1442488 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1442570), // Rule ID 18615 //
     /* 1442493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1442496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1442504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1442507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1442510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1442513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1442528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442532 */     // MIs[0] round
     /* 1442532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442535 */     // MIs[0] policy
     /* 1442535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442545 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1442548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442556 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442569 */     // GIR_Coverage, 18615,
     /* 1442569 */     GIR_EraseRootFromParent_Done,
     /* 1442570 */   // Label 20152: @1442570
     /* 1442570 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1442652), // Rule ID 18618 //
     /* 1442575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1442578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1442592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1442595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1442610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442614 */     // MIs[0] round
     /* 1442614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442617 */     // MIs[0] policy
     /* 1442617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442627 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1442630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442651 */     // GIR_Coverage, 18618,
     /* 1442651 */     GIR_EraseRootFromParent_Done,
     /* 1442652 */   // Label 20153: @1442652
     /* 1442652 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1442734), // Rule ID 18619 //
     /* 1442657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1442660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1442674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1442677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1442692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442696 */     // MIs[0] round
     /* 1442696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442699 */     // MIs[0] policy
     /* 1442699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442709 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10990:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1442712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442733 */     // GIR_Coverage, 18619,
     /* 1442733 */     GIR_EraseRootFromParent_Done,
     /* 1442734 */   // Label 20154: @1442734
     /* 1442734 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1442816), // Rule ID 18622 //
     /* 1442739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1442742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1442756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1442759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1442774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442778 */     // MIs[0] round
     /* 1442778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442781 */     // MIs[0] policy
     /* 1442781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1442794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442815 */     // GIR_Coverage, 18622,
     /* 1442815 */     GIR_EraseRootFromParent_Done,
     /* 1442816 */   // Label 20155: @1442816
     /* 1442816 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1442898), // Rule ID 18623 //
     /* 1442821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1442824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1442838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1442841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1442856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442860 */     // MIs[0] round
     /* 1442860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442863 */     // MIs[0] policy
     /* 1442863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442873 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10990:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1442876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442897 */     // GIR_Coverage, 18623,
     /* 1442897 */     GIR_EraseRootFromParent_Done,
     /* 1442898 */   // Label 20156: @1442898
     /* 1442898 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1442980), // Rule ID 18626 //
     /* 1442903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1442906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1442920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1442923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1442938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442942 */     // MIs[0] round
     /* 1442942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1442945 */     // MIs[0] policy
     /* 1442945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442955 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1442958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1442962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1442966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1442968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442979 */     // GIR_Coverage, 18626,
     /* 1442979 */     GIR_EraseRootFromParent_Done,
     /* 1442980 */   // Label 20157: @1442980
     /* 1442980 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1443062), // Rule ID 18627 //
     /* 1442985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1442988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1442993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1443002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1443005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1443020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443024 */     // MIs[0] round
     /* 1443024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443027 */     // MIs[0] policy
     /* 1443027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443037 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10990:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1443040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443048 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443061 */     // GIR_Coverage, 18627,
     /* 1443061 */     GIR_EraseRootFromParent_Done,
     /* 1443062 */   // Label 20158: @1443062
     /* 1443062 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1443144), // Rule ID 18630 //
     /* 1443067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1443070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1443075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1443078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1443081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1443084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1443087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1443102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443106 */     // MIs[0] round
     /* 1443106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443109 */     // MIs[0] policy
     /* 1443109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443119 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1443122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443143 */     // GIR_Coverage, 18630,
     /* 1443143 */     GIR_EraseRootFromParent_Done,
     /* 1443144 */   // Label 20159: @1443144
     /* 1443144 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1443226), // Rule ID 18631 //
     /* 1443149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1443152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1443157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1443160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1443163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1443166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1443169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1443184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443188 */     // MIs[0] round
     /* 1443188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443191 */     // MIs[0] policy
     /* 1443191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443201 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10990:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1443204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443225 */     // GIR_Coverage, 18631,
     /* 1443225 */     GIR_EraseRootFromParent_Done,
     /* 1443226 */   // Label 20160: @1443226
     /* 1443226 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1443308), // Rule ID 18634 //
     /* 1443231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1443234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1443251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443270 */     // MIs[0] round
     /* 1443270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443273 */     // MIs[0] policy
     /* 1443273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443283 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1443286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443307 */     // GIR_Coverage, 18634,
     /* 1443307 */     GIR_EraseRootFromParent_Done,
     /* 1443308 */   // Label 20161: @1443308
     /* 1443308 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1443390), // Rule ID 18635 //
     /* 1443313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1443316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1443333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443352 */     // MIs[0] round
     /* 1443352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443355 */     // MIs[0] policy
     /* 1443355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443365 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1443368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443376 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443389 */     // GIR_Coverage, 18635,
     /* 1443389 */     GIR_EraseRootFromParent_Done,
     /* 1443390 */   // Label 20162: @1443390
     /* 1443390 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1443472), // Rule ID 18638 //
     /* 1443395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1443398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1443406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1443409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1443415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443434 */     // MIs[0] round
     /* 1443434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443437 */     // MIs[0] policy
     /* 1443437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443447 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1443450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443458 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443471 */     // GIR_Coverage, 18638,
     /* 1443471 */     GIR_EraseRootFromParent_Done,
     /* 1443472 */   // Label 20163: @1443472
     /* 1443472 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1443554), // Rule ID 18639 //
     /* 1443477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1443480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1443488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1443491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1443497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443516 */     // MIs[0] round
     /* 1443516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443519 */     // MIs[0] policy
     /* 1443519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443529 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1443532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443553 */     // GIR_Coverage, 18639,
     /* 1443553 */     GIR_EraseRootFromParent_Done,
     /* 1443554 */   // Label 20164: @1443554
     /* 1443554 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1443636), // Rule ID 18642 //
     /* 1443559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1443562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1443576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1443579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443598 */     // MIs[0] round
     /* 1443598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443601 */     // MIs[0] policy
     /* 1443601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443611 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1443614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443635 */     // GIR_Coverage, 18642,
     /* 1443635 */     GIR_EraseRootFromParent_Done,
     /* 1443636 */   // Label 20165: @1443636
     /* 1443636 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1443718), // Rule ID 18643 //
     /* 1443641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1443644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1443658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1443661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443680 */     // MIs[0] round
     /* 1443680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443683 */     // MIs[0] policy
     /* 1443683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443693 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1443696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443717 */     // GIR_Coverage, 18643,
     /* 1443717 */     GIR_EraseRootFromParent_Done,
     /* 1443718 */   // Label 20166: @1443718
     /* 1443718 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1443800), // Rule ID 18646 //
     /* 1443723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1443726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1443743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443762 */     // MIs[0] round
     /* 1443762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443765 */     // MIs[0] policy
     /* 1443765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443775 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1443778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443786 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443799 */     // GIR_Coverage, 18646,
     /* 1443799 */     GIR_EraseRootFromParent_Done,
     /* 1443800 */   // Label 20167: @1443800
     /* 1443800 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1443882), // Rule ID 18647 //
     /* 1443805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1443808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1443825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443844 */     // MIs[0] round
     /* 1443844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443847 */     // MIs[0] policy
     /* 1443847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443857 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1443860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443868 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443881 */     // GIR_Coverage, 18647,
     /* 1443881 */     GIR_EraseRootFromParent_Done,
     /* 1443882 */   // Label 20168: @1443882
     /* 1443882 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1443964), // Rule ID 18650 //
     /* 1443887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1443890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1443898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1443901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1443907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443926 */     // MIs[0] round
     /* 1443926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1443929 */     // MIs[0] policy
     /* 1443929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443939 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1443942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1443946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1443950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1443952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443963 */     // GIR_Coverage, 18650,
     /* 1443963 */     GIR_EraseRootFromParent_Done,
     /* 1443964 */   // Label 20169: @1443964
     /* 1443964 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1444046), // Rule ID 18651 //
     /* 1443969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1443972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1443977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1443980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1443983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1443989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444008 */     // MIs[0] round
     /* 1444008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444011 */     // MIs[0] policy
     /* 1444011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444021 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1444024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444032 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444045 */     // GIR_Coverage, 18651,
     /* 1444045 */     GIR_EraseRootFromParent_Done,
     /* 1444046 */   // Label 20170: @1444046
     /* 1444046 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1444128), // Rule ID 18654 //
     /* 1444051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1444054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1444068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1444071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444090 */     // MIs[0] round
     /* 1444090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444093 */     // MIs[0] policy
     /* 1444093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444103 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1444106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444114 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444127 */     // GIR_Coverage, 18654,
     /* 1444127 */     GIR_EraseRootFromParent_Done,
     /* 1444128 */   // Label 20171: @1444128
     /* 1444128 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1444210), // Rule ID 18655 //
     /* 1444133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1444136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1444150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1444153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444172 */     // MIs[0] round
     /* 1444172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444175 */     // MIs[0] policy
     /* 1444175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444185 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1444188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444196 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444209 */     // GIR_Coverage, 18655,
     /* 1444209 */     GIR_EraseRootFromParent_Done,
     /* 1444210 */   // Label 20172: @1444210
     /* 1444210 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1444292), // Rule ID 18658 //
     /* 1444215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1444218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1444235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444254 */     // MIs[0] round
     /* 1444254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444257 */     // MIs[0] policy
     /* 1444257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444267 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1444270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444291 */     // GIR_Coverage, 18658,
     /* 1444291 */     GIR_EraseRootFromParent_Done,
     /* 1444292 */   // Label 20173: @1444292
     /* 1444292 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1444374), // Rule ID 18659 //
     /* 1444297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1444300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1444317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444336 */     // MIs[0] round
     /* 1444336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444339 */     // MIs[0] policy
     /* 1444339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444349 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1444352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444373 */     // GIR_Coverage, 18659,
     /* 1444373 */     GIR_EraseRootFromParent_Done,
     /* 1444374 */   // Label 20174: @1444374
     /* 1444374 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1444456), // Rule ID 18662 //
     /* 1444379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1444382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1444399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444418 */     // MIs[0] round
     /* 1444418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444421 */     // MIs[0] policy
     /* 1444421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444431 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1444434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444455 */     // GIR_Coverage, 18662,
     /* 1444455 */     GIR_EraseRootFromParent_Done,
     /* 1444456 */   // Label 20175: @1444456
     /* 1444456 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1444538), // Rule ID 18663 //
     /* 1444461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1444464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1444481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444500 */     // MIs[0] round
     /* 1444500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444503 */     // MIs[0] policy
     /* 1444503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444513 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1444516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444524 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444537 */     // GIR_Coverage, 18663,
     /* 1444537 */     GIR_EraseRootFromParent_Done,
     /* 1444538 */   // Label 20176: @1444538
     /* 1444538 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1444620), // Rule ID 18666 //
     /* 1444543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1444546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1444563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444582 */     // MIs[0] round
     /* 1444582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444585 */     // MIs[0] policy
     /* 1444585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444595 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1444598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444619 */     // GIR_Coverage, 18666,
     /* 1444619 */     GIR_EraseRootFromParent_Done,
     /* 1444620 */   // Label 20177: @1444620
     /* 1444620 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1444702), // Rule ID 18667 //
     /* 1444625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1444628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1444645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444664 */     // MIs[0] round
     /* 1444664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444667 */     // MIs[0] policy
     /* 1444667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444677 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1444680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444688 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444701 */     // GIR_Coverage, 18667,
     /* 1444701 */     GIR_EraseRootFromParent_Done,
     /* 1444702 */   // Label 20178: @1444702
     /* 1444702 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1444784), // Rule ID 18670 //
     /* 1444707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1444710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1444718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1444721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1444724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1444727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1444742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444746 */     // MIs[0] round
     /* 1444746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444749 */     // MIs[0] policy
     /* 1444749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444759 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1444762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444783 */     // GIR_Coverage, 18670,
     /* 1444783 */     GIR_EraseRootFromParent_Done,
     /* 1444784 */   // Label 20179: @1444784
     /* 1444784 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1444866), // Rule ID 18671 //
     /* 1444789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1444792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1444800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1444803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1444806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1444809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1444824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444828 */     // MIs[0] round
     /* 1444828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444831 */     // MIs[0] policy
     /* 1444831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444841 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1444844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444852 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444865 */     // GIR_Coverage, 18671,
     /* 1444865 */     GIR_EraseRootFromParent_Done,
     /* 1444866 */   // Label 20180: @1444866
     /* 1444866 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1444948), // Rule ID 18674 //
     /* 1444871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1444874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1444888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1444891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1444906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444910 */     // MIs[0] round
     /* 1444910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444913 */     // MIs[0] policy
     /* 1444913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444923 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1444926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1444930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1444934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1444936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444947 */     // GIR_Coverage, 18674,
     /* 1444947 */     GIR_EraseRootFromParent_Done,
     /* 1444948 */   // Label 20181: @1444948
     /* 1444948 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1445030), // Rule ID 18675 //
     /* 1444953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1444956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1444961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1444970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1444973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1444988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444992 */     // MIs[0] round
     /* 1444992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1444995 */     // MIs[0] policy
     /* 1444995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445005 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10998:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1445008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445016 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445029 */     // GIR_Coverage, 18675,
     /* 1445029 */     GIR_EraseRootFromParent_Done,
     /* 1445030 */   // Label 20182: @1445030
     /* 1445030 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1445112), // Rule ID 18678 //
     /* 1445035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1445038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1445055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445074 */     // MIs[0] round
     /* 1445074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445077 */     // MIs[0] policy
     /* 1445077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1445090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445111 */     // GIR_Coverage, 18678,
     /* 1445111 */     GIR_EraseRootFromParent_Done,
     /* 1445112 */   // Label 20183: @1445112
     /* 1445112 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1445194), // Rule ID 18679 //
     /* 1445117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1445120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1445137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445156 */     // MIs[0] round
     /* 1445156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445159 */     // MIs[0] policy
     /* 1445159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1445172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445180 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445193 */     // GIR_Coverage, 18679,
     /* 1445193 */     GIR_EraseRootFromParent_Done,
     /* 1445194 */   // Label 20184: @1445194
     /* 1445194 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1445276), // Rule ID 18682 //
     /* 1445199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1445202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1445210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1445213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1445219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445238 */     // MIs[0] round
     /* 1445238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445241 */     // MIs[0] policy
     /* 1445241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445251 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1445254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445275 */     // GIR_Coverage, 18682,
     /* 1445275 */     GIR_EraseRootFromParent_Done,
     /* 1445276 */   // Label 20185: @1445276
     /* 1445276 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1445358), // Rule ID 18683 //
     /* 1445281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1445284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1445292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1445295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1445301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445320 */     // MIs[0] round
     /* 1445320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445323 */     // MIs[0] policy
     /* 1445323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445333 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1445336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445344 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445357 */     // GIR_Coverage, 18683,
     /* 1445357 */     GIR_EraseRootFromParent_Done,
     /* 1445358 */   // Label 20186: @1445358
     /* 1445358 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1445440), // Rule ID 18686 //
     /* 1445363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1445366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1445374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1445377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1445383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445402 */     // MIs[0] round
     /* 1445402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445405 */     // MIs[0] policy
     /* 1445405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445415 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1445418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445439 */     // GIR_Coverage, 18686,
     /* 1445439 */     GIR_EraseRootFromParent_Done,
     /* 1445440 */   // Label 20187: @1445440
     /* 1445440 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1445522), // Rule ID 18687 //
     /* 1445445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1445448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1445456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1445459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1445462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1445465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1445480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445484 */     // MIs[0] round
     /* 1445484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445487 */     // MIs[0] policy
     /* 1445487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445497 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1445500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445508 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445521 */     // GIR_Coverage, 18687,
     /* 1445521 */     GIR_EraseRootFromParent_Done,
     /* 1445522 */   // Label 20188: @1445522
     /* 1445522 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1445604), // Rule ID 18690 //
     /* 1445527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1445530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1445538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1445541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1445547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445566 */     // MIs[0] round
     /* 1445566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445569 */     // MIs[0] policy
     /* 1445569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1445582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445603 */     // GIR_Coverage, 18690,
     /* 1445603 */     GIR_EraseRootFromParent_Done,
     /* 1445604 */   // Label 20189: @1445604
     /* 1445604 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1445686), // Rule ID 18691 //
     /* 1445609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1445612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1445620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1445623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1445629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445648 */     // MIs[0] round
     /* 1445648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445651 */     // MIs[0] policy
     /* 1445651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445661 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10998:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1445664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445672 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445685 */     // GIR_Coverage, 18691,
     /* 1445685 */     GIR_EraseRootFromParent_Done,
     /* 1445686 */   // Label 20190: @1445686
     /* 1445686 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1445768), // Rule ID 18694 //
     /* 1445691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1445694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1445702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1445705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1445711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445730 */     // MIs[0] round
     /* 1445730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445733 */     // MIs[0] policy
     /* 1445733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445743 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1445746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445767 */     // GIR_Coverage, 18694,
     /* 1445767 */     GIR_EraseRootFromParent_Done,
     /* 1445768 */   // Label 20191: @1445768
     /* 1445768 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1445850), // Rule ID 18695 //
     /* 1445773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1445776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1445784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1445787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1445793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445812 */     // MIs[0] round
     /* 1445812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445815 */     // MIs[0] policy
     /* 1445815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445825 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10998:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1445828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445836 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445849 */     // GIR_Coverage, 18695,
     /* 1445849 */     GIR_EraseRootFromParent_Done,
     /* 1445850 */   // Label 20192: @1445850
     /* 1445850 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1445932), // Rule ID 18698 //
     /* 1445855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1445858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1445875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445894 */     // MIs[0] round
     /* 1445894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445897 */     // MIs[0] policy
     /* 1445897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445907 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1445910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1445918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1445920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445931 */     // GIR_Coverage, 18698,
     /* 1445931 */     GIR_EraseRootFromParent_Done,
     /* 1445932 */   // Label 20193: @1445932
     /* 1445932 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1446014), // Rule ID 18699 //
     /* 1445937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1445940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1445945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1445954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1445957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1445972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445976 */     // MIs[0] round
     /* 1445976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1445979 */     // MIs[0] policy
     /* 1445979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445989 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10998:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1445992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1445996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446000 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446013 */     // GIR_Coverage, 18699,
     /* 1446013 */     GIR_EraseRootFromParent_Done,
     /* 1446014 */   // Label 20194: @1446014
     /* 1446014 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1446096), // Rule ID 18702 //
     /* 1446019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1446022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1446027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1446036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1446039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1446054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446058 */     // MIs[0] round
     /* 1446058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446061 */     // MIs[0] policy
     /* 1446061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446071 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1446074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446095 */     // GIR_Coverage, 18702,
     /* 1446095 */     GIR_EraseRootFromParent_Done,
     /* 1446096 */   // Label 20195: @1446096
     /* 1446096 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1446178), // Rule ID 18703 //
     /* 1446101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1446104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1446109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1446118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1446121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1446136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446140 */     // MIs[0] round
     /* 1446140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446143 */     // MIs[0] policy
     /* 1446143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446153 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10998:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1446156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446177 */     // GIR_Coverage, 18703,
     /* 1446177 */     GIR_EraseRootFromParent_Done,
     /* 1446178 */   // Label 20196: @1446178
     /* 1446178 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1446260), // Rule ID 18706 //
     /* 1446183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1446186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1446200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1446203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446222 */     // MIs[0] round
     /* 1446222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446225 */     // MIs[0] policy
     /* 1446225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446235 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1446238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446259 */     // GIR_Coverage, 18706,
     /* 1446259 */     GIR_EraseRootFromParent_Done,
     /* 1446260 */   // Label 20197: @1446260
     /* 1446260 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1446342), // Rule ID 18707 //
     /* 1446265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1446268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1446282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1446285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446304 */     // MIs[0] round
     /* 1446304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446307 */     // MIs[0] policy
     /* 1446307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446317 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1446320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446328 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446341 */     // GIR_Coverage, 18707,
     /* 1446341 */     GIR_EraseRootFromParent_Done,
     /* 1446342 */   // Label 20198: @1446342
     /* 1446342 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1446424), // Rule ID 18710 //
     /* 1446347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1446350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1446367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446386 */     // MIs[0] round
     /* 1446386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446389 */     // MIs[0] policy
     /* 1446389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446399 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1446402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446423 */     // GIR_Coverage, 18710,
     /* 1446423 */     GIR_EraseRootFromParent_Done,
     /* 1446424 */   // Label 20199: @1446424
     /* 1446424 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1446506), // Rule ID 18711 //
     /* 1446429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1446432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1446449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446468 */     // MIs[0] round
     /* 1446468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446471 */     // MIs[0] policy
     /* 1446471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446481 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1446484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446492 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446505 */     // GIR_Coverage, 18711,
     /* 1446505 */     GIR_EraseRootFromParent_Done,
     /* 1446506 */   // Label 20200: @1446506
     /* 1446506 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1446588), // Rule ID 18714 //
     /* 1446511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1446514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1446522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1446525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1446531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446550 */     // MIs[0] round
     /* 1446550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446553 */     // MIs[0] policy
     /* 1446553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1446566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446587 */     // GIR_Coverage, 18714,
     /* 1446587 */     GIR_EraseRootFromParent_Done,
     /* 1446588 */   // Label 20201: @1446588
     /* 1446588 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1446670), // Rule ID 18715 //
     /* 1446593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1446596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1446604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1446607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1446613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446632 */     // MIs[0] round
     /* 1446632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446635 */     // MIs[0] policy
     /* 1446635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446645 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1446648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446656 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446669 */     // GIR_Coverage, 18715,
     /* 1446669 */     GIR_EraseRootFromParent_Done,
     /* 1446670 */   // Label 20202: @1446670
     /* 1446670 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1446752), // Rule ID 18718 //
     /* 1446675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1446678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1446686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1446689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1446692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1446695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446714 */     // MIs[0] round
     /* 1446714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446717 */     // MIs[0] policy
     /* 1446717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1446730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446738 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446751 */     // GIR_Coverage, 18718,
     /* 1446751 */     GIR_EraseRootFromParent_Done,
     /* 1446752 */   // Label 20203: @1446752
     /* 1446752 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1446834), // Rule ID 18719 //
     /* 1446757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1446760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1446768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1446771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1446774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1446777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446796 */     // MIs[0] round
     /* 1446796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446799 */     // MIs[0] policy
     /* 1446799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446809 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1446812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446820 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446833 */     // GIR_Coverage, 18719,
     /* 1446833 */     GIR_EraseRootFromParent_Done,
     /* 1446834 */   // Label 20204: @1446834
     /* 1446834 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1446916), // Rule ID 18722 //
     /* 1446839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1446842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1446856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1446859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446878 */     // MIs[0] round
     /* 1446878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446881 */     // MIs[0] policy
     /* 1446881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446891 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1446894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446915 */     // GIR_Coverage, 18722,
     /* 1446915 */     GIR_EraseRootFromParent_Done,
     /* 1446916 */   // Label 20205: @1446916
     /* 1446916 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1446998), // Rule ID 18723 //
     /* 1446921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1446924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1446929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1446938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1446941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446960 */     // MIs[0] round
     /* 1446960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1446963 */     // MIs[0] policy
     /* 1446963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446973 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1446976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1446980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1446984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1446986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446997 */     // GIR_Coverage, 18723,
     /* 1446997 */     GIR_EraseRootFromParent_Done,
     /* 1446998 */   // Label 20206: @1446998
     /* 1446998 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1447080), // Rule ID 18726 //
     /* 1447003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1447006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1447020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1447023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447042 */     // MIs[0] round
     /* 1447042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447045 */     // MIs[0] policy
     /* 1447045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447055 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1447058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447066 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447079 */     // GIR_Coverage, 18726,
     /* 1447079 */     GIR_EraseRootFromParent_Done,
     /* 1447080 */   // Label 20207: @1447080
     /* 1447080 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1447162), // Rule ID 18727 //
     /* 1447085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1447088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1447102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1447105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447124 */     // MIs[0] round
     /* 1447124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447127 */     // MIs[0] policy
     /* 1447127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447137 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1447140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447161 */     // GIR_Coverage, 18727,
     /* 1447161 */     GIR_EraseRootFromParent_Done,
     /* 1447162 */   // Label 20208: @1447162
     /* 1447162 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1447244), // Rule ID 18730 //
     /* 1447167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1447170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1447178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1447181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1447184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1447187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447206 */     // MIs[0] round
     /* 1447206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447209 */     // MIs[0] policy
     /* 1447209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447219 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1447222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447243 */     // GIR_Coverage, 18730,
     /* 1447243 */     GIR_EraseRootFromParent_Done,
     /* 1447244 */   // Label 20209: @1447244
     /* 1447244 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1447326), // Rule ID 18731 //
     /* 1447249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1447252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1447260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1447263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1447266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1447269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447288 */     // MIs[0] round
     /* 1447288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447291 */     // MIs[0] policy
     /* 1447291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447301 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1447304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447312 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447325 */     // GIR_Coverage, 18731,
     /* 1447325 */     GIR_EraseRootFromParent_Done,
     /* 1447326 */   // Label 20210: @1447326
     /* 1447326 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1447408), // Rule ID 18734 //
     /* 1447331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1447334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1447342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1447345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1447348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1447351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447370 */     // MIs[0] round
     /* 1447370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447373 */     // MIs[0] policy
     /* 1447373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447383 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1447386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447407 */     // GIR_Coverage, 18734,
     /* 1447407 */     GIR_EraseRootFromParent_Done,
     /* 1447408 */   // Label 20211: @1447408
     /* 1447408 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1447490), // Rule ID 18735 //
     /* 1447413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1447416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1447424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1447427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1447430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1447433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447452 */     // MIs[0] round
     /* 1447452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447455 */     // MIs[0] policy
     /* 1447455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447465 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1447468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447489 */     // GIR_Coverage, 18735,
     /* 1447489 */     GIR_EraseRootFromParent_Done,
     /* 1447490 */   // Label 20212: @1447490
     /* 1447490 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1447572), // Rule ID 18738 //
     /* 1447495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1447498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1447506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1447509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1447512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1447515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447534 */     // MIs[0] round
     /* 1447534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447537 */     // MIs[0] policy
     /* 1447537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447547 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1447550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447558 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447571 */     // GIR_Coverage, 18738,
     /* 1447571 */     GIR_EraseRootFromParent_Done,
     /* 1447572 */   // Label 20213: @1447572
     /* 1447572 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1447654), // Rule ID 18739 //
     /* 1447577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1447580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1447588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1447591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1447594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1447597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447616 */     // MIs[0] round
     /* 1447616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447619 */     // MIs[0] policy
     /* 1447619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447629 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1447632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447640 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447653 */     // GIR_Coverage, 18739,
     /* 1447653 */     GIR_EraseRootFromParent_Done,
     /* 1447654 */   // Label 20214: @1447654
     /* 1447654 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1447736), // Rule ID 18742 //
     /* 1447659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1447662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1447670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1447673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1447676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1447679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1447694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447698 */     // MIs[0] round
     /* 1447698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447701 */     // MIs[0] policy
     /* 1447701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447711 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1447714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447722 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447735 */     // GIR_Coverage, 18742,
     /* 1447735 */     GIR_EraseRootFromParent_Done,
     /* 1447736 */   // Label 20215: @1447736
     /* 1447736 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1447818), // Rule ID 18743 //
     /* 1447741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1447744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1447752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1447755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1447758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1447761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1447776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447780 */     // MIs[0] round
     /* 1447780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447783 */     // MIs[0] policy
     /* 1447783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447793 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1447796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447817 */     // GIR_Coverage, 18743,
     /* 1447817 */     GIR_EraseRootFromParent_Done,
     /* 1447818 */   // Label 20216: @1447818
     /* 1447818 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1447900), // Rule ID 18746 //
     /* 1447823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1447826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1447834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1447837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1447840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1447843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1447858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447862 */     // MIs[0] round
     /* 1447862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447865 */     // MIs[0] policy
     /* 1447865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447875 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1447878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447899 */     // GIR_Coverage, 18746,
     /* 1447899 */     GIR_EraseRootFromParent_Done,
     /* 1447900 */   // Label 20217: @1447900
     /* 1447900 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1447982), // Rule ID 18747 //
     /* 1447905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1447908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1447916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1447919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1447922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1447925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1447940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447944 */     // MIs[0] round
     /* 1447944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1447947 */     // MIs[0] policy
     /* 1447947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10994:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1447960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1447964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1447968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1447970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447981 */     // GIR_Coverage, 18747,
     /* 1447981 */     GIR_EraseRootFromParent_Done,
     /* 1447982 */   // Label 20218: @1447982
     /* 1447982 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1448064), // Rule ID 18750 //
     /* 1447987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1447990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1447995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1447998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1448007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448026 */     // MIs[0] round
     /* 1448026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448029 */     // MIs[0] policy
     /* 1448029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1448042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448050 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448063 */     // GIR_Coverage, 18750,
     /* 1448063 */     GIR_EraseRootFromParent_Done,
     /* 1448064 */   // Label 20219: @1448064
     /* 1448064 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1448146), // Rule ID 18751 //
     /* 1448069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1448072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1448089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448108 */     // MIs[0] round
     /* 1448108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448111 */     // MIs[0] policy
     /* 1448111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1448124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448145 */     // GIR_Coverage, 18751,
     /* 1448145 */     GIR_EraseRootFromParent_Done,
     /* 1448146 */   // Label 20220: @1448146
     /* 1448146 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1448228), // Rule ID 18754 //
     /* 1448151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1448154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1448171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448190 */     // MIs[0] round
     /* 1448190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448193 */     // MIs[0] policy
     /* 1448193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448203 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1448206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448214 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448227 */     // GIR_Coverage, 18754,
     /* 1448227 */     GIR_EraseRootFromParent_Done,
     /* 1448228 */   // Label 20221: @1448228
     /* 1448228 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1448310), // Rule ID 18755 //
     /* 1448233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1448236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1448253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448272 */     // MIs[0] round
     /* 1448272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448275 */     // MIs[0] policy
     /* 1448275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448285 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1448288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448309 */     // GIR_Coverage, 18755,
     /* 1448309 */     GIR_EraseRootFromParent_Done,
     /* 1448310 */   // Label 20222: @1448310
     /* 1448310 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1448392), // Rule ID 18758 //
     /* 1448315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1448318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1448335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448354 */     // MIs[0] round
     /* 1448354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448357 */     // MIs[0] policy
     /* 1448357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448367 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1448370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448391 */     // GIR_Coverage, 18758,
     /* 1448391 */     GIR_EraseRootFromParent_Done,
     /* 1448392 */   // Label 20223: @1448392
     /* 1448392 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1448474), // Rule ID 18759 //
     /* 1448397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1448400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1448414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1448417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1448432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448436 */     // MIs[0] round
     /* 1448436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448439 */     // MIs[0] policy
     /* 1448439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448449 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1448452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448473 */     // GIR_Coverage, 18759,
     /* 1448473 */     GIR_EraseRootFromParent_Done,
     /* 1448474 */   // Label 20224: @1448474
     /* 1448474 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1448556), // Rule ID 18762 //
     /* 1448479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1448482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1448499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448518 */     // MIs[0] round
     /* 1448518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448521 */     // MIs[0] policy
     /* 1448521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448531 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1448534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448555 */     // GIR_Coverage, 18762,
     /* 1448555 */     GIR_EraseRootFromParent_Done,
     /* 1448556 */   // Label 20225: @1448556
     /* 1448556 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1448638), // Rule ID 18763 //
     /* 1448561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1448564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1448581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448600 */     // MIs[0] round
     /* 1448600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448603 */     // MIs[0] policy
     /* 1448603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448613 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10994:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1448616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448624 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448637 */     // GIR_Coverage, 18763,
     /* 1448637 */     GIR_EraseRootFromParent_Done,
     /* 1448638 */   // Label 20226: @1448638
     /* 1448638 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1448720), // Rule ID 18766 //
     /* 1448643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1448646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1448663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448682 */     // MIs[0] round
     /* 1448682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448685 */     // MIs[0] policy
     /* 1448685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1448698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448719 */     // GIR_Coverage, 18766,
     /* 1448719 */     GIR_EraseRootFromParent_Done,
     /* 1448720 */   // Label 20227: @1448720
     /* 1448720 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1448802), // Rule ID 18767 //
     /* 1448725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1448728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1448745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448764 */     // MIs[0] round
     /* 1448764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448767 */     // MIs[0] policy
     /* 1448767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10994:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1448780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448801 */     // GIR_Coverage, 18767,
     /* 1448801 */     GIR_EraseRootFromParent_Done,
     /* 1448802 */   // Label 20228: @1448802
     /* 1448802 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1448884), // Rule ID 18770 //
     /* 1448807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1448810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1448827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448846 */     // MIs[0] round
     /* 1448846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448849 */     // MIs[0] policy
     /* 1448849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448859 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1448862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448870 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448883 */     // GIR_Coverage, 18770,
     /* 1448883 */     GIR_EraseRootFromParent_Done,
     /* 1448884 */   // Label 20229: @1448884
     /* 1448884 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1448966), // Rule ID 18771 //
     /* 1448889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1448892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1448909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1448924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448928 */     // MIs[0] round
     /* 1448928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1448931 */     // MIs[0] policy
     /* 1448931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448941 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10994:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1448944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1448948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1448952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1448954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448965 */     // GIR_Coverage, 18771,
     /* 1448965 */     GIR_EraseRootFromParent_Done,
     /* 1448966 */   // Label 20230: @1448966
     /* 1448966 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1449048), // Rule ID 18774 //
     /* 1448971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1448974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1448979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1448982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1448985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1448988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1448991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1449006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449010 */     // MIs[0] round
     /* 1449010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449013 */     // MIs[0] policy
     /* 1449013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449023 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1449026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449034 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449047 */     // GIR_Coverage, 18774,
     /* 1449047 */     GIR_EraseRootFromParent_Done,
     /* 1449048 */   // Label 20231: @1449048
     /* 1449048 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1449130), // Rule ID 18775 //
     /* 1449053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1449056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1449061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1449070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1449073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1449088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449092 */     // MIs[0] round
     /* 1449092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449095 */     // MIs[0] policy
     /* 1449095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449105 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10994:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1449108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449116 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449129 */     // GIR_Coverage, 18775,
     /* 1449129 */     GIR_EraseRootFromParent_Done,
     /* 1449130 */   // Label 20232: @1449130
     /* 1449130 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1449212), // Rule ID 18778 //
     /* 1449135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1449138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1449146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1449149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1449155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449174 */     // MIs[0] round
     /* 1449174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449177 */     // MIs[0] policy
     /* 1449177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449187 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1449190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449198 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449211 */     // GIR_Coverage, 18778,
     /* 1449211 */     GIR_EraseRootFromParent_Done,
     /* 1449212 */   // Label 20233: @1449212
     /* 1449212 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1449294), // Rule ID 18779 //
     /* 1449217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1449220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1449228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1449231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1449237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449256 */     // MIs[0] round
     /* 1449256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449259 */     // MIs[0] policy
     /* 1449259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449269 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1449272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449280 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449293 */     // GIR_Coverage, 18779,
     /* 1449293 */     GIR_EraseRootFromParent_Done,
     /* 1449294 */   // Label 20234: @1449294
     /* 1449294 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1449376), // Rule ID 18782 //
     /* 1449299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1449302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1449310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1449313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1449319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449338 */     // MIs[0] round
     /* 1449338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449341 */     // MIs[0] policy
     /* 1449341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449351 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1449354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449362 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449375 */     // GIR_Coverage, 18782,
     /* 1449375 */     GIR_EraseRootFromParent_Done,
     /* 1449376 */   // Label 20235: @1449376
     /* 1449376 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1449458), // Rule ID 18783 //
     /* 1449381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1449384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1449392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1449395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1449401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449420 */     // MIs[0] round
     /* 1449420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449423 */     // MIs[0] policy
     /* 1449423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449433 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1449436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449457 */     // GIR_Coverage, 18783,
     /* 1449457 */     GIR_EraseRootFromParent_Done,
     /* 1449458 */   // Label 20236: @1449458
     /* 1449458 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1449540), // Rule ID 18786 //
     /* 1449463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1449466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1449474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1449477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1449480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1449483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449502 */     // MIs[0] round
     /* 1449502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449505 */     // MIs[0] policy
     /* 1449505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449515 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1449518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449539 */     // GIR_Coverage, 18786,
     /* 1449539 */     GIR_EraseRootFromParent_Done,
     /* 1449540 */   // Label 20237: @1449540
     /* 1449540 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1449622), // Rule ID 18787 //
     /* 1449545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1449548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1449556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1449559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1449562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1449565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449584 */     // MIs[0] round
     /* 1449584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449587 */     // MIs[0] policy
     /* 1449587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449597 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1449600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449621 */     // GIR_Coverage, 18787,
     /* 1449621 */     GIR_EraseRootFromParent_Done,
     /* 1449622 */   // Label 20238: @1449622
     /* 1449622 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1449704), // Rule ID 18790 //
     /* 1449627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1449630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1449638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1449641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1449647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449666 */     // MIs[0] round
     /* 1449666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449669 */     // MIs[0] policy
     /* 1449669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449679 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1449682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449690 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449703 */     // GIR_Coverage, 18790,
     /* 1449703 */     GIR_EraseRootFromParent_Done,
     /* 1449704 */   // Label 20239: @1449704
     /* 1449704 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1449786), // Rule ID 18791 //
     /* 1449709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1449712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1449720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1449723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1449729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449748 */     // MIs[0] round
     /* 1449748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449751 */     // MIs[0] policy
     /* 1449751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449761 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1449764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449772 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449785 */     // GIR_Coverage, 18791,
     /* 1449785 */     GIR_EraseRootFromParent_Done,
     /* 1449786 */   // Label 20240: @1449786
     /* 1449786 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1449868), // Rule ID 18794 //
     /* 1449791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1449794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1449802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1449805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1449811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449830 */     // MIs[0] round
     /* 1449830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449833 */     // MIs[0] policy
     /* 1449833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449843 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1449846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449854 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449867 */     // GIR_Coverage, 18794,
     /* 1449867 */     GIR_EraseRootFromParent_Done,
     /* 1449868 */   // Label 20241: @1449868
     /* 1449868 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1449950), // Rule ID 18795 //
     /* 1449873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1449876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1449884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1449887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1449893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449912 */     // MIs[0] round
     /* 1449912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449915 */     // MIs[0] policy
     /* 1449915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449925 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1449928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1449932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1449936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1449938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449949 */     // GIR_Coverage, 18795,
     /* 1449949 */     GIR_EraseRootFromParent_Done,
     /* 1449950 */   // Label 20242: @1449950
     /* 1449950 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1450032), // Rule ID 18798 //
     /* 1449955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1449958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1449963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1449966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1449969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1449972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1449975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449994 */     // MIs[0] round
     /* 1449994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1449997 */     // MIs[0] policy
     /* 1449997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450007 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1450010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450018 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450031 */     // GIR_Coverage, 18798,
     /* 1450031 */     GIR_EraseRootFromParent_Done,
     /* 1450032 */   // Label 20243: @1450032
     /* 1450032 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1450114), // Rule ID 18799 //
     /* 1450037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1450040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1450048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1450051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1450057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450076 */     // MIs[0] round
     /* 1450076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450079 */     // MIs[0] policy
     /* 1450079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450089 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1450092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450113 */     // GIR_Coverage, 18799,
     /* 1450113 */     GIR_EraseRootFromParent_Done,
     /* 1450114 */   // Label 20244: @1450114
     /* 1450114 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1450196), // Rule ID 18802 //
     /* 1450119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1450122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1450139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450158 */     // MIs[0] round
     /* 1450158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450161 */     // MIs[0] policy
     /* 1450161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450171 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1450174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450182 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450195 */     // GIR_Coverage, 18802,
     /* 1450195 */     GIR_EraseRootFromParent_Done,
     /* 1450196 */   // Label 20245: @1450196
     /* 1450196 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1450278), // Rule ID 18803 //
     /* 1450201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1450204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1450221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450240 */     // MIs[0] round
     /* 1450240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450243 */     // MIs[0] policy
     /* 1450243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450253 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1450256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450277 */     // GIR_Coverage, 18803,
     /* 1450277 */     GIR_EraseRootFromParent_Done,
     /* 1450278 */   // Label 20246: @1450278
     /* 1450278 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1450360), // Rule ID 18806 //
     /* 1450283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1450286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1450300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1450303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450322 */     // MIs[0] round
     /* 1450322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450325 */     // MIs[0] policy
     /* 1450325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450335 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1450338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450346 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450359 */     // GIR_Coverage, 18806,
     /* 1450359 */     GIR_EraseRootFromParent_Done,
     /* 1450360 */   // Label 20247: @1450360
     /* 1450360 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1450442), // Rule ID 18807 //
     /* 1450365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1450368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1450382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1450385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450404 */     // MIs[0] round
     /* 1450404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450407 */     // MIs[0] policy
     /* 1450407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450417 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1450420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450441 */     // GIR_Coverage, 18807,
     /* 1450441 */     GIR_EraseRootFromParent_Done,
     /* 1450442 */   // Label 20248: @1450442
     /* 1450442 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1450524), // Rule ID 18810 //
     /* 1450447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1450450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1450458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1450461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1450467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450486 */     // MIs[0] round
     /* 1450486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450489 */     // MIs[0] policy
     /* 1450489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450499 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1450502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450523 */     // GIR_Coverage, 18810,
     /* 1450523 */     GIR_EraseRootFromParent_Done,
     /* 1450524 */   // Label 20249: @1450524
     /* 1450524 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1450606), // Rule ID 18811 //
     /* 1450529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1450532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1450540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1450543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1450549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450568 */     // MIs[0] round
     /* 1450568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450571 */     // MIs[0] policy
     /* 1450571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450581 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1450584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450605 */     // GIR_Coverage, 18811,
     /* 1450605 */     GIR_EraseRootFromParent_Done,
     /* 1450606 */   // Label 20250: @1450606
     /* 1450606 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1450688), // Rule ID 18814 //
     /* 1450611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1450614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1450628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1450631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1450646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450650 */     // MIs[0] round
     /* 1450650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450653 */     // MIs[0] policy
     /* 1450653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450663 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1450666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450674 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450687 */     // GIR_Coverage, 18814,
     /* 1450687 */     GIR_EraseRootFromParent_Done,
     /* 1450688 */   // Label 20251: @1450688
     /* 1450688 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1450770), // Rule ID 18815 //
     /* 1450693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1450696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1450710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1450713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1450728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450732 */     // MIs[0] round
     /* 1450732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450735 */     // MIs[0] policy
     /* 1450735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450745 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1450748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450769 */     // GIR_Coverage, 18815,
     /* 1450769 */     GIR_EraseRootFromParent_Done,
     /* 1450770 */   // Label 20252: @1450770
     /* 1450770 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1450852), // Rule ID 18818 //
     /* 1450775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1450778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1450792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1450795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1450810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450814 */     // MIs[0] round
     /* 1450814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450817 */     // MIs[0] policy
     /* 1450817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1450830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450838 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450851 */     // GIR_Coverage, 18818,
     /* 1450851 */     GIR_EraseRootFromParent_Done,
     /* 1450852 */   // Label 20253: @1450852
     /* 1450852 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1450934), // Rule ID 18819 //
     /* 1450857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1450860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1450874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1450877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1450892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450896 */     // MIs[0] round
     /* 1450896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450899 */     // MIs[0] policy
     /* 1450899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450909 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11000:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1450912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1450920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1450922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450933 */     // GIR_Coverage, 18819,
     /* 1450933 */     GIR_EraseRootFromParent_Done,
     /* 1450934 */   // Label 20254: @1450934
     /* 1450934 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1451016), // Rule ID 18822 //
     /* 1450939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1450942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1450947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1450950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1450953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1450956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1450959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1450974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450978 */     // MIs[0] round
     /* 1450978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1450981 */     // MIs[0] policy
     /* 1450981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1450994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1450998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451015 */     // GIR_Coverage, 18822,
     /* 1451015 */     GIR_EraseRootFromParent_Done,
     /* 1451016 */   // Label 20255: @1451016
     /* 1451016 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1451098), // Rule ID 18823 //
     /* 1451021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1451024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1451032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1451035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1451038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1451041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1451056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451060 */     // MIs[0] round
     /* 1451060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451063 */     // MIs[0] policy
     /* 1451063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451073 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1451076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451097 */     // GIR_Coverage, 18823,
     /* 1451097 */     GIR_EraseRootFromParent_Done,
     /* 1451098 */   // Label 20256: @1451098
     /* 1451098 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1451180), // Rule ID 18826 //
     /* 1451103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1451106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1451114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1451117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1451120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1451123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1451138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451142 */     // MIs[0] round
     /* 1451142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451145 */     // MIs[0] policy
     /* 1451145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451155 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1451158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451179 */     // GIR_Coverage, 18826,
     /* 1451179 */     GIR_EraseRootFromParent_Done,
     /* 1451180 */   // Label 20257: @1451180
     /* 1451180 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1451262), // Rule ID 18827 //
     /* 1451185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1451188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1451196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1451199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1451202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1451205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1451220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451224 */     // MIs[0] round
     /* 1451224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451227 */     // MIs[0] policy
     /* 1451227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451237 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1451240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451261 */     // GIR_Coverage, 18827,
     /* 1451261 */     GIR_EraseRootFromParent_Done,
     /* 1451262 */   // Label 20258: @1451262
     /* 1451262 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1451344), // Rule ID 18830 //
     /* 1451267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1451270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1451278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1451281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1451284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1451287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1451302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451306 */     // MIs[0] round
     /* 1451306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451309 */     // MIs[0] policy
     /* 1451309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451319 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1451322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451330 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451343 */     // GIR_Coverage, 18830,
     /* 1451343 */     GIR_EraseRootFromParent_Done,
     /* 1451344 */   // Label 20259: @1451344
     /* 1451344 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1451426), // Rule ID 18831 //
     /* 1451349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1451352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1451360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1451363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1451366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1451369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1451384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451388 */     // MIs[0] round
     /* 1451388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451391 */     // MIs[0] policy
     /* 1451391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451401 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1451404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451425 */     // GIR_Coverage, 18831,
     /* 1451425 */     GIR_EraseRootFromParent_Done,
     /* 1451426 */   // Label 20260: @1451426
     /* 1451426 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1451508), // Rule ID 18834 //
     /* 1451431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1451434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1451451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451470 */     // MIs[0] round
     /* 1451470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451473 */     // MIs[0] policy
     /* 1451473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451483 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1451486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451494 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451507 */     // GIR_Coverage, 18834,
     /* 1451507 */     GIR_EraseRootFromParent_Done,
     /* 1451508 */   // Label 20261: @1451508
     /* 1451508 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1451590), // Rule ID 18835 //
     /* 1451513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1451516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1451533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451552 */     // MIs[0] round
     /* 1451552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451555 */     // MIs[0] policy
     /* 1451555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451565 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11000:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1451568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451589 */     // GIR_Coverage, 18835,
     /* 1451589 */     GIR_EraseRootFromParent_Done,
     /* 1451590 */   // Label 20262: @1451590
     /* 1451590 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1451672), // Rule ID 18838 //
     /* 1451595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1451598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1451606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1451609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1451615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451634 */     // MIs[0] round
     /* 1451634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451637 */     // MIs[0] policy
     /* 1451637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451647 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1451650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451658 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451671 */     // GIR_Coverage, 18838,
     /* 1451671 */     GIR_EraseRootFromParent_Done,
     /* 1451672 */   // Label 20263: @1451672
     /* 1451672 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1451754), // Rule ID 18839 //
     /* 1451677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1451680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1451688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1451691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1451697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451716 */     // MIs[0] round
     /* 1451716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451719 */     // MIs[0] policy
     /* 1451719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11000:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1451732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451740 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451753 */     // GIR_Coverage, 18839,
     /* 1451753 */     GIR_EraseRootFromParent_Done,
     /* 1451754 */   // Label 20264: @1451754
     /* 1451754 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1451836), // Rule ID 18842 //
     /* 1451759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1451762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1451770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1451773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1451779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451798 */     // MIs[0] round
     /* 1451798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451801 */     // MIs[0] policy
     /* 1451801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451811 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1451814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451835 */     // GIR_Coverage, 18842,
     /* 1451835 */     GIR_EraseRootFromParent_Done,
     /* 1451836 */   // Label 20265: @1451836
     /* 1451836 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1451918), // Rule ID 18843 //
     /* 1451841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1451844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1451852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1451855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1451861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451880 */     // MIs[0] round
     /* 1451880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451883 */     // MIs[0] policy
     /* 1451883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451893 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11000:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1451896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451917 */     // GIR_Coverage, 18843,
     /* 1451917 */     GIR_EraseRootFromParent_Done,
     /* 1451918 */   // Label 20266: @1451918
     /* 1451918 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1452000), // Rule ID 18846 //
     /* 1451923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1451926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1451931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1451934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1451937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1451940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1451943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1451958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451962 */     // MIs[0] round
     /* 1451962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1451965 */     // MIs[0] policy
     /* 1451965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1451978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1451982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1451986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1451988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451999 */     // GIR_Coverage, 18846,
     /* 1451999 */     GIR_EraseRootFromParent_Done,
     /* 1452000 */   // Label 20267: @1452000
     /* 1452000 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1452082), // Rule ID 18847 //
     /* 1452005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1452008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1452013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1452016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1452019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1452022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1452025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1452040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452044 */     // MIs[0] round
     /* 1452044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452047 */     // MIs[0] policy
     /* 1452047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452057 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11000:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1452060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1452064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1452068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452081 */     // GIR_Coverage, 18847,
     /* 1452081 */     GIR_EraseRootFromParent_Done,
     /* 1452082 */   // Label 20268: @1452082
     /* 1452082 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1452164), // Rule ID 18852 //
     /* 1452087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1452090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1452104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1452107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452126 */     // MIs[0] round
     /* 1452126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452129 */     // MIs[0] policy
     /* 1452129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452139 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1452142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452163 */     // GIR_Coverage, 18852,
     /* 1452163 */     GIR_EraseRootFromParent_Done,
     /* 1452164 */   // Label 20269: @1452164
     /* 1452164 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1452246), // Rule ID 18853 //
     /* 1452169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1452172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1452186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1452189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452208 */     // MIs[0] round
     /* 1452208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452211 */     // MIs[0] policy
     /* 1452211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452221 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1452224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452245 */     // GIR_Coverage, 18853,
     /* 1452245 */     GIR_EraseRootFromParent_Done,
     /* 1452246 */   // Label 20270: @1452246
     /* 1452246 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1452328), // Rule ID 18856 //
     /* 1452251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1452254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1452262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1452265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1452271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452290 */     // MIs[0] round
     /* 1452290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452293 */     // MIs[0] policy
     /* 1452293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452303 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1452306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452314 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452327 */     // GIR_Coverage, 18856,
     /* 1452327 */     GIR_EraseRootFromParent_Done,
     /* 1452328 */   // Label 20271: @1452328
     /* 1452328 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1452410), // Rule ID 18857 //
     /* 1452333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1452336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1452344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1452347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1452353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452372 */     // MIs[0] round
     /* 1452372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452375 */     // MIs[0] policy
     /* 1452375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452385 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1452388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452396 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452409 */     // GIR_Coverage, 18857,
     /* 1452409 */     GIR_EraseRootFromParent_Done,
     /* 1452410 */   // Label 20272: @1452410
     /* 1452410 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1452492), // Rule ID 18860 //
     /* 1452415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1452418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1452432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1452435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452454 */     // MIs[0] round
     /* 1452454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452457 */     // MIs[0] policy
     /* 1452457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452467 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1452470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452478 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452491 */     // GIR_Coverage, 18860,
     /* 1452491 */     GIR_EraseRootFromParent_Done,
     /* 1452492 */   // Label 20273: @1452492
     /* 1452492 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1452574), // Rule ID 18861 //
     /* 1452497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1452500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1452514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1452517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452536 */     // MIs[0] round
     /* 1452536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452539 */     // MIs[0] policy
     /* 1452539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10967:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1452552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452560 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452573 */     // GIR_Coverage, 18861,
     /* 1452573 */     GIR_EraseRootFromParent_Done,
     /* 1452574 */   // Label 20274: @1452574
     /* 1452574 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1452656), // Rule ID 18864 //
     /* 1452579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1452582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1452590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1452593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1452599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452618 */     // MIs[0] round
     /* 1452618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452621 */     // MIs[0] policy
     /* 1452621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452631 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10967:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1452634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452655 */     // GIR_Coverage, 18864,
     /* 1452655 */     GIR_EraseRootFromParent_Done,
     /* 1452656 */   // Label 20275: @1452656
     /* 1452656 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1452738), // Rule ID 18865 //
     /* 1452661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1452664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1452672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1452675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1452681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452700 */     // MIs[0] round
     /* 1452700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452703 */     // MIs[0] policy
     /* 1452703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452713 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10967:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1452716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452737 */     // GIR_Coverage, 18865,
     /* 1452737 */     GIR_EraseRootFromParent_Done,
     /* 1452738 */   // Label 20276: @1452738
     /* 1452738 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1452820), // Rule ID 18868 //
     /* 1452743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1452746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1452754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1452757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1452760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1452763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452782 */     // MIs[0] round
     /* 1452782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452785 */     // MIs[0] policy
     /* 1452785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452795 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1452798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452819 */     // GIR_Coverage, 18868,
     /* 1452819 */     GIR_EraseRootFromParent_Done,
     /* 1452820 */   // Label 20277: @1452820
     /* 1452820 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1452902), // Rule ID 18869 //
     /* 1452825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1452828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1452836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1452839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1452842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1452845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452864 */     // MIs[0] round
     /* 1452864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452867 */     // MIs[0] policy
     /* 1452867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10967:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1452880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452888 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452901 */     // GIR_Coverage, 18869,
     /* 1452901 */     GIR_EraseRootFromParent_Done,
     /* 1452902 */   // Label 20278: @1452902
     /* 1452902 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1452984), // Rule ID 18872 //
     /* 1452907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1452910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1452924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1452927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452946 */     // MIs[0] round
     /* 1452946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1452949 */     // MIs[0] policy
     /* 1452949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1452962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1452968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1452970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1452972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452983 */     // GIR_Coverage, 18872,
     /* 1452983 */     GIR_EraseRootFromParent_Done,
     /* 1452984 */   // Label 20279: @1452984
     /* 1452984 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1453066), // Rule ID 18873 //
     /* 1452989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1452992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1452997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1453000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1453003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1453006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1453009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453028 */     // MIs[0] round
     /* 1453028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453031 */     // MIs[0] policy
     /* 1453031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1453044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453052 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453065 */     // GIR_Coverage, 18873,
     /* 1453065 */     GIR_EraseRootFromParent_Done,
     /* 1453066 */   // Label 20280: @1453066
     /* 1453066 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1453148), // Rule ID 18876 //
     /* 1453071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1453074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1453082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1453085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1453088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1453091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453110 */     // MIs[0] round
     /* 1453110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453113 */     // MIs[0] policy
     /* 1453113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453123 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1453126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453134 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453147 */     // GIR_Coverage, 18876,
     /* 1453147 */     GIR_EraseRootFromParent_Done,
     /* 1453148 */   // Label 20281: @1453148
     /* 1453148 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1453230), // Rule ID 18877 //
     /* 1453153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1453156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1453164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1453167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1453170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1453173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453192 */     // MIs[0] round
     /* 1453192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453195 */     // MIs[0] policy
     /* 1453195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453205 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1453208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453216 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453229 */     // GIR_Coverage, 18877,
     /* 1453229 */     GIR_EraseRootFromParent_Done,
     /* 1453230 */   // Label 20282: @1453230
     /* 1453230 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1453312), // Rule ID 18880 //
     /* 1453235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1453238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1453246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1453249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1453252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1453255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453274 */     // MIs[0] round
     /* 1453274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453277 */     // MIs[0] policy
     /* 1453277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453287 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1453290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453311 */     // GIR_Coverage, 18880,
     /* 1453311 */     GIR_EraseRootFromParent_Done,
     /* 1453312 */   // Label 20283: @1453312
     /* 1453312 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1453394), // Rule ID 18881 //
     /* 1453317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1453320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1453328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1453331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1453334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1453337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453356 */     // MIs[0] round
     /* 1453356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453359 */     // MIs[0] policy
     /* 1453359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453369 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1453372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453380 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453393 */     // GIR_Coverage, 18881,
     /* 1453393 */     GIR_EraseRootFromParent_Done,
     /* 1453394 */   // Label 20284: @1453394
     /* 1453394 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1453476), // Rule ID 18884 //
     /* 1453399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1453402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1453410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1453413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1453416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1453419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453438 */     // MIs[0] round
     /* 1453438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453441 */     // MIs[0] policy
     /* 1453441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1453454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453475 */     // GIR_Coverage, 18884,
     /* 1453475 */     GIR_EraseRootFromParent_Done,
     /* 1453476 */   // Label 20285: @1453476
     /* 1453476 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1453558), // Rule ID 18885 //
     /* 1453481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1453484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1453492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1453495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1453498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1453501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453520 */     // MIs[0] round
     /* 1453520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453523 */     // MIs[0] policy
     /* 1453523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1453536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453544 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453557 */     // GIR_Coverage, 18885,
     /* 1453557 */     GIR_EraseRootFromParent_Done,
     /* 1453558 */   // Label 20286: @1453558
     /* 1453558 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1453640), // Rule ID 18888 //
     /* 1453563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1453566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1453580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1453583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453602 */     // MIs[0] round
     /* 1453602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453605 */     // MIs[0] policy
     /* 1453605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453615 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1453618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453639 */     // GIR_Coverage, 18888,
     /* 1453639 */     GIR_EraseRootFromParent_Done,
     /* 1453640 */   // Label 20287: @1453640
     /* 1453640 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1453722), // Rule ID 18889 //
     /* 1453645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1453648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1453662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1453665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453684 */     // MIs[0] round
     /* 1453684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453687 */     // MIs[0] policy
     /* 1453687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453697 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1453700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453708 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453721 */     // GIR_Coverage, 18889,
     /* 1453721 */     GIR_EraseRootFromParent_Done,
     /* 1453722 */   // Label 20288: @1453722
     /* 1453722 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1453804), // Rule ID 18892 //
     /* 1453727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1453730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1453747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453766 */     // MIs[0] round
     /* 1453766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453769 */     // MIs[0] policy
     /* 1453769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453779 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1453782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453803 */     // GIR_Coverage, 18892,
     /* 1453803 */     GIR_EraseRootFromParent_Done,
     /* 1453804 */   // Label 20289: @1453804
     /* 1453804 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1453886), // Rule ID 18893 //
     /* 1453809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1453812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1453829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453848 */     // MIs[0] round
     /* 1453848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453851 */     // MIs[0] policy
     /* 1453851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453861 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1453864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453872 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453885 */     // GIR_Coverage, 18893,
     /* 1453885 */     GIR_EraseRootFromParent_Done,
     /* 1453886 */   // Label 20290: @1453886
     /* 1453886 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1453968), // Rule ID 18896 //
     /* 1453891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1453894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1453911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453930 */     // MIs[0] round
     /* 1453930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1453933 */     // MIs[0] policy
     /* 1453933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453943 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1453946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1453952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1453954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1453956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453967 */     // GIR_Coverage, 18896,
     /* 1453967 */     GIR_EraseRootFromParent_Done,
     /* 1453968 */   // Label 20291: @1453968
     /* 1453968 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1454050), // Rule ID 18897 //
     /* 1453973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1453976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1453981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1453993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454012 */     // MIs[0] round
     /* 1454012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454015 */     // MIs[0] policy
     /* 1454015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454025 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10967:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1454028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454036 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454049 */     // GIR_Coverage, 18897,
     /* 1454049 */     GIR_EraseRootFromParent_Done,
     /* 1454050 */   // Label 20292: @1454050
     /* 1454050 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1454132), // Rule ID 18900 //
     /* 1454055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1454058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1454063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1454066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1454069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1454072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1454075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1454082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454094 */     // MIs[0] round
     /* 1454094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454097 */     // MIs[0] policy
     /* 1454097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454107 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1454110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454118 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454131 */     // GIR_Coverage, 18900,
     /* 1454131 */     GIR_EraseRootFromParent_Done,
     /* 1454132 */   // Label 20293: @1454132
     /* 1454132 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1454214), // Rule ID 18901 //
     /* 1454137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1454140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1454145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1454148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1454151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1454154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1454157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1454164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454176 */     // MIs[0] round
     /* 1454176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454179 */     // MIs[0] policy
     /* 1454179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454189 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10967:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1454192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454213 */     // GIR_Coverage, 18901,
     /* 1454213 */     GIR_EraseRootFromParent_Done,
     /* 1454214 */   // Label 20294: @1454214
     /* 1454214 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1454296), // Rule ID 18904 //
     /* 1454219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1454222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1454227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1454230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1454233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1454236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1454239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454258 */     // MIs[0] round
     /* 1454258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454261 */     // MIs[0] policy
     /* 1454261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454271 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1454274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454295 */     // GIR_Coverage, 18904,
     /* 1454295 */     GIR_EraseRootFromParent_Done,
     /* 1454296 */   // Label 20295: @1454296
     /* 1454296 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1454378), // Rule ID 18905 //
     /* 1454301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1454304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1454309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1454312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1454315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1454318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1454321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454340 */     // MIs[0] round
     /* 1454340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454343 */     // MIs[0] policy
     /* 1454343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454353 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10967:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1454356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454364 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454377 */     // GIR_Coverage, 18905,
     /* 1454377 */     GIR_EraseRootFromParent_Done,
     /* 1454378 */   // Label 20296: @1454378
     /* 1454378 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1454460), // Rule ID 18964 //
     /* 1454383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1454386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1454403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454422 */     // MIs[0] round
     /* 1454422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454425 */     // MIs[0] policy
     /* 1454425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454435 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1454438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454459 */     // GIR_Coverage, 18964,
     /* 1454459 */     GIR_EraseRootFromParent_Done,
     /* 1454460 */   // Label 20297: @1454460
     /* 1454460 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1454542), // Rule ID 18965 //
     /* 1454465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1454468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1454485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454504 */     // MIs[0] round
     /* 1454504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454507 */     // MIs[0] policy
     /* 1454507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454517 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1454520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454541 */     // GIR_Coverage, 18965,
     /* 1454541 */     GIR_EraseRootFromParent_Done,
     /* 1454542 */   // Label 20298: @1454542
     /* 1454542 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1454624), // Rule ID 18968 //
     /* 1454547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1454550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1454567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454586 */     // MIs[0] round
     /* 1454586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454589 */     // MIs[0] policy
     /* 1454589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454599 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1454602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454623 */     // GIR_Coverage, 18968,
     /* 1454623 */     GIR_EraseRootFromParent_Done,
     /* 1454624 */   // Label 20299: @1454624
     /* 1454624 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1454706), // Rule ID 18969 //
     /* 1454629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1454632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1454649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454668 */     // MIs[0] round
     /* 1454668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454671 */     // MIs[0] policy
     /* 1454671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454681 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1454684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454692 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454705 */     // GIR_Coverage, 18969,
     /* 1454705 */     GIR_EraseRootFromParent_Done,
     /* 1454706 */   // Label 20300: @1454706
     /* 1454706 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1454788), // Rule ID 18972 //
     /* 1454711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1454714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1454731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454750 */     // MIs[0] round
     /* 1454750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454753 */     // MIs[0] policy
     /* 1454753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454763 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1454766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454774 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454787 */     // GIR_Coverage, 18972,
     /* 1454787 */     GIR_EraseRootFromParent_Done,
     /* 1454788 */   // Label 20301: @1454788
     /* 1454788 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1454870), // Rule ID 18973 //
     /* 1454793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1454796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1454813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454832 */     // MIs[0] round
     /* 1454832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454835 */     // MIs[0] policy
     /* 1454835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454845 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1454848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454856 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454869 */     // GIR_Coverage, 18973,
     /* 1454869 */     GIR_EraseRootFromParent_Done,
     /* 1454870 */   // Label 20302: @1454870
     /* 1454870 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1454952), // Rule ID 18976 //
     /* 1454875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1454878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1454895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454914 */     // MIs[0] round
     /* 1454914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454917 */     // MIs[0] policy
     /* 1454917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1454930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1454936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1454938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1454940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454951 */     // GIR_Coverage, 18976,
     /* 1454951 */     GIR_EraseRootFromParent_Done,
     /* 1454952 */   // Label 20303: @1454952
     /* 1454952 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1455034), // Rule ID 18977 //
     /* 1454957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1454960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1454965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1454977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454996 */     // MIs[0] round
     /* 1454996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1454999 */     // MIs[0] policy
     /* 1454999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455009 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10943:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1455012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455020 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455033 */     // GIR_Coverage, 18977,
     /* 1455033 */     GIR_EraseRootFromParent_Done,
     /* 1455034 */   // Label 20304: @1455034
     /* 1455034 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1455116), // Rule ID 18980 //
     /* 1455039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1455042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1455059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455078 */     // MIs[0] round
     /* 1455078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455081 */     // MIs[0] policy
     /* 1455081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455091 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10943:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1455094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455102 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455115 */     // GIR_Coverage, 18980,
     /* 1455115 */     GIR_EraseRootFromParent_Done,
     /* 1455116 */   // Label 20305: @1455116
     /* 1455116 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1455198), // Rule ID 18981 //
     /* 1455121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1455124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1455141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455160 */     // MIs[0] round
     /* 1455160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455163 */     // MIs[0] policy
     /* 1455163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455173 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10943:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1455176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455184 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455197 */     // GIR_Coverage, 18981,
     /* 1455197 */     GIR_EraseRootFromParent_Done,
     /* 1455198 */   // Label 20306: @1455198
     /* 1455198 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1455280), // Rule ID 18984 //
     /* 1455203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1455206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1455223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455242 */     // MIs[0] round
     /* 1455242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455245 */     // MIs[0] policy
     /* 1455245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455255 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1455258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455264 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455279 */     // GIR_Coverage, 18984,
     /* 1455279 */     GIR_EraseRootFromParent_Done,
     /* 1455280 */   // Label 20307: @1455280
     /* 1455280 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1455362), // Rule ID 18985 //
     /* 1455285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1455288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1455305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455324 */     // MIs[0] round
     /* 1455324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455327 */     // MIs[0] policy
     /* 1455327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455337 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10943:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1455340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455348 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455361 */     // GIR_Coverage, 18985,
     /* 1455361 */     GIR_EraseRootFromParent_Done,
     /* 1455362 */   // Label 20308: @1455362
     /* 1455362 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1455444), // Rule ID 18988 //
     /* 1455367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1455370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1455384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1455387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455406 */     // MIs[0] round
     /* 1455406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455409 */     // MIs[0] policy
     /* 1455409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455419 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1455422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455443 */     // GIR_Coverage, 18988,
     /* 1455443 */     GIR_EraseRootFromParent_Done,
     /* 1455444 */   // Label 20309: @1455444
     /* 1455444 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1455526), // Rule ID 18989 //
     /* 1455449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1455452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1455466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1455469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455488 */     // MIs[0] round
     /* 1455488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455491 */     // MIs[0] policy
     /* 1455491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455501 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1455504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455512 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455525 */     // GIR_Coverage, 18989,
     /* 1455525 */     GIR_EraseRootFromParent_Done,
     /* 1455526 */   // Label 20310: @1455526
     /* 1455526 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1455608), // Rule ID 18992 //
     /* 1455531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1455534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1455542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1455545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1455548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1455551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455570 */     // MIs[0] round
     /* 1455570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455573 */     // MIs[0] policy
     /* 1455573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455583 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1455586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455594 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455607 */     // GIR_Coverage, 18992,
     /* 1455607 */     GIR_EraseRootFromParent_Done,
     /* 1455608 */   // Label 20311: @1455608
     /* 1455608 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1455690), // Rule ID 18993 //
     /* 1455613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1455616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1455624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1455627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1455630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1455633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455652 */     // MIs[0] round
     /* 1455652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455655 */     // MIs[0] policy
     /* 1455655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455665 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1455668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455676 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455689 */     // GIR_Coverage, 18993,
     /* 1455689 */     GIR_EraseRootFromParent_Done,
     /* 1455690 */   // Label 20312: @1455690
     /* 1455690 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1455772), // Rule ID 18996 //
     /* 1455695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1455698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1455706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1455709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1455712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1455715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455734 */     // MIs[0] round
     /* 1455734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455737 */     // MIs[0] policy
     /* 1455737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455747 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1455750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455771 */     // GIR_Coverage, 18996,
     /* 1455771 */     GIR_EraseRootFromParent_Done,
     /* 1455772 */   // Label 20313: @1455772
     /* 1455772 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1455854), // Rule ID 18997 //
     /* 1455777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1455780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1455788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1455791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1455794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1455797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455816 */     // MIs[0] round
     /* 1455816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455819 */     // MIs[0] policy
     /* 1455819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455829 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1455832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455840 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455853 */     // GIR_Coverage, 18997,
     /* 1455853 */     GIR_EraseRootFromParent_Done,
     /* 1455854 */   // Label 20314: @1455854
     /* 1455854 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1455936), // Rule ID 19000 //
     /* 1455859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1455862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1455870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1455873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1455876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1455879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455898 */     // MIs[0] round
     /* 1455898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455901 */     // MIs[0] policy
     /* 1455901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455911 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1455914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1455920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1455922 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1455924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455935 */     // GIR_Coverage, 19000,
     /* 1455935 */     GIR_EraseRootFromParent_Done,
     /* 1455936 */   // Label 20315: @1455936
     /* 1455936 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1456018), // Rule ID 19001 //
     /* 1455941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1455944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1455949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1455952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1455955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1455958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1455961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455980 */     // MIs[0] round
     /* 1455980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1455983 */     // MIs[0] policy
     /* 1455983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455993 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1455996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456004 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456017 */     // GIR_Coverage, 19001,
     /* 1456017 */     GIR_EraseRootFromParent_Done,
     /* 1456018 */   // Label 20316: @1456018
     /* 1456018 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1456100), // Rule ID 19004 //
     /* 1456023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1456026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1456043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456062 */     // MIs[0] round
     /* 1456062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456065 */     // MIs[0] policy
     /* 1456065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456075 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1456078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456099 */     // GIR_Coverage, 19004,
     /* 1456099 */     GIR_EraseRootFromParent_Done,
     /* 1456100 */   // Label 20317: @1456100
     /* 1456100 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1456182), // Rule ID 19005 //
     /* 1456105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1456108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1456125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456144 */     // MIs[0] round
     /* 1456144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456147 */     // MIs[0] policy
     /* 1456147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456157 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1456160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456168 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456181 */     // GIR_Coverage, 19005,
     /* 1456181 */     GIR_EraseRootFromParent_Done,
     /* 1456182 */   // Label 20318: @1456182
     /* 1456182 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1456264), // Rule ID 19008 //
     /* 1456187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1456190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1456207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456226 */     // MIs[0] round
     /* 1456226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456229 */     // MIs[0] policy
     /* 1456229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456239 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1456242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456263 */     // GIR_Coverage, 19008,
     /* 1456263 */     GIR_EraseRootFromParent_Done,
     /* 1456264 */   // Label 20319: @1456264
     /* 1456264 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1456346), // Rule ID 19009 //
     /* 1456269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1456272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1456289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456308 */     // MIs[0] round
     /* 1456308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456311 */     // MIs[0] policy
     /* 1456311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456321 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1456324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456332 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456345 */     // GIR_Coverage, 19009,
     /* 1456345 */     GIR_EraseRootFromParent_Done,
     /* 1456346 */   // Label 20320: @1456346
     /* 1456346 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1456428), // Rule ID 19012 //
     /* 1456351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1456354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1456362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1456365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1456371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456390 */     // MIs[0] round
     /* 1456390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456393 */     // MIs[0] policy
     /* 1456393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456403 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1456406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456427 */     // GIR_Coverage, 19012,
     /* 1456427 */     GIR_EraseRootFromParent_Done,
     /* 1456428 */   // Label 20321: @1456428
     /* 1456428 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1456510), // Rule ID 19013 //
     /* 1456433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1456436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1456444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1456447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1456453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456472 */     // MIs[0] round
     /* 1456472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456475 */     // MIs[0] policy
     /* 1456475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456485 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10943:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1456488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456494 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456496 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456509 */     // GIR_Coverage, 19013,
     /* 1456509 */     GIR_EraseRootFromParent_Done,
     /* 1456510 */   // Label 20322: @1456510
     /* 1456510 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1456592), // Rule ID 19016 //
     /* 1456515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1456518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1456526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1456529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1456532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1456535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456554 */     // MIs[0] round
     /* 1456554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456557 */     // MIs[0] policy
     /* 1456557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456567 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1456570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456591 */     // GIR_Coverage, 19016,
     /* 1456591 */     GIR_EraseRootFromParent_Done,
     /* 1456592 */   // Label 20323: @1456592
     /* 1456592 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1456674), // Rule ID 19017 //
     /* 1456597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1456600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1456608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1456611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1456614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1456617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456636 */     // MIs[0] round
     /* 1456636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456639 */     // MIs[0] policy
     /* 1456639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456649 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10943:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1456652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456660 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456673 */     // GIR_Coverage, 19017,
     /* 1456673 */     GIR_EraseRootFromParent_Done,
     /* 1456674 */   // Label 20324: @1456674
     /* 1456674 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1456756), // Rule ID 19020 //
     /* 1456679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1456682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1456690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1456693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1456696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1456699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456718 */     // MIs[0] round
     /* 1456718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456721 */     // MIs[0] policy
     /* 1456721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456731 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1456734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456755 */     // GIR_Coverage, 19020,
     /* 1456755 */     GIR_EraseRootFromParent_Done,
     /* 1456756 */   // Label 20325: @1456756
     /* 1456756 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1456838), // Rule ID 19021 //
     /* 1456761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1456764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1456769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1456772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1456775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1456778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1456781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456800 */     // MIs[0] round
     /* 1456800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456803 */     // MIs[0] policy
     /* 1456803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456813 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10943:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1456816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456837 */     // GIR_Coverage, 19021,
     /* 1456837 */     GIR_EraseRootFromParent_Done,
     /* 1456838 */   // Label 20326: @1456838
     /* 1456838 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1456920), // Rule ID 20606 //
     /* 1456843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1456846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1456851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1456854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1456857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1456860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1456863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456882 */     // MIs[0] round
     /* 1456882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456885 */     // MIs[0] policy
     /* 1456885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456895 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1456898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456919 */     // GIR_Coverage, 20606,
     /* 1456919 */     GIR_EraseRootFromParent_Done,
     /* 1456920 */   // Label 20327: @1456920
     /* 1456920 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1457002), // Rule ID 20607 //
     /* 1456925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1456928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1456933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1456936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1456939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1456942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1456945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456964 */     // MIs[0] round
     /* 1456964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1456967 */     // MIs[0] policy
     /* 1456967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1456980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1456986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1456988 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1456990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457001 */     // GIR_Coverage, 20607,
     /* 1457001 */     GIR_EraseRootFromParent_Done,
     /* 1457002 */   // Label 20328: @1457002
     /* 1457002 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1457084), // Rule ID 20610 //
     /* 1457007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1457010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1457018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1457021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1457024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1457027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457046 */     // MIs[0] round
     /* 1457046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457049 */     // MIs[0] policy
     /* 1457049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457059 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1457062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457083 */     // GIR_Coverage, 20610,
     /* 1457083 */     GIR_EraseRootFromParent_Done,
     /* 1457084 */   // Label 20329: @1457084
     /* 1457084 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1457166), // Rule ID 20611 //
     /* 1457089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1457092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1457100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1457103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1457106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1457109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457128 */     // MIs[0] round
     /* 1457128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457131 */     // MIs[0] policy
     /* 1457131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1457144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457165 */     // GIR_Coverage, 20611,
     /* 1457165 */     GIR_EraseRootFromParent_Done,
     /* 1457166 */   // Label 20330: @1457166
     /* 1457166 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1457248), // Rule ID 20614 //
     /* 1457171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1457174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1457182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1457185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1457188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1457191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457210 */     // MIs[0] round
     /* 1457210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457213 */     // MIs[0] policy
     /* 1457213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457223 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457234 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457247 */     // GIR_Coverage, 20614,
     /* 1457247 */     GIR_EraseRootFromParent_Done,
     /* 1457248 */   // Label 20331: @1457248
     /* 1457248 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1457330), // Rule ID 20615 //
     /* 1457253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1457256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1457264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1457267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1457270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1457273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457292 */     // MIs[0] round
     /* 1457292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457295 */     // MIs[0] policy
     /* 1457295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457305 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10889:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457316 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457329 */     // GIR_Coverage, 20615,
     /* 1457329 */     GIR_EraseRootFromParent_Done,
     /* 1457330 */   // Label 20332: @1457330
     /* 1457330 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1457412), // Rule ID 20618 //
     /* 1457335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1457338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1457346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1457349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1457352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1457355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457374 */     // MIs[0] round
     /* 1457374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457377 */     // MIs[0] policy
     /* 1457377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457398 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457411 */     // GIR_Coverage, 20618,
     /* 1457411 */     GIR_EraseRootFromParent_Done,
     /* 1457412 */   // Label 20333: @1457412
     /* 1457412 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1457494), // Rule ID 20619 //
     /* 1457417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1457420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1457428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1457431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1457434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1457437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457456 */     // MIs[0] round
     /* 1457456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457459 */     // MIs[0] policy
     /* 1457459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457469 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457493 */     // GIR_Coverage, 20619,
     /* 1457493 */     GIR_EraseRootFromParent_Done,
     /* 1457494 */   // Label 20334: @1457494
     /* 1457494 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1457576), // Rule ID 20622 //
     /* 1457499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1457502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1457510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1457513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1457516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1457519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457538 */     // MIs[0] round
     /* 1457538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457541 */     // MIs[0] policy
     /* 1457541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457562 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457575 */     // GIR_Coverage, 20622,
     /* 1457575 */     GIR_EraseRootFromParent_Done,
     /* 1457576 */   // Label 20335: @1457576
     /* 1457576 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1457658), // Rule ID 20623 //
     /* 1457581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1457584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1457592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1457595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1457598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1457601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457620 */     // MIs[0] round
     /* 1457620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457623 */     // MIs[0] policy
     /* 1457623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457633 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1457636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457644 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457657 */     // GIR_Coverage, 20623,
     /* 1457657 */     GIR_EraseRootFromParent_Done,
     /* 1457658 */   // Label 20336: @1457658
     /* 1457658 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1457740), // Rule ID 20626 //
     /* 1457663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1457666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1457674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1457677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1457680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1457683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457702 */     // MIs[0] round
     /* 1457702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457705 */     // MIs[0] policy
     /* 1457705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1457718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457739 */     // GIR_Coverage, 20626,
     /* 1457739 */     GIR_EraseRootFromParent_Done,
     /* 1457740 */   // Label 20337: @1457740
     /* 1457740 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1457822), // Rule ID 20627 //
     /* 1457745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1457748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1457756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1457759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1457762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1457765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457784 */     // MIs[0] round
     /* 1457784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457787 */     // MIs[0] policy
     /* 1457787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1457800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457821 */     // GIR_Coverage, 20627,
     /* 1457821 */     GIR_EraseRootFromParent_Done,
     /* 1457822 */   // Label 20338: @1457822
     /* 1457822 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1457904), // Rule ID 20630 //
     /* 1457827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1457830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1457838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1457841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1457844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1457847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457866 */     // MIs[0] round
     /* 1457866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457869 */     // MIs[0] policy
     /* 1457869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457879 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1457882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457903 */     // GIR_Coverage, 20630,
     /* 1457903 */     GIR_EraseRootFromParent_Done,
     /* 1457904 */   // Label 20339: @1457904
     /* 1457904 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1457986), // Rule ID 20631 //
     /* 1457909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1457912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1457920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1457923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1457926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1457929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457948 */     // MIs[0] round
     /* 1457948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1457951 */     // MIs[0] policy
     /* 1457951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457961 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1457964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1457970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1457972 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1457974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457985 */     // GIR_Coverage, 20631,
     /* 1457985 */     GIR_EraseRootFromParent_Done,
     /* 1457986 */   // Label 20340: @1457986
     /* 1457986 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1458068), // Rule ID 20634 //
     /* 1457991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1457994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1457999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1458002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1458005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1458011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458030 */     // MIs[0] round
     /* 1458030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458033 */     // MIs[0] policy
     /* 1458033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458043 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1458046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458054 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458067 */     // GIR_Coverage, 20634,
     /* 1458067 */     GIR_EraseRootFromParent_Done,
     /* 1458068 */   // Label 20341: @1458068
     /* 1458068 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1458150), // Rule ID 20635 //
     /* 1458073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1458076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1458084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1458087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1458093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458112 */     // MIs[0] round
     /* 1458112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458115 */     // MIs[0] policy
     /* 1458115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458125 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1458128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458149 */     // GIR_Coverage, 20635,
     /* 1458149 */     GIR_EraseRootFromParent_Done,
     /* 1458150 */   // Label 20342: @1458150
     /* 1458150 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1458232), // Rule ID 20638 //
     /* 1458155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1458158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1458166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1458169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1458172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1458175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458194 */     // MIs[0] round
     /* 1458194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458197 */     // MIs[0] policy
     /* 1458197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1458210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458218 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458231 */     // GIR_Coverage, 20638,
     /* 1458231 */     GIR_EraseRootFromParent_Done,
     /* 1458232 */   // Label 20343: @1458232
     /* 1458232 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1458314), // Rule ID 20639 //
     /* 1458237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1458240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1458248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1458251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1458254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1458257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458276 */     // MIs[0] round
     /* 1458276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458279 */     // MIs[0] policy
     /* 1458279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1458292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458313 */     // GIR_Coverage, 20639,
     /* 1458313 */     GIR_EraseRootFromParent_Done,
     /* 1458314 */   // Label 20344: @1458314
     /* 1458314 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1458396), // Rule ID 20642 //
     /* 1458319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1458322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1458330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1458333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1458336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1458339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458358 */     // MIs[0] round
     /* 1458358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458361 */     // MIs[0] policy
     /* 1458361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1458374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458382 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458395 */     // GIR_Coverage, 20642,
     /* 1458395 */     GIR_EraseRootFromParent_Done,
     /* 1458396 */   // Label 20345: @1458396
     /* 1458396 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1458478), // Rule ID 20643 //
     /* 1458401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1458404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1458412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1458415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1458418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1458421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458440 */     // MIs[0] round
     /* 1458440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458443 */     // MIs[0] policy
     /* 1458443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458453 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1458456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458477 */     // GIR_Coverage, 20643,
     /* 1458477 */     GIR_EraseRootFromParent_Done,
     /* 1458478 */   // Label 20346: @1458478
     /* 1458478 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1458560), // Rule ID 20646 //
     /* 1458483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1458486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1458494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1458497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1458500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1458503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458522 */     // MIs[0] round
     /* 1458522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458525 */     // MIs[0] policy
     /* 1458525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458535 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1458538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458546 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458559 */     // GIR_Coverage, 20646,
     /* 1458559 */     GIR_EraseRootFromParent_Done,
     /* 1458560 */   // Label 20347: @1458560
     /* 1458560 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1458642), // Rule ID 20647 //
     /* 1458565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1458568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1458576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1458579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1458582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1458585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458604 */     // MIs[0] round
     /* 1458604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458607 */     // MIs[0] policy
     /* 1458607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458617 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1458620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458641 */     // GIR_Coverage, 20647,
     /* 1458641 */     GIR_EraseRootFromParent_Done,
     /* 1458642 */   // Label 20348: @1458642
     /* 1458642 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1458724), // Rule ID 20650 //
     /* 1458647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1458650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1458658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1458661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1458664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1458667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458686 */     // MIs[0] round
     /* 1458686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458689 */     // MIs[0] policy
     /* 1458689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1458702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458723 */     // GIR_Coverage, 20650,
     /* 1458723 */     GIR_EraseRootFromParent_Done,
     /* 1458724 */   // Label 20349: @1458724
     /* 1458724 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1458806), // Rule ID 20651 //
     /* 1458729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1458732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1458740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1458743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1458746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1458749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458768 */     // MIs[0] round
     /* 1458768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458771 */     // MIs[0] policy
     /* 1458771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1458784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458805 */     // GIR_Coverage, 20651,
     /* 1458805 */     GIR_EraseRootFromParent_Done,
     /* 1458806 */   // Label 20350: @1458806
     /* 1458806 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1458888), // Rule ID 20654 //
     /* 1458811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1458814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1458822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1458825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1458828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1458831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458850 */     // MIs[0] round
     /* 1458850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458853 */     // MIs[0] policy
     /* 1458853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458863 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1458866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458874 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458887 */     // GIR_Coverage, 20654,
     /* 1458887 */     GIR_EraseRootFromParent_Done,
     /* 1458888 */   // Label 20351: @1458888
     /* 1458888 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1458970), // Rule ID 20655 //
     /* 1458893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1458896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1458904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1458907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1458910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1458913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458932 */     // MIs[0] round
     /* 1458932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1458935 */     // MIs[0] policy
     /* 1458935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458945 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1458948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1458954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1458956 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1458958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458969 */     // GIR_Coverage, 20655,
     /* 1458969 */     GIR_EraseRootFromParent_Done,
     /* 1458970 */   // Label 20352: @1458970
     /* 1458970 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1459052), // Rule ID 20658 //
     /* 1458975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1458978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1458983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1458986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1458989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1458995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459014 */     // MIs[0] round
     /* 1459014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459017 */     // MIs[0] policy
     /* 1459017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459027 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1459030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1459048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459051 */     // GIR_Coverage, 20658,
     /* 1459051 */     GIR_EraseRootFromParent_Done,
     /* 1459052 */   // Label 20353: @1459052
     /* 1459052 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1459134), // Rule ID 20659 //
     /* 1459057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1459060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1459065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1459068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1459071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1459074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1459077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459096 */     // MIs[0] round
     /* 1459096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459099 */     // MIs[0] policy
     /* 1459099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1459112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1459130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459133 */     // GIR_Coverage, 20659,
     /* 1459133 */     GIR_EraseRootFromParent_Done,
     /* 1459134 */   // Label 20354: @1459134
     /* 1459134 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1459216), // Rule ID 20662 //
     /* 1459139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1459142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1459156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1459159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459178 */     // MIs[0] round
     /* 1459178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459181 */     // MIs[0] policy
     /* 1459181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1459194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459202 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459215 */     // GIR_Coverage, 20662,
     /* 1459215 */     GIR_EraseRootFromParent_Done,
     /* 1459216 */   // Label 20355: @1459216
     /* 1459216 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1459298), // Rule ID 20663 //
     /* 1459221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1459224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1459238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1459241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459260 */     // MIs[0] round
     /* 1459260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459263 */     // MIs[0] policy
     /* 1459263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459273 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1459276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459297 */     // GIR_Coverage, 20663,
     /* 1459297 */     GIR_EraseRootFromParent_Done,
     /* 1459298 */   // Label 20356: @1459298
     /* 1459298 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1459380), // Rule ID 20666 //
     /* 1459303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1459306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1459320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1459323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459342 */     // MIs[0] round
     /* 1459342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459345 */     // MIs[0] policy
     /* 1459345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459355 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1459358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459379 */     // GIR_Coverage, 20666,
     /* 1459379 */     GIR_EraseRootFromParent_Done,
     /* 1459380 */   // Label 20357: @1459380
     /* 1459380 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1459462), // Rule ID 20667 //
     /* 1459385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1459388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1459402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1459405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459424 */     // MIs[0] round
     /* 1459424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459427 */     // MIs[0] policy
     /* 1459427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459437 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1459440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459461 */     // GIR_Coverage, 20667,
     /* 1459461 */     GIR_EraseRootFromParent_Done,
     /* 1459462 */   // Label 20358: @1459462
     /* 1459462 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1459544), // Rule ID 20670 //
     /* 1459467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1459470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1459487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459506 */     // MIs[0] round
     /* 1459506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459509 */     // MIs[0] policy
     /* 1459509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459519 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1459522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459530 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459543 */     // GIR_Coverage, 20670,
     /* 1459543 */     GIR_EraseRootFromParent_Done,
     /* 1459544 */   // Label 20359: @1459544
     /* 1459544 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1459626), // Rule ID 20671 //
     /* 1459549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1459552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1459569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459588 */     // MIs[0] round
     /* 1459588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459591 */     // MIs[0] policy
     /* 1459591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1459604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459612 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459625 */     // GIR_Coverage, 20671,
     /* 1459625 */     GIR_EraseRootFromParent_Done,
     /* 1459626 */   // Label 20360: @1459626
     /* 1459626 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1459708), // Rule ID 20674 //
     /* 1459631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1459634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1459648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1459651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459670 */     // MIs[0] round
     /* 1459670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459673 */     // MIs[0] policy
     /* 1459673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1459686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459707 */     // GIR_Coverage, 20674,
     /* 1459707 */     GIR_EraseRootFromParent_Done,
     /* 1459708 */   // Label 20361: @1459708
     /* 1459708 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1459790), // Rule ID 20675 //
     /* 1459713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1459716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1459730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1459733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459752 */     // MIs[0] round
     /* 1459752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459755 */     // MIs[0] policy
     /* 1459755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10891:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1459768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459776 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459789 */     // GIR_Coverage, 20675,
     /* 1459789 */     GIR_EraseRootFromParent_Done,
     /* 1459790 */   // Label 20362: @1459790
     /* 1459790 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1459872), // Rule ID 20678 //
     /* 1459795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1459798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1459806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1459809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1459815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459834 */     // MIs[0] round
     /* 1459834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459837 */     // MIs[0] policy
     /* 1459837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1459850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459858 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459871 */     // GIR_Coverage, 20678,
     /* 1459871 */     GIR_EraseRootFromParent_Done,
     /* 1459872 */   // Label 20363: @1459872
     /* 1459872 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1459954), // Rule ID 20679 //
     /* 1459877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1459880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1459888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1459891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1459897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459916 */     // MIs[0] round
     /* 1459916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1459919 */     // MIs[0] policy
     /* 1459919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459929 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1459932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1459938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1459940 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1459942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459953 */     // GIR_Coverage, 20679,
     /* 1459953 */     GIR_EraseRootFromParent_Done,
     /* 1459954 */   // Label 20364: @1459954
     /* 1459954 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1460036), // Rule ID 20682 //
     /* 1459959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1459962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1459967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1459970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1459973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1459979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459998 */     // MIs[0] round
     /* 1459998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460001 */     // MIs[0] policy
     /* 1460001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460011 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1460014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460022 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1460032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460035 */     // GIR_Coverage, 20682,
     /* 1460035 */     GIR_EraseRootFromParent_Done,
     /* 1460036 */   // Label 20365: @1460036
     /* 1460036 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1460118), // Rule ID 20683 //
     /* 1460041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1460044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1460052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1460055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1460061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460080 */     // MIs[0] round
     /* 1460080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460083 */     // MIs[0] policy
     /* 1460083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460093 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1460096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1460114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460117 */     // GIR_Coverage, 20683,
     /* 1460117 */     GIR_EraseRootFromParent_Done,
     /* 1460118 */   // Label 20366: @1460118
     /* 1460118 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1460200), // Rule ID 20686 //
     /* 1460123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1460126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1460140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1460143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460162 */     // MIs[0] round
     /* 1460162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460165 */     // MIs[0] policy
     /* 1460165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1460178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460186 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460199 */     // GIR_Coverage, 20686,
     /* 1460199 */     GIR_EraseRootFromParent_Done,
     /* 1460200 */   // Label 20367: @1460200
     /* 1460200 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1460282), // Rule ID 20687 //
     /* 1460205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1460208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1460222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1460225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460244 */     // MIs[0] round
     /* 1460244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460247 */     // MIs[0] policy
     /* 1460247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1460260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460281 */     // GIR_Coverage, 20687,
     /* 1460281 */     GIR_EraseRootFromParent_Done,
     /* 1460282 */   // Label 20368: @1460282
     /* 1460282 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1460364), // Rule ID 20690 //
     /* 1460287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1460290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1460304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1460307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460326 */     // MIs[0] round
     /* 1460326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460329 */     // MIs[0] policy
     /* 1460329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460339 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1460342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460363 */     // GIR_Coverage, 20690,
     /* 1460363 */     GIR_EraseRootFromParent_Done,
     /* 1460364 */   // Label 20369: @1460364
     /* 1460364 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1460446), // Rule ID 20691 //
     /* 1460369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1460372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1460386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1460389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460408 */     // MIs[0] round
     /* 1460408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460411 */     // MIs[0] policy
     /* 1460411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460421 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1460424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460445 */     // GIR_Coverage, 20691,
     /* 1460445 */     GIR_EraseRootFromParent_Done,
     /* 1460446 */   // Label 20370: @1460446
     /* 1460446 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1460528), // Rule ID 20694 //
     /* 1460451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1460454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1460462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1460465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1460468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1460471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460490 */     // MIs[0] round
     /* 1460490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460493 */     // MIs[0] policy
     /* 1460493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460503 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1460506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460514 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460527 */     // GIR_Coverage, 20694,
     /* 1460527 */     GIR_EraseRootFromParent_Done,
     /* 1460528 */   // Label 20371: @1460528
     /* 1460528 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1460610), // Rule ID 20695 //
     /* 1460533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1460536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1460544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1460547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1460550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1460553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460572 */     // MIs[0] round
     /* 1460572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460575 */     // MIs[0] policy
     /* 1460575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460585 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1460588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460596 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460609 */     // GIR_Coverage, 20695,
     /* 1460609 */     GIR_EraseRootFromParent_Done,
     /* 1460610 */   // Label 20372: @1460610
     /* 1460610 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1460692), // Rule ID 20698 //
     /* 1460615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1460618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1460635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460654 */     // MIs[0] round
     /* 1460654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460657 */     // MIs[0] policy
     /* 1460657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1460670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460678 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460691 */     // GIR_Coverage, 20698,
     /* 1460691 */     GIR_EraseRootFromParent_Done,
     /* 1460692 */   // Label 20373: @1460692
     /* 1460692 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1460774), // Rule ID 20699 //
     /* 1460697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1460700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1460717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460736 */     // MIs[0] round
     /* 1460736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460739 */     // MIs[0] policy
     /* 1460739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1460752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460773 */     // GIR_Coverage, 20699,
     /* 1460773 */     GIR_EraseRootFromParent_Done,
     /* 1460774 */   // Label 20374: @1460774
     /* 1460774 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1460856), // Rule ID 20702 //
     /* 1460779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1460782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1460799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460818 */     // MIs[0] round
     /* 1460818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460821 */     // MIs[0] policy
     /* 1460821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460831 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1460834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460842 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460855 */     // GIR_Coverage, 20702,
     /* 1460855 */     GIR_EraseRootFromParent_Done,
     /* 1460856 */   // Label 20375: @1460856
     /* 1460856 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1460938), // Rule ID 20703 //
     /* 1460861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1460864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1460881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460900 */     // MIs[0] round
     /* 1460900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460903 */     // MIs[0] policy
     /* 1460903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460913 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1460916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1460922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1460924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1460926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460937 */     // GIR_Coverage, 20703,
     /* 1460937 */     GIR_EraseRootFromParent_Done,
     /* 1460938 */   // Label 20376: @1460938
     /* 1460938 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1461020), // Rule ID 20706 //
     /* 1460943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1460946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1460951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1460954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1460957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1460963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460982 */     // MIs[0] round
     /* 1460982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1460985 */     // MIs[0] policy
     /* 1460985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460995 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1460998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461019 */     // GIR_Coverage, 20706,
     /* 1461019 */     GIR_EraseRootFromParent_Done,
     /* 1461020 */   // Label 20377: @1461020
     /* 1461020 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1461102), // Rule ID 20707 //
     /* 1461025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1461028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1461036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1461039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1461042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1461045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461064 */     // MIs[0] round
     /* 1461064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461067 */     // MIs[0] policy
     /* 1461067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461077 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1461080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461101 */     // GIR_Coverage, 20707,
     /* 1461101 */     GIR_EraseRootFromParent_Done,
     /* 1461102 */   // Label 20378: @1461102
     /* 1461102 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1461184), // Rule ID 20710 //
     /* 1461107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1461110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1461118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1461121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1461124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1461127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461146 */     // MIs[0] round
     /* 1461146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461149 */     // MIs[0] policy
     /* 1461149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461159 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1461162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461170 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461183 */     // GIR_Coverage, 20710,
     /* 1461183 */     GIR_EraseRootFromParent_Done,
     /* 1461184 */   // Label 20379: @1461184
     /* 1461184 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1461266), // Rule ID 20711 //
     /* 1461189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1461192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1461200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1461203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1461206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1461209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461228 */     // MIs[0] round
     /* 1461228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461231 */     // MIs[0] policy
     /* 1461231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461241 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1461244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461265 */     // GIR_Coverage, 20711,
     /* 1461265 */     GIR_EraseRootFromParent_Done,
     /* 1461266 */   // Label 20380: @1461266
     /* 1461266 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1461348), // Rule ID 20714 //
     /* 1461271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1461274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1461282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1461285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1461291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461310 */     // MIs[0] round
     /* 1461310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461313 */     // MIs[0] policy
     /* 1461313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461323 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1461326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461347 */     // GIR_Coverage, 20714,
     /* 1461347 */     GIR_EraseRootFromParent_Done,
     /* 1461348 */   // Label 20381: @1461348
     /* 1461348 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1461430), // Rule ID 20715 //
     /* 1461353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1461356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1461364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1461367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1461373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461392 */     // MIs[0] round
     /* 1461392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461395 */     // MIs[0] policy
     /* 1461395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1461408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461429 */     // GIR_Coverage, 20715,
     /* 1461429 */     GIR_EraseRootFromParent_Done,
     /* 1461430 */   // Label 20382: @1461430
     /* 1461430 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1461512), // Rule ID 20718 //
     /* 1461435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1461438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1461455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461474 */     // MIs[0] round
     /* 1461474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461477 */     // MIs[0] policy
     /* 1461477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461487 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1461490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461498 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461511 */     // GIR_Coverage, 20718,
     /* 1461511 */     GIR_EraseRootFromParent_Done,
     /* 1461512 */   // Label 20383: @1461512
     /* 1461512 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1461594), // Rule ID 20719 //
     /* 1461517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1461520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1461525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1461537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461556 */     // MIs[0] round
     /* 1461556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461559 */     // MIs[0] policy
     /* 1461559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1461572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461578 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461593 */     // GIR_Coverage, 20719,
     /* 1461593 */     GIR_EraseRootFromParent_Done,
     /* 1461594 */   // Label 20384: @1461594
     /* 1461594 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1461676), // Rule ID 20842 //
     /* 1461599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1461602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1461607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1461619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461638 */     // MIs[0] round
     /* 1461638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461641 */     // MIs[0] policy
     /* 1461641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461651 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1461654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461675 */     // GIR_Coverage, 20842,
     /* 1461675 */     GIR_EraseRootFromParent_Done,
     /* 1461676 */   // Label 20385: @1461676
     /* 1461676 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1461758), // Rule ID 20843 //
     /* 1461681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1461684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1461689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1461701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461720 */     // MIs[0] round
     /* 1461720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461723 */     // MIs[0] policy
     /* 1461723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461733 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1461736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461757 */     // GIR_Coverage, 20843,
     /* 1461757 */     GIR_EraseRootFromParent_Done,
     /* 1461758 */   // Label 20386: @1461758
     /* 1461758 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1461840), // Rule ID 20846 //
     /* 1461763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1461766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1461771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1461774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1461777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1461783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461802 */     // MIs[0] round
     /* 1461802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461805 */     // MIs[0] policy
     /* 1461805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1461818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461826 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461839 */     // GIR_Coverage, 20846,
     /* 1461839 */     GIR_EraseRootFromParent_Done,
     /* 1461840 */   // Label 20387: @1461840
     /* 1461840 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1461922), // Rule ID 20847 //
     /* 1461845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1461848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1461853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1461856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1461859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1461865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461884 */     // MIs[0] round
     /* 1461884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461887 */     // MIs[0] policy
     /* 1461887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461897 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1461900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461921 */     // GIR_Coverage, 20847,
     /* 1461921 */     GIR_EraseRootFromParent_Done,
     /* 1461922 */   // Label 20388: @1461922
     /* 1461922 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1462004), // Rule ID 20850 //
     /* 1461927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1461930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1461935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1461938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1461941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1461944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1461947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461966 */     // MIs[0] round
     /* 1461966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1461969 */     // MIs[0] policy
     /* 1461969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1461982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1461988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1461990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1461992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462003 */     // GIR_Coverage, 20850,
     /* 1462003 */     GIR_EraseRootFromParent_Done,
     /* 1462004 */   // Label 20389: @1462004
     /* 1462004 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1462086), // Rule ID 20851 //
     /* 1462009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1462012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1462029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462048 */     // MIs[0] round
     /* 1462048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462051 */     // MIs[0] policy
     /* 1462051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462061 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1462064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462085 */     // GIR_Coverage, 20851,
     /* 1462085 */     GIR_EraseRootFromParent_Done,
     /* 1462086 */   // Label 20390: @1462086
     /* 1462086 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1462168), // Rule ID 20854 //
     /* 1462091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1462094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1462111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462130 */     // MIs[0] round
     /* 1462130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462133 */     // MIs[0] policy
     /* 1462133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462143 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1462146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462154 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462167 */     // GIR_Coverage, 20854,
     /* 1462167 */     GIR_EraseRootFromParent_Done,
     /* 1462168 */   // Label 20391: @1462168
     /* 1462168 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1462250), // Rule ID 20855 //
     /* 1462173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1462176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1462193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462212 */     // MIs[0] round
     /* 1462212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462215 */     // MIs[0] policy
     /* 1462215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462225 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1462228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462249 */     // GIR_Coverage, 20855,
     /* 1462249 */     GIR_EraseRootFromParent_Done,
     /* 1462250 */   // Label 20392: @1462250
     /* 1462250 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1462332), // Rule ID 20858 //
     /* 1462255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1462258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1462275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462294 */     // MIs[0] round
     /* 1462294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462297 */     // MIs[0] policy
     /* 1462297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462307 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1462310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462331 */     // GIR_Coverage, 20858,
     /* 1462331 */     GIR_EraseRootFromParent_Done,
     /* 1462332 */   // Label 20393: @1462332
     /* 1462332 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1462414), // Rule ID 20859 //
     /* 1462337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1462340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1462357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462376 */     // MIs[0] round
     /* 1462376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462379 */     // MIs[0] policy
     /* 1462379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462389 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1462392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462400 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462413 */     // GIR_Coverage, 20859,
     /* 1462413 */     GIR_EraseRootFromParent_Done,
     /* 1462414 */   // Label 20394: @1462414
     /* 1462414 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1462496), // Rule ID 20862 //
     /* 1462419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1462422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1462430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1462433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1462439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462458 */     // MIs[0] round
     /* 1462458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462461 */     // MIs[0] policy
     /* 1462461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462471 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1462474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1462492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462495 */     // GIR_Coverage, 20862,
     /* 1462495 */     GIR_EraseRootFromParent_Done,
     /* 1462496 */   // Label 20395: @1462496
     /* 1462496 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1462578), // Rule ID 20863 //
     /* 1462501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1462504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1462512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1462515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1462521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462540 */     // MIs[0] round
     /* 1462540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462543 */     // MIs[0] policy
     /* 1462543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462553 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1462556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462564 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1462574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462577 */     // GIR_Coverage, 20863,
     /* 1462577 */     GIR_EraseRootFromParent_Done,
     /* 1462578 */   // Label 20396: @1462578
     /* 1462578 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1462660), // Rule ID 20866 //
     /* 1462583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1462586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1462600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1462603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462622 */     // MIs[0] round
     /* 1462622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462625 */     // MIs[0] policy
     /* 1462625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462635 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1462638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462659 */     // GIR_Coverage, 20866,
     /* 1462659 */     GIR_EraseRootFromParent_Done,
     /* 1462660 */   // Label 20397: @1462660
     /* 1462660 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1462742), // Rule ID 20867 //
     /* 1462665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1462668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1462682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1462685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462704 */     // MIs[0] round
     /* 1462704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462707 */     // MIs[0] policy
     /* 1462707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462717 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1462720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462741 */     // GIR_Coverage, 20867,
     /* 1462741 */     GIR_EraseRootFromParent_Done,
     /* 1462742 */   // Label 20398: @1462742
     /* 1462742 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1462824), // Rule ID 20870 //
     /* 1462747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1462750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1462764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1462767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462786 */     // MIs[0] round
     /* 1462786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462789 */     // MIs[0] policy
     /* 1462789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462799 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1462802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462810 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462823 */     // GIR_Coverage, 20870,
     /* 1462823 */     GIR_EraseRootFromParent_Done,
     /* 1462824 */   // Label 20399: @1462824
     /* 1462824 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1462906), // Rule ID 20871 //
     /* 1462829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1462832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1462846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1462849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462868 */     // MIs[0] round
     /* 1462868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462871 */     // MIs[0] policy
     /* 1462871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462881 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1462884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462905 */     // GIR_Coverage, 20871,
     /* 1462905 */     GIR_EraseRootFromParent_Done,
     /* 1462906 */   // Label 20400: @1462906
     /* 1462906 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1462988), // Rule ID 20874 //
     /* 1462911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1462914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1462919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1462922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1462925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1462931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1462938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462950 */     // MIs[0] round
     /* 1462950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1462953 */     // MIs[0] policy
     /* 1462953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1462966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1462972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1462974 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1462976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462987 */     // GIR_Coverage, 20874,
     /* 1462987 */     GIR_EraseRootFromParent_Done,
     /* 1462988 */   // Label 20401: @1462988
     /* 1462988 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1463070), // Rule ID 20875 //
     /* 1462993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1462996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1463004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1463007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1463010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1463013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463032 */     // MIs[0] round
     /* 1463032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463035 */     // MIs[0] policy
     /* 1463035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463045 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1463048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463056 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463069 */     // GIR_Coverage, 20875,
     /* 1463069 */     GIR_EraseRootFromParent_Done,
     /* 1463070 */   // Label 20402: @1463070
     /* 1463070 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1463152), // Rule ID 20878 //
     /* 1463075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1463078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1463092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1463095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463114 */     // MIs[0] round
     /* 1463114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463117 */     // MIs[0] policy
     /* 1463117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463127 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1463130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463138 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463151 */     // GIR_Coverage, 20878,
     /* 1463151 */     GIR_EraseRootFromParent_Done,
     /* 1463152 */   // Label 20403: @1463152
     /* 1463152 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1463234), // Rule ID 20879 //
     /* 1463157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1463160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1463174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1463177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463196 */     // MIs[0] round
     /* 1463196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463199 */     // MIs[0] policy
     /* 1463199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1463212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463220 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463233 */     // GIR_Coverage, 20879,
     /* 1463233 */     GIR_EraseRootFromParent_Done,
     /* 1463234 */   // Label 20404: @1463234
     /* 1463234 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1463316), // Rule ID 20882 //
     /* 1463239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1463242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1463256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1463259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463278 */     // MIs[0] round
     /* 1463278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463281 */     // MIs[0] policy
     /* 1463281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1463294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463315 */     // GIR_Coverage, 20882,
     /* 1463315 */     GIR_EraseRootFromParent_Done,
     /* 1463316 */   // Label 20405: @1463316
     /* 1463316 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1463398), // Rule ID 20883 //
     /* 1463321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1463324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1463338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1463341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463360 */     // MIs[0] round
     /* 1463360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463363 */     // MIs[0] policy
     /* 1463363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463373 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1463376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463384 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463397 */     // GIR_Coverage, 20883,
     /* 1463397 */     GIR_EraseRootFromParent_Done,
     /* 1463398 */   // Label 20406: @1463398
     /* 1463398 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1463480), // Rule ID 20886 //
     /* 1463403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1463406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1463414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1463417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1463423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463442 */     // MIs[0] round
     /* 1463442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463445 */     // MIs[0] policy
     /* 1463445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463455 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1463458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463466 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463479 */     // GIR_Coverage, 20886,
     /* 1463479 */     GIR_EraseRootFromParent_Done,
     /* 1463480 */   // Label 20407: @1463480
     /* 1463480 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1463562), // Rule ID 20887 //
     /* 1463485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1463488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1463496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1463499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1463505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463524 */     // MIs[0] round
     /* 1463524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463527 */     // MIs[0] policy
     /* 1463527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463537 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1463540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463561 */     // GIR_Coverage, 20887,
     /* 1463561 */     GIR_EraseRootFromParent_Done,
     /* 1463562 */   // Label 20408: @1463562
     /* 1463562 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1463644), // Rule ID 20890 //
     /* 1463567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1463570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1463578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1463581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1463587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463606 */     // MIs[0] round
     /* 1463606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463609 */     // MIs[0] policy
     /* 1463609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1463622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463643 */     // GIR_Coverage, 20890,
     /* 1463643 */     GIR_EraseRootFromParent_Done,
     /* 1463644 */   // Label 20409: @1463644
     /* 1463644 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1463726), // Rule ID 20891 //
     /* 1463649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1463652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1463660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1463663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1463669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463688 */     // MIs[0] round
     /* 1463688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463691 */     // MIs[0] policy
     /* 1463691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463701 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1463704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463712 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463725 */     // GIR_Coverage, 20891,
     /* 1463725 */     GIR_EraseRootFromParent_Done,
     /* 1463726 */   // Label 20410: @1463726
     /* 1463726 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1463808), // Rule ID 20894 //
     /* 1463731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1463734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1463742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1463745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1463751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463770 */     // MIs[0] round
     /* 1463770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463773 */     // MIs[0] policy
     /* 1463773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463783 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1463786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463794 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463807 */     // GIR_Coverage, 20894,
     /* 1463807 */     GIR_EraseRootFromParent_Done,
     /* 1463808 */   // Label 20411: @1463808
     /* 1463808 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1463890), // Rule ID 20895 //
     /* 1463813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1463816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1463824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1463827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1463833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463852 */     // MIs[0] round
     /* 1463852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463855 */     // MIs[0] policy
     /* 1463855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1463868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463876 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463889 */     // GIR_Coverage, 20895,
     /* 1463889 */     GIR_EraseRootFromParent_Done,
     /* 1463890 */   // Label 20412: @1463890
     /* 1463890 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1463972), // Rule ID 20898 //
     /* 1463895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1463898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1463906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1463909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1463915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463934 */     // MIs[0] round
     /* 1463934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1463937 */     // MIs[0] policy
     /* 1463937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463947 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1463950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1463956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1463958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1463960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463971 */     // GIR_Coverage, 20898,
     /* 1463971 */     GIR_EraseRootFromParent_Done,
     /* 1463972 */   // Label 20413: @1463972
     /* 1463972 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1464054), // Rule ID 20899 //
     /* 1463977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1463980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1463985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1463988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1463991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1463997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464016 */     // MIs[0] round
     /* 1464016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464019 */     // MIs[0] policy
     /* 1464019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464029 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1464032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464040 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1464050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464053 */     // GIR_Coverage, 20899,
     /* 1464053 */     GIR_EraseRootFromParent_Done,
     /* 1464054 */   // Label 20414: @1464054
     /* 1464054 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1464136), // Rule ID 20902 //
     /* 1464059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1464062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464098 */     // MIs[0] round
     /* 1464098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464101 */     // MIs[0] policy
     /* 1464101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464111 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1464114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464135 */     // GIR_Coverage, 20902,
     /* 1464135 */     GIR_EraseRootFromParent_Done,
     /* 1464136 */   // Label 20415: @1464136
     /* 1464136 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1464218), // Rule ID 20903 //
     /* 1464141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1464144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464180 */     // MIs[0] round
     /* 1464180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464183 */     // MIs[0] policy
     /* 1464183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464193 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1464196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464204 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464217 */     // GIR_Coverage, 20903,
     /* 1464217 */     GIR_EraseRootFromParent_Done,
     /* 1464218 */   // Label 20416: @1464218
     /* 1464218 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1464300), // Rule ID 20906 //
     /* 1464223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1464226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1464243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464262 */     // MIs[0] round
     /* 1464262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464265 */     // MIs[0] policy
     /* 1464265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464275 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1464278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464299 */     // GIR_Coverage, 20906,
     /* 1464299 */     GIR_EraseRootFromParent_Done,
     /* 1464300 */   // Label 20417: @1464300
     /* 1464300 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1464382), // Rule ID 20907 //
     /* 1464305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1464308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1464325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464344 */     // MIs[0] round
     /* 1464344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464347 */     // MIs[0] policy
     /* 1464347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464357 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1464360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464368 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464381 */     // GIR_Coverage, 20907,
     /* 1464381 */     GIR_EraseRootFromParent_Done,
     /* 1464382 */   // Label 20418: @1464382
     /* 1464382 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1464464), // Rule ID 20910 //
     /* 1464387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1464390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464426 */     // MIs[0] round
     /* 1464426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464429 */     // MIs[0] policy
     /* 1464429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464439 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1464442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464463 */     // GIR_Coverage, 20910,
     /* 1464463 */     GIR_EraseRootFromParent_Done,
     /* 1464464 */   // Label 20419: @1464464
     /* 1464464 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1464546), // Rule ID 20911 //
     /* 1464469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1464472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464508 */     // MIs[0] round
     /* 1464508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464511 */     // MIs[0] policy
     /* 1464511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464521 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1464524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464545 */     // GIR_Coverage, 20911,
     /* 1464545 */     GIR_EraseRootFromParent_Done,
     /* 1464546 */   // Label 20420: @1464546
     /* 1464546 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1464628), // Rule ID 20914 //
     /* 1464551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1464554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1464562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1464565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1464571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464590 */     // MIs[0] round
     /* 1464590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464593 */     // MIs[0] policy
     /* 1464593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464603 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1464606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464627 */     // GIR_Coverage, 20914,
     /* 1464627 */     GIR_EraseRootFromParent_Done,
     /* 1464628 */   // Label 20421: @1464628
     /* 1464628 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1464710), // Rule ID 20915 //
     /* 1464633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1464636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1464644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1464647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1464653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464672 */     // MIs[0] round
     /* 1464672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464675 */     // MIs[0] policy
     /* 1464675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464685 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1464688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464696 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464709 */     // GIR_Coverage, 20915,
     /* 1464709 */     GIR_EraseRootFromParent_Done,
     /* 1464710 */   // Label 20422: @1464710
     /* 1464710 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1464792), // Rule ID 20918 //
     /* 1464715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1464718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1464726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1464729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1464732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1464735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464754 */     // MIs[0] round
     /* 1464754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464757 */     // MIs[0] policy
     /* 1464757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464767 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1464770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464791 */     // GIR_Coverage, 20918,
     /* 1464791 */     GIR_EraseRootFromParent_Done,
     /* 1464792 */   // Label 20423: @1464792
     /* 1464792 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1464874), // Rule ID 20919 //
     /* 1464797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1464800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1464808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1464811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1464814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1464817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464836 */     // MIs[0] round
     /* 1464836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464839 */     // MIs[0] policy
     /* 1464839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464849 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1464852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464860 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464873 */     // GIR_Coverage, 20919,
     /* 1464873 */     GIR_EraseRootFromParent_Done,
     /* 1464874 */   // Label 20424: @1464874
     /* 1464874 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1464956), // Rule ID 20922 //
     /* 1464879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1464882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1464890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1464893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1464896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464918 */     // MIs[0] round
     /* 1464918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1464921 */     // MIs[0] policy
     /* 1464921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464931 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1464934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1464940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1464942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1464944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1464952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464955 */     // GIR_Coverage, 20922,
     /* 1464955 */     GIR_EraseRootFromParent_Done,
     /* 1464956 */   // Label 20425: @1464956
     /* 1464956 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1465038), // Rule ID 20923 //
     /* 1464961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1464964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1464969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1464972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1464975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1464978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1464981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465000 */     // MIs[0] round
     /* 1465000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465003 */     // MIs[0] policy
     /* 1465003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465013 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1465016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465024 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465037 */     // GIR_Coverage, 20923,
     /* 1465037 */     GIR_EraseRootFromParent_Done,
     /* 1465038 */   // Label 20426: @1465038
     /* 1465038 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1465120), // Rule ID 20926 //
     /* 1465043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1465046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1465054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1465057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1465060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1465063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465082 */     // MIs[0] round
     /* 1465082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465085 */     // MIs[0] policy
     /* 1465085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465095 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1465098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465119 */     // GIR_Coverage, 20926,
     /* 1465119 */     GIR_EraseRootFromParent_Done,
     /* 1465120 */   // Label 20427: @1465120
     /* 1465120 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1465202), // Rule ID 20927 //
     /* 1465125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1465128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1465136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1465139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1465142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1465145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465164 */     // MIs[0] round
     /* 1465164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465167 */     // MIs[0] policy
     /* 1465167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465177 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1465180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465188 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465201 */     // GIR_Coverage, 20927,
     /* 1465201 */     GIR_EraseRootFromParent_Done,
     /* 1465202 */   // Label 20428: @1465202
     /* 1465202 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1465284), // Rule ID 20930 //
     /* 1465207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1465210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1465218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1465221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1465224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1465227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465246 */     // MIs[0] round
     /* 1465246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465249 */     // MIs[0] policy
     /* 1465249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465259 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1465262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465283 */     // GIR_Coverage, 20930,
     /* 1465283 */     GIR_EraseRootFromParent_Done,
     /* 1465284 */   // Label 20429: @1465284
     /* 1465284 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1465366), // Rule ID 20931 //
     /* 1465289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1465292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1465300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1465303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1465306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1465309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465328 */     // MIs[0] round
     /* 1465328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465331 */     // MIs[0] policy
     /* 1465331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465341 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1465344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465352 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465365 */     // GIR_Coverage, 20931,
     /* 1465365 */     GIR_EraseRootFromParent_Done,
     /* 1465366 */   // Label 20430: @1465366
     /* 1465366 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1465448), // Rule ID 20934 //
     /* 1465371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1465374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1465382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1465385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1465388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1465391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465410 */     // MIs[0] round
     /* 1465410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465413 */     // MIs[0] policy
     /* 1465413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465423 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1465426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465447 */     // GIR_Coverage, 20934,
     /* 1465447 */     GIR_EraseRootFromParent_Done,
     /* 1465448 */   // Label 20431: @1465448
     /* 1465448 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1465530), // Rule ID 20935 //
     /* 1465453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1465456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1465464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1465467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1465470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1465473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465492 */     // MIs[0] round
     /* 1465492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465495 */     // MIs[0] policy
     /* 1465495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1465508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465516 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465529 */     // GIR_Coverage, 20935,
     /* 1465529 */     GIR_EraseRootFromParent_Done,
     /* 1465530 */   // Label 20432: @1465530
     /* 1465530 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1465612), // Rule ID 20938 //
     /* 1465535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1465538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1465546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1465549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1465552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1465555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465574 */     // MIs[0] round
     /* 1465574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465577 */     // MIs[0] policy
     /* 1465577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465587 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1465590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465598 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465611 */     // GIR_Coverage, 20938,
     /* 1465611 */     GIR_EraseRootFromParent_Done,
     /* 1465612 */   // Label 20433: @1465612
     /* 1465612 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1465694), // Rule ID 20939 //
     /* 1465617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1465620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1465628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1465631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1465634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1465637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465656 */     // MIs[0] round
     /* 1465656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465659 */     // MIs[0] policy
     /* 1465659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465669 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1465672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465680 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465693 */     // GIR_Coverage, 20939,
     /* 1465693 */     GIR_EraseRootFromParent_Done,
     /* 1465694 */   // Label 20434: @1465694
     /* 1465694 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1465776), // Rule ID 20942 //
     /* 1465699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1465702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1465710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1465713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1465716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1465719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465738 */     // MIs[0] round
     /* 1465738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465741 */     // MIs[0] policy
     /* 1465741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465751 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1465754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465775 */     // GIR_Coverage, 20942,
     /* 1465775 */     GIR_EraseRootFromParent_Done,
     /* 1465776 */   // Label 20435: @1465776
     /* 1465776 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1465858), // Rule ID 20943 //
     /* 1465781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1465784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1465792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1465795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1465798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1465801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465820 */     // MIs[0] round
     /* 1465820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465823 */     // MIs[0] policy
     /* 1465823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1465836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465844 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465857 */     // GIR_Coverage, 20943,
     /* 1465857 */     GIR_EraseRootFromParent_Done,
     /* 1465858 */   // Label 20436: @1465858
     /* 1465858 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1465940), // Rule ID 20946 //
     /* 1465863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1465866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1465874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1465877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1465880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1465883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465902 */     // MIs[0] round
     /* 1465902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465905 */     // MIs[0] policy
     /* 1465905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465915 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1465918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1465924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1465926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1465928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465939 */     // GIR_Coverage, 20946,
     /* 1465939 */     GIR_EraseRootFromParent_Done,
     /* 1465940 */   // Label 20437: @1465940
     /* 1465940 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1466022), // Rule ID 20947 //
     /* 1465945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1465948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1465953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1465956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1465959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1465962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1465965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465984 */     // MIs[0] round
     /* 1465984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1465987 */     // MIs[0] policy
     /* 1465987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465997 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1466000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466008 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466021 */     // GIR_Coverage, 20947,
     /* 1466021 */     GIR_EraseRootFromParent_Done,
     /* 1466022 */   // Label 20438: @1466022
     /* 1466022 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1466104), // Rule ID 20950 //
     /* 1466027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1466030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1466038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1466041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1466044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1466047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466066 */     // MIs[0] round
     /* 1466066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466069 */     // MIs[0] policy
     /* 1466069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1466082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466090 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466103 */     // GIR_Coverage, 20950,
     /* 1466103 */     GIR_EraseRootFromParent_Done,
     /* 1466104 */   // Label 20439: @1466104
     /* 1466104 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1466186), // Rule ID 20951 //
     /* 1466109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1466112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1466120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1466123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1466126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1466129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466148 */     // MIs[0] round
     /* 1466148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466151 */     // MIs[0] policy
     /* 1466151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466161 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1466164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466185 */     // GIR_Coverage, 20951,
     /* 1466185 */     GIR_EraseRootFromParent_Done,
     /* 1466186 */   // Label 20440: @1466186
     /* 1466186 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1466268), // Rule ID 20954 //
     /* 1466191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1466194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1466202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1466205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1466208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1466211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466230 */     // MIs[0] round
     /* 1466230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466233 */     // MIs[0] policy
     /* 1466233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466243 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1466246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466267 */     // GIR_Coverage, 20954,
     /* 1466267 */     GIR_EraseRootFromParent_Done,
     /* 1466268 */   // Label 20441: @1466268
     /* 1466268 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1466350), // Rule ID 20955 //
     /* 1466273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1466276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1466284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1466287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1466290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1466293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466312 */     // MIs[0] round
     /* 1466312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466315 */     // MIs[0] policy
     /* 1466315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1466328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466336 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466349 */     // GIR_Coverage, 20955,
     /* 1466349 */     GIR_EraseRootFromParent_Done,
     /* 1466350 */   // Label 20442: @1466350
     /* 1466350 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1466432), // Rule ID 20958 //
     /* 1466355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1466358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1466366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1466369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1466372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1466375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466394 */     // MIs[0] round
     /* 1466394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466397 */     // MIs[0] policy
     /* 1466397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466407 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1466410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466431 */     // GIR_Coverage, 20958,
     /* 1466431 */     GIR_EraseRootFromParent_Done,
     /* 1466432 */   // Label 20443: @1466432
     /* 1466432 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1466514), // Rule ID 20959 //
     /* 1466437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1466440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1466445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1466448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1466451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1466454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1466457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466476 */     // MIs[0] round
     /* 1466476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466479 */     // MIs[0] policy
     /* 1466479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466489 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1466492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466500 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466513 */     // GIR_Coverage, 20959,
     /* 1466513 */     GIR_EraseRootFromParent_Done,
     /* 1466514 */   // Label 20444: @1466514
     /* 1466514 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1466596), // Rule ID 21034 //
     /* 1466519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1466522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1466539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466558 */     // MIs[0] round
     /* 1466558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466561 */     // MIs[0] policy
     /* 1466561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466571 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1466574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466595 */     // GIR_Coverage, 21034,
     /* 1466595 */     GIR_EraseRootFromParent_Done,
     /* 1466596 */   // Label 20445: @1466596
     /* 1466596 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1466678), // Rule ID 21035 //
     /* 1466601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1466604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1466621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466640 */     // MIs[0] round
     /* 1466640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466643 */     // MIs[0] policy
     /* 1466643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466653 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1466656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466664 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466677 */     // GIR_Coverage, 21035,
     /* 1466677 */     GIR_EraseRootFromParent_Done,
     /* 1466678 */   // Label 20446: @1466678
     /* 1466678 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1466760), // Rule ID 21038 //
     /* 1466683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1466686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1466694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1466697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1466703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466722 */     // MIs[0] round
     /* 1466722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466725 */     // MIs[0] policy
     /* 1466725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466735 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1466738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466759 */     // GIR_Coverage, 21038,
     /* 1466759 */     GIR_EraseRootFromParent_Done,
     /* 1466760 */   // Label 20447: @1466760
     /* 1466760 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1466842), // Rule ID 21039 //
     /* 1466765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1466768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1466776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1466779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1466785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466804 */     // MIs[0] round
     /* 1466804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466807 */     // MIs[0] policy
     /* 1466807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466817 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10987:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1466820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466828 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466841 */     // GIR_Coverage, 21039,
     /* 1466841 */     GIR_EraseRootFromParent_Done,
     /* 1466842 */   // Label 20448: @1466842
     /* 1466842 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1466924), // Rule ID 21042 //
     /* 1466847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1466850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1466864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1466867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466886 */     // MIs[0] round
     /* 1466886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466889 */     // MIs[0] policy
     /* 1466889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1466902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466923 */     // GIR_Coverage, 21042,
     /* 1466923 */     GIR_EraseRootFromParent_Done,
     /* 1466924 */   // Label 20449: @1466924
     /* 1466924 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1467006), // Rule ID 21043 //
     /* 1466929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1466932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1466937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1466946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1466949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466968 */     // MIs[0] round
     /* 1466968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1466971 */     // MIs[0] policy
     /* 1466971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1466984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1466990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1466992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1466994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467005 */     // GIR_Coverage, 21043,
     /* 1467005 */     GIR_EraseRootFromParent_Done,
     /* 1467006 */   // Label 20450: @1467006
     /* 1467006 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1467088), // Rule ID 21046 //
     /* 1467011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1467014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1467028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1467031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467050 */     // MIs[0] round
     /* 1467050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467053 */     // MIs[0] policy
     /* 1467053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467063 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1467066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467087 */     // GIR_Coverage, 21046,
     /* 1467087 */     GIR_EraseRootFromParent_Done,
     /* 1467088 */   // Label 20451: @1467088
     /* 1467088 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1467170), // Rule ID 21047 //
     /* 1467093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1467096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1467110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1467113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467132 */     // MIs[0] round
     /* 1467132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467135 */     // MIs[0] policy
     /* 1467135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467145 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1467148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467156 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467169 */     // GIR_Coverage, 21047,
     /* 1467169 */     GIR_EraseRootFromParent_Done,
     /* 1467170 */   // Label 20452: @1467170
     /* 1467170 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1467252), // Rule ID 21050 //
     /* 1467175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1467178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1467192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1467195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467214 */     // MIs[0] round
     /* 1467214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467217 */     // MIs[0] policy
     /* 1467217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1467230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467238 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467251 */     // GIR_Coverage, 21050,
     /* 1467251 */     GIR_EraseRootFromParent_Done,
     /* 1467252 */   // Label 20453: @1467252
     /* 1467252 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1467334), // Rule ID 21051 //
     /* 1467257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1467260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1467274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1467277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467296 */     // MIs[0] round
     /* 1467296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467299 */     // MIs[0] policy
     /* 1467299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467309 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1467312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467320 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467333 */     // GIR_Coverage, 21051,
     /* 1467333 */     GIR_EraseRootFromParent_Done,
     /* 1467334 */   // Label 20454: @1467334
     /* 1467334 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1467416), // Rule ID 21054 //
     /* 1467339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1467342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1467356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1467359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467378 */     // MIs[0] round
     /* 1467378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467381 */     // MIs[0] policy
     /* 1467381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1467394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467402 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467415 */     // GIR_Coverage, 21054,
     /* 1467415 */     GIR_EraseRootFromParent_Done,
     /* 1467416 */   // Label 20455: @1467416
     /* 1467416 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1467498), // Rule ID 21055 //
     /* 1467421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1467424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1467438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1467441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467460 */     // MIs[0] round
     /* 1467460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467463 */     // MIs[0] policy
     /* 1467463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10987:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1467476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467497 */     // GIR_Coverage, 21055,
     /* 1467497 */     GIR_EraseRootFromParent_Done,
     /* 1467498 */   // Label 20456: @1467498
     /* 1467498 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1467580), // Rule ID 21058 //
     /* 1467503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1467506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1467523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467542 */     // MIs[0] round
     /* 1467542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467545 */     // MIs[0] policy
     /* 1467545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1467558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467579 */     // GIR_Coverage, 21058,
     /* 1467579 */     GIR_EraseRootFromParent_Done,
     /* 1467580 */   // Label 20457: @1467580
     /* 1467580 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1467662), // Rule ID 21059 //
     /* 1467585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1467588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1467605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467624 */     // MIs[0] round
     /* 1467624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467627 */     // MIs[0] policy
     /* 1467627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10987:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1467640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467648 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467661 */     // GIR_Coverage, 21059,
     /* 1467661 */     GIR_EraseRootFromParent_Done,
     /* 1467662 */   // Label 20458: @1467662
     /* 1467662 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1467744), // Rule ID 21062 //
     /* 1467667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1467670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1467687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467706 */     // MIs[0] round
     /* 1467706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467709 */     // MIs[0] policy
     /* 1467709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1467722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467743 */     // GIR_Coverage, 21062,
     /* 1467743 */     GIR_EraseRootFromParent_Done,
     /* 1467744 */   // Label 20459: @1467744
     /* 1467744 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1467826), // Rule ID 21063 //
     /* 1467749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1467752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1467769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467788 */     // MIs[0] round
     /* 1467788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467791 */     // MIs[0] policy
     /* 1467791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10987:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1467804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467810 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467825 */     // GIR_Coverage, 21063,
     /* 1467825 */     GIR_EraseRootFromParent_Done,
     /* 1467826 */   // Label 20460: @1467826
     /* 1467826 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1467908), // Rule ID 21066 //
     /* 1467831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1467834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1467851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467870 */     // MIs[0] round
     /* 1467870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467873 */     // MIs[0] policy
     /* 1467873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1467886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467894 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467907 */     // GIR_Coverage, 21066,
     /* 1467907 */     GIR_EraseRootFromParent_Done,
     /* 1467908 */   // Label 20461: @1467908
     /* 1467908 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1467990), // Rule ID 21067 //
     /* 1467913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1467916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1467921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1467933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467952 */     // MIs[0] round
     /* 1467952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1467955 */     // MIs[0] policy
     /* 1467955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467965 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10987:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1467968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1467974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1467976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1467978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467989 */     // GIR_Coverage, 21067,
     /* 1467989 */     GIR_EraseRootFromParent_Done,
     /* 1467990 */   // Label 20462: @1467990
     /* 1467990 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1468072), // Rule ID 21070 //
     /* 1467995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1467998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1468015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468034 */     // MIs[0] round
     /* 1468034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468037 */     // MIs[0] policy
     /* 1468037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468047 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1468050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468058 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468071 */     // GIR_Coverage, 21070,
     /* 1468071 */     GIR_EraseRootFromParent_Done,
     /* 1468072 */   // Label 20463: @1468072
     /* 1468072 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1468154), // Rule ID 21071 //
     /* 1468077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1468080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1468097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468116 */     // MIs[0] round
     /* 1468116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468119 */     // MIs[0] policy
     /* 1468119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1468132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468153 */     // GIR_Coverage, 21071,
     /* 1468153 */     GIR_EraseRootFromParent_Done,
     /* 1468154 */   // Label 20464: @1468154
     /* 1468154 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1468236), // Rule ID 21074 //
     /* 1468159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1468162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1468170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1468173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1468179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468198 */     // MIs[0] round
     /* 1468198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468201 */     // MIs[0] policy
     /* 1468201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468211 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1468214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468222 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468235 */     // GIR_Coverage, 21074,
     /* 1468235 */     GIR_EraseRootFromParent_Done,
     /* 1468236 */   // Label 20465: @1468236
     /* 1468236 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1468318), // Rule ID 21075 //
     /* 1468241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1468244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1468252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1468255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1468261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468280 */     // MIs[0] round
     /* 1468280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468283 */     // MIs[0] policy
     /* 1468283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10985:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1468296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468317 */     // GIR_Coverage, 21075,
     /* 1468317 */     GIR_EraseRootFromParent_Done,
     /* 1468318 */   // Label 20466: @1468318
     /* 1468318 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1468400), // Rule ID 21078 //
     /* 1468323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1468326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1468334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1468337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1468340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1468343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468362 */     // MIs[0] round
     /* 1468362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468365 */     // MIs[0] policy
     /* 1468365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1468378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468399 */     // GIR_Coverage, 21078,
     /* 1468399 */     GIR_EraseRootFromParent_Done,
     /* 1468400 */   // Label 20467: @1468400
     /* 1468400 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1468482), // Rule ID 21079 //
     /* 1468405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1468408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1468416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1468419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1468422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1468425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468444 */     // MIs[0] round
     /* 1468444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468447 */     // MIs[0] policy
     /* 1468447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1468460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468481 */     // GIR_Coverage, 21079,
     /* 1468481 */     GIR_EraseRootFromParent_Done,
     /* 1468482 */   // Label 20468: @1468482
     /* 1468482 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1468564), // Rule ID 21082 //
     /* 1468487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1468490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1468498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1468501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1468507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468526 */     // MIs[0] round
     /* 1468526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468529 */     // MIs[0] policy
     /* 1468529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1468542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468563 */     // GIR_Coverage, 21082,
     /* 1468563 */     GIR_EraseRootFromParent_Done,
     /* 1468564 */   // Label 20469: @1468564
     /* 1468564 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1468646), // Rule ID 21083 //
     /* 1468569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1468572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1468580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1468583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1468589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468608 */     // MIs[0] round
     /* 1468608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468611 */     // MIs[0] policy
     /* 1468611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1468624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468645 */     // GIR_Coverage, 21083,
     /* 1468645 */     GIR_EraseRootFromParent_Done,
     /* 1468646 */   // Label 20470: @1468646
     /* 1468646 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1468728), // Rule ID 21086 //
     /* 1468651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1468654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1468662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1468665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1468671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468690 */     // MIs[0] round
     /* 1468690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468693 */     // MIs[0] policy
     /* 1468693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468703 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1468706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468714 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468727 */     // GIR_Coverage, 21086,
     /* 1468727 */     GIR_EraseRootFromParent_Done,
     /* 1468728 */   // Label 20471: @1468728
     /* 1468728 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1468810), // Rule ID 21087 //
     /* 1468733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1468736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1468744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1468747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1468753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468772 */     // MIs[0] round
     /* 1468772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468775 */     // MIs[0] policy
     /* 1468775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468785 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1468788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468809 */     // GIR_Coverage, 21087,
     /* 1468809 */     GIR_EraseRootFromParent_Done,
     /* 1468810 */   // Label 20472: @1468810
     /* 1468810 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1468892), // Rule ID 21090 //
     /* 1468815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1468818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1468826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1468829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1468835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468854 */     // MIs[0] round
     /* 1468854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468857 */     // MIs[0] policy
     /* 1468857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468867 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1468870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468878 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1468888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468891 */     // GIR_Coverage, 21090,
     /* 1468891 */     GIR_EraseRootFromParent_Done,
     /* 1468892 */   // Label 20473: @1468892
     /* 1468892 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1468974), // Rule ID 21091 //
     /* 1468897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1468900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1468908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1468911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1468917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468936 */     // MIs[0] round
     /* 1468936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1468939 */     // MIs[0] policy
     /* 1468939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10985:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1468952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1468958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1468960 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1468962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1468970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468973 */     // GIR_Coverage, 21091,
     /* 1468973 */     GIR_EraseRootFromParent_Done,
     /* 1468974 */   // Label 20474: @1468974
     /* 1468974 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1469056), // Rule ID 21094 //
     /* 1468979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1468982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1468987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1468990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1468993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1468996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1468999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469018 */     // MIs[0] round
     /* 1469018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469021 */     // MIs[0] policy
     /* 1469021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1469034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469040 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469042 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469055 */     // GIR_Coverage, 21094,
     /* 1469055 */     GIR_EraseRootFromParent_Done,
     /* 1469056 */   // Label 20475: @1469056
     /* 1469056 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1469138), // Rule ID 21095 //
     /* 1469061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1469064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1469069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1469072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1469075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1469081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469100 */     // MIs[0] round
     /* 1469100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469103 */     // MIs[0] policy
     /* 1469103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469113 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10985:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1469116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469137 */     // GIR_Coverage, 21095,
     /* 1469137 */     GIR_EraseRootFromParent_Done,
     /* 1469138 */   // Label 20476: @1469138
     /* 1469138 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1469220), // Rule ID 21098 //
     /* 1469143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1469146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1469151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1469160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1469163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469182 */     // MIs[0] round
     /* 1469182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469185 */     // MIs[0] policy
     /* 1469185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469195 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1469198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469219 */     // GIR_Coverage, 21098,
     /* 1469219 */     GIR_EraseRootFromParent_Done,
     /* 1469220 */   // Label 20477: @1469220
     /* 1469220 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1469302), // Rule ID 21099 //
     /* 1469225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1469228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1469233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1469242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1469245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469264 */     // MIs[0] round
     /* 1469264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469267 */     // MIs[0] policy
     /* 1469267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469277 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10985:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1469280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469288 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469301 */     // GIR_Coverage, 21099,
     /* 1469301 */     GIR_EraseRootFromParent_Done,
     /* 1469302 */   // Label 20478: @1469302
     /* 1469302 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1469384), // Rule ID 21102 //
     /* 1469307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1469310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1469315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1469318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1469321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1469327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469346 */     // MIs[0] round
     /* 1469346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469349 */     // MIs[0] policy
     /* 1469349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469359 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1469362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469370 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469383 */     // GIR_Coverage, 21102,
     /* 1469383 */     GIR_EraseRootFromParent_Done,
     /* 1469384 */   // Label 20479: @1469384
     /* 1469384 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1469466), // Rule ID 21103 //
     /* 1469389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1469392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1469397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1469400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1469403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1469409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469428 */     // MIs[0] round
     /* 1469428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469431 */     // MIs[0] policy
     /* 1469431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469441 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10985:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1469444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469465 */     // GIR_Coverage, 21103,
     /* 1469465 */     GIR_EraseRootFromParent_Done,
     /* 1469466 */   // Label 20480: @1469466
     /* 1469466 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1469548), // Rule ID 21454 //
     /* 1469471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1469474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1469482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1469485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1469491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469510 */     // MIs[0] round
     /* 1469510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469513 */     // MIs[0] policy
     /* 1469513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469523 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1469526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469534 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469547 */     // GIR_Coverage, 21454,
     /* 1469547 */     GIR_EraseRootFromParent_Done,
     /* 1469548 */   // Label 20481: @1469548
     /* 1469548 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1469630), // Rule ID 21455 //
     /* 1469553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1469556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1469564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1469567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1469573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469592 */     // MIs[0] round
     /* 1469592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469595 */     // MIs[0] policy
     /* 1469595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469605 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1469608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469629 */     // GIR_Coverage, 21455,
     /* 1469629 */     GIR_EraseRootFromParent_Done,
     /* 1469630 */   // Label 20482: @1469630
     /* 1469630 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1469712), // Rule ID 21458 //
     /* 1469635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1469638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1469646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1469649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1469655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469674 */     // MIs[0] round
     /* 1469674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469677 */     // MIs[0] policy
     /* 1469677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469687 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1469690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469698 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469711 */     // GIR_Coverage, 21458,
     /* 1469711 */     GIR_EraseRootFromParent_Done,
     /* 1469712 */   // Label 20483: @1469712
     /* 1469712 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1469794), // Rule ID 21459 //
     /* 1469717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1469720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1469728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1469731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1469737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469756 */     // MIs[0] round
     /* 1469756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469759 */     // MIs[0] policy
     /* 1469759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1469772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469793 */     // GIR_Coverage, 21459,
     /* 1469793 */     GIR_EraseRootFromParent_Done,
     /* 1469794 */   // Label 20484: @1469794
     /* 1469794 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1469876), // Rule ID 21462 //
     /* 1469799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1469802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1469810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1469813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1469819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469838 */     // MIs[0] round
     /* 1469838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469841 */     // MIs[0] policy
     /* 1469841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469851 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1469854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469862 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469875 */     // GIR_Coverage, 21462,
     /* 1469875 */     GIR_EraseRootFromParent_Done,
     /* 1469876 */   // Label 20485: @1469876
     /* 1469876 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1469958), // Rule ID 21463 //
     /* 1469881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1469884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1469892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1469895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1469901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469920 */     // MIs[0] round
     /* 1469920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1469923 */     // MIs[0] policy
     /* 1469923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469933 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1469936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1469942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1469944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1469946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469957 */     // GIR_Coverage, 21463,
     /* 1469957 */     GIR_EraseRootFromParent_Done,
     /* 1469958 */   // Label 20486: @1469958
     /* 1469958 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1470040), // Rule ID 21466 //
     /* 1469963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1469966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1469971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1469980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1469983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470002 */     // MIs[0] round
     /* 1470002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470005 */     // MIs[0] policy
     /* 1470005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1470018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470026 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470039 */     // GIR_Coverage, 21466,
     /* 1470039 */     GIR_EraseRootFromParent_Done,
     /* 1470040 */   // Label 20487: @1470040
     /* 1470040 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1470122), // Rule ID 21467 //
     /* 1470045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1470048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1470056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1470059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1470065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470084 */     // MIs[0] round
     /* 1470084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470087 */     // MIs[0] policy
     /* 1470087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470097 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1470100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470108 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470121 */     // GIR_Coverage, 21467,
     /* 1470121 */     GIR_EraseRootFromParent_Done,
     /* 1470122 */   // Label 20488: @1470122
     /* 1470122 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1470204), // Rule ID 21470 //
     /* 1470127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1470130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1470147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470166 */     // MIs[0] round
     /* 1470166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470169 */     // MIs[0] policy
     /* 1470169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1470182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470203 */     // GIR_Coverage, 21470,
     /* 1470203 */     GIR_EraseRootFromParent_Done,
     /* 1470204 */   // Label 20489: @1470204
     /* 1470204 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1470286), // Rule ID 21471 //
     /* 1470209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1470212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1470229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470248 */     // MIs[0] round
     /* 1470248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470251 */     // MIs[0] policy
     /* 1470251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1470264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470270 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470272 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470285 */     // GIR_Coverage, 21471,
     /* 1470285 */     GIR_EraseRootFromParent_Done,
     /* 1470286 */   // Label 20490: @1470286
     /* 1470286 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1470368), // Rule ID 21474 //
     /* 1470291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1470294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1470311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470330 */     // MIs[0] round
     /* 1470330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470333 */     // MIs[0] policy
     /* 1470333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1470346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470367 */     // GIR_Coverage, 21474,
     /* 1470367 */     GIR_EraseRootFromParent_Done,
     /* 1470368 */   // Label 20491: @1470368
     /* 1470368 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1470450), // Rule ID 21475 //
     /* 1470373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1470376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1470393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470412 */     // MIs[0] round
     /* 1470412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470415 */     // MIs[0] policy
     /* 1470415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470425 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1470428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470449 */     // GIR_Coverage, 21475,
     /* 1470449 */     GIR_EraseRootFromParent_Done,
     /* 1470450 */   // Label 20492: @1470450
     /* 1470450 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1470532), // Rule ID 21478 //
     /* 1470455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1470458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1470472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1470475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470494 */     // MIs[0] round
     /* 1470494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470497 */     // MIs[0] policy
     /* 1470497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470507 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1470510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470518 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470531 */     // GIR_Coverage, 21478,
     /* 1470531 */     GIR_EraseRootFromParent_Done,
     /* 1470532 */   // Label 20493: @1470532
     /* 1470532 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1470614), // Rule ID 21479 //
     /* 1470537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1470540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1470554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1470557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470576 */     // MIs[0] round
     /* 1470576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470579 */     // MIs[0] policy
     /* 1470579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1470592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470613 */     // GIR_Coverage, 21479,
     /* 1470613 */     GIR_EraseRootFromParent_Done,
     /* 1470614 */   // Label 20494: @1470614
     /* 1470614 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1470696), // Rule ID 21482 //
     /* 1470619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1470622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1470630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1470633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1470639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470658 */     // MIs[0] round
     /* 1470658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470661 */     // MIs[0] policy
     /* 1470661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1470674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470682 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470695 */     // GIR_Coverage, 21482,
     /* 1470695 */     GIR_EraseRootFromParent_Done,
     /* 1470696 */   // Label 20495: @1470696
     /* 1470696 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1470778), // Rule ID 21483 //
     /* 1470701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1470704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1470712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1470715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1470721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470740 */     // MIs[0] round
     /* 1470740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470743 */     // MIs[0] policy
     /* 1470743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470753 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1470756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470777 */     // GIR_Coverage, 21483,
     /* 1470777 */     GIR_EraseRootFromParent_Done,
     /* 1470778 */   // Label 20496: @1470778
     /* 1470778 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1470860), // Rule ID 21486 //
     /* 1470783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1470786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1470794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1470797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1470800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1470803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470822 */     // MIs[0] round
     /* 1470822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470825 */     // MIs[0] policy
     /* 1470825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1470838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470846 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470859 */     // GIR_Coverage, 21486,
     /* 1470859 */     GIR_EraseRootFromParent_Done,
     /* 1470860 */   // Label 20497: @1470860
     /* 1470860 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1470942), // Rule ID 21487 //
     /* 1470865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1470868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1470876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1470879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1470882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1470885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470904 */     // MIs[0] round
     /* 1470904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470907 */     // MIs[0] policy
     /* 1470907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470917 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1470920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1470926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1470928 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1470930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470941 */     // GIR_Coverage, 21487,
     /* 1470941 */     GIR_EraseRootFromParent_Done,
     /* 1470942 */   // Label 20498: @1470942
     /* 1470942 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1471024), // Rule ID 21490 //
     /* 1470947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1470950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1470955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1470964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1470967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470986 */     // MIs[0] round
     /* 1470986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1470989 */     // MIs[0] policy
     /* 1470989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1471002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471010 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471023 */     // GIR_Coverage, 21490,
     /* 1471023 */     GIR_EraseRootFromParent_Done,
     /* 1471024 */   // Label 20499: @1471024
     /* 1471024 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1471106), // Rule ID 21491 //
     /* 1471029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1471032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1471040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1471043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1471049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471068 */     // MIs[0] round
     /* 1471068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471071 */     // MIs[0] policy
     /* 1471071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1471084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471092 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471105 */     // GIR_Coverage, 21491,
     /* 1471105 */     GIR_EraseRootFromParent_Done,
     /* 1471106 */   // Label 20500: @1471106
     /* 1471106 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1471188), // Rule ID 21494 //
     /* 1471111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1471114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1471131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471150 */     // MIs[0] round
     /* 1471150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471153 */     // MIs[0] policy
     /* 1471153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1471166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471187 */     // GIR_Coverage, 21494,
     /* 1471187 */     GIR_EraseRootFromParent_Done,
     /* 1471188 */   // Label 20501: @1471188
     /* 1471188 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1471270), // Rule ID 21495 //
     /* 1471193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1471196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1471213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471232 */     // MIs[0] round
     /* 1471232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471235 */     // MIs[0] policy
     /* 1471235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1471248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471269 */     // GIR_Coverage, 21495,
     /* 1471269 */     GIR_EraseRootFromParent_Done,
     /* 1471270 */   // Label 20502: @1471270
     /* 1471270 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1471352), // Rule ID 21498 //
     /* 1471275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1471278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1471295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471314 */     // MIs[0] round
     /* 1471314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471317 */     // MIs[0] policy
     /* 1471317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471327 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1471330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471338 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471351 */     // GIR_Coverage, 21498,
     /* 1471351 */     GIR_EraseRootFromParent_Done,
     /* 1471352 */   // Label 20503: @1471352
     /* 1471352 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1471434), // Rule ID 21499 //
     /* 1471357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1471360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1471377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471396 */     // MIs[0] round
     /* 1471396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471399 */     // MIs[0] policy
     /* 1471399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1471412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471418 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471433 */     // GIR_Coverage, 21499,
     /* 1471433 */     GIR_EraseRootFromParent_Done,
     /* 1471434 */   // Label 20504: @1471434
     /* 1471434 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1471516), // Rule ID 21502 //
     /* 1471439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1471442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1471459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471478 */     // MIs[0] round
     /* 1471478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471481 */     // MIs[0] policy
     /* 1471481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471491 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1471494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471502 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471515 */     // GIR_Coverage, 21502,
     /* 1471515 */     GIR_EraseRootFromParent_Done,
     /* 1471516 */   // Label 20505: @1471516
     /* 1471516 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1471598), // Rule ID 21503 //
     /* 1471521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1471524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1471541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471560 */     // MIs[0] round
     /* 1471560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471563 */     // MIs[0] policy
     /* 1471563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471573 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1471576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471597 */     // GIR_Coverage, 21503,
     /* 1471597 */     GIR_EraseRootFromParent_Done,
     /* 1471598 */   // Label 20506: @1471598
     /* 1471598 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1471680), // Rule ID 21506 //
     /* 1471603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1471606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1471623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471642 */     // MIs[0] round
     /* 1471642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471645 */     // MIs[0] policy
     /* 1471645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1471658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471666 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471679 */     // GIR_Coverage, 21506,
     /* 1471679 */     GIR_EraseRootFromParent_Done,
     /* 1471680 */   // Label 20507: @1471680
     /* 1471680 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1471762), // Rule ID 21507 //
     /* 1471685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1471688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1471705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471724 */     // MIs[0] round
     /* 1471724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471727 */     // MIs[0] policy
     /* 1471727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1471740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471748 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471761 */     // GIR_Coverage, 21507,
     /* 1471761 */     GIR_EraseRootFromParent_Done,
     /* 1471762 */   // Label 20508: @1471762
     /* 1471762 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1471844), // Rule ID 21510 //
     /* 1471767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1471770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1471784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1471787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471806 */     // MIs[0] round
     /* 1471806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471809 */     // MIs[0] policy
     /* 1471809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1471822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471843 */     // GIR_Coverage, 21510,
     /* 1471843 */     GIR_EraseRootFromParent_Done,
     /* 1471844 */   // Label 20509: @1471844
     /* 1471844 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1471926), // Rule ID 21511 //
     /* 1471849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1471852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1471857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1471866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1471869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471888 */     // MIs[0] round
     /* 1471888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471891 */     // MIs[0] policy
     /* 1471891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471901 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1471904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471925 */     // GIR_Coverage, 21511,
     /* 1471925 */     GIR_EraseRootFromParent_Done,
     /* 1471926 */   // Label 20510: @1471926
     /* 1471926 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1472008), // Rule ID 21514 //
     /* 1471931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1471934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1471939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1471942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1471945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1471948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1471951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471970 */     // MIs[0] round
     /* 1471970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1471973 */     // MIs[0] policy
     /* 1471973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471983 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1471986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1471992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1471994 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1471996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472007 */     // GIR_Coverage, 21514,
     /* 1472007 */     GIR_EraseRootFromParent_Done,
     /* 1472008 */   // Label 20511: @1472008
     /* 1472008 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1472090), // Rule ID 21515 //
     /* 1472013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1472030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1472033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472052 */     // MIs[0] round
     /* 1472052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472055 */     // MIs[0] policy
     /* 1472055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472065 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1472068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472076 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472089 */     // GIR_Coverage, 21515,
     /* 1472089 */     GIR_EraseRootFromParent_Done,
     /* 1472090 */   // Label 20512: @1472090
     /* 1472090 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1472172), // Rule ID 21518 //
     /* 1472095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1472098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1472112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1472115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472134 */     // MIs[0] round
     /* 1472134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472137 */     // MIs[0] policy
     /* 1472137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472147 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1472150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472158 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472171 */     // GIR_Coverage, 21518,
     /* 1472171 */     GIR_EraseRootFromParent_Done,
     /* 1472172 */   // Label 20513: @1472172
     /* 1472172 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1472254), // Rule ID 21519 //
     /* 1472177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1472194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1472197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472216 */     // MIs[0] round
     /* 1472216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472219 */     // MIs[0] policy
     /* 1472219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472229 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1472232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472253 */     // GIR_Coverage, 21519,
     /* 1472253 */     GIR_EraseRootFromParent_Done,
     /* 1472254 */   // Label 20514: @1472254
     /* 1472254 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1472336), // Rule ID 21522 //
     /* 1472259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1472262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1472276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1472279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472298 */     // MIs[0] round
     /* 1472298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472301 */     // MIs[0] policy
     /* 1472301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472311 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1472314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472322 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472335 */     // GIR_Coverage, 21522,
     /* 1472335 */     GIR_EraseRootFromParent_Done,
     /* 1472336 */   // Label 20515: @1472336
     /* 1472336 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1472418), // Rule ID 21523 //
     /* 1472341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1472358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1472361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472380 */     // MIs[0] round
     /* 1472380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472383 */     // MIs[0] policy
     /* 1472383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1472396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472404 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472417 */     // GIR_Coverage, 21523,
     /* 1472417 */     GIR_EraseRootFromParent_Done,
     /* 1472418 */   // Label 20516: @1472418
     /* 1472418 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1472500), // Rule ID 21526 //
     /* 1472423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1472426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1472434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1472437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1472443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472462 */     // MIs[0] round
     /* 1472462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472465 */     // MIs[0] policy
     /* 1472465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472475 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1472478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472486 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472499 */     // GIR_Coverage, 21526,
     /* 1472499 */     GIR_EraseRootFromParent_Done,
     /* 1472500 */   // Label 20517: @1472500
     /* 1472500 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1472582), // Rule ID 21527 //
     /* 1472505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1472516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1472519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1472525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472544 */     // MIs[0] round
     /* 1472544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472547 */     // MIs[0] policy
     /* 1472547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10927:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1472560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472581 */     // GIR_Coverage, 21527,
     /* 1472581 */     GIR_EraseRootFromParent_Done,
     /* 1472582 */   // Label 20518: @1472582
     /* 1472582 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1472664), // Rule ID 21530 //
     /* 1472587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1472590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1472598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1472601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1472607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472626 */     // MIs[0] round
     /* 1472626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472629 */     // MIs[0] policy
     /* 1472629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1472642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472648 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472650 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472663 */     // GIR_Coverage, 21530,
     /* 1472663 */     GIR_EraseRootFromParent_Done,
     /* 1472664 */   // Label 20519: @1472664
     /* 1472664 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1472746), // Rule ID 21531 //
     /* 1472669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1472680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1472683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1472689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472708 */     // MIs[0] round
     /* 1472708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472711 */     // MIs[0] policy
     /* 1472711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1472724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472745 */     // GIR_Coverage, 21531,
     /* 1472745 */     GIR_EraseRootFromParent_Done,
     /* 1472746 */   // Label 20520: @1472746
     /* 1472746 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1472828), // Rule ID 21534 //
     /* 1472751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1472754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1472768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1472771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472790 */     // MIs[0] round
     /* 1472790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472793 */     // MIs[0] policy
     /* 1472793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472803 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1472806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472827 */     // GIR_Coverage, 21534,
     /* 1472827 */     GIR_EraseRootFromParent_Done,
     /* 1472828 */   // Label 20521: @1472828
     /* 1472828 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1472910), // Rule ID 21535 //
     /* 1472833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1472836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1472850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1472853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472872 */     // MIs[0] round
     /* 1472872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472875 */     // MIs[0] policy
     /* 1472875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472885 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1472888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472896 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472909 */     // GIR_Coverage, 21535,
     /* 1472909 */     GIR_EraseRootFromParent_Done,
     /* 1472910 */   // Label 20522: @1472910
     /* 1472910 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1472992), // Rule ID 21538 //
     /* 1472915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1472918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1472923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1472926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1472929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1472932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1472935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472954 */     // MIs[0] round
     /* 1472954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1472957 */     // MIs[0] policy
     /* 1472957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472967 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1472970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1472976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1472978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1472980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472991 */     // GIR_Coverage, 21538,
     /* 1472991 */     GIR_EraseRootFromParent_Done,
     /* 1472992 */   // Label 20523: @1472992
     /* 1472992 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1473074), // Rule ID 21539 //
     /* 1472997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1473000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1473017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473036 */     // MIs[0] round
     /* 1473036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473039 */     // MIs[0] policy
     /* 1473039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473049 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1473052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473073 */     // GIR_Coverage, 21539,
     /* 1473073 */     GIR_EraseRootFromParent_Done,
     /* 1473074 */   // Label 20524: @1473074
     /* 1473074 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1473156), // Rule ID 21542 //
     /* 1473079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1473082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1473099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473118 */     // MIs[0] round
     /* 1473118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473121 */     // MIs[0] policy
     /* 1473121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473131 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1473134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473142 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473155 */     // GIR_Coverage, 21542,
     /* 1473155 */     GIR_EraseRootFromParent_Done,
     /* 1473156 */   // Label 20525: @1473156
     /* 1473156 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1473238), // Rule ID 21543 //
     /* 1473161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1473164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1473181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473200 */     // MIs[0] round
     /* 1473200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473203 */     // MIs[0] policy
     /* 1473203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473213 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1473216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473237 */     // GIR_Coverage, 21543,
     /* 1473237 */     GIR_EraseRootFromParent_Done,
     /* 1473238 */   // Label 20526: @1473238
     /* 1473238 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1473320), // Rule ID 21546 //
     /* 1473243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1473246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1473263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473282 */     // MIs[0] round
     /* 1473282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473285 */     // MIs[0] policy
     /* 1473285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1473298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473319 */     // GIR_Coverage, 21546,
     /* 1473319 */     GIR_EraseRootFromParent_Done,
     /* 1473320 */   // Label 20527: @1473320
     /* 1473320 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1473402), // Rule ID 21547 //
     /* 1473325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1473328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1473345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473364 */     // MIs[0] round
     /* 1473364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473367 */     // MIs[0] policy
     /* 1473367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10927:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1473380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473401 */     // GIR_Coverage, 21547,
     /* 1473401 */     GIR_EraseRootFromParent_Done,
     /* 1473402 */   // Label 20528: @1473402
     /* 1473402 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1473484), // Rule ID 21550 //
     /* 1473407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1473410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1473418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1473421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1473427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473446 */     // MIs[0] round
     /* 1473446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473449 */     // MIs[0] policy
     /* 1473449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1473462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473483 */     // GIR_Coverage, 21550,
     /* 1473483 */     GIR_EraseRootFromParent_Done,
     /* 1473484 */   // Label 20529: @1473484
     /* 1473484 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1473566), // Rule ID 21551 //
     /* 1473489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1473492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1473500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1473503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1473509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473528 */     // MIs[0] round
     /* 1473528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473531 */     // MIs[0] policy
     /* 1473531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1473544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473565 */     // GIR_Coverage, 21551,
     /* 1473565 */     GIR_EraseRootFromParent_Done,
     /* 1473566 */   // Label 20530: @1473566
     /* 1473566 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1473648), // Rule ID 21554 //
     /* 1473571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1473574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1473582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1473585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1473591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473610 */     // MIs[0] round
     /* 1473610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473613 */     // MIs[0] policy
     /* 1473613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473623 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1473626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473647 */     // GIR_Coverage, 21554,
     /* 1473647 */     GIR_EraseRootFromParent_Done,
     /* 1473648 */   // Label 20531: @1473648
     /* 1473648 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1473730), // Rule ID 21555 //
     /* 1473653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1473656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1473664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1473667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1473673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473692 */     // MIs[0] round
     /* 1473692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473695 */     // MIs[0] policy
     /* 1473695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473705 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1473708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473716 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473729 */     // GIR_Coverage, 21555,
     /* 1473729 */     GIR_EraseRootFromParent_Done,
     /* 1473730 */   // Label 20532: @1473730
     /* 1473730 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1473812), // Rule ID 21558 //
     /* 1473735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1473738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1473752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1473755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473774 */     // MIs[0] round
     /* 1473774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473777 */     // MIs[0] policy
     /* 1473777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473787 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1473790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473811 */     // GIR_Coverage, 21558,
     /* 1473811 */     GIR_EraseRootFromParent_Done,
     /* 1473812 */   // Label 20533: @1473812
     /* 1473812 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1473894), // Rule ID 21559 //
     /* 1473817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1473820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1473834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1473837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473856 */     // MIs[0] round
     /* 1473856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473859 */     // MIs[0] policy
     /* 1473859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1473872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473880 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473893 */     // GIR_Coverage, 21559,
     /* 1473893 */     GIR_EraseRootFromParent_Done,
     /* 1473894 */   // Label 20534: @1473894
     /* 1473894 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1473976), // Rule ID 21562 //
     /* 1473899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1473902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1473919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473938 */     // MIs[0] round
     /* 1473938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1473941 */     // MIs[0] policy
     /* 1473941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1473954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1473960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1473962 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1473964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473975 */     // GIR_Coverage, 21562,
     /* 1473975 */     GIR_EraseRootFromParent_Done,
     /* 1473976 */   // Label 20535: @1473976
     /* 1473976 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1474058), // Rule ID 21563 //
     /* 1473981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1473984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1473989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1474001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474020 */     // MIs[0] round
     /* 1474020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474023 */     // MIs[0] policy
     /* 1474023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1474036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474044 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474057 */     // GIR_Coverage, 21563,
     /* 1474057 */     GIR_EraseRootFromParent_Done,
     /* 1474058 */   // Label 20536: @1474058
     /* 1474058 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1474140), // Rule ID 21566 //
     /* 1474063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1474066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1474071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1474074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1474077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1474080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1474083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474102 */     // MIs[0] round
     /* 1474102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474105 */     // MIs[0] policy
     /* 1474105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1474118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474139 */     // GIR_Coverage, 21566,
     /* 1474139 */     GIR_EraseRootFromParent_Done,
     /* 1474140 */   // Label 20537: @1474140
     /* 1474140 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1474222), // Rule ID 21567 //
     /* 1474145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1474148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1474153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1474156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1474159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1474162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1474165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474184 */     // MIs[0] round
     /* 1474184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474187 */     // MIs[0] policy
     /* 1474187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1474200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474208 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474221 */     // GIR_Coverage, 21567,
     /* 1474221 */     GIR_EraseRootFromParent_Done,
     /* 1474222 */   // Label 20538: @1474222
     /* 1474222 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1474304), // Rule ID 21570 //
     /* 1474227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1474230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1474235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1474238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1474241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1474247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474266 */     // MIs[0] round
     /* 1474266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474269 */     // MIs[0] policy
     /* 1474269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474279 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1474282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474290 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474303 */     // GIR_Coverage, 21570,
     /* 1474303 */     GIR_EraseRootFromParent_Done,
     /* 1474304 */   // Label 20539: @1474304
     /* 1474304 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1474386), // Rule ID 21571 //
     /* 1474309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1474312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1474317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1474320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1474323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1474329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474348 */     // MIs[0] round
     /* 1474348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474351 */     // MIs[0] policy
     /* 1474351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1474364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474372 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474385 */     // GIR_Coverage, 21571,
     /* 1474385 */     GIR_EraseRootFromParent_Done,
     /* 1474386 */   // Label 20540: @1474386
     /* 1474386 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1474468), // Rule ID 21694 //
     /* 1474391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1474394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1474402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1474405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1474408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1474411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474430 */     // MIs[0] round
     /* 1474430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474433 */     // MIs[0] policy
     /* 1474433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474443 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1474446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474467 */     // GIR_Coverage, 21694,
     /* 1474467 */     GIR_EraseRootFromParent_Done,
     /* 1474468 */   // Label 20541: @1474468
     /* 1474468 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1474550), // Rule ID 21695 //
     /* 1474473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1474476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1474484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1474487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1474490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1474493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474512 */     // MIs[0] round
     /* 1474512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474515 */     // MIs[0] policy
     /* 1474515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474525 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1474528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474549 */     // GIR_Coverage, 21695,
     /* 1474549 */     GIR_EraseRootFromParent_Done,
     /* 1474550 */   // Label 20542: @1474550
     /* 1474550 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1474632), // Rule ID 21698 //
     /* 1474555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1474558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1474566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1474569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1474575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474594 */     // MIs[0] round
     /* 1474594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474597 */     // MIs[0] policy
     /* 1474597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474607 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1474610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474631 */     // GIR_Coverage, 21698,
     /* 1474631 */     GIR_EraseRootFromParent_Done,
     /* 1474632 */   // Label 20543: @1474632
     /* 1474632 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1474714), // Rule ID 21699 //
     /* 1474637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1474640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1474648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1474651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1474657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474676 */     // MIs[0] round
     /* 1474676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474679 */     // MIs[0] policy
     /* 1474679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474689 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1474692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474700 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474713 */     // GIR_Coverage, 21699,
     /* 1474713 */     GIR_EraseRootFromParent_Done,
     /* 1474714 */   // Label 20544: @1474714
     /* 1474714 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1474796), // Rule ID 21702 //
     /* 1474719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1474722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1474736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1474739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474758 */     // MIs[0] round
     /* 1474758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474761 */     // MIs[0] policy
     /* 1474761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474771 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1474774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474782 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474795 */     // GIR_Coverage, 21702,
     /* 1474795 */     GIR_EraseRootFromParent_Done,
     /* 1474796 */   // Label 20545: @1474796
     /* 1474796 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1474878), // Rule ID 21703 //
     /* 1474801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1474804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1474818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1474821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474840 */     // MIs[0] round
     /* 1474840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474843 */     // MIs[0] policy
     /* 1474843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474853 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10919:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1474856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474864 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474877 */     // GIR_Coverage, 21703,
     /* 1474877 */     GIR_EraseRootFromParent_Done,
     /* 1474878 */   // Label 20546: @1474878
     /* 1474878 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1474960), // Rule ID 21706 //
     /* 1474883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1474886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1474900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1474903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474922 */     // MIs[0] round
     /* 1474922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1474925 */     // MIs[0] policy
     /* 1474925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474935 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10919:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1474938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1474944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1474946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1474948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474959 */     // GIR_Coverage, 21706,
     /* 1474959 */     GIR_EraseRootFromParent_Done,
     /* 1474960 */   // Label 20547: @1474960
     /* 1474960 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1475042), // Rule ID 21707 //
     /* 1474965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1474968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1474973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1474982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1474985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475004 */     // MIs[0] round
     /* 1475004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475007 */     // MIs[0] policy
     /* 1475007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10919:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1475020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475028 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475041 */     // GIR_Coverage, 21707,
     /* 1475041 */     GIR_EraseRootFromParent_Done,
     /* 1475042 */   // Label 20548: @1475042
     /* 1475042 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1475124), // Rule ID 21710 //
     /* 1475047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1475050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1475067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475086 */     // MIs[0] round
     /* 1475086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475089 */     // MIs[0] policy
     /* 1475089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475099 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10919:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1475102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475123 */     // GIR_Coverage, 21710,
     /* 1475123 */     GIR_EraseRootFromParent_Done,
     /* 1475124 */   // Label 20549: @1475124
     /* 1475124 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1475206), // Rule ID 21711 //
     /* 1475129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1475132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1475149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475168 */     // MIs[0] round
     /* 1475168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475171 */     // MIs[0] policy
     /* 1475171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475181 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10919:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1475184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475192 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475205 */     // GIR_Coverage, 21711,
     /* 1475205 */     GIR_EraseRootFromParent_Done,
     /* 1475206 */   // Label 20550: @1475206
     /* 1475206 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1475288), // Rule ID 21714 //
     /* 1475211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1475214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1475222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1475225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1475228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1475231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475250 */     // MIs[0] round
     /* 1475250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475253 */     // MIs[0] policy
     /* 1475253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475263 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1475266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475272 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475274 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475287 */     // GIR_Coverage, 21714,
     /* 1475287 */     GIR_EraseRootFromParent_Done,
     /* 1475288 */   // Label 20551: @1475288
     /* 1475288 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1475370), // Rule ID 21715 //
     /* 1475293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1475296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1475304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1475307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1475310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1475313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475332 */     // MIs[0] round
     /* 1475332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475335 */     // MIs[0] policy
     /* 1475335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475345 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1475348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475356 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475369 */     // GIR_Coverage, 21715,
     /* 1475369 */     GIR_EraseRootFromParent_Done,
     /* 1475370 */   // Label 20552: @1475370
     /* 1475370 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1475452), // Rule ID 21718 //
     /* 1475375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1475378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1475386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1475389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1475392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1475395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475414 */     // MIs[0] round
     /* 1475414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475417 */     // MIs[0] policy
     /* 1475417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475427 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1475430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475451 */     // GIR_Coverage, 21718,
     /* 1475451 */     GIR_EraseRootFromParent_Done,
     /* 1475452 */   // Label 20553: @1475452
     /* 1475452 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1475534), // Rule ID 21719 //
     /* 1475457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1475460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1475468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1475471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1475474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1475477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475496 */     // MIs[0] round
     /* 1475496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475499 */     // MIs[0] policy
     /* 1475499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475509 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1475512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475520 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475533 */     // GIR_Coverage, 21719,
     /* 1475533 */     GIR_EraseRootFromParent_Done,
     /* 1475534 */   // Label 20554: @1475534
     /* 1475534 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1475616), // Rule ID 21722 //
     /* 1475539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1475542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1475556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1475559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475578 */     // MIs[0] round
     /* 1475578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475581 */     // MIs[0] policy
     /* 1475581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475591 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10919:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1475594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475615 */     // GIR_Coverage, 21722,
     /* 1475615 */     GIR_EraseRootFromParent_Done,
     /* 1475616 */   // Label 20555: @1475616
     /* 1475616 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1475698), // Rule ID 21723 //
     /* 1475621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1475624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1475638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1475641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475660 */     // MIs[0] round
     /* 1475660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475663 */     // MIs[0] policy
     /* 1475663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475673 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10919:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1475676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475684 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475697 */     // GIR_Coverage, 21723,
     /* 1475697 */     GIR_EraseRootFromParent_Done,
     /* 1475698 */   // Label 20556: @1475698
     /* 1475698 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1475780), // Rule ID 21726 //
     /* 1475703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1475706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1475720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1475723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475742 */     // MIs[0] round
     /* 1475742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475745 */     // MIs[0] policy
     /* 1475745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475755 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10919:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1475758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475779 */     // GIR_Coverage, 21726,
     /* 1475779 */     GIR_EraseRootFromParent_Done,
     /* 1475780 */   // Label 20557: @1475780
     /* 1475780 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1475862), // Rule ID 21727 //
     /* 1475785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1475788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1475793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1475802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1475805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475824 */     // MIs[0] round
     /* 1475824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475827 */     // MIs[0] policy
     /* 1475827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475837 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10919:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1475840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475848 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475861 */     // GIR_Coverage, 21727,
     /* 1475861 */     GIR_EraseRootFromParent_Done,
     /* 1475862 */   // Label 20558: @1475862
     /* 1475862 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1475944), // Rule ID 21730 //
     /* 1475867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1475870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1475875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1475878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1475881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1475884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1475887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475906 */     // MIs[0] round
     /* 1475906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475909 */     // MIs[0] policy
     /* 1475909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475919 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1475922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1475928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1475930 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1475932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475943 */     // GIR_Coverage, 21730,
     /* 1475943 */     GIR_EraseRootFromParent_Done,
     /* 1475944 */   // Label 20559: @1475944
     /* 1475944 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1476026), // Rule ID 21731 //
     /* 1475949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1475952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1475957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1475960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1475963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1475966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1475969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475988 */     // MIs[0] round
     /* 1475988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1475991 */     // MIs[0] policy
     /* 1475991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476001 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1476004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476012 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476025 */     // GIR_Coverage, 21731,
     /* 1476025 */     GIR_EraseRootFromParent_Done,
     /* 1476026 */   // Label 20560: @1476026
     /* 1476026 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1476108), // Rule ID 21734 //
     /* 1476031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1476034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1476042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1476045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1476048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1476051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476070 */     // MIs[0] round
     /* 1476070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476073 */     // MIs[0] policy
     /* 1476073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476083 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1476086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476107 */     // GIR_Coverage, 21734,
     /* 1476107 */     GIR_EraseRootFromParent_Done,
     /* 1476108 */   // Label 20561: @1476108
     /* 1476108 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1476190), // Rule ID 21735 //
     /* 1476113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1476116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1476124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1476127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1476130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1476133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476152 */     // MIs[0] round
     /* 1476152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476155 */     // MIs[0] policy
     /* 1476155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476165 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1476168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476176 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476189 */     // GIR_Coverage, 21735,
     /* 1476189 */     GIR_EraseRootFromParent_Done,
     /* 1476190 */   // Label 20562: @1476190
     /* 1476190 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1476272), // Rule ID 21738 //
     /* 1476195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1476198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1476206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1476209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1476215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476234 */     // MIs[0] round
     /* 1476234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476237 */     // MIs[0] policy
     /* 1476237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476247 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1476250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476271 */     // GIR_Coverage, 21738,
     /* 1476271 */     GIR_EraseRootFromParent_Done,
     /* 1476272 */   // Label 20563: @1476272
     /* 1476272 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1476354), // Rule ID 21739 //
     /* 1476277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1476280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1476288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1476291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1476297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476316 */     // MIs[0] round
     /* 1476316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476319 */     // MIs[0] policy
     /* 1476319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476329 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10917:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1476332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476340 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476353 */     // GIR_Coverage, 21739,
     /* 1476353 */     GIR_EraseRootFromParent_Done,
     /* 1476354 */   // Label 20564: @1476354
     /* 1476354 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1476436), // Rule ID 21742 //
     /* 1476359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1476362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1476370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1476373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1476379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476398 */     // MIs[0] round
     /* 1476398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476401 */     // MIs[0] policy
     /* 1476401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476411 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1476414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476435 */     // GIR_Coverage, 21742,
     /* 1476435 */     GIR_EraseRootFromParent_Done,
     /* 1476436 */   // Label 20565: @1476436
     /* 1476436 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1476518), // Rule ID 21743 //
     /* 1476441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1476444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1476452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1476455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1476461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476480 */     // MIs[0] round
     /* 1476480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476483 */     // MIs[0] policy
     /* 1476483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476493 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1476496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476502 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476504 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476517 */     // GIR_Coverage, 21743,
     /* 1476517 */     GIR_EraseRootFromParent_Done,
     /* 1476518 */   // Label 20566: @1476518
     /* 1476518 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1476600), // Rule ID 21746 //
     /* 1476523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1476526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1476534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1476537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1476543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476562 */     // MIs[0] round
     /* 1476562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476565 */     // MIs[0] policy
     /* 1476565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476575 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1476578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476586 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476599 */     // GIR_Coverage, 21746,
     /* 1476599 */     GIR_EraseRootFromParent_Done,
     /* 1476600 */   // Label 20567: @1476600
     /* 1476600 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1476682), // Rule ID 21747 //
     /* 1476605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1476608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1476616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1476619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1476625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476644 */     // MIs[0] round
     /* 1476644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476647 */     // MIs[0] policy
     /* 1476647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1476660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476668 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476681 */     // GIR_Coverage, 21747,
     /* 1476681 */     GIR_EraseRootFromParent_Done,
     /* 1476682 */   // Label 20568: @1476682
     /* 1476682 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1476764), // Rule ID 21750 //
     /* 1476687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1476690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1476698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1476701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1476704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1476707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476726 */     // MIs[0] round
     /* 1476726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476729 */     // MIs[0] policy
     /* 1476729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476739 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1476742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476763 */     // GIR_Coverage, 21750,
     /* 1476763 */     GIR_EraseRootFromParent_Done,
     /* 1476764 */   // Label 20569: @1476764
     /* 1476764 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1476846), // Rule ID 21751 //
     /* 1476769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1476772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1476780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1476783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1476786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1476789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476808 */     // MIs[0] round
     /* 1476808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476811 */     // MIs[0] policy
     /* 1476811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1476824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476832 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476845 */     // GIR_Coverage, 21751,
     /* 1476845 */     GIR_EraseRootFromParent_Done,
     /* 1476846 */   // Label 20570: @1476846
     /* 1476846 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1476928), // Rule ID 21754 //
     /* 1476851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1476854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1476862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1476865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1476871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476890 */     // MIs[0] round
     /* 1476890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476893 */     // MIs[0] policy
     /* 1476893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476903 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1476906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476927 */     // GIR_Coverage, 21754,
     /* 1476927 */     GIR_EraseRootFromParent_Done,
     /* 1476928 */   // Label 20571: @1476928
     /* 1476928 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1477010), // Rule ID 21755 //
     /* 1476933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1476936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1476941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1476944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1476947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1476953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476972 */     // MIs[0] round
     /* 1476972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1476975 */     // MIs[0] policy
     /* 1476975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476985 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1476988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1476994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1476996 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1476998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477009 */     // GIR_Coverage, 21755,
     /* 1477009 */     GIR_EraseRootFromParent_Done,
     /* 1477010 */   // Label 20572: @1477010
     /* 1477010 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1477092), // Rule ID 21758 //
     /* 1477015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1477018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1477023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1477032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1477035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477054 */     // MIs[0] round
     /* 1477054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477057 */     // MIs[0] policy
     /* 1477057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477067 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1477070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477091 */     // GIR_Coverage, 21758,
     /* 1477091 */     GIR_EraseRootFromParent_Done,
     /* 1477092 */   // Label 20573: @1477092
     /* 1477092 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1477174), // Rule ID 21759 //
     /* 1477097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1477100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1477105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1477114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1477117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477136 */     // MIs[0] round
     /* 1477136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477139 */     // MIs[0] policy
     /* 1477139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477149 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1477152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477173 */     // GIR_Coverage, 21759,
     /* 1477173 */     GIR_EraseRootFromParent_Done,
     /* 1477174 */   // Label 20574: @1477174
     /* 1477174 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1477256), // Rule ID 21762 //
     /* 1477179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1477182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1477187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1477199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477218 */     // MIs[0] round
     /* 1477218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477221 */     // MIs[0] policy
     /* 1477221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477231 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1477234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477242 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477255 */     // GIR_Coverage, 21762,
     /* 1477255 */     GIR_EraseRootFromParent_Done,
     /* 1477256 */   // Label 20575: @1477256
     /* 1477256 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1477338), // Rule ID 21763 //
     /* 1477261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1477264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1477269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1477281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477300 */     // MIs[0] round
     /* 1477300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477303 */     // MIs[0] policy
     /* 1477303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477313 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1477316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477324 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477337 */     // GIR_Coverage, 21763,
     /* 1477337 */     GIR_EraseRootFromParent_Done,
     /* 1477338 */   // Label 20576: @1477338
     /* 1477338 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1477420), // Rule ID 21766 //
     /* 1477343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1477346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1477360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1477363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477382 */     // MIs[0] round
     /* 1477382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477385 */     // MIs[0] policy
     /* 1477385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477395 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1477398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477419 */     // GIR_Coverage, 21766,
     /* 1477419 */     GIR_EraseRootFromParent_Done,
     /* 1477420 */   // Label 20577: @1477420
     /* 1477420 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1477502), // Rule ID 21767 //
     /* 1477425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1477428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1477442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1477445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477464 */     // MIs[0] round
     /* 1477464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477467 */     // MIs[0] policy
     /* 1477467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477477 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1477480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477501 */     // GIR_Coverage, 21767,
     /* 1477501 */     GIR_EraseRootFromParent_Done,
     /* 1477502 */   // Label 20578: @1477502
     /* 1477502 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1477584), // Rule ID 21770 //
     /* 1477507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1477510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1477518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1477521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1477524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1477527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477546 */     // MIs[0] round
     /* 1477546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477549 */     // MIs[0] policy
     /* 1477549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477559 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1477562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477570 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477583 */     // GIR_Coverage, 21770,
     /* 1477583 */     GIR_EraseRootFromParent_Done,
     /* 1477584 */   // Label 20579: @1477584
     /* 1477584 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1477666), // Rule ID 21771 //
     /* 1477589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1477592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1477600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1477603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1477606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1477609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477628 */     // MIs[0] round
     /* 1477628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477631 */     // MIs[0] policy
     /* 1477631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477641 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1477644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477650 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477652 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477665 */     // GIR_Coverage, 21771,
     /* 1477665 */     GIR_EraseRootFromParent_Done,
     /* 1477666 */   // Label 20580: @1477666
     /* 1477666 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1477748), // Rule ID 21774 //
     /* 1477671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1477674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1477688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1477691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477710 */     // MIs[0] round
     /* 1477710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477713 */     // MIs[0] policy
     /* 1477713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477723 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1477726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477734 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477747 */     // GIR_Coverage, 21774,
     /* 1477747 */     GIR_EraseRootFromParent_Done,
     /* 1477748 */   // Label 20581: @1477748
     /* 1477748 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1477830), // Rule ID 21775 //
     /* 1477753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1477756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1477770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1477773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477792 */     // MIs[0] round
     /* 1477792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477795 */     // MIs[0] policy
     /* 1477795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477805 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1477808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477829 */     // GIR_Coverage, 21775,
     /* 1477829 */     GIR_EraseRootFromParent_Done,
     /* 1477830 */   // Label 20582: @1477830
     /* 1477830 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1477912), // Rule ID 21778 //
     /* 1477835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1477838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1477855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477874 */     // MIs[0] round
     /* 1477874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477877 */     // MIs[0] policy
     /* 1477877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477887 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1477890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477911 */     // GIR_Coverage, 21778,
     /* 1477911 */     GIR_EraseRootFromParent_Done,
     /* 1477912 */   // Label 20583: @1477912
     /* 1477912 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1477994), // Rule ID 21779 //
     /* 1477917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1477920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1477925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1477937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477956 */     // MIs[0] round
     /* 1477956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1477959 */     // MIs[0] policy
     /* 1477959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477969 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1477972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1477976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1477978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1477980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1477982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477993 */     // GIR_Coverage, 21779,
     /* 1477993 */     GIR_EraseRootFromParent_Done,
     /* 1477994 */   // Label 20584: @1477994
     /* 1477994 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1478076), // Rule ID 21782 //
     /* 1477999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1478002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1478019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478038 */     // MIs[0] round
     /* 1478038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478041 */     // MIs[0] policy
     /* 1478041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478051 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1478054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478062 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478075 */     // GIR_Coverage, 21782,
     /* 1478075 */     GIR_EraseRootFromParent_Done,
     /* 1478076 */   // Label 20585: @1478076
     /* 1478076 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1478158), // Rule ID 21783 //
     /* 1478081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1478084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1478101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478120 */     // MIs[0] round
     /* 1478120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478123 */     // MIs[0] policy
     /* 1478123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478133 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1478136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478157 */     // GIR_Coverage, 21783,
     /* 1478157 */     GIR_EraseRootFromParent_Done,
     /* 1478158 */   // Label 20586: @1478158
     /* 1478158 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1478240), // Rule ID 21786 //
     /* 1478163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1478166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1478174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1478177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1478183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478202 */     // MIs[0] round
     /* 1478202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478205 */     // MIs[0] policy
     /* 1478205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478215 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1478218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478226 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478239 */     // GIR_Coverage, 21786,
     /* 1478239 */     GIR_EraseRootFromParent_Done,
     /* 1478240 */   // Label 20587: @1478240
     /* 1478240 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1478322), // Rule ID 21787 //
     /* 1478245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1478248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1478256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1478259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1478265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478284 */     // MIs[0] round
     /* 1478284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478287 */     // MIs[0] policy
     /* 1478287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478297 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1478300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478308 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478321 */     // GIR_Coverage, 21787,
     /* 1478321 */     GIR_EraseRootFromParent_Done,
     /* 1478322 */   // Label 20588: @1478322
     /* 1478322 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1478404), // Rule ID 21790 //
     /* 1478327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1478330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1478344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1478347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478366 */     // MIs[0] round
     /* 1478366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478369 */     // MIs[0] policy
     /* 1478369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478379 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1478382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478403 */     // GIR_Coverage, 21790,
     /* 1478403 */     GIR_EraseRootFromParent_Done,
     /* 1478404 */   // Label 20589: @1478404
     /* 1478404 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1478486), // Rule ID 21791 //
     /* 1478409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1478412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1478426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1478429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478448 */     // MIs[0] round
     /* 1478448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478451 */     // MIs[0] policy
     /* 1478451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478461 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10915:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1478464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478485 */     // GIR_Coverage, 21791,
     /* 1478485 */     GIR_EraseRootFromParent_Done,
     /* 1478486 */   // Label 20590: @1478486
     /* 1478486 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1478568), // Rule ID 21794 //
     /* 1478491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1478494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1478508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1478511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478530 */     // MIs[0] round
     /* 1478530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478533 */     // MIs[0] policy
     /* 1478533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478543 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1478546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478554 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478567 */     // GIR_Coverage, 21794,
     /* 1478567 */     GIR_EraseRootFromParent_Done,
     /* 1478568 */   // Label 20591: @1478568
     /* 1478568 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1478650), // Rule ID 21795 //
     /* 1478573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1478576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1478590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1478593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478612 */     // MIs[0] round
     /* 1478612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478615 */     // MIs[0] policy
     /* 1478615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478625 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1478628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478649 */     // GIR_Coverage, 21795,
     /* 1478649 */     GIR_EraseRootFromParent_Done,
     /* 1478650 */   // Label 20592: @1478650
     /* 1478650 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1478732), // Rule ID 21798 //
     /* 1478655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1478658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1478666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1478669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1478672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1478675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478694 */     // MIs[0] round
     /* 1478694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478697 */     // MIs[0] policy
     /* 1478697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478707 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1478710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478731 */     // GIR_Coverage, 21798,
     /* 1478731 */     GIR_EraseRootFromParent_Done,
     /* 1478732 */   // Label 20593: @1478732
     /* 1478732 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1478814), // Rule ID 21799 //
     /* 1478737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1478740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1478745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1478748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1478751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1478754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1478757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478776 */     // MIs[0] round
     /* 1478776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1478779 */     // MIs[0] policy
     /* 1478779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478789 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1478792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1478798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1478800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1478802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478813 */     // GIR_Coverage, 21799,
     /* 1478813 */     GIR_EraseRootFromParent_Done,
     /* 1478814 */   // Label 20594: @1478814
     /* 1478814 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1478896), // Rule ID 2616 //
     /* 1478819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1478827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1478836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478850 */     // MIs[0] passthru
     /* 1478850 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1478855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478863 */     // MIs[0] policy
     /* 1478863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478873 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1478876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1478882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478895 */     // GIR_Coverage, 2616,
     /* 1478895 */     GIR_EraseRootFromParent_Done,
     /* 1478896 */   // Label 20595: @1478896
     /* 1478896 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1478978), // Rule ID 2617 //
     /* 1478901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1478909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1478918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478932 */     // MIs[0] passthru
     /* 1478932 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1478937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478945 */     // MIs[0] policy
     /* 1478945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478955 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1478958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1478962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1478964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478977 */     // GIR_Coverage, 2617,
     /* 1478977 */     GIR_EraseRootFromParent_Done,
     /* 1478978 */   // Label 20596: @1478978
     /* 1478978 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1479060), // Rule ID 3924 //
     /* 1478983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1478991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1478994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1478997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1479000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479014 */     // MIs[0] passthru
     /* 1479014 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479027 */     // MIs[0] policy
     /* 1479027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479037 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1479040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479059 */     // GIR_Coverage, 3924,
     /* 1479059 */     GIR_EraseRootFromParent_Done,
     /* 1479060 */   // Label 20597: @1479060
     /* 1479060 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1479142), // Rule ID 3925 //
     /* 1479065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1479076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1479079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1479082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479096 */     // MIs[0] passthru
     /* 1479096 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479109 */     // MIs[0] policy
     /* 1479109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1479122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479141 */     // GIR_Coverage, 3925,
     /* 1479141 */     GIR_EraseRootFromParent_Done,
     /* 1479142 */   // Label 20598: @1479142
     /* 1479142 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1479224), // Rule ID 3934 //
     /* 1479147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1479158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1479161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1479164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479178 */     // MIs[0] passthru
     /* 1479178 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479191 */     // MIs[0] policy
     /* 1479191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1479204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479223 */     // GIR_Coverage, 3934,
     /* 1479223 */     GIR_EraseRootFromParent_Done,
     /* 1479224 */   // Label 20599: @1479224
     /* 1479224 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1479306), // Rule ID 3935 //
     /* 1479229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1479240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1479243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1479246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479260 */     // MIs[0] passthru
     /* 1479260 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479273 */     // MIs[0] policy
     /* 1479273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1479286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479305 */     // GIR_Coverage, 3935,
     /* 1479305 */     GIR_EraseRootFromParent_Done,
     /* 1479306 */   // Label 20600: @1479306
     /* 1479306 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1479388), // Rule ID 3944 //
     /* 1479311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1479328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479342 */     // MIs[0] passthru
     /* 1479342 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479355 */     // MIs[0] policy
     /* 1479355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1479368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479387 */     // GIR_Coverage, 3944,
     /* 1479387 */     GIR_EraseRootFromParent_Done,
     /* 1479388 */   // Label 20601: @1479388
     /* 1479388 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1479470), // Rule ID 3945 //
     /* 1479393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1479410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479424 */     // MIs[0] passthru
     /* 1479424 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479437 */     // MIs[0] policy
     /* 1479437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1479450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479469 */     // GIR_Coverage, 3945,
     /* 1479469 */     GIR_EraseRootFromParent_Done,
     /* 1479470 */   // Label 20602: @1479470
     /* 1479470 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1479552), // Rule ID 3954 //
     /* 1479475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1479492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479506 */     // MIs[0] passthru
     /* 1479506 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479519 */     // MIs[0] policy
     /* 1479519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1479532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479551 */     // GIR_Coverage, 3954,
     /* 1479551 */     GIR_EraseRootFromParent_Done,
     /* 1479552 */   // Label 20603: @1479552
     /* 1479552 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1479634), // Rule ID 3955 //
     /* 1479557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1479574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479588 */     // MIs[0] passthru
     /* 1479588 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479601 */     // MIs[0] policy
     /* 1479601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1479614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479633 */     // GIR_Coverage, 3955,
     /* 1479633 */     GIR_EraseRootFromParent_Done,
     /* 1479634 */   // Label 20604: @1479634
     /* 1479634 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1479716), // Rule ID 3964 //
     /* 1479639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1479656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479670 */     // MIs[0] passthru
     /* 1479670 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479683 */     // MIs[0] policy
     /* 1479683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1479696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479715 */     // GIR_Coverage, 3964,
     /* 1479715 */     GIR_EraseRootFromParent_Done,
     /* 1479716 */   // Label 20605: @1479716
     /* 1479716 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1479798), // Rule ID 3965 //
     /* 1479721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1479738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479752 */     // MIs[0] passthru
     /* 1479752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479765 */     // MIs[0] policy
     /* 1479765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479775 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1479778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479797 */     // GIR_Coverage, 3965,
     /* 1479797 */     GIR_EraseRootFromParent_Done,
     /* 1479798 */   // Label 20606: @1479798
     /* 1479798 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1479880), // Rule ID 3974 //
     /* 1479803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1479814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1479817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1479820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479834 */     // MIs[0] passthru
     /* 1479834 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479847 */     // MIs[0] policy
     /* 1479847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479857 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1479860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479879 */     // GIR_Coverage, 3974,
     /* 1479879 */     GIR_EraseRootFromParent_Done,
     /* 1479880 */   // Label 20607: @1479880
     /* 1479880 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1479962), // Rule ID 3975 //
     /* 1479885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1479896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1479899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1479902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479916 */     // MIs[0] passthru
     /* 1479916 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1479921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479929 */     // MIs[0] policy
     /* 1479929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479939 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1479942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1479946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1479948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479961 */     // GIR_Coverage, 3975,
     /* 1479961 */     GIR_EraseRootFromParent_Done,
     /* 1479962 */   // Label 20608: @1479962
     /* 1479962 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1480044), // Rule ID 3984 //
     /* 1479967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1479975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1479978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1479981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1479984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479998 */     // MIs[0] passthru
     /* 1479998 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480011 */     // MIs[0] policy
     /* 1480011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480021 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1480024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480043 */     // GIR_Coverage, 3984,
     /* 1480043 */     GIR_EraseRootFromParent_Done,
     /* 1480044 */   // Label 20609: @1480044
     /* 1480044 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1480126), // Rule ID 3985 //
     /* 1480049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1480060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1480063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1480066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480080 */     // MIs[0] passthru
     /* 1480080 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480093 */     // MIs[0] policy
     /* 1480093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480103 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1480106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480125 */     // GIR_Coverage, 3985,
     /* 1480125 */     GIR_EraseRootFromParent_Done,
     /* 1480126 */   // Label 20610: @1480126
     /* 1480126 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1480208), // Rule ID 3994 //
     /* 1480131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1480148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480162 */     // MIs[0] passthru
     /* 1480162 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480175 */     // MIs[0] policy
     /* 1480175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1480188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480207 */     // GIR_Coverage, 3994,
     /* 1480207 */     GIR_EraseRootFromParent_Done,
     /* 1480208 */   // Label 20611: @1480208
     /* 1480208 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1480290), // Rule ID 3995 //
     /* 1480213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1480230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480244 */     // MIs[0] passthru
     /* 1480244 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480257 */     // MIs[0] policy
     /* 1480257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1480270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480289 */     // GIR_Coverage, 3995,
     /* 1480289 */     GIR_EraseRootFromParent_Done,
     /* 1480290 */   // Label 20612: @1480290
     /* 1480290 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1480372), // Rule ID 4004 //
     /* 1480295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1480312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480326 */     // MIs[0] passthru
     /* 1480326 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480339 */     // MIs[0] policy
     /* 1480339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1480352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480371 */     // GIR_Coverage, 4004,
     /* 1480371 */     GIR_EraseRootFromParent_Done,
     /* 1480372 */   // Label 20613: @1480372
     /* 1480372 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1480454), // Rule ID 4005 //
     /* 1480377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1480394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480408 */     // MIs[0] passthru
     /* 1480408 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480421 */     // MIs[0] policy
     /* 1480421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480431 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1480434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480453 */     // GIR_Coverage, 4005,
     /* 1480453 */     GIR_EraseRootFromParent_Done,
     /* 1480454 */   // Label 20614: @1480454
     /* 1480454 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1480536), // Rule ID 4014 //
     /* 1480459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1480476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480490 */     // MIs[0] passthru
     /* 1480490 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480503 */     // MIs[0] policy
     /* 1480503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480513 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1480516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480535 */     // GIR_Coverage, 4014,
     /* 1480535 */     GIR_EraseRootFromParent_Done,
     /* 1480536 */   // Label 20615: @1480536
     /* 1480536 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1480618), // Rule ID 4015 //
     /* 1480541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1480558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480572 */     // MIs[0] passthru
     /* 1480572 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480585 */     // MIs[0] policy
     /* 1480585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1480598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480617 */     // GIR_Coverage, 4015,
     /* 1480617 */     GIR_EraseRootFromParent_Done,
     /* 1480618 */   // Label 20616: @1480618
     /* 1480618 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1480700), // Rule ID 4024 //
     /* 1480623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1480626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1480634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1480637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1480640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480654 */     // MIs[0] passthru
     /* 1480654 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480667 */     // MIs[0] policy
     /* 1480667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1480680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480699 */     // GIR_Coverage, 4024,
     /* 1480699 */     GIR_EraseRootFromParent_Done,
     /* 1480700 */   // Label 20617: @1480700
     /* 1480700 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1480782), // Rule ID 4025 //
     /* 1480705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1480708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1480716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1480719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1480722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480736 */     // MIs[0] passthru
     /* 1480736 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480749 */     // MIs[0] policy
     /* 1480749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480759 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1480762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480781 */     // GIR_Coverage, 4025,
     /* 1480781 */     GIR_EraseRootFromParent_Done,
     /* 1480782 */   // Label 20618: @1480782
     /* 1480782 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1480864), // Rule ID 4034 //
     /* 1480787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1480790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1480804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480818 */     // MIs[0] passthru
     /* 1480818 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480831 */     // MIs[0] policy
     /* 1480831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1480844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480863 */     // GIR_Coverage, 4034,
     /* 1480863 */     GIR_EraseRootFromParent_Done,
     /* 1480864 */   // Label 20619: @1480864
     /* 1480864 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1480946), // Rule ID 4035 //
     /* 1480869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1480872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1480886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480900 */     // MIs[0] passthru
     /* 1480900 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480913 */     // MIs[0] policy
     /* 1480913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1480926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1480932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480945 */     // GIR_Coverage, 4035,
     /* 1480945 */     GIR_EraseRootFromParent_Done,
     /* 1480946 */   // Label 20620: @1480946
     /* 1480946 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1481028), // Rule ID 4044 //
     /* 1480951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1480954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1480959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1480968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480982 */     // MIs[0] passthru
     /* 1480982 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1480987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480995 */     // MIs[0] policy
     /* 1480995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481005 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1481008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481027 */     // GIR_Coverage, 4044,
     /* 1481027 */     GIR_EraseRootFromParent_Done,
     /* 1481028 */   // Label 20621: @1481028
     /* 1481028 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1481110), // Rule ID 4045 //
     /* 1481033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1481036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1481041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1481044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1481047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1481050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481064 */     // MIs[0] passthru
     /* 1481064 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481077 */     // MIs[0] policy
     /* 1481077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481087 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1481090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481109 */     // GIR_Coverage, 4045,
     /* 1481109 */     GIR_EraseRootFromParent_Done,
     /* 1481110 */   // Label 20622: @1481110
     /* 1481110 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1481192), // Rule ID 4054 //
     /* 1481115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1481118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1481123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1481132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481146 */     // MIs[0] passthru
     /* 1481146 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481159 */     // MIs[0] policy
     /* 1481159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1481172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481191 */     // GIR_Coverage, 4054,
     /* 1481191 */     GIR_EraseRootFromParent_Done,
     /* 1481192 */   // Label 20623: @1481192
     /* 1481192 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1481274), // Rule ID 4055 //
     /* 1481197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1481200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1481205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1481214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481228 */     // MIs[0] passthru
     /* 1481228 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481241 */     // MIs[0] policy
     /* 1481241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1481254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481273 */     // GIR_Coverage, 4055,
     /* 1481273 */     GIR_EraseRootFromParent_Done,
     /* 1481274 */   // Label 20624: @1481274
     /* 1481274 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1481356), // Rule ID 4124 //
     /* 1481279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1481296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481310 */     // MIs[0] passthru
     /* 1481310 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481323 */     // MIs[0] policy
     /* 1481323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481333 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1481336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481355 */     // GIR_Coverage, 4124,
     /* 1481355 */     GIR_EraseRootFromParent_Done,
     /* 1481356 */   // Label 20625: @1481356
     /* 1481356 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1481438), // Rule ID 4125 //
     /* 1481361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1481378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481392 */     // MIs[0] passthru
     /* 1481392 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481405 */     // MIs[0] policy
     /* 1481405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1481418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481437 */     // GIR_Coverage, 4125,
     /* 1481437 */     GIR_EraseRootFromParent_Done,
     /* 1481438 */   // Label 20626: @1481438
     /* 1481438 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1481520), // Rule ID 4134 //
     /* 1481443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1481460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481474 */     // MIs[0] passthru
     /* 1481474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481487 */     // MIs[0] policy
     /* 1481487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481497 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1481500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481519 */     // GIR_Coverage, 4134,
     /* 1481519 */     GIR_EraseRootFromParent_Done,
     /* 1481520 */   // Label 20627: @1481520
     /* 1481520 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1481602), // Rule ID 4135 //
     /* 1481525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1481542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481556 */     // MIs[0] passthru
     /* 1481556 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481569 */     // MIs[0] policy
     /* 1481569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481579 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1481582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481601 */     // GIR_Coverage, 4135,
     /* 1481601 */     GIR_EraseRootFromParent_Done,
     /* 1481602 */   // Label 20628: @1481602
     /* 1481602 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1481684), // Rule ID 4144 //
     /* 1481607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1481624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481638 */     // MIs[0] passthru
     /* 1481638 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481651 */     // MIs[0] policy
     /* 1481651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1481664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481683 */     // GIR_Coverage, 4144,
     /* 1481683 */     GIR_EraseRootFromParent_Done,
     /* 1481684 */   // Label 20629: @1481684
     /* 1481684 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1481766), // Rule ID 4145 //
     /* 1481689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1481706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481720 */     // MIs[0] passthru
     /* 1481720 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481733 */     // MIs[0] policy
     /* 1481733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1481746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481765 */     // GIR_Coverage, 4145,
     /* 1481765 */     GIR_EraseRootFromParent_Done,
     /* 1481766 */   // Label 20630: @1481766
     /* 1481766 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1481848), // Rule ID 4154 //
     /* 1481771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1481782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1481785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1481788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1481798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481802 */     // MIs[0] passthru
     /* 1481802 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481815 */     // MIs[0] policy
     /* 1481815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1481828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481847 */     // GIR_Coverage, 4154,
     /* 1481847 */     GIR_EraseRootFromParent_Done,
     /* 1481848 */   // Label 20631: @1481848
     /* 1481848 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1481930), // Rule ID 4155 //
     /* 1481853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1481864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1481867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1481870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1481880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481884 */     // MIs[0] passthru
     /* 1481884 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481897 */     // MIs[0] policy
     /* 1481897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1481910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481929 */     // GIR_Coverage, 4155,
     /* 1481929 */     GIR_EraseRootFromParent_Done,
     /* 1481930 */   // Label 20632: @1481930
     /* 1481930 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1482012), // Rule ID 4164 //
     /* 1481935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1481943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1481946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1481949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1481952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1481955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481966 */     // MIs[0] passthru
     /* 1481966 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1481971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481979 */     // MIs[0] policy
     /* 1481979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1481992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1481998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482011 */     // GIR_Coverage, 4164,
     /* 1482011 */     GIR_EraseRootFromParent_Done,
     /* 1482012 */   // Label 20633: @1482012
     /* 1482012 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1482094), // Rule ID 4165 //
     /* 1482017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1482034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482048 */     // MIs[0] passthru
     /* 1482048 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482061 */     // MIs[0] policy
     /* 1482061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1482074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482093 */     // GIR_Coverage, 4165,
     /* 1482093 */     GIR_EraseRootFromParent_Done,
     /* 1482094 */   // Label 20634: @1482094
     /* 1482094 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1482176), // Rule ID 4174 //
     /* 1482099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1482116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482130 */     // MIs[0] passthru
     /* 1482130 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482143 */     // MIs[0] policy
     /* 1482143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482153 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1482156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482175 */     // GIR_Coverage, 4174,
     /* 1482175 */     GIR_EraseRootFromParent_Done,
     /* 1482176 */   // Label 20635: @1482176
     /* 1482176 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1482258), // Rule ID 4175 //
     /* 1482181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1482198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482212 */     // MIs[0] passthru
     /* 1482212 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482225 */     // MIs[0] policy
     /* 1482225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482235 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1482238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482257 */     // GIR_Coverage, 4175,
     /* 1482257 */     GIR_EraseRootFromParent_Done,
     /* 1482258 */   // Label 20636: @1482258
     /* 1482258 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1482340), // Rule ID 4184 //
     /* 1482263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1482274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1482277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1482280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482294 */     // MIs[0] passthru
     /* 1482294 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482307 */     // MIs[0] policy
     /* 1482307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482317 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1482320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482339 */     // GIR_Coverage, 4184,
     /* 1482339 */     GIR_EraseRootFromParent_Done,
     /* 1482340 */   // Label 20637: @1482340
     /* 1482340 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1482422), // Rule ID 4185 //
     /* 1482345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1482356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1482359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1482362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482376 */     // MIs[0] passthru
     /* 1482376 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482389 */     // MIs[0] policy
     /* 1482389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1482402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482421 */     // GIR_Coverage, 4185,
     /* 1482421 */     GIR_EraseRootFromParent_Done,
     /* 1482422 */   // Label 20638: @1482422
     /* 1482422 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1482504), // Rule ID 4194 //
     /* 1482427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1482444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482458 */     // MIs[0] passthru
     /* 1482458 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482471 */     // MIs[0] policy
     /* 1482471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482481 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1482484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482503 */     // GIR_Coverage, 4194,
     /* 1482503 */     GIR_EraseRootFromParent_Done,
     /* 1482504 */   // Label 20639: @1482504
     /* 1482504 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1482586), // Rule ID 4195 //
     /* 1482509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1482526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482540 */     // MIs[0] passthru
     /* 1482540 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482553 */     // MIs[0] policy
     /* 1482553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1482566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482585 */     // GIR_Coverage, 4195,
     /* 1482585 */     GIR_EraseRootFromParent_Done,
     /* 1482586 */   // Label 20640: @1482586
     /* 1482586 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1482668), // Rule ID 4204 //
     /* 1482591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1482608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482622 */     // MIs[0] passthru
     /* 1482622 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482635 */     // MIs[0] policy
     /* 1482635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482645 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1482648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482667 */     // GIR_Coverage, 4204,
     /* 1482667 */     GIR_EraseRootFromParent_Done,
     /* 1482668 */   // Label 20641: @1482668
     /* 1482668 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1482750), // Rule ID 4205 //
     /* 1482673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1482690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482704 */     // MIs[0] passthru
     /* 1482704 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482717 */     // MIs[0] policy
     /* 1482717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1482730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482749 */     // GIR_Coverage, 4205,
     /* 1482749 */     GIR_EraseRootFromParent_Done,
     /* 1482750 */   // Label 20642: @1482750
     /* 1482750 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1482832), // Rule ID 4214 //
     /* 1482755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1482772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482786 */     // MIs[0] passthru
     /* 1482786 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482799 */     // MIs[0] policy
     /* 1482799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1482812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482831 */     // GIR_Coverage, 4214,
     /* 1482831 */     GIR_EraseRootFromParent_Done,
     /* 1482832 */   // Label 20643: @1482832
     /* 1482832 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1482914), // Rule ID 4215 //
     /* 1482837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1482854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482868 */     // MIs[0] passthru
     /* 1482868 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482881 */     // MIs[0] policy
     /* 1482881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1482894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482913 */     // GIR_Coverage, 4215,
     /* 1482913 */     GIR_EraseRootFromParent_Done,
     /* 1482914 */   // Label 20644: @1482914
     /* 1482914 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1482996), // Rule ID 4224 //
     /* 1482919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1482927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1482930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1482933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1482936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482950 */     // MIs[0] passthru
     /* 1482950 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1482955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482963 */     // MIs[0] policy
     /* 1482963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482973 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1482976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1482982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482995 */     // GIR_Coverage, 4224,
     /* 1482995 */     GIR_EraseRootFromParent_Done,
     /* 1482996 */   // Label 20645: @1482996
     /* 1482996 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1483078), // Rule ID 4225 //
     /* 1483001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1483018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483032 */     // MIs[0] passthru
     /* 1483032 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483045 */     // MIs[0] policy
     /* 1483045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483055 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1483058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483077 */     // GIR_Coverage, 4225,
     /* 1483077 */     GIR_EraseRootFromParent_Done,
     /* 1483078 */   // Label 20646: @1483078
     /* 1483078 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1483160), // Rule ID 4234 //
     /* 1483083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1483086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1483094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1483097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1483100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483114 */     // MIs[0] passthru
     /* 1483114 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483127 */     // MIs[0] policy
     /* 1483127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483137 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1483140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483159 */     // GIR_Coverage, 4234,
     /* 1483159 */     GIR_EraseRootFromParent_Done,
     /* 1483160 */   // Label 20647: @1483160
     /* 1483160 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1483242), // Rule ID 4235 //
     /* 1483165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1483168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1483176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1483179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1483182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483196 */     // MIs[0] passthru
     /* 1483196 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483209 */     // MIs[0] policy
     /* 1483209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483219 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1483222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483241 */     // GIR_Coverage, 4235,
     /* 1483241 */     GIR_EraseRootFromParent_Done,
     /* 1483242 */   // Label 20648: @1483242
     /* 1483242 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1483324), // Rule ID 4244 //
     /* 1483247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1483250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1483264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483278 */     // MIs[0] passthru
     /* 1483278 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483291 */     // MIs[0] policy
     /* 1483291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1483304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483323 */     // GIR_Coverage, 4244,
     /* 1483323 */     GIR_EraseRootFromParent_Done,
     /* 1483324 */   // Label 20649: @1483324
     /* 1483324 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1483406), // Rule ID 4245 //
     /* 1483329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1483332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1483346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483360 */     // MIs[0] passthru
     /* 1483360 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483373 */     // MIs[0] policy
     /* 1483373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1483386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483405 */     // GIR_Coverage, 4245,
     /* 1483405 */     GIR_EraseRootFromParent_Done,
     /* 1483406 */   // Label 20650: @1483406
     /* 1483406 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1483488), // Rule ID 4254 //
     /* 1483411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1483414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1483428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483442 */     // MIs[0] passthru
     /* 1483442 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483455 */     // MIs[0] policy
     /* 1483455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483465 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1483468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483487 */     // GIR_Coverage, 4254,
     /* 1483487 */     GIR_EraseRootFromParent_Done,
     /* 1483488 */   // Label 20651: @1483488
     /* 1483488 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1483570), // Rule ID 4255 //
     /* 1483493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1483496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1483510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483524 */     // MIs[0] passthru
     /* 1483524 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483537 */     // MIs[0] policy
     /* 1483537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483547 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1483550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483569 */     // GIR_Coverage, 4255,
     /* 1483569 */     GIR_EraseRootFromParent_Done,
     /* 1483570 */   // Label 20652: @1483570
     /* 1483570 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1483652), // Rule ID 4264 //
     /* 1483575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1483578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1483592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483606 */     // MIs[0] passthru
     /* 1483606 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483619 */     // MIs[0] policy
     /* 1483619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1483632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483651 */     // GIR_Coverage, 4264,
     /* 1483651 */     GIR_EraseRootFromParent_Done,
     /* 1483652 */   // Label 20653: @1483652
     /* 1483652 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1483734), // Rule ID 4265 //
     /* 1483657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1483660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1483665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1483674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483688 */     // MIs[0] passthru
     /* 1483688 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483701 */     // MIs[0] policy
     /* 1483701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1483714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483733 */     // GIR_Coverage, 4265,
     /* 1483733 */     GIR_EraseRootFromParent_Done,
     /* 1483734 */   // Label 20654: @1483734
     /* 1483734 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1483816), // Rule ID 4334 //
     /* 1483739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1483747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1483756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483770 */     // MIs[0] passthru
     /* 1483770 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483783 */     // MIs[0] policy
     /* 1483783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483793 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1483796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1483812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483815 */     // GIR_Coverage, 4334,
     /* 1483815 */     GIR_EraseRootFromParent_Done,
     /* 1483816 */   // Label 20655: @1483816
     /* 1483816 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1483898), // Rule ID 4335 //
     /* 1483821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1483829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1483838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483852 */     // MIs[0] passthru
     /* 1483852 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483865 */     // MIs[0] policy
     /* 1483865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483875 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1483878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1483894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483897 */     // GIR_Coverage, 4335,
     /* 1483897 */     GIR_EraseRootFromParent_Done,
     /* 1483898 */   // Label 20656: @1483898
     /* 1483898 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1483980), // Rule ID 4344 //
     /* 1483903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1483911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1483914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1483917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1483920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483934 */     // MIs[0] passthru
     /* 1483934 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1483939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483947 */     // MIs[0] policy
     /* 1483947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1483960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1483966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1483976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483979 */     // GIR_Coverage, 4344,
     /* 1483979 */     GIR_EraseRootFromParent_Done,
     /* 1483980 */   // Label 20657: @1483980
     /* 1483980 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1484062), // Rule ID 4345 //
     /* 1483985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1483993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1483996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1483999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1484002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484016 */     // MIs[0] passthru
     /* 1484016 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484029 */     // MIs[0] policy
     /* 1484029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1484042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484061 */     // GIR_Coverage, 4345,
     /* 1484061 */     GIR_EraseRootFromParent_Done,
     /* 1484062 */   // Label 20658: @1484062
     /* 1484062 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1484144), // Rule ID 4354 //
     /* 1484067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1484084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484098 */     // MIs[0] passthru
     /* 1484098 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484111 */     // MIs[0] policy
     /* 1484111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1484124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484143 */     // GIR_Coverage, 4354,
     /* 1484143 */     GIR_EraseRootFromParent_Done,
     /* 1484144 */   // Label 20659: @1484144
     /* 1484144 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1484226), // Rule ID 4355 //
     /* 1484149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1484166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484180 */     // MIs[0] passthru
     /* 1484180 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484193 */     // MIs[0] policy
     /* 1484193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484203 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1484206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484225 */     // GIR_Coverage, 4355,
     /* 1484225 */     GIR_EraseRootFromParent_Done,
     /* 1484226 */   // Label 20660: @1484226
     /* 1484226 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1484308), // Rule ID 4364 //
     /* 1484231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1484242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1484245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1484248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484262 */     // MIs[0] passthru
     /* 1484262 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484275 */     // MIs[0] policy
     /* 1484275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1484288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484307 */     // GIR_Coverage, 4364,
     /* 1484307 */     GIR_EraseRootFromParent_Done,
     /* 1484308 */   // Label 20661: @1484308
     /* 1484308 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1484390), // Rule ID 4365 //
     /* 1484313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1484324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1484327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1484330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484344 */     // MIs[0] passthru
     /* 1484344 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484357 */     // MIs[0] policy
     /* 1484357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1484370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484389 */     // GIR_Coverage, 4365,
     /* 1484389 */     GIR_EraseRootFromParent_Done,
     /* 1484390 */   // Label 20662: @1484390
     /* 1484390 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1484472), // Rule ID 4374 //
     /* 1484395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1484406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1484409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1484412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1484415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484426 */     // MIs[0] passthru
     /* 1484426 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484439 */     // MIs[0] policy
     /* 1484439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1484452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484471 */     // GIR_Coverage, 4374,
     /* 1484471 */     GIR_EraseRootFromParent_Done,
     /* 1484472 */   // Label 20663: @1484472
     /* 1484472 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1484554), // Rule ID 4375 //
     /* 1484477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1484488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1484491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1484494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1484497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484508 */     // MIs[0] passthru
     /* 1484508 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484521 */     // MIs[0] policy
     /* 1484521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484531 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1484534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484553 */     // GIR_Coverage, 4375,
     /* 1484553 */     GIR_EraseRootFromParent_Done,
     /* 1484554 */   // Label 20664: @1484554
     /* 1484554 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1484636), // Rule ID 4384 //
     /* 1484559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1484570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1484573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1484576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1484579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484590 */     // MIs[0] passthru
     /* 1484590 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484603 */     // MIs[0] policy
     /* 1484603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484613 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1484616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484635 */     // GIR_Coverage, 4384,
     /* 1484635 */     GIR_EraseRootFromParent_Done,
     /* 1484636 */   // Label 20665: @1484636
     /* 1484636 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1484718), // Rule ID 4385 //
     /* 1484641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1484652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1484655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1484658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1484661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484672 */     // MIs[0] passthru
     /* 1484672 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484685 */     // MIs[0] policy
     /* 1484685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484695 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1484698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484717 */     // GIR_Coverage, 4385,
     /* 1484717 */     GIR_EraseRootFromParent_Done,
     /* 1484718 */   // Label 20666: @1484718
     /* 1484718 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1484800), // Rule ID 4394 //
     /* 1484723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1484740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484754 */     // MIs[0] passthru
     /* 1484754 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484767 */     // MIs[0] policy
     /* 1484767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1484780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484799 */     // GIR_Coverage, 4394,
     /* 1484799 */     GIR_EraseRootFromParent_Done,
     /* 1484800 */   // Label 20667: @1484800
     /* 1484800 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1484882), // Rule ID 4395 //
     /* 1484805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1484822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484836 */     // MIs[0] passthru
     /* 1484836 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484849 */     // MIs[0] policy
     /* 1484849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1484862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484881 */     // GIR_Coverage, 4395,
     /* 1484881 */     GIR_EraseRootFromParent_Done,
     /* 1484882 */   // Label 20668: @1484882
     /* 1484882 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1484964), // Rule ID 4404 //
     /* 1484887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1484904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484918 */     // MIs[0] passthru
     /* 1484918 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1484923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484931 */     // MIs[0] policy
     /* 1484931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484941 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1484944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1484950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484963 */     // GIR_Coverage, 4404,
     /* 1484963 */     GIR_EraseRootFromParent_Done,
     /* 1484964 */   // Label 20669: @1484964
     /* 1484964 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1485046), // Rule ID 4405 //
     /* 1484969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1484977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1484986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485000 */     // MIs[0] passthru
     /* 1485000 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485013 */     // MIs[0] policy
     /* 1485013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1485026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485045 */     // GIR_Coverage, 4405,
     /* 1485045 */     GIR_EraseRootFromParent_Done,
     /* 1485046 */   // Label 20670: @1485046
     /* 1485046 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1485128), // Rule ID 4414 //
     /* 1485051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1485068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485082 */     // MIs[0] passthru
     /* 1485082 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485095 */     // MIs[0] policy
     /* 1485095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1485108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485127 */     // GIR_Coverage, 4414,
     /* 1485127 */     GIR_EraseRootFromParent_Done,
     /* 1485128 */   // Label 20671: @1485128
     /* 1485128 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1485210), // Rule ID 4415 //
     /* 1485133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1485150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485164 */     // MIs[0] passthru
     /* 1485164 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485177 */     // MIs[0] policy
     /* 1485177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1485190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485209 */     // GIR_Coverage, 4415,
     /* 1485209 */     GIR_EraseRootFromParent_Done,
     /* 1485210 */   // Label 20672: @1485210
     /* 1485210 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1485292), // Rule ID 4424 //
     /* 1485215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1485232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485246 */     // MIs[0] passthru
     /* 1485246 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485259 */     // MIs[0] policy
     /* 1485259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485269 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1485272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485291 */     // GIR_Coverage, 4424,
     /* 1485291 */     GIR_EraseRootFromParent_Done,
     /* 1485292 */   // Label 20673: @1485292
     /* 1485292 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1485374), // Rule ID 4425 //
     /* 1485297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1485314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485328 */     // MIs[0] passthru
     /* 1485328 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485341 */     // MIs[0] policy
     /* 1485341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1485354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485373 */     // GIR_Coverage, 4425,
     /* 1485373 */     GIR_EraseRootFromParent_Done,
     /* 1485374 */   // Label 20674: @1485374
     /* 1485374 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1485456), // Rule ID 4434 //
     /* 1485379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1485396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485410 */     // MIs[0] passthru
     /* 1485410 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485423 */     // MIs[0] policy
     /* 1485423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485433 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1485436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485455 */     // GIR_Coverage, 4434,
     /* 1485455 */     GIR_EraseRootFromParent_Done,
     /* 1485456 */   // Label 20675: @1485456
     /* 1485456 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1485538), // Rule ID 4435 //
     /* 1485461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1485478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485492 */     // MIs[0] passthru
     /* 1485492 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485505 */     // MIs[0] policy
     /* 1485505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1485518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485537 */     // GIR_Coverage, 4435,
     /* 1485537 */     GIR_EraseRootFromParent_Done,
     /* 1485538 */   // Label 20676: @1485538
     /* 1485538 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1485620), // Rule ID 4444 //
     /* 1485543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1485546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1485560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485574 */     // MIs[0] passthru
     /* 1485574 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485587 */     // MIs[0] policy
     /* 1485587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485597 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1485600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485619 */     // GIR_Coverage, 4444,
     /* 1485619 */     GIR_EraseRootFromParent_Done,
     /* 1485620 */   // Label 20677: @1485620
     /* 1485620 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1485702), // Rule ID 4445 //
     /* 1485625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1485628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1485642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485656 */     // MIs[0] passthru
     /* 1485656 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485669 */     // MIs[0] policy
     /* 1485669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485679 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1485682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485701 */     // GIR_Coverage, 4445,
     /* 1485701 */     GIR_EraseRootFromParent_Done,
     /* 1485702 */   // Label 20678: @1485702
     /* 1485702 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1485784), // Rule ID 4454 //
     /* 1485707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1485710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1485718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1485721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1485724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485738 */     // MIs[0] passthru
     /* 1485738 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485751 */     // MIs[0] policy
     /* 1485751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1485764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485783 */     // GIR_Coverage, 4454,
     /* 1485783 */     GIR_EraseRootFromParent_Done,
     /* 1485784 */   // Label 20679: @1485784
     /* 1485784 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1485866), // Rule ID 4455 //
     /* 1485789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1485792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1485800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1485803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1485806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485820 */     // MIs[0] passthru
     /* 1485820 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485833 */     // MIs[0] policy
     /* 1485833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1485846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485865 */     // GIR_Coverage, 4455,
     /* 1485865 */     GIR_EraseRootFromParent_Done,
     /* 1485866 */   // Label 20680: @1485866
     /* 1485866 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1485948), // Rule ID 4464 //
     /* 1485871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1485874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1485882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1485885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1485888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485902 */     // MIs[0] passthru
     /* 1485902 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485915 */     // MIs[0] policy
     /* 1485915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485925 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1485928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1485934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485947 */     // GIR_Coverage, 4464,
     /* 1485947 */     GIR_EraseRootFromParent_Done,
     /* 1485948 */   // Label 20681: @1485948
     /* 1485948 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1486030), // Rule ID 4465 //
     /* 1485953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1485956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1485961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1485964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1485967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1485970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485984 */     // MIs[0] passthru
     /* 1485984 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1485989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485997 */     // MIs[0] policy
     /* 1485997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486007 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1486010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486029 */     // GIR_Coverage, 4465,
     /* 1486029 */     GIR_EraseRootFromParent_Done,
     /* 1486030 */   // Label 20682: @1486030
     /* 1486030 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1486112), // Rule ID 4474 //
     /* 1486035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1486038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1486043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1486052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486066 */     // MIs[0] passthru
     /* 1486066 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486079 */     // MIs[0] policy
     /* 1486079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486089 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1486092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486111 */     // GIR_Coverage, 4474,
     /* 1486111 */     GIR_EraseRootFromParent_Done,
     /* 1486112 */   // Label 20683: @1486112
     /* 1486112 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1486194), // Rule ID 4475 //
     /* 1486117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1486120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1486125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1486134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486148 */     // MIs[0] passthru
     /* 1486148 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486161 */     // MIs[0] policy
     /* 1486161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486171 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1486174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486193 */     // GIR_Coverage, 4475,
     /* 1486193 */     GIR_EraseRootFromParent_Done,
     /* 1486194 */   // Label 20684: @1486194
     /* 1486194 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1486276), // Rule ID 4544 //
     /* 1486199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1486210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1486213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1486216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486230 */     // MIs[0] passthru
     /* 1486230 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486243 */     // MIs[0] policy
     /* 1486243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486253 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1486256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486275 */     // GIR_Coverage, 4544,
     /* 1486275 */     GIR_EraseRootFromParent_Done,
     /* 1486276 */   // Label 20685: @1486276
     /* 1486276 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1486358), // Rule ID 4545 //
     /* 1486281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1486292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1486295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1486298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486312 */     // MIs[0] passthru
     /* 1486312 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486325 */     // MIs[0] policy
     /* 1486325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486335 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1486338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486357 */     // GIR_Coverage, 4545,
     /* 1486357 */     GIR_EraseRootFromParent_Done,
     /* 1486358 */   // Label 20686: @1486358
     /* 1486358 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1486440), // Rule ID 4554 //
     /* 1486363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1486374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1486377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1486380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486394 */     // MIs[0] passthru
     /* 1486394 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486407 */     // MIs[0] policy
     /* 1486407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486417 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1486420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486439 */     // GIR_Coverage, 4554,
     /* 1486439 */     GIR_EraseRootFromParent_Done,
     /* 1486440 */   // Label 20687: @1486440
     /* 1486440 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1486522), // Rule ID 4555 //
     /* 1486445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1486456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1486459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1486462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486476 */     // MIs[0] passthru
     /* 1486476 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486489 */     // MIs[0] policy
     /* 1486489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1486502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486521 */     // GIR_Coverage, 4555,
     /* 1486521 */     GIR_EraseRootFromParent_Done,
     /* 1486522 */   // Label 20688: @1486522
     /* 1486522 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1486604), // Rule ID 4564 //
     /* 1486527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1486538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1486541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1486544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486558 */     // MIs[0] passthru
     /* 1486558 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486571 */     // MIs[0] policy
     /* 1486571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1486584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486603 */     // GIR_Coverage, 4564,
     /* 1486603 */     GIR_EraseRootFromParent_Done,
     /* 1486604 */   // Label 20689: @1486604
     /* 1486604 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1486686), // Rule ID 4565 //
     /* 1486609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1486620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1486623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1486626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486640 */     // MIs[0] passthru
     /* 1486640 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486653 */     // MIs[0] policy
     /* 1486653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486663 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1486666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486685 */     // GIR_Coverage, 4565,
     /* 1486685 */     GIR_EraseRootFromParent_Done,
     /* 1486686 */   // Label 20690: @1486686
     /* 1486686 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1486768), // Rule ID 4574 //
     /* 1486691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1486702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1486705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1486708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486722 */     // MIs[0] passthru
     /* 1486722 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486735 */     // MIs[0] policy
     /* 1486735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1486748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486767 */     // GIR_Coverage, 4574,
     /* 1486767 */     GIR_EraseRootFromParent_Done,
     /* 1486768 */   // Label 20691: @1486768
     /* 1486768 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1486850), // Rule ID 4575 //
     /* 1486773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1486784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1486787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1486790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486804 */     // MIs[0] passthru
     /* 1486804 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486817 */     // MIs[0] policy
     /* 1486817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1486830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486849 */     // GIR_Coverage, 4575,
     /* 1486849 */     GIR_EraseRootFromParent_Done,
     /* 1486850 */   // Label 20692: @1486850
     /* 1486850 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1486932), // Rule ID 4584 //
     /* 1486855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1486866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1486869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1486872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486886 */     // MIs[0] passthru
     /* 1486886 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486899 */     // MIs[0] policy
     /* 1486899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486909 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1486912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1486918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486931 */     // GIR_Coverage, 4584,
     /* 1486931 */     GIR_EraseRootFromParent_Done,
     /* 1486932 */   // Label 20693: @1486932
     /* 1486932 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1487014), // Rule ID 4585 //
     /* 1486937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1486945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1486948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1486951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1486954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486968 */     // MIs[0] passthru
     /* 1486968 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1486973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486981 */     // MIs[0] policy
     /* 1486981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486991 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1486994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487013 */     // GIR_Coverage, 4585,
     /* 1487013 */     GIR_EraseRootFromParent_Done,
     /* 1487014 */   // Label 20694: @1487014
     /* 1487014 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1487096), // Rule ID 4594 //
     /* 1487019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1487036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487050 */     // MIs[0] passthru
     /* 1487050 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487063 */     // MIs[0] policy
     /* 1487063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487073 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1487076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487095 */     // GIR_Coverage, 4594,
     /* 1487095 */     GIR_EraseRootFromParent_Done,
     /* 1487096 */   // Label 20695: @1487096
     /* 1487096 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1487178), // Rule ID 4595 //
     /* 1487101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1487118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487132 */     // MIs[0] passthru
     /* 1487132 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487145 */     // MIs[0] policy
     /* 1487145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487155 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1487158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487177 */     // GIR_Coverage, 4595,
     /* 1487177 */     GIR_EraseRootFromParent_Done,
     /* 1487178 */   // Label 20696: @1487178
     /* 1487178 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1487260), // Rule ID 4604 //
     /* 1487183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1487200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487214 */     // MIs[0] passthru
     /* 1487214 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487227 */     // MIs[0] policy
     /* 1487227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487237 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1487240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487259 */     // GIR_Coverage, 4604,
     /* 1487259 */     GIR_EraseRootFromParent_Done,
     /* 1487260 */   // Label 20697: @1487260
     /* 1487260 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1487342), // Rule ID 4605 //
     /* 1487265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1487282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487296 */     // MIs[0] passthru
     /* 1487296 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487309 */     // MIs[0] policy
     /* 1487309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1487322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487341 */     // GIR_Coverage, 4605,
     /* 1487341 */     GIR_EraseRootFromParent_Done,
     /* 1487342 */   // Label 20698: @1487342
     /* 1487342 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1487424), // Rule ID 4614 //
     /* 1487347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1487358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1487361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1487364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487378 */     // MIs[0] passthru
     /* 1487378 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487391 */     // MIs[0] policy
     /* 1487391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1487404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487423 */     // GIR_Coverage, 4614,
     /* 1487423 */     GIR_EraseRootFromParent_Done,
     /* 1487424 */   // Label 20699: @1487424
     /* 1487424 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1487506), // Rule ID 4615 //
     /* 1487429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1487440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1487443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1487446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487460 */     // MIs[0] passthru
     /* 1487460 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487473 */     // MIs[0] policy
     /* 1487473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487483 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1487486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487505 */     // GIR_Coverage, 4615,
     /* 1487505 */     GIR_EraseRootFromParent_Done,
     /* 1487506 */   // Label 20700: @1487506
     /* 1487506 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1487588), // Rule ID 4624 //
     /* 1487511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1487522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1487525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1487528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487542 */     // MIs[0] passthru
     /* 1487542 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487555 */     // MIs[0] policy
     /* 1487555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1487568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487587 */     // GIR_Coverage, 4624,
     /* 1487587 */     GIR_EraseRootFromParent_Done,
     /* 1487588 */   // Label 20701: @1487588
     /* 1487588 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1487670), // Rule ID 4625 //
     /* 1487593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1487604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1487607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1487610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487624 */     // MIs[0] passthru
     /* 1487624 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487637 */     // MIs[0] policy
     /* 1487637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1487650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487669 */     // GIR_Coverage, 4625,
     /* 1487669 */     GIR_EraseRootFromParent_Done,
     /* 1487670 */   // Label 20702: @1487670
     /* 1487670 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1487752), // Rule ID 4634 //
     /* 1487675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1487686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1487689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1487692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487706 */     // MIs[0] passthru
     /* 1487706 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487719 */     // MIs[0] policy
     /* 1487719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487729 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1487732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487751 */     // GIR_Coverage, 4634,
     /* 1487751 */     GIR_EraseRootFromParent_Done,
     /* 1487752 */   // Label 20703: @1487752
     /* 1487752 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1487834), // Rule ID 4635 //
     /* 1487757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1487768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1487771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1487774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487788 */     // MIs[0] passthru
     /* 1487788 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487801 */     // MIs[0] policy
     /* 1487801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487811 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1487814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487833 */     // GIR_Coverage, 4635,
     /* 1487833 */     GIR_EraseRootFromParent_Done,
     /* 1487834 */   // Label 20704: @1487834
     /* 1487834 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1487916), // Rule ID 4644 //
     /* 1487839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1487850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1487853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1487856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487870 */     // MIs[0] passthru
     /* 1487870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487883 */     // MIs[0] policy
     /* 1487883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1487896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487915 */     // GIR_Coverage, 4644,
     /* 1487915 */     GIR_EraseRootFromParent_Done,
     /* 1487916 */   // Label 20705: @1487916
     /* 1487916 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1487998), // Rule ID 4645 //
     /* 1487921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1487929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1487932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1487935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1487938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487952 */     // MIs[0] passthru
     /* 1487952 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1487957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487965 */     // MIs[0] policy
     /* 1487965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487975 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1487978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1487984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487997 */     // GIR_Coverage, 4645,
     /* 1487997 */     GIR_EraseRootFromParent_Done,
     /* 1487998 */   // Label 20706: @1487998
     /* 1487998 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1488080), // Rule ID 4654 //
     /* 1488003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1488006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1488020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488034 */     // MIs[0] passthru
     /* 1488034 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488047 */     // MIs[0] policy
     /* 1488047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1488060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488079 */     // GIR_Coverage, 4654,
     /* 1488079 */     GIR_EraseRootFromParent_Done,
     /* 1488080 */   // Label 20707: @1488080
     /* 1488080 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1488162), // Rule ID 4655 //
     /* 1488085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1488088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1488102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488116 */     // MIs[0] passthru
     /* 1488116 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488129 */     // MIs[0] policy
     /* 1488129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488139 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1488142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488161 */     // GIR_Coverage, 4655,
     /* 1488161 */     GIR_EraseRootFromParent_Done,
     /* 1488162 */   // Label 20708: @1488162
     /* 1488162 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1488244), // Rule ID 4664 //
     /* 1488167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1488170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1488178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1488181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1488184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488198 */     // MIs[0] passthru
     /* 1488198 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488211 */     // MIs[0] policy
     /* 1488211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1488224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488243 */     // GIR_Coverage, 4664,
     /* 1488243 */     GIR_EraseRootFromParent_Done,
     /* 1488244 */   // Label 20709: @1488244
     /* 1488244 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1488326), // Rule ID 4665 //
     /* 1488249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1488252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1488260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1488263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1488266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488280 */     // MIs[0] passthru
     /* 1488280 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488293 */     // MIs[0] policy
     /* 1488293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1488306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488325 */     // GIR_Coverage, 4665,
     /* 1488325 */     GIR_EraseRootFromParent_Done,
     /* 1488326 */   // Label 20710: @1488326
     /* 1488326 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1488408), // Rule ID 4674 //
     /* 1488331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1488334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1488342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1488345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1488348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488362 */     // MIs[0] passthru
     /* 1488362 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488375 */     // MIs[0] policy
     /* 1488375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488385 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1488388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488407 */     // GIR_Coverage, 4674,
     /* 1488407 */     GIR_EraseRootFromParent_Done,
     /* 1488408 */   // Label 20711: @1488408
     /* 1488408 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1488490), // Rule ID 4675 //
     /* 1488413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1488416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1488424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1488427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1488430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488444 */     // MIs[0] passthru
     /* 1488444 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488457 */     // MIs[0] policy
     /* 1488457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488467 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1488470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488489 */     // GIR_Coverage, 4675,
     /* 1488489 */     GIR_EraseRootFromParent_Done,
     /* 1488490 */   // Label 20712: @1488490
     /* 1488490 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1488572), // Rule ID 4684 //
     /* 1488495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1488498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1488506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1488509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1488512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488526 */     // MIs[0] passthru
     /* 1488526 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488539 */     // MIs[0] policy
     /* 1488539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488549 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1488552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488571 */     // GIR_Coverage, 4684,
     /* 1488571 */     GIR_EraseRootFromParent_Done,
     /* 1488572 */   // Label 20713: @1488572
     /* 1488572 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1488654), // Rule ID 4685 //
     /* 1488577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1488580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1488585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1488588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1488591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1488594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488608 */     // MIs[0] passthru
     /* 1488608 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1488613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488621 */     // MIs[0] policy
     /* 1488621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488631 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1488634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488653 */     // GIR_Coverage, 4685,
     /* 1488653 */     GIR_EraseRootFromParent_Done,
     /* 1488654 */   // Label 20714: @1488654
     /* 1488654 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1488740), // Rule ID 2580 //
     /* 1488659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1488667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1488670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1488673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1488676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1488679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488705 */     // MIs[0] policy
     /* 1488705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488715 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1488718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488739 */     // GIR_Coverage, 2580,
     /* 1488739 */     GIR_EraseRootFromParent_Done,
     /* 1488740 */   // Label 20715: @1488740
     /* 1488740 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1488826), // Rule ID 2581 //
     /* 1488745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1488753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1488756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1488759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1488762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1488765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488791 */     // MIs[0] policy
     /* 1488791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488801 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1488804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488825 */     // GIR_Coverage, 2581,
     /* 1488825 */     GIR_EraseRootFromParent_Done,
     /* 1488826 */   // Label 20716: @1488826
     /* 1488826 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1488912), // Rule ID 2618 //
     /* 1488831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1488839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1488842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1488845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1488848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1488851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488877 */     // MIs[0] policy
     /* 1488877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488887 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1488890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488911 */     // GIR_Coverage, 2618,
     /* 1488911 */     GIR_EraseRootFromParent_Done,
     /* 1488912 */   // Label 20717: @1488912
     /* 1488912 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1488998), // Rule ID 2619 //
     /* 1488917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1488925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1488928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1488931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1488934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1488937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488963 */     // MIs[0] policy
     /* 1488963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488973 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1488976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1488984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488997 */     // GIR_Coverage, 2619,
     /* 1488997 */     GIR_EraseRootFromParent_Done,
     /* 1488998 */   // Label 20718: @1488998
     /* 1488998 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1489084), // Rule ID 2632 //
     /* 1489003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1489011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1489014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1489017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1489020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1489023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489049 */     // MIs[0] policy
     /* 1489049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1489062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1489070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489083 */     // GIR_Coverage, 2632,
     /* 1489083 */     GIR_EraseRootFromParent_Done,
     /* 1489084 */   // Label 20719: @1489084
     /* 1489084 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1489170), // Rule ID 2633 //
     /* 1489089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1489097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1489100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1489103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1489106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1489109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489135 */     // MIs[0] policy
     /* 1489135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489145 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1489148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1489156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489169 */     // GIR_Coverage, 2633,
     /* 1489169 */     GIR_EraseRootFromParent_Done,
     /* 1489170 */   // Label 20720: @1489170
     /* 1489170 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1489256), // Rule ID 2652 //
     /* 1489175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1489186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1489189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1489192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1489195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489221 */     // MIs[0] policy
     /* 1489221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489231 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1489234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489255 */     // GIR_Coverage, 2652,
     /* 1489255 */     GIR_EraseRootFromParent_Done,
     /* 1489256 */   // Label 20721: @1489256
     /* 1489256 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1489342), // Rule ID 2653 //
     /* 1489261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1489272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1489275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1489278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1489281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489307 */     // MIs[0] policy
     /* 1489307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489317 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1489320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489341 */     // GIR_Coverage, 2653,
     /* 1489341 */     GIR_EraseRootFromParent_Done,
     /* 1489342 */   // Label 20722: @1489342
     /* 1489342 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1489428), // Rule ID 2660 //
     /* 1489347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1489358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1489361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1489364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1489367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489393 */     // MIs[0] policy
     /* 1489393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489403 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1489406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489427 */     // GIR_Coverage, 2660,
     /* 1489427 */     GIR_EraseRootFromParent_Done,
     /* 1489428 */   // Label 20723: @1489428
     /* 1489428 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1489514), // Rule ID 2661 //
     /* 1489433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1489444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1489447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1489450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1489453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489479 */     // MIs[0] policy
     /* 1489479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1489492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489513 */     // GIR_Coverage, 2661,
     /* 1489513 */     GIR_EraseRootFromParent_Done,
     /* 1489514 */   // Label 20724: @1489514
     /* 1489514 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1489600), // Rule ID 2668 //
     /* 1489519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1489530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1489533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1489536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1489539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489565 */     // MIs[0] policy
     /* 1489565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489575 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1489578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489599 */     // GIR_Coverage, 2668,
     /* 1489599 */     GIR_EraseRootFromParent_Done,
     /* 1489600 */   // Label 20725: @1489600
     /* 1489600 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1489686), // Rule ID 2669 //
     /* 1489605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1489616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1489619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1489622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1489625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489651 */     // MIs[0] policy
     /* 1489651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489661 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1489664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489685 */     // GIR_Coverage, 2669,
     /* 1489685 */     GIR_EraseRootFromParent_Done,
     /* 1489686 */   // Label 20726: @1489686
     /* 1489686 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1489772), // Rule ID 2676 //
     /* 1489691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1489702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1489705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1489708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1489711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489737 */     // MIs[0] policy
     /* 1489737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489747 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1489750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489771 */     // GIR_Coverage, 2676,
     /* 1489771 */     GIR_EraseRootFromParent_Done,
     /* 1489772 */   // Label 20727: @1489772
     /* 1489772 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1489858), // Rule ID 2677 //
     /* 1489777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1489788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1489791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1489794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1489797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489823 */     // MIs[0] policy
     /* 1489823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489833 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1489836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489857 */     // GIR_Coverage, 2677,
     /* 1489857 */     GIR_EraseRootFromParent_Done,
     /* 1489858 */   // Label 20728: @1489858
     /* 1489858 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1489944), // Rule ID 2684 //
     /* 1489863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1489874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1489877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1489880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1489883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489909 */     // MIs[0] policy
     /* 1489909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1489922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1489928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1489930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489943 */     // GIR_Coverage, 2684,
     /* 1489943 */     GIR_EraseRootFromParent_Done,
     /* 1489944 */   // Label 20729: @1489944
     /* 1489944 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1490030), // Rule ID 2685 //
     /* 1489949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1489957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1489960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1489963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1489966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1489969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489995 */     // MIs[0] policy
     /* 1489995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490005 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1490008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490029 */     // GIR_Coverage, 2685,
     /* 1490029 */     GIR_EraseRootFromParent_Done,
     /* 1490030 */   // Label 20730: @1490030
     /* 1490030 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1490116), // Rule ID 2692 //
     /* 1490035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1490046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1490049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1490052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1490055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490081 */     // MIs[0] policy
     /* 1490081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1490094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490115 */     // GIR_Coverage, 2692,
     /* 1490115 */     GIR_EraseRootFromParent_Done,
     /* 1490116 */   // Label 20731: @1490116
     /* 1490116 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1490202), // Rule ID 2693 //
     /* 1490121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1490132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1490135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1490138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1490141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490167 */     // MIs[0] policy
     /* 1490167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1490180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490201 */     // GIR_Coverage, 2693,
     /* 1490201 */     GIR_EraseRootFromParent_Done,
     /* 1490202 */   // Label 20732: @1490202
     /* 1490202 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1490288), // Rule ID 2700 //
     /* 1490207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1490218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1490221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1490224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1490227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490253 */     // MIs[0] policy
     /* 1490253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490263 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490287 */     // GIR_Coverage, 2700,
     /* 1490287 */     GIR_EraseRootFromParent_Done,
     /* 1490288 */   // Label 20733: @1490288
     /* 1490288 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1490374), // Rule ID 2701 //
     /* 1490293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1490304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1490307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1490310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1490313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490339 */     // MIs[0] policy
     /* 1490339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490349 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490373 */     // GIR_Coverage, 2701,
     /* 1490373 */     GIR_EraseRootFromParent_Done,
     /* 1490374 */   // Label 20734: @1490374
     /* 1490374 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1490460), // Rule ID 2708 //
     /* 1490379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1490390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1490393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1490396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1490399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490425 */     // MIs[0] policy
     /* 1490425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490435 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490459 */     // GIR_Coverage, 2708,
     /* 1490459 */     GIR_EraseRootFromParent_Done,
     /* 1490460 */   // Label 20735: @1490460
     /* 1490460 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1490546), // Rule ID 2709 //
     /* 1490465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1490476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1490479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1490482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1490485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490511 */     // MIs[0] policy
     /* 1490511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490545 */     // GIR_Coverage, 2709,
     /* 1490545 */     GIR_EraseRootFromParent_Done,
     /* 1490546 */   // Label 20736: @1490546
     /* 1490546 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1490632), // Rule ID 2716 //
     /* 1490551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1490562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1490565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1490568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1490571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490597 */     // MIs[0] policy
     /* 1490597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490631 */     // GIR_Coverage, 2716,
     /* 1490631 */     GIR_EraseRootFromParent_Done,
     /* 1490632 */   // Label 20737: @1490632
     /* 1490632 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1490718), // Rule ID 2717 //
     /* 1490637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1490648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1490651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1490654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1490657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490683 */     // MIs[0] policy
     /* 1490683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490717 */     // GIR_Coverage, 2717,
     /* 1490717 */     GIR_EraseRootFromParent_Done,
     /* 1490718 */   // Label 20738: @1490718
     /* 1490718 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1490804), // Rule ID 2724 //
     /* 1490723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1490734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1490737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1490740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1490743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490769 */     // MIs[0] policy
     /* 1490769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490779 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490803 */     // GIR_Coverage, 2724,
     /* 1490803 */     GIR_EraseRootFromParent_Done,
     /* 1490804 */   // Label 20739: @1490804
     /* 1490804 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1490890), // Rule ID 2725 //
     /* 1490809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1490820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1490823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1490826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1490829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490855 */     // MIs[0] policy
     /* 1490855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1490868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490889 */     // GIR_Coverage, 2725,
     /* 1490889 */     GIR_EraseRootFromParent_Done,
     /* 1490890 */   // Label 20740: @1490890
     /* 1490890 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1490976), // Rule ID 2732 //
     /* 1490895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1490906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1490909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1490912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1490915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490941 */     // MIs[0] policy
     /* 1490941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490951 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1490954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1490960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1490962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490975 */     // GIR_Coverage, 2732,
     /* 1490975 */     GIR_EraseRootFromParent_Done,
     /* 1490976 */   // Label 20741: @1490976
     /* 1490976 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1491062), // Rule ID 2733 //
     /* 1490981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1490989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1490992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1490995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1490998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1491001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1491004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491027 */     // MIs[0] policy
     /* 1491027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491037 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1491040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491061 */     // GIR_Coverage, 2733,
     /* 1491061 */     GIR_EraseRootFromParent_Done,
     /* 1491062 */   // Label 20742: @1491062
     /* 1491062 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1491148), // Rule ID 2740 //
     /* 1491067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1491078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1491081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1491084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1491087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491113 */     // MIs[0] policy
     /* 1491113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491123 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1491126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491147 */     // GIR_Coverage, 2740,
     /* 1491147 */     GIR_EraseRootFromParent_Done,
     /* 1491148 */   // Label 20743: @1491148
     /* 1491148 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1491234), // Rule ID 2741 //
     /* 1491153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1491164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1491167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1491170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1491173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491199 */     // MIs[0] policy
     /* 1491199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491209 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1491212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491233 */     // GIR_Coverage, 2741,
     /* 1491233 */     GIR_EraseRootFromParent_Done,
     /* 1491234 */   // Label 20744: @1491234
     /* 1491234 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1491320), // Rule ID 2748 //
     /* 1491239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1491250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1491253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1491256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1491259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1491262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491285 */     // MIs[0] policy
     /* 1491285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491295 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1491298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491319 */     // GIR_Coverage, 2748,
     /* 1491319 */     GIR_EraseRootFromParent_Done,
     /* 1491320 */   // Label 20745: @1491320
     /* 1491320 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1491406), // Rule ID 2749 //
     /* 1491325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1491336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1491339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1491342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1491345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1491348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491371 */     // MIs[0] policy
     /* 1491371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491381 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1491384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491405 */     // GIR_Coverage, 2749,
     /* 1491405 */     GIR_EraseRootFromParent_Done,
     /* 1491406 */   // Label 20746: @1491406
     /* 1491406 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1491492), // Rule ID 2756 //
     /* 1491411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1491422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1491425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1491428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1491431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491457 */     // MIs[0] policy
     /* 1491457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1491470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491491 */     // GIR_Coverage, 2756,
     /* 1491491 */     GIR_EraseRootFromParent_Done,
     /* 1491492 */   // Label 20747: @1491492
     /* 1491492 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1491578), // Rule ID 2757 //
     /* 1491497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1491508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1491511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1491514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1491517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491543 */     // MIs[0] policy
     /* 1491543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1491556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491577 */     // GIR_Coverage, 2757,
     /* 1491577 */     GIR_EraseRootFromParent_Done,
     /* 1491578 */   // Label 20748: @1491578
     /* 1491578 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1491664), // Rule ID 2764 //
     /* 1491583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1491594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1491597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1491600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1491603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1491606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491629 */     // MIs[0] policy
     /* 1491629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1491642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491663 */     // GIR_Coverage, 2764,
     /* 1491663 */     GIR_EraseRootFromParent_Done,
     /* 1491664 */   // Label 20749: @1491664
     /* 1491664 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1491750), // Rule ID 2765 //
     /* 1491669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1491680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1491683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1491686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1491689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1491692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491715 */     // MIs[0] policy
     /* 1491715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491725 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1491728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491749 */     // GIR_Coverage, 2765,
     /* 1491749 */     GIR_EraseRootFromParent_Done,
     /* 1491750 */   // Label 20750: @1491750
     /* 1491750 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1491836), // Rule ID 2772 //
     /* 1491755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1491766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1491769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1491772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1491775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491801 */     // MIs[0] policy
     /* 1491801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491811 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1491814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491835 */     // GIR_Coverage, 2772,
     /* 1491835 */     GIR_EraseRootFromParent_Done,
     /* 1491836 */   // Label 20751: @1491836
     /* 1491836 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1491922), // Rule ID 2773 //
     /* 1491841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1491852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1491855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1491858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1491861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491887 */     // MIs[0] policy
     /* 1491887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491897 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1491900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491921 */     // GIR_Coverage, 2773,
     /* 1491921 */     GIR_EraseRootFromParent_Done,
     /* 1491922 */   // Label 20752: @1491922
     /* 1491922 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1492008), // Rule ID 2780 //
     /* 1491927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1491935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1491938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1491941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1491944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1491947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491973 */     // MIs[0] policy
     /* 1491973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1491986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1491992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1491994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492007 */     // GIR_Coverage, 2780,
     /* 1492007 */     GIR_EraseRootFromParent_Done,
     /* 1492008 */   // Label 20753: @1492008
     /* 1492008 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1492094), // Rule ID 2781 //
     /* 1492013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1492024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1492027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1492030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1492033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492059 */     // MIs[0] policy
     /* 1492059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1492072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492093 */     // GIR_Coverage, 2781,
     /* 1492093 */     GIR_EraseRootFromParent_Done,
     /* 1492094 */   // Label 20754: @1492094
     /* 1492094 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1492180), // Rule ID 2788 //
     /* 1492099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1492110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1492113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1492116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1492119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492145 */     // MIs[0] policy
     /* 1492145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492155 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1492158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492179 */     // GIR_Coverage, 2788,
     /* 1492179 */     GIR_EraseRootFromParent_Done,
     /* 1492180 */   // Label 20755: @1492180
     /* 1492180 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1492266), // Rule ID 2789 //
     /* 1492185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1492196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1492199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1492202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1492205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492231 */     // MIs[0] policy
     /* 1492231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492241 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1492244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492265 */     // GIR_Coverage, 2789,
     /* 1492265 */     GIR_EraseRootFromParent_Done,
     /* 1492266 */   // Label 20756: @1492266
     /* 1492266 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1492352), // Rule ID 2796 //
     /* 1492271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1492282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1492285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1492288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1492291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492317 */     // MIs[0] policy
     /* 1492317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1492330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492351 */     // GIR_Coverage, 2796,
     /* 1492351 */     GIR_EraseRootFromParent_Done,
     /* 1492352 */   // Label 20757: @1492352
     /* 1492352 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1492438), // Rule ID 2797 //
     /* 1492357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1492368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1492371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1492374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1492377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492403 */     // MIs[0] policy
     /* 1492403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1492416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492437 */     // GIR_Coverage, 2797,
     /* 1492437 */     GIR_EraseRootFromParent_Done,
     /* 1492438 */   // Label 20758: @1492438
     /* 1492438 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1492524), // Rule ID 2804 //
     /* 1492443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1492454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1492457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1492460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1492463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492489 */     // MIs[0] policy
     /* 1492489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492499 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1492502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492523 */     // GIR_Coverage, 2804,
     /* 1492523 */     GIR_EraseRootFromParent_Done,
     /* 1492524 */   // Label 20759: @1492524
     /* 1492524 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1492610), // Rule ID 2805 //
     /* 1492529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1492540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1492543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1492546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1492549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492575 */     // MIs[0] policy
     /* 1492575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1492588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492609 */     // GIR_Coverage, 2805,
     /* 1492609 */     GIR_EraseRootFromParent_Done,
     /* 1492610 */   // Label 20760: @1492610
     /* 1492610 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1492696), // Rule ID 2812 //
     /* 1492615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1492626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1492629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1492632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1492635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492661 */     // MIs[0] policy
     /* 1492661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1492674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492695 */     // GIR_Coverage, 2812,
     /* 1492695 */     GIR_EraseRootFromParent_Done,
     /* 1492696 */   // Label 20761: @1492696
     /* 1492696 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1492782), // Rule ID 2813 //
     /* 1492701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1492712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1492715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1492718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1492721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492747 */     // MIs[0] policy
     /* 1492747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492757 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1492760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492781 */     // GIR_Coverage, 2813,
     /* 1492781 */     GIR_EraseRootFromParent_Done,
     /* 1492782 */   // Label 20762: @1492782
     /* 1492782 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1492868), // Rule ID 2820 //
     /* 1492787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1492798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1492801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1492804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1492807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492833 */     // MIs[0] policy
     /* 1492833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1492846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492867 */     // GIR_Coverage, 2820,
     /* 1492867 */     GIR_EraseRootFromParent_Done,
     /* 1492868 */   // Label 20763: @1492868
     /* 1492868 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1492954), // Rule ID 2821 //
     /* 1492873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1492881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1492884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1492887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1492890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1492893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492919 */     // MIs[0] policy
     /* 1492919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492929 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1492932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1492938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1492940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492953 */     // GIR_Coverage, 2821,
     /* 1492953 */     GIR_EraseRootFromParent_Done,
     /* 1492954 */   // Label 20764: @1492954
     /* 1492954 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1493040), // Rule ID 2828 //
     /* 1492959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1492967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1492970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1492973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1492976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1492979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493005 */     // MIs[0] policy
     /* 1493005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493015 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1493018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493039 */     // GIR_Coverage, 2828,
     /* 1493039 */     GIR_EraseRootFromParent_Done,
     /* 1493040 */   // Label 20765: @1493040
     /* 1493040 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1493126), // Rule ID 2829 //
     /* 1493045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1493056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1493059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1493062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1493065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493091 */     // MIs[0] policy
     /* 1493091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493101 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1493104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493125 */     // GIR_Coverage, 2829,
     /* 1493125 */     GIR_EraseRootFromParent_Done,
     /* 1493126 */   // Label 20766: @1493126
     /* 1493126 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1493212), // Rule ID 2832 //
     /* 1493131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1493142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1493145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1493148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1493151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493177 */     // MIs[0] policy
     /* 1493177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493187 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493211 */     // GIR_Coverage, 2832,
     /* 1493211 */     GIR_EraseRootFromParent_Done,
     /* 1493212 */   // Label 20767: @1493212
     /* 1493212 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1493298), // Rule ID 2833 //
     /* 1493217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1493228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1493231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1493234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1493237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493263 */     // MIs[0] policy
     /* 1493263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493273 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493297 */     // GIR_Coverage, 2833,
     /* 1493297 */     GIR_EraseRootFromParent_Done,
     /* 1493298 */   // Label 20768: @1493298
     /* 1493298 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1493384), // Rule ID 2836 //
     /* 1493303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1493314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1493317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1493320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1493323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493349 */     // MIs[0] policy
     /* 1493349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493359 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1493362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493383 */     // GIR_Coverage, 2836,
     /* 1493383 */     GIR_EraseRootFromParent_Done,
     /* 1493384 */   // Label 20769: @1493384
     /* 1493384 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1493470), // Rule ID 2837 //
     /* 1493389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1493400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1493403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1493406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1493409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493435 */     // MIs[0] policy
     /* 1493435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493445 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1493448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493469 */     // GIR_Coverage, 2837,
     /* 1493469 */     GIR_EraseRootFromParent_Done,
     /* 1493470 */   // Label 20770: @1493470
     /* 1493470 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1493556), // Rule ID 2840 //
     /* 1493475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1493486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1493489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1493492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1493495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493521 */     // MIs[0] policy
     /* 1493521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493531 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493555 */     // GIR_Coverage, 2840,
     /* 1493555 */     GIR_EraseRootFromParent_Done,
     /* 1493556 */   // Label 20771: @1493556
     /* 1493556 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1493642), // Rule ID 2841 //
     /* 1493561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1493572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1493575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1493578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1493581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493607 */     // MIs[0] policy
     /* 1493607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493617 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493641 */     // GIR_Coverage, 2841,
     /* 1493641 */     GIR_EraseRootFromParent_Done,
     /* 1493642 */   // Label 20772: @1493642
     /* 1493642 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1493728), // Rule ID 2844 //
     /* 1493647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1493658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1493661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1493664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1493667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493693 */     // MIs[0] policy
     /* 1493693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493727 */     // GIR_Coverage, 2844,
     /* 1493727 */     GIR_EraseRootFromParent_Done,
     /* 1493728 */   // Label 20773: @1493728
     /* 1493728 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1493814), // Rule ID 2845 //
     /* 1493733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1493744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1493747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1493750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1493753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493779 */     // MIs[0] policy
     /* 1493779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1493792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493813 */     // GIR_Coverage, 2845,
     /* 1493813 */     GIR_EraseRootFromParent_Done,
     /* 1493814 */   // Label 20774: @1493814
     /* 1493814 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1493900), // Rule ID 2848 //
     /* 1493819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1493830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1493833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1493836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1493839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493865 */     // MIs[0] policy
     /* 1493865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493875 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1493878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493899 */     // GIR_Coverage, 2848,
     /* 1493899 */     GIR_EraseRootFromParent_Done,
     /* 1493900 */   // Label 20775: @1493900
     /* 1493900 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1493986), // Rule ID 2849 //
     /* 1493905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1493916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1493919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1493922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1493925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493951 */     // MIs[0] policy
     /* 1493951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493961 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1493964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1493972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493985 */     // GIR_Coverage, 2849,
     /* 1493985 */     GIR_EraseRootFromParent_Done,
     /* 1493986 */   // Label 20776: @1493986
     /* 1493986 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1494072), // Rule ID 2852 //
     /* 1493991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1493999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1494008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1494011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494037 */     // MIs[0] policy
     /* 1494037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494047 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494071 */     // GIR_Coverage, 2852,
     /* 1494071 */     GIR_EraseRootFromParent_Done,
     /* 1494072 */   // Label 20777: @1494072
     /* 1494072 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1494158), // Rule ID 2853 //
     /* 1494077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1494094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1494097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494123 */     // MIs[0] policy
     /* 1494123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494157 */     // GIR_Coverage, 2853,
     /* 1494157 */     GIR_EraseRootFromParent_Done,
     /* 1494158 */   // Label 20778: @1494158
     /* 1494158 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1494244), // Rule ID 2856 //
     /* 1494163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1494166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1494174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1494177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1494180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1494183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494209 */     // MIs[0] policy
     /* 1494209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494243 */     // GIR_Coverage, 2856,
     /* 1494243 */     GIR_EraseRootFromParent_Done,
     /* 1494244 */   // Label 20779: @1494244
     /* 1494244 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1494330), // Rule ID 2857 //
     /* 1494249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1494260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1494263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1494266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1494269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494295 */     // MIs[0] policy
     /* 1494295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494305 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494329 */     // GIR_Coverage, 2857,
     /* 1494329 */     GIR_EraseRootFromParent_Done,
     /* 1494330 */   // Label 20780: @1494330
     /* 1494330 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1494416), // Rule ID 2860 //
     /* 1494335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1494346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1494349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1494352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1494355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494381 */     // MIs[0] policy
     /* 1494381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494415 */     // GIR_Coverage, 2860,
     /* 1494415 */     GIR_EraseRootFromParent_Done,
     /* 1494416 */   // Label 20781: @1494416
     /* 1494416 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1494502), // Rule ID 2861 //
     /* 1494421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1494432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1494435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1494438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1494441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494467 */     // MIs[0] policy
     /* 1494467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1494480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494501 */     // GIR_Coverage, 2861,
     /* 1494501 */     GIR_EraseRootFromParent_Done,
     /* 1494502 */   // Label 20782: @1494502
     /* 1494502 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1494588), // Rule ID 2864 //
     /* 1494507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1494510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1494518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1494521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1494527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494553 */     // MIs[0] policy
     /* 1494553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1494566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494587 */     // GIR_Coverage, 2864,
     /* 1494587 */     GIR_EraseRootFromParent_Done,
     /* 1494588 */   // Label 20783: @1494588
     /* 1494588 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1494674), // Rule ID 2865 //
     /* 1494593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1494604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1494607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1494613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494639 */     // MIs[0] policy
     /* 1494639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1494652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494673 */     // GIR_Coverage, 2865,
     /* 1494673 */     GIR_EraseRootFromParent_Done,
     /* 1494674 */   // Label 20784: @1494674
     /* 1494674 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1494760), // Rule ID 2868 //
     /* 1494679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1494682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1494690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1494693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1494699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494725 */     // MIs[0] policy
     /* 1494725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494735 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1494738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494759 */     // GIR_Coverage, 2868,
     /* 1494759 */     GIR_EraseRootFromParent_Done,
     /* 1494760 */   // Label 20785: @1494760
     /* 1494760 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1494846), // Rule ID 2869 //
     /* 1494765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1494776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1494779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1494785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494811 */     // MIs[0] policy
     /* 1494811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1494824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494845 */     // GIR_Coverage, 2869,
     /* 1494845 */     GIR_EraseRootFromParent_Done,
     /* 1494846 */   // Label 20786: @1494846
     /* 1494846 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1494932), // Rule ID 2872 //
     /* 1494851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1494854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1494862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1494865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1494868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1494871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1494874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494897 */     // MIs[0] policy
     /* 1494897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494907 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1494910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494931 */     // GIR_Coverage, 2872,
     /* 1494931 */     GIR_EraseRootFromParent_Done,
     /* 1494932 */   // Label 20787: @1494932
     /* 1494932 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1495018), // Rule ID 2873 //
     /* 1494937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1494945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1494948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1494951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1494954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1494957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1494960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494983 */     // MIs[0] policy
     /* 1494983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1494996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495017 */     // GIR_Coverage, 2873,
     /* 1495017 */     GIR_EraseRootFromParent_Done,
     /* 1495018 */   // Label 20788: @1495018
     /* 1495018 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1495104), // Rule ID 2876 //
     /* 1495023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1495043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495069 */     // MIs[0] policy
     /* 1495069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495079 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1495082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495103 */     // GIR_Coverage, 2876,
     /* 1495103 */     GIR_EraseRootFromParent_Done,
     /* 1495104 */   // Label 20789: @1495104
     /* 1495104 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1495190), // Rule ID 2877 //
     /* 1495109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1495129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495155 */     // MIs[0] policy
     /* 1495155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1495168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495189 */     // GIR_Coverage, 2877,
     /* 1495189 */     GIR_EraseRootFromParent_Done,
     /* 1495190 */   // Label 20790: @1495190
     /* 1495190 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1495276), // Rule ID 2880 //
     /* 1495195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1495215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495241 */     // MIs[0] policy
     /* 1495241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495251 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1495254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495275 */     // GIR_Coverage, 2880,
     /* 1495275 */     GIR_EraseRootFromParent_Done,
     /* 1495276 */   // Label 20791: @1495276
     /* 1495276 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1495362), // Rule ID 2881 //
     /* 1495281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1495301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495327 */     // MIs[0] policy
     /* 1495327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495337 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1495340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495361 */     // GIR_Coverage, 2881,
     /* 1495361 */     GIR_EraseRootFromParent_Done,
     /* 1495362 */   // Label 20792: @1495362
     /* 1495362 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1495448), // Rule ID 2884 //
     /* 1495367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1495384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1495387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495413 */     // MIs[0] policy
     /* 1495413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495423 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1495426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495447 */     // GIR_Coverage, 2884,
     /* 1495447 */     GIR_EraseRootFromParent_Done,
     /* 1495448 */   // Label 20793: @1495448
     /* 1495448 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1495534), // Rule ID 2885 //
     /* 1495453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1495470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1495473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495499 */     // MIs[0] policy
     /* 1495499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495509 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1495512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495533 */     // GIR_Coverage, 2885,
     /* 1495533 */     GIR_EraseRootFromParent_Done,
     /* 1495534 */   // Label 20794: @1495534
     /* 1495534 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1495620), // Rule ID 2888 //
     /* 1495539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1495556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1495559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495585 */     // MIs[0] policy
     /* 1495585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1495598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495619 */     // GIR_Coverage, 2888,
     /* 1495619 */     GIR_EraseRootFromParent_Done,
     /* 1495620 */   // Label 20795: @1495620
     /* 1495620 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1495706), // Rule ID 2889 //
     /* 1495625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1495642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1495645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495671 */     // MIs[0] policy
     /* 1495671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1495684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495705 */     // GIR_Coverage, 2889,
     /* 1495705 */     GIR_EraseRootFromParent_Done,
     /* 1495706 */   // Label 20796: @1495706
     /* 1495706 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1495792), // Rule ID 2892 //
     /* 1495711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1495728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1495731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495757 */     // MIs[0] policy
     /* 1495757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495767 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1495770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495791 */     // GIR_Coverage, 2892,
     /* 1495791 */     GIR_EraseRootFromParent_Done,
     /* 1495792 */   // Label 20797: @1495792
     /* 1495792 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1495878), // Rule ID 2893 //
     /* 1495797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1495814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1495817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495843 */     // MIs[0] policy
     /* 1495843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495853 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1495856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495877 */     // GIR_Coverage, 2893,
     /* 1495877 */     GIR_EraseRootFromParent_Done,
     /* 1495878 */   // Label 20798: @1495878
     /* 1495878 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1495964), // Rule ID 2896 //
     /* 1495883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1495886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1495900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1495903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495929 */     // MIs[0] policy
     /* 1495929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1495942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495963 */     // GIR_Coverage, 2896,
     /* 1495963 */     GIR_EraseRootFromParent_Done,
     /* 1495964 */   // Label 20799: @1495964
     /* 1495964 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1496050), // Rule ID 2897 //
     /* 1495969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1495972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1495977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1495986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1495989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496015 */     // MIs[0] policy
     /* 1496015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1496028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496049 */     // GIR_Coverage, 2897,
     /* 1496049 */     GIR_EraseRootFromParent_Done,
     /* 1496050 */   // Label 20800: @1496050
     /* 1496050 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1496136), // Rule ID 2900 //
     /* 1496055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1496058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1496072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1496075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496101 */     // MIs[0] policy
     /* 1496101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1496114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496135 */     // GIR_Coverage, 2900,
     /* 1496135 */     GIR_EraseRootFromParent_Done,
     /* 1496136 */   // Label 20801: @1496136
     /* 1496136 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1496222), // Rule ID 2901 //
     /* 1496141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1496144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1496158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1496161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496187 */     // MIs[0] policy
     /* 1496187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1496200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496221 */     // GIR_Coverage, 2901,
     /* 1496221 */     GIR_EraseRootFromParent_Done,
     /* 1496222 */   // Label 20802: @1496222
     /* 1496222 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1496308), // Rule ID 2904 //
     /* 1496227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1496230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1496244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1496247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496273 */     // MIs[0] policy
     /* 1496273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496283 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1496286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496307 */     // GIR_Coverage, 2904,
     /* 1496307 */     GIR_EraseRootFromParent_Done,
     /* 1496308 */   // Label 20803: @1496308
     /* 1496308 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1496394), // Rule ID 2905 //
     /* 1496313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1496316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1496330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1496333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496359 */     // MIs[0] policy
     /* 1496359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496369 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1496372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496393 */     // GIR_Coverage, 2905,
     /* 1496393 */     GIR_EraseRootFromParent_Done,
     /* 1496394 */   // Label 20804: @1496394
     /* 1496394 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1496480), // Rule ID 2908 //
     /* 1496399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1496402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1496416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1496419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496445 */     // MIs[0] policy
     /* 1496445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496455 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1496458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496479 */     // GIR_Coverage, 2908,
     /* 1496479 */     GIR_EraseRootFromParent_Done,
     /* 1496480 */   // Label 20805: @1496480
     /* 1496480 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1496566), // Rule ID 2909 //
     /* 1496485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1496488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1496502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1496505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496531 */     // MIs[0] policy
     /* 1496531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496541 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1496544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496565 */     // GIR_Coverage, 2909,
     /* 1496565 */     GIR_EraseRootFromParent_Done,
     /* 1496566 */   // Label 20806: @1496566
     /* 1496566 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1496652), // Rule ID 2912 //
     /* 1496571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1496574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1496613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496617 */     // MIs[0] policy
     /* 1496617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1496630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496651 */     // GIR_Coverage, 2912,
     /* 1496651 */     GIR_EraseRootFromParent_Done,
     /* 1496652 */   // Label 20807: @1496652
     /* 1496652 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1496738), // Rule ID 2913 //
     /* 1496657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1496660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1496699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496703 */     // MIs[0] policy
     /* 1496703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496713 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1496716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496737 */     // GIR_Coverage, 2913,
     /* 1496737 */     GIR_EraseRootFromParent_Done,
     /* 1496738 */   // Label 20808: @1496738
     /* 1496738 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1496824), // Rule ID 2916 //
     /* 1496743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1496746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1496754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1496757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1496760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1496785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496789 */     // MIs[0] policy
     /* 1496789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496799 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1496802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496823 */     // GIR_Coverage, 2916,
     /* 1496823 */     GIR_EraseRootFromParent_Done,
     /* 1496824 */   // Label 20809: @1496824
     /* 1496824 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1496910), // Rule ID 2917 //
     /* 1496829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1496832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1496840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1496843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1496846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1496871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496875 */     // MIs[0] policy
     /* 1496875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496885 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1496888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496909 */     // GIR_Coverage, 2917,
     /* 1496909 */     GIR_EraseRootFromParent_Done,
     /* 1496910 */   // Label 20810: @1496910
     /* 1496910 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1496996), // Rule ID 2920 //
     /* 1496915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1496918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1496923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1496926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1496929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1496932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1496957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496961 */     // MIs[0] policy
     /* 1496961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1496974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496995 */     // GIR_Coverage, 2920,
     /* 1496995 */     GIR_EraseRootFromParent_Done,
     /* 1496996 */   // Label 20811: @1496996
     /* 1496996 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1497082), // Rule ID 2921 //
     /* 1497001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497047 */     // MIs[0] policy
     /* 1497047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497057 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1497060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497081 */     // GIR_Coverage, 2921,
     /* 1497081 */     GIR_EraseRootFromParent_Done,
     /* 1497082 */   // Label 20812: @1497082
     /* 1497082 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1497168), // Rule ID 2924 //
     /* 1497087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497133 */     // MIs[0] policy
     /* 1497133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1497146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497167 */     // GIR_Coverage, 2924,
     /* 1497167 */     GIR_EraseRootFromParent_Done,
     /* 1497168 */   // Label 20813: @1497168
     /* 1497168 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1497254), // Rule ID 2925 //
     /* 1497173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497219 */     // MIs[0] policy
     /* 1497219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497229 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1497232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497253 */     // GIR_Coverage, 2925,
     /* 1497253 */     GIR_EraseRootFromParent_Done,
     /* 1497254 */   // Label 20814: @1497254
     /* 1497254 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1497340), // Rule ID 2928 //
     /* 1497259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497305 */     // MIs[0] policy
     /* 1497305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1497318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497339 */     // GIR_Coverage, 2928,
     /* 1497339 */     GIR_EraseRootFromParent_Done,
     /* 1497340 */   // Label 20815: @1497340
     /* 1497340 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1497426), // Rule ID 2929 //
     /* 1497345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497391 */     // MIs[0] policy
     /* 1497391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1497404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497425 */     // GIR_Coverage, 2929,
     /* 1497425 */     GIR_EraseRootFromParent_Done,
     /* 1497426 */   // Label 20816: @1497426
     /* 1497426 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1497512), // Rule ID 2932 //
     /* 1497431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497477 */     // MIs[0] policy
     /* 1497477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497487 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1497490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497511 */     // GIR_Coverage, 2932,
     /* 1497511 */     GIR_EraseRootFromParent_Done,
     /* 1497512 */   // Label 20817: @1497512
     /* 1497512 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1497598), // Rule ID 2933 //
     /* 1497517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497563 */     // MIs[0] policy
     /* 1497563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1497576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497597 */     // GIR_Coverage, 2933,
     /* 1497597 */     GIR_EraseRootFromParent_Done,
     /* 1497598 */   // Label 20818: @1497598
     /* 1497598 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1497684), // Rule ID 2936 //
     /* 1497603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1497614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1497617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1497620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497649 */     // MIs[0] policy
     /* 1497649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1497662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497683 */     // GIR_Coverage, 2936,
     /* 1497683 */     GIR_EraseRootFromParent_Done,
     /* 1497684 */   // Label 20819: @1497684
     /* 1497684 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1497770), // Rule ID 2937 //
     /* 1497689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1497700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1497703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1497706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497735 */     // MIs[0] policy
     /* 1497735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497745 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10835:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1497748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497769 */     // GIR_Coverage, 2937,
     /* 1497769 */     GIR_EraseRootFromParent_Done,
     /* 1497770 */   // Label 20820: @1497770
     /* 1497770 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1497856), // Rule ID 2940 //
     /* 1497775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1497786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1497789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1497792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497821 */     // MIs[0] policy
     /* 1497821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497831 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1497834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497855 */     // GIR_Coverage, 2940,
     /* 1497855 */     GIR_EraseRootFromParent_Done,
     /* 1497856 */   // Label 20821: @1497856
     /* 1497856 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1497942), // Rule ID 2941 //
     /* 1497861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1497864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1497872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1497875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1497878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497907 */     // MIs[0] policy
     /* 1497907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497917 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1497920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497941 */     // GIR_Coverage, 2941,
     /* 1497941 */     GIR_EraseRootFromParent_Done,
     /* 1497942 */   // Label 20822: @1497942
     /* 1497942 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1498028), // Rule ID 2944 //
     /* 1497947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1497950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1497955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1497958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1497961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1497964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1497989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497993 */     // MIs[0] policy
     /* 1497993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498003 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1498006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498027 */     // GIR_Coverage, 2944,
     /* 1498027 */     GIR_EraseRootFromParent_Done,
     /* 1498028 */   // Label 20823: @1498028
     /* 1498028 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1498114), // Rule ID 2945 //
     /* 1498033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1498036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498079 */     // MIs[0] policy
     /* 1498079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1498092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498113 */     // GIR_Coverage, 2945,
     /* 1498113 */     GIR_EraseRootFromParent_Done,
     /* 1498114 */   // Label 20824: @1498114
     /* 1498114 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1498200), // Rule ID 2948 //
     /* 1498119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1498122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498165 */     // MIs[0] policy
     /* 1498165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1498178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498199 */     // GIR_Coverage, 2948,
     /* 1498199 */     GIR_EraseRootFromParent_Done,
     /* 1498200 */   // Label 20825: @1498200
     /* 1498200 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1498286), // Rule ID 2949 //
     /* 1498205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1498208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498251 */     // MIs[0] policy
     /* 1498251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498261 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1498264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498285 */     // GIR_Coverage, 2949,
     /* 1498285 */     GIR_EraseRootFromParent_Done,
     /* 1498286 */   // Label 20826: @1498286
     /* 1498286 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1498372), // Rule ID 2952 //
     /* 1498291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1498294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498337 */     // MIs[0] policy
     /* 1498337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1498350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498371 */     // GIR_Coverage, 2952,
     /* 1498371 */     GIR_EraseRootFromParent_Done,
     /* 1498372 */   // Label 20827: @1498372
     /* 1498372 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1498458), // Rule ID 2953 //
     /* 1498377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1498380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498423 */     // MIs[0] policy
     /* 1498423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498433 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1498436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498457 */     // GIR_Coverage, 2953,
     /* 1498457 */     GIR_EraseRootFromParent_Done,
     /* 1498458 */   // Label 20828: @1498458
     /* 1498458 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1498544), // Rule ID 2956 //
     /* 1498463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1498466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1498474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1498477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498509 */     // MIs[0] policy
     /* 1498509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498519 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1498522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498543 */     // GIR_Coverage, 2956,
     /* 1498543 */     GIR_EraseRootFromParent_Done,
     /* 1498544 */   // Label 20829: @1498544
     /* 1498544 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1498630), // Rule ID 2957 //
     /* 1498549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1498552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1498560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1498563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498595 */     // MIs[0] policy
     /* 1498595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498605 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1498608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498629 */     // GIR_Coverage, 2957,
     /* 1498629 */     GIR_EraseRootFromParent_Done,
     /* 1498630 */   // Label 20830: @1498630
     /* 1498630 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1498716), // Rule ID 2960 //
     /* 1498635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1498638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1498646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1498649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1498652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1498658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498681 */     // MIs[0] policy
     /* 1498681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498691 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1498694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498715 */     // GIR_Coverage, 2960,
     /* 1498715 */     GIR_EraseRootFromParent_Done,
     /* 1498716 */   // Label 20831: @1498716
     /* 1498716 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1498802), // Rule ID 2961 //
     /* 1498721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1498724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1498732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1498735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1498738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1498744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498767 */     // MIs[0] policy
     /* 1498767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498777 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1498780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498801 */     // GIR_Coverage, 2961,
     /* 1498801 */     GIR_EraseRootFromParent_Done,
     /* 1498802 */   // Label 20832: @1498802
     /* 1498802 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1498888), // Rule ID 2964 //
     /* 1498807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1498810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1498824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498853 */     // MIs[0] policy
     /* 1498853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1498866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498887 */     // GIR_Coverage, 2964,
     /* 1498887 */     GIR_EraseRootFromParent_Done,
     /* 1498888 */   // Label 20833: @1498888
     /* 1498888 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1498974), // Rule ID 2965 //
     /* 1498893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1498896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1498910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1498935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498939 */     // MIs[0] policy
     /* 1498939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1498952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498973 */     // GIR_Coverage, 2965,
     /* 1498973 */     GIR_EraseRootFromParent_Done,
     /* 1498974 */   // Label 20834: @1498974
     /* 1498974 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1499060), // Rule ID 2968 //
     /* 1498979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1498982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1498987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1498990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1498993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1498996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499025 */     // MIs[0] policy
     /* 1499025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499035 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1499038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499059 */     // GIR_Coverage, 2968,
     /* 1499059 */     GIR_EraseRootFromParent_Done,
     /* 1499060 */   // Label 20835: @1499060
     /* 1499060 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1499146), // Rule ID 2969 //
     /* 1499065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1499068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499111 */     // MIs[0] policy
     /* 1499111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499121 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1499124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499145 */     // GIR_Coverage, 2969,
     /* 1499145 */     GIR_EraseRootFromParent_Done,
     /* 1499146 */   // Label 20836: @1499146
     /* 1499146 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1499232), // Rule ID 2972 //
     /* 1499151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1499154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499197 */     // MIs[0] policy
     /* 1499197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499207 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1499210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499231 */     // GIR_Coverage, 2972,
     /* 1499231 */     GIR_EraseRootFromParent_Done,
     /* 1499232 */   // Label 20837: @1499232
     /* 1499232 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1499318), // Rule ID 2973 //
     /* 1499237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1499240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499283 */     // MIs[0] policy
     /* 1499283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499293 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1499296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499317 */     // GIR_Coverage, 2973,
     /* 1499317 */     GIR_EraseRootFromParent_Done,
     /* 1499318 */   // Label 20838: @1499318
     /* 1499318 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1499404), // Rule ID 2976 //
     /* 1499323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1499326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1499340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499369 */     // MIs[0] policy
     /* 1499369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1499382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499403 */     // GIR_Coverage, 2976,
     /* 1499403 */     GIR_EraseRootFromParent_Done,
     /* 1499404 */   // Label 20839: @1499404
     /* 1499404 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1499490), // Rule ID 2977 //
     /* 1499409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1499412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1499426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499455 */     // MIs[0] policy
     /* 1499455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1499468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499489 */     // GIR_Coverage, 2977,
     /* 1499489 */     GIR_EraseRootFromParent_Done,
     /* 1499490 */   // Label 20840: @1499490
     /* 1499490 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1499576), // Rule ID 2980 //
     /* 1499495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1499498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1499506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1499509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1499512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499541 */     // MIs[0] policy
     /* 1499541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1499554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499575 */     // GIR_Coverage, 2980,
     /* 1499575 */     GIR_EraseRootFromParent_Done,
     /* 1499576 */   // Label 20841: @1499576
     /* 1499576 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1499662), // Rule ID 2981 //
     /* 1499581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1499584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1499592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1499595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1499598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499627 */     // MIs[0] policy
     /* 1499627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1499640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499661 */     // GIR_Coverage, 2981,
     /* 1499661 */     GIR_EraseRootFromParent_Done,
     /* 1499662 */   // Label 20842: @1499662
     /* 1499662 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1499748), // Rule ID 2984 //
     /* 1499667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1499670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1499684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499713 */     // MIs[0] policy
     /* 1499713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1499726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499747 */     // GIR_Coverage, 2984,
     /* 1499747 */     GIR_EraseRootFromParent_Done,
     /* 1499748 */   // Label 20843: @1499748
     /* 1499748 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1499834), // Rule ID 2985 //
     /* 1499753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1499756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1499770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499799 */     // MIs[0] policy
     /* 1499799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1499812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499833 */     // GIR_Coverage, 2985,
     /* 1499833 */     GIR_EraseRootFromParent_Done,
     /* 1499834 */   // Label 20844: @1499834
     /* 1499834 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1499920), // Rule ID 2988 //
     /* 1499839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1499842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1499850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1499853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1499856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1499862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499885 */     // MIs[0] policy
     /* 1499885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1499898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499919 */     // GIR_Coverage, 2988,
     /* 1499919 */     GIR_EraseRootFromParent_Done,
     /* 1499920 */   // Label 20845: @1499920
     /* 1499920 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1500006), // Rule ID 2989 //
     /* 1499925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1499928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1499933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1499936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1499939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1499942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1499948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1499967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499971 */     // MIs[0] policy
     /* 1499971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1499984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500005 */     // GIR_Coverage, 2989,
     /* 1500005 */     GIR_EraseRootFromParent_Done,
     /* 1500006 */   // Label 20846: @1500006
     /* 1500006 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1500092), // Rule ID 2992 //
     /* 1500011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1500014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1500019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1500053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500057 */     // MIs[0] policy
     /* 1500057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500067 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1500070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500091 */     // GIR_Coverage, 2992,
     /* 1500091 */     GIR_EraseRootFromParent_Done,
     /* 1500092 */   // Label 20847: @1500092
     /* 1500092 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1500178), // Rule ID 2993 //
     /* 1500097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1500100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1500105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1500139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500143 */     // MIs[0] policy
     /* 1500143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1500156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500177 */     // GIR_Coverage, 2993,
     /* 1500177 */     GIR_EraseRootFromParent_Done,
     /* 1500178 */   // Label 20848: @1500178
     /* 1500178 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1500264), // Rule ID 2996 //
     /* 1500183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1500186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1500191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1500225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500229 */     // MIs[0] policy
     /* 1500229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500239 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1500242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500263 */     // GIR_Coverage, 2996,
     /* 1500263 */     GIR_EraseRootFromParent_Done,
     /* 1500264 */   // Label 20849: @1500264
     /* 1500264 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1500350), // Rule ID 2997 //
     /* 1500269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1500272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1500277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1500311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500315 */     // MIs[0] policy
     /* 1500315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500325 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10835:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1500328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500349 */     // GIR_Coverage, 2997,
     /* 1500349 */     GIR_EraseRootFromParent_Done,
     /* 1500350 */   // Label 20850: @1500350
     /* 1500350 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1500436), // Rule ID 3088 //
     /* 1500355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1500358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1500366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1500369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1500372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1500375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500401 */     // MIs[0] policy
     /* 1500401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500411 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1500414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500435 */     // GIR_Coverage, 3088,
     /* 1500435 */     GIR_EraseRootFromParent_Done,
     /* 1500436 */   // Label 20851: @1500436
     /* 1500436 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1500522), // Rule ID 3089 //
     /* 1500441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1500444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1500452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1500455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1500458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1500461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500487 */     // MIs[0] policy
     /* 1500487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500497 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1500500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500521 */     // GIR_Coverage, 3089,
     /* 1500521 */     GIR_EraseRootFromParent_Done,
     /* 1500522 */   // Label 20852: @1500522
     /* 1500522 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1500608), // Rule ID 3092 //
     /* 1500527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1500530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1500538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1500541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1500544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1500547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500573 */     // MIs[0] policy
     /* 1500573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500583 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1500586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500607 */     // GIR_Coverage, 3092,
     /* 1500607 */     GIR_EraseRootFromParent_Done,
     /* 1500608 */   // Label 20853: @1500608
     /* 1500608 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1500694), // Rule ID 3093 //
     /* 1500613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1500616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1500624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1500627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1500630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1500633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500659 */     // MIs[0] policy
     /* 1500659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1500672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500693 */     // GIR_Coverage, 3093,
     /* 1500693 */     GIR_EraseRootFromParent_Done,
     /* 1500694 */   // Label 20854: @1500694
     /* 1500694 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1500780), // Rule ID 3096 //
     /* 1500699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1500702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1500710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1500713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1500716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1500719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500745 */     // MIs[0] policy
     /* 1500745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500755 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1500758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500779 */     // GIR_Coverage, 3096,
     /* 1500779 */     GIR_EraseRootFromParent_Done,
     /* 1500780 */   // Label 20855: @1500780
     /* 1500780 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1500866), // Rule ID 3097 //
     /* 1500785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1500788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1500796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1500799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1500802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1500805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500831 */     // MIs[0] policy
     /* 1500831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500841 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1500844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500865 */     // GIR_Coverage, 3097,
     /* 1500865 */     GIR_EraseRootFromParent_Done,
     /* 1500866 */   // Label 20856: @1500866
     /* 1500866 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1500952), // Rule ID 3100 //
     /* 1500871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1500874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1500882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1500885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1500888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1500891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500917 */     // MIs[0] policy
     /* 1500917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500927 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1500930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500951 */     // GIR_Coverage, 3100,
     /* 1500951 */     GIR_EraseRootFromParent_Done,
     /* 1500952 */   // Label 20857: @1500952
     /* 1500952 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1501038), // Rule ID 3101 //
     /* 1500957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1500960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1500965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1500968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1500971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1500974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1500977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501003 */     // MIs[0] policy
     /* 1501003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501013 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1501016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501037 */     // GIR_Coverage, 3101,
     /* 1501037 */     GIR_EraseRootFromParent_Done,
     /* 1501038 */   // Label 20858: @1501038
     /* 1501038 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1501124), // Rule ID 3104 //
     /* 1501043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1501046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501089 */     // MIs[0] policy
     /* 1501089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501099 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1501102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501123 */     // GIR_Coverage, 3104,
     /* 1501123 */     GIR_EraseRootFromParent_Done,
     /* 1501124 */   // Label 20859: @1501124
     /* 1501124 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1501210), // Rule ID 3105 //
     /* 1501129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1501132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501175 */     // MIs[0] policy
     /* 1501175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501185 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1501188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501209 */     // GIR_Coverage, 3105,
     /* 1501209 */     GIR_EraseRootFromParent_Done,
     /* 1501210 */   // Label 20860: @1501210
     /* 1501210 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1501296), // Rule ID 3108 //
     /* 1501215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1501218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501261 */     // MIs[0] policy
     /* 1501261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1501274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501295 */     // GIR_Coverage, 3108,
     /* 1501295 */     GIR_EraseRootFromParent_Done,
     /* 1501296 */   // Label 20861: @1501296
     /* 1501296 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1501382), // Rule ID 3109 //
     /* 1501301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1501304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501347 */     // MIs[0] policy
     /* 1501347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501357 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1501360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501381 */     // GIR_Coverage, 3109,
     /* 1501381 */     GIR_EraseRootFromParent_Done,
     /* 1501382 */   // Label 20862: @1501382
     /* 1501382 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1501468), // Rule ID 3112 //
     /* 1501387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1501390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1501398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1501401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1501404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1501407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501433 */     // MIs[0] policy
     /* 1501433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501443 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501467 */     // GIR_Coverage, 3112,
     /* 1501467 */     GIR_EraseRootFromParent_Done,
     /* 1501468 */   // Label 20863: @1501468
     /* 1501468 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1501554), // Rule ID 3113 //
     /* 1501473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1501476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1501484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1501487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1501490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1501493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501519 */     // MIs[0] policy
     /* 1501519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501529 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501553 */     // GIR_Coverage, 3113,
     /* 1501553 */     GIR_EraseRootFromParent_Done,
     /* 1501554 */   // Label 20864: @1501554
     /* 1501554 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1501640), // Rule ID 3116 //
     /* 1501559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1501562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501605 */     // MIs[0] policy
     /* 1501605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501639 */     // GIR_Coverage, 3116,
     /* 1501639 */     GIR_EraseRootFromParent_Done,
     /* 1501640 */   // Label 20865: @1501640
     /* 1501640 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1501726), // Rule ID 3117 //
     /* 1501645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1501648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501691 */     // MIs[0] policy
     /* 1501691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501701 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501725 */     // GIR_Coverage, 3117,
     /* 1501725 */     GIR_EraseRootFromParent_Done,
     /* 1501726 */   // Label 20866: @1501726
     /* 1501726 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1501812), // Rule ID 3120 //
     /* 1501731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1501734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1501742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1501745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1501748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1501751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501777 */     // MIs[0] policy
     /* 1501777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501811 */     // GIR_Coverage, 3120,
     /* 1501811 */     GIR_EraseRootFromParent_Done,
     /* 1501812 */   // Label 20867: @1501812
     /* 1501812 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1501898), // Rule ID 3121 //
     /* 1501817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1501820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1501828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1501831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1501834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1501837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501863 */     // MIs[0] policy
     /* 1501863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501897 */     // GIR_Coverage, 3121,
     /* 1501897 */     GIR_EraseRootFromParent_Done,
     /* 1501898 */   // Label 20868: @1501898
     /* 1501898 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1501984), // Rule ID 3124 //
     /* 1501903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1501906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1501914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1501917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1501920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1501923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501949 */     // MIs[0] policy
     /* 1501949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501959 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1501962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501983 */     // GIR_Coverage, 3124,
     /* 1501983 */     GIR_EraseRootFromParent_Done,
     /* 1501984 */   // Label 20869: @1501984
     /* 1501984 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1502070), // Rule ID 3125 //
     /* 1501989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1501992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1501997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1502012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502035 */     // MIs[0] policy
     /* 1502035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502045 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1502048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502069 */     // GIR_Coverage, 3125,
     /* 1502069 */     GIR_EraseRootFromParent_Done,
     /* 1502070 */   // Label 20870: @1502070
     /* 1502070 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1502156), // Rule ID 3128 //
     /* 1502075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1502086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1502089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1502092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1502095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502121 */     // MIs[0] policy
     /* 1502121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1502134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502155 */     // GIR_Coverage, 3128,
     /* 1502155 */     GIR_EraseRootFromParent_Done,
     /* 1502156 */   // Label 20871: @1502156
     /* 1502156 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1502242), // Rule ID 3129 //
     /* 1502161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1502164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1502172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1502175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1502178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1502181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502207 */     // MIs[0] policy
     /* 1502207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502217 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1502220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502241 */     // GIR_Coverage, 3129,
     /* 1502241 */     GIR_EraseRootFromParent_Done,
     /* 1502242 */   // Label 20872: @1502242
     /* 1502242 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1502328), // Rule ID 3132 //
     /* 1502247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1502258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1502261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1502264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1502267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1502270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502293 */     // MIs[0] policy
     /* 1502293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502303 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1502306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502327 */     // GIR_Coverage, 3132,
     /* 1502327 */     GIR_EraseRootFromParent_Done,
     /* 1502328 */   // Label 20873: @1502328
     /* 1502328 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1502414), // Rule ID 3133 //
     /* 1502333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1502336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1502344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1502347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1502350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1502353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1502356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502379 */     // MIs[0] policy
     /* 1502379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502389 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1502392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502413 */     // GIR_Coverage, 3133,
     /* 1502413 */     GIR_EraseRootFromParent_Done,
     /* 1502414 */   // Label 20874: @1502414
     /* 1502414 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1502500), // Rule ID 3136 //
     /* 1502419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1502430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1502433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1502436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1502439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1502442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1502449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502465 */     // MIs[0] policy
     /* 1502465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502475 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1502478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502499 */     // GIR_Coverage, 3136,
     /* 1502499 */     GIR_EraseRootFromParent_Done,
     /* 1502500 */   // Label 20875: @1502500
     /* 1502500 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1502586), // Rule ID 3137 //
     /* 1502505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1502508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1502516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1502519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1502522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1502525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1502528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1502535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502551 */     // MIs[0] policy
     /* 1502551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502561 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1502564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502585 */     // GIR_Coverage, 3137,
     /* 1502585 */     GIR_EraseRootFromParent_Done,
     /* 1502586 */   // Label 20876: @1502586
     /* 1502586 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1502672), // Rule ID 3140 //
     /* 1502591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1502614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502637 */     // MIs[0] policy
     /* 1502637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1502650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502671 */     // GIR_Coverage, 3140,
     /* 1502671 */     GIR_EraseRootFromParent_Done,
     /* 1502672 */   // Label 20877: @1502672
     /* 1502672 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1502758), // Rule ID 3141 //
     /* 1502677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1502680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1502700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502723 */     // MIs[0] policy
     /* 1502723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1502736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502757 */     // GIR_Coverage, 3141,
     /* 1502757 */     GIR_EraseRootFromParent_Done,
     /* 1502758 */   // Label 20878: @1502758
     /* 1502758 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1502844), // Rule ID 3144 //
     /* 1502763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502809 */     // MIs[0] policy
     /* 1502809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502819 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1502822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502843 */     // GIR_Coverage, 3144,
     /* 1502843 */     GIR_EraseRootFromParent_Done,
     /* 1502844 */   // Label 20879: @1502844
     /* 1502844 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1502930), // Rule ID 3145 //
     /* 1502849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1502852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502895 */     // MIs[0] policy
     /* 1502895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502905 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1502908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502929 */     // GIR_Coverage, 3145,
     /* 1502929 */     GIR_EraseRootFromParent_Done,
     /* 1502930 */   // Label 20880: @1502930
     /* 1502930 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1503016), // Rule ID 3148 //
     /* 1502935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1502938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1502943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1502952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1502958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1502965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502981 */     // MIs[0] policy
     /* 1502981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1502994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503015 */     // GIR_Coverage, 3148,
     /* 1503015 */     GIR_EraseRootFromParent_Done,
     /* 1503016 */   // Label 20881: @1503016
     /* 1503016 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1503102), // Rule ID 3149 //
     /* 1503021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1503024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1503044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503067 */     // MIs[0] policy
     /* 1503067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1503080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503101 */     // GIR_Coverage, 3149,
     /* 1503101 */     GIR_EraseRootFromParent_Done,
     /* 1503102 */   // Label 20882: @1503102
     /* 1503102 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1503188), // Rule ID 3152 //
     /* 1503107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1503110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503153 */     // MIs[0] policy
     /* 1503153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1503166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503187 */     // GIR_Coverage, 3152,
     /* 1503187 */     GIR_EraseRootFromParent_Done,
     /* 1503188 */   // Label 20883: @1503188
     /* 1503188 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1503274), // Rule ID 3153 //
     /* 1503193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1503196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503239 */     // MIs[0] policy
     /* 1503239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1503252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503273 */     // GIR_Coverage, 3153,
     /* 1503273 */     GIR_EraseRootFromParent_Done,
     /* 1503274 */   // Label 20884: @1503274
     /* 1503274 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1503360), // Rule ID 3156 //
     /* 1503279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1503282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503325 */     // MIs[0] policy
     /* 1503325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503335 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1503338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503359 */     // GIR_Coverage, 3156,
     /* 1503359 */     GIR_EraseRootFromParent_Done,
     /* 1503360 */   // Label 20885: @1503360
     /* 1503360 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1503446), // Rule ID 3157 //
     /* 1503365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1503368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503411 */     // MIs[0] policy
     /* 1503411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1503424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503445 */     // GIR_Coverage, 3157,
     /* 1503445 */     GIR_EraseRootFromParent_Done,
     /* 1503446 */   // Label 20886: @1503446
     /* 1503446 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1503532), // Rule ID 3160 //
     /* 1503451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1503454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1503474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503497 */     // MIs[0] policy
     /* 1503497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1503510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503531 */     // GIR_Coverage, 3160,
     /* 1503531 */     GIR_EraseRootFromParent_Done,
     /* 1503532 */   // Label 20887: @1503532
     /* 1503532 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1503618), // Rule ID 3161 //
     /* 1503537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1503540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1503560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503583 */     // MIs[0] policy
     /* 1503583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1503596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503617 */     // GIR_Coverage, 3161,
     /* 1503617 */     GIR_EraseRootFromParent_Done,
     /* 1503618 */   // Label 20888: @1503618
     /* 1503618 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1503704), // Rule ID 3164 //
     /* 1503623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1503626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1503646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503669 */     // MIs[0] policy
     /* 1503669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1503682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503703 */     // GIR_Coverage, 3164,
     /* 1503703 */     GIR_EraseRootFromParent_Done,
     /* 1503704 */   // Label 20889: @1503704
     /* 1503704 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1503790), // Rule ID 3165 //
     /* 1503709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1503712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1503732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503755 */     // MIs[0] policy
     /* 1503755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1503768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503789 */     // GIR_Coverage, 3165,
     /* 1503789 */     GIR_EraseRootFromParent_Done,
     /* 1503790 */   // Label 20890: @1503790
     /* 1503790 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1503876), // Rule ID 3168 //
     /* 1503795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1503798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503841 */     // MIs[0] policy
     /* 1503841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1503854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503875 */     // GIR_Coverage, 3168,
     /* 1503875 */     GIR_EraseRootFromParent_Done,
     /* 1503876 */   // Label 20891: @1503876
     /* 1503876 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1503962), // Rule ID 3169 //
     /* 1503881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1503884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503927 */     // MIs[0] policy
     /* 1503927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503937 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1503940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503961 */     // GIR_Coverage, 3169,
     /* 1503961 */     GIR_EraseRootFromParent_Done,
     /* 1503962 */   // Label 20892: @1503962
     /* 1503962 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1504048), // Rule ID 3172 //
     /* 1503967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1503970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1503975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1503984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504013 */     // MIs[0] policy
     /* 1504013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504023 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1504026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504047 */     // GIR_Coverage, 3172,
     /* 1504047 */     GIR_EraseRootFromParent_Done,
     /* 1504048 */   // Label 20893: @1504048
     /* 1504048 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1504134), // Rule ID 3173 //
     /* 1504053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1504056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1504076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1504083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504099 */     // MIs[0] policy
     /* 1504099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1504112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504133 */     // GIR_Coverage, 3173,
     /* 1504133 */     GIR_EraseRootFromParent_Done,
     /* 1504134 */   // Label 20894: @1504134
     /* 1504134 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1504220), // Rule ID 3176 //
     /* 1504139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1504142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1504150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1504153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1504156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1504162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504185 */     // MIs[0] policy
     /* 1504185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504195 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1504198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504219 */     // GIR_Coverage, 3176,
     /* 1504219 */     GIR_EraseRootFromParent_Done,
     /* 1504220 */   // Label 20895: @1504220
     /* 1504220 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1504306), // Rule ID 3177 //
     /* 1504225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1504228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1504236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1504239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1504242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1504248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504271 */     // MIs[0] policy
     /* 1504271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504281 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1504284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504305 */     // GIR_Coverage, 3177,
     /* 1504305 */     GIR_EraseRootFromParent_Done,
     /* 1504306 */   // Label 20896: @1504306
     /* 1504306 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1504392), // Rule ID 3180 //
     /* 1504311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1504314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1504322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1504325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1504328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504357 */     // MIs[0] policy
     /* 1504357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504367 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1504370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504391 */     // GIR_Coverage, 3180,
     /* 1504391 */     GIR_EraseRootFromParent_Done,
     /* 1504392 */   // Label 20897: @1504392
     /* 1504392 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1504478), // Rule ID 3181 //
     /* 1504397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1504400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1504408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1504411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1504414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504443 */     // MIs[0] policy
     /* 1504443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504453 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1504456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504477 */     // GIR_Coverage, 3181,
     /* 1504477 */     GIR_EraseRootFromParent_Done,
     /* 1504478 */   // Label 20898: @1504478
     /* 1504478 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1504564), // Rule ID 3184 //
     /* 1504483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1504486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1504494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1504497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1504500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1504506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504529 */     // MIs[0] policy
     /* 1504529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1504542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504563 */     // GIR_Coverage, 3184,
     /* 1504563 */     GIR_EraseRootFromParent_Done,
     /* 1504564 */   // Label 20899: @1504564
     /* 1504564 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1504650), // Rule ID 3185 //
     /* 1504569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1504572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1504580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1504583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1504586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1504592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504615 */     // MIs[0] policy
     /* 1504615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504625 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1504628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1504646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504649 */     // GIR_Coverage, 3185,
     /* 1504649 */     GIR_EraseRootFromParent_Done,
     /* 1504650 */   // Label 20900: @1504650
     /* 1504650 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1504736), // Rule ID 3188 //
     /* 1504655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1504658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1504678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504701 */     // MIs[0] policy
     /* 1504701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504711 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1504714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504735 */     // GIR_Coverage, 3188,
     /* 1504735 */     GIR_EraseRootFromParent_Done,
     /* 1504736 */   // Label 20901: @1504736
     /* 1504736 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1504822), // Rule ID 3189 //
     /* 1504741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1504744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1504764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504787 */     // MIs[0] policy
     /* 1504787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504797 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1504800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504821 */     // GIR_Coverage, 3189,
     /* 1504821 */     GIR_EraseRootFromParent_Done,
     /* 1504822 */   // Label 20902: @1504822
     /* 1504822 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1504908), // Rule ID 3192 //
     /* 1504827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1504830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504873 */     // MIs[0] policy
     /* 1504873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1504886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504907 */     // GIR_Coverage, 3192,
     /* 1504907 */     GIR_EraseRootFromParent_Done,
     /* 1504908 */   // Label 20903: @1504908
     /* 1504908 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1504994), // Rule ID 3193 //
     /* 1504913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1504916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1504921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1504955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504959 */     // MIs[0] policy
     /* 1504959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504969 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1504972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504993 */     // GIR_Coverage, 3193,
     /* 1504993 */     GIR_EraseRootFromParent_Done,
     /* 1504994 */   // Label 20904: @1504994
     /* 1504994 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1505080), // Rule ID 3196 //
     /* 1504999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1505002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1505010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1505013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1505016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1505022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505045 */     // MIs[0] policy
     /* 1505045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505055 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1505058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505079 */     // GIR_Coverage, 3196,
     /* 1505079 */     GIR_EraseRootFromParent_Done,
     /* 1505080 */   // Label 20905: @1505080
     /* 1505080 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1505166), // Rule ID 3197 //
     /* 1505085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1505088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1505096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1505099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1505102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1505108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505131 */     // MIs[0] policy
     /* 1505131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1505144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505165 */     // GIR_Coverage, 3197,
     /* 1505165 */     GIR_EraseRootFromParent_Done,
     /* 1505166 */   // Label 20906: @1505166
     /* 1505166 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1505252), // Rule ID 3200 //
     /* 1505171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1505174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1505182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1505185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1505188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1505194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505217 */     // MIs[0] policy
     /* 1505217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1505248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505251 */     // GIR_Coverage, 3200,
     /* 1505251 */     GIR_EraseRootFromParent_Done,
     /* 1505252 */   // Label 20907: @1505252
     /* 1505252 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1505338), // Rule ID 3201 //
     /* 1505257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1505260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1505268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1505271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1505274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1505280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505303 */     // MIs[0] policy
     /* 1505303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505313 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11313:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1505334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505337 */     // GIR_Coverage, 3201,
     /* 1505337 */     GIR_EraseRootFromParent_Done,
     /* 1505338 */   // Label 20908: @1505338
     /* 1505338 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1505424), // Rule ID 3204 //
     /* 1505343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1505346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1505366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505389 */     // MIs[0] policy
     /* 1505389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505423 */     // GIR_Coverage, 3204,
     /* 1505423 */     GIR_EraseRootFromParent_Done,
     /* 1505424 */   // Label 20909: @1505424
     /* 1505424 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1505510), // Rule ID 3205 //
     /* 1505429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1505432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1505452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505475 */     // MIs[0] policy
     /* 1505475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505485 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505509 */     // GIR_Coverage, 3205,
     /* 1505509 */     GIR_EraseRootFromParent_Done,
     /* 1505510 */   // Label 20910: @1505510
     /* 1505510 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1505596), // Rule ID 3208 //
     /* 1505515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1505518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1505538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505561 */     // MIs[0] policy
     /* 1505561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505595 */     // GIR_Coverage, 3208,
     /* 1505595 */     GIR_EraseRootFromParent_Done,
     /* 1505596 */   // Label 20911: @1505596
     /* 1505596 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1505682), // Rule ID 3209 //
     /* 1505601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1505604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1505624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505647 */     // MIs[0] policy
     /* 1505647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505657 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505681 */     // GIR_Coverage, 3209,
     /* 1505681 */     GIR_EraseRootFromParent_Done,
     /* 1505682 */   // Label 20912: @1505682
     /* 1505682 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1505768), // Rule ID 3212 //
     /* 1505687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1505690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1505704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1505710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505733 */     // MIs[0] policy
     /* 1505733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505767 */     // GIR_Coverage, 3212,
     /* 1505767 */     GIR_EraseRootFromParent_Done,
     /* 1505768 */   // Label 20913: @1505768
     /* 1505768 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1505854), // Rule ID 3213 //
     /* 1505773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1505776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1505790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1505796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505819 */     // MIs[0] policy
     /* 1505819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505829 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1505832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505853 */     // GIR_Coverage, 3213,
     /* 1505853 */     GIR_EraseRootFromParent_Done,
     /* 1505854 */   // Label 20914: @1505854
     /* 1505854 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1505940), // Rule ID 3216 //
     /* 1505859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1505862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1505870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1505873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1505876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1505879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1505882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1505889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505905 */     // MIs[0] policy
     /* 1505905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505915 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1505918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1505928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1505936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505939 */     // GIR_Coverage, 3216,
     /* 1505939 */     GIR_EraseRootFromParent_Done,
     /* 1505940 */   // Label 20915: @1505940
     /* 1505940 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1506026), // Rule ID 3217 //
     /* 1505945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1505948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1505953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1505956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1505959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1505962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1505965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1505968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1505975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1505987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505991 */     // MIs[0] policy
     /* 1505991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1506004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1506022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506025 */     // GIR_Coverage, 3217,
     /* 1506025 */     GIR_EraseRootFromParent_Done,
     /* 1506026 */   // Label 20916: @1506026
     /* 1506026 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1506112), // Rule ID 3220 //
     /* 1506031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1506042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1506045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1506048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1506054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1506061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506077 */     // MIs[0] policy
     /* 1506077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506087 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1506090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1506108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506111 */     // GIR_Coverage, 3220,
     /* 1506111 */     GIR_EraseRootFromParent_Done,
     /* 1506112 */   // Label 20917: @1506112
     /* 1506112 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1506198), // Rule ID 3221 //
     /* 1506117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1506128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1506131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1506134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1506140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1506147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506163 */     // MIs[0] policy
     /* 1506163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506173 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1506176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1506194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506197 */     // GIR_Coverage, 3221,
     /* 1506197 */     GIR_EraseRootFromParent_Done,
     /* 1506198 */   // Label 20918: @1506198
     /* 1506198 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1506284), // Rule ID 3224 //
     /* 1506203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1506214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1506217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1506220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1506226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1506233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506249 */     // MIs[0] policy
     /* 1506249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1506262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1506280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506283 */     // GIR_Coverage, 3224,
     /* 1506283 */     GIR_EraseRootFromParent_Done,
     /* 1506284 */   // Label 20919: @1506284
     /* 1506284 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1506370), // Rule ID 3225 //
     /* 1506289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1506300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1506303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1506306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1506312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1506319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506335 */     // MIs[0] policy
     /* 1506335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506345 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1506348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1506366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506369 */     // GIR_Coverage, 3225,
     /* 1506369 */     GIR_EraseRootFromParent_Done,
     /* 1506370 */   // Label 20920: @1506370
     /* 1506370 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1506456), // Rule ID 3228 //
     /* 1506375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1506386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1506389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1506392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1506398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1506405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506421 */     // MIs[0] policy
     /* 1506421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506431 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1506434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506455 */     // GIR_Coverage, 3228,
     /* 1506455 */     GIR_EraseRootFromParent_Done,
     /* 1506456 */   // Label 20921: @1506456
     /* 1506456 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1506542), // Rule ID 3229 //
     /* 1506461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1506472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1506475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1506478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1506484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1506491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506507 */     // MIs[0] policy
     /* 1506507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1506520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506541 */     // GIR_Coverage, 3229,
     /* 1506541 */     GIR_EraseRootFromParent_Done,
     /* 1506542 */   // Label 20922: @1506542
     /* 1506542 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1506628), // Rule ID 3232 //
     /* 1506547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1506558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1506561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1506564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1506570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1506577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506593 */     // MIs[0] policy
     /* 1506593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506603 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1506606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506627 */     // GIR_Coverage, 3232,
     /* 1506627 */     GIR_EraseRootFromParent_Done,
     /* 1506628 */   // Label 20923: @1506628
     /* 1506628 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1506714), // Rule ID 3233 //
     /* 1506633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1506644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1506647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1506650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1506656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1506663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506679 */     // MIs[0] policy
     /* 1506679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506689 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1506692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506713 */     // GIR_Coverage, 3233,
     /* 1506713 */     GIR_EraseRootFromParent_Done,
     /* 1506714 */   // Label 20924: @1506714
     /* 1506714 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1506800), // Rule ID 3236 //
     /* 1506719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1506730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1506733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1506736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1506742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1506749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506765 */     // MIs[0] policy
     /* 1506765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506775 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1506778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506799 */     // GIR_Coverage, 3236,
     /* 1506799 */     GIR_EraseRootFromParent_Done,
     /* 1506800 */   // Label 20925: @1506800
     /* 1506800 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1506886), // Rule ID 3237 //
     /* 1506805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1506816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1506819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1506822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1506828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1506835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506851 */     // MIs[0] policy
     /* 1506851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1506864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506885 */     // GIR_Coverage, 3237,
     /* 1506885 */     GIR_EraseRootFromParent_Done,
     /* 1506886 */   // Label 20926: @1506886
     /* 1506886 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1506972), // Rule ID 3240 //
     /* 1506891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1506894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1506911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1506914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1506921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1506933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1506937 */     // MIs[0] policy
     /* 1506937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1506950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1506954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1506960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506971 */     // GIR_Coverage, 3240,
     /* 1506971 */     GIR_EraseRootFromParent_Done,
     /* 1506972 */   // Label 20927: @1506972
     /* 1506972 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1507058), // Rule ID 3241 //
     /* 1506977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1506980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1506985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1506997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1507000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1507007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507023 */     // MIs[0] policy
     /* 1507023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1507036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507057 */     // GIR_Coverage, 3241,
     /* 1507057 */     GIR_EraseRootFromParent_Done,
     /* 1507058 */   // Label 20928: @1507058
     /* 1507058 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1507144), // Rule ID 3244 //
     /* 1507063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1507066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1507074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1507077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1507080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1507086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1507093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507109 */     // MIs[0] policy
     /* 1507109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1507122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507143 */     // GIR_Coverage, 3244,
     /* 1507143 */     GIR_EraseRootFromParent_Done,
     /* 1507144 */   // Label 20929: @1507144
     /* 1507144 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1507230), // Rule ID 3245 //
     /* 1507149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1507152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1507160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1507163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1507166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1507169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1507172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1507179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507195 */     // MIs[0] policy
     /* 1507195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507205 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1507208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507229 */     // GIR_Coverage, 3245,
     /* 1507229 */     GIR_EraseRootFromParent_Done,
     /* 1507230 */   // Label 20930: @1507230
     /* 1507230 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1507316), // Rule ID 3248 //
     /* 1507235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1507238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1507246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1507249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1507252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1507258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1507265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507281 */     // MIs[0] policy
     /* 1507281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507291 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1507294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507315 */     // GIR_Coverage, 3248,
     /* 1507315 */     GIR_EraseRootFromParent_Done,
     /* 1507316 */   // Label 20931: @1507316
     /* 1507316 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1507402), // Rule ID 3249 //
     /* 1507321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1507324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1507332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1507335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1507338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1507341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1507344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1507351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507367 */     // MIs[0] policy
     /* 1507367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1507380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507401 */     // GIR_Coverage, 3249,
     /* 1507401 */     GIR_EraseRootFromParent_Done,
     /* 1507402 */   // Label 20932: @1507402
     /* 1507402 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1507488), // Rule ID 3252 //
     /* 1507407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1507410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1507418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1507421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1507424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1507430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1507437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507453 */     // MIs[0] policy
     /* 1507453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1507466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507487 */     // GIR_Coverage, 3252,
     /* 1507487 */     GIR_EraseRootFromParent_Done,
     /* 1507488 */   // Label 20933: @1507488
     /* 1507488 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1507574), // Rule ID 3253 //
     /* 1507493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1507496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1507504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1507507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1507510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1507513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1507516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1507523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507539 */     // MIs[0] policy
     /* 1507539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11313:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1507552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507573 */     // GIR_Coverage, 3253,
     /* 1507573 */     GIR_EraseRootFromParent_Done,
     /* 1507574 */   // Label 20934: @1507574
     /* 1507574 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1507660), // Rule ID 3256 //
     /* 1507579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1507582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1507590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1507593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1507596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1507602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1507609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507625 */     // MIs[0] policy
     /* 1507625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507635 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1507638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507659 */     // GIR_Coverage, 3256,
     /* 1507659 */     GIR_EraseRootFromParent_Done,
     /* 1507660 */   // Label 20935: @1507660
     /* 1507660 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1507746), // Rule ID 3257 //
     /* 1507665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1507668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1507676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1507679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1507682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1507685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1507688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1507695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507711 */     // MIs[0] policy
     /* 1507711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11313:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1507724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507745 */     // GIR_Coverage, 3257,
     /* 1507745 */     GIR_EraseRootFromParent_Done,
     /* 1507746 */   // Label 20936: @1507746
     /* 1507746 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1507832), // Rule ID 3260 //
     /* 1507751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1507754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1507762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1507765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1507768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1507774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1507781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507797 */     // MIs[0] policy
     /* 1507797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507807 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1507810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507831 */     // GIR_Coverage, 3260,
     /* 1507831 */     GIR_EraseRootFromParent_Done,
     /* 1507832 */   // Label 20937: @1507832
     /* 1507832 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1507918), // Rule ID 3261 //
     /* 1507837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1507840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1507845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1507848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1507851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1507854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1507857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1507860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1507867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507883 */     // MIs[0] policy
     /* 1507883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507893 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11313:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1507896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507917 */     // GIR_Coverage, 3261,
     /* 1507917 */     GIR_EraseRootFromParent_Done,
     /* 1507918 */   // Label 20938: @1507918
     /* 1507918 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1508004), // Rule ID 3264 //
     /* 1507923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1507926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1507931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1507934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1507937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1507940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1507943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1507946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1507953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1507965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1507969 */     // MIs[0] policy
     /* 1507969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507979 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1507982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1507986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1507992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508003 */     // GIR_Coverage, 3264,
     /* 1508003 */     GIR_EraseRootFromParent_Done,
     /* 1508004 */   // Label 20939: @1508004
     /* 1508004 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1508090), // Rule ID 3265 //
     /* 1508009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1508020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1508023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1508026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1508032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508055 */     // MIs[0] policy
     /* 1508055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508065 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1508068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508089 */     // GIR_Coverage, 3265,
     /* 1508089 */     GIR_EraseRootFromParent_Done,
     /* 1508090 */   // Label 20940: @1508090
     /* 1508090 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1508176), // Rule ID 3268 //
     /* 1508095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1508106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1508109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1508112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1508118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508141 */     // MIs[0] policy
     /* 1508141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1508154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508175 */     // GIR_Coverage, 3268,
     /* 1508175 */     GIR_EraseRootFromParent_Done,
     /* 1508176 */   // Label 20941: @1508176
     /* 1508176 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1508262), // Rule ID 3269 //
     /* 1508181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1508192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1508195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1508198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1508204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508227 */     // MIs[0] policy
     /* 1508227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508237 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1508240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508261 */     // GIR_Coverage, 3269,
     /* 1508261 */     GIR_EraseRootFromParent_Done,
     /* 1508262 */   // Label 20942: @1508262
     /* 1508262 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1508348), // Rule ID 3272 //
     /* 1508267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1508278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1508281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1508284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1508290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508313 */     // MIs[0] policy
     /* 1508313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508323 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508347 */     // GIR_Coverage, 3272,
     /* 1508347 */     GIR_EraseRootFromParent_Done,
     /* 1508348 */   // Label 20943: @1508348
     /* 1508348 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1508434), // Rule ID 3273 //
     /* 1508353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1508364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1508367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1508370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1508376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508399 */     // MIs[0] policy
     /* 1508399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508409 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1508430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508433 */     // GIR_Coverage, 3273,
     /* 1508433 */     GIR_EraseRootFromParent_Done,
     /* 1508434 */   // Label 20944: @1508434
     /* 1508434 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1508520), // Rule ID 3276 //
     /* 1508439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1508456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1508462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508485 */     // MIs[0] policy
     /* 1508485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508495 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1508498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508519 */     // GIR_Coverage, 3276,
     /* 1508519 */     GIR_EraseRootFromParent_Done,
     /* 1508520 */   // Label 20945: @1508520
     /* 1508520 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1508606), // Rule ID 3277 //
     /* 1508525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1508542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1508548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508571 */     // MIs[0] policy
     /* 1508571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508581 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1508584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508605 */     // GIR_Coverage, 3277,
     /* 1508605 */     GIR_EraseRootFromParent_Done,
     /* 1508606 */   // Label 20946: @1508606
     /* 1508606 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1508692), // Rule ID 3280 //
     /* 1508611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1508622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1508625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1508628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1508634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508657 */     // MIs[0] policy
     /* 1508657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508691 */     // GIR_Coverage, 3280,
     /* 1508691 */     GIR_EraseRootFromParent_Done,
     /* 1508692 */   // Label 20947: @1508692
     /* 1508692 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1508778), // Rule ID 3281 //
     /* 1508697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1508708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1508711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1508714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1508720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508743 */     // MIs[0] policy
     /* 1508743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508753 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508777 */     // GIR_Coverage, 3281,
     /* 1508777 */     GIR_EraseRootFromParent_Done,
     /* 1508778 */   // Label 20948: @1508778
     /* 1508778 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1508864), // Rule ID 3284 //
     /* 1508783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1508794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1508797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1508800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1508806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508829 */     // MIs[0] policy
     /* 1508829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508839 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508863 */     // GIR_Coverage, 3284,
     /* 1508863 */     GIR_EraseRootFromParent_Done,
     /* 1508864 */   // Label 20949: @1508864
     /* 1508864 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1508950), // Rule ID 3285 //
     /* 1508869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1508872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1508880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1508883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1508886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1508889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1508892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1508915 */     // MIs[0] policy
     /* 1508915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508925 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1508928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1508932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1508938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508949 */     // GIR_Coverage, 3285,
     /* 1508949 */     GIR_EraseRootFromParent_Done,
     /* 1508950 */   // Label 20950: @1508950
     /* 1508950 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1509036), // Rule ID 3288 //
     /* 1508955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1508958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1508963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1508966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1508969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1508972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1508975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1508978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1508985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1508997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509001 */     // MIs[0] policy
     /* 1509001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509035 */     // GIR_Coverage, 3288,
     /* 1509035 */     GIR_EraseRootFromParent_Done,
     /* 1509036 */   // Label 20951: @1509036
     /* 1509036 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1509122), // Rule ID 3289 //
     /* 1509041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1509044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1509052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1509055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1509058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1509064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509087 */     // MIs[0] policy
     /* 1509087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509097 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509121 */     // GIR_Coverage, 3289,
     /* 1509121 */     GIR_EraseRootFromParent_Done,
     /* 1509122 */   // Label 20952: @1509122
     /* 1509122 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1509208), // Rule ID 3292 //
     /* 1509127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1509130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1509144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1509147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1509150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509173 */     // MIs[0] policy
     /* 1509173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509183 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509207 */     // GIR_Coverage, 3292,
     /* 1509207 */     GIR_EraseRootFromParent_Done,
     /* 1509208 */   // Label 20953: @1509208
     /* 1509208 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1509294), // Rule ID 3293 //
     /* 1509213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1509216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1509230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1509236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509259 */     // MIs[0] policy
     /* 1509259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509293 */     // GIR_Coverage, 3293,
     /* 1509293 */     GIR_EraseRootFromParent_Done,
     /* 1509294 */   // Label 20954: @1509294
     /* 1509294 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1509380), // Rule ID 3296 //
     /* 1509299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1509302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1509316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1509319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1509322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509345 */     // MIs[0] policy
     /* 1509345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509379 */     // GIR_Coverage, 3296,
     /* 1509379 */     GIR_EraseRootFromParent_Done,
     /* 1509380 */   // Label 20955: @1509380
     /* 1509380 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1509466), // Rule ID 3297 //
     /* 1509385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1509388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1509402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1509408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509431 */     // MIs[0] policy
     /* 1509431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509441 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509465 */     // GIR_Coverage, 3297,
     /* 1509465 */     GIR_EraseRootFromParent_Done,
     /* 1509466 */   // Label 20956: @1509466
     /* 1509466 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1509552), // Rule ID 3300 //
     /* 1509471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1509474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1509488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1509491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1509494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509517 */     // MIs[0] policy
     /* 1509517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509551 */     // GIR_Coverage, 3300,
     /* 1509551 */     GIR_EraseRootFromParent_Done,
     /* 1509552 */   // Label 20957: @1509552
     /* 1509552 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1509638), // Rule ID 3301 //
     /* 1509557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1509560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1509574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1509580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1509587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509603 */     // MIs[0] policy
     /* 1509603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509613 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1509616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509637 */     // GIR_Coverage, 3301,
     /* 1509637 */     GIR_EraseRootFromParent_Done,
     /* 1509638 */   // Label 20958: @1509638
     /* 1509638 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1509724), // Rule ID 3304 //
     /* 1509643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1509646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1509654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1509657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1509660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1509663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1509666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1509673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509689 */     // MIs[0] policy
     /* 1509689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1509702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509723 */     // GIR_Coverage, 3304,
     /* 1509723 */     GIR_EraseRootFromParent_Done,
     /* 1509724 */   // Label 20959: @1509724
     /* 1509724 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1509810), // Rule ID 3305 //
     /* 1509729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1509732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1509740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1509743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1509746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1509752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1509759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509775 */     // MIs[0] policy
     /* 1509775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1509788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509809 */     // GIR_Coverage, 3305,
     /* 1509809 */     GIR_EraseRootFromParent_Done,
     /* 1509810 */   // Label 20960: @1509810
     /* 1509810 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1509896), // Rule ID 3308 //
     /* 1509815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1509818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1509826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1509829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1509832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1509835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1509838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1509845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509861 */     // MIs[0] policy
     /* 1509861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509871 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1509874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509895 */     // GIR_Coverage, 3308,
     /* 1509895 */     GIR_EraseRootFromParent_Done,
     /* 1509896 */   // Label 20961: @1509896
     /* 1509896 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1509982), // Rule ID 3309 //
     /* 1509901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1509904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1509912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1509915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1509918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1509921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1509924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1509931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1509943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1509947 */     // MIs[0] policy
     /* 1509947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509957 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1509960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1509964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1509970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1509978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509981 */     // GIR_Coverage, 3309,
     /* 1509981 */     GIR_EraseRootFromParent_Done,
     /* 1509982 */   // Label 20962: @1509982
     /* 1509982 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1510068), // Rule ID 3312 //
     /* 1509987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1509990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1509995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1509998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1510001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1510004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1510010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1510017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510033 */     // MIs[0] policy
     /* 1510033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510043 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1510046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1510064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510067 */     // GIR_Coverage, 3312,
     /* 1510067 */     GIR_EraseRootFromParent_Done,
     /* 1510068 */   // Label 20963: @1510068
     /* 1510068 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1510154), // Rule ID 3313 //
     /* 1510073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1510084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1510087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1510090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1510096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1510103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510119 */     // MIs[0] policy
     /* 1510119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510129 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1510132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1510150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510153 */     // GIR_Coverage, 3313,
     /* 1510153 */     GIR_EraseRootFromParent_Done,
     /* 1510154 */   // Label 20964: @1510154
     /* 1510154 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1510240), // Rule ID 3316 //
     /* 1510159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1510162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1510176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1510182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1510189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510205 */     // MIs[0] policy
     /* 1510205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1510218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510239 */     // GIR_Coverage, 3316,
     /* 1510239 */     GIR_EraseRootFromParent_Done,
     /* 1510240 */   // Label 20965: @1510240
     /* 1510240 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1510326), // Rule ID 3317 //
     /* 1510245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1510262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1510268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1510275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510291 */     // MIs[0] policy
     /* 1510291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1510304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510325 */     // GIR_Coverage, 3317,
     /* 1510325 */     GIR_EraseRootFromParent_Done,
     /* 1510326 */   // Label 20966: @1510326
     /* 1510326 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1510412), // Rule ID 3320 //
     /* 1510331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1510334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1510354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1510361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510377 */     // MIs[0] policy
     /* 1510377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510387 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1510390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510411 */     // GIR_Coverage, 3320,
     /* 1510411 */     GIR_EraseRootFromParent_Done,
     /* 1510412 */   // Label 20967: @1510412
     /* 1510412 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1510498), // Rule ID 3321 //
     /* 1510417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1510440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1510447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510463 */     // MIs[0] policy
     /* 1510463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510473 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1510476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510497 */     // GIR_Coverage, 3321,
     /* 1510497 */     GIR_EraseRootFromParent_Done,
     /* 1510498 */   // Label 20968: @1510498
     /* 1510498 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1510584), // Rule ID 3324 //
     /* 1510503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1510506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1510526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1510533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510549 */     // MIs[0] policy
     /* 1510549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510559 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1510562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510583 */     // GIR_Coverage, 3324,
     /* 1510583 */     GIR_EraseRootFromParent_Done,
     /* 1510584 */   // Label 20969: @1510584
     /* 1510584 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1510670), // Rule ID 3325 //
     /* 1510589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1510612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1510619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510635 */     // MIs[0] policy
     /* 1510635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1510648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510669 */     // GIR_Coverage, 3325,
     /* 1510669 */     GIR_EraseRootFromParent_Done,
     /* 1510670 */   // Label 20970: @1510670
     /* 1510670 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1510756), // Rule ID 3328 //
     /* 1510675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1510678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1510692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1510698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1510705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510721 */     // MIs[0] policy
     /* 1510721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1510734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510755 */     // GIR_Coverage, 3328,
     /* 1510755 */     GIR_EraseRootFromParent_Done,
     /* 1510756 */   // Label 20971: @1510756
     /* 1510756 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1510842), // Rule ID 3329 //
     /* 1510761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1510778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1510784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1510791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510807 */     // MIs[0] policy
     /* 1510807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1510820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510841 */     // GIR_Coverage, 3329,
     /* 1510841 */     GIR_EraseRootFromParent_Done,
     /* 1510842 */   // Label 20972: @1510842
     /* 1510842 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1510928), // Rule ID 3332 //
     /* 1510847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1510850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1510864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1510867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1510870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1510877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510893 */     // MIs[0] policy
     /* 1510893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510903 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1510906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1510916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510927 */     // GIR_Coverage, 3332,
     /* 1510927 */     GIR_EraseRootFromParent_Done,
     /* 1510928 */   // Label 20973: @1510928
     /* 1510928 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1511014), // Rule ID 3333 //
     /* 1510933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1510936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1510941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1510950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1510953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1510956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1510963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1510975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1510979 */     // MIs[0] policy
     /* 1510979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1510992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1510996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511013 */     // GIR_Coverage, 3333,
     /* 1511013 */     GIR_EraseRootFromParent_Done,
     /* 1511014 */   // Label 20974: @1511014
     /* 1511014 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1511100), // Rule ID 3336 //
     /* 1511019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1511022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1511036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1511039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1511042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1511049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511065 */     // MIs[0] policy
     /* 1511065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1511078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511099 */     // GIR_Coverage, 3336,
     /* 1511099 */     GIR_EraseRootFromParent_Done,
     /* 1511100 */   // Label 20975: @1511100
     /* 1511100 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1511186), // Rule ID 3337 //
     /* 1511105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1511108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1511122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1511125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1511128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1511135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511151 */     // MIs[0] policy
     /* 1511151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511161 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1511164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511185 */     // GIR_Coverage, 3337,
     /* 1511185 */     GIR_EraseRootFromParent_Done,
     /* 1511186 */   // Label 20976: @1511186
     /* 1511186 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1511272), // Rule ID 3340 //
     /* 1511191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1511194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1511208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1511211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1511214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1511221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511237 */     // MIs[0] policy
     /* 1511237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1511250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511271 */     // GIR_Coverage, 3340,
     /* 1511271 */     GIR_EraseRootFromParent_Done,
     /* 1511272 */   // Label 20977: @1511272
     /* 1511272 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1511358), // Rule ID 3341 //
     /* 1511277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1511280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1511294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1511297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1511300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1511307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511323 */     // MIs[0] policy
     /* 1511323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1511336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511357 */     // GIR_Coverage, 3341,
     /* 1511357 */     GIR_EraseRootFromParent_Done,
     /* 1511358 */   // Label 20978: @1511358
     /* 1511358 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1511444), // Rule ID 3344 //
     /* 1511363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1511366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1511383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1511386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1511393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511409 */     // MIs[0] policy
     /* 1511409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511419 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1511422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511443 */     // GIR_Coverage, 3344,
     /* 1511443 */     GIR_EraseRootFromParent_Done,
     /* 1511444 */   // Label 20979: @1511444
     /* 1511444 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1511530), // Rule ID 3345 //
     /* 1511449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1511452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1511469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1511472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1511479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511495 */     // MIs[0] policy
     /* 1511495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1511508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511529 */     // GIR_Coverage, 3345,
     /* 1511529 */     GIR_EraseRootFromParent_Done,
     /* 1511530 */   // Label 20980: @1511530
     /* 1511530 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1511616), // Rule ID 3348 //
     /* 1511535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1511538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1511555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1511558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1511565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511581 */     // MIs[0] policy
     /* 1511581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511591 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1511594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511615 */     // GIR_Coverage, 3348,
     /* 1511615 */     GIR_EraseRootFromParent_Done,
     /* 1511616 */   // Label 20981: @1511616
     /* 1511616 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1511702), // Rule ID 3349 //
     /* 1511621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1511624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1511629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1511641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1511644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1511651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1511663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511667 */     // MIs[0] policy
     /* 1511667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1511680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511701 */     // GIR_Coverage, 3349,
     /* 1511701 */     GIR_EraseRootFromParent_Done,
     /* 1511702 */   // Label 20982: @1511702
     /* 1511702 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1511788), // Rule ID 3440 //
     /* 1511707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1511710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1511715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1511724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1511727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1511730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1511737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511753 */     // MIs[0] policy
     /* 1511753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511763 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1511766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1511784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511787 */     // GIR_Coverage, 3440,
     /* 1511787 */     GIR_EraseRootFromParent_Done,
     /* 1511788 */   // Label 20983: @1511788
     /* 1511788 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1511874), // Rule ID 3441 //
     /* 1511793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1511796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1511801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1511810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1511813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1511816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1511823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511839 */     // MIs[0] policy
     /* 1511839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1511852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1511870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511873 */     // GIR_Coverage, 3441,
     /* 1511873 */     GIR_EraseRootFromParent_Done,
     /* 1511874 */   // Label 20984: @1511874
     /* 1511874 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1511960), // Rule ID 3444 //
     /* 1511879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1511882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1511887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1511896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1511899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1511902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1511909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1511925 */     // MIs[0] policy
     /* 1511925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511935 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1511938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1511942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1511948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1511956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511959 */     // GIR_Coverage, 3444,
     /* 1511959 */     GIR_EraseRootFromParent_Done,
     /* 1511960 */   // Label 20985: @1511960
     /* 1511960 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1512046), // Rule ID 3445 //
     /* 1511965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1511968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1511973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1511982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1511985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1511988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1511995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512011 */     // MIs[0] policy
     /* 1512011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512021 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1512024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512045 */     // GIR_Coverage, 3445,
     /* 1512045 */     GIR_EraseRootFromParent_Done,
     /* 1512046 */   // Label 20986: @1512046
     /* 1512046 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1512132), // Rule ID 3448 //
     /* 1512051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1512068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1512071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1512074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1512081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512097 */     // MIs[0] policy
     /* 1512097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1512110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512131 */     // GIR_Coverage, 3448,
     /* 1512131 */     GIR_EraseRootFromParent_Done,
     /* 1512132 */   // Label 20987: @1512132
     /* 1512132 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1512218), // Rule ID 3449 //
     /* 1512137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1512140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1512154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1512157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1512160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1512167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512183 */     // MIs[0] policy
     /* 1512183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512193 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1512196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512217 */     // GIR_Coverage, 3449,
     /* 1512217 */     GIR_EraseRootFromParent_Done,
     /* 1512218 */   // Label 20988: @1512218
     /* 1512218 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1512304), // Rule ID 3452 //
     /* 1512223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1512240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1512243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1512246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1512253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512269 */     // MIs[0] policy
     /* 1512269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1512282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512303 */     // GIR_Coverage, 3452,
     /* 1512303 */     GIR_EraseRootFromParent_Done,
     /* 1512304 */   // Label 20989: @1512304
     /* 1512304 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1512390), // Rule ID 3453 //
     /* 1512309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1512312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1512326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1512329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1512332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1512339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512355 */     // MIs[0] policy
     /* 1512355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1512368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512389 */     // GIR_Coverage, 3453,
     /* 1512389 */     GIR_EraseRootFromParent_Done,
     /* 1512390 */   // Label 20990: @1512390
     /* 1512390 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1512476), // Rule ID 3456 //
     /* 1512395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1512412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1512415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1512418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1512425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512441 */     // MIs[0] policy
     /* 1512441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512451 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1512454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512475 */     // GIR_Coverage, 3456,
     /* 1512475 */     GIR_EraseRootFromParent_Done,
     /* 1512476 */   // Label 20991: @1512476
     /* 1512476 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1512562), // Rule ID 3457 //
     /* 1512481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1512484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1512498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1512501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1512504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1512511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512527 */     // MIs[0] policy
     /* 1512527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1512540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512561 */     // GIR_Coverage, 3457,
     /* 1512561 */     GIR_EraseRootFromParent_Done,
     /* 1512562 */   // Label 20992: @1512562
     /* 1512562 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1512648), // Rule ID 3460 //
     /* 1512567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1512584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1512587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1512590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1512597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512613 */     // MIs[0] policy
     /* 1512613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1512626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512647 */     // GIR_Coverage, 3460,
     /* 1512647 */     GIR_EraseRootFromParent_Done,
     /* 1512648 */   // Label 20993: @1512648
     /* 1512648 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1512734), // Rule ID 3461 //
     /* 1512653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1512656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1512670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1512673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1512676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1512683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512699 */     // MIs[0] policy
     /* 1512699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1512712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1512730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512733 */     // GIR_Coverage, 3461,
     /* 1512733 */     GIR_EraseRootFromParent_Done,
     /* 1512734 */   // Label 20994: @1512734
     /* 1512734 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1512820), // Rule ID 3464 //
     /* 1512739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1512756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1512762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1512769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512785 */     // MIs[0] policy
     /* 1512785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512795 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1512798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512819 */     // GIR_Coverage, 3464,
     /* 1512819 */     GIR_EraseRootFromParent_Done,
     /* 1512820 */   // Label 20995: @1512820
     /* 1512820 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1512906), // Rule ID 3465 //
     /* 1512825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1512828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1512842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1512848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1512855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512871 */     // MIs[0] policy
     /* 1512871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512881 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1512884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512905 */     // GIR_Coverage, 3465,
     /* 1512905 */     GIR_EraseRootFromParent_Done,
     /* 1512906 */   // Label 20996: @1512906
     /* 1512906 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1512992), // Rule ID 3468 //
     /* 1512911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1512914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1512919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1512928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1512931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1512934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1512941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1512957 */     // MIs[0] policy
     /* 1512957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512967 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1512970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1512974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1512980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512991 */     // GIR_Coverage, 3468,
     /* 1512991 */     GIR_EraseRootFromParent_Done,
     /* 1512992 */   // Label 20997: @1512992
     /* 1512992 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1513078), // Rule ID 3469 //
     /* 1512997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1513000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1513008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1513011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1513014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1513017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1513020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1513027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513043 */     // MIs[0] policy
     /* 1513043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513053 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1513056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513077 */     // GIR_Coverage, 3469,
     /* 1513077 */     GIR_EraseRootFromParent_Done,
     /* 1513078 */   // Label 20998: @1513078
     /* 1513078 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1513164), // Rule ID 3472 //
     /* 1513083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1513086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1513100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1513103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1513106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1513113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513129 */     // MIs[0] policy
     /* 1513129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1513142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513163 */     // GIR_Coverage, 3472,
     /* 1513163 */     GIR_EraseRootFromParent_Done,
     /* 1513164 */   // Label 20999: @1513164
     /* 1513164 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1513250), // Rule ID 3473 //
     /* 1513169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1513172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1513186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1513189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1513192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1513199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513215 */     // MIs[0] policy
     /* 1513215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1513228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513249 */     // GIR_Coverage, 3473,
     /* 1513249 */     GIR_EraseRootFromParent_Done,
     /* 1513250 */   // Label 21000: @1513250
     /* 1513250 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1513336), // Rule ID 3476 //
     /* 1513255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1513258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1513272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1513278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1513285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513301 */     // MIs[0] policy
     /* 1513301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513311 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1513314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513335 */     // GIR_Coverage, 3476,
     /* 1513335 */     GIR_EraseRootFromParent_Done,
     /* 1513336 */   // Label 21001: @1513336
     /* 1513336 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1513422), // Rule ID 3477 //
     /* 1513341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1513344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1513358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1513364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1513371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513387 */     // MIs[0] policy
     /* 1513387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513397 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1513400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513421 */     // GIR_Coverage, 3477,
     /* 1513421 */     GIR_EraseRootFromParent_Done,
     /* 1513422 */   // Label 21002: @1513422
     /* 1513422 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1513508), // Rule ID 3480 //
     /* 1513427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1513430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1513444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1513450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1513457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513473 */     // MIs[0] policy
     /* 1513473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513483 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1513486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513507 */     // GIR_Coverage, 3480,
     /* 1513507 */     GIR_EraseRootFromParent_Done,
     /* 1513508 */   // Label 21003: @1513508
     /* 1513508 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1513594), // Rule ID 3481 //
     /* 1513513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1513516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1513530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1513536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1513543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513559 */     // MIs[0] policy
     /* 1513559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1513572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513593 */     // GIR_Coverage, 3481,
     /* 1513593 */     GIR_EraseRootFromParent_Done,
     /* 1513594 */   // Label 21004: @1513594
     /* 1513594 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1513680), // Rule ID 3484 //
     /* 1513599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1513602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1513610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1513613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1513616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1513619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1513622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1513629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513645 */     // MIs[0] policy
     /* 1513645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513655 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1513658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513679 */     // GIR_Coverage, 3484,
     /* 1513679 */     GIR_EraseRootFromParent_Done,
     /* 1513680 */   // Label 21005: @1513680
     /* 1513680 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1513766), // Rule ID 3485 //
     /* 1513685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1513688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1513696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1513699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1513702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1513705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1513708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1513715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513731 */     // MIs[0] policy
     /* 1513731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513741 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1513744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513765 */     // GIR_Coverage, 3485,
     /* 1513765 */     GIR_EraseRootFromParent_Done,
     /* 1513766 */   // Label 21006: @1513766
     /* 1513766 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1513852), // Rule ID 3488 //
     /* 1513771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1513774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1513788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1513791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1513794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1513801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513817 */     // MIs[0] policy
     /* 1513817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1513830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513851 */     // GIR_Coverage, 3488,
     /* 1513851 */     GIR_EraseRootFromParent_Done,
     /* 1513852 */   // Label 21007: @1513852
     /* 1513852 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1513938), // Rule ID 3489 //
     /* 1513857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1513860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1513874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1513877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1513880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1513887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513903 */     // MIs[0] policy
     /* 1513903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1513916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1513920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1513926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513937 */     // GIR_Coverage, 3489,
     /* 1513937 */     GIR_EraseRootFromParent_Done,
     /* 1513938 */   // Label 21008: @1513938
     /* 1513938 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1514024), // Rule ID 3492 //
     /* 1513943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1513946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1513951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1513960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1513966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1513973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1513989 */     // MIs[0] policy
     /* 1513989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513999 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1514002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514023 */     // GIR_Coverage, 3492,
     /* 1514023 */     GIR_EraseRootFromParent_Done,
     /* 1514024 */   // Label 21009: @1514024
     /* 1514024 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1514110), // Rule ID 3493 //
     /* 1514029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1514032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1514040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1514043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1514046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1514049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1514052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1514059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514075 */     // MIs[0] policy
     /* 1514075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514085 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1514088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514109 */     // GIR_Coverage, 3493,
     /* 1514109 */     GIR_EraseRootFromParent_Done,
     /* 1514110 */   // Label 21010: @1514110
     /* 1514110 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1514196), // Rule ID 3496 //
     /* 1514115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1514118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1514132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1514135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1514138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1514145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514161 */     // MIs[0] policy
     /* 1514161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514171 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1514174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514195 */     // GIR_Coverage, 3496,
     /* 1514195 */     GIR_EraseRootFromParent_Done,
     /* 1514196 */   // Label 21011: @1514196
     /* 1514196 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1514282), // Rule ID 3497 //
     /* 1514201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1514204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1514218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1514221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1514224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1514231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514247 */     // MIs[0] policy
     /* 1514247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514257 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1514260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514281 */     // GIR_Coverage, 3497,
     /* 1514281 */     GIR_EraseRootFromParent_Done,
     /* 1514282 */   // Label 21012: @1514282
     /* 1514282 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1514368), // Rule ID 3500 //
     /* 1514287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1514290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1514304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1514307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1514310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514333 */     // MIs[0] policy
     /* 1514333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1514346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514367 */     // GIR_Coverage, 3500,
     /* 1514367 */     GIR_EraseRootFromParent_Done,
     /* 1514368 */   // Label 21013: @1514368
     /* 1514368 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1514454), // Rule ID 3501 //
     /* 1514373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1514376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1514390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1514393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1514396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514419 */     // MIs[0] policy
     /* 1514419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514429 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1514432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514453 */     // GIR_Coverage, 3501,
     /* 1514453 */     GIR_EraseRootFromParent_Done,
     /* 1514454 */   // Label 21014: @1514454
     /* 1514454 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1514540), // Rule ID 3504 //
     /* 1514459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1514462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1514476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1514479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1514482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514505 */     // MIs[0] policy
     /* 1514505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514515 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1514518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514539 */     // GIR_Coverage, 3504,
     /* 1514539 */     GIR_EraseRootFromParent_Done,
     /* 1514540 */   // Label 21015: @1514540
     /* 1514540 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1514626), // Rule ID 3505 //
     /* 1514545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1514548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1514562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1514565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1514568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514591 */     // MIs[0] policy
     /* 1514591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1514604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514625 */     // GIR_Coverage, 3505,
     /* 1514625 */     GIR_EraseRootFromParent_Done,
     /* 1514626 */   // Label 21016: @1514626
     /* 1514626 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1514712), // Rule ID 3508 //
     /* 1514631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1514634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1514648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1514651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1514654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514677 */     // MIs[0] policy
     /* 1514677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514687 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1514690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514711 */     // GIR_Coverage, 3508,
     /* 1514711 */     GIR_EraseRootFromParent_Done,
     /* 1514712 */   // Label 21017: @1514712
     /* 1514712 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1514798), // Rule ID 3509 //
     /* 1514717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1514720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1514734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1514737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1514740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1514747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514763 */     // MIs[0] policy
     /* 1514763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514773 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11335:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1514776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514797 */     // GIR_Coverage, 3509,
     /* 1514797 */     GIR_EraseRootFromParent_Done,
     /* 1514798 */   // Label 21018: @1514798
     /* 1514798 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1514884), // Rule ID 3512 //
     /* 1514803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1514806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1514820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1514823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1514826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1514833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514849 */     // MIs[0] policy
     /* 1514849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1514862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514883 */     // GIR_Coverage, 3512,
     /* 1514883 */     GIR_EraseRootFromParent_Done,
     /* 1514884 */   // Label 21019: @1514884
     /* 1514884 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1514970), // Rule ID 3513 //
     /* 1514889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1514892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1514906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1514909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1514912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1514919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1514931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1514935 */     // MIs[0] policy
     /* 1514935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1514948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1514952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1514958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1514966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514969 */     // GIR_Coverage, 3513,
     /* 1514969 */     GIR_EraseRootFromParent_Done,
     /* 1514970 */   // Label 21020: @1514970
     /* 1514970 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1515056), // Rule ID 3516 //
     /* 1514975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1514978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1514983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1514986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1514989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1514992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1514995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1514998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1515005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515021 */     // MIs[0] policy
     /* 1515021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515031 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1515034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1515052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515055 */     // GIR_Coverage, 3516,
     /* 1515055 */     GIR_EraseRootFromParent_Done,
     /* 1515056 */   // Label 21021: @1515056
     /* 1515056 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1515142), // Rule ID 3517 //
     /* 1515061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1515078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1515084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1515091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515107 */     // MIs[0] policy
     /* 1515107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515117 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1515120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1515138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515141 */     // GIR_Coverage, 3517,
     /* 1515141 */     GIR_EraseRootFromParent_Done,
     /* 1515142 */   // Label 21022: @1515142
     /* 1515142 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1515228), // Rule ID 3520 //
     /* 1515147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1515150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1515164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1515167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1515170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1515177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515193 */     // MIs[0] policy
     /* 1515193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515203 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1515206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1515224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515227 */     // GIR_Coverage, 3520,
     /* 1515227 */     GIR_EraseRootFromParent_Done,
     /* 1515228 */   // Label 21023: @1515228
     /* 1515228 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1515314), // Rule ID 3521 //
     /* 1515233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1515250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1515256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1515263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515279 */     // MIs[0] policy
     /* 1515279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515289 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1515292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1515310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515313 */     // GIR_Coverage, 3521,
     /* 1515313 */     GIR_EraseRootFromParent_Done,
     /* 1515314 */   // Label 21024: @1515314
     /* 1515314 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1515400), // Rule ID 3524 //
     /* 1515319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1515322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1515330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1515333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1515336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1515339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1515342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1515349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515365 */     // MIs[0] policy
     /* 1515365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1515378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515399 */     // GIR_Coverage, 3524,
     /* 1515399 */     GIR_EraseRootFromParent_Done,
     /* 1515400 */   // Label 21025: @1515400
     /* 1515400 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1515486), // Rule ID 3525 //
     /* 1515405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1515416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1515419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1515422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1515428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1515435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515451 */     // MIs[0] policy
     /* 1515451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1515464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515485 */     // GIR_Coverage, 3525,
     /* 1515485 */     GIR_EraseRootFromParent_Done,
     /* 1515486 */   // Label 21026: @1515486
     /* 1515486 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1515572), // Rule ID 3528 //
     /* 1515491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1515494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1515508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1515511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1515514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1515521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515537 */     // MIs[0] policy
     /* 1515537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1515550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515571 */     // GIR_Coverage, 3528,
     /* 1515571 */     GIR_EraseRootFromParent_Done,
     /* 1515572 */   // Label 21027: @1515572
     /* 1515572 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1515658), // Rule ID 3529 //
     /* 1515577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1515594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1515600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1515607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515623 */     // MIs[0] policy
     /* 1515623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1515636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515657 */     // GIR_Coverage, 3529,
     /* 1515657 */     GIR_EraseRootFromParent_Done,
     /* 1515658 */   // Label 21028: @1515658
     /* 1515658 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1515744), // Rule ID 3532 //
     /* 1515663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1515666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1515680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1515683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1515686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1515693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515709 */     // MIs[0] policy
     /* 1515709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1515722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515743 */     // GIR_Coverage, 3532,
     /* 1515743 */     GIR_EraseRootFromParent_Done,
     /* 1515744 */   // Label 21029: @1515744
     /* 1515744 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1515830), // Rule ID 3533 //
     /* 1515749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1515766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1515772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1515779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515795 */     // MIs[0] policy
     /* 1515795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1515808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515829 */     // GIR_Coverage, 3533,
     /* 1515829 */     GIR_EraseRootFromParent_Done,
     /* 1515830 */   // Label 21030: @1515830
     /* 1515830 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1515916), // Rule ID 3536 //
     /* 1515835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1515838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1515852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1515855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1515858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1515865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515881 */     // MIs[0] policy
     /* 1515881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1515894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515915 */     // GIR_Coverage, 3536,
     /* 1515915 */     GIR_EraseRootFromParent_Done,
     /* 1515916 */   // Label 21031: @1515916
     /* 1515916 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1516002), // Rule ID 3537 //
     /* 1515921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1515924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1515929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1515938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1515941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1515944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1515951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1515963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1515967 */     // MIs[0] policy
     /* 1515967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1515980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1515984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1515990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516001 */     // GIR_Coverage, 3537,
     /* 1516001 */     GIR_EraseRootFromParent_Done,
     /* 1516002 */   // Label 21032: @1516002
     /* 1516002 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1516088), // Rule ID 3540 //
     /* 1516007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1516010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1516024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1516027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1516030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1516037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516053 */     // MIs[0] policy
     /* 1516053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516063 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1516066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516087 */     // GIR_Coverage, 3540,
     /* 1516087 */     GIR_EraseRootFromParent_Done,
     /* 1516088 */   // Label 21033: @1516088
     /* 1516088 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1516174), // Rule ID 3541 //
     /* 1516093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1516096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1516110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1516113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1516116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1516123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516139 */     // MIs[0] policy
     /* 1516139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516149 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1516152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516173 */     // GIR_Coverage, 3541,
     /* 1516173 */     GIR_EraseRootFromParent_Done,
     /* 1516174 */   // Label 21034: @1516174
     /* 1516174 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1516260), // Rule ID 3544 //
     /* 1516179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1516182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1516190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1516193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1516199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1516202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1516209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516225 */     // MIs[0] policy
     /* 1516225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1516238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516259 */     // GIR_Coverage, 3544,
     /* 1516259 */     GIR_EraseRootFromParent_Done,
     /* 1516260 */   // Label 21035: @1516260
     /* 1516260 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1516346), // Rule ID 3545 //
     /* 1516265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1516268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1516276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1516279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1516285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1516288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1516295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516311 */     // MIs[0] policy
     /* 1516311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1516324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516345 */     // GIR_Coverage, 3545,
     /* 1516345 */     GIR_EraseRootFromParent_Done,
     /* 1516346 */   // Label 21036: @1516346
     /* 1516346 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1516432), // Rule ID 3548 //
     /* 1516351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1516354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1516371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1516374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1516381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516397 */     // MIs[0] policy
     /* 1516397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516407 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1516410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516431 */     // GIR_Coverage, 3548,
     /* 1516431 */     GIR_EraseRootFromParent_Done,
     /* 1516432 */   // Label 21037: @1516432
     /* 1516432 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1516518), // Rule ID 3549 //
     /* 1516437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1516440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1516457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1516460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1516467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516483 */     // MIs[0] policy
     /* 1516483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1516496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516517 */     // GIR_Coverage, 3549,
     /* 1516517 */     GIR_EraseRootFromParent_Done,
     /* 1516518 */   // Label 21038: @1516518
     /* 1516518 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1516604), // Rule ID 3552 //
     /* 1516523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1516526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1516540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1516543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1516546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1516553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516569 */     // MIs[0] policy
     /* 1516569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516579 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1516582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516603 */     // GIR_Coverage, 3552,
     /* 1516603 */     GIR_EraseRootFromParent_Done,
     /* 1516604 */   // Label 21039: @1516604
     /* 1516604 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1516690), // Rule ID 3553 //
     /* 1516609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1516612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1516626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1516629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1516632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1516639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516655 */     // MIs[0] policy
     /* 1516655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516665 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1516668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516689 */     // GIR_Coverage, 3553,
     /* 1516689 */     GIR_EraseRootFromParent_Done,
     /* 1516690 */   // Label 21040: @1516690
     /* 1516690 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1516776), // Rule ID 3556 //
     /* 1516695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1516698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1516715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1516718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1516725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516741 */     // MIs[0] policy
     /* 1516741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1516754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516775 */     // GIR_Coverage, 3556,
     /* 1516775 */     GIR_EraseRootFromParent_Done,
     /* 1516776 */   // Label 21041: @1516776
     /* 1516776 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1516862), // Rule ID 3557 //
     /* 1516781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1516784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1516789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1516801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1516804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1516811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1516823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516827 */     // MIs[0] policy
     /* 1516827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516837 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1516840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516861 */     // GIR_Coverage, 3557,
     /* 1516861 */     GIR_EraseRootFromParent_Done,
     /* 1516862 */   // Label 21042: @1516862
     /* 1516862 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1516948), // Rule ID 3560 //
     /* 1516867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1516870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1516875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1516884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1516887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1516890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1516897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516913 */     // MIs[0] policy
     /* 1516913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516923 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1516926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1516930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1516936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1516944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516947 */     // GIR_Coverage, 3560,
     /* 1516947 */     GIR_EraseRootFromParent_Done,
     /* 1516948 */   // Label 21043: @1516948
     /* 1516948 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1517034), // Rule ID 3561 //
     /* 1516953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1516956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1516961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1516970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1516973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1516976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1516983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1516999 */     // MIs[0] policy
     /* 1516999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1517012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517033 */     // GIR_Coverage, 3561,
     /* 1517033 */     GIR_EraseRootFromParent_Done,
     /* 1517034 */   // Label 21044: @1517034
     /* 1517034 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1517120), // Rule ID 3564 //
     /* 1517039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1517056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1517059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1517062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1517069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517085 */     // MIs[0] policy
     /* 1517085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517095 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1517098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517119 */     // GIR_Coverage, 3564,
     /* 1517119 */     GIR_EraseRootFromParent_Done,
     /* 1517120 */   // Label 21045: @1517120
     /* 1517120 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1517206), // Rule ID 3565 //
     /* 1517125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1517142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1517145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1517148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1517155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517171 */     // MIs[0] policy
     /* 1517171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517181 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1517184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517205 */     // GIR_Coverage, 3565,
     /* 1517205 */     GIR_EraseRootFromParent_Done,
     /* 1517206 */   // Label 21046: @1517206
     /* 1517206 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1517292), // Rule ID 3568 //
     /* 1517211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1517228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1517231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1517234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1517241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517257 */     // MIs[0] policy
     /* 1517257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517267 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1517270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517291 */     // GIR_Coverage, 3568,
     /* 1517291 */     GIR_EraseRootFromParent_Done,
     /* 1517292 */   // Label 21047: @1517292
     /* 1517292 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1517378), // Rule ID 3569 //
     /* 1517297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1517314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1517317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1517320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1517327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517343 */     // MIs[0] policy
     /* 1517343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517353 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1517356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517377 */     // GIR_Coverage, 3569,
     /* 1517377 */     GIR_EraseRootFromParent_Done,
     /* 1517378 */   // Label 21048: @1517378
     /* 1517378 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1517464), // Rule ID 3572 //
     /* 1517383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1517400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1517403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1517406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1517413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517429 */     // MIs[0] policy
     /* 1517429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517439 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1517442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517463 */     // GIR_Coverage, 3572,
     /* 1517463 */     GIR_EraseRootFromParent_Done,
     /* 1517464 */   // Label 21049: @1517464
     /* 1517464 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1517550), // Rule ID 3573 //
     /* 1517469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1517486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1517489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1517492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1517499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517515 */     // MIs[0] policy
     /* 1517515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1517528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517549 */     // GIR_Coverage, 3573,
     /* 1517549 */     GIR_EraseRootFromParent_Done,
     /* 1517550 */   // Label 21050: @1517550
     /* 1517550 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1517636), // Rule ID 3576 //
     /* 1517555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1517572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1517575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1517578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1517585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517601 */     // MIs[0] policy
     /* 1517601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1517614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517635 */     // GIR_Coverage, 3576,
     /* 1517635 */     GIR_EraseRootFromParent_Done,
     /* 1517636 */   // Label 21051: @1517636
     /* 1517636 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1517722), // Rule ID 3577 //
     /* 1517641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1517658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1517661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1517664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1517671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517687 */     // MIs[0] policy
     /* 1517687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517697 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1517700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517721 */     // GIR_Coverage, 3577,
     /* 1517721 */     GIR_EraseRootFromParent_Done,
     /* 1517722 */   // Label 21052: @1517722
     /* 1517722 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1517808), // Rule ID 3580 //
     /* 1517727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1517744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1517747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1517750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1517757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517773 */     // MIs[0] policy
     /* 1517773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517783 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1517786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517807 */     // GIR_Coverage, 3580,
     /* 1517807 */     GIR_EraseRootFromParent_Done,
     /* 1517808 */   // Label 21053: @1517808
     /* 1517808 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1517894), // Rule ID 3581 //
     /* 1517813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1517830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1517833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1517836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1517843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517859 */     // MIs[0] policy
     /* 1517859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1517872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1517890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517893 */     // GIR_Coverage, 3581,
     /* 1517893 */     GIR_EraseRootFromParent_Done,
     /* 1517894 */   // Label 21054: @1517894
     /* 1517894 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1517980), // Rule ID 3584 //
     /* 1517899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1517902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1517916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1517919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1517922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1517929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1517945 */     // MIs[0] policy
     /* 1517945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1517958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1517962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1517968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517979 */     // GIR_Coverage, 3584,
     /* 1517979 */     GIR_EraseRootFromParent_Done,
     /* 1517980 */   // Label 21055: @1517980
     /* 1517980 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1518066), // Rule ID 3585 //
     /* 1517985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1517988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1517993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1518002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1518008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1518015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518031 */     // MIs[0] policy
     /* 1518031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518041 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1518044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518065 */     // GIR_Coverage, 3585,
     /* 1518065 */     GIR_EraseRootFromParent_Done,
     /* 1518066 */   // Label 21056: @1518066
     /* 1518066 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1518152), // Rule ID 3588 //
     /* 1518071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1518074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1518082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1518085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1518088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1518094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1518101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518117 */     // MIs[0] policy
     /* 1518117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1518130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518151 */     // GIR_Coverage, 3588,
     /* 1518151 */     GIR_EraseRootFromParent_Done,
     /* 1518152 */   // Label 21057: @1518152
     /* 1518152 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1518238), // Rule ID 3589 //
     /* 1518157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1518160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1518168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1518171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1518174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1518180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1518187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518203 */     // MIs[0] policy
     /* 1518203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1518216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518237 */     // GIR_Coverage, 3589,
     /* 1518237 */     GIR_EraseRootFromParent_Done,
     /* 1518238 */   // Label 21058: @1518238
     /* 1518238 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1518324), // Rule ID 3592 //
     /* 1518243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1518246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1518260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1518263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1518266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1518273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518289 */     // MIs[0] policy
     /* 1518289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1518302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518323 */     // GIR_Coverage, 3592,
     /* 1518323 */     GIR_EraseRootFromParent_Done,
     /* 1518324 */   // Label 21059: @1518324
     /* 1518324 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1518410), // Rule ID 3593 //
     /* 1518329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1518332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1518346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1518349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1518352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1518359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518375 */     // MIs[0] policy
     /* 1518375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518385 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1518388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518409 */     // GIR_Coverage, 3593,
     /* 1518409 */     GIR_EraseRootFromParent_Done,
     /* 1518410 */   // Label 21060: @1518410
     /* 1518410 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1518496), // Rule ID 3596 //
     /* 1518415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1518418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1518432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1518435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1518438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1518445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518461 */     // MIs[0] policy
     /* 1518461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1518474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518495 */     // GIR_Coverage, 3596,
     /* 1518495 */     GIR_EraseRootFromParent_Done,
     /* 1518496 */   // Label 21061: @1518496
     /* 1518496 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1518582), // Rule ID 3597 //
     /* 1518501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1518504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1518518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1518521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1518524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1518531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518547 */     // MIs[0] policy
     /* 1518547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518557 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1518560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518581 */     // GIR_Coverage, 3597,
     /* 1518581 */     GIR_EraseRootFromParent_Done,
     /* 1518582 */   // Label 21062: @1518582
     /* 1518582 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1518668), // Rule ID 3600 //
     /* 1518587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1518590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1518604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1518610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1518617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518633 */     // MIs[0] policy
     /* 1518633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1518646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518667 */     // GIR_Coverage, 3600,
     /* 1518667 */     GIR_EraseRootFromParent_Done,
     /* 1518668 */   // Label 21063: @1518668
     /* 1518668 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1518754), // Rule ID 3601 //
     /* 1518673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1518676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1518690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1518696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1518703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518719 */     // MIs[0] policy
     /* 1518719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1518732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518753 */     // GIR_Coverage, 3601,
     /* 1518753 */     GIR_EraseRootFromParent_Done,
     /* 1518754 */   // Label 21064: @1518754
     /* 1518754 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1518840), // Rule ID 3604 //
     /* 1518759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1518762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1518770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1518773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1518776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1518779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1518782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1518789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518805 */     // MIs[0] policy
     /* 1518805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518815 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1518818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518839 */     // GIR_Coverage, 3604,
     /* 1518839 */     GIR_EraseRootFromParent_Done,
     /* 1518840 */   // Label 21065: @1518840
     /* 1518840 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1518926), // Rule ID 3605 //
     /* 1518845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1518848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1518856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1518859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1518862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1518865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1518868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1518875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518891 */     // MIs[0] policy
     /* 1518891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518901 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1518904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1518914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518925 */     // GIR_Coverage, 3605,
     /* 1518925 */     GIR_EraseRootFromParent_Done,
     /* 1518926 */   // Label 21066: @1518926
     /* 1518926 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1519012), // Rule ID 3608 //
     /* 1518931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1518934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1518939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1518948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1518951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1518954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1518961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1518977 */     // MIs[0] policy
     /* 1518977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1518990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1518994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519011 */     // GIR_Coverage, 3608,
     /* 1519011 */     GIR_EraseRootFromParent_Done,
     /* 1519012 */   // Label 21067: @1519012
     /* 1519012 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1519098), // Rule ID 3609 //
     /* 1519017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1519020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1519028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1519031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1519034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1519040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1519047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519063 */     // MIs[0] policy
     /* 1519063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519073 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1519076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519097 */     // GIR_Coverage, 3609,
     /* 1519097 */     GIR_EraseRootFromParent_Done,
     /* 1519098 */   // Label 21068: @1519098
     /* 1519098 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1519184), // Rule ID 3612 //
     /* 1519103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1519106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1519120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1519123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1519126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1519133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519149 */     // MIs[0] policy
     /* 1519149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1519162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519183 */     // GIR_Coverage, 3612,
     /* 1519183 */     GIR_EraseRootFromParent_Done,
     /* 1519184 */   // Label 21069: @1519184
     /* 1519184 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1519270), // Rule ID 3613 //
     /* 1519189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1519192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1519206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1519209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1519212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1519219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519235 */     // MIs[0] policy
     /* 1519235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519245 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1519248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519269 */     // GIR_Coverage, 3613,
     /* 1519269 */     GIR_EraseRootFromParent_Done,
     /* 1519270 */   // Label 21070: @1519270
     /* 1519270 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1519356), // Rule ID 3616 //
     /* 1519275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1519278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1519292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1519295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1519298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1519305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519321 */     // MIs[0] policy
     /* 1519321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1519334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519355 */     // GIR_Coverage, 3616,
     /* 1519355 */     GIR_EraseRootFromParent_Done,
     /* 1519356 */   // Label 21071: @1519356
     /* 1519356 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1519442), // Rule ID 3617 //
     /* 1519361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1519364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1519378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1519381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1519384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1519391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519407 */     // MIs[0] policy
     /* 1519407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1519420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519441 */     // GIR_Coverage, 3617,
     /* 1519441 */     GIR_EraseRootFromParent_Done,
     /* 1519442 */   // Label 21072: @1519442
     /* 1519442 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1519528), // Rule ID 3620 //
     /* 1519447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1519450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1519464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1519467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1519470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519493 */     // MIs[0] policy
     /* 1519493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519503 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1519506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519527 */     // GIR_Coverage, 3620,
     /* 1519527 */     GIR_EraseRootFromParent_Done,
     /* 1519528 */   // Label 21073: @1519528
     /* 1519528 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1519614), // Rule ID 3621 //
     /* 1519533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1519536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1519550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1519553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1519556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519579 */     // MIs[0] policy
     /* 1519579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1519592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519613 */     // GIR_Coverage, 3621,
     /* 1519613 */     GIR_EraseRootFromParent_Done,
     /* 1519614 */   // Label 21074: @1519614
     /* 1519614 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1519700), // Rule ID 3624 //
     /* 1519619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1519622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1519636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1519639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1519642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519665 */     // MIs[0] policy
     /* 1519665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519675 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1519678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519699 */     // GIR_Coverage, 3624,
     /* 1519699 */     GIR_EraseRootFromParent_Done,
     /* 1519700 */   // Label 21075: @1519700
     /* 1519700 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1519786), // Rule ID 3625 //
     /* 1519705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1519708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1519722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1519725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1519728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519751 */     // MIs[0] policy
     /* 1519751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519761 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1519764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519785 */     // GIR_Coverage, 3625,
     /* 1519785 */     GIR_EraseRootFromParent_Done,
     /* 1519786 */   // Label 21076: @1519786
     /* 1519786 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1519872), // Rule ID 3628 //
     /* 1519791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1519794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1519808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1519811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1519814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519837 */     // MIs[0] policy
     /* 1519837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519847 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1519850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519871 */     // GIR_Coverage, 3628,
     /* 1519871 */     GIR_EraseRootFromParent_Done,
     /* 1519872 */   // Label 21077: @1519872
     /* 1519872 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1519958), // Rule ID 3629 //
     /* 1519877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1519880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1519894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1519897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1519900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1519907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1519919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1519923 */     // MIs[0] policy
     /* 1519923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1519936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1519940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1519946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1519954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519957 */     // GIR_Coverage, 3629,
     /* 1519957 */     GIR_EraseRootFromParent_Done,
     /* 1519958 */   // Label 21078: @1519958
     /* 1519958 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1520044), // Rule ID 3632 //
     /* 1519963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1519966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1519971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1519980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1519983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1519986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1519993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520009 */     // MIs[0] policy
     /* 1520009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1520022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520043 */     // GIR_Coverage, 3632,
     /* 1520043 */     GIR_EraseRootFromParent_Done,
     /* 1520044 */   // Label 21079: @1520044
     /* 1520044 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1520130), // Rule ID 3633 //
     /* 1520049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1520066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1520072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1520079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520095 */     // MIs[0] policy
     /* 1520095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520105 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1520108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520129 */     // GIR_Coverage, 3633,
     /* 1520129 */     GIR_EraseRootFromParent_Done,
     /* 1520130 */   // Label 21080: @1520130
     /* 1520130 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1520216), // Rule ID 3636 //
     /* 1520135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1520152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1520155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1520158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1520165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520181 */     // MIs[0] policy
     /* 1520181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520191 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1520194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520215 */     // GIR_Coverage, 3636,
     /* 1520215 */     GIR_EraseRootFromParent_Done,
     /* 1520216 */   // Label 21081: @1520216
     /* 1520216 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1520302), // Rule ID 3637 //
     /* 1520221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1520238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1520244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1520251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520267 */     // MIs[0] policy
     /* 1520267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520277 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1520280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520301 */     // GIR_Coverage, 3637,
     /* 1520301 */     GIR_EraseRootFromParent_Done,
     /* 1520302 */   // Label 21082: @1520302
     /* 1520302 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1520388), // Rule ID 3640 //
     /* 1520307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1520324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1520327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1520330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1520337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520353 */     // MIs[0] policy
     /* 1520353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520363 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1520366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520387 */     // GIR_Coverage, 3640,
     /* 1520387 */     GIR_EraseRootFromParent_Done,
     /* 1520388 */   // Label 21083: @1520388
     /* 1520388 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1520474), // Rule ID 3641 //
     /* 1520393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1520410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1520416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1520423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520439 */     // MIs[0] policy
     /* 1520439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520449 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1520452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1520470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520473 */     // GIR_Coverage, 3641,
     /* 1520473 */     GIR_EraseRootFromParent_Done,
     /* 1520474 */   // Label 21084: @1520474
     /* 1520474 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1520560), // Rule ID 3644 //
     /* 1520479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1520490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1520493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1520496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1520499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1520502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1520509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520525 */     // MIs[0] policy
     /* 1520525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520535 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1520538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520559 */     // GIR_Coverage, 3644,
     /* 1520559 */     GIR_EraseRootFromParent_Done,
     /* 1520560 */   // Label 21085: @1520560
     /* 1520560 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1520646), // Rule ID 3645 //
     /* 1520565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1520576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1520579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1520582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1520588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1520595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520611 */     // MIs[0] policy
     /* 1520611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1520624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520645 */     // GIR_Coverage, 3645,
     /* 1520645 */     GIR_EraseRootFromParent_Done,
     /* 1520646 */   // Label 21086: @1520646
     /* 1520646 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1520732), // Rule ID 3648 //
     /* 1520651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1520668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1520671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1520674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1520681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520697 */     // MIs[0] policy
     /* 1520697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1520710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520731 */     // GIR_Coverage, 3648,
     /* 1520731 */     GIR_EraseRootFromParent_Done,
     /* 1520732 */   // Label 21087: @1520732
     /* 1520732 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1520818), // Rule ID 3649 //
     /* 1520737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1520754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1520760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1520767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520783 */     // MIs[0] policy
     /* 1520783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1520796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520817 */     // GIR_Coverage, 3649,
     /* 1520817 */     GIR_EraseRootFromParent_Done,
     /* 1520818 */   // Label 21088: @1520818
     /* 1520818 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1520904), // Rule ID 3652 //
     /* 1520823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1520840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1520843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1520846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1520853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520869 */     // MIs[0] policy
     /* 1520869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1520882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520903 */     // GIR_Coverage, 3652,
     /* 1520903 */     GIR_EraseRootFromParent_Done,
     /* 1520904 */   // Label 21089: @1520904
     /* 1520904 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1520990), // Rule ID 3653 //
     /* 1520909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1520912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1520917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1520926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1520929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1520932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1520939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1520951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1520955 */     // MIs[0] policy
     /* 1520955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1520968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1520972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1520978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520989 */     // GIR_Coverage, 3653,
     /* 1520989 */     GIR_EraseRootFromParent_Done,
     /* 1520990 */   // Label 21090: @1520990
     /* 1520990 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1521076), // Rule ID 3656 //
     /* 1520995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1520998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1521012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1521018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1521025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521041 */     // MIs[0] policy
     /* 1521041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1521054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521075 */     // GIR_Coverage, 3656,
     /* 1521075 */     GIR_EraseRootFromParent_Done,
     /* 1521076 */   // Label 21091: @1521076
     /* 1521076 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1521162), // Rule ID 3657 //
     /* 1521081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1521084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1521098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1521104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1521111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521127 */     // MIs[0] policy
     /* 1521127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521137 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1521140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521161 */     // GIR_Coverage, 3657,
     /* 1521161 */     GIR_EraseRootFromParent_Done,
     /* 1521162 */   // Label 21092: @1521162
     /* 1521162 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1521248), // Rule ID 3660 //
     /* 1521167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1521170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1521184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1521190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1521197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521213 */     // MIs[0] policy
     /* 1521213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521223 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1521226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521247 */     // GIR_Coverage, 3660,
     /* 1521247 */     GIR_EraseRootFromParent_Done,
     /* 1521248 */   // Label 21093: @1521248
     /* 1521248 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1521334), // Rule ID 3661 //
     /* 1521253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1521256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1521270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1521276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1521283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521299 */     // MIs[0] policy
     /* 1521299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521309 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1521312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521333 */     // GIR_Coverage, 3661,
     /* 1521333 */     GIR_EraseRootFromParent_Done,
     /* 1521334 */   // Label 21094: @1521334
     /* 1521334 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1521420), // Rule ID 3664 //
     /* 1521339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1521342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1521362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1521369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521385 */     // MIs[0] policy
     /* 1521385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1521398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521419 */     // GIR_Coverage, 3664,
     /* 1521419 */     GIR_EraseRootFromParent_Done,
     /* 1521420 */   // Label 21095: @1521420
     /* 1521420 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1521506), // Rule ID 3665 //
     /* 1521425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1521428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1521448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1521455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521471 */     // MIs[0] policy
     /* 1521471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1521484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521505 */     // GIR_Coverage, 3665,
     /* 1521505 */     GIR_EraseRootFromParent_Done,
     /* 1521506 */   // Label 21096: @1521506
     /* 1521506 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1521592), // Rule ID 3668 //
     /* 1521511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1521514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1521534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1521541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521557 */     // MIs[0] policy
     /* 1521557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1521570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521591 */     // GIR_Coverage, 3668,
     /* 1521591 */     GIR_EraseRootFromParent_Done,
     /* 1521592 */   // Label 21097: @1521592
     /* 1521592 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1521678), // Rule ID 3669 //
     /* 1521597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1521600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1521620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1521627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521643 */     // MIs[0] policy
     /* 1521643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1521656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521677 */     // GIR_Coverage, 3669,
     /* 1521677 */     GIR_EraseRootFromParent_Done,
     /* 1521678 */   // Label 21098: @1521678
     /* 1521678 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1521764), // Rule ID 3672 //
     /* 1521683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1521686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1521700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1521706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1521713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521729 */     // MIs[0] policy
     /* 1521729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521739 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1521742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521763 */     // GIR_Coverage, 3672,
     /* 1521763 */     GIR_EraseRootFromParent_Done,
     /* 1521764 */   // Label 21099: @1521764
     /* 1521764 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1521850), // Rule ID 3673 //
     /* 1521769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1521772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1521786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1521792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1521799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521815 */     // MIs[0] policy
     /* 1521815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521825 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1521828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521849 */     // GIR_Coverage, 3673,
     /* 1521849 */     GIR_EraseRootFromParent_Done,
     /* 1521850 */   // Label 21100: @1521850
     /* 1521850 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1521936), // Rule ID 3676 //
     /* 1521855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1521858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1521875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1521878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1521885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521901 */     // MIs[0] policy
     /* 1521901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521911 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1521914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1521918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1521924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521935 */     // GIR_Coverage, 3676,
     /* 1521935 */     GIR_EraseRootFromParent_Done,
     /* 1521936 */   // Label 21101: @1521936
     /* 1521936 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1522022), // Rule ID 3677 //
     /* 1521941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1521944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1521949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1521961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1521964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1521971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1521983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1521987 */     // MIs[0] policy
     /* 1521987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521997 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1522000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522021 */     // GIR_Coverage, 3677,
     /* 1522021 */     GIR_EraseRootFromParent_Done,
     /* 1522022 */   // Label 21102: @1522022
     /* 1522022 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1522108), // Rule ID 3680 //
     /* 1522027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1522038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1522041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1522044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1522047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1522050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522073 */     // MIs[0] policy
     /* 1522073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522083 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1522086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522107 */     // GIR_Coverage, 3680,
     /* 1522107 */     GIR_EraseRootFromParent_Done,
     /* 1522108 */   // Label 21103: @1522108
     /* 1522108 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1522194), // Rule ID 3681 //
     /* 1522113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1522124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1522127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1522130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1522133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1522136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522159 */     // MIs[0] policy
     /* 1522159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1522172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522193 */     // GIR_Coverage, 3681,
     /* 1522193 */     GIR_EraseRootFromParent_Done,
     /* 1522194 */   // Label 21104: @1522194
     /* 1522194 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1522280), // Rule ID 3684 //
     /* 1522199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1522216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1522219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1522222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522245 */     // MIs[0] policy
     /* 1522245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522255 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1522258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522279 */     // GIR_Coverage, 3684,
     /* 1522279 */     GIR_EraseRootFromParent_Done,
     /* 1522280 */   // Label 21105: @1522280
     /* 1522280 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1522366), // Rule ID 3685 //
     /* 1522285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1522302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1522305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1522308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522331 */     // MIs[0] policy
     /* 1522331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1522344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522365 */     // GIR_Coverage, 3685,
     /* 1522365 */     GIR_EraseRootFromParent_Done,
     /* 1522366 */   // Label 21106: @1522366
     /* 1522366 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1522452), // Rule ID 3688 //
     /* 1522371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1522388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1522391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1522394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522417 */     // MIs[0] policy
     /* 1522417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1522430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522451 */     // GIR_Coverage, 3688,
     /* 1522451 */     GIR_EraseRootFromParent_Done,
     /* 1522452 */   // Label 21107: @1522452
     /* 1522452 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1522538), // Rule ID 3689 //
     /* 1522457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1522474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1522477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1522480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1522487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522503 */     // MIs[0] policy
     /* 1522503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522513 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1522516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522537 */     // GIR_Coverage, 3689,
     /* 1522537 */     GIR_EraseRootFromParent_Done,
     /* 1522538 */   // Label 21108: @1522538
     /* 1522538 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1522624), // Rule ID 3692 //
     /* 1522543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1522560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1522563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1522566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1522573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522589 */     // MIs[0] policy
     /* 1522589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1522602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522623 */     // GIR_Coverage, 3692,
     /* 1522623 */     GIR_EraseRootFromParent_Done,
     /* 1522624 */   // Label 21109: @1522624
     /* 1522624 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1522710), // Rule ID 3693 //
     /* 1522629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1522646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1522649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1522652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1522659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522675 */     // MIs[0] policy
     /* 1522675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1522688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522709 */     // GIR_Coverage, 3693,
     /* 1522709 */     GIR_EraseRootFromParent_Done,
     /* 1522710 */   // Label 21110: @1522710
     /* 1522710 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1522796), // Rule ID 3696 //
     /* 1522715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1522732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1522735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1522738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1522745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522761 */     // MIs[0] policy
     /* 1522761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1522774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522795 */     // GIR_Coverage, 3696,
     /* 1522795 */     GIR_EraseRootFromParent_Done,
     /* 1522796 */   // Label 21111: @1522796
     /* 1522796 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1522882), // Rule ID 3697 //
     /* 1522801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1522818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1522821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1522824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1522831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522847 */     // MIs[0] policy
     /* 1522847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522857 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1522860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522881 */     // GIR_Coverage, 3697,
     /* 1522881 */     GIR_EraseRootFromParent_Done,
     /* 1522882 */   // Label 21112: @1522882
     /* 1522882 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1522968), // Rule ID 3700 //
     /* 1522887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1522890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1522904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1522907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1522910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1522917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1522933 */     // MIs[0] policy
     /* 1522933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1522946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1522950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1522956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1522964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522967 */     // GIR_Coverage, 3700,
     /* 1522967 */     GIR_EraseRootFromParent_Done,
     /* 1522968 */   // Label 21113: @1522968
     /* 1522968 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1523054), // Rule ID 3701 //
     /* 1522973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1522976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1522981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1522990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1522993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1522996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1523003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523019 */     // MIs[0] policy
     /* 1523019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1523032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1523050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523053 */     // GIR_Coverage, 3701,
     /* 1523053 */     GIR_EraseRootFromParent_Done,
     /* 1523054 */   // Label 21114: @1523054
     /* 1523054 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1523140), // Rule ID 3704 //
     /* 1523059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1523062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1523076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1523082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1523089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523105 */     // MIs[0] policy
     /* 1523105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1523118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523139 */     // GIR_Coverage, 3704,
     /* 1523139 */     GIR_EraseRootFromParent_Done,
     /* 1523140 */   // Label 21115: @1523140
     /* 1523140 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1523226), // Rule ID 3705 //
     /* 1523145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1523148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1523162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1523168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1523175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523191 */     // MIs[0] policy
     /* 1523191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523201 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1523204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523225 */     // GIR_Coverage, 3705,
     /* 1523225 */     GIR_EraseRootFromParent_Done,
     /* 1523226 */   // Label 21116: @1523226
     /* 1523226 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1523312), // Rule ID 3708 //
     /* 1523231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1523234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1523242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1523245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1523248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1523254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1523261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523277 */     // MIs[0] policy
     /* 1523277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523287 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1523290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523311 */     // GIR_Coverage, 3708,
     /* 1523311 */     GIR_EraseRootFromParent_Done,
     /* 1523312 */   // Label 21117: @1523312
     /* 1523312 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1523398), // Rule ID 3709 //
     /* 1523317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1523320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1523328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1523331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1523334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1523340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1523347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523363 */     // MIs[0] policy
     /* 1523363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1523376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523397 */     // GIR_Coverage, 3709,
     /* 1523397 */     GIR_EraseRootFromParent_Done,
     /* 1523398 */   // Label 21118: @1523398
     /* 1523398 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1523484), // Rule ID 3712 //
     /* 1523403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1523406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1523420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1523423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1523426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1523433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523449 */     // MIs[0] policy
     /* 1523449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1523462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523483 */     // GIR_Coverage, 3712,
     /* 1523483 */     GIR_EraseRootFromParent_Done,
     /* 1523484 */   // Label 21119: @1523484
     /* 1523484 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1523570), // Rule ID 3713 //
     /* 1523489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1523492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1523506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1523509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1523512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1523519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523535 */     // MIs[0] policy
     /* 1523535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1523548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523569 */     // GIR_Coverage, 3713,
     /* 1523569 */     GIR_EraseRootFromParent_Done,
     /* 1523570 */   // Label 21120: @1523570
     /* 1523570 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1523656), // Rule ID 3716 //
     /* 1523575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1523578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1523592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1523595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1523598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1523605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523621 */     // MIs[0] policy
     /* 1523621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523631 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1523634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523655 */     // GIR_Coverage, 3716,
     /* 1523655 */     GIR_EraseRootFromParent_Done,
     /* 1523656 */   // Label 21121: @1523656
     /* 1523656 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1523742), // Rule ID 3717 //
     /* 1523661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1523664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1523678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1523681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1523684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1523691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523707 */     // MIs[0] policy
     /* 1523707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1523720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523741 */     // GIR_Coverage, 3717,
     /* 1523741 */     GIR_EraseRootFromParent_Done,
     /* 1523742 */   // Label 21122: @1523742
     /* 1523742 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1523828), // Rule ID 3720 //
     /* 1523747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1523750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1523764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1523770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1523777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523793 */     // MIs[0] policy
     /* 1523793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523803 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1523806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523827 */     // GIR_Coverage, 3720,
     /* 1523827 */     GIR_EraseRootFromParent_Done,
     /* 1523828 */   // Label 21123: @1523828
     /* 1523828 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1523914), // Rule ID 3721 //
     /* 1523833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1523836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1523850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1523856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1523863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523879 */     // MIs[0] policy
     /* 1523879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523889 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1523892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523913 */     // GIR_Coverage, 3721,
     /* 1523913 */     GIR_EraseRootFromParent_Done,
     /* 1523914 */   // Label 21124: @1523914
     /* 1523914 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1524000), // Rule ID 3724 //
     /* 1523919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1523922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1523927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1523930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1523933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1523936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1523939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1523942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1523949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1523965 */     // MIs[0] policy
     /* 1523965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1523978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1523982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1523988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523999 */     // GIR_Coverage, 3724,
     /* 1523999 */     GIR_EraseRootFromParent_Done,
     /* 1524000 */   // Label 21125: @1524000
     /* 1524000 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1524086), // Rule ID 3725 //
     /* 1524005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1524008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1524022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1524028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524051 */     // MIs[0] policy
     /* 1524051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1524064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524085 */     // GIR_Coverage, 3725,
     /* 1524085 */     GIR_EraseRootFromParent_Done,
     /* 1524086 */   // Label 21126: @1524086
     /* 1524086 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1524172), // Rule ID 3728 //
     /* 1524091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1524094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1524102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1524105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1524108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1524114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1524121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524137 */     // MIs[0] policy
     /* 1524137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524147 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1524150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524171 */     // GIR_Coverage, 3728,
     /* 1524171 */     GIR_EraseRootFromParent_Done,
     /* 1524172 */   // Label 21127: @1524172
     /* 1524172 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1524258), // Rule ID 3729 //
     /* 1524177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1524180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1524188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1524191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1524194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1524200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1524207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524223 */     // MIs[0] policy
     /* 1524223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1524236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524257 */     // GIR_Coverage, 3729,
     /* 1524257 */     GIR_EraseRootFromParent_Done,
     /* 1524258 */   // Label 21128: @1524258
     /* 1524258 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1524344), // Rule ID 3732 //
     /* 1524263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1524266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1524280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1524283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1524286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1524293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524309 */     // MIs[0] policy
     /* 1524309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1524322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524343 */     // GIR_Coverage, 3732,
     /* 1524343 */     GIR_EraseRootFromParent_Done,
     /* 1524344 */   // Label 21129: @1524344
     /* 1524344 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1524430), // Rule ID 3733 //
     /* 1524349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1524352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1524366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1524369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1524372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1524379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524395 */     // MIs[0] policy
     /* 1524395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1524408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524429 */     // GIR_Coverage, 3733,
     /* 1524429 */     GIR_EraseRootFromParent_Done,
     /* 1524430 */   // Label 21130: @1524430
     /* 1524430 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1524516), // Rule ID 3736 //
     /* 1524435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1524438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1524452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1524455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1524458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1524465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524481 */     // MIs[0] policy
     /* 1524481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524491 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1524494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524515 */     // GIR_Coverage, 3736,
     /* 1524515 */     GIR_EraseRootFromParent_Done,
     /* 1524516 */   // Label 21131: @1524516
     /* 1524516 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1524602), // Rule ID 3737 //
     /* 1524521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1524524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1524538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1524541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1524544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1524551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524567 */     // MIs[0] policy
     /* 1524567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1524580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524601 */     // GIR_Coverage, 3737,
     /* 1524601 */     GIR_EraseRootFromParent_Done,
     /* 1524602 */   // Label 21132: @1524602
     /* 1524602 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1524688), // Rule ID 3740 //
     /* 1524607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1524610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1524624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1524627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1524630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1524649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524653 */     // MIs[0] policy
     /* 1524653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524663 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1524666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1524684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524687 */     // GIR_Coverage, 3740,
     /* 1524687 */     GIR_EraseRootFromParent_Done,
     /* 1524688 */   // Label 21133: @1524688
     /* 1524688 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1524774), // Rule ID 3741 //
     /* 1524693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1524696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1524710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1524713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1524716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1524735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524739 */     // MIs[0] policy
     /* 1524739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524749 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1524752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1524770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524773 */     // GIR_Coverage, 3741,
     /* 1524773 */     GIR_EraseRootFromParent_Done,
     /* 1524774 */   // Label 21134: @1524774
     /* 1524774 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1524860), // Rule ID 3744 //
     /* 1524779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1524782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1524796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1524799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1524802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1524821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524825 */     // MIs[0] policy
     /* 1524825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1524838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1524856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524859 */     // GIR_Coverage, 3744,
     /* 1524859 */     GIR_EraseRootFromParent_Done,
     /* 1524860 */   // Label 21135: @1524860
     /* 1524860 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1524946), // Rule ID 3745 //
     /* 1524865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1524868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1524882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1524885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1524888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1524907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524911 */     // MIs[0] policy
     /* 1524911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1524924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1524928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1524934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1524942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524945 */     // GIR_Coverage, 3745,
     /* 1524945 */     GIR_EraseRootFromParent_Done,
     /* 1524946 */   // Label 21136: @1524946
     /* 1524946 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1525032), // Rule ID 3748 //
     /* 1524951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1524954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1524959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1524968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1524971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1524974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1524981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1524993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1524997 */     // MIs[0] policy
     /* 1524997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525007 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1525010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525031 */     // GIR_Coverage, 3748,
     /* 1525031 */     GIR_EraseRootFromParent_Done,
     /* 1525032 */   // Label 21137: @1525032
     /* 1525032 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1525118), // Rule ID 3749 //
     /* 1525037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1525048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1525051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1525054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1525060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1525067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525083 */     // MIs[0] policy
     /* 1525083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525093 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1525096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525117 */     // GIR_Coverage, 3749,
     /* 1525117 */     GIR_EraseRootFromParent_Done,
     /* 1525118 */   // Label 21138: @1525118
     /* 1525118 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1525204), // Rule ID 3752 //
     /* 1525123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1525140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1525143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1525146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1525153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525169 */     // MIs[0] policy
     /* 1525169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1525182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525203 */     // GIR_Coverage, 3752,
     /* 1525203 */     GIR_EraseRootFromParent_Done,
     /* 1525204 */   // Label 21139: @1525204
     /* 1525204 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1525290), // Rule ID 3753 //
     /* 1525209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1525226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1525232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1525239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525255 */     // MIs[0] policy
     /* 1525255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1525268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525289 */     // GIR_Coverage, 3753,
     /* 1525289 */     GIR_EraseRootFromParent_Done,
     /* 1525290 */   // Label 21140: @1525290
     /* 1525290 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1525376), // Rule ID 3756 //
     /* 1525295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1525312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1525315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1525318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1525325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525341 */     // MIs[0] policy
     /* 1525341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525351 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1525354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525375 */     // GIR_Coverage, 3756,
     /* 1525375 */     GIR_EraseRootFromParent_Done,
     /* 1525376 */   // Label 21141: @1525376
     /* 1525376 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1525462), // Rule ID 3757 //
     /* 1525381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1525398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1525404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1525411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525427 */     // MIs[0] policy
     /* 1525427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525437 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1525440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525461 */     // GIR_Coverage, 3757,
     /* 1525461 */     GIR_EraseRootFromParent_Done,
     /* 1525462 */   // Label 21142: @1525462
     /* 1525462 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1525548), // Rule ID 3760 //
     /* 1525467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1525484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1525487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1525490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1525497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525513 */     // MIs[0] policy
     /* 1525513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525523 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1525526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525547 */     // GIR_Coverage, 3760,
     /* 1525547 */     GIR_EraseRootFromParent_Done,
     /* 1525548 */   // Label 21143: @1525548
     /* 1525548 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1525634), // Rule ID 3761 //
     /* 1525553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1525570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1525576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1525583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525599 */     // MIs[0] policy
     /* 1525599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1525612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1525630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525633 */     // GIR_Coverage, 3761,
     /* 1525633 */     GIR_EraseRootFromParent_Done,
     /* 1525634 */   // Label 21144: @1525634
     /* 1525634 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1525720), // Rule ID 3764 //
     /* 1525639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1525650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1525653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1525656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1525659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1525662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1525669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525685 */     // MIs[0] policy
     /* 1525685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525695 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1525698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525719 */     // GIR_Coverage, 3764,
     /* 1525719 */     GIR_EraseRootFromParent_Done,
     /* 1525720 */   // Label 21145: @1525720
     /* 1525720 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1525806), // Rule ID 3765 //
     /* 1525725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1525736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1525739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1525742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1525748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1525755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525771 */     // MIs[0] policy
     /* 1525771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1525784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525805 */     // GIR_Coverage, 3765,
     /* 1525805 */     GIR_EraseRootFromParent_Done,
     /* 1525806 */   // Label 21146: @1525806
     /* 1525806 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1525892), // Rule ID 3768 //
     /* 1525811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1525822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1525825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1525828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1525831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1525834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1525841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525857 */     // MIs[0] policy
     /* 1525857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525867 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1525870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525891 */     // GIR_Coverage, 3768,
     /* 1525891 */     GIR_EraseRootFromParent_Done,
     /* 1525892 */   // Label 21147: @1525892
     /* 1525892 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1525978), // Rule ID 3769 //
     /* 1525897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1525900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1525908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1525911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1525914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1525917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1525920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1525927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1525939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1525943 */     // MIs[0] policy
     /* 1525943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525953 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1525956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1525960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1525966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525977 */     // GIR_Coverage, 3769,
     /* 1525977 */     GIR_EraseRootFromParent_Done,
     /* 1525978 */   // Label 21148: @1525978
     /* 1525978 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1526064), // Rule ID 3772 //
     /* 1525983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1525986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1525991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1526006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1526013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526029 */     // MIs[0] policy
     /* 1526029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1526042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526063 */     // GIR_Coverage, 3772,
     /* 1526063 */     GIR_EraseRootFromParent_Done,
     /* 1526064 */   // Label 21149: @1526064
     /* 1526064 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1526150), // Rule ID 3773 //
     /* 1526069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1526072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1526080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1526083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1526092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1526099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526115 */     // MIs[0] policy
     /* 1526115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1526128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526149 */     // GIR_Coverage, 3773,
     /* 1526149 */     GIR_EraseRootFromParent_Done,
     /* 1526150 */   // Label 21150: @1526150
     /* 1526150 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1526236), // Rule ID 3776 //
     /* 1526155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1526158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1526166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1526169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1526172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1526178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1526185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526201 */     // MIs[0] policy
     /* 1526201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1526214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526235 */     // GIR_Coverage, 3776,
     /* 1526235 */     GIR_EraseRootFromParent_Done,
     /* 1526236 */   // Label 21151: @1526236
     /* 1526236 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1526322), // Rule ID 3777 //
     /* 1526241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1526244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1526252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1526255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1526258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1526264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1526271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526287 */     // MIs[0] policy
     /* 1526287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526297 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1526300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526321 */     // GIR_Coverage, 3777,
     /* 1526321 */     GIR_EraseRootFromParent_Done,
     /* 1526322 */   // Label 21152: @1526322
     /* 1526322 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1526408), // Rule ID 3780 //
     /* 1526327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1526330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1526344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1526350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1526357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526373 */     // MIs[0] policy
     /* 1526373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526383 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1526386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526407 */     // GIR_Coverage, 3780,
     /* 1526407 */     GIR_EraseRootFromParent_Done,
     /* 1526408 */   // Label 21153: @1526408
     /* 1526408 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1526494), // Rule ID 3781 //
     /* 1526413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1526416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1526430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1526436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1526443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526459 */     // MIs[0] policy
     /* 1526459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526469 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1526472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526493 */     // GIR_Coverage, 3781,
     /* 1526493 */     GIR_EraseRootFromParent_Done,
     /* 1526494 */   // Label 21154: @1526494
     /* 1526494 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1526580), // Rule ID 3784 //
     /* 1526499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1526502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1526522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1526529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526545 */     // MIs[0] policy
     /* 1526545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526555 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1526558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526579 */     // GIR_Coverage, 3784,
     /* 1526579 */     GIR_EraseRootFromParent_Done,
     /* 1526580 */   // Label 21155: @1526580
     /* 1526580 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1526666), // Rule ID 3785 //
     /* 1526585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1526588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1526608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1526615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526631 */     // MIs[0] policy
     /* 1526631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1526644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526665 */     // GIR_Coverage, 3785,
     /* 1526665 */     GIR_EraseRootFromParent_Done,
     /* 1526666 */   // Label 21156: @1526666
     /* 1526666 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1526752), // Rule ID 3788 //
     /* 1526671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1526674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1526694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1526701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526717 */     // MIs[0] policy
     /* 1526717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1526730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526751 */     // GIR_Coverage, 3788,
     /* 1526751 */     GIR_EraseRootFromParent_Done,
     /* 1526752 */   // Label 21157: @1526752
     /* 1526752 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1526838), // Rule ID 3789 //
     /* 1526757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1526760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1526780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1526787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526803 */     // MIs[0] policy
     /* 1526803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1526816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526837 */     // GIR_Coverage, 3789,
     /* 1526837 */     GIR_EraseRootFromParent_Done,
     /* 1526838 */   // Label 21158: @1526838
     /* 1526838 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1526924), // Rule ID 3792 //
     /* 1526843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1526846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1526860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1526863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1526866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1526873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526889 */     // MIs[0] policy
     /* 1526889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526899 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1526902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526923 */     // GIR_Coverage, 3792,
     /* 1526923 */     GIR_EraseRootFromParent_Done,
     /* 1526924 */   // Label 21159: @1526924
     /* 1526924 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1527010), // Rule ID 3793 //
     /* 1526929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1526932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1526937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1526946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1526949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1526952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1526959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1526971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1526975 */     // MIs[0] policy
     /* 1526975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526985 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1526988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1526992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1526998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527009 */     // GIR_Coverage, 3793,
     /* 1527009 */     GIR_EraseRootFromParent_Done,
     /* 1527010 */   // Label 21160: @1527010
     /* 1527010 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1527096), // Rule ID 3796 //
     /* 1527015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1527018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1527023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1527026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1527029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1527035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1527038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1527045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1527057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527061 */     // MIs[0] policy
     /* 1527061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527071 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1527074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527095 */     // GIR_Coverage, 3796,
     /* 1527095 */     GIR_EraseRootFromParent_Done,
     /* 1527096 */   // Label 21161: @1527096
     /* 1527096 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1527182), // Rule ID 3797 //
     /* 1527101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1527104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1527109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1527112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1527115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1527121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1527124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1527131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1527143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527147 */     // MIs[0] policy
     /* 1527147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527157 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1527160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527181 */     // GIR_Coverage, 3797,
     /* 1527181 */     GIR_EraseRootFromParent_Done,
     /* 1527182 */   // Label 21162: @1527182
     /* 1527182 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1527268), // Rule ID 3800 //
     /* 1527187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1527190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1527198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1527201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1527204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1527207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1527210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527233 */     // MIs[0] policy
     /* 1527233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1527246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527267 */     // GIR_Coverage, 3800,
     /* 1527267 */     GIR_EraseRootFromParent_Done,
     /* 1527268 */   // Label 21163: @1527268
     /* 1527268 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1527354), // Rule ID 3801 //
     /* 1527273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1527276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1527284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1527287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1527290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1527293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1527296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527319 */     // MIs[0] policy
     /* 1527319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1527332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527353 */     // GIR_Coverage, 3801,
     /* 1527353 */     GIR_EraseRootFromParent_Done,
     /* 1527354 */   // Label 21164: @1527354
     /* 1527354 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1527440), // Rule ID 3804 //
     /* 1527359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1527362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1527370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1527373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1527376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1527379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1527382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527405 */     // MIs[0] policy
     /* 1527405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527415 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1527418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527439 */     // GIR_Coverage, 3804,
     /* 1527439 */     GIR_EraseRootFromParent_Done,
     /* 1527440 */   // Label 21165: @1527440
     /* 1527440 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1527526), // Rule ID 3805 //
     /* 1527445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1527448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1527456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1527459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1527462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1527465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1527468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527491 */     // MIs[0] policy
     /* 1527491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1527504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527525 */     // GIR_Coverage, 3805,
     /* 1527525 */     GIR_EraseRootFromParent_Done,
     /* 1527526 */   // Label 21166: @1527526
     /* 1527526 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1527612), // Rule ID 3808 //
     /* 1527531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1527534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1527548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1527551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1527554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527577 */     // MIs[0] policy
     /* 1527577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527587 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1527590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527611 */     // GIR_Coverage, 3808,
     /* 1527611 */     GIR_EraseRootFromParent_Done,
     /* 1527612 */   // Label 21167: @1527612
     /* 1527612 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1527698), // Rule ID 3809 //
     /* 1527617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1527620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1527634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1527637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1527640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1527647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527663 */     // MIs[0] policy
     /* 1527663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527673 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1527676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527697 */     // GIR_Coverage, 3809,
     /* 1527697 */     GIR_EraseRootFromParent_Done,
     /* 1527698 */   // Label 21168: @1527698
     /* 1527698 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1527784), // Rule ID 3812 //
     /* 1527703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1527706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1527720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1527723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1527726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1527733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527749 */     // MIs[0] policy
     /* 1527749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1527762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527783 */     // GIR_Coverage, 3812,
     /* 1527783 */     GIR_EraseRootFromParent_Done,
     /* 1527784 */   // Label 21169: @1527784
     /* 1527784 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1527870), // Rule ID 3813 //
     /* 1527789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1527792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1527806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1527809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1527812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1527819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527835 */     // MIs[0] policy
     /* 1527835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1527848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527869 */     // GIR_Coverage, 3813,
     /* 1527869 */     GIR_EraseRootFromParent_Done,
     /* 1527870 */   // Label 21170: @1527870
     /* 1527870 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1527956), // Rule ID 3816 //
     /* 1527875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1527878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1527892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1527895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1527898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1527905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1527921 */     // MIs[0] policy
     /* 1527921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527931 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1527934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1527938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1527944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1527952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527955 */     // GIR_Coverage, 3816,
     /* 1527955 */     GIR_EraseRootFromParent_Done,
     /* 1527956 */   // Label 21171: @1527956
     /* 1527956 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1528042), // Rule ID 3817 //
     /* 1527961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1527964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1527969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1527978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1527981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1527984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1527991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528007 */     // MIs[0] policy
     /* 1528007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1528020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1528038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528041 */     // GIR_Coverage, 3817,
     /* 1528041 */     GIR_EraseRootFromParent_Done,
     /* 1528042 */   // Label 21172: @1528042
     /* 1528042 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1528128), // Rule ID 3820 //
     /* 1528047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1528064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1528067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1528070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1528077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528093 */     // MIs[0] policy
     /* 1528093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528103 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1528106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1528124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528127 */     // GIR_Coverage, 3820,
     /* 1528127 */     GIR_EraseRootFromParent_Done,
     /* 1528128 */   // Label 21173: @1528128
     /* 1528128 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1528214), // Rule ID 3821 //
     /* 1528133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1528150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1528153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1528156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1528163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528179 */     // MIs[0] policy
     /* 1528179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528189 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1528192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1528210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528213 */     // GIR_Coverage, 3821,
     /* 1528213 */     GIR_EraseRootFromParent_Done,
     /* 1528214 */   // Label 21174: @1528214
     /* 1528214 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1528300), // Rule ID 3824 //
     /* 1528219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1528236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1528242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1528249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528265 */     // MIs[0] policy
     /* 1528265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528275 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1528278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528299 */     // GIR_Coverage, 3824,
     /* 1528299 */     GIR_EraseRootFromParent_Done,
     /* 1528300 */   // Label 21175: @1528300
     /* 1528300 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1528386), // Rule ID 3825 //
     /* 1528305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1528322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1528328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1528335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528351 */     // MIs[0] policy
     /* 1528351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528361 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1528364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528385 */     // GIR_Coverage, 3825,
     /* 1528385 */     GIR_EraseRootFromParent_Done,
     /* 1528386 */   // Label 21176: @1528386
     /* 1528386 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1528472), // Rule ID 3828 //
     /* 1528391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1528402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1528405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1528408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1528414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1528421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528437 */     // MIs[0] policy
     /* 1528437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528447 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1528450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528471 */     // GIR_Coverage, 3828,
     /* 1528471 */     GIR_EraseRootFromParent_Done,
     /* 1528472 */   // Label 21177: @1528472
     /* 1528472 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1528558), // Rule ID 3829 //
     /* 1528477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1528488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1528491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1528494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1528500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1528507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528523 */     // MIs[0] policy
     /* 1528523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1528536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528557 */     // GIR_Coverage, 3829,
     /* 1528557 */     GIR_EraseRootFromParent_Done,
     /* 1528558 */   // Label 21178: @1528558
     /* 1528558 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1528644), // Rule ID 3832 //
     /* 1528563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1528580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1528583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1528586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1528593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528609 */     // MIs[0] policy
     /* 1528609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1528622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528643 */     // GIR_Coverage, 3832,
     /* 1528643 */     GIR_EraseRootFromParent_Done,
     /* 1528644 */   // Label 21179: @1528644
     /* 1528644 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1528730), // Rule ID 3833 //
     /* 1528649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1528666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1528669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1528672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1528679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528695 */     // MIs[0] policy
     /* 1528695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1528708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528729 */     // GIR_Coverage, 3833,
     /* 1528729 */     GIR_EraseRootFromParent_Done,
     /* 1528730 */   // Label 21180: @1528730
     /* 1528730 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1528816), // Rule ID 3836 //
     /* 1528735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1528752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1528755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1528758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1528765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528781 */     // MIs[0] policy
     /* 1528781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1528794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528815 */     // GIR_Coverage, 3836,
     /* 1528815 */     GIR_EraseRootFromParent_Done,
     /* 1528816 */   // Label 21181: @1528816
     /* 1528816 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1528902), // Rule ID 3837 //
     /* 1528821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1528838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1528841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1528844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1528851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528867 */     // MIs[0] policy
     /* 1528867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528877 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1528880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528901 */     // GIR_Coverage, 3837,
     /* 1528901 */     GIR_EraseRootFromParent_Done,
     /* 1528902 */   // Label 21182: @1528902
     /* 1528902 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1528988), // Rule ID 3840 //
     /* 1528907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1528910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1528915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1528924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1528927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1528930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1528937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1528953 */     // MIs[0] policy
     /* 1528953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528963 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1528966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1528970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1528976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528987 */     // GIR_Coverage, 3840,
     /* 1528987 */     GIR_EraseRootFromParent_Done,
     /* 1528988 */   // Label 21183: @1528988
     /* 1528988 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1529074), // Rule ID 3841 //
     /* 1528993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1528996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1529004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1529007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1529010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1529016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1529023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529039 */     // MIs[0] policy
     /* 1529039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529049 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1529052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529073 */     // GIR_Coverage, 3841,
     /* 1529073 */     GIR_EraseRootFromParent_Done,
     /* 1529074 */   // Label 21184: @1529074
     /* 1529074 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1529160), // Rule ID 3844 //
     /* 1529079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1529082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1529102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1529109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529125 */     // MIs[0] policy
     /* 1529125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529135 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1529138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529159 */     // GIR_Coverage, 3844,
     /* 1529159 */     GIR_EraseRootFromParent_Done,
     /* 1529160 */   // Label 21185: @1529160
     /* 1529160 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1529246), // Rule ID 3845 //
     /* 1529165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1529168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1529188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1529195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529211 */     // MIs[0] policy
     /* 1529211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1529224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529245 */     // GIR_Coverage, 3845,
     /* 1529245 */     GIR_EraseRootFromParent_Done,
     /* 1529246 */   // Label 21186: @1529246
     /* 1529246 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1529332), // Rule ID 3848 //
     /* 1529251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1529254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1529262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1529265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1529274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1529281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529297 */     // MIs[0] policy
     /* 1529297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1529310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529331 */     // GIR_Coverage, 3848,
     /* 1529331 */     GIR_EraseRootFromParent_Done,
     /* 1529332 */   // Label 21187: @1529332
     /* 1529332 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1529418), // Rule ID 3849 //
     /* 1529337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1529340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1529348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1529351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1529360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1529367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529383 */     // MIs[0] policy
     /* 1529383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1529396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529417 */     // GIR_Coverage, 3849,
     /* 1529417 */     GIR_EraseRootFromParent_Done,
     /* 1529418 */   // Label 21188: @1529418
     /* 1529418 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1529504), // Rule ID 3852 //
     /* 1529423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1529426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1529434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1529437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1529440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1529443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1529446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1529453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529469 */     // MIs[0] policy
     /* 1529469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529479 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1529482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529503 */     // GIR_Coverage, 3852,
     /* 1529503 */     GIR_EraseRootFromParent_Done,
     /* 1529504 */   // Label 21189: @1529504
     /* 1529504 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1529590), // Rule ID 3853 //
     /* 1529509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1529512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1529520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1529523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1529526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1529529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1529532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1529539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529555 */     // MIs[0] policy
     /* 1529555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1529568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529589 */     // GIR_Coverage, 3853,
     /* 1529589 */     GIR_EraseRootFromParent_Done,
     /* 1529590 */   // Label 21190: @1529590
     /* 1529590 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1529676), // Rule ID 3856 //
     /* 1529595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1529598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1529612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1529615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1529618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1529625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529641 */     // MIs[0] policy
     /* 1529641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1529654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529675 */     // GIR_Coverage, 3856,
     /* 1529675 */     GIR_EraseRootFromParent_Done,
     /* 1529676 */   // Label 21191: @1529676
     /* 1529676 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1529762), // Rule ID 3857 //
     /* 1529681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1529684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1529698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1529701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1529704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1529711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529727 */     // MIs[0] policy
     /* 1529727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1529740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529761 */     // GIR_Coverage, 3857,
     /* 1529761 */     GIR_EraseRootFromParent_Done,
     /* 1529762 */   // Label 21192: @1529762
     /* 1529762 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1529848), // Rule ID 3860 //
     /* 1529767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1529770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1529784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1529787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1529790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1529797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1529809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529813 */     // MIs[0] policy
     /* 1529813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1529826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1529844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529847 */     // GIR_Coverage, 3860,
     /* 1529847 */     GIR_EraseRootFromParent_Done,
     /* 1529848 */   // Label 21193: @1529848
     /* 1529848 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1529934), // Rule ID 3861 //
     /* 1529853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1529856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1529870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1529873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1529876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1529883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1529895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529899 */     // MIs[0] policy
     /* 1529899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1529912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1529916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1529922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1529930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529933 */     // GIR_Coverage, 3861,
     /* 1529933 */     GIR_EraseRootFromParent_Done,
     /* 1529934 */   // Label 21194: @1529934
     /* 1529934 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1530020), // Rule ID 3864 //
     /* 1529939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1529942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1529947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1529956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1529959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1529962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1529969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1529981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1529985 */     // MIs[0] policy
     /* 1529985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529995 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1529998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530019 */     // GIR_Coverage, 3864,
     /* 1530019 */     GIR_EraseRootFromParent_Done,
     /* 1530020 */   // Label 21195: @1530020
     /* 1530020 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1530106), // Rule ID 3865 //
     /* 1530025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1530036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1530039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1530042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1530048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1530055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530071 */     // MIs[0] policy
     /* 1530071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530081 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1530084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530105 */     // GIR_Coverage, 3865,
     /* 1530105 */     GIR_EraseRootFromParent_Done,
     /* 1530106 */   // Label 21196: @1530106
     /* 1530106 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1530192), // Rule ID 3868 //
     /* 1530111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1530122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1530125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1530128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1530134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1530141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530157 */     // MIs[0] policy
     /* 1530157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530167 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1530170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530191 */     // GIR_Coverage, 3868,
     /* 1530191 */     GIR_EraseRootFromParent_Done,
     /* 1530192 */   // Label 21197: @1530192
     /* 1530192 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1530278), // Rule ID 3869 //
     /* 1530197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1530208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1530211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1530214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1530220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1530227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530243 */     // MIs[0] policy
     /* 1530243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530253 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1530256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530277 */     // GIR_Coverage, 3869,
     /* 1530277 */     GIR_EraseRootFromParent_Done,
     /* 1530278 */   // Label 21198: @1530278
     /* 1530278 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1530364), // Rule ID 3872 //
     /* 1530283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1530300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1530306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1530313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530329 */     // MIs[0] policy
     /* 1530329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1530342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530363 */     // GIR_Coverage, 3872,
     /* 1530363 */     GIR_EraseRootFromParent_Done,
     /* 1530364 */   // Label 21199: @1530364
     /* 1530364 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1530450), // Rule ID 3873 //
     /* 1530369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1530386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1530392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1530399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530415 */     // MIs[0] policy
     /* 1530415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1530428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530449 */     // GIR_Coverage, 3873,
     /* 1530449 */     GIR_EraseRootFromParent_Done,
     /* 1530450 */   // Label 21200: @1530450
     /* 1530450 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1530536), // Rule ID 3876 //
     /* 1530455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1530472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1530478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1530485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530501 */     // MIs[0] policy
     /* 1530501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1530514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530535 */     // GIR_Coverage, 3876,
     /* 1530535 */     GIR_EraseRootFromParent_Done,
     /* 1530536 */   // Label 21201: @1530536
     /* 1530536 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1530622), // Rule ID 3877 //
     /* 1530541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1530558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1530564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1530571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530587 */     // MIs[0] policy
     /* 1530587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530597 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1530600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530621 */     // GIR_Coverage, 3877,
     /* 1530621 */     GIR_EraseRootFromParent_Done,
     /* 1530622 */   // Label 21202: @1530622
     /* 1530622 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1530708), // Rule ID 3880 //
     /* 1530627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1530644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1530650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1530657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530673 */     // MIs[0] policy
     /* 1530673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530683 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1530686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530707 */     // GIR_Coverage, 3880,
     /* 1530707 */     GIR_EraseRootFromParent_Done,
     /* 1530708 */   // Label 21203: @1530708
     /* 1530708 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1530794), // Rule ID 3881 //
     /* 1530713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1530730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1530736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1530743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530759 */     // MIs[0] policy
     /* 1530759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530769 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1530772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1530790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530793 */     // GIR_Coverage, 3881,
     /* 1530793 */     GIR_EraseRootFromParent_Done,
     /* 1530794 */   // Label 21204: @1530794
     /* 1530794 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1530880), // Rule ID 3884 //
     /* 1530799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1530810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1530813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1530816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1530822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1530829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530845 */     // MIs[0] policy
     /* 1530845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530855 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1530858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530879 */     // GIR_Coverage, 3884,
     /* 1530879 */     GIR_EraseRootFromParent_Done,
     /* 1530880 */   // Label 21205: @1530880
     /* 1530880 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1530966), // Rule ID 3885 //
     /* 1530885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1530888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1530896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1530899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1530902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1530905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1530908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1530915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1530927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1530931 */     // MIs[0] policy
     /* 1530931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530941 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1530944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1530948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1530954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530965 */     // GIR_Coverage, 3885,
     /* 1530965 */     GIR_EraseRootFromParent_Done,
     /* 1530966 */   // Label 21206: @1530966
     /* 1530966 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1531052), // Rule ID 3888 //
     /* 1530971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1530974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1530979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1530982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1530985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1530988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1530991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1530994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1531001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531017 */     // MIs[0] policy
     /* 1531017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1531030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531051 */     // GIR_Coverage, 3888,
     /* 1531051 */     GIR_EraseRootFromParent_Done,
     /* 1531052 */   // Label 21207: @1531052
     /* 1531052 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1531138), // Rule ID 3889 //
     /* 1531057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1531060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1531080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1531087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531103 */     // MIs[0] policy
     /* 1531103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531113 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1531116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531137 */     // GIR_Coverage, 3889,
     /* 1531137 */     GIR_EraseRootFromParent_Done,
     /* 1531138 */   // Label 21208: @1531138
     /* 1531138 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1531224), // Rule ID 3892 //
     /* 1531143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1531146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1531154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1531157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1531163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1531166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1531173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531189 */     // MIs[0] policy
     /* 1531189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1531202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531223 */     // GIR_Coverage, 3892,
     /* 1531223 */     GIR_EraseRootFromParent_Done,
     /* 1531224 */   // Label 21209: @1531224
     /* 1531224 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1531310), // Rule ID 3893 //
     /* 1531229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1531232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1531240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1531243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1531252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1531259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531275 */     // MIs[0] policy
     /* 1531275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1531288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531309 */     // GIR_Coverage, 3893,
     /* 1531309 */     GIR_EraseRootFromParent_Done,
     /* 1531310 */   // Label 21210: @1531310
     /* 1531310 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1531396), // Rule ID 3896 //
     /* 1531315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1531318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1531326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1531329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1531332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1531335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1531338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1531345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531361 */     // MIs[0] policy
     /* 1531361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1531374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531395 */     // GIR_Coverage, 3896,
     /* 1531395 */     GIR_EraseRootFromParent_Done,
     /* 1531396 */   // Label 21211: @1531396
     /* 1531396 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1531482), // Rule ID 3897 //
     /* 1531401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1531404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1531412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1531415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1531418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1531424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1531431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531447 */     // MIs[0] policy
     /* 1531447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531457 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1531460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531481 */     // GIR_Coverage, 3897,
     /* 1531481 */     GIR_EraseRootFromParent_Done,
     /* 1531482 */   // Label 21212: @1531482
     /* 1531482 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1531568), // Rule ID 3900 //
     /* 1531487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1531490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1531504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1531507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1531510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1531517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531533 */     // MIs[0] policy
     /* 1531533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531543 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1531546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531567 */     // GIR_Coverage, 3900,
     /* 1531567 */     GIR_EraseRootFromParent_Done,
     /* 1531568 */   // Label 21213: @1531568
     /* 1531568 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1531654), // Rule ID 3901 //
     /* 1531573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1531576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1531590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1531596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1531603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531619 */     // MIs[0] policy
     /* 1531619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531629 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1531632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531653 */     // GIR_Coverage, 3901,
     /* 1531653 */     GIR_EraseRootFromParent_Done,
     /* 1531654 */   // Label 21214: @1531654
     /* 1531654 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1531740), // Rule ID 3904 //
     /* 1531659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1531662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1531679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1531682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1531689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531705 */     // MIs[0] policy
     /* 1531705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1531718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531739 */     // GIR_Coverage, 3904,
     /* 1531739 */     GIR_EraseRootFromParent_Done,
     /* 1531740 */   // Label 21215: @1531740
     /* 1531740 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1531826), // Rule ID 3905 //
     /* 1531745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1531748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1531768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1531775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531791 */     // MIs[0] policy
     /* 1531791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1531804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531825 */     // GIR_Coverage, 3905,
     /* 1531825 */     GIR_EraseRootFromParent_Done,
     /* 1531826 */   // Label 21216: @1531826
     /* 1531826 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1531912), // Rule ID 3908 //
     /* 1531831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1531834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1531851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1531854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1531861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531877 */     // MIs[0] policy
     /* 1531877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1531890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531911 */     // GIR_Coverage, 3908,
     /* 1531911 */     GIR_EraseRootFromParent_Done,
     /* 1531912 */   // Label 21217: @1531912
     /* 1531912 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1531998), // Rule ID 3909 //
     /* 1531917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1531920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1531925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1531937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1531940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1531947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1531959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1531963 */     // MIs[0] policy
     /* 1531963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1531976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1531980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1531986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531997 */     // GIR_Coverage, 3909,
     /* 1531997 */     GIR_EraseRootFromParent_Done,
     /* 1531998 */   // Label 21218: @1531998
     /* 1531998 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1532084), // Rule ID 3912 //
     /* 1532003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1532006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1532011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1532014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1532017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1532023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1532026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1532033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1532045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532049 */     // MIs[0] policy
     /* 1532049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1532062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532083 */     // GIR_Coverage, 3912,
     /* 1532083 */     GIR_EraseRootFromParent_Done,
     /* 1532084 */   // Label 21219: @1532084
     /* 1532084 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1532170), // Rule ID 3913 //
     /* 1532089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1532092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1532097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1532100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1532103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1532109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1532112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1532119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1532131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532135 */     // MIs[0] policy
     /* 1532135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1532148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532169 */     // GIR_Coverage, 3913,
     /* 1532169 */     GIR_EraseRootFromParent_Done,
     /* 1532170 */   // Label 21220: @1532170
     /* 1532170 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1532256), // Rule ID 3916 //
     /* 1532175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1532178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1532183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1532186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1532189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1532195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1532198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1532205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1532217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532221 */     // MIs[0] policy
     /* 1532221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1532234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532255 */     // GIR_Coverage, 3916,
     /* 1532255 */     GIR_EraseRootFromParent_Done,
     /* 1532256 */   // Label 21221: @1532256
     /* 1532256 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1532342), // Rule ID 3917 //
     /* 1532261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1532264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1532269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1532272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1532275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1532281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1532284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1532291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1532303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532307 */     // MIs[0] policy
     /* 1532307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532317 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1532320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532341 */     // GIR_Coverage, 3917,
     /* 1532341 */     GIR_EraseRootFromParent_Done,
     /* 1532342 */   // Label 21222: @1532342
     /* 1532342 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1532428), // Rule ID 3926 //
     /* 1532347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1532350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1532358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1532361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1532364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1532367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1532370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1532377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532393 */     // MIs[0] policy
     /* 1532393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532403 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1532406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532427 */     // GIR_Coverage, 3926,
     /* 1532427 */     GIR_EraseRootFromParent_Done,
     /* 1532428 */   // Label 21223: @1532428
     /* 1532428 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1532514), // Rule ID 3927 //
     /* 1532433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1532436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1532444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1532447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1532450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1532453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1532456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1532463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532479 */     // MIs[0] policy
     /* 1532479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532489 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1532492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532513 */     // GIR_Coverage, 3927,
     /* 1532513 */     GIR_EraseRootFromParent_Done,
     /* 1532514 */   // Label 21224: @1532514
     /* 1532514 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1532600), // Rule ID 3936 //
     /* 1532519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1532522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1532536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1532539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1532542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1532549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532565 */     // MIs[0] policy
     /* 1532565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1532578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532599 */     // GIR_Coverage, 3936,
     /* 1532599 */     GIR_EraseRootFromParent_Done,
     /* 1532600 */   // Label 21225: @1532600
     /* 1532600 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1532686), // Rule ID 3937 //
     /* 1532605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1532608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1532622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1532625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1532628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1532635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532651 */     // MIs[0] policy
     /* 1532651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1532664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532685 */     // GIR_Coverage, 3937,
     /* 1532685 */     GIR_EraseRootFromParent_Done,
     /* 1532686 */   // Label 21226: @1532686
     /* 1532686 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1532772), // Rule ID 3946 //
     /* 1532691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1532694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1532711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1532714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1532721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532737 */     // MIs[0] policy
     /* 1532737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532747 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1532750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532771 */     // GIR_Coverage, 3946,
     /* 1532771 */     GIR_EraseRootFromParent_Done,
     /* 1532772 */   // Label 21227: @1532772
     /* 1532772 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1532858), // Rule ID 3947 //
     /* 1532777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1532780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1532797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1532800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1532807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532823 */     // MIs[0] policy
     /* 1532823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1532836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532857 */     // GIR_Coverage, 3947,
     /* 1532857 */     GIR_EraseRootFromParent_Done,
     /* 1532858 */   // Label 21228: @1532858
     /* 1532858 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1532944), // Rule ID 3956 //
     /* 1532863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1532866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1532883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1532886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1532893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532909 */     // MIs[0] policy
     /* 1532909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1532922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1532926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1532932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1532940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532943 */     // GIR_Coverage, 3956,
     /* 1532943 */     GIR_EraseRootFromParent_Done,
     /* 1532944 */   // Label 21229: @1532944
     /* 1532944 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1533030), // Rule ID 3957 //
     /* 1532949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1532952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1532957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1532969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1532972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1532979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1532995 */     // MIs[0] policy
     /* 1532995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533005 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1533008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1533026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533029 */     // GIR_Coverage, 3957,
     /* 1533029 */     GIR_EraseRootFromParent_Done,
     /* 1533030 */   // Label 21230: @1533030
     /* 1533030 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1533116), // Rule ID 3966 //
     /* 1533035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1533052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1533055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1533058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1533065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533081 */     // MIs[0] policy
     /* 1533081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533091 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1533094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1533112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533115 */     // GIR_Coverage, 3966,
     /* 1533115 */     GIR_EraseRootFromParent_Done,
     /* 1533116 */   // Label 21231: @1533116
     /* 1533116 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1533202), // Rule ID 3967 //
     /* 1533121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1533138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1533141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1533144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1533151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533167 */     // MIs[0] policy
     /* 1533167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1533180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1533198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533201 */     // GIR_Coverage, 3967,
     /* 1533201 */     GIR_EraseRootFromParent_Done,
     /* 1533202 */   // Label 21232: @1533202
     /* 1533202 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1533288), // Rule ID 3976 //
     /* 1533207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1533224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1533230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1533237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533253 */     // MIs[0] policy
     /* 1533253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1533266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533287 */     // GIR_Coverage, 3976,
     /* 1533287 */     GIR_EraseRootFromParent_Done,
     /* 1533288 */   // Label 21233: @1533288
     /* 1533288 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1533374), // Rule ID 3977 //
     /* 1533293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1533310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1533316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1533323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533339 */     // MIs[0] policy
     /* 1533339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533349 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1533352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533373 */     // GIR_Coverage, 3977,
     /* 1533373 */     GIR_EraseRootFromParent_Done,
     /* 1533374 */   // Label 21234: @1533374
     /* 1533374 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1533460), // Rule ID 3986 //
     /* 1533379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1533390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1533393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1533396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1533402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1533409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533425 */     // MIs[0] policy
     /* 1533425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1533438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533459 */     // GIR_Coverage, 3986,
     /* 1533459 */     GIR_EraseRootFromParent_Done,
     /* 1533460 */   // Label 21235: @1533460
     /* 1533460 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1533546), // Rule ID 3987 //
     /* 1533465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1533476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1533479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1533482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1533488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1533495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533511 */     // MIs[0] policy
     /* 1533511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533521 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1533524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533545 */     // GIR_Coverage, 3987,
     /* 1533545 */     GIR_EraseRootFromParent_Done,
     /* 1533546 */   // Label 21236: @1533546
     /* 1533546 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1533632), // Rule ID 3996 //
     /* 1533551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1533568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1533574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1533581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533597 */     // MIs[0] policy
     /* 1533597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1533610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533631 */     // GIR_Coverage, 3996,
     /* 1533631 */     GIR_EraseRootFromParent_Done,
     /* 1533632 */   // Label 21237: @1533632
     /* 1533632 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1533718), // Rule ID 3997 //
     /* 1533637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1533654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1533660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1533667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533683 */     // MIs[0] policy
     /* 1533683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1533696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533717 */     // GIR_Coverage, 3997,
     /* 1533717 */     GIR_EraseRootFromParent_Done,
     /* 1533718 */   // Label 21238: @1533718
     /* 1533718 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1533804), // Rule ID 4006 //
     /* 1533723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1533743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1533746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1533753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533769 */     // MIs[0] policy
     /* 1533769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533779 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1533782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533803 */     // GIR_Coverage, 4006,
     /* 1533803 */     GIR_EraseRootFromParent_Done,
     /* 1533804 */   // Label 21239: @1533804
     /* 1533804 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1533890), // Rule ID 4007 //
     /* 1533809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1533829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1533832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1533839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533855 */     // MIs[0] policy
     /* 1533855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533865 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1533868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533889 */     // GIR_Coverage, 4007,
     /* 1533889 */     GIR_EraseRootFromParent_Done,
     /* 1533890 */   // Label 21240: @1533890
     /* 1533890 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1533976), // Rule ID 4016 //
     /* 1533895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1533898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1533915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1533918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1533925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1533941 */     // MIs[0] policy
     /* 1533941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533951 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1533954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1533958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1533964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533975 */     // GIR_Coverage, 4016,
     /* 1533975 */     GIR_EraseRootFromParent_Done,
     /* 1533976 */   // Label 21241: @1533976
     /* 1533976 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1534062), // Rule ID 4017 //
     /* 1533981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1533984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1533989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1534004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1534011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534027 */     // MIs[0] policy
     /* 1534027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534037 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1534040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534061 */     // GIR_Coverage, 4017,
     /* 1534061 */     GIR_EraseRootFromParent_Done,
     /* 1534062 */   // Label 21242: @1534062
     /* 1534062 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1534148), // Rule ID 4026 //
     /* 1534067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1534070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1534084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1534090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1534097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534113 */     // MIs[0] policy
     /* 1534113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534123 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1534126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534147 */     // GIR_Coverage, 4026,
     /* 1534147 */     GIR_EraseRootFromParent_Done,
     /* 1534148 */   // Label 21243: @1534148
     /* 1534148 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1534234), // Rule ID 4027 //
     /* 1534153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1534156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1534170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1534176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1534183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534199 */     // MIs[0] policy
     /* 1534199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1534212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534233 */     // GIR_Coverage, 4027,
     /* 1534233 */     GIR_EraseRootFromParent_Done,
     /* 1534234 */   // Label 21244: @1534234
     /* 1534234 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1534320), // Rule ID 4036 //
     /* 1534239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1534242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1534250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1534253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1534256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1534262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1534269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534285 */     // MIs[0] policy
     /* 1534285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1534298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534319 */     // GIR_Coverage, 4036,
     /* 1534319 */     GIR_EraseRootFromParent_Done,
     /* 1534320 */   // Label 21245: @1534320
     /* 1534320 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1534406), // Rule ID 4037 //
     /* 1534325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1534328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1534336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1534339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1534342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1534348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1534355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534371 */     // MIs[0] policy
     /* 1534371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1534384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534405 */     // GIR_Coverage, 4037,
     /* 1534405 */     GIR_EraseRootFromParent_Done,
     /* 1534406 */   // Label 21246: @1534406
     /* 1534406 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1534492), // Rule ID 4046 //
     /* 1534411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1534414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1534422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1534425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1534428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1534434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1534441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534457 */     // MIs[0] policy
     /* 1534457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534467 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1534470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534491 */     // GIR_Coverage, 4046,
     /* 1534491 */     GIR_EraseRootFromParent_Done,
     /* 1534492 */   // Label 21247: @1534492
     /* 1534492 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1534578), // Rule ID 4047 //
     /* 1534497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1534500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1534508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1534511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1534514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1534520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1534527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534543 */     // MIs[0] policy
     /* 1534543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534553 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1534556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534577 */     // GIR_Coverage, 4047,
     /* 1534577 */     GIR_EraseRootFromParent_Done,
     /* 1534578 */   // Label 21248: @1534578
     /* 1534578 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1534664), // Rule ID 4056 //
     /* 1534583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1534586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1534600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1534603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1534606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1534613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534629 */     // MIs[0] policy
     /* 1534629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534639 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1534642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534663 */     // GIR_Coverage, 4056,
     /* 1534663 */     GIR_EraseRootFromParent_Done,
     /* 1534664 */   // Label 21249: @1534664
     /* 1534664 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1534750), // Rule ID 4057 //
     /* 1534669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1534672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1534686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1534689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1534692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1534699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534715 */     // MIs[0] policy
     /* 1534715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534725 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1534728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534749 */     // GIR_Coverage, 4057,
     /* 1534749 */     GIR_EraseRootFromParent_Done,
     /* 1534750 */   // Label 21250: @1534750
     /* 1534750 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1534836), // Rule ID 4060 //
     /* 1534755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1534758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1534766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1534769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1534775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1534778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1534785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1534797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534801 */     // MIs[0] policy
     /* 1534801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534811 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1534814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1534832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534835 */     // GIR_Coverage, 4060,
     /* 1534835 */     GIR_EraseRootFromParent_Done,
     /* 1534836 */   // Label 21251: @1534836
     /* 1534836 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1534922), // Rule ID 4061 //
     /* 1534841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1534844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1534852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1534855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1534861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1534864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1534871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1534883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534887 */     // MIs[0] policy
     /* 1534887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534897 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1534900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1534918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534921 */     // GIR_Coverage, 4061,
     /* 1534921 */     GIR_EraseRootFromParent_Done,
     /* 1534922 */   // Label 21252: @1534922
     /* 1534922 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1535008), // Rule ID 4064 //
     /* 1534927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1534930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1534935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1534944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1534947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1534950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1534957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1534969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1534973 */     // MIs[0] policy
     /* 1534973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534983 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1534986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1534990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1534996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535007 */     // GIR_Coverage, 4064,
     /* 1535007 */     GIR_EraseRootFromParent_Done,
     /* 1535008 */   // Label 21253: @1535008
     /* 1535008 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1535094), // Rule ID 4065 //
     /* 1535013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1535024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1535027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1535030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1535036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535059 */     // MIs[0] policy
     /* 1535059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535069 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1535072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535093 */     // GIR_Coverage, 4065,
     /* 1535093 */     GIR_EraseRootFromParent_Done,
     /* 1535094 */   // Label 21254: @1535094
     /* 1535094 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1535180), // Rule ID 4068 //
     /* 1535099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1535110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1535113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1535116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1535122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535145 */     // MIs[0] policy
     /* 1535145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535155 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1535158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535179 */     // GIR_Coverage, 4068,
     /* 1535179 */     GIR_EraseRootFromParent_Done,
     /* 1535180 */   // Label 21255: @1535180
     /* 1535180 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1535266), // Rule ID 4069 //
     /* 1535185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1535196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1535199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1535202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1535208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535231 */     // MIs[0] policy
     /* 1535231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535241 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1535244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535265 */     // GIR_Coverage, 4069,
     /* 1535265 */     GIR_EraseRootFromParent_Done,
     /* 1535266 */   // Label 21256: @1535266
     /* 1535266 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1535352), // Rule ID 4072 //
     /* 1535271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1535282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1535285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1535288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1535294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1535301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535317 */     // MIs[0] policy
     /* 1535317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1535330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535351 */     // GIR_Coverage, 4072,
     /* 1535351 */     GIR_EraseRootFromParent_Done,
     /* 1535352 */   // Label 21257: @1535352
     /* 1535352 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1535438), // Rule ID 4073 //
     /* 1535357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1535368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1535371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1535374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1535380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1535387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535403 */     // MIs[0] policy
     /* 1535403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1535416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535437 */     // GIR_Coverage, 4073,
     /* 1535437 */     GIR_EraseRootFromParent_Done,
     /* 1535438 */   // Label 21258: @1535438
     /* 1535438 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1535524), // Rule ID 4076 //
     /* 1535443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1535460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1535466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1535473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535489 */     // MIs[0] policy
     /* 1535489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535499 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1535502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535523 */     // GIR_Coverage, 4076,
     /* 1535523 */     GIR_EraseRootFromParent_Done,
     /* 1535524 */   // Label 21259: @1535524
     /* 1535524 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1535610), // Rule ID 4077 //
     /* 1535529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1535546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1535552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1535559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535575 */     // MIs[0] policy
     /* 1535575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535585 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1535588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535609 */     // GIR_Coverage, 4077,
     /* 1535609 */     GIR_EraseRootFromParent_Done,
     /* 1535610 */   // Label 21260: @1535610
     /* 1535610 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1535696), // Rule ID 4080 //
     /* 1535615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1535632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1535638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1535645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535661 */     // MIs[0] policy
     /* 1535661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535671 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1535674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535695 */     // GIR_Coverage, 4080,
     /* 1535695 */     GIR_EraseRootFromParent_Done,
     /* 1535696 */   // Label 21261: @1535696
     /* 1535696 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1535782), // Rule ID 4081 //
     /* 1535701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1535718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1535724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1535731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535747 */     // MIs[0] policy
     /* 1535747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535757 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1535760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1535778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535781 */     // GIR_Coverage, 4081,
     /* 1535781 */     GIR_EraseRootFromParent_Done,
     /* 1535782 */   // Label 21262: @1535782
     /* 1535782 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1535868), // Rule ID 4084 //
     /* 1535787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1535810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535833 */     // MIs[0] policy
     /* 1535833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1535846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535867 */     // GIR_Coverage, 4084,
     /* 1535867 */     GIR_EraseRootFromParent_Done,
     /* 1535868 */   // Label 21263: @1535868
     /* 1535868 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1535954), // Rule ID 4085 //
     /* 1535873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1535876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1535893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1535896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1535915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1535919 */     // MIs[0] policy
     /* 1535919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535929 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1535932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1535936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1535942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535953 */     // GIR_Coverage, 4085,
     /* 1535953 */     GIR_EraseRootFromParent_Done,
     /* 1535954 */   // Label 21264: @1535954
     /* 1535954 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1536040), // Rule ID 4088 //
     /* 1535959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1535962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1535967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1535970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1535973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1535976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1535979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1535982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1535989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536005 */     // MIs[0] policy
     /* 1536005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1536018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536039 */     // GIR_Coverage, 4088,
     /* 1536039 */     GIR_EraseRootFromParent_Done,
     /* 1536040 */   // Label 21265: @1536040
     /* 1536040 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1536126), // Rule ID 4089 //
     /* 1536045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1536048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1536068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1536075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536091 */     // MIs[0] policy
     /* 1536091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1536104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536125 */     // GIR_Coverage, 4089,
     /* 1536125 */     GIR_EraseRootFromParent_Done,
     /* 1536126 */   // Label 21266: @1536126
     /* 1536126 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1536212), // Rule ID 4092 //
     /* 1536131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1536134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1536142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1536145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1536148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1536151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1536154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1536161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536177 */     // MIs[0] policy
     /* 1536177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1536190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536211 */     // GIR_Coverage, 4092,
     /* 1536211 */     GIR_EraseRootFromParent_Done,
     /* 1536212 */   // Label 21267: @1536212
     /* 1536212 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1536298), // Rule ID 4093 //
     /* 1536217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1536220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1536228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1536231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1536234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1536240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1536247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536263 */     // MIs[0] policy
     /* 1536263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1536276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536297 */     // GIR_Coverage, 4093,
     /* 1536297 */     GIR_EraseRootFromParent_Done,
     /* 1536298 */   // Label 21268: @1536298
     /* 1536298 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1536384), // Rule ID 4096 //
     /* 1536303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1536306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1536320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1536323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1536326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1536333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536349 */     // MIs[0] policy
     /* 1536349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536359 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1536362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536383 */     // GIR_Coverage, 4096,
     /* 1536383 */     GIR_EraseRootFromParent_Done,
     /* 1536384 */   // Label 21269: @1536384
     /* 1536384 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1536470), // Rule ID 4097 //
     /* 1536389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1536392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1536406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1536412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1536419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536435 */     // MIs[0] policy
     /* 1536435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536445 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1536448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536469 */     // GIR_Coverage, 4097,
     /* 1536469 */     GIR_EraseRootFromParent_Done,
     /* 1536470 */   // Label 21270: @1536470
     /* 1536470 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1536556), // Rule ID 4100 //
     /* 1536475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1536478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1536492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1536495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1536498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1536505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536521 */     // MIs[0] policy
     /* 1536521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536531 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1536534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536555 */     // GIR_Coverage, 4100,
     /* 1536555 */     GIR_EraseRootFromParent_Done,
     /* 1536556 */   // Label 21271: @1536556
     /* 1536556 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1536642), // Rule ID 4101 //
     /* 1536561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1536564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1536578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1536584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1536591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536607 */     // MIs[0] policy
     /* 1536607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536617 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1536620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536641 */     // GIR_Coverage, 4101,
     /* 1536641 */     GIR_EraseRootFromParent_Done,
     /* 1536642 */   // Label 21272: @1536642
     /* 1536642 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1536728), // Rule ID 4104 //
     /* 1536647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1536650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1536667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1536670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1536677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536693 */     // MIs[0] policy
     /* 1536693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536703 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1536706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536727 */     // GIR_Coverage, 4104,
     /* 1536727 */     GIR_EraseRootFromParent_Done,
     /* 1536728 */   // Label 21273: @1536728
     /* 1536728 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1536814), // Rule ID 4105 //
     /* 1536733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1536736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1536756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1536763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536779 */     // MIs[0] policy
     /* 1536779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1536792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536813 */     // GIR_Coverage, 4105,
     /* 1536813 */     GIR_EraseRootFromParent_Done,
     /* 1536814 */   // Label 21274: @1536814
     /* 1536814 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1536900), // Rule ID 4108 //
     /* 1536819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1536822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1536836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1536839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1536842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1536849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536865 */     // MIs[0] policy
     /* 1536865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1536878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536899 */     // GIR_Coverage, 4108,
     /* 1536899 */     GIR_EraseRootFromParent_Done,
     /* 1536900 */   // Label 21275: @1536900
     /* 1536900 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1536986), // Rule ID 4109 //
     /* 1536905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1536908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1536922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1536925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1536928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1536935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1536947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1536951 */     // MIs[0] policy
     /* 1536951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1536964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1536968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1536974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536985 */     // GIR_Coverage, 4109,
     /* 1536985 */     GIR_EraseRootFromParent_Done,
     /* 1536986 */   // Label 21276: @1536986
     /* 1536986 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1537072), // Rule ID 4112 //
     /* 1536991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1536994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1536999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1537002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1537005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1537008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1537011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1537014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1537021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1537033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537037 */     // MIs[0] policy
     /* 1537037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1537050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537071 */     // GIR_Coverage, 4112,
     /* 1537071 */     GIR_EraseRootFromParent_Done,
     /* 1537072 */   // Label 21277: @1537072
     /* 1537072 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1537158), // Rule ID 4113 //
     /* 1537077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1537080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1537085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1537088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1537091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1537094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1537097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1537100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1537107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1537119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537123 */     // MIs[0] policy
     /* 1537123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1537136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537157 */     // GIR_Coverage, 4113,
     /* 1537157 */     GIR_EraseRootFromParent_Done,
     /* 1537158 */   // Label 21278: @1537158
     /* 1537158 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1537244), // Rule ID 4116 //
     /* 1537163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1537166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1537171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1537174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1537177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1537180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1537183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1537186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1537193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1537205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537209 */     // MIs[0] policy
     /* 1537209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537219 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1537222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537243 */     // GIR_Coverage, 4116,
     /* 1537243 */     GIR_EraseRootFromParent_Done,
     /* 1537244 */   // Label 21279: @1537244
     /* 1537244 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1537330), // Rule ID 4117 //
     /* 1537249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1537252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1537257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1537260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1537263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1537266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1537269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1537272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1537279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1537291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537295 */     // MIs[0] policy
     /* 1537295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537305 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1537308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537329 */     // GIR_Coverage, 4117,
     /* 1537329 */     GIR_EraseRootFromParent_Done,
     /* 1537330 */   // Label 21280: @1537330
     /* 1537330 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1537416), // Rule ID 4126 //
     /* 1537335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1537338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1537346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1537349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1537352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1537355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1537358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537381 */     // MIs[0] policy
     /* 1537381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537391 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1537394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537415 */     // GIR_Coverage, 4126,
     /* 1537415 */     GIR_EraseRootFromParent_Done,
     /* 1537416 */   // Label 21281: @1537416
     /* 1537416 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1537502), // Rule ID 4127 //
     /* 1537421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1537424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1537432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1537435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1537438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1537441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1537444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537467 */     // MIs[0] policy
     /* 1537467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1537480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537501 */     // GIR_Coverage, 4127,
     /* 1537501 */     GIR_EraseRootFromParent_Done,
     /* 1537502 */   // Label 21282: @1537502
     /* 1537502 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1537588), // Rule ID 4136 //
     /* 1537507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1537510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1537518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1537521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1537524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1537527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1537530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537553 */     // MIs[0] policy
     /* 1537553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537563 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1537566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537587 */     // GIR_Coverage, 4136,
     /* 1537587 */     GIR_EraseRootFromParent_Done,
     /* 1537588 */   // Label 21283: @1537588
     /* 1537588 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1537674), // Rule ID 4137 //
     /* 1537593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1537596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1537604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1537607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1537610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1537613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1537616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537639 */     // MIs[0] policy
     /* 1537639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537649 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1537652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537673 */     // GIR_Coverage, 4137,
     /* 1537673 */     GIR_EraseRootFromParent_Done,
     /* 1537674 */   // Label 21284: @1537674
     /* 1537674 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1537760), // Rule ID 4146 //
     /* 1537679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1537682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1537690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1537693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1537696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1537699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1537702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537725 */     // MIs[0] policy
     /* 1537725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1537738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537759 */     // GIR_Coverage, 4146,
     /* 1537759 */     GIR_EraseRootFromParent_Done,
     /* 1537760 */   // Label 21285: @1537760
     /* 1537760 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1537846), // Rule ID 4147 //
     /* 1537765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1537768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1537776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1537779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1537782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1537785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1537788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1537795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537811 */     // MIs[0] policy
     /* 1537811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1537824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537845 */     // GIR_Coverage, 4147,
     /* 1537845 */     GIR_EraseRootFromParent_Done,
     /* 1537846 */   // Label 21286: @1537846
     /* 1537846 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1537932), // Rule ID 4156 //
     /* 1537851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1537854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1537871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1537874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1537881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537897 */     // MIs[0] policy
     /* 1537897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1537910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1537914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1537920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1537928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537931 */     // GIR_Coverage, 4156,
     /* 1537931 */     GIR_EraseRootFromParent_Done,
     /* 1537932 */   // Label 21287: @1537932
     /* 1537932 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1538018), // Rule ID 4157 //
     /* 1537937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1537940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1537945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1537957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1537960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1537967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1537983 */     // MIs[0] policy
     /* 1537983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1537996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1538014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538017 */     // GIR_Coverage, 4157,
     /* 1538017 */     GIR_EraseRootFromParent_Done,
     /* 1538018 */   // Label 21288: @1538018
     /* 1538018 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1538104), // Rule ID 4166 //
     /* 1538023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1538034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1538037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1538040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1538043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1538046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1538053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538069 */     // MIs[0] policy
     /* 1538069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1538082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1538100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538103 */     // GIR_Coverage, 4166,
     /* 1538103 */     GIR_EraseRootFromParent_Done,
     /* 1538104 */   // Label 21289: @1538104
     /* 1538104 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1538190), // Rule ID 4167 //
     /* 1538109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1538120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1538123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1538126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1538129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1538132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1538139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538155 */     // MIs[0] policy
     /* 1538155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1538168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1538186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538189 */     // GIR_Coverage, 4167,
     /* 1538189 */     GIR_EraseRootFromParent_Done,
     /* 1538190 */   // Label 21290: @1538190
     /* 1538190 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1538276), // Rule ID 4176 //
     /* 1538195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1538206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1538209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1538212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1538215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1538218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1538225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538241 */     // MIs[0] policy
     /* 1538241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1538254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1538272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538275 */     // GIR_Coverage, 4176,
     /* 1538275 */     GIR_EraseRootFromParent_Done,
     /* 1538276 */   // Label 21291: @1538276
     /* 1538276 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1538362), // Rule ID 4177 //
     /* 1538281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1538292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1538295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1538298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1538301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1538304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1538311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538327 */     // MIs[0] policy
     /* 1538327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538337 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1538340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1538358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538361 */     // GIR_Coverage, 4177,
     /* 1538361 */     GIR_EraseRootFromParent_Done,
     /* 1538362 */   // Label 21292: @1538362
     /* 1538362 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1538448), // Rule ID 4186 //
     /* 1538367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1538384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1538390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1538397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538413 */     // MIs[0] policy
     /* 1538413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538423 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1538426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538447 */     // GIR_Coverage, 4186,
     /* 1538447 */     GIR_EraseRootFromParent_Done,
     /* 1538448 */   // Label 21293: @1538448
     /* 1538448 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1538534), // Rule ID 4187 //
     /* 1538453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1538470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1538476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1538483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538499 */     // MIs[0] policy
     /* 1538499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1538512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538533 */     // GIR_Coverage, 4187,
     /* 1538533 */     GIR_EraseRootFromParent_Done,
     /* 1538534 */   // Label 21294: @1538534
     /* 1538534 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1538620), // Rule ID 4196 //
     /* 1538539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1538556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1538562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1538569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538585 */     // MIs[0] policy
     /* 1538585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1538598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538619 */     // GIR_Coverage, 4196,
     /* 1538619 */     GIR_EraseRootFromParent_Done,
     /* 1538620 */   // Label 21295: @1538620
     /* 1538620 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1538706), // Rule ID 4197 //
     /* 1538625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1538642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1538648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1538655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538671 */     // MIs[0] policy
     /* 1538671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1538684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538705 */     // GIR_Coverage, 4197,
     /* 1538705 */     GIR_EraseRootFromParent_Done,
     /* 1538706 */   // Label 21296: @1538706
     /* 1538706 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1538792), // Rule ID 4206 //
     /* 1538711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1538728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1538734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1538741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538757 */     // MIs[0] policy
     /* 1538757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1538770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538791 */     // GIR_Coverage, 4206,
     /* 1538791 */     GIR_EraseRootFromParent_Done,
     /* 1538792 */   // Label 21297: @1538792
     /* 1538792 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1538878), // Rule ID 4207 //
     /* 1538797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1538814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1538820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1538827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538843 */     // MIs[0] policy
     /* 1538843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1538856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538877 */     // GIR_Coverage, 4207,
     /* 1538877 */     GIR_EraseRootFromParent_Done,
     /* 1538878 */   // Label 21298: @1538878
     /* 1538878 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1538964), // Rule ID 4216 //
     /* 1538883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1538886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1538903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1538906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1538913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1538929 */     // MIs[0] policy
     /* 1538929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1538942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1538946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1538952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538963 */     // GIR_Coverage, 4216,
     /* 1538963 */     GIR_EraseRootFromParent_Done,
     /* 1538964 */   // Label 21299: @1538964
     /* 1538964 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1539050), // Rule ID 4217 //
     /* 1538969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1538972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1538977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1538989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1538992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1538999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539015 */     // MIs[0] policy
     /* 1539015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1539028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539049 */     // GIR_Coverage, 4217,
     /* 1539049 */     GIR_EraseRootFromParent_Done,
     /* 1539050 */   // Label 21300: @1539050
     /* 1539050 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1539136), // Rule ID 4226 //
     /* 1539055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1539058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1539072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1539078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1539085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539101 */     // MIs[0] policy
     /* 1539101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1539114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539135 */     // GIR_Coverage, 4226,
     /* 1539135 */     GIR_EraseRootFromParent_Done,
     /* 1539136 */   // Label 21301: @1539136
     /* 1539136 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1539222), // Rule ID 4227 //
     /* 1539141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1539144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1539158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1539164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1539171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539187 */     // MIs[0] policy
     /* 1539187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539197 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1539200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539221 */     // GIR_Coverage, 4227,
     /* 1539221 */     GIR_EraseRootFromParent_Done,
     /* 1539222 */   // Label 21302: @1539222
     /* 1539222 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1539308), // Rule ID 4236 //
     /* 1539227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1539230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1539244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1539250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1539257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539273 */     // MIs[0] policy
     /* 1539273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539283 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1539286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539307 */     // GIR_Coverage, 4236,
     /* 1539307 */     GIR_EraseRootFromParent_Done,
     /* 1539308 */   // Label 21303: @1539308
     /* 1539308 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1539394), // Rule ID 4237 //
     /* 1539313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1539316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1539330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1539336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1539343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539359 */     // MIs[0] policy
     /* 1539359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539369 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1539372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539393 */     // GIR_Coverage, 4237,
     /* 1539393 */     GIR_EraseRootFromParent_Done,
     /* 1539394 */   // Label 21304: @1539394
     /* 1539394 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1539480), // Rule ID 4246 //
     /* 1539399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1539402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1539416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1539422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1539429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539445 */     // MIs[0] policy
     /* 1539445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1539458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539479 */     // GIR_Coverage, 4246,
     /* 1539479 */     GIR_EraseRootFromParent_Done,
     /* 1539480 */   // Label 21305: @1539480
     /* 1539480 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1539566), // Rule ID 4247 //
     /* 1539485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1539488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1539502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1539508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1539515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539531 */     // MIs[0] policy
     /* 1539531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1539544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539565 */     // GIR_Coverage, 4247,
     /* 1539565 */     GIR_EraseRootFromParent_Done,
     /* 1539566 */   // Label 21306: @1539566
     /* 1539566 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1539652), // Rule ID 4256 //
     /* 1539571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1539574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1539588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1539594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1539601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539617 */     // MIs[0] policy
     /* 1539617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1539630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539651 */     // GIR_Coverage, 4256,
     /* 1539651 */     GIR_EraseRootFromParent_Done,
     /* 1539652 */   // Label 21307: @1539652
     /* 1539652 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1539738), // Rule ID 4257 //
     /* 1539657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1539660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1539674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1539680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1539687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539703 */     // MIs[0] policy
     /* 1539703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539713 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1539716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539737 */     // GIR_Coverage, 4257,
     /* 1539737 */     GIR_EraseRootFromParent_Done,
     /* 1539738 */   // Label 21308: @1539738
     /* 1539738 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1539824), // Rule ID 4266 //
     /* 1539743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1539746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1539760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1539766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1539773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539789 */     // MIs[0] policy
     /* 1539789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539799 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1539802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539823 */     // GIR_Coverage, 4266,
     /* 1539823 */     GIR_EraseRootFromParent_Done,
     /* 1539824 */   // Label 21309: @1539824
     /* 1539824 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1539910), // Rule ID 4267 //
     /* 1539829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1539832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1539846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1539852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1539859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539875 */     // MIs[0] policy
     /* 1539875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539885 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1539888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539909 */     // GIR_Coverage, 4267,
     /* 1539909 */     GIR_EraseRootFromParent_Done,
     /* 1539910 */   // Label 21310: @1539910
     /* 1539910 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1539996), // Rule ID 4270 //
     /* 1539915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1539918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1539923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1539926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1539929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1539932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1539935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1539938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1539945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1539957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1539961 */     // MIs[0] policy
     /* 1539961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539971 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1539974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1539978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1539984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1539992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539995 */     // GIR_Coverage, 4270,
     /* 1539995 */     GIR_EraseRootFromParent_Done,
     /* 1539996 */   // Label 21311: @1539996
     /* 1539996 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1540082), // Rule ID 4271 //
     /* 1540001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1540012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1540015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1540024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540047 */     // MIs[0] policy
     /* 1540047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540057 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1540060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540081 */     // GIR_Coverage, 4271,
     /* 1540081 */     GIR_EraseRootFromParent_Done,
     /* 1540082 */   // Label 21312: @1540082
     /* 1540082 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1540168), // Rule ID 4274 //
     /* 1540087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1540098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1540101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1540110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540133 */     // MIs[0] policy
     /* 1540133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540143 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1540146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540167 */     // GIR_Coverage, 4274,
     /* 1540167 */     GIR_EraseRootFromParent_Done,
     /* 1540168 */   // Label 21313: @1540168
     /* 1540168 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1540254), // Rule ID 4275 //
     /* 1540173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1540184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1540187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1540196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540219 */     // MIs[0] policy
     /* 1540219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540229 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1540232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540253 */     // GIR_Coverage, 4275,
     /* 1540253 */     GIR_EraseRootFromParent_Done,
     /* 1540254 */   // Label 21314: @1540254
     /* 1540254 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1540340), // Rule ID 4278 //
     /* 1540259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1540270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1540273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1540282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540305 */     // MIs[0] policy
     /* 1540305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1540318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540339 */     // GIR_Coverage, 4278,
     /* 1540339 */     GIR_EraseRootFromParent_Done,
     /* 1540340 */   // Label 21315: @1540340
     /* 1540340 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1540426), // Rule ID 4279 //
     /* 1540345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1540356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1540359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1540368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540391 */     // MIs[0] policy
     /* 1540391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540401 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1540404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540425 */     // GIR_Coverage, 4279,
     /* 1540425 */     GIR_EraseRootFromParent_Done,
     /* 1540426 */   // Label 21316: @1540426
     /* 1540426 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1540512), // Rule ID 4282 //
     /* 1540431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1540442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1540445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1540454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1540461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540477 */     // MIs[0] policy
     /* 1540477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540487 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1540490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540511 */     // GIR_Coverage, 4282,
     /* 1540511 */     GIR_EraseRootFromParent_Done,
     /* 1540512 */   // Label 21317: @1540512
     /* 1540512 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1540598), // Rule ID 4283 //
     /* 1540517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1540528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1540531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1540540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1540547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540563 */     // MIs[0] policy
     /* 1540563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1540576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540597 */     // GIR_Coverage, 4283,
     /* 1540597 */     GIR_EraseRootFromParent_Done,
     /* 1540598 */   // Label 21318: @1540598
     /* 1540598 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1540684), // Rule ID 4286 //
     /* 1540603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1540614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1540626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1540633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540649 */     // MIs[0] policy
     /* 1540649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540659 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1540662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540683 */     // GIR_Coverage, 4286,
     /* 1540683 */     GIR_EraseRootFromParent_Done,
     /* 1540684 */   // Label 21319: @1540684
     /* 1540684 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1540770), // Rule ID 4287 //
     /* 1540689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1540700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1540712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1540719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540735 */     // MIs[0] policy
     /* 1540735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540745 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1540748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540769 */     // GIR_Coverage, 4287,
     /* 1540769 */     GIR_EraseRootFromParent_Done,
     /* 1540770 */   // Label 21320: @1540770
     /* 1540770 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1540856), // Rule ID 4290 //
     /* 1540775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1540792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1540798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1540805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540821 */     // MIs[0] policy
     /* 1540821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540831 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1540834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540855 */     // GIR_Coverage, 4290,
     /* 1540855 */     GIR_EraseRootFromParent_Done,
     /* 1540856 */   // Label 21321: @1540856
     /* 1540856 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1540942), // Rule ID 4291 //
     /* 1540861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1540864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1540878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1540881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1540884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1540891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540907 */     // MIs[0] policy
     /* 1540907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540917 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1540920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1540924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1540930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1540938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540941 */     // GIR_Coverage, 4291,
     /* 1540941 */     GIR_EraseRootFromParent_Done,
     /* 1540942 */   // Label 21322: @1540942
     /* 1540942 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1541028), // Rule ID 4294 //
     /* 1540947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1540950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1540955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1540964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1540967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1540970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1540977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1540989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1540993 */     // MIs[0] policy
     /* 1540993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541003 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1541006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541027 */     // GIR_Coverage, 4294,
     /* 1541027 */     GIR_EraseRootFromParent_Done,
     /* 1541028 */   // Label 21323: @1541028
     /* 1541028 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1541114), // Rule ID 4295 //
     /* 1541033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1541036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1541050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1541056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1541063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541079 */     // MIs[0] policy
     /* 1541079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1541092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541113 */     // GIR_Coverage, 4295,
     /* 1541113 */     GIR_EraseRootFromParent_Done,
     /* 1541114 */   // Label 21324: @1541114
     /* 1541114 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1541200), // Rule ID 4298 //
     /* 1541119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1541122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1541142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1541149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541165 */     // MIs[0] policy
     /* 1541165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541175 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1541178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541199 */     // GIR_Coverage, 4298,
     /* 1541199 */     GIR_EraseRootFromParent_Done,
     /* 1541200 */   // Label 21325: @1541200
     /* 1541200 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1541286), // Rule ID 4299 //
     /* 1541205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1541208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1541228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1541235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541251 */     // MIs[0] policy
     /* 1541251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1541264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541285 */     // GIR_Coverage, 4299,
     /* 1541285 */     GIR_EraseRootFromParent_Done,
     /* 1541286 */   // Label 21326: @1541286
     /* 1541286 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1541372), // Rule ID 4302 //
     /* 1541291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1541294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1541314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1541321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541337 */     // MIs[0] policy
     /* 1541337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541347 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1541350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541371 */     // GIR_Coverage, 4302,
     /* 1541371 */     GIR_EraseRootFromParent_Done,
     /* 1541372 */   // Label 21327: @1541372
     /* 1541372 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1541458), // Rule ID 4303 //
     /* 1541377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1541380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1541400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1541407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541423 */     // MIs[0] policy
     /* 1541423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1541436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541457 */     // GIR_Coverage, 4303,
     /* 1541457 */     GIR_EraseRootFromParent_Done,
     /* 1541458 */   // Label 21328: @1541458
     /* 1541458 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1541544), // Rule ID 4306 //
     /* 1541463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1541466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1541486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1541493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541509 */     // MIs[0] policy
     /* 1541509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541519 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1541522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541543 */     // GIR_Coverage, 4306,
     /* 1541543 */     GIR_EraseRootFromParent_Done,
     /* 1541544 */   // Label 21329: @1541544
     /* 1541544 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1541630), // Rule ID 4307 //
     /* 1541549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1541552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1541572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1541579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541595 */     // MIs[0] policy
     /* 1541595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541605 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1541608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541629 */     // GIR_Coverage, 4307,
     /* 1541629 */     GIR_EraseRootFromParent_Done,
     /* 1541630 */   // Label 21330: @1541630
     /* 1541630 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1541716), // Rule ID 4310 //
     /* 1541635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1541638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1541652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1541658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1541665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541681 */     // MIs[0] policy
     /* 1541681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541691 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1541694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541715 */     // GIR_Coverage, 4310,
     /* 1541715 */     GIR_EraseRootFromParent_Done,
     /* 1541716 */   // Label 21331: @1541716
     /* 1541716 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1541802), // Rule ID 4311 //
     /* 1541721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1541724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1541738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1541744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1541751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541767 */     // MIs[0] policy
     /* 1541767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541777 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1541780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541801 */     // GIR_Coverage, 4311,
     /* 1541801 */     GIR_EraseRootFromParent_Done,
     /* 1541802 */   // Label 21332: @1541802
     /* 1541802 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1541888), // Rule ID 4314 //
     /* 1541807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1541810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1541824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1541830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1541837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541853 */     // MIs[0] policy
     /* 1541853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1541866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541887 */     // GIR_Coverage, 4314,
     /* 1541887 */     GIR_EraseRootFromParent_Done,
     /* 1541888 */   // Label 21333: @1541888
     /* 1541888 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1541974), // Rule ID 4315 //
     /* 1541893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1541896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1541910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1541913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1541916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1541923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1541935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1541939 */     // MIs[0] policy
     /* 1541939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1541952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1541956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1541962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541973 */     // GIR_Coverage, 4315,
     /* 1541973 */     GIR_EraseRootFromParent_Done,
     /* 1541974 */   // Label 21334: @1541974
     /* 1541974 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1542060), // Rule ID 4318 //
     /* 1541979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1541982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1541987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1541996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1541999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1542002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1542009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542025 */     // MIs[0] policy
     /* 1542025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1542038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542059 */     // GIR_Coverage, 4318,
     /* 1542059 */     GIR_EraseRootFromParent_Done,
     /* 1542060 */   // Label 21335: @1542060
     /* 1542060 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1542146), // Rule ID 4319 //
     /* 1542065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1542068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1542073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1542082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1542085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1542088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1542095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542111 */     // MIs[0] policy
     /* 1542111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1542124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542145 */     // GIR_Coverage, 4319,
     /* 1542145 */     GIR_EraseRootFromParent_Done,
     /* 1542146 */   // Label 21336: @1542146
     /* 1542146 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1542232), // Rule ID 4322 //
     /* 1542151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1542154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1542159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1542168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1542171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1542174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1542181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542197 */     // MIs[0] policy
     /* 1542197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542207 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1542210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542231 */     // GIR_Coverage, 4322,
     /* 1542231 */     GIR_EraseRootFromParent_Done,
     /* 1542232 */   // Label 21337: @1542232
     /* 1542232 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1542318), // Rule ID 4323 //
     /* 1542237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1542240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1542245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1542254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1542257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1542260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1542267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542283 */     // MIs[0] policy
     /* 1542283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1542296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542317 */     // GIR_Coverage, 4323,
     /* 1542317 */     GIR_EraseRootFromParent_Done,
     /* 1542318 */   // Label 21338: @1542318
     /* 1542318 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1542404), // Rule ID 4326 //
     /* 1542323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1542326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1542331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1542340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1542343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1542346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1542353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542369 */     // MIs[0] policy
     /* 1542369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542379 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1542382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542403 */     // GIR_Coverage, 4326,
     /* 1542403 */     GIR_EraseRootFromParent_Done,
     /* 1542404 */   // Label 21339: @1542404
     /* 1542404 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1542490), // Rule ID 4327 //
     /* 1542409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1542412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1542417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1542426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1542429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1542432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1542439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1542451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542455 */     // MIs[0] policy
     /* 1542455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542465 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1542468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542489 */     // GIR_Coverage, 4327,
     /* 1542489 */     GIR_EraseRootFromParent_Done,
     /* 1542490 */   // Label 21340: @1542490
     /* 1542490 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1542576), // Rule ID 4336 //
     /* 1542495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1542498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1542506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1542509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1542512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1542515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1542518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542541 */     // MIs[0] policy
     /* 1542541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1542554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1542572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542575 */     // GIR_Coverage, 4336,
     /* 1542575 */     GIR_EraseRootFromParent_Done,
     /* 1542576 */   // Label 21341: @1542576
     /* 1542576 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1542662), // Rule ID 4337 //
     /* 1542581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1542584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1542592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1542595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1542598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1542601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1542604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542627 */     // MIs[0] policy
     /* 1542627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542637 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1542640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1542658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542661 */     // GIR_Coverage, 4337,
     /* 1542661 */     GIR_EraseRootFromParent_Done,
     /* 1542662 */   // Label 21342: @1542662
     /* 1542662 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1542748), // Rule ID 4346 //
     /* 1542667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1542670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1542678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1542681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1542684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1542687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1542690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542713 */     // MIs[0] policy
     /* 1542713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542723 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1542726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1542744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542747 */     // GIR_Coverage, 4346,
     /* 1542747 */     GIR_EraseRootFromParent_Done,
     /* 1542748 */   // Label 21343: @1542748
     /* 1542748 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1542834), // Rule ID 4347 //
     /* 1542753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1542756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1542764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1542767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1542770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1542773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1542776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542799 */     // MIs[0] policy
     /* 1542799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542809 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1542812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1542830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542833 */     // GIR_Coverage, 4347,
     /* 1542833 */     GIR_EraseRootFromParent_Done,
     /* 1542834 */   // Label 21344: @1542834
     /* 1542834 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1542920), // Rule ID 4356 //
     /* 1542839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1542842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1542850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1542853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1542856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1542859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1542862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542885 */     // MIs[0] policy
     /* 1542885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542895 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1542898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1542916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542919 */     // GIR_Coverage, 4356,
     /* 1542919 */     GIR_EraseRootFromParent_Done,
     /* 1542920 */   // Label 21345: @1542920
     /* 1542920 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1543006), // Rule ID 4357 //
     /* 1542925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1542928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1542933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1542936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1542939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1542942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1542945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1542948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1542955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1542971 */     // MIs[0] policy
     /* 1542971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1542984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1542988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1542994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543005 */     // GIR_Coverage, 4357,
     /* 1543005 */     GIR_EraseRootFromParent_Done,
     /* 1543006 */   // Label 21346: @1543006
     /* 1543006 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1543092), // Rule ID 4366 //
     /* 1543011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1543022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1543025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1543028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1543031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1543034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1543041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543057 */     // MIs[0] policy
     /* 1543057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1543070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543091 */     // GIR_Coverage, 4366,
     /* 1543091 */     GIR_EraseRootFromParent_Done,
     /* 1543092 */   // Label 21347: @1543092
     /* 1543092 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1543178), // Rule ID 4367 //
     /* 1543097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1543108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1543111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1543114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1543117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1543120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1543127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543143 */     // MIs[0] policy
     /* 1543143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543153 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1543156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543177 */     // GIR_Coverage, 4367,
     /* 1543177 */     GIR_EraseRootFromParent_Done,
     /* 1543178 */   // Label 21348: @1543178
     /* 1543178 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1543264), // Rule ID 4376 //
     /* 1543183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1543194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1543197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1543200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1543203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1543206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1543213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543229 */     // MIs[0] policy
     /* 1543229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1543242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543263 */     // GIR_Coverage, 4376,
     /* 1543263 */     GIR_EraseRootFromParent_Done,
     /* 1543264 */   // Label 21349: @1543264
     /* 1543264 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1543350), // Rule ID 4377 //
     /* 1543269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1543280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1543283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1543286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1543289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1543292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1543299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543315 */     // MIs[0] policy
     /* 1543315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543325 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1543328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543349 */     // GIR_Coverage, 4377,
     /* 1543349 */     GIR_EraseRootFromParent_Done,
     /* 1543350 */   // Label 21350: @1543350
     /* 1543350 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1543436), // Rule ID 4386 //
     /* 1543355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1543366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1543369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1543372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1543375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1543378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1543385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543401 */     // MIs[0] policy
     /* 1543401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543411 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1543414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543435 */     // GIR_Coverage, 4386,
     /* 1543435 */     GIR_EraseRootFromParent_Done,
     /* 1543436 */   // Label 21351: @1543436
     /* 1543436 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1543522), // Rule ID 4387 //
     /* 1543441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1543452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1543455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1543458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1543461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1543464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1543471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543487 */     // MIs[0] policy
     /* 1543487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543497 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1543500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1543518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543521 */     // GIR_Coverage, 4387,
     /* 1543521 */     GIR_EraseRootFromParent_Done,
     /* 1543522 */   // Label 21352: @1543522
     /* 1543522 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1543608), // Rule ID 4396 //
     /* 1543527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1543544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1543550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1543557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543573 */     // MIs[0] policy
     /* 1543573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1543586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543607 */     // GIR_Coverage, 4396,
     /* 1543607 */     GIR_EraseRootFromParent_Done,
     /* 1543608 */   // Label 21353: @1543608
     /* 1543608 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1543694), // Rule ID 4397 //
     /* 1543613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1543630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1543636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1543643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543659 */     // MIs[0] policy
     /* 1543659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1543672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543693 */     // GIR_Coverage, 4397,
     /* 1543693 */     GIR_EraseRootFromParent_Done,
     /* 1543694 */   // Label 21354: @1543694
     /* 1543694 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1543780), // Rule ID 4406 //
     /* 1543699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1543716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1543722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1543729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543745 */     // MIs[0] policy
     /* 1543745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543755 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1543758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543779 */     // GIR_Coverage, 4406,
     /* 1543779 */     GIR_EraseRootFromParent_Done,
     /* 1543780 */   // Label 21355: @1543780
     /* 1543780 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1543866), // Rule ID 4407 //
     /* 1543785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1543802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1543808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1543815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543831 */     // MIs[0] policy
     /* 1543831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543841 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1543844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543865 */     // GIR_Coverage, 4407,
     /* 1543865 */     GIR_EraseRootFromParent_Done,
     /* 1543866 */   // Label 21356: @1543866
     /* 1543866 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1543952), // Rule ID 4416 //
     /* 1543871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1543874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1543888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1543894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1543901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1543917 */     // MIs[0] policy
     /* 1543917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1543930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1543934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1543940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543951 */     // GIR_Coverage, 4416,
     /* 1543951 */     GIR_EraseRootFromParent_Done,
     /* 1543952 */   // Label 21357: @1543952
     /* 1543952 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1544038), // Rule ID 4417 //
     /* 1543957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1543960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1543965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1543974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1543980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1543987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544003 */     // MIs[0] policy
     /* 1544003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1544016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544037 */     // GIR_Coverage, 4417,
     /* 1544037 */     GIR_EraseRootFromParent_Done,
     /* 1544038 */   // Label 21358: @1544038
     /* 1544038 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1544124), // Rule ID 4426 //
     /* 1544043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1544046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1544060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1544066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1544073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544089 */     // MIs[0] policy
     /* 1544089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1544102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544123 */     // GIR_Coverage, 4426,
     /* 1544123 */     GIR_EraseRootFromParent_Done,
     /* 1544124 */   // Label 21359: @1544124
     /* 1544124 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1544210), // Rule ID 4427 //
     /* 1544129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1544132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1544146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1544152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1544159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544175 */     // MIs[0] policy
     /* 1544175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1544188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544209 */     // GIR_Coverage, 4427,
     /* 1544209 */     GIR_EraseRootFromParent_Done,
     /* 1544210 */   // Label 21360: @1544210
     /* 1544210 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1544296), // Rule ID 4436 //
     /* 1544215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1544218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1544232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1544238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1544245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544261 */     // MIs[0] policy
     /* 1544261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1544274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544295 */     // GIR_Coverage, 4436,
     /* 1544295 */     GIR_EraseRootFromParent_Done,
     /* 1544296 */   // Label 21361: @1544296
     /* 1544296 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1544382), // Rule ID 4437 //
     /* 1544301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1544304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1544318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1544324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1544331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544347 */     // MIs[0] policy
     /* 1544347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544357 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1544360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544381 */     // GIR_Coverage, 4437,
     /* 1544381 */     GIR_EraseRootFromParent_Done,
     /* 1544382 */   // Label 21362: @1544382
     /* 1544382 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1544468), // Rule ID 4446 //
     /* 1544387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1544390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1544404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1544410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1544417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544433 */     // MIs[0] policy
     /* 1544433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1544446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544467 */     // GIR_Coverage, 4446,
     /* 1544467 */     GIR_EraseRootFromParent_Done,
     /* 1544468 */   // Label 21363: @1544468
     /* 1544468 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1544554), // Rule ID 4447 //
     /* 1544473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1544476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1544490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1544496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1544503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544519 */     // MIs[0] policy
     /* 1544519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544529 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1544532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544553 */     // GIR_Coverage, 4447,
     /* 1544553 */     GIR_EraseRootFromParent_Done,
     /* 1544554 */   // Label 21364: @1544554
     /* 1544554 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1544640), // Rule ID 4456 //
     /* 1544559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1544562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1544576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1544582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1544589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544605 */     // MIs[0] policy
     /* 1544605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1544618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544639 */     // GIR_Coverage, 4456,
     /* 1544639 */     GIR_EraseRootFromParent_Done,
     /* 1544640 */   // Label 21365: @1544640
     /* 1544640 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1544726), // Rule ID 4457 //
     /* 1544645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1544648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1544662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1544668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1544675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544691 */     // MIs[0] policy
     /* 1544691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1544704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544725 */     // GIR_Coverage, 4457,
     /* 1544725 */     GIR_EraseRootFromParent_Done,
     /* 1544726 */   // Label 21366: @1544726
     /* 1544726 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1544812), // Rule ID 4466 //
     /* 1544731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1544734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1544748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1544754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1544761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544777 */     // MIs[0] policy
     /* 1544777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544787 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1544790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544811 */     // GIR_Coverage, 4466,
     /* 1544811 */     GIR_EraseRootFromParent_Done,
     /* 1544812 */   // Label 21367: @1544812
     /* 1544812 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1544898), // Rule ID 4467 //
     /* 1544817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1544820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1544834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1544840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1544847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544863 */     // MIs[0] policy
     /* 1544863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544873 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1544876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544897 */     // GIR_Coverage, 4467,
     /* 1544897 */     GIR_EraseRootFromParent_Done,
     /* 1544898 */   // Label 21368: @1544898
     /* 1544898 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1544984), // Rule ID 4476 //
     /* 1544903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1544906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1544920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1544926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1544933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1544949 */     // MIs[0] policy
     /* 1544949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544959 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1544962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1544966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1544972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544983 */     // GIR_Coverage, 4476,
     /* 1544983 */     GIR_EraseRootFromParent_Done,
     /* 1544984 */   // Label 21369: @1544984
     /* 1544984 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1545070), // Rule ID 4477 //
     /* 1544989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1544992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1544997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1545006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1545012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1545019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545035 */     // MIs[0] policy
     /* 1545035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545045 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1545048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545069 */     // GIR_Coverage, 4477,
     /* 1545069 */     GIR_EraseRootFromParent_Done,
     /* 1545070 */   // Label 21370: @1545070
     /* 1545070 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1545156), // Rule ID 4480 //
     /* 1545075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1545086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1545089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1545092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1545098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545121 */     // MIs[0] policy
     /* 1545121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545131 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1545134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545155 */     // GIR_Coverage, 4480,
     /* 1545155 */     GIR_EraseRootFromParent_Done,
     /* 1545156 */   // Label 21371: @1545156
     /* 1545156 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1545242), // Rule ID 4481 //
     /* 1545161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1545164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1545172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1545175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1545178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1545181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1545184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545207 */     // MIs[0] policy
     /* 1545207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545217 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1545220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545241 */     // GIR_Coverage, 4481,
     /* 1545241 */     GIR_EraseRootFromParent_Done,
     /* 1545242 */   // Label 21372: @1545242
     /* 1545242 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1545328), // Rule ID 4484 //
     /* 1545247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1545258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1545261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1545264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1545270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545293 */     // MIs[0] policy
     /* 1545293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545303 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1545306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545327 */     // GIR_Coverage, 4484,
     /* 1545327 */     GIR_EraseRootFromParent_Done,
     /* 1545328 */   // Label 21373: @1545328
     /* 1545328 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1545414), // Rule ID 4485 //
     /* 1545333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1545336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1545344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1545347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1545350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1545353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1545356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545379 */     // MIs[0] policy
     /* 1545379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545389 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1545392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545413 */     // GIR_Coverage, 4485,
     /* 1545413 */     GIR_EraseRootFromParent_Done,
     /* 1545414 */   // Label 21374: @1545414
     /* 1545414 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1545500), // Rule ID 4488 //
     /* 1545419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1545430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1545433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1545436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1545442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545465 */     // MIs[0] policy
     /* 1545465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1545478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545499 */     // GIR_Coverage, 4488,
     /* 1545499 */     GIR_EraseRootFromParent_Done,
     /* 1545500 */   // Label 21375: @1545500
     /* 1545500 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1545586), // Rule ID 4489 //
     /* 1545505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1545508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1545516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1545519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1545522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1545525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1545528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545551 */     // MIs[0] policy
     /* 1545551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1545564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545585 */     // GIR_Coverage, 4489,
     /* 1545585 */     GIR_EraseRootFromParent_Done,
     /* 1545586 */   // Label 21376: @1545586
     /* 1545586 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1545672), // Rule ID 4492 //
     /* 1545591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1545602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1545605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1545608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1545614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1545621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545637 */     // MIs[0] policy
     /* 1545637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1545650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545671 */     // GIR_Coverage, 4492,
     /* 1545671 */     GIR_EraseRootFromParent_Done,
     /* 1545672 */   // Label 21377: @1545672
     /* 1545672 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1545758), // Rule ID 4493 //
     /* 1545677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1545680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1545688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1545691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1545694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1545697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1545700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1545707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545723 */     // MIs[0] policy
     /* 1545723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1545736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545757 */     // GIR_Coverage, 4493,
     /* 1545757 */     GIR_EraseRootFromParent_Done,
     /* 1545758 */   // Label 21378: @1545758
     /* 1545758 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1545844), // Rule ID 4496 //
     /* 1545763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1545774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1545777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1545786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1545793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545809 */     // MIs[0] policy
     /* 1545809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545819 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1545822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545843 */     // GIR_Coverage, 4496,
     /* 1545843 */     GIR_EraseRootFromParent_Done,
     /* 1545844 */   // Label 21379: @1545844
     /* 1545844 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1545930), // Rule ID 4497 //
     /* 1545849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1545852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1545860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1545863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1545869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1545872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1545879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545895 */     // MIs[0] policy
     /* 1545895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545905 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1545908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1545918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1545926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545929 */     // GIR_Coverage, 4497,
     /* 1545929 */     GIR_EraseRootFromParent_Done,
     /* 1545930 */   // Label 21380: @1545930
     /* 1545930 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1546016), // Rule ID 4500 //
     /* 1545935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1545938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1545943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1545946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1545949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1545952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1545955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1545958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1545965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1545977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1545981 */     // MIs[0] policy
     /* 1545981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1545994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1545998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1546012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546015 */     // GIR_Coverage, 4500,
     /* 1546015 */     GIR_EraseRootFromParent_Done,
     /* 1546016 */   // Label 21381: @1546016
     /* 1546016 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1546102), // Rule ID 4501 //
     /* 1546021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1546032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1546035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1546038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1546044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1546051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546067 */     // MIs[0] policy
     /* 1546067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1546080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1546098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546101 */     // GIR_Coverage, 4501,
     /* 1546101 */     GIR_EraseRootFromParent_Done,
     /* 1546102 */   // Label 21382: @1546102
     /* 1546102 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1546188), // Rule ID 4504 //
     /* 1546107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1546110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1546124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1546130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546153 */     // MIs[0] policy
     /* 1546153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546163 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1546166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546187 */     // GIR_Coverage, 4504,
     /* 1546187 */     GIR_EraseRootFromParent_Done,
     /* 1546188 */   // Label 21383: @1546188
     /* 1546188 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1546274), // Rule ID 4505 //
     /* 1546193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1546210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1546216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546239 */     // MIs[0] policy
     /* 1546239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1546252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546273 */     // GIR_Coverage, 4505,
     /* 1546273 */     GIR_EraseRootFromParent_Done,
     /* 1546274 */   // Label 21384: @1546274
     /* 1546274 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1546360), // Rule ID 4508 //
     /* 1546279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1546282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1546296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1546302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546325 */     // MIs[0] policy
     /* 1546325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546335 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1546338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546359 */     // GIR_Coverage, 4508,
     /* 1546359 */     GIR_EraseRootFromParent_Done,
     /* 1546360 */   // Label 21385: @1546360
     /* 1546360 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1546446), // Rule ID 4509 //
     /* 1546365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1546382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1546388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546411 */     // MIs[0] policy
     /* 1546411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546421 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1546424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546445 */     // GIR_Coverage, 4509,
     /* 1546445 */     GIR_EraseRootFromParent_Done,
     /* 1546446 */   // Label 21386: @1546446
     /* 1546446 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1546532), // Rule ID 4512 //
     /* 1546451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1546454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1546468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1546474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1546481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546497 */     // MIs[0] policy
     /* 1546497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1546510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546531 */     // GIR_Coverage, 4512,
     /* 1546531 */     GIR_EraseRootFromParent_Done,
     /* 1546532 */   // Label 21387: @1546532
     /* 1546532 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1546618), // Rule ID 4513 //
     /* 1546537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1546554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1546560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1546567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546583 */     // MIs[0] policy
     /* 1546583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1546596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546617 */     // GIR_Coverage, 4513,
     /* 1546617 */     GIR_EraseRootFromParent_Done,
     /* 1546618 */   // Label 21388: @1546618
     /* 1546618 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1546704), // Rule ID 4516 //
     /* 1546623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1546626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1546640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1546646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1546653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546669 */     // MIs[0] policy
     /* 1546669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546679 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1546682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546703 */     // GIR_Coverage, 4516,
     /* 1546703 */     GIR_EraseRootFromParent_Done,
     /* 1546704 */   // Label 21389: @1546704
     /* 1546704 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1546790), // Rule ID 4517 //
     /* 1546709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1546726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1546732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1546739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546755 */     // MIs[0] policy
     /* 1546755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546765 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1546768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546789 */     // GIR_Coverage, 4517,
     /* 1546789 */     GIR_EraseRootFromParent_Done,
     /* 1546790 */   // Label 21390: @1546790
     /* 1546790 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1546876), // Rule ID 4520 //
     /* 1546795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1546798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1546812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1546818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1546825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546841 */     // MIs[0] policy
     /* 1546841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546851 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1546854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546875 */     // GIR_Coverage, 4520,
     /* 1546875 */     GIR_EraseRootFromParent_Done,
     /* 1546876 */   // Label 21391: @1546876
     /* 1546876 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1546962), // Rule ID 4521 //
     /* 1546881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1546884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1546898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1546901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1546904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1546911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1546923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546927 */     // MIs[0] policy
     /* 1546927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546937 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1546940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1546950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546961 */     // GIR_Coverage, 4521,
     /* 1546961 */     GIR_EraseRootFromParent_Done,
     /* 1546962 */   // Label 21392: @1546962
     /* 1546962 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1547048), // Rule ID 4524 //
     /* 1546967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1546970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1546975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1546984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1546987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1546990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547013 */     // MIs[0] policy
     /* 1547013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547023 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1547026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547047 */     // GIR_Coverage, 4524,
     /* 1547047 */     GIR_EraseRootFromParent_Done,
     /* 1547048 */   // Label 21393: @1547048
     /* 1547048 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1547134), // Rule ID 4525 //
     /* 1547053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1547056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1547070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1547073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1547076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1547083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547099 */     // MIs[0] policy
     /* 1547099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1547112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547133 */     // GIR_Coverage, 4525,
     /* 1547133 */     GIR_EraseRootFromParent_Done,
     /* 1547134 */   // Label 21394: @1547134
     /* 1547134 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1547220), // Rule ID 4528 //
     /* 1547139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1547142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1547156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1547159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1547162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547185 */     // MIs[0] policy
     /* 1547185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1547198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547219 */     // GIR_Coverage, 4528,
     /* 1547219 */     GIR_EraseRootFromParent_Done,
     /* 1547220 */   // Label 21395: @1547220
     /* 1547220 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1547306), // Rule ID 4529 //
     /* 1547225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1547228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1547242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1547245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1547248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547271 */     // MIs[0] policy
     /* 1547271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1547284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547305 */     // GIR_Coverage, 4529,
     /* 1547305 */     GIR_EraseRootFromParent_Done,
     /* 1547306 */   // Label 21396: @1547306
     /* 1547306 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1547392), // Rule ID 4532 //
     /* 1547311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1547314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1547328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1547331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1547334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547357 */     // MIs[0] policy
     /* 1547357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1547370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547391 */     // GIR_Coverage, 4532,
     /* 1547391 */     GIR_EraseRootFromParent_Done,
     /* 1547392 */   // Label 21397: @1547392
     /* 1547392 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1547478), // Rule ID 4533 //
     /* 1547397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1547400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1547414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1547417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1547420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547443 */     // MIs[0] policy
     /* 1547443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547453 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1547456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547477 */     // GIR_Coverage, 4533,
     /* 1547477 */     GIR_EraseRootFromParent_Done,
     /* 1547478 */   // Label 21398: @1547478
     /* 1547478 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1547564), // Rule ID 4536 //
     /* 1547483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1547486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1547500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1547503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1547506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547529 */     // MIs[0] policy
     /* 1547529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1547542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547563 */     // GIR_Coverage, 4536,
     /* 1547563 */     GIR_EraseRootFromParent_Done,
     /* 1547564 */   // Label 21399: @1547564
     /* 1547564 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1547650), // Rule ID 4537 //
     /* 1547569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1547572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1547577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1547586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1547589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1547592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1547611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547615 */     // MIs[0] policy
     /* 1547615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1547628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547649 */     // GIR_Coverage, 4537,
     /* 1547649 */     GIR_EraseRootFromParent_Done,
     /* 1547650 */   // Label 21400: @1547650
     /* 1547650 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1547736), // Rule ID 4546 //
     /* 1547655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1547658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1547663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1547666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1547669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1547675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1547678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1547685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547701 */     // MIs[0] policy
     /* 1547701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547711 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1547714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1547732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547735 */     // GIR_Coverage, 4546,
     /* 1547735 */     GIR_EraseRootFromParent_Done,
     /* 1547736 */   // Label 21401: @1547736
     /* 1547736 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1547822), // Rule ID 4547 //
     /* 1547741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1547744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1547749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1547752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1547755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1547761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1547764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1547771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547787 */     // MIs[0] policy
     /* 1547787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547797 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1547800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1547818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547821 */     // GIR_Coverage, 4547,
     /* 1547821 */     GIR_EraseRootFromParent_Done,
     /* 1547822 */   // Label 21402: @1547822
     /* 1547822 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1547908), // Rule ID 4556 //
     /* 1547827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1547830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1547835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1547838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1547841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1547847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1547850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1547857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547873 */     // MIs[0] policy
     /* 1547873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1547886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1547904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547907 */     // GIR_Coverage, 4556,
     /* 1547907 */     GIR_EraseRootFromParent_Done,
     /* 1547908 */   // Label 21403: @1547908
     /* 1547908 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1547994), // Rule ID 4557 //
     /* 1547913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1547916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1547921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1547924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1547927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1547933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1547936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1547943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547959 */     // MIs[0] policy
     /* 1547959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547969 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1547972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1547982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1547990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547993 */     // GIR_Coverage, 4557,
     /* 1547993 */     GIR_EraseRootFromParent_Done,
     /* 1547994 */   // Label 21404: @1547994
     /* 1547994 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1548080), // Rule ID 4566 //
     /* 1547999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1548010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1548013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1548016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1548019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1548022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548045 */     // MIs[0] policy
     /* 1548045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548055 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1548058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548079 */     // GIR_Coverage, 4566,
     /* 1548079 */     GIR_EraseRootFromParent_Done,
     /* 1548080 */   // Label 21405: @1548080
     /* 1548080 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1548166), // Rule ID 4567 //
     /* 1548085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1548096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1548099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1548102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1548105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1548108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548131 */     // MIs[0] policy
     /* 1548131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1548144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548165 */     // GIR_Coverage, 4567,
     /* 1548165 */     GIR_EraseRootFromParent_Done,
     /* 1548166 */   // Label 21406: @1548166
     /* 1548166 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1548252), // Rule ID 4576 //
     /* 1548171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1548182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1548185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1548188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1548191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1548194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1548201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548217 */     // MIs[0] policy
     /* 1548217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1548230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548251 */     // GIR_Coverage, 4576,
     /* 1548251 */     GIR_EraseRootFromParent_Done,
     /* 1548252 */   // Label 21407: @1548252
     /* 1548252 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1548338), // Rule ID 4577 //
     /* 1548257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1548268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1548271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1548274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1548277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1548280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1548287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548303 */     // MIs[0] policy
     /* 1548303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548313 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1548316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548337 */     // GIR_Coverage, 4577,
     /* 1548337 */     GIR_EraseRootFromParent_Done,
     /* 1548338 */   // Label 21408: @1548338
     /* 1548338 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1548424), // Rule ID 4586 //
     /* 1548343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1548354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1548357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1548363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1548366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1548373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548389 */     // MIs[0] policy
     /* 1548389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548399 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1548402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548423 */     // GIR_Coverage, 4586,
     /* 1548423 */     GIR_EraseRootFromParent_Done,
     /* 1548424 */   // Label 21409: @1548424
     /* 1548424 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1548510), // Rule ID 4587 //
     /* 1548429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1548440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1548443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1548449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1548452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1548459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548475 */     // MIs[0] policy
     /* 1548475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548485 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1548488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548509 */     // GIR_Coverage, 4587,
     /* 1548509 */     GIR_EraseRootFromParent_Done,
     /* 1548510 */   // Label 21410: @1548510
     /* 1548510 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1548596), // Rule ID 4596 //
     /* 1548515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1548526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1548529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1548532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1548535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1548538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1548545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548561 */     // MIs[0] policy
     /* 1548561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548571 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1548574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548595 */     // GIR_Coverage, 4596,
     /* 1548595 */     GIR_EraseRootFromParent_Done,
     /* 1548596 */   // Label 21411: @1548596
     /* 1548596 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1548682), // Rule ID 4597 //
     /* 1548601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1548612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1548615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1548618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1548621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1548624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1548631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548647 */     // MIs[0] policy
     /* 1548647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548657 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1548660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1548678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548681 */     // GIR_Coverage, 4597,
     /* 1548681 */     GIR_EraseRootFromParent_Done,
     /* 1548682 */   // Label 21412: @1548682
     /* 1548682 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1548768), // Rule ID 4606 //
     /* 1548687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1548710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548733 */     // MIs[0] policy
     /* 1548733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1548746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548767 */     // GIR_Coverage, 4606,
     /* 1548767 */     GIR_EraseRootFromParent_Done,
     /* 1548768 */   // Label 21413: @1548768
     /* 1548768 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1548854), // Rule ID 4607 //
     /* 1548773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1548796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548819 */     // MIs[0] policy
     /* 1548819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548829 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1548832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548853 */     // GIR_Coverage, 4607,
     /* 1548853 */     GIR_EraseRootFromParent_Done,
     /* 1548854 */   // Label 21414: @1548854
     /* 1548854 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1548940), // Rule ID 4616 //
     /* 1548859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1548862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1548882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548905 */     // MIs[0] policy
     /* 1548905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1548918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1548928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548939 */     // GIR_Coverage, 4616,
     /* 1548939 */     GIR_EraseRootFromParent_Done,
     /* 1548940 */   // Label 21415: @1548940
     /* 1548940 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1549026), // Rule ID 4617 //
     /* 1548945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1548948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1548953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1548968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548991 */     // MIs[0] policy
     /* 1548991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1549004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549025 */     // GIR_Coverage, 4617,
     /* 1549025 */     GIR_EraseRootFromParent_Done,
     /* 1549026 */   // Label 21416: @1549026
     /* 1549026 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1549112), // Rule ID 4626 //
     /* 1549031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1549034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1549048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1549054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549077 */     // MIs[0] policy
     /* 1549077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1549090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549111 */     // GIR_Coverage, 4626,
     /* 1549111 */     GIR_EraseRootFromParent_Done,
     /* 1549112 */   // Label 21417: @1549112
     /* 1549112 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1549198), // Rule ID 4627 //
     /* 1549117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1549120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1549134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1549140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549163 */     // MIs[0] policy
     /* 1549163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1549176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549197 */     // GIR_Coverage, 4627,
     /* 1549197 */     GIR_EraseRootFromParent_Done,
     /* 1549198 */   // Label 21418: @1549198
     /* 1549198 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1549284), // Rule ID 4636 //
     /* 1549203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1549206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1549220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1549226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549249 */     // MIs[0] policy
     /* 1549249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549259 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1549262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549283 */     // GIR_Coverage, 4636,
     /* 1549283 */     GIR_EraseRootFromParent_Done,
     /* 1549284 */   // Label 21419: @1549284
     /* 1549284 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1549370), // Rule ID 4637 //
     /* 1549289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1549292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1549306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1549312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549335 */     // MIs[0] policy
     /* 1549335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549345 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1549348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549369 */     // GIR_Coverage, 4637,
     /* 1549369 */     GIR_EraseRootFromParent_Done,
     /* 1549370 */   // Label 21420: @1549370
     /* 1549370 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1549456), // Rule ID 4646 //
     /* 1549375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1549378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1549392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1549398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1549405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549421 */     // MIs[0] policy
     /* 1549421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549431 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1549434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549455 */     // GIR_Coverage, 4646,
     /* 1549455 */     GIR_EraseRootFromParent_Done,
     /* 1549456 */   // Label 21421: @1549456
     /* 1549456 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1549542), // Rule ID 4647 //
     /* 1549461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1549464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1549478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1549484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1549491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549507 */     // MIs[0] policy
     /* 1549507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549517 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1549520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549541 */     // GIR_Coverage, 4647,
     /* 1549541 */     GIR_EraseRootFromParent_Done,
     /* 1549542 */   // Label 21422: @1549542
     /* 1549542 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1549628), // Rule ID 4656 //
     /* 1549547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1549550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1549564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1549570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1549577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549593 */     // MIs[0] policy
     /* 1549593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549603 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1549606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549627 */     // GIR_Coverage, 4656,
     /* 1549627 */     GIR_EraseRootFromParent_Done,
     /* 1549628 */   // Label 21423: @1549628
     /* 1549628 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1549714), // Rule ID 4657 //
     /* 1549633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1549636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1549650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1549656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1549663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549679 */     // MIs[0] policy
     /* 1549679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549689 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1549692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549713 */     // GIR_Coverage, 4657,
     /* 1549713 */     GIR_EraseRootFromParent_Done,
     /* 1549714 */   // Label 21424: @1549714
     /* 1549714 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1549800), // Rule ID 4666 //
     /* 1549719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1549722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1549736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1549742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549765 */     // MIs[0] policy
     /* 1549765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1549778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549799 */     // GIR_Coverage, 4666,
     /* 1549799 */     GIR_EraseRootFromParent_Done,
     /* 1549800 */   // Label 21425: @1549800
     /* 1549800 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1549886), // Rule ID 4667 //
     /* 1549805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1549808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1549822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1549828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549851 */     // MIs[0] policy
     /* 1549851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1549864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549885 */     // GIR_Coverage, 4667,
     /* 1549885 */     GIR_EraseRootFromParent_Done,
     /* 1549886 */   // Label 21426: @1549886
     /* 1549886 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1549972), // Rule ID 4676 //
     /* 1549891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1549894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1549908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1549914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549937 */     // MIs[0] policy
     /* 1549937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549947 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1549950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1549960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549971 */     // GIR_Coverage, 4676,
     /* 1549971 */     GIR_EraseRootFromParent_Done,
     /* 1549972 */   // Label 21427: @1549972
     /* 1549972 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1550058), // Rule ID 4677 //
     /* 1549977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1549980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1549985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1549994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1550000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1550007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550023 */     // MIs[0] policy
     /* 1550023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550033 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1550036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550057 */     // GIR_Coverage, 4677,
     /* 1550057 */     GIR_EraseRootFromParent_Done,
     /* 1550058 */   // Label 21428: @1550058
     /* 1550058 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1550144), // Rule ID 4686 //
     /* 1550063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1550066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1550080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1550086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550109 */     // MIs[0] policy
     /* 1550109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550119 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1550122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550143 */     // GIR_Coverage, 4686,
     /* 1550143 */     GIR_EraseRootFromParent_Done,
     /* 1550144 */   // Label 21429: @1550144
     /* 1550144 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1550230), // Rule ID 4687 //
     /* 1550149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1550152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1550166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1550172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550195 */     // MIs[0] policy
     /* 1550195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550205 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1550208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550229 */     // GIR_Coverage, 4687,
     /* 1550229 */     GIR_EraseRootFromParent_Done,
     /* 1550230 */   // Label 21430: @1550230
     /* 1550230 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1550316), // Rule ID 4690 //
     /* 1550235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1550238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1550246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1550249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1550255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1550258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550281 */     // MIs[0] policy
     /* 1550281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1550294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550315 */     // GIR_Coverage, 4690,
     /* 1550315 */     GIR_EraseRootFromParent_Done,
     /* 1550316 */   // Label 21431: @1550316
     /* 1550316 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1550402), // Rule ID 4691 //
     /* 1550321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1550324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1550332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1550335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1550341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1550344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550367 */     // MIs[0] policy
     /* 1550367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550377 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1550380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550401 */     // GIR_Coverage, 4691,
     /* 1550401 */     GIR_EraseRootFromParent_Done,
     /* 1550402 */   // Label 21432: @1550402
     /* 1550402 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1550488), // Rule ID 4694 //
     /* 1550407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1550410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1550427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1550430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550453 */     // MIs[0] policy
     /* 1550453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550463 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1550466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550487 */     // GIR_Coverage, 4694,
     /* 1550487 */     GIR_EraseRootFromParent_Done,
     /* 1550488 */   // Label 21433: @1550488
     /* 1550488 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1550574), // Rule ID 4695 //
     /* 1550493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1550496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1550513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1550516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550539 */     // MIs[0] policy
     /* 1550539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1550552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550573 */     // GIR_Coverage, 4695,
     /* 1550573 */     GIR_EraseRootFromParent_Done,
     /* 1550574 */   // Label 21434: @1550574
     /* 1550574 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1550660), // Rule ID 4698 //
     /* 1550579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1550582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1550590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1550593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1550599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1550602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550625 */     // MIs[0] policy
     /* 1550625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550635 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1550638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550659 */     // GIR_Coverage, 4698,
     /* 1550659 */     GIR_EraseRootFromParent_Done,
     /* 1550660 */   // Label 21435: @1550660
     /* 1550660 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1550746), // Rule ID 4699 //
     /* 1550665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1550668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1550676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1550679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1550685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1550688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550711 */     // MIs[0] policy
     /* 1550711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1550724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550745 */     // GIR_Coverage, 4699,
     /* 1550745 */     GIR_EraseRootFromParent_Done,
     /* 1550746 */   // Label 21436: @1550746
     /* 1550746 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1550832), // Rule ID 4702 //
     /* 1550751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1550754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1550762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1550765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1550771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1550774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1550781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550797 */     // MIs[0] policy
     /* 1550797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1550810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550831 */     // GIR_Coverage, 4702,
     /* 1550831 */     GIR_EraseRootFromParent_Done,
     /* 1550832 */   // Label 21437: @1550832
     /* 1550832 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1550918), // Rule ID 4703 //
     /* 1550837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1550840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1550848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1550851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1550857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1550860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1550867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550883 */     // MIs[0] policy
     /* 1550883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1550896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1550914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550917 */     // GIR_Coverage, 4703,
     /* 1550917 */     GIR_EraseRootFromParent_Done,
     /* 1550918 */   // Label 21438: @1550918
     /* 1550918 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1551004), // Rule ID 4706 //
     /* 1550923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1550926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1550931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1550934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1550937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1550943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1550946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1550953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1550965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550969 */     // MIs[0] policy
     /* 1550969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550979 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1550982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1550992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1551000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551003 */     // GIR_Coverage, 4706,
     /* 1551003 */     GIR_EraseRootFromParent_Done,
     /* 1551004 */   // Label 21439: @1551004
     /* 1551004 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1551090), // Rule ID 4707 //
     /* 1551009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1551020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1551023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1551032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551055 */     // MIs[0] policy
     /* 1551055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551065 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1551068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1551086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551089 */     // GIR_Coverage, 4707,
     /* 1551089 */     GIR_EraseRootFromParent_Done,
     /* 1551090 */   // Label 21440: @1551090
     /* 1551090 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1551176), // Rule ID 4710 //
     /* 1551095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1551118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551141 */     // MIs[0] policy
     /* 1551141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1551154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1551172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551175 */     // GIR_Coverage, 4710,
     /* 1551175 */     GIR_EraseRootFromParent_Done,
     /* 1551176 */   // Label 21441: @1551176
     /* 1551176 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1551262), // Rule ID 4711 //
     /* 1551181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1551204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551227 */     // MIs[0] policy
     /* 1551227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551237 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1551240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1551258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551261 */     // GIR_Coverage, 4711,
     /* 1551261 */     GIR_EraseRootFromParent_Done,
     /* 1551262 */   // Label 21442: @1551262
     /* 1551262 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1551348), // Rule ID 4714 //
     /* 1551267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1551284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1551290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551313 */     // MIs[0] policy
     /* 1551313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1551326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551347 */     // GIR_Coverage, 4714,
     /* 1551347 */     GIR_EraseRootFromParent_Done,
     /* 1551348 */   // Label 21443: @1551348
     /* 1551348 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1551434), // Rule ID 4715 //
     /* 1551353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1551370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1551376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551399 */     // MIs[0] policy
     /* 1551399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1551412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551433 */     // GIR_Coverage, 4715,
     /* 1551433 */     GIR_EraseRootFromParent_Done,
     /* 1551434 */   // Label 21444: @1551434
     /* 1551434 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1551520), // Rule ID 4718 //
     /* 1551439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1551462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551485 */     // MIs[0] policy
     /* 1551485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551495 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1551498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551519 */     // GIR_Coverage, 4718,
     /* 1551519 */     GIR_EraseRootFromParent_Done,
     /* 1551520 */   // Label 21445: @1551520
     /* 1551520 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1551606), // Rule ID 4719 //
     /* 1551525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1551548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551571 */     // MIs[0] policy
     /* 1551571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1551584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551605 */     // GIR_Coverage, 4719,
     /* 1551605 */     GIR_EraseRootFromParent_Done,
     /* 1551606 */   // Label 21446: @1551606
     /* 1551606 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1551692), // Rule ID 4722 //
     /* 1551611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1551634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551657 */     // MIs[0] policy
     /* 1551657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1551670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551691 */     // GIR_Coverage, 4722,
     /* 1551691 */     GIR_EraseRootFromParent_Done,
     /* 1551692 */   // Label 21447: @1551692
     /* 1551692 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1551778), // Rule ID 4723 //
     /* 1551697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1551720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551743 */     // MIs[0] policy
     /* 1551743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1551756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551777 */     // GIR_Coverage, 4723,
     /* 1551777 */     GIR_EraseRootFromParent_Done,
     /* 1551778 */   // Label 21448: @1551778
     /* 1551778 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1551864), // Rule ID 4726 //
     /* 1551783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1551806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551829 */     // MIs[0] policy
     /* 1551829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1551842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551863 */     // GIR_Coverage, 4726,
     /* 1551863 */     GIR_EraseRootFromParent_Done,
     /* 1551864 */   // Label 21449: @1551864
     /* 1551864 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1551950), // Rule ID 4727 //
     /* 1551869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1551872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1551889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1551892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551915 */     // MIs[0] policy
     /* 1551915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551925 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1551928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1551938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551949 */     // GIR_Coverage, 4727,
     /* 1551949 */     GIR_EraseRootFromParent_Done,
     /* 1551950 */   // Label 21450: @1551950
     /* 1551950 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1552036), // Rule ID 4730 //
     /* 1551955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1551958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1551963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1551972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1551975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1551978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1551997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552001 */     // MIs[0] policy
     /* 1552001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552011 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1552014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552035 */     // GIR_Coverage, 4730,
     /* 1552035 */     GIR_EraseRootFromParent_Done,
     /* 1552036 */   // Label 21451: @1552036
     /* 1552036 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1552122), // Rule ID 4731 //
     /* 1552041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1552044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1552058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1552061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1552064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552087 */     // MIs[0] policy
     /* 1552087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552097 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1552100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552121 */     // GIR_Coverage, 4731,
     /* 1552121 */     GIR_EraseRootFromParent_Done,
     /* 1552122 */   // Label 21452: @1552122
     /* 1552122 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1552208), // Rule ID 4734 //
     /* 1552127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1552130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1552144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1552147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1552150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552173 */     // MIs[0] policy
     /* 1552173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1552186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552207 */     // GIR_Coverage, 4734,
     /* 1552207 */     GIR_EraseRootFromParent_Done,
     /* 1552208 */   // Label 21453: @1552208
     /* 1552208 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1552294), // Rule ID 4735 //
     /* 1552213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1552216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1552230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1552233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1552236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552259 */     // MIs[0] policy
     /* 1552259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552269 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1552272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552293 */     // GIR_Coverage, 4735,
     /* 1552293 */     GIR_EraseRootFromParent_Done,
     /* 1552294 */   // Label 21454: @1552294
     /* 1552294 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1552380), // Rule ID 4738 //
     /* 1552299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1552302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1552319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1552322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552345 */     // MIs[0] policy
     /* 1552345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1552358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552379 */     // GIR_Coverage, 4738,
     /* 1552379 */     GIR_EraseRootFromParent_Done,
     /* 1552380 */   // Label 21455: @1552380
     /* 1552380 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1552466), // Rule ID 4739 //
     /* 1552385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1552388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1552405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1552408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552431 */     // MIs[0] policy
     /* 1552431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1552444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552465 */     // GIR_Coverage, 4739,
     /* 1552465 */     GIR_EraseRootFromParent_Done,
     /* 1552466 */   // Label 21456: @1552466
     /* 1552466 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1552552), // Rule ID 4742 //
     /* 1552471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1552474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1552491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1552494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552517 */     // MIs[0] policy
     /* 1552517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1552530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552551 */     // GIR_Coverage, 4742,
     /* 1552551 */     GIR_EraseRootFromParent_Done,
     /* 1552552 */   // Label 21457: @1552552
     /* 1552552 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1552638), // Rule ID 4743 //
     /* 1552557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1552560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1552577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1552580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552603 */     // MIs[0] policy
     /* 1552603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552613 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1552616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552637 */     // GIR_Coverage, 4743,
     /* 1552637 */     GIR_EraseRootFromParent_Done,
     /* 1552638 */   // Label 21458: @1552638
     /* 1552638 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1552724), // Rule ID 4746 //
     /* 1552643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1552646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1552663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1552666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552689 */     // MIs[0] policy
     /* 1552689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1552702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552723 */     // GIR_Coverage, 4746,
     /* 1552723 */     GIR_EraseRootFromParent_Done,
     /* 1552724 */   // Label 21459: @1552724
     /* 1552724 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1552810), // Rule ID 4747 //
     /* 1552729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1552732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1552737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1552749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1552752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1552771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552775 */     // MIs[0] policy
     /* 1552775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552785 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1552788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552809 */     // GIR_Coverage, 4747,
     /* 1552809 */     GIR_EraseRootFromParent_Done,
     /* 1552810 */   // Label 21460: @1552810
     /* 1552810 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1552896), // Rule ID 5624 //
     /* 1552815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1552818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1552823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1552826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1552829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1552832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1552835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1552838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552861 */     // MIs[0] policy
     /* 1552861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1552874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1552892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552895 */     // GIR_Coverage, 5624,
     /* 1552895 */     GIR_EraseRootFromParent_Done,
     /* 1552896 */   // Label 21461: @1552896
     /* 1552896 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1552982), // Rule ID 5625 //
     /* 1552901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1552904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1552909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1552912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1552915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1552918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1552921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1552924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552947 */     // MIs[0] policy
     /* 1552947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552957 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1552960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1552970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1552978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552981 */     // GIR_Coverage, 5625,
     /* 1552981 */     GIR_EraseRootFromParent_Done,
     /* 1552982 */   // Label 21462: @1552982
     /* 1552982 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1553068), // Rule ID 5628 //
     /* 1552987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1552990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1552995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1552998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1553001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1553004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1553007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1553010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553033 */     // MIs[0] policy
     /* 1553033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1553046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1553064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553067 */     // GIR_Coverage, 5628,
     /* 1553067 */     GIR_EraseRootFromParent_Done,
     /* 1553068 */   // Label 21463: @1553068
     /* 1553068 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1553154), // Rule ID 5629 //
     /* 1553073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1553084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1553087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1553090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1553093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1553096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553119 */     // MIs[0] policy
     /* 1553119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553129 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1553132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1553150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553153 */     // GIR_Coverage, 5629,
     /* 1553153 */     GIR_EraseRootFromParent_Done,
     /* 1553154 */   // Label 21464: @1553154
     /* 1553154 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1553240), // Rule ID 5632 //
     /* 1553159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1553162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1553170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1553173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1553176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1553179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1553182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553205 */     // MIs[0] policy
     /* 1553205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553215 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1553236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553239 */     // GIR_Coverage, 5632,
     /* 1553239 */     GIR_EraseRootFromParent_Done,
     /* 1553240 */   // Label 21465: @1553240
     /* 1553240 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1553326), // Rule ID 5633 //
     /* 1553245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1553256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1553259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1553262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1553265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1553268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553291 */     // MIs[0] policy
     /* 1553291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1553322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553325 */     // GIR_Coverage, 5633,
     /* 1553325 */     GIR_EraseRootFromParent_Done,
     /* 1553326 */   // Label 21466: @1553326
     /* 1553326 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1553412), // Rule ID 5636 //
     /* 1553331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1553334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1553342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1553345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1553351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1553354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553377 */     // MIs[0] policy
     /* 1553377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553387 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1553390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553411 */     // GIR_Coverage, 5636,
     /* 1553411 */     GIR_EraseRootFromParent_Done,
     /* 1553412 */   // Label 21467: @1553412
     /* 1553412 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1553498), // Rule ID 5637 //
     /* 1553417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1553428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1553431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1553437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1553440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553463 */     // MIs[0] policy
     /* 1553463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1553476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553497 */     // GIR_Coverage, 5637,
     /* 1553497 */     GIR_EraseRootFromParent_Done,
     /* 1553498 */   // Label 21468: @1553498
     /* 1553498 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1553584), // Rule ID 5640 //
     /* 1553503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1553506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1553523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1553526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553549 */     // MIs[0] policy
     /* 1553549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553583 */     // GIR_Coverage, 5640,
     /* 1553583 */     GIR_EraseRootFromParent_Done,
     /* 1553584 */   // Label 21469: @1553584
     /* 1553584 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1553670), // Rule ID 5641 //
     /* 1553589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1553609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1553612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553635 */     // MIs[0] policy
     /* 1553635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553645 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553669 */     // GIR_Coverage, 5641,
     /* 1553669 */     GIR_EraseRootFromParent_Done,
     /* 1553670 */   // Label 21470: @1553670
     /* 1553670 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1553756), // Rule ID 5644 //
     /* 1553675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1553678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1553695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1553698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553721 */     // MIs[0] policy
     /* 1553721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553755 */     // GIR_Coverage, 5644,
     /* 1553755 */     GIR_EraseRootFromParent_Done,
     /* 1553756 */   // Label 21471: @1553756
     /* 1553756 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1553842), // Rule ID 5645 //
     /* 1553761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1553781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1553784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553807 */     // MIs[0] policy
     /* 1553807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553817 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1553820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553841 */     // GIR_Coverage, 5645,
     /* 1553841 */     GIR_EraseRootFromParent_Done,
     /* 1553842 */   // Label 21472: @1553842
     /* 1553842 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1553928), // Rule ID 5648 //
     /* 1553847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1553850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1553858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1553861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1553864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1553867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1553870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553893 */     // MIs[0] policy
     /* 1553893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553903 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1553906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1553916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1553924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553927 */     // GIR_Coverage, 5648,
     /* 1553927 */     GIR_EraseRootFromParent_Done,
     /* 1553928 */   // Label 21473: @1553928
     /* 1553928 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1554014), // Rule ID 5649 //
     /* 1553933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1553936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1553941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1553944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1553947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1553950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1553953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1553956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553979 */     // MIs[0] policy
     /* 1553979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1553992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554013 */     // GIR_Coverage, 5649,
     /* 1554013 */     GIR_EraseRootFromParent_Done,
     /* 1554014 */   // Label 21474: @1554014
     /* 1554014 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1554100), // Rule ID 5652 //
     /* 1554019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1554022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1554030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1554033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1554036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1554039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1554042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554065 */     // MIs[0] policy
     /* 1554065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554099 */     // GIR_Coverage, 5652,
     /* 1554099 */     GIR_EraseRootFromParent_Done,
     /* 1554100 */   // Label 21475: @1554100
     /* 1554100 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1554186), // Rule ID 5653 //
     /* 1554105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1554108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1554116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1554119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1554122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1554125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1554128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554151 */     // MIs[0] policy
     /* 1554151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554185 */     // GIR_Coverage, 5653,
     /* 1554185 */     GIR_EraseRootFromParent_Done,
     /* 1554186 */   // Label 21476: @1554186
     /* 1554186 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1554272), // Rule ID 5656 //
     /* 1554191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1554194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1554202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1554205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1554208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1554211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1554214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554237 */     // MIs[0] policy
     /* 1554237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554271 */     // GIR_Coverage, 5656,
     /* 1554271 */     GIR_EraseRootFromParent_Done,
     /* 1554272 */   // Label 21477: @1554272
     /* 1554272 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1554358), // Rule ID 5657 //
     /* 1554277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1554280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1554288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1554291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1554294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1554297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1554300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554323 */     // MIs[0] policy
     /* 1554323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554357 */     // GIR_Coverage, 5657,
     /* 1554357 */     GIR_EraseRootFromParent_Done,
     /* 1554358 */   // Label 21478: @1554358
     /* 1554358 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1554444), // Rule ID 5660 //
     /* 1554363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1554366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1554374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1554377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1554380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1554383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1554386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554409 */     // MIs[0] policy
     /* 1554409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554419 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554443 */     // GIR_Coverage, 5660,
     /* 1554443 */     GIR_EraseRootFromParent_Done,
     /* 1554444 */   // Label 21479: @1554444
     /* 1554444 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1554530), // Rule ID 5661 //
     /* 1554449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1554452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1554460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1554463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1554466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1554469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1554472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554495 */     // MIs[0] policy
     /* 1554495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554505 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1554508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554529 */     // GIR_Coverage, 5661,
     /* 1554529 */     GIR_EraseRootFromParent_Done,
     /* 1554530 */   // Label 21480: @1554530
     /* 1554530 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1554616), // Rule ID 5664 //
     /* 1554535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1554538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1554546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1554549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1554552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1554555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1554558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554581 */     // MIs[0] policy
     /* 1554581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1554594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554615 */     // GIR_Coverage, 5664,
     /* 1554615 */     GIR_EraseRootFromParent_Done,
     /* 1554616 */   // Label 21481: @1554616
     /* 1554616 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1554702), // Rule ID 5665 //
     /* 1554621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1554624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1554632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1554635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1554638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1554641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1554644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554667 */     // MIs[0] policy
     /* 1554667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1554680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554701 */     // GIR_Coverage, 5665,
     /* 1554701 */     GIR_EraseRootFromParent_Done,
     /* 1554702 */   // Label 21482: @1554702
     /* 1554702 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1554788), // Rule ID 5668 //
     /* 1554707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1554710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1554718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1554721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1554724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1554727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1554730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554753 */     // MIs[0] policy
     /* 1554753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554763 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1554766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554787 */     // GIR_Coverage, 5668,
     /* 1554787 */     GIR_EraseRootFromParent_Done,
     /* 1554788 */   // Label 21483: @1554788
     /* 1554788 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1554874), // Rule ID 5669 //
     /* 1554793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1554796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1554804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1554807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1554810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1554813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1554816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554839 */     // MIs[0] policy
     /* 1554839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1554852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554873 */     // GIR_Coverage, 5669,
     /* 1554873 */     GIR_EraseRootFromParent_Done,
     /* 1554874 */   // Label 21484: @1554874
     /* 1554874 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1554960), // Rule ID 5672 //
     /* 1554879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1554882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1554890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1554893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1554896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1554899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1554902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554925 */     // MIs[0] policy
     /* 1554925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554935 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1554938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1554948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1554956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554959 */     // GIR_Coverage, 5672,
     /* 1554959 */     GIR_EraseRootFromParent_Done,
     /* 1554960 */   // Label 21485: @1554960
     /* 1554960 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1555046), // Rule ID 5673 //
     /* 1554965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1554968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1554973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1554976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1554979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1554982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1554985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1554988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555011 */     // MIs[0] policy
     /* 1555011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555021 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1555024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1555042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555045 */     // GIR_Coverage, 5673,
     /* 1555045 */     GIR_EraseRootFromParent_Done,
     /* 1555046 */   // Label 21486: @1555046
     /* 1555046 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1555132), // Rule ID 5676 //
     /* 1555051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1555071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1555074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555097 */     // MIs[0] policy
     /* 1555097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1555110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555131 */     // GIR_Coverage, 5676,
     /* 1555131 */     GIR_EraseRootFromParent_Done,
     /* 1555132 */   // Label 21487: @1555132
     /* 1555132 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1555218), // Rule ID 5677 //
     /* 1555137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1555140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1555157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1555160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555183 */     // MIs[0] policy
     /* 1555183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1555196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555217 */     // GIR_Coverage, 5677,
     /* 1555217 */     GIR_EraseRootFromParent_Done,
     /* 1555218 */   // Label 21488: @1555218
     /* 1555218 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1555304), // Rule ID 5680 //
     /* 1555223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1555234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1555237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1555240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1555243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1555246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555269 */     // MIs[0] policy
     /* 1555269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555279 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1555282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555303 */     // GIR_Coverage, 5680,
     /* 1555303 */     GIR_EraseRootFromParent_Done,
     /* 1555304 */   // Label 21489: @1555304
     /* 1555304 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1555390), // Rule ID 5681 //
     /* 1555309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1555312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1555320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1555323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1555326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1555329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1555332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555355 */     // MIs[0] policy
     /* 1555355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555365 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1555368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555389 */     // GIR_Coverage, 5681,
     /* 1555389 */     GIR_EraseRootFromParent_Done,
     /* 1555390 */   // Label 21490: @1555390
     /* 1555390 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1555476), // Rule ID 5684 //
     /* 1555395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1555406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1555409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1555412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1555415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1555418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555441 */     // MIs[0] policy
     /* 1555441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555451 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1555454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555475 */     // GIR_Coverage, 5684,
     /* 1555475 */     GIR_EraseRootFromParent_Done,
     /* 1555476 */   // Label 21491: @1555476
     /* 1555476 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1555562), // Rule ID 5685 //
     /* 1555481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1555484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1555492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1555495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1555498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1555501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1555504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555527 */     // MIs[0] policy
     /* 1555527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555537 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1555540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555561 */     // GIR_Coverage, 5685,
     /* 1555561 */     GIR_EraseRootFromParent_Done,
     /* 1555562 */   // Label 21492: @1555562
     /* 1555562 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1555648), // Rule ID 5688 //
     /* 1555567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1555578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1555581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1555584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1555587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1555590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555613 */     // MIs[0] policy
     /* 1555613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1555626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555647 */     // GIR_Coverage, 5688,
     /* 1555647 */     GIR_EraseRootFromParent_Done,
     /* 1555648 */   // Label 21493: @1555648
     /* 1555648 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1555734), // Rule ID 5689 //
     /* 1555653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1555656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1555664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1555667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1555670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1555673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1555676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555699 */     // MIs[0] policy
     /* 1555699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1555712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555733 */     // GIR_Coverage, 5689,
     /* 1555733 */     GIR_EraseRootFromParent_Done,
     /* 1555734 */   // Label 21494: @1555734
     /* 1555734 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1555820), // Rule ID 5692 //
     /* 1555739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1555750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1555753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1555756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1555759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1555762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555785 */     // MIs[0] policy
     /* 1555785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555795 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1555798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555819 */     // GIR_Coverage, 5692,
     /* 1555819 */     GIR_EraseRootFromParent_Done,
     /* 1555820 */   // Label 21495: @1555820
     /* 1555820 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1555906), // Rule ID 5693 //
     /* 1555825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1555828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1555836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1555839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1555842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1555845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1555848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555871 */     // MIs[0] policy
     /* 1555871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1555884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555905 */     // GIR_Coverage, 5693,
     /* 1555905 */     GIR_EraseRootFromParent_Done,
     /* 1555906 */   // Label 21496: @1555906
     /* 1555906 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1555992), // Rule ID 5696 //
     /* 1555911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1555914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1555919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1555922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1555925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1555928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1555931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1555934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555957 */     // MIs[0] policy
     /* 1555957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555967 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1555970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1555980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555991 */     // GIR_Coverage, 5696,
     /* 1555991 */     GIR_EraseRootFromParent_Done,
     /* 1555992 */   // Label 21497: @1555992
     /* 1555992 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1556078), // Rule ID 5697 //
     /* 1555997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1556000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1556017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1556020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556043 */     // MIs[0] policy
     /* 1556043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556053 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1556056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556077 */     // GIR_Coverage, 5697,
     /* 1556077 */     GIR_EraseRootFromParent_Done,
     /* 1556078 */   // Label 21498: @1556078
     /* 1556078 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1556164), // Rule ID 5700 //
     /* 1556083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1556086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1556103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1556106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556129 */     // MIs[0] policy
     /* 1556129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1556142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556163 */     // GIR_Coverage, 5700,
     /* 1556163 */     GIR_EraseRootFromParent_Done,
     /* 1556164 */   // Label 21499: @1556164
     /* 1556164 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1556250), // Rule ID 5701 //
     /* 1556169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1556172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1556189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1556192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556215 */     // MIs[0] policy
     /* 1556215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556225 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1556228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556249 */     // GIR_Coverage, 5701,
     /* 1556249 */     GIR_EraseRootFromParent_Done,
     /* 1556250 */   // Label 21500: @1556250
     /* 1556250 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1556336), // Rule ID 5704 //
     /* 1556255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1556258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1556266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1556269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1556272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1556275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1556278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556301 */     // MIs[0] policy
     /* 1556301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1556314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556335 */     // GIR_Coverage, 5704,
     /* 1556335 */     GIR_EraseRootFromParent_Done,
     /* 1556336 */   // Label 21501: @1556336
     /* 1556336 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1556422), // Rule ID 5705 //
     /* 1556341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1556344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1556352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1556355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1556358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1556361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1556364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556387 */     // MIs[0] policy
     /* 1556387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1556400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556421 */     // GIR_Coverage, 5705,
     /* 1556421 */     GIR_EraseRootFromParent_Done,
     /* 1556422 */   // Label 21502: @1556422
     /* 1556422 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1556508), // Rule ID 5708 //
     /* 1556427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1556430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1556438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1556441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1556444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1556447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1556450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556473 */     // MIs[0] policy
     /* 1556473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556483 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1556486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556507 */     // GIR_Coverage, 5708,
     /* 1556507 */     GIR_EraseRootFromParent_Done,
     /* 1556508 */   // Label 21503: @1556508
     /* 1556508 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1556594), // Rule ID 5709 //
     /* 1556513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1556516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1556524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1556527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1556530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1556533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1556536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556559 */     // MIs[0] policy
     /* 1556559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1556572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556593 */     // GIR_Coverage, 5709,
     /* 1556593 */     GIR_EraseRootFromParent_Done,
     /* 1556594 */   // Label 21504: @1556594
     /* 1556594 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1556680), // Rule ID 5712 //
     /* 1556599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1556602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1556610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1556613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1556616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1556619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1556622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1556641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556645 */     // MIs[0] policy
     /* 1556645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556655 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1556658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1556676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556679 */     // GIR_Coverage, 5712,
     /* 1556679 */     GIR_EraseRootFromParent_Done,
     /* 1556680 */   // Label 21505: @1556680
     /* 1556680 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1556766), // Rule ID 5713 //
     /* 1556685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1556688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1556696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1556699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1556702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1556705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1556708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1556727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556731 */     // MIs[0] policy
     /* 1556731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556741 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1556744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1556762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556765 */     // GIR_Coverage, 5713,
     /* 1556765 */     GIR_EraseRootFromParent_Done,
     /* 1556766 */   // Label 21506: @1556766
     /* 1556766 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1556852), // Rule ID 5716 //
     /* 1556771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1556774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1556782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1556785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1556788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1556791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1556794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1556813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556817 */     // MIs[0] policy
     /* 1556817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556827 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1556830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1556848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556851 */     // GIR_Coverage, 5716,
     /* 1556851 */     GIR_EraseRootFromParent_Done,
     /* 1556852 */   // Label 21507: @1556852
     /* 1556852 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1556938), // Rule ID 5717 //
     /* 1556857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1556860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1556868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1556871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1556874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1556877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1556880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1556899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556903 */     // MIs[0] policy
     /* 1556903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556913 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1556916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1556926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1556934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556937 */     // GIR_Coverage, 5717,
     /* 1556937 */     GIR_EraseRootFromParent_Done,
     /* 1556938 */   // Label 21508: @1556938
     /* 1556938 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1557024), // Rule ID 5720 //
     /* 1556943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1556946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1556951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1556954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1556957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1556960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1556963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1556966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1556985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556989 */     // MIs[0] policy
     /* 1556989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556999 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1557020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557023 */     // GIR_Coverage, 5720,
     /* 1557023 */     GIR_EraseRootFromParent_Done,
     /* 1557024 */   // Label 21509: @1557024
     /* 1557024 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1557110), // Rule ID 5721 //
     /* 1557029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1557040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1557043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1557046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1557052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557075 */     // MIs[0] policy
     /* 1557075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557085 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1557106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557109 */     // GIR_Coverage, 5721,
     /* 1557109 */     GIR_EraseRootFromParent_Done,
     /* 1557110 */   // Label 21510: @1557110
     /* 1557110 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1557196), // Rule ID 5724 //
     /* 1557115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1557126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1557129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1557132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1557138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557161 */     // MIs[0] policy
     /* 1557161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557171 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1557174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557195 */     // GIR_Coverage, 5724,
     /* 1557195 */     GIR_EraseRootFromParent_Done,
     /* 1557196 */   // Label 21511: @1557196
     /* 1557196 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1557282), // Rule ID 5725 //
     /* 1557201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1557212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1557215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1557218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1557224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557247 */     // MIs[0] policy
     /* 1557247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557257 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1557260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557281 */     // GIR_Coverage, 5725,
     /* 1557281 */     GIR_EraseRootFromParent_Done,
     /* 1557282 */   // Label 21512: @1557282
     /* 1557282 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1557368), // Rule ID 5728 //
     /* 1557287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1557310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557333 */     // MIs[0] policy
     /* 1557333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557367 */     // GIR_Coverage, 5728,
     /* 1557367 */     GIR_EraseRootFromParent_Done,
     /* 1557368 */   // Label 21513: @1557368
     /* 1557368 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1557454), // Rule ID 5729 //
     /* 1557373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1557396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557419 */     // MIs[0] policy
     /* 1557419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557429 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557453 */     // GIR_Coverage, 5729,
     /* 1557453 */     GIR_EraseRootFromParent_Done,
     /* 1557454 */   // Label 21514: @1557454
     /* 1557454 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1557540), // Rule ID 5732 //
     /* 1557459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1557482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557505 */     // MIs[0] policy
     /* 1557505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557515 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557539 */     // GIR_Coverage, 5732,
     /* 1557539 */     GIR_EraseRootFromParent_Done,
     /* 1557540 */   // Label 21515: @1557540
     /* 1557540 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1557626), // Rule ID 5733 //
     /* 1557545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1557568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557591 */     // MIs[0] policy
     /* 1557591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1557604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557625 */     // GIR_Coverage, 5733,
     /* 1557625 */     GIR_EraseRootFromParent_Done,
     /* 1557626 */   // Label 21516: @1557626
     /* 1557626 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1557712), // Rule ID 5736 //
     /* 1557631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1557642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1557645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1557648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1557654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557677 */     // MIs[0] policy
     /* 1557677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557687 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1557690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1557708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557711 */     // GIR_Coverage, 5736,
     /* 1557711 */     GIR_EraseRootFromParent_Done,
     /* 1557712 */   // Label 21517: @1557712
     /* 1557712 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1557798), // Rule ID 5737 //
     /* 1557717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1557728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1557731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1557734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1557740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557763 */     // MIs[0] policy
     /* 1557763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557773 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10848:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1557776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1557794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557797 */     // GIR_Coverage, 5737,
     /* 1557797 */     GIR_EraseRootFromParent_Done,
     /* 1557798 */   // Label 21518: @1557798
     /* 1557798 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1557884), // Rule ID 5740 //
     /* 1557803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1557826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557849 */     // MIs[0] policy
     /* 1557849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557859 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1557862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557883 */     // GIR_Coverage, 5740,
     /* 1557883 */     GIR_EraseRootFromParent_Done,
     /* 1557884 */   // Label 21519: @1557884
     /* 1557884 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1557970), // Rule ID 5741 //
     /* 1557889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1557892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1557909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1557912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1557931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557935 */     // MIs[0] policy
     /* 1557935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1557948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1557954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1557956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1557958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557969 */     // GIR_Coverage, 5741,
     /* 1557969 */     GIR_EraseRootFromParent_Done,
     /* 1557970 */   // Label 21520: @1557970
     /* 1557970 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1558056), // Rule ID 5744 //
     /* 1557975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1557978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1557983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1557986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1557989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1557992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1557995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1557998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558021 */     // MIs[0] policy
     /* 1558021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558031 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1558034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558055 */     // GIR_Coverage, 5744,
     /* 1558055 */     GIR_EraseRootFromParent_Done,
     /* 1558056 */   // Label 21521: @1558056
     /* 1558056 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1558142), // Rule ID 5745 //
     /* 1558061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1558064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1558084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558107 */     // MIs[0] policy
     /* 1558107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1558120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558141 */     // GIR_Coverage, 5745,
     /* 1558141 */     GIR_EraseRootFromParent_Done,
     /* 1558142 */   // Label 21522: @1558142
     /* 1558142 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1558228), // Rule ID 5748 //
     /* 1558147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1558150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1558167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1558170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558193 */     // MIs[0] policy
     /* 1558193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558203 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1558206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558227 */     // GIR_Coverage, 5748,
     /* 1558227 */     GIR_EraseRootFromParent_Done,
     /* 1558228 */   // Label 21523: @1558228
     /* 1558228 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1558314), // Rule ID 5749 //
     /* 1558233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1558236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1558256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558279 */     // MIs[0] policy
     /* 1558279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558289 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1558292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558313 */     // GIR_Coverage, 5749,
     /* 1558313 */     GIR_EraseRootFromParent_Done,
     /* 1558314 */   // Label 21524: @1558314
     /* 1558314 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1558400), // Rule ID 5752 //
     /* 1558319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1558322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1558330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1558333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1558336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1558339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1558342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558365 */     // MIs[0] policy
     /* 1558365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1558378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558399 */     // GIR_Coverage, 5752,
     /* 1558399 */     GIR_EraseRootFromParent_Done,
     /* 1558400 */   // Label 21525: @1558400
     /* 1558400 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1558486), // Rule ID 5753 //
     /* 1558405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1558408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1558416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1558419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1558422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1558428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558451 */     // MIs[0] policy
     /* 1558451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1558464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558485 */     // GIR_Coverage, 5753,
     /* 1558485 */     GIR_EraseRootFromParent_Done,
     /* 1558486 */   // Label 21526: @1558486
     /* 1558486 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1558572), // Rule ID 5756 //
     /* 1558491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1558494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1558502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1558505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1558508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1558511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1558514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558537 */     // MIs[0] policy
     /* 1558537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558547 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1558550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558571 */     // GIR_Coverage, 5756,
     /* 1558571 */     GIR_EraseRootFromParent_Done,
     /* 1558572 */   // Label 21527: @1558572
     /* 1558572 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1558658), // Rule ID 5757 //
     /* 1558577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1558580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1558588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1558591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1558594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1558600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558623 */     // MIs[0] policy
     /* 1558623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558633 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1558636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558657 */     // GIR_Coverage, 5757,
     /* 1558657 */     GIR_EraseRootFromParent_Done,
     /* 1558658 */   // Label 21528: @1558658
     /* 1558658 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1558744), // Rule ID 5760 //
     /* 1558663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1558666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1558674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1558677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1558680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1558683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1558686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558709 */     // MIs[0] policy
     /* 1558709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1558722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558743 */     // GIR_Coverage, 5760,
     /* 1558743 */     GIR_EraseRootFromParent_Done,
     /* 1558744 */   // Label 21529: @1558744
     /* 1558744 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1558830), // Rule ID 5761 //
     /* 1558749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1558752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1558760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1558763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1558766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1558772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558795 */     // MIs[0] policy
     /* 1558795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558805 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1558808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1558826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558829 */     // GIR_Coverage, 5761,
     /* 1558829 */     GIR_EraseRootFromParent_Done,
     /* 1558830 */   // Label 21530: @1558830
     /* 1558830 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1558916), // Rule ID 5764 //
     /* 1558835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1558838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1558855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1558858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558881 */     // MIs[0] policy
     /* 1558881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1558894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558915 */     // GIR_Coverage, 5764,
     /* 1558915 */     GIR_EraseRootFromParent_Done,
     /* 1558916 */   // Label 21531: @1558916
     /* 1558916 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1559002), // Rule ID 5765 //
     /* 1558921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1558924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1558929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1558941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1558944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1558963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558967 */     // MIs[0] policy
     /* 1558967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1558980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1558986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1558988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1558990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559001 */     // GIR_Coverage, 5765,
     /* 1559001 */     GIR_EraseRootFromParent_Done,
     /* 1559002 */   // Label 21532: @1559002
     /* 1559002 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1559088), // Rule ID 5768 //
     /* 1559007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1559010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1559030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559053 */     // MIs[0] policy
     /* 1559053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559063 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1559066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559087 */     // GIR_Coverage, 5768,
     /* 1559087 */     GIR_EraseRootFromParent_Done,
     /* 1559088 */   // Label 21533: @1559088
     /* 1559088 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1559174), // Rule ID 5769 //
     /* 1559093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1559096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1559116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559139 */     // MIs[0] policy
     /* 1559139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1559152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559173 */     // GIR_Coverage, 5769,
     /* 1559173 */     GIR_EraseRootFromParent_Done,
     /* 1559174 */   // Label 21534: @1559174
     /* 1559174 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1559260), // Rule ID 5772 //
     /* 1559179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1559182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1559202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559225 */     // MIs[0] policy
     /* 1559225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559235 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1559238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559259 */     // GIR_Coverage, 5772,
     /* 1559259 */     GIR_EraseRootFromParent_Done,
     /* 1559260 */   // Label 21535: @1559260
     /* 1559260 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1559346), // Rule ID 5773 //
     /* 1559265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1559268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1559288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559311 */     // MIs[0] policy
     /* 1559311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1559324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559345 */     // GIR_Coverage, 5773,
     /* 1559345 */     GIR_EraseRootFromParent_Done,
     /* 1559346 */   // Label 21536: @1559346
     /* 1559346 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1559432), // Rule ID 5776 //
     /* 1559351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1559354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1559374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559397 */     // MIs[0] policy
     /* 1559397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1559410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559431 */     // GIR_Coverage, 5776,
     /* 1559431 */     GIR_EraseRootFromParent_Done,
     /* 1559432 */   // Label 21537: @1559432
     /* 1559432 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1559518), // Rule ID 5777 //
     /* 1559437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1559440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1559460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559483 */     // MIs[0] policy
     /* 1559483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1559496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559517 */     // GIR_Coverage, 5777,
     /* 1559517 */     GIR_EraseRootFromParent_Done,
     /* 1559518 */   // Label 21538: @1559518
     /* 1559518 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1559604), // Rule ID 5780 //
     /* 1559523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1559526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1559546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559569 */     // MIs[0] policy
     /* 1559569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559579 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1559582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559603 */     // GIR_Coverage, 5780,
     /* 1559603 */     GIR_EraseRootFromParent_Done,
     /* 1559604 */   // Label 21539: @1559604
     /* 1559604 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1559690), // Rule ID 5781 //
     /* 1559609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1559612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1559632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559655 */     // MIs[0] policy
     /* 1559655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1559668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559689 */     // GIR_Coverage, 5781,
     /* 1559689 */     GIR_EraseRootFromParent_Done,
     /* 1559690 */   // Label 21540: @1559690
     /* 1559690 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1559776), // Rule ID 5784 //
     /* 1559695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1559698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1559718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559741 */     // MIs[0] policy
     /* 1559741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559751 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1559754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559775 */     // GIR_Coverage, 5784,
     /* 1559775 */     GIR_EraseRootFromParent_Done,
     /* 1559776 */   // Label 21541: @1559776
     /* 1559776 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1559862), // Rule ID 5785 //
     /* 1559781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1559784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1559804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559827 */     // MIs[0] policy
     /* 1559827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559837 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1559840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559861 */     // GIR_Coverage, 5785,
     /* 1559861 */     GIR_EraseRootFromParent_Done,
     /* 1559862 */   // Label 21542: @1559862
     /* 1559862 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1559948), // Rule ID 5788 //
     /* 1559867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1559870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1559887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1559890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559913 */     // MIs[0] policy
     /* 1559913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1559926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1559932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1559934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1559936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559947 */     // GIR_Coverage, 5788,
     /* 1559947 */     GIR_EraseRootFromParent_Done,
     /* 1559948 */   // Label 21543: @1559948
     /* 1559948 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1560034), // Rule ID 5789 //
     /* 1559953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1559956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1559961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1559973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1559976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1559995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559999 */     // MIs[0] policy
     /* 1559999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1560012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560033 */     // GIR_Coverage, 5789,
     /* 1560033 */     GIR_EraseRootFromParent_Done,
     /* 1560034 */   // Label 21544: @1560034
     /* 1560034 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1560120), // Rule ID 5792 //
     /* 1560039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1560042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1560047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1560059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1560062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1560081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560085 */     // MIs[0] policy
     /* 1560085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560095 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1560098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560119 */     // GIR_Coverage, 5792,
     /* 1560119 */     GIR_EraseRootFromParent_Done,
     /* 1560120 */   // Label 21545: @1560120
     /* 1560120 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1560206), // Rule ID 5793 //
     /* 1560125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1560128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1560133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1560145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1560148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1560167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560171 */     // MIs[0] policy
     /* 1560171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1560184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560205 */     // GIR_Coverage, 5793,
     /* 1560205 */     GIR_EraseRootFromParent_Done,
     /* 1560206 */   // Label 21546: @1560206
     /* 1560206 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1560292), // Rule ID 5796 //
     /* 1560211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1560214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1560219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1560231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1560234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1560253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560257 */     // MIs[0] policy
     /* 1560257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560267 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1560270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560291 */     // GIR_Coverage, 5796,
     /* 1560291 */     GIR_EraseRootFromParent_Done,
     /* 1560292 */   // Label 21547: @1560292
     /* 1560292 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1560378), // Rule ID 5797 //
     /* 1560297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1560300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1560305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1560317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1560320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1560339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560343 */     // MIs[0] policy
     /* 1560343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560353 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1560356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560377 */     // GIR_Coverage, 5797,
     /* 1560377 */     GIR_EraseRootFromParent_Done,
     /* 1560378 */   // Label 21548: @1560378
     /* 1560378 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1560464), // Rule ID 5888 //
     /* 1560383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1560386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1560394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1560397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1560400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1560403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1560406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560429 */     // MIs[0] policy
     /* 1560429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1560442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560463 */     // GIR_Coverage, 5888,
     /* 1560463 */     GIR_EraseRootFromParent_Done,
     /* 1560464 */   // Label 21549: @1560464
     /* 1560464 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1560550), // Rule ID 5889 //
     /* 1560469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1560472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1560480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1560483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1560486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1560489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1560492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560515 */     // MIs[0] policy
     /* 1560515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1560528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560549 */     // GIR_Coverage, 5889,
     /* 1560549 */     GIR_EraseRootFromParent_Done,
     /* 1560550 */   // Label 21550: @1560550
     /* 1560550 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1560636), // Rule ID 5892 //
     /* 1560555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1560558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1560566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1560569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1560572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1560575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1560578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560601 */     // MIs[0] policy
     /* 1560601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560611 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1560614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560635 */     // GIR_Coverage, 5892,
     /* 1560635 */     GIR_EraseRootFromParent_Done,
     /* 1560636 */   // Label 21551: @1560636
     /* 1560636 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1560722), // Rule ID 5893 //
     /* 1560641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1560644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1560652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1560655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1560658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1560661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1560664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560687 */     // MIs[0] policy
     /* 1560687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1560700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560721 */     // GIR_Coverage, 5893,
     /* 1560721 */     GIR_EraseRootFromParent_Done,
     /* 1560722 */   // Label 21552: @1560722
     /* 1560722 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1560808), // Rule ID 5896 //
     /* 1560727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1560730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1560738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1560741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1560744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1560747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1560750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560773 */     // MIs[0] policy
     /* 1560773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560783 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1560786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560807 */     // GIR_Coverage, 5896,
     /* 1560807 */     GIR_EraseRootFromParent_Done,
     /* 1560808 */   // Label 21553: @1560808
     /* 1560808 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1560894), // Rule ID 5897 //
     /* 1560813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1560816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1560824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1560827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1560830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1560833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1560836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560859 */     // MIs[0] policy
     /* 1560859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560869 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1560872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1560890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560893 */     // GIR_Coverage, 5897,
     /* 1560893 */     GIR_EraseRootFromParent_Done,
     /* 1560894 */   // Label 21554: @1560894
     /* 1560894 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1560980), // Rule ID 5900 //
     /* 1560899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1560902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1560919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1560922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560945 */     // MIs[0] policy
     /* 1560945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560955 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1560958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1560964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1560966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1560968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560979 */     // GIR_Coverage, 5900,
     /* 1560979 */     GIR_EraseRootFromParent_Done,
     /* 1560980 */   // Label 21555: @1560980
     /* 1560980 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1561066), // Rule ID 5901 //
     /* 1560985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1560988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1560993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1561002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1561005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1561008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561031 */     // MIs[0] policy
     /* 1561031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561041 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1561044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561065 */     // GIR_Coverage, 5901,
     /* 1561065 */     GIR_EraseRootFromParent_Done,
     /* 1561066 */   // Label 21556: @1561066
     /* 1561066 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1561152), // Rule ID 5904 //
     /* 1561071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1561074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1561082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1561085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1561088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1561091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1561094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561117 */     // MIs[0] policy
     /* 1561117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1561130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561151 */     // GIR_Coverage, 5904,
     /* 1561151 */     GIR_EraseRootFromParent_Done,
     /* 1561152 */   // Label 21557: @1561152
     /* 1561152 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1561238), // Rule ID 5905 //
     /* 1561157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1561160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1561168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1561171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1561174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1561177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1561180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561203 */     // MIs[0] policy
     /* 1561203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561213 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1561216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561237 */     // GIR_Coverage, 5905,
     /* 1561237 */     GIR_EraseRootFromParent_Done,
     /* 1561238 */   // Label 21558: @1561238
     /* 1561238 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1561324), // Rule ID 5908 //
     /* 1561243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1561246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1561263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1561266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561289 */     // MIs[0] policy
     /* 1561289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561299 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1561302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561323 */     // GIR_Coverage, 5908,
     /* 1561323 */     GIR_EraseRootFromParent_Done,
     /* 1561324 */   // Label 21559: @1561324
     /* 1561324 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1561410), // Rule ID 5909 //
     /* 1561329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1561332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1561349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1561352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561375 */     // MIs[0] policy
     /* 1561375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561385 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1561388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561409 */     // GIR_Coverage, 5909,
     /* 1561409 */     GIR_EraseRootFromParent_Done,
     /* 1561410 */   // Label 21560: @1561410
     /* 1561410 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1561496), // Rule ID 5912 //
     /* 1561415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1561418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1561426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1561429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1561432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1561435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1561438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561461 */     // MIs[0] policy
     /* 1561461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1561492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561495 */     // GIR_Coverage, 5912,
     /* 1561495 */     GIR_EraseRootFromParent_Done,
     /* 1561496 */   // Label 21561: @1561496
     /* 1561496 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1561582), // Rule ID 5913 //
     /* 1561501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1561504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1561512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1561515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1561518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1561521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1561524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561547 */     // MIs[0] policy
     /* 1561547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1561578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561581 */     // GIR_Coverage, 5913,
     /* 1561581 */     GIR_EraseRootFromParent_Done,
     /* 1561582 */   // Label 21562: @1561582
     /* 1561582 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1561668), // Rule ID 5916 //
     /* 1561587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1561590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1561598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1561601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1561604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1561607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1561610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561633 */     // MIs[0] policy
     /* 1561633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561667 */     // GIR_Coverage, 5916,
     /* 1561667 */     GIR_EraseRootFromParent_Done,
     /* 1561668 */   // Label 21563: @1561668
     /* 1561668 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1561754), // Rule ID 5917 //
     /* 1561673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1561676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1561684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1561687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1561690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1561693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1561696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561719 */     // MIs[0] policy
     /* 1561719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561729 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561753 */     // GIR_Coverage, 5917,
     /* 1561753 */     GIR_EraseRootFromParent_Done,
     /* 1561754 */   // Label 21564: @1561754
     /* 1561754 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1561840), // Rule ID 5920 //
     /* 1561759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1561762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1561770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1561773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1561779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1561782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561805 */     // MIs[0] policy
     /* 1561805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561839 */     // GIR_Coverage, 5920,
     /* 1561839 */     GIR_EraseRootFromParent_Done,
     /* 1561840 */   // Label 21565: @1561840
     /* 1561840 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1561926), // Rule ID 5921 //
     /* 1561845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1561848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1561856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1561859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1561865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1561868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561891 */     // MIs[0] policy
     /* 1561891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1561914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561925 */     // GIR_Coverage, 5921,
     /* 1561925 */     GIR_EraseRootFromParent_Done,
     /* 1561926 */   // Label 21566: @1561926
     /* 1561926 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1562012), // Rule ID 5924 //
     /* 1561931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1561934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1561939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1561942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1561948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1561951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1561954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561977 */     // MIs[0] policy
     /* 1561977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561987 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1561990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1561996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1561998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562011 */     // GIR_Coverage, 5924,
     /* 1562011 */     GIR_EraseRootFromParent_Done,
     /* 1562012 */   // Label 21567: @1562012
     /* 1562012 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1562098), // Rule ID 5925 //
     /* 1562017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1562020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1562034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1562037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1562040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562063 */     // MIs[0] policy
     /* 1562063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562073 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1562076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562097 */     // GIR_Coverage, 5925,
     /* 1562097 */     GIR_EraseRootFromParent_Done,
     /* 1562098 */   // Label 21568: @1562098
     /* 1562098 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1562184), // Rule ID 5928 //
     /* 1562103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1562114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1562117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1562120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1562123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1562126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562149 */     // MIs[0] policy
     /* 1562149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1562162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562183 */     // GIR_Coverage, 5928,
     /* 1562183 */     GIR_EraseRootFromParent_Done,
     /* 1562184 */   // Label 21569: @1562184
     /* 1562184 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1562270), // Rule ID 5929 //
     /* 1562189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1562192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1562200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1562203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1562206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1562209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1562212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562235 */     // MIs[0] policy
     /* 1562235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1562248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562269 */     // GIR_Coverage, 5929,
     /* 1562269 */     GIR_EraseRootFromParent_Done,
     /* 1562270 */   // Label 21570: @1562270
     /* 1562270 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1562356), // Rule ID 5932 //
     /* 1562275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1562286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1562289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1562292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1562295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1562298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562321 */     // MIs[0] policy
     /* 1562321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562331 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1562334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562355 */     // GIR_Coverage, 5932,
     /* 1562355 */     GIR_EraseRootFromParent_Done,
     /* 1562356 */   // Label 21571: @1562356
     /* 1562356 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1562442), // Rule ID 5933 //
     /* 1562361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1562364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1562372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1562375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1562378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1562381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1562384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562407 */     // MIs[0] policy
     /* 1562407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562417 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1562420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562441 */     // GIR_Coverage, 5933,
     /* 1562441 */     GIR_EraseRootFromParent_Done,
     /* 1562442 */   // Label 21572: @1562442
     /* 1562442 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1562528), // Rule ID 5936 //
     /* 1562447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1562458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1562461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1562464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1562467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1562470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562493 */     // MIs[0] policy
     /* 1562493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562503 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1562506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562527 */     // GIR_Coverage, 5936,
     /* 1562527 */     GIR_EraseRootFromParent_Done,
     /* 1562528 */   // Label 21573: @1562528
     /* 1562528 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1562614), // Rule ID 5937 //
     /* 1562533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1562536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1562544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1562547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1562550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1562553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1562556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562579 */     // MIs[0] policy
     /* 1562579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562589 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1562592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1562610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562613 */     // GIR_Coverage, 5937,
     /* 1562613 */     GIR_EraseRootFromParent_Done,
     /* 1562614 */   // Label 21574: @1562614
     /* 1562614 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1562700), // Rule ID 5940 //
     /* 1562619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1562630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1562633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1562636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1562639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1562642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562665 */     // MIs[0] policy
     /* 1562665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562675 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1562678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562699 */     // GIR_Coverage, 5940,
     /* 1562699 */     GIR_EraseRootFromParent_Done,
     /* 1562700 */   // Label 21575: @1562700
     /* 1562700 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1562786), // Rule ID 5941 //
     /* 1562705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1562708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1562716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1562719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1562722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1562725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1562728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562751 */     // MIs[0] policy
     /* 1562751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1562764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562785 */     // GIR_Coverage, 5941,
     /* 1562785 */     GIR_EraseRootFromParent_Done,
     /* 1562786 */   // Label 21576: @1562786
     /* 1562786 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1562872), // Rule ID 5944 //
     /* 1562791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1562802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1562805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1562811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1562814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562837 */     // MIs[0] policy
     /* 1562837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562847 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1562850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562871 */     // GIR_Coverage, 5944,
     /* 1562871 */     GIR_EraseRootFromParent_Done,
     /* 1562872 */   // Label 21577: @1562872
     /* 1562872 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1562958), // Rule ID 5945 //
     /* 1562877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1562880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1562888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1562891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1562897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1562900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562923 */     // MIs[0] policy
     /* 1562923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1562936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1562942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1562944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1562946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562957 */     // GIR_Coverage, 5945,
     /* 1562957 */     GIR_EraseRootFromParent_Done,
     /* 1562958 */   // Label 21578: @1562958
     /* 1562958 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1563044), // Rule ID 5948 //
     /* 1562963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1562966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1562971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1562974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1562977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1562980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1562983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1562986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563009 */     // MIs[0] policy
     /* 1563009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563019 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1563022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563043 */     // GIR_Coverage, 5948,
     /* 1563043 */     GIR_EraseRootFromParent_Done,
     /* 1563044 */   // Label 21579: @1563044
     /* 1563044 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1563130), // Rule ID 5949 //
     /* 1563049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1563052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1563069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1563072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563095 */     // MIs[0] policy
     /* 1563095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1563108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563129 */     // GIR_Coverage, 5949,
     /* 1563129 */     GIR_EraseRootFromParent_Done,
     /* 1563130 */   // Label 21580: @1563130
     /* 1563130 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1563216), // Rule ID 5952 //
     /* 1563135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1563138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1563155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1563158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563181 */     // MIs[0] policy
     /* 1563181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1563194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563215 */     // GIR_Coverage, 5952,
     /* 1563215 */     GIR_EraseRootFromParent_Done,
     /* 1563216 */   // Label 21581: @1563216
     /* 1563216 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1563302), // Rule ID 5953 //
     /* 1563221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1563224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1563241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1563244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563267 */     // MIs[0] policy
     /* 1563267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1563280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563301 */     // GIR_Coverage, 5953,
     /* 1563301 */     GIR_EraseRootFromParent_Done,
     /* 1563302 */   // Label 21582: @1563302
     /* 1563302 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1563388), // Rule ID 5956 //
     /* 1563307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1563310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1563327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1563330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563353 */     // MIs[0] policy
     /* 1563353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563363 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1563366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563387 */     // GIR_Coverage, 5956,
     /* 1563387 */     GIR_EraseRootFromParent_Done,
     /* 1563388 */   // Label 21583: @1563388
     /* 1563388 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1563474), // Rule ID 5957 //
     /* 1563393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1563396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1563413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1563416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563439 */     // MIs[0] policy
     /* 1563439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1563452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563473 */     // GIR_Coverage, 5957,
     /* 1563473 */     GIR_EraseRootFromParent_Done,
     /* 1563474 */   // Label 21584: @1563474
     /* 1563474 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1563560), // Rule ID 5960 //
     /* 1563479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1563482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1563499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1563502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563525 */     // MIs[0] policy
     /* 1563525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563535 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1563538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563559 */     // GIR_Coverage, 5960,
     /* 1563559 */     GIR_EraseRootFromParent_Done,
     /* 1563560 */   // Label 21585: @1563560
     /* 1563560 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1563646), // Rule ID 5961 //
     /* 1563565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1563568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1563585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1563588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563611 */     // MIs[0] policy
     /* 1563611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563621 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1563624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563645 */     // GIR_Coverage, 5961,
     /* 1563645 */     GIR_EraseRootFromParent_Done,
     /* 1563646 */   // Label 21586: @1563646
     /* 1563646 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1563732), // Rule ID 5964 //
     /* 1563651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1563654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1563662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1563665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1563668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1563671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1563674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563697 */     // MIs[0] policy
     /* 1563697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1563710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563731 */     // GIR_Coverage, 5964,
     /* 1563731 */     GIR_EraseRootFromParent_Done,
     /* 1563732 */   // Label 21587: @1563732
     /* 1563732 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1563818), // Rule ID 5965 //
     /* 1563737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1563740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1563748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1563751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1563754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1563757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1563760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563783 */     // MIs[0] policy
     /* 1563783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1563796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563817 */     // GIR_Coverage, 5965,
     /* 1563817 */     GIR_EraseRootFromParent_Done,
     /* 1563818 */   // Label 21588: @1563818
     /* 1563818 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1563904), // Rule ID 5968 //
     /* 1563823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1563826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1563840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1563843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1563846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563869 */     // MIs[0] policy
     /* 1563869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1563882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563903 */     // GIR_Coverage, 5968,
     /* 1563903 */     GIR_EraseRootFromParent_Done,
     /* 1563904 */   // Label 21589: @1563904
     /* 1563904 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1563990), // Rule ID 5969 //
     /* 1563909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1563912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1563917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1563926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1563929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1563932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563955 */     // MIs[0] policy
     /* 1563955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563965 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1563968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1563974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1563976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1563978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563989 */     // GIR_Coverage, 5969,
     /* 1563989 */     GIR_EraseRootFromParent_Done,
     /* 1563990 */   // Label 21590: @1563990
     /* 1563990 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1564076), // Rule ID 5972 //
     /* 1563995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1563998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1564015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1564018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564041 */     // MIs[0] policy
     /* 1564041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1564054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564075 */     // GIR_Coverage, 5972,
     /* 1564075 */     GIR_EraseRootFromParent_Done,
     /* 1564076 */   // Label 21591: @1564076
     /* 1564076 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1564162), // Rule ID 5973 //
     /* 1564081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1564084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1564101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1564104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564127 */     // MIs[0] policy
     /* 1564127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564137 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1564140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564161 */     // GIR_Coverage, 5973,
     /* 1564161 */     GIR_EraseRootFromParent_Done,
     /* 1564162 */   // Label 21592: @1564162
     /* 1564162 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1564248), // Rule ID 5976 //
     /* 1564167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1564170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1564178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1564181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1564184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1564187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1564190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564213 */     // MIs[0] policy
     /* 1564213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1564226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564247 */     // GIR_Coverage, 5976,
     /* 1564247 */     GIR_EraseRootFromParent_Done,
     /* 1564248 */   // Label 21593: @1564248
     /* 1564248 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1564334), // Rule ID 5977 //
     /* 1564253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1564256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1564264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1564267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1564270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1564273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1564276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564299 */     // MIs[0] policy
     /* 1564299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564309 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1564312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564333 */     // GIR_Coverage, 5977,
     /* 1564333 */     GIR_EraseRootFromParent_Done,
     /* 1564334 */   // Label 21594: @1564334
     /* 1564334 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1564420), // Rule ID 5980 //
     /* 1564339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1564342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1564350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1564353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1564356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1564359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1564362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564385 */     // MIs[0] policy
     /* 1564385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1564398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564419 */     // GIR_Coverage, 5980,
     /* 1564419 */     GIR_EraseRootFromParent_Done,
     /* 1564420 */   // Label 21595: @1564420
     /* 1564420 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1564506), // Rule ID 5981 //
     /* 1564425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1564428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1564436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1564439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1564442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1564445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1564448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564471 */     // MIs[0] policy
     /* 1564471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564481 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1564484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564505 */     // GIR_Coverage, 5981,
     /* 1564505 */     GIR_EraseRootFromParent_Done,
     /* 1564506 */   // Label 21596: @1564506
     /* 1564506 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1564592), // Rule ID 5984 //
     /* 1564511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1564514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1564522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1564525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1564528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1564531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1564534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564557 */     // MIs[0] policy
     /* 1564557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564567 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1564570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564591 */     // GIR_Coverage, 5984,
     /* 1564591 */     GIR_EraseRootFromParent_Done,
     /* 1564592 */   // Label 21597: @1564592
     /* 1564592 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1564678), // Rule ID 5985 //
     /* 1564597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1564600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1564608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1564611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1564614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1564617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1564620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564643 */     // MIs[0] policy
     /* 1564643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564653 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1564656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564677 */     // GIR_Coverage, 5985,
     /* 1564677 */     GIR_EraseRootFromParent_Done,
     /* 1564678 */   // Label 21598: @1564678
     /* 1564678 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1564764), // Rule ID 5988 //
     /* 1564683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1564686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1564703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1564706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564729 */     // MIs[0] policy
     /* 1564729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564739 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1564742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564763 */     // GIR_Coverage, 5988,
     /* 1564763 */     GIR_EraseRootFromParent_Done,
     /* 1564764 */   // Label 21599: @1564764
     /* 1564764 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1564850), // Rule ID 5989 //
     /* 1564769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1564772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1564789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1564792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564815 */     // MIs[0] policy
     /* 1564815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564825 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1564828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564849 */     // GIR_Coverage, 5989,
     /* 1564849 */     GIR_EraseRootFromParent_Done,
     /* 1564850 */   // Label 21600: @1564850
     /* 1564850 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1564936), // Rule ID 5992 //
     /* 1564855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1564858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1564875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1564878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564901 */     // MIs[0] policy
     /* 1564901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564911 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1564914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1564920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1564922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1564924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564935 */     // GIR_Coverage, 5992,
     /* 1564935 */     GIR_EraseRootFromParent_Done,
     /* 1564936 */   // Label 21601: @1564936
     /* 1564936 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1565022), // Rule ID 5993 //
     /* 1564941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1564944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1564949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1564961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1564964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1564983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564987 */     // MIs[0] policy
     /* 1564987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564997 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1565000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565021 */     // GIR_Coverage, 5993,
     /* 1565021 */     GIR_EraseRootFromParent_Done,
     /* 1565022 */   // Label 21602: @1565022
     /* 1565022 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1565108), // Rule ID 5996 //
     /* 1565027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1565030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1565050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565073 */     // MIs[0] policy
     /* 1565073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1565086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565107 */     // GIR_Coverage, 5996,
     /* 1565107 */     GIR_EraseRootFromParent_Done,
     /* 1565108 */   // Label 21603: @1565108
     /* 1565108 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1565194), // Rule ID 5997 //
     /* 1565113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1565116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1565136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565159 */     // MIs[0] policy
     /* 1565159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1565172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565193 */     // GIR_Coverage, 5997,
     /* 1565193 */     GIR_EraseRootFromParent_Done,
     /* 1565194 */   // Label 21604: @1565194
     /* 1565194 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1565280), // Rule ID 6000 //
     /* 1565199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1565202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1565210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1565213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1565216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1565222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565245 */     // MIs[0] policy
     /* 1565245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565255 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1565276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565279 */     // GIR_Coverage, 6000,
     /* 1565279 */     GIR_EraseRootFromParent_Done,
     /* 1565280 */   // Label 21605: @1565280
     /* 1565280 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1565366), // Rule ID 6001 //
     /* 1565285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1565288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1565296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1565299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1565302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1565308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565331 */     // MIs[0] policy
     /* 1565331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565341 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1565362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565365 */     // GIR_Coverage, 6001,
     /* 1565365 */     GIR_EraseRootFromParent_Done,
     /* 1565366 */   // Label 21606: @1565366
     /* 1565366 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1565452), // Rule ID 6004 //
     /* 1565371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1565374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1565394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565417 */     // MIs[0] policy
     /* 1565417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565451 */     // GIR_Coverage, 6004,
     /* 1565451 */     GIR_EraseRootFromParent_Done,
     /* 1565452 */   // Label 21607: @1565452
     /* 1565452 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1565538), // Rule ID 6005 //
     /* 1565457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1565460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1565480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565503 */     // MIs[0] policy
     /* 1565503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565513 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565537 */     // GIR_Coverage, 6005,
     /* 1565537 */     GIR_EraseRootFromParent_Done,
     /* 1565538 */   // Label 21608: @1565538
     /* 1565538 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1565624), // Rule ID 6008 //
     /* 1565543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1565546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1565566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565589 */     // MIs[0] policy
     /* 1565589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565623 */     // GIR_Coverage, 6008,
     /* 1565623 */     GIR_EraseRootFromParent_Done,
     /* 1565624 */   // Label 21609: @1565624
     /* 1565624 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1565710), // Rule ID 6009 //
     /* 1565629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1565632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1565652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565675 */     // MIs[0] policy
     /* 1565675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565685 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565709 */     // GIR_Coverage, 6009,
     /* 1565709 */     GIR_EraseRootFromParent_Done,
     /* 1565710 */   // Label 21610: @1565710
     /* 1565710 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1565796), // Rule ID 6012 //
     /* 1565715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1565718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1565738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565761 */     // MIs[0] policy
     /* 1565761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565795 */     // GIR_Coverage, 6012,
     /* 1565795 */     GIR_EraseRootFromParent_Done,
     /* 1565796 */   // Label 21611: @1565796
     /* 1565796 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1565882), // Rule ID 6013 //
     /* 1565801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1565804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1565824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565847 */     // MIs[0] policy
     /* 1565847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1565860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565881 */     // GIR_Coverage, 6013,
     /* 1565881 */     GIR_EraseRootFromParent_Done,
     /* 1565882 */   // Label 21612: @1565882
     /* 1565882 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1565968), // Rule ID 6016 //
     /* 1565887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1565890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1565898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1565901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1565904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1565907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1565910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1565929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565933 */     // MIs[0] policy
     /* 1565933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565943 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1565946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1565952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1565954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1565956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1565964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565967 */     // GIR_Coverage, 6016,
     /* 1565967 */     GIR_EraseRootFromParent_Done,
     /* 1565968 */   // Label 21613: @1565968
     /* 1565968 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1566054), // Rule ID 6017 //
     /* 1565973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1565976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1565981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1565984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1565987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1565990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1565993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1565996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566019 */     // MIs[0] policy
     /* 1566019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1566032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566053 */     // GIR_Coverage, 6017,
     /* 1566053 */     GIR_EraseRootFromParent_Done,
     /* 1566054 */   // Label 21614: @1566054
     /* 1566054 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1566140), // Rule ID 6020 //
     /* 1566059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1566070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1566073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1566076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1566082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566105 */     // MIs[0] policy
     /* 1566105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566115 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1566118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566139 */     // GIR_Coverage, 6020,
     /* 1566139 */     GIR_EraseRootFromParent_Done,
     /* 1566140 */   // Label 21615: @1566140
     /* 1566140 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1566226), // Rule ID 6021 //
     /* 1566145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1566148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1566156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1566159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1566162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1566165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1566168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566191 */     // MIs[0] policy
     /* 1566191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566201 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1566204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566225 */     // GIR_Coverage, 6021,
     /* 1566225 */     GIR_EraseRootFromParent_Done,
     /* 1566226 */   // Label 21616: @1566226
     /* 1566226 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1566312), // Rule ID 6024 //
     /* 1566231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1566242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1566245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1566248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1566254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566277 */     // MIs[0] policy
     /* 1566277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566287 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1566290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566311 */     // GIR_Coverage, 6024,
     /* 1566311 */     GIR_EraseRootFromParent_Done,
     /* 1566312 */   // Label 21617: @1566312
     /* 1566312 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1566398), // Rule ID 6025 //
     /* 1566317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1566320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1566328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1566331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1566334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1566337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1566340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566363 */     // MIs[0] policy
     /* 1566363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566373 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1566376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566397 */     // GIR_Coverage, 6025,
     /* 1566397 */     GIR_EraseRootFromParent_Done,
     /* 1566398 */   // Label 21618: @1566398
     /* 1566398 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1566484), // Rule ID 6028 //
     /* 1566403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1566426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566449 */     // MIs[0] policy
     /* 1566449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1566462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566483 */     // GIR_Coverage, 6028,
     /* 1566483 */     GIR_EraseRootFromParent_Done,
     /* 1566484 */   // Label 21619: @1566484
     /* 1566484 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1566570), // Rule ID 6029 //
     /* 1566489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1566492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1566509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1566512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566535 */     // MIs[0] policy
     /* 1566535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1566548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566569 */     // GIR_Coverage, 6029,
     /* 1566569 */     GIR_EraseRootFromParent_Done,
     /* 1566570 */   // Label 21620: @1566570
     /* 1566570 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1566656), // Rule ID 6032 //
     /* 1566575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1566598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566621 */     // MIs[0] policy
     /* 1566621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1566634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566655 */     // GIR_Coverage, 6032,
     /* 1566655 */     GIR_EraseRootFromParent_Done,
     /* 1566656 */   // Label 21621: @1566656
     /* 1566656 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1566742), // Rule ID 6033 //
     /* 1566661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1566664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1566681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1566684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566707 */     // MIs[0] policy
     /* 1566707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566717 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1566720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566741 */     // GIR_Coverage, 6033,
     /* 1566741 */     GIR_EraseRootFromParent_Done,
     /* 1566742 */   // Label 21622: @1566742
     /* 1566742 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1566828), // Rule ID 6036 //
     /* 1566747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1566770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566793 */     // MIs[0] policy
     /* 1566793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566803 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1566806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566827 */     // GIR_Coverage, 6036,
     /* 1566827 */     GIR_EraseRootFromParent_Done,
     /* 1566828 */   // Label 21623: @1566828
     /* 1566828 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1566914), // Rule ID 6037 //
     /* 1566833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1566836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1566853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1566856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566879 */     // MIs[0] policy
     /* 1566879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1566892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566913 */     // GIR_Coverage, 6037,
     /* 1566913 */     GIR_EraseRootFromParent_Done,
     /* 1566914 */   // Label 21624: @1566914
     /* 1566914 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1567000), // Rule ID 6040 //
     /* 1566919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1566922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1566927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1566939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1566942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1566961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566965 */     // MIs[0] policy
     /* 1566965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1566978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1566984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1566986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1566988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566999 */     // GIR_Coverage, 6040,
     /* 1566999 */     GIR_EraseRootFromParent_Done,
     /* 1567000 */   // Label 21625: @1567000
     /* 1567000 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1567086), // Rule ID 6041 //
     /* 1567005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1567008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1567028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567051 */     // MIs[0] policy
     /* 1567051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1567064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567085 */     // GIR_Coverage, 6041,
     /* 1567085 */     GIR_EraseRootFromParent_Done,
     /* 1567086 */   // Label 21626: @1567086
     /* 1567086 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1567172), // Rule ID 6044 //
     /* 1567091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1567094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1567111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1567114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567137 */     // MIs[0] policy
     /* 1567137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567147 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1567150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567171 */     // GIR_Coverage, 6044,
     /* 1567171 */     GIR_EraseRootFromParent_Done,
     /* 1567172 */   // Label 21627: @1567172
     /* 1567172 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1567258), // Rule ID 6045 //
     /* 1567177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1567180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1567200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567223 */     // MIs[0] policy
     /* 1567223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567233 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1567236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567257 */     // GIR_Coverage, 6045,
     /* 1567257 */     GIR_EraseRootFromParent_Done,
     /* 1567258 */   // Label 21628: @1567258
     /* 1567258 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1567344), // Rule ID 6048 //
     /* 1567263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1567266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1567283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1567286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567309 */     // MIs[0] policy
     /* 1567309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1567322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567343 */     // GIR_Coverage, 6048,
     /* 1567343 */     GIR_EraseRootFromParent_Done,
     /* 1567344 */   // Label 21629: @1567344
     /* 1567344 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1567430), // Rule ID 6049 //
     /* 1567349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1567352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1567372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567395 */     // MIs[0] policy
     /* 1567395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567405 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1567408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567429 */     // GIR_Coverage, 6049,
     /* 1567429 */     GIR_EraseRootFromParent_Done,
     /* 1567430 */   // Label 21630: @1567430
     /* 1567430 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1567516), // Rule ID 6052 //
     /* 1567435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1567438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1567455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1567458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567481 */     // MIs[0] policy
     /* 1567481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1567494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567515 */     // GIR_Coverage, 6052,
     /* 1567515 */     GIR_EraseRootFromParent_Done,
     /* 1567516 */   // Label 21631: @1567516
     /* 1567516 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1567602), // Rule ID 6053 //
     /* 1567521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1567524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1567544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567567 */     // MIs[0] policy
     /* 1567567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1567580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567601 */     // GIR_Coverage, 6053,
     /* 1567601 */     GIR_EraseRootFromParent_Done,
     /* 1567602 */   // Label 21632: @1567602
     /* 1567602 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1567688), // Rule ID 6056 //
     /* 1567607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1567610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1567627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1567630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567653 */     // MIs[0] policy
     /* 1567653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567663 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1567666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567687 */     // GIR_Coverage, 6056,
     /* 1567687 */     GIR_EraseRootFromParent_Done,
     /* 1567688 */   // Label 21633: @1567688
     /* 1567688 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1567774), // Rule ID 6057 //
     /* 1567693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1567696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1567716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567739 */     // MIs[0] policy
     /* 1567739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567749 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1567752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567773 */     // GIR_Coverage, 6057,
     /* 1567773 */     GIR_EraseRootFromParent_Done,
     /* 1567774 */   // Label 21634: @1567774
     /* 1567774 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1567860), // Rule ID 6060 //
     /* 1567779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1567782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1567799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1567802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567825 */     // MIs[0] policy
     /* 1567825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567835 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1567838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567859 */     // GIR_Coverage, 6060,
     /* 1567859 */     GIR_EraseRootFromParent_Done,
     /* 1567860 */   // Label 21635: @1567860
     /* 1567860 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1567946), // Rule ID 6061 //
     /* 1567865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1567868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1567873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1567885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1567888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1567907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567911 */     // MIs[0] policy
     /* 1567911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1567924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1567930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1567932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1567934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567945 */     // GIR_Coverage, 6061,
     /* 1567945 */     GIR_EraseRootFromParent_Done,
     /* 1567946 */   // Label 21636: @1567946
     /* 1567946 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1568032), // Rule ID 6152 //
     /* 1567951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1567954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1567959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1567962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1567965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1567968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1567971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1567974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567997 */     // MIs[0] policy
     /* 1567997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568007 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1568010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568031 */     // GIR_Coverage, 6152,
     /* 1568031 */     GIR_EraseRootFromParent_Done,
     /* 1568032 */   // Label 21637: @1568032
     /* 1568032 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1568118), // Rule ID 6153 //
     /* 1568037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1568048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1568051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1568054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1568057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1568060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568083 */     // MIs[0] policy
     /* 1568083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568093 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1568096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568117 */     // GIR_Coverage, 6153,
     /* 1568117 */     GIR_EraseRootFromParent_Done,
     /* 1568118 */   // Label 21638: @1568118
     /* 1568118 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1568204), // Rule ID 6156 //
     /* 1568123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1568134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1568137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1568140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1568143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1568146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568169 */     // MIs[0] policy
     /* 1568169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568179 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1568182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568203 */     // GIR_Coverage, 6156,
     /* 1568203 */     GIR_EraseRootFromParent_Done,
     /* 1568204 */   // Label 21639: @1568204
     /* 1568204 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1568290), // Rule ID 6157 //
     /* 1568209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1568220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1568223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1568226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1568229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1568232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568255 */     // MIs[0] policy
     /* 1568255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568265 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1568268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568289 */     // GIR_Coverage, 6157,
     /* 1568289 */     GIR_EraseRootFromParent_Done,
     /* 1568290 */   // Label 21640: @1568290
     /* 1568290 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1568376), // Rule ID 6160 //
     /* 1568295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1568306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1568309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1568312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1568315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1568318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568341 */     // MIs[0] policy
     /* 1568341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568351 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568375 */     // GIR_Coverage, 6160,
     /* 1568375 */     GIR_EraseRootFromParent_Done,
     /* 1568376 */   // Label 21641: @1568376
     /* 1568376 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1568462), // Rule ID 6161 //
     /* 1568381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1568392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1568395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1568398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1568401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1568404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568427 */     // MIs[0] policy
     /* 1568427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568437 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568461 */     // GIR_Coverage, 6161,
     /* 1568461 */     GIR_EraseRootFromParent_Done,
     /* 1568462 */   // Label 21642: @1568462
     /* 1568462 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1568548), // Rule ID 6164 //
     /* 1568467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1568487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1568490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568513 */     // MIs[0] policy
     /* 1568513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568523 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1568526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568547 */     // GIR_Coverage, 6164,
     /* 1568547 */     GIR_EraseRootFromParent_Done,
     /* 1568548 */   // Label 21643: @1568548
     /* 1568548 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1568634), // Rule ID 6165 //
     /* 1568553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1568573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1568576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568599 */     // MIs[0] policy
     /* 1568599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1568612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568633 */     // GIR_Coverage, 6165,
     /* 1568633 */     GIR_EraseRootFromParent_Done,
     /* 1568634 */   // Label 21644: @1568634
     /* 1568634 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1568720), // Rule ID 6168 //
     /* 1568639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1568659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1568662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568685 */     // MIs[0] policy
     /* 1568685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568695 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568719 */     // GIR_Coverage, 6168,
     /* 1568719 */     GIR_EraseRootFromParent_Done,
     /* 1568720 */   // Label 21645: @1568720
     /* 1568720 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1568806), // Rule ID 6169 //
     /* 1568725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1568745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1568748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568771 */     // MIs[0] policy
     /* 1568771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568781 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568805 */     // GIR_Coverage, 6169,
     /* 1568805 */     GIR_EraseRootFromParent_Done,
     /* 1568806 */   // Label 21646: @1568806
     /* 1568806 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1568892), // Rule ID 6172 //
     /* 1568811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1568831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1568834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568857 */     // MIs[0] policy
     /* 1568857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568867 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568891 */     // GIR_Coverage, 6172,
     /* 1568891 */     GIR_EraseRootFromParent_Done,
     /* 1568892 */   // Label 21647: @1568892
     /* 1568892 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1568978), // Rule ID 6173 //
     /* 1568897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1568900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1568917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1568920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568943 */     // MIs[0] policy
     /* 1568943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1568956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1568962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1568964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1568966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568977 */     // GIR_Coverage, 6173,
     /* 1568977 */     GIR_EraseRootFromParent_Done,
     /* 1568978 */   // Label 21648: @1568978
     /* 1568978 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1569064), // Rule ID 6176 //
     /* 1568983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1568986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1568991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1568994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1568997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1569000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1569003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1569006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569029 */     // MIs[0] policy
     /* 1569029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1569060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569063 */     // GIR_Coverage, 6176,
     /* 1569063 */     GIR_EraseRootFromParent_Done,
     /* 1569064 */   // Label 21649: @1569064
     /* 1569064 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1569150), // Rule ID 6177 //
     /* 1569069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1569072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1569080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1569083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1569086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1569089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1569092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569115 */     // MIs[0] policy
     /* 1569115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1569146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569149 */     // GIR_Coverage, 6177,
     /* 1569149 */     GIR_EraseRootFromParent_Done,
     /* 1569150 */   // Label 21650: @1569150
     /* 1569150 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1569236), // Rule ID 6180 //
     /* 1569155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1569158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1569166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1569169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1569175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1569178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569201 */     // MIs[0] policy
     /* 1569201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569235 */     // GIR_Coverage, 6180,
     /* 1569235 */     GIR_EraseRootFromParent_Done,
     /* 1569236 */   // Label 21651: @1569236
     /* 1569236 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1569322), // Rule ID 6181 //
     /* 1569241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1569244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1569252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1569255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1569261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1569264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569287 */     // MIs[0] policy
     /* 1569287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569297 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569321 */     // GIR_Coverage, 6181,
     /* 1569321 */     GIR_EraseRootFromParent_Done,
     /* 1569322 */   // Label 21652: @1569322
     /* 1569322 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1569408), // Rule ID 6184 //
     /* 1569327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1569330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1569347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1569350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569373 */     // MIs[0] policy
     /* 1569373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569407 */     // GIR_Coverage, 6184,
     /* 1569407 */     GIR_EraseRootFromParent_Done,
     /* 1569408 */   // Label 21653: @1569408
     /* 1569408 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1569494), // Rule ID 6185 //
     /* 1569413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1569416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1569433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1569436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569459 */     // MIs[0] policy
     /* 1569459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569469 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569493 */     // GIR_Coverage, 6185,
     /* 1569493 */     GIR_EraseRootFromParent_Done,
     /* 1569494 */   // Label 21654: @1569494
     /* 1569494 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1569580), // Rule ID 6188 //
     /* 1569499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1569502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1569519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1569522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569545 */     // MIs[0] policy
     /* 1569545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569555 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1569576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569579 */     // GIR_Coverage, 6188,
     /* 1569579 */     GIR_EraseRootFromParent_Done,
     /* 1569580 */   // Label 21655: @1569580
     /* 1569580 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1569666), // Rule ID 6189 //
     /* 1569585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1569588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1569605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1569608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569631 */     // MIs[0] policy
     /* 1569631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1569644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1569662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569665 */     // GIR_Coverage, 6189,
     /* 1569665 */     GIR_EraseRootFromParent_Done,
     /* 1569666 */   // Label 21656: @1569666
     /* 1569666 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1569752), // Rule ID 6192 //
     /* 1569671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1569674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1569682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1569685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1569688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1569691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1569694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569717 */     // MIs[0] policy
     /* 1569717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1569730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1569748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569751 */     // GIR_Coverage, 6192,
     /* 1569751 */     GIR_EraseRootFromParent_Done,
     /* 1569752 */   // Label 21657: @1569752
     /* 1569752 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1569838), // Rule ID 6193 //
     /* 1569757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1569760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1569768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1569771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1569774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1569777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1569780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569803 */     // MIs[0] policy
     /* 1569803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569813 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1569816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1569834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569837 */     // GIR_Coverage, 6193,
     /* 1569837 */     GIR_EraseRootFromParent_Done,
     /* 1569838 */   // Label 21658: @1569838
     /* 1569838 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1569924), // Rule ID 6196 //
     /* 1569843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1569846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1569854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1569857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1569860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1569863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1569866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569889 */     // MIs[0] policy
     /* 1569889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569899 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1569902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1569920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569923 */     // GIR_Coverage, 6196,
     /* 1569923 */     GIR_EraseRootFromParent_Done,
     /* 1569924 */   // Label 21659: @1569924
     /* 1569924 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1570010), // Rule ID 6197 //
     /* 1569929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1569932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1569937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1569940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1569943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1569946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1569949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1569952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569975 */     // MIs[0] policy
     /* 1569975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569985 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1569988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1569994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1569996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1569998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570009 */     // GIR_Coverage, 6197,
     /* 1570009 */     GIR_EraseRootFromParent_Done,
     /* 1570010 */   // Label 21660: @1570010
     /* 1570010 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1570096), // Rule ID 6200 //
     /* 1570015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1570026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1570029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1570032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1570035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1570038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570061 */     // MIs[0] policy
     /* 1570061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1570074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570095 */     // GIR_Coverage, 6200,
     /* 1570095 */     GIR_EraseRootFromParent_Done,
     /* 1570096 */   // Label 21661: @1570096
     /* 1570096 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1570182), // Rule ID 6201 //
     /* 1570101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1570112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1570115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1570118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1570121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1570124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570147 */     // MIs[0] policy
     /* 1570147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570157 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1570160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570181 */     // GIR_Coverage, 6201,
     /* 1570181 */     GIR_EraseRootFromParent_Done,
     /* 1570182 */   // Label 21662: @1570182
     /* 1570182 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1570268), // Rule ID 6204 //
     /* 1570187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1570198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1570201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1570207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1570210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570233 */     // MIs[0] policy
     /* 1570233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1570246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570267 */     // GIR_Coverage, 6204,
     /* 1570267 */     GIR_EraseRootFromParent_Done,
     /* 1570268 */   // Label 21663: @1570268
     /* 1570268 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1570354), // Rule ID 6205 //
     /* 1570273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1570284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1570287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1570293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1570296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570319 */     // MIs[0] policy
     /* 1570319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1570332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570353 */     // GIR_Coverage, 6205,
     /* 1570353 */     GIR_EraseRootFromParent_Done,
     /* 1570354 */   // Label 21664: @1570354
     /* 1570354 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1570440), // Rule ID 6208 //
     /* 1570359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1570370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1570373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1570379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1570382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570405 */     // MIs[0] policy
     /* 1570405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1570418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570439 */     // GIR_Coverage, 6208,
     /* 1570439 */     GIR_EraseRootFromParent_Done,
     /* 1570440 */   // Label 21665: @1570440
     /* 1570440 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1570526), // Rule ID 6209 //
     /* 1570445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1570456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1570459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1570465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1570468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570491 */     // MIs[0] policy
     /* 1570491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570501 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1570504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570525 */     // GIR_Coverage, 6209,
     /* 1570525 */     GIR_EraseRootFromParent_Done,
     /* 1570526 */   // Label 21666: @1570526
     /* 1570526 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1570612), // Rule ID 6212 //
     /* 1570531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1570542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1570545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1570551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1570554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570577 */     // MIs[0] policy
     /* 1570577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570587 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1570590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570611 */     // GIR_Coverage, 6212,
     /* 1570611 */     GIR_EraseRootFromParent_Done,
     /* 1570612 */   // Label 21667: @1570612
     /* 1570612 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1570698), // Rule ID 6213 //
     /* 1570617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1570628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1570631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1570637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1570640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570663 */     // MIs[0] policy
     /* 1570663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570673 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1570676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570697 */     // GIR_Coverage, 6213,
     /* 1570697 */     GIR_EraseRootFromParent_Done,
     /* 1570698 */   // Label 21668: @1570698
     /* 1570698 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1570784), // Rule ID 6216 //
     /* 1570703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1570714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1570717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1570723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1570726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570749 */     // MIs[0] policy
     /* 1570749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1570762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570783 */     // GIR_Coverage, 6216,
     /* 1570783 */     GIR_EraseRootFromParent_Done,
     /* 1570784 */   // Label 21669: @1570784
     /* 1570784 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1570870), // Rule ID 6217 //
     /* 1570789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1570800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1570803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1570809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1570812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570835 */     // MIs[0] policy
     /* 1570835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1570848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570869 */     // GIR_Coverage, 6217,
     /* 1570869 */     GIR_EraseRootFromParent_Done,
     /* 1570870 */   // Label 21670: @1570870
     /* 1570870 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1570956), // Rule ID 6220 //
     /* 1570875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1570878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1570895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1570898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570921 */     // MIs[0] policy
     /* 1570921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1570934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1570940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1570942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1570944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570955 */     // GIR_Coverage, 6220,
     /* 1570955 */     GIR_EraseRootFromParent_Done,
     /* 1570956 */   // Label 21671: @1570956
     /* 1570956 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1571042), // Rule ID 6221 //
     /* 1570961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1570964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1570969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1570981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1570984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571007 */     // MIs[0] policy
     /* 1571007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571017 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1571020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571041 */     // GIR_Coverage, 6221,
     /* 1571041 */     GIR_EraseRootFromParent_Done,
     /* 1571042 */   // Label 21672: @1571042
     /* 1571042 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1571128), // Rule ID 6224 //
     /* 1571047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1571050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1571058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1571061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1571067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1571070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571093 */     // MIs[0] policy
     /* 1571093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571103 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1571106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571127 */     // GIR_Coverage, 6224,
     /* 1571127 */     GIR_EraseRootFromParent_Done,
     /* 1571128 */   // Label 21673: @1571128
     /* 1571128 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1571214), // Rule ID 6225 //
     /* 1571133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1571136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1571144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1571147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1571153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1571156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571179 */     // MIs[0] policy
     /* 1571179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1571192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571213 */     // GIR_Coverage, 6225,
     /* 1571213 */     GIR_EraseRootFromParent_Done,
     /* 1571214 */   // Label 21674: @1571214
     /* 1571214 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1571300), // Rule ID 6228 //
     /* 1571219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1571222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1571230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1571233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1571239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1571242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571265 */     // MIs[0] policy
     /* 1571265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1571278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571299 */     // GIR_Coverage, 6228,
     /* 1571299 */     GIR_EraseRootFromParent_Done,
     /* 1571300 */   // Label 21675: @1571300
     /* 1571300 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1571386), // Rule ID 6229 //
     /* 1571305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1571308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1571316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1571319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1571325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1571328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571351 */     // MIs[0] policy
     /* 1571351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1571364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571385 */     // GIR_Coverage, 6229,
     /* 1571385 */     GIR_EraseRootFromParent_Done,
     /* 1571386 */   // Label 21676: @1571386
     /* 1571386 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1571472), // Rule ID 6232 //
     /* 1571391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1571394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1571402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1571405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1571408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1571411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1571414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571437 */     // MIs[0] policy
     /* 1571437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571447 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1571450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571471 */     // GIR_Coverage, 6232,
     /* 1571471 */     GIR_EraseRootFromParent_Done,
     /* 1571472 */   // Label 21677: @1571472
     /* 1571472 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1571558), // Rule ID 6233 //
     /* 1571477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1571480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1571488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1571491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1571494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1571497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1571500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571523 */     // MIs[0] policy
     /* 1571523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571533 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1571536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571557 */     // GIR_Coverage, 6233,
     /* 1571557 */     GIR_EraseRootFromParent_Done,
     /* 1571558 */   // Label 21678: @1571558
     /* 1571558 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1571644), // Rule ID 6236 //
     /* 1571563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1571566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1571574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1571577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1571583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1571586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571609 */     // MIs[0] policy
     /* 1571609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571619 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1571622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571643 */     // GIR_Coverage, 6236,
     /* 1571643 */     GIR_EraseRootFromParent_Done,
     /* 1571644 */   // Label 21679: @1571644
     /* 1571644 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1571730), // Rule ID 6237 //
     /* 1571649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1571652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1571660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1571663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1571669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1571672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571695 */     // MIs[0] policy
     /* 1571695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571705 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1571708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1571726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571729 */     // GIR_Coverage, 6237,
     /* 1571729 */     GIR_EraseRootFromParent_Done,
     /* 1571730 */   // Label 21680: @1571730
     /* 1571730 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1571816), // Rule ID 6240 //
     /* 1571735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1571738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1571746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1571749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1571752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1571755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1571758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1571777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571781 */     // MIs[0] policy
     /* 1571781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571791 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1571794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571815 */     // GIR_Coverage, 6240,
     /* 1571815 */     GIR_EraseRootFromParent_Done,
     /* 1571816 */   // Label 21681: @1571816
     /* 1571816 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1571902), // Rule ID 6241 //
     /* 1571821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1571824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1571832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1571835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1571838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1571841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1571844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1571863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571867 */     // MIs[0] policy
     /* 1571867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571877 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1571880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571901 */     // GIR_Coverage, 6241,
     /* 1571901 */     GIR_EraseRootFromParent_Done,
     /* 1571902 */   // Label 21682: @1571902
     /* 1571902 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1571988), // Rule ID 6244 //
     /* 1571907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1571910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1571915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1571918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1571921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1571924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1571927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1571930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1571949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571953 */     // MIs[0] policy
     /* 1571953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571963 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1571966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1571972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1571974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1571976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571987 */     // GIR_Coverage, 6244,
     /* 1571987 */     GIR_EraseRootFromParent_Done,
     /* 1571988 */   // Label 21683: @1571988
     /* 1571988 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1572074), // Rule ID 6245 //
     /* 1571993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1571996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1572004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1572007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1572010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1572016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572039 */     // MIs[0] policy
     /* 1572039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1572052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572073 */     // GIR_Coverage, 6245,
     /* 1572073 */     GIR_EraseRootFromParent_Done,
     /* 1572074 */   // Label 21684: @1572074
     /* 1572074 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1572160), // Rule ID 6248 //
     /* 1572079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1572096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1572102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572125 */     // MIs[0] policy
     /* 1572125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572135 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572159 */     // GIR_Coverage, 6248,
     /* 1572159 */     GIR_EraseRootFromParent_Done,
     /* 1572160 */   // Label 21685: @1572160
     /* 1572160 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1572246), // Rule ID 6249 //
     /* 1572165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1572182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1572188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572211 */     // MIs[0] policy
     /* 1572211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572221 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572245 */     // GIR_Coverage, 6249,
     /* 1572245 */     GIR_EraseRootFromParent_Done,
     /* 1572246 */   // Label 21686: @1572246
     /* 1572246 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1572332), // Rule ID 6252 //
     /* 1572251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572297 */     // MIs[0] policy
     /* 1572297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572307 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1572310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572331 */     // GIR_Coverage, 6252,
     /* 1572331 */     GIR_EraseRootFromParent_Done,
     /* 1572332 */   // Label 21687: @1572332
     /* 1572332 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1572418), // Rule ID 6253 //
     /* 1572337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572383 */     // MIs[0] policy
     /* 1572383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1572396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572417 */     // GIR_Coverage, 6253,
     /* 1572417 */     GIR_EraseRootFromParent_Done,
     /* 1572418 */   // Label 21688: @1572418
     /* 1572418 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1572504), // Rule ID 6256 //
     /* 1572423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1572446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572469 */     // MIs[0] policy
     /* 1572469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572479 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572503 */     // GIR_Coverage, 6256,
     /* 1572503 */     GIR_EraseRootFromParent_Done,
     /* 1572504 */   // Label 21689: @1572504
     /* 1572504 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1572590), // Rule ID 6257 //
     /* 1572509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1572532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572555 */     // MIs[0] policy
     /* 1572555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572565 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572589 */     // GIR_Coverage, 6257,
     /* 1572589 */     GIR_EraseRootFromParent_Done,
     /* 1572590 */   // Label 21690: @1572590
     /* 1572590 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1572676), // Rule ID 6260 //
     /* 1572595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1572612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572641 */     // MIs[0] policy
     /* 1572641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572675 */     // GIR_Coverage, 6260,
     /* 1572675 */     GIR_EraseRootFromParent_Done,
     /* 1572676 */   // Label 21691: @1572676
     /* 1572676 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1572762), // Rule ID 6261 //
     /* 1572681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1572698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572727 */     // MIs[0] policy
     /* 1572727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572737 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1572740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572761 */     // GIR_Coverage, 6261,
     /* 1572761 */     GIR_EraseRootFromParent_Done,
     /* 1572762 */   // Label 21692: @1572762
     /* 1572762 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1572848), // Rule ID 6264 //
     /* 1572767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1572781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1572784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1572790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572813 */     // MIs[0] policy
     /* 1572813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572823 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1572826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572847 */     // GIR_Coverage, 6264,
     /* 1572847 */     GIR_EraseRootFromParent_Done,
     /* 1572848 */   // Label 21693: @1572848
     /* 1572848 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1572934), // Rule ID 6265 //
     /* 1572853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1572867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1572870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1572873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1572876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572899 */     // MIs[0] policy
     /* 1572899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572909 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1572912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1572918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572933 */     // GIR_Coverage, 6265,
     /* 1572933 */     GIR_EraseRootFromParent_Done,
     /* 1572934 */   // Label 21694: @1572934
     /* 1572934 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1573020), // Rule ID 6268 //
     /* 1572939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1572947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1572950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1572953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1572959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1572962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1572981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572985 */     // MIs[0] policy
     /* 1572985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1572998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573019 */     // GIR_Coverage, 6268,
     /* 1573019 */     GIR_EraseRootFromParent_Done,
     /* 1573020 */   // Label 21695: @1573020
     /* 1573020 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1573106), // Rule ID 6269 //
     /* 1573025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1573042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1573048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573071 */     // MIs[0] policy
     /* 1573071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1573084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573105 */     // GIR_Coverage, 6269,
     /* 1573105 */     GIR_EraseRootFromParent_Done,
     /* 1573106 */   // Label 21696: @1573106
     /* 1573106 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1573192), // Rule ID 6272 //
     /* 1573111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1573134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573157 */     // MIs[0] policy
     /* 1573157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573167 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1573170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573191 */     // GIR_Coverage, 6272,
     /* 1573191 */     GIR_EraseRootFromParent_Done,
     /* 1573192 */   // Label 21697: @1573192
     /* 1573192 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1573278), // Rule ID 6273 //
     /* 1573197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1573220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573243 */     // MIs[0] policy
     /* 1573243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573253 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1573256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573277 */     // GIR_Coverage, 6273,
     /* 1573277 */     GIR_EraseRootFromParent_Done,
     /* 1573278 */   // Label 21698: @1573278
     /* 1573278 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1573364), // Rule ID 6276 //
     /* 1573283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1573286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1573294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1573297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1573300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1573306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573329 */     // MIs[0] policy
     /* 1573329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1573342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1573360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573363 */     // GIR_Coverage, 6276,
     /* 1573363 */     GIR_EraseRootFromParent_Done,
     /* 1573364 */   // Label 21699: @1573364
     /* 1573364 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1573450), // Rule ID 6277 //
     /* 1573369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1573372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1573380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1573383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1573386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1573392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573415 */     // MIs[0] policy
     /* 1573415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573425 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1573428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1573446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573449 */     // GIR_Coverage, 6277,
     /* 1573449 */     GIR_EraseRootFromParent_Done,
     /* 1573450 */   // Label 21700: @1573450
     /* 1573450 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1573536), // Rule ID 6280 //
     /* 1573455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1573472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1573478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573501 */     // MIs[0] policy
     /* 1573501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573511 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1573514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573535 */     // GIR_Coverage, 6280,
     /* 1573535 */     GIR_EraseRootFromParent_Done,
     /* 1573536 */   // Label 21701: @1573536
     /* 1573536 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1573622), // Rule ID 6281 //
     /* 1573541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1573558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1573564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573587 */     // MIs[0] policy
     /* 1573587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1573600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573621 */     // GIR_Coverage, 6281,
     /* 1573621 */     GIR_EraseRootFromParent_Done,
     /* 1573622 */   // Label 21702: @1573622
     /* 1573622 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1573708), // Rule ID 6284 //
     /* 1573627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1573644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1573650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573673 */     // MIs[0] policy
     /* 1573673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573683 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1573686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573707 */     // GIR_Coverage, 6284,
     /* 1573707 */     GIR_EraseRootFromParent_Done,
     /* 1573708 */   // Label 21703: @1573708
     /* 1573708 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1573794), // Rule ID 6285 //
     /* 1573713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1573730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1573736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573759 */     // MIs[0] policy
     /* 1573759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573769 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1573772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573793 */     // GIR_Coverage, 6285,
     /* 1573793 */     GIR_EraseRootFromParent_Done,
     /* 1573794 */   // Label 21704: @1573794
     /* 1573794 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1573880), // Rule ID 6288 //
     /* 1573799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1573810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1573813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1573816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1573822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573845 */     // MIs[0] policy
     /* 1573845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573855 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1573858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573879 */     // GIR_Coverage, 6288,
     /* 1573879 */     GIR_EraseRootFromParent_Done,
     /* 1573880 */   // Label 21705: @1573880
     /* 1573880 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1573966), // Rule ID 6289 //
     /* 1573885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1573896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1573899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1573902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1573905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1573908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1573927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573931 */     // MIs[0] policy
     /* 1573931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573941 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1573944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1573950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573965 */     // GIR_Coverage, 6289,
     /* 1573965 */     GIR_EraseRootFromParent_Done,
     /* 1573966 */   // Label 21706: @1573966
     /* 1573966 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1574052), // Rule ID 6292 //
     /* 1573971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1573979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1573991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1573994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574017 */     // MIs[0] policy
     /* 1574017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1574030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574051 */     // GIR_Coverage, 6292,
     /* 1574051 */     GIR_EraseRootFromParent_Done,
     /* 1574052 */   // Label 21707: @1574052
     /* 1574052 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1574138), // Rule ID 6293 //
     /* 1574057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1574074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1574080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574103 */     // MIs[0] policy
     /* 1574103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1574116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574137 */     // GIR_Coverage, 6293,
     /* 1574137 */     GIR_EraseRootFromParent_Done,
     /* 1574138 */   // Label 21708: @1574138
     /* 1574138 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1574224), // Rule ID 6296 //
     /* 1574143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1574160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1574163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574189 */     // MIs[0] policy
     /* 1574189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1574202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574223 */     // GIR_Coverage, 6296,
     /* 1574223 */     GIR_EraseRootFromParent_Done,
     /* 1574224 */   // Label 21709: @1574224
     /* 1574224 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1574310), // Rule ID 6297 //
     /* 1574229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1574246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574275 */     // MIs[0] policy
     /* 1574275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574285 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1574288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574309 */     // GIR_Coverage, 6297,
     /* 1574309 */     GIR_EraseRootFromParent_Done,
     /* 1574310 */   // Label 21710: @1574310
     /* 1574310 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1574396), // Rule ID 6300 //
     /* 1574315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1574326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1574329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1574332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1574335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1574338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574361 */     // MIs[0] policy
     /* 1574361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574371 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1574374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574395 */     // GIR_Coverage, 6300,
     /* 1574395 */     GIR_EraseRootFromParent_Done,
     /* 1574396 */   // Label 21711: @1574396
     /* 1574396 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1574482), // Rule ID 6301 //
     /* 1574401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1574412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1574415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1574418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1574424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574447 */     // MIs[0] policy
     /* 1574447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574457 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1574460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574481 */     // GIR_Coverage, 6301,
     /* 1574481 */     GIR_EraseRootFromParent_Done,
     /* 1574482 */   // Label 21712: @1574482
     /* 1574482 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1574568), // Rule ID 6304 //
     /* 1574487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1574507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574533 */     // MIs[0] policy
     /* 1574533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1574546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574567 */     // GIR_Coverage, 6304,
     /* 1574567 */     GIR_EraseRootFromParent_Done,
     /* 1574568 */   // Label 21713: @1574568
     /* 1574568 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1574654), // Rule ID 6305 //
     /* 1574573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574619 */     // MIs[0] policy
     /* 1574619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1574632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574653 */     // GIR_Coverage, 6305,
     /* 1574653 */     GIR_EraseRootFromParent_Done,
     /* 1574654 */   // Label 21714: @1574654
     /* 1574654 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1574740), // Rule ID 6308 //
     /* 1574659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1574679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1574682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574705 */     // MIs[0] policy
     /* 1574705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574715 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1574718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574739 */     // GIR_Coverage, 6308,
     /* 1574739 */     GIR_EraseRootFromParent_Done,
     /* 1574740 */   // Label 21715: @1574740
     /* 1574740 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1574826), // Rule ID 6309 //
     /* 1574745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1574768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574791 */     // MIs[0] policy
     /* 1574791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1574804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574825 */     // GIR_Coverage, 6309,
     /* 1574825 */     GIR_EraseRootFromParent_Done,
     /* 1574826 */   // Label 21716: @1574826
     /* 1574826 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1574912), // Rule ID 6312 //
     /* 1574831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1574842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1574845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1574851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574877 */     // MIs[0] policy
     /* 1574877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574887 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1574890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574911 */     // GIR_Coverage, 6312,
     /* 1574911 */     GIR_EraseRootFromParent_Done,
     /* 1574912 */   // Label 21717: @1574912
     /* 1574912 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1574998), // Rule ID 6313 //
     /* 1574917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1574925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1574928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1574931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1574937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1574959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574963 */     // MIs[0] policy
     /* 1574963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574973 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1574976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1574982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574997 */     // GIR_Coverage, 6313,
     /* 1574997 */     GIR_EraseRootFromParent_Done,
     /* 1574998 */   // Label 21718: @1574998
     /* 1574998 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1575084), // Rule ID 6316 //
     /* 1575003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1575006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1575014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1575017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1575023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575049 */     // MIs[0] policy
     /* 1575049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1575062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575083 */     // GIR_Coverage, 6316,
     /* 1575083 */     GIR_EraseRootFromParent_Done,
     /* 1575084 */   // Label 21719: @1575084
     /* 1575084 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1575170), // Rule ID 6317 //
     /* 1575089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1575092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1575100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1575103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1575109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575135 */     // MIs[0] policy
     /* 1575135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1575148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575169 */     // GIR_Coverage, 6317,
     /* 1575169 */     GIR_EraseRootFromParent_Done,
     /* 1575170 */   // Label 21720: @1575170
     /* 1575170 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1575256), // Rule ID 6320 //
     /* 1575175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1575178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1575186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1575189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1575195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575221 */     // MIs[0] policy
     /* 1575221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1575234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575255 */     // GIR_Coverage, 6320,
     /* 1575255 */     GIR_EraseRootFromParent_Done,
     /* 1575256 */   // Label 21721: @1575256
     /* 1575256 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1575342), // Rule ID 6321 //
     /* 1575261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1575264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1575272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1575275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1575281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575307 */     // MIs[0] policy
     /* 1575307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575317 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1575320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575341 */     // GIR_Coverage, 6321,
     /* 1575341 */     GIR_EraseRootFromParent_Done,
     /* 1575342 */   // Label 21722: @1575342
     /* 1575342 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1575428), // Rule ID 6324 //
     /* 1575347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1575350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1575358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1575361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1575367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1575377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575393 */     // MIs[0] policy
     /* 1575393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575403 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1575406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575427 */     // GIR_Coverage, 6324,
     /* 1575427 */     GIR_EraseRootFromParent_Done,
     /* 1575428 */   // Label 21723: @1575428
     /* 1575428 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1575514), // Rule ID 6325 //
     /* 1575433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1575436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1575441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1575444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1575447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1575453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1575463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1575475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575479 */     // MIs[0] policy
     /* 1575479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1575492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1575510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575513 */     // GIR_Coverage, 6325,
     /* 1575513 */     GIR_EraseRootFromParent_Done,
     /* 1575514 */   // Label 21724: @1575514
     /* 1575514 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1575600), // Rule ID 6416 //
     /* 1575519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1575530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1575533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1575536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1575539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1575542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575565 */     // MIs[0] policy
     /* 1575565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575575 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1575578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575599 */     // GIR_Coverage, 6416,
     /* 1575599 */     GIR_EraseRootFromParent_Done,
     /* 1575600 */   // Label 21725: @1575600
     /* 1575600 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1575686), // Rule ID 6417 //
     /* 1575605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1575616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1575619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1575622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1575625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1575628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575651 */     // MIs[0] policy
     /* 1575651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575661 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1575664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575685 */     // GIR_Coverage, 6417,
     /* 1575685 */     GIR_EraseRootFromParent_Done,
     /* 1575686 */   // Label 21726: @1575686
     /* 1575686 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1575772), // Rule ID 6420 //
     /* 1575691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1575702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1575705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1575708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1575711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575737 */     // MIs[0] policy
     /* 1575737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575747 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1575750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575771 */     // GIR_Coverage, 6420,
     /* 1575771 */     GIR_EraseRootFromParent_Done,
     /* 1575772 */   // Label 21727: @1575772
     /* 1575772 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1575858), // Rule ID 6421 //
     /* 1575777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1575788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1575791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1575794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1575797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575823 */     // MIs[0] policy
     /* 1575823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575833 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1575836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575857 */     // GIR_Coverage, 6421,
     /* 1575857 */     GIR_EraseRootFromParent_Done,
     /* 1575858 */   // Label 21728: @1575858
     /* 1575858 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1575944), // Rule ID 6424 //
     /* 1575863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1575874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1575877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1575880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1575883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575909 */     // MIs[0] policy
     /* 1575909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1575922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1575928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575943 */     // GIR_Coverage, 6424,
     /* 1575943 */     GIR_EraseRootFromParent_Done,
     /* 1575944 */   // Label 21729: @1575944
     /* 1575944 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1576030), // Rule ID 6425 //
     /* 1575949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1575957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1575960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1575963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1575966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1575969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575995 */     // MIs[0] policy
     /* 1575995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576005 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1576008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576029 */     // GIR_Coverage, 6425,
     /* 1576029 */     GIR_EraseRootFromParent_Done,
     /* 1576030 */   // Label 21730: @1576030
     /* 1576030 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1576116), // Rule ID 6428 //
     /* 1576035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1576052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1576055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576081 */     // MIs[0] policy
     /* 1576081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576091 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1576094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576115 */     // GIR_Coverage, 6428,
     /* 1576115 */     GIR_EraseRootFromParent_Done,
     /* 1576116 */   // Label 21731: @1576116
     /* 1576116 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1576202), // Rule ID 6429 //
     /* 1576121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1576138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1576141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576167 */     // MIs[0] policy
     /* 1576167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1576180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576201 */     // GIR_Coverage, 6429,
     /* 1576201 */     GIR_EraseRootFromParent_Done,
     /* 1576202 */   // Label 21732: @1576202
     /* 1576202 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1576288), // Rule ID 6432 //
     /* 1576207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1576224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1576227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1576230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576253 */     // MIs[0] policy
     /* 1576253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576263 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1576266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576287 */     // GIR_Coverage, 6432,
     /* 1576287 */     GIR_EraseRootFromParent_Done,
     /* 1576288 */   // Label 21733: @1576288
     /* 1576288 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1576374), // Rule ID 6433 //
     /* 1576293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1576310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1576313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1576316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576339 */     // MIs[0] policy
     /* 1576339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576349 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1576352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576373 */     // GIR_Coverage, 6433,
     /* 1576373 */     GIR_EraseRootFromParent_Done,
     /* 1576374 */   // Label 21734: @1576374
     /* 1576374 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1576460), // Rule ID 6436 //
     /* 1576379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1576399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576425 */     // MIs[0] policy
     /* 1576425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576435 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1576438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576459 */     // GIR_Coverage, 6436,
     /* 1576459 */     GIR_EraseRootFromParent_Done,
     /* 1576460 */   // Label 21735: @1576460
     /* 1576460 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1576546), // Rule ID 6437 //
     /* 1576465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1576485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576511 */     // MIs[0] policy
     /* 1576511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1576524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576545 */     // GIR_Coverage, 6437,
     /* 1576545 */     GIR_EraseRootFromParent_Done,
     /* 1576546 */   // Label 21736: @1576546
     /* 1576546 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1576632), // Rule ID 6440 //
     /* 1576551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1576562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1576565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1576568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1576571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1576574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576597 */     // MIs[0] policy
     /* 1576597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1576610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576631 */     // GIR_Coverage, 6440,
     /* 1576631 */     GIR_EraseRootFromParent_Done,
     /* 1576632 */   // Label 21737: @1576632
     /* 1576632 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1576718), // Rule ID 6441 //
     /* 1576637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1576648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1576651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1576654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1576657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1576660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576683 */     // MIs[0] policy
     /* 1576683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1576696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576717 */     // GIR_Coverage, 6441,
     /* 1576717 */     GIR_EraseRootFromParent_Done,
     /* 1576718 */   // Label 21738: @1576718
     /* 1576718 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1576804), // Rule ID 6444 //
     /* 1576723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1576740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1576743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1576746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576769 */     // MIs[0] policy
     /* 1576769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1576782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576803 */     // GIR_Coverage, 6444,
     /* 1576803 */     GIR_EraseRootFromParent_Done,
     /* 1576804 */   // Label 21739: @1576804
     /* 1576804 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1576890), // Rule ID 6445 //
     /* 1576809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1576826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1576829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1576832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576855 */     // MIs[0] policy
     /* 1576855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1576868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576889 */     // GIR_Coverage, 6445,
     /* 1576889 */     GIR_EraseRootFromParent_Done,
     /* 1576890 */   // Label 21740: @1576890
     /* 1576890 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1576976), // Rule ID 6448 //
     /* 1576895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1576915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1576918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576941 */     // MIs[0] policy
     /* 1576941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1576954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1576960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576975 */     // GIR_Coverage, 6448,
     /* 1576975 */     GIR_EraseRootFromParent_Done,
     /* 1576976 */   // Label 21741: @1576976
     /* 1576976 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1577062), // Rule ID 6449 //
     /* 1576981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1576989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1577001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577027 */     // MIs[0] policy
     /* 1577027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577037 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1577040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577061 */     // GIR_Coverage, 6449,
     /* 1577061 */     GIR_EraseRootFromParent_Done,
     /* 1577062 */   // Label 21742: @1577062
     /* 1577062 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1577148), // Rule ID 6452 //
     /* 1577067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1577070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1577078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1577081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1577087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577113 */     // MIs[0] policy
     /* 1577113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577123 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1577126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1577144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577147 */     // GIR_Coverage, 6452,
     /* 1577147 */     GIR_EraseRootFromParent_Done,
     /* 1577148 */   // Label 21743: @1577148
     /* 1577148 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1577234), // Rule ID 6453 //
     /* 1577153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1577156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1577164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1577167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1577173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577199 */     // MIs[0] policy
     /* 1577199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1577212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1577230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577233 */     // GIR_Coverage, 6453,
     /* 1577233 */     GIR_EraseRootFromParent_Done,
     /* 1577234 */   // Label 21744: @1577234
     /* 1577234 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1577320), // Rule ID 6456 //
     /* 1577239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1577250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1577253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1577256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1577259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1577262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577285 */     // MIs[0] policy
     /* 1577285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1577298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577319 */     // GIR_Coverage, 6456,
     /* 1577319 */     GIR_EraseRootFromParent_Done,
     /* 1577320 */   // Label 21745: @1577320
     /* 1577320 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1577406), // Rule ID 6457 //
     /* 1577325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1577336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1577339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1577342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1577345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1577348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577371 */     // MIs[0] policy
     /* 1577371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577381 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1577384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577405 */     // GIR_Coverage, 6457,
     /* 1577405 */     GIR_EraseRootFromParent_Done,
     /* 1577406 */   // Label 21746: @1577406
     /* 1577406 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1577492), // Rule ID 6460 //
     /* 1577411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1577422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1577425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1577428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1577431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1577434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577457 */     // MIs[0] policy
     /* 1577457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1577470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577491 */     // GIR_Coverage, 6460,
     /* 1577491 */     GIR_EraseRootFromParent_Done,
     /* 1577492 */   // Label 21747: @1577492
     /* 1577492 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1577578), // Rule ID 6461 //
     /* 1577497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1577508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1577511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1577514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1577517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1577520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577543 */     // MIs[0] policy
     /* 1577543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577553 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1577556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577577 */     // GIR_Coverage, 6461,
     /* 1577577 */     GIR_EraseRootFromParent_Done,
     /* 1577578 */   // Label 21748: @1577578
     /* 1577578 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1577664), // Rule ID 6464 //
     /* 1577583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1577594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1577597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1577600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1577603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1577606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577629 */     // MIs[0] policy
     /* 1577629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577639 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1577642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577663 */     // GIR_Coverage, 6464,
     /* 1577663 */     GIR_EraseRootFromParent_Done,
     /* 1577664 */   // Label 21749: @1577664
     /* 1577664 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1577750), // Rule ID 6465 //
     /* 1577669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1577680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1577683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1577686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1577689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1577692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577715 */     // MIs[0] policy
     /* 1577715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577725 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1577728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577749 */     // GIR_Coverage, 6465,
     /* 1577749 */     GIR_EraseRootFromParent_Done,
     /* 1577750 */   // Label 21750: @1577750
     /* 1577750 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1577836), // Rule ID 6468 //
     /* 1577755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1577772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1577775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577801 */     // MIs[0] policy
     /* 1577801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1577814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577835 */     // GIR_Coverage, 6468,
     /* 1577835 */     GIR_EraseRootFromParent_Done,
     /* 1577836 */   // Label 21751: @1577836
     /* 1577836 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1577922), // Rule ID 6469 //
     /* 1577841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1577858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1577861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577887 */     // MIs[0] policy
     /* 1577887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577897 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1577900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577921 */     // GIR_Coverage, 6469,
     /* 1577921 */     GIR_EraseRootFromParent_Done,
     /* 1577922 */   // Label 21752: @1577922
     /* 1577922 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1578008), // Rule ID 6472 //
     /* 1577927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1577935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1577944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1577947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1577950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577973 */     // MIs[0] policy
     /* 1577973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577983 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1577986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1577992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578007 */     // GIR_Coverage, 6472,
     /* 1578007 */     GIR_EraseRootFromParent_Done,
     /* 1578008 */   // Label 21753: @1578008
     /* 1578008 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1578094), // Rule ID 6473 //
     /* 1578013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1578030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1578033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578059 */     // MIs[0] policy
     /* 1578059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578069 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1578072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578093 */     // GIR_Coverage, 6473,
     /* 1578093 */     GIR_EraseRootFromParent_Done,
     /* 1578094 */   // Label 21754: @1578094
     /* 1578094 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1578180), // Rule ID 6476 //
     /* 1578099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1578110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1578113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1578116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1578119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1578122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578145 */     // MIs[0] policy
     /* 1578145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578155 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1578158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578179 */     // GIR_Coverage, 6476,
     /* 1578179 */     GIR_EraseRootFromParent_Done,
     /* 1578180 */   // Label 21755: @1578180
     /* 1578180 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1578266), // Rule ID 6477 //
     /* 1578185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1578196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1578199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1578202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1578205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1578208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578231 */     // MIs[0] policy
     /* 1578231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1578244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578265 */     // GIR_Coverage, 6477,
     /* 1578265 */     GIR_EraseRootFromParent_Done,
     /* 1578266 */   // Label 21756: @1578266
     /* 1578266 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1578352), // Rule ID 6480 //
     /* 1578271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1578291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578317 */     // MIs[0] policy
     /* 1578317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1578330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578351 */     // GIR_Coverage, 6480,
     /* 1578351 */     GIR_EraseRootFromParent_Done,
     /* 1578352 */   // Label 21757: @1578352
     /* 1578352 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1578438), // Rule ID 6481 //
     /* 1578357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1578377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578403 */     // MIs[0] policy
     /* 1578403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1578416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578437 */     // GIR_Coverage, 6481,
     /* 1578437 */     GIR_EraseRootFromParent_Done,
     /* 1578438 */   // Label 21758: @1578438
     /* 1578438 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1578524), // Rule ID 6484 //
     /* 1578443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1578463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578489 */     // MIs[0] policy
     /* 1578489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578499 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1578502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578523 */     // GIR_Coverage, 6484,
     /* 1578523 */     GIR_EraseRootFromParent_Done,
     /* 1578524 */   // Label 21759: @1578524
     /* 1578524 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1578610), // Rule ID 6485 //
     /* 1578529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1578549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578575 */     // MIs[0] policy
     /* 1578575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1578588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578609 */     // GIR_Coverage, 6485,
     /* 1578609 */     GIR_EraseRootFromParent_Done,
     /* 1578610 */   // Label 21760: @1578610
     /* 1578610 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1578696), // Rule ID 6488 //
     /* 1578615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1578626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1578629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1578635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578661 */     // MIs[0] policy
     /* 1578661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1578674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578695 */     // GIR_Coverage, 6488,
     /* 1578695 */     GIR_EraseRootFromParent_Done,
     /* 1578696 */   // Label 21761: @1578696
     /* 1578696 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1578782), // Rule ID 6489 //
     /* 1578701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1578712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1578715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1578721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578747 */     // MIs[0] policy
     /* 1578747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578757 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1578760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578781 */     // GIR_Coverage, 6489,
     /* 1578781 */     GIR_EraseRootFromParent_Done,
     /* 1578782 */   // Label 21762: @1578782
     /* 1578782 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1578868), // Rule ID 6492 //
     /* 1578787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1578790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1578798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1578801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1578807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578833 */     // MIs[0] policy
     /* 1578833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1578846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1578864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578867 */     // GIR_Coverage, 6492,
     /* 1578867 */     GIR_EraseRootFromParent_Done,
     /* 1578868 */   // Label 21763: @1578868
     /* 1578868 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1578954), // Rule ID 6493 //
     /* 1578873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1578876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1578884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1578887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1578893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578919 */     // MIs[0] policy
     /* 1578919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1578932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1578938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1578950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578953 */     // GIR_Coverage, 6493,
     /* 1578953 */     GIR_EraseRootFromParent_Done,
     /* 1578954 */   // Label 21764: @1578954
     /* 1578954 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1579040), // Rule ID 6496 //
     /* 1578959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1578962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1578967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1578970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1578973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1578979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579005 */     // MIs[0] policy
     /* 1579005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1579018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1579036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579039 */     // GIR_Coverage, 6496,
     /* 1579039 */     GIR_EraseRootFromParent_Done,
     /* 1579040 */   // Label 21765: @1579040
     /* 1579040 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1579126), // Rule ID 6497 //
     /* 1579045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1579048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1579056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1579059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1579065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579091 */     // MIs[0] policy
     /* 1579091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1579104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1579122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579125 */     // GIR_Coverage, 6497,
     /* 1579125 */     GIR_EraseRootFromParent_Done,
     /* 1579126 */   // Label 21766: @1579126
     /* 1579126 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1579212), // Rule ID 6500 //
     /* 1579131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1579134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1579142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1579145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1579151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579177 */     // MIs[0] policy
     /* 1579177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579187 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1579190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1579208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579211 */     // GIR_Coverage, 6500,
     /* 1579211 */     GIR_EraseRootFromParent_Done,
     /* 1579212 */   // Label 21767: @1579212
     /* 1579212 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1579298), // Rule ID 6501 //
     /* 1579217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1579220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1579228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1579231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1579237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579263 */     // MIs[0] policy
     /* 1579263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579273 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1579276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1579294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579297 */     // GIR_Coverage, 6501,
     /* 1579297 */     GIR_EraseRootFromParent_Done,
     /* 1579298 */   // Label 21768: @1579298
     /* 1579298 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1579384), // Rule ID 6504 //
     /* 1579303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1579314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1579317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1579320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1579323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579349 */     // MIs[0] policy
     /* 1579349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1579362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579383 */     // GIR_Coverage, 6504,
     /* 1579383 */     GIR_EraseRootFromParent_Done,
     /* 1579384 */   // Label 21769: @1579384
     /* 1579384 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1579470), // Rule ID 6505 //
     /* 1579389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1579400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1579403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1579406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1579409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579435 */     // MIs[0] policy
     /* 1579435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579445 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1579448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579469 */     // GIR_Coverage, 6505,
     /* 1579469 */     GIR_EraseRootFromParent_Done,
     /* 1579470 */   // Label 21770: @1579470
     /* 1579470 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1579556), // Rule ID 6508 //
     /* 1579475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1579486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1579489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1579492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1579495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579521 */     // MIs[0] policy
     /* 1579521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579531 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1579534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579555 */     // GIR_Coverage, 6508,
     /* 1579555 */     GIR_EraseRootFromParent_Done,
     /* 1579556 */   // Label 21771: @1579556
     /* 1579556 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1579642), // Rule ID 6509 //
     /* 1579561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1579572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1579575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1579578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1579581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579607 */     // MIs[0] policy
     /* 1579607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579617 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1579620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579641 */     // GIR_Coverage, 6509,
     /* 1579641 */     GIR_EraseRootFromParent_Done,
     /* 1579642 */   // Label 21772: @1579642
     /* 1579642 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1579728), // Rule ID 6512 //
     /* 1579647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1579658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1579661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1579664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1579667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579693 */     // MIs[0] policy
     /* 1579693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579703 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1579706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579727 */     // GIR_Coverage, 6512,
     /* 1579727 */     GIR_EraseRootFromParent_Done,
     /* 1579728 */   // Label 21773: @1579728
     /* 1579728 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1579814), // Rule ID 6513 //
     /* 1579733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1579744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1579747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1579750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1579753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579779 */     // MIs[0] policy
     /* 1579779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579789 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1579792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579813 */     // GIR_Coverage, 6513,
     /* 1579813 */     GIR_EraseRootFromParent_Done,
     /* 1579814 */   // Label 21774: @1579814
     /* 1579814 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1579900), // Rule ID 6516 //
     /* 1579819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1579836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1579839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579865 */     // MIs[0] policy
     /* 1579865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579875 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1579878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579899 */     // GIR_Coverage, 6516,
     /* 1579899 */     GIR_EraseRootFromParent_Done,
     /* 1579900 */   // Label 21775: @1579900
     /* 1579900 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1579986), // Rule ID 6517 //
     /* 1579905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1579922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1579925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1579947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579951 */     // MIs[0] policy
     /* 1579951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579961 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1579964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1579970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579985 */     // GIR_Coverage, 6517,
     /* 1579985 */     GIR_EraseRootFromParent_Done,
     /* 1579986 */   // Label 21776: @1579986
     /* 1579986 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1580072), // Rule ID 6520 //
     /* 1579991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1579999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1580008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580037 */     // MIs[0] policy
     /* 1580037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580047 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1580050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580071 */     // GIR_Coverage, 6520,
     /* 1580071 */     GIR_EraseRootFromParent_Done,
     /* 1580072 */   // Label 21777: @1580072
     /* 1580072 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1580158), // Rule ID 6521 //
     /* 1580077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1580094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580123 */     // MIs[0] policy
     /* 1580123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1580136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580157 */     // GIR_Coverage, 6521,
     /* 1580157 */     GIR_EraseRootFromParent_Done,
     /* 1580158 */   // Label 21778: @1580158
     /* 1580158 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1580244), // Rule ID 6524 //
     /* 1580163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1580180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580209 */     // MIs[0] policy
     /* 1580209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580219 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1580222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580243 */     // GIR_Coverage, 6524,
     /* 1580243 */     GIR_EraseRootFromParent_Done,
     /* 1580244 */   // Label 21779: @1580244
     /* 1580244 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1580330), // Rule ID 6525 //
     /* 1580249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1580266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580295 */     // MIs[0] policy
     /* 1580295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580305 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1580308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580329 */     // GIR_Coverage, 6525,
     /* 1580329 */     GIR_EraseRootFromParent_Done,
     /* 1580330 */   // Label 21780: @1580330
     /* 1580330 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1580416), // Rule ID 6528 //
     /* 1580335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1580346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1580349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1580352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580381 */     // MIs[0] policy
     /* 1580381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580391 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580415 */     // GIR_Coverage, 6528,
     /* 1580415 */     GIR_EraseRootFromParent_Done,
     /* 1580416 */   // Label 21781: @1580416
     /* 1580416 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1580502), // Rule ID 6529 //
     /* 1580421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1580432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1580435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1580438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580467 */     // MIs[0] policy
     /* 1580467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11245:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580501 */     // GIR_Coverage, 6529,
     /* 1580501 */     GIR_EraseRootFromParent_Done,
     /* 1580502 */   // Label 21782: @1580502
     /* 1580502 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1580588), // Rule ID 6532 //
     /* 1580507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1580524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580553 */     // MIs[0] policy
     /* 1580553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580563 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580587 */     // GIR_Coverage, 6532,
     /* 1580587 */     GIR_EraseRootFromParent_Done,
     /* 1580588 */   // Label 21783: @1580588
     /* 1580588 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1580674), // Rule ID 6533 //
     /* 1580593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1580610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580639 */     // MIs[0] policy
     /* 1580639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580673 */     // GIR_Coverage, 6533,
     /* 1580673 */     GIR_EraseRootFromParent_Done,
     /* 1580674 */   // Label 21784: @1580674
     /* 1580674 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1580760), // Rule ID 6536 //
     /* 1580679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1580696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580725 */     // MIs[0] policy
     /* 1580725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580735 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580759 */     // GIR_Coverage, 6536,
     /* 1580759 */     GIR_EraseRootFromParent_Done,
     /* 1580760 */   // Label 21785: @1580760
     /* 1580760 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1580846), // Rule ID 6537 //
     /* 1580765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1580782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580811 */     // MIs[0] policy
     /* 1580811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580845 */     // GIR_Coverage, 6537,
     /* 1580845 */     GIR_EraseRootFromParent_Done,
     /* 1580846 */   // Label 21786: @1580846
     /* 1580846 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1580932), // Rule ID 6540 //
     /* 1580851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1580854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1580862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1580865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1580868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1580871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580897 */     // MIs[0] policy
     /* 1580897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580907 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1580916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1580928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580931 */     // GIR_Coverage, 6540,
     /* 1580931 */     GIR_EraseRootFromParent_Done,
     /* 1580932 */   // Label 21787: @1580932
     /* 1580932 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1581018), // Rule ID 6541 //
     /* 1580937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1580940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1580945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1580948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1580951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1580954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1580957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1580979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580983 */     // MIs[0] policy
     /* 1580983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1580996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1581014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581017 */     // GIR_Coverage, 6541,
     /* 1581017 */     GIR_EraseRootFromParent_Done,
     /* 1581018 */   // Label 21788: @1581018
     /* 1581018 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1581104), // Rule ID 6544 //
     /* 1581023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1581034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1581037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1581040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581069 */     // MIs[0] policy
     /* 1581069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1581082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581103 */     // GIR_Coverage, 6544,
     /* 1581103 */     GIR_EraseRootFromParent_Done,
     /* 1581104 */   // Label 21789: @1581104
     /* 1581104 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1581190), // Rule ID 6545 //
     /* 1581109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1581120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1581123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1581126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581155 */     // MIs[0] policy
     /* 1581155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581165 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1581168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581189 */     // GIR_Coverage, 6545,
     /* 1581189 */     GIR_EraseRootFromParent_Done,
     /* 1581190 */   // Label 21790: @1581190
     /* 1581190 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1581276), // Rule ID 6548 //
     /* 1581195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1581206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1581209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1581212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1581218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581241 */     // MIs[0] policy
     /* 1581241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581251 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1581254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581275 */     // GIR_Coverage, 6548,
     /* 1581275 */     GIR_EraseRootFromParent_Done,
     /* 1581276 */   // Label 21791: @1581276
     /* 1581276 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1581362), // Rule ID 6549 //
     /* 1581281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1581292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1581295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1581298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1581304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581327 */     // MIs[0] policy
     /* 1581327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581337 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1581340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581361 */     // GIR_Coverage, 6549,
     /* 1581361 */     GIR_EraseRootFromParent_Done,
     /* 1581362 */   // Label 21792: @1581362
     /* 1581362 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1581448), // Rule ID 6552 //
     /* 1581367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1581378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1581381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1581384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1581390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581413 */     // MIs[0] policy
     /* 1581413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581423 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1581426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581447 */     // GIR_Coverage, 6552,
     /* 1581447 */     GIR_EraseRootFromParent_Done,
     /* 1581448 */   // Label 21793: @1581448
     /* 1581448 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1581534), // Rule ID 6553 //
     /* 1581453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1581464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1581467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1581470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1581476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581499 */     // MIs[0] policy
     /* 1581499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581509 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1581512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581533 */     // GIR_Coverage, 6553,
     /* 1581533 */     GIR_EraseRootFromParent_Done,
     /* 1581534 */   // Label 21794: @1581534
     /* 1581534 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1581620), // Rule ID 6556 //
     /* 1581539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1581550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1581553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1581556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581585 */     // MIs[0] policy
     /* 1581585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1581598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581619 */     // GIR_Coverage, 6556,
     /* 1581619 */     GIR_EraseRootFromParent_Done,
     /* 1581620 */   // Label 21795: @1581620
     /* 1581620 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1581706), // Rule ID 6557 //
     /* 1581625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1581636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1581639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1581642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581671 */     // MIs[0] policy
     /* 1581671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1581684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581705 */     // GIR_Coverage, 6557,
     /* 1581705 */     GIR_EraseRootFromParent_Done,
     /* 1581706 */   // Label 21796: @1581706
     /* 1581706 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1581792), // Rule ID 6560 //
     /* 1581711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1581722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1581725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1581728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581757 */     // MIs[0] policy
     /* 1581757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1581770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581791 */     // GIR_Coverage, 6560,
     /* 1581791 */     GIR_EraseRootFromParent_Done,
     /* 1581792 */   // Label 21797: @1581792
     /* 1581792 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1581878), // Rule ID 6561 //
     /* 1581797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1581808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1581811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1581814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581843 */     // MIs[0] policy
     /* 1581843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581853 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1581856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581877 */     // GIR_Coverage, 6561,
     /* 1581877 */     GIR_EraseRootFromParent_Done,
     /* 1581878 */   // Label 21798: @1581878
     /* 1581878 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1581964), // Rule ID 6564 //
     /* 1581883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1581894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1581897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1581900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1581903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1581906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1581925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581929 */     // MIs[0] policy
     /* 1581929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581939 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1581942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1581948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581963 */     // GIR_Coverage, 6564,
     /* 1581963 */     GIR_EraseRootFromParent_Done,
     /* 1581964 */   // Label 21799: @1581964
     /* 1581964 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1582050), // Rule ID 6565 //
     /* 1581969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1581977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1581980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1581983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1581986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1581989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1581992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582015 */     // MIs[0] policy
     /* 1582015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582025 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1582028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582049 */     // GIR_Coverage, 6565,
     /* 1582049 */     GIR_EraseRootFromParent_Done,
     /* 1582050 */   // Label 21800: @1582050
     /* 1582050 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1582136), // Rule ID 6568 //
     /* 1582055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1582066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1582069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1582072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582101 */     // MIs[0] policy
     /* 1582101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1582114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582135 */     // GIR_Coverage, 6568,
     /* 1582135 */     GIR_EraseRootFromParent_Done,
     /* 1582136 */   // Label 21801: @1582136
     /* 1582136 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1582222), // Rule ID 6569 //
     /* 1582141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1582152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1582155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1582158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1582161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582187 */     // MIs[0] policy
     /* 1582187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1582200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582221 */     // GIR_Coverage, 6569,
     /* 1582221 */     GIR_EraseRootFromParent_Done,
     /* 1582222 */   // Label 21802: @1582222
     /* 1582222 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1582308), // Rule ID 6572 //
     /* 1582227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1582238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1582241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1582244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582273 */     // MIs[0] policy
     /* 1582273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1582286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582307 */     // GIR_Coverage, 6572,
     /* 1582307 */     GIR_EraseRootFromParent_Done,
     /* 1582308 */   // Label 21803: @1582308
     /* 1582308 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1582394), // Rule ID 6573 //
     /* 1582313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1582324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1582327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1582330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1582333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582359 */     // MIs[0] policy
     /* 1582359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1582372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582393 */     // GIR_Coverage, 6573,
     /* 1582393 */     GIR_EraseRootFromParent_Done,
     /* 1582394 */   // Label 21804: @1582394
     /* 1582394 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1582480), // Rule ID 6576 //
     /* 1582399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1582410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1582413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1582416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582445 */     // MIs[0] policy
     /* 1582445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582455 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1582458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582479 */     // GIR_Coverage, 6576,
     /* 1582479 */     GIR_EraseRootFromParent_Done,
     /* 1582480 */   // Label 21805: @1582480
     /* 1582480 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1582566), // Rule ID 6577 //
     /* 1582485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1582496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1582499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1582502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1582505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582531 */     // MIs[0] policy
     /* 1582531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1582544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582565 */     // GIR_Coverage, 6577,
     /* 1582565 */     GIR_EraseRootFromParent_Done,
     /* 1582566 */   // Label 21806: @1582566
     /* 1582566 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1582652), // Rule ID 6580 //
     /* 1582571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1582574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1582582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1582585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1582588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582617 */     // MIs[0] policy
     /* 1582617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1582630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1582648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582651 */     // GIR_Coverage, 6580,
     /* 1582651 */     GIR_EraseRootFromParent_Done,
     /* 1582652 */   // Label 21807: @1582652
     /* 1582652 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1582738), // Rule ID 6581 //
     /* 1582657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1582660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1582668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1582671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1582674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1582677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582703 */     // MIs[0] policy
     /* 1582703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1582716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1582734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582737 */     // GIR_Coverage, 6581,
     /* 1582737 */     GIR_EraseRootFromParent_Done,
     /* 1582738 */   // Label 21808: @1582738
     /* 1582738 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1582824), // Rule ID 6584 //
     /* 1582743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1582746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1582754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1582757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1582760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582789 */     // MIs[0] policy
     /* 1582789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1582802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1582820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582823 */     // GIR_Coverage, 6584,
     /* 1582823 */     GIR_EraseRootFromParent_Done,
     /* 1582824 */   // Label 21809: @1582824
     /* 1582824 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1582910), // Rule ID 6585 //
     /* 1582829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1582832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1582840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1582843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1582846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1582849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582875 */     // MIs[0] policy
     /* 1582875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582885 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1582888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1582906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582909 */     // GIR_Coverage, 6585,
     /* 1582909 */     GIR_EraseRootFromParent_Done,
     /* 1582910 */   // Label 21810: @1582910
     /* 1582910 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1582996), // Rule ID 6588 //
     /* 1582915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1582918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1582923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1582932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1582935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1582957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582961 */     // MIs[0] policy
     /* 1582961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582971 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1582974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1582992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582995 */     // GIR_Coverage, 6588,
     /* 1582995 */     GIR_EraseRootFromParent_Done,
     /* 1582996 */   // Label 21811: @1582996
     /* 1582996 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1583082), // Rule ID 6589 //
     /* 1583001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1583004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1583009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1583012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1583015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1583018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1583021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1583043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583047 */     // MIs[0] policy
     /* 1583047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1583060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1583078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583081 */     // GIR_Coverage, 6589,
     /* 1583081 */     GIR_EraseRootFromParent_Done,
     /* 1583082 */   // Label 21812: @1583082
     /* 1583082 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1583168), // Rule ID 6680 //
     /* 1583087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1583098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1583101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1583104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583133 */     // MIs[0] policy
     /* 1583133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583143 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1583146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583167 */     // GIR_Coverage, 6680,
     /* 1583167 */     GIR_EraseRootFromParent_Done,
     /* 1583168 */   // Label 21813: @1583168
     /* 1583168 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1583254), // Rule ID 6681 //
     /* 1583173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1583184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1583187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1583190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583219 */     // MIs[0] policy
     /* 1583219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583229 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1583232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583253 */     // GIR_Coverage, 6681,
     /* 1583253 */     GIR_EraseRootFromParent_Done,
     /* 1583254 */   // Label 21814: @1583254
     /* 1583254 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1583340), // Rule ID 6684 //
     /* 1583259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1583270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1583273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1583276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583305 */     // MIs[0] policy
     /* 1583305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1583318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583339 */     // GIR_Coverage, 6684,
     /* 1583339 */     GIR_EraseRootFromParent_Done,
     /* 1583340 */   // Label 21815: @1583340
     /* 1583340 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1583426), // Rule ID 6685 //
     /* 1583345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1583356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1583359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1583362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583391 */     // MIs[0] policy
     /* 1583391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1583404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583425 */     // GIR_Coverage, 6685,
     /* 1583425 */     GIR_EraseRootFromParent_Done,
     /* 1583426 */   // Label 21816: @1583426
     /* 1583426 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1583512), // Rule ID 6688 //
     /* 1583431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1583442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1583445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1583448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583477 */     // MIs[0] policy
     /* 1583477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583487 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1583490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583511 */     // GIR_Coverage, 6688,
     /* 1583511 */     GIR_EraseRootFromParent_Done,
     /* 1583512 */   // Label 21817: @1583512
     /* 1583512 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1583598), // Rule ID 6689 //
     /* 1583517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1583528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1583531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1583534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583563 */     // MIs[0] policy
     /* 1583563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583573 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1583576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583597 */     // GIR_Coverage, 6689,
     /* 1583597 */     GIR_EraseRootFromParent_Done,
     /* 1583598 */   // Label 21818: @1583598
     /* 1583598 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1583684), // Rule ID 6692 //
     /* 1583603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1583620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583649 */     // MIs[0] policy
     /* 1583649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1583662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583683 */     // GIR_Coverage, 6692,
     /* 1583683 */     GIR_EraseRootFromParent_Done,
     /* 1583684 */   // Label 21819: @1583684
     /* 1583684 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1583770), // Rule ID 6693 //
     /* 1583689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1583706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583735 */     // MIs[0] policy
     /* 1583735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583745 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1583748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583769 */     // GIR_Coverage, 6693,
     /* 1583769 */     GIR_EraseRootFromParent_Done,
     /* 1583770 */   // Label 21820: @1583770
     /* 1583770 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1583856), // Rule ID 6696 //
     /* 1583775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1583792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583821 */     // MIs[0] policy
     /* 1583821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583831 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1583834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583855 */     // GIR_Coverage, 6696,
     /* 1583855 */     GIR_EraseRootFromParent_Done,
     /* 1583856 */   // Label 21821: @1583856
     /* 1583856 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1583942), // Rule ID 6697 //
     /* 1583861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1583878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583907 */     // MIs[0] policy
     /* 1583907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583917 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1583920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583941 */     // GIR_Coverage, 6697,
     /* 1583941 */     GIR_EraseRootFromParent_Done,
     /* 1583942 */   // Label 21822: @1583942
     /* 1583942 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1584028), // Rule ID 6700 //
     /* 1583947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1583955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1583964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583993 */     // MIs[0] policy
     /* 1583993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584003 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1584006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584027 */     // GIR_Coverage, 6700,
     /* 1584027 */     GIR_EraseRootFromParent_Done,
     /* 1584028 */   // Label 21823: @1584028
     /* 1584028 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1584114), // Rule ID 6701 //
     /* 1584033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1584044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1584047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1584050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584079 */     // MIs[0] policy
     /* 1584079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1584092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584113 */     // GIR_Coverage, 6701,
     /* 1584113 */     GIR_EraseRootFromParent_Done,
     /* 1584114 */   // Label 21824: @1584114
     /* 1584114 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1584200), // Rule ID 6704 //
     /* 1584119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1584130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1584133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1584136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584165 */     // MIs[0] policy
     /* 1584165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584175 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584199 */     // GIR_Coverage, 6704,
     /* 1584199 */     GIR_EraseRootFromParent_Done,
     /* 1584200 */   // Label 21825: @1584200
     /* 1584200 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1584286), // Rule ID 6705 //
     /* 1584205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1584216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1584219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1584222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584251 */     // MIs[0] policy
     /* 1584251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584261 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584285 */     // GIR_Coverage, 6705,
     /* 1584285 */     GIR_EraseRootFromParent_Done,
     /* 1584286 */   // Label 21826: @1584286
     /* 1584286 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1584372), // Rule ID 6708 //
     /* 1584291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1584308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584337 */     // MIs[0] policy
     /* 1584337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584371 */     // GIR_Coverage, 6708,
     /* 1584371 */     GIR_EraseRootFromParent_Done,
     /* 1584372 */   // Label 21827: @1584372
     /* 1584372 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1584458), // Rule ID 6709 //
     /* 1584377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1584394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584423 */     // MIs[0] policy
     /* 1584423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584433 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584457 */     // GIR_Coverage, 6709,
     /* 1584457 */     GIR_EraseRootFromParent_Done,
     /* 1584458 */   // Label 21828: @1584458
     /* 1584458 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1584544), // Rule ID 6712 //
     /* 1584463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1584480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584509 */     // MIs[0] policy
     /* 1584509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584543 */     // GIR_Coverage, 6712,
     /* 1584543 */     GIR_EraseRootFromParent_Done,
     /* 1584544 */   // Label 21829: @1584544
     /* 1584544 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1584630), // Rule ID 6713 //
     /* 1584549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1584566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584595 */     // MIs[0] policy
     /* 1584595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584629 */     // GIR_Coverage, 6713,
     /* 1584629 */     GIR_EraseRootFromParent_Done,
     /* 1584630 */   // Label 21830: @1584630
     /* 1584630 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1584716), // Rule ID 6716 //
     /* 1584635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1584638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1584652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1584655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584681 */     // MIs[0] policy
     /* 1584681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1584712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584715 */     // GIR_Coverage, 6716,
     /* 1584715 */     GIR_EraseRootFromParent_Done,
     /* 1584716 */   // Label 21831: @1584716
     /* 1584716 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1584802), // Rule ID 6717 //
     /* 1584721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1584724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1584738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1584741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584767 */     // MIs[0] policy
     /* 1584767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1584780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1584798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584801 */     // GIR_Coverage, 6717,
     /* 1584801 */     GIR_EraseRootFromParent_Done,
     /* 1584802 */   // Label 21832: @1584802
     /* 1584802 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1584888), // Rule ID 6720 //
     /* 1584807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1584818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1584821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1584824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584853 */     // MIs[0] policy
     /* 1584853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1584866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584887 */     // GIR_Coverage, 6720,
     /* 1584887 */     GIR_EraseRootFromParent_Done,
     /* 1584888 */   // Label 21833: @1584888
     /* 1584888 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1584974), // Rule ID 6721 //
     /* 1584893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1584904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1584907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1584910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584939 */     // MIs[0] policy
     /* 1584939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1584952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1584958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584973 */     // GIR_Coverage, 6721,
     /* 1584973 */     GIR_EraseRootFromParent_Done,
     /* 1584974 */   // Label 21834: @1584974
     /* 1584974 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1585060), // Rule ID 6724 //
     /* 1584979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1584987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1584990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1584993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1584996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1584999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585025 */     // MIs[0] policy
     /* 1585025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585035 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1585038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585059 */     // GIR_Coverage, 6724,
     /* 1585059 */     GIR_EraseRootFromParent_Done,
     /* 1585060 */   // Label 21835: @1585060
     /* 1585060 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1585146), // Rule ID 6725 //
     /* 1585065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1585076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1585079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1585082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585111 */     // MIs[0] policy
     /* 1585111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1585124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585145 */     // GIR_Coverage, 6725,
     /* 1585145 */     GIR_EraseRootFromParent_Done,
     /* 1585146 */   // Label 21836: @1585146
     /* 1585146 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1585232), // Rule ID 6728 //
     /* 1585151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1585162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1585165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1585168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1585171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1585174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585197 */     // MIs[0] policy
     /* 1585197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585207 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1585210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585231 */     // GIR_Coverage, 6728,
     /* 1585231 */     GIR_EraseRootFromParent_Done,
     /* 1585232 */   // Label 21837: @1585232
     /* 1585232 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1585318), // Rule ID 6729 //
     /* 1585237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1585248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1585251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1585254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1585257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1585260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585283 */     // MIs[0] policy
     /* 1585283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1585296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585317 */     // GIR_Coverage, 6729,
     /* 1585317 */     GIR_EraseRootFromParent_Done,
     /* 1585318 */   // Label 21838: @1585318
     /* 1585318 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1585404), // Rule ID 6732 //
     /* 1585323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1585340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585369 */     // MIs[0] policy
     /* 1585369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1585382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585403 */     // GIR_Coverage, 6732,
     /* 1585403 */     GIR_EraseRootFromParent_Done,
     /* 1585404 */   // Label 21839: @1585404
     /* 1585404 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1585490), // Rule ID 6733 //
     /* 1585409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1585426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585455 */     // MIs[0] policy
     /* 1585455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1585468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585489 */     // GIR_Coverage, 6733,
     /* 1585489 */     GIR_EraseRootFromParent_Done,
     /* 1585490 */   // Label 21840: @1585490
     /* 1585490 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1585576), // Rule ID 6736 //
     /* 1585495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1585512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585541 */     // MIs[0] policy
     /* 1585541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1585554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585575 */     // GIR_Coverage, 6736,
     /* 1585575 */     GIR_EraseRootFromParent_Done,
     /* 1585576 */   // Label 21841: @1585576
     /* 1585576 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1585662), // Rule ID 6737 //
     /* 1585581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1585598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585627 */     // MIs[0] policy
     /* 1585627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585637 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1585640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585661 */     // GIR_Coverage, 6737,
     /* 1585661 */     GIR_EraseRootFromParent_Done,
     /* 1585662 */   // Label 21842: @1585662
     /* 1585662 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1585748), // Rule ID 6740 //
     /* 1585667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1585684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1585687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585713 */     // MIs[0] policy
     /* 1585713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585723 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1585726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585747 */     // GIR_Coverage, 6740,
     /* 1585747 */     GIR_EraseRootFromParent_Done,
     /* 1585748 */   // Label 21843: @1585748
     /* 1585748 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1585834), // Rule ID 6741 //
     /* 1585753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1585770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1585773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585799 */     // MIs[0] policy
     /* 1585799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1585812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585833 */     // GIR_Coverage, 6741,
     /* 1585833 */     GIR_EraseRootFromParent_Done,
     /* 1585834 */   // Label 21844: @1585834
     /* 1585834 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1585920), // Rule ID 6744 //
     /* 1585839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1585856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585885 */     // MIs[0] policy
     /* 1585885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1585898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585919 */     // GIR_Coverage, 6744,
     /* 1585919 */     GIR_EraseRootFromParent_Done,
     /* 1585920 */   // Label 21845: @1585920
     /* 1585920 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1586006), // Rule ID 6745 //
     /* 1585925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1585933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1585942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585971 */     // MIs[0] policy
     /* 1585971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1585984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1585990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586005 */     // GIR_Coverage, 6745,
     /* 1586005 */     GIR_EraseRootFromParent_Done,
     /* 1586006 */   // Label 21846: @1586006
     /* 1586006 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1586092), // Rule ID 6748 //
     /* 1586011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1586028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586057 */     // MIs[0] policy
     /* 1586057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1586070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586091 */     // GIR_Coverage, 6748,
     /* 1586091 */     GIR_EraseRootFromParent_Done,
     /* 1586092 */   // Label 21847: @1586092
     /* 1586092 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1586178), // Rule ID 6749 //
     /* 1586097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1586114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586143 */     // MIs[0] policy
     /* 1586143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586153 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1586156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586177 */     // GIR_Coverage, 6749,
     /* 1586177 */     GIR_EraseRootFromParent_Done,
     /* 1586178 */   // Label 21848: @1586178
     /* 1586178 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1586264), // Rule ID 6752 //
     /* 1586183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1586200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1586203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586229 */     // MIs[0] policy
     /* 1586229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1586242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586263 */     // GIR_Coverage, 6752,
     /* 1586263 */     GIR_EraseRootFromParent_Done,
     /* 1586264 */   // Label 21849: @1586264
     /* 1586264 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1586350), // Rule ID 6753 //
     /* 1586269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1586286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1586289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586315 */     // MIs[0] policy
     /* 1586315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1586328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586349 */     // GIR_Coverage, 6753,
     /* 1586349 */     GIR_EraseRootFromParent_Done,
     /* 1586350 */   // Label 21850: @1586350
     /* 1586350 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1586436), // Rule ID 6756 //
     /* 1586355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1586372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1586375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586401 */     // MIs[0] policy
     /* 1586401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1586414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586435 */     // GIR_Coverage, 6756,
     /* 1586435 */     GIR_EraseRootFromParent_Done,
     /* 1586436 */   // Label 21851: @1586436
     /* 1586436 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1586522), // Rule ID 6757 //
     /* 1586441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1586458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1586461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586487 */     // MIs[0] policy
     /* 1586487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1586500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586521 */     // GIR_Coverage, 6757,
     /* 1586521 */     GIR_EraseRootFromParent_Done,
     /* 1586522 */   // Label 21852: @1586522
     /* 1586522 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1586608), // Rule ID 6760 //
     /* 1586527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1586544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1586547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586573 */     // MIs[0] policy
     /* 1586573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586583 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1586586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586607 */     // GIR_Coverage, 6760,
     /* 1586607 */     GIR_EraseRootFromParent_Done,
     /* 1586608 */   // Label 21853: @1586608
     /* 1586608 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1586694), // Rule ID 6761 //
     /* 1586613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1586630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1586633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586659 */     // MIs[0] policy
     /* 1586659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586669 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1586672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586693 */     // GIR_Coverage, 6761,
     /* 1586693 */     GIR_EraseRootFromParent_Done,
     /* 1586694 */   // Label 21854: @1586694
     /* 1586694 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1586780), // Rule ID 6764 //
     /* 1586699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1586716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1586719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586745 */     // MIs[0] policy
     /* 1586745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586755 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1586758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586779 */     // GIR_Coverage, 6764,
     /* 1586779 */     GIR_EraseRootFromParent_Done,
     /* 1586780 */   // Label 21855: @1586780
     /* 1586780 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1586866), // Rule ID 6765 //
     /* 1586785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1586802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1586805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586831 */     // MIs[0] policy
     /* 1586831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586841 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1586844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586865 */     // GIR_Coverage, 6765,
     /* 1586865 */     GIR_EraseRootFromParent_Done,
     /* 1586866 */   // Label 21856: @1586866
     /* 1586866 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1586952), // Rule ID 6768 //
     /* 1586871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1586882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1586885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1586888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1586891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1586913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586917 */     // MIs[0] policy
     /* 1586917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1586930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586951 */     // GIR_Coverage, 6768,
     /* 1586951 */     GIR_EraseRootFromParent_Done,
     /* 1586952 */   // Label 21857: @1586952
     /* 1586952 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1587038), // Rule ID 6769 //
     /* 1586957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1586965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1586968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1586971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1586974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1586977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1586999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587003 */     // MIs[0] policy
     /* 1587003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587013 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1587016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587037 */     // GIR_Coverage, 6769,
     /* 1587037 */     GIR_EraseRootFromParent_Done,
     /* 1587038 */   // Label 21858: @1587038
     /* 1587038 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1587124), // Rule ID 6772 //
     /* 1587043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1587054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1587057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1587060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587089 */     // MIs[0] policy
     /* 1587089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587099 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1587102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587123 */     // GIR_Coverage, 6772,
     /* 1587123 */     GIR_EraseRootFromParent_Done,
     /* 1587124 */   // Label 21859: @1587124
     /* 1587124 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1587210), // Rule ID 6773 //
     /* 1587129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1587140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1587143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1587146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1587149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587175 */     // MIs[0] policy
     /* 1587175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587185 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1587188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587209 */     // GIR_Coverage, 6773,
     /* 1587209 */     GIR_EraseRootFromParent_Done,
     /* 1587210 */   // Label 21860: @1587210
     /* 1587210 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1587296), // Rule ID 6776 //
     /* 1587215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587261 */     // MIs[0] policy
     /* 1587261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587295 */     // GIR_Coverage, 6776,
     /* 1587295 */     GIR_EraseRootFromParent_Done,
     /* 1587296 */   // Label 21861: @1587296
     /* 1587296 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1587382), // Rule ID 6777 //
     /* 1587301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1587321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587347 */     // MIs[0] policy
     /* 1587347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587357 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587381 */     // GIR_Coverage, 6777,
     /* 1587381 */     GIR_EraseRootFromParent_Done,
     /* 1587382 */   // Label 21862: @1587382
     /* 1587382 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1587468), // Rule ID 6780 //
     /* 1587387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587433 */     // MIs[0] policy
     /* 1587433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1587446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587467 */     // GIR_Coverage, 6780,
     /* 1587467 */     GIR_EraseRootFromParent_Done,
     /* 1587468 */   // Label 21863: @1587468
     /* 1587468 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1587554), // Rule ID 6781 //
     /* 1587473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1587493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587519 */     // MIs[0] policy
     /* 1587519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1587532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587553 */     // GIR_Coverage, 6781,
     /* 1587553 */     GIR_EraseRootFromParent_Done,
     /* 1587554 */   // Label 21864: @1587554
     /* 1587554 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1587640), // Rule ID 6784 //
     /* 1587559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1587576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587605 */     // MIs[0] policy
     /* 1587605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587639 */     // GIR_Coverage, 6784,
     /* 1587639 */     GIR_EraseRootFromParent_Done,
     /* 1587640 */   // Label 21865: @1587640
     /* 1587640 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1587726), // Rule ID 6785 //
     /* 1587645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1587662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1587665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587691 */     // MIs[0] policy
     /* 1587691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587725 */     // GIR_Coverage, 6785,
     /* 1587725 */     GIR_EraseRootFromParent_Done,
     /* 1587726 */   // Label 21866: @1587726
     /* 1587726 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1587812), // Rule ID 6788 //
     /* 1587731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1587748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587777 */     // MIs[0] policy
     /* 1587777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587787 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587811 */     // GIR_Coverage, 6788,
     /* 1587811 */     GIR_EraseRootFromParent_Done,
     /* 1587812 */   // Label 21867: @1587812
     /* 1587812 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1587898), // Rule ID 6789 //
     /* 1587817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1587834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1587837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587863 */     // MIs[0] policy
     /* 1587863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1587876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587897 */     // GIR_Coverage, 6789,
     /* 1587897 */     GIR_EraseRootFromParent_Done,
     /* 1587898 */   // Label 21868: @1587898
     /* 1587898 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1587984), // Rule ID 6792 //
     /* 1587903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1587914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1587917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1587920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1587923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1587945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587949 */     // MIs[0] policy
     /* 1587949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1587962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587983 */     // GIR_Coverage, 6792,
     /* 1587983 */     GIR_EraseRootFromParent_Done,
     /* 1587984 */   // Label 21869: @1587984
     /* 1587984 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1588070), // Rule ID 6793 //
     /* 1587989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1587997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1588000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1588003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1588006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588035 */     // MIs[0] policy
     /* 1588035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11273:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588069 */     // GIR_Coverage, 6793,
     /* 1588069 */     GIR_EraseRootFromParent_Done,
     /* 1588070 */   // Label 21870: @1588070
     /* 1588070 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1588156), // Rule ID 6796 //
     /* 1588075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1588092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588121 */     // MIs[0] policy
     /* 1588121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588155 */     // GIR_Coverage, 6796,
     /* 1588155 */     GIR_EraseRootFromParent_Done,
     /* 1588156 */   // Label 21871: @1588156
     /* 1588156 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1588242), // Rule ID 6797 //
     /* 1588161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1588178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588207 */     // MIs[0] policy
     /* 1588207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588241 */     // GIR_Coverage, 6797,
     /* 1588241 */     GIR_EraseRootFromParent_Done,
     /* 1588242 */   // Label 21872: @1588242
     /* 1588242 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1588328), // Rule ID 6800 //
     /* 1588247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588293 */     // MIs[0] policy
     /* 1588293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588327 */     // GIR_Coverage, 6800,
     /* 1588327 */     GIR_EraseRootFromParent_Done,
     /* 1588328 */   // Label 21873: @1588328
     /* 1588328 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1588414), // Rule ID 6801 //
     /* 1588333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588379 */     // MIs[0] policy
     /* 1588379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588389 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588413 */     // GIR_Coverage, 6801,
     /* 1588413 */     GIR_EraseRootFromParent_Done,
     /* 1588414 */   // Label 21874: @1588414
     /* 1588414 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1588500), // Rule ID 6804 //
     /* 1588419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1588422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1588436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588465 */     // MIs[0] policy
     /* 1588465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1588496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588499 */     // GIR_Coverage, 6804,
     /* 1588499 */     GIR_EraseRootFromParent_Done,
     /* 1588500 */   // Label 21875: @1588500
     /* 1588500 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1588586), // Rule ID 6805 //
     /* 1588505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1588508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1588522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588551 */     // MIs[0] policy
     /* 1588551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1588564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1588582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588585 */     // GIR_Coverage, 6805,
     /* 1588585 */     GIR_EraseRootFromParent_Done,
     /* 1588586 */   // Label 21876: @1588586
     /* 1588586 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1588672), // Rule ID 6808 //
     /* 1588591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1588602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1588605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1588608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588637 */     // MIs[0] policy
     /* 1588637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1588650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588671 */     // GIR_Coverage, 6808,
     /* 1588671 */     GIR_EraseRootFromParent_Done,
     /* 1588672 */   // Label 21877: @1588672
     /* 1588672 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1588758), // Rule ID 6809 //
     /* 1588677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1588688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1588691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1588694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588723 */     // MIs[0] policy
     /* 1588723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1588736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588757 */     // GIR_Coverage, 6809,
     /* 1588757 */     GIR_EraseRootFromParent_Done,
     /* 1588758 */   // Label 21878: @1588758
     /* 1588758 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1588844), // Rule ID 6812 //
     /* 1588763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1588774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1588777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1588780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588809 */     // MIs[0] policy
     /* 1588809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588819 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1588822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588843 */     // GIR_Coverage, 6812,
     /* 1588843 */     GIR_EraseRootFromParent_Done,
     /* 1588844 */   // Label 21879: @1588844
     /* 1588844 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1588930), // Rule ID 6813 //
     /* 1588849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1588860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1588863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1588866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1588869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588895 */     // MIs[0] policy
     /* 1588895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588905 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1588908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588929 */     // GIR_Coverage, 6813,
     /* 1588929 */     GIR_EraseRootFromParent_Done,
     /* 1588930 */   // Label 21880: @1588930
     /* 1588930 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1589016), // Rule ID 6816 //
     /* 1588935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1588943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1588946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1588949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1588952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1588955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1588958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1588977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588981 */     // MIs[0] policy
     /* 1588981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588991 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1588994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589015 */     // GIR_Coverage, 6816,
     /* 1589015 */     GIR_EraseRootFromParent_Done,
     /* 1589016 */   // Label 21881: @1589016
     /* 1589016 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1589102), // Rule ID 6817 //
     /* 1589021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1589032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1589035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1589038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1589044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589067 */     // MIs[0] policy
     /* 1589067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589077 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1589080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589101 */     // GIR_Coverage, 6817,
     /* 1589101 */     GIR_EraseRootFromParent_Done,
     /* 1589102 */   // Label 21882: @1589102
     /* 1589102 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1589188), // Rule ID 6820 //
     /* 1589107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1589118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1589121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1589124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589153 */     // MIs[0] policy
     /* 1589153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1589166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589187 */     // GIR_Coverage, 6820,
     /* 1589187 */     GIR_EraseRootFromParent_Done,
     /* 1589188 */   // Label 21883: @1589188
     /* 1589188 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1589274), // Rule ID 6821 //
     /* 1589193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1589204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1589207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1589210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589239 */     // MIs[0] policy
     /* 1589239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1589252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589273 */     // GIR_Coverage, 6821,
     /* 1589273 */     GIR_EraseRootFromParent_Done,
     /* 1589274 */   // Label 21884: @1589274
     /* 1589274 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1589360), // Rule ID 6824 //
     /* 1589279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589325 */     // MIs[0] policy
     /* 1589325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589335 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1589338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589359 */     // GIR_Coverage, 6824,
     /* 1589359 */     GIR_EraseRootFromParent_Done,
     /* 1589360 */   // Label 21885: @1589360
     /* 1589360 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1589446), // Rule ID 6825 //
     /* 1589365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589411 */     // MIs[0] policy
     /* 1589411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589421 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1589424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589445 */     // GIR_Coverage, 6825,
     /* 1589445 */     GIR_EraseRootFromParent_Done,
     /* 1589446 */   // Label 21886: @1589446
     /* 1589446 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1589532), // Rule ID 6828 //
     /* 1589451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1589462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1589465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1589468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589497 */     // MIs[0] policy
     /* 1589497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589507 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1589510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589531 */     // GIR_Coverage, 6828,
     /* 1589531 */     GIR_EraseRootFromParent_Done,
     /* 1589532 */   // Label 21887: @1589532
     /* 1589532 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1589618), // Rule ID 6829 //
     /* 1589537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1589548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1589551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1589554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589583 */     // MIs[0] policy
     /* 1589583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1589596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589617 */     // GIR_Coverage, 6829,
     /* 1589617 */     GIR_EraseRootFromParent_Done,
     /* 1589618 */   // Label 21888: @1589618
     /* 1589618 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1589704), // Rule ID 6832 //
     /* 1589623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1589640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589669 */     // MIs[0] policy
     /* 1589669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1589682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589703 */     // GIR_Coverage, 6832,
     /* 1589703 */     GIR_EraseRootFromParent_Done,
     /* 1589704 */   // Label 21889: @1589704
     /* 1589704 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1589790), // Rule ID 6833 //
     /* 1589709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1589726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589755 */     // MIs[0] policy
     /* 1589755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1589768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589789 */     // GIR_Coverage, 6833,
     /* 1589789 */     GIR_EraseRootFromParent_Done,
     /* 1589790 */   // Label 21890: @1589790
     /* 1589790 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1589876), // Rule ID 6836 //
     /* 1589795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1589812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589841 */     // MIs[0] policy
     /* 1589841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1589854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589875 */     // GIR_Coverage, 6836,
     /* 1589875 */     GIR_EraseRootFromParent_Done,
     /* 1589876 */   // Label 21891: @1589876
     /* 1589876 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1589962), // Rule ID 6837 //
     /* 1589881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1589898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1589901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1589923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589927 */     // MIs[0] policy
     /* 1589927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1589940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589961 */     // GIR_Coverage, 6837,
     /* 1589961 */     GIR_EraseRootFromParent_Done,
     /* 1589962 */   // Label 21892: @1589962
     /* 1589962 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1590048), // Rule ID 6840 //
     /* 1589967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1589975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1589978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1589981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1589984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1589987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590013 */     // MIs[0] policy
     /* 1590013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590023 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1590026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590047 */     // GIR_Coverage, 6840,
     /* 1590047 */     GIR_EraseRootFromParent_Done,
     /* 1590048 */   // Label 21893: @1590048
     /* 1590048 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1590134), // Rule ID 6841 //
     /* 1590053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1590064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1590067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1590070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1590076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590099 */     // MIs[0] policy
     /* 1590099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1590112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590133 */     // GIR_Coverage, 6841,
     /* 1590133 */     GIR_EraseRootFromParent_Done,
     /* 1590134 */   // Label 21894: @1590134
     /* 1590134 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1590220), // Rule ID 6844 //
     /* 1590139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1590156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590185 */     // MIs[0] policy
     /* 1590185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1590198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590219 */     // GIR_Coverage, 6844,
     /* 1590219 */     GIR_EraseRootFromParent_Done,
     /* 1590220 */   // Label 21895: @1590220
     /* 1590220 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1590306), // Rule ID 6845 //
     /* 1590225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1590242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590271 */     // MIs[0] policy
     /* 1590271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1590284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590305 */     // GIR_Coverage, 6845,
     /* 1590305 */     GIR_EraseRootFromParent_Done,
     /* 1590306 */   // Label 21896: @1590306
     /* 1590306 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1590392), // Rule ID 6848 //
     /* 1590311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590357 */     // MIs[0] policy
     /* 1590357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1590370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590391 */     // GIR_Coverage, 6848,
     /* 1590391 */     GIR_EraseRootFromParent_Done,
     /* 1590392 */   // Label 21897: @1590392
     /* 1590392 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1590478), // Rule ID 6849 //
     /* 1590397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590443 */     // MIs[0] policy
     /* 1590443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590453 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1590456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590477 */     // GIR_Coverage, 6849,
     /* 1590477 */     GIR_EraseRootFromParent_Done,
     /* 1590478 */   // Label 21898: @1590478
     /* 1590478 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1590564), // Rule ID 6852 //
     /* 1590483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1590500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590529 */     // MIs[0] policy
     /* 1590529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1590542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590563 */     // GIR_Coverage, 6852,
     /* 1590563 */     GIR_EraseRootFromParent_Done,
     /* 1590564 */   // Label 21899: @1590564
     /* 1590564 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1590650), // Rule ID 6853 //
     /* 1590569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1590577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1590586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590615 */     // MIs[0] policy
     /* 1590615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1590628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590649 */     // GIR_Coverage, 6853,
     /* 1590649 */     GIR_EraseRootFromParent_Done,
     /* 1590650 */   // Label 21900: @1590650
     /* 1590650 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1590736), // Rule ID 6944 //
     /* 1590655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1590663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590701 */     // MIs[0] policy
     /* 1590701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590711 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1590714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590735 */     // GIR_Coverage, 6944,
     /* 1590735 */     GIR_EraseRootFromParent_Done,
     /* 1590736 */   // Label 21901: @1590736
     /* 1590736 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1590822), // Rule ID 6945 //
     /* 1590741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1590749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590787 */     // MIs[0] policy
     /* 1590787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590797 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1590800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590821 */     // GIR_Coverage, 6945,
     /* 1590821 */     GIR_EraseRootFromParent_Done,
     /* 1590822 */   // Label 21902: @1590822
     /* 1590822 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1590908), // Rule ID 6948 //
     /* 1590827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1590835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590873 */     // MIs[0] policy
     /* 1590873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590883 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1590886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590907 */     // GIR_Coverage, 6948,
     /* 1590907 */     GIR_EraseRootFromParent_Done,
     /* 1590908 */   // Label 21903: @1590908
     /* 1590908 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1590994), // Rule ID 6949 //
     /* 1590913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1590921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590959 */     // MIs[0] policy
     /* 1590959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1590972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590993 */     // GIR_Coverage, 6949,
     /* 1590993 */     GIR_EraseRootFromParent_Done,
     /* 1590994 */   // Label 21904: @1590994
     /* 1590994 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1591080), // Rule ID 6952 //
     /* 1590999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1591010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1591013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1591016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1591019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591045 */     // MIs[0] policy
     /* 1591045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591055 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591079 */     // GIR_Coverage, 6952,
     /* 1591079 */     GIR_EraseRootFromParent_Done,
     /* 1591080 */   // Label 21905: @1591080
     /* 1591080 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1591166), // Rule ID 6953 //
     /* 1591085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1591096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1591099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1591102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1591105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591131 */     // MIs[0] policy
     /* 1591131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591141 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591165 */     // GIR_Coverage, 6953,
     /* 1591165 */     GIR_EraseRootFromParent_Done,
     /* 1591166 */   // Label 21906: @1591166
     /* 1591166 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1591252), // Rule ID 6956 //
     /* 1591171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1591182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1591185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1591188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591217 */     // MIs[0] policy
     /* 1591217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591227 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1591230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591251 */     // GIR_Coverage, 6956,
     /* 1591251 */     GIR_EraseRootFromParent_Done,
     /* 1591252 */   // Label 21907: @1591252
     /* 1591252 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1591338), // Rule ID 6957 //
     /* 1591257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1591268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1591271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1591274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591303 */     // MIs[0] policy
     /* 1591303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591313 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1591316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591337 */     // GIR_Coverage, 6957,
     /* 1591337 */     GIR_EraseRootFromParent_Done,
     /* 1591338 */   // Label 21908: @1591338
     /* 1591338 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1591424), // Rule ID 6960 //
     /* 1591343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591389 */     // MIs[0] policy
     /* 1591389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591423 */     // GIR_Coverage, 6960,
     /* 1591423 */     GIR_EraseRootFromParent_Done,
     /* 1591424 */   // Label 21909: @1591424
     /* 1591424 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1591510), // Rule ID 6961 //
     /* 1591429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591475 */     // MIs[0] policy
     /* 1591475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591509 */     // GIR_Coverage, 6961,
     /* 1591509 */     GIR_EraseRootFromParent_Done,
     /* 1591510 */   // Label 21910: @1591510
     /* 1591510 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1591596), // Rule ID 6964 //
     /* 1591515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591561 */     // MIs[0] policy
     /* 1591561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591571 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591595 */     // GIR_Coverage, 6964,
     /* 1591595 */     GIR_EraseRootFromParent_Done,
     /* 1591596 */   // Label 21911: @1591596
     /* 1591596 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1591682), // Rule ID 6965 //
     /* 1591601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591647 */     // MIs[0] policy
     /* 1591647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591657 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1591660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591681 */     // GIR_Coverage, 6965,
     /* 1591681 */     GIR_EraseRootFromParent_Done,
     /* 1591682 */   // Label 21912: @1591682
     /* 1591682 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1591768), // Rule ID 6968 //
     /* 1591687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591733 */     // MIs[0] policy
     /* 1591733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591743 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1591746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591767 */     // GIR_Coverage, 6968,
     /* 1591767 */     GIR_EraseRootFromParent_Done,
     /* 1591768 */   // Label 21913: @1591768
     /* 1591768 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1591854), // Rule ID 6969 //
     /* 1591773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591819 */     // MIs[0] policy
     /* 1591819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591829 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1591832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591853 */     // GIR_Coverage, 6969,
     /* 1591853 */     GIR_EraseRootFromParent_Done,
     /* 1591854 */   // Label 21914: @1591854
     /* 1591854 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1591940), // Rule ID 6972 //
     /* 1591859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591905 */     // MIs[0] policy
     /* 1591905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1591918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591939 */     // GIR_Coverage, 6972,
     /* 1591939 */     GIR_EraseRootFromParent_Done,
     /* 1591940 */   // Label 21915: @1591940
     /* 1591940 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1592026), // Rule ID 6973 //
     /* 1591945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1591953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591991 */     // MIs[0] policy
     /* 1591991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592001 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1592004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592025 */     // GIR_Coverage, 6973,
     /* 1592025 */     GIR_EraseRootFromParent_Done,
     /* 1592026 */   // Label 21916: @1592026
     /* 1592026 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1592112), // Rule ID 6976 //
     /* 1592031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1592042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1592045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1592048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592077 */     // MIs[0] policy
     /* 1592077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592087 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1592090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592111 */     // GIR_Coverage, 6976,
     /* 1592111 */     GIR_EraseRootFromParent_Done,
     /* 1592112 */   // Label 21917: @1592112
     /* 1592112 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1592198), // Rule ID 6977 //
     /* 1592117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1592128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1592131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1592134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592163 */     // MIs[0] policy
     /* 1592163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1592176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592197 */     // GIR_Coverage, 6977,
     /* 1592197 */     GIR_EraseRootFromParent_Done,
     /* 1592198 */   // Label 21918: @1592198
     /* 1592198 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1592284), // Rule ID 6980 //
     /* 1592203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1592206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1592223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592249 */     // MIs[0] policy
     /* 1592249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1592262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592283 */     // GIR_Coverage, 6980,
     /* 1592283 */     GIR_EraseRootFromParent_Done,
     /* 1592284 */   // Label 21919: @1592284
     /* 1592284 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1592370), // Rule ID 6981 //
     /* 1592289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1592292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1592309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592335 */     // MIs[0] policy
     /* 1592335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592345 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1592348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592369 */     // GIR_Coverage, 6981,
     /* 1592369 */     GIR_EraseRootFromParent_Done,
     /* 1592370 */   // Label 21920: @1592370
     /* 1592370 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1592456), // Rule ID 6984 //
     /* 1592375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1592395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592421 */     // MIs[0] policy
     /* 1592421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1592434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592455 */     // GIR_Coverage, 6984,
     /* 1592455 */     GIR_EraseRootFromParent_Done,
     /* 1592456 */   // Label 21921: @1592456
     /* 1592456 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1592542), // Rule ID 6985 //
     /* 1592461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1592481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592507 */     // MIs[0] policy
     /* 1592507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592517 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1592520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592541 */     // GIR_Coverage, 6985,
     /* 1592541 */     GIR_EraseRootFromParent_Done,
     /* 1592542 */   // Label 21922: @1592542
     /* 1592542 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1592628), // Rule ID 6988 //
     /* 1592547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592593 */     // MIs[0] policy
     /* 1592593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592603 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1592606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592627 */     // GIR_Coverage, 6988,
     /* 1592627 */     GIR_EraseRootFromParent_Done,
     /* 1592628 */   // Label 21923: @1592628
     /* 1592628 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1592714), // Rule ID 6989 //
     /* 1592633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592679 */     // MIs[0] policy
     /* 1592679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1592692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592713 */     // GIR_Coverage, 6989,
     /* 1592713 */     GIR_EraseRootFromParent_Done,
     /* 1592714 */   // Label 21924: @1592714
     /* 1592714 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1592800), // Rule ID 6992 //
     /* 1592719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592765 */     // MIs[0] policy
     /* 1592765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592775 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1592778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592799 */     // GIR_Coverage, 6992,
     /* 1592799 */     GIR_EraseRootFromParent_Done,
     /* 1592800 */   // Label 21925: @1592800
     /* 1592800 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1592886), // Rule ID 6993 //
     /* 1592805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592851 */     // MIs[0] policy
     /* 1592851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592861 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1592864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592885 */     // GIR_Coverage, 6993,
     /* 1592885 */     GIR_EraseRootFromParent_Done,
     /* 1592886 */   // Label 21926: @1592886
     /* 1592886 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1592972), // Rule ID 6996 //
     /* 1592891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592937 */     // MIs[0] policy
     /* 1592937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1592950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592971 */     // GIR_Coverage, 6996,
     /* 1592971 */     GIR_EraseRootFromParent_Done,
     /* 1592972 */   // Label 21927: @1592972
     /* 1592972 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1593058), // Rule ID 6997 //
     /* 1592977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1592985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593023 */     // MIs[0] policy
     /* 1593023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1593036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593057 */     // GIR_Coverage, 6997,
     /* 1593057 */     GIR_EraseRootFromParent_Done,
     /* 1593058 */   // Label 21928: @1593058
     /* 1593058 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1593144), // Rule ID 7000 //
     /* 1593063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1593074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1593077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1593080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1593083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593109 */     // MIs[0] policy
     /* 1593109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1593122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593143 */     // GIR_Coverage, 7000,
     /* 1593143 */     GIR_EraseRootFromParent_Done,
     /* 1593144 */   // Label 21929: @1593144
     /* 1593144 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1593230), // Rule ID 7001 //
     /* 1593149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1593160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1593163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1593166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1593169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593195 */     // MIs[0] policy
     /* 1593195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593205 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1593208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593229 */     // GIR_Coverage, 7001,
     /* 1593229 */     GIR_EraseRootFromParent_Done,
     /* 1593230 */   // Label 21930: @1593230
     /* 1593230 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1593316), // Rule ID 7004 //
     /* 1593235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1593255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593281 */     // MIs[0] policy
     /* 1593281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593291 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1593294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593315 */     // GIR_Coverage, 7004,
     /* 1593315 */     GIR_EraseRootFromParent_Done,
     /* 1593316 */   // Label 21931: @1593316
     /* 1593316 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1593402), // Rule ID 7005 //
     /* 1593321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1593341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593367 */     // MIs[0] policy
     /* 1593367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1593380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593401 */     // GIR_Coverage, 7005,
     /* 1593401 */     GIR_EraseRootFromParent_Done,
     /* 1593402 */   // Label 21932: @1593402
     /* 1593402 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1593488), // Rule ID 7008 //
     /* 1593407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1593427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593453 */     // MIs[0] policy
     /* 1593453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1593466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593487 */     // GIR_Coverage, 7008,
     /* 1593487 */     GIR_EraseRootFromParent_Done,
     /* 1593488 */   // Label 21933: @1593488
     /* 1593488 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1593574), // Rule ID 7009 //
     /* 1593493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1593513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593539 */     // MIs[0] policy
     /* 1593539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1593552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593573 */     // GIR_Coverage, 7009,
     /* 1593573 */     GIR_EraseRootFromParent_Done,
     /* 1593574 */   // Label 21934: @1593574
     /* 1593574 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1593660), // Rule ID 7012 //
     /* 1593579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593625 */     // MIs[0] policy
     /* 1593625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1593638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593659 */     // GIR_Coverage, 7012,
     /* 1593659 */     GIR_EraseRootFromParent_Done,
     /* 1593660 */   // Label 21935: @1593660
     /* 1593660 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1593746), // Rule ID 7013 //
     /* 1593665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593711 */     // MIs[0] policy
     /* 1593711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1593724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593745 */     // GIR_Coverage, 7013,
     /* 1593745 */     GIR_EraseRootFromParent_Done,
     /* 1593746 */   // Label 21936: @1593746
     /* 1593746 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1593832), // Rule ID 7016 //
     /* 1593751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593797 */     // MIs[0] policy
     /* 1593797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593807 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1593810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593831 */     // GIR_Coverage, 7016,
     /* 1593831 */     GIR_EraseRootFromParent_Done,
     /* 1593832 */   // Label 21937: @1593832
     /* 1593832 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1593918), // Rule ID 7017 //
     /* 1593837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593883 */     // MIs[0] policy
     /* 1593883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1593896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593917 */     // GIR_Coverage, 7017,
     /* 1593917 */     GIR_EraseRootFromParent_Done,
     /* 1593918 */   // Label 21938: @1593918
     /* 1593918 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1594004), // Rule ID 7020 //
     /* 1593923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1593931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593969 */     // MIs[0] policy
     /* 1593969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1593982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594003 */     // GIR_Coverage, 7020,
     /* 1594003 */     GIR_EraseRootFromParent_Done,
     /* 1594004 */   // Label 21939: @1594004
     /* 1594004 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1594090), // Rule ID 7021 //
     /* 1594009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1594020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1594023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1594026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1594029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1594039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594055 */     // MIs[0] policy
     /* 1594055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1594068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594089 */     // GIR_Coverage, 7021,
     /* 1594089 */     GIR_EraseRootFromParent_Done,
     /* 1594090 */   // Label 21940: @1594090
     /* 1594090 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1594176), // Rule ID 7024 //
     /* 1594095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1594106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1594109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1594112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1594115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594141 */     // MIs[0] policy
     /* 1594141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594151 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1594154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594175 */     // GIR_Coverage, 7024,
     /* 1594175 */     GIR_EraseRootFromParent_Done,
     /* 1594176 */   // Label 21941: @1594176
     /* 1594176 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1594262), // Rule ID 7025 //
     /* 1594181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1594192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1594195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1594198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1594201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594227 */     // MIs[0] policy
     /* 1594227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1594240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594261 */     // GIR_Coverage, 7025,
     /* 1594261 */     GIR_EraseRootFromParent_Done,
     /* 1594262 */   // Label 21942: @1594262
     /* 1594262 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1594348), // Rule ID 7028 //
     /* 1594267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1594287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594313 */     // MIs[0] policy
     /* 1594313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1594326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594347 */     // GIR_Coverage, 7028,
     /* 1594347 */     GIR_EraseRootFromParent_Done,
     /* 1594348 */   // Label 21943: @1594348
     /* 1594348 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1594434), // Rule ID 7029 //
     /* 1594353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1594373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594399 */     // MIs[0] policy
     /* 1594399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1594412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594433 */     // GIR_Coverage, 7029,
     /* 1594433 */     GIR_EraseRootFromParent_Done,
     /* 1594434 */   // Label 21944: @1594434
     /* 1594434 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1594520), // Rule ID 7032 //
     /* 1594439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594485 */     // MIs[0] policy
     /* 1594485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594495 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1594498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594519 */     // GIR_Coverage, 7032,
     /* 1594519 */     GIR_EraseRootFromParent_Done,
     /* 1594520 */   // Label 21945: @1594520
     /* 1594520 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1594606), // Rule ID 7033 //
     /* 1594525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594571 */     // MIs[0] policy
     /* 1594571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594581 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1594584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594605 */     // GIR_Coverage, 7033,
     /* 1594605 */     GIR_EraseRootFromParent_Done,
     /* 1594606 */   // Label 21946: @1594606
     /* 1594606 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1594692), // Rule ID 7036 //
     /* 1594611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594657 */     // MIs[0] policy
     /* 1594657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594667 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1594670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594691 */     // GIR_Coverage, 7036,
     /* 1594691 */     GIR_EraseRootFromParent_Done,
     /* 1594692 */   // Label 21947: @1594692
     /* 1594692 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1594778), // Rule ID 7037 //
     /* 1594697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594743 */     // MIs[0] policy
     /* 1594743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594753 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1594756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594777 */     // GIR_Coverage, 7037,
     /* 1594777 */     GIR_EraseRootFromParent_Done,
     /* 1594778 */   // Label 21948: @1594778
     /* 1594778 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1594864), // Rule ID 7040 //
     /* 1594783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594829 */     // MIs[0] policy
     /* 1594829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1594842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594863 */     // GIR_Coverage, 7040,
     /* 1594863 */     GIR_EraseRootFromParent_Done,
     /* 1594864 */   // Label 21949: @1594864
     /* 1594864 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1594950), // Rule ID 7041 //
     /* 1594869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594915 */     // MIs[0] policy
     /* 1594915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594925 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1594928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594949 */     // GIR_Coverage, 7041,
     /* 1594949 */     GIR_EraseRootFromParent_Done,
     /* 1594950 */   // Label 21950: @1594950
     /* 1594950 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1595036), // Rule ID 7044 //
     /* 1594955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1594963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595001 */     // MIs[0] policy
     /* 1595001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1595014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595035 */     // GIR_Coverage, 7044,
     /* 1595035 */     GIR_EraseRootFromParent_Done,
     /* 1595036 */   // Label 21951: @1595036
     /* 1595036 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1595122), // Rule ID 7045 //
     /* 1595041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1595052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1595055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1595058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595087 */     // MIs[0] policy
     /* 1595087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595097 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1595100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595121 */     // GIR_Coverage, 7045,
     /* 1595121 */     GIR_EraseRootFromParent_Done,
     /* 1595122 */   // Label 21952: @1595122
     /* 1595122 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1595208), // Rule ID 7048 //
     /* 1595127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1595138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1595141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1595144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595173 */     // MIs[0] policy
     /* 1595173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595183 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1595186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595207 */     // GIR_Coverage, 7048,
     /* 1595207 */     GIR_EraseRootFromParent_Done,
     /* 1595208 */   // Label 21953: @1595208
     /* 1595208 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1595294), // Rule ID 7049 //
     /* 1595213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1595224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1595227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1595230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595259 */     // MIs[0] policy
     /* 1595259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595269 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1595272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595293 */     // GIR_Coverage, 7049,
     /* 1595293 */     GIR_EraseRootFromParent_Done,
     /* 1595294 */   // Label 21954: @1595294
     /* 1595294 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1595380), // Rule ID 7052 //
     /* 1595299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595345 */     // MIs[0] policy
     /* 1595345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595355 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1595358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595379 */     // GIR_Coverage, 7052,
     /* 1595379 */     GIR_EraseRootFromParent_Done,
     /* 1595380 */   // Label 21955: @1595380
     /* 1595380 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1595466), // Rule ID 7053 //
     /* 1595385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595431 */     // MIs[0] policy
     /* 1595431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595441 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1595444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595465 */     // GIR_Coverage, 7053,
     /* 1595465 */     GIR_EraseRootFromParent_Done,
     /* 1595466 */   // Label 21956: @1595466
     /* 1595466 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1595552), // Rule ID 7056 //
     /* 1595471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595517 */     // MIs[0] policy
     /* 1595517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595551 */     // GIR_Coverage, 7056,
     /* 1595551 */     GIR_EraseRootFromParent_Done,
     /* 1595552 */   // Label 21957: @1595552
     /* 1595552 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1595638), // Rule ID 7057 //
     /* 1595557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595603 */     // MIs[0] policy
     /* 1595603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595613 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11271:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595637 */     // GIR_Coverage, 7057,
     /* 1595637 */     GIR_EraseRootFromParent_Done,
     /* 1595638 */   // Label 21958: @1595638
     /* 1595638 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1595724), // Rule ID 7060 //
     /* 1595643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595689 */     // MIs[0] policy
     /* 1595689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595723 */     // GIR_Coverage, 7060,
     /* 1595723 */     GIR_EraseRootFromParent_Done,
     /* 1595724 */   // Label 21959: @1595724
     /* 1595724 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1595810), // Rule ID 7061 //
     /* 1595729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595775 */     // MIs[0] policy
     /* 1595775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595785 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595809 */     // GIR_Coverage, 7061,
     /* 1595809 */     GIR_EraseRootFromParent_Done,
     /* 1595810 */   // Label 21960: @1595810
     /* 1595810 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1595896), // Rule ID 7064 //
     /* 1595815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595861 */     // MIs[0] policy
     /* 1595861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595895 */     // GIR_Coverage, 7064,
     /* 1595895 */     GIR_EraseRootFromParent_Done,
     /* 1595896 */   // Label 21961: @1595896
     /* 1595896 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1595982), // Rule ID 7065 //
     /* 1595901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595947 */     // MIs[0] policy
     /* 1595947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595957 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1595960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595981 */     // GIR_Coverage, 7065,
     /* 1595981 */     GIR_EraseRootFromParent_Done,
     /* 1595982 */   // Label 21962: @1595982
     /* 1595982 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1596068), // Rule ID 7068 //
     /* 1595987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1595990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1595995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1596001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1596004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1596010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596033 */     // MIs[0] policy
     /* 1596033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1596046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596067 */     // GIR_Coverage, 7068,
     /* 1596067 */     GIR_EraseRootFromParent_Done,
     /* 1596068 */   // Label 21963: @1596068
     /* 1596068 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1596154), // Rule ID 7069 //
     /* 1596073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1596084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1596087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1596090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1596096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596119 */     // MIs[0] policy
     /* 1596119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1596132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596153 */     // GIR_Coverage, 7069,
     /* 1596153 */     GIR_EraseRootFromParent_Done,
     /* 1596154 */   // Label 21964: @1596154
     /* 1596154 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1596240), // Rule ID 7072 //
     /* 1596159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1596170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1596173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1596176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596205 */     // MIs[0] policy
     /* 1596205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1596218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596239 */     // GIR_Coverage, 7072,
     /* 1596239 */     GIR_EraseRootFromParent_Done,
     /* 1596240 */   // Label 21965: @1596240
     /* 1596240 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1596326), // Rule ID 7073 //
     /* 1596245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1596256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1596259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1596262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596291 */     // MIs[0] policy
     /* 1596291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1596304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596325 */     // GIR_Coverage, 7073,
     /* 1596325 */     GIR_EraseRootFromParent_Done,
     /* 1596326 */   // Label 21966: @1596326
     /* 1596326 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1596412), // Rule ID 7076 //
     /* 1596331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596377 */     // MIs[0] policy
     /* 1596377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596387 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1596390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596411 */     // GIR_Coverage, 7076,
     /* 1596411 */     GIR_EraseRootFromParent_Done,
     /* 1596412 */   // Label 21967: @1596412
     /* 1596412 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1596498), // Rule ID 7077 //
     /* 1596417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596463 */     // MIs[0] policy
     /* 1596463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1596476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596497 */     // GIR_Coverage, 7077,
     /* 1596497 */     GIR_EraseRootFromParent_Done,
     /* 1596498 */   // Label 21968: @1596498
     /* 1596498 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1596584), // Rule ID 7080 //
     /* 1596503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596549 */     // MIs[0] policy
     /* 1596549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1596562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596583 */     // GIR_Coverage, 7080,
     /* 1596583 */     GIR_EraseRootFromParent_Done,
     /* 1596584 */   // Label 21969: @1596584
     /* 1596584 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1596670), // Rule ID 7081 //
     /* 1596589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596635 */     // MIs[0] policy
     /* 1596635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1596648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596669 */     // GIR_Coverage, 7081,
     /* 1596669 */     GIR_EraseRootFromParent_Done,
     /* 1596670 */   // Label 21970: @1596670
     /* 1596670 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1596756), // Rule ID 7084 //
     /* 1596675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596721 */     // MIs[0] policy
     /* 1596721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1596734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596755 */     // GIR_Coverage, 7084,
     /* 1596755 */     GIR_EraseRootFromParent_Done,
     /* 1596756 */   // Label 21971: @1596756
     /* 1596756 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1596842), // Rule ID 7085 //
     /* 1596761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596807 */     // MIs[0] policy
     /* 1596807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1596820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596841 */     // GIR_Coverage, 7085,
     /* 1596841 */     GIR_EraseRootFromParent_Done,
     /* 1596842 */   // Label 21972: @1596842
     /* 1596842 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1596928), // Rule ID 7088 //
     /* 1596847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596893 */     // MIs[0] policy
     /* 1596893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596903 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1596906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596927 */     // GIR_Coverage, 7088,
     /* 1596927 */     GIR_EraseRootFromParent_Done,
     /* 1596928 */   // Label 21973: @1596928
     /* 1596928 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1597014), // Rule ID 7089 //
     /* 1596933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1596941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596979 */     // MIs[0] policy
     /* 1596979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1596992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597013 */     // GIR_Coverage, 7089,
     /* 1597013 */     GIR_EraseRootFromParent_Done,
     /* 1597014 */   // Label 21974: @1597014
     /* 1597014 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1597100), // Rule ID 7092 //
     /* 1597019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1597030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1597033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1597036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1597042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597065 */     // MIs[0] policy
     /* 1597065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597075 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1597078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597099 */     // GIR_Coverage, 7092,
     /* 1597099 */     GIR_EraseRootFromParent_Done,
     /* 1597100 */   // Label 21975: @1597100
     /* 1597100 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1597186), // Rule ID 7093 //
     /* 1597105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1597116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1597119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1597122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1597128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597151 */     // MIs[0] policy
     /* 1597151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597161 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1597164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597185 */     // GIR_Coverage, 7093,
     /* 1597185 */     GIR_EraseRootFromParent_Done,
     /* 1597186 */   // Label 21976: @1597186
     /* 1597186 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1597272), // Rule ID 7096 //
     /* 1597191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597237 */     // MIs[0] policy
     /* 1597237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1597250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597271 */     // GIR_Coverage, 7096,
     /* 1597271 */     GIR_EraseRootFromParent_Done,
     /* 1597272 */   // Label 21977: @1597272
     /* 1597272 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1597358), // Rule ID 7097 //
     /* 1597277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597323 */     // MIs[0] policy
     /* 1597323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1597336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597357 */     // GIR_Coverage, 7097,
     /* 1597357 */     GIR_EraseRootFromParent_Done,
     /* 1597358 */   // Label 21978: @1597358
     /* 1597358 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1597444), // Rule ID 7100 //
     /* 1597363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597409 */     // MIs[0] policy
     /* 1597409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597419 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1597422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597443 */     // GIR_Coverage, 7100,
     /* 1597443 */     GIR_EraseRootFromParent_Done,
     /* 1597444 */   // Label 21979: @1597444
     /* 1597444 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1597530), // Rule ID 7101 //
     /* 1597449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597495 */     // MIs[0] policy
     /* 1597495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597505 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1597508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597529 */     // GIR_Coverage, 7101,
     /* 1597529 */     GIR_EraseRootFromParent_Done,
     /* 1597530 */   // Label 21980: @1597530
     /* 1597530 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1597616), // Rule ID 7104 //
     /* 1597535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1597546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1597549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1597552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597581 */     // MIs[0] policy
     /* 1597581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597591 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1597594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597615 */     // GIR_Coverage, 7104,
     /* 1597615 */     GIR_EraseRootFromParent_Done,
     /* 1597616 */   // Label 21981: @1597616
     /* 1597616 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1597702), // Rule ID 7105 //
     /* 1597621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1597632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1597635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1597638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597667 */     // MIs[0] policy
     /* 1597667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1597680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597701 */     // GIR_Coverage, 7105,
     /* 1597701 */     GIR_EraseRootFromParent_Done,
     /* 1597702 */   // Label 21982: @1597702
     /* 1597702 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1597788), // Rule ID 7108 //
     /* 1597707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597753 */     // MIs[0] policy
     /* 1597753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1597766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597787 */     // GIR_Coverage, 7108,
     /* 1597787 */     GIR_EraseRootFromParent_Done,
     /* 1597788 */   // Label 21983: @1597788
     /* 1597788 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1597874), // Rule ID 7109 //
     /* 1597793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597839 */     // MIs[0] policy
     /* 1597839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1597852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597873 */     // GIR_Coverage, 7109,
     /* 1597873 */     GIR_EraseRootFromParent_Done,
     /* 1597874 */   // Label 21984: @1597874
     /* 1597874 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1597960), // Rule ID 7112 //
     /* 1597879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597925 */     // MIs[0] policy
     /* 1597925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597935 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1597938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597959 */     // GIR_Coverage, 7112,
     /* 1597959 */     GIR_EraseRootFromParent_Done,
     /* 1597960 */   // Label 21985: @1597960
     /* 1597960 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1598046), // Rule ID 7113 //
     /* 1597965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1597973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598011 */     // MIs[0] policy
     /* 1598011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1598024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598045 */     // GIR_Coverage, 7113,
     /* 1598045 */     GIR_EraseRootFromParent_Done,
     /* 1598046 */   // Label 21986: @1598046
     /* 1598046 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1598132), // Rule ID 7116 //
     /* 1598051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1598059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1598062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1598065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1598068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1598081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598097 */     // MIs[0] policy
     /* 1598097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1598110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598131 */     // GIR_Coverage, 7116,
     /* 1598131 */     GIR_EraseRootFromParent_Done,
     /* 1598132 */   // Label 21987: @1598132
     /* 1598132 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1598218), // Rule ID 7117 //
     /* 1598137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1598145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1598148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1598151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1598154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1598167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598183 */     // MIs[0] policy
     /* 1598183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1598196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598217 */     // GIR_Coverage, 7117,
     /* 1598217 */     GIR_EraseRootFromParent_Done,
     /* 1598218 */   // Label 21988: @1598218
     /* 1598218 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1598304), // Rule ID 7296 //
     /* 1598223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1598243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598269 */     // MIs[0] policy
     /* 1598269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598279 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1598282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598303 */     // GIR_Coverage, 7296,
     /* 1598303 */     GIR_EraseRootFromParent_Done,
     /* 1598304 */   // Label 21989: @1598304
     /* 1598304 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1598390), // Rule ID 7297 //
     /* 1598309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1598329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598355 */     // MIs[0] policy
     /* 1598355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598365 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1598368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598389 */     // GIR_Coverage, 7297,
     /* 1598389 */     GIR_EraseRootFromParent_Done,
     /* 1598390 */   // Label 21990: @1598390
     /* 1598390 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1598476), // Rule ID 7300 //
     /* 1598395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1598415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598441 */     // MIs[0] policy
     /* 1598441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1598454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598475 */     // GIR_Coverage, 7300,
     /* 1598475 */     GIR_EraseRootFromParent_Done,
     /* 1598476 */   // Label 21991: @1598476
     /* 1598476 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1598562), // Rule ID 7301 //
     /* 1598481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1598501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598527 */     // MIs[0] policy
     /* 1598527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598537 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1598540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598561 */     // GIR_Coverage, 7301,
     /* 1598561 */     GIR_EraseRootFromParent_Done,
     /* 1598562 */   // Label 21992: @1598562
     /* 1598562 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1598648), // Rule ID 7304 //
     /* 1598567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1598578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1598581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1598587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598613 */     // MIs[0] policy
     /* 1598613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1598626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598647 */     // GIR_Coverage, 7304,
     /* 1598647 */     GIR_EraseRootFromParent_Done,
     /* 1598648 */   // Label 21993: @1598648
     /* 1598648 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1598734), // Rule ID 7305 //
     /* 1598653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1598664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1598667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1598673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598699 */     // MIs[0] policy
     /* 1598699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598709 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1598712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598733 */     // GIR_Coverage, 7305,
     /* 1598733 */     GIR_EraseRootFromParent_Done,
     /* 1598734 */   // Label 21994: @1598734
     /* 1598734 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1598820), // Rule ID 7308 //
     /* 1598739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1598756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1598759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598785 */     // MIs[0] policy
     /* 1598785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598795 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1598798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598819 */     // GIR_Coverage, 7308,
     /* 1598819 */     GIR_EraseRootFromParent_Done,
     /* 1598820 */   // Label 21995: @1598820
     /* 1598820 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1598906), // Rule ID 7309 //
     /* 1598825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1598842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1598845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598871 */     // MIs[0] policy
     /* 1598871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598881 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1598884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598905 */     // GIR_Coverage, 7309,
     /* 1598905 */     GIR_EraseRootFromParent_Done,
     /* 1598906 */   // Label 21996: @1598906
     /* 1598906 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1598992), // Rule ID 7312 //
     /* 1598911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1598919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1598928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1598931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598957 */     // MIs[0] policy
     /* 1598957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1598970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598991 */     // GIR_Coverage, 7312,
     /* 1598991 */     GIR_EraseRootFromParent_Done,
     /* 1598992 */   // Label 21997: @1598992
     /* 1598992 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1599078), // Rule ID 7313 //
     /* 1598997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1599017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599043 */     // MIs[0] policy
     /* 1599043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599053 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1599056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599077 */     // GIR_Coverage, 7313,
     /* 1599077 */     GIR_EraseRootFromParent_Done,
     /* 1599078 */   // Label 21998: @1599078
     /* 1599078 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1599164), // Rule ID 7316 //
     /* 1599083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1599103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599129 */     // MIs[0] policy
     /* 1599129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599139 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1599142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599163 */     // GIR_Coverage, 7316,
     /* 1599163 */     GIR_EraseRootFromParent_Done,
     /* 1599164 */   // Label 21999: @1599164
     /* 1599164 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1599250), // Rule ID 7317 //
     /* 1599169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1599189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599215 */     // MIs[0] policy
     /* 1599215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1599228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599249 */     // GIR_Coverage, 7317,
     /* 1599249 */     GIR_EraseRootFromParent_Done,
     /* 1599250 */   // Label 22000: @1599250
     /* 1599250 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1599336), // Rule ID 7320 //
     /* 1599255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1599266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1599269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1599272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1599275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599301 */     // MIs[0] policy
     /* 1599301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1599314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599335 */     // GIR_Coverage, 7320,
     /* 1599335 */     GIR_EraseRootFromParent_Done,
     /* 1599336 */   // Label 22001: @1599336
     /* 1599336 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1599422), // Rule ID 7321 //
     /* 1599341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1599352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1599355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1599358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1599361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599387 */     // MIs[0] policy
     /* 1599387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599397 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1599400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599421 */     // GIR_Coverage, 7321,
     /* 1599421 */     GIR_EraseRootFromParent_Done,
     /* 1599422 */   // Label 22002: @1599422
     /* 1599422 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1599508), // Rule ID 7324 //
     /* 1599427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1599438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1599441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1599444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1599447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599473 */     // MIs[0] policy
     /* 1599473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599483 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1599486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599507 */     // GIR_Coverage, 7324,
     /* 1599507 */     GIR_EraseRootFromParent_Done,
     /* 1599508 */   // Label 22003: @1599508
     /* 1599508 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1599594), // Rule ID 7325 //
     /* 1599513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1599524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1599527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1599530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1599533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599559 */     // MIs[0] policy
     /* 1599559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1599572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599593 */     // GIR_Coverage, 7325,
     /* 1599593 */     GIR_EraseRootFromParent_Done,
     /* 1599594 */   // Label 22004: @1599594
     /* 1599594 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1599680), // Rule ID 7328 //
     /* 1599599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1599619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599645 */     // MIs[0] policy
     /* 1599645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599655 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1599658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599679 */     // GIR_Coverage, 7328,
     /* 1599679 */     GIR_EraseRootFromParent_Done,
     /* 1599680 */   // Label 22005: @1599680
     /* 1599680 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1599766), // Rule ID 7329 //
     /* 1599685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1599705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599731 */     // MIs[0] policy
     /* 1599731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599741 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1599744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599765 */     // GIR_Coverage, 7329,
     /* 1599765 */     GIR_EraseRootFromParent_Done,
     /* 1599766 */   // Label 22006: @1599766
     /* 1599766 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1599852), // Rule ID 7332 //
     /* 1599771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1599788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1599791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599817 */     // MIs[0] policy
     /* 1599817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1599830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599851 */     // GIR_Coverage, 7332,
     /* 1599851 */     GIR_EraseRootFromParent_Done,
     /* 1599852 */   // Label 22007: @1599852
     /* 1599852 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1599938), // Rule ID 7333 //
     /* 1599857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1599874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1599877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599903 */     // MIs[0] policy
     /* 1599903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1599916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599937 */     // GIR_Coverage, 7333,
     /* 1599937 */     GIR_EraseRootFromParent_Done,
     /* 1599938 */   // Label 22008: @1599938
     /* 1599938 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1600024), // Rule ID 7336 //
     /* 1599943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1599951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1599960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1599963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599989 */     // MIs[0] policy
     /* 1599989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1600002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600023 */     // GIR_Coverage, 7336,
     /* 1600023 */     GIR_EraseRootFromParent_Done,
     /* 1600024 */   // Label 22009: @1600024
     /* 1600024 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1600110), // Rule ID 7337 //
     /* 1600029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1600040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1600043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1600049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600075 */     // MIs[0] policy
     /* 1600075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600085 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1600088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600109 */     // GIR_Coverage, 7337,
     /* 1600109 */     GIR_EraseRootFromParent_Done,
     /* 1600110 */   // Label 22010: @1600110
     /* 1600110 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1600196), // Rule ID 7340 //
     /* 1600115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1600118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1600126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1600129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1600132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1600135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600161 */     // MIs[0] policy
     /* 1600161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1600174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600195 */     // GIR_Coverage, 7340,
     /* 1600195 */     GIR_EraseRootFromParent_Done,
     /* 1600196 */   // Label 22011: @1600196
     /* 1600196 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1600282), // Rule ID 7341 //
     /* 1600201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1600204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1600212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1600215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1600218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1600221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600247 */     // MIs[0] policy
     /* 1600247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600257 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1600260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600281 */     // GIR_Coverage, 7341,
     /* 1600281 */     GIR_EraseRootFromParent_Done,
     /* 1600282 */   // Label 22012: @1600282
     /* 1600282 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1600368), // Rule ID 7344 //
     /* 1600287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1600290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1600298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1600301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1600307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600333 */     // MIs[0] policy
     /* 1600333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1600346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600367 */     // GIR_Coverage, 7344,
     /* 1600367 */     GIR_EraseRootFromParent_Done,
     /* 1600368 */   // Label 22013: @1600368
     /* 1600368 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1600454), // Rule ID 7345 //
     /* 1600373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1600376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1600384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1600387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1600393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600419 */     // MIs[0] policy
     /* 1600419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1600432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600453 */     // GIR_Coverage, 7345,
     /* 1600453 */     GIR_EraseRootFromParent_Done,
     /* 1600454 */   // Label 22014: @1600454
     /* 1600454 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1600540), // Rule ID 7348 //
     /* 1600459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1600462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1600479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600505 */     // MIs[0] policy
     /* 1600505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1600518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600539 */     // GIR_Coverage, 7348,
     /* 1600539 */     GIR_EraseRootFromParent_Done,
     /* 1600540 */   // Label 22015: @1600540
     /* 1600540 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1600626), // Rule ID 7349 //
     /* 1600545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1600548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1600565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600591 */     // MIs[0] policy
     /* 1600591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1600604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600625 */     // GIR_Coverage, 7349,
     /* 1600625 */     GIR_EraseRootFromParent_Done,
     /* 1600626 */   // Label 22016: @1600626
     /* 1600626 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1600712), // Rule ID 7352 //
     /* 1600631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1600634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1600651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600677 */     // MIs[0] policy
     /* 1600677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600687 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1600690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600711 */     // GIR_Coverage, 7352,
     /* 1600711 */     GIR_EraseRootFromParent_Done,
     /* 1600712 */   // Label 22017: @1600712
     /* 1600712 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1600798), // Rule ID 7353 //
     /* 1600717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1600720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1600737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600763 */     // MIs[0] policy
     /* 1600763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1600776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600797 */     // GIR_Coverage, 7353,
     /* 1600797 */     GIR_EraseRootFromParent_Done,
     /* 1600798 */   // Label 22018: @1600798
     /* 1600798 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1600884), // Rule ID 7356 //
     /* 1600803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1600820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600849 */     // MIs[0] policy
     /* 1600849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1600862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600883 */     // GIR_Coverage, 7356,
     /* 1600883 */     GIR_EraseRootFromParent_Done,
     /* 1600884 */   // Label 22019: @1600884
     /* 1600884 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1600970), // Rule ID 7357 //
     /* 1600889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1600906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600935 */     // MIs[0] policy
     /* 1600935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600945 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1600948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600969 */     // GIR_Coverage, 7357,
     /* 1600969 */     GIR_EraseRootFromParent_Done,
     /* 1600970 */   // Label 22020: @1600970
     /* 1600970 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1601056), // Rule ID 7360 //
     /* 1600975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1600983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1600986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1600989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1600992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601021 */     // MIs[0] policy
     /* 1601021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601031 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1601034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601055 */     // GIR_Coverage, 7360,
     /* 1601055 */     GIR_EraseRootFromParent_Done,
     /* 1601056 */   // Label 22021: @1601056
     /* 1601056 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1601142), // Rule ID 7361 //
     /* 1601061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601107 */     // MIs[0] policy
     /* 1601107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1601120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601141 */     // GIR_Coverage, 7361,
     /* 1601141 */     GIR_EraseRootFromParent_Done,
     /* 1601142 */   // Label 22022: @1601142
     /* 1601142 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1601228), // Rule ID 7364 //
     /* 1601147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1601164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601193 */     // MIs[0] policy
     /* 1601193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601203 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1601206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601227 */     // GIR_Coverage, 7364,
     /* 1601227 */     GIR_EraseRootFromParent_Done,
     /* 1601228 */   // Label 22023: @1601228
     /* 1601228 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1601314), // Rule ID 7365 //
     /* 1601233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1601250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601279 */     // MIs[0] policy
     /* 1601279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601289 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1601292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601313 */     // GIR_Coverage, 7365,
     /* 1601313 */     GIR_EraseRootFromParent_Done,
     /* 1601314 */   // Label 22024: @1601314
     /* 1601314 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1601400), // Rule ID 7368 //
     /* 1601319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1601336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601365 */     // MIs[0] policy
     /* 1601365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601375 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1601378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601399 */     // GIR_Coverage, 7368,
     /* 1601399 */     GIR_EraseRootFromParent_Done,
     /* 1601400 */   // Label 22025: @1601400
     /* 1601400 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1601486), // Rule ID 7369 //
     /* 1601405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1601422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601451 */     // MIs[0] policy
     /* 1601451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601461 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11185:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1601464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601485 */     // GIR_Coverage, 7369,
     /* 1601485 */     GIR_EraseRootFromParent_Done,
     /* 1601486 */   // Label 22026: @1601486
     /* 1601486 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1601572), // Rule ID 7372 //
     /* 1601491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1601502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1601505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1601508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601537 */     // MIs[0] policy
     /* 1601537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601547 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1601550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601571 */     // GIR_Coverage, 7372,
     /* 1601571 */     GIR_EraseRootFromParent_Done,
     /* 1601572 */   // Label 22027: @1601572
     /* 1601572 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1601658), // Rule ID 7373 //
     /* 1601577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1601588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1601591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1601594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601623 */     // MIs[0] policy
     /* 1601623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1601636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601657 */     // GIR_Coverage, 7373,
     /* 1601657 */     GIR_EraseRootFromParent_Done,
     /* 1601658 */   // Label 22028: @1601658
     /* 1601658 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1601744), // Rule ID 7376 //
     /* 1601663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1601674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1601677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1601680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1601686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601709 */     // MIs[0] policy
     /* 1601709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601719 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1601722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601743 */     // GIR_Coverage, 7376,
     /* 1601743 */     GIR_EraseRootFromParent_Done,
     /* 1601744 */   // Label 22029: @1601744
     /* 1601744 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1601830), // Rule ID 7377 //
     /* 1601749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1601760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1601763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1601766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1601772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601795 */     // MIs[0] policy
     /* 1601795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601805 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1601808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601829 */     // GIR_Coverage, 7377,
     /* 1601829 */     GIR_EraseRootFromParent_Done,
     /* 1601830 */   // Label 22030: @1601830
     /* 1601830 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1601916), // Rule ID 7380 //
     /* 1601835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601881 */     // MIs[0] policy
     /* 1601881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601891 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1601894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601915 */     // GIR_Coverage, 7380,
     /* 1601915 */     GIR_EraseRootFromParent_Done,
     /* 1601916 */   // Label 22031: @1601916
     /* 1601916 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1602002), // Rule ID 7381 //
     /* 1601921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1601929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601967 */     // MIs[0] policy
     /* 1601967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1601980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602001 */     // GIR_Coverage, 7381,
     /* 1602001 */     GIR_EraseRootFromParent_Done,
     /* 1602002 */   // Label 22032: @1602002
     /* 1602002 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1602088), // Rule ID 7384 //
     /* 1602007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602053 */     // MIs[0] policy
     /* 1602053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602063 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1602066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602087 */     // GIR_Coverage, 7384,
     /* 1602087 */     GIR_EraseRootFromParent_Done,
     /* 1602088 */   // Label 22033: @1602088
     /* 1602088 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1602174), // Rule ID 7385 //
     /* 1602093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602139 */     // MIs[0] policy
     /* 1602139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602149 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1602152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602173 */     // GIR_Coverage, 7385,
     /* 1602173 */     GIR_EraseRootFromParent_Done,
     /* 1602174 */   // Label 22034: @1602174
     /* 1602174 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1602260), // Rule ID 7388 //
     /* 1602179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1602196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602225 */     // MIs[0] policy
     /* 1602225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602235 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1602238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602259 */     // GIR_Coverage, 7388,
     /* 1602259 */     GIR_EraseRootFromParent_Done,
     /* 1602260 */   // Label 22035: @1602260
     /* 1602260 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1602346), // Rule ID 7389 //
     /* 1602265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1602282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602311 */     // MIs[0] policy
     /* 1602311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1602324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602345 */     // GIR_Coverage, 7389,
     /* 1602345 */     GIR_EraseRootFromParent_Done,
     /* 1602346 */   // Label 22036: @1602346
     /* 1602346 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1602432), // Rule ID 7392 //
     /* 1602351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1602362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1602365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1602368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602397 */     // MIs[0] policy
     /* 1602397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1602410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602431 */     // GIR_Coverage, 7392,
     /* 1602431 */     GIR_EraseRootFromParent_Done,
     /* 1602432 */   // Label 22037: @1602432
     /* 1602432 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1602518), // Rule ID 7393 //
     /* 1602437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1602448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1602451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1602454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602483 */     // MIs[0] policy
     /* 1602483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602493 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1602496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602517 */     // GIR_Coverage, 7393,
     /* 1602517 */     GIR_EraseRootFromParent_Done,
     /* 1602518 */   // Label 22038: @1602518
     /* 1602518 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1602604), // Rule ID 7396 //
     /* 1602523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1602534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1602537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1602540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602569 */     // MIs[0] policy
     /* 1602569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602579 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1602582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602603 */     // GIR_Coverage, 7396,
     /* 1602603 */     GIR_EraseRootFromParent_Done,
     /* 1602604 */   // Label 22039: @1602604
     /* 1602604 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1602690), // Rule ID 7397 //
     /* 1602609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1602620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1602623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1602626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602655 */     // MIs[0] policy
     /* 1602655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602665 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1602668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602689 */     // GIR_Coverage, 7397,
     /* 1602689 */     GIR_EraseRootFromParent_Done,
     /* 1602690 */   // Label 22040: @1602690
     /* 1602690 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1602776), // Rule ID 7400 //
     /* 1602695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1602698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602741 */     // MIs[0] policy
     /* 1602741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1602754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602775 */     // GIR_Coverage, 7400,
     /* 1602775 */     GIR_EraseRootFromParent_Done,
     /* 1602776 */   // Label 22041: @1602776
     /* 1602776 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1602862), // Rule ID 7401 //
     /* 1602781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1602784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602827 */     // MIs[0] policy
     /* 1602827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1602840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602861 */     // GIR_Coverage, 7401,
     /* 1602861 */     GIR_EraseRootFromParent_Done,
     /* 1602862 */   // Label 22042: @1602862
     /* 1602862 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1602948), // Rule ID 7404 //
     /* 1602867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1602870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1602884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602913 */     // MIs[0] policy
     /* 1602913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602923 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1602926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602947 */     // GIR_Coverage, 7404,
     /* 1602947 */     GIR_EraseRootFromParent_Done,
     /* 1602948 */   // Label 22043: @1602948
     /* 1602948 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1603034), // Rule ID 7405 //
     /* 1602953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1602956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1602961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1602970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602999 */     // MIs[0] policy
     /* 1602999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1603012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603033 */     // GIR_Coverage, 7405,
     /* 1603033 */     GIR_EraseRootFromParent_Done,
     /* 1603034 */   // Label 22044: @1603034
     /* 1603034 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1603120), // Rule ID 7408 //
     /* 1603039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1603042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1603047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1603056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603085 */     // MIs[0] policy
     /* 1603085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1603098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603119 */     // GIR_Coverage, 7408,
     /* 1603119 */     GIR_EraseRootFromParent_Done,
     /* 1603120 */   // Label 22045: @1603120
     /* 1603120 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1603206), // Rule ID 7409 //
     /* 1603125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1603128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1603133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1603142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603171 */     // MIs[0] policy
     /* 1603171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1603184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603205 */     // GIR_Coverage, 7409,
     /* 1603205 */     GIR_EraseRootFromParent_Done,
     /* 1603206 */   // Label 22046: @1603206
     /* 1603206 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1603292), // Rule ID 7412 //
     /* 1603211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1603214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1603219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1603228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603257 */     // MIs[0] policy
     /* 1603257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603267 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1603270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603291 */     // GIR_Coverage, 7412,
     /* 1603291 */     GIR_EraseRootFromParent_Done,
     /* 1603292 */   // Label 22047: @1603292
     /* 1603292 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1603378), // Rule ID 7413 //
     /* 1603297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1603300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1603305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1603314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603343 */     // MIs[0] policy
     /* 1603343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1603356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603377 */     // GIR_Coverage, 7413,
     /* 1603377 */     GIR_EraseRootFromParent_Done,
     /* 1603378 */   // Label 22048: @1603378
     /* 1603378 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1603464), // Rule ID 7476 //
     /* 1603383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1603394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1603397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1603400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1603403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603429 */     // MIs[0] policy
     /* 1603429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1603442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603463 */     // GIR_Coverage, 7476,
     /* 1603463 */     GIR_EraseRootFromParent_Done,
     /* 1603464 */   // Label 22049: @1603464
     /* 1603464 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1603550), // Rule ID 7477 //
     /* 1603469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1603480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1603483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1603486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1603489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603515 */     // MIs[0] policy
     /* 1603515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1603528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603549 */     // GIR_Coverage, 7477,
     /* 1603549 */     GIR_EraseRootFromParent_Done,
     /* 1603550 */   // Label 22050: @1603550
     /* 1603550 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1603636), // Rule ID 7480 //
     /* 1603555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1603566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1603569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1603572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1603575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603601 */     // MIs[0] policy
     /* 1603601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603611 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1603614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603635 */     // GIR_Coverage, 7480,
     /* 1603635 */     GIR_EraseRootFromParent_Done,
     /* 1603636 */   // Label 22051: @1603636
     /* 1603636 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1603722), // Rule ID 7481 //
     /* 1603641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1603652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1603655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1603658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1603661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603687 */     // MIs[0] policy
     /* 1603687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1603700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603721 */     // GIR_Coverage, 7481,
     /* 1603721 */     GIR_EraseRootFromParent_Done,
     /* 1603722 */   // Label 22052: @1603722
     /* 1603722 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1603808), // Rule ID 7484 //
     /* 1603727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1603738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1603741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1603747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603773 */     // MIs[0] policy
     /* 1603773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603783 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1603786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603807 */     // GIR_Coverage, 7484,
     /* 1603807 */     GIR_EraseRootFromParent_Done,
     /* 1603808 */   // Label 22053: @1603808
     /* 1603808 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1603894), // Rule ID 7485 //
     /* 1603813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1603824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1603827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1603833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603859 */     // MIs[0] policy
     /* 1603859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603869 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1603872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603893 */     // GIR_Coverage, 7485,
     /* 1603893 */     GIR_EraseRootFromParent_Done,
     /* 1603894 */   // Label 22054: @1603894
     /* 1603894 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1603980), // Rule ID 7488 //
     /* 1603899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1603910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1603913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1603919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603945 */     // MIs[0] policy
     /* 1603945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603955 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1603958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603979 */     // GIR_Coverage, 7488,
     /* 1603979 */     GIR_EraseRootFromParent_Done,
     /* 1603980 */   // Label 22055: @1603980
     /* 1603980 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1604066), // Rule ID 7489 //
     /* 1603985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1603993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1603996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1603999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1604002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1604005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604031 */     // MIs[0] policy
     /* 1604031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604041 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1604044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604065 */     // GIR_Coverage, 7489,
     /* 1604065 */     GIR_EraseRootFromParent_Done,
     /* 1604066 */   // Label 22056: @1604066
     /* 1604066 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1604152), // Rule ID 7492 //
     /* 1604071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1604082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1604085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1604091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604117 */     // MIs[0] policy
     /* 1604117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1604130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604151 */     // GIR_Coverage, 7492,
     /* 1604151 */     GIR_EraseRootFromParent_Done,
     /* 1604152 */   // Label 22057: @1604152
     /* 1604152 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1604238), // Rule ID 7493 //
     /* 1604157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1604168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1604171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1604177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604203 */     // MIs[0] policy
     /* 1604203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604213 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1604216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604237 */     // GIR_Coverage, 7493,
     /* 1604237 */     GIR_EraseRootFromParent_Done,
     /* 1604238 */   // Label 22058: @1604238
     /* 1604238 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1604324), // Rule ID 7496 //
     /* 1604243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1604254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1604257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1604260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1604263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604289 */     // MIs[0] policy
     /* 1604289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1604302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604323 */     // GIR_Coverage, 7496,
     /* 1604323 */     GIR_EraseRootFromParent_Done,
     /* 1604324 */   // Label 22059: @1604324
     /* 1604324 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1604410), // Rule ID 7497 //
     /* 1604329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1604340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1604343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1604346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1604349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604375 */     // MIs[0] policy
     /* 1604375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604385 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1604388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604409 */     // GIR_Coverage, 7497,
     /* 1604409 */     GIR_EraseRootFromParent_Done,
     /* 1604410 */   // Label 22060: @1604410
     /* 1604410 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1604496), // Rule ID 7500 //
     /* 1604415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1604426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1604429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1604432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1604435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604461 */     // MIs[0] policy
     /* 1604461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1604474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604495 */     // GIR_Coverage, 7500,
     /* 1604495 */     GIR_EraseRootFromParent_Done,
     /* 1604496 */   // Label 22061: @1604496
     /* 1604496 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1604582), // Rule ID 7501 //
     /* 1604501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1604512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1604515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1604518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1604521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604547 */     // MIs[0] policy
     /* 1604547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604557 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1604560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604581 */     // GIR_Coverage, 7501,
     /* 1604581 */     GIR_EraseRootFromParent_Done,
     /* 1604582 */   // Label 22062: @1604582
     /* 1604582 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1604668), // Rule ID 7504 //
     /* 1604587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1604598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1604601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1604604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1604607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604633 */     // MIs[0] policy
     /* 1604633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604643 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1604646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604667 */     // GIR_Coverage, 7504,
     /* 1604667 */     GIR_EraseRootFromParent_Done,
     /* 1604668 */   // Label 22063: @1604668
     /* 1604668 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1604754), // Rule ID 7505 //
     /* 1604673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1604684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1604687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1604690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1604693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604719 */     // MIs[0] policy
     /* 1604719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604729 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1604732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604753 */     // GIR_Coverage, 7505,
     /* 1604753 */     GIR_EraseRootFromParent_Done,
     /* 1604754 */   // Label 22064: @1604754
     /* 1604754 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1604840), // Rule ID 7508 //
     /* 1604759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1604770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1604773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1604779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604805 */     // MIs[0] policy
     /* 1604805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1604818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604839 */     // GIR_Coverage, 7508,
     /* 1604839 */     GIR_EraseRootFromParent_Done,
     /* 1604840 */   // Label 22065: @1604840
     /* 1604840 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1604926), // Rule ID 7509 //
     /* 1604845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1604856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1604859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1604865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604891 */     // MIs[0] policy
     /* 1604891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604901 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1604904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604925 */     // GIR_Coverage, 7509,
     /* 1604925 */     GIR_EraseRootFromParent_Done,
     /* 1604926 */   // Label 22066: @1604926
     /* 1604926 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1605012), // Rule ID 7512 //
     /* 1604931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1604939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1604942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1604945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1604951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604977 */     // MIs[0] policy
     /* 1604977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1604990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605011 */     // GIR_Coverage, 7512,
     /* 1605011 */     GIR_EraseRootFromParent_Done,
     /* 1605012 */   // Label 22067: @1605012
     /* 1605012 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1605098), // Rule ID 7513 //
     /* 1605017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1605028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1605031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1605034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1605037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605063 */     // MIs[0] policy
     /* 1605063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1605076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605097 */     // GIR_Coverage, 7513,
     /* 1605097 */     GIR_EraseRootFromParent_Done,
     /* 1605098 */   // Label 22068: @1605098
     /* 1605098 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1605184), // Rule ID 7516 //
     /* 1605103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1605114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1605117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1605120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1605123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1605126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605149 */     // MIs[0] policy
     /* 1605149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1605162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605183 */     // GIR_Coverage, 7516,
     /* 1605183 */     GIR_EraseRootFromParent_Done,
     /* 1605184 */   // Label 22069: @1605184
     /* 1605184 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1605270), // Rule ID 7517 //
     /* 1605189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1605200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1605203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1605206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1605209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1605212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605235 */     // MIs[0] policy
     /* 1605235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1605248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605269 */     // GIR_Coverage, 7517,
     /* 1605269 */     GIR_EraseRootFromParent_Done,
     /* 1605270 */   // Label 22070: @1605270
     /* 1605270 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1605356), // Rule ID 7520 //
     /* 1605275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1605278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1605292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1605295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605321 */     // MIs[0] policy
     /* 1605321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1605334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605355 */     // GIR_Coverage, 7520,
     /* 1605355 */     GIR_EraseRootFromParent_Done,
     /* 1605356 */   // Label 22071: @1605356
     /* 1605356 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1605442), // Rule ID 7521 //
     /* 1605361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1605364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1605378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1605381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605407 */     // MIs[0] policy
     /* 1605407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605417 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1605420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605441 */     // GIR_Coverage, 7521,
     /* 1605441 */     GIR_EraseRootFromParent_Done,
     /* 1605442 */   // Label 22072: @1605442
     /* 1605442 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1605528), // Rule ID 7524 //
     /* 1605447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1605450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1605458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1605461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1605467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605493 */     // MIs[0] policy
     /* 1605493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605503 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1605506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605527 */     // GIR_Coverage, 7524,
     /* 1605527 */     GIR_EraseRootFromParent_Done,
     /* 1605528 */   // Label 22073: @1605528
     /* 1605528 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1605614), // Rule ID 7525 //
     /* 1605533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1605536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1605544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1605547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1605553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605579 */     // MIs[0] policy
     /* 1605579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605589 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1605592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605613 */     // GIR_Coverage, 7525,
     /* 1605613 */     GIR_EraseRootFromParent_Done,
     /* 1605614 */   // Label 22074: @1605614
     /* 1605614 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1605700), // Rule ID 7528 //
     /* 1605619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1605622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1605630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1605633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1605639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605665 */     // MIs[0] policy
     /* 1605665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1605678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605699 */     // GIR_Coverage, 7528,
     /* 1605699 */     GIR_EraseRootFromParent_Done,
     /* 1605700 */   // Label 22075: @1605700
     /* 1605700 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1605786), // Rule ID 7529 //
     /* 1605705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1605708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1605716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1605719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1605725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605751 */     // MIs[0] policy
     /* 1605751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1605764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605785 */     // GIR_Coverage, 7529,
     /* 1605785 */     GIR_EraseRootFromParent_Done,
     /* 1605786 */   // Label 22076: @1605786
     /* 1605786 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1605872), // Rule ID 7532 //
     /* 1605791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1605794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1605802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1605805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1605811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605837 */     // MIs[0] policy
     /* 1605837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605847 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1605850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605871 */     // GIR_Coverage, 7532,
     /* 1605871 */     GIR_EraseRootFromParent_Done,
     /* 1605872 */   // Label 22077: @1605872
     /* 1605872 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1605958), // Rule ID 7533 //
     /* 1605877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1605880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1605888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1605891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1605897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605923 */     // MIs[0] policy
     /* 1605923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1605936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605957 */     // GIR_Coverage, 7533,
     /* 1605957 */     GIR_EraseRootFromParent_Done,
     /* 1605958 */   // Label 22078: @1605958
     /* 1605958 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1606044), // Rule ID 7536 //
     /* 1605963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1605971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1605974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1605977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606009 */     // MIs[0] policy
     /* 1606009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1606022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606043 */     // GIR_Coverage, 7536,
     /* 1606043 */     GIR_EraseRootFromParent_Done,
     /* 1606044 */   // Label 22079: @1606044
     /* 1606044 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1606130), // Rule ID 7537 //
     /* 1606049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1606060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1606063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1606066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606095 */     // MIs[0] policy
     /* 1606095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606105 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1606108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606129 */     // GIR_Coverage, 7537,
     /* 1606129 */     GIR_EraseRootFromParent_Done,
     /* 1606130 */   // Label 22080: @1606130
     /* 1606130 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1606216), // Rule ID 7540 //
     /* 1606135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1606146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1606149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606181 */     // MIs[0] policy
     /* 1606181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606191 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1606194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606215 */     // GIR_Coverage, 7540,
     /* 1606215 */     GIR_EraseRootFromParent_Done,
     /* 1606216 */   // Label 22081: @1606216
     /* 1606216 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1606302), // Rule ID 7541 //
     /* 1606221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1606232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1606235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606267 */     // MIs[0] policy
     /* 1606267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1606280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606301 */     // GIR_Coverage, 7541,
     /* 1606301 */     GIR_EraseRootFromParent_Done,
     /* 1606302 */   // Label 22082: @1606302
     /* 1606302 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1606388), // Rule ID 7544 //
     /* 1606307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1606318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1606321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606353 */     // MIs[0] policy
     /* 1606353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606363 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1606366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606387 */     // GIR_Coverage, 7544,
     /* 1606387 */     GIR_EraseRootFromParent_Done,
     /* 1606388 */   // Label 22083: @1606388
     /* 1606388 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1606474), // Rule ID 7545 //
     /* 1606393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1606404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1606407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606439 */     // MIs[0] policy
     /* 1606439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606449 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1606452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606473 */     // GIR_Coverage, 7545,
     /* 1606473 */     GIR_EraseRootFromParent_Done,
     /* 1606474 */   // Label 22084: @1606474
     /* 1606474 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1606560), // Rule ID 7548 //
     /* 1606479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606525 */     // MIs[0] policy
     /* 1606525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606535 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1606538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606559 */     // GIR_Coverage, 7548,
     /* 1606559 */     GIR_EraseRootFromParent_Done,
     /* 1606560 */   // Label 22085: @1606560
     /* 1606560 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1606646), // Rule ID 7549 //
     /* 1606565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606611 */     // MIs[0] policy
     /* 1606611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606621 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1606624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606645 */     // GIR_Coverage, 7549,
     /* 1606645 */     GIR_EraseRootFromParent_Done,
     /* 1606646 */   // Label 22086: @1606646
     /* 1606646 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1606732), // Rule ID 7552 //
     /* 1606651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1606668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606697 */     // MIs[0] policy
     /* 1606697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1606710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606731 */     // GIR_Coverage, 7552,
     /* 1606731 */     GIR_EraseRootFromParent_Done,
     /* 1606732 */   // Label 22087: @1606732
     /* 1606732 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1606818), // Rule ID 7553 //
     /* 1606737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1606754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606783 */     // MIs[0] policy
     /* 1606783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1606796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606817 */     // GIR_Coverage, 7553,
     /* 1606817 */     GIR_EraseRootFromParent_Done,
     /* 1606818 */   // Label 22088: @1606818
     /* 1606818 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1606904), // Rule ID 7556 //
     /* 1606823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1606840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606869 */     // MIs[0] policy
     /* 1606869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606879 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1606882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606903 */     // GIR_Coverage, 7556,
     /* 1606903 */     GIR_EraseRootFromParent_Done,
     /* 1606904 */   // Label 22089: @1606904
     /* 1606904 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1606990), // Rule ID 7557 //
     /* 1606909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1606917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1606926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606955 */     // MIs[0] policy
     /* 1606955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606965 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1606968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606989 */     // GIR_Coverage, 7557,
     /* 1606989 */     GIR_EraseRootFromParent_Done,
     /* 1606990 */   // Label 22090: @1606990
     /* 1606990 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1607076), // Rule ID 7560 //
     /* 1606995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1607006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1607009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607041 */     // MIs[0] policy
     /* 1607041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1607054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607075 */     // GIR_Coverage, 7560,
     /* 1607075 */     GIR_EraseRootFromParent_Done,
     /* 1607076 */   // Label 22091: @1607076
     /* 1607076 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1607162), // Rule ID 7561 //
     /* 1607081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1607092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1607095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607127 */     // MIs[0] policy
     /* 1607127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1607140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607161 */     // GIR_Coverage, 7561,
     /* 1607161 */     GIR_EraseRootFromParent_Done,
     /* 1607162 */   // Label 22092: @1607162
     /* 1607162 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1607248), // Rule ID 7564 //
     /* 1607167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1607178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1607181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607213 */     // MIs[0] policy
     /* 1607213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1607226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607247 */     // GIR_Coverage, 7564,
     /* 1607247 */     GIR_EraseRootFromParent_Done,
     /* 1607248 */   // Label 22093: @1607248
     /* 1607248 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1607334), // Rule ID 7565 //
     /* 1607253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1607264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1607267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607299 */     // MIs[0] policy
     /* 1607299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1607312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607333 */     // GIR_Coverage, 7565,
     /* 1607333 */     GIR_EraseRootFromParent_Done,
     /* 1607334 */   // Label 22094: @1607334
     /* 1607334 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1607420), // Rule ID 7568 //
     /* 1607339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1607350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1607353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607385 */     // MIs[0] policy
     /* 1607385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607395 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1607398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607419 */     // GIR_Coverage, 7568,
     /* 1607419 */     GIR_EraseRootFromParent_Done,
     /* 1607420 */   // Label 22095: @1607420
     /* 1607420 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1607506), // Rule ID 7569 //
     /* 1607425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1607436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1607439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607471 */     // MIs[0] policy
     /* 1607471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607481 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1607484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607505 */     // GIR_Coverage, 7569,
     /* 1607505 */     GIR_EraseRootFromParent_Done,
     /* 1607506 */   // Label 22096: @1607506
     /* 1607506 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1607592), // Rule ID 7572 //
     /* 1607511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607557 */     // MIs[0] policy
     /* 1607557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1607570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607591 */     // GIR_Coverage, 7572,
     /* 1607591 */     GIR_EraseRootFromParent_Done,
     /* 1607592 */   // Label 22097: @1607592
     /* 1607592 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1607678), // Rule ID 7573 //
     /* 1607597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607643 */     // MIs[0] policy
     /* 1607643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607653 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1607656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607677 */     // GIR_Coverage, 7573,
     /* 1607677 */     GIR_EraseRootFromParent_Done,
     /* 1607678 */   // Label 22098: @1607678
     /* 1607678 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1607764), // Rule ID 7576 //
     /* 1607683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607729 */     // MIs[0] policy
     /* 1607729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607739 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1607742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607763 */     // GIR_Coverage, 7576,
     /* 1607763 */     GIR_EraseRootFromParent_Done,
     /* 1607764 */   // Label 22099: @1607764
     /* 1607764 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1607850), // Rule ID 7577 //
     /* 1607769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607815 */     // MIs[0] policy
     /* 1607815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607825 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1607828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607849 */     // GIR_Coverage, 7577,
     /* 1607849 */     GIR_EraseRootFromParent_Done,
     /* 1607850 */   // Label 22100: @1607850
     /* 1607850 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1607936), // Rule ID 7580 //
     /* 1607855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1607858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1607866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1607869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1607872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607901 */     // MIs[0] policy
     /* 1607901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1607914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607935 */     // GIR_Coverage, 7580,
     /* 1607935 */     GIR_EraseRootFromParent_Done,
     /* 1607936 */   // Label 22101: @1607936
     /* 1607936 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1608022), // Rule ID 7581 //
     /* 1607941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1607944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1607949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1607952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1607955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1607958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607987 */     // MIs[0] policy
     /* 1607987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607997 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1608000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608021 */     // GIR_Coverage, 7581,
     /* 1608021 */     GIR_EraseRootFromParent_Done,
     /* 1608022 */   // Label 22102: @1608022
     /* 1608022 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1608108), // Rule ID 7584 //
     /* 1608027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1608030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1608038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1608041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608073 */     // MIs[0] policy
     /* 1608073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608083 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1608086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608107 */     // GIR_Coverage, 7584,
     /* 1608107 */     GIR_EraseRootFromParent_Done,
     /* 1608108 */   // Label 22103: @1608108
     /* 1608108 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1608194), // Rule ID 7585 //
     /* 1608113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1608116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1608124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1608127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608159 */     // MIs[0] policy
     /* 1608159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608169 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1608172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608193 */     // GIR_Coverage, 7585,
     /* 1608193 */     GIR_EraseRootFromParent_Done,
     /* 1608194 */   // Label 22104: @1608194
     /* 1608194 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1608280), // Rule ID 7588 //
     /* 1608199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1608202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1608210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1608213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608245 */     // MIs[0] policy
     /* 1608245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1608258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608279 */     // GIR_Coverage, 7588,
     /* 1608279 */     GIR_EraseRootFromParent_Done,
     /* 1608280 */   // Label 22105: @1608280
     /* 1608280 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1608366), // Rule ID 7589 //
     /* 1608285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1608288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1608296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1608299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608331 */     // MIs[0] policy
     /* 1608331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1608344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608365 */     // GIR_Coverage, 7589,
     /* 1608365 */     GIR_EraseRootFromParent_Done,
     /* 1608366 */   // Label 22106: @1608366
     /* 1608366 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1608452), // Rule ID 7592 //
     /* 1608371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1608374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608417 */     // MIs[0] policy
     /* 1608417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608427 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1608430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608451 */     // GIR_Coverage, 7592,
     /* 1608451 */     GIR_EraseRootFromParent_Done,
     /* 1608452 */   // Label 22107: @1608452
     /* 1608452 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1608538), // Rule ID 7593 //
     /* 1608457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1608460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1608465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608503 */     // MIs[0] policy
     /* 1608503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608513 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1608516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608537 */     // GIR_Coverage, 7593,
     /* 1608537 */     GIR_EraseRootFromParent_Done,
     /* 1608538 */   // Label 22108: @1608538
     /* 1608538 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1608624), // Rule ID 10108 //
     /* 1608543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1608563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608589 */     // MIs[0] policy
     /* 1608589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608599 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1608602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608623 */     // GIR_Coverage, 10108,
     /* 1608623 */     GIR_EraseRootFromParent_Done,
     /* 1608624 */   // Label 22109: @1608624
     /* 1608624 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1608710), // Rule ID 10109 //
     /* 1608629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1608649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608675 */     // MIs[0] policy
     /* 1608675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608685 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1608688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608709 */     // GIR_Coverage, 10109,
     /* 1608709 */     GIR_EraseRootFromParent_Done,
     /* 1608710 */   // Label 22110: @1608710
     /* 1608710 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1608796), // Rule ID 10112 //
     /* 1608715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1608735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608761 */     // MIs[0] policy
     /* 1608761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608771 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1608774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608795 */     // GIR_Coverage, 10112,
     /* 1608795 */     GIR_EraseRootFromParent_Done,
     /* 1608796 */   // Label 22111: @1608796
     /* 1608796 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1608882), // Rule ID 10113 //
     /* 1608801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1608821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608847 */     // MIs[0] policy
     /* 1608847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608857 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1608860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608881 */     // GIR_Coverage, 10113,
     /* 1608881 */     GIR_EraseRootFromParent_Done,
     /* 1608882 */   // Label 22112: @1608882
     /* 1608882 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1608968), // Rule ID 10116 //
     /* 1608887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1608907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608933 */     // MIs[0] policy
     /* 1608933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608943 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1608946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608967 */     // GIR_Coverage, 10116,
     /* 1608967 */     GIR_EraseRootFromParent_Done,
     /* 1608968 */   // Label 22113: @1608968
     /* 1608968 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1609054), // Rule ID 10117 //
     /* 1608973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1608981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1608993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609019 */     // MIs[0] policy
     /* 1609019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609029 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1609032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609053 */     // GIR_Coverage, 10117,
     /* 1609053 */     GIR_EraseRootFromParent_Done,
     /* 1609054 */   // Label 22114: @1609054
     /* 1609054 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1609140), // Rule ID 10120 //
     /* 1609059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1609079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609105 */     // MIs[0] policy
     /* 1609105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609115 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1609118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609139 */     // GIR_Coverage, 10120,
     /* 1609139 */     GIR_EraseRootFromParent_Done,
     /* 1609140 */   // Label 22115: @1609140
     /* 1609140 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1609226), // Rule ID 10121 //
     /* 1609145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1609165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609191 */     // MIs[0] policy
     /* 1609191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609201 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1609204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609225 */     // GIR_Coverage, 10121,
     /* 1609225 */     GIR_EraseRootFromParent_Done,
     /* 1609226 */   // Label 22116: @1609226
     /* 1609226 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1609312), // Rule ID 10124 //
     /* 1609231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1609251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609277 */     // MIs[0] policy
     /* 1609277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609287 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1609290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609311 */     // GIR_Coverage, 10124,
     /* 1609311 */     GIR_EraseRootFromParent_Done,
     /* 1609312 */   // Label 22117: @1609312
     /* 1609312 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1609398), // Rule ID 10125 //
     /* 1609317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1609337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609363 */     // MIs[0] policy
     /* 1609363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609373 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1609376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609397 */     // GIR_Coverage, 10125,
     /* 1609397 */     GIR_EraseRootFromParent_Done,
     /* 1609398 */   // Label 22118: @1609398
     /* 1609398 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1609484), // Rule ID 10128 //
     /* 1609403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1609423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609449 */     // MIs[0] policy
     /* 1609449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1609462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609483 */     // GIR_Coverage, 10128,
     /* 1609483 */     GIR_EraseRootFromParent_Done,
     /* 1609484 */   // Label 22119: @1609484
     /* 1609484 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1609570), // Rule ID 10129 //
     /* 1609489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1609509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609535 */     // MIs[0] policy
     /* 1609535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609545 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1609548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609569 */     // GIR_Coverage, 10129,
     /* 1609569 */     GIR_EraseRootFromParent_Done,
     /* 1609570 */   // Label 22120: @1609570
     /* 1609570 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1609656), // Rule ID 10132 //
     /* 1609575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1609595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609621 */     // MIs[0] policy
     /* 1609621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609631 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1609634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609655 */     // GIR_Coverage, 10132,
     /* 1609655 */     GIR_EraseRootFromParent_Done,
     /* 1609656 */   // Label 22121: @1609656
     /* 1609656 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1609742), // Rule ID 10133 //
     /* 1609661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1609681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609707 */     // MIs[0] policy
     /* 1609707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609717 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1609720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609741 */     // GIR_Coverage, 10133,
     /* 1609741 */     GIR_EraseRootFromParent_Done,
     /* 1609742 */   // Label 22122: @1609742
     /* 1609742 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1609828), // Rule ID 10136 //
     /* 1609747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1609767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609793 */     // MIs[0] policy
     /* 1609793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609803 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1609806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609827 */     // GIR_Coverage, 10136,
     /* 1609827 */     GIR_EraseRootFromParent_Done,
     /* 1609828 */   // Label 22123: @1609828
     /* 1609828 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1609914), // Rule ID 10137 //
     /* 1609833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1609853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609879 */     // MIs[0] policy
     /* 1609879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609889 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1609892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609913 */     // GIR_Coverage, 10137,
     /* 1609913 */     GIR_EraseRootFromParent_Done,
     /* 1609914 */   // Label 22124: @1609914
     /* 1609914 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1610000), // Rule ID 10140 //
     /* 1609919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1609927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1609939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609965 */     // MIs[0] policy
     /* 1609965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1609978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609999 */     // GIR_Coverage, 10140,
     /* 1609999 */     GIR_EraseRootFromParent_Done,
     /* 1610000 */   // Label 22125: @1610000
     /* 1610000 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1610086), // Rule ID 10141 //
     /* 1610005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1610016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1610019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1610025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610051 */     // MIs[0] policy
     /* 1610051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1610064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610085 */     // GIR_Coverage, 10141,
     /* 1610085 */     GIR_EraseRootFromParent_Done,
     /* 1610086 */   // Label 22126: @1610086
     /* 1610086 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1610172), // Rule ID 10144 //
     /* 1610091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1610094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1610111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610137 */     // MIs[0] policy
     /* 1610137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610147 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1610150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610171 */     // GIR_Coverage, 10144,
     /* 1610171 */     GIR_EraseRootFromParent_Done,
     /* 1610172 */   // Label 22127: @1610172
     /* 1610172 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1610258), // Rule ID 10145 //
     /* 1610177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1610197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610223 */     // MIs[0] policy
     /* 1610223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610233 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1610236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610257 */     // GIR_Coverage, 10145,
     /* 1610257 */     GIR_EraseRootFromParent_Done,
     /* 1610258 */   // Label 22128: @1610258
     /* 1610258 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1610344), // Rule ID 10148 //
     /* 1610263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1610283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610309 */     // MIs[0] policy
     /* 1610309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1610322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610343 */     // GIR_Coverage, 10148,
     /* 1610343 */     GIR_EraseRootFromParent_Done,
     /* 1610344 */   // Label 22129: @1610344
     /* 1610344 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1610430), // Rule ID 10149 //
     /* 1610349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1610369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610395 */     // MIs[0] policy
     /* 1610395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1610408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610429 */     // GIR_Coverage, 10149,
     /* 1610429 */     GIR_EraseRootFromParent_Done,
     /* 1610430 */   // Label 22130: @1610430
     /* 1610430 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1610516), // Rule ID 10152 //
     /* 1610435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1610455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610481 */     // MIs[0] policy
     /* 1610481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610491 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1610494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610515 */     // GIR_Coverage, 10152,
     /* 1610515 */     GIR_EraseRootFromParent_Done,
     /* 1610516 */   // Label 22131: @1610516
     /* 1610516 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1610602), // Rule ID 10153 //
     /* 1610521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1610541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610567 */     // MIs[0] policy
     /* 1610567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610577 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1610580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610601 */     // GIR_Coverage, 10153,
     /* 1610601 */     GIR_EraseRootFromParent_Done,
     /* 1610602 */   // Label 22132: @1610602
     /* 1610602 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1610688), // Rule ID 10156 //
     /* 1610607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1610627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610653 */     // MIs[0] policy
     /* 1610653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610663 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1610666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610687 */     // GIR_Coverage, 10156,
     /* 1610687 */     GIR_EraseRootFromParent_Done,
     /* 1610688 */   // Label 22133: @1610688
     /* 1610688 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1610774), // Rule ID 10157 //
     /* 1610693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1610713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610739 */     // MIs[0] policy
     /* 1610739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610749 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1610752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610773 */     // GIR_Coverage, 10157,
     /* 1610773 */     GIR_EraseRootFromParent_Done,
     /* 1610774 */   // Label 22134: @1610774
     /* 1610774 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1610860), // Rule ID 10160 //
     /* 1610779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1610799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610825 */     // MIs[0] policy
     /* 1610825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1610838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610859 */     // GIR_Coverage, 10160,
     /* 1610859 */     GIR_EraseRootFromParent_Done,
     /* 1610860 */   // Label 22135: @1610860
     /* 1610860 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1610946), // Rule ID 10161 //
     /* 1610865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1610885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610911 */     // MIs[0] policy
     /* 1610911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1610924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610945 */     // GIR_Coverage, 10161,
     /* 1610945 */     GIR_EraseRootFromParent_Done,
     /* 1610946 */   // Label 22136: @1610946
     /* 1610946 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1611032), // Rule ID 10164 //
     /* 1610951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1610959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1610971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610997 */     // MIs[0] policy
     /* 1610997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611007 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1611010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611031 */     // GIR_Coverage, 10164,
     /* 1611031 */     GIR_EraseRootFromParent_Done,
     /* 1611032 */   // Label 22137: @1611032
     /* 1611032 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1611118), // Rule ID 10165 //
     /* 1611037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1611057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611083 */     // MIs[0] policy
     /* 1611083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1611096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611117 */     // GIR_Coverage, 10165,
     /* 1611117 */     GIR_EraseRootFromParent_Done,
     /* 1611118 */   // Label 22138: @1611118
     /* 1611118 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1611204), // Rule ID 10168 //
     /* 1611123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1611143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611169 */     // MIs[0] policy
     /* 1611169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611179 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1611182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611203 */     // GIR_Coverage, 10168,
     /* 1611203 */     GIR_EraseRootFromParent_Done,
     /* 1611204 */   // Label 22139: @1611204
     /* 1611204 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1611290), // Rule ID 10169 //
     /* 1611209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1611229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611255 */     // MIs[0] policy
     /* 1611255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611265 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1611268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611289 */     // GIR_Coverage, 10169,
     /* 1611289 */     GIR_EraseRootFromParent_Done,
     /* 1611290 */   // Label 22140: @1611290
     /* 1611290 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1611376), // Rule ID 10172 //
     /* 1611295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1611315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611341 */     // MIs[0] policy
     /* 1611341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1611354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611375 */     // GIR_Coverage, 10172,
     /* 1611375 */     GIR_EraseRootFromParent_Done,
     /* 1611376 */   // Label 22141: @1611376
     /* 1611376 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1611462), // Rule ID 10173 //
     /* 1611381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1611401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611427 */     // MIs[0] policy
     /* 1611427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1611440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611461 */     // GIR_Coverage, 10173,
     /* 1611461 */     GIR_EraseRootFromParent_Done,
     /* 1611462 */   // Label 22142: @1611462
     /* 1611462 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1611548), // Rule ID 10176 //
     /* 1611467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1611487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611513 */     // MIs[0] policy
     /* 1611513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611523 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1611526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611547 */     // GIR_Coverage, 10176,
     /* 1611547 */     GIR_EraseRootFromParent_Done,
     /* 1611548 */   // Label 22143: @1611548
     /* 1611548 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1611634), // Rule ID 10177 //
     /* 1611553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1611573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611599 */     // MIs[0] policy
     /* 1611599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1611612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611633 */     // GIR_Coverage, 10177,
     /* 1611633 */     GIR_EraseRootFromParent_Done,
     /* 1611634 */   // Label 22144: @1611634
     /* 1611634 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1611720), // Rule ID 10180 //
     /* 1611639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1611659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611685 */     // MIs[0] policy
     /* 1611685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611695 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1611698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611719 */     // GIR_Coverage, 10180,
     /* 1611719 */     GIR_EraseRootFromParent_Done,
     /* 1611720 */   // Label 22145: @1611720
     /* 1611720 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1611806), // Rule ID 10181 //
     /* 1611725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1611745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611771 */     // MIs[0] policy
     /* 1611771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1611784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611805 */     // GIR_Coverage, 10181,
     /* 1611805 */     GIR_EraseRootFromParent_Done,
     /* 1611806 */   // Label 22146: @1611806
     /* 1611806 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1611892), // Rule ID 10184 //
     /* 1611811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1611831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611857 */     // MIs[0] policy
     /* 1611857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1611870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611891 */     // GIR_Coverage, 10184,
     /* 1611891 */     GIR_EraseRootFromParent_Done,
     /* 1611892 */   // Label 22147: @1611892
     /* 1611892 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1611978), // Rule ID 10185 //
     /* 1611897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1611917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611943 */     // MIs[0] policy
     /* 1611943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1611956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611977 */     // GIR_Coverage, 10185,
     /* 1611977 */     GIR_EraseRootFromParent_Done,
     /* 1611978 */   // Label 22148: @1611978
     /* 1611978 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1612064), // Rule ID 10188 //
     /* 1611983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1611991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1612003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612029 */     // MIs[0] policy
     /* 1612029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1612042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612063 */     // GIR_Coverage, 10188,
     /* 1612063 */     GIR_EraseRootFromParent_Done,
     /* 1612064 */   // Label 22149: @1612064
     /* 1612064 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1612150), // Rule ID 10189 //
     /* 1612069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1612089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612115 */     // MIs[0] policy
     /* 1612115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612125 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1612128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612149 */     // GIR_Coverage, 10189,
     /* 1612149 */     GIR_EraseRootFromParent_Done,
     /* 1612150 */   // Label 22150: @1612150
     /* 1612150 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1612236), // Rule ID 10192 //
     /* 1612155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1612175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612201 */     // MIs[0] policy
     /* 1612201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1612214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612235 */     // GIR_Coverage, 10192,
     /* 1612235 */     GIR_EraseRootFromParent_Done,
     /* 1612236 */   // Label 22151: @1612236
     /* 1612236 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1612322), // Rule ID 10193 //
     /* 1612241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1612261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612287 */     // MIs[0] policy
     /* 1612287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612297 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1612300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612321 */     // GIR_Coverage, 10193,
     /* 1612321 */     GIR_EraseRootFromParent_Done,
     /* 1612322 */   // Label 22152: @1612322
     /* 1612322 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1612408), // Rule ID 10196 //
     /* 1612327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1612338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1612341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612373 */     // MIs[0] policy
     /* 1612373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612383 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1612386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612407 */     // GIR_Coverage, 10196,
     /* 1612407 */     GIR_EraseRootFromParent_Done,
     /* 1612408 */   // Label 22153: @1612408
     /* 1612408 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1612494), // Rule ID 10197 //
     /* 1612413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1612424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1612427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612459 */     // MIs[0] policy
     /* 1612459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1612472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612493 */     // GIR_Coverage, 10197,
     /* 1612493 */     GIR_EraseRootFromParent_Done,
     /* 1612494 */   // Label 22154: @1612494
     /* 1612494 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1612580), // Rule ID 10200 //
     /* 1612499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1612510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1612513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612545 */     // MIs[0] policy
     /* 1612545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612555 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1612558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612579 */     // GIR_Coverage, 10200,
     /* 1612579 */     GIR_EraseRootFromParent_Done,
     /* 1612580 */   // Label 22155: @1612580
     /* 1612580 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1612666), // Rule ID 10201 //
     /* 1612585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1612596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1612599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612631 */     // MIs[0] policy
     /* 1612631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612641 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1612644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612665 */     // GIR_Coverage, 10201,
     /* 1612665 */     GIR_EraseRootFromParent_Done,
     /* 1612666 */   // Label 22156: @1612666
     /* 1612666 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1612752), // Rule ID 10204 //
     /* 1612671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1612682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1612685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612717 */     // MIs[0] policy
     /* 1612717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1612730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612751 */     // GIR_Coverage, 10204,
     /* 1612751 */     GIR_EraseRootFromParent_Done,
     /* 1612752 */   // Label 22157: @1612752
     /* 1612752 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1612838), // Rule ID 10205 //
     /* 1612757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1612768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1612771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612803 */     // MIs[0] policy
     /* 1612803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612813 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1612816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612837 */     // GIR_Coverage, 10205,
     /* 1612837 */     GIR_EraseRootFromParent_Done,
     /* 1612838 */   // Label 22158: @1612838
     /* 1612838 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1612924), // Rule ID 10208 //
     /* 1612843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1612860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612889 */     // MIs[0] policy
     /* 1612889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612899 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1612902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612923 */     // GIR_Coverage, 10208,
     /* 1612923 */     GIR_EraseRootFromParent_Done,
     /* 1612924 */   // Label 22159: @1612924
     /* 1612924 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1613010), // Rule ID 10209 //
     /* 1612929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1612937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1612946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612975 */     // MIs[0] policy
     /* 1612975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612985 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1612988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613009 */     // GIR_Coverage, 10209,
     /* 1613009 */     GIR_EraseRootFromParent_Done,
     /* 1613010 */   // Label 22160: @1613010
     /* 1613010 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1613096), // Rule ID 10212 //
     /* 1613015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1613026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1613029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613061 */     // MIs[0] policy
     /* 1613061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1613074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613095 */     // GIR_Coverage, 10212,
     /* 1613095 */     GIR_EraseRootFromParent_Done,
     /* 1613096 */   // Label 22161: @1613096
     /* 1613096 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1613182), // Rule ID 10213 //
     /* 1613101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1613112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1613115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613147 */     // MIs[0] policy
     /* 1613147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613157 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1613160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613181 */     // GIR_Coverage, 10213,
     /* 1613181 */     GIR_EraseRootFromParent_Done,
     /* 1613182 */   // Label 22162: @1613182
     /* 1613182 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1613268), // Rule ID 10216 //
     /* 1613187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1613204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613233 */     // MIs[0] policy
     /* 1613233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1613246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613267 */     // GIR_Coverage, 10216,
     /* 1613267 */     GIR_EraseRootFromParent_Done,
     /* 1613268 */   // Label 22163: @1613268
     /* 1613268 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1613354), // Rule ID 10217 //
     /* 1613273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1613290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613319 */     // MIs[0] policy
     /* 1613319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613329 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1613332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613353 */     // GIR_Coverage, 10217,
     /* 1613353 */     GIR_EraseRootFromParent_Done,
     /* 1613354 */   // Label 22164: @1613354
     /* 1613354 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1613440), // Rule ID 10220 //
     /* 1613359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1613370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1613373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613405 */     // MIs[0] policy
     /* 1613405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613415 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613439 */     // GIR_Coverage, 10220,
     /* 1613439 */     GIR_EraseRootFromParent_Done,
     /* 1613440 */   // Label 22165: @1613440
     /* 1613440 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1613526), // Rule ID 10221 //
     /* 1613445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1613456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1613459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613491 */     // MIs[0] policy
     /* 1613491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613525 */     // GIR_Coverage, 10221,
     /* 1613525 */     GIR_EraseRootFromParent_Done,
     /* 1613526 */   // Label 22166: @1613526
     /* 1613526 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1613612), // Rule ID 10224 //
     /* 1613531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613577 */     // MIs[0] policy
     /* 1613577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613587 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613611 */     // GIR_Coverage, 10224,
     /* 1613611 */     GIR_EraseRootFromParent_Done,
     /* 1613612 */   // Label 22167: @1613612
     /* 1613612 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1613698), // Rule ID 10225 //
     /* 1613617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613663 */     // MIs[0] policy
     /* 1613663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613673 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613697 */     // GIR_Coverage, 10225,
     /* 1613697 */     GIR_EraseRootFromParent_Done,
     /* 1613698 */   // Label 22168: @1613698
     /* 1613698 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1613784), // Rule ID 10228 //
     /* 1613703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1613720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613749 */     // MIs[0] policy
     /* 1613749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613783 */     // GIR_Coverage, 10228,
     /* 1613783 */     GIR_EraseRootFromParent_Done,
     /* 1613784 */   // Label 22169: @1613784
     /* 1613784 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1613870), // Rule ID 10229 //
     /* 1613789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1613806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613835 */     // MIs[0] policy
     /* 1613835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613869 */     // GIR_Coverage, 10229,
     /* 1613869 */     GIR_EraseRootFromParent_Done,
     /* 1613870 */   // Label 22170: @1613870
     /* 1613870 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1613956), // Rule ID 10232 //
     /* 1613875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1613878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1613886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1613889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1613892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613921 */     // MIs[0] policy
     /* 1613921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1613934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1613952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613955 */     // GIR_Coverage, 10232,
     /* 1613955 */     GIR_EraseRootFromParent_Done,
     /* 1613956 */   // Label 22171: @1613956
     /* 1613956 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1614042), // Rule ID 10233 //
     /* 1613961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1613964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1613969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1613972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1613975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1613978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614007 */     // MIs[0] policy
     /* 1614007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614017 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1614020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1614038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614041 */     // GIR_Coverage, 10233,
     /* 1614041 */     GIR_EraseRootFromParent_Done,
     /* 1614042 */   // Label 22172: @1614042
     /* 1614042 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1614128), // Rule ID 10236 //
     /* 1614047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1614058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1614061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1614064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614093 */     // MIs[0] policy
     /* 1614093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614103 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1614106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614127 */     // GIR_Coverage, 10236,
     /* 1614127 */     GIR_EraseRootFromParent_Done,
     /* 1614128 */   // Label 22173: @1614128
     /* 1614128 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1614214), // Rule ID 10237 //
     /* 1614133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1614144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1614147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1614150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614179 */     // MIs[0] policy
     /* 1614179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1614192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614213 */     // GIR_Coverage, 10237,
     /* 1614213 */     GIR_EraseRootFromParent_Done,
     /* 1614214 */   // Label 22174: @1614214
     /* 1614214 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1614300), // Rule ID 10240 //
     /* 1614219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1614230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1614233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614265 */     // MIs[0] policy
     /* 1614265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614275 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1614278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614299 */     // GIR_Coverage, 10240,
     /* 1614299 */     GIR_EraseRootFromParent_Done,
     /* 1614300 */   // Label 22175: @1614300
     /* 1614300 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1614386), // Rule ID 10241 //
     /* 1614305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1614316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1614319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614351 */     // MIs[0] policy
     /* 1614351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614361 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1614364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614385 */     // GIR_Coverage, 10241,
     /* 1614385 */     GIR_EraseRootFromParent_Done,
     /* 1614386 */   // Label 22176: @1614386
     /* 1614386 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1614472), // Rule ID 10244 //
     /* 1614391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1614402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1614405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1614408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1614414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614437 */     // MIs[0] policy
     /* 1614437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614447 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1614450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614471 */     // GIR_Coverage, 10244,
     /* 1614471 */     GIR_EraseRootFromParent_Done,
     /* 1614472 */   // Label 22177: @1614472
     /* 1614472 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1614558), // Rule ID 10245 //
     /* 1614477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1614488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1614491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1614494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1614500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614523 */     // MIs[0] policy
     /* 1614523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614533 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1614536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614557 */     // GIR_Coverage, 10245,
     /* 1614557 */     GIR_EraseRootFromParent_Done,
     /* 1614558 */   // Label 22178: @1614558
     /* 1614558 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1614644), // Rule ID 10248 //
     /* 1614563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1614574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1614577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614609 */     // MIs[0] policy
     /* 1614609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1614622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614643 */     // GIR_Coverage, 10248,
     /* 1614643 */     GIR_EraseRootFromParent_Done,
     /* 1614644 */   // Label 22179: @1614644
     /* 1614644 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1614730), // Rule ID 10249 //
     /* 1614649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1614660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1614663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614695 */     // MIs[0] policy
     /* 1614695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614705 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1614708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614729 */     // GIR_Coverage, 10249,
     /* 1614729 */     GIR_EraseRootFromParent_Done,
     /* 1614730 */   // Label 22180: @1614730
     /* 1614730 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1614816), // Rule ID 10252 //
     /* 1614735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614781 */     // MIs[0] policy
     /* 1614781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614791 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1614794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614815 */     // GIR_Coverage, 10252,
     /* 1614815 */     GIR_EraseRootFromParent_Done,
     /* 1614816 */   // Label 22181: @1614816
     /* 1614816 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1614902), // Rule ID 10253 //
     /* 1614821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614867 */     // MIs[0] policy
     /* 1614867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614877 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1614880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614901 */     // GIR_Coverage, 10253,
     /* 1614901 */     GIR_EraseRootFromParent_Done,
     /* 1614902 */   // Label 22182: @1614902
     /* 1614902 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1614988), // Rule ID 10256 //
     /* 1614907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1614915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1614918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1614921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1614924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614953 */     // MIs[0] policy
     /* 1614953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614963 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1614966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614987 */     // GIR_Coverage, 10256,
     /* 1614987 */     GIR_EraseRootFromParent_Done,
     /* 1614988 */   // Label 22183: @1614988
     /* 1614988 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1615074), // Rule ID 10257 //
     /* 1614993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1615010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615039 */     // MIs[0] policy
     /* 1615039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615049 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1615052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615073 */     // GIR_Coverage, 10257,
     /* 1615073 */     GIR_EraseRootFromParent_Done,
     /* 1615074 */   // Label 22184: @1615074
     /* 1615074 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1615160), // Rule ID 10260 //
     /* 1615079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1615090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1615093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615125 */     // MIs[0] policy
     /* 1615125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1615138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615159 */     // GIR_Coverage, 10260,
     /* 1615159 */     GIR_EraseRootFromParent_Done,
     /* 1615160 */   // Label 22185: @1615160
     /* 1615160 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1615246), // Rule ID 10261 //
     /* 1615165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1615176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1615179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615211 */     // MIs[0] policy
     /* 1615211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1615224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615245 */     // GIR_Coverage, 10261,
     /* 1615245 */     GIR_EraseRootFromParent_Done,
     /* 1615246 */   // Label 22186: @1615246
     /* 1615246 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1615332), // Rule ID 10264 //
     /* 1615251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1615262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1615265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615297 */     // MIs[0] policy
     /* 1615297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615307 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1615310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615331 */     // GIR_Coverage, 10264,
     /* 1615331 */     GIR_EraseRootFromParent_Done,
     /* 1615332 */   // Label 22187: @1615332
     /* 1615332 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1615418), // Rule ID 10265 //
     /* 1615337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1615348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1615351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615383 */     // MIs[0] policy
     /* 1615383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615393 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1615396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615417 */     // GIR_Coverage, 10265,
     /* 1615417 */     GIR_EraseRootFromParent_Done,
     /* 1615418 */   // Label 22188: @1615418
     /* 1615418 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1615504), // Rule ID 10268 //
     /* 1615423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1615440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615469 */     // MIs[0] policy
     /* 1615469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615479 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1615482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615503 */     // GIR_Coverage, 10268,
     /* 1615503 */     GIR_EraseRootFromParent_Done,
     /* 1615504 */   // Label 22189: @1615504
     /* 1615504 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1615590), // Rule ID 10269 //
     /* 1615509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1615526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615555 */     // MIs[0] policy
     /* 1615555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615565 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1615568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615589 */     // GIR_Coverage, 10269,
     /* 1615589 */     GIR_EraseRootFromParent_Done,
     /* 1615590 */   // Label 22190: @1615590
     /* 1615590 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1615676), // Rule ID 10272 //
     /* 1615595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1615612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615641 */     // MIs[0] policy
     /* 1615641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1615654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615675 */     // GIR_Coverage, 10272,
     /* 1615675 */     GIR_EraseRootFromParent_Done,
     /* 1615676 */   // Label 22191: @1615676
     /* 1615676 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1615762), // Rule ID 10273 //
     /* 1615681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1615684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1615698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615727 */     // MIs[0] policy
     /* 1615727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1615740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615761 */     // GIR_Coverage, 10273,
     /* 1615761 */     GIR_EraseRootFromParent_Done,
     /* 1615762 */   // Label 22192: @1615762
     /* 1615762 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1615848), // Rule ID 10276 //
     /* 1615767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1615784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615813 */     // MIs[0] policy
     /* 1615813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615823 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1615826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615847 */     // GIR_Coverage, 10276,
     /* 1615847 */     GIR_EraseRootFromParent_Done,
     /* 1615848 */   // Label 22193: @1615848
     /* 1615848 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1615934), // Rule ID 10277 //
     /* 1615853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1615856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1615870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615899 */     // MIs[0] policy
     /* 1615899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1615912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615933 */     // GIR_Coverage, 10277,
     /* 1615933 */     GIR_EraseRootFromParent_Done,
     /* 1615934 */   // Label 22194: @1615934
     /* 1615934 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1616020), // Rule ID 10280 //
     /* 1615939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1615947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1615956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615985 */     // MIs[0] policy
     /* 1615985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1615998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1616016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616019 */     // GIR_Coverage, 10280,
     /* 1616019 */     GIR_EraseRootFromParent_Done,
     /* 1616020 */   // Label 22195: @1616020
     /* 1616020 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1616106), // Rule ID 10281 //
     /* 1616025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1616028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1616033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1616036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1616039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1616042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616071 */     // MIs[0] policy
     /* 1616071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616081 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1616084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1616102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616105 */     // GIR_Coverage, 10281,
     /* 1616105 */     GIR_EraseRootFromParent_Done,
     /* 1616106 */   // Label 22196: @1616106
     /* 1616106 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1616192), // Rule ID 10284 //
     /* 1616111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1616122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1616125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1616128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1616131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616157 */     // MIs[0] policy
     /* 1616157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1616170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616191 */     // GIR_Coverage, 10284,
     /* 1616191 */     GIR_EraseRootFromParent_Done,
     /* 1616192 */   // Label 22197: @1616192
     /* 1616192 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1616278), // Rule ID 10285 //
     /* 1616197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1616208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1616211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1616214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1616217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616243 */     // MIs[0] policy
     /* 1616243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616253 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1616256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616277 */     // GIR_Coverage, 10285,
     /* 1616277 */     GIR_EraseRootFromParent_Done,
     /* 1616278 */   // Label 22198: @1616278
     /* 1616278 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1616364), // Rule ID 10288 //
     /* 1616283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1616294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1616297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616329 */     // MIs[0] policy
     /* 1616329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616339 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1616342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616363 */     // GIR_Coverage, 10288,
     /* 1616363 */     GIR_EraseRootFromParent_Done,
     /* 1616364 */   // Label 22199: @1616364
     /* 1616364 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1616450), // Rule ID 10289 //
     /* 1616369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1616380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1616383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616415 */     // MIs[0] policy
     /* 1616415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616425 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1616428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616449 */     // GIR_Coverage, 10289,
     /* 1616449 */     GIR_EraseRootFromParent_Done,
     /* 1616450 */   // Label 22200: @1616450
     /* 1616450 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1616536), // Rule ID 10292 //
     /* 1616455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1616466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1616469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616501 */     // MIs[0] policy
     /* 1616501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616511 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1616514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616535 */     // GIR_Coverage, 10292,
     /* 1616535 */     GIR_EraseRootFromParent_Done,
     /* 1616536 */   // Label 22201: @1616536
     /* 1616536 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1616622), // Rule ID 10293 //
     /* 1616541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1616552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1616555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616587 */     // MIs[0] policy
     /* 1616587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616597 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1616600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616621 */     // GIR_Coverage, 10293,
     /* 1616621 */     GIR_EraseRootFromParent_Done,
     /* 1616622 */   // Label 22202: @1616622
     /* 1616622 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1616708), // Rule ID 10296 //
     /* 1616627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1616638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1616641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1616647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616673 */     // MIs[0] policy
     /* 1616673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616683 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1616686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616707 */     // GIR_Coverage, 10296,
     /* 1616707 */     GIR_EraseRootFromParent_Done,
     /* 1616708 */   // Label 22203: @1616708
     /* 1616708 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1616794), // Rule ID 10297 //
     /* 1616713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1616724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1616727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1616733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616759 */     // MIs[0] policy
     /* 1616759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1616772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616793 */     // GIR_Coverage, 10297,
     /* 1616793 */     GIR_EraseRootFromParent_Done,
     /* 1616794 */   // Label 22204: @1616794
     /* 1616794 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1616880), // Rule ID 10300 //
     /* 1616799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1616819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616845 */     // MIs[0] policy
     /* 1616845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616855 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1616858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616879 */     // GIR_Coverage, 10300,
     /* 1616879 */     GIR_EraseRootFromParent_Done,
     /* 1616880 */   // Label 22205: @1616880
     /* 1616880 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1616966), // Rule ID 10301 //
     /* 1616885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1616905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616931 */     // MIs[0] policy
     /* 1616931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616941 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1616944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616965 */     // GIR_Coverage, 10301,
     /* 1616965 */     GIR_EraseRootFromParent_Done,
     /* 1616966 */   // Label 22206: @1616966
     /* 1616966 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1617052), // Rule ID 10304 //
     /* 1616971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1616979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1616988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1616991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617017 */     // MIs[0] policy
     /* 1617017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1617030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617051 */     // GIR_Coverage, 10304,
     /* 1617051 */     GIR_EraseRootFromParent_Done,
     /* 1617052 */   // Label 22207: @1617052
     /* 1617052 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1617138), // Rule ID 10305 //
     /* 1617057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1617068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1617071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617103 */     // MIs[0] policy
     /* 1617103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617113 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1617116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617137 */     // GIR_Coverage, 10305,
     /* 1617137 */     GIR_EraseRootFromParent_Done,
     /* 1617138 */   // Label 22208: @1617138
     /* 1617138 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1617224), // Rule ID 10308 //
     /* 1617143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1617154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1617157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617189 */     // MIs[0] policy
     /* 1617189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617223 */     // GIR_Coverage, 10308,
     /* 1617223 */     GIR_EraseRootFromParent_Done,
     /* 1617224 */   // Label 22209: @1617224
     /* 1617224 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1617310), // Rule ID 10309 //
     /* 1617229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1617240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1617243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617275 */     // MIs[0] policy
     /* 1617275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617285 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617309 */     // GIR_Coverage, 10309,
     /* 1617309 */     GIR_EraseRootFromParent_Done,
     /* 1617310 */   // Label 22210: @1617310
     /* 1617310 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1617396), // Rule ID 10312 //
     /* 1617315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617361 */     // MIs[0] policy
     /* 1617361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617371 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617395 */     // GIR_Coverage, 10312,
     /* 1617395 */     GIR_EraseRootFromParent_Done,
     /* 1617396 */   // Label 22211: @1617396
     /* 1617396 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1617482), // Rule ID 10313 //
     /* 1617401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617447 */     // MIs[0] policy
     /* 1617447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617481 */     // GIR_Coverage, 10313,
     /* 1617481 */     GIR_EraseRootFromParent_Done,
     /* 1617482 */   // Label 22212: @1617482
     /* 1617482 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1617568), // Rule ID 10316 //
     /* 1617487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1617507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617533 */     // MIs[0] policy
     /* 1617533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617543 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617567 */     // GIR_Coverage, 10316,
     /* 1617567 */     GIR_EraseRootFromParent_Done,
     /* 1617568 */   // Label 22213: @1617568
     /* 1617568 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1617654), // Rule ID 10317 //
     /* 1617573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1617593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617619 */     // MIs[0] policy
     /* 1617619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617629 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617653 */     // GIR_Coverage, 10317,
     /* 1617653 */     GIR_EraseRootFromParent_Done,
     /* 1617654 */   // Label 22214: @1617654
     /* 1617654 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1617740), // Rule ID 10320 //
     /* 1617659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1617662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1617676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1617679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617705 */     // MIs[0] policy
     /* 1617705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1617736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617739 */     // GIR_Coverage, 10320,
     /* 1617739 */     GIR_EraseRootFromParent_Done,
     /* 1617740 */   // Label 22215: @1617740
     /* 1617740 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1617826), // Rule ID 10321 //
     /* 1617745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1617748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1617762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1617765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617791 */     // MIs[0] policy
     /* 1617791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1617804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1617822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617825 */     // GIR_Coverage, 10321,
     /* 1617825 */     GIR_EraseRootFromParent_Done,
     /* 1617826 */   // Label 22216: @1617826
     /* 1617826 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1617912), // Rule ID 10324 //
     /* 1617831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1617842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1617845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1617848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1617851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617877 */     // MIs[0] policy
     /* 1617877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617887 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1617890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617911 */     // GIR_Coverage, 10324,
     /* 1617911 */     GIR_EraseRootFromParent_Done,
     /* 1617912 */   // Label 22217: @1617912
     /* 1617912 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1617998), // Rule ID 10325 //
     /* 1617917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1617925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1617928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1617931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1617934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1617937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617963 */     // MIs[0] policy
     /* 1617963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617973 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1617976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617997 */     // GIR_Coverage, 10325,
     /* 1617997 */     GIR_EraseRootFromParent_Done,
     /* 1617998 */   // Label 22218: @1617998
     /* 1617998 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1618084), // Rule ID 10328 //
     /* 1618003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1618014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1618017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618049 */     // MIs[0] policy
     /* 1618049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618059 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1618062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618083 */     // GIR_Coverage, 10328,
     /* 1618083 */     GIR_EraseRootFromParent_Done,
     /* 1618084 */   // Label 22219: @1618084
     /* 1618084 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1618170), // Rule ID 10329 //
     /* 1618089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1618100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1618103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618135 */     // MIs[0] policy
     /* 1618135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618145 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1618148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618169 */     // GIR_Coverage, 10329,
     /* 1618169 */     GIR_EraseRootFromParent_Done,
     /* 1618170 */   // Label 22220: @1618170
     /* 1618170 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1618256), // Rule ID 10332 //
     /* 1618175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1618186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1618189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1618192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1618195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1618198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618221 */     // MIs[0] policy
     /* 1618221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618231 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1618234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618255 */     // GIR_Coverage, 10332,
     /* 1618255 */     GIR_EraseRootFromParent_Done,
     /* 1618256 */   // Label 22221: @1618256
     /* 1618256 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1618342), // Rule ID 10333 //
     /* 1618261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1618272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1618275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1618278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1618281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1618284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618307 */     // MIs[0] policy
     /* 1618307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618317 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1618320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618341 */     // GIR_Coverage, 10333,
     /* 1618341 */     GIR_EraseRootFromParent_Done,
     /* 1618342 */   // Label 22222: @1618342
     /* 1618342 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1618428), // Rule ID 10336 //
     /* 1618347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1618364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1618367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618393 */     // MIs[0] policy
     /* 1618393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1618406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618427 */     // GIR_Coverage, 10336,
     /* 1618427 */     GIR_EraseRootFromParent_Done,
     /* 1618428 */   // Label 22223: @1618428
     /* 1618428 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1618514), // Rule ID 10337 //
     /* 1618433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1618450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1618453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618479 */     // MIs[0] policy
     /* 1618479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1618492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618513 */     // GIR_Coverage, 10337,
     /* 1618513 */     GIR_EraseRootFromParent_Done,
     /* 1618514 */   // Label 22224: @1618514
     /* 1618514 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1618600), // Rule ID 10340 //
     /* 1618519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1618536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1618539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618565 */     // MIs[0] policy
     /* 1618565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618575 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1618578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618599 */     // GIR_Coverage, 10340,
     /* 1618599 */     GIR_EraseRootFromParent_Done,
     /* 1618600 */   // Label 22225: @1618600
     /* 1618600 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1618686), // Rule ID 10341 //
     /* 1618605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1618622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1618625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618651 */     // MIs[0] policy
     /* 1618651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618661 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1618664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618685 */     // GIR_Coverage, 10341,
     /* 1618685 */     GIR_EraseRootFromParent_Done,
     /* 1618686 */   // Label 22226: @1618686
     /* 1618686 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1618772), // Rule ID 10344 //
     /* 1618691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1618708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1618711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618737 */     // MIs[0] policy
     /* 1618737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618747 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1618750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618771 */     // GIR_Coverage, 10344,
     /* 1618771 */     GIR_EraseRootFromParent_Done,
     /* 1618772 */   // Label 22227: @1618772
     /* 1618772 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1618858), // Rule ID 10345 //
     /* 1618777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1618794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1618797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618823 */     // MIs[0] policy
     /* 1618823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618833 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1618836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618857 */     // GIR_Coverage, 10345,
     /* 1618857 */     GIR_EraseRootFromParent_Done,
     /* 1618858 */   // Label 22228: @1618858
     /* 1618858 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1618944), // Rule ID 10348 //
     /* 1618863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618909 */     // MIs[0] policy
     /* 1618909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1618922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618943 */     // GIR_Coverage, 10348,
     /* 1618943 */     GIR_EraseRootFromParent_Done,
     /* 1618944 */   // Label 22229: @1618944
     /* 1618944 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1619030), // Rule ID 10349 //
     /* 1618949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1618957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618995 */     // MIs[0] policy
     /* 1618995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1619008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619029 */     // GIR_Coverage, 10349,
     /* 1619029 */     GIR_EraseRootFromParent_Done,
     /* 1619030 */   // Label 22230: @1619030
     /* 1619030 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1619116), // Rule ID 10352 //
     /* 1619035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619081 */     // MIs[0] policy
     /* 1619081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1619094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619115 */     // GIR_Coverage, 10352,
     /* 1619115 */     GIR_EraseRootFromParent_Done,
     /* 1619116 */   // Label 22231: @1619116
     /* 1619116 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1619202), // Rule ID 10353 //
     /* 1619121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619167 */     // MIs[0] policy
     /* 1619167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1619180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619201 */     // GIR_Coverage, 10353,
     /* 1619201 */     GIR_EraseRootFromParent_Done,
     /* 1619202 */   // Label 22232: @1619202
     /* 1619202 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1619288), // Rule ID 10356 //
     /* 1619207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1619224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1619227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619253 */     // MIs[0] policy
     /* 1619253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619263 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1619266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619287 */     // GIR_Coverage, 10356,
     /* 1619287 */     GIR_EraseRootFromParent_Done,
     /* 1619288 */   // Label 22233: @1619288
     /* 1619288 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1619374), // Rule ID 10357 //
     /* 1619293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1619310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1619313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619339 */     // MIs[0] policy
     /* 1619339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619349 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1619352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619373 */     // GIR_Coverage, 10357,
     /* 1619373 */     GIR_EraseRootFromParent_Done,
     /* 1619374 */   // Label 22234: @1619374
     /* 1619374 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1619460), // Rule ID 10360 //
     /* 1619379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1619382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1619396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1619399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619425 */     // MIs[0] policy
     /* 1619425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1619438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619459 */     // GIR_Coverage, 10360,
     /* 1619459 */     GIR_EraseRootFromParent_Done,
     /* 1619460 */   // Label 22235: @1619460
     /* 1619460 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1619546), // Rule ID 10361 //
     /* 1619465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1619468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1619482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1619485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619511 */     // MIs[0] policy
     /* 1619511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1619524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619545 */     // GIR_Coverage, 10361,
     /* 1619545 */     GIR_EraseRootFromParent_Done,
     /* 1619546 */   // Label 22236: @1619546
     /* 1619546 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1619632), // Rule ID 10364 //
     /* 1619551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1619554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1619568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1619571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619597 */     // MIs[0] policy
     /* 1619597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619607 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1619610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619631 */     // GIR_Coverage, 10364,
     /* 1619631 */     GIR_EraseRootFromParent_Done,
     /* 1619632 */   // Label 22237: @1619632
     /* 1619632 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1619718), // Rule ID 10365 //
     /* 1619637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1619640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1619654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1619657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619683 */     // MIs[0] policy
     /* 1619683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1619696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619717 */     // GIR_Coverage, 10365,
     /* 1619717 */     GIR_EraseRootFromParent_Done,
     /* 1619718 */   // Label 22238: @1619718
     /* 1619718 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1619804), // Rule ID 10368 //
     /* 1619723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1619726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1619740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1619743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619769 */     // MIs[0] policy
     /* 1619769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619779 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1619782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619803 */     // GIR_Coverage, 10368,
     /* 1619803 */     GIR_EraseRootFromParent_Done,
     /* 1619804 */   // Label 22239: @1619804
     /* 1619804 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1619890), // Rule ID 10369 //
     /* 1619809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1619812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1619826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1619829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619855 */     // MIs[0] policy
     /* 1619855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1619868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1619886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619889 */     // GIR_Coverage, 10369,
     /* 1619889 */     GIR_EraseRootFromParent_Done,
     /* 1619890 */   // Label 22240: @1619890
     /* 1619890 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1619976), // Rule ID 10372 //
     /* 1619895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1619906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1619909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1619912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619941 */     // MIs[0] policy
     /* 1619941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619951 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1619954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619975 */     // GIR_Coverage, 10372,
     /* 1619975 */     GIR_EraseRootFromParent_Done,
     /* 1619976 */   // Label 22241: @1619976
     /* 1619976 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1620062), // Rule ID 10373 //
     /* 1619981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1619989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1619992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1619995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1619998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620027 */     // MIs[0] policy
     /* 1620027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620037 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1620040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620061 */     // GIR_Coverage, 10373,
     /* 1620061 */     GIR_EraseRootFromParent_Done,
     /* 1620062 */   // Label 22242: @1620062
     /* 1620062 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1620148), // Rule ID 10376 //
     /* 1620067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1620078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1620081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620113 */     // MIs[0] policy
     /* 1620113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620123 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1620126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620147 */     // GIR_Coverage, 10376,
     /* 1620147 */     GIR_EraseRootFromParent_Done,
     /* 1620148 */   // Label 22243: @1620148
     /* 1620148 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1620234), // Rule ID 10377 //
     /* 1620153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1620164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1620167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620199 */     // MIs[0] policy
     /* 1620199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1620212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620233 */     // GIR_Coverage, 10377,
     /* 1620233 */     GIR_EraseRootFromParent_Done,
     /* 1620234 */   // Label 22244: @1620234
     /* 1620234 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1620320), // Rule ID 10380 //
     /* 1620239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1620250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1620253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620285 */     // MIs[0] policy
     /* 1620285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620295 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620319 */     // GIR_Coverage, 10380,
     /* 1620319 */     GIR_EraseRootFromParent_Done,
     /* 1620320 */   // Label 22245: @1620320
     /* 1620320 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1620406), // Rule ID 10381 //
     /* 1620325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1620336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1620339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620371 */     // MIs[0] policy
     /* 1620371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620381 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620405 */     // GIR_Coverage, 10381,
     /* 1620405 */     GIR_EraseRootFromParent_Done,
     /* 1620406 */   // Label 22246: @1620406
     /* 1620406 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1620492), // Rule ID 10384 //
     /* 1620411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1620428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620457 */     // MIs[0] policy
     /* 1620457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620467 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1620470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620491 */     // GIR_Coverage, 10384,
     /* 1620491 */     GIR_EraseRootFromParent_Done,
     /* 1620492 */   // Label 22247: @1620492
     /* 1620492 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1620578), // Rule ID 10385 //
     /* 1620497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1620514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620543 */     // MIs[0] policy
     /* 1620543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620553 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1620556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620577 */     // GIR_Coverage, 10385,
     /* 1620577 */     GIR_EraseRootFromParent_Done,
     /* 1620578 */   // Label 22248: @1620578
     /* 1620578 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1620664), // Rule ID 10388 //
     /* 1620583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1620600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620629 */     // MIs[0] policy
     /* 1620629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620663 */     // GIR_Coverage, 10388,
     /* 1620663 */     GIR_EraseRootFromParent_Done,
     /* 1620664 */   // Label 22249: @1620664
     /* 1620664 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1620750), // Rule ID 10389 //
     /* 1620669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1620686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620715 */     // MIs[0] policy
     /* 1620715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620749 */     // GIR_Coverage, 10389,
     /* 1620749 */     GIR_EraseRootFromParent_Done,
     /* 1620750 */   // Label 22250: @1620750
     /* 1620750 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1620836), // Rule ID 10392 //
     /* 1620755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1620766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1620769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620801 */     // MIs[0] policy
     /* 1620801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620835 */     // GIR_Coverage, 10392,
     /* 1620835 */     GIR_EraseRootFromParent_Done,
     /* 1620836 */   // Label 22251: @1620836
     /* 1620836 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1620922), // Rule ID 10393 //
     /* 1620841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1620852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1620855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620887 */     // MIs[0] policy
     /* 1620887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620897 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1620900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620921 */     // GIR_Coverage, 10393,
     /* 1620921 */     GIR_EraseRootFromParent_Done,
     /* 1620922 */   // Label 22252: @1620922
     /* 1620922 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1621008), // Rule ID 10396 //
     /* 1620927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1620935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1620938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1620941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620973 */     // MIs[0] policy
     /* 1620973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1620986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621007 */     // GIR_Coverage, 10396,
     /* 1621007 */     GIR_EraseRootFromParent_Done,
     /* 1621008 */   // Label 22253: @1621008
     /* 1621008 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1621094), // Rule ID 10397 //
     /* 1621013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1621024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1621027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621059 */     // MIs[0] policy
     /* 1621059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621069 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621093 */     // GIR_Coverage, 10397,
     /* 1621093 */     GIR_EraseRootFromParent_Done,
     /* 1621094 */   // Label 22254: @1621094
     /* 1621094 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1621180), // Rule ID 10400 //
     /* 1621099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621145 */     // MIs[0] policy
     /* 1621145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621155 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621179 */     // GIR_Coverage, 10400,
     /* 1621179 */     GIR_EraseRootFromParent_Done,
     /* 1621180 */   // Label 22255: @1621180
     /* 1621180 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1621266), // Rule ID 10401 //
     /* 1621185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621231 */     // MIs[0] policy
     /* 1621231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621241 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621265 */     // GIR_Coverage, 10401,
     /* 1621265 */     GIR_EraseRootFromParent_Done,
     /* 1621266 */   // Label 22256: @1621266
     /* 1621266 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1621352), // Rule ID 10404 //
     /* 1621271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1621288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621317 */     // MIs[0] policy
     /* 1621317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621351 */     // GIR_Coverage, 10404,
     /* 1621351 */     GIR_EraseRootFromParent_Done,
     /* 1621352 */   // Label 22257: @1621352
     /* 1621352 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1621438), // Rule ID 10405 //
     /* 1621357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1621374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621403 */     // MIs[0] policy
     /* 1621403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621437 */     // GIR_Coverage, 10405,
     /* 1621437 */     GIR_EraseRootFromParent_Done,
     /* 1621438 */   // Label 22258: @1621438
     /* 1621438 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1621524), // Rule ID 10408 //
     /* 1621443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1621446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1621460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621489 */     // MIs[0] policy
     /* 1621489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1621520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621523 */     // GIR_Coverage, 10408,
     /* 1621523 */     GIR_EraseRootFromParent_Done,
     /* 1621524 */   // Label 22259: @1621524
     /* 1621524 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1621610), // Rule ID 10409 //
     /* 1621529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1621532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1621546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621575 */     // MIs[0] policy
     /* 1621575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621585 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1621588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1621606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621609 */     // GIR_Coverage, 10409,
     /* 1621609 */     GIR_EraseRootFromParent_Done,
     /* 1621610 */   // Label 22260: @1621610
     /* 1621610 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1621696), // Rule ID 10412 //
     /* 1621615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1621626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1621629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621661 */     // MIs[0] policy
     /* 1621661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1621674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621695 */     // GIR_Coverage, 10412,
     /* 1621695 */     GIR_EraseRootFromParent_Done,
     /* 1621696 */   // Label 22261: @1621696
     /* 1621696 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1621782), // Rule ID 10413 //
     /* 1621701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1621712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1621715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621747 */     // MIs[0] policy
     /* 1621747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1621760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621781 */     // GIR_Coverage, 10413,
     /* 1621781 */     GIR_EraseRootFromParent_Done,
     /* 1621782 */   // Label 22262: @1621782
     /* 1621782 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1621868), // Rule ID 10416 //
     /* 1621787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1621798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1621801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621833 */     // MIs[0] policy
     /* 1621833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621843 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1621846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621867 */     // GIR_Coverage, 10416,
     /* 1621867 */     GIR_EraseRootFromParent_Done,
     /* 1621868 */   // Label 22263: @1621868
     /* 1621868 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1621954), // Rule ID 10417 //
     /* 1621873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1621884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1621887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621919 */     // MIs[0] policy
     /* 1621919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1621932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621953 */     // GIR_Coverage, 10417,
     /* 1621953 */     GIR_EraseRootFromParent_Done,
     /* 1621954 */   // Label 22264: @1621954
     /* 1621954 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1622040), // Rule ID 10420 //
     /* 1621959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1621967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1621970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1621973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1621976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1621982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622005 */     // MIs[0] policy
     /* 1622005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622015 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1622018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622039 */     // GIR_Coverage, 10420,
     /* 1622039 */     GIR_EraseRootFromParent_Done,
     /* 1622040 */   // Label 22265: @1622040
     /* 1622040 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1622126), // Rule ID 10421 //
     /* 1622045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1622056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1622059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1622062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1622068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622091 */     // MIs[0] policy
     /* 1622091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1622104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622125 */     // GIR_Coverage, 10421,
     /* 1622125 */     GIR_EraseRootFromParent_Done,
     /* 1622126 */   // Label 22266: @1622126
     /* 1622126 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1622212), // Rule ID 10424 //
     /* 1622131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1622142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1622145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622177 */     // MIs[0] policy
     /* 1622177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1622190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622211 */     // GIR_Coverage, 10424,
     /* 1622211 */     GIR_EraseRootFromParent_Done,
     /* 1622212 */   // Label 22267: @1622212
     /* 1622212 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1622298), // Rule ID 10425 //
     /* 1622217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1622228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1622231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622263 */     // MIs[0] policy
     /* 1622263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1622276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622297 */     // GIR_Coverage, 10425,
     /* 1622297 */     GIR_EraseRootFromParent_Done,
     /* 1622298 */   // Label 22268: @1622298
     /* 1622298 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1622384), // Rule ID 10428 //
     /* 1622303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1622314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1622317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622349 */     // MIs[0] policy
     /* 1622349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622359 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1622362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622383 */     // GIR_Coverage, 10428,
     /* 1622383 */     GIR_EraseRootFromParent_Done,
     /* 1622384 */   // Label 22269: @1622384
     /* 1622384 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1622470), // Rule ID 10429 //
     /* 1622389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1622400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1622403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622435 */     // MIs[0] policy
     /* 1622435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622445 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1622448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622469 */     // GIR_Coverage, 10429,
     /* 1622469 */     GIR_EraseRootFromParent_Done,
     /* 1622470 */   // Label 22270: @1622470
     /* 1622470 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1622556), // Rule ID 10432 //
     /* 1622475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1622486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1622489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1622492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1622498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622521 */     // MIs[0] policy
     /* 1622521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622531 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1622534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622555 */     // GIR_Coverage, 10432,
     /* 1622555 */     GIR_EraseRootFromParent_Done,
     /* 1622556 */   // Label 22271: @1622556
     /* 1622556 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1622642), // Rule ID 10433 //
     /* 1622561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1622572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1622575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1622578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1622584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622607 */     // MIs[0] policy
     /* 1622607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622617 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1622620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622641 */     // GIR_Coverage, 10433,
     /* 1622641 */     GIR_EraseRootFromParent_Done,
     /* 1622642 */   // Label 22272: @1622642
     /* 1622642 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1622728), // Rule ID 10436 //
     /* 1622647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622693 */     // MIs[0] policy
     /* 1622693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622703 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1622706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622727 */     // GIR_Coverage, 10436,
     /* 1622727 */     GIR_EraseRootFromParent_Done,
     /* 1622728 */   // Label 22273: @1622728
     /* 1622728 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1622814), // Rule ID 10437 //
     /* 1622733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622779 */     // MIs[0] policy
     /* 1622779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1622792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622813 */     // GIR_Coverage, 10437,
     /* 1622813 */     GIR_EraseRootFromParent_Done,
     /* 1622814 */   // Label 22274: @1622814
     /* 1622814 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1622900), // Rule ID 10440 //
     /* 1622819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622865 */     // MIs[0] policy
     /* 1622865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622875 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1622878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622899 */     // GIR_Coverage, 10440,
     /* 1622899 */     GIR_EraseRootFromParent_Done,
     /* 1622900 */   // Label 22275: @1622900
     /* 1622900 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1622986), // Rule ID 10441 //
     /* 1622905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622951 */     // MIs[0] policy
     /* 1622951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1622964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622985 */     // GIR_Coverage, 10441,
     /* 1622985 */     GIR_EraseRootFromParent_Done,
     /* 1622986 */   // Label 22276: @1622986
     /* 1622986 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1623072), // Rule ID 10444 //
     /* 1622991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1622999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1623002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1623005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1623008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623037 */     // MIs[0] policy
     /* 1623037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623047 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1623050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623071 */     // GIR_Coverage, 10444,
     /* 1623071 */     GIR_EraseRootFromParent_Done,
     /* 1623072 */   // Label 22277: @1623072
     /* 1623072 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1623158), // Rule ID 10445 //
     /* 1623077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1623088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1623091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1623094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623123 */     // MIs[0] policy
     /* 1623123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623133 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1623136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623157 */     // GIR_Coverage, 10445,
     /* 1623157 */     GIR_EraseRootFromParent_Done,
     /* 1623158 */   // Label 22278: @1623158
     /* 1623158 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1623244), // Rule ID 10448 //
     /* 1623163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1623166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1623180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623209 */     // MIs[0] policy
     /* 1623209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1623222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623243 */     // GIR_Coverage, 10448,
     /* 1623243 */     GIR_EraseRootFromParent_Done,
     /* 1623244 */   // Label 22279: @1623244
     /* 1623244 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1623330), // Rule ID 10449 //
     /* 1623249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1623252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1623266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623295 */     // MIs[0] policy
     /* 1623295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1623308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623329 */     // GIR_Coverage, 10449,
     /* 1623329 */     GIR_EraseRootFromParent_Done,
     /* 1623330 */   // Label 22280: @1623330
     /* 1623330 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1623416), // Rule ID 10452 //
     /* 1623335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1623338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1623352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623381 */     // MIs[0] policy
     /* 1623381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623391 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1623394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623415 */     // GIR_Coverage, 10452,
     /* 1623415 */     GIR_EraseRootFromParent_Done,
     /* 1623416 */   // Label 22281: @1623416
     /* 1623416 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1623502), // Rule ID 10453 //
     /* 1623421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1623424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1623438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623467 */     // MIs[0] policy
     /* 1623467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1623480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623501 */     // GIR_Coverage, 10453,
     /* 1623501 */     GIR_EraseRootFromParent_Done,
     /* 1623502 */   // Label 22282: @1623502
     /* 1623502 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1623588), // Rule ID 10456 //
     /* 1623507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1623510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1623524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623553 */     // MIs[0] policy
     /* 1623553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623563 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1623566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623587 */     // GIR_Coverage, 10456,
     /* 1623587 */     GIR_EraseRootFromParent_Done,
     /* 1623588 */   // Label 22283: @1623588
     /* 1623588 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1623674), // Rule ID 10457 //
     /* 1623593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1623596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1623601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1623610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623639 */     // MIs[0] policy
     /* 1623639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623649 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1623652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1623670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623673 */     // GIR_Coverage, 10457,
     /* 1623673 */     GIR_EraseRootFromParent_Done,
     /* 1623674 */   // Label 22284: @1623674
     /* 1623674 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1623760), // Rule ID 10460 //
     /* 1623679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1623687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1623690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1623693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1623699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623725 */     // MIs[0] policy
     /* 1623725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623735 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1623738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623759 */     // GIR_Coverage, 10460,
     /* 1623759 */     GIR_EraseRootFromParent_Done,
     /* 1623760 */   // Label 22285: @1623760
     /* 1623760 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1623846), // Rule ID 10461 //
     /* 1623765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1623773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1623776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1623779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1623785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623811 */     // MIs[0] policy
     /* 1623811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1623824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623845 */     // GIR_Coverage, 10461,
     /* 1623845 */     GIR_EraseRootFromParent_Done,
     /* 1623846 */   // Label 22286: @1623846
     /* 1623846 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1623932), // Rule ID 10464 //
     /* 1623851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1623859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1623862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1623865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623897 */     // MIs[0] policy
     /* 1623897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623907 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1623910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623931 */     // GIR_Coverage, 10464,
     /* 1623931 */     GIR_EraseRootFromParent_Done,
     /* 1623932 */   // Label 22287: @1623932
     /* 1623932 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1624018), // Rule ID 10465 //
     /* 1623937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1623945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1623948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1623951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623983 */     // MIs[0] policy
     /* 1623983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623993 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1623996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624017 */     // GIR_Coverage, 10465,
     /* 1624017 */     GIR_EraseRootFromParent_Done,
     /* 1624018 */   // Label 22288: @1624018
     /* 1624018 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1624104), // Rule ID 10468 //
     /* 1624023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1624034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1624037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1624043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624069 */     // MIs[0] policy
     /* 1624069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624079 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624103 */     // GIR_Coverage, 10468,
     /* 1624103 */     GIR_EraseRootFromParent_Done,
     /* 1624104 */   // Label 22289: @1624104
     /* 1624104 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1624190), // Rule ID 10469 //
     /* 1624109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1624120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1624123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1624129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624155 */     // MIs[0] policy
     /* 1624155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624165 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624189 */     // GIR_Coverage, 10469,
     /* 1624189 */     GIR_EraseRootFromParent_Done,
     /* 1624190 */   // Label 22290: @1624190
     /* 1624190 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1624276), // Rule ID 10472 //
     /* 1624195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1624206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1624209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624241 */     // MIs[0] policy
     /* 1624241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624251 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1624254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624275 */     // GIR_Coverage, 10472,
     /* 1624275 */     GIR_EraseRootFromParent_Done,
     /* 1624276 */   // Label 22291: @1624276
     /* 1624276 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1624362), // Rule ID 10473 //
     /* 1624281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1624292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1624295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624327 */     // MIs[0] policy
     /* 1624327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624337 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1624340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624361 */     // GIR_Coverage, 10473,
     /* 1624361 */     GIR_EraseRootFromParent_Done,
     /* 1624362 */   // Label 22292: @1624362
     /* 1624362 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1624448), // Rule ID 10476 //
     /* 1624367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1624378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1624381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624413 */     // MIs[0] policy
     /* 1624413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624423 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624447 */     // GIR_Coverage, 10476,
     /* 1624447 */     GIR_EraseRootFromParent_Done,
     /* 1624448 */   // Label 22293: @1624448
     /* 1624448 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1624534), // Rule ID 10477 //
     /* 1624453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1624464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1624467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624499 */     // MIs[0] policy
     /* 1624499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624509 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624533 */     // GIR_Coverage, 10477,
     /* 1624533 */     GIR_EraseRootFromParent_Done,
     /* 1624534 */   // Label 22294: @1624534
     /* 1624534 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1624620), // Rule ID 10480 //
     /* 1624539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624585 */     // MIs[0] policy
     /* 1624585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624619 */     // GIR_Coverage, 10480,
     /* 1624619 */     GIR_EraseRootFromParent_Done,
     /* 1624620 */   // Label 22295: @1624620
     /* 1624620 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1624706), // Rule ID 10481 //
     /* 1624625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624671 */     // MIs[0] policy
     /* 1624671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1624684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624705 */     // GIR_Coverage, 10481,
     /* 1624705 */     GIR_EraseRootFromParent_Done,
     /* 1624706 */   // Label 22296: @1624706
     /* 1624706 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1624792), // Rule ID 10484 //
     /* 1624711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1624722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1624725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1624731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624757 */     // MIs[0] policy
     /* 1624757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624767 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1624770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624791 */     // GIR_Coverage, 10484,
     /* 1624791 */     GIR_EraseRootFromParent_Done,
     /* 1624792 */   // Label 22297: @1624792
     /* 1624792 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1624878), // Rule ID 10485 //
     /* 1624797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1624808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1624811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1624817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624843 */     // MIs[0] policy
     /* 1624843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624853 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1624856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624877 */     // GIR_Coverage, 10485,
     /* 1624877 */     GIR_EraseRootFromParent_Done,
     /* 1624878 */   // Label 22298: @1624878
     /* 1624878 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1624964), // Rule ID 10488 //
     /* 1624883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624929 */     // MIs[0] policy
     /* 1624929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624939 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1624942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624963 */     // GIR_Coverage, 10488,
     /* 1624963 */     GIR_EraseRootFromParent_Done,
     /* 1624964 */   // Label 22299: @1624964
     /* 1624964 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1625050), // Rule ID 10489 //
     /* 1624969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1624977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625015 */     // MIs[0] policy
     /* 1625015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625025 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1625028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625049 */     // GIR_Coverage, 10489,
     /* 1625049 */     GIR_EraseRootFromParent_Done,
     /* 1625050 */   // Label 22300: @1625050
     /* 1625050 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1625136), // Rule ID 10492 //
     /* 1625055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1625066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1625069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625101 */     // MIs[0] policy
     /* 1625101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625111 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1625114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625135 */     // GIR_Coverage, 10492,
     /* 1625135 */     GIR_EraseRootFromParent_Done,
     /* 1625136 */   // Label 22301: @1625136
     /* 1625136 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1625222), // Rule ID 10493 //
     /* 1625141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1625152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1625155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625187 */     // MIs[0] policy
     /* 1625187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625197 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1625200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625221 */     // GIR_Coverage, 10493,
     /* 1625221 */     GIR_EraseRootFromParent_Done,
     /* 1625222 */   // Label 22302: @1625222
     /* 1625222 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1625308), // Rule ID 10496 //
     /* 1625227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1625230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1625244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1625247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625273 */     // MIs[0] policy
     /* 1625273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625283 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1625286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1625304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625307 */     // GIR_Coverage, 10496,
     /* 1625307 */     GIR_EraseRootFromParent_Done,
     /* 1625308 */   // Label 22303: @1625308
     /* 1625308 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1625394), // Rule ID 10497 //
     /* 1625313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1625316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1625330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1625333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625359 */     // MIs[0] policy
     /* 1625359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625369 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1625372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1625390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625393 */     // GIR_Coverage, 10497,
     /* 1625393 */     GIR_EraseRootFromParent_Done,
     /* 1625394 */   // Label 22304: @1625394
     /* 1625394 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1625480), // Rule ID 10500 //
     /* 1625399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1625410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1625413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1625419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625445 */     // MIs[0] policy
     /* 1625445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625455 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1625458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625479 */     // GIR_Coverage, 10500,
     /* 1625479 */     GIR_EraseRootFromParent_Done,
     /* 1625480 */   // Label 22305: @1625480
     /* 1625480 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1625566), // Rule ID 10501 //
     /* 1625485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1625496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1625499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1625505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625531 */     // MIs[0] policy
     /* 1625531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1625544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625565 */     // GIR_Coverage, 10501,
     /* 1625565 */     GIR_EraseRootFromParent_Done,
     /* 1625566 */   // Label 22306: @1625566
     /* 1625566 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1625652), // Rule ID 10504 //
     /* 1625571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1625582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1625585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1625588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1625591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1625594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625617 */     // MIs[0] policy
     /* 1625617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1625630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625651 */     // GIR_Coverage, 10504,
     /* 1625651 */     GIR_EraseRootFromParent_Done,
     /* 1625652 */   // Label 22307: @1625652
     /* 1625652 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1625738), // Rule ID 10505 //
     /* 1625657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1625668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1625671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1625674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1625677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1625680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625703 */     // MIs[0] policy
     /* 1625703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625713 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1625716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625737 */     // GIR_Coverage, 10505,
     /* 1625737 */     GIR_EraseRootFromParent_Done,
     /* 1625738 */   // Label 22308: @1625738
     /* 1625738 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1625824), // Rule ID 10508 //
     /* 1625743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1625754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1625757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1625760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1625763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1625766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625789 */     // MIs[0] policy
     /* 1625789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625799 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1625802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625823 */     // GIR_Coverage, 10508,
     /* 1625823 */     GIR_EraseRootFromParent_Done,
     /* 1625824 */   // Label 22309: @1625824
     /* 1625824 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1625910), // Rule ID 10509 //
     /* 1625829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1625840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1625843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1625846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1625849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1625852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625875 */     // MIs[0] policy
     /* 1625875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625885 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1625888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625909 */     // GIR_Coverage, 10509,
     /* 1625909 */     GIR_EraseRootFromParent_Done,
     /* 1625910 */   // Label 22310: @1625910
     /* 1625910 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1625996), // Rule ID 10512 //
     /* 1625915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1625923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1625932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1625935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625961 */     // MIs[0] policy
     /* 1625961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1625974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625995 */     // GIR_Coverage, 10512,
     /* 1625995 */     GIR_EraseRootFromParent_Done,
     /* 1625996 */   // Label 22311: @1625996
     /* 1625996 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1626082), // Rule ID 10513 //
     /* 1626001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1626021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626047 */     // MIs[0] policy
     /* 1626047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1626060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626081 */     // GIR_Coverage, 10513,
     /* 1626081 */     GIR_EraseRootFromParent_Done,
     /* 1626082 */   // Label 22312: @1626082
     /* 1626082 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1626168), // Rule ID 10516 //
     /* 1626087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1626107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626133 */     // MIs[0] policy
     /* 1626133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626143 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1626146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626167 */     // GIR_Coverage, 10516,
     /* 1626167 */     GIR_EraseRootFromParent_Done,
     /* 1626168 */   // Label 22313: @1626168
     /* 1626168 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1626254), // Rule ID 10517 //
     /* 1626173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1626193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626219 */     // MIs[0] policy
     /* 1626219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626229 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1626232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626253 */     // GIR_Coverage, 10517,
     /* 1626253 */     GIR_EraseRootFromParent_Done,
     /* 1626254 */   // Label 22314: @1626254
     /* 1626254 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1626340), // Rule ID 10520 //
     /* 1626259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1626276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1626279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626305 */     // MIs[0] policy
     /* 1626305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1626318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626339 */     // GIR_Coverage, 10520,
     /* 1626339 */     GIR_EraseRootFromParent_Done,
     /* 1626340 */   // Label 22315: @1626340
     /* 1626340 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1626426), // Rule ID 10521 //
     /* 1626345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1626362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1626365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626391 */     // MIs[0] policy
     /* 1626391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1626404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626425 */     // GIR_Coverage, 10521,
     /* 1626425 */     GIR_EraseRootFromParent_Done,
     /* 1626426 */   // Label 22316: @1626426
     /* 1626426 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1626512), // Rule ID 10524 //
     /* 1626431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1626448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1626451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626477 */     // MIs[0] policy
     /* 1626477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1626490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626511 */     // GIR_Coverage, 10524,
     /* 1626511 */     GIR_EraseRootFromParent_Done,
     /* 1626512 */   // Label 22317: @1626512
     /* 1626512 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1626598), // Rule ID 10525 //
     /* 1626517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1626534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1626537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626563 */     // MIs[0] policy
     /* 1626563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1626576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626597 */     // GIR_Coverage, 10525,
     /* 1626597 */     GIR_EraseRootFromParent_Done,
     /* 1626598 */   // Label 22318: @1626598
     /* 1626598 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1626684), // Rule ID 10528 //
     /* 1626603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1626623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626649 */     // MIs[0] policy
     /* 1626649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626659 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1626662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626683 */     // GIR_Coverage, 10528,
     /* 1626683 */     GIR_EraseRootFromParent_Done,
     /* 1626684 */   // Label 22319: @1626684
     /* 1626684 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1626770), // Rule ID 10529 //
     /* 1626689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1626709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626735 */     // MIs[0] policy
     /* 1626735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626745 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1626748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626769 */     // GIR_Coverage, 10529,
     /* 1626769 */     GIR_EraseRootFromParent_Done,
     /* 1626770 */   // Label 22320: @1626770
     /* 1626770 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1626856), // Rule ID 10532 //
     /* 1626775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1626792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1626795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626821 */     // MIs[0] policy
     /* 1626821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626831 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1626834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626855 */     // GIR_Coverage, 10532,
     /* 1626855 */     GIR_EraseRootFromParent_Done,
     /* 1626856 */   // Label 22321: @1626856
     /* 1626856 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1626942), // Rule ID 10533 //
     /* 1626861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1626878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1626881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626907 */     // MIs[0] policy
     /* 1626907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626917 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1626920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626941 */     // GIR_Coverage, 10533,
     /* 1626941 */     GIR_EraseRootFromParent_Done,
     /* 1626942 */   // Label 22322: @1626942
     /* 1626942 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1627028), // Rule ID 10536 //
     /* 1626947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1626950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1626955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1626958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1626961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1626964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1626967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626993 */     // MIs[0] policy
     /* 1626993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1627006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627027 */     // GIR_Coverage, 10536,
     /* 1627027 */     GIR_EraseRootFromParent_Done,
     /* 1627028 */   // Label 22323: @1627028
     /* 1627028 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1627114), // Rule ID 10537 //
     /* 1627033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1627036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1627050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1627053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627079 */     // MIs[0] policy
     /* 1627079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1627092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627113 */     // GIR_Coverage, 10537,
     /* 1627113 */     GIR_EraseRootFromParent_Done,
     /* 1627114 */   // Label 22324: @1627114
     /* 1627114 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1627200), // Rule ID 10540 //
     /* 1627119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1627122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1627136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1627139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627165 */     // MIs[0] policy
     /* 1627165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627175 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1627178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627199 */     // GIR_Coverage, 10540,
     /* 1627199 */     GIR_EraseRootFromParent_Done,
     /* 1627200 */   // Label 22325: @1627200
     /* 1627200 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1627286), // Rule ID 10541 //
     /* 1627205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1627208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1627222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1627225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627251 */     // MIs[0] policy
     /* 1627251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1627264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627285 */     // GIR_Coverage, 10541,
     /* 1627285 */     GIR_EraseRootFromParent_Done,
     /* 1627286 */   // Label 22326: @1627286
     /* 1627286 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1627372), // Rule ID 10544 //
     /* 1627291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1627294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1627308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1627311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627337 */     // MIs[0] policy
     /* 1627337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1627350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627371 */     // GIR_Coverage, 10544,
     /* 1627371 */     GIR_EraseRootFromParent_Done,
     /* 1627372 */   // Label 22327: @1627372
     /* 1627372 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1627458), // Rule ID 10545 //
     /* 1627377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1627380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1627394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1627397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627423 */     // MIs[0] policy
     /* 1627423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627433 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1627436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1627454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627457 */     // GIR_Coverage, 10545,
     /* 1627457 */     GIR_EraseRootFromParent_Done,
     /* 1627458 */   // Label 22328: @1627458
     /* 1627458 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1627544), // Rule ID 10548 //
     /* 1627463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1627474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1627477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627509 */     // MIs[0] policy
     /* 1627509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1627522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627543 */     // GIR_Coverage, 10548,
     /* 1627543 */     GIR_EraseRootFromParent_Done,
     /* 1627544 */   // Label 22329: @1627544
     /* 1627544 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1627630), // Rule ID 10549 //
     /* 1627549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1627560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1627563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627595 */     // MIs[0] policy
     /* 1627595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627605 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1627608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627629 */     // GIR_Coverage, 10549,
     /* 1627629 */     GIR_EraseRootFromParent_Done,
     /* 1627630 */   // Label 22330: @1627630
     /* 1627630 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1627716), // Rule ID 10552 //
     /* 1627635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1627646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1627649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627681 */     // MIs[0] policy
     /* 1627681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627691 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1627694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627715 */     // GIR_Coverage, 10552,
     /* 1627715 */     GIR_EraseRootFromParent_Done,
     /* 1627716 */   // Label 22331: @1627716
     /* 1627716 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1627802), // Rule ID 10553 //
     /* 1627721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1627732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1627735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627767 */     // MIs[0] policy
     /* 1627767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627777 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1627780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627801 */     // GIR_Coverage, 10553,
     /* 1627801 */     GIR_EraseRootFromParent_Done,
     /* 1627802 */   // Label 22332: @1627802
     /* 1627802 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1627888), // Rule ID 10556 //
     /* 1627807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1627818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1627821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1627824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627853 */     // MIs[0] policy
     /* 1627853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627863 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1627866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627887 */     // GIR_Coverage, 10556,
     /* 1627887 */     GIR_EraseRootFromParent_Done,
     /* 1627888 */   // Label 22333: @1627888
     /* 1627888 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1627974), // Rule ID 10557 //
     /* 1627893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1627904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1627907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1627910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627939 */     // MIs[0] policy
     /* 1627939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627949 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1627952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627973 */     // GIR_Coverage, 10557,
     /* 1627973 */     GIR_EraseRootFromParent_Done,
     /* 1627974 */   // Label 22334: @1627974
     /* 1627974 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1628060), // Rule ID 10560 //
     /* 1627979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1627987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1627990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1627993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1627996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628025 */     // MIs[0] policy
     /* 1628025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628035 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1628038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628059 */     // GIR_Coverage, 10560,
     /* 1628059 */     GIR_EraseRootFromParent_Done,
     /* 1628060 */   // Label 22335: @1628060
     /* 1628060 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1628146), // Rule ID 10561 //
     /* 1628065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628111 */     // MIs[0] policy
     /* 1628111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1628124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628145 */     // GIR_Coverage, 10561,
     /* 1628145 */     GIR_EraseRootFromParent_Done,
     /* 1628146 */   // Label 22336: @1628146
     /* 1628146 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1628232), // Rule ID 10564 //
     /* 1628151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628197 */     // MIs[0] policy
     /* 1628197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628207 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1628210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628231 */     // GIR_Coverage, 10564,
     /* 1628231 */     GIR_EraseRootFromParent_Done,
     /* 1628232 */   // Label 22337: @1628232
     /* 1628232 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1628318), // Rule ID 10565 //
     /* 1628237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628283 */     // MIs[0] policy
     /* 1628283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1628296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628317 */     // GIR_Coverage, 10565,
     /* 1628317 */     GIR_EraseRootFromParent_Done,
     /* 1628318 */   // Label 22338: @1628318
     /* 1628318 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1628404), // Rule ID 10568 //
     /* 1628323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1628340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628369 */     // MIs[0] policy
     /* 1628369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1628382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628403 */     // GIR_Coverage, 10568,
     /* 1628403 */     GIR_EraseRootFromParent_Done,
     /* 1628404 */   // Label 22339: @1628404
     /* 1628404 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1628490), // Rule ID 10569 //
     /* 1628409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1628426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628455 */     // MIs[0] policy
     /* 1628455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1628468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628489 */     // GIR_Coverage, 10569,
     /* 1628489 */     GIR_EraseRootFromParent_Done,
     /* 1628490 */   // Label 22340: @1628490
     /* 1628490 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1628576), // Rule ID 10572 //
     /* 1628495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1628506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1628509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628541 */     // MIs[0] policy
     /* 1628541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628551 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628575 */     // GIR_Coverage, 10572,
     /* 1628575 */     GIR_EraseRootFromParent_Done,
     /* 1628576 */   // Label 22341: @1628576
     /* 1628576 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1628662), // Rule ID 10573 //
     /* 1628581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1628592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1628595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628627 */     // MIs[0] policy
     /* 1628627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628637 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628661 */     // GIR_Coverage, 10573,
     /* 1628661 */     GIR_EraseRootFromParent_Done,
     /* 1628662 */   // Label 22342: @1628662
     /* 1628662 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1628748), // Rule ID 10576 //
     /* 1628667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1628684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628713 */     // MIs[0] policy
     /* 1628713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628723 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628747 */     // GIR_Coverage, 10576,
     /* 1628747 */     GIR_EraseRootFromParent_Done,
     /* 1628748 */   // Label 22343: @1628748
     /* 1628748 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1628834), // Rule ID 10577 //
     /* 1628753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1628770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628799 */     // MIs[0] policy
     /* 1628799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628833 */     // GIR_Coverage, 10577,
     /* 1628833 */     GIR_EraseRootFromParent_Done,
     /* 1628834 */   // Label 22344: @1628834
     /* 1628834 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1628920), // Rule ID 10580 //
     /* 1628839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1628856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628885 */     // MIs[0] policy
     /* 1628885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628919 */     // GIR_Coverage, 10580,
     /* 1628919 */     GIR_EraseRootFromParent_Done,
     /* 1628920 */   // Label 22345: @1628920
     /* 1628920 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1629006), // Rule ID 10581 //
     /* 1628925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1628933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1628942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628971 */     // MIs[0] policy
     /* 1628971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628981 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1628984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629005 */     // GIR_Coverage, 10581,
     /* 1629005 */     GIR_EraseRootFromParent_Done,
     /* 1629006 */   // Label 22346: @1629006
     /* 1629006 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1629092), // Rule ID 10584 //
     /* 1629011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1629014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1629028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629057 */     // MIs[0] policy
     /* 1629057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629067 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1629070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1629088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629091 */     // GIR_Coverage, 10584,
     /* 1629091 */     GIR_EraseRootFromParent_Done,
     /* 1629092 */   // Label 22347: @1629092
     /* 1629092 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1629178), // Rule ID 10585 //
     /* 1629097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1629100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1629114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629143 */     // MIs[0] policy
     /* 1629143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1629156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1629174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629177 */     // GIR_Coverage, 10585,
     /* 1629177 */     GIR_EraseRootFromParent_Done,
     /* 1629178 */   // Label 22348: @1629178
     /* 1629178 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1629264), // Rule ID 10588 //
     /* 1629183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1629194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1629197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1629200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629229 */     // MIs[0] policy
     /* 1629229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1629242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629263 */     // GIR_Coverage, 10588,
     /* 1629263 */     GIR_EraseRootFromParent_Done,
     /* 1629264 */   // Label 22349: @1629264
     /* 1629264 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1629350), // Rule ID 10589 //
     /* 1629269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1629280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1629283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1629286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629315 */     // MIs[0] policy
     /* 1629315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629325 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1629328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629349 */     // GIR_Coverage, 10589,
     /* 1629349 */     GIR_EraseRootFromParent_Done,
     /* 1629350 */   // Label 22350: @1629350
     /* 1629350 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1629436), // Rule ID 10592 //
     /* 1629355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1629366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1629369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629401 */     // MIs[0] policy
     /* 1629401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629411 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1629414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629435 */     // GIR_Coverage, 10592,
     /* 1629435 */     GIR_EraseRootFromParent_Done,
     /* 1629436 */   // Label 22351: @1629436
     /* 1629436 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1629522), // Rule ID 10593 //
     /* 1629441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1629452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1629455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629487 */     // MIs[0] policy
     /* 1629487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629497 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1629500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629521 */     // GIR_Coverage, 10593,
     /* 1629521 */     GIR_EraseRootFromParent_Done,
     /* 1629522 */   // Label 22352: @1629522
     /* 1629522 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1629608), // Rule ID 10596 //
     /* 1629527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1629538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1629541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1629544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1629550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629573 */     // MIs[0] policy
     /* 1629573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629583 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1629586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629607 */     // GIR_Coverage, 10596,
     /* 1629607 */     GIR_EraseRootFromParent_Done,
     /* 1629608 */   // Label 22353: @1629608
     /* 1629608 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1629694), // Rule ID 10597 //
     /* 1629613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1629624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1629627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1629630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1629636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629659 */     // MIs[0] policy
     /* 1629659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629669 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1629672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629693 */     // GIR_Coverage, 10597,
     /* 1629693 */     GIR_EraseRootFromParent_Done,
     /* 1629694 */   // Label 22354: @1629694
     /* 1629694 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1629780), // Rule ID 10600 //
     /* 1629699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629745 */     // MIs[0] policy
     /* 1629745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629755 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1629758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629779 */     // GIR_Coverage, 10600,
     /* 1629779 */     GIR_EraseRootFromParent_Done,
     /* 1629780 */   // Label 22355: @1629780
     /* 1629780 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1629866), // Rule ID 10601 //
     /* 1629785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629831 */     // MIs[0] policy
     /* 1629831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1629844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629865 */     // GIR_Coverage, 10601,
     /* 1629865 */     GIR_EraseRootFromParent_Done,
     /* 1629866 */   // Label 22356: @1629866
     /* 1629866 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1629952), // Rule ID 10604 //
     /* 1629871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629917 */     // MIs[0] policy
     /* 1629917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629927 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1629930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629951 */     // GIR_Coverage, 10604,
     /* 1629951 */     GIR_EraseRootFromParent_Done,
     /* 1629952 */   // Label 22357: @1629952
     /* 1629952 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1630038), // Rule ID 10605 //
     /* 1629957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1629965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630003 */     // MIs[0] policy
     /* 1630003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630013 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1630016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630037 */     // GIR_Coverage, 10605,
     /* 1630037 */     GIR_EraseRootFromParent_Done,
     /* 1630038 */   // Label 22358: @1630038
     /* 1630038 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1630124), // Rule ID 10608 //
     /* 1630043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1630054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1630057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1630060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1630066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630089 */     // MIs[0] policy
     /* 1630089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1630102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630123 */     // GIR_Coverage, 10608,
     /* 1630123 */     GIR_EraseRootFromParent_Done,
     /* 1630124 */   // Label 22359: @1630124
     /* 1630124 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1630210), // Rule ID 10609 //
     /* 1630129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1630140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1630143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1630146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1630152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630175 */     // MIs[0] policy
     /* 1630175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630185 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1630188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630209 */     // GIR_Coverage, 10609,
     /* 1630209 */     GIR_EraseRootFromParent_Done,
     /* 1630210 */   // Label 22360: @1630210
     /* 1630210 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1630296), // Rule ID 10612 //
     /* 1630215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630261 */     // MIs[0] policy
     /* 1630261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1630274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630295 */     // GIR_Coverage, 10612,
     /* 1630295 */     GIR_EraseRootFromParent_Done,
     /* 1630296 */   // Label 22361: @1630296
     /* 1630296 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1630382), // Rule ID 10613 //
     /* 1630301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630347 */     // MIs[0] policy
     /* 1630347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1630360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630381 */     // GIR_Coverage, 10613,
     /* 1630381 */     GIR_EraseRootFromParent_Done,
     /* 1630382 */   // Label 22362: @1630382
     /* 1630382 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1630468), // Rule ID 10616 //
     /* 1630387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630433 */     // MIs[0] policy
     /* 1630433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1630446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630467 */     // GIR_Coverage, 10616,
     /* 1630467 */     GIR_EraseRootFromParent_Done,
     /* 1630468 */   // Label 22363: @1630468
     /* 1630468 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1630554), // Rule ID 10617 //
     /* 1630473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630519 */     // MIs[0] policy
     /* 1630519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1630532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630553 */     // GIR_Coverage, 10617,
     /* 1630553 */     GIR_EraseRootFromParent_Done,
     /* 1630554 */   // Label 22364: @1630554
     /* 1630554 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1630640), // Rule ID 10620 //
     /* 1630559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1630576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630605 */     // MIs[0] policy
     /* 1630605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1630618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630639 */     // GIR_Coverage, 10620,
     /* 1630639 */     GIR_EraseRootFromParent_Done,
     /* 1630640 */   // Label 22365: @1630640
     /* 1630640 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1630726), // Rule ID 10621 //
     /* 1630645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1630662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630691 */     // MIs[0] policy
     /* 1630691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1630704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630725 */     // GIR_Coverage, 10621,
     /* 1630725 */     GIR_EraseRootFromParent_Done,
     /* 1630726 */   // Label 22366: @1630726
     /* 1630726 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1630812), // Rule ID 10624 //
     /* 1630731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1630734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1630748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630777 */     // MIs[0] policy
     /* 1630777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1630790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1630808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630811 */     // GIR_Coverage, 10624,
     /* 1630811 */     GIR_EraseRootFromParent_Done,
     /* 1630812 */   // Label 22367: @1630812
     /* 1630812 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1630898), // Rule ID 10625 //
     /* 1630817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1630820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1630834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630863 */     // MIs[0] policy
     /* 1630863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1630876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1630894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630897 */     // GIR_Coverage, 10625,
     /* 1630897 */     GIR_EraseRootFromParent_Done,
     /* 1630898 */   // Label 22368: @1630898
     /* 1630898 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1630984), // Rule ID 10628 //
     /* 1630903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1630906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1630920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630949 */     // MIs[0] policy
     /* 1630949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1630962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1630980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630983 */     // GIR_Coverage, 10628,
     /* 1630983 */     GIR_EraseRootFromParent_Done,
     /* 1630984 */   // Label 22369: @1630984
     /* 1630984 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1631070), // Rule ID 10629 //
     /* 1630989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1630992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1630997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1631000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1631003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1631006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631035 */     // MIs[0] policy
     /* 1631035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631045 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1631048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1631066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631069 */     // GIR_Coverage, 10629,
     /* 1631069 */     GIR_EraseRootFromParent_Done,
     /* 1631070 */   // Label 22370: @1631070
     /* 1631070 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1631156), // Rule ID 10632 //
     /* 1631075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1631078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1631083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1631092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631121 */     // MIs[0] policy
     /* 1631121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1631134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1631152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631155 */     // GIR_Coverage, 10632,
     /* 1631155 */     GIR_EraseRootFromParent_Done,
     /* 1631156 */   // Label 22371: @1631156
     /* 1631156 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1631242), // Rule ID 10633 //
     /* 1631161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1631164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1631169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1631178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631207 */     // MIs[0] policy
     /* 1631207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631217 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1631220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1631238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631241 */     // GIR_Coverage, 10633,
     /* 1631241 */     GIR_EraseRootFromParent_Done,
     /* 1631242 */   // Label 22372: @1631242
     /* 1631242 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1631328), // Rule ID 10636 //
     /* 1631247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1631258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1631261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1631264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631293 */     // MIs[0] policy
     /* 1631293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631303 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1631306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631327 */     // GIR_Coverage, 10636,
     /* 1631327 */     GIR_EraseRootFromParent_Done,
     /* 1631328 */   // Label 22373: @1631328
     /* 1631328 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1631414), // Rule ID 10637 //
     /* 1631333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1631344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1631347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1631350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631379 */     // MIs[0] policy
     /* 1631379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631389 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1631392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631413 */     // GIR_Coverage, 10637,
     /* 1631413 */     GIR_EraseRootFromParent_Done,
     /* 1631414 */   // Label 22374: @1631414
     /* 1631414 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1631500), // Rule ID 10640 //
     /* 1631419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1631430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1631433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1631436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631465 */     // MIs[0] policy
     /* 1631465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1631478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631499 */     // GIR_Coverage, 10640,
     /* 1631499 */     GIR_EraseRootFromParent_Done,
     /* 1631500 */   // Label 22375: @1631500
     /* 1631500 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1631586), // Rule ID 10641 //
     /* 1631505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1631516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1631519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1631522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631551 */     // MIs[0] policy
     /* 1631551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631561 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1631564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631585 */     // GIR_Coverage, 10641,
     /* 1631585 */     GIR_EraseRootFromParent_Done,
     /* 1631586 */   // Label 22376: @1631586
     /* 1631586 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1631672), // Rule ID 10644 //
     /* 1631591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1631602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1631605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631637 */     // MIs[0] policy
     /* 1631637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631647 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1631650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631671 */     // GIR_Coverage, 10644,
     /* 1631671 */     GIR_EraseRootFromParent_Done,
     /* 1631672 */   // Label 22377: @1631672
     /* 1631672 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1631758), // Rule ID 10645 //
     /* 1631677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1631688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1631691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631723 */     // MIs[0] policy
     /* 1631723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631733 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1631736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631757 */     // GIR_Coverage, 10645,
     /* 1631757 */     GIR_EraseRootFromParent_Done,
     /* 1631758 */   // Label 22378: @1631758
     /* 1631758 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1631844), // Rule ID 10648 //
     /* 1631763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1631783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631809 */     // MIs[0] policy
     /* 1631809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631819 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1631822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631843 */     // GIR_Coverage, 10648,
     /* 1631843 */     GIR_EraseRootFromParent_Done,
     /* 1631844 */   // Label 22379: @1631844
     /* 1631844 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1631930), // Rule ID 10649 //
     /* 1631849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1631869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631895 */     // MIs[0] policy
     /* 1631895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631905 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1631908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631929 */     // GIR_Coverage, 10649,
     /* 1631929 */     GIR_EraseRootFromParent_Done,
     /* 1631930 */   // Label 22380: @1631930
     /* 1631930 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1632016), // Rule ID 10652 //
     /* 1631935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1631943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1631946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1631949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1631955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631981 */     // MIs[0] policy
     /* 1631981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1631994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632015 */     // GIR_Coverage, 10652,
     /* 1632015 */     GIR_EraseRootFromParent_Done,
     /* 1632016 */   // Label 22381: @1632016
     /* 1632016 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1632102), // Rule ID 10653 //
     /* 1632021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1632032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1632035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1632041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632067 */     // MIs[0] policy
     /* 1632067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1632080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632101 */     // GIR_Coverage, 10653,
     /* 1632101 */     GIR_EraseRootFromParent_Done,
     /* 1632102 */   // Label 22382: @1632102
     /* 1632102 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1632188), // Rule ID 10656 //
     /* 1632107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1632127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632153 */     // MIs[0] policy
     /* 1632153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632163 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1632166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632187 */     // GIR_Coverage, 10656,
     /* 1632187 */     GIR_EraseRootFromParent_Done,
     /* 1632188 */   // Label 22383: @1632188
     /* 1632188 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1632274), // Rule ID 10657 //
     /* 1632193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1632213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632239 */     // MIs[0] policy
     /* 1632239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1632252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632273 */     // GIR_Coverage, 10657,
     /* 1632273 */     GIR_EraseRootFromParent_Done,
     /* 1632274 */   // Label 22384: @1632274
     /* 1632274 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1632360), // Rule ID 10660 //
     /* 1632279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1632290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1632293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1632296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1632299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632325 */     // MIs[0] policy
     /* 1632325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632335 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632359 */     // GIR_Coverage, 10660,
     /* 1632359 */     GIR_EraseRootFromParent_Done,
     /* 1632360 */   // Label 22385: @1632360
     /* 1632360 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1632446), // Rule ID 10661 //
     /* 1632365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1632376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1632379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1632382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1632385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632411 */     // MIs[0] policy
     /* 1632411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632421 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632445 */     // GIR_Coverage, 10661,
     /* 1632445 */     GIR_EraseRootFromParent_Done,
     /* 1632446 */   // Label 22386: @1632446
     /* 1632446 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1632532), // Rule ID 10664 //
     /* 1632451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1632462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1632465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632497 */     // MIs[0] policy
     /* 1632497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632531 */     // GIR_Coverage, 10664,
     /* 1632531 */     GIR_EraseRootFromParent_Done,
     /* 1632532 */   // Label 22387: @1632532
     /* 1632532 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1632618), // Rule ID 10665 //
     /* 1632537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1632548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1632551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632583 */     // MIs[0] policy
     /* 1632583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632593 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632617 */     // GIR_Coverage, 10665,
     /* 1632617 */     GIR_EraseRootFromParent_Done,
     /* 1632618 */   // Label 22388: @1632618
     /* 1632618 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1632704), // Rule ID 10668 //
     /* 1632623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1632643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632669 */     // MIs[0] policy
     /* 1632669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632703 */     // GIR_Coverage, 10668,
     /* 1632703 */     GIR_EraseRootFromParent_Done,
     /* 1632704 */   // Label 22389: @1632704
     /* 1632704 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1632790), // Rule ID 10669 //
     /* 1632709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1632729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632755 */     // MIs[0] policy
     /* 1632755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632789 */     // GIR_Coverage, 10669,
     /* 1632789 */     GIR_EraseRootFromParent_Done,
     /* 1632790 */   // Label 22390: @1632790
     /* 1632790 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1632876), // Rule ID 10672 //
     /* 1632795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1632798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1632812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1632815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632841 */     // MIs[0] policy
     /* 1632841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1632872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632875 */     // GIR_Coverage, 10672,
     /* 1632875 */     GIR_EraseRootFromParent_Done,
     /* 1632876 */   // Label 22391: @1632876
     /* 1632876 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1632962), // Rule ID 10673 //
     /* 1632881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1632884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1632898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1632901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632927 */     // MIs[0] policy
     /* 1632927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632937 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1632940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1632958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632961 */     // GIR_Coverage, 10673,
     /* 1632961 */     GIR_EraseRootFromParent_Done,
     /* 1632962 */   // Label 22392: @1632962
     /* 1632962 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1633048), // Rule ID 10676 //
     /* 1632967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1632975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1632978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1632981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1632984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1632987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633013 */     // MIs[0] policy
     /* 1633013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633023 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1633026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633047 */     // GIR_Coverage, 10676,
     /* 1633047 */     GIR_EraseRootFromParent_Done,
     /* 1633048 */   // Label 22393: @1633048
     /* 1633048 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1633134), // Rule ID 10677 //
     /* 1633053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1633064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1633067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1633070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633099 */     // MIs[0] policy
     /* 1633099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1633112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633133 */     // GIR_Coverage, 10677,
     /* 1633133 */     GIR_EraseRootFromParent_Done,
     /* 1633134 */   // Label 22394: @1633134
     /* 1633134 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1633220), // Rule ID 10680 //
     /* 1633139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1633150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1633153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1633156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633185 */     // MIs[0] policy
     /* 1633185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633195 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1633198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633219 */     // GIR_Coverage, 10680,
     /* 1633219 */     GIR_EraseRootFromParent_Done,
     /* 1633220 */   // Label 22395: @1633220
     /* 1633220 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1633306), // Rule ID 10681 //
     /* 1633225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1633236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1633239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1633242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633271 */     // MIs[0] policy
     /* 1633271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633281 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1633284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633305 */     // GIR_Coverage, 10681,
     /* 1633305 */     GIR_EraseRootFromParent_Done,
     /* 1633306 */   // Label 22396: @1633306
     /* 1633306 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1633392), // Rule ID 10684 //
     /* 1633311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1633322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1633325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1633328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1633331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1633334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633357 */     // MIs[0] policy
     /* 1633357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633367 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1633370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633391 */     // GIR_Coverage, 10684,
     /* 1633391 */     GIR_EraseRootFromParent_Done,
     /* 1633392 */   // Label 22397: @1633392
     /* 1633392 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1633478), // Rule ID 10685 //
     /* 1633397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1633408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1633411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1633414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1633417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1633420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633443 */     // MIs[0] policy
     /* 1633443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633453 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1633456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633477 */     // GIR_Coverage, 10685,
     /* 1633477 */     GIR_EraseRootFromParent_Done,
     /* 1633478 */   // Label 22398: @1633478
     /* 1633478 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1633564), // Rule ID 10688 //
     /* 1633483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1633503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633529 */     // MIs[0] policy
     /* 1633529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1633542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633563 */     // GIR_Coverage, 10688,
     /* 1633563 */     GIR_EraseRootFromParent_Done,
     /* 1633564 */   // Label 22399: @1633564
     /* 1633564 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1633650), // Rule ID 10689 //
     /* 1633569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1633589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633615 */     // MIs[0] policy
     /* 1633615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1633628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633649 */     // GIR_Coverage, 10689,
     /* 1633649 */     GIR_EraseRootFromParent_Done,
     /* 1633650 */   // Label 22400: @1633650
     /* 1633650 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1633736), // Rule ID 10692 //
     /* 1633655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1633675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633701 */     // MIs[0] policy
     /* 1633701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1633714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633735 */     // GIR_Coverage, 10692,
     /* 1633735 */     GIR_EraseRootFromParent_Done,
     /* 1633736 */   // Label 22401: @1633736
     /* 1633736 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1633822), // Rule ID 10693 //
     /* 1633741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1633761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633787 */     // MIs[0] policy
     /* 1633787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633797 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1633800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633821 */     // GIR_Coverage, 10693,
     /* 1633821 */     GIR_EraseRootFromParent_Done,
     /* 1633822 */   // Label 22402: @1633822
     /* 1633822 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1633908), // Rule ID 10696 //
     /* 1633827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1633847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633873 */     // MIs[0] policy
     /* 1633873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633883 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1633886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633907 */     // GIR_Coverage, 10696,
     /* 1633907 */     GIR_EraseRootFromParent_Done,
     /* 1633908 */   // Label 22403: @1633908
     /* 1633908 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1633994), // Rule ID 10697 //
     /* 1633913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1633921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1633933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633959 */     // MIs[0] policy
     /* 1633959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1633972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633993 */     // GIR_Coverage, 10697,
     /* 1633993 */     GIR_EraseRootFromParent_Done,
     /* 1633994 */   // Label 22404: @1633994
     /* 1633994 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1634080), // Rule ID 10700 //
     /* 1633999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1634019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634045 */     // MIs[0] policy
     /* 1634045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1634058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634079 */     // GIR_Coverage, 10700,
     /* 1634079 */     GIR_EraseRootFromParent_Done,
     /* 1634080 */   // Label 22405: @1634080
     /* 1634080 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1634166), // Rule ID 10701 //
     /* 1634085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1634105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634131 */     // MIs[0] policy
     /* 1634131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1634144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634165 */     // GIR_Coverage, 10701,
     /* 1634165 */     GIR_EraseRootFromParent_Done,
     /* 1634166 */   // Label 22406: @1634166
     /* 1634166 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1634252), // Rule ID 10704 //
     /* 1634171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1634191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634217 */     // MIs[0] policy
     /* 1634217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1634230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634251 */     // GIR_Coverage, 10704,
     /* 1634251 */     GIR_EraseRootFromParent_Done,
     /* 1634252 */   // Label 22407: @1634252
     /* 1634252 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1634338), // Rule ID 10705 //
     /* 1634257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1634277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634303 */     // MIs[0] policy
     /* 1634303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1634316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634337 */     // GIR_Coverage, 10705,
     /* 1634337 */     GIR_EraseRootFromParent_Done,
     /* 1634338 */   // Label 22408: @1634338
     /* 1634338 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1634424), // Rule ID 10708 //
     /* 1634343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1634363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634389 */     // MIs[0] policy
     /* 1634389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634399 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1634402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634423 */     // GIR_Coverage, 10708,
     /* 1634423 */     GIR_EraseRootFromParent_Done,
     /* 1634424 */   // Label 22409: @1634424
     /* 1634424 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1634510), // Rule ID 10709 //
     /* 1634429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1634449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634475 */     // MIs[0] policy
     /* 1634475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1634488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634509 */     // GIR_Coverage, 10709,
     /* 1634509 */     GIR_EraseRootFromParent_Done,
     /* 1634510 */   // Label 22410: @1634510
     /* 1634510 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1634596), // Rule ID 10712 //
     /* 1634515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1634518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1634535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634561 */     // MIs[0] policy
     /* 1634561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1634574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1634592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634595 */     // GIR_Coverage, 10712,
     /* 1634595 */     GIR_EraseRootFromParent_Done,
     /* 1634596 */   // Label 22411: @1634596
     /* 1634596 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1634682), // Rule ID 10713 //
     /* 1634601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1634604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1634621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634647 */     // MIs[0] policy
     /* 1634647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1634660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1634678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634681 */     // GIR_Coverage, 10713,
     /* 1634681 */     GIR_EraseRootFromParent_Done,
     /* 1634682 */   // Label 22412: @1634682
     /* 1634682 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1634768), // Rule ID 10716 //
     /* 1634687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1634690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1634707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634733 */     // MIs[0] policy
     /* 1634733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634743 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1634746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1634764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634767 */     // GIR_Coverage, 10716,
     /* 1634767 */     GIR_EraseRootFromParent_Done,
     /* 1634768 */   // Label 22413: @1634768
     /* 1634768 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1634854), // Rule ID 10717 //
     /* 1634773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1634776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1634793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634819 */     // MIs[0] policy
     /* 1634819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634829 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1634832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1634850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634853 */     // GIR_Coverage, 10717,
     /* 1634853 */     GIR_EraseRootFromParent_Done,
     /* 1634854 */   // Label 22414: @1634854
     /* 1634854 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1634940), // Rule ID 10720 //
     /* 1634859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1634862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1634870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1634873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1634876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1634879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634905 */     // MIs[0] policy
     /* 1634905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634915 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1634918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1634936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634939 */     // GIR_Coverage, 10720,
     /* 1634939 */     GIR_EraseRootFromParent_Done,
     /* 1634940 */   // Label 22415: @1634940
     /* 1634940 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1635026), // Rule ID 10721 //
     /* 1634945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1634948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1634953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1634956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1634959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1634962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1634965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634991 */     // MIs[0] policy
     /* 1634991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1635004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1635022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635025 */     // GIR_Coverage, 10721,
     /* 1635025 */     GIR_EraseRootFromParent_Done,
     /* 1635026 */   // Label 22416: @1635026
     /* 1635026 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1635112), // Rule ID 10724 //
     /* 1635031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1635042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1635045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1635048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635077 */     // MIs[0] policy
     /* 1635077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635087 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1635090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635111 */     // GIR_Coverage, 10724,
     /* 1635111 */     GIR_EraseRootFromParent_Done,
     /* 1635112 */   // Label 22417: @1635112
     /* 1635112 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1635198), // Rule ID 10725 //
     /* 1635117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1635128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1635131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1635134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635163 */     // MIs[0] policy
     /* 1635163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635173 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1635176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635197 */     // GIR_Coverage, 10725,
     /* 1635197 */     GIR_EraseRootFromParent_Done,
     /* 1635198 */   // Label 22418: @1635198
     /* 1635198 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1635284), // Rule ID 10728 //
     /* 1635203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1635214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1635217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1635220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635249 */     // MIs[0] policy
     /* 1635249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635259 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1635262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635283 */     // GIR_Coverage, 10728,
     /* 1635283 */     GIR_EraseRootFromParent_Done,
     /* 1635284 */   // Label 22419: @1635284
     /* 1635284 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1635370), // Rule ID 10729 //
     /* 1635289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1635300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1635303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1635306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635335 */     // MIs[0] policy
     /* 1635335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635345 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1635348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635369 */     // GIR_Coverage, 10729,
     /* 1635369 */     GIR_EraseRootFromParent_Done,
     /* 1635370 */   // Label 22420: @1635370
     /* 1635370 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1635456), // Rule ID 10732 //
     /* 1635375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1635386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1635389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1635392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635421 */     // MIs[0] policy
     /* 1635421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635431 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1635434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635455 */     // GIR_Coverage, 10732,
     /* 1635455 */     GIR_EraseRootFromParent_Done,
     /* 1635456 */   // Label 22421: @1635456
     /* 1635456 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1635542), // Rule ID 10733 //
     /* 1635461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1635472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1635475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1635478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635507 */     // MIs[0] policy
     /* 1635507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635517 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1635520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635541 */     // GIR_Coverage, 10733,
     /* 1635541 */     GIR_EraseRootFromParent_Done,
     /* 1635542 */   // Label 22422: @1635542
     /* 1635542 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1635628), // Rule ID 10736 //
     /* 1635547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635593 */     // MIs[0] policy
     /* 1635593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1635606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635627 */     // GIR_Coverage, 10736,
     /* 1635627 */     GIR_EraseRootFromParent_Done,
     /* 1635628 */   // Label 22423: @1635628
     /* 1635628 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1635714), // Rule ID 10737 //
     /* 1635633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635679 */     // MIs[0] policy
     /* 1635679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1635692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635713 */     // GIR_Coverage, 10737,
     /* 1635713 */     GIR_EraseRootFromParent_Done,
     /* 1635714 */   // Label 22424: @1635714
     /* 1635714 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1635800), // Rule ID 10740 //
     /* 1635719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635765 */     // MIs[0] policy
     /* 1635765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635775 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1635778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635799 */     // GIR_Coverage, 10740,
     /* 1635799 */     GIR_EraseRootFromParent_Done,
     /* 1635800 */   // Label 22425: @1635800
     /* 1635800 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1635886), // Rule ID 10741 //
     /* 1635805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635851 */     // MIs[0] policy
     /* 1635851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635861 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1635864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635885 */     // GIR_Coverage, 10741,
     /* 1635885 */     GIR_EraseRootFromParent_Done,
     /* 1635886 */   // Label 22426: @1635886
     /* 1635886 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1635972), // Rule ID 10744 //
     /* 1635891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1635902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1635905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1635908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635937 */     // MIs[0] policy
     /* 1635937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635947 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1635950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635971 */     // GIR_Coverage, 10744,
     /* 1635971 */     GIR_EraseRootFromParent_Done,
     /* 1635972 */   // Label 22427: @1635972
     /* 1635972 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1636058), // Rule ID 10745 //
     /* 1635977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1635985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1635988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1635991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1635994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636023 */     // MIs[0] policy
     /* 1636023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636033 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1636036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636057 */     // GIR_Coverage, 10745,
     /* 1636057 */     GIR_EraseRootFromParent_Done,
     /* 1636058 */   // Label 22428: @1636058
     /* 1636058 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1636144), // Rule ID 10748 //
     /* 1636063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1636074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1636077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1636080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636109 */     // MIs[0] policy
     /* 1636109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636143 */     // GIR_Coverage, 10748,
     /* 1636143 */     GIR_EraseRootFromParent_Done,
     /* 1636144 */   // Label 22429: @1636144
     /* 1636144 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1636230), // Rule ID 10749 //
     /* 1636149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1636160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1636163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1636166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636195 */     // MIs[0] policy
     /* 1636195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636205 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636229 */     // GIR_Coverage, 10749,
     /* 1636229 */     GIR_EraseRootFromParent_Done,
     /* 1636230 */   // Label 22430: @1636230
     /* 1636230 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1636316), // Rule ID 10752 //
     /* 1636235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636281 */     // MIs[0] policy
     /* 1636281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636315 */     // GIR_Coverage, 10752,
     /* 1636315 */     GIR_EraseRootFromParent_Done,
     /* 1636316 */   // Label 22431: @1636316
     /* 1636316 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1636402), // Rule ID 10753 //
     /* 1636321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636367 */     // MIs[0] policy
     /* 1636367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636401 */     // GIR_Coverage, 10753,
     /* 1636401 */     GIR_EraseRootFromParent_Done,
     /* 1636402 */   // Label 22432: @1636402
     /* 1636402 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1636488), // Rule ID 10756 //
     /* 1636407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636453 */     // MIs[0] policy
     /* 1636453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636463 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636487 */     // GIR_Coverage, 10756,
     /* 1636487 */     GIR_EraseRootFromParent_Done,
     /* 1636488 */   // Label 22433: @1636488
     /* 1636488 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1636574), // Rule ID 10757 //
     /* 1636493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636539 */     // MIs[0] policy
     /* 1636539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636573 */     // GIR_Coverage, 10757,
     /* 1636573 */     GIR_EraseRootFromParent_Done,
     /* 1636574 */   // Label 22434: @1636574
     /* 1636574 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1636660), // Rule ID 10760 //
     /* 1636579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1636582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1636590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1636593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1636596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636625 */     // MIs[0] policy
     /* 1636625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636635 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1636656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636659 */     // GIR_Coverage, 10760,
     /* 1636659 */     GIR_EraseRootFromParent_Done,
     /* 1636660 */   // Label 22435: @1636660
     /* 1636660 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1636746), // Rule ID 10761 //
     /* 1636665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1636668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1636676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1636679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1636682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636711 */     // MIs[0] policy
     /* 1636711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1636724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1636742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636745 */     // GIR_Coverage, 10761,
     /* 1636745 */     GIR_EraseRootFromParent_Done,
     /* 1636746 */   // Label 22436: @1636746
     /* 1636746 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1636832), // Rule ID 10764 //
     /* 1636751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1636762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1636765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1636768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636797 */     // MIs[0] policy
     /* 1636797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636807 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1636810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636831 */     // GIR_Coverage, 10764,
     /* 1636831 */     GIR_EraseRootFromParent_Done,
     /* 1636832 */   // Label 22437: @1636832
     /* 1636832 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1636918), // Rule ID 10765 //
     /* 1636837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1636848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1636851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1636854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636883 */     // MIs[0] policy
     /* 1636883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1636896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636917 */     // GIR_Coverage, 10765,
     /* 1636917 */     GIR_EraseRootFromParent_Done,
     /* 1636918 */   // Label 22438: @1636918
     /* 1636918 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1637004), // Rule ID 10768 //
     /* 1636923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1636931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1636934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1636937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1636940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636969 */     // MIs[0] policy
     /* 1636969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636979 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1636982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637003 */     // GIR_Coverage, 10768,
     /* 1637003 */     GIR_EraseRootFromParent_Done,
     /* 1637004 */   // Label 22439: @1637004
     /* 1637004 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1637090), // Rule ID 10769 //
     /* 1637009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1637020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1637023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1637026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637055 */     // MIs[0] policy
     /* 1637055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637065 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1637068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637089 */     // GIR_Coverage, 10769,
     /* 1637089 */     GIR_EraseRootFromParent_Done,
     /* 1637090 */   // Label 22440: @1637090
     /* 1637090 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1637176), // Rule ID 10772 //
     /* 1637095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1637106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1637109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1637112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1637118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637141 */     // MIs[0] policy
     /* 1637141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637151 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1637154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637175 */     // GIR_Coverage, 10772,
     /* 1637175 */     GIR_EraseRootFromParent_Done,
     /* 1637176 */   // Label 22441: @1637176
     /* 1637176 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1637262), // Rule ID 10773 //
     /* 1637181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1637192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1637195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1637198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1637204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637227 */     // MIs[0] policy
     /* 1637227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637237 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1637240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637261 */     // GIR_Coverage, 10773,
     /* 1637261 */     GIR_EraseRootFromParent_Done,
     /* 1637262 */   // Label 22442: @1637262
     /* 1637262 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1637348), // Rule ID 10776 //
     /* 1637267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1637278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1637281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1637284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637313 */     // MIs[0] policy
     /* 1637313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1637326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637347 */     // GIR_Coverage, 10776,
     /* 1637347 */     GIR_EraseRootFromParent_Done,
     /* 1637348 */   // Label 22443: @1637348
     /* 1637348 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1637434), // Rule ID 10777 //
     /* 1637353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1637364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1637367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1637370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637399 */     // MIs[0] policy
     /* 1637399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1637412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637433 */     // GIR_Coverage, 10777,
     /* 1637433 */     GIR_EraseRootFromParent_Done,
     /* 1637434 */   // Label 22444: @1637434
     /* 1637434 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1637520), // Rule ID 10780 //
     /* 1637439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637485 */     // MIs[0] policy
     /* 1637485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637495 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1637498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637519 */     // GIR_Coverage, 10780,
     /* 1637519 */     GIR_EraseRootFromParent_Done,
     /* 1637520 */   // Label 22445: @1637520
     /* 1637520 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1637606), // Rule ID 10781 //
     /* 1637525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637571 */     // MIs[0] policy
     /* 1637571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637581 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1637584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637605 */     // GIR_Coverage, 10781,
     /* 1637605 */     GIR_EraseRootFromParent_Done,
     /* 1637606 */   // Label 22446: @1637606
     /* 1637606 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1637692), // Rule ID 10784 //
     /* 1637611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637657 */     // MIs[0] policy
     /* 1637657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637667 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1637670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637691 */     // GIR_Coverage, 10784,
     /* 1637691 */     GIR_EraseRootFromParent_Done,
     /* 1637692 */   // Label 22447: @1637692
     /* 1637692 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1637778), // Rule ID 10785 //
     /* 1637697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637743 */     // MIs[0] policy
     /* 1637743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637753 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1637756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637777 */     // GIR_Coverage, 10785,
     /* 1637777 */     GIR_EraseRootFromParent_Done,
     /* 1637778 */   // Label 22448: @1637778
     /* 1637778 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1637864), // Rule ID 10788 //
     /* 1637783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637829 */     // MIs[0] policy
     /* 1637829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1637842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637863 */     // GIR_Coverage, 10788,
     /* 1637863 */     GIR_EraseRootFromParent_Done,
     /* 1637864 */   // Label 22449: @1637864
     /* 1637864 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1637950), // Rule ID 10789 //
     /* 1637869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637915 */     // MIs[0] policy
     /* 1637915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1637928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637949 */     // GIR_Coverage, 10789,
     /* 1637949 */     GIR_EraseRootFromParent_Done,
     /* 1637950 */   // Label 22450: @1637950
     /* 1637950 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1638036), // Rule ID 10792 //
     /* 1637955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1637963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638001 */     // MIs[0] policy
     /* 1638001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1638014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638035 */     // GIR_Coverage, 10792,
     /* 1638035 */     GIR_EraseRootFromParent_Done,
     /* 1638036 */   // Label 22451: @1638036
     /* 1638036 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1638122), // Rule ID 10793 //
     /* 1638041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1638052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1638055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1638058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638087 */     // MIs[0] policy
     /* 1638087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638097 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1638100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638121 */     // GIR_Coverage, 10793,
     /* 1638121 */     GIR_EraseRootFromParent_Done,
     /* 1638122 */   // Label 22452: @1638122
     /* 1638122 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1638208), // Rule ID 10796 //
     /* 1638127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638173 */     // MIs[0] policy
     /* 1638173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638183 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1638186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638207 */     // GIR_Coverage, 10796,
     /* 1638207 */     GIR_EraseRootFromParent_Done,
     /* 1638208 */   // Label 22453: @1638208
     /* 1638208 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1638294), // Rule ID 10797 //
     /* 1638213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638259 */     // MIs[0] policy
     /* 1638259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638269 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1638272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638293 */     // GIR_Coverage, 10797,
     /* 1638293 */     GIR_EraseRootFromParent_Done,
     /* 1638294 */   // Label 22454: @1638294
     /* 1638294 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1638380), // Rule ID 10800 //
     /* 1638299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1638302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638345 */     // MIs[0] policy
     /* 1638345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1638358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638379 */     // GIR_Coverage, 10800,
     /* 1638379 */     GIR_EraseRootFromParent_Done,
     /* 1638380 */   // Label 22455: @1638380
     /* 1638380 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1638466), // Rule ID 10801 //
     /* 1638385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1638388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638431 */     // MIs[0] policy
     /* 1638431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1638444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638465 */     // GIR_Coverage, 10801,
     /* 1638465 */     GIR_EraseRootFromParent_Done,
     /* 1638466 */   // Label 22456: @1638466
     /* 1638466 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1638552), // Rule ID 10804 //
     /* 1638471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1638474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638517 */     // MIs[0] policy
     /* 1638517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1638530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638551 */     // GIR_Coverage, 10804,
     /* 1638551 */     GIR_EraseRootFromParent_Done,
     /* 1638552 */   // Label 22457: @1638552
     /* 1638552 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1638638), // Rule ID 10805 //
     /* 1638557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1638560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638603 */     // MIs[0] policy
     /* 1638603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638613 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1638616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638637 */     // GIR_Coverage, 10805,
     /* 1638637 */     GIR_EraseRootFromParent_Done,
     /* 1638638 */   // Label 22458: @1638638
     /* 1638638 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1638724), // Rule ID 10808 //
     /* 1638643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1638646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638689 */     // MIs[0] policy
     /* 1638689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1638702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638723 */     // GIR_Coverage, 10808,
     /* 1638723 */     GIR_EraseRootFromParent_Done,
     /* 1638724 */   // Label 22459: @1638724
     /* 1638724 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1638810), // Rule ID 10809 //
     /* 1638729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1638732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1638737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638775 */     // MIs[0] policy
     /* 1638775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638785 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1638788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1638806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638809 */     // GIR_Coverage, 10809,
     /* 1638809 */     GIR_EraseRootFromParent_Done,
     /* 1638810 */   // Label 22460: @1638810
     /* 1638810 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1638896), // Rule ID 10812 //
     /* 1638815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1638823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1638826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1638829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1638832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638861 */     // MIs[0] policy
     /* 1638861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1638874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638895 */     // GIR_Coverage, 10812,
     /* 1638895 */     GIR_EraseRootFromParent_Done,
     /* 1638896 */   // Label 22461: @1638896
     /* 1638896 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1638982), // Rule ID 10813 //
     /* 1638901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1638909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1638912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1638915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1638918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638947 */     // MIs[0] policy
     /* 1638947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638957 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1638960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638981 */     // GIR_Coverage, 10813,
     /* 1638981 */     GIR_EraseRootFromParent_Done,
     /* 1638982 */   // Label 22462: @1638982
     /* 1638982 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1639068), // Rule ID 10816 //
     /* 1638987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1638995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1638998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1639001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1639004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1639007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639033 */     // MIs[0] policy
     /* 1639033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1639046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639067 */     // GIR_Coverage, 10816,
     /* 1639067 */     GIR_EraseRootFromParent_Done,
     /* 1639068 */   // Label 22463: @1639068
     /* 1639068 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1639154), // Rule ID 10817 //
     /* 1639073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1639084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1639087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1639090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1639093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639119 */     // MIs[0] policy
     /* 1639119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639129 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1639132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639153 */     // GIR_Coverage, 10817,
     /* 1639153 */     GIR_EraseRootFromParent_Done,
     /* 1639154 */   // Label 22464: @1639154
     /* 1639154 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1639240), // Rule ID 10820 //
     /* 1639159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1639170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1639173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1639176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1639179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639205 */     // MIs[0] policy
     /* 1639205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639215 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639239 */     // GIR_Coverage, 10820,
     /* 1639239 */     GIR_EraseRootFromParent_Done,
     /* 1639240 */   // Label 22465: @1639240
     /* 1639240 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1639326), // Rule ID 10821 //
     /* 1639245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1639256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1639259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1639262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1639265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639291 */     // MIs[0] policy
     /* 1639291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639325 */     // GIR_Coverage, 10821,
     /* 1639325 */     GIR_EraseRootFromParent_Done,
     /* 1639326 */   // Label 22466: @1639326
     /* 1639326 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1639412), // Rule ID 10824 //
     /* 1639331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1639342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1639345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1639348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639377 */     // MIs[0] policy
     /* 1639377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639387 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1639390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639411 */     // GIR_Coverage, 10824,
     /* 1639411 */     GIR_EraseRootFromParent_Done,
     /* 1639412 */   // Label 22467: @1639412
     /* 1639412 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1639498), // Rule ID 10825 //
     /* 1639417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1639428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1639431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1639434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639463 */     // MIs[0] policy
     /* 1639463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1639476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639497 */     // GIR_Coverage, 10825,
     /* 1639497 */     GIR_EraseRootFromParent_Done,
     /* 1639498 */   // Label 22468: @1639498
     /* 1639498 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1639584), // Rule ID 10828 //
     /* 1639503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639549 */     // MIs[0] policy
     /* 1639549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639583 */     // GIR_Coverage, 10828,
     /* 1639583 */     GIR_EraseRootFromParent_Done,
     /* 1639584 */   // Label 22469: @1639584
     /* 1639584 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1639670), // Rule ID 10829 //
     /* 1639589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639635 */     // MIs[0] policy
     /* 1639635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639645 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639669 */     // GIR_Coverage, 10829,
     /* 1639669 */     GIR_EraseRootFromParent_Done,
     /* 1639670 */   // Label 22470: @1639670
     /* 1639670 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1639756), // Rule ID 10832 //
     /* 1639675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639721 */     // MIs[0] policy
     /* 1639721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639755 */     // GIR_Coverage, 10832,
     /* 1639755 */     GIR_EraseRootFromParent_Done,
     /* 1639756 */   // Label 22471: @1639756
     /* 1639756 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1639842), // Rule ID 10833 //
     /* 1639761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639807 */     // MIs[0] policy
     /* 1639807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639817 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1639820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639841 */     // GIR_Coverage, 10833,
     /* 1639841 */     GIR_EraseRootFromParent_Done,
     /* 1639842 */   // Label 22472: @1639842
     /* 1639842 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1639928), // Rule ID 10836 //
     /* 1639847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1639858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1639861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1639864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1639867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639893 */     // MIs[0] policy
     /* 1639893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639903 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1639906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639927 */     // GIR_Coverage, 10836,
     /* 1639927 */     GIR_EraseRootFromParent_Done,
     /* 1639928 */   // Label 22473: @1639928
     /* 1639928 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1640014), // Rule ID 10837 //
     /* 1639933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1639941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1639944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1639947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1639950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1639953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639979 */     // MIs[0] policy
     /* 1639979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1639992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640013 */     // GIR_Coverage, 10837,
     /* 1640013 */     GIR_EraseRootFromParent_Done,
     /* 1640014 */   // Label 22474: @1640014
     /* 1640014 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1640100), // Rule ID 10840 //
     /* 1640019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1640039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640065 */     // MIs[0] policy
     /* 1640065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640099 */     // GIR_Coverage, 10840,
     /* 1640099 */     GIR_EraseRootFromParent_Done,
     /* 1640100 */   // Label 22475: @1640100
     /* 1640100 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1640186), // Rule ID 10841 //
     /* 1640105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1640125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640151 */     // MIs[0] policy
     /* 1640151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640185 */     // GIR_Coverage, 10841,
     /* 1640185 */     GIR_EraseRootFromParent_Done,
     /* 1640186 */   // Label 22476: @1640186
     /* 1640186 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1640272), // Rule ID 10844 //
     /* 1640191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640237 */     // MIs[0] policy
     /* 1640237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640271 */     // GIR_Coverage, 10844,
     /* 1640271 */     GIR_EraseRootFromParent_Done,
     /* 1640272 */   // Label 22477: @1640272
     /* 1640272 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1640358), // Rule ID 10845 //
     /* 1640277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640323 */     // MIs[0] policy
     /* 1640323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640357 */     // GIR_Coverage, 10845,
     /* 1640357 */     GIR_EraseRootFromParent_Done,
     /* 1640358 */   // Label 22478: @1640358
     /* 1640358 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1640444), // Rule ID 10848 //
     /* 1640363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1640366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1640383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640409 */     // MIs[0] policy
     /* 1640409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640419 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1640440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640443 */     // GIR_Coverage, 10848,
     /* 1640443 */     GIR_EraseRootFromParent_Done,
     /* 1640444 */   // Label 22479: @1640444
     /* 1640444 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1640530), // Rule ID 10849 //
     /* 1640449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1640452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1640469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640495 */     // MIs[0] policy
     /* 1640495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640505 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1640508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1640526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640529 */     // GIR_Coverage, 10849,
     /* 1640529 */     GIR_EraseRootFromParent_Done,
     /* 1640530 */   // Label 22480: @1640530
     /* 1640530 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1640616), // Rule ID 10852 //
     /* 1640535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1640546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1640549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1640552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1640555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640581 */     // MIs[0] policy
     /* 1640581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1640594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640615 */     // GIR_Coverage, 10852,
     /* 1640615 */     GIR_EraseRootFromParent_Done,
     /* 1640616 */   // Label 22481: @1640616
     /* 1640616 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1640702), // Rule ID 10853 //
     /* 1640621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1640632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1640635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1640638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1640641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640667 */     // MIs[0] policy
     /* 1640667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1640680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640701 */     // GIR_Coverage, 10853,
     /* 1640701 */     GIR_EraseRootFromParent_Done,
     /* 1640702 */   // Label 22482: @1640702
     /* 1640702 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1640788), // Rule ID 10856 //
     /* 1640707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1640718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1640721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1640724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1640727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1640730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640753 */     // MIs[0] policy
     /* 1640753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640763 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1640766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640787 */     // GIR_Coverage, 10856,
     /* 1640787 */     GIR_EraseRootFromParent_Done,
     /* 1640788 */   // Label 22483: @1640788
     /* 1640788 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1640874), // Rule ID 10857 //
     /* 1640793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1640804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1640807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1640810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1640813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1640816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640839 */     // MIs[0] policy
     /* 1640839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1640852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640873 */     // GIR_Coverage, 10857,
     /* 1640873 */     GIR_EraseRootFromParent_Done,
     /* 1640874 */   // Label 22484: @1640874
     /* 1640874 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1640960), // Rule ID 10860 //
     /* 1640879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1640890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1640893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1640896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1640899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1640902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640925 */     // MIs[0] policy
     /* 1640925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640935 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1640938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640959 */     // GIR_Coverage, 10860,
     /* 1640959 */     GIR_EraseRootFromParent_Done,
     /* 1640960 */   // Label 22485: @1640960
     /* 1640960 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1641046), // Rule ID 10861 //
     /* 1640965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1640973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1640976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1640979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1640982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1640985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1640988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641011 */     // MIs[0] policy
     /* 1641011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641021 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1641024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641045 */     // GIR_Coverage, 10861,
     /* 1641045 */     GIR_EraseRootFromParent_Done,
     /* 1641046 */   // Label 22486: @1641046
     /* 1641046 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1641132), // Rule ID 10864 //
     /* 1641051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1641071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641097 */     // MIs[0] policy
     /* 1641097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1641110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641131 */     // GIR_Coverage, 10864,
     /* 1641131 */     GIR_EraseRootFromParent_Done,
     /* 1641132 */   // Label 22487: @1641132
     /* 1641132 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1641218), // Rule ID 10865 //
     /* 1641137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1641157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641183 */     // MIs[0] policy
     /* 1641183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1641196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641217 */     // GIR_Coverage, 10865,
     /* 1641217 */     GIR_EraseRootFromParent_Done,
     /* 1641218 */   // Label 22488: @1641218
     /* 1641218 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1641304), // Rule ID 10868 //
     /* 1641223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1641243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641269 */     // MIs[0] policy
     /* 1641269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641279 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1641282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641303 */     // GIR_Coverage, 10868,
     /* 1641303 */     GIR_EraseRootFromParent_Done,
     /* 1641304 */   // Label 22489: @1641304
     /* 1641304 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1641390), // Rule ID 10869 //
     /* 1641309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1641329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641355 */     // MIs[0] policy
     /* 1641355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641365 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1641368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641389 */     // GIR_Coverage, 10869,
     /* 1641389 */     GIR_EraseRootFromParent_Done,
     /* 1641390 */   // Label 22490: @1641390
     /* 1641390 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1641476), // Rule ID 10872 //
     /* 1641395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1641415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641441 */     // MIs[0] policy
     /* 1641441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641451 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1641454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641475 */     // GIR_Coverage, 10872,
     /* 1641475 */     GIR_EraseRootFromParent_Done,
     /* 1641476 */   // Label 22491: @1641476
     /* 1641476 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1641562), // Rule ID 10873 //
     /* 1641481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1641501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641527 */     // MIs[0] policy
     /* 1641527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641537 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1641540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641561 */     // GIR_Coverage, 10873,
     /* 1641561 */     GIR_EraseRootFromParent_Done,
     /* 1641562 */   // Label 22492: @1641562
     /* 1641562 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1641648), // Rule ID 10876 //
     /* 1641567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1641587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641613 */     // MIs[0] policy
     /* 1641613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1641626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641647 */     // GIR_Coverage, 10876,
     /* 1641647 */     GIR_EraseRootFromParent_Done,
     /* 1641648 */   // Label 22493: @1641648
     /* 1641648 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1641734), // Rule ID 10877 //
     /* 1641653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1641673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641699 */     // MIs[0] policy
     /* 1641699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1641712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641733 */     // GIR_Coverage, 10877,
     /* 1641733 */     GIR_EraseRootFromParent_Done,
     /* 1641734 */   // Label 22494: @1641734
     /* 1641734 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1641820), // Rule ID 10880 //
     /* 1641739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1641750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1641753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1641756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1641759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641785 */     // MIs[0] policy
     /* 1641785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641795 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1641798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641819 */     // GIR_Coverage, 10880,
     /* 1641819 */     GIR_EraseRootFromParent_Done,
     /* 1641820 */   // Label 22495: @1641820
     /* 1641820 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1641906), // Rule ID 10881 //
     /* 1641825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1641836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1641839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1641842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1641845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641871 */     // MIs[0] policy
     /* 1641871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1641884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641905 */     // GIR_Coverage, 10881,
     /* 1641905 */     GIR_EraseRootFromParent_Done,
     /* 1641906 */   // Label 22496: @1641906
     /* 1641906 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1641992), // Rule ID 10884 //
     /* 1641911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1641919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1641922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1641925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1641928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1641931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641957 */     // MIs[0] policy
     /* 1641957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641967 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1641970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641991 */     // GIR_Coverage, 10884,
     /* 1641991 */     GIR_EraseRootFromParent_Done,
     /* 1641992 */   // Label 22497: @1641992
     /* 1641992 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1642078), // Rule ID 10885 //
     /* 1641997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1642017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642043 */     // MIs[0] policy
     /* 1642043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642053 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1642056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642077 */     // GIR_Coverage, 10885,
     /* 1642077 */     GIR_EraseRootFromParent_Done,
     /* 1642078 */   // Label 22498: @1642078
     /* 1642078 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1642164), // Rule ID 10888 //
     /* 1642083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1642086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1642103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642129 */     // MIs[0] policy
     /* 1642129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1642142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642163 */     // GIR_Coverage, 10888,
     /* 1642163 */     GIR_EraseRootFromParent_Done,
     /* 1642164 */   // Label 22499: @1642164
     /* 1642164 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1642250), // Rule ID 10889 //
     /* 1642169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1642172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1642189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642215 */     // MIs[0] policy
     /* 1642215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642225 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1642228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642249 */     // GIR_Coverage, 10889,
     /* 1642249 */     GIR_EraseRootFromParent_Done,
     /* 1642250 */   // Label 22500: @1642250
     /* 1642250 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1642336), // Rule ID 10892 //
     /* 1642255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1642258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1642275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642301 */     // MIs[0] policy
     /* 1642301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1642314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642335 */     // GIR_Coverage, 10892,
     /* 1642335 */     GIR_EraseRootFromParent_Done,
     /* 1642336 */   // Label 22501: @1642336
     /* 1642336 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1642422), // Rule ID 10893 //
     /* 1642341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1642344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1642361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642387 */     // MIs[0] policy
     /* 1642387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1642400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642421 */     // GIR_Coverage, 10893,
     /* 1642421 */     GIR_EraseRootFromParent_Done,
     /* 1642422 */   // Label 22502: @1642422
     /* 1642422 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1642508), // Rule ID 10896 //
     /* 1642427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1642430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1642447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642473 */     // MIs[0] policy
     /* 1642473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642483 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1642486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642507 */     // GIR_Coverage, 10896,
     /* 1642507 */     GIR_EraseRootFromParent_Done,
     /* 1642508 */   // Label 22503: @1642508
     /* 1642508 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1642594), // Rule ID 10897 //
     /* 1642513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1642516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1642533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642559 */     // MIs[0] policy
     /* 1642559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1642572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1642590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642593 */     // GIR_Coverage, 10897,
     /* 1642593 */     GIR_EraseRootFromParent_Done,
     /* 1642594 */   // Label 22504: @1642594
     /* 1642594 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1642680), // Rule ID 10900 //
     /* 1642599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1642610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1642613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1642616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642645 */     // MIs[0] policy
     /* 1642645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642655 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1642658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642679 */     // GIR_Coverage, 10900,
     /* 1642679 */     GIR_EraseRootFromParent_Done,
     /* 1642680 */   // Label 22505: @1642680
     /* 1642680 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1642766), // Rule ID 10901 //
     /* 1642685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1642696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1642699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1642702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642731 */     // MIs[0] policy
     /* 1642731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642741 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1642744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642765 */     // GIR_Coverage, 10901,
     /* 1642765 */     GIR_EraseRootFromParent_Done,
     /* 1642766 */   // Label 22506: @1642766
     /* 1642766 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1642852), // Rule ID 10904 //
     /* 1642771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1642782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1642785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1642788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642817 */     // MIs[0] policy
     /* 1642817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642827 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1642830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642851 */     // GIR_Coverage, 10904,
     /* 1642851 */     GIR_EraseRootFromParent_Done,
     /* 1642852 */   // Label 22507: @1642852
     /* 1642852 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1642938), // Rule ID 10905 //
     /* 1642857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1642868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1642871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1642874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642903 */     // MIs[0] policy
     /* 1642903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642913 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1642916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642937 */     // GIR_Coverage, 10905,
     /* 1642937 */     GIR_EraseRootFromParent_Done,
     /* 1642938 */   // Label 22508: @1642938
     /* 1642938 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1643024), // Rule ID 10908 //
     /* 1642943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1642951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1642954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1642957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1642960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642989 */     // MIs[0] policy
     /* 1642989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642999 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643023 */     // GIR_Coverage, 10908,
     /* 1643023 */     GIR_EraseRootFromParent_Done,
     /* 1643024 */   // Label 22509: @1643024
     /* 1643024 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1643110), // Rule ID 10909 //
     /* 1643029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1643040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1643043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1643046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643075 */     // MIs[0] policy
     /* 1643075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643085 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643109 */     // GIR_Coverage, 10909,
     /* 1643109 */     GIR_EraseRootFromParent_Done,
     /* 1643110 */   // Label 22510: @1643110
     /* 1643110 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1643196), // Rule ID 10912 //
     /* 1643115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643161 */     // MIs[0] policy
     /* 1643161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643171 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1643174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643195 */     // GIR_Coverage, 10912,
     /* 1643195 */     GIR_EraseRootFromParent_Done,
     /* 1643196 */   // Label 22511: @1643196
     /* 1643196 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1643282), // Rule ID 10913 //
     /* 1643201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643247 */     // MIs[0] policy
     /* 1643247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643257 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1643260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643281 */     // GIR_Coverage, 10913,
     /* 1643281 */     GIR_EraseRootFromParent_Done,
     /* 1643282 */   // Label 22512: @1643282
     /* 1643282 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1643368), // Rule ID 10916 //
     /* 1643287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643333 */     // MIs[0] policy
     /* 1643333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643367 */     // GIR_Coverage, 10916,
     /* 1643367 */     GIR_EraseRootFromParent_Done,
     /* 1643368 */   // Label 22513: @1643368
     /* 1643368 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1643454), // Rule ID 10917 //
     /* 1643373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643419 */     // MIs[0] policy
     /* 1643419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643429 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643453 */     // GIR_Coverage, 10917,
     /* 1643453 */     GIR_EraseRootFromParent_Done,
     /* 1643454 */   // Label 22514: @1643454
     /* 1643454 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1643540), // Rule ID 10920 //
     /* 1643459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1643470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1643473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1643476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643505 */     // MIs[0] policy
     /* 1643505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643515 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643539 */     // GIR_Coverage, 10920,
     /* 1643539 */     GIR_EraseRootFromParent_Done,
     /* 1643540 */   // Label 22515: @1643540
     /* 1643540 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1643626), // Rule ID 10921 //
     /* 1643545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1643556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1643559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1643562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643591 */     // MIs[0] policy
     /* 1643591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1643604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643625 */     // GIR_Coverage, 10921,
     /* 1643625 */     GIR_EraseRootFromParent_Done,
     /* 1643626 */   // Label 22516: @1643626
     /* 1643626 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1643712), // Rule ID 10924 //
     /* 1643631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1643642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1643645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1643648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643677 */     // MIs[0] policy
     /* 1643677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643687 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1643690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643711 */     // GIR_Coverage, 10924,
     /* 1643711 */     GIR_EraseRootFromParent_Done,
     /* 1643712 */   // Label 22517: @1643712
     /* 1643712 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1643798), // Rule ID 10925 //
     /* 1643717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1643728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1643731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1643734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643763 */     // MIs[0] policy
     /* 1643763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643773 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1643776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643797 */     // GIR_Coverage, 10925,
     /* 1643797 */     GIR_EraseRootFromParent_Done,
     /* 1643798 */   // Label 22518: @1643798
     /* 1643798 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1643884), // Rule ID 10928 //
     /* 1643803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643849 */     // MIs[0] policy
     /* 1643849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643859 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1643862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643883 */     // GIR_Coverage, 10928,
     /* 1643883 */     GIR_EraseRootFromParent_Done,
     /* 1643884 */   // Label 22519: @1643884
     /* 1643884 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1643970), // Rule ID 10929 //
     /* 1643889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643935 */     // MIs[0] policy
     /* 1643935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1643948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643969 */     // GIR_Coverage, 10929,
     /* 1643969 */     GIR_EraseRootFromParent_Done,
     /* 1643970 */   // Label 22520: @1643970
     /* 1643970 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1644056), // Rule ID 10932 //
     /* 1643975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1643983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1643986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1643989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1643992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644021 */     // MIs[0] policy
     /* 1644021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644031 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1644034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644055 */     // GIR_Coverage, 10932,
     /* 1644055 */     GIR_EraseRootFromParent_Done,
     /* 1644056 */   // Label 22521: @1644056
     /* 1644056 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1644142), // Rule ID 10933 //
     /* 1644061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644107 */     // MIs[0] policy
     /* 1644107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1644120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644141 */     // GIR_Coverage, 10933,
     /* 1644141 */     GIR_EraseRootFromParent_Done,
     /* 1644142 */   // Label 22522: @1644142
     /* 1644142 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1644228), // Rule ID 10936 //
     /* 1644147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1644150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644193 */     // MIs[0] policy
     /* 1644193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644203 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1644206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1644224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644227 */     // GIR_Coverage, 10936,
     /* 1644227 */     GIR_EraseRootFromParent_Done,
     /* 1644228 */   // Label 22523: @1644228
     /* 1644228 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1644314), // Rule ID 10937 //
     /* 1644233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1644236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644279 */     // MIs[0] policy
     /* 1644279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644289 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1644292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1644310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644313 */     // GIR_Coverage, 10937,
     /* 1644313 */     GIR_EraseRootFromParent_Done,
     /* 1644314 */   // Label 22524: @1644314
     /* 1644314 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1644400), // Rule ID 10940 //
     /* 1644319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1644330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1644333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1644336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644365 */     // MIs[0] policy
     /* 1644365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1644378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644399 */     // GIR_Coverage, 10940,
     /* 1644399 */     GIR_EraseRootFromParent_Done,
     /* 1644400 */   // Label 22525: @1644400
     /* 1644400 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1644486), // Rule ID 10941 //
     /* 1644405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1644416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1644419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1644422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644451 */     // MIs[0] policy
     /* 1644451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1644464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644485 */     // GIR_Coverage, 10941,
     /* 1644485 */     GIR_EraseRootFromParent_Done,
     /* 1644486 */   // Label 22526: @1644486
     /* 1644486 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1644572), // Rule ID 10944 //
     /* 1644491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1644502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1644505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1644508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644537 */     // MIs[0] policy
     /* 1644537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644547 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1644550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644571 */     // GIR_Coverage, 10944,
     /* 1644571 */     GIR_EraseRootFromParent_Done,
     /* 1644572 */   // Label 22527: @1644572
     /* 1644572 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1644658), // Rule ID 10945 //
     /* 1644577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1644588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1644591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1644594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644623 */     // MIs[0] policy
     /* 1644623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644633 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1644636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644657 */     // GIR_Coverage, 10945,
     /* 1644657 */     GIR_EraseRootFromParent_Done,
     /* 1644658 */   // Label 22528: @1644658
     /* 1644658 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1644744), // Rule ID 10948 //
     /* 1644663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1644674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1644677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1644680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1644686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644709 */     // MIs[0] policy
     /* 1644709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1644722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644743 */     // GIR_Coverage, 10948,
     /* 1644743 */     GIR_EraseRootFromParent_Done,
     /* 1644744 */   // Label 22529: @1644744
     /* 1644744 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1644830), // Rule ID 10949 //
     /* 1644749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1644760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1644763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1644766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1644772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644795 */     // MIs[0] policy
     /* 1644795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644805 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1644808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644829 */     // GIR_Coverage, 10949,
     /* 1644829 */     GIR_EraseRootFromParent_Done,
     /* 1644830 */   // Label 22530: @1644830
     /* 1644830 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1644916), // Rule ID 10952 //
     /* 1644835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644881 */     // MIs[0] policy
     /* 1644881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1644894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644915 */     // GIR_Coverage, 10952,
     /* 1644915 */     GIR_EraseRootFromParent_Done,
     /* 1644916 */   // Label 22531: @1644916
     /* 1644916 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1645002), // Rule ID 10953 //
     /* 1644921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1644929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644967 */     // MIs[0] policy
     /* 1644967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1644980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645001 */     // GIR_Coverage, 10953,
     /* 1645001 */     GIR_EraseRootFromParent_Done,
     /* 1645002 */   // Label 22532: @1645002
     /* 1645002 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1645088), // Rule ID 10956 //
     /* 1645007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1645018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1645021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1645024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645053 */     // MIs[0] policy
     /* 1645053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645063 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1645066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645087 */     // GIR_Coverage, 10956,
     /* 1645087 */     GIR_EraseRootFromParent_Done,
     /* 1645088 */   // Label 22533: @1645088
     /* 1645088 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1645174), // Rule ID 10957 //
     /* 1645093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1645104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1645107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1645110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645139 */     // MIs[0] policy
     /* 1645139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1645152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645173 */     // GIR_Coverage, 10957,
     /* 1645173 */     GIR_EraseRootFromParent_Done,
     /* 1645174 */   // Label 22534: @1645174
     /* 1645174 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1645260), // Rule ID 10960 //
     /* 1645179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1645190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1645193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1645196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645225 */     // MIs[0] policy
     /* 1645225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645235 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1645238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645259 */     // GIR_Coverage, 10960,
     /* 1645259 */     GIR_EraseRootFromParent_Done,
     /* 1645260 */   // Label 22535: @1645260
     /* 1645260 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1645346), // Rule ID 10961 //
     /* 1645265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1645276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1645279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1645282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645311 */     // MIs[0] policy
     /* 1645311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1645324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645345 */     // GIR_Coverage, 10961,
     /* 1645345 */     GIR_EraseRootFromParent_Done,
     /* 1645346 */   // Label 22536: @1645346
     /* 1645346 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1645432), // Rule ID 10964 //
     /* 1645351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645397 */     // MIs[0] policy
     /* 1645397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1645410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645431 */     // GIR_Coverage, 10964,
     /* 1645431 */     GIR_EraseRootFromParent_Done,
     /* 1645432 */   // Label 22537: @1645432
     /* 1645432 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1645518), // Rule ID 10965 //
     /* 1645437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645483 */     // MIs[0] policy
     /* 1645483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1645496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645517 */     // GIR_Coverage, 10965,
     /* 1645517 */     GIR_EraseRootFromParent_Done,
     /* 1645518 */   // Label 22538: @1645518
     /* 1645518 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1645604), // Rule ID 10968 //
     /* 1645523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645569 */     // MIs[0] policy
     /* 1645569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645579 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1645582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645603 */     // GIR_Coverage, 10968,
     /* 1645603 */     GIR_EraseRootFromParent_Done,
     /* 1645604 */   // Label 22539: @1645604
     /* 1645604 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1645690), // Rule ID 10969 //
     /* 1645609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645655 */     // MIs[0] policy
     /* 1645655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1645668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645689 */     // GIR_Coverage, 10969,
     /* 1645689 */     GIR_EraseRootFromParent_Done,
     /* 1645690 */   // Label 22540: @1645690
     /* 1645690 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1645776), // Rule ID 10972 //
     /* 1645695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645741 */     // MIs[0] policy
     /* 1645741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645751 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1645754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645775 */     // GIR_Coverage, 10972,
     /* 1645775 */     GIR_EraseRootFromParent_Done,
     /* 1645776 */   // Label 22541: @1645776
     /* 1645776 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1645862), // Rule ID 10973 //
     /* 1645781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645827 */     // MIs[0] policy
     /* 1645827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645837 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1645840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645861 */     // GIR_Coverage, 10973,
     /* 1645861 */     GIR_EraseRootFromParent_Done,
     /* 1645862 */   // Label 22542: @1645862
     /* 1645862 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1645948), // Rule ID 10976 //
     /* 1645867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1645870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645913 */     // MIs[0] policy
     /* 1645913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1645926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1645944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645947 */     // GIR_Coverage, 10976,
     /* 1645947 */     GIR_EraseRootFromParent_Done,
     /* 1645948 */   // Label 22543: @1645948
     /* 1645948 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1646034), // Rule ID 10977 //
     /* 1645953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1645956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1645961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645999 */     // MIs[0] policy
     /* 1645999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1646012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1646030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646033 */     // GIR_Coverage, 10977,
     /* 1646033 */     GIR_EraseRootFromParent_Done,
     /* 1646034 */   // Label 22544: @1646034
     /* 1646034 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1646120), // Rule ID 10980 //
     /* 1646039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1646042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1646047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646085 */     // MIs[0] policy
     /* 1646085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646095 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1646098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1646116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646119 */     // GIR_Coverage, 10980,
     /* 1646119 */     GIR_EraseRootFromParent_Done,
     /* 1646120 */   // Label 22545: @1646120
     /* 1646120 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1646206), // Rule ID 10981 //
     /* 1646125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1646128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1646133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646171 */     // MIs[0] policy
     /* 1646171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1646184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1646202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646205 */     // GIR_Coverage, 10981,
     /* 1646205 */     GIR_EraseRootFromParent_Done,
     /* 1646206 */   // Label 22546: @1646206
     /* 1646206 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1646292), // Rule ID 10984 //
     /* 1646211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1646214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1646219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646257 */     // MIs[0] policy
     /* 1646257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646267 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1646270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1646288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646291 */     // GIR_Coverage, 10984,
     /* 1646291 */     GIR_EraseRootFromParent_Done,
     /* 1646292 */   // Label 22547: @1646292
     /* 1646292 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1646378), // Rule ID 10985 //
     /* 1646297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1646300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1646305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646343 */     // MIs[0] policy
     /* 1646343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646353 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1646356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1646374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646377 */     // GIR_Coverage, 10985,
     /* 1646377 */     GIR_EraseRootFromParent_Done,
     /* 1646378 */   // Label 22548: @1646378
     /* 1646378 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1646464), // Rule ID 10988 //
     /* 1646383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1646394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1646397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1646400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646429 */     // MIs[0] policy
     /* 1646429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1646442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646463 */     // GIR_Coverage, 10988,
     /* 1646463 */     GIR_EraseRootFromParent_Done,
     /* 1646464 */   // Label 22549: @1646464
     /* 1646464 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1646550), // Rule ID 10989 //
     /* 1646469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1646480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1646483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1646486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646515 */     // MIs[0] policy
     /* 1646515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1646528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646549 */     // GIR_Coverage, 10989,
     /* 1646549 */     GIR_EraseRootFromParent_Done,
     /* 1646550 */   // Label 22550: @1646550
     /* 1646550 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1646636), // Rule ID 10992 //
     /* 1646555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1646566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1646569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1646572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646601 */     // MIs[0] policy
     /* 1646601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646611 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1646614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646635 */     // GIR_Coverage, 10992,
     /* 1646635 */     GIR_EraseRootFromParent_Done,
     /* 1646636 */   // Label 22551: @1646636
     /* 1646636 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1646722), // Rule ID 10993 //
     /* 1646641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1646652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1646655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1646658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646687 */     // MIs[0] policy
     /* 1646687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1646700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646721 */     // GIR_Coverage, 10993,
     /* 1646721 */     GIR_EraseRootFromParent_Done,
     /* 1646722 */   // Label 22552: @1646722
     /* 1646722 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1646808), // Rule ID 10996 //
     /* 1646727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1646738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1646741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1646744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1646747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646773 */     // MIs[0] policy
     /* 1646773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646783 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1646786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646807 */     // GIR_Coverage, 10996,
     /* 1646807 */     GIR_EraseRootFromParent_Done,
     /* 1646808 */   // Label 22553: @1646808
     /* 1646808 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1646894), // Rule ID 10997 //
     /* 1646813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1646824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1646827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1646830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1646833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646859 */     // MIs[0] policy
     /* 1646859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646869 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1646872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646893 */     // GIR_Coverage, 10997,
     /* 1646893 */     GIR_EraseRootFromParent_Done,
     /* 1646894 */   // Label 22554: @1646894
     /* 1646894 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1646980), // Rule ID 11000 //
     /* 1646899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1646919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646945 */     // MIs[0] policy
     /* 1646945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646955 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1646958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646979 */     // GIR_Coverage, 11000,
     /* 1646979 */     GIR_EraseRootFromParent_Done,
     /* 1646980 */   // Label 22555: @1646980
     /* 1646980 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1647066), // Rule ID 11001 //
     /* 1646985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1646993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1647002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647031 */     // MIs[0] policy
     /* 1647031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647041 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1647044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647065 */     // GIR_Coverage, 11001,
     /* 1647065 */     GIR_EraseRootFromParent_Done,
     /* 1647066 */   // Label 22556: @1647066
     /* 1647066 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1647152), // Rule ID 11004 //
     /* 1647071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1647082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1647085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1647088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647117 */     // MIs[0] policy
     /* 1647117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1647130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647151 */     // GIR_Coverage, 11004,
     /* 1647151 */     GIR_EraseRootFromParent_Done,
     /* 1647152 */   // Label 22557: @1647152
     /* 1647152 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1647238), // Rule ID 11005 //
     /* 1647157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1647168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1647171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1647174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647203 */     // MIs[0] policy
     /* 1647203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647213 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1647216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647237 */     // GIR_Coverage, 11005,
     /* 1647237 */     GIR_EraseRootFromParent_Done,
     /* 1647238 */   // Label 22558: @1647238
     /* 1647238 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1647324), // Rule ID 11008 //
     /* 1647243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647289 */     // MIs[0] policy
     /* 1647289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647299 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1647302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647323 */     // GIR_Coverage, 11008,
     /* 1647323 */     GIR_EraseRootFromParent_Done,
     /* 1647324 */   // Label 22559: @1647324
     /* 1647324 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1647410), // Rule ID 11009 //
     /* 1647329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647375 */     // MIs[0] policy
     /* 1647375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647385 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1647388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647409 */     // GIR_Coverage, 11009,
     /* 1647409 */     GIR_EraseRootFromParent_Done,
     /* 1647410 */   // Label 22560: @1647410
     /* 1647410 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1647496), // Rule ID 11012 //
     /* 1647415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1647426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1647429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1647432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647461 */     // MIs[0] policy
     /* 1647461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647495 */     // GIR_Coverage, 11012,
     /* 1647495 */     GIR_EraseRootFromParent_Done,
     /* 1647496 */   // Label 22561: @1647496
     /* 1647496 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1647582), // Rule ID 11013 //
     /* 1647501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1647512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1647515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1647518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647547 */     // MIs[0] policy
     /* 1647547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647581 */     // GIR_Coverage, 11013,
     /* 1647581 */     GIR_EraseRootFromParent_Done,
     /* 1647582 */   // Label 22562: @1647582
     /* 1647582 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1647668), // Rule ID 11016 //
     /* 1647587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1647598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1647601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1647604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1647607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647633 */     // MIs[0] policy
     /* 1647633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647667 */     // GIR_Coverage, 11016,
     /* 1647667 */     GIR_EraseRootFromParent_Done,
     /* 1647668 */   // Label 22563: @1647668
     /* 1647668 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1647754), // Rule ID 11017 //
     /* 1647673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1647684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1647687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1647690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1647693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647719 */     // MIs[0] policy
     /* 1647719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647729 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647753 */     // GIR_Coverage, 11017,
     /* 1647753 */     GIR_EraseRootFromParent_Done,
     /* 1647754 */   // Label 22564: @1647754
     /* 1647754 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1647840), // Rule ID 11020 //
     /* 1647759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1647779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647805 */     // MIs[0] policy
     /* 1647805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647839 */     // GIR_Coverage, 11020,
     /* 1647839 */     GIR_EraseRootFromParent_Done,
     /* 1647840 */   // Label 22565: @1647840
     /* 1647840 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1647926), // Rule ID 11021 //
     /* 1647845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1647865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647891 */     // MIs[0] policy
     /* 1647891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1647904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647925 */     // GIR_Coverage, 11021,
     /* 1647925 */     GIR_EraseRootFromParent_Done,
     /* 1647926 */   // Label 22566: @1647926
     /* 1647926 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1648012), // Rule ID 11024 //
     /* 1647931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1647939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1647942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1647945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1647948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1647951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647977 */     // MIs[0] policy
     /* 1647977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1647990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648011 */     // GIR_Coverage, 11024,
     /* 1648011 */     GIR_EraseRootFromParent_Done,
     /* 1648012 */   // Label 22567: @1648012
     /* 1648012 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1648098), // Rule ID 11025 //
     /* 1648017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1648028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1648031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1648034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648063 */     // MIs[0] policy
     /* 1648063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648073 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1648076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648097 */     // GIR_Coverage, 11025,
     /* 1648097 */     GIR_EraseRootFromParent_Done,
     /* 1648098 */   // Label 22568: @1648098
     /* 1648098 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1648184), // Rule ID 11028 //
     /* 1648103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1648114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1648117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1648120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1648123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648149 */     // MIs[0] policy
     /* 1648149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648159 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1648162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648183 */     // GIR_Coverage, 11028,
     /* 1648183 */     GIR_EraseRootFromParent_Done,
     /* 1648184 */   // Label 22569: @1648184
     /* 1648184 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1648270), // Rule ID 11029 //
     /* 1648189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1648200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1648203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1648206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1648209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648235 */     // MIs[0] policy
     /* 1648235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648245 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1648248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648269 */     // GIR_Coverage, 11029,
     /* 1648269 */     GIR_EraseRootFromParent_Done,
     /* 1648270 */   // Label 22570: @1648270
     /* 1648270 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1648356), // Rule ID 11032 //
     /* 1648275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1648286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1648289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1648292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1648295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1648298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648321 */     // MIs[0] policy
     /* 1648321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648331 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1648334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648355 */     // GIR_Coverage, 11032,
     /* 1648355 */     GIR_EraseRootFromParent_Done,
     /* 1648356 */   // Label 22571: @1648356
     /* 1648356 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1648442), // Rule ID 11033 //
     /* 1648361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1648372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1648375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1648378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1648381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1648384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648407 */     // MIs[0] policy
     /* 1648407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648417 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1648420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648441 */     // GIR_Coverage, 11033,
     /* 1648441 */     GIR_EraseRootFromParent_Done,
     /* 1648442 */   // Label 22572: @1648442
     /* 1648442 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1648528), // Rule ID 11036 //
     /* 1648447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1648467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648493 */     // MIs[0] policy
     /* 1648493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1648506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648527 */     // GIR_Coverage, 11036,
     /* 1648527 */     GIR_EraseRootFromParent_Done,
     /* 1648528 */   // Label 22573: @1648528
     /* 1648528 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1648614), // Rule ID 11037 //
     /* 1648533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1648553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648579 */     // MIs[0] policy
     /* 1648579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1648592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648613 */     // GIR_Coverage, 11037,
     /* 1648613 */     GIR_EraseRootFromParent_Done,
     /* 1648614 */   // Label 22574: @1648614
     /* 1648614 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1648700), // Rule ID 11040 //
     /* 1648619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1648639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648665 */     // MIs[0] policy
     /* 1648665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648675 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1648678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648699 */     // GIR_Coverage, 11040,
     /* 1648699 */     GIR_EraseRootFromParent_Done,
     /* 1648700 */   // Label 22575: @1648700
     /* 1648700 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1648786), // Rule ID 11041 //
     /* 1648705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1648725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648751 */     // MIs[0] policy
     /* 1648751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648761 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1648764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648785 */     // GIR_Coverage, 11041,
     /* 1648785 */     GIR_EraseRootFromParent_Done,
     /* 1648786 */   // Label 22576: @1648786
     /* 1648786 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1648872), // Rule ID 11044 //
     /* 1648791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1648802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1648805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1648808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1648811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648837 */     // MIs[0] policy
     /* 1648837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648847 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1648850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648871 */     // GIR_Coverage, 11044,
     /* 1648871 */     GIR_EraseRootFromParent_Done,
     /* 1648872 */   // Label 22577: @1648872
     /* 1648872 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1648958), // Rule ID 11045 //
     /* 1648877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1648888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1648891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1648894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1648897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648923 */     // MIs[0] policy
     /* 1648923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648933 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1648936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648957 */     // GIR_Coverage, 11045,
     /* 1648957 */     GIR_EraseRootFromParent_Done,
     /* 1648958 */   // Label 22578: @1648958
     /* 1648958 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1649044), // Rule ID 11048 //
     /* 1648963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1648971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1648974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1648977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1648980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1648983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649009 */     // MIs[0] policy
     /* 1649009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1649022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649043 */     // GIR_Coverage, 11048,
     /* 1649043 */     GIR_EraseRootFromParent_Done,
     /* 1649044 */   // Label 22579: @1649044
     /* 1649044 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1649130), // Rule ID 11049 //
     /* 1649049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1649069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649095 */     // MIs[0] policy
     /* 1649095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1649108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649129 */     // GIR_Coverage, 11049,
     /* 1649129 */     GIR_EraseRootFromParent_Done,
     /* 1649130 */   // Label 22580: @1649130
     /* 1649130 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1649216), // Rule ID 11052 //
     /* 1649135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649181 */     // MIs[0] policy
     /* 1649181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1649194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649215 */     // GIR_Coverage, 11052,
     /* 1649215 */     GIR_EraseRootFromParent_Done,
     /* 1649216 */   // Label 22581: @1649216
     /* 1649216 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1649302), // Rule ID 11053 //
     /* 1649221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649267 */     // MIs[0] policy
     /* 1649267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1649280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649301 */     // GIR_Coverage, 11053,
     /* 1649301 */     GIR_EraseRootFromParent_Done,
     /* 1649302 */   // Label 22582: @1649302
     /* 1649302 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1649388), // Rule ID 11056 //
     /* 1649307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1649327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649353 */     // MIs[0] policy
     /* 1649353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649363 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1649366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649387 */     // GIR_Coverage, 11056,
     /* 1649387 */     GIR_EraseRootFromParent_Done,
     /* 1649388 */   // Label 22583: @1649388
     /* 1649388 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1649474), // Rule ID 11057 //
     /* 1649393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1649413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649439 */     // MIs[0] policy
     /* 1649439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649449 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1649452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649473 */     // GIR_Coverage, 11057,
     /* 1649473 */     GIR_EraseRootFromParent_Done,
     /* 1649474 */   // Label 22584: @1649474
     /* 1649474 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1649560), // Rule ID 11060 //
     /* 1649479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1649490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1649493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1649496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649525 */     // MIs[0] policy
     /* 1649525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1649538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649559 */     // GIR_Coverage, 11060,
     /* 1649559 */     GIR_EraseRootFromParent_Done,
     /* 1649560 */   // Label 22585: @1649560
     /* 1649560 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1649646), // Rule ID 11061 //
     /* 1649565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1649576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1649579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1649582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649611 */     // MIs[0] policy
     /* 1649611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649621 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1649624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649645 */     // GIR_Coverage, 11061,
     /* 1649645 */     GIR_EraseRootFromParent_Done,
     /* 1649646 */   // Label 22586: @1649646
     /* 1649646 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1649732), // Rule ID 11064 //
     /* 1649651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1649662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1649665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1649668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649697 */     // MIs[0] policy
     /* 1649697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1649710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649731 */     // GIR_Coverage, 11064,
     /* 1649731 */     GIR_EraseRootFromParent_Done,
     /* 1649732 */   // Label 22587: @1649732
     /* 1649732 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1649818), // Rule ID 11065 //
     /* 1649737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1649748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1649751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1649754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649783 */     // MIs[0] policy
     /* 1649783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649793 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1649796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649817 */     // GIR_Coverage, 11065,
     /* 1649817 */     GIR_EraseRootFromParent_Done,
     /* 1649818 */   // Label 22588: @1649818
     /* 1649818 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1649904), // Rule ID 11068 //
     /* 1649823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1649834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1649837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1649840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649869 */     // MIs[0] policy
     /* 1649869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649879 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1649882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649903 */     // GIR_Coverage, 11068,
     /* 1649903 */     GIR_EraseRootFromParent_Done,
     /* 1649904 */   // Label 22589: @1649904
     /* 1649904 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1649990), // Rule ID 11069 //
     /* 1649909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1649917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1649920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1649923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1649926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649955 */     // MIs[0] policy
     /* 1649955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649965 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1649968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649989 */     // GIR_Coverage, 11069,
     /* 1649989 */     GIR_EraseRootFromParent_Done,
     /* 1649990 */   // Label 22590: @1649990
     /* 1649990 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1650076), // Rule ID 11072 //
     /* 1649995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650041 */     // MIs[0] policy
     /* 1650041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1650054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650075 */     // GIR_Coverage, 11072,
     /* 1650075 */     GIR_EraseRootFromParent_Done,
     /* 1650076 */   // Label 22591: @1650076
     /* 1650076 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1650162), // Rule ID 11073 //
     /* 1650081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650127 */     // MIs[0] policy
     /* 1650127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1650140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650161 */     // GIR_Coverage, 11073,
     /* 1650161 */     GIR_EraseRootFromParent_Done,
     /* 1650162 */   // Label 22592: @1650162
     /* 1650162 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1650248), // Rule ID 11076 //
     /* 1650167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650213 */     // MIs[0] policy
     /* 1650213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1650226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650247 */     // GIR_Coverage, 11076,
     /* 1650247 */     GIR_EraseRootFromParent_Done,
     /* 1650248 */   // Label 22593: @1650248
     /* 1650248 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1650334), // Rule ID 11077 //
     /* 1650253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650299 */     // MIs[0] policy
     /* 1650299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1650312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650333 */     // GIR_Coverage, 11077,
     /* 1650333 */     GIR_EraseRootFromParent_Done,
     /* 1650334 */   // Label 22594: @1650334
     /* 1650334 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1650420), // Rule ID 11080 //
     /* 1650339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1650350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1650353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1650356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650385 */     // MIs[0] policy
     /* 1650385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650395 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1650398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650419 */     // GIR_Coverage, 11080,
     /* 1650419 */     GIR_EraseRootFromParent_Done,
     /* 1650420 */   // Label 22595: @1650420
     /* 1650420 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1650506), // Rule ID 11081 //
     /* 1650425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1650436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1650439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1650442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650471 */     // MIs[0] policy
     /* 1650471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650481 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1650484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650505 */     // GIR_Coverage, 11081,
     /* 1650505 */     GIR_EraseRootFromParent_Done,
     /* 1650506 */   // Label 22596: @1650506
     /* 1650506 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1650592), // Rule ID 11084 //
     /* 1650511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1650522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1650525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1650528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650557 */     // MIs[0] policy
     /* 1650557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650567 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1650570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650591 */     // GIR_Coverage, 11084,
     /* 1650591 */     GIR_EraseRootFromParent_Done,
     /* 1650592 */   // Label 22597: @1650592
     /* 1650592 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1650678), // Rule ID 11085 //
     /* 1650597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1650608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1650611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1650614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650643 */     // MIs[0] policy
     /* 1650643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650653 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1650656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650677 */     // GIR_Coverage, 11085,
     /* 1650677 */     GIR_EraseRootFromParent_Done,
     /* 1650678 */   // Label 22598: @1650678
     /* 1650678 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1650764), // Rule ID 11088 //
     /* 1650683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1650694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1650697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1650700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650729 */     // MIs[0] policy
     /* 1650729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1650742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650763 */     // GIR_Coverage, 11088,
     /* 1650763 */     GIR_EraseRootFromParent_Done,
     /* 1650764 */   // Label 22599: @1650764
     /* 1650764 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1650850), // Rule ID 11089 //
     /* 1650769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1650780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1650783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1650786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650815 */     // MIs[0] policy
     /* 1650815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1650828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650849 */     // GIR_Coverage, 11089,
     /* 1650849 */     GIR_EraseRootFromParent_Done,
     /* 1650850 */   // Label 22600: @1650850
     /* 1650850 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1650936), // Rule ID 11092 //
     /* 1650855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1650866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1650869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1650872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650901 */     // MIs[0] policy
     /* 1650901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1650914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650935 */     // GIR_Coverage, 11092,
     /* 1650935 */     GIR_EraseRootFromParent_Done,
     /* 1650936 */   // Label 22601: @1650936
     /* 1650936 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1651022), // Rule ID 11093 //
     /* 1650941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1650949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1650952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1650955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1650958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650987 */     // MIs[0] policy
     /* 1650987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650997 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1651000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651021 */     // GIR_Coverage, 11093,
     /* 1651021 */     GIR_EraseRootFromParent_Done,
     /* 1651022 */   // Label 22602: @1651022
     /* 1651022 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1651108), // Rule ID 11096 //
     /* 1651027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1651038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1651041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1651044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651073 */     // MIs[0] policy
     /* 1651073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1651086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651107 */     // GIR_Coverage, 11096,
     /* 1651107 */     GIR_EraseRootFromParent_Done,
     /* 1651108 */   // Label 22603: @1651108
     /* 1651108 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1651194), // Rule ID 11097 //
     /* 1651113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1651124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1651127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1651130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651159 */     // MIs[0] policy
     /* 1651159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1651172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651193 */     // GIR_Coverage, 11097,
     /* 1651193 */     GIR_EraseRootFromParent_Done,
     /* 1651194 */   // Label 22604: @1651194
     /* 1651194 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1651280), // Rule ID 11100 //
     /* 1651199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1651210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1651213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1651216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651245 */     // MIs[0] policy
     /* 1651245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651255 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1651258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651279 */     // GIR_Coverage, 11100,
     /* 1651279 */     GIR_EraseRootFromParent_Done,
     /* 1651280 */   // Label 22605: @1651280
     /* 1651280 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1651366), // Rule ID 11101 //
     /* 1651285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1651296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1651299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1651302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651331 */     // MIs[0] policy
     /* 1651331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651341 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1651344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651365 */     // GIR_Coverage, 11101,
     /* 1651365 */     GIR_EraseRootFromParent_Done,
     /* 1651366 */   // Label 22606: @1651366
     /* 1651366 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1651452), // Rule ID 11104 //
     /* 1651371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1651382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1651385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1651388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1651394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651417 */     // MIs[0] policy
     /* 1651417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1651430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651451 */     // GIR_Coverage, 11104,
     /* 1651451 */     GIR_EraseRootFromParent_Done,
     /* 1651452 */   // Label 22607: @1651452
     /* 1651452 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1651538), // Rule ID 11105 //
     /* 1651457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1651468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1651471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1651474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1651480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651503 */     // MIs[0] policy
     /* 1651503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651513 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1651516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651537 */     // GIR_Coverage, 11105,
     /* 1651537 */     GIR_EraseRootFromParent_Done,
     /* 1651538 */   // Label 22608: @1651538
     /* 1651538 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1651624), // Rule ID 11108 //
     /* 1651543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651589 */     // MIs[0] policy
     /* 1651589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1651602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651623 */     // GIR_Coverage, 11108,
     /* 1651623 */     GIR_EraseRootFromParent_Done,
     /* 1651624 */   // Label 22609: @1651624
     /* 1651624 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1651710), // Rule ID 11109 //
     /* 1651629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651675 */     // MIs[0] policy
     /* 1651675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1651688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651709 */     // GIR_Coverage, 11109,
     /* 1651709 */     GIR_EraseRootFromParent_Done,
     /* 1651710 */   // Label 22610: @1651710
     /* 1651710 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1651796), // Rule ID 11112 //
     /* 1651715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651761 */     // MIs[0] policy
     /* 1651761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1651774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651795 */     // GIR_Coverage, 11112,
     /* 1651795 */     GIR_EraseRootFromParent_Done,
     /* 1651796 */   // Label 22611: @1651796
     /* 1651796 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1651882), // Rule ID 11113 //
     /* 1651801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651847 */     // MIs[0] policy
     /* 1651847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651857 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1651860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651881 */     // GIR_Coverage, 11113,
     /* 1651881 */     GIR_EraseRootFromParent_Done,
     /* 1651882 */   // Label 22612: @1651882
     /* 1651882 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1651968), // Rule ID 11116 //
     /* 1651887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651933 */     // MIs[0] policy
     /* 1651933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1651946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651967 */     // GIR_Coverage, 11116,
     /* 1651967 */     GIR_EraseRootFromParent_Done,
     /* 1651968 */   // Label 22613: @1651968
     /* 1651968 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1652054), // Rule ID 11117 //
     /* 1651973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1651981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652019 */     // MIs[0] policy
     /* 1652019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1652032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652053 */     // GIR_Coverage, 11117,
     /* 1652053 */     GIR_EraseRootFromParent_Done,
     /* 1652054 */   // Label 22614: @1652054
     /* 1652054 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1652140), // Rule ID 11120 //
     /* 1652059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652105 */     // MIs[0] policy
     /* 1652105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1652118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652139 */     // GIR_Coverage, 11120,
     /* 1652139 */     GIR_EraseRootFromParent_Done,
     /* 1652140 */   // Label 22615: @1652140
     /* 1652140 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1652226), // Rule ID 11121 //
     /* 1652145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652191 */     // MIs[0] policy
     /* 1652191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1652204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652225 */     // GIR_Coverage, 11121,
     /* 1652225 */     GIR_EraseRootFromParent_Done,
     /* 1652226 */   // Label 22616: @1652226
     /* 1652226 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1652312), // Rule ID 11124 //
     /* 1652231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652277 */     // MIs[0] policy
     /* 1652277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652287 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1652290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652311 */     // GIR_Coverage, 11124,
     /* 1652311 */     GIR_EraseRootFromParent_Done,
     /* 1652312 */   // Label 22617: @1652312
     /* 1652312 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1652398), // Rule ID 11125 //
     /* 1652317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652363 */     // MIs[0] policy
     /* 1652363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652373 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1652376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652397 */     // GIR_Coverage, 11125,
     /* 1652397 */     GIR_EraseRootFromParent_Done,
     /* 1652398 */   // Label 22618: @1652398
     /* 1652398 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1652484), // Rule ID 11128 //
     /* 1652403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652449 */     // MIs[0] policy
     /* 1652449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1652462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652483 */     // GIR_Coverage, 11128,
     /* 1652483 */     GIR_EraseRootFromParent_Done,
     /* 1652484 */   // Label 22619: @1652484
     /* 1652484 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1652570), // Rule ID 11129 //
     /* 1652489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1652497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652535 */     // MIs[0] policy
     /* 1652535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652545 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1652548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652569 */     // GIR_Coverage, 11129,
     /* 1652569 */     GIR_EraseRootFromParent_Done,
     /* 1652570 */   // Label 22620: @1652570
     /* 1652570 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1652656), // Rule ID 11132 //
     /* 1652575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1652583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1652586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1652589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1652592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1652595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652621 */     // MIs[0] policy
     /* 1652621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652631 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1652634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652655 */     // GIR_Coverage, 11132,
     /* 1652655 */     GIR_EraseRootFromParent_Done,
     /* 1652656 */   // Label 22621: @1652656
     /* 1652656 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1652742), // Rule ID 11133 //
     /* 1652661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1652669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1652672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1652675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1652678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1652681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652707 */     // MIs[0] policy
     /* 1652707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652717 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1652720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652741 */     // GIR_Coverage, 11133,
     /* 1652741 */     GIR_EraseRootFromParent_Done,
     /* 1652742 */   // Label 22622: @1652742
     /* 1652742 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1652828), // Rule ID 11136 //
     /* 1652747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1652755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1652758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1652761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1652764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1652767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652793 */     // MIs[0] policy
     /* 1652793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652803 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1652806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652827 */     // GIR_Coverage, 11136,
     /* 1652827 */     GIR_EraseRootFromParent_Done,
     /* 1652828 */   // Label 22623: @1652828
     /* 1652828 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1652914), // Rule ID 11137 //
     /* 1652833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1652841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1652844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1652847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1652850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1652853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652879 */     // MIs[0] policy
     /* 1652879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1652892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652913 */     // GIR_Coverage, 11137,
     /* 1652913 */     GIR_EraseRootFromParent_Done,
     /* 1652914 */   // Label 22624: @1652914
     /* 1652914 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1653000), // Rule ID 11140 //
     /* 1652919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1652927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1652930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1652933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1652936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1652939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652965 */     // MIs[0] policy
     /* 1652965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652975 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1652978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652999 */     // GIR_Coverage, 11140,
     /* 1652999 */     GIR_EraseRootFromParent_Done,
     /* 1653000 */   // Label 22625: @1653000
     /* 1653000 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1653086), // Rule ID 11141 //
     /* 1653005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1653016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1653019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1653022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1653025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653051 */     // MIs[0] policy
     /* 1653051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653061 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1653064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653085 */     // GIR_Coverage, 11141,
     /* 1653085 */     GIR_EraseRootFromParent_Done,
     /* 1653086 */   // Label 22626: @1653086
     /* 1653086 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1653172), // Rule ID 11144 //
     /* 1653091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653137 */     // MIs[0] policy
     /* 1653137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653147 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1653150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653171 */     // GIR_Coverage, 11144,
     /* 1653171 */     GIR_EraseRootFromParent_Done,
     /* 1653172 */   // Label 22627: @1653172
     /* 1653172 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1653258), // Rule ID 11145 //
     /* 1653177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653223 */     // MIs[0] policy
     /* 1653223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653233 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1653236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653257 */     // GIR_Coverage, 11145,
     /* 1653257 */     GIR_EraseRootFromParent_Done,
     /* 1653258 */   // Label 22628: @1653258
     /* 1653258 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1653344), // Rule ID 11148 //
     /* 1653263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1653274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1653277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1653280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1653283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653309 */     // MIs[0] policy
     /* 1653309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1653322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653343 */     // GIR_Coverage, 11148,
     /* 1653343 */     GIR_EraseRootFromParent_Done,
     /* 1653344 */   // Label 22629: @1653344
     /* 1653344 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1653430), // Rule ID 11149 //
     /* 1653349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1653360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1653363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1653366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1653369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653395 */     // MIs[0] policy
     /* 1653395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653405 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1653408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653429 */     // GIR_Coverage, 11149,
     /* 1653429 */     GIR_EraseRootFromParent_Done,
     /* 1653430 */   // Label 22630: @1653430
     /* 1653430 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1653516), // Rule ID 11152 //
     /* 1653435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1653446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1653449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1653452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1653455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653481 */     // MIs[0] policy
     /* 1653481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1653494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653515 */     // GIR_Coverage, 11152,
     /* 1653515 */     GIR_EraseRootFromParent_Done,
     /* 1653516 */   // Label 22631: @1653516
     /* 1653516 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1653602), // Rule ID 11153 //
     /* 1653521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1653532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1653535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1653538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1653541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653567 */     // MIs[0] policy
     /* 1653567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1653580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653601 */     // GIR_Coverage, 11153,
     /* 1653601 */     GIR_EraseRootFromParent_Done,
     /* 1653602 */   // Label 22632: @1653602
     /* 1653602 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1653688), // Rule ID 11156 //
     /* 1653607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1653618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1653621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1653624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1653627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653653 */     // MIs[0] policy
     /* 1653653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1653666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653687 */     // GIR_Coverage, 11156,
     /* 1653687 */     GIR_EraseRootFromParent_Done,
     /* 1653688 */   // Label 22633: @1653688
     /* 1653688 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1653774), // Rule ID 11157 //
     /* 1653693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1653704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1653707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1653710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1653713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653739 */     // MIs[0] policy
     /* 1653739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653749 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1653752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653773 */     // GIR_Coverage, 11157,
     /* 1653773 */     GIR_EraseRootFromParent_Done,
     /* 1653774 */   // Label 22634: @1653774
     /* 1653774 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1653860), // Rule ID 11160 //
     /* 1653779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1653790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1653793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1653796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1653799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653825 */     // MIs[0] policy
     /* 1653825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1653838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653859 */     // GIR_Coverage, 11160,
     /* 1653859 */     GIR_EraseRootFromParent_Done,
     /* 1653860 */   // Label 22635: @1653860
     /* 1653860 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1653946), // Rule ID 11161 //
     /* 1653865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1653876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1653879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1653882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1653885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653911 */     // MIs[0] policy
     /* 1653911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1653924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653945 */     // GIR_Coverage, 11161,
     /* 1653945 */     GIR_EraseRootFromParent_Done,
     /* 1653946 */   // Label 22636: @1653946
     /* 1653946 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1654032), // Rule ID 11164 //
     /* 1653951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1653959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1653962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1653965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1653968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1653971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653997 */     // MIs[0] policy
     /* 1653997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1654010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654031 */     // GIR_Coverage, 11164,
     /* 1654031 */     GIR_EraseRootFromParent_Done,
     /* 1654032 */   // Label 22637: @1654032
     /* 1654032 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1654118), // Rule ID 11165 //
     /* 1654037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1654048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1654051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1654054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654083 */     // MIs[0] policy
     /* 1654083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1654096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654117 */     // GIR_Coverage, 11165,
     /* 1654117 */     GIR_EraseRootFromParent_Done,
     /* 1654118 */   // Label 22638: @1654118
     /* 1654118 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1654204), // Rule ID 11168 //
     /* 1654123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1654134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1654137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1654140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1654143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654169 */     // MIs[0] policy
     /* 1654169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1654182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654203 */     // GIR_Coverage, 11168,
     /* 1654203 */     GIR_EraseRootFromParent_Done,
     /* 1654204 */   // Label 22639: @1654204
     /* 1654204 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1654290), // Rule ID 11169 //
     /* 1654209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1654220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1654223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1654226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1654229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654255 */     // MIs[0] policy
     /* 1654255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1654268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654289 */     // GIR_Coverage, 11169,
     /* 1654289 */     GIR_EraseRootFromParent_Done,
     /* 1654290 */   // Label 22640: @1654290
     /* 1654290 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1654376), // Rule ID 11172 //
     /* 1654295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1654306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1654309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1654312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1654315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1654318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654341 */     // MIs[0] policy
     /* 1654341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654351 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1654354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654375 */     // GIR_Coverage, 11172,
     /* 1654375 */     GIR_EraseRootFromParent_Done,
     /* 1654376 */   // Label 22641: @1654376
     /* 1654376 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1654462), // Rule ID 11173 //
     /* 1654381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1654392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1654395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1654398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1654401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1654404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654427 */     // MIs[0] policy
     /* 1654427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654437 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1654440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654461 */     // GIR_Coverage, 11173,
     /* 1654461 */     GIR_EraseRootFromParent_Done,
     /* 1654462 */   // Label 22642: @1654462
     /* 1654462 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1654548), // Rule ID 11176 //
     /* 1654467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1654478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1654481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1654484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1654487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1654490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654513 */     // MIs[0] policy
     /* 1654513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654523 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1654526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654547 */     // GIR_Coverage, 11176,
     /* 1654547 */     GIR_EraseRootFromParent_Done,
     /* 1654548 */   // Label 22643: @1654548
     /* 1654548 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1654634), // Rule ID 11177 //
     /* 1654553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1654564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1654567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1654570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1654573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1654576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654599 */     // MIs[0] policy
     /* 1654599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654609 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1654612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654633 */     // GIR_Coverage, 11177,
     /* 1654633 */     GIR_EraseRootFromParent_Done,
     /* 1654634 */   // Label 22644: @1654634
     /* 1654634 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1654720), // Rule ID 11180 //
     /* 1654639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1654650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1654653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1654656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1654659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654685 */     // MIs[0] policy
     /* 1654685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654695 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1654698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654719 */     // GIR_Coverage, 11180,
     /* 1654719 */     GIR_EraseRootFromParent_Done,
     /* 1654720 */   // Label 22645: @1654720
     /* 1654720 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1654806), // Rule ID 11181 //
     /* 1654725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1654736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1654739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1654742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1654745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654771 */     // MIs[0] policy
     /* 1654771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1654784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654805 */     // GIR_Coverage, 11181,
     /* 1654805 */     GIR_EraseRootFromParent_Done,
     /* 1654806 */   // Label 22646: @1654806
     /* 1654806 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1654892), // Rule ID 11184 //
     /* 1654811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1654822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1654825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1654828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1654831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654857 */     // MIs[0] policy
     /* 1654857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654867 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1654870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654891 */     // GIR_Coverage, 11184,
     /* 1654891 */     GIR_EraseRootFromParent_Done,
     /* 1654892 */   // Label 22647: @1654892
     /* 1654892 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1654978), // Rule ID 11185 //
     /* 1654897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1654908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1654911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1654914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1654917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654943 */     // MIs[0] policy
     /* 1654943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654953 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1654956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654977 */     // GIR_Coverage, 11185,
     /* 1654977 */     GIR_EraseRootFromParent_Done,
     /* 1654978 */   // Label 22648: @1654978
     /* 1654978 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1655064), // Rule ID 11188 //
     /* 1654983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1654991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1654994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1654997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655029 */     // MIs[0] policy
     /* 1655029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1655042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655063 */     // GIR_Coverage, 11188,
     /* 1655063 */     GIR_EraseRootFromParent_Done,
     /* 1655064 */   // Label 22649: @1655064
     /* 1655064 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1655150), // Rule ID 11189 //
     /* 1655069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655115 */     // MIs[0] policy
     /* 1655115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655125 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1655128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655149 */     // GIR_Coverage, 11189,
     /* 1655149 */     GIR_EraseRootFromParent_Done,
     /* 1655150 */   // Label 22650: @1655150
     /* 1655150 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1655236), // Rule ID 11192 //
     /* 1655155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1655166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1655169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1655172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1655175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655201 */     // MIs[0] policy
     /* 1655201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1655214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655235 */     // GIR_Coverage, 11192,
     /* 1655235 */     GIR_EraseRootFromParent_Done,
     /* 1655236 */   // Label 22651: @1655236
     /* 1655236 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1655322), // Rule ID 11193 //
     /* 1655241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1655252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1655255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1655258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1655261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655287 */     // MIs[0] policy
     /* 1655287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1655300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655321 */     // GIR_Coverage, 11193,
     /* 1655321 */     GIR_EraseRootFromParent_Done,
     /* 1655322 */   // Label 22652: @1655322
     /* 1655322 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1655408), // Rule ID 11196 //
     /* 1655327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1655338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1655341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1655344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1655347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655373 */     // MIs[0] policy
     /* 1655373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1655386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655407 */     // GIR_Coverage, 11196,
     /* 1655407 */     GIR_EraseRootFromParent_Done,
     /* 1655408 */   // Label 22653: @1655408
     /* 1655408 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1655494), // Rule ID 11197 //
     /* 1655413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1655424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1655427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1655430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1655433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655459 */     // MIs[0] policy
     /* 1655459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1655472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655493 */     // GIR_Coverage, 11197,
     /* 1655493 */     GIR_EraseRootFromParent_Done,
     /* 1655494 */   // Label 22654: @1655494
     /* 1655494 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1655580), // Rule ID 11200 //
     /* 1655499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1655510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1655513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1655516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1655519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655545 */     // MIs[0] policy
     /* 1655545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655555 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1655558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655579 */     // GIR_Coverage, 11200,
     /* 1655579 */     GIR_EraseRootFromParent_Done,
     /* 1655580 */   // Label 22655: @1655580
     /* 1655580 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1655666), // Rule ID 11201 //
     /* 1655585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1655596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1655599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1655602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1655605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655631 */     // MIs[0] policy
     /* 1655631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655641 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1655644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655665 */     // GIR_Coverage, 11201,
     /* 1655665 */     GIR_EraseRootFromParent_Done,
     /* 1655666 */   // Label 22656: @1655666
     /* 1655666 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1655752), // Rule ID 11204 //
     /* 1655671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1655682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1655685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1655688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655717 */     // MIs[0] policy
     /* 1655717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1655730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655751 */     // GIR_Coverage, 11204,
     /* 1655751 */     GIR_EraseRootFromParent_Done,
     /* 1655752 */   // Label 22657: @1655752
     /* 1655752 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1655838), // Rule ID 11205 //
     /* 1655757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1655768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1655771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1655774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655803 */     // MIs[0] policy
     /* 1655803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655813 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1655816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655837 */     // GIR_Coverage, 11205,
     /* 1655837 */     GIR_EraseRootFromParent_Done,
     /* 1655838 */   // Label 22658: @1655838
     /* 1655838 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1655924), // Rule ID 11208 //
     /* 1655843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1655854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1655857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1655860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655889 */     // MIs[0] policy
     /* 1655889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655899 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1655902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655923 */     // GIR_Coverage, 11208,
     /* 1655923 */     GIR_EraseRootFromParent_Done,
     /* 1655924 */   // Label 22659: @1655924
     /* 1655924 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1656010), // Rule ID 11209 //
     /* 1655929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1655937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1655940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1655943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1655946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655975 */     // MIs[0] policy
     /* 1655975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655985 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1655988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656009 */     // GIR_Coverage, 11209,
     /* 1656009 */     GIR_EraseRootFromParent_Done,
     /* 1656010 */   // Label 22660: @1656010
     /* 1656010 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1656096), // Rule ID 11212 //
     /* 1656015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1656026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1656029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1656032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656061 */     // MIs[0] policy
     /* 1656061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656095 */     // GIR_Coverage, 11212,
     /* 1656095 */     GIR_EraseRootFromParent_Done,
     /* 1656096 */   // Label 22661: @1656096
     /* 1656096 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1656182), // Rule ID 11213 //
     /* 1656101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1656112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1656115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1656118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656147 */     // MIs[0] policy
     /* 1656147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656157 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656181 */     // GIR_Coverage, 11213,
     /* 1656181 */     GIR_EraseRootFromParent_Done,
     /* 1656182 */   // Label 22662: @1656182
     /* 1656182 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1656268), // Rule ID 11216 //
     /* 1656187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1656198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1656201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1656204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656233 */     // MIs[0] policy
     /* 1656233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1656246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656267 */     // GIR_Coverage, 11216,
     /* 1656267 */     GIR_EraseRootFromParent_Done,
     /* 1656268 */   // Label 22663: @1656268
     /* 1656268 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1656354), // Rule ID 11217 //
     /* 1656273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1656284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1656287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1656290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656319 */     // MIs[0] policy
     /* 1656319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1656332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656353 */     // GIR_Coverage, 11217,
     /* 1656353 */     GIR_EraseRootFromParent_Done,
     /* 1656354 */   // Label 22664: @1656354
     /* 1656354 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1656440), // Rule ID 11220 //
     /* 1656359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1656370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1656373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1656376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656405 */     // MIs[0] policy
     /* 1656405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656415 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656439 */     // GIR_Coverage, 11220,
     /* 1656439 */     GIR_EraseRootFromParent_Done,
     /* 1656440 */   // Label 22665: @1656440
     /* 1656440 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1656526), // Rule ID 11221 //
     /* 1656445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1656456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1656459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1656462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656491 */     // MIs[0] policy
     /* 1656491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656525 */     // GIR_Coverage, 11221,
     /* 1656525 */     GIR_EraseRootFromParent_Done,
     /* 1656526 */   // Label 22666: @1656526
     /* 1656526 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1656612), // Rule ID 11224 //
     /* 1656531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1656542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1656545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1656548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656577 */     // MIs[0] policy
     /* 1656577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656587 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656611 */     // GIR_Coverage, 11224,
     /* 1656611 */     GIR_EraseRootFromParent_Done,
     /* 1656612 */   // Label 22667: @1656612
     /* 1656612 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1656698), // Rule ID 11225 //
     /* 1656617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1656628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1656631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1656634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656663 */     // MIs[0] policy
     /* 1656663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656673 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1656676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656697 */     // GIR_Coverage, 11225,
     /* 1656697 */     GIR_EraseRootFromParent_Done,
     /* 1656698 */   // Label 22668: @1656698
     /* 1656698 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1656784), // Rule ID 11228 //
     /* 1656703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1656714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1656717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1656720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656749 */     // MIs[0] policy
     /* 1656749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1656762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656783 */     // GIR_Coverage, 11228,
     /* 1656783 */     GIR_EraseRootFromParent_Done,
     /* 1656784 */   // Label 22669: @1656784
     /* 1656784 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1656870), // Rule ID 11229 //
     /* 1656789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1656800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1656803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1656806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656835 */     // MIs[0] policy
     /* 1656835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1656848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656869 */     // GIR_Coverage, 11229,
     /* 1656869 */     GIR_EraseRootFromParent_Done,
     /* 1656870 */   // Label 22670: @1656870
     /* 1656870 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1656956), // Rule ID 11232 //
     /* 1656875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1656886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1656889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1656892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656921 */     // MIs[0] policy
     /* 1656921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656931 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1656934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656955 */     // GIR_Coverage, 11232,
     /* 1656955 */     GIR_EraseRootFromParent_Done,
     /* 1656956 */   // Label 22671: @1656956
     /* 1656956 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1657042), // Rule ID 11233 //
     /* 1656961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1656969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1656972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1656975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1656978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657007 */     // MIs[0] policy
     /* 1657007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657017 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1657020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657041 */     // GIR_Coverage, 11233,
     /* 1657041 */     GIR_EraseRootFromParent_Done,
     /* 1657042 */   // Label 22672: @1657042
     /* 1657042 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1657128), // Rule ID 11236 //
     /* 1657047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1657058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1657061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1657064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657093 */     // MIs[0] policy
     /* 1657093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657103 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1657106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657127 */     // GIR_Coverage, 11236,
     /* 1657127 */     GIR_EraseRootFromParent_Done,
     /* 1657128 */   // Label 22673: @1657128
     /* 1657128 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1657214), // Rule ID 11237 //
     /* 1657133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1657144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1657147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1657150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657179 */     // MIs[0] policy
     /* 1657179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657189 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1657192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657213 */     // GIR_Coverage, 11237,
     /* 1657213 */     GIR_EraseRootFromParent_Done,
     /* 1657214 */   // Label 22674: @1657214
     /* 1657214 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1657300), // Rule ID 11240 //
     /* 1657219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1657230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1657233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1657236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657265 */     // MIs[0] policy
     /* 1657265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1657278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657299 */     // GIR_Coverage, 11240,
     /* 1657299 */     GIR_EraseRootFromParent_Done,
     /* 1657300 */   // Label 22675: @1657300
     /* 1657300 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1657386), // Rule ID 11241 //
     /* 1657305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1657316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1657319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1657322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657351 */     // MIs[0] policy
     /* 1657351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1657364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657385 */     // GIR_Coverage, 11241,
     /* 1657385 */     GIR_EraseRootFromParent_Done,
     /* 1657386 */   // Label 22676: @1657386
     /* 1657386 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1657472), // Rule ID 11244 //
     /* 1657391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1657402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1657405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1657408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1657414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657437 */     // MIs[0] policy
     /* 1657437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657447 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1657450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657471 */     // GIR_Coverage, 11244,
     /* 1657471 */     GIR_EraseRootFromParent_Done,
     /* 1657472 */   // Label 22677: @1657472
     /* 1657472 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1657558), // Rule ID 11245 //
     /* 1657477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1657488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1657491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1657494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1657500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657523 */     // MIs[0] policy
     /* 1657523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657533 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1657536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657557 */     // GIR_Coverage, 11245,
     /* 1657557 */     GIR_EraseRootFromParent_Done,
     /* 1657558 */   // Label 22678: @1657558
     /* 1657558 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1657644), // Rule ID 11248 //
     /* 1657563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1657574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1657577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1657580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1657586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657609 */     // MIs[0] policy
     /* 1657609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657619 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1657622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657643 */     // GIR_Coverage, 11248,
     /* 1657643 */     GIR_EraseRootFromParent_Done,
     /* 1657644 */   // Label 22679: @1657644
     /* 1657644 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1657730), // Rule ID 11249 //
     /* 1657649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1657660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1657663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1657666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1657672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657695 */     // MIs[0] policy
     /* 1657695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657705 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1657708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657729 */     // GIR_Coverage, 11249,
     /* 1657729 */     GIR_EraseRootFromParent_Done,
     /* 1657730 */   // Label 22680: @1657730
     /* 1657730 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1657816), // Rule ID 11252 //
     /* 1657735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1657746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1657749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1657752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657781 */     // MIs[0] policy
     /* 1657781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1657794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657815 */     // GIR_Coverage, 11252,
     /* 1657815 */     GIR_EraseRootFromParent_Done,
     /* 1657816 */   // Label 22681: @1657816
     /* 1657816 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1657902), // Rule ID 11253 //
     /* 1657821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1657832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1657835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1657838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657867 */     // MIs[0] policy
     /* 1657867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1657880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657901 */     // GIR_Coverage, 11253,
     /* 1657901 */     GIR_EraseRootFromParent_Done,
     /* 1657902 */   // Label 22682: @1657902
     /* 1657902 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1657988), // Rule ID 11256 //
     /* 1657907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1657915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1657918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1657921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1657924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657953 */     // MIs[0] policy
     /* 1657953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657963 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1657966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657987 */     // GIR_Coverage, 11256,
     /* 1657987 */     GIR_EraseRootFromParent_Done,
     /* 1657988 */   // Label 22683: @1657988
     /* 1657988 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1658074), // Rule ID 11257 //
     /* 1657993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1658004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1658007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1658010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658039 */     // MIs[0] policy
     /* 1658039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658049 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1658052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658073 */     // GIR_Coverage, 11257,
     /* 1658073 */     GIR_EraseRootFromParent_Done,
     /* 1658074 */   // Label 22684: @1658074
     /* 1658074 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1658160), // Rule ID 11260 //
     /* 1658079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1658090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1658093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1658096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1658102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658125 */     // MIs[0] policy
     /* 1658125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658135 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1658138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658159 */     // GIR_Coverage, 11260,
     /* 1658159 */     GIR_EraseRootFromParent_Done,
     /* 1658160 */   // Label 22685: @1658160
     /* 1658160 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1658246), // Rule ID 11261 //
     /* 1658165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1658176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1658179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1658182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1658188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658211 */     // MIs[0] policy
     /* 1658211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1658224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658245 */     // GIR_Coverage, 11261,
     /* 1658245 */     GIR_EraseRootFromParent_Done,
     /* 1658246 */   // Label 22686: @1658246
     /* 1658246 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1658332), // Rule ID 11264 //
     /* 1658251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1658262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1658265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1658268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658297 */     // MIs[0] policy
     /* 1658297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1658310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658331 */     // GIR_Coverage, 11264,
     /* 1658331 */     GIR_EraseRootFromParent_Done,
     /* 1658332 */   // Label 22687: @1658332
     /* 1658332 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1658418), // Rule ID 11265 //
     /* 1658337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1658348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1658351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1658354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658383 */     // MIs[0] policy
     /* 1658383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1658396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658417 */     // GIR_Coverage, 11265,
     /* 1658417 */     GIR_EraseRootFromParent_Done,
     /* 1658418 */   // Label 22688: @1658418
     /* 1658418 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1658504), // Rule ID 11268 //
     /* 1658423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1658434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1658437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1658440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658469 */     // MIs[0] policy
     /* 1658469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1658482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658503 */     // GIR_Coverage, 11268,
     /* 1658503 */     GIR_EraseRootFromParent_Done,
     /* 1658504 */   // Label 22689: @1658504
     /* 1658504 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1658590), // Rule ID 11269 //
     /* 1658509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1658520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1658523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1658526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658555 */     // MIs[0] policy
     /* 1658555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1658568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658589 */     // GIR_Coverage, 11269,
     /* 1658589 */     GIR_EraseRootFromParent_Done,
     /* 1658590 */   // Label 22690: @1658590
     /* 1658590 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1658676), // Rule ID 11272 //
     /* 1658595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1658606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1658609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1658612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658641 */     // MIs[0] policy
     /* 1658641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658651 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1658654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658675 */     // GIR_Coverage, 11272,
     /* 1658675 */     GIR_EraseRootFromParent_Done,
     /* 1658676 */   // Label 22691: @1658676
     /* 1658676 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1658762), // Rule ID 11273 //
     /* 1658681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1658689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1658692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1658695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1658698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658727 */     // MIs[0] policy
     /* 1658727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1658740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658761 */     // GIR_Coverage, 11273,
     /* 1658761 */     GIR_EraseRootFromParent_Done,
     /* 1658762 */   // Label 22692: @1658762
     /* 1658762 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1658848), // Rule ID 11276 //
     /* 1658767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1658775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1658787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658813 */     // MIs[0] policy
     /* 1658813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658823 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1658826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658847 */     // GIR_Coverage, 11276,
     /* 1658847 */     GIR_EraseRootFromParent_Done,
     /* 1658848 */   // Label 22693: @1658848
     /* 1658848 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1658934), // Rule ID 11277 //
     /* 1658853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1658861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1658873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658899 */     // MIs[0] policy
     /* 1658899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658909 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1658912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658933 */     // GIR_Coverage, 11277,
     /* 1658933 */     GIR_EraseRootFromParent_Done,
     /* 1658934 */   // Label 22694: @1658934
     /* 1658934 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1659020), // Rule ID 11280 //
     /* 1658939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1658947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1658950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1658953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1658956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1658959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658985 */     // MIs[0] policy
     /* 1658985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1658998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659019 */     // GIR_Coverage, 11280,
     /* 1659019 */     GIR_EraseRootFromParent_Done,
     /* 1659020 */   // Label 22695: @1659020
     /* 1659020 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1659106), // Rule ID 11281 //
     /* 1659025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1659036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1659039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1659042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1659045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659071 */     // MIs[0] policy
     /* 1659071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659081 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1659084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659105 */     // GIR_Coverage, 11281,
     /* 1659105 */     GIR_EraseRootFromParent_Done,
     /* 1659106 */   // Label 22696: @1659106
     /* 1659106 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1659192), // Rule ID 11284 //
     /* 1659111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1659122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1659125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1659128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1659131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659157 */     // MIs[0] policy
     /* 1659157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659167 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659191 */     // GIR_Coverage, 11284,
     /* 1659191 */     GIR_EraseRootFromParent_Done,
     /* 1659192 */   // Label 22697: @1659192
     /* 1659192 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1659278), // Rule ID 11285 //
     /* 1659197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1659208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1659211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1659214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1659217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659243 */     // MIs[0] policy
     /* 1659243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659253 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659277 */     // GIR_Coverage, 11285,
     /* 1659277 */     GIR_EraseRootFromParent_Done,
     /* 1659278 */   // Label 22698: @1659278
     /* 1659278 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1659364), // Rule ID 11288 //
     /* 1659283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1659294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1659297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1659300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1659303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659329 */     // MIs[0] policy
     /* 1659329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659339 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1659342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659363 */     // GIR_Coverage, 11288,
     /* 1659363 */     GIR_EraseRootFromParent_Done,
     /* 1659364 */   // Label 22699: @1659364
     /* 1659364 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1659450), // Rule ID 11289 //
     /* 1659369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1659380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1659383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1659386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1659389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659415 */     // MIs[0] policy
     /* 1659415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659425 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1659428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659449 */     // GIR_Coverage, 11289,
     /* 1659449 */     GIR_EraseRootFromParent_Done,
     /* 1659450 */   // Label 22700: @1659450
     /* 1659450 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1659536), // Rule ID 11292 //
     /* 1659455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1659466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1659469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1659472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1659475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659501 */     // MIs[0] policy
     /* 1659501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659535 */     // GIR_Coverage, 11292,
     /* 1659535 */     GIR_EraseRootFromParent_Done,
     /* 1659536 */   // Label 22701: @1659536
     /* 1659536 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1659622), // Rule ID 11293 //
     /* 1659541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1659552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1659555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1659558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1659561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659587 */     // MIs[0] policy
     /* 1659587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659597 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659621 */     // GIR_Coverage, 11293,
     /* 1659621 */     GIR_EraseRootFromParent_Done,
     /* 1659622 */   // Label 22702: @1659622
     /* 1659622 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1659708), // Rule ID 11296 //
     /* 1659627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1659638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1659641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1659644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1659647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659673 */     // MIs[0] policy
     /* 1659673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659707 */     // GIR_Coverage, 11296,
     /* 1659707 */     GIR_EraseRootFromParent_Done,
     /* 1659708 */   // Label 22703: @1659708
     /* 1659708 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1659794), // Rule ID 11297 //
     /* 1659713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1659724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1659727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1659730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1659733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659759 */     // MIs[0] policy
     /* 1659759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1659772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659793 */     // GIR_Coverage, 11297,
     /* 1659793 */     GIR_EraseRootFromParent_Done,
     /* 1659794 */   // Label 22704: @1659794
     /* 1659794 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1659880), // Rule ID 11300 //
     /* 1659799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1659819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659845 */     // MIs[0] policy
     /* 1659845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659855 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1659858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659879 */     // GIR_Coverage, 11300,
     /* 1659879 */     GIR_EraseRootFromParent_Done,
     /* 1659880 */   // Label 22705: @1659880
     /* 1659880 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1659966), // Rule ID 11301 //
     /* 1659885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1659905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659931 */     // MIs[0] policy
     /* 1659931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659941 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1659944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659965 */     // GIR_Coverage, 11301,
     /* 1659965 */     GIR_EraseRootFromParent_Done,
     /* 1659966 */   // Label 22706: @1659966
     /* 1659966 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1660052), // Rule ID 11304 //
     /* 1659971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1659979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1659982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1659985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1659988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1659991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660017 */     // MIs[0] policy
     /* 1660017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1660030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660051 */     // GIR_Coverage, 11304,
     /* 1660051 */     GIR_EraseRootFromParent_Done,
     /* 1660052 */   // Label 22707: @1660052
     /* 1660052 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1660138), // Rule ID 11305 //
     /* 1660057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1660068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1660071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1660074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1660077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660103 */     // MIs[0] policy
     /* 1660103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660113 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1660116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660137 */     // GIR_Coverage, 11305,
     /* 1660137 */     GIR_EraseRootFromParent_Done,
     /* 1660138 */   // Label 22708: @1660138
     /* 1660138 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1660224), // Rule ID 11308 //
     /* 1660143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1660154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1660157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1660160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1660163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660189 */     // MIs[0] policy
     /* 1660189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1660202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660223 */     // GIR_Coverage, 11308,
     /* 1660223 */     GIR_EraseRootFromParent_Done,
     /* 1660224 */   // Label 22709: @1660224
     /* 1660224 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1660310), // Rule ID 11309 //
     /* 1660229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1660240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1660243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1660246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1660249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660275 */     // MIs[0] policy
     /* 1660275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1660288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660309 */     // GIR_Coverage, 11309,
     /* 1660309 */     GIR_EraseRootFromParent_Done,
     /* 1660310 */   // Label 22710: @1660310
     /* 1660310 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1660396), // Rule ID 11312 //
     /* 1660315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1660326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1660329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1660332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1660335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660361 */     // MIs[0] policy
     /* 1660361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1660374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660395 */     // GIR_Coverage, 11312,
     /* 1660395 */     GIR_EraseRootFromParent_Done,
     /* 1660396 */   // Label 22711: @1660396
     /* 1660396 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1660482), // Rule ID 11313 //
     /* 1660401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1660412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1660415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1660418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1660421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660447 */     // MIs[0] policy
     /* 1660447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1660460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660481 */     // GIR_Coverage, 11313,
     /* 1660481 */     GIR_EraseRootFromParent_Done,
     /* 1660482 */   // Label 22712: @1660482
     /* 1660482 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1660568), // Rule ID 11316 //
     /* 1660487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1660498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1660501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1660504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1660507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660533 */     // MIs[0] policy
     /* 1660533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1660546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660567 */     // GIR_Coverage, 11316,
     /* 1660567 */     GIR_EraseRootFromParent_Done,
     /* 1660568 */   // Label 22713: @1660568
     /* 1660568 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1660654), // Rule ID 11317 //
     /* 1660573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1660584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1660587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1660590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1660593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660619 */     // MIs[0] policy
     /* 1660619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660629 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1660632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660653 */     // GIR_Coverage, 11317,
     /* 1660653 */     GIR_EraseRootFromParent_Done,
     /* 1660654 */   // Label 22714: @1660654
     /* 1660654 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1660740), // Rule ID 11320 //
     /* 1660659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1660679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660705 */     // MIs[0] policy
     /* 1660705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660715 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1660718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660739 */     // GIR_Coverage, 11320,
     /* 1660739 */     GIR_EraseRootFromParent_Done,
     /* 1660740 */   // Label 22715: @1660740
     /* 1660740 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1660826), // Rule ID 11321 //
     /* 1660745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1660765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660791 */     // MIs[0] policy
     /* 1660791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660801 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1660804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660825 */     // GIR_Coverage, 11321,
     /* 1660825 */     GIR_EraseRootFromParent_Done,
     /* 1660826 */   // Label 22716: @1660826
     /* 1660826 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1660912), // Rule ID 11324 //
     /* 1660831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1660851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660877 */     // MIs[0] policy
     /* 1660877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1660890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660911 */     // GIR_Coverage, 11324,
     /* 1660911 */     GIR_EraseRootFromParent_Done,
     /* 1660912 */   // Label 22717: @1660912
     /* 1660912 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1660998), // Rule ID 11325 //
     /* 1660917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1660925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1660937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660963 */     // MIs[0] policy
     /* 1660963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660973 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1660976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660997 */     // GIR_Coverage, 11325,
     /* 1660997 */     GIR_EraseRootFromParent_Done,
     /* 1660998 */   // Label 22718: @1660998
     /* 1660998 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1661084), // Rule ID 11328 //
     /* 1661003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1661014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1661017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1661020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1661023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661049 */     // MIs[0] policy
     /* 1661049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1661062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661083 */     // GIR_Coverage, 11328,
     /* 1661083 */     GIR_EraseRootFromParent_Done,
     /* 1661084 */   // Label 22719: @1661084
     /* 1661084 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1661170), // Rule ID 11329 //
     /* 1661089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1661100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1661103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1661106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1661109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661135 */     // MIs[0] policy
     /* 1661135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661145 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1661148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661169 */     // GIR_Coverage, 11329,
     /* 1661169 */     GIR_EraseRootFromParent_Done,
     /* 1661170 */   // Label 22720: @1661170
     /* 1661170 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1661256), // Rule ID 11332 //
     /* 1661175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1661186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1661189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1661192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1661195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1661198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661221 */     // MIs[0] policy
     /* 1661221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661231 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1661234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661255 */     // GIR_Coverage, 11332,
     /* 1661255 */     GIR_EraseRootFromParent_Done,
     /* 1661256 */   // Label 22721: @1661256
     /* 1661256 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1661342), // Rule ID 11333 //
     /* 1661261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1661272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1661275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1661278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1661281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1661284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661307 */     // MIs[0] policy
     /* 1661307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661317 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1661320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661341 */     // GIR_Coverage, 11333,
     /* 1661341 */     GIR_EraseRootFromParent_Done,
     /* 1661342 */   // Label 22722: @1661342
     /* 1661342 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1661428), // Rule ID 11336 //
     /* 1661347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1661358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1661361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1661364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1661367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661393 */     // MIs[0] policy
     /* 1661393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1661406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661427 */     // GIR_Coverage, 11336,
     /* 1661427 */     GIR_EraseRootFromParent_Done,
     /* 1661428 */   // Label 22723: @1661428
     /* 1661428 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1661514), // Rule ID 11337 //
     /* 1661433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1661444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1661447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1661450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1661453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661479 */     // MIs[0] policy
     /* 1661479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1661492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661513 */     // GIR_Coverage, 11337,
     /* 1661513 */     GIR_EraseRootFromParent_Done,
     /* 1661514 */   // Label 22724: @1661514
     /* 1661514 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1661600), // Rule ID 11340 //
     /* 1661519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1661530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1661533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1661536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1661539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661565 */     // MIs[0] policy
     /* 1661565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1661578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661599 */     // GIR_Coverage, 11340,
     /* 1661599 */     GIR_EraseRootFromParent_Done,
     /* 1661600 */   // Label 22725: @1661600
     /* 1661600 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1661686), // Rule ID 11341 //
     /* 1661605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1661616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1661619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1661622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1661625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661651 */     // MIs[0] policy
     /* 1661651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1661664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661685 */     // GIR_Coverage, 11341,
     /* 1661685 */     GIR_EraseRootFromParent_Done,
     /* 1661686 */   // Label 22726: @1661686
     /* 1661686 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1661772), // Rule ID 11344 //
     /* 1661691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1661711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661737 */     // MIs[0] policy
     /* 1661737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1661750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661771 */     // GIR_Coverage, 11344,
     /* 1661771 */     GIR_EraseRootFromParent_Done,
     /* 1661772 */   // Label 22727: @1661772
     /* 1661772 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1661858), // Rule ID 11345 //
     /* 1661777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1661797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661823 */     // MIs[0] policy
     /* 1661823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661833 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1661836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661857 */     // GIR_Coverage, 11345,
     /* 1661857 */     GIR_EraseRootFromParent_Done,
     /* 1661858 */   // Label 22728: @1661858
     /* 1661858 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1661944), // Rule ID 11348 //
     /* 1661863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661909 */     // MIs[0] policy
     /* 1661909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1661922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661943 */     // GIR_Coverage, 11348,
     /* 1661943 */     GIR_EraseRootFromParent_Done,
     /* 1661944 */   // Label 22729: @1661944
     /* 1661944 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1662030), // Rule ID 11349 //
     /* 1661949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1661957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661995 */     // MIs[0] policy
     /* 1661995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662005 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1662008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662029 */     // GIR_Coverage, 11349,
     /* 1662029 */     GIR_EraseRootFromParent_Done,
     /* 1662030 */   // Label 22730: @1662030
     /* 1662030 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1662116), // Rule ID 11352 //
     /* 1662035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662081 */     // MIs[0] policy
     /* 1662081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662091 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1662094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662115 */     // GIR_Coverage, 11352,
     /* 1662115 */     GIR_EraseRootFromParent_Done,
     /* 1662116 */   // Label 22731: @1662116
     /* 1662116 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1662202), // Rule ID 11353 //
     /* 1662121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662167 */     // MIs[0] policy
     /* 1662167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662177 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1662180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662201 */     // GIR_Coverage, 11353,
     /* 1662201 */     GIR_EraseRootFromParent_Done,
     /* 1662202 */   // Label 22732: @1662202
     /* 1662202 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1662288), // Rule ID 11356 //
     /* 1662207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662253 */     // MIs[0] policy
     /* 1662253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662263 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662287 */     // GIR_Coverage, 11356,
     /* 1662287 */     GIR_EraseRootFromParent_Done,
     /* 1662288 */   // Label 22733: @1662288
     /* 1662288 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1662374), // Rule ID 11357 //
     /* 1662293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662339 */     // MIs[0] policy
     /* 1662339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662349 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662373 */     // GIR_Coverage, 11357,
     /* 1662373 */     GIR_EraseRootFromParent_Done,
     /* 1662374 */   // Label 22734: @1662374
     /* 1662374 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1662460), // Rule ID 11360 //
     /* 1662379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1662390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1662393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1662396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662425 */     // MIs[0] policy
     /* 1662425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662435 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1662438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662459 */     // GIR_Coverage, 11360,
     /* 1662459 */     GIR_EraseRootFromParent_Done,
     /* 1662460 */   // Label 22735: @1662460
     /* 1662460 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1662546), // Rule ID 11361 //
     /* 1662465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1662476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1662479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1662482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662511 */     // MIs[0] policy
     /* 1662511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1662524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662545 */     // GIR_Coverage, 11361,
     /* 1662545 */     GIR_EraseRootFromParent_Done,
     /* 1662546 */   // Label 22736: @1662546
     /* 1662546 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1662632), // Rule ID 11364 //
     /* 1662551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662597 */     // MIs[0] policy
     /* 1662597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662631 */     // GIR_Coverage, 11364,
     /* 1662631 */     GIR_EraseRootFromParent_Done,
     /* 1662632 */   // Label 22737: @1662632
     /* 1662632 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1662718), // Rule ID 11365 //
     /* 1662637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662683 */     // MIs[0] policy
     /* 1662683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662717 */     // GIR_Coverage, 11365,
     /* 1662717 */     GIR_EraseRootFromParent_Done,
     /* 1662718 */   // Label 22738: @1662718
     /* 1662718 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1662804), // Rule ID 11368 //
     /* 1662723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662769 */     // MIs[0] policy
     /* 1662769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662779 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662803 */     // GIR_Coverage, 11368,
     /* 1662803 */     GIR_EraseRootFromParent_Done,
     /* 1662804 */   // Label 22739: @1662804
     /* 1662804 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1662890), // Rule ID 11369 //
     /* 1662809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662855 */     // MIs[0] policy
     /* 1662855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662865 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1662868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662889 */     // GIR_Coverage, 11369,
     /* 1662889 */     GIR_EraseRootFromParent_Done,
     /* 1662890 */   // Label 22740: @1662890
     /* 1662890 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1662976), // Rule ID 11372 //
     /* 1662895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662941 */     // MIs[0] policy
     /* 1662941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662951 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1662954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662975 */     // GIR_Coverage, 11372,
     /* 1662975 */     GIR_EraseRootFromParent_Done,
     /* 1662976 */   // Label 22741: @1662976
     /* 1662976 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1663062), // Rule ID 11373 //
     /* 1662981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1662989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663027 */     // MIs[0] policy
     /* 1663027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663037 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1663040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663061 */     // GIR_Coverage, 11373,
     /* 1663061 */     GIR_EraseRootFromParent_Done,
     /* 1663062 */   // Label 22742: @1663062
     /* 1663062 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1663148), // Rule ID 11376 //
     /* 1663067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663113 */     // MIs[0] policy
     /* 1663113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663123 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1663126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663147 */     // GIR_Coverage, 11376,
     /* 1663147 */     GIR_EraseRootFromParent_Done,
     /* 1663148 */   // Label 22743: @1663148
     /* 1663148 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1663234), // Rule ID 11377 //
     /* 1663153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663199 */     // MIs[0] policy
     /* 1663199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1663212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663233 */     // GIR_Coverage, 11377,
     /* 1663233 */     GIR_EraseRootFromParent_Done,
     /* 1663234 */   // Label 22744: @1663234
     /* 1663234 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1663320), // Rule ID 11380 //
     /* 1663239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663285 */     // MIs[0] policy
     /* 1663285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1663298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663319 */     // GIR_Coverage, 11380,
     /* 1663319 */     GIR_EraseRootFromParent_Done,
     /* 1663320 */   // Label 22745: @1663320
     /* 1663320 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1663406), // Rule ID 11381 //
     /* 1663325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663371 */     // MIs[0] policy
     /* 1663371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663381 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1663384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663405 */     // GIR_Coverage, 11381,
     /* 1663405 */     GIR_EraseRootFromParent_Done,
     /* 1663406 */   // Label 22746: @1663406
     /* 1663406 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1663492), // Rule ID 11384 //
     /* 1663411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663457 */     // MIs[0] policy
     /* 1663457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1663470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663491 */     // GIR_Coverage, 11384,
     /* 1663491 */     GIR_EraseRootFromParent_Done,
     /* 1663492 */   // Label 22747: @1663492
     /* 1663492 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1663578), // Rule ID 11385 //
     /* 1663497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663543 */     // MIs[0] policy
     /* 1663543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1663556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663577 */     // GIR_Coverage, 11385,
     /* 1663577 */     GIR_EraseRootFromParent_Done,
     /* 1663578 */   // Label 22748: @1663578
     /* 1663578 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1663664), // Rule ID 11388 //
     /* 1663583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663629 */     // MIs[0] policy
     /* 1663629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663639 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1663642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663663 */     // GIR_Coverage, 11388,
     /* 1663663 */     GIR_EraseRootFromParent_Done,
     /* 1663664 */   // Label 22749: @1663664
     /* 1663664 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1663750), // Rule ID 11389 //
     /* 1663669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663715 */     // MIs[0] policy
     /* 1663715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663725 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1663728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663749 */     // GIR_Coverage, 11389,
     /* 1663749 */     GIR_EraseRootFromParent_Done,
     /* 1663750 */   // Label 22750: @1663750
     /* 1663750 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1663836), // Rule ID 11392 //
     /* 1663755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663801 */     // MIs[0] policy
     /* 1663801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663811 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1663814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663835 */     // GIR_Coverage, 11392,
     /* 1663835 */     GIR_EraseRootFromParent_Done,
     /* 1663836 */   // Label 22751: @1663836
     /* 1663836 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1663922), // Rule ID 11393 //
     /* 1663841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663887 */     // MIs[0] policy
     /* 1663887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663897 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1663900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663921 */     // GIR_Coverage, 11393,
     /* 1663921 */     GIR_EraseRootFromParent_Done,
     /* 1663922 */   // Label 22752: @1663922
     /* 1663922 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1664008), // Rule ID 11396 //
     /* 1663927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1663935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663973 */     // MIs[0] policy
     /* 1663973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1663986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664007 */     // GIR_Coverage, 11396,
     /* 1664007 */     GIR_EraseRootFromParent_Done,
     /* 1664008 */   // Label 22753: @1664008
     /* 1664008 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1664094), // Rule ID 11397 //
     /* 1664013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1664024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1664027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1664030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664059 */     // MIs[0] policy
     /* 1664059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1664072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664093 */     // GIR_Coverage, 11397,
     /* 1664093 */     GIR_EraseRootFromParent_Done,
     /* 1664094 */   // Label 22754: @1664094
     /* 1664094 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1664180), // Rule ID 11400 //
     /* 1664099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664145 */     // MIs[0] policy
     /* 1664145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664155 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1664158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664179 */     // GIR_Coverage, 11400,
     /* 1664179 */     GIR_EraseRootFromParent_Done,
     /* 1664180 */   // Label 22755: @1664180
     /* 1664180 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1664266), // Rule ID 11401 //
     /* 1664185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664231 */     // MIs[0] policy
     /* 1664231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664241 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1664244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664265 */     // GIR_Coverage, 11401,
     /* 1664265 */     GIR_EraseRootFromParent_Done,
     /* 1664266 */   // Label 22756: @1664266
     /* 1664266 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1664352), // Rule ID 11404 //
     /* 1664271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664317 */     // MIs[0] policy
     /* 1664317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664327 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1664330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664351 */     // GIR_Coverage, 11404,
     /* 1664351 */     GIR_EraseRootFromParent_Done,
     /* 1664352 */   // Label 22757: @1664352
     /* 1664352 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1664438), // Rule ID 11405 //
     /* 1664357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664403 */     // MIs[0] policy
     /* 1664403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664413 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1664416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664437 */     // GIR_Coverage, 11405,
     /* 1664437 */     GIR_EraseRootFromParent_Done,
     /* 1664438 */   // Label 22758: @1664438
     /* 1664438 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1664524), // Rule ID 11408 //
     /* 1664443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664489 */     // MIs[0] policy
     /* 1664489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1664502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664523 */     // GIR_Coverage, 11408,
     /* 1664523 */     GIR_EraseRootFromParent_Done,
     /* 1664524 */   // Label 22759: @1664524
     /* 1664524 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1664610), // Rule ID 11409 //
     /* 1664529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664575 */     // MIs[0] policy
     /* 1664575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664585 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1664588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664609 */     // GIR_Coverage, 11409,
     /* 1664609 */     GIR_EraseRootFromParent_Done,
     /* 1664610 */   // Label 22760: @1664610
     /* 1664610 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1664696), // Rule ID 11412 //
     /* 1664615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664661 */     // MIs[0] policy
     /* 1664661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1664674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664695 */     // GIR_Coverage, 11412,
     /* 1664695 */     GIR_EraseRootFromParent_Done,
     /* 1664696 */   // Label 22761: @1664696
     /* 1664696 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1664782), // Rule ID 11413 //
     /* 1664701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664747 */     // MIs[0] policy
     /* 1664747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664757 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1664760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664781 */     // GIR_Coverage, 11413,
     /* 1664781 */     GIR_EraseRootFromParent_Done,
     /* 1664782 */   // Label 22762: @1664782
     /* 1664782 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1664868), // Rule ID 11416 //
     /* 1664787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664833 */     // MIs[0] policy
     /* 1664833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1664846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664867 */     // GIR_Coverage, 11416,
     /* 1664867 */     GIR_EraseRootFromParent_Done,
     /* 1664868 */   // Label 22763: @1664868
     /* 1664868 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1664954), // Rule ID 11417 //
     /* 1664873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1664881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664919 */     // MIs[0] policy
     /* 1664919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664929 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1664932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664953 */     // GIR_Coverage, 11417,
     /* 1664953 */     GIR_EraseRootFromParent_Done,
     /* 1664954 */   // Label 22764: @1664954
     /* 1664954 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1665040), // Rule ID 11420 //
     /* 1664959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1664962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1664967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1664970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1664973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1664976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1664979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665005 */     // MIs[0] policy
     /* 1665005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665015 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1665018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665039 */     // GIR_Coverage, 11420,
     /* 1665039 */     GIR_EraseRootFromParent_Done,
     /* 1665040 */   // Label 22765: @1665040
     /* 1665040 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1665126), // Rule ID 11421 //
     /* 1665045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1665056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1665059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1665062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1665065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665091 */     // MIs[0] policy
     /* 1665091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665101 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1665104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665125 */     // GIR_Coverage, 11421,
     /* 1665125 */     GIR_EraseRootFromParent_Done,
     /* 1665126 */   // Label 22766: @1665126
     /* 1665126 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1665212), // Rule ID 11424 //
     /* 1665131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1665151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665177 */     // MIs[0] policy
     /* 1665177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1665190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665211 */     // GIR_Coverage, 11424,
     /* 1665211 */     GIR_EraseRootFromParent_Done,
     /* 1665212 */   // Label 22767: @1665212
     /* 1665212 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1665298), // Rule ID 11425 //
     /* 1665217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1665237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665263 */     // MIs[0] policy
     /* 1665263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1665276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665297 */     // GIR_Coverage, 11425,
     /* 1665297 */     GIR_EraseRootFromParent_Done,
     /* 1665298 */   // Label 22768: @1665298
     /* 1665298 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1665384), // Rule ID 11428 //
     /* 1665303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1665323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665349 */     // MIs[0] policy
     /* 1665349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1665362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665383 */     // GIR_Coverage, 11428,
     /* 1665383 */     GIR_EraseRootFromParent_Done,
     /* 1665384 */   // Label 22769: @1665384
     /* 1665384 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1665470), // Rule ID 11429 //
     /* 1665389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1665409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665435 */     // MIs[0] policy
     /* 1665435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665445 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1665448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665469 */     // GIR_Coverage, 11429,
     /* 1665469 */     GIR_EraseRootFromParent_Done,
     /* 1665470 */   // Label 22770: @1665470
     /* 1665470 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1665556), // Rule ID 11432 //
     /* 1665475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665521 */     // MIs[0] policy
     /* 1665521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665531 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1665534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665555 */     // GIR_Coverage, 11432,
     /* 1665555 */     GIR_EraseRootFromParent_Done,
     /* 1665556 */   // Label 22771: @1665556
     /* 1665556 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1665642), // Rule ID 11433 //
     /* 1665561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665607 */     // MIs[0] policy
     /* 1665607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665617 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1665620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665641 */     // GIR_Coverage, 11433,
     /* 1665641 */     GIR_EraseRootFromParent_Done,
     /* 1665642 */   // Label 22772: @1665642
     /* 1665642 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1665728), // Rule ID 11436 //
     /* 1665647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1665658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1665661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1665664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665693 */     // MIs[0] policy
     /* 1665693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665703 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1665706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665727 */     // GIR_Coverage, 11436,
     /* 1665727 */     GIR_EraseRootFromParent_Done,
     /* 1665728 */   // Label 22773: @1665728
     /* 1665728 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1665814), // Rule ID 11437 //
     /* 1665733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1665744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1665747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1665750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665779 */     // MIs[0] policy
     /* 1665779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1665792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665813 */     // GIR_Coverage, 11437,
     /* 1665813 */     GIR_EraseRootFromParent_Done,
     /* 1665814 */   // Label 22774: @1665814
     /* 1665814 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1665900), // Rule ID 11440 //
     /* 1665819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665865 */     // MIs[0] policy
     /* 1665865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1665878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665899 */     // GIR_Coverage, 11440,
     /* 1665899 */     GIR_EraseRootFromParent_Done,
     /* 1665900 */   // Label 22775: @1665900
     /* 1665900 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1665986), // Rule ID 11441 //
     /* 1665905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1665908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665951 */     // MIs[0] policy
     /* 1665951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1665964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665985 */     // GIR_Coverage, 11441,
     /* 1665985 */     GIR_EraseRootFromParent_Done,
     /* 1665986 */   // Label 22776: @1665986
     /* 1665986 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1666072), // Rule ID 11444 //
     /* 1665991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1665994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1665999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1666002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1666005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1666008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666037 */     // MIs[0] policy
     /* 1666037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1666050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666071 */     // GIR_Coverage, 11444,
     /* 1666071 */     GIR_EraseRootFromParent_Done,
     /* 1666072 */   // Label 22777: @1666072
     /* 1666072 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1666158), // Rule ID 11445 //
     /* 1666077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1666085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1666088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1666091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1666094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666123 */     // MIs[0] policy
     /* 1666123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1666136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666157 */     // GIR_Coverage, 11445,
     /* 1666157 */     GIR_EraseRootFromParent_Done,
     /* 1666158 */   // Label 22778: @1666158
     /* 1666158 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1666244), // Rule ID 11448 //
     /* 1666163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1666166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1666171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666209 */     // MIs[0] policy
     /* 1666209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666219 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1666222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666243 */     // GIR_Coverage, 11448,
     /* 1666243 */     GIR_EraseRootFromParent_Done,
     /* 1666244 */   // Label 22779: @1666244
     /* 1666244 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1666330), // Rule ID 11449 //
     /* 1666249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1666257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666295 */     // MIs[0] policy
     /* 1666295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666305 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1666308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666329 */     // GIR_Coverage, 11449,
     /* 1666329 */     GIR_EraseRootFromParent_Done,
     /* 1666330 */   // Label 22780: @1666330
     /* 1666330 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1666416), // Rule ID 11452 //
     /* 1666335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1666338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1666355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666381 */     // MIs[0] policy
     /* 1666381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1666394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666415 */     // GIR_Coverage, 11452,
     /* 1666415 */     GIR_EraseRootFromParent_Done,
     /* 1666416 */   // Label 22781: @1666416
     /* 1666416 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1666502), // Rule ID 11453 //
     /* 1666421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1666441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666467 */     // MIs[0] policy
     /* 1666467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1666480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666501 */     // GIR_Coverage, 11453,
     /* 1666501 */     GIR_EraseRootFromParent_Done,
     /* 1666502 */   // Label 22782: @1666502
     /* 1666502 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1666588), // Rule ID 11456 //
     /* 1666507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1666510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1666518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1666521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1666524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1666527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666553 */     // MIs[0] policy
     /* 1666553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666563 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1666566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666587 */     // GIR_Coverage, 11456,
     /* 1666587 */     GIR_EraseRootFromParent_Done,
     /* 1666588 */   // Label 22783: @1666588
     /* 1666588 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1666674), // Rule ID 11457 //
     /* 1666593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1666604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1666607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1666610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1666613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666639 */     // MIs[0] policy
     /* 1666639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1666652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666673 */     // GIR_Coverage, 11457,
     /* 1666673 */     GIR_EraseRootFromParent_Done,
     /* 1666674 */   // Label 22784: @1666674
     /* 1666674 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1666760), // Rule ID 11460 //
     /* 1666679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1666682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1666690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1666693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1666696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1666699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666725 */     // MIs[0] policy
     /* 1666725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666735 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1666738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666759 */     // GIR_Coverage, 11460,
     /* 1666759 */     GIR_EraseRootFromParent_Done,
     /* 1666760 */   // Label 22785: @1666760
     /* 1666760 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1666846), // Rule ID 11461 //
     /* 1666765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1666776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1666779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1666782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1666785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666811 */     // MIs[0] policy
     /* 1666811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666821 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1666824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666845 */     // GIR_Coverage, 11461,
     /* 1666845 */     GIR_EraseRootFromParent_Done,
     /* 1666846 */   // Label 22786: @1666846
     /* 1666846 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1666932), // Rule ID 11464 //
     /* 1666851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1666854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1666871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666897 */     // MIs[0] policy
     /* 1666897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666907 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1666910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666931 */     // GIR_Coverage, 11464,
     /* 1666931 */     GIR_EraseRootFromParent_Done,
     /* 1666932 */   // Label 22787: @1666932
     /* 1666932 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1667018), // Rule ID 11465 //
     /* 1666937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1666940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1666945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1666957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666983 */     // MIs[0] policy
     /* 1666983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666993 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1666996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667017 */     // GIR_Coverage, 11465,
     /* 1667017 */     GIR_EraseRootFromParent_Done,
     /* 1667018 */   // Label 22788: @1667018
     /* 1667018 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1667104), // Rule ID 11468 //
     /* 1667023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667069 */     // MIs[0] policy
     /* 1667069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667079 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1667082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667103 */     // GIR_Coverage, 11468,
     /* 1667103 */     GIR_EraseRootFromParent_Done,
     /* 1667104 */   // Label 22789: @1667104
     /* 1667104 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1667190), // Rule ID 11469 //
     /* 1667109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667155 */     // MIs[0] policy
     /* 1667155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667165 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1667168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667189 */     // GIR_Coverage, 11469,
     /* 1667189 */     GIR_EraseRootFromParent_Done,
     /* 1667190 */   // Label 22790: @1667190
     /* 1667190 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1667276), // Rule ID 11472 //
     /* 1667195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667241 */     // MIs[0] policy
     /* 1667241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1667254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667275 */     // GIR_Coverage, 11472,
     /* 1667275 */     GIR_EraseRootFromParent_Done,
     /* 1667276 */   // Label 22791: @1667276
     /* 1667276 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1667362), // Rule ID 11473 //
     /* 1667281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667327 */     // MIs[0] policy
     /* 1667327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1667340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667361 */     // GIR_Coverage, 11473,
     /* 1667361 */     GIR_EraseRootFromParent_Done,
     /* 1667362 */   // Label 22792: @1667362
     /* 1667362 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1667448), // Rule ID 11476 //
     /* 1667367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1667378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1667381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1667384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667413 */     // MIs[0] policy
     /* 1667413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667423 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1667426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667447 */     // GIR_Coverage, 11476,
     /* 1667447 */     GIR_EraseRootFromParent_Done,
     /* 1667448 */   // Label 22793: @1667448
     /* 1667448 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1667534), // Rule ID 11477 //
     /* 1667453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1667464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1667467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1667470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667499 */     // MIs[0] policy
     /* 1667499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667509 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1667512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667533 */     // GIR_Coverage, 11477,
     /* 1667533 */     GIR_EraseRootFromParent_Done,
     /* 1667534 */   // Label 22794: @1667534
     /* 1667534 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1667620), // Rule ID 11480 //
     /* 1667539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1667550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1667553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1667556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667585 */     // MIs[0] policy
     /* 1667585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667595 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1667598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667619 */     // GIR_Coverage, 11480,
     /* 1667619 */     GIR_EraseRootFromParent_Done,
     /* 1667620 */   // Label 22795: @1667620
     /* 1667620 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1667706), // Rule ID 11481 //
     /* 1667625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1667633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1667636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1667639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1667642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667671 */     // MIs[0] policy
     /* 1667671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667681 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1667684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667705 */     // GIR_Coverage, 11481,
     /* 1667705 */     GIR_EraseRootFromParent_Done,
     /* 1667706 */   // Label 22796: @1667706
     /* 1667706 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1667792), // Rule ID 11484 //
     /* 1667711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1667719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1667731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667757 */     // MIs[0] policy
     /* 1667757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667767 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1667770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667791 */     // GIR_Coverage, 11484,
     /* 1667791 */     GIR_EraseRootFromParent_Done,
     /* 1667792 */   // Label 22797: @1667792
     /* 1667792 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1667878), // Rule ID 11485 //
     /* 1667797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1667805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1667817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667843 */     // MIs[0] policy
     /* 1667843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667853 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1667856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667877 */     // GIR_Coverage, 11485,
     /* 1667877 */     GIR_EraseRootFromParent_Done,
     /* 1667878 */   // Label 22798: @1667878
     /* 1667878 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1667964), // Rule ID 11488 //
     /* 1667883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1667886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1667891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1667903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667929 */     // MIs[0] policy
     /* 1667929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1667942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667963 */     // GIR_Coverage, 11488,
     /* 1667963 */     GIR_EraseRootFromParent_Done,
     /* 1667964 */   // Label 22799: @1667964
     /* 1667964 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1668050), // Rule ID 11489 //
     /* 1667969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1667972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1667977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1667989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668015 */     // MIs[0] policy
     /* 1668015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1668028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668049 */     // GIR_Coverage, 11489,
     /* 1668049 */     GIR_EraseRootFromParent_Done,
     /* 1668050 */   // Label 22800: @1668050
     /* 1668050 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1668136), // Rule ID 11492 //
     /* 1668055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1668075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668101 */     // MIs[0] policy
     /* 1668101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1668114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668135 */     // GIR_Coverage, 11492,
     /* 1668135 */     GIR_EraseRootFromParent_Done,
     /* 1668136 */   // Label 22801: @1668136
     /* 1668136 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1668222), // Rule ID 11493 //
     /* 1668141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1668144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1668161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668187 */     // MIs[0] policy
     /* 1668187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668197 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1668200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668221 */     // GIR_Coverage, 11493,
     /* 1668221 */     GIR_EraseRootFromParent_Done,
     /* 1668222 */   // Label 22802: @1668222
     /* 1668222 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1668308), // Rule ID 11496 //
     /* 1668227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1668247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668273 */     // MIs[0] policy
     /* 1668273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1668286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668307 */     // GIR_Coverage, 11496,
     /* 1668307 */     GIR_EraseRootFromParent_Done,
     /* 1668308 */   // Label 22803: @1668308
     /* 1668308 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1668394), // Rule ID 11497 //
     /* 1668313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1668316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1668333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668359 */     // MIs[0] policy
     /* 1668359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1668372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668393 */     // GIR_Coverage, 11497,
     /* 1668393 */     GIR_EraseRootFromParent_Done,
     /* 1668394 */   // Label 22804: @1668394
     /* 1668394 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1668480), // Rule ID 11500 //
     /* 1668399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1668410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1668413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1668416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668445 */     // MIs[0] policy
     /* 1668445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668455 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1668458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668479 */     // GIR_Coverage, 11500,
     /* 1668479 */     GIR_EraseRootFromParent_Done,
     /* 1668480 */   // Label 22805: @1668480
     /* 1668480 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1668566), // Rule ID 11501 //
     /* 1668485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1668488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1668496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1668499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1668502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668531 */     // MIs[0] policy
     /* 1668531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668541 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1668544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668565 */     // GIR_Coverage, 11501,
     /* 1668565 */     GIR_EraseRootFromParent_Done,
     /* 1668566 */   // Label 22806: @1668566
     /* 1668566 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1668652), // Rule ID 11504 //
     /* 1668571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668617 */     // MIs[0] policy
     /* 1668617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1668630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668651 */     // GIR_Coverage, 11504,
     /* 1668651 */     GIR_EraseRootFromParent_Done,
     /* 1668652 */   // Label 22807: @1668652
     /* 1668652 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1668738), // Rule ID 11505 //
     /* 1668657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1668660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668703 */     // MIs[0] policy
     /* 1668703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1668716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668737 */     // GIR_Coverage, 11505,
     /* 1668737 */     GIR_EraseRootFromParent_Done,
     /* 1668738 */   // Label 22808: @1668738
     /* 1668738 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1668824), // Rule ID 11508 //
     /* 1668743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668789 */     // MIs[0] policy
     /* 1668789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1668802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668823 */     // GIR_Coverage, 11508,
     /* 1668823 */     GIR_EraseRootFromParent_Done,
     /* 1668824 */   // Label 22809: @1668824
     /* 1668824 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1668910), // Rule ID 11509 //
     /* 1668829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1668832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668875 */     // MIs[0] policy
     /* 1668875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668885 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1668888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668909 */     // GIR_Coverage, 11509,
     /* 1668909 */     GIR_EraseRootFromParent_Done,
     /* 1668910 */   // Label 22810: @1668910
     /* 1668910 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1668996), // Rule ID 11512 //
     /* 1668915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1668918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1668923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668961 */     // MIs[0] policy
     /* 1668961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668971 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1668974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668995 */     // GIR_Coverage, 11512,
     /* 1668995 */     GIR_EraseRootFromParent_Done,
     /* 1668996 */   // Label 22811: @1668996
     /* 1668996 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1669082), // Rule ID 11513 //
     /* 1669001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1669004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1669009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1669012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1669015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1669018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669047 */     // MIs[0] policy
     /* 1669047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1669060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669081 */     // GIR_Coverage, 11513,
     /* 1669081 */     GIR_EraseRootFromParent_Done,
     /* 1669082 */   // Label 22812: @1669082
     /* 1669082 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1669168), // Rule ID 11516 //
     /* 1669087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1669098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1669101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1669104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1669107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669133 */     // MIs[0] policy
     /* 1669133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669143 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1669146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669167 */     // GIR_Coverage, 11516,
     /* 1669167 */     GIR_EraseRootFromParent_Done,
     /* 1669168 */   // Label 22813: @1669168
     /* 1669168 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1669254), // Rule ID 11517 //
     /* 1669173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1669184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1669187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1669190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1669193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669219 */     // MIs[0] policy
     /* 1669219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669229 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1669232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669253 */     // GIR_Coverage, 11517,
     /* 1669253 */     GIR_EraseRootFromParent_Done,
     /* 1669254 */   // Label 22814: @1669254
     /* 1669254 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1669340), // Rule ID 11520 //
     /* 1669259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669305 */     // MIs[0] policy
     /* 1669305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1669318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669339 */     // GIR_Coverage, 11520,
     /* 1669339 */     GIR_EraseRootFromParent_Done,
     /* 1669340 */   // Label 22815: @1669340
     /* 1669340 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1669426), // Rule ID 11521 //
     /* 1669345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669391 */     // MIs[0] policy
     /* 1669391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1669404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669425 */     // GIR_Coverage, 11521,
     /* 1669425 */     GIR_EraseRootFromParent_Done,
     /* 1669426 */   // Label 22816: @1669426
     /* 1669426 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1669512), // Rule ID 11524 //
     /* 1669431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669477 */     // MIs[0] policy
     /* 1669477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669487 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1669490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669511 */     // GIR_Coverage, 11524,
     /* 1669511 */     GIR_EraseRootFromParent_Done,
     /* 1669512 */   // Label 22817: @1669512
     /* 1669512 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1669598), // Rule ID 11525 //
     /* 1669517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669563 */     // MIs[0] policy
     /* 1669563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669573 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1669576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669597 */     // GIR_Coverage, 11525,
     /* 1669597 */     GIR_EraseRootFromParent_Done,
     /* 1669598 */   // Label 22818: @1669598
     /* 1669598 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1669684), // Rule ID 11528 //
     /* 1669603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669649 */     // MIs[0] policy
     /* 1669649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1669662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669683 */     // GIR_Coverage, 11528,
     /* 1669683 */     GIR_EraseRootFromParent_Done,
     /* 1669684 */   // Label 22819: @1669684
     /* 1669684 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1669770), // Rule ID 11529 //
     /* 1669689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669735 */     // MIs[0] policy
     /* 1669735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669745 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1669748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669769 */     // GIR_Coverage, 11529,
     /* 1669769 */     GIR_EraseRootFromParent_Done,
     /* 1669770 */   // Label 22820: @1669770
     /* 1669770 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1669856), // Rule ID 11532 //
     /* 1669775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669821 */     // MIs[0] policy
     /* 1669821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669831 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1669834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669855 */     // GIR_Coverage, 11532,
     /* 1669855 */     GIR_EraseRootFromParent_Done,
     /* 1669856 */   // Label 22821: @1669856
     /* 1669856 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1669942), // Rule ID 11533 //
     /* 1669861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669907 */     // MIs[0] policy
     /* 1669907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669917 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1669920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669941 */     // GIR_Coverage, 11533,
     /* 1669941 */     GIR_EraseRootFromParent_Done,
     /* 1669942 */   // Label 22822: @1669942
     /* 1669942 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1670028), // Rule ID 11536 //
     /* 1669947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1669955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669993 */     // MIs[0] policy
     /* 1669993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670003 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1670006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670027 */     // GIR_Coverage, 11536,
     /* 1670027 */     GIR_EraseRootFromParent_Done,
     /* 1670028 */   // Label 22823: @1670028
     /* 1670028 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1670114), // Rule ID 11537 //
     /* 1670033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1670044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1670047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1670050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1670053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670079 */     // MIs[0] policy
     /* 1670079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1670092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670113 */     // GIR_Coverage, 11537,
     /* 1670113 */     GIR_EraseRootFromParent_Done,
     /* 1670114 */   // Label 22824: @1670114
     /* 1670114 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1670200), // Rule ID 11540 //
     /* 1670119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670165 */     // MIs[0] policy
     /* 1670165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670175 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1670178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670199 */     // GIR_Coverage, 11540,
     /* 1670199 */     GIR_EraseRootFromParent_Done,
     /* 1670200 */   // Label 22825: @1670200
     /* 1670200 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1670286), // Rule ID 11541 //
     /* 1670205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670251 */     // MIs[0] policy
     /* 1670251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670261 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1670264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670285 */     // GIR_Coverage, 11541,
     /* 1670285 */     GIR_EraseRootFromParent_Done,
     /* 1670286 */   // Label 22826: @1670286
     /* 1670286 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1670372), // Rule ID 11544 //
     /* 1670291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670337 */     // MIs[0] policy
     /* 1670337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1670350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670371 */     // GIR_Coverage, 11544,
     /* 1670371 */     GIR_EraseRootFromParent_Done,
     /* 1670372 */   // Label 22827: @1670372
     /* 1670372 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1670458), // Rule ID 11545 //
     /* 1670377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670423 */     // MIs[0] policy
     /* 1670423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670433 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1670436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670457 */     // GIR_Coverage, 11545,
     /* 1670457 */     GIR_EraseRootFromParent_Done,
     /* 1670458 */   // Label 22828: @1670458
     /* 1670458 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1670544), // Rule ID 11548 //
     /* 1670463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670509 */     // MIs[0] policy
     /* 1670509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1670522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670543 */     // GIR_Coverage, 11548,
     /* 1670543 */     GIR_EraseRootFromParent_Done,
     /* 1670544 */   // Label 22829: @1670544
     /* 1670544 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1670630), // Rule ID 11549 //
     /* 1670549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670595 */     // MIs[0] policy
     /* 1670595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1670608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670629 */     // GIR_Coverage, 11549,
     /* 1670629 */     GIR_EraseRootFromParent_Done,
     /* 1670630 */   // Label 22830: @1670630
     /* 1670630 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1670716), // Rule ID 11552 //
     /* 1670635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1670638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670681 */     // MIs[0] policy
     /* 1670681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1670694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670715 */     // GIR_Coverage, 11552,
     /* 1670715 */     GIR_EraseRootFromParent_Done,
     /* 1670716 */   // Label 22831: @1670716
     /* 1670716 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1670802), // Rule ID 11553 //
     /* 1670721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670767 */     // MIs[0] policy
     /* 1670767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1670780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670801 */     // GIR_Coverage, 11553,
     /* 1670801 */     GIR_EraseRootFromParent_Done,
     /* 1670802 */   // Label 22832: @1670802
     /* 1670802 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1670888), // Rule ID 11556 //
     /* 1670807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670853 */     // MIs[0] policy
     /* 1670853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1670866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670887 */     // GIR_Coverage, 11556,
     /* 1670887 */     GIR_EraseRootFromParent_Done,
     /* 1670888 */   // Label 22833: @1670888
     /* 1670888 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1670974), // Rule ID 11557 //
     /* 1670893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670939 */     // MIs[0] policy
     /* 1670939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1670952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670973 */     // GIR_Coverage, 11557,
     /* 1670973 */     GIR_EraseRootFromParent_Done,
     /* 1670974 */   // Label 22834: @1670974
     /* 1670974 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1671060), // Rule ID 11560 //
     /* 1670979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1670987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671025 */     // MIs[0] policy
     /* 1671025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671035 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1671038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671059 */     // GIR_Coverage, 11560,
     /* 1671059 */     GIR_EraseRootFromParent_Done,
     /* 1671060 */   // Label 22835: @1671060
     /* 1671060 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1671146), // Rule ID 11561 //
     /* 1671065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1671076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1671079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1671082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1671085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671111 */     // MIs[0] policy
     /* 1671111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1671124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671145 */     // GIR_Coverage, 11561,
     /* 1671145 */     GIR_EraseRootFromParent_Done,
     /* 1671146 */   // Label 22836: @1671146
     /* 1671146 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1671232), // Rule ID 11564 //
     /* 1671151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671197 */     // MIs[0] policy
     /* 1671197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671207 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1671210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671231 */     // GIR_Coverage, 11564,
     /* 1671231 */     GIR_EraseRootFromParent_Done,
     /* 1671232 */   // Label 22837: @1671232
     /* 1671232 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1671318), // Rule ID 11565 //
     /* 1671237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671283 */     // MIs[0] policy
     /* 1671283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1671296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671317 */     // GIR_Coverage, 11565,
     /* 1671317 */     GIR_EraseRootFromParent_Done,
     /* 1671318 */   // Label 22838: @1671318
     /* 1671318 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1671404), // Rule ID 11568 //
     /* 1671323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671369 */     // MIs[0] policy
     /* 1671369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1671382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671403 */     // GIR_Coverage, 11568,
     /* 1671403 */     GIR_EraseRootFromParent_Done,
     /* 1671404 */   // Label 22839: @1671404
     /* 1671404 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1671490), // Rule ID 11569 //
     /* 1671409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671455 */     // MIs[0] policy
     /* 1671455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1671468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671489 */     // GIR_Coverage, 11569,
     /* 1671489 */     GIR_EraseRootFromParent_Done,
     /* 1671490 */   // Label 22840: @1671490
     /* 1671490 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1671576), // Rule ID 11572 //
     /* 1671495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671541 */     // MIs[0] policy
     /* 1671541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1671554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671575 */     // GIR_Coverage, 11572,
     /* 1671575 */     GIR_EraseRootFromParent_Done,
     /* 1671576 */   // Label 22841: @1671576
     /* 1671576 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1671662), // Rule ID 11573 //
     /* 1671581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671627 */     // MIs[0] policy
     /* 1671627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671637 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1671640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671661 */     // GIR_Coverage, 11573,
     /* 1671661 */     GIR_EraseRootFromParent_Done,
     /* 1671662 */   // Label 22842: @1671662
     /* 1671662 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1671748), // Rule ID 11576 //
     /* 1671667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671713 */     // MIs[0] policy
     /* 1671713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671723 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1671726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671747 */     // GIR_Coverage, 11576,
     /* 1671747 */     GIR_EraseRootFromParent_Done,
     /* 1671748 */   // Label 22843: @1671748
     /* 1671748 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1671834), // Rule ID 11577 //
     /* 1671753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671799 */     // MIs[0] policy
     /* 1671799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1671812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671833 */     // GIR_Coverage, 11577,
     /* 1671833 */     GIR_EraseRootFromParent_Done,
     /* 1671834 */   // Label 22844: @1671834
     /* 1671834 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1671920), // Rule ID 11580 //
     /* 1671839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671885 */     // MIs[0] policy
     /* 1671885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1671898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671919 */     // GIR_Coverage, 11580,
     /* 1671919 */     GIR_EraseRootFromParent_Done,
     /* 1671920 */   // Label 22845: @1671920
     /* 1671920 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1672006), // Rule ID 11581 //
     /* 1671925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1671933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671971 */     // MIs[0] policy
     /* 1671971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1671984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672005 */     // GIR_Coverage, 11581,
     /* 1672005 */     GIR_EraseRootFromParent_Done,
     /* 1672006 */   // Label 22846: @1672006
     /* 1672006 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1672092), // Rule ID 11584 //
     /* 1672011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1672031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672057 */     // MIs[0] policy
     /* 1672057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1672070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672091 */     // GIR_Coverage, 11584,
     /* 1672091 */     GIR_EraseRootFromParent_Done,
     /* 1672092 */   // Label 22847: @1672092
     /* 1672092 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1672178), // Rule ID 11585 //
     /* 1672097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1672117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672143 */     // MIs[0] policy
     /* 1672143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672153 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1672156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672177 */     // GIR_Coverage, 11585,
     /* 1672177 */     GIR_EraseRootFromParent_Done,
     /* 1672178 */   // Label 22848: @1672178
     /* 1672178 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1672264), // Rule ID 11588 //
     /* 1672183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672229 */     // MIs[0] policy
     /* 1672229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1672242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672263 */     // GIR_Coverage, 11588,
     /* 1672263 */     GIR_EraseRootFromParent_Done,
     /* 1672264 */   // Label 22849: @1672264
     /* 1672264 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1672350), // Rule ID 11589 //
     /* 1672269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672315 */     // MIs[0] policy
     /* 1672315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1672328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672349 */     // GIR_Coverage, 11589,
     /* 1672349 */     GIR_EraseRootFromParent_Done,
     /* 1672350 */   // Label 22850: @1672350
     /* 1672350 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1672436), // Rule ID 11592 //
     /* 1672355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672401 */     // MIs[0] policy
     /* 1672401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1672414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672435 */     // GIR_Coverage, 11592,
     /* 1672435 */     GIR_EraseRootFromParent_Done,
     /* 1672436 */   // Label 22851: @1672436
     /* 1672436 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1672522), // Rule ID 11593 //
     /* 1672441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672487 */     // MIs[0] policy
     /* 1672487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1672500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672521 */     // GIR_Coverage, 11593,
     /* 1672521 */     GIR_EraseRootFromParent_Done,
     /* 1672522 */   // Label 22852: @1672522
     /* 1672522 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1672608), // Rule ID 11596 //
     /* 1672527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672573 */     // MIs[0] policy
     /* 1672573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672583 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1672586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672607 */     // GIR_Coverage, 11596,
     /* 1672607 */     GIR_EraseRootFromParent_Done,
     /* 1672608 */   // Label 22853: @1672608
     /* 1672608 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1672694), // Rule ID 11597 //
     /* 1672613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672659 */     // MIs[0] policy
     /* 1672659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672669 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1672672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672693 */     // GIR_Coverage, 11597,
     /* 1672693 */     GIR_EraseRootFromParent_Done,
     /* 1672694 */   // Label 22854: @1672694
     /* 1672694 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1672780), // Rule ID 11600 //
     /* 1672699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672745 */     // MIs[0] policy
     /* 1672745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672755 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1672758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672779 */     // GIR_Coverage, 11600,
     /* 1672779 */     GIR_EraseRootFromParent_Done,
     /* 1672780 */   // Label 22855: @1672780
     /* 1672780 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1672866), // Rule ID 11601 //
     /* 1672785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672831 */     // MIs[0] policy
     /* 1672831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672841 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1672844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672865 */     // GIR_Coverage, 11601,
     /* 1672865 */     GIR_EraseRootFromParent_Done,
     /* 1672866 */   // Label 22856: @1672866
     /* 1672866 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1672952), // Rule ID 11604 //
     /* 1672871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672917 */     // MIs[0] policy
     /* 1672917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1672930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672951 */     // GIR_Coverage, 11604,
     /* 1672951 */     GIR_EraseRootFromParent_Done,
     /* 1672952 */   // Label 22857: @1672952
     /* 1672952 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1673038), // Rule ID 11605 //
     /* 1672957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1672965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673003 */     // MIs[0] policy
     /* 1673003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673013 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1673016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673037 */     // GIR_Coverage, 11605,
     /* 1673037 */     GIR_EraseRootFromParent_Done,
     /* 1673038 */   // Label 22858: @1673038
     /* 1673038 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1673124), // Rule ID 11608 //
     /* 1673043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1673054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1673057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1673060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673089 */     // MIs[0] policy
     /* 1673089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673099 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1673102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673123 */     // GIR_Coverage, 11608,
     /* 1673123 */     GIR_EraseRootFromParent_Done,
     /* 1673124 */   // Label 22859: @1673124
     /* 1673124 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1673210), // Rule ID 11609 //
     /* 1673129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1673140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1673143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1673146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673175 */     // MIs[0] policy
     /* 1673175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673185 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1673188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673209 */     // GIR_Coverage, 11609,
     /* 1673209 */     GIR_EraseRootFromParent_Done,
     /* 1673210 */   // Label 22860: @1673210
     /* 1673210 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1673296), // Rule ID 11612 //
     /* 1673215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673261 */     // MIs[0] policy
     /* 1673261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1673274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673295 */     // GIR_Coverage, 11612,
     /* 1673295 */     GIR_EraseRootFromParent_Done,
     /* 1673296 */   // Label 22861: @1673296
     /* 1673296 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1673382), // Rule ID 11613 //
     /* 1673301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673347 */     // MIs[0] policy
     /* 1673347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673357 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1673360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673381 */     // GIR_Coverage, 11613,
     /* 1673381 */     GIR_EraseRootFromParent_Done,
     /* 1673382 */   // Label 22862: @1673382
     /* 1673382 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1673468), // Rule ID 11616 //
     /* 1673387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673433 */     // MIs[0] policy
     /* 1673433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1673446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673467 */     // GIR_Coverage, 11616,
     /* 1673467 */     GIR_EraseRootFromParent_Done,
     /* 1673468 */   // Label 22863: @1673468
     /* 1673468 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1673554), // Rule ID 11617 //
     /* 1673473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673519 */     // MIs[0] policy
     /* 1673519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1673532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673553 */     // GIR_Coverage, 11617,
     /* 1673553 */     GIR_EraseRootFromParent_Done,
     /* 1673554 */   // Label 22864: @1673554
     /* 1673554 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1673640), // Rule ID 11620 //
     /* 1673559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673605 */     // MIs[0] policy
     /* 1673605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1673618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673639 */     // GIR_Coverage, 11620,
     /* 1673639 */     GIR_EraseRootFromParent_Done,
     /* 1673640 */   // Label 22865: @1673640
     /* 1673640 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1673726), // Rule ID 11621 //
     /* 1673645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673691 */     // MIs[0] policy
     /* 1673691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1673704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673725 */     // GIR_Coverage, 11621,
     /* 1673725 */     GIR_EraseRootFromParent_Done,
     /* 1673726 */   // Label 22866: @1673726
     /* 1673726 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1673812), // Rule ID 11624 //
     /* 1673731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673777 */     // MIs[0] policy
     /* 1673777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673787 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1673790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673811 */     // GIR_Coverage, 11624,
     /* 1673811 */     GIR_EraseRootFromParent_Done,
     /* 1673812 */   // Label 22867: @1673812
     /* 1673812 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1673898), // Rule ID 11625 //
     /* 1673817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673863 */     // MIs[0] policy
     /* 1673863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1673876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673897 */     // GIR_Coverage, 11625,
     /* 1673897 */     GIR_EraseRootFromParent_Done,
     /* 1673898 */   // Label 22868: @1673898
     /* 1673898 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1673984), // Rule ID 11628 //
     /* 1673903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673949 */     // MIs[0] policy
     /* 1673949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1673962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673983 */     // GIR_Coverage, 11628,
     /* 1673983 */     GIR_EraseRootFromParent_Done,
     /* 1673984 */   // Label 22869: @1673984
     /* 1673984 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1674070), // Rule ID 11629 //
     /* 1673989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1673997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1674000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1674003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1674006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674035 */     // MIs[0] policy
     /* 1674035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674045 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10875:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1674048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674069 */     // GIR_Coverage, 11629,
     /* 1674069 */     GIR_EraseRootFromParent_Done,
     /* 1674070 */   // Label 22870: @1674070
     /* 1674070 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1674156), // Rule ID 11632 //
     /* 1674075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1674086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1674089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1674092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674121 */     // MIs[0] policy
     /* 1674121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1674134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674155 */     // GIR_Coverage, 11632,
     /* 1674155 */     GIR_EraseRootFromParent_Done,
     /* 1674156 */   // Label 22871: @1674156
     /* 1674156 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1674242), // Rule ID 11633 //
     /* 1674161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1674172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1674175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1674178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674207 */     // MIs[0] policy
     /* 1674207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1674220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674241 */     // GIR_Coverage, 11633,
     /* 1674241 */     GIR_EraseRootFromParent_Done,
     /* 1674242 */   // Label 22872: @1674242
     /* 1674242 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1674328), // Rule ID 11636 //
     /* 1674247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674293 */     // MIs[0] policy
     /* 1674293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1674306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674327 */     // GIR_Coverage, 11636,
     /* 1674327 */     GIR_EraseRootFromParent_Done,
     /* 1674328 */   // Label 22873: @1674328
     /* 1674328 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1674414), // Rule ID 11637 //
     /* 1674333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674379 */     // MIs[0] policy
     /* 1674379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674389 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1674392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674413 */     // GIR_Coverage, 11637,
     /* 1674413 */     GIR_EraseRootFromParent_Done,
     /* 1674414 */   // Label 22874: @1674414
     /* 1674414 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1674500), // Rule ID 11640 //
     /* 1674419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1674422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674465 */     // MIs[0] policy
     /* 1674465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1674478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674499 */     // GIR_Coverage, 11640,
     /* 1674499 */     GIR_EraseRootFromParent_Done,
     /* 1674500 */   // Label 22875: @1674500
     /* 1674500 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1674586), // Rule ID 11641 //
     /* 1674505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1674508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674551 */     // MIs[0] policy
     /* 1674551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1674564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674585 */     // GIR_Coverage, 11641,
     /* 1674585 */     GIR_EraseRootFromParent_Done,
     /* 1674586 */   // Label 22876: @1674586
     /* 1674586 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1674672), // Rule ID 11644 //
     /* 1674591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674637 */     // MIs[0] policy
     /* 1674637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1674650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674671 */     // GIR_Coverage, 11644,
     /* 1674671 */     GIR_EraseRootFromParent_Done,
     /* 1674672 */   // Label 22877: @1674672
     /* 1674672 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1674758), // Rule ID 11645 //
     /* 1674677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674723 */     // MIs[0] policy
     /* 1674723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1674736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674757 */     // GIR_Coverage, 11645,
     /* 1674757 */     GIR_EraseRootFromParent_Done,
     /* 1674758 */   // Label 22878: @1674758
     /* 1674758 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1674844), // Rule ID 11648 //
     /* 1674763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674809 */     // MIs[0] policy
     /* 1674809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674819 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1674822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674843 */     // GIR_Coverage, 11648,
     /* 1674843 */     GIR_EraseRootFromParent_Done,
     /* 1674844 */   // Label 22879: @1674844
     /* 1674844 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1674930), // Rule ID 11649 //
     /* 1674849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674895 */     // MIs[0] policy
     /* 1674895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674905 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1674908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674929 */     // GIR_Coverage, 11649,
     /* 1674929 */     GIR_EraseRootFromParent_Done,
     /* 1674930 */   // Label 22880: @1674930
     /* 1674930 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1675016), // Rule ID 11652 //
     /* 1674935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1674943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674981 */     // MIs[0] policy
     /* 1674981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674991 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1674994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675015 */     // GIR_Coverage, 11652,
     /* 1675015 */     GIR_EraseRootFromParent_Done,
     /* 1675016 */   // Label 22881: @1675016
     /* 1675016 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1675102), // Rule ID 11653 //
     /* 1675021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1675032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1675035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1675038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1675044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675067 */     // MIs[0] policy
     /* 1675067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675077 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1675080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675101 */     // GIR_Coverage, 11653,
     /* 1675101 */     GIR_EraseRootFromParent_Done,
     /* 1675102 */   // Label 22882: @1675102
     /* 1675102 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1675188), // Rule ID 11656 //
     /* 1675107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675153 */     // MIs[0] policy
     /* 1675153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1675166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675187 */     // GIR_Coverage, 11656,
     /* 1675187 */     GIR_EraseRootFromParent_Done,
     /* 1675188 */   // Label 22883: @1675188
     /* 1675188 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1675274), // Rule ID 11657 //
     /* 1675193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675239 */     // MIs[0] policy
     /* 1675239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1675252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675273 */     // GIR_Coverage, 11657,
     /* 1675273 */     GIR_EraseRootFromParent_Done,
     /* 1675274 */   // Label 22884: @1675274
     /* 1675274 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1675360), // Rule ID 11660 //
     /* 1675279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675325 */     // MIs[0] policy
     /* 1675325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675335 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1675338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675359 */     // GIR_Coverage, 11660,
     /* 1675359 */     GIR_EraseRootFromParent_Done,
     /* 1675360 */   // Label 22885: @1675360
     /* 1675360 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1675446), // Rule ID 11661 //
     /* 1675365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675411 */     // MIs[0] policy
     /* 1675411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675421 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1675424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675445 */     // GIR_Coverage, 11661,
     /* 1675445 */     GIR_EraseRootFromParent_Done,
     /* 1675446 */   // Label 22886: @1675446
     /* 1675446 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1675532), // Rule ID 11664 //
     /* 1675451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675497 */     // MIs[0] policy
     /* 1675497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675507 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1675510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675531 */     // GIR_Coverage, 11664,
     /* 1675531 */     GIR_EraseRootFromParent_Done,
     /* 1675532 */   // Label 22887: @1675532
     /* 1675532 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1675618), // Rule ID 11665 //
     /* 1675537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675583 */     // MIs[0] policy
     /* 1675583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1675596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675617 */     // GIR_Coverage, 11665,
     /* 1675617 */     GIR_EraseRootFromParent_Done,
     /* 1675618 */   // Label 22888: @1675618
     /* 1675618 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1675704), // Rule ID 11668 //
     /* 1675623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675669 */     // MIs[0] policy
     /* 1675669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1675682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675703 */     // GIR_Coverage, 11668,
     /* 1675703 */     GIR_EraseRootFromParent_Done,
     /* 1675704 */   // Label 22889: @1675704
     /* 1675704 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1675790), // Rule ID 11669 //
     /* 1675709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675755 */     // MIs[0] policy
     /* 1675755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1675768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675789 */     // GIR_Coverage, 11669,
     /* 1675789 */     GIR_EraseRootFromParent_Done,
     /* 1675790 */   // Label 22890: @1675790
     /* 1675790 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1675876), // Rule ID 11672 //
     /* 1675795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675841 */     // MIs[0] policy
     /* 1675841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1675854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675875 */     // GIR_Coverage, 11672,
     /* 1675875 */     GIR_EraseRootFromParent_Done,
     /* 1675876 */   // Label 22891: @1675876
     /* 1675876 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1675962), // Rule ID 11673 //
     /* 1675881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675927 */     // MIs[0] policy
     /* 1675927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1675940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675961 */     // GIR_Coverage, 11673,
     /* 1675961 */     GIR_EraseRootFromParent_Done,
     /* 1675962 */   // Label 22892: @1675962
     /* 1675962 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1676048), // Rule ID 11676 //
     /* 1675967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1675975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676013 */     // MIs[0] policy
     /* 1676013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676023 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1676026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676047 */     // GIR_Coverage, 11676,
     /* 1676047 */     GIR_EraseRootFromParent_Done,
     /* 1676048 */   // Label 22893: @1676048
     /* 1676048 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1676134), // Rule ID 11677 //
     /* 1676053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1676064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1676067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1676070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676099 */     // MIs[0] policy
     /* 1676099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1676112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676133 */     // GIR_Coverage, 11677,
     /* 1676133 */     GIR_EraseRootFromParent_Done,
     /* 1676134 */   // Label 22894: @1676134
     /* 1676134 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1676220), // Rule ID 11680 //
     /* 1676139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676185 */     // MIs[0] policy
     /* 1676185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1676198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676219 */     // GIR_Coverage, 11680,
     /* 1676219 */     GIR_EraseRootFromParent_Done,
     /* 1676220 */   // Label 22895: @1676220
     /* 1676220 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1676306), // Rule ID 11681 //
     /* 1676225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676271 */     // MIs[0] policy
     /* 1676271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1676284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676305 */     // GIR_Coverage, 11681,
     /* 1676305 */     GIR_EraseRootFromParent_Done,
     /* 1676306 */   // Label 22896: @1676306
     /* 1676306 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1676392), // Rule ID 11684 //
     /* 1676311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676357 */     // MIs[0] policy
     /* 1676357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1676370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676391 */     // GIR_Coverage, 11684,
     /* 1676391 */     GIR_EraseRootFromParent_Done,
     /* 1676392 */   // Label 22897: @1676392
     /* 1676392 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1676478), // Rule ID 11685 //
     /* 1676397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676443 */     // MIs[0] policy
     /* 1676443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676453 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1676456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676477 */     // GIR_Coverage, 11685,
     /* 1676477 */     GIR_EraseRootFromParent_Done,
     /* 1676478 */   // Label 22898: @1676478
     /* 1676478 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1676564), // Rule ID 11688 //
     /* 1676483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676529 */     // MIs[0] policy
     /* 1676529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1676542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676563 */     // GIR_Coverage, 11688,
     /* 1676563 */     GIR_EraseRootFromParent_Done,
     /* 1676564 */   // Label 22899: @1676564
     /* 1676564 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1676650), // Rule ID 11689 //
     /* 1676569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1676577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676615 */     // MIs[0] policy
     /* 1676615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1676628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676649 */     // GIR_Coverage, 11689,
     /* 1676649 */     GIR_EraseRootFromParent_Done,
     /* 1676650 */   // Label 22900: @1676650
     /* 1676650 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1676736), // Rule ID 11692 //
     /* 1676655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1676663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676701 */     // MIs[0] policy
     /* 1676701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676711 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1676714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676735 */     // GIR_Coverage, 11692,
     /* 1676735 */     GIR_EraseRootFromParent_Done,
     /* 1676736 */   // Label 22901: @1676736
     /* 1676736 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1676822), // Rule ID 11693 //
     /* 1676741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1676749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676787 */     // MIs[0] policy
     /* 1676787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676797 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1676800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676821 */     // GIR_Coverage, 11693,
     /* 1676821 */     GIR_EraseRootFromParent_Done,
     /* 1676822 */   // Label 22902: @1676822
     /* 1676822 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1676908), // Rule ID 11696 //
     /* 1676827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1676835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676873 */     // MIs[0] policy
     /* 1676873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676883 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1676886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676907 */     // GIR_Coverage, 11696,
     /* 1676907 */     GIR_EraseRootFromParent_Done,
     /* 1676908 */   // Label 22903: @1676908
     /* 1676908 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1676994), // Rule ID 11697 //
     /* 1676913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1676921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676959 */     // MIs[0] policy
     /* 1676959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1676972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676993 */     // GIR_Coverage, 11697,
     /* 1676993 */     GIR_EraseRootFromParent_Done,
     /* 1676994 */   // Label 22904: @1676994
     /* 1676994 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1677080), // Rule ID 11700 //
     /* 1676999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1677019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677045 */     // MIs[0] policy
     /* 1677045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677055 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1677058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677079 */     // GIR_Coverage, 11700,
     /* 1677079 */     GIR_EraseRootFromParent_Done,
     /* 1677080 */   // Label 22905: @1677080
     /* 1677080 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1677166), // Rule ID 11701 //
     /* 1677085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1677105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677131 */     // MIs[0] policy
     /* 1677131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677141 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1677144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677165 */     // GIR_Coverage, 11701,
     /* 1677165 */     GIR_EraseRootFromParent_Done,
     /* 1677166 */   // Label 22906: @1677166
     /* 1677166 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1677252), // Rule ID 11704 //
     /* 1677171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677217 */     // MIs[0] policy
     /* 1677217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677227 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1677230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677251 */     // GIR_Coverage, 11704,
     /* 1677251 */     GIR_EraseRootFromParent_Done,
     /* 1677252 */   // Label 22907: @1677252
     /* 1677252 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1677338), // Rule ID 11705 //
     /* 1677257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677303 */     // MIs[0] policy
     /* 1677303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677313 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1677316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677337 */     // GIR_Coverage, 11705,
     /* 1677337 */     GIR_EraseRootFromParent_Done,
     /* 1677338 */   // Label 22908: @1677338
     /* 1677338 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1677424), // Rule ID 11708 //
     /* 1677343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677389 */     // MIs[0] policy
     /* 1677389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1677402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677423 */     // GIR_Coverage, 11708,
     /* 1677423 */     GIR_EraseRootFromParent_Done,
     /* 1677424 */   // Label 22909: @1677424
     /* 1677424 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1677510), // Rule ID 11709 //
     /* 1677429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677475 */     // MIs[0] policy
     /* 1677475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1677488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677509 */     // GIR_Coverage, 11709,
     /* 1677509 */     GIR_EraseRootFromParent_Done,
     /* 1677510 */   // Label 22910: @1677510
     /* 1677510 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1677596), // Rule ID 11712 //
     /* 1677515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677561 */     // MIs[0] policy
     /* 1677561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677571 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1677574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677595 */     // GIR_Coverage, 11712,
     /* 1677595 */     GIR_EraseRootFromParent_Done,
     /* 1677596 */   // Label 22911: @1677596
     /* 1677596 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1677682), // Rule ID 11713 //
     /* 1677601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677647 */     // MIs[0] policy
     /* 1677647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677657 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1677660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677681 */     // GIR_Coverage, 11713,
     /* 1677681 */     GIR_EraseRootFromParent_Done,
     /* 1677682 */   // Label 22912: @1677682
     /* 1677682 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1677768), // Rule ID 11716 //
     /* 1677687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677733 */     // MIs[0] policy
     /* 1677733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677743 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1677746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677767 */     // GIR_Coverage, 11716,
     /* 1677767 */     GIR_EraseRootFromParent_Done,
     /* 1677768 */   // Label 22913: @1677768
     /* 1677768 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1677854), // Rule ID 11717 //
     /* 1677773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677819 */     // MIs[0] policy
     /* 1677819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677829 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1677832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677853 */     // GIR_Coverage, 11717,
     /* 1677853 */     GIR_EraseRootFromParent_Done,
     /* 1677854 */   // Label 22914: @1677854
     /* 1677854 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1677940), // Rule ID 11720 //
     /* 1677859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677905 */     // MIs[0] policy
     /* 1677905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1677918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677939 */     // GIR_Coverage, 11720,
     /* 1677939 */     GIR_EraseRootFromParent_Done,
     /* 1677940 */   // Label 22915: @1677940
     /* 1677940 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1678026), // Rule ID 11721 //
     /* 1677945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1677953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677991 */     // MIs[0] policy
     /* 1677991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678001 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1678004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678025 */     // GIR_Coverage, 11721,
     /* 1678025 */     GIR_EraseRootFromParent_Done,
     /* 1678026 */   // Label 22916: @1678026
     /* 1678026 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1678112), // Rule ID 11724 //
     /* 1678031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1678042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1678045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1678048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1678051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678077 */     // MIs[0] policy
     /* 1678077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678087 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1678090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678111 */     // GIR_Coverage, 11724,
     /* 1678111 */     GIR_EraseRootFromParent_Done,
     /* 1678112 */   // Label 22917: @1678112
     /* 1678112 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1678198), // Rule ID 11725 //
     /* 1678117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1678128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1678131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1678134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1678137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678163 */     // MIs[0] policy
     /* 1678163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1678176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678197 */     // GIR_Coverage, 11725,
     /* 1678197 */     GIR_EraseRootFromParent_Done,
     /* 1678198 */   // Label 22918: @1678198
     /* 1678198 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1678284), // Rule ID 11728 //
     /* 1678203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1678206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678249 */     // MIs[0] policy
     /* 1678249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1678262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678283 */     // GIR_Coverage, 11728,
     /* 1678283 */     GIR_EraseRootFromParent_Done,
     /* 1678284 */   // Label 22919: @1678284
     /* 1678284 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1678370), // Rule ID 11729 //
     /* 1678289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1678292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678335 */     // MIs[0] policy
     /* 1678335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678345 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1678348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678369 */     // GIR_Coverage, 11729,
     /* 1678369 */     GIR_EraseRootFromParent_Done,
     /* 1678370 */   // Label 22920: @1678370
     /* 1678370 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1678456), // Rule ID 11732 //
     /* 1678375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678421 */     // MIs[0] policy
     /* 1678421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1678434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678455 */     // GIR_Coverage, 11732,
     /* 1678455 */     GIR_EraseRootFromParent_Done,
     /* 1678456 */   // Label 22921: @1678456
     /* 1678456 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1678542), // Rule ID 11733 //
     /* 1678461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678507 */     // MIs[0] policy
     /* 1678507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678517 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1678520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678541 */     // GIR_Coverage, 11733,
     /* 1678541 */     GIR_EraseRootFromParent_Done,
     /* 1678542 */   // Label 22922: @1678542
     /* 1678542 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1678628), // Rule ID 11736 //
     /* 1678547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678593 */     // MIs[0] policy
     /* 1678593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678603 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1678606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678627 */     // GIR_Coverage, 11736,
     /* 1678627 */     GIR_EraseRootFromParent_Done,
     /* 1678628 */   // Label 22923: @1678628
     /* 1678628 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1678714), // Rule ID 11737 //
     /* 1678633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678679 */     // MIs[0] policy
     /* 1678679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1678692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678713 */     // GIR_Coverage, 11737,
     /* 1678713 */     GIR_EraseRootFromParent_Done,
     /* 1678714 */   // Label 22924: @1678714
     /* 1678714 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1678800), // Rule ID 11740 //
     /* 1678719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678765 */     // MIs[0] policy
     /* 1678765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678775 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1678778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678799 */     // GIR_Coverage, 11740,
     /* 1678799 */     GIR_EraseRootFromParent_Done,
     /* 1678800 */   // Label 22925: @1678800
     /* 1678800 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1678886), // Rule ID 11741 //
     /* 1678805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678851 */     // MIs[0] policy
     /* 1678851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678861 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1678864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678885 */     // GIR_Coverage, 11741,
     /* 1678885 */     GIR_EraseRootFromParent_Done,
     /* 1678886 */   // Label 22926: @1678886
     /* 1678886 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1678972), // Rule ID 11744 //
     /* 1678891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678937 */     // MIs[0] policy
     /* 1678937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1678950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678971 */     // GIR_Coverage, 11744,
     /* 1678971 */     GIR_EraseRootFromParent_Done,
     /* 1678972 */   // Label 22927: @1678972
     /* 1678972 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1679058), // Rule ID 11745 //
     /* 1678977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1678985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679023 */     // MIs[0] policy
     /* 1679023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1679036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679057 */     // GIR_Coverage, 11745,
     /* 1679057 */     GIR_EraseRootFromParent_Done,
     /* 1679058 */   // Label 22928: @1679058
     /* 1679058 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1679144), // Rule ID 11748 //
     /* 1679063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1679074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1679077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1679080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1679083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679109 */     // MIs[0] policy
     /* 1679109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1679122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679143 */     // GIR_Coverage, 11748,
     /* 1679143 */     GIR_EraseRootFromParent_Done,
     /* 1679144 */   // Label 22929: @1679144
     /* 1679144 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1679230), // Rule ID 11749 //
     /* 1679149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1679160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1679163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1679166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1679169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679195 */     // MIs[0] policy
     /* 1679195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679205 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1679208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679229 */     // GIR_Coverage, 11749,
     /* 1679229 */     GIR_EraseRootFromParent_Done,
     /* 1679230 */   // Label 22930: @1679230
     /* 1679230 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1679316), // Rule ID 11752 //
     /* 1679235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679281 */     // MIs[0] policy
     /* 1679281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679291 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1679294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679315 */     // GIR_Coverage, 11752,
     /* 1679315 */     GIR_EraseRootFromParent_Done,
     /* 1679316 */   // Label 22931: @1679316
     /* 1679316 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1679402), // Rule ID 11753 //
     /* 1679321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679367 */     // MIs[0] policy
     /* 1679367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1679380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679401 */     // GIR_Coverage, 11753,
     /* 1679401 */     GIR_EraseRootFromParent_Done,
     /* 1679402 */   // Label 22932: @1679402
     /* 1679402 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1679488), // Rule ID 11756 //
     /* 1679407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679453 */     // MIs[0] policy
     /* 1679453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1679466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679487 */     // GIR_Coverage, 11756,
     /* 1679487 */     GIR_EraseRootFromParent_Done,
     /* 1679488 */   // Label 22933: @1679488
     /* 1679488 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1679574), // Rule ID 11757 //
     /* 1679493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679539 */     // MIs[0] policy
     /* 1679539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1679552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679573 */     // GIR_Coverage, 11757,
     /* 1679573 */     GIR_EraseRootFromParent_Done,
     /* 1679574 */   // Label 22934: @1679574
     /* 1679574 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1679660), // Rule ID 11760 //
     /* 1679579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679625 */     // MIs[0] policy
     /* 1679625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1679638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679659 */     // GIR_Coverage, 11760,
     /* 1679659 */     GIR_EraseRootFromParent_Done,
     /* 1679660 */   // Label 22935: @1679660
     /* 1679660 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1679746), // Rule ID 11761 //
     /* 1679665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679711 */     // MIs[0] policy
     /* 1679711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1679724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679745 */     // GIR_Coverage, 11761,
     /* 1679745 */     GIR_EraseRootFromParent_Done,
     /* 1679746 */   // Label 22936: @1679746
     /* 1679746 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1679832), // Rule ID 11764 //
     /* 1679751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679797 */     // MIs[0] policy
     /* 1679797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679807 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1679810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679831 */     // GIR_Coverage, 11764,
     /* 1679831 */     GIR_EraseRootFromParent_Done,
     /* 1679832 */   // Label 22937: @1679832
     /* 1679832 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1679918), // Rule ID 11765 //
     /* 1679837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679883 */     // MIs[0] policy
     /* 1679883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1679896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679917 */     // GIR_Coverage, 11765,
     /* 1679917 */     GIR_EraseRootFromParent_Done,
     /* 1679918 */   // Label 22938: @1679918
     /* 1679918 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1680004), // Rule ID 11768 //
     /* 1679923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1679931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679969 */     // MIs[0] policy
     /* 1679969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1679982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680003 */     // GIR_Coverage, 11768,
     /* 1680003 */     GIR_EraseRootFromParent_Done,
     /* 1680004 */   // Label 22939: @1680004
     /* 1680004 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1680090), // Rule ID 11769 //
     /* 1680009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1680020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1680023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1680026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1680029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680055 */     // MIs[0] policy
     /* 1680055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1680068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680089 */     // GIR_Coverage, 11769,
     /* 1680089 */     GIR_EraseRootFromParent_Done,
     /* 1680090 */   // Label 22940: @1680090
     /* 1680090 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1680176), // Rule ID 11772 //
     /* 1680095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680141 */     // MIs[0] policy
     /* 1680141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680151 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1680154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680175 */     // GIR_Coverage, 11772,
     /* 1680175 */     GIR_EraseRootFromParent_Done,
     /* 1680176 */   // Label 22941: @1680176
     /* 1680176 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1680262), // Rule ID 11773 //
     /* 1680181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680227 */     // MIs[0] policy
     /* 1680227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1680240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680261 */     // GIR_Coverage, 11773,
     /* 1680261 */     GIR_EraseRootFromParent_Done,
     /* 1680262 */   // Label 22942: @1680262
     /* 1680262 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1680348), // Rule ID 11776 //
     /* 1680267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680313 */     // MIs[0] policy
     /* 1680313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1680326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680347 */     // GIR_Coverage, 11776,
     /* 1680347 */     GIR_EraseRootFromParent_Done,
     /* 1680348 */   // Label 22943: @1680348
     /* 1680348 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1680434), // Rule ID 11777 //
     /* 1680353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680399 */     // MIs[0] policy
     /* 1680399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1680412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680433 */     // GIR_Coverage, 11777,
     /* 1680433 */     GIR_EraseRootFromParent_Done,
     /* 1680434 */   // Label 22944: @1680434
     /* 1680434 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1680520), // Rule ID 11780 //
     /* 1680439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680485 */     // MIs[0] policy
     /* 1680485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680495 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1680498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680519 */     // GIR_Coverage, 11780,
     /* 1680519 */     GIR_EraseRootFromParent_Done,
     /* 1680520 */   // Label 22945: @1680520
     /* 1680520 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1680606), // Rule ID 11781 //
     /* 1680525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680571 */     // MIs[0] policy
     /* 1680571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680581 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1680584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680605 */     // GIR_Coverage, 11781,
     /* 1680605 */     GIR_EraseRootFromParent_Done,
     /* 1680606 */   // Label 22946: @1680606
     /* 1680606 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1680692), // Rule ID 11784 //
     /* 1680611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680657 */     // MIs[0] policy
     /* 1680657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680667 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1680670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680691 */     // GIR_Coverage, 11784,
     /* 1680691 */     GIR_EraseRootFromParent_Done,
     /* 1680692 */   // Label 22947: @1680692
     /* 1680692 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1680778), // Rule ID 11785 //
     /* 1680697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680743 */     // MIs[0] policy
     /* 1680743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680753 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1680756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680777 */     // GIR_Coverage, 11785,
     /* 1680777 */     GIR_EraseRootFromParent_Done,
     /* 1680778 */   // Label 22948: @1680778
     /* 1680778 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1680864), // Rule ID 11788 //
     /* 1680783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680829 */     // MIs[0] policy
     /* 1680829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680839 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1680842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680863 */     // GIR_Coverage, 11788,
     /* 1680863 */     GIR_EraseRootFromParent_Done,
     /* 1680864 */   // Label 22949: @1680864
     /* 1680864 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1680950), // Rule ID 11789 //
     /* 1680869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680915 */     // MIs[0] policy
     /* 1680915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680925 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1680928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680949 */     // GIR_Coverage, 11789,
     /* 1680949 */     GIR_EraseRootFromParent_Done,
     /* 1680950 */   // Label 22950: @1680950
     /* 1680950 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1681036), // Rule ID 11792 //
     /* 1680955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1680963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681001 */     // MIs[0] policy
     /* 1681001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1681014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681035 */     // GIR_Coverage, 11792,
     /* 1681035 */     GIR_EraseRootFromParent_Done,
     /* 1681036 */   // Label 22951: @1681036
     /* 1681036 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1681122), // Rule ID 11793 //
     /* 1681041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1681052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1681055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1681058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681087 */     // MIs[0] policy
     /* 1681087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681097 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1681100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681121 */     // GIR_Coverage, 11793,
     /* 1681121 */     GIR_EraseRootFromParent_Done,
     /* 1681122 */   // Label 22952: @1681122
     /* 1681122 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1681208), // Rule ID 11796 //
     /* 1681127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681173 */     // MIs[0] policy
     /* 1681173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681183 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1681186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681207 */     // GIR_Coverage, 11796,
     /* 1681207 */     GIR_EraseRootFromParent_Done,
     /* 1681208 */   // Label 22953: @1681208
     /* 1681208 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1681294), // Rule ID 11797 //
     /* 1681213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681259 */     // MIs[0] policy
     /* 1681259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681269 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1681272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681293 */     // GIR_Coverage, 11797,
     /* 1681293 */     GIR_EraseRootFromParent_Done,
     /* 1681294 */   // Label 22954: @1681294
     /* 1681294 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1681380), // Rule ID 11800 //
     /* 1681299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681345 */     // MIs[0] policy
     /* 1681345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681355 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1681358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681379 */     // GIR_Coverage, 11800,
     /* 1681379 */     GIR_EraseRootFromParent_Done,
     /* 1681380 */   // Label 22955: @1681380
     /* 1681380 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1681466), // Rule ID 11801 //
     /* 1681385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681431 */     // MIs[0] policy
     /* 1681431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681441 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1681444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681465 */     // GIR_Coverage, 11801,
     /* 1681465 */     GIR_EraseRootFromParent_Done,
     /* 1681466 */   // Label 22956: @1681466
     /* 1681466 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1681552), // Rule ID 11804 //
     /* 1681471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681517 */     // MIs[0] policy
     /* 1681517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1681530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681551 */     // GIR_Coverage, 11804,
     /* 1681551 */     GIR_EraseRootFromParent_Done,
     /* 1681552 */   // Label 22957: @1681552
     /* 1681552 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1681638), // Rule ID 11805 //
     /* 1681557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681603 */     // MIs[0] policy
     /* 1681603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681613 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10873:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1681616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681637 */     // GIR_Coverage, 11805,
     /* 1681637 */     GIR_EraseRootFromParent_Done,
     /* 1681638 */   // Label 22958: @1681638
     /* 1681638 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1681724), // Rule ID 11808 //
     /* 1681643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681689 */     // MIs[0] policy
     /* 1681689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1681702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681723 */     // GIR_Coverage, 11808,
     /* 1681723 */     GIR_EraseRootFromParent_Done,
     /* 1681724 */   // Label 22959: @1681724
     /* 1681724 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1681810), // Rule ID 11809 //
     /* 1681729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681775 */     // MIs[0] policy
     /* 1681775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681785 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1681788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681809 */     // GIR_Coverage, 11809,
     /* 1681809 */     GIR_EraseRootFromParent_Done,
     /* 1681810 */   // Label 22960: @1681810
     /* 1681810 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1681896), // Rule ID 11812 //
     /* 1681815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681861 */     // MIs[0] policy
     /* 1681861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1681874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681895 */     // GIR_Coverage, 11812,
     /* 1681895 */     GIR_EraseRootFromParent_Done,
     /* 1681896 */   // Label 22961: @1681896
     /* 1681896 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1681982), // Rule ID 11813 //
     /* 1681901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681947 */     // MIs[0] policy
     /* 1681947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681957 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1681960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681981 */     // GIR_Coverage, 11813,
     /* 1681981 */     GIR_EraseRootFromParent_Done,
     /* 1681982 */   // Label 22962: @1681982
     /* 1681982 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1682068), // Rule ID 11816 //
     /* 1681987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1681995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682033 */     // MIs[0] policy
     /* 1682033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1682046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1682064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682067 */     // GIR_Coverage, 11816,
     /* 1682067 */     GIR_EraseRootFromParent_Done,
     /* 1682068 */   // Label 22963: @1682068
     /* 1682068 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1682154), // Rule ID 11817 //
     /* 1682073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1682076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1682084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682119 */     // MIs[0] policy
     /* 1682119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1682132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1682150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682153 */     // GIR_Coverage, 11817,
     /* 1682153 */     GIR_EraseRootFromParent_Done,
     /* 1682154 */   // Label 22964: @1682154
     /* 1682154 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1682240), // Rule ID 11820 //
     /* 1682159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682205 */     // MIs[0] policy
     /* 1682205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1682218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682239 */     // GIR_Coverage, 11820,
     /* 1682239 */     GIR_EraseRootFromParent_Done,
     /* 1682240 */   // Label 22965: @1682240
     /* 1682240 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1682326), // Rule ID 11821 //
     /* 1682245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682291 */     // MIs[0] policy
     /* 1682291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1682304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682325 */     // GIR_Coverage, 11821,
     /* 1682325 */     GIR_EraseRootFromParent_Done,
     /* 1682326 */   // Label 22966: @1682326
     /* 1682326 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1682412), // Rule ID 11824 //
     /* 1682331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682377 */     // MIs[0] policy
     /* 1682377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682387 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1682390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682411 */     // GIR_Coverage, 11824,
     /* 1682411 */     GIR_EraseRootFromParent_Done,
     /* 1682412 */   // Label 22967: @1682412
     /* 1682412 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1682498), // Rule ID 11825 //
     /* 1682417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682463 */     // MIs[0] policy
     /* 1682463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1682476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682497 */     // GIR_Coverage, 11825,
     /* 1682497 */     GIR_EraseRootFromParent_Done,
     /* 1682498 */   // Label 22968: @1682498
     /* 1682498 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1682584), // Rule ID 11828 //
     /* 1682503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682549 */     // MIs[0] policy
     /* 1682549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1682562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682583 */     // GIR_Coverage, 11828,
     /* 1682583 */     GIR_EraseRootFromParent_Done,
     /* 1682584 */   // Label 22969: @1682584
     /* 1682584 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1682670), // Rule ID 11829 //
     /* 1682589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682635 */     // MIs[0] policy
     /* 1682635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1682648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682669 */     // GIR_Coverage, 11829,
     /* 1682669 */     GIR_EraseRootFromParent_Done,
     /* 1682670 */   // Label 22970: @1682670
     /* 1682670 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1682756), // Rule ID 11832 //
     /* 1682675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682721 */     // MIs[0] policy
     /* 1682721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1682734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682755 */     // GIR_Coverage, 11832,
     /* 1682755 */     GIR_EraseRootFromParent_Done,
     /* 1682756 */   // Label 22971: @1682756
     /* 1682756 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1682842), // Rule ID 11833 //
     /* 1682761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682807 */     // MIs[0] policy
     /* 1682807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1682820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682841 */     // GIR_Coverage, 11833,
     /* 1682841 */     GIR_EraseRootFromParent_Done,
     /* 1682842 */   // Label 22972: @1682842
     /* 1682842 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1682928), // Rule ID 11836 //
     /* 1682847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682893 */     // MIs[0] policy
     /* 1682893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682903 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1682906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682927 */     // GIR_Coverage, 11836,
     /* 1682927 */     GIR_EraseRootFromParent_Done,
     /* 1682928 */   // Label 22973: @1682928
     /* 1682928 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1683014), // Rule ID 11837 //
     /* 1682933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1682941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682979 */     // MIs[0] policy
     /* 1682979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1682992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683013 */     // GIR_Coverage, 11837,
     /* 1683013 */     GIR_EraseRootFromParent_Done,
     /* 1683014 */   // Label 22974: @1683014
     /* 1683014 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1683100), // Rule ID 11840 //
     /* 1683019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1683030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1683033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1683036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683065 */     // MIs[0] policy
     /* 1683065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683075 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1683078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683099 */     // GIR_Coverage, 11840,
     /* 1683099 */     GIR_EraseRootFromParent_Done,
     /* 1683100 */   // Label 22975: @1683100
     /* 1683100 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1683186), // Rule ID 11841 //
     /* 1683105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1683116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1683119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1683122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683151 */     // MIs[0] policy
     /* 1683151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683161 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1683164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683185 */     // GIR_Coverage, 11841,
     /* 1683185 */     GIR_EraseRootFromParent_Done,
     /* 1683186 */   // Label 22976: @1683186
     /* 1683186 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1683272), // Rule ID 11844 //
     /* 1683191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683237 */     // MIs[0] policy
     /* 1683237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1683250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683271 */     // GIR_Coverage, 11844,
     /* 1683271 */     GIR_EraseRootFromParent_Done,
     /* 1683272 */   // Label 22977: @1683272
     /* 1683272 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1683358), // Rule ID 11845 //
     /* 1683277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683323 */     // MIs[0] policy
     /* 1683323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1683336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683357 */     // GIR_Coverage, 11845,
     /* 1683357 */     GIR_EraseRootFromParent_Done,
     /* 1683358 */   // Label 22978: @1683358
     /* 1683358 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1683444), // Rule ID 11848 //
     /* 1683363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683409 */     // MIs[0] policy
     /* 1683409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683419 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1683422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683443 */     // GIR_Coverage, 11848,
     /* 1683443 */     GIR_EraseRootFromParent_Done,
     /* 1683444 */   // Label 22979: @1683444
     /* 1683444 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1683530), // Rule ID 11849 //
     /* 1683449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683495 */     // MIs[0] policy
     /* 1683495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683505 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1683508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683529 */     // GIR_Coverage, 11849,
     /* 1683529 */     GIR_EraseRootFromParent_Done,
     /* 1683530 */   // Label 22980: @1683530
     /* 1683530 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1683616), // Rule ID 11852 //
     /* 1683535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683581 */     // MIs[0] policy
     /* 1683581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683591 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1683594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683615 */     // GIR_Coverage, 11852,
     /* 1683615 */     GIR_EraseRootFromParent_Done,
     /* 1683616 */   // Label 22981: @1683616
     /* 1683616 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1683702), // Rule ID 11853 //
     /* 1683621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683667 */     // MIs[0] policy
     /* 1683667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1683680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683701 */     // GIR_Coverage, 11853,
     /* 1683701 */     GIR_EraseRootFromParent_Done,
     /* 1683702 */   // Label 22982: @1683702
     /* 1683702 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1683788), // Rule ID 11856 //
     /* 1683707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683753 */     // MIs[0] policy
     /* 1683753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1683766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683787 */     // GIR_Coverage, 11856,
     /* 1683787 */     GIR_EraseRootFromParent_Done,
     /* 1683788 */   // Label 22983: @1683788
     /* 1683788 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1683874), // Rule ID 11857 //
     /* 1683793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683839 */     // MIs[0] policy
     /* 1683839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1683852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683873 */     // GIR_Coverage, 11857,
     /* 1683873 */     GIR_EraseRootFromParent_Done,
     /* 1683874 */   // Label 22984: @1683874
     /* 1683874 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1683960), // Rule ID 11860 //
     /* 1683879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683925 */     // MIs[0] policy
     /* 1683925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683935 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1683938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683959 */     // GIR_Coverage, 11860,
     /* 1683959 */     GIR_EraseRootFromParent_Done,
     /* 1683960 */   // Label 22985: @1683960
     /* 1683960 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1684046), // Rule ID 11861 //
     /* 1683965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1683973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684011 */     // MIs[0] policy
     /* 1684011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1684024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684045 */     // GIR_Coverage, 11861,
     /* 1684045 */     GIR_EraseRootFromParent_Done,
     /* 1684046 */   // Label 22986: @1684046
     /* 1684046 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1684132), // Rule ID 11864 //
     /* 1684051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1684059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1684062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1684065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1684068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684097 */     // MIs[0] policy
     /* 1684097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1684110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684131 */     // GIR_Coverage, 11864,
     /* 1684131 */     GIR_EraseRootFromParent_Done,
     /* 1684132 */   // Label 22987: @1684132
     /* 1684132 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1684218), // Rule ID 11865 //
     /* 1684137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1684145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1684148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1684151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1684154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684183 */     // MIs[0] policy
     /* 1684183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1684196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684217 */     // GIR_Coverage, 11865,
     /* 1684217 */     GIR_EraseRootFromParent_Done,
     /* 1684218 */   // Label 22988: @1684218
     /* 1684218 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1684304), // Rule ID 11868 //
     /* 1684223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684269 */     // MIs[0] policy
     /* 1684269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684279 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1684282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684303 */     // GIR_Coverage, 11868,
     /* 1684303 */     GIR_EraseRootFromParent_Done,
     /* 1684304 */   // Label 22989: @1684304
     /* 1684304 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1684390), // Rule ID 11869 //
     /* 1684309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684355 */     // MIs[0] policy
     /* 1684355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684365 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1684368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684389 */     // GIR_Coverage, 11869,
     /* 1684389 */     GIR_EraseRootFromParent_Done,
     /* 1684390 */   // Label 22990: @1684390
     /* 1684390 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1684476), // Rule ID 11872 //
     /* 1684395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684441 */     // MIs[0] policy
     /* 1684441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1684454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684475 */     // GIR_Coverage, 11872,
     /* 1684475 */     GIR_EraseRootFromParent_Done,
     /* 1684476 */   // Label 22991: @1684476
     /* 1684476 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1684562), // Rule ID 11873 //
     /* 1684481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684527 */     // MIs[0] policy
     /* 1684527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684537 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1684540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684561 */     // GIR_Coverage, 11873,
     /* 1684561 */     GIR_EraseRootFromParent_Done,
     /* 1684562 */   // Label 22992: @1684562
     /* 1684562 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1684648), // Rule ID 11876 //
     /* 1684567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684613 */     // MIs[0] policy
     /* 1684613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1684626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684647 */     // GIR_Coverage, 11876,
     /* 1684647 */     GIR_EraseRootFromParent_Done,
     /* 1684648 */   // Label 22993: @1684648
     /* 1684648 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1684734), // Rule ID 11877 //
     /* 1684653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684699 */     // MIs[0] policy
     /* 1684699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684709 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1684712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684733 */     // GIR_Coverage, 11877,
     /* 1684733 */     GIR_EraseRootFromParent_Done,
     /* 1684734 */   // Label 22994: @1684734
     /* 1684734 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1684820), // Rule ID 11880 //
     /* 1684739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684785 */     // MIs[0] policy
     /* 1684785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684795 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1684798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684819 */     // GIR_Coverage, 11880,
     /* 1684819 */     GIR_EraseRootFromParent_Done,
     /* 1684820 */   // Label 22995: @1684820
     /* 1684820 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1684906), // Rule ID 11881 //
     /* 1684825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684871 */     // MIs[0] policy
     /* 1684871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684881 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1684884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684905 */     // GIR_Coverage, 11881,
     /* 1684905 */     GIR_EraseRootFromParent_Done,
     /* 1684906 */   // Label 22996: @1684906
     /* 1684906 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1684992), // Rule ID 11884 //
     /* 1684911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1684919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684957 */     // MIs[0] policy
     /* 1684957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1684970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684991 */     // GIR_Coverage, 11884,
     /* 1684991 */     GIR_EraseRootFromParent_Done,
     /* 1684992 */   // Label 22997: @1684992
     /* 1684992 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1685078), // Rule ID 11885 //
     /* 1684997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1685008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1685011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1685014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1685017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685043 */     // MIs[0] policy
     /* 1685043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685053 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1685056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685077 */     // GIR_Coverage, 11885,
     /* 1685077 */     GIR_EraseRootFromParent_Done,
     /* 1685078 */   // Label 22998: @1685078
     /* 1685078 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1685164), // Rule ID 11888 //
     /* 1685083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1685094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1685097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1685100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1685103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685129 */     // MIs[0] policy
     /* 1685129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685139 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1685142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685163 */     // GIR_Coverage, 11888,
     /* 1685163 */     GIR_EraseRootFromParent_Done,
     /* 1685164 */   // Label 22999: @1685164
     /* 1685164 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1685250), // Rule ID 11889 //
     /* 1685169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1685180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1685183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1685186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1685189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685215 */     // MIs[0] policy
     /* 1685215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1685228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685249 */     // GIR_Coverage, 11889,
     /* 1685249 */     GIR_EraseRootFromParent_Done,
     /* 1685250 */   // Label 23000: @1685250
     /* 1685250 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1685336), // Rule ID 11892 //
     /* 1685255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685301 */     // MIs[0] policy
     /* 1685301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1685314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685335 */     // GIR_Coverage, 11892,
     /* 1685335 */     GIR_EraseRootFromParent_Done,
     /* 1685336 */   // Label 23001: @1685336
     /* 1685336 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1685422), // Rule ID 11893 //
     /* 1685341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685387 */     // MIs[0] policy
     /* 1685387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685397 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1685400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685421 */     // GIR_Coverage, 11893,
     /* 1685421 */     GIR_EraseRootFromParent_Done,
     /* 1685422 */   // Label 23002: @1685422
     /* 1685422 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1685508), // Rule ID 11896 //
     /* 1685427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685473 */     // MIs[0] policy
     /* 1685473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1685486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685507 */     // GIR_Coverage, 11896,
     /* 1685507 */     GIR_EraseRootFromParent_Done,
     /* 1685508 */   // Label 23003: @1685508
     /* 1685508 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1685594), // Rule ID 11897 //
     /* 1685513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685559 */     // MIs[0] policy
     /* 1685559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1685572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685593 */     // GIR_Coverage, 11897,
     /* 1685593 */     GIR_EraseRootFromParent_Done,
     /* 1685594 */   // Label 23004: @1685594
     /* 1685594 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1685680), // Rule ID 11900 //
     /* 1685599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685645 */     // MIs[0] policy
     /* 1685645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685655 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1685658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685679 */     // GIR_Coverage, 11900,
     /* 1685679 */     GIR_EraseRootFromParent_Done,
     /* 1685680 */   // Label 23005: @1685680
     /* 1685680 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1685766), // Rule ID 11901 //
     /* 1685685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685731 */     // MIs[0] policy
     /* 1685731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685741 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1685744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685765 */     // GIR_Coverage, 11901,
     /* 1685765 */     GIR_EraseRootFromParent_Done,
     /* 1685766 */   // Label 23006: @1685766
     /* 1685766 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1685852), // Rule ID 11904 //
     /* 1685771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685817 */     // MIs[0] policy
     /* 1685817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1685830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685851 */     // GIR_Coverage, 11904,
     /* 1685851 */     GIR_EraseRootFromParent_Done,
     /* 1685852 */   // Label 23007: @1685852
     /* 1685852 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1685938), // Rule ID 11905 //
     /* 1685857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685903 */     // MIs[0] policy
     /* 1685903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685913 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1685916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685937 */     // GIR_Coverage, 11905,
     /* 1685937 */     GIR_EraseRootFromParent_Done,
     /* 1685938 */   // Label 23008: @1685938
     /* 1685938 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1686024), // Rule ID 11908 //
     /* 1685943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1685951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685989 */     // MIs[0] policy
     /* 1685989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1686002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686023 */     // GIR_Coverage, 11908,
     /* 1686023 */     GIR_EraseRootFromParent_Done,
     /* 1686024 */   // Label 23009: @1686024
     /* 1686024 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1686110), // Rule ID 11909 //
     /* 1686029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1686040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1686043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1686046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1686049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686075 */     // MIs[0] policy
     /* 1686075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1686088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686109 */     // GIR_Coverage, 11909,
     /* 1686109 */     GIR_EraseRootFromParent_Done,
     /* 1686110 */   // Label 23010: @1686110
     /* 1686110 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1686196), // Rule ID 11912 //
     /* 1686115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686161 */     // MIs[0] policy
     /* 1686161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1686174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686195 */     // GIR_Coverage, 11912,
     /* 1686195 */     GIR_EraseRootFromParent_Done,
     /* 1686196 */   // Label 23011: @1686196
     /* 1686196 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1686282), // Rule ID 11913 //
     /* 1686201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686247 */     // MIs[0] policy
     /* 1686247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686257 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1686260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686281 */     // GIR_Coverage, 11913,
     /* 1686281 */     GIR_EraseRootFromParent_Done,
     /* 1686282 */   // Label 23012: @1686282
     /* 1686282 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1686368), // Rule ID 11916 //
     /* 1686287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686333 */     // MIs[0] policy
     /* 1686333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686343 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1686346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686367 */     // GIR_Coverage, 11916,
     /* 1686367 */     GIR_EraseRootFromParent_Done,
     /* 1686368 */   // Label 23013: @1686368
     /* 1686368 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1686454), // Rule ID 11917 //
     /* 1686373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686419 */     // MIs[0] policy
     /* 1686419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686429 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1686432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686453 */     // GIR_Coverage, 11917,
     /* 1686453 */     GIR_EraseRootFromParent_Done,
     /* 1686454 */   // Label 23014: @1686454
     /* 1686454 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1686540), // Rule ID 11920 //
     /* 1686459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686505 */     // MIs[0] policy
     /* 1686505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1686518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686539 */     // GIR_Coverage, 11920,
     /* 1686539 */     GIR_EraseRootFromParent_Done,
     /* 1686540 */   // Label 23015: @1686540
     /* 1686540 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1686626), // Rule ID 11921 //
     /* 1686545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686591 */     // MIs[0] policy
     /* 1686591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1686604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686625 */     // GIR_Coverage, 11921,
     /* 1686625 */     GIR_EraseRootFromParent_Done,
     /* 1686626 */   // Label 23016: @1686626
     /* 1686626 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1686712), // Rule ID 11924 //
     /* 1686631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686677 */     // MIs[0] policy
     /* 1686677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686687 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1686690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686711 */     // GIR_Coverage, 11924,
     /* 1686711 */     GIR_EraseRootFromParent_Done,
     /* 1686712 */   // Label 23017: @1686712
     /* 1686712 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1686798), // Rule ID 11925 //
     /* 1686717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686763 */     // MIs[0] policy
     /* 1686763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686773 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1686776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686797 */     // GIR_Coverage, 11925,
     /* 1686797 */     GIR_EraseRootFromParent_Done,
     /* 1686798 */   // Label 23018: @1686798
     /* 1686798 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1686884), // Rule ID 11928 //
     /* 1686803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686849 */     // MIs[0] policy
     /* 1686849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686859 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1686862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686883 */     // GIR_Coverage, 11928,
     /* 1686883 */     GIR_EraseRootFromParent_Done,
     /* 1686884 */   // Label 23019: @1686884
     /* 1686884 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1686970), // Rule ID 11929 //
     /* 1686889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686935 */     // MIs[0] policy
     /* 1686935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686945 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1686948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686969 */     // GIR_Coverage, 11929,
     /* 1686969 */     GIR_EraseRootFromParent_Done,
     /* 1686970 */   // Label 23020: @1686970
     /* 1686970 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1687056), // Rule ID 11932 //
     /* 1686975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1686983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687021 */     // MIs[0] policy
     /* 1687021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1687034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687055 */     // GIR_Coverage, 11932,
     /* 1687055 */     GIR_EraseRootFromParent_Done,
     /* 1687056 */   // Label 23021: @1687056
     /* 1687056 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1687142), // Rule ID 11933 //
     /* 1687061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1687072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1687075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1687078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1687081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687107 */     // MIs[0] policy
     /* 1687107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1687120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687141 */     // GIR_Coverage, 11933,
     /* 1687141 */     GIR_EraseRootFromParent_Done,
     /* 1687142 */   // Label 23022: @1687142
     /* 1687142 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1687228), // Rule ID 11936 //
     /* 1687147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687193 */     // MIs[0] policy
     /* 1687193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1687206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687227 */     // GIR_Coverage, 11936,
     /* 1687227 */     GIR_EraseRootFromParent_Done,
     /* 1687228 */   // Label 23023: @1687228
     /* 1687228 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1687314), // Rule ID 11937 //
     /* 1687233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687279 */     // MIs[0] policy
     /* 1687279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1687292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687313 */     // GIR_Coverage, 11937,
     /* 1687313 */     GIR_EraseRootFromParent_Done,
     /* 1687314 */   // Label 23024: @1687314
     /* 1687314 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1687400), // Rule ID 11940 //
     /* 1687319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687365 */     // MIs[0] policy
     /* 1687365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687375 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1687378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687399 */     // GIR_Coverage, 11940,
     /* 1687399 */     GIR_EraseRootFromParent_Done,
     /* 1687400 */   // Label 23025: @1687400
     /* 1687400 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1687486), // Rule ID 11941 //
     /* 1687405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687451 */     // MIs[0] policy
     /* 1687451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1687464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687485 */     // GIR_Coverage, 11941,
     /* 1687485 */     GIR_EraseRootFromParent_Done,
     /* 1687486 */   // Label 23026: @1687486
     /* 1687486 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1687572), // Rule ID 11944 //
     /* 1687491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687537 */     // MIs[0] policy
     /* 1687537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1687550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687571 */     // GIR_Coverage, 11944,
     /* 1687571 */     GIR_EraseRootFromParent_Done,
     /* 1687572 */   // Label 23027: @1687572
     /* 1687572 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1687658), // Rule ID 11945 //
     /* 1687577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687623 */     // MIs[0] policy
     /* 1687623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687633 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1687636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687657 */     // GIR_Coverage, 11945,
     /* 1687657 */     GIR_EraseRootFromParent_Done,
     /* 1687658 */   // Label 23028: @1687658
     /* 1687658 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1687744), // Rule ID 11948 //
     /* 1687663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687709 */     // MIs[0] policy
     /* 1687709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1687722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687743 */     // GIR_Coverage, 11948,
     /* 1687743 */     GIR_EraseRootFromParent_Done,
     /* 1687744 */   // Label 23029: @1687744
     /* 1687744 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1687830), // Rule ID 11949 //
     /* 1687749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687795 */     // MIs[0] policy
     /* 1687795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687805 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1687808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687829 */     // GIR_Coverage, 11949,
     /* 1687829 */     GIR_EraseRootFromParent_Done,
     /* 1687830 */   // Label 23030: @1687830
     /* 1687830 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1687916), // Rule ID 11952 //
     /* 1687835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687881 */     // MIs[0] policy
     /* 1687881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687891 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1687894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687915 */     // GIR_Coverage, 11952,
     /* 1687915 */     GIR_EraseRootFromParent_Done,
     /* 1687916 */   // Label 23031: @1687916
     /* 1687916 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1688002), // Rule ID 11953 //
     /* 1687921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1687929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687967 */     // MIs[0] policy
     /* 1687967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1687980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688001 */     // GIR_Coverage, 11953,
     /* 1688001 */     GIR_EraseRootFromParent_Done,
     /* 1688002 */   // Label 23032: @1688002
     /* 1688002 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1688088), // Rule ID 11956 //
     /* 1688007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688053 */     // MIs[0] policy
     /* 1688053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688063 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1688066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688087 */     // GIR_Coverage, 11956,
     /* 1688087 */     GIR_EraseRootFromParent_Done,
     /* 1688088 */   // Label 23033: @1688088
     /* 1688088 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1688174), // Rule ID 11957 //
     /* 1688093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688139 */     // MIs[0] policy
     /* 1688139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1688152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688173 */     // GIR_Coverage, 11957,
     /* 1688173 */     GIR_EraseRootFromParent_Done,
     /* 1688174 */   // Label 23034: @1688174
     /* 1688174 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1688260), // Rule ID 11960 //
     /* 1688179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688225 */     // MIs[0] policy
     /* 1688225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688235 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1688238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688259 */     // GIR_Coverage, 11960,
     /* 1688259 */     GIR_EraseRootFromParent_Done,
     /* 1688260 */   // Label 23035: @1688260
     /* 1688260 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1688346), // Rule ID 11961 //
     /* 1688265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688311 */     // MIs[0] policy
     /* 1688311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1688324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688345 */     // GIR_Coverage, 11961,
     /* 1688345 */     GIR_EraseRootFromParent_Done,
     /* 1688346 */   // Label 23036: @1688346
     /* 1688346 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1688432), // Rule ID 11964 //
     /* 1688351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688397 */     // MIs[0] policy
     /* 1688397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688407 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1688410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688431 */     // GIR_Coverage, 11964,
     /* 1688431 */     GIR_EraseRootFromParent_Done,
     /* 1688432 */   // Label 23037: @1688432
     /* 1688432 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1688518), // Rule ID 11965 //
     /* 1688437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688483 */     // MIs[0] policy
     /* 1688483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1688496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688517 */     // GIR_Coverage, 11965,
     /* 1688517 */     GIR_EraseRootFromParent_Done,
     /* 1688518 */   // Label 23038: @1688518
     /* 1688518 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1688604), // Rule ID 11968 //
     /* 1688523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688569 */     // MIs[0] policy
     /* 1688569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1688582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688603 */     // GIR_Coverage, 11968,
     /* 1688603 */     GIR_EraseRootFromParent_Done,
     /* 1688604 */   // Label 23039: @1688604
     /* 1688604 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1688690), // Rule ID 11969 //
     /* 1688609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688655 */     // MIs[0] policy
     /* 1688655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688665 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1688668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688689 */     // GIR_Coverage, 11969,
     /* 1688689 */     GIR_EraseRootFromParent_Done,
     /* 1688690 */   // Label 23040: @1688690
     /* 1688690 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1688776), // Rule ID 11972 //
     /* 1688695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688741 */     // MIs[0] policy
     /* 1688741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1688754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688775 */     // GIR_Coverage, 11972,
     /* 1688775 */     GIR_EraseRootFromParent_Done,
     /* 1688776 */   // Label 23041: @1688776
     /* 1688776 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1688862), // Rule ID 11973 //
     /* 1688781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688827 */     // MIs[0] policy
     /* 1688827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688837 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1688840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688861 */     // GIR_Coverage, 11973,
     /* 1688861 */     GIR_EraseRootFromParent_Done,
     /* 1688862 */   // Label 23042: @1688862
     /* 1688862 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1688948), // Rule ID 11976 //
     /* 1688867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688913 */     // MIs[0] policy
     /* 1688913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688923 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1688926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688947 */     // GIR_Coverage, 11976,
     /* 1688947 */     GIR_EraseRootFromParent_Done,
     /* 1688948 */   // Label 23043: @1688948
     /* 1688948 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1689034), // Rule ID 11977 //
     /* 1688953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1688961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688999 */     // MIs[0] policy
     /* 1688999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1689012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689033 */     // GIR_Coverage, 11977,
     /* 1689033 */     GIR_EraseRootFromParent_Done,
     /* 1689034 */   // Label 23044: @1689034
     /* 1689034 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1689120), // Rule ID 11980 //
     /* 1689039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1689050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1689053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1689056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689085 */     // MIs[0] policy
     /* 1689085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689095 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1689098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689119 */     // GIR_Coverage, 11980,
     /* 1689119 */     GIR_EraseRootFromParent_Done,
     /* 1689120 */   // Label 23045: @1689120
     /* 1689120 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1689206), // Rule ID 11981 //
     /* 1689125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1689136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1689139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1689142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689171 */     // MIs[0] policy
     /* 1689171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689181 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1689184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689205 */     // GIR_Coverage, 11981,
     /* 1689205 */     GIR_EraseRootFromParent_Done,
     /* 1689206 */   // Label 23046: @1689206
     /* 1689206 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1689292), // Rule ID 11984 //
     /* 1689211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689257 */     // MIs[0] policy
     /* 1689257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689267 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1689270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689291 */     // GIR_Coverage, 11984,
     /* 1689291 */     GIR_EraseRootFromParent_Done,
     /* 1689292 */   // Label 23047: @1689292
     /* 1689292 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1689378), // Rule ID 11985 //
     /* 1689297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689343 */     // MIs[0] policy
     /* 1689343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689353 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1689356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689377 */     // GIR_Coverage, 11985,
     /* 1689377 */     GIR_EraseRootFromParent_Done,
     /* 1689378 */   // Label 23048: @1689378
     /* 1689378 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1689464), // Rule ID 11988 //
     /* 1689383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689429 */     // MIs[0] policy
     /* 1689429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689439 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1689442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689463 */     // GIR_Coverage, 11988,
     /* 1689463 */     GIR_EraseRootFromParent_Done,
     /* 1689464 */   // Label 23049: @1689464
     /* 1689464 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1689550), // Rule ID 11989 //
     /* 1689469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689515 */     // MIs[0] policy
     /* 1689515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1689528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689549 */     // GIR_Coverage, 11989,
     /* 1689549 */     GIR_EraseRootFromParent_Done,
     /* 1689550 */   // Label 23050: @1689550
     /* 1689550 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1689636), // Rule ID 11992 //
     /* 1689555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1689558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689601 */     // MIs[0] policy
     /* 1689601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1689614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689635 */     // GIR_Coverage, 11992,
     /* 1689635 */     GIR_EraseRootFromParent_Done,
     /* 1689636 */   // Label 23051: @1689636
     /* 1689636 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1689722), // Rule ID 11993 //
     /* 1689641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1689644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689687 */     // MIs[0] policy
     /* 1689687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689697 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1689700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689721 */     // GIR_Coverage, 11993,
     /* 1689721 */     GIR_EraseRootFromParent_Done,
     /* 1689722 */   // Label 23052: @1689722
     /* 1689722 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1689808), // Rule ID 11996 //
     /* 1689727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689773 */     // MIs[0] policy
     /* 1689773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1689786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689807 */     // GIR_Coverage, 11996,
     /* 1689807 */     GIR_EraseRootFromParent_Done,
     /* 1689808 */   // Label 23053: @1689808
     /* 1689808 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1689894), // Rule ID 11997 //
     /* 1689813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689859 */     // MIs[0] policy
     /* 1689859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1689872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689893 */     // GIR_Coverage, 11997,
     /* 1689893 */     GIR_EraseRootFromParent_Done,
     /* 1689894 */   // Label 23054: @1689894
     /* 1689894 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1689980), // Rule ID 12000 //
     /* 1689899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689945 */     // MIs[0] policy
     /* 1689945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1689958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689979 */     // GIR_Coverage, 12000,
     /* 1689979 */     GIR_EraseRootFromParent_Done,
     /* 1689980 */   // Label 23055: @1689980
     /* 1689980 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1690066), // Rule ID 12001 //
     /* 1689985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1689993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1690002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690031 */     // MIs[0] policy
     /* 1690031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690041 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1690044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690065 */     // GIR_Coverage, 12001,
     /* 1690065 */     GIR_EraseRootFromParent_Done,
     /* 1690066 */   // Label 23056: @1690066
     /* 1690066 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1690152), // Rule ID 12004 //
     /* 1690071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1690082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1690085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1690088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1690094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690117 */     // MIs[0] policy
     /* 1690117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1690130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690151 */     // GIR_Coverage, 12004,
     /* 1690151 */     GIR_EraseRootFromParent_Done,
     /* 1690152 */   // Label 23057: @1690152
     /* 1690152 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1690238), // Rule ID 12005 //
     /* 1690157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1690168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1690171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1690174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1690180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690203 */     // MIs[0] policy
     /* 1690203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690213 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1690216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690237 */     // GIR_Coverage, 12005,
     /* 1690237 */     GIR_EraseRootFromParent_Done,
     /* 1690238 */   // Label 23058: @1690238
     /* 1690238 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1690324), // Rule ID 12008 //
     /* 1690243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690289 */     // MIs[0] policy
     /* 1690289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1690302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690323 */     // GIR_Coverage, 12008,
     /* 1690323 */     GIR_EraseRootFromParent_Done,
     /* 1690324 */   // Label 23059: @1690324
     /* 1690324 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1690410), // Rule ID 12009 //
     /* 1690329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690375 */     // MIs[0] policy
     /* 1690375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690385 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1690388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690409 */     // GIR_Coverage, 12009,
     /* 1690409 */     GIR_EraseRootFromParent_Done,
     /* 1690410 */   // Label 23060: @1690410
     /* 1690410 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1690496), // Rule ID 12012 //
     /* 1690415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690461 */     // MIs[0] policy
     /* 1690461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1690474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690495 */     // GIR_Coverage, 12012,
     /* 1690495 */     GIR_EraseRootFromParent_Done,
     /* 1690496 */   // Label 23061: @1690496
     /* 1690496 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1690582), // Rule ID 12013 //
     /* 1690501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690547 */     // MIs[0] policy
     /* 1690547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690557 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1690560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690581 */     // GIR_Coverage, 12013,
     /* 1690581 */     GIR_EraseRootFromParent_Done,
     /* 1690582 */   // Label 23062: @1690582
     /* 1690582 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1690668), // Rule ID 12016 //
     /* 1690587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690633 */     // MIs[0] policy
     /* 1690633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1690646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690667 */     // GIR_Coverage, 12016,
     /* 1690667 */     GIR_EraseRootFromParent_Done,
     /* 1690668 */   // Label 23063: @1690668
     /* 1690668 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1690754), // Rule ID 12017 //
     /* 1690673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690719 */     // MIs[0] policy
     /* 1690719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690729 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1690732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690753 */     // GIR_Coverage, 12017,
     /* 1690753 */     GIR_EraseRootFromParent_Done,
     /* 1690754 */   // Label 23064: @1690754
     /* 1690754 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1690840), // Rule ID 12020 //
     /* 1690759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690805 */     // MIs[0] policy
     /* 1690805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1690818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690839 */     // GIR_Coverage, 12020,
     /* 1690839 */     GIR_EraseRootFromParent_Done,
     /* 1690840 */   // Label 23065: @1690840
     /* 1690840 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1690926), // Rule ID 12021 //
     /* 1690845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690891 */     // MIs[0] policy
     /* 1690891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1690904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690925 */     // GIR_Coverage, 12021,
     /* 1690925 */     GIR_EraseRootFromParent_Done,
     /* 1690926 */   // Label 23066: @1690926
     /* 1690926 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1691012), // Rule ID 12024 //
     /* 1690931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1690939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690977 */     // MIs[0] policy
     /* 1690977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690987 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1690990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691011 */     // GIR_Coverage, 12024,
     /* 1691011 */     GIR_EraseRootFromParent_Done,
     /* 1691012 */   // Label 23067: @1691012
     /* 1691012 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1691098), // Rule ID 12025 //
     /* 1691017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1691028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1691031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1691034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691063 */     // MIs[0] policy
     /* 1691063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691073 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1691076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691097 */     // GIR_Coverage, 12025,
     /* 1691097 */     GIR_EraseRootFromParent_Done,
     /* 1691098 */   // Label 23068: @1691098
     /* 1691098 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1691184), // Rule ID 12028 //
     /* 1691103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691149 */     // MIs[0] policy
     /* 1691149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1691162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691183 */     // GIR_Coverage, 12028,
     /* 1691183 */     GIR_EraseRootFromParent_Done,
     /* 1691184 */   // Label 23069: @1691184
     /* 1691184 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1691270), // Rule ID 12029 //
     /* 1691189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691235 */     // MIs[0] policy
     /* 1691235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1691248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691269 */     // GIR_Coverage, 12029,
     /* 1691269 */     GIR_EraseRootFromParent_Done,
     /* 1691270 */   // Label 23070: @1691270
     /* 1691270 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1691356), // Rule ID 12032 //
     /* 1691275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691321 */     // MIs[0] policy
     /* 1691321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691331 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1691334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691355 */     // GIR_Coverage, 12032,
     /* 1691355 */     GIR_EraseRootFromParent_Done,
     /* 1691356 */   // Label 23071: @1691356
     /* 1691356 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1691442), // Rule ID 12033 //
     /* 1691361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691407 */     // MIs[0] policy
     /* 1691407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1691420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691441 */     // GIR_Coverage, 12033,
     /* 1691441 */     GIR_EraseRootFromParent_Done,
     /* 1691442 */   // Label 23072: @1691442
     /* 1691442 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1691528), // Rule ID 12036 //
     /* 1691447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691493 */     // MIs[0] policy
     /* 1691493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691503 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1691506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691527 */     // GIR_Coverage, 12036,
     /* 1691527 */     GIR_EraseRootFromParent_Done,
     /* 1691528 */   // Label 23073: @1691528
     /* 1691528 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1691614), // Rule ID 12037 //
     /* 1691533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691579 */     // MIs[0] policy
     /* 1691579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691589 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1691592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691613 */     // GIR_Coverage, 12037,
     /* 1691613 */     GIR_EraseRootFromParent_Done,
     /* 1691614 */   // Label 23074: @1691614
     /* 1691614 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1691700), // Rule ID 12040 //
     /* 1691619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691665 */     // MIs[0] policy
     /* 1691665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1691678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691699 */     // GIR_Coverage, 12040,
     /* 1691699 */     GIR_EraseRootFromParent_Done,
     /* 1691700 */   // Label 23075: @1691700
     /* 1691700 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1691786), // Rule ID 12041 //
     /* 1691705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1691713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691751 */     // MIs[0] policy
     /* 1691751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691761 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1691764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691785 */     // GIR_Coverage, 12041,
     /* 1691785 */     GIR_EraseRootFromParent_Done,
     /* 1691786 */   // Label 23076: @1691786
     /* 1691786 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1691872), // Rule ID 12044 //
     /* 1691791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1691799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691837 */     // MIs[0] policy
     /* 1691837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691847 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1691850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691871 */     // GIR_Coverage, 12044,
     /* 1691871 */     GIR_EraseRootFromParent_Done,
     /* 1691872 */   // Label 23077: @1691872
     /* 1691872 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1691958), // Rule ID 12045 //
     /* 1691877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1691885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691923 */     // MIs[0] policy
     /* 1691923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691933 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1691936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691957 */     // GIR_Coverage, 12045,
     /* 1691957 */     GIR_EraseRootFromParent_Done,
     /* 1691958 */   // Label 23078: @1691958
     /* 1691958 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1692044), // Rule ID 12048 //
     /* 1691963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1691971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692009 */     // MIs[0] policy
     /* 1692009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692019 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1692022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692043 */     // GIR_Coverage, 12048,
     /* 1692043 */     GIR_EraseRootFromParent_Done,
     /* 1692044 */   // Label 23079: @1692044
     /* 1692044 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1692130), // Rule ID 12049 //
     /* 1692049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1692060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1692063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1692066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1692069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692095 */     // MIs[0] policy
     /* 1692095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692105 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1692108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692129 */     // GIR_Coverage, 12049,
     /* 1692129 */     GIR_EraseRootFromParent_Done,
     /* 1692130 */   // Label 23080: @1692130
     /* 1692130 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1692216), // Rule ID 12052 //
     /* 1692135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1692152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692181 */     // MIs[0] policy
     /* 1692181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692191 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1692194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692215 */     // GIR_Coverage, 12052,
     /* 1692215 */     GIR_EraseRootFromParent_Done,
     /* 1692216 */   // Label 23081: @1692216
     /* 1692216 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1692302), // Rule ID 12053 //
     /* 1692221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1692238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692267 */     // MIs[0] policy
     /* 1692267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692277 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1692280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692301 */     // GIR_Coverage, 12053,
     /* 1692301 */     GIR_EraseRootFromParent_Done,
     /* 1692302 */   // Label 23082: @1692302
     /* 1692302 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1692388), // Rule ID 12056 //
     /* 1692307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692353 */     // MIs[0] policy
     /* 1692353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692363 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1692366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692387 */     // GIR_Coverage, 12056,
     /* 1692387 */     GIR_EraseRootFromParent_Done,
     /* 1692388 */   // Label 23083: @1692388
     /* 1692388 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1692474), // Rule ID 12057 //
     /* 1692393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692439 */     // MIs[0] policy
     /* 1692439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692449 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1692452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692473 */     // GIR_Coverage, 12057,
     /* 1692473 */     GIR_EraseRootFromParent_Done,
     /* 1692474 */   // Label 23084: @1692474
     /* 1692474 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1692560), // Rule ID 12060 //
     /* 1692479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692525 */     // MIs[0] policy
     /* 1692525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692535 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1692538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692559 */     // GIR_Coverage, 12060,
     /* 1692559 */     GIR_EraseRootFromParent_Done,
     /* 1692560 */   // Label 23085: @1692560
     /* 1692560 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1692646), // Rule ID 12061 //
     /* 1692565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692611 */     // MIs[0] policy
     /* 1692611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692621 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1692624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692645 */     // GIR_Coverage, 12061,
     /* 1692645 */     GIR_EraseRootFromParent_Done,
     /* 1692646 */   // Label 23086: @1692646
     /* 1692646 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1692732), // Rule ID 12064 //
     /* 1692651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692697 */     // MIs[0] policy
     /* 1692697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692707 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1692710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692731 */     // GIR_Coverage, 12064,
     /* 1692731 */     GIR_EraseRootFromParent_Done,
     /* 1692732 */   // Label 23087: @1692732
     /* 1692732 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1692818), // Rule ID 12065 //
     /* 1692737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692783 */     // MIs[0] policy
     /* 1692783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692793 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1692796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692817 */     // GIR_Coverage, 12065,
     /* 1692817 */     GIR_EraseRootFromParent_Done,
     /* 1692818 */   // Label 23088: @1692818
     /* 1692818 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1692904), // Rule ID 12068 //
     /* 1692823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692869 */     // MIs[0] policy
     /* 1692869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692879 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1692882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692903 */     // GIR_Coverage, 12068,
     /* 1692903 */     GIR_EraseRootFromParent_Done,
     /* 1692904 */   // Label 23089: @1692904
     /* 1692904 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1692990), // Rule ID 12069 //
     /* 1692909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1692917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692955 */     // MIs[0] policy
     /* 1692955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1692968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692989 */     // GIR_Coverage, 12069,
     /* 1692989 */     GIR_EraseRootFromParent_Done,
     /* 1692990 */   // Label 23090: @1692990
     /* 1692990 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1693076), // Rule ID 12072 //
     /* 1692995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1693012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1693015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693041 */     // MIs[0] policy
     /* 1693041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1693054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693075 */     // GIR_Coverage, 12072,
     /* 1693075 */     GIR_EraseRootFromParent_Done,
     /* 1693076 */   // Label 23091: @1693076
     /* 1693076 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1693162), // Rule ID 12073 //
     /* 1693081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1693098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1693101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693127 */     // MIs[0] policy
     /* 1693127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693137 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1693140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693161 */     // GIR_Coverage, 12073,
     /* 1693161 */     GIR_EraseRootFromParent_Done,
     /* 1693162 */   // Label 23092: @1693162
     /* 1693162 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1693248), // Rule ID 12076 //
     /* 1693167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1693178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1693181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1693187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693213 */     // MIs[0] policy
     /* 1693213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693223 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1693226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693247 */     // GIR_Coverage, 12076,
     /* 1693247 */     GIR_EraseRootFromParent_Done,
     /* 1693248 */   // Label 23093: @1693248
     /* 1693248 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1693334), // Rule ID 12077 //
     /* 1693253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1693264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1693267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1693273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693299 */     // MIs[0] policy
     /* 1693299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693309 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1693312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693333 */     // GIR_Coverage, 12077,
     /* 1693333 */     GIR_EraseRootFromParent_Done,
     /* 1693334 */   // Label 23094: @1693334
     /* 1693334 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1693420), // Rule ID 12080 //
     /* 1693339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1693342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693385 */     // MIs[0] policy
     /* 1693385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1693398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693419 */     // GIR_Coverage, 12080,
     /* 1693419 */     GIR_EraseRootFromParent_Done,
     /* 1693420 */   // Label 23095: @1693420
     /* 1693420 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1693506), // Rule ID 12081 //
     /* 1693425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1693428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693471 */     // MIs[0] policy
     /* 1693471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1693484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693505 */     // GIR_Coverage, 12081,
     /* 1693505 */     GIR_EraseRootFromParent_Done,
     /* 1693506 */   // Label 23096: @1693506
     /* 1693506 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1693592), // Rule ID 12084 //
     /* 1693511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693557 */     // MIs[0] policy
     /* 1693557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693567 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1693570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693591 */     // GIR_Coverage, 12084,
     /* 1693591 */     GIR_EraseRootFromParent_Done,
     /* 1693592 */   // Label 23097: @1693592
     /* 1693592 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1693678), // Rule ID 12085 //
     /* 1693597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693643 */     // MIs[0] policy
     /* 1693643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1693656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693677 */     // GIR_Coverage, 12085,
     /* 1693677 */     GIR_EraseRootFromParent_Done,
     /* 1693678 */   // Label 23098: @1693678
     /* 1693678 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1693764), // Rule ID 12088 //
     /* 1693683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693729 */     // MIs[0] policy
     /* 1693729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693739 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1693742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693763 */     // GIR_Coverage, 12088,
     /* 1693763 */     GIR_EraseRootFromParent_Done,
     /* 1693764 */   // Label 23099: @1693764
     /* 1693764 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1693850), // Rule ID 12089 //
     /* 1693769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693815 */     // MIs[0] policy
     /* 1693815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693825 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1693828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693849 */     // GIR_Coverage, 12089,
     /* 1693849 */     GIR_EraseRootFromParent_Done,
     /* 1693850 */   // Label 23100: @1693850
     /* 1693850 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1693936), // Rule ID 12092 //
     /* 1693855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693901 */     // MIs[0] policy
     /* 1693901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693911 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1693914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693935 */     // GIR_Coverage, 12092,
     /* 1693935 */     GIR_EraseRootFromParent_Done,
     /* 1693936 */   // Label 23101: @1693936
     /* 1693936 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1694022), // Rule ID 12093 //
     /* 1693941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1693949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693987 */     // MIs[0] policy
     /* 1693987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693997 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1694000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694021 */     // GIR_Coverage, 12093,
     /* 1694021 */     GIR_EraseRootFromParent_Done,
     /* 1694022 */   // Label 23102: @1694022
     /* 1694022 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1694108), // Rule ID 12096 //
     /* 1694027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1694038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1694041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1694044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1694047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694073 */     // MIs[0] policy
     /* 1694073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694083 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1694086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694107 */     // GIR_Coverage, 12096,
     /* 1694107 */     GIR_EraseRootFromParent_Done,
     /* 1694108 */   // Label 23103: @1694108
     /* 1694108 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1694194), // Rule ID 12097 //
     /* 1694113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1694124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1694127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1694130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1694133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694159 */     // MIs[0] policy
     /* 1694159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1694172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694193 */     // GIR_Coverage, 12097,
     /* 1694193 */     GIR_EraseRootFromParent_Done,
     /* 1694194 */   // Label 23104: @1694194
     /* 1694194 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1694280), // Rule ID 12100 //
     /* 1694199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694245 */     // MIs[0] policy
     /* 1694245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1694258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694279 */     // GIR_Coverage, 12100,
     /* 1694279 */     GIR_EraseRootFromParent_Done,
     /* 1694280 */   // Label 23105: @1694280
     /* 1694280 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1694366), // Rule ID 12101 //
     /* 1694285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694331 */     // MIs[0] policy
     /* 1694331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1694344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694365 */     // GIR_Coverage, 12101,
     /* 1694365 */     GIR_EraseRootFromParent_Done,
     /* 1694366 */   // Label 23106: @1694366
     /* 1694366 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1694452), // Rule ID 12104 //
     /* 1694371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694417 */     // MIs[0] policy
     /* 1694417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694427 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1694430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694451 */     // GIR_Coverage, 12104,
     /* 1694451 */     GIR_EraseRootFromParent_Done,
     /* 1694452 */   // Label 23107: @1694452
     /* 1694452 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1694538), // Rule ID 12105 //
     /* 1694457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694503 */     // MIs[0] policy
     /* 1694503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694513 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1694516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694537 */     // GIR_Coverage, 12105,
     /* 1694537 */     GIR_EraseRootFromParent_Done,
     /* 1694538 */   // Label 23108: @1694538
     /* 1694538 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1694624), // Rule ID 12108 //
     /* 1694543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694589 */     // MIs[0] policy
     /* 1694589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1694602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694623 */     // GIR_Coverage, 12108,
     /* 1694623 */     GIR_EraseRootFromParent_Done,
     /* 1694624 */   // Label 23109: @1694624
     /* 1694624 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1694710), // Rule ID 12109 //
     /* 1694629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694675 */     // MIs[0] policy
     /* 1694675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1694688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694709 */     // GIR_Coverage, 12109,
     /* 1694709 */     GIR_EraseRootFromParent_Done,
     /* 1694710 */   // Label 23110: @1694710
     /* 1694710 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1694796), // Rule ID 12112 //
     /* 1694715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694761 */     // MIs[0] policy
     /* 1694761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1694774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694795 */     // GIR_Coverage, 12112,
     /* 1694795 */     GIR_EraseRootFromParent_Done,
     /* 1694796 */   // Label 23111: @1694796
     /* 1694796 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1694882), // Rule ID 12113 //
     /* 1694801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694847 */     // MIs[0] policy
     /* 1694847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694857 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1694860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694881 */     // GIR_Coverage, 12113,
     /* 1694881 */     GIR_EraseRootFromParent_Done,
     /* 1694882 */   // Label 23112: @1694882
     /* 1694882 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1694968), // Rule ID 12116 //
     /* 1694887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694933 */     // MIs[0] policy
     /* 1694933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1694946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694967 */     // GIR_Coverage, 12116,
     /* 1694967 */     GIR_EraseRootFromParent_Done,
     /* 1694968 */   // Label 23113: @1694968
     /* 1694968 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1695054), // Rule ID 12117 //
     /* 1694973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1694981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695019 */     // MIs[0] policy
     /* 1695019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695029 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1695032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695053 */     // GIR_Coverage, 12117,
     /* 1695053 */     GIR_EraseRootFromParent_Done,
     /* 1695054 */   // Label 23114: @1695054
     /* 1695054 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1695140), // Rule ID 12120 //
     /* 1695059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1695070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1695073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1695076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1695079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695105 */     // MIs[0] policy
     /* 1695105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1695118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695139 */     // GIR_Coverage, 12120,
     /* 1695139 */     GIR_EraseRootFromParent_Done,
     /* 1695140 */   // Label 23115: @1695140
     /* 1695140 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1695226), // Rule ID 12121 //
     /* 1695145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1695156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1695159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1695162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1695165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695191 */     // MIs[0] policy
     /* 1695191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1695204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695225 */     // GIR_Coverage, 12121,
     /* 1695225 */     GIR_EraseRootFromParent_Done,
     /* 1695226 */   // Label 23116: @1695226
     /* 1695226 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1695312), // Rule ID 12124 //
     /* 1695231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695277 */     // MIs[0] policy
     /* 1695277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695287 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1695290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695311 */     // GIR_Coverage, 12124,
     /* 1695311 */     GIR_EraseRootFromParent_Done,
     /* 1695312 */   // Label 23117: @1695312
     /* 1695312 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1695398), // Rule ID 12125 //
     /* 1695317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695363 */     // MIs[0] policy
     /* 1695363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695373 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1695376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695397 */     // GIR_Coverage, 12125,
     /* 1695397 */     GIR_EraseRootFromParent_Done,
     /* 1695398 */   // Label 23118: @1695398
     /* 1695398 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1695484), // Rule ID 12128 //
     /* 1695403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695449 */     // MIs[0] policy
     /* 1695449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695459 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1695462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695483 */     // GIR_Coverage, 12128,
     /* 1695483 */     GIR_EraseRootFromParent_Done,
     /* 1695484 */   // Label 23119: @1695484
     /* 1695484 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1695570), // Rule ID 12129 //
     /* 1695489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695535 */     // MIs[0] policy
     /* 1695535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695545 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1695548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695569 */     // GIR_Coverage, 12129,
     /* 1695569 */     GIR_EraseRootFromParent_Done,
     /* 1695570 */   // Label 23120: @1695570
     /* 1695570 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1695656), // Rule ID 12132 //
     /* 1695575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695621 */     // MIs[0] policy
     /* 1695621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695631 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1695634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695655 */     // GIR_Coverage, 12132,
     /* 1695655 */     GIR_EraseRootFromParent_Done,
     /* 1695656 */   // Label 23121: @1695656
     /* 1695656 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1695742), // Rule ID 12133 //
     /* 1695661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695707 */     // MIs[0] policy
     /* 1695707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695717 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1695720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695741 */     // GIR_Coverage, 12133,
     /* 1695741 */     GIR_EraseRootFromParent_Done,
     /* 1695742 */   // Label 23122: @1695742
     /* 1695742 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1695828), // Rule ID 12136 //
     /* 1695747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695793 */     // MIs[0] policy
     /* 1695793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695803 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1695806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695827 */     // GIR_Coverage, 12136,
     /* 1695827 */     GIR_EraseRootFromParent_Done,
     /* 1695828 */   // Label 23123: @1695828
     /* 1695828 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1695914), // Rule ID 12137 //
     /* 1695833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695879 */     // MIs[0] policy
     /* 1695879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695889 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1695892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695913 */     // GIR_Coverage, 12137,
     /* 1695913 */     GIR_EraseRootFromParent_Done,
     /* 1695914 */   // Label 23124: @1695914
     /* 1695914 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1696000), // Rule ID 12140 //
     /* 1695919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1695927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695965 */     // MIs[0] policy
     /* 1695965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695975 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1695978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695999 */     // GIR_Coverage, 12140,
     /* 1695999 */     GIR_EraseRootFromParent_Done,
     /* 1696000 */   // Label 23125: @1696000
     /* 1696000 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1696086), // Rule ID 12141 //
     /* 1696005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1696016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1696019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1696022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696051 */     // MIs[0] policy
     /* 1696051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696061 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1696064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696085 */     // GIR_Coverage, 12141,
     /* 1696085 */     GIR_EraseRootFromParent_Done,
     /* 1696086 */   // Label 23126: @1696086
     /* 1696086 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1696172), // Rule ID 12144 //
     /* 1696091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1696102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1696105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1696108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696137 */     // MIs[0] policy
     /* 1696137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696147 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1696150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696171 */     // GIR_Coverage, 12144,
     /* 1696171 */     GIR_EraseRootFromParent_Done,
     /* 1696172 */   // Label 23127: @1696172
     /* 1696172 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1696258), // Rule ID 12145 //
     /* 1696177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1696188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1696191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1696194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696223 */     // MIs[0] policy
     /* 1696223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696233 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1696236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696257 */     // GIR_Coverage, 12145,
     /* 1696257 */     GIR_EraseRootFromParent_Done,
     /* 1696258 */   // Label 23128: @1696258
     /* 1696258 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1696344), // Rule ID 12148 //
     /* 1696263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696309 */     // MIs[0] policy
     /* 1696309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1696322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696343 */     // GIR_Coverage, 12148,
     /* 1696343 */     GIR_EraseRootFromParent_Done,
     /* 1696344 */   // Label 23129: @1696344
     /* 1696344 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1696430), // Rule ID 12149 //
     /* 1696349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696395 */     // MIs[0] policy
     /* 1696395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696405 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1696408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696429 */     // GIR_Coverage, 12149,
     /* 1696429 */     GIR_EraseRootFromParent_Done,
     /* 1696430 */   // Label 23130: @1696430
     /* 1696430 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1696516), // Rule ID 12152 //
     /* 1696435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696481 */     // MIs[0] policy
     /* 1696481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1696494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696515 */     // GIR_Coverage, 12152,
     /* 1696515 */     GIR_EraseRootFromParent_Done,
     /* 1696516 */   // Label 23131: @1696516
     /* 1696516 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1696602), // Rule ID 12153 //
     /* 1696521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696567 */     // MIs[0] policy
     /* 1696567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1696580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696601 */     // GIR_Coverage, 12153,
     /* 1696601 */     GIR_EraseRootFromParent_Done,
     /* 1696602 */   // Label 23132: @1696602
     /* 1696602 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1696688), // Rule ID 12156 //
     /* 1696607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696653 */     // MIs[0] policy
     /* 1696653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1696666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696687 */     // GIR_Coverage, 12156,
     /* 1696687 */     GIR_EraseRootFromParent_Done,
     /* 1696688 */   // Label 23133: @1696688
     /* 1696688 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1696774), // Rule ID 12157 //
     /* 1696693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696739 */     // MIs[0] policy
     /* 1696739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696749 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11205:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1696752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696773 */     // GIR_Coverage, 12157,
     /* 1696773 */     GIR_EraseRootFromParent_Done,
     /* 1696774 */   // Label 23134: @1696774
     /* 1696774 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1696860), // Rule ID 12160 //
     /* 1696779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696825 */     // MIs[0] policy
     /* 1696825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696835 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1696838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696859 */     // GIR_Coverage, 12160,
     /* 1696859 */     GIR_EraseRootFromParent_Done,
     /* 1696860 */   // Label 23135: @1696860
     /* 1696860 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1696946), // Rule ID 12161 //
     /* 1696865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696911 */     // MIs[0] policy
     /* 1696911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1696924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696945 */     // GIR_Coverage, 12161,
     /* 1696945 */     GIR_EraseRootFromParent_Done,
     /* 1696946 */   // Label 23136: @1696946
     /* 1696946 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1697032), // Rule ID 12164 //
     /* 1696951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1696959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696997 */     // MIs[0] policy
     /* 1696997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1697010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697031 */     // GIR_Coverage, 12164,
     /* 1697031 */     GIR_EraseRootFromParent_Done,
     /* 1697032 */   // Label 23137: @1697032
     /* 1697032 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1697118), // Rule ID 12165 //
     /* 1697037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1697048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1697051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1697054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1697060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697083 */     // MIs[0] policy
     /* 1697083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1697096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697117 */     // GIR_Coverage, 12165,
     /* 1697117 */     GIR_EraseRootFromParent_Done,
     /* 1697118 */   // Label 23138: @1697118
     /* 1697118 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1697204), // Rule ID 12168 //
     /* 1697123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1697126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1697134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1697137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1697140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697169 */     // MIs[0] policy
     /* 1697169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697179 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1697182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697203 */     // GIR_Coverage, 12168,
     /* 1697203 */     GIR_EraseRootFromParent_Done,
     /* 1697204 */   // Label 23139: @1697204
     /* 1697204 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1697290), // Rule ID 12169 //
     /* 1697209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1697212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1697220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1697223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1697226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697255 */     // MIs[0] policy
     /* 1697255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1697268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697289 */     // GIR_Coverage, 12169,
     /* 1697289 */     GIR_EraseRootFromParent_Done,
     /* 1697290 */   // Label 23140: @1697290
     /* 1697290 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1697376), // Rule ID 12172 //
     /* 1697295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697341 */     // MIs[0] policy
     /* 1697341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1697354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697375 */     // GIR_Coverage, 12172,
     /* 1697375 */     GIR_EraseRootFromParent_Done,
     /* 1697376 */   // Label 23141: @1697376
     /* 1697376 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1697462), // Rule ID 12173 //
     /* 1697381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697427 */     // MIs[0] policy
     /* 1697427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1697440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697461 */     // GIR_Coverage, 12173,
     /* 1697461 */     GIR_EraseRootFromParent_Done,
     /* 1697462 */   // Label 23142: @1697462
     /* 1697462 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1697548), // Rule ID 12176 //
     /* 1697467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697513 */     // MIs[0] policy
     /* 1697513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697523 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1697526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697547 */     // GIR_Coverage, 12176,
     /* 1697547 */     GIR_EraseRootFromParent_Done,
     /* 1697548 */   // Label 23143: @1697548
     /* 1697548 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1697634), // Rule ID 12177 //
     /* 1697553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697599 */     // MIs[0] policy
     /* 1697599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697609 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1697612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697633 */     // GIR_Coverage, 12177,
     /* 1697633 */     GIR_EraseRootFromParent_Done,
     /* 1697634 */   // Label 23144: @1697634
     /* 1697634 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1697720), // Rule ID 12180 //
     /* 1697639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697685 */     // MIs[0] policy
     /* 1697685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697695 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1697698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697719 */     // GIR_Coverage, 12180,
     /* 1697719 */     GIR_EraseRootFromParent_Done,
     /* 1697720 */   // Label 23145: @1697720
     /* 1697720 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1697806), // Rule ID 12181 //
     /* 1697725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697771 */     // MIs[0] policy
     /* 1697771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1697784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697805 */     // GIR_Coverage, 12181,
     /* 1697805 */     GIR_EraseRootFromParent_Done,
     /* 1697806 */   // Label 23146: @1697806
     /* 1697806 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1697892), // Rule ID 12184 //
     /* 1697811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697857 */     // MIs[0] policy
     /* 1697857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1697870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697891 */     // GIR_Coverage, 12184,
     /* 1697891 */     GIR_EraseRootFromParent_Done,
     /* 1697892 */   // Label 23147: @1697892
     /* 1697892 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1697978), // Rule ID 12185 //
     /* 1697897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697943 */     // MIs[0] policy
     /* 1697943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1697956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697977 */     // GIR_Coverage, 12185,
     /* 1697977 */     GIR_EraseRootFromParent_Done,
     /* 1697978 */   // Label 23148: @1697978
     /* 1697978 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1698064), // Rule ID 12188 //
     /* 1697983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1697991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1698000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698029 */     // MIs[0] policy
     /* 1698029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698039 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1698042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698063 */     // GIR_Coverage, 12188,
     /* 1698063 */     GIR_EraseRootFromParent_Done,
     /* 1698064 */   // Label 23149: @1698064
     /* 1698064 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1698150), // Rule ID 12189 //
     /* 1698069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1698080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1698083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1698086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698115 */     // MIs[0] policy
     /* 1698115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698125 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1698128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698149 */     // GIR_Coverage, 12189,
     /* 1698149 */     GIR_EraseRootFromParent_Done,
     /* 1698150 */   // Label 23150: @1698150
     /* 1698150 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1698236), // Rule ID 12192 //
     /* 1698155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1698166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1698169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698201 */     // MIs[0] policy
     /* 1698201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698211 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1698214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698235 */     // GIR_Coverage, 12192,
     /* 1698235 */     GIR_EraseRootFromParent_Done,
     /* 1698236 */   // Label 23151: @1698236
     /* 1698236 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1698322), // Rule ID 12193 //
     /* 1698241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1698252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1698255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698287 */     // MIs[0] policy
     /* 1698287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698297 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1698300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698321 */     // GIR_Coverage, 12193,
     /* 1698321 */     GIR_EraseRootFromParent_Done,
     /* 1698322 */   // Label 23152: @1698322
     /* 1698322 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1698408), // Rule ID 12196 //
     /* 1698327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698373 */     // MIs[0] policy
     /* 1698373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1698386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698407 */     // GIR_Coverage, 12196,
     /* 1698407 */     GIR_EraseRootFromParent_Done,
     /* 1698408 */   // Label 23153: @1698408
     /* 1698408 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1698494), // Rule ID 12197 //
     /* 1698413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698459 */     // MIs[0] policy
     /* 1698459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1698472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698493 */     // GIR_Coverage, 12197,
     /* 1698493 */     GIR_EraseRootFromParent_Done,
     /* 1698494 */   // Label 23154: @1698494
     /* 1698494 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1698580), // Rule ID 12200 //
     /* 1698499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698545 */     // MIs[0] policy
     /* 1698545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1698558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698579 */     // GIR_Coverage, 12200,
     /* 1698579 */     GIR_EraseRootFromParent_Done,
     /* 1698580 */   // Label 23155: @1698580
     /* 1698580 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1698666), // Rule ID 12201 //
     /* 1698585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698631 */     // MIs[0] policy
     /* 1698631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1698644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698665 */     // GIR_Coverage, 12201,
     /* 1698665 */     GIR_EraseRootFromParent_Done,
     /* 1698666 */   // Label 23156: @1698666
     /* 1698666 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1698752), // Rule ID 12204 //
     /* 1698671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698717 */     // MIs[0] policy
     /* 1698717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1698730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698751 */     // GIR_Coverage, 12204,
     /* 1698751 */     GIR_EraseRootFromParent_Done,
     /* 1698752 */   // Label 23157: @1698752
     /* 1698752 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1698838), // Rule ID 12205 //
     /* 1698757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698803 */     // MIs[0] policy
     /* 1698803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698813 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1698816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698837 */     // GIR_Coverage, 12205,
     /* 1698837 */     GIR_EraseRootFromParent_Done,
     /* 1698838 */   // Label 23158: @1698838
     /* 1698838 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1698924), // Rule ID 12208 //
     /* 1698843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698889 */     // MIs[0] policy
     /* 1698889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1698902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698923 */     // GIR_Coverage, 12208,
     /* 1698923 */     GIR_EraseRootFromParent_Done,
     /* 1698924 */   // Label 23159: @1698924
     /* 1698924 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1699010), // Rule ID 12209 //
     /* 1698929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1698937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698975 */     // MIs[0] policy
     /* 1698975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1698988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699009 */     // GIR_Coverage, 12209,
     /* 1699009 */     GIR_EraseRootFromParent_Done,
     /* 1699010 */   // Label 23160: @1699010
     /* 1699010 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1699096), // Rule ID 12212 //
     /* 1699015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1699018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1699023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1699026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1699029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1699032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699061 */     // MIs[0] policy
     /* 1699061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1699074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699095 */     // GIR_Coverage, 12212,
     /* 1699095 */     GIR_EraseRootFromParent_Done,
     /* 1699096 */   // Label 23161: @1699096
     /* 1699096 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1699182), // Rule ID 12213 //
     /* 1699101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1699104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1699109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1699112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1699115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1699118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699147 */     // MIs[0] policy
     /* 1699147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699157 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1699160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699181 */     // GIR_Coverage, 12213,
     /* 1699181 */     GIR_EraseRootFromParent_Done,
     /* 1699182 */   // Label 23162: @1699182
     /* 1699182 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1699268), // Rule ID 12216 //
     /* 1699187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1699190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1699195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1699198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699233 */     // MIs[0] policy
     /* 1699233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1699246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699267 */     // GIR_Coverage, 12216,
     /* 1699267 */     GIR_EraseRootFromParent_Done,
     /* 1699268 */   // Label 23163: @1699268
     /* 1699268 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1699354), // Rule ID 12217 //
     /* 1699273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1699276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1699281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1699284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699319 */     // MIs[0] policy
     /* 1699319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699329 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1699332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699353 */     // GIR_Coverage, 12217,
     /* 1699353 */     GIR_EraseRootFromParent_Done,
     /* 1699354 */   // Label 23164: @1699354
     /* 1699354 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1699440), // Rule ID 12220 //
     /* 1699359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1699376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699405 */     // MIs[0] policy
     /* 1699405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1699418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699439 */     // GIR_Coverage, 12220,
     /* 1699439 */     GIR_EraseRootFromParent_Done,
     /* 1699440 */   // Label 23165: @1699440
     /* 1699440 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1699526), // Rule ID 12221 //
     /* 1699445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1699462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699491 */     // MIs[0] policy
     /* 1699491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699501 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1699504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699525 */     // GIR_Coverage, 12221,
     /* 1699525 */     GIR_EraseRootFromParent_Done,
     /* 1699526 */   // Label 23166: @1699526
     /* 1699526 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1699612), // Rule ID 12224 //
     /* 1699531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1699548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699577 */     // MIs[0] policy
     /* 1699577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699587 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1699590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699611 */     // GIR_Coverage, 12224,
     /* 1699611 */     GIR_EraseRootFromParent_Done,
     /* 1699612 */   // Label 23167: @1699612
     /* 1699612 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1699698), // Rule ID 12225 //
     /* 1699617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1699634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699663 */     // MIs[0] policy
     /* 1699663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699673 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1699676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699697 */     // GIR_Coverage, 12225,
     /* 1699697 */     GIR_EraseRootFromParent_Done,
     /* 1699698 */   // Label 23168: @1699698
     /* 1699698 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1699784), // Rule ID 12228 //
     /* 1699703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1699714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1699717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1699720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699749 */     // MIs[0] policy
     /* 1699749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699759 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1699762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699783 */     // GIR_Coverage, 12228,
     /* 1699783 */     GIR_EraseRootFromParent_Done,
     /* 1699784 */   // Label 23169: @1699784
     /* 1699784 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1699870), // Rule ID 12229 //
     /* 1699789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1699800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1699803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1699806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699835 */     // MIs[0] policy
     /* 1699835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1699848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699869 */     // GIR_Coverage, 12229,
     /* 1699869 */     GIR_EraseRootFromParent_Done,
     /* 1699870 */   // Label 23170: @1699870
     /* 1699870 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1699956), // Rule ID 12232 //
     /* 1699875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1699886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1699889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1699892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699921 */     // MIs[0] policy
     /* 1699921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1699934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699955 */     // GIR_Coverage, 12232,
     /* 1699955 */     GIR_EraseRootFromParent_Done,
     /* 1699956 */   // Label 23171: @1699956
     /* 1699956 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1700042), // Rule ID 12233 //
     /* 1699961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1699969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1699972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1699975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1699978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700007 */     // MIs[0] policy
     /* 1700007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1700020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700041 */     // GIR_Coverage, 12233,
     /* 1700041 */     GIR_EraseRootFromParent_Done,
     /* 1700042 */   // Label 23172: @1700042
     /* 1700042 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1700128), // Rule ID 12236 //
     /* 1700047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1700064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1700067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700093 */     // MIs[0] policy
     /* 1700093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700103 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1700106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700127 */     // GIR_Coverage, 12236,
     /* 1700127 */     GIR_EraseRootFromParent_Done,
     /* 1700128 */   // Label 23173: @1700128
     /* 1700128 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1700214), // Rule ID 12237 //
     /* 1700133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1700150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1700153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700179 */     // MIs[0] policy
     /* 1700179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700189 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1700192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700213 */     // GIR_Coverage, 12237,
     /* 1700213 */     GIR_EraseRootFromParent_Done,
     /* 1700214 */   // Label 23174: @1700214
     /* 1700214 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1700300), // Rule ID 12240 //
     /* 1700219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1700230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1700233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1700236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1700249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700265 */     // MIs[0] policy
     /* 1700265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700275 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1700278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700299 */     // GIR_Coverage, 12240,
     /* 1700299 */     GIR_EraseRootFromParent_Done,
     /* 1700300 */   // Label 23175: @1700300
     /* 1700300 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1700386), // Rule ID 12241 //
     /* 1700305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1700316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1700319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1700322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1700335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700351 */     // MIs[0] policy
     /* 1700351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1700364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700385 */     // GIR_Coverage, 12241,
     /* 1700385 */     GIR_EraseRootFromParent_Done,
     /* 1700386 */   // Label 23176: @1700386
     /* 1700386 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1700472), // Rule ID 12244 //
     /* 1700391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1700408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700437 */     // MIs[0] policy
     /* 1700437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700447 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1700450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700471 */     // GIR_Coverage, 12244,
     /* 1700471 */     GIR_EraseRootFromParent_Done,
     /* 1700472 */   // Label 23177: @1700472
     /* 1700472 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1700558), // Rule ID 12245 //
     /* 1700477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1700494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700523 */     // MIs[0] policy
     /* 1700523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700533 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1700536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700557 */     // GIR_Coverage, 12245,
     /* 1700557 */     GIR_EraseRootFromParent_Done,
     /* 1700558 */   // Label 23178: @1700558
     /* 1700558 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1700644), // Rule ID 12248 //
     /* 1700563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1700580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700609 */     // MIs[0] policy
     /* 1700609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1700622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700643 */     // GIR_Coverage, 12248,
     /* 1700643 */     GIR_EraseRootFromParent_Done,
     /* 1700644 */   // Label 23179: @1700644
     /* 1700644 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1700730), // Rule ID 12249 //
     /* 1700649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1700666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700695 */     // MIs[0] policy
     /* 1700695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700705 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1700708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700729 */     // GIR_Coverage, 12249,
     /* 1700729 */     GIR_EraseRootFromParent_Done,
     /* 1700730 */   // Label 23180: @1700730
     /* 1700730 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1700816), // Rule ID 12252 //
     /* 1700735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1700746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1700749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1700752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700781 */     // MIs[0] policy
     /* 1700781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1700794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700815 */     // GIR_Coverage, 12252,
     /* 1700815 */     GIR_EraseRootFromParent_Done,
     /* 1700816 */   // Label 23181: @1700816
     /* 1700816 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1700902), // Rule ID 12253 //
     /* 1700821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1700832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1700835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1700838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700867 */     // MIs[0] policy
     /* 1700867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1700880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700901 */     // GIR_Coverage, 12253,
     /* 1700901 */     GIR_EraseRootFromParent_Done,
     /* 1700902 */   // Label 23182: @1700902
     /* 1700902 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1700988), // Rule ID 12256 //
     /* 1700907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1700915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1700918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1700921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1700924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700953 */     // MIs[0] policy
     /* 1700953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1700966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700987 */     // GIR_Coverage, 12256,
     /* 1700987 */     GIR_EraseRootFromParent_Done,
     /* 1700988 */   // Label 23183: @1700988
     /* 1700988 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1701074), // Rule ID 12257 //
     /* 1700993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1701013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701039 */     // MIs[0] policy
     /* 1701039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701049 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1701052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701073 */     // GIR_Coverage, 12257,
     /* 1701073 */     GIR_EraseRootFromParent_Done,
     /* 1701074 */   // Label 23184: @1701074
     /* 1701074 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1701160), // Rule ID 12260 //
     /* 1701079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1701090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1701093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1701099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701125 */     // MIs[0] policy
     /* 1701125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701135 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1701138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701159 */     // GIR_Coverage, 12260,
     /* 1701159 */     GIR_EraseRootFromParent_Done,
     /* 1701160 */   // Label 23185: @1701160
     /* 1701160 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1701246), // Rule ID 12261 //
     /* 1701165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1701176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1701179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1701185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701211 */     // MIs[0] policy
     /* 1701211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701221 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1701224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701245 */     // GIR_Coverage, 12261,
     /* 1701245 */     GIR_EraseRootFromParent_Done,
     /* 1701246 */   // Label 23186: @1701246
     /* 1701246 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1701332), // Rule ID 12264 //
     /* 1701251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1701262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1701265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1701268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701297 */     // MIs[0] policy
     /* 1701297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701307 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1701310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701331 */     // GIR_Coverage, 12264,
     /* 1701331 */     GIR_EraseRootFromParent_Done,
     /* 1701332 */   // Label 23187: @1701332
     /* 1701332 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1701418), // Rule ID 12265 //
     /* 1701337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1701348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1701351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1701354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701383 */     // MIs[0] policy
     /* 1701383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1701396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701417 */     // GIR_Coverage, 12265,
     /* 1701417 */     GIR_EraseRootFromParent_Done,
     /* 1701418 */   // Label 23188: @1701418
     /* 1701418 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1701504), // Rule ID 12268 //
     /* 1701423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1701434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1701437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1701440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701469 */     // MIs[0] policy
     /* 1701469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1701482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701503 */     // GIR_Coverage, 12268,
     /* 1701503 */     GIR_EraseRootFromParent_Done,
     /* 1701504 */   // Label 23189: @1701504
     /* 1701504 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1701590), // Rule ID 12269 //
     /* 1701509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1701520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1701523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1701526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701555 */     // MIs[0] policy
     /* 1701555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1701568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701589 */     // GIR_Coverage, 12269,
     /* 1701589 */     GIR_EraseRootFromParent_Done,
     /* 1701590 */   // Label 23190: @1701590
     /* 1701590 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1701676), // Rule ID 12272 //
     /* 1701595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1701606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1701609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701641 */     // MIs[0] policy
     /* 1701641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1701654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701675 */     // GIR_Coverage, 12272,
     /* 1701675 */     GIR_EraseRootFromParent_Done,
     /* 1701676 */   // Label 23191: @1701676
     /* 1701676 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1701762), // Rule ID 12273 //
     /* 1701681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1701692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1701695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701727 */     // MIs[0] policy
     /* 1701727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701737 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1701740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701761 */     // GIR_Coverage, 12273,
     /* 1701761 */     GIR_EraseRootFromParent_Done,
     /* 1701762 */   // Label 23192: @1701762
     /* 1701762 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1701848), // Rule ID 12276 //
     /* 1701767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1701778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1701781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701813 */     // MIs[0] policy
     /* 1701813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1701826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701847 */     // GIR_Coverage, 12276,
     /* 1701847 */     GIR_EraseRootFromParent_Done,
     /* 1701848 */   // Label 23193: @1701848
     /* 1701848 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1701934), // Rule ID 12277 //
     /* 1701853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1701864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1701867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701899 */     // MIs[0] policy
     /* 1701899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1701912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701933 */     // GIR_Coverage, 12277,
     /* 1701933 */     GIR_EraseRootFromParent_Done,
     /* 1701934 */   // Label 23194: @1701934
     /* 1701934 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1702020), // Rule ID 12280 //
     /* 1701939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1701947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1701950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1701953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1701956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701985 */     // MIs[0] policy
     /* 1701985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701995 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1701998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702019 */     // GIR_Coverage, 12280,
     /* 1702019 */     GIR_EraseRootFromParent_Done,
     /* 1702020 */   // Label 23195: @1702020
     /* 1702020 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1702106), // Rule ID 12281 //
     /* 1702025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1702042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702071 */     // MIs[0] policy
     /* 1702071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1702084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702105 */     // GIR_Coverage, 12281,
     /* 1702105 */     GIR_EraseRootFromParent_Done,
     /* 1702106 */   // Label 23196: @1702106
     /* 1702106 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1702192), // Rule ID 12284 //
     /* 1702111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1702128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702157 */     // MIs[0] policy
     /* 1702157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702167 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1702170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702191 */     // GIR_Coverage, 12284,
     /* 1702191 */     GIR_EraseRootFromParent_Done,
     /* 1702192 */   // Label 23197: @1702192
     /* 1702192 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1702278), // Rule ID 12285 //
     /* 1702197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1702214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702243 */     // MIs[0] policy
     /* 1702243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1702256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702277 */     // GIR_Coverage, 12285,
     /* 1702277 */     GIR_EraseRootFromParent_Done,
     /* 1702278 */   // Label 23198: @1702278
     /* 1702278 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1702364), // Rule ID 12288 //
     /* 1702283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1702300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702329 */     // MIs[0] policy
     /* 1702329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702339 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1702342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702363 */     // GIR_Coverage, 12288,
     /* 1702363 */     GIR_EraseRootFromParent_Done,
     /* 1702364 */   // Label 23199: @1702364
     /* 1702364 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1702450), // Rule ID 12289 //
     /* 1702369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1702386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702415 */     // MIs[0] policy
     /* 1702415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1702428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702449 */     // GIR_Coverage, 12289,
     /* 1702449 */     GIR_EraseRootFromParent_Done,
     /* 1702450 */   // Label 23200: @1702450
     /* 1702450 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1702536), // Rule ID 12292 //
     /* 1702455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1702472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702501 */     // MIs[0] policy
     /* 1702501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702511 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1702514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702535 */     // GIR_Coverage, 12292,
     /* 1702535 */     GIR_EraseRootFromParent_Done,
     /* 1702536 */   // Label 23201: @1702536
     /* 1702536 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1702622), // Rule ID 12293 //
     /* 1702541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1702558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702587 */     // MIs[0] policy
     /* 1702587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1702600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702621 */     // GIR_Coverage, 12293,
     /* 1702621 */     GIR_EraseRootFromParent_Done,
     /* 1702622 */   // Label 23202: @1702622
     /* 1702622 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1702708), // Rule ID 12296 //
     /* 1702627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1702638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1702641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1702644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702673 */     // MIs[0] policy
     /* 1702673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702683 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1702686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702707 */     // GIR_Coverage, 12296,
     /* 1702707 */     GIR_EraseRootFromParent_Done,
     /* 1702708 */   // Label 23203: @1702708
     /* 1702708 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1702794), // Rule ID 12297 //
     /* 1702713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1702724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1702727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1702730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702759 */     // MIs[0] policy
     /* 1702759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702769 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1702772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702793 */     // GIR_Coverage, 12297,
     /* 1702793 */     GIR_EraseRootFromParent_Done,
     /* 1702794 */   // Label 23204: @1702794
     /* 1702794 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1702880), // Rule ID 12300 //
     /* 1702799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1702810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1702813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1702816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1702829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702845 */     // MIs[0] policy
     /* 1702845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702855 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1702858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702879 */     // GIR_Coverage, 12300,
     /* 1702879 */     GIR_EraseRootFromParent_Done,
     /* 1702880 */   // Label 23205: @1702880
     /* 1702880 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1702966), // Rule ID 12301 //
     /* 1702885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1702896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1702899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1702902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1702915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702931 */     // MIs[0] policy
     /* 1702931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1702944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702965 */     // GIR_Coverage, 12301,
     /* 1702965 */     GIR_EraseRootFromParent_Done,
     /* 1702966 */   // Label 23206: @1702966
     /* 1702966 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1703052), // Rule ID 12304 //
     /* 1702971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1702979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1702982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1702985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1702988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703017 */     // MIs[0] policy
     /* 1703017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1703030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703051 */     // GIR_Coverage, 12304,
     /* 1703051 */     GIR_EraseRootFromParent_Done,
     /* 1703052 */   // Label 23207: @1703052
     /* 1703052 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1703138), // Rule ID 12305 //
     /* 1703057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703103 */     // MIs[0] policy
     /* 1703103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703113 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1703116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703137 */     // GIR_Coverage, 12305,
     /* 1703137 */     GIR_EraseRootFromParent_Done,
     /* 1703138 */   // Label 23208: @1703138
     /* 1703138 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1703224), // Rule ID 12308 //
     /* 1703143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1703160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703189 */     // MIs[0] policy
     /* 1703189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1703202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703223 */     // GIR_Coverage, 12308,
     /* 1703223 */     GIR_EraseRootFromParent_Done,
     /* 1703224 */   // Label 23209: @1703224
     /* 1703224 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1703310), // Rule ID 12309 //
     /* 1703229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1703246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703275 */     // MIs[0] policy
     /* 1703275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1703288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703309 */     // GIR_Coverage, 12309,
     /* 1703309 */     GIR_EraseRootFromParent_Done,
     /* 1703310 */   // Label 23210: @1703310
     /* 1703310 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1703396), // Rule ID 12312 //
     /* 1703315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1703332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703361 */     // MIs[0] policy
     /* 1703361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1703374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703395 */     // GIR_Coverage, 12312,
     /* 1703395 */     GIR_EraseRootFromParent_Done,
     /* 1703396 */   // Label 23211: @1703396
     /* 1703396 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1703482), // Rule ID 12313 //
     /* 1703401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1703418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703447 */     // MIs[0] policy
     /* 1703447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1703460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703481 */     // GIR_Coverage, 12313,
     /* 1703481 */     GIR_EraseRootFromParent_Done,
     /* 1703482 */   // Label 23212: @1703482
     /* 1703482 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1703568), // Rule ID 12316 //
     /* 1703487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1703504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703533 */     // MIs[0] policy
     /* 1703533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1703546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703567 */     // GIR_Coverage, 12316,
     /* 1703567 */     GIR_EraseRootFromParent_Done,
     /* 1703568 */   // Label 23213: @1703568
     /* 1703568 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1703654), // Rule ID 12317 //
     /* 1703573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1703590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703619 */     // MIs[0] policy
     /* 1703619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1703632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703653 */     // GIR_Coverage, 12317,
     /* 1703653 */     GIR_EraseRootFromParent_Done,
     /* 1703654 */   // Label 23214: @1703654
     /* 1703654 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1703740), // Rule ID 12320 //
     /* 1703659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1703670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1703673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1703676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1703689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703705 */     // MIs[0] policy
     /* 1703705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1703718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703739 */     // GIR_Coverage, 12320,
     /* 1703739 */     GIR_EraseRootFromParent_Done,
     /* 1703740 */   // Label 23215: @1703740
     /* 1703740 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1703826), // Rule ID 12321 //
     /* 1703745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1703756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1703759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1703762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1703775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703791 */     // MIs[0] policy
     /* 1703791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1703804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703825 */     // GIR_Coverage, 12321,
     /* 1703825 */     GIR_EraseRootFromParent_Done,
     /* 1703826 */   // Label 23216: @1703826
     /* 1703826 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1703912), // Rule ID 12324 //
     /* 1703831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1703842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1703845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703877 */     // MIs[0] policy
     /* 1703877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703887 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1703890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703911 */     // GIR_Coverage, 12324,
     /* 1703911 */     GIR_EraseRootFromParent_Done,
     /* 1703912 */   // Label 23217: @1703912
     /* 1703912 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1703998), // Rule ID 12325 //
     /* 1703917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1703925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1703928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1703931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703963 */     // MIs[0] policy
     /* 1703963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1703976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703997 */     // GIR_Coverage, 12325,
     /* 1703997 */     GIR_EraseRootFromParent_Done,
     /* 1703998 */   // Label 23218: @1703998
     /* 1703998 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1704084), // Rule ID 12328 //
     /* 1704003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1704014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1704017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1704020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704049 */     // MIs[0] policy
     /* 1704049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1704062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704083 */     // GIR_Coverage, 12328,
     /* 1704083 */     GIR_EraseRootFromParent_Done,
     /* 1704084 */   // Label 23219: @1704084
     /* 1704084 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1704170), // Rule ID 12329 //
     /* 1704089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1704100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1704103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1704106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704135 */     // MIs[0] policy
     /* 1704135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1704148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704169 */     // GIR_Coverage, 12329,
     /* 1704169 */     GIR_EraseRootFromParent_Done,
     /* 1704170 */   // Label 23220: @1704170
     /* 1704170 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1704256), // Rule ID 12332 //
     /* 1704175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1704186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1704189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1704192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704221 */     // MIs[0] policy
     /* 1704221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1704234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704255 */     // GIR_Coverage, 12332,
     /* 1704255 */     GIR_EraseRootFromParent_Done,
     /* 1704256 */   // Label 23221: @1704256
     /* 1704256 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1704342), // Rule ID 12333 //
     /* 1704261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1704272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1704275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1704278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704307 */     // MIs[0] policy
     /* 1704307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704317 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1704320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704341 */     // GIR_Coverage, 12333,
     /* 1704341 */     GIR_EraseRootFromParent_Done,
     /* 1704342 */   // Label 23222: @1704342
     /* 1704342 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1704428), // Rule ID 12336 //
     /* 1704347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1704358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1704361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1704364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1704377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704393 */     // MIs[0] policy
     /* 1704393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704403 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1704406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704427 */     // GIR_Coverage, 12336,
     /* 1704427 */     GIR_EraseRootFromParent_Done,
     /* 1704428 */   // Label 23223: @1704428
     /* 1704428 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1704514), // Rule ID 12337 //
     /* 1704433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1704441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1704444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1704447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1704450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1704463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704479 */     // MIs[0] policy
     /* 1704479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1704492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704513 */     // GIR_Coverage, 12337,
     /* 1704513 */     GIR_EraseRootFromParent_Done,
     /* 1704514 */   // Label 23224: @1704514
     /* 1704514 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1704600), // Rule ID 12340 //
     /* 1704519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1704536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704565 */     // MIs[0] policy
     /* 1704565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704575 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1704578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704599 */     // GIR_Coverage, 12340,
     /* 1704599 */     GIR_EraseRootFromParent_Done,
     /* 1704600 */   // Label 23225: @1704600
     /* 1704600 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1704686), // Rule ID 12341 //
     /* 1704605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1704622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704651 */     // MIs[0] policy
     /* 1704651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704661 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1704664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704685 */     // GIR_Coverage, 12341,
     /* 1704685 */     GIR_EraseRootFromParent_Done,
     /* 1704686 */   // Label 23226: @1704686
     /* 1704686 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1704772), // Rule ID 12344 //
     /* 1704691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1704702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1704705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1704708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704737 */     // MIs[0] policy
     /* 1704737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704747 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1704750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704771 */     // GIR_Coverage, 12344,
     /* 1704771 */     GIR_EraseRootFromParent_Done,
     /* 1704772 */   // Label 23227: @1704772
     /* 1704772 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1704858), // Rule ID 12345 //
     /* 1704777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1704788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1704791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1704794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704823 */     // MIs[0] policy
     /* 1704823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1704836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704857 */     // GIR_Coverage, 12345,
     /* 1704857 */     GIR_EraseRootFromParent_Done,
     /* 1704858 */   // Label 23228: @1704858
     /* 1704858 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1704944), // Rule ID 12348 //
     /* 1704863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1704874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1704877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1704880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704909 */     // MIs[0] policy
     /* 1704909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1704922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704943 */     // GIR_Coverage, 12348,
     /* 1704943 */     GIR_EraseRootFromParent_Done,
     /* 1704944 */   // Label 23229: @1704944
     /* 1704944 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1705030), // Rule ID 12349 //
     /* 1704949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1704957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1704960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1704963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1704966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704995 */     // MIs[0] policy
     /* 1704995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705005 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1705008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705029 */     // GIR_Coverage, 12349,
     /* 1705029 */     GIR_EraseRootFromParent_Done,
     /* 1705030 */   // Label 23230: @1705030
     /* 1705030 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1705116), // Rule ID 12352 //
     /* 1705035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1705052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1705055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705081 */     // MIs[0] policy
     /* 1705081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1705094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705115 */     // GIR_Coverage, 12352,
     /* 1705115 */     GIR_EraseRootFromParent_Done,
     /* 1705116 */   // Label 23231: @1705116
     /* 1705116 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1705202), // Rule ID 12353 //
     /* 1705121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1705138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1705141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705167 */     // MIs[0] policy
     /* 1705167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1705180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705201 */     // GIR_Coverage, 12353,
     /* 1705201 */     GIR_EraseRootFromParent_Done,
     /* 1705202 */   // Label 23232: @1705202
     /* 1705202 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1705288), // Rule ID 12356 //
     /* 1705207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1705224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705253 */     // MIs[0] policy
     /* 1705253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705263 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1705266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705287 */     // GIR_Coverage, 12356,
     /* 1705287 */     GIR_EraseRootFromParent_Done,
     /* 1705288 */   // Label 23233: @1705288
     /* 1705288 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1705374), // Rule ID 12357 //
     /* 1705293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1705310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705339 */     // MIs[0] policy
     /* 1705339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1705352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705373 */     // GIR_Coverage, 12357,
     /* 1705373 */     GIR_EraseRootFromParent_Done,
     /* 1705374 */   // Label 23234: @1705374
     /* 1705374 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1705460), // Rule ID 12360 //
     /* 1705379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1705390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1705393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1705396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705425 */     // MIs[0] policy
     /* 1705425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705435 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1705438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705459 */     // GIR_Coverage, 12360,
     /* 1705459 */     GIR_EraseRootFromParent_Done,
     /* 1705460 */   // Label 23235: @1705460
     /* 1705460 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1705546), // Rule ID 12361 //
     /* 1705465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1705476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1705479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1705482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705511 */     // MIs[0] policy
     /* 1705511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1705524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705545 */     // GIR_Coverage, 12361,
     /* 1705545 */     GIR_EraseRootFromParent_Done,
     /* 1705546 */   // Label 23236: @1705546
     /* 1705546 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1705632), // Rule ID 12364 //
     /* 1705551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1705568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705597 */     // MIs[0] policy
     /* 1705597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705607 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1705610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705631 */     // GIR_Coverage, 12364,
     /* 1705631 */     GIR_EraseRootFromParent_Done,
     /* 1705632 */   // Label 23237: @1705632
     /* 1705632 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1705718), // Rule ID 12365 //
     /* 1705637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1705654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705683 */     // MIs[0] policy
     /* 1705683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1705696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705717 */     // GIR_Coverage, 12365,
     /* 1705717 */     GIR_EraseRootFromParent_Done,
     /* 1705718 */   // Label 23238: @1705718
     /* 1705718 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1705804), // Rule ID 12368 //
     /* 1705723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1705734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1705737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1705740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705769 */     // MIs[0] policy
     /* 1705769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1705782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705803 */     // GIR_Coverage, 12368,
     /* 1705803 */     GIR_EraseRootFromParent_Done,
     /* 1705804 */   // Label 23239: @1705804
     /* 1705804 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1705890), // Rule ID 12369 //
     /* 1705809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1705820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1705823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1705826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705855 */     // MIs[0] policy
     /* 1705855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1705868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705889 */     // GIR_Coverage, 12369,
     /* 1705889 */     GIR_EraseRootFromParent_Done,
     /* 1705890 */   // Label 23240: @1705890
     /* 1705890 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1705976), // Rule ID 12372 //
     /* 1705895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1705906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1705909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1705912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705941 */     // MIs[0] policy
     /* 1705941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1705954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705975 */     // GIR_Coverage, 12372,
     /* 1705975 */     GIR_EraseRootFromParent_Done,
     /* 1705976 */   // Label 23241: @1705976
     /* 1705976 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1706062), // Rule ID 12373 //
     /* 1705981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1705989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1705992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1705995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1705998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1706001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706027 */     // MIs[0] policy
     /* 1706027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1706040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706061 */     // GIR_Coverage, 12373,
     /* 1706061 */     GIR_EraseRootFromParent_Done,
     /* 1706062 */   // Label 23242: @1706062
     /* 1706062 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1706148), // Rule ID 12376 //
     /* 1706067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1706084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1706087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706113 */     // MIs[0] policy
     /* 1706113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706123 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1706126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706147 */     // GIR_Coverage, 12376,
     /* 1706147 */     GIR_EraseRootFromParent_Done,
     /* 1706148 */   // Label 23243: @1706148
     /* 1706148 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1706234), // Rule ID 12377 //
     /* 1706153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1706170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1706173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706199 */     // MIs[0] policy
     /* 1706199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1706212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706233 */     // GIR_Coverage, 12377,
     /* 1706233 */     GIR_EraseRootFromParent_Done,
     /* 1706234 */   // Label 23244: @1706234
     /* 1706234 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1706320), // Rule ID 12380 //
     /* 1706239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1706250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1706253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1706256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1706269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706285 */     // MIs[0] policy
     /* 1706285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706295 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1706298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706319 */     // GIR_Coverage, 12380,
     /* 1706319 */     GIR_EraseRootFromParent_Done,
     /* 1706320 */   // Label 23245: @1706320
     /* 1706320 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1706406), // Rule ID 12381 //
     /* 1706325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1706336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1706339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1706342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1706355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706371 */     // MIs[0] policy
     /* 1706371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1706384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706405 */     // GIR_Coverage, 12381,
     /* 1706405 */     GIR_EraseRootFromParent_Done,
     /* 1706406 */   // Label 23246: @1706406
     /* 1706406 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1706492), // Rule ID 12384 //
     /* 1706411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1706422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1706425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1706428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706457 */     // MIs[0] policy
     /* 1706457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706467 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1706470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706491 */     // GIR_Coverage, 12384,
     /* 1706491 */     GIR_EraseRootFromParent_Done,
     /* 1706492 */   // Label 23247: @1706492
     /* 1706492 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1706578), // Rule ID 12385 //
     /* 1706497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1706508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1706511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1706514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706543 */     // MIs[0] policy
     /* 1706543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1706556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706577 */     // GIR_Coverage, 12385,
     /* 1706577 */     GIR_EraseRootFromParent_Done,
     /* 1706578 */   // Label 23248: @1706578
     /* 1706578 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1706664), // Rule ID 12388 //
     /* 1706583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1706594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1706597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1706600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706629 */     // MIs[0] policy
     /* 1706629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1706642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706663 */     // GIR_Coverage, 12388,
     /* 1706663 */     GIR_EraseRootFromParent_Done,
     /* 1706664 */   // Label 23249: @1706664
     /* 1706664 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1706750), // Rule ID 12389 //
     /* 1706669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1706680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1706683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1706686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706715 */     // MIs[0] policy
     /* 1706715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1706728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706749 */     // GIR_Coverage, 12389,
     /* 1706749 */     GIR_EraseRootFromParent_Done,
     /* 1706750 */   // Label 23250: @1706750
     /* 1706750 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1706836), // Rule ID 12392 //
     /* 1706755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1706766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1706769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1706772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706801 */     // MIs[0] policy
     /* 1706801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1706814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706835 */     // GIR_Coverage, 12392,
     /* 1706835 */     GIR_EraseRootFromParent_Done,
     /* 1706836 */   // Label 23251: @1706836
     /* 1706836 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1706922), // Rule ID 12393 //
     /* 1706841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1706852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1706855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1706858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706887 */     // MIs[0] policy
     /* 1706887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706897 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1706900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706921 */     // GIR_Coverage, 12393,
     /* 1706921 */     GIR_EraseRootFromParent_Done,
     /* 1706922 */   // Label 23252: @1706922
     /* 1706922 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1707008), // Rule ID 12396 //
     /* 1706927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1706935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1706938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1706941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1706944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1706957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706973 */     // MIs[0] policy
     /* 1706973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1706986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707007 */     // GIR_Coverage, 12396,
     /* 1707007 */     GIR_EraseRootFromParent_Done,
     /* 1707008 */   // Label 23253: @1707008
     /* 1707008 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1707094), // Rule ID 12397 //
     /* 1707013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1707016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1707024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1707027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1707030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1707033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1707043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707059 */     // MIs[0] policy
     /* 1707059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1707072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707093 */     // GIR_Coverage, 12397,
     /* 1707093 */     GIR_EraseRootFromParent_Done,
     /* 1707094 */   // Label 23254: @1707094
     /* 1707094 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1707180), // Rule ID 12400 //
     /* 1707099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1707116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707145 */     // MIs[0] policy
     /* 1707145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707155 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1707158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707179 */     // GIR_Coverage, 12400,
     /* 1707179 */     GIR_EraseRootFromParent_Done,
     /* 1707180 */   // Label 23255: @1707180
     /* 1707180 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1707266), // Rule ID 12401 //
     /* 1707185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1707202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707231 */     // MIs[0] policy
     /* 1707231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1707244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707265 */     // GIR_Coverage, 12401,
     /* 1707265 */     GIR_EraseRootFromParent_Done,
     /* 1707266 */   // Label 23256: @1707266
     /* 1707266 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1707352), // Rule ID 12404 //
     /* 1707271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1707288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707317 */     // MIs[0] policy
     /* 1707317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1707330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707351 */     // GIR_Coverage, 12404,
     /* 1707351 */     GIR_EraseRootFromParent_Done,
     /* 1707352 */   // Label 23257: @1707352
     /* 1707352 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1707438), // Rule ID 12405 //
     /* 1707357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1707374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707403 */     // MIs[0] policy
     /* 1707403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1707416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707437 */     // GIR_Coverage, 12405,
     /* 1707437 */     GIR_EraseRootFromParent_Done,
     /* 1707438 */   // Label 23258: @1707438
     /* 1707438 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1707524), // Rule ID 12408 //
     /* 1707443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1707460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707489 */     // MIs[0] policy
     /* 1707489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1707502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707523 */     // GIR_Coverage, 12408,
     /* 1707523 */     GIR_EraseRootFromParent_Done,
     /* 1707524 */   // Label 23259: @1707524
     /* 1707524 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1707610), // Rule ID 12409 //
     /* 1707529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1707546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707575 */     // MIs[0] policy
     /* 1707575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707585 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1707588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707609 */     // GIR_Coverage, 12409,
     /* 1707609 */     GIR_EraseRootFromParent_Done,
     /* 1707610 */   // Label 23260: @1707610
     /* 1707610 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1707696), // Rule ID 12412 //
     /* 1707615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1707626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1707629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707661 */     // MIs[0] policy
     /* 1707661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1707674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707695 */     // GIR_Coverage, 12412,
     /* 1707695 */     GIR_EraseRootFromParent_Done,
     /* 1707696 */   // Label 23261: @1707696
     /* 1707696 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1707782), // Rule ID 12413 //
     /* 1707701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1707712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1707715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707747 */     // MIs[0] policy
     /* 1707747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1707760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707781 */     // GIR_Coverage, 12413,
     /* 1707781 */     GIR_EraseRootFromParent_Done,
     /* 1707782 */   // Label 23262: @1707782
     /* 1707782 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1707868), // Rule ID 12416 //
     /* 1707787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1707798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1707801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1707804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707833 */     // MIs[0] policy
     /* 1707833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707843 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1707846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707867 */     // GIR_Coverage, 12416,
     /* 1707867 */     GIR_EraseRootFromParent_Done,
     /* 1707868 */   // Label 23263: @1707868
     /* 1707868 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1707954), // Rule ID 12417 //
     /* 1707873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1707884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1707887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1707890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707919 */     // MIs[0] policy
     /* 1707919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707929 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1707932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707953 */     // GIR_Coverage, 12417,
     /* 1707953 */     GIR_EraseRootFromParent_Done,
     /* 1707954 */   // Label 23264: @1707954
     /* 1707954 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1708040), // Rule ID 12420 //
     /* 1707959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1707967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1707970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1707973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1707976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1707989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708005 */     // MIs[0] policy
     /* 1708005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1708018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708039 */     // GIR_Coverage, 12420,
     /* 1708039 */     GIR_EraseRootFromParent_Done,
     /* 1708040 */   // Label 23265: @1708040
     /* 1708040 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1708126), // Rule ID 12421 //
     /* 1708045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1708056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1708059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1708062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708091 */     // MIs[0] policy
     /* 1708091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708101 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1708104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708125 */     // GIR_Coverage, 12421,
     /* 1708125 */     GIR_EraseRootFromParent_Done,
     /* 1708126 */   // Label 23266: @1708126
     /* 1708126 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1708212), // Rule ID 12424 //
     /* 1708131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1708148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708177 */     // MIs[0] policy
     /* 1708177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708187 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1708190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708211 */     // GIR_Coverage, 12424,
     /* 1708211 */     GIR_EraseRootFromParent_Done,
     /* 1708212 */   // Label 23267: @1708212
     /* 1708212 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1708298), // Rule ID 12425 //
     /* 1708217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1708234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708263 */     // MIs[0] policy
     /* 1708263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708273 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1708276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708297 */     // GIR_Coverage, 12425,
     /* 1708297 */     GIR_EraseRootFromParent_Done,
     /* 1708298 */   // Label 23268: @1708298
     /* 1708298 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1708384), // Rule ID 12428 //
     /* 1708303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1708320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708349 */     // MIs[0] policy
     /* 1708349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1708362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708383 */     // GIR_Coverage, 12428,
     /* 1708383 */     GIR_EraseRootFromParent_Done,
     /* 1708384 */   // Label 23269: @1708384
     /* 1708384 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1708470), // Rule ID 12429 //
     /* 1708389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1708406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708435 */     // MIs[0] policy
     /* 1708435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1708448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708469 */     // GIR_Coverage, 12429,
     /* 1708469 */     GIR_EraseRootFromParent_Done,
     /* 1708470 */   // Label 23270: @1708470
     /* 1708470 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1708556), // Rule ID 12432 //
     /* 1708475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708521 */     // MIs[0] policy
     /* 1708521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1708534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708555 */     // GIR_Coverage, 12432,
     /* 1708555 */     GIR_EraseRootFromParent_Done,
     /* 1708556 */   // Label 23271: @1708556
     /* 1708556 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1708642), // Rule ID 12433 //
     /* 1708561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708607 */     // MIs[0] policy
     /* 1708607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1708620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708641 */     // GIR_Coverage, 12433,
     /* 1708641 */     GIR_EraseRootFromParent_Done,
     /* 1708642 */   // Label 23272: @1708642
     /* 1708642 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1708728), // Rule ID 12436 //
     /* 1708647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708693 */     // MIs[0] policy
     /* 1708693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708703 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1708706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708727 */     // GIR_Coverage, 12436,
     /* 1708727 */     GIR_EraseRootFromParent_Done,
     /* 1708728 */   // Label 23273: @1708728
     /* 1708728 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1708814), // Rule ID 12437 //
     /* 1708733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708779 */     // MIs[0] policy
     /* 1708779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1708792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708813 */     // GIR_Coverage, 12437,
     /* 1708813 */     GIR_EraseRootFromParent_Done,
     /* 1708814 */   // Label 23274: @1708814
     /* 1708814 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1708900), // Rule ID 12440 //
     /* 1708819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1708830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1708833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708865 */     // MIs[0] policy
     /* 1708865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1708878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708899 */     // GIR_Coverage, 12440,
     /* 1708899 */     GIR_EraseRootFromParent_Done,
     /* 1708900 */   // Label 23275: @1708900
     /* 1708900 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1708986), // Rule ID 12441 //
     /* 1708905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1708916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1708919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708951 */     // MIs[0] policy
     /* 1708951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1708964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708985 */     // GIR_Coverage, 12441,
     /* 1708985 */     GIR_EraseRootFromParent_Done,
     /* 1708986 */   // Label 23276: @1708986
     /* 1708986 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1709072), // Rule ID 12444 //
     /* 1708991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1708999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1709002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1709005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709037 */     // MIs[0] policy
     /* 1709037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1709050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709071 */     // GIR_Coverage, 12444,
     /* 1709071 */     GIR_EraseRootFromParent_Done,
     /* 1709072 */   // Label 23277: @1709072
     /* 1709072 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1709158), // Rule ID 12445 //
     /* 1709077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1709088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1709091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709123 */     // MIs[0] policy
     /* 1709123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709133 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1709136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709157 */     // GIR_Coverage, 12445,
     /* 1709157 */     GIR_EraseRootFromParent_Done,
     /* 1709158 */   // Label 23278: @1709158
     /* 1709158 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1709244), // Rule ID 12448 //
     /* 1709163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1709174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1709177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1709180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709209 */     // MIs[0] policy
     /* 1709209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1709222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709243 */     // GIR_Coverage, 12448,
     /* 1709243 */     GIR_EraseRootFromParent_Done,
     /* 1709244 */   // Label 23279: @1709244
     /* 1709244 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1709330), // Rule ID 12449 //
     /* 1709249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1709260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1709263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1709266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709295 */     // MIs[0] policy
     /* 1709295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1709308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709329 */     // GIR_Coverage, 12449,
     /* 1709329 */     GIR_EraseRootFromParent_Done,
     /* 1709330 */   // Label 23280: @1709330
     /* 1709330 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1709416), // Rule ID 12452 //
     /* 1709335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1709346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1709349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709381 */     // MIs[0] policy
     /* 1709381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709391 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1709394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709415 */     // GIR_Coverage, 12452,
     /* 1709415 */     GIR_EraseRootFromParent_Done,
     /* 1709416 */   // Label 23281: @1709416
     /* 1709416 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1709502), // Rule ID 12453 //
     /* 1709421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1709432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1709435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709467 */     // MIs[0] policy
     /* 1709467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1709480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709501 */     // GIR_Coverage, 12453,
     /* 1709501 */     GIR_EraseRootFromParent_Done,
     /* 1709502 */   // Label 23282: @1709502
     /* 1709502 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1709588), // Rule ID 12456 //
     /* 1709507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1709518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1709521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709553 */     // MIs[0] policy
     /* 1709553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709563 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1709566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709587 */     // GIR_Coverage, 12456,
     /* 1709587 */     GIR_EraseRootFromParent_Done,
     /* 1709588 */   // Label 23283: @1709588
     /* 1709588 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1709674), // Rule ID 12457 //
     /* 1709593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1709601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1709604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1709607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709639 */     // MIs[0] policy
     /* 1709639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709649 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1709652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709673 */     // GIR_Coverage, 12457,
     /* 1709673 */     GIR_EraseRootFromParent_Done,
     /* 1709674 */   // Label 23284: @1709674
     /* 1709674 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1709760), // Rule ID 12460 //
     /* 1709679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1709687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709725 */     // MIs[0] policy
     /* 1709725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709735 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1709738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709759 */     // GIR_Coverage, 12460,
     /* 1709759 */     GIR_EraseRootFromParent_Done,
     /* 1709760 */   // Label 23285: @1709760
     /* 1709760 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1709846), // Rule ID 12461 //
     /* 1709765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1709773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709811 */     // MIs[0] policy
     /* 1709811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1709824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709845 */     // GIR_Coverage, 12461,
     /* 1709845 */     GIR_EraseRootFromParent_Done,
     /* 1709846 */   // Label 23286: @1709846
     /* 1709846 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1709932), // Rule ID 12464 //
     /* 1709851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1709859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709897 */     // MIs[0] policy
     /* 1709897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1709910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709931 */     // GIR_Coverage, 12464,
     /* 1709931 */     GIR_EraseRootFromParent_Done,
     /* 1709932 */   // Label 23287: @1709932
     /* 1709932 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1710018), // Rule ID 12465 //
     /* 1709937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1709945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709983 */     // MIs[0] policy
     /* 1709983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1709996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710017 */     // GIR_Coverage, 12465,
     /* 1710017 */     GIR_EraseRootFromParent_Done,
     /* 1710018 */   // Label 23288: @1710018
     /* 1710018 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1710104), // Rule ID 12468 //
     /* 1710023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1710040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1710043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710069 */     // MIs[0] policy
     /* 1710069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710079 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1710082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710103 */     // GIR_Coverage, 12468,
     /* 1710103 */     GIR_EraseRootFromParent_Done,
     /* 1710104 */   // Label 23289: @1710104
     /* 1710104 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1710190), // Rule ID 12469 //
     /* 1710109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1710126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1710129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710155 */     // MIs[0] policy
     /* 1710155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1710168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710189 */     // GIR_Coverage, 12469,
     /* 1710189 */     GIR_EraseRootFromParent_Done,
     /* 1710190 */   // Label 23290: @1710190
     /* 1710190 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1710276), // Rule ID 12472 //
     /* 1710195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1710206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1710209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710241 */     // MIs[0] policy
     /* 1710241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1710254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710275 */     // GIR_Coverage, 12472,
     /* 1710275 */     GIR_EraseRootFromParent_Done,
     /* 1710276 */   // Label 23291: @1710276
     /* 1710276 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1710362), // Rule ID 12473 //
     /* 1710281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1710292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1710295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710327 */     // MIs[0] policy
     /* 1710327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1710340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710361 */     // GIR_Coverage, 12473,
     /* 1710361 */     GIR_EraseRootFromParent_Done,
     /* 1710362 */   // Label 23292: @1710362
     /* 1710362 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1710448), // Rule ID 12476 //
     /* 1710367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1710378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1710381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710413 */     // MIs[0] policy
     /* 1710413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1710426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710447 */     // GIR_Coverage, 12476,
     /* 1710447 */     GIR_EraseRootFromParent_Done,
     /* 1710448 */   // Label 23293: @1710448
     /* 1710448 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1710534), // Rule ID 12477 //
     /* 1710453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1710464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1710467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710499 */     // MIs[0] policy
     /* 1710499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1710512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710533 */     // GIR_Coverage, 12477,
     /* 1710533 */     GIR_EraseRootFromParent_Done,
     /* 1710534 */   // Label 23294: @1710534
     /* 1710534 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1710620), // Rule ID 12480 //
     /* 1710539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1710550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1710553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1710556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1710559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1710562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1710569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710585 */     // MIs[0] policy
     /* 1710585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1710598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710619 */     // GIR_Coverage, 12480,
     /* 1710619 */     GIR_EraseRootFromParent_Done,
     /* 1710620 */   // Label 23295: @1710620
     /* 1710620 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1710706), // Rule ID 12481 //
     /* 1710625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1710636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1710639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1710642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1710645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1710648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1710655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710671 */     // MIs[0] policy
     /* 1710671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710681 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1710684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710705 */     // GIR_Coverage, 12481,
     /* 1710705 */     GIR_EraseRootFromParent_Done,
     /* 1710706 */   // Label 23296: @1710706
     /* 1710706 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1710792), // Rule ID 12484 //
     /* 1710711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710757 */     // MIs[0] policy
     /* 1710757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710767 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1710770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710791 */     // GIR_Coverage, 12484,
     /* 1710791 */     GIR_EraseRootFromParent_Done,
     /* 1710792 */   // Label 23297: @1710792
     /* 1710792 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1710878), // Rule ID 12485 //
     /* 1710797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710843 */     // MIs[0] policy
     /* 1710843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710853 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1710856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710877 */     // GIR_Coverage, 12485,
     /* 1710877 */     GIR_EraseRootFromParent_Done,
     /* 1710878 */   // Label 23298: @1710878
     /* 1710878 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1710964), // Rule ID 12488 //
     /* 1710883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710929 */     // MIs[0] policy
     /* 1710929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1710942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710963 */     // GIR_Coverage, 12488,
     /* 1710963 */     GIR_EraseRootFromParent_Done,
     /* 1710964 */   // Label 23299: @1710964
     /* 1710964 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1711050), // Rule ID 12489 //
     /* 1710969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1710977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711015 */     // MIs[0] policy
     /* 1711015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1711028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711049 */     // GIR_Coverage, 12489,
     /* 1711049 */     GIR_EraseRootFromParent_Done,
     /* 1711050 */   // Label 23300: @1711050
     /* 1711050 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1711136), // Rule ID 12492 //
     /* 1711055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1711075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711101 */     // MIs[0] policy
     /* 1711101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1711114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711135 */     // GIR_Coverage, 12492,
     /* 1711135 */     GIR_EraseRootFromParent_Done,
     /* 1711136 */   // Label 23301: @1711136
     /* 1711136 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1711222), // Rule ID 12493 //
     /* 1711141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1711161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711187 */     // MIs[0] policy
     /* 1711187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1711200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711221 */     // GIR_Coverage, 12493,
     /* 1711221 */     GIR_EraseRootFromParent_Done,
     /* 1711222 */   // Label 23302: @1711222
     /* 1711222 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1711308), // Rule ID 12496 //
     /* 1711227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1711238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1711241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711273 */     // MIs[0] policy
     /* 1711273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1711286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711307 */     // GIR_Coverage, 12496,
     /* 1711307 */     GIR_EraseRootFromParent_Done,
     /* 1711308 */   // Label 23303: @1711308
     /* 1711308 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1711394), // Rule ID 12497 //
     /* 1711313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1711324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1711327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711359 */     // MIs[0] policy
     /* 1711359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1711372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711393 */     // GIR_Coverage, 12497,
     /* 1711393 */     GIR_EraseRootFromParent_Done,
     /* 1711394 */   // Label 23304: @1711394
     /* 1711394 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1711480), // Rule ID 12500 //
     /* 1711399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1711410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1711413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711445 */     // MIs[0] policy
     /* 1711445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711455 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1711458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711479 */     // GIR_Coverage, 12500,
     /* 1711479 */     GIR_EraseRootFromParent_Done,
     /* 1711480 */   // Label 23305: @1711480
     /* 1711480 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1711566), // Rule ID 12501 //
     /* 1711485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1711496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1711499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711531 */     // MIs[0] policy
     /* 1711531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1711544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711565 */     // GIR_Coverage, 12501,
     /* 1711565 */     GIR_EraseRootFromParent_Done,
     /* 1711566 */   // Label 23306: @1711566
     /* 1711566 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1711652), // Rule ID 12504 //
     /* 1711571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1711574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1711591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711617 */     // MIs[0] policy
     /* 1711617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1711630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711651 */     // GIR_Coverage, 12504,
     /* 1711651 */     GIR_EraseRootFromParent_Done,
     /* 1711652 */   // Label 23307: @1711652
     /* 1711652 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1711738), // Rule ID 12505 //
     /* 1711657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1711660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1711677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711703 */     // MIs[0] policy
     /* 1711703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1711716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711737 */     // GIR_Coverage, 12505,
     /* 1711737 */     GIR_EraseRootFromParent_Done,
     /* 1711738 */   // Label 23308: @1711738
     /* 1711738 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1711824), // Rule ID 12508 //
     /* 1711743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1711746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1711754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1711757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1711763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711789 */     // MIs[0] policy
     /* 1711789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1711802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711823 */     // GIR_Coverage, 12508,
     /* 1711823 */     GIR_EraseRootFromParent_Done,
     /* 1711824 */   // Label 23309: @1711824
     /* 1711824 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1711910), // Rule ID 12509 //
     /* 1711829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1711832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1711840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1711843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1711849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711875 */     // MIs[0] policy
     /* 1711875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1711888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711909 */     // GIR_Coverage, 12509,
     /* 1711909 */     GIR_EraseRootFromParent_Done,
     /* 1711910 */   // Label 23310: @1711910
     /* 1711910 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1711996), // Rule ID 12512 //
     /* 1711915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1711918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1711923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1711926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1711929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1711935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711961 */     // MIs[0] policy
     /* 1711961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1711974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711995 */     // GIR_Coverage, 12512,
     /* 1711995 */     GIR_EraseRootFromParent_Done,
     /* 1711996 */   // Label 23311: @1711996
     /* 1711996 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1712082), // Rule ID 12513 //
     /* 1712001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712047 */     // MIs[0] policy
     /* 1712047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712057 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1712060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712081 */     // GIR_Coverage, 12513,
     /* 1712081 */     GIR_EraseRootFromParent_Done,
     /* 1712082 */   // Label 23312: @1712082
     /* 1712082 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1712168), // Rule ID 12516 //
     /* 1712087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1712090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712133 */     // MIs[0] policy
     /* 1712133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1712146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712167 */     // GIR_Coverage, 12516,
     /* 1712167 */     GIR_EraseRootFromParent_Done,
     /* 1712168 */   // Label 23313: @1712168
     /* 1712168 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1712254), // Rule ID 12517 //
     /* 1712173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712219 */     // MIs[0] policy
     /* 1712219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712229 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1712232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712253 */     // GIR_Coverage, 12517,
     /* 1712253 */     GIR_EraseRootFromParent_Done,
     /* 1712254 */   // Label 23314: @1712254
     /* 1712254 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1712340), // Rule ID 12520 //
     /* 1712259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1712270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1712273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712305 */     // MIs[0] policy
     /* 1712305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1712318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712339 */     // GIR_Coverage, 12520,
     /* 1712339 */     GIR_EraseRootFromParent_Done,
     /* 1712340 */   // Label 23315: @1712340
     /* 1712340 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1712426), // Rule ID 12521 //
     /* 1712345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1712356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1712359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712391 */     // MIs[0] policy
     /* 1712391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712401 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1712404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712425 */     // GIR_Coverage, 12521,
     /* 1712425 */     GIR_EraseRootFromParent_Done,
     /* 1712426 */   // Label 23316: @1712426
     /* 1712426 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1712512), // Rule ID 12524 //
     /* 1712431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1712442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1712445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1712448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712477 */     // MIs[0] policy
     /* 1712477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712487 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1712490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712511 */     // GIR_Coverage, 12524,
     /* 1712511 */     GIR_EraseRootFromParent_Done,
     /* 1712512 */   // Label 23317: @1712512
     /* 1712512 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1712598), // Rule ID 12525 //
     /* 1712517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1712528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1712531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1712534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712563 */     // MIs[0] policy
     /* 1712563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1712576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712597 */     // GIR_Coverage, 12525,
     /* 1712597 */     GIR_EraseRootFromParent_Done,
     /* 1712598 */   // Label 23318: @1712598
     /* 1712598 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1712684), // Rule ID 12528 //
     /* 1712603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1712614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1712617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1712620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712649 */     // MIs[0] policy
     /* 1712649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712659 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1712662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712683 */     // GIR_Coverage, 12528,
     /* 1712683 */     GIR_EraseRootFromParent_Done,
     /* 1712684 */   // Label 23319: @1712684
     /* 1712684 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1712770), // Rule ID 12529 //
     /* 1712689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1712700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1712703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1712706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712735 */     // MIs[0] policy
     /* 1712735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1712748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712769 */     // GIR_Coverage, 12529,
     /* 1712769 */     GIR_EraseRootFromParent_Done,
     /* 1712770 */   // Label 23320: @1712770
     /* 1712770 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1712856), // Rule ID 12532 //
     /* 1712775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1712792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712821 */     // MIs[0] policy
     /* 1712821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1712834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712855 */     // GIR_Coverage, 12532,
     /* 1712855 */     GIR_EraseRootFromParent_Done,
     /* 1712856 */   // Label 23321: @1712856
     /* 1712856 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1712942), // Rule ID 12533 //
     /* 1712861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1712878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712907 */     // MIs[0] policy
     /* 1712907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1712920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712941 */     // GIR_Coverage, 12533,
     /* 1712941 */     GIR_EraseRootFromParent_Done,
     /* 1712942 */   // Label 23322: @1712942
     /* 1712942 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1713028), // Rule ID 12536 //
     /* 1712947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1712955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1712964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712993 */     // MIs[0] policy
     /* 1712993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713003 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1713006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713027 */     // GIR_Coverage, 12536,
     /* 1713027 */     GIR_EraseRootFromParent_Done,
     /* 1713028 */   // Label 23323: @1713028
     /* 1713028 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1713114), // Rule ID 12537 //
     /* 1713033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1713044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1713047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1713050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713079 */     // MIs[0] policy
     /* 1713079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713089 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1713092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713113 */     // GIR_Coverage, 12537,
     /* 1713113 */     GIR_EraseRootFromParent_Done,
     /* 1713114 */   // Label 23324: @1713114
     /* 1713114 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1713200), // Rule ID 12540 //
     /* 1713119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1713130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1713133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1713136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1713142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713165 */     // MIs[0] policy
     /* 1713165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713175 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1713178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713199 */     // GIR_Coverage, 12540,
     /* 1713199 */     GIR_EraseRootFromParent_Done,
     /* 1713200 */   // Label 23325: @1713200
     /* 1713200 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1713286), // Rule ID 12541 //
     /* 1713205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1713216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1713219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1713222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1713228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713251 */     // MIs[0] policy
     /* 1713251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1713264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713285 */     // GIR_Coverage, 12541,
     /* 1713285 */     GIR_EraseRootFromParent_Done,
     /* 1713286 */   // Label 23326: @1713286
     /* 1713286 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1713372), // Rule ID 12544 //
     /* 1713291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713337 */     // MIs[0] policy
     /* 1713337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713347 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1713350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713371 */     // GIR_Coverage, 12544,
     /* 1713371 */     GIR_EraseRootFromParent_Done,
     /* 1713372 */   // Label 23327: @1713372
     /* 1713372 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1713458), // Rule ID 12545 //
     /* 1713377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713423 */     // MIs[0] policy
     /* 1713423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1713436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713457 */     // GIR_Coverage, 12545,
     /* 1713457 */     GIR_EraseRootFromParent_Done,
     /* 1713458 */   // Label 23328: @1713458
     /* 1713458 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1713544), // Rule ID 12548 //
     /* 1713463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1713474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1713477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713509 */     // MIs[0] policy
     /* 1713509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1713522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713543 */     // GIR_Coverage, 12548,
     /* 1713543 */     GIR_EraseRootFromParent_Done,
     /* 1713544 */   // Label 23329: @1713544
     /* 1713544 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1713630), // Rule ID 12549 //
     /* 1713549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1713560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1713563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713595 */     // MIs[0] policy
     /* 1713595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1713608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713629 */     // GIR_Coverage, 12549,
     /* 1713629 */     GIR_EraseRootFromParent_Done,
     /* 1713630 */   // Label 23330: @1713630
     /* 1713630 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1713716), // Rule ID 12552 //
     /* 1713635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1713646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1713649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1713652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713681 */     // MIs[0] policy
     /* 1713681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1713694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713715 */     // GIR_Coverage, 12552,
     /* 1713715 */     GIR_EraseRootFromParent_Done,
     /* 1713716 */   // Label 23331: @1713716
     /* 1713716 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1713802), // Rule ID 12553 //
     /* 1713721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1713732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1713735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1713738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713767 */     // MIs[0] policy
     /* 1713767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1713780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713801 */     // GIR_Coverage, 12553,
     /* 1713801 */     GIR_EraseRootFromParent_Done,
     /* 1713802 */   // Label 23332: @1713802
     /* 1713802 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1713888), // Rule ID 12556 //
     /* 1713807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1713818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1713821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1713824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713853 */     // MIs[0] policy
     /* 1713853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713863 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1713866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713887 */     // GIR_Coverage, 12556,
     /* 1713887 */     GIR_EraseRootFromParent_Done,
     /* 1713888 */   // Label 23333: @1713888
     /* 1713888 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1713974), // Rule ID 12557 //
     /* 1713893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1713904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1713907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1713910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713939 */     // MIs[0] policy
     /* 1713939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1713952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713973 */     // GIR_Coverage, 12557,
     /* 1713973 */     GIR_EraseRootFromParent_Done,
     /* 1713974 */   // Label 23334: @1713974
     /* 1713974 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1714060), // Rule ID 12560 //
     /* 1713979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1713987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1713990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1713993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1713996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714025 */     // MIs[0] policy
     /* 1714025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714035 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1714038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714059 */     // GIR_Coverage, 12560,
     /* 1714059 */     GIR_EraseRootFromParent_Done,
     /* 1714060 */   // Label 23335: @1714060
     /* 1714060 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1714146), // Rule ID 12561 //
     /* 1714065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1714076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1714079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1714082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714111 */     // MIs[0] policy
     /* 1714111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1714124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714145 */     // GIR_Coverage, 12561,
     /* 1714145 */     GIR_EraseRootFromParent_Done,
     /* 1714146 */   // Label 23336: @1714146
     /* 1714146 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1714232), // Rule ID 12564 //
     /* 1714151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1714154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714197 */     // MIs[0] policy
     /* 1714197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714207 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1714210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714231 */     // GIR_Coverage, 12564,
     /* 1714231 */     GIR_EraseRootFromParent_Done,
     /* 1714232 */   // Label 23337: @1714232
     /* 1714232 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1714318), // Rule ID 12565 //
     /* 1714237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1714240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714283 */     // MIs[0] policy
     /* 1714283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1714296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714317 */     // GIR_Coverage, 12565,
     /* 1714317 */     GIR_EraseRootFromParent_Done,
     /* 1714318 */   // Label 23338: @1714318
     /* 1714318 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1714404), // Rule ID 12568 //
     /* 1714323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1714326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1714334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1714337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714369 */     // MIs[0] policy
     /* 1714369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1714382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714403 */     // GIR_Coverage, 12568,
     /* 1714403 */     GIR_EraseRootFromParent_Done,
     /* 1714404 */   // Label 23339: @1714404
     /* 1714404 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1714490), // Rule ID 12569 //
     /* 1714409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1714412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1714420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1714423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714455 */     // MIs[0] policy
     /* 1714455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1714468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714489 */     // GIR_Coverage, 12569,
     /* 1714489 */     GIR_EraseRootFromParent_Done,
     /* 1714490 */   // Label 23340: @1714490
     /* 1714490 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1714576), // Rule ID 12572 //
     /* 1714495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1714498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1714506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1714509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1714512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714541 */     // MIs[0] policy
     /* 1714541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1714554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714575 */     // GIR_Coverage, 12572,
     /* 1714575 */     GIR_EraseRootFromParent_Done,
     /* 1714576 */   // Label 23341: @1714576
     /* 1714576 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1714662), // Rule ID 12573 //
     /* 1714581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1714584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1714592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1714595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1714598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714627 */     // MIs[0] policy
     /* 1714627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714637 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1714640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714661 */     // GIR_Coverage, 12573,
     /* 1714661 */     GIR_EraseRootFromParent_Done,
     /* 1714662 */   // Label 23342: @1714662
     /* 1714662 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1714748), // Rule ID 12576 //
     /* 1714667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1714670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1714678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1714681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1714684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714713 */     // MIs[0] policy
     /* 1714713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714723 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1714726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714747 */     // GIR_Coverage, 12576,
     /* 1714747 */     GIR_EraseRootFromParent_Done,
     /* 1714748 */   // Label 23343: @1714748
     /* 1714748 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1714834), // Rule ID 12577 //
     /* 1714753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1714756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1714761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1714764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1714767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1714770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714799 */     // MIs[0] policy
     /* 1714799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1714812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714833 */     // GIR_Coverage, 12577,
     /* 1714833 */     GIR_EraseRootFromParent_Done,
     /* 1714834 */   // Label 23344: @1714834
     /* 1714834 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1714920), // Rule ID 12580 //
     /* 1714839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1714847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1714850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1714853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1714856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1714859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714885 */     // MIs[0] policy
     /* 1714885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714895 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1714898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1714902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714919 */     // GIR_Coverage, 12580,
     /* 1714919 */     GIR_EraseRootFromParent_Done,
     /* 1714920 */   // Label 23345: @1714920
     /* 1714920 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1715006), // Rule ID 12581 //
     /* 1714925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1714933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1714936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1714939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1714942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1714945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714971 */     // MIs[0] policy
     /* 1714971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714981 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1714984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1714988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715005 */     // GIR_Coverage, 12581,
     /* 1715005 */     GIR_EraseRootFromParent_Done,
     /* 1715006 */   // Label 23346: @1715006
     /* 1715006 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1715092), // Rule ID 12584 //
     /* 1715011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1715022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1715025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1715028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1715031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715057 */     // MIs[0] policy
     /* 1715057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715067 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715091 */     // GIR_Coverage, 12584,
     /* 1715091 */     GIR_EraseRootFromParent_Done,
     /* 1715092 */   // Label 23347: @1715092
     /* 1715092 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1715178), // Rule ID 12585 //
     /* 1715097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1715108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1715111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1715114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1715117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715143 */     // MIs[0] policy
     /* 1715143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715153 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715177 */     // GIR_Coverage, 12585,
     /* 1715177 */     GIR_EraseRootFromParent_Done,
     /* 1715178 */   // Label 23348: @1715178
     /* 1715178 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1715264), // Rule ID 12588 //
     /* 1715183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1715194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1715197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1715200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1715203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715229 */     // MIs[0] policy
     /* 1715229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1715242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715263 */     // GIR_Coverage, 12588,
     /* 1715263 */     GIR_EraseRootFromParent_Done,
     /* 1715264 */   // Label 23349: @1715264
     /* 1715264 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1715350), // Rule ID 12589 //
     /* 1715269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1715280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1715283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1715286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1715289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715315 */     // MIs[0] policy
     /* 1715315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715325 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1715328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715349 */     // GIR_Coverage, 12589,
     /* 1715349 */     GIR_EraseRootFromParent_Done,
     /* 1715350 */   // Label 23350: @1715350
     /* 1715350 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1715436), // Rule ID 12592 //
     /* 1715355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1715366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1715369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1715372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1715375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715401 */     // MIs[0] policy
     /* 1715401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715435 */     // GIR_Coverage, 12592,
     /* 1715435 */     GIR_EraseRootFromParent_Done,
     /* 1715436 */   // Label 23351: @1715436
     /* 1715436 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1715522), // Rule ID 12593 //
     /* 1715441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1715452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1715455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1715458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1715461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715487 */     // MIs[0] policy
     /* 1715487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715497 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715521 */     // GIR_Coverage, 12593,
     /* 1715521 */     GIR_EraseRootFromParent_Done,
     /* 1715522 */   // Label 23352: @1715522
     /* 1715522 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1715608), // Rule ID 12596 //
     /* 1715527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1715538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1715541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1715544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1715547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715573 */     // MIs[0] policy
     /* 1715573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715607 */     // GIR_Coverage, 12596,
     /* 1715607 */     GIR_EraseRootFromParent_Done,
     /* 1715608 */   // Label 23353: @1715608
     /* 1715608 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1715694), // Rule ID 12597 //
     /* 1715613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1715624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1715627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1715630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1715633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715659 */     // MIs[0] policy
     /* 1715659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1715672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715693 */     // GIR_Coverage, 12597,
     /* 1715693 */     GIR_EraseRootFromParent_Done,
     /* 1715694 */   // Label 23354: @1715694
     /* 1715694 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1715780), // Rule ID 12600 //
     /* 1715699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1715710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1715713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1715716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1715719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715745 */     // MIs[0] policy
     /* 1715745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715755 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1715758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715779 */     // GIR_Coverage, 12600,
     /* 1715779 */     GIR_EraseRootFromParent_Done,
     /* 1715780 */   // Label 23355: @1715780
     /* 1715780 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1715866), // Rule ID 12601 //
     /* 1715785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1715796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1715799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1715802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1715805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715831 */     // MIs[0] policy
     /* 1715831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715841 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1715844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715865 */     // GIR_Coverage, 12601,
     /* 1715865 */     GIR_EraseRootFromParent_Done,
     /* 1715866 */   // Label 23356: @1715866
     /* 1715866 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1715952), // Rule ID 12604 //
     /* 1715871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1715882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1715885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1715891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715917 */     // MIs[0] policy
     /* 1715917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1715930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1715934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715951 */     // GIR_Coverage, 12604,
     /* 1715951 */     GIR_EraseRootFromParent_Done,
     /* 1715952 */   // Label 23357: @1715952
     /* 1715952 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1716038), // Rule ID 12605 //
     /* 1715957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1715965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1715968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1715971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1715977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716003 */     // MIs[0] policy
     /* 1716003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716013 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1716016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716037 */     // GIR_Coverage, 12605,
     /* 1716037 */     GIR_EraseRootFromParent_Done,
     /* 1716038 */   // Label 23358: @1716038
     /* 1716038 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1716124), // Rule ID 12608 //
     /* 1716043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1716054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1716057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1716060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1716063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716089 */     // MIs[0] policy
     /* 1716089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1716102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716123 */     // GIR_Coverage, 12608,
     /* 1716123 */     GIR_EraseRootFromParent_Done,
     /* 1716124 */   // Label 23359: @1716124
     /* 1716124 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1716210), // Rule ID 12609 //
     /* 1716129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1716140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1716143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1716146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1716149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716175 */     // MIs[0] policy
     /* 1716175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716185 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1716188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716209 */     // GIR_Coverage, 12609,
     /* 1716209 */     GIR_EraseRootFromParent_Done,
     /* 1716210 */   // Label 23360: @1716210
     /* 1716210 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1716296), // Rule ID 12612 //
     /* 1716215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1716226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1716229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1716232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1716235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716261 */     // MIs[0] policy
     /* 1716261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1716274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716295 */     // GIR_Coverage, 12612,
     /* 1716295 */     GIR_EraseRootFromParent_Done,
     /* 1716296 */   // Label 23361: @1716296
     /* 1716296 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1716382), // Rule ID 12613 //
     /* 1716301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1716312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1716315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1716318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1716321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716347 */     // MIs[0] policy
     /* 1716347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1716360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716381 */     // GIR_Coverage, 12613,
     /* 1716381 */     GIR_EraseRootFromParent_Done,
     /* 1716382 */   // Label 23362: @1716382
     /* 1716382 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1716468), // Rule ID 12616 //
     /* 1716387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1716398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1716401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1716404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1716407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716433 */     // MIs[0] policy
     /* 1716433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1716446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716467 */     // GIR_Coverage, 12616,
     /* 1716467 */     GIR_EraseRootFromParent_Done,
     /* 1716468 */   // Label 23363: @1716468
     /* 1716468 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1716554), // Rule ID 12617 //
     /* 1716473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1716484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1716487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1716490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1716493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716519 */     // MIs[0] policy
     /* 1716519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716529 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1716532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716553 */     // GIR_Coverage, 12617,
     /* 1716553 */     GIR_EraseRootFromParent_Done,
     /* 1716554 */   // Label 23364: @1716554
     /* 1716554 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1716640), // Rule ID 12620 //
     /* 1716559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1716570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1716573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1716576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1716579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716605 */     // MIs[0] policy
     /* 1716605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716615 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1716618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716639 */     // GIR_Coverage, 12620,
     /* 1716639 */     GIR_EraseRootFromParent_Done,
     /* 1716640 */   // Label 23365: @1716640
     /* 1716640 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1716726), // Rule ID 12621 //
     /* 1716645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1716656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1716659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1716662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1716665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716691 */     // MIs[0] policy
     /* 1716691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716701 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1716704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716725 */     // GIR_Coverage, 12621,
     /* 1716725 */     GIR_EraseRootFromParent_Done,
     /* 1716726 */   // Label 23366: @1716726
     /* 1716726 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1716812), // Rule ID 12624 //
     /* 1716731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1716742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1716745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1716748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1716751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1716754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716777 */     // MIs[0] policy
     /* 1716777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716787 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1716790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716811 */     // GIR_Coverage, 12624,
     /* 1716811 */     GIR_EraseRootFromParent_Done,
     /* 1716812 */   // Label 23367: @1716812
     /* 1716812 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1716898), // Rule ID 12625 //
     /* 1716817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1716828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1716831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1716834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1716837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1716840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716863 */     // MIs[0] policy
     /* 1716863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716873 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1716876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716897 */     // GIR_Coverage, 12625,
     /* 1716897 */     GIR_EraseRootFromParent_Done,
     /* 1716898 */   // Label 23368: @1716898
     /* 1716898 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1716984), // Rule ID 12628 //
     /* 1716903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1716914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1716917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1716920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1716923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716949 */     // MIs[0] policy
     /* 1716949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1716962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1716966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716983 */     // GIR_Coverage, 12628,
     /* 1716983 */     GIR_EraseRootFromParent_Done,
     /* 1716984 */   // Label 23369: @1716984
     /* 1716984 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1717070), // Rule ID 12629 //
     /* 1716989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1716997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1717000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1717003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1717006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1717009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717035 */     // MIs[0] policy
     /* 1717035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1717048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717069 */     // GIR_Coverage, 12629,
     /* 1717069 */     GIR_EraseRootFromParent_Done,
     /* 1717070 */   // Label 23370: @1717070
     /* 1717070 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1717156), // Rule ID 12632 //
     /* 1717075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1717086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1717089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1717092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1717095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717121 */     // MIs[0] policy
     /* 1717121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717131 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1717134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717155 */     // GIR_Coverage, 12632,
     /* 1717155 */     GIR_EraseRootFromParent_Done,
     /* 1717156 */   // Label 23371: @1717156
     /* 1717156 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1717242), // Rule ID 12633 //
     /* 1717161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1717172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1717175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1717178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1717181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717207 */     // MIs[0] policy
     /* 1717207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717217 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1717220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717241 */     // GIR_Coverage, 12633,
     /* 1717241 */     GIR_EraseRootFromParent_Done,
     /* 1717242 */   // Label 23372: @1717242
     /* 1717242 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1717328), // Rule ID 12636 //
     /* 1717247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1717258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1717261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1717264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1717267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1717270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717293 */     // MIs[0] policy
     /* 1717293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717303 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1717306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717327 */     // GIR_Coverage, 12636,
     /* 1717327 */     GIR_EraseRootFromParent_Done,
     /* 1717328 */   // Label 23373: @1717328
     /* 1717328 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1717414), // Rule ID 12637 //
     /* 1717333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1717344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1717347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1717350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1717353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1717356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717379 */     // MIs[0] policy
     /* 1717379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1717392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717413 */     // GIR_Coverage, 12637,
     /* 1717413 */     GIR_EraseRootFromParent_Done,
     /* 1717414 */   // Label 23374: @1717414
     /* 1717414 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1717500), // Rule ID 12640 //
     /* 1717419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1717430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1717433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1717436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1717439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717465 */     // MIs[0] policy
     /* 1717465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1717478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717499 */     // GIR_Coverage, 12640,
     /* 1717499 */     GIR_EraseRootFromParent_Done,
     /* 1717500 */   // Label 23375: @1717500
     /* 1717500 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1717586), // Rule ID 12641 //
     /* 1717505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1717516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1717519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1717522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1717525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717551 */     // MIs[0] policy
     /* 1717551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1717564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717585 */     // GIR_Coverage, 12641,
     /* 1717585 */     GIR_EraseRootFromParent_Done,
     /* 1717586 */   // Label 23376: @1717586
     /* 1717586 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1717672), // Rule ID 12644 //
     /* 1717591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1717602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1717605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1717608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1717611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717637 */     // MIs[0] policy
     /* 1717637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717647 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1717650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717671 */     // GIR_Coverage, 12644,
     /* 1717671 */     GIR_EraseRootFromParent_Done,
     /* 1717672 */   // Label 23377: @1717672
     /* 1717672 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1717758), // Rule ID 12645 //
     /* 1717677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1717688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1717691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1717694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1717697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717723 */     // MIs[0] policy
     /* 1717723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717733 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1717736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717757 */     // GIR_Coverage, 12645,
     /* 1717757 */     GIR_EraseRootFromParent_Done,
     /* 1717758 */   // Label 23378: @1717758
     /* 1717758 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1717844), // Rule ID 12648 //
     /* 1717763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1717774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1717777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1717780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1717783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717809 */     // MIs[0] policy
     /* 1717809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1717822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717843 */     // GIR_Coverage, 12648,
     /* 1717843 */     GIR_EraseRootFromParent_Done,
     /* 1717844 */   // Label 23379: @1717844
     /* 1717844 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1717930), // Rule ID 12649 //
     /* 1717849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1717860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1717863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1717866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1717869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717895 */     // MIs[0] policy
     /* 1717895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1717908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717929 */     // GIR_Coverage, 12649,
     /* 1717929 */     GIR_EraseRootFromParent_Done,
     /* 1717930 */   // Label 23380: @1717930
     /* 1717930 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1718016), // Rule ID 12652 //
     /* 1717935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1717943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1717946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1717949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1717952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1717955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717981 */     // MIs[0] policy
     /* 1717981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1717994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1717998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718015 */     // GIR_Coverage, 12652,
     /* 1718015 */     GIR_EraseRootFromParent_Done,
     /* 1718016 */   // Label 23381: @1718016
     /* 1718016 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1718102), // Rule ID 12653 //
     /* 1718021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1718032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1718035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1718038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1718041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718067 */     // MIs[0] policy
     /* 1718067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1718080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718101 */     // GIR_Coverage, 12653,
     /* 1718101 */     GIR_EraseRootFromParent_Done,
     /* 1718102 */   // Label 23382: @1718102
     /* 1718102 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1718188), // Rule ID 12656 //
     /* 1718107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1718118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1718121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1718124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1718127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718153 */     // MIs[0] policy
     /* 1718153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718163 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1718166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718187 */     // GIR_Coverage, 12656,
     /* 1718187 */     GIR_EraseRootFromParent_Done,
     /* 1718188 */   // Label 23383: @1718188
     /* 1718188 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1718274), // Rule ID 12657 //
     /* 1718193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1718204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1718207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1718210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1718213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718239 */     // MIs[0] policy
     /* 1718239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718249 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1718252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718273 */     // GIR_Coverage, 12657,
     /* 1718273 */     GIR_EraseRootFromParent_Done,
     /* 1718274 */   // Label 23384: @1718274
     /* 1718274 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1718360), // Rule ID 12660 //
     /* 1718279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1718290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1718293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1718296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1718299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718325 */     // MIs[0] policy
     /* 1718325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718335 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1718338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718359 */     // GIR_Coverage, 12660,
     /* 1718359 */     GIR_EraseRootFromParent_Done,
     /* 1718360 */   // Label 23385: @1718360
     /* 1718360 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1718446), // Rule ID 12661 //
     /* 1718365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1718376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1718379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1718382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1718385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718411 */     // MIs[0] policy
     /* 1718411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1718424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718445 */     // GIR_Coverage, 12661,
     /* 1718445 */     GIR_EraseRootFromParent_Done,
     /* 1718446 */   // Label 23386: @1718446
     /* 1718446 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1718532), // Rule ID 12664 //
     /* 1718451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1718462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1718465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1718468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1718471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718497 */     // MIs[0] policy
     /* 1718497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718507 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1718510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718531 */     // GIR_Coverage, 12664,
     /* 1718531 */     GIR_EraseRootFromParent_Done,
     /* 1718532 */   // Label 23387: @1718532
     /* 1718532 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1718618), // Rule ID 12665 //
     /* 1718537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1718548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1718551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1718554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1718557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718583 */     // MIs[0] policy
     /* 1718583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1718596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718617 */     // GIR_Coverage, 12665,
     /* 1718617 */     GIR_EraseRootFromParent_Done,
     /* 1718618 */   // Label 23388: @1718618
     /* 1718618 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1718704), // Rule ID 12668 //
     /* 1718623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1718634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1718637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1718640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1718643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718669 */     // MIs[0] policy
     /* 1718669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718679 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1718682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718703 */     // GIR_Coverage, 12668,
     /* 1718703 */     GIR_EraseRootFromParent_Done,
     /* 1718704 */   // Label 23389: @1718704
     /* 1718704 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1718790), // Rule ID 12669 //
     /* 1718709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1718720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1718723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1718726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1718729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718755 */     // MIs[0] policy
     /* 1718755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718765 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1718768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718789 */     // GIR_Coverage, 12669,
     /* 1718789 */     GIR_EraseRootFromParent_Done,
     /* 1718790 */   // Label 23390: @1718790
     /* 1718790 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1718876), // Rule ID 12672 //
     /* 1718795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1718806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1718809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1718812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1718815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718841 */     // MIs[0] policy
     /* 1718841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718851 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1718854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718875 */     // GIR_Coverage, 12672,
     /* 1718875 */     GIR_EraseRootFromParent_Done,
     /* 1718876 */   // Label 23391: @1718876
     /* 1718876 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1718962), // Rule ID 12673 //
     /* 1718881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1718892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1718895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1718898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1718901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718927 */     // MIs[0] policy
     /* 1718927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718937 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1718940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1718944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718961 */     // GIR_Coverage, 12673,
     /* 1718961 */     GIR_EraseRootFromParent_Done,
     /* 1718962 */   // Label 23392: @1718962
     /* 1718962 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1719048), // Rule ID 12676 //
     /* 1718967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1718975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1718978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1718981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1718984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1718987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719013 */     // MIs[0] policy
     /* 1719013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719023 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1719026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719047 */     // GIR_Coverage, 12676,
     /* 1719047 */     GIR_EraseRootFromParent_Done,
     /* 1719048 */   // Label 23393: @1719048
     /* 1719048 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1719134), // Rule ID 12677 //
     /* 1719053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1719064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1719067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1719073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719099 */     // MIs[0] policy
     /* 1719099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1719112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719133 */     // GIR_Coverage, 12677,
     /* 1719133 */     GIR_EraseRootFromParent_Done,
     /* 1719134 */   // Label 23394: @1719134
     /* 1719134 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1719220), // Rule ID 12680 //
     /* 1719139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1719150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1719153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1719156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1719159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719185 */     // MIs[0] policy
     /* 1719185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719195 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1719198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719219 */     // GIR_Coverage, 12680,
     /* 1719219 */     GIR_EraseRootFromParent_Done,
     /* 1719220 */   // Label 23395: @1719220
     /* 1719220 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1719306), // Rule ID 12681 //
     /* 1719225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1719236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1719239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1719245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719271 */     // MIs[0] policy
     /* 1719271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719281 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1719284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719305 */     // GIR_Coverage, 12681,
     /* 1719305 */     GIR_EraseRootFromParent_Done,
     /* 1719306 */   // Label 23396: @1719306
     /* 1719306 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1719392), // Rule ID 12684 //
     /* 1719311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1719322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1719325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1719328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1719331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719357 */     // MIs[0] policy
     /* 1719357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1719370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719391 */     // GIR_Coverage, 12684,
     /* 1719391 */     GIR_EraseRootFromParent_Done,
     /* 1719392 */   // Label 23397: @1719392
     /* 1719392 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1719478), // Rule ID 12685 //
     /* 1719397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1719408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1719411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1719417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719443 */     // MIs[0] policy
     /* 1719443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1719456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719477 */     // GIR_Coverage, 12685,
     /* 1719477 */     GIR_EraseRootFromParent_Done,
     /* 1719478 */   // Label 23398: @1719478
     /* 1719478 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1719564), // Rule ID 12688 //
     /* 1719483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1719494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1719497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1719500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1719503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719529 */     // MIs[0] policy
     /* 1719529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719563 */     // GIR_Coverage, 12688,
     /* 1719563 */     GIR_EraseRootFromParent_Done,
     /* 1719564 */   // Label 23399: @1719564
     /* 1719564 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1719650), // Rule ID 12689 //
     /* 1719569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1719580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1719583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1719589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719615 */     // MIs[0] policy
     /* 1719615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719649 */     // GIR_Coverage, 12689,
     /* 1719649 */     GIR_EraseRootFromParent_Done,
     /* 1719650 */   // Label 23400: @1719650
     /* 1719650 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1719736), // Rule ID 12692 //
     /* 1719655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1719666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1719669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1719672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1719675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719701 */     // MIs[0] policy
     /* 1719701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719711 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719735 */     // GIR_Coverage, 12692,
     /* 1719735 */     GIR_EraseRootFromParent_Done,
     /* 1719736 */   // Label 23401: @1719736
     /* 1719736 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1719822), // Rule ID 12693 //
     /* 1719741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1719752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1719755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1719761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719787 */     // MIs[0] policy
     /* 1719787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719797 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719821 */     // GIR_Coverage, 12693,
     /* 1719821 */     GIR_EraseRootFromParent_Done,
     /* 1719822 */   // Label 23402: @1719822
     /* 1719822 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1719908), // Rule ID 12696 //
     /* 1719827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1719838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1719841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1719844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1719847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719873 */     // MIs[0] policy
     /* 1719873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719907 */     // GIR_Coverage, 12696,
     /* 1719907 */     GIR_EraseRootFromParent_Done,
     /* 1719908 */   // Label 23403: @1719908
     /* 1719908 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1719994), // Rule ID 12697 //
     /* 1719913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1719921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1719924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1719927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1719930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1719933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719959 */     // MIs[0] policy
     /* 1719959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719969 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1719972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1719976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719993 */     // GIR_Coverage, 12697,
     /* 1719993 */     GIR_EraseRootFromParent_Done,
     /* 1719994 */   // Label 23404: @1719994
     /* 1719994 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1720080), // Rule ID 12700 //
     /* 1719999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1720010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1720013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1720019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720045 */     // MIs[0] policy
     /* 1720045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720055 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1720058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720079 */     // GIR_Coverage, 12700,
     /* 1720079 */     GIR_EraseRootFromParent_Done,
     /* 1720080 */   // Label 23405: @1720080
     /* 1720080 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1720166), // Rule ID 12701 //
     /* 1720085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1720096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1720099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1720105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720131 */     // MIs[0] policy
     /* 1720131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720141 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1720144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720165 */     // GIR_Coverage, 12701,
     /* 1720165 */     GIR_EraseRootFromParent_Done,
     /* 1720166 */   // Label 23406: @1720166
     /* 1720166 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1720252), // Rule ID 12704 //
     /* 1720171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1720182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1720185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1720191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720217 */     // MIs[0] policy
     /* 1720217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1720230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720251 */     // GIR_Coverage, 12704,
     /* 1720251 */     GIR_EraseRootFromParent_Done,
     /* 1720252 */   // Label 23407: @1720252
     /* 1720252 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1720338), // Rule ID 12705 //
     /* 1720257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1720268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1720271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1720277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720303 */     // MIs[0] policy
     /* 1720303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720313 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1720316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720337 */     // GIR_Coverage, 12705,
     /* 1720337 */     GIR_EraseRootFromParent_Done,
     /* 1720338 */   // Label 23408: @1720338
     /* 1720338 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1720424), // Rule ID 12708 //
     /* 1720343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1720354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1720357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1720363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720389 */     // MIs[0] policy
     /* 1720389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720399 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1720402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720423 */     // GIR_Coverage, 12708,
     /* 1720423 */     GIR_EraseRootFromParent_Done,
     /* 1720424 */   // Label 23409: @1720424
     /* 1720424 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1720510), // Rule ID 12709 //
     /* 1720429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1720440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1720443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1720449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720475 */     // MIs[0] policy
     /* 1720475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720485 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1720488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720509 */     // GIR_Coverage, 12709,
     /* 1720509 */     GIR_EraseRootFromParent_Done,
     /* 1720510 */   // Label 23410: @1720510
     /* 1720510 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1720596), // Rule ID 12712 //
     /* 1720515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1720526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1720529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1720535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1720538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720561 */     // MIs[0] policy
     /* 1720561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720571 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1720574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720595 */     // GIR_Coverage, 12712,
     /* 1720595 */     GIR_EraseRootFromParent_Done,
     /* 1720596 */   // Label 23411: @1720596
     /* 1720596 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1720682), // Rule ID 12713 //
     /* 1720601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1720612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1720615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1720621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1720624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720647 */     // MIs[0] policy
     /* 1720647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720657 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1720660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720681 */     // GIR_Coverage, 12713,
     /* 1720681 */     GIR_EraseRootFromParent_Done,
     /* 1720682 */   // Label 23412: @1720682
     /* 1720682 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1720768), // Rule ID 12716 //
     /* 1720687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1720698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1720701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1720707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720733 */     // MIs[0] policy
     /* 1720733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1720746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720767 */     // GIR_Coverage, 12716,
     /* 1720767 */     GIR_EraseRootFromParent_Done,
     /* 1720768 */   // Label 23413: @1720768
     /* 1720768 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1720854), // Rule ID 12717 //
     /* 1720773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1720784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1720787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1720793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720819 */     // MIs[0] policy
     /* 1720819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1720832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720853 */     // GIR_Coverage, 12717,
     /* 1720853 */     GIR_EraseRootFromParent_Done,
     /* 1720854 */   // Label 23414: @1720854
     /* 1720854 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1720940), // Rule ID 12720 //
     /* 1720859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1720870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1720873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1720876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1720879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720905 */     // MIs[0] policy
     /* 1720905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1720918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1720922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720939 */     // GIR_Coverage, 12720,
     /* 1720939 */     GIR_EraseRootFromParent_Done,
     /* 1720940 */   // Label 23415: @1720940
     /* 1720940 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1721026), // Rule ID 12721 //
     /* 1720945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1720953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1720956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1720959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1720962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1720965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720991 */     // MIs[0] policy
     /* 1720991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1721004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721025 */     // GIR_Coverage, 12721,
     /* 1721025 */     GIR_EraseRootFromParent_Done,
     /* 1721026 */   // Label 23416: @1721026
     /* 1721026 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1721112), // Rule ID 12724 //
     /* 1721031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1721042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1721045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1721051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1721054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721077 */     // MIs[0] policy
     /* 1721077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721087 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1721090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721111 */     // GIR_Coverage, 12724,
     /* 1721111 */     GIR_EraseRootFromParent_Done,
     /* 1721112 */   // Label 23417: @1721112
     /* 1721112 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1721198), // Rule ID 12725 //
     /* 1721117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1721128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1721131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1721137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1721140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721163 */     // MIs[0] policy
     /* 1721163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721173 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1721176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721197 */     // GIR_Coverage, 12725,
     /* 1721197 */     GIR_EraseRootFromParent_Done,
     /* 1721198 */   // Label 23418: @1721198
     /* 1721198 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1721284), // Rule ID 12728 //
     /* 1721203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1721214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1721217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1721223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721249 */     // MIs[0] policy
     /* 1721249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1721262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721283 */     // GIR_Coverage, 12728,
     /* 1721283 */     GIR_EraseRootFromParent_Done,
     /* 1721284 */   // Label 23419: @1721284
     /* 1721284 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1721370), // Rule ID 12729 //
     /* 1721289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1721300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1721303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1721309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721335 */     // MIs[0] policy
     /* 1721335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1721348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721369 */     // GIR_Coverage, 12729,
     /* 1721369 */     GIR_EraseRootFromParent_Done,
     /* 1721370 */   // Label 23420: @1721370
     /* 1721370 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1721456), // Rule ID 12732 //
     /* 1721375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1721386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1721389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1721395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721421 */     // MIs[0] policy
     /* 1721421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721431 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1721434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721455 */     // GIR_Coverage, 12732,
     /* 1721455 */     GIR_EraseRootFromParent_Done,
     /* 1721456 */   // Label 23421: @1721456
     /* 1721456 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1721542), // Rule ID 12733 //
     /* 1721461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1721472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1721475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1721481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721507 */     // MIs[0] policy
     /* 1721507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721517 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1721520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721541 */     // GIR_Coverage, 12733,
     /* 1721541 */     GIR_EraseRootFromParent_Done,
     /* 1721542 */   // Label 23422: @1721542
     /* 1721542 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1721628), // Rule ID 12736 //
     /* 1721547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1721558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1721561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1721567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1721570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721593 */     // MIs[0] policy
     /* 1721593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721603 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1721606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721627 */     // GIR_Coverage, 12736,
     /* 1721627 */     GIR_EraseRootFromParent_Done,
     /* 1721628 */   // Label 23423: @1721628
     /* 1721628 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1721714), // Rule ID 12737 //
     /* 1721633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1721644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1721647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1721653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1721656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721679 */     // MIs[0] policy
     /* 1721679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721689 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1721692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721713 */     // GIR_Coverage, 12737,
     /* 1721713 */     GIR_EraseRootFromParent_Done,
     /* 1721714 */   // Label 23424: @1721714
     /* 1721714 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1721800), // Rule ID 12740 //
     /* 1721719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1721730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1721733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1721739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721765 */     // MIs[0] policy
     /* 1721765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1721778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721799 */     // GIR_Coverage, 12740,
     /* 1721799 */     GIR_EraseRootFromParent_Done,
     /* 1721800 */   // Label 23425: @1721800
     /* 1721800 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1721886), // Rule ID 12741 //
     /* 1721805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1721816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1721819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1721825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721851 */     // MIs[0] policy
     /* 1721851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1721864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721885 */     // GIR_Coverage, 12741,
     /* 1721885 */     GIR_EraseRootFromParent_Done,
     /* 1721886 */   // Label 23426: @1721886
     /* 1721886 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1721972), // Rule ID 12744 //
     /* 1721891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1721908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1721911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721937 */     // MIs[0] policy
     /* 1721937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721947 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1721950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1721954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721971 */     // GIR_Coverage, 12744,
     /* 1721971 */     GIR_EraseRootFromParent_Done,
     /* 1721972 */   // Label 23427: @1721972
     /* 1721972 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1722058), // Rule ID 12745 //
     /* 1721977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1721985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1721994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1721997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722023 */     // MIs[0] policy
     /* 1722023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722033 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1722036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722057 */     // GIR_Coverage, 12745,
     /* 1722057 */     GIR_EraseRootFromParent_Done,
     /* 1722058 */   // Label 23428: @1722058
     /* 1722058 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1722144), // Rule ID 12748 //
     /* 1722063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1722066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1722071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1722074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1722077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1722080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1722083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722109 */     // MIs[0] policy
     /* 1722109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722119 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1722122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722143 */     // GIR_Coverage, 12748,
     /* 1722143 */     GIR_EraseRootFromParent_Done,
     /* 1722144 */   // Label 23429: @1722144
     /* 1722144 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1722230), // Rule ID 12749 //
     /* 1722149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1722157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1722160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1722163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1722166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1722169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722195 */     // MIs[0] policy
     /* 1722195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722205 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1722208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722229 */     // GIR_Coverage, 12749,
     /* 1722229 */     GIR_EraseRootFromParent_Done,
     /* 1722230 */   // Label 23430: @1722230
     /* 1722230 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1722316), // Rule ID 12752 //
     /* 1722235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1722246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1722249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1722252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1722255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722281 */     // MIs[0] policy
     /* 1722281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722291 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1722294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722315 */     // GIR_Coverage, 12752,
     /* 1722315 */     GIR_EraseRootFromParent_Done,
     /* 1722316 */   // Label 23431: @1722316
     /* 1722316 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1722402), // Rule ID 12753 //
     /* 1722321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1722332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1722335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1722338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1722341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722367 */     // MIs[0] policy
     /* 1722367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722377 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1722380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722401 */     // GIR_Coverage, 12753,
     /* 1722401 */     GIR_EraseRootFromParent_Done,
     /* 1722402 */   // Label 23432: @1722402
     /* 1722402 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1722488), // Rule ID 12756 //
     /* 1722407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1722418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1722421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1722424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1722427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722453 */     // MIs[0] policy
     /* 1722453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722463 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1722466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722487 */     // GIR_Coverage, 12756,
     /* 1722487 */     GIR_EraseRootFromParent_Done,
     /* 1722488 */   // Label 23433: @1722488
     /* 1722488 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1722574), // Rule ID 12757 //
     /* 1722493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1722504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1722507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1722510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1722513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722539 */     // MIs[0] policy
     /* 1722539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722549 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1722552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722573 */     // GIR_Coverage, 12757,
     /* 1722573 */     GIR_EraseRootFromParent_Done,
     /* 1722574 */   // Label 23434: @1722574
     /* 1722574 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1722660), // Rule ID 12760 //
     /* 1722579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1722590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1722593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1722596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1722599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722625 */     // MIs[0] policy
     /* 1722625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1722638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722659 */     // GIR_Coverage, 12760,
     /* 1722659 */     GIR_EraseRootFromParent_Done,
     /* 1722660 */   // Label 23435: @1722660
     /* 1722660 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1722746), // Rule ID 12761 //
     /* 1722665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1722676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1722679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1722682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1722685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722711 */     // MIs[0] policy
     /* 1722711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722721 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1722724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722745 */     // GIR_Coverage, 12761,
     /* 1722745 */     GIR_EraseRootFromParent_Done,
     /* 1722746 */   // Label 23436: @1722746
     /* 1722746 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1722832), // Rule ID 12764 //
     /* 1722751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1722762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1722765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1722768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1722771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722797 */     // MIs[0] policy
     /* 1722797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722807 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1722810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722831 */     // GIR_Coverage, 12764,
     /* 1722831 */     GIR_EraseRootFromParent_Done,
     /* 1722832 */   // Label 23437: @1722832
     /* 1722832 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1722918), // Rule ID 12765 //
     /* 1722837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1722848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1722851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1722854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1722857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722883 */     // MIs[0] policy
     /* 1722883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722893 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1722896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722917 */     // GIR_Coverage, 12765,
     /* 1722917 */     GIR_EraseRootFromParent_Done,
     /* 1722918 */   // Label 23438: @1722918
     /* 1722918 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1723004), // Rule ID 12768 //
     /* 1722923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1722931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1722934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1722937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1722940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1722943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722969 */     // MIs[0] policy
     /* 1722969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722979 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1722982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1722986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723003 */     // GIR_Coverage, 12768,
     /* 1723003 */     GIR_EraseRootFromParent_Done,
     /* 1723004 */   // Label 23439: @1723004
     /* 1723004 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1723090), // Rule ID 12769 //
     /* 1723009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1723020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1723023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1723026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1723029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723055 */     // MIs[0] policy
     /* 1723055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723065 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1723068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723089 */     // GIR_Coverage, 12769,
     /* 1723089 */     GIR_EraseRootFromParent_Done,
     /* 1723090 */   // Label 23440: @1723090
     /* 1723090 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1723176), // Rule ID 12772 //
     /* 1723095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1723106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1723109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1723112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1723115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723141 */     // MIs[0] policy
     /* 1723141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1723154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723175 */     // GIR_Coverage, 12772,
     /* 1723175 */     GIR_EraseRootFromParent_Done,
     /* 1723176 */   // Label 23441: @1723176
     /* 1723176 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1723262), // Rule ID 12773 //
     /* 1723181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1723192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1723195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1723198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1723201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723227 */     // MIs[0] policy
     /* 1723227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723237 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1723240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723261 */     // GIR_Coverage, 12773,
     /* 1723261 */     GIR_EraseRootFromParent_Done,
     /* 1723262 */   // Label 23442: @1723262
     /* 1723262 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1723348), // Rule ID 12776 //
     /* 1723267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1723278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1723281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1723284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1723287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723313 */     // MIs[0] policy
     /* 1723313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723323 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723347 */     // GIR_Coverage, 12776,
     /* 1723347 */     GIR_EraseRootFromParent_Done,
     /* 1723348 */   // Label 23443: @1723348
     /* 1723348 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1723434), // Rule ID 12777 //
     /* 1723353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1723364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1723367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1723370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1723373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723399 */     // MIs[0] policy
     /* 1723399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723409 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723433 */     // GIR_Coverage, 12777,
     /* 1723433 */     GIR_EraseRootFromParent_Done,
     /* 1723434 */   // Label 23444: @1723434
     /* 1723434 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1723520), // Rule ID 12780 //
     /* 1723439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1723450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1723453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1723456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1723459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723485 */     // MIs[0] policy
     /* 1723485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723519 */     // GIR_Coverage, 12780,
     /* 1723519 */     GIR_EraseRootFromParent_Done,
     /* 1723520 */   // Label 23445: @1723520
     /* 1723520 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1723606), // Rule ID 12781 //
     /* 1723525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1723536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1723539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1723542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1723545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723571 */     // MIs[0] policy
     /* 1723571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723605 */     // GIR_Coverage, 12781,
     /* 1723605 */     GIR_EraseRootFromParent_Done,
     /* 1723606 */   // Label 23446: @1723606
     /* 1723606 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1723692), // Rule ID 12784 //
     /* 1723611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1723622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1723625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1723628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1723631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723657 */     // MIs[0] policy
     /* 1723657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723691 */     // GIR_Coverage, 12784,
     /* 1723691 */     GIR_EraseRootFromParent_Done,
     /* 1723692 */   // Label 23447: @1723692
     /* 1723692 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1723778), // Rule ID 12785 //
     /* 1723697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1723708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1723711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1723714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1723717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723743 */     // MIs[0] policy
     /* 1723743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723777 */     // GIR_Coverage, 12785,
     /* 1723777 */     GIR_EraseRootFromParent_Done,
     /* 1723778 */   // Label 23448: @1723778
     /* 1723778 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1723864), // Rule ID 12788 //
     /* 1723783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1723794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1723797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1723800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1723803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723829 */     // MIs[0] policy
     /* 1723829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723839 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723863 */     // GIR_Coverage, 12788,
     /* 1723863 */     GIR_EraseRootFromParent_Done,
     /* 1723864 */   // Label 23449: @1723864
     /* 1723864 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1723950), // Rule ID 12789 //
     /* 1723869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1723880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1723883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1723886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1723889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723915 */     // MIs[0] policy
     /* 1723915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723925 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1723928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1723932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723949 */     // GIR_Coverage, 12789,
     /* 1723949 */     GIR_EraseRootFromParent_Done,
     /* 1723950 */   // Label 23450: @1723950
     /* 1723950 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1724036), // Rule ID 12792 //
     /* 1723955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1723963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1723966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1723969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1723972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1723975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724001 */     // MIs[0] policy
     /* 1724001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1724014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724035 */     // GIR_Coverage, 12792,
     /* 1724035 */     GIR_EraseRootFromParent_Done,
     /* 1724036 */   // Label 23451: @1724036
     /* 1724036 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1724122), // Rule ID 12793 //
     /* 1724041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1724052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1724055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1724058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1724061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724087 */     // MIs[0] policy
     /* 1724087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724097 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1724100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724121 */     // GIR_Coverage, 12793,
     /* 1724121 */     GIR_EraseRootFromParent_Done,
     /* 1724122 */   // Label 23452: @1724122
     /* 1724122 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1724208), // Rule ID 12796 //
     /* 1724127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1724138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1724141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1724144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1724147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724173 */     // MIs[0] policy
     /* 1724173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724183 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1724186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724207 */     // GIR_Coverage, 12796,
     /* 1724207 */     GIR_EraseRootFromParent_Done,
     /* 1724208 */   // Label 23453: @1724208
     /* 1724208 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1724294), // Rule ID 12797 //
     /* 1724213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1724224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1724227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1724230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1724233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724259 */     // MIs[0] policy
     /* 1724259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1724272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724293 */     // GIR_Coverage, 12797,
     /* 1724293 */     GIR_EraseRootFromParent_Done,
     /* 1724294 */   // Label 23454: @1724294
     /* 1724294 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1724380), // Rule ID 12800 //
     /* 1724299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1724310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1724313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1724316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1724319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1724322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724345 */     // MIs[0] policy
     /* 1724345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724355 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1724358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724379 */     // GIR_Coverage, 12800,
     /* 1724379 */     GIR_EraseRootFromParent_Done,
     /* 1724380 */   // Label 23455: @1724380
     /* 1724380 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1724466), // Rule ID 12801 //
     /* 1724385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1724396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1724399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1724402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1724405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1724408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724431 */     // MIs[0] policy
     /* 1724431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724441 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1724444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724465 */     // GIR_Coverage, 12801,
     /* 1724465 */     GIR_EraseRootFromParent_Done,
     /* 1724466 */   // Label 23456: @1724466
     /* 1724466 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1724552), // Rule ID 12804 //
     /* 1724471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1724482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1724485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1724488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1724491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724517 */     // MIs[0] policy
     /* 1724517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724527 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1724530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724551 */     // GIR_Coverage, 12804,
     /* 1724551 */     GIR_EraseRootFromParent_Done,
     /* 1724552 */   // Label 23457: @1724552
     /* 1724552 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1724638), // Rule ID 12805 //
     /* 1724557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1724568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1724571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1724574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1724577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724603 */     // MIs[0] policy
     /* 1724603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1724616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724637 */     // GIR_Coverage, 12805,
     /* 1724637 */     GIR_EraseRootFromParent_Done,
     /* 1724638 */   // Label 23458: @1724638
     /* 1724638 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1724724), // Rule ID 12808 //
     /* 1724643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1724654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1724657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1724660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1724663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724689 */     // MIs[0] policy
     /* 1724689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1724702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724723 */     // GIR_Coverage, 12808,
     /* 1724723 */     GIR_EraseRootFromParent_Done,
     /* 1724724 */   // Label 23459: @1724724
     /* 1724724 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1724810), // Rule ID 12809 //
     /* 1724729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1724740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1724743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1724746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1724749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724775 */     // MIs[0] policy
     /* 1724775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724785 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1724788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724809 */     // GIR_Coverage, 12809,
     /* 1724809 */     GIR_EraseRootFromParent_Done,
     /* 1724810 */   // Label 23460: @1724810
     /* 1724810 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1724896), // Rule ID 12812 //
     /* 1724815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1724826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1724829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1724832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1724835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724861 */     // MIs[0] policy
     /* 1724861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724871 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1724874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724895 */     // GIR_Coverage, 12812,
     /* 1724895 */     GIR_EraseRootFromParent_Done,
     /* 1724896 */   // Label 23461: @1724896
     /* 1724896 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1724982), // Rule ID 12813 //
     /* 1724901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1724912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1724915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1724918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1724921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724947 */     // MIs[0] policy
     /* 1724947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724957 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1724960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1724964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724981 */     // GIR_Coverage, 12813,
     /* 1724981 */     GIR_EraseRootFromParent_Done,
     /* 1724982 */   // Label 23462: @1724982
     /* 1724982 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1725068), // Rule ID 12816 //
     /* 1724987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1724995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1724998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1725001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1725004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1725007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725033 */     // MIs[0] policy
     /* 1725033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1725046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725067 */     // GIR_Coverage, 12816,
     /* 1725067 */     GIR_EraseRootFromParent_Done,
     /* 1725068 */   // Label 23463: @1725068
     /* 1725068 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1725154), // Rule ID 12817 //
     /* 1725073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1725084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1725087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1725090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1725093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725119 */     // MIs[0] policy
     /* 1725119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1725132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725153 */     // GIR_Coverage, 12817,
     /* 1725153 */     GIR_EraseRootFromParent_Done,
     /* 1725154 */   // Label 23464: @1725154
     /* 1725154 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1725240), // Rule ID 12820 //
     /* 1725159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1725170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1725173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1725176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1725179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725205 */     // MIs[0] policy
     /* 1725205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725215 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1725218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725239 */     // GIR_Coverage, 12820,
     /* 1725239 */     GIR_EraseRootFromParent_Done,
     /* 1725240 */   // Label 23465: @1725240
     /* 1725240 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1725326), // Rule ID 12821 //
     /* 1725245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1725256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1725259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1725262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1725265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725291 */     // MIs[0] policy
     /* 1725291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1725304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725325 */     // GIR_Coverage, 12821,
     /* 1725325 */     GIR_EraseRootFromParent_Done,
     /* 1725326 */   // Label 23466: @1725326
     /* 1725326 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1725412), // Rule ID 12824 //
     /* 1725331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1725342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1725345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1725348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1725351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725377 */     // MIs[0] policy
     /* 1725377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725387 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1725390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725411 */     // GIR_Coverage, 12824,
     /* 1725411 */     GIR_EraseRootFromParent_Done,
     /* 1725412 */   // Label 23467: @1725412
     /* 1725412 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1725498), // Rule ID 12825 //
     /* 1725417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1725428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1725431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1725434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1725437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725463 */     // MIs[0] policy
     /* 1725463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725473 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1725476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725497 */     // GIR_Coverage, 12825,
     /* 1725497 */     GIR_EraseRootFromParent_Done,
     /* 1725498 */   // Label 23468: @1725498
     /* 1725498 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1725584), // Rule ID 12828 //
     /* 1725503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1725514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1725517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1725520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1725523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725549 */     // MIs[0] policy
     /* 1725549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725559 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1725562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725583 */     // GIR_Coverage, 12828,
     /* 1725583 */     GIR_EraseRootFromParent_Done,
     /* 1725584 */   // Label 23469: @1725584
     /* 1725584 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1725670), // Rule ID 12829 //
     /* 1725589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1725600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1725603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1725606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1725609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725635 */     // MIs[0] policy
     /* 1725635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1725648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725669 */     // GIR_Coverage, 12829,
     /* 1725669 */     GIR_EraseRootFromParent_Done,
     /* 1725670 */   // Label 23470: @1725670
     /* 1725670 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1725756), // Rule ID 12832 //
     /* 1725675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1725686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1725689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1725692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1725695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725721 */     // MIs[0] policy
     /* 1725721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725731 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1725734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725755 */     // GIR_Coverage, 12832,
     /* 1725755 */     GIR_EraseRootFromParent_Done,
     /* 1725756 */   // Label 23471: @1725756
     /* 1725756 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1725842), // Rule ID 12833 //
     /* 1725761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1725772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1725775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1725778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1725781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725807 */     // MIs[0] policy
     /* 1725807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725817 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1725820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725841 */     // GIR_Coverage, 12833,
     /* 1725841 */     GIR_EraseRootFromParent_Done,
     /* 1725842 */   // Label 23472: @1725842
     /* 1725842 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1725928), // Rule ID 12836 //
     /* 1725847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1725858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1725861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1725864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1725867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725893 */     // MIs[0] policy
     /* 1725893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725903 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1725906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725927 */     // GIR_Coverage, 12836,
     /* 1725927 */     GIR_EraseRootFromParent_Done,
     /* 1725928 */   // Label 23473: @1725928
     /* 1725928 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1726014), // Rule ID 12837 //
     /* 1725933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1725941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1725944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1725947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1725950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1725953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725979 */     // MIs[0] policy
     /* 1725979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1725992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1725996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726013 */     // GIR_Coverage, 12837,
     /* 1726013 */     GIR_EraseRootFromParent_Done,
     /* 1726014 */   // Label 23474: @1726014
     /* 1726014 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1726100), // Rule ID 12840 //
     /* 1726019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1726030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1726033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1726039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726065 */     // MIs[0] policy
     /* 1726065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726075 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1726078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726099 */     // GIR_Coverage, 12840,
     /* 1726099 */     GIR_EraseRootFromParent_Done,
     /* 1726100 */   // Label 23475: @1726100
     /* 1726100 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1726186), // Rule ID 12841 //
     /* 1726105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1726116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1726119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1726125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726151 */     // MIs[0] policy
     /* 1726151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726161 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1726164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726185 */     // GIR_Coverage, 12841,
     /* 1726185 */     GIR_EraseRootFromParent_Done,
     /* 1726186 */   // Label 23476: @1726186
     /* 1726186 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1726272), // Rule ID 12844 //
     /* 1726191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1726202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1726205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1726211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726237 */     // MIs[0] policy
     /* 1726237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726247 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1726250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726271 */     // GIR_Coverage, 12844,
     /* 1726271 */     GIR_EraseRootFromParent_Done,
     /* 1726272 */   // Label 23477: @1726272
     /* 1726272 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1726358), // Rule ID 12845 //
     /* 1726277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1726288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1726291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1726297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726323 */     // MIs[0] policy
     /* 1726323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726333 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1726336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726357 */     // GIR_Coverage, 12845,
     /* 1726357 */     GIR_EraseRootFromParent_Done,
     /* 1726358 */   // Label 23478: @1726358
     /* 1726358 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1726444), // Rule ID 12848 //
     /* 1726363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1726374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1726377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1726383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726409 */     // MIs[0] policy
     /* 1726409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1726422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726443 */     // GIR_Coverage, 12848,
     /* 1726443 */     GIR_EraseRootFromParent_Done,
     /* 1726444 */   // Label 23479: @1726444
     /* 1726444 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1726530), // Rule ID 12849 //
     /* 1726449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1726460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1726463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1726469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726495 */     // MIs[0] policy
     /* 1726495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726505 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1726508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726529 */     // GIR_Coverage, 12849,
     /* 1726529 */     GIR_EraseRootFromParent_Done,
     /* 1726530 */   // Label 23480: @1726530
     /* 1726530 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1726616), // Rule ID 12852 //
     /* 1726535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1726546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1726549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1726555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726581 */     // MIs[0] policy
     /* 1726581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726591 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1726594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726615 */     // GIR_Coverage, 12852,
     /* 1726615 */     GIR_EraseRootFromParent_Done,
     /* 1726616 */   // Label 23481: @1726616
     /* 1726616 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1726702), // Rule ID 12853 //
     /* 1726621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1726632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1726635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1726641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726667 */     // MIs[0] policy
     /* 1726667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1726680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726701 */     // GIR_Coverage, 12853,
     /* 1726701 */     GIR_EraseRootFromParent_Done,
     /* 1726702 */   // Label 23482: @1726702
     /* 1726702 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1726788), // Rule ID 12856 //
     /* 1726707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1726718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1726721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1726727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726753 */     // MIs[0] policy
     /* 1726753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726763 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1726766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726787 */     // GIR_Coverage, 12856,
     /* 1726787 */     GIR_EraseRootFromParent_Done,
     /* 1726788 */   // Label 23483: @1726788
     /* 1726788 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1726874), // Rule ID 12857 //
     /* 1726793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1726804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1726807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1726813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726839 */     // MIs[0] policy
     /* 1726839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726849 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1726852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726873 */     // GIR_Coverage, 12857,
     /* 1726873 */     GIR_EraseRootFromParent_Done,
     /* 1726874 */   // Label 23484: @1726874
     /* 1726874 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1726960), // Rule ID 12860 //
     /* 1726879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1726896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1726899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726925 */     // MIs[0] policy
     /* 1726925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726935 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1726938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1726942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726959 */     // GIR_Coverage, 12860,
     /* 1726959 */     GIR_EraseRootFromParent_Done,
     /* 1726960 */   // Label 23485: @1726960
     /* 1726960 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1727046), // Rule ID 12861 //
     /* 1726965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1726973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1726982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1726985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727011 */     // MIs[0] policy
     /* 1727011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1727024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727045 */     // GIR_Coverage, 12861,
     /* 1727045 */     GIR_EraseRootFromParent_Done,
     /* 1727046 */   // Label 23486: @1727046
     /* 1727046 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1727132), // Rule ID 12864 //
     /* 1727051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1727062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1727065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1727071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727097 */     // MIs[0] policy
     /* 1727097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727131 */     // GIR_Coverage, 12864,
     /* 1727131 */     GIR_EraseRootFromParent_Done,
     /* 1727132 */   // Label 23487: @1727132
     /* 1727132 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1727218), // Rule ID 12865 //
     /* 1727137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1727148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1727151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1727154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1727157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727183 */     // MIs[0] policy
     /* 1727183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727217 */     // GIR_Coverage, 12865,
     /* 1727217 */     GIR_EraseRootFromParent_Done,
     /* 1727218 */   // Label 23488: @1727218
     /* 1727218 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1727304), // Rule ID 12868 //
     /* 1727223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1727234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1727237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1727243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727269 */     // MIs[0] policy
     /* 1727269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727279 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727303 */     // GIR_Coverage, 12868,
     /* 1727303 */     GIR_EraseRootFromParent_Done,
     /* 1727304 */   // Label 23489: @1727304
     /* 1727304 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1727390), // Rule ID 12869 //
     /* 1727309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1727320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1727323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1727326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1727329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727355 */     // MIs[0] policy
     /* 1727355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727389 */     // GIR_Coverage, 12869,
     /* 1727389 */     GIR_EraseRootFromParent_Done,
     /* 1727390 */   // Label 23490: @1727390
     /* 1727390 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1727476), // Rule ID 12872 //
     /* 1727395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1727406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1727409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1727415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727441 */     // MIs[0] policy
     /* 1727441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727451 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727475 */     // GIR_Coverage, 12872,
     /* 1727475 */     GIR_EraseRootFromParent_Done,
     /* 1727476 */   // Label 23491: @1727476
     /* 1727476 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1727562), // Rule ID 12873 //
     /* 1727481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1727492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1727495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1727498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1727501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727527 */     // MIs[0] policy
     /* 1727527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727537 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727561 */     // GIR_Coverage, 12873,
     /* 1727561 */     GIR_EraseRootFromParent_Done,
     /* 1727562 */   // Label 23492: @1727562
     /* 1727562 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1727648), // Rule ID 12876 //
     /* 1727567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1727578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1727581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1727587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727613 */     // MIs[0] policy
     /* 1727613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727623 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727647 */     // GIR_Coverage, 12876,
     /* 1727647 */     GIR_EraseRootFromParent_Done,
     /* 1727648 */   // Label 23493: @1727648
     /* 1727648 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1727734), // Rule ID 12877 //
     /* 1727653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1727664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1727667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1727670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1727673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727699 */     // MIs[0] policy
     /* 1727699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1727712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727733 */     // GIR_Coverage, 12877,
     /* 1727733 */     GIR_EraseRootFromParent_Done,
     /* 1727734 */   // Label 23494: @1727734
     /* 1727734 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1727820), // Rule ID 12880 //
     /* 1727739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1727750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1727753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1727759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727785 */     // MIs[0] policy
     /* 1727785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1727798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727819 */     // GIR_Coverage, 12880,
     /* 1727819 */     GIR_EraseRootFromParent_Done,
     /* 1727820 */   // Label 23495: @1727820
     /* 1727820 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1727906), // Rule ID 12881 //
     /* 1727825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1727836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1727839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1727842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1727845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727871 */     // MIs[0] policy
     /* 1727871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1727884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727905 */     // GIR_Coverage, 12881,
     /* 1727905 */     GIR_EraseRootFromParent_Done,
     /* 1727906 */   // Label 23496: @1727906
     /* 1727906 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1727992), // Rule ID 12884 //
     /* 1727911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1727919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1727922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1727925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1727928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1727931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727957 */     // MIs[0] policy
     /* 1727957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727967 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1727970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1727974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727991 */     // GIR_Coverage, 12884,
     /* 1727991 */     GIR_EraseRootFromParent_Done,
     /* 1727992 */   // Label 23497: @1727992
     /* 1727992 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1728078), // Rule ID 12885 //
     /* 1727997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1728008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1728011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1728017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1728020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728043 */     // MIs[0] policy
     /* 1728043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728053 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1728056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728077 */     // GIR_Coverage, 12885,
     /* 1728077 */     GIR_EraseRootFromParent_Done,
     /* 1728078 */   // Label 23498: @1728078
     /* 1728078 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1728164), // Rule ID 12888 //
     /* 1728083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1728094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1728097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1728103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1728106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728129 */     // MIs[0] policy
     /* 1728129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728139 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1728142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728163 */     // GIR_Coverage, 12888,
     /* 1728163 */     GIR_EraseRootFromParent_Done,
     /* 1728164 */   // Label 23499: @1728164
     /* 1728164 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1728250), // Rule ID 12889 //
     /* 1728169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1728180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1728183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1728189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1728192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728215 */     // MIs[0] policy
     /* 1728215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728225 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1728228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728249 */     // GIR_Coverage, 12889,
     /* 1728249 */     GIR_EraseRootFromParent_Done,
     /* 1728250 */   // Label 23500: @1728250
     /* 1728250 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1728336), // Rule ID 12892 //
     /* 1728255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1728266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1728269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1728275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728301 */     // MIs[0] policy
     /* 1728301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1728314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728335 */     // GIR_Coverage, 12892,
     /* 1728335 */     GIR_EraseRootFromParent_Done,
     /* 1728336 */   // Label 23501: @1728336
     /* 1728336 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1728422), // Rule ID 12893 //
     /* 1728341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1728352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1728355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1728361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728387 */     // MIs[0] policy
     /* 1728387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1728400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728421 */     // GIR_Coverage, 12893,
     /* 1728421 */     GIR_EraseRootFromParent_Done,
     /* 1728422 */   // Label 23502: @1728422
     /* 1728422 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1728508), // Rule ID 12896 //
     /* 1728427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1728438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1728441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1728447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728473 */     // MIs[0] policy
     /* 1728473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1728486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728507 */     // GIR_Coverage, 12896,
     /* 1728507 */     GIR_EraseRootFromParent_Done,
     /* 1728508 */   // Label 23503: @1728508
     /* 1728508 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1728594), // Rule ID 12897 //
     /* 1728513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1728524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1728527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1728533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728559 */     // MIs[0] policy
     /* 1728559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728569 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1728572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728593 */     // GIR_Coverage, 12897,
     /* 1728593 */     GIR_EraseRootFromParent_Done,
     /* 1728594 */   // Label 23504: @1728594
     /* 1728594 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1728680), // Rule ID 12900 //
     /* 1728599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1728610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1728613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1728619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1728622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728645 */     // MIs[0] policy
     /* 1728645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728655 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1728658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728679 */     // GIR_Coverage, 12900,
     /* 1728679 */     GIR_EraseRootFromParent_Done,
     /* 1728680 */   // Label 23505: @1728680
     /* 1728680 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1728766), // Rule ID 12901 //
     /* 1728685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1728696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1728699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1728705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1728708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728731 */     // MIs[0] policy
     /* 1728731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728741 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1728744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728765 */     // GIR_Coverage, 12901,
     /* 1728765 */     GIR_EraseRootFromParent_Done,
     /* 1728766 */   // Label 23506: @1728766
     /* 1728766 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1728852), // Rule ID 12904 //
     /* 1728771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1728782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1728785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1728791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728817 */     // MIs[0] policy
     /* 1728817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1728830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728851 */     // GIR_Coverage, 12904,
     /* 1728851 */     GIR_EraseRootFromParent_Done,
     /* 1728852 */   // Label 23507: @1728852
     /* 1728852 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1728938), // Rule ID 12905 //
     /* 1728857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1728868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1728871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1728874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1728877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728903 */     // MIs[0] policy
     /* 1728903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1728916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1728920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728937 */     // GIR_Coverage, 12905,
     /* 1728937 */     GIR_EraseRootFromParent_Done,
     /* 1728938 */   // Label 23508: @1728938
     /* 1728938 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1729024), // Rule ID 12908 //
     /* 1728943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1728951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1728954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1728957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1728960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1728963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728989 */     // MIs[0] policy
     /* 1728989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1729002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729023 */     // GIR_Coverage, 12908,
     /* 1729023 */     GIR_EraseRootFromParent_Done,
     /* 1729024 */   // Label 23509: @1729024
     /* 1729024 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1729110), // Rule ID 12909 //
     /* 1729029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1729040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1729043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1729046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1729049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729075 */     // MIs[0] policy
     /* 1729075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729085 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1729088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729109 */     // GIR_Coverage, 12909,
     /* 1729109 */     GIR_EraseRootFromParent_Done,
     /* 1729110 */   // Label 23510: @1729110
     /* 1729110 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1729196), // Rule ID 12912 //
     /* 1729115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1729126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1729129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1729132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1729135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729161 */     // MIs[0] policy
     /* 1729161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1729174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729195 */     // GIR_Coverage, 12912,
     /* 1729195 */     GIR_EraseRootFromParent_Done,
     /* 1729196 */   // Label 23511: @1729196
     /* 1729196 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1729282), // Rule ID 12913 //
     /* 1729201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1729212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1729215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1729218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1729221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729247 */     // MIs[0] policy
     /* 1729247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729257 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1729260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729281 */     // GIR_Coverage, 12913,
     /* 1729281 */     GIR_EraseRootFromParent_Done,
     /* 1729282 */   // Label 23512: @1729282
     /* 1729282 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1729368), // Rule ID 12916 //
     /* 1729287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1729298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1729301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1729304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1729307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729333 */     // MIs[0] policy
     /* 1729333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1729346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729367 */     // GIR_Coverage, 12916,
     /* 1729367 */     GIR_EraseRootFromParent_Done,
     /* 1729368 */   // Label 23513: @1729368
     /* 1729368 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1729454), // Rule ID 12917 //
     /* 1729373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1729384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1729387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1729390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1729393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729419 */     // MIs[0] policy
     /* 1729419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1729432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729453 */     // GIR_Coverage, 12917,
     /* 1729453 */     GIR_EraseRootFromParent_Done,
     /* 1729454 */   // Label 23514: @1729454
     /* 1729454 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1729540), // Rule ID 12920 //
     /* 1729459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1729470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1729473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1729476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1729479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729505 */     // MIs[0] policy
     /* 1729505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1729518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729539 */     // GIR_Coverage, 12920,
     /* 1729539 */     GIR_EraseRootFromParent_Done,
     /* 1729540 */   // Label 23515: @1729540
     /* 1729540 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1729626), // Rule ID 12921 //
     /* 1729545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1729556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1729559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1729562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1729565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729591 */     // MIs[0] policy
     /* 1729591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1729604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729625 */     // GIR_Coverage, 12921,
     /* 1729625 */     GIR_EraseRootFromParent_Done,
     /* 1729626 */   // Label 23516: @1729626
     /* 1729626 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1729712), // Rule ID 12924 //
     /* 1729631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1729642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1729645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1729648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1729651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729677 */     // MIs[0] policy
     /* 1729677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729687 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1729690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729711 */     // GIR_Coverage, 12924,
     /* 1729711 */     GIR_EraseRootFromParent_Done,
     /* 1729712 */   // Label 23517: @1729712
     /* 1729712 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1729798), // Rule ID 12925 //
     /* 1729717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1729725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1729728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1729731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1729734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1729737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729763 */     // MIs[0] policy
     /* 1729763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1729776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729797 */     // GIR_Coverage, 12925,
     /* 1729797 */     GIR_EraseRootFromParent_Done,
     /* 1729798 */   // Label 23518: @1729798
     /* 1729798 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1729884), // Rule ID 12928 //
     /* 1729803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1729811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1729814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1729817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1729820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1729823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729849 */     // MIs[0] policy
     /* 1729849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1729862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729883 */     // GIR_Coverage, 12928,
     /* 1729883 */     GIR_EraseRootFromParent_Done,
     /* 1729884 */   // Label 23519: @1729884
     /* 1729884 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1729970), // Rule ID 12929 //
     /* 1729889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1729897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1729900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1729903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1729906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1729909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729935 */     // MIs[0] policy
     /* 1729935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729945 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1729948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1729952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729969 */     // GIR_Coverage, 12929,
     /* 1729969 */     GIR_EraseRootFromParent_Done,
     /* 1729970 */   // Label 23520: @1729970
     /* 1729970 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1730056), // Rule ID 12932 //
     /* 1729975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1729983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1729986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1729989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1729992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1729995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730021 */     // MIs[0] policy
     /* 1730021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730031 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1730034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730055 */     // GIR_Coverage, 12932,
     /* 1730055 */     GIR_EraseRootFromParent_Done,
     /* 1730056 */   // Label 23521: @1730056
     /* 1730056 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1730142), // Rule ID 12933 //
     /* 1730061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1730072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1730075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1730078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1730081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730107 */     // MIs[0] policy
     /* 1730107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1730120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730141 */     // GIR_Coverage, 12933,
     /* 1730141 */     GIR_EraseRootFromParent_Done,
     /* 1730142 */   // Label 23522: @1730142
     /* 1730142 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1730228), // Rule ID 12936 //
     /* 1730147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1730158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1730161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1730164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1730167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730193 */     // MIs[0] policy
     /* 1730193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730203 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730227 */     // GIR_Coverage, 12936,
     /* 1730227 */     GIR_EraseRootFromParent_Done,
     /* 1730228 */   // Label 23523: @1730228
     /* 1730228 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1730314), // Rule ID 12937 //
     /* 1730233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1730244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1730247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1730250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1730253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730279 */     // MIs[0] policy
     /* 1730279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730289 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730313 */     // GIR_Coverage, 12937,
     /* 1730313 */     GIR_EraseRootFromParent_Done,
     /* 1730314 */   // Label 23524: @1730314
     /* 1730314 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1730400), // Rule ID 12940 //
     /* 1730319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1730330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1730333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1730336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1730339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730365 */     // MIs[0] policy
     /* 1730365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730375 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1730378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730399 */     // GIR_Coverage, 12940,
     /* 1730399 */     GIR_EraseRootFromParent_Done,
     /* 1730400 */   // Label 23525: @1730400
     /* 1730400 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1730486), // Rule ID 12941 //
     /* 1730405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1730416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1730419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1730422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1730425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730451 */     // MIs[0] policy
     /* 1730451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730461 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1730464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730485 */     // GIR_Coverage, 12941,
     /* 1730485 */     GIR_EraseRootFromParent_Done,
     /* 1730486 */   // Label 23526: @1730486
     /* 1730486 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1730572), // Rule ID 12944 //
     /* 1730491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1730502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1730505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1730508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1730511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730537 */     // MIs[0] policy
     /* 1730537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730547 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730571 */     // GIR_Coverage, 12944,
     /* 1730571 */     GIR_EraseRootFromParent_Done,
     /* 1730572 */   // Label 23527: @1730572
     /* 1730572 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1730658), // Rule ID 12945 //
     /* 1730577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1730588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1730591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1730594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1730597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730623 */     // MIs[0] policy
     /* 1730623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730633 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730657 */     // GIR_Coverage, 12945,
     /* 1730657 */     GIR_EraseRootFromParent_Done,
     /* 1730658 */   // Label 23528: @1730658
     /* 1730658 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1730744), // Rule ID 12948 //
     /* 1730663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1730674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1730677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1730680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1730683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730709 */     // MIs[0] policy
     /* 1730709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730719 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730743 */     // GIR_Coverage, 12948,
     /* 1730743 */     GIR_EraseRootFromParent_Done,
     /* 1730744 */   // Label 23529: @1730744
     /* 1730744 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1730830), // Rule ID 12949 //
     /* 1730749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1730760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1730763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1730766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1730769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730795 */     // MIs[0] policy
     /* 1730795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730805 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1730808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730829 */     // GIR_Coverage, 12949,
     /* 1730829 */     GIR_EraseRootFromParent_Done,
     /* 1730830 */   // Label 23530: @1730830
     /* 1730830 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1730916), // Rule ID 12952 //
     /* 1730835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1730846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1730849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1730852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1730855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730881 */     // MIs[0] policy
     /* 1730881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730891 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1730894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730915 */     // GIR_Coverage, 12952,
     /* 1730915 */     GIR_EraseRootFromParent_Done,
     /* 1730916 */   // Label 23531: @1730916
     /* 1730916 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1731002), // Rule ID 12953 //
     /* 1730921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1730929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1730932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1730935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1730938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1730941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730967 */     // MIs[0] policy
     /* 1730967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1730980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1730984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731001 */     // GIR_Coverage, 12953,
     /* 1731001 */     GIR_EraseRootFromParent_Done,
     /* 1731002 */   // Label 23532: @1731002
     /* 1731002 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1731088), // Rule ID 12956 //
     /* 1731007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1731018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1731021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1731024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1731027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731053 */     // MIs[0] policy
     /* 1731053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731063 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731087 */     // GIR_Coverage, 12956,
     /* 1731087 */     GIR_EraseRootFromParent_Done,
     /* 1731088 */   // Label 23533: @1731088
     /* 1731088 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1731174), // Rule ID 12957 //
     /* 1731093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1731104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1731107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1731110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1731113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731139 */     // MIs[0] policy
     /* 1731139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731173 */     // GIR_Coverage, 12957,
     /* 1731173 */     GIR_EraseRootFromParent_Done,
     /* 1731174 */   // Label 23534: @1731174
     /* 1731174 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1731260), // Rule ID 12960 //
     /* 1731179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1731190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1731193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1731196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1731199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731225 */     // MIs[0] policy
     /* 1731225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731235 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731259 */     // GIR_Coverage, 12960,
     /* 1731259 */     GIR_EraseRootFromParent_Done,
     /* 1731260 */   // Label 23535: @1731260
     /* 1731260 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1731346), // Rule ID 12961 //
     /* 1731265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1731276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1731279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1731282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1731285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731311 */     // MIs[0] policy
     /* 1731311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731345 */     // GIR_Coverage, 12961,
     /* 1731345 */     GIR_EraseRootFromParent_Done,
     /* 1731346 */   // Label 23536: @1731346
     /* 1731346 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1731432), // Rule ID 12964 //
     /* 1731351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1731362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1731365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1731368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1731371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731397 */     // MIs[0] policy
     /* 1731397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731407 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731431 */     // GIR_Coverage, 12964,
     /* 1731431 */     GIR_EraseRootFromParent_Done,
     /* 1731432 */   // Label 23537: @1731432
     /* 1731432 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1731518), // Rule ID 12965 //
     /* 1731437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1731448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1731451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1731454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1731457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731483 */     // MIs[0] policy
     /* 1731483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1731496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731517 */     // GIR_Coverage, 12965,
     /* 1731517 */     GIR_EraseRootFromParent_Done,
     /* 1731518 */   // Label 23538: @1731518
     /* 1731518 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1731604), // Rule ID 12968 //
     /* 1731523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1731534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1731537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1731540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1731543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731569 */     // MIs[0] policy
     /* 1731569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731579 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1731582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731603 */     // GIR_Coverage, 12968,
     /* 1731603 */     GIR_EraseRootFromParent_Done,
     /* 1731604 */   // Label 23539: @1731604
     /* 1731604 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1731690), // Rule ID 12969 //
     /* 1731609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1731620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1731623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1731626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1731629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731655 */     // MIs[0] policy
     /* 1731655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1731668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731689 */     // GIR_Coverage, 12969,
     /* 1731689 */     GIR_EraseRootFromParent_Done,
     /* 1731690 */   // Label 23540: @1731690
     /* 1731690 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1731776), // Rule ID 12972 //
     /* 1731695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1731706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1731709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1731712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1731715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731741 */     // MIs[0] policy
     /* 1731741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1731754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731775 */     // GIR_Coverage, 12972,
     /* 1731775 */     GIR_EraseRootFromParent_Done,
     /* 1731776 */   // Label 23541: @1731776
     /* 1731776 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1731862), // Rule ID 12973 //
     /* 1731781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1731792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1731795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1731798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1731801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731827 */     // MIs[0] policy
     /* 1731827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731837 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1731840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731861 */     // GIR_Coverage, 12973,
     /* 1731861 */     GIR_EraseRootFromParent_Done,
     /* 1731862 */   // Label 23542: @1731862
     /* 1731862 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1731948), // Rule ID 12976 //
     /* 1731867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1731878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1731881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1731884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1731887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731913 */     // MIs[0] policy
     /* 1731913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731923 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1731926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1731930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731947 */     // GIR_Coverage, 12976,
     /* 1731947 */     GIR_EraseRootFromParent_Done,
     /* 1731948 */   // Label 23543: @1731948
     /* 1731948 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1732034), // Rule ID 12977 //
     /* 1731953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1731961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1731964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1731967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1731970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1731973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731999 */     // MIs[0] policy
     /* 1731999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732009 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1732012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732033 */     // GIR_Coverage, 12977,
     /* 1732033 */     GIR_EraseRootFromParent_Done,
     /* 1732034 */   // Label 23544: @1732034
     /* 1732034 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1732120), // Rule ID 12980 //
     /* 1732039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1732050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1732053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1732056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1732059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732085 */     // MIs[0] policy
     /* 1732085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1732098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732119 */     // GIR_Coverage, 12980,
     /* 1732119 */     GIR_EraseRootFromParent_Done,
     /* 1732120 */   // Label 23545: @1732120
     /* 1732120 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1732206), // Rule ID 12981 //
     /* 1732125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1732136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1732139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1732142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1732145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732171 */     // MIs[0] policy
     /* 1732171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1732184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732205 */     // GIR_Coverage, 12981,
     /* 1732205 */     GIR_EraseRootFromParent_Done,
     /* 1732206 */   // Label 23546: @1732206
     /* 1732206 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1732292), // Rule ID 12984 //
     /* 1732211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1732222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1732225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1732228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1732231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732257 */     // MIs[0] policy
     /* 1732257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1732270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732291 */     // GIR_Coverage, 12984,
     /* 1732291 */     GIR_EraseRootFromParent_Done,
     /* 1732292 */   // Label 23547: @1732292
     /* 1732292 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1732378), // Rule ID 12985 //
     /* 1732297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1732308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1732311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1732314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1732317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732343 */     // MIs[0] policy
     /* 1732343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732353 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1732356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732377 */     // GIR_Coverage, 12985,
     /* 1732377 */     GIR_EraseRootFromParent_Done,
     /* 1732378 */   // Label 23548: @1732378
     /* 1732378 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1732464), // Rule ID 12988 //
     /* 1732383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1732394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1732397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1732400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1732403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1732406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732429 */     // MIs[0] policy
     /* 1732429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732439 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1732442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732463 */     // GIR_Coverage, 12988,
     /* 1732463 */     GIR_EraseRootFromParent_Done,
     /* 1732464 */   // Label 23549: @1732464
     /* 1732464 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1732550), // Rule ID 12989 //
     /* 1732469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1732480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1732483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1732486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1732489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1732492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732515 */     // MIs[0] policy
     /* 1732515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732525 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1732528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732549 */     // GIR_Coverage, 12989,
     /* 1732549 */     GIR_EraseRootFromParent_Done,
     /* 1732550 */   // Label 23550: @1732550
     /* 1732550 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1732636), // Rule ID 12992 //
     /* 1732555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1732566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1732569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1732572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1732575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732601 */     // MIs[0] policy
     /* 1732601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1732614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732635 */     // GIR_Coverage, 12992,
     /* 1732635 */     GIR_EraseRootFromParent_Done,
     /* 1732636 */   // Label 23551: @1732636
     /* 1732636 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1732722), // Rule ID 12993 //
     /* 1732641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1732652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1732655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1732658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1732661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732687 */     // MIs[0] policy
     /* 1732687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1732700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732721 */     // GIR_Coverage, 12993,
     /* 1732721 */     GIR_EraseRootFromParent_Done,
     /* 1732722 */   // Label 23552: @1732722
     /* 1732722 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1732808), // Rule ID 12996 //
     /* 1732727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1732738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1732741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1732744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1732747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732773 */     // MIs[0] policy
     /* 1732773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732783 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1732786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732807 */     // GIR_Coverage, 12996,
     /* 1732807 */     GIR_EraseRootFromParent_Done,
     /* 1732808 */   // Label 23553: @1732808
     /* 1732808 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1732894), // Rule ID 12997 //
     /* 1732813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1732824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1732827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1732830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1732833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732859 */     // MIs[0] policy
     /* 1732859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732869 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1732872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732893 */     // GIR_Coverage, 12997,
     /* 1732893 */     GIR_EraseRootFromParent_Done,
     /* 1732894 */   // Label 23554: @1732894
     /* 1732894 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1732980), // Rule ID 13000 //
     /* 1732899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1732916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1732919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732945 */     // MIs[0] policy
     /* 1732945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732955 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1732958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1732962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732979 */     // GIR_Coverage, 13000,
     /* 1732979 */     GIR_EraseRootFromParent_Done,
     /* 1732980 */   // Label 23555: @1732980
     /* 1732980 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1733066), // Rule ID 13001 //
     /* 1732985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1732993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1733002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1733005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733031 */     // MIs[0] policy
     /* 1733031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1733044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733065 */     // GIR_Coverage, 13001,
     /* 1733065 */     GIR_EraseRootFromParent_Done,
     /* 1733066 */   // Label 23556: @1733066
     /* 1733066 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1733152), // Rule ID 13004 //
     /* 1733071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1733082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1733085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1733088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1733091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733117 */     // MIs[0] policy
     /* 1733117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1733130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733151 */     // GIR_Coverage, 13004,
     /* 1733151 */     GIR_EraseRootFromParent_Done,
     /* 1733152 */   // Label 23557: @1733152
     /* 1733152 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1733238), // Rule ID 13005 //
     /* 1733157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1733168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1733171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1733174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1733177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733203 */     // MIs[0] policy
     /* 1733203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1733216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733237 */     // GIR_Coverage, 13005,
     /* 1733237 */     GIR_EraseRootFromParent_Done,
     /* 1733238 */   // Label 23558: @1733238
     /* 1733238 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1733324), // Rule ID 13008 //
     /* 1733243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1733254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1733257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1733260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1733263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733289 */     // MIs[0] policy
     /* 1733289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1733302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733323 */     // GIR_Coverage, 13008,
     /* 1733323 */     GIR_EraseRootFromParent_Done,
     /* 1733324 */   // Label 23559: @1733324
     /* 1733324 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1733410), // Rule ID 13009 //
     /* 1733329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1733340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1733343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1733346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1733349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733375 */     // MIs[0] policy
     /* 1733375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733385 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1733388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733409 */     // GIR_Coverage, 13009,
     /* 1733409 */     GIR_EraseRootFromParent_Done,
     /* 1733410 */   // Label 23560: @1733410
     /* 1733410 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1733496), // Rule ID 13012 //
     /* 1733415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1733426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1733429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1733432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1733435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733461 */     // MIs[0] policy
     /* 1733461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733471 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1733474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733495 */     // GIR_Coverage, 13012,
     /* 1733495 */     GIR_EraseRootFromParent_Done,
     /* 1733496 */   // Label 23561: @1733496
     /* 1733496 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1733582), // Rule ID 13013 //
     /* 1733501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1733512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1733515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1733518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1733521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733547 */     // MIs[0] policy
     /* 1733547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733557 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1733560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733581 */     // GIR_Coverage, 13013,
     /* 1733581 */     GIR_EraseRootFromParent_Done,
     /* 1733582 */   // Label 23562: @1733582
     /* 1733582 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1733668), // Rule ID 13016 //
     /* 1733587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1733598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1733601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1733604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1733607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733633 */     // MIs[0] policy
     /* 1733633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733643 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1733646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733667 */     // GIR_Coverage, 13016,
     /* 1733667 */     GIR_EraseRootFromParent_Done,
     /* 1733668 */   // Label 23563: @1733668
     /* 1733668 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1733754), // Rule ID 13017 //
     /* 1733673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1733684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1733687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1733690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1733693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733719 */     // MIs[0] policy
     /* 1733719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733729 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1733732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733753 */     // GIR_Coverage, 13017,
     /* 1733753 */     GIR_EraseRootFromParent_Done,
     /* 1733754 */   // Label 23564: @1733754
     /* 1733754 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1733840), // Rule ID 13020 //
     /* 1733759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1733770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1733773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1733776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1733779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733805 */     // MIs[0] policy
     /* 1733805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733815 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1733818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733839 */     // GIR_Coverage, 13020,
     /* 1733839 */     GIR_EraseRootFromParent_Done,
     /* 1733840 */   // Label 23565: @1733840
     /* 1733840 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1733926), // Rule ID 13021 //
     /* 1733845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1733856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1733859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1733862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1733865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733891 */     // MIs[0] policy
     /* 1733891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733901 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1733904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733925 */     // GIR_Coverage, 13021,
     /* 1733925 */     GIR_EraseRootFromParent_Done,
     /* 1733926 */   // Label 23566: @1733926
     /* 1733926 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1734012), // Rule ID 13024 //
     /* 1733931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1733939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1733942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1733945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1733948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1733951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733977 */     // MIs[0] policy
     /* 1733977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733987 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1733990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1733994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734011 */     // GIR_Coverage, 13024,
     /* 1734011 */     GIR_EraseRootFromParent_Done,
     /* 1734012 */   // Label 23567: @1734012
     /* 1734012 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1734098), // Rule ID 13025 //
     /* 1734017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1734028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1734031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1734037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734063 */     // MIs[0] policy
     /* 1734063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734073 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1734076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734097 */     // GIR_Coverage, 13025,
     /* 1734097 */     GIR_EraseRootFromParent_Done,
     /* 1734098 */   // Label 23568: @1734098
     /* 1734098 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1734184), // Rule ID 13028 //
     /* 1734103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1734114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1734117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1734123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734149 */     // MIs[0] policy
     /* 1734149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734159 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1734162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734183 */     // GIR_Coverage, 13028,
     /* 1734183 */     GIR_EraseRootFromParent_Done,
     /* 1734184 */   // Label 23569: @1734184
     /* 1734184 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1734270), // Rule ID 13029 //
     /* 1734189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1734200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1734203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1734209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734235 */     // MIs[0] policy
     /* 1734235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734245 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1734248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734269 */     // GIR_Coverage, 13029,
     /* 1734269 */     GIR_EraseRootFromParent_Done,
     /* 1734270 */   // Label 23570: @1734270
     /* 1734270 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1734356), // Rule ID 13032 //
     /* 1734275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1734286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1734289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1734295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734321 */     // MIs[0] policy
     /* 1734321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734331 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1734334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734355 */     // GIR_Coverage, 13032,
     /* 1734355 */     GIR_EraseRootFromParent_Done,
     /* 1734356 */   // Label 23571: @1734356
     /* 1734356 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1734442), // Rule ID 13033 //
     /* 1734361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1734372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1734375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1734381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734407 */     // MIs[0] policy
     /* 1734407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734417 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1734420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734441 */     // GIR_Coverage, 13033,
     /* 1734441 */     GIR_EraseRootFromParent_Done,
     /* 1734442 */   // Label 23572: @1734442
     /* 1734442 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1734528), // Rule ID 13036 //
     /* 1734447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1734458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1734461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1734467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734493 */     // MIs[0] policy
     /* 1734493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734503 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1734506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734527 */     // GIR_Coverage, 13036,
     /* 1734527 */     GIR_EraseRootFromParent_Done,
     /* 1734528 */   // Label 23573: @1734528
     /* 1734528 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1734614), // Rule ID 13037 //
     /* 1734533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1734544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1734547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1734553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734579 */     // MIs[0] policy
     /* 1734579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1734592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734613 */     // GIR_Coverage, 13037,
     /* 1734613 */     GIR_EraseRootFromParent_Done,
     /* 1734614 */   // Label 23574: @1734614
     /* 1734614 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1734700), // Rule ID 13040 //
     /* 1734619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1734630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1734633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1734639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734665 */     // MIs[0] policy
     /* 1734665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1734678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734699 */     // GIR_Coverage, 13040,
     /* 1734699 */     GIR_EraseRootFromParent_Done,
     /* 1734700 */   // Label 23575: @1734700
     /* 1734700 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1734786), // Rule ID 13041 //
     /* 1734705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1734716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1734719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1734725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734751 */     // MIs[0] policy
     /* 1734751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734761 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1734764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734785 */     // GIR_Coverage, 13041,
     /* 1734785 */     GIR_EraseRootFromParent_Done,
     /* 1734786 */   // Label 23576: @1734786
     /* 1734786 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1734872), // Rule ID 13044 //
     /* 1734791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1734802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1734805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1734811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734837 */     // MIs[0] policy
     /* 1734837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734847 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1734850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734871 */     // GIR_Coverage, 13044,
     /* 1734871 */     GIR_EraseRootFromParent_Done,
     /* 1734872 */   // Label 23577: @1734872
     /* 1734872 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1734958), // Rule ID 13045 //
     /* 1734877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1734888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1734891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1734894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1734897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734923 */     // MIs[0] policy
     /* 1734923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1734936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1734940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734957 */     // GIR_Coverage, 13045,
     /* 1734957 */     GIR_EraseRootFromParent_Done,
     /* 1734958 */   // Label 23578: @1734958
     /* 1734958 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1735044), // Rule ID 13048 //
     /* 1734963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1734971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1734974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1734977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1734980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1734983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735009 */     // MIs[0] policy
     /* 1735009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1735022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735043 */     // GIR_Coverage, 13048,
     /* 1735043 */     GIR_EraseRootFromParent_Done,
     /* 1735044 */   // Label 23579: @1735044
     /* 1735044 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1735130), // Rule ID 13049 //
     /* 1735049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1735060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1735063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1735069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735095 */     // MIs[0] policy
     /* 1735095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735105 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1735108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735129 */     // GIR_Coverage, 13049,
     /* 1735129 */     GIR_EraseRootFromParent_Done,
     /* 1735130 */   // Label 23580: @1735130
     /* 1735130 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1735216), // Rule ID 13052 //
     /* 1735135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1735146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1735149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1735152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1735155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735181 */     // MIs[0] policy
     /* 1735181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735191 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1735194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735215 */     // GIR_Coverage, 13052,
     /* 1735215 */     GIR_EraseRootFromParent_Done,
     /* 1735216 */   // Label 23581: @1735216
     /* 1735216 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1735302), // Rule ID 13053 //
     /* 1735221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1735232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1735235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1735241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735267 */     // MIs[0] policy
     /* 1735267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1735280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735301 */     // GIR_Coverage, 13053,
     /* 1735301 */     GIR_EraseRootFromParent_Done,
     /* 1735302 */   // Label 23582: @1735302
     /* 1735302 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1735388), // Rule ID 13056 //
     /* 1735307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1735318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1735321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1735324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1735327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735353 */     // MIs[0] policy
     /* 1735353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1735366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735387 */     // GIR_Coverage, 13056,
     /* 1735387 */     GIR_EraseRootFromParent_Done,
     /* 1735388 */   // Label 23583: @1735388
     /* 1735388 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1735474), // Rule ID 13057 //
     /* 1735393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1735404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1735407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1735413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735439 */     // MIs[0] policy
     /* 1735439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1735452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735473 */     // GIR_Coverage, 13057,
     /* 1735473 */     GIR_EraseRootFromParent_Done,
     /* 1735474 */   // Label 23584: @1735474
     /* 1735474 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1735560), // Rule ID 13060 //
     /* 1735479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1735490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1735493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1735496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1735499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735525 */     // MIs[0] policy
     /* 1735525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735535 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1735538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735559 */     // GIR_Coverage, 13060,
     /* 1735559 */     GIR_EraseRootFromParent_Done,
     /* 1735560 */   // Label 23585: @1735560
     /* 1735560 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1735646), // Rule ID 13061 //
     /* 1735565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1735576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1735579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1735585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735611 */     // MIs[0] policy
     /* 1735611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1735624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735645 */     // GIR_Coverage, 13061,
     /* 1735645 */     GIR_EraseRootFromParent_Done,
     /* 1735646 */   // Label 23586: @1735646
     /* 1735646 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1735732), // Rule ID 13064 //
     /* 1735651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1735662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1735665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1735668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1735671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1735674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735697 */     // MIs[0] policy
     /* 1735697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735707 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1735710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735731 */     // GIR_Coverage, 13064,
     /* 1735731 */     GIR_EraseRootFromParent_Done,
     /* 1735732 */   // Label 23587: @1735732
     /* 1735732 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1735818), // Rule ID 13065 //
     /* 1735737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1735748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1735751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1735757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1735760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735783 */     // MIs[0] policy
     /* 1735783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1735796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735817 */     // GIR_Coverage, 13065,
     /* 1735817 */     GIR_EraseRootFromParent_Done,
     /* 1735818 */   // Label 23588: @1735818
     /* 1735818 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1735904), // Rule ID 13068 //
     /* 1735823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1735834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1735837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1735840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1735843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735869 */     // MIs[0] policy
     /* 1735869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1735882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735903 */     // GIR_Coverage, 13068,
     /* 1735903 */     GIR_EraseRootFromParent_Done,
     /* 1735904 */   // Label 23589: @1735904
     /* 1735904 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1735990), // Rule ID 13069 //
     /* 1735909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1735917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1735920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1735923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1735926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1735929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735955 */     // MIs[0] policy
     /* 1735955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1735968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1735972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735989 */     // GIR_Coverage, 13069,
     /* 1735989 */     GIR_EraseRootFromParent_Done,
     /* 1735990 */   // Label 23590: @1735990
     /* 1735990 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1736076), // Rule ID 13072 //
     /* 1735995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1736006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1736009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1736015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736041 */     // MIs[0] policy
     /* 1736041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736051 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1736054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736075 */     // GIR_Coverage, 13072,
     /* 1736075 */     GIR_EraseRootFromParent_Done,
     /* 1736076 */   // Label 23591: @1736076
     /* 1736076 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1736162), // Rule ID 13073 //
     /* 1736081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1736092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1736095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1736101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736127 */     // MIs[0] policy
     /* 1736127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736137 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1736140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736161 */     // GIR_Coverage, 13073,
     /* 1736161 */     GIR_EraseRootFromParent_Done,
     /* 1736162 */   // Label 23592: @1736162
     /* 1736162 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1736248), // Rule ID 13076 //
     /* 1736167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1736178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1736181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1736187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1736190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736213 */     // MIs[0] policy
     /* 1736213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736223 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1736226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736247 */     // GIR_Coverage, 13076,
     /* 1736247 */     GIR_EraseRootFromParent_Done,
     /* 1736248 */   // Label 23593: @1736248
     /* 1736248 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1736334), // Rule ID 13077 //
     /* 1736253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1736264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1736267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1736273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1736276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736299 */     // MIs[0] policy
     /* 1736299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1736312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736333 */     // GIR_Coverage, 13077,
     /* 1736333 */     GIR_EraseRootFromParent_Done,
     /* 1736334 */   // Label 23594: @1736334
     /* 1736334 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1736420), // Rule ID 13080 //
     /* 1736339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1736350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1736353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1736359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736385 */     // MIs[0] policy
     /* 1736385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1736398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736419 */     // GIR_Coverage, 13080,
     /* 1736419 */     GIR_EraseRootFromParent_Done,
     /* 1736420 */   // Label 23595: @1736420
     /* 1736420 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1736506), // Rule ID 13081 //
     /* 1736425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1736436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1736439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1736445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736471 */     // MIs[0] policy
     /* 1736471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1736484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736505 */     // GIR_Coverage, 13081,
     /* 1736505 */     GIR_EraseRootFromParent_Done,
     /* 1736506 */   // Label 23596: @1736506
     /* 1736506 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1736592), // Rule ID 13084 //
     /* 1736511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1736522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1736525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1736531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736557 */     // MIs[0] policy
     /* 1736557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736567 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1736570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736591 */     // GIR_Coverage, 13084,
     /* 1736591 */     GIR_EraseRootFromParent_Done,
     /* 1736592 */   // Label 23597: @1736592
     /* 1736592 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1736678), // Rule ID 13085 //
     /* 1736597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1736608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1736611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1736617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736643 */     // MIs[0] policy
     /* 1736643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736653 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1736656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736677 */     // GIR_Coverage, 13085,
     /* 1736677 */     GIR_EraseRootFromParent_Done,
     /* 1736678 */   // Label 23598: @1736678
     /* 1736678 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1736764), // Rule ID 13088 //
     /* 1736683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1736694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1736697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1736703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736729 */     // MIs[0] policy
     /* 1736729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1736742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736763 */     // GIR_Coverage, 13088,
     /* 1736763 */     GIR_EraseRootFromParent_Done,
     /* 1736764 */   // Label 23599: @1736764
     /* 1736764 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1736850), // Rule ID 13089 //
     /* 1736769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1736780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1736783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1736789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736815 */     // MIs[0] policy
     /* 1736815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736825 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1736828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736849 */     // GIR_Coverage, 13089,
     /* 1736849 */     GIR_EraseRootFromParent_Done,
     /* 1736850 */   // Label 23600: @1736850
     /* 1736850 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1736936), // Rule ID 13092 //
     /* 1736855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1736866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1736869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1736872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1736875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736901 */     // MIs[0] policy
     /* 1736901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1736914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1736918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736935 */     // GIR_Coverage, 13092,
     /* 1736935 */     GIR_EraseRootFromParent_Done,
     /* 1736936 */   // Label 23601: @1736936
     /* 1736936 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1737022), // Rule ID 13093 //
     /* 1736941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1736949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1736952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1736955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1736958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1736961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736987 */     // MIs[0] policy
     /* 1736987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1737000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737021 */     // GIR_Coverage, 13093,
     /* 1737021 */     GIR_EraseRootFromParent_Done,
     /* 1737022 */   // Label 23602: @1737022
     /* 1737022 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1737108), // Rule ID 13096 //
     /* 1737027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1737035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1737038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1737041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1737044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1737047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737073 */     // MIs[0] policy
     /* 1737073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737083 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1737086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737107 */     // GIR_Coverage, 13096,
     /* 1737107 */     GIR_EraseRootFromParent_Done,
     /* 1737108 */   // Label 23603: @1737108
     /* 1737108 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1737194), // Rule ID 13097 //
     /* 1737113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1737121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1737124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1737127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1737130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1737133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737159 */     // MIs[0] policy
     /* 1737159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737169 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1737172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737193 */     // GIR_Coverage, 13097,
     /* 1737193 */     GIR_EraseRootFromParent_Done,
     /* 1737194 */   // Label 23604: @1737194
     /* 1737194 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1737280), // Rule ID 13100 //
     /* 1737199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1737207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1737210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1737213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1737216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1737219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737245 */     // MIs[0] policy
     /* 1737245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737255 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1737258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737279 */     // GIR_Coverage, 13100,
     /* 1737279 */     GIR_EraseRootFromParent_Done,
     /* 1737280 */   // Label 23605: @1737280
     /* 1737280 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1737366), // Rule ID 13101 //
     /* 1737285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1737293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1737296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1737299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1737302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1737305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737331 */     // MIs[0] policy
     /* 1737331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1737344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737365 */     // GIR_Coverage, 13101,
     /* 1737365 */     GIR_EraseRootFromParent_Done,
     /* 1737366 */   // Label 23606: @1737366
     /* 1737366 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1737452), // Rule ID 13104 //
     /* 1737371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1737382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1737385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1737388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1737391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737417 */     // MIs[0] policy
     /* 1737417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1737430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737451 */     // GIR_Coverage, 13104,
     /* 1737451 */     GIR_EraseRootFromParent_Done,
     /* 1737452 */   // Label 23607: @1737452
     /* 1737452 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1737538), // Rule ID 13105 //
     /* 1737457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1737468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1737471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1737474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1737477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737503 */     // MIs[0] policy
     /* 1737503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737513 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1737516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737537 */     // GIR_Coverage, 13105,
     /* 1737537 */     GIR_EraseRootFromParent_Done,
     /* 1737538 */   // Label 23608: @1737538
     /* 1737538 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1737624), // Rule ID 13108 //
     /* 1737543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1737554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1737557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1737560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1737563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737589 */     // MIs[0] policy
     /* 1737589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737599 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1737602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737623 */     // GIR_Coverage, 13108,
     /* 1737623 */     GIR_EraseRootFromParent_Done,
     /* 1737624 */   // Label 23609: @1737624
     /* 1737624 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1737710), // Rule ID 13109 //
     /* 1737629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1737640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1737643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1737646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1737649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737675 */     // MIs[0] policy
     /* 1737675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737685 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1737688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737709 */     // GIR_Coverage, 13109,
     /* 1737709 */     GIR_EraseRootFromParent_Done,
     /* 1737710 */   // Label 23610: @1737710
     /* 1737710 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1737796), // Rule ID 13112 //
     /* 1737715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1737726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1737729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1737732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1737735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737761 */     // MIs[0] policy
     /* 1737761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1737774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737795 */     // GIR_Coverage, 13112,
     /* 1737795 */     GIR_EraseRootFromParent_Done,
     /* 1737796 */   // Label 23611: @1737796
     /* 1737796 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1737882), // Rule ID 13113 //
     /* 1737801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1737812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1737815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1737818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1737821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737847 */     // MIs[0] policy
     /* 1737847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737857 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1737860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737881 */     // GIR_Coverage, 13113,
     /* 1737881 */     GIR_EraseRootFromParent_Done,
     /* 1737882 */   // Label 23612: @1737882
     /* 1737882 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1737968), // Rule ID 13116 //
     /* 1737887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1737907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737933 */     // MIs[0] policy
     /* 1737933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1737946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1737950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737967 */     // GIR_Coverage, 13116,
     /* 1737967 */     GIR_EraseRootFromParent_Done,
     /* 1737968 */   // Label 23613: @1737968
     /* 1737968 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1738054), // Rule ID 13117 //
     /* 1737973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1737981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1737993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738019 */     // MIs[0] policy
     /* 1738019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738029 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1738032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738053 */     // GIR_Coverage, 13117,
     /* 1738053 */     GIR_EraseRootFromParent_Done,
     /* 1738054 */   // Label 23614: @1738054
     /* 1738054 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1738140), // Rule ID 13120 //
     /* 1738059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1738070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1738073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1738076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1738079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738105 */     // MIs[0] policy
     /* 1738105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738115 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1738118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738139 */     // GIR_Coverage, 13120,
     /* 1738139 */     GIR_EraseRootFromParent_Done,
     /* 1738140 */   // Label 23615: @1738140
     /* 1738140 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1738226), // Rule ID 13121 //
     /* 1738145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1738156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1738159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1738162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1738165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738191 */     // MIs[0] policy
     /* 1738191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1738204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738225 */     // GIR_Coverage, 13121,
     /* 1738225 */     GIR_EraseRootFromParent_Done,
     /* 1738226 */   // Label 23616: @1738226
     /* 1738226 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1738312), // Rule ID 13124 //
     /* 1738231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1738242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1738245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1738248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1738251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738277 */     // MIs[0] policy
     /* 1738277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738287 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1738290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738311 */     // GIR_Coverage, 13124,
     /* 1738311 */     GIR_EraseRootFromParent_Done,
     /* 1738312 */   // Label 23617: @1738312
     /* 1738312 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1738398), // Rule ID 13125 //
     /* 1738317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1738328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1738331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1738334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1738337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738363 */     // MIs[0] policy
     /* 1738363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738373 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1738376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738397 */     // GIR_Coverage, 13125,
     /* 1738397 */     GIR_EraseRootFromParent_Done,
     /* 1738398 */   // Label 23618: @1738398
     /* 1738398 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1738484), // Rule ID 13128 //
     /* 1738403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1738414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1738417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1738420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1738423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738449 */     // MIs[0] policy
     /* 1738449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738483 */     // GIR_Coverage, 13128,
     /* 1738483 */     GIR_EraseRootFromParent_Done,
     /* 1738484 */   // Label 23619: @1738484
     /* 1738484 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1738570), // Rule ID 13129 //
     /* 1738489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1738500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1738503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1738506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1738509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738535 */     // MIs[0] policy
     /* 1738535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738569 */     // GIR_Coverage, 13129,
     /* 1738569 */     GIR_EraseRootFromParent_Done,
     /* 1738570 */   // Label 23620: @1738570
     /* 1738570 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1738656), // Rule ID 13132 //
     /* 1738575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1738586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1738589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1738592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1738595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738621 */     // MIs[0] policy
     /* 1738621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738631 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738655 */     // GIR_Coverage, 13132,
     /* 1738655 */     GIR_EraseRootFromParent_Done,
     /* 1738656 */   // Label 23621: @1738656
     /* 1738656 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1738742), // Rule ID 13133 //
     /* 1738661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1738672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1738675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1738678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1738681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738707 */     // MIs[0] policy
     /* 1738707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738717 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738741 */     // GIR_Coverage, 13133,
     /* 1738741 */     GIR_EraseRootFromParent_Done,
     /* 1738742 */   // Label 23622: @1738742
     /* 1738742 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1738828), // Rule ID 13136 //
     /* 1738747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1738758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1738761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1738764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1738767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738793 */     // MIs[0] policy
     /* 1738793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738827 */     // GIR_Coverage, 13136,
     /* 1738827 */     GIR_EraseRootFromParent_Done,
     /* 1738828 */   // Label 23623: @1738828
     /* 1738828 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1738914), // Rule ID 13137 //
     /* 1738833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1738844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1738847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1738850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1738853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738879 */     // MIs[0] policy
     /* 1738879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738889 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738913 */     // GIR_Coverage, 13137,
     /* 1738913 */     GIR_EraseRootFromParent_Done,
     /* 1738914 */   // Label 23624: @1738914
     /* 1738914 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1739000), // Rule ID 13140 //
     /* 1738919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1738927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1738930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1738933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1738936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1738939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738965 */     // MIs[0] policy
     /* 1738965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1738978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1738982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738999 */     // GIR_Coverage, 13140,
     /* 1738999 */     GIR_EraseRootFromParent_Done,
     /* 1739000 */   // Label 23625: @1739000
     /* 1739000 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1739086), // Rule ID 13141 //
     /* 1739005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1739016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1739019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1739022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1739025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739051 */     // MIs[0] policy
     /* 1739051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1739064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739085 */     // GIR_Coverage, 13141,
     /* 1739085 */     GIR_EraseRootFromParent_Done,
     /* 1739086 */   // Label 23626: @1739086
     /* 1739086 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1739172), // Rule ID 13144 //
     /* 1739091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1739102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1739105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1739108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1739111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739137 */     // MIs[0] policy
     /* 1739137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1739150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739171 */     // GIR_Coverage, 13144,
     /* 1739171 */     GIR_EraseRootFromParent_Done,
     /* 1739172 */   // Label 23627: @1739172
     /* 1739172 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1739258), // Rule ID 13145 //
     /* 1739177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1739188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1739191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1739194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1739197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739223 */     // MIs[0] policy
     /* 1739223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739233 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1739236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739257 */     // GIR_Coverage, 13145,
     /* 1739257 */     GIR_EraseRootFromParent_Done,
     /* 1739258 */   // Label 23628: @1739258
     /* 1739258 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1739344), // Rule ID 13148 //
     /* 1739263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1739274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1739277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1739280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1739283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739309 */     // MIs[0] policy
     /* 1739309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739319 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1739322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739343 */     // GIR_Coverage, 13148,
     /* 1739343 */     GIR_EraseRootFromParent_Done,
     /* 1739344 */   // Label 23629: @1739344
     /* 1739344 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1739430), // Rule ID 13149 //
     /* 1739349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1739360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1739363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1739366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1739369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739395 */     // MIs[0] policy
     /* 1739395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739405 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1739408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739429 */     // GIR_Coverage, 13149,
     /* 1739429 */     GIR_EraseRootFromParent_Done,
     /* 1739430 */   // Label 23630: @1739430
     /* 1739430 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1739516), // Rule ID 13152 //
     /* 1739435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1739446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1739449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1739452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1739455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1739458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739481 */     // MIs[0] policy
     /* 1739481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739491 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1739494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739515 */     // GIR_Coverage, 13152,
     /* 1739515 */     GIR_EraseRootFromParent_Done,
     /* 1739516 */   // Label 23631: @1739516
     /* 1739516 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1739602), // Rule ID 13153 //
     /* 1739521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1739532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1739535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1739538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1739541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1739544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739567 */     // MIs[0] policy
     /* 1739567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739577 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1739580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739601 */     // GIR_Coverage, 13153,
     /* 1739601 */     GIR_EraseRootFromParent_Done,
     /* 1739602 */   // Label 23632: @1739602
     /* 1739602 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1739688), // Rule ID 13156 //
     /* 1739607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1739618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1739621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1739624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1739627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739653 */     // MIs[0] policy
     /* 1739653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1739666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739687 */     // GIR_Coverage, 13156,
     /* 1739687 */     GIR_EraseRootFromParent_Done,
     /* 1739688 */   // Label 23633: @1739688
     /* 1739688 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1739774), // Rule ID 13157 //
     /* 1739693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1739704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1739707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1739710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1739713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739739 */     // MIs[0] policy
     /* 1739739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1739752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739773 */     // GIR_Coverage, 13157,
     /* 1739773 */     GIR_EraseRootFromParent_Done,
     /* 1739774 */   // Label 23634: @1739774
     /* 1739774 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1739860), // Rule ID 13160 //
     /* 1739779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1739790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1739793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1739796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1739799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739825 */     // MIs[0] policy
     /* 1739825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739835 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1739838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739859 */     // GIR_Coverage, 13160,
     /* 1739859 */     GIR_EraseRootFromParent_Done,
     /* 1739860 */   // Label 23635: @1739860
     /* 1739860 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1739946), // Rule ID 13161 //
     /* 1739865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1739876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1739879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1739882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1739885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739911 */     // MIs[0] policy
     /* 1739911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739921 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1739924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1739928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739945 */     // GIR_Coverage, 13161,
     /* 1739945 */     GIR_EraseRootFromParent_Done,
     /* 1739946 */   // Label 23636: @1739946
     /* 1739946 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1740032), // Rule ID 13164 //
     /* 1739951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1739959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1739962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1739965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1739968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1739971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739997 */     // MIs[0] policy
     /* 1739997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740007 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1740010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740031 */     // GIR_Coverage, 13164,
     /* 1740031 */     GIR_EraseRootFromParent_Done,
     /* 1740032 */   // Label 23637: @1740032
     /* 1740032 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1740118), // Rule ID 13165 //
     /* 1740037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1740048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1740051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1740054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1740057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1740060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740083 */     // MIs[0] policy
     /* 1740083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1740096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740117 */     // GIR_Coverage, 13165,
     /* 1740117 */     GIR_EraseRootFromParent_Done,
     /* 1740118 */   // Label 23638: @1740118
     /* 1740118 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1740204), // Rule ID 13168 //
     /* 1740123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1740134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1740137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1740140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1740143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740169 */     // MIs[0] policy
     /* 1740169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1740182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740203 */     // GIR_Coverage, 13168,
     /* 1740203 */     GIR_EraseRootFromParent_Done,
     /* 1740204 */   // Label 23639: @1740204
     /* 1740204 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1740290), // Rule ID 13169 //
     /* 1740209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1740220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1740223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1740226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1740229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740255 */     // MIs[0] policy
     /* 1740255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1740268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740289 */     // GIR_Coverage, 13169,
     /* 1740289 */     GIR_EraseRootFromParent_Done,
     /* 1740290 */   // Label 23640: @1740290
     /* 1740290 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1740376), // Rule ID 13172 //
     /* 1740295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1740306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1740309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1740312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1740315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740341 */     // MIs[0] policy
     /* 1740341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1740354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740375 */     // GIR_Coverage, 13172,
     /* 1740375 */     GIR_EraseRootFromParent_Done,
     /* 1740376 */   // Label 23641: @1740376
     /* 1740376 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1740462), // Rule ID 13173 //
     /* 1740381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1740392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1740395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1740398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1740401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740427 */     // MIs[0] policy
     /* 1740427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740437 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1740440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740461 */     // GIR_Coverage, 13173,
     /* 1740461 */     GIR_EraseRootFromParent_Done,
     /* 1740462 */   // Label 23642: @1740462
     /* 1740462 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1740548), // Rule ID 13176 //
     /* 1740467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1740478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1740481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1740484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1740487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1740490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740513 */     // MIs[0] policy
     /* 1740513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740523 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1740526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740547 */     // GIR_Coverage, 13176,
     /* 1740547 */     GIR_EraseRootFromParent_Done,
     /* 1740548 */   // Label 23643: @1740548
     /* 1740548 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1740634), // Rule ID 13177 //
     /* 1740553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1740564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1740567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1740570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1740573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1740576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740599 */     // MIs[0] policy
     /* 1740599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740609 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1740612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740633 */     // GIR_Coverage, 13177,
     /* 1740633 */     GIR_EraseRootFromParent_Done,
     /* 1740634 */   // Label 23644: @1740634
     /* 1740634 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1740720), // Rule ID 13180 //
     /* 1740639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1740650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1740653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1740656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1740659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740685 */     // MIs[0] policy
     /* 1740685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1740698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740719 */     // GIR_Coverage, 13180,
     /* 1740719 */     GIR_EraseRootFromParent_Done,
     /* 1740720 */   // Label 23645: @1740720
     /* 1740720 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1740806), // Rule ID 13181 //
     /* 1740725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1740736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1740739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1740742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1740745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740771 */     // MIs[0] policy
     /* 1740771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1740784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740805 */     // GIR_Coverage, 13181,
     /* 1740805 */     GIR_EraseRootFromParent_Done,
     /* 1740806 */   // Label 23646: @1740806
     /* 1740806 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1740892), // Rule ID 13184 //
     /* 1740811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1740822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1740825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1740828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1740831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740857 */     // MIs[0] policy
     /* 1740857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1740870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740891 */     // GIR_Coverage, 13184,
     /* 1740891 */     GIR_EraseRootFromParent_Done,
     /* 1740892 */   // Label 23647: @1740892
     /* 1740892 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1740978), // Rule ID 13185 //
     /* 1740897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1740908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1740911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1740914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1740917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740943 */     // MIs[0] policy
     /* 1740943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1740956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1740960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740977 */     // GIR_Coverage, 13185,
     /* 1740977 */     GIR_EraseRootFromParent_Done,
     /* 1740978 */   // Label 23648: @1740978
     /* 1740978 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1741064), // Rule ID 13188 //
     /* 1740983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1740991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1740994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1740997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1741000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1741003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741029 */     // MIs[0] policy
     /* 1741029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741039 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1741042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741063 */     // GIR_Coverage, 13188,
     /* 1741063 */     GIR_EraseRootFromParent_Done,
     /* 1741064 */   // Label 23649: @1741064
     /* 1741064 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1741150), // Rule ID 13189 //
     /* 1741069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1741072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1741080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1741083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1741086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1741089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741115 */     // MIs[0] policy
     /* 1741115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1741128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741149 */     // GIR_Coverage, 13189,
     /* 1741149 */     GIR_EraseRootFromParent_Done,
     /* 1741150 */   // Label 23650: @1741150
     /* 1741150 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1741236), // Rule ID 13192 //
     /* 1741155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1741166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1741169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1741172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1741175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741201 */     // MIs[0] policy
     /* 1741201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1741214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741235 */     // GIR_Coverage, 13192,
     /* 1741235 */     GIR_EraseRootFromParent_Done,
     /* 1741236 */   // Label 23651: @1741236
     /* 1741236 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1741322), // Rule ID 13193 //
     /* 1741241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1741252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1741255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1741258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1741261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741287 */     // MIs[0] policy
     /* 1741287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741297 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1741300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741321 */     // GIR_Coverage, 13193,
     /* 1741321 */     GIR_EraseRootFromParent_Done,
     /* 1741322 */   // Label 23652: @1741322
     /* 1741322 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1741408), // Rule ID 13196 //
     /* 1741327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1741338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1741341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1741344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1741347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741373 */     // MIs[0] policy
     /* 1741373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741383 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1741386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741407 */     // GIR_Coverage, 13196,
     /* 1741407 */     GIR_EraseRootFromParent_Done,
     /* 1741408 */   // Label 23653: @1741408
     /* 1741408 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1741494), // Rule ID 13197 //
     /* 1741413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1741424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1741427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1741430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1741433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741459 */     // MIs[0] policy
     /* 1741459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1741472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741493 */     // GIR_Coverage, 13197,
     /* 1741493 */     GIR_EraseRootFromParent_Done,
     /* 1741494 */   // Label 23654: @1741494
     /* 1741494 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1741580), // Rule ID 13200 //
     /* 1741499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1741510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1741513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1741516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1741519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741545 */     // MIs[0] policy
     /* 1741545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741555 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1741558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741579 */     // GIR_Coverage, 13200,
     /* 1741579 */     GIR_EraseRootFromParent_Done,
     /* 1741580 */   // Label 23655: @1741580
     /* 1741580 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1741666), // Rule ID 13201 //
     /* 1741585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1741596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1741599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1741602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1741605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741631 */     // MIs[0] policy
     /* 1741631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741641 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1741644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741665 */     // GIR_Coverage, 13201,
     /* 1741665 */     GIR_EraseRootFromParent_Done,
     /* 1741666 */   // Label 23656: @1741666
     /* 1741666 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1741752), // Rule ID 13204 //
     /* 1741671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1741682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1741685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1741688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1741691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741717 */     // MIs[0] policy
     /* 1741717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741727 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1741730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741751 */     // GIR_Coverage, 13204,
     /* 1741751 */     GIR_EraseRootFromParent_Done,
     /* 1741752 */   // Label 23657: @1741752
     /* 1741752 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1741838), // Rule ID 13205 //
     /* 1741757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1741768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1741771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1741774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1741777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741803 */     // MIs[0] policy
     /* 1741803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741813 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1741816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741837 */     // GIR_Coverage, 13205,
     /* 1741837 */     GIR_EraseRootFromParent_Done,
     /* 1741838 */   // Label 23658: @1741838
     /* 1741838 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1741924), // Rule ID 13208 //
     /* 1741843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1741854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1741857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1741860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1741863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741889 */     // MIs[0] policy
     /* 1741889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1741902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741923 */     // GIR_Coverage, 13208,
     /* 1741923 */     GIR_EraseRootFromParent_Done,
     /* 1741924 */   // Label 23659: @1741924
     /* 1741924 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1742010), // Rule ID 13209 //
     /* 1741929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1741937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1741940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1741943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1741946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1741949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741975 */     // MIs[0] policy
     /* 1741975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741985 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1741988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1741992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742009 */     // GIR_Coverage, 13209,
     /* 1742009 */     GIR_EraseRootFromParent_Done,
     /* 1742010 */   // Label 23660: @1742010
     /* 1742010 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1742096), // Rule ID 13212 //
     /* 1742015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1742026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1742029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1742035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742061 */     // MIs[0] policy
     /* 1742061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742071 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1742074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742095 */     // GIR_Coverage, 13212,
     /* 1742095 */     GIR_EraseRootFromParent_Done,
     /* 1742096 */   // Label 23661: @1742096
     /* 1742096 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1742182), // Rule ID 13213 //
     /* 1742101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1742112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1742115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1742121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742147 */     // MIs[0] policy
     /* 1742147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1742160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742181 */     // GIR_Coverage, 13213,
     /* 1742181 */     GIR_EraseRootFromParent_Done,
     /* 1742182 */   // Label 23662: @1742182
     /* 1742182 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1742268), // Rule ID 13216 //
     /* 1742187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1742198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1742201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1742207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742233 */     // MIs[0] policy
     /* 1742233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742243 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742267 */     // GIR_Coverage, 13216,
     /* 1742267 */     GIR_EraseRootFromParent_Done,
     /* 1742268 */   // Label 23663: @1742268
     /* 1742268 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1742354), // Rule ID 13217 //
     /* 1742273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1742284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1742287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1742293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742319 */     // MIs[0] policy
     /* 1742319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742329 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742353 */     // GIR_Coverage, 13217,
     /* 1742353 */     GIR_EraseRootFromParent_Done,
     /* 1742354 */   // Label 23664: @1742354
     /* 1742354 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1742440), // Rule ID 13220 //
     /* 1742359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1742370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1742373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1742379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742405 */     // MIs[0] policy
     /* 1742405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742439 */     // GIR_Coverage, 13220,
     /* 1742439 */     GIR_EraseRootFromParent_Done,
     /* 1742440 */   // Label 23665: @1742440
     /* 1742440 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1742526), // Rule ID 13221 //
     /* 1742445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1742456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1742459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1742465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742491 */     // MIs[0] policy
     /* 1742491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742501 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742525 */     // GIR_Coverage, 13221,
     /* 1742525 */     GIR_EraseRootFromParent_Done,
     /* 1742526 */   // Label 23666: @1742526
     /* 1742526 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1742612), // Rule ID 13224 //
     /* 1742531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1742542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1742545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1742551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742577 */     // MIs[0] policy
     /* 1742577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742587 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742611 */     // GIR_Coverage, 13224,
     /* 1742611 */     GIR_EraseRootFromParent_Done,
     /* 1742612 */   // Label 23667: @1742612
     /* 1742612 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1742698), // Rule ID 13225 //
     /* 1742617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1742628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1742631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1742637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742663 */     // MIs[0] policy
     /* 1742663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742673 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742697 */     // GIR_Coverage, 13225,
     /* 1742697 */     GIR_EraseRootFromParent_Done,
     /* 1742698 */   // Label 23668: @1742698
     /* 1742698 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1742784), // Rule ID 13228 //
     /* 1742703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1742714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1742717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1742723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742749 */     // MIs[0] policy
     /* 1742749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742759 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742783 */     // GIR_Coverage, 13228,
     /* 1742783 */     GIR_EraseRootFromParent_Done,
     /* 1742784 */   // Label 23669: @1742784
     /* 1742784 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1742870), // Rule ID 13229 //
     /* 1742789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1742800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1742803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1742809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742835 */     // MIs[0] policy
     /* 1742835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1742848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742869 */     // GIR_Coverage, 13229,
     /* 1742869 */     GIR_EraseRootFromParent_Done,
     /* 1742870 */   // Label 23670: @1742870
     /* 1742870 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1742956), // Rule ID 13232 //
     /* 1742875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1742886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1742889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1742892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1742895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742921 */     // MIs[0] policy
     /* 1742921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742931 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1742934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1742938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742955 */     // GIR_Coverage, 13232,
     /* 1742955 */     GIR_EraseRootFromParent_Done,
     /* 1742956 */   // Label 23671: @1742956
     /* 1742956 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1743042), // Rule ID 13233 //
     /* 1742961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1742969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1742972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1742975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1742978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1742981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743007 */     // MIs[0] policy
     /* 1743007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743017 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1743020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743041 */     // GIR_Coverage, 13233,
     /* 1743041 */     GIR_EraseRootFromParent_Done,
     /* 1743042 */   // Label 23672: @1743042
     /* 1743042 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1743128), // Rule ID 13236 //
     /* 1743047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1743058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1743061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1743067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743093 */     // MIs[0] policy
     /* 1743093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743103 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1743106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743127 */     // GIR_Coverage, 13236,
     /* 1743127 */     GIR_EraseRootFromParent_Done,
     /* 1743128 */   // Label 23673: @1743128
     /* 1743128 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1743214), // Rule ID 13237 //
     /* 1743133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1743144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1743147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1743150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1743153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743179 */     // MIs[0] policy
     /* 1743179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743189 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1743192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743213 */     // GIR_Coverage, 13237,
     /* 1743213 */     GIR_EraseRootFromParent_Done,
     /* 1743214 */   // Label 23674: @1743214
     /* 1743214 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1743300), // Rule ID 13240 //
     /* 1743219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1743230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1743233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1743239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1743242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743265 */     // MIs[0] policy
     /* 1743265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743275 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1743278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743299 */     // GIR_Coverage, 13240,
     /* 1743299 */     GIR_EraseRootFromParent_Done,
     /* 1743300 */   // Label 23675: @1743300
     /* 1743300 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1743386), // Rule ID 13241 //
     /* 1743305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1743316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1743319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1743322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1743325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1743328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743351 */     // MIs[0] policy
     /* 1743351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743361 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1743364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743385 */     // GIR_Coverage, 13241,
     /* 1743385 */     GIR_EraseRootFromParent_Done,
     /* 1743386 */   // Label 23676: @1743386
     /* 1743386 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1743472), // Rule ID 13244 //
     /* 1743391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1743402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1743405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1743411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743437 */     // MIs[0] policy
     /* 1743437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1743450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743471 */     // GIR_Coverage, 13244,
     /* 1743471 */     GIR_EraseRootFromParent_Done,
     /* 1743472 */   // Label 23677: @1743472
     /* 1743472 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1743558), // Rule ID 13245 //
     /* 1743477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1743488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1743491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1743494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1743497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743523 */     // MIs[0] policy
     /* 1743523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743533 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1743536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743557 */     // GIR_Coverage, 13245,
     /* 1743557 */     GIR_EraseRootFromParent_Done,
     /* 1743558 */   // Label 23678: @1743558
     /* 1743558 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1743644), // Rule ID 13248 //
     /* 1743563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1743574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1743577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1743583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743609 */     // MIs[0] policy
     /* 1743609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1743622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743643 */     // GIR_Coverage, 13248,
     /* 1743643 */     GIR_EraseRootFromParent_Done,
     /* 1743644 */   // Label 23679: @1743644
     /* 1743644 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1743730), // Rule ID 13249 //
     /* 1743649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1743660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1743663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1743666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1743669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743695 */     // MIs[0] policy
     /* 1743695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743705 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1743708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743729 */     // GIR_Coverage, 13249,
     /* 1743729 */     GIR_EraseRootFromParent_Done,
     /* 1743730 */   // Label 23680: @1743730
     /* 1743730 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1743816), // Rule ID 13252 //
     /* 1743735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1743746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1743749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1743755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743781 */     // MIs[0] policy
     /* 1743781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743791 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1743794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743815 */     // GIR_Coverage, 13252,
     /* 1743815 */     GIR_EraseRootFromParent_Done,
     /* 1743816 */   // Label 23681: @1743816
     /* 1743816 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1743902), // Rule ID 13253 //
     /* 1743821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1743832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1743835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1743838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1743841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743867 */     // MIs[0] policy
     /* 1743867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1743880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743901 */     // GIR_Coverage, 13253,
     /* 1743901 */     GIR_EraseRootFromParent_Done,
     /* 1743902 */   // Label 23682: @1743902
     /* 1743902 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1743988), // Rule ID 13256 //
     /* 1743907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1743915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1743918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1743921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1743924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1743927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743953 */     // MIs[0] policy
     /* 1743953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1743966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1743970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743987 */     // GIR_Coverage, 13256,
     /* 1743987 */     GIR_EraseRootFromParent_Done,
     /* 1743988 */   // Label 23683: @1743988
     /* 1743988 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1744074), // Rule ID 13257 //
     /* 1743993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1744004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1744007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1744013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744039 */     // MIs[0] policy
     /* 1744039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1744052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744073 */     // GIR_Coverage, 13257,
     /* 1744073 */     GIR_EraseRootFromParent_Done,
     /* 1744074 */   // Label 23684: @1744074
     /* 1744074 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1744160), // Rule ID 13260 //
     /* 1744079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1744090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1744093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1744096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1744099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744125 */     // MIs[0] policy
     /* 1744125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744135 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1744138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744159 */     // GIR_Coverage, 13260,
     /* 1744159 */     GIR_EraseRootFromParent_Done,
     /* 1744160 */   // Label 23685: @1744160
     /* 1744160 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1744246), // Rule ID 13261 //
     /* 1744165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1744176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1744179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1744185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744211 */     // MIs[0] policy
     /* 1744211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1744224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744245 */     // GIR_Coverage, 13261,
     /* 1744245 */     GIR_EraseRootFromParent_Done,
     /* 1744246 */   // Label 23686: @1744246
     /* 1744246 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1744332), // Rule ID 13264 //
     /* 1744251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1744262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1744265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1744268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1744271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744297 */     // MIs[0] policy
     /* 1744297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744307 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1744310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744331 */     // GIR_Coverage, 13264,
     /* 1744331 */     GIR_EraseRootFromParent_Done,
     /* 1744332 */   // Label 23687: @1744332
     /* 1744332 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1744418), // Rule ID 13265 //
     /* 1744337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1744348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1744351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1744357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744383 */     // MIs[0] policy
     /* 1744383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1744396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744417 */     // GIR_Coverage, 13265,
     /* 1744417 */     GIR_EraseRootFromParent_Done,
     /* 1744418 */   // Label 23688: @1744418
     /* 1744418 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1744504), // Rule ID 13268 //
     /* 1744423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1744434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1744437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1744440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1744443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744469 */     // MIs[0] policy
     /* 1744469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1744482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744503 */     // GIR_Coverage, 13268,
     /* 1744503 */     GIR_EraseRootFromParent_Done,
     /* 1744504 */   // Label 23689: @1744504
     /* 1744504 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1744590), // Rule ID 13269 //
     /* 1744509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1744520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1744523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1744529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744555 */     // MIs[0] policy
     /* 1744555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1744568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744589 */     // GIR_Coverage, 13269,
     /* 1744589 */     GIR_EraseRootFromParent_Done,
     /* 1744590 */   // Label 23690: @1744590
     /* 1744590 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1744676), // Rule ID 13272 //
     /* 1744595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1744606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1744609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1744612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1744615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744641 */     // MIs[0] policy
     /* 1744641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1744654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744675 */     // GIR_Coverage, 13272,
     /* 1744675 */     GIR_EraseRootFromParent_Done,
     /* 1744676 */   // Label 23691: @1744676
     /* 1744676 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1744762), // Rule ID 13273 //
     /* 1744681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1744692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1744695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1744701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744727 */     // MIs[0] policy
     /* 1744727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744737 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1744740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744761 */     // GIR_Coverage, 13273,
     /* 1744761 */     GIR_EraseRootFromParent_Done,
     /* 1744762 */   // Label 23692: @1744762
     /* 1744762 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1744848), // Rule ID 13276 //
     /* 1744767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1744778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1744781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1744784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1744787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744813 */     // MIs[0] policy
     /* 1744813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1744826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744847 */     // GIR_Coverage, 13276,
     /* 1744847 */     GIR_EraseRootFromParent_Done,
     /* 1744848 */   // Label 23693: @1744848
     /* 1744848 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1744934), // Rule ID 13277 //
     /* 1744853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1744861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1744864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1744867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1744870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1744873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744899 */     // MIs[0] policy
     /* 1744899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1744912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1744916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744933 */     // GIR_Coverage, 13277,
     /* 1744933 */     GIR_EraseRootFromParent_Done,
     /* 1744934 */   // Label 23694: @1744934
     /* 1744934 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1745020), // Rule ID 13280 //
     /* 1744939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1744947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1744950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1744953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1744956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1744959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744985 */     // MIs[0] policy
     /* 1744985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744995 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1744998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745019 */     // GIR_Coverage, 13280,
     /* 1745019 */     GIR_EraseRootFromParent_Done,
     /* 1745020 */   // Label 23695: @1745020
     /* 1745020 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1745106), // Rule ID 13281 //
     /* 1745025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1745036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1745039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1745042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1745045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745071 */     // MIs[0] policy
     /* 1745071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1745084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745105 */     // GIR_Coverage, 13281,
     /* 1745105 */     GIR_EraseRootFromParent_Done,
     /* 1745106 */   // Label 23696: @1745106
     /* 1745106 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1745192), // Rule ID 13284 //
     /* 1745111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1745122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1745125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1745128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1745131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745157 */     // MIs[0] policy
     /* 1745157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745167 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1745170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745191 */     // GIR_Coverage, 13284,
     /* 1745191 */     GIR_EraseRootFromParent_Done,
     /* 1745192 */   // Label 23697: @1745192
     /* 1745192 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1745278), // Rule ID 13285 //
     /* 1745197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1745208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1745211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1745214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1745217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745243 */     // MIs[0] policy
     /* 1745243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1745256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745277 */     // GIR_Coverage, 13285,
     /* 1745277 */     GIR_EraseRootFromParent_Done,
     /* 1745278 */   // Label 23698: @1745278
     /* 1745278 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1745364), // Rule ID 13288 //
     /* 1745283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1745294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1745297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1745300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1745303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745329 */     // MIs[0] policy
     /* 1745329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745339 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1745342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745363 */     // GIR_Coverage, 13288,
     /* 1745363 */     GIR_EraseRootFromParent_Done,
     /* 1745364 */   // Label 23699: @1745364
     /* 1745364 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1745450), // Rule ID 13289 //
     /* 1745369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1745380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1745383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1745386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1745389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745415 */     // MIs[0] policy
     /* 1745415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1745428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745449 */     // GIR_Coverage, 13289,
     /* 1745449 */     GIR_EraseRootFromParent_Done,
     /* 1745450 */   // Label 23700: @1745450
     /* 1745450 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1745536), // Rule ID 13292 //
     /* 1745455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1745472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1745475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745501 */     // MIs[0] policy
     /* 1745501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745511 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1745514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745535 */     // GIR_Coverage, 13292,
     /* 1745535 */     GIR_EraseRootFromParent_Done,
     /* 1745536 */   // Label 23701: @1745536
     /* 1745536 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1745622), // Rule ID 13293 //
     /* 1745541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1745558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1745561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745587 */     // MIs[0] policy
     /* 1745587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1745600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745621 */     // GIR_Coverage, 13293,
     /* 1745621 */     GIR_EraseRootFromParent_Done,
     /* 1745622 */   // Label 23702: @1745622
     /* 1745622 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1745708), // Rule ID 13296 //
     /* 1745627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1745647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745673 */     // MIs[0] policy
     /* 1745673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745683 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1745686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745707 */     // GIR_Coverage, 13296,
     /* 1745707 */     GIR_EraseRootFromParent_Done,
     /* 1745708 */   // Label 23703: @1745708
     /* 1745708 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1745794), // Rule ID 13297 //
     /* 1745713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1745733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745759 */     // MIs[0] policy
     /* 1745759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745769 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1745772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745793 */     // GIR_Coverage, 13297,
     /* 1745793 */     GIR_EraseRootFromParent_Done,
     /* 1745794 */   // Label 23704: @1745794
     /* 1745794 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1745880), // Rule ID 13300 //
     /* 1745799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1745819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745845 */     // MIs[0] policy
     /* 1745845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745855 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1745858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745879 */     // GIR_Coverage, 13300,
     /* 1745879 */     GIR_EraseRootFromParent_Done,
     /* 1745880 */   // Label 23705: @1745880
     /* 1745880 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1745966), // Rule ID 13301 //
     /* 1745885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1745905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745931 */     // MIs[0] policy
     /* 1745931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1745944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1745948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745965 */     // GIR_Coverage, 13301,
     /* 1745965 */     GIR_EraseRootFromParent_Done,
     /* 1745966 */   // Label 23706: @1745966
     /* 1745966 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1746052), // Rule ID 13304 //
     /* 1745971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1745979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1745982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1745985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1745988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1745991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746017 */     // MIs[0] policy
     /* 1746017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1746030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746051 */     // GIR_Coverage, 13304,
     /* 1746051 */     GIR_EraseRootFromParent_Done,
     /* 1746052 */   // Label 23707: @1746052
     /* 1746052 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1746138), // Rule ID 13305 //
     /* 1746057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1746068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1746071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1746074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1746077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746103 */     // MIs[0] policy
     /* 1746103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746113 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1746116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746137 */     // GIR_Coverage, 13305,
     /* 1746137 */     GIR_EraseRootFromParent_Done,
     /* 1746138 */   // Label 23708: @1746138
     /* 1746138 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1746224), // Rule ID 13308 //
     /* 1746143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1746154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1746157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1746160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1746163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746189 */     // MIs[0] policy
     /* 1746189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1746202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746223 */     // GIR_Coverage, 13308,
     /* 1746223 */     GIR_EraseRootFromParent_Done,
     /* 1746224 */   // Label 23709: @1746224
     /* 1746224 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1746310), // Rule ID 13309 //
     /* 1746229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1746240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1746243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1746246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1746249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746275 */     // MIs[0] policy
     /* 1746275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1746288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746309 */     // GIR_Coverage, 13309,
     /* 1746309 */     GIR_EraseRootFromParent_Done,
     /* 1746310 */   // Label 23710: @1746310
     /* 1746310 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1746396), // Rule ID 13312 //
     /* 1746315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1746332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1746335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746361 */     // MIs[0] policy
     /* 1746361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1746374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746395 */     // GIR_Coverage, 13312,
     /* 1746395 */     GIR_EraseRootFromParent_Done,
     /* 1746396 */   // Label 23711: @1746396
     /* 1746396 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1746482), // Rule ID 13313 //
     /* 1746401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1746418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1746421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746447 */     // MIs[0] policy
     /* 1746447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1746460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746481 */     // GIR_Coverage, 13313,
     /* 1746481 */     GIR_EraseRootFromParent_Done,
     /* 1746482 */   // Label 23712: @1746482
     /* 1746482 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1746568), // Rule ID 13316 //
     /* 1746487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1746504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1746507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746533 */     // MIs[0] policy
     /* 1746533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1746546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746567 */     // GIR_Coverage, 13316,
     /* 1746567 */     GIR_EraseRootFromParent_Done,
     /* 1746568 */   // Label 23713: @1746568
     /* 1746568 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1746654), // Rule ID 13317 //
     /* 1746573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1746590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1746593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746619 */     // MIs[0] policy
     /* 1746619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1746632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746653 */     // GIR_Coverage, 13317,
     /* 1746653 */     GIR_EraseRootFromParent_Done,
     /* 1746654 */   // Label 23714: @1746654
     /* 1746654 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1746740), // Rule ID 13320 //
     /* 1746659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1746679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746705 */     // MIs[0] policy
     /* 1746705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1746718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746739 */     // GIR_Coverage, 13320,
     /* 1746739 */     GIR_EraseRootFromParent_Done,
     /* 1746740 */   // Label 23715: @1746740
     /* 1746740 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1746826), // Rule ID 13321 //
     /* 1746745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1746765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746791 */     // MIs[0] policy
     /* 1746791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1746804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746825 */     // GIR_Coverage, 13321,
     /* 1746825 */     GIR_EraseRootFromParent_Done,
     /* 1746826 */   // Label 23716: @1746826
     /* 1746826 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1746912), // Rule ID 13324 //
     /* 1746831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1746834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1746842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1746845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1746848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1746851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746877 */     // MIs[0] policy
     /* 1746877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746887 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1746890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746911 */     // GIR_Coverage, 13324,
     /* 1746911 */     GIR_EraseRootFromParent_Done,
     /* 1746912 */   // Label 23717: @1746912
     /* 1746912 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1746998), // Rule ID 13325 //
     /* 1746917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1746920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1746925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1746928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1746931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1746934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1746937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746963 */     // MIs[0] policy
     /* 1746963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1746976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1746980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746997 */     // GIR_Coverage, 13325,
     /* 1746997 */     GIR_EraseRootFromParent_Done,
     /* 1746998 */   // Label 23718: @1746998
     /* 1746998 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1747084), // Rule ID 13328 //
     /* 1747003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1747006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1747014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1747017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1747020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1747023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1747033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747049 */     // MIs[0] policy
     /* 1747049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1747062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747083 */     // GIR_Coverage, 13328,
     /* 1747083 */     GIR_EraseRootFromParent_Done,
     /* 1747084 */   // Label 23719: @1747084
     /* 1747084 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1747170), // Rule ID 13329 //
     /* 1747089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1747092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1747100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1747103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1747106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1747109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1747119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747135 */     // MIs[0] policy
     /* 1747135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1747148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747169 */     // GIR_Coverage, 13329,
     /* 1747169 */     GIR_EraseRootFromParent_Done,
     /* 1747170 */   // Label 23720: @1747170
     /* 1747170 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1747256), // Rule ID 13332 //
     /* 1747175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1747178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1747186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1747189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1747192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1747195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747221 */     // MIs[0] policy
     /* 1747221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1747234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747255 */     // GIR_Coverage, 13332,
     /* 1747255 */     GIR_EraseRootFromParent_Done,
     /* 1747256 */   // Label 23721: @1747256
     /* 1747256 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1747342), // Rule ID 13333 //
     /* 1747261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1747264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1747272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1747275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1747278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1747281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747307 */     // MIs[0] policy
     /* 1747307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747317 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1747320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747341 */     // GIR_Coverage, 13333,
     /* 1747341 */     GIR_EraseRootFromParent_Done,
     /* 1747342 */   // Label 23722: @1747342
     /* 1747342 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1747428), // Rule ID 13336 //
     /* 1747347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1747350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1747364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1747367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747393 */     // MIs[0] policy
     /* 1747393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747403 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1747406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747427 */     // GIR_Coverage, 13336,
     /* 1747427 */     GIR_EraseRootFromParent_Done,
     /* 1747428 */   // Label 23723: @1747428
     /* 1747428 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1747514), // Rule ID 13337 //
     /* 1747433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1747436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1747450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1747453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747479 */     // MIs[0] policy
     /* 1747479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1747492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747513 */     // GIR_Coverage, 13337,
     /* 1747513 */     GIR_EraseRootFromParent_Done,
     /* 1747514 */   // Label 23724: @1747514
     /* 1747514 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1747600), // Rule ID 13340 //
     /* 1747519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1747536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747565 */     // MIs[0] policy
     /* 1747565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747575 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1747578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747599 */     // GIR_Coverage, 13340,
     /* 1747599 */     GIR_EraseRootFromParent_Done,
     /* 1747600 */   // Label 23725: @1747600
     /* 1747600 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1747686), // Rule ID 13341 //
     /* 1747605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1747622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747651 */     // MIs[0] policy
     /* 1747651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747661 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1747664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747685 */     // GIR_Coverage, 13341,
     /* 1747685 */     GIR_EraseRootFromParent_Done,
     /* 1747686 */   // Label 23726: @1747686
     /* 1747686 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1747772), // Rule ID 13344 //
     /* 1747691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1747708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747737 */     // MIs[0] policy
     /* 1747737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747747 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1747750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747771 */     // GIR_Coverage, 13344,
     /* 1747771 */     GIR_EraseRootFromParent_Done,
     /* 1747772 */   // Label 23727: @1747772
     /* 1747772 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1747858), // Rule ID 13345 //
     /* 1747777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1747794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747823 */     // MIs[0] policy
     /* 1747823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1747836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747857 */     // GIR_Coverage, 13345,
     /* 1747857 */     GIR_EraseRootFromParent_Done,
     /* 1747858 */   // Label 23728: @1747858
     /* 1747858 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1747944), // Rule ID 13348 //
     /* 1747863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1747874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1747877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1747880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747909 */     // MIs[0] policy
     /* 1747909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1747922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1747926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747943 */     // GIR_Coverage, 13348,
     /* 1747943 */     GIR_EraseRootFromParent_Done,
     /* 1747944 */   // Label 23729: @1747944
     /* 1747944 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1748030), // Rule ID 13349 //
     /* 1747949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1747957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1747960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1747963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1747966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747995 */     // MIs[0] policy
     /* 1747995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748005 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1748008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748029 */     // GIR_Coverage, 13349,
     /* 1748029 */     GIR_EraseRootFromParent_Done,
     /* 1748030 */   // Label 23730: @1748030
     /* 1748030 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1748116), // Rule ID 13352 //
     /* 1748035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748081 */     // MIs[0] policy
     /* 1748081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1748094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748115 */     // GIR_Coverage, 13352,
     /* 1748115 */     GIR_EraseRootFromParent_Done,
     /* 1748116 */   // Label 23731: @1748116
     /* 1748116 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1748202), // Rule ID 13353 //
     /* 1748121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748167 */     // MIs[0] policy
     /* 1748167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1748180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748201 */     // GIR_Coverage, 13353,
     /* 1748201 */     GIR_EraseRootFromParent_Done,
     /* 1748202 */   // Label 23732: @1748202
     /* 1748202 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1748288), // Rule ID 13356 //
     /* 1748207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1748218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1748221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748253 */     // MIs[0] policy
     /* 1748253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748263 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1748266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748287 */     // GIR_Coverage, 13356,
     /* 1748287 */     GIR_EraseRootFromParent_Done,
     /* 1748288 */   // Label 23733: @1748288
     /* 1748288 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1748374), // Rule ID 13357 //
     /* 1748293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1748304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1748307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748339 */     // MIs[0] policy
     /* 1748339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1748352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748373 */     // GIR_Coverage, 13357,
     /* 1748373 */     GIR_EraseRootFromParent_Done,
     /* 1748374 */   // Label 23734: @1748374
     /* 1748374 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1748460), // Rule ID 13360 //
     /* 1748379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1748390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1748393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748425 */     // MIs[0] policy
     /* 1748425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748435 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1748438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748459 */     // GIR_Coverage, 13360,
     /* 1748459 */     GIR_EraseRootFromParent_Done,
     /* 1748460 */   // Label 23735: @1748460
     /* 1748460 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1748546), // Rule ID 13361 //
     /* 1748465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1748476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1748479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748511 */     // MIs[0] policy
     /* 1748511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1748524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748545 */     // GIR_Coverage, 13361,
     /* 1748545 */     GIR_EraseRootFromParent_Done,
     /* 1748546 */   // Label 23736: @1748546
     /* 1748546 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1748632), // Rule ID 13364 //
     /* 1748551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1748571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748597 */     // MIs[0] policy
     /* 1748597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748607 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1748610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748631 */     // GIR_Coverage, 13364,
     /* 1748631 */     GIR_EraseRootFromParent_Done,
     /* 1748632 */   // Label 23737: @1748632
     /* 1748632 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1748718), // Rule ID 13365 //
     /* 1748637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1748657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748683 */     // MIs[0] policy
     /* 1748683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1748696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748717 */     // GIR_Coverage, 13365,
     /* 1748717 */     GIR_EraseRootFromParent_Done,
     /* 1748718 */   // Label 23738: @1748718
     /* 1748718 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1748804), // Rule ID 13368 //
     /* 1748723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748769 */     // MIs[0] policy
     /* 1748769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748779 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1748782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748803 */     // GIR_Coverage, 13368,
     /* 1748803 */     GIR_EraseRootFromParent_Done,
     /* 1748804 */   // Label 23739: @1748804
     /* 1748804 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1748890), // Rule ID 13369 //
     /* 1748809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748855 */     // MIs[0] policy
     /* 1748855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1748868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748889 */     // GIR_Coverage, 13369,
     /* 1748889 */     GIR_EraseRootFromParent_Done,
     /* 1748890 */   // Label 23740: @1748890
     /* 1748890 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1748976), // Rule ID 13372 //
     /* 1748895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1748906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1748909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1748912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748941 */     // MIs[0] policy
     /* 1748941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1748954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1748958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748975 */     // GIR_Coverage, 13372,
     /* 1748975 */     GIR_EraseRootFromParent_Done,
     /* 1748976 */   // Label 23741: @1748976
     /* 1748976 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1749062), // Rule ID 13373 //
     /* 1748981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1748989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1748992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1748995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1748998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1749001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749027 */     // MIs[0] policy
     /* 1749027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1749040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749061 */     // GIR_Coverage, 13373,
     /* 1749061 */     GIR_EraseRootFromParent_Done,
     /* 1749062 */   // Label 23742: @1749062
     /* 1749062 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1749148), // Rule ID 13376 //
     /* 1749067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749113 */     // MIs[0] policy
     /* 1749113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749123 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1749126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749147 */     // GIR_Coverage, 13376,
     /* 1749147 */     GIR_EraseRootFromParent_Done,
     /* 1749148 */   // Label 23743: @1749148
     /* 1749148 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1749234), // Rule ID 13377 //
     /* 1749153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1749170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749199 */     // MIs[0] policy
     /* 1749199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1749212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749233 */     // GIR_Coverage, 13377,
     /* 1749233 */     GIR_EraseRootFromParent_Done,
     /* 1749234 */   // Label 23744: @1749234
     /* 1749234 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1749320), // Rule ID 13380 //
     /* 1749239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749285 */     // MIs[0] policy
     /* 1749285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749295 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1749298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749319 */     // GIR_Coverage, 13380,
     /* 1749319 */     GIR_EraseRootFromParent_Done,
     /* 1749320 */   // Label 23745: @1749320
     /* 1749320 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1749406), // Rule ID 13381 //
     /* 1749325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1749342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749371 */     // MIs[0] policy
     /* 1749371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749381 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1749384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749405 */     // GIR_Coverage, 13381,
     /* 1749405 */     GIR_EraseRootFromParent_Done,
     /* 1749406 */   // Label 23746: @1749406
     /* 1749406 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1749492), // Rule ID 13384 //
     /* 1749411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1749414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1749422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1749425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1749431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749457 */     // MIs[0] policy
     /* 1749457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749467 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1749470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749491 */     // GIR_Coverage, 13384,
     /* 1749491 */     GIR_EraseRootFromParent_Done,
     /* 1749492 */   // Label 23747: @1749492
     /* 1749492 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1749578), // Rule ID 13385 //
     /* 1749497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1749500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1749508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1749511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1749514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1749517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749543 */     // MIs[0] policy
     /* 1749543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1749556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749577 */     // GIR_Coverage, 13385,
     /* 1749577 */     GIR_EraseRootFromParent_Done,
     /* 1749578 */   // Label 23748: @1749578
     /* 1749578 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1749664), // Rule ID 13388 //
     /* 1749583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1749586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1749594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1749597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1749603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749629 */     // MIs[0] policy
     /* 1749629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1749642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749663 */     // GIR_Coverage, 13388,
     /* 1749663 */     GIR_EraseRootFromParent_Done,
     /* 1749664 */   // Label 23749: @1749664
     /* 1749664 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1749750), // Rule ID 13389 //
     /* 1749669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1749672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1749680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1749683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1749686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1749689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749715 */     // MIs[0] policy
     /* 1749715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1749728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749749 */     // GIR_Coverage, 13389,
     /* 1749749 */     GIR_EraseRootFromParent_Done,
     /* 1749750 */   // Label 23750: @1749750
     /* 1749750 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1749836), // Rule ID 13392 //
     /* 1749755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1749758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1749766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1749769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749801 */     // MIs[0] policy
     /* 1749801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1749814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749835 */     // GIR_Coverage, 13392,
     /* 1749835 */     GIR_EraseRootFromParent_Done,
     /* 1749836 */   // Label 23751: @1749836
     /* 1749836 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1749922), // Rule ID 13393 //
     /* 1749841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1749844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1749852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1749855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1749858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749887 */     // MIs[0] policy
     /* 1749887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749897 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1749900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749921 */     // GIR_Coverage, 13393,
     /* 1749921 */     GIR_EraseRootFromParent_Done,
     /* 1749922 */   // Label 23752: @1749922
     /* 1749922 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1750008), // Rule ID 13396 //
     /* 1749927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1749930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1749935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1749938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1749941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1749944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749973 */     // MIs[0] policy
     /* 1749973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1749986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1749990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750007 */     // GIR_Coverage, 13396,
     /* 1750007 */     GIR_EraseRootFromParent_Done,
     /* 1750008 */   // Label 23753: @1750008
     /* 1750008 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1750094), // Rule ID 13397 //
     /* 1750013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1750016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1750021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1750024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1750027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1750030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1750033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750059 */     // MIs[0] policy
     /* 1750059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1750072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750093 */     // GIR_Coverage, 13397,
     /* 1750093 */     GIR_EraseRootFromParent_Done,
     /* 1750094 */   // Label 23754: @1750094
     /* 1750094 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1750180), // Rule ID 13400 //
     /* 1750099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750145 */     // MIs[0] policy
     /* 1750145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750155 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1750158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750179 */     // GIR_Coverage, 13400,
     /* 1750179 */     GIR_EraseRootFromParent_Done,
     /* 1750180 */   // Label 23755: @1750180
     /* 1750180 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1750266), // Rule ID 13401 //
     /* 1750185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750231 */     // MIs[0] policy
     /* 1750231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1750244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750265 */     // GIR_Coverage, 13401,
     /* 1750265 */     GIR_EraseRootFromParent_Done,
     /* 1750266 */   // Label 23756: @1750266
     /* 1750266 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1750352), // Rule ID 13404 //
     /* 1750271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1750291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750317 */     // MIs[0] policy
     /* 1750317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1750330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750351 */     // GIR_Coverage, 13404,
     /* 1750351 */     GIR_EraseRootFromParent_Done,
     /* 1750352 */   // Label 23757: @1750352
     /* 1750352 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1750438), // Rule ID 13405 //
     /* 1750357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1750377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750403 */     // MIs[0] policy
     /* 1750403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1750416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750437 */     // GIR_Coverage, 13405,
     /* 1750437 */     GIR_EraseRootFromParent_Done,
     /* 1750438 */   // Label 23758: @1750438
     /* 1750438 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1750524), // Rule ID 13408 //
     /* 1750443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1750454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1750457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1750463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750489 */     // MIs[0] policy
     /* 1750489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1750502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750523 */     // GIR_Coverage, 13408,
     /* 1750523 */     GIR_EraseRootFromParent_Done,
     /* 1750524 */   // Label 23759: @1750524
     /* 1750524 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1750610), // Rule ID 13409 //
     /* 1750529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1750540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1750543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1750549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750575 */     // MIs[0] policy
     /* 1750575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750585 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1750588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750609 */     // GIR_Coverage, 13409,
     /* 1750609 */     GIR_EraseRootFromParent_Done,
     /* 1750610 */   // Label 23760: @1750610
     /* 1750610 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1750696), // Rule ID 13412 //
     /* 1750615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1750626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1750629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1750632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1750635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750661 */     // MIs[0] policy
     /* 1750661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1750674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750695 */     // GIR_Coverage, 13412,
     /* 1750695 */     GIR_EraseRootFromParent_Done,
     /* 1750696 */   // Label 23761: @1750696
     /* 1750696 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1750782), // Rule ID 13413 //
     /* 1750701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1750712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1750715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1750718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1750721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750747 */     // MIs[0] policy
     /* 1750747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1750760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750781 */     // GIR_Coverage, 13413,
     /* 1750781 */     GIR_EraseRootFromParent_Done,
     /* 1750782 */   // Label 23762: @1750782
     /* 1750782 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1750868), // Rule ID 13416 //
     /* 1750787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1750798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1750801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1750804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1750807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750833 */     // MIs[0] policy
     /* 1750833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750843 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1750846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750867 */     // GIR_Coverage, 13416,
     /* 1750867 */     GIR_EraseRootFromParent_Done,
     /* 1750868 */   // Label 23763: @1750868
     /* 1750868 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1750954), // Rule ID 13417 //
     /* 1750873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1750884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1750887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1750890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1750893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750919 */     // MIs[0] policy
     /* 1750919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750929 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1750932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1750936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750953 */     // GIR_Coverage, 13417,
     /* 1750953 */     GIR_EraseRootFromParent_Done,
     /* 1750954 */   // Label 23764: @1750954
     /* 1750954 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1751040), // Rule ID 13420 //
     /* 1750959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1750967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1750970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1750973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1750976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1750979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1750982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751005 */     // MIs[0] policy
     /* 1751005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1751018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751039 */     // GIR_Coverage, 13420,
     /* 1751039 */     GIR_EraseRootFromParent_Done,
     /* 1751040 */   // Label 23765: @1751040
     /* 1751040 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1751126), // Rule ID 13421 //
     /* 1751045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1751056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1751059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1751065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751091 */     // MIs[0] policy
     /* 1751091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751101 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1751104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751125 */     // GIR_Coverage, 13421,
     /* 1751125 */     GIR_EraseRootFromParent_Done,
     /* 1751126 */   // Label 23766: @1751126
     /* 1751126 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1751212), // Rule ID 13424 //
     /* 1751131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751177 */     // MIs[0] policy
     /* 1751177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751187 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1751190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751211 */     // GIR_Coverage, 13424,
     /* 1751211 */     GIR_EraseRootFromParent_Done,
     /* 1751212 */   // Label 23767: @1751212
     /* 1751212 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1751298), // Rule ID 13425 //
     /* 1751217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751263 */     // MIs[0] policy
     /* 1751263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751273 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1751276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751297 */     // GIR_Coverage, 13425,
     /* 1751297 */     GIR_EraseRootFromParent_Done,
     /* 1751298 */   // Label 23768: @1751298
     /* 1751298 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1751384), // Rule ID 13428 //
     /* 1751303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751349 */     // MIs[0] policy
     /* 1751349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1751362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751383 */     // GIR_Coverage, 13428,
     /* 1751383 */     GIR_EraseRootFromParent_Done,
     /* 1751384 */   // Label 23769: @1751384
     /* 1751384 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1751470), // Rule ID 13429 //
     /* 1751389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751435 */     // MIs[0] policy
     /* 1751435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1751448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751469 */     // GIR_Coverage, 13429,
     /* 1751469 */     GIR_EraseRootFromParent_Done,
     /* 1751470 */   // Label 23770: @1751470
     /* 1751470 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1751556), // Rule ID 13432 //
     /* 1751475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1751486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1751489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1751495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751521 */     // MIs[0] policy
     /* 1751521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1751534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751555 */     // GIR_Coverage, 13432,
     /* 1751555 */     GIR_EraseRootFromParent_Done,
     /* 1751556 */   // Label 23771: @1751556
     /* 1751556 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1751642), // Rule ID 13433 //
     /* 1751561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1751572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1751575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1751581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751607 */     // MIs[0] policy
     /* 1751607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1751620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751641 */     // GIR_Coverage, 13433,
     /* 1751641 */     GIR_EraseRootFromParent_Done,
     /* 1751642 */   // Label 23772: @1751642
     /* 1751642 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1751728), // Rule ID 13436 //
     /* 1751647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1751658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1751661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1751664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1751667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751693 */     // MIs[0] policy
     /* 1751693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751703 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1751706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751727 */     // GIR_Coverage, 13436,
     /* 1751727 */     GIR_EraseRootFromParent_Done,
     /* 1751728 */   // Label 23773: @1751728
     /* 1751728 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1751814), // Rule ID 13437 //
     /* 1751733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1751744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1751747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1751750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1751753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751779 */     // MIs[0] policy
     /* 1751779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1751792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751813 */     // GIR_Coverage, 13437,
     /* 1751813 */     GIR_EraseRootFromParent_Done,
     /* 1751814 */   // Label 23774: @1751814
     /* 1751814 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1751900), // Rule ID 13440 //
     /* 1751819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1751830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1751833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1751836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1751839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751865 */     // MIs[0] policy
     /* 1751865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1751878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751899 */     // GIR_Coverage, 13440,
     /* 1751899 */     GIR_EraseRootFromParent_Done,
     /* 1751900 */   // Label 23775: @1751900
     /* 1751900 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1751986), // Rule ID 13441 //
     /* 1751905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1751916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1751919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1751922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1751925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751951 */     // MIs[0] policy
     /* 1751951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1751964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1751968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751985 */     // GIR_Coverage, 13441,
     /* 1751985 */     GIR_EraseRootFromParent_Done,
     /* 1751986 */   // Label 23776: @1751986
     /* 1751986 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1752072), // Rule ID 13444 //
     /* 1751991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1751994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1751999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1752002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1752005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1752008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1752011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752037 */     // MIs[0] policy
     /* 1752037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1752050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752071 */     // GIR_Coverage, 13444,
     /* 1752071 */     GIR_EraseRootFromParent_Done,
     /* 1752072 */   // Label 23777: @1752072
     /* 1752072 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1752158), // Rule ID 13445 //
     /* 1752077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1752080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1752088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1752091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1752094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1752097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752123 */     // MIs[0] policy
     /* 1752123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752133 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1752136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752157 */     // GIR_Coverage, 13445,
     /* 1752157 */     GIR_EraseRootFromParent_Done,
     /* 1752158 */   // Label 23778: @1752158
     /* 1752158 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1752244), // Rule ID 13448 //
     /* 1752163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1752166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1752174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1752177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752209 */     // MIs[0] policy
     /* 1752209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1752222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752243 */     // GIR_Coverage, 13448,
     /* 1752243 */     GIR_EraseRootFromParent_Done,
     /* 1752244 */   // Label 23779: @1752244
     /* 1752244 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1752330), // Rule ID 13449 //
     /* 1752249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1752252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1752260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1752263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752295 */     // MIs[0] policy
     /* 1752295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1752308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752329 */     // GIR_Coverage, 13449,
     /* 1752329 */     GIR_EraseRootFromParent_Done,
     /* 1752330 */   // Label 23780: @1752330
     /* 1752330 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1752416), // Rule ID 13452 //
     /* 1752335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1752338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1752346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1752349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1752355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752381 */     // MIs[0] policy
     /* 1752381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752391 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1752394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752415 */     // GIR_Coverage, 13452,
     /* 1752415 */     GIR_EraseRootFromParent_Done,
     /* 1752416 */   // Label 23781: @1752416
     /* 1752416 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1752502), // Rule ID 13453 //
     /* 1752421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1752424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1752432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1752435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1752441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752467 */     // MIs[0] policy
     /* 1752467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1752480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752501 */     // GIR_Coverage, 13453,
     /* 1752501 */     GIR_EraseRootFromParent_Done,
     /* 1752502 */   // Label 23782: @1752502
     /* 1752502 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1752588), // Rule ID 13456 //
     /* 1752507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1752510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1752518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1752521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1752527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752553 */     // MIs[0] policy
     /* 1752553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752563 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1752566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752587 */     // GIR_Coverage, 13456,
     /* 1752587 */     GIR_EraseRootFromParent_Done,
     /* 1752588 */   // Label 23783: @1752588
     /* 1752588 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1752674), // Rule ID 13457 //
     /* 1752593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1752596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1752604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1752607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1752613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752639 */     // MIs[0] policy
     /* 1752639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752649 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1752652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752673 */     // GIR_Coverage, 13457,
     /* 1752673 */     GIR_EraseRootFromParent_Done,
     /* 1752674 */   // Label 23784: @1752674
     /* 1752674 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1752760), // Rule ID 13460 //
     /* 1752679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1752690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1752693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1752696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1752699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752725 */     // MIs[0] policy
     /* 1752725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752735 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1752738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752759 */     // GIR_Coverage, 13460,
     /* 1752759 */     GIR_EraseRootFromParent_Done,
     /* 1752760 */   // Label 23785: @1752760
     /* 1752760 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1752846), // Rule ID 13461 //
     /* 1752765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1752776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1752779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1752782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1752785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752811 */     // MIs[0] policy
     /* 1752811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1752824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752845 */     // GIR_Coverage, 13461,
     /* 1752845 */     GIR_EraseRootFromParent_Done,
     /* 1752846 */   // Label 23786: @1752846
     /* 1752846 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1752932), // Rule ID 13464 //
     /* 1752851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1752862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1752865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1752868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1752871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752897 */     // MIs[0] policy
     /* 1752897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1752910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1752914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752931 */     // GIR_Coverage, 13464,
     /* 1752931 */     GIR_EraseRootFromParent_Done,
     /* 1752932 */   // Label 23787: @1752932
     /* 1752932 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1753018), // Rule ID 13465 //
     /* 1752937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1752945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1752948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1752951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1752954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1752957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752983 */     // MIs[0] policy
     /* 1752983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1752996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753017 */     // GIR_Coverage, 13465,
     /* 1753017 */     GIR_EraseRootFromParent_Done,
     /* 1753018 */   // Label 23788: @1753018
     /* 1753018 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1753104), // Rule ID 13468 //
     /* 1753023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1753034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1753037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753069 */     // MIs[0] policy
     /* 1753069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753079 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1753082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753103 */     // GIR_Coverage, 13468,
     /* 1753103 */     GIR_EraseRootFromParent_Done,
     /* 1753104 */   // Label 23789: @1753104
     /* 1753104 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1753190), // Rule ID 13469 //
     /* 1753109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1753120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1753123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753155 */     // MIs[0] policy
     /* 1753155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1753168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753189 */     // GIR_Coverage, 13469,
     /* 1753189 */     GIR_EraseRootFromParent_Done,
     /* 1753190 */   // Label 23790: @1753190
     /* 1753190 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1753276), // Rule ID 13472 //
     /* 1753195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1753206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1753209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1753215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753241 */     // MIs[0] policy
     /* 1753241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1753254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753275 */     // GIR_Coverage, 13472,
     /* 1753275 */     GIR_EraseRootFromParent_Done,
     /* 1753276 */   // Label 23791: @1753276
     /* 1753276 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1753362), // Rule ID 13473 //
     /* 1753281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1753292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1753295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1753301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753327 */     // MIs[0] policy
     /* 1753327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1753340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753361 */     // GIR_Coverage, 13473,
     /* 1753361 */     GIR_EraseRootFromParent_Done,
     /* 1753362 */   // Label 23792: @1753362
     /* 1753362 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1753448), // Rule ID 13476 //
     /* 1753367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1753378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1753381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1753387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753413 */     // MIs[0] policy
     /* 1753413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1753426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753447 */     // GIR_Coverage, 13476,
     /* 1753447 */     GIR_EraseRootFromParent_Done,
     /* 1753448 */   // Label 23793: @1753448
     /* 1753448 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1753534), // Rule ID 13477 //
     /* 1753453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1753464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1753467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1753473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753499 */     // MIs[0] policy
     /* 1753499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1753512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753533 */     // GIR_Coverage, 13477,
     /* 1753533 */     GIR_EraseRootFromParent_Done,
     /* 1753534 */   // Label 23794: @1753534
     /* 1753534 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1753620), // Rule ID 13480 //
     /* 1753539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1753559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753585 */     // MIs[0] policy
     /* 1753585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1753598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753619 */     // GIR_Coverage, 13480,
     /* 1753619 */     GIR_EraseRootFromParent_Done,
     /* 1753620 */   // Label 23795: @1753620
     /* 1753620 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1753706), // Rule ID 13481 //
     /* 1753625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1753645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753671 */     // MIs[0] policy
     /* 1753671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753681 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1753684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753705 */     // GIR_Coverage, 13481,
     /* 1753705 */     GIR_EraseRootFromParent_Done,
     /* 1753706 */   // Label 23796: @1753706
     /* 1753706 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1753792), // Rule ID 13484 //
     /* 1753711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753757 */     // MIs[0] policy
     /* 1753757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753767 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1753770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753791 */     // GIR_Coverage, 13484,
     /* 1753791 */     GIR_EraseRootFromParent_Done,
     /* 1753792 */   // Label 23797: @1753792
     /* 1753792 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1753878), // Rule ID 13485 //
     /* 1753797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753843 */     // MIs[0] policy
     /* 1753843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753853 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1753856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753877 */     // GIR_Coverage, 13485,
     /* 1753877 */     GIR_EraseRootFromParent_Done,
     /* 1753878 */   // Label 23798: @1753878
     /* 1753878 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1753964), // Rule ID 13488 //
     /* 1753883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1753894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1753897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1753900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753929 */     // MIs[0] policy
     /* 1753929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1753942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1753946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753963 */     // GIR_Coverage, 13488,
     /* 1753963 */     GIR_EraseRootFromParent_Done,
     /* 1753964 */   // Label 23799: @1753964
     /* 1753964 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1754050), // Rule ID 13489 //
     /* 1753969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1753977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1753980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1753983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1753986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754015 */     // MIs[0] policy
     /* 1754015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1754028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754049 */     // GIR_Coverage, 13489,
     /* 1754049 */     GIR_EraseRootFromParent_Done,
     /* 1754050 */   // Label 23800: @1754050
     /* 1754050 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1754136), // Rule ID 13492 //
     /* 1754055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1754066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1754069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754101 */     // MIs[0] policy
     /* 1754101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1754114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754135 */     // GIR_Coverage, 13492,
     /* 1754135 */     GIR_EraseRootFromParent_Done,
     /* 1754136 */   // Label 23801: @1754136
     /* 1754136 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1754222), // Rule ID 13493 //
     /* 1754141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1754152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1754155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1754158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754187 */     // MIs[0] policy
     /* 1754187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1754200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754221 */     // GIR_Coverage, 13493,
     /* 1754221 */     GIR_EraseRootFromParent_Done,
     /* 1754222 */   // Label 23802: @1754222
     /* 1754222 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1754308), // Rule ID 13496 //
     /* 1754227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1754238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1754241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1754247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754273 */     // MIs[0] policy
     /* 1754273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1754286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754307 */     // GIR_Coverage, 13496,
     /* 1754307 */     GIR_EraseRootFromParent_Done,
     /* 1754308 */   // Label 23803: @1754308
     /* 1754308 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1754394), // Rule ID 13497 //
     /* 1754313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1754324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1754327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1754330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1754333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754359 */     // MIs[0] policy
     /* 1754359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1754372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754393 */     // GIR_Coverage, 13497,
     /* 1754393 */     GIR_EraseRootFromParent_Done,
     /* 1754394 */   // Label 23804: @1754394
     /* 1754394 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1754480), // Rule ID 13500 //
     /* 1754399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1754410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1754413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1754419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754445 */     // MIs[0] policy
     /* 1754445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754455 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1754458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754479 */     // GIR_Coverage, 13500,
     /* 1754479 */     GIR_EraseRootFromParent_Done,
     /* 1754480 */   // Label 23805: @1754480
     /* 1754480 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1754566), // Rule ID 13501 //
     /* 1754485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1754496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1754499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1754502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1754505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754531 */     // MIs[0] policy
     /* 1754531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1754544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754565 */     // GIR_Coverage, 13501,
     /* 1754565 */     GIR_EraseRootFromParent_Done,
     /* 1754566 */   // Label 23806: @1754566
     /* 1754566 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1754652), // Rule ID 13504 //
     /* 1754571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1754574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1754582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1754585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754617 */     // MIs[0] policy
     /* 1754617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1754630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754651 */     // GIR_Coverage, 13504,
     /* 1754651 */     GIR_EraseRootFromParent_Done,
     /* 1754652 */   // Label 23807: @1754652
     /* 1754652 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1754738), // Rule ID 13505 //
     /* 1754657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1754660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1754668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1754671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1754674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754703 */     // MIs[0] policy
     /* 1754703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1754716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754737 */     // GIR_Coverage, 13505,
     /* 1754737 */     GIR_EraseRootFromParent_Done,
     /* 1754738 */   // Label 23808: @1754738
     /* 1754738 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1754824), // Rule ID 13508 //
     /* 1754743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1754746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1754754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1754757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754789 */     // MIs[0] policy
     /* 1754789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1754802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754823 */     // GIR_Coverage, 13508,
     /* 1754823 */     GIR_EraseRootFromParent_Done,
     /* 1754824 */   // Label 23809: @1754824
     /* 1754824 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1754910), // Rule ID 13509 //
     /* 1754829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1754832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1754840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1754843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1754846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754875 */     // MIs[0] policy
     /* 1754875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1754888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754909 */     // GIR_Coverage, 13509,
     /* 1754909 */     GIR_EraseRootFromParent_Done,
     /* 1754910 */   // Label 23810: @1754910
     /* 1754910 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1754996), // Rule ID 13512 //
     /* 1754915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1754918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1754923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1754926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1754929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1754932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1754935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754961 */     // MIs[0] policy
     /* 1754961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1754974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1754978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754995 */     // GIR_Coverage, 13512,
     /* 1754995 */     GIR_EraseRootFromParent_Done,
     /* 1754996 */   // Label 23811: @1754996
     /* 1754996 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1755082), // Rule ID 13513 //
     /* 1755001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1755004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1755009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1755012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1755015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1755018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755047 */     // MIs[0] policy
     /* 1755047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755057 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1755060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755081 */     // GIR_Coverage, 13513,
     /* 1755081 */     GIR_EraseRootFromParent_Done,
     /* 1755082 */   // Label 23812: @1755082
     /* 1755082 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1755168), // Rule ID 13516 //
     /* 1755087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1755090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1755095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1755098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1755101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1755104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755133 */     // MIs[0] policy
     /* 1755133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1755146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755167 */     // GIR_Coverage, 13516,
     /* 1755167 */     GIR_EraseRootFromParent_Done,
     /* 1755168 */   // Label 23813: @1755168
     /* 1755168 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1755254), // Rule ID 13517 //
     /* 1755173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1755176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1755181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1755184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1755187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1755190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755219 */     // MIs[0] policy
     /* 1755219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755229 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1755232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755253 */     // GIR_Coverage, 13517,
     /* 1755253 */     GIR_EraseRootFromParent_Done,
     /* 1755254 */   // Label 23814: @1755254
     /* 1755254 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1755340), // Rule ID 13520 //
     /* 1755259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1755270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1755273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1755276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1755279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1755282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755305 */     // MIs[0] policy
     /* 1755305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1755318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755339 */     // GIR_Coverage, 13520,
     /* 1755339 */     GIR_EraseRootFromParent_Done,
     /* 1755340 */   // Label 23815: @1755340
     /* 1755340 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1755426), // Rule ID 13521 //
     /* 1755345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1755356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1755359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1755362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1755365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1755368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755391 */     // MIs[0] policy
     /* 1755391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755401 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1755404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755425 */     // GIR_Coverage, 13521,
     /* 1755425 */     GIR_EraseRootFromParent_Done,
     /* 1755426 */   // Label 23816: @1755426
     /* 1755426 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1755512), // Rule ID 13524 //
     /* 1755431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1755442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1755445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1755448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1755451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755477 */     // MIs[0] policy
     /* 1755477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755487 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1755490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755511 */     // GIR_Coverage, 13524,
     /* 1755511 */     GIR_EraseRootFromParent_Done,
     /* 1755512 */   // Label 23817: @1755512
     /* 1755512 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1755598), // Rule ID 13525 //
     /* 1755517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1755528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1755531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1755534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1755537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755563 */     // MIs[0] policy
     /* 1755563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1755576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755597 */     // GIR_Coverage, 13525,
     /* 1755597 */     GIR_EraseRootFromParent_Done,
     /* 1755598 */   // Label 23818: @1755598
     /* 1755598 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1755684), // Rule ID 13528 //
     /* 1755603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1755620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1755623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755649 */     // MIs[0] policy
     /* 1755649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755659 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1755662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755683 */     // GIR_Coverage, 13528,
     /* 1755683 */     GIR_EraseRootFromParent_Done,
     /* 1755684 */   // Label 23819: @1755684
     /* 1755684 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1755770), // Rule ID 13529 //
     /* 1755689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1755706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1755709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755735 */     // MIs[0] policy
     /* 1755735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1755748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755769 */     // GIR_Coverage, 13529,
     /* 1755769 */     GIR_EraseRootFromParent_Done,
     /* 1755770 */   // Label 23820: @1755770
     /* 1755770 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1755856), // Rule ID 13532 //
     /* 1755775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1755792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1755795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755821 */     // MIs[0] policy
     /* 1755821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1755834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755855 */     // GIR_Coverage, 13532,
     /* 1755855 */     GIR_EraseRootFromParent_Done,
     /* 1755856 */   // Label 23821: @1755856
     /* 1755856 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1755942), // Rule ID 13533 //
     /* 1755861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1755878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1755881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755907 */     // MIs[0] policy
     /* 1755907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1755920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1755924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755941 */     // GIR_Coverage, 13533,
     /* 1755941 */     GIR_EraseRootFromParent_Done,
     /* 1755942 */   // Label 23822: @1755942
     /* 1755942 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1756028), // Rule ID 13536 //
     /* 1755947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1755955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1755967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755993 */     // MIs[0] policy
     /* 1755993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756003 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1756006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756027 */     // GIR_Coverage, 13536,
     /* 1756027 */     GIR_EraseRootFromParent_Done,
     /* 1756028 */   // Label 23823: @1756028
     /* 1756028 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1756114), // Rule ID 13537 //
     /* 1756033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1756044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1756047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1756050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1756053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756079 */     // MIs[0] policy
     /* 1756079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756089 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1756092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756113 */     // GIR_Coverage, 13537,
     /* 1756113 */     GIR_EraseRootFromParent_Done,
     /* 1756114 */   // Label 23824: @1756114
     /* 1756114 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1756200), // Rule ID 13540 //
     /* 1756119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1756136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1756139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756165 */     // MIs[0] policy
     /* 1756165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756175 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1756178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756199 */     // GIR_Coverage, 13540,
     /* 1756199 */     GIR_EraseRootFromParent_Done,
     /* 1756200 */   // Label 23825: @1756200
     /* 1756200 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1756286), // Rule ID 13541 //
     /* 1756205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1756222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1756225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756251 */     // MIs[0] policy
     /* 1756251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1756264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756285 */     // GIR_Coverage, 13541,
     /* 1756285 */     GIR_EraseRootFromParent_Done,
     /* 1756286 */   // Label 23826: @1756286
     /* 1756286 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1756372), // Rule ID 13544 //
     /* 1756291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1756302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1756305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1756311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756337 */     // MIs[0] policy
     /* 1756337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756347 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1756350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756371 */     // GIR_Coverage, 13544,
     /* 1756371 */     GIR_EraseRootFromParent_Done,
     /* 1756372 */   // Label 23827: @1756372
     /* 1756372 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1756458), // Rule ID 13545 //
     /* 1756377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1756388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1756391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1756397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756423 */     // MIs[0] policy
     /* 1756423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1756436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756457 */     // GIR_Coverage, 13545,
     /* 1756457 */     GIR_EraseRootFromParent_Done,
     /* 1756458 */   // Label 23828: @1756458
     /* 1756458 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1756544), // Rule ID 13548 //
     /* 1756463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1756474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1756477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1756483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756509 */     // MIs[0] policy
     /* 1756509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1756522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756543 */     // GIR_Coverage, 13548,
     /* 1756543 */     GIR_EraseRootFromParent_Done,
     /* 1756544 */   // Label 23829: @1756544
     /* 1756544 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1756630), // Rule ID 13549 //
     /* 1756549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1756560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1756563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1756569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756595 */     // MIs[0] policy
     /* 1756595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1756608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756629 */     // GIR_Coverage, 13549,
     /* 1756629 */     GIR_EraseRootFromParent_Done,
     /* 1756630 */   // Label 23830: @1756630
     /* 1756630 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1756716), // Rule ID 13552 //
     /* 1756635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1756652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1756655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756681 */     // MIs[0] policy
     /* 1756681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1756694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756715 */     // GIR_Coverage, 13552,
     /* 1756715 */     GIR_EraseRootFromParent_Done,
     /* 1756716 */   // Label 23831: @1756716
     /* 1756716 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1756802), // Rule ID 13553 //
     /* 1756721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1756738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1756741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756767 */     // MIs[0] policy
     /* 1756767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1756780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756801 */     // GIR_Coverage, 13553,
     /* 1756801 */     GIR_EraseRootFromParent_Done,
     /* 1756802 */   // Label 23832: @1756802
     /* 1756802 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1756888), // Rule ID 13556 //
     /* 1756807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1756824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1756827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756853 */     // MIs[0] policy
     /* 1756853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756863 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1756866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756887 */     // GIR_Coverage, 13556,
     /* 1756887 */     GIR_EraseRootFromParent_Done,
     /* 1756888 */   // Label 23833: @1756888
     /* 1756888 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1756974), // Rule ID 13557 //
     /* 1756893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1756910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1756913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756939 */     // MIs[0] policy
     /* 1756939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1756952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1756956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756973 */     // GIR_Coverage, 13557,
     /* 1756973 */     GIR_EraseRootFromParent_Done,
     /* 1756974 */   // Label 23834: @1756974
     /* 1756974 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1757060), // Rule ID 13560 //
     /* 1756979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1756987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1756996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1756999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757025 */     // MIs[0] policy
     /* 1757025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757035 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1757038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757059 */     // GIR_Coverage, 13560,
     /* 1757059 */     GIR_EraseRootFromParent_Done,
     /* 1757060 */   // Label 23835: @1757060
     /* 1757060 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1757146), // Rule ID 13561 //
     /* 1757065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1757076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1757079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1757082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1757085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757111 */     // MIs[0] policy
     /* 1757111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1757124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757145 */     // GIR_Coverage, 13561,
     /* 1757145 */     GIR_EraseRootFromParent_Done,
     /* 1757146 */   // Label 23836: @1757146
     /* 1757146 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1757232), // Rule ID 13564 //
     /* 1757151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1757154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1757162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1757165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757197 */     // MIs[0] policy
     /* 1757197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757207 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1757210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757231 */     // GIR_Coverage, 13564,
     /* 1757231 */     GIR_EraseRootFromParent_Done,
     /* 1757232 */   // Label 23837: @1757232
     /* 1757232 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1757318), // Rule ID 13565 //
     /* 1757237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1757240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1757248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1757251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757283 */     // MIs[0] policy
     /* 1757283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1757296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757317 */     // GIR_Coverage, 13565,
     /* 1757317 */     GIR_EraseRootFromParent_Done,
     /* 1757318 */   // Label 23838: @1757318
     /* 1757318 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1757404), // Rule ID 13568 //
     /* 1757323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1757326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1757334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1757337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1757343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757369 */     // MIs[0] policy
     /* 1757369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1757382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757403 */     // GIR_Coverage, 13568,
     /* 1757403 */     GIR_EraseRootFromParent_Done,
     /* 1757404 */   // Label 23839: @1757404
     /* 1757404 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1757490), // Rule ID 13569 //
     /* 1757409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1757412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1757420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1757423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1757429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757455 */     // MIs[0] policy
     /* 1757455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1757468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757489 */     // GIR_Coverage, 13569,
     /* 1757489 */     GIR_EraseRootFromParent_Done,
     /* 1757490 */   // Label 23840: @1757490
     /* 1757490 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1757576), // Rule ID 13572 //
     /* 1757495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1757498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1757506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1757509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1757512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1757515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757541 */     // MIs[0] policy
     /* 1757541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1757554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757575 */     // GIR_Coverage, 13572,
     /* 1757575 */     GIR_EraseRootFromParent_Done,
     /* 1757576 */   // Label 23841: @1757576
     /* 1757576 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1757662), // Rule ID 13573 //
     /* 1757581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1757584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1757592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1757595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1757598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1757601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757627 */     // MIs[0] policy
     /* 1757627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757637 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1757640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757661 */     // GIR_Coverage, 13573,
     /* 1757661 */     GIR_EraseRootFromParent_Done,
     /* 1757662 */   // Label 23842: @1757662
     /* 1757662 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1757748), // Rule ID 13576 //
     /* 1757667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1757670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1757678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1757681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1757684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1757687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757713 */     // MIs[0] policy
     /* 1757713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757723 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1757726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757747 */     // GIR_Coverage, 13576,
     /* 1757747 */     GIR_EraseRootFromParent_Done,
     /* 1757748 */   // Label 23843: @1757748
     /* 1757748 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1757834), // Rule ID 13577 //
     /* 1757753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1757756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1757764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1757767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1757770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1757773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757799 */     // MIs[0] policy
     /* 1757799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757809 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1757812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757833 */     // GIR_Coverage, 13577,
     /* 1757833 */     GIR_EraseRootFromParent_Done,
     /* 1757834 */   // Label 23844: @1757834
     /* 1757834 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1757920), // Rule ID 13580 //
     /* 1757839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1757856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1757859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757885 */     // MIs[0] policy
     /* 1757885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757895 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1757898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757919 */     // GIR_Coverage, 13580,
     /* 1757919 */     GIR_EraseRootFromParent_Done,
     /* 1757920 */   // Label 23845: @1757920
     /* 1757920 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1758006), // Rule ID 13581 //
     /* 1757925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1757933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1757942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1757945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757971 */     // MIs[0] policy
     /* 1757971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757981 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1757984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1757988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758005 */     // GIR_Coverage, 13581,
     /* 1758005 */     GIR_EraseRootFromParent_Done,
     /* 1758006 */   // Label 23846: @1758006
     /* 1758006 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1758092), // Rule ID 13584 //
     /* 1758011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1758022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1758025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1758031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758057 */     // MIs[0] policy
     /* 1758057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758067 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1758070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758091 */     // GIR_Coverage, 13584,
     /* 1758091 */     GIR_EraseRootFromParent_Done,
     /* 1758092 */   // Label 23847: @1758092
     /* 1758092 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1758178), // Rule ID 13585 //
     /* 1758097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1758108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1758111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1758117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758143 */     // MIs[0] policy
     /* 1758143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758153 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1758156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758177 */     // GIR_Coverage, 13585,
     /* 1758177 */     GIR_EraseRootFromParent_Done,
     /* 1758178 */   // Label 23848: @1758178
     /* 1758178 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1758264), // Rule ID 13588 //
     /* 1758183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1758203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758229 */     // MIs[0] policy
     /* 1758229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1758242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758263 */     // GIR_Coverage, 13588,
     /* 1758263 */     GIR_EraseRootFromParent_Done,
     /* 1758264 */   // Label 23849: @1758264
     /* 1758264 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1758350), // Rule ID 13589 //
     /* 1758269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1758289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758315 */     // MIs[0] policy
     /* 1758315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758325 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1758328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758349 */     // GIR_Coverage, 13589,
     /* 1758349 */     GIR_EraseRootFromParent_Done,
     /* 1758350 */   // Label 23850: @1758350
     /* 1758350 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1758436), // Rule ID 13592 //
     /* 1758355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1758375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758401 */     // MIs[0] policy
     /* 1758401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758411 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1758414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758435 */     // GIR_Coverage, 13592,
     /* 1758435 */     GIR_EraseRootFromParent_Done,
     /* 1758436 */   // Label 23851: @1758436
     /* 1758436 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1758522), // Rule ID 13593 //
     /* 1758441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1758461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758487 */     // MIs[0] policy
     /* 1758487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758497 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1758500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758521 */     // GIR_Coverage, 13593,
     /* 1758521 */     GIR_EraseRootFromParent_Done,
     /* 1758522 */   // Label 23852: @1758522
     /* 1758522 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1758608), // Rule ID 13596 //
     /* 1758527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758573 */     // MIs[0] policy
     /* 1758573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758583 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1758586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758607 */     // GIR_Coverage, 13596,
     /* 1758607 */     GIR_EraseRootFromParent_Done,
     /* 1758608 */   // Label 23853: @1758608
     /* 1758608 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1758694), // Rule ID 13597 //
     /* 1758613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758659 */     // MIs[0] policy
     /* 1758659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758669 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1758672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758693 */     // GIR_Coverage, 13597,
     /* 1758693 */     GIR_EraseRootFromParent_Done,
     /* 1758694 */   // Label 23854: @1758694
     /* 1758694 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1758780), // Rule ID 13600 //
     /* 1758699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758745 */     // MIs[0] policy
     /* 1758745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758755 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1758758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758779 */     // GIR_Coverage, 13600,
     /* 1758779 */     GIR_EraseRootFromParent_Done,
     /* 1758780 */   // Label 23855: @1758780
     /* 1758780 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1758866), // Rule ID 13601 //
     /* 1758785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758831 */     // MIs[0] policy
     /* 1758831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758841 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1758844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758865 */     // GIR_Coverage, 13601,
     /* 1758865 */     GIR_EraseRootFromParent_Done,
     /* 1758866 */   // Label 23856: @1758866
     /* 1758866 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1758952), // Rule ID 13604 //
     /* 1758871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1758882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1758885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1758888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1758891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1758894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758917 */     // MIs[0] policy
     /* 1758917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1758930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1758934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758951 */     // GIR_Coverage, 13604,
     /* 1758951 */     GIR_EraseRootFromParent_Done,
     /* 1758952 */   // Label 23857: @1758952
     /* 1758952 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1759038), // Rule ID 13605 //
     /* 1758957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1758965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1758968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1758971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1758974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1758977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1758980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759003 */     // MIs[0] policy
     /* 1759003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759013 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1759016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759037 */     // GIR_Coverage, 13605,
     /* 1759037 */     GIR_EraseRootFromParent_Done,
     /* 1759038 */   // Label 23858: @1759038
     /* 1759038 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1759124), // Rule ID 13608 //
     /* 1759043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1759054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1759057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1759063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759089 */     // MIs[0] policy
     /* 1759089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1759102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759123 */     // GIR_Coverage, 13608,
     /* 1759123 */     GIR_EraseRootFromParent_Done,
     /* 1759124 */   // Label 23859: @1759124
     /* 1759124 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1759210), // Rule ID 13609 //
     /* 1759129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1759140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1759143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1759146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1759149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759175 */     // MIs[0] policy
     /* 1759175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759185 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1759188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759209 */     // GIR_Coverage, 13609,
     /* 1759209 */     GIR_EraseRootFromParent_Done,
     /* 1759210 */   // Label 23860: @1759210
     /* 1759210 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1759296), // Rule ID 13612 //
     /* 1759215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1759235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759261 */     // MIs[0] policy
     /* 1759261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1759274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759295 */     // GIR_Coverage, 13612,
     /* 1759295 */     GIR_EraseRootFromParent_Done,
     /* 1759296 */   // Label 23861: @1759296
     /* 1759296 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1759382), // Rule ID 13613 //
     /* 1759301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1759318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1759321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759347 */     // MIs[0] policy
     /* 1759347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1759360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759381 */     // GIR_Coverage, 13613,
     /* 1759381 */     GIR_EraseRootFromParent_Done,
     /* 1759382 */   // Label 23862: @1759382
     /* 1759382 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1759468), // Rule ID 13616 //
     /* 1759387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1759407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759433 */     // MIs[0] policy
     /* 1759433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1759446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759467 */     // GIR_Coverage, 13616,
     /* 1759467 */     GIR_EraseRootFromParent_Done,
     /* 1759468 */   // Label 23863: @1759468
     /* 1759468 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1759554), // Rule ID 13617 //
     /* 1759473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1759490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1759493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759519 */     // MIs[0] policy
     /* 1759519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1759532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759553 */     // GIR_Coverage, 13617,
     /* 1759553 */     GIR_EraseRootFromParent_Done,
     /* 1759554 */   // Label 23864: @1759554
     /* 1759554 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1759640), // Rule ID 13620 //
     /* 1759559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759605 */     // MIs[0] policy
     /* 1759605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1759618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759639 */     // GIR_Coverage, 13620,
     /* 1759639 */     GIR_EraseRootFromParent_Done,
     /* 1759640 */   // Label 23865: @1759640
     /* 1759640 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1759726), // Rule ID 13621 //
     /* 1759645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1759662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759691 */     // MIs[0] policy
     /* 1759691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1759704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759725 */     // GIR_Coverage, 13621,
     /* 1759725 */     GIR_EraseRootFromParent_Done,
     /* 1759726 */   // Label 23866: @1759726
     /* 1759726 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1759812), // Rule ID 13624 //
     /* 1759731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1759734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1759742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1759745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1759751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759777 */     // MIs[0] policy
     /* 1759777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759787 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1759790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759811 */     // GIR_Coverage, 13624,
     /* 1759811 */     GIR_EraseRootFromParent_Done,
     /* 1759812 */   // Label 23867: @1759812
     /* 1759812 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1759898), // Rule ID 13625 //
     /* 1759817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1759820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1759828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1759831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1759834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1759837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759863 */     // MIs[0] policy
     /* 1759863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1759876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759897 */     // GIR_Coverage, 13625,
     /* 1759897 */     GIR_EraseRootFromParent_Done,
     /* 1759898 */   // Label 23868: @1759898
     /* 1759898 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1759984), // Rule ID 13628 //
     /* 1759903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1759906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1759914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1759917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1759920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1759923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759949 */     // MIs[0] policy
     /* 1759949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1759962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1759966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759983 */     // GIR_Coverage, 13628,
     /* 1759983 */     GIR_EraseRootFromParent_Done,
     /* 1759984 */   // Label 23869: @1759984
     /* 1759984 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1760070), // Rule ID 13629 //
     /* 1759989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1759992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1759997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1760000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1760003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1760009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760035 */     // MIs[0] policy
     /* 1760035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1760048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760069 */     // GIR_Coverage, 13629,
     /* 1760069 */     GIR_EraseRootFromParent_Done,
     /* 1760070 */   // Label 23870: @1760070
     /* 1760070 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1760156), // Rule ID 13632 //
     /* 1760075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1760078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1760083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1760086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1760089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1760095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1760105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760121 */     // MIs[0] policy
     /* 1760121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760131 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1760134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760155 */     // GIR_Coverage, 13632,
     /* 1760155 */     GIR_EraseRootFromParent_Done,
     /* 1760156 */   // Label 23871: @1760156
     /* 1760156 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1760242), // Rule ID 13633 //
     /* 1760161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1760164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1760169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1760172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1760175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1760181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1760191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760207 */     // MIs[0] policy
     /* 1760207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760217 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1760220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760241 */     // GIR_Coverage, 13633,
     /* 1760241 */     GIR_EraseRootFromParent_Done,
     /* 1760242 */   // Label 23872: @1760242
     /* 1760242 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1760328), // Rule ID 13636 //
     /* 1760247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1760250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1760255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1760267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760293 */     // MIs[0] policy
     /* 1760293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760303 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1760306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760327 */     // GIR_Coverage, 13636,
     /* 1760327 */     GIR_EraseRootFromParent_Done,
     /* 1760328 */   // Label 23873: @1760328
     /* 1760328 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1760414), // Rule ID 13637 //
     /* 1760333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1760336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1760341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1760353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760379 */     // MIs[0] policy
     /* 1760379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1760392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760413 */     // GIR_Coverage, 13637,
     /* 1760413 */     GIR_EraseRootFromParent_Done,
     /* 1760414 */   // Label 23874: @1760414
     /* 1760414 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1760500), // Rule ID 13640 //
     /* 1760419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1760439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760465 */     // MIs[0] policy
     /* 1760465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760475 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1760478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760499 */     // GIR_Coverage, 13640,
     /* 1760499 */     GIR_EraseRootFromParent_Done,
     /* 1760500 */   // Label 23875: @1760500
     /* 1760500 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1760586), // Rule ID 13641 //
     /* 1760505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1760525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760551 */     // MIs[0] policy
     /* 1760551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1760564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760585 */     // GIR_Coverage, 13641,
     /* 1760585 */     GIR_EraseRootFromParent_Done,
     /* 1760586 */   // Label 23876: @1760586
     /* 1760586 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1760672), // Rule ID 13644 //
     /* 1760591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1760611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760637 */     // MIs[0] policy
     /* 1760637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760647 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1760650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760671 */     // GIR_Coverage, 13644,
     /* 1760671 */     GIR_EraseRootFromParent_Done,
     /* 1760672 */   // Label 23877: @1760672
     /* 1760672 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1760758), // Rule ID 13645 //
     /* 1760677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1760697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760723 */     // MIs[0] policy
     /* 1760723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1760736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760757 */     // GIR_Coverage, 13645,
     /* 1760757 */     GIR_EraseRootFromParent_Done,
     /* 1760758 */   // Label 23878: @1760758
     /* 1760758 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1760844), // Rule ID 13648 //
     /* 1760763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760809 */     // MIs[0] policy
     /* 1760809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760819 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1760822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760843 */     // GIR_Coverage, 13648,
     /* 1760843 */     GIR_EraseRootFromParent_Done,
     /* 1760844 */   // Label 23879: @1760844
     /* 1760844 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1760930), // Rule ID 13649 //
     /* 1760849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1760866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760895 */     // MIs[0] policy
     /* 1760895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760905 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1760908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760929 */     // GIR_Coverage, 13649,
     /* 1760929 */     GIR_EraseRootFromParent_Done,
     /* 1760930 */   // Label 23880: @1760930
     /* 1760930 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1761016), // Rule ID 13652 //
     /* 1760935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1760943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1760946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1760949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1760952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760981 */     // MIs[0] policy
     /* 1760981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1760994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1760998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761015 */     // GIR_Coverage, 13652,
     /* 1761015 */     GIR_EraseRootFromParent_Done,
     /* 1761016 */   // Label 23881: @1761016
     /* 1761016 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1761102), // Rule ID 13653 //
     /* 1761021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1761041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761067 */     // MIs[0] policy
     /* 1761067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1761080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761101 */     // GIR_Coverage, 13653,
     /* 1761101 */     GIR_EraseRootFromParent_Done,
     /* 1761102 */   // Label 23882: @1761102
     /* 1761102 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1761188), // Rule ID 13656 //
     /* 1761107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761153 */     // MIs[0] policy
     /* 1761153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1761166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761187 */     // GIR_Coverage, 13656,
     /* 1761187 */     GIR_EraseRootFromParent_Done,
     /* 1761188 */   // Label 23883: @1761188
     /* 1761188 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1761274), // Rule ID 13657 //
     /* 1761193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761239 */     // MIs[0] policy
     /* 1761239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761249 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1761252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761273 */     // GIR_Coverage, 13657,
     /* 1761273 */     GIR_EraseRootFromParent_Done,
     /* 1761274 */   // Label 23884: @1761274
     /* 1761274 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1761360), // Rule ID 13660 //
     /* 1761279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761325 */     // MIs[0] policy
     /* 1761325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761335 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1761338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761359 */     // GIR_Coverage, 13660,
     /* 1761359 */     GIR_EraseRootFromParent_Done,
     /* 1761360 */   // Label 23885: @1761360
     /* 1761360 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1761446), // Rule ID 13661 //
     /* 1761365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761411 */     // MIs[0] policy
     /* 1761411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1761424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761445 */     // GIR_Coverage, 13661,
     /* 1761445 */     GIR_EraseRootFromParent_Done,
     /* 1761446 */   // Label 23886: @1761446
     /* 1761446 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1761532), // Rule ID 13664 //
     /* 1761451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1761462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1761465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1761471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761497 */     // MIs[0] policy
     /* 1761497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1761510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761531 */     // GIR_Coverage, 13664,
     /* 1761531 */     GIR_EraseRootFromParent_Done,
     /* 1761532 */   // Label 23887: @1761532
     /* 1761532 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1761618), // Rule ID 13665 //
     /* 1761537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1761548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1761551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1761557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761583 */     // MIs[0] policy
     /* 1761583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1761596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761617 */     // GIR_Coverage, 13665,
     /* 1761617 */     GIR_EraseRootFromParent_Done,
     /* 1761618 */   // Label 23888: @1761618
     /* 1761618 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1761704), // Rule ID 13668 //
     /* 1761623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1761643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761669 */     // MIs[0] policy
     /* 1761669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1761682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761703 */     // GIR_Coverage, 13668,
     /* 1761703 */     GIR_EraseRootFromParent_Done,
     /* 1761704 */   // Label 23889: @1761704
     /* 1761704 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1761790), // Rule ID 13669 //
     /* 1761709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1761729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761755 */     // MIs[0] policy
     /* 1761755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1761768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761789 */     // GIR_Coverage, 13669,
     /* 1761789 */     GIR_EraseRootFromParent_Done,
     /* 1761790 */   // Label 23890: @1761790
     /* 1761790 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1761876), // Rule ID 13672 //
     /* 1761795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1761815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761841 */     // MIs[0] policy
     /* 1761841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1761854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761875 */     // GIR_Coverage, 13672,
     /* 1761875 */     GIR_EraseRootFromParent_Done,
     /* 1761876 */   // Label 23891: @1761876
     /* 1761876 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1761962), // Rule ID 13673 //
     /* 1761881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1761898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1761901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761927 */     // MIs[0] policy
     /* 1761927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1761940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1761944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761961 */     // GIR_Coverage, 13673,
     /* 1761961 */     GIR_EraseRootFromParent_Done,
     /* 1761962 */   // Label 23892: @1761962
     /* 1761962 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1762048), // Rule ID 13676 //
     /* 1761967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1761975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1761978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1761981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1761984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762013 */     // MIs[0] policy
     /* 1762013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1762026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762047 */     // GIR_Coverage, 13676,
     /* 1762047 */     GIR_EraseRootFromParent_Done,
     /* 1762048 */   // Label 23893: @1762048
     /* 1762048 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1762134), // Rule ID 13677 //
     /* 1762053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1762073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762099 */     // MIs[0] policy
     /* 1762099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1762112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762133 */     // GIR_Coverage, 13677,
     /* 1762133 */     GIR_EraseRootFromParent_Done,
     /* 1762134 */   // Label 23894: @1762134
     /* 1762134 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1762220), // Rule ID 13680 //
     /* 1762139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1762156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1762159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762185 */     // MIs[0] policy
     /* 1762185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1762198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762219 */     // GIR_Coverage, 13680,
     /* 1762219 */     GIR_EraseRootFromParent_Done,
     /* 1762220 */   // Label 23895: @1762220
     /* 1762220 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1762306), // Rule ID 13681 //
     /* 1762225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1762245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762271 */     // MIs[0] policy
     /* 1762271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762281 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1762284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762305 */     // GIR_Coverage, 13681,
     /* 1762305 */     GIR_EraseRootFromParent_Done,
     /* 1762306 */   // Label 23896: @1762306
     /* 1762306 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1762392), // Rule ID 13684 //
     /* 1762311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1762314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1762322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1762325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1762328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1762331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762357 */     // MIs[0] policy
     /* 1762357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762367 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1762370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762391 */     // GIR_Coverage, 13684,
     /* 1762391 */     GIR_EraseRootFromParent_Done,
     /* 1762392 */   // Label 23897: @1762392
     /* 1762392 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1762478), // Rule ID 13685 //
     /* 1762397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1762400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1762408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1762411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1762417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762443 */     // MIs[0] policy
     /* 1762443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762453 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1762456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762477 */     // GIR_Coverage, 13685,
     /* 1762477 */     GIR_EraseRootFromParent_Done,
     /* 1762478 */   // Label 23898: @1762478
     /* 1762478 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1762564), // Rule ID 13688 //
     /* 1762483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1762486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1762494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1762497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1762500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1762503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762529 */     // MIs[0] policy
     /* 1762529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1762542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762563 */     // GIR_Coverage, 13688,
     /* 1762563 */     GIR_EraseRootFromParent_Done,
     /* 1762564 */   // Label 23899: @1762564
     /* 1762564 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1762650), // Rule ID 13689 //
     /* 1762569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1762572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1762580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1762583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1762589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762615 */     // MIs[0] policy
     /* 1762615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1762628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762649 */     // GIR_Coverage, 13689,
     /* 1762649 */     GIR_EraseRootFromParent_Done,
     /* 1762650 */   // Label 23900: @1762650
     /* 1762650 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1762736), // Rule ID 13692 //
     /* 1762655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1762658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1762666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1762669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1762672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762701 */     // MIs[0] policy
     /* 1762701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1762714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762735 */     // GIR_Coverage, 13692,
     /* 1762735 */     GIR_EraseRootFromParent_Done,
     /* 1762736 */   // Label 23901: @1762736
     /* 1762736 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1762822), // Rule ID 13693 //
     /* 1762741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1762744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1762752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1762755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762787 */     // MIs[0] policy
     /* 1762787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1762800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762821 */     // GIR_Coverage, 13693,
     /* 1762821 */     GIR_EraseRootFromParent_Done,
     /* 1762822 */   // Label 23902: @1762822
     /* 1762822 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1762908), // Rule ID 13696 //
     /* 1762827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1762830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1762844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762873 */     // MIs[0] policy
     /* 1762873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1762886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762907 */     // GIR_Coverage, 13696,
     /* 1762907 */     GIR_EraseRootFromParent_Done,
     /* 1762908 */   // Label 23903: @1762908
     /* 1762908 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1762994), // Rule ID 13697 //
     /* 1762913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1762916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1762921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1762930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762959 */     // MIs[0] policy
     /* 1762959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762969 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1762972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1762976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762993 */     // GIR_Coverage, 13697,
     /* 1762993 */     GIR_EraseRootFromParent_Done,
     /* 1762994 */   // Label 23904: @1762994
     /* 1762994 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1763083), // Rule ID 13906 //
     /* 1762999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1763010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1763013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1763016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1763019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763045 */     // MIs[0] policy
     /* 1763045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763055 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1763058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763082 */     // GIR_Coverage, 13906,
     /* 1763082 */     GIR_EraseRootFromParent_Done,
     /* 1763083 */   // Label 23905: @1763083
     /* 1763083 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1763172), // Rule ID 13907 //
     /* 1763088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1763099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1763102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1763105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1763108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763134 */     // MIs[0] policy
     /* 1763134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1763147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763171 */     // GIR_Coverage, 13907,
     /* 1763171 */     GIR_EraseRootFromParent_Done,
     /* 1763172 */   // Label 23906: @1763172
     /* 1763172 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1763261), // Rule ID 13910 //
     /* 1763177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763223 */     // MIs[0] policy
     /* 1763223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763233 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1763236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763260 */     // GIR_Coverage, 13910,
     /* 1763260 */     GIR_EraseRootFromParent_Done,
     /* 1763261 */   // Label 23907: @1763261
     /* 1763261 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1763350), // Rule ID 13911 //
     /* 1763266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763312 */     // MIs[0] policy
     /* 1763312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763322 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1763325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763349 */     // GIR_Coverage, 13911,
     /* 1763349 */     GIR_EraseRootFromParent_Done,
     /* 1763350 */   // Label 23908: @1763350
     /* 1763350 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1763439), // Rule ID 13914 //
     /* 1763355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763401 */     // MIs[0] policy
     /* 1763401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1763414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763438 */     // GIR_Coverage, 13914,
     /* 1763438 */     GIR_EraseRootFromParent_Done,
     /* 1763439 */   // Label 23909: @1763439
     /* 1763439 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1763528), // Rule ID 13915 //
     /* 1763444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763490 */     // MIs[0] policy
     /* 1763490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1763503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763527 */     // GIR_Coverage, 13915,
     /* 1763527 */     GIR_EraseRootFromParent_Done,
     /* 1763528 */   // Label 23910: @1763528
     /* 1763528 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1763617), // Rule ID 13918 //
     /* 1763533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763579 */     // MIs[0] policy
     /* 1763579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1763592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763616 */     // GIR_Coverage, 13918,
     /* 1763616 */     GIR_EraseRootFromParent_Done,
     /* 1763617 */   // Label 23911: @1763617
     /* 1763617 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1763706), // Rule ID 13919 //
     /* 1763622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763668 */     // MIs[0] policy
     /* 1763668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1763681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763705 */     // GIR_Coverage, 13919,
     /* 1763705 */     GIR_EraseRootFromParent_Done,
     /* 1763706 */   // Label 23912: @1763706
     /* 1763706 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1763795), // Rule ID 13922 //
     /* 1763711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763757 */     // MIs[0] policy
     /* 1763757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763767 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1763770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763794 */     // GIR_Coverage, 13922,
     /* 1763794 */     GIR_EraseRootFromParent_Done,
     /* 1763795 */   // Label 23913: @1763795
     /* 1763795 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1763884), // Rule ID 13923 //
     /* 1763800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763846 */     // MIs[0] policy
     /* 1763846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1763859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763883 */     // GIR_Coverage, 13923,
     /* 1763883 */     GIR_EraseRootFromParent_Done,
     /* 1763884 */   // Label 23914: @1763884
     /* 1763884 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1763973), // Rule ID 13926 //
     /* 1763889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1763909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763935 */     // MIs[0] policy
     /* 1763935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763945 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1763948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1763971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763972 */     // GIR_Coverage, 13926,
     /* 1763972 */     GIR_EraseRootFromParent_Done,
     /* 1763973 */   // Label 23915: @1763973
     /* 1763973 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1764062), // Rule ID 13927 //
     /* 1763978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1763986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1763998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764024 */     // MIs[0] policy
     /* 1764024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1764037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764061 */     // GIR_Coverage, 13927,
     /* 1764061 */     GIR_EraseRootFromParent_Done,
     /* 1764062 */   // Label 23916: @1764062
     /* 1764062 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1764151), // Rule ID 13930 //
     /* 1764067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764113 */     // MIs[0] policy
     /* 1764113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764123 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764150 */     // GIR_Coverage, 13930,
     /* 1764150 */     GIR_EraseRootFromParent_Done,
     /* 1764151 */   // Label 23917: @1764151
     /* 1764151 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1764240), // Rule ID 13931 //
     /* 1764156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764202 */     // MIs[0] policy
     /* 1764202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764239 */     // GIR_Coverage, 13931,
     /* 1764239 */     GIR_EraseRootFromParent_Done,
     /* 1764240 */   // Label 23918: @1764240
     /* 1764240 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1764329), // Rule ID 13934 //
     /* 1764245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764291 */     // MIs[0] policy
     /* 1764291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764301 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764328 */     // GIR_Coverage, 13934,
     /* 1764328 */     GIR_EraseRootFromParent_Done,
     /* 1764329 */   // Label 23919: @1764329
     /* 1764329 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1764418), // Rule ID 13935 //
     /* 1764334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764380 */     // MIs[0] policy
     /* 1764380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764417 */     // GIR_Coverage, 13935,
     /* 1764417 */     GIR_EraseRootFromParent_Done,
     /* 1764418 */   // Label 23920: @1764418
     /* 1764418 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1764507), // Rule ID 13938 //
     /* 1764423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764469 */     // MIs[0] policy
     /* 1764469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764479 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764506 */     // GIR_Coverage, 13938,
     /* 1764506 */     GIR_EraseRootFromParent_Done,
     /* 1764507 */   // Label 23921: @1764507
     /* 1764507 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1764596), // Rule ID 13939 //
     /* 1764512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764558 */     // MIs[0] policy
     /* 1764558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764595 */     // GIR_Coverage, 13939,
     /* 1764595 */     GIR_EraseRootFromParent_Done,
     /* 1764596 */   // Label 23922: @1764596
     /* 1764596 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1764685), // Rule ID 13942 //
     /* 1764601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1764604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764647 */     // MIs[0] policy
     /* 1764647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764684 */     // GIR_Coverage, 13942,
     /* 1764684 */     GIR_EraseRootFromParent_Done,
     /* 1764685 */   // Label 23923: @1764685
     /* 1764685 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1764774), // Rule ID 13943 //
     /* 1764690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1764693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764736 */     // MIs[0] policy
     /* 1764736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1764749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764773 */     // GIR_Coverage, 13943,
     /* 1764773 */     GIR_EraseRootFromParent_Done,
     /* 1764774 */   // Label 23924: @1764774
     /* 1764774 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1764863), // Rule ID 13946 //
     /* 1764779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764825 */     // MIs[0] policy
     /* 1764825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1764838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764862 */     // GIR_Coverage, 13946,
     /* 1764862 */     GIR_EraseRootFromParent_Done,
     /* 1764863 */   // Label 23925: @1764863
     /* 1764863 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1764952), // Rule ID 13947 //
     /* 1764868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764914 */     // MIs[0] policy
     /* 1764914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1764927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1764950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764951 */     // GIR_Coverage, 13947,
     /* 1764951 */     GIR_EraseRootFromParent_Done,
     /* 1764952 */   // Label 23926: @1764952
     /* 1764952 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1765041), // Rule ID 13950 //
     /* 1764957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1764965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1764977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765003 */     // MIs[0] policy
     /* 1765003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765013 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1765016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765040 */     // GIR_Coverage, 13950,
     /* 1765040 */     GIR_EraseRootFromParent_Done,
     /* 1765041 */   // Label 23927: @1765041
     /* 1765041 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1765130), // Rule ID 13951 //
     /* 1765046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1765057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1765060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1765063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1765066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765092 */     // MIs[0] policy
     /* 1765092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765102 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1765105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765129 */     // GIR_Coverage, 13951,
     /* 1765129 */     GIR_EraseRootFromParent_Done,
     /* 1765130 */   // Label 23928: @1765130
     /* 1765130 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1765219), // Rule ID 13954 //
     /* 1765135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1765146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1765149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1765152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1765155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1765158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765181 */     // MIs[0] policy
     /* 1765181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765191 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1765194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765218 */     // GIR_Coverage, 13954,
     /* 1765218 */     GIR_EraseRootFromParent_Done,
     /* 1765219 */   // Label 23929: @1765219
     /* 1765219 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1765308), // Rule ID 13955 //
     /* 1765224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1765235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1765238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1765241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1765244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1765247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765270 */     // MIs[0] policy
     /* 1765270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765280 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1765283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765307 */     // GIR_Coverage, 13955,
     /* 1765307 */     GIR_EraseRootFromParent_Done,
     /* 1765308 */   // Label 23930: @1765308
     /* 1765308 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1765397), // Rule ID 13958 //
     /* 1765313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765359 */     // MIs[0] policy
     /* 1765359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1765372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765396 */     // GIR_Coverage, 13958,
     /* 1765396 */     GIR_EraseRootFromParent_Done,
     /* 1765397 */   // Label 23931: @1765397
     /* 1765397 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1765486), // Rule ID 13959 //
     /* 1765402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765448 */     // MIs[0] policy
     /* 1765448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1765461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765485 */     // GIR_Coverage, 13959,
     /* 1765485 */     GIR_EraseRootFromParent_Done,
     /* 1765486 */   // Label 23932: @1765486
     /* 1765486 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1765575), // Rule ID 13962 //
     /* 1765491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765537 */     // MIs[0] policy
     /* 1765537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765547 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1765550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765574 */     // GIR_Coverage, 13962,
     /* 1765574 */     GIR_EraseRootFromParent_Done,
     /* 1765575 */   // Label 23933: @1765575
     /* 1765575 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1765664), // Rule ID 13963 //
     /* 1765580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765626 */     // MIs[0] policy
     /* 1765626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1765639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765663 */     // GIR_Coverage, 13963,
     /* 1765663 */     GIR_EraseRootFromParent_Done,
     /* 1765664 */   // Label 23934: @1765664
     /* 1765664 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1765753), // Rule ID 13966 //
     /* 1765669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765715 */     // MIs[0] policy
     /* 1765715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765725 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1765728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765752 */     // GIR_Coverage, 13966,
     /* 1765752 */     GIR_EraseRootFromParent_Done,
     /* 1765753 */   // Label 23935: @1765753
     /* 1765753 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1765842), // Rule ID 13967 //
     /* 1765758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765804 */     // MIs[0] policy
     /* 1765804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1765817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765841 */     // GIR_Coverage, 13967,
     /* 1765841 */     GIR_EraseRootFromParent_Done,
     /* 1765842 */   // Label 23936: @1765842
     /* 1765842 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1765931), // Rule ID 13970 //
     /* 1765847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765893 */     // MIs[0] policy
     /* 1765893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1765906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1765929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765930 */     // GIR_Coverage, 13970,
     /* 1765930 */     GIR_EraseRootFromParent_Done,
     /* 1765931 */   // Label 23937: @1765931
     /* 1765931 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1766020), // Rule ID 13971 //
     /* 1765936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1765944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765982 */     // MIs[0] policy
     /* 1765982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1765995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766019 */     // GIR_Coverage, 13971,
     /* 1766019 */     GIR_EraseRootFromParent_Done,
     /* 1766020 */   // Label 23938: @1766020
     /* 1766020 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1766109), // Rule ID 13974 //
     /* 1766025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1766036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1766039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1766042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1766045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766071 */     // MIs[0] policy
     /* 1766071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766081 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1766084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766108 */     // GIR_Coverage, 13974,
     /* 1766108 */     GIR_EraseRootFromParent_Done,
     /* 1766109 */   // Label 23939: @1766109
     /* 1766109 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1766198), // Rule ID 13975 //
     /* 1766114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1766125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1766128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1766131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1766134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766160 */     // MIs[0] policy
     /* 1766160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1766173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766197 */     // GIR_Coverage, 13975,
     /* 1766197 */     GIR_EraseRootFromParent_Done,
     /* 1766198 */   // Label 23940: @1766198
     /* 1766198 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1766287), // Rule ID 13978 //
     /* 1766203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766249 */     // MIs[0] policy
     /* 1766249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1766262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766286 */     // GIR_Coverage, 13978,
     /* 1766286 */     GIR_EraseRootFromParent_Done,
     /* 1766287 */   // Label 23941: @1766287
     /* 1766287 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1766376), // Rule ID 13979 //
     /* 1766292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766338 */     // MIs[0] policy
     /* 1766338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1766351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766375 */     // GIR_Coverage, 13979,
     /* 1766375 */     GIR_EraseRootFromParent_Done,
     /* 1766376 */   // Label 23942: @1766376
     /* 1766376 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1766465), // Rule ID 13982 //
     /* 1766381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766427 */     // MIs[0] policy
     /* 1766427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1766440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766464 */     // GIR_Coverage, 13982,
     /* 1766464 */     GIR_EraseRootFromParent_Done,
     /* 1766465 */   // Label 23943: @1766465
     /* 1766465 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1766554), // Rule ID 13983 //
     /* 1766470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766516 */     // MIs[0] policy
     /* 1766516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766526 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1766529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766553 */     // GIR_Coverage, 13983,
     /* 1766553 */     GIR_EraseRootFromParent_Done,
     /* 1766554 */   // Label 23944: @1766554
     /* 1766554 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1766643), // Rule ID 13986 //
     /* 1766559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766605 */     // MIs[0] policy
     /* 1766605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766615 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1766618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766642 */     // GIR_Coverage, 13986,
     /* 1766642 */     GIR_EraseRootFromParent_Done,
     /* 1766643 */   // Label 23945: @1766643
     /* 1766643 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1766732), // Rule ID 13987 //
     /* 1766648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766694 */     // MIs[0] policy
     /* 1766694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1766707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766731 */     // GIR_Coverage, 13987,
     /* 1766731 */     GIR_EraseRootFromParent_Done,
     /* 1766732 */   // Label 23946: @1766732
     /* 1766732 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1766821), // Rule ID 13990 //
     /* 1766737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766783 */     // MIs[0] policy
     /* 1766783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1766796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766820 */     // GIR_Coverage, 13990,
     /* 1766820 */     GIR_EraseRootFromParent_Done,
     /* 1766821 */   // Label 23947: @1766821
     /* 1766821 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1766910), // Rule ID 13991 //
     /* 1766826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766872 */     // MIs[0] policy
     /* 1766872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766882 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1766885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766909 */     // GIR_Coverage, 13991,
     /* 1766909 */     GIR_EraseRootFromParent_Done,
     /* 1766910 */   // Label 23948: @1766910
     /* 1766910 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1766999), // Rule ID 13994 //
     /* 1766915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1766923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1766926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1766929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1766932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766961 */     // MIs[0] policy
     /* 1766961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1766974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1766997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766998 */     // GIR_Coverage, 13994,
     /* 1766998 */     GIR_EraseRootFromParent_Done,
     /* 1766999 */   // Label 23949: @1766999
     /* 1766999 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1767088), // Rule ID 13995 //
     /* 1767004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1767015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1767018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1767021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767050 */     // MIs[0] policy
     /* 1767050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1767063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767087 */     // GIR_Coverage, 13995,
     /* 1767087 */     GIR_EraseRootFromParent_Done,
     /* 1767088 */   // Label 23950: @1767088
     /* 1767088 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1767177), // Rule ID 13998 //
     /* 1767093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1767104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1767107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1767110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767139 */     // MIs[0] policy
     /* 1767139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767149 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1767152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767176 */     // GIR_Coverage, 13998,
     /* 1767176 */     GIR_EraseRootFromParent_Done,
     /* 1767177 */   // Label 23951: @1767177
     /* 1767177 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1767266), // Rule ID 13999 //
     /* 1767182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1767193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1767196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1767199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767228 */     // MIs[0] policy
     /* 1767228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1767241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767265 */     // GIR_Coverage, 13999,
     /* 1767265 */     GIR_EraseRootFromParent_Done,
     /* 1767266 */   // Label 23952: @1767266
     /* 1767266 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1767355), // Rule ID 14002 //
     /* 1767271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767317 */     // MIs[0] policy
     /* 1767317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767327 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767354 */     // GIR_Coverage, 14002,
     /* 1767354 */     GIR_EraseRootFromParent_Done,
     /* 1767355 */   // Label 23953: @1767355
     /* 1767355 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1767444), // Rule ID 14003 //
     /* 1767360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767406 */     // MIs[0] policy
     /* 1767406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767443 */     // GIR_Coverage, 14003,
     /* 1767443 */     GIR_EraseRootFromParent_Done,
     /* 1767444 */   // Label 23954: @1767444
     /* 1767444 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1767533), // Rule ID 14006 //
     /* 1767449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767495 */     // MIs[0] policy
     /* 1767495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767505 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1767508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767532 */     // GIR_Coverage, 14006,
     /* 1767532 */     GIR_EraseRootFromParent_Done,
     /* 1767533 */   // Label 23955: @1767533
     /* 1767533 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1767622), // Rule ID 14007 //
     /* 1767538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767584 */     // MIs[0] policy
     /* 1767584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1767597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767621 */     // GIR_Coverage, 14007,
     /* 1767621 */     GIR_EraseRootFromParent_Done,
     /* 1767622 */   // Label 23956: @1767622
     /* 1767622 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1767711), // Rule ID 14010 //
     /* 1767627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1767638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1767641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1767644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767673 */     // MIs[0] policy
     /* 1767673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767683 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767710 */     // GIR_Coverage, 14010,
     /* 1767710 */     GIR_EraseRootFromParent_Done,
     /* 1767711 */   // Label 23957: @1767711
     /* 1767711 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1767800), // Rule ID 14011 //
     /* 1767716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1767727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1767730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1767733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767762 */     // MIs[0] policy
     /* 1767762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767799 */     // GIR_Coverage, 14011,
     /* 1767799 */     GIR_EraseRootFromParent_Done,
     /* 1767800 */   // Label 23958: @1767800
     /* 1767800 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1767889), // Rule ID 14014 //
     /* 1767805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767851 */     // MIs[0] policy
     /* 1767851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767861 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767888 */     // GIR_Coverage, 14014,
     /* 1767888 */     GIR_EraseRootFromParent_Done,
     /* 1767889 */   // Label 23959: @1767889
     /* 1767889 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1767978), // Rule ID 14015 //
     /* 1767894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767940 */     // MIs[0] policy
     /* 1767940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1767953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1767976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767977 */     // GIR_Coverage, 14015,
     /* 1767977 */     GIR_EraseRootFromParent_Done,
     /* 1767978 */   // Label 23960: @1767978
     /* 1767978 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1768067), // Rule ID 14018 //
     /* 1767983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1767991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1767994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1767997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1768000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768029 */     // MIs[0] policy
     /* 1768029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768039 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768066 */     // GIR_Coverage, 14018,
     /* 1768066 */     GIR_EraseRootFromParent_Done,
     /* 1768067 */   // Label 23961: @1768067
     /* 1768067 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1768156), // Rule ID 14019 //
     /* 1768072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1768083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1768086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1768089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768118 */     // MIs[0] policy
     /* 1768118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768155 */     // GIR_Coverage, 14019,
     /* 1768155 */     GIR_EraseRootFromParent_Done,
     /* 1768156 */   // Label 23962: @1768156
     /* 1768156 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1768245), // Rule ID 14022 //
     /* 1768161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1768172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1768175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1768178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768207 */     // MIs[0] policy
     /* 1768207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768244 */     // GIR_Coverage, 14022,
     /* 1768244 */     GIR_EraseRootFromParent_Done,
     /* 1768245 */   // Label 23963: @1768245
     /* 1768245 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1768334), // Rule ID 14023 //
     /* 1768250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1768261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1768264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1768267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768296 */     // MIs[0] policy
     /* 1768296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768333 */     // GIR_Coverage, 14023,
     /* 1768333 */     GIR_EraseRootFromParent_Done,
     /* 1768334 */   // Label 23964: @1768334
     /* 1768334 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1768423), // Rule ID 14026 //
     /* 1768339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768385 */     // MIs[0] policy
     /* 1768385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768422 */     // GIR_Coverage, 14026,
     /* 1768422 */     GIR_EraseRootFromParent_Done,
     /* 1768423 */   // Label 23965: @1768423
     /* 1768423 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1768512), // Rule ID 14027 //
     /* 1768428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768474 */     // MIs[0] policy
     /* 1768474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768511 */     // GIR_Coverage, 14027,
     /* 1768511 */     GIR_EraseRootFromParent_Done,
     /* 1768512 */   // Label 23966: @1768512
     /* 1768512 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1768601), // Rule ID 14030 //
     /* 1768517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1768520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768563 */     // MIs[0] policy
     /* 1768563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768573 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768600 */     // GIR_Coverage, 14030,
     /* 1768600 */     GIR_EraseRootFromParent_Done,
     /* 1768601 */   // Label 23967: @1768601
     /* 1768601 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1768690), // Rule ID 14031 //
     /* 1768606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1768609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768652 */     // MIs[0] policy
     /* 1768652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1768665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768689 */     // GIR_Coverage, 14031,
     /* 1768689 */     GIR_EraseRootFromParent_Done,
     /* 1768690 */   // Label 23968: @1768690
     /* 1768690 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1768779), // Rule ID 14034 //
     /* 1768695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1768706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1768709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1768712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768741 */     // MIs[0] policy
     /* 1768741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1768754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768778 */     // GIR_Coverage, 14034,
     /* 1768778 */     GIR_EraseRootFromParent_Done,
     /* 1768779 */   // Label 23969: @1768779
     /* 1768779 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1768868), // Rule ID 14035 //
     /* 1768784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1768795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1768798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1768801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768830 */     // MIs[0] policy
     /* 1768830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1768843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768867 */     // GIR_Coverage, 14035,
     /* 1768867 */     GIR_EraseRootFromParent_Done,
     /* 1768868 */   // Label 23970: @1768868
     /* 1768868 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1768957), // Rule ID 14038 //
     /* 1768873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1768884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1768887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1768890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768919 */     // MIs[0] policy
     /* 1768919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1768932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1768955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768956 */     // GIR_Coverage, 14038,
     /* 1768956 */     GIR_EraseRootFromParent_Done,
     /* 1768957 */   // Label 23971: @1768957
     /* 1768957 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1769046), // Rule ID 14039 //
     /* 1768962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1768970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1768973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1768976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1768979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769008 */     // MIs[0] policy
     /* 1769008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1769021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769045 */     // GIR_Coverage, 14039,
     /* 1769045 */     GIR_EraseRootFromParent_Done,
     /* 1769046 */   // Label 23972: @1769046
     /* 1769046 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1769135), // Rule ID 14042 //
     /* 1769051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1769062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1769065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1769068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1769074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769097 */     // MIs[0] policy
     /* 1769097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769107 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1769110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769134 */     // GIR_Coverage, 14042,
     /* 1769134 */     GIR_EraseRootFromParent_Done,
     /* 1769135 */   // Label 23973: @1769135
     /* 1769135 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1769224), // Rule ID 14043 //
     /* 1769140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1769151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1769154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1769157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1769163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769186 */     // MIs[0] policy
     /* 1769186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1769199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769223 */     // GIR_Coverage, 14043,
     /* 1769223 */     GIR_EraseRootFromParent_Done,
     /* 1769224 */   // Label 23974: @1769224
     /* 1769224 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1769313), // Rule ID 14046 //
     /* 1769229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769275 */     // MIs[0] policy
     /* 1769275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1769288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769312 */     // GIR_Coverage, 14046,
     /* 1769312 */     GIR_EraseRootFromParent_Done,
     /* 1769313 */   // Label 23975: @1769313
     /* 1769313 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1769402), // Rule ID 14047 //
     /* 1769318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769364 */     // MIs[0] policy
     /* 1769364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1769377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769401 */     // GIR_Coverage, 14047,
     /* 1769401 */     GIR_EraseRootFromParent_Done,
     /* 1769402 */   // Label 23976: @1769402
     /* 1769402 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1769491), // Rule ID 14050 //
     /* 1769407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769453 */     // MIs[0] policy
     /* 1769453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769463 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1769466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769490 */     // GIR_Coverage, 14050,
     /* 1769490 */     GIR_EraseRootFromParent_Done,
     /* 1769491 */   // Label 23977: @1769491
     /* 1769491 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1769580), // Rule ID 14051 //
     /* 1769496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769542 */     // MIs[0] policy
     /* 1769542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1769555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769579 */     // GIR_Coverage, 14051,
     /* 1769579 */     GIR_EraseRootFromParent_Done,
     /* 1769580 */   // Label 23978: @1769580
     /* 1769580 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1769669), // Rule ID 14054 //
     /* 1769585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1769596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1769599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1769602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769631 */     // MIs[0] policy
     /* 1769631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769641 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1769644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769668 */     // GIR_Coverage, 14054,
     /* 1769668 */     GIR_EraseRootFromParent_Done,
     /* 1769669 */   // Label 23979: @1769669
     /* 1769669 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1769758), // Rule ID 14055 //
     /* 1769674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1769685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1769688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1769691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769720 */     // MIs[0] policy
     /* 1769720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769730 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1769733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769757 */     // GIR_Coverage, 14055,
     /* 1769757 */     GIR_EraseRootFromParent_Done,
     /* 1769758 */   // Label 23980: @1769758
     /* 1769758 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1769847), // Rule ID 14058 //
     /* 1769763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1769774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1769777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1769780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769809 */     // MIs[0] policy
     /* 1769809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1769822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769846 */     // GIR_Coverage, 14058,
     /* 1769846 */     GIR_EraseRootFromParent_Done,
     /* 1769847 */   // Label 23981: @1769847
     /* 1769847 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1769936), // Rule ID 14059 //
     /* 1769852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1769863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1769866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1769869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769898 */     // MIs[0] policy
     /* 1769898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1769911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1769934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769935 */     // GIR_Coverage, 14059,
     /* 1769935 */     GIR_EraseRootFromParent_Done,
     /* 1769936 */   // Label 23982: @1769936
     /* 1769936 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1770025), // Rule ID 14062 //
     /* 1769941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1769949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1769952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1769955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1769958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769987 */     // MIs[0] policy
     /* 1769987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1770000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770024 */     // GIR_Coverage, 14062,
     /* 1770024 */     GIR_EraseRootFromParent_Done,
     /* 1770025 */   // Label 23983: @1770025
     /* 1770025 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1770114), // Rule ID 14063 //
     /* 1770030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1770041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1770044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1770047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770076 */     // MIs[0] policy
     /* 1770076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1770089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770113 */     // GIR_Coverage, 14063,
     /* 1770113 */     GIR_EraseRootFromParent_Done,
     /* 1770114 */   // Label 23984: @1770114
     /* 1770114 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1770203), // Rule ID 14066 //
     /* 1770119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1770130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1770133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1770136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1770142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770165 */     // MIs[0] policy
     /* 1770165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770175 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1770178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770202 */     // GIR_Coverage, 14066,
     /* 1770202 */     GIR_EraseRootFromParent_Done,
     /* 1770203 */   // Label 23985: @1770203
     /* 1770203 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1770292), // Rule ID 14067 //
     /* 1770208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1770219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1770222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1770225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1770231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770254 */     // MIs[0] policy
     /* 1770254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1770267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770291 */     // GIR_Coverage, 14067,
     /* 1770291 */     GIR_EraseRootFromParent_Done,
     /* 1770292 */   // Label 23986: @1770292
     /* 1770292 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1770381), // Rule ID 14070 //
     /* 1770297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770343 */     // MIs[0] policy
     /* 1770343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1770356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770380 */     // GIR_Coverage, 14070,
     /* 1770380 */     GIR_EraseRootFromParent_Done,
     /* 1770381 */   // Label 23987: @1770381
     /* 1770381 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1770470), // Rule ID 14071 //
     /* 1770386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770432 */     // MIs[0] policy
     /* 1770432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1770445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770469 */     // GIR_Coverage, 14071,
     /* 1770469 */     GIR_EraseRootFromParent_Done,
     /* 1770470 */   // Label 23988: @1770470
     /* 1770470 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1770559), // Rule ID 14074 //
     /* 1770475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770521 */     // MIs[0] policy
     /* 1770521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1770534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770558 */     // GIR_Coverage, 14074,
     /* 1770558 */     GIR_EraseRootFromParent_Done,
     /* 1770559 */   // Label 23989: @1770559
     /* 1770559 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1770648), // Rule ID 14075 //
     /* 1770564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770610 */     // MIs[0] policy
     /* 1770610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770620 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1770623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770647 */     // GIR_Coverage, 14075,
     /* 1770647 */     GIR_EraseRootFromParent_Done,
     /* 1770648 */   // Label 23990: @1770648
     /* 1770648 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1770737), // Rule ID 14078 //
     /* 1770653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770699 */     // MIs[0] policy
     /* 1770699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1770712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770736 */     // GIR_Coverage, 14078,
     /* 1770736 */     GIR_EraseRootFromParent_Done,
     /* 1770737 */   // Label 23991: @1770737
     /* 1770737 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1770826), // Rule ID 14079 //
     /* 1770742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1770750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770788 */     // MIs[0] policy
     /* 1770788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1770801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770825 */     // GIR_Coverage, 14079,
     /* 1770825 */     GIR_EraseRootFromParent_Done,
     /* 1770826 */   // Label 23992: @1770826
     /* 1770826 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1770915), // Rule ID 14170 //
     /* 1770831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1770839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770877 */     // MIs[0] policy
     /* 1770877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770887 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1770890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1770913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770914 */     // GIR_Coverage, 14170,
     /* 1770914 */     GIR_EraseRootFromParent_Done,
     /* 1770915 */   // Label 23993: @1770915
     /* 1770915 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1771004), // Rule ID 14171 //
     /* 1770920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1770928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770966 */     // MIs[0] policy
     /* 1770966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770976 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1770979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771003 */     // GIR_Coverage, 14171,
     /* 1771003 */     GIR_EraseRootFromParent_Done,
     /* 1771004 */   // Label 23994: @1771004
     /* 1771004 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1771093), // Rule ID 14174 //
     /* 1771009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1771020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1771023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1771026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1771029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771055 */     // MIs[0] policy
     /* 1771055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771065 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1771068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771092 */     // GIR_Coverage, 14174,
     /* 1771092 */     GIR_EraseRootFromParent_Done,
     /* 1771093 */   // Label 23995: @1771093
     /* 1771093 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1771182), // Rule ID 14175 //
     /* 1771098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1771109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1771112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1771115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1771118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771144 */     // MIs[0] policy
     /* 1771144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771154 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1771157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771181 */     // GIR_Coverage, 14175,
     /* 1771181 */     GIR_EraseRootFromParent_Done,
     /* 1771182 */   // Label 23996: @1771182
     /* 1771182 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1771271), // Rule ID 14178 //
     /* 1771187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1771198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1771201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1771204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1771207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771233 */     // MIs[0] policy
     /* 1771233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771270 */     // GIR_Coverage, 14178,
     /* 1771270 */     GIR_EraseRootFromParent_Done,
     /* 1771271 */   // Label 23997: @1771271
     /* 1771271 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1771360), // Rule ID 14179 //
     /* 1771276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1771287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1771290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1771293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1771296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771322 */     // MIs[0] policy
     /* 1771322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771359 */     // GIR_Coverage, 14179,
     /* 1771359 */     GIR_EraseRootFromParent_Done,
     /* 1771360 */   // Label 23998: @1771360
     /* 1771360 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1771449), // Rule ID 14182 //
     /* 1771365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1771385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771411 */     // MIs[0] policy
     /* 1771411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1771424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771448 */     // GIR_Coverage, 14182,
     /* 1771448 */     GIR_EraseRootFromParent_Done,
     /* 1771449 */   // Label 23999: @1771449
     /* 1771449 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1771538), // Rule ID 14183 //
     /* 1771454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1771474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771500 */     // MIs[0] policy
     /* 1771500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1771513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771537 */     // GIR_Coverage, 14183,
     /* 1771537 */     GIR_EraseRootFromParent_Done,
     /* 1771538 */   // Label 24000: @1771538
     /* 1771538 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1771627), // Rule ID 14186 //
     /* 1771543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1771563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771589 */     // MIs[0] policy
     /* 1771589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771599 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771626 */     // GIR_Coverage, 14186,
     /* 1771626 */     GIR_EraseRootFromParent_Done,
     /* 1771627 */   // Label 24001: @1771627
     /* 1771627 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1771716), // Rule ID 14187 //
     /* 1771632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1771652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771678 */     // MIs[0] policy
     /* 1771678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771715 */     // GIR_Coverage, 14187,
     /* 1771715 */     GIR_EraseRootFromParent_Done,
     /* 1771716 */   // Label 24002: @1771716
     /* 1771716 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1771805), // Rule ID 14190 //
     /* 1771721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1771732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1771735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1771738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1771741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771767 */     // MIs[0] policy
     /* 1771767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771804 */     // GIR_Coverage, 14190,
     /* 1771804 */     GIR_EraseRootFromParent_Done,
     /* 1771805 */   // Label 24003: @1771805
     /* 1771805 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1771894), // Rule ID 14191 //
     /* 1771810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1771821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1771824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1771827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1771830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771856 */     // MIs[0] policy
     /* 1771856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1771869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771893 */     // GIR_Coverage, 14191,
     /* 1771893 */     GIR_EraseRootFromParent_Done,
     /* 1771894 */   // Label 24004: @1771894
     /* 1771894 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1771983), // Rule ID 14194 //
     /* 1771899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771945 */     // MIs[0] policy
     /* 1771945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771955 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1771958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1771981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771982 */     // GIR_Coverage, 14194,
     /* 1771982 */     GIR_EraseRootFromParent_Done,
     /* 1771983 */   // Label 24005: @1771983
     /* 1771983 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1772072), // Rule ID 14195 //
     /* 1771988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1771996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1772002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1772005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1772008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772034 */     // MIs[0] policy
     /* 1772034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772071 */     // GIR_Coverage, 14195,
     /* 1772071 */     GIR_EraseRootFromParent_Done,
     /* 1772072 */   // Label 24006: @1772072
     /* 1772072 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1772161), // Rule ID 14198 //
     /* 1772077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1772088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1772091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1772094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1772097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772123 */     // MIs[0] policy
     /* 1772123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772160 */     // GIR_Coverage, 14198,
     /* 1772160 */     GIR_EraseRootFromParent_Done,
     /* 1772161 */   // Label 24007: @1772161
     /* 1772161 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1772250), // Rule ID 14199 //
     /* 1772166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1772177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1772180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1772183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1772186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772212 */     // MIs[0] policy
     /* 1772212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772249 */     // GIR_Coverage, 14199,
     /* 1772249 */     GIR_EraseRootFromParent_Done,
     /* 1772250 */   // Label 24008: @1772250
     /* 1772250 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1772339), // Rule ID 14202 //
     /* 1772255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1772266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1772269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1772272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1772275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772301 */     // MIs[0] policy
     /* 1772301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772338 */     // GIR_Coverage, 14202,
     /* 1772338 */     GIR_EraseRootFromParent_Done,
     /* 1772339 */   // Label 24009: @1772339
     /* 1772339 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1772428), // Rule ID 14203 //
     /* 1772344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1772355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1772358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1772361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1772364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772390 */     // MIs[0] policy
     /* 1772390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772427 */     // GIR_Coverage, 14203,
     /* 1772427 */     GIR_EraseRootFromParent_Done,
     /* 1772428 */   // Label 24010: @1772428
     /* 1772428 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1772517), // Rule ID 14206 //
     /* 1772433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1772436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772479 */     // MIs[0] policy
     /* 1772479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772516 */     // GIR_Coverage, 14206,
     /* 1772516 */     GIR_EraseRootFromParent_Done,
     /* 1772517 */   // Label 24011: @1772517
     /* 1772517 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1772606), // Rule ID 14207 //
     /* 1772522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1772525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772568 */     // MIs[0] policy
     /* 1772568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1772581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772605 */     // GIR_Coverage, 14207,
     /* 1772605 */     GIR_EraseRootFromParent_Done,
     /* 1772606 */   // Label 24012: @1772606
     /* 1772606 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1772695), // Rule ID 14210 //
     /* 1772611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1772631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772657 */     // MIs[0] policy
     /* 1772657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1772670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772694 */     // GIR_Coverage, 14210,
     /* 1772694 */     GIR_EraseRootFromParent_Done,
     /* 1772695 */   // Label 24013: @1772695
     /* 1772695 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1772784), // Rule ID 14211 //
     /* 1772700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1772720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772746 */     // MIs[0] policy
     /* 1772746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1772759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772783 */     // GIR_Coverage, 14211,
     /* 1772783 */     GIR_EraseRootFromParent_Done,
     /* 1772784 */   // Label 24014: @1772784
     /* 1772784 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1772873), // Rule ID 14214 //
     /* 1772789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772835 */     // MIs[0] policy
     /* 1772835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772845 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1772848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772872 */     // GIR_Coverage, 14214,
     /* 1772872 */     GIR_EraseRootFromParent_Done,
     /* 1772873 */   // Label 24015: @1772873
     /* 1772873 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1772962), // Rule ID 14215 //
     /* 1772878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772924 */     // MIs[0] policy
     /* 1772924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1772937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1772960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772961 */     // GIR_Coverage, 14215,
     /* 1772961 */     GIR_EraseRootFromParent_Done,
     /* 1772962 */   // Label 24016: @1772962
     /* 1772962 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1773051), // Rule ID 14218 //
     /* 1772967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1772975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773013 */     // MIs[0] policy
     /* 1773013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773023 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1773026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773050 */     // GIR_Coverage, 14218,
     /* 1773050 */     GIR_EraseRootFromParent_Done,
     /* 1773051 */   // Label 24017: @1773051
     /* 1773051 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1773140), // Rule ID 14219 //
     /* 1773056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1773067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1773070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1773073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1773076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1773079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773102 */     // MIs[0] policy
     /* 1773102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773112 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1773115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773139 */     // GIR_Coverage, 14219,
     /* 1773139 */     GIR_EraseRootFromParent_Done,
     /* 1773140 */   // Label 24018: @1773140
     /* 1773140 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1773229), // Rule ID 14222 //
     /* 1773145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1773156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1773159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1773162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1773165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773191 */     // MIs[0] policy
     /* 1773191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773201 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1773204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773228 */     // GIR_Coverage, 14222,
     /* 1773228 */     GIR_EraseRootFromParent_Done,
     /* 1773229 */   // Label 24019: @1773229
     /* 1773229 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1773318), // Rule ID 14223 //
     /* 1773234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1773245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1773248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1773251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1773254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773280 */     // MIs[0] policy
     /* 1773280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1773293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773317 */     // GIR_Coverage, 14223,
     /* 1773317 */     GIR_EraseRootFromParent_Done,
     /* 1773318 */   // Label 24020: @1773318
     /* 1773318 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1773407), // Rule ID 14226 //
     /* 1773323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1773334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1773337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1773340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1773343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773369 */     // MIs[0] policy
     /* 1773369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773379 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1773382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773406 */     // GIR_Coverage, 14226,
     /* 1773406 */     GIR_EraseRootFromParent_Done,
     /* 1773407 */   // Label 24021: @1773407
     /* 1773407 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1773496), // Rule ID 14227 //
     /* 1773412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1773423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1773426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1773429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1773432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773458 */     // MIs[0] policy
     /* 1773458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1773471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773495 */     // GIR_Coverage, 14227,
     /* 1773495 */     GIR_EraseRootFromParent_Done,
     /* 1773496 */   // Label 24022: @1773496
     /* 1773496 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1773585), // Rule ID 14230 //
     /* 1773501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1773521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773547 */     // MIs[0] policy
     /* 1773547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773557 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1773560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773584 */     // GIR_Coverage, 14230,
     /* 1773584 */     GIR_EraseRootFromParent_Done,
     /* 1773585 */   // Label 24023: @1773585
     /* 1773585 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1773674), // Rule ID 14231 //
     /* 1773590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1773610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773636 */     // MIs[0] policy
     /* 1773636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1773649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773673 */     // GIR_Coverage, 14231,
     /* 1773673 */     GIR_EraseRootFromParent_Done,
     /* 1773674 */   // Label 24024: @1773674
     /* 1773674 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1773763), // Rule ID 14234 //
     /* 1773679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1773699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773725 */     // MIs[0] policy
     /* 1773725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1773738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773762 */     // GIR_Coverage, 14234,
     /* 1773762 */     GIR_EraseRootFromParent_Done,
     /* 1773763 */   // Label 24025: @1773763
     /* 1773763 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1773852), // Rule ID 14235 //
     /* 1773768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1773788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773814 */     // MIs[0] policy
     /* 1773814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1773827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773851 */     // GIR_Coverage, 14235,
     /* 1773851 */     GIR_EraseRootFromParent_Done,
     /* 1773852 */   // Label 24026: @1773852
     /* 1773852 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1773941), // Rule ID 14238 //
     /* 1773857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773903 */     // MIs[0] policy
     /* 1773903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773913 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1773916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1773939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773940 */     // GIR_Coverage, 14238,
     /* 1773940 */     GIR_EraseRootFromParent_Done,
     /* 1773941 */   // Label 24027: @1773941
     /* 1773941 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1774030), // Rule ID 14239 //
     /* 1773946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1773954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773992 */     // MIs[0] policy
     /* 1773992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1774005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774029 */     // GIR_Coverage, 14239,
     /* 1774029 */     GIR_EraseRootFromParent_Done,
     /* 1774030 */   // Label 24028: @1774030
     /* 1774030 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1774119), // Rule ID 14242 //
     /* 1774035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1774046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1774049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1774052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1774055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1774058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774081 */     // MIs[0] policy
     /* 1774081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1774094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774118 */     // GIR_Coverage, 14242,
     /* 1774118 */     GIR_EraseRootFromParent_Done,
     /* 1774119 */   // Label 24029: @1774119
     /* 1774119 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1774208), // Rule ID 14243 //
     /* 1774124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1774135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1774138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1774141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1774144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1774147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774170 */     // MIs[0] policy
     /* 1774170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1774183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774207 */     // GIR_Coverage, 14243,
     /* 1774207 */     GIR_EraseRootFromParent_Done,
     /* 1774208 */   // Label 24030: @1774208
     /* 1774208 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1774297), // Rule ID 14246 //
     /* 1774213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1774224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1774227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1774230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1774233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1774243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774259 */     // MIs[0] policy
     /* 1774259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1774272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774296 */     // GIR_Coverage, 14246,
     /* 1774296 */     GIR_EraseRootFromParent_Done,
     /* 1774297 */   // Label 24031: @1774297
     /* 1774297 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1774386), // Rule ID 14247 //
     /* 1774302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1774313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1774316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1774319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1774322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1774332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774348 */     // MIs[0] policy
     /* 1774348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1774361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774385 */     // GIR_Coverage, 14247,
     /* 1774385 */     GIR_EraseRootFromParent_Done,
     /* 1774386 */   // Label 24032: @1774386
     /* 1774386 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1774475), // Rule ID 14250 //
     /* 1774391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1774402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1774405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1774408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1774411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774437 */     // MIs[0] policy
     /* 1774437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774447 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1774450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774474 */     // GIR_Coverage, 14250,
     /* 1774474 */     GIR_EraseRootFromParent_Done,
     /* 1774475 */   // Label 24033: @1774475
     /* 1774475 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1774564), // Rule ID 14251 //
     /* 1774480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1774491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1774494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1774497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1774500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774526 */     // MIs[0] policy
     /* 1774526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1774539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774563 */     // GIR_Coverage, 14251,
     /* 1774563 */     GIR_EraseRootFromParent_Done,
     /* 1774564 */   // Label 24034: @1774564
     /* 1774564 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1774653), // Rule ID 14254 //
     /* 1774569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1774589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774615 */     // MIs[0] policy
     /* 1774615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1774628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774652 */     // GIR_Coverage, 14254,
     /* 1774652 */     GIR_EraseRootFromParent_Done,
     /* 1774653 */   // Label 24035: @1774653
     /* 1774653 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1774742), // Rule ID 14255 //
     /* 1774658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1774678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774704 */     // MIs[0] policy
     /* 1774704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1774717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774741 */     // GIR_Coverage, 14255,
     /* 1774741 */     GIR_EraseRootFromParent_Done,
     /* 1774742 */   // Label 24036: @1774742
     /* 1774742 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1774831), // Rule ID 14258 //
     /* 1774747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774793 */     // MIs[0] policy
     /* 1774793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774803 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1774806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774830 */     // GIR_Coverage, 14258,
     /* 1774830 */     GIR_EraseRootFromParent_Done,
     /* 1774831 */   // Label 24037: @1774831
     /* 1774831 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1774920), // Rule ID 14259 //
     /* 1774836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774882 */     // MIs[0] policy
     /* 1774882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1774895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1774918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774919 */     // GIR_Coverage, 14259,
     /* 1774919 */     GIR_EraseRootFromParent_Done,
     /* 1774920 */   // Label 24038: @1774920
     /* 1774920 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1775009), // Rule ID 14262 //
     /* 1774925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1774933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1774936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774971 */     // MIs[0] policy
     /* 1774971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774981 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1774984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775008 */     // GIR_Coverage, 14262,
     /* 1775008 */     GIR_EraseRootFromParent_Done,
     /* 1775009 */   // Label 24039: @1775009
     /* 1775009 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1775098), // Rule ID 14263 //
     /* 1775014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1775025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1775028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1775031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775060 */     // MIs[0] policy
     /* 1775060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1775073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775097 */     // GIR_Coverage, 14263,
     /* 1775097 */     GIR_EraseRootFromParent_Done,
     /* 1775098 */   // Label 24040: @1775098
     /* 1775098 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1775187), // Rule ID 14266 //
     /* 1775103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1775114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1775117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1775120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775149 */     // MIs[0] policy
     /* 1775149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775186 */     // GIR_Coverage, 14266,
     /* 1775186 */     GIR_EraseRootFromParent_Done,
     /* 1775187 */   // Label 24041: @1775187
     /* 1775187 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1775276), // Rule ID 14267 //
     /* 1775192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1775203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1775206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1775209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775238 */     // MIs[0] policy
     /* 1775238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775275 */     // GIR_Coverage, 14267,
     /* 1775275 */     GIR_EraseRootFromParent_Done,
     /* 1775276 */   // Label 24042: @1775276
     /* 1775276 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1775365), // Rule ID 14270 //
     /* 1775281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1775292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1775295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1775298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775327 */     // MIs[0] policy
     /* 1775327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775337 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1775340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775364 */     // GIR_Coverage, 14270,
     /* 1775364 */     GIR_EraseRootFromParent_Done,
     /* 1775365 */   // Label 24043: @1775365
     /* 1775365 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1775454), // Rule ID 14271 //
     /* 1775370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1775381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1775384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1775387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775416 */     // MIs[0] policy
     /* 1775416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1775429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775453 */     // GIR_Coverage, 14271,
     /* 1775453 */     GIR_EraseRootFromParent_Done,
     /* 1775454 */   // Label 24044: @1775454
     /* 1775454 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1775543), // Rule ID 14274 //
     /* 1775459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775505 */     // MIs[0] policy
     /* 1775505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775515 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775542 */     // GIR_Coverage, 14274,
     /* 1775542 */     GIR_EraseRootFromParent_Done,
     /* 1775543 */   // Label 24045: @1775543
     /* 1775543 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1775632), // Rule ID 14275 //
     /* 1775548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775594 */     // MIs[0] policy
     /* 1775594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775631 */     // GIR_Coverage, 14275,
     /* 1775631 */     GIR_EraseRootFromParent_Done,
     /* 1775632 */   // Label 24046: @1775632
     /* 1775632 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1775721), // Rule ID 14278 //
     /* 1775637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775683 */     // MIs[0] policy
     /* 1775683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775720 */     // GIR_Coverage, 14278,
     /* 1775720 */     GIR_EraseRootFromParent_Done,
     /* 1775721 */   // Label 24047: @1775721
     /* 1775721 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1775810), // Rule ID 14279 //
     /* 1775726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775772 */     // MIs[0] policy
     /* 1775772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1775785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775809 */     // GIR_Coverage, 14279,
     /* 1775809 */     GIR_EraseRootFromParent_Done,
     /* 1775810 */   // Label 24048: @1775810
     /* 1775810 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1775899), // Rule ID 14282 //
     /* 1775815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1775826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1775829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1775832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775861 */     // MIs[0] policy
     /* 1775861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1775874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775898 */     // GIR_Coverage, 14282,
     /* 1775898 */     GIR_EraseRootFromParent_Done,
     /* 1775899 */   // Label 24049: @1775899
     /* 1775899 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1775988), // Rule ID 14283 //
     /* 1775904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1775912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1775915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1775918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1775921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775950 */     // MIs[0] policy
     /* 1775950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1775963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1775986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775987 */     // GIR_Coverage, 14283,
     /* 1775987 */     GIR_EraseRootFromParent_Done,
     /* 1775988 */   // Label 24050: @1775988
     /* 1775988 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1776077), // Rule ID 14286 //
     /* 1775993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1776004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1776007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1776010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776039 */     // MIs[0] policy
     /* 1776039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776076 */     // GIR_Coverage, 14286,
     /* 1776076 */     GIR_EraseRootFromParent_Done,
     /* 1776077 */   // Label 24051: @1776077
     /* 1776077 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1776166), // Rule ID 14287 //
     /* 1776082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1776093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1776096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1776099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776128 */     // MIs[0] policy
     /* 1776128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776165 */     // GIR_Coverage, 14287,
     /* 1776165 */     GIR_EraseRootFromParent_Done,
     /* 1776166 */   // Label 24052: @1776166
     /* 1776166 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1776255), // Rule ID 14290 //
     /* 1776171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1776182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1776185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1776188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776217 */     // MIs[0] policy
     /* 1776217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776254 */     // GIR_Coverage, 14290,
     /* 1776254 */     GIR_EraseRootFromParent_Done,
     /* 1776255 */   // Label 24053: @1776255
     /* 1776255 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1776344), // Rule ID 14291 //
     /* 1776260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1776271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1776274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1776277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776306 */     // MIs[0] policy
     /* 1776306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776343 */     // GIR_Coverage, 14291,
     /* 1776343 */     GIR_EraseRootFromParent_Done,
     /* 1776344 */   // Label 24054: @1776344
     /* 1776344 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1776433), // Rule ID 14294 //
     /* 1776349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1776360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1776363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1776366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1776372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776395 */     // MIs[0] policy
     /* 1776395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776405 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776432 */     // GIR_Coverage, 14294,
     /* 1776432 */     GIR_EraseRootFromParent_Done,
     /* 1776433 */   // Label 24055: @1776433
     /* 1776433 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1776522), // Rule ID 14295 //
     /* 1776438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1776449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1776452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1776455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1776461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776484 */     // MIs[0] policy
     /* 1776484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1776497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776521 */     // GIR_Coverage, 14295,
     /* 1776521 */     GIR_EraseRootFromParent_Done,
     /* 1776522 */   // Label 24056: @1776522
     /* 1776522 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1776611), // Rule ID 14298 //
     /* 1776527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776573 */     // MIs[0] policy
     /* 1776573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776583 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1776586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776610 */     // GIR_Coverage, 14298,
     /* 1776610 */     GIR_EraseRootFromParent_Done,
     /* 1776611 */   // Label 24057: @1776611
     /* 1776611 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1776700), // Rule ID 14299 //
     /* 1776616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776662 */     // MIs[0] policy
     /* 1776662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1776675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776699 */     // GIR_Coverage, 14299,
     /* 1776699 */     GIR_EraseRootFromParent_Done,
     /* 1776700 */   // Label 24058: @1776700
     /* 1776700 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1776789), // Rule ID 14302 //
     /* 1776705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776751 */     // MIs[0] policy
     /* 1776751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776761 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1776764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776788 */     // GIR_Coverage, 14302,
     /* 1776788 */     GIR_EraseRootFromParent_Done,
     /* 1776789 */   // Label 24059: @1776789
     /* 1776789 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1776878), // Rule ID 14303 //
     /* 1776794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776840 */     // MIs[0] policy
     /* 1776840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1776853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776877 */     // GIR_Coverage, 14303,
     /* 1776877 */     GIR_EraseRootFromParent_Done,
     /* 1776878 */   // Label 24060: @1776878
     /* 1776878 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1776967), // Rule ID 14306 //
     /* 1776883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1776894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1776897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1776900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1776906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776929 */     // MIs[0] policy
     /* 1776929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776939 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1776942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1776965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776966 */     // GIR_Coverage, 14306,
     /* 1776966 */     GIR_EraseRootFromParent_Done,
     /* 1776967 */   // Label 24061: @1776967
     /* 1776967 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1777056), // Rule ID 14307 //
     /* 1776972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1776980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1776983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1776986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1776989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1776995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777018 */     // MIs[0] policy
     /* 1777018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777028 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1777031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777055 */     // GIR_Coverage, 14307,
     /* 1777055 */     GIR_EraseRootFromParent_Done,
     /* 1777056 */   // Label 24062: @1777056
     /* 1777056 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1777145), // Rule ID 14310 //
     /* 1777061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1777072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1777075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1777078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777107 */     // MIs[0] policy
     /* 1777107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1777120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777144 */     // GIR_Coverage, 14310,
     /* 1777144 */     GIR_EraseRootFromParent_Done,
     /* 1777145 */   // Label 24063: @1777145
     /* 1777145 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1777234), // Rule ID 14311 //
     /* 1777150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1777161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1777164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1777167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777196 */     // MIs[0] policy
     /* 1777196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1777209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777233 */     // GIR_Coverage, 14311,
     /* 1777233 */     GIR_EraseRootFromParent_Done,
     /* 1777234 */   // Label 24064: @1777234
     /* 1777234 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1777323), // Rule ID 14314 //
     /* 1777239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1777250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1777253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1777256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777285 */     // MIs[0] policy
     /* 1777285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777295 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1777298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777322 */     // GIR_Coverage, 14314,
     /* 1777322 */     GIR_EraseRootFromParent_Done,
     /* 1777323 */   // Label 24065: @1777323
     /* 1777323 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1777412), // Rule ID 14315 //
     /* 1777328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1777339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1777342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1777345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777374 */     // MIs[0] policy
     /* 1777374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1777387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777411 */     // GIR_Coverage, 14315,
     /* 1777411 */     GIR_EraseRootFromParent_Done,
     /* 1777412 */   // Label 24066: @1777412
     /* 1777412 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1777501), // Rule ID 14318 //
     /* 1777417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1777428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1777431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1777434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1777440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777463 */     // MIs[0] policy
     /* 1777463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777473 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1777476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777500 */     // GIR_Coverage, 14318,
     /* 1777500 */     GIR_EraseRootFromParent_Done,
     /* 1777501 */   // Label 24067: @1777501
     /* 1777501 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1777590), // Rule ID 14319 //
     /* 1777506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1777517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1777520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1777523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1777529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777552 */     // MIs[0] policy
     /* 1777552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1777565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777589 */     // GIR_Coverage, 14319,
     /* 1777589 */     GIR_EraseRootFromParent_Done,
     /* 1777590 */   // Label 24068: @1777590
     /* 1777590 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1777679), // Rule ID 14322 //
     /* 1777595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777641 */     // MIs[0] policy
     /* 1777641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1777654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777678 */     // GIR_Coverage, 14322,
     /* 1777678 */     GIR_EraseRootFromParent_Done,
     /* 1777679 */   // Label 24069: @1777679
     /* 1777679 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1777768), // Rule ID 14323 //
     /* 1777684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777730 */     // MIs[0] policy
     /* 1777730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1777743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777767 */     // GIR_Coverage, 14323,
     /* 1777767 */     GIR_EraseRootFromParent_Done,
     /* 1777768 */   // Label 24070: @1777768
     /* 1777768 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1777857), // Rule ID 14326 //
     /* 1777773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777819 */     // MIs[0] policy
     /* 1777819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1777832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777856 */     // GIR_Coverage, 14326,
     /* 1777856 */     GIR_EraseRootFromParent_Done,
     /* 1777857 */   // Label 24071: @1777857
     /* 1777857 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1777946), // Rule ID 14327 //
     /* 1777862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777908 */     // MIs[0] policy
     /* 1777908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1777921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1777944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777945 */     // GIR_Coverage, 14327,
     /* 1777945 */     GIR_EraseRootFromParent_Done,
     /* 1777946 */   // Label 24072: @1777946
     /* 1777946 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1778035), // Rule ID 14330 //
     /* 1777951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1777959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1777965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1777968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777997 */     // MIs[0] policy
     /* 1777997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778007 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1778010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778034 */     // GIR_Coverage, 14330,
     /* 1778034 */     GIR_EraseRootFromParent_Done,
     /* 1778035 */   // Label 24073: @1778035
     /* 1778035 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1778124), // Rule ID 14331 //
     /* 1778040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1778051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1778054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1778057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778086 */     // MIs[0] policy
     /* 1778086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1778099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778123 */     // GIR_Coverage, 14331,
     /* 1778123 */     GIR_EraseRootFromParent_Done,
     /* 1778124 */   // Label 24074: @1778124
     /* 1778124 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1778213), // Rule ID 14334 //
     /* 1778129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1778140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1778143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1778146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778175 */     // MIs[0] policy
     /* 1778175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1778188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778212 */     // GIR_Coverage, 14334,
     /* 1778212 */     GIR_EraseRootFromParent_Done,
     /* 1778213 */   // Label 24075: @1778213
     /* 1778213 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1778302), // Rule ID 14335 //
     /* 1778218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1778229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1778232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1778235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778264 */     // MIs[0] policy
     /* 1778264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1778277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778301 */     // GIR_Coverage, 14335,
     /* 1778301 */     GIR_EraseRootFromParent_Done,
     /* 1778302 */   // Label 24076: @1778302
     /* 1778302 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1778391), // Rule ID 14338 //
     /* 1778307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1778318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1778321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1778324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1778337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778353 */     // MIs[0] policy
     /* 1778353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778363 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1778366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778390 */     // GIR_Coverage, 14338,
     /* 1778390 */     GIR_EraseRootFromParent_Done,
     /* 1778391 */   // Label 24077: @1778391
     /* 1778391 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1778480), // Rule ID 14339 //
     /* 1778396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1778407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1778410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1778413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1778426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778442 */     // MIs[0] policy
     /* 1778442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1778455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778479 */     // GIR_Coverage, 14339,
     /* 1778479 */     GIR_EraseRootFromParent_Done,
     /* 1778480 */   // Label 24078: @1778480
     /* 1778480 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1778569), // Rule ID 14342 //
     /* 1778485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1778496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1778499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1778502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778531 */     // MIs[0] policy
     /* 1778531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778541 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1778544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778568 */     // GIR_Coverage, 14342,
     /* 1778568 */     GIR_EraseRootFromParent_Done,
     /* 1778569 */   // Label 24079: @1778569
     /* 1778569 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1778658), // Rule ID 14343 //
     /* 1778574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1778582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1778585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1778588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1778591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778620 */     // MIs[0] policy
     /* 1778620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778630 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1778633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778657 */     // GIR_Coverage, 14343,
     /* 1778657 */     GIR_EraseRootFromParent_Done,
     /* 1778658 */   // Label 24080: @1778658
     /* 1778658 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1778747), // Rule ID 14434 //
     /* 1778663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1778671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1778683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778709 */     // MIs[0] policy
     /* 1778709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1778722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778746 */     // GIR_Coverage, 14434,
     /* 1778746 */     GIR_EraseRootFromParent_Done,
     /* 1778747 */   // Label 24081: @1778747
     /* 1778747 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1778836), // Rule ID 14435 //
     /* 1778752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1778760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1778772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778798 */     // MIs[0] policy
     /* 1778798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778808 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1778811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778835 */     // GIR_Coverage, 14435,
     /* 1778835 */     GIR_EraseRootFromParent_Done,
     /* 1778836 */   // Label 24082: @1778836
     /* 1778836 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1778925), // Rule ID 14438 //
     /* 1778841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1778849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1778861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778887 */     // MIs[0] policy
     /* 1778887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778897 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1778900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1778923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778924 */     // GIR_Coverage, 14438,
     /* 1778924 */     GIR_EraseRootFromParent_Done,
     /* 1778925 */   // Label 24083: @1778925
     /* 1778925 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1779014), // Rule ID 14439 //
     /* 1778930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1778938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1778950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778976 */     // MIs[0] policy
     /* 1778976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1778989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779013 */     // GIR_Coverage, 14439,
     /* 1779013 */     GIR_EraseRootFromParent_Done,
     /* 1779014 */   // Label 24084: @1779014
     /* 1779014 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1779103), // Rule ID 14442 //
     /* 1779019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1779030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1779033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1779036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1779039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779065 */     // MIs[0] policy
     /* 1779065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779075 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779102 */     // GIR_Coverage, 14442,
     /* 1779102 */     GIR_EraseRootFromParent_Done,
     /* 1779103 */   // Label 24085: @1779103
     /* 1779103 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1779192), // Rule ID 14443 //
     /* 1779108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1779119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1779122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1779125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1779128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779154 */     // MIs[0] policy
     /* 1779154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779191 */     // GIR_Coverage, 14443,
     /* 1779191 */     GIR_EraseRootFromParent_Done,
     /* 1779192 */   // Label 24086: @1779192
     /* 1779192 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1779281), // Rule ID 14446 //
     /* 1779197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1779208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1779211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1779214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1779217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779243 */     // MIs[0] policy
     /* 1779243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779253 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1779256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779280 */     // GIR_Coverage, 14446,
     /* 1779280 */     GIR_EraseRootFromParent_Done,
     /* 1779281 */   // Label 24087: @1779281
     /* 1779281 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1779370), // Rule ID 14447 //
     /* 1779286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1779297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1779300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1779303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1779306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779332 */     // MIs[0] policy
     /* 1779332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1779345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779369 */     // GIR_Coverage, 14447,
     /* 1779369 */     GIR_EraseRootFromParent_Done,
     /* 1779370 */   // Label 24088: @1779370
     /* 1779370 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1779459), // Rule ID 14450 //
     /* 1779375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1779386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1779389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1779392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1779395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779421 */     // MIs[0] policy
     /* 1779421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779431 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779458 */     // GIR_Coverage, 14450,
     /* 1779458 */     GIR_EraseRootFromParent_Done,
     /* 1779459 */   // Label 24089: @1779459
     /* 1779459 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1779548), // Rule ID 14451 //
     /* 1779464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1779475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1779478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1779481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1779484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779510 */     // MIs[0] policy
     /* 1779510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779547 */     // GIR_Coverage, 14451,
     /* 1779547 */     GIR_EraseRootFromParent_Done,
     /* 1779548 */   // Label 24090: @1779548
     /* 1779548 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1779637), // Rule ID 14454 //
     /* 1779553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1779564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1779567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1779570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1779573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779599 */     // MIs[0] policy
     /* 1779599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779636 */     // GIR_Coverage, 14454,
     /* 1779636 */     GIR_EraseRootFromParent_Done,
     /* 1779637 */   // Label 24091: @1779637
     /* 1779637 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1779726), // Rule ID 14455 //
     /* 1779642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1779653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1779656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1779659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1779662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779688 */     // MIs[0] policy
     /* 1779688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1779701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779725 */     // GIR_Coverage, 14455,
     /* 1779725 */     GIR_EraseRootFromParent_Done,
     /* 1779726 */   // Label 24092: @1779726
     /* 1779726 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1779815), // Rule ID 14458 //
     /* 1779731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1779751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779777 */     // MIs[0] policy
     /* 1779777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779787 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1779790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779814 */     // GIR_Coverage, 14458,
     /* 1779814 */     GIR_EraseRootFromParent_Done,
     /* 1779815 */   // Label 24093: @1779815
     /* 1779815 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1779904), // Rule ID 14459 //
     /* 1779820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1779840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779866 */     // MIs[0] policy
     /* 1779866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779876 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1779879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779903 */     // GIR_Coverage, 14459,
     /* 1779903 */     GIR_EraseRootFromParent_Done,
     /* 1779904 */   // Label 24094: @1779904
     /* 1779904 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1779993), // Rule ID 14462 //
     /* 1779909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1779917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1779920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1779923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1779926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1779929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779955 */     // MIs[0] policy
     /* 1779955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1779968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1779991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779992 */     // GIR_Coverage, 14462,
     /* 1779992 */     GIR_EraseRootFromParent_Done,
     /* 1779993 */   // Label 24095: @1779993
     /* 1779993 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1780082), // Rule ID 14463 //
     /* 1779998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1780009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1780012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1780015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1780018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780044 */     // MIs[0] policy
     /* 1780044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1780057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780081 */     // GIR_Coverage, 14463,
     /* 1780081 */     GIR_EraseRootFromParent_Done,
     /* 1780082 */   // Label 24096: @1780082
     /* 1780082 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1780171), // Rule ID 14466 //
     /* 1780087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1780098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1780101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1780104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1780107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780133 */     // MIs[0] policy
     /* 1780133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1780146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780170 */     // GIR_Coverage, 14466,
     /* 1780170 */     GIR_EraseRootFromParent_Done,
     /* 1780171 */   // Label 24097: @1780171
     /* 1780171 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1780260), // Rule ID 14467 //
     /* 1780176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1780187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1780190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1780193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1780196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780222 */     // MIs[0] policy
     /* 1780222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1780235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780259 */     // GIR_Coverage, 14467,
     /* 1780259 */     GIR_EraseRootFromParent_Done,
     /* 1780260 */   // Label 24098: @1780260
     /* 1780260 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1780349), // Rule ID 14470 //
     /* 1780265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1780276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1780279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1780282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1780285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780311 */     // MIs[0] policy
     /* 1780311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1780324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780348 */     // GIR_Coverage, 14470,
     /* 1780348 */     GIR_EraseRootFromParent_Done,
     /* 1780349 */   // Label 24099: @1780349
     /* 1780349 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1780438), // Rule ID 14471 //
     /* 1780354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1780365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1780368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1780371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1780374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780400 */     // MIs[0] policy
     /* 1780400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1780413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780437 */     // GIR_Coverage, 14471,
     /* 1780437 */     GIR_EraseRootFromParent_Done,
     /* 1780438 */   // Label 24100: @1780438
     /* 1780438 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1780527), // Rule ID 14474 //
     /* 1780443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1780454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1780457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1780460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1780463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780489 */     // MIs[0] policy
     /* 1780489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780499 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1780502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780526 */     // GIR_Coverage, 14474,
     /* 1780526 */     GIR_EraseRootFromParent_Done,
     /* 1780527 */   // Label 24101: @1780527
     /* 1780527 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1780616), // Rule ID 14475 //
     /* 1780532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1780543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1780546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1780549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1780552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780578 */     // MIs[0] policy
     /* 1780578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1780591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780615 */     // GIR_Coverage, 14475,
     /* 1780615 */     GIR_EraseRootFromParent_Done,
     /* 1780616 */   // Label 24102: @1780616
     /* 1780616 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1780705), // Rule ID 14478 //
     /* 1780621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1780641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780667 */     // MIs[0] policy
     /* 1780667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780677 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1780680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780704 */     // GIR_Coverage, 14478,
     /* 1780704 */     GIR_EraseRootFromParent_Done,
     /* 1780705 */   // Label 24103: @1780705
     /* 1780705 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1780794), // Rule ID 14479 //
     /* 1780710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1780730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780756 */     // MIs[0] policy
     /* 1780756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1780769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780793 */     // GIR_Coverage, 14479,
     /* 1780793 */     GIR_EraseRootFromParent_Done,
     /* 1780794 */   // Label 24104: @1780794
     /* 1780794 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1780883), // Rule ID 14482 //
     /* 1780799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1780819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780845 */     // MIs[0] policy
     /* 1780845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780855 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1780858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780882 */     // GIR_Coverage, 14482,
     /* 1780882 */     GIR_EraseRootFromParent_Done,
     /* 1780883 */   // Label 24105: @1780883
     /* 1780883 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1780972), // Rule ID 14483 //
     /* 1780888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1780908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780934 */     // MIs[0] policy
     /* 1780934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1780947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1780970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780971 */     // GIR_Coverage, 14483,
     /* 1780971 */     GIR_EraseRootFromParent_Done,
     /* 1780972 */   // Label 24106: @1780972
     /* 1780972 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1781061), // Rule ID 14486 //
     /* 1780977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1780985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1780988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1780991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1780994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1780997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781023 */     // MIs[0] policy
     /* 1781023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1781036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781060 */     // GIR_Coverage, 14486,
     /* 1781060 */     GIR_EraseRootFromParent_Done,
     /* 1781061 */   // Label 24107: @1781061
     /* 1781061 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1781150), // Rule ID 14487 //
     /* 1781066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1781077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1781080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1781083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1781086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781112 */     // MIs[0] policy
     /* 1781112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1781125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781149 */     // GIR_Coverage, 14487,
     /* 1781149 */     GIR_EraseRootFromParent_Done,
     /* 1781150 */   // Label 24108: @1781150
     /* 1781150 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1781239), // Rule ID 14490 //
     /* 1781155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1781166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1781169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1781172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1781175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781201 */     // MIs[0] policy
     /* 1781201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1781214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781238 */     // GIR_Coverage, 14490,
     /* 1781238 */     GIR_EraseRootFromParent_Done,
     /* 1781239 */   // Label 24109: @1781239
     /* 1781239 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1781328), // Rule ID 14491 //
     /* 1781244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1781255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1781258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1781261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1781264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781290 */     // MIs[0] policy
     /* 1781290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1781303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781327 */     // GIR_Coverage, 14491,
     /* 1781327 */     GIR_EraseRootFromParent_Done,
     /* 1781328 */   // Label 24110: @1781328
     /* 1781328 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1781417), // Rule ID 14494 //
     /* 1781333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1781344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1781347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1781350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1781353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1781356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781379 */     // MIs[0] policy
     /* 1781379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781389 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1781392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781416 */     // GIR_Coverage, 14494,
     /* 1781416 */     GIR_EraseRootFromParent_Done,
     /* 1781417 */   // Label 24111: @1781417
     /* 1781417 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1781506), // Rule ID 14495 //
     /* 1781422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1781433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1781436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1781439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1781442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1781445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781468 */     // MIs[0] policy
     /* 1781468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1781481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781505 */     // GIR_Coverage, 14495,
     /* 1781505 */     GIR_EraseRootFromParent_Done,
     /* 1781506 */   // Label 24112: @1781506
     /* 1781506 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1781595), // Rule ID 14498 //
     /* 1781511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1781522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1781525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1781528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1781531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781557 */     // MIs[0] policy
     /* 1781557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1781570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781594 */     // GIR_Coverage, 14498,
     /* 1781594 */     GIR_EraseRootFromParent_Done,
     /* 1781595 */   // Label 24113: @1781595
     /* 1781595 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1781684), // Rule ID 14499 //
     /* 1781600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1781611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1781614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1781617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1781620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781646 */     // MIs[0] policy
     /* 1781646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1781659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781683 */     // GIR_Coverage, 14499,
     /* 1781683 */     GIR_EraseRootFromParent_Done,
     /* 1781684 */   // Label 24114: @1781684
     /* 1781684 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1781773), // Rule ID 14502 //
     /* 1781689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1781709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781735 */     // MIs[0] policy
     /* 1781735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781745 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1781748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781772 */     // GIR_Coverage, 14502,
     /* 1781772 */     GIR_EraseRootFromParent_Done,
     /* 1781773 */   // Label 24115: @1781773
     /* 1781773 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1781862), // Rule ID 14503 //
     /* 1781778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1781798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781824 */     // MIs[0] policy
     /* 1781824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1781837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781861 */     // GIR_Coverage, 14503,
     /* 1781861 */     GIR_EraseRootFromParent_Done,
     /* 1781862 */   // Label 24116: @1781862
     /* 1781862 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1781951), // Rule ID 14506 //
     /* 1781867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1781887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781913 */     // MIs[0] policy
     /* 1781913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781923 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1781926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1781949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781950 */     // GIR_Coverage, 14506,
     /* 1781950 */     GIR_EraseRootFromParent_Done,
     /* 1781951 */   // Label 24117: @1781951
     /* 1781951 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1782040), // Rule ID 14507 //
     /* 1781956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1781964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1781976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782002 */     // MIs[0] policy
     /* 1782002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1782015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782039 */     // GIR_Coverage, 14507,
     /* 1782039 */     GIR_EraseRootFromParent_Done,
     /* 1782040 */   // Label 24118: @1782040
     /* 1782040 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1782129), // Rule ID 14510 //
     /* 1782045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1782056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1782059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1782062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1782065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782091 */     // MIs[0] policy
     /* 1782091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782101 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1782104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782128 */     // GIR_Coverage, 14510,
     /* 1782128 */     GIR_EraseRootFromParent_Done,
     /* 1782129 */   // Label 24119: @1782129
     /* 1782129 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1782218), // Rule ID 14511 //
     /* 1782134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1782145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1782148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1782151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1782154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782180 */     // MIs[0] policy
     /* 1782180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1782193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782217 */     // GIR_Coverage, 14511,
     /* 1782217 */     GIR_EraseRootFromParent_Done,
     /* 1782218 */   // Label 24120: @1782218
     /* 1782218 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1782307), // Rule ID 14514 //
     /* 1782223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1782234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1782237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1782240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1782243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782269 */     // MIs[0] policy
     /* 1782269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782279 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1782282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782306 */     // GIR_Coverage, 14514,
     /* 1782306 */     GIR_EraseRootFromParent_Done,
     /* 1782307 */   // Label 24121: @1782307
     /* 1782307 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1782396), // Rule ID 14515 //
     /* 1782312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1782323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1782326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1782329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1782332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782358 */     // MIs[0] policy
     /* 1782358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1782371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782395 */     // GIR_Coverage, 14515,
     /* 1782395 */     GIR_EraseRootFromParent_Done,
     /* 1782396 */   // Label 24122: @1782396
     /* 1782396 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1782485), // Rule ID 14518 //
     /* 1782401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1782412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1782415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1782418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1782421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1782431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782447 */     // MIs[0] policy
     /* 1782447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782457 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1782460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782484 */     // GIR_Coverage, 14518,
     /* 1782484 */     GIR_EraseRootFromParent_Done,
     /* 1782485 */   // Label 24123: @1782485
     /* 1782485 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1782574), // Rule ID 14519 //
     /* 1782490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1782501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1782504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1782507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1782510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1782520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782536 */     // MIs[0] policy
     /* 1782536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1782549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782573 */     // GIR_Coverage, 14519,
     /* 1782573 */     GIR_EraseRootFromParent_Done,
     /* 1782574 */   // Label 24124: @1782574
     /* 1782574 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1782663), // Rule ID 14522 //
     /* 1782579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1782590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1782593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1782596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782625 */     // MIs[0] policy
     /* 1782625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782635 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1782638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782662 */     // GIR_Coverage, 14522,
     /* 1782662 */     GIR_EraseRootFromParent_Done,
     /* 1782663 */   // Label 24125: @1782663
     /* 1782663 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1782752), // Rule ID 14523 //
     /* 1782668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1782679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1782682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1782685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782714 */     // MIs[0] policy
     /* 1782714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782724 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1782727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782751 */     // GIR_Coverage, 14523,
     /* 1782751 */     GIR_EraseRootFromParent_Done,
     /* 1782752 */   // Label 24126: @1782752
     /* 1782752 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1782841), // Rule ID 14526 //
     /* 1782757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782803 */     // MIs[0] policy
     /* 1782803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782813 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1782816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782840 */     // GIR_Coverage, 14526,
     /* 1782840 */     GIR_EraseRootFromParent_Done,
     /* 1782841 */   // Label 24127: @1782841
     /* 1782841 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1782930), // Rule ID 14527 //
     /* 1782846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782892 */     // MIs[0] policy
     /* 1782892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1782905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1782928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782929 */     // GIR_Coverage, 14527,
     /* 1782929 */     GIR_EraseRootFromParent_Done,
     /* 1782930 */   // Label 24128: @1782930
     /* 1782930 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1783019), // Rule ID 14530 //
     /* 1782935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1782943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1782946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1782949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1782952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782981 */     // MIs[0] policy
     /* 1782981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782991 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1782994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783018 */     // GIR_Coverage, 14530,
     /* 1783018 */     GIR_EraseRootFromParent_Done,
     /* 1783019 */   // Label 24129: @1783019
     /* 1783019 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1783108), // Rule ID 14531 //
     /* 1783024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1783035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1783038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1783041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783070 */     // MIs[0] policy
     /* 1783070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1783083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783107 */     // GIR_Coverage, 14531,
     /* 1783107 */     GIR_EraseRootFromParent_Done,
     /* 1783108 */   // Label 24130: @1783108
     /* 1783108 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1783197), // Rule ID 14534 //
     /* 1783113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1783124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1783127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1783130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783159 */     // MIs[0] policy
     /* 1783159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1783172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783196 */     // GIR_Coverage, 14534,
     /* 1783196 */     GIR_EraseRootFromParent_Done,
     /* 1783197 */   // Label 24131: @1783197
     /* 1783197 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1783286), // Rule ID 14535 //
     /* 1783202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1783213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1783216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1783219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783248 */     // MIs[0] policy
     /* 1783248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1783261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783285 */     // GIR_Coverage, 14535,
     /* 1783285 */     GIR_EraseRootFromParent_Done,
     /* 1783286 */   // Label 24132: @1783286
     /* 1783286 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1783375), // Rule ID 14538 //
     /* 1783291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1783302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1783305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1783308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783337 */     // MIs[0] policy
     /* 1783337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783347 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1783350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783374 */     // GIR_Coverage, 14538,
     /* 1783374 */     GIR_EraseRootFromParent_Done,
     /* 1783375 */   // Label 24133: @1783375
     /* 1783375 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1783464), // Rule ID 14539 //
     /* 1783380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1783391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1783394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1783397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783426 */     // MIs[0] policy
     /* 1783426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1783439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783463 */     // GIR_Coverage, 14539,
     /* 1783463 */     GIR_EraseRootFromParent_Done,
     /* 1783464 */   // Label 24134: @1783464
     /* 1783464 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1783553), // Rule ID 14542 //
     /* 1783469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1783480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1783483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1783486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783515 */     // MIs[0] policy
     /* 1783515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783525 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1783528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783552 */     // GIR_Coverage, 14542,
     /* 1783552 */     GIR_EraseRootFromParent_Done,
     /* 1783553 */   // Label 24135: @1783553
     /* 1783553 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1783642), // Rule ID 14543 //
     /* 1783558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1783569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1783572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1783575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783604 */     // MIs[0] policy
     /* 1783604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1783617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783641 */     // GIR_Coverage, 14543,
     /* 1783641 */     GIR_EraseRootFromParent_Done,
     /* 1783642 */   // Label 24136: @1783642
     /* 1783642 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1783731), // Rule ID 14546 //
     /* 1783647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1783658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1783661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1783664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783693 */     // MIs[0] policy
     /* 1783693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783703 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1783706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783730 */     // GIR_Coverage, 14546,
     /* 1783730 */     GIR_EraseRootFromParent_Done,
     /* 1783731 */   // Label 24137: @1783731
     /* 1783731 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1783820), // Rule ID 14547 //
     /* 1783736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1783747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1783750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1783753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783782 */     // MIs[0] policy
     /* 1783782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11311:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1783795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783819 */     // GIR_Coverage, 14547,
     /* 1783819 */     GIR_EraseRootFromParent_Done,
     /* 1783820 */   // Label 24138: @1783820
     /* 1783820 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1783909), // Rule ID 14550 //
     /* 1783825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783871 */     // MIs[0] policy
     /* 1783871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783881 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1783884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783908 */     // GIR_Coverage, 14550,
     /* 1783908 */     GIR_EraseRootFromParent_Done,
     /* 1783909 */   // Label 24139: @1783909
     /* 1783909 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1783998), // Rule ID 14551 //
     /* 1783914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1783922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783960 */     // MIs[0] policy
     /* 1783960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1783973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1783996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783997 */     // GIR_Coverage, 14551,
     /* 1783997 */     GIR_EraseRootFromParent_Done,
     /* 1783998 */   // Label 24140: @1783998
     /* 1783998 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1784087), // Rule ID 14554 //
     /* 1784003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1784014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1784017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1784020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784049 */     // MIs[0] policy
     /* 1784049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1784062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784086 */     // GIR_Coverage, 14554,
     /* 1784086 */     GIR_EraseRootFromParent_Done,
     /* 1784087 */   // Label 24141: @1784087
     /* 1784087 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1784176), // Rule ID 14555 //
     /* 1784092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1784103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1784106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1784109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784138 */     // MIs[0] policy
     /* 1784138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1784151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784175 */     // GIR_Coverage, 14555,
     /* 1784175 */     GIR_EraseRootFromParent_Done,
     /* 1784176 */   // Label 24142: @1784176
     /* 1784176 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1784265), // Rule ID 14558 //
     /* 1784181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1784192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1784195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1784198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784227 */     // MIs[0] policy
     /* 1784227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784237 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1784240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784264 */     // GIR_Coverage, 14558,
     /* 1784264 */     GIR_EraseRootFromParent_Done,
     /* 1784265 */   // Label 24143: @1784265
     /* 1784265 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1784354), // Rule ID 14559 //
     /* 1784270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1784281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1784284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1784287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784316 */     // MIs[0] policy
     /* 1784316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1784329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784353 */     // GIR_Coverage, 14559,
     /* 1784353 */     GIR_EraseRootFromParent_Done,
     /* 1784354 */   // Label 24144: @1784354
     /* 1784354 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1784443), // Rule ID 14562 //
     /* 1784359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1784370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1784373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1784376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784405 */     // MIs[0] policy
     /* 1784405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1784418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784442 */     // GIR_Coverage, 14562,
     /* 1784442 */     GIR_EraseRootFromParent_Done,
     /* 1784443 */   // Label 24145: @1784443
     /* 1784443 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1784532), // Rule ID 14563 //
     /* 1784448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1784459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1784462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1784465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784494 */     // MIs[0] policy
     /* 1784494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1784507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784531 */     // GIR_Coverage, 14563,
     /* 1784531 */     GIR_EraseRootFromParent_Done,
     /* 1784532 */   // Label 24146: @1784532
     /* 1784532 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1784621), // Rule ID 14566 //
     /* 1784537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1784548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1784551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1784554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784583 */     // MIs[0] policy
     /* 1784583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1784596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784620 */     // GIR_Coverage, 14566,
     /* 1784620 */     GIR_EraseRootFromParent_Done,
     /* 1784621 */   // Label 24147: @1784621
     /* 1784621 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1784710), // Rule ID 14567 //
     /* 1784626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1784637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1784640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1784643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784672 */     // MIs[0] policy
     /* 1784672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784682 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1784685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784709 */     // GIR_Coverage, 14567,
     /* 1784709 */     GIR_EraseRootFromParent_Done,
     /* 1784710 */   // Label 24148: @1784710
     /* 1784710 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1784799), // Rule ID 14570 //
     /* 1784715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1784726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1784729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1784732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1784738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784761 */     // MIs[0] policy
     /* 1784761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1784774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784798 */     // GIR_Coverage, 14570,
     /* 1784798 */     GIR_EraseRootFromParent_Done,
     /* 1784799 */   // Label 24149: @1784799
     /* 1784799 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1784888), // Rule ID 14571 //
     /* 1784804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1784815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1784818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1784821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1784827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784850 */     // MIs[0] policy
     /* 1784850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1784863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784887 */     // GIR_Coverage, 14571,
     /* 1784887 */     GIR_EraseRootFromParent_Done,
     /* 1784888 */   // Label 24150: @1784888
     /* 1784888 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1784977), // Rule ID 14574 //
     /* 1784893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784939 */     // MIs[0] policy
     /* 1784939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1784952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1784975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784976 */     // GIR_Coverage, 14574,
     /* 1784976 */     GIR_EraseRootFromParent_Done,
     /* 1784977 */   // Label 24151: @1784977
     /* 1784977 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1785066), // Rule ID 14575 //
     /* 1784982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1784990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785028 */     // MIs[0] policy
     /* 1785028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1785041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785065 */     // GIR_Coverage, 14575,
     /* 1785065 */     GIR_EraseRootFromParent_Done,
     /* 1785066 */   // Label 24152: @1785066
     /* 1785066 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1785155), // Rule ID 14578 //
     /* 1785071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1785082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1785085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1785088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785117 */     // MIs[0] policy
     /* 1785117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1785130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785154 */     // GIR_Coverage, 14578,
     /* 1785154 */     GIR_EraseRootFromParent_Done,
     /* 1785155 */   // Label 24153: @1785155
     /* 1785155 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1785244), // Rule ID 14579 //
     /* 1785160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1785171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1785174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1785177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785206 */     // MIs[0] policy
     /* 1785206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1785219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785243 */     // GIR_Coverage, 14579,
     /* 1785243 */     GIR_EraseRootFromParent_Done,
     /* 1785244 */   // Label 24154: @1785244
     /* 1785244 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1785333), // Rule ID 14582 //
     /* 1785249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1785260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1785263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1785266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1785272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785295 */     // MIs[0] policy
     /* 1785295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785305 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1785308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785332 */     // GIR_Coverage, 14582,
     /* 1785332 */     GIR_EraseRootFromParent_Done,
     /* 1785333 */   // Label 24155: @1785333
     /* 1785333 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1785422), // Rule ID 14583 //
     /* 1785338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1785349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1785352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1785355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1785361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785384 */     // MIs[0] policy
     /* 1785384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1785397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785421 */     // GIR_Coverage, 14583,
     /* 1785421 */     GIR_EraseRootFromParent_Done,
     /* 1785422 */   // Label 24156: @1785422
     /* 1785422 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1785511), // Rule ID 14586 //
     /* 1785427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1785438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1785441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1785444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785473 */     // MIs[0] policy
     /* 1785473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1785486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785510 */     // GIR_Coverage, 14586,
     /* 1785510 */     GIR_EraseRootFromParent_Done,
     /* 1785511 */   // Label 24157: @1785511
     /* 1785511 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1785600), // Rule ID 14587 //
     /* 1785516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1785527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1785530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1785533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785562 */     // MIs[0] policy
     /* 1785562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1785575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785599 */     // GIR_Coverage, 14587,
     /* 1785599 */     GIR_EraseRootFromParent_Done,
     /* 1785600 */   // Label 24158: @1785600
     /* 1785600 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1785689), // Rule ID 14590 //
     /* 1785605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1785616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1785619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1785622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785651 */     // MIs[0] policy
     /* 1785651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1785664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785688 */     // GIR_Coverage, 14590,
     /* 1785688 */     GIR_EraseRootFromParent_Done,
     /* 1785689 */   // Label 24159: @1785689
     /* 1785689 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1785778), // Rule ID 14591 //
     /* 1785694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1785705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1785708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1785711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785740 */     // MIs[0] policy
     /* 1785740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1785753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785777 */     // GIR_Coverage, 14591,
     /* 1785777 */     GIR_EraseRootFromParent_Done,
     /* 1785778 */   // Label 24160: @1785778
     /* 1785778 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1785867), // Rule ID 14594 //
     /* 1785783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1785794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785829 */     // MIs[0] policy
     /* 1785829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1785842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785866 */     // GIR_Coverage, 14594,
     /* 1785866 */     GIR_EraseRootFromParent_Done,
     /* 1785867 */   // Label 24161: @1785867
     /* 1785867 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1785956), // Rule ID 14595 //
     /* 1785872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1785883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785918 */     // MIs[0] policy
     /* 1785918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785928 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1785931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1785954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785955 */     // GIR_Coverage, 14595,
     /* 1785955 */     GIR_EraseRootFromParent_Done,
     /* 1785956 */   // Label 24162: @1785956
     /* 1785956 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1786045), // Rule ID 14598 //
     /* 1785961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1785969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1785972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1785975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1785978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786007 */     // MIs[0] policy
     /* 1786007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1786020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786044 */     // GIR_Coverage, 14598,
     /* 1786044 */     GIR_EraseRootFromParent_Done,
     /* 1786045 */   // Label 24163: @1786045
     /* 1786045 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1786134), // Rule ID 14599 //
     /* 1786050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1786058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1786061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1786064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1786067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786096 */     // MIs[0] policy
     /* 1786096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11311:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1786109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786133 */     // GIR_Coverage, 14599,
     /* 1786133 */     GIR_EraseRootFromParent_Done,
     /* 1786134 */   // Label 24164: @1786134
     /* 1786134 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1786223), // Rule ID 14602 //
     /* 1786139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1786147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1786150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1786153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1786156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786185 */     // MIs[0] policy
     /* 1786185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786195 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1786198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786222 */     // GIR_Coverage, 14602,
     /* 1786222 */     GIR_EraseRootFromParent_Done,
     /* 1786223 */   // Label 24165: @1786223
     /* 1786223 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1786312), // Rule ID 14603 //
     /* 1786228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1786236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1786239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1786242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1786245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786274 */     // MIs[0] policy
     /* 1786274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11311:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1786287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786311 */     // GIR_Coverage, 14603,
     /* 1786311 */     GIR_EraseRootFromParent_Done,
     /* 1786312 */   // Label 24166: @1786312
     /* 1786312 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1786401), // Rule ID 14606 //
     /* 1786317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1786325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1786328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1786331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1786334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786363 */     // MIs[0] policy
     /* 1786363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786373 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1786376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786400 */     // GIR_Coverage, 14606,
     /* 1786400 */     GIR_EraseRootFromParent_Done,
     /* 1786401 */   // Label 24167: @1786401
     /* 1786401 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1786490), // Rule ID 14607 //
     /* 1786406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1786414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1786417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1786420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1786423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786452 */     // MIs[0] policy
     /* 1786452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786462 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11311:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1786465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786489 */     // GIR_Coverage, 14607,
     /* 1786489 */     GIR_EraseRootFromParent_Done,
     /* 1786490 */   // Label 24168: @1786490
     /* 1786490 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1786579), // Rule ID 14610 //
     /* 1786495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1786506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1786509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1786512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1786515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786541 */     // MIs[0] policy
     /* 1786541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1786554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786578 */     // GIR_Coverage, 14610,
     /* 1786578 */     GIR_EraseRootFromParent_Done,
     /* 1786579 */   // Label 24169: @1786579
     /* 1786579 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1786668), // Rule ID 14611 //
     /* 1786584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1786595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1786598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1786601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1786604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786630 */     // MIs[0] policy
     /* 1786630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1786643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786667 */     // GIR_Coverage, 14611,
     /* 1786667 */     GIR_EraseRootFromParent_Done,
     /* 1786668 */   // Label 24170: @1786668
     /* 1786668 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1786757), // Rule ID 14614 //
     /* 1786673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1786684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1786687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1786690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1786693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786719 */     // MIs[0] policy
     /* 1786719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786729 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1786732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786756 */     // GIR_Coverage, 14614,
     /* 1786756 */     GIR_EraseRootFromParent_Done,
     /* 1786757 */   // Label 24171: @1786757
     /* 1786757 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1786846), // Rule ID 14615 //
     /* 1786762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1786773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1786776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1786779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1786782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786808 */     // MIs[0] policy
     /* 1786808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786818 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1786821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786845 */     // GIR_Coverage, 14615,
     /* 1786845 */     GIR_EraseRootFromParent_Done,
     /* 1786846 */   // Label 24172: @1786846
     /* 1786846 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1786935), // Rule ID 14618 //
     /* 1786851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1786871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786897 */     // MIs[0] policy
     /* 1786897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786907 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1786910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1786933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786934 */     // GIR_Coverage, 14618,
     /* 1786934 */     GIR_EraseRootFromParent_Done,
     /* 1786935 */   // Label 24173: @1786935
     /* 1786935 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1787024), // Rule ID 14619 //
     /* 1786940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1786948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1786960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786986 */     // MIs[0] policy
     /* 1786986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1786999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787023 */     // GIR_Coverage, 14619,
     /* 1787023 */     GIR_EraseRootFromParent_Done,
     /* 1787024 */   // Label 24174: @1787024
     /* 1787024 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1787113), // Rule ID 14622 //
     /* 1787029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1787040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1787043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1787046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1787049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787075 */     // MIs[0] policy
     /* 1787075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1787088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787112 */     // GIR_Coverage, 14622,
     /* 1787112 */     GIR_EraseRootFromParent_Done,
     /* 1787113 */   // Label 24175: @1787113
     /* 1787113 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1787202), // Rule ID 14623 //
     /* 1787118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1787129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1787132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1787135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1787138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787164 */     // MIs[0] policy
     /* 1787164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1787177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787201 */     // GIR_Coverage, 14623,
     /* 1787201 */     GIR_EraseRootFromParent_Done,
     /* 1787202 */   // Label 24176: @1787202
     /* 1787202 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1787291), // Rule ID 14626 //
     /* 1787207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1787218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1787221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1787224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1787227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787253 */     // MIs[0] policy
     /* 1787253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787263 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1787266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787290 */     // GIR_Coverage, 14626,
     /* 1787290 */     GIR_EraseRootFromParent_Done,
     /* 1787291 */   // Label 24177: @1787291
     /* 1787291 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1787380), // Rule ID 14627 //
     /* 1787296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1787307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1787310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1787313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1787316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787342 */     // MIs[0] policy
     /* 1787342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1787355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787379 */     // GIR_Coverage, 14627,
     /* 1787379 */     GIR_EraseRootFromParent_Done,
     /* 1787380 */   // Label 24178: @1787380
     /* 1787380 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1787469), // Rule ID 14630 //
     /* 1787385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1787396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1787399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1787402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1787405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787431 */     // MIs[0] policy
     /* 1787431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787441 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1787444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787468 */     // GIR_Coverage, 14630,
     /* 1787468 */     GIR_EraseRootFromParent_Done,
     /* 1787469 */   // Label 24179: @1787469
     /* 1787469 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1787558), // Rule ID 14631 //
     /* 1787474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1787485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1787488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1787491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1787494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787520 */     // MIs[0] policy
     /* 1787520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1787533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787557 */     // GIR_Coverage, 14631,
     /* 1787557 */     GIR_EraseRootFromParent_Done,
     /* 1787558 */   // Label 24180: @1787558
     /* 1787558 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1787647), // Rule ID 14634 //
     /* 1787563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1787574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1787577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1787580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1787583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787609 */     // MIs[0] policy
     /* 1787609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1787622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787646 */     // GIR_Coverage, 14634,
     /* 1787646 */     GIR_EraseRootFromParent_Done,
     /* 1787647 */   // Label 24181: @1787647
     /* 1787647 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1787736), // Rule ID 14635 //
     /* 1787652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1787663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1787666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1787669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1787672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787698 */     // MIs[0] policy
     /* 1787698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1787711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787735 */     // GIR_Coverage, 14635,
     /* 1787735 */     GIR_EraseRootFromParent_Done,
     /* 1787736 */   // Label 24182: @1787736
     /* 1787736 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1787825), // Rule ID 14638 //
     /* 1787741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1787752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1787755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1787758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1787761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787787 */     // MIs[0] policy
     /* 1787787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787797 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1787800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787824 */     // GIR_Coverage, 14638,
     /* 1787824 */     GIR_EraseRootFromParent_Done,
     /* 1787825 */   // Label 24183: @1787825
     /* 1787825 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1787914), // Rule ID 14639 //
     /* 1787830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1787841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1787844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1787847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1787850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787876 */     // MIs[0] policy
     /* 1787876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1787889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1787912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787913 */     // GIR_Coverage, 14639,
     /* 1787913 */     GIR_EraseRootFromParent_Done,
     /* 1787914 */   // Label 24184: @1787914
     /* 1787914 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1788003), // Rule ID 14642 //
     /* 1787919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1787927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1787930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1787933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1787936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1787939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787965 */     // MIs[0] policy
     /* 1787965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1787978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788002 */     // GIR_Coverage, 14642,
     /* 1788002 */     GIR_EraseRootFromParent_Done,
     /* 1788003 */   // Label 24185: @1788003
     /* 1788003 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1788092), // Rule ID 14643 //
     /* 1788008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1788019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1788022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1788025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1788028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788054 */     // MIs[0] policy
     /* 1788054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1788067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788091 */     // GIR_Coverage, 14643,
     /* 1788091 */     GIR_EraseRootFromParent_Done,
     /* 1788092 */   // Label 24186: @1788092
     /* 1788092 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1788181), // Rule ID 14646 //
     /* 1788097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1788108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1788111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1788114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1788117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788143 */     // MIs[0] policy
     /* 1788143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1788156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788180 */     // GIR_Coverage, 14646,
     /* 1788180 */     GIR_EraseRootFromParent_Done,
     /* 1788181 */   // Label 24187: @1788181
     /* 1788181 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1788270), // Rule ID 14647 //
     /* 1788186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1788197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1788200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1788203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1788206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788232 */     // MIs[0] policy
     /* 1788232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1788245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788269 */     // GIR_Coverage, 14647,
     /* 1788269 */     GIR_EraseRootFromParent_Done,
     /* 1788270 */   // Label 24188: @1788270
     /* 1788270 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1788359), // Rule ID 14650 //
     /* 1788275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1788286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1788289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1788292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1788295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788321 */     // MIs[0] policy
     /* 1788321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1788334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788358 */     // GIR_Coverage, 14650,
     /* 1788358 */     GIR_EraseRootFromParent_Done,
     /* 1788359 */   // Label 24189: @1788359
     /* 1788359 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1788448), // Rule ID 14651 //
     /* 1788364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1788375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1788378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1788381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1788384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788410 */     // MIs[0] policy
     /* 1788410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1788423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788447 */     // GIR_Coverage, 14651,
     /* 1788447 */     GIR_EraseRootFromParent_Done,
     /* 1788448 */   // Label 24190: @1788448
     /* 1788448 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1788537), // Rule ID 14654 //
     /* 1788453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1788464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1788467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1788470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1788473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788499 */     // MIs[0] policy
     /* 1788499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1788512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788536 */     // GIR_Coverage, 14654,
     /* 1788536 */     GIR_EraseRootFromParent_Done,
     /* 1788537 */   // Label 24191: @1788537
     /* 1788537 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1788626), // Rule ID 14655 //
     /* 1788542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1788553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1788556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1788559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1788562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788588 */     // MIs[0] policy
     /* 1788588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1788601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788625 */     // GIR_Coverage, 14655,
     /* 1788625 */     GIR_EraseRootFromParent_Done,
     /* 1788626 */   // Label 24192: @1788626
     /* 1788626 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1788715), // Rule ID 14658 //
     /* 1788631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1788642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1788645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1788648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1788651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1788654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788677 */     // MIs[0] policy
     /* 1788677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788687 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1788690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788714 */     // GIR_Coverage, 14658,
     /* 1788714 */     GIR_EraseRootFromParent_Done,
     /* 1788715 */   // Label 24193: @1788715
     /* 1788715 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1788804), // Rule ID 14659 //
     /* 1788720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1788731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1788734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1788737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1788740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1788743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788766 */     // MIs[0] policy
     /* 1788766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1788779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788803 */     // GIR_Coverage, 14659,
     /* 1788803 */     GIR_EraseRootFromParent_Done,
     /* 1788804 */   // Label 24194: @1788804
     /* 1788804 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1788893), // Rule ID 14662 //
     /* 1788809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1788820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1788823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1788826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1788829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788855 */     // MIs[0] policy
     /* 1788855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1788868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788892 */     // GIR_Coverage, 14662,
     /* 1788892 */     GIR_EraseRootFromParent_Done,
     /* 1788893 */   // Label 24195: @1788893
     /* 1788893 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1788982), // Rule ID 14663 //
     /* 1788898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1788909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1788912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1788915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1788918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788944 */     // MIs[0] policy
     /* 1788944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1788957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1788980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788981 */     // GIR_Coverage, 14663,
     /* 1788981 */     GIR_EraseRootFromParent_Done,
     /* 1788982 */   // Label 24196: @1788982
     /* 1788982 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1789071), // Rule ID 14666 //
     /* 1788987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1788995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1788998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1789001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1789004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1789007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789033 */     // MIs[0] policy
     /* 1789033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1789046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789070 */     // GIR_Coverage, 14666,
     /* 1789070 */     GIR_EraseRootFromParent_Done,
     /* 1789071 */   // Label 24197: @1789071
     /* 1789071 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1789160), // Rule ID 14667 //
     /* 1789076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1789087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1789090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1789093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1789096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789122 */     // MIs[0] policy
     /* 1789122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1789135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789159 */     // GIR_Coverage, 14667,
     /* 1789159 */     GIR_EraseRootFromParent_Done,
     /* 1789160 */   // Label 24198: @1789160
     /* 1789160 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1789249), // Rule ID 14670 //
     /* 1789165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1789176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1789179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1789182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1789185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1789188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789211 */     // MIs[0] policy
     /* 1789211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1789224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789248 */     // GIR_Coverage, 14670,
     /* 1789248 */     GIR_EraseRootFromParent_Done,
     /* 1789249 */   // Label 24199: @1789249
     /* 1789249 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1789338), // Rule ID 14671 //
     /* 1789254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1789265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1789268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1789271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1789274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1789277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789300 */     // MIs[0] policy
     /* 1789300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789310 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1789313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789337 */     // GIR_Coverage, 14671,
     /* 1789337 */     GIR_EraseRootFromParent_Done,
     /* 1789338 */   // Label 24200: @1789338
     /* 1789338 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1789427), // Rule ID 14674 //
     /* 1789343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1789354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1789357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1789360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1789363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789389 */     // MIs[0] policy
     /* 1789389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1789402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789426 */     // GIR_Coverage, 14674,
     /* 1789426 */     GIR_EraseRootFromParent_Done,
     /* 1789427 */   // Label 24201: @1789427
     /* 1789427 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1789516), // Rule ID 14675 //
     /* 1789432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1789443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1789446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1789449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1789452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789478 */     // MIs[0] policy
     /* 1789478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1789491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789515 */     // GIR_Coverage, 14675,
     /* 1789515 */     GIR_EraseRootFromParent_Done,
     /* 1789516 */   // Label 24202: @1789516
     /* 1789516 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1789605), // Rule ID 14678 //
     /* 1789521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1789532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1789535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1789538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1789541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789567 */     // MIs[0] policy
     /* 1789567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1789580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789604 */     // GIR_Coverage, 14678,
     /* 1789604 */     GIR_EraseRootFromParent_Done,
     /* 1789605 */   // Label 24203: @1789605
     /* 1789605 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1789694), // Rule ID 14679 //
     /* 1789610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1789621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1789624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1789627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1789630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789656 */     // MIs[0] policy
     /* 1789656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1789669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789693 */     // GIR_Coverage, 14679,
     /* 1789693 */     GIR_EraseRootFromParent_Done,
     /* 1789694 */   // Label 24204: @1789694
     /* 1789694 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1789783), // Rule ID 14682 //
     /* 1789699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1789710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1789713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1789716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1789719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789745 */     // MIs[0] policy
     /* 1789745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789755 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1789758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789782 */     // GIR_Coverage, 14682,
     /* 1789782 */     GIR_EraseRootFromParent_Done,
     /* 1789783 */   // Label 24205: @1789783
     /* 1789783 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1789872), // Rule ID 14683 //
     /* 1789788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1789799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1789802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1789805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1789808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789834 */     // MIs[0] policy
     /* 1789834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1789847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789871 */     // GIR_Coverage, 14683,
     /* 1789871 */     GIR_EraseRootFromParent_Done,
     /* 1789872 */   // Label 24206: @1789872
     /* 1789872 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1789961), // Rule ID 14686 //
     /* 1789877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1789888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1789891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1789894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1789897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789923 */     // MIs[0] policy
     /* 1789923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1789936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1789959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789960 */     // GIR_Coverage, 14686,
     /* 1789960 */     GIR_EraseRootFromParent_Done,
     /* 1789961 */   // Label 24207: @1789961
     /* 1789961 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1790050), // Rule ID 14687 //
     /* 1789966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1789974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1789977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1789980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1789983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1789986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790012 */     // MIs[0] policy
     /* 1790012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1790025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790049 */     // GIR_Coverage, 14687,
     /* 1790049 */     GIR_EraseRootFromParent_Done,
     /* 1790050 */   // Label 24208: @1790050
     /* 1790050 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1790139), // Rule ID 14690 //
     /* 1790055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1790066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1790069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1790072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1790075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790101 */     // MIs[0] policy
     /* 1790101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1790114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790138 */     // GIR_Coverage, 14690,
     /* 1790138 */     GIR_EraseRootFromParent_Done,
     /* 1790139 */   // Label 24209: @1790139
     /* 1790139 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1790228), // Rule ID 14691 //
     /* 1790144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1790155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1790158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1790161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1790164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790190 */     // MIs[0] policy
     /* 1790190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1790203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790227 */     // GIR_Coverage, 14691,
     /* 1790227 */     GIR_EraseRootFromParent_Done,
     /* 1790228 */   // Label 24210: @1790228
     /* 1790228 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1790317), // Rule ID 14694 //
     /* 1790233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1790244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1790247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1790250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1790253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790279 */     // MIs[0] policy
     /* 1790279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1790292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790316 */     // GIR_Coverage, 14694,
     /* 1790316 */     GIR_EraseRootFromParent_Done,
     /* 1790317 */   // Label 24211: @1790317
     /* 1790317 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1790406), // Rule ID 14695 //
     /* 1790322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1790333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1790336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1790339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1790342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790368 */     // MIs[0] policy
     /* 1790368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790378 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1790381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790405 */     // GIR_Coverage, 14695,
     /* 1790405 */     GIR_EraseRootFromParent_Done,
     /* 1790406 */   // Label 24212: @1790406
     /* 1790406 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1790495), // Rule ID 14698 //
     /* 1790411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1790422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1790425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1790428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790457 */     // MIs[0] policy
     /* 1790457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790467 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1790470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790494 */     // GIR_Coverage, 14698,
     /* 1790494 */     GIR_EraseRootFromParent_Done,
     /* 1790495 */   // Label 24213: @1790495
     /* 1790495 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1790584), // Rule ID 14699 //
     /* 1790500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1790511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1790514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1790517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790546 */     // MIs[0] policy
     /* 1790546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790556 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1790559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790583 */     // GIR_Coverage, 14699,
     /* 1790583 */     GIR_EraseRootFromParent_Done,
     /* 1790584 */   // Label 24214: @1790584
     /* 1790584 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1790673), // Rule ID 14702 //
     /* 1790589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1790600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1790603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1790606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790635 */     // MIs[0] policy
     /* 1790635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790645 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1790648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790672 */     // GIR_Coverage, 14702,
     /* 1790672 */     GIR_EraseRootFromParent_Done,
     /* 1790673 */   // Label 24215: @1790673
     /* 1790673 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1790762), // Rule ID 14703 //
     /* 1790678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1790689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1790692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1790695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790724 */     // MIs[0] policy
     /* 1790724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1790737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790761 */     // GIR_Coverage, 14703,
     /* 1790761 */     GIR_EraseRootFromParent_Done,
     /* 1790762 */   // Label 24216: @1790762
     /* 1790762 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1790851), // Rule ID 14706 //
     /* 1790767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1790778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1790781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1790784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790813 */     // MIs[0] policy
     /* 1790813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790823 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1790826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790850 */     // GIR_Coverage, 14706,
     /* 1790850 */     GIR_EraseRootFromParent_Done,
     /* 1790851 */   // Label 24217: @1790851
     /* 1790851 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1790940), // Rule ID 14707 //
     /* 1790856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1790867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1790870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1790873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790902 */     // MIs[0] policy
     /* 1790902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1790915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1790938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790939 */     // GIR_Coverage, 14707,
     /* 1790939 */     GIR_EraseRootFromParent_Done,
     /* 1790940 */   // Label 24218: @1790940
     /* 1790940 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1791029), // Rule ID 14710 //
     /* 1790945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1790953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1790956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1790959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1790962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790991 */     // MIs[0] policy
     /* 1790991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791001 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1791004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791028 */     // GIR_Coverage, 14710,
     /* 1791028 */     GIR_EraseRootFromParent_Done,
     /* 1791029 */   // Label 24219: @1791029
     /* 1791029 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1791118), // Rule ID 14711 //
     /* 1791034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1791045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1791048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1791051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791080 */     // MIs[0] policy
     /* 1791080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791090 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1791093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791117 */     // GIR_Coverage, 14711,
     /* 1791117 */     GIR_EraseRootFromParent_Done,
     /* 1791118 */   // Label 24220: @1791118
     /* 1791118 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1791207), // Rule ID 14714 //
     /* 1791123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1791134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1791137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1791140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791169 */     // MIs[0] policy
     /* 1791169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1791182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791206 */     // GIR_Coverage, 14714,
     /* 1791206 */     GIR_EraseRootFromParent_Done,
     /* 1791207 */   // Label 24221: @1791207
     /* 1791207 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1791296), // Rule ID 14715 //
     /* 1791212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1791223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1791226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1791229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791258 */     // MIs[0] policy
     /* 1791258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1791271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791295 */     // GIR_Coverage, 14715,
     /* 1791295 */     GIR_EraseRootFromParent_Done,
     /* 1791296 */   // Label 24222: @1791296
     /* 1791296 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1791385), // Rule ID 14718 //
     /* 1791301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1791312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1791315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1791318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791347 */     // MIs[0] policy
     /* 1791347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791357 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1791360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791384 */     // GIR_Coverage, 14718,
     /* 1791384 */     GIR_EraseRootFromParent_Done,
     /* 1791385 */   // Label 24223: @1791385
     /* 1791385 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1791474), // Rule ID 14719 //
     /* 1791390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1791401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1791404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1791407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791436 */     // MIs[0] policy
     /* 1791436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1791449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791473 */     // GIR_Coverage, 14719,
     /* 1791473 */     GIR_EraseRootFromParent_Done,
     /* 1791474 */   // Label 24224: @1791474
     /* 1791474 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1791563), // Rule ID 14722 //
     /* 1791479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1791490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1791493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1791496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791525 */     // MIs[0] policy
     /* 1791525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791535 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791562 */     // GIR_Coverage, 14722,
     /* 1791562 */     GIR_EraseRootFromParent_Done,
     /* 1791563 */   // Label 24225: @1791563
     /* 1791563 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1791652), // Rule ID 14723 //
     /* 1791568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1791579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1791582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1791585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791614 */     // MIs[0] policy
     /* 1791614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11309:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791651 */     // GIR_Coverage, 14723,
     /* 1791651 */     GIR_EraseRootFromParent_Done,
     /* 1791652 */   // Label 24226: @1791652
     /* 1791652 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1791741), // Rule ID 14726 //
     /* 1791657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1791668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1791671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1791674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791703 */     // MIs[0] policy
     /* 1791703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791713 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791740 */     // GIR_Coverage, 14726,
     /* 1791740 */     GIR_EraseRootFromParent_Done,
     /* 1791741 */   // Label 24227: @1791741
     /* 1791741 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1791830), // Rule ID 14727 //
     /* 1791746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1791757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1791760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1791763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791792 */     // MIs[0] policy
     /* 1791792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791829 */     // GIR_Coverage, 14727,
     /* 1791829 */     GIR_EraseRootFromParent_Done,
     /* 1791830 */   // Label 24228: @1791830
     /* 1791830 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1791919), // Rule ID 14730 //
     /* 1791835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1791846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1791849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1791852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791881 */     // MIs[0] policy
     /* 1791881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791891 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1791917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791918 */     // GIR_Coverage, 14730,
     /* 1791918 */     GIR_EraseRootFromParent_Done,
     /* 1791919 */   // Label 24229: @1791919
     /* 1791919 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1792008), // Rule ID 14731 //
     /* 1791924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1791932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1791935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1791938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1791941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791970 */     // MIs[0] policy
     /* 1791970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1791983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792007 */     // GIR_Coverage, 14731,
     /* 1792007 */     GIR_EraseRootFromParent_Done,
     /* 1792008 */   // Label 24230: @1792008
     /* 1792008 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1792097), // Rule ID 14734 //
     /* 1792013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1792024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1792027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1792030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792059 */     // MIs[0] policy
     /* 1792059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792069 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1792072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792096 */     // GIR_Coverage, 14734,
     /* 1792096 */     GIR_EraseRootFromParent_Done,
     /* 1792097 */   // Label 24231: @1792097
     /* 1792097 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1792186), // Rule ID 14735 //
     /* 1792102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1792113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1792116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1792119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792148 */     // MIs[0] policy
     /* 1792148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1792161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792185 */     // GIR_Coverage, 14735,
     /* 1792185 */     GIR_EraseRootFromParent_Done,
     /* 1792186 */   // Label 24232: @1792186
     /* 1792186 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1792275), // Rule ID 14738 //
     /* 1792191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1792202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1792205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1792208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792237 */     // MIs[0] policy
     /* 1792237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1792250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792274 */     // GIR_Coverage, 14738,
     /* 1792274 */     GIR_EraseRootFromParent_Done,
     /* 1792275 */   // Label 24233: @1792275
     /* 1792275 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1792364), // Rule ID 14739 //
     /* 1792280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1792291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1792294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1792297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792326 */     // MIs[0] policy
     /* 1792326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1792339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792363 */     // GIR_Coverage, 14739,
     /* 1792363 */     GIR_EraseRootFromParent_Done,
     /* 1792364 */   // Label 24234: @1792364
     /* 1792364 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1792453), // Rule ID 14742 //
     /* 1792369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1792380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1792383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1792386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792415 */     // MIs[0] policy
     /* 1792415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792425 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1792428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792452 */     // GIR_Coverage, 14742,
     /* 1792452 */     GIR_EraseRootFromParent_Done,
     /* 1792453 */   // Label 24235: @1792453
     /* 1792453 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1792542), // Rule ID 14743 //
     /* 1792458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1792469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1792472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1792475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792504 */     // MIs[0] policy
     /* 1792504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1792517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792541 */     // GIR_Coverage, 14743,
     /* 1792541 */     GIR_EraseRootFromParent_Done,
     /* 1792542 */   // Label 24236: @1792542
     /* 1792542 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1792631), // Rule ID 14746 //
     /* 1792547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1792558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1792561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1792564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1792570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792593 */     // MIs[0] policy
     /* 1792593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792603 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1792606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792630 */     // GIR_Coverage, 14746,
     /* 1792630 */     GIR_EraseRootFromParent_Done,
     /* 1792631 */   // Label 24237: @1792631
     /* 1792631 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1792720), // Rule ID 14747 //
     /* 1792636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1792647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1792650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1792653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1792659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792682 */     // MIs[0] policy
     /* 1792682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792692 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1792695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792719 */     // GIR_Coverage, 14747,
     /* 1792719 */     GIR_EraseRootFromParent_Done,
     /* 1792720 */   // Label 24238: @1792720
     /* 1792720 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1792809), // Rule ID 14750 //
     /* 1792725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1792736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1792739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1792742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792771 */     // MIs[0] policy
     /* 1792771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1792784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792808 */     // GIR_Coverage, 14750,
     /* 1792808 */     GIR_EraseRootFromParent_Done,
     /* 1792809 */   // Label 24239: @1792809
     /* 1792809 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1792898), // Rule ID 14751 //
     /* 1792814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1792825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1792828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1792831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792860 */     // MIs[0] policy
     /* 1792860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1792873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792897 */     // GIR_Coverage, 14751,
     /* 1792897 */     GIR_EraseRootFromParent_Done,
     /* 1792898 */   // Label 24240: @1792898
     /* 1792898 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1792987), // Rule ID 14754 //
     /* 1792903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1792911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1792914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1792917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1792920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792949 */     // MIs[0] policy
     /* 1792949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1792962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1792985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792986 */     // GIR_Coverage, 14754,
     /* 1792986 */     GIR_EraseRootFromParent_Done,
     /* 1792987 */   // Label 24241: @1792987
     /* 1792987 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1793076), // Rule ID 14755 //
     /* 1792992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1793003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1793006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1793009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793038 */     // MIs[0] policy
     /* 1793038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1793051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793075 */     // GIR_Coverage, 14755,
     /* 1793075 */     GIR_EraseRootFromParent_Done,
     /* 1793076 */   // Label 24242: @1793076
     /* 1793076 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1793165), // Rule ID 14758 //
     /* 1793081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1793092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1793095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1793098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1793104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793127 */     // MIs[0] policy
     /* 1793127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793137 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1793140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793164 */     // GIR_Coverage, 14758,
     /* 1793164 */     GIR_EraseRootFromParent_Done,
     /* 1793165 */   // Label 24243: @1793165
     /* 1793165 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1793254), // Rule ID 14759 //
     /* 1793170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1793181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1793184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1793187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1793193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793216 */     // MIs[0] policy
     /* 1793216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1793229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793253 */     // GIR_Coverage, 14759,
     /* 1793253 */     GIR_EraseRootFromParent_Done,
     /* 1793254 */   // Label 24244: @1793254
     /* 1793254 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1793343), // Rule ID 14762 //
     /* 1793259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1793270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1793273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1793276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793305 */     // MIs[0] policy
     /* 1793305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1793318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793342 */     // GIR_Coverage, 14762,
     /* 1793342 */     GIR_EraseRootFromParent_Done,
     /* 1793343 */   // Label 24245: @1793343
     /* 1793343 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1793432), // Rule ID 14763 //
     /* 1793348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1793359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1793362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1793365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793394 */     // MIs[0] policy
     /* 1793394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1793407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793431 */     // GIR_Coverage, 14763,
     /* 1793431 */     GIR_EraseRootFromParent_Done,
     /* 1793432 */   // Label 24246: @1793432
     /* 1793432 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1793521), // Rule ID 14766 //
     /* 1793437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1793448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1793451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1793454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793483 */     // MIs[0] policy
     /* 1793483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1793496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793520 */     // GIR_Coverage, 14766,
     /* 1793520 */     GIR_EraseRootFromParent_Done,
     /* 1793521 */   // Label 24247: @1793521
     /* 1793521 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1793610), // Rule ID 14767 //
     /* 1793526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1793537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1793540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1793543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793572 */     // MIs[0] policy
     /* 1793572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1793585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793609 */     // GIR_Coverage, 14767,
     /* 1793609 */     GIR_EraseRootFromParent_Done,
     /* 1793610 */   // Label 24248: @1793610
     /* 1793610 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1793699), // Rule ID 14770 //
     /* 1793615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1793626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1793629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1793632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793661 */     // MIs[0] policy
     /* 1793661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1793674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793698 */     // GIR_Coverage, 14770,
     /* 1793698 */     GIR_EraseRootFromParent_Done,
     /* 1793699 */   // Label 24249: @1793699
     /* 1793699 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1793788), // Rule ID 14771 //
     /* 1793704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1793715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1793718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1793721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793750 */     // MIs[0] policy
     /* 1793750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1793763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793787 */     // GIR_Coverage, 14771,
     /* 1793787 */     GIR_EraseRootFromParent_Done,
     /* 1793788 */   // Label 24250: @1793788
     /* 1793788 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1793877), // Rule ID 14774 //
     /* 1793793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1793804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1793807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1793810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793839 */     // MIs[0] policy
     /* 1793839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1793852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793876 */     // GIR_Coverage, 14774,
     /* 1793876 */     GIR_EraseRootFromParent_Done,
     /* 1793877 */   // Label 24251: @1793877
     /* 1793877 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1793966), // Rule ID 14775 //
     /* 1793882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1793893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1793896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1793899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793928 */     // MIs[0] policy
     /* 1793928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1793941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1793964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793965 */     // GIR_Coverage, 14775,
     /* 1793965 */     GIR_EraseRootFromParent_Done,
     /* 1793966 */   // Label 24252: @1793966
     /* 1793966 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1794055), // Rule ID 14778 //
     /* 1793971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1793979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1793982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1793985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1793988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794017 */     // MIs[0] policy
     /* 1794017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1794030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1794053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794054 */     // GIR_Coverage, 14778,
     /* 1794054 */     GIR_EraseRootFromParent_Done,
     /* 1794055 */   // Label 24253: @1794055
     /* 1794055 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1794144), // Rule ID 14779 //
     /* 1794060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1794063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1794068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1794071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1794074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1794077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794106 */     // MIs[0] policy
     /* 1794106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1794119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1794142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794143 */     // GIR_Coverage, 14779,
     /* 1794143 */     GIR_EraseRootFromParent_Done,
     /* 1794144 */   // Label 24254: @1794144
     /* 1794144 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1794233), // Rule ID 14782 //
     /* 1794149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1794152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1794157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1794160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1794163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1794166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794195 */     // MIs[0] policy
     /* 1794195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794205 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1794208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1794231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794232 */     // GIR_Coverage, 14782,
     /* 1794232 */     GIR_EraseRootFromParent_Done,
     /* 1794233 */   // Label 24255: @1794233
     /* 1794233 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1794322), // Rule ID 14783 //
     /* 1794238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1794241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1794246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1794249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1794252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1794255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794284 */     // MIs[0] policy
     /* 1794284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1794297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1794320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794321 */     // GIR_Coverage, 14783,
     /* 1794321 */     GIR_EraseRootFromParent_Done,
     /* 1794322 */   // Label 24256: @1794322
     /* 1794322 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1794408), // Rule ID 19024 //
     /* 1794327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1794330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1794338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1794341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1794347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794373 */     // MIs[0] policy
     /* 1794373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1794386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794407 */     // GIR_Coverage, 19024,
     /* 1794407 */     GIR_EraseRootFromParent_Done,
     /* 1794408 */   // Label 24257: @1794408
     /* 1794408 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1794494), // Rule ID 19025 //
     /* 1794413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1794416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1794424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1794427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1794433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794459 */     // MIs[0] policy
     /* 1794459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794469 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1794472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794493 */     // GIR_Coverage, 19025,
     /* 1794493 */     GIR_EraseRootFromParent_Done,
     /* 1794494 */   // Label 24258: @1794494
     /* 1794494 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1794580), // Rule ID 19028 //
     /* 1794499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1794502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1794510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1794513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1794519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794545 */     // MIs[0] policy
     /* 1794545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794555 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1794558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794579 */     // GIR_Coverage, 19028,
     /* 1794579 */     GIR_EraseRootFromParent_Done,
     /* 1794580 */   // Label 24259: @1794580
     /* 1794580 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1794666), // Rule ID 19029 //
     /* 1794585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1794588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1794596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1794599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1794605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794631 */     // MIs[0] policy
     /* 1794631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794641 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1794644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794665 */     // GIR_Coverage, 19029,
     /* 1794665 */     GIR_EraseRootFromParent_Done,
     /* 1794666 */   // Label 24260: @1794666
     /* 1794666 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1794752), // Rule ID 19032 //
     /* 1794671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1794674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1794688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1794691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794717 */     // MIs[0] policy
     /* 1794717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794727 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1794730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794751 */     // GIR_Coverage, 19032,
     /* 1794751 */     GIR_EraseRootFromParent_Done,
     /* 1794752 */   // Label 24261: @1794752
     /* 1794752 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1794838), // Rule ID 19033 //
     /* 1794757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1794760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1794774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1794777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794803 */     // MIs[0] policy
     /* 1794803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794813 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1794816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794837 */     // GIR_Coverage, 19033,
     /* 1794837 */     GIR_EraseRootFromParent_Done,
     /* 1794838 */   // Label 24262: @1794838
     /* 1794838 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1794924), // Rule ID 19036 //
     /* 1794843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1794846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1794854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1794857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794889 */     // MIs[0] policy
     /* 1794889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1794902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794923 */     // GIR_Coverage, 19036,
     /* 1794923 */     GIR_EraseRootFromParent_Done,
     /* 1794924 */   // Label 24263: @1794924
     /* 1794924 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1795010), // Rule ID 19037 //
     /* 1794929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1794932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1794937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1794940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1794943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794975 */     // MIs[0] policy
     /* 1794975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794985 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1794988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795009 */     // GIR_Coverage, 19037,
     /* 1795009 */     GIR_EraseRootFromParent_Done,
     /* 1795010 */   // Label 24264: @1795010
     /* 1795010 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1795096), // Rule ID 19040 //
     /* 1795015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1795018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1795026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1795029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1795035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795061 */     // MIs[0] policy
     /* 1795061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795071 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1795074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795095 */     // GIR_Coverage, 19040,
     /* 1795095 */     GIR_EraseRootFromParent_Done,
     /* 1795096 */   // Label 24265: @1795096
     /* 1795096 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1795182), // Rule ID 19041 //
     /* 1795101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1795104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1795112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1795115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1795121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795147 */     // MIs[0] policy
     /* 1795147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795157 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1795160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795181 */     // GIR_Coverage, 19041,
     /* 1795181 */     GIR_EraseRootFromParent_Done,
     /* 1795182 */   // Label 24266: @1795182
     /* 1795182 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1795268), // Rule ID 19044 //
     /* 1795187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1795190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1795204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1795207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795233 */     // MIs[0] policy
     /* 1795233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795243 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1795246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795267 */     // GIR_Coverage, 19044,
     /* 1795267 */     GIR_EraseRootFromParent_Done,
     /* 1795268 */   // Label 24267: @1795268
     /* 1795268 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1795354), // Rule ID 19045 //
     /* 1795273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1795276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1795290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1795293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795319 */     // MIs[0] policy
     /* 1795319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795329 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1795332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795353 */     // GIR_Coverage, 19045,
     /* 1795353 */     GIR_EraseRootFromParent_Done,
     /* 1795354 */   // Label 24268: @1795354
     /* 1795354 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1795440), // Rule ID 19048 //
     /* 1795359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1795362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1795370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1795373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1795376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1795379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795405 */     // MIs[0] policy
     /* 1795405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1795418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795439 */     // GIR_Coverage, 19048,
     /* 1795439 */     GIR_EraseRootFromParent_Done,
     /* 1795440 */   // Label 24269: @1795440
     /* 1795440 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1795526), // Rule ID 19049 //
     /* 1795445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1795448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1795456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1795459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1795462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1795465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795491 */     // MIs[0] policy
     /* 1795491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795501 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1795504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795525 */     // GIR_Coverage, 19049,
     /* 1795525 */     GIR_EraseRootFromParent_Done,
     /* 1795526 */   // Label 24270: @1795526
     /* 1795526 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1795612), // Rule ID 19052 //
     /* 1795531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1795534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795577 */     // MIs[0] policy
     /* 1795577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795587 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1795590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795611 */     // GIR_Coverage, 19052,
     /* 1795611 */     GIR_EraseRootFromParent_Done,
     /* 1795612 */   // Label 24271: @1795612
     /* 1795612 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1795698), // Rule ID 19053 //
     /* 1795617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1795620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795663 */     // MIs[0] policy
     /* 1795663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795673 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1795676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795697 */     // GIR_Coverage, 19053,
     /* 1795697 */     GIR_EraseRootFromParent_Done,
     /* 1795698 */   // Label 24272: @1795698
     /* 1795698 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1795784), // Rule ID 19056 //
     /* 1795703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1795706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795749 */     // MIs[0] policy
     /* 1795749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795759 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1795762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795783 */     // GIR_Coverage, 19056,
     /* 1795783 */     GIR_EraseRootFromParent_Done,
     /* 1795784 */   // Label 24273: @1795784
     /* 1795784 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1795870), // Rule ID 19057 //
     /* 1795789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1795792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795835 */     // MIs[0] policy
     /* 1795835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795845 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1795848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795869 */     // GIR_Coverage, 19057,
     /* 1795869 */     GIR_EraseRootFromParent_Done,
     /* 1795870 */   // Label 24274: @1795870
     /* 1795870 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1795956), // Rule ID 19060 //
     /* 1795875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1795878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795921 */     // MIs[0] policy
     /* 1795921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795931 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1795934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795955 */     // GIR_Coverage, 19060,
     /* 1795955 */     GIR_EraseRootFromParent_Done,
     /* 1795956 */   // Label 24275: @1795956
     /* 1795956 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1796042), // Rule ID 19061 //
     /* 1795961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1795964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1795969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796007 */     // MIs[0] policy
     /* 1796007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796017 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1796020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796041 */     // GIR_Coverage, 19061,
     /* 1796041 */     GIR_EraseRootFromParent_Done,
     /* 1796042 */   // Label 24276: @1796042
     /* 1796042 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1796128), // Rule ID 19064 //
     /* 1796047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1796050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1796058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1796061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1796064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1796067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796093 */     // MIs[0] policy
     /* 1796093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796103 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1796106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796127 */     // GIR_Coverage, 19064,
     /* 1796127 */     GIR_EraseRootFromParent_Done,
     /* 1796128 */   // Label 24277: @1796128
     /* 1796128 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1796214), // Rule ID 19065 //
     /* 1796133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1796136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1796144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1796147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1796150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1796153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796179 */     // MIs[0] policy
     /* 1796179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796189 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1796192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796213 */     // GIR_Coverage, 19065,
     /* 1796213 */     GIR_EraseRootFromParent_Done,
     /* 1796214 */   // Label 24278: @1796214
     /* 1796214 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1796300), // Rule ID 19068 //
     /* 1796219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1796222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1796230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1796233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1796236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1796239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796265 */     // MIs[0] policy
     /* 1796265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796275 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1796278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796299 */     // GIR_Coverage, 19068,
     /* 1796299 */     GIR_EraseRootFromParent_Done,
     /* 1796300 */   // Label 24279: @1796300
     /* 1796300 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1796386), // Rule ID 19069 //
     /* 1796305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1796308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1796316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1796319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1796322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1796325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796351 */     // MIs[0] policy
     /* 1796351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796361 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1796364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796385 */     // GIR_Coverage, 19069,
     /* 1796385 */     GIR_EraseRootFromParent_Done,
     /* 1796386 */   // Label 24280: @1796386
     /* 1796386 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1796472), // Rule ID 19072 //
     /* 1796391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1796394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796437 */     // MIs[0] policy
     /* 1796437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796447 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1796450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796471 */     // GIR_Coverage, 19072,
     /* 1796471 */     GIR_EraseRootFromParent_Done,
     /* 1796472 */   // Label 24281: @1796472
     /* 1796472 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1796558), // Rule ID 19073 //
     /* 1796477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1796480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796523 */     // MIs[0] policy
     /* 1796523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796533 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1796536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796557 */     // GIR_Coverage, 19073,
     /* 1796557 */     GIR_EraseRootFromParent_Done,
     /* 1796558 */   // Label 24282: @1796558
     /* 1796558 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1796644), // Rule ID 19076 //
     /* 1796563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1796566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796609 */     // MIs[0] policy
     /* 1796609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796619 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1796622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796643 */     // GIR_Coverage, 19076,
     /* 1796643 */     GIR_EraseRootFromParent_Done,
     /* 1796644 */   // Label 24283: @1796644
     /* 1796644 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1796730), // Rule ID 19077 //
     /* 1796649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1796652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796695 */     // MIs[0] policy
     /* 1796695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796705 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1796708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796729 */     // GIR_Coverage, 19077,
     /* 1796729 */     GIR_EraseRootFromParent_Done,
     /* 1796730 */   // Label 24284: @1796730
     /* 1796730 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1796816), // Rule ID 19080 //
     /* 1796735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1796738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796781 */     // MIs[0] policy
     /* 1796781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796791 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1796794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796815 */     // GIR_Coverage, 19080,
     /* 1796815 */     GIR_EraseRootFromParent_Done,
     /* 1796816 */   // Label 24285: @1796816
     /* 1796816 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1796902), // Rule ID 19081 //
     /* 1796821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1796824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796867 */     // MIs[0] policy
     /* 1796867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796877 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1796880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796901 */     // GIR_Coverage, 19081,
     /* 1796901 */     GIR_EraseRootFromParent_Done,
     /* 1796902 */   // Label 24286: @1796902
     /* 1796902 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1796988), // Rule ID 19084 //
     /* 1796907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1796910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1796915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1796927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1796949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796953 */     // MIs[0] policy
     /* 1796953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796963 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1796966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796987 */     // GIR_Coverage, 19084,
     /* 1796987 */     GIR_EraseRootFromParent_Done,
     /* 1796988 */   // Label 24287: @1796988
     /* 1796988 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1797074), // Rule ID 19085 //
     /* 1796993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1796996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1797010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797039 */     // MIs[0] policy
     /* 1797039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797049 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1797052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797073 */     // GIR_Coverage, 19085,
     /* 1797073 */     GIR_EraseRootFromParent_Done,
     /* 1797074 */   // Label 24288: @1797074
     /* 1797074 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1797160), // Rule ID 19088 //
     /* 1797079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1797082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797125 */     // MIs[0] policy
     /* 1797125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797135 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1797138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797159 */     // GIR_Coverage, 19088,
     /* 1797159 */     GIR_EraseRootFromParent_Done,
     /* 1797160 */   // Label 24289: @1797160
     /* 1797160 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1797246), // Rule ID 19089 //
     /* 1797165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1797168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797211 */     // MIs[0] policy
     /* 1797211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797221 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1797224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797245 */     // GIR_Coverage, 19089,
     /* 1797245 */     GIR_EraseRootFromParent_Done,
     /* 1797246 */   // Label 24290: @1797246
     /* 1797246 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1797332), // Rule ID 19092 //
     /* 1797251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1797254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1797293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797297 */     // MIs[0] policy
     /* 1797297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797307 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1797310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797331 */     // GIR_Coverage, 19092,
     /* 1797331 */     GIR_EraseRootFromParent_Done,
     /* 1797332 */   // Label 24291: @1797332
     /* 1797332 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1797418), // Rule ID 19093 //
     /* 1797337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1797340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1797379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797383 */     // MIs[0] policy
     /* 1797383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797393 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1797396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797417 */     // GIR_Coverage, 19093,
     /* 1797417 */     GIR_EraseRootFromParent_Done,
     /* 1797418 */   // Label 24292: @1797418
     /* 1797418 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1797504), // Rule ID 19096 //
     /* 1797423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1797426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797469 */     // MIs[0] policy
     /* 1797469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1797482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797503 */     // GIR_Coverage, 19096,
     /* 1797503 */     GIR_EraseRootFromParent_Done,
     /* 1797504 */   // Label 24293: @1797504
     /* 1797504 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1797590), // Rule ID 19097 //
     /* 1797509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1797512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797555 */     // MIs[0] policy
     /* 1797555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797565 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10904:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1797568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797589 */     // GIR_Coverage, 19097,
     /* 1797589 */     GIR_EraseRootFromParent_Done,
     /* 1797590 */   // Label 24294: @1797590
     /* 1797590 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1797676), // Rule ID 19100 //
     /* 1797595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1797598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1797637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797641 */     // MIs[0] policy
     /* 1797641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797651 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1797654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797675 */     // GIR_Coverage, 19100,
     /* 1797675 */     GIR_EraseRootFromParent_Done,
     /* 1797676 */   // Label 24295: @1797676
     /* 1797676 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1797762), // Rule ID 19101 //
     /* 1797681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1797684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1797723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797727 */     // MIs[0] policy
     /* 1797727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797737 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10904:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1797740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797761 */     // GIR_Coverage, 19101,
     /* 1797761 */     GIR_EraseRootFromParent_Done,
     /* 1797762 */   // Label 24296: @1797762
     /* 1797762 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1797848), // Rule ID 19104 //
     /* 1797767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1797770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1797809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797813 */     // MIs[0] policy
     /* 1797813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797823 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1797826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797847 */     // GIR_Coverage, 19104,
     /* 1797847 */     GIR_EraseRootFromParent_Done,
     /* 1797848 */   // Label 24297: @1797848
     /* 1797848 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1797934), // Rule ID 19105 //
     /* 1797853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1797856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1797895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797899 */     // MIs[0] policy
     /* 1797899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797909 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10904:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1797912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797933 */     // GIR_Coverage, 19105,
     /* 1797933 */     GIR_EraseRootFromParent_Done,
     /* 1797934 */   // Label 24298: @1797934
     /* 1797934 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1798020), // Rule ID 19108 //
     /* 1797939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1797942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1797947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1797950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1797953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1797956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1797959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1797981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797985 */     // MIs[0] policy
     /* 1797985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1797998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798019 */     // GIR_Coverage, 19108,
     /* 1798019 */     GIR_EraseRootFromParent_Done,
     /* 1798020 */   // Label 24299: @1798020
     /* 1798020 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1798106), // Rule ID 19109 //
     /* 1798025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1798028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1798045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1798067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798071 */     // MIs[0] policy
     /* 1798071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798081 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1798084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798105 */     // GIR_Coverage, 19109,
     /* 1798105 */     GIR_EraseRootFromParent_Done,
     /* 1798106 */   // Label 24300: @1798106
     /* 1798106 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1798192), // Rule ID 19112 //
     /* 1798111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1798114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1798131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1798153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798157 */     // MIs[0] policy
     /* 1798157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798167 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1798170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798191 */     // GIR_Coverage, 19112,
     /* 1798191 */     GIR_EraseRootFromParent_Done,
     /* 1798192 */   // Label 24301: @1798192
     /* 1798192 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1798278), // Rule ID 19113 //
     /* 1798197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1798200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1798217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1798239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798243 */     // MIs[0] policy
     /* 1798243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798253 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1798256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798277 */     // GIR_Coverage, 19113,
     /* 1798277 */     GIR_EraseRootFromParent_Done,
     /* 1798278 */   // Label 24302: @1798278
     /* 1798278 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1798364), // Rule ID 19116 //
     /* 1798283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1798286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1798303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1798325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798329 */     // MIs[0] policy
     /* 1798329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798339 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1798342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798363 */     // GIR_Coverage, 19116,
     /* 1798363 */     GIR_EraseRootFromParent_Done,
     /* 1798364 */   // Label 24303: @1798364
     /* 1798364 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1798450), // Rule ID 19117 //
     /* 1798369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1798372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1798389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1798411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798415 */     // MIs[0] policy
     /* 1798415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798425 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1798428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798449 */     // GIR_Coverage, 19117,
     /* 1798449 */     GIR_EraseRootFromParent_Done,
     /* 1798450 */   // Label 24304: @1798450
     /* 1798450 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1798536), // Rule ID 19120 //
     /* 1798455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1798458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798501 */     // MIs[0] policy
     /* 1798501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798511 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1798514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798535 */     // GIR_Coverage, 19120,
     /* 1798535 */     GIR_EraseRootFromParent_Done,
     /* 1798536 */   // Label 24305: @1798536
     /* 1798536 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1798622), // Rule ID 19121 //
     /* 1798541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1798544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798587 */     // MIs[0] policy
     /* 1798587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798597 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1798600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798621 */     // GIR_Coverage, 19121,
     /* 1798621 */     GIR_EraseRootFromParent_Done,
     /* 1798622 */   // Label 24306: @1798622
     /* 1798622 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1798708), // Rule ID 19124 //
     /* 1798627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1798630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1798638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1798641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798673 */     // MIs[0] policy
     /* 1798673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798683 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1798686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798707 */     // GIR_Coverage, 19124,
     /* 1798707 */     GIR_EraseRootFromParent_Done,
     /* 1798708 */   // Label 24307: @1798708
     /* 1798708 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1798794), // Rule ID 19125 //
     /* 1798713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1798716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1798724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1798727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798759 */     // MIs[0] policy
     /* 1798759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798769 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1798772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798793 */     // GIR_Coverage, 19125,
     /* 1798793 */     GIR_EraseRootFromParent_Done,
     /* 1798794 */   // Label 24308: @1798794
     /* 1798794 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1798880), // Rule ID 19128 //
     /* 1798799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1798802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1798810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1798813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1798816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798845 */     // MIs[0] policy
     /* 1798845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798855 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1798858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798879 */     // GIR_Coverage, 19128,
     /* 1798879 */     GIR_EraseRootFromParent_Done,
     /* 1798880 */   // Label 24309: @1798880
     /* 1798880 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1798966), // Rule ID 19129 //
     /* 1798885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1798888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1798896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1798899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1798902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1798927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798931 */     // MIs[0] policy
     /* 1798931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798941 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1798944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798965 */     // GIR_Coverage, 19129,
     /* 1798965 */     GIR_EraseRootFromParent_Done,
     /* 1798966 */   // Label 24310: @1798966
     /* 1798966 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1799052), // Rule ID 19132 //
     /* 1798971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1798974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1798979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1798982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1798985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1798988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799017 */     // MIs[0] policy
     /* 1799017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1799030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799051 */     // GIR_Coverage, 19132,
     /* 1799051 */     GIR_EraseRootFromParent_Done,
     /* 1799052 */   // Label 24311: @1799052
     /* 1799052 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1799138), // Rule ID 19133 //
     /* 1799057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1799060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1799065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799103 */     // MIs[0] policy
     /* 1799103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799113 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10904:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1799116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799137 */     // GIR_Coverage, 19133,
     /* 1799137 */     GIR_EraseRootFromParent_Done,
     /* 1799138 */   // Label 24312: @1799138
     /* 1799138 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1799224), // Rule ID 19136 //
     /* 1799143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1799146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1799151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799189 */     // MIs[0] policy
     /* 1799189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799199 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1799202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799223 */     // GIR_Coverage, 19136,
     /* 1799223 */     GIR_EraseRootFromParent_Done,
     /* 1799224 */   // Label 24313: @1799224
     /* 1799224 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1799310), // Rule ID 19137 //
     /* 1799229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1799232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1799237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799275 */     // MIs[0] policy
     /* 1799275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799285 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10904:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1799288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799309 */     // GIR_Coverage, 19137,
     /* 1799309 */     GIR_EraseRootFromParent_Done,
     /* 1799310 */   // Label 24314: @1799310
     /* 1799310 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1799396), // Rule ID 19140 //
     /* 1799315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1799318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1799323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799361 */     // MIs[0] policy
     /* 1799361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799371 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1799374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799395 */     // GIR_Coverage, 19140,
     /* 1799395 */     GIR_EraseRootFromParent_Done,
     /* 1799396 */   // Label 24315: @1799396
     /* 1799396 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1799482), // Rule ID 19141 //
     /* 1799401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1799404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1799409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1799443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799447 */     // MIs[0] policy
     /* 1799447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799457 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10904:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1799460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799481 */     // GIR_Coverage, 19141,
     /* 1799481 */     GIR_EraseRootFromParent_Done,
     /* 1799482 */   // Label 24316: @1799482
     /* 1799482 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1799568), // Rule ID 19144 //
     /* 1799487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1799490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1799504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1799507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799533 */     // MIs[0] policy
     /* 1799533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799543 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1799546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799567 */     // GIR_Coverage, 19144,
     /* 1799567 */     GIR_EraseRootFromParent_Done,
     /* 1799568 */   // Label 24317: @1799568
     /* 1799568 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1799654), // Rule ID 19145 //
     /* 1799573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1799576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1799590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1799593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799619 */     // MIs[0] policy
     /* 1799619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799629 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1799632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799653 */     // GIR_Coverage, 19145,
     /* 1799653 */     GIR_EraseRootFromParent_Done,
     /* 1799654 */   // Label 24318: @1799654
     /* 1799654 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1799740), // Rule ID 19148 //
     /* 1799659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1799662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1799670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1799673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1799676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1799679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799705 */     // MIs[0] policy
     /* 1799705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799715 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1799718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799739 */     // GIR_Coverage, 19148,
     /* 1799739 */     GIR_EraseRootFromParent_Done,
     /* 1799740 */   // Label 24319: @1799740
     /* 1799740 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1799826), // Rule ID 19149 //
     /* 1799745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1799748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1799756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1799759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1799762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1799765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799791 */     // MIs[0] policy
     /* 1799791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799801 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1799804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799825 */     // GIR_Coverage, 19149,
     /* 1799825 */     GIR_EraseRootFromParent_Done,
     /* 1799826 */   // Label 24320: @1799826
     /* 1799826 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1799912), // Rule ID 19152 //
     /* 1799831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1799834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1799842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1799845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1799848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1799851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799877 */     // MIs[0] policy
     /* 1799877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799887 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1799890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799911 */     // GIR_Coverage, 19152,
     /* 1799911 */     GIR_EraseRootFromParent_Done,
     /* 1799912 */   // Label 24321: @1799912
     /* 1799912 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1799998), // Rule ID 19153 //
     /* 1799917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1799920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1799925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1799928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1799931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1799934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1799937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799963 */     // MIs[0] policy
     /* 1799963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799973 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1799976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799997 */     // GIR_Coverage, 19153,
     /* 1799997 */     GIR_EraseRootFromParent_Done,
     /* 1799998 */   // Label 24322: @1799998
     /* 1799998 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1800084), // Rule ID 19156 //
     /* 1800003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1800006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1800020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1800023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800049 */     // MIs[0] policy
     /* 1800049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800059 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1800062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800083 */     // GIR_Coverage, 19156,
     /* 1800083 */     GIR_EraseRootFromParent_Done,
     /* 1800084 */   // Label 24323: @1800084
     /* 1800084 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1800170), // Rule ID 19157 //
     /* 1800089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1800092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1800106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1800109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800135 */     // MIs[0] policy
     /* 1800135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800145 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1800148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800169 */     // GIR_Coverage, 19157,
     /* 1800169 */     GIR_EraseRootFromParent_Done,
     /* 1800170 */   // Label 24324: @1800170
     /* 1800170 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1800256), // Rule ID 19160 //
     /* 1800175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1800178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1800186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1800189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1800192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1800195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800221 */     // MIs[0] policy
     /* 1800221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800231 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1800234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800255 */     // GIR_Coverage, 19160,
     /* 1800255 */     GIR_EraseRootFromParent_Done,
     /* 1800256 */   // Label 24325: @1800256
     /* 1800256 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1800342), // Rule ID 19161 //
     /* 1800261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1800264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1800272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1800275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1800278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1800281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800307 */     // MIs[0] policy
     /* 1800307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800317 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1800320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800341 */     // GIR_Coverage, 19161,
     /* 1800341 */     GIR_EraseRootFromParent_Done,
     /* 1800342 */   // Label 24326: @1800342
     /* 1800342 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1800428), // Rule ID 19164 //
     /* 1800347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1800350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1800358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1800361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1800364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1800367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800393 */     // MIs[0] policy
     /* 1800393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800403 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1800406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800427 */     // GIR_Coverage, 19164,
     /* 1800427 */     GIR_EraseRootFromParent_Done,
     /* 1800428 */   // Label 24327: @1800428
     /* 1800428 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1800514), // Rule ID 19165 //
     /* 1800433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1800436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1800444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1800447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1800450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1800453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800479 */     // MIs[0] policy
     /* 1800479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800489 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1800492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800513 */     // GIR_Coverage, 19165,
     /* 1800513 */     GIR_EraseRootFromParent_Done,
     /* 1800514 */   // Label 24328: @1800514
     /* 1800514 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1800600), // Rule ID 19168 //
     /* 1800519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1800522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1800536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1800539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800565 */     // MIs[0] policy
     /* 1800565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800575 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1800578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800599 */     // GIR_Coverage, 19168,
     /* 1800599 */     GIR_EraseRootFromParent_Done,
     /* 1800600 */   // Label 24329: @1800600
     /* 1800600 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1800686), // Rule ID 19169 //
     /* 1800605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1800608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1800622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1800625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800651 */     // MIs[0] policy
     /* 1800651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800661 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1800664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800685 */     // GIR_Coverage, 19169,
     /* 1800685 */     GIR_EraseRootFromParent_Done,
     /* 1800686 */   // Label 24330: @1800686
     /* 1800686 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1800772), // Rule ID 19172 //
     /* 1800691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1800694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1800708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1800711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800737 */     // MIs[0] policy
     /* 1800737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800747 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1800750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800771 */     // GIR_Coverage, 19172,
     /* 1800771 */     GIR_EraseRootFromParent_Done,
     /* 1800772 */   // Label 24331: @1800772
     /* 1800772 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1800858), // Rule ID 19173 //
     /* 1800777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1800780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1800794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1800797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800823 */     // MIs[0] policy
     /* 1800823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800833 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1800836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800857 */     // GIR_Coverage, 19173,
     /* 1800857 */     GIR_EraseRootFromParent_Done,
     /* 1800858 */   // Label 24332: @1800858
     /* 1800858 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1800944), // Rule ID 19176 //
     /* 1800863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1800866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1800880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1800883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800909 */     // MIs[0] policy
     /* 1800909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800919 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1800922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800943 */     // GIR_Coverage, 19176,
     /* 1800943 */     GIR_EraseRootFromParent_Done,
     /* 1800944 */   // Label 24333: @1800944
     /* 1800944 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1801030), // Rule ID 19177 //
     /* 1800949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1800952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1800957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1800966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1800969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800995 */     // MIs[0] policy
     /* 1800995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801005 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1801008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801029 */     // GIR_Coverage, 19177,
     /* 1801029 */     GIR_EraseRootFromParent_Done,
     /* 1801030 */   // Label 24334: @1801030
     /* 1801030 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1801116), // Rule ID 19180 //
     /* 1801035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1801038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1801052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1801055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801081 */     // MIs[0] policy
     /* 1801081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801091 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1801094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801115 */     // GIR_Coverage, 19180,
     /* 1801115 */     GIR_EraseRootFromParent_Done,
     /* 1801116 */   // Label 24335: @1801116
     /* 1801116 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1801202), // Rule ID 19181 //
     /* 1801121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1801124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1801138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1801141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801167 */     // MIs[0] policy
     /* 1801167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801177 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1801180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801201 */     // GIR_Coverage, 19181,
     /* 1801201 */     GIR_EraseRootFromParent_Done,
     /* 1801202 */   // Label 24336: @1801202
     /* 1801202 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1801288), // Rule ID 19184 //
     /* 1801207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1801210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1801224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1801227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801253 */     // MIs[0] policy
     /* 1801253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801263 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1801266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801287 */     // GIR_Coverage, 19184,
     /* 1801287 */     GIR_EraseRootFromParent_Done,
     /* 1801288 */   // Label 24337: @1801288
     /* 1801288 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1801374), // Rule ID 19185 //
     /* 1801293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1801296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1801310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1801313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801339 */     // MIs[0] policy
     /* 1801339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1801352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801373 */     // GIR_Coverage, 19185,
     /* 1801373 */     GIR_EraseRootFromParent_Done,
     /* 1801374 */   // Label 24338: @1801374
     /* 1801374 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1801460), // Rule ID 19188 //
     /* 1801379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1801382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1801396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1801399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801425 */     // MIs[0] policy
     /* 1801425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801435 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1801438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801459 */     // GIR_Coverage, 19188,
     /* 1801459 */     GIR_EraseRootFromParent_Done,
     /* 1801460 */   // Label 24339: @1801460
     /* 1801460 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1801546), // Rule ID 19189 //
     /* 1801465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1801468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1801482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1801485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801511 */     // MIs[0] policy
     /* 1801511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801521 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1801524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801545 */     // GIR_Coverage, 19189,
     /* 1801545 */     GIR_EraseRootFromParent_Done,
     /* 1801546 */   // Label 24340: @1801546
     /* 1801546 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1801632), // Rule ID 19192 //
     /* 1801551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1801554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1801562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1801565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1801568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1801571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801597 */     // MIs[0] policy
     /* 1801597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801607 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1801610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801631 */     // GIR_Coverage, 19192,
     /* 1801631 */     GIR_EraseRootFromParent_Done,
     /* 1801632 */   // Label 24341: @1801632
     /* 1801632 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1801718), // Rule ID 19193 //
     /* 1801637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1801640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1801648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1801651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1801654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1801657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801683 */     // MIs[0] policy
     /* 1801683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1801696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801717 */     // GIR_Coverage, 19193,
     /* 1801717 */     GIR_EraseRootFromParent_Done,
     /* 1801718 */   // Label 24342: @1801718
     /* 1801718 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1801804), // Rule ID 19196 //
     /* 1801723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1801726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1801734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1801737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1801740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1801743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801769 */     // MIs[0] policy
     /* 1801769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801779 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1801782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801803 */     // GIR_Coverage, 19196,
     /* 1801803 */     GIR_EraseRootFromParent_Done,
     /* 1801804 */   // Label 24343: @1801804
     /* 1801804 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1801890), // Rule ID 19197 //
     /* 1801809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1801812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1801820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1801823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1801826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1801829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801855 */     // MIs[0] policy
     /* 1801855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801865 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1801868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801889 */     // GIR_Coverage, 19197,
     /* 1801889 */     GIR_EraseRootFromParent_Done,
     /* 1801890 */   // Label 24344: @1801890
     /* 1801890 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1801976), // Rule ID 19200 //
     /* 1801895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1801898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1801906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1801909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1801912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1801915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801941 */     // MIs[0] policy
     /* 1801941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801951 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1801954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801975 */     // GIR_Coverage, 19200,
     /* 1801975 */     GIR_EraseRootFromParent_Done,
     /* 1801976 */   // Label 24345: @1801976
     /* 1801976 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1802062), // Rule ID 19201 //
     /* 1801981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1801984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1801989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1801992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1801995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1801998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1802001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802027 */     // MIs[0] policy
     /* 1802027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802037 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1802040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1802058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802061 */     // GIR_Coverage, 19201,
     /* 1802061 */     GIR_EraseRootFromParent_Done,
     /* 1802062 */   // Label 24346: @1802062
     /* 1802062 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1802148), // Rule ID 19204 //
     /* 1802067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1802070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1802084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802113 */     // MIs[0] policy
     /* 1802113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802123 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1802126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802147 */     // GIR_Coverage, 19204,
     /* 1802147 */     GIR_EraseRootFromParent_Done,
     /* 1802148 */   // Label 24347: @1802148
     /* 1802148 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1802234), // Rule ID 19205 //
     /* 1802153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1802156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1802170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802199 */     // MIs[0] policy
     /* 1802199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802209 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1802212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802233 */     // GIR_Coverage, 19205,
     /* 1802233 */     GIR_EraseRootFromParent_Done,
     /* 1802234 */   // Label 24348: @1802234
     /* 1802234 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1802320), // Rule ID 19208 //
     /* 1802239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1802242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1802256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802285 */     // MIs[0] policy
     /* 1802285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1802298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802319 */     // GIR_Coverage, 19208,
     /* 1802319 */     GIR_EraseRootFromParent_Done,
     /* 1802320 */   // Label 24349: @1802320
     /* 1802320 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1802406), // Rule ID 19209 //
     /* 1802325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1802328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1802342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802371 */     // MIs[0] policy
     /* 1802371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802381 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1802384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802405 */     // GIR_Coverage, 19209,
     /* 1802405 */     GIR_EraseRootFromParent_Done,
     /* 1802406 */   // Label 24350: @1802406
     /* 1802406 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1802492), // Rule ID 19212 //
     /* 1802411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1802414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1802422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1802425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1802453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802457 */     // MIs[0] policy
     /* 1802457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802467 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1802470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802491 */     // GIR_Coverage, 19212,
     /* 1802491 */     GIR_EraseRootFromParent_Done,
     /* 1802492 */   // Label 24351: @1802492
     /* 1802492 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1802578), // Rule ID 19213 //
     /* 1802497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1802500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1802508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1802511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1802539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802543 */     // MIs[0] policy
     /* 1802543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802553 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1802556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802577 */     // GIR_Coverage, 19213,
     /* 1802577 */     GIR_EraseRootFromParent_Done,
     /* 1802578 */   // Label 24352: @1802578
     /* 1802578 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1802664), // Rule ID 19216 //
     /* 1802583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1802586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1802600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802629 */     // MIs[0] policy
     /* 1802629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802639 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1802642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802663 */     // GIR_Coverage, 19216,
     /* 1802663 */     GIR_EraseRootFromParent_Done,
     /* 1802664 */   // Label 24353: @1802664
     /* 1802664 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1802750), // Rule ID 19217 //
     /* 1802669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1802672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1802686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1802689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1802711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802715 */     // MIs[0] policy
     /* 1802715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802725 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10901:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1802728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802749 */     // GIR_Coverage, 19217,
     /* 1802749 */     GIR_EraseRootFromParent_Done,
     /* 1802750 */   // Label 24354: @1802750
     /* 1802750 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1802836), // Rule ID 19220 //
     /* 1802755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1802758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1802766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1802769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1802797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802801 */     // MIs[0] policy
     /* 1802801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802811 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1802814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802835 */     // GIR_Coverage, 19220,
     /* 1802835 */     GIR_EraseRootFromParent_Done,
     /* 1802836 */   // Label 24355: @1802836
     /* 1802836 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1802922), // Rule ID 19221 //
     /* 1802841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1802844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1802852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1802855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1802883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802887 */     // MIs[0] policy
     /* 1802887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802897 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1802900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802921 */     // GIR_Coverage, 19221,
     /* 1802921 */     GIR_EraseRootFromParent_Done,
     /* 1802922 */   // Label 24356: @1802922
     /* 1802922 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1803008), // Rule ID 19224 //
     /* 1802927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1802930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1802935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1802944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1802969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802973 */     // MIs[0] policy
     /* 1802973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802983 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1802986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803007 */     // GIR_Coverage, 19224,
     /* 1803007 */     GIR_EraseRootFromParent_Done,
     /* 1803008 */   // Label 24357: @1803008
     /* 1803008 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1803094), // Rule ID 19225 //
     /* 1803013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1803016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1803024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1803027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1803030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1803055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803059 */     // MIs[0] policy
     /* 1803059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803069 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1803072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803093 */     // GIR_Coverage, 19225,
     /* 1803093 */     GIR_EraseRootFromParent_Done,
     /* 1803094 */   // Label 24358: @1803094
     /* 1803094 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1803180), // Rule ID 19228 //
     /* 1803099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1803102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1803116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803145 */     // MIs[0] policy
     /* 1803145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803155 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1803158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803179 */     // GIR_Coverage, 19228,
     /* 1803179 */     GIR_EraseRootFromParent_Done,
     /* 1803180 */   // Label 24359: @1803180
     /* 1803180 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1803266), // Rule ID 19229 //
     /* 1803185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1803188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1803202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803231 */     // MIs[0] policy
     /* 1803231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803241 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1803244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803265 */     // GIR_Coverage, 19229,
     /* 1803265 */     GIR_EraseRootFromParent_Done,
     /* 1803266 */   // Label 24360: @1803266
     /* 1803266 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1803352), // Rule ID 19232 //
     /* 1803271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1803274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1803288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803317 */     // MIs[0] policy
     /* 1803317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803327 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1803330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803351 */     // GIR_Coverage, 19232,
     /* 1803351 */     GIR_EraseRootFromParent_Done,
     /* 1803352 */   // Label 24361: @1803352
     /* 1803352 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1803438), // Rule ID 19233 //
     /* 1803357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1803360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1803374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803403 */     // MIs[0] policy
     /* 1803403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803413 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1803416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803437 */     // GIR_Coverage, 19233,
     /* 1803437 */     GIR_EraseRootFromParent_Done,
     /* 1803438 */   // Label 24362: @1803438
     /* 1803438 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1803524), // Rule ID 19236 //
     /* 1803443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1803446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1803460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803489 */     // MIs[0] policy
     /* 1803489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803499 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1803502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803523 */     // GIR_Coverage, 19236,
     /* 1803523 */     GIR_EraseRootFromParent_Done,
     /* 1803524 */   // Label 24363: @1803524
     /* 1803524 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1803610), // Rule ID 19237 //
     /* 1803529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1803532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1803546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1803549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1803571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803575 */     // MIs[0] policy
     /* 1803575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803585 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1803588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803609 */     // GIR_Coverage, 19237,
     /* 1803609 */     GIR_EraseRootFromParent_Done,
     /* 1803610 */   // Label 24364: @1803610
     /* 1803610 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1803696), // Rule ID 19240 //
     /* 1803615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1803618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1803632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1803657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803661 */     // MIs[0] policy
     /* 1803661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803671 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1803674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803695 */     // GIR_Coverage, 19240,
     /* 1803695 */     GIR_EraseRootFromParent_Done,
     /* 1803696 */   // Label 24365: @1803696
     /* 1803696 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1803782), // Rule ID 19241 //
     /* 1803701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1803704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1803718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1803743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803747 */     // MIs[0] policy
     /* 1803747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803757 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1803760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803781 */     // GIR_Coverage, 19241,
     /* 1803781 */     GIR_EraseRootFromParent_Done,
     /* 1803782 */   // Label 24366: @1803782
     /* 1803782 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1803868), // Rule ID 19244 //
     /* 1803787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1803790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1803798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1803801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1803804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1803829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803833 */     // MIs[0] policy
     /* 1803833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803843 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1803846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803867 */     // GIR_Coverage, 19244,
     /* 1803867 */     GIR_EraseRootFromParent_Done,
     /* 1803868 */   // Label 24367: @1803868
     /* 1803868 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1803954), // Rule ID 19245 //
     /* 1803873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1803876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1803884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1803887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1803890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1803915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803919 */     // MIs[0] policy
     /* 1803919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803929 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1803932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803953 */     // GIR_Coverage, 19245,
     /* 1803953 */     GIR_EraseRootFromParent_Done,
     /* 1803954 */   // Label 24368: @1803954
     /* 1803954 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1804040), // Rule ID 19248 //
     /* 1803959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1803962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1803967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1803970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1803973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1803976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1804001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804005 */     // MIs[0] policy
     /* 1804005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804015 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1804018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804039 */     // GIR_Coverage, 19248,
     /* 1804039 */     GIR_EraseRootFromParent_Done,
     /* 1804040 */   // Label 24369: @1804040
     /* 1804040 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1804126), // Rule ID 19249 //
     /* 1804045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1804048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1804062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1804087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804091 */     // MIs[0] policy
     /* 1804091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804101 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1804104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804125 */     // GIR_Coverage, 19249,
     /* 1804125 */     GIR_EraseRootFromParent_Done,
     /* 1804126 */   // Label 24370: @1804126
     /* 1804126 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1804212), // Rule ID 19252 //
     /* 1804131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1804134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1804148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804177 */     // MIs[0] policy
     /* 1804177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804187 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1804190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804211 */     // GIR_Coverage, 19252,
     /* 1804211 */     GIR_EraseRootFromParent_Done,
     /* 1804212 */   // Label 24371: @1804212
     /* 1804212 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1804298), // Rule ID 19253 //
     /* 1804217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1804220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1804234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804263 */     // MIs[0] policy
     /* 1804263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804273 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1804276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804297 */     // GIR_Coverage, 19253,
     /* 1804297 */     GIR_EraseRootFromParent_Done,
     /* 1804298 */   // Label 24372: @1804298
     /* 1804298 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1804384), // Rule ID 19256 //
     /* 1804303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1804306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1804320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804349 */     // MIs[0] policy
     /* 1804349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804359 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1804362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804383 */     // GIR_Coverage, 19256,
     /* 1804383 */     GIR_EraseRootFromParent_Done,
     /* 1804384 */   // Label 24373: @1804384
     /* 1804384 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1804470), // Rule ID 19257 //
     /* 1804389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1804392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1804406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804435 */     // MIs[0] policy
     /* 1804435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804445 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1804448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804469 */     // GIR_Coverage, 19257,
     /* 1804469 */     GIR_EraseRootFromParent_Done,
     /* 1804470 */   // Label 24374: @1804470
     /* 1804470 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1804556), // Rule ID 19260 //
     /* 1804475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1804478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1804492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804521 */     // MIs[0] policy
     /* 1804521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804531 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1804534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804555 */     // GIR_Coverage, 19260,
     /* 1804555 */     GIR_EraseRootFromParent_Done,
     /* 1804556 */   // Label 24375: @1804556
     /* 1804556 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1804642), // Rule ID 19261 //
     /* 1804561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1804564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1804569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1804578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1804603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804607 */     // MIs[0] policy
     /* 1804607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804617 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1804620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1804638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804641 */     // GIR_Coverage, 19261,
     /* 1804641 */     GIR_EraseRootFromParent_Done,
     /* 1804642 */   // Label 24376: @1804642
     /* 1804642 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1804728), // Rule ID 19264 //
     /* 1804647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1804650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1804655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1804658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1804661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804693 */     // MIs[0] policy
     /* 1804693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804703 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1804706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804727 */     // GIR_Coverage, 19264,
     /* 1804727 */     GIR_EraseRootFromParent_Done,
     /* 1804728 */   // Label 24377: @1804728
     /* 1804728 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1804814), // Rule ID 19265 //
     /* 1804733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1804736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1804741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1804744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1804747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804779 */     // MIs[0] policy
     /* 1804779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804789 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1804792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804813 */     // GIR_Coverage, 19265,
     /* 1804813 */     GIR_EraseRootFromParent_Done,
     /* 1804814 */   // Label 24378: @1804814
     /* 1804814 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1804900), // Rule ID 19268 //
     /* 1804819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1804822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1804827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1804830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1804833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804865 */     // MIs[0] policy
     /* 1804865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804875 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1804878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804899 */     // GIR_Coverage, 19268,
     /* 1804899 */     GIR_EraseRootFromParent_Done,
     /* 1804900 */   // Label 24379: @1804900
     /* 1804900 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1804986), // Rule ID 19269 //
     /* 1804905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1804908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1804913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1804916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1804919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804951 */     // MIs[0] policy
     /* 1804951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804961 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1804964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804985 */     // GIR_Coverage, 19269,
     /* 1804985 */     GIR_EraseRootFromParent_Done,
     /* 1804986 */   // Label 24380: @1804986
     /* 1804986 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1805072), // Rule ID 19272 //
     /* 1804991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1804994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1804999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1805002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1805005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805037 */     // MIs[0] policy
     /* 1805037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805047 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1805050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805071 */     // GIR_Coverage, 19272,
     /* 1805071 */     GIR_EraseRootFromParent_Done,
     /* 1805072 */   // Label 24381: @1805072
     /* 1805072 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1805158), // Rule ID 19273 //
     /* 1805077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1805080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1805088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1805091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805123 */     // MIs[0] policy
     /* 1805123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805133 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1805136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805157 */     // GIR_Coverage, 19273,
     /* 1805157 */     GIR_EraseRootFromParent_Done,
     /* 1805158 */   // Label 24382: @1805158
     /* 1805158 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1805244), // Rule ID 19276 //
     /* 1805163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1805166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1805180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1805183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805209 */     // MIs[0] policy
     /* 1805209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805219 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1805222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805243 */     // GIR_Coverage, 19276,
     /* 1805243 */     GIR_EraseRootFromParent_Done,
     /* 1805244 */   // Label 24383: @1805244
     /* 1805244 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1805330), // Rule ID 19277 //
     /* 1805249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1805252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1805266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1805269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805295 */     // MIs[0] policy
     /* 1805295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805305 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1805308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805329 */     // GIR_Coverage, 19277,
     /* 1805329 */     GIR_EraseRootFromParent_Done,
     /* 1805330 */   // Label 24384: @1805330
     /* 1805330 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1805416), // Rule ID 19280 //
     /* 1805335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1805338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1805346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1805349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805381 */     // MIs[0] policy
     /* 1805381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805391 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1805394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805415 */     // GIR_Coverage, 19280,
     /* 1805415 */     GIR_EraseRootFromParent_Done,
     /* 1805416 */   // Label 24385: @1805416
     /* 1805416 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1805502), // Rule ID 19281 //
     /* 1805421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1805424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1805432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1805435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805467 */     // MIs[0] policy
     /* 1805467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1805480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805501 */     // GIR_Coverage, 19281,
     /* 1805501 */     GIR_EraseRootFromParent_Done,
     /* 1805502 */   // Label 24386: @1805502
     /* 1805502 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1805588), // Rule ID 19284 //
     /* 1805507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1805510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1805524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1805527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805553 */     // MIs[0] policy
     /* 1805553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805563 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1805566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1805584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805587 */     // GIR_Coverage, 19284,
     /* 1805587 */     GIR_EraseRootFromParent_Done,
     /* 1805588 */   // Label 24387: @1805588
     /* 1805588 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1805674), // Rule ID 19285 //
     /* 1805593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1805596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1805610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1805613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805639 */     // MIs[0] policy
     /* 1805639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805649 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1805652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1805670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805673 */     // GIR_Coverage, 19285,
     /* 1805673 */     GIR_EraseRootFromParent_Done,
     /* 1805674 */   // Label 24388: @1805674
     /* 1805674 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1805760), // Rule ID 19288 //
     /* 1805679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1805682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805725 */     // MIs[0] policy
     /* 1805725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805735 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1805738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805759 */     // GIR_Coverage, 19288,
     /* 1805759 */     GIR_EraseRootFromParent_Done,
     /* 1805760 */   // Label 24389: @1805760
     /* 1805760 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1805846), // Rule ID 19289 //
     /* 1805765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1805768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805811 */     // MIs[0] policy
     /* 1805811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805821 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1805824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805845 */     // GIR_Coverage, 19289,
     /* 1805845 */     GIR_EraseRootFromParent_Done,
     /* 1805846 */   // Label 24390: @1805846
     /* 1805846 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1805932), // Rule ID 19292 //
     /* 1805851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1805854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805897 */     // MIs[0] policy
     /* 1805897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805907 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1805910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805931 */     // GIR_Coverage, 19292,
     /* 1805931 */     GIR_EraseRootFromParent_Done,
     /* 1805932 */   // Label 24391: @1805932
     /* 1805932 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1806018), // Rule ID 19293 //
     /* 1805937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1805940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1805945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805983 */     // MIs[0] policy
     /* 1805983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805993 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1805996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806017 */     // GIR_Coverage, 19293,
     /* 1806017 */     GIR_EraseRootFromParent_Done,
     /* 1806018 */   // Label 24392: @1806018
     /* 1806018 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1806104), // Rule ID 19296 //
     /* 1806023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1806026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1806040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1806043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806069 */     // MIs[0] policy
     /* 1806069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806079 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1806082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806103 */     // GIR_Coverage, 19296,
     /* 1806103 */     GIR_EraseRootFromParent_Done,
     /* 1806104 */   // Label 24393: @1806104
     /* 1806104 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1806190), // Rule ID 19297 //
     /* 1806109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1806112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1806126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1806129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806155 */     // MIs[0] policy
     /* 1806155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806165 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1806168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806189 */     // GIR_Coverage, 19297,
     /* 1806189 */     GIR_EraseRootFromParent_Done,
     /* 1806190 */   // Label 24394: @1806190
     /* 1806190 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1806276), // Rule ID 19300 //
     /* 1806195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1806198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1806212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1806215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806241 */     // MIs[0] policy
     /* 1806241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806251 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1806254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806275 */     // GIR_Coverage, 19300,
     /* 1806275 */     GIR_EraseRootFromParent_Done,
     /* 1806276 */   // Label 24395: @1806276
     /* 1806276 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1806362), // Rule ID 19301 //
     /* 1806281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1806284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1806298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1806301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806327 */     // MIs[0] policy
     /* 1806327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806337 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1806340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806361 */     // GIR_Coverage, 19301,
     /* 1806361 */     GIR_EraseRootFromParent_Done,
     /* 1806362 */   // Label 24396: @1806362
     /* 1806362 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1806448), // Rule ID 19304 //
     /* 1806367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1806370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1806384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1806387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806413 */     // MIs[0] policy
     /* 1806413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806423 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1806426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806447 */     // GIR_Coverage, 19304,
     /* 1806447 */     GIR_EraseRootFromParent_Done,
     /* 1806448 */   // Label 24397: @1806448
     /* 1806448 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1806534), // Rule ID 19305 //
     /* 1806453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1806456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1806470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1806473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806499 */     // MIs[0] policy
     /* 1806499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806509 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1806512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806533 */     // GIR_Coverage, 19305,
     /* 1806533 */     GIR_EraseRootFromParent_Done,
     /* 1806534 */   // Label 24398: @1806534
     /* 1806534 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1806620), // Rule ID 19308 //
     /* 1806539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1806542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1806556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1806559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806585 */     // MIs[0] policy
     /* 1806585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806595 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1806598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806619 */     // GIR_Coverage, 19308,
     /* 1806619 */     GIR_EraseRootFromParent_Done,
     /* 1806620 */   // Label 24399: @1806620
     /* 1806620 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1806706), // Rule ID 19309 //
     /* 1806625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1806628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1806642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1806645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806671 */     // MIs[0] policy
     /* 1806671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806681 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1806684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806705 */     // GIR_Coverage, 19309,
     /* 1806705 */     GIR_EraseRootFromParent_Done,
     /* 1806706 */   // Label 24400: @1806706
     /* 1806706 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1806792), // Rule ID 19312 //
     /* 1806711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1806714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1806722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1806725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1806728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1806731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806757 */     // MIs[0] policy
     /* 1806757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806767 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1806770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1806788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806791 */     // GIR_Coverage, 19312,
     /* 1806791 */     GIR_EraseRootFromParent_Done,
     /* 1806792 */   // Label 24401: @1806792
     /* 1806792 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1806878), // Rule ID 19313 //
     /* 1806797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1806800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1806808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1806811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1806814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1806817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806843 */     // MIs[0] policy
     /* 1806843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1806856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1806874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806877 */     // GIR_Coverage, 19313,
     /* 1806877 */     GIR_EraseRootFromParent_Done,
     /* 1806878 */   // Label 24402: @1806878
     /* 1806878 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1806964), // Rule ID 19316 //
     /* 1806883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1806886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1806894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1806897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1806900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1806903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806929 */     // MIs[0] policy
     /* 1806929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806939 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1806942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1806960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806963 */     // GIR_Coverage, 19316,
     /* 1806963 */     GIR_EraseRootFromParent_Done,
     /* 1806964 */   // Label 24403: @1806964
     /* 1806964 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1807050), // Rule ID 19317 //
     /* 1806969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1806972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1806977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1806980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1806983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1806986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1806989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807015 */     // MIs[0] policy
     /* 1807015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807025 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1807028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1807046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807049 */     // GIR_Coverage, 19317,
     /* 1807049 */     GIR_EraseRootFromParent_Done,
     /* 1807050 */   // Label 24404: @1807050
     /* 1807050 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1807136), // Rule ID 19320 //
     /* 1807055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1807058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1807072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1807075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807101 */     // MIs[0] policy
     /* 1807101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807111 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1807114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1807132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807135 */     // GIR_Coverage, 19320,
     /* 1807135 */     GIR_EraseRootFromParent_Done,
     /* 1807136 */   // Label 24405: @1807136
     /* 1807136 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1807222), // Rule ID 19321 //
     /* 1807141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1807144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1807158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1807161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807187 */     // MIs[0] policy
     /* 1807187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807197 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1807200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1807218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807221 */     // GIR_Coverage, 19321,
     /* 1807221 */     GIR_EraseRootFromParent_Done,
     /* 1807222 */   // Label 24406: @1807222
     /* 1807222 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1807308), // Rule ID 19324 //
     /* 1807227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1807230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807273 */     // MIs[0] policy
     /* 1807273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807283 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1807286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807307 */     // GIR_Coverage, 19324,
     /* 1807307 */     GIR_EraseRootFromParent_Done,
     /* 1807308 */   // Label 24407: @1807308
     /* 1807308 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1807394), // Rule ID 19325 //
     /* 1807313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1807316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807359 */     // MIs[0] policy
     /* 1807359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807369 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1807372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807393 */     // GIR_Coverage, 19325,
     /* 1807393 */     GIR_EraseRootFromParent_Done,
     /* 1807394 */   // Label 24408: @1807394
     /* 1807394 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1807480), // Rule ID 19328 //
     /* 1807399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1807402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807445 */     // MIs[0] policy
     /* 1807445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807455 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1807458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807479 */     // GIR_Coverage, 19328,
     /* 1807479 */     GIR_EraseRootFromParent_Done,
     /* 1807480 */   // Label 24409: @1807480
     /* 1807480 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1807566), // Rule ID 19329 //
     /* 1807485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1807488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807531 */     // MIs[0] policy
     /* 1807531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807541 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1807544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807565 */     // GIR_Coverage, 19329,
     /* 1807565 */     GIR_EraseRootFromParent_Done,
     /* 1807566 */   // Label 24410: @1807566
     /* 1807566 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1807652), // Rule ID 19332 //
     /* 1807571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1807574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1807613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807617 */     // MIs[0] policy
     /* 1807617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807627 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1807630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807651 */     // GIR_Coverage, 19332,
     /* 1807651 */     GIR_EraseRootFromParent_Done,
     /* 1807652 */   // Label 24411: @1807652
     /* 1807652 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1807738), // Rule ID 19333 //
     /* 1807657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1807660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1807699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807703 */     // MIs[0] policy
     /* 1807703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807713 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1807716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807737 */     // GIR_Coverage, 19333,
     /* 1807737 */     GIR_EraseRootFromParent_Done,
     /* 1807738 */   // Label 24412: @1807738
     /* 1807738 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1807824), // Rule ID 19336 //
     /* 1807743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1807746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1807754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1807757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807789 */     // MIs[0] policy
     /* 1807789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1807802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807823 */     // GIR_Coverage, 19336,
     /* 1807823 */     GIR_EraseRootFromParent_Done,
     /* 1807824 */   // Label 24413: @1807824
     /* 1807824 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1807910), // Rule ID 19337 //
     /* 1807829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1807832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1807840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1807843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1807849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1807871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807875 */     // MIs[0] policy
     /* 1807875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807885 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10957:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1807888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807909 */     // GIR_Coverage, 19337,
     /* 1807909 */     GIR_EraseRootFromParent_Done,
     /* 1807910 */   // Label 24414: @1807910
     /* 1807910 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1807996), // Rule ID 19340 //
     /* 1807915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1807918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1807923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1807926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1807929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1807957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807961 */     // MIs[0] policy
     /* 1807961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1807974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807995 */     // GIR_Coverage, 19340,
     /* 1807995 */     GIR_EraseRootFromParent_Done,
     /* 1807996 */   // Label 24415: @1807996
     /* 1807996 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1808082), // Rule ID 19341 //
     /* 1808001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1808004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1808012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1808015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1808018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1808043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808047 */     // MIs[0] policy
     /* 1808047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808057 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10957:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1808060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808081 */     // GIR_Coverage, 19341,
     /* 1808081 */     GIR_EraseRootFromParent_Done,
     /* 1808082 */   // Label 24416: @1808082
     /* 1808082 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1808168), // Rule ID 19344 //
     /* 1808087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1808090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1808104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1808129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808133 */     // MIs[0] policy
     /* 1808133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808143 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1808146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1808164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808167 */     // GIR_Coverage, 19344,
     /* 1808167 */     GIR_EraseRootFromParent_Done,
     /* 1808168 */   // Label 24417: @1808168
     /* 1808168 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1808254), // Rule ID 19345 //
     /* 1808173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1808176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1808190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1808215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808219 */     // MIs[0] policy
     /* 1808219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808229 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10957:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1808232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1808250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808253 */     // GIR_Coverage, 19345,
     /* 1808253 */     GIR_EraseRootFromParent_Done,
     /* 1808254 */   // Label 24418: @1808254
     /* 1808254 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1808340), // Rule ID 19348 //
     /* 1808259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1808262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1808276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808305 */     // MIs[0] policy
     /* 1808305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1808318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808339 */     // GIR_Coverage, 19348,
     /* 1808339 */     GIR_EraseRootFromParent_Done,
     /* 1808340 */   // Label 24419: @1808340
     /* 1808340 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1808426), // Rule ID 19349 //
     /* 1808345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1808348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1808362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808391 */     // MIs[0] policy
     /* 1808391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808401 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1808404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808425 */     // GIR_Coverage, 19349,
     /* 1808425 */     GIR_EraseRootFromParent_Done,
     /* 1808426 */   // Label 24420: @1808426
     /* 1808426 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1808512), // Rule ID 19352 //
     /* 1808431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1808434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1808448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808477 */     // MIs[0] policy
     /* 1808477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808487 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1808490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808511 */     // GIR_Coverage, 19352,
     /* 1808511 */     GIR_EraseRootFromParent_Done,
     /* 1808512 */   // Label 24421: @1808512
     /* 1808512 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1808598), // Rule ID 19353 //
     /* 1808517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1808520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1808534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808563 */     // MIs[0] policy
     /* 1808563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808573 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1808576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808597 */     // GIR_Coverage, 19353,
     /* 1808597 */     GIR_EraseRootFromParent_Done,
     /* 1808598 */   // Label 24422: @1808598
     /* 1808598 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1808684), // Rule ID 19356 //
     /* 1808603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1808606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1808620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808649 */     // MIs[0] policy
     /* 1808649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808659 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1808662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808683 */     // GIR_Coverage, 19356,
     /* 1808683 */     GIR_EraseRootFromParent_Done,
     /* 1808684 */   // Label 24423: @1808684
     /* 1808684 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1808770), // Rule ID 19357 //
     /* 1808689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1808692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1808706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1808709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1808731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808735 */     // MIs[0] policy
     /* 1808735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808745 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1808748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808769 */     // GIR_Coverage, 19357,
     /* 1808769 */     GIR_EraseRootFromParent_Done,
     /* 1808770 */   // Label 24424: @1808770
     /* 1808770 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1808856), // Rule ID 19360 //
     /* 1808775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1808778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1808786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1808789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1808817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808821 */     // MIs[0] policy
     /* 1808821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808831 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1808834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808855 */     // GIR_Coverage, 19360,
     /* 1808855 */     GIR_EraseRootFromParent_Done,
     /* 1808856 */   // Label 24425: @1808856
     /* 1808856 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1808942), // Rule ID 19361 //
     /* 1808861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1808864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1808872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1808875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1808903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808907 */     // MIs[0] policy
     /* 1808907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808917 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1808920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808941 */     // GIR_Coverage, 19361,
     /* 1808941 */     GIR_EraseRootFromParent_Done,
     /* 1808942 */   // Label 24426: @1808942
     /* 1808942 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1809028), // Rule ID 19364 //
     /* 1808947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1808950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1808955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1808958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1808961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1808964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1808989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808993 */     // MIs[0] policy
     /* 1808993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809003 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1809006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809027 */     // GIR_Coverage, 19364,
     /* 1809027 */     GIR_EraseRootFromParent_Done,
     /* 1809028 */   // Label 24427: @1809028
     /* 1809028 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1809114), // Rule ID 19365 //
     /* 1809033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1809036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1809050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1809075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809079 */     // MIs[0] policy
     /* 1809079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809089 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1809092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809113 */     // GIR_Coverage, 19365,
     /* 1809113 */     GIR_EraseRootFromParent_Done,
     /* 1809114 */   // Label 24428: @1809114
     /* 1809114 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1809200), // Rule ID 19368 //
     /* 1809119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1809122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1809136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1809161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809165 */     // MIs[0] policy
     /* 1809165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809175 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1809178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809199 */     // GIR_Coverage, 19368,
     /* 1809199 */     GIR_EraseRootFromParent_Done,
     /* 1809200 */   // Label 24429: @1809200
     /* 1809200 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1809286), // Rule ID 19369 //
     /* 1809205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1809208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1809222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1809247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809251 */     // MIs[0] policy
     /* 1809251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809261 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1809264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809285 */     // GIR_Coverage, 19369,
     /* 1809285 */     GIR_EraseRootFromParent_Done,
     /* 1809286 */   // Label 24430: @1809286
     /* 1809286 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1809372), // Rule ID 19372 //
     /* 1809291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1809294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1809308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809337 */     // MIs[0] policy
     /* 1809337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809347 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1809350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809371 */     // GIR_Coverage, 19372,
     /* 1809371 */     GIR_EraseRootFromParent_Done,
     /* 1809372 */   // Label 24431: @1809372
     /* 1809372 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1809458), // Rule ID 19373 //
     /* 1809377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1809380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1809394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809423 */     // MIs[0] policy
     /* 1809423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809433 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10957:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1809436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809457 */     // GIR_Coverage, 19373,
     /* 1809457 */     GIR_EraseRootFromParent_Done,
     /* 1809458 */   // Label 24432: @1809458
     /* 1809458 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1809544), // Rule ID 19376 //
     /* 1809463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1809466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1809480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809509 */     // MIs[0] policy
     /* 1809509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809519 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1809522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809543 */     // GIR_Coverage, 19376,
     /* 1809543 */     GIR_EraseRootFromParent_Done,
     /* 1809544 */   // Label 24433: @1809544
     /* 1809544 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1809630), // Rule ID 19377 //
     /* 1809549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1809552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1809566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809595 */     // MIs[0] policy
     /* 1809595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809605 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10957:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1809608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809629 */     // GIR_Coverage, 19377,
     /* 1809629 */     GIR_EraseRootFromParent_Done,
     /* 1809630 */   // Label 24434: @1809630
     /* 1809630 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1809716), // Rule ID 19380 //
     /* 1809635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1809638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1809646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1809649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1809652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809681 */     // MIs[0] policy
     /* 1809681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809691 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1809694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809715 */     // GIR_Coverage, 19380,
     /* 1809715 */     GIR_EraseRootFromParent_Done,
     /* 1809716 */   // Label 24435: @1809716
     /* 1809716 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1809802), // Rule ID 19381 //
     /* 1809721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1809724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1809729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1809732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1809735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1809738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1809763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809767 */     // MIs[0] policy
     /* 1809767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809777 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10957:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1809780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1809798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809801 */     // GIR_Coverage, 19381,
     /* 1809801 */     GIR_EraseRootFromParent_Done,
     /* 1809802 */   // Label 24436: @1809802
     /* 1809802 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1809888), // Rule ID 19384 //
     /* 1809807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1809810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1809815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1809818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1809821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809853 */     // MIs[0] policy
     /* 1809853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809863 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1809866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809887 */     // GIR_Coverage, 19384,
     /* 1809887 */     GIR_EraseRootFromParent_Done,
     /* 1809888 */   // Label 24437: @1809888
     /* 1809888 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1809974), // Rule ID 19385 //
     /* 1809893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1809896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1809901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1809904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1809907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809939 */     // MIs[0] policy
     /* 1809939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809949 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1809952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809973 */     // GIR_Coverage, 19385,
     /* 1809973 */     GIR_EraseRootFromParent_Done,
     /* 1809974 */   // Label 24438: @1809974
     /* 1809974 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1810060), // Rule ID 19388 //
     /* 1809979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1809982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1809987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1809990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1809993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1809999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810025 */     // MIs[0] policy
     /* 1810025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810035 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1810038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810059 */     // GIR_Coverage, 19388,
     /* 1810059 */     GIR_EraseRootFromParent_Done,
     /* 1810060 */   // Label 24439: @1810060
     /* 1810060 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1810146), // Rule ID 19389 //
     /* 1810065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1810068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1810082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1810085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810111 */     // MIs[0] policy
     /* 1810111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810121 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1810124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810145 */     // GIR_Coverage, 19389,
     /* 1810145 */     GIR_EraseRootFromParent_Done,
     /* 1810146 */   // Label 24440: @1810146
     /* 1810146 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1810232), // Rule ID 19392 //
     /* 1810151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1810154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1810162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1810165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1810171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810197 */     // MIs[0] policy
     /* 1810197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810207 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1810210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810231 */     // GIR_Coverage, 19392,
     /* 1810231 */     GIR_EraseRootFromParent_Done,
     /* 1810232 */   // Label 24441: @1810232
     /* 1810232 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1810318), // Rule ID 19393 //
     /* 1810237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1810240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1810248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1810251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1810257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810283 */     // MIs[0] policy
     /* 1810283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810293 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1810296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810317 */     // GIR_Coverage, 19393,
     /* 1810317 */     GIR_EraseRootFromParent_Done,
     /* 1810318 */   // Label 24442: @1810318
     /* 1810318 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1810404), // Rule ID 19396 //
     /* 1810323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1810326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1810340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1810343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810369 */     // MIs[0] policy
     /* 1810369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810379 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1810382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810403 */     // GIR_Coverage, 19396,
     /* 1810403 */     GIR_EraseRootFromParent_Done,
     /* 1810404 */   // Label 24443: @1810404
     /* 1810404 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1810490), // Rule ID 19397 //
     /* 1810409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1810412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1810426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1810429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810455 */     // MIs[0] policy
     /* 1810455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810465 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1810468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810489 */     // GIR_Coverage, 19397,
     /* 1810489 */     GIR_EraseRootFromParent_Done,
     /* 1810490 */   // Label 24444: @1810490
     /* 1810490 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1810576), // Rule ID 19400 //
     /* 1810495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1810498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1810506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1810509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810541 */     // MIs[0] policy
     /* 1810541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810551 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1810554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810575 */     // GIR_Coverage, 19400,
     /* 1810575 */     GIR_EraseRootFromParent_Done,
     /* 1810576 */   // Label 24445: @1810576
     /* 1810576 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1810662), // Rule ID 19401 //
     /* 1810581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1810584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1810592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1810595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810627 */     // MIs[0] policy
     /* 1810627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810637 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1810640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810661 */     // GIR_Coverage, 19401,
     /* 1810661 */     GIR_EraseRootFromParent_Done,
     /* 1810662 */   // Label 24446: @1810662
     /* 1810662 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1810748), // Rule ID 19404 //
     /* 1810667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1810670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1810684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1810687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810713 */     // MIs[0] policy
     /* 1810713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810723 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1810726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1810744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810747 */     // GIR_Coverage, 19404,
     /* 1810747 */     GIR_EraseRootFromParent_Done,
     /* 1810748 */   // Label 24447: @1810748
     /* 1810748 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1810834), // Rule ID 19405 //
     /* 1810753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1810756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1810770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1810773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810799 */     // MIs[0] policy
     /* 1810799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810809 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1810812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1810830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810833 */     // GIR_Coverage, 19405,
     /* 1810833 */     GIR_EraseRootFromParent_Done,
     /* 1810834 */   // Label 24448: @1810834
     /* 1810834 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1810920), // Rule ID 19408 //
     /* 1810839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1810842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810885 */     // MIs[0] policy
     /* 1810885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810895 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1810898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810919 */     // GIR_Coverage, 19408,
     /* 1810919 */     GIR_EraseRootFromParent_Done,
     /* 1810920 */   // Label 24449: @1810920
     /* 1810920 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1811006), // Rule ID 19409 //
     /* 1810925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1810928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1810933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810971 */     // MIs[0] policy
     /* 1810971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810981 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1810984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811005 */     // GIR_Coverage, 19409,
     /* 1811005 */     GIR_EraseRootFromParent_Done,
     /* 1811006 */   // Label 24450: @1811006
     /* 1811006 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1811092), // Rule ID 19412 //
     /* 1811011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1811014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811057 */     // MIs[0] policy
     /* 1811057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811067 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1811070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811091 */     // GIR_Coverage, 19412,
     /* 1811091 */     GIR_EraseRootFromParent_Done,
     /* 1811092 */   // Label 24451: @1811092
     /* 1811092 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1811178), // Rule ID 19413 //
     /* 1811097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1811100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811143 */     // MIs[0] policy
     /* 1811143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811153 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1811156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811177 */     // GIR_Coverage, 19413,
     /* 1811177 */     GIR_EraseRootFromParent_Done,
     /* 1811178 */   // Label 24452: @1811178
     /* 1811178 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1811264), // Rule ID 19416 //
     /* 1811183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1811186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1811200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1811203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811229 */     // MIs[0] policy
     /* 1811229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811239 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1811242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811263 */     // GIR_Coverage, 19416,
     /* 1811263 */     GIR_EraseRootFromParent_Done,
     /* 1811264 */   // Label 24453: @1811264
     /* 1811264 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1811350), // Rule ID 19417 //
     /* 1811269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1811272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1811286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1811289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811315 */     // MIs[0] policy
     /* 1811315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811325 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1811328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811349 */     // GIR_Coverage, 19417,
     /* 1811349 */     GIR_EraseRootFromParent_Done,
     /* 1811350 */   // Label 24454: @1811350
     /* 1811350 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1811436), // Rule ID 19420 //
     /* 1811355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1811358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811401 */     // MIs[0] policy
     /* 1811401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1811414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811435 */     // GIR_Coverage, 19420,
     /* 1811435 */     GIR_EraseRootFromParent_Done,
     /* 1811436 */   // Label 24455: @1811436
     /* 1811436 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1811522), // Rule ID 19421 //
     /* 1811441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1811444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811487 */     // MIs[0] policy
     /* 1811487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811497 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1811500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811521 */     // GIR_Coverage, 19421,
     /* 1811521 */     GIR_EraseRootFromParent_Done,
     /* 1811522 */   // Label 24456: @1811522
     /* 1811522 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1811608), // Rule ID 19424 //
     /* 1811527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1811530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811573 */     // MIs[0] policy
     /* 1811573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811583 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1811586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811607 */     // GIR_Coverage, 19424,
     /* 1811607 */     GIR_EraseRootFromParent_Done,
     /* 1811608 */   // Label 24457: @1811608
     /* 1811608 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1811694), // Rule ID 19425 //
     /* 1811613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1811616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811659 */     // MIs[0] policy
     /* 1811659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811669 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1811672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811693 */     // GIR_Coverage, 19425,
     /* 1811693 */     GIR_EraseRootFromParent_Done,
     /* 1811694 */   // Label 24458: @1811694
     /* 1811694 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1811780), // Rule ID 19428 //
     /* 1811699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1811702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1811716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1811719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811745 */     // MIs[0] policy
     /* 1811745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811755 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1811758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811779 */     // GIR_Coverage, 19428,
     /* 1811779 */     GIR_EraseRootFromParent_Done,
     /* 1811780 */   // Label 24459: @1811780
     /* 1811780 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1811866), // Rule ID 19429 //
     /* 1811785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1811788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1811802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1811805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811831 */     // MIs[0] policy
     /* 1811831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811841 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1811844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811865 */     // GIR_Coverage, 19429,
     /* 1811865 */     GIR_EraseRootFromParent_Done,
     /* 1811866 */   // Label 24460: @1811866
     /* 1811866 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1811952), // Rule ID 19432 //
     /* 1811871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1811874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1811882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1811885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1811888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1811891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811917 */     // MIs[0] policy
     /* 1811917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811927 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1811930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1811948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811951 */     // GIR_Coverage, 19432,
     /* 1811951 */     GIR_EraseRootFromParent_Done,
     /* 1811952 */   // Label 24461: @1811952
     /* 1811952 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1812038), // Rule ID 19433 //
     /* 1811957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1811960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1811965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1811968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1811971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1811974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1811977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812003 */     // MIs[0] policy
     /* 1812003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1812016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812037 */     // GIR_Coverage, 19433,
     /* 1812037 */     GIR_EraseRootFromParent_Done,
     /* 1812038 */   // Label 24462: @1812038
     /* 1812038 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1812124), // Rule ID 19436 //
     /* 1812043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1812046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1812060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1812063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812089 */     // MIs[0] policy
     /* 1812089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812099 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1812102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812123 */     // GIR_Coverage, 19436,
     /* 1812123 */     GIR_EraseRootFromParent_Done,
     /* 1812124 */   // Label 24463: @1812124
     /* 1812124 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1812210), // Rule ID 19437 //
     /* 1812129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1812132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1812146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1812149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812175 */     // MIs[0] policy
     /* 1812175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812185 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1812188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812209 */     // GIR_Coverage, 19437,
     /* 1812209 */     GIR_EraseRootFromParent_Done,
     /* 1812210 */   // Label 24464: @1812210
     /* 1812210 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1812296), // Rule ID 19440 //
     /* 1812215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1812218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1812232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1812235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812261 */     // MIs[0] policy
     /* 1812261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812271 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1812274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812295 */     // GIR_Coverage, 19440,
     /* 1812295 */     GIR_EraseRootFromParent_Done,
     /* 1812296 */   // Label 24465: @1812296
     /* 1812296 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1812382), // Rule ID 19441 //
     /* 1812301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1812304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1812318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1812321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812347 */     // MIs[0] policy
     /* 1812347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1812360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812381 */     // GIR_Coverage, 19441,
     /* 1812381 */     GIR_EraseRootFromParent_Done,
     /* 1812382 */   // Label 24466: @1812382
     /* 1812382 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1812468), // Rule ID 19444 //
     /* 1812387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1812390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1812404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1812407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1812429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812433 */     // MIs[0] policy
     /* 1812433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812443 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1812446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812467 */     // GIR_Coverage, 19444,
     /* 1812467 */     GIR_EraseRootFromParent_Done,
     /* 1812468 */   // Label 24467: @1812468
     /* 1812468 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1812554), // Rule ID 19445 //
     /* 1812473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1812476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1812490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1812493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1812515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812519 */     // MIs[0] policy
     /* 1812519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812529 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1812532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812553 */     // GIR_Coverage, 19445,
     /* 1812553 */     GIR_EraseRootFromParent_Done,
     /* 1812554 */   // Label 24468: @1812554
     /* 1812554 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1812640), // Rule ID 19448 //
     /* 1812559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1812562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1812570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1812573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1812576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1812579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1812601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812605 */     // MIs[0] policy
     /* 1812605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812615 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1812618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812639 */     // GIR_Coverage, 19448,
     /* 1812639 */     GIR_EraseRootFromParent_Done,
     /* 1812640 */   // Label 24469: @1812640
     /* 1812640 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1812726), // Rule ID 19449 //
     /* 1812645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1812648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1812656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1812659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1812662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1812665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1812687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812691 */     // MIs[0] policy
     /* 1812691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812701 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1812704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812725 */     // GIR_Coverage, 19449,
     /* 1812725 */     GIR_EraseRootFromParent_Done,
     /* 1812726 */   // Label 24470: @1812726
     /* 1812726 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1812812), // Rule ID 19452 //
     /* 1812731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1812734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1812742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1812745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1812773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812777 */     // MIs[0] policy
     /* 1812777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812787 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1812790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812811 */     // GIR_Coverage, 19452,
     /* 1812811 */     GIR_EraseRootFromParent_Done,
     /* 1812812 */   // Label 24471: @1812812
     /* 1812812 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1812898), // Rule ID 19453 //
     /* 1812817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1812820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1812828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1812831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1812859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812863 */     // MIs[0] policy
     /* 1812863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812873 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1812876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812897 */     // GIR_Coverage, 19453,
     /* 1812897 */     GIR_EraseRootFromParent_Done,
     /* 1812898 */   // Label 24472: @1812898
     /* 1812898 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1812984), // Rule ID 19456 //
     /* 1812903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1812906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1812914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1812917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1812923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1812945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812949 */     // MIs[0] policy
     /* 1812949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812959 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1812962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812983 */     // GIR_Coverage, 19456,
     /* 1812983 */     GIR_EraseRootFromParent_Done,
     /* 1812984 */   // Label 24473: @1812984
     /* 1812984 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1813070), // Rule ID 19457 //
     /* 1812989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1812992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1812997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1813006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813035 */     // MIs[0] policy
     /* 1813035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813045 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10959:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1813048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813069 */     // GIR_Coverage, 19457,
     /* 1813069 */     GIR_EraseRootFromParent_Done,
     /* 1813070 */   // Label 24474: @1813070
     /* 1813070 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1813156), // Rule ID 19460 //
     /* 1813075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1813078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1813092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1813117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813121 */     // MIs[0] policy
     /* 1813121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813131 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1813134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813155 */     // GIR_Coverage, 19460,
     /* 1813155 */     GIR_EraseRootFromParent_Done,
     /* 1813156 */   // Label 24475: @1813156
     /* 1813156 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1813242), // Rule ID 19461 //
     /* 1813161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1813164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1813178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1813203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813207 */     // MIs[0] policy
     /* 1813207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813217 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10959:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1813220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813241 */     // GIR_Coverage, 19461,
     /* 1813241 */     GIR_EraseRootFromParent_Done,
     /* 1813242 */   // Label 24476: @1813242
     /* 1813242 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1813328), // Rule ID 19464 //
     /* 1813247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1813250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1813264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1813289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813293 */     // MIs[0] policy
     /* 1813293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813303 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1813306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1813324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813327 */     // GIR_Coverage, 19464,
     /* 1813327 */     GIR_EraseRootFromParent_Done,
     /* 1813328 */   // Label 24477: @1813328
     /* 1813328 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1813414), // Rule ID 19465 //
     /* 1813333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1813336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1813350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1813375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813379 */     // MIs[0] policy
     /* 1813379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813389 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10959:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1813392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1813410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813413 */     // GIR_Coverage, 19465,
     /* 1813413 */     GIR_EraseRootFromParent_Done,
     /* 1813414 */   // Label 24478: @1813414
     /* 1813414 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1813500), // Rule ID 19468 //
     /* 1813419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1813422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1813436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813465 */     // MIs[0] policy
     /* 1813465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1813478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813499 */     // GIR_Coverage, 19468,
     /* 1813499 */     GIR_EraseRootFromParent_Done,
     /* 1813500 */   // Label 24479: @1813500
     /* 1813500 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1813586), // Rule ID 19469 //
     /* 1813505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1813508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1813522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813551 */     // MIs[0] policy
     /* 1813551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813561 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1813564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813585 */     // GIR_Coverage, 19469,
     /* 1813585 */     GIR_EraseRootFromParent_Done,
     /* 1813586 */   // Label 24480: @1813586
     /* 1813586 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1813672), // Rule ID 19472 //
     /* 1813591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1813594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1813608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813637 */     // MIs[0] policy
     /* 1813637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813647 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1813650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813671 */     // GIR_Coverage, 19472,
     /* 1813671 */     GIR_EraseRootFromParent_Done,
     /* 1813672 */   // Label 24481: @1813672
     /* 1813672 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1813758), // Rule ID 19473 //
     /* 1813677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1813680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1813694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813723 */     // MIs[0] policy
     /* 1813723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813733 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1813736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813757 */     // GIR_Coverage, 19473,
     /* 1813757 */     GIR_EraseRootFromParent_Done,
     /* 1813758 */   // Label 24482: @1813758
     /* 1813758 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1813844), // Rule ID 19476 //
     /* 1813763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1813766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1813780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813809 */     // MIs[0] policy
     /* 1813809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813819 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1813822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813843 */     // GIR_Coverage, 19476,
     /* 1813843 */     GIR_EraseRootFromParent_Done,
     /* 1813844 */   // Label 24483: @1813844
     /* 1813844 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1813930), // Rule ID 19477 //
     /* 1813849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1813852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1813866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1813869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1813891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813895 */     // MIs[0] policy
     /* 1813895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813905 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1813908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813929 */     // GIR_Coverage, 19477,
     /* 1813929 */     GIR_EraseRootFromParent_Done,
     /* 1813930 */   // Label 24484: @1813930
     /* 1813930 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1814016), // Rule ID 19480 //
     /* 1813935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1813938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1813943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1813946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1813949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1813952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1813977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813981 */     // MIs[0] policy
     /* 1813981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1813994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814015 */     // GIR_Coverage, 19480,
     /* 1814015 */     GIR_EraseRootFromParent_Done,
     /* 1814016 */   // Label 24485: @1814016
     /* 1814016 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1814102), // Rule ID 19481 //
     /* 1814021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1814024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1814038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1814063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814067 */     // MIs[0] policy
     /* 1814067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1814080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814101 */     // GIR_Coverage, 19481,
     /* 1814101 */     GIR_EraseRootFromParent_Done,
     /* 1814102 */   // Label 24486: @1814102
     /* 1814102 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1814188), // Rule ID 19484 //
     /* 1814107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1814110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1814124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1814149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814153 */     // MIs[0] policy
     /* 1814153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814163 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1814166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814187 */     // GIR_Coverage, 19484,
     /* 1814187 */     GIR_EraseRootFromParent_Done,
     /* 1814188 */   // Label 24487: @1814188
     /* 1814188 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1814274), // Rule ID 19485 //
     /* 1814193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1814196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1814210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1814235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814239 */     // MIs[0] policy
     /* 1814239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814249 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1814252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814273 */     // GIR_Coverage, 19485,
     /* 1814273 */     GIR_EraseRootFromParent_Done,
     /* 1814274 */   // Label 24488: @1814274
     /* 1814274 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1814360), // Rule ID 19488 //
     /* 1814279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1814282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1814296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1814321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814325 */     // MIs[0] policy
     /* 1814325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814335 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1814338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814359 */     // GIR_Coverage, 19488,
     /* 1814359 */     GIR_EraseRootFromParent_Done,
     /* 1814360 */   // Label 24489: @1814360
     /* 1814360 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1814446), // Rule ID 19489 //
     /* 1814365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1814368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1814382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1814407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814411 */     // MIs[0] policy
     /* 1814411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814421 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1814424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814445 */     // GIR_Coverage, 19489,
     /* 1814445 */     GIR_EraseRootFromParent_Done,
     /* 1814446 */   // Label 24490: @1814446
     /* 1814446 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1814532), // Rule ID 19492 //
     /* 1814451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1814454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1814468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814497 */     // MIs[0] policy
     /* 1814497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814507 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1814510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814531 */     // GIR_Coverage, 19492,
     /* 1814531 */     GIR_EraseRootFromParent_Done,
     /* 1814532 */   // Label 24491: @1814532
     /* 1814532 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1814618), // Rule ID 19493 //
     /* 1814537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1814540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1814554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814583 */     // MIs[0] policy
     /* 1814583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10959:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1814596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814617 */     // GIR_Coverage, 19493,
     /* 1814617 */     GIR_EraseRootFromParent_Done,
     /* 1814618 */   // Label 24492: @1814618
     /* 1814618 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1814704), // Rule ID 19496 //
     /* 1814623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1814626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1814634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1814637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1814640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814669 */     // MIs[0] policy
     /* 1814669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814679 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1814682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814703 */     // GIR_Coverage, 19496,
     /* 1814703 */     GIR_EraseRootFromParent_Done,
     /* 1814704 */   // Label 24493: @1814704
     /* 1814704 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1814790), // Rule ID 19497 //
     /* 1814709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1814712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1814720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1814723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1814726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814755 */     // MIs[0] policy
     /* 1814755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814765 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10959:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1814768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814789 */     // GIR_Coverage, 19497,
     /* 1814789 */     GIR_EraseRootFromParent_Done,
     /* 1814790 */   // Label 24494: @1814790
     /* 1814790 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1814876), // Rule ID 19500 //
     /* 1814795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1814798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1814806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1814809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1814812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814841 */     // MIs[0] policy
     /* 1814841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814851 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1814854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814875 */     // GIR_Coverage, 19500,
     /* 1814875 */     GIR_EraseRootFromParent_Done,
     /* 1814876 */   // Label 24495: @1814876
     /* 1814876 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1814962), // Rule ID 19501 //
     /* 1814881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1814884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1814889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1814892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1814895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1814898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1814923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814927 */     // MIs[0] policy
     /* 1814927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814937 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10959:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1814940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814961 */     // GIR_Coverage, 19501,
     /* 1814961 */     GIR_EraseRootFromParent_Done,
     /* 1814962 */   // Label 24496: @1814962
     /* 1814962 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1815048), // Rule ID 19504 //
     /* 1814967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1814970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1814975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1814978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1814981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1814984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1814987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815013 */     // MIs[0] policy
     /* 1815013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815023 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1815026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815047 */     // GIR_Coverage, 19504,
     /* 1815047 */     GIR_EraseRootFromParent_Done,
     /* 1815048 */   // Label 24497: @1815048
     /* 1815048 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1815134), // Rule ID 19505 //
     /* 1815053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1815056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1815064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1815067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815099 */     // MIs[0] policy
     /* 1815099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815109 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1815112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815133 */     // GIR_Coverage, 19505,
     /* 1815133 */     GIR_EraseRootFromParent_Done,
     /* 1815134 */   // Label 24498: @1815134
     /* 1815134 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1815220), // Rule ID 19508 //
     /* 1815139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1815142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815185 */     // MIs[0] policy
     /* 1815185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815195 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1815198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815219 */     // GIR_Coverage, 19508,
     /* 1815219 */     GIR_EraseRootFromParent_Done,
     /* 1815220 */   // Label 24499: @1815220
     /* 1815220 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1815306), // Rule ID 19509 //
     /* 1815225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1815228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815271 */     // MIs[0] policy
     /* 1815271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815281 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1815284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815305 */     // GIR_Coverage, 19509,
     /* 1815305 */     GIR_EraseRootFromParent_Done,
     /* 1815306 */   // Label 24500: @1815306
     /* 1815306 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1815392), // Rule ID 19512 //
     /* 1815311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1815314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1815322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1815325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1815331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815357 */     // MIs[0] policy
     /* 1815357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815367 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1815370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815391 */     // GIR_Coverage, 19512,
     /* 1815391 */     GIR_EraseRootFromParent_Done,
     /* 1815392 */   // Label 24501: @1815392
     /* 1815392 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1815478), // Rule ID 19513 //
     /* 1815397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1815400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1815408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1815411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1815417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815443 */     // MIs[0] policy
     /* 1815443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815453 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1815456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815477 */     // GIR_Coverage, 19513,
     /* 1815477 */     GIR_EraseRootFromParent_Done,
     /* 1815478 */   // Label 24502: @1815478
     /* 1815478 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1815564), // Rule ID 19516 //
     /* 1815483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1815486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1815494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1815497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1815500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1815503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815529 */     // MIs[0] policy
     /* 1815529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815539 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1815542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815563 */     // GIR_Coverage, 19516,
     /* 1815563 */     GIR_EraseRootFromParent_Done,
     /* 1815564 */   // Label 24503: @1815564
     /* 1815564 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1815650), // Rule ID 19517 //
     /* 1815569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1815572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1815580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1815583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1815586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1815589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815615 */     // MIs[0] policy
     /* 1815615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815625 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1815628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815649 */     // GIR_Coverage, 19517,
     /* 1815649 */     GIR_EraseRootFromParent_Done,
     /* 1815650 */   // Label 24504: @1815650
     /* 1815650 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1815736), // Rule ID 19520 //
     /* 1815655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1815658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1815666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1815669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1815675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815701 */     // MIs[0] policy
     /* 1815701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815711 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1815714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815735 */     // GIR_Coverage, 19520,
     /* 1815735 */     GIR_EraseRootFromParent_Done,
     /* 1815736 */   // Label 24505: @1815736
     /* 1815736 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1815822), // Rule ID 19521 //
     /* 1815741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1815744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1815752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1815755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1815761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815787 */     // MIs[0] policy
     /* 1815787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815797 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1815800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815821 */     // GIR_Coverage, 19521,
     /* 1815821 */     GIR_EraseRootFromParent_Done,
     /* 1815822 */   // Label 24506: @1815822
     /* 1815822 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1815908), // Rule ID 19524 //
     /* 1815827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1815830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1815844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1815847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815873 */     // MIs[0] policy
     /* 1815873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1815886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815907 */     // GIR_Coverage, 19524,
     /* 1815907 */     GIR_EraseRootFromParent_Done,
     /* 1815908 */   // Label 24507: @1815908
     /* 1815908 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1815994), // Rule ID 19525 //
     /* 1815913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1815916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1815921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1815930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1815933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815959 */     // MIs[0] policy
     /* 1815959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815969 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1815972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815993 */     // GIR_Coverage, 19525,
     /* 1815993 */     GIR_EraseRootFromParent_Done,
     /* 1815994 */   // Label 24508: @1815994
     /* 1815994 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1816080), // Rule ID 19528 //
     /* 1815999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1816002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1816010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1816013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1816016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1816019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816045 */     // MIs[0] policy
     /* 1816045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816055 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1816058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816079 */     // GIR_Coverage, 19528,
     /* 1816079 */     GIR_EraseRootFromParent_Done,
     /* 1816080 */   // Label 24509: @1816080
     /* 1816080 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1816166), // Rule ID 19529 //
     /* 1816085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1816088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1816096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1816099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1816102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1816105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816131 */     // MIs[0] policy
     /* 1816131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816141 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1816144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816165 */     // GIR_Coverage, 19529,
     /* 1816165 */     GIR_EraseRootFromParent_Done,
     /* 1816166 */   // Label 24510: @1816166
     /* 1816166 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1816252), // Rule ID 19532 //
     /* 1816171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1816174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1816182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1816185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1816188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1816191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816217 */     // MIs[0] policy
     /* 1816217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816227 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1816230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816251 */     // GIR_Coverage, 19532,
     /* 1816251 */     GIR_EraseRootFromParent_Done,
     /* 1816252 */   // Label 24511: @1816252
     /* 1816252 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1816338), // Rule ID 19533 //
     /* 1816257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1816260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1816268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1816271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1816274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1816277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816303 */     // MIs[0] policy
     /* 1816303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816313 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1816316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816337 */     // GIR_Coverage, 19533,
     /* 1816337 */     GIR_EraseRootFromParent_Done,
     /* 1816338 */   // Label 24512: @1816338
     /* 1816338 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1816424), // Rule ID 19536 //
     /* 1816343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1816346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1816354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1816357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1816360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1816363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1816366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816389 */     // MIs[0] policy
     /* 1816389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816399 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1816402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816423 */     // GIR_Coverage, 19536,
     /* 1816423 */     GIR_EraseRootFromParent_Done,
     /* 1816424 */   // Label 24513: @1816424
     /* 1816424 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1816510), // Rule ID 19537 //
     /* 1816429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1816432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1816440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1816443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1816446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1816449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1816452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816475 */     // MIs[0] policy
     /* 1816475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816485 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1816488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816509 */     // GIR_Coverage, 19537,
     /* 1816509 */     GIR_EraseRootFromParent_Done,
     /* 1816510 */   // Label 24514: @1816510
     /* 1816510 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1816596), // Rule ID 19540 //
     /* 1816515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1816518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1816526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1816529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1816532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1816535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816561 */     // MIs[0] policy
     /* 1816561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1816574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816595 */     // GIR_Coverage, 19540,
     /* 1816595 */     GIR_EraseRootFromParent_Done,
     /* 1816596 */   // Label 24515: @1816596
     /* 1816596 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1816682), // Rule ID 19541 //
     /* 1816601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1816604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1816612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1816615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1816618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1816621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816647 */     // MIs[0] policy
     /* 1816647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816657 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1816660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816681 */     // GIR_Coverage, 19541,
     /* 1816681 */     GIR_EraseRootFromParent_Done,
     /* 1816682 */   // Label 24516: @1816682
     /* 1816682 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1816768), // Rule ID 19544 //
     /* 1816687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1816690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1816698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1816701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1816704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1816707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816733 */     // MIs[0] policy
     /* 1816733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816743 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1816746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816767 */     // GIR_Coverage, 19544,
     /* 1816767 */     GIR_EraseRootFromParent_Done,
     /* 1816768 */   // Label 24517: @1816768
     /* 1816768 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1816854), // Rule ID 19545 //
     /* 1816773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1816776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1816784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1816787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1816790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1816793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816819 */     // MIs[0] policy
     /* 1816819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816829 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1816832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816853 */     // GIR_Coverage, 19545,
     /* 1816853 */     GIR_EraseRootFromParent_Done,
     /* 1816854 */   // Label 24518: @1816854
     /* 1816854 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1816940), // Rule ID 19548 //
     /* 1816859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1816862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1816870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1816873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1816876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1816879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816905 */     // MIs[0] policy
     /* 1816905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816915 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1816918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816939 */     // GIR_Coverage, 19548,
     /* 1816939 */     GIR_EraseRootFromParent_Done,
     /* 1816940 */   // Label 24519: @1816940
     /* 1816940 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1817026), // Rule ID 19549 //
     /* 1816945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1816948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1816953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1816956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1816959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1816962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1816965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816991 */     // MIs[0] policy
     /* 1816991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817001 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1817004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817025 */     // GIR_Coverage, 19549,
     /* 1817025 */     GIR_EraseRootFromParent_Done,
     /* 1817026 */   // Label 24520: @1817026
     /* 1817026 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1817112), // Rule ID 19552 //
     /* 1817031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1817034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1817042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1817045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1817048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1817051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817077 */     // MIs[0] policy
     /* 1817077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817087 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1817090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817111 */     // GIR_Coverage, 19552,
     /* 1817111 */     GIR_EraseRootFromParent_Done,
     /* 1817112 */   // Label 24521: @1817112
     /* 1817112 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1817198), // Rule ID 19553 //
     /* 1817117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1817120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1817128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1817131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1817134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1817137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817163 */     // MIs[0] policy
     /* 1817163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817173 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1817176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817197 */     // GIR_Coverage, 19553,
     /* 1817197 */     GIR_EraseRootFromParent_Done,
     /* 1817198 */   // Label 24522: @1817198
     /* 1817198 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1817284), // Rule ID 19556 //
     /* 1817203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1817206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1817214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1817217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1817220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1817223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817249 */     // MIs[0] policy
     /* 1817249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817259 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1817262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817283 */     // GIR_Coverage, 19556,
     /* 1817283 */     GIR_EraseRootFromParent_Done,
     /* 1817284 */   // Label 24523: @1817284
     /* 1817284 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1817370), // Rule ID 19557 //
     /* 1817289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1817292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1817300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1817303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1817306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1817309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817335 */     // MIs[0] policy
     /* 1817335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1817348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817369 */     // GIR_Coverage, 19557,
     /* 1817369 */     GIR_EraseRootFromParent_Done,
     /* 1817370 */   // Label 24524: @1817370
     /* 1817370 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1817456), // Rule ID 19560 //
     /* 1817375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1817378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1817386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1817389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1817392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1817395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817421 */     // MIs[0] policy
     /* 1817421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817431 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1817434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817455 */     // GIR_Coverage, 19560,
     /* 1817455 */     GIR_EraseRootFromParent_Done,
     /* 1817456 */   // Label 24525: @1817456
     /* 1817456 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1817542), // Rule ID 19561 //
     /* 1817461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1817464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1817472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1817475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1817478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1817481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817507 */     // MIs[0] policy
     /* 1817507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817517 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1817520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817541 */     // GIR_Coverage, 19561,
     /* 1817541 */     GIR_EraseRootFromParent_Done,
     /* 1817542 */   // Label 24526: @1817542
     /* 1817542 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1817628), // Rule ID 19564 //
     /* 1817547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1817550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1817558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1817561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1817564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1817567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1817589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817593 */     // MIs[0] policy
     /* 1817593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817603 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1817606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817627 */     // GIR_Coverage, 19564,
     /* 1817627 */     GIR_EraseRootFromParent_Done,
     /* 1817628 */   // Label 24527: @1817628
     /* 1817628 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1817714), // Rule ID 19565 //
     /* 1817633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1817636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1817644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1817647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1817650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1817653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1817675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817679 */     // MIs[0] policy
     /* 1817679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817689 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1817692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817713 */     // GIR_Coverage, 19565,
     /* 1817713 */     GIR_EraseRootFromParent_Done,
     /* 1817714 */   // Label 24528: @1817714
     /* 1817714 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1817800), // Rule ID 19568 //
     /* 1817719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1817722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1817730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1817733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1817736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1817739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1817761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817765 */     // MIs[0] policy
     /* 1817765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817775 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1817778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817799 */     // GIR_Coverage, 19568,
     /* 1817799 */     GIR_EraseRootFromParent_Done,
     /* 1817800 */   // Label 24529: @1817800
     /* 1817800 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1817886), // Rule ID 19569 //
     /* 1817805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1817808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1817816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1817819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1817822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1817825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1817847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817851 */     // MIs[0] policy
     /* 1817851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817861 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1817864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817885 */     // GIR_Coverage, 19569,
     /* 1817885 */     GIR_EraseRootFromParent_Done,
     /* 1817886 */   // Label 24530: @1817886
     /* 1817886 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1817972), // Rule ID 19572 //
     /* 1817891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1817894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1817908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1817933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817937 */     // MIs[0] policy
     /* 1817937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817947 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1817950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817971 */     // GIR_Coverage, 19572,
     /* 1817971 */     GIR_EraseRootFromParent_Done,
     /* 1817972 */   // Label 24531: @1817972
     /* 1817972 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1818058), // Rule ID 19573 //
     /* 1817977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1817980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1817985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1817994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1818019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818023 */     // MIs[0] policy
     /* 1818023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1818036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818057 */     // GIR_Coverage, 19573,
     /* 1818057 */     GIR_EraseRootFromParent_Done,
     /* 1818058 */   // Label 24532: @1818058
     /* 1818058 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1818144), // Rule ID 19576 //
     /* 1818063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1818066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1818074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1818077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1818080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818109 */     // MIs[0] policy
     /* 1818109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818119 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1818122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818143 */     // GIR_Coverage, 19576,
     /* 1818143 */     GIR_EraseRootFromParent_Done,
     /* 1818144 */   // Label 24533: @1818144
     /* 1818144 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1818230), // Rule ID 19577 //
     /* 1818149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1818152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1818160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1818163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1818166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818195 */     // MIs[0] policy
     /* 1818195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818205 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10961:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1818208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818229 */     // GIR_Coverage, 19577,
     /* 1818229 */     GIR_EraseRootFromParent_Done,
     /* 1818230 */   // Label 24534: @1818230
     /* 1818230 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1818316), // Rule ID 19580 //
     /* 1818235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1818238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1818246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1818249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1818252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1818277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818281 */     // MIs[0] policy
     /* 1818281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818291 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1818294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818315 */     // GIR_Coverage, 19580,
     /* 1818315 */     GIR_EraseRootFromParent_Done,
     /* 1818316 */   // Label 24535: @1818316
     /* 1818316 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1818402), // Rule ID 19581 //
     /* 1818321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1818324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1818332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1818335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1818338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1818363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818367 */     // MIs[0] policy
     /* 1818367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10961:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1818380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818401 */     // GIR_Coverage, 19581,
     /* 1818401 */     GIR_EraseRootFromParent_Done,
     /* 1818402 */   // Label 24536: @1818402
     /* 1818402 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1818488), // Rule ID 19584 //
     /* 1818407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1818410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1818424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1818449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818453 */     // MIs[0] policy
     /* 1818453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818463 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1818466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818487 */     // GIR_Coverage, 19584,
     /* 1818487 */     GIR_EraseRootFromParent_Done,
     /* 1818488 */   // Label 24537: @1818488
     /* 1818488 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1818574), // Rule ID 19585 //
     /* 1818493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1818496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1818510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1818535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818539 */     // MIs[0] policy
     /* 1818539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818549 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10961:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1818552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818573 */     // GIR_Coverage, 19585,
     /* 1818573 */     GIR_EraseRootFromParent_Done,
     /* 1818574 */   // Label 24538: @1818574
     /* 1818574 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1818660), // Rule ID 19588 //
     /* 1818579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1818582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1818590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1818593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818625 */     // MIs[0] policy
     /* 1818625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818635 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1818638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818659 */     // GIR_Coverage, 19588,
     /* 1818659 */     GIR_EraseRootFromParent_Done,
     /* 1818660 */   // Label 24539: @1818660
     /* 1818660 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1818746), // Rule ID 19589 //
     /* 1818665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1818668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1818676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1818679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818711 */     // MIs[0] policy
     /* 1818711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818721 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1818724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818745 */     // GIR_Coverage, 19589,
     /* 1818745 */     GIR_EraseRootFromParent_Done,
     /* 1818746 */   // Label 24540: @1818746
     /* 1818746 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1818832), // Rule ID 19592 //
     /* 1818751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1818754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818797 */     // MIs[0] policy
     /* 1818797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818807 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1818810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818831 */     // GIR_Coverage, 19592,
     /* 1818831 */     GIR_EraseRootFromParent_Done,
     /* 1818832 */   // Label 24541: @1818832
     /* 1818832 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1818918), // Rule ID 19593 //
     /* 1818837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1818840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818883 */     // MIs[0] policy
     /* 1818883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818893 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1818896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818917 */     // GIR_Coverage, 19593,
     /* 1818917 */     GIR_EraseRootFromParent_Done,
     /* 1818918 */   // Label 24542: @1818918
     /* 1818918 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1819004), // Rule ID 19596 //
     /* 1818923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1818926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1818931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1818943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1818965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818969 */     // MIs[0] policy
     /* 1818969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818979 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1818982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819003 */     // GIR_Coverage, 19596,
     /* 1819003 */     GIR_EraseRootFromParent_Done,
     /* 1819004 */   // Label 24543: @1819004
     /* 1819004 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1819090), // Rule ID 19597 //
     /* 1819009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1819012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1819020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1819023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1819026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1819029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1819032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1819051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819055 */     // MIs[0] policy
     /* 1819055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819065 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1819068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819089 */     // GIR_Coverage, 19597,
     /* 1819089 */     GIR_EraseRootFromParent_Done,
     /* 1819090 */   // Label 24544: @1819090
     /* 1819090 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1819176), // Rule ID 19600 //
     /* 1819095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1819098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1819106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1819109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1819112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819141 */     // MIs[0] policy
     /* 1819141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1819154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819175 */     // GIR_Coverage, 19600,
     /* 1819175 */     GIR_EraseRootFromParent_Done,
     /* 1819176 */   // Label 24545: @1819176
     /* 1819176 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1819262), // Rule ID 19601 //
     /* 1819181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1819184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1819192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1819195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1819198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819227 */     // MIs[0] policy
     /* 1819227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819237 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1819240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819261 */     // GIR_Coverage, 19601,
     /* 1819261 */     GIR_EraseRootFromParent_Done,
     /* 1819262 */   // Label 24546: @1819262
     /* 1819262 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1819348), // Rule ID 19604 //
     /* 1819267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1819270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1819284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819313 */     // MIs[0] policy
     /* 1819313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819323 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1819326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819347 */     // GIR_Coverage, 19604,
     /* 1819347 */     GIR_EraseRootFromParent_Done,
     /* 1819348 */   // Label 24547: @1819348
     /* 1819348 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1819434), // Rule ID 19605 //
     /* 1819353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1819356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1819370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819399 */     // MIs[0] policy
     /* 1819399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819409 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1819412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819433 */     // GIR_Coverage, 19605,
     /* 1819433 */     GIR_EraseRootFromParent_Done,
     /* 1819434 */   // Label 24548: @1819434
     /* 1819434 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1819520), // Rule ID 19608 //
     /* 1819439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1819442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1819456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819485 */     // MIs[0] policy
     /* 1819485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819495 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1819498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819519 */     // GIR_Coverage, 19608,
     /* 1819519 */     GIR_EraseRootFromParent_Done,
     /* 1819520 */   // Label 24549: @1819520
     /* 1819520 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1819606), // Rule ID 19609 //
     /* 1819525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1819528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1819542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1819567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819571 */     // MIs[0] policy
     /* 1819571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819581 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1819584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819605 */     // GIR_Coverage, 19609,
     /* 1819605 */     GIR_EraseRootFromParent_Done,
     /* 1819606 */   // Label 24550: @1819606
     /* 1819606 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1819692), // Rule ID 19612 //
     /* 1819611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1819614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1819622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1819625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1819628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1819653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819657 */     // MIs[0] policy
     /* 1819657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819667 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1819670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819691 */     // GIR_Coverage, 19612,
     /* 1819691 */     GIR_EraseRootFromParent_Done,
     /* 1819692 */   // Label 24551: @1819692
     /* 1819692 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1819778), // Rule ID 19613 //
     /* 1819697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1819700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1819708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1819711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1819714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1819739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819743 */     // MIs[0] policy
     /* 1819743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819753 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10961:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1819756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819777 */     // GIR_Coverage, 19613,
     /* 1819777 */     GIR_EraseRootFromParent_Done,
     /* 1819778 */   // Label 24552: @1819778
     /* 1819778 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1819864), // Rule ID 19616 //
     /* 1819783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1819786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1819825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819829 */     // MIs[0] policy
     /* 1819829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819839 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1819842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819863 */     // GIR_Coverage, 19616,
     /* 1819863 */     GIR_EraseRootFromParent_Done,
     /* 1819864 */   // Label 24553: @1819864
     /* 1819864 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1819950), // Rule ID 19617 //
     /* 1819869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1819872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1819911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819915 */     // MIs[0] policy
     /* 1819915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819925 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10961:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1819928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819949 */     // GIR_Coverage, 19617,
     /* 1819949 */     GIR_EraseRootFromParent_Done,
     /* 1819950 */   // Label 24554: @1819950
     /* 1819950 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1820036), // Rule ID 19620 //
     /* 1819955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1819958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1819963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1819997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820001 */     // MIs[0] policy
     /* 1820001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820011 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1820014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1820018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820035 */     // GIR_Coverage, 19620,
     /* 1820035 */     GIR_EraseRootFromParent_Done,
     /* 1820036 */   // Label 24555: @1820036
     /* 1820036 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1820122), // Rule ID 19621 //
     /* 1820041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1820044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1820049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1820052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1820055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1820058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1820071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1820083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820087 */     // MIs[0] policy
     /* 1820087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820097 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10961:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1820100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1820104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820121 */     // GIR_Coverage, 19621,
     /* 1820121 */     GIR_EraseRootFromParent_Done,
     /* 1820122 */   // Label 24556: @1820122
     /* 1820122 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1820208), // Rule ID 23462 //
     /* 1820127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1820138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1820141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1820144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820173 */     // MIs[0] policy
     /* 1820173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820183 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1820186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820207 */     // GIR_Coverage, 23462,
     /* 1820207 */     GIR_EraseRootFromParent_Done,
     /* 1820208 */   // Label 24557: @1820208
     /* 1820208 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1820294), // Rule ID 23463 //
     /* 1820213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1820224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1820227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1820230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1820233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820259 */     // MIs[0] policy
     /* 1820259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820269 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1820272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820293 */     // GIR_Coverage, 23463,
     /* 1820293 */     GIR_EraseRootFromParent_Done,
     /* 1820294 */   // Label 24558: @1820294
     /* 1820294 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1820380), // Rule ID 23466 //
     /* 1820299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1820316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820345 */     // MIs[0] policy
     /* 1820345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820355 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1820358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820379 */     // GIR_Coverage, 23466,
     /* 1820379 */     GIR_EraseRootFromParent_Done,
     /* 1820380 */   // Label 24559: @1820380
     /* 1820380 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1820466), // Rule ID 23467 //
     /* 1820385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1820402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1820405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820431 */     // MIs[0] policy
     /* 1820431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820441 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1820444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820465 */     // GIR_Coverage, 23467,
     /* 1820465 */     GIR_EraseRootFromParent_Done,
     /* 1820466 */   // Label 24560: @1820466
     /* 1820466 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1820552), // Rule ID 23470 //
     /* 1820471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1820488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820517 */     // MIs[0] policy
     /* 1820517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1820530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820551 */     // GIR_Coverage, 23470,
     /* 1820551 */     GIR_EraseRootFromParent_Done,
     /* 1820552 */   // Label 24561: @1820552
     /* 1820552 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1820638), // Rule ID 23471 //
     /* 1820557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1820574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1820577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820603 */     // MIs[0] policy
     /* 1820603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820613 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1820616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820637 */     // GIR_Coverage, 23471,
     /* 1820637 */     GIR_EraseRootFromParent_Done,
     /* 1820638 */   // Label 24562: @1820638
     /* 1820638 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1820724), // Rule ID 23474 //
     /* 1820643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1820660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820689 */     // MIs[0] policy
     /* 1820689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820699 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1820702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820723 */     // GIR_Coverage, 23474,
     /* 1820723 */     GIR_EraseRootFromParent_Done,
     /* 1820724 */   // Label 24563: @1820724
     /* 1820724 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1820810), // Rule ID 23475 //
     /* 1820729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1820746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1820749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820775 */     // MIs[0] policy
     /* 1820775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1820788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820809 */     // GIR_Coverage, 23475,
     /* 1820809 */     GIR_EraseRootFromParent_Done,
     /* 1820810 */   // Label 24564: @1820810
     /* 1820810 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1820896), // Rule ID 23478 //
     /* 1820815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1820832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1820835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820861 */     // MIs[0] policy
     /* 1820861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1820874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820895 */     // GIR_Coverage, 23478,
     /* 1820895 */     GIR_EraseRootFromParent_Done,
     /* 1820896 */   // Label 24565: @1820896
     /* 1820896 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1820982), // Rule ID 23479 //
     /* 1820901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1820918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1820921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820947 */     // MIs[0] policy
     /* 1820947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1820960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820981 */     // GIR_Coverage, 23479,
     /* 1820981 */     GIR_EraseRootFromParent_Done,
     /* 1820982 */   // Label 24566: @1820982
     /* 1820982 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1821068), // Rule ID 23482 //
     /* 1820987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1820995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1821001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1821004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821033 */     // MIs[0] policy
     /* 1821033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1821046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821067 */     // GIR_Coverage, 23482,
     /* 1821067 */     GIR_EraseRootFromParent_Done,
     /* 1821068 */   // Label 24567: @1821068
     /* 1821068 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1821154), // Rule ID 23483 //
     /* 1821073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1821084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1821087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1821090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821119 */     // MIs[0] policy
     /* 1821119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1821132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821153 */     // GIR_Coverage, 23483,
     /* 1821153 */     GIR_EraseRootFromParent_Done,
     /* 1821154 */   // Label 24568: @1821154
     /* 1821154 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1821240), // Rule ID 23486 //
     /* 1821159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1821170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1821173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1821176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821205 */     // MIs[0] policy
     /* 1821205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821239 */     // GIR_Coverage, 23486,
     /* 1821239 */     GIR_EraseRootFromParent_Done,
     /* 1821240 */   // Label 24569: @1821240
     /* 1821240 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1821326), // Rule ID 23487 //
     /* 1821245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1821256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1821259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1821262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821291 */     // MIs[0] policy
     /* 1821291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821301 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11243:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821325 */     // GIR_Coverage, 23487,
     /* 1821325 */     GIR_EraseRootFromParent_Done,
     /* 1821326 */   // Label 24570: @1821326
     /* 1821326 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1821412), // Rule ID 23490 //
     /* 1821331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1821348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821377 */     // MIs[0] policy
     /* 1821377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821387 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821411 */     // GIR_Coverage, 23490,
     /* 1821411 */     GIR_EraseRootFromParent_Done,
     /* 1821412 */   // Label 24571: @1821412
     /* 1821412 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1821498), // Rule ID 23491 //
     /* 1821417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1821434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821463 */     // MIs[0] policy
     /* 1821463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821473 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821497 */     // GIR_Coverage, 23491,
     /* 1821497 */     GIR_EraseRootFromParent_Done,
     /* 1821498 */   // Label 24572: @1821498
     /* 1821498 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1821584), // Rule ID 23494 //
     /* 1821503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1821520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821549 */     // MIs[0] policy
     /* 1821549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821583 */     // GIR_Coverage, 23494,
     /* 1821583 */     GIR_EraseRootFromParent_Done,
     /* 1821584 */   // Label 24573: @1821584
     /* 1821584 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1821670), // Rule ID 23495 //
     /* 1821589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1821606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821635 */     // MIs[0] policy
     /* 1821635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821669 */     // GIR_Coverage, 23495,
     /* 1821669 */     GIR_EraseRootFromParent_Done,
     /* 1821670 */   // Label 24574: @1821670
     /* 1821670 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1821756), // Rule ID 23498 //
     /* 1821675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1821678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1821692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821721 */     // MIs[0] policy
     /* 1821721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821755 */     // GIR_Coverage, 23498,
     /* 1821755 */     GIR_EraseRootFromParent_Done,
     /* 1821756 */   // Label 24575: @1821756
     /* 1821756 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1821842), // Rule ID 23499 //
     /* 1821761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1821764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1821778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821807 */     // MIs[0] policy
     /* 1821807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821817 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1821820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821841 */     // GIR_Coverage, 23499,
     /* 1821841 */     GIR_EraseRootFromParent_Done,
     /* 1821842 */   // Label 24576: @1821842
     /* 1821842 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1821928), // Rule ID 23502 //
     /* 1821847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1821864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1821867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821893 */     // MIs[0] policy
     /* 1821893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1821906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821927 */     // GIR_Coverage, 23502,
     /* 1821927 */     GIR_EraseRootFromParent_Done,
     /* 1821928 */   // Label 24577: @1821928
     /* 1821928 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1822014), // Rule ID 23503 //
     /* 1821933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1821941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1821950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1821953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821979 */     // MIs[0] policy
     /* 1821979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1821992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822013 */     // GIR_Coverage, 23503,
     /* 1822013 */     GIR_EraseRootFromParent_Done,
     /* 1822014 */   // Label 24578: @1822014
     /* 1822014 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1822100), // Rule ID 23506 //
     /* 1822019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1822030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1822033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1822036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822065 */     // MIs[0] policy
     /* 1822065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822075 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1822078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822099 */     // GIR_Coverage, 23506,
     /* 1822099 */     GIR_EraseRootFromParent_Done,
     /* 1822100 */   // Label 24579: @1822100
     /* 1822100 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1822186), // Rule ID 23507 //
     /* 1822105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1822116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1822119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1822122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822151 */     // MIs[0] policy
     /* 1822151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822161 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1822164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822185 */     // GIR_Coverage, 23507,
     /* 1822185 */     GIR_EraseRootFromParent_Done,
     /* 1822186 */   // Label 24580: @1822186
     /* 1822186 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1822272), // Rule ID 23510 //
     /* 1822191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1822202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1822205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1822208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1822214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822237 */     // MIs[0] policy
     /* 1822237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822247 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1822250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822271 */     // GIR_Coverage, 23510,
     /* 1822271 */     GIR_EraseRootFromParent_Done,
     /* 1822272 */   // Label 24581: @1822272
     /* 1822272 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1822358), // Rule ID 23511 //
     /* 1822277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1822288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1822291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1822294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1822300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822323 */     // MIs[0] policy
     /* 1822323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822333 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1822336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822357 */     // GIR_Coverage, 23511,
     /* 1822357 */     GIR_EraseRootFromParent_Done,
     /* 1822358 */   // Label 24582: @1822358
     /* 1822358 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1822444), // Rule ID 23514 //
     /* 1822363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1822380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822409 */     // MIs[0] policy
     /* 1822409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1822422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822443 */     // GIR_Coverage, 23514,
     /* 1822443 */     GIR_EraseRootFromParent_Done,
     /* 1822444 */   // Label 24583: @1822444
     /* 1822444 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1822530), // Rule ID 23515 //
     /* 1822449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1822466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822495 */     // MIs[0] policy
     /* 1822495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1822508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822529 */     // GIR_Coverage, 23515,
     /* 1822529 */     GIR_EraseRootFromParent_Done,
     /* 1822530 */   // Label 24584: @1822530
     /* 1822530 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1822616), // Rule ID 23518 //
     /* 1822535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1822552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822581 */     // MIs[0] policy
     /* 1822581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822591 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1822594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822615 */     // GIR_Coverage, 23518,
     /* 1822615 */     GIR_EraseRootFromParent_Done,
     /* 1822616 */   // Label 24585: @1822616
     /* 1822616 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1822702), // Rule ID 23519 //
     /* 1822621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1822638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822667 */     // MIs[0] policy
     /* 1822667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822677 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1822680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822701 */     // GIR_Coverage, 23519,
     /* 1822701 */     GIR_EraseRootFromParent_Done,
     /* 1822702 */   // Label 24586: @1822702
     /* 1822702 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1822788), // Rule ID 23522 //
     /* 1822707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1822724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822753 */     // MIs[0] policy
     /* 1822753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822763 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1822766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822787 */     // GIR_Coverage, 23522,
     /* 1822787 */     GIR_EraseRootFromParent_Done,
     /* 1822788 */   // Label 24587: @1822788
     /* 1822788 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1822874), // Rule ID 23523 //
     /* 1822793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1822810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822839 */     // MIs[0] policy
     /* 1822839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822849 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1822852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822873 */     // GIR_Coverage, 23523,
     /* 1822873 */     GIR_EraseRootFromParent_Done,
     /* 1822874 */   // Label 24588: @1822874
     /* 1822874 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1822960), // Rule ID 23526 //
     /* 1822879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1822896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1822899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822925 */     // MIs[0] policy
     /* 1822925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1822938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822959 */     // GIR_Coverage, 23526,
     /* 1822959 */     GIR_EraseRootFromParent_Done,
     /* 1822960 */   // Label 24589: @1822960
     /* 1822960 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1823046), // Rule ID 23527 //
     /* 1822965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1822973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1822982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1822985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823011 */     // MIs[0] policy
     /* 1823011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1823024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823045 */     // GIR_Coverage, 23527,
     /* 1823045 */     GIR_EraseRootFromParent_Done,
     /* 1823046 */   // Label 24590: @1823046
     /* 1823046 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1823132), // Rule ID 23530 //
     /* 1823051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1823062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1823065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1823068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823097 */     // MIs[0] policy
     /* 1823097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1823110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823131 */     // GIR_Coverage, 23530,
     /* 1823131 */     GIR_EraseRootFromParent_Done,
     /* 1823132 */   // Label 24591: @1823132
     /* 1823132 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1823218), // Rule ID 23531 //
     /* 1823137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1823148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1823151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1823154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1823157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823183 */     // MIs[0] policy
     /* 1823183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1823196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823217 */     // GIR_Coverage, 23531,
     /* 1823217 */     GIR_EraseRootFromParent_Done,
     /* 1823218 */   // Label 24592: @1823218
     /* 1823218 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1823304), // Rule ID 23534 //
     /* 1823223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1823240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823269 */     // MIs[0] policy
     /* 1823269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1823282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823303 */     // GIR_Coverage, 23534,
     /* 1823303 */     GIR_EraseRootFromParent_Done,
     /* 1823304 */   // Label 24593: @1823304
     /* 1823304 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1823390), // Rule ID 23535 //
     /* 1823309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1823326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1823329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823355 */     // MIs[0] policy
     /* 1823355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823365 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1823368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823389 */     // GIR_Coverage, 23535,
     /* 1823389 */     GIR_EraseRootFromParent_Done,
     /* 1823390 */   // Label 24594: @1823390
     /* 1823390 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1823476), // Rule ID 23538 //
     /* 1823395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1823412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823441 */     // MIs[0] policy
     /* 1823441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1823454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823475 */     // GIR_Coverage, 23538,
     /* 1823475 */     GIR_EraseRootFromParent_Done,
     /* 1823476 */   // Label 24595: @1823476
     /* 1823476 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1823562), // Rule ID 23539 //
     /* 1823481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1823498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1823501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823527 */     // MIs[0] policy
     /* 1823527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1823540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823561 */     // GIR_Coverage, 23539,
     /* 1823561 */     GIR_EraseRootFromParent_Done,
     /* 1823562 */   // Label 24596: @1823562
     /* 1823562 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1823648), // Rule ID 23542 //
     /* 1823567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1823578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1823581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1823584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823613 */     // MIs[0] policy
     /* 1823613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823623 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1823626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823647 */     // GIR_Coverage, 23542,
     /* 1823647 */     GIR_EraseRootFromParent_Done,
     /* 1823648 */   // Label 24597: @1823648
     /* 1823648 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1823734), // Rule ID 23543 //
     /* 1823653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1823664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1823667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1823670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1823673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823699 */     // MIs[0] policy
     /* 1823699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823709 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1823712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823733 */     // GIR_Coverage, 23543,
     /* 1823733 */     GIR_EraseRootFromParent_Done,
     /* 1823734 */   // Label 24598: @1823734
     /* 1823734 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1823820), // Rule ID 23546 //
     /* 1823739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1823756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823785 */     // MIs[0] policy
     /* 1823785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823795 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1823798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823819 */     // GIR_Coverage, 23546,
     /* 1823819 */     GIR_EraseRootFromParent_Done,
     /* 1823820 */   // Label 24599: @1823820
     /* 1823820 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1823906), // Rule ID 23547 //
     /* 1823825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1823833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1823842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1823845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823871 */     // MIs[0] policy
     /* 1823871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1823884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823905 */     // GIR_Coverage, 23547,
     /* 1823905 */     GIR_EraseRootFromParent_Done,
     /* 1823906 */   // Label 24600: @1823906
     /* 1823906 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1823992), // Rule ID 23638 //
     /* 1823911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1823919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1823931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823957 */     // MIs[0] policy
     /* 1823957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823967 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1823970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823991 */     // GIR_Coverage, 23638,
     /* 1823991 */     GIR_EraseRootFromParent_Done,
     /* 1823992 */   // Label 24601: @1823992
     /* 1823992 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1824078), // Rule ID 23639 //
     /* 1823997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1824008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1824011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1824014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824043 */     // MIs[0] policy
     /* 1824043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824053 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1824056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824077 */     // GIR_Coverage, 23639,
     /* 1824077 */     GIR_EraseRootFromParent_Done,
     /* 1824078 */   // Label 24602: @1824078
     /* 1824078 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1824164), // Rule ID 23642 //
     /* 1824083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1824094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1824097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1824100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824129 */     // MIs[0] policy
     /* 1824129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1824142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824163 */     // GIR_Coverage, 23642,
     /* 1824163 */     GIR_EraseRootFromParent_Done,
     /* 1824164 */   // Label 24603: @1824164
     /* 1824164 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1824250), // Rule ID 23643 //
     /* 1824169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1824180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1824183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1824186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824215 */     // MIs[0] policy
     /* 1824215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824225 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1824228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824249 */     // GIR_Coverage, 23643,
     /* 1824249 */     GIR_EraseRootFromParent_Done,
     /* 1824250 */   // Label 24604: @1824250
     /* 1824250 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1824336), // Rule ID 23646 //
     /* 1824255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1824272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824301 */     // MIs[0] policy
     /* 1824301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824311 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824335 */     // GIR_Coverage, 23646,
     /* 1824335 */     GIR_EraseRootFromParent_Done,
     /* 1824336 */   // Label 24605: @1824336
     /* 1824336 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1824422), // Rule ID 23647 //
     /* 1824341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1824358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824387 */     // MIs[0] policy
     /* 1824387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824397 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824421 */     // GIR_Coverage, 23647,
     /* 1824421 */     GIR_EraseRootFromParent_Done,
     /* 1824422 */   // Label 24606: @1824422
     /* 1824422 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1824508), // Rule ID 23650 //
     /* 1824427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1824444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824473 */     // MIs[0] policy
     /* 1824473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824483 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1824486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824507 */     // GIR_Coverage, 23650,
     /* 1824507 */     GIR_EraseRootFromParent_Done,
     /* 1824508 */   // Label 24607: @1824508
     /* 1824508 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1824594), // Rule ID 23651 //
     /* 1824513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1824530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824559 */     // MIs[0] policy
     /* 1824559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1824572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824593 */     // GIR_Coverage, 23651,
     /* 1824593 */     GIR_EraseRootFromParent_Done,
     /* 1824594 */   // Label 24608: @1824594
     /* 1824594 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1824680), // Rule ID 23654 //
     /* 1824599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1824610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1824613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1824616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824645 */     // MIs[0] policy
     /* 1824645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824679 */     // GIR_Coverage, 23654,
     /* 1824679 */     GIR_EraseRootFromParent_Done,
     /* 1824680 */   // Label 24609: @1824680
     /* 1824680 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1824766), // Rule ID 23655 //
     /* 1824685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1824696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1824699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1824702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824731 */     // MIs[0] policy
     /* 1824731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824765 */     // GIR_Coverage, 23655,
     /* 1824765 */     GIR_EraseRootFromParent_Done,
     /* 1824766 */   // Label 24610: @1824766
     /* 1824766 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1824852), // Rule ID 23658 //
     /* 1824771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824817 */     // MIs[0] policy
     /* 1824817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824851 */     // GIR_Coverage, 23658,
     /* 1824851 */     GIR_EraseRootFromParent_Done,
     /* 1824852 */   // Label 24611: @1824852
     /* 1824852 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1824938), // Rule ID 23659 //
     /* 1824857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1824877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824903 */     // MIs[0] policy
     /* 1824903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824913 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1824916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824937 */     // GIR_Coverage, 23659,
     /* 1824937 */     GIR_EraseRootFromParent_Done,
     /* 1824938 */   // Label 24612: @1824938
     /* 1824938 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1825024), // Rule ID 23662 //
     /* 1824943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1824951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1824963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824989 */     // MIs[0] policy
     /* 1824989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825023 */     // GIR_Coverage, 23662,
     /* 1825023 */     GIR_EraseRootFromParent_Done,
     /* 1825024 */   // Label 24613: @1825024
     /* 1825024 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1825110), // Rule ID 23663 //
     /* 1825029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1825040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1825043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1825046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825075 */     // MIs[0] policy
     /* 1825075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825085 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11241:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825109 */     // GIR_Coverage, 23663,
     /* 1825109 */     GIR_EraseRootFromParent_Done,
     /* 1825110 */   // Label 24614: @1825110
     /* 1825110 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1825196), // Rule ID 23666 //
     /* 1825115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1825126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1825129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1825132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825161 */     // MIs[0] policy
     /* 1825161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825171 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825195 */     // GIR_Coverage, 23666,
     /* 1825195 */     GIR_EraseRootFromParent_Done,
     /* 1825196 */   // Label 24615: @1825196
     /* 1825196 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1825282), // Rule ID 23667 //
     /* 1825201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1825212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1825215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1825218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825247 */     // MIs[0] policy
     /* 1825247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825281 */     // GIR_Coverage, 23667,
     /* 1825281 */     GIR_EraseRootFromParent_Done,
     /* 1825282 */   // Label 24616: @1825282
     /* 1825282 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1825368), // Rule ID 23670 //
     /* 1825287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1825304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825333 */     // MIs[0] policy
     /* 1825333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825367 */     // GIR_Coverage, 23670,
     /* 1825367 */     GIR_EraseRootFromParent_Done,
     /* 1825368 */   // Label 24617: @1825368
     /* 1825368 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1825454), // Rule ID 23671 //
     /* 1825373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1825390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825419 */     // MIs[0] policy
     /* 1825419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825453 */     // GIR_Coverage, 23671,
     /* 1825453 */     GIR_EraseRootFromParent_Done,
     /* 1825454 */   // Label 24618: @1825454
     /* 1825454 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1825540), // Rule ID 23674 //
     /* 1825459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1825462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1825476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825505 */     // MIs[0] policy
     /* 1825505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825539 */     // GIR_Coverage, 23674,
     /* 1825539 */     GIR_EraseRootFromParent_Done,
     /* 1825540 */   // Label 24619: @1825540
     /* 1825540 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1825626), // Rule ID 23675 //
     /* 1825545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1825548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1825562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825591 */     // MIs[0] policy
     /* 1825591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825601 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1825604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825625 */     // GIR_Coverage, 23675,
     /* 1825625 */     GIR_EraseRootFromParent_Done,
     /* 1825626 */   // Label 24620: @1825626
     /* 1825626 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1825712), // Rule ID 23678 //
     /* 1825631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1825642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1825648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825677 */     // MIs[0] policy
     /* 1825677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825687 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1825690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825711 */     // GIR_Coverage, 23678,
     /* 1825711 */     GIR_EraseRootFromParent_Done,
     /* 1825712 */   // Label 24621: @1825712
     /* 1825712 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1825798), // Rule ID 23679 //
     /* 1825717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1825728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1825734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825763 */     // MIs[0] policy
     /* 1825763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1825776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825797 */     // GIR_Coverage, 23679,
     /* 1825797 */     GIR_EraseRootFromParent_Done,
     /* 1825798 */   // Label 24622: @1825798
     /* 1825798 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1825884), // Rule ID 23682 //
     /* 1825803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825849 */     // MIs[0] policy
     /* 1825849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825859 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1825862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825883 */     // GIR_Coverage, 23682,
     /* 1825883 */     GIR_EraseRootFromParent_Done,
     /* 1825884 */   // Label 24623: @1825884
     /* 1825884 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1825970), // Rule ID 23683 //
     /* 1825889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1825909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825935 */     // MIs[0] policy
     /* 1825935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825945 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1825948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825969 */     // GIR_Coverage, 23683,
     /* 1825969 */     GIR_EraseRootFromParent_Done,
     /* 1825970 */   // Label 24624: @1825970
     /* 1825970 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1826056), // Rule ID 23686 //
     /* 1825975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1825983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1825995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826021 */     // MIs[0] policy
     /* 1826021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826031 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1826034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826055 */     // GIR_Coverage, 23686,
     /* 1826055 */     GIR_EraseRootFromParent_Done,
     /* 1826056 */   // Label 24625: @1826056
     /* 1826056 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1826142), // Rule ID 23687 //
     /* 1826061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1826072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1826075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1826078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1826084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826107 */     // MIs[0] policy
     /* 1826107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826117 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1826120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826141 */     // GIR_Coverage, 23687,
     /* 1826141 */     GIR_EraseRootFromParent_Done,
     /* 1826142 */   // Label 24626: @1826142
     /* 1826142 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1826228), // Rule ID 23690 //
     /* 1826147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1826158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1826161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1826164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1826167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826193 */     // MIs[0] policy
     /* 1826193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826203 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1826206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826227 */     // GIR_Coverage, 23690,
     /* 1826227 */     GIR_EraseRootFromParent_Done,
     /* 1826228 */   // Label 24627: @1826228
     /* 1826228 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1826314), // Rule ID 23691 //
     /* 1826233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1826244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1826247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1826250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826279 */     // MIs[0] policy
     /* 1826279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1826292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826313 */     // GIR_Coverage, 23691,
     /* 1826313 */     GIR_EraseRootFromParent_Done,
     /* 1826314 */   // Label 24628: @1826314
     /* 1826314 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1826400), // Rule ID 23694 //
     /* 1826319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1826336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1826339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826365 */     // MIs[0] policy
     /* 1826365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826375 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1826378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826399 */     // GIR_Coverage, 23694,
     /* 1826399 */     GIR_EraseRootFromParent_Done,
     /* 1826400 */   // Label 24629: @1826400
     /* 1826400 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1826486), // Rule ID 23695 //
     /* 1826405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1826422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826451 */     // MIs[0] policy
     /* 1826451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826461 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1826464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826485 */     // GIR_Coverage, 23695,
     /* 1826485 */     GIR_EraseRootFromParent_Done,
     /* 1826486 */   // Label 24630: @1826486
     /* 1826486 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1826572), // Rule ID 23698 //
     /* 1826491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1826508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1826511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826537 */     // MIs[0] policy
     /* 1826537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826547 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1826550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826571 */     // GIR_Coverage, 23698,
     /* 1826571 */     GIR_EraseRootFromParent_Done,
     /* 1826572 */   // Label 24631: @1826572
     /* 1826572 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1826658), // Rule ID 23699 //
     /* 1826577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1826594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826623 */     // MIs[0] policy
     /* 1826623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826633 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1826636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826657 */     // GIR_Coverage, 23699,
     /* 1826657 */     GIR_EraseRootFromParent_Done,
     /* 1826658 */   // Label 24632: @1826658
     /* 1826658 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1826744), // Rule ID 23702 //
     /* 1826663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1826683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826709 */     // MIs[0] policy
     /* 1826709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1826722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826743 */     // GIR_Coverage, 23702,
     /* 1826743 */     GIR_EraseRootFromParent_Done,
     /* 1826744 */   // Label 24633: @1826744
     /* 1826744 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1826830), // Rule ID 23703 //
     /* 1826749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826795 */     // MIs[0] policy
     /* 1826795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1826808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826829 */     // GIR_Coverage, 23703,
     /* 1826829 */     GIR_EraseRootFromParent_Done,
     /* 1826830 */   // Label 24634: @1826830
     /* 1826830 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1826916), // Rule ID 23706 //
     /* 1826835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1826855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826881 */     // MIs[0] policy
     /* 1826881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1826894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826915 */     // GIR_Coverage, 23706,
     /* 1826915 */     GIR_EraseRootFromParent_Done,
     /* 1826916 */   // Label 24635: @1826916
     /* 1826916 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1827002), // Rule ID 23707 //
     /* 1826921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1826929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1826941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826967 */     // MIs[0] policy
     /* 1826967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1826980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827001 */     // GIR_Coverage, 23707,
     /* 1827001 */     GIR_EraseRootFromParent_Done,
     /* 1827002 */   // Label 24636: @1827002
     /* 1827002 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1827088), // Rule ID 23710 //
     /* 1827007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1827018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1827021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1827024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1827030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827053 */     // MIs[0] policy
     /* 1827053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827063 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1827066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827087 */     // GIR_Coverage, 23710,
     /* 1827087 */     GIR_EraseRootFromParent_Done,
     /* 1827088 */   // Label 24637: @1827088
     /* 1827088 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1827174), // Rule ID 23711 //
     /* 1827093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1827104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1827107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1827110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1827116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827139 */     // MIs[0] policy
     /* 1827139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827149 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1827152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827173 */     // GIR_Coverage, 23711,
     /* 1827173 */     GIR_EraseRootFromParent_Done,
     /* 1827174 */   // Label 24638: @1827174
     /* 1827174 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1827260), // Rule ID 23714 //
     /* 1827179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1827190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1827193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1827196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827225 */     // MIs[0] policy
     /* 1827225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1827238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827259 */     // GIR_Coverage, 23714,
     /* 1827259 */     GIR_EraseRootFromParent_Done,
     /* 1827260 */   // Label 24639: @1827260
     /* 1827260 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1827346), // Rule ID 23715 //
     /* 1827265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1827276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1827279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1827282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827311 */     // MIs[0] policy
     /* 1827311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1827324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827345 */     // GIR_Coverage, 23715,
     /* 1827345 */     GIR_EraseRootFromParent_Done,
     /* 1827346 */   // Label 24640: @1827346
     /* 1827346 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1827432), // Rule ID 23718 //
     /* 1827351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1827368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827397 */     // MIs[0] policy
     /* 1827397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827407 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1827410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827431 */     // GIR_Coverage, 23718,
     /* 1827431 */     GIR_EraseRootFromParent_Done,
     /* 1827432 */   // Label 24641: @1827432
     /* 1827432 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1827518), // Rule ID 23719 //
     /* 1827437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1827454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827483 */     // MIs[0] policy
     /* 1827483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1827496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827517 */     // GIR_Coverage, 23719,
     /* 1827517 */     GIR_EraseRootFromParent_Done,
     /* 1827518 */   // Label 24642: @1827518
     /* 1827518 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1827604), // Rule ID 23722 //
     /* 1827523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1827540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827569 */     // MIs[0] policy
     /* 1827569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827579 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1827582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827603 */     // GIR_Coverage, 23722,
     /* 1827603 */     GIR_EraseRootFromParent_Done,
     /* 1827604 */   // Label 24643: @1827604
     /* 1827604 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1827690), // Rule ID 23723 //
     /* 1827609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1827617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1827626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827655 */     // MIs[0] policy
     /* 1827655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827665 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1827668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827689 */     // GIR_Coverage, 23723,
     /* 1827689 */     GIR_EraseRootFromParent_Done,
     /* 1827690 */   // Label 24644: @1827690
     /* 1827690 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1827776), // Rule ID 23814 //
     /* 1827695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1827703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1827712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827741 */     // MIs[0] policy
     /* 1827741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827751 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1827754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1827758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827775 */     // GIR_Coverage, 23814,
     /* 1827775 */     GIR_EraseRootFromParent_Done,
     /* 1827776 */   // Label 24645: @1827776
     /* 1827776 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1827862), // Rule ID 23815 //
     /* 1827781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1827789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1827798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827827 */     // MIs[0] policy
     /* 1827827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827837 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1827840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1827844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827861 */     // GIR_Coverage, 23815,
     /* 1827861 */     GIR_EraseRootFromParent_Done,
     /* 1827862 */   // Label 24646: @1827862
     /* 1827862 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1827948), // Rule ID 23818 //
     /* 1827867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1827875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1827884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1827887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827913 */     // MIs[0] policy
     /* 1827913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827923 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1827926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1827930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827947 */     // GIR_Coverage, 23818,
     /* 1827947 */     GIR_EraseRootFromParent_Done,
     /* 1827948 */   // Label 24647: @1827948
     /* 1827948 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1828034), // Rule ID 23819 //
     /* 1827953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1827961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1827970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1827973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827999 */     // MIs[0] policy
     /* 1827999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1828012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828033 */     // GIR_Coverage, 23819,
     /* 1828033 */     GIR_EraseRootFromParent_Done,
     /* 1828034 */   // Label 24648: @1828034
     /* 1828034 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1828120), // Rule ID 23822 //
     /* 1828039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1828050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1828053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1828056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828085 */     // MIs[0] policy
     /* 1828085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828095 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828119 */     // GIR_Coverage, 23822,
     /* 1828119 */     GIR_EraseRootFromParent_Done,
     /* 1828120 */   // Label 24649: @1828120
     /* 1828120 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1828206), // Rule ID 23823 //
     /* 1828125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1828136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1828139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1828142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1828145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828171 */     // MIs[0] policy
     /* 1828171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828181 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828205 */     // GIR_Coverage, 23823,
     /* 1828205 */     GIR_EraseRootFromParent_Done,
     /* 1828206 */   // Label 24650: @1828206
     /* 1828206 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1828292), // Rule ID 23826 //
     /* 1828211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1828222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1828228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828257 */     // MIs[0] policy
     /* 1828257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828267 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1828270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828291 */     // GIR_Coverage, 23826,
     /* 1828291 */     GIR_EraseRootFromParent_Done,
     /* 1828292 */   // Label 24651: @1828292
     /* 1828292 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1828378), // Rule ID 23827 //
     /* 1828297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1828308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1828314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1828317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828343 */     // MIs[0] policy
     /* 1828343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828353 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1828356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828377 */     // GIR_Coverage, 23827,
     /* 1828377 */     GIR_EraseRootFromParent_Done,
     /* 1828378 */   // Label 24652: @1828378
     /* 1828378 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1828464), // Rule ID 23830 //
     /* 1828383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1828400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828429 */     // MIs[0] policy
     /* 1828429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828439 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828463 */     // GIR_Coverage, 23830,
     /* 1828463 */     GIR_EraseRootFromParent_Done,
     /* 1828464 */   // Label 24653: @1828464
     /* 1828464 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1828550), // Rule ID 23831 //
     /* 1828469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1828486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1828489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828515 */     // MIs[0] policy
     /* 1828515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828525 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828549 */     // GIR_Coverage, 23831,
     /* 1828549 */     GIR_EraseRootFromParent_Done,
     /* 1828550 */   // Label 24654: @1828550
     /* 1828550 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1828636), // Rule ID 23834 //
     /* 1828555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1828569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1828572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828601 */     // MIs[0] policy
     /* 1828601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828611 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828635 */     // GIR_Coverage, 23834,
     /* 1828635 */     GIR_EraseRootFromParent_Done,
     /* 1828636 */   // Label 24655: @1828636
     /* 1828636 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1828722), // Rule ID 23835 //
     /* 1828641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1828655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1828658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1828661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828687 */     // MIs[0] policy
     /* 1828687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828697 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1828700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828721 */     // GIR_Coverage, 23835,
     /* 1828721 */     GIR_EraseRootFromParent_Done,
     /* 1828722 */   // Label 24656: @1828722
     /* 1828722 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1828808), // Rule ID 23838 //
     /* 1828727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1828744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828773 */     // MIs[0] policy
     /* 1828773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828783 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1828786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828807 */     // GIR_Coverage, 23838,
     /* 1828807 */     GIR_EraseRootFromParent_Done,
     /* 1828808 */   // Label 24657: @1828808
     /* 1828808 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1828894), // Rule ID 23839 //
     /* 1828813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1828830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1828833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828859 */     // MIs[0] policy
     /* 1828859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828869 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1828872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828893 */     // GIR_Coverage, 23839,
     /* 1828893 */     GIR_EraseRootFromParent_Done,
     /* 1828894 */   // Label 24658: @1828894
     /* 1828894 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1828980), // Rule ID 23842 //
     /* 1828899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1828916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1828919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828945 */     // MIs[0] policy
     /* 1828945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1828958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1828962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828979 */     // GIR_Coverage, 23842,
     /* 1828979 */     GIR_EraseRootFromParent_Done,
     /* 1828980 */   // Label 24659: @1828980
     /* 1828980 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1829066), // Rule ID 23843 //
     /* 1828985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1828993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1829002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829031 */     // MIs[0] policy
     /* 1829031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829041 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1829044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829065 */     // GIR_Coverage, 23843,
     /* 1829065 */     GIR_EraseRootFromParent_Done,
     /* 1829066 */   // Label 24660: @1829066
     /* 1829066 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1829152), // Rule ID 23846 //
     /* 1829071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1829082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1829085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1829088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829117 */     // MIs[0] policy
     /* 1829117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1829130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829151 */     // GIR_Coverage, 23846,
     /* 1829151 */     GIR_EraseRootFromParent_Done,
     /* 1829152 */   // Label 24661: @1829152
     /* 1829152 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1829238), // Rule ID 23847 //
     /* 1829157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1829168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1829171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1829174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829203 */     // MIs[0] policy
     /* 1829203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1829216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829237 */     // GIR_Coverage, 23847,
     /* 1829237 */     GIR_EraseRootFromParent_Done,
     /* 1829238 */   // Label 24662: @1829238
     /* 1829238 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1829324), // Rule ID 23850 //
     /* 1829243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1829260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829289 */     // MIs[0] policy
     /* 1829289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1829302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829323 */     // GIR_Coverage, 23850,
     /* 1829323 */     GIR_EraseRootFromParent_Done,
     /* 1829324 */   // Label 24663: @1829324
     /* 1829324 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1829410), // Rule ID 23851 //
     /* 1829329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1829346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829375 */     // MIs[0] policy
     /* 1829375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829385 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1829388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829409 */     // GIR_Coverage, 23851,
     /* 1829409 */     GIR_EraseRootFromParent_Done,
     /* 1829410 */   // Label 24664: @1829410
     /* 1829410 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1829496), // Rule ID 23854 //
     /* 1829415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1829432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829461 */     // MIs[0] policy
     /* 1829461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1829474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829495 */     // GIR_Coverage, 23854,
     /* 1829495 */     GIR_EraseRootFromParent_Done,
     /* 1829496 */   // Label 24665: @1829496
     /* 1829496 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1829582), // Rule ID 23855 //
     /* 1829501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1829518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829547 */     // MIs[0] policy
     /* 1829547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829557 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1829560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829581 */     // GIR_Coverage, 23855,
     /* 1829581 */     GIR_EraseRootFromParent_Done,
     /* 1829582 */   // Label 24666: @1829582
     /* 1829582 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1829668), // Rule ID 23858 //
     /* 1829587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1829598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1829601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1829604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829633 */     // MIs[0] policy
     /* 1829633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1829646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829667 */     // GIR_Coverage, 23858,
     /* 1829667 */     GIR_EraseRootFromParent_Done,
     /* 1829668 */   // Label 24667: @1829668
     /* 1829668 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1829754), // Rule ID 23859 //
     /* 1829673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1829684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1829687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1829690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829719 */     // MIs[0] policy
     /* 1829719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829729 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1829732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829753 */     // GIR_Coverage, 23859,
     /* 1829753 */     GIR_EraseRootFromParent_Done,
     /* 1829754 */   // Label 24668: @1829754
     /* 1829754 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1829840), // Rule ID 23862 //
     /* 1829759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1829776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829805 */     // MIs[0] policy
     /* 1829805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829815 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1829818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829839 */     // GIR_Coverage, 23862,
     /* 1829839 */     GIR_EraseRootFromParent_Done,
     /* 1829840 */   // Label 24669: @1829840
     /* 1829840 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1829926), // Rule ID 23863 //
     /* 1829845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1829862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1829865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829891 */     // MIs[0] policy
     /* 1829891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829901 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1829904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829925 */     // GIR_Coverage, 23863,
     /* 1829925 */     GIR_EraseRootFromParent_Done,
     /* 1829926 */   // Label 24670: @1829926
     /* 1829926 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1830012), // Rule ID 23866 //
     /* 1829931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1829939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1829948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1829951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829977 */     // MIs[0] policy
     /* 1829977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1829990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1829994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830011 */     // GIR_Coverage, 23866,
     /* 1830011 */     GIR_EraseRootFromParent_Done,
     /* 1830012 */   // Label 24671: @1830012
     /* 1830012 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1830098), // Rule ID 23867 //
     /* 1830017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1830028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1830031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1830034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830063 */     // MIs[0] policy
     /* 1830063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1830076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830097 */     // GIR_Coverage, 23867,
     /* 1830097 */     GIR_EraseRootFromParent_Done,
     /* 1830098 */   // Label 24672: @1830098
     /* 1830098 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1830184), // Rule ID 23870 //
     /* 1830103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1830114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1830117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1830120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830149 */     // MIs[0] policy
     /* 1830149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1830162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830183 */     // GIR_Coverage, 23870,
     /* 1830183 */     GIR_EraseRootFromParent_Done,
     /* 1830184 */   // Label 24673: @1830184
     /* 1830184 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1830270), // Rule ID 23871 //
     /* 1830189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1830200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1830203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1830206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830235 */     // MIs[0] policy
     /* 1830235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1830248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830269 */     // GIR_Coverage, 23871,
     /* 1830269 */     GIR_EraseRootFromParent_Done,
     /* 1830270 */   // Label 24674: @1830270
     /* 1830270 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1830356), // Rule ID 23874 //
     /* 1830275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1830292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830321 */     // MIs[0] policy
     /* 1830321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830331 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1830334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830355 */     // GIR_Coverage, 23874,
     /* 1830355 */     GIR_EraseRootFromParent_Done,
     /* 1830356 */   // Label 24675: @1830356
     /* 1830356 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1830442), // Rule ID 23875 //
     /* 1830361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1830378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830407 */     // MIs[0] policy
     /* 1830407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830417 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1830420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830441 */     // GIR_Coverage, 23875,
     /* 1830441 */     GIR_EraseRootFromParent_Done,
     /* 1830442 */   // Label 24676: @1830442
     /* 1830442 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1830528), // Rule ID 23878 //
     /* 1830447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1830464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830493 */     // MIs[0] policy
     /* 1830493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1830506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830527 */     // GIR_Coverage, 23878,
     /* 1830527 */     GIR_EraseRootFromParent_Done,
     /* 1830528 */   // Label 24677: @1830528
     /* 1830528 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1830614), // Rule ID 23879 //
     /* 1830533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1830550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830579 */     // MIs[0] policy
     /* 1830579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1830592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830613 */     // GIR_Coverage, 23879,
     /* 1830613 */     GIR_EraseRootFromParent_Done,
     /* 1830614 */   // Label 24678: @1830614
     /* 1830614 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1830700), // Rule ID 23882 //
     /* 1830619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1830630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1830633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1830636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830665 */     // MIs[0] policy
     /* 1830665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830675 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1830678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830699 */     // GIR_Coverage, 23882,
     /* 1830699 */     GIR_EraseRootFromParent_Done,
     /* 1830700 */   // Label 24679: @1830700
     /* 1830700 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1830786), // Rule ID 23883 //
     /* 1830705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1830716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1830719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1830722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830751 */     // MIs[0] policy
     /* 1830751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1830764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830785 */     // GIR_Coverage, 23883,
     /* 1830785 */     GIR_EraseRootFromParent_Done,
     /* 1830786 */   // Label 24680: @1830786
     /* 1830786 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1830872), // Rule ID 23886 //
     /* 1830791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1830808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830837 */     // MIs[0] policy
     /* 1830837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830847 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1830850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830871 */     // GIR_Coverage, 23886,
     /* 1830871 */     GIR_EraseRootFromParent_Done,
     /* 1830872 */   // Label 24681: @1830872
     /* 1830872 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1830958), // Rule ID 23887 //
     /* 1830877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1830894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1830897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830923 */     // MIs[0] policy
     /* 1830923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830933 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1830936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1830940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830957 */     // GIR_Coverage, 23887,
     /* 1830957 */     GIR_EraseRootFromParent_Done,
     /* 1830958 */   // Label 24682: @1830958
     /* 1830958 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1831044), // Rule ID 23890 //
     /* 1830963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1830971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1830980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1830983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831009 */     // MIs[0] policy
     /* 1831009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1831022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831043 */     // GIR_Coverage, 23890,
     /* 1831043 */     GIR_EraseRootFromParent_Done,
     /* 1831044 */   // Label 24683: @1831044
     /* 1831044 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1831130), // Rule ID 23891 //
     /* 1831049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1831057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1831060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1831063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1831066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1831079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831095 */     // MIs[0] policy
     /* 1831095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1831108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831129 */     // GIR_Coverage, 23891,
     /* 1831129 */     GIR_EraseRootFromParent_Done,
     /* 1831130 */   // Label 24684: @1831130
     /* 1831130 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1831216), // Rule ID 23894 //
     /* 1831135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1831143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1831146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1831149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1831152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1831155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831181 */     // MIs[0] policy
     /* 1831181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831191 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1831194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831215 */     // GIR_Coverage, 23894,
     /* 1831215 */     GIR_EraseRootFromParent_Done,
     /* 1831216 */   // Label 24685: @1831216
     /* 1831216 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1831302), // Rule ID 23895 //
     /* 1831221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1831229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1831232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1831235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1831238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831267 */     // MIs[0] policy
     /* 1831267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831277 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1831280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831301 */     // GIR_Coverage, 23895,
     /* 1831301 */     GIR_EraseRootFromParent_Done,
     /* 1831302 */   // Label 24686: @1831302
     /* 1831302 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1831388), // Rule ID 23898 //
     /* 1831307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1831315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1831324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1831327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831353 */     // MIs[0] policy
     /* 1831353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831363 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1831366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831387 */     // GIR_Coverage, 23898,
     /* 1831387 */     GIR_EraseRootFromParent_Done,
     /* 1831388 */   // Label 24687: @1831388
     /* 1831388 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1831474), // Rule ID 23899 //
     /* 1831393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1831401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1831410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831439 */     // MIs[0] policy
     /* 1831439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831449 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1831452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831473 */     // GIR_Coverage, 23899,
     /* 1831473 */     GIR_EraseRootFromParent_Done,
     /* 1831474 */   // Label 24688: @1831474
     /* 1831474 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1831560), // Rule ID 23902 //
     /* 1831479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1831496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1831499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831525 */     // MIs[0] policy
     /* 1831525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1831538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831559 */     // GIR_Coverage, 23902,
     /* 1831559 */     GIR_EraseRootFromParent_Done,
     /* 1831560 */   // Label 24689: @1831560
     /* 1831560 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1831646), // Rule ID 23903 //
     /* 1831565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1831582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831611 */     // MIs[0] policy
     /* 1831611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831621 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1831624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831645 */     // GIR_Coverage, 23903,
     /* 1831645 */     GIR_EraseRootFromParent_Done,
     /* 1831646 */   // Label 24690: @1831646
     /* 1831646 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1831732), // Rule ID 23906 //
     /* 1831651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1831671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831697 */     // MIs[0] policy
     /* 1831697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1831710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831731 */     // GIR_Coverage, 23906,
     /* 1831731 */     GIR_EraseRootFromParent_Done,
     /* 1831732 */   // Label 24691: @1831732
     /* 1831732 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1831818), // Rule ID 23907 //
     /* 1831737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831783 */     // MIs[0] policy
     /* 1831783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831793 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1831796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831817 */     // GIR_Coverage, 23907,
     /* 1831817 */     GIR_EraseRootFromParent_Done,
     /* 1831818 */   // Label 24692: @1831818
     /* 1831818 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1831904), // Rule ID 23910 //
     /* 1831823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1831843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831869 */     // MIs[0] policy
     /* 1831869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831879 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1831882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831903 */     // GIR_Coverage, 23910,
     /* 1831903 */     GIR_EraseRootFromParent_Done,
     /* 1831904 */   // Label 24693: @1831904
     /* 1831904 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1831990), // Rule ID 23911 //
     /* 1831909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1831917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1831929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831955 */     // MIs[0] policy
     /* 1831955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831965 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1831968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1831972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831989 */     // GIR_Coverage, 23911,
     /* 1831989 */     GIR_EraseRootFromParent_Done,
     /* 1831990 */   // Label 24694: @1831990
     /* 1831990 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1832076), // Rule ID 23914 //
     /* 1831995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1832006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1832009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1832012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832041 */     // MIs[0] policy
     /* 1832041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1832054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832075 */     // GIR_Coverage, 23914,
     /* 1832075 */     GIR_EraseRootFromParent_Done,
     /* 1832076 */   // Label 24695: @1832076
     /* 1832076 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1832162), // Rule ID 23915 //
     /* 1832081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1832092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1832095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1832098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832127 */     // MIs[0] policy
     /* 1832127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1832140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832161 */     // GIR_Coverage, 23915,
     /* 1832161 */     GIR_EraseRootFromParent_Done,
     /* 1832162 */   // Label 24696: @1832162
     /* 1832162 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1832248), // Rule ID 23918 //
     /* 1832167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1832178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1832181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1832184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832213 */     // MIs[0] policy
     /* 1832213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1832226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832247 */     // GIR_Coverage, 23918,
     /* 1832247 */     GIR_EraseRootFromParent_Done,
     /* 1832248 */   // Label 24697: @1832248
     /* 1832248 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1832334), // Rule ID 23919 //
     /* 1832253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1832264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1832267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1832270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832299 */     // MIs[0] policy
     /* 1832299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1832312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832333 */     // GIR_Coverage, 23919,
     /* 1832333 */     GIR_EraseRootFromParent_Done,
     /* 1832334 */   // Label 24698: @1832334
     /* 1832334 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1832420), // Rule ID 23922 //
     /* 1832339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1832356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832385 */     // MIs[0] policy
     /* 1832385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832395 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1832398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832419 */     // GIR_Coverage, 23922,
     /* 1832419 */     GIR_EraseRootFromParent_Done,
     /* 1832420 */   // Label 24699: @1832420
     /* 1832420 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1832506), // Rule ID 23923 //
     /* 1832425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1832442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832471 */     // MIs[0] policy
     /* 1832471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832481 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1832484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832505 */     // GIR_Coverage, 23923,
     /* 1832505 */     GIR_EraseRootFromParent_Done,
     /* 1832506 */   // Label 24700: @1832506
     /* 1832506 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1832592), // Rule ID 23926 //
     /* 1832511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1832528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832557 */     // MIs[0] policy
     /* 1832557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832567 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1832570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832591 */     // GIR_Coverage, 23926,
     /* 1832591 */     GIR_EraseRootFromParent_Done,
     /* 1832592 */   // Label 24701: @1832592
     /* 1832592 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1832678), // Rule ID 23927 //
     /* 1832597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1832614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832643 */     // MIs[0] policy
     /* 1832643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832653 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1832656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832677 */     // GIR_Coverage, 23927,
     /* 1832677 */     GIR_EraseRootFromParent_Done,
     /* 1832678 */   // Label 24702: @1832678
     /* 1832678 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1832764), // Rule ID 23930 //
     /* 1832683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832729 */     // MIs[0] policy
     /* 1832729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1832742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832763 */     // GIR_Coverage, 23930,
     /* 1832763 */     GIR_EraseRootFromParent_Done,
     /* 1832764 */   // Label 24703: @1832764
     /* 1832764 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1832850), // Rule ID 23931 //
     /* 1832769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832815 */     // MIs[0] policy
     /* 1832815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1832828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832849 */     // GIR_Coverage, 23931,
     /* 1832849 */     GIR_EraseRootFromParent_Done,
     /* 1832850 */   // Label 24704: @1832850
     /* 1832850 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1832936), // Rule ID 23934 //
     /* 1832855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1832875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832901 */     // MIs[0] policy
     /* 1832901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1832914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1832918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832935 */     // GIR_Coverage, 23934,
     /* 1832935 */     GIR_EraseRootFromParent_Done,
     /* 1832936 */   // Label 24705: @1832936
     /* 1832936 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1833022), // Rule ID 23935 //
     /* 1832941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1832949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1832961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832987 */     // MIs[0] policy
     /* 1832987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832997 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1833000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833021 */     // GIR_Coverage, 23935,
     /* 1833021 */     GIR_EraseRootFromParent_Done,
     /* 1833022 */   // Label 24706: @1833022
     /* 1833022 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1833108), // Rule ID 23938 //
     /* 1833027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1833038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1833041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1833044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1833050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833073 */     // MIs[0] policy
     /* 1833073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1833086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833107 */     // GIR_Coverage, 23938,
     /* 1833107 */     GIR_EraseRootFromParent_Done,
     /* 1833108 */   // Label 24707: @1833108
     /* 1833108 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1833194), // Rule ID 23939 //
     /* 1833113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1833124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1833127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1833130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1833136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833159 */     // MIs[0] policy
     /* 1833159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1833172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833193 */     // GIR_Coverage, 23939,
     /* 1833193 */     GIR_EraseRootFromParent_Done,
     /* 1833194 */   // Label 24708: @1833194
     /* 1833194 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1833280), // Rule ID 23942 //
     /* 1833199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1833210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1833213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1833216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833245 */     // MIs[0] policy
     /* 1833245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1833258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833279 */     // GIR_Coverage, 23942,
     /* 1833279 */     GIR_EraseRootFromParent_Done,
     /* 1833280 */   // Label 24709: @1833280
     /* 1833280 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1833366), // Rule ID 23943 //
     /* 1833285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1833296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1833299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1833302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833331 */     // MIs[0] policy
     /* 1833331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1833344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833365 */     // GIR_Coverage, 23943,
     /* 1833365 */     GIR_EraseRootFromParent_Done,
     /* 1833366 */   // Label 24710: @1833366
     /* 1833366 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1833452), // Rule ID 23946 //
     /* 1833371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1833388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833417 */     // MIs[0] policy
     /* 1833417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833427 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1833430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833451 */     // GIR_Coverage, 23946,
     /* 1833451 */     GIR_EraseRootFromParent_Done,
     /* 1833452 */   // Label 24711: @1833452
     /* 1833452 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1833538), // Rule ID 23947 //
     /* 1833457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1833474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833503 */     // MIs[0] policy
     /* 1833503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833513 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1833516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833537 */     // GIR_Coverage, 23947,
     /* 1833537 */     GIR_EraseRootFromParent_Done,
     /* 1833538 */   // Label 24712: @1833538
     /* 1833538 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1833624), // Rule ID 23950 //
     /* 1833543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1833560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833589 */     // MIs[0] policy
     /* 1833589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833599 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1833602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833623 */     // GIR_Coverage, 23950,
     /* 1833623 */     GIR_EraseRootFromParent_Done,
     /* 1833624 */   // Label 24713: @1833624
     /* 1833624 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1833710), // Rule ID 23951 //
     /* 1833629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1833646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833675 */     // MIs[0] policy
     /* 1833675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833685 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1833688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833709 */     // GIR_Coverage, 23951,
     /* 1833709 */     GIR_EraseRootFromParent_Done,
     /* 1833710 */   // Label 24714: @1833710
     /* 1833710 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1833796), // Rule ID 23954 //
     /* 1833715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833761 */     // MIs[0] policy
     /* 1833761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1833774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833795 */     // GIR_Coverage, 23954,
     /* 1833795 */     GIR_EraseRootFromParent_Done,
     /* 1833796 */   // Label 24715: @1833796
     /* 1833796 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1833882), // Rule ID 23955 //
     /* 1833801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833847 */     // MIs[0] policy
     /* 1833847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1833860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833881 */     // GIR_Coverage, 23955,
     /* 1833881 */     GIR_EraseRootFromParent_Done,
     /* 1833882 */   // Label 24716: @1833882
     /* 1833882 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1833968), // Rule ID 23958 //
     /* 1833887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1833907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833933 */     // MIs[0] policy
     /* 1833933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1833946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1833950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833967 */     // GIR_Coverage, 23958,
     /* 1833967 */     GIR_EraseRootFromParent_Done,
     /* 1833968 */   // Label 24717: @1833968
     /* 1833968 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1834054), // Rule ID 23959 //
     /* 1833973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1833981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1833993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834019 */     // MIs[0] policy
     /* 1834019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834029 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1834032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834053 */     // GIR_Coverage, 23959,
     /* 1834053 */     GIR_EraseRootFromParent_Done,
     /* 1834054 */   // Label 24718: @1834054
     /* 1834054 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1834140), // Rule ID 23962 //
     /* 1834059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1834070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1834073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1834076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1834082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834105 */     // MIs[0] policy
     /* 1834105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834115 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1834118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834139 */     // GIR_Coverage, 23962,
     /* 1834139 */     GIR_EraseRootFromParent_Done,
     /* 1834140 */   // Label 24719: @1834140
     /* 1834140 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1834226), // Rule ID 23963 //
     /* 1834145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1834156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1834159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1834162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1834165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1834168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834191 */     // MIs[0] policy
     /* 1834191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834201 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1834204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834225 */     // GIR_Coverage, 23963,
     /* 1834225 */     GIR_EraseRootFromParent_Done,
     /* 1834226 */   // Label 24720: @1834226
     /* 1834226 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1834312), // Rule ID 23966 //
     /* 1834231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1834248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834277 */     // MIs[0] policy
     /* 1834277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1834290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834311 */     // GIR_Coverage, 23966,
     /* 1834311 */     GIR_EraseRootFromParent_Done,
     /* 1834312 */   // Label 24721: @1834312
     /* 1834312 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1834398), // Rule ID 23967 //
     /* 1834317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1834334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1834337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834363 */     // MIs[0] policy
     /* 1834363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1834376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834397 */     // GIR_Coverage, 23967,
     /* 1834397 */     GIR_EraseRootFromParent_Done,
     /* 1834398 */   // Label 24722: @1834398
     /* 1834398 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1834484), // Rule ID 23970 //
     /* 1834403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1834420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834449 */     // MIs[0] policy
     /* 1834449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1834462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834483 */     // GIR_Coverage, 23970,
     /* 1834483 */     GIR_EraseRootFromParent_Done,
     /* 1834484 */   // Label 24723: @1834484
     /* 1834484 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1834570), // Rule ID 23971 //
     /* 1834489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1834506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1834509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834535 */     // MIs[0] policy
     /* 1834535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834545 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1834548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834569 */     // GIR_Coverage, 23971,
     /* 1834569 */     GIR_EraseRootFromParent_Done,
     /* 1834570 */   // Label 24724: @1834570
     /* 1834570 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1834656), // Rule ID 23974 //
     /* 1834575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1834586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1834589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1834592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834621 */     // MIs[0] policy
     /* 1834621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834631 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1834634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834655 */     // GIR_Coverage, 23974,
     /* 1834655 */     GIR_EraseRootFromParent_Done,
     /* 1834656 */   // Label 24725: @1834656
     /* 1834656 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1834742), // Rule ID 23975 //
     /* 1834661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1834672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1834675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1834678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1834681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834707 */     // MIs[0] policy
     /* 1834707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834717 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1834720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834741 */     // GIR_Coverage, 23975,
     /* 1834741 */     GIR_EraseRootFromParent_Done,
     /* 1834742 */   // Label 24726: @1834742
     /* 1834742 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1834828), // Rule ID 23978 //
     /* 1834747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834793 */     // MIs[0] policy
     /* 1834793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834803 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1834806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834827 */     // GIR_Coverage, 23978,
     /* 1834827 */     GIR_EraseRootFromParent_Done,
     /* 1834828 */   // Label 24727: @1834828
     /* 1834828 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1834914), // Rule ID 23979 //
     /* 1834833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1834853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834879 */     // MIs[0] policy
     /* 1834879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1834892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834913 */     // GIR_Coverage, 23979,
     /* 1834913 */     GIR_EraseRootFromParent_Done,
     /* 1834914 */   // Label 24728: @1834914
     /* 1834914 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1835000), // Rule ID 23982 //
     /* 1834919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1834927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1834939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834965 */     // MIs[0] policy
     /* 1834965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834975 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1834978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1834982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834999 */     // GIR_Coverage, 23982,
     /* 1834999 */     GIR_EraseRootFromParent_Done,
     /* 1835000 */   // Label 24729: @1835000
     /* 1835000 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1835086), // Rule ID 23983 //
     /* 1835005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1835013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1835016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1835019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1835022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1835035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835051 */     // MIs[0] policy
     /* 1835051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1835064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1835068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835085 */     // GIR_Coverage, 23983,
     /* 1835085 */     GIR_EraseRootFromParent_Done,
     /* 1835086 */   // Label 24730: @1835086
     /* 1835086 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1835172), // Rule ID 23986 //
     /* 1835091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1835099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1835102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1835105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1835108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1835121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835137 */     // MIs[0] policy
     /* 1835137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835147 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1835150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1835154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835171 */     // GIR_Coverage, 23986,
     /* 1835171 */     GIR_EraseRootFromParent_Done,
     /* 1835172 */   // Label 24731: @1835172
     /* 1835172 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1835258), // Rule ID 23987 //
     /* 1835177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1835185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1835188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1835191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1835194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1835207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835223 */     // MIs[0] policy
     /* 1835223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835233 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1835236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1835240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835257 */     // GIR_Coverage, 23987,
     /* 1835257 */     GIR_EraseRootFromParent_Done,
     /* 1835258 */   // Label 24732: @1835258
     /* 1835258 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1835344), // Rule ID 23990 //
     /* 1835263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1835266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1835280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835309 */     // MIs[0] policy
     /* 1835309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835319 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1835322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835343 */     // GIR_Coverage, 23990,
     /* 1835343 */     GIR_EraseRootFromParent_Done,
     /* 1835344 */   // Label 24733: @1835344
     /* 1835344 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1835430), // Rule ID 23991 //
     /* 1835349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1835352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1835366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835395 */     // MIs[0] policy
     /* 1835395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835405 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1835408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835429 */     // GIR_Coverage, 23991,
     /* 1835429 */     GIR_EraseRootFromParent_Done,
     /* 1835430 */   // Label 24734: @1835430
     /* 1835430 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1835516), // Rule ID 23994 //
     /* 1835435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1835438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1835452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835481 */     // MIs[0] policy
     /* 1835481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835491 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1835494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835515 */     // GIR_Coverage, 23994,
     /* 1835515 */     GIR_EraseRootFromParent_Done,
     /* 1835516 */   // Label 24735: @1835516
     /* 1835516 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1835602), // Rule ID 23995 //
     /* 1835521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1835524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1835538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835567 */     // MIs[0] policy
     /* 1835567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835577 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1835580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835601 */     // GIR_Coverage, 23995,
     /* 1835601 */     GIR_EraseRootFromParent_Done,
     /* 1835602 */   // Label 24736: @1835602
     /* 1835602 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1835688), // Rule ID 23998 //
     /* 1835607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1835610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1835624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835653 */     // MIs[0] policy
     /* 1835653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835663 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1835666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835687 */     // GIR_Coverage, 23998,
     /* 1835687 */     GIR_EraseRootFromParent_Done,
     /* 1835688 */   // Label 24737: @1835688
     /* 1835688 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1835774), // Rule ID 23999 //
     /* 1835693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1835696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1835710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835739 */     // MIs[0] policy
     /* 1835739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835749 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1835752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835773 */     // GIR_Coverage, 23999,
     /* 1835773 */     GIR_EraseRootFromParent_Done,
     /* 1835774 */   // Label 24738: @1835774
     /* 1835774 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1835860), // Rule ID 24002 //
     /* 1835779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1835782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1835796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835825 */     // MIs[0] policy
     /* 1835825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835835 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1835838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835859 */     // GIR_Coverage, 24002,
     /* 1835859 */     GIR_EraseRootFromParent_Done,
     /* 1835860 */   // Label 24739: @1835860
     /* 1835860 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1835946), // Rule ID 24003 //
     /* 1835865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1835868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1835882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1835885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835911 */     // MIs[0] policy
     /* 1835911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835921 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1835924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835945 */     // GIR_Coverage, 24003,
     /* 1835945 */     GIR_EraseRootFromParent_Done,
     /* 1835946 */   // Label 24740: @1835946
     /* 1835946 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1836032), // Rule ID 24006 //
     /* 1835951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1835954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1835959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1835968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1835971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835997 */     // MIs[0] policy
     /* 1835997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836007 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1836010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836031 */     // GIR_Coverage, 24006,
     /* 1836031 */     GIR_EraseRootFromParent_Done,
     /* 1836032 */   // Label 24741: @1836032
     /* 1836032 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1836118), // Rule ID 24007 //
     /* 1836037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1836040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1836048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1836054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836083 */     // MIs[0] policy
     /* 1836083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836093 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1836096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836117 */     // GIR_Coverage, 24007,
     /* 1836117 */     GIR_EraseRootFromParent_Done,
     /* 1836118 */   // Label 24742: @1836118
     /* 1836118 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1836204), // Rule ID 24010 //
     /* 1836123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1836126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1836140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1836143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836169 */     // MIs[0] policy
     /* 1836169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1836182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836203 */     // GIR_Coverage, 24010,
     /* 1836203 */     GIR_EraseRootFromParent_Done,
     /* 1836204 */   // Label 24743: @1836204
     /* 1836204 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1836290), // Rule ID 24011 //
     /* 1836209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1836212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1836226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836255 */     // MIs[0] policy
     /* 1836255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836265 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1836268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836289 */     // GIR_Coverage, 24011,
     /* 1836289 */     GIR_EraseRootFromParent_Done,
     /* 1836290 */   // Label 24744: @1836290
     /* 1836290 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1836376), // Rule ID 24014 //
     /* 1836295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1836298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1836312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1836315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836341 */     // MIs[0] policy
     /* 1836341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836351 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1836354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836375 */     // GIR_Coverage, 24014,
     /* 1836375 */     GIR_EraseRootFromParent_Done,
     /* 1836376 */   // Label 24745: @1836376
     /* 1836376 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1836462), // Rule ID 24015 //
     /* 1836381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1836384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1836398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836427 */     // MIs[0] policy
     /* 1836427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836437 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1836440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836461 */     // GIR_Coverage, 24015,
     /* 1836461 */     GIR_EraseRootFromParent_Done,
     /* 1836462 */   // Label 24746: @1836462
     /* 1836462 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1836548), // Rule ID 24018 //
     /* 1836467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1836470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1836484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1836487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836513 */     // MIs[0] policy
     /* 1836513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836523 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1836526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836547 */     // GIR_Coverage, 24018,
     /* 1836547 */     GIR_EraseRootFromParent_Done,
     /* 1836548 */   // Label 24747: @1836548
     /* 1836548 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1836634), // Rule ID 24019 //
     /* 1836553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1836556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1836570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836599 */     // MIs[0] policy
     /* 1836599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836609 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1836612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836633 */     // GIR_Coverage, 24019,
     /* 1836633 */     GIR_EraseRootFromParent_Done,
     /* 1836634 */   // Label 24748: @1836634
     /* 1836634 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1836720), // Rule ID 24022 //
     /* 1836639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1836642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1836656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1836659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836685 */     // MIs[0] policy
     /* 1836685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836695 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1836698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836719 */     // GIR_Coverage, 24022,
     /* 1836719 */     GIR_EraseRootFromParent_Done,
     /* 1836720 */   // Label 24749: @1836720
     /* 1836720 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1836806), // Rule ID 24023 //
     /* 1836725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1836728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1836742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836771 */     // MIs[0] policy
     /* 1836771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836781 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1836784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836805 */     // GIR_Coverage, 24023,
     /* 1836805 */     GIR_EraseRootFromParent_Done,
     /* 1836806 */   // Label 24750: @1836806
     /* 1836806 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1836892), // Rule ID 24026 //
     /* 1836811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1836814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1836828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1836831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836857 */     // MIs[0] policy
     /* 1836857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836867 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1836870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836891 */     // GIR_Coverage, 24026,
     /* 1836891 */     GIR_EraseRootFromParent_Done,
     /* 1836892 */   // Label 24751: @1836892
     /* 1836892 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1836978), // Rule ID 24027 //
     /* 1836897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1836900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1836914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1836917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836943 */     // MIs[0] policy
     /* 1836943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836953 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1836956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836977 */     // GIR_Coverage, 24027,
     /* 1836977 */     GIR_EraseRootFromParent_Done,
     /* 1836978 */   // Label 24752: @1836978
     /* 1836978 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1837064), // Rule ID 24030 //
     /* 1836983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1836986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1836991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1836994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1836997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1837000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837029 */     // MIs[0] policy
     /* 1837029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837039 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1837042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837063 */     // GIR_Coverage, 24030,
     /* 1837063 */     GIR_EraseRootFromParent_Done,
     /* 1837064 */   // Label 24753: @1837064
     /* 1837064 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1837150), // Rule ID 24031 //
     /* 1837069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1837072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1837086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837115 */     // MIs[0] policy
     /* 1837115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1837128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837149 */     // GIR_Coverage, 24031,
     /* 1837149 */     GIR_EraseRootFromParent_Done,
     /* 1837150 */   // Label 24754: @1837150
     /* 1837150 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1837236), // Rule ID 24034 //
     /* 1837155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1837158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1837172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837201 */     // MIs[0] policy
     /* 1837201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837211 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1837214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837235 */     // GIR_Coverage, 24034,
     /* 1837235 */     GIR_EraseRootFromParent_Done,
     /* 1837236 */   // Label 24755: @1837236
     /* 1837236 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1837322), // Rule ID 24035 //
     /* 1837241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1837244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1837258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837287 */     // MIs[0] policy
     /* 1837287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837297 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1837300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837321 */     // GIR_Coverage, 24035,
     /* 1837321 */     GIR_EraseRootFromParent_Done,
     /* 1837322 */   // Label 24756: @1837322
     /* 1837322 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1837408), // Rule ID 24038 //
     /* 1837327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1837330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1837344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837373 */     // MIs[0] policy
     /* 1837373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1837386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837407 */     // GIR_Coverage, 24038,
     /* 1837407 */     GIR_EraseRootFromParent_Done,
     /* 1837408 */   // Label 24757: @1837408
     /* 1837408 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1837494), // Rule ID 24039 //
     /* 1837413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1837416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1837430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837459 */     // MIs[0] policy
     /* 1837459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837469 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1837472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837493 */     // GIR_Coverage, 24039,
     /* 1837493 */     GIR_EraseRootFromParent_Done,
     /* 1837494 */   // Label 24758: @1837494
     /* 1837494 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1837580), // Rule ID 24042 //
     /* 1837499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1837502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1837516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837545 */     // MIs[0] policy
     /* 1837545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837555 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1837558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837579 */     // GIR_Coverage, 24042,
     /* 1837579 */     GIR_EraseRootFromParent_Done,
     /* 1837580 */   // Label 24759: @1837580
     /* 1837580 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1837666), // Rule ID 24043 //
     /* 1837585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1837588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1837602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837631 */     // MIs[0] policy
     /* 1837631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837641 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1837644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837665 */     // GIR_Coverage, 24043,
     /* 1837665 */     GIR_EraseRootFromParent_Done,
     /* 1837666 */   // Label 24760: @1837666
     /* 1837666 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1837752), // Rule ID 24046 //
     /* 1837671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1837674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1837688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837717 */     // MIs[0] policy
     /* 1837717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837727 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1837730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837751 */     // GIR_Coverage, 24046,
     /* 1837751 */     GIR_EraseRootFromParent_Done,
     /* 1837752 */   // Label 24761: @1837752
     /* 1837752 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1837838), // Rule ID 24047 //
     /* 1837757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1837760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1837765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1837774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837803 */     // MIs[0] policy
     /* 1837803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837813 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1837816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837837 */     // GIR_Coverage, 24047,
     /* 1837837 */     GIR_EraseRootFromParent_Done,
     /* 1837838 */   // Label 24762: @1837838
     /* 1837838 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1837924), // Rule ID 24110 //
     /* 1837843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1837846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1837851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1837854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1837857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1837860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1837863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837889 */     // MIs[0] policy
     /* 1837889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837899 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1837902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837923 */     // GIR_Coverage, 24110,
     /* 1837923 */     GIR_EraseRootFromParent_Done,
     /* 1837924 */   // Label 24763: @1837924
     /* 1837924 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1838010), // Rule ID 24111 //
     /* 1837929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1837932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1837937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1837940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1837943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1837946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1837949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837975 */     // MIs[0] policy
     /* 1837975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837985 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1837988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838009 */     // GIR_Coverage, 24111,
     /* 1838009 */     GIR_EraseRootFromParent_Done,
     /* 1838010 */   // Label 24764: @1838010
     /* 1838010 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1838096), // Rule ID 24114 //
     /* 1838015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1838018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838061 */     // MIs[0] policy
     /* 1838061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838071 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1838074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838095 */     // GIR_Coverage, 24114,
     /* 1838095 */     GIR_EraseRootFromParent_Done,
     /* 1838096 */   // Label 24765: @1838096
     /* 1838096 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1838182), // Rule ID 24115 //
     /* 1838101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1838104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838147 */     // MIs[0] policy
     /* 1838147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838157 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1838160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838181 */     // GIR_Coverage, 24115,
     /* 1838181 */     GIR_EraseRootFromParent_Done,
     /* 1838182 */   // Label 24766: @1838182
     /* 1838182 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1838268), // Rule ID 24118 //
     /* 1838187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1838190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838233 */     // MIs[0] policy
     /* 1838233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838243 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1838246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838267 */     // GIR_Coverage, 24118,
     /* 1838267 */     GIR_EraseRootFromParent_Done,
     /* 1838268 */   // Label 24767: @1838268
     /* 1838268 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1838354), // Rule ID 24119 //
     /* 1838273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1838276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838319 */     // MIs[0] policy
     /* 1838319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838329 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1838332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838353 */     // GIR_Coverage, 24119,
     /* 1838353 */     GIR_EraseRootFromParent_Done,
     /* 1838354 */   // Label 24768: @1838354
     /* 1838354 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1838440), // Rule ID 24122 //
     /* 1838359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1838362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1838370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1838373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1838376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838405 */     // MIs[0] policy
     /* 1838405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838415 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838439 */     // GIR_Coverage, 24122,
     /* 1838439 */     GIR_EraseRootFromParent_Done,
     /* 1838440 */   // Label 24769: @1838440
     /* 1838440 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1838526), // Rule ID 24123 //
     /* 1838445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1838448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1838456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1838459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1838462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838491 */     // MIs[0] policy
     /* 1838491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838501 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838525 */     // GIR_Coverage, 24123,
     /* 1838525 */     GIR_EraseRootFromParent_Done,
     /* 1838526 */   // Label 24770: @1838526
     /* 1838526 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1838612), // Rule ID 24126 //
     /* 1838531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1838534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1838542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1838545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1838548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838577 */     // MIs[0] policy
     /* 1838577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838611 */     // GIR_Coverage, 24126,
     /* 1838611 */     GIR_EraseRootFromParent_Done,
     /* 1838612 */   // Label 24771: @1838612
     /* 1838612 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1838698), // Rule ID 24127 //
     /* 1838617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1838620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1838628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1838631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1838634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838663 */     // MIs[0] policy
     /* 1838663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838673 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838697 */     // GIR_Coverage, 24127,
     /* 1838697 */     GIR_EraseRootFromParent_Done,
     /* 1838698 */   // Label 24772: @1838698
     /* 1838698 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1838784), // Rule ID 24130 //
     /* 1838703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1838706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1838714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1838717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1838720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838749 */     // MIs[0] policy
     /* 1838749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838759 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838783 */     // GIR_Coverage, 24130,
     /* 1838783 */     GIR_EraseRootFromParent_Done,
     /* 1838784 */   // Label 24773: @1838784
     /* 1838784 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1838870), // Rule ID 24131 //
     /* 1838789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1838792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1838800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1838803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1838806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838835 */     // MIs[0] policy
     /* 1838835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838845 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1838848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838869 */     // GIR_Coverage, 24131,
     /* 1838869 */     GIR_EraseRootFromParent_Done,
     /* 1838870 */   // Label 24774: @1838870
     /* 1838870 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1838956), // Rule ID 24134 //
     /* 1838875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1838878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1838886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1838889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1838892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1838895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838921 */     // MIs[0] policy
     /* 1838921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838931 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1838934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838955 */     // GIR_Coverage, 24134,
     /* 1838955 */     GIR_EraseRootFromParent_Done,
     /* 1838956 */   // Label 24775: @1838956
     /* 1838956 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1839042), // Rule ID 24135 //
     /* 1838961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1838964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1838969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1838972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1838975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1838978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1838981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839007 */     // MIs[0] policy
     /* 1839007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1839020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839041 */     // GIR_Coverage, 24135,
     /* 1839041 */     GIR_EraseRootFromParent_Done,
     /* 1839042 */   // Label 24776: @1839042
     /* 1839042 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1839128), // Rule ID 24138 //
     /* 1839047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1839050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1839058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1839061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1839064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839093 */     // MIs[0] policy
     /* 1839093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839103 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1839106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839127 */     // GIR_Coverage, 24138,
     /* 1839127 */     GIR_EraseRootFromParent_Done,
     /* 1839128 */   // Label 24777: @1839128
     /* 1839128 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1839214), // Rule ID 24139 //
     /* 1839133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1839136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1839144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1839147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1839150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1839153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839179 */     // MIs[0] policy
     /* 1839179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839189 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1839192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839213 */     // GIR_Coverage, 24139,
     /* 1839213 */     GIR_EraseRootFromParent_Done,
     /* 1839214 */   // Label 24778: @1839214
     /* 1839214 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1839300), // Rule ID 24142 //
     /* 1839219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1839222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1839230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1839233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1839236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839265 */     // MIs[0] policy
     /* 1839265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839275 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1839278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839299 */     // GIR_Coverage, 24142,
     /* 1839299 */     GIR_EraseRootFromParent_Done,
     /* 1839300 */   // Label 24779: @1839300
     /* 1839300 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1839386), // Rule ID 24143 //
     /* 1839305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1839308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1839316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1839319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1839322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1839325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839351 */     // MIs[0] policy
     /* 1839351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839361 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1839364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839385 */     // GIR_Coverage, 24143,
     /* 1839385 */     GIR_EraseRootFromParent_Done,
     /* 1839386 */   // Label 24780: @1839386
     /* 1839386 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1839472), // Rule ID 24146 //
     /* 1839391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1839394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1839402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1839405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1839408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839437 */     // MIs[0] policy
     /* 1839437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839447 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1839450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839471 */     // GIR_Coverage, 24146,
     /* 1839471 */     GIR_EraseRootFromParent_Done,
     /* 1839472 */   // Label 24781: @1839472
     /* 1839472 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1839558), // Rule ID 24147 //
     /* 1839477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1839480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1839488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1839491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1839494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1839497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839523 */     // MIs[0] policy
     /* 1839523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1839536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839557 */     // GIR_Coverage, 24147,
     /* 1839557 */     GIR_EraseRootFromParent_Done,
     /* 1839558 */   // Label 24782: @1839558
     /* 1839558 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1839644), // Rule ID 24150 //
     /* 1839563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1839566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1839574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1839577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1839580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839609 */     // MIs[0] policy
     /* 1839609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839619 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1839622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839643 */     // GIR_Coverage, 24150,
     /* 1839643 */     GIR_EraseRootFromParent_Done,
     /* 1839644 */   // Label 24783: @1839644
     /* 1839644 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1839730), // Rule ID 24151 //
     /* 1839649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1839652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1839660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1839663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1839666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1839669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839695 */     // MIs[0] policy
     /* 1839695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839705 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1839708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839729 */     // GIR_Coverage, 24151,
     /* 1839729 */     GIR_EraseRootFromParent_Done,
     /* 1839730 */   // Label 24784: @1839730
     /* 1839730 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1839816), // Rule ID 24154 //
     /* 1839735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1839738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1839746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1839749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1839752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839781 */     // MIs[0] policy
     /* 1839781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839791 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1839794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839815 */     // GIR_Coverage, 24154,
     /* 1839815 */     GIR_EraseRootFromParent_Done,
     /* 1839816 */   // Label 24785: @1839816
     /* 1839816 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1839902), // Rule ID 24155 //
     /* 1839821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1839824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1839832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1839835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1839838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1839841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839867 */     // MIs[0] policy
     /* 1839867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1839880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839901 */     // GIR_Coverage, 24155,
     /* 1839901 */     GIR_EraseRootFromParent_Done,
     /* 1839902 */   // Label 24786: @1839902
     /* 1839902 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1839988), // Rule ID 24158 //
     /* 1839907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1839910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1839915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1839918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1839921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1839924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1839927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839953 */     // MIs[0] policy
     /* 1839953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839963 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1839966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839987 */     // GIR_Coverage, 24158,
     /* 1839987 */     GIR_EraseRootFromParent_Done,
     /* 1839988 */   // Label 24787: @1839988
     /* 1839988 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1840074), // Rule ID 24159 //
     /* 1839993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1839996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1840001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1840004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1840007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1840010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1840013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840039 */     // MIs[0] policy
     /* 1840039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840049 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1840052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840073 */     // GIR_Coverage, 24159,
     /* 1840073 */     GIR_EraseRootFromParent_Done,
     /* 1840074 */   // Label 24788: @1840074
     /* 1840074 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1840160), // Rule ID 24162 //
     /* 1840079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1840082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1840087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1840090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1840093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1840096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1840099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840125 */     // MIs[0] policy
     /* 1840125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840135 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1840138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840159 */     // GIR_Coverage, 24162,
     /* 1840159 */     GIR_EraseRootFromParent_Done,
     /* 1840160 */   // Label 24789: @1840160
     /* 1840160 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1840246), // Rule ID 24163 //
     /* 1840165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1840168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1840173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1840176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1840179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1840182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1840185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840211 */     // MIs[0] policy
     /* 1840211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840221 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1840224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840245 */     // GIR_Coverage, 24163,
     /* 1840245 */     GIR_EraseRootFromParent_Done,
     /* 1840246 */   // Label 24790: @1840246
     /* 1840246 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1840332), // Rule ID 24166 //
     /* 1840251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1840254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1840259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1840262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1840265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1840268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1840271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840297 */     // MIs[0] policy
     /* 1840297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840307 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1840310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840331 */     // GIR_Coverage, 24166,
     /* 1840331 */     GIR_EraseRootFromParent_Done,
     /* 1840332 */   // Label 24791: @1840332
     /* 1840332 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1840418), // Rule ID 24167 //
     /* 1840337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1840340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1840345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1840348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1840351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1840354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1840357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840383 */     // MIs[0] policy
     /* 1840383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840393 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1840396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840417 */     // GIR_Coverage, 24167,
     /* 1840417 */     GIR_EraseRootFromParent_Done,
     /* 1840418 */   // Label 24792: @1840418
     /* 1840418 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1840504), // Rule ID 24230 //
     /* 1840423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1840426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1840434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1840437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1840440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1840443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1840465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840469 */     // MIs[0] policy
     /* 1840469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840479 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1840482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840503 */     // GIR_Coverage, 24230,
     /* 1840503 */     GIR_EraseRootFromParent_Done,
     /* 1840504 */   // Label 24793: @1840504
     /* 1840504 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1840590), // Rule ID 24231 //
     /* 1840509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1840512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1840520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1840523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1840526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1840529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1840551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840555 */     // MIs[0] policy
     /* 1840555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840565 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1840568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840589 */     // GIR_Coverage, 24231,
     /* 1840589 */     GIR_EraseRootFromParent_Done,
     /* 1840590 */   // Label 24794: @1840590
     /* 1840590 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1840676), // Rule ID 24234 //
     /* 1840595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1840598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1840606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1840609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1840612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1840615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1840637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840641 */     // MIs[0] policy
     /* 1840641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840651 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1840654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840675 */     // GIR_Coverage, 24234,
     /* 1840675 */     GIR_EraseRootFromParent_Done,
     /* 1840676 */   // Label 24795: @1840676
     /* 1840676 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1840762), // Rule ID 24235 //
     /* 1840681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1840684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1840692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1840695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1840698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1840701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1840723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840727 */     // MIs[0] policy
     /* 1840727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840737 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1840740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840761 */     // GIR_Coverage, 24235,
     /* 1840761 */     GIR_EraseRootFromParent_Done,
     /* 1840762 */   // Label 24796: @1840762
     /* 1840762 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1840848), // Rule ID 24238 //
     /* 1840767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1840770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1840778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1840781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1840784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1840787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1840809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840813 */     // MIs[0] policy
     /* 1840813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840823 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1840826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840847 */     // GIR_Coverage, 24238,
     /* 1840847 */     GIR_EraseRootFromParent_Done,
     /* 1840848 */   // Label 24797: @1840848
     /* 1840848 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1840934), // Rule ID 24239 //
     /* 1840853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1840856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1840864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1840867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1840870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1840873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1840895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840899 */     // MIs[0] policy
     /* 1840899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840909 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1840912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1840916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840933 */     // GIR_Coverage, 24239,
     /* 1840933 */     GIR_EraseRootFromParent_Done,
     /* 1840934 */   // Label 24798: @1840934
     /* 1840934 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1841020), // Rule ID 24242 //
     /* 1840939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1840942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1840947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1840950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1840953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1840956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1840959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1840981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840985 */     // MIs[0] policy
     /* 1840985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840995 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1840998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841019 */     // GIR_Coverage, 24242,
     /* 1841019 */     GIR_EraseRootFromParent_Done,
     /* 1841020 */   // Label 24799: @1841020
     /* 1841020 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1841106), // Rule ID 24243 //
     /* 1841025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1841028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1841036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1841039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1841042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841071 */     // MIs[0] policy
     /* 1841071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841081 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10965:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1841084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841105 */     // GIR_Coverage, 24243,
     /* 1841105 */     GIR_EraseRootFromParent_Done,
     /* 1841106 */   // Label 24800: @1841106
     /* 1841106 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1841192), // Rule ID 24246 //
     /* 1841111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1841114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1841122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1841125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1841128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1841131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1841153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841157 */     // MIs[0] policy
     /* 1841157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841167 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10965:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1841170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841191 */     // GIR_Coverage, 24246,
     /* 1841191 */     GIR_EraseRootFromParent_Done,
     /* 1841192 */   // Label 24801: @1841192
     /* 1841192 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1841278), // Rule ID 24247 //
     /* 1841197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1841200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1841208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1841211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1841214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1841217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1841239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841243 */     // MIs[0] policy
     /* 1841243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841253 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10965:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1841256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841277 */     // GIR_Coverage, 24247,
     /* 1841277 */     GIR_EraseRootFromParent_Done,
     /* 1841278 */   // Label 24802: @1841278
     /* 1841278 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1841364), // Rule ID 24250 //
     /* 1841283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1841286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1841294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1841297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1841300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1841303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1841325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841329 */     // MIs[0] policy
     /* 1841329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841339 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1841342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841363 */     // GIR_Coverage, 24250,
     /* 1841363 */     GIR_EraseRootFromParent_Done,
     /* 1841364 */   // Label 24803: @1841364
     /* 1841364 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1841450), // Rule ID 24251 //
     /* 1841369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1841372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1841380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1841383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1841386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1841389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1841411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841415 */     // MIs[0] policy
     /* 1841415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841425 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10965:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1841428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841449 */     // GIR_Coverage, 24251,
     /* 1841449 */     GIR_EraseRootFromParent_Done,
     /* 1841450 */   // Label 24804: @1841450
     /* 1841450 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1841536), // Rule ID 24254 //
     /* 1841455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1841458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1841466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1841469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1841472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841501 */     // MIs[0] policy
     /* 1841501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841511 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1841514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841535 */     // GIR_Coverage, 24254,
     /* 1841535 */     GIR_EraseRootFromParent_Done,
     /* 1841536 */   // Label 24805: @1841536
     /* 1841536 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1841622), // Rule ID 24255 //
     /* 1841541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1841544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1841552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1841555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1841558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841587 */     // MIs[0] policy
     /* 1841587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1841600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841621 */     // GIR_Coverage, 24255,
     /* 1841621 */     GIR_EraseRootFromParent_Done,
     /* 1841622 */   // Label 24806: @1841622
     /* 1841622 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1841708), // Rule ID 24258 //
     /* 1841627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1841630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1841638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1841641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1841644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841673 */     // MIs[0] policy
     /* 1841673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1841686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841707 */     // GIR_Coverage, 24258,
     /* 1841707 */     GIR_EraseRootFromParent_Done,
     /* 1841708 */   // Label 24807: @1841708
     /* 1841708 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1841794), // Rule ID 24259 //
     /* 1841713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1841716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1841724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1841727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1841730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841759 */     // MIs[0] policy
     /* 1841759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841769 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1841772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841793 */     // GIR_Coverage, 24259,
     /* 1841793 */     GIR_EraseRootFromParent_Done,
     /* 1841794 */   // Label 24808: @1841794
     /* 1841794 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1841880), // Rule ID 24262 //
     /* 1841799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1841802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1841810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1841813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1841816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841845 */     // MIs[0] policy
     /* 1841845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841855 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1841858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841879 */     // GIR_Coverage, 24262,
     /* 1841879 */     GIR_EraseRootFromParent_Done,
     /* 1841880 */   // Label 24809: @1841880
     /* 1841880 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1841966), // Rule ID 24263 //
     /* 1841885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1841888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1841896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1841899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1841902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1841905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1841927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841931 */     // MIs[0] policy
     /* 1841931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841941 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1841944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1841948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841965 */     // GIR_Coverage, 24263,
     /* 1841965 */     GIR_EraseRootFromParent_Done,
     /* 1841966 */   // Label 24810: @1841966
     /* 1841966 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1842052), // Rule ID 24266 //
     /* 1841971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1841974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1841979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1841982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1841985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1841991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842017 */     // MIs[0] policy
     /* 1842017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842027 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1842030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842051 */     // GIR_Coverage, 24266,
     /* 1842051 */     GIR_EraseRootFromParent_Done,
     /* 1842052 */   // Label 24811: @1842052
     /* 1842052 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1842138), // Rule ID 24267 //
     /* 1842057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1842060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1842068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1842071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1842074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1842077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842103 */     // MIs[0] policy
     /* 1842103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842113 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1842116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842137 */     // GIR_Coverage, 24267,
     /* 1842137 */     GIR_EraseRootFromParent_Done,
     /* 1842138 */   // Label 24812: @1842138
     /* 1842138 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1842224), // Rule ID 24270 //
     /* 1842143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1842146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1842154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1842157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1842160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1842163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842189 */     // MIs[0] policy
     /* 1842189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842199 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1842202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842223 */     // GIR_Coverage, 24270,
     /* 1842223 */     GIR_EraseRootFromParent_Done,
     /* 1842224 */   // Label 24813: @1842224
     /* 1842224 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1842310), // Rule ID 24271 //
     /* 1842229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1842232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1842240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1842243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1842246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1842249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842275 */     // MIs[0] policy
     /* 1842275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842285 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1842288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842309 */     // GIR_Coverage, 24271,
     /* 1842309 */     GIR_EraseRootFromParent_Done,
     /* 1842310 */   // Label 24814: @1842310
     /* 1842310 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1842396), // Rule ID 24274 //
     /* 1842315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1842318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1842326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1842329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1842332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1842335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842361 */     // MIs[0] policy
     /* 1842361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842371 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1842374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842395 */     // GIR_Coverage, 24274,
     /* 1842395 */     GIR_EraseRootFromParent_Done,
     /* 1842396 */   // Label 24815: @1842396
     /* 1842396 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1842482), // Rule ID 24275 //
     /* 1842401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1842404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1842412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1842415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1842418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1842421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1842443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842447 */     // MIs[0] policy
     /* 1842447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842457 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1842460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842481 */     // GIR_Coverage, 24275,
     /* 1842481 */     GIR_EraseRootFromParent_Done,
     /* 1842482 */   // Label 24816: @1842482
     /* 1842482 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1842568), // Rule ID 24278 //
     /* 1842487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1842490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1842498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1842501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1842504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842533 */     // MIs[0] policy
     /* 1842533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842543 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1842546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842567 */     // GIR_Coverage, 24278,
     /* 1842567 */     GIR_EraseRootFromParent_Done,
     /* 1842568 */   // Label 24817: @1842568
     /* 1842568 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1842654), // Rule ID 24279 //
     /* 1842573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1842576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1842584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1842587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1842590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842619 */     // MIs[0] policy
     /* 1842619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842629 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10965:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1842632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842653 */     // GIR_Coverage, 24279,
     /* 1842653 */     GIR_EraseRootFromParent_Done,
     /* 1842654 */   // Label 24818: @1842654
     /* 1842654 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1842740), // Rule ID 24282 //
     /* 1842659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1842662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1842670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1842673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1842676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842705 */     // MIs[0] policy
     /* 1842705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842715 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1842718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842739 */     // GIR_Coverage, 24282,
     /* 1842739 */     GIR_EraseRootFromParent_Done,
     /* 1842740 */   // Label 24819: @1842740
     /* 1842740 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1842826), // Rule ID 24283 //
     /* 1842745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1842748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1842756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1842759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1842762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842791 */     // MIs[0] policy
     /* 1842791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842801 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10965:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1842804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842825 */     // GIR_Coverage, 24283,
     /* 1842825 */     GIR_EraseRootFromParent_Done,
     /* 1842826 */   // Label 24820: @1842826
     /* 1842826 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1842912), // Rule ID 24286 //
     /* 1842831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1842834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1842842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1842845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1842848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842877 */     // MIs[0] policy
     /* 1842877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842887 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1842890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842911 */     // GIR_Coverage, 24286,
     /* 1842911 */     GIR_EraseRootFromParent_Done,
     /* 1842912 */   // Label 24821: @1842912
     /* 1842912 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1842998), // Rule ID 24287 //
     /* 1842917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1842920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1842925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1842928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1842931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1842934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1842937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1842959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842963 */     // MIs[0] policy
     /* 1842963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842973 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10965:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1842976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1842980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842997 */     // GIR_Coverage, 24287,
     /* 1842997 */     GIR_EraseRootFromParent_Done,
     /* 1842998 */   // Label 24822: @1842998
     /* 1842998 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1843084), // Rule ID 24290 //
     /* 1843003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1843006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1843014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1843017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1843020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843049 */     // MIs[0] policy
     /* 1843049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843059 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1843062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843083 */     // GIR_Coverage, 24290,
     /* 1843083 */     GIR_EraseRootFromParent_Done,
     /* 1843084 */   // Label 24823: @1843084
     /* 1843084 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1843170), // Rule ID 24291 //
     /* 1843089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1843092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1843100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1843103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1843106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843135 */     // MIs[0] policy
     /* 1843135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843145 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1843148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843169 */     // GIR_Coverage, 24291,
     /* 1843169 */     GIR_EraseRootFromParent_Done,
     /* 1843170 */   // Label 24824: @1843170
     /* 1843170 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1843256), // Rule ID 24294 //
     /* 1843175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1843178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1843186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1843189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1843192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843221 */     // MIs[0] policy
     /* 1843221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843231 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1843234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843255 */     // GIR_Coverage, 24294,
     /* 1843255 */     GIR_EraseRootFromParent_Done,
     /* 1843256 */   // Label 24825: @1843256
     /* 1843256 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1843342), // Rule ID 24295 //
     /* 1843261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1843264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1843272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1843275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1843278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843307 */     // MIs[0] policy
     /* 1843307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843317 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1843320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843341 */     // GIR_Coverage, 24295,
     /* 1843341 */     GIR_EraseRootFromParent_Done,
     /* 1843342 */   // Label 24826: @1843342
     /* 1843342 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1843428), // Rule ID 24298 //
     /* 1843347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1843350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1843358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1843361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1843364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1843367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1843389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843393 */     // MIs[0] policy
     /* 1843393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843403 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1843406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843427 */     // GIR_Coverage, 24298,
     /* 1843427 */     GIR_EraseRootFromParent_Done,
     /* 1843428 */   // Label 24827: @1843428
     /* 1843428 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1843514), // Rule ID 24299 //
     /* 1843433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1843436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1843444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1843447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1843450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1843453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1843475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843479 */     // MIs[0] policy
     /* 1843479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843489 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1843492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843513 */     // GIR_Coverage, 24299,
     /* 1843513 */     GIR_EraseRootFromParent_Done,
     /* 1843514 */   // Label 24828: @1843514
     /* 1843514 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1843600), // Rule ID 24302 //
     /* 1843519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1843522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1843536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843565 */     // MIs[0] policy
     /* 1843565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843575 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1843578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843599 */     // GIR_Coverage, 24302,
     /* 1843599 */     GIR_EraseRootFromParent_Done,
     /* 1843600 */   // Label 24829: @1843600
     /* 1843600 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1843686), // Rule ID 24303 //
     /* 1843605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1843608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1843622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1843625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1843647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843651 */     // MIs[0] policy
     /* 1843651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843661 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10963:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1843664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843685 */     // GIR_Coverage, 24303,
     /* 1843685 */     GIR_EraseRootFromParent_Done,
     /* 1843686 */   // Label 24830: @1843686
     /* 1843686 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1843772), // Rule ID 24306 //
     /* 1843691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1843694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1843708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1843711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1843733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843737 */     // MIs[0] policy
     /* 1843737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843747 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10963:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1843750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843771 */     // GIR_Coverage, 24306,
     /* 1843771 */     GIR_EraseRootFromParent_Done,
     /* 1843772 */   // Label 24831: @1843772
     /* 1843772 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1843858), // Rule ID 24307 //
     /* 1843777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1843780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1843794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1843797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1843819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843823 */     // MIs[0] policy
     /* 1843823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843833 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10963:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1843836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843857 */     // GIR_Coverage, 24307,
     /* 1843857 */     GIR_EraseRootFromParent_Done,
     /* 1843858 */   // Label 24832: @1843858
     /* 1843858 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1843944), // Rule ID 24310 //
     /* 1843863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1843866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1843880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1843883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1843905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843909 */     // MIs[0] policy
     /* 1843909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843919 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1843922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1843926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843943 */     // GIR_Coverage, 24310,
     /* 1843943 */     GIR_EraseRootFromParent_Done,
     /* 1843944 */   // Label 24833: @1843944
     /* 1843944 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1844030), // Rule ID 24311 //
     /* 1843949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1843952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1843957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1843966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1843969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1843991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843995 */     // MIs[0] policy
     /* 1843995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844005 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10963:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1844008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1844026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844029 */     // GIR_Coverage, 24311,
     /* 1844029 */     GIR_EraseRootFromParent_Done,
     /* 1844030 */   // Label 24834: @1844030
     /* 1844030 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1844116), // Rule ID 24314 //
     /* 1844035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1844038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1844052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844081 */     // MIs[0] policy
     /* 1844081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1844094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844115 */     // GIR_Coverage, 24314,
     /* 1844115 */     GIR_EraseRootFromParent_Done,
     /* 1844116 */   // Label 24835: @1844116
     /* 1844116 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1844202), // Rule ID 24315 //
     /* 1844121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1844124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1844138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844167 */     // MIs[0] policy
     /* 1844167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844177 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1844180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844201 */     // GIR_Coverage, 24315,
     /* 1844201 */     GIR_EraseRootFromParent_Done,
     /* 1844202 */   // Label 24836: @1844202
     /* 1844202 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1844288), // Rule ID 24318 //
     /* 1844207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1844210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844253 */     // MIs[0] policy
     /* 1844253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844263 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1844266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844287 */     // GIR_Coverage, 24318,
     /* 1844287 */     GIR_EraseRootFromParent_Done,
     /* 1844288 */   // Label 24837: @1844288
     /* 1844288 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1844374), // Rule ID 24319 //
     /* 1844293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1844296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844339 */     // MIs[0] policy
     /* 1844339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844349 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1844352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844373 */     // GIR_Coverage, 24319,
     /* 1844373 */     GIR_EraseRootFromParent_Done,
     /* 1844374 */   // Label 24838: @1844374
     /* 1844374 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1844460), // Rule ID 24322 //
     /* 1844379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1844382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1844396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844425 */     // MIs[0] policy
     /* 1844425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844435 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1844438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844459 */     // GIR_Coverage, 24322,
     /* 1844459 */     GIR_EraseRootFromParent_Done,
     /* 1844460 */   // Label 24839: @1844460
     /* 1844460 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1844546), // Rule ID 24323 //
     /* 1844465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1844468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1844482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1844485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1844507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844511 */     // MIs[0] policy
     /* 1844511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844521 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1844524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844545 */     // GIR_Coverage, 24323,
     /* 1844545 */     GIR_EraseRootFromParent_Done,
     /* 1844546 */   // Label 24840: @1844546
     /* 1844546 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1844632), // Rule ID 24326 //
     /* 1844551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1844554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1844568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1844571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1844593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844597 */     // MIs[0] policy
     /* 1844597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844607 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1844610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844631 */     // GIR_Coverage, 24326,
     /* 1844631 */     GIR_EraseRootFromParent_Done,
     /* 1844632 */   // Label 24841: @1844632
     /* 1844632 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1844718), // Rule ID 24327 //
     /* 1844637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1844640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1844654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1844657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1844679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844683 */     // MIs[0] policy
     /* 1844683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844693 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1844696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844717 */     // GIR_Coverage, 24327,
     /* 1844717 */     GIR_EraseRootFromParent_Done,
     /* 1844718 */   // Label 24842: @1844718
     /* 1844718 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1844804), // Rule ID 24330 //
     /* 1844723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1844726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1844740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1844743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1844765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844769 */     // MIs[0] policy
     /* 1844769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844779 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1844782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844803 */     // GIR_Coverage, 24330,
     /* 1844803 */     GIR_EraseRootFromParent_Done,
     /* 1844804 */   // Label 24843: @1844804
     /* 1844804 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1844890), // Rule ID 24331 //
     /* 1844809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1844812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1844826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1844829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1844851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844855 */     // MIs[0] policy
     /* 1844855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844865 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1844868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844889 */     // GIR_Coverage, 24331,
     /* 1844889 */     GIR_EraseRootFromParent_Done,
     /* 1844890 */   // Label 24844: @1844890
     /* 1844890 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1844976), // Rule ID 24334 //
     /* 1844895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1844898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1844912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1844915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1844937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844941 */     // MIs[0] policy
     /* 1844941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844951 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1844954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1844958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844975 */     // GIR_Coverage, 24334,
     /* 1844975 */     GIR_EraseRootFromParent_Done,
     /* 1844976 */   // Label 24845: @1844976
     /* 1844976 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1845062), // Rule ID 24335 //
     /* 1844981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1844984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1844989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1844998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1845001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1845023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845027 */     // MIs[0] policy
     /* 1845027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845037 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1845040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845061 */     // GIR_Coverage, 24335,
     /* 1845061 */     GIR_EraseRootFromParent_Done,
     /* 1845062 */   // Label 24846: @1845062
     /* 1845062 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1845148), // Rule ID 24338 //
     /* 1845067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1845070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1845084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845113 */     // MIs[0] policy
     /* 1845113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845123 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1845126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845147 */     // GIR_Coverage, 24338,
     /* 1845147 */     GIR_EraseRootFromParent_Done,
     /* 1845148 */   // Label 24847: @1845148
     /* 1845148 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1845234), // Rule ID 24339 //
     /* 1845153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1845156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1845170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845199 */     // MIs[0] policy
     /* 1845199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845209 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10963:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1845212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845233 */     // GIR_Coverage, 24339,
     /* 1845233 */     GIR_EraseRootFromParent_Done,
     /* 1845234 */   // Label 24848: @1845234
     /* 1845234 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1845320), // Rule ID 24342 //
     /* 1845239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1845242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1845256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845285 */     // MIs[0] policy
     /* 1845285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845295 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1845298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845319 */     // GIR_Coverage, 24342,
     /* 1845319 */     GIR_EraseRootFromParent_Done,
     /* 1845320 */   // Label 24849: @1845320
     /* 1845320 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1845406), // Rule ID 24343 //
     /* 1845325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1845328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1845342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845371 */     // MIs[0] policy
     /* 1845371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845381 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10963:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1845384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845405 */     // GIR_Coverage, 24343,
     /* 1845405 */     GIR_EraseRootFromParent_Done,
     /* 1845406 */   // Label 24850: @1845406
     /* 1845406 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1845492), // Rule ID 24346 //
     /* 1845411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1845414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1845428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845457 */     // MIs[0] policy
     /* 1845457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845467 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1845470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845491 */     // GIR_Coverage, 24346,
     /* 1845491 */     GIR_EraseRootFromParent_Done,
     /* 1845492 */   // Label 24851: @1845492
     /* 1845492 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1845578), // Rule ID 24347 //
     /* 1845497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1845500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1845505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1845514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1845517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1845539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845543 */     // MIs[0] policy
     /* 1845543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845553 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10963:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1845556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845577 */     // GIR_Coverage, 24347,
     /* 1845577 */     GIR_EraseRootFromParent_Done,
     /* 1845578 */   // Label 24852: @1845578
     /* 1845578 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1845664), // Rule ID 24350 //
     /* 1845583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1845591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1845594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1845597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845629 */     // MIs[0] policy
     /* 1845629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845639 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1845642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845663 */     // GIR_Coverage, 24350,
     /* 1845663 */     GIR_EraseRootFromParent_Done,
     /* 1845664 */   // Label 24853: @1845664
     /* 1845664 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1845750), // Rule ID 24351 //
     /* 1845669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1845677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1845680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1845683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845715 */     // MIs[0] policy
     /* 1845715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845725 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1845728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845749 */     // GIR_Coverage, 24351,
     /* 1845749 */     GIR_EraseRootFromParent_Done,
     /* 1845750 */   // Label 24854: @1845750
     /* 1845750 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1845836), // Rule ID 24354 //
     /* 1845755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1845763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1845766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1845769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845801 */     // MIs[0] policy
     /* 1845801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845811 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1845814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845835 */     // GIR_Coverage, 24354,
     /* 1845835 */     GIR_EraseRootFromParent_Done,
     /* 1845836 */   // Label 24855: @1845836
     /* 1845836 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1845922), // Rule ID 24355 //
     /* 1845841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1845849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1845852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1845855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845887 */     // MIs[0] policy
     /* 1845887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845897 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1845900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845921 */     // GIR_Coverage, 24355,
     /* 1845921 */     GIR_EraseRootFromParent_Done,
     /* 1845922 */   // Label 24856: @1845922
     /* 1845922 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1846008), // Rule ID 24358 //
     /* 1845927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1845935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1845938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1845941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1845944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845973 */     // MIs[0] policy
     /* 1845973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845983 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1845986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1845990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846007 */     // GIR_Coverage, 24358,
     /* 1846007 */     GIR_EraseRootFromParent_Done,
     /* 1846008 */   // Label 24857: @1846008
     /* 1846008 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1846094), // Rule ID 24359 //
     /* 1846013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1846024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1846027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1846030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846059 */     // MIs[0] policy
     /* 1846059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846069 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1846072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846093 */     // GIR_Coverage, 24359,
     /* 1846093 */     GIR_EraseRootFromParent_Done,
     /* 1846094 */   // Label 24858: @1846094
     /* 1846094 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1846180), // Rule ID 24362 //
     /* 1846099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1846110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846145 */     // MIs[0] policy
     /* 1846145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846155 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1846158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846179 */     // GIR_Coverage, 24362,
     /* 1846179 */     GIR_EraseRootFromParent_Done,
     /* 1846180 */   // Label 24859: @1846180
     /* 1846180 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1846266), // Rule ID 24363 //
     /* 1846185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1846196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846231 */     // MIs[0] policy
     /* 1846231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1846244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846265 */     // GIR_Coverage, 24363,
     /* 1846265 */     GIR_EraseRootFromParent_Done,
     /* 1846266 */   // Label 24860: @1846266
     /* 1846266 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1846352), // Rule ID 24366 //
     /* 1846271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846317 */     // MIs[0] policy
     /* 1846317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1846330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846351 */     // GIR_Coverage, 24366,
     /* 1846351 */     GIR_EraseRootFromParent_Done,
     /* 1846352 */   // Label 24861: @1846352
     /* 1846352 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1846438), // Rule ID 24367 //
     /* 1846357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846403 */     // MIs[0] policy
     /* 1846403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1846416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846437 */     // GIR_Coverage, 24367,
     /* 1846437 */     GIR_EraseRootFromParent_Done,
     /* 1846438 */   // Label 24862: @1846438
     /* 1846438 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1846524), // Rule ID 24370 //
     /* 1846443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1846460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1846463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846489 */     // MIs[0] policy
     /* 1846489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1846502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846523 */     // GIR_Coverage, 24370,
     /* 1846523 */     GIR_EraseRootFromParent_Done,
     /* 1846524 */   // Label 24863: @1846524
     /* 1846524 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1846610), // Rule ID 24371 //
     /* 1846529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1846546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1846549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846575 */     // MIs[0] policy
     /* 1846575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846585 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1846588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846609 */     // GIR_Coverage, 24371,
     /* 1846609 */     GIR_EraseRootFromParent_Done,
     /* 1846610 */   // Label 24864: @1846610
     /* 1846610 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1846696), // Rule ID 24374 //
     /* 1846615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1846626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1846629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846661 */     // MIs[0] policy
     /* 1846661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1846674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846695 */     // GIR_Coverage, 24374,
     /* 1846695 */     GIR_EraseRootFromParent_Done,
     /* 1846696 */   // Label 24865: @1846696
     /* 1846696 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1846782), // Rule ID 24375 //
     /* 1846701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1846712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1846715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846747 */     // MIs[0] policy
     /* 1846747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846757 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1846760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846781 */     // GIR_Coverage, 24375,
     /* 1846781 */     GIR_EraseRootFromParent_Done,
     /* 1846782 */   // Label 24866: @1846782
     /* 1846782 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1846868), // Rule ID 24378 //
     /* 1846787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846833 */     // MIs[0] policy
     /* 1846833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1846846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846867 */     // GIR_Coverage, 24378,
     /* 1846867 */     GIR_EraseRootFromParent_Done,
     /* 1846868 */   // Label 24867: @1846868
     /* 1846868 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1846954), // Rule ID 24379 //
     /* 1846873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846919 */     // MIs[0] policy
     /* 1846919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846929 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1846932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1846936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846953 */     // GIR_Coverage, 24379,
     /* 1846953 */     GIR_EraseRootFromParent_Done,
     /* 1846954 */   // Label 24868: @1846954
     /* 1846954 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1847040), // Rule ID 24382 //
     /* 1846959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1846967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1846976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1846979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847005 */     // MIs[0] policy
     /* 1847005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1847018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847039 */     // GIR_Coverage, 24382,
     /* 1847039 */     GIR_EraseRootFromParent_Done,
     /* 1847040 */   // Label 24869: @1847040
     /* 1847040 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1847126), // Rule ID 24383 //
     /* 1847045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847091 */     // MIs[0] policy
     /* 1847091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1847104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847125 */     // GIR_Coverage, 24383,
     /* 1847125 */     GIR_EraseRootFromParent_Done,
     /* 1847126 */   // Label 24870: @1847126
     /* 1847126 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1847212), // Rule ID 24386 //
     /* 1847131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1847134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1847148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1847151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847177 */     // MIs[0] policy
     /* 1847177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847187 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1847190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1847208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847211 */     // GIR_Coverage, 24386,
     /* 1847211 */     GIR_EraseRootFromParent_Done,
     /* 1847212 */   // Label 24871: @1847212
     /* 1847212 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1847298), // Rule ID 24387 //
     /* 1847217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1847220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1847234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1847237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847263 */     // MIs[0] policy
     /* 1847263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1847276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1847294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847297 */     // GIR_Coverage, 24387,
     /* 1847297 */     GIR_EraseRootFromParent_Done,
     /* 1847298 */   // Label 24872: @1847298
     /* 1847298 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1847384), // Rule ID 24390 //
     /* 1847303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1847314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1847317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1847320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847349 */     // MIs[0] policy
     /* 1847349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1847362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847383 */     // GIR_Coverage, 24390,
     /* 1847383 */     GIR_EraseRootFromParent_Done,
     /* 1847384 */   // Label 24873: @1847384
     /* 1847384 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1847470), // Rule ID 24391 //
     /* 1847389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1847400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1847403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1847406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847435 */     // MIs[0] policy
     /* 1847435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1847448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847469 */     // GIR_Coverage, 24391,
     /* 1847469 */     GIR_EraseRootFromParent_Done,
     /* 1847470 */   // Label 24874: @1847470
     /* 1847470 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1847556), // Rule ID 24394 //
     /* 1847475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1847486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1847489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1847492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847521 */     // MIs[0] policy
     /* 1847521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847531 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1847534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847555 */     // GIR_Coverage, 24394,
     /* 1847555 */     GIR_EraseRootFromParent_Done,
     /* 1847556 */   // Label 24875: @1847556
     /* 1847556 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1847642), // Rule ID 24395 //
     /* 1847561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1847572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1847575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1847578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847607 */     // MIs[0] policy
     /* 1847607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1847620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847641 */     // GIR_Coverage, 24395,
     /* 1847641 */     GIR_EraseRootFromParent_Done,
     /* 1847642 */   // Label 24876: @1847642
     /* 1847642 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1847728), // Rule ID 24398 //
     /* 1847647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1847658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1847661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1847664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1847667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1847670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847693 */     // MIs[0] policy
     /* 1847693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847703 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1847706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847727 */     // GIR_Coverage, 24398,
     /* 1847727 */     GIR_EraseRootFromParent_Done,
     /* 1847728 */   // Label 24877: @1847728
     /* 1847728 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1847814), // Rule ID 24399 //
     /* 1847733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1847744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1847747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1847750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1847753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1847756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847779 */     // MIs[0] policy
     /* 1847779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1847792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847813 */     // GIR_Coverage, 24399,
     /* 1847813 */     GIR_EraseRootFromParent_Done,
     /* 1847814 */   // Label 24878: @1847814
     /* 1847814 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1847900), // Rule ID 24402 //
     /* 1847819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847865 */     // MIs[0] policy
     /* 1847865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1847878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847899 */     // GIR_Coverage, 24402,
     /* 1847899 */     GIR_EraseRootFromParent_Done,
     /* 1847900 */   // Label 24879: @1847900
     /* 1847900 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1847986), // Rule ID 24403 //
     /* 1847905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847951 */     // MIs[0] policy
     /* 1847951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1847964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1847968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847985 */     // GIR_Coverage, 24403,
     /* 1847985 */     GIR_EraseRootFromParent_Done,
     /* 1847986 */   // Label 24880: @1847986
     /* 1847986 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1848072), // Rule ID 24406 //
     /* 1847991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1847999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1848008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1848011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848037 */     // MIs[0] policy
     /* 1848037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848047 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1848050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848071 */     // GIR_Coverage, 24406,
     /* 1848071 */     GIR_EraseRootFromParent_Done,
     /* 1848072 */   // Label 24881: @1848072
     /* 1848072 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1848158), // Rule ID 24407 //
     /* 1848077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1848094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1848097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848123 */     // MIs[0] policy
     /* 1848123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848133 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1848136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848157 */     // GIR_Coverage, 24407,
     /* 1848157 */     GIR_EraseRootFromParent_Done,
     /* 1848158 */   // Label 24882: @1848158
     /* 1848158 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1848244), // Rule ID 24410 //
     /* 1848163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1848180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1848183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848209 */     // MIs[0] policy
     /* 1848209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848219 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1848222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848243 */     // GIR_Coverage, 24410,
     /* 1848243 */     GIR_EraseRootFromParent_Done,
     /* 1848244 */   // Label 24883: @1848244
     /* 1848244 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1848330), // Rule ID 24411 //
     /* 1848249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1848266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1848269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848295 */     // MIs[0] policy
     /* 1848295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848305 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1848308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848329 */     // GIR_Coverage, 24411,
     /* 1848329 */     GIR_EraseRootFromParent_Done,
     /* 1848330 */   // Label 24884: @1848330
     /* 1848330 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1848416), // Rule ID 24414 //
     /* 1848335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1848346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1848349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848381 */     // MIs[0] policy
     /* 1848381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1848394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848415 */     // GIR_Coverage, 24414,
     /* 1848415 */     GIR_EraseRootFromParent_Done,
     /* 1848416 */   // Label 24885: @1848416
     /* 1848416 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1848502), // Rule ID 24415 //
     /* 1848421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1848432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1848435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848467 */     // MIs[0] policy
     /* 1848467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1848480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848501 */     // GIR_Coverage, 24415,
     /* 1848501 */     GIR_EraseRootFromParent_Done,
     /* 1848502 */   // Label 24886: @1848502
     /* 1848502 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1848588), // Rule ID 24418 //
     /* 1848507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848553 */     // MIs[0] policy
     /* 1848553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1848566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848587 */     // GIR_Coverage, 24418,
     /* 1848587 */     GIR_EraseRootFromParent_Done,
     /* 1848588 */   // Label 24887: @1848588
     /* 1848588 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1848674), // Rule ID 24419 //
     /* 1848593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848639 */     // MIs[0] policy
     /* 1848639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848649 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1848652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848673 */     // GIR_Coverage, 24419,
     /* 1848673 */     GIR_EraseRootFromParent_Done,
     /* 1848674 */   // Label 24888: @1848674
     /* 1848674 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1848760), // Rule ID 24422 //
     /* 1848679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1848696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1848699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848725 */     // MIs[0] policy
     /* 1848725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1848738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848759 */     // GIR_Coverage, 24422,
     /* 1848759 */     GIR_EraseRootFromParent_Done,
     /* 1848760 */   // Label 24889: @1848760
     /* 1848760 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1848846), // Rule ID 24423 //
     /* 1848765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1848782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1848785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848811 */     // MIs[0] policy
     /* 1848811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848821 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1848824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848845 */     // GIR_Coverage, 24423,
     /* 1848845 */     GIR_EraseRootFromParent_Done,
     /* 1848846 */   // Label 24890: @1848846
     /* 1848846 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1848932), // Rule ID 24426 //
     /* 1848851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1848854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1848868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1848871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848897 */     // MIs[0] policy
     /* 1848897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1848910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1848914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1848928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848931 */     // GIR_Coverage, 24426,
     /* 1848931 */     GIR_EraseRootFromParent_Done,
     /* 1848932 */   // Label 24891: @1848932
     /* 1848932 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1849018), // Rule ID 24427 //
     /* 1848937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1848940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1848945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1848954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1848957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848983 */     // MIs[0] policy
     /* 1848983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1848996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849017 */     // GIR_Coverage, 24427,
     /* 1849017 */     GIR_EraseRootFromParent_Done,
     /* 1849018 */   // Label 24892: @1849018
     /* 1849018 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1849104), // Rule ID 24430 //
     /* 1849023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1849026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1849031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1849034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1849037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1849040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1849043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849069 */     // MIs[0] policy
     /* 1849069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849079 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1849082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849103 */     // GIR_Coverage, 24430,
     /* 1849103 */     GIR_EraseRootFromParent_Done,
     /* 1849104 */   // Label 24893: @1849104
     /* 1849104 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1849190), // Rule ID 24431 //
     /* 1849109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1849112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1849117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1849120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1849123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1849126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1849129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849155 */     // MIs[0] policy
     /* 1849155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849165 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1849168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849189 */     // GIR_Coverage, 24431,
     /* 1849189 */     GIR_EraseRootFromParent_Done,
     /* 1849190 */   // Label 24894: @1849190
     /* 1849190 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1849276), // Rule ID 24434 //
     /* 1849195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1849198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1849203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1849206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1849209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1849212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1849215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849241 */     // MIs[0] policy
     /* 1849241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1849254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849275 */     // GIR_Coverage, 24434,
     /* 1849275 */     GIR_EraseRootFromParent_Done,
     /* 1849276 */   // Label 24895: @1849276
     /* 1849276 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1849362), // Rule ID 24435 //
     /* 1849281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1849284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1849289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1849292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1849295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1849298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1849301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849327 */     // MIs[0] policy
     /* 1849327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849337 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1849340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849361 */     // GIR_Coverage, 24435,
     /* 1849361 */     GIR_EraseRootFromParent_Done,
     /* 1849362 */   // Label 24896: @1849362
     /* 1849362 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1849448), // Rule ID 24438 //
     /* 1849367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1849378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1849381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1849387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849413 */     // MIs[0] policy
     /* 1849413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849423 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1849426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849447 */     // GIR_Coverage, 24438,
     /* 1849447 */     GIR_EraseRootFromParent_Done,
     /* 1849448 */   // Label 24897: @1849448
     /* 1849448 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1849534), // Rule ID 24439 //
     /* 1849453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1849464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1849467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1849473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849499 */     // MIs[0] policy
     /* 1849499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849509 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1849512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849533 */     // GIR_Coverage, 24439,
     /* 1849533 */     GIR_EraseRootFromParent_Done,
     /* 1849534 */   // Label 24898: @1849534
     /* 1849534 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1849620), // Rule ID 24442 //
     /* 1849539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1849550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1849553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1849559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849585 */     // MIs[0] policy
     /* 1849585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849595 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1849598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849619 */     // GIR_Coverage, 24442,
     /* 1849619 */     GIR_EraseRootFromParent_Done,
     /* 1849620 */   // Label 24899: @1849620
     /* 1849620 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1849706), // Rule ID 24443 //
     /* 1849625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1849636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1849639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1849645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849671 */     // MIs[0] policy
     /* 1849671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849681 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1849684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849705 */     // GIR_Coverage, 24443,
     /* 1849705 */     GIR_EraseRootFromParent_Done,
     /* 1849706 */   // Label 24900: @1849706
     /* 1849706 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1849792), // Rule ID 24446 //
     /* 1849711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1849722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1849725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1849731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849757 */     // MIs[0] policy
     /* 1849757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849767 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1849770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849791 */     // GIR_Coverage, 24446,
     /* 1849791 */     GIR_EraseRootFromParent_Done,
     /* 1849792 */   // Label 24901: @1849792
     /* 1849792 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1849878), // Rule ID 24447 //
     /* 1849797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1849808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1849811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1849817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849843 */     // MIs[0] policy
     /* 1849843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849853 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1849856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849877 */     // GIR_Coverage, 24447,
     /* 1849877 */     GIR_EraseRootFromParent_Done,
     /* 1849878 */   // Label 24902: @1849878
     /* 1849878 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1849964), // Rule ID 24450 //
     /* 1849883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1849900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1849903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849929 */     // MIs[0] policy
     /* 1849929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1849942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1849946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849963 */     // GIR_Coverage, 24450,
     /* 1849963 */     GIR_EraseRootFromParent_Done,
     /* 1849964 */   // Label 24903: @1849964
     /* 1849964 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1850050), // Rule ID 24451 //
     /* 1849969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1849977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1849986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1849989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850015 */     // MIs[0] policy
     /* 1850015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850025 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1850028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850049 */     // GIR_Coverage, 24451,
     /* 1850049 */     GIR_EraseRootFromParent_Done,
     /* 1850050 */   // Label 24904: @1850050
     /* 1850050 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1850136), // Rule ID 24454 //
     /* 1850055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850101 */     // MIs[0] policy
     /* 1850101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1850114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850135 */     // GIR_Coverage, 24454,
     /* 1850135 */     GIR_EraseRootFromParent_Done,
     /* 1850136 */   // Label 24905: @1850136
     /* 1850136 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1850222), // Rule ID 24455 //
     /* 1850141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1850161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850187 */     // MIs[0] policy
     /* 1850187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850197 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1850200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850221 */     // GIR_Coverage, 24455,
     /* 1850221 */     GIR_EraseRootFromParent_Done,
     /* 1850222 */   // Label 24906: @1850222
     /* 1850222 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1850308), // Rule ID 24458 //
     /* 1850227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1850244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850273 */     // MIs[0] policy
     /* 1850273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850283 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1850286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850307 */     // GIR_Coverage, 24458,
     /* 1850307 */     GIR_EraseRootFromParent_Done,
     /* 1850308 */   // Label 24907: @1850308
     /* 1850308 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1850394), // Rule ID 24459 //
     /* 1850313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1850330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1850333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850359 */     // MIs[0] policy
     /* 1850359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1850372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850393 */     // GIR_Coverage, 24459,
     /* 1850393 */     GIR_EraseRootFromParent_Done,
     /* 1850394 */   // Label 24908: @1850394
     /* 1850394 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1850480), // Rule ID 24462 //
     /* 1850399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1850410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1850413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1850416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850445 */     // MIs[0] policy
     /* 1850445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850455 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850479 */     // GIR_Coverage, 24462,
     /* 1850479 */     GIR_EraseRootFromParent_Done,
     /* 1850480 */   // Label 24909: @1850480
     /* 1850480 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1850566), // Rule ID 24463 //
     /* 1850485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1850496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1850499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1850502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1850505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850531 */     // MIs[0] policy
     /* 1850531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850541 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850565 */     // GIR_Coverage, 24463,
     /* 1850565 */     GIR_EraseRootFromParent_Done,
     /* 1850566 */   // Label 24910: @1850566
     /* 1850566 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1850652), // Rule ID 24466 //
     /* 1850571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1850582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1850585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850617 */     // MIs[0] policy
     /* 1850617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850651 */     // GIR_Coverage, 24466,
     /* 1850651 */     GIR_EraseRootFromParent_Done,
     /* 1850652 */   // Label 24911: @1850652
     /* 1850652 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1850738), // Rule ID 24467 //
     /* 1850657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1850668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1850671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1850677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850703 */     // MIs[0] policy
     /* 1850703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850713 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850737 */     // GIR_Coverage, 24467,
     /* 1850737 */     GIR_EraseRootFromParent_Done,
     /* 1850738 */   // Label 24912: @1850738
     /* 1850738 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1850824), // Rule ID 24470 //
     /* 1850743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1850760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850789 */     // MIs[0] policy
     /* 1850789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850823 */     // GIR_Coverage, 24470,
     /* 1850823 */     GIR_EraseRootFromParent_Done,
     /* 1850824 */   // Label 24913: @1850824
     /* 1850824 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1850910), // Rule ID 24471 //
     /* 1850829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1850846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1850849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850875 */     // MIs[0] policy
     /* 1850875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850885 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850909 */     // GIR_Coverage, 24471,
     /* 1850909 */     GIR_EraseRootFromParent_Done,
     /* 1850910 */   // Label 24914: @1850910
     /* 1850910 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1850996), // Rule ID 24474 //
     /* 1850915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1850918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1850923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1850932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1850935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850961 */     // MIs[0] policy
     /* 1850961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850971 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1850974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1850978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1850992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850995 */     // GIR_Coverage, 24474,
     /* 1850995 */     GIR_EraseRootFromParent_Done,
     /* 1850996 */   // Label 24915: @1850996
     /* 1850996 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1851082), // Rule ID 24475 //
     /* 1851001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1851004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1851012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1851015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1851018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851047 */     // MIs[0] policy
     /* 1851047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1851060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1851078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851081 */     // GIR_Coverage, 24475,
     /* 1851081 */     GIR_EraseRootFromParent_Done,
     /* 1851082 */   // Label 24916: @1851082
     /* 1851082 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1851168), // Rule ID 24478 //
     /* 1851087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1851098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1851101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851133 */     // MIs[0] policy
     /* 1851133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1851146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851167 */     // GIR_Coverage, 24478,
     /* 1851167 */     GIR_EraseRootFromParent_Done,
     /* 1851168 */   // Label 24917: @1851168
     /* 1851168 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1851254), // Rule ID 24479 //
     /* 1851173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1851184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1851187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851219 */     // MIs[0] policy
     /* 1851219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851229 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1851232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851253 */     // GIR_Coverage, 24479,
     /* 1851253 */     GIR_EraseRootFromParent_Done,
     /* 1851254 */   // Label 24918: @1851254
     /* 1851254 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1851340), // Rule ID 24482 //
     /* 1851259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1851270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1851273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851305 */     // MIs[0] policy
     /* 1851305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851315 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1851318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851339 */     // GIR_Coverage, 24482,
     /* 1851339 */     GIR_EraseRootFromParent_Done,
     /* 1851340 */   // Label 24919: @1851340
     /* 1851340 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1851426), // Rule ID 24483 //
     /* 1851345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1851356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1851359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851391 */     // MIs[0] policy
     /* 1851391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851401 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1851404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851425 */     // GIR_Coverage, 24483,
     /* 1851425 */     GIR_EraseRootFromParent_Done,
     /* 1851426 */   // Label 24920: @1851426
     /* 1851426 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1851512), // Rule ID 24486 //
     /* 1851431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1851442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1851445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1851448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1851454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851477 */     // MIs[0] policy
     /* 1851477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851487 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1851490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851511 */     // GIR_Coverage, 24486,
     /* 1851511 */     GIR_EraseRootFromParent_Done,
     /* 1851512 */   // Label 24921: @1851512
     /* 1851512 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1851598), // Rule ID 24487 //
     /* 1851517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1851528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1851531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1851534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1851540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851563 */     // MIs[0] policy
     /* 1851563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851573 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1851576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851597 */     // GIR_Coverage, 24487,
     /* 1851597 */     GIR_EraseRootFromParent_Done,
     /* 1851598 */   // Label 24922: @1851598
     /* 1851598 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1851684), // Rule ID 24490 //
     /* 1851603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1851620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851649 */     // MIs[0] policy
     /* 1851649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1851662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851683 */     // GIR_Coverage, 24490,
     /* 1851683 */     GIR_EraseRootFromParent_Done,
     /* 1851684 */   // Label 24923: @1851684
     /* 1851684 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1851770), // Rule ID 24491 //
     /* 1851689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1851706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851735 */     // MIs[0] policy
     /* 1851735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1851748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851769 */     // GIR_Coverage, 24491,
     /* 1851769 */     GIR_EraseRootFromParent_Done,
     /* 1851770 */   // Label 24924: @1851770
     /* 1851770 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1851856), // Rule ID 24494 //
     /* 1851775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1851792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851821 */     // MIs[0] policy
     /* 1851821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851831 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1851834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851855 */     // GIR_Coverage, 24494,
     /* 1851855 */     GIR_EraseRootFromParent_Done,
     /* 1851856 */   // Label 24925: @1851856
     /* 1851856 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1851942), // Rule ID 24495 //
     /* 1851861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1851878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1851881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851907 */     // MIs[0] policy
     /* 1851907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1851920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1851924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851941 */     // GIR_Coverage, 24495,
     /* 1851941 */     GIR_EraseRootFromParent_Done,
     /* 1851942 */   // Label 24926: @1851942
     /* 1851942 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1852028), // Rule ID 24498 //
     /* 1851947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1851955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1851964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1851967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851993 */     // MIs[0] policy
     /* 1851993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852003 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1852006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852027 */     // GIR_Coverage, 24498,
     /* 1852027 */     GIR_EraseRootFromParent_Done,
     /* 1852028 */   // Label 24927: @1852028
     /* 1852028 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1852114), // Rule ID 24499 //
     /* 1852033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1852050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852079 */     // MIs[0] policy
     /* 1852079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1852092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852113 */     // GIR_Coverage, 24499,
     /* 1852113 */     GIR_EraseRootFromParent_Done,
     /* 1852114 */   // Label 24928: @1852114
     /* 1852114 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1852200), // Rule ID 24502 //
     /* 1852119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852165 */     // MIs[0] policy
     /* 1852165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1852178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852199 */     // GIR_Coverage, 24502,
     /* 1852199 */     GIR_EraseRootFromParent_Done,
     /* 1852200 */   // Label 24929: @1852200
     /* 1852200 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1852286), // Rule ID 24503 //
     /* 1852205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852251 */     // MIs[0] policy
     /* 1852251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1852264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852285 */     // GIR_Coverage, 24503,
     /* 1852285 */     GIR_EraseRootFromParent_Done,
     /* 1852286 */   // Label 24930: @1852286
     /* 1852286 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1852372), // Rule ID 24506 //
     /* 1852291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1852308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852337 */     // MIs[0] policy
     /* 1852337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852347 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1852350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852371 */     // GIR_Coverage, 24506,
     /* 1852371 */     GIR_EraseRootFromParent_Done,
     /* 1852372 */   // Label 24931: @1852372
     /* 1852372 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1852458), // Rule ID 24507 //
     /* 1852377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1852394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852423 */     // MIs[0] policy
     /* 1852423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852433 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1852436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852457 */     // GIR_Coverage, 24507,
     /* 1852457 */     GIR_EraseRootFromParent_Done,
     /* 1852458 */   // Label 24932: @1852458
     /* 1852458 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1852544), // Rule ID 24510 //
     /* 1852463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1852480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852509 */     // MIs[0] policy
     /* 1852509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1852522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852543 */     // GIR_Coverage, 24510,
     /* 1852543 */     GIR_EraseRootFromParent_Done,
     /* 1852544 */   // Label 24933: @1852544
     /* 1852544 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1852630), // Rule ID 24511 //
     /* 1852549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1852566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852595 */     // MIs[0] policy
     /* 1852595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852605 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1852608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852629 */     // GIR_Coverage, 24511,
     /* 1852629 */     GIR_EraseRootFromParent_Done,
     /* 1852630 */   // Label 24934: @1852630
     /* 1852630 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1852716), // Rule ID 24514 //
     /* 1852635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1852638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1852652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852681 */     // MIs[0] policy
     /* 1852681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1852694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1852712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852715 */     // GIR_Coverage, 24514,
     /* 1852715 */     GIR_EraseRootFromParent_Done,
     /* 1852716 */   // Label 24935: @1852716
     /* 1852716 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1852802), // Rule ID 24515 //
     /* 1852721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1852724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1852738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852767 */     // MIs[0] policy
     /* 1852767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1852780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1852798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852801 */     // GIR_Coverage, 24515,
     /* 1852801 */     GIR_EraseRootFromParent_Done,
     /* 1852802 */   // Label 24936: @1852802
     /* 1852802 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1852888), // Rule ID 24518 //
     /* 1852807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1852810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1852824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852853 */     // MIs[0] policy
     /* 1852853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852863 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1852866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1852884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852887 */     // GIR_Coverage, 24518,
     /* 1852887 */     GIR_EraseRootFromParent_Done,
     /* 1852888 */   // Label 24937: @1852888
     /* 1852888 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1852974), // Rule ID 24519 //
     /* 1852893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1852896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1852910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1852913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852939 */     // MIs[0] policy
     /* 1852939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1852952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1852956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1852970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852973 */     // GIR_Coverage, 24519,
     /* 1852973 */     GIR_EraseRootFromParent_Done,
     /* 1852974 */   // Label 24938: @1852974
     /* 1852974 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1853060), // Rule ID 24522 //
     /* 1852979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1852982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1852987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1852990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1852993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1852996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1852999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853025 */     // MIs[0] policy
     /* 1853025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853035 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1853038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1853056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853059 */     // GIR_Coverage, 24522,
     /* 1853059 */     GIR_EraseRootFromParent_Done,
     /* 1853060 */   // Label 24939: @1853060
     /* 1853060 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1853146), // Rule ID 24523 //
     /* 1853065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1853068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1853073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1853082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1853085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853111 */     // MIs[0] policy
     /* 1853111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1853124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1853142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853145 */     // GIR_Coverage, 24523,
     /* 1853145 */     GIR_EraseRootFromParent_Done,
     /* 1853146 */   // Label 24940: @1853146
     /* 1853146 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1853232), // Rule ID 24614 //
     /* 1853151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1853162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1853165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1853168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1853171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853197 */     // MIs[0] policy
     /* 1853197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853207 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1853210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853231 */     // GIR_Coverage, 24614,
     /* 1853231 */     GIR_EraseRootFromParent_Done,
     /* 1853232 */   // Label 24941: @1853232
     /* 1853232 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1853318), // Rule ID 24615 //
     /* 1853237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1853248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1853251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1853254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1853257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853283 */     // MIs[0] policy
     /* 1853283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1853296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853317 */     // GIR_Coverage, 24615,
     /* 1853317 */     GIR_EraseRootFromParent_Done,
     /* 1853318 */   // Label 24942: @1853318
     /* 1853318 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1853404), // Rule ID 24618 //
     /* 1853323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1853334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1853337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1853340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853369 */     // MIs[0] policy
     /* 1853369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853379 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1853382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853403 */     // GIR_Coverage, 24618,
     /* 1853403 */     GIR_EraseRootFromParent_Done,
     /* 1853404 */   // Label 24943: @1853404
     /* 1853404 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1853490), // Rule ID 24619 //
     /* 1853409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1853420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1853423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1853426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853455 */     // MIs[0] policy
     /* 1853455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853465 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1853468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853489 */     // GIR_Coverage, 24619,
     /* 1853489 */     GIR_EraseRootFromParent_Done,
     /* 1853490 */   // Label 24944: @1853490
     /* 1853490 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1853576), // Rule ID 24622 //
     /* 1853495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1853506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1853509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1853512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853541 */     // MIs[0] policy
     /* 1853541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853551 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1853554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853575 */     // GIR_Coverage, 24622,
     /* 1853575 */     GIR_EraseRootFromParent_Done,
     /* 1853576 */   // Label 24945: @1853576
     /* 1853576 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1853662), // Rule ID 24623 //
     /* 1853581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1853592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1853595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1853598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853627 */     // MIs[0] policy
     /* 1853627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853637 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1853640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853661 */     // GIR_Coverage, 24623,
     /* 1853661 */     GIR_EraseRootFromParent_Done,
     /* 1853662 */   // Label 24946: @1853662
     /* 1853662 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1853748), // Rule ID 24626 //
     /* 1853667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1853684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1853687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853713 */     // MIs[0] policy
     /* 1853713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853723 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1853726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853747 */     // GIR_Coverage, 24626,
     /* 1853747 */     GIR_EraseRootFromParent_Done,
     /* 1853748 */   // Label 24947: @1853748
     /* 1853748 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1853834), // Rule ID 24627 //
     /* 1853753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1853770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1853773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853799 */     // MIs[0] policy
     /* 1853799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1853812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853833 */     // GIR_Coverage, 24627,
     /* 1853833 */     GIR_EraseRootFromParent_Done,
     /* 1853834 */   // Label 24948: @1853834
     /* 1853834 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1853920), // Rule ID 24630 //
     /* 1853839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1853856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853885 */     // MIs[0] policy
     /* 1853885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853895 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1853898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853919 */     // GIR_Coverage, 24630,
     /* 1853919 */     GIR_EraseRootFromParent_Done,
     /* 1853920 */   // Label 24949: @1853920
     /* 1853920 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1854006), // Rule ID 24631 //
     /* 1853925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1853933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1853942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853971 */     // MIs[0] policy
     /* 1853971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853981 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1853984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1853988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854005 */     // GIR_Coverage, 24631,
     /* 1854005 */     GIR_EraseRootFromParent_Done,
     /* 1854006 */   // Label 24950: @1854006
     /* 1854006 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1854092), // Rule ID 24634 //
     /* 1854011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1854028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854057 */     // MIs[0] policy
     /* 1854057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854067 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1854070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854091 */     // GIR_Coverage, 24634,
     /* 1854091 */     GIR_EraseRootFromParent_Done,
     /* 1854092 */   // Label 24951: @1854092
     /* 1854092 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1854178), // Rule ID 24635 //
     /* 1854097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1854114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854143 */     // MIs[0] policy
     /* 1854143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854153 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1854156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854177 */     // GIR_Coverage, 24635,
     /* 1854177 */     GIR_EraseRootFromParent_Done,
     /* 1854178 */   // Label 24952: @1854178
     /* 1854178 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1854264), // Rule ID 24638 //
     /* 1854183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1854194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1854197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1854200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854229 */     // MIs[0] policy
     /* 1854229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854239 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1854242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854263 */     // GIR_Coverage, 24638,
     /* 1854263 */     GIR_EraseRootFromParent_Done,
     /* 1854264 */   // Label 24953: @1854264
     /* 1854264 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1854350), // Rule ID 24639 //
     /* 1854269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1854280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1854283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1854286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854315 */     // MIs[0] policy
     /* 1854315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1854328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854349 */     // GIR_Coverage, 24639,
     /* 1854349 */     GIR_EraseRootFromParent_Done,
     /* 1854350 */   // Label 24954: @1854350
     /* 1854350 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1854436), // Rule ID 24642 //
     /* 1854355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1854372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854401 */     // MIs[0] policy
     /* 1854401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854411 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1854414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854435 */     // GIR_Coverage, 24642,
     /* 1854435 */     GIR_EraseRootFromParent_Done,
     /* 1854436 */   // Label 24955: @1854436
     /* 1854436 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1854522), // Rule ID 24643 //
     /* 1854441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1854458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854487 */     // MIs[0] policy
     /* 1854487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1854500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854521 */     // GIR_Coverage, 24643,
     /* 1854521 */     GIR_EraseRootFromParent_Done,
     /* 1854522 */   // Label 24956: @1854522
     /* 1854522 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1854608), // Rule ID 24646 //
     /* 1854527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1854544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854573 */     // MIs[0] policy
     /* 1854573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1854586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854607 */     // GIR_Coverage, 24646,
     /* 1854607 */     GIR_EraseRootFromParent_Done,
     /* 1854608 */   // Label 24957: @1854608
     /* 1854608 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1854694), // Rule ID 24647 //
     /* 1854613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1854630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854659 */     // MIs[0] policy
     /* 1854659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854669 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1854672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854693 */     // GIR_Coverage, 24647,
     /* 1854693 */     GIR_EraseRootFromParent_Done,
     /* 1854694 */   // Label 24958: @1854694
     /* 1854694 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1854780), // Rule ID 24650 //
     /* 1854699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1854702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1854710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1854713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1854716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854745 */     // MIs[0] policy
     /* 1854745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854755 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1854758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1854776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854779 */     // GIR_Coverage, 24650,
     /* 1854779 */     GIR_EraseRootFromParent_Done,
     /* 1854780 */   // Label 24959: @1854780
     /* 1854780 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1854866), // Rule ID 24651 //
     /* 1854785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1854788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1854796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1854799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1854802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854831 */     // MIs[0] policy
     /* 1854831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854841 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1854844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1854862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854865 */     // GIR_Coverage, 24651,
     /* 1854865 */     GIR_EraseRootFromParent_Done,
     /* 1854866 */   // Label 24960: @1854866
     /* 1854866 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1854952), // Rule ID 24654 //
     /* 1854871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1854882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1854885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1854888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854917 */     // MIs[0] policy
     /* 1854917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1854930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1854934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854951 */     // GIR_Coverage, 24654,
     /* 1854951 */     GIR_EraseRootFromParent_Done,
     /* 1854952 */   // Label 24961: @1854952
     /* 1854952 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1855038), // Rule ID 24655 //
     /* 1854957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1854965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1854968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1854971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1854974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855003 */     // MIs[0] policy
     /* 1855003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855013 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1855016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855037 */     // GIR_Coverage, 24655,
     /* 1855037 */     GIR_EraseRootFromParent_Done,
     /* 1855038 */   // Label 24962: @1855038
     /* 1855038 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1855124), // Rule ID 24658 //
     /* 1855043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1855054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1855057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1855060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1855063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855089 */     // MIs[0] policy
     /* 1855089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855099 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1855102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855123 */     // GIR_Coverage, 24658,
     /* 1855123 */     GIR_EraseRootFromParent_Done,
     /* 1855124 */   // Label 24963: @1855124
     /* 1855124 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1855210), // Rule ID 24659 //
     /* 1855129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1855140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1855143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1855146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1855149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855175 */     // MIs[0] policy
     /* 1855175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855185 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1855188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855209 */     // GIR_Coverage, 24659,
     /* 1855209 */     GIR_EraseRootFromParent_Done,
     /* 1855210 */   // Label 24964: @1855210
     /* 1855210 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1855296), // Rule ID 24662 //
     /* 1855215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1855226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1855229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1855232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855261 */     // MIs[0] policy
     /* 1855261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1855274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855295 */     // GIR_Coverage, 24662,
     /* 1855295 */     GIR_EraseRootFromParent_Done,
     /* 1855296 */   // Label 24965: @1855296
     /* 1855296 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1855382), // Rule ID 24663 //
     /* 1855301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1855312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1855315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1855318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855347 */     // MIs[0] policy
     /* 1855347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1855360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855381 */     // GIR_Coverage, 24663,
     /* 1855381 */     GIR_EraseRootFromParent_Done,
     /* 1855382 */   // Label 24966: @1855382
     /* 1855382 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1855468), // Rule ID 24666 //
     /* 1855387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1855404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855433 */     // MIs[0] policy
     /* 1855433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1855446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855467 */     // GIR_Coverage, 24666,
     /* 1855467 */     GIR_EraseRootFromParent_Done,
     /* 1855468 */   // Label 24967: @1855468
     /* 1855468 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1855554), // Rule ID 24667 //
     /* 1855473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1855490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855519 */     // MIs[0] policy
     /* 1855519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1855532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855553 */     // GIR_Coverage, 24667,
     /* 1855553 */     GIR_EraseRootFromParent_Done,
     /* 1855554 */   // Label 24968: @1855554
     /* 1855554 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1855640), // Rule ID 24670 //
     /* 1855559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1855576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1855579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855605 */     // MIs[0] policy
     /* 1855605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855615 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1855618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855639 */     // GIR_Coverage, 24670,
     /* 1855639 */     GIR_EraseRootFromParent_Done,
     /* 1855640 */   // Label 24969: @1855640
     /* 1855640 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1855726), // Rule ID 24671 //
     /* 1855645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1855662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1855665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855691 */     // MIs[0] policy
     /* 1855691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855701 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1855704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855725 */     // GIR_Coverage, 24671,
     /* 1855725 */     GIR_EraseRootFromParent_Done,
     /* 1855726 */   // Label 24970: @1855726
     /* 1855726 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1855812), // Rule ID 24674 //
     /* 1855731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1855748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855777 */     // MIs[0] policy
     /* 1855777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1855790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855811 */     // GIR_Coverage, 24674,
     /* 1855811 */     GIR_EraseRootFromParent_Done,
     /* 1855812 */   // Label 24971: @1855812
     /* 1855812 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1855898), // Rule ID 24675 //
     /* 1855817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1855834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855863 */     // MIs[0] policy
     /* 1855863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1855876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855897 */     // GIR_Coverage, 24675,
     /* 1855897 */     GIR_EraseRootFromParent_Done,
     /* 1855898 */   // Label 24972: @1855898
     /* 1855898 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1855984), // Rule ID 24678 //
     /* 1855903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1855920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855949 */     // MIs[0] policy
     /* 1855949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855959 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1855962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1855966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855983 */     // GIR_Coverage, 24678,
     /* 1855983 */     GIR_EraseRootFromParent_Done,
     /* 1855984 */   // Label 24973: @1855984
     /* 1855984 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1856070), // Rule ID 24679 //
     /* 1855989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1855997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1856000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1856003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1856006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1856009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856035 */     // MIs[0] policy
     /* 1856035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856045 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1856048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856069 */     // GIR_Coverage, 24679,
     /* 1856069 */     GIR_EraseRootFromParent_Done,
     /* 1856070 */   // Label 24974: @1856070
     /* 1856070 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1856156), // Rule ID 24682 //
     /* 1856075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1856092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856121 */     // MIs[0] policy
     /* 1856121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1856134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856155 */     // GIR_Coverage, 24682,
     /* 1856155 */     GIR_EraseRootFromParent_Done,
     /* 1856156 */   // Label 24975: @1856156
     /* 1856156 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1856242), // Rule ID 24683 //
     /* 1856161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1856178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856207 */     // MIs[0] policy
     /* 1856207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856217 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1856220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856241 */     // GIR_Coverage, 24683,
     /* 1856241 */     GIR_EraseRootFromParent_Done,
     /* 1856242 */   // Label 24976: @1856242
     /* 1856242 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1856328), // Rule ID 24686 //
     /* 1856247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1856264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1856267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856293 */     // MIs[0] policy
     /* 1856293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1856306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856327 */     // GIR_Coverage, 24686,
     /* 1856327 */     GIR_EraseRootFromParent_Done,
     /* 1856328 */   // Label 24977: @1856328
     /* 1856328 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1856414), // Rule ID 24687 //
     /* 1856333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1856350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1856353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856379 */     // MIs[0] policy
     /* 1856379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1856392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856413 */     // GIR_Coverage, 24687,
     /* 1856413 */     GIR_EraseRootFromParent_Done,
     /* 1856414 */   // Label 24978: @1856414
     /* 1856414 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1856500), // Rule ID 24690 //
     /* 1856419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1856436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1856439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856465 */     // MIs[0] policy
     /* 1856465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856475 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1856478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856499 */     // GIR_Coverage, 24690,
     /* 1856499 */     GIR_EraseRootFromParent_Done,
     /* 1856500 */   // Label 24979: @1856500
     /* 1856500 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1856586), // Rule ID 24691 //
     /* 1856505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1856522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1856525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856551 */     // MIs[0] policy
     /* 1856551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856561 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1856564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856585 */     // GIR_Coverage, 24691,
     /* 1856585 */     GIR_EraseRootFromParent_Done,
     /* 1856586 */   // Label 24980: @1856586
     /* 1856586 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1856672), // Rule ID 24694 //
     /* 1856591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1856608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1856611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856637 */     // MIs[0] policy
     /* 1856637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856647 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1856650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856671 */     // GIR_Coverage, 24694,
     /* 1856671 */     GIR_EraseRootFromParent_Done,
     /* 1856672 */   // Label 24981: @1856672
     /* 1856672 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1856758), // Rule ID 24695 //
     /* 1856677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1856685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1856694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1856697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856723 */     // MIs[0] policy
     /* 1856723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856733 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1856736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1856754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856757 */     // GIR_Coverage, 24695,
     /* 1856757 */     GIR_EraseRootFromParent_Done,
     /* 1856758 */   // Label 24982: @1856758
     /* 1856758 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1856844), // Rule ID 24698 //
     /* 1856763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1856766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1856771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1856780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856809 */     // MIs[0] policy
     /* 1856809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856819 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1856822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856843 */     // GIR_Coverage, 24698,
     /* 1856843 */     GIR_EraseRootFromParent_Done,
     /* 1856844 */   // Label 24983: @1856844
     /* 1856844 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1856930), // Rule ID 24699 //
     /* 1856849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1856852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1856857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1856866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856895 */     // MIs[0] policy
     /* 1856895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856905 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1856908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856929 */     // GIR_Coverage, 24699,
     /* 1856929 */     GIR_EraseRootFromParent_Done,
     /* 1856930 */   // Label 24984: @1856930
     /* 1856930 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1857016), // Rule ID 24702 //
     /* 1856935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1856938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1856943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1856946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1856949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1856952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1856955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856981 */     // MIs[0] policy
     /* 1856981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856991 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1856994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857015 */     // GIR_Coverage, 24702,
     /* 1857015 */     GIR_EraseRootFromParent_Done,
     /* 1857016 */   // Label 24985: @1857016
     /* 1857016 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1857102), // Rule ID 24703 //
     /* 1857021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1857024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1857038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1857041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857067 */     // MIs[0] policy
     /* 1857067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857077 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1857080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857101 */     // GIR_Coverage, 24703,
     /* 1857101 */     GIR_EraseRootFromParent_Done,
     /* 1857102 */   // Label 24986: @1857102
     /* 1857102 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1857188), // Rule ID 24706 //
     /* 1857107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1857110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1857124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1857127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857153 */     // MIs[0] policy
     /* 1857153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857163 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1857166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1857184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857187 */     // GIR_Coverage, 24706,
     /* 1857187 */     GIR_EraseRootFromParent_Done,
     /* 1857188 */   // Label 24987: @1857188
     /* 1857188 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1857274), // Rule ID 24707 //
     /* 1857193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1857196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1857210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1857213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857239 */     // MIs[0] policy
     /* 1857239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857249 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1857252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1857270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857273 */     // GIR_Coverage, 24707,
     /* 1857273 */     GIR_EraseRootFromParent_Done,
     /* 1857274 */   // Label 24988: @1857274
     /* 1857274 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1857360), // Rule ID 24710 //
     /* 1857279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1857282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1857296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1857299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857325 */     // MIs[0] policy
     /* 1857325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857335 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1857338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857359 */     // GIR_Coverage, 24710,
     /* 1857359 */     GIR_EraseRootFromParent_Done,
     /* 1857360 */   // Label 24989: @1857360
     /* 1857360 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1857446), // Rule ID 24711 //
     /* 1857365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1857368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1857382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1857385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857411 */     // MIs[0] policy
     /* 1857411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1857424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857445 */     // GIR_Coverage, 24711,
     /* 1857445 */     GIR_EraseRootFromParent_Done,
     /* 1857446 */   // Label 24990: @1857446
     /* 1857446 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1857532), // Rule ID 24714 //
     /* 1857451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1857454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1857468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1857471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857497 */     // MIs[0] policy
     /* 1857497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857507 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1857510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857531 */     // GIR_Coverage, 24714,
     /* 1857531 */     GIR_EraseRootFromParent_Done,
     /* 1857532 */   // Label 24991: @1857532
     /* 1857532 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1857618), // Rule ID 24715 //
     /* 1857537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1857540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1857554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1857557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857583 */     // MIs[0] policy
     /* 1857583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857593 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1857596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857617 */     // GIR_Coverage, 24715,
     /* 1857617 */     GIR_EraseRootFromParent_Done,
     /* 1857618 */   // Label 24992: @1857618
     /* 1857618 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1857704), // Rule ID 24718 //
     /* 1857623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1857626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1857640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1857643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857669 */     // MIs[0] policy
     /* 1857669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857679 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1857682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857703 */     // GIR_Coverage, 24718,
     /* 1857703 */     GIR_EraseRootFromParent_Done,
     /* 1857704 */   // Label 24993: @1857704
     /* 1857704 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1857790), // Rule ID 24719 //
     /* 1857709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1857712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1857726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1857729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857755 */     // MIs[0] policy
     /* 1857755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857765 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1857768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857789 */     // GIR_Coverage, 24719,
     /* 1857789 */     GIR_EraseRootFromParent_Done,
     /* 1857790 */   // Label 24994: @1857790
     /* 1857790 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1857876), // Rule ID 24722 //
     /* 1857795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1857798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1857812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1857815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857841 */     // MIs[0] policy
     /* 1857841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857851 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1857854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1857872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857875 */     // GIR_Coverage, 24722,
     /* 1857875 */     GIR_EraseRootFromParent_Done,
     /* 1857876 */   // Label 24995: @1857876
     /* 1857876 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1857962), // Rule ID 24723 //
     /* 1857881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1857884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1857898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1857901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857927 */     // MIs[0] policy
     /* 1857927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1857940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1857958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857961 */     // GIR_Coverage, 24723,
     /* 1857961 */     GIR_EraseRootFromParent_Done,
     /* 1857962 */   // Label 24996: @1857962
     /* 1857962 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1858048), // Rule ID 24726 //
     /* 1857967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1857970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1857975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1857978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1857981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1857984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1857987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858013 */     // MIs[0] policy
     /* 1858013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858023 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1858026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858047 */     // GIR_Coverage, 24726,
     /* 1858047 */     GIR_EraseRootFromParent_Done,
     /* 1858048 */   // Label 24997: @1858048
     /* 1858048 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1858134), // Rule ID 24727 //
     /* 1858053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1858056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1858061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1858070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1858073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858099 */     // MIs[0] policy
     /* 1858099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858109 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1858112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858133 */     // GIR_Coverage, 24727,
     /* 1858133 */     GIR_EraseRootFromParent_Done,
     /* 1858134 */   // Label 24998: @1858134
     /* 1858134 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1858220), // Rule ID 24730 //
     /* 1858139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1858142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1858147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1858156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1858159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858185 */     // MIs[0] policy
     /* 1858185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858195 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1858198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858219 */     // GIR_Coverage, 24730,
     /* 1858219 */     GIR_EraseRootFromParent_Done,
     /* 1858220 */   // Label 24999: @1858220
     /* 1858220 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1858306), // Rule ID 24731 //
     /* 1858225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1858228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1858233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1858242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1858245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858271 */     // MIs[0] policy
     /* 1858271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858281 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1858284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858305 */     // GIR_Coverage, 24731,
     /* 1858305 */     GIR_EraseRootFromParent_Done,
     /* 1858306 */   // Label 25000: @1858306
     /* 1858306 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1858392), // Rule ID 24734 //
     /* 1858311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1858314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1858322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1858325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1858331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858357 */     // MIs[0] policy
     /* 1858357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858367 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1858370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858391 */     // GIR_Coverage, 24734,
     /* 1858391 */     GIR_EraseRootFromParent_Done,
     /* 1858392 */   // Label 25001: @1858392
     /* 1858392 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1858478), // Rule ID 24735 //
     /* 1858397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1858400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1858408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1858411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1858417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858443 */     // MIs[0] policy
     /* 1858443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858453 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1858456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858477 */     // GIR_Coverage, 24735,
     /* 1858477 */     GIR_EraseRootFromParent_Done,
     /* 1858478 */   // Label 25002: @1858478
     /* 1858478 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1858564), // Rule ID 24738 //
     /* 1858483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1858486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1858503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858529 */     // MIs[0] policy
     /* 1858529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1858542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858563 */     // GIR_Coverage, 24738,
     /* 1858563 */     GIR_EraseRootFromParent_Done,
     /* 1858564 */   // Label 25003: @1858564
     /* 1858564 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1858650), // Rule ID 24739 //
     /* 1858569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1858572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1858589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858615 */     // MIs[0] policy
     /* 1858615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858625 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1858628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858649 */     // GIR_Coverage, 24739,
     /* 1858649 */     GIR_EraseRootFromParent_Done,
     /* 1858650 */   // Label 25004: @1858650
     /* 1858650 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1858736), // Rule ID 24742 //
     /* 1858655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1858658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1858672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1858675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858701 */     // MIs[0] policy
     /* 1858701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858711 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1858714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858735 */     // GIR_Coverage, 24742,
     /* 1858735 */     GIR_EraseRootFromParent_Done,
     /* 1858736 */   // Label 25005: @1858736
     /* 1858736 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1858822), // Rule ID 24743 //
     /* 1858741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1858744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1858758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1858761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858787 */     // MIs[0] policy
     /* 1858787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858797 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1858800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858821 */     // GIR_Coverage, 24743,
     /* 1858821 */     GIR_EraseRootFromParent_Done,
     /* 1858822 */   // Label 25006: @1858822
     /* 1858822 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1858908), // Rule ID 24746 //
     /* 1858827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1858830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1858838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1858841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1858847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858873 */     // MIs[0] policy
     /* 1858873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858883 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1858886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858907 */     // GIR_Coverage, 24746,
     /* 1858907 */     GIR_EraseRootFromParent_Done,
     /* 1858908 */   // Label 25007: @1858908
     /* 1858908 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1858994), // Rule ID 24747 //
     /* 1858913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1858916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1858921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1858924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1858927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1858933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858959 */     // MIs[0] policy
     /* 1858959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858969 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1858972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858993 */     // GIR_Coverage, 24747,
     /* 1858993 */     GIR_EraseRootFromParent_Done,
     /* 1858994 */   // Label 25008: @1858994
     /* 1858994 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1859080), // Rule ID 24750 //
     /* 1858999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1859002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1859016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1859019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859045 */     // MIs[0] policy
     /* 1859045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859055 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1859058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859079 */     // GIR_Coverage, 24750,
     /* 1859079 */     GIR_EraseRootFromParent_Done,
     /* 1859080 */   // Label 25009: @1859080
     /* 1859080 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1859166), // Rule ID 24751 //
     /* 1859085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1859088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1859102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1859105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859131 */     // MIs[0] policy
     /* 1859131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859141 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1859144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859165 */     // GIR_Coverage, 24751,
     /* 1859165 */     GIR_EraseRootFromParent_Done,
     /* 1859166 */   // Label 25010: @1859166
     /* 1859166 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1859252), // Rule ID 24754 //
     /* 1859171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1859174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1859182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1859185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1859188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1859191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859217 */     // MIs[0] policy
     /* 1859217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859227 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1859230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859251 */     // GIR_Coverage, 24754,
     /* 1859251 */     GIR_EraseRootFromParent_Done,
     /* 1859252 */   // Label 25011: @1859252
     /* 1859252 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1859338), // Rule ID 24755 //
     /* 1859257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1859260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1859268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1859271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1859274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1859277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859303 */     // MIs[0] policy
     /* 1859303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859313 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1859316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859337 */     // GIR_Coverage, 24755,
     /* 1859337 */     GIR_EraseRootFromParent_Done,
     /* 1859338 */   // Label 25012: @1859338
     /* 1859338 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1859424), // Rule ID 24758 //
     /* 1859343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1859346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1859354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1859357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1859360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1859363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859389 */     // MIs[0] policy
     /* 1859389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1859402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859423 */     // GIR_Coverage, 24758,
     /* 1859423 */     GIR_EraseRootFromParent_Done,
     /* 1859424 */   // Label 25013: @1859424
     /* 1859424 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1859510), // Rule ID 24759 //
     /* 1859429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1859432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1859440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1859443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1859446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1859449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859475 */     // MIs[0] policy
     /* 1859475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859485 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1859488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859509 */     // GIR_Coverage, 24759,
     /* 1859509 */     GIR_EraseRootFromParent_Done,
     /* 1859510 */   // Label 25014: @1859510
     /* 1859510 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1859596), // Rule ID 24762 //
     /* 1859515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1859518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1859526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1859529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1859532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1859535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859561 */     // MIs[0] policy
     /* 1859561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859571 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1859574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859595 */     // GIR_Coverage, 24762,
     /* 1859595 */     GIR_EraseRootFromParent_Done,
     /* 1859596 */   // Label 25015: @1859596
     /* 1859596 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1859682), // Rule ID 24763 //
     /* 1859601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1859604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1859612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1859615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1859618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1859621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859647 */     // MIs[0] policy
     /* 1859647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859657 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1859660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859681 */     // GIR_Coverage, 24763,
     /* 1859681 */     GIR_EraseRootFromParent_Done,
     /* 1859682 */   // Label 25016: @1859682
     /* 1859682 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1859768), // Rule ID 24766 //
     /* 1859687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1859690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1859698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1859701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1859704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1859707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859733 */     // MIs[0] policy
     /* 1859733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859743 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1859746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859767 */     // GIR_Coverage, 24766,
     /* 1859767 */     GIR_EraseRootFromParent_Done,
     /* 1859768 */   // Label 25017: @1859768
     /* 1859768 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1859854), // Rule ID 24767 //
     /* 1859773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1859776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1859781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1859784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1859787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1859790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1859793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859819 */     // MIs[0] policy
     /* 1859819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859829 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1859832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1859850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859853 */     // GIR_Coverage, 24767,
     /* 1859853 */     GIR_EraseRootFromParent_Done,
     /* 1859854 */   // Label 25018: @1859854
     /* 1859854 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1859940), // Rule ID 24806 //
     /* 1859859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1859862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1859867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1859870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1859873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1859876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859905 */     // MIs[0] policy
     /* 1859905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1859918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859939 */     // GIR_Coverage, 24806,
     /* 1859939 */     GIR_EraseRootFromParent_Done,
     /* 1859940 */   // Label 25019: @1859940
     /* 1859940 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1860026), // Rule ID 24807 //
     /* 1859945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1859948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1859953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1859956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1859959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1859962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859991 */     // MIs[0] policy
     /* 1859991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860001 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1860004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860025 */     // GIR_Coverage, 24807,
     /* 1860025 */     GIR_EraseRootFromParent_Done,
     /* 1860026 */   // Label 25020: @1860026
     /* 1860026 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1860112), // Rule ID 24810 //
     /* 1860031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1860042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1860045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1860048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860077 */     // MIs[0] policy
     /* 1860077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860087 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1860090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860111 */     // GIR_Coverage, 24810,
     /* 1860111 */     GIR_EraseRootFromParent_Done,
     /* 1860112 */   // Label 25021: @1860112
     /* 1860112 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1860198), // Rule ID 24811 //
     /* 1860117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1860128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1860131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1860134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860163 */     // MIs[0] policy
     /* 1860163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860173 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1860176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860197 */     // GIR_Coverage, 24811,
     /* 1860197 */     GIR_EraseRootFromParent_Done,
     /* 1860198 */   // Label 25022: @1860198
     /* 1860198 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1860284), // Rule ID 24814 //
     /* 1860203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1860214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1860217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1860220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860249 */     // MIs[0] policy
     /* 1860249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1860262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860283 */     // GIR_Coverage, 24814,
     /* 1860283 */     GIR_EraseRootFromParent_Done,
     /* 1860284 */   // Label 25023: @1860284
     /* 1860284 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1860370), // Rule ID 24815 //
     /* 1860289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1860300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1860303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1860306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860335 */     // MIs[0] policy
     /* 1860335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860345 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1860348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860369 */     // GIR_Coverage, 24815,
     /* 1860369 */     GIR_EraseRootFromParent_Done,
     /* 1860370 */   // Label 25024: @1860370
     /* 1860370 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1860456), // Rule ID 24818 //
     /* 1860375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1860386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1860389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1860392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860421 */     // MIs[0] policy
     /* 1860421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860431 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1860434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860455 */     // GIR_Coverage, 24818,
     /* 1860455 */     GIR_EraseRootFromParent_Done,
     /* 1860456 */   // Label 25025: @1860456
     /* 1860456 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1860542), // Rule ID 24819 //
     /* 1860461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1860472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1860475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1860478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860507 */     // MIs[0] policy
     /* 1860507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860517 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1860520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860541 */     // GIR_Coverage, 24819,
     /* 1860541 */     GIR_EraseRootFromParent_Done,
     /* 1860542 */   // Label 25026: @1860542
     /* 1860542 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1860628), // Rule ID 24822 //
     /* 1860547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1860558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1860561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1860564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860593 */     // MIs[0] policy
     /* 1860593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860603 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1860606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860627 */     // GIR_Coverage, 24822,
     /* 1860627 */     GIR_EraseRootFromParent_Done,
     /* 1860628 */   // Label 25027: @1860628
     /* 1860628 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1860714), // Rule ID 24823 //
     /* 1860633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1860644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1860647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1860650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860679 */     // MIs[0] policy
     /* 1860679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860689 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1860692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860713 */     // GIR_Coverage, 24823,
     /* 1860713 */     GIR_EraseRootFromParent_Done,
     /* 1860714 */   // Label 25028: @1860714
     /* 1860714 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1860800), // Rule ID 24826 //
     /* 1860719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1860730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1860733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1860736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1860739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1860742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860765 */     // MIs[0] policy
     /* 1860765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860775 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1860778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860799 */     // GIR_Coverage, 24826,
     /* 1860799 */     GIR_EraseRootFromParent_Done,
     /* 1860800 */   // Label 25029: @1860800
     /* 1860800 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1860886), // Rule ID 24827 //
     /* 1860805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1860813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1860816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1860819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1860822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1860825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1860828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860851 */     // MIs[0] policy
     /* 1860851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860861 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1860864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860885 */     // GIR_Coverage, 24827,
     /* 1860885 */     GIR_EraseRootFromParent_Done,
     /* 1860886 */   // Label 25030: @1860886
     /* 1860886 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1860972), // Rule ID 24830 //
     /* 1860891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1860894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1860899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1860905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1860908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1860911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860937 */     // MIs[0] policy
     /* 1860937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860947 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1860950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860971 */     // GIR_Coverage, 24830,
     /* 1860971 */     GIR_EraseRootFromParent_Done,
     /* 1860972 */   // Label 25031: @1860972
     /* 1860972 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1861058), // Rule ID 24831 //
     /* 1860977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1860980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1860985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1860991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1860994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1860997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861023 */     // MIs[0] policy
     /* 1861023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861033 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1861036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861057 */     // GIR_Coverage, 24831,
     /* 1861057 */     GIR_EraseRootFromParent_Done,
     /* 1861058 */   // Label 25032: @1861058
     /* 1861058 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1861144), // Rule ID 24834 //
     /* 1861063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1861066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1861080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861109 */     // MIs[0] policy
     /* 1861109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861119 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1861122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861143 */     // GIR_Coverage, 24834,
     /* 1861143 */     GIR_EraseRootFromParent_Done,
     /* 1861144 */   // Label 25033: @1861144
     /* 1861144 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1861230), // Rule ID 24835 //
     /* 1861149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1861152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1861166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861195 */     // MIs[0] policy
     /* 1861195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861205 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1861208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861229 */     // GIR_Coverage, 24835,
     /* 1861229 */     GIR_EraseRootFromParent_Done,
     /* 1861230 */   // Label 25034: @1861230
     /* 1861230 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1861316), // Rule ID 24838 //
     /* 1861235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1861238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1861252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861281 */     // MIs[0] policy
     /* 1861281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861291 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1861294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861315 */     // GIR_Coverage, 24838,
     /* 1861315 */     GIR_EraseRootFromParent_Done,
     /* 1861316 */   // Label 25035: @1861316
     /* 1861316 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1861402), // Rule ID 24839 //
     /* 1861321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1861324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1861338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861367 */     // MIs[0] policy
     /* 1861367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861377 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1861380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861401 */     // GIR_Coverage, 24839,
     /* 1861401 */     GIR_EraseRootFromParent_Done,
     /* 1861402 */   // Label 25036: @1861402
     /* 1861402 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1861488), // Rule ID 24842 //
     /* 1861407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1861410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1861424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861453 */     // MIs[0] policy
     /* 1861453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861463 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1861466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861487 */     // GIR_Coverage, 24842,
     /* 1861487 */     GIR_EraseRootFromParent_Done,
     /* 1861488 */   // Label 25037: @1861488
     /* 1861488 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1861574), // Rule ID 24843 //
     /* 1861493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1861496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1861510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861539 */     // MIs[0] policy
     /* 1861539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861549 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1861552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861573 */     // GIR_Coverage, 24843,
     /* 1861573 */     GIR_EraseRootFromParent_Done,
     /* 1861574 */   // Label 25038: @1861574
     /* 1861574 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1861660), // Rule ID 24846 //
     /* 1861579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1861582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1861596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861625 */     // MIs[0] policy
     /* 1861625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861635 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1861638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861659 */     // GIR_Coverage, 24846,
     /* 1861659 */     GIR_EraseRootFromParent_Done,
     /* 1861660 */   // Label 25039: @1861660
     /* 1861660 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1861746), // Rule ID 24847 //
     /* 1861665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1861668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1861682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861711 */     // MIs[0] policy
     /* 1861711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861721 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1861724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861745 */     // GIR_Coverage, 24847,
     /* 1861745 */     GIR_EraseRootFromParent_Done,
     /* 1861746 */   // Label 25040: @1861746
     /* 1861746 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1861832), // Rule ID 24850 //
     /* 1861751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1861754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1861768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861797 */     // MIs[0] policy
     /* 1861797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1861810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861831 */     // GIR_Coverage, 24850,
     /* 1861831 */     GIR_EraseRootFromParent_Done,
     /* 1861832 */   // Label 25041: @1861832
     /* 1861832 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1861918), // Rule ID 24851 //
     /* 1861837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1861840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1861845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1861854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861883 */     // MIs[0] policy
     /* 1861883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861893 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1861896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861917 */     // GIR_Coverage, 24851,
     /* 1861917 */     GIR_EraseRootFromParent_Done,
     /* 1861918 */   // Label 25042: @1861918
     /* 1861918 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1862004), // Rule ID 24878 //
     /* 1861923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1861926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1861931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1861940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1861943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861969 */     // MIs[0] policy
     /* 1861969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861979 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1861982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862003 */     // GIR_Coverage, 24878,
     /* 1862003 */     GIR_EraseRootFromParent_Done,
     /* 1862004 */   // Label 25043: @1862004
     /* 1862004 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1862090), // Rule ID 24879 //
     /* 1862009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1862012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1862020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1862023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1862026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862055 */     // MIs[0] policy
     /* 1862055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862065 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1862068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862089 */     // GIR_Coverage, 24879,
     /* 1862089 */     GIR_EraseRootFromParent_Done,
     /* 1862090 */   // Label 25044: @1862090
     /* 1862090 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1862176), // Rule ID 24882 //
     /* 1862095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1862098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1862106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1862109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1862112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862141 */     // MIs[0] policy
     /* 1862141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862151 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1862154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862175 */     // GIR_Coverage, 24882,
     /* 1862175 */     GIR_EraseRootFromParent_Done,
     /* 1862176 */   // Label 25045: @1862176
     /* 1862176 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1862262), // Rule ID 24883 //
     /* 1862181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1862184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1862192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1862195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1862198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862227 */     // MIs[0] policy
     /* 1862227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862237 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1862240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862261 */     // GIR_Coverage, 24883,
     /* 1862261 */     GIR_EraseRootFromParent_Done,
     /* 1862262 */   // Label 25046: @1862262
     /* 1862262 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1862348), // Rule ID 24886 //
     /* 1862267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1862270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1862284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862313 */     // MIs[0] policy
     /* 1862313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862323 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1862326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862347 */     // GIR_Coverage, 24886,
     /* 1862347 */     GIR_EraseRootFromParent_Done,
     /* 1862348 */   // Label 25047: @1862348
     /* 1862348 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1862434), // Rule ID 24887 //
     /* 1862353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1862356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1862370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862399 */     // MIs[0] policy
     /* 1862399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862409 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1862412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862433 */     // GIR_Coverage, 24887,
     /* 1862433 */     GIR_EraseRootFromParent_Done,
     /* 1862434 */   // Label 25048: @1862434
     /* 1862434 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1862520), // Rule ID 24890 //
     /* 1862439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1862442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862485 */     // MIs[0] policy
     /* 1862485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862495 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1862498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862519 */     // GIR_Coverage, 24890,
     /* 1862519 */     GIR_EraseRootFromParent_Done,
     /* 1862520 */   // Label 25049: @1862520
     /* 1862520 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1862606), // Rule ID 24891 //
     /* 1862525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1862528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862571 */     // MIs[0] policy
     /* 1862571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862581 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1862584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862605 */     // GIR_Coverage, 24891,
     /* 1862605 */     GIR_EraseRootFromParent_Done,
     /* 1862606 */   // Label 25050: @1862606
     /* 1862606 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1862692), // Rule ID 24894 //
     /* 1862611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1862614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862657 */     // MIs[0] policy
     /* 1862657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862667 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1862670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862691 */     // GIR_Coverage, 24894,
     /* 1862691 */     GIR_EraseRootFromParent_Done,
     /* 1862692 */   // Label 25051: @1862692
     /* 1862692 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1862778), // Rule ID 24895 //
     /* 1862697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1862700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862743 */     // MIs[0] policy
     /* 1862743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862753 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1862756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862777 */     // GIR_Coverage, 24895,
     /* 1862777 */     GIR_EraseRootFromParent_Done,
     /* 1862778 */   // Label 25052: @1862778
     /* 1862778 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1862864), // Rule ID 24898 //
     /* 1862783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1862786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862829 */     // MIs[0] policy
     /* 1862829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862839 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1862842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1862860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862863 */     // GIR_Coverage, 24898,
     /* 1862863 */     GIR_EraseRootFromParent_Done,
     /* 1862864 */   // Label 25053: @1862864
     /* 1862864 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1862950), // Rule ID 24899 //
     /* 1862869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1862872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862915 */     // MIs[0] policy
     /* 1862915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862925 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1862928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1862946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862949 */     // GIR_Coverage, 24899,
     /* 1862949 */     GIR_EraseRootFromParent_Done,
     /* 1862950 */   // Label 25054: @1862950
     /* 1862950 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1863036), // Rule ID 24902 //
     /* 1862955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1862958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1862963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1862966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1862969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1862972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863001 */     // MIs[0] policy
     /* 1863001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863011 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1863014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863035 */     // GIR_Coverage, 24902,
     /* 1863035 */     GIR_EraseRootFromParent_Done,
     /* 1863036 */   // Label 25055: @1863036
     /* 1863036 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1863122), // Rule ID 24903 //
     /* 1863041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1863044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1863052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1863055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1863058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863087 */     // MIs[0] policy
     /* 1863087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863097 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1863100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863121 */     // GIR_Coverage, 24903,
     /* 1863121 */     GIR_EraseRootFromParent_Done,
     /* 1863122 */   // Label 25056: @1863122
     /* 1863122 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1863208), // Rule ID 24906 //
     /* 1863127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1863130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863173 */     // MIs[0] policy
     /* 1863173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863183 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1863186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863207 */     // GIR_Coverage, 24906,
     /* 1863207 */     GIR_EraseRootFromParent_Done,
     /* 1863208 */   // Label 25057: @1863208
     /* 1863208 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1863294), // Rule ID 24907 //
     /* 1863213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1863216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863259 */     // MIs[0] policy
     /* 1863259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863269 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1863272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863293 */     // GIR_Coverage, 24907,
     /* 1863293 */     GIR_EraseRootFromParent_Done,
     /* 1863294 */   // Label 25058: @1863294
     /* 1863294 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1863380), // Rule ID 24910 //
     /* 1863299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1863302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1863316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1863319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863345 */     // MIs[0] policy
     /* 1863345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863355 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1863358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863379 */     // GIR_Coverage, 24910,
     /* 1863379 */     GIR_EraseRootFromParent_Done,
     /* 1863380 */   // Label 25059: @1863380
     /* 1863380 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1863466), // Rule ID 24911 //
     /* 1863385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1863388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1863402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1863405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863431 */     // MIs[0] policy
     /* 1863431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863441 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1863444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863465 */     // GIR_Coverage, 24911,
     /* 1863465 */     GIR_EraseRootFromParent_Done,
     /* 1863466 */   // Label 25060: @1863466
     /* 1863466 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1863552), // Rule ID 24914 //
     /* 1863471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1863474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1863488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1863491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863517 */     // MIs[0] policy
     /* 1863517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863527 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1863530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863551 */     // GIR_Coverage, 24914,
     /* 1863551 */     GIR_EraseRootFromParent_Done,
     /* 1863552 */   // Label 25061: @1863552
     /* 1863552 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1863638), // Rule ID 24915 //
     /* 1863557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1863560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1863574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1863577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863603 */     // MIs[0] policy
     /* 1863603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1863616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863637 */     // GIR_Coverage, 24915,
     /* 1863637 */     GIR_EraseRootFromParent_Done,
     /* 1863638 */   // Label 25062: @1863638
     /* 1863638 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1863724), // Rule ID 24918 //
     /* 1863643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1863646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1863660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863689 */     // MIs[0] policy
     /* 1863689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863699 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1863702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863723 */     // GIR_Coverage, 24918,
     /* 1863723 */     GIR_EraseRootFromParent_Done,
     /* 1863724 */   // Label 25063: @1863724
     /* 1863724 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1863810), // Rule ID 24919 //
     /* 1863729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1863732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1863746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863775 */     // MIs[0] policy
     /* 1863775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863785 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1863788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863809 */     // GIR_Coverage, 24919,
     /* 1863809 */     GIR_EraseRootFromParent_Done,
     /* 1863810 */   // Label 25064: @1863810
     /* 1863810 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1863896), // Rule ID 24922 //
     /* 1863815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1863818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1863832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863861 */     // MIs[0] policy
     /* 1863861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863871 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1863874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863895 */     // GIR_Coverage, 24922,
     /* 1863895 */     GIR_EraseRootFromParent_Done,
     /* 1863896 */   // Label 25065: @1863896
     /* 1863896 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1863982), // Rule ID 24923 //
     /* 1863901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1863904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1863918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863947 */     // MIs[0] policy
     /* 1863947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863957 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1863960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863981 */     // GIR_Coverage, 24923,
     /* 1863981 */     GIR_EraseRootFromParent_Done,
     /* 1863982 */   // Label 25066: @1863982
     /* 1863982 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1864068), // Rule ID 24926 //
     /* 1863987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1863990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1863995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864033 */     // MIs[0] policy
     /* 1864033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1864046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864067 */     // GIR_Coverage, 24926,
     /* 1864067 */     GIR_EraseRootFromParent_Done,
     /* 1864068 */   // Label 25067: @1864068
     /* 1864068 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1864154), // Rule ID 24927 //
     /* 1864073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1864076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1864081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864119 */     // MIs[0] policy
     /* 1864119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864129 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1864132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864153 */     // GIR_Coverage, 24927,
     /* 1864153 */     GIR_EraseRootFromParent_Done,
     /* 1864154 */   // Label 25068: @1864154
     /* 1864154 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1864240), // Rule ID 24930 //
     /* 1864159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1864162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1864167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864205 */     // MIs[0] policy
     /* 1864205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864215 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1864218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864239 */     // GIR_Coverage, 24930,
     /* 1864239 */     GIR_EraseRootFromParent_Done,
     /* 1864240 */   // Label 25069: @1864240
     /* 1864240 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1864326), // Rule ID 24931 //
     /* 1864245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1864248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1864253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864291 */     // MIs[0] policy
     /* 1864291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864301 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1864304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864325 */     // GIR_Coverage, 24931,
     /* 1864325 */     GIR_EraseRootFromParent_Done,
     /* 1864326 */   // Label 25070: @1864326
     /* 1864326 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1864412), // Rule ID 24934 //
     /* 1864331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1864334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1864339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1864348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1864351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864377 */     // MIs[0] policy
     /* 1864377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864387 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1864390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864411 */     // GIR_Coverage, 24934,
     /* 1864411 */     GIR_EraseRootFromParent_Done,
     /* 1864412 */   // Label 25071: @1864412
     /* 1864412 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1864498), // Rule ID 24935 //
     /* 1864417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1864420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1864425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1864434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1864437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864463 */     // MIs[0] policy
     /* 1864463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864473 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1864476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864497 */     // GIR_Coverage, 24935,
     /* 1864497 */     GIR_EraseRootFromParent_Done,
     /* 1864498 */   // Label 25072: @1864498
     /* 1864498 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1864584), // Rule ID 60246 //
     /* 1864503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1864506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864549 */     // MIs[0] policy
     /* 1864549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864559 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1864562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864583 */     // GIR_Coverage, 60246,
     /* 1864583 */     GIR_EraseRootFromParent_Done,
     /* 1864584 */   // Label 25073: @1864584
     /* 1864584 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1864670), // Rule ID 60247 //
     /* 1864589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1864592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864635 */     // MIs[0] policy
     /* 1864635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864645 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1864648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864669 */     // GIR_Coverage, 60247,
     /* 1864669 */     GIR_EraseRootFromParent_Done,
     /* 1864670 */   // Label 25074: @1864670
     /* 1864670 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1864756), // Rule ID 60250 //
     /* 1864675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1864678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864721 */     // MIs[0] policy
     /* 1864721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864731 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1864734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864755 */     // GIR_Coverage, 60250,
     /* 1864755 */     GIR_EraseRootFromParent_Done,
     /* 1864756 */   // Label 25075: @1864756
     /* 1864756 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1864842), // Rule ID 60251 //
     /* 1864761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1864764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864807 */     // MIs[0] policy
     /* 1864807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864817 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1864820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864841 */     // GIR_Coverage, 60251,
     /* 1864841 */     GIR_EraseRootFromParent_Done,
     /* 1864842 */   // Label 25076: @1864842
     /* 1864842 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1864928), // Rule ID 60254 //
     /* 1864847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1864850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864893 */     // MIs[0] policy
     /* 1864893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864903 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1864906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864927 */     // GIR_Coverage, 60254,
     /* 1864927 */     GIR_EraseRootFromParent_Done,
     /* 1864928 */   // Label 25077: @1864928
     /* 1864928 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1865014), // Rule ID 60255 //
     /* 1864933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1864936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1864941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864979 */     // MIs[0] policy
     /* 1864979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864989 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1864992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865013 */     // GIR_Coverage, 60255,
     /* 1865013 */     GIR_EraseRootFromParent_Done,
     /* 1865014 */   // Label 25078: @1865014
     /* 1865014 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1865100), // Rule ID 60258 //
     /* 1865019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865065 */     // MIs[0] policy
     /* 1865065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1865078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865099 */     // GIR_Coverage, 60258,
     /* 1865099 */     GIR_EraseRootFromParent_Done,
     /* 1865100 */   // Label 25079: @1865100
     /* 1865100 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1865186), // Rule ID 60259 //
     /* 1865105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865151 */     // MIs[0] policy
     /* 1865151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1865164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865185 */     // GIR_Coverage, 60259,
     /* 1865185 */     GIR_EraseRootFromParent_Done,
     /* 1865186 */   // Label 25080: @1865186
     /* 1865186 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1865272), // Rule ID 60262 //
     /* 1865191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865237 */     // MIs[0] policy
     /* 1865237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865247 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1865250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865271 */     // GIR_Coverage, 60262,
     /* 1865271 */     GIR_EraseRootFromParent_Done,
     /* 1865272 */   // Label 25081: @1865272
     /* 1865272 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1865358), // Rule ID 60263 //
     /* 1865277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865323 */     // MIs[0] policy
     /* 1865323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865333 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1865336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865357 */     // GIR_Coverage, 60263,
     /* 1865357 */     GIR_EraseRootFromParent_Done,
     /* 1865358 */   // Label 25082: @1865358
     /* 1865358 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1865444), // Rule ID 60266 //
     /* 1865363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1865374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1865377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865409 */     // MIs[0] policy
     /* 1865409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1865422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865443 */     // GIR_Coverage, 60266,
     /* 1865443 */     GIR_EraseRootFromParent_Done,
     /* 1865444 */   // Label 25083: @1865444
     /* 1865444 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1865530), // Rule ID 60267 //
     /* 1865449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1865460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1865463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865495 */     // MIs[0] policy
     /* 1865495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865505 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1865508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865529 */     // GIR_Coverage, 60267,
     /* 1865529 */     GIR_EraseRootFromParent_Done,
     /* 1865530 */   // Label 25084: @1865530
     /* 1865530 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1865616), // Rule ID 60270 //
     /* 1865535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865581 */     // MIs[0] policy
     /* 1865581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1865594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865615 */     // GIR_Coverage, 60270,
     /* 1865615 */     GIR_EraseRootFromParent_Done,
     /* 1865616 */   // Label 25085: @1865616
     /* 1865616 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1865702), // Rule ID 60271 //
     /* 1865621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865667 */     // MIs[0] policy
     /* 1865667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1865680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865701 */     // GIR_Coverage, 60271,
     /* 1865701 */     GIR_EraseRootFromParent_Done,
     /* 1865702 */   // Label 25086: @1865702
     /* 1865702 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1865788), // Rule ID 60274 //
     /* 1865707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1865727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865753 */     // MIs[0] policy
     /* 1865753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865763 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1865766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865787 */     // GIR_Coverage, 60274,
     /* 1865787 */     GIR_EraseRootFromParent_Done,
     /* 1865788 */   // Label 25087: @1865788
     /* 1865788 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1865874), // Rule ID 60275 //
     /* 1865793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1865813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865839 */     // MIs[0] policy
     /* 1865839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1865852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865873 */     // GIR_Coverage, 60275,
     /* 1865873 */     GIR_EraseRootFromParent_Done,
     /* 1865874 */   // Label 25088: @1865874
     /* 1865874 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1865960), // Rule ID 60278 //
     /* 1865879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1865882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1865890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1865893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865925 */     // MIs[0] policy
     /* 1865925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1865938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865959 */     // GIR_Coverage, 60278,
     /* 1865959 */     GIR_EraseRootFromParent_Done,
     /* 1865960 */   // Label 25089: @1865960
     /* 1865960 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1866046), // Rule ID 60279 //
     /* 1865965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1865968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1865973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1865976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1865979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866011 */     // MIs[0] policy
     /* 1866011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1866024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866045 */     // GIR_Coverage, 60279,
     /* 1866045 */     GIR_EraseRootFromParent_Done,
     /* 1866046 */   // Label 25090: @1866046
     /* 1866046 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1866132), // Rule ID 60282 //
     /* 1866051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866097 */     // MIs[0] policy
     /* 1866097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1866110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866131 */     // GIR_Coverage, 60282,
     /* 1866131 */     GIR_EraseRootFromParent_Done,
     /* 1866132 */   // Label 25091: @1866132
     /* 1866132 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1866218), // Rule ID 60283 //
     /* 1866137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1866140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866183 */     // MIs[0] policy
     /* 1866183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1866196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866217 */     // GIR_Coverage, 60283,
     /* 1866217 */     GIR_EraseRootFromParent_Done,
     /* 1866218 */   // Label 25092: @1866218
     /* 1866218 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1866304), // Rule ID 60286 //
     /* 1866223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866269 */     // MIs[0] policy
     /* 1866269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1866282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866303 */     // GIR_Coverage, 60286,
     /* 1866303 */     GIR_EraseRootFromParent_Done,
     /* 1866304 */   // Label 25093: @1866304
     /* 1866304 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1866390), // Rule ID 60287 //
     /* 1866309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1866312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866355 */     // MIs[0] policy
     /* 1866355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866365 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1866368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866389 */     // GIR_Coverage, 60287,
     /* 1866389 */     GIR_EraseRootFromParent_Done,
     /* 1866390 */   // Label 25094: @1866390
     /* 1866390 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1866476), // Rule ID 60290 //
     /* 1866395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1866412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1866415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866441 */     // MIs[0] policy
     /* 1866441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1866454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866475 */     // GIR_Coverage, 60290,
     /* 1866475 */     GIR_EraseRootFromParent_Done,
     /* 1866476 */   // Label 25095: @1866476
     /* 1866476 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1866562), // Rule ID 60291 //
     /* 1866481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1866484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1866498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1866501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866527 */     // MIs[0] policy
     /* 1866527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866537 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1866540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866561 */     // GIR_Coverage, 60291,
     /* 1866561 */     GIR_EraseRootFromParent_Done,
     /* 1866562 */   // Label 25096: @1866562
     /* 1866562 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1866648), // Rule ID 60294 //
     /* 1866567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866613 */     // MIs[0] policy
     /* 1866613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1866626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866647 */     // GIR_Coverage, 60294,
     /* 1866647 */     GIR_EraseRootFromParent_Done,
     /* 1866648 */   // Label 25097: @1866648
     /* 1866648 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1866734), // Rule ID 60295 //
     /* 1866653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1866656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866699 */     // MIs[0] policy
     /* 1866699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1866712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866733 */     // GIR_Coverage, 60295,
     /* 1866733 */     GIR_EraseRootFromParent_Done,
     /* 1866734 */   // Label 25098: @1866734
     /* 1866734 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1866820), // Rule ID 60298 //
     /* 1866739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1866750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1866753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866785 */     // MIs[0] policy
     /* 1866785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866795 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1866798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866819 */     // GIR_Coverage, 60298,
     /* 1866819 */     GIR_EraseRootFromParent_Done,
     /* 1866820 */   // Label 25099: @1866820
     /* 1866820 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1866906), // Rule ID 60299 //
     /* 1866825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1866828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1866836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1866839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866871 */     // MIs[0] policy
     /* 1866871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866881 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1866884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866905 */     // GIR_Coverage, 60299,
     /* 1866905 */     GIR_EraseRootFromParent_Done,
     /* 1866906 */   // Label 25100: @1866906
     /* 1866906 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1866992), // Rule ID 60302 //
     /* 1866911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1866914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1866919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1866922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1866925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866957 */     // MIs[0] policy
     /* 1866957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866967 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1866970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866991 */     // GIR_Coverage, 60302,
     /* 1866991 */     GIR_EraseRootFromParent_Done,
     /* 1866992 */   // Label 25101: @1866992
     /* 1866992 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1867078), // Rule ID 60303 //
     /* 1866997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1867014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867043 */     // MIs[0] policy
     /* 1867043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867053 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1867056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867077 */     // GIR_Coverage, 60303,
     /* 1867077 */     GIR_EraseRootFromParent_Done,
     /* 1867078 */   // Label 25102: @1867078
     /* 1867078 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1867164), // Rule ID 60306 //
     /* 1867083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867129 */     // MIs[0] policy
     /* 1867129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1867142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867163 */     // GIR_Coverage, 60306,
     /* 1867163 */     GIR_EraseRootFromParent_Done,
     /* 1867164 */   // Label 25103: @1867164
     /* 1867164 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1867250), // Rule ID 60307 //
     /* 1867169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867215 */     // MIs[0] policy
     /* 1867215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867225 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1867228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867249 */     // GIR_Coverage, 60307,
     /* 1867249 */     GIR_EraseRootFromParent_Done,
     /* 1867250 */   // Label 25104: @1867250
     /* 1867250 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1867336), // Rule ID 60314 //
     /* 1867255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1867266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1867269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867301 */     // MIs[0] policy
     /* 1867301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1867314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867335 */     // GIR_Coverage, 60314,
     /* 1867335 */     GIR_EraseRootFromParent_Done,
     /* 1867336 */   // Label 25105: @1867336
     /* 1867336 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1867422), // Rule ID 60315 //
     /* 1867341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1867352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1867355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867387 */     // MIs[0] policy
     /* 1867387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867397 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1867400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867421 */     // GIR_Coverage, 60315,
     /* 1867421 */     GIR_EraseRootFromParent_Done,
     /* 1867422 */   // Label 25106: @1867422
     /* 1867422 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1867508), // Rule ID 60322 //
     /* 1867427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1867438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1867441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867473 */     // MIs[0] policy
     /* 1867473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1867486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867507 */     // GIR_Coverage, 60322,
     /* 1867507 */     GIR_EraseRootFromParent_Done,
     /* 1867508 */   // Label 25107: @1867508
     /* 1867508 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1867594), // Rule ID 60323 //
     /* 1867513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1867524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1867527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867559 */     // MIs[0] policy
     /* 1867559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1867572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867593 */     // GIR_Coverage, 60323,
     /* 1867593 */     GIR_EraseRootFromParent_Done,
     /* 1867594 */   // Label 25108: @1867594
     /* 1867594 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1867680), // Rule ID 60330 //
     /* 1867599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1867616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867645 */     // MIs[0] policy
     /* 1867645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1867658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867679 */     // GIR_Coverage, 60330,
     /* 1867679 */     GIR_EraseRootFromParent_Done,
     /* 1867680 */   // Label 25109: @1867680
     /* 1867680 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1867766), // Rule ID 60331 //
     /* 1867685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1867702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867731 */     // MIs[0] policy
     /* 1867731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1867744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867765 */     // GIR_Coverage, 60331,
     /* 1867765 */     GIR_EraseRootFromParent_Done,
     /* 1867766 */   // Label 25110: @1867766
     /* 1867766 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1867852), // Rule ID 60338 //
     /* 1867771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1867788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867817 */     // MIs[0] policy
     /* 1867817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867827 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1867830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867851 */     // GIR_Coverage, 60338,
     /* 1867851 */     GIR_EraseRootFromParent_Done,
     /* 1867852 */   // Label 25111: @1867852
     /* 1867852 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1867938), // Rule ID 60339 //
     /* 1867857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1867860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1867874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867903 */     // MIs[0] policy
     /* 1867903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867913 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1867916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867937 */     // GIR_Coverage, 60339,
     /* 1867937 */     GIR_EraseRootFromParent_Done,
     /* 1867938 */   // Label 25112: @1867938
     /* 1867938 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1868024), // Rule ID 60346 //
     /* 1867943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1867946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1867951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1867954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1867957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1867960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867989 */     // MIs[0] policy
     /* 1867989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1868002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868023 */     // GIR_Coverage, 60346,
     /* 1868023 */     GIR_EraseRootFromParent_Done,
     /* 1868024 */   // Label 25113: @1868024
     /* 1868024 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1868110), // Rule ID 60347 //
     /* 1868029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1868040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1868043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1868046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1868052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868075 */     // MIs[0] policy
     /* 1868075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868085 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1868088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868109 */     // GIR_Coverage, 60347,
     /* 1868109 */     GIR_EraseRootFromParent_Done,
     /* 1868110 */   // Label 25114: @1868110
     /* 1868110 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1868196), // Rule ID 60354 //
     /* 1868115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868161 */     // MIs[0] policy
     /* 1868161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1868174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868195 */     // GIR_Coverage, 60354,
     /* 1868195 */     GIR_EraseRootFromParent_Done,
     /* 1868196 */   // Label 25115: @1868196
     /* 1868196 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1868282), // Rule ID 60355 //
     /* 1868201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868247 */     // MIs[0] policy
     /* 1868247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868257 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1868260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868281 */     // GIR_Coverage, 60355,
     /* 1868281 */     GIR_EraseRootFromParent_Done,
     /* 1868282 */   // Label 25116: @1868282
     /* 1868282 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1868368), // Rule ID 60362 //
     /* 1868287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868333 */     // MIs[0] policy
     /* 1868333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1868346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868367 */     // GIR_Coverage, 60362,
     /* 1868367 */     GIR_EraseRootFromParent_Done,
     /* 1868368 */   // Label 25117: @1868368
     /* 1868368 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1868454), // Rule ID 60363 //
     /* 1868373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868419 */     // MIs[0] policy
     /* 1868419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1868432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868453 */     // GIR_Coverage, 60363,
     /* 1868453 */     GIR_EraseRootFromParent_Done,
     /* 1868454 */   // Label 25118: @1868454
     /* 1868454 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1868540), // Rule ID 60370 //
     /* 1868459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1868470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1868473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868505 */     // MIs[0] policy
     /* 1868505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1868518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868539 */     // GIR_Coverage, 60370,
     /* 1868539 */     GIR_EraseRootFromParent_Done,
     /* 1868540 */   // Label 25119: @1868540
     /* 1868540 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1868626), // Rule ID 60371 //
     /* 1868545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1868556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1868559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868591 */     // MIs[0] policy
     /* 1868591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1868604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868625 */     // GIR_Coverage, 60371,
     /* 1868625 */     GIR_EraseRootFromParent_Done,
     /* 1868626 */   // Label 25120: @1868626
     /* 1868626 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1868712), // Rule ID 60378 //
     /* 1868631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1868642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1868645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1868648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868677 */     // MIs[0] policy
     /* 1868677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868687 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1868690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868711 */     // GIR_Coverage, 60378,
     /* 1868711 */     GIR_EraseRootFromParent_Done,
     /* 1868712 */   // Label 25121: @1868712
     /* 1868712 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1868798), // Rule ID 60379 //
     /* 1868717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1868728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1868731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1868734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868763 */     // MIs[0] policy
     /* 1868763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1868776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868797 */     // GIR_Coverage, 60379,
     /* 1868797 */     GIR_EraseRootFromParent_Done,
     /* 1868798 */   // Label 25122: @1868798
     /* 1868798 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1868884), // Rule ID 60386 //
     /* 1868803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1868814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1868817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1868820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1868826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868849 */     // MIs[0] policy
     /* 1868849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1868862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868883 */     // GIR_Coverage, 60386,
     /* 1868883 */     GIR_EraseRootFromParent_Done,
     /* 1868884 */   // Label 25123: @1868884
     /* 1868884 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1868970), // Rule ID 60387 //
     /* 1868889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1868892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1868900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1868903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1868906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1868912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868935 */     // MIs[0] policy
     /* 1868935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868945 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1868948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868969 */     // GIR_Coverage, 60387,
     /* 1868969 */     GIR_EraseRootFromParent_Done,
     /* 1868970 */   // Label 25124: @1868970
     /* 1868970 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1869056), // Rule ID 60394 //
     /* 1868975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1868978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1868983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1868986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1868989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869021 */     // MIs[0] policy
     /* 1869021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1869034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869055 */     // GIR_Coverage, 60394,
     /* 1869055 */     GIR_EraseRootFromParent_Done,
     /* 1869056 */   // Label 25125: @1869056
     /* 1869056 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1869142), // Rule ID 60395 //
     /* 1869061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1869064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1869078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869107 */     // MIs[0] policy
     /* 1869107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869117 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1869120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869141 */     // GIR_Coverage, 60395,
     /* 1869141 */     GIR_EraseRootFromParent_Done,
     /* 1869142 */   // Label 25126: @1869142
     /* 1869142 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1869228), // Rule ID 60402 //
     /* 1869147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1869150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1869158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1869161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869193 */     // MIs[0] policy
     /* 1869193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1869206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869227 */     // GIR_Coverage, 60402,
     /* 1869227 */     GIR_EraseRootFromParent_Done,
     /* 1869228 */   // Label 25127: @1869228
     /* 1869228 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1869314), // Rule ID 60403 //
     /* 1869233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1869236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1869244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1869247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869279 */     // MIs[0] policy
     /* 1869279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1869292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869313 */     // GIR_Coverage, 60403,
     /* 1869313 */     GIR_EraseRootFromParent_Done,
     /* 1869314 */   // Label 25128: @1869314
     /* 1869314 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1869400), // Rule ID 60410 //
     /* 1869319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1869322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1869330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1869333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1869336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869365 */     // MIs[0] policy
     /* 1869365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869375 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1869378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869399 */     // GIR_Coverage, 60410,
     /* 1869399 */     GIR_EraseRootFromParent_Done,
     /* 1869400 */   // Label 25129: @1869400
     /* 1869400 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1869486), // Rule ID 60411 //
     /* 1869405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1869408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1869416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1869419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1869422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869451 */     // MIs[0] policy
     /* 1869451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1869464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869485 */     // GIR_Coverage, 60411,
     /* 1869485 */     GIR_EraseRootFromParent_Done,
     /* 1869486 */   // Label 25130: @1869486
     /* 1869486 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1869572), // Rule ID 60418 //
     /* 1869491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1869494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1869502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1869505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1869508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869537 */     // MIs[0] policy
     /* 1869537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869547 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1869550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869571 */     // GIR_Coverage, 60418,
     /* 1869571 */     GIR_EraseRootFromParent_Done,
     /* 1869572 */   // Label 25131: @1869572
     /* 1869572 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1869658), // Rule ID 60419 //
     /* 1869577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1869580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1869585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1869588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1869591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1869594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869623 */     // MIs[0] policy
     /* 1869623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869633 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1869636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869657 */     // GIR_Coverage, 60419,
     /* 1869657 */     GIR_EraseRootFromParent_Done,
     /* 1869658 */   // Label 25132: @1869658
     /* 1869658 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1869744), // Rule ID 60426 //
     /* 1869663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1869666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1869671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1869683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869709 */     // MIs[0] policy
     /* 1869709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869719 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1869722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869743 */     // GIR_Coverage, 60426,
     /* 1869743 */     GIR_EraseRootFromParent_Done,
     /* 1869744 */   // Label 25133: @1869744
     /* 1869744 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1869830), // Rule ID 60427 //
     /* 1869749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1869752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1869757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1869769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869795 */     // MIs[0] policy
     /* 1869795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869805 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1869808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869829 */     // GIR_Coverage, 60427,
     /* 1869829 */     GIR_EraseRootFromParent_Done,
     /* 1869830 */   // Label 25134: @1869830
     /* 1869830 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1869916), // Rule ID 60430 //
     /* 1869835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1869838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1869843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1869846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1869849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1869852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1869855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869881 */     // MIs[0] policy
     /* 1869881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10860:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1869894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869915 */     // GIR_Coverage, 60430,
     /* 1869915 */     GIR_EraseRootFromParent_Done,
     /* 1869916 */   // Label 25135: @1869916
     /* 1869916 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1870002), // Rule ID 60431 //
     /* 1869921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1869924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1869929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1869932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1869935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1869938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1869941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869967 */     // MIs[0] policy
     /* 1869967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10860:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1869980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870001 */     // GIR_Coverage, 60431,
     /* 1870001 */     GIR_EraseRootFromParent_Done,
     /* 1870002 */   // Label 25136: @1870002
     /* 1870002 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1870088), // Rule ID 60434 //
     /* 1870007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1870027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870053 */     // MIs[0] policy
     /* 1870053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870063 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10860:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1870066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870087 */     // GIR_Coverage, 60434,
     /* 1870087 */     GIR_EraseRootFromParent_Done,
     /* 1870088 */   // Label 25137: @1870088
     /* 1870088 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1870174), // Rule ID 60435 //
     /* 1870093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1870113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870139 */     // MIs[0] policy
     /* 1870139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10860:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1870152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870173 */     // GIR_Coverage, 60435,
     /* 1870173 */     GIR_EraseRootFromParent_Done,
     /* 1870174 */   // Label 25138: @1870174
     /* 1870174 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1870260), // Rule ID 60438 //
     /* 1870179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1870190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1870193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1870196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1870199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870225 */     // MIs[0] policy
     /* 1870225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870235 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10860:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1870238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870259 */     // GIR_Coverage, 60438,
     /* 1870259 */     GIR_EraseRootFromParent_Done,
     /* 1870260 */   // Label 25139: @1870260
     /* 1870260 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1870346), // Rule ID 60439 //
     /* 1870265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1870276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1870279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1870282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1870285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870311 */     // MIs[0] policy
     /* 1870311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10860:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1870324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870345 */     // GIR_Coverage, 60439,
     /* 1870345 */     GIR_EraseRootFromParent_Done,
     /* 1870346 */   // Label 25140: @1870346
     /* 1870346 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1870432), // Rule ID 60442 //
     /* 1870351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870397 */     // MIs[0] policy
     /* 1870397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870407 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1870410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870431 */     // GIR_Coverage, 60442,
     /* 1870431 */     GIR_EraseRootFromParent_Done,
     /* 1870432 */   // Label 25141: @1870432
     /* 1870432 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1870518), // Rule ID 60443 //
     /* 1870437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870483 */     // MIs[0] policy
     /* 1870483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1870496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870517 */     // GIR_Coverage, 60443,
     /* 1870517 */     GIR_EraseRootFromParent_Done,
     /* 1870518 */   // Label 25142: @1870518
     /* 1870518 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1870604), // Rule ID 60446 //
     /* 1870523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870569 */     // MIs[0] policy
     /* 1870569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870579 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10860:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1870582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870603 */     // GIR_Coverage, 60446,
     /* 1870603 */     GIR_EraseRootFromParent_Done,
     /* 1870604 */   // Label 25143: @1870604
     /* 1870604 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1870690), // Rule ID 60447 //
     /* 1870609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870655 */     // MIs[0] policy
     /* 1870655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10860:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1870668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870689 */     // GIR_Coverage, 60447,
     /* 1870689 */     GIR_EraseRootFromParent_Done,
     /* 1870690 */   // Label 25144: @1870690
     /* 1870690 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1870776), // Rule ID 60450 //
     /* 1870695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870741 */     // MIs[0] policy
     /* 1870741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870751 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10860:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1870754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870775 */     // GIR_Coverage, 60450,
     /* 1870775 */     GIR_EraseRootFromParent_Done,
     /* 1870776 */   // Label 25145: @1870776
     /* 1870776 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1870862), // Rule ID 60451 //
     /* 1870781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870827 */     // MIs[0] policy
     /* 1870827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870837 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10860:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1870840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870861 */     // GIR_Coverage, 60451,
     /* 1870861 */     GIR_EraseRootFromParent_Done,
     /* 1870862 */   // Label 25146: @1870862
     /* 1870862 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1870948), // Rule ID 60454 //
     /* 1870867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1870870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1870878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1870881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1870884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870913 */     // MIs[0] policy
     /* 1870913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870923 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10860:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1870926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870947 */     // GIR_Coverage, 60454,
     /* 1870947 */     GIR_EraseRootFromParent_Done,
     /* 1870948 */   // Label 25147: @1870948
     /* 1870948 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1871034), // Rule ID 60455 //
     /* 1870953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1870956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1870961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1870964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1870967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1870970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870999 */     // MIs[0] policy
     /* 1870999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871009 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10860:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1871012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871033 */     // GIR_Coverage, 60455,
     /* 1871033 */     GIR_EraseRootFromParent_Done,
     /* 1871034 */   // Label 25148: @1871034
     /* 1871034 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1871120), // Rule ID 60458 //
     /* 1871039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1871050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1871053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1871056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1871059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871085 */     // MIs[0] policy
     /* 1871085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1871098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871119 */     // GIR_Coverage, 60458,
     /* 1871119 */     GIR_EraseRootFromParent_Done,
     /* 1871120 */   // Label 25149: @1871120
     /* 1871120 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1871206), // Rule ID 60459 //
     /* 1871125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1871136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1871139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1871142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1871145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871171 */     // MIs[0] policy
     /* 1871171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871181 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1871184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871205 */     // GIR_Coverage, 60459,
     /* 1871205 */     GIR_EraseRootFromParent_Done,
     /* 1871206 */   // Label 25150: @1871206
     /* 1871206 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1871292), // Rule ID 60462 //
     /* 1871211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1871231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871257 */     // MIs[0] policy
     /* 1871257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871267 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10862:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1871270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871291 */     // GIR_Coverage, 60462,
     /* 1871291 */     GIR_EraseRootFromParent_Done,
     /* 1871292 */   // Label 25151: @1871292
     /* 1871292 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1871378), // Rule ID 60463 //
     /* 1871297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1871317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871343 */     // MIs[0] policy
     /* 1871343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10862:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1871356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871377 */     // GIR_Coverage, 60463,
     /* 1871377 */     GIR_EraseRootFromParent_Done,
     /* 1871378 */   // Label 25152: @1871378
     /* 1871378 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1871464), // Rule ID 60466 //
     /* 1871383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1871403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871429 */     // MIs[0] policy
     /* 1871429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10862:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1871442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871463 */     // GIR_Coverage, 60466,
     /* 1871463 */     GIR_EraseRootFromParent_Done,
     /* 1871464 */   // Label 25153: @1871464
     /* 1871464 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1871550), // Rule ID 60467 //
     /* 1871469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1871489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871515 */     // MIs[0] policy
     /* 1871515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871525 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10862:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1871528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871549 */     // GIR_Coverage, 60467,
     /* 1871549 */     GIR_EraseRootFromParent_Done,
     /* 1871550 */   // Label 25154: @1871550
     /* 1871550 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1871636), // Rule ID 60470 //
     /* 1871555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1871575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871601 */     // MIs[0] policy
     /* 1871601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871611 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10862:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1871614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871635 */     // GIR_Coverage, 60470,
     /* 1871635 */     GIR_EraseRootFromParent_Done,
     /* 1871636 */   // Label 25155: @1871636
     /* 1871636 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1871722), // Rule ID 60471 //
     /* 1871641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1871661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871687 */     // MIs[0] policy
     /* 1871687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871697 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10862:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1871700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871721 */     // GIR_Coverage, 60471,
     /* 1871721 */     GIR_EraseRootFromParent_Done,
     /* 1871722 */   // Label 25156: @1871722
     /* 1871722 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1871808), // Rule ID 60474 //
     /* 1871727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1871738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1871741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1871744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871773 */     // MIs[0] policy
     /* 1871773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1871786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871807 */     // GIR_Coverage, 60474,
     /* 1871807 */     GIR_EraseRootFromParent_Done,
     /* 1871808 */   // Label 25157: @1871808
     /* 1871808 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1871894), // Rule ID 60475 //
     /* 1871813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1871824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1871827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1871830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871859 */     // MIs[0] policy
     /* 1871859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1871872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871893 */     // GIR_Coverage, 60475,
     /* 1871893 */     GIR_EraseRootFromParent_Done,
     /* 1871894 */   // Label 25158: @1871894
     /* 1871894 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1871980), // Rule ID 60478 //
     /* 1871899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1871902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871945 */     // MIs[0] policy
     /* 1871945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871955 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10862:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1871958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871979 */     // GIR_Coverage, 60478,
     /* 1871979 */     GIR_EraseRootFromParent_Done,
     /* 1871980 */   // Label 25159: @1871980
     /* 1871980 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1872066), // Rule ID 60479 //
     /* 1871985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1871988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1871993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1872002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872031 */     // MIs[0] policy
     /* 1872031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10862:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1872044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872065 */     // GIR_Coverage, 60479,
     /* 1872065 */     GIR_EraseRootFromParent_Done,
     /* 1872066 */   // Label 25160: @1872066
     /* 1872066 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1872152), // Rule ID 60482 //
     /* 1872071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1872074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1872079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872117 */     // MIs[0] policy
     /* 1872117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10862:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1872130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872151 */     // GIR_Coverage, 60482,
     /* 1872151 */     GIR_EraseRootFromParent_Done,
     /* 1872152 */   // Label 25161: @1872152
     /* 1872152 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1872238), // Rule ID 60483 //
     /* 1872157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1872160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1872165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872203 */     // MIs[0] policy
     /* 1872203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872213 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10862:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1872216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872237 */     // GIR_Coverage, 60483,
     /* 1872237 */     GIR_EraseRootFromParent_Done,
     /* 1872238 */   // Label 25162: @1872238
     /* 1872238 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1872324), // Rule ID 60486 //
     /* 1872243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1872246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1872251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872289 */     // MIs[0] policy
     /* 1872289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10862:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1872302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872323 */     // GIR_Coverage, 60486,
     /* 1872323 */     GIR_EraseRootFromParent_Done,
     /* 1872324 */   // Label 25163: @1872324
     /* 1872324 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1872410), // Rule ID 60487 //
     /* 1872329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1872332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1872337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872375 */     // MIs[0] policy
     /* 1872375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872385 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10862:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1872388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872409 */     // GIR_Coverage, 60487,
     /* 1872409 */     GIR_EraseRootFromParent_Done,
     /* 1872410 */   // Label 25164: @1872410
     /* 1872410 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1872496), // Rule ID 60490 //
     /* 1872415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1872418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1872426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1872429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1872432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1872435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872461 */     // MIs[0] policy
     /* 1872461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1872474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872495 */     // GIR_Coverage, 60490,
     /* 1872495 */     GIR_EraseRootFromParent_Done,
     /* 1872496 */   // Label 25165: @1872496
     /* 1872496 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1872582), // Rule ID 60491 //
     /* 1872501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1872504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1872512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1872515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1872518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1872521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872547 */     // MIs[0] policy
     /* 1872547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872557 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1872560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872581 */     // GIR_Coverage, 60491,
     /* 1872581 */     GIR_EraseRootFromParent_Done,
     /* 1872582 */   // Label 25166: @1872582
     /* 1872582 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1872668), // Rule ID 60494 //
     /* 1872587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1872590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872633 */     // MIs[0] policy
     /* 1872633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1872646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872667 */     // GIR_Coverage, 60494,
     /* 1872667 */     GIR_EraseRootFromParent_Done,
     /* 1872668 */   // Label 25167: @1872668
     /* 1872668 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1872754), // Rule ID 60495 //
     /* 1872673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1872676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872719 */     // MIs[0] policy
     /* 1872719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872729 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1872732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872753 */     // GIR_Coverage, 60495,
     /* 1872753 */     GIR_EraseRootFromParent_Done,
     /* 1872754 */   // Label 25168: @1872754
     /* 1872754 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1872840), // Rule ID 60498 //
     /* 1872759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1872762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872805 */     // MIs[0] policy
     /* 1872805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872815 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1872818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872839 */     // GIR_Coverage, 60498,
     /* 1872839 */     GIR_EraseRootFromParent_Done,
     /* 1872840 */   // Label 25169: @1872840
     /* 1872840 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1872926), // Rule ID 60499 //
     /* 1872845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1872848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872891 */     // MIs[0] policy
     /* 1872891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1872904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872925 */     // GIR_Coverage, 60499,
     /* 1872925 */     GIR_EraseRootFromParent_Done,
     /* 1872926 */   // Label 25170: @1872926
     /* 1872926 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1873012), // Rule ID 60502 //
     /* 1872931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1872934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1872939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1872942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1872945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1872948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1872951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872977 */     // MIs[0] policy
     /* 1872977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872987 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1872990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873011 */     // GIR_Coverage, 60502,
     /* 1873011 */     GIR_EraseRootFromParent_Done,
     /* 1873012 */   // Label 25171: @1873012
     /* 1873012 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1873098), // Rule ID 60503 //
     /* 1873017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1873028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1873031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1873034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1873037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873063 */     // MIs[0] policy
     /* 1873063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873073 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1873076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873097 */     // GIR_Coverage, 60503,
     /* 1873097 */     GIR_EraseRootFromParent_Done,
     /* 1873098 */   // Label 25172: @1873098
     /* 1873098 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1873184), // Rule ID 60506 //
     /* 1873103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1873123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873149 */     // MIs[0] policy
     /* 1873149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1873162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873183 */     // GIR_Coverage, 60506,
     /* 1873183 */     GIR_EraseRootFromParent_Done,
     /* 1873184 */   // Label 25173: @1873184
     /* 1873184 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1873270), // Rule ID 60507 //
     /* 1873189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1873209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873235 */     // MIs[0] policy
     /* 1873235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873245 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1873248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873269 */     // GIR_Coverage, 60507,
     /* 1873269 */     GIR_EraseRootFromParent_Done,
     /* 1873270 */   // Label 25174: @1873270
     /* 1873270 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1873356), // Rule ID 60510 //
     /* 1873275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1873295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873321 */     // MIs[0] policy
     /* 1873321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1873334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873355 */     // GIR_Coverage, 60510,
     /* 1873355 */     GIR_EraseRootFromParent_Done,
     /* 1873356 */   // Label 25175: @1873356
     /* 1873356 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1873442), // Rule ID 60511 //
     /* 1873361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1873381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873407 */     // MIs[0] policy
     /* 1873407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873417 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1873420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873441 */     // GIR_Coverage, 60511,
     /* 1873441 */     GIR_EraseRootFromParent_Done,
     /* 1873442 */   // Label 25176: @1873442
     /* 1873442 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1873528), // Rule ID 60514 //
     /* 1873447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1873458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1873461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1873464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1873467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873493 */     // MIs[0] policy
     /* 1873493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873503 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873527 */     // GIR_Coverage, 60514,
     /* 1873527 */     GIR_EraseRootFromParent_Done,
     /* 1873528 */   // Label 25177: @1873528
     /* 1873528 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1873614), // Rule ID 60515 //
     /* 1873533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1873544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1873547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1873550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1873553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873579 */     // MIs[0] policy
     /* 1873579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873589 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873613 */     // GIR_Coverage, 60515,
     /* 1873613 */     GIR_EraseRootFromParent_Done,
     /* 1873614 */   // Label 25178: @1873614
     /* 1873614 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1873700), // Rule ID 60518 //
     /* 1873619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873665 */     // MIs[0] policy
     /* 1873665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873699 */     // GIR_Coverage, 60518,
     /* 1873699 */     GIR_EraseRootFromParent_Done,
     /* 1873700 */   // Label 25179: @1873700
     /* 1873700 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1873786), // Rule ID 60519 //
     /* 1873705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873751 */     // MIs[0] policy
     /* 1873751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873761 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873785 */     // GIR_Coverage, 60519,
     /* 1873785 */     GIR_EraseRootFromParent_Done,
     /* 1873786 */   // Label 25180: @1873786
     /* 1873786 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1873872), // Rule ID 60522 //
     /* 1873791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873837 */     // MIs[0] policy
     /* 1873837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873871 */     // GIR_Coverage, 60522,
     /* 1873871 */     GIR_EraseRootFromParent_Done,
     /* 1873872 */   // Label 25181: @1873872
     /* 1873872 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1873958), // Rule ID 60523 //
     /* 1873877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1873880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873923 */     // MIs[0] policy
     /* 1873923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1873936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873957 */     // GIR_Coverage, 60523,
     /* 1873957 */     GIR_EraseRootFromParent_Done,
     /* 1873958 */   // Label 25182: @1873958
     /* 1873958 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1874044), // Rule ID 60526 //
     /* 1873963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1873966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1873971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874009 */     // MIs[0] policy
     /* 1874009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1874022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874043 */     // GIR_Coverage, 60526,
     /* 1874043 */     GIR_EraseRootFromParent_Done,
     /* 1874044 */   // Label 25183: @1874044
     /* 1874044 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1874130), // Rule ID 60527 //
     /* 1874049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1874060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1874063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1874066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1874069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1874072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874095 */     // MIs[0] policy
     /* 1874095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874105 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1874108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874129 */     // GIR_Coverage, 60527,
     /* 1874129 */     GIR_EraseRootFromParent_Done,
     /* 1874130 */   // Label 25184: @1874130
     /* 1874130 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1874216), // Rule ID 60530 //
     /* 1874135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1874155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874181 */     // MIs[0] policy
     /* 1874181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874191 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1874194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874215 */     // GIR_Coverage, 60530,
     /* 1874215 */     GIR_EraseRootFromParent_Done,
     /* 1874216 */   // Label 25185: @1874216
     /* 1874216 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1874302), // Rule ID 60531 //
     /* 1874221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1874241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874267 */     // MIs[0] policy
     /* 1874267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1874280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874301 */     // GIR_Coverage, 60531,
     /* 1874301 */     GIR_EraseRootFromParent_Done,
     /* 1874302 */   // Label 25186: @1874302
     /* 1874302 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1874388), // Rule ID 60534 //
     /* 1874307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1874318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1874321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1874324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1874327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874353 */     // MIs[0] policy
     /* 1874353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874363 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1874366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874387 */     // GIR_Coverage, 60534,
     /* 1874387 */     GIR_EraseRootFromParent_Done,
     /* 1874388 */   // Label 25187: @1874388
     /* 1874388 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1874474), // Rule ID 60535 //
     /* 1874393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1874404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1874407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1874410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1874413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874439 */     // MIs[0] policy
     /* 1874439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874449 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1874452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874473 */     // GIR_Coverage, 60535,
     /* 1874473 */     GIR_EraseRootFromParent_Done,
     /* 1874474 */   // Label 25188: @1874474
     /* 1874474 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1874560), // Rule ID 60538 //
     /* 1874479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874525 */     // MIs[0] policy
     /* 1874525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874535 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1874538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874559 */     // GIR_Coverage, 60538,
     /* 1874559 */     GIR_EraseRootFromParent_Done,
     /* 1874560 */   // Label 25189: @1874560
     /* 1874560 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1874646), // Rule ID 60539 //
     /* 1874565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874611 */     // MIs[0] policy
     /* 1874611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1874624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874645 */     // GIR_Coverage, 60539,
     /* 1874645 */     GIR_EraseRootFromParent_Done,
     /* 1874646 */   // Label 25190: @1874646
     /* 1874646 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1874732), // Rule ID 60542 //
     /* 1874651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874697 */     // MIs[0] policy
     /* 1874697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1874710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874731 */     // GIR_Coverage, 60542,
     /* 1874731 */     GIR_EraseRootFromParent_Done,
     /* 1874732 */   // Label 25191: @1874732
     /* 1874732 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1874818), // Rule ID 60543 //
     /* 1874737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874783 */     // MIs[0] policy
     /* 1874783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1874796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874817 */     // GIR_Coverage, 60543,
     /* 1874817 */     GIR_EraseRootFromParent_Done,
     /* 1874818 */   // Label 25192: @1874818
     /* 1874818 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1874904), // Rule ID 60546 //
     /* 1874823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874869 */     // MIs[0] policy
     /* 1874869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874879 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1874882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874903 */     // GIR_Coverage, 60546,
     /* 1874903 */     GIR_EraseRootFromParent_Done,
     /* 1874904 */   // Label 25193: @1874904
     /* 1874904 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1874990), // Rule ID 60547 //
     /* 1874909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1874912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1874917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874955 */     // MIs[0] policy
     /* 1874955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874965 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1874968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874989 */     // GIR_Coverage, 60547,
     /* 1874989 */     GIR_EraseRootFromParent_Done,
     /* 1874990 */   // Label 25194: @1874990
     /* 1874990 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1875076), // Rule ID 60550 //
     /* 1874995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1874998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1875015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875041 */     // MIs[0] policy
     /* 1875041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875051 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1875054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875075 */     // GIR_Coverage, 60550,
     /* 1875075 */     GIR_EraseRootFromParent_Done,
     /* 1875076 */   // Label 25195: @1875076
     /* 1875076 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1875162), // Rule ID 60551 //
     /* 1875081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1875101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875127 */     // MIs[0] policy
     /* 1875127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875137 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1875140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875161 */     // GIR_Coverage, 60551,
     /* 1875161 */     GIR_EraseRootFromParent_Done,
     /* 1875162 */   // Label 25196: @1875162
     /* 1875162 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1875248), // Rule ID 60554 //
     /* 1875167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1875170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1875187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875213 */     // MIs[0] policy
     /* 1875213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1875226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875247 */     // GIR_Coverage, 60554,
     /* 1875247 */     GIR_EraseRootFromParent_Done,
     /* 1875248 */   // Label 25197: @1875248
     /* 1875248 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1875334), // Rule ID 60555 //
     /* 1875253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1875273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875299 */     // MIs[0] policy
     /* 1875299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1875312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875333 */     // GIR_Coverage, 60555,
     /* 1875333 */     GIR_EraseRootFromParent_Done,
     /* 1875334 */   // Label 25198: @1875334
     /* 1875334 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1875420), // Rule ID 60558 //
     /* 1875339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1875342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1875350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1875353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1875356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1875359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875385 */     // MIs[0] policy
     /* 1875385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1875398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875419 */     // GIR_Coverage, 60558,
     /* 1875419 */     GIR_EraseRootFromParent_Done,
     /* 1875420 */   // Label 25199: @1875420
     /* 1875420 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1875506), // Rule ID 60559 //
     /* 1875425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1875436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1875439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1875442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1875445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875471 */     // MIs[0] policy
     /* 1875471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1875484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875505 */     // GIR_Coverage, 60559,
     /* 1875505 */     GIR_EraseRootFromParent_Done,
     /* 1875506 */   // Label 25200: @1875506
     /* 1875506 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1875592), // Rule ID 60562 //
     /* 1875511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1875514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875557 */     // MIs[0] policy
     /* 1875557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875567 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1875570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875591 */     // GIR_Coverage, 60562,
     /* 1875591 */     GIR_EraseRootFromParent_Done,
     /* 1875592 */   // Label 25201: @1875592
     /* 1875592 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1875678), // Rule ID 60563 //
     /* 1875597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875643 */     // MIs[0] policy
     /* 1875643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875653 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1875656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875677 */     // GIR_Coverage, 60563,
     /* 1875677 */     GIR_EraseRootFromParent_Done,
     /* 1875678 */   // Label 25202: @1875678
     /* 1875678 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1875764), // Rule ID 60566 //
     /* 1875683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1875686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875729 */     // MIs[0] policy
     /* 1875729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1875742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875763 */     // GIR_Coverage, 60566,
     /* 1875763 */     GIR_EraseRootFromParent_Done,
     /* 1875764 */   // Label 25203: @1875764
     /* 1875764 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1875850), // Rule ID 60567 //
     /* 1875769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875815 */     // MIs[0] policy
     /* 1875815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1875828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875849 */     // GIR_Coverage, 60567,
     /* 1875849 */     GIR_EraseRootFromParent_Done,
     /* 1875850 */   // Label 25204: @1875850
     /* 1875850 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1875936), // Rule ID 60570 //
     /* 1875855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1875858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875901 */     // MIs[0] policy
     /* 1875901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875911 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1875914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875935 */     // GIR_Coverage, 60570,
     /* 1875935 */     GIR_EraseRootFromParent_Done,
     /* 1875936 */   // Label 25205: @1875936
     /* 1875936 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1876022), // Rule ID 60571 //
     /* 1875941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1875944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1875949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875987 */     // MIs[0] policy
     /* 1875987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875997 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1876000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876021 */     // GIR_Coverage, 60571,
     /* 1876021 */     GIR_EraseRootFromParent_Done,
     /* 1876022 */   // Label 25206: @1876022
     /* 1876022 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1876108), // Rule ID 60574 //
     /* 1876027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1876047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876073 */     // MIs[0] policy
     /* 1876073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876083 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1876086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876107 */     // GIR_Coverage, 60574,
     /* 1876107 */     GIR_EraseRootFromParent_Done,
     /* 1876108 */   // Label 25207: @1876108
     /* 1876108 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1876194), // Rule ID 60575 //
     /* 1876113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1876133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876159 */     // MIs[0] policy
     /* 1876159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1876172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876193 */     // GIR_Coverage, 60575,
     /* 1876193 */     GIR_EraseRootFromParent_Done,
     /* 1876194 */   // Label 25208: @1876194
     /* 1876194 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1876280), // Rule ID 60578 //
     /* 1876199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1876210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1876213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1876216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876245 */     // MIs[0] policy
     /* 1876245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1876258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876279 */     // GIR_Coverage, 60578,
     /* 1876279 */     GIR_EraseRootFromParent_Done,
     /* 1876280 */   // Label 25209: @1876280
     /* 1876280 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1876366), // Rule ID 60579 //
     /* 1876285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1876296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1876299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1876302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876331 */     // MIs[0] policy
     /* 1876331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876341 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1876344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876365 */     // GIR_Coverage, 60579,
     /* 1876365 */     GIR_EraseRootFromParent_Done,
     /* 1876366 */   // Label 25210: @1876366
     /* 1876366 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1876452), // Rule ID 60582 //
     /* 1876371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1876382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1876385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1876388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876417 */     // MIs[0] policy
     /* 1876417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876427 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1876430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876451 */     // GIR_Coverage, 60582,
     /* 1876451 */     GIR_EraseRootFromParent_Done,
     /* 1876452 */   // Label 25211: @1876452
     /* 1876452 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1876538), // Rule ID 60583 //
     /* 1876457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1876468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1876471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1876474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876503 */     // MIs[0] policy
     /* 1876503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876513 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1876516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876537 */     // GIR_Coverage, 60583,
     /* 1876537 */     GIR_EraseRootFromParent_Done,
     /* 1876538 */   // Label 25212: @1876538
     /* 1876538 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1876624), // Rule ID 60586 //
     /* 1876543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876589 */     // MIs[0] policy
     /* 1876589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876599 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1876602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876623 */     // GIR_Coverage, 60586,
     /* 1876623 */     GIR_EraseRootFromParent_Done,
     /* 1876624 */   // Label 25213: @1876624
     /* 1876624 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1876710), // Rule ID 60587 //
     /* 1876629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876675 */     // MIs[0] policy
     /* 1876675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876685 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1876688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876709 */     // GIR_Coverage, 60587,
     /* 1876709 */     GIR_EraseRootFromParent_Done,
     /* 1876710 */   // Label 25214: @1876710
     /* 1876710 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1876796), // Rule ID 60590 //
     /* 1876715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876761 */     // MIs[0] policy
     /* 1876761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1876774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876795 */     // GIR_Coverage, 60590,
     /* 1876795 */     GIR_EraseRootFromParent_Done,
     /* 1876796 */   // Label 25215: @1876796
     /* 1876796 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1876882), // Rule ID 60591 //
     /* 1876801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876847 */     // MIs[0] policy
     /* 1876847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876857 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1876860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876881 */     // GIR_Coverage, 60591,
     /* 1876881 */     GIR_EraseRootFromParent_Done,
     /* 1876882 */   // Label 25216: @1876882
     /* 1876882 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1876968), // Rule ID 60594 //
     /* 1876887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1876890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876933 */     // MIs[0] policy
     /* 1876933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876943 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1876946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876967 */     // GIR_Coverage, 60594,
     /* 1876967 */     GIR_EraseRootFromParent_Done,
     /* 1876968 */   // Label 25217: @1876968
     /* 1876968 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1877054), // Rule ID 60595 //
     /* 1876973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1876976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1876981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877019 */     // MIs[0] policy
     /* 1877019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877029 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1877032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877053 */     // GIR_Coverage, 60595,
     /* 1877053 */     GIR_EraseRootFromParent_Done,
     /* 1877054 */   // Label 25218: @1877054
     /* 1877054 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1877140), // Rule ID 60598 //
     /* 1877059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877105 */     // MIs[0] policy
     /* 1877105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1877118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877139 */     // GIR_Coverage, 60598,
     /* 1877139 */     GIR_EraseRootFromParent_Done,
     /* 1877140 */   // Label 25219: @1877140
     /* 1877140 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1877226), // Rule ID 60599 //
     /* 1877145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1877148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877191 */     // MIs[0] policy
     /* 1877191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877201 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1877204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877225 */     // GIR_Coverage, 60599,
     /* 1877225 */     GIR_EraseRootFromParent_Done,
     /* 1877226 */   // Label 25220: @1877226
     /* 1877226 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1877312), // Rule ID 60602 //
     /* 1877231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1877242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1877245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1877248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877277 */     // MIs[0] policy
     /* 1877277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877287 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877311 */     // GIR_Coverage, 60602,
     /* 1877311 */     GIR_EraseRootFromParent_Done,
     /* 1877312 */   // Label 25221: @1877312
     /* 1877312 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1877398), // Rule ID 60603 //
     /* 1877317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1877320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1877328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1877331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1877334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877363 */     // MIs[0] policy
     /* 1877363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877373 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10850:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877397 */     // GIR_Coverage, 60603,
     /* 1877397 */     GIR_EraseRootFromParent_Done,
     /* 1877398 */   // Label 25222: @1877398
     /* 1877398 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1877484), // Rule ID 60606 //
     /* 1877403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877449 */     // MIs[0] policy
     /* 1877449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877483 */     // GIR_Coverage, 60606,
     /* 1877483 */     GIR_EraseRootFromParent_Done,
     /* 1877484 */   // Label 25223: @1877484
     /* 1877484 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1877570), // Rule ID 60607 //
     /* 1877489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1877492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877535 */     // MIs[0] policy
     /* 1877535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877545 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877569 */     // GIR_Coverage, 60607,
     /* 1877569 */     GIR_EraseRootFromParent_Done,
     /* 1877570 */   // Label 25224: @1877570
     /* 1877570 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1877656), // Rule ID 60610 //
     /* 1877575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877621 */     // MIs[0] policy
     /* 1877621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877655 */     // GIR_Coverage, 60610,
     /* 1877655 */     GIR_EraseRootFromParent_Done,
     /* 1877656 */   // Label 25225: @1877656
     /* 1877656 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1877742), // Rule ID 60611 //
     /* 1877661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1877664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877707 */     // MIs[0] policy
     /* 1877707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877717 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877741 */     // GIR_Coverage, 60611,
     /* 1877741 */     GIR_EraseRootFromParent_Done,
     /* 1877742 */   // Label 25226: @1877742
     /* 1877742 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1877828), // Rule ID 60614 //
     /* 1877747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877793 */     // MIs[0] policy
     /* 1877793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877803 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877827 */     // GIR_Coverage, 60614,
     /* 1877827 */     GIR_EraseRootFromParent_Done,
     /* 1877828 */   // Label 25227: @1877828
     /* 1877828 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1877914), // Rule ID 60615 //
     /* 1877833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1877836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877879 */     // MIs[0] policy
     /* 1877879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1877892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877913 */     // GIR_Coverage, 60615,
     /* 1877913 */     GIR_EraseRootFromParent_Done,
     /* 1877914 */   // Label 25228: @1877914
     /* 1877914 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1878000), // Rule ID 60618 //
     /* 1877919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1877922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1877927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877965 */     // MIs[0] policy
     /* 1877965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1877978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877999 */     // GIR_Coverage, 60618,
     /* 1877999 */     GIR_EraseRootFromParent_Done,
     /* 1878000 */   // Label 25229: @1878000
     /* 1878000 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1878086), // Rule ID 60619 //
     /* 1878005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1878016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1878019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1878022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878051 */     // MIs[0] policy
     /* 1878051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878061 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1878064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878085 */     // GIR_Coverage, 60619,
     /* 1878085 */     GIR_EraseRootFromParent_Done,
     /* 1878086 */   // Label 25230: @1878086
     /* 1878086 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1878172), // Rule ID 60622 //
     /* 1878091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878137 */     // MIs[0] policy
     /* 1878137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878147 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1878150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878171 */     // GIR_Coverage, 60622,
     /* 1878171 */     GIR_EraseRootFromParent_Done,
     /* 1878172 */   // Label 25231: @1878172
     /* 1878172 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1878258), // Rule ID 60623 //
     /* 1878177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878223 */     // MIs[0] policy
     /* 1878223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878233 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1878236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878257 */     // GIR_Coverage, 60623,
     /* 1878257 */     GIR_EraseRootFromParent_Done,
     /* 1878258 */   // Label 25232: @1878258
     /* 1878258 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1878344), // Rule ID 60626 //
     /* 1878263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1878274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1878277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1878280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1878286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878309 */     // MIs[0] policy
     /* 1878309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878319 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1878322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878343 */     // GIR_Coverage, 60626,
     /* 1878343 */     GIR_EraseRootFromParent_Done,
     /* 1878344 */   // Label 25233: @1878344
     /* 1878344 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1878430), // Rule ID 60627 //
     /* 1878349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1878360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1878363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1878366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1878372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878395 */     // MIs[0] policy
     /* 1878395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878405 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1878408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878429 */     // GIR_Coverage, 60627,
     /* 1878429 */     GIR_EraseRootFromParent_Done,
     /* 1878430 */   // Label 25234: @1878430
     /* 1878430 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1878516), // Rule ID 60630 //
     /* 1878435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878481 */     // MIs[0] policy
     /* 1878481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1878494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878515 */     // GIR_Coverage, 60630,
     /* 1878515 */     GIR_EraseRootFromParent_Done,
     /* 1878516 */   // Label 25235: @1878516
     /* 1878516 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1878602), // Rule ID 60631 //
     /* 1878521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878567 */     // MIs[0] policy
     /* 1878567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1878580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878601 */     // GIR_Coverage, 60631,
     /* 1878601 */     GIR_EraseRootFromParent_Done,
     /* 1878602 */   // Label 25236: @1878602
     /* 1878602 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1878688), // Rule ID 60634 //
     /* 1878607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878653 */     // MIs[0] policy
     /* 1878653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878663 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1878666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878687 */     // GIR_Coverage, 60634,
     /* 1878687 */     GIR_EraseRootFromParent_Done,
     /* 1878688 */   // Label 25237: @1878688
     /* 1878688 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1878774), // Rule ID 60635 //
     /* 1878693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878739 */     // MIs[0] policy
     /* 1878739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878749 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1878752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878773 */     // GIR_Coverage, 60635,
     /* 1878773 */     GIR_EraseRootFromParent_Done,
     /* 1878774 */   // Label 25238: @1878774
     /* 1878774 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1878860), // Rule ID 60638 //
     /* 1878779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878825 */     // MIs[0] policy
     /* 1878825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878835 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1878838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878859 */     // GIR_Coverage, 60638,
     /* 1878859 */     GIR_EraseRootFromParent_Done,
     /* 1878860 */   // Label 25239: @1878860
     /* 1878860 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1878946), // Rule ID 60639 //
     /* 1878865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1878868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878911 */     // MIs[0] policy
     /* 1878911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1878924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878945 */     // GIR_Coverage, 60639,
     /* 1878945 */     GIR_EraseRootFromParent_Done,
     /* 1878946 */   // Label 25240: @1878946
     /* 1878946 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1879032), // Rule ID 60642 //
     /* 1878951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1878954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1878959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878997 */     // MIs[0] policy
     /* 1878997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1879010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879031 */     // GIR_Coverage, 60642,
     /* 1879031 */     GIR_EraseRootFromParent_Done,
     /* 1879032 */   // Label 25241: @1879032
     /* 1879032 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1879118), // Rule ID 60643 //
     /* 1879037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1879048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1879051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1879054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879083 */     // MIs[0] policy
     /* 1879083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1879096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879117 */     // GIR_Coverage, 60643,
     /* 1879117 */     GIR_EraseRootFromParent_Done,
     /* 1879118 */   // Label 25242: @1879118
     /* 1879118 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1879204), // Rule ID 60646 //
     /* 1879123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1879134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1879137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1879140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879169 */     // MIs[0] policy
     /* 1879169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879179 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1879182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879203 */     // GIR_Coverage, 60646,
     /* 1879203 */     GIR_EraseRootFromParent_Done,
     /* 1879204 */   // Label 25243: @1879204
     /* 1879204 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1879290), // Rule ID 60647 //
     /* 1879209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1879220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1879223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1879226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879255 */     // MIs[0] policy
     /* 1879255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879265 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1879268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879289 */     // GIR_Coverage, 60647,
     /* 1879289 */     GIR_EraseRootFromParent_Done,
     /* 1879290 */   // Label 25244: @1879290
     /* 1879290 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1879376), // Rule ID 60650 //
     /* 1879295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1879306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1879309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1879312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879341 */     // MIs[0] policy
     /* 1879341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879351 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1879354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879375 */     // GIR_Coverage, 60650,
     /* 1879375 */     GIR_EraseRootFromParent_Done,
     /* 1879376 */   // Label 25245: @1879376
     /* 1879376 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1879462), // Rule ID 60651 //
     /* 1879381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1879392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1879395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1879398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879427 */     // MIs[0] policy
     /* 1879427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879437 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1879440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879461 */     // GIR_Coverage, 60651,
     /* 1879461 */     GIR_EraseRootFromParent_Done,
     /* 1879462 */   // Label 25246: @1879462
     /* 1879462 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1879548), // Rule ID 60654 //
     /* 1879467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879513 */     // MIs[0] policy
     /* 1879513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1879526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879547 */     // GIR_Coverage, 60654,
     /* 1879547 */     GIR_EraseRootFromParent_Done,
     /* 1879548 */   // Label 25247: @1879548
     /* 1879548 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1879634), // Rule ID 60655 //
     /* 1879553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879599 */     // MIs[0] policy
     /* 1879599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1879612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879633 */     // GIR_Coverage, 60655,
     /* 1879633 */     GIR_EraseRootFromParent_Done,
     /* 1879634 */   // Label 25248: @1879634
     /* 1879634 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1879720), // Rule ID 60658 //
     /* 1879639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879685 */     // MIs[0] policy
     /* 1879685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879695 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1879698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879719 */     // GIR_Coverage, 60658,
     /* 1879719 */     GIR_EraseRootFromParent_Done,
     /* 1879720 */   // Label 25249: @1879720
     /* 1879720 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1879806), // Rule ID 60659 //
     /* 1879725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879771 */     // MIs[0] policy
     /* 1879771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879781 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1879784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879805 */     // GIR_Coverage, 60659,
     /* 1879805 */     GIR_EraseRootFromParent_Done,
     /* 1879806 */   // Label 25250: @1879806
     /* 1879806 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1879892), // Rule ID 60662 //
     /* 1879811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879857 */     // MIs[0] policy
     /* 1879857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879867 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1879870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879891 */     // GIR_Coverage, 60662,
     /* 1879891 */     GIR_EraseRootFromParent_Done,
     /* 1879892 */   // Label 25251: @1879892
     /* 1879892 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1879978), // Rule ID 60663 //
     /* 1879897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1879900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1879905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879943 */     // MIs[0] policy
     /* 1879943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879953 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1879956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879977 */     // GIR_Coverage, 60663,
     /* 1879977 */     GIR_EraseRootFromParent_Done,
     /* 1879978 */   // Label 25252: @1879978
     /* 1879978 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1880064), // Rule ID 60842 //
     /* 1879983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1879986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1879991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1880003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880029 */     // MIs[0] policy
     /* 1880029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1880042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880063 */     // GIR_Coverage, 60842,
     /* 1880063 */     GIR_EraseRootFromParent_Done,
     /* 1880064 */   // Label 25253: @1880064
     /* 1880064 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1880150), // Rule ID 60843 //
     /* 1880069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1880080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1880083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1880089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880115 */     // MIs[0] policy
     /* 1880115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880125 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1880128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880149 */     // GIR_Coverage, 60843,
     /* 1880149 */     GIR_EraseRootFromParent_Done,
     /* 1880150 */   // Label 25254: @1880150
     /* 1880150 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1880236), // Rule ID 60846 //
     /* 1880155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1880158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1880166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1880169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1880172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1880175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880201 */     // MIs[0] policy
     /* 1880201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880211 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1880214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880235 */     // GIR_Coverage, 60846,
     /* 1880235 */     GIR_EraseRootFromParent_Done,
     /* 1880236 */   // Label 25255: @1880236
     /* 1880236 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1880322), // Rule ID 60847 //
     /* 1880241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1880252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1880255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1880258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1880261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880287 */     // MIs[0] policy
     /* 1880287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880297 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1880300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880321 */     // GIR_Coverage, 60847,
     /* 1880321 */     GIR_EraseRootFromParent_Done,
     /* 1880322 */   // Label 25256: @1880322
     /* 1880322 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1880408), // Rule ID 60850 //
     /* 1880327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1880330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880373 */     // MIs[0] policy
     /* 1880373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880383 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880407 */     // GIR_Coverage, 60850,
     /* 1880407 */     GIR_EraseRootFromParent_Done,
     /* 1880408 */   // Label 25257: @1880408
     /* 1880408 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1880494), // Rule ID 60851 //
     /* 1880413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880459 */     // MIs[0] policy
     /* 1880459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880493 */     // GIR_Coverage, 60851,
     /* 1880493 */     GIR_EraseRootFromParent_Done,
     /* 1880494 */   // Label 25258: @1880494
     /* 1880494 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1880580), // Rule ID 60854 //
     /* 1880499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1880502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880545 */     // MIs[0] policy
     /* 1880545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880555 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1880558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880579 */     // GIR_Coverage, 60854,
     /* 1880579 */     GIR_EraseRootFromParent_Done,
     /* 1880580 */   // Label 25259: @1880580
     /* 1880580 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1880666), // Rule ID 60855 //
     /* 1880585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880631 */     // MIs[0] policy
     /* 1880631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880641 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1880644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880665 */     // GIR_Coverage, 60855,
     /* 1880665 */     GIR_EraseRootFromParent_Done,
     /* 1880666 */   // Label 25260: @1880666
     /* 1880666 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1880752), // Rule ID 60858 //
     /* 1880671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1880674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880717 */     // MIs[0] policy
     /* 1880717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880751 */     // GIR_Coverage, 60858,
     /* 1880751 */     GIR_EraseRootFromParent_Done,
     /* 1880752 */   // Label 25261: @1880752
     /* 1880752 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1880838), // Rule ID 60859 //
     /* 1880757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880803 */     // MIs[0] policy
     /* 1880803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880813 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880837 */     // GIR_Coverage, 60859,
     /* 1880837 */     GIR_EraseRootFromParent_Done,
     /* 1880838 */   // Label 25262: @1880838
     /* 1880838 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1880924), // Rule ID 60862 //
     /* 1880843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1880846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880889 */     // MIs[0] policy
     /* 1880889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880923 */     // GIR_Coverage, 60862,
     /* 1880923 */     GIR_EraseRootFromParent_Done,
     /* 1880924 */   // Label 25263: @1880924
     /* 1880924 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1881010), // Rule ID 60863 //
     /* 1880929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1880932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1880937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880975 */     // MIs[0] policy
     /* 1880975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880985 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1880988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881009 */     // GIR_Coverage, 60863,
     /* 1881009 */     GIR_EraseRootFromParent_Done,
     /* 1881010 */   // Label 25264: @1881010
     /* 1881010 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1881096), // Rule ID 60866 //
     /* 1881015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1881035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881061 */     // MIs[0] policy
     /* 1881061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881095 */     // GIR_Coverage, 60866,
     /* 1881095 */     GIR_EraseRootFromParent_Done,
     /* 1881096 */   // Label 25265: @1881096
     /* 1881096 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1881182), // Rule ID 60867 //
     /* 1881101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1881121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881147 */     // MIs[0] policy
     /* 1881147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881181 */     // GIR_Coverage, 60867,
     /* 1881181 */     GIR_EraseRootFromParent_Done,
     /* 1881182 */   // Label 25266: @1881182
     /* 1881182 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1881268), // Rule ID 60870 //
     /* 1881187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1881198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1881201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1881204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1881207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881233 */     // MIs[0] policy
     /* 1881233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881267 */     // GIR_Coverage, 60870,
     /* 1881267 */     GIR_EraseRootFromParent_Done,
     /* 1881268 */   // Label 25267: @1881268
     /* 1881268 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1881354), // Rule ID 60871 //
     /* 1881273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1881284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1881287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1881290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1881293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881319 */     // MIs[0] policy
     /* 1881319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881329 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881353 */     // GIR_Coverage, 60871,
     /* 1881353 */     GIR_EraseRootFromParent_Done,
     /* 1881354 */   // Label 25268: @1881354
     /* 1881354 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1881440), // Rule ID 60874 //
     /* 1881359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881405 */     // MIs[0] policy
     /* 1881405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881415 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881439 */     // GIR_Coverage, 60874,
     /* 1881439 */     GIR_EraseRootFromParent_Done,
     /* 1881440 */   // Label 25269: @1881440
     /* 1881440 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1881526), // Rule ID 60875 //
     /* 1881445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881491 */     // MIs[0] policy
     /* 1881491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881525 */     // GIR_Coverage, 60875,
     /* 1881525 */     GIR_EraseRootFromParent_Done,
     /* 1881526 */   // Label 25270: @1881526
     /* 1881526 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1881612), // Rule ID 60878 //
     /* 1881531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881577 */     // MIs[0] policy
     /* 1881577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881587 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881611 */     // GIR_Coverage, 60878,
     /* 1881611 */     GIR_EraseRootFromParent_Done,
     /* 1881612 */   // Label 25271: @1881612
     /* 1881612 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1881698), // Rule ID 60879 //
     /* 1881617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881663 */     // MIs[0] policy
     /* 1881663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881673 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1881676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881697 */     // GIR_Coverage, 60879,
     /* 1881697 */     GIR_EraseRootFromParent_Done,
     /* 1881698 */   // Label 25272: @1881698
     /* 1881698 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1881784), // Rule ID 60882 //
     /* 1881703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881749 */     // MIs[0] policy
     /* 1881749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1881762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881783 */     // GIR_Coverage, 60882,
     /* 1881783 */     GIR_EraseRootFromParent_Done,
     /* 1881784 */   // Label 25273: @1881784
     /* 1881784 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1881870), // Rule ID 60883 //
     /* 1881789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881835 */     // MIs[0] policy
     /* 1881835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881845 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1881848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881869 */     // GIR_Coverage, 60883,
     /* 1881869 */     GIR_EraseRootFromParent_Done,
     /* 1881870 */   // Label 25274: @1881870
     /* 1881870 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1881956), // Rule ID 60886 //
     /* 1881875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1881878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881921 */     // MIs[0] policy
     /* 1881921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881931 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1881934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881955 */     // GIR_Coverage, 60886,
     /* 1881955 */     GIR_EraseRootFromParent_Done,
     /* 1881956 */   // Label 25275: @1881956
     /* 1881956 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1882042), // Rule ID 60887 //
     /* 1881961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1881964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1881969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882007 */     // MIs[0] policy
     /* 1882007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882017 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1882020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882041 */     // GIR_Coverage, 60887,
     /* 1882041 */     GIR_EraseRootFromParent_Done,
     /* 1882042 */   // Label 25276: @1882042
     /* 1882042 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1882128), // Rule ID 60890 //
     /* 1882047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1882058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1882061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1882064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1882067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1882070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882093 */     // MIs[0] policy
     /* 1882093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882103 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1882106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882127 */     // GIR_Coverage, 60890,
     /* 1882127 */     GIR_EraseRootFromParent_Done,
     /* 1882128 */   // Label 25277: @1882128
     /* 1882128 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1882214), // Rule ID 60891 //
     /* 1882133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1882144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1882147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1882150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1882153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1882156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882179 */     // MIs[0] policy
     /* 1882179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882189 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1882192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882213 */     // GIR_Coverage, 60891,
     /* 1882213 */     GIR_EraseRootFromParent_Done,
     /* 1882214 */   // Label 25278: @1882214
     /* 1882214 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1882300), // Rule ID 60894 //
     /* 1882219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882265 */     // MIs[0] policy
     /* 1882265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1882278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882299 */     // GIR_Coverage, 60894,
     /* 1882299 */     GIR_EraseRootFromParent_Done,
     /* 1882300 */   // Label 25279: @1882300
     /* 1882300 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1882386), // Rule ID 60895 //
     /* 1882305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882351 */     // MIs[0] policy
     /* 1882351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1882364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882385 */     // GIR_Coverage, 60895,
     /* 1882385 */     GIR_EraseRootFromParent_Done,
     /* 1882386 */   // Label 25280: @1882386
     /* 1882386 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1882472), // Rule ID 60898 //
     /* 1882391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882437 */     // MIs[0] policy
     /* 1882437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882447 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1882450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882471 */     // GIR_Coverage, 60898,
     /* 1882471 */     GIR_EraseRootFromParent_Done,
     /* 1882472 */   // Label 25281: @1882472
     /* 1882472 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1882558), // Rule ID 60899 //
     /* 1882477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882523 */     // MIs[0] policy
     /* 1882523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1882536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882557 */     // GIR_Coverage, 60899,
     /* 1882557 */     GIR_EraseRootFromParent_Done,
     /* 1882558 */   // Label 25282: @1882558
     /* 1882558 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1882644), // Rule ID 60902 //
     /* 1882563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882609 */     // MIs[0] policy
     /* 1882609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882619 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1882622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882643 */     // GIR_Coverage, 60902,
     /* 1882643 */     GIR_EraseRootFromParent_Done,
     /* 1882644 */   // Label 25283: @1882644
     /* 1882644 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1882730), // Rule ID 60903 //
     /* 1882649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882695 */     // MIs[0] policy
     /* 1882695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882705 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1882708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882729 */     // GIR_Coverage, 60903,
     /* 1882729 */     GIR_EraseRootFromParent_Done,
     /* 1882730 */   // Label 25284: @1882730
     /* 1882730 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1882816), // Rule ID 60906 //
     /* 1882735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882781 */     // MIs[0] policy
     /* 1882781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1882794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882815 */     // GIR_Coverage, 60906,
     /* 1882815 */     GIR_EraseRootFromParent_Done,
     /* 1882816 */   // Label 25285: @1882816
     /* 1882816 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1882902), // Rule ID 60907 //
     /* 1882821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882867 */     // MIs[0] policy
     /* 1882867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1882880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882901 */     // GIR_Coverage, 60907,
     /* 1882901 */     GIR_EraseRootFromParent_Done,
     /* 1882902 */   // Label 25286: @1882902
     /* 1882902 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1882988), // Rule ID 60910 //
     /* 1882907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1882910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1882915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882953 */     // MIs[0] policy
     /* 1882953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1882966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882987 */     // GIR_Coverage, 60910,
     /* 1882987 */     GIR_EraseRootFromParent_Done,
     /* 1882988 */   // Label 25287: @1882988
     /* 1882988 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1883074), // Rule ID 60911 //
     /* 1882993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1882996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1883004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1883007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1883010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1883013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883039 */     // MIs[0] policy
     /* 1883039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883049 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1883052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883073 */     // GIR_Coverage, 60911,
     /* 1883073 */     GIR_EraseRootFromParent_Done,
     /* 1883074 */   // Label 25288: @1883074
     /* 1883074 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1883160), // Rule ID 60914 //
     /* 1883079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1883090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1883093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1883096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1883099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883125 */     // MIs[0] policy
     /* 1883125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883135 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1883138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883159 */     // GIR_Coverage, 60914,
     /* 1883159 */     GIR_EraseRootFromParent_Done,
     /* 1883160 */   // Label 25289: @1883160
     /* 1883160 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1883246), // Rule ID 60915 //
     /* 1883165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1883168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1883176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1883179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1883182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1883185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883211 */     // MIs[0] policy
     /* 1883211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883221 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1883224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883245 */     // GIR_Coverage, 60915,
     /* 1883245 */     GIR_EraseRootFromParent_Done,
     /* 1883246 */   // Label 25290: @1883246
     /* 1883246 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1883332), // Rule ID 60918 //
     /* 1883251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883297 */     // MIs[0] policy
     /* 1883297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1883310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883331 */     // GIR_Coverage, 60918,
     /* 1883331 */     GIR_EraseRootFromParent_Done,
     /* 1883332 */   // Label 25291: @1883332
     /* 1883332 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1883418), // Rule ID 60919 //
     /* 1883337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1883340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883383 */     // MIs[0] policy
     /* 1883383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1883396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883417 */     // GIR_Coverage, 60919,
     /* 1883417 */     GIR_EraseRootFromParent_Done,
     /* 1883418 */   // Label 25292: @1883418
     /* 1883418 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1883504), // Rule ID 60922 //
     /* 1883423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883469 */     // MIs[0] policy
     /* 1883469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883479 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1883482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883503 */     // GIR_Coverage, 60922,
     /* 1883503 */     GIR_EraseRootFromParent_Done,
     /* 1883504 */   // Label 25293: @1883504
     /* 1883504 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1883590), // Rule ID 60923 //
     /* 1883509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1883512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883555 */     // MIs[0] policy
     /* 1883555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1883568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883589 */     // GIR_Coverage, 60923,
     /* 1883589 */     GIR_EraseRootFromParent_Done,
     /* 1883590 */   // Label 25294: @1883590
     /* 1883590 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1883676), // Rule ID 60926 //
     /* 1883595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883641 */     // MIs[0] policy
     /* 1883641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1883654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883675 */     // GIR_Coverage, 60926,
     /* 1883675 */     GIR_EraseRootFromParent_Done,
     /* 1883676 */   // Label 25295: @1883676
     /* 1883676 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1883762), // Rule ID 60927 //
     /* 1883681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1883684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883727 */     // MIs[0] policy
     /* 1883727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1883740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883761 */     // GIR_Coverage, 60927,
     /* 1883761 */     GIR_EraseRootFromParent_Done,
     /* 1883762 */   // Label 25296: @1883762
     /* 1883762 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1883848), // Rule ID 60930 //
     /* 1883767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883813 */     // MIs[0] policy
     /* 1883813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883823 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1883826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883847 */     // GIR_Coverage, 60930,
     /* 1883847 */     GIR_EraseRootFromParent_Done,
     /* 1883848 */   // Label 25297: @1883848
     /* 1883848 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1883934), // Rule ID 60931 //
     /* 1883853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1883856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883899 */     // MIs[0] policy
     /* 1883899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883909 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1883912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883933 */     // GIR_Coverage, 60931,
     /* 1883933 */     GIR_EraseRootFromParent_Done,
     /* 1883934 */   // Label 25298: @1883934
     /* 1883934 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1884020), // Rule ID 60934 //
     /* 1883939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1883942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1883947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883985 */     // MIs[0] policy
     /* 1883985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1883998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884019 */     // GIR_Coverage, 60934,
     /* 1884019 */     GIR_EraseRootFromParent_Done,
     /* 1884020 */   // Label 25299: @1884020
     /* 1884020 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1884106), // Rule ID 60935 //
     /* 1884025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1884036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1884039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1884042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884071 */     // MIs[0] policy
     /* 1884071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884081 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1884084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884105 */     // GIR_Coverage, 60935,
     /* 1884105 */     GIR_EraseRootFromParent_Done,
     /* 1884106 */   // Label 25300: @1884106
     /* 1884106 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1884192), // Rule ID 60938 //
     /* 1884111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1884122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1884125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1884128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884157 */     // MIs[0] policy
     /* 1884157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884167 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884191 */     // GIR_Coverage, 60938,
     /* 1884191 */     GIR_EraseRootFromParent_Done,
     /* 1884192 */   // Label 25301: @1884192
     /* 1884192 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1884278), // Rule ID 60939 //
     /* 1884197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1884208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1884211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1884214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884243 */     // MIs[0] policy
     /* 1884243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884253 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884277 */     // GIR_Coverage, 60939,
     /* 1884277 */     GIR_EraseRootFromParent_Done,
     /* 1884278 */   // Label 25302: @1884278
     /* 1884278 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1884364), // Rule ID 60942 //
     /* 1884283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884329 */     // MIs[0] policy
     /* 1884329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884339 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1884342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884363 */     // GIR_Coverage, 60942,
     /* 1884363 */     GIR_EraseRootFromParent_Done,
     /* 1884364 */   // Label 25303: @1884364
     /* 1884364 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1884450), // Rule ID 60943 //
     /* 1884369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884415 */     // MIs[0] policy
     /* 1884415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884425 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1884428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884449 */     // GIR_Coverage, 60943,
     /* 1884449 */     GIR_EraseRootFromParent_Done,
     /* 1884450 */   // Label 25304: @1884450
     /* 1884450 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1884536), // Rule ID 60946 //
     /* 1884455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884501 */     // MIs[0] policy
     /* 1884501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884535 */     // GIR_Coverage, 60946,
     /* 1884535 */     GIR_EraseRootFromParent_Done,
     /* 1884536 */   // Label 25305: @1884536
     /* 1884536 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1884622), // Rule ID 60947 //
     /* 1884541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884587 */     // MIs[0] policy
     /* 1884587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884597 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884621 */     // GIR_Coverage, 60947,
     /* 1884621 */     GIR_EraseRootFromParent_Done,
     /* 1884622 */   // Label 25306: @1884622
     /* 1884622 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1884708), // Rule ID 60950 //
     /* 1884627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884673 */     // MIs[0] policy
     /* 1884673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884707 */     // GIR_Coverage, 60950,
     /* 1884707 */     GIR_EraseRootFromParent_Done,
     /* 1884708 */   // Label 25307: @1884708
     /* 1884708 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1884794), // Rule ID 60951 //
     /* 1884713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884759 */     // MIs[0] policy
     /* 1884759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1884772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884793 */     // GIR_Coverage, 60951,
     /* 1884793 */     GIR_EraseRootFromParent_Done,
     /* 1884794 */   // Label 25308: @1884794
     /* 1884794 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1884880), // Rule ID 60954 //
     /* 1884799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884845 */     // MIs[0] policy
     /* 1884845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884855 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1884858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884879 */     // GIR_Coverage, 60954,
     /* 1884879 */     GIR_EraseRootFromParent_Done,
     /* 1884880 */   // Label 25309: @1884880
     /* 1884880 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1884966), // Rule ID 60955 //
     /* 1884885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1884888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884931 */     // MIs[0] policy
     /* 1884931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884941 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1884944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884965 */     // GIR_Coverage, 60955,
     /* 1884965 */     GIR_EraseRootFromParent_Done,
     /* 1884966 */   // Label 25310: @1884966
     /* 1884966 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1885052), // Rule ID 60958 //
     /* 1884971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1884974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1884979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885017 */     // MIs[0] policy
     /* 1885017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885051 */     // GIR_Coverage, 60958,
     /* 1885051 */     GIR_EraseRootFromParent_Done,
     /* 1885052 */   // Label 25311: @1885052
     /* 1885052 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1885138), // Rule ID 60959 //
     /* 1885057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1885068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1885071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1885074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885103 */     // MIs[0] policy
     /* 1885103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885113 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885137 */     // GIR_Coverage, 60959,
     /* 1885137 */     GIR_EraseRootFromParent_Done,
     /* 1885138 */   // Label 25312: @1885138
     /* 1885138 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1885224), // Rule ID 60962 //
     /* 1885143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1885146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885189 */     // MIs[0] policy
     /* 1885189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885223 */     // GIR_Coverage, 60962,
     /* 1885223 */     GIR_EraseRootFromParent_Done,
     /* 1885224 */   // Label 25313: @1885224
     /* 1885224 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1885310), // Rule ID 60963 //
     /* 1885229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885275 */     // MIs[0] policy
     /* 1885275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885309 */     // GIR_Coverage, 60963,
     /* 1885309 */     GIR_EraseRootFromParent_Done,
     /* 1885310 */   // Label 25314: @1885310
     /* 1885310 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1885396), // Rule ID 60966 //
     /* 1885315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1885318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885361 */     // MIs[0] policy
     /* 1885361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885395 */     // GIR_Coverage, 60966,
     /* 1885395 */     GIR_EraseRootFromParent_Done,
     /* 1885396 */   // Label 25315: @1885396
     /* 1885396 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1885482), // Rule ID 60967 //
     /* 1885401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885447 */     // MIs[0] policy
     /* 1885447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1885460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885481 */     // GIR_Coverage, 60967,
     /* 1885481 */     GIR_EraseRootFromParent_Done,
     /* 1885482 */   // Label 25316: @1885482
     /* 1885482 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1885568), // Rule ID 60970 //
     /* 1885487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1885490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885533 */     // MIs[0] policy
     /* 1885533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1885546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885567 */     // GIR_Coverage, 60970,
     /* 1885567 */     GIR_EraseRootFromParent_Done,
     /* 1885568 */   // Label 25317: @1885568
     /* 1885568 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1885654), // Rule ID 60971 //
     /* 1885573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885619 */     // MIs[0] policy
     /* 1885619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885629 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1885632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885653 */     // GIR_Coverage, 60971,
     /* 1885653 */     GIR_EraseRootFromParent_Done,
     /* 1885654 */   // Label 25318: @1885654
     /* 1885654 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1885740), // Rule ID 60974 //
     /* 1885659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1885662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885705 */     // MIs[0] policy
     /* 1885705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885715 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1885718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885739 */     // GIR_Coverage, 60974,
     /* 1885739 */     GIR_EraseRootFromParent_Done,
     /* 1885740 */   // Label 25319: @1885740
     /* 1885740 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1885826), // Rule ID 60975 //
     /* 1885745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885791 */     // MIs[0] policy
     /* 1885791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885801 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1885804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885825 */     // GIR_Coverage, 60975,
     /* 1885825 */     GIR_EraseRootFromParent_Done,
     /* 1885826 */   // Label 25320: @1885826
     /* 1885826 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1885912), // Rule ID 60978 //
     /* 1885831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1885834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885877 */     // MIs[0] policy
     /* 1885877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885887 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1885890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885911 */     // GIR_Coverage, 60978,
     /* 1885911 */     GIR_EraseRootFromParent_Done,
     /* 1885912 */   // Label 25321: @1885912
     /* 1885912 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1885998), // Rule ID 60979 //
     /* 1885917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1885920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1885925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885963 */     // MIs[0] policy
     /* 1885963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885973 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1885976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885997 */     // GIR_Coverage, 60979,
     /* 1885997 */     GIR_EraseRootFromParent_Done,
     /* 1885998 */   // Label 25322: @1885998
     /* 1885998 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1886084), // Rule ID 60982 //
     /* 1886003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1886014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1886017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1886020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886049 */     // MIs[0] policy
     /* 1886049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1886062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886083 */     // GIR_Coverage, 60982,
     /* 1886083 */     GIR_EraseRootFromParent_Done,
     /* 1886084 */   // Label 25323: @1886084
     /* 1886084 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1886170), // Rule ID 60983 //
     /* 1886089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1886100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1886103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1886106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886135 */     // MIs[0] policy
     /* 1886135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886145 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1886148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886169 */     // GIR_Coverage, 60983,
     /* 1886169 */     GIR_EraseRootFromParent_Done,
     /* 1886170 */   // Label 25324: @1886170
     /* 1886170 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1886256), // Rule ID 60986 //
     /* 1886175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886221 */     // MIs[0] policy
     /* 1886221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886231 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1886234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886255 */     // GIR_Coverage, 60986,
     /* 1886255 */     GIR_EraseRootFromParent_Done,
     /* 1886256 */   // Label 25325: @1886256
     /* 1886256 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1886342), // Rule ID 60987 //
     /* 1886261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886307 */     // MIs[0] policy
     /* 1886307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886317 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1886320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886341 */     // GIR_Coverage, 60987,
     /* 1886341 */     GIR_EraseRootFromParent_Done,
     /* 1886342 */   // Label 25326: @1886342
     /* 1886342 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1886428), // Rule ID 60990 //
     /* 1886347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886393 */     // MIs[0] policy
     /* 1886393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886403 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1886406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886427 */     // GIR_Coverage, 60990,
     /* 1886427 */     GIR_EraseRootFromParent_Done,
     /* 1886428 */   // Label 25327: @1886428
     /* 1886428 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1886514), // Rule ID 60991 //
     /* 1886433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886479 */     // MIs[0] policy
     /* 1886479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886489 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1886492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886513 */     // GIR_Coverage, 60991,
     /* 1886513 */     GIR_EraseRootFromParent_Done,
     /* 1886514 */   // Label 25328: @1886514
     /* 1886514 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1886600), // Rule ID 60994 //
     /* 1886519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886565 */     // MIs[0] policy
     /* 1886565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1886578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886599 */     // GIR_Coverage, 60994,
     /* 1886599 */     GIR_EraseRootFromParent_Done,
     /* 1886600 */   // Label 25329: @1886600
     /* 1886600 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1886686), // Rule ID 60995 //
     /* 1886605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886651 */     // MIs[0] policy
     /* 1886651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1886664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886685 */     // GIR_Coverage, 60995,
     /* 1886685 */     GIR_EraseRootFromParent_Done,
     /* 1886686 */   // Label 25330: @1886686
     /* 1886686 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1886772), // Rule ID 60998 //
     /* 1886691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886737 */     // MIs[0] policy
     /* 1886737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886747 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1886750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886771 */     // GIR_Coverage, 60998,
     /* 1886771 */     GIR_EraseRootFromParent_Done,
     /* 1886772 */   // Label 25331: @1886772
     /* 1886772 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1886858), // Rule ID 60999 //
     /* 1886777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886823 */     // MIs[0] policy
     /* 1886823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1886836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886857 */     // GIR_Coverage, 60999,
     /* 1886857 */     GIR_EraseRootFromParent_Done,
     /* 1886858 */   // Label 25332: @1886858
     /* 1886858 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1886944), // Rule ID 61002 //
     /* 1886863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1886866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886909 */     // MIs[0] policy
     /* 1886909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1886922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886943 */     // GIR_Coverage, 61002,
     /* 1886943 */     GIR_EraseRootFromParent_Done,
     /* 1886944 */   // Label 25333: @1886944
     /* 1886944 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1887030), // Rule ID 61003 //
     /* 1886949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1886952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1886957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886995 */     // MIs[0] policy
     /* 1886995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887005 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1887008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887029 */     // GIR_Coverage, 61003,
     /* 1887029 */     GIR_EraseRootFromParent_Done,
     /* 1887030 */   // Label 25334: @1887030
     /* 1887030 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1887116), // Rule ID 61006 //
     /* 1887035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1887046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887081 */     // MIs[0] policy
     /* 1887081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887091 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1887094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887115 */     // GIR_Coverage, 61006,
     /* 1887115 */     GIR_EraseRootFromParent_Done,
     /* 1887116 */   // Label 25335: @1887116
     /* 1887116 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1887202), // Rule ID 61007 //
     /* 1887121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1887132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887167 */     // MIs[0] policy
     /* 1887167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1887180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887201 */     // GIR_Coverage, 61007,
     /* 1887201 */     GIR_EraseRootFromParent_Done,
     /* 1887202 */   // Label 25336: @1887202
     /* 1887202 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1887288), // Rule ID 61010 //
     /* 1887207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887253 */     // MIs[0] policy
     /* 1887253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887263 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1887266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887287 */     // GIR_Coverage, 61010,
     /* 1887287 */     GIR_EraseRootFromParent_Done,
     /* 1887288 */   // Label 25337: @1887288
     /* 1887288 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1887374), // Rule ID 61011 //
     /* 1887293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887339 */     // MIs[0] policy
     /* 1887339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887349 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1887352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887373 */     // GIR_Coverage, 61011,
     /* 1887373 */     GIR_EraseRootFromParent_Done,
     /* 1887374 */   // Label 25338: @1887374
     /* 1887374 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1887460), // Rule ID 61014 //
     /* 1887379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887425 */     // MIs[0] policy
     /* 1887425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887435 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1887438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887459 */     // GIR_Coverage, 61014,
     /* 1887459 */     GIR_EraseRootFromParent_Done,
     /* 1887460 */   // Label 25339: @1887460
     /* 1887460 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1887546), // Rule ID 61015 //
     /* 1887465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1887473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887511 */     // MIs[0] policy
     /* 1887511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1887524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887545 */     // GIR_Coverage, 61015,
     /* 1887545 */     GIR_EraseRootFromParent_Done,
     /* 1887546 */   // Label 25340: @1887546
     /* 1887546 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1887632), // Rule ID 61102 //
     /* 1887551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887597 */     // MIs[0] policy
     /* 1887597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887607 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1887610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887631 */     // GIR_Coverage, 61102,
     /* 1887631 */     GIR_EraseRootFromParent_Done,
     /* 1887632 */   // Label 25341: @1887632
     /* 1887632 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1887718), // Rule ID 61103 //
     /* 1887637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887683 */     // MIs[0] policy
     /* 1887683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1887696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887717 */     // GIR_Coverage, 61103,
     /* 1887717 */     GIR_EraseRootFromParent_Done,
     /* 1887718 */   // Label 25342: @1887718
     /* 1887718 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1887804), // Rule ID 61106 //
     /* 1887723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887769 */     // MIs[0] policy
     /* 1887769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887779 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1887782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887803 */     // GIR_Coverage, 61106,
     /* 1887803 */     GIR_EraseRootFromParent_Done,
     /* 1887804 */   // Label 25343: @1887804
     /* 1887804 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1887890), // Rule ID 61107 //
     /* 1887809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887855 */     // MIs[0] policy
     /* 1887855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887865 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1887868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887889 */     // GIR_Coverage, 61107,
     /* 1887889 */     GIR_EraseRootFromParent_Done,
     /* 1887890 */   // Label 25344: @1887890
     /* 1887890 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1887976), // Rule ID 61110 //
     /* 1887895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1887898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887941 */     // MIs[0] policy
     /* 1887941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887951 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1887954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887975 */     // GIR_Coverage, 61110,
     /* 1887975 */     GIR_EraseRootFromParent_Done,
     /* 1887976 */   // Label 25345: @1887976
     /* 1887976 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1888062), // Rule ID 61111 //
     /* 1887981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1887984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1887989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1888001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888027 */     // MIs[0] policy
     /* 1888027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888037 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1888040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888061 */     // GIR_Coverage, 61111,
     /* 1888061 */     GIR_EraseRootFromParent_Done,
     /* 1888062 */   // Label 25346: @1888062
     /* 1888062 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1888148), // Rule ID 61114 //
     /* 1888067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888113 */     // MIs[0] policy
     /* 1888113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888123 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1888126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888147 */     // GIR_Coverage, 61114,
     /* 1888147 */     GIR_EraseRootFromParent_Done,
     /* 1888148 */   // Label 25347: @1888148
     /* 1888148 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1888234), // Rule ID 61115 //
     /* 1888153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1888156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888199 */     // MIs[0] policy
     /* 1888199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1888212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888233 */     // GIR_Coverage, 61115,
     /* 1888233 */     GIR_EraseRootFromParent_Done,
     /* 1888234 */   // Label 25348: @1888234
     /* 1888234 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1888320), // Rule ID 61118 //
     /* 1888239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888285 */     // MIs[0] policy
     /* 1888285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888295 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1888298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888319 */     // GIR_Coverage, 61118,
     /* 1888319 */     GIR_EraseRootFromParent_Done,
     /* 1888320 */   // Label 25349: @1888320
     /* 1888320 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1888406), // Rule ID 61119 //
     /* 1888325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1888328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888371 */     // MIs[0] policy
     /* 1888371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888381 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1888384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888405 */     // GIR_Coverage, 61119,
     /* 1888405 */     GIR_EraseRootFromParent_Done,
     /* 1888406 */   // Label 25350: @1888406
     /* 1888406 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1888492), // Rule ID 61122 //
     /* 1888411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888457 */     // MIs[0] policy
     /* 1888457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888467 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1888470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888491 */     // GIR_Coverage, 61122,
     /* 1888491 */     GIR_EraseRootFromParent_Done,
     /* 1888492 */   // Label 25351: @1888492
     /* 1888492 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1888578), // Rule ID 61123 //
     /* 1888497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1888500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888543 */     // MIs[0] policy
     /* 1888543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888553 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1888556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888577 */     // GIR_Coverage, 61123,
     /* 1888577 */     GIR_EraseRootFromParent_Done,
     /* 1888578 */   // Label 25352: @1888578
     /* 1888578 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1888664), // Rule ID 61126 //
     /* 1888583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888629 */     // MIs[0] policy
     /* 1888629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1888642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888663 */     // GIR_Coverage, 61126,
     /* 1888663 */     GIR_EraseRootFromParent_Done,
     /* 1888664 */   // Label 25353: @1888664
     /* 1888664 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1888750), // Rule ID 61127 //
     /* 1888669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1888672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888715 */     // MIs[0] policy
     /* 1888715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888725 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1888728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888749 */     // GIR_Coverage, 61127,
     /* 1888749 */     GIR_EraseRootFromParent_Done,
     /* 1888750 */   // Label 25354: @1888750
     /* 1888750 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1888836), // Rule ID 61130 //
     /* 1888755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888801 */     // MIs[0] policy
     /* 1888801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888811 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1888814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888835 */     // GIR_Coverage, 61130,
     /* 1888835 */     GIR_EraseRootFromParent_Done,
     /* 1888836 */   // Label 25355: @1888836
     /* 1888836 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1888922), // Rule ID 61131 //
     /* 1888841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1888844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888887 */     // MIs[0] policy
     /* 1888887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888897 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1888900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888921 */     // GIR_Coverage, 61131,
     /* 1888921 */     GIR_EraseRootFromParent_Done,
     /* 1888922 */   // Label 25356: @1888922
     /* 1888922 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1889008), // Rule ID 61134 //
     /* 1888927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1888930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1888935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888973 */     // MIs[0] policy
     /* 1888973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1888986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889007 */     // GIR_Coverage, 61134,
     /* 1889007 */     GIR_EraseRootFromParent_Done,
     /* 1889008 */   // Label 25357: @1889008
     /* 1889008 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1889094), // Rule ID 61135 //
     /* 1889013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1889024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1889027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1889030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1889033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1889036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889059 */     // MIs[0] policy
     /* 1889059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889069 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1889072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889093 */     // GIR_Coverage, 61135,
     /* 1889093 */     GIR_EraseRootFromParent_Done,
     /* 1889094 */   // Label 25358: @1889094
     /* 1889094 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1889180), // Rule ID 61138 //
     /* 1889099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889145 */     // MIs[0] policy
     /* 1889145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1889158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889179 */     // GIR_Coverage, 61138,
     /* 1889179 */     GIR_EraseRootFromParent_Done,
     /* 1889180 */   // Label 25359: @1889180
     /* 1889180 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1889266), // Rule ID 61139 //
     /* 1889185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889231 */     // MIs[0] policy
     /* 1889231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889241 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1889244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889265 */     // GIR_Coverage, 61139,
     /* 1889265 */     GIR_EraseRootFromParent_Done,
     /* 1889266 */   // Label 25360: @1889266
     /* 1889266 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1889352), // Rule ID 61142 //
     /* 1889271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889317 */     // MIs[0] policy
     /* 1889317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1889330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889351 */     // GIR_Coverage, 61142,
     /* 1889351 */     GIR_EraseRootFromParent_Done,
     /* 1889352 */   // Label 25361: @1889352
     /* 1889352 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1889438), // Rule ID 61143 //
     /* 1889357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889403 */     // MIs[0] policy
     /* 1889403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1889416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889437 */     // GIR_Coverage, 61143,
     /* 1889437 */     GIR_EraseRootFromParent_Done,
     /* 1889438 */   // Label 25362: @1889438
     /* 1889438 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1889524), // Rule ID 61146 //
     /* 1889443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889489 */     // MIs[0] policy
     /* 1889489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889499 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1889502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889523 */     // GIR_Coverage, 61146,
     /* 1889523 */     GIR_EraseRootFromParent_Done,
     /* 1889524 */   // Label 25363: @1889524
     /* 1889524 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1889610), // Rule ID 61147 //
     /* 1889529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889575 */     // MIs[0] policy
     /* 1889575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889585 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1889588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889609 */     // GIR_Coverage, 61147,
     /* 1889609 */     GIR_EraseRootFromParent_Done,
     /* 1889610 */   // Label 25364: @1889610
     /* 1889610 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1889696), // Rule ID 61150 //
     /* 1889615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889661 */     // MIs[0] policy
     /* 1889661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1889674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889695 */     // GIR_Coverage, 61150,
     /* 1889695 */     GIR_EraseRootFromParent_Done,
     /* 1889696 */   // Label 25365: @1889696
     /* 1889696 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1889782), // Rule ID 61151 //
     /* 1889701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889747 */     // MIs[0] policy
     /* 1889747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889757 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1889760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889781 */     // GIR_Coverage, 61151,
     /* 1889781 */     GIR_EraseRootFromParent_Done,
     /* 1889782 */   // Label 25366: @1889782
     /* 1889782 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1889868), // Rule ID 61154 //
     /* 1889787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889833 */     // MIs[0] policy
     /* 1889833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1889846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889867 */     // GIR_Coverage, 61154,
     /* 1889867 */     GIR_EraseRootFromParent_Done,
     /* 1889868 */   // Label 25367: @1889868
     /* 1889868 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1889954), // Rule ID 61155 //
     /* 1889873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1889876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889919 */     // MIs[0] policy
     /* 1889919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1889932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889953 */     // GIR_Coverage, 61155,
     /* 1889953 */     GIR_EraseRootFromParent_Done,
     /* 1889954 */   // Label 25368: @1889954
     /* 1889954 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1890040), // Rule ID 61158 //
     /* 1889959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1889962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1889967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890005 */     // MIs[0] policy
     /* 1890005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890015 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1890018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890039 */     // GIR_Coverage, 61158,
     /* 1890039 */     GIR_EraseRootFromParent_Done,
     /* 1890040 */   // Label 25369: @1890040
     /* 1890040 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1890126), // Rule ID 61159 //
     /* 1890045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1890056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1890059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1890062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1890065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890091 */     // MIs[0] policy
     /* 1890091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1890104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890125 */     // GIR_Coverage, 61159,
     /* 1890125 */     GIR_EraseRootFromParent_Done,
     /* 1890126 */   // Label 25370: @1890126
     /* 1890126 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1890212), // Rule ID 61162 //
     /* 1890131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890177 */     // MIs[0] policy
     /* 1890177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890187 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1890190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890211 */     // GIR_Coverage, 61162,
     /* 1890211 */     GIR_EraseRootFromParent_Done,
     /* 1890212 */   // Label 25371: @1890212
     /* 1890212 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1890298), // Rule ID 61163 //
     /* 1890217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890263 */     // MIs[0] policy
     /* 1890263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890273 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1890276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890297 */     // GIR_Coverage, 61163,
     /* 1890297 */     GIR_EraseRootFromParent_Done,
     /* 1890298 */   // Label 25372: @1890298
     /* 1890298 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1890384), // Rule ID 61166 //
     /* 1890303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890349 */     // MIs[0] policy
     /* 1890349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1890362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890383 */     // GIR_Coverage, 61166,
     /* 1890383 */     GIR_EraseRootFromParent_Done,
     /* 1890384 */   // Label 25373: @1890384
     /* 1890384 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1890470), // Rule ID 61167 //
     /* 1890389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890435 */     // MIs[0] policy
     /* 1890435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1890448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890469 */     // GIR_Coverage, 61167,
     /* 1890469 */     GIR_EraseRootFromParent_Done,
     /* 1890470 */   // Label 25374: @1890470
     /* 1890470 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1890556), // Rule ID 61170 //
     /* 1890475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890521 */     // MIs[0] policy
     /* 1890521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890531 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1890534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890555 */     // GIR_Coverage, 61170,
     /* 1890555 */     GIR_EraseRootFromParent_Done,
     /* 1890556 */   // Label 25375: @1890556
     /* 1890556 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1890642), // Rule ID 61171 //
     /* 1890561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890607 */     // MIs[0] policy
     /* 1890607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890617 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1890620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890641 */     // GIR_Coverage, 61171,
     /* 1890641 */     GIR_EraseRootFromParent_Done,
     /* 1890642 */   // Label 25376: @1890642
     /* 1890642 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1890728), // Rule ID 61174 //
     /* 1890647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890693 */     // MIs[0] policy
     /* 1890693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890703 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1890706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890727 */     // GIR_Coverage, 61174,
     /* 1890727 */     GIR_EraseRootFromParent_Done,
     /* 1890728 */   // Label 25377: @1890728
     /* 1890728 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1890814), // Rule ID 61175 //
     /* 1890733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890779 */     // MIs[0] policy
     /* 1890779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1890792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890813 */     // GIR_Coverage, 61175,
     /* 1890813 */     GIR_EraseRootFromParent_Done,
     /* 1890814 */   // Label 25378: @1890814
     /* 1890814 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1890900), // Rule ID 61178 //
     /* 1890819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890865 */     // MIs[0] policy
     /* 1890865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1890878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890899 */     // GIR_Coverage, 61178,
     /* 1890899 */     GIR_EraseRootFromParent_Done,
     /* 1890900 */   // Label 25379: @1890900
     /* 1890900 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1890986), // Rule ID 61179 //
     /* 1890905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1890908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890951 */     // MIs[0] policy
     /* 1890951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1890964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890985 */     // GIR_Coverage, 61179,
     /* 1890985 */     GIR_EraseRootFromParent_Done,
     /* 1890986 */   // Label 25380: @1890986
     /* 1890986 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1891072), // Rule ID 61182 //
     /* 1890991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1890994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1890999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891037 */     // MIs[0] policy
     /* 1891037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1891050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891071 */     // GIR_Coverage, 61182,
     /* 1891071 */     GIR_EraseRootFromParent_Done,
     /* 1891072 */   // Label 25381: @1891072
     /* 1891072 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1891158), // Rule ID 61183 //
     /* 1891077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891123 */     // MIs[0] policy
     /* 1891123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1891136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891157 */     // GIR_Coverage, 61183,
     /* 1891157 */     GIR_EraseRootFromParent_Done,
     /* 1891158 */   // Label 25382: @1891158
     /* 1891158 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1891244), // Rule ID 61186 //
     /* 1891163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1891166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891209 */     // MIs[0] policy
     /* 1891209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891219 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1891222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891243 */     // GIR_Coverage, 61186,
     /* 1891243 */     GIR_EraseRootFromParent_Done,
     /* 1891244 */   // Label 25383: @1891244
     /* 1891244 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1891330), // Rule ID 61187 //
     /* 1891249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891295 */     // MIs[0] policy
     /* 1891295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891305 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1891308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891329 */     // GIR_Coverage, 61187,
     /* 1891329 */     GIR_EraseRootFromParent_Done,
     /* 1891330 */   // Label 25384: @1891330
     /* 1891330 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1891416), // Rule ID 61190 //
     /* 1891335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1891338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891381 */     // MIs[0] policy
     /* 1891381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891391 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1891394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891415 */     // GIR_Coverage, 61190,
     /* 1891415 */     GIR_EraseRootFromParent_Done,
     /* 1891416 */   // Label 25385: @1891416
     /* 1891416 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1891502), // Rule ID 61191 //
     /* 1891421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891467 */     // MIs[0] policy
     /* 1891467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1891480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891501 */     // GIR_Coverage, 61191,
     /* 1891501 */     GIR_EraseRootFromParent_Done,
     /* 1891502 */   // Label 25386: @1891502
     /* 1891502 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1891588), // Rule ID 61194 //
     /* 1891507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1891510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891553 */     // MIs[0] policy
     /* 1891553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891563 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1891566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891587 */     // GIR_Coverage, 61194,
     /* 1891587 */     GIR_EraseRootFromParent_Done,
     /* 1891588 */   // Label 25387: @1891588
     /* 1891588 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1891674), // Rule ID 61195 //
     /* 1891593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891639 */     // MIs[0] policy
     /* 1891639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891649 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1891652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891673 */     // GIR_Coverage, 61195,
     /* 1891673 */     GIR_EraseRootFromParent_Done,
     /* 1891674 */   // Label 25388: @1891674
     /* 1891674 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1891760), // Rule ID 61198 //
     /* 1891679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1891682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891725 */     // MIs[0] policy
     /* 1891725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891735 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1891738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891759 */     // GIR_Coverage, 61198,
     /* 1891759 */     GIR_EraseRootFromParent_Done,
     /* 1891760 */   // Label 25389: @1891760
     /* 1891760 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1891846), // Rule ID 61199 //
     /* 1891765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891811 */     // MIs[0] policy
     /* 1891811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891821 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1891824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891845 */     // GIR_Coverage, 61199,
     /* 1891845 */     GIR_EraseRootFromParent_Done,
     /* 1891846 */   // Label 25390: @1891846
     /* 1891846 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1891932), // Rule ID 61202 //
     /* 1891851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1891854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891897 */     // MIs[0] policy
     /* 1891897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891907 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1891910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891931 */     // GIR_Coverage, 61202,
     /* 1891931 */     GIR_EraseRootFromParent_Done,
     /* 1891932 */   // Label 25391: @1891932
     /* 1891932 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1892018), // Rule ID 61203 //
     /* 1891937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1891940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1891945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891983 */     // MIs[0] policy
     /* 1891983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891993 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1891996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892017 */     // GIR_Coverage, 61203,
     /* 1892017 */     GIR_EraseRootFromParent_Done,
     /* 1892018 */   // Label 25392: @1892018
     /* 1892018 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1892104), // Rule ID 61206 //
     /* 1892023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892069 */     // MIs[0] policy
     /* 1892069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892079 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1892082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892103 */     // GIR_Coverage, 61206,
     /* 1892103 */     GIR_EraseRootFromParent_Done,
     /* 1892104 */   // Label 25393: @1892104
     /* 1892104 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1892190), // Rule ID 61207 //
     /* 1892109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892155 */     // MIs[0] policy
     /* 1892155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892165 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1892168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892189 */     // GIR_Coverage, 61207,
     /* 1892189 */     GIR_EraseRootFromParent_Done,
     /* 1892190 */   // Label 25394: @1892190
     /* 1892190 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1892276), // Rule ID 61210 //
     /* 1892195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892241 */     // MIs[0] policy
     /* 1892241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892251 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1892254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892275 */     // GIR_Coverage, 61210,
     /* 1892275 */     GIR_EraseRootFromParent_Done,
     /* 1892276 */   // Label 25395: @1892276
     /* 1892276 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1892362), // Rule ID 61211 //
     /* 1892281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892327 */     // MIs[0] policy
     /* 1892327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892337 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1892340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892361 */     // GIR_Coverage, 61211,
     /* 1892361 */     GIR_EraseRootFromParent_Done,
     /* 1892362 */   // Label 25396: @1892362
     /* 1892362 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1892448), // Rule ID 61214 //
     /* 1892367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892413 */     // MIs[0] policy
     /* 1892413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892423 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892447 */     // GIR_Coverage, 61214,
     /* 1892447 */     GIR_EraseRootFromParent_Done,
     /* 1892448 */   // Label 25397: @1892448
     /* 1892448 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1892534), // Rule ID 61215 //
     /* 1892453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892499 */     // MIs[0] policy
     /* 1892499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892509 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892533 */     // GIR_Coverage, 61215,
     /* 1892533 */     GIR_EraseRootFromParent_Done,
     /* 1892534 */   // Label 25398: @1892534
     /* 1892534 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1892620), // Rule ID 61218 //
     /* 1892539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892585 */     // MIs[0] policy
     /* 1892585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892619 */     // GIR_Coverage, 61218,
     /* 1892619 */     GIR_EraseRootFromParent_Done,
     /* 1892620 */   // Label 25399: @1892620
     /* 1892620 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1892706), // Rule ID 61219 //
     /* 1892625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892671 */     // MIs[0] policy
     /* 1892671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892681 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892705 */     // GIR_Coverage, 61219,
     /* 1892705 */     GIR_EraseRootFromParent_Done,
     /* 1892706 */   // Label 25400: @1892706
     /* 1892706 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1892792), // Rule ID 61222 //
     /* 1892711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892757 */     // MIs[0] policy
     /* 1892757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892791 */     // GIR_Coverage, 61222,
     /* 1892791 */     GIR_EraseRootFromParent_Done,
     /* 1892792 */   // Label 25401: @1892792
     /* 1892792 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1892878), // Rule ID 61223 //
     /* 1892797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892843 */     // MIs[0] policy
     /* 1892843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892853 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892877 */     // GIR_Coverage, 61223,
     /* 1892877 */     GIR_EraseRootFromParent_Done,
     /* 1892878 */   // Label 25402: @1892878
     /* 1892878 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1892964), // Rule ID 61226 //
     /* 1892883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1892886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892929 */     // MIs[0] policy
     /* 1892929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1892942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892963 */     // GIR_Coverage, 61226,
     /* 1892963 */     GIR_EraseRootFromParent_Done,
     /* 1892964 */   // Label 25403: @1892964
     /* 1892964 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1893050), // Rule ID 61227 //
     /* 1892969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1892972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1892977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893015 */     // MIs[0] policy
     /* 1893015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1893028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893049 */     // GIR_Coverage, 61227,
     /* 1893049 */     GIR_EraseRootFromParent_Done,
     /* 1893050 */   // Label 25404: @1893050
     /* 1893050 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1893136), // Rule ID 61230 //
     /* 1893055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893101 */     // MIs[0] policy
     /* 1893101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893111 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1893114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893135 */     // GIR_Coverage, 61230,
     /* 1893135 */     GIR_EraseRootFromParent_Done,
     /* 1893136 */   // Label 25405: @1893136
     /* 1893136 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1893222), // Rule ID 61231 //
     /* 1893141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1893144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893187 */     // MIs[0] policy
     /* 1893187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893197 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1893200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893221 */     // GIR_Coverage, 61231,
     /* 1893221 */     GIR_EraseRootFromParent_Done,
     /* 1893222 */   // Label 25406: @1893222
     /* 1893222 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1893308), // Rule ID 61234 //
     /* 1893227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893273 */     // MIs[0] policy
     /* 1893273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893283 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1893286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893307 */     // GIR_Coverage, 61234,
     /* 1893307 */     GIR_EraseRootFromParent_Done,
     /* 1893308 */   // Label 25407: @1893308
     /* 1893308 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1893394), // Rule ID 61235 //
     /* 1893313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1893316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893359 */     // MIs[0] policy
     /* 1893359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893369 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1893372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893393 */     // GIR_Coverage, 61235,
     /* 1893393 */     GIR_EraseRootFromParent_Done,
     /* 1893394 */   // Label 25408: @1893394
     /* 1893394 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1893480), // Rule ID 61238 //
     /* 1893399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893445 */     // MIs[0] policy
     /* 1893445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893455 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1893458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893479 */     // GIR_Coverage, 61238,
     /* 1893479 */     GIR_EraseRootFromParent_Done,
     /* 1893480 */   // Label 25409: @1893480
     /* 1893480 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1893566), // Rule ID 61239 //
     /* 1893485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1893488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893531 */     // MIs[0] policy
     /* 1893531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893541 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1893544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893565 */     // GIR_Coverage, 61239,
     /* 1893565 */     GIR_EraseRootFromParent_Done,
     /* 1893566 */   // Label 25410: @1893566
     /* 1893566 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1893652), // Rule ID 61242 //
     /* 1893571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893617 */     // MIs[0] policy
     /* 1893617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1893630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893651 */     // GIR_Coverage, 61242,
     /* 1893651 */     GIR_EraseRootFromParent_Done,
     /* 1893652 */   // Label 25411: @1893652
     /* 1893652 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1893738), // Rule ID 61243 //
     /* 1893657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1893660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893703 */     // MIs[0] policy
     /* 1893703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893713 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1893716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893737 */     // GIR_Coverage, 61243,
     /* 1893737 */     GIR_EraseRootFromParent_Done,
     /* 1893738 */   // Label 25412: @1893738
     /* 1893738 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1893824), // Rule ID 61246 //
     /* 1893743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893789 */     // MIs[0] policy
     /* 1893789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893799 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1893802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893823 */     // GIR_Coverage, 61246,
     /* 1893823 */     GIR_EraseRootFromParent_Done,
     /* 1893824 */   // Label 25413: @1893824
     /* 1893824 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1893910), // Rule ID 61247 //
     /* 1893829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1893832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893875 */     // MIs[0] policy
     /* 1893875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893885 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1893888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893909 */     // GIR_Coverage, 61247,
     /* 1893909 */     GIR_EraseRootFromParent_Done,
     /* 1893910 */   // Label 25414: @1893910
     /* 1893910 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1893996), // Rule ID 61250 //
     /* 1893915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1893918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1893923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893961 */     // MIs[0] policy
     /* 1893961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893971 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1893974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893995 */     // GIR_Coverage, 61250,
     /* 1893995 */     GIR_EraseRootFromParent_Done,
     /* 1893996 */   // Label 25415: @1893996
     /* 1893996 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1894082), // Rule ID 61251 //
     /* 1894001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894047 */     // MIs[0] policy
     /* 1894047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894057 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1894060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894081 */     // GIR_Coverage, 61251,
     /* 1894081 */     GIR_EraseRootFromParent_Done,
     /* 1894082 */   // Label 25416: @1894082
     /* 1894082 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1894168), // Rule ID 61254 //
     /* 1894087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894133 */     // MIs[0] policy
     /* 1894133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1894146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894167 */     // GIR_Coverage, 61254,
     /* 1894167 */     GIR_EraseRootFromParent_Done,
     /* 1894168 */   // Label 25417: @1894168
     /* 1894168 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1894254), // Rule ID 61255 //
     /* 1894173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894219 */     // MIs[0] policy
     /* 1894219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1894232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894253 */     // GIR_Coverage, 61255,
     /* 1894253 */     GIR_EraseRootFromParent_Done,
     /* 1894254 */   // Label 25418: @1894254
     /* 1894254 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1894340), // Rule ID 61258 //
     /* 1894259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894305 */     // MIs[0] policy
     /* 1894305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894315 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1894318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894339 */     // GIR_Coverage, 61258,
     /* 1894339 */     GIR_EraseRootFromParent_Done,
     /* 1894340 */   // Label 25419: @1894340
     /* 1894340 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1894426), // Rule ID 61259 //
     /* 1894345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894391 */     // MIs[0] policy
     /* 1894391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894401 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1894404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894425 */     // GIR_Coverage, 61259,
     /* 1894425 */     GIR_EraseRootFromParent_Done,
     /* 1894426 */   // Label 25420: @1894426
     /* 1894426 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1894512), // Rule ID 61262 //
     /* 1894431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894477 */     // MIs[0] policy
     /* 1894477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894487 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1894490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894511 */     // GIR_Coverage, 61262,
     /* 1894511 */     GIR_EraseRootFromParent_Done,
     /* 1894512 */   // Label 25421: @1894512
     /* 1894512 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1894598), // Rule ID 61263 //
     /* 1894517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894563 */     // MIs[0] policy
     /* 1894563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1894576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894597 */     // GIR_Coverage, 61263,
     /* 1894597 */     GIR_EraseRootFromParent_Done,
     /* 1894598 */   // Label 25422: @1894598
     /* 1894598 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1894684), // Rule ID 61266 //
     /* 1894603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894649 */     // MIs[0] policy
     /* 1894649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1894662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894683 */     // GIR_Coverage, 61266,
     /* 1894683 */     GIR_EraseRootFromParent_Done,
     /* 1894684 */   // Label 25423: @1894684
     /* 1894684 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1894770), // Rule ID 61267 //
     /* 1894689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894735 */     // MIs[0] policy
     /* 1894735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1894748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894769 */     // GIR_Coverage, 61267,
     /* 1894769 */     GIR_EraseRootFromParent_Done,
     /* 1894770 */   // Label 25424: @1894770
     /* 1894770 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1894856), // Rule ID 61270 //
     /* 1894775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894821 */     // MIs[0] policy
     /* 1894821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894831 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1894834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894855 */     // GIR_Coverage, 61270,
     /* 1894855 */     GIR_EraseRootFromParent_Done,
     /* 1894856 */   // Label 25425: @1894856
     /* 1894856 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1894942), // Rule ID 61271 //
     /* 1894861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1894864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894907 */     // MIs[0] policy
     /* 1894907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894917 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1894920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894941 */     // GIR_Coverage, 61271,
     /* 1894941 */     GIR_EraseRootFromParent_Done,
     /* 1894942 */   // Label 25426: @1894942
     /* 1894942 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1895028), // Rule ID 61274 //
     /* 1894947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1894950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1894955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894993 */     // MIs[0] policy
     /* 1894993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895003 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1895006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895027 */     // GIR_Coverage, 61274,
     /* 1895027 */     GIR_EraseRootFromParent_Done,
     /* 1895028 */   // Label 25427: @1895028
     /* 1895028 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1895114), // Rule ID 61275 //
     /* 1895033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1895036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1895041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895079 */     // MIs[0] policy
     /* 1895079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895089 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1895092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895113 */     // GIR_Coverage, 61275,
     /* 1895113 */     GIR_EraseRootFromParent_Done,
     /* 1895114 */   // Label 25428: @1895114
     /* 1895114 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1895200), // Rule ID 61916 //
     /* 1895119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1895136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1895139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895165 */     // MIs[0] policy
     /* 1895165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895175 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1895178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895199 */     // GIR_Coverage, 61916,
     /* 1895199 */     GIR_EraseRootFromParent_Done,
     /* 1895200 */   // Label 25429: @1895200
     /* 1895200 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1895286), // Rule ID 61917 //
     /* 1895205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1895208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1895222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1895225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895251 */     // MIs[0] policy
     /* 1895251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1895264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895285 */     // GIR_Coverage, 61917,
     /* 1895285 */     GIR_EraseRootFromParent_Done,
     /* 1895286 */   // Label 25430: @1895286
     /* 1895286 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1895372), // Rule ID 61920 //
     /* 1895291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1895308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1895311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895337 */     // MIs[0] policy
     /* 1895337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1895350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895371 */     // GIR_Coverage, 61920,
     /* 1895371 */     GIR_EraseRootFromParent_Done,
     /* 1895372 */   // Label 25431: @1895372
     /* 1895372 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1895458), // Rule ID 61921 //
     /* 1895377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1895380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1895394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1895397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895423 */     // MIs[0] policy
     /* 1895423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1895436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895457 */     // GIR_Coverage, 61921,
     /* 1895457 */     GIR_EraseRootFromParent_Done,
     /* 1895458 */   // Label 25432: @1895458
     /* 1895458 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1895544), // Rule ID 61924 //
     /* 1895463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1895474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1895477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1895480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1895483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1895486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895509 */     // MIs[0] policy
     /* 1895509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1895522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895543 */     // GIR_Coverage, 61924,
     /* 1895543 */     GIR_EraseRootFromParent_Done,
     /* 1895544 */   // Label 25433: @1895544
     /* 1895544 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1895630), // Rule ID 61925 //
     /* 1895549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1895552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1895560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1895563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1895566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1895569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1895572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895595 */     // MIs[0] policy
     /* 1895595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1895608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895629 */     // GIR_Coverage, 61925,
     /* 1895629 */     GIR_EraseRootFromParent_Done,
     /* 1895630 */   // Label 25434: @1895630
     /* 1895630 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1895716), // Rule ID 61928 //
     /* 1895635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1895646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1895649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1895652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1895655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1895658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895681 */     // MIs[0] policy
     /* 1895681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1895694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895715 */     // GIR_Coverage, 61928,
     /* 1895715 */     GIR_EraseRootFromParent_Done,
     /* 1895716 */   // Label 25435: @1895716
     /* 1895716 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1895802), // Rule ID 61929 //
     /* 1895721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1895724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1895732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1895735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1895738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1895741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1895744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895767 */     // MIs[0] policy
     /* 1895767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1895780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895801 */     // GIR_Coverage, 61929,
     /* 1895801 */     GIR_EraseRootFromParent_Done,
     /* 1895802 */   // Label 25436: @1895802
     /* 1895802 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1895888), // Rule ID 61932 //
     /* 1895807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1895818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1895821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1895824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1895827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1895830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895853 */     // MIs[0] policy
     /* 1895853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895863 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1895866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895887 */     // GIR_Coverage, 61932,
     /* 1895887 */     GIR_EraseRootFromParent_Done,
     /* 1895888 */   // Label 25437: @1895888
     /* 1895888 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1895974), // Rule ID 61933 //
     /* 1895893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1895896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1895904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1895907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1895910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1895913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1895916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895939 */     // MIs[0] policy
     /* 1895939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895949 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1895952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1895956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895973 */     // GIR_Coverage, 61933,
     /* 1895973 */     GIR_EraseRootFromParent_Done,
     /* 1895974 */   // Label 25438: @1895974
     /* 1895974 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1896060), // Rule ID 61936 //
     /* 1895979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1895982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1895987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1895996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1895999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896025 */     // MIs[0] policy
     /* 1896025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896035 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1896038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896059 */     // GIR_Coverage, 61936,
     /* 1896059 */     GIR_EraseRootFromParent_Done,
     /* 1896060 */   // Label 25439: @1896060
     /* 1896060 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1896146), // Rule ID 61937 //
     /* 1896065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1896076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1896079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1896082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1896085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896111 */     // MIs[0] policy
     /* 1896111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1896124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896145 */     // GIR_Coverage, 61937,
     /* 1896145 */     GIR_EraseRootFromParent_Done,
     /* 1896146 */   // Label 25440: @1896146
     /* 1896146 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1896232), // Rule ID 61940 //
     /* 1896151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1896154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1896168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1896171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896197 */     // MIs[0] policy
     /* 1896197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1896210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896231 */     // GIR_Coverage, 61940,
     /* 1896231 */     GIR_EraseRootFromParent_Done,
     /* 1896232 */   // Label 25441: @1896232
     /* 1896232 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1896318), // Rule ID 61941 //
     /* 1896237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1896254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1896257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896283 */     // MIs[0] policy
     /* 1896283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1896296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896317 */     // GIR_Coverage, 61941,
     /* 1896317 */     GIR_EraseRootFromParent_Done,
     /* 1896318 */   // Label 25442: @1896318
     /* 1896318 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1896404), // Rule ID 61944 //
     /* 1896323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1896326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1896340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1896343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896369 */     // MIs[0] policy
     /* 1896369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1896382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896403 */     // GIR_Coverage, 61944,
     /* 1896403 */     GIR_EraseRootFromParent_Done,
     /* 1896404 */   // Label 25443: @1896404
     /* 1896404 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1896490), // Rule ID 61945 //
     /* 1896409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1896426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1896429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896455 */     // MIs[0] policy
     /* 1896455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1896468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896489 */     // GIR_Coverage, 61945,
     /* 1896489 */     GIR_EraseRootFromParent_Done,
     /* 1896490 */   // Label 25444: @1896490
     /* 1896490 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1896576), // Rule ID 61948 //
     /* 1896495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1896498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1896512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1896515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896541 */     // MIs[0] policy
     /* 1896541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1896554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896575 */     // GIR_Coverage, 61948,
     /* 1896575 */     GIR_EraseRootFromParent_Done,
     /* 1896576 */   // Label 25445: @1896576
     /* 1896576 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1896662), // Rule ID 61949 //
     /* 1896581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1896598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1896601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896627 */     // MIs[0] policy
     /* 1896627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1896640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896661 */     // GIR_Coverage, 61949,
     /* 1896661 */     GIR_EraseRootFromParent_Done,
     /* 1896662 */   // Label 25446: @1896662
     /* 1896662 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1896748), // Rule ID 61952 //
     /* 1896667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1896670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1896684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1896687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1896690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896713 */     // MIs[0] policy
     /* 1896713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1896726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896747 */     // GIR_Coverage, 61952,
     /* 1896747 */     GIR_EraseRootFromParent_Done,
     /* 1896748 */   // Label 25447: @1896748
     /* 1896748 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1896834), // Rule ID 61953 //
     /* 1896753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1896761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1896770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1896773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1896776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896799 */     // MIs[0] policy
     /* 1896799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1896812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896833 */     // GIR_Coverage, 61953,
     /* 1896833 */     GIR_EraseRootFromParent_Done,
     /* 1896834 */   // Label 25448: @1896834
     /* 1896834 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1896920), // Rule ID 61956 //
     /* 1896839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1896842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1896847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1896850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1896853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1896856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1896859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896885 */     // MIs[0] policy
     /* 1896885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896895 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1896898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896919 */     // GIR_Coverage, 61956,
     /* 1896919 */     GIR_EraseRootFromParent_Done,
     /* 1896920 */   // Label 25449: @1896920
     /* 1896920 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1897006), // Rule ID 61957 //
     /* 1896925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1896928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1896933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1896936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1896939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1896942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1896945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896971 */     // MIs[0] policy
     /* 1896971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896981 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1896984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1896988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897005 */     // GIR_Coverage, 61957,
     /* 1897005 */     GIR_EraseRootFromParent_Done,
     /* 1897006 */   // Label 25450: @1897006
     /* 1897006 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1897092), // Rule ID 61960 //
     /* 1897011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1897022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1897025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1897028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1897031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897057 */     // MIs[0] policy
     /* 1897057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1897070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897091 */     // GIR_Coverage, 61960,
     /* 1897091 */     GIR_EraseRootFromParent_Done,
     /* 1897092 */   // Label 25451: @1897092
     /* 1897092 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1897178), // Rule ID 61961 //
     /* 1897097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1897108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1897111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1897114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1897117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897143 */     // MIs[0] policy
     /* 1897143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1897156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897177 */     // GIR_Coverage, 61961,
     /* 1897177 */     GIR_EraseRootFromParent_Done,
     /* 1897178 */   // Label 25452: @1897178
     /* 1897178 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1897264), // Rule ID 61964 //
     /* 1897183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1897200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1897203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897229 */     // MIs[0] policy
     /* 1897229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1897242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897263 */     // GIR_Coverage, 61964,
     /* 1897263 */     GIR_EraseRootFromParent_Done,
     /* 1897264 */   // Label 25453: @1897264
     /* 1897264 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1897350), // Rule ID 61965 //
     /* 1897269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1897286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1897289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897315 */     // MIs[0] policy
     /* 1897315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1897328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897349 */     // GIR_Coverage, 61965,
     /* 1897349 */     GIR_EraseRootFromParent_Done,
     /* 1897350 */   // Label 25454: @1897350
     /* 1897350 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1897436), // Rule ID 61968 //
     /* 1897355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1897372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1897375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897401 */     // MIs[0] policy
     /* 1897401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897411 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1897414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897435 */     // GIR_Coverage, 61968,
     /* 1897435 */     GIR_EraseRootFromParent_Done,
     /* 1897436 */   // Label 25455: @1897436
     /* 1897436 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1897522), // Rule ID 61969 //
     /* 1897441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1897458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1897461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897487 */     // MIs[0] policy
     /* 1897487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897497 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1897500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897521 */     // GIR_Coverage, 61969,
     /* 1897521 */     GIR_EraseRootFromParent_Done,
     /* 1897522 */   // Label 25456: @1897522
     /* 1897522 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1897608), // Rule ID 61972 //
     /* 1897527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1897544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1897547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1897550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897573 */     // MIs[0] policy
     /* 1897573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897583 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1897586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897607 */     // GIR_Coverage, 61972,
     /* 1897607 */     GIR_EraseRootFromParent_Done,
     /* 1897608 */   // Label 25457: @1897608
     /* 1897608 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1897694), // Rule ID 61973 //
     /* 1897613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1897630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1897633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1897636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897659 */     // MIs[0] policy
     /* 1897659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897669 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1897672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897693 */     // GIR_Coverage, 61973,
     /* 1897693 */     GIR_EraseRootFromParent_Done,
     /* 1897694 */   // Label 25458: @1897694
     /* 1897694 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1897780), // Rule ID 61976 //
     /* 1897699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1897716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1897719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897745 */     // MIs[0] policy
     /* 1897745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897755 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1897758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897779 */     // GIR_Coverage, 61976,
     /* 1897779 */     GIR_EraseRootFromParent_Done,
     /* 1897780 */   // Label 25459: @1897780
     /* 1897780 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1897866), // Rule ID 61977 //
     /* 1897785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1897802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1897805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897831 */     // MIs[0] policy
     /* 1897831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1897844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897865 */     // GIR_Coverage, 61977,
     /* 1897865 */     GIR_EraseRootFromParent_Done,
     /* 1897866 */   // Label 25460: @1897866
     /* 1897866 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1897952), // Rule ID 61980 //
     /* 1897871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1897874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1897882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1897885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1897888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1897891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897917 */     // MIs[0] policy
     /* 1897917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1897930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1897934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897951 */     // GIR_Coverage, 61980,
     /* 1897951 */     GIR_EraseRootFromParent_Done,
     /* 1897952 */   // Label 25461: @1897952
     /* 1897952 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1898038), // Rule ID 61981 //
     /* 1897957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1897960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1897965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1897968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1897971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1897974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1897977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898003 */     // MIs[0] policy
     /* 1898003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898013 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1898016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898037 */     // GIR_Coverage, 61981,
     /* 1898037 */     GIR_EraseRootFromParent_Done,
     /* 1898038 */   // Label 25462: @1898038
     /* 1898038 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1898124), // Rule ID 61984 //
     /* 1898043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1898054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1898057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1898060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1898063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898089 */     // MIs[0] policy
     /* 1898089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1898102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898123 */     // GIR_Coverage, 61984,
     /* 1898123 */     GIR_EraseRootFromParent_Done,
     /* 1898124 */   // Label 25463: @1898124
     /* 1898124 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1898210), // Rule ID 61985 //
     /* 1898129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1898140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1898143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1898146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1898149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898175 */     // MIs[0] policy
     /* 1898175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1898188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898209 */     // GIR_Coverage, 61985,
     /* 1898209 */     GIR_EraseRootFromParent_Done,
     /* 1898210 */   // Label 25464: @1898210
     /* 1898210 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1898296), // Rule ID 61988 //
     /* 1898215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1898226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1898229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1898232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1898235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898261 */     // MIs[0] policy
     /* 1898261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898271 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1898274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898295 */     // GIR_Coverage, 61988,
     /* 1898295 */     GIR_EraseRootFromParent_Done,
     /* 1898296 */   // Label 25465: @1898296
     /* 1898296 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1898382), // Rule ID 61989 //
     /* 1898301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1898312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1898315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1898318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1898321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898347 */     // MIs[0] policy
     /* 1898347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898357 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1898360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898381 */     // GIR_Coverage, 61989,
     /* 1898381 */     GIR_EraseRootFromParent_Done,
     /* 1898382 */   // Label 25466: @1898382
     /* 1898382 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1898468), // Rule ID 61992 //
     /* 1898387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1898398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1898401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1898404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1898407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1898410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898433 */     // MIs[0] policy
     /* 1898433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1898446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898467 */     // GIR_Coverage, 61992,
     /* 1898467 */     GIR_EraseRootFromParent_Done,
     /* 1898468 */   // Label 25467: @1898468
     /* 1898468 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1898554), // Rule ID 61993 //
     /* 1898473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1898481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1898484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1898487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1898490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1898493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1898496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898519 */     // MIs[0] policy
     /* 1898519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898529 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1898532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898553 */     // GIR_Coverage, 61993,
     /* 1898553 */     GIR_EraseRootFromParent_Done,
     /* 1898554 */   // Label 25468: @1898554
     /* 1898554 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1898640), // Rule ID 61996 //
     /* 1898559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1898576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1898579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898605 */     // MIs[0] policy
     /* 1898605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898615 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1898618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898639 */     // GIR_Coverage, 61996,
     /* 1898639 */     GIR_EraseRootFromParent_Done,
     /* 1898640 */   // Label 25469: @1898640
     /* 1898640 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1898726), // Rule ID 61997 //
     /* 1898645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1898662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1898665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898691 */     // MIs[0] policy
     /* 1898691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898701 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1898704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898725 */     // GIR_Coverage, 61997,
     /* 1898725 */     GIR_EraseRootFromParent_Done,
     /* 1898726 */   // Label 25470: @1898726
     /* 1898726 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1898812), // Rule ID 62000 //
     /* 1898731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1898748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1898751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898777 */     // MIs[0] policy
     /* 1898777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1898790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898811 */     // GIR_Coverage, 62000,
     /* 1898811 */     GIR_EraseRootFromParent_Done,
     /* 1898812 */   // Label 25471: @1898812
     /* 1898812 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1898898), // Rule ID 62001 //
     /* 1898817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1898834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1898837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898863 */     // MIs[0] policy
     /* 1898863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1898876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898897 */     // GIR_Coverage, 62001,
     /* 1898897 */     GIR_EraseRootFromParent_Done,
     /* 1898898 */   // Label 25472: @1898898
     /* 1898898 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1898984), // Rule ID 62004 //
     /* 1898903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1898906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1898914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1898917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1898920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1898923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898949 */     // MIs[0] policy
     /* 1898949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1898962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1898966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898983 */     // GIR_Coverage, 62004,
     /* 1898983 */     GIR_EraseRootFromParent_Done,
     /* 1898984 */   // Label 25473: @1898984
     /* 1898984 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1899070), // Rule ID 62005 //
     /* 1898989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1898992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1898997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1899006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1899009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899035 */     // MIs[0] policy
     /* 1899035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1899048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899069 */     // GIR_Coverage, 62005,
     /* 1899069 */     GIR_EraseRootFromParent_Done,
     /* 1899070 */   // Label 25474: @1899070
     /* 1899070 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1899156), // Rule ID 62008 //
     /* 1899075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1899092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1899095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899121 */     // MIs[0] policy
     /* 1899121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1899134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899155 */     // GIR_Coverage, 62008,
     /* 1899155 */     GIR_EraseRootFromParent_Done,
     /* 1899156 */   // Label 25475: @1899156
     /* 1899156 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1899242), // Rule ID 62009 //
     /* 1899161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1899164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1899178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1899181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899207 */     // MIs[0] policy
     /* 1899207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899217 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1899220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899241 */     // GIR_Coverage, 62009,
     /* 1899241 */     GIR_EraseRootFromParent_Done,
     /* 1899242 */   // Label 25476: @1899242
     /* 1899242 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1899328), // Rule ID 62012 //
     /* 1899247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1899264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1899267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1899270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899293 */     // MIs[0] policy
     /* 1899293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899303 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1899306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899327 */     // GIR_Coverage, 62012,
     /* 1899327 */     GIR_EraseRootFromParent_Done,
     /* 1899328 */   // Label 25477: @1899328
     /* 1899328 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1899414), // Rule ID 62013 //
     /* 1899333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1899336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1899350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1899353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1899356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899379 */     // MIs[0] policy
     /* 1899379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899389 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1899392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899413 */     // GIR_Coverage, 62013,
     /* 1899413 */     GIR_EraseRootFromParent_Done,
     /* 1899414 */   // Label 25478: @1899414
     /* 1899414 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1899500), // Rule ID 62016 //
     /* 1899419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1899430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1899433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1899436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1899439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899465 */     // MIs[0] policy
     /* 1899465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1899478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899499 */     // GIR_Coverage, 62016,
     /* 1899499 */     GIR_EraseRootFromParent_Done,
     /* 1899500 */   // Label 25479: @1899500
     /* 1899500 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1899586), // Rule ID 62017 //
     /* 1899505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1899508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1899516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1899519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1899522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1899525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899551 */     // MIs[0] policy
     /* 1899551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1899564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899585 */     // GIR_Coverage, 62017,
     /* 1899585 */     GIR_EraseRootFromParent_Done,
     /* 1899586 */   // Label 25480: @1899586
     /* 1899586 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1899672), // Rule ID 62020 //
     /* 1899591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1899608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1899611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899637 */     // MIs[0] policy
     /* 1899637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1899650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899671 */     // GIR_Coverage, 62020,
     /* 1899671 */     GIR_EraseRootFromParent_Done,
     /* 1899672 */   // Label 25481: @1899672
     /* 1899672 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1899758), // Rule ID 62021 //
     /* 1899677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1899680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1899694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1899697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899723 */     // MIs[0] policy
     /* 1899723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1899736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899757 */     // GIR_Coverage, 62021,
     /* 1899757 */     GIR_EraseRootFromParent_Done,
     /* 1899758 */   // Label 25482: @1899758
     /* 1899758 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1899844), // Rule ID 62024 //
     /* 1899763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1899780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1899783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899809 */     // MIs[0] policy
     /* 1899809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1899822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899843 */     // GIR_Coverage, 62024,
     /* 1899843 */     GIR_EraseRootFromParent_Done,
     /* 1899844 */   // Label 25483: @1899844
     /* 1899844 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1899930), // Rule ID 62025 //
     /* 1899849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1899852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1899866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1899869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899895 */     // MIs[0] policy
     /* 1899895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1899908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899929 */     // GIR_Coverage, 62025,
     /* 1899929 */     GIR_EraseRootFromParent_Done,
     /* 1899930 */   // Label 25484: @1899930
     /* 1899930 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1900016), // Rule ID 62028 //
     /* 1899935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1899938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1899943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1899952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1899955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1899973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899981 */     // MIs[0] policy
     /* 1899981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899991 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1899994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1899998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900015 */     // GIR_Coverage, 62028,
     /* 1900015 */     GIR_EraseRootFromParent_Done,
     /* 1900016 */   // Label 25485: @1900016
     /* 1900016 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1900102), // Rule ID 62029 //
     /* 1900021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1900029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1900041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900067 */     // MIs[0] policy
     /* 1900067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1900080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900101 */     // GIR_Coverage, 62029,
     /* 1900101 */     GIR_EraseRootFromParent_Done,
     /* 1900102 */   // Label 25486: @1900102
     /* 1900102 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1900188), // Rule ID 62032 //
     /* 1900107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1900115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1900127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1900130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900153 */     // MIs[0] policy
     /* 1900153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1900166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900187 */     // GIR_Coverage, 62032,
     /* 1900187 */     GIR_EraseRootFromParent_Done,
     /* 1900188 */   // Label 25487: @1900188
     /* 1900188 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1900274), // Rule ID 62033 //
     /* 1900193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1900201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1900213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1900216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900239 */     // MIs[0] policy
     /* 1900239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1900252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900273 */     // GIR_Coverage, 62033,
     /* 1900273 */     GIR_EraseRootFromParent_Done,
     /* 1900274 */   // Label 25488: @1900274
     /* 1900274 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1900360), // Rule ID 62036 //
     /* 1900279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1900299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900325 */     // MIs[0] policy
     /* 1900325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900335 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1900338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900359 */     // GIR_Coverage, 62036,
     /* 1900359 */     GIR_EraseRootFromParent_Done,
     /* 1900360 */   // Label 25489: @1900360
     /* 1900360 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1900446), // Rule ID 62037 //
     /* 1900365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1900385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900411 */     // MIs[0] policy
     /* 1900411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1900424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900445 */     // GIR_Coverage, 62037,
     /* 1900445 */     GIR_EraseRootFromParent_Done,
     /* 1900446 */   // Label 25490: @1900446
     /* 1900446 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1900532), // Rule ID 62040 //
     /* 1900451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1900471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900497 */     // MIs[0] policy
     /* 1900497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1900510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900531 */     // GIR_Coverage, 62040,
     /* 1900531 */     GIR_EraseRootFromParent_Done,
     /* 1900532 */   // Label 25491: @1900532
     /* 1900532 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1900618), // Rule ID 62041 //
     /* 1900537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1900557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900583 */     // MIs[0] policy
     /* 1900583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1900596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900617 */     // GIR_Coverage, 62041,
     /* 1900617 */     GIR_EraseRootFromParent_Done,
     /* 1900618 */   // Label 25492: @1900618
     /* 1900618 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1900704), // Rule ID 62044 //
     /* 1900623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1900643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900669 */     // MIs[0] policy
     /* 1900669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1900682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900703 */     // GIR_Coverage, 62044,
     /* 1900703 */     GIR_EraseRootFromParent_Done,
     /* 1900704 */   // Label 25493: @1900704
     /* 1900704 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1900790), // Rule ID 62045 //
     /* 1900709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1900729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900755 */     // MIs[0] policy
     /* 1900755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1900768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900789 */     // GIR_Coverage, 62045,
     /* 1900789 */     GIR_EraseRootFromParent_Done,
     /* 1900790 */   // Label 25494: @1900790
     /* 1900790 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1900876), // Rule ID 62048 //
     /* 1900795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1900815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900841 */     // MIs[0] policy
     /* 1900841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1900854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900875 */     // GIR_Coverage, 62048,
     /* 1900875 */     GIR_EraseRootFromParent_Done,
     /* 1900876 */   // Label 25495: @1900876
     /* 1900876 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1900962), // Rule ID 62049 //
     /* 1900881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1900884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1900898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1900901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1900919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900927 */     // MIs[0] policy
     /* 1900927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1900940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1900944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900961 */     // GIR_Coverage, 62049,
     /* 1900961 */     GIR_EraseRootFromParent_Done,
     /* 1900962 */   // Label 25496: @1900962
     /* 1900962 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1901048), // Rule ID 62052 //
     /* 1900967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1900970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1900975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1900984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1900987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1900990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1901005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901013 */     // MIs[0] policy
     /* 1901013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901023 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1901026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901047 */     // GIR_Coverage, 62052,
     /* 1901047 */     GIR_EraseRootFromParent_Done,
     /* 1901048 */   // Label 25497: @1901048
     /* 1901048 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1901134), // Rule ID 62053 //
     /* 1901053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1901056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1901061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1901064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1901067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1901070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1901073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1901076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1901091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901099 */     // MIs[0] policy
     /* 1901099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1901112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901133 */     // GIR_Coverage, 62053,
     /* 1901133 */     GIR_EraseRootFromParent_Done,
     /* 1901134 */   // Label 25498: @1901134
     /* 1901134 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1901223), // Rule ID 2644 //
     /* 1901139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1901165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901185 */     // MIs[0] round
     /* 1901185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901195 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1901195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1901198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901222 */     // GIR_Coverage, 2644,
     /* 1901222 */     GIR_EraseRootFromParent_Done,
     /* 1901223 */   // Label 25499: @1901223
     /* 1901223 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1901312), // Rule ID 2645 //
     /* 1901228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1901254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901274 */     // MIs[0] round
     /* 1901274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1901284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1901287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901311 */     // GIR_Coverage, 2645,
     /* 1901311 */     GIR_EraseRootFromParent_Done,
     /* 1901312 */   // Label 25500: @1901312
     /* 1901312 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1901401), // Rule ID 22682 //
     /* 1901317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1901343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901363 */     // MIs[0] round
     /* 1901363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901373 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1901373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1901376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901400 */     // GIR_Coverage, 22682,
     /* 1901400 */     GIR_EraseRootFromParent_Done,
     /* 1901401 */   // Label 25501: @1901401
     /* 1901401 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1901490), // Rule ID 22683 //
     /* 1901406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1901432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901452 */     // MIs[0] round
     /* 1901452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1901462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1901465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901489 */     // GIR_Coverage, 22683,
     /* 1901489 */     GIR_EraseRootFromParent_Done,
     /* 1901490 */   // Label 25502: @1901490
     /* 1901490 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1901579), // Rule ID 22686 //
     /* 1901495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1901521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901541 */     // MIs[0] round
     /* 1901541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901551 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1901551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1901554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901578 */     // GIR_Coverage, 22686,
     /* 1901578 */     GIR_EraseRootFromParent_Done,
     /* 1901579 */   // Label 25503: @1901579
     /* 1901579 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1901668), // Rule ID 22687 //
     /* 1901584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1901610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901630 */     // MIs[0] round
     /* 1901630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901640 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1901640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1901643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901667 */     // GIR_Coverage, 22687,
     /* 1901667 */     GIR_EraseRootFromParent_Done,
     /* 1901668 */   // Label 25504: @1901668
     /* 1901668 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1901757), // Rule ID 22690 //
     /* 1901673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1901699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901719 */     // MIs[0] round
     /* 1901719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901729 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1901729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 1901732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901756 */     // GIR_Coverage, 22690,
     /* 1901756 */     GIR_EraseRootFromParent_Done,
     /* 1901757 */   // Label 25505: @1901757
     /* 1901757 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1901846), // Rule ID 22691 //
     /* 1901762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1901788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901808 */     // MIs[0] round
     /* 1901808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1901818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 1901821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901845 */     // GIR_Coverage, 22691,
     /* 1901845 */     GIR_EraseRootFromParent_Done,
     /* 1901846 */   // Label 25506: @1901846
     /* 1901846 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1901935), // Rule ID 22694 //
     /* 1901851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1901877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901897 */     // MIs[0] round
     /* 1901897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901907 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1901907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 1901910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1901914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1901922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1901933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901934 */     // GIR_Coverage, 22694,
     /* 1901934 */     GIR_EraseRootFromParent_Done,
     /* 1901935 */   // Label 25507: @1901935
     /* 1901935 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1902024), // Rule ID 22695 //
     /* 1901940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1901948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1901966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901986 */     // MIs[0] round
     /* 1901986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1901989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901996 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1901996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 1901999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902023 */     // GIR_Coverage, 22695,
     /* 1902023 */     GIR_EraseRootFromParent_Done,
     /* 1902024 */   // Label 25508: @1902024
     /* 1902024 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1902113), // Rule ID 22698 //
     /* 1902029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1902040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1902043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1902046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1902049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902075 */     // MIs[0] round
     /* 1902075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902085 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 1902088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902112 */     // GIR_Coverage, 22698,
     /* 1902112 */     GIR_EraseRootFromParent_Done,
     /* 1902113 */   // Label 25509: @1902113
     /* 1902113 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1902202), // Rule ID 22699 //
     /* 1902118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1902129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1902132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1902135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1902138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1902144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902164 */     // MIs[0] round
     /* 1902164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1902174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 1902177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902201 */     // GIR_Coverage, 22699,
     /* 1902201 */     GIR_EraseRootFromParent_Done,
     /* 1902202 */   // Label 25510: @1902202
     /* 1902202 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1902291), // Rule ID 22702 //
     /* 1902207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902253 */     // MIs[0] round
     /* 1902253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902263 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 1902266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902290 */     // GIR_Coverage, 22702,
     /* 1902290 */     GIR_EraseRootFromParent_Done,
     /* 1902291 */   // Label 25511: @1902291
     /* 1902291 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1902380), // Rule ID 22703 //
     /* 1902296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1902322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902342 */     // MIs[0] round
     /* 1902342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1902352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 1902355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902379 */     // GIR_Coverage, 22703,
     /* 1902379 */     GIR_EraseRootFromParent_Done,
     /* 1902380 */   // Label 25512: @1902380
     /* 1902380 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1902469), // Rule ID 22706 //
     /* 1902385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902431 */     // MIs[0] round
     /* 1902431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902441 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 1902444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902468 */     // GIR_Coverage, 22706,
     /* 1902468 */     GIR_EraseRootFromParent_Done,
     /* 1902469 */   // Label 25513: @1902469
     /* 1902469 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1902558), // Rule ID 22707 //
     /* 1902474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1902500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902520 */     // MIs[0] round
     /* 1902520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1902530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 1902533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902557 */     // GIR_Coverage, 22707,
     /* 1902557 */     GIR_EraseRootFromParent_Done,
     /* 1902558 */   // Label 25514: @1902558
     /* 1902558 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1902647), // Rule ID 22710 //
     /* 1902563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902609 */     // MIs[0] round
     /* 1902609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902619 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 1902622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902646 */     // GIR_Coverage, 22710,
     /* 1902646 */     GIR_EraseRootFromParent_Done,
     /* 1902647 */   // Label 25515: @1902647
     /* 1902647 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1902736), // Rule ID 22711 //
     /* 1902652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1902663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1902666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1902672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1902678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902698 */     // MIs[0] round
     /* 1902698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10949:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1902708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 1902711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902735 */     // GIR_Coverage, 22711,
     /* 1902735 */     GIR_EraseRootFromParent_Done,
     /* 1902736 */   // Label 25516: @1902736
     /* 1902736 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1902825), // Rule ID 22714 //
     /* 1902741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1902752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1902755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1902761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902787 */     // MIs[0] round
     /* 1902787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902797 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 1902800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902824 */     // GIR_Coverage, 22714,
     /* 1902824 */     GIR_EraseRootFromParent_Done,
     /* 1902825 */   // Label 25517: @1902825
     /* 1902825 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1902914), // Rule ID 22715 //
     /* 1902830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1902841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1902844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1902850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1902856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902876 */     // MIs[0] round
     /* 1902876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902886 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1902886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 1902889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1902912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902913 */     // GIR_Coverage, 22715,
     /* 1902913 */     GIR_EraseRootFromParent_Done,
     /* 1902914 */   // Label 25518: @1902914
     /* 1902914 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1903003), // Rule ID 22718 //
     /* 1902919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1902927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1902930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1902933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1902939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1902945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902965 */     // MIs[0] round
     /* 1902965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1902968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1902975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 1902978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1902982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1902990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903002 */     // GIR_Coverage, 22718,
     /* 1903002 */     GIR_EraseRootFromParent_Done,
     /* 1903003 */   // Label 25519: @1903003
     /* 1903003 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1903092), // Rule ID 22719 //
     /* 1903008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1903025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1903028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903054 */     // MIs[0] round
     /* 1903054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 1903067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903091 */     // GIR_Coverage, 22719,
     /* 1903091 */     GIR_EraseRootFromParent_Done,
     /* 1903092 */   // Label 25520: @1903092
     /* 1903092 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1903181), // Rule ID 22722 //
     /* 1903097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1903117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1903123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903143 */     // MIs[0] round
     /* 1903143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903153 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1903153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 1903156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903180 */     // GIR_Coverage, 22722,
     /* 1903180 */     GIR_EraseRootFromParent_Done,
     /* 1903181 */   // Label 25521: @1903181
     /* 1903181 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1903270), // Rule ID 22723 //
     /* 1903186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1903206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903232 */     // MIs[0] round
     /* 1903232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903242 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10949:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 1903245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903269 */     // GIR_Coverage, 22723,
     /* 1903269 */     GIR_EraseRootFromParent_Done,
     /* 1903270 */   // Label 25522: @1903270
     /* 1903270 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1903359), // Rule ID 22726 //
     /* 1903275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1903301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903321 */     // MIs[0] round
     /* 1903321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903331 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1903331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 1903334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903358 */     // GIR_Coverage, 22726,
     /* 1903358 */     GIR_EraseRootFromParent_Done,
     /* 1903359 */   // Label 25523: @1903359
     /* 1903359 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1903448), // Rule ID 22727 //
     /* 1903364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903410 */     // MIs[0] round
     /* 1903410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903420 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 1903423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903447 */     // GIR_Coverage, 22727,
     /* 1903447 */     GIR_EraseRootFromParent_Done,
     /* 1903448 */   // Label 25524: @1903448
     /* 1903448 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1903537), // Rule ID 22730 //
     /* 1903453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1903479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903499 */     // MIs[0] round
     /* 1903499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903509 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1903509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 1903512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903536 */     // GIR_Coverage, 22730,
     /* 1903536 */     GIR_EraseRootFromParent_Done,
     /* 1903537 */   // Label 25525: @1903537
     /* 1903537 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1903626), // Rule ID 22731 //
     /* 1903542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903588 */     // MIs[0] round
     /* 1903588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 1903601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903625 */     // GIR_Coverage, 22731,
     /* 1903625 */     GIR_EraseRootFromParent_Done,
     /* 1903626 */   // Label 25526: @1903626
     /* 1903626 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1903715), // Rule ID 22734 //
     /* 1903631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1903657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903677 */     // MIs[0] round
     /* 1903677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903687 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1903687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 1903690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903714 */     // GIR_Coverage, 22734,
     /* 1903714 */     GIR_EraseRootFromParent_Done,
     /* 1903715 */   // Label 25527: @1903715
     /* 1903715 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1903804), // Rule ID 22735 //
     /* 1903720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1903728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903766 */     // MIs[0] round
     /* 1903766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10949:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 1903779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903803 */     // GIR_Coverage, 22735,
     /* 1903803 */     GIR_EraseRootFromParent_Done,
     /* 1903804 */   // Label 25528: @1903804
     /* 1903804 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1903893), // Rule ID 22738 //
     /* 1903809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1903817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1903829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1903835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903855 */     // MIs[0] round
     /* 1903855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1903865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 1903868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903892 */     // GIR_Coverage, 22738,
     /* 1903892 */     GIR_EraseRootFromParent_Done,
     /* 1903893 */   // Label 25529: @1903893
     /* 1903893 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1903982), // Rule ID 22739 //
     /* 1903898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1903906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1903918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1903924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903944 */     // MIs[0] round
     /* 1903944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1903947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903954 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1903954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 1903957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1903961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1903969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1903980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903981 */     // GIR_Coverage, 22739,
     /* 1903981 */     GIR_EraseRootFromParent_Done,
     /* 1903982 */   // Label 25530: @1903982
     /* 1903982 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1904071), // Rule ID 22742 //
     /* 1903987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1903995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1904004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904033 */     // MIs[0] round
     /* 1904033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904043 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 1904046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904070 */     // GIR_Coverage, 22742,
     /* 1904070 */     GIR_EraseRootFromParent_Done,
     /* 1904071 */   // Label 25531: @1904071
     /* 1904071 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1904160), // Rule ID 22743 //
     /* 1904076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1904093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904122 */     // MIs[0] round
     /* 1904122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1904132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 1904135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904159 */     // GIR_Coverage, 22743,
     /* 1904159 */     GIR_EraseRootFromParent_Done,
     /* 1904160 */   // Label 25532: @1904160
     /* 1904160 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1904249), // Rule ID 22746 //
     /* 1904165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904211 */     // MIs[0] round
     /* 1904211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904221 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 1904224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904248 */     // GIR_Coverage, 22746,
     /* 1904248 */     GIR_EraseRootFromParent_Done,
     /* 1904249 */   // Label 25533: @1904249
     /* 1904249 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1904338), // Rule ID 22747 //
     /* 1904254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904300 */     // MIs[0] round
     /* 1904300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904310 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1904310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 1904313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904337 */     // GIR_Coverage, 22747,
     /* 1904337 */     GIR_EraseRootFromParent_Done,
     /* 1904338 */   // Label 25534: @1904338
     /* 1904338 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1904427), // Rule ID 22750 //
     /* 1904343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904389 */     // MIs[0] round
     /* 1904389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904399 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 1904402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904426 */     // GIR_Coverage, 22750,
     /* 1904426 */     GIR_EraseRootFromParent_Done,
     /* 1904427 */   // Label 25535: @1904427
     /* 1904427 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1904516), // Rule ID 22751 //
     /* 1904432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904478 */     // MIs[0] round
     /* 1904478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1904488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 1904491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904515 */     // GIR_Coverage, 22751,
     /* 1904515 */     GIR_EraseRootFromParent_Done,
     /* 1904516 */   // Label 25536: @1904516
     /* 1904516 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1904605), // Rule ID 22754 //
     /* 1904521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904567 */     // MIs[0] round
     /* 1904567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 1904580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904604 */     // GIR_Coverage, 22754,
     /* 1904604 */     GIR_EraseRootFromParent_Done,
     /* 1904605 */   // Label 25537: @1904605
     /* 1904605 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1904694), // Rule ID 22755 //
     /* 1904610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904656 */     // MIs[0] round
     /* 1904656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904666 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1904666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 1904669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904693 */     // GIR_Coverage, 22755,
     /* 1904693 */     GIR_EraseRootFromParent_Done,
     /* 1904694 */   // Label 25538: @1904694
     /* 1904694 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1904783), // Rule ID 22758 //
     /* 1904699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904745 */     // MIs[0] round
     /* 1904745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904755 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 1904758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904782 */     // GIR_Coverage, 22758,
     /* 1904782 */     GIR_EraseRootFromParent_Done,
     /* 1904783 */   // Label 25539: @1904783
     /* 1904783 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1904872), // Rule ID 22759 //
     /* 1904788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904834 */     // MIs[0] round
     /* 1904834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1904844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 1904847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904871 */     // GIR_Coverage, 22759,
     /* 1904871 */     GIR_EraseRootFromParent_Done,
     /* 1904872 */   // Label 25540: @1904872
     /* 1904872 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1904961), // Rule ID 22762 //
     /* 1904877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1904903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904923 */     // MIs[0] round
     /* 1904923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1904926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1904933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 1904936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1904940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1904948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1904959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904960 */     // GIR_Coverage, 22762,
     /* 1904960 */     GIR_EraseRootFromParent_Done,
     /* 1904961 */   // Label 25541: @1904961
     /* 1904961 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1905050), // Rule ID 22763 //
     /* 1904966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1904974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1904992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905012 */     // MIs[0] round
     /* 1905012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 1905025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905049 */     // GIR_Coverage, 22763,
     /* 1905049 */     GIR_EraseRootFromParent_Done,
     /* 1905050 */   // Label 25542: @1905050
     /* 1905050 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1905139), // Rule ID 22766 //
     /* 1905055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1905072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905101 */     // MIs[0] round
     /* 1905101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905111 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1905111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 1905114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905138 */     // GIR_Coverage, 22766,
     /* 1905138 */     GIR_EraseRootFromParent_Done,
     /* 1905139 */   // Label 25543: @1905139
     /* 1905139 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1905228), // Rule ID 22767 //
     /* 1905144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1905161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1905170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905190 */     // MIs[0] round
     /* 1905190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905200 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 1905203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905227 */     // GIR_Coverage, 22767,
     /* 1905227 */     GIR_EraseRootFromParent_Done,
     /* 1905228 */   // Label 25544: @1905228
     /* 1905228 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1905317), // Rule ID 22770 //
     /* 1905233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905279 */     // MIs[0] round
     /* 1905279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905289 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1905289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 1905292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905316 */     // GIR_Coverage, 22770,
     /* 1905316 */     GIR_EraseRootFromParent_Done,
     /* 1905317 */   // Label 25545: @1905317
     /* 1905317 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1905406), // Rule ID 22771 //
     /* 1905322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1905348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905368 */     // MIs[0] round
     /* 1905368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905378 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10951:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 1905381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905405 */     // GIR_Coverage, 22771,
     /* 1905405 */     GIR_EraseRootFromParent_Done,
     /* 1905406 */   // Label 25546: @1905406
     /* 1905406 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1905495), // Rule ID 22774 //
     /* 1905411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905457 */     // MIs[0] round
     /* 1905457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905467 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1905467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 1905470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905494 */     // GIR_Coverage, 22774,
     /* 1905494 */     GIR_EraseRootFromParent_Done,
     /* 1905495 */   // Label 25547: @1905495
     /* 1905495 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1905584), // Rule ID 22775 //
     /* 1905500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1905526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905546 */     // MIs[0] round
     /* 1905546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 1905559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905583 */     // GIR_Coverage, 22775,
     /* 1905583 */     GIR_EraseRootFromParent_Done,
     /* 1905584 */   // Label 25548: @1905584
     /* 1905584 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1905673), // Rule ID 22778 //
     /* 1905589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905635 */     // MIs[0] round
     /* 1905635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1905645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 1905648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905672 */     // GIR_Coverage, 22778,
     /* 1905672 */     GIR_EraseRootFromParent_Done,
     /* 1905673 */   // Label 25549: @1905673
     /* 1905673 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1905762), // Rule ID 22779 //
     /* 1905678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1905704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905724 */     // MIs[0] round
     /* 1905724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 1905737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905761 */     // GIR_Coverage, 22779,
     /* 1905761 */     GIR_EraseRootFromParent_Done,
     /* 1905762 */   // Label 25550: @1905762
     /* 1905762 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1905851), // Rule ID 22782 //
     /* 1905767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905813 */     // MIs[0] round
     /* 1905813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905823 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1905823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 1905826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905850 */     // GIR_Coverage, 22782,
     /* 1905850 */     GIR_EraseRootFromParent_Done,
     /* 1905851 */   // Label 25551: @1905851
     /* 1905851 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1905940), // Rule ID 22783 //
     /* 1905856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1905882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905902 */     // MIs[0] round
     /* 1905902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10951:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1905912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 1905915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1905919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1905927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1905938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905939 */     // GIR_Coverage, 22783,
     /* 1905939 */     GIR_EraseRootFromParent_Done,
     /* 1905940 */   // Label 25552: @1905940
     /* 1905940 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1906029), // Rule ID 22786 //
     /* 1905945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1905953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1905956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1905959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1905965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1905971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905991 */     // MIs[0] round
     /* 1905991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1905994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906001 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 1906004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906028 */     // GIR_Coverage, 22786,
     /* 1906028 */     GIR_EraseRootFromParent_Done,
     /* 1906029 */   // Label 25553: @1906029
     /* 1906029 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1906118), // Rule ID 22787 //
     /* 1906034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1906042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1906051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906080 */     // MIs[0] round
     /* 1906080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 1906093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906117 */     // GIR_Coverage, 22787,
     /* 1906117 */     GIR_EraseRootFromParent_Done,
     /* 1906118 */   // Label 25554: @1906118
     /* 1906118 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1906207), // Rule ID 22790 //
     /* 1906123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1906131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1906140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1906149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906169 */     // MIs[0] round
     /* 1906169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 1906182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906206 */     // GIR_Coverage, 22790,
     /* 1906206 */     GIR_EraseRootFromParent_Done,
     /* 1906207 */   // Label 25555: @1906207
     /* 1906207 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1906296), // Rule ID 22791 //
     /* 1906212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1906220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1906229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906258 */     // MIs[0] round
     /* 1906258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 1906271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906295 */     // GIR_Coverage, 22791,
     /* 1906295 */     GIR_EraseRootFromParent_Done,
     /* 1906296 */   // Label 25556: @1906296
     /* 1906296 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1906385), // Rule ID 22794 //
     /* 1906301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1906309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1906327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906347 */     // MIs[0] round
     /* 1906347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 1906360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906384 */     // GIR_Coverage, 22794,
     /* 1906384 */     GIR_EraseRootFromParent_Done,
     /* 1906385 */   // Label 25557: @1906385
     /* 1906385 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1906474), // Rule ID 22795 //
     /* 1906390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1906398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906436 */     // MIs[0] round
     /* 1906436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906446 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10951:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 1906449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906473 */     // GIR_Coverage, 22795,
     /* 1906473 */     GIR_EraseRootFromParent_Done,
     /* 1906474 */   // Label 25558: @1906474
     /* 1906474 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1906563), // Rule ID 22918 //
     /* 1906479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1906505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906525 */     // MIs[0] round
     /* 1906525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906535 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 1906538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906562 */     // GIR_Coverage, 22918,
     /* 1906562 */     GIR_EraseRootFromParent_Done,
     /* 1906563 */   // Label 25559: @1906563
     /* 1906563 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1906652), // Rule ID 22919 //
     /* 1906568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906614 */     // MIs[0] round
     /* 1906614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 1906627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906651 */     // GIR_Coverage, 22919,
     /* 1906651 */     GIR_EraseRootFromParent_Done,
     /* 1906652 */   // Label 25560: @1906652
     /* 1906652 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1906741), // Rule ID 22922 //
     /* 1906657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1906683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906703 */     // MIs[0] round
     /* 1906703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906713 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 1906716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906740 */     // GIR_Coverage, 22922,
     /* 1906740 */     GIR_EraseRootFromParent_Done,
     /* 1906741 */   // Label 25561: @1906741
     /* 1906741 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1906830), // Rule ID 22923 //
     /* 1906746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906792 */     // MIs[0] round
     /* 1906792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 1906805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906829 */     // GIR_Coverage, 22923,
     /* 1906829 */     GIR_EraseRootFromParent_Done,
     /* 1906830 */   // Label 25562: @1906830
     /* 1906830 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1906919), // Rule ID 22926 //
     /* 1906835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1906861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906881 */     // MIs[0] round
     /* 1906881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906891 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1906891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 1906894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1906917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906918 */     // GIR_Coverage, 22926,
     /* 1906918 */     GIR_EraseRootFromParent_Done,
     /* 1906919 */   // Label 25563: @1906919
     /* 1906919 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1907008), // Rule ID 22927 //
     /* 1906924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1906932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1906950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906970 */     // MIs[0] round
     /* 1906970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1906973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906980 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1906980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 1906983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1906987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1906995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907007 */     // GIR_Coverage, 22927,
     /* 1907007 */     GIR_EraseRootFromParent_Done,
     /* 1907008 */   // Label 25564: @1907008
     /* 1907008 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1907097), // Rule ID 22930 //
     /* 1907013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1907030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907059 */     // MIs[0] round
     /* 1907059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907069 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 1907072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907096 */     // GIR_Coverage, 22930,
     /* 1907096 */     GIR_EraseRootFromParent_Done,
     /* 1907097 */   // Label 25565: @1907097
     /* 1907097 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1907186), // Rule ID 22931 //
     /* 1907102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1907119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1907128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907148 */     // MIs[0] round
     /* 1907148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1907158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 1907161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907185 */     // GIR_Coverage, 22931,
     /* 1907185 */     GIR_EraseRootFromParent_Done,
     /* 1907186 */   // Label 25566: @1907186
     /* 1907186 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1907275), // Rule ID 22934 //
     /* 1907191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1907208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1907211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907237 */     // MIs[0] round
     /* 1907237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907247 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 1907250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907274 */     // GIR_Coverage, 22934,
     /* 1907274 */     GIR_EraseRootFromParent_Done,
     /* 1907275 */   // Label 25567: @1907275
     /* 1907275 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1907364), // Rule ID 22935 //
     /* 1907280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1907297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1907300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1907306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907326 */     // MIs[0] round
     /* 1907326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1907336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 1907339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907363 */     // GIR_Coverage, 22935,
     /* 1907363 */     GIR_EraseRootFromParent_Done,
     /* 1907364 */   // Label 25568: @1907364
     /* 1907364 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1907453), // Rule ID 22938 //
     /* 1907369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907415 */     // MIs[0] round
     /* 1907415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907425 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 1907428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907452 */     // GIR_Coverage, 22938,
     /* 1907452 */     GIR_EraseRootFromParent_Done,
     /* 1907453 */   // Label 25569: @1907453
     /* 1907453 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1907542), // Rule ID 22939 //
     /* 1907458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1907484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907504 */     // MIs[0] round
     /* 1907504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907514 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1907514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 1907517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907541 */     // GIR_Coverage, 22939,
     /* 1907541 */     GIR_EraseRootFromParent_Done,
     /* 1907542 */   // Label 25570: @1907542
     /* 1907542 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1907631), // Rule ID 22942 //
     /* 1907547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907593 */     // MIs[0] round
     /* 1907593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907603 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 1907606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907630 */     // GIR_Coverage, 22942,
     /* 1907630 */     GIR_EraseRootFromParent_Done,
     /* 1907631 */   // Label 25571: @1907631
     /* 1907631 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1907720), // Rule ID 22943 //
     /* 1907636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1907662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907682 */     // MIs[0] round
     /* 1907682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1907692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 1907695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907719 */     // GIR_Coverage, 22943,
     /* 1907719 */     GIR_EraseRootFromParent_Done,
     /* 1907720 */   // Label 25572: @1907720
     /* 1907720 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1907809), // Rule ID 22946 //
     /* 1907725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907771 */     // MIs[0] round
     /* 1907771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907781 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 1907784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907808 */     // GIR_Coverage, 22946,
     /* 1907808 */     GIR_EraseRootFromParent_Done,
     /* 1907809 */   // Label 25573: @1907809
     /* 1907809 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1907898), // Rule ID 22947 //
     /* 1907814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1907834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1907840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907860 */     // MIs[0] round
     /* 1907860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1907870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 1907873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907897 */     // GIR_Coverage, 22947,
     /* 1907897 */     GIR_EraseRootFromParent_Done,
     /* 1907898 */   // Label 25574: @1907898
     /* 1907898 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1907987), // Rule ID 22950 //
     /* 1907903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1907911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1907923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1907929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907949 */     // MIs[0] round
     /* 1907949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1907952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907959 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1907959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 1907962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1907966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1907974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1907985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907986 */     // GIR_Coverage, 22950,
     /* 1907986 */     GIR_EraseRootFromParent_Done,
     /* 1907987 */   // Label 25575: @1907987
     /* 1907987 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1908076), // Rule ID 22951 //
     /* 1907992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1908000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1908009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908038 */     // MIs[0] round
     /* 1908038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908048 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 1908051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908075 */     // GIR_Coverage, 22951,
     /* 1908075 */     GIR_EraseRootFromParent_Done,
     /* 1908076 */   // Label 25576: @1908076
     /* 1908076 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1908165), // Rule ID 22954 //
     /* 1908081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1908089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908127 */     // MIs[0] round
     /* 1908127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908137 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1908137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 1908140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908164 */     // GIR_Coverage, 22954,
     /* 1908164 */     GIR_EraseRootFromParent_Done,
     /* 1908165 */   // Label 25577: @1908165
     /* 1908165 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1908254), // Rule ID 22955 //
     /* 1908170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1908178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908216 */     // MIs[0] round
     /* 1908216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908226 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 1908229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908253 */     // GIR_Coverage, 22955,
     /* 1908253 */     GIR_EraseRootFromParent_Done,
     /* 1908254 */   // Label 25578: @1908254
     /* 1908254 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1908343), // Rule ID 22958 //
     /* 1908259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1908267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908305 */     // MIs[0] round
     /* 1908305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908315 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1908315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 1908318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908342 */     // GIR_Coverage, 22958,
     /* 1908342 */     GIR_EraseRootFromParent_Done,
     /* 1908343 */   // Label 25579: @1908343
     /* 1908343 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1908432), // Rule ID 22959 //
     /* 1908348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 1908356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908394 */     // MIs[0] round
     /* 1908394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 1908407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908431 */     // GIR_Coverage, 22959,
     /* 1908431 */     GIR_EraseRootFromParent_Done,
     /* 1908432 */   // Label 25580: @1908432
     /* 1908432 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1908521), // Rule ID 22962 //
     /* 1908437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908483 */     // MIs[0] round
     /* 1908483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908493 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1908493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 1908496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908520 */     // GIR_Coverage, 22962,
     /* 1908520 */     GIR_EraseRootFromParent_Done,
     /* 1908521 */   // Label 25581: @1908521
     /* 1908521 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1908610), // Rule ID 22963 //
     /* 1908526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908572 */     // MIs[0] round
     /* 1908572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 1908585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908609 */     // GIR_Coverage, 22963,
     /* 1908609 */     GIR_EraseRootFromParent_Done,
     /* 1908610 */   // Label 25582: @1908610
     /* 1908610 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1908699), // Rule ID 22966 //
     /* 1908615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908661 */     // MIs[0] round
     /* 1908661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908671 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1908671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 1908674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908698 */     // GIR_Coverage, 22966,
     /* 1908698 */     GIR_EraseRootFromParent_Done,
     /* 1908699 */   // Label 25583: @1908699
     /* 1908699 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1908788), // Rule ID 22967 //
     /* 1908704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908750 */     // MIs[0] round
     /* 1908750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 1908763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908787 */     // GIR_Coverage, 22967,
     /* 1908787 */     GIR_EraseRootFromParent_Done,
     /* 1908788 */   // Label 25584: @1908788
     /* 1908788 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1908877), // Rule ID 22970 //
     /* 1908793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908839 */     // MIs[0] round
     /* 1908839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1908849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 1908852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908876 */     // GIR_Coverage, 22970,
     /* 1908876 */     GIR_EraseRootFromParent_Done,
     /* 1908877 */   // Label 25585: @1908877
     /* 1908877 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1908966), // Rule ID 22971 //
     /* 1908882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1908908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908928 */     // MIs[0] round
     /* 1908928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1908931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908938 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1908938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 1908941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1908945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1908953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1908964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908965 */     // GIR_Coverage, 22971,
     /* 1908965 */     GIR_EraseRootFromParent_Done,
     /* 1908966 */   // Label 25586: @1908966
     /* 1908966 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1909055), // Rule ID 22974 //
     /* 1908971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1908979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1908997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909017 */     // MIs[0] round
     /* 1909017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909027 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 1909030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909054 */     // GIR_Coverage, 22974,
     /* 1909054 */     GIR_EraseRootFromParent_Done,
     /* 1909055 */   // Label 25587: @1909055
     /* 1909055 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1909144), // Rule ID 22975 //
     /* 1909060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1909077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909106 */     // MIs[0] round
     /* 1909106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1909116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 1909119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909143 */     // GIR_Coverage, 22975,
     /* 1909143 */     GIR_EraseRootFromParent_Done,
     /* 1909144 */   // Label 25588: @1909144
     /* 1909144 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1909233), // Rule ID 22978 //
     /* 1909149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1909175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909195 */     // MIs[0] round
     /* 1909195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909205 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 1909208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909232 */     // GIR_Coverage, 22978,
     /* 1909232 */     GIR_EraseRootFromParent_Done,
     /* 1909233 */   // Label 25589: @1909233
     /* 1909233 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1909322), // Rule ID 22979 //
     /* 1909238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909284 */     // MIs[0] round
     /* 1909284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1909294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 1909297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909321 */     // GIR_Coverage, 22979,
     /* 1909321 */     GIR_EraseRootFromParent_Done,
     /* 1909322 */   // Label 25590: @1909322
     /* 1909322 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1909411), // Rule ID 22982 //
     /* 1909327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1909353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909373 */     // MIs[0] round
     /* 1909373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909383 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 1909386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909410 */     // GIR_Coverage, 22982,
     /* 1909410 */     GIR_EraseRootFromParent_Done,
     /* 1909411 */   // Label 25591: @1909411
     /* 1909411 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1909500), // Rule ID 22983 //
     /* 1909416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909462 */     // MIs[0] round
     /* 1909462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1909472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 1909475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909499 */     // GIR_Coverage, 22983,
     /* 1909499 */     GIR_EraseRootFromParent_Done,
     /* 1909500 */   // Label 25592: @1909500
     /* 1909500 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1909589), // Rule ID 22986 //
     /* 1909505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1909531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909551 */     // MIs[0] round
     /* 1909551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909561 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 1909564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909588 */     // GIR_Coverage, 22986,
     /* 1909588 */     GIR_EraseRootFromParent_Done,
     /* 1909589 */   // Label 25593: @1909589
     /* 1909589 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1909678), // Rule ID 22987 //
     /* 1909594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909640 */     // MIs[0] round
     /* 1909640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1909650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 1909653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909677 */     // GIR_Coverage, 22987,
     /* 1909677 */     GIR_EraseRootFromParent_Done,
     /* 1909678 */   // Label 25594: @1909678
     /* 1909678 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1909767), // Rule ID 22990 //
     /* 1909683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1909709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909729 */     // MIs[0] round
     /* 1909729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 1909742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909766 */     // GIR_Coverage, 22990,
     /* 1909766 */     GIR_EraseRootFromParent_Done,
     /* 1909767 */   // Label 25595: @1909767
     /* 1909767 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1909856), // Rule ID 22991 //
     /* 1909772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909818 */     // MIs[0] round
     /* 1909818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11003:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1909828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 1909831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909855 */     // GIR_Coverage, 22991,
     /* 1909855 */     GIR_EraseRootFromParent_Done,
     /* 1909856 */   // Label 25596: @1909856
     /* 1909856 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1909945), // Rule ID 22994 //
     /* 1909861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1909887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909907 */     // MIs[0] round
     /* 1909907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909917 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1909917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 1909920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1909924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1909932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1909943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909944 */     // GIR_Coverage, 22994,
     /* 1909944 */     GIR_EraseRootFromParent_Done,
     /* 1909945 */   // Label 25597: @1909945
     /* 1909945 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1910034), // Rule ID 22995 //
     /* 1909950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1909958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1909976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909996 */     // MIs[0] round
     /* 1909996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1909999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910006 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1910006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 1910009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1910013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1910032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910033 */     // GIR_Coverage, 22995,
     /* 1910033 */     GIR_EraseRootFromParent_Done,
     /* 1910034 */   // Label 25598: @1910034
     /* 1910034 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1910123), // Rule ID 22998 //
     /* 1910039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1910047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1910050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1910053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1910059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1910065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910085 */     // MIs[0] round
     /* 1910085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910095 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1910095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 1910098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1910102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1910121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910122 */     // GIR_Coverage, 22998,
     /* 1910122 */     GIR_EraseRootFromParent_Done,
     /* 1910123 */   // Label 25599: @1910123
     /* 1910123 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1910212), // Rule ID 22999 //
     /* 1910128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1910136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1910139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1910142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1910148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1910154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910174 */     // MIs[0] round
     /* 1910174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910184 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1910184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 1910187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1910191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1910210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910211 */     // GIR_Coverage, 22999,
     /* 1910211 */     GIR_EraseRootFromParent_Done,
     /* 1910212 */   // Label 25600: @1910212
     /* 1910212 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1910301), // Rule ID 23002 //
     /* 1910217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1910225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1910228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1910231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1910237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1910243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910263 */     // MIs[0] round
     /* 1910263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910273 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1910273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 1910276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1910280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1910299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910300 */     // GIR_Coverage, 23002,
     /* 1910300 */     GIR_EraseRootFromParent_Done,
     /* 1910301 */   // Label 25601: @1910301
     /* 1910301 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1910390), // Rule ID 23003 //
     /* 1910306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 1910314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1910317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1910320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1910326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1910332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910352 */     // MIs[0] round
     /* 1910352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910362 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11003:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1910362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 1910365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1910369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1910388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910389 */     // GIR_Coverage, 23003,
     /* 1910389 */     GIR_EraseRootFromParent_Done,
     /* 1910390 */   // Label 25602: @1910390
     /* 1910390 */   GIM_Reject,
     /* 1910391 */ // Label 18600: @1910391
     /* 1910391 */ GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(2098692),
     /* 1910396 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 1910399 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1910501), // Rule ID 15838 //
     /* 1910404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1910407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1910415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1910418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1910421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1910430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910454 */     // MIs[1] Operand 1
     /* 1910454 */     // No operand predicates
     /* 1910454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910458 */     // MIs[0] round
     /* 1910458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910461 */     // MIs[0] policy
     /* 1910461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910473 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 1910476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1910497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1910499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910500 */     // GIR_Coverage, 15838,
     /* 1910500 */     GIR_EraseRootFromParent_Done,
     /* 1910501 */   // Label 25604: @1910501
     /* 1910501 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1910603), // Rule ID 15839 //
     /* 1910506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1910509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1910517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1910520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1910523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1910532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910556 */     // MIs[1] Operand 1
     /* 1910556 */     // No operand predicates
     /* 1910556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910560 */     // MIs[0] round
     /* 1910560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910563 */     // MIs[0] policy
     /* 1910563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910575 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 1910578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1910599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1910601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910602 */     // GIR_Coverage, 15839,
     /* 1910602 */     GIR_EraseRootFromParent_Done,
     /* 1910603 */   // Label 25605: @1910603
     /* 1910603 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1910705), // Rule ID 15842 //
     /* 1910608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1910611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1910619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1910622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1910625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1910634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910658 */     // MIs[1] Operand 1
     /* 1910658 */     // No operand predicates
     /* 1910658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910662 */     // MIs[0] round
     /* 1910662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910665 */     // MIs[0] policy
     /* 1910665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 1910680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1910701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1910703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910704 */     // GIR_Coverage, 15842,
     /* 1910704 */     GIR_EraseRootFromParent_Done,
     /* 1910705 */   // Label 25606: @1910705
     /* 1910705 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1910807), // Rule ID 15843 //
     /* 1910710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1910713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1910721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1910724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1910727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1910736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910760 */     // MIs[1] Operand 1
     /* 1910760 */     // No operand predicates
     /* 1910760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910764 */     // MIs[0] round
     /* 1910764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910767 */     // MIs[0] policy
     /* 1910767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910779 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 1910782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1910803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1910805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910806 */     // GIR_Coverage, 15843,
     /* 1910806 */     GIR_EraseRootFromParent_Done,
     /* 1910807 */   // Label 25607: @1910807
     /* 1910807 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1910909), // Rule ID 15846 //
     /* 1910812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1910815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1910823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1910826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1910829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1910838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910862 */     // MIs[1] Operand 1
     /* 1910862 */     // No operand predicates
     /* 1910862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910866 */     // MIs[0] round
     /* 1910866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910869 */     // MIs[0] policy
     /* 1910869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910881 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1910884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1910905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1910907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910908 */     // GIR_Coverage, 15846,
     /* 1910908 */     GIR_EraseRootFromParent_Done,
     /* 1910909 */   // Label 25608: @1910909
     /* 1910909 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1911011), // Rule ID 15847 //
     /* 1910914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1910917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1910922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1910925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1910928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1910931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1910940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1910956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1910964 */     // MIs[1] Operand 1
     /* 1910964 */     // No operand predicates
     /* 1910964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910968 */     // MIs[0] round
     /* 1910968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1910971 */     // MIs[0] policy
     /* 1910971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1910974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1910976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910983 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1910986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1910995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1910999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1911007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911010 */     // GIR_Coverage, 15847,
     /* 1911010 */     GIR_EraseRootFromParent_Done,
     /* 1911011 */   // Label 25609: @1911011
     /* 1911011 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1911113), // Rule ID 15850 //
     /* 1911016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1911019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1911042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911066 */     // MIs[1] Operand 1
     /* 1911066 */     // No operand predicates
     /* 1911066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911070 */     // MIs[0] round
     /* 1911070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911073 */     // MIs[0] policy
     /* 1911073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 1911088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911112 */     // GIR_Coverage, 15850,
     /* 1911112 */     GIR_EraseRootFromParent_Done,
     /* 1911113 */   // Label 25610: @1911113
     /* 1911113 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1911215), // Rule ID 15851 //
     /* 1911118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1911121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1911144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911168 */     // MIs[1] Operand 1
     /* 1911168 */     // No operand predicates
     /* 1911168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911172 */     // MIs[0] round
     /* 1911172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911175 */     // MIs[0] policy
     /* 1911175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911187 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 1911190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911214 */     // GIR_Coverage, 15851,
     /* 1911214 */     GIR_EraseRootFromParent_Done,
     /* 1911215 */   // Label 25611: @1911215
     /* 1911215 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1911317), // Rule ID 15854 //
     /* 1911220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1911223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1911246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911270 */     // MIs[1] Operand 1
     /* 1911270 */     // No operand predicates
     /* 1911270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911274 */     // MIs[0] round
     /* 1911274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911277 */     // MIs[0] policy
     /* 1911277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1911292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911316 */     // GIR_Coverage, 15854,
     /* 1911316 */     GIR_EraseRootFromParent_Done,
     /* 1911317 */   // Label 25612: @1911317
     /* 1911317 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1911419), // Rule ID 15855 //
     /* 1911322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1911325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1911348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911372 */     // MIs[1] Operand 1
     /* 1911372 */     // No operand predicates
     /* 1911372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911376 */     // MIs[0] round
     /* 1911376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911379 */     // MIs[0] policy
     /* 1911379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911391 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1911394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911418 */     // GIR_Coverage, 15855,
     /* 1911418 */     GIR_EraseRootFromParent_Done,
     /* 1911419 */   // Label 25613: @1911419
     /* 1911419 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1911521), // Rule ID 15858 //
     /* 1911424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1911427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1911450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911474 */     // MIs[1] Operand 1
     /* 1911474 */     // No operand predicates
     /* 1911474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911478 */     // MIs[0] round
     /* 1911478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911481 */     // MIs[0] policy
     /* 1911481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1911496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911520 */     // GIR_Coverage, 15858,
     /* 1911520 */     GIR_EraseRootFromParent_Done,
     /* 1911521 */   // Label 25614: @1911521
     /* 1911521 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1911623), // Rule ID 15859 //
     /* 1911526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1911529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1911552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911576 */     // MIs[1] Operand 1
     /* 1911576 */     // No operand predicates
     /* 1911576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911580 */     // MIs[0] round
     /* 1911580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911583 */     // MIs[0] policy
     /* 1911583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 1911598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911622 */     // GIR_Coverage, 15859,
     /* 1911622 */     GIR_EraseRootFromParent_Done,
     /* 1911623 */   // Label 25615: @1911623
     /* 1911623 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1911725), // Rule ID 15862 //
     /* 1911628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1911631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1911639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1911642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1911645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1911654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911678 */     // MIs[1] Operand 1
     /* 1911678 */     // No operand predicates
     /* 1911678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911682 */     // MIs[0] round
     /* 1911682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911685 */     // MIs[0] policy
     /* 1911685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911697 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1911700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1911721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911724 */     // GIR_Coverage, 15862,
     /* 1911724 */     GIR_EraseRootFromParent_Done,
     /* 1911725 */   // Label 25616: @1911725
     /* 1911725 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1911827), // Rule ID 15863 //
     /* 1911730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1911733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1911741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1911744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1911747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1911756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911780 */     // MIs[1] Operand 1
     /* 1911780 */     // No operand predicates
     /* 1911780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911784 */     // MIs[0] round
     /* 1911784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911787 */     // MIs[0] policy
     /* 1911787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1911802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1911823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911826 */     // GIR_Coverage, 15863,
     /* 1911826 */     GIR_EraseRootFromParent_Done,
     /* 1911827 */   // Label 25617: @1911827
     /* 1911827 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1911929), // Rule ID 15866 //
     /* 1911832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1911835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1911858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911882 */     // MIs[1] Operand 1
     /* 1911882 */     // No operand predicates
     /* 1911882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911886 */     // MIs[0] round
     /* 1911886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911889 */     // MIs[0] policy
     /* 1911889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911901 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1911904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1911913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1911917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1911927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911928 */     // GIR_Coverage, 15866,
     /* 1911928 */     GIR_EraseRootFromParent_Done,
     /* 1911929 */   // Label 25618: @1911929
     /* 1911929 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1912031), // Rule ID 15867 //
     /* 1911934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1911937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1911942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1911960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1911976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1911980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1911984 */     // MIs[1] Operand 1
     /* 1911984 */     // No operand predicates
     /* 1911984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911988 */     // MIs[0] round
     /* 1911988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1911991 */     // MIs[0] policy
     /* 1911991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1911994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912003 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1912006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912030 */     // GIR_Coverage, 15867,
     /* 1912030 */     GIR_EraseRootFromParent_Done,
     /* 1912031 */   // Label 25619: @1912031
     /* 1912031 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1912133), // Rule ID 15870 //
     /* 1912036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1912039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1912062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912086 */     // MIs[1] Operand 1
     /* 1912086 */     // No operand predicates
     /* 1912086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912090 */     // MIs[0] round
     /* 1912090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912093 */     // MIs[0] policy
     /* 1912093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912105 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1912108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912132 */     // GIR_Coverage, 15870,
     /* 1912132 */     GIR_EraseRootFromParent_Done,
     /* 1912133 */   // Label 25620: @1912133
     /* 1912133 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1912235), // Rule ID 15871 //
     /* 1912138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1912141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1912164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912188 */     // MIs[1] Operand 1
     /* 1912188 */     // No operand predicates
     /* 1912188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912192 */     // MIs[0] round
     /* 1912192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912195 */     // MIs[0] policy
     /* 1912195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1912210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912234 */     // GIR_Coverage, 15871,
     /* 1912234 */     GIR_EraseRootFromParent_Done,
     /* 1912235 */   // Label 25621: @1912235
     /* 1912235 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1912337), // Rule ID 15874 //
     /* 1912240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1912243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1912266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912290 */     // MIs[1] Operand 1
     /* 1912290 */     // No operand predicates
     /* 1912290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912294 */     // MIs[0] round
     /* 1912294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912297 */     // MIs[0] policy
     /* 1912297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1912312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912336 */     // GIR_Coverage, 15874,
     /* 1912336 */     GIR_EraseRootFromParent_Done,
     /* 1912337 */   // Label 25622: @1912337
     /* 1912337 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1912439), // Rule ID 15875 //
     /* 1912342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1912345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1912368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912392 */     // MIs[1] Operand 1
     /* 1912392 */     // No operand predicates
     /* 1912392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912396 */     // MIs[0] round
     /* 1912396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912399 */     // MIs[0] policy
     /* 1912399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 1912414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912438 */     // GIR_Coverage, 15875,
     /* 1912438 */     GIR_EraseRootFromParent_Done,
     /* 1912439 */   // Label 25623: @1912439
     /* 1912439 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1912541), // Rule ID 15878 //
     /* 1912444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1912447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1912455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1912458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1912461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1912470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912494 */     // MIs[1] Operand 1
     /* 1912494 */     // No operand predicates
     /* 1912494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912498 */     // MIs[0] round
     /* 1912498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912501 */     // MIs[0] policy
     /* 1912501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1912516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1912537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912540 */     // GIR_Coverage, 15878,
     /* 1912540 */     GIR_EraseRootFromParent_Done,
     /* 1912541 */   // Label 25624: @1912541
     /* 1912541 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1912643), // Rule ID 15879 //
     /* 1912546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1912549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1912557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1912560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1912563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1912572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912596 */     // MIs[1] Operand 1
     /* 1912596 */     // No operand predicates
     /* 1912596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912600 */     // MIs[0] round
     /* 1912600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912603 */     // MIs[0] policy
     /* 1912603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912615 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1912618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1912639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912642 */     // GIR_Coverage, 15879,
     /* 1912642 */     GIR_EraseRootFromParent_Done,
     /* 1912643 */   // Label 25625: @1912643
     /* 1912643 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1912745), // Rule ID 15882 //
     /* 1912648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1912651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1912659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1912662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1912665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1912674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912698 */     // MIs[1] Operand 1
     /* 1912698 */     // No operand predicates
     /* 1912698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912702 */     // MIs[0] round
     /* 1912702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912705 */     // MIs[0] policy
     /* 1912705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912717 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1912720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1912741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912744 */     // GIR_Coverage, 15882,
     /* 1912744 */     GIR_EraseRootFromParent_Done,
     /* 1912745 */   // Label 25626: @1912745
     /* 1912745 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1912847), // Rule ID 15883 //
     /* 1912750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1912753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1912761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1912764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1912767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1912776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912800 */     // MIs[1] Operand 1
     /* 1912800 */     // No operand predicates
     /* 1912800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912804 */     // MIs[0] round
     /* 1912804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912807 */     // MIs[0] policy
     /* 1912807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912819 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1912822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1912843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912846 */     // GIR_Coverage, 15883,
     /* 1912846 */     GIR_EraseRootFromParent_Done,
     /* 1912847 */   // Label 25627: @1912847
     /* 1912847 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1912949), // Rule ID 15886 //
     /* 1912852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1912855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1912863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1912866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1912869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1912875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1912878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1912898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1912902 */     // MIs[1] Operand 1
     /* 1912902 */     // No operand predicates
     /* 1912902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912906 */     // MIs[0] round
     /* 1912906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1912909 */     // MIs[0] policy
     /* 1912909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1912912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1912914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912921 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1912924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1912933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1912937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1912945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1912947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912948 */     // GIR_Coverage, 15886,
     /* 1912948 */     GIR_EraseRootFromParent_Done,
     /* 1912949 */   // Label 25628: @1912949
     /* 1912949 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1913051), // Rule ID 15887 //
     /* 1912954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1912957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1912962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1912965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1912968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1912971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1912977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1912980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1912996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913004 */     // MIs[1] Operand 1
     /* 1913004 */     // No operand predicates
     /* 1913004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913008 */     // MIs[0] round
     /* 1913008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913011 */     // MIs[0] policy
     /* 1913011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913023 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1913026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1913047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913050 */     // GIR_Coverage, 15887,
     /* 1913050 */     GIR_EraseRootFromParent_Done,
     /* 1913051 */   // Label 25629: @1913051
     /* 1913051 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1913153), // Rule ID 15890 //
     /* 1913056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1913059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1913070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1913073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1913082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913106 */     // MIs[1] Operand 1
     /* 1913106 */     // No operand predicates
     /* 1913106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913110 */     // MIs[0] round
     /* 1913110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913113 */     // MIs[0] policy
     /* 1913113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913125 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1913128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913152 */     // GIR_Coverage, 15890,
     /* 1913152 */     GIR_EraseRootFromParent_Done,
     /* 1913153 */   // Label 25630: @1913153
     /* 1913153 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1913255), // Rule ID 15891 //
     /* 1913158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1913161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1913172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1913175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1913184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913208 */     // MIs[1] Operand 1
     /* 1913208 */     // No operand predicates
     /* 1913208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913212 */     // MIs[0] round
     /* 1913212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913215 */     // MIs[0] policy
     /* 1913215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1913230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913254 */     // GIR_Coverage, 15891,
     /* 1913254 */     GIR_EraseRootFromParent_Done,
     /* 1913255 */   // Label 25631: @1913255
     /* 1913255 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1913357), // Rule ID 15894 //
     /* 1913260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1913263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1913271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1913274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1913277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1913286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913310 */     // MIs[1] Operand 1
     /* 1913310 */     // No operand predicates
     /* 1913310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913314 */     // MIs[0] round
     /* 1913314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913317 */     // MIs[0] policy
     /* 1913317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913329 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1913332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913356 */     // GIR_Coverage, 15894,
     /* 1913356 */     GIR_EraseRootFromParent_Done,
     /* 1913357 */   // Label 25632: @1913357
     /* 1913357 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1913459), // Rule ID 15895 //
     /* 1913362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1913365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1913373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1913376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1913379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1913388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913412 */     // MIs[1] Operand 1
     /* 1913412 */     // No operand predicates
     /* 1913412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913416 */     // MIs[0] round
     /* 1913416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913419 */     // MIs[0] policy
     /* 1913419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913431 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1913434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913458 */     // GIR_Coverage, 15895,
     /* 1913458 */     GIR_EraseRootFromParent_Done,
     /* 1913459 */   // Label 25633: @1913459
     /* 1913459 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1913561), // Rule ID 15898 //
     /* 1913464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1913467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1913475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1913478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1913481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1913487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1913490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913514 */     // MIs[1] Operand 1
     /* 1913514 */     // No operand predicates
     /* 1913514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913518 */     // MIs[0] round
     /* 1913518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913521 */     // MIs[0] policy
     /* 1913521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913533 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1913536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913560 */     // GIR_Coverage, 15898,
     /* 1913560 */     GIR_EraseRootFromParent_Done,
     /* 1913561 */   // Label 25634: @1913561
     /* 1913561 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1913663), // Rule ID 15899 //
     /* 1913566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1913569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1913577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1913580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1913583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1913589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1913592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913616 */     // MIs[1] Operand 1
     /* 1913616 */     // No operand predicates
     /* 1913616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913620 */     // MIs[0] round
     /* 1913620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913623 */     // MIs[0] policy
     /* 1913623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913635 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1913638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913662 */     // GIR_Coverage, 15899,
     /* 1913662 */     GIR_EraseRootFromParent_Done,
     /* 1913663 */   // Label 25635: @1913663
     /* 1913663 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1913765), // Rule ID 15902 //
     /* 1913668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1913671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1913679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1913682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1913685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1913694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913718 */     // MIs[1] Operand 1
     /* 1913718 */     // No operand predicates
     /* 1913718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913722 */     // MIs[0] round
     /* 1913722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913725 */     // MIs[0] policy
     /* 1913725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1913740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913764 */     // GIR_Coverage, 15902,
     /* 1913764 */     GIR_EraseRootFromParent_Done,
     /* 1913765 */   // Label 25636: @1913765
     /* 1913765 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1913867), // Rule ID 15903 //
     /* 1913770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1913773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1913781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1913784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1913787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1913796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913820 */     // MIs[1] Operand 1
     /* 1913820 */     // No operand predicates
     /* 1913820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913824 */     // MIs[0] round
     /* 1913824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913827 */     // MIs[0] policy
     /* 1913827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1913842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913866 */     // GIR_Coverage, 15903,
     /* 1913866 */     GIR_EraseRootFromParent_Done,
     /* 1913867 */   // Label 25637: @1913867
     /* 1913867 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1913969), // Rule ID 15906 //
     /* 1913872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1913875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1913898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1913914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1913918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1913922 */     // MIs[1] Operand 1
     /* 1913922 */     // No operand predicates
     /* 1913922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913926 */     // MIs[0] round
     /* 1913926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1913929 */     // MIs[0] policy
     /* 1913929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1913932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1913944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1913953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1913957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1913967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913968 */     // GIR_Coverage, 15906,
     /* 1913968 */     GIR_EraseRootFromParent_Done,
     /* 1913969 */   // Label 25638: @1913969
     /* 1913969 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1914071), // Rule ID 15907 //
     /* 1913974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1913977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1913982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1914000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914024 */     // MIs[1] Operand 1
     /* 1914024 */     // No operand predicates
     /* 1914024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914028 */     // MIs[0] round
     /* 1914028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914031 */     // MIs[0] policy
     /* 1914031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1914046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914070 */     // GIR_Coverage, 15907,
     /* 1914070 */     GIR_EraseRootFromParent_Done,
     /* 1914071 */   // Label 25639: @1914071
     /* 1914071 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1914173), // Rule ID 15910 //
     /* 1914076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1914102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914126 */     // MIs[1] Operand 1
     /* 1914126 */     // No operand predicates
     /* 1914126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914130 */     // MIs[0] round
     /* 1914130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914133 */     // MIs[0] policy
     /* 1914133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914145 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1914148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914172 */     // GIR_Coverage, 15910,
     /* 1914172 */     GIR_EraseRootFromParent_Done,
     /* 1914173 */   // Label 25640: @1914173
     /* 1914173 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1914275), // Rule ID 15911 //
     /* 1914178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1914204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914228 */     // MIs[1] Operand 1
     /* 1914228 */     // No operand predicates
     /* 1914228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914232 */     // MIs[0] round
     /* 1914232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914235 */     // MIs[0] policy
     /* 1914235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914247 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1914250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914274 */     // GIR_Coverage, 15911,
     /* 1914274 */     GIR_EraseRootFromParent_Done,
     /* 1914275 */   // Label 25641: @1914275
     /* 1914275 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1914377), // Rule ID 15914 //
     /* 1914280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1914283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1914291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1914294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1914297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1914306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914330 */     // MIs[1] Operand 1
     /* 1914330 */     // No operand predicates
     /* 1914330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914334 */     // MIs[0] round
     /* 1914334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914337 */     // MIs[0] policy
     /* 1914337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1914352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914376 */     // GIR_Coverage, 15914,
     /* 1914376 */     GIR_EraseRootFromParent_Done,
     /* 1914377 */   // Label 25642: @1914377
     /* 1914377 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1914479), // Rule ID 15915 //
     /* 1914382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1914385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1914393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1914396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1914399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1914408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914432 */     // MIs[1] Operand 1
     /* 1914432 */     // No operand predicates
     /* 1914432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914436 */     // MIs[0] round
     /* 1914436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914439 */     // MIs[0] policy
     /* 1914439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 1914454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914478 */     // GIR_Coverage, 15915,
     /* 1914478 */     GIR_EraseRootFromParent_Done,
     /* 1914479 */   // Label 25643: @1914479
     /* 1914479 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1914581), // Rule ID 15918 //
     /* 1914484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1914487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1914495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1914498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1914501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1914510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914534 */     // MIs[1] Operand 1
     /* 1914534 */     // No operand predicates
     /* 1914534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914538 */     // MIs[0] round
     /* 1914538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914541 */     // MIs[0] policy
     /* 1914541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914553 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1914556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914580 */     // GIR_Coverage, 15918,
     /* 1914580 */     GIR_EraseRootFromParent_Done,
     /* 1914581 */   // Label 25644: @1914581
     /* 1914581 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1914683), // Rule ID 15919 //
     /* 1914586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1914589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1914597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1914600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1914603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1914612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914636 */     // MIs[1] Operand 1
     /* 1914636 */     // No operand predicates
     /* 1914636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914640 */     // MIs[0] round
     /* 1914640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914643 */     // MIs[0] policy
     /* 1914643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914655 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 1914658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914682 */     // GIR_Coverage, 15919,
     /* 1914682 */     GIR_EraseRootFromParent_Done,
     /* 1914683 */   // Label 25645: @1914683
     /* 1914683 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1914785), // Rule ID 15922 //
     /* 1914688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1914691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1914699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1914702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1914705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1914714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914738 */     // MIs[1] Operand 1
     /* 1914738 */     // No operand predicates
     /* 1914738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914742 */     // MIs[0] round
     /* 1914742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914745 */     // MIs[0] policy
     /* 1914745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914757 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1914760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914784 */     // GIR_Coverage, 15922,
     /* 1914784 */     GIR_EraseRootFromParent_Done,
     /* 1914785 */   // Label 25646: @1914785
     /* 1914785 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1914887), // Rule ID 15923 //
     /* 1914790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1914793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1914798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1914801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1914804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1914807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1914816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914840 */     // MIs[1] Operand 1
     /* 1914840 */     // No operand predicates
     /* 1914840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914844 */     // MIs[0] round
     /* 1914844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914847 */     // MIs[0] policy
     /* 1914847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914859 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 1914862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914886 */     // GIR_Coverage, 15923,
     /* 1914886 */     GIR_EraseRootFromParent_Done,
     /* 1914887 */   // Label 25647: @1914887
     /* 1914887 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1914989), // Rule ID 16102 //
     /* 1914892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1914900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1914903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1914906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1914909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1914918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1914934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1914938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1914942 */     // MIs[1] Operand 1
     /* 1914942 */     // No operand predicates
     /* 1914942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914946 */     // MIs[0] round
     /* 1914946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1914949 */     // MIs[0] policy
     /* 1914949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1914952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1914954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914961 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 1914964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1914973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1914977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1914987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914988 */     // GIR_Coverage, 16102,
     /* 1914988 */     GIR_EraseRootFromParent_Done,
     /* 1914989 */   // Label 25648: @1914989
     /* 1914989 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1915091), // Rule ID 16103 //
     /* 1914994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1915005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1915008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1915011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1915020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915044 */     // MIs[1] Operand 1
     /* 1915044 */     // No operand predicates
     /* 1915044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915048 */     // MIs[0] round
     /* 1915048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915051 */     // MIs[0] policy
     /* 1915051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915063 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 1915066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915090 */     // GIR_Coverage, 16103,
     /* 1915090 */     GIR_EraseRootFromParent_Done,
     /* 1915091 */   // Label 25649: @1915091
     /* 1915091 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1915193), // Rule ID 16106 //
     /* 1915096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1915107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1915110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1915113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1915122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915146 */     // MIs[1] Operand 1
     /* 1915146 */     // No operand predicates
     /* 1915146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915150 */     // MIs[0] round
     /* 1915150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915153 */     // MIs[0] policy
     /* 1915153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915165 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 1915168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915192 */     // GIR_Coverage, 16106,
     /* 1915192 */     GIR_EraseRootFromParent_Done,
     /* 1915193 */   // Label 25650: @1915193
     /* 1915193 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1915295), // Rule ID 16107 //
     /* 1915198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1915209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1915212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1915215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1915224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915248 */     // MIs[1] Operand 1
     /* 1915248 */     // No operand predicates
     /* 1915248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915252 */     // MIs[0] round
     /* 1915252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915255 */     // MIs[0] policy
     /* 1915255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915267 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 1915270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915294 */     // GIR_Coverage, 16107,
     /* 1915294 */     GIR_EraseRootFromParent_Done,
     /* 1915295 */   // Label 25651: @1915295
     /* 1915295 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1915397), // Rule ID 16110 //
     /* 1915300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1915311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1915314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1915317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1915326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915350 */     // MIs[1] Operand 1
     /* 1915350 */     // No operand predicates
     /* 1915350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915354 */     // MIs[0] round
     /* 1915354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915357 */     // MIs[0] policy
     /* 1915357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915369 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1915372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915396 */     // GIR_Coverage, 16110,
     /* 1915396 */     GIR_EraseRootFromParent_Done,
     /* 1915397 */   // Label 25652: @1915397
     /* 1915397 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1915499), // Rule ID 16111 //
     /* 1915402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1915413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1915416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1915419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1915428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915452 */     // MIs[1] Operand 1
     /* 1915452 */     // No operand predicates
     /* 1915452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915456 */     // MIs[0] round
     /* 1915456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915459 */     // MIs[0] policy
     /* 1915459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1915474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915498 */     // GIR_Coverage, 16111,
     /* 1915498 */     GIR_EraseRootFromParent_Done,
     /* 1915499 */   // Label 25653: @1915499
     /* 1915499 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1915601), // Rule ID 16114 //
     /* 1915504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1915530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915554 */     // MIs[1] Operand 1
     /* 1915554 */     // No operand predicates
     /* 1915554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915558 */     // MIs[0] round
     /* 1915558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915561 */     // MIs[0] policy
     /* 1915561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 1915576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915600 */     // GIR_Coverage, 16114,
     /* 1915600 */     GIR_EraseRootFromParent_Done,
     /* 1915601 */   // Label 25654: @1915601
     /* 1915601 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1915703), // Rule ID 16115 //
     /* 1915606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1915632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915656 */     // MIs[1] Operand 1
     /* 1915656 */     // No operand predicates
     /* 1915656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915660 */     // MIs[0] round
     /* 1915660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915663 */     // MIs[0] policy
     /* 1915663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915675 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 1915678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915702 */     // GIR_Coverage, 16115,
     /* 1915702 */     GIR_EraseRootFromParent_Done,
     /* 1915703 */   // Label 25655: @1915703
     /* 1915703 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1915805), // Rule ID 16118 //
     /* 1915708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1915734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915758 */     // MIs[1] Operand 1
     /* 1915758 */     // No operand predicates
     /* 1915758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915762 */     // MIs[0] round
     /* 1915762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915765 */     // MIs[0] policy
     /* 1915765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915777 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1915780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915804 */     // GIR_Coverage, 16118,
     /* 1915804 */     GIR_EraseRootFromParent_Done,
     /* 1915805 */   // Label 25656: @1915805
     /* 1915805 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1915907), // Rule ID 16119 //
     /* 1915810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1915836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915860 */     // MIs[1] Operand 1
     /* 1915860 */     // No operand predicates
     /* 1915860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915864 */     // MIs[0] round
     /* 1915864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915867 */     // MIs[0] policy
     /* 1915867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915879 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1915882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1915905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915906 */     // GIR_Coverage, 16119,
     /* 1915906 */     GIR_EraseRootFromParent_Done,
     /* 1915907 */   // Label 25657: @1915907
     /* 1915907 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1916009), // Rule ID 16122 //
     /* 1915912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1915920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1915923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1915926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1915929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1915938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1915954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1915958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1915962 */     // MIs[1] Operand 1
     /* 1915962 */     // No operand predicates
     /* 1915962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915966 */     // MIs[0] round
     /* 1915966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1915969 */     // MIs[0] policy
     /* 1915969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1915972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1915974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915981 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1915984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1915993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1915997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916008 */     // GIR_Coverage, 16122,
     /* 1916008 */     GIR_EraseRootFromParent_Done,
     /* 1916009 */   // Label 25658: @1916009
     /* 1916009 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1916111), // Rule ID 16123 //
     /* 1916014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1916040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916064 */     // MIs[1] Operand 1
     /* 1916064 */     // No operand predicates
     /* 1916064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916068 */     // MIs[0] round
     /* 1916068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916071 */     // MIs[0] policy
     /* 1916071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 1916086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916110 */     // GIR_Coverage, 16123,
     /* 1916110 */     GIR_EraseRootFromParent_Done,
     /* 1916111 */   // Label 25659: @1916111
     /* 1916111 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1916213), // Rule ID 16126 //
     /* 1916116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1916127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1916130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1916133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1916142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916166 */     // MIs[1] Operand 1
     /* 1916166 */     // No operand predicates
     /* 1916166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916170 */     // MIs[0] round
     /* 1916170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916173 */     // MIs[0] policy
     /* 1916173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916185 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1916209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916212 */     // GIR_Coverage, 16126,
     /* 1916212 */     GIR_EraseRootFromParent_Done,
     /* 1916213 */   // Label 25660: @1916213
     /* 1916213 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1916315), // Rule ID 16127 //
     /* 1916218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1916229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1916232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1916235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1916244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916268 */     // MIs[1] Operand 1
     /* 1916268 */     // No operand predicates
     /* 1916268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916272 */     // MIs[0] round
     /* 1916272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916275 */     // MIs[0] policy
     /* 1916275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916287 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1916311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916314 */     // GIR_Coverage, 16127,
     /* 1916314 */     GIR_EraseRootFromParent_Done,
     /* 1916315 */   // Label 25661: @1916315
     /* 1916315 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1916417), // Rule ID 16130 //
     /* 1916320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1916346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916370 */     // MIs[1] Operand 1
     /* 1916370 */     // No operand predicates
     /* 1916370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916374 */     // MIs[0] round
     /* 1916374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916377 */     // MIs[0] policy
     /* 1916377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916416 */     // GIR_Coverage, 16130,
     /* 1916416 */     GIR_EraseRootFromParent_Done,
     /* 1916417 */   // Label 25662: @1916417
     /* 1916417 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1916519), // Rule ID 16131 //
     /* 1916422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1916448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916472 */     // MIs[1] Operand 1
     /* 1916472 */     // No operand predicates
     /* 1916472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916476 */     // MIs[0] round
     /* 1916476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916479 */     // MIs[0] policy
     /* 1916479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916491 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916518 */     // GIR_Coverage, 16131,
     /* 1916518 */     GIR_EraseRootFromParent_Done,
     /* 1916519 */   // Label 25663: @1916519
     /* 1916519 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1916621), // Rule ID 16134 //
     /* 1916524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1916550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916574 */     // MIs[1] Operand 1
     /* 1916574 */     // No operand predicates
     /* 1916574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916578 */     // MIs[0] round
     /* 1916578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916581 */     // MIs[0] policy
     /* 1916581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916620 */     // GIR_Coverage, 16134,
     /* 1916620 */     GIR_EraseRootFromParent_Done,
     /* 1916621 */   // Label 25664: @1916621
     /* 1916621 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1916723), // Rule ID 16135 //
     /* 1916626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1916652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916676 */     // MIs[1] Operand 1
     /* 1916676 */     // No operand predicates
     /* 1916676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916680 */     // MIs[0] round
     /* 1916680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916683 */     // MIs[0] policy
     /* 1916683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916722 */     // GIR_Coverage, 16135,
     /* 1916722 */     GIR_EraseRootFromParent_Done,
     /* 1916723 */   // Label 25665: @1916723
     /* 1916723 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1916825), // Rule ID 16138 //
     /* 1916728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1916731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1916754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916778 */     // MIs[1] Operand 1
     /* 1916778 */     // No operand predicates
     /* 1916778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916782 */     // MIs[0] round
     /* 1916782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916785 */     // MIs[0] policy
     /* 1916785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916797 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916824 */     // GIR_Coverage, 16138,
     /* 1916824 */     GIR_EraseRootFromParent_Done,
     /* 1916825 */   // Label 25666: @1916825
     /* 1916825 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1916927), // Rule ID 16139 //
     /* 1916830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1916833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1916856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916880 */     // MIs[1] Operand 1
     /* 1916880 */     // No operand predicates
     /* 1916880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916884 */     // MIs[0] round
     /* 1916884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916887 */     // MIs[0] policy
     /* 1916887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 1916902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1916911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1916915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1916925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916926 */     // GIR_Coverage, 16139,
     /* 1916926 */     GIR_EraseRootFromParent_Done,
     /* 1916927 */   // Label 25667: @1916927
     /* 1916927 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1917029), // Rule ID 16142 //
     /* 1916932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1916940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1916943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1916946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1916949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1916958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1916974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1916978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1916982 */     // MIs[1] Operand 1
     /* 1916982 */     // No operand predicates
     /* 1916982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916986 */     // MIs[0] round
     /* 1916986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1916989 */     // MIs[0] policy
     /* 1916989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1916992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1916994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1917004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917028 */     // GIR_Coverage, 16142,
     /* 1917028 */     GIR_EraseRootFromParent_Done,
     /* 1917029 */   // Label 25668: @1917029
     /* 1917029 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1917131), // Rule ID 16143 //
     /* 1917034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1917045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1917048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1917051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1917060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917084 */     // MIs[1] Operand 1
     /* 1917084 */     // No operand predicates
     /* 1917084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917088 */     // MIs[0] round
     /* 1917088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917091 */     // MIs[0] policy
     /* 1917091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917103 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1917106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917130 */     // GIR_Coverage, 16143,
     /* 1917130 */     GIR_EraseRootFromParent_Done,
     /* 1917131 */   // Label 25669: @1917131
     /* 1917131 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1917233), // Rule ID 16146 //
     /* 1917136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1917147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1917150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1917153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1917162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917186 */     // MIs[1] Operand 1
     /* 1917186 */     // No operand predicates
     /* 1917186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917190 */     // MIs[0] round
     /* 1917190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917193 */     // MIs[0] policy
     /* 1917193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917205 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1917208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917232 */     // GIR_Coverage, 16146,
     /* 1917232 */     GIR_EraseRootFromParent_Done,
     /* 1917233 */   // Label 25670: @1917233
     /* 1917233 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1917335), // Rule ID 16147 //
     /* 1917238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1917249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1917252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1917255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1917264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917288 */     // MIs[1] Operand 1
     /* 1917288 */     // No operand predicates
     /* 1917288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917292 */     // MIs[0] round
     /* 1917292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917295 */     // MIs[0] policy
     /* 1917295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917307 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1917310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917334 */     // GIR_Coverage, 16147,
     /* 1917334 */     GIR_EraseRootFromParent_Done,
     /* 1917335 */   // Label 25671: @1917335
     /* 1917335 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1917437), // Rule ID 16150 //
     /* 1917340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1917351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1917354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1917357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1917363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1917366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917390 */     // MIs[1] Operand 1
     /* 1917390 */     // No operand predicates
     /* 1917390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917394 */     // MIs[0] round
     /* 1917394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917397 */     // MIs[0] policy
     /* 1917397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917409 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1917412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917436 */     // GIR_Coverage, 16150,
     /* 1917436 */     GIR_EraseRootFromParent_Done,
     /* 1917437 */   // Label 25672: @1917437
     /* 1917437 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1917539), // Rule ID 16151 //
     /* 1917442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1917453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1917456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1917459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1917465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1917468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917492 */     // MIs[1] Operand 1
     /* 1917492 */     // No operand predicates
     /* 1917492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917496 */     // MIs[0] round
     /* 1917496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917499 */     // MIs[0] policy
     /* 1917499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917511 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1917514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917538 */     // GIR_Coverage, 16151,
     /* 1917538 */     GIR_EraseRootFromParent_Done,
     /* 1917539 */   // Label 25673: @1917539
     /* 1917539 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1917641), // Rule ID 16154 //
     /* 1917544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1917570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917594 */     // MIs[1] Operand 1
     /* 1917594 */     // No operand predicates
     /* 1917594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917598 */     // MIs[0] round
     /* 1917598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917601 */     // MIs[0] policy
     /* 1917601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1917616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917640 */     // GIR_Coverage, 16154,
     /* 1917640 */     GIR_EraseRootFromParent_Done,
     /* 1917641 */   // Label 25674: @1917641
     /* 1917641 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1917743), // Rule ID 16155 //
     /* 1917646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1917672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917696 */     // MIs[1] Operand 1
     /* 1917696 */     // No operand predicates
     /* 1917696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917700 */     // MIs[0] round
     /* 1917700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917703 */     // MIs[0] policy
     /* 1917703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1917718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917742 */     // GIR_Coverage, 16155,
     /* 1917742 */     GIR_EraseRootFromParent_Done,
     /* 1917743 */   // Label 25675: @1917743
     /* 1917743 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1917845), // Rule ID 16158 //
     /* 1917748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1917774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917798 */     // MIs[1] Operand 1
     /* 1917798 */     // No operand predicates
     /* 1917798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917802 */     // MIs[0] round
     /* 1917802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917805 */     // MIs[0] policy
     /* 1917805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917817 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1917820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917844 */     // GIR_Coverage, 16158,
     /* 1917844 */     GIR_EraseRootFromParent_Done,
     /* 1917845 */   // Label 25676: @1917845
     /* 1917845 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1917947), // Rule ID 16159 //
     /* 1917850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1917876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1917900 */     // MIs[1] Operand 1
     /* 1917900 */     // No operand predicates
     /* 1917900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917904 */     // MIs[0] round
     /* 1917904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1917907 */     // MIs[0] policy
     /* 1917907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1917910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1917912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1917922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1917931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1917935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1917945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917946 */     // GIR_Coverage, 16159,
     /* 1917946 */     GIR_EraseRootFromParent_Done,
     /* 1917947 */   // Label 25677: @1917947
     /* 1917947 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1918049), // Rule ID 16162 //
     /* 1917952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1917960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1917978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1917994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918002 */     // MIs[1] Operand 1
     /* 1918002 */     // No operand predicates
     /* 1918002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918006 */     // MIs[0] round
     /* 1918006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918009 */     // MIs[0] policy
     /* 1918009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1918024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918048 */     // GIR_Coverage, 16162,
     /* 1918048 */     GIR_EraseRootFromParent_Done,
     /* 1918049 */   // Label 25678: @1918049
     /* 1918049 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1918151), // Rule ID 16163 //
     /* 1918054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1918065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1918068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1918071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1918077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1918080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918104 */     // MIs[1] Operand 1
     /* 1918104 */     // No operand predicates
     /* 1918104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918108 */     // MIs[0] round
     /* 1918108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918111 */     // MIs[0] policy
     /* 1918111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918123 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1918126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918150 */     // GIR_Coverage, 16163,
     /* 1918150 */     GIR_EraseRootFromParent_Done,
     /* 1918151 */   // Label 25679: @1918151
     /* 1918151 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1918253), // Rule ID 16166 //
     /* 1918156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1918167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1918170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1918173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1918182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918206 */     // MIs[1] Operand 1
     /* 1918206 */     // No operand predicates
     /* 1918206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918210 */     // MIs[0] round
     /* 1918210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918213 */     // MIs[0] policy
     /* 1918213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1918228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918252 */     // GIR_Coverage, 16166,
     /* 1918252 */     GIR_EraseRootFromParent_Done,
     /* 1918253 */   // Label 25680: @1918253
     /* 1918253 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1918355), // Rule ID 16167 //
     /* 1918258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1918269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1918272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1918275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1918284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918308 */     // MIs[1] Operand 1
     /* 1918308 */     // No operand predicates
     /* 1918308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918312 */     // MIs[0] round
     /* 1918312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918315 */     // MIs[0] policy
     /* 1918315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1918330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918354 */     // GIR_Coverage, 16167,
     /* 1918354 */     GIR_EraseRootFromParent_Done,
     /* 1918355 */   // Label 25681: @1918355
     /* 1918355 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1918457), // Rule ID 16170 //
     /* 1918360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1918371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1918374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1918377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1918386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918410 */     // MIs[1] Operand 1
     /* 1918410 */     // No operand predicates
     /* 1918410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918414 */     // MIs[0] round
     /* 1918414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918417 */     // MIs[0] policy
     /* 1918417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918429 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1918432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918456 */     // GIR_Coverage, 16170,
     /* 1918456 */     GIR_EraseRootFromParent_Done,
     /* 1918457 */   // Label 25682: @1918457
     /* 1918457 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1918559), // Rule ID 16171 //
     /* 1918462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1918473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1918476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1918479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1918488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918512 */     // MIs[1] Operand 1
     /* 1918512 */     // No operand predicates
     /* 1918512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918516 */     // MIs[0] round
     /* 1918516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918519 */     // MIs[0] policy
     /* 1918519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918531 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1918534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918558 */     // GIR_Coverage, 16171,
     /* 1918558 */     GIR_EraseRootFromParent_Done,
     /* 1918559 */   // Label 25683: @1918559
     /* 1918559 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1918661), // Rule ID 16174 //
     /* 1918564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1918575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1918578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1918581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1918587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1918590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918614 */     // MIs[1] Operand 1
     /* 1918614 */     // No operand predicates
     /* 1918614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918618 */     // MIs[0] round
     /* 1918618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918621 */     // MIs[0] policy
     /* 1918621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918633 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1918636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918660 */     // GIR_Coverage, 16174,
     /* 1918660 */     GIR_EraseRootFromParent_Done,
     /* 1918661 */   // Label 25684: @1918661
     /* 1918661 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1918763), // Rule ID 16175 //
     /* 1918666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1918677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1918680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1918683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1918689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1918692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918716 */     // MIs[1] Operand 1
     /* 1918716 */     // No operand predicates
     /* 1918716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918720 */     // MIs[0] round
     /* 1918720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918723 */     // MIs[0] policy
     /* 1918723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1918738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918762 */     // GIR_Coverage, 16175,
     /* 1918762 */     GIR_EraseRootFromParent_Done,
     /* 1918763 */   // Label 25685: @1918763
     /* 1918763 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1918865), // Rule ID 16178 //
     /* 1918768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1918771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1918794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918818 */     // MIs[1] Operand 1
     /* 1918818 */     // No operand predicates
     /* 1918818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918822 */     // MIs[0] round
     /* 1918822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918825 */     // MIs[0] policy
     /* 1918825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1918840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918864 */     // GIR_Coverage, 16178,
     /* 1918864 */     GIR_EraseRootFromParent_Done,
     /* 1918865 */   // Label 25686: @1918865
     /* 1918865 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1918967), // Rule ID 16179 //
     /* 1918870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1918873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1918896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1918912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1918916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1918920 */     // MIs[1] Operand 1
     /* 1918920 */     // No operand predicates
     /* 1918920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918924 */     // MIs[0] round
     /* 1918924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1918927 */     // MIs[0] policy
     /* 1918927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1918930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1918932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 1918942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1918951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1918955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1918965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918966 */     // GIR_Coverage, 16179,
     /* 1918966 */     GIR_EraseRootFromParent_Done,
     /* 1918967 */   // Label 25687: @1918967
     /* 1918967 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1919069), // Rule ID 16182 //
     /* 1918972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1918975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1918980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1918998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919022 */     // MIs[1] Operand 1
     /* 1919022 */     // No operand predicates
     /* 1919022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919026 */     // MIs[0] round
     /* 1919026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919029 */     // MIs[0] policy
     /* 1919029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919041 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1919044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919068 */     // GIR_Coverage, 16182,
     /* 1919068 */     GIR_EraseRootFromParent_Done,
     /* 1919069 */   // Label 25688: @1919069
     /* 1919069 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1919171), // Rule ID 16183 //
     /* 1919074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1919077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1919082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1919085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1919088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1919091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1919100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919124 */     // MIs[1] Operand 1
     /* 1919124 */     // No operand predicates
     /* 1919124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919128 */     // MIs[0] round
     /* 1919128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919131 */     // MIs[0] policy
     /* 1919131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 1919146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919170 */     // GIR_Coverage, 16183,
     /* 1919170 */     GIR_EraseRootFromParent_Done,
     /* 1919171 */   // Label 25689: @1919171
     /* 1919171 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1919273), // Rule ID 16186 //
     /* 1919176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1919179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1919184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1919187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1919190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1919193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1919202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919226 */     // MIs[1] Operand 1
     /* 1919226 */     // No operand predicates
     /* 1919226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919230 */     // MIs[0] round
     /* 1919230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919233 */     // MIs[0] policy
     /* 1919233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919245 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1919248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919272 */     // GIR_Coverage, 16186,
     /* 1919272 */     GIR_EraseRootFromParent_Done,
     /* 1919273 */   // Label 25690: @1919273
     /* 1919273 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1919375), // Rule ID 16187 //
     /* 1919278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1919281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1919286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1919289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1919292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1919295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1919304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919328 */     // MIs[1] Operand 1
     /* 1919328 */     // No operand predicates
     /* 1919328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919332 */     // MIs[0] round
     /* 1919332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919335 */     // MIs[0] policy
     /* 1919335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 1919350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919374 */     // GIR_Coverage, 16187,
     /* 1919374 */     GIR_EraseRootFromParent_Done,
     /* 1919375 */   // Label 25691: @1919375
     /* 1919375 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1919480), // Rule ID 16310 //
     /* 1919380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1919391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1919394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1919397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1919406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919430 */     // MIs[1] Operand 1
     /* 1919430 */     // No operand predicates
     /* 1919430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919434 */     // MIs[0] round
     /* 1919434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919437 */     // MIs[0] policy
     /* 1919437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919449 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 1919452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1919478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919479 */     // GIR_Coverage, 16310,
     /* 1919479 */     GIR_EraseRootFromParent_Done,
     /* 1919480 */   // Label 25692: @1919480
     /* 1919480 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1919585), // Rule ID 16311 //
     /* 1919485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1919496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1919499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1919502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1919511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919535 */     // MIs[1] Operand 1
     /* 1919535 */     // No operand predicates
     /* 1919535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919539 */     // MIs[0] round
     /* 1919539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919542 */     // MIs[0] policy
     /* 1919542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919554 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 1919557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1919583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919584 */     // GIR_Coverage, 16311,
     /* 1919584 */     GIR_EraseRootFromParent_Done,
     /* 1919585 */   // Label 25693: @1919585
     /* 1919585 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1919690), // Rule ID 16314 //
     /* 1919590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1919601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1919604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1919616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919640 */     // MIs[1] Operand 1
     /* 1919640 */     // No operand predicates
     /* 1919640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919644 */     // MIs[0] round
     /* 1919644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919647 */     // MIs[0] policy
     /* 1919647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919659 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 1919662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1919688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919689 */     // GIR_Coverage, 16314,
     /* 1919689 */     GIR_EraseRootFromParent_Done,
     /* 1919690 */   // Label 25694: @1919690
     /* 1919690 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1919795), // Rule ID 16315 //
     /* 1919695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1919706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1919709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1919721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919745 */     // MIs[1] Operand 1
     /* 1919745 */     // No operand predicates
     /* 1919745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919749 */     // MIs[0] round
     /* 1919749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919752 */     // MIs[0] policy
     /* 1919752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 1919767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1919793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919794 */     // GIR_Coverage, 16315,
     /* 1919794 */     GIR_EraseRootFromParent_Done,
     /* 1919795 */   // Label 25695: @1919795
     /* 1919795 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1919900), // Rule ID 16318 //
     /* 1919800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1919811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1919814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1919826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919850 */     // MIs[1] Operand 1
     /* 1919850 */     // No operand predicates
     /* 1919850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919854 */     // MIs[0] round
     /* 1919854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919857 */     // MIs[0] policy
     /* 1919857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919869 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1919872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1919895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1919898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919899 */     // GIR_Coverage, 16318,
     /* 1919899 */     GIR_EraseRootFromParent_Done,
     /* 1919900 */   // Label 25696: @1919900
     /* 1919900 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1920005), // Rule ID 16319 //
     /* 1919905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1919913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1919916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1919919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1919931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1919947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1919951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1919955 */     // MIs[1] Operand 1
     /* 1919955 */     // No operand predicates
     /* 1919955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919959 */     // MIs[0] round
     /* 1919959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1919962 */     // MIs[0] policy
     /* 1919962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1919965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1919967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919974 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1919977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1919986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1919990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920004 */     // GIR_Coverage, 16319,
     /* 1920004 */     GIR_EraseRootFromParent_Done,
     /* 1920005 */   // Label 25697: @1920005
     /* 1920005 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1920110), // Rule ID 16322 //
     /* 1920010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1920021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1920024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1920036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920060 */     // MIs[1] Operand 1
     /* 1920060 */     // No operand predicates
     /* 1920060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920064 */     // MIs[0] round
     /* 1920064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920067 */     // MIs[0] policy
     /* 1920067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920079 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1920082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920109 */     // GIR_Coverage, 16322,
     /* 1920109 */     GIR_EraseRootFromParent_Done,
     /* 1920110 */   // Label 25698: @1920110
     /* 1920110 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1920215), // Rule ID 16323 //
     /* 1920115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1920126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1920129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1920141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920165 */     // MIs[1] Operand 1
     /* 1920165 */     // No operand predicates
     /* 1920165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920169 */     // MIs[0] round
     /* 1920169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920172 */     // MIs[0] policy
     /* 1920172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920184 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1920187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920214 */     // GIR_Coverage, 16323,
     /* 1920214 */     GIR_EraseRootFromParent_Done,
     /* 1920215 */   // Label 25699: @1920215
     /* 1920215 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1920320), // Rule ID 16326 //
     /* 1920220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1920231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1920234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1920246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920270 */     // MIs[1] Operand 1
     /* 1920270 */     // No operand predicates
     /* 1920270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920274 */     // MIs[0] round
     /* 1920274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920277 */     // MIs[0] policy
     /* 1920277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1920292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920319 */     // GIR_Coverage, 16326,
     /* 1920319 */     GIR_EraseRootFromParent_Done,
     /* 1920320 */   // Label 25700: @1920320
     /* 1920320 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1920425), // Rule ID 16327 //
     /* 1920325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1920336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1920339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1920351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920375 */     // MIs[1] Operand 1
     /* 1920375 */     // No operand predicates
     /* 1920375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920379 */     // MIs[0] round
     /* 1920379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920382 */     // MIs[0] policy
     /* 1920382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1920397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920424 */     // GIR_Coverage, 16327,
     /* 1920424 */     GIR_EraseRootFromParent_Done,
     /* 1920425 */   // Label 25701: @1920425
     /* 1920425 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1920530), // Rule ID 16330 //
     /* 1920430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1920441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1920444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1920456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920480 */     // MIs[1] Operand 1
     /* 1920480 */     // No operand predicates
     /* 1920480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920484 */     // MIs[0] round
     /* 1920484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920487 */     // MIs[0] policy
     /* 1920487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920499 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1920502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920529 */     // GIR_Coverage, 16330,
     /* 1920529 */     GIR_EraseRootFromParent_Done,
     /* 1920530 */   // Label 25702: @1920530
     /* 1920530 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1920635), // Rule ID 16331 //
     /* 1920535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1920546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1920549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1920561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920585 */     // MIs[1] Operand 1
     /* 1920585 */     // No operand predicates
     /* 1920585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920589 */     // MIs[0] round
     /* 1920589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920592 */     // MIs[0] policy
     /* 1920592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920604 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1920607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920634 */     // GIR_Coverage, 16331,
     /* 1920634 */     GIR_EraseRootFromParent_Done,
     /* 1920635 */   // Label 25703: @1920635
     /* 1920635 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1920740), // Rule ID 16334 //
     /* 1920640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1920651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1920654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1920657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1920666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920690 */     // MIs[1] Operand 1
     /* 1920690 */     // No operand predicates
     /* 1920690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920694 */     // MIs[0] round
     /* 1920694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920697 */     // MIs[0] policy
     /* 1920697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 1920712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920739 */     // GIR_Coverage, 16334,
     /* 1920739 */     GIR_EraseRootFromParent_Done,
     /* 1920740 */   // Label 25704: @1920740
     /* 1920740 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1920845), // Rule ID 16335 //
     /* 1920745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1920756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1920759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1920762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1920771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920795 */     // MIs[1] Operand 1
     /* 1920795 */     // No operand predicates
     /* 1920795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920799 */     // MIs[0] round
     /* 1920799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920802 */     // MIs[0] policy
     /* 1920802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 1920817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920844 */     // GIR_Coverage, 16335,
     /* 1920844 */     GIR_EraseRootFromParent_Done,
     /* 1920845 */   // Label 25705: @1920845
     /* 1920845 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1920950), // Rule ID 16338 //
     /* 1920850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1920861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1920864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1920867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1920876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1920896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1920900 */     // MIs[1] Operand 1
     /* 1920900 */     // No operand predicates
     /* 1920900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920904 */     // MIs[0] round
     /* 1920904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1920907 */     // MIs[0] policy
     /* 1920907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1920910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1920912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1920922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1920931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1920935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1920945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1920948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920949 */     // GIR_Coverage, 16338,
     /* 1920949 */     GIR_EraseRootFromParent_Done,
     /* 1920950 */   // Label 25706: @1920950
     /* 1920950 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1921055), // Rule ID 16339 //
     /* 1920955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1920963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1920966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1920969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1920972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1920981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1920997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921005 */     // MIs[1] Operand 1
     /* 1921005 */     // No operand predicates
     /* 1921005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921009 */     // MIs[0] round
     /* 1921009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921012 */     // MIs[0] policy
     /* 1921012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921024 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1921027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921054 */     // GIR_Coverage, 16339,
     /* 1921054 */     GIR_EraseRootFromParent_Done,
     /* 1921055 */   // Label 25707: @1921055
     /* 1921055 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1921160), // Rule ID 16342 //
     /* 1921060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1921077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1921086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921110 */     // MIs[1] Operand 1
     /* 1921110 */     // No operand predicates
     /* 1921110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921114 */     // MIs[0] round
     /* 1921114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921117 */     // MIs[0] policy
     /* 1921117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921129 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1921132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921159 */     // GIR_Coverage, 16342,
     /* 1921159 */     GIR_EraseRootFromParent_Done,
     /* 1921160 */   // Label 25708: @1921160
     /* 1921160 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1921265), // Rule ID 16343 //
     /* 1921165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1921182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1921191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921215 */     // MIs[1] Operand 1
     /* 1921215 */     // No operand predicates
     /* 1921215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921219 */     // MIs[0] round
     /* 1921219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921222 */     // MIs[0] policy
     /* 1921222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1921237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921264 */     // GIR_Coverage, 16343,
     /* 1921264 */     GIR_EraseRootFromParent_Done,
     /* 1921265 */   // Label 25709: @1921265
     /* 1921265 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1921370), // Rule ID 16346 //
     /* 1921270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1921281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1921284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1921296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921320 */     // MIs[1] Operand 1
     /* 1921320 */     // No operand predicates
     /* 1921320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921324 */     // MIs[0] round
     /* 1921324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921327 */     // MIs[0] policy
     /* 1921327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1921342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921369 */     // GIR_Coverage, 16346,
     /* 1921369 */     GIR_EraseRootFromParent_Done,
     /* 1921370 */   // Label 25710: @1921370
     /* 1921370 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1921475), // Rule ID 16347 //
     /* 1921375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1921386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1921389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1921401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921425 */     // MIs[1] Operand 1
     /* 1921425 */     // No operand predicates
     /* 1921425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921429 */     // MIs[0] round
     /* 1921429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921432 */     // MIs[0] policy
     /* 1921432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1921447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921474 */     // GIR_Coverage, 16347,
     /* 1921474 */     GIR_EraseRootFromParent_Done,
     /* 1921475 */   // Label 25711: @1921475
     /* 1921475 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1921580), // Rule ID 16350 //
     /* 1921480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1921491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1921494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1921506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921530 */     // MIs[1] Operand 1
     /* 1921530 */     // No operand predicates
     /* 1921530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921534 */     // MIs[0] round
     /* 1921534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921537 */     // MIs[0] policy
     /* 1921537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921549 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1921552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921579 */     // GIR_Coverage, 16350,
     /* 1921579 */     GIR_EraseRootFromParent_Done,
     /* 1921580 */   // Label 25712: @1921580
     /* 1921580 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1921685), // Rule ID 16351 //
     /* 1921585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1921596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1921599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1921611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921635 */     // MIs[1] Operand 1
     /* 1921635 */     // No operand predicates
     /* 1921635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921639 */     // MIs[0] round
     /* 1921639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921642 */     // MIs[0] policy
     /* 1921642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1921657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921684 */     // GIR_Coverage, 16351,
     /* 1921684 */     GIR_EraseRootFromParent_Done,
     /* 1921685 */   // Label 25713: @1921685
     /* 1921685 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1921790), // Rule ID 16354 //
     /* 1921690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1921693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1921707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1921716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921740 */     // MIs[1] Operand 1
     /* 1921740 */     // No operand predicates
     /* 1921740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921744 */     // MIs[0] round
     /* 1921744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921747 */     // MIs[0] policy
     /* 1921747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921759 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1921762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921789 */     // GIR_Coverage, 16354,
     /* 1921789 */     GIR_EraseRootFromParent_Done,
     /* 1921790 */   // Label 25714: @1921790
     /* 1921790 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1921895), // Rule ID 16355 //
     /* 1921795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1921798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1921812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1921821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921845 */     // MIs[1] Operand 1
     /* 1921845 */     // No operand predicates
     /* 1921845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921849 */     // MIs[0] round
     /* 1921849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921852 */     // MIs[0] policy
     /* 1921852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921864 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 1921867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921894 */     // GIR_Coverage, 16355,
     /* 1921894 */     GIR_EraseRootFromParent_Done,
     /* 1921895 */   // Label 25715: @1921895
     /* 1921895 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1922000), // Rule ID 16358 //
     /* 1921900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1921903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1921908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1921911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1921914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1921926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1921942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1921946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1921950 */     // MIs[1] Operand 1
     /* 1921950 */     // No operand predicates
     /* 1921950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921954 */     // MIs[0] round
     /* 1921954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1921957 */     // MIs[0] policy
     /* 1921957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1921960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1921962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921969 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1921972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1921981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1921985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1921995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1921998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921999 */     // GIR_Coverage, 16358,
     /* 1921999 */     GIR_EraseRootFromParent_Done,
     /* 1922000 */   // Label 25716: @1922000
     /* 1922000 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1922105), // Rule ID 16359 //
     /* 1922005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1922008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1922013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1922022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1922031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922055 */     // MIs[1] Operand 1
     /* 1922055 */     // No operand predicates
     /* 1922055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922059 */     // MIs[0] round
     /* 1922059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922062 */     // MIs[0] policy
     /* 1922062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 1922077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922104 */     // GIR_Coverage, 16359,
     /* 1922104 */     GIR_EraseRootFromParent_Done,
     /* 1922105 */   // Label 25717: @1922105
     /* 1922105 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1922210), // Rule ID 16362 //
     /* 1922110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1922113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1922118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1922121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1922124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1922127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1922136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922160 */     // MIs[1] Operand 1
     /* 1922160 */     // No operand predicates
     /* 1922160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922164 */     // MIs[0] round
     /* 1922164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922167 */     // MIs[0] policy
     /* 1922167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1922182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922209 */     // GIR_Coverage, 16362,
     /* 1922209 */     GIR_EraseRootFromParent_Done,
     /* 1922210 */   // Label 25718: @1922210
     /* 1922210 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1922315), // Rule ID 16363 //
     /* 1922215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1922218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1922223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1922226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1922229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1922232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1922241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922265 */     // MIs[1] Operand 1
     /* 1922265 */     // No operand predicates
     /* 1922265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922269 */     // MIs[0] round
     /* 1922269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922272 */     // MIs[0] policy
     /* 1922272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 1922287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922314 */     // GIR_Coverage, 16363,
     /* 1922314 */     GIR_EraseRootFromParent_Done,
     /* 1922315 */   // Label 25719: @1922315
     /* 1922315 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1922420), // Rule ID 16366 //
     /* 1922320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1922323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1922328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1922331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1922334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1922337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1922346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922370 */     // MIs[1] Operand 1
     /* 1922370 */     // No operand predicates
     /* 1922370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922374 */     // MIs[0] round
     /* 1922374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922377 */     // MIs[0] policy
     /* 1922377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1922392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922419 */     // GIR_Coverage, 16366,
     /* 1922419 */     GIR_EraseRootFromParent_Done,
     /* 1922420 */   // Label 25720: @1922420
     /* 1922420 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1922525), // Rule ID 16367 //
     /* 1922425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1922428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1922433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1922436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1922439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1922442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1922451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922475 */     // MIs[1] Operand 1
     /* 1922475 */     // No operand predicates
     /* 1922475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922479 */     // MIs[0] round
     /* 1922479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922482 */     // MIs[0] policy
     /* 1922482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 1922497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922524 */     // GIR_Coverage, 16367,
     /* 1922524 */     GIR_EraseRootFromParent_Done,
     /* 1922525 */   // Label 25721: @1922525
     /* 1922525 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1922630), // Rule ID 16490 //
     /* 1922530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1922538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1922541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1922544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1922556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922580 */     // MIs[1] Operand 1
     /* 1922580 */     // No operand predicates
     /* 1922580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922584 */     // MIs[0] round
     /* 1922584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922587 */     // MIs[0] policy
     /* 1922587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922599 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 1922602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922629 */     // GIR_Coverage, 16490,
     /* 1922629 */     GIR_EraseRootFromParent_Done,
     /* 1922630 */   // Label 25722: @1922630
     /* 1922630 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1922735), // Rule ID 16491 //
     /* 1922635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1922643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1922646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1922649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1922661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922685 */     // MIs[1] Operand 1
     /* 1922685 */     // No operand predicates
     /* 1922685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922689 */     // MIs[0] round
     /* 1922689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922692 */     // MIs[0] policy
     /* 1922692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 1922707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922734 */     // GIR_Coverage, 16491,
     /* 1922734 */     GIR_EraseRootFromParent_Done,
     /* 1922735 */   // Label 25723: @1922735
     /* 1922735 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1922840), // Rule ID 16494 //
     /* 1922740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1922748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1922751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1922754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1922766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922790 */     // MIs[1] Operand 1
     /* 1922790 */     // No operand predicates
     /* 1922790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922794 */     // MIs[0] round
     /* 1922794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922797 */     // MIs[0] policy
     /* 1922797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922809 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 1922812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922839 */     // GIR_Coverage, 16494,
     /* 1922839 */     GIR_EraseRootFromParent_Done,
     /* 1922840 */   // Label 25724: @1922840
     /* 1922840 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1922945), // Rule ID 16495 //
     /* 1922845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1922853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1922856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1922859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1922871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1922895 */     // MIs[1] Operand 1
     /* 1922895 */     // No operand predicates
     /* 1922895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922899 */     // MIs[0] round
     /* 1922899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1922902 */     // MIs[0] policy
     /* 1922902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1922905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1922907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 1922917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1922926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1922930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1922940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1922943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922944 */     // GIR_Coverage, 16495,
     /* 1922944 */     GIR_EraseRootFromParent_Done,
     /* 1922945 */   // Label 25725: @1922945
     /* 1922945 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1923050), // Rule ID 16498 //
     /* 1922950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1922958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1922961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1922964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1922976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1922992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923000 */     // MIs[1] Operand 1
     /* 1923000 */     // No operand predicates
     /* 1923000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923004 */     // MIs[0] round
     /* 1923004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923007 */     // MIs[0] policy
     /* 1923007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1923022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923049 */     // GIR_Coverage, 16498,
     /* 1923049 */     GIR_EraseRootFromParent_Done,
     /* 1923050 */   // Label 25726: @1923050
     /* 1923050 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1923155), // Rule ID 16499 //
     /* 1923055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1923066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1923069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1923072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1923081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923105 */     // MIs[1] Operand 1
     /* 1923105 */     // No operand predicates
     /* 1923105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923109 */     // MIs[0] round
     /* 1923109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923112 */     // MIs[0] policy
     /* 1923112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1923127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923154 */     // GIR_Coverage, 16499,
     /* 1923154 */     GIR_EraseRootFromParent_Done,
     /* 1923155 */   // Label 25727: @1923155
     /* 1923155 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1923260), // Rule ID 16502 //
     /* 1923160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1923171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1923174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1923186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923210 */     // MIs[1] Operand 1
     /* 1923210 */     // No operand predicates
     /* 1923210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923214 */     // MIs[0] round
     /* 1923214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923217 */     // MIs[0] policy
     /* 1923217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923229 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1923232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923259 */     // GIR_Coverage, 16502,
     /* 1923259 */     GIR_EraseRootFromParent_Done,
     /* 1923260 */   // Label 25728: @1923260
     /* 1923260 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1923365), // Rule ID 16503 //
     /* 1923265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1923276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1923279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1923291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923315 */     // MIs[1] Operand 1
     /* 1923315 */     // No operand predicates
     /* 1923315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923319 */     // MIs[0] round
     /* 1923319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923322 */     // MIs[0] policy
     /* 1923322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1923337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923364 */     // GIR_Coverage, 16503,
     /* 1923364 */     GIR_EraseRootFromParent_Done,
     /* 1923365 */   // Label 25729: @1923365
     /* 1923365 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1923470), // Rule ID 16506 //
     /* 1923370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1923396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923420 */     // MIs[1] Operand 1
     /* 1923420 */     // No operand predicates
     /* 1923420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923424 */     // MIs[0] round
     /* 1923424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923427 */     // MIs[0] policy
     /* 1923427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1923442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923469 */     // GIR_Coverage, 16506,
     /* 1923469 */     GIR_EraseRootFromParent_Done,
     /* 1923470 */   // Label 25730: @1923470
     /* 1923470 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1923575), // Rule ID 16507 //
     /* 1923475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1923501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923525 */     // MIs[1] Operand 1
     /* 1923525 */     // No operand predicates
     /* 1923525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923529 */     // MIs[0] round
     /* 1923529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923532 */     // MIs[0] policy
     /* 1923532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1923547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923574 */     // GIR_Coverage, 16507,
     /* 1923574 */     GIR_EraseRootFromParent_Done,
     /* 1923575 */   // Label 25731: @1923575
     /* 1923575 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1923680), // Rule ID 16510 //
     /* 1923580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1923606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923630 */     // MIs[1] Operand 1
     /* 1923630 */     // No operand predicates
     /* 1923630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923634 */     // MIs[0] round
     /* 1923634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923637 */     // MIs[0] policy
     /* 1923637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923649 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1923652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923679 */     // GIR_Coverage, 16510,
     /* 1923679 */     GIR_EraseRootFromParent_Done,
     /* 1923680 */   // Label 25732: @1923680
     /* 1923680 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1923785), // Rule ID 16511 //
     /* 1923685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1923711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923735 */     // MIs[1] Operand 1
     /* 1923735 */     // No operand predicates
     /* 1923735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923739 */     // MIs[0] round
     /* 1923739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923742 */     // MIs[0] policy
     /* 1923742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923754 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1923757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923784 */     // GIR_Coverage, 16511,
     /* 1923784 */     GIR_EraseRootFromParent_Done,
     /* 1923785 */   // Label 25733: @1923785
     /* 1923785 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1923890), // Rule ID 16514 //
     /* 1923790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1923801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1923804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1923807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1923816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923840 */     // MIs[1] Operand 1
     /* 1923840 */     // No operand predicates
     /* 1923840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923844 */     // MIs[0] round
     /* 1923844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923847 */     // MIs[0] policy
     /* 1923847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923859 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 1923862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923889 */     // GIR_Coverage, 16514,
     /* 1923889 */     GIR_EraseRootFromParent_Done,
     /* 1923890 */   // Label 25734: @1923890
     /* 1923890 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1923995), // Rule ID 16515 //
     /* 1923895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1923903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1923906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1923909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1923912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1923921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1923937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1923941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1923945 */     // MIs[1] Operand 1
     /* 1923945 */     // No operand predicates
     /* 1923945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923949 */     // MIs[0] round
     /* 1923949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1923952 */     // MIs[0] policy
     /* 1923952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1923955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1923957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 1923967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1923976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1923980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1923990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1923993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923994 */     // GIR_Coverage, 16515,
     /* 1923994 */     GIR_EraseRootFromParent_Done,
     /* 1923995 */   // Label 25735: @1923995
     /* 1923995 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1924100), // Rule ID 16518 //
     /* 1924000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1924011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1924014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1924017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1924026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924050 */     // MIs[1] Operand 1
     /* 1924050 */     // No operand predicates
     /* 1924050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924054 */     // MIs[0] round
     /* 1924054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924057 */     // MIs[0] policy
     /* 1924057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924069 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1924072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924099 */     // GIR_Coverage, 16518,
     /* 1924099 */     GIR_EraseRootFromParent_Done,
     /* 1924100 */   // Label 25736: @1924100
     /* 1924100 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1924205), // Rule ID 16519 //
     /* 1924105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1924116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1924119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1924122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1924131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924155 */     // MIs[1] Operand 1
     /* 1924155 */     // No operand predicates
     /* 1924155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924159 */     // MIs[0] round
     /* 1924159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924162 */     // MIs[0] policy
     /* 1924162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1924177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924204 */     // GIR_Coverage, 16519,
     /* 1924204 */     GIR_EraseRootFromParent_Done,
     /* 1924205 */   // Label 25737: @1924205
     /* 1924205 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1924310), // Rule ID 16522 //
     /* 1924210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1924221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1924224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1924227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1924236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924260 */     // MIs[1] Operand 1
     /* 1924260 */     // No operand predicates
     /* 1924260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924264 */     // MIs[0] round
     /* 1924264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924267 */     // MIs[0] policy
     /* 1924267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924279 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1924282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924309 */     // GIR_Coverage, 16522,
     /* 1924309 */     GIR_EraseRootFromParent_Done,
     /* 1924310 */   // Label 25738: @1924310
     /* 1924310 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1924415), // Rule ID 16523 //
     /* 1924315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1924326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1924329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1924332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1924341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924365 */     // MIs[1] Operand 1
     /* 1924365 */     // No operand predicates
     /* 1924365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924369 */     // MIs[0] round
     /* 1924369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924372 */     // MIs[0] policy
     /* 1924372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1924387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924414 */     // GIR_Coverage, 16523,
     /* 1924414 */     GIR_EraseRootFromParent_Done,
     /* 1924415 */   // Label 25739: @1924415
     /* 1924415 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1924520), // Rule ID 16526 //
     /* 1924420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1924431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1924434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1924446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924470 */     // MIs[1] Operand 1
     /* 1924470 */     // No operand predicates
     /* 1924470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924474 */     // MIs[0] round
     /* 1924474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924477 */     // MIs[0] policy
     /* 1924477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1924492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924519 */     // GIR_Coverage, 16526,
     /* 1924519 */     GIR_EraseRootFromParent_Done,
     /* 1924520 */   // Label 25740: @1924520
     /* 1924520 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1924625), // Rule ID 16527 //
     /* 1924525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1924536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1924539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1924551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924575 */     // MIs[1] Operand 1
     /* 1924575 */     // No operand predicates
     /* 1924575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924579 */     // MIs[0] round
     /* 1924579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924582 */     // MIs[0] policy
     /* 1924582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1924597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924624 */     // GIR_Coverage, 16527,
     /* 1924624 */     GIR_EraseRootFromParent_Done,
     /* 1924625 */   // Label 25741: @1924625
     /* 1924625 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1924730), // Rule ID 16530 //
     /* 1924630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1924641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1924656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924680 */     // MIs[1] Operand 1
     /* 1924680 */     // No operand predicates
     /* 1924680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924684 */     // MIs[0] round
     /* 1924684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924687 */     // MIs[0] policy
     /* 1924687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1924702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924729 */     // GIR_Coverage, 16530,
     /* 1924729 */     GIR_EraseRootFromParent_Done,
     /* 1924730 */   // Label 25742: @1924730
     /* 1924730 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1924835), // Rule ID 16531 //
     /* 1924735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1924746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1924761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924785 */     // MIs[1] Operand 1
     /* 1924785 */     // No operand predicates
     /* 1924785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924789 */     // MIs[0] round
     /* 1924789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924792 */     // MIs[0] policy
     /* 1924792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1924807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924834 */     // GIR_Coverage, 16531,
     /* 1924834 */     GIR_EraseRootFromParent_Done,
     /* 1924835 */   // Label 25743: @1924835
     /* 1924835 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1924940), // Rule ID 16534 //
     /* 1924840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1924843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1924851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1924854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1924857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1924866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924890 */     // MIs[1] Operand 1
     /* 1924890 */     // No operand predicates
     /* 1924890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924894 */     // MIs[0] round
     /* 1924894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1924897 */     // MIs[0] policy
     /* 1924897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1924900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1924902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1924912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1924921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1924925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1924935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1924938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924939 */     // GIR_Coverage, 16534,
     /* 1924939 */     GIR_EraseRootFromParent_Done,
     /* 1924940 */   // Label 25744: @1924940
     /* 1924940 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1925045), // Rule ID 16535 //
     /* 1924945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1924948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1924953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1924956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1924959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1924962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1924971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1924987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1924991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1924995 */     // MIs[1] Operand 1
     /* 1924995 */     // No operand predicates
     /* 1924995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924999 */     // MIs[0] round
     /* 1924999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925002 */     // MIs[0] policy
     /* 1925002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 1925017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925044 */     // GIR_Coverage, 16535,
     /* 1925044 */     GIR_EraseRootFromParent_Done,
     /* 1925045 */   // Label 25745: @1925045
     /* 1925045 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1925150), // Rule ID 16538 //
     /* 1925050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1925053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1925067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1925076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925100 */     // MIs[1] Operand 1
     /* 1925100 */     // No operand predicates
     /* 1925100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925104 */     // MIs[0] round
     /* 1925104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925107 */     // MIs[0] policy
     /* 1925107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1925122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925149 */     // GIR_Coverage, 16538,
     /* 1925149 */     GIR_EraseRootFromParent_Done,
     /* 1925150 */   // Label 25746: @1925150
     /* 1925150 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1925255), // Rule ID 16539 //
     /* 1925155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1925158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1925172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1925181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925205 */     // MIs[1] Operand 1
     /* 1925205 */     // No operand predicates
     /* 1925205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925209 */     // MIs[0] round
     /* 1925209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925212 */     // MIs[0] policy
     /* 1925212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 1925227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925254 */     // GIR_Coverage, 16539,
     /* 1925254 */     GIR_EraseRootFromParent_Done,
     /* 1925255 */   // Label 25747: @1925255
     /* 1925255 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1925360), // Rule ID 16542 //
     /* 1925260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1925263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1925271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1925274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1925286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1925290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925310 */     // MIs[1] Operand 1
     /* 1925310 */     // No operand predicates
     /* 1925310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925314 */     // MIs[0] round
     /* 1925314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925317 */     // MIs[0] policy
     /* 1925317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1925332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925359 */     // GIR_Coverage, 16542,
     /* 1925359 */     GIR_EraseRootFromParent_Done,
     /* 1925360 */   // Label 25748: @1925360
     /* 1925360 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1925465), // Rule ID 16543 //
     /* 1925365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1925368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1925376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1925379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1925391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1925395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925415 */     // MIs[1] Operand 1
     /* 1925415 */     // No operand predicates
     /* 1925415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925419 */     // MIs[0] round
     /* 1925419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925422 */     // MIs[0] policy
     /* 1925422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 1925437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925464 */     // GIR_Coverage, 16543,
     /* 1925464 */     GIR_EraseRootFromParent_Done,
     /* 1925465 */   // Label 25749: @1925465
     /* 1925465 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1925570), // Rule ID 16546 //
     /* 1925470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1925473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1925481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1925484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1925496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925520 */     // MIs[1] Operand 1
     /* 1925520 */     // No operand predicates
     /* 1925520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925524 */     // MIs[0] round
     /* 1925524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925527 */     // MIs[0] policy
     /* 1925527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1925542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925569 */     // GIR_Coverage, 16546,
     /* 1925569 */     GIR_EraseRootFromParent_Done,
     /* 1925570 */   // Label 25750: @1925570
     /* 1925570 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1925675), // Rule ID 16547 //
     /* 1925575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1925578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1925583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1925586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1925589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1925601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1925617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1925621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1925625 */     // MIs[1] Operand 1
     /* 1925625 */     // No operand predicates
     /* 1925625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925629 */     // MIs[0] round
     /* 1925629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925632 */     // MIs[0] policy
     /* 1925632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1925637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 1925647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1925656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1925673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925674 */     // GIR_Coverage, 16547,
     /* 1925674 */     GIR_EraseRootFromParent_Done,
     /* 1925675 */   // Label 25751: @1925675
     /* 1925675 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1925762), // Rule ID 2626 //
     /* 1925680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1925683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1925688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1925697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1925703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925711 */     // MIs[0] passthru
     /* 1925711 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1925716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925724 */     // MIs[0] round
     /* 1925724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925727 */     // MIs[0] policy
     /* 1925727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925737 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 1925740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925761 */     // GIR_Coverage, 2626,
     /* 1925761 */     GIR_EraseRootFromParent_Done,
     /* 1925762 */   // Label 25752: @1925762
     /* 1925762 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1925849), // Rule ID 2627 //
     /* 1925767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1925770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1925775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1925784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1925790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925798 */     // MIs[0] passthru
     /* 1925798 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1925803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925811 */     // MIs[0] round
     /* 1925811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925814 */     // MIs[0] policy
     /* 1925814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 1925827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925848 */     // GIR_Coverage, 2627,
     /* 1925848 */     GIR_EraseRootFromParent_Done,
     /* 1925849 */   // Label 25753: @1925849
     /* 1925849 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1925936), // Rule ID 16998 //
     /* 1925854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1925857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1925862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1925871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1925877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925885 */     // MIs[0] passthru
     /* 1925885 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1925890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925898 */     // MIs[0] round
     /* 1925898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925901 */     // MIs[0] policy
     /* 1925901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925911 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 1925914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1925924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1925934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925935 */     // GIR_Coverage, 16998,
     /* 1925935 */     GIR_EraseRootFromParent_Done,
     /* 1925936 */   // Label 25754: @1925936
     /* 1925936 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1926023), // Rule ID 16999 //
     /* 1925941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1925944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1925949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1925958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1925964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925972 */     // MIs[0] passthru
     /* 1925972 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1925977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925985 */     // MIs[0] round
     /* 1925985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1925988 */     // MIs[0] policy
     /* 1925988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1925991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925998 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 1926001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926022 */     // GIR_Coverage, 16999,
     /* 1926022 */     GIR_EraseRootFromParent_Done,
     /* 1926023 */   // Label 25755: @1926023
     /* 1926023 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1926110), // Rule ID 17008 //
     /* 1926028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1926031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1926039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1926042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1926045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926059 */     // MIs[0] passthru
     /* 1926059 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926072 */     // MIs[0] round
     /* 1926072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926075 */     // MIs[0] policy
     /* 1926075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926085 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 1926088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926109 */     // GIR_Coverage, 17008,
     /* 1926109 */     GIR_EraseRootFromParent_Done,
     /* 1926110 */   // Label 25756: @1926110
     /* 1926110 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1926197), // Rule ID 17009 //
     /* 1926115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1926118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1926126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1926129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1926132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1926138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926146 */     // MIs[0] passthru
     /* 1926146 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926159 */     // MIs[0] round
     /* 1926159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926162 */     // MIs[0] policy
     /* 1926162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926172 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 1926175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926196 */     // GIR_Coverage, 17009,
     /* 1926196 */     GIR_EraseRootFromParent_Done,
     /* 1926197 */   // Label 25757: @1926197
     /* 1926197 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1926284), // Rule ID 17018 //
     /* 1926202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1926205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1926213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1926216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1926219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926233 */     // MIs[0] passthru
     /* 1926233 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926246 */     // MIs[0] round
     /* 1926246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926249 */     // MIs[0] policy
     /* 1926249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926259 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 1926262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926283 */     // GIR_Coverage, 17018,
     /* 1926283 */     GIR_EraseRootFromParent_Done,
     /* 1926284 */   // Label 25758: @1926284
     /* 1926284 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1926371), // Rule ID 17019 //
     /* 1926289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1926292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1926300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1926303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1926306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1926312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926320 */     // MIs[0] passthru
     /* 1926320 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926333 */     // MIs[0] round
     /* 1926333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926336 */     // MIs[0] policy
     /* 1926336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926346 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 1926349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926370 */     // GIR_Coverage, 17019,
     /* 1926370 */     GIR_EraseRootFromParent_Done,
     /* 1926371 */   // Label 25759: @1926371
     /* 1926371 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1926458), // Rule ID 17028 //
     /* 1926376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1926379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1926387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1926390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1926393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926407 */     // MIs[0] passthru
     /* 1926407 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926420 */     // MIs[0] round
     /* 1926420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926423 */     // MIs[0] policy
     /* 1926423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926433 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 1926436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926457 */     // GIR_Coverage, 17028,
     /* 1926457 */     GIR_EraseRootFromParent_Done,
     /* 1926458 */   // Label 25760: @1926458
     /* 1926458 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1926545), // Rule ID 17029 //
     /* 1926463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1926466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1926474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1926477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1926480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1926486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926494 */     // MIs[0] passthru
     /* 1926494 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926507 */     // MIs[0] round
     /* 1926507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926510 */     // MIs[0] policy
     /* 1926510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926520 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 1926523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926544 */     // GIR_Coverage, 17029,
     /* 1926544 */     GIR_EraseRootFromParent_Done,
     /* 1926545 */   // Label 25761: @1926545
     /* 1926545 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1926632), // Rule ID 17038 //
     /* 1926550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1926553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1926567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926581 */     // MIs[0] passthru
     /* 1926581 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926594 */     // MIs[0] round
     /* 1926594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926597 */     // MIs[0] policy
     /* 1926597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 1926610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926631 */     // GIR_Coverage, 17038,
     /* 1926631 */     GIR_EraseRootFromParent_Done,
     /* 1926632 */   // Label 25762: @1926632
     /* 1926632 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1926719), // Rule ID 17039 //
     /* 1926637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1926640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1926654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1926660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926668 */     // MIs[0] passthru
     /* 1926668 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926681 */     // MIs[0] round
     /* 1926681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926684 */     // MIs[0] policy
     /* 1926684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926694 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 1926697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926718 */     // GIR_Coverage, 17039,
     /* 1926718 */     GIR_EraseRootFromParent_Done,
     /* 1926719 */   // Label 25763: @1926719
     /* 1926719 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1926806), // Rule ID 17048 //
     /* 1926724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1926727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1926735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1926738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1926741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926755 */     // MIs[0] passthru
     /* 1926755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926768 */     // MIs[0] round
     /* 1926768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926771 */     // MIs[0] policy
     /* 1926771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 1926784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926805 */     // GIR_Coverage, 17048,
     /* 1926805 */     GIR_EraseRootFromParent_Done,
     /* 1926806 */   // Label 25764: @1926806
     /* 1926806 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1926893), // Rule ID 17049 //
     /* 1926811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1926814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1926822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1926825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1926828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1926834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926842 */     // MIs[0] passthru
     /* 1926842 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926855 */     // MIs[0] round
     /* 1926855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926858 */     // MIs[0] policy
     /* 1926858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926868 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 1926871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926892 */     // GIR_Coverage, 17049,
     /* 1926892 */     GIR_EraseRootFromParent_Done,
     /* 1926893 */   // Label 25765: @1926893
     /* 1926893 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1926980), // Rule ID 17058 //
     /* 1926898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1926901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1926909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1926912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1926915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1926921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926929 */     // MIs[0] passthru
     /* 1926929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1926934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926942 */     // MIs[0] round
     /* 1926942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1926945 */     // MIs[0] policy
     /* 1926945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1926948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926955 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 1926958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1926968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1926978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926979 */     // GIR_Coverage, 17058,
     /* 1926979 */     GIR_EraseRootFromParent_Done,
     /* 1926980 */   // Label 25766: @1926980
     /* 1926980 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1927067), // Rule ID 17059 //
     /* 1926985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1926988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1926993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1926996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1926999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1927002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927016 */     // MIs[0] passthru
     /* 1927016 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927029 */     // MIs[0] round
     /* 1927029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927032 */     // MIs[0] policy
     /* 1927032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927042 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 1927045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927066 */     // GIR_Coverage, 17059,
     /* 1927066 */     GIR_EraseRootFromParent_Done,
     /* 1927067 */   // Label 25767: @1927067
     /* 1927067 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1927154), // Rule ID 17068 //
     /* 1927072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1927075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1927080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1927083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1927086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1927089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927103 */     // MIs[0] passthru
     /* 1927103 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927116 */     // MIs[0] round
     /* 1927116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927119 */     // MIs[0] policy
     /* 1927119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927129 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 1927132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927153 */     // GIR_Coverage, 17068,
     /* 1927153 */     GIR_EraseRootFromParent_Done,
     /* 1927154 */   // Label 25768: @1927154
     /* 1927154 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1927241), // Rule ID 17069 //
     /* 1927159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1927162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1927167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1927170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1927173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1927176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927190 */     // MIs[0] passthru
     /* 1927190 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927203 */     // MIs[0] round
     /* 1927203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927206 */     // MIs[0] policy
     /* 1927206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927216 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 1927219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927240 */     // GIR_Coverage, 17069,
     /* 1927240 */     GIR_EraseRootFromParent_Done,
     /* 1927241 */   // Label 25769: @1927241
     /* 1927241 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1927328), // Rule ID 17114 //
     /* 1927246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1927249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1927257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1927260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1927263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1927266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927277 */     // MIs[0] passthru
     /* 1927277 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927290 */     // MIs[0] round
     /* 1927290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927293 */     // MIs[0] policy
     /* 1927293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927303 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 1927306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927327 */     // GIR_Coverage, 17114,
     /* 1927327 */     GIR_EraseRootFromParent_Done,
     /* 1927328 */   // Label 25770: @1927328
     /* 1927328 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1927415), // Rule ID 17115 //
     /* 1927333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1927336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1927344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1927347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1927350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1927353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927364 */     // MIs[0] passthru
     /* 1927364 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927377 */     // MIs[0] round
     /* 1927377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927380 */     // MIs[0] policy
     /* 1927380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927390 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 1927393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927414 */     // GIR_Coverage, 17115,
     /* 1927414 */     GIR_EraseRootFromParent_Done,
     /* 1927415 */   // Label 25771: @1927415
     /* 1927415 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1927502), // Rule ID 17124 //
     /* 1927420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1927423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1927431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1927434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1927437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927451 */     // MIs[0] passthru
     /* 1927451 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927464 */     // MIs[0] round
     /* 1927464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927467 */     // MIs[0] policy
     /* 1927467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 1927480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927501 */     // GIR_Coverage, 17124,
     /* 1927501 */     GIR_EraseRootFromParent_Done,
     /* 1927502 */   // Label 25772: @1927502
     /* 1927502 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1927589), // Rule ID 17125 //
     /* 1927507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1927510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1927518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1927521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1927524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927538 */     // MIs[0] passthru
     /* 1927538 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927551 */     // MIs[0] round
     /* 1927551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927554 */     // MIs[0] policy
     /* 1927554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 1927567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927588 */     // GIR_Coverage, 17125,
     /* 1927588 */     GIR_EraseRootFromParent_Done,
     /* 1927589 */   // Label 25773: @1927589
     /* 1927589 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1927676), // Rule ID 17134 //
     /* 1927594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1927597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1927611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927625 */     // MIs[0] passthru
     /* 1927625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927638 */     // MIs[0] round
     /* 1927638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927641 */     // MIs[0] policy
     /* 1927641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 1927654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927675 */     // GIR_Coverage, 17134,
     /* 1927675 */     GIR_EraseRootFromParent_Done,
     /* 1927676 */   // Label 25774: @1927676
     /* 1927676 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1927763), // Rule ID 17135 //
     /* 1927681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1927684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1927698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927712 */     // MIs[0] passthru
     /* 1927712 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927725 */     // MIs[0] round
     /* 1927725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927728 */     // MIs[0] policy
     /* 1927728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927738 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 1927741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927762 */     // GIR_Coverage, 17135,
     /* 1927762 */     GIR_EraseRootFromParent_Done,
     /* 1927763 */   // Label 25775: @1927763
     /* 1927763 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1927850), // Rule ID 17144 //
     /* 1927768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1927771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1927785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927799 */     // MIs[0] passthru
     /* 1927799 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927812 */     // MIs[0] round
     /* 1927812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927815 */     // MIs[0] policy
     /* 1927815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927825 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 1927828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927849 */     // GIR_Coverage, 17144,
     /* 1927849 */     GIR_EraseRootFromParent_Done,
     /* 1927850 */   // Label 25776: @1927850
     /* 1927850 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1927937), // Rule ID 17145 //
     /* 1927855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1927858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1927872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1927878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927886 */     // MIs[0] passthru
     /* 1927886 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927899 */     // MIs[0] round
     /* 1927899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927902 */     // MIs[0] policy
     /* 1927902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927912 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 1927915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1927925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1927935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927936 */     // GIR_Coverage, 17145,
     /* 1927936 */     GIR_EraseRootFromParent_Done,
     /* 1927937 */   // Label 25777: @1927937
     /* 1927937 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1928024), // Rule ID 17154 //
     /* 1927942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1927945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1927950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1927959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1927965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927973 */     // MIs[0] passthru
     /* 1927973 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1927978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927986 */     // MIs[0] round
     /* 1927986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1927989 */     // MIs[0] policy
     /* 1927989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1927992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927999 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 1928002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928023 */     // GIR_Coverage, 17154,
     /* 1928023 */     GIR_EraseRootFromParent_Done,
     /* 1928024 */   // Label 25778: @1928024
     /* 1928024 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1928111), // Rule ID 17155 //
     /* 1928029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1928032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1928040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1928043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1928046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928060 */     // MIs[0] passthru
     /* 1928060 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928073 */     // MIs[0] round
     /* 1928073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928076 */     // MIs[0] policy
     /* 1928076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928086 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 1928089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928110 */     // GIR_Coverage, 17155,
     /* 1928110 */     GIR_EraseRootFromParent_Done,
     /* 1928111 */   // Label 25779: @1928111
     /* 1928111 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1928198), // Rule ID 17164 //
     /* 1928116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1928119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1928127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1928130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1928133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1928139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928147 */     // MIs[0] passthru
     /* 1928147 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928160 */     // MIs[0] round
     /* 1928160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928163 */     // MIs[0] policy
     /* 1928163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928173 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 1928176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928197 */     // GIR_Coverage, 17164,
     /* 1928197 */     GIR_EraseRootFromParent_Done,
     /* 1928198 */   // Label 25780: @1928198
     /* 1928198 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1928285), // Rule ID 17165 //
     /* 1928203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1928206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1928214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1928217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1928220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928234 */     // MIs[0] passthru
     /* 1928234 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928247 */     // MIs[0] round
     /* 1928247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928250 */     // MIs[0] policy
     /* 1928250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928260 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 1928263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928284 */     // GIR_Coverage, 17165,
     /* 1928284 */     GIR_EraseRootFromParent_Done,
     /* 1928285 */   // Label 25781: @1928285
     /* 1928285 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1928372), // Rule ID 17174 //
     /* 1928290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1928293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1928307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1928313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928321 */     // MIs[0] passthru
     /* 1928321 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928334 */     // MIs[0] round
     /* 1928334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928337 */     // MIs[0] policy
     /* 1928337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928347 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 1928350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928371 */     // GIR_Coverage, 17174,
     /* 1928371 */     GIR_EraseRootFromParent_Done,
     /* 1928372 */   // Label 25782: @1928372
     /* 1928372 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1928459), // Rule ID 17175 //
     /* 1928377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1928380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1928394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928408 */     // MIs[0] passthru
     /* 1928408 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928421 */     // MIs[0] round
     /* 1928421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928424 */     // MIs[0] policy
     /* 1928424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 1928437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928458 */     // GIR_Coverage, 17175,
     /* 1928458 */     GIR_EraseRootFromParent_Done,
     /* 1928459 */   // Label 25783: @1928459
     /* 1928459 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1928546), // Rule ID 17184 //
     /* 1928464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1928467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1928481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1928487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928495 */     // MIs[0] passthru
     /* 1928495 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928508 */     // MIs[0] round
     /* 1928508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928511 */     // MIs[0] policy
     /* 1928511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928521 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 1928524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928545 */     // GIR_Coverage, 17184,
     /* 1928545 */     GIR_EraseRootFromParent_Done,
     /* 1928546 */   // Label 25784: @1928546
     /* 1928546 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1928633), // Rule ID 17185 //
     /* 1928551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1928554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1928568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928582 */     // MIs[0] passthru
     /* 1928582 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928595 */     // MIs[0] round
     /* 1928595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928598 */     // MIs[0] policy
     /* 1928598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928608 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 1928611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928632 */     // GIR_Coverage, 17185,
     /* 1928632 */     GIR_EraseRootFromParent_Done,
     /* 1928633 */   // Label 25785: @1928633
     /* 1928633 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1928720), // Rule ID 17194 //
     /* 1928638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1928641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1928655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1928661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928669 */     // MIs[0] passthru
     /* 1928669 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928682 */     // MIs[0] round
     /* 1928682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928685 */     // MIs[0] policy
     /* 1928685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928695 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 1928698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928719 */     // GIR_Coverage, 17194,
     /* 1928719 */     GIR_EraseRootFromParent_Done,
     /* 1928720 */   // Label 25786: @1928720
     /* 1928720 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1928807), // Rule ID 17195 //
     /* 1928725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1928728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 1928733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1928742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928756 */     // MIs[0] passthru
     /* 1928756 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1928761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928769 */     // MIs[0] round
     /* 1928769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928772 */     // MIs[0] policy
     /* 1928772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 1928785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928806 */     // GIR_Coverage, 17195,
     /* 1928806 */     GIR_EraseRootFromParent_Done,
     /* 1928807 */   // Label 25787: @1928807
     /* 1928807 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1928898), // Rule ID 2584 //
     /* 1928812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1928820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1928832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1928838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928858 */     // MIs[0] round
     /* 1928858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928861 */     // MIs[0] policy
     /* 1928861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 1928874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928897 */     // GIR_Coverage, 2584,
     /* 1928897 */     GIR_EraseRootFromParent_Done,
     /* 1928898 */   // Label 25788: @1928898
     /* 1928898 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1928989), // Rule ID 2585 //
     /* 1928903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1928911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1928923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1928929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928949 */     // MIs[0] round
     /* 1928949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1928952 */     // MIs[0] policy
     /* 1928952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1928955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928962 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 1928965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1928977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1928987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928988 */     // GIR_Coverage, 2585,
     /* 1928988 */     GIR_EraseRootFromParent_Done,
     /* 1928989 */   // Label 25789: @1928989
     /* 1928989 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1929080), // Rule ID 2628 //
     /* 1928994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1928997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1929002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929040 */     // MIs[0] round
     /* 1929040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929043 */     // MIs[0] policy
     /* 1929043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929053 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 1929056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929079 */     // GIR_Coverage, 2628,
     /* 1929079 */     GIR_EraseRootFromParent_Done,
     /* 1929080 */   // Label 25790: @1929080
     /* 1929080 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1929171), // Rule ID 2629 //
     /* 1929085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1929088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 1929093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1929111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929131 */     // MIs[0] round
     /* 1929131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929134 */     // MIs[0] policy
     /* 1929134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929144 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 1929147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929170 */     // GIR_Coverage, 2629,
     /* 1929170 */     GIR_EraseRootFromParent_Done,
     /* 1929171 */   // Label 25791: @1929171
     /* 1929171 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1929262), // Rule ID 2636 //
     /* 1929176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1929179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 1929184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929222 */     // MIs[0] round
     /* 1929222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929225 */     // MIs[0] policy
     /* 1929225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929235 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 1929238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929261 */     // GIR_Coverage, 2636,
     /* 1929261 */     GIR_EraseRootFromParent_Done,
     /* 1929262 */   // Label 25792: @1929262
     /* 1929262 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1929353), // Rule ID 2637 //
     /* 1929267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1929270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 1929275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1929293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929313 */     // MIs[0] round
     /* 1929313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929316 */     // MIs[0] policy
     /* 1929316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929326 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 1929329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929352 */     // GIR_Coverage, 2637,
     /* 1929352 */     GIR_EraseRootFromParent_Done,
     /* 1929353 */   // Label 25793: @1929353
     /* 1929353 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1929444), // Rule ID 14786 //
     /* 1929358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1929369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1929372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1929375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1929378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929404 */     // MIs[0] round
     /* 1929404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929407 */     // MIs[0] policy
     /* 1929407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 1929420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929443 */     // GIR_Coverage, 14786,
     /* 1929443 */     GIR_EraseRootFromParent_Done,
     /* 1929444 */   // Label 25794: @1929444
     /* 1929444 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1929535), // Rule ID 14787 //
     /* 1929449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1929460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1929463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1929466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1929469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1929475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929495 */     // MIs[0] round
     /* 1929495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929498 */     // MIs[0] policy
     /* 1929498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 1929511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929534 */     // GIR_Coverage, 14787,
     /* 1929534 */     GIR_EraseRootFromParent_Done,
     /* 1929535 */   // Label 25795: @1929535
     /* 1929535 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1929626), // Rule ID 14790 //
     /* 1929540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1929551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1929554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1929557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1929560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929586 */     // MIs[0] round
     /* 1929586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929589 */     // MIs[0] policy
     /* 1929589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929599 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1929602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929625 */     // GIR_Coverage, 14790,
     /* 1929625 */     GIR_EraseRootFromParent_Done,
     /* 1929626 */   // Label 25796: @1929626
     /* 1929626 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1929717), // Rule ID 14791 //
     /* 1929631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1929642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1929645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1929648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1929651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1929657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929677 */     // MIs[0] round
     /* 1929677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929680 */     // MIs[0] policy
     /* 1929680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929690 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1929693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929716 */     // GIR_Coverage, 14791,
     /* 1929716 */     GIR_EraseRootFromParent_Done,
     /* 1929717 */   // Label 25797: @1929717
     /* 1929717 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1929808), // Rule ID 14794 //
     /* 1929722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929768 */     // MIs[0] round
     /* 1929768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929771 */     // MIs[0] policy
     /* 1929771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 1929784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929807 */     // GIR_Coverage, 14794,
     /* 1929807 */     GIR_EraseRootFromParent_Done,
     /* 1929808 */   // Label 25798: @1929808
     /* 1929808 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1929899), // Rule ID 14795 //
     /* 1929813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1929833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1929839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929859 */     // MIs[0] round
     /* 1929859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929862 */     // MIs[0] policy
     /* 1929862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 1929875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929898 */     // GIR_Coverage, 14795,
     /* 1929898 */     GIR_EraseRootFromParent_Done,
     /* 1929899 */   // Label 25799: @1929899
     /* 1929899 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1929990), // Rule ID 14798 //
     /* 1929904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1929912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1929924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1929930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929950 */     // MIs[0] round
     /* 1929950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1929953 */     // MIs[0] policy
     /* 1929953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1929956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929963 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1929966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1929978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1929988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929989 */     // GIR_Coverage, 14798,
     /* 1929989 */     GIR_EraseRootFromParent_Done,
     /* 1929990 */   // Label 25800: @1929990
     /* 1929990 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1930081), // Rule ID 14799 //
     /* 1929995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1930006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1930009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1930012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1930015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930041 */     // MIs[0] round
     /* 1930041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930044 */     // MIs[0] policy
     /* 1930044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1930057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930080 */     // GIR_Coverage, 14799,
     /* 1930080 */     GIR_EraseRootFromParent_Done,
     /* 1930081 */   // Label 25801: @1930081
     /* 1930081 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1930172), // Rule ID 14802 //
     /* 1930086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1930097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1930100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1930103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1930106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1930112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930132 */     // MIs[0] round
     /* 1930132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930135 */     // MIs[0] policy
     /* 1930135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930145 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1930148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930171 */     // GIR_Coverage, 14802,
     /* 1930171 */     GIR_EraseRootFromParent_Done,
     /* 1930172 */   // Label 25802: @1930172
     /* 1930172 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1930263), // Rule ID 14803 //
     /* 1930177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1930188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1930191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1930194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1930197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930223 */     // MIs[0] round
     /* 1930223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930226 */     // MIs[0] policy
     /* 1930226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 1930239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930262 */     // GIR_Coverage, 14803,
     /* 1930262 */     GIR_EraseRootFromParent_Done,
     /* 1930263 */   // Label 25803: @1930263
     /* 1930263 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1930354), // Rule ID 14806 //
     /* 1930268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1930279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1930282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1930285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1930288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1930294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930314 */     // MIs[0] round
     /* 1930314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930317 */     // MIs[0] policy
     /* 1930317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930353 */     // GIR_Coverage, 14806,
     /* 1930353 */     GIR_EraseRootFromParent_Done,
     /* 1930354 */   // Label 25804: @1930354
     /* 1930354 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1930445), // Rule ID 14807 //
     /* 1930359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1930370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1930373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1930376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1930379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930405 */     // MIs[0] round
     /* 1930405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930408 */     // MIs[0] policy
     /* 1930408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930444 */     // GIR_Coverage, 14807,
     /* 1930444 */     GIR_EraseRootFromParent_Done,
     /* 1930445 */   // Label 25805: @1930445
     /* 1930445 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1930536), // Rule ID 14810 //
     /* 1930450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1930461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1930464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1930467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1930470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1930476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930496 */     // MIs[0] round
     /* 1930496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930499 */     // MIs[0] policy
     /* 1930499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930535 */     // GIR_Coverage, 14810,
     /* 1930535 */     GIR_EraseRootFromParent_Done,
     /* 1930536 */   // Label 25806: @1930536
     /* 1930536 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1930627), // Rule ID 14811 //
     /* 1930541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1930552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1930555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1930558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1930561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930587 */     // MIs[0] round
     /* 1930587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930590 */     // MIs[0] policy
     /* 1930590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930626 */     // GIR_Coverage, 14811,
     /* 1930626 */     GIR_EraseRootFromParent_Done,
     /* 1930627 */   // Label 25807: @1930627
     /* 1930627 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1930718), // Rule ID 14814 //
     /* 1930632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1930652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1930658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930678 */     // MIs[0] round
     /* 1930678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930681 */     // MIs[0] policy
     /* 1930681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930717 */     // GIR_Coverage, 14814,
     /* 1930717 */     GIR_EraseRootFromParent_Done,
     /* 1930718 */   // Label 25808: @1930718
     /* 1930718 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1930809), // Rule ID 14815 //
     /* 1930723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1930743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930769 */     // MIs[0] round
     /* 1930769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930772 */     // MIs[0] policy
     /* 1930772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930808 */     // GIR_Coverage, 14815,
     /* 1930808 */     GIR_EraseRootFromParent_Done,
     /* 1930809 */   // Label 25809: @1930809
     /* 1930809 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1930900), // Rule ID 14818 //
     /* 1930814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1930817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1930834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1930840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930860 */     // MIs[0] round
     /* 1930860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930863 */     // MIs[0] policy
     /* 1930863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930899 */     // GIR_Coverage, 14818,
     /* 1930899 */     GIR_EraseRootFromParent_Done,
     /* 1930900 */   // Label 25810: @1930900
     /* 1930900 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1930991), // Rule ID 14819 //
     /* 1930905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1930908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1930913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1930925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1930931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930951 */     // MIs[0] round
     /* 1930951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1930954 */     // MIs[0] policy
     /* 1930954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1930957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 1930967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1930979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1930989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930990 */     // GIR_Coverage, 14819,
     /* 1930990 */     GIR_EraseRootFromParent_Done,
     /* 1930991 */   // Label 25811: @1930991
     /* 1930991 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1931082), // Rule ID 14822 //
     /* 1930996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1931007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1931010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1931013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1931016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931042 */     // MIs[0] round
     /* 1931042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931045 */     // MIs[0] policy
     /* 1931045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1931058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931081 */     // GIR_Coverage, 14822,
     /* 1931081 */     GIR_EraseRootFromParent_Done,
     /* 1931082 */   // Label 25812: @1931082
     /* 1931082 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1931173), // Rule ID 14823 //
     /* 1931087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1931098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1931101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1931104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1931107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1931113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931133 */     // MIs[0] round
     /* 1931133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931136 */     // MIs[0] policy
     /* 1931136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1931149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931172 */     // GIR_Coverage, 14823,
     /* 1931172 */     GIR_EraseRootFromParent_Done,
     /* 1931173 */   // Label 25813: @1931173
     /* 1931173 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1931264), // Rule ID 14826 //
     /* 1931178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1931189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1931192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1931195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1931198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931224 */     // MIs[0] round
     /* 1931224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931227 */     // MIs[0] policy
     /* 1931227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931237 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1931240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931263 */     // GIR_Coverage, 14826,
     /* 1931263 */     GIR_EraseRootFromParent_Done,
     /* 1931264 */   // Label 25814: @1931264
     /* 1931264 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1931355), // Rule ID 14827 //
     /* 1931269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1931280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1931283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1931286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1931289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1931295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931315 */     // MIs[0] round
     /* 1931315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931318 */     // MIs[0] policy
     /* 1931318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1931331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931354 */     // GIR_Coverage, 14827,
     /* 1931354 */     GIR_EraseRootFromParent_Done,
     /* 1931355 */   // Label 25815: @1931355
     /* 1931355 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1931446), // Rule ID 14830 //
     /* 1931360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1931371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1931374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1931377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1931380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1931383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931406 */     // MIs[0] round
     /* 1931406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931409 */     // MIs[0] policy
     /* 1931409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1931422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931445 */     // GIR_Coverage, 14830,
     /* 1931445 */     GIR_EraseRootFromParent_Done,
     /* 1931446 */   // Label 25816: @1931446
     /* 1931446 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1931537), // Rule ID 14831 //
     /* 1931451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1931462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1931465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1931468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1931471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1931474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1931477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931497 */     // MIs[0] round
     /* 1931497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931500 */     // MIs[0] policy
     /* 1931500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1931513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931536 */     // GIR_Coverage, 14831,
     /* 1931536 */     GIR_EraseRootFromParent_Done,
     /* 1931537 */   // Label 25817: @1931537
     /* 1931537 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1931628), // Rule ID 14834 //
     /* 1931542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1931553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1931556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1931559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1931562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931588 */     // MIs[0] round
     /* 1931588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931591 */     // MIs[0] policy
     /* 1931591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1931604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931627 */     // GIR_Coverage, 14834,
     /* 1931627 */     GIR_EraseRootFromParent_Done,
     /* 1931628 */   // Label 25818: @1931628
     /* 1931628 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1931719), // Rule ID 14835 //
     /* 1931633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1931644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1931647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1931650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1931653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1931659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931679 */     // MIs[0] round
     /* 1931679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931682 */     // MIs[0] policy
     /* 1931682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1931695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931718 */     // GIR_Coverage, 14835,
     /* 1931718 */     GIR_EraseRootFromParent_Done,
     /* 1931719 */   // Label 25819: @1931719
     /* 1931719 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1931810), // Rule ID 14838 //
     /* 1931724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1931744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931770 */     // MIs[0] round
     /* 1931770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931773 */     // MIs[0] policy
     /* 1931773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1931786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931809 */     // GIR_Coverage, 14838,
     /* 1931809 */     GIR_EraseRootFromParent_Done,
     /* 1931810 */   // Label 25820: @1931810
     /* 1931810 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1931901), // Rule ID 14839 //
     /* 1931815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1931835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1931841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931861 */     // MIs[0] round
     /* 1931861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931864 */     // MIs[0] policy
     /* 1931864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1931877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931900 */     // GIR_Coverage, 14839,
     /* 1931900 */     GIR_EraseRootFromParent_Done,
     /* 1931901 */   // Label 25821: @1931901
     /* 1931901 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1931992), // Rule ID 14842 //
     /* 1931906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1931914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1931917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1931920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1931923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1931926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1931932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931952 */     // MIs[0] round
     /* 1931952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1931955 */     // MIs[0] policy
     /* 1931955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1931958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1931968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1931980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1931990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931991 */     // GIR_Coverage, 14842,
     /* 1931991 */     GIR_EraseRootFromParent_Done,
     /* 1931992 */   // Label 25822: @1931992
     /* 1931992 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1932083), // Rule ID 14843 //
     /* 1931997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1932008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1932011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1932014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1932017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1932020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932043 */     // MIs[0] round
     /* 1932043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932046 */     // MIs[0] policy
     /* 1932046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932056 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1932059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932082 */     // GIR_Coverage, 14843,
     /* 1932082 */     GIR_EraseRootFromParent_Done,
     /* 1932083 */   // Label 25823: @1932083
     /* 1932083 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1932174), // Rule ID 14846 //
     /* 1932088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1932099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1932102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1932105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1932108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1932114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932134 */     // MIs[0] round
     /* 1932134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932137 */     // MIs[0] policy
     /* 1932137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1932150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932173 */     // GIR_Coverage, 14846,
     /* 1932173 */     GIR_EraseRootFromParent_Done,
     /* 1932174 */   // Label 25824: @1932174
     /* 1932174 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1932265), // Rule ID 14847 //
     /* 1932179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1932190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1932193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1932196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1932199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932225 */     // MIs[0] round
     /* 1932225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932228 */     // MIs[0] policy
     /* 1932228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1932241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932264 */     // GIR_Coverage, 14847,
     /* 1932264 */     GIR_EraseRootFromParent_Done,
     /* 1932265 */   // Label 25825: @1932265
     /* 1932265 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1932356), // Rule ID 14850 //
     /* 1932270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1932281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1932284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1932287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1932290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1932296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932316 */     // MIs[0] round
     /* 1932316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932319 */     // MIs[0] policy
     /* 1932319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932329 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1932332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932355 */     // GIR_Coverage, 14850,
     /* 1932355 */     GIR_EraseRootFromParent_Done,
     /* 1932356 */   // Label 25826: @1932356
     /* 1932356 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1932447), // Rule ID 14851 //
     /* 1932361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1932372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1932375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1932378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1932381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932407 */     // MIs[0] round
     /* 1932407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932410 */     // MIs[0] policy
     /* 1932410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1932423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932446 */     // GIR_Coverage, 14851,
     /* 1932446 */     GIR_EraseRootFromParent_Done,
     /* 1932447 */   // Label 25827: @1932447
     /* 1932447 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1932538), // Rule ID 14854 //
     /* 1932452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1932463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1932466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1932469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1932472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1932478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932498 */     // MIs[0] round
     /* 1932498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932501 */     // MIs[0] policy
     /* 1932501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1932514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932537 */     // GIR_Coverage, 14854,
     /* 1932537 */     GIR_EraseRootFromParent_Done,
     /* 1932538 */   // Label 25828: @1932538
     /* 1932538 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1932629), // Rule ID 14855 //
     /* 1932543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1932554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1932557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1932560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1932563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932589 */     // MIs[0] round
     /* 1932589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932592 */     // MIs[0] policy
     /* 1932592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1932605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932628 */     // GIR_Coverage, 14855,
     /* 1932628 */     GIR_EraseRootFromParent_Done,
     /* 1932629 */   // Label 25829: @1932629
     /* 1932629 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1932720), // Rule ID 14858 //
     /* 1932634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1932645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1932648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1932651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1932654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1932660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932680 */     // MIs[0] round
     /* 1932680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932683 */     // MIs[0] policy
     /* 1932683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1932696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932719 */     // GIR_Coverage, 14858,
     /* 1932719 */     GIR_EraseRootFromParent_Done,
     /* 1932720 */   // Label 25830: @1932720
     /* 1932720 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1932811), // Rule ID 14859 //
     /* 1932725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1932736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1932739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1932742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1932745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932771 */     // MIs[0] round
     /* 1932771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932774 */     // MIs[0] policy
     /* 1932774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 1932787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932810 */     // GIR_Coverage, 14859,
     /* 1932810 */     GIR_EraseRootFromParent_Done,
     /* 1932811 */   // Label 25831: @1932811
     /* 1932811 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1932902), // Rule ID 14862 //
     /* 1932816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1932836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1932842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932862 */     // MIs[0] round
     /* 1932862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932865 */     // MIs[0] policy
     /* 1932865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932875 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1932878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932901 */     // GIR_Coverage, 14862,
     /* 1932901 */     GIR_EraseRootFromParent_Done,
     /* 1932902 */   // Label 25832: @1932902
     /* 1932902 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1932993), // Rule ID 14863 //
     /* 1932907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1932915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1932927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1932933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932953 */     // MIs[0] round
     /* 1932953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1932956 */     // MIs[0] policy
     /* 1932956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1932959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 1932969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1932981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1932991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932992 */     // GIR_Coverage, 14863,
     /* 1932992 */     GIR_EraseRootFromParent_Done,
     /* 1932993 */   // Label 25833: @1932993
     /* 1932993 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1933084), // Rule ID 14866 //
     /* 1932998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1933009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1933012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1933015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1933018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933044 */     // MIs[0] round
     /* 1933044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933047 */     // MIs[0] policy
     /* 1933047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1933060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933083 */     // GIR_Coverage, 14866,
     /* 1933083 */     GIR_EraseRootFromParent_Done,
     /* 1933084 */   // Label 25834: @1933084
     /* 1933084 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1933175), // Rule ID 14867 //
     /* 1933089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1933100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1933103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1933106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1933109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1933115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933135 */     // MIs[0] round
     /* 1933135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933138 */     // MIs[0] policy
     /* 1933138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 1933151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933174 */     // GIR_Coverage, 14867,
     /* 1933174 */     GIR_EraseRootFromParent_Done,
     /* 1933175 */   // Label 25835: @1933175
     /* 1933175 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1933266), // Rule ID 14870 //
     /* 1933180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1933191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1933194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1933197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933226 */     // MIs[0] round
     /* 1933226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933229 */     // MIs[0] policy
     /* 1933229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 1933242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933265 */     // GIR_Coverage, 14870,
     /* 1933265 */     GIR_EraseRootFromParent_Done,
     /* 1933266 */   // Label 25836: @1933266
     /* 1933266 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1933357), // Rule ID 14871 //
     /* 1933271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1933282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1933285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1933288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1933297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933317 */     // MIs[0] round
     /* 1933317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933320 */     // MIs[0] policy
     /* 1933320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 1933333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933356 */     // GIR_Coverage, 14871,
     /* 1933356 */     GIR_EraseRootFromParent_Done,
     /* 1933357 */   // Label 25837: @1933357
     /* 1933357 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1933448), // Rule ID 14874 //
     /* 1933362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1933373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1933376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1933379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933408 */     // MIs[0] round
     /* 1933408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933411 */     // MIs[0] policy
     /* 1933411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 1933424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933447 */     // GIR_Coverage, 14874,
     /* 1933447 */     GIR_EraseRootFromParent_Done,
     /* 1933448 */   // Label 25838: @1933448
     /* 1933448 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1933539), // Rule ID 14875 //
     /* 1933453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1933464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1933467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1933470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1933479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933499 */     // MIs[0] round
     /* 1933499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933502 */     // MIs[0] policy
     /* 1933502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933512 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 1933515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933538 */     // GIR_Coverage, 14875,
     /* 1933538 */     GIR_EraseRootFromParent_Done,
     /* 1933539 */   // Label 25839: @1933539
     /* 1933539 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1933630), // Rule ID 14878 //
     /* 1933544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1933555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1933558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1933561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933590 */     // MIs[0] round
     /* 1933590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933593 */     // MIs[0] policy
     /* 1933593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933603 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1933606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933629 */     // GIR_Coverage, 14878,
     /* 1933629 */     GIR_EraseRootFromParent_Done,
     /* 1933630 */   // Label 25840: @1933630
     /* 1933630 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1933721), // Rule ID 14879 //
     /* 1933635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1933646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1933649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1933652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1933661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933681 */     // MIs[0] round
     /* 1933681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933684 */     // MIs[0] policy
     /* 1933684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933694 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1933697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933720 */     // GIR_Coverage, 14879,
     /* 1933720 */     GIR_EraseRootFromParent_Done,
     /* 1933721 */   // Label 25841: @1933721
     /* 1933721 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1933812), // Rule ID 14882 //
     /* 1933726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933772 */     // MIs[0] round
     /* 1933772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933775 */     // MIs[0] policy
     /* 1933775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 1933788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933811 */     // GIR_Coverage, 14882,
     /* 1933811 */     GIR_EraseRootFromParent_Done,
     /* 1933812 */   // Label 25842: @1933812
     /* 1933812 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1933903), // Rule ID 14883 //
     /* 1933817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1933843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933863 */     // MIs[0] round
     /* 1933863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933866 */     // MIs[0] policy
     /* 1933866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 1933879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933902 */     // GIR_Coverage, 14883,
     /* 1933902 */     GIR_EraseRootFromParent_Done,
     /* 1933903 */   // Label 25843: @1933903
     /* 1933903 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1933994), // Rule ID 14886 //
     /* 1933908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1933916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1933934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933954 */     // MIs[0] round
     /* 1933954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1933957 */     // MIs[0] policy
     /* 1933957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1933960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1933970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1933982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1933992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933993 */     // GIR_Coverage, 14886,
     /* 1933993 */     GIR_EraseRootFromParent_Done,
     /* 1933994 */   // Label 25844: @1933994
     /* 1933994 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1934085), // Rule ID 14887 //
     /* 1933999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1934010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1934013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1934016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934045 */     // MIs[0] round
     /* 1934045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934048 */     // MIs[0] policy
     /* 1934048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1934061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934084 */     // GIR_Coverage, 14887,
     /* 1934084 */     GIR_EraseRootFromParent_Done,
     /* 1934085 */   // Label 25845: @1934085
     /* 1934085 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1934176), // Rule ID 14890 //
     /* 1934090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1934101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1934104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1934107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1934116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934136 */     // MIs[0] round
     /* 1934136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934139 */     // MIs[0] policy
     /* 1934139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1934152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934175 */     // GIR_Coverage, 14890,
     /* 1934175 */     GIR_EraseRootFromParent_Done,
     /* 1934176 */   // Label 25846: @1934176
     /* 1934176 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1934267), // Rule ID 14891 //
     /* 1934181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1934192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1934195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1934198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934227 */     // MIs[0] round
     /* 1934227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934230 */     // MIs[0] policy
     /* 1934230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 1934243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934266 */     // GIR_Coverage, 14891,
     /* 1934266 */     GIR_EraseRootFromParent_Done,
     /* 1934267 */   // Label 25847: @1934267
     /* 1934267 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1934358), // Rule ID 14894 //
     /* 1934272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1934283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1934286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1934289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1934298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934318 */     // MIs[0] round
     /* 1934318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934321 */     // MIs[0] policy
     /* 1934321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934331 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934357 */     // GIR_Coverage, 14894,
     /* 1934357 */     GIR_EraseRootFromParent_Done,
     /* 1934358 */   // Label 25848: @1934358
     /* 1934358 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1934449), // Rule ID 14895 //
     /* 1934363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1934374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1934377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1934380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934409 */     // MIs[0] round
     /* 1934409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934412 */     // MIs[0] policy
     /* 1934412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10832:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934448 */     // GIR_Coverage, 14895,
     /* 1934448 */     GIR_EraseRootFromParent_Done,
     /* 1934449 */   // Label 25849: @1934449
     /* 1934449 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1934540), // Rule ID 14898 //
     /* 1934454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1934480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934500 */     // MIs[0] round
     /* 1934500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934503 */     // MIs[0] policy
     /* 1934503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934513 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934539 */     // GIR_Coverage, 14898,
     /* 1934539 */     GIR_EraseRootFromParent_Done,
     /* 1934540 */   // Label 25850: @1934540
     /* 1934540 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1934631), // Rule ID 14899 //
     /* 1934545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934591 */     // MIs[0] round
     /* 1934591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934594 */     // MIs[0] policy
     /* 1934594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934630 */     // GIR_Coverage, 14899,
     /* 1934630 */     GIR_EraseRootFromParent_Done,
     /* 1934631 */   // Label 25851: @1934631
     /* 1934631 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1934722), // Rule ID 14902 //
     /* 1934636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1934647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1934650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1934653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1934662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934682 */     // MIs[0] round
     /* 1934682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934685 */     // MIs[0] policy
     /* 1934685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934721 */     // GIR_Coverage, 14902,
     /* 1934721 */     GIR_EraseRootFromParent_Done,
     /* 1934722 */   // Label 25852: @1934722
     /* 1934722 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1934813), // Rule ID 14903 //
     /* 1934727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1934738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1934741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1934744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934773 */     // MIs[0] round
     /* 1934773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934776 */     // MIs[0] policy
     /* 1934776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934812 */     // GIR_Coverage, 14903,
     /* 1934812 */     GIR_EraseRootFromParent_Done,
     /* 1934813 */   // Label 25853: @1934813
     /* 1934813 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1934904), // Rule ID 14906 //
     /* 1934818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1934821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1934844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934864 */     // MIs[0] round
     /* 1934864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934867 */     // MIs[0] policy
     /* 1934867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934903 */     // GIR_Coverage, 14906,
     /* 1934903 */     GIR_EraseRootFromParent_Done,
     /* 1934904 */   // Label 25854: @1934904
     /* 1934904 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1934995), // Rule ID 14907 //
     /* 1934909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1934912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1934917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1934935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934955 */     // MIs[0] round
     /* 1934955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1934958 */     // MIs[0] policy
     /* 1934958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1934961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 1934971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1934983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1934993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934994 */     // GIR_Coverage, 14907,
     /* 1934994 */     GIR_EraseRootFromParent_Done,
     /* 1934995 */   // Label 25855: @1934995
     /* 1934995 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1935086), // Rule ID 14910 //
     /* 1935000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1935011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1935014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1935017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935046 */     // MIs[0] round
     /* 1935046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935049 */     // MIs[0] policy
     /* 1935049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1935062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935085 */     // GIR_Coverage, 14910,
     /* 1935085 */     GIR_EraseRootFromParent_Done,
     /* 1935086 */   // Label 25856: @1935086
     /* 1935086 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1935177), // Rule ID 14911 //
     /* 1935091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1935102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1935105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1935108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1935117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935137 */     // MIs[0] round
     /* 1935137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935140 */     // MIs[0] policy
     /* 1935140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1935153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935176 */     // GIR_Coverage, 14911,
     /* 1935176 */     GIR_EraseRootFromParent_Done,
     /* 1935177 */   // Label 25857: @1935177
     /* 1935177 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1935268), // Rule ID 14914 //
     /* 1935182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1935193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1935196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1935199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935228 */     // MIs[0] round
     /* 1935228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935231 */     // MIs[0] policy
     /* 1935231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935241 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1935244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935267 */     // GIR_Coverage, 14914,
     /* 1935267 */     GIR_EraseRootFromParent_Done,
     /* 1935268 */   // Label 25858: @1935268
     /* 1935268 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1935359), // Rule ID 14915 //
     /* 1935273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1935284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1935287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1935290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1935299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935319 */     // MIs[0] round
     /* 1935319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935322 */     // MIs[0] policy
     /* 1935322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1935335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935358 */     // GIR_Coverage, 14915,
     /* 1935358 */     GIR_EraseRootFromParent_Done,
     /* 1935359 */   // Label 25859: @1935359
     /* 1935359 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1935450), // Rule ID 14918 //
     /* 1935364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1935375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1935378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1935381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1935387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935410 */     // MIs[0] round
     /* 1935410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935413 */     // MIs[0] policy
     /* 1935413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935423 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1935426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935449 */     // GIR_Coverage, 14918,
     /* 1935449 */     GIR_EraseRootFromParent_Done,
     /* 1935450 */   // Label 25860: @1935450
     /* 1935450 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1935541), // Rule ID 14919 //
     /* 1935455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1935466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1935469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1935472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1935478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1935481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935501 */     // MIs[0] round
     /* 1935501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935504 */     // MIs[0] policy
     /* 1935504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1935517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935540 */     // GIR_Coverage, 14919,
     /* 1935540 */     GIR_EraseRootFromParent_Done,
     /* 1935541 */   // Label 25861: @1935541
     /* 1935541 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1935632), // Rule ID 14922 //
     /* 1935546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1935557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1935560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1935563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935592 */     // MIs[0] round
     /* 1935592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935595 */     // MIs[0] policy
     /* 1935595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1935608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935631 */     // GIR_Coverage, 14922,
     /* 1935631 */     GIR_EraseRootFromParent_Done,
     /* 1935632 */   // Label 25862: @1935632
     /* 1935632 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1935723), // Rule ID 14923 //
     /* 1935637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1935648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1935651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1935654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1935663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935683 */     // MIs[0] round
     /* 1935683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935686 */     // MIs[0] policy
     /* 1935686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1935699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935722 */     // GIR_Coverage, 14923,
     /* 1935722 */     GIR_EraseRootFromParent_Done,
     /* 1935723 */   // Label 25863: @1935723
     /* 1935723 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1935814), // Rule ID 14926 //
     /* 1935728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1935739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1935742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1935745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935774 */     // MIs[0] round
     /* 1935774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935777 */     // MIs[0] policy
     /* 1935777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935787 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1935790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935813 */     // GIR_Coverage, 14926,
     /* 1935813 */     GIR_EraseRootFromParent_Done,
     /* 1935814 */   // Label 25864: @1935814
     /* 1935814 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1935905), // Rule ID 14927 //
     /* 1935819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1935830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1935833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1935836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1935845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935865 */     // MIs[0] round
     /* 1935865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935868 */     // MIs[0] policy
     /* 1935868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1935881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935904 */     // GIR_Coverage, 14927,
     /* 1935904 */     GIR_EraseRootFromParent_Done,
     /* 1935905 */   // Label 25865: @1935905
     /* 1935905 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1935996), // Rule ID 14930 //
     /* 1935910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1935918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1935936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935956 */     // MIs[0] round
     /* 1935956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1935959 */     // MIs[0] policy
     /* 1935959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1935962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1935972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1935984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1935994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935995 */     // GIR_Coverage, 14930,
     /* 1935995 */     GIR_EraseRootFromParent_Done,
     /* 1935996 */   // Label 25866: @1935996
     /* 1935996 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1936087), // Rule ID 14931 //
     /* 1936001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1936012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1936015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1936018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1936024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936047 */     // MIs[0] round
     /* 1936047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936050 */     // MIs[0] policy
     /* 1936050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1936063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936086 */     // GIR_Coverage, 14931,
     /* 1936086 */     GIR_EraseRootFromParent_Done,
     /* 1936087 */   // Label 25867: @1936087
     /* 1936087 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1936178), // Rule ID 14934 //
     /* 1936092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1936103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1936106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1936109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1936118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936138 */     // MIs[0] round
     /* 1936138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936141 */     // MIs[0] policy
     /* 1936141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1936154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936177 */     // GIR_Coverage, 14934,
     /* 1936177 */     GIR_EraseRootFromParent_Done,
     /* 1936178 */   // Label 25868: @1936178
     /* 1936178 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1936269), // Rule ID 14935 //
     /* 1936183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1936194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1936197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1936200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936229 */     // MIs[0] round
     /* 1936229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936232 */     // MIs[0] policy
     /* 1936232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1936245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936268 */     // GIR_Coverage, 14935,
     /* 1936268 */     GIR_EraseRootFromParent_Done,
     /* 1936269 */   // Label 25869: @1936269
     /* 1936269 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1936360), // Rule ID 14938 //
     /* 1936274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1936285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1936288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1936291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1936300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936320 */     // MIs[0] round
     /* 1936320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936323 */     // MIs[0] policy
     /* 1936323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936333 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1936336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936359 */     // GIR_Coverage, 14938,
     /* 1936359 */     GIR_EraseRootFromParent_Done,
     /* 1936360 */   // Label 25870: @1936360
     /* 1936360 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1936451), // Rule ID 14939 //
     /* 1936365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1936376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1936379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1936382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936411 */     // MIs[0] round
     /* 1936411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936414 */     // MIs[0] policy
     /* 1936414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1936427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936450 */     // GIR_Coverage, 14939,
     /* 1936450 */     GIR_EraseRootFromParent_Done,
     /* 1936451 */   // Label 25871: @1936451
     /* 1936451 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1936542), // Rule ID 14942 //
     /* 1936456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1936467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1936470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1936473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1936482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936502 */     // MIs[0] round
     /* 1936502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936505 */     // MIs[0] policy
     /* 1936505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1936518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936541 */     // GIR_Coverage, 14942,
     /* 1936541 */     GIR_EraseRootFromParent_Done,
     /* 1936542 */   // Label 25872: @1936542
     /* 1936542 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1936633), // Rule ID 14943 //
     /* 1936547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1936558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1936561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1936564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936593 */     // MIs[0] round
     /* 1936593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936596 */     // MIs[0] policy
     /* 1936596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1936609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936632 */     // GIR_Coverage, 14943,
     /* 1936632 */     GIR_EraseRootFromParent_Done,
     /* 1936633 */   // Label 25873: @1936633
     /* 1936633 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1936724), // Rule ID 14946 //
     /* 1936638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1936641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1936649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1936652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1936655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1936664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936684 */     // MIs[0] round
     /* 1936684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936687 */     // MIs[0] policy
     /* 1936687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936697 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1936700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936723 */     // GIR_Coverage, 14946,
     /* 1936723 */     GIR_EraseRootFromParent_Done,
     /* 1936724 */   // Label 25874: @1936724
     /* 1936724 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1936815), // Rule ID 14947 //
     /* 1936729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1936732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1936740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1936743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1936746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936775 */     // MIs[0] round
     /* 1936775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936778 */     // MIs[0] policy
     /* 1936778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 1936791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936814 */     // GIR_Coverage, 14947,
     /* 1936814 */     GIR_EraseRootFromParent_Done,
     /* 1936815 */   // Label 25875: @1936815
     /* 1936815 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1936906), // Rule ID 14950 //
     /* 1936820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1936823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1936831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1936834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1936837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1936846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936866 */     // MIs[0] round
     /* 1936866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936869 */     // MIs[0] policy
     /* 1936869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1936882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936905 */     // GIR_Coverage, 14950,
     /* 1936905 */     GIR_EraseRootFromParent_Done,
     /* 1936906 */   // Label 25876: @1936906
     /* 1936906 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1936997), // Rule ID 14951 //
     /* 1936911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1936914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1936919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1936922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1936925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1936928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1936937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936957 */     // MIs[0] round
     /* 1936957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1936960 */     // MIs[0] policy
     /* 1936960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1936963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 1936973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1936985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1936995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936996 */     // GIR_Coverage, 14951,
     /* 1936996 */     GIR_EraseRootFromParent_Done,
     /* 1936997 */   // Label 25877: @1936997
     /* 1936997 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1937088), // Rule ID 14954 //
     /* 1937002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1937010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1937013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1937016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1937019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937048 */     // MIs[0] round
     /* 1937048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937051 */     // MIs[0] policy
     /* 1937051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1937064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937087 */     // GIR_Coverage, 14954,
     /* 1937087 */     GIR_EraseRootFromParent_Done,
     /* 1937088 */   // Label 25878: @1937088
     /* 1937088 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1937179), // Rule ID 14955 //
     /* 1937093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1937096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 1937101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1937104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1937107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1937110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1937119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937139 */     // MIs[0] round
     /* 1937139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937142 */     // MIs[0] policy
     /* 1937142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10832:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 1937155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937178 */     // GIR_Coverage, 14955,
     /* 1937178 */     GIR_EraseRootFromParent_Done,
     /* 1937179 */   // Label 25879: @1937179
     /* 1937179 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1937270), // Rule ID 14958 //
     /* 1937184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1937195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1937198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1937201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1937204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937230 */     // MIs[0] round
     /* 1937230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937233 */     // MIs[0] policy
     /* 1937233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937243 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 1937246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937269 */     // GIR_Coverage, 14958,
     /* 1937269 */     GIR_EraseRootFromParent_Done,
     /* 1937270 */   // Label 25880: @1937270
     /* 1937270 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1937361), // Rule ID 14959 //
     /* 1937275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1937286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1937289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1937292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1937295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1937301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937321 */     // MIs[0] round
     /* 1937321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937324 */     // MIs[0] policy
     /* 1937324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 1937337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937360 */     // GIR_Coverage, 14959,
     /* 1937360 */     GIR_EraseRootFromParent_Done,
     /* 1937361 */   // Label 25881: @1937361
     /* 1937361 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1937452), // Rule ID 14962 //
     /* 1937366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1937377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1937380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1937383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1937386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937412 */     // MIs[0] round
     /* 1937412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937415 */     // MIs[0] policy
     /* 1937415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937425 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 1937428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937451 */     // GIR_Coverage, 14962,
     /* 1937451 */     GIR_EraseRootFromParent_Done,
     /* 1937452 */   // Label 25882: @1937452
     /* 1937452 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1937543), // Rule ID 14963 //
     /* 1937457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1937468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1937471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1937474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1937477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1937483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937503 */     // MIs[0] round
     /* 1937503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937506 */     // MIs[0] policy
     /* 1937506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937516 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 1937519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937542 */     // GIR_Coverage, 14963,
     /* 1937542 */     GIR_EraseRootFromParent_Done,
     /* 1937543 */   // Label 25883: @1937543
     /* 1937543 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1937634), // Rule ID 14966 //
     /* 1937548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1937559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1937562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1937565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1937568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937594 */     // MIs[0] round
     /* 1937594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937597 */     // MIs[0] policy
     /* 1937597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937607 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1937610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937633 */     // GIR_Coverage, 14966,
     /* 1937633 */     GIR_EraseRootFromParent_Done,
     /* 1937634 */   // Label 25884: @1937634
     /* 1937634 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1937725), // Rule ID 14967 //
     /* 1937639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1937650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1937653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1937656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1937659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1937665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937685 */     // MIs[0] round
     /* 1937685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937688 */     // MIs[0] policy
     /* 1937688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1937701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937724 */     // GIR_Coverage, 14967,
     /* 1937724 */     GIR_EraseRootFromParent_Done,
     /* 1937725 */   // Label 25885: @1937725
     /* 1937725 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1937816), // Rule ID 14970 //
     /* 1937730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1937741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1937744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1937747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1937750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937776 */     // MIs[0] round
     /* 1937776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937779 */     // MIs[0] policy
     /* 1937779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 1937792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937815 */     // GIR_Coverage, 14970,
     /* 1937815 */     GIR_EraseRootFromParent_Done,
     /* 1937816 */   // Label 25886: @1937816
     /* 1937816 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1937907), // Rule ID 14971 //
     /* 1937821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1937832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1937835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1937838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1937841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1937847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937867 */     // MIs[0] round
     /* 1937867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937870 */     // MIs[0] policy
     /* 1937870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 1937883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937906 */     // GIR_Coverage, 14971,
     /* 1937906 */     GIR_EraseRootFromParent_Done,
     /* 1937907 */   // Label 25887: @1937907
     /* 1937907 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1937998), // Rule ID 14974 //
     /* 1937912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1937920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1937923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1937926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1937929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1937932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1937938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937958 */     // MIs[0] round
     /* 1937958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1937961 */     // MIs[0] policy
     /* 1937961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1937964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1937974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1937986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1937996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937997 */     // GIR_Coverage, 14974,
     /* 1937997 */     GIR_EraseRootFromParent_Done,
     /* 1937998 */   // Label 25888: @1937998
     /* 1937998 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1938089), // Rule ID 14975 //
     /* 1938003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1938023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938049 */     // MIs[0] round
     /* 1938049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938052 */     // MIs[0] policy
     /* 1938052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1938065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938088 */     // GIR_Coverage, 14975,
     /* 1938088 */     GIR_EraseRootFromParent_Done,
     /* 1938089 */   // Label 25889: @1938089
     /* 1938089 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1938180), // Rule ID 14978 //
     /* 1938094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1938114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1938120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938140 */     // MIs[0] round
     /* 1938140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938143 */     // MIs[0] policy
     /* 1938143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938153 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1938156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938179 */     // GIR_Coverage, 14978,
     /* 1938179 */     GIR_EraseRootFromParent_Done,
     /* 1938180 */   // Label 25890: @1938180
     /* 1938180 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1938271), // Rule ID 14979 //
     /* 1938185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1938205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938231 */     // MIs[0] round
     /* 1938231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938234 */     // MIs[0] policy
     /* 1938234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 1938247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938270 */     // GIR_Coverage, 14979,
     /* 1938270 */     GIR_EraseRootFromParent_Done,
     /* 1938271 */   // Label 25891: @1938271
     /* 1938271 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1938362), // Rule ID 14982 //
     /* 1938276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1938287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1938290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1938293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1938296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1938302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938322 */     // MIs[0] round
     /* 1938322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938325 */     // MIs[0] policy
     /* 1938325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938335 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1938358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938361 */     // GIR_Coverage, 14982,
     /* 1938361 */     GIR_EraseRootFromParent_Done,
     /* 1938362 */   // Label 25892: @1938362
     /* 1938362 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1938453), // Rule ID 14983 //
     /* 1938367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1938378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1938381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1938384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1938387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938413 */     // MIs[0] round
     /* 1938413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938416 */     // MIs[0] policy
     /* 1938416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1938449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938452 */     // GIR_Coverage, 14983,
     /* 1938452 */     GIR_EraseRootFromParent_Done,
     /* 1938453 */   // Label 25893: @1938453
     /* 1938453 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1938544), // Rule ID 14986 //
     /* 1938458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1938478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1938484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938504 */     // MIs[0] round
     /* 1938504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938507 */     // MIs[0] policy
     /* 1938507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938517 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938543 */     // GIR_Coverage, 14986,
     /* 1938543 */     GIR_EraseRootFromParent_Done,
     /* 1938544 */   // Label 25894: @1938544
     /* 1938544 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1938635), // Rule ID 14987 //
     /* 1938549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1938569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938595 */     // MIs[0] round
     /* 1938595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938598 */     // MIs[0] policy
     /* 1938598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938634 */     // GIR_Coverage, 14987,
     /* 1938634 */     GIR_EraseRootFromParent_Done,
     /* 1938635 */   // Label 25895: @1938635
     /* 1938635 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1938726), // Rule ID 14990 //
     /* 1938640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1938651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1938654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1938657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1938660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1938666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938686 */     // MIs[0] round
     /* 1938686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938689 */     // MIs[0] policy
     /* 1938689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938725 */     // GIR_Coverage, 14990,
     /* 1938725 */     GIR_EraseRootFromParent_Done,
     /* 1938726 */   // Label 25896: @1938726
     /* 1938726 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1938817), // Rule ID 14991 //
     /* 1938731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1938742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1938745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1938748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1938751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938777 */     // MIs[0] round
     /* 1938777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938780 */     // MIs[0] policy
     /* 1938780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938816 */     // GIR_Coverage, 14991,
     /* 1938816 */     GIR_EraseRootFromParent_Done,
     /* 1938817 */   // Label 25897: @1938817
     /* 1938817 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1938908), // Rule ID 14994 //
     /* 1938822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1938833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1938836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1938839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1938842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1938848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938868 */     // MIs[0] round
     /* 1938868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938871 */     // MIs[0] policy
     /* 1938871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938881 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938907 */     // GIR_Coverage, 14994,
     /* 1938907 */     GIR_EraseRootFromParent_Done,
     /* 1938908 */   // Label 25898: @1938908
     /* 1938908 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1938999), // Rule ID 14995 //
     /* 1938913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1938921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1938924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1938927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1938930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1938933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1938939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938959 */     // MIs[0] round
     /* 1938959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1938962 */     // MIs[0] policy
     /* 1938962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1938965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 1938975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1938987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1938997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938998 */     // GIR_Coverage, 14995,
     /* 1938998 */     GIR_EraseRootFromParent_Done,
     /* 1938999 */   // Label 25899: @1938999
     /* 1938999 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1939090), // Rule ID 14998 //
     /* 1939004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1939015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1939018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1939021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1939024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939050 */     // MIs[0] round
     /* 1939050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939053 */     // MIs[0] policy
     /* 1939053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939063 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1939066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939089 */     // GIR_Coverage, 14998,
     /* 1939089 */     GIR_EraseRootFromParent_Done,
     /* 1939090 */   // Label 25900: @1939090
     /* 1939090 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1939181), // Rule ID 14999 //
     /* 1939095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1939106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1939109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1939112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1939115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1939121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939141 */     // MIs[0] round
     /* 1939141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939144 */     // MIs[0] policy
     /* 1939144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1939157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939180 */     // GIR_Coverage, 14999,
     /* 1939180 */     GIR_EraseRootFromParent_Done,
     /* 1939181 */   // Label 25901: @1939181
     /* 1939181 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1939272), // Rule ID 15002 //
     /* 1939186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1939197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1939200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1939203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1939206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939232 */     // MIs[0] round
     /* 1939232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939235 */     // MIs[0] policy
     /* 1939235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939245 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1939248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939271 */     // GIR_Coverage, 15002,
     /* 1939271 */     GIR_EraseRootFromParent_Done,
     /* 1939272 */   // Label 25902: @1939272
     /* 1939272 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1939363), // Rule ID 15003 //
     /* 1939277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1939288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1939291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1939294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1939297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1939303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939323 */     // MIs[0] round
     /* 1939323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939326 */     // MIs[0] policy
     /* 1939326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939336 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1939339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939362 */     // GIR_Coverage, 15003,
     /* 1939362 */     GIR_EraseRootFromParent_Done,
     /* 1939363 */   // Label 25903: @1939363
     /* 1939363 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1939454), // Rule ID 15006 //
     /* 1939368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1939379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1939382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1939385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1939388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1939391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939414 */     // MIs[0] round
     /* 1939414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939417 */     // MIs[0] policy
     /* 1939417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1939430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939453 */     // GIR_Coverage, 15006,
     /* 1939453 */     GIR_EraseRootFromParent_Done,
     /* 1939454 */   // Label 25904: @1939454
     /* 1939454 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1939545), // Rule ID 15007 //
     /* 1939459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1939470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1939473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1939476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1939479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1939482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1939485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939505 */     // MIs[0] round
     /* 1939505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939508 */     // MIs[0] policy
     /* 1939508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1939521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939544 */     // GIR_Coverage, 15007,
     /* 1939544 */     GIR_EraseRootFromParent_Done,
     /* 1939545 */   // Label 25905: @1939545
     /* 1939545 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1939636), // Rule ID 15010 //
     /* 1939550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1939570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939596 */     // MIs[0] round
     /* 1939596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939599 */     // MIs[0] policy
     /* 1939599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1939612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939635 */     // GIR_Coverage, 15010,
     /* 1939635 */     GIR_EraseRootFromParent_Done,
     /* 1939636 */   // Label 25906: @1939636
     /* 1939636 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1939727), // Rule ID 15011 //
     /* 1939641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1939661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1939667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939687 */     // MIs[0] round
     /* 1939687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939690 */     // MIs[0] policy
     /* 1939690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1939703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939726 */     // GIR_Coverage, 15011,
     /* 1939726 */     GIR_EraseRootFromParent_Done,
     /* 1939727 */   // Label 25907: @1939727
     /* 1939727 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1939818), // Rule ID 15014 //
     /* 1939732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1939752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939778 */     // MIs[0] round
     /* 1939778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939781 */     // MIs[0] policy
     /* 1939781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939791 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1939794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939817 */     // GIR_Coverage, 15014,
     /* 1939817 */     GIR_EraseRootFromParent_Done,
     /* 1939818 */   // Label 25908: @1939818
     /* 1939818 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1939909), // Rule ID 15015 //
     /* 1939823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1939843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1939849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939869 */     // MIs[0] round
     /* 1939869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939872 */     // MIs[0] policy
     /* 1939872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1939885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939908 */     // GIR_Coverage, 15015,
     /* 1939908 */     GIR_EraseRootFromParent_Done,
     /* 1939909 */   // Label 25909: @1939909
     /* 1939909 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1940000), // Rule ID 15018 //
     /* 1939914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1939922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1939925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1939928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1939931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1939934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1939940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939960 */     // MIs[0] round
     /* 1939960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1939963 */     // MIs[0] policy
     /* 1939963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1939966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939973 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1939976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1939988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1939998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939999 */     // GIR_Coverage, 15018,
     /* 1939999 */     GIR_EraseRootFromParent_Done,
     /* 1940000 */   // Label 25910: @1940000
     /* 1940000 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1940091), // Rule ID 15019 //
     /* 1940005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1940025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940051 */     // MIs[0] round
     /* 1940051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940054 */     // MIs[0] policy
     /* 1940054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1940067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940090 */     // GIR_Coverage, 15019,
     /* 1940090 */     GIR_EraseRootFromParent_Done,
     /* 1940091 */   // Label 25911: @1940091
     /* 1940091 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1940182), // Rule ID 15022 //
     /* 1940096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1940116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1940122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940142 */     // MIs[0] round
     /* 1940142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940145 */     // MIs[0] policy
     /* 1940145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1940158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940181 */     // GIR_Coverage, 15022,
     /* 1940181 */     GIR_EraseRootFromParent_Done,
     /* 1940182 */   // Label 25912: @1940182
     /* 1940182 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1940273), // Rule ID 15023 //
     /* 1940187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1940207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940233 */     // MIs[0] round
     /* 1940233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940236 */     // MIs[0] policy
     /* 1940236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1940249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940272 */     // GIR_Coverage, 15023,
     /* 1940272 */     GIR_EraseRootFromParent_Done,
     /* 1940273 */   // Label 25913: @1940273
     /* 1940273 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1940364), // Rule ID 15026 //
     /* 1940278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1940298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1940304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940324 */     // MIs[0] round
     /* 1940324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940327 */     // MIs[0] policy
     /* 1940327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940337 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1940340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940363 */     // GIR_Coverage, 15026,
     /* 1940363 */     GIR_EraseRootFromParent_Done,
     /* 1940364 */   // Label 25914: @1940364
     /* 1940364 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1940455), // Rule ID 15027 //
     /* 1940369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1940389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940415 */     // MIs[0] round
     /* 1940415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940418 */     // MIs[0] policy
     /* 1940418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1940431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940454 */     // GIR_Coverage, 15027,
     /* 1940454 */     GIR_EraseRootFromParent_Done,
     /* 1940455 */   // Label 25915: @1940455
     /* 1940455 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1940546), // Rule ID 15030 //
     /* 1940460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1940480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1940486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940506 */     // MIs[0] round
     /* 1940506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940509 */     // MIs[0] policy
     /* 1940509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1940522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940545 */     // GIR_Coverage, 15030,
     /* 1940545 */     GIR_EraseRootFromParent_Done,
     /* 1940546 */   // Label 25916: @1940546
     /* 1940546 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1940637), // Rule ID 15031 //
     /* 1940551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1940571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940597 */     // MIs[0] round
     /* 1940597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940600 */     // MIs[0] policy
     /* 1940600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1940613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940636 */     // GIR_Coverage, 15031,
     /* 1940636 */     GIR_EraseRootFromParent_Done,
     /* 1940637 */   // Label 25917: @1940637
     /* 1940637 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1940728), // Rule ID 15034 //
     /* 1940642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1940662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1940668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940688 */     // MIs[0] round
     /* 1940688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940691 */     // MIs[0] policy
     /* 1940691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1940704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940727 */     // GIR_Coverage, 15034,
     /* 1940727 */     GIR_EraseRootFromParent_Done,
     /* 1940728 */   // Label 25918: @1940728
     /* 1940728 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1940819), // Rule ID 15035 //
     /* 1940733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1940753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940779 */     // MIs[0] round
     /* 1940779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940782 */     // MIs[0] policy
     /* 1940782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 1940795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940818 */     // GIR_Coverage, 15035,
     /* 1940818 */     GIR_EraseRootFromParent_Done,
     /* 1940819 */   // Label 25919: @1940819
     /* 1940819 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1940910), // Rule ID 15038 //
     /* 1940824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1940844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1940850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940870 */     // MIs[0] round
     /* 1940870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940873 */     // MIs[0] policy
     /* 1940873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1940886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940909 */     // GIR_Coverage, 15038,
     /* 1940909 */     GIR_EraseRootFromParent_Done,
     /* 1940910 */   // Label 25920: @1940910
     /* 1940910 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1941001), // Rule ID 15039 //
     /* 1940915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1940923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1940935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1940941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940961 */     // MIs[0] round
     /* 1940961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1940964 */     // MIs[0] policy
     /* 1940964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1940967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 1940977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1940989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1940999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941000 */     // GIR_Coverage, 15039,
     /* 1941000 */     GIR_EraseRootFromParent_Done,
     /* 1941001 */   // Label 25921: @1941001
     /* 1941001 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1941092), // Rule ID 15042 //
     /* 1941006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1941026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941052 */     // MIs[0] round
     /* 1941052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941055 */     // MIs[0] policy
     /* 1941055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941065 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1941068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941091 */     // GIR_Coverage, 15042,
     /* 1941091 */     GIR_EraseRootFromParent_Done,
     /* 1941092 */   // Label 25922: @1941092
     /* 1941092 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1941183), // Rule ID 15043 //
     /* 1941097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1941117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1941123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941143 */     // MIs[0] round
     /* 1941143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941146 */     // MIs[0] policy
     /* 1941146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 1941159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941182 */     // GIR_Coverage, 15043,
     /* 1941182 */     GIR_EraseRootFromParent_Done,
     /* 1941183 */   // Label 25923: @1941183
     /* 1941183 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1941274), // Rule ID 15046 //
     /* 1941188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1941199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1941202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1941205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941234 */     // MIs[0] round
     /* 1941234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941237 */     // MIs[0] policy
     /* 1941237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941247 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 1941250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941273 */     // GIR_Coverage, 15046,
     /* 1941273 */     GIR_EraseRootFromParent_Done,
     /* 1941274 */   // Label 25924: @1941274
     /* 1941274 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1941365), // Rule ID 15047 //
     /* 1941279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1941290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1941293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1941296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1941305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941325 */     // MIs[0] round
     /* 1941325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941328 */     // MIs[0] policy
     /* 1941328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941338 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 1941341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941364 */     // GIR_Coverage, 15047,
     /* 1941364 */     GIR_EraseRootFromParent_Done,
     /* 1941365 */   // Label 25925: @1941365
     /* 1941365 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1941456), // Rule ID 15050 //
     /* 1941370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1941381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1941384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1941387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941416 */     // MIs[0] round
     /* 1941416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941419 */     // MIs[0] policy
     /* 1941419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 1941432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941455 */     // GIR_Coverage, 15050,
     /* 1941455 */     GIR_EraseRootFromParent_Done,
     /* 1941456 */   // Label 25926: @1941456
     /* 1941456 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1941547), // Rule ID 15051 //
     /* 1941461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1941472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1941475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1941478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1941487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941507 */     // MIs[0] round
     /* 1941507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941510 */     // MIs[0] policy
     /* 1941510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 1941523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941546 */     // GIR_Coverage, 15051,
     /* 1941546 */     GIR_EraseRootFromParent_Done,
     /* 1941547 */   // Label 25927: @1941547
     /* 1941547 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1941638), // Rule ID 15054 //
     /* 1941552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1941563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1941566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1941569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941598 */     // MIs[0] round
     /* 1941598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941601 */     // MIs[0] policy
     /* 1941601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941611 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1941614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941637 */     // GIR_Coverage, 15054,
     /* 1941637 */     GIR_EraseRootFromParent_Done,
     /* 1941638 */   // Label 25928: @1941638
     /* 1941638 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1941729), // Rule ID 15055 //
     /* 1941643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1941654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1941657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1941660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1941669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941689 */     // MIs[0] round
     /* 1941689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941692 */     // MIs[0] policy
     /* 1941692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1941705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941728 */     // GIR_Coverage, 15055,
     /* 1941728 */     GIR_EraseRootFromParent_Done,
     /* 1941729 */   // Label 25929: @1941729
     /* 1941729 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1941820), // Rule ID 15058 //
     /* 1941734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941780 */     // MIs[0] round
     /* 1941780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941783 */     // MIs[0] policy
     /* 1941783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941793 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 1941796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941819 */     // GIR_Coverage, 15058,
     /* 1941819 */     GIR_EraseRootFromParent_Done,
     /* 1941820 */   // Label 25930: @1941820
     /* 1941820 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1941911), // Rule ID 15059 //
     /* 1941825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1941851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941871 */     // MIs[0] round
     /* 1941871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941874 */     // MIs[0] policy
     /* 1941874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 1941887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1941909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941910 */     // GIR_Coverage, 15059,
     /* 1941910 */     GIR_EraseRootFromParent_Done,
     /* 1941911 */   // Label 25931: @1941911
     /* 1941911 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1942002), // Rule ID 15062 //
     /* 1941916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1941924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1941942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941962 */     // MIs[0] round
     /* 1941962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1941965 */     // MIs[0] policy
     /* 1941965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1941968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941975 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1941978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1941990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942001 */     // GIR_Coverage, 15062,
     /* 1942001 */     GIR_EraseRootFromParent_Done,
     /* 1942002 */   // Label 25932: @1942002
     /* 1942002 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1942093), // Rule ID 15063 //
     /* 1942007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1942018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1942021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1942024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942053 */     // MIs[0] round
     /* 1942053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942056 */     // MIs[0] policy
     /* 1942056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1942069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942092 */     // GIR_Coverage, 15063,
     /* 1942092 */     GIR_EraseRootFromParent_Done,
     /* 1942093 */   // Label 25933: @1942093
     /* 1942093 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1942184), // Rule ID 15066 //
     /* 1942098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1942109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1942112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1942115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1942124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942144 */     // MIs[0] round
     /* 1942144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942147 */     // MIs[0] policy
     /* 1942147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1942160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942183 */     // GIR_Coverage, 15066,
     /* 1942183 */     GIR_EraseRootFromParent_Done,
     /* 1942184 */   // Label 25934: @1942184
     /* 1942184 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1942275), // Rule ID 15067 //
     /* 1942189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1942200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1942203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1942206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942235 */     // MIs[0] round
     /* 1942235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942238 */     // MIs[0] policy
     /* 1942238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 1942251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942274 */     // GIR_Coverage, 15067,
     /* 1942274 */     GIR_EraseRootFromParent_Done,
     /* 1942275 */   // Label 25935: @1942275
     /* 1942275 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1942366), // Rule ID 15070 //
     /* 1942280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1942291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1942294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1942297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1942306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942326 */     // MIs[0] round
     /* 1942326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942329 */     // MIs[0] policy
     /* 1942329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1942362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942365 */     // GIR_Coverage, 15070,
     /* 1942365 */     GIR_EraseRootFromParent_Done,
     /* 1942366 */   // Label 25936: @1942366
     /* 1942366 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1942457), // Rule ID 15071 //
     /* 1942371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1942382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1942385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1942388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942417 */     // MIs[0] round
     /* 1942417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942420 */     // MIs[0] policy
     /* 1942420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10854:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1942453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942456 */     // GIR_Coverage, 15071,
     /* 1942456 */     GIR_EraseRootFromParent_Done,
     /* 1942457 */   // Label 25937: @1942457
     /* 1942457 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1942548), // Rule ID 15074 //
     /* 1942462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1942473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1942476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1942479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1942488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942508 */     // MIs[0] round
     /* 1942508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942511 */     // MIs[0] policy
     /* 1942511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942547 */     // GIR_Coverage, 15074,
     /* 1942547 */     GIR_EraseRootFromParent_Done,
     /* 1942548 */   // Label 25938: @1942548
     /* 1942548 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1942639), // Rule ID 15075 //
     /* 1942553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1942564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1942567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1942570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942599 */     // MIs[0] round
     /* 1942599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942602 */     // MIs[0] policy
     /* 1942602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942638 */     // GIR_Coverage, 15075,
     /* 1942638 */     GIR_EraseRootFromParent_Done,
     /* 1942639 */   // Label 25939: @1942639
     /* 1942639 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1942730), // Rule ID 15078 //
     /* 1942644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1942670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942690 */     // MIs[0] round
     /* 1942690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942693 */     // MIs[0] policy
     /* 1942693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942703 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942729 */     // GIR_Coverage, 15078,
     /* 1942729 */     GIR_EraseRootFromParent_Done,
     /* 1942730 */   // Label 25940: @1942730
     /* 1942730 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1942821), // Rule ID 15079 //
     /* 1942735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942781 */     // MIs[0] round
     /* 1942781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942784 */     // MIs[0] policy
     /* 1942784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942820 */     // GIR_Coverage, 15079,
     /* 1942820 */     GIR_EraseRootFromParent_Done,
     /* 1942821 */   // Label 25941: @1942821
     /* 1942821 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1942912), // Rule ID 15082 //
     /* 1942826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1942829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1942852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942872 */     // MIs[0] round
     /* 1942872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942875 */     // MIs[0] policy
     /* 1942875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942885 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1942910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942911 */     // GIR_Coverage, 15082,
     /* 1942911 */     GIR_EraseRootFromParent_Done,
     /* 1942912 */   // Label 25942: @1942912
     /* 1942912 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1943003), // Rule ID 15083 //
     /* 1942917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1942920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1942925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1942943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942963 */     // MIs[0] round
     /* 1942963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1942966 */     // MIs[0] policy
     /* 1942966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1942969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 1942979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1942991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943002 */     // GIR_Coverage, 15083,
     /* 1943002 */     GIR_EraseRootFromParent_Done,
     /* 1943003 */   // Label 25943: @1943003
     /* 1943003 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1943094), // Rule ID 15086 //
     /* 1943008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1943019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1943022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1943025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943054 */     // MIs[0] round
     /* 1943054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943057 */     // MIs[0] policy
     /* 1943057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1943070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943093 */     // GIR_Coverage, 15086,
     /* 1943093 */     GIR_EraseRootFromParent_Done,
     /* 1943094 */   // Label 25944: @1943094
     /* 1943094 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1943185), // Rule ID 15087 //
     /* 1943099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1943110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1943113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1943116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1943125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943145 */     // MIs[0] round
     /* 1943145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943148 */     // MIs[0] policy
     /* 1943148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1943161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943184 */     // GIR_Coverage, 15087,
     /* 1943184 */     GIR_EraseRootFromParent_Done,
     /* 1943185 */   // Label 25945: @1943185
     /* 1943185 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1943276), // Rule ID 15090 //
     /* 1943190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1943201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1943204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1943207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1943213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943236 */     // MIs[0] round
     /* 1943236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943239 */     // MIs[0] policy
     /* 1943239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943249 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1943252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943275 */     // GIR_Coverage, 15090,
     /* 1943275 */     GIR_EraseRootFromParent_Done,
     /* 1943276 */   // Label 25946: @1943276
     /* 1943276 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1943367), // Rule ID 15091 //
     /* 1943281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1943292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1943295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1943298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1943304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1943307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943327 */     // MIs[0] round
     /* 1943327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943330 */     // MIs[0] policy
     /* 1943330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1943343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943366 */     // GIR_Coverage, 15091,
     /* 1943366 */     GIR_EraseRootFromParent_Done,
     /* 1943367 */   // Label 25947: @1943367
     /* 1943367 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1943458), // Rule ID 15094 //
     /* 1943372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1943383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1943386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1943389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1943395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943418 */     // MIs[0] round
     /* 1943418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943421 */     // MIs[0] policy
     /* 1943421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943431 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1943434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943457 */     // GIR_Coverage, 15094,
     /* 1943457 */     GIR_EraseRootFromParent_Done,
     /* 1943458 */   // Label 25948: @1943458
     /* 1943458 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1943549), // Rule ID 15095 //
     /* 1943463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1943474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1943477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1943480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1943486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1943489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943509 */     // MIs[0] round
     /* 1943509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943512 */     // MIs[0] policy
     /* 1943512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1943525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943548 */     // GIR_Coverage, 15095,
     /* 1943548 */     GIR_EraseRootFromParent_Done,
     /* 1943549 */   // Label 25949: @1943549
     /* 1943549 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1943640), // Rule ID 15098 //
     /* 1943554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1943565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1943568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1943571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943600 */     // MIs[0] round
     /* 1943600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943603 */     // MIs[0] policy
     /* 1943603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1943616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943639 */     // GIR_Coverage, 15098,
     /* 1943639 */     GIR_EraseRootFromParent_Done,
     /* 1943640 */   // Label 25950: @1943640
     /* 1943640 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1943731), // Rule ID 15099 //
     /* 1943645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1943656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1943659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1943662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1943671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943691 */     // MIs[0] round
     /* 1943691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943694 */     // MIs[0] policy
     /* 1943694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1943707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943730 */     // GIR_Coverage, 15099,
     /* 1943730 */     GIR_EraseRootFromParent_Done,
     /* 1943731 */   // Label 25951: @1943731
     /* 1943731 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1943822), // Rule ID 15102 //
     /* 1943736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1943747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1943750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1943753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943782 */     // MIs[0] round
     /* 1943782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943785 */     // MIs[0] policy
     /* 1943785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943795 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1943798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943821 */     // GIR_Coverage, 15102,
     /* 1943821 */     GIR_EraseRootFromParent_Done,
     /* 1943822 */   // Label 25952: @1943822
     /* 1943822 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1943913), // Rule ID 15103 //
     /* 1943827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1943838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1943841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1943844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1943853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943873 */     // MIs[0] round
     /* 1943873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943876 */     // MIs[0] policy
     /* 1943876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1943889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1943911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943912 */     // GIR_Coverage, 15103,
     /* 1943912 */     GIR_EraseRootFromParent_Done,
     /* 1943913 */   // Label 25953: @1943913
     /* 1943913 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1944004), // Rule ID 15106 //
     /* 1943918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1943926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1943929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1943932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1943935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1943941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1943944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943964 */     // MIs[0] round
     /* 1943964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1943967 */     // MIs[0] policy
     /* 1943967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1943970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943977 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1943980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1943992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944003 */     // GIR_Coverage, 15106,
     /* 1944003 */     GIR_EraseRootFromParent_Done,
     /* 1944004 */   // Label 25954: @1944004
     /* 1944004 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1944095), // Rule ID 15107 //
     /* 1944009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1944020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1944023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1944026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1944032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944055 */     // MIs[0] round
     /* 1944055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944058 */     // MIs[0] policy
     /* 1944058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1944071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944094 */     // GIR_Coverage, 15107,
     /* 1944094 */     GIR_EraseRootFromParent_Done,
     /* 1944095 */   // Label 25955: @1944095
     /* 1944095 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1944186), // Rule ID 15110 //
     /* 1944100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1944111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1944114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1944117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1944126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944146 */     // MIs[0] round
     /* 1944146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944149 */     // MIs[0] policy
     /* 1944149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1944162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944185 */     // GIR_Coverage, 15110,
     /* 1944185 */     GIR_EraseRootFromParent_Done,
     /* 1944186 */   // Label 25956: @1944186
     /* 1944186 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1944277), // Rule ID 15111 //
     /* 1944191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1944202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1944205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1944208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944237 */     // MIs[0] round
     /* 1944237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944240 */     // MIs[0] policy
     /* 1944240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1944253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944276 */     // GIR_Coverage, 15111,
     /* 1944276 */     GIR_EraseRootFromParent_Done,
     /* 1944277 */   // Label 25957: @1944277
     /* 1944277 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1944368), // Rule ID 15114 //
     /* 1944282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1944293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1944296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1944299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1944308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944328 */     // MIs[0] round
     /* 1944328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944331 */     // MIs[0] policy
     /* 1944331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944341 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1944344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944367 */     // GIR_Coverage, 15114,
     /* 1944367 */     GIR_EraseRootFromParent_Done,
     /* 1944368 */   // Label 25958: @1944368
     /* 1944368 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1944459), // Rule ID 15115 //
     /* 1944373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1944384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1944387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1944390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944419 */     // MIs[0] round
     /* 1944419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944422 */     // MIs[0] policy
     /* 1944422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944432 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1944435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944458 */     // GIR_Coverage, 15115,
     /* 1944458 */     GIR_EraseRootFromParent_Done,
     /* 1944459 */   // Label 25959: @1944459
     /* 1944459 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1944550), // Rule ID 15118 //
     /* 1944464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1944475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1944478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1944481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1944490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944510 */     // MIs[0] round
     /* 1944510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944513 */     // MIs[0] policy
     /* 1944513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944523 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1944526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944549 */     // GIR_Coverage, 15118,
     /* 1944549 */     GIR_EraseRootFromParent_Done,
     /* 1944550 */   // Label 25960: @1944550
     /* 1944550 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1944641), // Rule ID 15119 //
     /* 1944555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1944566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1944569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1944572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944601 */     // MIs[0] round
     /* 1944601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944604 */     // MIs[0] policy
     /* 1944604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1944617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944640 */     // GIR_Coverage, 15119,
     /* 1944640 */     GIR_EraseRootFromParent_Done,
     /* 1944641 */   // Label 25961: @1944641
     /* 1944641 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1944732), // Rule ID 15122 //
     /* 1944646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1944649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1944657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1944660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1944663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1944672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944692 */     // MIs[0] round
     /* 1944692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944695 */     // MIs[0] policy
     /* 1944695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1944708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944731 */     // GIR_Coverage, 15122,
     /* 1944731 */     GIR_EraseRootFromParent_Done,
     /* 1944732 */   // Label 25962: @1944732
     /* 1944732 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1944823), // Rule ID 15123 //
     /* 1944737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1944740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1944748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1944751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1944754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944783 */     // MIs[0] round
     /* 1944783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944786 */     // MIs[0] policy
     /* 1944786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 1944799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944822 */     // GIR_Coverage, 15123,
     /* 1944822 */     GIR_EraseRootFromParent_Done,
     /* 1944823 */   // Label 25963: @1944823
     /* 1944823 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1944914), // Rule ID 15126 //
     /* 1944828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1944831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1944839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1944842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1944845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1944854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944874 */     // MIs[0] round
     /* 1944874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944877 */     // MIs[0] policy
     /* 1944877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944887 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1944890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1944912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944913 */     // GIR_Coverage, 15126,
     /* 1944913 */     GIR_EraseRootFromParent_Done,
     /* 1944914 */   // Label 25964: @1944914
     /* 1944914 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1945005), // Rule ID 15127 //
     /* 1944919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1944922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1944927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1944930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1944933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1944936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1944945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944965 */     // MIs[0] round
     /* 1944965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1944968 */     // MIs[0] policy
     /* 1944968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1944971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 1944981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1944993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945004 */     // GIR_Coverage, 15127,
     /* 1945004 */     GIR_EraseRootFromParent_Done,
     /* 1945005 */   // Label 25965: @1945005
     /* 1945005 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1945096), // Rule ID 15130 //
     /* 1945010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1945013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1945018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945056 */     // MIs[0] round
     /* 1945056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945059 */     // MIs[0] policy
     /* 1945059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1945072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945095 */     // GIR_Coverage, 15130,
     /* 1945095 */     GIR_EraseRootFromParent_Done,
     /* 1945096 */   // Label 25966: @1945096
     /* 1945096 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1945187), // Rule ID 15131 //
     /* 1945101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1945104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 1945109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1945127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945147 */     // MIs[0] round
     /* 1945147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945150 */     // MIs[0] policy
     /* 1945150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945160 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 1945163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945186 */     // GIR_Coverage, 15131,
     /* 1945186 */     GIR_EraseRootFromParent_Done,
     /* 1945187 */   // Label 25967: @1945187
     /* 1945187 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1945278), // Rule ID 15134 //
     /* 1945192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1945203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1945206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1945209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1945212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945238 */     // MIs[0] round
     /* 1945238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945241 */     // MIs[0] policy
     /* 1945241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945251 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 1945254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945277 */     // GIR_Coverage, 15134,
     /* 1945277 */     GIR_EraseRootFromParent_Done,
     /* 1945278 */   // Label 25968: @1945278
     /* 1945278 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1945369), // Rule ID 15135 //
     /* 1945283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1945294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1945297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1945300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1945303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1945309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945329 */     // MIs[0] round
     /* 1945329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945332 */     // MIs[0] policy
     /* 1945332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 1945345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945368 */     // GIR_Coverage, 15135,
     /* 1945368 */     GIR_EraseRootFromParent_Done,
     /* 1945369 */   // Label 25969: @1945369
     /* 1945369 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1945460), // Rule ID 15138 //
     /* 1945374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1945385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1945388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1945391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1945394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945420 */     // MIs[0] round
     /* 1945420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945423 */     // MIs[0] policy
     /* 1945423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945433 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 1945436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945459 */     // GIR_Coverage, 15138,
     /* 1945459 */     GIR_EraseRootFromParent_Done,
     /* 1945460 */   // Label 25970: @1945460
     /* 1945460 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1945551), // Rule ID 15139 //
     /* 1945465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1945476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1945479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1945482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1945485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1945491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945511 */     // MIs[0] round
     /* 1945511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945514 */     // MIs[0] policy
     /* 1945514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945524 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 1945527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945550 */     // GIR_Coverage, 15139,
     /* 1945550 */     GIR_EraseRootFromParent_Done,
     /* 1945551 */   // Label 25971: @1945551
     /* 1945551 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1945642), // Rule ID 15142 //
     /* 1945556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1945567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1945570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1945573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1945576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945602 */     // MIs[0] round
     /* 1945602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945605 */     // MIs[0] policy
     /* 1945605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945615 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1945618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945641 */     // GIR_Coverage, 15142,
     /* 1945641 */     GIR_EraseRootFromParent_Done,
     /* 1945642 */   // Label 25972: @1945642
     /* 1945642 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1945733), // Rule ID 15143 //
     /* 1945647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1945658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1945661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1945664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1945667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1945673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945693 */     // MIs[0] round
     /* 1945693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945696 */     // MIs[0] policy
     /* 1945696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1945709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945732 */     // GIR_Coverage, 15143,
     /* 1945732 */     GIR_EraseRootFromParent_Done,
     /* 1945733 */   // Label 25973: @1945733
     /* 1945733 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1945824), // Rule ID 15146 //
     /* 1945738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1945749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1945752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1945755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1945758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945784 */     // MIs[0] round
     /* 1945784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945787 */     // MIs[0] policy
     /* 1945787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945797 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 1945800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945823 */     // GIR_Coverage, 15146,
     /* 1945823 */     GIR_EraseRootFromParent_Done,
     /* 1945824 */   // Label 25974: @1945824
     /* 1945824 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1945915), // Rule ID 15147 //
     /* 1945829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1945840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1945843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1945846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1945849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1945855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945875 */     // MIs[0] round
     /* 1945875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945878 */     // MIs[0] policy
     /* 1945878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945888 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 1945891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1945913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945914 */     // GIR_Coverage, 15147,
     /* 1945914 */     GIR_EraseRootFromParent_Done,
     /* 1945915 */   // Label 25975: @1945915
     /* 1945915 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1946006), // Rule ID 15150 //
     /* 1945920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1945928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1945931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1945934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1945937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1945940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1945946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945966 */     // MIs[0] round
     /* 1945966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1945969 */     // MIs[0] policy
     /* 1945969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1945972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945979 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1945982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1945994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946005 */     // GIR_Coverage, 15150,
     /* 1946005 */     GIR_EraseRootFromParent_Done,
     /* 1946006 */   // Label 25976: @1946006
     /* 1946006 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1946097), // Rule ID 15151 //
     /* 1946011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1946022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1946025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1946028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1946031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946057 */     // MIs[0] round
     /* 1946057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946060 */     // MIs[0] policy
     /* 1946060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1946073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946096 */     // GIR_Coverage, 15151,
     /* 1946096 */     GIR_EraseRootFromParent_Done,
     /* 1946097 */   // Label 25977: @1946097
     /* 1946097 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1946188), // Rule ID 15154 //
     /* 1946102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1946113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1946116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1946119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1946122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1946128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946148 */     // MIs[0] round
     /* 1946148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946151 */     // MIs[0] policy
     /* 1946151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1946164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946187 */     // GIR_Coverage, 15154,
     /* 1946187 */     GIR_EraseRootFromParent_Done,
     /* 1946188 */   // Label 25978: @1946188
     /* 1946188 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1946279), // Rule ID 15155 //
     /* 1946193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1946204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1946207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1946210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1946213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946239 */     // MIs[0] round
     /* 1946239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946242 */     // MIs[0] policy
     /* 1946242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 1946255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946278 */     // GIR_Coverage, 15155,
     /* 1946278 */     GIR_EraseRootFromParent_Done,
     /* 1946279 */   // Label 25979: @1946279
     /* 1946279 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1946370), // Rule ID 15158 //
     /* 1946284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1946295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1946298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1946301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1946304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1946310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946330 */     // MIs[0] round
     /* 1946330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946333 */     // MIs[0] policy
     /* 1946333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946343 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946369 */     // GIR_Coverage, 15158,
     /* 1946369 */     GIR_EraseRootFromParent_Done,
     /* 1946370 */   // Label 25980: @1946370
     /* 1946370 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1946461), // Rule ID 15159 //
     /* 1946375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1946386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1946389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1946392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1946395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946421 */     // MIs[0] round
     /* 1946421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946424 */     // MIs[0] policy
     /* 1946424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946460 */     // GIR_Coverage, 15159,
     /* 1946460 */     GIR_EraseRootFromParent_Done,
     /* 1946461 */   // Label 25981: @1946461
     /* 1946461 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1946552), // Rule ID 15162 //
     /* 1946466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1946477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1946480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1946483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1946486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1946492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946512 */     // MIs[0] round
     /* 1946512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946515 */     // MIs[0] policy
     /* 1946515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946551 */     // GIR_Coverage, 15162,
     /* 1946551 */     GIR_EraseRootFromParent_Done,
     /* 1946552 */   // Label 25982: @1946552
     /* 1946552 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1946643), // Rule ID 15163 //
     /* 1946557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1946568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1946571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1946574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1946577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946603 */     // MIs[0] round
     /* 1946603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946606 */     // MIs[0] policy
     /* 1946606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946642 */     // GIR_Coverage, 15163,
     /* 1946642 */     GIR_EraseRootFromParent_Done,
     /* 1946643 */   // Label 25983: @1946643
     /* 1946643 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1946734), // Rule ID 15166 //
     /* 1946648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1946659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1946662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1946665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1946668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1946674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946694 */     // MIs[0] round
     /* 1946694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946697 */     // MIs[0] policy
     /* 1946697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946733 */     // GIR_Coverage, 15166,
     /* 1946733 */     GIR_EraseRootFromParent_Done,
     /* 1946734 */   // Label 25984: @1946734
     /* 1946734 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1946825), // Rule ID 15167 //
     /* 1946739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1946750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1946753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1946756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1946759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946785 */     // MIs[0] round
     /* 1946785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946788 */     // MIs[0] policy
     /* 1946788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946824 */     // GIR_Coverage, 15167,
     /* 1946824 */     GIR_EraseRootFromParent_Done,
     /* 1946825 */   // Label 25985: @1946825
     /* 1946825 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1946916), // Rule ID 15170 //
     /* 1946830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1946833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1946841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1946844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1946847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1946850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1946856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946876 */     // MIs[0] round
     /* 1946876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946879 */     // MIs[0] policy
     /* 1946879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946889 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1946914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946915 */     // GIR_Coverage, 15170,
     /* 1946915 */     GIR_EraseRootFromParent_Done,
     /* 1946916 */   // Label 25986: @1946916
     /* 1946916 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1947007), // Rule ID 15171 //
     /* 1946921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1946924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1946929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1946932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1946935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1946938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1946941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1946947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946967 */     // MIs[0] round
     /* 1946967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1946970 */     // MIs[0] policy
     /* 1946970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1946973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 1946983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1946995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947006 */     // GIR_Coverage, 15171,
     /* 1947006 */     GIR_EraseRootFromParent_Done,
     /* 1947007 */   // Label 25987: @1947007
     /* 1947007 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1947098), // Rule ID 15174 //
     /* 1947012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947058 */     // MIs[0] round
     /* 1947058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947061 */     // MIs[0] policy
     /* 1947061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1947074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947097 */     // GIR_Coverage, 15174,
     /* 1947097 */     GIR_EraseRootFromParent_Done,
     /* 1947098 */   // Label 25988: @1947098
     /* 1947098 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1947189), // Rule ID 15175 //
     /* 1947103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1947129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947149 */     // MIs[0] round
     /* 1947149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947152 */     // MIs[0] policy
     /* 1947152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1947165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947188 */     // GIR_Coverage, 15175,
     /* 1947188 */     GIR_EraseRootFromParent_Done,
     /* 1947189 */   // Label 25989: @1947189
     /* 1947189 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1947280), // Rule ID 15178 //
     /* 1947194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1947205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1947208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1947211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1947214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1947217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947240 */     // MIs[0] round
     /* 1947240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947243 */     // MIs[0] policy
     /* 1947243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947253 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1947256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947279 */     // GIR_Coverage, 15178,
     /* 1947279 */     GIR_EraseRootFromParent_Done,
     /* 1947280 */   // Label 25990: @1947280
     /* 1947280 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1947371), // Rule ID 15179 //
     /* 1947285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1947296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1947299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1947302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1947305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1947308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1947311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947331 */     // MIs[0] round
     /* 1947331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947334 */     // MIs[0] policy
     /* 1947334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1947347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947370 */     // GIR_Coverage, 15179,
     /* 1947370 */     GIR_EraseRootFromParent_Done,
     /* 1947371 */   // Label 25991: @1947371
     /* 1947371 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1947462), // Rule ID 15182 //
     /* 1947376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1947387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1947390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1947393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1947396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1947399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947422 */     // MIs[0] round
     /* 1947422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947425 */     // MIs[0] policy
     /* 1947425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947435 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1947438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947461 */     // GIR_Coverage, 15182,
     /* 1947461 */     GIR_EraseRootFromParent_Done,
     /* 1947462 */   // Label 25992: @1947462
     /* 1947462 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1947553), // Rule ID 15183 //
     /* 1947467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1947478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1947481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1947484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1947487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1947490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1947493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947513 */     // MIs[0] round
     /* 1947513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947516 */     // MIs[0] policy
     /* 1947516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1947529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947552 */     // GIR_Coverage, 15183,
     /* 1947552 */     GIR_EraseRootFromParent_Done,
     /* 1947553 */   // Label 25993: @1947553
     /* 1947553 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1947644), // Rule ID 15186 //
     /* 1947558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1947569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1947572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1947575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1947578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947604 */     // MIs[0] round
     /* 1947604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947607 */     // MIs[0] policy
     /* 1947607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1947620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947643 */     // GIR_Coverage, 15186,
     /* 1947643 */     GIR_EraseRootFromParent_Done,
     /* 1947644 */   // Label 25994: @1947644
     /* 1947644 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1947735), // Rule ID 15187 //
     /* 1947649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1947660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1947663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1947666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1947669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1947675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947695 */     // MIs[0] round
     /* 1947695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947698 */     // MIs[0] policy
     /* 1947698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1947711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947734 */     // GIR_Coverage, 15187,
     /* 1947734 */     GIR_EraseRootFromParent_Done,
     /* 1947735 */   // Label 25995: @1947735
     /* 1947735 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1947826), // Rule ID 15190 //
     /* 1947740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1947751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1947754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1947757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1947760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947786 */     // MIs[0] round
     /* 1947786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947789 */     // MIs[0] policy
     /* 1947789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947799 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1947802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947825 */     // GIR_Coverage, 15190,
     /* 1947825 */     GIR_EraseRootFromParent_Done,
     /* 1947826 */   // Label 25996: @1947826
     /* 1947826 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1947917), // Rule ID 15191 //
     /* 1947831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1947842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1947845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1947848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1947851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1947857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947877 */     // MIs[0] round
     /* 1947877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947880 */     // MIs[0] policy
     /* 1947880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1947893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1947915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947916 */     // GIR_Coverage, 15191,
     /* 1947916 */     GIR_EraseRootFromParent_Done,
     /* 1947917 */   // Label 25997: @1947917
     /* 1947917 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1948008), // Rule ID 15194 //
     /* 1947922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1947930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1947933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1947936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1947939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1947942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1947945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1947948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947968 */     // MIs[0] round
     /* 1947968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1947971 */     // MIs[0] policy
     /* 1947971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1947974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947981 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1947984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1947996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948007 */     // GIR_Coverage, 15194,
     /* 1948007 */     GIR_EraseRootFromParent_Done,
     /* 1948008 */   // Label 25998: @1948008
     /* 1948008 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1948099), // Rule ID 15195 //
     /* 1948013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948059 */     // MIs[0] round
     /* 1948059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948062 */     // MIs[0] policy
     /* 1948062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1948075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948098 */     // GIR_Coverage, 15195,
     /* 1948098 */     GIR_EraseRootFromParent_Done,
     /* 1948099 */   // Label 25999: @1948099
     /* 1948099 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1948190), // Rule ID 15198 //
     /* 1948104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1948130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948150 */     // MIs[0] round
     /* 1948150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948153 */     // MIs[0] policy
     /* 1948153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1948166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948189 */     // GIR_Coverage, 15198,
     /* 1948189 */     GIR_EraseRootFromParent_Done,
     /* 1948190 */   // Label 26000: @1948190
     /* 1948190 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1948281), // Rule ID 15199 //
     /* 1948195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948241 */     // MIs[0] round
     /* 1948241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948244 */     // MIs[0] policy
     /* 1948244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1948257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948280 */     // GIR_Coverage, 15199,
     /* 1948280 */     GIR_EraseRootFromParent_Done,
     /* 1948281 */   // Label 26001: @1948281
     /* 1948281 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1948372), // Rule ID 15202 //
     /* 1948286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1948297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1948300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1948303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1948306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1948312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948332 */     // MIs[0] round
     /* 1948332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948335 */     // MIs[0] policy
     /* 1948335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948345 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1948348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948371 */     // GIR_Coverage, 15202,
     /* 1948371 */     GIR_EraseRootFromParent_Done,
     /* 1948372 */   // Label 26002: @1948372
     /* 1948372 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1948463), // Rule ID 15203 //
     /* 1948377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1948388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1948391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1948394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1948397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948423 */     // MIs[0] round
     /* 1948423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948426 */     // MIs[0] policy
     /* 1948426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1948439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948462 */     // GIR_Coverage, 15203,
     /* 1948462 */     GIR_EraseRootFromParent_Done,
     /* 1948463 */   // Label 26003: @1948463
     /* 1948463 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1948554), // Rule ID 15206 //
     /* 1948468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1948479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1948482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1948485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1948488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1948494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948514 */     // MIs[0] round
     /* 1948514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948517 */     // MIs[0] policy
     /* 1948517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1948530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948553 */     // GIR_Coverage, 15206,
     /* 1948553 */     GIR_EraseRootFromParent_Done,
     /* 1948554 */   // Label 26004: @1948554
     /* 1948554 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1948645), // Rule ID 15207 //
     /* 1948559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1948570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1948573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1948576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1948579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948605 */     // MIs[0] round
     /* 1948605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948608 */     // MIs[0] policy
     /* 1948608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1948621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948644 */     // GIR_Coverage, 15207,
     /* 1948644 */     GIR_EraseRootFromParent_Done,
     /* 1948645 */   // Label 26005: @1948645
     /* 1948645 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1948736), // Rule ID 15210 //
     /* 1948650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1948653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1948661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1948664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1948667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1948670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1948676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948696 */     // MIs[0] round
     /* 1948696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948699 */     // MIs[0] policy
     /* 1948699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1948712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948735 */     // GIR_Coverage, 15210,
     /* 1948735 */     GIR_EraseRootFromParent_Done,
     /* 1948736 */   // Label 26006: @1948736
     /* 1948736 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1948827), // Rule ID 15211 //
     /* 1948741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1948744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1948752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1948755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1948758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1948761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948787 */     // MIs[0] round
     /* 1948787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948790 */     // MIs[0] policy
     /* 1948790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 1948803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948826 */     // GIR_Coverage, 15211,
     /* 1948826 */     GIR_EraseRootFromParent_Done,
     /* 1948827 */   // Label 26007: @1948827
     /* 1948827 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1948918), // Rule ID 15214 //
     /* 1948832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1948835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1948843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1948846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1948849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1948852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1948858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948878 */     // MIs[0] round
     /* 1948878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948881 */     // MIs[0] policy
     /* 1948881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948891 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1948894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1948916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948917 */     // GIR_Coverage, 15214,
     /* 1948917 */     GIR_EraseRootFromParent_Done,
     /* 1948918 */   // Label 26008: @1948918
     /* 1948918 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1949009), // Rule ID 15215 //
     /* 1948923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1948926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1948931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1948934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1948937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1948940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1948943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1948949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948969 */     // MIs[0] round
     /* 1948969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1948972 */     // MIs[0] policy
     /* 1948972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1948975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948982 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 1948985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1948997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949008 */     // GIR_Coverage, 15215,
     /* 1949008 */     GIR_EraseRootFromParent_Done,
     /* 1949009 */   // Label 26009: @1949009
     /* 1949009 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1949100), // Rule ID 15218 //
     /* 1949014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949060 */     // MIs[0] round
     /* 1949060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949063 */     // MIs[0] policy
     /* 1949063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1949076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949099 */     // GIR_Coverage, 15218,
     /* 1949099 */     GIR_EraseRootFromParent_Done,
     /* 1949100 */   // Label 26010: @1949100
     /* 1949100 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1949191), // Rule ID 15219 //
     /* 1949105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1949131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949151 */     // MIs[0] round
     /* 1949151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949154 */     // MIs[0] policy
     /* 1949154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 1949167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949190 */     // GIR_Coverage, 15219,
     /* 1949190 */     GIR_EraseRootFromParent_Done,
     /* 1949191 */   // Label 26011: @1949191
     /* 1949191 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1949282), // Rule ID 15222 //
     /* 1949196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949242 */     // MIs[0] round
     /* 1949242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949245 */     // MIs[0] policy
     /* 1949245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 1949258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949281 */     // GIR_Coverage, 15222,
     /* 1949281 */     GIR_EraseRootFromParent_Done,
     /* 1949282 */   // Label 26012: @1949282
     /* 1949282 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1949373), // Rule ID 15223 //
     /* 1949287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1949313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949333 */     // MIs[0] round
     /* 1949333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949336 */     // MIs[0] policy
     /* 1949336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 1949349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949372 */     // GIR_Coverage, 15223,
     /* 1949372 */     GIR_EraseRootFromParent_Done,
     /* 1949373 */   // Label 26013: @1949373
     /* 1949373 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1949464), // Rule ID 15226 //
     /* 1949378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1949389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1949392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1949395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949424 */     // MIs[0] round
     /* 1949424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949427 */     // MIs[0] policy
     /* 1949427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949437 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 1949440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949463 */     // GIR_Coverage, 15226,
     /* 1949463 */     GIR_EraseRootFromParent_Done,
     /* 1949464 */   // Label 26014: @1949464
     /* 1949464 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1949555), // Rule ID 15227 //
     /* 1949469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1949480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1949483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1949486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1949495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949515 */     // MIs[0] round
     /* 1949515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949518 */     // MIs[0] policy
     /* 1949518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 1949531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949554 */     // GIR_Coverage, 15227,
     /* 1949554 */     GIR_EraseRootFromParent_Done,
     /* 1949555 */   // Label 26015: @1949555
     /* 1949555 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1949646), // Rule ID 15230 //
     /* 1949560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1949571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1949574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1949577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949606 */     // MIs[0] round
     /* 1949606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949609 */     // MIs[0] policy
     /* 1949609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1949622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949645 */     // GIR_Coverage, 15230,
     /* 1949645 */     GIR_EraseRootFromParent_Done,
     /* 1949646 */   // Label 26016: @1949646
     /* 1949646 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1949737), // Rule ID 15231 //
     /* 1949651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1949662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1949665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1949668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1949677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949697 */     // MIs[0] round
     /* 1949697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949700 */     // MIs[0] policy
     /* 1949700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1949713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949736 */     // GIR_Coverage, 15231,
     /* 1949736 */     GIR_EraseRootFromParent_Done,
     /* 1949737 */   // Label 26017: @1949737
     /* 1949737 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1949828), // Rule ID 15234 //
     /* 1949742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1949753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1949756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1949759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949788 */     // MIs[0] round
     /* 1949788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949791 */     // MIs[0] policy
     /* 1949791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949801 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 1949804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949827 */     // GIR_Coverage, 15234,
     /* 1949827 */     GIR_EraseRootFromParent_Done,
     /* 1949828 */   // Label 26018: @1949828
     /* 1949828 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1949919), // Rule ID 15235 //
     /* 1949833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1949844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1949847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1949850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1949859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949879 */     // MIs[0] round
     /* 1949879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949882 */     // MIs[0] policy
     /* 1949882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 1949895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1949917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949918 */     // GIR_Coverage, 15235,
     /* 1949918 */     GIR_EraseRootFromParent_Done,
     /* 1949919 */   // Label 26019: @1949919
     /* 1949919 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1950010), // Rule ID 15238 //
     /* 1949924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1949932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1949935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1949938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1949941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1949950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949970 */     // MIs[0] round
     /* 1949970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1949973 */     // MIs[0] policy
     /* 1949973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1949976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949983 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1949986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1949998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950009 */     // GIR_Coverage, 15238,
     /* 1950009 */     GIR_EraseRootFromParent_Done,
     /* 1950010 */   // Label 26020: @1950010
     /* 1950010 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1950101), // Rule ID 15239 //
     /* 1950015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950061 */     // MIs[0] round
     /* 1950061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950064 */     // MIs[0] policy
     /* 1950064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1950077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950100 */     // GIR_Coverage, 15239,
     /* 1950100 */     GIR_EraseRootFromParent_Done,
     /* 1950101 */   // Label 26021: @1950101
     /* 1950101 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1950192), // Rule ID 15242 //
     /* 1950106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1950132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950152 */     // MIs[0] round
     /* 1950152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950155 */     // MIs[0] policy
     /* 1950155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950165 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1950168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950191 */     // GIR_Coverage, 15242,
     /* 1950191 */     GIR_EraseRootFromParent_Done,
     /* 1950192 */   // Label 26022: @1950192
     /* 1950192 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1950283), // Rule ID 15243 //
     /* 1950197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950243 */     // MIs[0] round
     /* 1950243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950246 */     // MIs[0] policy
     /* 1950246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 1950259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950282 */     // GIR_Coverage, 15243,
     /* 1950282 */     GIR_EraseRootFromParent_Done,
     /* 1950283 */   // Label 26023: @1950283
     /* 1950283 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1950374), // Rule ID 15246 //
     /* 1950288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1950314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950334 */     // MIs[0] round
     /* 1950334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950337 */     // MIs[0] policy
     /* 1950337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950347 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950373 */     // GIR_Coverage, 15246,
     /* 1950373 */     GIR_EraseRootFromParent_Done,
     /* 1950374 */   // Label 26024: @1950374
     /* 1950374 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1950465), // Rule ID 15247 //
     /* 1950379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950425 */     // MIs[0] round
     /* 1950425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950428 */     // MIs[0] policy
     /* 1950428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10852:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950464 */     // GIR_Coverage, 15247,
     /* 1950464 */     GIR_EraseRootFromParent_Done,
     /* 1950465 */   // Label 26025: @1950465
     /* 1950465 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1950556), // Rule ID 15250 //
     /* 1950470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1950481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1950484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1950487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1950496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950516 */     // MIs[0] round
     /* 1950516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950519 */     // MIs[0] policy
     /* 1950519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950529 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950555 */     // GIR_Coverage, 15250,
     /* 1950555 */     GIR_EraseRootFromParent_Done,
     /* 1950556 */   // Label 26026: @1950556
     /* 1950556 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1950647), // Rule ID 15251 //
     /* 1950561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1950572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1950575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1950578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950607 */     // MIs[0] round
     /* 1950607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950610 */     // MIs[0] policy
     /* 1950610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950646 */     // GIR_Coverage, 15251,
     /* 1950646 */     GIR_EraseRootFromParent_Done,
     /* 1950647 */   // Label 26027: @1950647
     /* 1950647 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1950738), // Rule ID 15254 //
     /* 1950652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1950663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1950666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1950669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1950678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950698 */     // MIs[0] round
     /* 1950698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950701 */     // MIs[0] policy
     /* 1950701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950737 */     // GIR_Coverage, 15254,
     /* 1950737 */     GIR_EraseRootFromParent_Done,
     /* 1950738 */   // Label 26028: @1950738
     /* 1950738 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1950829), // Rule ID 15255 //
     /* 1950743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1950754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1950757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1950760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950789 */     // MIs[0] round
     /* 1950789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950792 */     // MIs[0] policy
     /* 1950792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950828 */     // GIR_Coverage, 15255,
     /* 1950828 */     GIR_EraseRootFromParent_Done,
     /* 1950829 */   // Label 26029: @1950829
     /* 1950829 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1950920), // Rule ID 15258 //
     /* 1950834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1950837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1950845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1950848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1950851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1950860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950880 */     // MIs[0] round
     /* 1950880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950883 */     // MIs[0] policy
     /* 1950883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950893 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1950918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950919 */     // GIR_Coverage, 15258,
     /* 1950919 */     GIR_EraseRootFromParent_Done,
     /* 1950920 */   // Label 26030: @1950920
     /* 1950920 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1951011), // Rule ID 15259 //
     /* 1950925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1950933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1950936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1950939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1950942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1950951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950971 */     // MIs[0] round
     /* 1950971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1950974 */     // MIs[0] policy
     /* 1950974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1950977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 1950987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1950999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951010 */     // GIR_Coverage, 15259,
     /* 1951010 */     GIR_EraseRootFromParent_Done,
     /* 1951011 */   // Label 26031: @1951011
     /* 1951011 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1951102), // Rule ID 15262 //
     /* 1951016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951062 */     // MIs[0] round
     /* 1951062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951065 */     // MIs[0] policy
     /* 1951065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1951078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951101 */     // GIR_Coverage, 15262,
     /* 1951101 */     GIR_EraseRootFromParent_Done,
     /* 1951102 */   // Label 26032: @1951102
     /* 1951102 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1951193), // Rule ID 15263 //
     /* 1951107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1951133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951153 */     // MIs[0] round
     /* 1951153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951156 */     // MIs[0] policy
     /* 1951156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951166 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1951169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951192 */     // GIR_Coverage, 15263,
     /* 1951192 */     GIR_EraseRootFromParent_Done,
     /* 1951193 */   // Label 26033: @1951193
     /* 1951193 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1951284), // Rule ID 15266 //
     /* 1951198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951244 */     // MIs[0] round
     /* 1951244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951247 */     // MIs[0] policy
     /* 1951247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951257 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1951260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951283 */     // GIR_Coverage, 15266,
     /* 1951283 */     GIR_EraseRootFromParent_Done,
     /* 1951284 */   // Label 26034: @1951284
     /* 1951284 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1951375), // Rule ID 15267 //
     /* 1951289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1951315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951335 */     // MIs[0] round
     /* 1951335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951338 */     // MIs[0] policy
     /* 1951338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951348 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1951351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951374 */     // GIR_Coverage, 15267,
     /* 1951374 */     GIR_EraseRootFromParent_Done,
     /* 1951375 */   // Label 26035: @1951375
     /* 1951375 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1951466), // Rule ID 15270 //
     /* 1951380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1951394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1951397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1951403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951426 */     // MIs[0] round
     /* 1951426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951429 */     // MIs[0] policy
     /* 1951429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951439 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1951442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951465 */     // GIR_Coverage, 15270,
     /* 1951465 */     GIR_EraseRootFromParent_Done,
     /* 1951466 */   // Label 26036: @1951466
     /* 1951466 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1951557), // Rule ID 15271 //
     /* 1951471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1951485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1951488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1951494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1951497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951517 */     // MIs[0] round
     /* 1951517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951520 */     // MIs[0] policy
     /* 1951520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1951533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951556 */     // GIR_Coverage, 15271,
     /* 1951556 */     GIR_EraseRootFromParent_Done,
     /* 1951557 */   // Label 26037: @1951557
     /* 1951557 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1951648), // Rule ID 15274 //
     /* 1951562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1951573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1951576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1951579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951608 */     // MIs[0] round
     /* 1951608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951611 */     // MIs[0] policy
     /* 1951611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1951624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951647 */     // GIR_Coverage, 15274,
     /* 1951647 */     GIR_EraseRootFromParent_Done,
     /* 1951648 */   // Label 26038: @1951648
     /* 1951648 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1951739), // Rule ID 15275 //
     /* 1951653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1951664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1951667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1951670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1951679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951699 */     // MIs[0] round
     /* 1951699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951702 */     // MIs[0] policy
     /* 1951702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1951715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951738 */     // GIR_Coverage, 15275,
     /* 1951738 */     GIR_EraseRootFromParent_Done,
     /* 1951739 */   // Label 26039: @1951739
     /* 1951739 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1951830), // Rule ID 15278 //
     /* 1951744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1951755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1951758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1951761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951790 */     // MIs[0] round
     /* 1951790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951793 */     // MIs[0] policy
     /* 1951793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951803 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1951806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951829 */     // GIR_Coverage, 15278,
     /* 1951829 */     GIR_EraseRootFromParent_Done,
     /* 1951830 */   // Label 26040: @1951830
     /* 1951830 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1951921), // Rule ID 15279 //
     /* 1951835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1951846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1951849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1951852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1951861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951881 */     // MIs[0] round
     /* 1951881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951884 */     // MIs[0] policy
     /* 1951884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1951897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1951909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1951919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951920 */     // GIR_Coverage, 15279,
     /* 1951920 */     GIR_EraseRootFromParent_Done,
     /* 1951921 */   // Label 26041: @1951921
     /* 1951921 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1952012), // Rule ID 15282 //
     /* 1951926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1951934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1951937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1951940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1951943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1951952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951972 */     // MIs[0] round
     /* 1951972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1951975 */     // MIs[0] policy
     /* 1951975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1951978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951985 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1951988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952011 */     // GIR_Coverage, 15282,
     /* 1952011 */     GIR_EraseRootFromParent_Done,
     /* 1952012 */   // Label 26042: @1952012
     /* 1952012 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1952103), // Rule ID 15283 //
     /* 1952017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952063 */     // MIs[0] round
     /* 1952063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952066 */     // MIs[0] policy
     /* 1952066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1952079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952102 */     // GIR_Coverage, 15283,
     /* 1952102 */     GIR_EraseRootFromParent_Done,
     /* 1952103 */   // Label 26043: @1952103
     /* 1952103 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1952194), // Rule ID 15286 //
     /* 1952108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1952134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952154 */     // MIs[0] round
     /* 1952154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952157 */     // MIs[0] policy
     /* 1952157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1952170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952193 */     // GIR_Coverage, 15286,
     /* 1952193 */     GIR_EraseRootFromParent_Done,
     /* 1952194 */   // Label 26044: @1952194
     /* 1952194 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1952285), // Rule ID 15287 //
     /* 1952199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952245 */     // MIs[0] round
     /* 1952245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952248 */     // MIs[0] policy
     /* 1952248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1952261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952284 */     // GIR_Coverage, 15287,
     /* 1952284 */     GIR_EraseRootFromParent_Done,
     /* 1952285 */   // Label 26045: @1952285
     /* 1952285 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1952376), // Rule ID 15290 //
     /* 1952290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1952316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952336 */     // MIs[0] round
     /* 1952336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952339 */     // MIs[0] policy
     /* 1952339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1952352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952375 */     // GIR_Coverage, 15290,
     /* 1952375 */     GIR_EraseRootFromParent_Done,
     /* 1952376 */   // Label 26046: @1952376
     /* 1952376 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1952467), // Rule ID 15291 //
     /* 1952381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952427 */     // MIs[0] round
     /* 1952427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952430 */     // MIs[0] policy
     /* 1952430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1952443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952466 */     // GIR_Coverage, 15291,
     /* 1952466 */     GIR_EraseRootFromParent_Done,
     /* 1952467 */   // Label 26047: @1952467
     /* 1952467 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1952558), // Rule ID 15294 //
     /* 1952472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1952483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1952486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1952489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1952498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952518 */     // MIs[0] round
     /* 1952518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952521 */     // MIs[0] policy
     /* 1952521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952531 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1952534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952557 */     // GIR_Coverage, 15294,
     /* 1952557 */     GIR_EraseRootFromParent_Done,
     /* 1952558 */   // Label 26048: @1952558
     /* 1952558 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1952649), // Rule ID 15295 //
     /* 1952563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1952574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1952577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1952580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952609 */     // MIs[0] round
     /* 1952609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952612 */     // MIs[0] policy
     /* 1952612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1952625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952648 */     // GIR_Coverage, 15295,
     /* 1952648 */     GIR_EraseRootFromParent_Done,
     /* 1952649 */   // Label 26049: @1952649
     /* 1952649 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1952740), // Rule ID 15298 //
     /* 1952654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1952657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1952665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1952668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1952671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1952680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952700 */     // MIs[0] round
     /* 1952700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952703 */     // MIs[0] policy
     /* 1952703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1952716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952739 */     // GIR_Coverage, 15298,
     /* 1952739 */     GIR_EraseRootFromParent_Done,
     /* 1952740 */   // Label 26050: @1952740
     /* 1952740 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1952831), // Rule ID 15299 //
     /* 1952745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1952748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1952756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1952759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1952762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952791 */     // MIs[0] round
     /* 1952791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952794 */     // MIs[0] policy
     /* 1952794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 1952807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952830 */     // GIR_Coverage, 15299,
     /* 1952830 */     GIR_EraseRootFromParent_Done,
     /* 1952831 */   // Label 26051: @1952831
     /* 1952831 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1952922), // Rule ID 15302 //
     /* 1952836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1952839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1952847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1952850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1952853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1952862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952882 */     // MIs[0] round
     /* 1952882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952885 */     // MIs[0] policy
     /* 1952885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952895 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1952898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1952910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1952920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952921 */     // GIR_Coverage, 15302,
     /* 1952921 */     GIR_EraseRootFromParent_Done,
     /* 1952922 */   // Label 26052: @1952922
     /* 1952922 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1953013), // Rule ID 15303 //
     /* 1952927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1952930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1952935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1952938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1952941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1952944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1952953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952973 */     // MIs[0] round
     /* 1952973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1952976 */     // MIs[0] policy
     /* 1952976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1952979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 1952989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953012 */     // GIR_Coverage, 15303,
     /* 1953012 */     GIR_EraseRootFromParent_Done,
     /* 1953013 */   // Label 26053: @1953013
     /* 1953013 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1953104), // Rule ID 15306 //
     /* 1953018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1953026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953064 */     // MIs[0] round
     /* 1953064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953067 */     // MIs[0] policy
     /* 1953067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1953080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953103 */     // GIR_Coverage, 15306,
     /* 1953103 */     GIR_EraseRootFromParent_Done,
     /* 1953104 */   // Label 26054: @1953104
     /* 1953104 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1953195), // Rule ID 15307 //
     /* 1953109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 1953117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1953135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953155 */     // MIs[0] round
     /* 1953155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953158 */     // MIs[0] policy
     /* 1953158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 1953171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953194 */     // GIR_Coverage, 15307,
     /* 1953194 */     GIR_EraseRootFromParent_Done,
     /* 1953195 */   // Label 26055: @1953195
     /* 1953195 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1953286), // Rule ID 15310 //
     /* 1953200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1953220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953246 */     // MIs[0] round
     /* 1953246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953249 */     // MIs[0] policy
     /* 1953249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953259 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 1953262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953285 */     // GIR_Coverage, 15310,
     /* 1953285 */     GIR_EraseRootFromParent_Done,
     /* 1953286 */   // Label 26056: @1953286
     /* 1953286 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1953377), // Rule ID 15311 //
     /* 1953291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1953311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1953317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953337 */     // MIs[0] round
     /* 1953337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953340 */     // MIs[0] policy
     /* 1953340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953350 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 1953353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953376 */     // GIR_Coverage, 15311,
     /* 1953376 */     GIR_EraseRootFromParent_Done,
     /* 1953377 */   // Label 26057: @1953377
     /* 1953377 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1953468), // Rule ID 15314 //
     /* 1953382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1953402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953428 */     // MIs[0] round
     /* 1953428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953431 */     // MIs[0] policy
     /* 1953431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953441 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 1953444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953467 */     // GIR_Coverage, 15314,
     /* 1953467 */     GIR_EraseRootFromParent_Done,
     /* 1953468 */   // Label 26058: @1953468
     /* 1953468 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1953559), // Rule ID 15315 //
     /* 1953473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1953493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1953499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953519 */     // MIs[0] round
     /* 1953519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953522 */     // MIs[0] policy
     /* 1953522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 1953535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953558 */     // GIR_Coverage, 15315,
     /* 1953558 */     GIR_EraseRootFromParent_Done,
     /* 1953559 */   // Label 26059: @1953559
     /* 1953559 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1953650), // Rule ID 15318 //
     /* 1953564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1953575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1953578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1953581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1953584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953610 */     // MIs[0] round
     /* 1953610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953613 */     // MIs[0] policy
     /* 1953613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1953626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953649 */     // GIR_Coverage, 15318,
     /* 1953649 */     GIR_EraseRootFromParent_Done,
     /* 1953650 */   // Label 26060: @1953650
     /* 1953650 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1953741), // Rule ID 15319 //
     /* 1953655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1953666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1953669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1953672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1953675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1953681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953701 */     // MIs[0] round
     /* 1953701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953704 */     // MIs[0] policy
     /* 1953704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1953717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953740 */     // GIR_Coverage, 15319,
     /* 1953740 */     GIR_EraseRootFromParent_Done,
     /* 1953741 */   // Label 26061: @1953741
     /* 1953741 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1953832), // Rule ID 15322 //
     /* 1953746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1953757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1953760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1953763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953792 */     // MIs[0] round
     /* 1953792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953795 */     // MIs[0] policy
     /* 1953795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953805 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 1953808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953831 */     // GIR_Coverage, 15322,
     /* 1953831 */     GIR_EraseRootFromParent_Done,
     /* 1953832 */   // Label 26062: @1953832
     /* 1953832 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1953923), // Rule ID 15323 //
     /* 1953837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1953848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1953851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1953854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1953863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953883 */     // MIs[0] round
     /* 1953883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953886 */     // MIs[0] policy
     /* 1953886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 1953899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1953911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1953921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953922 */     // GIR_Coverage, 15323,
     /* 1953922 */     GIR_EraseRootFromParent_Done,
     /* 1953923 */   // Label 26063: @1953923
     /* 1953923 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1954014), // Rule ID 15326 //
     /* 1953928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1953936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1953939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1953942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1953945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1953954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953974 */     // MIs[0] round
     /* 1953974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1953977 */     // MIs[0] policy
     /* 1953977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1953980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953987 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1953990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954013 */     // GIR_Coverage, 15326,
     /* 1954013 */     GIR_EraseRootFromParent_Done,
     /* 1954014 */   // Label 26064: @1954014
     /* 1954014 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1954105), // Rule ID 15327 //
     /* 1954019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954065 */     // MIs[0] round
     /* 1954065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954068 */     // MIs[0] policy
     /* 1954068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1954081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954104 */     // GIR_Coverage, 15327,
     /* 1954104 */     GIR_EraseRootFromParent_Done,
     /* 1954105 */   // Label 26065: @1954105
     /* 1954105 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1954196), // Rule ID 15330 //
     /* 1954110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1954130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1954136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954156 */     // MIs[0] round
     /* 1954156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954159 */     // MIs[0] policy
     /* 1954159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1954172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954195 */     // GIR_Coverage, 15330,
     /* 1954195 */     GIR_EraseRootFromParent_Done,
     /* 1954196 */   // Label 26066: @1954196
     /* 1954196 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1954287), // Rule ID 15331 //
     /* 1954201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1954221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954247 */     // MIs[0] round
     /* 1954247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954250 */     // MIs[0] policy
     /* 1954250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 1954263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954286 */     // GIR_Coverage, 15331,
     /* 1954286 */     GIR_EraseRootFromParent_Done,
     /* 1954287 */   // Label 26067: @1954287
     /* 1954287 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1954378), // Rule ID 15334 //
     /* 1954292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1954312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1954318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954338 */     // MIs[0] round
     /* 1954338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954341 */     // MIs[0] policy
     /* 1954341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954351 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954377 */     // GIR_Coverage, 15334,
     /* 1954377 */     GIR_EraseRootFromParent_Done,
     /* 1954378 */   // Label 26068: @1954378
     /* 1954378 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1954469), // Rule ID 15335 //
     /* 1954383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1954403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954429 */     // MIs[0] round
     /* 1954429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954432 */     // MIs[0] policy
     /* 1954432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954468 */     // GIR_Coverage, 15335,
     /* 1954468 */     GIR_EraseRootFromParent_Done,
     /* 1954469 */   // Label 26069: @1954469
     /* 1954469 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1954560), // Rule ID 15338 //
     /* 1954474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1954500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954520 */     // MIs[0] round
     /* 1954520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954523 */     // MIs[0] policy
     /* 1954523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954533 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954559 */     // GIR_Coverage, 15338,
     /* 1954559 */     GIR_EraseRootFromParent_Done,
     /* 1954560 */   // Label 26070: @1954560
     /* 1954560 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1954651), // Rule ID 15339 //
     /* 1954565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954611 */     // MIs[0] round
     /* 1954611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954614 */     // MIs[0] policy
     /* 1954614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954650 */     // GIR_Coverage, 15339,
     /* 1954650 */     GIR_EraseRootFromParent_Done,
     /* 1954651 */   // Label 26071: @1954651
     /* 1954651 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1954742), // Rule ID 15342 //
     /* 1954656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1954667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1954670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1954673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1954676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1954682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954702 */     // MIs[0] round
     /* 1954702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954705 */     // MIs[0] policy
     /* 1954705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954741 */     // GIR_Coverage, 15342,
     /* 1954741 */     GIR_EraseRootFromParent_Done,
     /* 1954742 */   // Label 26072: @1954742
     /* 1954742 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1954833), // Rule ID 15343 //
     /* 1954747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1954758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1954761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1954764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1954767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954793 */     // MIs[0] round
     /* 1954793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954796 */     // MIs[0] policy
     /* 1954796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954832 */     // GIR_Coverage, 15343,
     /* 1954832 */     GIR_EraseRootFromParent_Done,
     /* 1954833 */   // Label 26073: @1954833
     /* 1954833 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1954924), // Rule ID 15346 //
     /* 1954838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1954841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1954849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1954852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1954855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1954858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1954864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954884 */     // MIs[0] round
     /* 1954884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954887 */     // MIs[0] policy
     /* 1954887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954897 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1954912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1954922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954923 */     // GIR_Coverage, 15346,
     /* 1954923 */     GIR_EraseRootFromParent_Done,
     /* 1954924 */   // Label 26074: @1954924
     /* 1954924 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1955015), // Rule ID 15347 //
     /* 1954929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1954932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1954937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1954940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1954943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1954946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1954949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1954955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954975 */     // MIs[0] round
     /* 1954975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1954978 */     // MIs[0] policy
     /* 1954978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1954981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 1954991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955014 */     // GIR_Coverage, 15347,
     /* 1955014 */     GIR_EraseRootFromParent_Done,
     /* 1955015 */   // Label 26075: @1955015
     /* 1955015 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1955106), // Rule ID 15350 //
     /* 1955020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1955040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955066 */     // MIs[0] round
     /* 1955066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955069 */     // MIs[0] policy
     /* 1955069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1955082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955105 */     // GIR_Coverage, 15350,
     /* 1955105 */     GIR_EraseRootFromParent_Done,
     /* 1955106 */   // Label 26076: @1955106
     /* 1955106 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1955197), // Rule ID 15351 //
     /* 1955111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1955131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1955137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955157 */     // MIs[0] round
     /* 1955157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955160 */     // MIs[0] policy
     /* 1955160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1955173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955196 */     // GIR_Coverage, 15351,
     /* 1955196 */     GIR_EraseRootFromParent_Done,
     /* 1955197 */   // Label 26077: @1955197
     /* 1955197 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1955288), // Rule ID 15354 //
     /* 1955202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1955222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955248 */     // MIs[0] round
     /* 1955248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955251 */     // MIs[0] policy
     /* 1955251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955261 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1955264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955287 */     // GIR_Coverage, 15354,
     /* 1955287 */     GIR_EraseRootFromParent_Done,
     /* 1955288 */   // Label 26078: @1955288
     /* 1955288 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1955379), // Rule ID 15355 //
     /* 1955293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1955313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1955319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955339 */     // MIs[0] round
     /* 1955339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955342 */     // MIs[0] policy
     /* 1955342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1955355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955378 */     // GIR_Coverage, 15355,
     /* 1955378 */     GIR_EraseRootFromParent_Done,
     /* 1955379 */   // Label 26079: @1955379
     /* 1955379 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1955470), // Rule ID 15358 //
     /* 1955384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1955395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1955398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1955401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1955404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1955407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955430 */     // MIs[0] round
     /* 1955430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955433 */     // MIs[0] policy
     /* 1955433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955443 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1955446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955469 */     // GIR_Coverage, 15358,
     /* 1955469 */     GIR_EraseRootFromParent_Done,
     /* 1955470 */   // Label 26080: @1955470
     /* 1955470 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1955561), // Rule ID 15359 //
     /* 1955475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1955486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1955489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1955492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1955495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1955498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1955501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955521 */     // MIs[0] round
     /* 1955521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955524 */     // MIs[0] policy
     /* 1955524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1955537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955560 */     // GIR_Coverage, 15359,
     /* 1955560 */     GIR_EraseRootFromParent_Done,
     /* 1955561 */   // Label 26081: @1955561
     /* 1955561 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1955652), // Rule ID 15362 //
     /* 1955566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955612 */     // MIs[0] round
     /* 1955612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955615 */     // MIs[0] policy
     /* 1955615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1955628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955651 */     // GIR_Coverage, 15362,
     /* 1955651 */     GIR_EraseRootFromParent_Done,
     /* 1955652 */   // Label 26082: @1955652
     /* 1955652 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1955743), // Rule ID 15363 //
     /* 1955657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1955683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955703 */     // MIs[0] round
     /* 1955703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955706 */     // MIs[0] policy
     /* 1955706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1955719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955742 */     // GIR_Coverage, 15363,
     /* 1955742 */     GIR_EraseRootFromParent_Done,
     /* 1955743 */   // Label 26083: @1955743
     /* 1955743 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1955834), // Rule ID 15366 //
     /* 1955748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955794 */     // MIs[0] round
     /* 1955794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955797 */     // MIs[0] policy
     /* 1955797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955807 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1955810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955833 */     // GIR_Coverage, 15366,
     /* 1955833 */     GIR_EraseRootFromParent_Done,
     /* 1955834 */   // Label 26084: @1955834
     /* 1955834 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1955925), // Rule ID 15367 //
     /* 1955839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1955865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955885 */     // MIs[0] round
     /* 1955885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955888 */     // MIs[0] policy
     /* 1955888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1955901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1955913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1955923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955924 */     // GIR_Coverage, 15367,
     /* 1955924 */     GIR_EraseRootFromParent_Done,
     /* 1955925 */   // Label 26085: @1955925
     /* 1955925 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1956016), // Rule ID 15370 //
     /* 1955930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1955938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1955941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1955944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1955947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1955950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1955956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955976 */     // MIs[0] round
     /* 1955976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1955979 */     // MIs[0] policy
     /* 1955979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1955982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955989 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1955992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956015 */     // GIR_Coverage, 15370,
     /* 1956015 */     GIR_EraseRootFromParent_Done,
     /* 1956016 */   // Label 26086: @1956016
     /* 1956016 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1956107), // Rule ID 15371 //
     /* 1956021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956067 */     // MIs[0] round
     /* 1956067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956070 */     // MIs[0] policy
     /* 1956070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1956083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956106 */     // GIR_Coverage, 15371,
     /* 1956106 */     GIR_EraseRootFromParent_Done,
     /* 1956107 */   // Label 26087: @1956107
     /* 1956107 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1956198), // Rule ID 15374 //
     /* 1956112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1956132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1956138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956158 */     // MIs[0] round
     /* 1956158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956161 */     // MIs[0] policy
     /* 1956161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1956174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956197 */     // GIR_Coverage, 15374,
     /* 1956197 */     GIR_EraseRootFromParent_Done,
     /* 1956198 */   // Label 26088: @1956198
     /* 1956198 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1956289), // Rule ID 15375 //
     /* 1956203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1956223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956249 */     // MIs[0] round
     /* 1956249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956252 */     // MIs[0] policy
     /* 1956252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1956265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956288 */     // GIR_Coverage, 15375,
     /* 1956288 */     GIR_EraseRootFromParent_Done,
     /* 1956289 */   // Label 26089: @1956289
     /* 1956289 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1956380), // Rule ID 15378 //
     /* 1956294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1956314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1956320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956340 */     // MIs[0] round
     /* 1956340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956343 */     // MIs[0] policy
     /* 1956343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1956356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956379 */     // GIR_Coverage, 15378,
     /* 1956379 */     GIR_EraseRootFromParent_Done,
     /* 1956380 */   // Label 26090: @1956380
     /* 1956380 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1956471), // Rule ID 15379 //
     /* 1956385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1956405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956431 */     // MIs[0] round
     /* 1956431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956434 */     // MIs[0] policy
     /* 1956434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1956447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956470 */     // GIR_Coverage, 15379,
     /* 1956470 */     GIR_EraseRootFromParent_Done,
     /* 1956471 */   // Label 26091: @1956471
     /* 1956471 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1956562), // Rule ID 15382 //
     /* 1956476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1956496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1956502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956522 */     // MIs[0] round
     /* 1956522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956525 */     // MIs[0] policy
     /* 1956525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956535 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1956538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956561 */     // GIR_Coverage, 15382,
     /* 1956561 */     GIR_EraseRootFromParent_Done,
     /* 1956562 */   // Label 26092: @1956562
     /* 1956562 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1956653), // Rule ID 15383 //
     /* 1956567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1956587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956613 */     // MIs[0] round
     /* 1956613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956616 */     // MIs[0] policy
     /* 1956616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1956629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956652 */     // GIR_Coverage, 15383,
     /* 1956652 */     GIR_EraseRootFromParent_Done,
     /* 1956653 */   // Label 26093: @1956653
     /* 1956653 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1956744), // Rule ID 15386 //
     /* 1956658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1956661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1956678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1956684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956704 */     // MIs[0] round
     /* 1956704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956707 */     // MIs[0] policy
     /* 1956707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1956720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956743 */     // GIR_Coverage, 15386,
     /* 1956743 */     GIR_EraseRootFromParent_Done,
     /* 1956744 */   // Label 26094: @1956744
     /* 1956744 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1956835), // Rule ID 15387 //
     /* 1956749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1956752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1956769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956795 */     // MIs[0] round
     /* 1956795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956798 */     // MIs[0] policy
     /* 1956798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 1956811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956834 */     // GIR_Coverage, 15387,
     /* 1956834 */     GIR_EraseRootFromParent_Done,
     /* 1956835 */   // Label 26095: @1956835
     /* 1956835 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1956926), // Rule ID 15390 //
     /* 1956840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1956843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1956860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1956866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956886 */     // MIs[0] round
     /* 1956886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956889 */     // MIs[0] policy
     /* 1956889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956899 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1956902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1956914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1956924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956925 */     // GIR_Coverage, 15390,
     /* 1956925 */     GIR_EraseRootFromParent_Done,
     /* 1956926 */   // Label 26096: @1956926
     /* 1956926 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1957017), // Rule ID 15391 //
     /* 1956931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1956934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1956939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1956951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1956957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956977 */     // MIs[0] round
     /* 1956977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1956980 */     // MIs[0] policy
     /* 1956980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1956983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956990 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 1956993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957016 */     // GIR_Coverage, 15391,
     /* 1957016 */     GIR_EraseRootFromParent_Done,
     /* 1957017 */   // Label 26097: @1957017
     /* 1957017 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1957108), // Rule ID 15394 //
     /* 1957022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1957025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1957042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957068 */     // MIs[0] round
     /* 1957068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957071 */     // MIs[0] policy
     /* 1957071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957081 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1957084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957107 */     // GIR_Coverage, 15394,
     /* 1957107 */     GIR_EraseRootFromParent_Done,
     /* 1957108 */   // Label 26098: @1957108
     /* 1957108 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1957199), // Rule ID 15395 //
     /* 1957113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1957116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1957133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1957139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957159 */     // MIs[0] round
     /* 1957159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957162 */     // MIs[0] policy
     /* 1957162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 1957175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957198 */     // GIR_Coverage, 15395,
     /* 1957198 */     GIR_EraseRootFromParent_Done,
     /* 1957199 */   // Label 26099: @1957199
     /* 1957199 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1957290), // Rule ID 15398 //
     /* 1957204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1957215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1957218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1957221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957250 */     // MIs[0] round
     /* 1957250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957253 */     // MIs[0] policy
     /* 1957253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957263 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 1957266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957289 */     // GIR_Coverage, 15398,
     /* 1957289 */     GIR_EraseRootFromParent_Done,
     /* 1957290 */   // Label 26100: @1957290
     /* 1957290 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1957381), // Rule ID 15399 //
     /* 1957295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1957306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1957309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1957312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1957321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957341 */     // MIs[0] round
     /* 1957341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957344 */     // MIs[0] policy
     /* 1957344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 1957357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957380 */     // GIR_Coverage, 15399,
     /* 1957380 */     GIR_EraseRootFromParent_Done,
     /* 1957381 */   // Label 26101: @1957381
     /* 1957381 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1957472), // Rule ID 15402 //
     /* 1957386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1957397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1957400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1957403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957432 */     // MIs[0] round
     /* 1957432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957435 */     // MIs[0] policy
     /* 1957435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 1957448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957471 */     // GIR_Coverage, 15402,
     /* 1957471 */     GIR_EraseRootFromParent_Done,
     /* 1957472 */   // Label 26102: @1957472
     /* 1957472 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1957563), // Rule ID 15403 //
     /* 1957477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1957488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1957491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1957494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1957503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957523 */     // MIs[0] round
     /* 1957523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957526 */     // MIs[0] policy
     /* 1957526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 1957539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957562 */     // GIR_Coverage, 15403,
     /* 1957562 */     GIR_EraseRootFromParent_Done,
     /* 1957563 */   // Label 26103: @1957563
     /* 1957563 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1957654), // Rule ID 15406 //
     /* 1957568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1957579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1957582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1957585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957614 */     // MIs[0] round
     /* 1957614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957617 */     // MIs[0] policy
     /* 1957617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1957630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957653 */     // GIR_Coverage, 15406,
     /* 1957653 */     GIR_EraseRootFromParent_Done,
     /* 1957654 */   // Label 26104: @1957654
     /* 1957654 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1957745), // Rule ID 15407 //
     /* 1957659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1957670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1957673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1957676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1957685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957705 */     // MIs[0] round
     /* 1957705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957708 */     // MIs[0] policy
     /* 1957708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1957721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957744 */     // GIR_Coverage, 15407,
     /* 1957744 */     GIR_EraseRootFromParent_Done,
     /* 1957745 */   // Label 26105: @1957745
     /* 1957745 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1957836), // Rule ID 15410 //
     /* 1957750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957796 */     // MIs[0] round
     /* 1957796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957799 */     // MIs[0] policy
     /* 1957799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 1957812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957835 */     // GIR_Coverage, 15410,
     /* 1957835 */     GIR_EraseRootFromParent_Done,
     /* 1957836 */   // Label 26106: @1957836
     /* 1957836 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1957927), // Rule ID 15411 //
     /* 1957841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1957867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957887 */     // MIs[0] round
     /* 1957887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957890 */     // MIs[0] policy
     /* 1957890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 1957903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1957915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1957925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957926 */     // GIR_Coverage, 15411,
     /* 1957926 */     GIR_EraseRootFromParent_Done,
     /* 1957927 */   // Label 26107: @1957927
     /* 1957927 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1958018), // Rule ID 15414 //
     /* 1957932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1957940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1957958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957978 */     // MIs[0] round
     /* 1957978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1957981 */     // MIs[0] policy
     /* 1957981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1957984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1957994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958017 */     // GIR_Coverage, 15414,
     /* 1958017 */     GIR_EraseRootFromParent_Done,
     /* 1958018 */   // Label 26108: @1958018
     /* 1958018 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1958109), // Rule ID 15415 //
     /* 1958023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1958040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958069 */     // MIs[0] round
     /* 1958069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958072 */     // MIs[0] policy
     /* 1958072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1958085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958108 */     // GIR_Coverage, 15415,
     /* 1958108 */     GIR_EraseRootFromParent_Done,
     /* 1958109 */   // Label 26109: @1958109
     /* 1958109 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1958200), // Rule ID 15418 //
     /* 1958114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1958134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1958140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958160 */     // MIs[0] round
     /* 1958160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958163 */     // MIs[0] policy
     /* 1958163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958173 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1958176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958199 */     // GIR_Coverage, 15418,
     /* 1958199 */     GIR_EraseRootFromParent_Done,
     /* 1958200 */   // Label 26110: @1958200
     /* 1958200 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1958291), // Rule ID 15419 //
     /* 1958205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958251 */     // MIs[0] round
     /* 1958251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958254 */     // MIs[0] policy
     /* 1958254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 1958267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958290 */     // GIR_Coverage, 15419,
     /* 1958290 */     GIR_EraseRootFromParent_Done,
     /* 1958291 */   // Label 26111: @1958291
     /* 1958291 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1958382), // Rule ID 15422 //
     /* 1958296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1958307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1958310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1958313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1958316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1958322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958342 */     // MIs[0] round
     /* 1958342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958345 */     // MIs[0] policy
     /* 1958345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958355 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958381 */     // GIR_Coverage, 15422,
     /* 1958381 */     GIR_EraseRootFromParent_Done,
     /* 1958382 */   // Label 26112: @1958382
     /* 1958382 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1958473), // Rule ID 15423 //
     /* 1958387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1958398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1958401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1958404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958433 */     // MIs[0] round
     /* 1958433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958436 */     // MIs[0] policy
     /* 1958436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10830:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958472 */     // GIR_Coverage, 15423,
     /* 1958472 */     GIR_EraseRootFromParent_Done,
     /* 1958473 */   // Label 26113: @1958473
     /* 1958473 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1958564), // Rule ID 15426 //
     /* 1958478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1958498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1958504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958524 */     // MIs[0] round
     /* 1958524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958527 */     // MIs[0] policy
     /* 1958527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958537 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958563 */     // GIR_Coverage, 15426,
     /* 1958563 */     GIR_EraseRootFromParent_Done,
     /* 1958564 */   // Label 26114: @1958564
     /* 1958564 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1958655), // Rule ID 15427 //
     /* 1958569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958615 */     // MIs[0] round
     /* 1958615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958618 */     // MIs[0] policy
     /* 1958618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958654 */     // GIR_Coverage, 15427,
     /* 1958654 */     GIR_EraseRootFromParent_Done,
     /* 1958655 */   // Label 26115: @1958655
     /* 1958655 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1958746), // Rule ID 15430 //
     /* 1958660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1958680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1958686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958706 */     // MIs[0] round
     /* 1958706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958709 */     // MIs[0] policy
     /* 1958709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958745 */     // GIR_Coverage, 15430,
     /* 1958745 */     GIR_EraseRootFromParent_Done,
     /* 1958746 */   // Label 26116: @1958746
     /* 1958746 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1958837), // Rule ID 15431 //
     /* 1958751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958797 */     // MIs[0] round
     /* 1958797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958800 */     // MIs[0] policy
     /* 1958800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958836 */     // GIR_Coverage, 15431,
     /* 1958836 */     GIR_EraseRootFromParent_Done,
     /* 1958837 */   // Label 26117: @1958837
     /* 1958837 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1958928), // Rule ID 15434 //
     /* 1958842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1958845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1958862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1958868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958888 */     // MIs[0] round
     /* 1958888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958891 */     // MIs[0] policy
     /* 1958891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958901 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1958916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1958926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958927 */     // GIR_Coverage, 15434,
     /* 1958927 */     GIR_EraseRootFromParent_Done,
     /* 1958928 */   // Label 26118: @1958928
     /* 1958928 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1959019), // Rule ID 15435 //
     /* 1958933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1958936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1958941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1958959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958979 */     // MIs[0] round
     /* 1958979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1958982 */     // MIs[0] policy
     /* 1958982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1958985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 1958995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959018 */     // GIR_Coverage, 15435,
     /* 1959018 */     GIR_EraseRootFromParent_Done,
     /* 1959019 */   // Label 26119: @1959019
     /* 1959019 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1959110), // Rule ID 15438 //
     /* 1959024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1959035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1959038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959070 */     // MIs[0] round
     /* 1959070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959073 */     // MIs[0] policy
     /* 1959073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1959086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959109 */     // GIR_Coverage, 15438,
     /* 1959109 */     GIR_EraseRootFromParent_Done,
     /* 1959110 */   // Label 26120: @1959110
     /* 1959110 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1959201), // Rule ID 15439 //
     /* 1959115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1959126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1959129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1959141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959161 */     // MIs[0] round
     /* 1959161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959164 */     // MIs[0] policy
     /* 1959164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1959177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959200 */     // GIR_Coverage, 15439,
     /* 1959200 */     GIR_EraseRootFromParent_Done,
     /* 1959201 */   // Label 26121: @1959201
     /* 1959201 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1959292), // Rule ID 15442 //
     /* 1959206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1959217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1959220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959252 */     // MIs[0] round
     /* 1959252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959255 */     // MIs[0] policy
     /* 1959255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959265 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1959268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959291 */     // GIR_Coverage, 15442,
     /* 1959291 */     GIR_EraseRootFromParent_Done,
     /* 1959292 */   // Label 26122: @1959292
     /* 1959292 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1959383), // Rule ID 15443 //
     /* 1959297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1959308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1959311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1959323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959343 */     // MIs[0] round
     /* 1959343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959346 */     // MIs[0] policy
     /* 1959346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1959359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959382 */     // GIR_Coverage, 15443,
     /* 1959382 */     GIR_EraseRootFromParent_Done,
     /* 1959383 */   // Label 26123: @1959383
     /* 1959383 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1959474), // Rule ID 15446 //
     /* 1959388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1959399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1959402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1959405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1959411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959434 */     // MIs[0] round
     /* 1959434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959437 */     // MIs[0] policy
     /* 1959437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959447 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1959450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959473 */     // GIR_Coverage, 15446,
     /* 1959473 */     GIR_EraseRootFromParent_Done,
     /* 1959474 */   // Label 26124: @1959474
     /* 1959474 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1959565), // Rule ID 15447 //
     /* 1959479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1959490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1959493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1959496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1959502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1959505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959525 */     // MIs[0] round
     /* 1959525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959528 */     // MIs[0] policy
     /* 1959528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959538 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1959541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959564 */     // GIR_Coverage, 15447,
     /* 1959564 */     GIR_EraseRootFromParent_Done,
     /* 1959565 */   // Label 26125: @1959565
     /* 1959565 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1959656), // Rule ID 15450 //
     /* 1959570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959616 */     // MIs[0] round
     /* 1959616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959619 */     // MIs[0] policy
     /* 1959619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1959632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959655 */     // GIR_Coverage, 15450,
     /* 1959655 */     GIR_EraseRootFromParent_Done,
     /* 1959656 */   // Label 26126: @1959656
     /* 1959656 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1959747), // Rule ID 15451 //
     /* 1959661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1959687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959707 */     // MIs[0] round
     /* 1959707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959710 */     // MIs[0] policy
     /* 1959710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1959723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959746 */     // GIR_Coverage, 15451,
     /* 1959746 */     GIR_EraseRootFromParent_Done,
     /* 1959747 */   // Label 26127: @1959747
     /* 1959747 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1959838), // Rule ID 15454 //
     /* 1959752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959798 */     // MIs[0] round
     /* 1959798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959801 */     // MIs[0] policy
     /* 1959801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959811 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1959814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959837 */     // GIR_Coverage, 15454,
     /* 1959837 */     GIR_EraseRootFromParent_Done,
     /* 1959838 */   // Label 26128: @1959838
     /* 1959838 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1959929), // Rule ID 15455 //
     /* 1959843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1959869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959889 */     // MIs[0] round
     /* 1959889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959892 */     // MIs[0] policy
     /* 1959892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1959905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1959917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1959927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959928 */     // GIR_Coverage, 15455,
     /* 1959928 */     GIR_EraseRootFromParent_Done,
     /* 1959929 */   // Label 26129: @1959929
     /* 1959929 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1960020), // Rule ID 15458 //
     /* 1959934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1959942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1959960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959980 */     // MIs[0] round
     /* 1959980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1959983 */     // MIs[0] policy
     /* 1959983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1959986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959993 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1959996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960019 */     // GIR_Coverage, 15458,
     /* 1960019 */     GIR_EraseRootFromParent_Done,
     /* 1960020 */   // Label 26130: @1960020
     /* 1960020 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1960111), // Rule ID 15459 //
     /* 1960025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1960036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1960039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1960042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1960048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960071 */     // MIs[0] round
     /* 1960071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960074 */     // MIs[0] policy
     /* 1960074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1960087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960110 */     // GIR_Coverage, 15459,
     /* 1960110 */     GIR_EraseRootFromParent_Done,
     /* 1960111 */   // Label 26131: @1960111
     /* 1960111 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1960202), // Rule ID 15462 //
     /* 1960116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1960127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1960130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1960142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960162 */     // MIs[0] round
     /* 1960162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960165 */     // MIs[0] policy
     /* 1960165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1960178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960201 */     // GIR_Coverage, 15462,
     /* 1960201 */     GIR_EraseRootFromParent_Done,
     /* 1960202 */   // Label 26132: @1960202
     /* 1960202 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1960293), // Rule ID 15463 //
     /* 1960207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1960218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1960221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960253 */     // MIs[0] round
     /* 1960253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960256 */     // MIs[0] policy
     /* 1960256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1960269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960292 */     // GIR_Coverage, 15463,
     /* 1960292 */     GIR_EraseRootFromParent_Done,
     /* 1960293 */   // Label 26133: @1960293
     /* 1960293 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1960384), // Rule ID 15466 //
     /* 1960298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1960309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1960312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1960324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960344 */     // MIs[0] round
     /* 1960344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960347 */     // MIs[0] policy
     /* 1960347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960357 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1960360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960383 */     // GIR_Coverage, 15466,
     /* 1960383 */     GIR_EraseRootFromParent_Done,
     /* 1960384 */   // Label 26134: @1960384
     /* 1960384 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1960475), // Rule ID 15467 //
     /* 1960389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1960400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1960403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960435 */     // MIs[0] round
     /* 1960435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960438 */     // MIs[0] policy
     /* 1960438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1960451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960474 */     // GIR_Coverage, 15467,
     /* 1960474 */     GIR_EraseRootFromParent_Done,
     /* 1960475 */   // Label 26135: @1960475
     /* 1960475 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1960566), // Rule ID 15470 //
     /* 1960480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1960497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1960506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960526 */     // MIs[0] round
     /* 1960526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960529 */     // MIs[0] policy
     /* 1960529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1960542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960565 */     // GIR_Coverage, 15470,
     /* 1960565 */     GIR_EraseRootFromParent_Done,
     /* 1960566 */   // Label 26136: @1960566
     /* 1960566 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1960657), // Rule ID 15471 //
     /* 1960571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1960588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960617 */     // MIs[0] round
     /* 1960617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960620 */     // MIs[0] policy
     /* 1960620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1960633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960656 */     // GIR_Coverage, 15471,
     /* 1960656 */     GIR_EraseRootFromParent_Done,
     /* 1960657 */   // Label 26137: @1960657
     /* 1960657 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1960748), // Rule ID 15474 //
     /* 1960662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1960665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1960679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1960688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960708 */     // MIs[0] round
     /* 1960708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960711 */     // MIs[0] policy
     /* 1960711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1960724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960747 */     // GIR_Coverage, 15474,
     /* 1960747 */     GIR_EraseRootFromParent_Done,
     /* 1960748 */   // Label 26138: @1960748
     /* 1960748 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1960839), // Rule ID 15475 //
     /* 1960753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1960770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960799 */     // MIs[0] round
     /* 1960799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960802 */     // MIs[0] policy
     /* 1960802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 1960815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960838 */     // GIR_Coverage, 15475,
     /* 1960838 */     GIR_EraseRootFromParent_Done,
     /* 1960839 */   // Label 26139: @1960839
     /* 1960839 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1960930), // Rule ID 15478 //
     /* 1960844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1960847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1960870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960890 */     // MIs[0] round
     /* 1960890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960893 */     // MIs[0] policy
     /* 1960893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960903 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1960906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1960918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1960928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960929 */     // GIR_Coverage, 15478,
     /* 1960929 */     GIR_EraseRootFromParent_Done,
     /* 1960930 */   // Label 26140: @1960930
     /* 1960930 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1961021), // Rule ID 15479 //
     /* 1960935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1960943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1960961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960981 */     // MIs[0] round
     /* 1960981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1960984 */     // MIs[0] policy
     /* 1960984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1960987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 1960997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961020 */     // GIR_Coverage, 15479,
     /* 1961020 */     GIR_EraseRootFromParent_Done,
     /* 1961021 */   // Label 26141: @1961021
     /* 1961021 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1961112), // Rule ID 15482 //
     /* 1961026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1961029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1961034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1961037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1961040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1961043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961072 */     // MIs[0] round
     /* 1961072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961075 */     // MIs[0] policy
     /* 1961075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961085 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1961088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961111 */     // GIR_Coverage, 15482,
     /* 1961111 */     GIR_EraseRootFromParent_Done,
     /* 1961112 */   // Label 26142: @1961112
     /* 1961112 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1961203), // Rule ID 15483 //
     /* 1961117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1961120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 1961125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1961128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1961131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1961134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1961143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961163 */     // MIs[0] round
     /* 1961163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961166 */     // MIs[0] policy
     /* 1961166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10830:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 1961179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961202 */     // GIR_Coverage, 15483,
     /* 1961202 */     GIR_EraseRootFromParent_Done,
     /* 1961203 */   // Label 26143: @1961203
     /* 1961203 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1961297), // Rule ID 15486 //
     /* 1961208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1961219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1961222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1961225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1961228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961254 */     // MIs[0] round
     /* 1961254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961257 */     // MIs[0] policy
     /* 1961257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961267 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 1961270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961296 */     // GIR_Coverage, 15486,
     /* 1961296 */     GIR_EraseRootFromParent_Done,
     /* 1961297 */   // Label 26144: @1961297
     /* 1961297 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1961391), // Rule ID 15487 //
     /* 1961302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1961313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1961316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1961319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1961322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1961328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961348 */     // MIs[0] round
     /* 1961348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961351 */     // MIs[0] policy
     /* 1961351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961361 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 1961364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961390 */     // GIR_Coverage, 15487,
     /* 1961390 */     GIR_EraseRootFromParent_Done,
     /* 1961391 */   // Label 26145: @1961391
     /* 1961391 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1961485), // Rule ID 15490 //
     /* 1961396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1961407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1961410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1961413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1961416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961442 */     // MIs[0] round
     /* 1961442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961445 */     // MIs[0] policy
     /* 1961445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961455 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 1961458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961484 */     // GIR_Coverage, 15490,
     /* 1961484 */     GIR_EraseRootFromParent_Done,
     /* 1961485 */   // Label 26146: @1961485
     /* 1961485 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1961579), // Rule ID 15491 //
     /* 1961490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1961501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1961504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1961507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1961510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1961516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961536 */     // MIs[0] round
     /* 1961536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961539 */     // MIs[0] policy
     /* 1961539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961549 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 1961552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961578 */     // GIR_Coverage, 15491,
     /* 1961578 */     GIR_EraseRootFromParent_Done,
     /* 1961579 */   // Label 26147: @1961579
     /* 1961579 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1961673), // Rule ID 15494 //
     /* 1961584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1961595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1961598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1961601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1961604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961630 */     // MIs[0] round
     /* 1961630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961633 */     // MIs[0] policy
     /* 1961633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961643 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1961646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961672 */     // GIR_Coverage, 15494,
     /* 1961672 */     GIR_EraseRootFromParent_Done,
     /* 1961673 */   // Label 26148: @1961673
     /* 1961673 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1961767), // Rule ID 15495 //
     /* 1961678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1961689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1961692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1961695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1961698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1961704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961724 */     // MIs[0] round
     /* 1961724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961727 */     // MIs[0] policy
     /* 1961727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961737 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1961740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961766 */     // GIR_Coverage, 15495,
     /* 1961766 */     GIR_EraseRootFromParent_Done,
     /* 1961767 */   // Label 26149: @1961767
     /* 1961767 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1961861), // Rule ID 15498 //
     /* 1961772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1961783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1961786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1961789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1961792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961818 */     // MIs[0] round
     /* 1961818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961821 */     // MIs[0] policy
     /* 1961821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961831 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 1961834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961860 */     // GIR_Coverage, 15498,
     /* 1961860 */     GIR_EraseRootFromParent_Done,
     /* 1961861 */   // Label 26150: @1961861
     /* 1961861 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1961955), // Rule ID 15499 //
     /* 1961866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1961877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1961880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1961883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1961886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1961892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961912 */     // MIs[0] round
     /* 1961912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1961915 */     // MIs[0] policy
     /* 1961915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1961918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961925 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 1961928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1961940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1961950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1961953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961954 */     // GIR_Coverage, 15499,
     /* 1961954 */     GIR_EraseRootFromParent_Done,
     /* 1961955 */   // Label 26151: @1961955
     /* 1961955 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1962049), // Rule ID 15502 //
     /* 1961960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1961968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1961971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1961974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1961977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1961980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1961986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962006 */     // MIs[0] round
     /* 1962006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962009 */     // MIs[0] policy
     /* 1962009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1962022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962048 */     // GIR_Coverage, 15502,
     /* 1962048 */     GIR_EraseRootFromParent_Done,
     /* 1962049 */   // Label 26152: @1962049
     /* 1962049 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1962143), // Rule ID 15503 //
     /* 1962054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1962080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962100 */     // MIs[0] round
     /* 1962100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962103 */     // MIs[0] policy
     /* 1962103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962113 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1962116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962142 */     // GIR_Coverage, 15503,
     /* 1962142 */     GIR_EraseRootFromParent_Done,
     /* 1962143 */   // Label 26153: @1962143
     /* 1962143 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1962237), // Rule ID 15506 //
     /* 1962148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1962168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1962174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962194 */     // MIs[0] round
     /* 1962194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962197 */     // MIs[0] policy
     /* 1962197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962207 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1962210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962236 */     // GIR_Coverage, 15506,
     /* 1962236 */     GIR_EraseRootFromParent_Done,
     /* 1962237 */   // Label 26154: @1962237
     /* 1962237 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1962331), // Rule ID 15507 //
     /* 1962242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1962262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1962268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962288 */     // MIs[0] round
     /* 1962288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962291 */     // MIs[0] policy
     /* 1962291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962301 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 1962304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962330 */     // GIR_Coverage, 15507,
     /* 1962330 */     GIR_EraseRootFromParent_Done,
     /* 1962331 */   // Label 26155: @1962331
     /* 1962331 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1962425), // Rule ID 15510 //
     /* 1962336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1962347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1962350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1962353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1962356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1962362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962382 */     // MIs[0] round
     /* 1962382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962385 */     // MIs[0] policy
     /* 1962385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962395 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962424 */     // GIR_Coverage, 15510,
     /* 1962424 */     GIR_EraseRootFromParent_Done,
     /* 1962425 */   // Label 26156: @1962425
     /* 1962425 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1962519), // Rule ID 15511 //
     /* 1962430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1962441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1962444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1962447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1962450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1962456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962476 */     // MIs[0] round
     /* 1962476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962479 */     // MIs[0] policy
     /* 1962479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962489 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962518 */     // GIR_Coverage, 15511,
     /* 1962518 */     GIR_EraseRootFromParent_Done,
     /* 1962519 */   // Label 26157: @1962519
     /* 1962519 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1962613), // Rule ID 15514 //
     /* 1962524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1962535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1962538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1962550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962570 */     // MIs[0] round
     /* 1962570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962573 */     // MIs[0] policy
     /* 1962573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962612 */     // GIR_Coverage, 15514,
     /* 1962612 */     GIR_EraseRootFromParent_Done,
     /* 1962613 */   // Label 26158: @1962613
     /* 1962613 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1962707), // Rule ID 15515 //
     /* 1962618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1962629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1962632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1962644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962664 */     // MIs[0] round
     /* 1962664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962667 */     // MIs[0] policy
     /* 1962667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962706 */     // GIR_Coverage, 15515,
     /* 1962706 */     GIR_EraseRootFromParent_Done,
     /* 1962707 */   // Label 26159: @1962707
     /* 1962707 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1962801), // Rule ID 15518 //
     /* 1962712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1962729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1962732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1962738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962758 */     // MIs[0] round
     /* 1962758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962761 */     // MIs[0] policy
     /* 1962761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962800 */     // GIR_Coverage, 15518,
     /* 1962800 */     GIR_EraseRootFromParent_Done,
     /* 1962801 */   // Label 26160: @1962801
     /* 1962801 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1962895), // Rule ID 15519 //
     /* 1962806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1962823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1962826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1962832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962852 */     // MIs[0] round
     /* 1962852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962855 */     // MIs[0] policy
     /* 1962855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1962868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962894 */     // GIR_Coverage, 15519,
     /* 1962894 */     GIR_EraseRootFromParent_Done,
     /* 1962895 */   // Label 26161: @1962895
     /* 1962895 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1962989), // Rule ID 15522 //
     /* 1962900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1962908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1962911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1962914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1962917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1962920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1962926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962946 */     // MIs[0] round
     /* 1962946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1962949 */     // MIs[0] policy
     /* 1962949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1962952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1962962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1962974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1962984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1962987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962988 */     // GIR_Coverage, 15522,
     /* 1962988 */     GIR_EraseRootFromParent_Done,
     /* 1962989 */   // Label 26162: @1962989
     /* 1962989 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1963083), // Rule ID 15523 //
     /* 1962994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1963005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1963008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1963011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1963014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963040 */     // MIs[0] round
     /* 1963040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963043 */     // MIs[0] policy
     /* 1963043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963053 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1963056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963082 */     // GIR_Coverage, 15523,
     /* 1963082 */     GIR_EraseRootFromParent_Done,
     /* 1963083 */   // Label 26163: @1963083
     /* 1963083 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1963177), // Rule ID 15526 //
     /* 1963088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1963099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1963102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1963105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1963108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1963114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963134 */     // MIs[0] round
     /* 1963134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963137 */     // MIs[0] policy
     /* 1963137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963147 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1963150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963176 */     // GIR_Coverage, 15526,
     /* 1963176 */     GIR_EraseRootFromParent_Done,
     /* 1963177 */   // Label 26164: @1963177
     /* 1963177 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1963271), // Rule ID 15527 //
     /* 1963182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1963193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1963196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1963199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1963202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963228 */     // MIs[0] round
     /* 1963228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963231 */     // MIs[0] policy
     /* 1963231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963241 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1963244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963270 */     // GIR_Coverage, 15527,
     /* 1963270 */     GIR_EraseRootFromParent_Done,
     /* 1963271 */   // Label 26165: @1963271
     /* 1963271 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1963365), // Rule ID 15530 //
     /* 1963276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1963287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1963290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1963293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1963296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1963299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1963302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963322 */     // MIs[0] round
     /* 1963322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963325 */     // MIs[0] policy
     /* 1963325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963335 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1963338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963364 */     // GIR_Coverage, 15530,
     /* 1963364 */     GIR_EraseRootFromParent_Done,
     /* 1963365 */   // Label 26166: @1963365
     /* 1963365 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1963459), // Rule ID 15531 //
     /* 1963370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1963381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1963384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1963387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1963390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1963393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963416 */     // MIs[0] round
     /* 1963416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963419 */     // MIs[0] policy
     /* 1963419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963429 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1963432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963458 */     // GIR_Coverage, 15531,
     /* 1963458 */     GIR_EraseRootFromParent_Done,
     /* 1963459 */   // Label 26167: @1963459
     /* 1963459 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1963553), // Rule ID 15534 //
     /* 1963464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1963490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963510 */     // MIs[0] round
     /* 1963510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963513 */     // MIs[0] policy
     /* 1963513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1963526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963552 */     // GIR_Coverage, 15534,
     /* 1963552 */     GIR_EraseRootFromParent_Done,
     /* 1963553 */   // Label 26168: @1963553
     /* 1963553 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1963647), // Rule ID 15535 //
     /* 1963558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963604 */     // MIs[0] round
     /* 1963604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963607 */     // MIs[0] policy
     /* 1963607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1963620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963646 */     // GIR_Coverage, 15535,
     /* 1963646 */     GIR_EraseRootFromParent_Done,
     /* 1963647 */   // Label 26169: @1963647
     /* 1963647 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1963741), // Rule ID 15538 //
     /* 1963652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1963678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963698 */     // MIs[0] round
     /* 1963698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963701 */     // MIs[0] policy
     /* 1963701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1963714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963740 */     // GIR_Coverage, 15538,
     /* 1963740 */     GIR_EraseRootFromParent_Done,
     /* 1963741 */   // Label 26170: @1963741
     /* 1963741 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1963835), // Rule ID 15539 //
     /* 1963746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963792 */     // MIs[0] round
     /* 1963792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963795 */     // MIs[0] policy
     /* 1963795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963805 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1963808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963834 */     // GIR_Coverage, 15539,
     /* 1963834 */     GIR_EraseRootFromParent_Done,
     /* 1963835 */   // Label 26171: @1963835
     /* 1963835 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1963929), // Rule ID 15542 //
     /* 1963840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1963866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963886 */     // MIs[0] round
     /* 1963886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963889 */     // MIs[0] policy
     /* 1963889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963899 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1963902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1963914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1963924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1963927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963928 */     // GIR_Coverage, 15542,
     /* 1963928 */     GIR_EraseRootFromParent_Done,
     /* 1963929 */   // Label 26172: @1963929
     /* 1963929 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1964023), // Rule ID 15543 //
     /* 1963934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1963942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1963960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963980 */     // MIs[0] round
     /* 1963980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1963983 */     // MIs[0] policy
     /* 1963983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1963986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963993 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1963996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964022 */     // GIR_Coverage, 15543,
     /* 1964022 */     GIR_EraseRootFromParent_Done,
     /* 1964023 */   // Label 26173: @1964023
     /* 1964023 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1964117), // Rule ID 15546 //
     /* 1964028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1964048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964074 */     // MIs[0] round
     /* 1964074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964077 */     // MIs[0] policy
     /* 1964077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1964090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964116 */     // GIR_Coverage, 15546,
     /* 1964116 */     GIR_EraseRootFromParent_Done,
     /* 1964117 */   // Label 26174: @1964117
     /* 1964117 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1964211), // Rule ID 15547 //
     /* 1964122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1964142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1964148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964168 */     // MIs[0] round
     /* 1964168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964171 */     // MIs[0] policy
     /* 1964171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1964184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964210 */     // GIR_Coverage, 15547,
     /* 1964210 */     GIR_EraseRootFromParent_Done,
     /* 1964211 */   // Label 26175: @1964211
     /* 1964211 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1964305), // Rule ID 15550 //
     /* 1964216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1964236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964262 */     // MIs[0] round
     /* 1964262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964265 */     // MIs[0] policy
     /* 1964265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964275 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1964278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964304 */     // GIR_Coverage, 15550,
     /* 1964304 */     GIR_EraseRootFromParent_Done,
     /* 1964305 */   // Label 26176: @1964305
     /* 1964305 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1964399), // Rule ID 15551 //
     /* 1964310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1964330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1964336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964356 */     // MIs[0] round
     /* 1964356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964359 */     // MIs[0] policy
     /* 1964359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1964372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964398 */     // GIR_Coverage, 15551,
     /* 1964398 */     GIR_EraseRootFromParent_Done,
     /* 1964399 */   // Label 26177: @1964399
     /* 1964399 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1964493), // Rule ID 15554 //
     /* 1964404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1964424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964450 */     // MIs[0] round
     /* 1964450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964453 */     // MIs[0] policy
     /* 1964453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964463 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1964466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964492 */     // GIR_Coverage, 15554,
     /* 1964492 */     GIR_EraseRootFromParent_Done,
     /* 1964493 */   // Label 26178: @1964493
     /* 1964493 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1964587), // Rule ID 15555 //
     /* 1964498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1964518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1964524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964544 */     // MIs[0] round
     /* 1964544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964547 */     // MIs[0] policy
     /* 1964547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964557 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1964560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964586 */     // GIR_Coverage, 15555,
     /* 1964586 */     GIR_EraseRootFromParent_Done,
     /* 1964587 */   // Label 26179: @1964587
     /* 1964587 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1964681), // Rule ID 15558 //
     /* 1964592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1964603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1964606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1964609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964638 */     // MIs[0] round
     /* 1964638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964641 */     // MIs[0] policy
     /* 1964641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964651 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 1964654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1964674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964680 */     // GIR_Coverage, 15558,
     /* 1964680 */     GIR_EraseRootFromParent_Done,
     /* 1964681 */   // Label 26180: @1964681
     /* 1964681 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1964775), // Rule ID 15559 //
     /* 1964686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1964697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1964700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1964703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1964712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964732 */     // MIs[0] round
     /* 1964732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964735 */     // MIs[0] policy
     /* 1964735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964745 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 1964748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1964768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964774 */     // GIR_Coverage, 15559,
     /* 1964774 */     GIR_EraseRootFromParent_Done,
     /* 1964775 */   // Label 26181: @1964775
     /* 1964775 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1964869), // Rule ID 15562 //
     /* 1964780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1964791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1964794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1964797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964826 */     // MIs[0] round
     /* 1964826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964829 */     // MIs[0] policy
     /* 1964829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964839 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 1964842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1964862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964868 */     // GIR_Coverage, 15562,
     /* 1964868 */     GIR_EraseRootFromParent_Done,
     /* 1964869 */   // Label 26182: @1964869
     /* 1964869 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1964963), // Rule ID 15563 //
     /* 1964874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1964885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1964888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1964891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1964900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964920 */     // MIs[0] round
     /* 1964920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1964923 */     // MIs[0] policy
     /* 1964923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1964926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964933 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 1964936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1964948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1964956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1964958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1964961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964962 */     // GIR_Coverage, 15563,
     /* 1964962 */     GIR_EraseRootFromParent_Done,
     /* 1964963 */   // Label 26183: @1964963
     /* 1964963 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1965057), // Rule ID 15566 //
     /* 1964968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1964976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1964979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1964982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1964985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1964994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965014 */     // MIs[0] round
     /* 1965014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965017 */     // MIs[0] policy
     /* 1965017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965056 */     // GIR_Coverage, 15566,
     /* 1965056 */     GIR_EraseRootFromParent_Done,
     /* 1965057 */   // Label 26184: @1965057
     /* 1965057 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1965151), // Rule ID 15567 //
     /* 1965062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1965065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1965073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1965076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1965088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965108 */     // MIs[0] round
     /* 1965108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965111 */     // MIs[0] policy
     /* 1965111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965121 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965150 */     // GIR_Coverage, 15567,
     /* 1965150 */     GIR_EraseRootFromParent_Done,
     /* 1965151 */   // Label 26185: @1965151
     /* 1965151 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1965245), // Rule ID 15570 //
     /* 1965156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1965159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1965173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1965182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965202 */     // MIs[0] round
     /* 1965202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965205 */     // MIs[0] policy
     /* 1965205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965215 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 1965218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965244 */     // GIR_Coverage, 15570,
     /* 1965244 */     GIR_EraseRootFromParent_Done,
     /* 1965245 */   // Label 26186: @1965245
     /* 1965245 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1965339), // Rule ID 15571 //
     /* 1965250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1965253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1965267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1965276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965296 */     // MIs[0] round
     /* 1965296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965299 */     // MIs[0] policy
     /* 1965299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 1965312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965338 */     // GIR_Coverage, 15571,
     /* 1965338 */     GIR_EraseRootFromParent_Done,
     /* 1965339 */   // Label 26187: @1965339
     /* 1965339 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1965433), // Rule ID 15574 //
     /* 1965344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1965347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1965361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1965370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965390 */     // MIs[0] round
     /* 1965390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965393 */     // MIs[0] policy
     /* 1965393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965403 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965432 */     // GIR_Coverage, 15574,
     /* 1965432 */     GIR_EraseRootFromParent_Done,
     /* 1965433 */   // Label 26188: @1965433
     /* 1965433 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1965527), // Rule ID 15575 //
     /* 1965438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1965441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1965455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1965464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965484 */     // MIs[0] round
     /* 1965484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965487 */     // MIs[0] policy
     /* 1965487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965497 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965526 */     // GIR_Coverage, 15575,
     /* 1965526 */     GIR_EraseRootFromParent_Done,
     /* 1965527 */   // Label 26189: @1965527
     /* 1965527 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1965621), // Rule ID 15578 //
     /* 1965532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1965535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1965543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1965546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1965549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1965558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965578 */     // MIs[0] round
     /* 1965578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965581 */     // MIs[0] policy
     /* 1965581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965620 */     // GIR_Coverage, 15578,
     /* 1965620 */     GIR_EraseRootFromParent_Done,
     /* 1965621 */   // Label 26190: @1965621
     /* 1965621 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1965715), // Rule ID 15579 //
     /* 1965626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1965629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1965637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1965640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1965643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1965652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965672 */     // MIs[0] round
     /* 1965672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965675 */     // MIs[0] policy
     /* 1965675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965685 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 1965688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965714 */     // GIR_Coverage, 15579,
     /* 1965714 */     GIR_EraseRootFromParent_Done,
     /* 1965715 */   // Label 26191: @1965715
     /* 1965715 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1965809), // Rule ID 15582 //
     /* 1965720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1965723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1965731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1965734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1965746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965766 */     // MIs[0] round
     /* 1965766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965769 */     // MIs[0] policy
     /* 1965769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965779 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1965782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965808 */     // GIR_Coverage, 15582,
     /* 1965808 */     GIR_EraseRootFromParent_Done,
     /* 1965809 */   // Label 26192: @1965809
     /* 1965809 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1965903), // Rule ID 15583 //
     /* 1965814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1965817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1965825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1965828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1965840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965860 */     // MIs[0] round
     /* 1965860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965863 */     // MIs[0] policy
     /* 1965863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965873 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1965876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965902 */     // GIR_Coverage, 15583,
     /* 1965902 */     GIR_EraseRootFromParent_Done,
     /* 1965903 */   // Label 26193: @1965903
     /* 1965903 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1965997), // Rule ID 15586 //
     /* 1965908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1965911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1965916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1965925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1965934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965954 */     // MIs[0] round
     /* 1965954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1965957 */     // MIs[0] policy
     /* 1965957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1965960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965967 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1965970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1965982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1965992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1965995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965996 */     // GIR_Coverage, 15586,
     /* 1965996 */     GIR_EraseRootFromParent_Done,
     /* 1965997 */   // Label 26194: @1965997
     /* 1965997 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1966091), // Rule ID 15587 //
     /* 1966002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1966013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1966016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966048 */     // MIs[0] round
     /* 1966048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966051 */     // MIs[0] policy
     /* 1966051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966061 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1966064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966090 */     // GIR_Coverage, 15587,
     /* 1966090 */     GIR_EraseRootFromParent_Done,
     /* 1966091 */   // Label 26195: @1966091
     /* 1966091 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1966185), // Rule ID 15590 //
     /* 1966096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1966099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1966113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1966122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966142 */     // MIs[0] round
     /* 1966142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966145 */     // MIs[0] policy
     /* 1966145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966155 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1966158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966184 */     // GIR_Coverage, 15590,
     /* 1966184 */     GIR_EraseRootFromParent_Done,
     /* 1966185 */   // Label 26196: @1966185
     /* 1966185 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1966279), // Rule ID 15591 //
     /* 1966190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1966207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966236 */     // MIs[0] round
     /* 1966236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966239 */     // MIs[0] policy
     /* 1966239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1966252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966278 */     // GIR_Coverage, 15591,
     /* 1966278 */     GIR_EraseRootFromParent_Done,
     /* 1966279 */   // Label 26197: @1966279
     /* 1966279 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1966373), // Rule ID 15594 //
     /* 1966284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1966287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1966295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1966298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1966310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966330 */     // MIs[0] round
     /* 1966330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966333 */     // MIs[0] policy
     /* 1966333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1966346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966372 */     // GIR_Coverage, 15594,
     /* 1966372 */     GIR_EraseRootFromParent_Done,
     /* 1966373 */   // Label 26198: @1966373
     /* 1966373 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1966467), // Rule ID 15595 //
     /* 1966378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1966389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1966392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966424 */     // MIs[0] round
     /* 1966424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966427 */     // MIs[0] policy
     /* 1966427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1966440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966466 */     // GIR_Coverage, 15595,
     /* 1966466 */     GIR_EraseRootFromParent_Done,
     /* 1966467 */   // Label 26199: @1966467
     /* 1966467 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1966561), // Rule ID 15598 //
     /* 1966472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1966475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1966483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1966486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1966498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966518 */     // MIs[0] round
     /* 1966518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966521 */     // MIs[0] policy
     /* 1966521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966531 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1966534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966560 */     // GIR_Coverage, 15598,
     /* 1966560 */     GIR_EraseRootFromParent_Done,
     /* 1966561 */   // Label 26200: @1966561
     /* 1966561 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1966655), // Rule ID 15599 //
     /* 1966566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1966577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1966580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966612 */     // MIs[0] round
     /* 1966612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966615 */     // MIs[0] policy
     /* 1966615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966625 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1966628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966654 */     // GIR_Coverage, 15599,
     /* 1966654 */     GIR_EraseRootFromParent_Done,
     /* 1966655 */   // Label 26201: @1966655
     /* 1966655 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1966749), // Rule ID 15602 //
     /* 1966660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1966663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1966671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1966674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1966677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1966683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1966686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966706 */     // MIs[0] round
     /* 1966706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966709 */     // MIs[0] policy
     /* 1966709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1966722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966748 */     // GIR_Coverage, 15602,
     /* 1966748 */     GIR_EraseRootFromParent_Done,
     /* 1966749 */   // Label 26202: @1966749
     /* 1966749 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1966843), // Rule ID 15603 //
     /* 1966754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1966765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1966768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1966771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1966777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966800 */     // MIs[0] round
     /* 1966800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966803 */     // MIs[0] policy
     /* 1966803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966813 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1966816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966842 */     // GIR_Coverage, 15603,
     /* 1966842 */     GIR_EraseRootFromParent_Done,
     /* 1966843 */   // Label 26203: @1966843
     /* 1966843 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1966937), // Rule ID 15606 //
     /* 1966848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1966851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1966859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1966862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1966874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966894 */     // MIs[0] round
     /* 1966894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966897 */     // MIs[0] policy
     /* 1966897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1966910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1966922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1966932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1966935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966936 */     // GIR_Coverage, 15606,
     /* 1966936 */     GIR_EraseRootFromParent_Done,
     /* 1966937 */   // Label 26204: @1966937
     /* 1966937 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1967031), // Rule ID 15607 //
     /* 1966942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1966945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1966950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1966953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1966956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1966968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966988 */     // MIs[0] round
     /* 1966988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1966991 */     // MIs[0] policy
     /* 1966991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1966994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1967004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967030 */     // GIR_Coverage, 15607,
     /* 1967030 */     GIR_EraseRootFromParent_Done,
     /* 1967031 */   // Label 26205: @1967031
     /* 1967031 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1967125), // Rule ID 15610 //
     /* 1967036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1967039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1967047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1967050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1967062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967082 */     // MIs[0] round
     /* 1967082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967085 */     // MIs[0] policy
     /* 1967085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967095 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1967098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967124 */     // GIR_Coverage, 15610,
     /* 1967124 */     GIR_EraseRootFromParent_Done,
     /* 1967125 */   // Label 26206: @1967125
     /* 1967125 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1967219), // Rule ID 15611 //
     /* 1967130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1967133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1967141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1967144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1967156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967176 */     // MIs[0] round
     /* 1967176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967179 */     // MIs[0] policy
     /* 1967179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967189 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1967192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967218 */     // GIR_Coverage, 15611,
     /* 1967218 */     GIR_EraseRootFromParent_Done,
     /* 1967219 */   // Label 26207: @1967219
     /* 1967219 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1967313), // Rule ID 15614 //
     /* 1967224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1967227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1967235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1967238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1967241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1967247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1967250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967270 */     // MIs[0] round
     /* 1967270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967273 */     // MIs[0] policy
     /* 1967273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967283 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1967286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967312 */     // GIR_Coverage, 15614,
     /* 1967312 */     GIR_EraseRootFromParent_Done,
     /* 1967313 */   // Label 26208: @1967313
     /* 1967313 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1967407), // Rule ID 15615 //
     /* 1967318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1967321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1967329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1967332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1967335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1967341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1967344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967364 */     // MIs[0] round
     /* 1967364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967367 */     // MIs[0] policy
     /* 1967367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1967380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967406 */     // GIR_Coverage, 15615,
     /* 1967406 */     GIR_EraseRootFromParent_Done,
     /* 1967407 */   // Label 26209: @1967407
     /* 1967407 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1967501), // Rule ID 15618 //
     /* 1967412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1967415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1967423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1967426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1967438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967458 */     // MIs[0] round
     /* 1967458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967461 */     // MIs[0] policy
     /* 1967461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1967474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967500 */     // GIR_Coverage, 15618,
     /* 1967500 */     GIR_EraseRootFromParent_Done,
     /* 1967501 */   // Label 26210: @1967501
     /* 1967501 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1967595), // Rule ID 15619 //
     /* 1967506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1967509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1967517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1967520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1967532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967552 */     // MIs[0] round
     /* 1967552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967555 */     // MIs[0] policy
     /* 1967555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1967568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967594 */     // GIR_Coverage, 15619,
     /* 1967594 */     GIR_EraseRootFromParent_Done,
     /* 1967595 */   // Label 26211: @1967595
     /* 1967595 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1967689), // Rule ID 15622 //
     /* 1967600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1967603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1967626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967646 */     // MIs[0] round
     /* 1967646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967649 */     // MIs[0] policy
     /* 1967649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967659 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1967662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967688 */     // GIR_Coverage, 15622,
     /* 1967688 */     GIR_EraseRootFromParent_Done,
     /* 1967689 */   // Label 26212: @1967689
     /* 1967689 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1967783), // Rule ID 15623 //
     /* 1967694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1967697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1967720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967740 */     // MIs[0] round
     /* 1967740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967743 */     // MIs[0] policy
     /* 1967743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967753 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1967756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967782 */     // GIR_Coverage, 15623,
     /* 1967782 */     GIR_EraseRootFromParent_Done,
     /* 1967783 */   // Label 26213: @1967783
     /* 1967783 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1967877), // Rule ID 15626 //
     /* 1967788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1967791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1967805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1967814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967834 */     // MIs[0] round
     /* 1967834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967837 */     // MIs[0] policy
     /* 1967837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967847 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1967850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967876 */     // GIR_Coverage, 15626,
     /* 1967876 */     GIR_EraseRootFromParent_Done,
     /* 1967877 */   // Label 26214: @1967877
     /* 1967877 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1967971), // Rule ID 15627 //
     /* 1967882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1967885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1967899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1967908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967928 */     // MIs[0] round
     /* 1967928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1967931 */     // MIs[0] policy
     /* 1967931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1967934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967941 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1967944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1967956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1967966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1967969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967970 */     // GIR_Coverage, 15627,
     /* 1967970 */     GIR_EraseRootFromParent_Done,
     /* 1967971 */   // Label 26215: @1967971
     /* 1967971 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1968065), // Rule ID 15630 //
     /* 1967976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1967979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1967984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1967996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968022 */     // MIs[0] round
     /* 1968022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968025 */     // MIs[0] policy
     /* 1968025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968035 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1968038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968064 */     // GIR_Coverage, 15630,
     /* 1968064 */     GIR_EraseRootFromParent_Done,
     /* 1968065 */   // Label 26216: @1968065
     /* 1968065 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1968159), // Rule ID 15631 //
     /* 1968070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1968073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1968081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1968090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1968096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968116 */     // MIs[0] round
     /* 1968116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968119 */     // MIs[0] policy
     /* 1968119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 1968132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968158 */     // GIR_Coverage, 15631,
     /* 1968158 */     GIR_EraseRootFromParent_Done,
     /* 1968159 */   // Label 26217: @1968159
     /* 1968159 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1968253), // Rule ID 15634 //
     /* 1968164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1968167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1968184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968210 */     // MIs[0] round
     /* 1968210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968213 */     // MIs[0] policy
     /* 1968213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1968226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968252 */     // GIR_Coverage, 15634,
     /* 1968252 */     GIR_EraseRootFromParent_Done,
     /* 1968253 */   // Label 26218: @1968253
     /* 1968253 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1968347), // Rule ID 15635 //
     /* 1968258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1968261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1968278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1968284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968304 */     // MIs[0] round
     /* 1968304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968307 */     // MIs[0] policy
     /* 1968307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 1968320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968346 */     // GIR_Coverage, 15635,
     /* 1968346 */     GIR_EraseRootFromParent_Done,
     /* 1968347 */   // Label 26219: @1968347
     /* 1968347 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1968441), // Rule ID 15638 //
     /* 1968352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1968355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1968372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968398 */     // MIs[0] round
     /* 1968398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968401 */     // MIs[0] policy
     /* 1968401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968411 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1968414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968440 */     // GIR_Coverage, 15638,
     /* 1968440 */     GIR_EraseRootFromParent_Done,
     /* 1968441 */   // Label 26220: @1968441
     /* 1968441 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1968535), // Rule ID 15639 //
     /* 1968446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1968449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1968466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1968472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968492 */     // MIs[0] round
     /* 1968492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968495 */     // MIs[0] policy
     /* 1968495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 1968508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968534 */     // GIR_Coverage, 15639,
     /* 1968534 */     GIR_EraseRootFromParent_Done,
     /* 1968535 */   // Label 26221: @1968535
     /* 1968535 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1968629), // Rule ID 15642 //
     /* 1968540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1968543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1968560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968586 */     // MIs[0] round
     /* 1968586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968589 */     // MIs[0] policy
     /* 1968589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1968602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968628 */     // GIR_Coverage, 15642,
     /* 1968628 */     GIR_EraseRootFromParent_Done,
     /* 1968629 */   // Label 26222: @1968629
     /* 1968629 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1968723), // Rule ID 15643 //
     /* 1968634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1968637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1968654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1968660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968680 */     // MIs[0] round
     /* 1968680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968683 */     // MIs[0] policy
     /* 1968683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 1968696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968722 */     // GIR_Coverage, 15643,
     /* 1968722 */     GIR_EraseRootFromParent_Done,
     /* 1968723 */   // Label 26223: @1968723
     /* 1968723 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1968817), // Rule ID 15646 //
     /* 1968728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1968731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1968739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968774 */     // MIs[0] round
     /* 1968774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968777 */     // MIs[0] policy
     /* 1968777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968787 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1968790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968816 */     // GIR_Coverage, 15646,
     /* 1968816 */     GIR_EraseRootFromParent_Done,
     /* 1968817 */   // Label 26224: @1968817
     /* 1968817 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1968911), // Rule ID 15647 //
     /* 1968822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1968825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1968833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1968848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968868 */     // MIs[0] round
     /* 1968868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968871 */     // MIs[0] policy
     /* 1968871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968881 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 1968884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1968906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1968909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968910 */     // GIR_Coverage, 15647,
     /* 1968910 */     GIR_EraseRootFromParent_Done,
     /* 1968911 */   // Label 26225: @1968911
     /* 1968911 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1969005), // Rule ID 15650 //
     /* 1968916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1968919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1968924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1968942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968962 */     // MIs[0] round
     /* 1968962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1968965 */     // MIs[0] policy
     /* 1968965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1968968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1968978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1968990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969004 */     // GIR_Coverage, 15650,
     /* 1969004 */     GIR_EraseRootFromParent_Done,
     /* 1969005 */   // Label 26226: @1969005
     /* 1969005 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1969099), // Rule ID 15651 //
     /* 1969010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1969013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1969018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1969027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969056 */     // MIs[0] round
     /* 1969056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969059 */     // MIs[0] policy
     /* 1969059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 1969072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969098 */     // GIR_Coverage, 15651,
     /* 1969098 */     GIR_EraseRootFromParent_Done,
     /* 1969099 */   // Label 26227: @1969099
     /* 1969099 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1969193), // Rule ID 15654 //
     /* 1969104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1969107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1969112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1969130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969150 */     // MIs[0] round
     /* 1969150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969153 */     // MIs[0] policy
     /* 1969153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969163 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1969166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969192 */     // GIR_Coverage, 15654,
     /* 1969192 */     GIR_EraseRootFromParent_Done,
     /* 1969193 */   // Label 26228: @1969193
     /* 1969193 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1969287), // Rule ID 15655 //
     /* 1969198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1969201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1969206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969244 */     // MIs[0] round
     /* 1969244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969247 */     // MIs[0] policy
     /* 1969247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969257 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 1969260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969286 */     // GIR_Coverage, 15655,
     /* 1969286 */     GIR_EraseRootFromParent_Done,
     /* 1969287 */   // Label 26229: @1969287
     /* 1969287 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1969381), // Rule ID 15658 //
     /* 1969292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1969295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1969300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1969318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969338 */     // MIs[0] round
     /* 1969338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969341 */     // MIs[0] policy
     /* 1969341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1969354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969380 */     // GIR_Coverage, 15658,
     /* 1969380 */     GIR_EraseRootFromParent_Done,
     /* 1969381 */   // Label 26230: @1969381
     /* 1969381 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1969475), // Rule ID 15659 //
     /* 1969386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1969389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 1969394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969432 */     // MIs[0] round
     /* 1969432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969435 */     // MIs[0] policy
     /* 1969435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969445 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 1969448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1969473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969474 */     // GIR_Coverage, 15659,
     /* 1969474 */     GIR_EraseRootFromParent_Done,
     /* 1969475 */   // Label 26231: @1969475
     /* 1969475 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1969566), // Rule ID 15662 //
     /* 1969480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1969483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1969491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1969494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1969497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1969500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1969506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969526 */     // MIs[0] round
     /* 1969526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969529 */     // MIs[0] policy
     /* 1969529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 1969542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969565 */     // GIR_Coverage, 15662,
     /* 1969565 */     GIR_EraseRootFromParent_Done,
     /* 1969566 */   // Label 26232: @1969566
     /* 1969566 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1969657), // Rule ID 15663 //
     /* 1969571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1969574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1969582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1969585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1969588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1969591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969617 */     // MIs[0] round
     /* 1969617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969620 */     // MIs[0] policy
     /* 1969620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 1969633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969656 */     // GIR_Coverage, 15663,
     /* 1969656 */     GIR_EraseRootFromParent_Done,
     /* 1969657 */   // Label 26233: @1969657
     /* 1969657 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1969748), // Rule ID 15666 //
     /* 1969662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1969665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1969673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1969676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1969679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1969682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1969688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969708 */     // MIs[0] round
     /* 1969708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969711 */     // MIs[0] policy
     /* 1969711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 1969724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969747 */     // GIR_Coverage, 15666,
     /* 1969747 */     GIR_EraseRootFromParent_Done,
     /* 1969748 */   // Label 26234: @1969748
     /* 1969748 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1969839), // Rule ID 15667 //
     /* 1969753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1969756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1969764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1969767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1969770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1969773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969799 */     // MIs[0] round
     /* 1969799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969802 */     // MIs[0] policy
     /* 1969802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 1969815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969838 */     // GIR_Coverage, 15667,
     /* 1969838 */     GIR_EraseRootFromParent_Done,
     /* 1969839 */   // Label 26235: @1969839
     /* 1969839 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1969930), // Rule ID 15670 //
     /* 1969844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1969847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1969855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1969858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1969861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1969864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1969870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969890 */     // MIs[0] round
     /* 1969890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969893 */     // MIs[0] policy
     /* 1969893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969903 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1969906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1969918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1969928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969929 */     // GIR_Coverage, 15670,
     /* 1969929 */     GIR_EraseRootFromParent_Done,
     /* 1969930 */   // Label 26236: @1969930
     /* 1969930 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1970021), // Rule ID 15671 //
     /* 1969935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1969938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1969943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1969946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1969949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1969952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1969955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1969961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969981 */     // MIs[0] round
     /* 1969981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1969984 */     // MIs[0] policy
     /* 1969984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1969987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969994 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1969997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970020 */     // GIR_Coverage, 15671,
     /* 1970020 */     GIR_EraseRootFromParent_Done,
     /* 1970021 */   // Label 26237: @1970021
     /* 1970021 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1970112), // Rule ID 15674 //
     /* 1970026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1970037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1970040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1970043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1970046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970072 */     // MIs[0] round
     /* 1970072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970075 */     // MIs[0] policy
     /* 1970075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 1970088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970111 */     // GIR_Coverage, 15674,
     /* 1970111 */     GIR_EraseRootFromParent_Done,
     /* 1970112 */   // Label 26238: @1970112
     /* 1970112 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1970203), // Rule ID 15675 //
     /* 1970117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1970120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1970128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1970131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1970134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1970137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1970143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970163 */     // MIs[0] round
     /* 1970163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970166 */     // MIs[0] policy
     /* 1970166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 1970179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970202 */     // GIR_Coverage, 15675,
     /* 1970202 */     GIR_EraseRootFromParent_Done,
     /* 1970203 */   // Label 26239: @1970203
     /* 1970203 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1970294), // Rule ID 15678 //
     /* 1970208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1970219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1970222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1970228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970254 */     // MIs[0] round
     /* 1970254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970257 */     // MIs[0] policy
     /* 1970257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1970270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970293 */     // GIR_Coverage, 15678,
     /* 1970293 */     GIR_EraseRootFromParent_Done,
     /* 1970294 */   // Label 26240: @1970294
     /* 1970294 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1970385), // Rule ID 15679 //
     /* 1970299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1970302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1970310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1970313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1970319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1970325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970345 */     // MIs[0] round
     /* 1970345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970348 */     // MIs[0] policy
     /* 1970348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1970361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970384 */     // GIR_Coverage, 15679,
     /* 1970384 */     GIR_EraseRootFromParent_Done,
     /* 1970385 */   // Label 26241: @1970385
     /* 1970385 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1970476), // Rule ID 15682 //
     /* 1970390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1970401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1970404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1970410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970436 */     // MIs[0] round
     /* 1970436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970439 */     // MIs[0] policy
     /* 1970439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1970452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970475 */     // GIR_Coverage, 15682,
     /* 1970475 */     GIR_EraseRootFromParent_Done,
     /* 1970476 */   // Label 26242: @1970476
     /* 1970476 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1970567), // Rule ID 15683 //
     /* 1970481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1970484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1970492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1970495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1970501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1970507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970527 */     // MIs[0] round
     /* 1970527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970530 */     // MIs[0] policy
     /* 1970530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 1970543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970566 */     // GIR_Coverage, 15683,
     /* 1970566 */     GIR_EraseRootFromParent_Done,
     /* 1970567 */   // Label 26243: @1970567
     /* 1970567 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1970658), // Rule ID 15686 //
     /* 1970572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1970583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1970586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1970589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1970592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970618 */     // MIs[0] round
     /* 1970618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970621 */     // MIs[0] policy
     /* 1970621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970631 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1970634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970657 */     // GIR_Coverage, 15686,
     /* 1970657 */     GIR_EraseRootFromParent_Done,
     /* 1970658 */   // Label 26244: @1970658
     /* 1970658 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1970749), // Rule ID 15687 //
     /* 1970663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1970666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1970674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1970677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1970680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1970683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1970689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970709 */     // MIs[0] round
     /* 1970709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970712 */     // MIs[0] policy
     /* 1970712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970722 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1970725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970748 */     // GIR_Coverage, 15687,
     /* 1970748 */     GIR_EraseRootFromParent_Done,
     /* 1970749 */   // Label 26245: @1970749
     /* 1970749 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1970840), // Rule ID 15690 //
     /* 1970754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1970765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1970768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1970771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1970774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970800 */     // MIs[0] round
     /* 1970800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970803 */     // MIs[0] policy
     /* 1970803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1970816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970839 */     // GIR_Coverage, 15690,
     /* 1970839 */     GIR_EraseRootFromParent_Done,
     /* 1970840 */   // Label 26246: @1970840
     /* 1970840 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1970931), // Rule ID 15691 //
     /* 1970845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1970848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1970856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1970859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1970862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1970865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1970871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970891 */     // MIs[0] round
     /* 1970891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970894 */     // MIs[0] policy
     /* 1970894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1970907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1970919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1970929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970930 */     // GIR_Coverage, 15691,
     /* 1970930 */     GIR_EraseRootFromParent_Done,
     /* 1970931 */   // Label 26247: @1970931
     /* 1970931 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1971022), // Rule ID 15694 //
     /* 1970936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1970939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1970944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1970947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1970950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1970956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1970962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970982 */     // MIs[0] round
     /* 1970982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1970985 */     // MIs[0] policy
     /* 1970985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1970988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1970998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971021 */     // GIR_Coverage, 15694,
     /* 1971021 */     GIR_EraseRootFromParent_Done,
     /* 1971022 */   // Label 26248: @1971022
     /* 1971022 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1971113), // Rule ID 15695 //
     /* 1971027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1971030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1971038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1971041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1971044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1971047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971073 */     // MIs[0] round
     /* 1971073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971076 */     // MIs[0] policy
     /* 1971076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1971089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971112 */     // GIR_Coverage, 15695,
     /* 1971112 */     GIR_EraseRootFromParent_Done,
     /* 1971113 */   // Label 26249: @1971113
     /* 1971113 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1971204), // Rule ID 15698 //
     /* 1971118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1971121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1971144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971164 */     // MIs[0] round
     /* 1971164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971167 */     // MIs[0] policy
     /* 1971167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1971180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971203 */     // GIR_Coverage, 15698,
     /* 1971203 */     GIR_EraseRootFromParent_Done,
     /* 1971204 */   // Label 26250: @1971204
     /* 1971204 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1971295), // Rule ID 15699 //
     /* 1971209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1971212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971255 */     // MIs[0] round
     /* 1971255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971258 */     // MIs[0] policy
     /* 1971258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 1971271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971294 */     // GIR_Coverage, 15699,
     /* 1971294 */     GIR_EraseRootFromParent_Done,
     /* 1971295 */   // Label 26251: @1971295
     /* 1971295 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1971386), // Rule ID 15702 //
     /* 1971300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1971303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1971311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1971314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1971317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1971320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1971323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1971326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971346 */     // MIs[0] round
     /* 1971346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971349 */     // MIs[0] policy
     /* 1971349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1971362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971385 */     // GIR_Coverage, 15702,
     /* 1971385 */     GIR_EraseRootFromParent_Done,
     /* 1971386 */   // Label 26252: @1971386
     /* 1971386 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1971477), // Rule ID 15703 //
     /* 1971391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1971394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1971402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1971405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1971408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1971411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1971414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971437 */     // MIs[0] round
     /* 1971437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971440 */     // MIs[0] policy
     /* 1971440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1971453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971476 */     // GIR_Coverage, 15703,
     /* 1971476 */     GIR_EraseRootFromParent_Done,
     /* 1971477 */   // Label 26253: @1971477
     /* 1971477 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1971568), // Rule ID 15706 //
     /* 1971482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1971485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1971493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1971496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1971499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1971502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1971505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1971508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971528 */     // MIs[0] round
     /* 1971528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971531 */     // MIs[0] policy
     /* 1971531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971541 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1971544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971567 */     // GIR_Coverage, 15706,
     /* 1971567 */     GIR_EraseRootFromParent_Done,
     /* 1971568 */   // Label 26254: @1971568
     /* 1971568 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1971659), // Rule ID 15707 //
     /* 1971573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1971576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1971584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1971587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1971590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1971593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1971596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971619 */     // MIs[0] round
     /* 1971619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971622 */     // MIs[0] policy
     /* 1971622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971632 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1971635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971658 */     // GIR_Coverage, 15707,
     /* 1971658 */     GIR_EraseRootFromParent_Done,
     /* 1971659 */   // Label 26255: @1971659
     /* 1971659 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1971750), // Rule ID 15710 //
     /* 1971664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1971667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1971675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1971678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1971681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1971684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1971687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1971690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971710 */     // MIs[0] round
     /* 1971710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971713 */     // MIs[0] policy
     /* 1971713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971723 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1971726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971749 */     // GIR_Coverage, 15710,
     /* 1971749 */     GIR_EraseRootFromParent_Done,
     /* 1971750 */   // Label 26256: @1971750
     /* 1971750 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1971841), // Rule ID 15711 //
     /* 1971755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1971758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1971766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1971769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1971772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1971775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1971778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971801 */     // MIs[0] round
     /* 1971801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971804 */     // MIs[0] policy
     /* 1971804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1971817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971840 */     // GIR_Coverage, 15711,
     /* 1971840 */     GIR_EraseRootFromParent_Done,
     /* 1971841 */   // Label 26257: @1971841
     /* 1971841 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1971932), // Rule ID 15714 //
     /* 1971846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1971849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1971857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1971860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1971863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1971866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1971872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971892 */     // MIs[0] round
     /* 1971892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971895 */     // MIs[0] policy
     /* 1971895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1971908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1971920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1971930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971931 */     // GIR_Coverage, 15714,
     /* 1971931 */     GIR_EraseRootFromParent_Done,
     /* 1971932 */   // Label 26258: @1971932
     /* 1971932 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1972023), // Rule ID 15715 //
     /* 1971937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1971940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1971945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1971948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1971951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1971954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1971957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1971963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971983 */     // MIs[0] round
     /* 1971983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1971986 */     // MIs[0] policy
     /* 1971986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1971989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1971999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972022 */     // GIR_Coverage, 15715,
     /* 1972022 */     GIR_EraseRootFromParent_Done,
     /* 1972023 */   // Label 26259: @1972023
     /* 1972023 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1972114), // Rule ID 15718 //
     /* 1972028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1972031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1972045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1972048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972074 */     // MIs[0] round
     /* 1972074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972077 */     // MIs[0] policy
     /* 1972077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1972090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972113 */     // GIR_Coverage, 15718,
     /* 1972113 */     GIR_EraseRootFromParent_Done,
     /* 1972114 */   // Label 26260: @1972114
     /* 1972114 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1972205), // Rule ID 15719 //
     /* 1972119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1972122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1972136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1972139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1972145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972165 */     // MIs[0] round
     /* 1972165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972168 */     // MIs[0] policy
     /* 1972168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972178 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1972181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972204 */     // GIR_Coverage, 15719,
     /* 1972204 */     GIR_EraseRootFromParent_Done,
     /* 1972205 */   // Label 26261: @1972205
     /* 1972205 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1972296), // Rule ID 15722 //
     /* 1972210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1972213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1972227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1972230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972256 */     // MIs[0] round
     /* 1972256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972259 */     // MIs[0] policy
     /* 1972259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1972272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972295 */     // GIR_Coverage, 15722,
     /* 1972295 */     GIR_EraseRootFromParent_Done,
     /* 1972296 */   // Label 26262: @1972296
     /* 1972296 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1972387), // Rule ID 15723 //
     /* 1972301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1972304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1972318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1972321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1972327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972347 */     // MIs[0] round
     /* 1972347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972350 */     // MIs[0] policy
     /* 1972350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1972363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972386 */     // GIR_Coverage, 15723,
     /* 1972386 */     GIR_EraseRootFromParent_Done,
     /* 1972387 */   // Label 26263: @1972387
     /* 1972387 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1972478), // Rule ID 15726 //
     /* 1972392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1972395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1972409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1972412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972438 */     // MIs[0] round
     /* 1972438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972441 */     // MIs[0] policy
     /* 1972441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1972454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972477 */     // GIR_Coverage, 15726,
     /* 1972477 */     GIR_EraseRootFromParent_Done,
     /* 1972478 */   // Label 26264: @1972478
     /* 1972478 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1972569), // Rule ID 15727 //
     /* 1972483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1972486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1972500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1972503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1972509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972529 */     // MIs[0] round
     /* 1972529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972532 */     // MIs[0] policy
     /* 1972532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1972545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972568 */     // GIR_Coverage, 15727,
     /* 1972568 */     GIR_EraseRootFromParent_Done,
     /* 1972569 */   // Label 26265: @1972569
     /* 1972569 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1972660), // Rule ID 15730 //
     /* 1972574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1972577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1972585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1972588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1972591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1972594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972620 */     // MIs[0] round
     /* 1972620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972623 */     // MIs[0] policy
     /* 1972623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972633 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1972636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972659 */     // GIR_Coverage, 15730,
     /* 1972659 */     GIR_EraseRootFromParent_Done,
     /* 1972660 */   // Label 26266: @1972660
     /* 1972660 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1972751), // Rule ID 15731 //
     /* 1972665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1972668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1972676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1972679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1972682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1972685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1972691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972711 */     // MIs[0] round
     /* 1972711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972714 */     // MIs[0] policy
     /* 1972714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1972727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972750 */     // GIR_Coverage, 15731,
     /* 1972750 */     GIR_EraseRootFromParent_Done,
     /* 1972751 */   // Label 26267: @1972751
     /* 1972751 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1972842), // Rule ID 15734 //
     /* 1972756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1972759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1972767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1972770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1972773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1972776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972802 */     // MIs[0] round
     /* 1972802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972805 */     // MIs[0] policy
     /* 1972805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972815 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1972818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972841 */     // GIR_Coverage, 15734,
     /* 1972841 */     GIR_EraseRootFromParent_Done,
     /* 1972842 */   // Label 26268: @1972842
     /* 1972842 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1972933), // Rule ID 15735 //
     /* 1972847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1972850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1972858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1972861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1972864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1972867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1972873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972893 */     // MIs[0] round
     /* 1972893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972896 */     // MIs[0] policy
     /* 1972896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1972909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1972921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1972931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972932 */     // GIR_Coverage, 15735,
     /* 1972932 */     GIR_EraseRootFromParent_Done,
     /* 1972933 */   // Label 26269: @1972933
     /* 1972933 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1973024), // Rule ID 15738 //
     /* 1972938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1972941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1972946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1972958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1972964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972984 */     // MIs[0] round
     /* 1972984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1972987 */     // MIs[0] policy
     /* 1972987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1972990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1973000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973023 */     // GIR_Coverage, 15738,
     /* 1973023 */     GIR_EraseRootFromParent_Done,
     /* 1973024 */   // Label 26270: @1973024
     /* 1973024 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1973115), // Rule ID 15739 //
     /* 1973029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1973032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1973046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1973049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973075 */     // MIs[0] round
     /* 1973075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973078 */     // MIs[0] policy
     /* 1973078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 1973091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973114 */     // GIR_Coverage, 15739,
     /* 1973114 */     GIR_EraseRootFromParent_Done,
     /* 1973115 */   // Label 26271: @1973115
     /* 1973115 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1973206), // Rule ID 15742 //
     /* 1973120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1973123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1973140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1973146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973166 */     // MIs[0] round
     /* 1973166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973169 */     // MIs[0] policy
     /* 1973169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973179 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1973182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973205 */     // GIR_Coverage, 15742,
     /* 1973205 */     GIR_EraseRootFromParent_Done,
     /* 1973206 */   // Label 26272: @1973206
     /* 1973206 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1973297), // Rule ID 15743 //
     /* 1973211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1973214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1973231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973257 */     // MIs[0] round
     /* 1973257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973260 */     // MIs[0] policy
     /* 1973260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 1973273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973296 */     // GIR_Coverage, 15743,
     /* 1973296 */     GIR_EraseRootFromParent_Done,
     /* 1973297 */   // Label 26273: @1973297
     /* 1973297 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1973388), // Rule ID 15746 //
     /* 1973302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1973305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1973322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1973328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973348 */     // MIs[0] round
     /* 1973348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973351 */     // MIs[0] policy
     /* 1973351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1973364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973387 */     // GIR_Coverage, 15746,
     /* 1973387 */     GIR_EraseRootFromParent_Done,
     /* 1973388 */   // Label 26274: @1973388
     /* 1973388 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1973479), // Rule ID 15747 //
     /* 1973393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1973396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1973413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973439 */     // MIs[0] round
     /* 1973439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973442 */     // MIs[0] policy
     /* 1973442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 1973455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973478 */     // GIR_Coverage, 15747,
     /* 1973478 */     GIR_EraseRootFromParent_Done,
     /* 1973479 */   // Label 26275: @1973479
     /* 1973479 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1973570), // Rule ID 15750 //
     /* 1973484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1973487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1973510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973530 */     // MIs[0] round
     /* 1973530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973533 */     // MIs[0] policy
     /* 1973533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973543 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 1973546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973569 */     // GIR_Coverage, 15750,
     /* 1973569 */     GIR_EraseRootFromParent_Done,
     /* 1973570 */   // Label 26276: @1973570
     /* 1973570 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1973661), // Rule ID 15751 //
     /* 1973575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1973578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973621 */     // MIs[0] round
     /* 1973621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973624 */     // MIs[0] policy
     /* 1973624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 1973637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973660 */     // GIR_Coverage, 15751,
     /* 1973660 */     GIR_EraseRootFromParent_Done,
     /* 1973661 */   // Label 26277: @1973661
     /* 1973661 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1973752), // Rule ID 15754 //
     /* 1973666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1973669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1973692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973712 */     // MIs[0] round
     /* 1973712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973715 */     // MIs[0] policy
     /* 1973715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973725 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 1973728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973751 */     // GIR_Coverage, 15754,
     /* 1973751 */     GIR_EraseRootFromParent_Done,
     /* 1973752 */   // Label 26278: @1973752
     /* 1973752 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1973843), // Rule ID 15755 //
     /* 1973757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1973760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973803 */     // MIs[0] round
     /* 1973803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973806 */     // MIs[0] policy
     /* 1973806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 1973819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973842 */     // GIR_Coverage, 15755,
     /* 1973842 */     GIR_EraseRootFromParent_Done,
     /* 1973843 */   // Label 26279: @1973843
     /* 1973843 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1973934), // Rule ID 15758 //
     /* 1973848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1973851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1973874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973894 */     // MIs[0] round
     /* 1973894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973897 */     // MIs[0] policy
     /* 1973897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973907 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1973910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1973922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1973932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973933 */     // GIR_Coverage, 15758,
     /* 1973933 */     GIR_EraseRootFromParent_Done,
     /* 1973934 */   // Label 26280: @1973934
     /* 1973934 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1974025), // Rule ID 15759 //
     /* 1973939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1973942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1973947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1973965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973985 */     // MIs[0] round
     /* 1973985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1973988 */     // MIs[0] policy
     /* 1973988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1973991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1974001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974024 */     // GIR_Coverage, 15759,
     /* 1974024 */     GIR_EraseRootFromParent_Done,
     /* 1974025 */   // Label 26281: @1974025
     /* 1974025 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1974116), // Rule ID 15762 //
     /* 1974030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1974041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1974044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1974047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974076 */     // MIs[0] round
     /* 1974076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974079 */     // MIs[0] policy
     /* 1974079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974089 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 1974092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974115 */     // GIR_Coverage, 15762,
     /* 1974115 */     GIR_EraseRootFromParent_Done,
     /* 1974116 */   // Label 26282: @1974116
     /* 1974116 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1974207), // Rule ID 15763 //
     /* 1974121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1974124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1974132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1974135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1974138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1974147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974167 */     // MIs[0] round
     /* 1974167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974170 */     // MIs[0] policy
     /* 1974170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 1974183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974206 */     // GIR_Coverage, 15763,
     /* 1974206 */     GIR_EraseRootFromParent_Done,
     /* 1974207 */   // Label 26283: @1974207
     /* 1974207 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1974298), // Rule ID 15766 //
     /* 1974212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974258 */     // MIs[0] round
     /* 1974258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974261 */     // MIs[0] policy
     /* 1974261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1974274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974297 */     // GIR_Coverage, 15766,
     /* 1974297 */     GIR_EraseRootFromParent_Done,
     /* 1974298 */   // Label 26284: @1974298
     /* 1974298 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1974389), // Rule ID 15767 //
     /* 1974303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1974306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1974329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974349 */     // MIs[0] round
     /* 1974349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974352 */     // MIs[0] policy
     /* 1974352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1974365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974388 */     // GIR_Coverage, 15767,
     /* 1974388 */     GIR_EraseRootFromParent_Done,
     /* 1974389 */   // Label 26285: @1974389
     /* 1974389 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1974480), // Rule ID 15770 //
     /* 1974394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974440 */     // MIs[0] round
     /* 1974440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974443 */     // MIs[0] policy
     /* 1974443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1974456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974479 */     // GIR_Coverage, 15770,
     /* 1974479 */     GIR_EraseRootFromParent_Done,
     /* 1974480 */   // Label 26286: @1974480
     /* 1974480 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1974571), // Rule ID 15771 //
     /* 1974485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1974488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1974511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974531 */     // MIs[0] round
     /* 1974531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974534 */     // MIs[0] policy
     /* 1974534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 1974547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974570 */     // GIR_Coverage, 15771,
     /* 1974570 */     GIR_EraseRootFromParent_Done,
     /* 1974571 */   // Label 26287: @1974571
     /* 1974571 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1974662), // Rule ID 15774 //
     /* 1974576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974622 */     // MIs[0] round
     /* 1974622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974625 */     // MIs[0] policy
     /* 1974625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974635 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1974638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974661 */     // GIR_Coverage, 15774,
     /* 1974661 */     GIR_EraseRootFromParent_Done,
     /* 1974662 */   // Label 26288: @1974662
     /* 1974662 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1974753), // Rule ID 15775 //
     /* 1974667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1974670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1974693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974713 */     // MIs[0] round
     /* 1974713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974716 */     // MIs[0] policy
     /* 1974716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1974729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974752 */     // GIR_Coverage, 15775,
     /* 1974752 */     GIR_EraseRootFromParent_Done,
     /* 1974753 */   // Label 26289: @1974753
     /* 1974753 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1974844), // Rule ID 15778 //
     /* 1974758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974804 */     // MIs[0] round
     /* 1974804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974807 */     // MIs[0] policy
     /* 1974807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974817 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1974820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974843 */     // GIR_Coverage, 15778,
     /* 1974843 */     GIR_EraseRootFromParent_Done,
     /* 1974844 */   // Label 26290: @1974844
     /* 1974844 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1974935), // Rule ID 15779 //
     /* 1974849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1974852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1974875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974895 */     // MIs[0] round
     /* 1974895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974898 */     // MIs[0] policy
     /* 1974898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1974911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1974923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1974933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974934 */     // GIR_Coverage, 15779,
     /* 1974934 */     GIR_EraseRootFromParent_Done,
     /* 1974935 */   // Label 26291: @1974935
     /* 1974935 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1975026), // Rule ID 15782 //
     /* 1974940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1974943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1974948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1974966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974986 */     // MIs[0] round
     /* 1974986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1974989 */     // MIs[0] policy
     /* 1974989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1974992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1975002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975025 */     // GIR_Coverage, 15782,
     /* 1975025 */     GIR_EraseRootFromParent_Done,
     /* 1975026 */   // Label 26292: @1975026
     /* 1975026 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1975117), // Rule ID 15783 //
     /* 1975031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1975034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1975042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1975045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1975048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975077 */     // MIs[0] round
     /* 1975077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975080 */     // MIs[0] policy
     /* 1975080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1975093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975116 */     // GIR_Coverage, 15783,
     /* 1975116 */     GIR_EraseRootFromParent_Done,
     /* 1975117 */   // Label 26293: @1975117
     /* 1975117 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1975208), // Rule ID 15786 //
     /* 1975122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1975125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1975148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975168 */     // MIs[0] round
     /* 1975168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975171 */     // MIs[0] policy
     /* 1975171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975181 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1975184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975207 */     // GIR_Coverage, 15786,
     /* 1975207 */     GIR_EraseRootFromParent_Done,
     /* 1975208 */   // Label 26294: @1975208
     /* 1975208 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1975299), // Rule ID 15787 //
     /* 1975213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1975216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975259 */     // MIs[0] round
     /* 1975259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975262 */     // MIs[0] policy
     /* 1975262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 1975275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975298 */     // GIR_Coverage, 15787,
     /* 1975298 */     GIR_EraseRootFromParent_Done,
     /* 1975299 */   // Label 26295: @1975299
     /* 1975299 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1975390), // Rule ID 15790 //
     /* 1975304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1975307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1975330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975350 */     // MIs[0] round
     /* 1975350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975353 */     // MIs[0] policy
     /* 1975353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1975366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975389 */     // GIR_Coverage, 15790,
     /* 1975389 */     GIR_EraseRootFromParent_Done,
     /* 1975390 */   // Label 26296: @1975390
     /* 1975390 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1975481), // Rule ID 15791 //
     /* 1975395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1975398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975441 */     // MIs[0] round
     /* 1975441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975444 */     // MIs[0] policy
     /* 1975444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975454 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1975457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975480 */     // GIR_Coverage, 15791,
     /* 1975480 */     GIR_EraseRootFromParent_Done,
     /* 1975481 */   // Label 26297: @1975481
     /* 1975481 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1975572), // Rule ID 15794 //
     /* 1975486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1975489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1975512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975532 */     // MIs[0] round
     /* 1975532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975535 */     // MIs[0] policy
     /* 1975535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975545 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1975548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975571 */     // GIR_Coverage, 15794,
     /* 1975571 */     GIR_EraseRootFromParent_Done,
     /* 1975572 */   // Label 26298: @1975572
     /* 1975572 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1975663), // Rule ID 15795 //
     /* 1975577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1975580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975623 */     // MIs[0] round
     /* 1975623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975626 */     // MIs[0] policy
     /* 1975626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1975639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975662 */     // GIR_Coverage, 15795,
     /* 1975662 */     GIR_EraseRootFromParent_Done,
     /* 1975663 */   // Label 26299: @1975663
     /* 1975663 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1975754), // Rule ID 15798 //
     /* 1975668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1975671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1975694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975714 */     // MIs[0] round
     /* 1975714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975717 */     // MIs[0] policy
     /* 1975717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975727 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1975730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975753 */     // GIR_Coverage, 15798,
     /* 1975753 */     GIR_EraseRootFromParent_Done,
     /* 1975754 */   // Label 26300: @1975754
     /* 1975754 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1975845), // Rule ID 15799 //
     /* 1975759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1975762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975805 */     // MIs[0] round
     /* 1975805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975808 */     // MIs[0] policy
     /* 1975808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1975821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975844 */     // GIR_Coverage, 15799,
     /* 1975844 */     GIR_EraseRootFromParent_Done,
     /* 1975845 */   // Label 26301: @1975845
     /* 1975845 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1975936), // Rule ID 15802 //
     /* 1975850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1975853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1975876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975896 */     // MIs[0] round
     /* 1975896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975899 */     // MIs[0] policy
     /* 1975899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1975912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1975924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1975934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975935 */     // GIR_Coverage, 15802,
     /* 1975935 */     GIR_EraseRootFromParent_Done,
     /* 1975936 */   // Label 26302: @1975936
     /* 1975936 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1976027), // Rule ID 15803 //
     /* 1975941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1975944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1975949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1975967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975987 */     // MIs[0] round
     /* 1975987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1975990 */     // MIs[0] policy
     /* 1975990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1975993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1976003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976026 */     // GIR_Coverage, 15803,
     /* 1976026 */     GIR_EraseRootFromParent_Done,
     /* 1976027 */   // Label 26303: @1976027
     /* 1976027 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1976118), // Rule ID 15806 //
     /* 1976032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1976035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976078 */     // MIs[0] round
     /* 1976078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976081 */     // MIs[0] policy
     /* 1976081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976091 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1976094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976117 */     // GIR_Coverage, 15806,
     /* 1976117 */     GIR_EraseRootFromParent_Done,
     /* 1976118 */   // Label 26304: @1976118
     /* 1976118 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1976209), // Rule ID 15807 //
     /* 1976123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1976126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1976149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976169 */     // MIs[0] round
     /* 1976169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976172 */     // MIs[0] policy
     /* 1976172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1976185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976208 */     // GIR_Coverage, 15807,
     /* 1976208 */     GIR_EraseRootFromParent_Done,
     /* 1976209 */   // Label 26305: @1976209
     /* 1976209 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1976300), // Rule ID 15810 //
     /* 1976214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1976217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976260 */     // MIs[0] round
     /* 1976260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976263 */     // MIs[0] policy
     /* 1976263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976273 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1976276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976299 */     // GIR_Coverage, 15810,
     /* 1976299 */     GIR_EraseRootFromParent_Done,
     /* 1976300 */   // Label 26306: @1976300
     /* 1976300 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1976391), // Rule ID 15811 //
     /* 1976305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1976308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1976331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976351 */     // MIs[0] round
     /* 1976351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976354 */     // MIs[0] policy
     /* 1976354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976364 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1976367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976390 */     // GIR_Coverage, 15811,
     /* 1976390 */     GIR_EraseRootFromParent_Done,
     /* 1976391 */   // Label 26307: @1976391
     /* 1976391 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1976482), // Rule ID 15814 //
     /* 1976396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1976399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976442 */     // MIs[0] round
     /* 1976442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976445 */     // MIs[0] policy
     /* 1976445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1976458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976481 */     // GIR_Coverage, 15814,
     /* 1976481 */     GIR_EraseRootFromParent_Done,
     /* 1976482 */   // Label 26308: @1976482
     /* 1976482 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1976573), // Rule ID 15815 //
     /* 1976487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1976490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1976513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976533 */     // MIs[0] round
     /* 1976533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976536 */     // MIs[0] policy
     /* 1976536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1976549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976572 */     // GIR_Coverage, 15815,
     /* 1976572 */     GIR_EraseRootFromParent_Done,
     /* 1976573 */   // Label 26309: @1976573
     /* 1976573 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1976664), // Rule ID 15818 //
     /* 1976578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1976581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976624 */     // MIs[0] round
     /* 1976624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976627 */     // MIs[0] policy
     /* 1976627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1976640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976663 */     // GIR_Coverage, 15818,
     /* 1976663 */     GIR_EraseRootFromParent_Done,
     /* 1976664 */   // Label 26310: @1976664
     /* 1976664 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1976755), // Rule ID 15819 //
     /* 1976669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1976672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1976695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976715 */     // MIs[0] round
     /* 1976715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976718 */     // MIs[0] policy
     /* 1976718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1976731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976754 */     // GIR_Coverage, 15819,
     /* 1976754 */     GIR_EraseRootFromParent_Done,
     /* 1976755 */   // Label 26311: @1976755
     /* 1976755 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1976846), // Rule ID 15822 //
     /* 1976760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1976763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976806 */     // MIs[0] round
     /* 1976806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976809 */     // MIs[0] policy
     /* 1976809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1976822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976845 */     // GIR_Coverage, 15822,
     /* 1976845 */     GIR_EraseRootFromParent_Done,
     /* 1976846 */   // Label 26312: @1976846
     /* 1976846 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1976937), // Rule ID 15823 //
     /* 1976851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1976854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1976877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976897 */     // MIs[0] round
     /* 1976897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976900 */     // MIs[0] policy
     /* 1976900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1976913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1976925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1976935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976936 */     // GIR_Coverage, 15823,
     /* 1976936 */     GIR_EraseRootFromParent_Done,
     /* 1976937 */   // Label 26313: @1976937
     /* 1976937 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1977028), // Rule ID 15826 //
     /* 1976942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1976945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1976950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1976968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976988 */     // MIs[0] round
     /* 1976988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1976991 */     // MIs[0] policy
     /* 1976991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1976994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1977004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977027 */     // GIR_Coverage, 15826,
     /* 1977027 */     GIR_EraseRootFromParent_Done,
     /* 1977028 */   // Label 26314: @1977028
     /* 1977028 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1977119), // Rule ID 15827 //
     /* 1977033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1977036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1977041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1977044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1977047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1977050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977079 */     // MIs[0] round
     /* 1977079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977082 */     // MIs[0] policy
     /* 1977082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 1977095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977118 */     // GIR_Coverage, 15827,
     /* 1977118 */     GIR_EraseRootFromParent_Done,
     /* 1977119 */   // Label 26315: @1977119
     /* 1977119 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1977210), // Rule ID 15830 //
     /* 1977124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1977127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1977132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1977150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977170 */     // MIs[0] round
     /* 1977170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977173 */     // MIs[0] policy
     /* 1977173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977183 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1977186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977209 */     // GIR_Coverage, 15830,
     /* 1977209 */     GIR_EraseRootFromParent_Done,
     /* 1977210 */   // Label 26316: @1977210
     /* 1977210 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1977301), // Rule ID 15831 //
     /* 1977215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1977218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1977223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977261 */     // MIs[0] round
     /* 1977261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977264 */     // MIs[0] policy
     /* 1977264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 1977277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977300 */     // GIR_Coverage, 15831,
     /* 1977300 */     GIR_EraseRootFromParent_Done,
     /* 1977301 */   // Label 26317: @1977301
     /* 1977301 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1977392), // Rule ID 15834 //
     /* 1977306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1977309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1977314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1977332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977352 */     // MIs[0] round
     /* 1977352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977355 */     // MIs[0] policy
     /* 1977355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977365 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1977368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977391 */     // GIR_Coverage, 15834,
     /* 1977391 */     GIR_EraseRootFromParent_Done,
     /* 1977392 */   // Label 26318: @1977392
     /* 1977392 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1977483), // Rule ID 15835 //
     /* 1977397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1977400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 1977405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977443 */     // MIs[0] round
     /* 1977443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977446 */     // MIs[0] policy
     /* 1977446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 1977459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977482 */     // GIR_Coverage, 15835,
     /* 1977482 */     GIR_EraseRootFromParent_Done,
     /* 1977483 */   // Label 26319: @1977483
     /* 1977483 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1977574), // Rule ID 15926 //
     /* 1977488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1977491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1977508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1977514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977534 */     // MIs[0] round
     /* 1977534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977537 */     // MIs[0] policy
     /* 1977537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977547 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 1977550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977573 */     // GIR_Coverage, 15926,
     /* 1977573 */     GIR_EraseRootFromParent_Done,
     /* 1977574 */   // Label 26320: @1977574
     /* 1977574 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1977665), // Rule ID 15927 //
     /* 1977579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1977582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1977599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977625 */     // MIs[0] round
     /* 1977625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977628 */     // MIs[0] policy
     /* 1977628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977638 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 1977641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977664 */     // GIR_Coverage, 15927,
     /* 1977664 */     GIR_EraseRootFromParent_Done,
     /* 1977665 */   // Label 26321: @1977665
     /* 1977665 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1977756), // Rule ID 15930 //
     /* 1977670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1977673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1977690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1977696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977716 */     // MIs[0] round
     /* 1977716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977719 */     // MIs[0] policy
     /* 1977719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977729 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 1977732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977755 */     // GIR_Coverage, 15930,
     /* 1977755 */     GIR_EraseRootFromParent_Done,
     /* 1977756 */   // Label 26322: @1977756
     /* 1977756 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1977847), // Rule ID 15931 //
     /* 1977761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1977764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1977781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977807 */     // MIs[0] round
     /* 1977807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977810 */     // MIs[0] policy
     /* 1977810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 1977823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977846 */     // GIR_Coverage, 15931,
     /* 1977846 */     GIR_EraseRootFromParent_Done,
     /* 1977847 */   // Label 26323: @1977847
     /* 1977847 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1977938), // Rule ID 15934 //
     /* 1977852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1977855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1977872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1977878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977898 */     // MIs[0] round
     /* 1977898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977901 */     // MIs[0] policy
     /* 1977901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977911 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1977914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1977926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1977936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977937 */     // GIR_Coverage, 15934,
     /* 1977937 */     GIR_EraseRootFromParent_Done,
     /* 1977938 */   // Label 26324: @1977938
     /* 1977938 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1978029), // Rule ID 15935 //
     /* 1977943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1977946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1977951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1977963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1977969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977989 */     // MIs[0] round
     /* 1977989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1977992 */     // MIs[0] policy
     /* 1977992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1977995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1978005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978028 */     // GIR_Coverage, 15935,
     /* 1978028 */     GIR_EraseRootFromParent_Done,
     /* 1978029 */   // Label 26325: @1978029
     /* 1978029 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1978120), // Rule ID 15938 //
     /* 1978034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1978054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978080 */     // MIs[0] round
     /* 1978080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978083 */     // MIs[0] policy
     /* 1978083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 1978096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978119 */     // GIR_Coverage, 15938,
     /* 1978119 */     GIR_EraseRootFromParent_Done,
     /* 1978120 */   // Label 26326: @1978120
     /* 1978120 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1978211), // Rule ID 15939 //
     /* 1978125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1978128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1978145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1978151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978171 */     // MIs[0] round
     /* 1978171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978174 */     // MIs[0] policy
     /* 1978174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 1978187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978210 */     // GIR_Coverage, 15939,
     /* 1978210 */     GIR_EraseRootFromParent_Done,
     /* 1978211 */   // Label 26327: @1978211
     /* 1978211 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1978302), // Rule ID 15942 //
     /* 1978216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1978227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1978230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1978233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1978236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978262 */     // MIs[0] round
     /* 1978262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978265 */     // MIs[0] policy
     /* 1978265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978275 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1978278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978301 */     // GIR_Coverage, 15942,
     /* 1978301 */     GIR_EraseRootFromParent_Done,
     /* 1978302 */   // Label 26328: @1978302
     /* 1978302 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1978393), // Rule ID 15943 //
     /* 1978307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1978310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1978318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1978321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1978324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1978327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1978333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978353 */     // MIs[0] round
     /* 1978353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978356 */     // MIs[0] policy
     /* 1978356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1978369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978392 */     // GIR_Coverage, 15943,
     /* 1978392 */     GIR_EraseRootFromParent_Done,
     /* 1978393 */   // Label 26329: @1978393
     /* 1978393 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1978484), // Rule ID 15946 //
     /* 1978398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1978418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978444 */     // MIs[0] round
     /* 1978444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978447 */     // MIs[0] policy
     /* 1978447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1978460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978483 */     // GIR_Coverage, 15946,
     /* 1978483 */     GIR_EraseRootFromParent_Done,
     /* 1978484 */   // Label 26330: @1978484
     /* 1978484 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1978575), // Rule ID 15947 //
     /* 1978489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1978492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1978509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1978515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978535 */     // MIs[0] round
     /* 1978535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978538 */     // MIs[0] policy
     /* 1978538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 1978551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978574 */     // GIR_Coverage, 15947,
     /* 1978574 */     GIR_EraseRootFromParent_Done,
     /* 1978575 */   // Label 26331: @1978575
     /* 1978575 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1978666), // Rule ID 15950 //
     /* 1978580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1978600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978626 */     // MIs[0] round
     /* 1978626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978629 */     // MIs[0] policy
     /* 1978629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978639 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1978642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978665 */     // GIR_Coverage, 15950,
     /* 1978665 */     GIR_EraseRootFromParent_Done,
     /* 1978666 */   // Label 26332: @1978666
     /* 1978666 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1978757), // Rule ID 15951 //
     /* 1978671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1978674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1978691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1978697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978717 */     // MIs[0] round
     /* 1978717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978720 */     // MIs[0] policy
     /* 1978720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1978733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978756 */     // GIR_Coverage, 15951,
     /* 1978756 */     GIR_EraseRootFromParent_Done,
     /* 1978757 */   // Label 26333: @1978757
     /* 1978757 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1978848), // Rule ID 15954 //
     /* 1978762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1978782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978808 */     // MIs[0] round
     /* 1978808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978811 */     // MIs[0] policy
     /* 1978811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1978824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978847 */     // GIR_Coverage, 15954,
     /* 1978847 */     GIR_EraseRootFromParent_Done,
     /* 1978848 */   // Label 26334: @1978848
     /* 1978848 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1978939), // Rule ID 15955 //
     /* 1978853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1978856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1978873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1978879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978899 */     // MIs[0] round
     /* 1978899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978902 */     // MIs[0] policy
     /* 1978902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1978915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1978927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1978937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978938 */     // GIR_Coverage, 15955,
     /* 1978938 */     GIR_EraseRootFromParent_Done,
     /* 1978939 */   // Label 26335: @1978939
     /* 1978939 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1979030), // Rule ID 15958 //
     /* 1978944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1978947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1978952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1978964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1978970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978990 */     // MIs[0] round
     /* 1978990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1978993 */     // MIs[0] policy
     /* 1978993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1978996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979003 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1979006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979029 */     // GIR_Coverage, 15958,
     /* 1979029 */     GIR_EraseRootFromParent_Done,
     /* 1979030 */   // Label 26336: @1979030
     /* 1979030 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1979121), // Rule ID 15959 //
     /* 1979035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1979038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1979046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1979049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1979052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1979055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979081 */     // MIs[0] round
     /* 1979081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979084 */     // MIs[0] policy
     /* 1979084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979094 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1979097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979120 */     // GIR_Coverage, 15959,
     /* 1979120 */     GIR_EraseRootFromParent_Done,
     /* 1979121 */   // Label 26337: @1979121
     /* 1979121 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1979212), // Rule ID 15962 //
     /* 1979126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1979129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1979146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1979152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979172 */     // MIs[0] round
     /* 1979172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979175 */     // MIs[0] policy
     /* 1979175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979185 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1979188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979211 */     // GIR_Coverage, 15962,
     /* 1979211 */     GIR_EraseRootFromParent_Done,
     /* 1979212 */   // Label 26338: @1979212
     /* 1979212 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1979303), // Rule ID 15963 //
     /* 1979217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1979220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1979237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979263 */     // MIs[0] round
     /* 1979263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979266 */     // MIs[0] policy
     /* 1979266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 1979279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979302 */     // GIR_Coverage, 15963,
     /* 1979302 */     GIR_EraseRootFromParent_Done,
     /* 1979303 */   // Label 26339: @1979303
     /* 1979303 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1979394), // Rule ID 15966 //
     /* 1979308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1979311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1979319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1979322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1979325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1979328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1979334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979354 */     // MIs[0] round
     /* 1979354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979357 */     // MIs[0] policy
     /* 1979357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1979370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979393 */     // GIR_Coverage, 15966,
     /* 1979393 */     GIR_EraseRootFromParent_Done,
     /* 1979394 */   // Label 26340: @1979394
     /* 1979394 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1979485), // Rule ID 15967 //
     /* 1979399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1979402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1979410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1979413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1979416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1979419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979445 */     // MIs[0] round
     /* 1979445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979448 */     // MIs[0] policy
     /* 1979448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1979461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979484 */     // GIR_Coverage, 15967,
     /* 1979484 */     GIR_EraseRootFromParent_Done,
     /* 1979485 */   // Label 26341: @1979485
     /* 1979485 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1979576), // Rule ID 15970 //
     /* 1979490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1979493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1979510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1979516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979536 */     // MIs[0] round
     /* 1979536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979539 */     // MIs[0] policy
     /* 1979539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979549 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1979552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979575 */     // GIR_Coverage, 15970,
     /* 1979575 */     GIR_EraseRootFromParent_Done,
     /* 1979576 */   // Label 26342: @1979576
     /* 1979576 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1979667), // Rule ID 15971 //
     /* 1979581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1979584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1979601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979627 */     // MIs[0] round
     /* 1979627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979630 */     // MIs[0] policy
     /* 1979630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979640 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1979643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979666 */     // GIR_Coverage, 15971,
     /* 1979666 */     GIR_EraseRootFromParent_Done,
     /* 1979667 */   // Label 26343: @1979667
     /* 1979667 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1979758), // Rule ID 15974 //
     /* 1979672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1979675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1979692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1979698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979718 */     // MIs[0] round
     /* 1979718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979721 */     // MIs[0] policy
     /* 1979721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979731 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1979734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979757 */     // GIR_Coverage, 15974,
     /* 1979757 */     GIR_EraseRootFromParent_Done,
     /* 1979758 */   // Label 26344: @1979758
     /* 1979758 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1979849), // Rule ID 15975 //
     /* 1979763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1979766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1979783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979809 */     // MIs[0] round
     /* 1979809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979812 */     // MIs[0] policy
     /* 1979812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979822 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1979825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979848 */     // GIR_Coverage, 15975,
     /* 1979848 */     GIR_EraseRootFromParent_Done,
     /* 1979849 */   // Label 26345: @1979849
     /* 1979849 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1979940), // Rule ID 15978 //
     /* 1979854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1979857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1979874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1979880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979900 */     // MIs[0] round
     /* 1979900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979903 */     // MIs[0] policy
     /* 1979903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1979916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1979928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1979938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979939 */     // GIR_Coverage, 15978,
     /* 1979939 */     GIR_EraseRootFromParent_Done,
     /* 1979940 */   // Label 26346: @1979940
     /* 1979940 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1980031), // Rule ID 15979 //
     /* 1979945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1979948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1979953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1979965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1979971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979991 */     // MIs[0] round
     /* 1979991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1979994 */     // MIs[0] policy
     /* 1979994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1979997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1980007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980030 */     // GIR_Coverage, 15979,
     /* 1980030 */     GIR_EraseRootFromParent_Done,
     /* 1980031 */   // Label 26347: @1980031
     /* 1980031 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1980122), // Rule ID 15982 //
     /* 1980036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1980039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1980056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980082 */     // MIs[0] round
     /* 1980082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980085 */     // MIs[0] policy
     /* 1980085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980095 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1980098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980121 */     // GIR_Coverage, 15982,
     /* 1980121 */     GIR_EraseRootFromParent_Done,
     /* 1980122 */   // Label 26348: @1980122
     /* 1980122 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1980213), // Rule ID 15983 //
     /* 1980127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1980130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1980147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1980153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980173 */     // MIs[0] round
     /* 1980173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980176 */     // MIs[0] policy
     /* 1980176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1980189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980212 */     // GIR_Coverage, 15983,
     /* 1980212 */     GIR_EraseRootFromParent_Done,
     /* 1980213 */   // Label 26349: @1980213
     /* 1980213 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1980304), // Rule ID 15986 //
     /* 1980218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1980221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1980238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980264 */     // MIs[0] round
     /* 1980264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980267 */     // MIs[0] policy
     /* 1980267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1980280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980303 */     // GIR_Coverage, 15986,
     /* 1980303 */     GIR_EraseRootFromParent_Done,
     /* 1980304 */   // Label 26350: @1980304
     /* 1980304 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1980395), // Rule ID 15987 //
     /* 1980309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1980312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1980329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1980335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980355 */     // MIs[0] round
     /* 1980355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980358 */     // MIs[0] policy
     /* 1980358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1980371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980394 */     // GIR_Coverage, 15987,
     /* 1980394 */     GIR_EraseRootFromParent_Done,
     /* 1980395 */   // Label 26351: @1980395
     /* 1980395 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1980486), // Rule ID 15990 //
     /* 1980400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1980403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1980411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1980414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1980417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1980420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980446 */     // MIs[0] round
     /* 1980446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980449 */     // MIs[0] policy
     /* 1980449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1980462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980485 */     // GIR_Coverage, 15990,
     /* 1980485 */     GIR_EraseRootFromParent_Done,
     /* 1980486 */   // Label 26352: @1980486
     /* 1980486 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1980577), // Rule ID 15991 //
     /* 1980491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1980494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1980502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1980505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1980508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1980511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1980517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980537 */     // MIs[0] round
     /* 1980537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980540 */     // MIs[0] policy
     /* 1980540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1980553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980576 */     // GIR_Coverage, 15991,
     /* 1980576 */     GIR_EraseRootFromParent_Done,
     /* 1980577 */   // Label 26353: @1980577
     /* 1980577 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1980668), // Rule ID 15994 //
     /* 1980582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1980585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1980602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980628 */     // MIs[0] round
     /* 1980628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980631 */     // MIs[0] policy
     /* 1980631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1980644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980667 */     // GIR_Coverage, 15994,
     /* 1980667 */     GIR_EraseRootFromParent_Done,
     /* 1980668 */   // Label 26354: @1980668
     /* 1980668 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1980759), // Rule ID 15995 //
     /* 1980673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1980676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1980693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1980699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980719 */     // MIs[0] round
     /* 1980719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980722 */     // MIs[0] policy
     /* 1980722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1980735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980758 */     // GIR_Coverage, 15995,
     /* 1980758 */     GIR_EraseRootFromParent_Done,
     /* 1980759 */   // Label 26355: @1980759
     /* 1980759 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1980850), // Rule ID 15998 //
     /* 1980764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1980767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1980784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980810 */     // MIs[0] round
     /* 1980810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980813 */     // MIs[0] policy
     /* 1980813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980823 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1980826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980849 */     // GIR_Coverage, 15998,
     /* 1980849 */     GIR_EraseRootFromParent_Done,
     /* 1980850 */   // Label 26356: @1980850
     /* 1980850 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1980941), // Rule ID 15999 //
     /* 1980855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1980858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1980875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1980881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980901 */     // MIs[0] round
     /* 1980901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980904 */     // MIs[0] policy
     /* 1980904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1980917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1980929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1980939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980940 */     // GIR_Coverage, 15999,
     /* 1980940 */     GIR_EraseRootFromParent_Done,
     /* 1980941 */   // Label 26357: @1980941
     /* 1980941 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1981032), // Rule ID 16002 //
     /* 1980946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1980949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1980954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1980966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1980972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980992 */     // MIs[0] round
     /* 1980992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1980995 */     // MIs[0] policy
     /* 1980995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1980998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1981008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981031 */     // GIR_Coverage, 16002,
     /* 1981031 */     GIR_EraseRootFromParent_Done,
     /* 1981032 */   // Label 26358: @1981032
     /* 1981032 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1981123), // Rule ID 16003 //
     /* 1981037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1981040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1981048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1981051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1981054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1981057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981083 */     // MIs[0] round
     /* 1981083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981086 */     // MIs[0] policy
     /* 1981086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 1981099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981122 */     // GIR_Coverage, 16003,
     /* 1981122 */     GIR_EraseRootFromParent_Done,
     /* 1981123 */   // Label 26359: @1981123
     /* 1981123 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1981214), // Rule ID 16006 //
     /* 1981128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1981131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1981148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1981154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981174 */     // MIs[0] round
     /* 1981174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981177 */     // MIs[0] policy
     /* 1981177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1981190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981213 */     // GIR_Coverage, 16006,
     /* 1981213 */     GIR_EraseRootFromParent_Done,
     /* 1981214 */   // Label 26360: @1981214
     /* 1981214 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1981305), // Rule ID 16007 //
     /* 1981219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1981222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1981239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981265 */     // MIs[0] round
     /* 1981265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981268 */     // MIs[0] policy
     /* 1981268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 1981281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981304 */     // GIR_Coverage, 16007,
     /* 1981304 */     GIR_EraseRootFromParent_Done,
     /* 1981305 */   // Label 26361: @1981305
     /* 1981305 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1981396), // Rule ID 16010 //
     /* 1981310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1981313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1981330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1981336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981356 */     // MIs[0] round
     /* 1981356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981359 */     // MIs[0] policy
     /* 1981359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1981372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981395 */     // GIR_Coverage, 16010,
     /* 1981395 */     GIR_EraseRootFromParent_Done,
     /* 1981396 */   // Label 26362: @1981396
     /* 1981396 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1981487), // Rule ID 16011 //
     /* 1981401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1981404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1981421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981447 */     // MIs[0] round
     /* 1981447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981450 */     // MIs[0] policy
     /* 1981450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 1981463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981486 */     // GIR_Coverage, 16011,
     /* 1981486 */     GIR_EraseRootFromParent_Done,
     /* 1981487 */   // Label 26363: @1981487
     /* 1981487 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1981578), // Rule ID 16014 //
     /* 1981492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1981495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1981518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981538 */     // MIs[0] round
     /* 1981538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981541 */     // MIs[0] policy
     /* 1981541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 1981554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981577 */     // GIR_Coverage, 16014,
     /* 1981577 */     GIR_EraseRootFromParent_Done,
     /* 1981578 */   // Label 26364: @1981578
     /* 1981578 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1981669), // Rule ID 16015 //
     /* 1981583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1981586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981629 */     // MIs[0] round
     /* 1981629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981632 */     // MIs[0] policy
     /* 1981632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981642 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 1981645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981668 */     // GIR_Coverage, 16015,
     /* 1981668 */     GIR_EraseRootFromParent_Done,
     /* 1981669 */   // Label 26365: @1981669
     /* 1981669 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1981760), // Rule ID 16018 //
     /* 1981674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1981677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1981700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981720 */     // MIs[0] round
     /* 1981720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981723 */     // MIs[0] policy
     /* 1981723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981733 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 1981736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981759 */     // GIR_Coverage, 16018,
     /* 1981759 */     GIR_EraseRootFromParent_Done,
     /* 1981760 */   // Label 26366: @1981760
     /* 1981760 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1981851), // Rule ID 16019 //
     /* 1981765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1981768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981811 */     // MIs[0] round
     /* 1981811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981814 */     // MIs[0] policy
     /* 1981814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981824 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 1981827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981850 */     // GIR_Coverage, 16019,
     /* 1981850 */     GIR_EraseRootFromParent_Done,
     /* 1981851 */   // Label 26367: @1981851
     /* 1981851 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1981942), // Rule ID 16022 //
     /* 1981856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1981859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1981882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981902 */     // MIs[0] round
     /* 1981902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981905 */     // MIs[0] policy
     /* 1981905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981915 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1981918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1981930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1981940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981941 */     // GIR_Coverage, 16022,
     /* 1981941 */     GIR_EraseRootFromParent_Done,
     /* 1981942 */   // Label 26368: @1981942
     /* 1981942 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1982033), // Rule ID 16023 //
     /* 1981947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1981950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1981955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1981973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981993 */     // MIs[0] round
     /* 1981993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1981996 */     // MIs[0] policy
     /* 1981996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1981999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1982009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982032 */     // GIR_Coverage, 16023,
     /* 1982032 */     GIR_EraseRootFromParent_Done,
     /* 1982033 */   // Label 26369: @1982033
     /* 1982033 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1982124), // Rule ID 16026 //
     /* 1982038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1982049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1982052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1982055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982084 */     // MIs[0] round
     /* 1982084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982087 */     // MIs[0] policy
     /* 1982087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982097 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 1982100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982123 */     // GIR_Coverage, 16026,
     /* 1982123 */     GIR_EraseRootFromParent_Done,
     /* 1982124 */   // Label 26370: @1982124
     /* 1982124 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1982215), // Rule ID 16027 //
     /* 1982129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1982132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1982140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1982143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1982146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1982155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982175 */     // MIs[0] round
     /* 1982175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982178 */     // MIs[0] policy
     /* 1982178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 1982191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982214 */     // GIR_Coverage, 16027,
     /* 1982214 */     GIR_EraseRootFromParent_Done,
     /* 1982215 */   // Label 26371: @1982215
     /* 1982215 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1982306), // Rule ID 16030 //
     /* 1982220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982266 */     // MIs[0] round
     /* 1982266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982269 */     // MIs[0] policy
     /* 1982269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1982282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982305 */     // GIR_Coverage, 16030,
     /* 1982305 */     GIR_EraseRootFromParent_Done,
     /* 1982306 */   // Label 26372: @1982306
     /* 1982306 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1982397), // Rule ID 16031 //
     /* 1982311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1982314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1982337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982357 */     // MIs[0] round
     /* 1982357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982360 */     // MIs[0] policy
     /* 1982360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1982373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982396 */     // GIR_Coverage, 16031,
     /* 1982396 */     GIR_EraseRootFromParent_Done,
     /* 1982397 */   // Label 26373: @1982397
     /* 1982397 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1982488), // Rule ID 16034 //
     /* 1982402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982448 */     // MIs[0] round
     /* 1982448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982451 */     // MIs[0] policy
     /* 1982451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1982464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982487 */     // GIR_Coverage, 16034,
     /* 1982487 */     GIR_EraseRootFromParent_Done,
     /* 1982488 */   // Label 26374: @1982488
     /* 1982488 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1982579), // Rule ID 16035 //
     /* 1982493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1982496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1982519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982539 */     // MIs[0] round
     /* 1982539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982542 */     // MIs[0] policy
     /* 1982542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 1982555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982578 */     // GIR_Coverage, 16035,
     /* 1982578 */     GIR_EraseRootFromParent_Done,
     /* 1982579 */   // Label 26375: @1982579
     /* 1982579 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1982670), // Rule ID 16038 //
     /* 1982584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982630 */     // MIs[0] round
     /* 1982630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982633 */     // MIs[0] policy
     /* 1982633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982643 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1982646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982669 */     // GIR_Coverage, 16038,
     /* 1982669 */     GIR_EraseRootFromParent_Done,
     /* 1982670 */   // Label 26376: @1982670
     /* 1982670 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1982761), // Rule ID 16039 //
     /* 1982675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1982678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1982701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982721 */     // MIs[0] round
     /* 1982721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982724 */     // MIs[0] policy
     /* 1982724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1982737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982760 */     // GIR_Coverage, 16039,
     /* 1982760 */     GIR_EraseRootFromParent_Done,
     /* 1982761 */   // Label 26377: @1982761
     /* 1982761 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1982852), // Rule ID 16042 //
     /* 1982766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982812 */     // MIs[0] round
     /* 1982812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982815 */     // MIs[0] policy
     /* 1982815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1982828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982851 */     // GIR_Coverage, 16042,
     /* 1982851 */     GIR_EraseRootFromParent_Done,
     /* 1982852 */   // Label 26378: @1982852
     /* 1982852 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1982943), // Rule ID 16043 //
     /* 1982857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1982860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1982883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982903 */     // MIs[0] round
     /* 1982903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982906 */     // MIs[0] policy
     /* 1982906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1982909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1982919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1982931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1982941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982942 */     // GIR_Coverage, 16043,
     /* 1982942 */     GIR_EraseRootFromParent_Done,
     /* 1982943 */   // Label 26379: @1982943
     /* 1982943 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1983034), // Rule ID 16046 //
     /* 1982948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1982951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1982956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1982974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982994 */     // MIs[0] round
     /* 1982994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1982997 */     // MIs[0] policy
     /* 1982997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1983010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983033 */     // GIR_Coverage, 16046,
     /* 1983033 */     GIR_EraseRootFromParent_Done,
     /* 1983034 */   // Label 26380: @1983034
     /* 1983034 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1983125), // Rule ID 16047 //
     /* 1983039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1983042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1983050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1983053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1983056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983085 */     // MIs[0] round
     /* 1983085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983088 */     // MIs[0] policy
     /* 1983088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1983101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983124 */     // GIR_Coverage, 16047,
     /* 1983124 */     GIR_EraseRootFromParent_Done,
     /* 1983125 */   // Label 26381: @1983125
     /* 1983125 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1983216), // Rule ID 16050 //
     /* 1983130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1983133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1983141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1983144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1983156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983176 */     // MIs[0] round
     /* 1983176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983179 */     // MIs[0] policy
     /* 1983179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1983192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983215 */     // GIR_Coverage, 16050,
     /* 1983215 */     GIR_EraseRootFromParent_Done,
     /* 1983216 */   // Label 26382: @1983216
     /* 1983216 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1983307), // Rule ID 16051 //
     /* 1983221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1983224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1983232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1983235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983267 */     // MIs[0] round
     /* 1983267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983270 */     // MIs[0] policy
     /* 1983270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 1983283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983306 */     // GIR_Coverage, 16051,
     /* 1983306 */     GIR_EraseRootFromParent_Done,
     /* 1983307 */   // Label 26383: @1983307
     /* 1983307 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1983398), // Rule ID 16054 //
     /* 1983312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1983315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1983338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983358 */     // MIs[0] round
     /* 1983358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983361 */     // MIs[0] policy
     /* 1983361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1983374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983397 */     // GIR_Coverage, 16054,
     /* 1983397 */     GIR_EraseRootFromParent_Done,
     /* 1983398 */   // Label 26384: @1983398
     /* 1983398 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1983489), // Rule ID 16055 //
     /* 1983403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1983406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983449 */     // MIs[0] round
     /* 1983449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983452 */     // MIs[0] policy
     /* 1983452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1983465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983488 */     // GIR_Coverage, 16055,
     /* 1983488 */     GIR_EraseRootFromParent_Done,
     /* 1983489 */   // Label 26385: @1983489
     /* 1983489 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1983580), // Rule ID 16058 //
     /* 1983494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1983497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1983520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983540 */     // MIs[0] round
     /* 1983540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983543 */     // MIs[0] policy
     /* 1983543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983553 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1983556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983579 */     // GIR_Coverage, 16058,
     /* 1983579 */     GIR_EraseRootFromParent_Done,
     /* 1983580 */   // Label 26386: @1983580
     /* 1983580 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1983671), // Rule ID 16059 //
     /* 1983585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1983588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983631 */     // MIs[0] round
     /* 1983631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983634 */     // MIs[0] policy
     /* 1983634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1983647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983670 */     // GIR_Coverage, 16059,
     /* 1983670 */     GIR_EraseRootFromParent_Done,
     /* 1983671 */   // Label 26387: @1983671
     /* 1983671 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1983762), // Rule ID 16062 //
     /* 1983676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1983679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1983702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983722 */     // MIs[0] round
     /* 1983722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983725 */     // MIs[0] policy
     /* 1983725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983735 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1983738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983761 */     // GIR_Coverage, 16062,
     /* 1983761 */     GIR_EraseRootFromParent_Done,
     /* 1983762 */   // Label 26388: @1983762
     /* 1983762 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1983853), // Rule ID 16063 //
     /* 1983767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1983770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983813 */     // MIs[0] round
     /* 1983813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983816 */     // MIs[0] policy
     /* 1983816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1983829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983852 */     // GIR_Coverage, 16063,
     /* 1983852 */     GIR_EraseRootFromParent_Done,
     /* 1983853 */   // Label 26389: @1983853
     /* 1983853 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1983944), // Rule ID 16066 //
     /* 1983858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1983861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1983884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983904 */     // MIs[0] round
     /* 1983904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983907 */     // MIs[0] policy
     /* 1983907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1983910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1983920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1983932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1983942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983943 */     // GIR_Coverage, 16066,
     /* 1983943 */     GIR_EraseRootFromParent_Done,
     /* 1983944 */   // Label 26390: @1983944
     /* 1983944 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1984035), // Rule ID 16067 //
     /* 1983949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1983952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1983957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1983975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983995 */     // MIs[0] round
     /* 1983995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1983998 */     // MIs[0] policy
     /* 1983998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1984011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984034 */     // GIR_Coverage, 16067,
     /* 1984034 */     GIR_EraseRootFromParent_Done,
     /* 1984035 */   // Label 26391: @1984035
     /* 1984035 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1984126), // Rule ID 16070 //
     /* 1984040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1984043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1984051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1984054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1984057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984086 */     // MIs[0] round
     /* 1984086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984089 */     // MIs[0] policy
     /* 1984089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1984102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984125 */     // GIR_Coverage, 16070,
     /* 1984125 */     GIR_EraseRootFromParent_Done,
     /* 1984126 */   // Label 26392: @1984126
     /* 1984126 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1984217), // Rule ID 16071 //
     /* 1984131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1984134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1984142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1984145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1984148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1984157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984177 */     // MIs[0] round
     /* 1984177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984180 */     // MIs[0] policy
     /* 1984180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1984193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984216 */     // GIR_Coverage, 16071,
     /* 1984216 */     GIR_EraseRootFromParent_Done,
     /* 1984217 */   // Label 26393: @1984217
     /* 1984217 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1984308), // Rule ID 16074 //
     /* 1984222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1984225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984268 */     // MIs[0] round
     /* 1984268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984271 */     // MIs[0] policy
     /* 1984271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1984284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984307 */     // GIR_Coverage, 16074,
     /* 1984307 */     GIR_EraseRootFromParent_Done,
     /* 1984308 */   // Label 26394: @1984308
     /* 1984308 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1984399), // Rule ID 16075 //
     /* 1984313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1984316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1984339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984359 */     // MIs[0] round
     /* 1984359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984362 */     // MIs[0] policy
     /* 1984362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1984375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984398 */     // GIR_Coverage, 16075,
     /* 1984398 */     GIR_EraseRootFromParent_Done,
     /* 1984399 */   // Label 26395: @1984399
     /* 1984399 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1984490), // Rule ID 16078 //
     /* 1984404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1984407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984450 */     // MIs[0] round
     /* 1984450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984453 */     // MIs[0] policy
     /* 1984453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1984466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984489 */     // GIR_Coverage, 16078,
     /* 1984489 */     GIR_EraseRootFromParent_Done,
     /* 1984490 */   // Label 26396: @1984490
     /* 1984490 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1984581), // Rule ID 16079 //
     /* 1984495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1984498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1984521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984541 */     // MIs[0] round
     /* 1984541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984544 */     // MIs[0] policy
     /* 1984544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1984557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984580 */     // GIR_Coverage, 16079,
     /* 1984580 */     GIR_EraseRootFromParent_Done,
     /* 1984581 */   // Label 26397: @1984581
     /* 1984581 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1984672), // Rule ID 16082 //
     /* 1984586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1984589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1984597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1984600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1984603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984632 */     // MIs[0] round
     /* 1984632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984635 */     // MIs[0] policy
     /* 1984635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1984648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984671 */     // GIR_Coverage, 16082,
     /* 1984671 */     GIR_EraseRootFromParent_Done,
     /* 1984672 */   // Label 26398: @1984672
     /* 1984672 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1984763), // Rule ID 16083 //
     /* 1984677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1984680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1984688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1984691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1984694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1984703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984723 */     // MIs[0] round
     /* 1984723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984726 */     // MIs[0] policy
     /* 1984726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1984739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984762 */     // GIR_Coverage, 16083,
     /* 1984762 */     GIR_EraseRootFromParent_Done,
     /* 1984763 */   // Label 26399: @1984763
     /* 1984763 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1984854), // Rule ID 16086 //
     /* 1984768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1984771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984814 */     // MIs[0] round
     /* 1984814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984817 */     // MIs[0] policy
     /* 1984817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1984830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984853 */     // GIR_Coverage, 16086,
     /* 1984853 */     GIR_EraseRootFromParent_Done,
     /* 1984854 */   // Label 26400: @1984854
     /* 1984854 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1984945), // Rule ID 16087 //
     /* 1984859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1984862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1984885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984905 */     // MIs[0] round
     /* 1984905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984908 */     // MIs[0] policy
     /* 1984908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1984911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1984921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1984933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1984943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984944 */     // GIR_Coverage, 16087,
     /* 1984944 */     GIR_EraseRootFromParent_Done,
     /* 1984945 */   // Label 26401: @1984945
     /* 1984945 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1985036), // Rule ID 16090 //
     /* 1984950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1984953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1984958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1984976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984996 */     // MIs[0] round
     /* 1984996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1984999 */     // MIs[0] policy
     /* 1984999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1985012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985035 */     // GIR_Coverage, 16090,
     /* 1985035 */     GIR_EraseRootFromParent_Done,
     /* 1985036 */   // Label 26402: @1985036
     /* 1985036 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1985127), // Rule ID 16091 //
     /* 1985041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1985044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1985049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1985052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1985055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1985058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1985071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985087 */     // MIs[0] round
     /* 1985087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985090 */     // MIs[0] policy
     /* 1985090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 1985103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985126 */     // GIR_Coverage, 16091,
     /* 1985126 */     GIR_EraseRootFromParent_Done,
     /* 1985127 */   // Label 26403: @1985127
     /* 1985127 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1985218), // Rule ID 16094 //
     /* 1985132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1985135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1985140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1985143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1985146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1985149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1985158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1985162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985178 */     // MIs[0] round
     /* 1985178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985181 */     // MIs[0] policy
     /* 1985181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985191 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1985194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985217 */     // GIR_Coverage, 16094,
     /* 1985217 */     GIR_EraseRootFromParent_Done,
     /* 1985218 */   // Label 26404: @1985218
     /* 1985218 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1985309), // Rule ID 16095 //
     /* 1985223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1985226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1985231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1985234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1985237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1985240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1985253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985269 */     // MIs[0] round
     /* 1985269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985272 */     // MIs[0] policy
     /* 1985272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 1985285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985308 */     // GIR_Coverage, 16095,
     /* 1985308 */     GIR_EraseRootFromParent_Done,
     /* 1985309 */   // Label 26405: @1985309
     /* 1985309 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1985400), // Rule ID 16098 //
     /* 1985314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1985317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1985322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1985340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985360 */     // MIs[0] round
     /* 1985360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985363 */     // MIs[0] policy
     /* 1985363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985373 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1985376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985399 */     // GIR_Coverage, 16098,
     /* 1985399 */     GIR_EraseRootFromParent_Done,
     /* 1985400 */   // Label 26406: @1985400
     /* 1985400 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1985491), // Rule ID 16099 //
     /* 1985405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1985408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 1985413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985451 */     // MIs[0] round
     /* 1985451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985454 */     // MIs[0] policy
     /* 1985454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985464 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 1985467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985490 */     // GIR_Coverage, 16099,
     /* 1985490 */     GIR_EraseRootFromParent_Done,
     /* 1985491 */   // Label 26407: @1985491
     /* 1985491 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1985585), // Rule ID 16190 //
     /* 1985496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1985499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1985516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1985522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985542 */     // MIs[0] round
     /* 1985542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985545 */     // MIs[0] policy
     /* 1985545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985555 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 1985558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1985583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985584 */     // GIR_Coverage, 16190,
     /* 1985584 */     GIR_EraseRootFromParent_Done,
     /* 1985585 */   // Label 26408: @1985585
     /* 1985585 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1985679), // Rule ID 16191 //
     /* 1985590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1985593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1985610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985636 */     // MIs[0] round
     /* 1985636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985639 */     // MIs[0] policy
     /* 1985639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985649 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 1985652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1985677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985678 */     // GIR_Coverage, 16191,
     /* 1985678 */     GIR_EraseRootFromParent_Done,
     /* 1985679 */   // Label 26409: @1985679
     /* 1985679 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1985773), // Rule ID 16194 //
     /* 1985684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1985687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1985695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1985698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1985704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1985710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985730 */     // MIs[0] round
     /* 1985730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985733 */     // MIs[0] policy
     /* 1985733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 1985746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1985771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985772 */     // GIR_Coverage, 16194,
     /* 1985772 */     GIR_EraseRootFromParent_Done,
     /* 1985773 */   // Label 26410: @1985773
     /* 1985773 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1985867), // Rule ID 16195 //
     /* 1985778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1985781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1985789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1985792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1985798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985824 */     // MIs[0] round
     /* 1985824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985827 */     // MIs[0] policy
     /* 1985827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985837 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 1985840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1985865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985866 */     // GIR_Coverage, 16195,
     /* 1985866 */     GIR_EraseRootFromParent_Done,
     /* 1985867 */   // Label 26411: @1985867
     /* 1985867 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1985961), // Rule ID 16198 //
     /* 1985872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1985875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1985892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1985898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985918 */     // MIs[0] round
     /* 1985918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1985921 */     // MIs[0] policy
     /* 1985921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1985924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985931 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1985934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1985946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1985956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1985959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985960 */     // GIR_Coverage, 16198,
     /* 1985960 */     GIR_EraseRootFromParent_Done,
     /* 1985961 */   // Label 26412: @1985961
     /* 1985961 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1986055), // Rule ID 16199 //
     /* 1985966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1985969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1985974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1985986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1985992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986012 */     // MIs[0] round
     /* 1986012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986015 */     // MIs[0] policy
     /* 1986015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986025 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1986028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986054 */     // GIR_Coverage, 16199,
     /* 1986054 */     GIR_EraseRootFromParent_Done,
     /* 1986055 */   // Label 26413: @1986055
     /* 1986055 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1986149), // Rule ID 16202 //
     /* 1986060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1986063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1986080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1986086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986106 */     // MIs[0] round
     /* 1986106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986109 */     // MIs[0] policy
     /* 1986109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1986122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986148 */     // GIR_Coverage, 16202,
     /* 1986148 */     GIR_EraseRootFromParent_Done,
     /* 1986149 */   // Label 26414: @1986149
     /* 1986149 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1986243), // Rule ID 16203 //
     /* 1986154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1986157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1986174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1986180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986200 */     // MIs[0] round
     /* 1986200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986203 */     // MIs[0] policy
     /* 1986203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986213 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1986216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986242 */     // GIR_Coverage, 16203,
     /* 1986242 */     GIR_EraseRootFromParent_Done,
     /* 1986243 */   // Label 26415: @1986243
     /* 1986243 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1986337), // Rule ID 16206 //
     /* 1986248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1986251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1986268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1986274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986294 */     // MIs[0] round
     /* 1986294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986297 */     // MIs[0] policy
     /* 1986297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1986310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986336 */     // GIR_Coverage, 16206,
     /* 1986336 */     GIR_EraseRootFromParent_Done,
     /* 1986337 */   // Label 26416: @1986337
     /* 1986337 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1986431), // Rule ID 16207 //
     /* 1986342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1986345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1986362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1986368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986388 */     // MIs[0] round
     /* 1986388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986391 */     // MIs[0] policy
     /* 1986391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986401 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1986404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986430 */     // GIR_Coverage, 16207,
     /* 1986430 */     GIR_EraseRootFromParent_Done,
     /* 1986431 */   // Label 26417: @1986431
     /* 1986431 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1986525), // Rule ID 16210 //
     /* 1986436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1986439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1986456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1986462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986482 */     // MIs[0] round
     /* 1986482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986485 */     // MIs[0] policy
     /* 1986485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986495 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1986498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986524 */     // GIR_Coverage, 16210,
     /* 1986524 */     GIR_EraseRootFromParent_Done,
     /* 1986525 */   // Label 26418: @1986525
     /* 1986525 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1986619), // Rule ID 16211 //
     /* 1986530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1986533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1986550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1986556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986576 */     // MIs[0] round
     /* 1986576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986579 */     // MIs[0] policy
     /* 1986579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1986592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986618 */     // GIR_Coverage, 16211,
     /* 1986618 */     GIR_EraseRootFromParent_Done,
     /* 1986619 */   // Label 26419: @1986619
     /* 1986619 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1986713), // Rule ID 16214 //
     /* 1986624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1986627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1986635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1986638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1986644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1986650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986670 */     // MIs[0] round
     /* 1986670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986673 */     // MIs[0] policy
     /* 1986673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986683 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 1986686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986712 */     // GIR_Coverage, 16214,
     /* 1986712 */     GIR_EraseRootFromParent_Done,
     /* 1986713 */   // Label 26420: @1986713
     /* 1986713 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1986807), // Rule ID 16215 //
     /* 1986718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1986721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1986729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1986732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1986738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1986744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986764 */     // MIs[0] round
     /* 1986764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986767 */     // MIs[0] policy
     /* 1986767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 1986780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986806 */     // GIR_Coverage, 16215,
     /* 1986806 */     GIR_EraseRootFromParent_Done,
     /* 1986807 */   // Label 26421: @1986807
     /* 1986807 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1986901), // Rule ID 16218 //
     /* 1986812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1986815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1986823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1986826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1986832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1986838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986858 */     // MIs[0] round
     /* 1986858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986861 */     // MIs[0] policy
     /* 1986861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1986874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986900 */     // GIR_Coverage, 16218,
     /* 1986900 */     GIR_EraseRootFromParent_Done,
     /* 1986901 */   // Label 26422: @1986901
     /* 1986901 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1986995), // Rule ID 16219 //
     /* 1986906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1986909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1986914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1986917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1986920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1986926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1986932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986952 */     // MIs[0] round
     /* 1986952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1986955 */     // MIs[0] policy
     /* 1986955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1986958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986965 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1986968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1986980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1986990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1986993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986994 */     // GIR_Coverage, 16219,
     /* 1986994 */     GIR_EraseRootFromParent_Done,
     /* 1986995 */   // Label 26423: @1986995
     /* 1986995 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1987089), // Rule ID 16222 //
     /* 1987000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1987003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1987011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1987014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1987020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987046 */     // MIs[0] round
     /* 1987046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987049 */     // MIs[0] policy
     /* 1987049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987059 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1987062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987088 */     // GIR_Coverage, 16222,
     /* 1987088 */     GIR_EraseRootFromParent_Done,
     /* 1987089 */   // Label 26424: @1987089
     /* 1987089 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1987183), // Rule ID 16223 //
     /* 1987094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1987097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1987105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1987108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1987114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1987120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987140 */     // MIs[0] round
     /* 1987140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987143 */     // MIs[0] policy
     /* 1987143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987153 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1987156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987182 */     // GIR_Coverage, 16223,
     /* 1987182 */     GIR_EraseRootFromParent_Done,
     /* 1987183 */   // Label 26425: @1987183
     /* 1987183 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1987277), // Rule ID 16226 //
     /* 1987188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1987191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1987208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987234 */     // MIs[0] round
     /* 1987234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987237 */     // MIs[0] policy
     /* 1987237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987247 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1987250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987276 */     // GIR_Coverage, 16226,
     /* 1987276 */     GIR_EraseRootFromParent_Done,
     /* 1987277 */   // Label 26426: @1987277
     /* 1987277 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1987371), // Rule ID 16227 //
     /* 1987282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1987285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1987302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1987308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987328 */     // MIs[0] round
     /* 1987328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987331 */     // MIs[0] policy
     /* 1987331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1987344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987370 */     // GIR_Coverage, 16227,
     /* 1987370 */     GIR_EraseRootFromParent_Done,
     /* 1987371 */   // Label 26427: @1987371
     /* 1987371 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1987465), // Rule ID 16230 //
     /* 1987376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1987379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1987396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987422 */     // MIs[0] round
     /* 1987422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987425 */     // MIs[0] policy
     /* 1987425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1987438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987464 */     // GIR_Coverage, 16230,
     /* 1987464 */     GIR_EraseRootFromParent_Done,
     /* 1987465 */   // Label 26428: @1987465
     /* 1987465 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1987559), // Rule ID 16231 //
     /* 1987470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1987473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1987490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1987496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987516 */     // MIs[0] round
     /* 1987516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987519 */     // MIs[0] policy
     /* 1987519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1987532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987558 */     // GIR_Coverage, 16231,
     /* 1987558 */     GIR_EraseRootFromParent_Done,
     /* 1987559 */   // Label 26429: @1987559
     /* 1987559 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1987653), // Rule ID 16234 //
     /* 1987564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1987567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1987575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1987578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1987581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1987584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1987587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987610 */     // MIs[0] round
     /* 1987610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987613 */     // MIs[0] policy
     /* 1987613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987623 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1987626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987652 */     // GIR_Coverage, 16234,
     /* 1987652 */     GIR_EraseRootFromParent_Done,
     /* 1987653 */   // Label 26430: @1987653
     /* 1987653 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1987747), // Rule ID 16235 //
     /* 1987658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1987661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1987669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1987672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1987675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1987678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1987681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1987684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987704 */     // MIs[0] round
     /* 1987704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987707 */     // MIs[0] policy
     /* 1987707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987717 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 1987720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987746 */     // GIR_Coverage, 16235,
     /* 1987746 */     GIR_EraseRootFromParent_Done,
     /* 1987747 */   // Label 26431: @1987747
     /* 1987747 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1987841), // Rule ID 16238 //
     /* 1987752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1987755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1987763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1987766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1987772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987798 */     // MIs[0] round
     /* 1987798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987801 */     // MIs[0] policy
     /* 1987801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1987814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987840 */     // GIR_Coverage, 16238,
     /* 1987840 */     GIR_EraseRootFromParent_Done,
     /* 1987841 */   // Label 26432: @1987841
     /* 1987841 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1987935), // Rule ID 16239 //
     /* 1987846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1987849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1987857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1987860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1987866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1987872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987892 */     // MIs[0] round
     /* 1987892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987895 */     // MIs[0] policy
     /* 1987895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987905 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 1987908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1987920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1987930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1987933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987934 */     // GIR_Coverage, 16239,
     /* 1987934 */     GIR_EraseRootFromParent_Done,
     /* 1987935 */   // Label 26433: @1987935
     /* 1987935 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1988029), // Rule ID 16242 //
     /* 1987940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1987943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1987948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1987960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1987966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987986 */     // MIs[0] round
     /* 1987986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1987989 */     // MIs[0] policy
     /* 1987989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1987992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1988002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988028 */     // GIR_Coverage, 16242,
     /* 1988028 */     GIR_EraseRootFromParent_Done,
     /* 1988029 */   // Label 26434: @1988029
     /* 1988029 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1988123), // Rule ID 16243 //
     /* 1988034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1988037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1988045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1988048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1988054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1988060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988080 */     // MIs[0] round
     /* 1988080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988083 */     // MIs[0] policy
     /* 1988083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 1988096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988122 */     // GIR_Coverage, 16243,
     /* 1988122 */     GIR_EraseRootFromParent_Done,
     /* 1988123 */   // Label 26435: @1988123
     /* 1988123 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1988217), // Rule ID 16246 //
     /* 1988128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1988131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1988148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1988154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988174 */     // MIs[0] round
     /* 1988174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988177 */     // MIs[0] policy
     /* 1988177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988187 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1988190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988216 */     // GIR_Coverage, 16246,
     /* 1988216 */     GIR_EraseRootFromParent_Done,
     /* 1988217 */   // Label 26436: @1988217
     /* 1988217 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1988311), // Rule ID 16247 //
     /* 1988222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1988225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1988242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1988248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988268 */     // MIs[0] round
     /* 1988268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988271 */     // MIs[0] policy
     /* 1988271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988281 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 1988284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988310 */     // GIR_Coverage, 16247,
     /* 1988310 */     GIR_EraseRootFromParent_Done,
     /* 1988311 */   // Label 26437: @1988311
     /* 1988311 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1988405), // Rule ID 16250 //
     /* 1988316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1988319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1988342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988362 */     // MIs[0] round
     /* 1988362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988365 */     // MIs[0] policy
     /* 1988365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988375 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 1988378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988404 */     // GIR_Coverage, 16250,
     /* 1988404 */     GIR_EraseRootFromParent_Done,
     /* 1988405 */   // Label 26438: @1988405
     /* 1988405 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1988499), // Rule ID 16251 //
     /* 1988410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1988413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1988436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988456 */     // MIs[0] round
     /* 1988456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988459 */     // MIs[0] policy
     /* 1988459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 1988472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988498 */     // GIR_Coverage, 16251,
     /* 1988498 */     GIR_EraseRootFromParent_Done,
     /* 1988499 */   // Label 26439: @1988499
     /* 1988499 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1988593), // Rule ID 16254 //
     /* 1988504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1988507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1988530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988550 */     // MIs[0] round
     /* 1988550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988553 */     // MIs[0] policy
     /* 1988553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988563 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 1988566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988592 */     // GIR_Coverage, 16254,
     /* 1988592 */     GIR_EraseRootFromParent_Done,
     /* 1988593 */   // Label 26440: @1988593
     /* 1988593 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1988687), // Rule ID 16255 //
     /* 1988598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1988601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1988624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988644 */     // MIs[0] round
     /* 1988644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988647 */     // MIs[0] policy
     /* 1988647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988657 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 1988660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988686 */     // GIR_Coverage, 16255,
     /* 1988686 */     GIR_EraseRootFromParent_Done,
     /* 1988687 */   // Label 26441: @1988687
     /* 1988687 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1988781), // Rule ID 16258 //
     /* 1988692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1988695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1988709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1988718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988738 */     // MIs[0] round
     /* 1988738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988741 */     // MIs[0] policy
     /* 1988741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988751 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1988754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988780 */     // GIR_Coverage, 16258,
     /* 1988780 */     GIR_EraseRootFromParent_Done,
     /* 1988781 */   // Label 26442: @1988781
     /* 1988781 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1988875), // Rule ID 16259 //
     /* 1988786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1988789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1988803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1988812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988832 */     // MIs[0] round
     /* 1988832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988835 */     // MIs[0] policy
     /* 1988835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988845 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1988848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988874 */     // GIR_Coverage, 16259,
     /* 1988874 */     GIR_EraseRootFromParent_Done,
     /* 1988875 */   // Label 26443: @1988875
     /* 1988875 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1988969), // Rule ID 16262 //
     /* 1988880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1988883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1988891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1988894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1988897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1988906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988926 */     // MIs[0] round
     /* 1988926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1988929 */     // MIs[0] policy
     /* 1988929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1988932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1988942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1988954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1988964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1988967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988968 */     // GIR_Coverage, 16262,
     /* 1988968 */     GIR_EraseRootFromParent_Done,
     /* 1988969 */   // Label 26444: @1988969
     /* 1988969 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1989063), // Rule ID 16263 //
     /* 1988974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1988977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1988982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1988985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1988988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1988991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989020 */     // MIs[0] round
     /* 1989020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989023 */     // MIs[0] policy
     /* 1989023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1989036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989062 */     // GIR_Coverage, 16263,
     /* 1989062 */     GIR_EraseRootFromParent_Done,
     /* 1989063 */   // Label 26445: @1989063
     /* 1989063 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1989157), // Rule ID 16266 //
     /* 1989068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1989071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1989085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1989094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989114 */     // MIs[0] round
     /* 1989114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989117 */     // MIs[0] policy
     /* 1989117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1989130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989156 */     // GIR_Coverage, 16266,
     /* 1989156 */     GIR_EraseRootFromParent_Done,
     /* 1989157 */   // Label 26446: @1989157
     /* 1989157 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1989251), // Rule ID 16267 //
     /* 1989162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1989165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1989179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989208 */     // MIs[0] round
     /* 1989208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989211 */     // MIs[0] policy
     /* 1989211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989221 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1989224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989250 */     // GIR_Coverage, 16267,
     /* 1989250 */     GIR_EraseRootFromParent_Done,
     /* 1989251 */   // Label 26447: @1989251
     /* 1989251 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1989345), // Rule ID 16270 //
     /* 1989256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1989259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1989267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1989270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1989273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1989282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989302 */     // MIs[0] round
     /* 1989302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989305 */     // MIs[0] policy
     /* 1989305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989315 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1989318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989344 */     // GIR_Coverage, 16270,
     /* 1989344 */     GIR_EraseRootFromParent_Done,
     /* 1989345 */   // Label 26448: @1989345
     /* 1989345 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1989439), // Rule ID 16271 //
     /* 1989350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1989353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1989361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1989364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1989367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989396 */     // MIs[0] round
     /* 1989396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989399 */     // MIs[0] policy
     /* 1989399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989409 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1989412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989438 */     // GIR_Coverage, 16271,
     /* 1989438 */     GIR_EraseRootFromParent_Done,
     /* 1989439 */   // Label 26449: @1989439
     /* 1989439 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1989533), // Rule ID 16274 //
     /* 1989444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1989447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1989470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989490 */     // MIs[0] round
     /* 1989490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989493 */     // MIs[0] policy
     /* 1989493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989503 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 1989506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989532 */     // GIR_Coverage, 16274,
     /* 1989532 */     GIR_EraseRootFromParent_Done,
     /* 1989533 */   // Label 26450: @1989533
     /* 1989533 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1989627), // Rule ID 16275 //
     /* 1989538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1989541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989584 */     // MIs[0] round
     /* 1989584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989587 */     // MIs[0] policy
     /* 1989587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989597 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 1989600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989626 */     // GIR_Coverage, 16275,
     /* 1989626 */     GIR_EraseRootFromParent_Done,
     /* 1989627 */   // Label 26451: @1989627
     /* 1989627 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1989721), // Rule ID 16278 //
     /* 1989632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1989635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1989658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989678 */     // MIs[0] round
     /* 1989678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989681 */     // MIs[0] policy
     /* 1989681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989691 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1989694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989720 */     // GIR_Coverage, 16278,
     /* 1989720 */     GIR_EraseRootFromParent_Done,
     /* 1989721 */   // Label 26452: @1989721
     /* 1989721 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1989815), // Rule ID 16279 //
     /* 1989726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1989729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989772 */     // MIs[0] round
     /* 1989772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989775 */     // MIs[0] policy
     /* 1989775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989785 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1989788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989814 */     // GIR_Coverage, 16279,
     /* 1989814 */     GIR_EraseRootFromParent_Done,
     /* 1989815 */   // Label 26453: @1989815
     /* 1989815 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1989909), // Rule ID 16282 //
     /* 1989820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1989823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1989837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1989846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989866 */     // MIs[0] round
     /* 1989866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989869 */     // MIs[0] policy
     /* 1989869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989879 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1989882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1989907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989908 */     // GIR_Coverage, 16282,
     /* 1989908 */     GIR_EraseRootFromParent_Done,
     /* 1989909 */   // Label 26454: @1989909
     /* 1989909 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1990003), // Rule ID 16283 //
     /* 1989914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1989917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1989922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1989931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1989940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989960 */     // MIs[0] round
     /* 1989960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1989963 */     // MIs[0] policy
     /* 1989963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1989966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989973 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1989976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1989988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1989998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990002 */     // GIR_Coverage, 16283,
     /* 1990002 */     GIR_EraseRootFromParent_Done,
     /* 1990003 */   // Label 26455: @1990003
     /* 1990003 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1990097), // Rule ID 16286 //
     /* 1990008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1990011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1990025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990054 */     // MIs[0] round
     /* 1990054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990057 */     // MIs[0] policy
     /* 1990057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1990070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990096 */     // GIR_Coverage, 16286,
     /* 1990096 */     GIR_EraseRootFromParent_Done,
     /* 1990097 */   // Label 26456: @1990097
     /* 1990097 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1990191), // Rule ID 16287 //
     /* 1990102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1990105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1990119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1990128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990148 */     // MIs[0] round
     /* 1990148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990151 */     // MIs[0] policy
     /* 1990151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1990164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990190 */     // GIR_Coverage, 16287,
     /* 1990190 */     GIR_EraseRootFromParent_Done,
     /* 1990191 */   // Label 26457: @1990191
     /* 1990191 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1990285), // Rule ID 16290 //
     /* 1990196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1990199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1990213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990242 */     // MIs[0] round
     /* 1990242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990245 */     // MIs[0] policy
     /* 1990245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1990258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990284 */     // GIR_Coverage, 16290,
     /* 1990284 */     GIR_EraseRootFromParent_Done,
     /* 1990285 */   // Label 26458: @1990285
     /* 1990285 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1990379), // Rule ID 16291 //
     /* 1990290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1990293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1990307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1990316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990336 */     // MIs[0] round
     /* 1990336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990339 */     // MIs[0] policy
     /* 1990339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1990352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990378 */     // GIR_Coverage, 16291,
     /* 1990378 */     GIR_EraseRootFromParent_Done,
     /* 1990379 */   // Label 26459: @1990379
     /* 1990379 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1990473), // Rule ID 16294 //
     /* 1990384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1990387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990430 */     // MIs[0] round
     /* 1990430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990433 */     // MIs[0] policy
     /* 1990433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1990446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990472 */     // GIR_Coverage, 16294,
     /* 1990472 */     GIR_EraseRootFromParent_Done,
     /* 1990473 */   // Label 26460: @1990473
     /* 1990473 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1990567), // Rule ID 16295 //
     /* 1990478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1990481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1990504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990524 */     // MIs[0] round
     /* 1990524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990527 */     // MIs[0] policy
     /* 1990527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990537 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 1990540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990566 */     // GIR_Coverage, 16295,
     /* 1990566 */     GIR_EraseRootFromParent_Done,
     /* 1990567 */   // Label 26461: @1990567
     /* 1990567 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1990661), // Rule ID 16298 //
     /* 1990572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1990575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1990589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1990595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990618 */     // MIs[0] round
     /* 1990618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990621 */     // MIs[0] policy
     /* 1990621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1990634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990660 */     // GIR_Coverage, 16298,
     /* 1990660 */     GIR_EraseRootFromParent_Done,
     /* 1990661 */   // Label 26462: @1990661
     /* 1990661 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1990755), // Rule ID 16299 //
     /* 1990666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1990669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1990683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1990689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1990692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990712 */     // MIs[0] round
     /* 1990712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990715 */     // MIs[0] policy
     /* 1990715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990725 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 1990728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990754 */     // GIR_Coverage, 16299,
     /* 1990754 */     GIR_EraseRootFromParent_Done,
     /* 1990755 */   // Label 26463: @1990755
     /* 1990755 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1990849), // Rule ID 16302 //
     /* 1990760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1990763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1990777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990806 */     // MIs[0] round
     /* 1990806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990809 */     // MIs[0] policy
     /* 1990809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1990822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990848 */     // GIR_Coverage, 16302,
     /* 1990848 */     GIR_EraseRootFromParent_Done,
     /* 1990849 */   // Label 26464: @1990849
     /* 1990849 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1990943), // Rule ID 16303 //
     /* 1990854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1990857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1990871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1990880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990900 */     // MIs[0] round
     /* 1990900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990903 */     // MIs[0] policy
     /* 1990903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1990906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 1990916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1990928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1990938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1990941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990942 */     // GIR_Coverage, 16303,
     /* 1990942 */     GIR_EraseRootFromParent_Done,
     /* 1990943 */   // Label 26465: @1990943
     /* 1990943 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1991037), // Rule ID 16306 //
     /* 1990948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1990951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1990956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1990959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1990962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1990965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1990974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990994 */     // MIs[0] round
     /* 1990994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1990997 */     // MIs[0] policy
     /* 1990997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991007 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1991010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991036 */     // GIR_Coverage, 16306,
     /* 1991036 */     GIR_EraseRootFromParent_Done,
     /* 1991037 */   // Label 26466: @1991037
     /* 1991037 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1991131), // Rule ID 16307 //
     /* 1991042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1991045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 1991050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1991068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991088 */     // MIs[0] round
     /* 1991088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991091 */     // MIs[0] policy
     /* 1991091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991101 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 1991104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991130 */     // GIR_Coverage, 16307,
     /* 1991130 */     GIR_EraseRootFromParent_Done,
     /* 1991131 */   // Label 26467: @1991131
     /* 1991131 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1991225), // Rule ID 16370 //
     /* 1991136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1991139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1991153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1991156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1991162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991182 */     // MIs[0] round
     /* 1991182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991185 */     // MIs[0] policy
     /* 1991185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991195 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 1991198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991224 */     // GIR_Coverage, 16370,
     /* 1991224 */     GIR_EraseRootFromParent_Done,
     /* 1991225 */   // Label 26468: @1991225
     /* 1991225 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1991319), // Rule ID 16371 //
     /* 1991230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1991233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1991247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1991250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1991256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991276 */     // MIs[0] round
     /* 1991276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991279 */     // MIs[0] policy
     /* 1991279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991289 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 1991292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991318 */     // GIR_Coverage, 16371,
     /* 1991318 */     GIR_EraseRootFromParent_Done,
     /* 1991319 */   // Label 26469: @1991319
     /* 1991319 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1991413), // Rule ID 16374 //
     /* 1991324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1991327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1991335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1991338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1991341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1991344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1991350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991370 */     // MIs[0] round
     /* 1991370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991373 */     // MIs[0] policy
     /* 1991373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991383 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 1991386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991412 */     // GIR_Coverage, 16374,
     /* 1991412 */     GIR_EraseRootFromParent_Done,
     /* 1991413 */   // Label 26470: @1991413
     /* 1991413 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1991507), // Rule ID 16375 //
     /* 1991418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1991421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1991429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1991432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1991435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1991438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1991444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991464 */     // MIs[0] round
     /* 1991464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991467 */     // MIs[0] policy
     /* 1991467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 1991480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991506 */     // GIR_Coverage, 16375,
     /* 1991506 */     GIR_EraseRootFromParent_Done,
     /* 1991507 */   // Label 26471: @1991507
     /* 1991507 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1991601), // Rule ID 16378 //
     /* 1991512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1991515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1991523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1991526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1991529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1991532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1991538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991558 */     // MIs[0] round
     /* 1991558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991561 */     // MIs[0] policy
     /* 1991561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1991574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991600 */     // GIR_Coverage, 16378,
     /* 1991600 */     GIR_EraseRootFromParent_Done,
     /* 1991601 */   // Label 26472: @1991601
     /* 1991601 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1991695), // Rule ID 16379 //
     /* 1991606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1991609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1991617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1991620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1991623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1991626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1991632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991652 */     // MIs[0] round
     /* 1991652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991655 */     // MIs[0] policy
     /* 1991655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991665 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1991668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991694 */     // GIR_Coverage, 16379,
     /* 1991694 */     GIR_EraseRootFromParent_Done,
     /* 1991695 */   // Label 26473: @1991695
     /* 1991695 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1991789), // Rule ID 16382 //
     /* 1991700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1991703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1991711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1991714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1991717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1991720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1991726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991746 */     // MIs[0] round
     /* 1991746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991749 */     // MIs[0] policy
     /* 1991749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1991762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991788 */     // GIR_Coverage, 16382,
     /* 1991788 */     GIR_EraseRootFromParent_Done,
     /* 1991789 */   // Label 26474: @1991789
     /* 1991789 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1991883), // Rule ID 16383 //
     /* 1991794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1991797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1991805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1991808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1991811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1991814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1991820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991840 */     // MIs[0] round
     /* 1991840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991843 */     // MIs[0] policy
     /* 1991843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991853 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1991856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991882 */     // GIR_Coverage, 16383,
     /* 1991882 */     GIR_EraseRootFromParent_Done,
     /* 1991883 */   // Label 26475: @1991883
     /* 1991883 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1991977), // Rule ID 16386 //
     /* 1991888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1991891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1991899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1991902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1991905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1991908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1991914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991934 */     // MIs[0] round
     /* 1991934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1991937 */     // MIs[0] policy
     /* 1991937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1991940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1991950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1991962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1991972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1991975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991976 */     // GIR_Coverage, 16386,
     /* 1991976 */     GIR_EraseRootFromParent_Done,
     /* 1991977 */   // Label 26476: @1991977
     /* 1991977 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1992071), // Rule ID 16387 //
     /* 1991982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1991985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1991990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1991993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1991996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1991999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1992002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992028 */     // MIs[0] round
     /* 1992028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992031 */     // MIs[0] policy
     /* 1992031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992041 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1992044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992070 */     // GIR_Coverage, 16387,
     /* 1992070 */     GIR_EraseRootFromParent_Done,
     /* 1992071 */   // Label 26477: @1992071
     /* 1992071 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1992165), // Rule ID 16390 //
     /* 1992076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1992079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1992087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1992090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1992093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1992096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1992102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992122 */     // MIs[0] round
     /* 1992122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992125 */     // MIs[0] policy
     /* 1992125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992135 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1992138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992164 */     // GIR_Coverage, 16390,
     /* 1992164 */     GIR_EraseRootFromParent_Done,
     /* 1992165 */   // Label 26478: @1992165
     /* 1992165 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1992259), // Rule ID 16391 //
     /* 1992170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1992173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1992181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1992184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1992187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1992190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992216 */     // MIs[0] round
     /* 1992216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992219 */     // MIs[0] policy
     /* 1992219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1992232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992258 */     // GIR_Coverage, 16391,
     /* 1992258 */     GIR_EraseRootFromParent_Done,
     /* 1992259 */   // Label 26479: @1992259
     /* 1992259 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1992353), // Rule ID 16394 //
     /* 1992264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1992267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1992284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1992290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992310 */     // MIs[0] round
     /* 1992310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992313 */     // MIs[0] policy
     /* 1992313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 1992326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992352 */     // GIR_Coverage, 16394,
     /* 1992352 */     GIR_EraseRootFromParent_Done,
     /* 1992353 */   // Label 26480: @1992353
     /* 1992353 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1992447), // Rule ID 16395 //
     /* 1992358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1992361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1992378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992404 */     // MIs[0] round
     /* 1992404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992407 */     // MIs[0] policy
     /* 1992407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992417 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 1992420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992446 */     // GIR_Coverage, 16395,
     /* 1992446 */     GIR_EraseRootFromParent_Done,
     /* 1992447 */   // Label 26481: @1992447
     /* 1992447 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1992541), // Rule ID 16398 //
     /* 1992452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1992455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1992469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1992472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1992478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992498 */     // MIs[0] round
     /* 1992498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992501 */     // MIs[0] policy
     /* 1992501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1992514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992540 */     // GIR_Coverage, 16398,
     /* 1992540 */     GIR_EraseRootFromParent_Done,
     /* 1992541 */   // Label 26482: @1992541
     /* 1992541 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1992635), // Rule ID 16399 //
     /* 1992546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1992549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1992563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1992566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992592 */     // MIs[0] round
     /* 1992592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992595 */     // MIs[0] policy
     /* 1992595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992605 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1992608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992634 */     // GIR_Coverage, 16399,
     /* 1992634 */     GIR_EraseRootFromParent_Done,
     /* 1992635 */   // Label 26483: @1992635
     /* 1992635 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1992729), // Rule ID 16402 //
     /* 1992640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1992643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1992651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1992654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1992657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1992660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1992666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992686 */     // MIs[0] round
     /* 1992686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992689 */     // MIs[0] policy
     /* 1992689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1992702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992728 */     // GIR_Coverage, 16402,
     /* 1992728 */     GIR_EraseRootFromParent_Done,
     /* 1992729 */   // Label 26484: @1992729
     /* 1992729 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1992823), // Rule ID 16403 //
     /* 1992734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1992737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1992745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1992748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1992751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1992754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992780 */     // MIs[0] round
     /* 1992780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992783 */     // MIs[0] policy
     /* 1992783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992793 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1992796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992822 */     // GIR_Coverage, 16403,
     /* 1992822 */     GIR_EraseRootFromParent_Done,
     /* 1992823 */   // Label 26485: @1992823
     /* 1992823 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1992917), // Rule ID 16406 //
     /* 1992828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1992831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1992839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1992842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1992845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1992848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1992854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992874 */     // MIs[0] round
     /* 1992874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992877 */     // MIs[0] policy
     /* 1992877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1992890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1992912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1992915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992916 */     // GIR_Coverage, 16406,
     /* 1992916 */     GIR_EraseRootFromParent_Done,
     /* 1992917 */   // Label 26486: @1992917
     /* 1992917 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1993011), // Rule ID 16407 //
     /* 1992922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1992925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1992930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1992933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1992936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1992939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1992942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1992948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992968 */     // MIs[0] round
     /* 1992968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1992971 */     // MIs[0] policy
     /* 1992971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1992974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1992984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1992996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993010 */     // GIR_Coverage, 16407,
     /* 1993010 */     GIR_EraseRootFromParent_Done,
     /* 1993011 */   // Label 26487: @1993011
     /* 1993011 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1993105), // Rule ID 16410 //
     /* 1993016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1993019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1993027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1993030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1993033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1993036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993062 */     // MIs[0] round
     /* 1993062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993065 */     // MIs[0] policy
     /* 1993065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993075 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1993078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993104 */     // GIR_Coverage, 16410,
     /* 1993104 */     GIR_EraseRootFromParent_Done,
     /* 1993105 */   // Label 26488: @1993105
     /* 1993105 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1993199), // Rule ID 16411 //
     /* 1993110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1993113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1993121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1993124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1993127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1993130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1993136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993156 */     // MIs[0] round
     /* 1993156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993159 */     // MIs[0] policy
     /* 1993159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993169 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1993172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993198 */     // GIR_Coverage, 16411,
     /* 1993198 */     GIR_EraseRootFromParent_Done,
     /* 1993199 */   // Label 26489: @1993199
     /* 1993199 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1993293), // Rule ID 16414 //
     /* 1993204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1993207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1993224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993250 */     // MIs[0] round
     /* 1993250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993253 */     // MIs[0] policy
     /* 1993253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1993266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993292 */     // GIR_Coverage, 16414,
     /* 1993292 */     GIR_EraseRootFromParent_Done,
     /* 1993293 */   // Label 26490: @1993293
     /* 1993293 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1993387), // Rule ID 16415 //
     /* 1993298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1993301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1993318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1993324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993344 */     // MIs[0] round
     /* 1993344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993347 */     // MIs[0] policy
     /* 1993347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993357 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 1993360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993386 */     // GIR_Coverage, 16415,
     /* 1993386 */     GIR_EraseRootFromParent_Done,
     /* 1993387 */   // Label 26491: @1993387
     /* 1993387 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1993481), // Rule ID 16418 //
     /* 1993392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1993395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1993409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1993412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993438 */     // MIs[0] round
     /* 1993438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993441 */     // MIs[0] policy
     /* 1993441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993451 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1993454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993480 */     // GIR_Coverage, 16418,
     /* 1993480 */     GIR_EraseRootFromParent_Done,
     /* 1993481 */   // Label 26492: @1993481
     /* 1993481 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1993575), // Rule ID 16419 //
     /* 1993486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1993489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1993503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1993506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1993512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993532 */     // MIs[0] round
     /* 1993532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993535 */     // MIs[0] policy
     /* 1993535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 1993548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993574 */     // GIR_Coverage, 16419,
     /* 1993574 */     GIR_EraseRootFromParent_Done,
     /* 1993575 */   // Label 26493: @1993575
     /* 1993575 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1993669), // Rule ID 16422 //
     /* 1993580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1993583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1993597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1993600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993626 */     // MIs[0] round
     /* 1993626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993629 */     // MIs[0] policy
     /* 1993629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1993642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993668 */     // GIR_Coverage, 16422,
     /* 1993668 */     GIR_EraseRootFromParent_Done,
     /* 1993669 */   // Label 26494: @1993669
     /* 1993669 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1993763), // Rule ID 16423 //
     /* 1993674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1993677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1993691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1993694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1993700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993720 */     // MIs[0] round
     /* 1993720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993723 */     // MIs[0] policy
     /* 1993723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 1993736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993762 */     // GIR_Coverage, 16423,
     /* 1993762 */     GIR_EraseRootFromParent_Done,
     /* 1993763 */   // Label 26495: @1993763
     /* 1993763 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1993857), // Rule ID 16426 //
     /* 1993768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1993771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1993785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1993788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993814 */     // MIs[0] round
     /* 1993814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993817 */     // MIs[0] policy
     /* 1993817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1993830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993856 */     // GIR_Coverage, 16426,
     /* 1993856 */     GIR_EraseRootFromParent_Done,
     /* 1993857 */   // Label 26496: @1993857
     /* 1993857 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1993951), // Rule ID 16427 //
     /* 1993862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1993865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1993879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1993882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1993888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993908 */     // MIs[0] round
     /* 1993908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1993911 */     // MIs[0] policy
     /* 1993911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1993914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 1993924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1993936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1993946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1993949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993950 */     // GIR_Coverage, 16427,
     /* 1993950 */     GIR_EraseRootFromParent_Done,
     /* 1993951 */   // Label 26497: @1993951
     /* 1993951 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1994045), // Rule ID 16430 //
     /* 1993956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1993959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1993964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1993967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1993970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1993973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1993982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994002 */     // MIs[0] round
     /* 1994002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994005 */     // MIs[0] policy
     /* 1994005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994015 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 1994018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994044 */     // GIR_Coverage, 16430,
     /* 1994044 */     GIR_EraseRootFromParent_Done,
     /* 1994045 */   // Label 26498: @1994045
     /* 1994045 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1994139), // Rule ID 16431 //
     /* 1994050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1994061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1994064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1994067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1994073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1994076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994096 */     // MIs[0] round
     /* 1994096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994099 */     // MIs[0] policy
     /* 1994099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994109 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 1994112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994138 */     // GIR_Coverage, 16431,
     /* 1994138 */     GIR_EraseRootFromParent_Done,
     /* 1994139 */   // Label 26499: @1994139
     /* 1994139 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1994233), // Rule ID 16434 //
     /* 1994144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1994147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1994155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1994158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1994161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1994167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1994170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994190 */     // MIs[0] round
     /* 1994190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994193 */     // MIs[0] policy
     /* 1994193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994203 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 1994206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994232 */     // GIR_Coverage, 16434,
     /* 1994232 */     GIR_EraseRootFromParent_Done,
     /* 1994233 */   // Label 26500: @1994233
     /* 1994233 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1994327), // Rule ID 16435 //
     /* 1994238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1994249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1994252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1994255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1994261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1994264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994284 */     // MIs[0] round
     /* 1994284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994287 */     // MIs[0] policy
     /* 1994287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994297 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 1994300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994326 */     // GIR_Coverage, 16435,
     /* 1994326 */     GIR_EraseRootFromParent_Done,
     /* 1994327 */   // Label 26501: @1994327
     /* 1994327 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1994421), // Rule ID 16438 //
     /* 1994332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1994335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1994343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1994346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1994349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1994358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994378 */     // MIs[0] round
     /* 1994378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994381 */     // MIs[0] policy
     /* 1994381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994391 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1994394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994420 */     // GIR_Coverage, 16438,
     /* 1994420 */     GIR_EraseRootFromParent_Done,
     /* 1994421 */   // Label 26502: @1994421
     /* 1994421 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1994515), // Rule ID 16439 //
     /* 1994426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1994437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1994440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1994443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1994452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994472 */     // MIs[0] round
     /* 1994472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994475 */     // MIs[0] policy
     /* 1994475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994485 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1994488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994514 */     // GIR_Coverage, 16439,
     /* 1994514 */     GIR_EraseRootFromParent_Done,
     /* 1994515 */   // Label 26503: @1994515
     /* 1994515 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1994609), // Rule ID 16442 //
     /* 1994520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1994523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1994531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1994534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1994546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994566 */     // MIs[0] round
     /* 1994566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994569 */     // MIs[0] policy
     /* 1994569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994579 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1994582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994608 */     // GIR_Coverage, 16442,
     /* 1994608 */     GIR_EraseRootFromParent_Done,
     /* 1994609 */   // Label 26504: @1994609
     /* 1994609 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1994703), // Rule ID 16443 //
     /* 1994614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1994625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1994628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1994640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994660 */     // MIs[0] round
     /* 1994660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994663 */     // MIs[0] policy
     /* 1994663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994673 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1994676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994702 */     // GIR_Coverage, 16443,
     /* 1994702 */     GIR_EraseRootFromParent_Done,
     /* 1994703 */   // Label 26505: @1994703
     /* 1994703 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1994797), // Rule ID 16446 //
     /* 1994708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1994711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1994734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994754 */     // MIs[0] round
     /* 1994754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994757 */     // MIs[0] policy
     /* 1994757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994767 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1994770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994796 */     // GIR_Coverage, 16446,
     /* 1994796 */     GIR_EraseRootFromParent_Done,
     /* 1994797 */   // Label 26506: @1994797
     /* 1994797 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1994891), // Rule ID 16447 //
     /* 1994802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1994828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994848 */     // MIs[0] round
     /* 1994848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994851 */     // MIs[0] policy
     /* 1994851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1994864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994890 */     // GIR_Coverage, 16447,
     /* 1994890 */     GIR_EraseRootFromParent_Done,
     /* 1994891 */   // Label 26507: @1994891
     /* 1994891 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1994985), // Rule ID 16450 //
     /* 1994896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1994899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1994907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1994910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1994922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994942 */     // MIs[0] round
     /* 1994942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1994945 */     // MIs[0] policy
     /* 1994945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1994948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1994958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1994970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1994980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1994983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994984 */     // GIR_Coverage, 16450,
     /* 1994984 */     GIR_EraseRootFromParent_Done,
     /* 1994985 */   // Label 26508: @1994985
     /* 1994985 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1995079), // Rule ID 16451 //
     /* 1994990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1994993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1994998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1995001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1995004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1995007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1995013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995036 */     // MIs[0] round
     /* 1995036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995039 */     // MIs[0] policy
     /* 1995039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995049 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1995052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1995072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995078 */     // GIR_Coverage, 16451,
     /* 1995078 */     GIR_EraseRootFromParent_Done,
     /* 1995079 */   // Label 26509: @1995079
     /* 1995079 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1995173), // Rule ID 16454 //
     /* 1995084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1995087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1995095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1995098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1995101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995130 */     // MIs[0] round
     /* 1995130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995133 */     // MIs[0] policy
     /* 1995133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 1995146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995172 */     // GIR_Coverage, 16454,
     /* 1995172 */     GIR_EraseRootFromParent_Done,
     /* 1995173 */   // Label 26510: @1995173
     /* 1995173 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1995267), // Rule ID 16455 //
     /* 1995178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1995181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1995189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1995192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1995195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995224 */     // MIs[0] round
     /* 1995224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995227 */     // MIs[0] policy
     /* 1995227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995237 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 1995240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995266 */     // GIR_Coverage, 16455,
     /* 1995266 */     GIR_EraseRootFromParent_Done,
     /* 1995267 */   // Label 26511: @1995267
     /* 1995267 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1995361), // Rule ID 16458 //
     /* 1995272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1995275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1995283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1995286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1995289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995318 */     // MIs[0] round
     /* 1995318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995321 */     // MIs[0] policy
     /* 1995321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995331 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1995334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995360 */     // GIR_Coverage, 16458,
     /* 1995360 */     GIR_EraseRootFromParent_Done,
     /* 1995361 */   // Label 26512: @1995361
     /* 1995361 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1995455), // Rule ID 16459 //
     /* 1995366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1995369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1995377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1995380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1995383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995412 */     // MIs[0] round
     /* 1995412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995415 */     // MIs[0] policy
     /* 1995415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995425 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1995428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995454 */     // GIR_Coverage, 16459,
     /* 1995454 */     GIR_EraseRootFromParent_Done,
     /* 1995455 */   // Label 26513: @1995455
     /* 1995455 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1995549), // Rule ID 16462 //
     /* 1995460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1995463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995506 */     // MIs[0] round
     /* 1995506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995509 */     // MIs[0] policy
     /* 1995509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995519 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1995522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995548 */     // GIR_Coverage, 16462,
     /* 1995548 */     GIR_EraseRootFromParent_Done,
     /* 1995549 */   // Label 26514: @1995549
     /* 1995549 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1995643), // Rule ID 16463 //
     /* 1995554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1995557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995600 */     // MIs[0] round
     /* 1995600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995603 */     // MIs[0] policy
     /* 1995603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995613 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1995616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995642 */     // GIR_Coverage, 16463,
     /* 1995642 */     GIR_EraseRootFromParent_Done,
     /* 1995643 */   // Label 26515: @1995643
     /* 1995643 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1995737), // Rule ID 16466 //
     /* 1995648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1995651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1995659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1995662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995694 */     // MIs[0] round
     /* 1995694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995697 */     // MIs[0] policy
     /* 1995697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1995710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995736 */     // GIR_Coverage, 16466,
     /* 1995736 */     GIR_EraseRootFromParent_Done,
     /* 1995737 */   // Label 26516: @1995737
     /* 1995737 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1995831), // Rule ID 16467 //
     /* 1995742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1995745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1995753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1995756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995788 */     // MIs[0] round
     /* 1995788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995791 */     // MIs[0] policy
     /* 1995791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1995804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995830 */     // GIR_Coverage, 16467,
     /* 1995830 */     GIR_EraseRootFromParent_Done,
     /* 1995831 */   // Label 26517: @1995831
     /* 1995831 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1995925), // Rule ID 16470 //
     /* 1995836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1995839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1995847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1995850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995882 */     // MIs[0] round
     /* 1995882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995885 */     // MIs[0] policy
     /* 1995885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995895 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1995898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1995920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1995923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995924 */     // GIR_Coverage, 16470,
     /* 1995924 */     GIR_EraseRootFromParent_Done,
     /* 1995925 */   // Label 26518: @1995925
     /* 1995925 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1996019), // Rule ID 16471 //
     /* 1995930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1995933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1995938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1995941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1995944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995976 */     // MIs[0] round
     /* 1995976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995979 */     // MIs[0] policy
     /* 1995979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1995982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1995992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996018 */     // GIR_Coverage, 16471,
     /* 1996018 */     GIR_EraseRootFromParent_Done,
     /* 1996019 */   // Label 26519: @1996019
     /* 1996019 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1996113), // Rule ID 16474 //
     /* 1996024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1996027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1996041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996070 */     // MIs[0] round
     /* 1996070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996073 */     // MIs[0] policy
     /* 1996073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1996086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996112 */     // GIR_Coverage, 16474,
     /* 1996112 */     GIR_EraseRootFromParent_Done,
     /* 1996113 */   // Label 26520: @1996113
     /* 1996113 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1996207), // Rule ID 16475 //
     /* 1996118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1996121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1996135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996164 */     // MIs[0] round
     /* 1996164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996167 */     // MIs[0] policy
     /* 1996167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 1996180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996206 */     // GIR_Coverage, 16475,
     /* 1996206 */     GIR_EraseRootFromParent_Done,
     /* 1996207 */   // Label 26521: @1996207
     /* 1996207 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1996301), // Rule ID 16478 //
     /* 1996212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1996215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1996229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1996235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996258 */     // MIs[0] round
     /* 1996258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996261 */     // MIs[0] policy
     /* 1996261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1996274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996300 */     // GIR_Coverage, 16478,
     /* 1996300 */     GIR_EraseRootFromParent_Done,
     /* 1996301 */   // Label 26522: @1996301
     /* 1996301 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1996395), // Rule ID 16479 //
     /* 1996306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1996309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1996323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1996329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996352 */     // MIs[0] round
     /* 1996352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996355 */     // MIs[0] policy
     /* 1996355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 1996368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996394 */     // GIR_Coverage, 16479,
     /* 1996394 */     GIR_EraseRootFromParent_Done,
     /* 1996395 */   // Label 26523: @1996395
     /* 1996395 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1996489), // Rule ID 16482 //
     /* 1996400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1996403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1996417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996446 */     // MIs[0] round
     /* 1996446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996449 */     // MIs[0] policy
     /* 1996449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1996462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996488 */     // GIR_Coverage, 16482,
     /* 1996488 */     GIR_EraseRootFromParent_Done,
     /* 1996489 */   // Label 26524: @1996489
     /* 1996489 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1996583), // Rule ID 16483 //
     /* 1996494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1996497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1996511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996540 */     // MIs[0] round
     /* 1996540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996543 */     // MIs[0] policy
     /* 1996543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 1996556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996582 */     // GIR_Coverage, 16483,
     /* 1996582 */     GIR_EraseRootFromParent_Done,
     /* 1996583 */   // Label 26525: @1996583
     /* 1996583 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1996677), // Rule ID 16486 //
     /* 1996588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1996591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1996605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996634 */     // MIs[0] round
     /* 1996634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996637 */     // MIs[0] policy
     /* 1996637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996647 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1996650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996676 */     // GIR_Coverage, 16486,
     /* 1996676 */     GIR_EraseRootFromParent_Done,
     /* 1996677 */   // Label 26526: @1996677
     /* 1996677 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1996771), // Rule ID 16487 //
     /* 1996682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1996685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 1996690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1996699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996728 */     // MIs[0] round
     /* 1996728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996731 */     // MIs[0] policy
     /* 1996731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996741 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 1996744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1996769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996770 */     // GIR_Coverage, 16487,
     /* 1996770 */     GIR_EraseRootFromParent_Done,
     /* 1996771 */   // Label 26527: @1996771
     /* 1996771 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1996862), // Rule ID 16550 //
     /* 1996776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1996779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1996784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1996787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1996790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1996793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1996796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996822 */     // MIs[0] round
     /* 1996822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996825 */     // MIs[0] policy
     /* 1996825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996835 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 1996838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996861 */     // GIR_Coverage, 16550,
     /* 1996861 */     GIR_EraseRootFromParent_Done,
     /* 1996862 */   // Label 26528: @1996862
     /* 1996862 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1996953), // Rule ID 16551 //
     /* 1996867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1996870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1996875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1996878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1996881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1996884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1996887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996913 */     // MIs[0] round
     /* 1996913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996916 */     // MIs[0] policy
     /* 1996916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1996919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996926 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 1996929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1996951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996952 */     // GIR_Coverage, 16551,
     /* 1996952 */     GIR_EraseRootFromParent_Done,
     /* 1996953 */   // Label 26529: @1996953
     /* 1996953 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1997044), // Rule ID 16554 //
     /* 1996958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1996961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1996966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1996969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1996972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1996975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1996978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1996981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997004 */     // MIs[0] round
     /* 1997004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997007 */     // MIs[0] policy
     /* 1997007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997017 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 1997020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997043 */     // GIR_Coverage, 16554,
     /* 1997043 */     GIR_EraseRootFromParent_Done,
     /* 1997044 */   // Label 26530: @1997044
     /* 1997044 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1997135), // Rule ID 16555 //
     /* 1997049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1997052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1997060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1997063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1997066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1997069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997095 */     // MIs[0] round
     /* 1997095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997098 */     // MIs[0] policy
     /* 1997098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997108 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 1997111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997134 */     // GIR_Coverage, 16555,
     /* 1997134 */     GIR_EraseRootFromParent_Done,
     /* 1997135 */   // Label 26531: @1997135
     /* 1997135 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1997226), // Rule ID 16558 //
     /* 1997140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1997143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1997157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1997160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997186 */     // MIs[0] round
     /* 1997186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997189 */     // MIs[0] policy
     /* 1997189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997199 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 1997202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997225 */     // GIR_Coverage, 16558,
     /* 1997225 */     GIR_EraseRootFromParent_Done,
     /* 1997226 */   // Label 26532: @1997226
     /* 1997226 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1997317), // Rule ID 16559 //
     /* 1997231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1997234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1997248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1997251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997277 */     // MIs[0] round
     /* 1997277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997280 */     // MIs[0] policy
     /* 1997280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 1997293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997316 */     // GIR_Coverage, 16559,
     /* 1997316 */     GIR_EraseRootFromParent_Done,
     /* 1997317 */   // Label 26533: @1997317
     /* 1997317 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1997408), // Rule ID 16562 //
     /* 1997322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1997325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1997339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997368 */     // MIs[0] round
     /* 1997368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997371 */     // MIs[0] policy
     /* 1997371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997381 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 1997384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997407 */     // GIR_Coverage, 16562,
     /* 1997407 */     GIR_EraseRootFromParent_Done,
     /* 1997408 */   // Label 26534: @1997408
     /* 1997408 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1997499), // Rule ID 16563 //
     /* 1997413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1997416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1997430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997459 */     // MIs[0] round
     /* 1997459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997462 */     // MIs[0] policy
     /* 1997462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997472 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 1997475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997498 */     // GIR_Coverage, 16563,
     /* 1997498 */     GIR_EraseRootFromParent_Done,
     /* 1997499 */   // Label 26535: @1997499
     /* 1997499 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1997590), // Rule ID 16566 //
     /* 1997504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1997507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1997521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1997524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997550 */     // MIs[0] round
     /* 1997550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997553 */     // MIs[0] policy
     /* 1997553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997563 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 1997566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997589 */     // GIR_Coverage, 16566,
     /* 1997589 */     GIR_EraseRootFromParent_Done,
     /* 1997590 */   // Label 26536: @1997590
     /* 1997590 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1997681), // Rule ID 16567 //
     /* 1997595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1997598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1997612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1997615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997641 */     // MIs[0] round
     /* 1997641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997644 */     // MIs[0] policy
     /* 1997644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 1997657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997680 */     // GIR_Coverage, 16567,
     /* 1997680 */     GIR_EraseRootFromParent_Done,
     /* 1997681 */   // Label 26537: @1997681
     /* 1997681 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1997772), // Rule ID 16570 //
     /* 1997686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1997689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1997703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997732 */     // MIs[0] round
     /* 1997732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997735 */     // MIs[0] policy
     /* 1997735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997745 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 1997748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997771 */     // GIR_Coverage, 16570,
     /* 1997771 */     GIR_EraseRootFromParent_Done,
     /* 1997772 */   // Label 26538: @1997772
     /* 1997772 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1997863), // Rule ID 16571 //
     /* 1997777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1997780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1997794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997823 */     // MIs[0] round
     /* 1997823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997826 */     // MIs[0] policy
     /* 1997826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997836 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 1997839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997862 */     // GIR_Coverage, 16571,
     /* 1997862 */     GIR_EraseRootFromParent_Done,
     /* 1997863 */   // Label 26539: @1997863
     /* 1997863 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1997954), // Rule ID 16574 //
     /* 1997868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1997871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1997879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1997882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1997885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1997888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997914 */     // MIs[0] round
     /* 1997914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997917 */     // MIs[0] policy
     /* 1997917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1997920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997927 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 1997930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1997952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997953 */     // GIR_Coverage, 16574,
     /* 1997953 */     GIR_EraseRootFromParent_Done,
     /* 1997954 */   // Label 26540: @1997954
     /* 1997954 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1998045), // Rule ID 16575 //
     /* 1997959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1997962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1997967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1997970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1997973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1997976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1997979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998005 */     // MIs[0] round
     /* 1998005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998008 */     // MIs[0] policy
     /* 1998008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 1998021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998044 */     // GIR_Coverage, 16575,
     /* 1998044 */     GIR_EraseRootFromParent_Done,
     /* 1998045 */   // Label 26541: @1998045
     /* 1998045 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1998136), // Rule ID 16578 //
     /* 1998050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1998053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1998061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1998064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1998067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1998070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998096 */     // MIs[0] round
     /* 1998096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998099 */     // MIs[0] policy
     /* 1998099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998109 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 1998112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998135 */     // GIR_Coverage, 16578,
     /* 1998135 */     GIR_EraseRootFromParent_Done,
     /* 1998136 */   // Label 26542: @1998136
     /* 1998136 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1998227), // Rule ID 16579 //
     /* 1998141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1998144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1998152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1998155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1998158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1998161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998187 */     // MIs[0] round
     /* 1998187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998190 */     // MIs[0] policy
     /* 1998190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998200 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 1998203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998226 */     // GIR_Coverage, 16579,
     /* 1998226 */     GIR_EraseRootFromParent_Done,
     /* 1998227 */   // Label 26543: @1998227
     /* 1998227 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1998318), // Rule ID 16582 //
     /* 1998232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1998235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1998243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1998246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1998249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1998252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998278 */     // MIs[0] round
     /* 1998278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998281 */     // MIs[0] policy
     /* 1998281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998291 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 1998294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998317 */     // GIR_Coverage, 16582,
     /* 1998317 */     GIR_EraseRootFromParent_Done,
     /* 1998318 */   // Label 26544: @1998318
     /* 1998318 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1998409), // Rule ID 16583 //
     /* 1998323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1998326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1998334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1998337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1998340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1998343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998369 */     // MIs[0] round
     /* 1998369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998372 */     // MIs[0] policy
     /* 1998372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998382 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 1998385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998408 */     // GIR_Coverage, 16583,
     /* 1998408 */     GIR_EraseRootFromParent_Done,
     /* 1998409 */   // Label 26545: @1998409
     /* 1998409 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1998500), // Rule ID 16586 //
     /* 1998414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1998417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1998431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1998434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998460 */     // MIs[0] round
     /* 1998460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998463 */     // MIs[0] policy
     /* 1998463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998473 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 1998476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998499 */     // GIR_Coverage, 16586,
     /* 1998499 */     GIR_EraseRootFromParent_Done,
     /* 1998500 */   // Label 26546: @1998500
     /* 1998500 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1998591), // Rule ID 16587 //
     /* 1998505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1998508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1998522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1998525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998551 */     // MIs[0] round
     /* 1998551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998554 */     // MIs[0] policy
     /* 1998554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998564 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 1998567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998590 */     // GIR_Coverage, 16587,
     /* 1998590 */     GIR_EraseRootFromParent_Done,
     /* 1998591 */   // Label 26547: @1998591
     /* 1998591 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1998682), // Rule ID 16590 //
     /* 1998596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1998599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1998613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1998616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998642 */     // MIs[0] round
     /* 1998642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998645 */     // MIs[0] policy
     /* 1998645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998655 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 1998658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998681 */     // GIR_Coverage, 16590,
     /* 1998681 */     GIR_EraseRootFromParent_Done,
     /* 1998682 */   // Label 26548: @1998682
     /* 1998682 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1998773), // Rule ID 16591 //
     /* 1998687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1998690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1998704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1998707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998733 */     // MIs[0] round
     /* 1998733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998736 */     // MIs[0] policy
     /* 1998736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998746 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 1998749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998772 */     // GIR_Coverage, 16591,
     /* 1998772 */     GIR_EraseRootFromParent_Done,
     /* 1998773 */   // Label 26549: @1998773
     /* 1998773 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1998864), // Rule ID 16594 //
     /* 1998778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1998781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1998795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1998798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998824 */     // MIs[0] round
     /* 1998824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998827 */     // MIs[0] policy
     /* 1998827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998837 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 1998840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998863 */     // GIR_Coverage, 16594,
     /* 1998863 */     GIR_EraseRootFromParent_Done,
     /* 1998864 */   // Label 26550: @1998864
     /* 1998864 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1998955), // Rule ID 16595 //
     /* 1998869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1998872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1998886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1998889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998915 */     // MIs[0] round
     /* 1998915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998918 */     // MIs[0] policy
     /* 1998918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1998921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998928 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 1998931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1998953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998954 */     // GIR_Coverage, 16595,
     /* 1998954 */     GIR_EraseRootFromParent_Done,
     /* 1998955 */   // Label 26551: @1998955
     /* 1998955 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1999046), // Rule ID 16598 //
     /* 1998960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1998963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1998968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1998971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1998974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1998977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1998980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1998983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999006 */     // MIs[0] round
     /* 1999006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999009 */     // MIs[0] policy
     /* 1999009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999019 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 1999022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999045 */     // GIR_Coverage, 16598,
     /* 1999045 */     GIR_EraseRootFromParent_Done,
     /* 1999046 */   // Label 26552: @1999046
     /* 1999046 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1999137), // Rule ID 16599 //
     /* 1999051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1999054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1999062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1999065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1999068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1999071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999097 */     // MIs[0] round
     /* 1999097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999100 */     // MIs[0] policy
     /* 1999100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999110 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 1999113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999136 */     // GIR_Coverage, 16599,
     /* 1999136 */     GIR_EraseRootFromParent_Done,
     /* 1999137 */   // Label 26553: @1999137
     /* 1999137 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1999228), // Rule ID 16602 //
     /* 1999142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1999145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1999153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1999156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1999159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1999162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999188 */     // MIs[0] round
     /* 1999188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999191 */     // MIs[0] policy
     /* 1999191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999201 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 1999204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999227 */     // GIR_Coverage, 16602,
     /* 1999227 */     GIR_EraseRootFromParent_Done,
     /* 1999228 */   // Label 26554: @1999228
     /* 1999228 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1999319), // Rule ID 16603 //
     /* 1999233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1999236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1999244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1999247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1999250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1999253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999279 */     // MIs[0] round
     /* 1999279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999282 */     // MIs[0] policy
     /* 1999282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999292 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 1999295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999318 */     // GIR_Coverage, 16603,
     /* 1999318 */     GIR_EraseRootFromParent_Done,
     /* 1999319 */   // Label 26555: @1999319
     /* 1999319 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1999410), // Rule ID 16606 //
     /* 1999324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1999327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1999335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1999338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1999341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1999344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999370 */     // MIs[0] round
     /* 1999370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999373 */     // MIs[0] policy
     /* 1999373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999383 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 1999386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999409 */     // GIR_Coverage, 16606,
     /* 1999409 */     GIR_EraseRootFromParent_Done,
     /* 1999410 */   // Label 26556: @1999410
     /* 1999410 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1999501), // Rule ID 16607 //
     /* 1999415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1999418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1999426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1999429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1999432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1999435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999461 */     // MIs[0] round
     /* 1999461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999464 */     // MIs[0] policy
     /* 1999464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999474 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 1999477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999500 */     // GIR_Coverage, 16607,
     /* 1999500 */     GIR_EraseRootFromParent_Done,
     /* 1999501 */   // Label 26557: @1999501
     /* 1999501 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1999592), // Rule ID 16610 //
     /* 1999506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1999517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1999520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1999523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1999526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1999548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999552 */     // MIs[0] round
     /* 1999552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999555 */     // MIs[0] policy
     /* 1999555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999565 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 1999568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999591 */     // GIR_Coverage, 16610,
     /* 1999591 */     GIR_EraseRootFromParent_Done,
     /* 1999592 */   // Label 26558: @1999592
     /* 1999592 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1999683), // Rule ID 16611 //
     /* 1999597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1999608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1999611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1999614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1999617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1999639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999643 */     // MIs[0] round
     /* 1999643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999646 */     // MIs[0] policy
     /* 1999646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999656 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 1999659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999682 */     // GIR_Coverage, 16611,
     /* 1999682 */     GIR_EraseRootFromParent_Done,
     /* 1999683 */   // Label 26559: @1999683
     /* 1999683 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1999774), // Rule ID 16614 //
     /* 1999688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1999699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1999702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1999705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1999708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1999730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999734 */     // MIs[0] round
     /* 1999734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999737 */     // MIs[0] policy
     /* 1999737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999747 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 1999750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999773 */     // GIR_Coverage, 16614,
     /* 1999773 */     GIR_EraseRootFromParent_Done,
     /* 1999774 */   // Label 26560: @1999774
     /* 1999774 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1999865), // Rule ID 16615 //
     /* 1999779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1999790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1999793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1999796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1999799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1999821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999825 */     // MIs[0] round
     /* 1999825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999828 */     // MIs[0] policy
     /* 1999828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999838 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 1999841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999864 */     // GIR_Coverage, 16615,
     /* 1999864 */     GIR_EraseRootFromParent_Done,
     /* 1999865 */   // Label 26561: @1999865
     /* 1999865 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1999956), // Rule ID 16618 //
     /* 1999870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1999873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1999887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1999890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1999912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999916 */     // MIs[0] round
     /* 1999916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999919 */     // MIs[0] policy
     /* 1999919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 1999922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999929 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 1999932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 1999954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999955 */     // GIR_Coverage, 16618,
     /* 1999955 */     GIR_EraseRootFromParent_Done,
     /* 1999956 */   // Label 26562: @1999956
     /* 1999956 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(2000047), // Rule ID 16619 //
     /* 1999961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1999964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 1999969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1999978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1999981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2000003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000007 */     // MIs[0] round
     /* 2000007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000010 */     // MIs[0] policy
     /* 2000010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000020 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2000023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000046 */     // GIR_Coverage, 16619,
     /* 2000046 */     GIR_EraseRootFromParent_Done,
     /* 2000047 */   // Label 26563: @2000047
     /* 2000047 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(2000138), // Rule ID 16622 //
     /* 2000052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2000069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000098 */     // MIs[0] round
     /* 2000098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000101 */     // MIs[0] policy
     /* 2000101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000111 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2000114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000137 */     // GIR_Coverage, 16622,
     /* 2000137 */     GIR_EraseRootFromParent_Done,
     /* 2000138 */   // Label 26564: @2000138
     /* 2000138 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(2000229), // Rule ID 16623 //
     /* 2000143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2000160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000189 */     // MIs[0] round
     /* 2000189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000192 */     // MIs[0] policy
     /* 2000192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000202 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2000205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000228 */     // GIR_Coverage, 16623,
     /* 2000228 */     GIR_EraseRootFromParent_Done,
     /* 2000229 */   // Label 26565: @2000229
     /* 2000229 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(2000320), // Rule ID 16626 //
     /* 2000234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2000237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2000251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2000254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2000276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000280 */     // MIs[0] round
     /* 2000280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000283 */     // MIs[0] policy
     /* 2000283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000293 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2000296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000319 */     // GIR_Coverage, 16626,
     /* 2000319 */     GIR_EraseRootFromParent_Done,
     /* 2000320 */   // Label 26566: @2000320
     /* 2000320 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(2000411), // Rule ID 16627 //
     /* 2000325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2000328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2000342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2000345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2000367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000371 */     // MIs[0] round
     /* 2000371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000374 */     // MIs[0] policy
     /* 2000374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2000387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000410 */     // GIR_Coverage, 16627,
     /* 2000410 */     GIR_EraseRootFromParent_Done,
     /* 2000411 */   // Label 26567: @2000411
     /* 2000411 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(2000502), // Rule ID 16630 //
     /* 2000416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2000419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2000433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2000436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2000458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000462 */     // MIs[0] round
     /* 2000462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000465 */     // MIs[0] policy
     /* 2000465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000475 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2000478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000501 */     // GIR_Coverage, 16630,
     /* 2000501 */     GIR_EraseRootFromParent_Done,
     /* 2000502 */   // Label 26568: @2000502
     /* 2000502 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(2000593), // Rule ID 16631 //
     /* 2000507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2000510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2000524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2000527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2000549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000553 */     // MIs[0] round
     /* 2000553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000556 */     // MIs[0] policy
     /* 2000556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000566 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2000569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000592 */     // GIR_Coverage, 16631,
     /* 2000592 */     GIR_EraseRootFromParent_Done,
     /* 2000593 */   // Label 26569: @2000593
     /* 2000593 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(2000684), // Rule ID 16634 //
     /* 2000598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2000609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2000612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2000615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000644 */     // MIs[0] round
     /* 2000644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000647 */     // MIs[0] policy
     /* 2000647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000657 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2000660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000683 */     // GIR_Coverage, 16634,
     /* 2000683 */     GIR_EraseRootFromParent_Done,
     /* 2000684 */   // Label 26570: @2000684
     /* 2000684 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(2000775), // Rule ID 16635 //
     /* 2000689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2000700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2000703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2000706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000735 */     // MIs[0] round
     /* 2000735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000738 */     // MIs[0] policy
     /* 2000738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000748 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2000751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000774 */     // GIR_Coverage, 16635,
     /* 2000774 */     GIR_EraseRootFromParent_Done,
     /* 2000775 */   // Label 26571: @2000775
     /* 2000775 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(2000866), // Rule ID 16638 //
     /* 2000780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2000791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2000794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2000797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000826 */     // MIs[0] round
     /* 2000826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000829 */     // MIs[0] policy
     /* 2000829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000839 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2000842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000865 */     // GIR_Coverage, 16638,
     /* 2000865 */     GIR_EraseRootFromParent_Done,
     /* 2000866 */   // Label 26572: @2000866
     /* 2000866 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(2000957), // Rule ID 16639 //
     /* 2000871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2000882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2000885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2000888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2000913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000917 */     // MIs[0] round
     /* 2000917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000920 */     // MIs[0] policy
     /* 2000920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2000923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000930 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2000933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2000937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2000955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000956 */     // GIR_Coverage, 16639,
     /* 2000956 */     GIR_EraseRootFromParent_Done,
     /* 2000957 */   // Label 26573: @2000957
     /* 2000957 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(2001048), // Rule ID 16642 //
     /* 2000962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2000970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2000973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2000976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2000979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2000982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2001004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001008 */     // MIs[0] round
     /* 2001008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001011 */     // MIs[0] policy
     /* 2001011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001021 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2001024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001047 */     // GIR_Coverage, 16642,
     /* 2001047 */     GIR_EraseRootFromParent_Done,
     /* 2001048 */   // Label 26574: @2001048
     /* 2001048 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(2001139), // Rule ID 16643 //
     /* 2001053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2001056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2001064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2001067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2001070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2001073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2001095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001099 */     // MIs[0] round
     /* 2001099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001102 */     // MIs[0] policy
     /* 2001102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001112 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2001115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001138 */     // GIR_Coverage, 16643,
     /* 2001138 */     GIR_EraseRootFromParent_Done,
     /* 2001139 */   // Label 26575: @2001139
     /* 2001139 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(2001230), // Rule ID 16646 //
     /* 2001144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2001161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001190 */     // MIs[0] round
     /* 2001190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001193 */     // MIs[0] policy
     /* 2001193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001203 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2001206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001229 */     // GIR_Coverage, 16646,
     /* 2001229 */     GIR_EraseRootFromParent_Done,
     /* 2001230 */   // Label 26576: @2001230
     /* 2001230 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(2001321), // Rule ID 16647 //
     /* 2001235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2001252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001281 */     // MIs[0] round
     /* 2001281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001284 */     // MIs[0] policy
     /* 2001284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001294 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2001297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001320 */     // GIR_Coverage, 16647,
     /* 2001320 */     GIR_EraseRootFromParent_Done,
     /* 2001321 */   // Label 26577: @2001321
     /* 2001321 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(2001412), // Rule ID 16650 //
     /* 2001326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2001343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001372 */     // MIs[0] round
     /* 2001372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001375 */     // MIs[0] policy
     /* 2001375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001385 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2001388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001411 */     // GIR_Coverage, 16650,
     /* 2001411 */     GIR_EraseRootFromParent_Done,
     /* 2001412 */   // Label 26578: @2001412
     /* 2001412 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(2001503), // Rule ID 16651 //
     /* 2001417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2001434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001463 */     // MIs[0] round
     /* 2001463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001466 */     // MIs[0] policy
     /* 2001466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2001479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001502 */     // GIR_Coverage, 16651,
     /* 2001502 */     GIR_EraseRootFromParent_Done,
     /* 2001503 */   // Label 26579: @2001503
     /* 2001503 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(2001594), // Rule ID 16654 //
     /* 2001508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2001525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001554 */     // MIs[0] round
     /* 2001554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001557 */     // MIs[0] policy
     /* 2001557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001567 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2001570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001593 */     // GIR_Coverage, 16654,
     /* 2001593 */     GIR_EraseRootFromParent_Done,
     /* 2001594 */   // Label 26580: @2001594
     /* 2001594 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(2001685), // Rule ID 16655 //
     /* 2001599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2001616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2001619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2001641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001645 */     // MIs[0] round
     /* 2001645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001648 */     // MIs[0] policy
     /* 2001648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001658 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2001661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001684 */     // GIR_Coverage, 16655,
     /* 2001684 */     GIR_EraseRootFromParent_Done,
     /* 2001685 */   // Label 26581: @2001685
     /* 2001685 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(2001776), // Rule ID 16658 //
     /* 2001690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2001693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2001701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2001704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2001707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2001710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2001732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001736 */     // MIs[0] round
     /* 2001736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001739 */     // MIs[0] policy
     /* 2001739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001749 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2001752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001775 */     // GIR_Coverage, 16658,
     /* 2001775 */     GIR_EraseRootFromParent_Done,
     /* 2001776 */   // Label 26582: @2001776
     /* 2001776 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(2001867), // Rule ID 16659 //
     /* 2001781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2001784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2001792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2001795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2001798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2001801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2001823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001827 */     // MIs[0] round
     /* 2001827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001830 */     // MIs[0] policy
     /* 2001830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001840 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2001843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001866 */     // GIR_Coverage, 16659,
     /* 2001866 */     GIR_EraseRootFromParent_Done,
     /* 2001867 */   // Label 26583: @2001867
     /* 2001867 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(2001958), // Rule ID 16662 //
     /* 2001872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2001875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2001883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2001886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2001889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2001892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2001914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001918 */     // MIs[0] round
     /* 2001918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001921 */     // MIs[0] policy
     /* 2001921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2001924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001931 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2001934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2001938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2001956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001957 */     // GIR_Coverage, 16662,
     /* 2001957 */     GIR_EraseRootFromParent_Done,
     /* 2001958 */   // Label 26584: @2001958
     /* 2001958 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(2002049), // Rule ID 16663 //
     /* 2001963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2001966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2001971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2001974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2001977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2001980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2001983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2002005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002009 */     // MIs[0] round
     /* 2002009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002012 */     // MIs[0] policy
     /* 2002012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002022 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2002025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002048 */     // GIR_Coverage, 16663,
     /* 2002048 */     GIR_EraseRootFromParent_Done,
     /* 2002049 */   // Label 26585: @2002049
     /* 2002049 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(2002140), // Rule ID 16666 //
     /* 2002054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2002057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2002062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2002065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2002068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2002071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2002074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2002096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002100 */     // MIs[0] round
     /* 2002100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002103 */     // MIs[0] policy
     /* 2002103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002113 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2002116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002139 */     // GIR_Coverage, 16666,
     /* 2002139 */     GIR_EraseRootFromParent_Done,
     /* 2002140 */   // Label 26586: @2002140
     /* 2002140 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(2002231), // Rule ID 16667 //
     /* 2002145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2002148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2002153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2002156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2002159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2002162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2002165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2002187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002191 */     // MIs[0] round
     /* 2002191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002194 */     // MIs[0] policy
     /* 2002194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002204 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2002207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002230 */     // GIR_Coverage, 16667,
     /* 2002230 */     GIR_EraseRootFromParent_Done,
     /* 2002231 */   // Label 26587: @2002231
     /* 2002231 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(2002322), // Rule ID 16670 //
     /* 2002236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2002247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2002250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2002256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002282 */     // MIs[0] round
     /* 2002282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002285 */     // MIs[0] policy
     /* 2002285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002295 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2002298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002321 */     // GIR_Coverage, 16670,
     /* 2002321 */     GIR_EraseRootFromParent_Done,
     /* 2002322 */   // Label 26588: @2002322
     /* 2002322 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(2002413), // Rule ID 16671 //
     /* 2002327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2002338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2002341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2002347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002373 */     // MIs[0] round
     /* 2002373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002376 */     // MIs[0] policy
     /* 2002376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002386 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2002389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002412 */     // GIR_Coverage, 16671,
     /* 2002412 */     GIR_EraseRootFromParent_Done,
     /* 2002413 */   // Label 26589: @2002413
     /* 2002413 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(2002504), // Rule ID 16674 //
     /* 2002418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2002429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2002432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2002438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002464 */     // MIs[0] round
     /* 2002464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002467 */     // MIs[0] policy
     /* 2002467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002477 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2002480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002503 */     // GIR_Coverage, 16674,
     /* 2002503 */     GIR_EraseRootFromParent_Done,
     /* 2002504 */   // Label 26590: @2002504
     /* 2002504 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(2002595), // Rule ID 16675 //
     /* 2002509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2002520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2002523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2002529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002555 */     // MIs[0] round
     /* 2002555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002558 */     // MIs[0] policy
     /* 2002558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002568 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2002571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002594 */     // GIR_Coverage, 16675,
     /* 2002594 */     GIR_EraseRootFromParent_Done,
     /* 2002595 */   // Label 26591: @2002595
     /* 2002595 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(2002686), // Rule ID 16678 //
     /* 2002600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2002620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002646 */     // MIs[0] round
     /* 2002646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002649 */     // MIs[0] policy
     /* 2002649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002659 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2002662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002685 */     // GIR_Coverage, 16678,
     /* 2002685 */     GIR_EraseRootFromParent_Done,
     /* 2002686 */   // Label 26592: @2002686
     /* 2002686 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(2002777), // Rule ID 16679 //
     /* 2002691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2002711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002737 */     // MIs[0] round
     /* 2002737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002740 */     // MIs[0] policy
     /* 2002740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002750 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2002753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002776 */     // GIR_Coverage, 16679,
     /* 2002776 */     GIR_EraseRootFromParent_Done,
     /* 2002777 */   // Label 26593: @2002777
     /* 2002777 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(2002868), // Rule ID 16682 //
     /* 2002782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002828 */     // MIs[0] round
     /* 2002828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002831 */     // MIs[0] policy
     /* 2002831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002841 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2002844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002867 */     // GIR_Coverage, 16682,
     /* 2002867 */     GIR_EraseRootFromParent_Done,
     /* 2002868 */   // Label 26594: @2002868
     /* 2002868 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(2002959), // Rule ID 16683 //
     /* 2002873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002919 */     // MIs[0] round
     /* 2002919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002922 */     // MIs[0] policy
     /* 2002922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2002925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002932 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2002935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2002939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2002957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002958 */     // GIR_Coverage, 16683,
     /* 2002958 */     GIR_EraseRootFromParent_Done,
     /* 2002959 */   // Label 26595: @2002959
     /* 2002959 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(2003050), // Rule ID 16686 //
     /* 2002964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2002972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2002981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003010 */     // MIs[0] round
     /* 2003010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003013 */     // MIs[0] policy
     /* 2003013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003023 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2003026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003049 */     // GIR_Coverage, 16686,
     /* 2003049 */     GIR_EraseRootFromParent_Done,
     /* 2003050 */   // Label 26596: @2003050
     /* 2003050 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(2003141), // Rule ID 16687 //
     /* 2003055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2003072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003101 */     // MIs[0] round
     /* 2003101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003104 */     // MIs[0] policy
     /* 2003104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2003117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003140 */     // GIR_Coverage, 16687,
     /* 2003140 */     GIR_EraseRootFromParent_Done,
     /* 2003141 */   // Label 26597: @2003141
     /* 2003141 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(2003232), // Rule ID 16690 //
     /* 2003146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2003149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2003163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003192 */     // MIs[0] round
     /* 2003192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003195 */     // MIs[0] policy
     /* 2003195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003205 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2003208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003231 */     // GIR_Coverage, 16690,
     /* 2003231 */     GIR_EraseRootFromParent_Done,
     /* 2003232 */   // Label 26598: @2003232
     /* 2003232 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(2003323), // Rule ID 16691 //
     /* 2003237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2003240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2003254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003283 */     // MIs[0] round
     /* 2003283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003286 */     // MIs[0] policy
     /* 2003286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003296 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2003299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003322 */     // GIR_Coverage, 16691,
     /* 2003322 */     GIR_EraseRootFromParent_Done,
     /* 2003323 */   // Label 26599: @2003323
     /* 2003323 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(2003414), // Rule ID 16694 //
     /* 2003328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2003339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2003342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003374 */     // MIs[0] round
     /* 2003374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003377 */     // MIs[0] policy
     /* 2003377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003387 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2003390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003413 */     // GIR_Coverage, 16694,
     /* 2003413 */     GIR_EraseRootFromParent_Done,
     /* 2003414 */   // Label 26600: @2003414
     /* 2003414 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(2003505), // Rule ID 16695 //
     /* 2003419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2003430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2003433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003465 */     // MIs[0] round
     /* 2003465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003468 */     // MIs[0] policy
     /* 2003468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003478 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2003481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003504 */     // GIR_Coverage, 16695,
     /* 2003504 */     GIR_EraseRootFromParent_Done,
     /* 2003505 */   // Label 26601: @2003505
     /* 2003505 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(2003596), // Rule ID 16698 //
     /* 2003510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2003521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2003524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003556 */     // MIs[0] round
     /* 2003556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003559 */     // MIs[0] policy
     /* 2003559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003569 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2003572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003595 */     // GIR_Coverage, 16698,
     /* 2003595 */     GIR_EraseRootFromParent_Done,
     /* 2003596 */   // Label 26602: @2003596
     /* 2003596 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(2003687), // Rule ID 16699 //
     /* 2003601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2003612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2003615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003647 */     // MIs[0] round
     /* 2003647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003650 */     // MIs[0] policy
     /* 2003650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003660 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2003663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003686 */     // GIR_Coverage, 16699,
     /* 2003686 */     GIR_EraseRootFromParent_Done,
     /* 2003687 */   // Label 26603: @2003687
     /* 2003687 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(2003778), // Rule ID 16702 //
     /* 2003692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2003703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2003706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003738 */     // MIs[0] round
     /* 2003738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003741 */     // MIs[0] policy
     /* 2003741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003751 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2003754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003777 */     // GIR_Coverage, 16702,
     /* 2003777 */     GIR_EraseRootFromParent_Done,
     /* 2003778 */   // Label 26604: @2003778
     /* 2003778 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(2003869), // Rule ID 16703 //
     /* 2003783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2003794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2003797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003829 */     // MIs[0] round
     /* 2003829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003832 */     // MIs[0] policy
     /* 2003832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003842 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2003845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003868 */     // GIR_Coverage, 16703,
     /* 2003868 */     GIR_EraseRootFromParent_Done,
     /* 2003869 */   // Label 26605: @2003869
     /* 2003869 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(2003960), // Rule ID 16706 //
     /* 2003874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2003894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003920 */     // MIs[0] round
     /* 2003920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003923 */     // MIs[0] policy
     /* 2003923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2003926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003933 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2003936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2003940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2003958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003959 */     // GIR_Coverage, 16706,
     /* 2003959 */     GIR_EraseRootFromParent_Done,
     /* 2003960 */   // Label 26606: @2003960
     /* 2003960 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(2004051), // Rule ID 16707 //
     /* 2003965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2003973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2003985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004011 */     // MIs[0] round
     /* 2004011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004014 */     // MIs[0] policy
     /* 2004014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2004027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004050 */     // GIR_Coverage, 16707,
     /* 2004050 */     GIR_EraseRootFromParent_Done,
     /* 2004051 */   // Label 26607: @2004051
     /* 2004051 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(2004142), // Rule ID 16710 //
     /* 2004056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2004059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2004073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2004076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004102 */     // MIs[0] round
     /* 2004102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004105 */     // MIs[0] policy
     /* 2004105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004115 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2004118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004141 */     // GIR_Coverage, 16710,
     /* 2004141 */     GIR_EraseRootFromParent_Done,
     /* 2004142 */   // Label 26608: @2004142
     /* 2004142 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(2004233), // Rule ID 16711 //
     /* 2004147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2004150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2004164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2004167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004193 */     // MIs[0] round
     /* 2004193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004196 */     // MIs[0] policy
     /* 2004196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004206 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2004209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004232 */     // GIR_Coverage, 16711,
     /* 2004232 */     GIR_EraseRootFromParent_Done,
     /* 2004233 */   // Label 26609: @2004233
     /* 2004233 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(2004324), // Rule ID 16714 //
     /* 2004238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2004241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2004258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004284 */     // MIs[0] round
     /* 2004284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004287 */     // MIs[0] policy
     /* 2004287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004297 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2004300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004323 */     // GIR_Coverage, 16714,
     /* 2004323 */     GIR_EraseRootFromParent_Done,
     /* 2004324 */   // Label 26610: @2004324
     /* 2004324 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(2004415), // Rule ID 16715 //
     /* 2004329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2004332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2004349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004375 */     // MIs[0] round
     /* 2004375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004378 */     // MIs[0] policy
     /* 2004378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004388 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2004391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004414 */     // GIR_Coverage, 16715,
     /* 2004414 */     GIR_EraseRootFromParent_Done,
     /* 2004415 */   // Label 26611: @2004415
     /* 2004415 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(2004506), // Rule ID 16718 //
     /* 2004420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2004437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2004440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004466 */     // MIs[0] round
     /* 2004466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004469 */     // MIs[0] policy
     /* 2004469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004479 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2004482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004505 */     // GIR_Coverage, 16718,
     /* 2004505 */     GIR_EraseRootFromParent_Done,
     /* 2004506 */   // Label 26612: @2004506
     /* 2004506 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(2004597), // Rule ID 16719 //
     /* 2004511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2004528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2004531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004557 */     // MIs[0] round
     /* 2004557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004560 */     // MIs[0] policy
     /* 2004560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2004573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004596 */     // GIR_Coverage, 16719,
     /* 2004596 */     GIR_EraseRootFromParent_Done,
     /* 2004597 */   // Label 26613: @2004597
     /* 2004597 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(2004688), // Rule ID 16722 //
     /* 2004602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2004619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2004622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004648 */     // MIs[0] round
     /* 2004648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004651 */     // MIs[0] policy
     /* 2004651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004661 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2004664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004687 */     // GIR_Coverage, 16722,
     /* 2004687 */     GIR_EraseRootFromParent_Done,
     /* 2004688 */   // Label 26614: @2004688
     /* 2004688 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(2004779), // Rule ID 16723 //
     /* 2004693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2004710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2004713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004739 */     // MIs[0] round
     /* 2004739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004742 */     // MIs[0] policy
     /* 2004742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004752 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2004755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004778 */     // GIR_Coverage, 16723,
     /* 2004778 */     GIR_EraseRootFromParent_Done,
     /* 2004779 */   // Label 26615: @2004779
     /* 2004779 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(2004870), // Rule ID 16726 //
     /* 2004784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2004801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2004804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004830 */     // MIs[0] round
     /* 2004830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004833 */     // MIs[0] policy
     /* 2004833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004843 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2004846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004869 */     // GIR_Coverage, 16726,
     /* 2004869 */     GIR_EraseRootFromParent_Done,
     /* 2004870 */   // Label 26616: @2004870
     /* 2004870 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(2004961), // Rule ID 16727 //
     /* 2004875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2004892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2004895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004921 */     // MIs[0] round
     /* 2004921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004924 */     // MIs[0] policy
     /* 2004924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004934 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2004937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004960 */     // GIR_Coverage, 16727,
     /* 2004960 */     GIR_EraseRootFromParent_Done,
     /* 2004961 */   // Label 26617: @2004961
     /* 2004961 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(2005052), // Rule ID 16730 //
     /* 2004966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2004969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2004974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2004977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2004980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2004983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2004986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005012 */     // MIs[0] round
     /* 2005012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005015 */     // MIs[0] policy
     /* 2005015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005025 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2005028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005051 */     // GIR_Coverage, 16730,
     /* 2005051 */     GIR_EraseRootFromParent_Done,
     /* 2005052 */   // Label 26618: @2005052
     /* 2005052 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(2005143), // Rule ID 16731 //
     /* 2005057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2005068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2005071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2005074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2005077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005103 */     // MIs[0] round
     /* 2005103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005106 */     // MIs[0] policy
     /* 2005106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005116 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2005119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005142 */     // GIR_Coverage, 16731,
     /* 2005142 */     GIR_EraseRootFromParent_Done,
     /* 2005143 */   // Label 26619: @2005143
     /* 2005143 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(2005234), // Rule ID 16734 //
     /* 2005148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2005159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2005162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2005165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2005168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005194 */     // MIs[0] round
     /* 2005194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005197 */     // MIs[0] policy
     /* 2005197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005207 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2005210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005233 */     // GIR_Coverage, 16734,
     /* 2005233 */     GIR_EraseRootFromParent_Done,
     /* 2005234 */   // Label 26620: @2005234
     /* 2005234 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(2005325), // Rule ID 16735 //
     /* 2005239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2005250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2005253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2005256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2005259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005285 */     // MIs[0] round
     /* 2005285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005288 */     // MIs[0] policy
     /* 2005288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005298 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2005301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005324 */     // GIR_Coverage, 16735,
     /* 2005324 */     GIR_EraseRootFromParent_Done,
     /* 2005325 */   // Label 26621: @2005325
     /* 2005325 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(2005416), // Rule ID 16738 //
     /* 2005330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2005333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2005372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005376 */     // MIs[0] round
     /* 2005376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005379 */     // MIs[0] policy
     /* 2005379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005389 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2005392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005415 */     // GIR_Coverage, 16738,
     /* 2005415 */     GIR_EraseRootFromParent_Done,
     /* 2005416 */   // Label 26622: @2005416
     /* 2005416 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(2005507), // Rule ID 16739 //
     /* 2005421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2005424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2005463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005467 */     // MIs[0] round
     /* 2005467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005470 */     // MIs[0] policy
     /* 2005470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005480 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2005483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005506 */     // GIR_Coverage, 16739,
     /* 2005506 */     GIR_EraseRootFromParent_Done,
     /* 2005507 */   // Label 26623: @2005507
     /* 2005507 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(2005598), // Rule ID 16742 //
     /* 2005512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2005523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2005526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2005532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005558 */     // MIs[0] round
     /* 2005558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005561 */     // MIs[0] policy
     /* 2005561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005571 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2005574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005597 */     // GIR_Coverage, 16742,
     /* 2005597 */     GIR_EraseRootFromParent_Done,
     /* 2005598 */   // Label 26624: @2005598
     /* 2005598 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(2005689), // Rule ID 16743 //
     /* 2005603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2005614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2005617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2005623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2005645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005649 */     // MIs[0] round
     /* 2005649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005652 */     // MIs[0] policy
     /* 2005652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005662 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10969:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2005665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005688 */     // GIR_Coverage, 16743,
     /* 2005688 */     GIR_EraseRootFromParent_Done,
     /* 2005689 */   // Label 26625: @2005689
     /* 2005689 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(2005780), // Rule ID 16746 //
     /* 2005694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2005697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2005711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2005736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005740 */     // MIs[0] round
     /* 2005740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005743 */     // MIs[0] policy
     /* 2005743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005753 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2005756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005779 */     // GIR_Coverage, 16746,
     /* 2005779 */     GIR_EraseRootFromParent_Done,
     /* 2005780 */   // Label 26626: @2005780
     /* 2005780 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(2005871), // Rule ID 16747 //
     /* 2005785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2005788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2005802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2005827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005831 */     // MIs[0] round
     /* 2005831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005834 */     // MIs[0] policy
     /* 2005834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10969:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2005847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005870 */     // GIR_Coverage, 16747,
     /* 2005870 */     GIR_EraseRootFromParent_Done,
     /* 2005871 */   // Label 26627: @2005871
     /* 2005871 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(2005962), // Rule ID 16750 //
     /* 2005876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2005879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2005893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2005918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005922 */     // MIs[0] round
     /* 2005922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005925 */     // MIs[0] policy
     /* 2005925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005935 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2005938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005961 */     // GIR_Coverage, 16750,
     /* 2005961 */     GIR_EraseRootFromParent_Done,
     /* 2005962 */   // Label 26628: @2005962
     /* 2005962 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(2006053), // Rule ID 16751 //
     /* 2005967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2005970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2005975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2005984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2006009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006013 */     // MIs[0] round
     /* 2006013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006016 */     // MIs[0] policy
     /* 2006016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10969:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2006029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006052 */     // GIR_Coverage, 16751,
     /* 2006052 */     GIR_EraseRootFromParent_Done,
     /* 2006053 */   // Label 26629: @2006053
     /* 2006053 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(2006144), // Rule ID 16754 //
     /* 2006058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2006069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2006072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006104 */     // MIs[0] round
     /* 2006104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006107 */     // MIs[0] policy
     /* 2006107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2006120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006143 */     // GIR_Coverage, 16754,
     /* 2006143 */     GIR_EraseRootFromParent_Done,
     /* 2006144 */   // Label 26630: @2006144
     /* 2006144 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(2006235), // Rule ID 16755 //
     /* 2006149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2006160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2006163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006195 */     // MIs[0] round
     /* 2006195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006198 */     // MIs[0] policy
     /* 2006198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006208 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2006211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006234 */     // GIR_Coverage, 16755,
     /* 2006234 */     GIR_EraseRootFromParent_Done,
     /* 2006235 */   // Label 26631: @2006235
     /* 2006235 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(2006326), // Rule ID 16758 //
     /* 2006240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2006251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2006254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006286 */     // MIs[0] round
     /* 2006286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006289 */     // MIs[0] policy
     /* 2006289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006299 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2006302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006325 */     // GIR_Coverage, 16758,
     /* 2006325 */     GIR_EraseRootFromParent_Done,
     /* 2006326 */   // Label 26632: @2006326
     /* 2006326 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(2006417), // Rule ID 16759 //
     /* 2006331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2006342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2006345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006377 */     // MIs[0] round
     /* 2006377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006380 */     // MIs[0] policy
     /* 2006380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006390 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2006393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006416 */     // GIR_Coverage, 16759,
     /* 2006416 */     GIR_EraseRootFromParent_Done,
     /* 2006417 */   // Label 26633: @2006417
     /* 2006417 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(2006508), // Rule ID 16762 //
     /* 2006422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2006433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2006436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2006445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006468 */     // MIs[0] round
     /* 2006468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006471 */     // MIs[0] policy
     /* 2006471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006481 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2006484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006507 */     // GIR_Coverage, 16762,
     /* 2006507 */     GIR_EraseRootFromParent_Done,
     /* 2006508 */   // Label 26634: @2006508
     /* 2006508 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(2006599), // Rule ID 16763 //
     /* 2006513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2006524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2006527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2006533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2006536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2006555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006559 */     // MIs[0] round
     /* 2006559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006562 */     // MIs[0] policy
     /* 2006562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006572 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2006575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006598 */     // GIR_Coverage, 16763,
     /* 2006598 */     GIR_EraseRootFromParent_Done,
     /* 2006599 */   // Label 26635: @2006599
     /* 2006599 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(2006690), // Rule ID 16766 //
     /* 2006604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2006615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2006618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2006621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2006646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006650 */     // MIs[0] round
     /* 2006650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006653 */     // MIs[0] policy
     /* 2006653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006663 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2006666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006689 */     // GIR_Coverage, 16766,
     /* 2006689 */     GIR_EraseRootFromParent_Done,
     /* 2006690 */   // Label 26636: @2006690
     /* 2006690 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(2006781), // Rule ID 16767 //
     /* 2006695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2006706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2006709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2006712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2006737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006741 */     // MIs[0] round
     /* 2006741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006744 */     // MIs[0] policy
     /* 2006744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006754 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2006757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006780 */     // GIR_Coverage, 16767,
     /* 2006780 */     GIR_EraseRootFromParent_Done,
     /* 2006781 */   // Label 26637: @2006781
     /* 2006781 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(2006872), // Rule ID 16770 //
     /* 2006786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2006797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2006800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2006803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2006828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006832 */     // MIs[0] round
     /* 2006832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006835 */     // MIs[0] policy
     /* 2006835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006845 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2006848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006871 */     // GIR_Coverage, 16770,
     /* 2006871 */     GIR_EraseRootFromParent_Done,
     /* 2006872 */   // Label 26638: @2006872
     /* 2006872 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(2006963), // Rule ID 16771 //
     /* 2006877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2006888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2006891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2006894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2006919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006923 */     // MIs[0] round
     /* 2006923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006926 */     // MIs[0] policy
     /* 2006926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2006939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006962 */     // GIR_Coverage, 16771,
     /* 2006962 */     GIR_EraseRootFromParent_Done,
     /* 2006963 */   // Label 26639: @2006963
     /* 2006963 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(2007054), // Rule ID 16774 //
     /* 2006968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2006976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2006979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2006982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2006985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2007010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007014 */     // MIs[0] round
     /* 2007014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007017 */     // MIs[0] policy
     /* 2007017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007027 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2007030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007053 */     // GIR_Coverage, 16774,
     /* 2007053 */     GIR_EraseRootFromParent_Done,
     /* 2007054 */   // Label 26640: @2007054
     /* 2007054 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(2007145), // Rule ID 16775 //
     /* 2007059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2007070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2007073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2007076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2007101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007105 */     // MIs[0] round
     /* 2007105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007108 */     // MIs[0] policy
     /* 2007108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007118 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2007121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007144 */     // GIR_Coverage, 16775,
     /* 2007144 */     GIR_EraseRootFromParent_Done,
     /* 2007145 */   // Label 26641: @2007145
     /* 2007145 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(2007236), // Rule ID 16778 //
     /* 2007150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2007161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2007164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2007167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007196 */     // MIs[0] round
     /* 2007196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007199 */     // MIs[0] policy
     /* 2007199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007209 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2007212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007235 */     // GIR_Coverage, 16778,
     /* 2007235 */     GIR_EraseRootFromParent_Done,
     /* 2007236 */   // Label 26642: @2007236
     /* 2007236 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(2007327), // Rule ID 16779 //
     /* 2007241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2007252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2007255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2007258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007287 */     // MIs[0] round
     /* 2007287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007290 */     // MIs[0] policy
     /* 2007290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007300 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10969:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2007303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007326 */     // GIR_Coverage, 16779,
     /* 2007326 */     GIR_EraseRootFromParent_Done,
     /* 2007327 */   // Label 26643: @2007327
     /* 2007327 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(2007418), // Rule ID 16782 //
     /* 2007332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2007343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2007346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2007349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007378 */     // MIs[0] round
     /* 2007378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007381 */     // MIs[0] policy
     /* 2007381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007391 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2007394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007417 */     // GIR_Coverage, 16782,
     /* 2007417 */     GIR_EraseRootFromParent_Done,
     /* 2007418 */   // Label 26644: @2007418
     /* 2007418 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(2007509), // Rule ID 16783 //
     /* 2007423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2007434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2007437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2007440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007469 */     // MIs[0] round
     /* 2007469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007472 */     // MIs[0] policy
     /* 2007472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10969:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2007485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007508 */     // GIR_Coverage, 16783,
     /* 2007508 */     GIR_EraseRootFromParent_Done,
     /* 2007509 */   // Label 26645: @2007509
     /* 2007509 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(2007600), // Rule ID 16786 //
     /* 2007514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2007525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2007528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2007531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007560 */     // MIs[0] round
     /* 2007560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007563 */     // MIs[0] policy
     /* 2007563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007573 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2007576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007599 */     // GIR_Coverage, 16786,
     /* 2007599 */     GIR_EraseRootFromParent_Done,
     /* 2007600 */   // Label 26646: @2007600
     /* 2007600 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(2007691), // Rule ID 16787 //
     /* 2007605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2007613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2007616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2007619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2007622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2007647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007651 */     // MIs[0] round
     /* 2007651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007654 */     // MIs[0] policy
     /* 2007654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10969:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2007667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007690 */     // GIR_Coverage, 16787,
     /* 2007690 */     GIR_EraseRootFromParent_Done,
     /* 2007691 */   // Label 26647: @2007691
     /* 2007691 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(2007782), // Rule ID 16790 //
     /* 2007696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2007704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2007707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2007710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2007713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2007716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2007738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007742 */     // MIs[0] round
     /* 2007742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007745 */     // MIs[0] policy
     /* 2007745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007755 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2007758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007781 */     // GIR_Coverage, 16790,
     /* 2007781 */     GIR_EraseRootFromParent_Done,
     /* 2007782 */   // Label 26648: @2007782
     /* 2007782 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(2007873), // Rule ID 16791 //
     /* 2007787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2007795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2007798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2007801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2007804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2007807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2007829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007833 */     // MIs[0] round
     /* 2007833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007836 */     // MIs[0] policy
     /* 2007836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007846 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2007849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007872 */     // GIR_Coverage, 16791,
     /* 2007872 */     GIR_EraseRootFromParent_Done,
     /* 2007873 */   // Label 26649: @2007873
     /* 2007873 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(2007964), // Rule ID 16794 //
     /* 2007878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2007886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2007889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2007892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2007895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2007898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2007920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007924 */     // MIs[0] round
     /* 2007924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007927 */     // MIs[0] policy
     /* 2007927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007937 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2007940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007963 */     // GIR_Coverage, 16794,
     /* 2007963 */     GIR_EraseRootFromParent_Done,
     /* 2007964 */   // Label 26650: @2007964
     /* 2007964 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(2008055), // Rule ID 16795 //
     /* 2007969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2007977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2007980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2007983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2007986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2007989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2008011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008015 */     // MIs[0] round
     /* 2008015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008018 */     // MIs[0] policy
     /* 2008018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008028 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2008031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008054 */     // GIR_Coverage, 16795,
     /* 2008054 */     GIR_EraseRootFromParent_Done,
     /* 2008055 */   // Label 26651: @2008055
     /* 2008055 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(2008146), // Rule ID 16798 //
     /* 2008060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2008071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2008074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2008077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2008102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008106 */     // MIs[0] round
     /* 2008106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008109 */     // MIs[0] policy
     /* 2008109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008119 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2008122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008145 */     // GIR_Coverage, 16798,
     /* 2008145 */     GIR_EraseRootFromParent_Done,
     /* 2008146 */   // Label 26652: @2008146
     /* 2008146 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(2008237), // Rule ID 16799 //
     /* 2008151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2008162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2008165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2008168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2008193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008197 */     // MIs[0] round
     /* 2008197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008200 */     // MIs[0] policy
     /* 2008200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2008213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008236 */     // GIR_Coverage, 16799,
     /* 2008236 */     GIR_EraseRootFromParent_Done,
     /* 2008237 */   // Label 26653: @2008237
     /* 2008237 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(2008328), // Rule ID 16802 //
     /* 2008242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2008259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2008262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2008284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008288 */     // MIs[0] round
     /* 2008288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008291 */     // MIs[0] policy
     /* 2008291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008301 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2008304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008327 */     // GIR_Coverage, 16802,
     /* 2008327 */     GIR_EraseRootFromParent_Done,
     /* 2008328 */   // Label 26654: @2008328
     /* 2008328 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(2008419), // Rule ID 16803 //
     /* 2008333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2008350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2008353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2008375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008379 */     // MIs[0] round
     /* 2008379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008382 */     // MIs[0] policy
     /* 2008382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008392 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10955:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2008395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008418 */     // GIR_Coverage, 16803,
     /* 2008418 */     GIR_EraseRootFromParent_Done,
     /* 2008419 */   // Label 26655: @2008419
     /* 2008419 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(2008510), // Rule ID 16806 //
     /* 2008424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2008441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2008466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008470 */     // MIs[0] round
     /* 2008470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008473 */     // MIs[0] policy
     /* 2008473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10955:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2008486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008509 */     // GIR_Coverage, 16806,
     /* 2008509 */     GIR_EraseRootFromParent_Done,
     /* 2008510 */   // Label 26656: @2008510
     /* 2008510 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(2008601), // Rule ID 16807 //
     /* 2008515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2008532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2008557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008561 */     // MIs[0] round
     /* 2008561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008564 */     // MIs[0] policy
     /* 2008564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10955:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2008577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008600 */     // GIR_Coverage, 16807,
     /* 2008600 */     GIR_EraseRootFromParent_Done,
     /* 2008601 */   // Label 26657: @2008601
     /* 2008601 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(2008692), // Rule ID 16810 //
     /* 2008606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2008623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2008648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008652 */     // MIs[0] round
     /* 2008652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008655 */     // MIs[0] policy
     /* 2008655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008665 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2008668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008691 */     // GIR_Coverage, 16810,
     /* 2008691 */     GIR_EraseRootFromParent_Done,
     /* 2008692 */   // Label 26658: @2008692
     /* 2008692 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(2008783), // Rule ID 16811 //
     /* 2008697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2008714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2008739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008743 */     // MIs[0] round
     /* 2008743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008746 */     // MIs[0] policy
     /* 2008746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008756 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10955:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2008759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008782 */     // GIR_Coverage, 16811,
     /* 2008782 */     GIR_EraseRootFromParent_Done,
     /* 2008783 */   // Label 26659: @2008783
     /* 2008783 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(2008874), // Rule ID 16814 //
     /* 2008788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2008799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2008802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2008805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2008808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2008830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008834 */     // MIs[0] round
     /* 2008834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008837 */     // MIs[0] policy
     /* 2008837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008847 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2008850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008873 */     // GIR_Coverage, 16814,
     /* 2008873 */     GIR_EraseRootFromParent_Done,
     /* 2008874 */   // Label 26660: @2008874
     /* 2008874 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(2008965), // Rule ID 16815 //
     /* 2008879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2008890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2008893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2008896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2008899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2008921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008925 */     // MIs[0] round
     /* 2008925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008928 */     // MIs[0] policy
     /* 2008928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2008941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008964 */     // GIR_Coverage, 16815,
     /* 2008964 */     GIR_EraseRootFromParent_Done,
     /* 2008965 */   // Label 26661: @2008965
     /* 2008965 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(2009056), // Rule ID 16818 //
     /* 2008970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2008978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2008981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2008984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2008987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2008990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2009012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009016 */     // MIs[0] round
     /* 2009016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009019 */     // MIs[0] policy
     /* 2009019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009029 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2009032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009055 */     // GIR_Coverage, 16818,
     /* 2009055 */     GIR_EraseRootFromParent_Done,
     /* 2009056 */   // Label 26662: @2009056
     /* 2009056 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(2009147), // Rule ID 16819 //
     /* 2009061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2009072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2009075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2009078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2009081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2009084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2009103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009107 */     // MIs[0] round
     /* 2009107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009110 */     // MIs[0] policy
     /* 2009110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2009123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009146 */     // GIR_Coverage, 16819,
     /* 2009146 */     GIR_EraseRootFromParent_Done,
     /* 2009147 */   // Label 26663: @2009147
     /* 2009147 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(2009238), // Rule ID 16822 //
     /* 2009152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2009163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2009166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2009169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2009172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2009175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2009194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009198 */     // MIs[0] round
     /* 2009198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009201 */     // MIs[0] policy
     /* 2009201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009211 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2009214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009237 */     // GIR_Coverage, 16822,
     /* 2009237 */     GIR_EraseRootFromParent_Done,
     /* 2009238 */   // Label 26664: @2009238
     /* 2009238 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(2009329), // Rule ID 16823 //
     /* 2009243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2009254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2009257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2009260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2009263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2009266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2009285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009289 */     // MIs[0] round
     /* 2009289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009292 */     // MIs[0] policy
     /* 2009292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009302 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2009305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009328 */     // GIR_Coverage, 16823,
     /* 2009328 */     GIR_EraseRootFromParent_Done,
     /* 2009329 */   // Label 26665: @2009329
     /* 2009329 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(2009420), // Rule ID 16826 //
     /* 2009334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2009345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2009348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2009351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009380 */     // MIs[0] round
     /* 2009380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009383 */     // MIs[0] policy
     /* 2009383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009393 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2009396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009419 */     // GIR_Coverage, 16826,
     /* 2009419 */     GIR_EraseRootFromParent_Done,
     /* 2009420 */   // Label 26666: @2009420
     /* 2009420 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(2009511), // Rule ID 16827 //
     /* 2009425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2009436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2009439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2009442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009471 */     // MIs[0] round
     /* 2009471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009474 */     // MIs[0] policy
     /* 2009474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2009487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009510 */     // GIR_Coverage, 16827,
     /* 2009510 */     GIR_EraseRootFromParent_Done,
     /* 2009511 */   // Label 26667: @2009511
     /* 2009511 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(2009602), // Rule ID 16830 //
     /* 2009516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2009527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2009530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2009533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009562 */     // MIs[0] round
     /* 2009562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009565 */     // MIs[0] policy
     /* 2009565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009575 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2009578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009601 */     // GIR_Coverage, 16830,
     /* 2009601 */     GIR_EraseRootFromParent_Done,
     /* 2009602 */   // Label 26668: @2009602
     /* 2009602 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(2009693), // Rule ID 16831 //
     /* 2009607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2009618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2009621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2009624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009653 */     // MIs[0] round
     /* 2009653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009656 */     // MIs[0] policy
     /* 2009656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009666 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2009669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009692 */     // GIR_Coverage, 16831,
     /* 2009692 */     GIR_EraseRootFromParent_Done,
     /* 2009693 */   // Label 26669: @2009693
     /* 2009693 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(2009784), // Rule ID 16834 //
     /* 2009698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2009709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2009712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2009715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2009721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009744 */     // MIs[0] round
     /* 2009744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009747 */     // MIs[0] policy
     /* 2009747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2009760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009783 */     // GIR_Coverage, 16834,
     /* 2009783 */     GIR_EraseRootFromParent_Done,
     /* 2009784 */   // Label 26670: @2009784
     /* 2009784 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(2009875), // Rule ID 16835 //
     /* 2009789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2009800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2009803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2009806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2009812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2009831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009835 */     // MIs[0] round
     /* 2009835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009838 */     // MIs[0] policy
     /* 2009838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009848 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2009851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009874 */     // GIR_Coverage, 16835,
     /* 2009874 */     GIR_EraseRootFromParent_Done,
     /* 2009875 */   // Label 26671: @2009875
     /* 2009875 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(2009966), // Rule ID 16838 //
     /* 2009880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2009891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2009894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2009897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2009922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009926 */     // MIs[0] round
     /* 2009926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009929 */     // MIs[0] policy
     /* 2009929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2009942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009965 */     // GIR_Coverage, 16838,
     /* 2009965 */     GIR_EraseRootFromParent_Done,
     /* 2009966 */   // Label 26672: @2009966
     /* 2009966 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(2010057), // Rule ID 16839 //
     /* 2009971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2009979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2009982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2009985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2009988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2010013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010017 */     // MIs[0] round
     /* 2010017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010020 */     // MIs[0] policy
     /* 2010020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010030 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10955:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2010033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010056 */     // GIR_Coverage, 16839,
     /* 2010056 */     GIR_EraseRootFromParent_Done,
     /* 2010057 */   // Label 26673: @2010057
     /* 2010057 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(2010148), // Rule ID 16842 //
     /* 2010062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2010065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2010070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2010073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2010076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2010079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2010092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2010104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010108 */     // MIs[0] round
     /* 2010108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010111 */     // MIs[0] policy
     /* 2010111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010121 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2010124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010147 */     // GIR_Coverage, 16842,
     /* 2010147 */     GIR_EraseRootFromParent_Done,
     /* 2010148 */   // Label 26674: @2010148
     /* 2010148 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(2010239), // Rule ID 16843 //
     /* 2010153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2010156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2010161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2010164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2010167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2010170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2010183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2010195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010199 */     // MIs[0] round
     /* 2010199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010202 */     // MIs[0] policy
     /* 2010202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010212 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10955:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2010215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010238 */     // GIR_Coverage, 16843,
     /* 2010238 */     GIR_EraseRootFromParent_Done,
     /* 2010239 */   // Label 26675: @2010239
     /* 2010239 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(2010330), // Rule ID 16846 //
     /* 2010244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2010247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2010252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2010255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2010258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2010261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2010274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2010286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010290 */     // MIs[0] round
     /* 2010290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010293 */     // MIs[0] policy
     /* 2010293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010303 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2010306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010329 */     // GIR_Coverage, 16846,
     /* 2010329 */     GIR_EraseRootFromParent_Done,
     /* 2010330 */   // Label 26676: @2010330
     /* 2010330 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(2010421), // Rule ID 16847 //
     /* 2010335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2010338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2010343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2010346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2010349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2010352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2010365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2010377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010381 */     // MIs[0] round
     /* 2010381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010384 */     // MIs[0] policy
     /* 2010384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010394 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10955:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2010397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010420 */     // GIR_Coverage, 16847,
     /* 2010420 */     GIR_EraseRootFromParent_Done,
     /* 2010421 */   // Label 26677: @2010421
     /* 2010421 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(2010512), // Rule ID 16850 //
     /* 2010426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2010429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2010437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2010440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2010443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2010446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010472 */     // MIs[0] round
     /* 2010472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010475 */     // MIs[0] policy
     /* 2010475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010485 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2010488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010511 */     // GIR_Coverage, 16850,
     /* 2010511 */     GIR_EraseRootFromParent_Done,
     /* 2010512 */   // Label 26678: @2010512
     /* 2010512 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(2010603), // Rule ID 16851 //
     /* 2010517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2010520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2010528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2010531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2010534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2010537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010563 */     // MIs[0] round
     /* 2010563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010566 */     // MIs[0] policy
     /* 2010566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010576 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2010579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010602 */     // GIR_Coverage, 16851,
     /* 2010602 */     GIR_EraseRootFromParent_Done,
     /* 2010603 */   // Label 26679: @2010603
     /* 2010603 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(2010694), // Rule ID 16854 //
     /* 2010608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2010611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2010625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2010628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010654 */     // MIs[0] round
     /* 2010654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010657 */     // MIs[0] policy
     /* 2010657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010667 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2010670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010693 */     // GIR_Coverage, 16854,
     /* 2010693 */     GIR_EraseRootFromParent_Done,
     /* 2010694 */   // Label 26680: @2010694
     /* 2010694 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(2010785), // Rule ID 16855 //
     /* 2010699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2010702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2010716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2010719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010745 */     // MIs[0] round
     /* 2010745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010748 */     // MIs[0] policy
     /* 2010748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010758 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2010761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010784 */     // GIR_Coverage, 16855,
     /* 2010784 */     GIR_EraseRootFromParent_Done,
     /* 2010785 */   // Label 26681: @2010785
     /* 2010785 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(2010876), // Rule ID 16858 //
     /* 2010790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2010793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2010801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2010804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010836 */     // MIs[0] round
     /* 2010836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010839 */     // MIs[0] policy
     /* 2010839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010849 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2010852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010875 */     // GIR_Coverage, 16858,
     /* 2010875 */     GIR_EraseRootFromParent_Done,
     /* 2010876 */   // Label 26682: @2010876
     /* 2010876 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(2010967), // Rule ID 16859 //
     /* 2010881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2010884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2010892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2010895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010927 */     // MIs[0] round
     /* 2010927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010930 */     // MIs[0] policy
     /* 2010930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010940 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2010943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010966 */     // GIR_Coverage, 16859,
     /* 2010966 */     GIR_EraseRootFromParent_Done,
     /* 2010967 */   // Label 26683: @2010967
     /* 2010967 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(2011058), // Rule ID 16862 //
     /* 2010972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2010975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2010980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2010983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2010986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2010992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011018 */     // MIs[0] round
     /* 2011018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011021 */     // MIs[0] policy
     /* 2011021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011031 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2011034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011057 */     // GIR_Coverage, 16862,
     /* 2011057 */     GIR_EraseRootFromParent_Done,
     /* 2011058 */   // Label 26684: @2011058
     /* 2011058 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(2011149), // Rule ID 16863 //
     /* 2011063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2011066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2011074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2011077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2011083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011109 */     // MIs[0] round
     /* 2011109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011112 */     // MIs[0] policy
     /* 2011112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011122 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2011125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011148 */     // GIR_Coverage, 16863,
     /* 2011148 */     GIR_EraseRootFromParent_Done,
     /* 2011149 */   // Label 26685: @2011149
     /* 2011149 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(2011240), // Rule ID 16866 //
     /* 2011154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2011157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2011165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2011168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2011174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011200 */     // MIs[0] round
     /* 2011200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011203 */     // MIs[0] policy
     /* 2011203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011213 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2011216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011239 */     // GIR_Coverage, 16866,
     /* 2011239 */     GIR_EraseRootFromParent_Done,
     /* 2011240 */   // Label 26686: @2011240
     /* 2011240 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(2011331), // Rule ID 16867 //
     /* 2011245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2011248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2011256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2011259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2011265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011291 */     // MIs[0] round
     /* 2011291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011294 */     // MIs[0] policy
     /* 2011294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011304 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2011307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011330 */     // GIR_Coverage, 16867,
     /* 2011330 */     GIR_EraseRootFromParent_Done,
     /* 2011331 */   // Label 26687: @2011331
     /* 2011331 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(2011422), // Rule ID 16870 //
     /* 2011336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2011339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2011353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2011356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011382 */     // MIs[0] round
     /* 2011382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011385 */     // MIs[0] policy
     /* 2011385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2011398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011421 */     // GIR_Coverage, 16870,
     /* 2011421 */     GIR_EraseRootFromParent_Done,
     /* 2011422 */   // Label 26688: @2011422
     /* 2011422 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(2011513), // Rule ID 16871 //
     /* 2011427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2011430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2011444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2011447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011473 */     // MIs[0] round
     /* 2011473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011476 */     // MIs[0] policy
     /* 2011476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011486 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2011489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011512 */     // GIR_Coverage, 16871,
     /* 2011512 */     GIR_EraseRootFromParent_Done,
     /* 2011513 */   // Label 26689: @2011513
     /* 2011513 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(2011604), // Rule ID 16874 //
     /* 2011518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2011521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2011529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2011532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2011535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011564 */     // MIs[0] round
     /* 2011564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011567 */     // MIs[0] policy
     /* 2011567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2011580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011603 */     // GIR_Coverage, 16874,
     /* 2011603 */     GIR_EraseRootFromParent_Done,
     /* 2011604 */   // Label 26690: @2011604
     /* 2011604 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(2011695), // Rule ID 16875 //
     /* 2011609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2011612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2011620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2011623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2011626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011655 */     // MIs[0] round
     /* 2011655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011658 */     // MIs[0] policy
     /* 2011658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011668 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2011671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011694 */     // GIR_Coverage, 16875,
     /* 2011694 */     GIR_EraseRootFromParent_Done,
     /* 2011695 */   // Label 26691: @2011695
     /* 2011695 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(2011786), // Rule ID 16878 //
     /* 2011700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2011703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2011711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2011714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2011720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011746 */     // MIs[0] round
     /* 2011746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011749 */     // MIs[0] policy
     /* 2011749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011759 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2011762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011785 */     // GIR_Coverage, 16878,
     /* 2011785 */     GIR_EraseRootFromParent_Done,
     /* 2011786 */   // Label 26692: @2011786
     /* 2011786 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(2011877), // Rule ID 16879 //
     /* 2011791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2011794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2011802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2011805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2011811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011837 */     // MIs[0] round
     /* 2011837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011840 */     // MIs[0] policy
     /* 2011840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011850 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2011853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011876 */     // GIR_Coverage, 16879,
     /* 2011876 */     GIR_EraseRootFromParent_Done,
     /* 2011877 */   // Label 26693: @2011877
     /* 2011877 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(2011968), // Rule ID 16882 //
     /* 2011882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2011885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2011893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2011896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2011902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011928 */     // MIs[0] round
     /* 2011928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011931 */     // MIs[0] policy
     /* 2011931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011941 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2011944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011967 */     // GIR_Coverage, 16882,
     /* 2011967 */     GIR_EraseRootFromParent_Done,
     /* 2011968 */   // Label 26694: @2011968
     /* 2011968 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(2012059), // Rule ID 16883 //
     /* 2011973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2011976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2011981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2011984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2011987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2011993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012019 */     // MIs[0] round
     /* 2012019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012022 */     // MIs[0] policy
     /* 2012022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012032 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2012035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012058 */     // GIR_Coverage, 16883,
     /* 2012058 */     GIR_EraseRootFromParent_Done,
     /* 2012059 */   // Label 26695: @2012059
     /* 2012059 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(2012150), // Rule ID 16886 //
     /* 2012064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2012067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2012075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2012078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012110 */     // MIs[0] round
     /* 2012110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012113 */     // MIs[0] policy
     /* 2012113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012123 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2012126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012149 */     // GIR_Coverage, 16886,
     /* 2012149 */     GIR_EraseRootFromParent_Done,
     /* 2012150 */   // Label 26696: @2012150
     /* 2012150 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(2012241), // Rule ID 16887 //
     /* 2012155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2012158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2012166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2012169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012201 */     // MIs[0] round
     /* 2012201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012204 */     // MIs[0] policy
     /* 2012204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2012217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012240 */     // GIR_Coverage, 16887,
     /* 2012240 */     GIR_EraseRootFromParent_Done,
     /* 2012241 */   // Label 26697: @2012241
     /* 2012241 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(2012332), // Rule ID 16890 //
     /* 2012246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2012249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012292 */     // MIs[0] round
     /* 2012292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012295 */     // MIs[0] policy
     /* 2012295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012305 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2012308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012331 */     // GIR_Coverage, 16890,
     /* 2012331 */     GIR_EraseRootFromParent_Done,
     /* 2012332 */   // Label 26698: @2012332
     /* 2012332 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(2012423), // Rule ID 16891 //
     /* 2012337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2012340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012383 */     // MIs[0] round
     /* 2012383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012386 */     // MIs[0] policy
     /* 2012386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10971:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2012399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012422 */     // GIR_Coverage, 16891,
     /* 2012422 */     GIR_EraseRootFromParent_Done,
     /* 2012423 */   // Label 26699: @2012423
     /* 2012423 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(2012514), // Rule ID 16894 //
     /* 2012428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2012431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2012439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2012442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012474 */     // MIs[0] round
     /* 2012474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012477 */     // MIs[0] policy
     /* 2012477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012487 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2012490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012513 */     // GIR_Coverage, 16894,
     /* 2012513 */     GIR_EraseRootFromParent_Done,
     /* 2012514 */   // Label 26700: @2012514
     /* 2012514 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(2012605), // Rule ID 16895 //
     /* 2012519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2012522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2012530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2012533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012565 */     // MIs[0] round
     /* 2012565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012568 */     // MIs[0] policy
     /* 2012568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012578 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2012581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012604 */     // GIR_Coverage, 16895,
     /* 2012604 */     GIR_EraseRootFromParent_Done,
     /* 2012605 */   // Label 26701: @2012605
     /* 2012605 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(2012696), // Rule ID 16898 //
     /* 2012610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2012613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012656 */     // MIs[0] round
     /* 2012656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012659 */     // MIs[0] policy
     /* 2012659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012669 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2012672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012695 */     // GIR_Coverage, 16898,
     /* 2012695 */     GIR_EraseRootFromParent_Done,
     /* 2012696 */   // Label 26702: @2012696
     /* 2012696 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(2012787), // Rule ID 16899 //
     /* 2012701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2012704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012747 */     // MIs[0] round
     /* 2012747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012750 */     // MIs[0] policy
     /* 2012750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012760 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2012763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012786 */     // GIR_Coverage, 16899,
     /* 2012786 */     GIR_EraseRootFromParent_Done,
     /* 2012787 */   // Label 26703: @2012787
     /* 2012787 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(2012878), // Rule ID 16902 //
     /* 2012792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2012795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012838 */     // MIs[0] round
     /* 2012838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012841 */     // MIs[0] policy
     /* 2012841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012851 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2012854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012877 */     // GIR_Coverage, 16902,
     /* 2012877 */     GIR_EraseRootFromParent_Done,
     /* 2012878 */   // Label 26704: @2012878
     /* 2012878 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(2012969), // Rule ID 16903 //
     /* 2012883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2012886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2012903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2012925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012929 */     // MIs[0] round
     /* 2012929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012932 */     // MIs[0] policy
     /* 2012932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2012945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012968 */     // GIR_Coverage, 16903,
     /* 2012968 */     GIR_EraseRootFromParent_Done,
     /* 2012969 */   // Label 26705: @2012969
     /* 2012969 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(2013060), // Rule ID 16906 //
     /* 2012974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2012977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2012982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013020 */     // MIs[0] round
     /* 2013020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013023 */     // MIs[0] policy
     /* 2013023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013033 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2013036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013059 */     // GIR_Coverage, 16906,
     /* 2013059 */     GIR_EraseRootFromParent_Done,
     /* 2013060 */   // Label 26706: @2013060
     /* 2013060 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(2013151), // Rule ID 16907 //
     /* 2013065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2013068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2013082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013111 */     // MIs[0] round
     /* 2013111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013114 */     // MIs[0] policy
     /* 2013114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10971:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2013127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013150 */     // GIR_Coverage, 16907,
     /* 2013150 */     GIR_EraseRootFromParent_Done,
     /* 2013151 */   // Label 26707: @2013151
     /* 2013151 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(2013242), // Rule ID 16910 //
     /* 2013156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2013159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2013167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2013170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2013173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2013186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013202 */     // MIs[0] round
     /* 2013202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013205 */     // MIs[0] policy
     /* 2013205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2013218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013241 */     // GIR_Coverage, 16910,
     /* 2013241 */     GIR_EraseRootFromParent_Done,
     /* 2013242 */   // Label 26708: @2013242
     /* 2013242 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(2013333), // Rule ID 16911 //
     /* 2013247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2013250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2013258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2013261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2013264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2013277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013293 */     // MIs[0] round
     /* 2013293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013296 */     // MIs[0] policy
     /* 2013296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013306 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10971:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2013309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013332 */     // GIR_Coverage, 16911,
     /* 2013332 */     GIR_EraseRootFromParent_Done,
     /* 2013333 */   // Label 26709: @2013333
     /* 2013333 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(2013424), // Rule ID 16914 //
     /* 2013338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2013341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2013349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2013352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2013368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013384 */     // MIs[0] round
     /* 2013384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013387 */     // MIs[0] policy
     /* 2013387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013397 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2013400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013423 */     // GIR_Coverage, 16914,
     /* 2013423 */     GIR_EraseRootFromParent_Done,
     /* 2013424 */   // Label 26710: @2013424
     /* 2013424 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(2013515), // Rule ID 16915 //
     /* 2013429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2013432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2013440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2013443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2013459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013475 */     // MIs[0] round
     /* 2013475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013478 */     // MIs[0] policy
     /* 2013478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013488 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10971:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2013491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013514 */     // GIR_Coverage, 16915,
     /* 2013514 */     GIR_EraseRootFromParent_Done,
     /* 2013515 */   // Label 26711: @2013515
     /* 2013515 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(2013606), // Rule ID 16918 //
     /* 2013520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2013523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2013531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2013534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2013550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013566 */     // MIs[0] round
     /* 2013566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013569 */     // MIs[0] policy
     /* 2013569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013579 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2013582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013605 */     // GIR_Coverage, 16918,
     /* 2013605 */     GIR_EraseRootFromParent_Done,
     /* 2013606 */   // Label 26712: @2013606
     /* 2013606 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(2013697), // Rule ID 16919 //
     /* 2013611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2013614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2013619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2013622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2013625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2013641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2013653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013657 */     // MIs[0] round
     /* 2013657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013660 */     // MIs[0] policy
     /* 2013660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10971:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2013673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013696 */     // GIR_Coverage, 16919,
     /* 2013696 */     GIR_EraseRootFromParent_Done,
     /* 2013697 */   // Label 26713: @2013697
     /* 2013697 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(2013788), // Rule ID 16922 //
     /* 2013702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2013705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2013710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2013713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2013716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2013722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013748 */     // MIs[0] round
     /* 2013748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013751 */     // MIs[0] policy
     /* 2013751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013761 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2013764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013787 */     // GIR_Coverage, 16922,
     /* 2013787 */     GIR_EraseRootFromParent_Done,
     /* 2013788 */   // Label 26714: @2013788
     /* 2013788 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(2013879), // Rule ID 16923 //
     /* 2013793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2013796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2013801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2013804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2013807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2013813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013839 */     // MIs[0] round
     /* 2013839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013842 */     // MIs[0] policy
     /* 2013842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013852 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2013855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013878 */     // GIR_Coverage, 16923,
     /* 2013878 */     GIR_EraseRootFromParent_Done,
     /* 2013879 */   // Label 26715: @2013879
     /* 2013879 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(2013970), // Rule ID 16926 //
     /* 2013884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2013887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2013892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2013904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013930 */     // MIs[0] round
     /* 2013930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013933 */     // MIs[0] policy
     /* 2013933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013943 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2013946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013969 */     // GIR_Coverage, 16926,
     /* 2013969 */     GIR_EraseRootFromParent_Done,
     /* 2013970 */   // Label 26716: @2013970
     /* 2013970 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(2014061), // Rule ID 16927 //
     /* 2013975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2013978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2013983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2013995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014021 */     // MIs[0] round
     /* 2014021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014024 */     // MIs[0] policy
     /* 2014024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2014037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014060 */     // GIR_Coverage, 16927,
     /* 2014060 */     GIR_EraseRootFromParent_Done,
     /* 2014061 */   // Label 26717: @2014061
     /* 2014061 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(2014152), // Rule ID 16930 //
     /* 2014066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2014069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2014077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2014080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014112 */     // MIs[0] round
     /* 2014112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014115 */     // MIs[0] policy
     /* 2014115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014125 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2014128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014151 */     // GIR_Coverage, 16930,
     /* 2014151 */     GIR_EraseRootFromParent_Done,
     /* 2014152 */   // Label 26718: @2014152
     /* 2014152 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(2014243), // Rule ID 16931 //
     /* 2014157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2014160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2014168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2014171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014203 */     // MIs[0] round
     /* 2014203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014206 */     // MIs[0] policy
     /* 2014206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2014219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014242 */     // GIR_Coverage, 16931,
     /* 2014242 */     GIR_EraseRootFromParent_Done,
     /* 2014243 */   // Label 26719: @2014243
     /* 2014243 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(2014334), // Rule ID 16934 //
     /* 2014248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2014251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2014259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2014262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2014268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2014278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014294 */     // MIs[0] round
     /* 2014294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014297 */     // MIs[0] policy
     /* 2014297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014307 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2014310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014333 */     // GIR_Coverage, 16934,
     /* 2014333 */     GIR_EraseRootFromParent_Done,
     /* 2014334 */   // Label 26720: @2014334
     /* 2014334 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(2014425), // Rule ID 16935 //
     /* 2014339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2014342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2014350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2014353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2014359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2014369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014385 */     // MIs[0] round
     /* 2014385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014388 */     // MIs[0] policy
     /* 2014388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014398 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2014401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014424 */     // GIR_Coverage, 16935,
     /* 2014424 */     GIR_EraseRootFromParent_Done,
     /* 2014425 */   // Label 26721: @2014425
     /* 2014425 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(2014516), // Rule ID 16938 //
     /* 2014430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2014433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2014441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2014444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2014450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2014460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014476 */     // MIs[0] round
     /* 2014476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014479 */     // MIs[0] policy
     /* 2014479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014489 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2014492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014515 */     // GIR_Coverage, 16938,
     /* 2014515 */     GIR_EraseRootFromParent_Done,
     /* 2014516 */   // Label 26722: @2014516
     /* 2014516 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(2014607), // Rule ID 16939 //
     /* 2014521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2014524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2014532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2014535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2014541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2014551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014567 */     // MIs[0] round
     /* 2014567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014570 */     // MIs[0] policy
     /* 2014570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014580 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2014583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014606 */     // GIR_Coverage, 16939,
     /* 2014606 */     GIR_EraseRootFromParent_Done,
     /* 2014607 */   // Label 26723: @2014607
     /* 2014607 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(2014698), // Rule ID 16942 //
     /* 2014612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2014615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2014632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014658 */     // MIs[0] round
     /* 2014658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014661 */     // MIs[0] policy
     /* 2014661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014671 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2014674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014697 */     // GIR_Coverage, 16942,
     /* 2014697 */     GIR_EraseRootFromParent_Done,
     /* 2014698 */   // Label 26724: @2014698
     /* 2014698 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(2014789), // Rule ID 16943 //
     /* 2014703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2014706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2014723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014749 */     // MIs[0] round
     /* 2014749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014752 */     // MIs[0] policy
     /* 2014752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014762 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2014765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014788 */     // GIR_Coverage, 16943,
     /* 2014788 */     GIR_EraseRootFromParent_Done,
     /* 2014789 */   // Label 26725: @2014789
     /* 2014789 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(2014880), // Rule ID 16946 //
     /* 2014794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2014797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2014805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2014808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014840 */     // MIs[0] round
     /* 2014840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014843 */     // MIs[0] policy
     /* 2014843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2014856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014879 */     // GIR_Coverage, 16946,
     /* 2014879 */     GIR_EraseRootFromParent_Done,
     /* 2014880 */   // Label 26726: @2014880
     /* 2014880 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(2014971), // Rule ID 16947 //
     /* 2014885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2014888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2014896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2014899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014931 */     // MIs[0] round
     /* 2014931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014934 */     // MIs[0] policy
     /* 2014934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2014947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014970 */     // GIR_Coverage, 16947,
     /* 2014970 */     GIR_EraseRootFromParent_Done,
     /* 2014971 */   // Label 26727: @2014971
     /* 2014971 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(2015062), // Rule ID 16950 //
     /* 2014976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2014979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2014984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2014987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2014990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2014993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2014996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015022 */     // MIs[0] round
     /* 2015022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015025 */     // MIs[0] policy
     /* 2015025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015035 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2015038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015061 */     // GIR_Coverage, 16950,
     /* 2015061 */     GIR_EraseRootFromParent_Done,
     /* 2015062 */   // Label 26728: @2015062
     /* 2015062 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(2015153), // Rule ID 16951 //
     /* 2015067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2015070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2015078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2015081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2015087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015113 */     // MIs[0] round
     /* 2015113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015116 */     // MIs[0] policy
     /* 2015116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015126 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2015129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015152 */     // GIR_Coverage, 16951,
     /* 2015152 */     GIR_EraseRootFromParent_Done,
     /* 2015153 */   // Label 26729: @2015153
     /* 2015153 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(2015244), // Rule ID 16954 //
     /* 2015158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2015161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2015169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2015172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2015178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2015188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015204 */     // MIs[0] round
     /* 2015204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015207 */     // MIs[0] policy
     /* 2015207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015217 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2015220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015243 */     // GIR_Coverage, 16954,
     /* 2015243 */     GIR_EraseRootFromParent_Done,
     /* 2015244 */   // Label 26730: @2015244
     /* 2015244 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(2015335), // Rule ID 16955 //
     /* 2015249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2015252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2015260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2015263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2015269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2015279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015295 */     // MIs[0] round
     /* 2015295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015298 */     // MIs[0] policy
     /* 2015298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015308 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2015311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015334 */     // GIR_Coverage, 16955,
     /* 2015334 */     GIR_EraseRootFromParent_Done,
     /* 2015335 */   // Label 26731: @2015335
     /* 2015335 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(2015426), // Rule ID 16958 //
     /* 2015340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2015343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2015351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2015354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2015357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015386 */     // MIs[0] round
     /* 2015386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015389 */     // MIs[0] policy
     /* 2015389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015399 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2015402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015425 */     // GIR_Coverage, 16958,
     /* 2015425 */     GIR_EraseRootFromParent_Done,
     /* 2015426 */   // Label 26732: @2015426
     /* 2015426 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(2015517), // Rule ID 16959 //
     /* 2015431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2015434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2015442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2015445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2015448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015477 */     // MIs[0] round
     /* 2015477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015480 */     // MIs[0] policy
     /* 2015480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2015493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015516 */     // GIR_Coverage, 16959,
     /* 2015516 */     GIR_EraseRootFromParent_Done,
     /* 2015517 */   // Label 26733: @2015517
     /* 2015517 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(2015608), // Rule ID 16962 //
     /* 2015522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2015525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2015539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015568 */     // MIs[0] round
     /* 2015568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015571 */     // MIs[0] policy
     /* 2015571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015581 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2015584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015607 */     // GIR_Coverage, 16962,
     /* 2015607 */     GIR_EraseRootFromParent_Done,
     /* 2015608 */   // Label 26734: @2015608
     /* 2015608 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(2015699), // Rule ID 16963 //
     /* 2015613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2015616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2015630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015659 */     // MIs[0] round
     /* 2015659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015662 */     // MIs[0] policy
     /* 2015662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015672 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2015675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015698 */     // GIR_Coverage, 16963,
     /* 2015698 */     GIR_EraseRootFromParent_Done,
     /* 2015699 */   // Label 26735: @2015699
     /* 2015699 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(2015790), // Rule ID 16966 //
     /* 2015704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2015707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2015715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2015718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2015721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015750 */     // MIs[0] round
     /* 2015750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015753 */     // MIs[0] policy
     /* 2015753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015763 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2015766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015789 */     // GIR_Coverage, 16966,
     /* 2015789 */     GIR_EraseRootFromParent_Done,
     /* 2015790 */   // Label 26736: @2015790
     /* 2015790 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(2015881), // Rule ID 16967 //
     /* 2015795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2015798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2015806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2015809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2015812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015841 */     // MIs[0] round
     /* 2015841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015844 */     // MIs[0] policy
     /* 2015844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2015857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015880 */     // GIR_Coverage, 16967,
     /* 2015880 */     GIR_EraseRootFromParent_Done,
     /* 2015881 */   // Label 26737: @2015881
     /* 2015881 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(2015972), // Rule ID 16970 //
     /* 2015886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2015889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2015897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2015900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2015928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015932 */     // MIs[0] round
     /* 2015932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015935 */     // MIs[0] policy
     /* 2015935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015945 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2015948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015971 */     // GIR_Coverage, 16970,
     /* 2015971 */     GIR_EraseRootFromParent_Done,
     /* 2015972 */   // Label 26738: @2015972
     /* 2015972 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(2016063), // Rule ID 16971 //
     /* 2015977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2015980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2015985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2015988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2015991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2015997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2016019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016023 */     // MIs[0] round
     /* 2016023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016026 */     // MIs[0] policy
     /* 2016026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2016039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016062 */     // GIR_Coverage, 16971,
     /* 2016062 */     GIR_EraseRootFromParent_Done,
     /* 2016063 */   // Label 26739: @2016063
     /* 2016063 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(2016154), // Rule ID 16974 //
     /* 2016068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2016071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2016079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2016082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2016088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2016110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016114 */     // MIs[0] round
     /* 2016114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016117 */     // MIs[0] policy
     /* 2016117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016127 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2016130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016153 */     // GIR_Coverage, 16974,
     /* 2016153 */     GIR_EraseRootFromParent_Done,
     /* 2016154 */   // Label 26740: @2016154
     /* 2016154 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(2016245), // Rule ID 16975 //
     /* 2016159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2016162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2016170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2016173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2016179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2016201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016205 */     // MIs[0] round
     /* 2016205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016208 */     // MIs[0] policy
     /* 2016208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016218 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2016221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016244 */     // GIR_Coverage, 16975,
     /* 2016244 */     GIR_EraseRootFromParent_Done,
     /* 2016245 */   // Label 26741: @2016245
     /* 2016245 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(2016336), // Rule ID 16978 //
     /* 2016250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2016253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016296 */     // MIs[0] round
     /* 2016296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016299 */     // MIs[0] policy
     /* 2016299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016309 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2016312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016335 */     // GIR_Coverage, 16978,
     /* 2016335 */     GIR_EraseRootFromParent_Done,
     /* 2016336 */   // Label 26742: @2016336
     /* 2016336 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(2016427), // Rule ID 16979 //
     /* 2016341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2016344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016387 */     // MIs[0] round
     /* 2016387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016390 */     // MIs[0] policy
     /* 2016390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2016403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016426 */     // GIR_Coverage, 16979,
     /* 2016426 */     GIR_EraseRootFromParent_Done,
     /* 2016427 */   // Label 26743: @2016427
     /* 2016427 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(2016518), // Rule ID 16982 //
     /* 2016432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2016435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2016443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2016446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2016449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016478 */     // MIs[0] round
     /* 2016478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016481 */     // MIs[0] policy
     /* 2016481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016491 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2016494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016517 */     // GIR_Coverage, 16982,
     /* 2016517 */     GIR_EraseRootFromParent_Done,
     /* 2016518 */   // Label 26744: @2016518
     /* 2016518 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(2016609), // Rule ID 16983 //
     /* 2016523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2016526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2016534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2016537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2016540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016569 */     // MIs[0] round
     /* 2016569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016572 */     // MIs[0] policy
     /* 2016572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2016585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016608 */     // GIR_Coverage, 16983,
     /* 2016608 */     GIR_EraseRootFromParent_Done,
     /* 2016609 */   // Label 26745: @2016609
     /* 2016609 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(2016700), // Rule ID 16986 //
     /* 2016614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2016617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2016625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2016628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016660 */     // MIs[0] round
     /* 2016660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016663 */     // MIs[0] policy
     /* 2016663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016673 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2016676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016699 */     // GIR_Coverage, 16986,
     /* 2016699 */     GIR_EraseRootFromParent_Done,
     /* 2016700 */   // Label 26746: @2016700
     /* 2016700 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(2016791), // Rule ID 16987 //
     /* 2016705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2016708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2016716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2016719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016751 */     // MIs[0] round
     /* 2016751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016754 */     // MIs[0] policy
     /* 2016754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016764 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2016767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016790 */     // GIR_Coverage, 16987,
     /* 2016790 */     GIR_EraseRootFromParent_Done,
     /* 2016791 */   // Label 26747: @2016791
     /* 2016791 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(2016882), // Rule ID 16990 //
     /* 2016796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2016799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2016807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2016810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2016813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016842 */     // MIs[0] round
     /* 2016842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016845 */     // MIs[0] policy
     /* 2016845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016855 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2016858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016881 */     // GIR_Coverage, 16990,
     /* 2016881 */     GIR_EraseRootFromParent_Done,
     /* 2016882 */   // Label 26748: @2016882
     /* 2016882 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(2016973), // Rule ID 16991 //
     /* 2016887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2016890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2016895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2016898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2016901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2016904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2016929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016933 */     // MIs[0] round
     /* 2016933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016936 */     // MIs[0] policy
     /* 2016936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016946 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2016949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016972 */     // GIR_Coverage, 16991,
     /* 2016972 */     GIR_EraseRootFromParent_Done,
     /* 2016973 */   // Label 26749: @2016973
     /* 2016973 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(2017064), // Rule ID 17000 //
     /* 2016978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2016981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2016986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2016995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2016998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017024 */     // MIs[0] round
     /* 2017024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017027 */     // MIs[0] policy
     /* 2017027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017037 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2017040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017063 */     // GIR_Coverage, 17000,
     /* 2017063 */     GIR_EraseRootFromParent_Done,
     /* 2017064 */   // Label 26750: @2017064
     /* 2017064 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(2017155), // Rule ID 17001 //
     /* 2017069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2017072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2017089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017115 */     // MIs[0] round
     /* 2017115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017118 */     // MIs[0] policy
     /* 2017118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017128 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2017131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017154 */     // GIR_Coverage, 17001,
     /* 2017154 */     GIR_EraseRootFromParent_Done,
     /* 2017155 */   // Label 26751: @2017155
     /* 2017155 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(2017246), // Rule ID 17010 //
     /* 2017160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2017163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2017171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2017174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2017177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2017180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017206 */     // MIs[0] round
     /* 2017206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017209 */     // MIs[0] policy
     /* 2017209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017219 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2017222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017245 */     // GIR_Coverage, 17010,
     /* 2017245 */     GIR_EraseRootFromParent_Done,
     /* 2017246 */   // Label 26752: @2017246
     /* 2017246 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(2017337), // Rule ID 17011 //
     /* 2017251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2017254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2017262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2017265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2017268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2017271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017297 */     // MIs[0] round
     /* 2017297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017300 */     // MIs[0] policy
     /* 2017300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2017313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017336 */     // GIR_Coverage, 17011,
     /* 2017336 */     GIR_EraseRootFromParent_Done,
     /* 2017337 */   // Label 26753: @2017337
     /* 2017337 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(2017428), // Rule ID 17020 //
     /* 2017342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2017345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2017353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2017356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2017359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2017362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017388 */     // MIs[0] round
     /* 2017388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017391 */     // MIs[0] policy
     /* 2017391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017401 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2017404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017427 */     // GIR_Coverage, 17020,
     /* 2017427 */     GIR_EraseRootFromParent_Done,
     /* 2017428 */   // Label 26754: @2017428
     /* 2017428 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(2017519), // Rule ID 17021 //
     /* 2017433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2017436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2017444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2017447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2017450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2017453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017479 */     // MIs[0] round
     /* 2017479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017482 */     // MIs[0] policy
     /* 2017482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017492 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2017495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017518 */     // GIR_Coverage, 17021,
     /* 2017518 */     GIR_EraseRootFromParent_Done,
     /* 2017519 */   // Label 26755: @2017519
     /* 2017519 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(2017610), // Rule ID 17030 //
     /* 2017524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2017527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2017535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2017538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2017541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2017544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2017554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017570 */     // MIs[0] round
     /* 2017570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017573 */     // MIs[0] policy
     /* 2017573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017583 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2017586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017609 */     // GIR_Coverage, 17030,
     /* 2017609 */     GIR_EraseRootFromParent_Done,
     /* 2017610 */   // Label 26756: @2017610
     /* 2017610 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(2017701), // Rule ID 17031 //
     /* 2017615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2017618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2017626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2017629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2017632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2017635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2017645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017661 */     // MIs[0] round
     /* 2017661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017664 */     // MIs[0] policy
     /* 2017664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017674 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2017677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017700 */     // GIR_Coverage, 17031,
     /* 2017700 */     GIR_EraseRootFromParent_Done,
     /* 2017701 */   // Label 26757: @2017701
     /* 2017701 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(2017792), // Rule ID 17040 //
     /* 2017706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2017709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2017726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017752 */     // MIs[0] round
     /* 2017752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017755 */     // MIs[0] policy
     /* 2017755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017765 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2017768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017791 */     // GIR_Coverage, 17040,
     /* 2017791 */     GIR_EraseRootFromParent_Done,
     /* 2017792 */   // Label 26758: @2017792
     /* 2017792 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(2017883), // Rule ID 17041 //
     /* 2017797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2017800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2017817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017843 */     // MIs[0] round
     /* 2017843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017846 */     // MIs[0] policy
     /* 2017846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2017859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017882 */     // GIR_Coverage, 17041,
     /* 2017882 */     GIR_EraseRootFromParent_Done,
     /* 2017883 */   // Label 26759: @2017883
     /* 2017883 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(2017974), // Rule ID 17050 //
     /* 2017888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2017891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2017899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2017902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2017905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017934 */     // MIs[0] round
     /* 2017934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017937 */     // MIs[0] policy
     /* 2017937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017947 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2017950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017973 */     // GIR_Coverage, 17050,
     /* 2017973 */     GIR_EraseRootFromParent_Done,
     /* 2017974 */   // Label 26760: @2017974
     /* 2017974 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(2018065), // Rule ID 17051 //
     /* 2017979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2017982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2017987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2017990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2017993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2017996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018025 */     // MIs[0] round
     /* 2018025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018028 */     // MIs[0] policy
     /* 2018028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018038 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2018041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018064 */     // GIR_Coverage, 17051,
     /* 2018064 */     GIR_EraseRootFromParent_Done,
     /* 2018065 */   // Label 26761: @2018065
     /* 2018065 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(2018156), // Rule ID 17060 //
     /* 2018070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2018073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2018081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2018084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2018087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2018090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018116 */     // MIs[0] round
     /* 2018116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018119 */     // MIs[0] policy
     /* 2018119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018129 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2018132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018155 */     // GIR_Coverage, 17060,
     /* 2018155 */     GIR_EraseRootFromParent_Done,
     /* 2018156 */   // Label 26762: @2018156
     /* 2018156 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(2018247), // Rule ID 17061 //
     /* 2018161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2018164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2018172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2018175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2018178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2018181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018207 */     // MIs[0] round
     /* 2018207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018210 */     // MIs[0] policy
     /* 2018210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018220 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2018223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018246 */     // GIR_Coverage, 17061,
     /* 2018246 */     GIR_EraseRootFromParent_Done,
     /* 2018247 */   // Label 26763: @2018247
     /* 2018247 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2018338), // Rule ID 17070 //
     /* 2018252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2018255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2018263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2018266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2018269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2018272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018298 */     // MIs[0] round
     /* 2018298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018301 */     // MIs[0] policy
     /* 2018301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018311 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2018314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018337 */     // GIR_Coverage, 17070,
     /* 2018337 */     GIR_EraseRootFromParent_Done,
     /* 2018338 */   // Label 26764: @2018338
     /* 2018338 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2018429), // Rule ID 17071 //
     /* 2018343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2018346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2018354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2018357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2018360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2018363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018389 */     // MIs[0] round
     /* 2018389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018392 */     // MIs[0] policy
     /* 2018392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018402 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2018405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018428 */     // GIR_Coverage, 17071,
     /* 2018428 */     GIR_EraseRootFromParent_Done,
     /* 2018429 */   // Label 26765: @2018429
     /* 2018429 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2018520), // Rule ID 17074 //
     /* 2018434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2018437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2018445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2018448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2018451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2018457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018480 */     // MIs[0] round
     /* 2018480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018483 */     // MIs[0] policy
     /* 2018483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018493 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2018496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018519 */     // GIR_Coverage, 17074,
     /* 2018519 */     GIR_EraseRootFromParent_Done,
     /* 2018520 */   // Label 26766: @2018520
     /* 2018520 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2018611), // Rule ID 17075 //
     /* 2018525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2018528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2018536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2018539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2018542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2018548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018571 */     // MIs[0] round
     /* 2018571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018574 */     // MIs[0] policy
     /* 2018574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2018587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018610 */     // GIR_Coverage, 17075,
     /* 2018610 */     GIR_EraseRootFromParent_Done,
     /* 2018611 */   // Label 26767: @2018611
     /* 2018611 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2018702), // Rule ID 17078 //
     /* 2018616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2018619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2018633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018662 */     // MIs[0] round
     /* 2018662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018665 */     // MIs[0] policy
     /* 2018665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018675 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2018678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018701 */     // GIR_Coverage, 17078,
     /* 2018701 */     GIR_EraseRootFromParent_Done,
     /* 2018702 */   // Label 26768: @2018702
     /* 2018702 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2018793), // Rule ID 17079 //
     /* 2018707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2018710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2018724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018753 */     // MIs[0] round
     /* 2018753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018756 */     // MIs[0] policy
     /* 2018756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10973:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2018769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018792 */     // GIR_Coverage, 17079,
     /* 2018792 */     GIR_EraseRootFromParent_Done,
     /* 2018793 */   // Label 26769: @2018793
     /* 2018793 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2018884), // Rule ID 17082 //
     /* 2018798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2018801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018844 */     // MIs[0] round
     /* 2018844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018847 */     // MIs[0] policy
     /* 2018847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018857 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2018860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018883 */     // GIR_Coverage, 17082,
     /* 2018883 */     GIR_EraseRootFromParent_Done,
     /* 2018884 */   // Label 26770: @2018884
     /* 2018884 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2018975), // Rule ID 17083 //
     /* 2018889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2018892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2018909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2018931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018935 */     // MIs[0] round
     /* 2018935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018938 */     // MIs[0] policy
     /* 2018938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2018951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018974 */     // GIR_Coverage, 17083,
     /* 2018974 */     GIR_EraseRootFromParent_Done,
     /* 2018975 */   // Label 26771: @2018975
     /* 2018975 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2019066), // Rule ID 17086 //
     /* 2018980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2018983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2018988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2018991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2018994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2018997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2019000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2019022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019026 */     // MIs[0] round
     /* 2019026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019029 */     // MIs[0] policy
     /* 2019029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019039 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2019042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019065 */     // GIR_Coverage, 17086,
     /* 2019065 */     GIR_EraseRootFromParent_Done,
     /* 2019066 */   // Label 26772: @2019066
     /* 2019066 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2019157), // Rule ID 17087 //
     /* 2019071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2019074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2019091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2019113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019117 */     // MIs[0] round
     /* 2019117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019120 */     // MIs[0] policy
     /* 2019120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019130 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2019133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019156 */     // GIR_Coverage, 17087,
     /* 2019156 */     GIR_EraseRootFromParent_Done,
     /* 2019157 */   // Label 26773: @2019157
     /* 2019157 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2019248), // Rule ID 17090 //
     /* 2019162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2019165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2019182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2019204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019208 */     // MIs[0] round
     /* 2019208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019211 */     // MIs[0] policy
     /* 2019211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019221 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2019224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019247 */     // GIR_Coverage, 17090,
     /* 2019247 */     GIR_EraseRootFromParent_Done,
     /* 2019248 */   // Label 26774: @2019248
     /* 2019248 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2019339), // Rule ID 17091 //
     /* 2019253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2019256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2019273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2019295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019299 */     // MIs[0] round
     /* 2019299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019302 */     // MIs[0] policy
     /* 2019302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2019315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019338 */     // GIR_Coverage, 17091,
     /* 2019338 */     GIR_EraseRootFromParent_Done,
     /* 2019339 */   // Label 26775: @2019339
     /* 2019339 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2019430), // Rule ID 17094 //
     /* 2019344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2019347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2019361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019390 */     // MIs[0] round
     /* 2019390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019393 */     // MIs[0] policy
     /* 2019393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019403 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2019406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019429 */     // GIR_Coverage, 17094,
     /* 2019429 */     GIR_EraseRootFromParent_Done,
     /* 2019430 */   // Label 26776: @2019430
     /* 2019430 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2019521), // Rule ID 17095 //
     /* 2019435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2019438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2019452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019481 */     // MIs[0] round
     /* 2019481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019484 */     // MIs[0] policy
     /* 2019484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10973:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2019497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019520 */     // GIR_Coverage, 17095,
     /* 2019520 */     GIR_EraseRootFromParent_Done,
     /* 2019521 */   // Label 26777: @2019521
     /* 2019521 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2019612), // Rule ID 17098 //
     /* 2019526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2019529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019572 */     // MIs[0] round
     /* 2019572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019575 */     // MIs[0] policy
     /* 2019575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019585 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2019588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019611 */     // GIR_Coverage, 17098,
     /* 2019611 */     GIR_EraseRootFromParent_Done,
     /* 2019612 */   // Label 26778: @2019612
     /* 2019612 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2019703), // Rule ID 17099 //
     /* 2019617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2019620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019663 */     // MIs[0] round
     /* 2019663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019666 */     // MIs[0] policy
     /* 2019666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019676 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10973:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2019679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019702 */     // GIR_Coverage, 17099,
     /* 2019702 */     GIR_EraseRootFromParent_Done,
     /* 2019703 */   // Label 26779: @2019703
     /* 2019703 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2019794), // Rule ID 17102 //
     /* 2019708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2019711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019754 */     // MIs[0] round
     /* 2019754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019757 */     // MIs[0] policy
     /* 2019757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019767 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2019770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019793 */     // GIR_Coverage, 17102,
     /* 2019793 */     GIR_EraseRootFromParent_Done,
     /* 2019794 */   // Label 26780: @2019794
     /* 2019794 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2019885), // Rule ID 17103 //
     /* 2019799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2019802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019845 */     // MIs[0] round
     /* 2019845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019848 */     // MIs[0] policy
     /* 2019848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019858 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10973:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2019861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019884 */     // GIR_Coverage, 17103,
     /* 2019884 */     GIR_EraseRootFromParent_Done,
     /* 2019885 */   // Label 26781: @2019885
     /* 2019885 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2019976), // Rule ID 17106 //
     /* 2019890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2019893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2019932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019936 */     // MIs[0] round
     /* 2019936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019939 */     // MIs[0] policy
     /* 2019939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2019952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019975 */     // GIR_Coverage, 17106,
     /* 2019975 */     GIR_EraseRootFromParent_Done,
     /* 2019976 */   // Label 26782: @2019976
     /* 2019976 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2020067), // Rule ID 17107 //
     /* 2019981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2019984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2020023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020027 */     // MIs[0] round
     /* 2020027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020030 */     // MIs[0] policy
     /* 2020030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020040 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10973:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2020043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020066 */     // GIR_Coverage, 17107,
     /* 2020066 */     GIR_EraseRootFromParent_Done,
     /* 2020067 */   // Label 26783: @2020067
     /* 2020067 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2020158), // Rule ID 17116 //
     /* 2020072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2020083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2020086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2020089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2020092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020118 */     // MIs[0] round
     /* 2020118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020121 */     // MIs[0] policy
     /* 2020121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020131 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2020134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020157 */     // GIR_Coverage, 17116,
     /* 2020157 */     GIR_EraseRootFromParent_Done,
     /* 2020158 */   // Label 26784: @2020158
     /* 2020158 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2020249), // Rule ID 17117 //
     /* 2020163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2020174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2020177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2020180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2020183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020209 */     // MIs[0] round
     /* 2020209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020212 */     // MIs[0] policy
     /* 2020212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020222 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2020225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020248 */     // GIR_Coverage, 17117,
     /* 2020248 */     GIR_EraseRootFromParent_Done,
     /* 2020249 */   // Label 26785: @2020249
     /* 2020249 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2020340), // Rule ID 17126 //
     /* 2020254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2020265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2020268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2020271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2020274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020300 */     // MIs[0] round
     /* 2020300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020303 */     // MIs[0] policy
     /* 2020303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020313 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2020316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020339 */     // GIR_Coverage, 17126,
     /* 2020339 */     GIR_EraseRootFromParent_Done,
     /* 2020340 */   // Label 26786: @2020340
     /* 2020340 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2020431), // Rule ID 17127 //
     /* 2020345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2020356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2020359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2020362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2020365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020391 */     // MIs[0] round
     /* 2020391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020394 */     // MIs[0] policy
     /* 2020394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2020407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020430 */     // GIR_Coverage, 17127,
     /* 2020430 */     GIR_EraseRootFromParent_Done,
     /* 2020431 */   // Label 26787: @2020431
     /* 2020431 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2020522), // Rule ID 17136 //
     /* 2020436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2020447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2020450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2020453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2020456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020482 */     // MIs[0] round
     /* 2020482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020485 */     // MIs[0] policy
     /* 2020485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2020498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020521 */     // GIR_Coverage, 17136,
     /* 2020521 */     GIR_EraseRootFromParent_Done,
     /* 2020522 */   // Label 26788: @2020522
     /* 2020522 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2020613), // Rule ID 17137 //
     /* 2020527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2020538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2020541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2020544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2020547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020573 */     // MIs[0] round
     /* 2020573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020576 */     // MIs[0] policy
     /* 2020576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020586 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2020589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020612 */     // GIR_Coverage, 17137,
     /* 2020612 */     GIR_EraseRootFromParent_Done,
     /* 2020613 */   // Label 26789: @2020613
     /* 2020613 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2020704), // Rule ID 17146 //
     /* 2020618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2020635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2020638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020664 */     // MIs[0] round
     /* 2020664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020667 */     // MIs[0] policy
     /* 2020667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020677 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2020680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020703 */     // GIR_Coverage, 17146,
     /* 2020703 */     GIR_EraseRootFromParent_Done,
     /* 2020704 */   // Label 26790: @2020704
     /* 2020704 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2020795), // Rule ID 17147 //
     /* 2020709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2020726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2020729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020755 */     // MIs[0] round
     /* 2020755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020758 */     // MIs[0] policy
     /* 2020758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2020771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020794 */     // GIR_Coverage, 17147,
     /* 2020794 */     GIR_EraseRootFromParent_Done,
     /* 2020795 */   // Label 26791: @2020795
     /* 2020795 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2020886), // Rule ID 17156 //
     /* 2020800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2020811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2020814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2020817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2020820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2020823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020846 */     // MIs[0] round
     /* 2020846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020849 */     // MIs[0] policy
     /* 2020849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020859 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2020862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020885 */     // GIR_Coverage, 17156,
     /* 2020885 */     GIR_EraseRootFromParent_Done,
     /* 2020886 */   // Label 26792: @2020886
     /* 2020886 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2020977), // Rule ID 17157 //
     /* 2020891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2020902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2020905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2020908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2020911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2020914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020937 */     // MIs[0] round
     /* 2020937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020940 */     // MIs[0] policy
     /* 2020940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2020953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020976 */     // GIR_Coverage, 17157,
     /* 2020976 */     GIR_EraseRootFromParent_Done,
     /* 2020977 */   // Label 26793: @2020977
     /* 2020977 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2021068), // Rule ID 17166 //
     /* 2020982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2020985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2020990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2020993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2020996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2020999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2021002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021028 */     // MIs[0] round
     /* 2021028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021031 */     // MIs[0] policy
     /* 2021031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021041 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2021044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021067 */     // GIR_Coverage, 17166,
     /* 2021067 */     GIR_EraseRootFromParent_Done,
     /* 2021068 */   // Label 26794: @2021068
     /* 2021068 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2021159), // Rule ID 17167 //
     /* 2021073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2021076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2021093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021119 */     // MIs[0] round
     /* 2021119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021122 */     // MIs[0] policy
     /* 2021122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2021135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021158 */     // GIR_Coverage, 17167,
     /* 2021158 */     GIR_EraseRootFromParent_Done,
     /* 2021159 */   // Label 26795: @2021159
     /* 2021159 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2021250), // Rule ID 17176 //
     /* 2021164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2021167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2021175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2021178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2021181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2021184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021210 */     // MIs[0] round
     /* 2021210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021213 */     // MIs[0] policy
     /* 2021213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021223 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2021226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021249 */     // GIR_Coverage, 17176,
     /* 2021249 */     GIR_EraseRootFromParent_Done,
     /* 2021250 */   // Label 26796: @2021250
     /* 2021250 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2021341), // Rule ID 17177 //
     /* 2021255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2021258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2021266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2021269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2021272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2021275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021301 */     // MIs[0] round
     /* 2021301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021304 */     // MIs[0] policy
     /* 2021304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2021317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021340 */     // GIR_Coverage, 17177,
     /* 2021340 */     GIR_EraseRootFromParent_Done,
     /* 2021341 */   // Label 26797: @2021341
     /* 2021341 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2021432), // Rule ID 17186 //
     /* 2021346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2021349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2021357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2021360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2021363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2021366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021392 */     // MIs[0] round
     /* 2021392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021395 */     // MIs[0] policy
     /* 2021395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021405 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2021408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021431 */     // GIR_Coverage, 17186,
     /* 2021431 */     GIR_EraseRootFromParent_Done,
     /* 2021432 */   // Label 26798: @2021432
     /* 2021432 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2021523), // Rule ID 17187 //
     /* 2021437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2021440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2021448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2021451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2021454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2021457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021483 */     // MIs[0] round
     /* 2021483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021486 */     // MIs[0] policy
     /* 2021486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2021499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021522 */     // GIR_Coverage, 17187,
     /* 2021522 */     GIR_EraseRootFromParent_Done,
     /* 2021523 */   // Label 26799: @2021523
     /* 2021523 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2021614), // Rule ID 17196 //
     /* 2021528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2021531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2021539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2021542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2021545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2021548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021574 */     // MIs[0] round
     /* 2021574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021577 */     // MIs[0] policy
     /* 2021577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021587 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2021590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021613 */     // GIR_Coverage, 17196,
     /* 2021613 */     GIR_EraseRootFromParent_Done,
     /* 2021614 */   // Label 26800: @2021614
     /* 2021614 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2021705), // Rule ID 17197 //
     /* 2021619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2021622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2021630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2021633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2021636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2021639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021665 */     // MIs[0] round
     /* 2021665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021668 */     // MIs[0] policy
     /* 2021668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021678 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2021681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021704 */     // GIR_Coverage, 17197,
     /* 2021704 */     GIR_EraseRootFromParent_Done,
     /* 2021705 */   // Label 26801: @2021705
     /* 2021705 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2021796), // Rule ID 17200 //
     /* 2021710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2021730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2021752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021756 */     // MIs[0] round
     /* 2021756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021759 */     // MIs[0] policy
     /* 2021759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021769 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2021772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021795 */     // GIR_Coverage, 17200,
     /* 2021795 */     GIR_EraseRootFromParent_Done,
     /* 2021796 */   // Label 26802: @2021796
     /* 2021796 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2021887), // Rule ID 17201 //
     /* 2021801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2021821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2021843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021847 */     // MIs[0] round
     /* 2021847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021850 */     // MIs[0] policy
     /* 2021850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021860 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2021863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021886 */     // GIR_Coverage, 17201,
     /* 2021886 */     GIR_EraseRootFromParent_Done,
     /* 2021887 */   // Label 26803: @2021887
     /* 2021887 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2021978), // Rule ID 17204 //
     /* 2021892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2021912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2021934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021938 */     // MIs[0] round
     /* 2021938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021941 */     // MIs[0] policy
     /* 2021941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021951 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2021954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021977 */     // GIR_Coverage, 17204,
     /* 2021977 */     GIR_EraseRootFromParent_Done,
     /* 2021978 */   // Label 26804: @2021978
     /* 2021978 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2022069), // Rule ID 17205 //
     /* 2021983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022029 */     // MIs[0] round
     /* 2022029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022032 */     // MIs[0] policy
     /* 2022032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022042 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2022045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022068 */     // GIR_Coverage, 17205,
     /* 2022068 */     GIR_EraseRootFromParent_Done,
     /* 2022069 */   // Label 26805: @2022069
     /* 2022069 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2022160), // Rule ID 17208 //
     /* 2022074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2022077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2022085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2022088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022120 */     // MIs[0] round
     /* 2022120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022123 */     // MIs[0] policy
     /* 2022123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2022136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022159 */     // GIR_Coverage, 17208,
     /* 2022159 */     GIR_EraseRootFromParent_Done,
     /* 2022160 */   // Label 26806: @2022160
     /* 2022160 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2022251), // Rule ID 17209 //
     /* 2022165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2022168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2022176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2022179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022211 */     // MIs[0] round
     /* 2022211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022214 */     // MIs[0] policy
     /* 2022214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2022227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022250 */     // GIR_Coverage, 17209,
     /* 2022250 */     GIR_EraseRootFromParent_Done,
     /* 2022251 */   // Label 26807: @2022251
     /* 2022251 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2022342), // Rule ID 17212 //
     /* 2022256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2022259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2022267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2022270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022302 */     // MIs[0] round
     /* 2022302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022305 */     // MIs[0] policy
     /* 2022305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022315 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2022318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022341 */     // GIR_Coverage, 17212,
     /* 2022341 */     GIR_EraseRootFromParent_Done,
     /* 2022342 */   // Label 26808: @2022342
     /* 2022342 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2022433), // Rule ID 17213 //
     /* 2022347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2022350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2022358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2022361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022393 */     // MIs[0] round
     /* 2022393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022396 */     // MIs[0] policy
     /* 2022396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022406 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2022409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022432 */     // GIR_Coverage, 17213,
     /* 2022432 */     GIR_EraseRootFromParent_Done,
     /* 2022433 */   // Label 26809: @2022433
     /* 2022433 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2022524), // Rule ID 17216 //
     /* 2022438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2022441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2022449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2022452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2022455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022484 */     // MIs[0] round
     /* 2022484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022487 */     // MIs[0] policy
     /* 2022487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022497 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2022500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022523 */     // GIR_Coverage, 17216,
     /* 2022523 */     GIR_EraseRootFromParent_Done,
     /* 2022524 */   // Label 26810: @2022524
     /* 2022524 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2022615), // Rule ID 17217 //
     /* 2022529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2022532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2022540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2022543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2022546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2022549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2022571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022575 */     // MIs[0] round
     /* 2022575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022578 */     // MIs[0] policy
     /* 2022578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022588 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2022591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022614 */     // GIR_Coverage, 17217,
     /* 2022614 */     GIR_EraseRootFromParent_Done,
     /* 2022615 */   // Label 26811: @2022615
     /* 2022615 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2022706), // Rule ID 17220 //
     /* 2022620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2022662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022666 */     // MIs[0] round
     /* 2022666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022669 */     // MIs[0] policy
     /* 2022669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022679 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2022682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022705 */     // GIR_Coverage, 17220,
     /* 2022705 */     GIR_EraseRootFromParent_Done,
     /* 2022706 */   // Label 26812: @2022706
     /* 2022706 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2022797), // Rule ID 17221 //
     /* 2022711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2022753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022757 */     // MIs[0] round
     /* 2022757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022760 */     // MIs[0] policy
     /* 2022760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2022773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022796 */     // GIR_Coverage, 17221,
     /* 2022796 */     GIR_EraseRootFromParent_Done,
     /* 2022797 */   // Label 26813: @2022797
     /* 2022797 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2022888), // Rule ID 17224 //
     /* 2022802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2022813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2022816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2022819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2022844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022848 */     // MIs[0] round
     /* 2022848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022851 */     // MIs[0] policy
     /* 2022851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2022864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022887 */     // GIR_Coverage, 17224,
     /* 2022887 */     GIR_EraseRootFromParent_Done,
     /* 2022888 */   // Label 26814: @2022888
     /* 2022888 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2022979), // Rule ID 17225 //
     /* 2022893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2022904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2022907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2022910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2022935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022939 */     // MIs[0] round
     /* 2022939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022942 */     // MIs[0] policy
     /* 2022942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2022955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022978 */     // GIR_Coverage, 17225,
     /* 2022978 */     GIR_EraseRootFromParent_Done,
     /* 2022979 */   // Label 26815: @2022979
     /* 2022979 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2023070), // Rule ID 17228 //
     /* 2022984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2022995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2022998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2023026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023030 */     // MIs[0] round
     /* 2023030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023033 */     // MIs[0] policy
     /* 2023033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023043 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2023046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023069 */     // GIR_Coverage, 17228,
     /* 2023069 */     GIR_EraseRootFromParent_Done,
     /* 2023070 */   // Label 26816: @2023070
     /* 2023070 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2023161), // Rule ID 17229 //
     /* 2023075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2023078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2023083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2023086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2023089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2023117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023121 */     // MIs[0] round
     /* 2023121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023124 */     // MIs[0] policy
     /* 2023124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2023137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023160 */     // GIR_Coverage, 17229,
     /* 2023160 */     GIR_EraseRootFromParent_Done,
     /* 2023161 */   // Label 26817: @2023161
     /* 2023161 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2023252), // Rule ID 17232 //
     /* 2023166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2023169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2023174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2023177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2023180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2023208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023212 */     // MIs[0] round
     /* 2023212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023215 */     // MIs[0] policy
     /* 2023215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023225 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2023228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023251 */     // GIR_Coverage, 17232,
     /* 2023251 */     GIR_EraseRootFromParent_Done,
     /* 2023252 */   // Label 26818: @2023252
     /* 2023252 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2023343), // Rule ID 17233 //
     /* 2023257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2023260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2023265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2023268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2023271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2023299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023303 */     // MIs[0] round
     /* 2023303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023306 */     // MIs[0] policy
     /* 2023306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2023319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023342 */     // GIR_Coverage, 17233,
     /* 2023342 */     GIR_EraseRootFromParent_Done,
     /* 2023343 */   // Label 26819: @2023343
     /* 2023343 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2023434), // Rule ID 17236 //
     /* 2023348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2023351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023394 */     // MIs[0] round
     /* 2023394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023397 */     // MIs[0] policy
     /* 2023397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023407 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2023410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023433 */     // GIR_Coverage, 17236,
     /* 2023433 */     GIR_EraseRootFromParent_Done,
     /* 2023434 */   // Label 26820: @2023434
     /* 2023434 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2023525), // Rule ID 17237 //
     /* 2023439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2023442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023485 */     // MIs[0] round
     /* 2023485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023488 */     // MIs[0] policy
     /* 2023488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023498 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2023501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023524 */     // GIR_Coverage, 17237,
     /* 2023524 */     GIR_EraseRootFromParent_Done,
     /* 2023525 */   // Label 26821: @2023525
     /* 2023525 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2023616), // Rule ID 17240 //
     /* 2023530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2023533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2023541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2023544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2023547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2023550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023576 */     // MIs[0] round
     /* 2023576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023579 */     // MIs[0] policy
     /* 2023579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023589 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2023592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023615 */     // GIR_Coverage, 17240,
     /* 2023615 */     GIR_EraseRootFromParent_Done,
     /* 2023616 */   // Label 26822: @2023616
     /* 2023616 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2023707), // Rule ID 17241 //
     /* 2023621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2023624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2023632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2023635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2023638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2023641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023667 */     // MIs[0] round
     /* 2023667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023670 */     // MIs[0] policy
     /* 2023670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023680 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2023683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023706 */     // GIR_Coverage, 17241,
     /* 2023706 */     GIR_EraseRootFromParent_Done,
     /* 2023707 */   // Label 26823: @2023707
     /* 2023707 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2023798), // Rule ID 17244 //
     /* 2023712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2023715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2023729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2023732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023758 */     // MIs[0] round
     /* 2023758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023761 */     // MIs[0] policy
     /* 2023761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023771 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2023774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023797 */     // GIR_Coverage, 17244,
     /* 2023797 */     GIR_EraseRootFromParent_Done,
     /* 2023798 */   // Label 26824: @2023798
     /* 2023798 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2023889), // Rule ID 17245 //
     /* 2023803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2023806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2023820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2023823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023849 */     // MIs[0] round
     /* 2023849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023852 */     // MIs[0] policy
     /* 2023852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2023865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023888 */     // GIR_Coverage, 17245,
     /* 2023888 */     GIR_EraseRootFromParent_Done,
     /* 2023889 */   // Label 26825: @2023889
     /* 2023889 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2023980), // Rule ID 17248 //
     /* 2023894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2023897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2023905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2023908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2023911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2023914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023940 */     // MIs[0] round
     /* 2023940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023943 */     // MIs[0] policy
     /* 2023943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023953 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2023956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023979 */     // GIR_Coverage, 17248,
     /* 2023979 */     GIR_EraseRootFromParent_Done,
     /* 2023980 */   // Label 26826: @2023980
     /* 2023980 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2024071), // Rule ID 17249 //
     /* 2023985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2023988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2023993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2023996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2023999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2024002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2024005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024031 */     // MIs[0] round
     /* 2024031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024034 */     // MIs[0] policy
     /* 2024034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2024047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024070 */     // GIR_Coverage, 17249,
     /* 2024070 */     GIR_EraseRootFromParent_Done,
     /* 2024071 */   // Label 26827: @2024071
     /* 2024071 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2024162), // Rule ID 17252 //
     /* 2024076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2024079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2024093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2024096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024122 */     // MIs[0] round
     /* 2024122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024125 */     // MIs[0] policy
     /* 2024125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024135 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2024138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024161 */     // GIR_Coverage, 17252,
     /* 2024161 */     GIR_EraseRootFromParent_Done,
     /* 2024162 */   // Label 26828: @2024162
     /* 2024162 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2024253), // Rule ID 17253 //
     /* 2024167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2024170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2024184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2024187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024213 */     // MIs[0] round
     /* 2024213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024216 */     // MIs[0] policy
     /* 2024216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024226 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2024229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024252 */     // GIR_Coverage, 17253,
     /* 2024252 */     GIR_EraseRootFromParent_Done,
     /* 2024253 */   // Label 26829: @2024253
     /* 2024253 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2024344), // Rule ID 17256 //
     /* 2024258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2024261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2024275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2024278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024304 */     // MIs[0] round
     /* 2024304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024307 */     // MIs[0] policy
     /* 2024307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024317 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2024320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024343 */     // GIR_Coverage, 17256,
     /* 2024343 */     GIR_EraseRootFromParent_Done,
     /* 2024344 */   // Label 26830: @2024344
     /* 2024344 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2024435), // Rule ID 17257 //
     /* 2024349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2024352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2024366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2024369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024395 */     // MIs[0] round
     /* 2024395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024398 */     // MIs[0] policy
     /* 2024398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2024411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024434 */     // GIR_Coverage, 17257,
     /* 2024434 */     GIR_EraseRootFromParent_Done,
     /* 2024435 */   // Label 26831: @2024435
     /* 2024435 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2024526), // Rule ID 17260 //
     /* 2024440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2024443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2024451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2024454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2024457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2024460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024486 */     // MIs[0] round
     /* 2024486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024489 */     // MIs[0] policy
     /* 2024489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2024502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024525 */     // GIR_Coverage, 17260,
     /* 2024525 */     GIR_EraseRootFromParent_Done,
     /* 2024526 */   // Label 26832: @2024526
     /* 2024526 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2024617), // Rule ID 17261 //
     /* 2024531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2024534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2024542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2024545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2024548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2024551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024577 */     // MIs[0] round
     /* 2024577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024580 */     // MIs[0] policy
     /* 2024580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2024593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024616 */     // GIR_Coverage, 17261,
     /* 2024616 */     GIR_EraseRootFromParent_Done,
     /* 2024617 */   // Label 26833: @2024617
     /* 2024617 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2024708), // Rule ID 17264 //
     /* 2024622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2024625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2024633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2024636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2024639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2024642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024668 */     // MIs[0] round
     /* 2024668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024671 */     // MIs[0] policy
     /* 2024671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024681 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2024684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024707 */     // GIR_Coverage, 17264,
     /* 2024707 */     GIR_EraseRootFromParent_Done,
     /* 2024708 */   // Label 26834: @2024708
     /* 2024708 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2024799), // Rule ID 17265 //
     /* 2024713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2024716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2024724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2024727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2024730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2024733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024759 */     // MIs[0] round
     /* 2024759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024762 */     // MIs[0] policy
     /* 2024762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024772 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2024775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024798 */     // GIR_Coverage, 17265,
     /* 2024798 */     GIR_EraseRootFromParent_Done,
     /* 2024799 */   // Label 26835: @2024799
     /* 2024799 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2024890), // Rule ID 17268 //
     /* 2024804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2024807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2024815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2024818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2024821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2024824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2024827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024850 */     // MIs[0] round
     /* 2024850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024853 */     // MIs[0] policy
     /* 2024853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024863 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2024866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024889 */     // GIR_Coverage, 17268,
     /* 2024889 */     GIR_EraseRootFromParent_Done,
     /* 2024890 */   // Label 26836: @2024890
     /* 2024890 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2024981), // Rule ID 17269 //
     /* 2024895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2024898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2024906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2024909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2024912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2024915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2024918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024941 */     // MIs[0] round
     /* 2024941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024944 */     // MIs[0] policy
     /* 2024944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024954 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2024957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024980 */     // GIR_Coverage, 17269,
     /* 2024980 */     GIR_EraseRootFromParent_Done,
     /* 2024981 */   // Label 26837: @2024981
     /* 2024981 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2025072), // Rule ID 17272 //
     /* 2024986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2024989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2024994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2024997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2025000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2025003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2025006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025032 */     // MIs[0] round
     /* 2025032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025035 */     // MIs[0] policy
     /* 2025035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025045 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2025048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025071 */     // GIR_Coverage, 17272,
     /* 2025071 */     GIR_EraseRootFromParent_Done,
     /* 2025072 */   // Label 26838: @2025072
     /* 2025072 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2025163), // Rule ID 17273 //
     /* 2025077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2025080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2025088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2025091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2025094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2025097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025123 */     // MIs[0] round
     /* 2025123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025126 */     // MIs[0] policy
     /* 2025126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2025139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025162 */     // GIR_Coverage, 17273,
     /* 2025162 */     GIR_EraseRootFromParent_Done,
     /* 2025163 */   // Label 26839: @2025163
     /* 2025163 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2025254), // Rule ID 17276 //
     /* 2025168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2025171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2025179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2025182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2025185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2025188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025214 */     // MIs[0] round
     /* 2025214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025217 */     // MIs[0] policy
     /* 2025217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2025230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025253 */     // GIR_Coverage, 17276,
     /* 2025253 */     GIR_EraseRootFromParent_Done,
     /* 2025254 */   // Label 26840: @2025254
     /* 2025254 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2025345), // Rule ID 17277 //
     /* 2025259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2025262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2025270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2025273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2025276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2025279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025305 */     // MIs[0] round
     /* 2025305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025308 */     // MIs[0] policy
     /* 2025308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2025321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025344 */     // GIR_Coverage, 17277,
     /* 2025344 */     GIR_EraseRootFromParent_Done,
     /* 2025345 */   // Label 26841: @2025345
     /* 2025345 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2025436), // Rule ID 17280 //
     /* 2025350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2025353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2025361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2025364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2025367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2025370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025396 */     // MIs[0] round
     /* 2025396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025399 */     // MIs[0] policy
     /* 2025399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025409 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2025412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025435 */     // GIR_Coverage, 17280,
     /* 2025435 */     GIR_EraseRootFromParent_Done,
     /* 2025436 */   // Label 26842: @2025436
     /* 2025436 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2025527), // Rule ID 17281 //
     /* 2025441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2025444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2025452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2025455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2025458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2025461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025487 */     // MIs[0] round
     /* 2025487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025490 */     // MIs[0] policy
     /* 2025490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025500 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2025503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025526 */     // GIR_Coverage, 17281,
     /* 2025526 */     GIR_EraseRootFromParent_Done,
     /* 2025527 */   // Label 26843: @2025527
     /* 2025527 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2025618), // Rule ID 17284 //
     /* 2025532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2025535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2025543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2025546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2025549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2025552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025578 */     // MIs[0] round
     /* 2025578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025581 */     // MIs[0] policy
     /* 2025581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025591 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2025594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025617 */     // GIR_Coverage, 17284,
     /* 2025617 */     GIR_EraseRootFromParent_Done,
     /* 2025618 */   // Label 26844: @2025618
     /* 2025618 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2025709), // Rule ID 17285 //
     /* 2025623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2025626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2025634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2025637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2025640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2025643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025669 */     // MIs[0] round
     /* 2025669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025672 */     // MIs[0] policy
     /* 2025672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025682 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2025685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025708 */     // GIR_Coverage, 17285,
     /* 2025708 */     GIR_EraseRootFromParent_Done,
     /* 2025709 */   // Label 26845: @2025709
     /* 2025709 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2025800), // Rule ID 17288 //
     /* 2025714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2025717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2025725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2025728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2025731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2025734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025760 */     // MIs[0] round
     /* 2025760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025763 */     // MIs[0] policy
     /* 2025763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025773 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2025776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025799 */     // GIR_Coverage, 17288,
     /* 2025799 */     GIR_EraseRootFromParent_Done,
     /* 2025800 */   // Label 26846: @2025800
     /* 2025800 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2025891), // Rule ID 17289 //
     /* 2025805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2025808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2025816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2025819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2025822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2025825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025851 */     // MIs[0] round
     /* 2025851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025854 */     // MIs[0] policy
     /* 2025854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2025867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025890 */     // GIR_Coverage, 17289,
     /* 2025890 */     GIR_EraseRootFromParent_Done,
     /* 2025891 */   // Label 26847: @2025891
     /* 2025891 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2025982), // Rule ID 17292 //
     /* 2025896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2025899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2025907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2025910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2025913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2025916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025942 */     // MIs[0] round
     /* 2025942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025945 */     // MIs[0] policy
     /* 2025945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025955 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2025958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025981 */     // GIR_Coverage, 17292,
     /* 2025981 */     GIR_EraseRootFromParent_Done,
     /* 2025982 */   // Label 26848: @2025982
     /* 2025982 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2026073), // Rule ID 17293 //
     /* 2025987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2025990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2025995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2025998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2026001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2026004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2026007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026033 */     // MIs[0] round
     /* 2026033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026036 */     // MIs[0] policy
     /* 2026036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2026049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026072 */     // GIR_Coverage, 17293,
     /* 2026072 */     GIR_EraseRootFromParent_Done,
     /* 2026073 */   // Label 26849: @2026073
     /* 2026073 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2026164), // Rule ID 17296 //
     /* 2026078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2026081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2026095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026124 */     // MIs[0] round
     /* 2026124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026127 */     // MIs[0] policy
     /* 2026127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026137 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2026140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026163 */     // GIR_Coverage, 17296,
     /* 2026163 */     GIR_EraseRootFromParent_Done,
     /* 2026164 */   // Label 26850: @2026164
     /* 2026164 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2026255), // Rule ID 17297 //
     /* 2026169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2026172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2026186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026215 */     // MIs[0] round
     /* 2026215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026218 */     // MIs[0] policy
     /* 2026218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026228 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2026231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026254 */     // GIR_Coverage, 17297,
     /* 2026254 */     GIR_EraseRootFromParent_Done,
     /* 2026255 */   // Label 26851: @2026255
     /* 2026255 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2026346), // Rule ID 17300 //
     /* 2026260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2026263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2026277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026306 */     // MIs[0] round
     /* 2026306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026309 */     // MIs[0] policy
     /* 2026309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026319 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2026322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026345 */     // GIR_Coverage, 17300,
     /* 2026345 */     GIR_EraseRootFromParent_Done,
     /* 2026346 */   // Label 26852: @2026346
     /* 2026346 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2026437), // Rule ID 17301 //
     /* 2026351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2026354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2026368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026397 */     // MIs[0] round
     /* 2026397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026400 */     // MIs[0] policy
     /* 2026400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2026413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026436 */     // GIR_Coverage, 17301,
     /* 2026436 */     GIR_EraseRootFromParent_Done,
     /* 2026437 */   // Label 26853: @2026437
     /* 2026437 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2026528), // Rule ID 17304 //
     /* 2026442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2026445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2026484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026488 */     // MIs[0] round
     /* 2026488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026491 */     // MIs[0] policy
     /* 2026491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026501 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2026504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026527 */     // GIR_Coverage, 17304,
     /* 2026527 */     GIR_EraseRootFromParent_Done,
     /* 2026528 */   // Label 26854: @2026528
     /* 2026528 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2026619), // Rule ID 17305 //
     /* 2026533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2026536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2026575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026579 */     // MIs[0] round
     /* 2026579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026582 */     // MIs[0] policy
     /* 2026582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026592 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2026595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026618 */     // GIR_Coverage, 17305,
     /* 2026618 */     GIR_EraseRootFromParent_Done,
     /* 2026619 */   // Label 26855: @2026619
     /* 2026619 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2026710), // Rule ID 17308 //
     /* 2026624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2026627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2026641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026670 */     // MIs[0] round
     /* 2026670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026673 */     // MIs[0] policy
     /* 2026673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026683 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2026686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026709 */     // GIR_Coverage, 17308,
     /* 2026709 */     GIR_EraseRootFromParent_Done,
     /* 2026710 */   // Label 26856: @2026710
     /* 2026710 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2026801), // Rule ID 17309 //
     /* 2026715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2026718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2026732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2026735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2026757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026761 */     // MIs[0] round
     /* 2026761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026764 */     // MIs[0] policy
     /* 2026764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10910:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2026777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026800 */     // GIR_Coverage, 17309,
     /* 2026800 */     GIR_EraseRootFromParent_Done,
     /* 2026801 */   // Label 26857: @2026801
     /* 2026801 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2026892), // Rule ID 17312 //
     /* 2026806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2026809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2026817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2026820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2026848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026852 */     // MIs[0] round
     /* 2026852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026855 */     // MIs[0] policy
     /* 2026855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026865 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2026868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026891 */     // GIR_Coverage, 17312,
     /* 2026891 */     GIR_EraseRootFromParent_Done,
     /* 2026892 */   // Label 26858: @2026892
     /* 2026892 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2026983), // Rule ID 17313 //
     /* 2026897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2026900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2026908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2026911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2026939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026943 */     // MIs[0] round
     /* 2026943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026946 */     // MIs[0] policy
     /* 2026946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2026959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026982 */     // GIR_Coverage, 17313,
     /* 2026982 */     GIR_EraseRootFromParent_Done,
     /* 2026983 */   // Label 26859: @2026983
     /* 2026983 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2027074), // Rule ID 17316 //
     /* 2026988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2026991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2026996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2026999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2027002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2027030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027034 */     // MIs[0] round
     /* 2027034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027037 */     // MIs[0] policy
     /* 2027037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027047 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2027050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2027070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027073 */     // GIR_Coverage, 17316,
     /* 2027073 */     GIR_EraseRootFromParent_Done,
     /* 2027074 */   // Label 26860: @2027074
     /* 2027074 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2027165), // Rule ID 17317 //
     /* 2027079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2027082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2027090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2027093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2027121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027125 */     // MIs[0] round
     /* 2027125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027128 */     // MIs[0] policy
     /* 2027128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2027141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2027161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027164 */     // GIR_Coverage, 17317,
     /* 2027164 */     GIR_EraseRootFromParent_Done,
     /* 2027165 */   // Label 26861: @2027165
     /* 2027165 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2027256), // Rule ID 17320 //
     /* 2027170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2027173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2027181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2027184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2027187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027216 */     // MIs[0] round
     /* 2027216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027219 */     // MIs[0] policy
     /* 2027219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027229 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2027232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027255 */     // GIR_Coverage, 17320,
     /* 2027255 */     GIR_EraseRootFromParent_Done,
     /* 2027256 */   // Label 26862: @2027256
     /* 2027256 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2027347), // Rule ID 17321 //
     /* 2027261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2027264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2027272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2027275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2027278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027307 */     // MIs[0] round
     /* 2027307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027310 */     // MIs[0] policy
     /* 2027310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2027323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027346 */     // GIR_Coverage, 17321,
     /* 2027346 */     GIR_EraseRootFromParent_Done,
     /* 2027347 */   // Label 26863: @2027347
     /* 2027347 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2027438), // Rule ID 17324 //
     /* 2027352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2027355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2027369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027398 */     // MIs[0] round
     /* 2027398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027401 */     // MIs[0] policy
     /* 2027401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027411 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2027414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027437 */     // GIR_Coverage, 17324,
     /* 2027437 */     GIR_EraseRootFromParent_Done,
     /* 2027438 */   // Label 26864: @2027438
     /* 2027438 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2027529), // Rule ID 17325 //
     /* 2027443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2027446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2027460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027489 */     // MIs[0] round
     /* 2027489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027492 */     // MIs[0] policy
     /* 2027492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027502 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2027505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027528 */     // GIR_Coverage, 17325,
     /* 2027528 */     GIR_EraseRootFromParent_Done,
     /* 2027529 */   // Label 26865: @2027529
     /* 2027529 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2027620), // Rule ID 17328 //
     /* 2027534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2027537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2027545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2027548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2027551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2027557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027580 */     // MIs[0] round
     /* 2027580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027583 */     // MIs[0] policy
     /* 2027583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027593 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2027596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027619 */     // GIR_Coverage, 17328,
     /* 2027619 */     GIR_EraseRootFromParent_Done,
     /* 2027620 */   // Label 26866: @2027620
     /* 2027620 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2027711), // Rule ID 17329 //
     /* 2027625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2027628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2027636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2027639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2027642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2027645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2027648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2027667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027671 */     // MIs[0] round
     /* 2027671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027674 */     // MIs[0] policy
     /* 2027674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2027687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027710 */     // GIR_Coverage, 17329,
     /* 2027710 */     GIR_EraseRootFromParent_Done,
     /* 2027711 */   // Label 26867: @2027711
     /* 2027711 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2027802), // Rule ID 17332 //
     /* 2027716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2027719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2027733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2027758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027762 */     // MIs[0] round
     /* 2027762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027765 */     // MIs[0] policy
     /* 2027765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027775 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2027778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027801 */     // GIR_Coverage, 17332,
     /* 2027801 */     GIR_EraseRootFromParent_Done,
     /* 2027802 */   // Label 26868: @2027802
     /* 2027802 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2027893), // Rule ID 17333 //
     /* 2027807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2027810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2027824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2027849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027853 */     // MIs[0] round
     /* 2027853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027856 */     // MIs[0] policy
     /* 2027856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027866 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2027869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027892 */     // GIR_Coverage, 17333,
     /* 2027892 */     GIR_EraseRootFromParent_Done,
     /* 2027893 */   // Label 26869: @2027893
     /* 2027893 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2027984), // Rule ID 17336 //
     /* 2027898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2027901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2027915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2027940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027944 */     // MIs[0] round
     /* 2027944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027947 */     // MIs[0] policy
     /* 2027947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027957 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2027960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027983 */     // GIR_Coverage, 17336,
     /* 2027983 */     GIR_EraseRootFromParent_Done,
     /* 2027984 */   // Label 26870: @2027984
     /* 2027984 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2028075), // Rule ID 17337 //
     /* 2027989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2027992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2027997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2028000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2028003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2028006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2028031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028035 */     // MIs[0] round
     /* 2028035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028038 */     // MIs[0] policy
     /* 2028038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2028051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028074 */     // GIR_Coverage, 17337,
     /* 2028074 */     GIR_EraseRootFromParent_Done,
     /* 2028075 */   // Label 26871: @2028075
     /* 2028075 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2028166), // Rule ID 17340 //
     /* 2028080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2028083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2028091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2028094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2028097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2028122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028126 */     // MIs[0] round
     /* 2028126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028129 */     // MIs[0] policy
     /* 2028129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028139 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2028142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028165 */     // GIR_Coverage, 17340,
     /* 2028165 */     GIR_EraseRootFromParent_Done,
     /* 2028166 */   // Label 26872: @2028166
     /* 2028166 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2028257), // Rule ID 17341 //
     /* 2028171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2028174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2028182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2028185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2028188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2028213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028217 */     // MIs[0] round
     /* 2028217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028220 */     // MIs[0] policy
     /* 2028220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2028233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028256 */     // GIR_Coverage, 17341,
     /* 2028256 */     GIR_EraseRootFromParent_Done,
     /* 2028257 */   // Label 26873: @2028257
     /* 2028257 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2028348), // Rule ID 17344 //
     /* 2028262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2028265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2028273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2028276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2028279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028308 */     // MIs[0] round
     /* 2028308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028311 */     // MIs[0] policy
     /* 2028311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2028324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028347 */     // GIR_Coverage, 17344,
     /* 2028347 */     GIR_EraseRootFromParent_Done,
     /* 2028348 */   // Label 26874: @2028348
     /* 2028348 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2028439), // Rule ID 17345 //
     /* 2028353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2028356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2028364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2028367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2028370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028399 */     // MIs[0] round
     /* 2028399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028402 */     // MIs[0] policy
     /* 2028402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028412 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2028415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028438 */     // GIR_Coverage, 17345,
     /* 2028438 */     GIR_EraseRootFromParent_Done,
     /* 2028439 */   // Label 26875: @2028439
     /* 2028439 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2028530), // Rule ID 17348 //
     /* 2028444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2028447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2028455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2028458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2028461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028490 */     // MIs[0] round
     /* 2028490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028493 */     // MIs[0] policy
     /* 2028493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028503 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2028506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028529 */     // GIR_Coverage, 17348,
     /* 2028529 */     GIR_EraseRootFromParent_Done,
     /* 2028530 */   // Label 26876: @2028530
     /* 2028530 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2028621), // Rule ID 17349 //
     /* 2028535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2028538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2028546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2028549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2028552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028581 */     // MIs[0] round
     /* 2028581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028584 */     // MIs[0] policy
     /* 2028584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028594 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2028597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028620 */     // GIR_Coverage, 17349,
     /* 2028620 */     GIR_EraseRootFromParent_Done,
     /* 2028621 */   // Label 26877: @2028621
     /* 2028621 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2028712), // Rule ID 17352 //
     /* 2028626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2028629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2028637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2028640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028672 */     // MIs[0] round
     /* 2028672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028675 */     // MIs[0] policy
     /* 2028675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028685 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2028688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028711 */     // GIR_Coverage, 17352,
     /* 2028711 */     GIR_EraseRootFromParent_Done,
     /* 2028712 */   // Label 26878: @2028712
     /* 2028712 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2028803), // Rule ID 17353 //
     /* 2028717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2028720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2028725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2028728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2028731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2028759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028763 */     // MIs[0] round
     /* 2028763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028766 */     // MIs[0] policy
     /* 2028766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028776 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2028779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028802 */     // GIR_Coverage, 17353,
     /* 2028802 */     GIR_EraseRootFromParent_Done,
     /* 2028803 */   // Label 26879: @2028803
     /* 2028803 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2028894), // Rule ID 17356 //
     /* 2028808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2028811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2028816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2028819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2028822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2028828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028854 */     // MIs[0] round
     /* 2028854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028857 */     // MIs[0] policy
     /* 2028857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028867 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2028870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028893 */     // GIR_Coverage, 17356,
     /* 2028893 */     GIR_EraseRootFromParent_Done,
     /* 2028894 */   // Label 26880: @2028894
     /* 2028894 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2028985), // Rule ID 17357 //
     /* 2028899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2028902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2028907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2028910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2028913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2028919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028945 */     // MIs[0] round
     /* 2028945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028948 */     // MIs[0] policy
     /* 2028948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028958 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2028961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028984 */     // GIR_Coverage, 17357,
     /* 2028984 */     GIR_EraseRootFromParent_Done,
     /* 2028985 */   // Label 26881: @2028985
     /* 2028985 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2029076), // Rule ID 17360 //
     /* 2028990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2028993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2028998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2029007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2029010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029036 */     // MIs[0] round
     /* 2029036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029039 */     // MIs[0] policy
     /* 2029039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029049 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2029052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029075 */     // GIR_Coverage, 17360,
     /* 2029075 */     GIR_EraseRootFromParent_Done,
     /* 2029076 */   // Label 26882: @2029076
     /* 2029076 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2029167), // Rule ID 17361 //
     /* 2029081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2029084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2029098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2029101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029127 */     // MIs[0] round
     /* 2029127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029130 */     // MIs[0] policy
     /* 2029130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2029143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029166 */     // GIR_Coverage, 17361,
     /* 2029166 */     GIR_EraseRootFromParent_Done,
     /* 2029167 */   // Label 26883: @2029167
     /* 2029167 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2029258), // Rule ID 17364 //
     /* 2029172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2029175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2029183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2029186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2029192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029218 */     // MIs[0] round
     /* 2029218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029221 */     // MIs[0] policy
     /* 2029221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029231 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2029234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2029254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029257 */     // GIR_Coverage, 17364,
     /* 2029257 */     GIR_EraseRootFromParent_Done,
     /* 2029258 */   // Label 26884: @2029258
     /* 2029258 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2029349), // Rule ID 17365 //
     /* 2029263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2029266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2029274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2029277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2029283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029309 */     // MIs[0] round
     /* 2029309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029312 */     // MIs[0] policy
     /* 2029312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2029325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2029345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029348 */     // GIR_Coverage, 17365,
     /* 2029348 */     GIR_EraseRootFromParent_Done,
     /* 2029349 */   // Label 26885: @2029349
     /* 2029349 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2029440), // Rule ID 17368 //
     /* 2029354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2029357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2029371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2029374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029400 */     // MIs[0] round
     /* 2029400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029403 */     // MIs[0] policy
     /* 2029403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029413 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2029416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029439 */     // GIR_Coverage, 17368,
     /* 2029439 */     GIR_EraseRootFromParent_Done,
     /* 2029440 */   // Label 26886: @2029440
     /* 2029440 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2029531), // Rule ID 17369 //
     /* 2029445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2029448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2029462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2029465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029491 */     // MIs[0] round
     /* 2029491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029494 */     // MIs[0] policy
     /* 2029494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029504 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2029507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029530 */     // GIR_Coverage, 17369,
     /* 2029530 */     GIR_EraseRootFromParent_Done,
     /* 2029531 */   // Label 26887: @2029531
     /* 2029531 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2029622), // Rule ID 17372 //
     /* 2029536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2029539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2029547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2029550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2029556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029582 */     // MIs[0] round
     /* 2029582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029585 */     // MIs[0] policy
     /* 2029585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029595 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2029598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2029618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029621 */     // GIR_Coverage, 17372,
     /* 2029621 */     GIR_EraseRootFromParent_Done,
     /* 2029622 */   // Label 26888: @2029622
     /* 2029622 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2029713), // Rule ID 17373 //
     /* 2029627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2029630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2029638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2029641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2029647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029673 */     // MIs[0] round
     /* 2029673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029676 */     // MIs[0] policy
     /* 2029676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029686 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2029689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2029709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029712 */     // GIR_Coverage, 17373,
     /* 2029712 */     GIR_EraseRootFromParent_Done,
     /* 2029713 */   // Label 26889: @2029713
     /* 2029713 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2029804), // Rule ID 17376 //
     /* 2029718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2029721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2029729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2029732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2029738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029764 */     // MIs[0] round
     /* 2029764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029767 */     // MIs[0] policy
     /* 2029767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029777 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2029780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2029800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029803 */     // GIR_Coverage, 17376,
     /* 2029803 */     GIR_EraseRootFromParent_Done,
     /* 2029804 */   // Label 26890: @2029804
     /* 2029804 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2029895), // Rule ID 17377 //
     /* 2029809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2029812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2029820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2029823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2029829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029855 */     // MIs[0] round
     /* 2029855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029858 */     // MIs[0] policy
     /* 2029858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2029871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2029891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029894 */     // GIR_Coverage, 17377,
     /* 2029894 */     GIR_EraseRootFromParent_Done,
     /* 2029895 */   // Label 26891: @2029895
     /* 2029895 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2029986), // Rule ID 17380 //
     /* 2029900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2029903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2029920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029946 */     // MIs[0] round
     /* 2029946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029949 */     // MIs[0] policy
     /* 2029949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2029962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029985 */     // GIR_Coverage, 17380,
     /* 2029985 */     GIR_EraseRootFromParent_Done,
     /* 2029986 */   // Label 26892: @2029986
     /* 2029986 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2030077), // Rule ID 17381 //
     /* 2029991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2029994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2029999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2030008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2030011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030037 */     // MIs[0] round
     /* 2030037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030040 */     // MIs[0] policy
     /* 2030040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030050 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2030053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030076 */     // GIR_Coverage, 17381,
     /* 2030076 */     GIR_EraseRootFromParent_Done,
     /* 2030077 */   // Label 26893: @2030077
     /* 2030077 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2030168), // Rule ID 17384 //
     /* 2030082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2030085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2030099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2030102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030128 */     // MIs[0] round
     /* 2030128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030131 */     // MIs[0] policy
     /* 2030131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030141 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2030144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030167 */     // GIR_Coverage, 17384,
     /* 2030167 */     GIR_EraseRootFromParent_Done,
     /* 2030168 */   // Label 26894: @2030168
     /* 2030168 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2030259), // Rule ID 17385 //
     /* 2030173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2030176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2030190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2030193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030219 */     // MIs[0] round
     /* 2030219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030222 */     // MIs[0] policy
     /* 2030222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030232 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2030235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030258 */     // GIR_Coverage, 17385,
     /* 2030258 */     GIR_EraseRootFromParent_Done,
     /* 2030259 */   // Label 26895: @2030259
     /* 2030259 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2030350), // Rule ID 17388 //
     /* 2030264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2030267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2030275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2030278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2030281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2030284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2030287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030310 */     // MIs[0] round
     /* 2030310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030313 */     // MIs[0] policy
     /* 2030313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030323 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2030326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030349 */     // GIR_Coverage, 17388,
     /* 2030349 */     GIR_EraseRootFromParent_Done,
     /* 2030350 */   // Label 26896: @2030350
     /* 2030350 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2030441), // Rule ID 17389 //
     /* 2030355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2030358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2030366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2030369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2030372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2030375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2030378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030401 */     // MIs[0] round
     /* 2030401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030404 */     // MIs[0] policy
     /* 2030404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030414 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2030417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030440 */     // GIR_Coverage, 17389,
     /* 2030440 */     GIR_EraseRootFromParent_Done,
     /* 2030441 */   // Label 26897: @2030441
     /* 2030441 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2030532), // Rule ID 17392 //
     /* 2030446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2030449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2030466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030492 */     // MIs[0] round
     /* 2030492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030495 */     // MIs[0] policy
     /* 2030495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030505 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2030508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030531 */     // GIR_Coverage, 17392,
     /* 2030531 */     GIR_EraseRootFromParent_Done,
     /* 2030532 */   // Label 26898: @2030532
     /* 2030532 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2030623), // Rule ID 17393 //
     /* 2030537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2030540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2030557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030583 */     // MIs[0] round
     /* 2030583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030586 */     // MIs[0] policy
     /* 2030586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2030599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030622 */     // GIR_Coverage, 17393,
     /* 2030622 */     GIR_EraseRootFromParent_Done,
     /* 2030623 */   // Label 26899: @2030623
     /* 2030623 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2030714), // Rule ID 17396 //
     /* 2030628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2030631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2030648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030674 */     // MIs[0] round
     /* 2030674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030677 */     // MIs[0] policy
     /* 2030677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030687 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2030690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030713 */     // GIR_Coverage, 17396,
     /* 2030713 */     GIR_EraseRootFromParent_Done,
     /* 2030714 */   // Label 26900: @2030714
     /* 2030714 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2030805), // Rule ID 17397 //
     /* 2030719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2030722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2030739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030765 */     // MIs[0] round
     /* 2030765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030768 */     // MIs[0] policy
     /* 2030768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030778 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2030781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030804 */     // GIR_Coverage, 17397,
     /* 2030804 */     GIR_EraseRootFromParent_Done,
     /* 2030805 */   // Label 26901: @2030805
     /* 2030805 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2030896), // Rule ID 17400 //
     /* 2030810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2030813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2030830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030856 */     // MIs[0] round
     /* 2030856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030859 */     // MIs[0] policy
     /* 2030859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030869 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2030872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030895 */     // GIR_Coverage, 17400,
     /* 2030895 */     GIR_EraseRootFromParent_Done,
     /* 2030896 */   // Label 26902: @2030896
     /* 2030896 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2030987), // Rule ID 17401 //
     /* 2030901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2030904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2030909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2030921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030947 */     // MIs[0] round
     /* 2030947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030950 */     // MIs[0] policy
     /* 2030950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030960 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2030963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030986 */     // GIR_Coverage, 17401,
     /* 2030986 */     GIR_EraseRootFromParent_Done,
     /* 2030987 */   // Label 26903: @2030987
     /* 2030987 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2031078), // Rule ID 17404 //
     /* 2030992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2030995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2031009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2031012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031038 */     // MIs[0] round
     /* 2031038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031041 */     // MIs[0] policy
     /* 2031041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2031054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031077 */     // GIR_Coverage, 17404,
     /* 2031077 */     GIR_EraseRootFromParent_Done,
     /* 2031078 */   // Label 26904: @2031078
     /* 2031078 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2031169), // Rule ID 17405 //
     /* 2031083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2031086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2031100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2031103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031129 */     // MIs[0] round
     /* 2031129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031132 */     // MIs[0] policy
     /* 2031132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2031145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031168 */     // GIR_Coverage, 17405,
     /* 2031168 */     GIR_EraseRootFromParent_Done,
     /* 2031169 */   // Label 26905: @2031169
     /* 2031169 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2031260), // Rule ID 17408 //
     /* 2031174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2031177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2031185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2031188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2031194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031220 */     // MIs[0] round
     /* 2031220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031223 */     // MIs[0] policy
     /* 2031223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031233 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2031236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031259 */     // GIR_Coverage, 17408,
     /* 2031259 */     GIR_EraseRootFromParent_Done,
     /* 2031260 */   // Label 26906: @2031260
     /* 2031260 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2031351), // Rule ID 17409 //
     /* 2031265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2031268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2031276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2031279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2031285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031311 */     // MIs[0] round
     /* 2031311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031314 */     // MIs[0] policy
     /* 2031314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2031327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031350 */     // GIR_Coverage, 17409,
     /* 2031350 */     GIR_EraseRootFromParent_Done,
     /* 2031351 */   // Label 26907: @2031351
     /* 2031351 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2031442), // Rule ID 17412 //
     /* 2031356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2031359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2031367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2031370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2031376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031402 */     // MIs[0] round
     /* 2031402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031405 */     // MIs[0] policy
     /* 2031405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031415 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2031418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031441 */     // GIR_Coverage, 17412,
     /* 2031441 */     GIR_EraseRootFromParent_Done,
     /* 2031442 */   // Label 26908: @2031442
     /* 2031442 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2031533), // Rule ID 17413 //
     /* 2031447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2031450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2031458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2031461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2031467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031493 */     // MIs[0] round
     /* 2031493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031496 */     // MIs[0] policy
     /* 2031496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2031509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031532 */     // GIR_Coverage, 17413,
     /* 2031532 */     GIR_EraseRootFromParent_Done,
     /* 2031533 */   // Label 26909: @2031533
     /* 2031533 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2031624), // Rule ID 17416 //
     /* 2031538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2031541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2031549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2031552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2031558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2031580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031584 */     // MIs[0] round
     /* 2031584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031587 */     // MIs[0] policy
     /* 2031587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031597 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2031600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031623 */     // GIR_Coverage, 17416,
     /* 2031623 */     GIR_EraseRootFromParent_Done,
     /* 2031624 */   // Label 26910: @2031624
     /* 2031624 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2031715), // Rule ID 17417 //
     /* 2031629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2031632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2031640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2031643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2031649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2031671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031675 */     // MIs[0] round
     /* 2031675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031678 */     // MIs[0] policy
     /* 2031678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031688 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2031691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031714 */     // GIR_Coverage, 17417,
     /* 2031714 */     GIR_EraseRootFromParent_Done,
     /* 2031715 */   // Label 26911: @2031715
     /* 2031715 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2031806), // Rule ID 17420 //
     /* 2031720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2031723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2031731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2031734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2031740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2031762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031766 */     // MIs[0] round
     /* 2031766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031769 */     // MIs[0] policy
     /* 2031769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031779 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2031782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031805 */     // GIR_Coverage, 17420,
     /* 2031805 */     GIR_EraseRootFromParent_Done,
     /* 2031806 */   // Label 26912: @2031806
     /* 2031806 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2031897), // Rule ID 17421 //
     /* 2031811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2031814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2031822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2031825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2031831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2031853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031857 */     // MIs[0] round
     /* 2031857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031860 */     // MIs[0] policy
     /* 2031860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031870 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2031873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031896 */     // GIR_Coverage, 17421,
     /* 2031896 */     GIR_EraseRootFromParent_Done,
     /* 2031897 */   // Label 26913: @2031897
     /* 2031897 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2031988), // Rule ID 17424 //
     /* 2031902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2031905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2031910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2031919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2031944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031948 */     // MIs[0] round
     /* 2031948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031951 */     // MIs[0] policy
     /* 2031951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031961 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2031964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031987 */     // GIR_Coverage, 17424,
     /* 2031987 */     GIR_EraseRootFromParent_Done,
     /* 2031988 */   // Label 26914: @2031988
     /* 2031988 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2032079), // Rule ID 17425 //
     /* 2031993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2031996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2032035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032039 */     // MIs[0] round
     /* 2032039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032042 */     // MIs[0] policy
     /* 2032042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032052 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2032055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032078 */     // GIR_Coverage, 17425,
     /* 2032078 */     GIR_EraseRootFromParent_Done,
     /* 2032079 */   // Label 26915: @2032079
     /* 2032079 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2032170), // Rule ID 17428 //
     /* 2032084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2032087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032130 */     // MIs[0] round
     /* 2032130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032133 */     // MIs[0] policy
     /* 2032133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032143 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2032146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032169 */     // GIR_Coverage, 17428,
     /* 2032169 */     GIR_EraseRootFromParent_Done,
     /* 2032170 */   // Label 26916: @2032170
     /* 2032170 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2032261), // Rule ID 17429 //
     /* 2032175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2032178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032221 */     // MIs[0] round
     /* 2032221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032224 */     // MIs[0] policy
     /* 2032224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032234 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2032237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032260 */     // GIR_Coverage, 17429,
     /* 2032260 */     GIR_EraseRootFromParent_Done,
     /* 2032261 */   // Label 26917: @2032261
     /* 2032261 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2032352), // Rule ID 17432 //
     /* 2032266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2032269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2032308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032312 */     // MIs[0] round
     /* 2032312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032315 */     // MIs[0] policy
     /* 2032315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032325 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2032328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032351 */     // GIR_Coverage, 17432,
     /* 2032351 */     GIR_EraseRootFromParent_Done,
     /* 2032352 */   // Label 26918: @2032352
     /* 2032352 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2032443), // Rule ID 17433 //
     /* 2032357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2032360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2032399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032403 */     // MIs[0] round
     /* 2032403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032406 */     // MIs[0] policy
     /* 2032406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032416 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2032419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032442 */     // GIR_Coverage, 17433,
     /* 2032442 */     GIR_EraseRootFromParent_Done,
     /* 2032443 */   // Label 26919: @2032443
     /* 2032443 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2032534), // Rule ID 17436 //
     /* 2032448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2032451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2032465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2032490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032494 */     // MIs[0] round
     /* 2032494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032497 */     // MIs[0] policy
     /* 2032497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032507 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2032510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2032530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032533 */     // GIR_Coverage, 17436,
     /* 2032533 */     GIR_EraseRootFromParent_Done,
     /* 2032534 */   // Label 26920: @2032534
     /* 2032534 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2032625), // Rule ID 17437 //
     /* 2032539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2032542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2032556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2032581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032585 */     // MIs[0] round
     /* 2032585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032588 */     // MIs[0] policy
     /* 2032588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2032601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2032621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032624 */     // GIR_Coverage, 17437,
     /* 2032624 */     GIR_EraseRootFromParent_Done,
     /* 2032625 */   // Label 26921: @2032625
     /* 2032625 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2032716), // Rule ID 17440 //
     /* 2032630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2032633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2032641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2032644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2032647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032676 */     // MIs[0] round
     /* 2032676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032679 */     // MIs[0] policy
     /* 2032679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032689 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2032692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032715 */     // GIR_Coverage, 17440,
     /* 2032715 */     GIR_EraseRootFromParent_Done,
     /* 2032716 */   // Label 26922: @2032716
     /* 2032716 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2032807), // Rule ID 17441 //
     /* 2032721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2032724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2032732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2032735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2032738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032767 */     // MIs[0] round
     /* 2032767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032770 */     // MIs[0] policy
     /* 2032770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032780 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2032783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032806 */     // GIR_Coverage, 17441,
     /* 2032806 */     GIR_EraseRootFromParent_Done,
     /* 2032807 */   // Label 26923: @2032807
     /* 2032807 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2032898), // Rule ID 17444 //
     /* 2032812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2032815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2032823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2032826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2032829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032858 */     // MIs[0] round
     /* 2032858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032861 */     // MIs[0] policy
     /* 2032861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032871 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2032874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032897 */     // GIR_Coverage, 17444,
     /* 2032897 */     GIR_EraseRootFromParent_Done,
     /* 2032898 */   // Label 26924: @2032898
     /* 2032898 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2032989), // Rule ID 17445 //
     /* 2032903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2032906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2032911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2032914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2032917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2032920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2032923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2032945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032949 */     // MIs[0] round
     /* 2032949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032952 */     // MIs[0] policy
     /* 2032952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032962 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2032965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032988 */     // GIR_Coverage, 17445,
     /* 2032988 */     GIR_EraseRootFromParent_Done,
     /* 2032989 */   // Label 26925: @2032989
     /* 2032989 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2033080), // Rule ID 17448 //
     /* 2032994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2032997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2033005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2033008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2033011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2033014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2033036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033040 */     // MIs[0] round
     /* 2033040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033043 */     // MIs[0] policy
     /* 2033043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033053 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2033056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033079 */     // GIR_Coverage, 17448,
     /* 2033079 */     GIR_EraseRootFromParent_Done,
     /* 2033080 */   // Label 26926: @2033080
     /* 2033080 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2033171), // Rule ID 17449 //
     /* 2033085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2033088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2033096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2033099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2033102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2033105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2033127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033131 */     // MIs[0] round
     /* 2033131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033134 */     // MIs[0] policy
     /* 2033134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033144 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2033147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033170 */     // GIR_Coverage, 17449,
     /* 2033170 */     GIR_EraseRootFromParent_Done,
     /* 2033171 */   // Label 26927: @2033171
     /* 2033171 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2033262), // Rule ID 17452 //
     /* 2033176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2033179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2033193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033222 */     // MIs[0] round
     /* 2033222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033225 */     // MIs[0] policy
     /* 2033225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033235 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2033238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033261 */     // GIR_Coverage, 17452,
     /* 2033261 */     GIR_EraseRootFromParent_Done,
     /* 2033262 */   // Label 26928: @2033262
     /* 2033262 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2033353), // Rule ID 17453 //
     /* 2033267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2033270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2033284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033313 */     // MIs[0] round
     /* 2033313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033316 */     // MIs[0] policy
     /* 2033316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033326 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2033329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033352 */     // GIR_Coverage, 17453,
     /* 2033352 */     GIR_EraseRootFromParent_Done,
     /* 2033353 */   // Label 26929: @2033353
     /* 2033353 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2033444), // Rule ID 17456 //
     /* 2033358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2033361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2033375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033404 */     // MIs[0] round
     /* 2033404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033407 */     // MIs[0] policy
     /* 2033407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033417 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2033420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033443 */     // GIR_Coverage, 17456,
     /* 2033443 */     GIR_EraseRootFromParent_Done,
     /* 2033444 */   // Label 26930: @2033444
     /* 2033444 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2033535), // Rule ID 17457 //
     /* 2033449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2033452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2033466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033495 */     // MIs[0] round
     /* 2033495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033498 */     // MIs[0] policy
     /* 2033498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033508 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2033511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033534 */     // GIR_Coverage, 17457,
     /* 2033534 */     GIR_EraseRootFromParent_Done,
     /* 2033535 */   // Label 26931: @2033535
     /* 2033535 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2033626), // Rule ID 17460 //
     /* 2033540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2033543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2033557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033586 */     // MIs[0] round
     /* 2033586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033589 */     // MIs[0] policy
     /* 2033589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033599 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2033602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033625 */     // GIR_Coverage, 17460,
     /* 2033625 */     GIR_EraseRootFromParent_Done,
     /* 2033626 */   // Label 26932: @2033626
     /* 2033626 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2033717), // Rule ID 17461 //
     /* 2033631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2033634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2033648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2033673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033677 */     // MIs[0] round
     /* 2033677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033680 */     // MIs[0] policy
     /* 2033680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2033693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033716 */     // GIR_Coverage, 17461,
     /* 2033716 */     GIR_EraseRootFromParent_Done,
     /* 2033717 */   // Label 26933: @2033717
     /* 2033717 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2033808), // Rule ID 17464 //
     /* 2033722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2033725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2033739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2033764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033768 */     // MIs[0] round
     /* 2033768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033771 */     // MIs[0] policy
     /* 2033771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2033784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2033804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033807 */     // GIR_Coverage, 17464,
     /* 2033807 */     GIR_EraseRootFromParent_Done,
     /* 2033808 */   // Label 26934: @2033808
     /* 2033808 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2033899), // Rule ID 17465 //
     /* 2033813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2033816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2033830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2033855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033859 */     // MIs[0] round
     /* 2033859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033862 */     // MIs[0] policy
     /* 2033862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2033875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2033895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033898 */     // GIR_Coverage, 17465,
     /* 2033898 */     GIR_EraseRootFromParent_Done,
     /* 2033899 */   // Label 26935: @2033899
     /* 2033899 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2033990), // Rule ID 17468 //
     /* 2033904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2033907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2033912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2033915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2033918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2033921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2033946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033950 */     // MIs[0] round
     /* 2033950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033953 */     // MIs[0] policy
     /* 2033953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033963 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2033966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2033986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033989 */     // GIR_Coverage, 17468,
     /* 2033989 */     GIR_EraseRootFromParent_Done,
     /* 2033990 */   // Label 26936: @2033990
     /* 2033990 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2034081), // Rule ID 17469 //
     /* 2033995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2033998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2034003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2034012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2034037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034041 */     // MIs[0] round
     /* 2034041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034044 */     // MIs[0] policy
     /* 2034044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034054 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2034057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034080 */     // GIR_Coverage, 17469,
     /* 2034080 */     GIR_EraseRootFromParent_Done,
     /* 2034081 */   // Label 26937: @2034081
     /* 2034081 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2034172), // Rule ID 17472 //
     /* 2034086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2034089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2034094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2034128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034132 */     // MIs[0] round
     /* 2034132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034135 */     // MIs[0] policy
     /* 2034135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034145 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2034148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034171 */     // GIR_Coverage, 17472,
     /* 2034171 */     GIR_EraseRootFromParent_Done,
     /* 2034172 */   // Label 26938: @2034172
     /* 2034172 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2034263), // Rule ID 17473 //
     /* 2034177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2034180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2034185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2034219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034223 */     // MIs[0] round
     /* 2034223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034226 */     // MIs[0] policy
     /* 2034226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2034239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034262 */     // GIR_Coverage, 17473,
     /* 2034262 */     GIR_EraseRootFromParent_Done,
     /* 2034263 */   // Label 26939: @2034263
     /* 2034263 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2034354), // Rule ID 17476 //
     /* 2034268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034314 */     // MIs[0] round
     /* 2034314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034317 */     // MIs[0] policy
     /* 2034317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034327 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2034330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034353 */     // GIR_Coverage, 17476,
     /* 2034353 */     GIR_EraseRootFromParent_Done,
     /* 2034354 */   // Label 26940: @2034354
     /* 2034354 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2034445), // Rule ID 17477 //
     /* 2034359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034405 */     // MIs[0] round
     /* 2034405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034408 */     // MIs[0] policy
     /* 2034408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034418 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2034421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034444 */     // GIR_Coverage, 17477,
     /* 2034444 */     GIR_EraseRootFromParent_Done,
     /* 2034445 */   // Label 26941: @2034445
     /* 2034445 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2034536), // Rule ID 17480 //
     /* 2034450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2034461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2034464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2034467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034496 */     // MIs[0] round
     /* 2034496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034499 */     // MIs[0] policy
     /* 2034499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034509 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2034512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034535 */     // GIR_Coverage, 17480,
     /* 2034535 */     GIR_EraseRootFromParent_Done,
     /* 2034536 */   // Label 26942: @2034536
     /* 2034536 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2034627), // Rule ID 17481 //
     /* 2034541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2034552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2034555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2034558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034587 */     // MIs[0] round
     /* 2034587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034590 */     // MIs[0] policy
     /* 2034590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2034603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034626 */     // GIR_Coverage, 17481,
     /* 2034626 */     GIR_EraseRootFromParent_Done,
     /* 2034627 */   // Label 26943: @2034627
     /* 2034627 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2034718), // Rule ID 17484 //
     /* 2034632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2034635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2034674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034678 */     // MIs[0] round
     /* 2034678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034681 */     // MIs[0] policy
     /* 2034681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034691 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2034694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034717 */     // GIR_Coverage, 17484,
     /* 2034717 */     GIR_EraseRootFromParent_Done,
     /* 2034718 */   // Label 26944: @2034718
     /* 2034718 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2034809), // Rule ID 17485 //
     /* 2034723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2034726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2034765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034769 */     // MIs[0] round
     /* 2034769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034772 */     // MIs[0] policy
     /* 2034772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2034785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034808 */     // GIR_Coverage, 17485,
     /* 2034808 */     GIR_EraseRootFromParent_Done,
     /* 2034809 */   // Label 26945: @2034809
     /* 2034809 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2034900), // Rule ID 17488 //
     /* 2034814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2034825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2034828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2034831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034860 */     // MIs[0] round
     /* 2034860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034863 */     // MIs[0] policy
     /* 2034863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034873 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2034876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034899 */     // GIR_Coverage, 17488,
     /* 2034899 */     GIR_EraseRootFromParent_Done,
     /* 2034900 */   // Label 26946: @2034900
     /* 2034900 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2034991), // Rule ID 17489 //
     /* 2034905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2034913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2034916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2034919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2034922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2034925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2034947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034951 */     // MIs[0] round
     /* 2034951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034954 */     // MIs[0] policy
     /* 2034954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10941:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2034967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034990 */     // GIR_Coverage, 17489,
     /* 2034990 */     GIR_EraseRootFromParent_Done,
     /* 2034991 */   // Label 26947: @2034991
     /* 2034991 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2035082), // Rule ID 17492 //
     /* 2034996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2034999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2035038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035042 */     // MIs[0] round
     /* 2035042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035045 */     // MIs[0] policy
     /* 2035045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035055 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10941:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2035058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035081 */     // GIR_Coverage, 17492,
     /* 2035081 */     GIR_EraseRootFromParent_Done,
     /* 2035082 */   // Label 26948: @2035082
     /* 2035082 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2035173), // Rule ID 17493 //
     /* 2035087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2035090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2035129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035133 */     // MIs[0] round
     /* 2035133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035136 */     // MIs[0] policy
     /* 2035136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035146 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10941:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2035149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035172 */     // GIR_Coverage, 17493,
     /* 2035172 */     GIR_EraseRootFromParent_Done,
     /* 2035173 */   // Label 26949: @2035173
     /* 2035173 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2035264), // Rule ID 17496 //
     /* 2035178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2035181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2035195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2035220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035224 */     // MIs[0] round
     /* 2035224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035227 */     // MIs[0] policy
     /* 2035227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035237 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2035240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035263 */     // GIR_Coverage, 17496,
     /* 2035263 */     GIR_EraseRootFromParent_Done,
     /* 2035264 */   // Label 26950: @2035264
     /* 2035264 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2035355), // Rule ID 17497 //
     /* 2035269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2035272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2035286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2035311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035315 */     // MIs[0] round
     /* 2035315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035318 */     // MIs[0] policy
     /* 2035318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10941:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2035331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035354 */     // GIR_Coverage, 17497,
     /* 2035354 */     GIR_EraseRootFromParent_Done,
     /* 2035355 */   // Label 26951: @2035355
     /* 2035355 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2035446), // Rule ID 17500 //
     /* 2035360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2035363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2035371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2035374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2035377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035406 */     // MIs[0] round
     /* 2035406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035409 */     // MIs[0] policy
     /* 2035409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035419 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2035422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035445 */     // GIR_Coverage, 17500,
     /* 2035445 */     GIR_EraseRootFromParent_Done,
     /* 2035446 */   // Label 26952: @2035446
     /* 2035446 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2035537), // Rule ID 17501 //
     /* 2035451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2035454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2035462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2035465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2035468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035497 */     // MIs[0] round
     /* 2035497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035500 */     // MIs[0] policy
     /* 2035500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035510 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2035513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035536 */     // GIR_Coverage, 17501,
     /* 2035536 */     GIR_EraseRootFromParent_Done,
     /* 2035537 */   // Label 26953: @2035537
     /* 2035537 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2035628), // Rule ID 17504 //
     /* 2035542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2035545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2035553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2035556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2035559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2035565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035588 */     // MIs[0] round
     /* 2035588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035591 */     // MIs[0] policy
     /* 2035591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035601 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2035604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035627 */     // GIR_Coverage, 17504,
     /* 2035627 */     GIR_EraseRootFromParent_Done,
     /* 2035628 */   // Label 26954: @2035628
     /* 2035628 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2035719), // Rule ID 17505 //
     /* 2035633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2035636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2035644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2035647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2035650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2035656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035679 */     // MIs[0] round
     /* 2035679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035682 */     // MIs[0] policy
     /* 2035682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035692 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2035695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035718 */     // GIR_Coverage, 17505,
     /* 2035718 */     GIR_EraseRootFromParent_Done,
     /* 2035719 */   // Label 26955: @2035719
     /* 2035719 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2035810), // Rule ID 17508 //
     /* 2035724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2035727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2035735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2035738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2035741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2035747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035770 */     // MIs[0] round
     /* 2035770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035773 */     // MIs[0] policy
     /* 2035773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035783 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2035786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035809 */     // GIR_Coverage, 17508,
     /* 2035809 */     GIR_EraseRootFromParent_Done,
     /* 2035810 */   // Label 26956: @2035810
     /* 2035810 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2035901), // Rule ID 17509 //
     /* 2035815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2035818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2035826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2035829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2035832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2035835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2035838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2035857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035861 */     // MIs[0] round
     /* 2035861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035864 */     // MIs[0] policy
     /* 2035864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035874 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2035877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035900 */     // GIR_Coverage, 17509,
     /* 2035900 */     GIR_EraseRootFromParent_Done,
     /* 2035901 */   // Label 26957: @2035901
     /* 2035901 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2035992), // Rule ID 17512 //
     /* 2035906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2035909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2035914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2035917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2035920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2035923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2035948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035952 */     // MIs[0] round
     /* 2035952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035955 */     // MIs[0] policy
     /* 2035955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035965 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2035968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035991 */     // GIR_Coverage, 17512,
     /* 2035991 */     GIR_EraseRootFromParent_Done,
     /* 2035992 */   // Label 26958: @2035992
     /* 2035992 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2036083), // Rule ID 17513 //
     /* 2035997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2036000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2036008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2036011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2036014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2036039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036043 */     // MIs[0] round
     /* 2036043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036046 */     // MIs[0] policy
     /* 2036046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2036059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036082 */     // GIR_Coverage, 17513,
     /* 2036082 */     GIR_EraseRootFromParent_Done,
     /* 2036083 */   // Label 26959: @2036083
     /* 2036083 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2036174), // Rule ID 17516 //
     /* 2036088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2036091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2036099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2036102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2036105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2036130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036134 */     // MIs[0] round
     /* 2036134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036137 */     // MIs[0] policy
     /* 2036137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036147 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2036150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036173 */     // GIR_Coverage, 17516,
     /* 2036173 */     GIR_EraseRootFromParent_Done,
     /* 2036174 */   // Label 26960: @2036174
     /* 2036174 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2036265), // Rule ID 17517 //
     /* 2036179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2036182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2036190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2036193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2036196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2036221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036225 */     // MIs[0] round
     /* 2036225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036228 */     // MIs[0] policy
     /* 2036228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036238 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2036241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036264 */     // GIR_Coverage, 17517,
     /* 2036264 */     GIR_EraseRootFromParent_Done,
     /* 2036265 */   // Label 26961: @2036265
     /* 2036265 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2036356), // Rule ID 17520 //
     /* 2036270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2036273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2036281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2036284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2036287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2036312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036316 */     // MIs[0] round
     /* 2036316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036319 */     // MIs[0] policy
     /* 2036319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036329 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2036332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036355 */     // GIR_Coverage, 17520,
     /* 2036355 */     GIR_EraseRootFromParent_Done,
     /* 2036356 */   // Label 26962: @2036356
     /* 2036356 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2036447), // Rule ID 17521 //
     /* 2036361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2036364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2036372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2036375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2036378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2036403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036407 */     // MIs[0] round
     /* 2036407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036410 */     // MIs[0] policy
     /* 2036410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036420 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2036423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036446 */     // GIR_Coverage, 17521,
     /* 2036446 */     GIR_EraseRootFromParent_Done,
     /* 2036447 */   // Label 26963: @2036447
     /* 2036447 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2036538), // Rule ID 17524 //
     /* 2036452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2036455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2036463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2036466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2036469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036498 */     // MIs[0] round
     /* 2036498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036501 */     // MIs[0] policy
     /* 2036501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036511 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2036514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036537 */     // GIR_Coverage, 17524,
     /* 2036537 */     GIR_EraseRootFromParent_Done,
     /* 2036538 */   // Label 26964: @2036538
     /* 2036538 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2036629), // Rule ID 17525 //
     /* 2036543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2036546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2036554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2036557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2036560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036589 */     // MIs[0] round
     /* 2036589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036592 */     // MIs[0] policy
     /* 2036592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10941:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2036605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036628 */     // GIR_Coverage, 17525,
     /* 2036628 */     GIR_EraseRootFromParent_Done,
     /* 2036629 */   // Label 26965: @2036629
     /* 2036629 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2036720), // Rule ID 17528 //
     /* 2036634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2036637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2036645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2036648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2036651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036680 */     // MIs[0] round
     /* 2036680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036683 */     // MIs[0] policy
     /* 2036683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036693 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2036696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036719 */     // GIR_Coverage, 17528,
     /* 2036719 */     GIR_EraseRootFromParent_Done,
     /* 2036720 */   // Label 26966: @2036720
     /* 2036720 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2036811), // Rule ID 17529 //
     /* 2036725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2036728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2036736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2036739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2036742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036771 */     // MIs[0] round
     /* 2036771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036774 */     // MIs[0] policy
     /* 2036774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10941:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2036787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036810 */     // GIR_Coverage, 17529,
     /* 2036810 */     GIR_EraseRootFromParent_Done,
     /* 2036811 */   // Label 26967: @2036811
     /* 2036811 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2036902), // Rule ID 17532 //
     /* 2036816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2036819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2036827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2036830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2036833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036862 */     // MIs[0] round
     /* 2036862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036865 */     // MIs[0] policy
     /* 2036865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036875 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2036878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036901 */     // GIR_Coverage, 17532,
     /* 2036901 */     GIR_EraseRootFromParent_Done,
     /* 2036902 */   // Label 26968: @2036902
     /* 2036902 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2036993), // Rule ID 17533 //
     /* 2036907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2036910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2036915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2036918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2036921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2036924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2036949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036953 */     // MIs[0] round
     /* 2036953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036956 */     // MIs[0] policy
     /* 2036956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10941:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2036969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036992 */     // GIR_Coverage, 17533,
     /* 2036992 */     GIR_EraseRootFromParent_Done,
     /* 2036993 */   // Label 26969: @2036993
     /* 2036993 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2037084), // Rule ID 17536 //
     /* 2036998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2037009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2037012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2037015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2037018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037044 */     // MIs[0] round
     /* 2037044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037047 */     // MIs[0] policy
     /* 2037047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037057 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2037060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037083 */     // GIR_Coverage, 17536,
     /* 2037083 */     GIR_EraseRootFromParent_Done,
     /* 2037084 */   // Label 26970: @2037084
     /* 2037084 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2037175), // Rule ID 17537 //
     /* 2037089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2037092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2037100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2037103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2037106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2037109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037135 */     // MIs[0] round
     /* 2037135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037138 */     // MIs[0] policy
     /* 2037138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037148 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2037151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037174 */     // GIR_Coverage, 17537,
     /* 2037174 */     GIR_EraseRootFromParent_Done,
     /* 2037175 */   // Label 26971: @2037175
     /* 2037175 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2037266), // Rule ID 17540 //
     /* 2037180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2037191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2037194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2037197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2037200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037226 */     // MIs[0] round
     /* 2037226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037229 */     // MIs[0] policy
     /* 2037229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037239 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2037242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037265 */     // GIR_Coverage, 17540,
     /* 2037265 */     GIR_EraseRootFromParent_Done,
     /* 2037266 */   // Label 26972: @2037266
     /* 2037266 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2037357), // Rule ID 17541 //
     /* 2037271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2037274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2037282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2037285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2037288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2037291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037317 */     // MIs[0] round
     /* 2037317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037320 */     // MIs[0] policy
     /* 2037320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2037333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037356 */     // GIR_Coverage, 17541,
     /* 2037356 */     GIR_EraseRootFromParent_Done,
     /* 2037357 */   // Label 26973: @2037357
     /* 2037357 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2037448), // Rule ID 17544 //
     /* 2037362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2037379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2037382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037408 */     // MIs[0] round
     /* 2037408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037411 */     // MIs[0] policy
     /* 2037411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2037424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037447 */     // GIR_Coverage, 17544,
     /* 2037447 */     GIR_EraseRootFromParent_Done,
     /* 2037448 */   // Label 26974: @2037448
     /* 2037448 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2037539), // Rule ID 17545 //
     /* 2037453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2037456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2037470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2037473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037499 */     // MIs[0] round
     /* 2037499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037502 */     // MIs[0] policy
     /* 2037502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037512 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2037515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037538 */     // GIR_Coverage, 17545,
     /* 2037538 */     GIR_EraseRootFromParent_Done,
     /* 2037539 */   // Label 26975: @2037539
     /* 2037539 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2037630), // Rule ID 17548 //
     /* 2037544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037590 */     // MIs[0] round
     /* 2037590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037593 */     // MIs[0] policy
     /* 2037593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037603 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2037606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037629 */     // GIR_Coverage, 17548,
     /* 2037629 */     GIR_EraseRootFromParent_Done,
     /* 2037630 */   // Label 26976: @2037630
     /* 2037630 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2037721), // Rule ID 17549 //
     /* 2037635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2037638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037681 */     // MIs[0] round
     /* 2037681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037684 */     // MIs[0] policy
     /* 2037684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037694 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2037697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037720 */     // GIR_Coverage, 17549,
     /* 2037720 */     GIR_EraseRootFromParent_Done,
     /* 2037721 */   // Label 26977: @2037721
     /* 2037721 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2037812), // Rule ID 17552 //
     /* 2037726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037772 */     // MIs[0] round
     /* 2037772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037775 */     // MIs[0] policy
     /* 2037775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037785 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2037788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037811 */     // GIR_Coverage, 17552,
     /* 2037811 */     GIR_EraseRootFromParent_Done,
     /* 2037812 */   // Label 26978: @2037812
     /* 2037812 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2037903), // Rule ID 17553 //
     /* 2037817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2037820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037863 */     // MIs[0] round
     /* 2037863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037866 */     // MIs[0] policy
     /* 2037866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2037879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037902 */     // GIR_Coverage, 17553,
     /* 2037902 */     GIR_EraseRootFromParent_Done,
     /* 2037903 */   // Label 26979: @2037903
     /* 2037903 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2037994), // Rule ID 17556 //
     /* 2037908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2037911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2037916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2037919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2037922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2037925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2037928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037954 */     // MIs[0] round
     /* 2037954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037957 */     // MIs[0] policy
     /* 2037957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037967 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2037970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037993 */     // GIR_Coverage, 17556,
     /* 2037993 */     GIR_EraseRootFromParent_Done,
     /* 2037994 */   // Label 26980: @2037994
     /* 2037994 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2038085), // Rule ID 17557 //
     /* 2037999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2038002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2038010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2038013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2038016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2038019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038045 */     // MIs[0] round
     /* 2038045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038048 */     // MIs[0] policy
     /* 2038048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2038061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038084 */     // GIR_Coverage, 17557,
     /* 2038084 */     GIR_EraseRootFromParent_Done,
     /* 2038085 */   // Label 26981: @2038085
     /* 2038085 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2038176), // Rule ID 17560 //
     /* 2038090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2038093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2038107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2038110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038136 */     // MIs[0] round
     /* 2038136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038139 */     // MIs[0] policy
     /* 2038139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2038152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038175 */     // GIR_Coverage, 17560,
     /* 2038175 */     GIR_EraseRootFromParent_Done,
     /* 2038176 */   // Label 26982: @2038176
     /* 2038176 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2038267), // Rule ID 17561 //
     /* 2038181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2038184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2038198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2038201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038227 */     // MIs[0] round
     /* 2038227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038230 */     // MIs[0] policy
     /* 2038230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038240 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2038243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038266 */     // GIR_Coverage, 17561,
     /* 2038266 */     GIR_EraseRootFromParent_Done,
     /* 2038267 */   // Label 26983: @2038267
     /* 2038267 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2038358), // Rule ID 17564 //
     /* 2038272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2038275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2038292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038318 */     // MIs[0] round
     /* 2038318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038321 */     // MIs[0] policy
     /* 2038321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038331 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2038334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038357 */     // GIR_Coverage, 17564,
     /* 2038357 */     GIR_EraseRootFromParent_Done,
     /* 2038358 */   // Label 26984: @2038358
     /* 2038358 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2038449), // Rule ID 17565 //
     /* 2038363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2038366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2038383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038409 */     // MIs[0] round
     /* 2038409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038412 */     // MIs[0] policy
     /* 2038412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2038425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038448 */     // GIR_Coverage, 17565,
     /* 2038448 */     GIR_EraseRootFromParent_Done,
     /* 2038449 */   // Label 26985: @2038449
     /* 2038449 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2038540), // Rule ID 17568 //
     /* 2038454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2038457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2038474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038500 */     // MIs[0] round
     /* 2038500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038503 */     // MIs[0] policy
     /* 2038503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038513 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2038516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038539 */     // GIR_Coverage, 17568,
     /* 2038539 */     GIR_EraseRootFromParent_Done,
     /* 2038540 */   // Label 26986: @2038540
     /* 2038540 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2038631), // Rule ID 17569 //
     /* 2038545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2038548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2038565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038591 */     // MIs[0] round
     /* 2038591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038594 */     // MIs[0] policy
     /* 2038594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038604 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2038607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038630 */     // GIR_Coverage, 17569,
     /* 2038630 */     GIR_EraseRootFromParent_Done,
     /* 2038631 */   // Label 26987: @2038631
     /* 2038631 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2038722), // Rule ID 17572 //
     /* 2038636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2038639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2038647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2038650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2038656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2038678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038682 */     // MIs[0] round
     /* 2038682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038685 */     // MIs[0] policy
     /* 2038685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038695 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2038698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038721 */     // GIR_Coverage, 17572,
     /* 2038721 */     GIR_EraseRootFromParent_Done,
     /* 2038722 */   // Label 26988: @2038722
     /* 2038722 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2038813), // Rule ID 17573 //
     /* 2038727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2038730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2038738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2038741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2038747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2038769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038773 */     // MIs[0] round
     /* 2038773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038776 */     // MIs[0] policy
     /* 2038776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2038789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038812 */     // GIR_Coverage, 17573,
     /* 2038812 */     GIR_EraseRootFromParent_Done,
     /* 2038813 */   // Label 26989: @2038813
     /* 2038813 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2038904), // Rule ID 17576 //
     /* 2038818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2038821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2038829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2038832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2038835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2038838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2038860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038864 */     // MIs[0] round
     /* 2038864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038867 */     // MIs[0] policy
     /* 2038867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038877 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2038880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038903 */     // GIR_Coverage, 17576,
     /* 2038903 */     GIR_EraseRootFromParent_Done,
     /* 2038904 */   // Label 26990: @2038904
     /* 2038904 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2038995), // Rule ID 17577 //
     /* 2038909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2038912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2038917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2038920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2038923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2038926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2038929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2038951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038955 */     // MIs[0] round
     /* 2038955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038958 */     // MIs[0] policy
     /* 2038958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038968 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10997:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2038971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038994 */     // GIR_Coverage, 17577,
     /* 2038994 */     GIR_EraseRootFromParent_Done,
     /* 2038995 */   // Label 26991: @2038995
     /* 2038995 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2039086), // Rule ID 17580 //
     /* 2039000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2039003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2039011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2039014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039046 */     // MIs[0] round
     /* 2039046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039049 */     // MIs[0] policy
     /* 2039049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2039062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039085 */     // GIR_Coverage, 17580,
     /* 2039085 */     GIR_EraseRootFromParent_Done,
     /* 2039086 */   // Label 26992: @2039086
     /* 2039086 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2039177), // Rule ID 17581 //
     /* 2039091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2039094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2039102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2039105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039137 */     // MIs[0] round
     /* 2039137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039140 */     // MIs[0] policy
     /* 2039140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2039153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039176 */     // GIR_Coverage, 17581,
     /* 2039176 */     GIR_EraseRootFromParent_Done,
     /* 2039177 */   // Label 26993: @2039177
     /* 2039177 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2039268), // Rule ID 17584 //
     /* 2039182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2039185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2039193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2039196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2039199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2039212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039228 */     // MIs[0] round
     /* 2039228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039231 */     // MIs[0] policy
     /* 2039231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039241 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2039244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039267 */     // GIR_Coverage, 17584,
     /* 2039267 */     GIR_EraseRootFromParent_Done,
     /* 2039268 */   // Label 26994: @2039268
     /* 2039268 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2039359), // Rule ID 17585 //
     /* 2039273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2039276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2039284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2039287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2039290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2039303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039319 */     // MIs[0] round
     /* 2039319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039322 */     // MIs[0] policy
     /* 2039322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039332 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2039335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039358 */     // GIR_Coverage, 17585,
     /* 2039358 */     GIR_EraseRootFromParent_Done,
     /* 2039359 */   // Label 26995: @2039359
     /* 2039359 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2039450), // Rule ID 17588 //
     /* 2039364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2039367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2039375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2039378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2039381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2039387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2039394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039410 */     // MIs[0] round
     /* 2039410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039413 */     // MIs[0] policy
     /* 2039413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039423 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2039426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039449 */     // GIR_Coverage, 17588,
     /* 2039449 */     GIR_EraseRootFromParent_Done,
     /* 2039450 */   // Label 26996: @2039450
     /* 2039450 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2039541), // Rule ID 17589 //
     /* 2039455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2039458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2039466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2039469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2039472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2039475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2039478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2039485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2039497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039501 */     // MIs[0] round
     /* 2039501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039504 */     // MIs[0] policy
     /* 2039504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039514 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2039517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039540 */     // GIR_Coverage, 17589,
     /* 2039540 */     GIR_EraseRootFromParent_Done,
     /* 2039541 */   // Label 26997: @2039541
     /* 2039541 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2039632), // Rule ID 17592 //
     /* 2039546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2039549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2039588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039592 */     // MIs[0] round
     /* 2039592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039595 */     // MIs[0] policy
     /* 2039595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039605 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2039608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039631 */     // GIR_Coverage, 17592,
     /* 2039631 */     GIR_EraseRootFromParent_Done,
     /* 2039632 */   // Label 26998: @2039632
     /* 2039632 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2039723), // Rule ID 17593 //
     /* 2039637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2039640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2039679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039683 */     // MIs[0] round
     /* 2039683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039686 */     // MIs[0] policy
     /* 2039686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10997:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2039699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039722 */     // GIR_Coverage, 17593,
     /* 2039722 */     GIR_EraseRootFromParent_Done,
     /* 2039723 */   // Label 26999: @2039723
     /* 2039723 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2039814), // Rule ID 17596 //
     /* 2039728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2039731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2039739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2039742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2039770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039774 */     // MIs[0] round
     /* 2039774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039777 */     // MIs[0] policy
     /* 2039777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039787 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2039790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039813 */     // GIR_Coverage, 17596,
     /* 2039813 */     GIR_EraseRootFromParent_Done,
     /* 2039814 */   // Label 27000: @2039814
     /* 2039814 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2039905), // Rule ID 17597 //
     /* 2039819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2039822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2039830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2039833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2039861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039865 */     // MIs[0] round
     /* 2039865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039868 */     // MIs[0] policy
     /* 2039868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10997:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2039881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039904 */     // GIR_Coverage, 17597,
     /* 2039904 */     GIR_EraseRootFromParent_Done,
     /* 2039905 */   // Label 27001: @2039905
     /* 2039905 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2039996), // Rule ID 17600 //
     /* 2039910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2039913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2039918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2039921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2039924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2039927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2039940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2039952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039956 */     // MIs[0] round
     /* 2039956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039959 */     // MIs[0] policy
     /* 2039959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039969 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2039972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039995 */     // GIR_Coverage, 17600,
     /* 2039995 */     GIR_EraseRootFromParent_Done,
     /* 2039996 */   // Label 27002: @2039996
     /* 2039996 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2040087), // Rule ID 17601 //
     /* 2040001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2040004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2040009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2040012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2040015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2040018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2040043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040047 */     // MIs[0] round
     /* 2040047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040050 */     // MIs[0] policy
     /* 2040050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040060 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10997:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2040063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040086 */     // GIR_Coverage, 17601,
     /* 2040086 */     GIR_EraseRootFromParent_Done,
     /* 2040087 */   // Label 27003: @2040087
     /* 2040087 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2040178), // Rule ID 17604 //
     /* 2040092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2040095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2040100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2040103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2040106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2040109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2040134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040138 */     // MIs[0] round
     /* 2040138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040141 */     // MIs[0] policy
     /* 2040141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040151 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2040154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040177 */     // GIR_Coverage, 17604,
     /* 2040177 */     GIR_EraseRootFromParent_Done,
     /* 2040178 */   // Label 27004: @2040178
     /* 2040178 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2040269), // Rule ID 17605 //
     /* 2040183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2040186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2040191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2040194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2040197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2040200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2040225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040229 */     // MIs[0] round
     /* 2040229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040232 */     // MIs[0] policy
     /* 2040232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040242 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10997:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2040245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040268 */     // GIR_Coverage, 17605,
     /* 2040268 */     GIR_EraseRootFromParent_Done,
     /* 2040269 */   // Label 27005: @2040269
     /* 2040269 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2040360), // Rule ID 17608 //
     /* 2040274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2040277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2040285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2040288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2040291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2040294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040320 */     // MIs[0] round
     /* 2040320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040323 */     // MIs[0] policy
     /* 2040323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040333 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2040336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040359 */     // GIR_Coverage, 17608,
     /* 2040359 */     GIR_EraseRootFromParent_Done,
     /* 2040360 */   // Label 27006: @2040360
     /* 2040360 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2040451), // Rule ID 17609 //
     /* 2040365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2040368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2040376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2040379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2040382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2040385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040411 */     // MIs[0] round
     /* 2040411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040414 */     // MIs[0] policy
     /* 2040414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2040427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040450 */     // GIR_Coverage, 17609,
     /* 2040450 */     GIR_EraseRootFromParent_Done,
     /* 2040451 */   // Label 27007: @2040451
     /* 2040451 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2040542), // Rule ID 17612 //
     /* 2040456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2040459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2040467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2040476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040502 */     // MIs[0] round
     /* 2040502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040505 */     // MIs[0] policy
     /* 2040505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040515 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2040518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040541 */     // GIR_Coverage, 17612,
     /* 2040541 */     GIR_EraseRootFromParent_Done,
     /* 2040542 */   // Label 27008: @2040542
     /* 2040542 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2040633), // Rule ID 17613 //
     /* 2040547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2040550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2040558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2040567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040593 */     // MIs[0] round
     /* 2040593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040596 */     // MIs[0] policy
     /* 2040596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040606 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2040609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040632 */     // GIR_Coverage, 17613,
     /* 2040632 */     GIR_EraseRootFromParent_Done,
     /* 2040633 */   // Label 27009: @2040633
     /* 2040633 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2040724), // Rule ID 17616 //
     /* 2040638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2040641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2040658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040684 */     // MIs[0] round
     /* 2040684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040687 */     // MIs[0] policy
     /* 2040687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040697 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2040700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040723 */     // GIR_Coverage, 17616,
     /* 2040723 */     GIR_EraseRootFromParent_Done,
     /* 2040724 */   // Label 27010: @2040724
     /* 2040724 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2040815), // Rule ID 17617 //
     /* 2040729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2040732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2040749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040775 */     // MIs[0] round
     /* 2040775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040778 */     // MIs[0] policy
     /* 2040778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2040791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040814 */     // GIR_Coverage, 17617,
     /* 2040814 */     GIR_EraseRootFromParent_Done,
     /* 2040815 */   // Label 27011: @2040815
     /* 2040815 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2040906), // Rule ID 17620 //
     /* 2040820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2040823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2040840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040866 */     // MIs[0] round
     /* 2040866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040869 */     // MIs[0] policy
     /* 2040869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040879 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2040882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040905 */     // GIR_Coverage, 17620,
     /* 2040905 */     GIR_EraseRootFromParent_Done,
     /* 2040906 */   // Label 27012: @2040906
     /* 2040906 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2040997), // Rule ID 17621 //
     /* 2040911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2040914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2040919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2040931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040957 */     // MIs[0] round
     /* 2040957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040960 */     // MIs[0] policy
     /* 2040960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2040973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2040977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040996 */     // GIR_Coverage, 17621,
     /* 2040996 */     GIR_EraseRootFromParent_Done,
     /* 2040997 */   // Label 27013: @2040997
     /* 2040997 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2041088), // Rule ID 17624 //
     /* 2041002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2041005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2041013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2041016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2041019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2041022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2041025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2041032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041048 */     // MIs[0] round
     /* 2041048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041051 */     // MIs[0] policy
     /* 2041051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041061 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2041064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041087 */     // GIR_Coverage, 17624,
     /* 2041087 */     GIR_EraseRootFromParent_Done,
     /* 2041088 */   // Label 27014: @2041088
     /* 2041088 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2041179), // Rule ID 17625 //
     /* 2041093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2041096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2041104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2041107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2041110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2041113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2041116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2041123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041139 */     // MIs[0] round
     /* 2041139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041142 */     // MIs[0] policy
     /* 2041142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2041155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041178 */     // GIR_Coverage, 17625,
     /* 2041178 */     GIR_EraseRootFromParent_Done,
     /* 2041179 */   // Label 27015: @2041179
     /* 2041179 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2041270), // Rule ID 17628 //
     /* 2041184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2041187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2041204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041230 */     // MIs[0] round
     /* 2041230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041233 */     // MIs[0] policy
     /* 2041233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2041246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041269 */     // GIR_Coverage, 17628,
     /* 2041269 */     GIR_EraseRootFromParent_Done,
     /* 2041270 */   // Label 27016: @2041270
     /* 2041270 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2041361), // Rule ID 17629 //
     /* 2041275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2041278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2041295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041321 */     // MIs[0] round
     /* 2041321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041324 */     // MIs[0] policy
     /* 2041324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041334 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2041337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041360 */     // GIR_Coverage, 17629,
     /* 2041360 */     GIR_EraseRootFromParent_Done,
     /* 2041361 */   // Label 27017: @2041361
     /* 2041361 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2041452), // Rule ID 17632 //
     /* 2041366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2041369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2041386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041412 */     // MIs[0] round
     /* 2041412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041415 */     // MIs[0] policy
     /* 2041415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2041428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041451 */     // GIR_Coverage, 17632,
     /* 2041451 */     GIR_EraseRootFromParent_Done,
     /* 2041452 */   // Label 27018: @2041452
     /* 2041452 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2041543), // Rule ID 17633 //
     /* 2041457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2041460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2041477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041503 */     // MIs[0] round
     /* 2041503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041506 */     // MIs[0] policy
     /* 2041506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041516 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2041519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041542 */     // GIR_Coverage, 17633,
     /* 2041542 */     GIR_EraseRootFromParent_Done,
     /* 2041543 */   // Label 27019: @2041543
     /* 2041543 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2041634), // Rule ID 17636 //
     /* 2041548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2041551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2041568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041594 */     // MIs[0] round
     /* 2041594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041597 */     // MIs[0] policy
     /* 2041597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041607 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2041610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041633 */     // GIR_Coverage, 17636,
     /* 2041633 */     GIR_EraseRootFromParent_Done,
     /* 2041634 */   // Label 27020: @2041634
     /* 2041634 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2041725), // Rule ID 17637 //
     /* 2041639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2041642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2041659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041685 */     // MIs[0] round
     /* 2041685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041688 */     // MIs[0] policy
     /* 2041688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041698 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2041701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041724 */     // GIR_Coverage, 17637,
     /* 2041724 */     GIR_EraseRootFromParent_Done,
     /* 2041725 */   // Label 27021: @2041725
     /* 2041725 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2041816), // Rule ID 17640 //
     /* 2041730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2041733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2041750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041776 */     // MIs[0] round
     /* 2041776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041779 */     // MIs[0] policy
     /* 2041779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041789 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2041792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041815 */     // GIR_Coverage, 17640,
     /* 2041815 */     GIR_EraseRootFromParent_Done,
     /* 2041816 */   // Label 27022: @2041816
     /* 2041816 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2041907), // Rule ID 17641 //
     /* 2041821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2041824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2041841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041867 */     // MIs[0] round
     /* 2041867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041870 */     // MIs[0] policy
     /* 2041870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041880 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2041883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041906 */     // GIR_Coverage, 17641,
     /* 2041906 */     GIR_EraseRootFromParent_Done,
     /* 2041907 */   // Label 27023: @2041907
     /* 2041907 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2041998), // Rule ID 17644 //
     /* 2041912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2041915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2041920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2041932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041958 */     // MIs[0] round
     /* 2041958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041961 */     // MIs[0] policy
     /* 2041961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041971 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2041974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2041978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041997 */     // GIR_Coverage, 17644,
     /* 2041997 */     GIR_EraseRootFromParent_Done,
     /* 2041998 */   // Label 27024: @2041998
     /* 2041998 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2042089), // Rule ID 17645 //
     /* 2042003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2042006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2042014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2042017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2042020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2042023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042049 */     // MIs[0] round
     /* 2042049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042052 */     // MIs[0] policy
     /* 2042052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2042065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042088 */     // GIR_Coverage, 17645,
     /* 2042088 */     GIR_EraseRootFromParent_Done,
     /* 2042089 */   // Label 27025: @2042089
     /* 2042089 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2042180), // Rule ID 17648 //
     /* 2042094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2042097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2042114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042140 */     // MIs[0] round
     /* 2042140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042143 */     // MIs[0] policy
     /* 2042143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042153 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2042156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042179 */     // GIR_Coverage, 17648,
     /* 2042179 */     GIR_EraseRootFromParent_Done,
     /* 2042180 */   // Label 27026: @2042180
     /* 2042180 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2042271), // Rule ID 17649 //
     /* 2042185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2042188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2042205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042231 */     // MIs[0] round
     /* 2042231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042234 */     // MIs[0] policy
     /* 2042234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042244 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2042247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042270 */     // GIR_Coverage, 17649,
     /* 2042270 */     GIR_EraseRootFromParent_Done,
     /* 2042271 */   // Label 27027: @2042271
     /* 2042271 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2042362), // Rule ID 17652 //
     /* 2042276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2042279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2042296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042322 */     // MIs[0] round
     /* 2042322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042325 */     // MIs[0] policy
     /* 2042325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042335 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2042338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042361 */     // GIR_Coverage, 17652,
     /* 2042361 */     GIR_EraseRootFromParent_Done,
     /* 2042362 */   // Label 27028: @2042362
     /* 2042362 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2042453), // Rule ID 17653 //
     /* 2042367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2042370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2042387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042413 */     // MIs[0] round
     /* 2042413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042416 */     // MIs[0] policy
     /* 2042416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2042429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042452 */     // GIR_Coverage, 17653,
     /* 2042452 */     GIR_EraseRootFromParent_Done,
     /* 2042453 */   // Label 27029: @2042453
     /* 2042453 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2042544), // Rule ID 17656 //
     /* 2042458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2042461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2042478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042504 */     // MIs[0] round
     /* 2042504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042507 */     // MIs[0] policy
     /* 2042507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042517 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2042520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042543 */     // GIR_Coverage, 17656,
     /* 2042543 */     GIR_EraseRootFromParent_Done,
     /* 2042544 */   // Label 27030: @2042544
     /* 2042544 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2042635), // Rule ID 17657 //
     /* 2042549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2042552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2042569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042595 */     // MIs[0] round
     /* 2042595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042598 */     // MIs[0] policy
     /* 2042598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042608 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2042611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042634 */     // GIR_Coverage, 17657,
     /* 2042634 */     GIR_EraseRootFromParent_Done,
     /* 2042635 */   // Label 27031: @2042635
     /* 2042635 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2042726), // Rule ID 17660 //
     /* 2042640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2042643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2042660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042686 */     // MIs[0] round
     /* 2042686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042689 */     // MIs[0] policy
     /* 2042689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2042702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042725 */     // GIR_Coverage, 17660,
     /* 2042725 */     GIR_EraseRootFromParent_Done,
     /* 2042726 */   // Label 27032: @2042726
     /* 2042726 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2042817), // Rule ID 17661 //
     /* 2042731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2042734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2042751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042777 */     // MIs[0] round
     /* 2042777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042780 */     // MIs[0] policy
     /* 2042780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042790 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2042793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042816 */     // GIR_Coverage, 17661,
     /* 2042816 */     GIR_EraseRootFromParent_Done,
     /* 2042817 */   // Label 27033: @2042817
     /* 2042817 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2042908), // Rule ID 17664 //
     /* 2042822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2042825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2042839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2042860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042868 */     // MIs[0] round
     /* 2042868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042871 */     // MIs[0] policy
     /* 2042871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042881 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2042884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042907 */     // GIR_Coverage, 17664,
     /* 2042907 */     GIR_EraseRootFromParent_Done,
     /* 2042908 */   // Label 27034: @2042908
     /* 2042908 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2042999), // Rule ID 17665 //
     /* 2042913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2042916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2042921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2042930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2042951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042959 */     // MIs[0] round
     /* 2042959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042962 */     // MIs[0] policy
     /* 2042962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042972 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2042975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2042979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042998 */     // GIR_Coverage, 17665,
     /* 2042998 */     GIR_EraseRootFromParent_Done,
     /* 2042999 */   // Label 27035: @2042999
     /* 2042999 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2043090), // Rule ID 17668 //
     /* 2043004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2043007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2043021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2043042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043050 */     // MIs[0] round
     /* 2043050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043053 */     // MIs[0] policy
     /* 2043053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043063 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2043066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043089 */     // GIR_Coverage, 17668,
     /* 2043089 */     GIR_EraseRootFromParent_Done,
     /* 2043090 */   // Label 27036: @2043090
     /* 2043090 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2043181), // Rule ID 17669 //
     /* 2043095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2043098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2043112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2043133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043141 */     // MIs[0] round
     /* 2043141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043144 */     // MIs[0] policy
     /* 2043144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043154 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2043157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043180 */     // GIR_Coverage, 17669,
     /* 2043180 */     GIR_EraseRootFromParent_Done,
     /* 2043181 */   // Label 27037: @2043181
     /* 2043181 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2043272), // Rule ID 17672 //
     /* 2043186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2043189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2043203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2043224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043232 */     // MIs[0] round
     /* 2043232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043235 */     // MIs[0] policy
     /* 2043235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043245 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2043248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043271 */     // GIR_Coverage, 17672,
     /* 2043271 */     GIR_EraseRootFromParent_Done,
     /* 2043272 */   // Label 27038: @2043272
     /* 2043272 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2043363), // Rule ID 17673 //
     /* 2043277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2043280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2043294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2043315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043323 */     // MIs[0] round
     /* 2043323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043326 */     // MIs[0] policy
     /* 2043326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043336 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2043339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043362 */     // GIR_Coverage, 17673,
     /* 2043362 */     GIR_EraseRootFromParent_Done,
     /* 2043363 */   // Label 27039: @2043363
     /* 2043363 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2043454), // Rule ID 17676 //
     /* 2043368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2043371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2043385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2043406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043414 */     // MIs[0] round
     /* 2043414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043417 */     // MIs[0] policy
     /* 2043417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2043430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043453 */     // GIR_Coverage, 17676,
     /* 2043453 */     GIR_EraseRootFromParent_Done,
     /* 2043454 */   // Label 27040: @2043454
     /* 2043454 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2043545), // Rule ID 17677 //
     /* 2043459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2043462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2043476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2043497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043505 */     // MIs[0] round
     /* 2043505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043508 */     // MIs[0] policy
     /* 2043508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043518 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10897:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2043521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043544 */     // GIR_Coverage, 17677,
     /* 2043544 */     GIR_EraseRootFromParent_Done,
     /* 2043545 */   // Label 27041: @2043545
     /* 2043545 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2043636), // Rule ID 17680 //
     /* 2043550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2043553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2043567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2043588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043596 */     // MIs[0] round
     /* 2043596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043599 */     // MIs[0] policy
     /* 2043599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043609 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2043612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043635 */     // GIR_Coverage, 17680,
     /* 2043635 */     GIR_EraseRootFromParent_Done,
     /* 2043636 */   // Label 27042: @2043636
     /* 2043636 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2043727), // Rule ID 17681 //
     /* 2043641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2043644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2043658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2043679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043687 */     // MIs[0] round
     /* 2043687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043690 */     // MIs[0] policy
     /* 2043690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2043703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043726 */     // GIR_Coverage, 17681,
     /* 2043726 */     GIR_EraseRootFromParent_Done,
     /* 2043727 */   // Label 27043: @2043727
     /* 2043727 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2043818), // Rule ID 17684 //
     /* 2043732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2043735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2043749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2043752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2043770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043778 */     // MIs[0] round
     /* 2043778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043781 */     // MIs[0] policy
     /* 2043781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043791 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2043794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043817 */     // GIR_Coverage, 17684,
     /* 2043817 */     GIR_EraseRootFromParent_Done,
     /* 2043818 */   // Label 27044: @2043818
     /* 2043818 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2043909), // Rule ID 17685 //
     /* 2043823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2043826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2043840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2043843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2043861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043869 */     // MIs[0] round
     /* 2043869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043872 */     // MIs[0] policy
     /* 2043872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043882 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2043885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043908 */     // GIR_Coverage, 17685,
     /* 2043908 */     GIR_EraseRootFromParent_Done,
     /* 2043909 */   // Label 27045: @2043909
     /* 2043909 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2044000), // Rule ID 17688 //
     /* 2043914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2043917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2043922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2043925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2043928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2043931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2043934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2043944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2043952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043960 */     // MIs[0] round
     /* 2043960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043963 */     // MIs[0] policy
     /* 2043963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043973 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2043976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2043980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043999 */     // GIR_Coverage, 17688,
     /* 2043999 */     GIR_EraseRootFromParent_Done,
     /* 2044000 */   // Label 27046: @2044000
     /* 2044000 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2044091), // Rule ID 17689 //
     /* 2044005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2044008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2044022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2044025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2044043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044051 */     // MIs[0] round
     /* 2044051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044054 */     // MIs[0] policy
     /* 2044054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044064 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2044067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044090 */     // GIR_Coverage, 17689,
     /* 2044090 */     GIR_EraseRootFromParent_Done,
     /* 2044091 */   // Label 27047: @2044091
     /* 2044091 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2044182), // Rule ID 17692 //
     /* 2044096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2044099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2044113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2044134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044142 */     // MIs[0] round
     /* 2044142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044145 */     // MIs[0] policy
     /* 2044145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044155 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2044158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044181 */     // GIR_Coverage, 17692,
     /* 2044181 */     GIR_EraseRootFromParent_Done,
     /* 2044182 */   // Label 27048: @2044182
     /* 2044182 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2044273), // Rule ID 17693 //
     /* 2044187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2044190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2044204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2044225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044233 */     // MIs[0] round
     /* 2044233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044236 */     // MIs[0] policy
     /* 2044236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044246 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2044249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044272 */     // GIR_Coverage, 17693,
     /* 2044272 */     GIR_EraseRootFromParent_Done,
     /* 2044273 */   // Label 27049: @2044273
     /* 2044273 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2044364), // Rule ID 17696 //
     /* 2044278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2044281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2044289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2044292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2044295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2044298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2044316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044324 */     // MIs[0] round
     /* 2044324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044327 */     // MIs[0] policy
     /* 2044327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044337 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2044340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044363 */     // GIR_Coverage, 17696,
     /* 2044363 */     GIR_EraseRootFromParent_Done,
     /* 2044364 */   // Label 27050: @2044364
     /* 2044364 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2044455), // Rule ID 17697 //
     /* 2044369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2044372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2044380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2044383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2044386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2044389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2044407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044415 */     // MIs[0] round
     /* 2044415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044418 */     // MIs[0] policy
     /* 2044418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044428 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2044431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044454 */     // GIR_Coverage, 17697,
     /* 2044454 */     GIR_EraseRootFromParent_Done,
     /* 2044455 */   // Label 27051: @2044455
     /* 2044455 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2044546), // Rule ID 17700 //
     /* 2044460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2044463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2044471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2044474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2044480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044506 */     // MIs[0] round
     /* 2044506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044509 */     // MIs[0] policy
     /* 2044509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044519 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2044522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044545 */     // GIR_Coverage, 17700,
     /* 2044545 */     GIR_EraseRootFromParent_Done,
     /* 2044546 */   // Label 27052: @2044546
     /* 2044546 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2044637), // Rule ID 17701 //
     /* 2044551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2044554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2044562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2044565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2044571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044597 */     // MIs[0] round
     /* 2044597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044600 */     // MIs[0] policy
     /* 2044600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2044613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044636 */     // GIR_Coverage, 17701,
     /* 2044636 */     GIR_EraseRootFromParent_Done,
     /* 2044637 */   // Label 27053: @2044637
     /* 2044637 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2044728), // Rule ID 17704 //
     /* 2044642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2044645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2044653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2044656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2044662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044688 */     // MIs[0] round
     /* 2044688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044691 */     // MIs[0] policy
     /* 2044691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044701 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2044704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044727 */     // GIR_Coverage, 17704,
     /* 2044727 */     GIR_EraseRootFromParent_Done,
     /* 2044728 */   // Label 27054: @2044728
     /* 2044728 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2044819), // Rule ID 17705 //
     /* 2044733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2044736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2044744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2044747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2044753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044779 */     // MIs[0] round
     /* 2044779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044782 */     // MIs[0] policy
     /* 2044782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044792 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2044795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044818 */     // GIR_Coverage, 17705,
     /* 2044818 */     GIR_EraseRootFromParent_Done,
     /* 2044819 */   // Label 27055: @2044819
     /* 2044819 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2044910), // Rule ID 17708 //
     /* 2044824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2044827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2044835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2044838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2044844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044870 */     // MIs[0] round
     /* 2044870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044873 */     // MIs[0] policy
     /* 2044873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044883 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2044886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044909 */     // GIR_Coverage, 17708,
     /* 2044909 */     GIR_EraseRootFromParent_Done,
     /* 2044910 */   // Label 27056: @2044910
     /* 2044910 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2045001), // Rule ID 17709 //
     /* 2044915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2044918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2044923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2044926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2044929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2044932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2044935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2044953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044961 */     // MIs[0] round
     /* 2044961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044964 */     // MIs[0] policy
     /* 2044964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044974 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2044977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2044981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045000 */     // GIR_Coverage, 17709,
     /* 2045000 */     GIR_EraseRootFromParent_Done,
     /* 2045001 */   // Label 27057: @2045001
     /* 2045001 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2045092), // Rule ID 17712 //
     /* 2045006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2045009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045052 */     // MIs[0] round
     /* 2045052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045055 */     // MIs[0] policy
     /* 2045055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045065 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2045068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045091 */     // GIR_Coverage, 17712,
     /* 2045091 */     GIR_EraseRootFromParent_Done,
     /* 2045092 */   // Label 27058: @2045092
     /* 2045092 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2045183), // Rule ID 17713 //
     /* 2045097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2045100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045143 */     // MIs[0] round
     /* 2045143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045146 */     // MIs[0] policy
     /* 2045146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2045159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045182 */     // GIR_Coverage, 17713,
     /* 2045182 */     GIR_EraseRootFromParent_Done,
     /* 2045183 */   // Label 27059: @2045183
     /* 2045183 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2045274), // Rule ID 17716 //
     /* 2045188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2045191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2045208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045234 */     // MIs[0] round
     /* 2045234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045237 */     // MIs[0] policy
     /* 2045237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045247 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2045250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045273 */     // GIR_Coverage, 17716,
     /* 2045273 */     GIR_EraseRootFromParent_Done,
     /* 2045274 */   // Label 27060: @2045274
     /* 2045274 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2045365), // Rule ID 17717 //
     /* 2045279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2045282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2045299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045325 */     // MIs[0] round
     /* 2045325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045328 */     // MIs[0] policy
     /* 2045328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045338 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2045341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045364 */     // GIR_Coverage, 17717,
     /* 2045364 */     GIR_EraseRootFromParent_Done,
     /* 2045365 */   // Label 27061: @2045365
     /* 2045365 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2045456), // Rule ID 17720 //
     /* 2045370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2045373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2045381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2045384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2045390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045416 */     // MIs[0] round
     /* 2045416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045419 */     // MIs[0] policy
     /* 2045419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045429 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2045432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045455 */     // GIR_Coverage, 17720,
     /* 2045455 */     GIR_EraseRootFromParent_Done,
     /* 2045456 */   // Label 27062: @2045456
     /* 2045456 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2045547), // Rule ID 17721 //
     /* 2045461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2045464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2045469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2045472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2045475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2045478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2045481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2045499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045507 */     // MIs[0] round
     /* 2045507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045510 */     // MIs[0] policy
     /* 2045510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045520 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2045523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045546 */     // GIR_Coverage, 17721,
     /* 2045546 */     GIR_EraseRootFromParent_Done,
     /* 2045547 */   // Label 27063: @2045547
     /* 2045547 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2045638), // Rule ID 17724 //
     /* 2045552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2045555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2045560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2045563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2045566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2045569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2045572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2045575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045598 */     // MIs[0] round
     /* 2045598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045601 */     // MIs[0] policy
     /* 2045601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045611 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2045614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045637 */     // GIR_Coverage, 17724,
     /* 2045637 */     GIR_EraseRootFromParent_Done,
     /* 2045638 */   // Label 27064: @2045638
     /* 2045638 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2045729), // Rule ID 17725 //
     /* 2045643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2045646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2045651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2045654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2045657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2045660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2045663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2045666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045689 */     // MIs[0] round
     /* 2045689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045692 */     // MIs[0] policy
     /* 2045692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045702 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2045705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045728 */     // GIR_Coverage, 17725,
     /* 2045728 */     GIR_EraseRootFromParent_Done,
     /* 2045729 */   // Label 27065: @2045729
     /* 2045729 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2045820), // Rule ID 17728 //
     /* 2045734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2045737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2045742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2045745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2045748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2045751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2045754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045780 */     // MIs[0] round
     /* 2045780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045783 */     // MIs[0] policy
     /* 2045783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045793 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2045796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045819 */     // GIR_Coverage, 17728,
     /* 2045819 */     GIR_EraseRootFromParent_Done,
     /* 2045820 */   // Label 27066: @2045820
     /* 2045820 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2045911), // Rule ID 17729 //
     /* 2045825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2045828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2045833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2045836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2045839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2045842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2045845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045871 */     // MIs[0] round
     /* 2045871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045874 */     // MIs[0] policy
     /* 2045874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045884 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2045887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045910 */     // GIR_Coverage, 17729,
     /* 2045910 */     GIR_EraseRootFromParent_Done,
     /* 2045911 */   // Label 27067: @2045911
     /* 2045911 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2046002), // Rule ID 17732 //
     /* 2045916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2045919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2045924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2045927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2045930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2045933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2045936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2045939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045962 */     // MIs[0] round
     /* 2045962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045965 */     // MIs[0] policy
     /* 2045965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045975 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2045978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2045982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046001 */     // GIR_Coverage, 17732,
     /* 2046001 */     GIR_EraseRootFromParent_Done,
     /* 2046002 */   // Label 27068: @2046002
     /* 2046002 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2046093), // Rule ID 17733 //
     /* 2046007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2046010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2046018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2046021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2046024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2046027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046053 */     // MIs[0] round
     /* 2046053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046056 */     // MIs[0] policy
     /* 2046056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046066 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2046069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046092 */     // GIR_Coverage, 17733,
     /* 2046092 */     GIR_EraseRootFromParent_Done,
     /* 2046093 */   // Label 27069: @2046093
     /* 2046093 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2046184), // Rule ID 17736 //
     /* 2046098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2046101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2046109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2046112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2046115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2046118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046144 */     // MIs[0] round
     /* 2046144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046147 */     // MIs[0] policy
     /* 2046147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046157 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2046160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046183 */     // GIR_Coverage, 17736,
     /* 2046183 */     GIR_EraseRootFromParent_Done,
     /* 2046184 */   // Label 27070: @2046184
     /* 2046184 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2046275), // Rule ID 17737 //
     /* 2046189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2046192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2046200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2046203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2046206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2046209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046235 */     // MIs[0] round
     /* 2046235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046238 */     // MIs[0] policy
     /* 2046238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2046251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046274 */     // GIR_Coverage, 17737,
     /* 2046274 */     GIR_EraseRootFromParent_Done,
     /* 2046275 */   // Label 27071: @2046275
     /* 2046275 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2046366), // Rule ID 17740 //
     /* 2046280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2046283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2046291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2046294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2046297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2046300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046326 */     // MIs[0] round
     /* 2046326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046329 */     // MIs[0] policy
     /* 2046329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2046342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046365 */     // GIR_Coverage, 17740,
     /* 2046365 */     GIR_EraseRootFromParent_Done,
     /* 2046366 */   // Label 27072: @2046366
     /* 2046366 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2046457), // Rule ID 17741 //
     /* 2046371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2046374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2046382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2046385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2046388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2046391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046417 */     // MIs[0] round
     /* 2046417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046420 */     // MIs[0] policy
     /* 2046420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046430 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2046433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046456 */     // GIR_Coverage, 17741,
     /* 2046456 */     GIR_EraseRootFromParent_Done,
     /* 2046457 */   // Label 27073: @2046457
     /* 2046457 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2046548), // Rule ID 17744 //
     /* 2046462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2046465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2046473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2046476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2046479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2046482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046508 */     // MIs[0] round
     /* 2046508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046511 */     // MIs[0] policy
     /* 2046511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046521 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2046524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046547 */     // GIR_Coverage, 17744,
     /* 2046547 */     GIR_EraseRootFromParent_Done,
     /* 2046548 */   // Label 27074: @2046548
     /* 2046548 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2046639), // Rule ID 17745 //
     /* 2046553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2046556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2046564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2046567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2046570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2046573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046599 */     // MIs[0] round
     /* 2046599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046602 */     // MIs[0] policy
     /* 2046602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046612 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2046615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046638 */     // GIR_Coverage, 17745,
     /* 2046638 */     GIR_EraseRootFromParent_Done,
     /* 2046639 */   // Label 27075: @2046639
     /* 2046639 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2046730), // Rule ID 17748 //
     /* 2046644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2046647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2046655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2046658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2046661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2046664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046690 */     // MIs[0] round
     /* 2046690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046693 */     // MIs[0] policy
     /* 2046693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046703 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2046706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046729 */     // GIR_Coverage, 17748,
     /* 2046729 */     GIR_EraseRootFromParent_Done,
     /* 2046730 */   // Label 27076: @2046730
     /* 2046730 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2046821), // Rule ID 17749 //
     /* 2046735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2046738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2046746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2046749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2046752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2046755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046781 */     // MIs[0] round
     /* 2046781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046784 */     // MIs[0] policy
     /* 2046784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046794 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2046797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046820 */     // GIR_Coverage, 17749,
     /* 2046820 */     GIR_EraseRootFromParent_Done,
     /* 2046821 */   // Label 27077: @2046821
     /* 2046821 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2046912), // Rule ID 17752 //
     /* 2046826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2046829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2046837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2046840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2046843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2046846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046872 */     // MIs[0] round
     /* 2046872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046875 */     // MIs[0] policy
     /* 2046875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046885 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2046888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046911 */     // GIR_Coverage, 17752,
     /* 2046911 */     GIR_EraseRootFromParent_Done,
     /* 2046912 */   // Label 27078: @2046912
     /* 2046912 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2047003), // Rule ID 17753 //
     /* 2046917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2046920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2046925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2046928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2046931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2046934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2046937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046963 */     // MIs[0] round
     /* 2046963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046966 */     // MIs[0] policy
     /* 2046966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046976 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2046979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2046983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047002 */     // GIR_Coverage, 17753,
     /* 2047002 */     GIR_EraseRootFromParent_Done,
     /* 2047003 */   // Label 27079: @2047003
     /* 2047003 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2047094), // Rule ID 17756 //
     /* 2047008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2047011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2047019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2047022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2047025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2047028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2047031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047054 */     // MIs[0] round
     /* 2047054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047057 */     // MIs[0] policy
     /* 2047057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047067 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2047070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047093 */     // GIR_Coverage, 17756,
     /* 2047093 */     GIR_EraseRootFromParent_Done,
     /* 2047094 */   // Label 27080: @2047094
     /* 2047094 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2047185), // Rule ID 17757 //
     /* 2047099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2047102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2047110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2047113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2047116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2047119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2047122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047145 */     // MIs[0] round
     /* 2047145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047148 */     // MIs[0] policy
     /* 2047148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047158 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2047161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047184 */     // GIR_Coverage, 17757,
     /* 2047184 */     GIR_EraseRootFromParent_Done,
     /* 2047185 */   // Label 27081: @2047185
     /* 2047185 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2047276), // Rule ID 17760 //
     /* 2047190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2047193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2047201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2047204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2047207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2047210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047236 */     // MIs[0] round
     /* 2047236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047239 */     // MIs[0] policy
     /* 2047239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047249 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2047252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047275 */     // GIR_Coverage, 17760,
     /* 2047275 */     GIR_EraseRootFromParent_Done,
     /* 2047276 */   // Label 27082: @2047276
     /* 2047276 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2047367), // Rule ID 17761 //
     /* 2047281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2047284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2047292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2047295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2047298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2047301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047327 */     // MIs[0] round
     /* 2047327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047330 */     // MIs[0] policy
     /* 2047330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2047343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047366 */     // GIR_Coverage, 17761,
     /* 2047366 */     GIR_EraseRootFromParent_Done,
     /* 2047367 */   // Label 27083: @2047367
     /* 2047367 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2047458), // Rule ID 17764 //
     /* 2047372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2047375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2047383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2047386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2047389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2047392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2047402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047418 */     // MIs[0] round
     /* 2047418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047421 */     // MIs[0] policy
     /* 2047421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047431 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2047434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047457 */     // GIR_Coverage, 17764,
     /* 2047457 */     GIR_EraseRootFromParent_Done,
     /* 2047458 */   // Label 27084: @2047458
     /* 2047458 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2047549), // Rule ID 17765 //
     /* 2047463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2047466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2047474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2047477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2047480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2047483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2047493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047509 */     // MIs[0] round
     /* 2047509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047512 */     // MIs[0] policy
     /* 2047512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2047525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047548 */     // GIR_Coverage, 17765,
     /* 2047548 */     GIR_EraseRootFromParent_Done,
     /* 2047549 */   // Label 27085: @2047549
     /* 2047549 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2047640), // Rule ID 17768 //
     /* 2047554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2047557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2047565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2047568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2047571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2047574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2047577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047600 */     // MIs[0] round
     /* 2047600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047603 */     // MIs[0] policy
     /* 2047603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047613 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2047616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047639 */     // GIR_Coverage, 17768,
     /* 2047639 */     GIR_EraseRootFromParent_Done,
     /* 2047640 */   // Label 27086: @2047640
     /* 2047640 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2047731), // Rule ID 17769 //
     /* 2047645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2047648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2047656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2047659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2047662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2047665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2047668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047691 */     // MIs[0] round
     /* 2047691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047694 */     // MIs[0] policy
     /* 2047694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047704 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2047707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047730 */     // GIR_Coverage, 17769,
     /* 2047730 */     GIR_EraseRootFromParent_Done,
     /* 2047731 */   // Label 27087: @2047731
     /* 2047731 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2047822), // Rule ID 17772 //
     /* 2047736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2047739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2047747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2047750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2047753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2047756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047782 */     // MIs[0] round
     /* 2047782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047785 */     // MIs[0] policy
     /* 2047785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047795 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2047798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047821 */     // GIR_Coverage, 17772,
     /* 2047821 */     GIR_EraseRootFromParent_Done,
     /* 2047822 */   // Label 27088: @2047822
     /* 2047822 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2047913), // Rule ID 17773 //
     /* 2047827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2047830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2047838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2047841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2047844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2047847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047873 */     // MIs[0] round
     /* 2047873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047876 */     // MIs[0] policy
     /* 2047876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047886 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2047889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047912 */     // GIR_Coverage, 17773,
     /* 2047912 */     GIR_EraseRootFromParent_Done,
     /* 2047913 */   // Label 27089: @2047913
     /* 2047913 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2048004), // Rule ID 17776 //
     /* 2047918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2047921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2047926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2047929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2047932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2047935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2047938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2047948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047964 */     // MIs[0] round
     /* 2047964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047967 */     // MIs[0] policy
     /* 2047967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047977 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2047980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2047984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048003 */     // GIR_Coverage, 17776,
     /* 2048003 */     GIR_EraseRootFromParent_Done,
     /* 2048004 */   // Label 27090: @2048004
     /* 2048004 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2048095), // Rule ID 17777 //
     /* 2048009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2048012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2048020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2048023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2048026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2048029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048055 */     // MIs[0] round
     /* 2048055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048058 */     // MIs[0] policy
     /* 2048058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048068 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2048071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048094 */     // GIR_Coverage, 17777,
     /* 2048094 */     GIR_EraseRootFromParent_Done,
     /* 2048095 */   // Label 27091: @2048095
     /* 2048095 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2048186), // Rule ID 17780 //
     /* 2048100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2048103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2048111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2048114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2048117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2048120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048146 */     // MIs[0] round
     /* 2048146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048149 */     // MIs[0] policy
     /* 2048149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048159 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2048162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048185 */     // GIR_Coverage, 17780,
     /* 2048185 */     GIR_EraseRootFromParent_Done,
     /* 2048186 */   // Label 27092: @2048186
     /* 2048186 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2048277), // Rule ID 17781 //
     /* 2048191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2048194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2048202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2048205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2048208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2048211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048237 */     // MIs[0] round
     /* 2048237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048240 */     // MIs[0] policy
     /* 2048240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048250 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2048253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048276 */     // GIR_Coverage, 17781,
     /* 2048276 */     GIR_EraseRootFromParent_Done,
     /* 2048277 */   // Label 27093: @2048277
     /* 2048277 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2048368), // Rule ID 17784 //
     /* 2048282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2048285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2048293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2048296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2048302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048328 */     // MIs[0] round
     /* 2048328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048331 */     // MIs[0] policy
     /* 2048331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048341 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2048344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048367 */     // GIR_Coverage, 17784,
     /* 2048367 */     GIR_EraseRootFromParent_Done,
     /* 2048368 */   // Label 27094: @2048368
     /* 2048368 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2048459), // Rule ID 17785 //
     /* 2048373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2048376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2048384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2048387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2048393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048419 */     // MIs[0] round
     /* 2048419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048422 */     // MIs[0] policy
     /* 2048422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048432 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2048435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048458 */     // GIR_Coverage, 17785,
     /* 2048458 */     GIR_EraseRootFromParent_Done,
     /* 2048459 */   // Label 27095: @2048459
     /* 2048459 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2048550), // Rule ID 17788 //
     /* 2048464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2048467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2048475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2048478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2048484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048510 */     // MIs[0] round
     /* 2048510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048513 */     // MIs[0] policy
     /* 2048513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048523 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2048526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048549 */     // GIR_Coverage, 17788,
     /* 2048549 */     GIR_EraseRootFromParent_Done,
     /* 2048550 */   // Label 27096: @2048550
     /* 2048550 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2048641), // Rule ID 17789 //
     /* 2048555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2048558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2048566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2048569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2048575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048601 */     // MIs[0] round
     /* 2048601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048604 */     // MIs[0] policy
     /* 2048604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048614 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2048617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048640 */     // GIR_Coverage, 17789,
     /* 2048640 */     GIR_EraseRootFromParent_Done,
     /* 2048641 */   // Label 27097: @2048641
     /* 2048641 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2048732), // Rule ID 17792 //
     /* 2048646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2048649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2048663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2048666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2048684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048692 */     // MIs[0] round
     /* 2048692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048695 */     // MIs[0] policy
     /* 2048695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048705 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2048708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048731 */     // GIR_Coverage, 17792,
     /* 2048731 */     GIR_EraseRootFromParent_Done,
     /* 2048732 */   // Label 27098: @2048732
     /* 2048732 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2048823), // Rule ID 17793 //
     /* 2048737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2048740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2048754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2048757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2048775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048783 */     // MIs[0] round
     /* 2048783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048786 */     // MIs[0] policy
     /* 2048786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2048799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048822 */     // GIR_Coverage, 17793,
     /* 2048822 */     GIR_EraseRootFromParent_Done,
     /* 2048823 */   // Label 27099: @2048823
     /* 2048823 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2048914), // Rule ID 17796 //
     /* 2048828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2048831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2048848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048874 */     // MIs[0] round
     /* 2048874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048877 */     // MIs[0] policy
     /* 2048877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048887 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2048890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048913 */     // GIR_Coverage, 17796,
     /* 2048913 */     GIR_EraseRootFromParent_Done,
     /* 2048914 */   // Label 27100: @2048914
     /* 2048914 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2049005), // Rule ID 17797 //
     /* 2048919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2048922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2048927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2048936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2048939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2048957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048965 */     // MIs[0] round
     /* 2048965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048968 */     // MIs[0] policy
     /* 2048968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048978 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10933:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2048981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2048985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049004 */     // GIR_Coverage, 17797,
     /* 2049004 */     GIR_EraseRootFromParent_Done,
     /* 2049005 */   // Label 27101: @2049005
     /* 2049005 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2049096), // Rule ID 17800 //
     /* 2049010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2049013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2049021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2049024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2049027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2049030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2049048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049056 */     // MIs[0] round
     /* 2049056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049059 */     // MIs[0] policy
     /* 2049059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049069 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2049072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049095 */     // GIR_Coverage, 17800,
     /* 2049095 */     GIR_EraseRootFromParent_Done,
     /* 2049096 */   // Label 27102: @2049096
     /* 2049096 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2049187), // Rule ID 17801 //
     /* 2049101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2049104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2049112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2049115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2049118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2049121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2049139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049147 */     // MIs[0] round
     /* 2049147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049150 */     // MIs[0] policy
     /* 2049150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049160 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10933:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2049163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049186 */     // GIR_Coverage, 17801,
     /* 2049186 */     GIR_EraseRootFromParent_Done,
     /* 2049187 */   // Label 27103: @2049187
     /* 2049187 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2049278), // Rule ID 17804 //
     /* 2049192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2049195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2049203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2049206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2049209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2049212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2049215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2049230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049238 */     // MIs[0] round
     /* 2049238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049241 */     // MIs[0] policy
     /* 2049241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049251 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2049254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049277 */     // GIR_Coverage, 17804,
     /* 2049277 */     GIR_EraseRootFromParent_Done,
     /* 2049278 */   // Label 27104: @2049278
     /* 2049278 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2049369), // Rule ID 17805 //
     /* 2049283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2049286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2049294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2049297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2049300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2049303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2049306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2049321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049329 */     // MIs[0] round
     /* 2049329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049332 */     // MIs[0] policy
     /* 2049332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10933:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2049345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049368 */     // GIR_Coverage, 17805,
     /* 2049368 */     GIR_EraseRootFromParent_Done,
     /* 2049369 */   // Label 27105: @2049369
     /* 2049369 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2049460), // Rule ID 17808 //
     /* 2049374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2049377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2049394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049420 */     // MIs[0] round
     /* 2049420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049423 */     // MIs[0] policy
     /* 2049423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049433 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2049436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049459 */     // GIR_Coverage, 17808,
     /* 2049459 */     GIR_EraseRootFromParent_Done,
     /* 2049460 */   // Label 27106: @2049460
     /* 2049460 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2049551), // Rule ID 17809 //
     /* 2049465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2049468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2049485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049511 */     // MIs[0] round
     /* 2049511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049514 */     // MIs[0] policy
     /* 2049514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049524 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2049527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049550 */     // GIR_Coverage, 17809,
     /* 2049550 */     GIR_EraseRootFromParent_Done,
     /* 2049551 */   // Label 27107: @2049551
     /* 2049551 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2049642), // Rule ID 17812 //
     /* 2049556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2049559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2049576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049602 */     // MIs[0] round
     /* 2049602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049605 */     // MIs[0] policy
     /* 2049605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049615 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2049618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049641 */     // GIR_Coverage, 17812,
     /* 2049641 */     GIR_EraseRootFromParent_Done,
     /* 2049642 */   // Label 27108: @2049642
     /* 2049642 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2049733), // Rule ID 17813 //
     /* 2049647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2049650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2049667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049693 */     // MIs[0] round
     /* 2049693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049696 */     // MIs[0] policy
     /* 2049696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049706 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2049709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049732 */     // GIR_Coverage, 17813,
     /* 2049732 */     GIR_EraseRootFromParent_Done,
     /* 2049733 */   // Label 27109: @2049733
     /* 2049733 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2049824), // Rule ID 17816 //
     /* 2049738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2049741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2049758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049784 */     // MIs[0] round
     /* 2049784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049787 */     // MIs[0] policy
     /* 2049787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049797 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2049800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049823 */     // GIR_Coverage, 17816,
     /* 2049823 */     GIR_EraseRootFromParent_Done,
     /* 2049824 */   // Label 27110: @2049824
     /* 2049824 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2049915), // Rule ID 17817 //
     /* 2049829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2049832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2049846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2049849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2049867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049875 */     // MIs[0] round
     /* 2049875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049878 */     // MIs[0] policy
     /* 2049878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049888 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2049891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049914 */     // GIR_Coverage, 17817,
     /* 2049914 */     GIR_EraseRootFromParent_Done,
     /* 2049915 */   // Label 27111: @2049915
     /* 2049915 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2050006), // Rule ID 17820 //
     /* 2049920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2049923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2049928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2049937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2049940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2049958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049966 */     // MIs[0] round
     /* 2049966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049969 */     // MIs[0] policy
     /* 2049969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049979 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2049982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2049986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050005 */     // GIR_Coverage, 17820,
     /* 2050005 */     GIR_EraseRootFromParent_Done,
     /* 2050006 */   // Label 27112: @2050006
     /* 2050006 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2050097), // Rule ID 17821 //
     /* 2050011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2050014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2050022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2050025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2050028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2050031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2050049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050057 */     // MIs[0] round
     /* 2050057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050060 */     // MIs[0] policy
     /* 2050060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2050073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050096 */     // GIR_Coverage, 17821,
     /* 2050096 */     GIR_EraseRootFromParent_Done,
     /* 2050097 */   // Label 27113: @2050097
     /* 2050097 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2050188), // Rule ID 17824 //
     /* 2050102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2050105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2050119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2050122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2050140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050148 */     // MIs[0] round
     /* 2050148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050151 */     // MIs[0] policy
     /* 2050151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050161 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2050164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050187 */     // GIR_Coverage, 17824,
     /* 2050187 */     GIR_EraseRootFromParent_Done,
     /* 2050188 */   // Label 27114: @2050188
     /* 2050188 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2050279), // Rule ID 17825 //
     /* 2050193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2050196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2050210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2050213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2050231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050239 */     // MIs[0] round
     /* 2050239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050242 */     // MIs[0] policy
     /* 2050242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2050255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050278 */     // GIR_Coverage, 17825,
     /* 2050278 */     GIR_EraseRootFromParent_Done,
     /* 2050279 */   // Label 27115: @2050279
     /* 2050279 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2050370), // Rule ID 17828 //
     /* 2050284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2050287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2050301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2050304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2050322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050330 */     // MIs[0] round
     /* 2050330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050333 */     // MIs[0] policy
     /* 2050333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050343 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2050346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050369 */     // GIR_Coverage, 17828,
     /* 2050369 */     GIR_EraseRootFromParent_Done,
     /* 2050370 */   // Label 27116: @2050370
     /* 2050370 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2050461), // Rule ID 17829 //
     /* 2050375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2050378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2050392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2050395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2050413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050421 */     // MIs[0] round
     /* 2050421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050424 */     // MIs[0] policy
     /* 2050424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050434 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2050437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050460 */     // GIR_Coverage, 17829,
     /* 2050460 */     GIR_EraseRootFromParent_Done,
     /* 2050461 */   // Label 27117: @2050461
     /* 2050461 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2050552), // Rule ID 17832 //
     /* 2050466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2050469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2050486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050512 */     // MIs[0] round
     /* 2050512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050515 */     // MIs[0] policy
     /* 2050515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050525 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2050528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050551 */     // GIR_Coverage, 17832,
     /* 2050551 */     GIR_EraseRootFromParent_Done,
     /* 2050552 */   // Label 27118: @2050552
     /* 2050552 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2050643), // Rule ID 17833 //
     /* 2050557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2050560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2050577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050603 */     // MIs[0] round
     /* 2050603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050606 */     // MIs[0] policy
     /* 2050606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10933:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2050619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050642 */     // GIR_Coverage, 17833,
     /* 2050642 */     GIR_EraseRootFromParent_Done,
     /* 2050643 */   // Label 27119: @2050643
     /* 2050643 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2050734), // Rule ID 17836 //
     /* 2050648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2050651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2050668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050694 */     // MIs[0] round
     /* 2050694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050697 */     // MIs[0] policy
     /* 2050697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050707 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2050710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050733 */     // GIR_Coverage, 17836,
     /* 2050733 */     GIR_EraseRootFromParent_Done,
     /* 2050734 */   // Label 27120: @2050734
     /* 2050734 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2050825), // Rule ID 17837 //
     /* 2050739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2050742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2050759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050785 */     // MIs[0] round
     /* 2050785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050788 */     // MIs[0] policy
     /* 2050788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050798 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10933:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2050801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050824 */     // GIR_Coverage, 17837,
     /* 2050824 */     GIR_EraseRootFromParent_Done,
     /* 2050825 */   // Label 27121: @2050825
     /* 2050825 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2050916), // Rule ID 17840 //
     /* 2050830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2050833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2050850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050876 */     // MIs[0] round
     /* 2050876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050879 */     // MIs[0] policy
     /* 2050879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050889 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2050892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050915 */     // GIR_Coverage, 17840,
     /* 2050915 */     GIR_EraseRootFromParent_Done,
     /* 2050916 */   // Label 27122: @2050916
     /* 2050916 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2051007), // Rule ID 17841 //
     /* 2050921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2050924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2050929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2050938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2050941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2050959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050967 */     // MIs[0] round
     /* 2050967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050970 */     // MIs[0] policy
     /* 2050970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050980 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10933:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2050983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2050987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051006 */     // GIR_Coverage, 17841,
     /* 2051006 */     GIR_EraseRootFromParent_Done,
     /* 2051007 */   // Label 27123: @2051007
     /* 2051007 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2051098), // Rule ID 17844 //
     /* 2051012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2051015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051058 */     // MIs[0] round
     /* 2051058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051061 */     // MIs[0] policy
     /* 2051061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051071 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2051074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051097 */     // GIR_Coverage, 17844,
     /* 2051097 */     GIR_EraseRootFromParent_Done,
     /* 2051098 */   // Label 27124: @2051098
     /* 2051098 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2051189), // Rule ID 17845 //
     /* 2051103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2051106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051149 */     // MIs[0] round
     /* 2051149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051152 */     // MIs[0] policy
     /* 2051152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051162 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2051165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051188 */     // GIR_Coverage, 17845,
     /* 2051188 */     GIR_EraseRootFromParent_Done,
     /* 2051189 */   // Label 27125: @2051189
     /* 2051189 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2051280), // Rule ID 17848 //
     /* 2051194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2051197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051240 */     // MIs[0] round
     /* 2051240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051243 */     // MIs[0] policy
     /* 2051243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051253 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2051256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051279 */     // GIR_Coverage, 17848,
     /* 2051279 */     GIR_EraseRootFromParent_Done,
     /* 2051280 */   // Label 27126: @2051280
     /* 2051280 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2051371), // Rule ID 17849 //
     /* 2051285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2051288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051331 */     // MIs[0] round
     /* 2051331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051334 */     // MIs[0] policy
     /* 2051334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051344 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2051347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051370 */     // GIR_Coverage, 17849,
     /* 2051370 */     GIR_EraseRootFromParent_Done,
     /* 2051371 */   // Label 27127: @2051371
     /* 2051371 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2051462), // Rule ID 17852 //
     /* 2051376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2051379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051422 */     // MIs[0] round
     /* 2051422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051425 */     // MIs[0] policy
     /* 2051425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051435 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2051438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051461 */     // GIR_Coverage, 17852,
     /* 2051461 */     GIR_EraseRootFromParent_Done,
     /* 2051462 */   // Label 27128: @2051462
     /* 2051462 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2051553), // Rule ID 17853 //
     /* 2051467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2051470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051513 */     // MIs[0] round
     /* 2051513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051516 */     // MIs[0] policy
     /* 2051516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051526 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2051529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051552 */     // GIR_Coverage, 17853,
     /* 2051552 */     GIR_EraseRootFromParent_Done,
     /* 2051553 */   // Label 27129: @2051553
     /* 2051553 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2051644), // Rule ID 17856 //
     /* 2051558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2051561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051604 */     // MIs[0] round
     /* 2051604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051607 */     // MIs[0] policy
     /* 2051607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051617 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2051620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051643 */     // GIR_Coverage, 17856,
     /* 2051643 */     GIR_EraseRootFromParent_Done,
     /* 2051644 */   // Label 27130: @2051644
     /* 2051644 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2051735), // Rule ID 17857 //
     /* 2051649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2051652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051695 */     // MIs[0] round
     /* 2051695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051698 */     // MIs[0] policy
     /* 2051698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2051711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051734 */     // GIR_Coverage, 17857,
     /* 2051734 */     GIR_EraseRootFromParent_Done,
     /* 2051735 */   // Label 27131: @2051735
     /* 2051735 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2051826), // Rule ID 17860 //
     /* 2051740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2051743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051786 */     // MIs[0] round
     /* 2051786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051789 */     // MIs[0] policy
     /* 2051789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051799 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2051802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051825 */     // GIR_Coverage, 17860,
     /* 2051825 */     GIR_EraseRootFromParent_Done,
     /* 2051826 */   // Label 27132: @2051826
     /* 2051826 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2051917), // Rule ID 17861 //
     /* 2051831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2051834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051877 */     // MIs[0] round
     /* 2051877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051880 */     // MIs[0] policy
     /* 2051880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2051893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051916 */     // GIR_Coverage, 17861,
     /* 2051916 */     GIR_EraseRootFromParent_Done,
     /* 2051917 */   // Label 27133: @2051917
     /* 2051917 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2052008), // Rule ID 17864 //
     /* 2051922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2051925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2051930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2051933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2051936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2051939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2051942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051968 */     // MIs[0] round
     /* 2051968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051971 */     // MIs[0] policy
     /* 2051971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051981 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2051984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2051988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052007 */     // GIR_Coverage, 17864,
     /* 2052007 */     GIR_EraseRootFromParent_Done,
     /* 2052008 */   // Label 27134: @2052008
     /* 2052008 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2052099), // Rule ID 17865 //
     /* 2052013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2052016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052059 */     // MIs[0] round
     /* 2052059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052062 */     // MIs[0] policy
     /* 2052062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052072 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2052075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052098 */     // GIR_Coverage, 17865,
     /* 2052098 */     GIR_EraseRootFromParent_Done,
     /* 2052099 */   // Label 27135: @2052099
     /* 2052099 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2052190), // Rule ID 17868 //
     /* 2052104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2052107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052150 */     // MIs[0] round
     /* 2052150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052153 */     // MIs[0] policy
     /* 2052153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052163 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2052166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052189 */     // GIR_Coverage, 17868,
     /* 2052189 */     GIR_EraseRootFromParent_Done,
     /* 2052190 */   // Label 27136: @2052190
     /* 2052190 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2052281), // Rule ID 17869 //
     /* 2052195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2052198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052241 */     // MIs[0] round
     /* 2052241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052244 */     // MIs[0] policy
     /* 2052244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2052257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052280 */     // GIR_Coverage, 17869,
     /* 2052280 */     GIR_EraseRootFromParent_Done,
     /* 2052281 */   // Label 27137: @2052281
     /* 2052281 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2052372), // Rule ID 17872 //
     /* 2052286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2052289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052332 */     // MIs[0] round
     /* 2052332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052335 */     // MIs[0] policy
     /* 2052335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052345 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2052348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052371 */     // GIR_Coverage, 17872,
     /* 2052371 */     GIR_EraseRootFromParent_Done,
     /* 2052372 */   // Label 27138: @2052372
     /* 2052372 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2052463), // Rule ID 17873 //
     /* 2052377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2052380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052423 */     // MIs[0] round
     /* 2052423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052426 */     // MIs[0] policy
     /* 2052426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052436 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2052439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052462 */     // GIR_Coverage, 17873,
     /* 2052462 */     GIR_EraseRootFromParent_Done,
     /* 2052463 */   // Label 27139: @2052463
     /* 2052463 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2052554), // Rule ID 17876 //
     /* 2052468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2052471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2052479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2052482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2052485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2052488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052514 */     // MIs[0] round
     /* 2052514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052517 */     // MIs[0] policy
     /* 2052517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052527 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2052530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052553 */     // GIR_Coverage, 17876,
     /* 2052553 */     GIR_EraseRootFromParent_Done,
     /* 2052554 */   // Label 27140: @2052554
     /* 2052554 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2052645), // Rule ID 17877 //
     /* 2052559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2052562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2052570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2052573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2052576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2052579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052605 */     // MIs[0] round
     /* 2052605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052608 */     // MIs[0] policy
     /* 2052608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052618 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2052621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052644 */     // GIR_Coverage, 17877,
     /* 2052644 */     GIR_EraseRootFromParent_Done,
     /* 2052645 */   // Label 27141: @2052645
     /* 2052645 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2052736), // Rule ID 17880 //
     /* 2052650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2052653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2052661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2052664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2052667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2052670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052696 */     // MIs[0] round
     /* 2052696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052699 */     // MIs[0] policy
     /* 2052699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052709 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2052712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052735 */     // GIR_Coverage, 17880,
     /* 2052735 */     GIR_EraseRootFromParent_Done,
     /* 2052736 */   // Label 27142: @2052736
     /* 2052736 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2052827), // Rule ID 17881 //
     /* 2052741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2052744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2052752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2052755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2052758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2052761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052787 */     // MIs[0] round
     /* 2052787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052790 */     // MIs[0] policy
     /* 2052790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052800 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2052803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052826 */     // GIR_Coverage, 17881,
     /* 2052826 */     GIR_EraseRootFromParent_Done,
     /* 2052827 */   // Label 27143: @2052827
     /* 2052827 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2052918), // Rule ID 17884 //
     /* 2052832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2052835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2052843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2052846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2052849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2052852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052878 */     // MIs[0] round
     /* 2052878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052881 */     // MIs[0] policy
     /* 2052881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052891 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2052894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052917 */     // GIR_Coverage, 17884,
     /* 2052917 */     GIR_EraseRootFromParent_Done,
     /* 2052918 */   // Label 27144: @2052918
     /* 2052918 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2053009), // Rule ID 17885 //
     /* 2052923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2052926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2052931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2052934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2052937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2052940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2052943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052969 */     // MIs[0] round
     /* 2052969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052972 */     // MIs[0] policy
     /* 2052972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052982 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2052985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2052989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053008 */     // GIR_Coverage, 17885,
     /* 2053008 */     GIR_EraseRootFromParent_Done,
     /* 2053009 */   // Label 27145: @2053009
     /* 2053009 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2053100), // Rule ID 17888 //
     /* 2053014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2053017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053060 */     // MIs[0] round
     /* 2053060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053063 */     // MIs[0] policy
     /* 2053063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053073 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2053076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053099 */     // GIR_Coverage, 17888,
     /* 2053099 */     GIR_EraseRootFromParent_Done,
     /* 2053100 */   // Label 27146: @2053100
     /* 2053100 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2053191), // Rule ID 17889 //
     /* 2053105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2053108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053151 */     // MIs[0] round
     /* 2053151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053154 */     // MIs[0] policy
     /* 2053154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2053167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053190 */     // GIR_Coverage, 17889,
     /* 2053190 */     GIR_EraseRootFromParent_Done,
     /* 2053191 */   // Label 27147: @2053191
     /* 2053191 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2053282), // Rule ID 17892 //
     /* 2053196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2053199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053242 */     // MIs[0] round
     /* 2053242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053245 */     // MIs[0] policy
     /* 2053245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053255 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2053258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053281 */     // GIR_Coverage, 17892,
     /* 2053281 */     GIR_EraseRootFromParent_Done,
     /* 2053282 */   // Label 27148: @2053282
     /* 2053282 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2053373), // Rule ID 17893 //
     /* 2053287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2053290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053333 */     // MIs[0] round
     /* 2053333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053336 */     // MIs[0] policy
     /* 2053336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2053349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053372 */     // GIR_Coverage, 17893,
     /* 2053372 */     GIR_EraseRootFromParent_Done,
     /* 2053373 */   // Label 27149: @2053373
     /* 2053373 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2053464), // Rule ID 17896 //
     /* 2053378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2053381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2053398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053424 */     // MIs[0] round
     /* 2053424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053427 */     // MIs[0] policy
     /* 2053427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053437 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2053440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053463 */     // GIR_Coverage, 17896,
     /* 2053463 */     GIR_EraseRootFromParent_Done,
     /* 2053464 */   // Label 27150: @2053464
     /* 2053464 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2053555), // Rule ID 17897 //
     /* 2053469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2053472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2053489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053515 */     // MIs[0] round
     /* 2053515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053518 */     // MIs[0] policy
     /* 2053518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053528 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2053531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053554 */     // GIR_Coverage, 17897,
     /* 2053554 */     GIR_EraseRootFromParent_Done,
     /* 2053555 */   // Label 27151: @2053555
     /* 2053555 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2053646), // Rule ID 17900 //
     /* 2053560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2053563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2053571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2053574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2053577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2053580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053606 */     // MIs[0] round
     /* 2053606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053609 */     // MIs[0] policy
     /* 2053609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053619 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2053622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053645 */     // GIR_Coverage, 17900,
     /* 2053645 */     GIR_EraseRootFromParent_Done,
     /* 2053646 */   // Label 27152: @2053646
     /* 2053646 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2053737), // Rule ID 17901 //
     /* 2053651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2053654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2053662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2053665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2053668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2053671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053697 */     // MIs[0] round
     /* 2053697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053700 */     // MIs[0] policy
     /* 2053700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053710 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2053713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053736 */     // GIR_Coverage, 17901,
     /* 2053736 */     GIR_EraseRootFromParent_Done,
     /* 2053737 */   // Label 27153: @2053737
     /* 2053737 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2053828), // Rule ID 17904 //
     /* 2053742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2053745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2053753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2053756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2053759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2053762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2053765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2053780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053788 */     // MIs[0] round
     /* 2053788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053791 */     // MIs[0] policy
     /* 2053791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053801 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2053804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053827 */     // GIR_Coverage, 17904,
     /* 2053827 */     GIR_EraseRootFromParent_Done,
     /* 2053828 */   // Label 27154: @2053828
     /* 2053828 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2053919), // Rule ID 17905 //
     /* 2053833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2053836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2053844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2053847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2053850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2053853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2053856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2053871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053879 */     // MIs[0] round
     /* 2053879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053882 */     // MIs[0] policy
     /* 2053882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053892 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2053895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053918 */     // GIR_Coverage, 17905,
     /* 2053918 */     GIR_EraseRootFromParent_Done,
     /* 2053919 */   // Label 27155: @2053919
     /* 2053919 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2054010), // Rule ID 17908 //
     /* 2053924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2053927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2053932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2053935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2053938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2053941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2053944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2053962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053970 */     // MIs[0] round
     /* 2053970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053973 */     // MIs[0] policy
     /* 2053973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053983 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2053986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2053990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054009 */     // GIR_Coverage, 17908,
     /* 2054009 */     GIR_EraseRootFromParent_Done,
     /* 2054010 */   // Label 27156: @2054010
     /* 2054010 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2054101), // Rule ID 17909 //
     /* 2054015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2054018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2054026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2054029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2054032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2054035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2054053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054061 */     // MIs[0] round
     /* 2054061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054064 */     // MIs[0] policy
     /* 2054064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054074 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2054077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054100 */     // GIR_Coverage, 17909,
     /* 2054100 */     GIR_EraseRootFromParent_Done,
     /* 2054101 */   // Label 27157: @2054101
     /* 2054101 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2054192), // Rule ID 17912 //
     /* 2054106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2054109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2054117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2054120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2054123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2054126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2054144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054152 */     // MIs[0] round
     /* 2054152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054155 */     // MIs[0] policy
     /* 2054155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054165 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2054168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054191 */     // GIR_Coverage, 17912,
     /* 2054191 */     GIR_EraseRootFromParent_Done,
     /* 2054192 */   // Label 27158: @2054192
     /* 2054192 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2054283), // Rule ID 17913 //
     /* 2054197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2054200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2054208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2054211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2054214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2054217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2054235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054243 */     // MIs[0] round
     /* 2054243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054246 */     // MIs[0] policy
     /* 2054246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2054259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054282 */     // GIR_Coverage, 17913,
     /* 2054282 */     GIR_EraseRootFromParent_Done,
     /* 2054283 */   // Label 27159: @2054283
     /* 2054283 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2054374), // Rule ID 17916 //
     /* 2054288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2054291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2054299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2054302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2054305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2054308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2054326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054334 */     // MIs[0] round
     /* 2054334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054337 */     // MIs[0] policy
     /* 2054337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054347 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2054350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054373 */     // GIR_Coverage, 17916,
     /* 2054373 */     GIR_EraseRootFromParent_Done,
     /* 2054374 */   // Label 27160: @2054374
     /* 2054374 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2054465), // Rule ID 17917 //
     /* 2054379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2054382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2054390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2054393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2054396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2054399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2054417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054425 */     // MIs[0] round
     /* 2054425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054428 */     // MIs[0] policy
     /* 2054428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054438 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10906:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2054441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054464 */     // GIR_Coverage, 17917,
     /* 2054464 */     GIR_EraseRootFromParent_Done,
     /* 2054465 */   // Label 27161: @2054465
     /* 2054465 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2054556), // Rule ID 17920 //
     /* 2054470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2054473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2054481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2054484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2054487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2054490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2054508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054516 */     // MIs[0] round
     /* 2054516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054519 */     // MIs[0] policy
     /* 2054519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054529 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2054532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054555 */     // GIR_Coverage, 17920,
     /* 2054555 */     GIR_EraseRootFromParent_Done,
     /* 2054556 */   // Label 27162: @2054556
     /* 2054556 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2054647), // Rule ID 17921 //
     /* 2054561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2054564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2054572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2054575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2054578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2054581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2054599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054607 */     // MIs[0] round
     /* 2054607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054610 */     // MIs[0] policy
     /* 2054610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2054623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054646 */     // GIR_Coverage, 17921,
     /* 2054646 */     GIR_EraseRootFromParent_Done,
     /* 2054647 */   // Label 27163: @2054647
     /* 2054647 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2054738), // Rule ID 17924 //
     /* 2054652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2054655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2054663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2054666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2054669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2054672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2054690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054698 */     // MIs[0] round
     /* 2054698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054701 */     // MIs[0] policy
     /* 2054701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054711 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2054714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054737 */     // GIR_Coverage, 17924,
     /* 2054737 */     GIR_EraseRootFromParent_Done,
     /* 2054738 */   // Label 27164: @2054738
     /* 2054738 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2054829), // Rule ID 17925 //
     /* 2054743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2054746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2054754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2054757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2054760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2054763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2054781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054789 */     // MIs[0] round
     /* 2054789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054792 */     // MIs[0] policy
     /* 2054792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2054805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054828 */     // GIR_Coverage, 17925,
     /* 2054828 */     GIR_EraseRootFromParent_Done,
     /* 2054829 */   // Label 27165: @2054829
     /* 2054829 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2054920), // Rule ID 17928 //
     /* 2054834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2054837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2054845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2054848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2054851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2054854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2054872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054880 */     // MIs[0] round
     /* 2054880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054883 */     // MIs[0] policy
     /* 2054883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054893 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2054896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054919 */     // GIR_Coverage, 17928,
     /* 2054919 */     GIR_EraseRootFromParent_Done,
     /* 2054920 */   // Label 27166: @2054920
     /* 2054920 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2055011), // Rule ID 17929 //
     /* 2054925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2054928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2054933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2054936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2054939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2054942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2054945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2054963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054971 */     // MIs[0] round
     /* 2054971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054974 */     // MIs[0] policy
     /* 2054974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2054987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2054991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055010 */     // GIR_Coverage, 17929,
     /* 2055010 */     GIR_EraseRootFromParent_Done,
     /* 2055011 */   // Label 27167: @2055011
     /* 2055011 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2055102), // Rule ID 17932 //
     /* 2055016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2055019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2055027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2055030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2055033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2055036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2055039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2055054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055062 */     // MIs[0] round
     /* 2055062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055065 */     // MIs[0] policy
     /* 2055065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055075 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2055078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055101 */     // GIR_Coverage, 17932,
     /* 2055101 */     GIR_EraseRootFromParent_Done,
     /* 2055102 */   // Label 27168: @2055102
     /* 2055102 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2055193), // Rule ID 17933 //
     /* 2055107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2055110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2055118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2055121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2055124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2055127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2055130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2055145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055153 */     // MIs[0] round
     /* 2055153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055156 */     // MIs[0] policy
     /* 2055156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055166 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2055169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055192 */     // GIR_Coverage, 17933,
     /* 2055192 */     GIR_EraseRootFromParent_Done,
     /* 2055193 */   // Label 27169: @2055193
     /* 2055193 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2055284), // Rule ID 17936 //
     /* 2055198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2055201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2055209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2055212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2055215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2055218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2055221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2055236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055244 */     // MIs[0] round
     /* 2055244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055247 */     // MIs[0] policy
     /* 2055247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055257 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2055260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055283 */     // GIR_Coverage, 17936,
     /* 2055283 */     GIR_EraseRootFromParent_Done,
     /* 2055284 */   // Label 27170: @2055284
     /* 2055284 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2055375), // Rule ID 17937 //
     /* 2055289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2055292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2055300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2055303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2055306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2055309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2055312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2055327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055335 */     // MIs[0] round
     /* 2055335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055338 */     // MIs[0] policy
     /* 2055338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055348 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2055351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055374 */     // GIR_Coverage, 17937,
     /* 2055374 */     GIR_EraseRootFromParent_Done,
     /* 2055375 */   // Label 27171: @2055375
     /* 2055375 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2055466), // Rule ID 17940 //
     /* 2055380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2055383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2055391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2055394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2055400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2055410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055426 */     // MIs[0] round
     /* 2055426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055429 */     // MIs[0] policy
     /* 2055429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055439 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2055442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055465 */     // GIR_Coverage, 17940,
     /* 2055465 */     GIR_EraseRootFromParent_Done,
     /* 2055466 */   // Label 27172: @2055466
     /* 2055466 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2055557), // Rule ID 17941 //
     /* 2055471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2055474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2055482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2055485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2055491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2055501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055517 */     // MIs[0] round
     /* 2055517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055520 */     // MIs[0] policy
     /* 2055520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2055533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055556 */     // GIR_Coverage, 17941,
     /* 2055556 */     GIR_EraseRootFromParent_Done,
     /* 2055557 */   // Label 27173: @2055557
     /* 2055557 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2055648), // Rule ID 17944 //
     /* 2055562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2055565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2055573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2055576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2055582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055608 */     // MIs[0] round
     /* 2055608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055611 */     // MIs[0] policy
     /* 2055611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055621 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2055624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055647 */     // GIR_Coverage, 17944,
     /* 2055647 */     GIR_EraseRootFromParent_Done,
     /* 2055648 */   // Label 27174: @2055648
     /* 2055648 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2055739), // Rule ID 17945 //
     /* 2055653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2055656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2055664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2055667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2055673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055699 */     // MIs[0] round
     /* 2055699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055702 */     // MIs[0] policy
     /* 2055702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055712 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2055715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055738 */     // GIR_Coverage, 17945,
     /* 2055738 */     GIR_EraseRootFromParent_Done,
     /* 2055739 */   // Label 27175: @2055739
     /* 2055739 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2055830), // Rule ID 17948 //
     /* 2055744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2055747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2055755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2055758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2055764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2055767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055790 */     // MIs[0] round
     /* 2055790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055793 */     // MIs[0] policy
     /* 2055793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055803 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2055806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055829 */     // GIR_Coverage, 17948,
     /* 2055829 */     GIR_EraseRootFromParent_Done,
     /* 2055830 */   // Label 27176: @2055830
     /* 2055830 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2055921), // Rule ID 17949 //
     /* 2055835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2055838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2055846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2055849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2055852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2055855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2055858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2055873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055881 */     // MIs[0] round
     /* 2055881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055884 */     // MIs[0] policy
     /* 2055884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055894 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2055897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055920 */     // GIR_Coverage, 17949,
     /* 2055920 */     GIR_EraseRootFromParent_Done,
     /* 2055921 */   // Label 27177: @2055921
     /* 2055921 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2056012), // Rule ID 17952 //
     /* 2055926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2055929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2055934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2055937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2055940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2055943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2055946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2055956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2055964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055972 */     // MIs[0] round
     /* 2055972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055975 */     // MIs[0] policy
     /* 2055975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055985 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2055988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2055992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056011 */     // GIR_Coverage, 17952,
     /* 2056011 */     GIR_EraseRootFromParent_Done,
     /* 2056012 */   // Label 27178: @2056012
     /* 2056012 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2056103), // Rule ID 17953 //
     /* 2056017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2056020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2056025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2056028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2056031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2056034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2056037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2056055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056063 */     // MIs[0] round
     /* 2056063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056066 */     // MIs[0] policy
     /* 2056066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2056079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056102 */     // GIR_Coverage, 17953,
     /* 2056102 */     GIR_EraseRootFromParent_Done,
     /* 2056103 */   // Label 27179: @2056103
     /* 2056103 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2056194), // Rule ID 17956 //
     /* 2056108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2056111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2056116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2056119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2056122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2056125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2056128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2056146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056154 */     // MIs[0] round
     /* 2056154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056157 */     // MIs[0] policy
     /* 2056157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056167 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2056170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056193 */     // GIR_Coverage, 17956,
     /* 2056193 */     GIR_EraseRootFromParent_Done,
     /* 2056194 */   // Label 27180: @2056194
     /* 2056194 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2056285), // Rule ID 17957 //
     /* 2056199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2056202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2056207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2056210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2056213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2056216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2056219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2056237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056245 */     // MIs[0] round
     /* 2056245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056248 */     // MIs[0] policy
     /* 2056248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2056261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056284 */     // GIR_Coverage, 17957,
     /* 2056284 */     GIR_EraseRootFromParent_Done,
     /* 2056285 */   // Label 27181: @2056285
     /* 2056285 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2056376), // Rule ID 17960 //
     /* 2056290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2056293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2056298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2056301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2056304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2056307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2056310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2056328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056336 */     // MIs[0] round
     /* 2056336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056339 */     // MIs[0] policy
     /* 2056339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056349 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2056352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056375 */     // GIR_Coverage, 17960,
     /* 2056375 */     GIR_EraseRootFromParent_Done,
     /* 2056376 */   // Label 27182: @2056376
     /* 2056376 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2056467), // Rule ID 17961 //
     /* 2056381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2056384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2056389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2056392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2056395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2056398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2056401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2056419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056427 */     // MIs[0] round
     /* 2056427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056430 */     // MIs[0] policy
     /* 2056430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056440 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2056443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056466 */     // GIR_Coverage, 17961,
     /* 2056466 */     GIR_EraseRootFromParent_Done,
     /* 2056467 */   // Label 27183: @2056467
     /* 2056467 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2056558), // Rule ID 17964 //
     /* 2056472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2056475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2056483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2056486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2056489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2056492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056518 */     // MIs[0] round
     /* 2056518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056521 */     // MIs[0] policy
     /* 2056521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056531 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2056534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056557 */     // GIR_Coverage, 17964,
     /* 2056557 */     GIR_EraseRootFromParent_Done,
     /* 2056558 */   // Label 27184: @2056558
     /* 2056558 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2056649), // Rule ID 17965 //
     /* 2056563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2056566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2056574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2056577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2056580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2056583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056609 */     // MIs[0] round
     /* 2056609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056612 */     // MIs[0] policy
     /* 2056612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056622 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2056625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056648 */     // GIR_Coverage, 17965,
     /* 2056648 */     GIR_EraseRootFromParent_Done,
     /* 2056649 */   // Label 27185: @2056649
     /* 2056649 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2056740), // Rule ID 17968 //
     /* 2056654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2056657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2056665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2056668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2056671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2056674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056700 */     // MIs[0] round
     /* 2056700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056703 */     // MIs[0] policy
     /* 2056703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056713 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2056716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056739 */     // GIR_Coverage, 17968,
     /* 2056739 */     GIR_EraseRootFromParent_Done,
     /* 2056740 */   // Label 27186: @2056740
     /* 2056740 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2056831), // Rule ID 17969 //
     /* 2056745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2056748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2056756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2056759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2056762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2056765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056791 */     // MIs[0] round
     /* 2056791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056794 */     // MIs[0] policy
     /* 2056794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056804 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2056807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056830 */     // GIR_Coverage, 17969,
     /* 2056830 */     GIR_EraseRootFromParent_Done,
     /* 2056831 */   // Label 27187: @2056831
     /* 2056831 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2056922), // Rule ID 17972 //
     /* 2056836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2056839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2056856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056882 */     // MIs[0] round
     /* 2056882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056885 */     // MIs[0] policy
     /* 2056885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056895 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2056898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056921 */     // GIR_Coverage, 17972,
     /* 2056921 */     GIR_EraseRootFromParent_Done,
     /* 2056922 */   // Label 27188: @2056922
     /* 2056922 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2057013), // Rule ID 17973 //
     /* 2056927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2056930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2056935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2056947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056973 */     // MIs[0] round
     /* 2056973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056976 */     // MIs[0] policy
     /* 2056976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056986 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2056989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2056993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057012 */     // GIR_Coverage, 17973,
     /* 2057012 */     GIR_EraseRootFromParent_Done,
     /* 2057013 */   // Label 27189: @2057013
     /* 2057013 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2057104), // Rule ID 17976 //
     /* 2057018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2057021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2057029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2057032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2057035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2057038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057064 */     // MIs[0] round
     /* 2057064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057067 */     // MIs[0] policy
     /* 2057067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057077 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2057080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057103 */     // GIR_Coverage, 17976,
     /* 2057103 */     GIR_EraseRootFromParent_Done,
     /* 2057104 */   // Label 27190: @2057104
     /* 2057104 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2057195), // Rule ID 17977 //
     /* 2057109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2057112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2057120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2057123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2057126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2057129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057155 */     // MIs[0] round
     /* 2057155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057158 */     // MIs[0] policy
     /* 2057158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2057171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057194 */     // GIR_Coverage, 17977,
     /* 2057194 */     GIR_EraseRootFromParent_Done,
     /* 2057195 */   // Label 27191: @2057195
     /* 2057195 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2057286), // Rule ID 17980 //
     /* 2057200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2057203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2057211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2057214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2057217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2057220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057246 */     // MIs[0] round
     /* 2057246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057249 */     // MIs[0] policy
     /* 2057249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057259 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2057262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057285 */     // GIR_Coverage, 17980,
     /* 2057285 */     GIR_EraseRootFromParent_Done,
     /* 2057286 */   // Label 27192: @2057286
     /* 2057286 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2057377), // Rule ID 17981 //
     /* 2057291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2057294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2057302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2057305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2057308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2057311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057337 */     // MIs[0] round
     /* 2057337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057340 */     // MIs[0] policy
     /* 2057340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057350 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2057353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057376 */     // GIR_Coverage, 17981,
     /* 2057376 */     GIR_EraseRootFromParent_Done,
     /* 2057377 */   // Label 27193: @2057377
     /* 2057377 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2057468), // Rule ID 17984 //
     /* 2057382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2057385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2057393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2057396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2057399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2057402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2057405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057428 */     // MIs[0] round
     /* 2057428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057431 */     // MIs[0] policy
     /* 2057431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057441 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2057444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057467 */     // GIR_Coverage, 17984,
     /* 2057467 */     GIR_EraseRootFromParent_Done,
     /* 2057468 */   // Label 27194: @2057468
     /* 2057468 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2057559), // Rule ID 17985 //
     /* 2057473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2057476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2057484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2057487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2057490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2057493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2057496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057519 */     // MIs[0] round
     /* 2057519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057522 */     // MIs[0] policy
     /* 2057522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2057535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057558 */     // GIR_Coverage, 17985,
     /* 2057558 */     GIR_EraseRootFromParent_Done,
     /* 2057559 */   // Label 27195: @2057559
     /* 2057559 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2057650), // Rule ID 17988 //
     /* 2057564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2057567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2057584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057610 */     // MIs[0] round
     /* 2057610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057613 */     // MIs[0] policy
     /* 2057613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057623 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2057626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057649 */     // GIR_Coverage, 17988,
     /* 2057649 */     GIR_EraseRootFromParent_Done,
     /* 2057650 */   // Label 27196: @2057650
     /* 2057650 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2057741), // Rule ID 17989 //
     /* 2057655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2057658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2057675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057701 */     // MIs[0] round
     /* 2057701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057704 */     // MIs[0] policy
     /* 2057704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057714 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2057717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057740 */     // GIR_Coverage, 17989,
     /* 2057740 */     GIR_EraseRootFromParent_Done,
     /* 2057741 */   // Label 27197: @2057741
     /* 2057741 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2057832), // Rule ID 17992 //
     /* 2057746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2057749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2057766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057792 */     // MIs[0] round
     /* 2057792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057795 */     // MIs[0] policy
     /* 2057795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057805 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2057808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057831 */     // GIR_Coverage, 17992,
     /* 2057831 */     GIR_EraseRootFromParent_Done,
     /* 2057832 */   // Label 27198: @2057832
     /* 2057832 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2057923), // Rule ID 17993 //
     /* 2057837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2057840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2057857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057883 */     // MIs[0] round
     /* 2057883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057886 */     // MIs[0] policy
     /* 2057886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057896 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2057899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057922 */     // GIR_Coverage, 17993,
     /* 2057922 */     GIR_EraseRootFromParent_Done,
     /* 2057923 */   // Label 27199: @2057923
     /* 2057923 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2058014), // Rule ID 17996 //
     /* 2057928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2057931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2057936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2057948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057974 */     // MIs[0] round
     /* 2057974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057977 */     // MIs[0] policy
     /* 2057977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057987 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2057990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2057994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058013 */     // GIR_Coverage, 17996,
     /* 2058013 */     GIR_EraseRootFromParent_Done,
     /* 2058014 */   // Label 27200: @2058014
     /* 2058014 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2058105), // Rule ID 17997 //
     /* 2058019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2058022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2058030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2058033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2058036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2058039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2058042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058065 */     // MIs[0] round
     /* 2058065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058068 */     // MIs[0] policy
     /* 2058068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058078 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2058081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058104 */     // GIR_Coverage, 17997,
     /* 2058104 */     GIR_EraseRootFromParent_Done,
     /* 2058105 */   // Label 27201: @2058105
     /* 2058105 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2058196), // Rule ID 18000 //
     /* 2058110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2058113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2058121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2058124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2058127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2058130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058156 */     // MIs[0] round
     /* 2058156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058159 */     // MIs[0] policy
     /* 2058159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2058172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058195 */     // GIR_Coverage, 18000,
     /* 2058195 */     GIR_EraseRootFromParent_Done,
     /* 2058196 */   // Label 27202: @2058196
     /* 2058196 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2058287), // Rule ID 18001 //
     /* 2058201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2058204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2058212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2058215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2058218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2058221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058247 */     // MIs[0] round
     /* 2058247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058250 */     // MIs[0] policy
     /* 2058250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2058263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058286 */     // GIR_Coverage, 18001,
     /* 2058286 */     GIR_EraseRootFromParent_Done,
     /* 2058287 */   // Label 27203: @2058287
     /* 2058287 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2058378), // Rule ID 18004 //
     /* 2058292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2058295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2058312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058338 */     // MIs[0] round
     /* 2058338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058341 */     // MIs[0] policy
     /* 2058341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058351 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2058354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058377 */     // GIR_Coverage, 18004,
     /* 2058377 */     GIR_EraseRootFromParent_Done,
     /* 2058378 */   // Label 27204: @2058378
     /* 2058378 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2058469), // Rule ID 18005 //
     /* 2058383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2058386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2058403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058429 */     // MIs[0] round
     /* 2058429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058432 */     // MIs[0] policy
     /* 2058432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058442 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2058445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058468 */     // GIR_Coverage, 18005,
     /* 2058468 */     GIR_EraseRootFromParent_Done,
     /* 2058469 */   // Label 27205: @2058469
     /* 2058469 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2058560), // Rule ID 18008 //
     /* 2058474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2058477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2058494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058520 */     // MIs[0] round
     /* 2058520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058523 */     // MIs[0] policy
     /* 2058523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2058536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058559 */     // GIR_Coverage, 18008,
     /* 2058559 */     GIR_EraseRootFromParent_Done,
     /* 2058560 */   // Label 27206: @2058560
     /* 2058560 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2058651), // Rule ID 18009 //
     /* 2058565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2058568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2058585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058611 */     // MIs[0] round
     /* 2058611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058614 */     // MIs[0] policy
     /* 2058614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2058627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058650 */     // GIR_Coverage, 18009,
     /* 2058650 */     GIR_EraseRootFromParent_Done,
     /* 2058651 */   // Label 27207: @2058651
     /* 2058651 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2058742), // Rule ID 18012 //
     /* 2058656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2058659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2058676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058702 */     // MIs[0] round
     /* 2058702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058705 */     // MIs[0] policy
     /* 2058705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2058718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058741 */     // GIR_Coverage, 18012,
     /* 2058741 */     GIR_EraseRootFromParent_Done,
     /* 2058742 */   // Label 27208: @2058742
     /* 2058742 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2058833), // Rule ID 18013 //
     /* 2058747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2058750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2058767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058793 */     // MIs[0] round
     /* 2058793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058796 */     // MIs[0] policy
     /* 2058796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2058809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058832 */     // GIR_Coverage, 18013,
     /* 2058832 */     GIR_EraseRootFromParent_Done,
     /* 2058833 */   // Label 27209: @2058833
     /* 2058833 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2058924), // Rule ID 18016 //
     /* 2058838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2058841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2058858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058884 */     // MIs[0] round
     /* 2058884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058887 */     // MIs[0] policy
     /* 2058887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058897 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2058900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058923 */     // GIR_Coverage, 18016,
     /* 2058923 */     GIR_EraseRootFromParent_Done,
     /* 2058924 */   // Label 27210: @2058924
     /* 2058924 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2059015), // Rule ID 18017 //
     /* 2058929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2058932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2058937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2058949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058975 */     // MIs[0] round
     /* 2058975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058978 */     // MIs[0] policy
     /* 2058978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058988 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2058991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2058995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059014 */     // GIR_Coverage, 18017,
     /* 2059014 */     GIR_EraseRootFromParent_Done,
     /* 2059015 */   // Label 27211: @2059015
     /* 2059015 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2059106), // Rule ID 18020 //
     /* 2059020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2059023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2059031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2059034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2059037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2059040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2059050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059066 */     // MIs[0] round
     /* 2059066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059069 */     // MIs[0] policy
     /* 2059069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059079 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2059082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059105 */     // GIR_Coverage, 18020,
     /* 2059105 */     GIR_EraseRootFromParent_Done,
     /* 2059106 */   // Label 27212: @2059106
     /* 2059106 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2059197), // Rule ID 18021 //
     /* 2059111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2059114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2059122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2059125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2059128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2059131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2059141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059157 */     // MIs[0] round
     /* 2059157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059160 */     // MIs[0] policy
     /* 2059160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2059173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059196 */     // GIR_Coverage, 18021,
     /* 2059196 */     GIR_EraseRootFromParent_Done,
     /* 2059197 */   // Label 27213: @2059197
     /* 2059197 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2059288), // Rule ID 18024 //
     /* 2059202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2059205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059248 */     // MIs[0] round
     /* 2059248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059251 */     // MIs[0] policy
     /* 2059251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059261 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2059264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059287 */     // GIR_Coverage, 18024,
     /* 2059287 */     GIR_EraseRootFromParent_Done,
     /* 2059288 */   // Label 27214: @2059288
     /* 2059288 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2059379), // Rule ID 18025 //
     /* 2059293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2059296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059339 */     // MIs[0] round
     /* 2059339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059342 */     // MIs[0] policy
     /* 2059342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059352 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2059355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059378 */     // GIR_Coverage, 18025,
     /* 2059378 */     GIR_EraseRootFromParent_Done,
     /* 2059379 */   // Label 27215: @2059379
     /* 2059379 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2059470), // Rule ID 18028 //
     /* 2059384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2059387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059430 */     // MIs[0] round
     /* 2059430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059433 */     // MIs[0] policy
     /* 2059433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059443 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2059446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059469 */     // GIR_Coverage, 18028,
     /* 2059469 */     GIR_EraseRootFromParent_Done,
     /* 2059470 */   // Label 27216: @2059470
     /* 2059470 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2059561), // Rule ID 18029 //
     /* 2059475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2059478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059521 */     // MIs[0] round
     /* 2059521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059524 */     // MIs[0] policy
     /* 2059524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059534 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2059537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059560 */     // GIR_Coverage, 18029,
     /* 2059560 */     GIR_EraseRootFromParent_Done,
     /* 2059561 */   // Label 27217: @2059561
     /* 2059561 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2059652), // Rule ID 18032 //
     /* 2059566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2059569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2059583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2059604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059612 */     // MIs[0] round
     /* 2059612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059615 */     // MIs[0] policy
     /* 2059615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059625 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2059628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059651 */     // GIR_Coverage, 18032,
     /* 2059651 */     GIR_EraseRootFromParent_Done,
     /* 2059652 */   // Label 27218: @2059652
     /* 2059652 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2059743), // Rule ID 18033 //
     /* 2059657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2059660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2059674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2059695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059703 */     // MIs[0] round
     /* 2059703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059706 */     // MIs[0] policy
     /* 2059706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059716 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2059719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059742 */     // GIR_Coverage, 18033,
     /* 2059742 */     GIR_EraseRootFromParent_Done,
     /* 2059743 */   // Label 27219: @2059743
     /* 2059743 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2059834), // Rule ID 18036 //
     /* 2059748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2059751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059794 */     // MIs[0] round
     /* 2059794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059797 */     // MIs[0] policy
     /* 2059797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2059810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059833 */     // GIR_Coverage, 18036,
     /* 2059833 */     GIR_EraseRootFromParent_Done,
     /* 2059834 */   // Label 27220: @2059834
     /* 2059834 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2059925), // Rule ID 18037 //
     /* 2059839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2059842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2059856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2059877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059885 */     // MIs[0] round
     /* 2059885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059888 */     // MIs[0] policy
     /* 2059888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059898 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10937:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2059901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059924 */     // GIR_Coverage, 18037,
     /* 2059924 */     GIR_EraseRootFromParent_Done,
     /* 2059925 */   // Label 27221: @2059925
     /* 2059925 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2060016), // Rule ID 18040 //
     /* 2059930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2059933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2059938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2059947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2059950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2059968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059976 */     // MIs[0] round
     /* 2059976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059979 */     // MIs[0] policy
     /* 2059979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059989 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2059992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2059996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060015 */     // GIR_Coverage, 18040,
     /* 2060015 */     GIR_EraseRootFromParent_Done,
     /* 2060016 */   // Label 27222: @2060016
     /* 2060016 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2060107), // Rule ID 18041 //
     /* 2060021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2060024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2060038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2060059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060067 */     // MIs[0] round
     /* 2060067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060070 */     // MIs[0] policy
     /* 2060070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060080 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10937:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2060083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060106 */     // GIR_Coverage, 18041,
     /* 2060106 */     GIR_EraseRootFromParent_Done,
     /* 2060107 */   // Label 27223: @2060107
     /* 2060107 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2060198), // Rule ID 18044 //
     /* 2060112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2060115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2060129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2060150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060158 */     // MIs[0] round
     /* 2060158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060161 */     // MIs[0] policy
     /* 2060161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060171 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2060174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060197 */     // GIR_Coverage, 18044,
     /* 2060197 */     GIR_EraseRootFromParent_Done,
     /* 2060198 */   // Label 27224: @2060198
     /* 2060198 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2060289), // Rule ID 18045 //
     /* 2060203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2060206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2060220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2060241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060249 */     // MIs[0] round
     /* 2060249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060252 */     // MIs[0] policy
     /* 2060252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060262 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10937:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2060265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060288 */     // GIR_Coverage, 18045,
     /* 2060288 */     GIR_EraseRootFromParent_Done,
     /* 2060289 */   // Label 27225: @2060289
     /* 2060289 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2060380), // Rule ID 18048 //
     /* 2060294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2060297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060340 */     // MIs[0] round
     /* 2060340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060343 */     // MIs[0] policy
     /* 2060343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060353 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2060356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060379 */     // GIR_Coverage, 18048,
     /* 2060379 */     GIR_EraseRootFromParent_Done,
     /* 2060380 */   // Label 27226: @2060380
     /* 2060380 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2060471), // Rule ID 18049 //
     /* 2060385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2060388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060431 */     // MIs[0] round
     /* 2060431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060434 */     // MIs[0] policy
     /* 2060434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060444 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2060447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060470 */     // GIR_Coverage, 18049,
     /* 2060470 */     GIR_EraseRootFromParent_Done,
     /* 2060471 */   // Label 27227: @2060471
     /* 2060471 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2060562), // Rule ID 18052 //
     /* 2060476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2060479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060522 */     // MIs[0] round
     /* 2060522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060525 */     // MIs[0] policy
     /* 2060525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060535 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2060538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060561 */     // GIR_Coverage, 18052,
     /* 2060561 */     GIR_EraseRootFromParent_Done,
     /* 2060562 */   // Label 27228: @2060562
     /* 2060562 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2060653), // Rule ID 18053 //
     /* 2060567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2060570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060613 */     // MIs[0] round
     /* 2060613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060616 */     // MIs[0] policy
     /* 2060616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060626 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2060629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060652 */     // GIR_Coverage, 18053,
     /* 2060652 */     GIR_EraseRootFromParent_Done,
     /* 2060653 */   // Label 27229: @2060653
     /* 2060653 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2060744), // Rule ID 18056 //
     /* 2060658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2060661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2060669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2060672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2060678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060704 */     // MIs[0] round
     /* 2060704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060707 */     // MIs[0] policy
     /* 2060707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060717 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2060720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060743 */     // GIR_Coverage, 18056,
     /* 2060743 */     GIR_EraseRootFromParent_Done,
     /* 2060744 */   // Label 27230: @2060744
     /* 2060744 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2060835), // Rule ID 18057 //
     /* 2060749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2060752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2060760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2060763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2060766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2060769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2060787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060795 */     // MIs[0] round
     /* 2060795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060798 */     // MIs[0] policy
     /* 2060798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060808 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2060811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060834 */     // GIR_Coverage, 18057,
     /* 2060834 */     GIR_EraseRootFromParent_Done,
     /* 2060835 */   // Label 27231: @2060835
     /* 2060835 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2060926), // Rule ID 18060 //
     /* 2060840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2060843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2060851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2060854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2060857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2060860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2060878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060886 */     // MIs[0] round
     /* 2060886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060889 */     // MIs[0] policy
     /* 2060889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2060902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060925 */     // GIR_Coverage, 18060,
     /* 2060925 */     GIR_EraseRootFromParent_Done,
     /* 2060926 */   // Label 27232: @2060926
     /* 2060926 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2061017), // Rule ID 18061 //
     /* 2060931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2060934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2060939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2060942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2060945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2060948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2060951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2060969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060977 */     // MIs[0] round
     /* 2060977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060980 */     // MIs[0] policy
     /* 2060980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060990 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2060993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2060997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061016 */     // GIR_Coverage, 18061,
     /* 2061016 */     GIR_EraseRootFromParent_Done,
     /* 2061017 */   // Label 27233: @2061017
     /* 2061017 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2061108), // Rule ID 18064 //
     /* 2061022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2061025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2061039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2061060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061068 */     // MIs[0] round
     /* 2061068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061071 */     // MIs[0] policy
     /* 2061071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061081 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2061084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061107 */     // GIR_Coverage, 18064,
     /* 2061107 */     GIR_EraseRootFromParent_Done,
     /* 2061108 */   // Label 27234: @2061108
     /* 2061108 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2061199), // Rule ID 18065 //
     /* 2061113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2061116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2061130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2061151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061159 */     // MIs[0] round
     /* 2061159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061162 */     // MIs[0] policy
     /* 2061162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061172 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2061175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061198 */     // GIR_Coverage, 18065,
     /* 2061198 */     GIR_EraseRootFromParent_Done,
     /* 2061199 */   // Label 27235: @2061199
     /* 2061199 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2061290), // Rule ID 18068 //
     /* 2061204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2061207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2061221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2061242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061250 */     // MIs[0] round
     /* 2061250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061253 */     // MIs[0] policy
     /* 2061253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061263 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2061266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061289 */     // GIR_Coverage, 18068,
     /* 2061289 */     GIR_EraseRootFromParent_Done,
     /* 2061290 */   // Label 27236: @2061290
     /* 2061290 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2061381), // Rule ID 18069 //
     /* 2061295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2061298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2061312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2061333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061341 */     // MIs[0] round
     /* 2061341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061344 */     // MIs[0] policy
     /* 2061344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061354 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2061357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061380 */     // GIR_Coverage, 18069,
     /* 2061380 */     GIR_EraseRootFromParent_Done,
     /* 2061381 */   // Label 27237: @2061381
     /* 2061381 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2061472), // Rule ID 18072 //
     /* 2061386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2061389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061432 */     // MIs[0] round
     /* 2061432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061435 */     // MIs[0] policy
     /* 2061435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2061448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061471 */     // GIR_Coverage, 18072,
     /* 2061471 */     GIR_EraseRootFromParent_Done,
     /* 2061472 */   // Label 27238: @2061472
     /* 2061472 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2061563), // Rule ID 18073 //
     /* 2061477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2061480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061523 */     // MIs[0] round
     /* 2061523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061526 */     // MIs[0] policy
     /* 2061526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10937:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2061539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061562 */     // GIR_Coverage, 18073,
     /* 2061562 */     GIR_EraseRootFromParent_Done,
     /* 2061563 */   // Label 27239: @2061563
     /* 2061563 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2061654), // Rule ID 18076 //
     /* 2061568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2061571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2061588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061614 */     // MIs[0] round
     /* 2061614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061617 */     // MIs[0] policy
     /* 2061617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061627 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2061630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061653 */     // GIR_Coverage, 18076,
     /* 2061653 */     GIR_EraseRootFromParent_Done,
     /* 2061654 */   // Label 27240: @2061654
     /* 2061654 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2061745), // Rule ID 18077 //
     /* 2061659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2061662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2061679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061705 */     // MIs[0] round
     /* 2061705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061708 */     // MIs[0] policy
     /* 2061708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061718 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10937:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2061721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061744 */     // GIR_Coverage, 18077,
     /* 2061744 */     GIR_EraseRootFromParent_Done,
     /* 2061745 */   // Label 27241: @2061745
     /* 2061745 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2061836), // Rule ID 18080 //
     /* 2061750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2061753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2061761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2061764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2061770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061796 */     // MIs[0] round
     /* 2061796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061799 */     // MIs[0] policy
     /* 2061799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061809 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2061812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061835 */     // GIR_Coverage, 18080,
     /* 2061835 */     GIR_EraseRootFromParent_Done,
     /* 2061836 */   // Label 27242: @2061836
     /* 2061836 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2061927), // Rule ID 18081 //
     /* 2061841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2061844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2061849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2061852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2061855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2061858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2061861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2061879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061887 */     // MIs[0] round
     /* 2061887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061890 */     // MIs[0] policy
     /* 2061890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10937:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2061903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061926 */     // GIR_Coverage, 18081,
     /* 2061926 */     GIR_EraseRootFromParent_Done,
     /* 2061927 */   // Label 27243: @2061927
     /* 2061927 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2062018), // Rule ID 18084 //
     /* 2061932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2061935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2061940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2061943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2061946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2061949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2061952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2061955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2061962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061978 */     // MIs[0] round
     /* 2061978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061981 */     // MIs[0] policy
     /* 2061981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061991 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2061994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2061998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062017 */     // GIR_Coverage, 18084,
     /* 2062017 */     GIR_EraseRootFromParent_Done,
     /* 2062018 */   // Label 27244: @2062018
     /* 2062018 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2062109), // Rule ID 18085 //
     /* 2062023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2062026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2062043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062069 */     // MIs[0] round
     /* 2062069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062072 */     // MIs[0] policy
     /* 2062072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062082 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2062085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062108 */     // GIR_Coverage, 18085,
     /* 2062108 */     GIR_EraseRootFromParent_Done,
     /* 2062109 */   // Label 27245: @2062109
     /* 2062109 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2062200), // Rule ID 18088 //
     /* 2062114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2062117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2062125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2062128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2062131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2062134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062160 */     // MIs[0] round
     /* 2062160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062163 */     // MIs[0] policy
     /* 2062163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062173 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2062176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062199 */     // GIR_Coverage, 18088,
     /* 2062199 */     GIR_EraseRootFromParent_Done,
     /* 2062200 */   // Label 27246: @2062200
     /* 2062200 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2062291), // Rule ID 18089 //
     /* 2062205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2062208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2062216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2062219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2062222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2062225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062251 */     // MIs[0] round
     /* 2062251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062254 */     // MIs[0] policy
     /* 2062254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062264 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2062267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062290 */     // GIR_Coverage, 18089,
     /* 2062290 */     GIR_EraseRootFromParent_Done,
     /* 2062291 */   // Label 27247: @2062291
     /* 2062291 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2062382), // Rule ID 18092 //
     /* 2062296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2062299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2062307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2062310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2062313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2062316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062342 */     // MIs[0] round
     /* 2062342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062345 */     // MIs[0] policy
     /* 2062345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062355 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2062358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062381 */     // GIR_Coverage, 18092,
     /* 2062381 */     GIR_EraseRootFromParent_Done,
     /* 2062382 */   // Label 27248: @2062382
     /* 2062382 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2062473), // Rule ID 18093 //
     /* 2062387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2062390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2062398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2062401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2062404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2062407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062433 */     // MIs[0] round
     /* 2062433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062436 */     // MIs[0] policy
     /* 2062436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062446 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2062449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062472 */     // GIR_Coverage, 18093,
     /* 2062472 */     GIR_EraseRootFromParent_Done,
     /* 2062473 */   // Label 27249: @2062473
     /* 2062473 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2062564), // Rule ID 18096 //
     /* 2062478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2062481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2062489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2062492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2062495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2062498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062524 */     // MIs[0] round
     /* 2062524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062527 */     // MIs[0] policy
     /* 2062527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062537 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2062540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062563 */     // GIR_Coverage, 18096,
     /* 2062563 */     GIR_EraseRootFromParent_Done,
     /* 2062564 */   // Label 27250: @2062564
     /* 2062564 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2062655), // Rule ID 18097 //
     /* 2062569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2062572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2062580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2062583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2062586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2062589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062615 */     // MIs[0] round
     /* 2062615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062618 */     // MIs[0] policy
     /* 2062618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062628 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2062631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062654 */     // GIR_Coverage, 18097,
     /* 2062654 */     GIR_EraseRootFromParent_Done,
     /* 2062655 */   // Label 27251: @2062655
     /* 2062655 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2062746), // Rule ID 18100 //
     /* 2062660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2062663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2062671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2062674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2062677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2062680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062706 */     // MIs[0] round
     /* 2062706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062709 */     // MIs[0] policy
     /* 2062709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062719 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2062722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062745 */     // GIR_Coverage, 18100,
     /* 2062745 */     GIR_EraseRootFromParent_Done,
     /* 2062746 */   // Label 27252: @2062746
     /* 2062746 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2062837), // Rule ID 18101 //
     /* 2062751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2062754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2062762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2062765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2062768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2062771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062797 */     // MIs[0] round
     /* 2062797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062800 */     // MIs[0] policy
     /* 2062800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2062813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062836 */     // GIR_Coverage, 18101,
     /* 2062836 */     GIR_EraseRootFromParent_Done,
     /* 2062837 */   // Label 27253: @2062837
     /* 2062837 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2062928), // Rule ID 18104 //
     /* 2062842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2062845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2062853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2062856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2062859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2062862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062888 */     // MIs[0] round
     /* 2062888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062891 */     // MIs[0] policy
     /* 2062891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062901 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2062904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062927 */     // GIR_Coverage, 18104,
     /* 2062927 */     GIR_EraseRootFromParent_Done,
     /* 2062928 */   // Label 27254: @2062928
     /* 2062928 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2063019), // Rule ID 18105 //
     /* 2062933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2062936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2062941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2062944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2062947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2062950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2062953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062979 */     // MIs[0] round
     /* 2062979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062982 */     // MIs[0] policy
     /* 2062982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062992 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2062995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2062999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063018 */     // GIR_Coverage, 18105,
     /* 2063018 */     GIR_EraseRootFromParent_Done,
     /* 2063019 */   // Label 27255: @2063019
     /* 2063019 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2063110), // Rule ID 18108 //
     /* 2063024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2063027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2063035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2063038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2063041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2063044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2063054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063070 */     // MIs[0] round
     /* 2063070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063073 */     // MIs[0] policy
     /* 2063073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063083 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2063086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063109 */     // GIR_Coverage, 18108,
     /* 2063109 */     GIR_EraseRootFromParent_Done,
     /* 2063110 */   // Label 27256: @2063110
     /* 2063110 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2063201), // Rule ID 18109 //
     /* 2063115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2063118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2063126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2063129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2063132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2063135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2063145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063161 */     // MIs[0] round
     /* 2063161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063164 */     // MIs[0] policy
     /* 2063164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2063177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063200 */     // GIR_Coverage, 18109,
     /* 2063200 */     GIR_EraseRootFromParent_Done,
     /* 2063201 */   // Label 27257: @2063201
     /* 2063201 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2063292), // Rule ID 18112 //
     /* 2063206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2063209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2063217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2063220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2063223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2063226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2063229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063252 */     // MIs[0] round
     /* 2063252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063255 */     // MIs[0] policy
     /* 2063255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063265 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2063268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063291 */     // GIR_Coverage, 18112,
     /* 2063291 */     GIR_EraseRootFromParent_Done,
     /* 2063292 */   // Label 27258: @2063292
     /* 2063292 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2063383), // Rule ID 18113 //
     /* 2063297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2063300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2063308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2063311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2063314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2063317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2063320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063343 */     // MIs[0] round
     /* 2063343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063346 */     // MIs[0] policy
     /* 2063346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2063359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063382 */     // GIR_Coverage, 18113,
     /* 2063382 */     GIR_EraseRootFromParent_Done,
     /* 2063383 */   // Label 27259: @2063383
     /* 2063383 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2063474), // Rule ID 18116 //
     /* 2063388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2063391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2063399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2063402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2063405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2063408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2063411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2063418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063434 */     // MIs[0] round
     /* 2063434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063437 */     // MIs[0] policy
     /* 2063437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063447 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2063450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063473 */     // GIR_Coverage, 18116,
     /* 2063473 */     GIR_EraseRootFromParent_Done,
     /* 2063474 */   // Label 27260: @2063474
     /* 2063474 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2063565), // Rule ID 18117 //
     /* 2063479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2063482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2063490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2063493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2063496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2063499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2063502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2063509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063525 */     // MIs[0] round
     /* 2063525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063528 */     // MIs[0] policy
     /* 2063528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063538 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2063541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063564 */     // GIR_Coverage, 18117,
     /* 2063564 */     GIR_EraseRootFromParent_Done,
     /* 2063565 */   // Label 27261: @2063565
     /* 2063565 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2063656), // Rule ID 18120 //
     /* 2063570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2063573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2063581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2063584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2063587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2063590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2063600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063616 */     // MIs[0] round
     /* 2063616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063619 */     // MIs[0] policy
     /* 2063619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063629 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2063632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063655 */     // GIR_Coverage, 18120,
     /* 2063655 */     GIR_EraseRootFromParent_Done,
     /* 2063656 */   // Label 27262: @2063656
     /* 2063656 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2063747), // Rule ID 18121 //
     /* 2063661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2063664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2063672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2063675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2063678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2063681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2063691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2063703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063707 */     // MIs[0] round
     /* 2063707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063710 */     // MIs[0] policy
     /* 2063710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063720 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2063723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063746 */     // GIR_Coverage, 18121,
     /* 2063746 */     GIR_EraseRootFromParent_Done,
     /* 2063747 */   // Label 27263: @2063747
     /* 2063747 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2063838), // Rule ID 18124 //
     /* 2063752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2063755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2063763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2063766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2063769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2063772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063798 */     // MIs[0] round
     /* 2063798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063801 */     // MIs[0] policy
     /* 2063801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063811 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2063814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063837 */     // GIR_Coverage, 18124,
     /* 2063837 */     GIR_EraseRootFromParent_Done,
     /* 2063838 */   // Label 27264: @2063838
     /* 2063838 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2063929), // Rule ID 18125 //
     /* 2063843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2063846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2063854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2063857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2063860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2063863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063889 */     // MIs[0] round
     /* 2063889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063892 */     // MIs[0] policy
     /* 2063892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063902 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2063905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2063909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063928 */     // GIR_Coverage, 18125,
     /* 2063928 */     GIR_EraseRootFromParent_Done,
     /* 2063929 */   // Label 27265: @2063929
     /* 2063929 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2064020), // Rule ID 18128 //
     /* 2063934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2063937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2063942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2063945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2063948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2063951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2063954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2063957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2063964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063980 */     // MIs[0] round
     /* 2063980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063983 */     // MIs[0] policy
     /* 2063983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063993 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2063996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064019 */     // GIR_Coverage, 18128,
     /* 2064019 */     GIR_EraseRootFromParent_Done,
     /* 2064020 */   // Label 27266: @2064020
     /* 2064020 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2064111), // Rule ID 18129 //
     /* 2064025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2064028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2064036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2064039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2064042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2064045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064071 */     // MIs[0] round
     /* 2064071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064074 */     // MIs[0] policy
     /* 2064074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064084 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2064087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064110 */     // GIR_Coverage, 18129,
     /* 2064110 */     GIR_EraseRootFromParent_Done,
     /* 2064111 */   // Label 27267: @2064111
     /* 2064111 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2064202), // Rule ID 18132 //
     /* 2064116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2064119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2064127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2064130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2064133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2064136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064162 */     // MIs[0] round
     /* 2064162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064165 */     // MIs[0] policy
     /* 2064165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2064178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064201 */     // GIR_Coverage, 18132,
     /* 2064201 */     GIR_EraseRootFromParent_Done,
     /* 2064202 */   // Label 27268: @2064202
     /* 2064202 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2064293), // Rule ID 18133 //
     /* 2064207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2064210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2064218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2064221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2064224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2064227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064253 */     // MIs[0] round
     /* 2064253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064256 */     // MIs[0] policy
     /* 2064256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064266 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2064269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064292 */     // GIR_Coverage, 18133,
     /* 2064292 */     GIR_EraseRootFromParent_Done,
     /* 2064293 */   // Label 27269: @2064293
     /* 2064293 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2064384), // Rule ID 18136 //
     /* 2064298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2064301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2064309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2064312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2064315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2064318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064344 */     // MIs[0] round
     /* 2064344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064347 */     // MIs[0] policy
     /* 2064347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064357 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2064360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064383 */     // GIR_Coverage, 18136,
     /* 2064383 */     GIR_EraseRootFromParent_Done,
     /* 2064384 */   // Label 27270: @2064384
     /* 2064384 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2064475), // Rule ID 18137 //
     /* 2064389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2064392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2064400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2064403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2064406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2064409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064435 */     // MIs[0] round
     /* 2064435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064438 */     // MIs[0] policy
     /* 2064438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064448 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2064451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064474 */     // GIR_Coverage, 18137,
     /* 2064474 */     GIR_EraseRootFromParent_Done,
     /* 2064475 */   // Label 27271: @2064475
     /* 2064475 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2064566), // Rule ID 18140 //
     /* 2064480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2064483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2064491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2064494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2064497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2064500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064526 */     // MIs[0] round
     /* 2064526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064529 */     // MIs[0] policy
     /* 2064529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064539 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2064542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064565 */     // GIR_Coverage, 18140,
     /* 2064565 */     GIR_EraseRootFromParent_Done,
     /* 2064566 */   // Label 27272: @2064566
     /* 2064566 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2064657), // Rule ID 18141 //
     /* 2064571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2064574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2064582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2064585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2064588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2064591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064617 */     // MIs[0] round
     /* 2064617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064620 */     // MIs[0] policy
     /* 2064620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064630 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2064633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064656 */     // GIR_Coverage, 18141,
     /* 2064656 */     GIR_EraseRootFromParent_Done,
     /* 2064657 */   // Label 27273: @2064657
     /* 2064657 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2064748), // Rule ID 18144 //
     /* 2064662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2064665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2064673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2064676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2064679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2064682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2064700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064708 */     // MIs[0] round
     /* 2064708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064711 */     // MIs[0] policy
     /* 2064711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064721 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2064724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064747 */     // GIR_Coverage, 18144,
     /* 2064747 */     GIR_EraseRootFromParent_Done,
     /* 2064748 */   // Label 27274: @2064748
     /* 2064748 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2064839), // Rule ID 18145 //
     /* 2064753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2064756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2064764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2064767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2064770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2064773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2064791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064799 */     // MIs[0] round
     /* 2064799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064802 */     // MIs[0] policy
     /* 2064802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064812 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2064815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064838 */     // GIR_Coverage, 18145,
     /* 2064838 */     GIR_EraseRootFromParent_Done,
     /* 2064839 */   // Label 27275: @2064839
     /* 2064839 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2064930), // Rule ID 18148 //
     /* 2064844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2064847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2064855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2064858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2064861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2064864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2064882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064890 */     // MIs[0] round
     /* 2064890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064893 */     // MIs[0] policy
     /* 2064893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064903 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2064906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2064910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064929 */     // GIR_Coverage, 18148,
     /* 2064929 */     GIR_EraseRootFromParent_Done,
     /* 2064930 */   // Label 27276: @2064930
     /* 2064930 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2065021), // Rule ID 18149 //
     /* 2064935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2064938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2064943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2064946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2064949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2064952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2064955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2064973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064981 */     // MIs[0] round
     /* 2064981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064984 */     // MIs[0] policy
     /* 2064984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064994 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2064997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065020 */     // GIR_Coverage, 18149,
     /* 2065020 */     GIR_EraseRootFromParent_Done,
     /* 2065021 */   // Label 27277: @2065021
     /* 2065021 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2065112), // Rule ID 18152 //
     /* 2065026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2065029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2065037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2065040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2065043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2065046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2065064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065072 */     // MIs[0] round
     /* 2065072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065075 */     // MIs[0] policy
     /* 2065075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065085 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2065088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065111 */     // GIR_Coverage, 18152,
     /* 2065111 */     GIR_EraseRootFromParent_Done,
     /* 2065112 */   // Label 27278: @2065112
     /* 2065112 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2065203), // Rule ID 18153 //
     /* 2065117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2065120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2065128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2065131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2065134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2065137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2065155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065163 */     // MIs[0] round
     /* 2065163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065166 */     // MIs[0] policy
     /* 2065166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065176 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2065179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065202 */     // GIR_Coverage, 18153,
     /* 2065202 */     GIR_EraseRootFromParent_Done,
     /* 2065203 */   // Label 27279: @2065203
     /* 2065203 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2065294), // Rule ID 18156 //
     /* 2065208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2065211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2065219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2065222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2065225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2065228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2065246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065254 */     // MIs[0] round
     /* 2065254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065257 */     // MIs[0] policy
     /* 2065257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065267 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2065270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065293 */     // GIR_Coverage, 18156,
     /* 2065293 */     GIR_EraseRootFromParent_Done,
     /* 2065294 */   // Label 27280: @2065294
     /* 2065294 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2065385), // Rule ID 18157 //
     /* 2065299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2065302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2065310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2065313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2065316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2065319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2065337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065345 */     // MIs[0] round
     /* 2065345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065348 */     // MIs[0] policy
     /* 2065348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065358 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10899:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2065361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065384 */     // GIR_Coverage, 18157,
     /* 2065384 */     GIR_EraseRootFromParent_Done,
     /* 2065385 */   // Label 27281: @2065385
     /* 2065385 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2065476), // Rule ID 18160 //
     /* 2065390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2065393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2065401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2065404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2065407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2065410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2065428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065436 */     // MIs[0] round
     /* 2065436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065439 */     // MIs[0] policy
     /* 2065439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2065452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065475 */     // GIR_Coverage, 18160,
     /* 2065475 */     GIR_EraseRootFromParent_Done,
     /* 2065476 */   // Label 27282: @2065476
     /* 2065476 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2065567), // Rule ID 18161 //
     /* 2065481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2065484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2065492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2065495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2065498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2065501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2065519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065527 */     // MIs[0] round
     /* 2065527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065530 */     // MIs[0] policy
     /* 2065530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2065543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065566 */     // GIR_Coverage, 18161,
     /* 2065566 */     GIR_EraseRootFromParent_Done,
     /* 2065567 */   // Label 27283: @2065567
     /* 2065567 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2065658), // Rule ID 18164 //
     /* 2065572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2065575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2065583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2065586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2065589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2065592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2065610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065618 */     // MIs[0] round
     /* 2065618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065621 */     // MIs[0] policy
     /* 2065621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065631 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2065634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065657 */     // GIR_Coverage, 18164,
     /* 2065657 */     GIR_EraseRootFromParent_Done,
     /* 2065658 */   // Label 27284: @2065658
     /* 2065658 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2065749), // Rule ID 18165 //
     /* 2065663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2065666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2065674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2065677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2065680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2065683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2065701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065709 */     // MIs[0] round
     /* 2065709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065712 */     // MIs[0] policy
     /* 2065712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065722 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2065725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065748 */     // GIR_Coverage, 18165,
     /* 2065748 */     GIR_EraseRootFromParent_Done,
     /* 2065749 */   // Label 27285: @2065749
     /* 2065749 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2065840), // Rule ID 18168 //
     /* 2065754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2065757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2065771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2065774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2065792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065800 */     // MIs[0] round
     /* 2065800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065803 */     // MIs[0] policy
     /* 2065803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065813 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2065816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065839 */     // GIR_Coverage, 18168,
     /* 2065839 */     GIR_EraseRootFromParent_Done,
     /* 2065840 */   // Label 27286: @2065840
     /* 2065840 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2065931), // Rule ID 18169 //
     /* 2065845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2065848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2065862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2065865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2065883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065891 */     // MIs[0] round
     /* 2065891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065894 */     // MIs[0] policy
     /* 2065894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065904 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2065907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2065911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065930 */     // GIR_Coverage, 18169,
     /* 2065930 */     GIR_EraseRootFromParent_Done,
     /* 2065931 */   // Label 27287: @2065931
     /* 2065931 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2066022), // Rule ID 18172 //
     /* 2065936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2065939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2065944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2065953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2065956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2065974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065982 */     // MIs[0] round
     /* 2065982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065985 */     // MIs[0] policy
     /* 2065985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065995 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2065998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066021 */     // GIR_Coverage, 18172,
     /* 2066021 */     GIR_EraseRootFromParent_Done,
     /* 2066022 */   // Label 27288: @2066022
     /* 2066022 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2066113), // Rule ID 18173 //
     /* 2066027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2066030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2066038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2066041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2066044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2066047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2066065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066073 */     // MIs[0] round
     /* 2066073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066076 */     // MIs[0] policy
     /* 2066076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066086 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2066089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066112 */     // GIR_Coverage, 18173,
     /* 2066112 */     GIR_EraseRootFromParent_Done,
     /* 2066113 */   // Label 27289: @2066113
     /* 2066113 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2066204), // Rule ID 18176 //
     /* 2066118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2066121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2066129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2066132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2066135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2066138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2066141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2066156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066164 */     // MIs[0] round
     /* 2066164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066167 */     // MIs[0] policy
     /* 2066167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2066180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066203 */     // GIR_Coverage, 18176,
     /* 2066203 */     GIR_EraseRootFromParent_Done,
     /* 2066204 */   // Label 27290: @2066204
     /* 2066204 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2066295), // Rule ID 18177 //
     /* 2066209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2066212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2066220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2066223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2066226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2066229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2066232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2066247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066255 */     // MIs[0] round
     /* 2066255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066258 */     // MIs[0] policy
     /* 2066258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066268 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2066271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066294 */     // GIR_Coverage, 18177,
     /* 2066294 */     GIR_EraseRootFromParent_Done,
     /* 2066295 */   // Label 27291: @2066295
     /* 2066295 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2066386), // Rule ID 18180 //
     /* 2066300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2066303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2066311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2066314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2066320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066346 */     // MIs[0] round
     /* 2066346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066349 */     // MIs[0] policy
     /* 2066349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066359 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2066362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066385 */     // GIR_Coverage, 18180,
     /* 2066385 */     GIR_EraseRootFromParent_Done,
     /* 2066386 */   // Label 27292: @2066386
     /* 2066386 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2066477), // Rule ID 18181 //
     /* 2066391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2066394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2066402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2066405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2066411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066437 */     // MIs[0] round
     /* 2066437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066440 */     // MIs[0] policy
     /* 2066440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2066453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066476 */     // GIR_Coverage, 18181,
     /* 2066476 */     GIR_EraseRootFromParent_Done,
     /* 2066477 */   // Label 27293: @2066477
     /* 2066477 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2066568), // Rule ID 18184 //
     /* 2066482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2066485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2066493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2066496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2066502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066528 */     // MIs[0] round
     /* 2066528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066531 */     // MIs[0] policy
     /* 2066531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066541 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2066544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066567 */     // GIR_Coverage, 18184,
     /* 2066567 */     GIR_EraseRootFromParent_Done,
     /* 2066568 */   // Label 27294: @2066568
     /* 2066568 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2066659), // Rule ID 18185 //
     /* 2066573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2066576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2066584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2066587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2066593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066619 */     // MIs[0] round
     /* 2066619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066622 */     // MIs[0] policy
     /* 2066622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066632 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2066635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066658 */     // GIR_Coverage, 18185,
     /* 2066658 */     GIR_EraseRootFromParent_Done,
     /* 2066659 */   // Label 27295: @2066659
     /* 2066659 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2066750), // Rule ID 18188 //
     /* 2066664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2066667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2066684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066710 */     // MIs[0] round
     /* 2066710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066713 */     // MIs[0] policy
     /* 2066713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066723 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2066726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066749 */     // GIR_Coverage, 18188,
     /* 2066749 */     GIR_EraseRootFromParent_Done,
     /* 2066750 */   // Label 27296: @2066750
     /* 2066750 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2066841), // Rule ID 18189 //
     /* 2066755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2066758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2066772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2066775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2066793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066801 */     // MIs[0] round
     /* 2066801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066804 */     // MIs[0] policy
     /* 2066804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066814 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2066817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066840 */     // GIR_Coverage, 18189,
     /* 2066840 */     GIR_EraseRootFromParent_Done,
     /* 2066841 */   // Label 27297: @2066841
     /* 2066841 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2066932), // Rule ID 18192 //
     /* 2066846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2066849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2066863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2066884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066892 */     // MIs[0] round
     /* 2066892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066895 */     // MIs[0] policy
     /* 2066895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066905 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2066908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2066912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066931 */     // GIR_Coverage, 18192,
     /* 2066931 */     GIR_EraseRootFromParent_Done,
     /* 2066932 */   // Label 27298: @2066932
     /* 2066932 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2067023), // Rule ID 18193 //
     /* 2066937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2066940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2066945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2066954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2066975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066983 */     // MIs[0] round
     /* 2066983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066986 */     // MIs[0] policy
     /* 2066986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066996 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2066999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067022 */     // GIR_Coverage, 18193,
     /* 2067022 */     GIR_EraseRootFromParent_Done,
     /* 2067023 */   // Label 27299: @2067023
     /* 2067023 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2067114), // Rule ID 18196 //
     /* 2067028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2067031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2067036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2067045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2067048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2067066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067074 */     // MIs[0] round
     /* 2067074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067077 */     // MIs[0] policy
     /* 2067077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067087 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2067090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067113 */     // GIR_Coverage, 18196,
     /* 2067113 */     GIR_EraseRootFromParent_Done,
     /* 2067114 */   // Label 27300: @2067114
     /* 2067114 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2067205), // Rule ID 18197 //
     /* 2067119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2067122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2067127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2067136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2067139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2067157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067165 */     // MIs[0] round
     /* 2067165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067168 */     // MIs[0] policy
     /* 2067168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067178 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2067181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067204 */     // GIR_Coverage, 18197,
     /* 2067204 */     GIR_EraseRootFromParent_Done,
     /* 2067205 */   // Label 27301: @2067205
     /* 2067205 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2067296), // Rule ID 18200 //
     /* 2067210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2067213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2067218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2067227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2067230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2067248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067256 */     // MIs[0] round
     /* 2067256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067259 */     // MIs[0] policy
     /* 2067259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067269 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2067272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067295 */     // GIR_Coverage, 18200,
     /* 2067295 */     GIR_EraseRootFromParent_Done,
     /* 2067296 */   // Label 27302: @2067296
     /* 2067296 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2067387), // Rule ID 18201 //
     /* 2067301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2067304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2067309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2067318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2067321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2067339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067347 */     // MIs[0] round
     /* 2067347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067350 */     // MIs[0] policy
     /* 2067350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067360 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2067363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067386 */     // GIR_Coverage, 18201,
     /* 2067386 */     GIR_EraseRootFromParent_Done,
     /* 2067387 */   // Label 27303: @2067387
     /* 2067387 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2067478), // Rule ID 18204 //
     /* 2067392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2067395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067438 */     // MIs[0] round
     /* 2067438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067441 */     // MIs[0] policy
     /* 2067441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067451 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2067454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067477 */     // GIR_Coverage, 18204,
     /* 2067477 */     GIR_EraseRootFromParent_Done,
     /* 2067478 */   // Label 27304: @2067478
     /* 2067478 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2067569), // Rule ID 18205 //
     /* 2067483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2067486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067529 */     // MIs[0] round
     /* 2067529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067532 */     // MIs[0] policy
     /* 2067532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067542 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2067545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067568 */     // GIR_Coverage, 18205,
     /* 2067568 */     GIR_EraseRootFromParent_Done,
     /* 2067569 */   // Label 27305: @2067569
     /* 2067569 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2067660), // Rule ID 18208 //
     /* 2067574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2067577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067620 */     // MIs[0] round
     /* 2067620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067623 */     // MIs[0] policy
     /* 2067623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067633 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2067636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067659 */     // GIR_Coverage, 18208,
     /* 2067659 */     GIR_EraseRootFromParent_Done,
     /* 2067660 */   // Label 27306: @2067660
     /* 2067660 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2067751), // Rule ID 18209 //
     /* 2067665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2067668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067711 */     // MIs[0] round
     /* 2067711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067714 */     // MIs[0] policy
     /* 2067714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067724 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2067727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067750 */     // GIR_Coverage, 18209,
     /* 2067750 */     GIR_EraseRootFromParent_Done,
     /* 2067751 */   // Label 27307: @2067751
     /* 2067751 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2067842), // Rule ID 18212 //
     /* 2067756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2067759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067802 */     // MIs[0] round
     /* 2067802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067805 */     // MIs[0] policy
     /* 2067805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067815 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2067818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067841 */     // GIR_Coverage, 18212,
     /* 2067841 */     GIR_EraseRootFromParent_Done,
     /* 2067842 */   // Label 27308: @2067842
     /* 2067842 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2067933), // Rule ID 18213 //
     /* 2067847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2067850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067893 */     // MIs[0] round
     /* 2067893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067896 */     // MIs[0] policy
     /* 2067896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067906 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2067909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2067913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067932 */     // GIR_Coverage, 18213,
     /* 2067932 */     GIR_EraseRootFromParent_Done,
     /* 2067933 */   // Label 27309: @2067933
     /* 2067933 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2068024), // Rule ID 18216 //
     /* 2067938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2067941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2067946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2067958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067984 */     // MIs[0] round
     /* 2067984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067987 */     // MIs[0] policy
     /* 2067987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067997 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2068000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068023 */     // GIR_Coverage, 18216,
     /* 2068023 */     GIR_EraseRootFromParent_Done,
     /* 2068024 */   // Label 27310: @2068024
     /* 2068024 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2068115), // Rule ID 18217 //
     /* 2068029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2068032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2068049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068075 */     // MIs[0] round
     /* 2068075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068078 */     // MIs[0] policy
     /* 2068078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2068091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068114 */     // GIR_Coverage, 18217,
     /* 2068114 */     GIR_EraseRootFromParent_Done,
     /* 2068115 */   // Label 27311: @2068115
     /* 2068115 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2068206), // Rule ID 18220 //
     /* 2068120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2068123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068166 */     // MIs[0] round
     /* 2068166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068169 */     // MIs[0] policy
     /* 2068169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068179 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2068182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068205 */     // GIR_Coverage, 18220,
     /* 2068205 */     GIR_EraseRootFromParent_Done,
     /* 2068206 */   // Label 27312: @2068206
     /* 2068206 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2068297), // Rule ID 18221 //
     /* 2068211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2068214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068257 */     // MIs[0] round
     /* 2068257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068260 */     // MIs[0] policy
     /* 2068260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068270 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2068273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068296 */     // GIR_Coverage, 18221,
     /* 2068296 */     GIR_EraseRootFromParent_Done,
     /* 2068297 */   // Label 27313: @2068297
     /* 2068297 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2068388), // Rule ID 18224 //
     /* 2068302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2068305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2068313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2068316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2068319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2068322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068348 */     // MIs[0] round
     /* 2068348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068351 */     // MIs[0] policy
     /* 2068351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068361 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2068364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2068384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068387 */     // GIR_Coverage, 18224,
     /* 2068387 */     GIR_EraseRootFromParent_Done,
     /* 2068388 */   // Label 27314: @2068388
     /* 2068388 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2068479), // Rule ID 18225 //
     /* 2068393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2068396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2068404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2068407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2068410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2068413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068439 */     // MIs[0] round
     /* 2068439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068442 */     // MIs[0] policy
     /* 2068442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2068455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2068475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068478 */     // GIR_Coverage, 18225,
     /* 2068478 */     GIR_EraseRootFromParent_Done,
     /* 2068479 */   // Label 27315: @2068479
     /* 2068479 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2068570), // Rule ID 18228 //
     /* 2068484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2068487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068530 */     // MIs[0] round
     /* 2068530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068533 */     // MIs[0] policy
     /* 2068533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068543 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2068546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068569 */     // GIR_Coverage, 18228,
     /* 2068569 */     GIR_EraseRootFromParent_Done,
     /* 2068570 */   // Label 27316: @2068570
     /* 2068570 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2068661), // Rule ID 18229 //
     /* 2068575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2068578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068621 */     // MIs[0] round
     /* 2068621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068624 */     // MIs[0] policy
     /* 2068624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068634 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2068637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068660 */     // GIR_Coverage, 18229,
     /* 2068660 */     GIR_EraseRootFromParent_Done,
     /* 2068661 */   // Label 27317: @2068661
     /* 2068661 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2068752), // Rule ID 18232 //
     /* 2068666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2068669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068712 */     // MIs[0] round
     /* 2068712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068715 */     // MIs[0] policy
     /* 2068715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068725 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2068728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068751 */     // GIR_Coverage, 18232,
     /* 2068751 */     GIR_EraseRootFromParent_Done,
     /* 2068752 */   // Label 27318: @2068752
     /* 2068752 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2068843), // Rule ID 18233 //
     /* 2068757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2068760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068803 */     // MIs[0] round
     /* 2068803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068806 */     // MIs[0] policy
     /* 2068806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068816 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2068819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068842 */     // GIR_Coverage, 18233,
     /* 2068842 */     GIR_EraseRootFromParent_Done,
     /* 2068843 */   // Label 27319: @2068843
     /* 2068843 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2068934), // Rule ID 18236 //
     /* 2068848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2068851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2068865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2068868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068894 */     // MIs[0] round
     /* 2068894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068897 */     // MIs[0] policy
     /* 2068897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068907 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2068910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2068914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068933 */     // GIR_Coverage, 18236,
     /* 2068933 */     GIR_EraseRootFromParent_Done,
     /* 2068934 */   // Label 27320: @2068934
     /* 2068934 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2069025), // Rule ID 18237 //
     /* 2068939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2068942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2068947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2068956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2068959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068985 */     // MIs[0] round
     /* 2068985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068988 */     // MIs[0] policy
     /* 2068988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068998 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2069001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069024 */     // GIR_Coverage, 18237,
     /* 2069024 */     GIR_EraseRootFromParent_Done,
     /* 2069025 */   // Label 27321: @2069025
     /* 2069025 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2069116), // Rule ID 18240 //
     /* 2069030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2069033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069076 */     // MIs[0] round
     /* 2069076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069079 */     // MIs[0] policy
     /* 2069079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069089 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2069092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069115 */     // GIR_Coverage, 18240,
     /* 2069115 */     GIR_EraseRootFromParent_Done,
     /* 2069116 */   // Label 27322: @2069116
     /* 2069116 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2069207), // Rule ID 18241 //
     /* 2069121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2069124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069167 */     // MIs[0] round
     /* 2069167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069170 */     // MIs[0] policy
     /* 2069170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069180 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2069183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069206 */     // GIR_Coverage, 18241,
     /* 2069206 */     GIR_EraseRootFromParent_Done,
     /* 2069207 */   // Label 27323: @2069207
     /* 2069207 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2069298), // Rule ID 18244 //
     /* 2069212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2069215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069258 */     // MIs[0] round
     /* 2069258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069261 */     // MIs[0] policy
     /* 2069261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069271 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2069274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069297 */     // GIR_Coverage, 18244,
     /* 2069297 */     GIR_EraseRootFromParent_Done,
     /* 2069298 */   // Label 27324: @2069298
     /* 2069298 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2069389), // Rule ID 18245 //
     /* 2069303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2069306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069349 */     // MIs[0] round
     /* 2069349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069352 */     // MIs[0] policy
     /* 2069352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069362 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2069365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069388 */     // GIR_Coverage, 18245,
     /* 2069388 */     GIR_EraseRootFromParent_Done,
     /* 2069389 */   // Label 27325: @2069389
     /* 2069389 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2069480), // Rule ID 18248 //
     /* 2069394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2069397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069440 */     // MIs[0] round
     /* 2069440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069443 */     // MIs[0] policy
     /* 2069443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069453 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2069456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069479 */     // GIR_Coverage, 18248,
     /* 2069479 */     GIR_EraseRootFromParent_Done,
     /* 2069480 */   // Label 27326: @2069480
     /* 2069480 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2069571), // Rule ID 18249 //
     /* 2069485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2069488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069531 */     // MIs[0] round
     /* 2069531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069534 */     // MIs[0] policy
     /* 2069534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069544 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2069547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069570 */     // GIR_Coverage, 18249,
     /* 2069570 */     GIR_EraseRootFromParent_Done,
     /* 2069571 */   // Label 27327: @2069571
     /* 2069571 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2069662), // Rule ID 18252 //
     /* 2069576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2069579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2069587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2069590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2069593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2069596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069622 */     // MIs[0] round
     /* 2069622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069625 */     // MIs[0] policy
     /* 2069625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2069638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069661 */     // GIR_Coverage, 18252,
     /* 2069661 */     GIR_EraseRootFromParent_Done,
     /* 2069662 */   // Label 27328: @2069662
     /* 2069662 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2069753), // Rule ID 18253 //
     /* 2069667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2069670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2069678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2069681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2069684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2069687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069713 */     // MIs[0] round
     /* 2069713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069716 */     // MIs[0] policy
     /* 2069716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069726 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2069729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069752 */     // GIR_Coverage, 18253,
     /* 2069752 */     GIR_EraseRootFromParent_Done,
     /* 2069753 */   // Label 27329: @2069753
     /* 2069753 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2069844), // Rule ID 18256 //
     /* 2069758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2069761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2069769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2069772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2069775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2069778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069804 */     // MIs[0] round
     /* 2069804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069807 */     // MIs[0] policy
     /* 2069807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069817 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2069820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069843 */     // GIR_Coverage, 18256,
     /* 2069843 */     GIR_EraseRootFromParent_Done,
     /* 2069844 */   // Label 27330: @2069844
     /* 2069844 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2069935), // Rule ID 18257 //
     /* 2069849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2069852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2069860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2069863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2069866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2069869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069895 */     // MIs[0] round
     /* 2069895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069898 */     // MIs[0] policy
     /* 2069898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069908 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2069911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2069915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069934 */     // GIR_Coverage, 18257,
     /* 2069934 */     GIR_EraseRootFromParent_Done,
     /* 2069935 */   // Label 27331: @2069935
     /* 2069935 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2070026), // Rule ID 18260 //
     /* 2069940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2069943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2069948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2069951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2069954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2069957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2069960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069986 */     // MIs[0] round
     /* 2069986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069989 */     // MIs[0] policy
     /* 2069989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069999 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2070002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2070022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070025 */     // GIR_Coverage, 18260,
     /* 2070025 */     GIR_EraseRootFromParent_Done,
     /* 2070026 */   // Label 27332: @2070026
     /* 2070026 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2070117), // Rule ID 18261 //
     /* 2070031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2070034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2070042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2070045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2070048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2070051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070077 */     // MIs[0] round
     /* 2070077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070080 */     // MIs[0] policy
     /* 2070080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2070093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2070113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070116 */     // GIR_Coverage, 18261,
     /* 2070116 */     GIR_EraseRootFromParent_Done,
     /* 2070117 */   // Label 27333: @2070117
     /* 2070117 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2070208), // Rule ID 18264 //
     /* 2070122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2070125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2070142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070168 */     // MIs[0] round
     /* 2070168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070171 */     // MIs[0] policy
     /* 2070171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070181 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2070184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070207 */     // GIR_Coverage, 18264,
     /* 2070207 */     GIR_EraseRootFromParent_Done,
     /* 2070208 */   // Label 27334: @2070208
     /* 2070208 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2070299), // Rule ID 18265 //
     /* 2070213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2070216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2070233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070259 */     // MIs[0] round
     /* 2070259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070262 */     // MIs[0] policy
     /* 2070262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070272 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2070275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070298 */     // GIR_Coverage, 18265,
     /* 2070298 */     GIR_EraseRootFromParent_Done,
     /* 2070299 */   // Label 27335: @2070299
     /* 2070299 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2070390), // Rule ID 18268 //
     /* 2070304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2070307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2070324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070350 */     // MIs[0] round
     /* 2070350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070353 */     // MIs[0] policy
     /* 2070353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070363 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2070366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070389 */     // GIR_Coverage, 18268,
     /* 2070389 */     GIR_EraseRootFromParent_Done,
     /* 2070390 */   // Label 27336: @2070390
     /* 2070390 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2070481), // Rule ID 18269 //
     /* 2070395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2070398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2070415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070441 */     // MIs[0] round
     /* 2070441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070444 */     // MIs[0] policy
     /* 2070444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2070457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070480 */     // GIR_Coverage, 18269,
     /* 2070480 */     GIR_EraseRootFromParent_Done,
     /* 2070481 */   // Label 27337: @2070481
     /* 2070481 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2070572), // Rule ID 18272 //
     /* 2070486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2070489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2070503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2070506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2070524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070532 */     // MIs[0] round
     /* 2070532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070535 */     // MIs[0] policy
     /* 2070535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070545 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2070548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070571 */     // GIR_Coverage, 18272,
     /* 2070571 */     GIR_EraseRootFromParent_Done,
     /* 2070572 */   // Label 27338: @2070572
     /* 2070572 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2070663), // Rule ID 18273 //
     /* 2070577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2070580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2070594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2070597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2070615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070623 */     // MIs[0] round
     /* 2070623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070626 */     // MIs[0] policy
     /* 2070626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070636 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2070639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070662 */     // GIR_Coverage, 18273,
     /* 2070662 */     GIR_EraseRootFromParent_Done,
     /* 2070663 */   // Label 27339: @2070663
     /* 2070663 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2070754), // Rule ID 18276 //
     /* 2070668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2070671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2070679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2070682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2070688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070714 */     // MIs[0] round
     /* 2070714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070717 */     // MIs[0] policy
     /* 2070717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070727 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2070730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070753 */     // GIR_Coverage, 18276,
     /* 2070753 */     GIR_EraseRootFromParent_Done,
     /* 2070754 */   // Label 27340: @2070754
     /* 2070754 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2070845), // Rule ID 18277 //
     /* 2070759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2070762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2070770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2070773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2070776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2070779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2070797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070805 */     // MIs[0] round
     /* 2070805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070808 */     // MIs[0] policy
     /* 2070808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10935:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2070821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070844 */     // GIR_Coverage, 18277,
     /* 2070844 */     GIR_EraseRootFromParent_Done,
     /* 2070845 */   // Label 27341: @2070845
     /* 2070845 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2070936), // Rule ID 18280 //
     /* 2070850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2070853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2070861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2070864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2070867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2070870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2070888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070896 */     // MIs[0] round
     /* 2070896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070899 */     // MIs[0] policy
     /* 2070899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070909 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2070912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2070916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070935 */     // GIR_Coverage, 18280,
     /* 2070935 */     GIR_EraseRootFromParent_Done,
     /* 2070936 */   // Label 27342: @2070936
     /* 2070936 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2071027), // Rule ID 18281 //
     /* 2070941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2070944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2070949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2070952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2070955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2070958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2070961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2070979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070987 */     // MIs[0] round
     /* 2070987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070990 */     // MIs[0] policy
     /* 2070990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071000 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10935:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2071003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071026 */     // GIR_Coverage, 18281,
     /* 2071026 */     GIR_EraseRootFromParent_Done,
     /* 2071027 */   // Label 27343: @2071027
     /* 2071027 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2071118), // Rule ID 18284 //
     /* 2071032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2071035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2071043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2071046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2071049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2071052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2071070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071078 */     // MIs[0] round
     /* 2071078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071081 */     // MIs[0] policy
     /* 2071081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071091 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2071094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071117 */     // GIR_Coverage, 18284,
     /* 2071117 */     GIR_EraseRootFromParent_Done,
     /* 2071118 */   // Label 27344: @2071118
     /* 2071118 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2071209), // Rule ID 18285 //
     /* 2071123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2071126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2071134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2071137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2071140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2071143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2071161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071169 */     // MIs[0] round
     /* 2071169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071172 */     // MIs[0] policy
     /* 2071172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10935:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2071185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071208 */     // GIR_Coverage, 18285,
     /* 2071208 */     GIR_EraseRootFromParent_Done,
     /* 2071209 */   // Label 27345: @2071209
     /* 2071209 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2071300), // Rule ID 18288 //
     /* 2071214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2071217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2071225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2071228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2071234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071260 */     // MIs[0] round
     /* 2071260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071263 */     // MIs[0] policy
     /* 2071263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071273 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2071276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071299 */     // GIR_Coverage, 18288,
     /* 2071299 */     GIR_EraseRootFromParent_Done,
     /* 2071300 */   // Label 27346: @2071300
     /* 2071300 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2071391), // Rule ID 18289 //
     /* 2071305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2071308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2071316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2071319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2071325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071351 */     // MIs[0] round
     /* 2071351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071354 */     // MIs[0] policy
     /* 2071354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071364 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2071367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071390 */     // GIR_Coverage, 18289,
     /* 2071390 */     GIR_EraseRootFromParent_Done,
     /* 2071391 */   // Label 27347: @2071391
     /* 2071391 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2071482), // Rule ID 18292 //
     /* 2071396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2071399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2071407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2071410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2071416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071442 */     // MIs[0] round
     /* 2071442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071445 */     // MIs[0] policy
     /* 2071445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071455 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2071458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071481 */     // GIR_Coverage, 18292,
     /* 2071481 */     GIR_EraseRootFromParent_Done,
     /* 2071482 */   // Label 27348: @2071482
     /* 2071482 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2071573), // Rule ID 18293 //
     /* 2071487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2071490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2071498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2071501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2071507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071533 */     // MIs[0] round
     /* 2071533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071536 */     // MIs[0] policy
     /* 2071536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071546 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2071549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071572 */     // GIR_Coverage, 18293,
     /* 2071572 */     GIR_EraseRootFromParent_Done,
     /* 2071573 */   // Label 27349: @2071573
     /* 2071573 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2071664), // Rule ID 18296 //
     /* 2071578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2071581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2071589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2071592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2071598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071624 */     // MIs[0] round
     /* 2071624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071627 */     // MIs[0] policy
     /* 2071627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071637 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2071640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071663 */     // GIR_Coverage, 18296,
     /* 2071663 */     GIR_EraseRootFromParent_Done,
     /* 2071664 */   // Label 27350: @2071664
     /* 2071664 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2071755), // Rule ID 18297 //
     /* 2071669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2071672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2071680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2071683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2071686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2071689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2071707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071715 */     // MIs[0] round
     /* 2071715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071718 */     // MIs[0] policy
     /* 2071718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071728 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2071731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071754 */     // GIR_Coverage, 18297,
     /* 2071754 */     GIR_EraseRootFromParent_Done,
     /* 2071755 */   // Label 27351: @2071755
     /* 2071755 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2071846), // Rule ID 18300 //
     /* 2071760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2071763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2071771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2071774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2071777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2071780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2071798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071806 */     // MIs[0] round
     /* 2071806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071809 */     // MIs[0] policy
     /* 2071809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2071822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071845 */     // GIR_Coverage, 18300,
     /* 2071845 */     GIR_EraseRootFromParent_Done,
     /* 2071846 */   // Label 27352: @2071846
     /* 2071846 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2071937), // Rule ID 18301 //
     /* 2071851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2071854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2071862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2071865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2071868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2071871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2071889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071897 */     // MIs[0] round
     /* 2071897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071900 */     // MIs[0] policy
     /* 2071900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2071913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2071917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071936 */     // GIR_Coverage, 18301,
     /* 2071936 */     GIR_EraseRootFromParent_Done,
     /* 2071937 */   // Label 27353: @2071937
     /* 2071937 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2072028), // Rule ID 18304 //
     /* 2071942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2071945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2071950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2071953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2071956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2071959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2071962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2071980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071988 */     // MIs[0] round
     /* 2071988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071991 */     // MIs[0] policy
     /* 2071991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072001 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2072004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072027 */     // GIR_Coverage, 18304,
     /* 2072027 */     GIR_EraseRootFromParent_Done,
     /* 2072028 */   // Label 27354: @2072028
     /* 2072028 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2072119), // Rule ID 18305 //
     /* 2072033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2072036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2072044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2072047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2072050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2072053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2072071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072079 */     // MIs[0] round
     /* 2072079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072082 */     // MIs[0] policy
     /* 2072082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072092 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2072095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072118 */     // GIR_Coverage, 18305,
     /* 2072118 */     GIR_EraseRootFromParent_Done,
     /* 2072119 */   // Label 27355: @2072119
     /* 2072119 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2072210), // Rule ID 18308 //
     /* 2072124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2072127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2072135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2072138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2072141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2072144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2072162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072170 */     // MIs[0] round
     /* 2072170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072173 */     // MIs[0] policy
     /* 2072173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072183 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2072186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072209 */     // GIR_Coverage, 18308,
     /* 2072209 */     GIR_EraseRootFromParent_Done,
     /* 2072210 */   // Label 27356: @2072210
     /* 2072210 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2072301), // Rule ID 18309 //
     /* 2072215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2072218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2072226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2072229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2072232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2072235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2072253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072261 */     // MIs[0] round
     /* 2072261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072264 */     // MIs[0] policy
     /* 2072264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072274 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2072277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072300 */     // GIR_Coverage, 18309,
     /* 2072300 */     GIR_EraseRootFromParent_Done,
     /* 2072301 */   // Label 27357: @2072301
     /* 2072301 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2072392), // Rule ID 18312 //
     /* 2072306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2072309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2072317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2072320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2072326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072352 */     // MIs[0] round
     /* 2072352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072355 */     // MIs[0] policy
     /* 2072355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072365 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2072368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072391 */     // GIR_Coverage, 18312,
     /* 2072391 */     GIR_EraseRootFromParent_Done,
     /* 2072392 */   // Label 27358: @2072392
     /* 2072392 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2072483), // Rule ID 18313 //
     /* 2072397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2072400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2072408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2072411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2072417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072443 */     // MIs[0] round
     /* 2072443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072446 */     // MIs[0] policy
     /* 2072446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072456 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10935:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2072459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072482 */     // GIR_Coverage, 18313,
     /* 2072482 */     GIR_EraseRootFromParent_Done,
     /* 2072483 */   // Label 27359: @2072483
     /* 2072483 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2072574), // Rule ID 18316 //
     /* 2072488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2072491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2072499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2072502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2072508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072534 */     // MIs[0] round
     /* 2072534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072537 */     // MIs[0] policy
     /* 2072537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072547 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2072550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072573 */     // GIR_Coverage, 18316,
     /* 2072573 */     GIR_EraseRootFromParent_Done,
     /* 2072574 */   // Label 27360: @2072574
     /* 2072574 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2072665), // Rule ID 18317 //
     /* 2072579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2072582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2072590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2072593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2072599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072625 */     // MIs[0] round
     /* 2072625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072628 */     // MIs[0] policy
     /* 2072628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072638 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10935:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2072641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072664 */     // GIR_Coverage, 18317,
     /* 2072664 */     GIR_EraseRootFromParent_Done,
     /* 2072665 */   // Label 27361: @2072665
     /* 2072665 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2072756), // Rule ID 18320 //
     /* 2072670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2072673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2072681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2072684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2072690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072716 */     // MIs[0] round
     /* 2072716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072719 */     // MIs[0] policy
     /* 2072719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072729 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2072732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072755 */     // GIR_Coverage, 18320,
     /* 2072755 */     GIR_EraseRootFromParent_Done,
     /* 2072756 */   // Label 27362: @2072756
     /* 2072756 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2072847), // Rule ID 18321 //
     /* 2072761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2072764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2072769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2072772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2072775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2072778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2072781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2072799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072807 */     // MIs[0] round
     /* 2072807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072810 */     // MIs[0] policy
     /* 2072810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072820 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10935:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2072823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2072843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072846 */     // GIR_Coverage, 18321,
     /* 2072846 */     GIR_EraseRootFromParent_Done,
     /* 2072847 */   // Label 27363: @2072847
     /* 2072847 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2072938), // Rule ID 18324 //
     /* 2072852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2072855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2072860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2072863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2072866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2072869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2072872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072898 */     // MIs[0] round
     /* 2072898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072901 */     // MIs[0] policy
     /* 2072901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072911 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2072914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2072918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072937 */     // GIR_Coverage, 18324,
     /* 2072937 */     GIR_EraseRootFromParent_Done,
     /* 2072938 */   // Label 27364: @2072938
     /* 2072938 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2073029), // Rule ID 18325 //
     /* 2072943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2072946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2072951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2072954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2072957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2072960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2072963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072989 */     // MIs[0] round
     /* 2072989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072992 */     // MIs[0] policy
     /* 2072992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073002 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2073005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073028 */     // GIR_Coverage, 18325,
     /* 2073028 */     GIR_EraseRootFromParent_Done,
     /* 2073029 */   // Label 27365: @2073029
     /* 2073029 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2073120), // Rule ID 18328 //
     /* 2073034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2073037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2073045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2073048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2073051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2073054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073080 */     // MIs[0] round
     /* 2073080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073083 */     // MIs[0] policy
     /* 2073083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073093 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2073096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073119 */     // GIR_Coverage, 18328,
     /* 2073119 */     GIR_EraseRootFromParent_Done,
     /* 2073120 */   // Label 27366: @2073120
     /* 2073120 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2073211), // Rule ID 18329 //
     /* 2073125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2073128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2073136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2073139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2073142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2073145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073171 */     // MIs[0] round
     /* 2073171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073174 */     // MIs[0] policy
     /* 2073174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073184 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2073187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073210 */     // GIR_Coverage, 18329,
     /* 2073210 */     GIR_EraseRootFromParent_Done,
     /* 2073211 */   // Label 27367: @2073211
     /* 2073211 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2073302), // Rule ID 18332 //
     /* 2073216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2073219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2073227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2073230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2073233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2073236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073262 */     // MIs[0] round
     /* 2073262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073265 */     // MIs[0] policy
     /* 2073265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073275 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2073278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073301 */     // GIR_Coverage, 18332,
     /* 2073301 */     GIR_EraseRootFromParent_Done,
     /* 2073302 */   // Label 27368: @2073302
     /* 2073302 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2073393), // Rule ID 18333 //
     /* 2073307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2073310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2073318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2073321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2073324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2073327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073353 */     // MIs[0] round
     /* 2073353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073356 */     // MIs[0] policy
     /* 2073356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073366 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2073369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073392 */     // GIR_Coverage, 18333,
     /* 2073392 */     GIR_EraseRootFromParent_Done,
     /* 2073393 */   // Label 27369: @2073393
     /* 2073393 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2073484), // Rule ID 18336 //
     /* 2073398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2073401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2073409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2073412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2073415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2073418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073444 */     // MIs[0] round
     /* 2073444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073447 */     // MIs[0] policy
     /* 2073447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073457 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2073460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073483 */     // GIR_Coverage, 18336,
     /* 2073483 */     GIR_EraseRootFromParent_Done,
     /* 2073484 */   // Label 27370: @2073484
     /* 2073484 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2073575), // Rule ID 18337 //
     /* 2073489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2073492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2073500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2073503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2073506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2073509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073535 */     // MIs[0] round
     /* 2073535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073538 */     // MIs[0] policy
     /* 2073538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073548 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2073551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073574 */     // GIR_Coverage, 18337,
     /* 2073574 */     GIR_EraseRootFromParent_Done,
     /* 2073575 */   // Label 27371: @2073575
     /* 2073575 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2073666), // Rule ID 18340 //
     /* 2073580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2073583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2073591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2073594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2073597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2073600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073626 */     // MIs[0] round
     /* 2073626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073629 */     // MIs[0] policy
     /* 2073629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073639 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2073642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073665 */     // GIR_Coverage, 18340,
     /* 2073665 */     GIR_EraseRootFromParent_Done,
     /* 2073666 */   // Label 27372: @2073666
     /* 2073666 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2073757), // Rule ID 18341 //
     /* 2073671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2073674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2073682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2073685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2073688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2073691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073717 */     // MIs[0] round
     /* 2073717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073720 */     // MIs[0] policy
     /* 2073720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073730 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2073733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073756 */     // GIR_Coverage, 18341,
     /* 2073756 */     GIR_EraseRootFromParent_Done,
     /* 2073757 */   // Label 27373: @2073757
     /* 2073757 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2073848), // Rule ID 18344 //
     /* 2073762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2073765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073808 */     // MIs[0] round
     /* 2073808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073811 */     // MIs[0] policy
     /* 2073811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073821 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2073824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073847 */     // GIR_Coverage, 18344,
     /* 2073847 */     GIR_EraseRootFromParent_Done,
     /* 2073848 */   // Label 27374: @2073848
     /* 2073848 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2073939), // Rule ID 18345 //
     /* 2073853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2073856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073899 */     // MIs[0] round
     /* 2073899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073902 */     // MIs[0] policy
     /* 2073902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073912 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2073915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2073919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073938 */     // GIR_Coverage, 18345,
     /* 2073938 */     GIR_EraseRootFromParent_Done,
     /* 2073939 */   // Label 27375: @2073939
     /* 2073939 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2074030), // Rule ID 18348 //
     /* 2073944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2073947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2073952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2073955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2073958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2073961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2073964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073990 */     // MIs[0] round
     /* 2073990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073993 */     // MIs[0] policy
     /* 2073993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074003 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2074006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074029 */     // GIR_Coverage, 18348,
     /* 2074029 */     GIR_EraseRootFromParent_Done,
     /* 2074030 */   // Label 27376: @2074030
     /* 2074030 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2074121), // Rule ID 18349 //
     /* 2074035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2074038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2074046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2074049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2074052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2074055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074081 */     // MIs[0] round
     /* 2074081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074084 */     // MIs[0] policy
     /* 2074084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074094 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2074097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074120 */     // GIR_Coverage, 18349,
     /* 2074120 */     GIR_EraseRootFromParent_Done,
     /* 2074121 */   // Label 27377: @2074121
     /* 2074121 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2074212), // Rule ID 18352 //
     /* 2074126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2074129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2074137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2074140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2074143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2074146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074172 */     // MIs[0] round
     /* 2074172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074175 */     // MIs[0] policy
     /* 2074175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074185 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2074188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074211 */     // GIR_Coverage, 18352,
     /* 2074211 */     GIR_EraseRootFromParent_Done,
     /* 2074212 */   // Label 27378: @2074212
     /* 2074212 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2074303), // Rule ID 18353 //
     /* 2074217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2074220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2074228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2074231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2074234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2074237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074263 */     // MIs[0] round
     /* 2074263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074266 */     // MIs[0] policy
     /* 2074266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074276 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2074279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074302 */     // GIR_Coverage, 18353,
     /* 2074302 */     GIR_EraseRootFromParent_Done,
     /* 2074303 */   // Label 27379: @2074303
     /* 2074303 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2074394), // Rule ID 18356 //
     /* 2074308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2074311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2074328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074354 */     // MIs[0] round
     /* 2074354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074357 */     // MIs[0] policy
     /* 2074357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074367 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2074370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074393 */     // GIR_Coverage, 18356,
     /* 2074393 */     GIR_EraseRootFromParent_Done,
     /* 2074394 */   // Label 27380: @2074394
     /* 2074394 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2074485), // Rule ID 18357 //
     /* 2074399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2074402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2074419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074445 */     // MIs[0] round
     /* 2074445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074448 */     // MIs[0] policy
     /* 2074448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074458 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2074461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074484 */     // GIR_Coverage, 18357,
     /* 2074484 */     GIR_EraseRootFromParent_Done,
     /* 2074485 */   // Label 27381: @2074485
     /* 2074485 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2074576), // Rule ID 18360 //
     /* 2074490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2074493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2074510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074536 */     // MIs[0] round
     /* 2074536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074539 */     // MIs[0] policy
     /* 2074539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074549 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2074552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074575 */     // GIR_Coverage, 18360,
     /* 2074575 */     GIR_EraseRootFromParent_Done,
     /* 2074576 */   // Label 27382: @2074576
     /* 2074576 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2074667), // Rule ID 18361 //
     /* 2074581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2074584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2074601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074627 */     // MIs[0] round
     /* 2074627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074630 */     // MIs[0] policy
     /* 2074630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074640 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2074643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074666 */     // GIR_Coverage, 18361,
     /* 2074666 */     GIR_EraseRootFromParent_Done,
     /* 2074667 */   // Label 27383: @2074667
     /* 2074667 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2074758), // Rule ID 18364 //
     /* 2074672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2074675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2074692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074718 */     // MIs[0] round
     /* 2074718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074721 */     // MIs[0] policy
     /* 2074721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074731 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2074734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074757 */     // GIR_Coverage, 18364,
     /* 2074757 */     GIR_EraseRootFromParent_Done,
     /* 2074758 */   // Label 27384: @2074758
     /* 2074758 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2074849), // Rule ID 18365 //
     /* 2074763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2074766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2074783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074809 */     // MIs[0] round
     /* 2074809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074812 */     // MIs[0] policy
     /* 2074812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074822 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2074825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074848 */     // GIR_Coverage, 18365,
     /* 2074848 */     GIR_EraseRootFromParent_Done,
     /* 2074849 */   // Label 27385: @2074849
     /* 2074849 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2074940), // Rule ID 18368 //
     /* 2074854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2074857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2074865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2074868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2074871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2074874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074900 */     // MIs[0] round
     /* 2074900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074903 */     // MIs[0] policy
     /* 2074903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074913 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2074916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2074920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074939 */     // GIR_Coverage, 18368,
     /* 2074939 */     GIR_EraseRootFromParent_Done,
     /* 2074940 */   // Label 27386: @2074940
     /* 2074940 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2075031), // Rule ID 18369 //
     /* 2074945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2074948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2074953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2074956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2074959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2074962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2074965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074991 */     // MIs[0] round
     /* 2074991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074994 */     // MIs[0] policy
     /* 2074994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075004 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2075007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075030 */     // GIR_Coverage, 18369,
     /* 2075030 */     GIR_EraseRootFromParent_Done,
     /* 2075031 */   // Label 27387: @2075031
     /* 2075031 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2075122), // Rule ID 18372 //
     /* 2075036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2075039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2075047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2075050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2075053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2075056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075082 */     // MIs[0] round
     /* 2075082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075085 */     // MIs[0] policy
     /* 2075085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075095 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2075098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075121 */     // GIR_Coverage, 18372,
     /* 2075121 */     GIR_EraseRootFromParent_Done,
     /* 2075122 */   // Label 27388: @2075122
     /* 2075122 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2075213), // Rule ID 18373 //
     /* 2075127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2075130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2075138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2075141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2075144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2075147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075173 */     // MIs[0] round
     /* 2075173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075176 */     // MIs[0] policy
     /* 2075176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2075189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075212 */     // GIR_Coverage, 18373,
     /* 2075212 */     GIR_EraseRootFromParent_Done,
     /* 2075213 */   // Label 27389: @2075213
     /* 2075213 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2075304), // Rule ID 18376 //
     /* 2075218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2075221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2075238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075264 */     // MIs[0] round
     /* 2075264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075267 */     // MIs[0] policy
     /* 2075267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075277 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2075280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075303 */     // GIR_Coverage, 18376,
     /* 2075303 */     GIR_EraseRootFromParent_Done,
     /* 2075304 */   // Label 27390: @2075304
     /* 2075304 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2075395), // Rule ID 18377 //
     /* 2075309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2075312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2075329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075355 */     // MIs[0] round
     /* 2075355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075358 */     // MIs[0] policy
     /* 2075358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2075371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075394 */     // GIR_Coverage, 18377,
     /* 2075394 */     GIR_EraseRootFromParent_Done,
     /* 2075395 */   // Label 27391: @2075395
     /* 2075395 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2075486), // Rule ID 18380 //
     /* 2075400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2075403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2075420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075446 */     // MIs[0] round
     /* 2075446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075449 */     // MIs[0] policy
     /* 2075449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075459 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2075462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075485 */     // GIR_Coverage, 18380,
     /* 2075485 */     GIR_EraseRootFromParent_Done,
     /* 2075486 */   // Label 27392: @2075486
     /* 2075486 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2075577), // Rule ID 18381 //
     /* 2075491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2075494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2075511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075537 */     // MIs[0] round
     /* 2075537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075540 */     // MIs[0] policy
     /* 2075540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075550 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2075553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075576 */     // GIR_Coverage, 18381,
     /* 2075576 */     GIR_EraseRootFromParent_Done,
     /* 2075577 */   // Label 27393: @2075577
     /* 2075577 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2075668), // Rule ID 18384 //
     /* 2075582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2075585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2075599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2075620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075628 */     // MIs[0] round
     /* 2075628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075631 */     // MIs[0] policy
     /* 2075631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075641 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2075644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075667 */     // GIR_Coverage, 18384,
     /* 2075667 */     GIR_EraseRootFromParent_Done,
     /* 2075668 */   // Label 27394: @2075668
     /* 2075668 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2075759), // Rule ID 18385 //
     /* 2075673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2075676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2075690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2075711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075719 */     // MIs[0] round
     /* 2075719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075722 */     // MIs[0] policy
     /* 2075722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075732 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2075735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075758 */     // GIR_Coverage, 18385,
     /* 2075758 */     GIR_EraseRootFromParent_Done,
     /* 2075759 */   // Label 27395: @2075759
     /* 2075759 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2075850), // Rule ID 18388 //
     /* 2075764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2075767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2075781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2075802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075810 */     // MIs[0] round
     /* 2075810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075813 */     // MIs[0] policy
     /* 2075813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075823 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2075826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075849 */     // GIR_Coverage, 18388,
     /* 2075849 */     GIR_EraseRootFromParent_Done,
     /* 2075850 */   // Label 27396: @2075850
     /* 2075850 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2075941), // Rule ID 18389 //
     /* 2075855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2075858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2075872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2075893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075901 */     // MIs[0] round
     /* 2075901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075904 */     // MIs[0] policy
     /* 2075904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2075917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2075921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075940 */     // GIR_Coverage, 18389,
     /* 2075940 */     GIR_EraseRootFromParent_Done,
     /* 2075941 */   // Label 27397: @2075941
     /* 2075941 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2076032), // Rule ID 18392 //
     /* 2075946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2075949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2075954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2075963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2075984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075992 */     // MIs[0] round
     /* 2075992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075995 */     // MIs[0] policy
     /* 2075995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076005 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2076008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076031 */     // GIR_Coverage, 18392,
     /* 2076031 */     GIR_EraseRootFromParent_Done,
     /* 2076032 */   // Label 27398: @2076032
     /* 2076032 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2076123), // Rule ID 18393 //
     /* 2076037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2076040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2076054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2076057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2076075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076083 */     // MIs[0] round
     /* 2076083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076086 */     // MIs[0] policy
     /* 2076086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076096 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2076099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076122 */     // GIR_Coverage, 18393,
     /* 2076122 */     GIR_EraseRootFromParent_Done,
     /* 2076123 */   // Label 27399: @2076123
     /* 2076123 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2076214), // Rule ID 18396 //
     /* 2076128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2076131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076174 */     // MIs[0] round
     /* 2076174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076177 */     // MIs[0] policy
     /* 2076177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076187 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2076190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076213 */     // GIR_Coverage, 18396,
     /* 2076213 */     GIR_EraseRootFromParent_Done,
     /* 2076214 */   // Label 27400: @2076214
     /* 2076214 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2076305), // Rule ID 18397 //
     /* 2076219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2076222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076265 */     // MIs[0] round
     /* 2076265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076268 */     // MIs[0] policy
     /* 2076268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076278 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10908:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2076281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076304 */     // GIR_Coverage, 18397,
     /* 2076304 */     GIR_EraseRootFromParent_Done,
     /* 2076305 */   // Label 27401: @2076305
     /* 2076305 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2076396), // Rule ID 18400 //
     /* 2076310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2076313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2076327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2076348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076356 */     // MIs[0] round
     /* 2076356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076359 */     // MIs[0] policy
     /* 2076359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076369 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2076372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076395 */     // GIR_Coverage, 18400,
     /* 2076395 */     GIR_EraseRootFromParent_Done,
     /* 2076396 */   // Label 27402: @2076396
     /* 2076396 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2076487), // Rule ID 18401 //
     /* 2076401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2076404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2076418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2076439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076447 */     // MIs[0] round
     /* 2076447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076450 */     // MIs[0] policy
     /* 2076450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076460 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10908:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2076463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076486 */     // GIR_Coverage, 18401,
     /* 2076486 */     GIR_EraseRootFromParent_Done,
     /* 2076487 */   // Label 27403: @2076487
     /* 2076487 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2076578), // Rule ID 18404 //
     /* 2076492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2076495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2076509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2076530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076538 */     // MIs[0] round
     /* 2076538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076541 */     // MIs[0] policy
     /* 2076541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076551 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2076554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076577 */     // GIR_Coverage, 18404,
     /* 2076577 */     GIR_EraseRootFromParent_Done,
     /* 2076578 */   // Label 27404: @2076578
     /* 2076578 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2076669), // Rule ID 18405 //
     /* 2076583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2076586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2076600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2076621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076629 */     // MIs[0] round
     /* 2076629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076632 */     // MIs[0] policy
     /* 2076632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076642 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10908:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2076645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076668 */     // GIR_Coverage, 18405,
     /* 2076668 */     GIR_EraseRootFromParent_Done,
     /* 2076669 */   // Label 27405: @2076669
     /* 2076669 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2076760), // Rule ID 18408 //
     /* 2076674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2076677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2076685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2076688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2076694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076720 */     // MIs[0] round
     /* 2076720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076723 */     // MIs[0] policy
     /* 2076723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076733 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2076736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076759 */     // GIR_Coverage, 18408,
     /* 2076759 */     GIR_EraseRootFromParent_Done,
     /* 2076760 */   // Label 27406: @2076760
     /* 2076760 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2076851), // Rule ID 18409 //
     /* 2076765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2076768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2076776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2076779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2076785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076811 */     // MIs[0] round
     /* 2076811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076814 */     // MIs[0] policy
     /* 2076814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2076827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076850 */     // GIR_Coverage, 18409,
     /* 2076850 */     GIR_EraseRootFromParent_Done,
     /* 2076851 */   // Label 27407: @2076851
     /* 2076851 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2076942), // Rule ID 18412 //
     /* 2076856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2076859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2076867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2076870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2076876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076902 */     // MIs[0] round
     /* 2076902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076905 */     // MIs[0] policy
     /* 2076905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076915 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2076918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2076922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076941 */     // GIR_Coverage, 18412,
     /* 2076941 */     GIR_EraseRootFromParent_Done,
     /* 2076942 */   // Label 27408: @2076942
     /* 2076942 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2077033), // Rule ID 18413 //
     /* 2076947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2076950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2076955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2076958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2076961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2076964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2076967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2076985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076993 */     // MIs[0] round
     /* 2076993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076996 */     // MIs[0] policy
     /* 2076996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077006 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2077009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077032 */     // GIR_Coverage, 18413,
     /* 2077032 */     GIR_EraseRootFromParent_Done,
     /* 2077033 */   // Label 27409: @2077033
     /* 2077033 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2077124), // Rule ID 18416 //
     /* 2077038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2077041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2077055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2077076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077084 */     // MIs[0] round
     /* 2077084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077087 */     // MIs[0] policy
     /* 2077087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077097 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2077100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077123 */     // GIR_Coverage, 18416,
     /* 2077123 */     GIR_EraseRootFromParent_Done,
     /* 2077124 */   // Label 27410: @2077124
     /* 2077124 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2077215), // Rule ID 18417 //
     /* 2077129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2077132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2077146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2077167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077175 */     // MIs[0] round
     /* 2077175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077178 */     // MIs[0] policy
     /* 2077178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077188 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2077191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077214 */     // GIR_Coverage, 18417,
     /* 2077214 */     GIR_EraseRootFromParent_Done,
     /* 2077215 */   // Label 27411: @2077215
     /* 2077215 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2077306), // Rule ID 18420 //
     /* 2077220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2077223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077266 */     // MIs[0] round
     /* 2077266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077269 */     // MIs[0] policy
     /* 2077269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077279 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2077282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077305 */     // GIR_Coverage, 18420,
     /* 2077305 */     GIR_EraseRootFromParent_Done,
     /* 2077306 */   // Label 27412: @2077306
     /* 2077306 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2077397), // Rule ID 18421 //
     /* 2077311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2077314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077357 */     // MIs[0] round
     /* 2077357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077360 */     // MIs[0] policy
     /* 2077360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2077373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077396 */     // GIR_Coverage, 18421,
     /* 2077396 */     GIR_EraseRootFromParent_Done,
     /* 2077397 */   // Label 27413: @2077397
     /* 2077397 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2077488), // Rule ID 18424 //
     /* 2077402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2077405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077448 */     // MIs[0] round
     /* 2077448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077451 */     // MIs[0] policy
     /* 2077451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077461 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2077464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077487 */     // GIR_Coverage, 18424,
     /* 2077487 */     GIR_EraseRootFromParent_Done,
     /* 2077488 */   // Label 27414: @2077488
     /* 2077488 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2077579), // Rule ID 18425 //
     /* 2077493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2077496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077539 */     // MIs[0] round
     /* 2077539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077542 */     // MIs[0] policy
     /* 2077542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2077555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077578 */     // GIR_Coverage, 18425,
     /* 2077578 */     GIR_EraseRootFromParent_Done,
     /* 2077579 */   // Label 27415: @2077579
     /* 2077579 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2077670), // Rule ID 18428 //
     /* 2077584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2077587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077630 */     // MIs[0] round
     /* 2077630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077633 */     // MIs[0] policy
     /* 2077633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077643 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2077646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077669 */     // GIR_Coverage, 18428,
     /* 2077669 */     GIR_EraseRootFromParent_Done,
     /* 2077670 */   // Label 27416: @2077670
     /* 2077670 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2077761), // Rule ID 18429 //
     /* 2077675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2077678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2077692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2077713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077721 */     // MIs[0] round
     /* 2077721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077724 */     // MIs[0] policy
     /* 2077724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2077737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077760 */     // GIR_Coverage, 18429,
     /* 2077760 */     GIR_EraseRootFromParent_Done,
     /* 2077761 */   // Label 27417: @2077761
     /* 2077761 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2077852), // Rule ID 18432 //
     /* 2077766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2077769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2077783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2077786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2077804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077812 */     // MIs[0] round
     /* 2077812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077815 */     // MIs[0] policy
     /* 2077815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077825 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2077828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077851 */     // GIR_Coverage, 18432,
     /* 2077851 */     GIR_EraseRootFromParent_Done,
     /* 2077852 */   // Label 27418: @2077852
     /* 2077852 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2077943), // Rule ID 18433 //
     /* 2077857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2077860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2077874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2077877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2077895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077903 */     // MIs[0] round
     /* 2077903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077906 */     // MIs[0] policy
     /* 2077906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10908:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2077919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2077923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077942 */     // GIR_Coverage, 18433,
     /* 2077942 */     GIR_EraseRootFromParent_Done,
     /* 2077943 */   // Label 27419: @2077943
     /* 2077943 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2078034), // Rule ID 18436 //
     /* 2077948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2077951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2077956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2077959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2077962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2077965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2077968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2077986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077994 */     // MIs[0] round
     /* 2077994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077997 */     // MIs[0] policy
     /* 2077997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078007 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2078010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078033 */     // GIR_Coverage, 18436,
     /* 2078033 */     GIR_EraseRootFromParent_Done,
     /* 2078034 */   // Label 27420: @2078034
     /* 2078034 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2078125), // Rule ID 18437 //
     /* 2078039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2078042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2078047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2078056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2078077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078085 */     // MIs[0] round
     /* 2078085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078088 */     // MIs[0] policy
     /* 2078088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078098 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10908:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2078101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078124 */     // GIR_Coverage, 18437,
     /* 2078124 */     GIR_EraseRootFromParent_Done,
     /* 2078125 */   // Label 27421: @2078125
     /* 2078125 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2078216), // Rule ID 18440 //
     /* 2078130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2078133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2078138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2078147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2078168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078176 */     // MIs[0] round
     /* 2078176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078179 */     // MIs[0] policy
     /* 2078179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078189 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2078192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078215 */     // GIR_Coverage, 18440,
     /* 2078215 */     GIR_EraseRootFromParent_Done,
     /* 2078216 */   // Label 27422: @2078216
     /* 2078216 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2078307), // Rule ID 18441 //
     /* 2078221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2078224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2078229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2078238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2078259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078267 */     // MIs[0] round
     /* 2078267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078270 */     // MIs[0] policy
     /* 2078270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078280 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10908:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2078283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078306 */     // GIR_Coverage, 18441,
     /* 2078306 */     GIR_EraseRootFromParent_Done,
     /* 2078307 */   // Label 27423: @2078307
     /* 2078307 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2078398), // Rule ID 18444 //
     /* 2078312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2078315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2078323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2078326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2078329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2078332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078358 */     // MIs[0] round
     /* 2078358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078361 */     // MIs[0] policy
     /* 2078361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078371 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2078374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078397 */     // GIR_Coverage, 18444,
     /* 2078397 */     GIR_EraseRootFromParent_Done,
     /* 2078398 */   // Label 27424: @2078398
     /* 2078398 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2078489), // Rule ID 18445 //
     /* 2078403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2078406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2078414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2078417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2078420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2078423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078449 */     // MIs[0] round
     /* 2078449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078452 */     // MIs[0] policy
     /* 2078452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2078465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078488 */     // GIR_Coverage, 18445,
     /* 2078488 */     GIR_EraseRootFromParent_Done,
     /* 2078489 */   // Label 27425: @2078489
     /* 2078489 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2078580), // Rule ID 18448 //
     /* 2078494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2078497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2078505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2078508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2078511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2078514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078540 */     // MIs[0] round
     /* 2078540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078543 */     // MIs[0] policy
     /* 2078543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078553 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2078556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078579 */     // GIR_Coverage, 18448,
     /* 2078579 */     GIR_EraseRootFromParent_Done,
     /* 2078580 */   // Label 27426: @2078580
     /* 2078580 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2078671), // Rule ID 18449 //
     /* 2078585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2078588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2078596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2078599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2078602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2078605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078631 */     // MIs[0] round
     /* 2078631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078634 */     // MIs[0] policy
     /* 2078634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078644 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2078647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078670 */     // GIR_Coverage, 18449,
     /* 2078670 */     GIR_EraseRootFromParent_Done,
     /* 2078671 */   // Label 27427: @2078671
     /* 2078671 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2078762), // Rule ID 18452 //
     /* 2078676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2078679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2078687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2078690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2078693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2078696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078722 */     // MIs[0] round
     /* 2078722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078725 */     // MIs[0] policy
     /* 2078725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078735 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2078738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078761 */     // GIR_Coverage, 18452,
     /* 2078761 */     GIR_EraseRootFromParent_Done,
     /* 2078762 */   // Label 27428: @2078762
     /* 2078762 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2078853), // Rule ID 18453 //
     /* 2078767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2078770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2078778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2078781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2078784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2078787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078813 */     // MIs[0] round
     /* 2078813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078816 */     // MIs[0] policy
     /* 2078816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078826 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2078829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078852 */     // GIR_Coverage, 18453,
     /* 2078852 */     GIR_EraseRootFromParent_Done,
     /* 2078853 */   // Label 27429: @2078853
     /* 2078853 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2078944), // Rule ID 18456 //
     /* 2078858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2078861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2078869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2078872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2078875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2078878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078904 */     // MIs[0] round
     /* 2078904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078907 */     // MIs[0] policy
     /* 2078907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078917 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2078920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2078924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078943 */     // GIR_Coverage, 18456,
     /* 2078943 */     GIR_EraseRootFromParent_Done,
     /* 2078944 */   // Label 27430: @2078944
     /* 2078944 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2079035), // Rule ID 18457 //
     /* 2078949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2078952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2078957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2078960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2078963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2078966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2078969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078995 */     // MIs[0] round
     /* 2078995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078998 */     // MIs[0] policy
     /* 2078998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2079011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079034 */     // GIR_Coverage, 18457,
     /* 2079034 */     GIR_EraseRootFromParent_Done,
     /* 2079035 */   // Label 27431: @2079035
     /* 2079035 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2079126), // Rule ID 18460 //
     /* 2079040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2079043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2079051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2079054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2079057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2079060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079086 */     // MIs[0] round
     /* 2079086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079089 */     // MIs[0] policy
     /* 2079089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2079102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079125 */     // GIR_Coverage, 18460,
     /* 2079125 */     GIR_EraseRootFromParent_Done,
     /* 2079126 */   // Label 27432: @2079126
     /* 2079126 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2079217), // Rule ID 18461 //
     /* 2079131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2079134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2079142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2079145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2079148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2079151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079177 */     // MIs[0] round
     /* 2079177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079180 */     // MIs[0] policy
     /* 2079180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2079193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079216 */     // GIR_Coverage, 18461,
     /* 2079216 */     GIR_EraseRootFromParent_Done,
     /* 2079217 */   // Label 27433: @2079217
     /* 2079217 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2079308), // Rule ID 18464 //
     /* 2079222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2079225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2079233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2079236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2079239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2079242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079268 */     // MIs[0] round
     /* 2079268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079271 */     // MIs[0] policy
     /* 2079271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079281 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2079284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079307 */     // GIR_Coverage, 18464,
     /* 2079307 */     GIR_EraseRootFromParent_Done,
     /* 2079308 */   // Label 27434: @2079308
     /* 2079308 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2079399), // Rule ID 18465 //
     /* 2079313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2079316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2079324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2079327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2079330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2079333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079359 */     // MIs[0] round
     /* 2079359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079362 */     // MIs[0] policy
     /* 2079362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079372 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2079375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079398 */     // GIR_Coverage, 18465,
     /* 2079398 */     GIR_EraseRootFromParent_Done,
     /* 2079399 */   // Label 27435: @2079399
     /* 2079399 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2079490), // Rule ID 18468 //
     /* 2079404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2079407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2079415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2079418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2079421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2079424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2079434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079450 */     // MIs[0] round
     /* 2079450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079453 */     // MIs[0] policy
     /* 2079453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079463 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2079466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079489 */     // GIR_Coverage, 18468,
     /* 2079489 */     GIR_EraseRootFromParent_Done,
     /* 2079490 */   // Label 27436: @2079490
     /* 2079490 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2079581), // Rule ID 18469 //
     /* 2079495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2079498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2079506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2079509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2079512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2079515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2079525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079541 */     // MIs[0] round
     /* 2079541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079544 */     // MIs[0] policy
     /* 2079544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2079557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079580 */     // GIR_Coverage, 18469,
     /* 2079580 */     GIR_EraseRootFromParent_Done,
     /* 2079581 */   // Label 27437: @2079581
     /* 2079581 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2079672), // Rule ID 18472 //
     /* 2079586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2079589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2079597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2079600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2079603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2079606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2079609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079632 */     // MIs[0] round
     /* 2079632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079635 */     // MIs[0] policy
     /* 2079635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079645 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2079648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079671 */     // GIR_Coverage, 18472,
     /* 2079671 */     GIR_EraseRootFromParent_Done,
     /* 2079672 */   // Label 27438: @2079672
     /* 2079672 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2079763), // Rule ID 18473 //
     /* 2079677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2079680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2079688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2079691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2079694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2079697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2079700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079723 */     // MIs[0] round
     /* 2079723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079726 */     // MIs[0] policy
     /* 2079726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2079739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079762 */     // GIR_Coverage, 18473,
     /* 2079762 */     GIR_EraseRootFromParent_Done,
     /* 2079763 */   // Label 27439: @2079763
     /* 2079763 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2079854), // Rule ID 18476 //
     /* 2079768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2079771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2079779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2079782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2079785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2079788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2079791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079814 */     // MIs[0] round
     /* 2079814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079817 */     // MIs[0] policy
     /* 2079817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079827 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2079830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079853 */     // GIR_Coverage, 18476,
     /* 2079853 */     GIR_EraseRootFromParent_Done,
     /* 2079854 */   // Label 27440: @2079854
     /* 2079854 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2079945), // Rule ID 18477 //
     /* 2079859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2079862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2079870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2079873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2079876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2079879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2079882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079905 */     // MIs[0] round
     /* 2079905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079908 */     // MIs[0] policy
     /* 2079908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079918 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2079921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2079925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079944 */     // GIR_Coverage, 18477,
     /* 2079944 */     GIR_EraseRootFromParent_Done,
     /* 2079945 */   // Label 27441: @2079945
     /* 2079945 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2080036), // Rule ID 18480 //
     /* 2079950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2079953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2079958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2079961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2079964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2079967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2079970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2079980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079996 */     // MIs[0] round
     /* 2079996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079999 */     // MIs[0] policy
     /* 2079999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080009 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2080012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080035 */     // GIR_Coverage, 18480,
     /* 2080035 */     GIR_EraseRootFromParent_Done,
     /* 2080036 */   // Label 27442: @2080036
     /* 2080036 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2080127), // Rule ID 18481 //
     /* 2080041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2080044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2080052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2080055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2080058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2080061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080087 */     // MIs[0] round
     /* 2080087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080090 */     // MIs[0] policy
     /* 2080090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2080103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080126 */     // GIR_Coverage, 18481,
     /* 2080126 */     GIR_EraseRootFromParent_Done,
     /* 2080127 */   // Label 27443: @2080127
     /* 2080127 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2080218), // Rule ID 18484 //
     /* 2080132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2080135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2080143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2080146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2080149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2080152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080178 */     // MIs[0] round
     /* 2080178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080181 */     // MIs[0] policy
     /* 2080181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080191 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2080194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080217 */     // GIR_Coverage, 18484,
     /* 2080217 */     GIR_EraseRootFromParent_Done,
     /* 2080218 */   // Label 27444: @2080218
     /* 2080218 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2080309), // Rule ID 18485 //
     /* 2080223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2080226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2080234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2080237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2080240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2080243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080269 */     // MIs[0] round
     /* 2080269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080272 */     // MIs[0] policy
     /* 2080272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2080285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080308 */     // GIR_Coverage, 18485,
     /* 2080308 */     GIR_EraseRootFromParent_Done,
     /* 2080309 */   // Label 27445: @2080309
     /* 2080309 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2080400), // Rule ID 18488 //
     /* 2080314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2080317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2080325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2080328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2080331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2080334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080360 */     // MIs[0] round
     /* 2080360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080363 */     // MIs[0] policy
     /* 2080363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080373 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2080376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080399 */     // GIR_Coverage, 18488,
     /* 2080399 */     GIR_EraseRootFromParent_Done,
     /* 2080400 */   // Label 27446: @2080400
     /* 2080400 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2080491), // Rule ID 18489 //
     /* 2080405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2080408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2080416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2080419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2080422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2080425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080451 */     // MIs[0] round
     /* 2080451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080454 */     // MIs[0] policy
     /* 2080454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080464 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2080467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080490 */     // GIR_Coverage, 18489,
     /* 2080490 */     GIR_EraseRootFromParent_Done,
     /* 2080491 */   // Label 27447: @2080491
     /* 2080491 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2080582), // Rule ID 18492 //
     /* 2080496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2080499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2080507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2080510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2080513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2080516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080542 */     // MIs[0] round
     /* 2080542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080545 */     // MIs[0] policy
     /* 2080545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080555 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2080558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080581 */     // GIR_Coverage, 18492,
     /* 2080581 */     GIR_EraseRootFromParent_Done,
     /* 2080582 */   // Label 27448: @2080582
     /* 2080582 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2080673), // Rule ID 18493 //
     /* 2080587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2080590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2080598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2080601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2080604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2080607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080633 */     // MIs[0] round
     /* 2080633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080636 */     // MIs[0] policy
     /* 2080636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080646 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2080649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080672 */     // GIR_Coverage, 18493,
     /* 2080672 */     GIR_EraseRootFromParent_Done,
     /* 2080673 */   // Label 27449: @2080673
     /* 2080673 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2080764), // Rule ID 18496 //
     /* 2080678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2080681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2080689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2080692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2080695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2080698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080724 */     // MIs[0] round
     /* 2080724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080727 */     // MIs[0] policy
     /* 2080727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080737 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2080740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080763 */     // GIR_Coverage, 18496,
     /* 2080763 */     GIR_EraseRootFromParent_Done,
     /* 2080764 */   // Label 27450: @2080764
     /* 2080764 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2080855), // Rule ID 18497 //
     /* 2080769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2080772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2080780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2080783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2080786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2080789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080815 */     // MIs[0] round
     /* 2080815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080818 */     // MIs[0] policy
     /* 2080818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080828 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2080831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080854 */     // GIR_Coverage, 18497,
     /* 2080854 */     GIR_EraseRootFromParent_Done,
     /* 2080855 */   // Label 27451: @2080855
     /* 2080855 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2080946), // Rule ID 18500 //
     /* 2080860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2080863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2080871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2080874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2080877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2080880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080906 */     // MIs[0] round
     /* 2080906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080909 */     // MIs[0] policy
     /* 2080909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080919 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2080922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2080926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080945 */     // GIR_Coverage, 18500,
     /* 2080945 */     GIR_EraseRootFromParent_Done,
     /* 2080946 */   // Label 27452: @2080946
     /* 2080946 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2081037), // Rule ID 18501 //
     /* 2080951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2080954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2080959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2080962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2080965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2080968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2080971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080997 */     // MIs[0] round
     /* 2080997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081000 */     // MIs[0] policy
     /* 2081000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081010 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2081013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2081033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081036 */     // GIR_Coverage, 18501,
     /* 2081036 */     GIR_EraseRootFromParent_Done,
     /* 2081037 */   // Label 27453: @2081037
     /* 2081037 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2081128), // Rule ID 18504 //
     /* 2081042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2081045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2081053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2081056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2081062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081088 */     // MIs[0] round
     /* 2081088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081091 */     // MIs[0] policy
     /* 2081091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081101 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2081104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081127 */     // GIR_Coverage, 18504,
     /* 2081127 */     GIR_EraseRootFromParent_Done,
     /* 2081128 */   // Label 27454: @2081128
     /* 2081128 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2081219), // Rule ID 18505 //
     /* 2081133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2081136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2081144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2081147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2081153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081179 */     // MIs[0] round
     /* 2081179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081182 */     // MIs[0] policy
     /* 2081182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081192 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2081195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081218 */     // GIR_Coverage, 18505,
     /* 2081218 */     GIR_EraseRootFromParent_Done,
     /* 2081219 */   // Label 27455: @2081219
     /* 2081219 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2081310), // Rule ID 18508 //
     /* 2081224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2081227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2081235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2081238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2081244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081270 */     // MIs[0] round
     /* 2081270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081273 */     // MIs[0] policy
     /* 2081273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081283 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2081286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081309 */     // GIR_Coverage, 18508,
     /* 2081309 */     GIR_EraseRootFromParent_Done,
     /* 2081310 */   // Label 27456: @2081310
     /* 2081310 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2081401), // Rule ID 18509 //
     /* 2081315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2081318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2081326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2081329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2081335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081361 */     // MIs[0] round
     /* 2081361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081364 */     // MIs[0] policy
     /* 2081364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2081377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081400 */     // GIR_Coverage, 18509,
     /* 2081400 */     GIR_EraseRootFromParent_Done,
     /* 2081401 */   // Label 27457: @2081401
     /* 2081401 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2081492), // Rule ID 18512 //
     /* 2081406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2081409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2081417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2081420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2081423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2081426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2081444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081452 */     // MIs[0] round
     /* 2081452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081455 */     // MIs[0] policy
     /* 2081455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081465 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2081468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081491 */     // GIR_Coverage, 18512,
     /* 2081491 */     GIR_EraseRootFromParent_Done,
     /* 2081492 */   // Label 27458: @2081492
     /* 2081492 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2081583), // Rule ID 18513 //
     /* 2081497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2081500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2081508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2081511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2081514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2081517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2081535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081543 */     // MIs[0] round
     /* 2081543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081546 */     // MIs[0] policy
     /* 2081546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081556 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2081559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081582 */     // GIR_Coverage, 18513,
     /* 2081582 */     GIR_EraseRootFromParent_Done,
     /* 2081583 */   // Label 27459: @2081583
     /* 2081583 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2081674), // Rule ID 18516 //
     /* 2081588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2081591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2081599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2081602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2081608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081634 */     // MIs[0] round
     /* 2081634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081637 */     // MIs[0] policy
     /* 2081637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081647 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2081650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081673 */     // GIR_Coverage, 18516,
     /* 2081673 */     GIR_EraseRootFromParent_Done,
     /* 2081674 */   // Label 27460: @2081674
     /* 2081674 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2081765), // Rule ID 18517 //
     /* 2081679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2081682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2081690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2081693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2081696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2081699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2081717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081725 */     // MIs[0] round
     /* 2081725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081728 */     // MIs[0] policy
     /* 2081728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081738 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 10939:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2081741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081764 */     // GIR_Coverage, 18517,
     /* 2081764 */     GIR_EraseRootFromParent_Done,
     /* 2081765 */   // Label 27461: @2081765
     /* 2081765 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2081856), // Rule ID 18520 //
     /* 2081770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2081773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2081787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2081790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2081808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081816 */     // MIs[0] round
     /* 2081816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081819 */     // MIs[0] policy
     /* 2081819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081829 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2081832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081855 */     // GIR_Coverage, 18520,
     /* 2081855 */     GIR_EraseRootFromParent_Done,
     /* 2081856 */   // Label 27462: @2081856
     /* 2081856 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2081947), // Rule ID 18521 //
     /* 2081861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2081864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2081878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2081881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2081899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081907 */     // MIs[0] round
     /* 2081907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081910 */     // MIs[0] policy
     /* 2081910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10939:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2081923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2081927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081946 */     // GIR_Coverage, 18521,
     /* 2081946 */     GIR_EraseRootFromParent_Done,
     /* 2081947 */   // Label 27463: @2081947
     /* 2081947 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2082038), // Rule ID 18524 //
     /* 2081952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2081955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2081960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2081963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2081966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2081969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2081972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2081990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081998 */     // MIs[0] round
     /* 2081998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082001 */     // MIs[0] policy
     /* 2082001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082011 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2082014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082037 */     // GIR_Coverage, 18524,
     /* 2082037 */     GIR_EraseRootFromParent_Done,
     /* 2082038 */   // Label 27464: @2082038
     /* 2082038 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2082129), // Rule ID 18525 //
     /* 2082043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2082046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2082054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2082057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2082060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2082063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2082081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082089 */     // MIs[0] round
     /* 2082089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082092 */     // MIs[0] policy
     /* 2082092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10939:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2082105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082128 */     // GIR_Coverage, 18525,
     /* 2082128 */     GIR_EraseRootFromParent_Done,
     /* 2082129 */   // Label 27465: @2082129
     /* 2082129 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2082220), // Rule ID 18528 //
     /* 2082134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2082137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2082145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2082148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2082154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082180 */     // MIs[0] round
     /* 2082180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082183 */     // MIs[0] policy
     /* 2082183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082193 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2082196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082219 */     // GIR_Coverage, 18528,
     /* 2082219 */     GIR_EraseRootFromParent_Done,
     /* 2082220 */   // Label 27466: @2082220
     /* 2082220 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2082311), // Rule ID 18529 //
     /* 2082225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2082228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2082236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2082239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2082245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082271 */     // MIs[0] round
     /* 2082271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082274 */     // MIs[0] policy
     /* 2082274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082284 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2082287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082310 */     // GIR_Coverage, 18529,
     /* 2082310 */     GIR_EraseRootFromParent_Done,
     /* 2082311 */   // Label 27467: @2082311
     /* 2082311 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2082402), // Rule ID 18532 //
     /* 2082316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2082319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2082327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2082330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2082336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082362 */     // MIs[0] round
     /* 2082362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082365 */     // MIs[0] policy
     /* 2082365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082375 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2082378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082401 */     // GIR_Coverage, 18532,
     /* 2082401 */     GIR_EraseRootFromParent_Done,
     /* 2082402 */   // Label 27468: @2082402
     /* 2082402 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2082493), // Rule ID 18533 //
     /* 2082407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2082410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2082418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2082421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2082427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082453 */     // MIs[0] round
     /* 2082453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082456 */     // MIs[0] policy
     /* 2082456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082466 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2082469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082492 */     // GIR_Coverage, 18533,
     /* 2082492 */     GIR_EraseRootFromParent_Done,
     /* 2082493 */   // Label 27469: @2082493
     /* 2082493 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2082584), // Rule ID 18536 //
     /* 2082498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2082501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2082509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2082512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2082518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2082521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082544 */     // MIs[0] round
     /* 2082544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082547 */     // MIs[0] policy
     /* 2082547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082557 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2082560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082583 */     // GIR_Coverage, 18536,
     /* 2082583 */     GIR_EraseRootFromParent_Done,
     /* 2082584 */   // Label 27470: @2082584
     /* 2082584 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2082675), // Rule ID 18537 //
     /* 2082589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2082592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2082600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2082603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2082606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2082609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2082612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2082627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082635 */     // MIs[0] round
     /* 2082635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082638 */     // MIs[0] policy
     /* 2082638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082648 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2082651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082674 */     // GIR_Coverage, 18537,
     /* 2082674 */     GIR_EraseRootFromParent_Done,
     /* 2082675 */   // Label 27471: @2082675
     /* 2082675 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2082766), // Rule ID 18540 //
     /* 2082680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2082683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2082697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2082700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2082718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082726 */     // MIs[0] round
     /* 2082726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082729 */     // MIs[0] policy
     /* 2082729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2082742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082765 */     // GIR_Coverage, 18540,
     /* 2082765 */     GIR_EraseRootFromParent_Done,
     /* 2082766 */   // Label 27472: @2082766
     /* 2082766 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2082857), // Rule ID 18541 //
     /* 2082771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2082774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2082788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2082791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2082809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082817 */     // MIs[0] round
     /* 2082817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082820 */     // MIs[0] policy
     /* 2082820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2082833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082856 */     // GIR_Coverage, 18541,
     /* 2082856 */     GIR_EraseRootFromParent_Done,
     /* 2082857 */   // Label 27473: @2082857
     /* 2082857 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2082948), // Rule ID 18544 //
     /* 2082862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2082865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2082879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2082882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2082900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082908 */     // MIs[0] round
     /* 2082908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082911 */     // MIs[0] policy
     /* 2082911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082921 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2082924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2082928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082947 */     // GIR_Coverage, 18544,
     /* 2082947 */     GIR_EraseRootFromParent_Done,
     /* 2082948 */   // Label 27474: @2082948
     /* 2082948 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2083039), // Rule ID 18545 //
     /* 2082953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2082956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2082961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2082970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2082973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2082991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082999 */     // MIs[0] round
     /* 2082999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083002 */     // MIs[0] policy
     /* 2083002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2083015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083038 */     // GIR_Coverage, 18545,
     /* 2083038 */     GIR_EraseRootFromParent_Done,
     /* 2083039 */   // Label 27475: @2083039
     /* 2083039 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2083130), // Rule ID 18548 //
     /* 2083044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2083047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2083055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2083058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2083061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2083064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2083067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2083082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083090 */     // MIs[0] round
     /* 2083090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083093 */     // MIs[0] policy
     /* 2083093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083103 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2083106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083129 */     // GIR_Coverage, 18548,
     /* 2083129 */     GIR_EraseRootFromParent_Done,
     /* 2083130 */   // Label 27476: @2083130
     /* 2083130 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2083221), // Rule ID 18549 //
     /* 2083135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2083138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2083146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2083149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2083152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2083155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2083158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2083173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083181 */     // MIs[0] round
     /* 2083181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083184 */     // MIs[0] policy
     /* 2083184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083194 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2083197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083220 */     // GIR_Coverage, 18549,
     /* 2083220 */     GIR_EraseRootFromParent_Done,
     /* 2083221 */   // Label 27477: @2083221
     /* 2083221 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2083312), // Rule ID 18552 //
     /* 2083226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2083229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2083237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2083240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2083246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083272 */     // MIs[0] round
     /* 2083272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083275 */     // MIs[0] policy
     /* 2083275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083285 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2083288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083311 */     // GIR_Coverage, 18552,
     /* 2083311 */     GIR_EraseRootFromParent_Done,
     /* 2083312 */   // Label 27478: @2083312
     /* 2083312 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2083403), // Rule ID 18553 //
     /* 2083317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2083320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2083328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2083331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2083337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083363 */     // MIs[0] round
     /* 2083363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083366 */     // MIs[0] policy
     /* 2083366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10939:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2083379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083402 */     // GIR_Coverage, 18553,
     /* 2083402 */     GIR_EraseRootFromParent_Done,
     /* 2083403 */   // Label 27479: @2083403
     /* 2083403 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2083494), // Rule ID 18556 //
     /* 2083408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2083411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2083419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2083422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2083428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083454 */     // MIs[0] round
     /* 2083454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083457 */     // MIs[0] policy
     /* 2083457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083467 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2083470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083493 */     // GIR_Coverage, 18556,
     /* 2083493 */     GIR_EraseRootFromParent_Done,
     /* 2083494 */   // Label 27480: @2083494
     /* 2083494 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2083585), // Rule ID 18557 //
     /* 2083499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2083502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2083510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2083513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2083519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083545 */     // MIs[0] round
     /* 2083545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083548 */     // MIs[0] policy
     /* 2083548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10939:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2083561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083584 */     // GIR_Coverage, 18557,
     /* 2083584 */     GIR_EraseRootFromParent_Done,
     /* 2083585 */   // Label 27481: @2083585
     /* 2083585 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2083676), // Rule ID 18560 //
     /* 2083590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2083593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2083601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2083604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2083610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083636 */     // MIs[0] round
     /* 2083636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083639 */     // MIs[0] policy
     /* 2083639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083649 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2083652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083675 */     // GIR_Coverage, 18560,
     /* 2083675 */     GIR_EraseRootFromParent_Done,
     /* 2083676 */   // Label 27482: @2083676
     /* 2083676 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2083767), // Rule ID 18561 //
     /* 2083681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2083684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2083689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2083692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2083695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2083698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2083701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2083719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083727 */     // MIs[0] round
     /* 2083727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083730 */     // MIs[0] policy
     /* 2083730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083740 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10939:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2083743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083766 */     // GIR_Coverage, 18561,
     /* 2083766 */     GIR_EraseRootFromParent_Done,
     /* 2083767 */   // Label 27483: @2083767
     /* 2083767 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2083858), // Rule ID 18564 //
     /* 2083772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2083775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2083780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083818 */     // MIs[0] round
     /* 2083818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083821 */     // MIs[0] policy
     /* 2083821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083831 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2083834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083857 */     // GIR_Coverage, 18564,
     /* 2083857 */     GIR_EraseRootFromParent_Done,
     /* 2083858 */   // Label 27484: @2083858
     /* 2083858 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2083949), // Rule ID 18565 //
     /* 2083863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2083866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2083871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083909 */     // MIs[0] round
     /* 2083909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083912 */     // MIs[0] policy
     /* 2083912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083922 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2083925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2083929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083948 */     // GIR_Coverage, 18565,
     /* 2083948 */     GIR_EraseRootFromParent_Done,
     /* 2083949 */   // Label 27485: @2083949
     /* 2083949 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2084040), // Rule ID 18568 //
     /* 2083954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2083957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2083962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2083965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2083968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084000 */     // MIs[0] round
     /* 2084000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084003 */     // MIs[0] policy
     /* 2084003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084013 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2084016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084039 */     // GIR_Coverage, 18568,
     /* 2084039 */     GIR_EraseRootFromParent_Done,
     /* 2084040 */   // Label 27486: @2084040
     /* 2084040 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2084131), // Rule ID 18569 //
     /* 2084045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2084048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2084062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2084065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084091 */     // MIs[0] round
     /* 2084091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084094 */     // MIs[0] policy
     /* 2084094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2084107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084130 */     // GIR_Coverage, 18569,
     /* 2084130 */     GIR_EraseRootFromParent_Done,
     /* 2084131 */   // Label 27487: @2084131
     /* 2084131 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2084222), // Rule ID 18572 //
     /* 2084136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2084139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2084147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2084150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084182 */     // MIs[0] round
     /* 2084182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084185 */     // MIs[0] policy
     /* 2084185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084195 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2084198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084221 */     // GIR_Coverage, 18572,
     /* 2084221 */     GIR_EraseRootFromParent_Done,
     /* 2084222 */   // Label 27488: @2084222
     /* 2084222 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2084313), // Rule ID 18573 //
     /* 2084227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2084230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2084238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2084241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084273 */     // MIs[0] round
     /* 2084273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084276 */     // MIs[0] policy
     /* 2084276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084286 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2084289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084312 */     // GIR_Coverage, 18573,
     /* 2084312 */     GIR_EraseRootFromParent_Done,
     /* 2084313 */   // Label 27489: @2084313
     /* 2084313 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2084404), // Rule ID 18576 //
     /* 2084318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2084321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2084329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2084332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2084338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084364 */     // MIs[0] round
     /* 2084364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084367 */     // MIs[0] policy
     /* 2084367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084377 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2084380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084403 */     // GIR_Coverage, 18576,
     /* 2084403 */     GIR_EraseRootFromParent_Done,
     /* 2084404 */   // Label 27490: @2084404
     /* 2084404 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2084495), // Rule ID 18577 //
     /* 2084409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2084412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2084420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2084423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2084429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084455 */     // MIs[0] round
     /* 2084455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084458 */     // MIs[0] policy
     /* 2084458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2084471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084494 */     // GIR_Coverage, 18577,
     /* 2084494 */     GIR_EraseRootFromParent_Done,
     /* 2084495 */   // Label 27491: @2084495
     /* 2084495 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2084586), // Rule ID 18580 //
     /* 2084500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2084503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2084511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2084514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2084517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2084520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084546 */     // MIs[0] round
     /* 2084546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084549 */     // MIs[0] policy
     /* 2084549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084559 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2084562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084585 */     // GIR_Coverage, 18580,
     /* 2084585 */     GIR_EraseRootFromParent_Done,
     /* 2084586 */   // Label 27492: @2084586
     /* 2084586 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2084677), // Rule ID 18581 //
     /* 2084591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2084594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2084602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2084605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2084608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2084611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084637 */     // MIs[0] round
     /* 2084637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084640 */     // MIs[0] policy
     /* 2084640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084650 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2084653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084676 */     // GIR_Coverage, 18581,
     /* 2084676 */     GIR_EraseRootFromParent_Done,
     /* 2084677 */   // Label 27493: @2084677
     /* 2084677 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2084768), // Rule ID 18584 //
     /* 2084682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2084685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2084702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084728 */     // MIs[0] round
     /* 2084728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084731 */     // MIs[0] policy
     /* 2084731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084741 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2084744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084767 */     // GIR_Coverage, 18584,
     /* 2084767 */     GIR_EraseRootFromParent_Done,
     /* 2084768 */   // Label 27494: @2084768
     /* 2084768 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2084859), // Rule ID 18585 //
     /* 2084773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2084776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2084793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084819 */     // MIs[0] round
     /* 2084819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084822 */     // MIs[0] policy
     /* 2084822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084832 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2084835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084858 */     // GIR_Coverage, 18585,
     /* 2084858 */     GIR_EraseRootFromParent_Done,
     /* 2084859 */   // Label 27495: @2084859
     /* 2084859 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2084950), // Rule ID 18588 //
     /* 2084864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2084867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2084875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2084878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084910 */     // MIs[0] round
     /* 2084910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084913 */     // MIs[0] policy
     /* 2084913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084923 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2084926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2084930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084949 */     // GIR_Coverage, 18588,
     /* 2084949 */     GIR_EraseRootFromParent_Done,
     /* 2084950 */   // Label 27496: @2084950
     /* 2084950 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2085041), // Rule ID 18589 //
     /* 2084955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2084958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2084963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2084966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2084969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085001 */     // MIs[0] round
     /* 2085001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085004 */     // MIs[0] policy
     /* 2085004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2085017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085040 */     // GIR_Coverage, 18589,
     /* 2085040 */     GIR_EraseRootFromParent_Done,
     /* 2085041 */   // Label 27497: @2085041
     /* 2085041 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2085132), // Rule ID 18592 //
     /* 2085046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2085049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2085057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2085060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085092 */     // MIs[0] round
     /* 2085092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085095 */     // MIs[0] policy
     /* 2085095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085105 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2085108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085131 */     // GIR_Coverage, 18592,
     /* 2085131 */     GIR_EraseRootFromParent_Done,
     /* 2085132 */   // Label 27498: @2085132
     /* 2085132 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2085223), // Rule ID 18593 //
     /* 2085137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2085140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2085148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2085151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085183 */     // MIs[0] round
     /* 2085183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085186 */     // MIs[0] policy
     /* 2085186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085196 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2085199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085222 */     // GIR_Coverage, 18593,
     /* 2085222 */     GIR_EraseRootFromParent_Done,
     /* 2085223 */   // Label 27499: @2085223
     /* 2085223 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2085314), // Rule ID 18596 //
     /* 2085228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2085231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2085239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2085242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085274 */     // MIs[0] round
     /* 2085274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085277 */     // MIs[0] policy
     /* 2085277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085287 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2085290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085313 */     // GIR_Coverage, 18596,
     /* 2085313 */     GIR_EraseRootFromParent_Done,
     /* 2085314 */   // Label 27500: @2085314
     /* 2085314 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2085405), // Rule ID 18597 //
     /* 2085319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2085322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2085330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2085333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085365 */     // MIs[0] round
     /* 2085365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085368 */     // MIs[0] policy
     /* 2085368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085378 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2085381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085404 */     // GIR_Coverage, 18597,
     /* 2085404 */     GIR_EraseRootFromParent_Done,
     /* 2085405 */   // Label 27501: @2085405
     /* 2085405 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2085496), // Rule ID 18600 //
     /* 2085410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2085413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2085421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2085424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2085430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085456 */     // MIs[0] round
     /* 2085456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085459 */     // MIs[0] policy
     /* 2085459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085469 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2085472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085495 */     // GIR_Coverage, 18600,
     /* 2085495 */     GIR_EraseRootFromParent_Done,
     /* 2085496 */   // Label 27502: @2085496
     /* 2085496 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2085587), // Rule ID 18601 //
     /* 2085501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2085504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2085512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2085515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2085521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085547 */     // MIs[0] round
     /* 2085547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085550 */     // MIs[0] policy
     /* 2085550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085560 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2085563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085586 */     // GIR_Coverage, 18601,
     /* 2085586 */     GIR_EraseRootFromParent_Done,
     /* 2085587 */   // Label 27503: @2085587
     /* 2085587 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2085678), // Rule ID 18604 //
     /* 2085592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2085595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2085603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2085606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2085612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085638 */     // MIs[0] round
     /* 2085638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085641 */     // MIs[0] policy
     /* 2085641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085651 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2085654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085677 */     // GIR_Coverage, 18604,
     /* 2085677 */     GIR_EraseRootFromParent_Done,
     /* 2085678 */   // Label 27504: @2085678
     /* 2085678 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2085769), // Rule ID 18605 //
     /* 2085683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2085686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2085694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2085697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2085703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085729 */     // MIs[0] round
     /* 2085729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085732 */     // MIs[0] policy
     /* 2085732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10991:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2085745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085768 */     // GIR_Coverage, 18605,
     /* 2085768 */     GIR_EraseRootFromParent_Done,
     /* 2085769 */   // Label 27505: @2085769
     /* 2085769 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2085860), // Rule ID 18608 //
     /* 2085774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2085777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2085794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085820 */     // MIs[0] round
     /* 2085820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085823 */     // MIs[0] policy
     /* 2085823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085833 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2085836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085859 */     // GIR_Coverage, 18608,
     /* 2085859 */     GIR_EraseRootFromParent_Done,
     /* 2085860 */   // Label 27506: @2085860
     /* 2085860 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2085951), // Rule ID 18609 //
     /* 2085865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2085868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2085885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085911 */     // MIs[0] round
     /* 2085911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085914 */     // MIs[0] policy
     /* 2085914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2085927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2085931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085950 */     // GIR_Coverage, 18609,
     /* 2085950 */     GIR_EraseRootFromParent_Done,
     /* 2085951 */   // Label 27507: @2085951
     /* 2085951 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2086042), // Rule ID 18612 //
     /* 2085956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2085959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2085964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2085973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2085994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086002 */     // MIs[0] round
     /* 2086002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086005 */     // MIs[0] policy
     /* 2086005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086015 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2086018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086041 */     // GIR_Coverage, 18612,
     /* 2086041 */     GIR_EraseRootFromParent_Done,
     /* 2086042 */   // Label 27508: @2086042
     /* 2086042 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2086133), // Rule ID 18613 //
     /* 2086047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2086050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2086064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2086067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2086085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086093 */     // MIs[0] round
     /* 2086093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086096 */     // MIs[0] policy
     /* 2086096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086106 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2086109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086132 */     // GIR_Coverage, 18613,
     /* 2086132 */     GIR_EraseRootFromParent_Done,
     /* 2086133 */   // Label 27509: @2086133
     /* 2086133 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2086224), // Rule ID 18616 //
     /* 2086138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2086141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2086155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2086158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2086176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086184 */     // MIs[0] round
     /* 2086184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086187 */     // MIs[0] policy
     /* 2086187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086197 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2086200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086223 */     // GIR_Coverage, 18616,
     /* 2086223 */     GIR_EraseRootFromParent_Done,
     /* 2086224 */   // Label 27510: @2086224
     /* 2086224 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2086315), // Rule ID 18617 //
     /* 2086229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2086232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2086246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2086249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2086267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086275 */     // MIs[0] round
     /* 2086275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086278 */     // MIs[0] policy
     /* 2086278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086288 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2086291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086314 */     // GIR_Coverage, 18617,
     /* 2086314 */     GIR_EraseRootFromParent_Done,
     /* 2086315 */   // Label 27511: @2086315
     /* 2086315 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2086406), // Rule ID 18620 //
     /* 2086320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2086323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2086331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2086334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2086340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086366 */     // MIs[0] round
     /* 2086366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086369 */     // MIs[0] policy
     /* 2086369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086379 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2086382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086405 */     // GIR_Coverage, 18620,
     /* 2086405 */     GIR_EraseRootFromParent_Done,
     /* 2086406 */   // Label 27512: @2086406
     /* 2086406 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2086497), // Rule ID 18621 //
     /* 2086411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2086414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2086422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2086425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2086431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086457 */     // MIs[0] round
     /* 2086457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086460 */     // MIs[0] policy
     /* 2086460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086470 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10991:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2086473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086496 */     // GIR_Coverage, 18621,
     /* 2086496 */     GIR_EraseRootFromParent_Done,
     /* 2086497 */   // Label 27513: @2086497
     /* 2086497 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2086588), // Rule ID 18624 //
     /* 2086502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2086505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2086522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086548 */     // MIs[0] round
     /* 2086548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086551 */     // MIs[0] policy
     /* 2086551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086561 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2086564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086587 */     // GIR_Coverage, 18624,
     /* 2086587 */     GIR_EraseRootFromParent_Done,
     /* 2086588 */   // Label 27514: @2086588
     /* 2086588 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2086679), // Rule ID 18625 //
     /* 2086593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2086596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2086613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086639 */     // MIs[0] round
     /* 2086639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086642 */     // MIs[0] policy
     /* 2086642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086652 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10991:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2086655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086678 */     // GIR_Coverage, 18625,
     /* 2086678 */     GIR_EraseRootFromParent_Done,
     /* 2086679 */   // Label 27515: @2086679
     /* 2086679 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2086770), // Rule ID 18628 //
     /* 2086684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2086687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086730 */     // MIs[0] round
     /* 2086730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086733 */     // MIs[0] policy
     /* 2086733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086743 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2086746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086769 */     // GIR_Coverage, 18628,
     /* 2086769 */     GIR_EraseRootFromParent_Done,
     /* 2086770 */   // Label 27516: @2086770
     /* 2086770 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2086861), // Rule ID 18629 //
     /* 2086775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2086778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086821 */     // MIs[0] round
     /* 2086821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086824 */     // MIs[0] policy
     /* 2086824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10991:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2086837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086860 */     // GIR_Coverage, 18629,
     /* 2086860 */     GIR_EraseRootFromParent_Done,
     /* 2086861 */   // Label 27517: @2086861
     /* 2086861 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2086952), // Rule ID 18632 //
     /* 2086866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2086869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086912 */     // MIs[0] round
     /* 2086912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086915 */     // MIs[0] policy
     /* 2086915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086925 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2086928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2086932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086951 */     // GIR_Coverage, 18632,
     /* 2086951 */     GIR_EraseRootFromParent_Done,
     /* 2086952 */   // Label 27518: @2086952
     /* 2086952 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2087043), // Rule ID 18633 //
     /* 2086957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2086960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2086965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2086974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2086995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087003 */     // MIs[0] round
     /* 2087003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087006 */     // MIs[0] policy
     /* 2087006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087016 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10991:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2087019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087042 */     // GIR_Coverage, 18633,
     /* 2087042 */     GIR_EraseRootFromParent_Done,
     /* 2087043 */   // Label 27519: @2087043
     /* 2087043 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2087134), // Rule ID 18636 //
     /* 2087048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2087051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2087068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087094 */     // MIs[0] round
     /* 2087094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087097 */     // MIs[0] policy
     /* 2087097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087107 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2087110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087133 */     // GIR_Coverage, 18636,
     /* 2087133 */     GIR_EraseRootFromParent_Done,
     /* 2087134 */   // Label 27520: @2087134
     /* 2087134 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2087225), // Rule ID 18637 //
     /* 2087139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2087142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2087159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087185 */     // MIs[0] round
     /* 2087185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087188 */     // MIs[0] policy
     /* 2087188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087198 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2087201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087224 */     // GIR_Coverage, 18637,
     /* 2087224 */     GIR_EraseRootFromParent_Done,
     /* 2087225 */   // Label 27521: @2087225
     /* 2087225 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2087316), // Rule ID 18640 //
     /* 2087230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2087233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2087241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2087244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2087250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087276 */     // MIs[0] round
     /* 2087276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087279 */     // MIs[0] policy
     /* 2087279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087289 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2087292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087315 */     // GIR_Coverage, 18640,
     /* 2087315 */     GIR_EraseRootFromParent_Done,
     /* 2087316 */   // Label 27522: @2087316
     /* 2087316 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2087407), // Rule ID 18641 //
     /* 2087321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2087324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2087332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2087335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2087341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087367 */     // MIs[0] round
     /* 2087367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087370 */     // MIs[0] policy
     /* 2087370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2087383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087406 */     // GIR_Coverage, 18641,
     /* 2087406 */     GIR_EraseRootFromParent_Done,
     /* 2087407 */   // Label 27523: @2087407
     /* 2087407 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2087498), // Rule ID 18644 //
     /* 2087412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2087415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2087423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2087426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2087432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087458 */     // MIs[0] round
     /* 2087458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087461 */     // MIs[0] policy
     /* 2087461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087471 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2087474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087497 */     // GIR_Coverage, 18644,
     /* 2087497 */     GIR_EraseRootFromParent_Done,
     /* 2087498 */   // Label 27524: @2087498
     /* 2087498 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2087589), // Rule ID 18645 //
     /* 2087503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2087506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2087514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2087517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2087523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087549 */     // MIs[0] round
     /* 2087549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087552 */     // MIs[0] policy
     /* 2087552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2087565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087588 */     // GIR_Coverage, 18645,
     /* 2087588 */     GIR_EraseRootFromParent_Done,
     /* 2087589 */   // Label 27525: @2087589
     /* 2087589 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2087680), // Rule ID 18648 //
     /* 2087594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2087597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2087605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2087608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2087611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2087614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087640 */     // MIs[0] round
     /* 2087640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087643 */     // MIs[0] policy
     /* 2087643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087653 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2087656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087679 */     // GIR_Coverage, 18648,
     /* 2087679 */     GIR_EraseRootFromParent_Done,
     /* 2087680 */   // Label 27526: @2087680
     /* 2087680 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2087771), // Rule ID 18649 //
     /* 2087685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2087688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2087696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2087699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2087702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2087705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087731 */     // MIs[0] round
     /* 2087731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087734 */     // MIs[0] policy
     /* 2087734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2087747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087770 */     // GIR_Coverage, 18649,
     /* 2087770 */     GIR_EraseRootFromParent_Done,
     /* 2087771 */   // Label 27527: @2087771
     /* 2087771 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2087862), // Rule ID 18652 //
     /* 2087776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2087779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2087787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2087790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2087793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2087796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2087799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2087806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087822 */     // MIs[0] round
     /* 2087822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087825 */     // MIs[0] policy
     /* 2087825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087835 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2087838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087861 */     // GIR_Coverage, 18652,
     /* 2087861 */     GIR_EraseRootFromParent_Done,
     /* 2087862 */   // Label 27528: @2087862
     /* 2087862 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2087953), // Rule ID 18653 //
     /* 2087867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2087870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2087878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2087881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2087884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2087887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2087890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2087897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087913 */     // MIs[0] round
     /* 2087913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087916 */     // MIs[0] policy
     /* 2087916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087926 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2087929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2087933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087952 */     // GIR_Coverage, 18653,
     /* 2087952 */     GIR_EraseRootFromParent_Done,
     /* 2087953 */   // Label 27529: @2087953
     /* 2087953 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2088044), // Rule ID 18656 //
     /* 2087958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2087961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2087966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2087969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2087972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2087978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088004 */     // MIs[0] round
     /* 2088004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088007 */     // MIs[0] policy
     /* 2088007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088017 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2088020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088043 */     // GIR_Coverage, 18656,
     /* 2088043 */     GIR_EraseRootFromParent_Done,
     /* 2088044 */   // Label 27530: @2088044
     /* 2088044 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2088135), // Rule ID 18657 //
     /* 2088049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2088052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2088069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088095 */     // MIs[0] round
     /* 2088095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088098 */     // MIs[0] policy
     /* 2088098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088108 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2088111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088134 */     // GIR_Coverage, 18657,
     /* 2088134 */     GIR_EraseRootFromParent_Done,
     /* 2088135 */   // Label 27531: @2088135
     /* 2088135 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2088226), // Rule ID 18660 //
     /* 2088140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2088143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2088151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2088154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2088160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088186 */     // MIs[0] round
     /* 2088186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088189 */     // MIs[0] policy
     /* 2088189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2088202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088225 */     // GIR_Coverage, 18660,
     /* 2088225 */     GIR_EraseRootFromParent_Done,
     /* 2088226 */   // Label 27532: @2088226
     /* 2088226 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2088317), // Rule ID 18661 //
     /* 2088231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2088234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2088242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2088245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2088251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088277 */     // MIs[0] round
     /* 2088277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088280 */     // MIs[0] policy
     /* 2088280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2088293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088316 */     // GIR_Coverage, 18661,
     /* 2088316 */     GIR_EraseRootFromParent_Done,
     /* 2088317 */   // Label 27533: @2088317
     /* 2088317 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2088408), // Rule ID 18664 //
     /* 2088322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2088325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2088333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2088336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2088339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2088342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088368 */     // MIs[0] round
     /* 2088368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088371 */     // MIs[0] policy
     /* 2088371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088381 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2088384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088407 */     // GIR_Coverage, 18664,
     /* 2088407 */     GIR_EraseRootFromParent_Done,
     /* 2088408 */   // Label 27534: @2088408
     /* 2088408 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2088499), // Rule ID 18665 //
     /* 2088413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2088416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2088424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2088427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2088430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2088433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088459 */     // MIs[0] round
     /* 2088459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088462 */     // MIs[0] policy
     /* 2088462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088472 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2088475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088498 */     // GIR_Coverage, 18665,
     /* 2088498 */     GIR_EraseRootFromParent_Done,
     /* 2088499 */   // Label 27535: @2088499
     /* 2088499 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2088590), // Rule ID 18668 //
     /* 2088504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2088507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2088515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2088518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2088521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2088524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088550 */     // MIs[0] round
     /* 2088550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088553 */     // MIs[0] policy
     /* 2088553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088563 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2088566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088589 */     // GIR_Coverage, 18668,
     /* 2088589 */     GIR_EraseRootFromParent_Done,
     /* 2088590 */   // Label 27536: @2088590
     /* 2088590 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2088681), // Rule ID 18669 //
     /* 2088595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2088598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2088606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2088609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2088612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2088615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088641 */     // MIs[0] round
     /* 2088641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088644 */     // MIs[0] policy
     /* 2088644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088654 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2088657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088680 */     // GIR_Coverage, 18669,
     /* 2088680 */     GIR_EraseRootFromParent_Done,
     /* 2088681 */   // Label 27537: @2088681
     /* 2088681 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2088772), // Rule ID 18672 //
     /* 2088686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2088689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2088703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2088706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2088724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088732 */     // MIs[0] round
     /* 2088732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088735 */     // MIs[0] policy
     /* 2088735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088745 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2088748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088771 */     // GIR_Coverage, 18672,
     /* 2088771 */     GIR_EraseRootFromParent_Done,
     /* 2088772 */   // Label 27538: @2088772
     /* 2088772 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2088863), // Rule ID 18673 //
     /* 2088777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2088780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2088794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2088797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2088815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088823 */     // MIs[0] round
     /* 2088823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088826 */     // MIs[0] policy
     /* 2088826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2088839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088862 */     // GIR_Coverage, 18673,
     /* 2088862 */     GIR_EraseRootFromParent_Done,
     /* 2088863 */   // Label 27539: @2088863
     /* 2088863 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2088954), // Rule ID 18676 //
     /* 2088868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2088871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2088885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2088888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2088906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088914 */     // MIs[0] round
     /* 2088914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088917 */     // MIs[0] policy
     /* 2088917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088927 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2088930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2088934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088953 */     // GIR_Coverage, 18676,
     /* 2088953 */     GIR_EraseRootFromParent_Done,
     /* 2088954 */   // Label 27540: @2088954
     /* 2088954 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2089045), // Rule ID 18677 //
     /* 2088959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2088962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2088967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2088976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2088979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2088997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089005 */     // MIs[0] round
     /* 2089005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089008 */     // MIs[0] policy
     /* 2089008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089018 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10999:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2089021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089044 */     // GIR_Coverage, 18677,
     /* 2089044 */     GIR_EraseRootFromParent_Done,
     /* 2089045 */   // Label 27541: @2089045
     /* 2089045 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2089136), // Rule ID 18680 //
     /* 2089050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2089053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2089070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089096 */     // MIs[0] round
     /* 2089096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089099 */     // MIs[0] policy
     /* 2089099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089109 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2089112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089135 */     // GIR_Coverage, 18680,
     /* 2089135 */     GIR_EraseRootFromParent_Done,
     /* 2089136 */   // Label 27542: @2089136
     /* 2089136 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2089227), // Rule ID 18681 //
     /* 2089141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2089144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2089161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089187 */     // MIs[0] round
     /* 2089187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089190 */     // MIs[0] policy
     /* 2089190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089200 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2089203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089226 */     // GIR_Coverage, 18681,
     /* 2089226 */     GIR_EraseRootFromParent_Done,
     /* 2089227 */   // Label 27543: @2089227
     /* 2089227 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2089318), // Rule ID 18684 //
     /* 2089232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2089235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2089252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089278 */     // MIs[0] round
     /* 2089278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089281 */     // MIs[0] policy
     /* 2089281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2089294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089317 */     // GIR_Coverage, 18684,
     /* 2089317 */     GIR_EraseRootFromParent_Done,
     /* 2089318 */   // Label 27544: @2089318
     /* 2089318 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2089409), // Rule ID 18685 //
     /* 2089323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2089326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2089343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089369 */     // MIs[0] round
     /* 2089369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089372 */     // MIs[0] policy
     /* 2089372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089382 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2089385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089408 */     // GIR_Coverage, 18685,
     /* 2089408 */     GIR_EraseRootFromParent_Done,
     /* 2089409 */   // Label 27545: @2089409
     /* 2089409 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2089500), // Rule ID 18688 //
     /* 2089414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2089417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2089434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089460 */     // MIs[0] round
     /* 2089460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089463 */     // MIs[0] policy
     /* 2089463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089473 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2089476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089499 */     // GIR_Coverage, 18688,
     /* 2089499 */     GIR_EraseRootFromParent_Done,
     /* 2089500 */   // Label 27546: @2089500
     /* 2089500 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2089591), // Rule ID 18689 //
     /* 2089505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2089508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2089522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2089525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2089543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089551 */     // MIs[0] round
     /* 2089551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089554 */     // MIs[0] policy
     /* 2089554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089564 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2089567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089590 */     // GIR_Coverage, 18689,
     /* 2089590 */     GIR_EraseRootFromParent_Done,
     /* 2089591 */   // Label 27547: @2089591
     /* 2089591 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2089682), // Rule ID 18692 //
     /* 2089596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2089599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2089607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2089610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2089613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2089616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2089634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089642 */     // MIs[0] round
     /* 2089642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089645 */     // MIs[0] policy
     /* 2089645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089655 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2089658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089681 */     // GIR_Coverage, 18692,
     /* 2089681 */     GIR_EraseRootFromParent_Done,
     /* 2089682 */   // Label 27548: @2089682
     /* 2089682 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2089773), // Rule ID 18693 //
     /* 2089687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2089690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2089698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2089701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2089704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2089707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2089725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089733 */     // MIs[0] round
     /* 2089733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089736 */     // MIs[0] policy
     /* 2089736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089746 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10999:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2089749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089772 */     // GIR_Coverage, 18693,
     /* 2089772 */     GIR_EraseRootFromParent_Done,
     /* 2089773 */   // Label 27549: @2089773
     /* 2089773 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2089864), // Rule ID 18696 //
     /* 2089778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2089781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2089789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2089792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2089795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2089798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2089816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089824 */     // MIs[0] round
     /* 2089824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089827 */     // MIs[0] policy
     /* 2089827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089837 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2089840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089863 */     // GIR_Coverage, 18696,
     /* 2089863 */     GIR_EraseRootFromParent_Done,
     /* 2089864 */   // Label 27550: @2089864
     /* 2089864 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2089955), // Rule ID 18697 //
     /* 2089869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2089872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2089880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2089883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2089886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2089889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2089907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089915 */     // MIs[0] round
     /* 2089915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089918 */     // MIs[0] policy
     /* 2089918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089928 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10999:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2089931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2089935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089954 */     // GIR_Coverage, 18697,
     /* 2089954 */     GIR_EraseRootFromParent_Done,
     /* 2089955 */   // Label 27551: @2089955
     /* 2089955 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2090046), // Rule ID 18700 //
     /* 2089960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2089963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2089968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2089971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2089974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2089977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2089980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2089998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090006 */     // MIs[0] round
     /* 2090006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090009 */     // MIs[0] policy
     /* 2090009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090019 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2090022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090045 */     // GIR_Coverage, 18700,
     /* 2090045 */     GIR_EraseRootFromParent_Done,
     /* 2090046 */   // Label 27552: @2090046
     /* 2090046 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2090137), // Rule ID 18701 //
     /* 2090051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2090054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2090059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2090068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2090071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2090089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090097 */     // MIs[0] round
     /* 2090097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090100 */     // MIs[0] policy
     /* 2090100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090110 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10999:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2090113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090136 */     // GIR_Coverage, 18701,
     /* 2090136 */     GIR_EraseRootFromParent_Done,
     /* 2090137 */   // Label 27553: @2090137
     /* 2090137 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2090228), // Rule ID 18704 //
     /* 2090142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2090145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2090150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2090159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2090162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2090180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090188 */     // MIs[0] round
     /* 2090188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090191 */     // MIs[0] policy
     /* 2090191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090201 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2090204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090227 */     // GIR_Coverage, 18704,
     /* 2090227 */     GIR_EraseRootFromParent_Done,
     /* 2090228 */   // Label 27554: @2090228
     /* 2090228 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2090319), // Rule ID 18705 //
     /* 2090233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2090236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2090241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2090250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2090253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2090271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090279 */     // MIs[0] round
     /* 2090279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090282 */     // MIs[0] policy
     /* 2090282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090292 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10999:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2090295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090318 */     // GIR_Coverage, 18705,
     /* 2090318 */     GIR_EraseRootFromParent_Done,
     /* 2090319 */   // Label 27555: @2090319
     /* 2090319 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2090410), // Rule ID 18708 //
     /* 2090324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2090327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2090335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2090338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090370 */     // MIs[0] round
     /* 2090370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090373 */     // MIs[0] policy
     /* 2090373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090383 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2090386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090409 */     // GIR_Coverage, 18708,
     /* 2090409 */     GIR_EraseRootFromParent_Done,
     /* 2090410 */   // Label 27556: @2090410
     /* 2090410 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2090501), // Rule ID 18709 //
     /* 2090415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2090418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2090426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2090429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090461 */     // MIs[0] round
     /* 2090461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090464 */     // MIs[0] policy
     /* 2090464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090474 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2090477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090500 */     // GIR_Coverage, 18709,
     /* 2090500 */     GIR_EraseRootFromParent_Done,
     /* 2090501 */   // Label 27557: @2090501
     /* 2090501 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2090592), // Rule ID 18712 //
     /* 2090506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2090509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2090517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2090520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090552 */     // MIs[0] round
     /* 2090552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090555 */     // MIs[0] policy
     /* 2090555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090565 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2090568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090591 */     // GIR_Coverage, 18712,
     /* 2090591 */     GIR_EraseRootFromParent_Done,
     /* 2090592 */   // Label 27558: @2090592
     /* 2090592 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2090683), // Rule ID 18713 //
     /* 2090597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2090600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2090608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2090611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090643 */     // MIs[0] round
     /* 2090643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090646 */     // MIs[0] policy
     /* 2090646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2090659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090682 */     // GIR_Coverage, 18713,
     /* 2090682 */     GIR_EraseRootFromParent_Done,
     /* 2090683 */   // Label 27559: @2090683
     /* 2090683 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2090774), // Rule ID 18716 //
     /* 2090688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2090691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2090705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2090708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090734 */     // MIs[0] round
     /* 2090734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090737 */     // MIs[0] policy
     /* 2090737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090747 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2090750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090773 */     // GIR_Coverage, 18716,
     /* 2090773 */     GIR_EraseRootFromParent_Done,
     /* 2090774 */   // Label 27560: @2090774
     /* 2090774 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2090865), // Rule ID 18717 //
     /* 2090779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2090782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2090796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2090799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090825 */     // MIs[0] round
     /* 2090825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090828 */     // MIs[0] policy
     /* 2090828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2090841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090864 */     // GIR_Coverage, 18717,
     /* 2090864 */     GIR_EraseRootFromParent_Done,
     /* 2090865 */   // Label 27561: @2090865
     /* 2090865 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2090956), // Rule ID 18720 //
     /* 2090870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2090873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2090887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2090890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090916 */     // MIs[0] round
     /* 2090916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090919 */     // MIs[0] policy
     /* 2090919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090929 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2090932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2090936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090955 */     // GIR_Coverage, 18720,
     /* 2090955 */     GIR_EraseRootFromParent_Done,
     /* 2090956 */   // Label 27562: @2090956
     /* 2090956 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2091047), // Rule ID 18721 //
     /* 2090961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2090964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2090969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2090978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2090981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091007 */     // MIs[0] round
     /* 2091007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091010 */     // MIs[0] policy
     /* 2091010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091020 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2091023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091046 */     // GIR_Coverage, 18721,
     /* 2091046 */     GIR_EraseRootFromParent_Done,
     /* 2091047 */   // Label 27563: @2091047
     /* 2091047 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2091138), // Rule ID 18724 //
     /* 2091052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2091055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2091063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2091066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2091072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091098 */     // MIs[0] round
     /* 2091098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091101 */     // MIs[0] policy
     /* 2091101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091111 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2091114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091137 */     // GIR_Coverage, 18724,
     /* 2091137 */     GIR_EraseRootFromParent_Done,
     /* 2091138 */   // Label 27564: @2091138
     /* 2091138 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2091229), // Rule ID 18725 //
     /* 2091143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2091146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2091154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2091157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2091163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091189 */     // MIs[0] round
     /* 2091189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091192 */     // MIs[0] policy
     /* 2091192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2091205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091228 */     // GIR_Coverage, 18725,
     /* 2091228 */     GIR_EraseRootFromParent_Done,
     /* 2091229 */   // Label 27565: @2091229
     /* 2091229 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2091320), // Rule ID 18728 //
     /* 2091234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2091237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2091245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2091248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091280 */     // MIs[0] round
     /* 2091280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091283 */     // MIs[0] policy
     /* 2091283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091293 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2091296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091319 */     // GIR_Coverage, 18728,
     /* 2091319 */     GIR_EraseRootFromParent_Done,
     /* 2091320 */   // Label 27566: @2091320
     /* 2091320 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2091411), // Rule ID 18729 //
     /* 2091325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2091328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2091336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2091339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091371 */     // MIs[0] round
     /* 2091371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091374 */     // MIs[0] policy
     /* 2091374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091384 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2091387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091410 */     // GIR_Coverage, 18729,
     /* 2091410 */     GIR_EraseRootFromParent_Done,
     /* 2091411 */   // Label 27567: @2091411
     /* 2091411 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2091502), // Rule ID 18732 //
     /* 2091416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2091419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2091427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2091430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091462 */     // MIs[0] round
     /* 2091462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091465 */     // MIs[0] policy
     /* 2091465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2091478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091501 */     // GIR_Coverage, 18732,
     /* 2091501 */     GIR_EraseRootFromParent_Done,
     /* 2091502 */   // Label 27568: @2091502
     /* 2091502 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2091593), // Rule ID 18733 //
     /* 2091507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2091510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2091518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2091521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091553 */     // MIs[0] round
     /* 2091553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091556 */     // MIs[0] policy
     /* 2091556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2091569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091592 */     // GIR_Coverage, 18733,
     /* 2091592 */     GIR_EraseRootFromParent_Done,
     /* 2091593 */   // Label 27569: @2091593
     /* 2091593 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2091684), // Rule ID 18736 //
     /* 2091598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2091601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2091609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2091612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2091615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2091618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091644 */     // MIs[0] round
     /* 2091644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091647 */     // MIs[0] policy
     /* 2091647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091657 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2091660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091683 */     // GIR_Coverage, 18736,
     /* 2091683 */     GIR_EraseRootFromParent_Done,
     /* 2091684 */   // Label 27570: @2091684
     /* 2091684 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2091775), // Rule ID 18737 //
     /* 2091689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2091692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2091700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2091703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2091706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2091709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091735 */     // MIs[0] round
     /* 2091735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091738 */     // MIs[0] policy
     /* 2091738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091748 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2091751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091774 */     // GIR_Coverage, 18737,
     /* 2091774 */     GIR_EraseRootFromParent_Done,
     /* 2091775 */   // Label 27571: @2091775
     /* 2091775 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2091866), // Rule ID 18740 //
     /* 2091780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2091783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2091791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2091794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2091797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2091800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091826 */     // MIs[0] round
     /* 2091826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091829 */     // MIs[0] policy
     /* 2091829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091839 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2091842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091865 */     // GIR_Coverage, 18740,
     /* 2091865 */     GIR_EraseRootFromParent_Done,
     /* 2091866 */   // Label 27572: @2091866
     /* 2091866 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2091957), // Rule ID 18741 //
     /* 2091871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2091874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2091882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2091885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2091888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2091891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091917 */     // MIs[0] round
     /* 2091917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091920 */     // MIs[0] policy
     /* 2091920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091930 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2091933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2091937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091956 */     // GIR_Coverage, 18741,
     /* 2091956 */     GIR_EraseRootFromParent_Done,
     /* 2091957 */   // Label 27573: @2091957
     /* 2091957 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2092048), // Rule ID 18744 //
     /* 2091962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2091965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2091970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2091979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2091982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092008 */     // MIs[0] round
     /* 2092008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092011 */     // MIs[0] policy
     /* 2092011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092021 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2092024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092047 */     // GIR_Coverage, 18744,
     /* 2092047 */     GIR_EraseRootFromParent_Done,
     /* 2092048 */   // Label 27574: @2092048
     /* 2092048 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2092139), // Rule ID 18745 //
     /* 2092053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2092056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2092064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2092067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2092073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092099 */     // MIs[0] round
     /* 2092099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092102 */     // MIs[0] policy
     /* 2092102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092112 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2092115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092138 */     // GIR_Coverage, 18745,
     /* 2092138 */     GIR_EraseRootFromParent_Done,
     /* 2092139 */   // Label 27575: @2092139
     /* 2092139 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2092230), // Rule ID 18748 //
     /* 2092144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2092147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092190 */     // MIs[0] round
     /* 2092190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092193 */     // MIs[0] policy
     /* 2092193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092203 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2092206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092229 */     // GIR_Coverage, 18748,
     /* 2092229 */     GIR_EraseRootFromParent_Done,
     /* 2092230 */   // Label 27576: @2092230
     /* 2092230 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2092321), // Rule ID 18749 //
     /* 2092235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2092238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092281 */     // MIs[0] round
     /* 2092281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092284 */     // MIs[0] policy
     /* 2092284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 10995:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2092297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092320 */     // GIR_Coverage, 18749,
     /* 2092320 */     GIR_EraseRootFromParent_Done,
     /* 2092321 */   // Label 27577: @2092321
     /* 2092321 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2092412), // Rule ID 18752 //
     /* 2092326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2092329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2092337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2092340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092372 */     // MIs[0] round
     /* 2092372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092375 */     // MIs[0] policy
     /* 2092375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092385 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2092388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092411 */     // GIR_Coverage, 18752,
     /* 2092411 */     GIR_EraseRootFromParent_Done,
     /* 2092412 */   // Label 27578: @2092412
     /* 2092412 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2092503), // Rule ID 18753 //
     /* 2092417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2092420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2092428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2092431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092463 */     // MIs[0] round
     /* 2092463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092466 */     // MIs[0] policy
     /* 2092466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2092479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092502 */     // GIR_Coverage, 18753,
     /* 2092502 */     GIR_EraseRootFromParent_Done,
     /* 2092503 */   // Label 27579: @2092503
     /* 2092503 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2092594), // Rule ID 18756 //
     /* 2092508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2092511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092554 */     // MIs[0] round
     /* 2092554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092557 */     // MIs[0] policy
     /* 2092557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092567 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2092570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092593 */     // GIR_Coverage, 18756,
     /* 2092593 */     GIR_EraseRootFromParent_Done,
     /* 2092594 */   // Label 27580: @2092594
     /* 2092594 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2092685), // Rule ID 18757 //
     /* 2092599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2092602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092645 */     // MIs[0] round
     /* 2092645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092648 */     // MIs[0] policy
     /* 2092648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092658 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2092661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092684 */     // GIR_Coverage, 18757,
     /* 2092684 */     GIR_EraseRootFromParent_Done,
     /* 2092685 */   // Label 27581: @2092685
     /* 2092685 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2092776), // Rule ID 18760 //
     /* 2092690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2092693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2092701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2092704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092736 */     // MIs[0] round
     /* 2092736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092739 */     // MIs[0] policy
     /* 2092739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092749 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2092752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092775 */     // GIR_Coverage, 18760,
     /* 2092775 */     GIR_EraseRootFromParent_Done,
     /* 2092776 */   // Label 27582: @2092776
     /* 2092776 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2092867), // Rule ID 18761 //
     /* 2092781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2092784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2092792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2092795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2092798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2092819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092827 */     // MIs[0] round
     /* 2092827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092830 */     // MIs[0] policy
     /* 2092830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092840 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2092843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092866 */     // GIR_Coverage, 18761,
     /* 2092866 */     GIR_EraseRootFromParent_Done,
     /* 2092867 */   // Label 27583: @2092867
     /* 2092867 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2092958), // Rule ID 18764 //
     /* 2092872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2092875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2092883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2092886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2092889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2092910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092918 */     // MIs[0] round
     /* 2092918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092921 */     // MIs[0] policy
     /* 2092921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092931 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2092934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2092938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092957 */     // GIR_Coverage, 18764,
     /* 2092957 */     GIR_EraseRootFromParent_Done,
     /* 2092958 */   // Label 27584: @2092958
     /* 2092958 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2093049), // Rule ID 18765 //
     /* 2092963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2092966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2092971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2092974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2092977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2092980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093009 */     // MIs[0] round
     /* 2093009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093012 */     // MIs[0] policy
     /* 2093012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 10995:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2093025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093048 */     // GIR_Coverage, 18765,
     /* 2093048 */     GIR_EraseRootFromParent_Done,
     /* 2093049 */   // Label 27585: @2093049
     /* 2093049 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2093140), // Rule ID 18768 //
     /* 2093054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2093057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2093065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2093068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093100 */     // MIs[0] round
     /* 2093100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093103 */     // MIs[0] policy
     /* 2093103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093113 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2093116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093139 */     // GIR_Coverage, 18768,
     /* 2093139 */     GIR_EraseRootFromParent_Done,
     /* 2093140 */   // Label 27586: @2093140
     /* 2093140 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2093231), // Rule ID 18769 //
     /* 2093145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2093148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2093156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2093159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093191 */     // MIs[0] round
     /* 2093191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093194 */     // MIs[0] policy
     /* 2093194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 10995:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2093207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093230 */     // GIR_Coverage, 18769,
     /* 2093230 */     GIR_EraseRootFromParent_Done,
     /* 2093231 */   // Label 27587: @2093231
     /* 2093231 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2093322), // Rule ID 18772 //
     /* 2093236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2093239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2093247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2093250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093282 */     // MIs[0] round
     /* 2093282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093285 */     // MIs[0] policy
     /* 2093285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093295 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2093298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093321 */     // GIR_Coverage, 18772,
     /* 2093321 */     GIR_EraseRootFromParent_Done,
     /* 2093322 */   // Label 27588: @2093322
     /* 2093322 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2093413), // Rule ID 18773 //
     /* 2093327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2093330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2093338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2093341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093373 */     // MIs[0] round
     /* 2093373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093376 */     // MIs[0] policy
     /* 2093376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093386 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 10995:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2093389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093412 */     // GIR_Coverage, 18773,
     /* 2093412 */     GIR_EraseRootFromParent_Done,
     /* 2093413 */   // Label 27589: @2093413
     /* 2093413 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2093504), // Rule ID 18776 //
     /* 2093418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2093421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2093429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2093432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093464 */     // MIs[0] round
     /* 2093464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093467 */     // MIs[0] policy
     /* 2093467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093477 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2093480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093503 */     // GIR_Coverage, 18776,
     /* 2093503 */     GIR_EraseRootFromParent_Done,
     /* 2093504 */   // Label 27590: @2093504
     /* 2093504 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2093595), // Rule ID 18777 //
     /* 2093509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2093512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2093517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2093520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2093523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2093526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093555 */     // MIs[0] round
     /* 2093555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093558 */     // MIs[0] policy
     /* 2093558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093568 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 10995:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2093571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093594 */     // GIR_Coverage, 18777,
     /* 2093594 */     GIR_EraseRootFromParent_Done,
     /* 2093595 */   // Label 27591: @2093595
     /* 2093595 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2093686), // Rule ID 18780 //
     /* 2093600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2093603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2093608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2093620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093646 */     // MIs[0] round
     /* 2093646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093649 */     // MIs[0] policy
     /* 2093649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093659 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2093662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093685 */     // GIR_Coverage, 18780,
     /* 2093685 */     GIR_EraseRootFromParent_Done,
     /* 2093686 */   // Label 27592: @2093686
     /* 2093686 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2093777), // Rule ID 18781 //
     /* 2093691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2093694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2093699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2093711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093737 */     // MIs[0] round
     /* 2093737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093740 */     // MIs[0] policy
     /* 2093740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093750 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2093753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093776 */     // GIR_Coverage, 18781,
     /* 2093776 */     GIR_EraseRootFromParent_Done,
     /* 2093777 */   // Label 27593: @2093777
     /* 2093777 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2093868), // Rule ID 18784 //
     /* 2093782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2093785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2093790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2093802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093828 */     // MIs[0] round
     /* 2093828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093831 */     // MIs[0] policy
     /* 2093831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093841 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2093844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093867 */     // GIR_Coverage, 18784,
     /* 2093867 */     GIR_EraseRootFromParent_Done,
     /* 2093868 */   // Label 27594: @2093868
     /* 2093868 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2093959), // Rule ID 18785 //
     /* 2093873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2093876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2093881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2093893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093919 */     // MIs[0] round
     /* 2093919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093922 */     // MIs[0] policy
     /* 2093922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093932 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2093935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2093939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093958 */     // GIR_Coverage, 18785,
     /* 2093958 */     GIR_EraseRootFromParent_Done,
     /* 2093959 */   // Label 27595: @2093959
     /* 2093959 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2094050), // Rule ID 18788 //
     /* 2093964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2093967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2093972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2093984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094010 */     // MIs[0] round
     /* 2094010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094013 */     // MIs[0] policy
     /* 2094013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094023 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2094026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094049 */     // GIR_Coverage, 18788,
     /* 2094049 */     GIR_EraseRootFromParent_Done,
     /* 2094050 */   // Label 27596: @2094050
     /* 2094050 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2094141), // Rule ID 18789 //
     /* 2094055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2094058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2094066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2094069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2094075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094101 */     // MIs[0] round
     /* 2094101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094104 */     // MIs[0] policy
     /* 2094104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094114 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2094117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094140 */     // GIR_Coverage, 18789,
     /* 2094140 */     GIR_EraseRootFromParent_Done,
     /* 2094141 */   // Label 27597: @2094141
     /* 2094141 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2094232), // Rule ID 18792 //
     /* 2094146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2094149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2094157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2094160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2094166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094192 */     // MIs[0] round
     /* 2094192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094195 */     // MIs[0] policy
     /* 2094195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094205 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2094208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094231 */     // GIR_Coverage, 18792,
     /* 2094231 */     GIR_EraseRootFromParent_Done,
     /* 2094232 */   // Label 27598: @2094232
     /* 2094232 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2094323), // Rule ID 18793 //
     /* 2094237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2094240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2094248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2094251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2094257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094283 */     // MIs[0] round
     /* 2094283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094286 */     // MIs[0] policy
     /* 2094286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094296 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2094299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094322 */     // GIR_Coverage, 18793,
     /* 2094322 */     GIR_EraseRootFromParent_Done,
     /* 2094323 */   // Label 27599: @2094323
     /* 2094323 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2094414), // Rule ID 18796 //
     /* 2094328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2094331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2094339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2094342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2094348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094374 */     // MIs[0] round
     /* 2094374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094377 */     // MIs[0] policy
     /* 2094377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094387 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2094390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094413 */     // GIR_Coverage, 18796,
     /* 2094413 */     GIR_EraseRootFromParent_Done,
     /* 2094414 */   // Label 27600: @2094414
     /* 2094414 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2094505), // Rule ID 18797 //
     /* 2094419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2094422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2094430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2094433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2094439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094465 */     // MIs[0] round
     /* 2094465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094468 */     // MIs[0] policy
     /* 2094468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094478 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2094481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094504 */     // GIR_Coverage, 18797,
     /* 2094504 */     GIR_EraseRootFromParent_Done,
     /* 2094505 */   // Label 27601: @2094505
     /* 2094505 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2094596), // Rule ID 18800 //
     /* 2094510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2094513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2094521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2094524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2094530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094556 */     // MIs[0] round
     /* 2094556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094559 */     // MIs[0] policy
     /* 2094559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094569 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2094572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094595 */     // GIR_Coverage, 18800,
     /* 2094595 */     GIR_EraseRootFromParent_Done,
     /* 2094596 */   // Label 27602: @2094596
     /* 2094596 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2094687), // Rule ID 18801 //
     /* 2094601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2094604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2094612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2094615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2094621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094647 */     // MIs[0] round
     /* 2094647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094650 */     // MIs[0] policy
     /* 2094650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094660 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2094663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094686 */     // GIR_Coverage, 18801,
     /* 2094686 */     GIR_EraseRootFromParent_Done,
     /* 2094687 */   // Label 27603: @2094687
     /* 2094687 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2094778), // Rule ID 18804 //
     /* 2094692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2094695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2094703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2094706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2094712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094738 */     // MIs[0] round
     /* 2094738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094741 */     // MIs[0] policy
     /* 2094741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094751 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2094754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094777 */     // GIR_Coverage, 18804,
     /* 2094777 */     GIR_EraseRootFromParent_Done,
     /* 2094778 */   // Label 27604: @2094778
     /* 2094778 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2094869), // Rule ID 18805 //
     /* 2094783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2094786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2094794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2094797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2094803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094829 */     // MIs[0] round
     /* 2094829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094832 */     // MIs[0] policy
     /* 2094832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2094845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094868 */     // GIR_Coverage, 18805,
     /* 2094868 */     GIR_EraseRootFromParent_Done,
     /* 2094869 */   // Label 27605: @2094869
     /* 2094869 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2094960), // Rule ID 18808 //
     /* 2094874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2094877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2094885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2094888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2094891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2094894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094920 */     // MIs[0] round
     /* 2094920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094923 */     // MIs[0] policy
     /* 2094923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094933 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2094936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2094940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094959 */     // GIR_Coverage, 18808,
     /* 2094959 */     GIR_EraseRootFromParent_Done,
     /* 2094960 */   // Label 27606: @2094960
     /* 2094960 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2095051), // Rule ID 18809 //
     /* 2094965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2094968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2094973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2094976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2094979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2094982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2094985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095011 */     // MIs[0] round
     /* 2095011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095014 */     // MIs[0] policy
     /* 2095014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095024 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2095027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095050 */     // GIR_Coverage, 18809,
     /* 2095050 */     GIR_EraseRootFromParent_Done,
     /* 2095051 */   // Label 27607: @2095051
     /* 2095051 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2095142), // Rule ID 18812 //
     /* 2095056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2095059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2095067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2095070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2095076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095102 */     // MIs[0] round
     /* 2095102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095105 */     // MIs[0] policy
     /* 2095105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095115 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2095118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095141 */     // GIR_Coverage, 18812,
     /* 2095141 */     GIR_EraseRootFromParent_Done,
     /* 2095142 */   // Label 27608: @2095142
     /* 2095142 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2095233), // Rule ID 18813 //
     /* 2095147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2095150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2095158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2095161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2095167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095193 */     // MIs[0] round
     /* 2095193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095196 */     // MIs[0] policy
     /* 2095196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095206 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2095209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095232 */     // GIR_Coverage, 18813,
     /* 2095232 */     GIR_EraseRootFromParent_Done,
     /* 2095233 */   // Label 27609: @2095233
     /* 2095233 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2095324), // Rule ID 18816 //
     /* 2095238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2095241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095284 */     // MIs[0] round
     /* 2095284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095287 */     // MIs[0] policy
     /* 2095287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095297 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2095300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095323 */     // GIR_Coverage, 18816,
     /* 2095323 */     GIR_EraseRootFromParent_Done,
     /* 2095324 */   // Label 27610: @2095324
     /* 2095324 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2095415), // Rule ID 18817 //
     /* 2095329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2095332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095375 */     // MIs[0] round
     /* 2095375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095378 */     // MIs[0] policy
     /* 2095378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095388 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2095391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095414 */     // GIR_Coverage, 18817,
     /* 2095414 */     GIR_EraseRootFromParent_Done,
     /* 2095415 */   // Label 27611: @2095415
     /* 2095415 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2095506), // Rule ID 18820 //
     /* 2095420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2095423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095466 */     // MIs[0] round
     /* 2095466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095469 */     // MIs[0] policy
     /* 2095469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095479 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2095482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095505 */     // GIR_Coverage, 18820,
     /* 2095505 */     GIR_EraseRootFromParent_Done,
     /* 2095506 */   // Label 27612: @2095506
     /* 2095506 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2095597), // Rule ID 18821 //
     /* 2095511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2095514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095557 */     // MIs[0] round
     /* 2095557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095560 */     // MIs[0] policy
     /* 2095560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11001:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2095573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095596 */     // GIR_Coverage, 18821,
     /* 2095596 */     GIR_EraseRootFromParent_Done,
     /* 2095597 */   // Label 27613: @2095597
     /* 2095597 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2095688), // Rule ID 18824 //
     /* 2095602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2095605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2095622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095648 */     // MIs[0] round
     /* 2095648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095651 */     // MIs[0] policy
     /* 2095651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095661 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2095664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095687 */     // GIR_Coverage, 18824,
     /* 2095687 */     GIR_EraseRootFromParent_Done,
     /* 2095688 */   // Label 27614: @2095688
     /* 2095688 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2095779), // Rule ID 18825 //
     /* 2095693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2095696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2095713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095739 */     // MIs[0] round
     /* 2095739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095742 */     // MIs[0] policy
     /* 2095742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2095755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095778 */     // GIR_Coverage, 18825,
     /* 2095778 */     GIR_EraseRootFromParent_Done,
     /* 2095779 */   // Label 27615: @2095779
     /* 2095779 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2095870), // Rule ID 18828 //
     /* 2095784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2095787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2095795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2095798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2095804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095830 */     // MIs[0] round
     /* 2095830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095833 */     // MIs[0] policy
     /* 2095833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095843 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2095846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095869 */     // GIR_Coverage, 18828,
     /* 2095869 */     GIR_EraseRootFromParent_Done,
     /* 2095870 */   // Label 27616: @2095870
     /* 2095870 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2095961), // Rule ID 18829 //
     /* 2095875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2095878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2095886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2095889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2095895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2095913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095921 */     // MIs[0] round
     /* 2095921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095924 */     // MIs[0] policy
     /* 2095924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2095937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2095941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095960 */     // GIR_Coverage, 18829,
     /* 2095960 */     GIR_EraseRootFromParent_Done,
     /* 2095961 */   // Label 27617: @2095961
     /* 2095961 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2096052), // Rule ID 18832 //
     /* 2095966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2095969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2095974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2095977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2095980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2095983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2095986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2096004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096012 */     // MIs[0] round
     /* 2096012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096015 */     // MIs[0] policy
     /* 2096015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096025 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2096028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096051 */     // GIR_Coverage, 18832,
     /* 2096051 */     GIR_EraseRootFromParent_Done,
     /* 2096052 */   // Label 27618: @2096052
     /* 2096052 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2096143), // Rule ID 18833 //
     /* 2096057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2096060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2096068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2096071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2096074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2096077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2096080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2096095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096103 */     // MIs[0] round
     /* 2096103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096106 */     // MIs[0] policy
     /* 2096106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096116 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2096119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096142 */     // GIR_Coverage, 18833,
     /* 2096142 */     GIR_EraseRootFromParent_Done,
     /* 2096143 */   // Label 27619: @2096143
     /* 2096143 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2096234), // Rule ID 18836 //
     /* 2096148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2096151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2096159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2096162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096194 */     // MIs[0] round
     /* 2096194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096197 */     // MIs[0] policy
     /* 2096197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096207 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2096210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096233 */     // GIR_Coverage, 18836,
     /* 2096233 */     GIR_EraseRootFromParent_Done,
     /* 2096234 */   // Label 27620: @2096234
     /* 2096234 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2096325), // Rule ID 18837 //
     /* 2096239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2096242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2096250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2096253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096285 */     // MIs[0] round
     /* 2096285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096288 */     // MIs[0] policy
     /* 2096288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11001:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2096301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096324 */     // GIR_Coverage, 18837,
     /* 2096324 */     GIR_EraseRootFromParent_Done,
     /* 2096325 */   // Label 27621: @2096325
     /* 2096325 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2096416), // Rule ID 18840 //
     /* 2096330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2096333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2096341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2096344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096376 */     // MIs[0] round
     /* 2096376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096379 */     // MIs[0] policy
     /* 2096379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096389 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2096392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096415 */     // GIR_Coverage, 18840,
     /* 2096415 */     GIR_EraseRootFromParent_Done,
     /* 2096416 */   // Label 27622: @2096416
     /* 2096416 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2096507), // Rule ID 18841 //
     /* 2096421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2096424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2096432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2096435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096467 */     // MIs[0] round
     /* 2096467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096470 */     // MIs[0] policy
     /* 2096470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11001:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2096483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096506 */     // GIR_Coverage, 18841,
     /* 2096506 */     GIR_EraseRootFromParent_Done,
     /* 2096507 */   // Label 27623: @2096507
     /* 2096507 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2096598), // Rule ID 18844 //
     /* 2096512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2096515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2096523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2096526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2096532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096558 */     // MIs[0] round
     /* 2096558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096561 */     // MIs[0] policy
     /* 2096561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096571 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2096574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096597 */     // GIR_Coverage, 18844,
     /* 2096597 */     GIR_EraseRootFromParent_Done,
     /* 2096598 */   // Label 27624: @2096598
     /* 2096598 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2096689), // Rule ID 18845 //
     /* 2096603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2096606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2096614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2096617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2096623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096649 */     // MIs[0] round
     /* 2096649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096652 */     // MIs[0] policy
     /* 2096652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096662 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11001:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2096665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096688 */     // GIR_Coverage, 18845,
     /* 2096688 */     GIR_EraseRootFromParent_Done,
     /* 2096689 */   // Label 27625: @2096689
     /* 2096689 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2096780), // Rule ID 18848 //
     /* 2096694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2096697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2096705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2096708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2096714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096740 */     // MIs[0] round
     /* 2096740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096743 */     // MIs[0] policy
     /* 2096743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096753 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2096756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096779 */     // GIR_Coverage, 18848,
     /* 2096779 */     GIR_EraseRootFromParent_Done,
     /* 2096780 */   // Label 27626: @2096780
     /* 2096780 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2096871), // Rule ID 18849 //
     /* 2096785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2096788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2096793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2096796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2096799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2096802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2096805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096831 */     // MIs[0] round
     /* 2096831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096834 */     // MIs[0] policy
     /* 2096834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096844 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11001:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2096847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2096851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096870 */     // GIR_Coverage, 18849,
     /* 2096870 */     GIR_EraseRootFromParent_Done,
     /* 2096871 */   // Label 27627: @2096871
     /* 2096871 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2096962), // Rule ID 63667 //
     /* 2096876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2096879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2096884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2096893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2096918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096922 */     // MIs[0] round
     /* 2096922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096925 */     // MIs[0] policy
     /* 2096925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096935 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2096938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096961 */     // GIR_Coverage, 63667,
     /* 2096961 */     GIR_EraseRootFromParent_Done,
     /* 2096962 */   // Label 27628: @2096962
     /* 2096962 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2097053), // Rule ID 63668 //
     /* 2096967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2096970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2096975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2096984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097013 */     // MIs[0] round
     /* 2097013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097016 */     // MIs[0] policy
     /* 2097016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2097029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097052 */     // GIR_Coverage, 63668,
     /* 2097052 */     GIR_EraseRootFromParent_Done,
     /* 2097053 */   // Label 27629: @2097053
     /* 2097053 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2097144), // Rule ID 63671 //
     /* 2097058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097104 */     // MIs[0] round
     /* 2097104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097107 */     // MIs[0] policy
     /* 2097107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2097120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097143 */     // GIR_Coverage, 63671,
     /* 2097143 */     GIR_EraseRootFromParent_Done,
     /* 2097144 */   // Label 27630: @2097144
     /* 2097144 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2097235), // Rule ID 63672 //
     /* 2097149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2097152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097195 */     // MIs[0] round
     /* 2097195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097198 */     // MIs[0] policy
     /* 2097198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097208 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2097211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097234 */     // GIR_Coverage, 63672,
     /* 2097234 */     GIR_EraseRootFromParent_Done,
     /* 2097235 */   // Label 27631: @2097235
     /* 2097235 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2097326), // Rule ID 63675 //
     /* 2097240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097286 */     // MIs[0] round
     /* 2097286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097289 */     // MIs[0] policy
     /* 2097289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097299 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2097302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097325 */     // GIR_Coverage, 63675,
     /* 2097325 */     GIR_EraseRootFromParent_Done,
     /* 2097326 */   // Label 27632: @2097326
     /* 2097326 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2097417), // Rule ID 63676 //
     /* 2097331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2097334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097377 */     // MIs[0] round
     /* 2097377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097380 */     // MIs[0] policy
     /* 2097380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2097393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097416 */     // GIR_Coverage, 63676,
     /* 2097416 */     GIR_EraseRootFromParent_Done,
     /* 2097417 */   // Label 27633: @2097417
     /* 2097417 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2097508), // Rule ID 63679 //
     /* 2097422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2097439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097468 */     // MIs[0] round
     /* 2097468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097471 */     // MIs[0] policy
     /* 2097471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097481 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2097484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097507 */     // GIR_Coverage, 63679,
     /* 2097507 */     GIR_EraseRootFromParent_Done,
     /* 2097508 */   // Label 27634: @2097508
     /* 2097508 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2097599), // Rule ID 63680 //
     /* 2097513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2097516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2097530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097559 */     // MIs[0] round
     /* 2097559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097562 */     // MIs[0] policy
     /* 2097562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2097575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097598 */     // GIR_Coverage, 63680,
     /* 2097598 */     GIR_EraseRootFromParent_Done,
     /* 2097599 */   // Label 27635: @2097599
     /* 2097599 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2097690), // Rule ID 63683 //
     /* 2097604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2097621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097650 */     // MIs[0] round
     /* 2097650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097653 */     // MIs[0] policy
     /* 2097653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097663 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2097666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097689 */     // GIR_Coverage, 63683,
     /* 2097689 */     GIR_EraseRootFromParent_Done,
     /* 2097690 */   // Label 27636: @2097690
     /* 2097690 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2097781), // Rule ID 63684 //
     /* 2097695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2097698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2097703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2097712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097741 */     // MIs[0] round
     /* 2097741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097744 */     // MIs[0] policy
     /* 2097744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2097757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097780 */     // GIR_Coverage, 63684,
     /* 2097780 */     GIR_EraseRootFromParent_Done,
     /* 2097781 */   // Label 27637: @2097781
     /* 2097781 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2097872), // Rule ID 63687 //
     /* 2097786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2097794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2097797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2097800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097832 */     // MIs[0] round
     /* 2097832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097835 */     // MIs[0] policy
     /* 2097835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097845 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2097848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097871 */     // GIR_Coverage, 63687,
     /* 2097871 */     GIR_EraseRootFromParent_Done,
     /* 2097872 */   // Label 27638: @2097872
     /* 2097872 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2097963), // Rule ID 63688 //
     /* 2097877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2097880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2097885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2097888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2097891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2097919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097923 */     // MIs[0] round
     /* 2097923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097926 */     // MIs[0] policy
     /* 2097926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2097939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097962 */     // GIR_Coverage, 63688,
     /* 2097962 */     GIR_EraseRootFromParent_Done,
     /* 2097963 */   // Label 27639: @2097963
     /* 2097963 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2098054), // Rule ID 63691 //
     /* 2097968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2097971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2097976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098014 */     // MIs[0] round
     /* 2098014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098017 */     // MIs[0] policy
     /* 2098017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098027 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2098030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098053 */     // GIR_Coverage, 63691,
     /* 2098053 */     GIR_EraseRootFromParent_Done,
     /* 2098054 */   // Label 27640: @2098054
     /* 2098054 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2098145), // Rule ID 63692 //
     /* 2098059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2098062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2098070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2098073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098105 */     // MIs[0] round
     /* 2098105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098108 */     // MIs[0] policy
     /* 2098108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098118 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2098121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098144 */     // GIR_Coverage, 63692,
     /* 2098144 */     GIR_EraseRootFromParent_Done,
     /* 2098145 */   // Label 27641: @2098145
     /* 2098145 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2098236), // Rule ID 63695 //
     /* 2098150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2098153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2098161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2098164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098196 */     // MIs[0] round
     /* 2098196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098199 */     // MIs[0] policy
     /* 2098199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098209 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2098212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098235 */     // GIR_Coverage, 63695,
     /* 2098235 */     GIR_EraseRootFromParent_Done,
     /* 2098236 */   // Label 27642: @2098236
     /* 2098236 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2098327), // Rule ID 63696 //
     /* 2098241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2098244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2098252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2098255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098287 */     // MIs[0] round
     /* 2098287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098290 */     // MIs[0] policy
     /* 2098290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098300 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2098303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098326 */     // GIR_Coverage, 63696,
     /* 2098326 */     GIR_EraseRootFromParent_Done,
     /* 2098327 */   // Label 27643: @2098327
     /* 2098327 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2098418), // Rule ID 63699 //
     /* 2098332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2098335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2098343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2098346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098378 */     // MIs[0] round
     /* 2098378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098381 */     // MIs[0] policy
     /* 2098381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098391 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2098394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098417 */     // GIR_Coverage, 63699,
     /* 2098417 */     GIR_EraseRootFromParent_Done,
     /* 2098418 */   // Label 27644: @2098418
     /* 2098418 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2098509), // Rule ID 63700 //
     /* 2098423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2098426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2098434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2098437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098469 */     // MIs[0] round
     /* 2098469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098472 */     // MIs[0] policy
     /* 2098472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2098485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098508 */     // GIR_Coverage, 63700,
     /* 2098508 */     GIR_EraseRootFromParent_Done,
     /* 2098509 */   // Label 27645: @2098509
     /* 2098509 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2098600), // Rule ID 63703 //
     /* 2098514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2098517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2098525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2098528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098560 */     // MIs[0] round
     /* 2098560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098563 */     // MIs[0] policy
     /* 2098563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2098576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098599 */     // GIR_Coverage, 63703,
     /* 2098599 */     GIR_EraseRootFromParent_Done,
     /* 2098600 */   // Label 27646: @2098600
     /* 2098600 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2098691), // Rule ID 63704 //
     /* 2098605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2098608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2098613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2098616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2098619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098651 */     // MIs[0] round
     /* 2098651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098654 */     // MIs[0] policy
     /* 2098654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2098667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098690 */     // GIR_Coverage, 63704,
     /* 2098690 */     GIR_EraseRootFromParent_Done,
     /* 2098691 */   // Label 27647: @2098691
     /* 2098691 */   GIM_Reject,
     /* 2098692 */ // Label 25603: @2098692
     /* 2098692 */ GIM_Reject,
     /* 2098693 */ // Label 38: @2098693
     /* 2098693 */ GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2098776), // Rule ID 35 //
     /* 2098698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2098701 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2098704 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2098709 */   // MIs[0] Operand 1
     /* 2098709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2098713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2098717 */   // MIs[0] ptr
     /* 2098717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2098721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2098725 */   // MIs[0] accessinfo
     /* 2098725 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2098728 */   // (intrinsic_void 192:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2098728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2098732 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2098738 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2098742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2098745 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2098747 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2098749 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2098752 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2098755 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2098758 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2098761 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2098764 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2098767 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2098770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2098774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2098775 */   // GIR_Coverage, 35,
     /* 2098775 */   GIR_EraseRootFromParent_Done,
     /* 2098776 */ // Label 27648: @2098776
     /* 2098776 */ GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2099681),
     /* 2098781 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2098784 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2098856), // Rule ID 605 //
     /* 2098789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2098792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2098797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2098800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2098803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098810 */     // MIs[0] addr
     /* 2098810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2098814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098826 */     // MIs[0] ordering
     /* 2098826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2098829 */     // (intrinsic_w_chain:{ *:[i32] } 10724:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2098829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2098832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2098835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2098837 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2098842 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2098844 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2098846 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2098848 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2098850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2098854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098855 */     // GIR_Coverage, 605,
     /* 2098855 */     GIR_EraseRootFromParent_Done,
     /* 2098856 */   // Label 27650: @2098856
     /* 2098856 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2098928), // Rule ID 606 //
     /* 2098861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2098864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2098869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2098872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2098875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098882 */     // MIs[0] addr
     /* 2098882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2098886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098898 */     // MIs[0] ordering
     /* 2098898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2098901 */     // (intrinsic_w_chain:{ *:[i32] } 10710:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2098901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2098904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2098907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2098909 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2098914 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2098916 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2098918 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2098920 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2098922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2098926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098927 */     // GIR_Coverage, 606,
     /* 2098927 */     GIR_EraseRootFromParent_Done,
     /* 2098928 */   // Label 27651: @2098928
     /* 2098928 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2099000), // Rule ID 607 //
     /* 2098933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2098936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2098941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2098944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2098947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098954 */     // MIs[0] addr
     /* 2098954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2098958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098970 */     // MIs[0] ordering
     /* 2098970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2098973 */     // (intrinsic_w_chain:{ *:[i32] } 10718:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2098973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2098976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2098979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2098981 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2098986 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2098988 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2098990 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2098992 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2098994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2098998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098999 */     // GIR_Coverage, 607,
     /* 2098999 */     GIR_EraseRootFromParent_Done,
     /* 2099000 */   // Label 27652: @2099000
     /* 2099000 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2099072), // Rule ID 608 //
     /* 2099005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2099008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2099013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2099016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2099019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099026 */     // MIs[0] addr
     /* 2099026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099042 */     // MIs[0] ordering
     /* 2099042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099045 */     // (intrinsic_w_chain:{ *:[i32] } 10716:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2099045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2099051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099053 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099058 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099060 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099062 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099064 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099071 */     // GIR_Coverage, 608,
     /* 2099071 */     GIR_EraseRootFromParent_Done,
     /* 2099072 */   // Label 27653: @2099072
     /* 2099072 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2099152), // Rule ID 611 //
     /* 2099077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2099080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2099085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2099088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2099091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099098 */     // MIs[0] addr
     /* 2099098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099114 */     // MIs[0] ordering
     /* 2099114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099117 */     // (intrinsic_w_chain:{ *:[i32] } 10720:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2099117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2099126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099128 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099133 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099138 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099140 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099142 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099144 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099151 */     // GIR_Coverage, 611,
     /* 2099151 */     GIR_EraseRootFromParent_Done,
     /* 2099152 */   // Label 27654: @2099152
     /* 2099152 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2099232), // Rule ID 612 //
     /* 2099157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2099160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2099165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2099168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2099171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099178 */     // MIs[0] addr
     /* 2099178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099194 */     // MIs[0] ordering
     /* 2099194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099197 */     // (intrinsic_w_chain:{ *:[i32] } 10722:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2099197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2099206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099208 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099213 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099218 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099220 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099222 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099224 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099231 */     // GIR_Coverage, 612,
     /* 2099231 */     GIR_EraseRootFromParent_Done,
     /* 2099232 */   // Label 27655: @2099232
     /* 2099232 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2099304), // Rule ID 618 //
     /* 2099237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2099245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099258 */     // MIs[0] addr
     /* 2099258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099274 */     // MIs[0] ordering
     /* 2099274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099277 */     // (intrinsic_w_chain:{ *:[i64] } 10725:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2099283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099285 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099290 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099292 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099294 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099296 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099303 */     // GIR_Coverage, 618,
     /* 2099303 */     GIR_EraseRootFromParent_Done,
     /* 2099304 */   // Label 27656: @2099304
     /* 2099304 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2099376), // Rule ID 619 //
     /* 2099309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2099317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099330 */     // MIs[0] addr
     /* 2099330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099346 */     // MIs[0] ordering
     /* 2099346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099349 */     // (intrinsic_w_chain:{ *:[i64] } 10711:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2099355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099357 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099362 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099364 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099366 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099368 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099375 */     // GIR_Coverage, 619,
     /* 2099375 */     GIR_EraseRootFromParent_Done,
     /* 2099376 */   // Label 27657: @2099376
     /* 2099376 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2099448), // Rule ID 620 //
     /* 2099381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2099389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099402 */     // MIs[0] addr
     /* 2099402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099418 */     // MIs[0] ordering
     /* 2099418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099421 */     // (intrinsic_w_chain:{ *:[i64] } 10719:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2099427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099429 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099434 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099436 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099438 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099440 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099447 */     // GIR_Coverage, 620,
     /* 2099447 */     GIR_EraseRootFromParent_Done,
     /* 2099448 */   // Label 27658: @2099448
     /* 2099448 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2099520), // Rule ID 621 //
     /* 2099453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2099461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099474 */     // MIs[0] addr
     /* 2099474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099490 */     // MIs[0] ordering
     /* 2099490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099493 */     // (intrinsic_w_chain:{ *:[i64] } 10717:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2099499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099501 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099506 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099508 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099510 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099512 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099519 */     // GIR_Coverage, 621,
     /* 2099519 */     GIR_EraseRootFromParent_Done,
     /* 2099520 */   // Label 27659: @2099520
     /* 2099520 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2099600), // Rule ID 624 //
     /* 2099525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2099533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099546 */     // MIs[0] addr
     /* 2099546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099562 */     // MIs[0] ordering
     /* 2099562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099565 */     // (intrinsic_w_chain:{ *:[i64] } 10721:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2099574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099576 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099581 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099586 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099588 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099590 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099592 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099599 */     // GIR_Coverage, 624,
     /* 2099599 */     GIR_EraseRootFromParent_Done,
     /* 2099600 */   // Label 27660: @2099600
     /* 2099600 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2099680), // Rule ID 625 //
     /* 2099605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2099613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099626 */     // MIs[0] addr
     /* 2099626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099642 */     // MIs[0] ordering
     /* 2099642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2099645 */     // (intrinsic_w_chain:{ *:[i64] } 10723:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2099645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2099654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099656 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099661 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099666 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099668 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099670 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099672 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2099674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099679 */     // GIR_Coverage, 625,
     /* 2099679 */     GIR_EraseRootFromParent_Done,
     /* 2099680 */   // Label 27661: @2099680
     /* 2099680 */   GIM_Reject,
     /* 2099681 */ // Label 27649: @2099681
     /* 2099681 */ GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2100208),
     /* 2099686 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2099689 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2099778), // Rule ID 609 //
     /* 2099694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2099697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2099702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2099705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2099708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2099714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099718 */     // MIs[0] addr
     /* 2099718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099738 */     // MIs[0] ordering
     /* 2099738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099741 */     // (intrinsic_w_chain:{ *:[i32] } 10712:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2099741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2099750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099752 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099757 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099762 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099764 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099766 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099768 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2099770 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2099772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099777 */     // GIR_Coverage, 609,
     /* 2099777 */     GIR_EraseRootFromParent_Done,
     /* 2099778 */   // Label 27663: @2099778
     /* 2099778 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2099867), // Rule ID 610 //
     /* 2099783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2099786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2099791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2099794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2099797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2099803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099807 */     // MIs[0] addr
     /* 2099807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099827 */     // MIs[0] ordering
     /* 2099827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099830 */     // (intrinsic_w_chain:{ *:[i32] } 10714:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2099830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2099839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099841 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099846 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099851 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099853 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099855 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099857 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2099859 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2099861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099866 */     // GIR_Coverage, 610,
     /* 2099866 */     GIR_EraseRootFromParent_Done,
     /* 2099867 */   // Label 27664: @2099867
     /* 2099867 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2099956), // Rule ID 622 //
     /* 2099872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2099880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2099892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099896 */     // MIs[0] addr
     /* 2099896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099916 */     // MIs[0] ordering
     /* 2099916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099919 */     // (intrinsic_w_chain:{ *:[i64] } 10713:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2099919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2099922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2099925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2099928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2099930 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099935 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2099940 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2099942 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2099944 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2099946 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2099948 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2099950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2099954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099955 */     // GIR_Coverage, 622,
     /* 2099955 */     GIR_EraseRootFromParent_Done,
     /* 2099956 */   // Label 27665: @2099956
     /* 2099956 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2100045), // Rule ID 623 //
     /* 2099961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2099964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2099969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2099972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2099975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2099981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099985 */     // MIs[0] addr
     /* 2099985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2099989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100005 */     // MIs[0] ordering
     /* 2100005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100008 */     // (intrinsic_w_chain:{ *:[i64] } 10715:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2100008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2100011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2100014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2100017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2100019 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2100024 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2100029 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2100031 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2100033 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2100035 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2100037 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2100039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2100043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100044 */     // GIR_Coverage, 623,
     /* 2100044 */     GIR_EraseRootFromParent_Done,
     /* 2100045 */   // Label 27666: @2100045
     /* 2100045 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2100126), // Rule ID 641 //
     /* 2100050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2100053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2100058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2100061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2100064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2100070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100074 */     // MIs[0] addr
     /* 2100074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2100078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100094 */     // MIs[0] ordering
     /* 2100094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100097 */     // (intrinsic_w_chain:{ *:[i32] } 10726:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2100097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2100100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2100103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2100105 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2100110 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2100112 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2100114 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2100116 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2100118 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2100120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2100124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100125 */     // GIR_Coverage, 641,
     /* 2100125 */     GIR_EraseRootFromParent_Done,
     /* 2100126 */   // Label 27667: @2100126
     /* 2100126 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2100207), // Rule ID 642 //
     /* 2100131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2100134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2100139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2100142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2100145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2100151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100155 */     // MIs[0] addr
     /* 2100155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2100159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100175 */     // MIs[0] ordering
     /* 2100175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100178 */     // (intrinsic_w_chain:{ *:[i64] } 10727:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2100178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2100181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2100184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2100186 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2100191 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2100193 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2100195 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2100197 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2100199 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2100201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2100205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100206 */     // GIR_Coverage, 642,
     /* 2100206 */     GIR_EraseRootFromParent_Done,
     /* 2100207 */   // Label 27668: @2100207
     /* 2100207 */   GIM_Reject,
     /* 2100208 */ // Label 27662: @2100208
     /* 2100208 */ GIM_Reject,
     /* 2100209 */ // Label 39: @2100209
     /* 2100209 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 27684*/ GIMT_Encode4(2103329),
     /* 2100220 */ /*GILLT_nxv1s16*//*Label 27669*/ GIMT_Encode4(2100320),
     /* 2100224 */ /*GILLT_nxv1s32*//*Label 27670*/ GIMT_Encode4(2100424),
     /* 2100228 */ /*GILLT_nxv1s64*//*Label 27671*/ GIMT_Encode4(2100641), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2100240 */ /*GILLT_nxv2s16*//*Label 27672*/ GIMT_Encode4(2100966),
     /* 2100244 */ /*GILLT_nxv2s32*//*Label 27673*/ GIMT_Encode4(2101070),
     /* 2100248 */ /*GILLT_nxv2s64*//*Label 27674*/ GIMT_Encode4(2101287), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2100260 */ /*GILLT_nxv4s16*//*Label 27675*/ GIMT_Encode4(2101612),
     /* 2100264 */ /*GILLT_nxv4s32*//*Label 27676*/ GIMT_Encode4(2101716),
     /* 2100268 */ /*GILLT_nxv4s64*//*Label 27677*/ GIMT_Encode4(2101933), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2100280 */ /*GILLT_nxv8s16*//*Label 27678*/ GIMT_Encode4(2102258),
     /* 2100284 */ /*GILLT_nxv8s32*//*Label 27679*/ GIMT_Encode4(2102362),
     /* 2100288 */ /*GILLT_nxv8s64*//*Label 27680*/ GIMT_Encode4(2102579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2100300 */ /*GILLT_nxv16s16*//*Label 27681*/ GIMT_Encode4(2102904),
     /* 2100304 */ /*GILLT_nxv16s32*//*Label 27682*/ GIMT_Encode4(2103008), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2100316 */ /*GILLT_nxv32s16*//*Label 27683*/ GIMT_Encode4(2103225),
     /* 2100320 */ // Label 27669: @2100320
     /* 2100320 */ GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2100423),
     /* 2100325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2100328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100336 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2100379), // Rule ID 46940 //
     /* 2100341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100344 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2100347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2100361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100378 */     // GIR_Coverage, 46940,
     /* 2100378 */     GIR_EraseRootFromParent_Done,
     /* 2100379 */   // Label 27686: @2100379
     /* 2100379 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2100422), // Rule ID 46941 //
     /* 2100384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100387 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2100390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2100404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100421 */     // GIR_Coverage, 46941,
     /* 2100421 */     GIR_EraseRootFromParent_Done,
     /* 2100422 */   // Label 27687: @2100422
     /* 2100422 */   GIM_Reject,
     /* 2100423 */ // Label 27685: @2100423
     /* 2100423 */ GIM_Reject,
     /* 2100424 */ // Label 27670: @2100424
     /* 2100424 */ GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2100478), // Rule ID 46964 //
     /* 2100429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2100435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100443 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2100446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2100460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100477 */   // GIR_Coverage, 46964,
     /* 2100477 */   GIR_EraseRootFromParent_Done,
     /* 2100478 */ // Label 27688: @2100478
     /* 2100478 */ GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2100532), // Rule ID 46965 //
     /* 2100483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2100489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100497 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2100500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2100514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100519 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100531 */   // GIR_Coverage, 46965,
     /* 2100531 */   GIR_EraseRootFromParent_Done,
     /* 2100532 */ // Label 27689: @2100532
     /* 2100532 */ GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2100586), // Rule ID 47030 //
     /* 2100537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2100543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100551 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2100554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2100568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100585 */   // GIR_Coverage, 47030,
     /* 2100585 */   GIR_EraseRootFromParent_Done,
     /* 2100586 */ // Label 27690: @2100586
     /* 2100586 */ GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2100640), // Rule ID 47031 //
     /* 2100591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2100597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100605 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2100608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2100622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100627 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100639 */   // GIR_Coverage, 47031,
     /* 2100639 */   GIR_EraseRootFromParent_Done,
     /* 2100640 */ // Label 27691: @2100640
     /* 2100640 */ GIM_Reject,
     /* 2100641 */ // Label 27671: @2100641
     /* 2100641 */ GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2100695), // Rule ID 46984 //
     /* 2100646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2100649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2100652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100660 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2100677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100682 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100694 */   // GIR_Coverage, 46984,
     /* 2100694 */   GIR_EraseRootFromParent_Done,
     /* 2100695 */ // Label 27692: @2100695
     /* 2100695 */ GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2100749), // Rule ID 46985 //
     /* 2100700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2100703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2100706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100714 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2100731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100748 */   // GIR_Coverage, 46985,
     /* 2100748 */   GIR_EraseRootFromParent_Done,
     /* 2100749 */ // Label 27693: @2100749
     /* 2100749 */ GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2100803), // Rule ID 47050 //
     /* 2100754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2100757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2100760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100768 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2100785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100802 */   // GIR_Coverage, 47050,
     /* 2100802 */   GIR_EraseRootFromParent_Done,
     /* 2100803 */ // Label 27694: @2100803
     /* 2100803 */ GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2100857), // Rule ID 47051 //
     /* 2100808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2100811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2100814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100822 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2100839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100856 */   // GIR_Coverage, 47051,
     /* 2100856 */   GIR_EraseRootFromParent_Done,
     /* 2100857 */ // Label 27695: @2100857
     /* 2100857 */ GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2100911), // Rule ID 47084 //
     /* 2100862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2100865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2100868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100876 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2100893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100910 */   // GIR_Coverage, 47084,
     /* 2100910 */   GIR_EraseRootFromParent_Done,
     /* 2100911 */ // Label 27696: @2100911
     /* 2100911 */ GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2100965), // Rule ID 47085 //
     /* 2100916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2100919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2100922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100930 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2100930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2100933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2100942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2100944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2100947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2100952 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2100954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2100957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2100964 */   // GIR_Coverage, 47085,
     /* 2100964 */   GIR_EraseRootFromParent_Done,
     /* 2100965 */ // Label 27697: @2100965
     /* 2100965 */ GIM_Reject,
     /* 2100966 */ // Label 27672: @2100966
     /* 2100966 */ GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2101069),
     /* 2100971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2100974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100982 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2101025), // Rule ID 46944 //
     /* 2100987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100990 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2100990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2100993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2100997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2101007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101024 */     // GIR_Coverage, 46944,
     /* 2101024 */     GIR_EraseRootFromParent_Done,
     /* 2101025 */   // Label 27699: @2101025
     /* 2101025 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2101068), // Rule ID 46945 //
     /* 2101030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101033 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2101036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2101050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101067 */     // GIR_Coverage, 46945,
     /* 2101067 */     GIR_EraseRootFromParent_Done,
     /* 2101068 */   // Label 27700: @2101068
     /* 2101068 */   GIM_Reject,
     /* 2101069 */ // Label 27698: @2101069
     /* 2101069 */ GIM_Reject,
     /* 2101070 */ // Label 27673: @2101070
     /* 2101070 */ GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2101124), // Rule ID 46968 //
     /* 2101075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2101081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101089 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2101092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2101106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101111 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101123 */   // GIR_Coverage, 46968,
     /* 2101123 */   GIR_EraseRootFromParent_Done,
     /* 2101124 */ // Label 27701: @2101124
     /* 2101124 */ GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2101178), // Rule ID 46969 //
     /* 2101129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2101135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101143 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2101146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2101160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101165 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101177 */   // GIR_Coverage, 46969,
     /* 2101177 */   GIR_EraseRootFromParent_Done,
     /* 2101178 */ // Label 27702: @2101178
     /* 2101178 */ GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2101232), // Rule ID 47034 //
     /* 2101183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2101189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101197 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2101200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2101214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101219 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101231 */   // GIR_Coverage, 47034,
     /* 2101231 */   GIR_EraseRootFromParent_Done,
     /* 2101232 */ // Label 27703: @2101232
     /* 2101232 */ GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2101286), // Rule ID 47035 //
     /* 2101237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2101243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101251 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2101254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2101268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101273 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101285 */   // GIR_Coverage, 47035,
     /* 2101285 */   GIR_EraseRootFromParent_Done,
     /* 2101286 */ // Label 27704: @2101286
     /* 2101286 */ GIM_Reject,
     /* 2101287 */ // Label 27674: @2101287
     /* 2101287 */ GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2101341), // Rule ID 46988 //
     /* 2101292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2101298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101306 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2101323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101340 */   // GIR_Coverage, 46988,
     /* 2101340 */   GIR_EraseRootFromParent_Done,
     /* 2101341 */ // Label 27705: @2101341
     /* 2101341 */ GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2101395), // Rule ID 46989 //
     /* 2101346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2101352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101360 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2101377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101394 */   // GIR_Coverage, 46989,
     /* 2101394 */   GIR_EraseRootFromParent_Done,
     /* 2101395 */ // Label 27706: @2101395
     /* 2101395 */ GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2101449), // Rule ID 47054 //
     /* 2101400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2101406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101414 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2101431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101436 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101448 */   // GIR_Coverage, 47054,
     /* 2101448 */   GIR_EraseRootFromParent_Done,
     /* 2101449 */ // Label 27707: @2101449
     /* 2101449 */ GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2101503), // Rule ID 47055 //
     /* 2101454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2101460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101468 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2101485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101490 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101502 */   // GIR_Coverage, 47055,
     /* 2101502 */   GIR_EraseRootFromParent_Done,
     /* 2101503 */ // Label 27708: @2101503
     /* 2101503 */ GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2101557), // Rule ID 47088 //
     /* 2101508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2101514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101522 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2101539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101544 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101556 */   // GIR_Coverage, 47088,
     /* 2101556 */   GIR_EraseRootFromParent_Done,
     /* 2101557 */ // Label 27709: @2101557
     /* 2101557 */ GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2101611), // Rule ID 47089 //
     /* 2101562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2101568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101576 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2101579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2101593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101598 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101610 */   // GIR_Coverage, 47089,
     /* 2101610 */   GIR_EraseRootFromParent_Done,
     /* 2101611 */ // Label 27710: @2101611
     /* 2101611 */ GIM_Reject,
     /* 2101612 */ // Label 27675: @2101612
     /* 2101612 */ GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2101715),
     /* 2101617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2101620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101628 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2101671), // Rule ID 46948 //
     /* 2101633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101636 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2101639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2101653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101670 */     // GIR_Coverage, 46948,
     /* 2101670 */     GIR_EraseRootFromParent_Done,
     /* 2101671 */   // Label 27712: @2101671
     /* 2101671 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2101714), // Rule ID 46949 //
     /* 2101676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101679 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2101682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2101696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101713 */     // GIR_Coverage, 46949,
     /* 2101713 */     GIR_EraseRootFromParent_Done,
     /* 2101714 */   // Label 27713: @2101714
     /* 2101714 */   GIM_Reject,
     /* 2101715 */ // Label 27711: @2101715
     /* 2101715 */ GIM_Reject,
     /* 2101716 */ // Label 27676: @2101716
     /* 2101716 */ GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2101770), // Rule ID 46972 //
     /* 2101721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2101727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101735 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2101738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2101752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101769 */   // GIR_Coverage, 46972,
     /* 2101769 */   GIR_EraseRootFromParent_Done,
     /* 2101770 */ // Label 27714: @2101770
     /* 2101770 */ GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2101824), // Rule ID 46973 //
     /* 2101775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2101781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101789 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2101792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2101806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101823 */   // GIR_Coverage, 46973,
     /* 2101823 */   GIR_EraseRootFromParent_Done,
     /* 2101824 */ // Label 27715: @2101824
     /* 2101824 */ GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2101878), // Rule ID 47038 //
     /* 2101829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2101835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101843 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2101846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2101860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101877 */   // GIR_Coverage, 47038,
     /* 2101877 */   GIR_EraseRootFromParent_Done,
     /* 2101878 */ // Label 27716: @2101878
     /* 2101878 */ GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2101932), // Rule ID 47039 //
     /* 2101883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2101889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101897 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2101897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2101900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2101914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101931 */   // GIR_Coverage, 47039,
     /* 2101931 */   GIR_EraseRootFromParent_Done,
     /* 2101932 */ // Label 27717: @2101932
     /* 2101932 */ GIM_Reject,
     /* 2101933 */ // Label 27677: @2101933
     /* 2101933 */ GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2101987), // Rule ID 46992 //
     /* 2101938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2101944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101952 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2101952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2101955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2101959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2101964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2101966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2101969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2101974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2101976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2101979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2101986 */   // GIR_Coverage, 46992,
     /* 2101986 */   GIR_EraseRootFromParent_Done,
     /* 2101987 */ // Label 27718: @2101987
     /* 2101987 */ GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2102041), // Rule ID 46993 //
     /* 2101992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2101998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102006 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2102009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2102023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102040 */   // GIR_Coverage, 46993,
     /* 2102040 */   GIR_EraseRootFromParent_Done,
     /* 2102041 */ // Label 27719: @2102041
     /* 2102041 */ GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2102095), // Rule ID 47058 //
     /* 2102046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2102052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102060 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2102063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2102077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102094 */   // GIR_Coverage, 47058,
     /* 2102094 */   GIR_EraseRootFromParent_Done,
     /* 2102095 */ // Label 27720: @2102095
     /* 2102095 */ GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2102149), // Rule ID 47059 //
     /* 2102100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2102106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102114 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2102117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2102131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102148 */   // GIR_Coverage, 47059,
     /* 2102148 */   GIR_EraseRootFromParent_Done,
     /* 2102149 */ // Label 27721: @2102149
     /* 2102149 */ GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2102203), // Rule ID 47092 //
     /* 2102154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2102160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102168 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2102171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2102185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102202 */   // GIR_Coverage, 47092,
     /* 2102202 */   GIR_EraseRootFromParent_Done,
     /* 2102203 */ // Label 27722: @2102203
     /* 2102203 */ GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2102257), // Rule ID 47093 //
     /* 2102208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2102214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102222 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2102225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2102239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102256 */   // GIR_Coverage, 47093,
     /* 2102256 */   GIR_EraseRootFromParent_Done,
     /* 2102257 */ // Label 27723: @2102257
     /* 2102257 */ GIM_Reject,
     /* 2102258 */ // Label 27678: @2102258
     /* 2102258 */ GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2102361),
     /* 2102263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2102266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102274 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2102317), // Rule ID 46952 //
     /* 2102279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2102282 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2102285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2102299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102316 */     // GIR_Coverage, 46952,
     /* 2102316 */     GIR_EraseRootFromParent_Done,
     /* 2102317 */   // Label 27725: @2102317
     /* 2102317 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2102360), // Rule ID 46953 //
     /* 2102322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2102325 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2102328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2102342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102359 */     // GIR_Coverage, 46953,
     /* 2102359 */     GIR_EraseRootFromParent_Done,
     /* 2102360 */   // Label 27726: @2102360
     /* 2102360 */   GIM_Reject,
     /* 2102361 */ // Label 27724: @2102361
     /* 2102361 */ GIM_Reject,
     /* 2102362 */ // Label 27679: @2102362
     /* 2102362 */ GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2102416), // Rule ID 46976 //
     /* 2102367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2102370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2102373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102381 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2102384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2102398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102415 */   // GIR_Coverage, 46976,
     /* 2102415 */   GIR_EraseRootFromParent_Done,
     /* 2102416 */ // Label 27727: @2102416
     /* 2102416 */ GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2102470), // Rule ID 46977 //
     /* 2102421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2102424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2102427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102435 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2102438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2102452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102469 */   // GIR_Coverage, 46977,
     /* 2102469 */   GIR_EraseRootFromParent_Done,
     /* 2102470 */ // Label 27728: @2102470
     /* 2102470 */ GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2102524), // Rule ID 47042 //
     /* 2102475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2102478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2102481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102489 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2102492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2102506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102523 */   // GIR_Coverage, 47042,
     /* 2102523 */   GIR_EraseRootFromParent_Done,
     /* 2102524 */ // Label 27729: @2102524
     /* 2102524 */ GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2102578), // Rule ID 47043 //
     /* 2102529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2102532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2102535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102543 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2102546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2102560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102577 */   // GIR_Coverage, 47043,
     /* 2102577 */   GIR_EraseRootFromParent_Done,
     /* 2102578 */ // Label 27730: @2102578
     /* 2102578 */ GIM_Reject,
     /* 2102579 */ // Label 27680: @2102579
     /* 2102579 */ GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2102633), // Rule ID 46996 //
     /* 2102584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2102590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102598 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2102615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102632 */   // GIR_Coverage, 46996,
     /* 2102632 */   GIR_EraseRootFromParent_Done,
     /* 2102633 */ // Label 27731: @2102633
     /* 2102633 */ GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2102687), // Rule ID 46997 //
     /* 2102638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2102644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102652 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2102669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102686 */   // GIR_Coverage, 46997,
     /* 2102686 */   GIR_EraseRootFromParent_Done,
     /* 2102687 */ // Label 27732: @2102687
     /* 2102687 */ GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2102741), // Rule ID 47062 //
     /* 2102692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2102698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102706 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2102723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102740 */   // GIR_Coverage, 47062,
     /* 2102740 */   GIR_EraseRootFromParent_Done,
     /* 2102741 */ // Label 27733: @2102741
     /* 2102741 */ GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2102795), // Rule ID 47063 //
     /* 2102746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2102752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102760 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2102777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102794 */   // GIR_Coverage, 47063,
     /* 2102794 */   GIR_EraseRootFromParent_Done,
     /* 2102795 */ // Label 27734: @2102795
     /* 2102795 */ GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2102849), // Rule ID 47096 //
     /* 2102800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2102806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102814 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2102831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102848 */   // GIR_Coverage, 47096,
     /* 2102848 */   GIR_EraseRootFromParent_Done,
     /* 2102849 */ // Label 27735: @2102849
     /* 2102849 */ GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2102903), // Rule ID 47097 //
     /* 2102854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2102860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102868 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2102871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2102885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2102902 */   // GIR_Coverage, 47097,
     /* 2102902 */   GIR_EraseRootFromParent_Done,
     /* 2102903 */ // Label 27736: @2102903
     /* 2102903 */ GIM_Reject,
     /* 2102904 */ // Label 27681: @2102904
     /* 2102904 */ GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2103007),
     /* 2102909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2102912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102920 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2102963), // Rule ID 46956 //
     /* 2102925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2102928 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2102928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2102931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2102945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102962 */     // GIR_Coverage, 46956,
     /* 2102962 */     GIR_EraseRootFromParent_Done,
     /* 2102963 */   // Label 27738: @2102963
     /* 2102963 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2103006), // Rule ID 46957 //
     /* 2102968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2102971 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2102971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2102974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2102978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2102983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2102985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2102988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2102993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2102995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2102998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103005 */     // GIR_Coverage, 46957,
     /* 2103005 */     GIR_EraseRootFromParent_Done,
     /* 2103006 */   // Label 27739: @2103006
     /* 2103006 */   GIM_Reject,
     /* 2103007 */ // Label 27737: @2103007
     /* 2103007 */ GIM_Reject,
     /* 2103008 */ // Label 27682: @2103008
     /* 2103008 */ GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2103062), // Rule ID 46980 //
     /* 2103013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2103019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103027 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2103027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2103030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2103044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103061 */   // GIR_Coverage, 46980,
     /* 2103061 */   GIR_EraseRootFromParent_Done,
     /* 2103062 */ // Label 27740: @2103062
     /* 2103062 */ GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2103116), // Rule ID 46981 //
     /* 2103067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2103073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103081 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2103081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2103084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2103098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103103 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103115 */   // GIR_Coverage, 46981,
     /* 2103115 */   GIR_EraseRootFromParent_Done,
     /* 2103116 */ // Label 27741: @2103116
     /* 2103116 */ GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2103170), // Rule ID 47046 //
     /* 2103121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2103127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103135 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2103135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2103138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2103152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103169 */   // GIR_Coverage, 47046,
     /* 2103169 */   GIR_EraseRootFromParent_Done,
     /* 2103170 */ // Label 27742: @2103170
     /* 2103170 */ GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2103224), // Rule ID 47047 //
     /* 2103175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2103181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103189 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2103189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2103192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2103206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103223 */   // GIR_Coverage, 47047,
     /* 2103223 */   GIR_EraseRootFromParent_Done,
     /* 2103224 */ // Label 27743: @2103224
     /* 2103224 */ GIM_Reject,
     /* 2103225 */ // Label 27683: @2103225
     /* 2103225 */ GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2103328),
     /* 2103230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2103233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103241 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2103284), // Rule ID 46960 //
     /* 2103246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103249 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2103249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2103252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2103266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103283 */     // GIR_Coverage, 46960,
     /* 2103283 */     GIR_EraseRootFromParent_Done,
     /* 2103284 */   // Label 27745: @2103284
     /* 2103284 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2103327), // Rule ID 46961 //
     /* 2103289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103292 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2103292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2103295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2103309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103326 */     // GIR_Coverage, 46961,
     /* 2103326 */     GIR_EraseRootFromParent_Done,
     /* 2103327 */   // Label 27746: @2103327
     /* 2103327 */   GIM_Reject,
     /* 2103328 */ // Label 27744: @2103328
     /* 2103328 */ GIM_Reject,
     /* 2103329 */ // Label 27684: @2103329
     /* 2103329 */ GIM_Reject,
     /* 2103330 */ // Label 40: @2103330
     /* 2103330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 27764*/ GIMT_Encode4(2106804),
     /* 2103341 */ /*GILLT_s32*//*Label 27747*/ GIMT_Encode4(2103457),
     /* 2103345 */ /*GILLT_s64*//*Label 27748*/ GIMT_Encode4(2103631), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103357 */ /*GILLT_nxv1s16*//*Label 27749*/ GIMT_Encode4(2103795),
     /* 2103361 */ /*GILLT_nxv1s32*//*Label 27750*/ GIMT_Encode4(2103899),
     /* 2103365 */ /*GILLT_nxv1s64*//*Label 27751*/ GIMT_Encode4(2104116), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103377 */ /*GILLT_nxv2s16*//*Label 27752*/ GIMT_Encode4(2104441),
     /* 2103381 */ /*GILLT_nxv2s32*//*Label 27753*/ GIMT_Encode4(2104545),
     /* 2103385 */ /*GILLT_nxv2s64*//*Label 27754*/ GIMT_Encode4(2104762), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103397 */ /*GILLT_nxv4s16*//*Label 27755*/ GIMT_Encode4(2105087),
     /* 2103401 */ /*GILLT_nxv4s32*//*Label 27756*/ GIMT_Encode4(2105191),
     /* 2103405 */ /*GILLT_nxv4s64*//*Label 27757*/ GIMT_Encode4(2105408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103417 */ /*GILLT_nxv8s16*//*Label 27758*/ GIMT_Encode4(2105733),
     /* 2103421 */ /*GILLT_nxv8s32*//*Label 27759*/ GIMT_Encode4(2105837),
     /* 2103425 */ /*GILLT_nxv8s64*//*Label 27760*/ GIMT_Encode4(2106054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103437 */ /*GILLT_nxv16s16*//*Label 27761*/ GIMT_Encode4(2106379),
     /* 2103441 */ /*GILLT_nxv16s32*//*Label 27762*/ GIMT_Encode4(2106483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2103453 */ /*GILLT_nxv32s16*//*Label 27763*/ GIMT_Encode4(2106700),
     /* 2103457 */ // Label 27747: @2103457
     /* 2103457 */ GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2103630),
     /* 2103462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2103465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103473 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2103515), // Rule ID 63973 //
     /* 2103478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2103481 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2103481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2103484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2103488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2103497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2103500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2103505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2103513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103514 */     // GIR_Coverage, 63973,
     /* 2103514 */     GIR_EraseRootFromParent_Done,
     /* 2103515 */   // Label 27766: @2103515
     /* 2103515 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2103557), // Rule ID 63975 //
     /* 2103520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2103523 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2103523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2103526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2103530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2103539 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2103542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2103547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2103555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103556 */     // GIR_Coverage, 63975,
     /* 2103556 */     GIR_EraseRootFromParent_Done,
     /* 2103557 */   // Label 27767: @2103557
     /* 2103557 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2103599), // Rule ID 63976 //
     /* 2103562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2103565 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2103565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2103568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2103572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2103581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2103584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2103589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2103597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103598 */     // GIR_Coverage, 63976,
     /* 2103598 */     GIR_EraseRootFromParent_Done,
     /* 2103599 */   // Label 27768: @2103599
     /* 2103599 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2103614), // Rule ID 63978 //
     /* 2103604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2103607 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2103607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2103612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103613 */     // GIR_Coverage, 63978,
     /* 2103613 */     GIR_Done,
     /* 2103614 */   // Label 27769: @2103614
     /* 2103614 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2103629), // Rule ID 63979 //
     /* 2103619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2103622 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2103622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2103627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103628 */     // GIR_Coverage, 63979,
     /* 2103628 */     GIR_Done,
     /* 2103629 */   // Label 27770: @2103629
     /* 2103629 */   GIM_Reject,
     /* 2103630 */ // Label 27765: @2103630
     /* 2103630 */ GIM_Reject,
     /* 2103631 */ // Label 27748: @2103631
     /* 2103631 */ GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2103662), // Rule ID 63963 //
     /* 2103636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2103639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2103642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103650 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2103650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2103653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2103657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2103660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103661 */   // GIR_Coverage, 63963,
     /* 2103661 */   GIR_EraseRootFromParent_Done,
     /* 2103662 */ // Label 27771: @2103662
     /* 2103662 */ GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2103715), // Rule ID 63972 //
     /* 2103667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2103670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2103673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103681 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2103681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2103684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2103688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103693 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2103697 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2103700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2103705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2103713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103714 */   // GIR_Coverage, 63972,
     /* 2103714 */   GIR_EraseRootFromParent_Done,
     /* 2103715 */ // Label 27772: @2103715
     /* 2103715 */ GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2103768), // Rule ID 63974 //
     /* 2103720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2103723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2103726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103734 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2103734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2103737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2103741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103746 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2103750 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2103753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2103758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2103766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103767 */   // GIR_Coverage, 63974,
     /* 2103767 */   GIR_EraseRootFromParent_Done,
     /* 2103768 */ // Label 27773: @2103768
     /* 2103768 */ GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2103794), // Rule ID 63980 //
     /* 2103773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2103776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2103779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103787 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2103787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2103792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103793 */   // GIR_Coverage, 63980,
     /* 2103793 */   GIR_Done,
     /* 2103794 */ // Label 27774: @2103794
     /* 2103794 */ GIM_Reject,
     /* 2103795 */ // Label 27749: @2103795
     /* 2103795 */ GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2103898),
     /* 2103800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2103803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103811 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2103854), // Rule ID 46998 //
     /* 2103816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103819 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2103819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2103822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2103836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103853 */     // GIR_Coverage, 46998,
     /* 2103853 */     GIR_EraseRootFromParent_Done,
     /* 2103854 */   // Label 27776: @2103854
     /* 2103854 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2103897), // Rule ID 46999 //
     /* 2103859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103862 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2103862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2103865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2103879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103896 */     // GIR_Coverage, 46999,
     /* 2103896 */     GIR_EraseRootFromParent_Done,
     /* 2103897 */   // Label 27777: @2103897
     /* 2103897 */   GIM_Reject,
     /* 2103898 */ // Label 27775: @2103898
     /* 2103898 */ GIM_Reject,
     /* 2103899 */ // Label 27750: @2103899
     /* 2103899 */ GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2103953), // Rule ID 47010 //
     /* 2103904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2103910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103918 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2103918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2103921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2103935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103940 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2103952 */   // GIR_Coverage, 47010,
     /* 2103952 */   GIR_EraseRootFromParent_Done,
     /* 2103953 */ // Label 27778: @2103953
     /* 2103953 */ GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2104007), // Rule ID 47011 //
     /* 2103958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2103964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103972 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2103972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2103975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2103979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2103984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2103986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2103989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2103994 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2103996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2103999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104006 */   // GIR_Coverage, 47011,
     /* 2104006 */   GIR_EraseRootFromParent_Done,
     /* 2104007 */ // Label 27779: @2104007
     /* 2104007 */ GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2104061), // Rule ID 47064 //
     /* 2104012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2104018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104026 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2104029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2104043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104060 */   // GIR_Coverage, 47064,
     /* 2104060 */   GIR_EraseRootFromParent_Done,
     /* 2104061 */ // Label 27780: @2104061
     /* 2104061 */ GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2104115), // Rule ID 47065 //
     /* 2104066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2104072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104080 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2104083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2104097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104102 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104114 */   // GIR_Coverage, 47065,
     /* 2104114 */   GIR_EraseRootFromParent_Done,
     /* 2104115 */ // Label 27781: @2104115
     /* 2104115 */ GIM_Reject,
     /* 2104116 */ // Label 27751: @2104116
     /* 2104116 */ GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2104170), // Rule ID 47020 //
     /* 2104121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2104127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104135 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2104152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104169 */   // GIR_Coverage, 47020,
     /* 2104169 */   GIR_EraseRootFromParent_Done,
     /* 2104170 */ // Label 27782: @2104170
     /* 2104170 */ GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2104224), // Rule ID 47021 //
     /* 2104175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2104178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2104181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104189 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2104206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104223 */   // GIR_Coverage, 47021,
     /* 2104223 */   GIR_EraseRootFromParent_Done,
     /* 2104224 */ // Label 27783: @2104224
     /* 2104224 */ GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2104278), // Rule ID 47074 //
     /* 2104229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2104235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104243 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2104260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104277 */   // GIR_Coverage, 47074,
     /* 2104277 */   GIR_EraseRootFromParent_Done,
     /* 2104278 */ // Label 27784: @2104278
     /* 2104278 */ GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2104332), // Rule ID 47075 //
     /* 2104283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2104286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2104289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104297 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2104314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104319 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104331 */   // GIR_Coverage, 47075,
     /* 2104331 */   GIR_EraseRootFromParent_Done,
     /* 2104332 */ // Label 27785: @2104332
     /* 2104332 */ GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2104386), // Rule ID 47098 //
     /* 2104337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2104343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104351 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2104368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104373 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104385 */   // GIR_Coverage, 47098,
     /* 2104385 */   GIR_EraseRootFromParent_Done,
     /* 2104386 */ // Label 27786: @2104386
     /* 2104386 */ GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2104440), // Rule ID 47099 //
     /* 2104391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2104394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2104397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104405 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2104408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2104422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104439 */   // GIR_Coverage, 47099,
     /* 2104439 */   GIR_EraseRootFromParent_Done,
     /* 2104440 */ // Label 27787: @2104440
     /* 2104440 */ GIM_Reject,
     /* 2104441 */ // Label 27752: @2104441
     /* 2104441 */ GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2104544),
     /* 2104446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2104449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104457 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2104500), // Rule ID 47000 //
     /* 2104462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104465 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2104468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2104482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104499 */     // GIR_Coverage, 47000,
     /* 2104499 */     GIR_EraseRootFromParent_Done,
     /* 2104500 */   // Label 27789: @2104500
     /* 2104500 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2104543), // Rule ID 47001 //
     /* 2104505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104508 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2104511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2104525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104542 */     // GIR_Coverage, 47001,
     /* 2104542 */     GIR_EraseRootFromParent_Done,
     /* 2104543 */   // Label 27790: @2104543
     /* 2104543 */   GIM_Reject,
     /* 2104544 */ // Label 27788: @2104544
     /* 2104544 */ GIM_Reject,
     /* 2104545 */ // Label 27753: @2104545
     /* 2104545 */ GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2104599), // Rule ID 47012 //
     /* 2104550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2104556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104564 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2104567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2104581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104586 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104598 */   // GIR_Coverage, 47012,
     /* 2104598 */   GIR_EraseRootFromParent_Done,
     /* 2104599 */ // Label 27791: @2104599
     /* 2104599 */ GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2104653), // Rule ID 47013 //
     /* 2104604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2104610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104618 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2104621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2104635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104640 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104652 */   // GIR_Coverage, 47013,
     /* 2104652 */   GIR_EraseRootFromParent_Done,
     /* 2104653 */ // Label 27792: @2104653
     /* 2104653 */ GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2104707), // Rule ID 47066 //
     /* 2104658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2104664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104672 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2104675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2104689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104694 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104706 */   // GIR_Coverage, 47066,
     /* 2104706 */   GIR_EraseRootFromParent_Done,
     /* 2104707 */ // Label 27793: @2104707
     /* 2104707 */ GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2104761), // Rule ID 47067 //
     /* 2104712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2104718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104726 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2104729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2104743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104748 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104760 */   // GIR_Coverage, 47067,
     /* 2104760 */   GIR_EraseRootFromParent_Done,
     /* 2104761 */ // Label 27794: @2104761
     /* 2104761 */ GIM_Reject,
     /* 2104762 */ // Label 27754: @2104762
     /* 2104762 */ GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2104816), // Rule ID 47022 //
     /* 2104767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2104773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104781 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2104784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2104798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104815 */   // GIR_Coverage, 47022,
     /* 2104815 */   GIR_EraseRootFromParent_Done,
     /* 2104816 */ // Label 27795: @2104816
     /* 2104816 */ GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2104870), // Rule ID 47023 //
     /* 2104821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2104824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2104827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104835 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2104838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2104852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104869 */   // GIR_Coverage, 47023,
     /* 2104869 */   GIR_EraseRootFromParent_Done,
     /* 2104870 */ // Label 27796: @2104870
     /* 2104870 */ GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2104924), // Rule ID 47076 //
     /* 2104875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2104881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104889 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2104892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2104906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104923 */   // GIR_Coverage, 47076,
     /* 2104923 */   GIR_EraseRootFromParent_Done,
     /* 2104924 */ // Label 27797: @2104924
     /* 2104924 */ GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2104978), // Rule ID 47077 //
     /* 2104929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2104932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2104935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104943 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2104943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2104946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2104950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2104955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2104957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2104960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2104965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2104967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2104970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2104977 */   // GIR_Coverage, 47077,
     /* 2104977 */   GIR_EraseRootFromParent_Done,
     /* 2104978 */ // Label 27798: @2104978
     /* 2104978 */ GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2105032), // Rule ID 47100 //
     /* 2104983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2104989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104997 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2104997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2105000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2105014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105031 */   // GIR_Coverage, 47100,
     /* 2105031 */   GIR_EraseRootFromParent_Done,
     /* 2105032 */ // Label 27799: @2105032
     /* 2105032 */ GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2105086), // Rule ID 47101 //
     /* 2105037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2105043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105051 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2105054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2105068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105085 */   // GIR_Coverage, 47101,
     /* 2105085 */   GIR_EraseRootFromParent_Done,
     /* 2105086 */ // Label 27800: @2105086
     /* 2105086 */ GIM_Reject,
     /* 2105087 */ // Label 27755: @2105087
     /* 2105087 */ GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2105190),
     /* 2105092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2105095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105103 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2105146), // Rule ID 47002 //
     /* 2105108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105111 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2105114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2105128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105145 */     // GIR_Coverage, 47002,
     /* 2105145 */     GIR_EraseRootFromParent_Done,
     /* 2105146 */   // Label 27802: @2105146
     /* 2105146 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2105189), // Rule ID 47003 //
     /* 2105151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2105154 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2105157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2105171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105188 */     // GIR_Coverage, 47003,
     /* 2105188 */     GIR_EraseRootFromParent_Done,
     /* 2105189 */   // Label 27803: @2105189
     /* 2105189 */   GIM_Reject,
     /* 2105190 */ // Label 27801: @2105190
     /* 2105190 */ GIM_Reject,
     /* 2105191 */ // Label 27756: @2105191
     /* 2105191 */ GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2105245), // Rule ID 47014 //
     /* 2105196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2105202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105210 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2105213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2105227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105232 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105244 */   // GIR_Coverage, 47014,
     /* 2105244 */   GIR_EraseRootFromParent_Done,
     /* 2105245 */ // Label 27804: @2105245
     /* 2105245 */ GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2105299), // Rule ID 47015 //
     /* 2105250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2105253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2105256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105264 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2105267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2105281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105298 */   // GIR_Coverage, 47015,
     /* 2105298 */   GIR_EraseRootFromParent_Done,
     /* 2105299 */ // Label 27805: @2105299
     /* 2105299 */ GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2105353), // Rule ID 47068 //
     /* 2105304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2105310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105318 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2105321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2105335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105352 */   // GIR_Coverage, 47068,
     /* 2105352 */   GIR_EraseRootFromParent_Done,
     /* 2105353 */ // Label 27806: @2105353
     /* 2105353 */ GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2105407), // Rule ID 47069 //
     /* 2105358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2105361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2105364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105372 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2105375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2105389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105394 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105406 */   // GIR_Coverage, 47069,
     /* 2105406 */   GIR_EraseRootFromParent_Done,
     /* 2105407 */ // Label 27807: @2105407
     /* 2105407 */ GIM_Reject,
     /* 2105408 */ // Label 27757: @2105408
     /* 2105408 */ GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2105462), // Rule ID 47024 //
     /* 2105413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2105419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105427 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2105444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105461 */   // GIR_Coverage, 47024,
     /* 2105461 */   GIR_EraseRootFromParent_Done,
     /* 2105462 */ // Label 27808: @2105462
     /* 2105462 */ GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2105516), // Rule ID 47025 //
     /* 2105467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2105473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105481 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2105498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105515 */   // GIR_Coverage, 47025,
     /* 2105515 */   GIR_EraseRootFromParent_Done,
     /* 2105516 */ // Label 27809: @2105516
     /* 2105516 */ GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2105570), // Rule ID 47078 //
     /* 2105521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2105527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105535 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2105552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105557 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105569 */   // GIR_Coverage, 47078,
     /* 2105569 */   GIR_EraseRootFromParent_Done,
     /* 2105570 */ // Label 27810: @2105570
     /* 2105570 */ GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2105624), // Rule ID 47079 //
     /* 2105575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2105581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105589 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2105606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105623 */   // GIR_Coverage, 47079,
     /* 2105623 */   GIR_EraseRootFromParent_Done,
     /* 2105624 */ // Label 27811: @2105624
     /* 2105624 */ GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2105678), // Rule ID 47102 //
     /* 2105629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2105635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105643 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2105660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105665 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105677 */   // GIR_Coverage, 47102,
     /* 2105677 */   GIR_EraseRootFromParent_Done,
     /* 2105678 */ // Label 27812: @2105678
     /* 2105678 */ GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2105732), // Rule ID 47103 //
     /* 2105683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2105689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105697 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2105700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2105714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105731 */   // GIR_Coverage, 47103,
     /* 2105731 */   GIR_EraseRootFromParent_Done,
     /* 2105732 */ // Label 27813: @2105732
     /* 2105732 */ GIM_Reject,
     /* 2105733 */ // Label 27758: @2105733
     /* 2105733 */ GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2105836),
     /* 2105738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2105741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105749 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2105792), // Rule ID 47004 //
     /* 2105754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105757 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2105760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2105774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105791 */     // GIR_Coverage, 47004,
     /* 2105791 */     GIR_EraseRootFromParent_Done,
     /* 2105792 */   // Label 27815: @2105792
     /* 2105792 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2105835), // Rule ID 47005 //
     /* 2105797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2105800 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2105803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2105817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105834 */     // GIR_Coverage, 47005,
     /* 2105834 */     GIR_EraseRootFromParent_Done,
     /* 2105835 */   // Label 27816: @2105835
     /* 2105835 */   GIM_Reject,
     /* 2105836 */ // Label 27814: @2105836
     /* 2105836 */ GIM_Reject,
     /* 2105837 */ // Label 27759: @2105837
     /* 2105837 */ GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2105891), // Rule ID 47016 //
     /* 2105842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2105848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105856 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2105859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2105873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105890 */   // GIR_Coverage, 47016,
     /* 2105890 */   GIR_EraseRootFromParent_Done,
     /* 2105891 */ // Label 27817: @2105891
     /* 2105891 */ GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2105945), // Rule ID 47017 //
     /* 2105896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2105899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2105902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105910 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2105910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2105913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2105927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105932 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105944 */   // GIR_Coverage, 47017,
     /* 2105944 */   GIR_EraseRootFromParent_Done,
     /* 2105945 */ // Label 27818: @2105945
     /* 2105945 */ GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2105999), // Rule ID 47070 //
     /* 2105950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2105953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2105956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105964 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2105964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2105967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2105971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2105976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2105978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2105981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2105986 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2105988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2105991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2105997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2105998 */   // GIR_Coverage, 47070,
     /* 2105998 */   GIR_EraseRootFromParent_Done,
     /* 2105999 */ // Label 27819: @2105999
     /* 2105999 */ GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2106053), // Rule ID 47071 //
     /* 2106004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2106007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2106010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106018 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2106021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2106035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106052 */   // GIR_Coverage, 47071,
     /* 2106052 */   GIR_EraseRootFromParent_Done,
     /* 2106053 */ // Label 27820: @2106053
     /* 2106053 */ GIM_Reject,
     /* 2106054 */ // Label 27760: @2106054
     /* 2106054 */ GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2106108), // Rule ID 47026 //
     /* 2106059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2106062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2106065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106073 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106107 */   // GIR_Coverage, 47026,
     /* 2106107 */   GIR_EraseRootFromParent_Done,
     /* 2106108 */ // Label 27821: @2106108
     /* 2106108 */ GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2106162), // Rule ID 47027 //
     /* 2106113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2106116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2106119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106127 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106161 */   // GIR_Coverage, 47027,
     /* 2106161 */   GIR_EraseRootFromParent_Done,
     /* 2106162 */ // Label 27822: @2106162
     /* 2106162 */ GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2106216), // Rule ID 47080 //
     /* 2106167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2106170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2106173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106181 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2106198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106203 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106215 */   // GIR_Coverage, 47080,
     /* 2106215 */   GIR_EraseRootFromParent_Done,
     /* 2106216 */ // Label 27823: @2106216
     /* 2106216 */ GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2106270), // Rule ID 47081 //
     /* 2106221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2106224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2106227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106235 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2106252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106257 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106269 */   // GIR_Coverage, 47081,
     /* 2106269 */   GIR_EraseRootFromParent_Done,
     /* 2106270 */ // Label 27824: @2106270
     /* 2106270 */ GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2106324), // Rule ID 47104 //
     /* 2106275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2106278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2106281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106289 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2106306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106311 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106323 */   // GIR_Coverage, 47104,
     /* 2106323 */   GIR_EraseRootFromParent_Done,
     /* 2106324 */ // Label 27825: @2106324
     /* 2106324 */ GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2106378), // Rule ID 47105 //
     /* 2106329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2106332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2106335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106343 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2106346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2106360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106365 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106377 */   // GIR_Coverage, 47105,
     /* 2106377 */   GIR_EraseRootFromParent_Done,
     /* 2106378 */ // Label 27826: @2106378
     /* 2106378 */ GIM_Reject,
     /* 2106379 */ // Label 27761: @2106379
     /* 2106379 */ GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2106482),
     /* 2106384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2106387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106395 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2106438), // Rule ID 47006 //
     /* 2106400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2106403 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2106406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2106420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106437 */     // GIR_Coverage, 47006,
     /* 2106437 */     GIR_EraseRootFromParent_Done,
     /* 2106438 */   // Label 27828: @2106438
     /* 2106438 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2106481), // Rule ID 47007 //
     /* 2106443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2106446 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2106449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2106463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106480 */     // GIR_Coverage, 47007,
     /* 2106480 */     GIR_EraseRootFromParent_Done,
     /* 2106481 */   // Label 27829: @2106481
     /* 2106481 */   GIM_Reject,
     /* 2106482 */ // Label 27827: @2106482
     /* 2106482 */ GIM_Reject,
     /* 2106483 */ // Label 27762: @2106483
     /* 2106483 */ GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2106537), // Rule ID 47018 //
     /* 2106488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2106491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2106494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106502 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2106505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106524 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106536 */   // GIR_Coverage, 47018,
     /* 2106536 */   GIR_EraseRootFromParent_Done,
     /* 2106537 */ // Label 27830: @2106537
     /* 2106537 */ GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2106591), // Rule ID 47019 //
     /* 2106542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2106545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2106548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106556 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2106559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106578 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106590 */   // GIR_Coverage, 47019,
     /* 2106590 */   GIR_EraseRootFromParent_Done,
     /* 2106591 */ // Label 27831: @2106591
     /* 2106591 */ GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2106645), // Rule ID 47072 //
     /* 2106596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2106599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2106602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106610 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2106613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2106627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106632 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106644 */   // GIR_Coverage, 47072,
     /* 2106644 */   GIR_EraseRootFromParent_Done,
     /* 2106645 */ // Label 27832: @2106645
     /* 2106645 */ GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2106699), // Rule ID 47073 //
     /* 2106650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2106653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2106656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106664 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2106667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2106681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2106698 */   // GIR_Coverage, 47073,
     /* 2106698 */   GIR_EraseRootFromParent_Done,
     /* 2106699 */ // Label 27833: @2106699
     /* 2106699 */ GIM_Reject,
     /* 2106700 */ // Label 27763: @2106700
     /* 2106700 */ GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2106803),
     /* 2106705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2106708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106716 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2106759), // Rule ID 47008 //
     /* 2106721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2106724 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2106724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2106727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106758 */     // GIR_Coverage, 47008,
     /* 2106758 */     GIR_EraseRootFromParent_Done,
     /* 2106759 */   // Label 27835: @2106759
     /* 2106759 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2106802), // Rule ID 47009 //
     /* 2106764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2106767 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2106767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2106770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2106774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2106779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2106781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2106784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2106789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2106791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2106794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2106800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106801 */     // GIR_Coverage, 47009,
     /* 2106801 */     GIR_EraseRootFromParent_Done,
     /* 2106802 */   // Label 27836: @2106802
     /* 2106802 */   GIM_Reject,
     /* 2106803 */ // Label 27834: @2106803
     /* 2106803 */ GIM_Reject,
     /* 2106804 */ // Label 27764: @2106804
     /* 2106804 */ GIM_Reject,
     /* 2106805 */ // Label 41: @2106805
     /* 2106805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 27839*/ GIMT_Encode4(2107353),
     /* 2106816 */ /*GILLT_s32*//*Label 27837*/ GIMT_Encode4(2106824),
     /* 2106820 */ /*GILLT_s64*//*Label 27838*/ GIMT_Encode4(2107056),
     /* 2106824 */ // Label 27837: @2106824
     /* 2106824 */ GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2107055),
     /* 2106829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2106832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2106836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2106840 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2106868), // Rule ID 63783 //
     /* 2106845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2106848 */     // MIs[0] Operand 2
     /* 2106848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2106859 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2106859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2106862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2106866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106867 */     // GIR_Coverage, 63783,
     /* 2106867 */     GIR_EraseRootFromParent_Done,
     /* 2106868 */   // Label 27841: @2106868
     /* 2106868 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2106896), // Rule ID 63785 //
     /* 2106873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2106876 */     // MIs[0] Operand 2
     /* 2106876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2106887 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2106887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2106890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2106894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106895 */     // GIR_Coverage, 63785,
     /* 2106895 */     GIR_EraseRootFromParent_Done,
     /* 2106896 */   // Label 27842: @2106896
     /* 2106896 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2106924), // Rule ID 2383 //
     /* 2106901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2106904 */     // MIs[0] Operand 2
     /* 2106904 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2106915 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2106915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2106918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2106922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106923 */     // GIR_Coverage, 2383,
     /* 2106923 */     GIR_EraseRootFromParent_Done,
     /* 2106924 */   // Label 27843: @2106924
     /* 2106924 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2106952), // Rule ID 2385 //
     /* 2106929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2106932 */     // MIs[0] Operand 2
     /* 2106932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2106943 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2106943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2106946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2106950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106951 */     // GIR_Coverage, 2385,
     /* 2106951 */     GIR_EraseRootFromParent_Done,
     /* 2106952 */   // Label 27844: @2106952
     /* 2106952 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2106986), // Rule ID 61866 //
     /* 2106957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2106960 */     // MIs[0] Operand 2
     /* 2106960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2106971 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2106971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2106974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2106978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2106981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2106984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106985 */     // GIR_Coverage, 61866,
     /* 2106985 */     GIR_EraseRootFromParent_Done,
     /* 2106986 */   // Label 27845: @2106986
     /* 2106986 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2107020), // Rule ID 61868 //
     /* 2106991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2106994 */     // MIs[0] Operand 2
     /* 2106994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2107005 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2107005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2107015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107019 */     // GIR_Coverage, 61868,
     /* 2107019 */     GIR_EraseRootFromParent_Done,
     /* 2107020 */   // Label 27846: @2107020
     /* 2107020 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2107054), // Rule ID 61870 //
     /* 2107025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2107028 */     // MIs[0] Operand 2
     /* 2107028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2107039 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2107039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107053 */     // GIR_Coverage, 61870,
     /* 2107053 */     GIR_EraseRootFromParent_Done,
     /* 2107054 */   // Label 27847: @2107054
     /* 2107054 */   GIM_Reject,
     /* 2107055 */ // Label 27840: @2107055
     /* 2107055 */ GIM_Reject,
     /* 2107056 */ // Label 27838: @2107056
     /* 2107056 */ GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2107352),
     /* 2107061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2107064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107072 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2107100), // Rule ID 63782 //
     /* 2107077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2107080 */     // MIs[0] Operand 2
     /* 2107080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2107091 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2107091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2107094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107099 */     // GIR_Coverage, 63782,
     /* 2107099 */     GIR_EraseRootFromParent_Done,
     /* 2107100 */   // Label 27849: @2107100
     /* 2107100 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2107128), // Rule ID 63784 //
     /* 2107105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2107108 */     // MIs[0] Operand 2
     /* 2107108 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2107119 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2107119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2107122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107127 */     // GIR_Coverage, 63784,
     /* 2107127 */     GIR_EraseRootFromParent_Done,
     /* 2107128 */   // Label 27850: @2107128
     /* 2107128 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2107159), // Rule ID 256 //
     /* 2107133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2107136 */     // MIs[0] Operand 2
     /* 2107136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2107147 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2107147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2107150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107158 */     // GIR_Coverage, 256,
     /* 2107158 */     GIR_EraseRootFromParent_Done,
     /* 2107159 */   // Label 27851: @2107159
     /* 2107159 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2107187), // Rule ID 2382 //
     /* 2107164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2107167 */     // MIs[0] Operand 2
     /* 2107167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2107178 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2107178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2107181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107186 */     // GIR_Coverage, 2382,
     /* 2107186 */     GIR_EraseRootFromParent_Done,
     /* 2107187 */   // Label 27852: @2107187
     /* 2107187 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2107215), // Rule ID 2384 //
     /* 2107192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2107195 */     // MIs[0] Operand 2
     /* 2107195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2107206 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2107206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2107209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107214 */     // GIR_Coverage, 2384,
     /* 2107214 */     GIR_EraseRootFromParent_Done,
     /* 2107215 */   // Label 27853: @2107215
     /* 2107215 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2107249), // Rule ID 61864 //
     /* 2107220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2107223 */     // MIs[0] Operand 2
     /* 2107223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2107234 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 31:{ *:[i64] }, 0:{ *:[i64] })
     /* 2107234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 2107244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107248 */     // GIR_Coverage, 61864,
     /* 2107248 */     GIR_EraseRootFromParent_Done,
     /* 2107249 */   // Label 27854: @2107249
     /* 2107249 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2107283), // Rule ID 61865 //
     /* 2107254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2107257 */     // MIs[0] Operand 2
     /* 2107257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2107268 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2107268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2107278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107282 */     // GIR_Coverage, 61865,
     /* 2107282 */     GIR_EraseRootFromParent_Done,
     /* 2107283 */   // Label 27855: @2107283
     /* 2107283 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2107317), // Rule ID 61867 //
     /* 2107288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2107291 */     // MIs[0] Operand 2
     /* 2107291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2107302 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2107302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2107312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107316 */     // GIR_Coverage, 61867,
     /* 2107316 */     GIR_EraseRootFromParent_Done,
     /* 2107317 */   // Label 27856: @2107317
     /* 2107317 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2107351), // Rule ID 61869 //
     /* 2107322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2107325 */     // MIs[0] Operand 2
     /* 2107325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2107336 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2107336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2107339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2107343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2107349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107350 */     // GIR_Coverage, 61869,
     /* 2107350 */     GIR_EraseRootFromParent_Done,
     /* 2107351 */   // Label 27857: @2107351
     /* 2107351 */   GIM_Reject,
     /* 2107352 */ // Label 27848: @2107352
     /* 2107352 */ GIM_Reject,
     /* 2107353 */ // Label 27839: @2107353
     /* 2107353 */ GIM_Reject,
     /* 2107354 */ // Label 42: @2107354
     /* 2107354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 27875*/ GIMT_Encode4(2111040),
     /* 2107365 */ /*GILLT_s32*//*Label 27858*/ GIMT_Encode4(2107481),
     /* 2107369 */ /*GILLT_s64*//*Label 27859*/ GIMT_Encode4(2107777), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107381 */ /*GILLT_nxv1s16*//*Label 27860*/ GIMT_Encode4(2108031),
     /* 2107385 */ /*GILLT_nxv1s32*//*Label 27861*/ GIMT_Encode4(2108135),
     /* 2107389 */ /*GILLT_nxv1s64*//*Label 27862*/ GIMT_Encode4(2108352), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107401 */ /*GILLT_nxv2s16*//*Label 27863*/ GIMT_Encode4(2108677),
     /* 2107405 */ /*GILLT_nxv2s32*//*Label 27864*/ GIMT_Encode4(2108781),
     /* 2107409 */ /*GILLT_nxv2s64*//*Label 27865*/ GIMT_Encode4(2108998), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107421 */ /*GILLT_nxv4s16*//*Label 27866*/ GIMT_Encode4(2109323),
     /* 2107425 */ /*GILLT_nxv4s32*//*Label 27867*/ GIMT_Encode4(2109427),
     /* 2107429 */ /*GILLT_nxv4s64*//*Label 27868*/ GIMT_Encode4(2109644), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107441 */ /*GILLT_nxv8s16*//*Label 27869*/ GIMT_Encode4(2109969),
     /* 2107445 */ /*GILLT_nxv8s32*//*Label 27870*/ GIMT_Encode4(2110073),
     /* 2107449 */ /*GILLT_nxv8s64*//*Label 27871*/ GIMT_Encode4(2110290), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107461 */ /*GILLT_nxv16s16*//*Label 27872*/ GIMT_Encode4(2110615),
     /* 2107465 */ /*GILLT_nxv16s32*//*Label 27873*/ GIMT_Encode4(2110719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2107477 */ /*GILLT_nxv32s16*//*Label 27874*/ GIMT_Encode4(2110936),
     /* 2107481 */ // Label 27858: @2107481
     /* 2107481 */ GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2107776),
     /* 2107486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2107489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107497 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2107539), // Rule ID 63968 //
     /* 2107502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2107505 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2107505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2107508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107517 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107521 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2107524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2107537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107538 */     // GIR_Coverage, 63968,
     /* 2107538 */     GIR_EraseRootFromParent_Done,
     /* 2107539 */   // Label 27877: @2107539
     /* 2107539 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2107581), // Rule ID 63970 //
     /* 2107544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2107547 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2107547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2107550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2107566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2107579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107580 */     // GIR_Coverage, 63970,
     /* 2107580 */     GIR_EraseRootFromParent_Done,
     /* 2107581 */   // Label 27878: @2107581
     /* 2107581 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2107623), // Rule ID 63971 //
     /* 2107586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2107589 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2107589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2107592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107605 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2107608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2107621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107622 */     // GIR_Coverage, 63971,
     /* 2107622 */     GIR_EraseRootFromParent_Done,
     /* 2107623 */   // Label 27879: @2107623
     /* 2107623 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2107638), // Rule ID 63981 //
     /* 2107628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2107631 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2107631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2107636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107637 */     // GIR_Coverage, 63981,
     /* 2107637 */     GIR_Done,
     /* 2107638 */   // Label 27880: @2107638
     /* 2107638 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2107653), // Rule ID 63982 //
     /* 2107643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2107646 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2107646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2107651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107652 */     // GIR_Coverage, 63982,
     /* 2107652 */     GIR_Done,
     /* 2107653 */   // Label 27881: @2107653
     /* 2107653 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2107668), // Rule ID 63984 //
     /* 2107658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2107661 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2107661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2107666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107667 */     // GIR_Coverage, 63984,
     /* 2107667 */     GIR_Done,
     /* 2107668 */   // Label 27882: @2107668
     /* 2107668 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2107683), // Rule ID 63985 //
     /* 2107673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2107676 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2107676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2107681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107682 */     // GIR_Coverage, 63985,
     /* 2107682 */     GIR_Done,
     /* 2107683 */   // Label 27883: @2107683
     /* 2107683 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2107706), // Rule ID 63986 //
     /* 2107688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2107691 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2107691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2107694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2107698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2107704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107705 */     // GIR_Coverage, 63986,
     /* 2107705 */     GIR_EraseRootFromParent_Done,
     /* 2107706 */   // Label 27884: @2107706
     /* 2107706 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2107729), // Rule ID 63987 //
     /* 2107711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2107714 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2107714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2107717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2107721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2107727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107728 */     // GIR_Coverage, 63987,
     /* 2107728 */     GIR_EraseRootFromParent_Done,
     /* 2107729 */   // Label 27885: @2107729
     /* 2107729 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2107752), // Rule ID 63989 //
     /* 2107734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2107737 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2107737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2107740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2107744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2107750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107751 */     // GIR_Coverage, 63989,
     /* 2107751 */     GIR_EraseRootFromParent_Done,
     /* 2107752 */   // Label 27886: @2107752
     /* 2107752 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2107775), // Rule ID 63990 //
     /* 2107757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2107760 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2107760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2107763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2107767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2107773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107774 */     // GIR_Coverage, 63990,
     /* 2107774 */     GIR_EraseRootFromParent_Done,
     /* 2107775 */   // Label 27887: @2107775
     /* 2107775 */   GIM_Reject,
     /* 2107776 */ // Label 27876: @2107776
     /* 2107776 */ GIM_Reject,
     /* 2107777 */ // Label 27859: @2107777
     /* 2107777 */ GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2107830), // Rule ID 63966 //
     /* 2107782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2107785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2107788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107796 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2107796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2107799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107808 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107812 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2107815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2107828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107829 */   // GIR_Coverage, 63966,
     /* 2107829 */   GIR_EraseRootFromParent_Done,
     /* 2107830 */ // Label 27888: @2107830
     /* 2107830 */ GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2107883), // Rule ID 63967 //
     /* 2107835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2107838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2107841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107849 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2107849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2107852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107865 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2107868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2107881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107882 */   // GIR_Coverage, 63967,
     /* 2107882 */   GIR_EraseRootFromParent_Done,
     /* 2107883 */ // Label 27889: @2107883
     /* 2107883 */ GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2107936), // Rule ID 63969 //
     /* 2107888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2107891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2107894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107902 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2107902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2107905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2107909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2107914 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2107918 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2107921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2107923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2107926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2107931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2107934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107935 */   // GIR_Coverage, 63969,
     /* 2107935 */   GIR_EraseRootFromParent_Done,
     /* 2107936 */ // Label 27890: @2107936
     /* 2107936 */ GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2107970), // Rule ID 63977 //
     /* 2107941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2107944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2107947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107955 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2107955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2107958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2107962 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2107968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107969 */   // GIR_Coverage, 63977,
     /* 2107969 */   GIR_EraseRootFromParent_Done,
     /* 2107970 */ // Label 27891: @2107970
     /* 2107970 */ GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2107996), // Rule ID 63983 //
     /* 2107975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2107978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2107981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2107989 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2107989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2107994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107995 */   // GIR_Coverage, 63983,
     /* 2107995 */   GIR_Done,
     /* 2107996 */ // Label 27892: @2107996
     /* 2107996 */ GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2108030), // Rule ID 63988 //
     /* 2108001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2108004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2108007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2108011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2108015 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2108015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2108018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2108022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2108028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108029 */   // GIR_Coverage, 63988,
     /* 2108029 */   GIR_EraseRootFromParent_Done,
     /* 2108030 */ // Label 27893: @2108030
     /* 2108030 */ GIM_Reject,
     /* 2108031 */ // Label 27860: @2108031
     /* 2108031 */ GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2108134),
     /* 2108036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2108039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108047 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2108090), // Rule ID 45478 //
     /* 2108052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108055 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2108058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2108072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108089 */     // GIR_Coverage, 45478,
     /* 2108089 */     GIR_EraseRootFromParent_Done,
     /* 2108090 */   // Label 27895: @2108090
     /* 2108090 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2108133), // Rule ID 45479 //
     /* 2108095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108098 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2108101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2108115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108132 */     // GIR_Coverage, 45479,
     /* 2108132 */     GIR_EraseRootFromParent_Done,
     /* 2108133 */   // Label 27896: @2108133
     /* 2108133 */   GIM_Reject,
     /* 2108134 */ // Label 27894: @2108134
     /* 2108134 */ GIM_Reject,
     /* 2108135 */ // Label 27861: @2108135
     /* 2108135 */ GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2108189), // Rule ID 46962 //
     /* 2108140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2108146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108154 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2108157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2108171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108176 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108188 */   // GIR_Coverage, 46962,
     /* 2108188 */   GIR_EraseRootFromParent_Done,
     /* 2108189 */ // Label 27897: @2108189
     /* 2108189 */ GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2108243), // Rule ID 46963 //
     /* 2108194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2108200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108208 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2108211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2108225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108230 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108242 */   // GIR_Coverage, 46963,
     /* 2108242 */   GIR_EraseRootFromParent_Done,
     /* 2108243 */ // Label 27898: @2108243
     /* 2108243 */ GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2108297), // Rule ID 47028 //
     /* 2108248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2108254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108262 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2108265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2108279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108284 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108296 */   // GIR_Coverage, 47028,
     /* 2108296 */   GIR_EraseRootFromParent_Done,
     /* 2108297 */ // Label 27899: @2108297
     /* 2108297 */ GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2108351), // Rule ID 47029 //
     /* 2108302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2108308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108316 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2108319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2108333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108338 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108350 */   // GIR_Coverage, 47029,
     /* 2108350 */   GIR_EraseRootFromParent_Done,
     /* 2108351 */ // Label 27900: @2108351
     /* 2108351 */ GIM_Reject,
     /* 2108352 */ // Label 27862: @2108352
     /* 2108352 */ GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2108406), // Rule ID 46982 //
     /* 2108357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2108360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2108363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108371 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2108388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108393 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108405 */   // GIR_Coverage, 46982,
     /* 2108405 */   GIR_EraseRootFromParent_Done,
     /* 2108406 */ // Label 27901: @2108406
     /* 2108406 */ GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2108460), // Rule ID 46983 //
     /* 2108411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2108414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2108417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108425 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2108442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108447 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108459 */   // GIR_Coverage, 46983,
     /* 2108459 */   GIR_EraseRootFromParent_Done,
     /* 2108460 */ // Label 27902: @2108460
     /* 2108460 */ GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2108514), // Rule ID 47048 //
     /* 2108465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2108468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2108471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108479 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2108496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108501 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108513 */   // GIR_Coverage, 47048,
     /* 2108513 */   GIR_EraseRootFromParent_Done,
     /* 2108514 */ // Label 27903: @2108514
     /* 2108514 */ GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2108568), // Rule ID 47049 //
     /* 2108519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2108522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2108525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108533 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2108550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108555 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108567 */   // GIR_Coverage, 47049,
     /* 2108567 */   GIR_EraseRootFromParent_Done,
     /* 2108568 */ // Label 27904: @2108568
     /* 2108568 */ GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2108622), // Rule ID 47082 //
     /* 2108573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2108576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2108579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108587 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2108604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108609 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108621 */   // GIR_Coverage, 47082,
     /* 2108621 */   GIR_EraseRootFromParent_Done,
     /* 2108622 */ // Label 27905: @2108622
     /* 2108622 */ GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2108676), // Rule ID 47083 //
     /* 2108627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2108630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2108633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108641 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2108644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2108658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108663 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108675 */   // GIR_Coverage, 47083,
     /* 2108675 */   GIR_EraseRootFromParent_Done,
     /* 2108676 */ // Label 27906: @2108676
     /* 2108676 */ GIM_Reject,
     /* 2108677 */ // Label 27863: @2108677
     /* 2108677 */ GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2108780),
     /* 2108682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2108685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108693 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2108736), // Rule ID 46942 //
     /* 2108698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108701 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2108704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2108718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108735 */     // GIR_Coverage, 46942,
     /* 2108735 */     GIR_EraseRootFromParent_Done,
     /* 2108736 */   // Label 27908: @2108736
     /* 2108736 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2108779), // Rule ID 46943 //
     /* 2108741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108744 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2108747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2108761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108778 */     // GIR_Coverage, 46943,
     /* 2108778 */     GIR_EraseRootFromParent_Done,
     /* 2108779 */   // Label 27909: @2108779
     /* 2108779 */   GIM_Reject,
     /* 2108780 */ // Label 27907: @2108780
     /* 2108780 */ GIM_Reject,
     /* 2108781 */ // Label 27864: @2108781
     /* 2108781 */ GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2108835), // Rule ID 46966 //
     /* 2108786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2108792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108800 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2108803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2108817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108834 */   // GIR_Coverage, 46966,
     /* 2108834 */   GIR_EraseRootFromParent_Done,
     /* 2108835 */ // Label 27910: @2108835
     /* 2108835 */ GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2108889), // Rule ID 46967 //
     /* 2108840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2108846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108854 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2108857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2108871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108876 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108888 */   // GIR_Coverage, 46967,
     /* 2108888 */   GIR_EraseRootFromParent_Done,
     /* 2108889 */ // Label 27911: @2108889
     /* 2108889 */ GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2108943), // Rule ID 47032 //
     /* 2108894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2108897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2108900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108908 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2108908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2108911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2108925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108930 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108942 */   // GIR_Coverage, 47032,
     /* 2108942 */   GIR_EraseRootFromParent_Done,
     /* 2108943 */ // Label 27912: @2108943
     /* 2108943 */ GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2108997), // Rule ID 47033 //
     /* 2108948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2108951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2108954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108962 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2108962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2108965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2108969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2108974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2108976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2108979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2108984 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2108986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2108989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2108995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2108996 */   // GIR_Coverage, 47033,
     /* 2108996 */   GIR_EraseRootFromParent_Done,
     /* 2108997 */ // Label 27913: @2108997
     /* 2108997 */ GIM_Reject,
     /* 2108998 */ // Label 27865: @2108998
     /* 2108998 */ GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2109052), // Rule ID 46986 //
     /* 2109003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2109009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109017 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2109034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109039 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109051 */   // GIR_Coverage, 46986,
     /* 2109051 */   GIR_EraseRootFromParent_Done,
     /* 2109052 */ // Label 27914: @2109052
     /* 2109052 */ GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2109106), // Rule ID 46987 //
     /* 2109057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2109063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109071 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2109088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109093 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109105 */   // GIR_Coverage, 46987,
     /* 2109105 */   GIR_EraseRootFromParent_Done,
     /* 2109106 */ // Label 27915: @2109106
     /* 2109106 */ GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2109160), // Rule ID 47052 //
     /* 2109111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2109117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109125 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2109142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109159 */   // GIR_Coverage, 47052,
     /* 2109159 */   GIR_EraseRootFromParent_Done,
     /* 2109160 */ // Label 27916: @2109160
     /* 2109160 */ GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2109214), // Rule ID 47053 //
     /* 2109165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2109171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109179 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2109196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109201 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109213 */   // GIR_Coverage, 47053,
     /* 2109213 */   GIR_EraseRootFromParent_Done,
     /* 2109214 */ // Label 27917: @2109214
     /* 2109214 */ GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2109268), // Rule ID 47086 //
     /* 2109219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2109225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109233 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2109250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109255 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109267 */   // GIR_Coverage, 47086,
     /* 2109267 */   GIR_EraseRootFromParent_Done,
     /* 2109268 */ // Label 27918: @2109268
     /* 2109268 */ GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2109322), // Rule ID 47087 //
     /* 2109273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2109279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109287 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2109290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2109304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109321 */   // GIR_Coverage, 47087,
     /* 2109321 */   GIR_EraseRootFromParent_Done,
     /* 2109322 */ // Label 27919: @2109322
     /* 2109322 */ GIM_Reject,
     /* 2109323 */ // Label 27866: @2109323
     /* 2109323 */ GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2109426),
     /* 2109328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2109331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109339 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2109382), // Rule ID 46946 //
     /* 2109344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2109347 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2109350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2109364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109381 */     // GIR_Coverage, 46946,
     /* 2109381 */     GIR_EraseRootFromParent_Done,
     /* 2109382 */   // Label 27921: @2109382
     /* 2109382 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2109425), // Rule ID 46947 //
     /* 2109387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2109390 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2109393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2109407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109424 */     // GIR_Coverage, 46947,
     /* 2109424 */     GIR_EraseRootFromParent_Done,
     /* 2109425 */   // Label 27922: @2109425
     /* 2109425 */   GIM_Reject,
     /* 2109426 */ // Label 27920: @2109426
     /* 2109426 */ GIM_Reject,
     /* 2109427 */ // Label 27867: @2109427
     /* 2109427 */ GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2109481), // Rule ID 46970 //
     /* 2109432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2109435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2109438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109446 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2109449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2109463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109480 */   // GIR_Coverage, 46970,
     /* 2109480 */   GIR_EraseRootFromParent_Done,
     /* 2109481 */ // Label 27923: @2109481
     /* 2109481 */ GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2109535), // Rule ID 46971 //
     /* 2109486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2109489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2109492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109500 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2109503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2109517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109522 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109534 */   // GIR_Coverage, 46971,
     /* 2109534 */   GIR_EraseRootFromParent_Done,
     /* 2109535 */ // Label 27924: @2109535
     /* 2109535 */ GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2109589), // Rule ID 47036 //
     /* 2109540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2109543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2109546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109554 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2109557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2109571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109576 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109588 */   // GIR_Coverage, 47036,
     /* 2109588 */   GIR_EraseRootFromParent_Done,
     /* 2109589 */ // Label 27925: @2109589
     /* 2109589 */ GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2109643), // Rule ID 47037 //
     /* 2109594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2109597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2109600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109608 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2109611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2109625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109630 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109642 */   // GIR_Coverage, 47037,
     /* 2109642 */   GIR_EraseRootFromParent_Done,
     /* 2109643 */ // Label 27926: @2109643
     /* 2109643 */ GIM_Reject,
     /* 2109644 */ // Label 27868: @2109644
     /* 2109644 */ GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2109698), // Rule ID 46990 //
     /* 2109649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2109655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109663 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2109680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109685 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109697 */   // GIR_Coverage, 46990,
     /* 2109697 */   GIR_EraseRootFromParent_Done,
     /* 2109698 */ // Label 27927: @2109698
     /* 2109698 */ GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2109752), // Rule ID 46991 //
     /* 2109703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2109709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109717 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2109734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109739 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109751 */   // GIR_Coverage, 46991,
     /* 2109751 */   GIR_EraseRootFromParent_Done,
     /* 2109752 */ // Label 27928: @2109752
     /* 2109752 */ GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2109806), // Rule ID 47056 //
     /* 2109757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2109763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109771 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2109788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109793 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109805 */   // GIR_Coverage, 47056,
     /* 2109805 */   GIR_EraseRootFromParent_Done,
     /* 2109806 */ // Label 27929: @2109806
     /* 2109806 */ GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2109860), // Rule ID 47057 //
     /* 2109811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2109817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109825 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2109842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109847 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109859 */   // GIR_Coverage, 47057,
     /* 2109859 */   GIR_EraseRootFromParent_Done,
     /* 2109860 */ // Label 27930: @2109860
     /* 2109860 */ GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2109914), // Rule ID 47090 //
     /* 2109865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2109868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2109871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109879 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2109896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109913 */   // GIR_Coverage, 47090,
     /* 2109913 */   GIR_EraseRootFromParent_Done,
     /* 2109914 */ // Label 27931: @2109914
     /* 2109914 */ GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2109968), // Rule ID 47091 //
     /* 2109919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2109922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2109925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109933 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2109933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2109936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2109940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2109945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2109947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2109950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2109955 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2109957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2109960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2109966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2109967 */   // GIR_Coverage, 47091,
     /* 2109967 */   GIR_EraseRootFromParent_Done,
     /* 2109968 */ // Label 27932: @2109968
     /* 2109968 */ GIM_Reject,
     /* 2109969 */ // Label 27869: @2109969
     /* 2109969 */ GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2110072),
     /* 2109974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2109977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109985 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2110028), // Rule ID 46950 //
     /* 2109990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2109993 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2109993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2109996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2110010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110027 */     // GIR_Coverage, 46950,
     /* 2110027 */     GIR_EraseRootFromParent_Done,
     /* 2110028 */   // Label 27934: @2110028
     /* 2110028 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2110071), // Rule ID 46951 //
     /* 2110033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110036 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2110039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2110053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110070 */     // GIR_Coverage, 46951,
     /* 2110070 */     GIR_EraseRootFromParent_Done,
     /* 2110071 */   // Label 27935: @2110071
     /* 2110071 */   GIM_Reject,
     /* 2110072 */ // Label 27933: @2110072
     /* 2110072 */ GIM_Reject,
     /* 2110073 */ // Label 27870: @2110073
     /* 2110073 */ GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2110127), // Rule ID 46974 //
     /* 2110078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2110084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110092 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2110095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2110109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110114 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110126 */   // GIR_Coverage, 46974,
     /* 2110126 */   GIR_EraseRootFromParent_Done,
     /* 2110127 */ // Label 27936: @2110127
     /* 2110127 */ GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2110181), // Rule ID 46975 //
     /* 2110132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2110138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110146 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2110149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2110163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110168 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110180 */   // GIR_Coverage, 46975,
     /* 2110180 */   GIR_EraseRootFromParent_Done,
     /* 2110181 */ // Label 27937: @2110181
     /* 2110181 */ GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2110235), // Rule ID 47040 //
     /* 2110186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2110192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110200 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2110203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2110217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110222 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110233 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110234 */   // GIR_Coverage, 47040,
     /* 2110234 */   GIR_EraseRootFromParent_Done,
     /* 2110235 */ // Label 27938: @2110235
     /* 2110235 */ GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2110289), // Rule ID 47041 //
     /* 2110240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2110246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110254 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2110257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2110271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110276 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110288 */   // GIR_Coverage, 47041,
     /* 2110288 */   GIR_EraseRootFromParent_Done,
     /* 2110289 */ // Label 27939: @2110289
     /* 2110289 */ GIM_Reject,
     /* 2110290 */ // Label 27871: @2110290
     /* 2110290 */ GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2110344), // Rule ID 46994 //
     /* 2110295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2110298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2110301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110309 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2110326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110343 */   // GIR_Coverage, 46994,
     /* 2110343 */   GIR_EraseRootFromParent_Done,
     /* 2110344 */ // Label 27940: @2110344
     /* 2110344 */ GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2110398), // Rule ID 46995 //
     /* 2110349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2110352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2110355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110363 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2110380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110385 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110397 */   // GIR_Coverage, 46995,
     /* 2110397 */   GIR_EraseRootFromParent_Done,
     /* 2110398 */ // Label 27941: @2110398
     /* 2110398 */ GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2110452), // Rule ID 47060 //
     /* 2110403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2110406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2110409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110417 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2110434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110439 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110451 */   // GIR_Coverage, 47060,
     /* 2110451 */   GIR_EraseRootFromParent_Done,
     /* 2110452 */ // Label 27942: @2110452
     /* 2110452 */ GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2110506), // Rule ID 47061 //
     /* 2110457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2110460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2110463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110471 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2110488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110493 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110505 */   // GIR_Coverage, 47061,
     /* 2110505 */   GIR_EraseRootFromParent_Done,
     /* 2110506 */ // Label 27943: @2110506
     /* 2110506 */ GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2110560), // Rule ID 47094 //
     /* 2110511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2110514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2110517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110525 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2110542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110547 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110559 */   // GIR_Coverage, 47094,
     /* 2110559 */   GIR_EraseRootFromParent_Done,
     /* 2110560 */ // Label 27944: @2110560
     /* 2110560 */ GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2110614), // Rule ID 47095 //
     /* 2110565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2110568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2110571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110579 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2110582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2110596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110601 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110613 */   // GIR_Coverage, 47095,
     /* 2110613 */   GIR_EraseRootFromParent_Done,
     /* 2110614 */ // Label 27945: @2110614
     /* 2110614 */ GIM_Reject,
     /* 2110615 */ // Label 27872: @2110615
     /* 2110615 */ GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2110718),
     /* 2110620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2110623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110631 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2110674), // Rule ID 46954 //
     /* 2110636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110639 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2110642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2110656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110673 */     // GIR_Coverage, 46954,
     /* 2110673 */     GIR_EraseRootFromParent_Done,
     /* 2110674 */   // Label 27947: @2110674
     /* 2110674 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2110717), // Rule ID 46955 //
     /* 2110679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110682 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2110685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2110699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110716 */     // GIR_Coverage, 46955,
     /* 2110716 */     GIR_EraseRootFromParent_Done,
     /* 2110717 */   // Label 27948: @2110717
     /* 2110717 */   GIM_Reject,
     /* 2110718 */ // Label 27946: @2110718
     /* 2110718 */ GIM_Reject,
     /* 2110719 */ // Label 27873: @2110719
     /* 2110719 */ GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2110773), // Rule ID 46978 //
     /* 2110724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2110730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110738 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2110741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2110755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110772 */   // GIR_Coverage, 46978,
     /* 2110772 */   GIR_EraseRootFromParent_Done,
     /* 2110773 */ // Label 27949: @2110773
     /* 2110773 */ GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2110827), // Rule ID 46979 //
     /* 2110778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2110784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110792 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2110795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2110809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110814 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110826 */   // GIR_Coverage, 46979,
     /* 2110826 */   GIR_EraseRootFromParent_Done,
     /* 2110827 */ // Label 27950: @2110827
     /* 2110827 */ GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2110881), // Rule ID 47044 //
     /* 2110832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2110838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110846 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2110849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2110863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110868 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110880 */   // GIR_Coverage, 47044,
     /* 2110880 */   GIR_EraseRootFromParent_Done,
     /* 2110881 */ // Label 27951: @2110881
     /* 2110881 */ GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2110935), // Rule ID 47045 //
     /* 2110886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2110892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110900 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2110900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2110903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2110917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110922 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2110934 */   // GIR_Coverage, 47045,
     /* 2110934 */   GIR_EraseRootFromParent_Done,
     /* 2110935 */ // Label 27952: @2110935
     /* 2110935 */ GIM_Reject,
     /* 2110936 */ // Label 27874: @2110936
     /* 2110936 */ GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2111039),
     /* 2110941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2110944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110952 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2110995), // Rule ID 46958 //
     /* 2110957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2110960 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2110960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2110963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2110967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2110972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2110974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2110977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2110982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2110984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2110987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2110993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110994 */     // GIR_Coverage, 46958,
     /* 2110994 */     GIR_EraseRootFromParent_Done,
     /* 2110995 */   // Label 27954: @2110995
     /* 2110995 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2111038), // Rule ID 46959 //
     /* 2111000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2111003 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2111003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2111006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2111020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2111027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111037 */     // GIR_Coverage, 46959,
     /* 2111037 */     GIR_EraseRootFromParent_Done,
     /* 2111038 */   // Label 27955: @2111038
     /* 2111038 */   GIM_Reject,
     /* 2111039 */ // Label 27953: @2111039
     /* 2111039 */ GIM_Reject,
     /* 2111040 */ // Label 27875: @2111040
     /* 2111040 */ GIM_Reject,
     /* 2111041 */ // Label 43: @2111041
     /* 2111041 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 27980*/ GIMT_Encode4(2114176),
     /* 2111052 */ /*GILLT_s32*//*Label 27956*/ GIMT_Encode4(2111176),
     /* 2111056 */ /*GILLT_s64*//*Label 27957*/ GIMT_Encode4(2111301), GIMT_Encode4(0),
     /* 2111064 */ /*GILLT_nxv1s8*//*Label 27958*/ GIMT_Encode4(2111646),
     /* 2111068 */ /*GILLT_nxv1s16*//*Label 27959*/ GIMT_Encode4(2111761),
     /* 2111072 */ /*GILLT_nxv1s32*//*Label 27960*/ GIMT_Encode4(2111876),
     /* 2111076 */ /*GILLT_nxv1s64*//*Label 27961*/ GIMT_Encode4(2111991), GIMT_Encode4(0),
     /* 2111084 */ /*GILLT_nxv2s8*//*Label 27962*/ GIMT_Encode4(2112106),
     /* 2111088 */ /*GILLT_nxv2s16*//*Label 27963*/ GIMT_Encode4(2112221),
     /* 2111092 */ /*GILLT_nxv2s32*//*Label 27964*/ GIMT_Encode4(2112336),
     /* 2111096 */ /*GILLT_nxv2s64*//*Label 27965*/ GIMT_Encode4(2112451), GIMT_Encode4(0),
     /* 2111104 */ /*GILLT_nxv4s8*//*Label 27966*/ GIMT_Encode4(2112566),
     /* 2111108 */ /*GILLT_nxv4s16*//*Label 27967*/ GIMT_Encode4(2112681),
     /* 2111112 */ /*GILLT_nxv4s32*//*Label 27968*/ GIMT_Encode4(2112796),
     /* 2111116 */ /*GILLT_nxv4s64*//*Label 27969*/ GIMT_Encode4(2112911), GIMT_Encode4(0),
     /* 2111124 */ /*GILLT_nxv8s8*//*Label 27970*/ GIMT_Encode4(2113026),
     /* 2111128 */ /*GILLT_nxv8s16*//*Label 27971*/ GIMT_Encode4(2113141),
     /* 2111132 */ /*GILLT_nxv8s32*//*Label 27972*/ GIMT_Encode4(2113256),
     /* 2111136 */ /*GILLT_nxv8s64*//*Label 27973*/ GIMT_Encode4(2113371), GIMT_Encode4(0),
     /* 2111144 */ /*GILLT_nxv16s8*//*Label 27974*/ GIMT_Encode4(2113486),
     /* 2111148 */ /*GILLT_nxv16s16*//*Label 27975*/ GIMT_Encode4(2113601),
     /* 2111152 */ /*GILLT_nxv16s32*//*Label 27976*/ GIMT_Encode4(2113716), GIMT_Encode4(0),
     /* 2111160 */ /*GILLT_nxv32s8*//*Label 27977*/ GIMT_Encode4(2113831),
     /* 2111164 */ /*GILLT_nxv32s16*//*Label 27978*/ GIMT_Encode4(2113946), GIMT_Encode4(0),
     /* 2111172 */ /*GILLT_nxv64s8*//*Label 27979*/ GIMT_Encode4(2114061),
     /* 2111176 */ // Label 27956: @2111176
     /* 2111176 */ GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2111300),
     /* 2111181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2111184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2111187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111191 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2111228), // Rule ID 2339 //
     /* 2111196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2111199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2111203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2111210 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2111210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2111213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2111221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2111226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111227 */     // GIR_Coverage, 2339,
     /* 2111227 */     GIR_EraseRootFromParent_Done,
     /* 2111228 */   // Label 27982: @2111228
     /* 2111228 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2111266), // Rule ID 91 //
     /* 2111233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2111236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2111244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2111252 */     // MIs[1] Operand 1
     /* 2111252 */     // No operand predicates
     /* 2111252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2111254 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2111254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2111257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2111264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111265 */     // GIR_Coverage, 91,
     /* 2111265 */     GIR_EraseRootFromParent_Done,
     /* 2111266 */   // Label 27983: @2111266
     /* 2111266 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2111299), // Rule ID 105 //
     /* 2111271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2111274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2111285 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2111285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2111288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2111297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111298 */     // GIR_Coverage, 105,
     /* 2111298 */     GIR_EraseRootFromParent_Done,
     /* 2111299 */   // Label 27984: @2111299
     /* 2111299 */   GIM_Reject,
     /* 2111300 */ // Label 27981: @2111300
     /* 2111300 */ GIM_Reject,
     /* 2111301 */ // Label 27957: @2111301
     /* 2111301 */ GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2111645),
     /* 2111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2111309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2111312 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2111406), // Rule ID 253 //
     /* 2111317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2111320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2111328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2111332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2111336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2111340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111345 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2111356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2111360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111364 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2111368 */     // MIs[2] Operand 1
     /* 2111368 */     // No operand predicates
     /* 2111368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2111370 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2111370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2111373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2111377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2111386 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2111389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2111394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111399 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2111404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111405 */     // GIR_Coverage, 253,
     /* 2111405 */     GIR_EraseRootFromParent_Done,
     /* 2111406 */   // Label 27986: @2111406
     /* 2111406 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2111478), // Rule ID 2457 //
     /* 2111411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2111414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2111422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2111426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2111430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2111434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111439 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2111450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2111454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2111462 */     // MIs[2] Operand 1
     /* 2111462 */     // No operand predicates
     /* 2111462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2111464 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2111464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2111467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2111473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2111476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111477 */     // GIR_Coverage, 2457,
     /* 2111477 */     GIR_EraseRootFromParent_Done,
     /* 2111478 */   // Label 27987: @2111478
     /* 2111478 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2111519), // Rule ID 2338 //
     /* 2111483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2111486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2111494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2111501 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2111501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2111504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2111512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2111517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111518 */     // GIR_Coverage, 2338,
     /* 2111518 */     GIR_EraseRootFromParent_Done,
     /* 2111519 */   // Label 27988: @2111519
     /* 2111519 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2111565), // Rule ID 268 //
     /* 2111524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2111527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2111539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2111547 */     // MIs[1] Operand 1
     /* 2111547 */     // No operand predicates
     /* 2111547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9709),
     /* 2111551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2111553 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_9709>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2111553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2111556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2111563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111564 */     // GIR_Coverage, 268,
     /* 2111564 */     GIR_EraseRootFromParent_Done,
     /* 2111565 */   // Label 27989: @2111565
     /* 2111565 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2111607), // Rule ID 90 //
     /* 2111570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2111573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2111585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2111593 */     // MIs[1] Operand 1
     /* 2111593 */     // No operand predicates
     /* 2111593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2111595 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2111595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2111598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2111605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111606 */     // GIR_Coverage, 90,
     /* 2111606 */     GIR_EraseRootFromParent_Done,
     /* 2111607 */   // Label 27990: @2111607
     /* 2111607 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2111644), // Rule ID 104 //
     /* 2111612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2111615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2111623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2111630 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2111630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2111633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2111642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111643 */     // GIR_Coverage, 104,
     /* 2111643 */     GIR_EraseRootFromParent_Done,
     /* 2111644 */   // Label 27991: @2111644
     /* 2111644 */   GIM_Reject,
     /* 2111645 */ // Label 27985: @2111645
     /* 2111645 */ GIM_Reject,
     /* 2111646 */ // Label 27958: @2111646
     /* 2111646 */ GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2111760),
     /* 2111651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2111654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2111657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111669 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2111714), // Rule ID 47502 //
     /* 2111674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2111677 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2111677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2111680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2111694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111713 */     // GIR_Coverage, 47502,
     /* 2111713 */     GIR_EraseRootFromParent_Done,
     /* 2111714 */   // Label 27993: @2111714
     /* 2111714 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2111759), // Rule ID 47503 //
     /* 2111719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2111722 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2111722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2111725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2111739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111758 */     // GIR_Coverage, 47503,
     /* 2111758 */     GIR_EraseRootFromParent_Done,
     /* 2111759 */   // Label 27994: @2111759
     /* 2111759 */   GIM_Reject,
     /* 2111760 */ // Label 27992: @2111760
     /* 2111760 */ GIM_Reject,
     /* 2111761 */ // Label 27959: @2111761
     /* 2111761 */ GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2111875),
     /* 2111766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2111769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2111772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111784 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2111829), // Rule ID 47514 //
     /* 2111789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2111792 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2111792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2111795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2111809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111828 */     // GIR_Coverage, 47514,
     /* 2111828 */     GIR_EraseRootFromParent_Done,
     /* 2111829 */   // Label 27996: @2111829
     /* 2111829 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2111874), // Rule ID 47515 //
     /* 2111834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2111837 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2111837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2111840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2111854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111873 */     // GIR_Coverage, 47515,
     /* 2111873 */     GIR_EraseRootFromParent_Done,
     /* 2111874 */   // Label 27997: @2111874
     /* 2111874 */   GIM_Reject,
     /* 2111875 */ // Label 27995: @2111875
     /* 2111875 */ GIM_Reject,
     /* 2111876 */ // Label 27960: @2111876
     /* 2111876 */ GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2111990),
     /* 2111881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2111884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111899 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2111944), // Rule ID 47522 //
     /* 2111904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2111907 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2111907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2111910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2111924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111943 */     // GIR_Coverage, 47522,
     /* 2111943 */     GIR_EraseRootFromParent_Done,
     /* 2111944 */   // Label 27999: @2111944
     /* 2111944 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2111989), // Rule ID 47523 //
     /* 2111949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2111952 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2111952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2111955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2111959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2111964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2111966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2111969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2111974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2111976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2111978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2111981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2111987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111988 */     // GIR_Coverage, 47523,
     /* 2111988 */     GIR_EraseRootFromParent_Done,
     /* 2111989 */   // Label 28000: @2111989
     /* 2111989 */   GIM_Reject,
     /* 2111990 */ // Label 27998: @2111990
     /* 2111990 */ GIM_Reject,
     /* 2111991 */ // Label 27961: @2111991
     /* 2111991 */ GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2112105),
     /* 2111996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2111999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2112002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112014 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2112059), // Rule ID 47538 //
     /* 2112019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2112022 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2112025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112058 */     // GIR_Coverage, 47538,
     /* 2112058 */     GIR_EraseRootFromParent_Done,
     /* 2112059 */   // Label 28002: @2112059
     /* 2112059 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2112104), // Rule ID 47539 //
     /* 2112064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2112067 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2112070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112103 */     // GIR_Coverage, 47539,
     /* 2112103 */     GIR_EraseRootFromParent_Done,
     /* 2112104 */   // Label 28003: @2112104
     /* 2112104 */   GIM_Reject,
     /* 2112105 */ // Label 28001: @2112105
     /* 2112105 */ GIM_Reject,
     /* 2112106 */ // Label 27962: @2112106
     /* 2112106 */ GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2112220),
     /* 2112111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2112114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2112117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112129 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2112174), // Rule ID 47506 //
     /* 2112134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112137 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2112140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2112154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112173 */     // GIR_Coverage, 47506,
     /* 2112173 */     GIR_EraseRootFromParent_Done,
     /* 2112174 */   // Label 28005: @2112174
     /* 2112174 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2112219), // Rule ID 47507 //
     /* 2112179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112182 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2112185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2112199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112218 */     // GIR_Coverage, 47507,
     /* 2112218 */     GIR_EraseRootFromParent_Done,
     /* 2112219 */   // Label 28006: @2112219
     /* 2112219 */   GIM_Reject,
     /* 2112220 */ // Label 28004: @2112220
     /* 2112220 */ GIM_Reject,
     /* 2112221 */ // Label 27963: @2112221
     /* 2112221 */ GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2112335),
     /* 2112226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2112229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2112232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112244 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2112289), // Rule ID 47518 //
     /* 2112249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112252 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2112255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2112269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112288 */     // GIR_Coverage, 47518,
     /* 2112288 */     GIR_EraseRootFromParent_Done,
     /* 2112289 */   // Label 28008: @2112289
     /* 2112289 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2112334), // Rule ID 47519 //
     /* 2112294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112297 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2112300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2112314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112333 */     // GIR_Coverage, 47519,
     /* 2112333 */     GIR_EraseRootFromParent_Done,
     /* 2112334 */   // Label 28009: @2112334
     /* 2112334 */   GIM_Reject,
     /* 2112335 */ // Label 28007: @2112335
     /* 2112335 */ GIM_Reject,
     /* 2112336 */ // Label 27964: @2112336
     /* 2112336 */ GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2112450),
     /* 2112341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2112344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112359 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2112404), // Rule ID 47534 //
     /* 2112364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112367 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2112370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112403 */     // GIR_Coverage, 47534,
     /* 2112403 */     GIR_EraseRootFromParent_Done,
     /* 2112404 */   // Label 28011: @2112404
     /* 2112404 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2112449), // Rule ID 47535 //
     /* 2112409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112412 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2112415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112448 */     // GIR_Coverage, 47535,
     /* 2112448 */     GIR_EraseRootFromParent_Done,
     /* 2112449 */   // Label 28012: @2112449
     /* 2112449 */   GIM_Reject,
     /* 2112450 */ // Label 28010: @2112450
     /* 2112450 */ GIM_Reject,
     /* 2112451 */ // Label 27965: @2112451
     /* 2112451 */ GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2112565),
     /* 2112456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2112459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112474 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2112519), // Rule ID 47578 //
     /* 2112479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2112482 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2112485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2112499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112518 */     // GIR_Coverage, 47578,
     /* 2112518 */     GIR_EraseRootFromParent_Done,
     /* 2112519 */   // Label 28014: @2112519
     /* 2112519 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2112564), // Rule ID 47579 //
     /* 2112524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2112527 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2112530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2112544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112563 */     // GIR_Coverage, 47579,
     /* 2112563 */     GIR_EraseRootFromParent_Done,
     /* 2112564 */   // Label 28015: @2112564
     /* 2112564 */   GIM_Reject,
     /* 2112565 */ // Label 28013: @2112565
     /* 2112565 */ GIM_Reject,
     /* 2112566 */ // Label 27966: @2112566
     /* 2112566 */ GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2112680),
     /* 2112571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2112574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2112577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112589 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2112634), // Rule ID 47510 //
     /* 2112594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112597 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2112600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2112614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112633 */     // GIR_Coverage, 47510,
     /* 2112633 */     GIR_EraseRootFromParent_Done,
     /* 2112634 */   // Label 28017: @2112634
     /* 2112634 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2112679), // Rule ID 47511 //
     /* 2112639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112642 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2112645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2112659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112678 */     // GIR_Coverage, 47511,
     /* 2112678 */     GIR_EraseRootFromParent_Done,
     /* 2112679 */   // Label 28018: @2112679
     /* 2112679 */   GIM_Reject,
     /* 2112680 */ // Label 28016: @2112680
     /* 2112680 */ GIM_Reject,
     /* 2112681 */ // Label 27967: @2112681
     /* 2112681 */ GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2112795),
     /* 2112686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2112689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2112692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112704 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2112749), // Rule ID 47530 //
     /* 2112709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112712 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2112715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112748 */     // GIR_Coverage, 47530,
     /* 2112748 */     GIR_EraseRootFromParent_Done,
     /* 2112749 */   // Label 28020: @2112749
     /* 2112749 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2112794), // Rule ID 47531 //
     /* 2112754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112757 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2112760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2112774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112793 */     // GIR_Coverage, 47531,
     /* 2112793 */     GIR_EraseRootFromParent_Done,
     /* 2112794 */   // Label 28021: @2112794
     /* 2112794 */   GIM_Reject,
     /* 2112795 */ // Label 28019: @2112795
     /* 2112795 */ GIM_Reject,
     /* 2112796 */ // Label 27968: @2112796
     /* 2112796 */ GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2112910),
     /* 2112801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2112804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112819 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2112864), // Rule ID 47566 //
     /* 2112824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2112827 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2112830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2112844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112863 */     // GIR_Coverage, 47566,
     /* 2112863 */     GIR_EraseRootFromParent_Done,
     /* 2112864 */   // Label 28023: @2112864
     /* 2112864 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2112909), // Rule ID 47567 //
     /* 2112869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2112872 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2112875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2112889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112908 */     // GIR_Coverage, 47567,
     /* 2112908 */     GIR_EraseRootFromParent_Done,
     /* 2112909 */   // Label 28024: @2112909
     /* 2112909 */   GIM_Reject,
     /* 2112910 */ // Label 28022: @2112910
     /* 2112910 */ GIM_Reject,
     /* 2112911 */ // Label 27969: @2112911
     /* 2112911 */ GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2113025),
     /* 2112916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2112919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112934 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2112979), // Rule ID 47582 //
     /* 2112939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2112942 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2112942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2112945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2112956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2112959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2112964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2112966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2112968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2112971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2112977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112978 */     // GIR_Coverage, 47582,
     /* 2112978 */     GIR_EraseRootFromParent_Done,
     /* 2112979 */   // Label 28026: @2112979
     /* 2112979 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2113024), // Rule ID 47583 //
     /* 2112984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2112987 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2112987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2112990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2112994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2112999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113023 */     // GIR_Coverage, 47583,
     /* 2113023 */     GIR_EraseRootFromParent_Done,
     /* 2113024 */   // Label 28027: @2113024
     /* 2113024 */   GIM_Reject,
     /* 2113025 */ // Label 28025: @2113025
     /* 2113025 */ GIM_Reject,
     /* 2113026 */ // Label 27970: @2113026
     /* 2113026 */ GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2113140),
     /* 2113031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2113034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2113037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113049 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2113094), // Rule ID 47526 //
     /* 2113054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113057 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2113060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2113074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113093 */     // GIR_Coverage, 47526,
     /* 2113093 */     GIR_EraseRootFromParent_Done,
     /* 2113094 */   // Label 28029: @2113094
     /* 2113094 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2113139), // Rule ID 47527 //
     /* 2113099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113102 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2113105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2113119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113138 */     // GIR_Coverage, 47527,
     /* 2113138 */     GIR_EraseRootFromParent_Done,
     /* 2113139 */   // Label 28030: @2113139
     /* 2113139 */   GIM_Reject,
     /* 2113140 */ // Label 28028: @2113140
     /* 2113140 */ GIM_Reject,
     /* 2113141 */ // Label 27971: @2113141
     /* 2113141 */ GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2113255),
     /* 2113146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2113149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2113152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113164 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2113209), // Rule ID 47554 //
     /* 2113169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113172 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2113175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2113189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113208 */     // GIR_Coverage, 47554,
     /* 2113208 */     GIR_EraseRootFromParent_Done,
     /* 2113209 */   // Label 28032: @2113209
     /* 2113209 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2113254), // Rule ID 47555 //
     /* 2113214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113217 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2113220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2113234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113253 */     // GIR_Coverage, 47555,
     /* 2113253 */     GIR_EraseRootFromParent_Done,
     /* 2113254 */   // Label 28033: @2113254
     /* 2113254 */   GIM_Reject,
     /* 2113255 */ // Label 28031: @2113255
     /* 2113255 */ GIM_Reject,
     /* 2113256 */ // Label 27972: @2113256
     /* 2113256 */ GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2113370),
     /* 2113261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2113264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2113267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113279 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2113324), // Rule ID 47570 //
     /* 2113284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113287 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2113290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113323 */     // GIR_Coverage, 47570,
     /* 2113323 */     GIR_EraseRootFromParent_Done,
     /* 2113324 */   // Label 28035: @2113324
     /* 2113324 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2113369), // Rule ID 47571 //
     /* 2113329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113332 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2113335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113368 */     // GIR_Coverage, 47571,
     /* 2113368 */     GIR_EraseRootFromParent_Done,
     /* 2113369 */   // Label 28036: @2113369
     /* 2113369 */   GIM_Reject,
     /* 2113370 */ // Label 28034: @2113370
     /* 2113370 */ GIM_Reject,
     /* 2113371 */ // Label 27973: @2113371
     /* 2113371 */ GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2113485),
     /* 2113376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2113379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113394 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2113439), // Rule ID 47586 //
     /* 2113399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2113402 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2113405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2113419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113438 */     // GIR_Coverage, 47586,
     /* 2113438 */     GIR_EraseRootFromParent_Done,
     /* 2113439 */   // Label 28038: @2113439
     /* 2113439 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2113484), // Rule ID 47587 //
     /* 2113444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2113447 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2113450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2113464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113483 */     // GIR_Coverage, 47587,
     /* 2113483 */     GIR_EraseRootFromParent_Done,
     /* 2113484 */   // Label 28039: @2113484
     /* 2113484 */   GIM_Reject,
     /* 2113485 */ // Label 28037: @2113485
     /* 2113485 */ GIM_Reject,
     /* 2113486 */ // Label 27974: @2113486
     /* 2113486 */ GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2113600),
     /* 2113491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2113494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2113497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113509 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2113554), // Rule ID 47542 //
     /* 2113514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113517 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2113520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2113534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113553 */     // GIR_Coverage, 47542,
     /* 2113553 */     GIR_EraseRootFromParent_Done,
     /* 2113554 */   // Label 28041: @2113554
     /* 2113554 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2113599), // Rule ID 47543 //
     /* 2113559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113562 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2113565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2113579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113598 */     // GIR_Coverage, 47543,
     /* 2113598 */     GIR_EraseRootFromParent_Done,
     /* 2113599 */   // Label 28042: @2113599
     /* 2113599 */   GIM_Reject,
     /* 2113600 */ // Label 28040: @2113600
     /* 2113600 */ GIM_Reject,
     /* 2113601 */ // Label 27975: @2113601
     /* 2113601 */ GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2113715),
     /* 2113606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2113609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2113612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113624 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2113669), // Rule ID 47558 //
     /* 2113629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113632 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2113635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113668 */     // GIR_Coverage, 47558,
     /* 2113668 */     GIR_EraseRootFromParent_Done,
     /* 2113669 */   // Label 28044: @2113669
     /* 2113669 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2113714), // Rule ID 47559 //
     /* 2113674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113677 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2113680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113713 */     // GIR_Coverage, 47559,
     /* 2113713 */     GIR_EraseRootFromParent_Done,
     /* 2113714 */   // Label 28045: @2113714
     /* 2113714 */   GIM_Reject,
     /* 2113715 */ // Label 28043: @2113715
     /* 2113715 */ GIM_Reject,
     /* 2113716 */ // Label 27976: @2113716
     /* 2113716 */ GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2113830),
     /* 2113721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2113724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2113727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113739 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2113784), // Rule ID 47574 //
     /* 2113744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113747 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2113750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2113764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113783 */     // GIR_Coverage, 47574,
     /* 2113783 */     GIR_EraseRootFromParent_Done,
     /* 2113784 */   // Label 28047: @2113784
     /* 2113784 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2113829), // Rule ID 47575 //
     /* 2113789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113792 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2113795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2113809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113828 */     // GIR_Coverage, 47575,
     /* 2113828 */     GIR_EraseRootFromParent_Done,
     /* 2113829 */   // Label 28048: @2113829
     /* 2113829 */   GIM_Reject,
     /* 2113830 */ // Label 28046: @2113830
     /* 2113830 */ GIM_Reject,
     /* 2113831 */ // Label 27977: @2113831
     /* 2113831 */ GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2113945),
     /* 2113836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2113839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2113842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113854 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2113899), // Rule ID 47546 //
     /* 2113859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113862 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2113865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113898 */     // GIR_Coverage, 47546,
     /* 2113898 */     GIR_EraseRootFromParent_Done,
     /* 2113899 */   // Label 28050: @2113899
     /* 2113899 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2113944), // Rule ID 47547 //
     /* 2113904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2113907 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2113907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2113910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2113924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2113931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2113933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2113936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2113942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113943 */     // GIR_Coverage, 47547,
     /* 2113943 */     GIR_EraseRootFromParent_Done,
     /* 2113944 */   // Label 28051: @2113944
     /* 2113944 */   GIM_Reject,
     /* 2113945 */ // Label 28049: @2113945
     /* 2113945 */ GIM_Reject,
     /* 2113946 */ // Label 27978: @2113946
     /* 2113946 */ GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2114060),
     /* 2113951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2113954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2113957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113969 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2114014), // Rule ID 47562 //
     /* 2113974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2113977 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2113977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2113980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2113984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2113989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2113991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2113994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2113999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114013 */     // GIR_Coverage, 47562,
     /* 2114013 */     GIR_EraseRootFromParent_Done,
     /* 2114014 */   // Label 28053: @2114014
     /* 2114014 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2114059), // Rule ID 47563 //
     /* 2114019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2114022 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2114022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2114025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2114039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114058 */     // GIR_Coverage, 47563,
     /* 2114058 */     GIR_EraseRootFromParent_Done,
     /* 2114059 */   // Label 28054: @2114059
     /* 2114059 */   GIM_Reject,
     /* 2114060 */ // Label 28052: @2114060
     /* 2114060 */ GIM_Reject,
     /* 2114061 */ // Label 27979: @2114061
     /* 2114061 */ GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2114175),
     /* 2114066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2114069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2114072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114084 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2114129), // Rule ID 47550 //
     /* 2114089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2114092 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2114092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2114095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2114109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114128 */     // GIR_Coverage, 47550,
     /* 2114128 */     GIR_EraseRootFromParent_Done,
     /* 2114129 */   // Label 28056: @2114129
     /* 2114129 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2114174), // Rule ID 47551 //
     /* 2114134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2114137 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2114137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2114140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2114154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114173 */     // GIR_Coverage, 47551,
     /* 2114173 */     GIR_EraseRootFromParent_Done,
     /* 2114174 */   // Label 28057: @2114174
     /* 2114174 */   GIM_Reject,
     /* 2114175 */ // Label 28055: @2114175
     /* 2114175 */ GIM_Reject,
     /* 2114176 */ // Label 27980: @2114176
     /* 2114176 */ GIM_Reject,
     /* 2114177 */ // Label 44: @2114177
     /* 2114177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28082*/ GIMT_Encode4(2117207),
     /* 2114188 */ /*GILLT_s32*//*Label 28058*/ GIMT_Encode4(2114312),
     /* 2114192 */ /*GILLT_s64*//*Label 28059*/ GIMT_Encode4(2114396), GIMT_Encode4(0),
     /* 2114200 */ /*GILLT_nxv1s8*//*Label 28060*/ GIMT_Encode4(2114677),
     /* 2114204 */ /*GILLT_nxv1s16*//*Label 28061*/ GIMT_Encode4(2114792),
     /* 2114208 */ /*GILLT_nxv1s32*//*Label 28062*/ GIMT_Encode4(2114907),
     /* 2114212 */ /*GILLT_nxv1s64*//*Label 28063*/ GIMT_Encode4(2115022), GIMT_Encode4(0),
     /* 2114220 */ /*GILLT_nxv2s8*//*Label 28064*/ GIMT_Encode4(2115137),
     /* 2114224 */ /*GILLT_nxv2s16*//*Label 28065*/ GIMT_Encode4(2115252),
     /* 2114228 */ /*GILLT_nxv2s32*//*Label 28066*/ GIMT_Encode4(2115367),
     /* 2114232 */ /*GILLT_nxv2s64*//*Label 28067*/ GIMT_Encode4(2115482), GIMT_Encode4(0),
     /* 2114240 */ /*GILLT_nxv4s8*//*Label 28068*/ GIMT_Encode4(2115597),
     /* 2114244 */ /*GILLT_nxv4s16*//*Label 28069*/ GIMT_Encode4(2115712),
     /* 2114248 */ /*GILLT_nxv4s32*//*Label 28070*/ GIMT_Encode4(2115827),
     /* 2114252 */ /*GILLT_nxv4s64*//*Label 28071*/ GIMT_Encode4(2115942), GIMT_Encode4(0),
     /* 2114260 */ /*GILLT_nxv8s8*//*Label 28072*/ GIMT_Encode4(2116057),
     /* 2114264 */ /*GILLT_nxv8s16*//*Label 28073*/ GIMT_Encode4(2116172),
     /* 2114268 */ /*GILLT_nxv8s32*//*Label 28074*/ GIMT_Encode4(2116287),
     /* 2114272 */ /*GILLT_nxv8s64*//*Label 28075*/ GIMT_Encode4(2116402), GIMT_Encode4(0),
     /* 2114280 */ /*GILLT_nxv16s8*//*Label 28076*/ GIMT_Encode4(2116517),
     /* 2114284 */ /*GILLT_nxv16s16*//*Label 28077*/ GIMT_Encode4(2116632),
     /* 2114288 */ /*GILLT_nxv16s32*//*Label 28078*/ GIMT_Encode4(2116747), GIMT_Encode4(0),
     /* 2114296 */ /*GILLT_nxv32s8*//*Label 28079*/ GIMT_Encode4(2116862),
     /* 2114300 */ /*GILLT_nxv32s16*//*Label 28080*/ GIMT_Encode4(2116977), GIMT_Encode4(0),
     /* 2114308 */ /*GILLT_nxv64s8*//*Label 28081*/ GIMT_Encode4(2117092),
     /* 2114312 */ // Label 28058: @2114312
     /* 2114312 */ GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2114395),
     /* 2114317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2114320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2114323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114331 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2114365), // Rule ID 93 //
     /* 2114336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2114339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2114343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2114347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2114351 */     // MIs[1] Operand 1
     /* 2114351 */     // No operand predicates
     /* 2114351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2114353 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2114353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2114356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2114363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114364 */     // GIR_Coverage, 93,
     /* 2114364 */     GIR_EraseRootFromParent_Done,
     /* 2114365 */   // Label 28084: @2114365
     /* 2114365 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2114394), // Rule ID 107 //
     /* 2114370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2114373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2114380 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2114380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2114383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2114392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114393 */     // GIR_Coverage, 107,
     /* 2114393 */     GIR_EraseRootFromParent_Done,
     /* 2114394 */   // Label 28085: @2114394
     /* 2114394 */   GIM_Reject,
     /* 2114395 */ // Label 28083: @2114395
     /* 2114395 */ GIM_Reject,
     /* 2114396 */ // Label 28059: @2114396
     /* 2114396 */ GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2114676),
     /* 2114401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2114404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2114407 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2114479), // Rule ID 257 //
     /* 2114412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2114415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2114423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2114427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2114431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2114435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114440 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2114451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2114455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2114459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2114463 */     // MIs[2] Operand 1
     /* 2114463 */     // No operand predicates
     /* 2114463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2114465 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2114465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2114468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2114474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2114477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114478 */     // GIR_Coverage, 257,
     /* 2114478 */     GIR_EraseRootFromParent_Done,
     /* 2114479 */   // Label 28087: @2114479
     /* 2114479 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2114524), // Rule ID 61880 //
     /* 2114484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2114487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2114495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2114499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2114503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2114507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9711),
     /* 2114511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2114513 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_9711>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2114513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2114516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2114522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114523 */     // GIR_Coverage, 61880,
     /* 2114523 */     GIR_EraseRootFromParent_Done,
     /* 2114524 */   // Label 28088: @2114524
     /* 2114524 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2114596), // Rule ID 269 //
     /* 2114529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2114532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2114540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2114544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2114548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114553 */     // MIs[1] Operand 2
     /* 2114553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2114564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2114568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2114572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2114576 */     // MIs[2] Operand 1
     /* 2114576 */     // No operand predicates
     /* 2114576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9711),
     /* 2114580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2114582 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_9711>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2114582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2114585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2114591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2114594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114595 */     // GIR_Coverage, 269,
     /* 2114595 */     GIR_EraseRootFromParent_Done,
     /* 2114596 */   // Label 28089: @2114596
     /* 2114596 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2114638), // Rule ID 92 //
     /* 2114601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2114604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2114616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2114620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2114624 */     // MIs[1] Operand 1
     /* 2114624 */     // No operand predicates
     /* 2114624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2114626 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2114626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2114629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2114636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114637 */     // GIR_Coverage, 92,
     /* 2114637 */     GIR_EraseRootFromParent_Done,
     /* 2114638 */   // Label 28090: @2114638
     /* 2114638 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2114675), // Rule ID 106 //
     /* 2114643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2114646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2114654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2114661 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2114661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2114664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2114673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114674 */     // GIR_Coverage, 106,
     /* 2114674 */     GIR_EraseRootFromParent_Done,
     /* 2114675 */   // Label 28091: @2114675
     /* 2114675 */   GIM_Reject,
     /* 2114676 */ // Label 28086: @2114676
     /* 2114676 */ GIM_Reject,
     /* 2114677 */ // Label 28060: @2114677
     /* 2114677 */ GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2114791),
     /* 2114682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2114685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2114688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114700 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2114745), // Rule ID 47634 //
     /* 2114705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2114708 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2114708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2114711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2114725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114744 */     // GIR_Coverage, 47634,
     /* 2114744 */     GIR_EraseRootFromParent_Done,
     /* 2114745 */   // Label 28093: @2114745
     /* 2114745 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2114790), // Rule ID 47635 //
     /* 2114750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2114753 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2114753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2114756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2114770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114789 */     // GIR_Coverage, 47635,
     /* 2114789 */     GIR_EraseRootFromParent_Done,
     /* 2114790 */   // Label 28094: @2114790
     /* 2114790 */   GIM_Reject,
     /* 2114791 */ // Label 28092: @2114791
     /* 2114791 */ GIM_Reject,
     /* 2114792 */ // Label 28061: @2114792
     /* 2114792 */ GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2114906),
     /* 2114797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2114800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2114803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114815 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2114860), // Rule ID 47646 //
     /* 2114820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2114823 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2114823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2114826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2114840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114859 */     // GIR_Coverage, 47646,
     /* 2114859 */     GIR_EraseRootFromParent_Done,
     /* 2114860 */   // Label 28096: @2114860
     /* 2114860 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2114905), // Rule ID 47647 //
     /* 2114865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2114868 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2114868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2114871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2114885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114904 */     // GIR_Coverage, 47647,
     /* 2114904 */     GIR_EraseRootFromParent_Done,
     /* 2114905 */   // Label 28097: @2114905
     /* 2114905 */   GIM_Reject,
     /* 2114906 */ // Label 28095: @2114906
     /* 2114906 */ GIM_Reject,
     /* 2114907 */ // Label 28062: @2114907
     /* 2114907 */ GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2115021),
     /* 2114912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2114915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2114918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114930 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2114975), // Rule ID 47654 //
     /* 2114935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2114938 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2114938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2114941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2114955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2114960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2114962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2114964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2114967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2114973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114974 */     // GIR_Coverage, 47654,
     /* 2114974 */     GIR_EraseRootFromParent_Done,
     /* 2114975 */   // Label 28099: @2114975
     /* 2114975 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2115020), // Rule ID 47655 //
     /* 2114980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2114983 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2114983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2114986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2114990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2114995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2114997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2115000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115019 */     // GIR_Coverage, 47655,
     /* 2115019 */     GIR_EraseRootFromParent_Done,
     /* 2115020 */   // Label 28100: @2115020
     /* 2115020 */   GIM_Reject,
     /* 2115021 */ // Label 28098: @2115021
     /* 2115021 */ GIM_Reject,
     /* 2115022 */ // Label 28063: @2115022
     /* 2115022 */ GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2115136),
     /* 2115027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2115030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2115033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115045 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2115090), // Rule ID 47670 //
     /* 2115050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2115053 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2115056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115089 */     // GIR_Coverage, 47670,
     /* 2115089 */     GIR_EraseRootFromParent_Done,
     /* 2115090 */   // Label 28102: @2115090
     /* 2115090 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2115135), // Rule ID 47671 //
     /* 2115095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2115098 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2115101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115134 */     // GIR_Coverage, 47671,
     /* 2115134 */     GIR_EraseRootFromParent_Done,
     /* 2115135 */   // Label 28103: @2115135
     /* 2115135 */   GIM_Reject,
     /* 2115136 */ // Label 28101: @2115136
     /* 2115136 */ GIM_Reject,
     /* 2115137 */ // Label 28064: @2115137
     /* 2115137 */ GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2115251),
     /* 2115142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2115145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2115148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115160 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2115205), // Rule ID 47638 //
     /* 2115165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115168 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2115171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2115185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115204 */     // GIR_Coverage, 47638,
     /* 2115204 */     GIR_EraseRootFromParent_Done,
     /* 2115205 */   // Label 28105: @2115205
     /* 2115205 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2115250), // Rule ID 47639 //
     /* 2115210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115213 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2115216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2115230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115249 */     // GIR_Coverage, 47639,
     /* 2115249 */     GIR_EraseRootFromParent_Done,
     /* 2115250 */   // Label 28106: @2115250
     /* 2115250 */   GIM_Reject,
     /* 2115251 */ // Label 28104: @2115251
     /* 2115251 */ GIM_Reject,
     /* 2115252 */ // Label 28065: @2115252
     /* 2115252 */ GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2115366),
     /* 2115257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2115260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2115263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115275 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2115320), // Rule ID 47650 //
     /* 2115280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115283 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2115286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2115300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115319 */     // GIR_Coverage, 47650,
     /* 2115319 */     GIR_EraseRootFromParent_Done,
     /* 2115320 */   // Label 28108: @2115320
     /* 2115320 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2115365), // Rule ID 47651 //
     /* 2115325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115328 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2115331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2115345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115364 */     // GIR_Coverage, 47651,
     /* 2115364 */     GIR_EraseRootFromParent_Done,
     /* 2115365 */   // Label 28109: @2115365
     /* 2115365 */   GIM_Reject,
     /* 2115366 */ // Label 28107: @2115366
     /* 2115366 */ GIM_Reject,
     /* 2115367 */ // Label 28066: @2115367
     /* 2115367 */ GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2115481),
     /* 2115372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2115375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115390 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2115435), // Rule ID 47666 //
     /* 2115395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115398 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2115401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115434 */     // GIR_Coverage, 47666,
     /* 2115434 */     GIR_EraseRootFromParent_Done,
     /* 2115435 */   // Label 28111: @2115435
     /* 2115435 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2115480), // Rule ID 47667 //
     /* 2115440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115443 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2115446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115479 */     // GIR_Coverage, 47667,
     /* 2115479 */     GIR_EraseRootFromParent_Done,
     /* 2115480 */   // Label 28112: @2115480
     /* 2115480 */   GIM_Reject,
     /* 2115481 */ // Label 28110: @2115481
     /* 2115481 */ GIM_Reject,
     /* 2115482 */ // Label 28067: @2115482
     /* 2115482 */ GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2115596),
     /* 2115487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2115490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115505 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2115550), // Rule ID 47710 //
     /* 2115510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2115513 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2115516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2115530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115549 */     // GIR_Coverage, 47710,
     /* 2115549 */     GIR_EraseRootFromParent_Done,
     /* 2115550 */   // Label 28114: @2115550
     /* 2115550 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2115595), // Rule ID 47711 //
     /* 2115555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2115558 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2115561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2115575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115594 */     // GIR_Coverage, 47711,
     /* 2115594 */     GIR_EraseRootFromParent_Done,
     /* 2115595 */   // Label 28115: @2115595
     /* 2115595 */   GIM_Reject,
     /* 2115596 */ // Label 28113: @2115596
     /* 2115596 */ GIM_Reject,
     /* 2115597 */ // Label 28068: @2115597
     /* 2115597 */ GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2115711),
     /* 2115602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2115605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2115608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115620 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2115665), // Rule ID 47642 //
     /* 2115625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115628 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2115631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2115645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115664 */     // GIR_Coverage, 47642,
     /* 2115664 */     GIR_EraseRootFromParent_Done,
     /* 2115665 */   // Label 28117: @2115665
     /* 2115665 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2115710), // Rule ID 47643 //
     /* 2115670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115673 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2115676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2115690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115709 */     // GIR_Coverage, 47643,
     /* 2115709 */     GIR_EraseRootFromParent_Done,
     /* 2115710 */   // Label 28118: @2115710
     /* 2115710 */   GIM_Reject,
     /* 2115711 */ // Label 28116: @2115711
     /* 2115711 */ GIM_Reject,
     /* 2115712 */ // Label 28069: @2115712
     /* 2115712 */ GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2115826),
     /* 2115717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2115720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2115723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115735 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2115780), // Rule ID 47662 //
     /* 2115740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115743 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2115746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115779 */     // GIR_Coverage, 47662,
     /* 2115779 */     GIR_EraseRootFromParent_Done,
     /* 2115780 */   // Label 28120: @2115780
     /* 2115780 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2115825), // Rule ID 47663 //
     /* 2115785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115788 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2115791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2115805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115824 */     // GIR_Coverage, 47663,
     /* 2115824 */     GIR_EraseRootFromParent_Done,
     /* 2115825 */   // Label 28121: @2115825
     /* 2115825 */   GIM_Reject,
     /* 2115826 */ // Label 28119: @2115826
     /* 2115826 */ GIM_Reject,
     /* 2115827 */ // Label 28070: @2115827
     /* 2115827 */ GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2115941),
     /* 2115832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2115835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115850 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2115895), // Rule ID 47698 //
     /* 2115855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2115858 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2115861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2115875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115894 */     // GIR_Coverage, 47698,
     /* 2115894 */     GIR_EraseRootFromParent_Done,
     /* 2115895 */   // Label 28123: @2115895
     /* 2115895 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2115940), // Rule ID 47699 //
     /* 2115900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2115903 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2115903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2115906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2115920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2115932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2115938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115939 */     // GIR_Coverage, 47699,
     /* 2115939 */     GIR_EraseRootFromParent_Done,
     /* 2115940 */   // Label 28124: @2115940
     /* 2115940 */   GIM_Reject,
     /* 2115941 */ // Label 28122: @2115941
     /* 2115941 */ GIM_Reject,
     /* 2115942 */ // Label 28071: @2115942
     /* 2115942 */ GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2116056),
     /* 2115947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2115950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115965 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2116010), // Rule ID 47714 //
     /* 2115970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2115973 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2115973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2115976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2115980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2115985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2115987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2115990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2115995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2115997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2115999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116009 */     // GIR_Coverage, 47714,
     /* 2116009 */     GIR_EraseRootFromParent_Done,
     /* 2116010 */   // Label 28126: @2116010
     /* 2116010 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2116055), // Rule ID 47715 //
     /* 2116015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2116018 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2116021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116054 */     // GIR_Coverage, 47715,
     /* 2116054 */     GIR_EraseRootFromParent_Done,
     /* 2116055 */   // Label 28127: @2116055
     /* 2116055 */   GIM_Reject,
     /* 2116056 */ // Label 28125: @2116056
     /* 2116056 */ GIM_Reject,
     /* 2116057 */ // Label 28072: @2116057
     /* 2116057 */ GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2116171),
     /* 2116062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2116065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2116068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116080 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2116125), // Rule ID 47658 //
     /* 2116085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116088 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2116091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2116105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116124 */     // GIR_Coverage, 47658,
     /* 2116124 */     GIR_EraseRootFromParent_Done,
     /* 2116125 */   // Label 28129: @2116125
     /* 2116125 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2116170), // Rule ID 47659 //
     /* 2116130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116133 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2116136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2116150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116169 */     // GIR_Coverage, 47659,
     /* 2116169 */     GIR_EraseRootFromParent_Done,
     /* 2116170 */   // Label 28130: @2116170
     /* 2116170 */   GIM_Reject,
     /* 2116171 */ // Label 28128: @2116171
     /* 2116171 */ GIM_Reject,
     /* 2116172 */ // Label 28073: @2116172
     /* 2116172 */ GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2116286),
     /* 2116177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2116180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2116183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116195 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2116240), // Rule ID 47686 //
     /* 2116200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116203 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2116206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2116220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116239 */     // GIR_Coverage, 47686,
     /* 2116239 */     GIR_EraseRootFromParent_Done,
     /* 2116240 */   // Label 28132: @2116240
     /* 2116240 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2116285), // Rule ID 47687 //
     /* 2116245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116248 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2116251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2116265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116284 */     // GIR_Coverage, 47687,
     /* 2116284 */     GIR_EraseRootFromParent_Done,
     /* 2116285 */   // Label 28133: @2116285
     /* 2116285 */   GIM_Reject,
     /* 2116286 */ // Label 28131: @2116286
     /* 2116286 */ GIM_Reject,
     /* 2116287 */ // Label 28074: @2116287
     /* 2116287 */ GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2116401),
     /* 2116292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2116295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116310 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2116355), // Rule ID 47702 //
     /* 2116315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116318 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2116321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116354 */     // GIR_Coverage, 47702,
     /* 2116354 */     GIR_EraseRootFromParent_Done,
     /* 2116355 */   // Label 28135: @2116355
     /* 2116355 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2116400), // Rule ID 47703 //
     /* 2116360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116363 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2116366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116399 */     // GIR_Coverage, 47703,
     /* 2116399 */     GIR_EraseRootFromParent_Done,
     /* 2116400 */   // Label 28136: @2116400
     /* 2116400 */   GIM_Reject,
     /* 2116401 */ // Label 28134: @2116401
     /* 2116401 */ GIM_Reject,
     /* 2116402 */ // Label 28075: @2116402
     /* 2116402 */ GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2116516),
     /* 2116407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2116410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2116413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116425 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2116470), // Rule ID 47718 //
     /* 2116430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2116433 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2116436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2116450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116469 */     // GIR_Coverage, 47718,
     /* 2116469 */     GIR_EraseRootFromParent_Done,
     /* 2116470 */   // Label 28138: @2116470
     /* 2116470 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2116515), // Rule ID 47719 //
     /* 2116475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2116478 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2116481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2116495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116514 */     // GIR_Coverage, 47719,
     /* 2116514 */     GIR_EraseRootFromParent_Done,
     /* 2116515 */   // Label 28139: @2116515
     /* 2116515 */   GIM_Reject,
     /* 2116516 */ // Label 28137: @2116516
     /* 2116516 */ GIM_Reject,
     /* 2116517 */ // Label 28076: @2116517
     /* 2116517 */ GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2116631),
     /* 2116522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2116525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2116528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116540 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2116585), // Rule ID 47674 //
     /* 2116545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116548 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2116551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2116565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116584 */     // GIR_Coverage, 47674,
     /* 2116584 */     GIR_EraseRootFromParent_Done,
     /* 2116585 */   // Label 28141: @2116585
     /* 2116585 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2116630), // Rule ID 47675 //
     /* 2116590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116593 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2116596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2116610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116629 */     // GIR_Coverage, 47675,
     /* 2116629 */     GIR_EraseRootFromParent_Done,
     /* 2116630 */   // Label 28142: @2116630
     /* 2116630 */   GIM_Reject,
     /* 2116631 */ // Label 28140: @2116631
     /* 2116631 */ GIM_Reject,
     /* 2116632 */ // Label 28077: @2116632
     /* 2116632 */ GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2116746),
     /* 2116637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2116640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2116643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116655 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2116700), // Rule ID 47690 //
     /* 2116660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116663 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2116666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116699 */     // GIR_Coverage, 47690,
     /* 2116699 */     GIR_EraseRootFromParent_Done,
     /* 2116700 */   // Label 28144: @2116700
     /* 2116700 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2116745), // Rule ID 47691 //
     /* 2116705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116708 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2116711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116744 */     // GIR_Coverage, 47691,
     /* 2116744 */     GIR_EraseRootFromParent_Done,
     /* 2116745 */   // Label 28145: @2116745
     /* 2116745 */   GIM_Reject,
     /* 2116746 */ // Label 28143: @2116746
     /* 2116746 */ GIM_Reject,
     /* 2116747 */ // Label 28078: @2116747
     /* 2116747 */ GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2116861),
     /* 2116752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2116755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116770 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2116815), // Rule ID 47706 //
     /* 2116775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116778 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2116781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2116795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116814 */     // GIR_Coverage, 47706,
     /* 2116814 */     GIR_EraseRootFromParent_Done,
     /* 2116815 */   // Label 28147: @2116815
     /* 2116815 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2116860), // Rule ID 47707 //
     /* 2116820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116823 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2116826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2116840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116859 */     // GIR_Coverage, 47707,
     /* 2116859 */     GIR_EraseRootFromParent_Done,
     /* 2116860 */   // Label 28148: @2116860
     /* 2116860 */   GIM_Reject,
     /* 2116861 */ // Label 28146: @2116861
     /* 2116861 */ GIM_Reject,
     /* 2116862 */ // Label 28079: @2116862
     /* 2116862 */ GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2116976),
     /* 2116867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2116870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2116873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116885 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2116930), // Rule ID 47678 //
     /* 2116890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2116893 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2116893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2116896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116929 */     // GIR_Coverage, 47678,
     /* 2116929 */     GIR_EraseRootFromParent_Done,
     /* 2116930 */   // Label 28150: @2116930
     /* 2116930 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2116975), // Rule ID 47679 //
     /* 2116935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2116938 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2116938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2116941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2116945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2116950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2116952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2116955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2116960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2116962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2116964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2116967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2116973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116974 */     // GIR_Coverage, 47679,
     /* 2116974 */     GIR_EraseRootFromParent_Done,
     /* 2116975 */   // Label 28151: @2116975
     /* 2116975 */   GIM_Reject,
     /* 2116976 */ // Label 28149: @2116976
     /* 2116976 */ GIM_Reject,
     /* 2116977 */ // Label 28080: @2116977
     /* 2116977 */ GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2117091),
     /* 2116982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2116985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2116988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117000 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2117045), // Rule ID 47694 //
     /* 2117005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2117008 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2117011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2117025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117044 */     // GIR_Coverage, 47694,
     /* 2117044 */     GIR_EraseRootFromParent_Done,
     /* 2117045 */   // Label 28153: @2117045
     /* 2117045 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2117090), // Rule ID 47695 //
     /* 2117050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2117053 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2117053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2117056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2117070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117089 */     // GIR_Coverage, 47695,
     /* 2117089 */     GIR_EraseRootFromParent_Done,
     /* 2117090 */   // Label 28154: @2117090
     /* 2117090 */   GIM_Reject,
     /* 2117091 */ // Label 28152: @2117091
     /* 2117091 */ GIM_Reject,
     /* 2117092 */ // Label 28081: @2117092
     /* 2117092 */ GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2117206),
     /* 2117097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2117100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2117103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117115 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2117160), // Rule ID 47682 //
     /* 2117120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2117123 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2117126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2117140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117159 */     // GIR_Coverage, 47682,
     /* 2117159 */     GIR_EraseRootFromParent_Done,
     /* 2117160 */   // Label 28156: @2117160
     /* 2117160 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2117205), // Rule ID 47683 //
     /* 2117165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2117168 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2117168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2117171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2117185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117204 */     // GIR_Coverage, 47683,
     /* 2117204 */     GIR_EraseRootFromParent_Done,
     /* 2117205 */   // Label 28157: @2117205
     /* 2117205 */   GIM_Reject,
     /* 2117206 */ // Label 28155: @2117206
     /* 2117206 */ GIM_Reject,
     /* 2117207 */ // Label 28082: @2117207
     /* 2117207 */ GIM_Reject,
     /* 2117208 */ // Label 45: @2117208
     /* 2117208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28182*/ GIMT_Encode4(2120146),
     /* 2117219 */ /*GILLT_s32*//*Label 28158*/ GIMT_Encode4(2117343),
     /* 2117223 */ /*GILLT_s64*//*Label 28159*/ GIMT_Encode4(2117427), GIMT_Encode4(0),
     /* 2117231 */ /*GILLT_nxv1s8*//*Label 28160*/ GIMT_Encode4(2117616),
     /* 2117235 */ /*GILLT_nxv1s16*//*Label 28161*/ GIMT_Encode4(2117731),
     /* 2117239 */ /*GILLT_nxv1s32*//*Label 28162*/ GIMT_Encode4(2117846),
     /* 2117243 */ /*GILLT_nxv1s64*//*Label 28163*/ GIMT_Encode4(2117961), GIMT_Encode4(0),
     /* 2117251 */ /*GILLT_nxv2s8*//*Label 28164*/ GIMT_Encode4(2118076),
     /* 2117255 */ /*GILLT_nxv2s16*//*Label 28165*/ GIMT_Encode4(2118191),
     /* 2117259 */ /*GILLT_nxv2s32*//*Label 28166*/ GIMT_Encode4(2118306),
     /* 2117263 */ /*GILLT_nxv2s64*//*Label 28167*/ GIMT_Encode4(2118421), GIMT_Encode4(0),
     /* 2117271 */ /*GILLT_nxv4s8*//*Label 28168*/ GIMT_Encode4(2118536),
     /* 2117275 */ /*GILLT_nxv4s16*//*Label 28169*/ GIMT_Encode4(2118651),
     /* 2117279 */ /*GILLT_nxv4s32*//*Label 28170*/ GIMT_Encode4(2118766),
     /* 2117283 */ /*GILLT_nxv4s64*//*Label 28171*/ GIMT_Encode4(2118881), GIMT_Encode4(0),
     /* 2117291 */ /*GILLT_nxv8s8*//*Label 28172*/ GIMT_Encode4(2118996),
     /* 2117295 */ /*GILLT_nxv8s16*//*Label 28173*/ GIMT_Encode4(2119111),
     /* 2117299 */ /*GILLT_nxv8s32*//*Label 28174*/ GIMT_Encode4(2119226),
     /* 2117303 */ /*GILLT_nxv8s64*//*Label 28175*/ GIMT_Encode4(2119341), GIMT_Encode4(0),
     /* 2117311 */ /*GILLT_nxv16s8*//*Label 28176*/ GIMT_Encode4(2119456),
     /* 2117315 */ /*GILLT_nxv16s16*//*Label 28177*/ GIMT_Encode4(2119571),
     /* 2117319 */ /*GILLT_nxv16s32*//*Label 28178*/ GIMT_Encode4(2119686), GIMT_Encode4(0),
     /* 2117327 */ /*GILLT_nxv32s8*//*Label 28179*/ GIMT_Encode4(2119801),
     /* 2117331 */ /*GILLT_nxv32s16*//*Label 28180*/ GIMT_Encode4(2119916), GIMT_Encode4(0),
     /* 2117339 */ /*GILLT_nxv64s8*//*Label 28181*/ GIMT_Encode4(2120031),
     /* 2117343 */ // Label 28158: @2117343
     /* 2117343 */ GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2117426),
     /* 2117348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2117351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2117354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117362 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2117396), // Rule ID 95 //
     /* 2117367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2117370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2117374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2117378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2117382 */     // MIs[1] Operand 1
     /* 2117382 */     // No operand predicates
     /* 2117382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2117384 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2117384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2117387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2117394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117395 */     // GIR_Coverage, 95,
     /* 2117395 */     GIR_EraseRootFromParent_Done,
     /* 2117396 */   // Label 28184: @2117396
     /* 2117396 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2117425), // Rule ID 109 //
     /* 2117401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2117404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2117411 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2117411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2117414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2117423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117424 */     // GIR_Coverage, 109,
     /* 2117424 */     GIR_EraseRootFromParent_Done,
     /* 2117425 */   // Label 28185: @2117425
     /* 2117425 */   GIM_Reject,
     /* 2117426 */ // Label 28183: @2117426
     /* 2117426 */ GIM_Reject,
     /* 2117427 */ // Label 28159: @2117427
     /* 2117427 */ GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2117615),
     /* 2117432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2117435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2117438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117442 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2117479), // Rule ID 61879 //
     /* 2117447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2117450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2117454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2117458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2117462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2117466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2117468 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2117468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2117471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2117477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117478 */     // GIR_Coverage, 61879,
     /* 2117478 */     GIR_EraseRootFromParent_Done,
     /* 2117479 */   // Label 28187: @2117479
     /* 2117479 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2117543), // Rule ID 259 //
     /* 2117484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2117487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2117491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2117495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2117499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117504 */     // MIs[1] Operand 2
     /* 2117504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2117515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2117519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2117523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2117527 */     // MIs[2] Operand 1
     /* 2117527 */     // No operand predicates
     /* 2117527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2117529 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2117529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2117532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2117538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2117541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117542 */     // GIR_Coverage, 259,
     /* 2117542 */     GIR_EraseRootFromParent_Done,
     /* 2117543 */   // Label 28188: @2117543
     /* 2117543 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2117581), // Rule ID 94 //
     /* 2117548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2117551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2117559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2117563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2117567 */     // MIs[1] Operand 1
     /* 2117567 */     // No operand predicates
     /* 2117567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2117569 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2117569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2117572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2117579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117580 */     // GIR_Coverage, 94,
     /* 2117580 */     GIR_EraseRootFromParent_Done,
     /* 2117581 */   // Label 28189: @2117581
     /* 2117581 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2117614), // Rule ID 108 //
     /* 2117586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2117589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2117593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2117600 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2117600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2117603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2117612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117613 */     // GIR_Coverage, 108,
     /* 2117613 */     GIR_EraseRootFromParent_Done,
     /* 2117614 */   // Label 28190: @2117614
     /* 2117614 */   GIM_Reject,
     /* 2117615 */ // Label 28186: @2117615
     /* 2117615 */ GIM_Reject,
     /* 2117616 */ // Label 28160: @2117616
     /* 2117616 */ GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2117730),
     /* 2117621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2117624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2117627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117639 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2117684), // Rule ID 47766 //
     /* 2117644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2117647 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2117650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2117664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117683 */     // GIR_Coverage, 47766,
     /* 2117683 */     GIR_EraseRootFromParent_Done,
     /* 2117684 */   // Label 28192: @2117684
     /* 2117684 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2117729), // Rule ID 47767 //
     /* 2117689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2117692 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2117692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2117695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2117709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117728 */     // GIR_Coverage, 47767,
     /* 2117728 */     GIR_EraseRootFromParent_Done,
     /* 2117729 */   // Label 28193: @2117729
     /* 2117729 */   GIM_Reject,
     /* 2117730 */ // Label 28191: @2117730
     /* 2117730 */ GIM_Reject,
     /* 2117731 */ // Label 28161: @2117731
     /* 2117731 */ GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2117845),
     /* 2117736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2117739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2117742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117754 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2117799), // Rule ID 47778 //
     /* 2117759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2117762 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2117765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2117779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117798 */     // GIR_Coverage, 47778,
     /* 2117798 */     GIR_EraseRootFromParent_Done,
     /* 2117799 */   // Label 28195: @2117799
     /* 2117799 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2117844), // Rule ID 47779 //
     /* 2117804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2117807 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2117807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2117810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2117824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117843 */     // GIR_Coverage, 47779,
     /* 2117843 */     GIR_EraseRootFromParent_Done,
     /* 2117844 */   // Label 28196: @2117844
     /* 2117844 */   GIM_Reject,
     /* 2117845 */ // Label 28194: @2117845
     /* 2117845 */ GIM_Reject,
     /* 2117846 */ // Label 28162: @2117846
     /* 2117846 */ GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2117960),
     /* 2117851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2117854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117869 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2117914), // Rule ID 47786 //
     /* 2117874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2117877 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2117880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2117894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117913 */     // GIR_Coverage, 47786,
     /* 2117913 */     GIR_EraseRootFromParent_Done,
     /* 2117914 */   // Label 28198: @2117914
     /* 2117914 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2117959), // Rule ID 47787 //
     /* 2117919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2117922 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2117922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2117925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2117934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2117936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2117939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2117944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2117946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2117948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2117951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2117957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117958 */     // GIR_Coverage, 47787,
     /* 2117958 */     GIR_EraseRootFromParent_Done,
     /* 2117959 */   // Label 28199: @2117959
     /* 2117959 */   GIM_Reject,
     /* 2117960 */ // Label 28197: @2117960
     /* 2117960 */ GIM_Reject,
     /* 2117961 */ // Label 28163: @2117961
     /* 2117961 */ GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2118075),
     /* 2117966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2117969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117984 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2118029), // Rule ID 47802 //
     /* 2117989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2117992 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2117992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2117995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2117999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118028 */     // GIR_Coverage, 47802,
     /* 2118028 */     GIR_EraseRootFromParent_Done,
     /* 2118029 */   // Label 28201: @2118029
     /* 2118029 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2118074), // Rule ID 47803 //
     /* 2118034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2118037 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2118040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118073 */     // GIR_Coverage, 47803,
     /* 2118073 */     GIR_EraseRootFromParent_Done,
     /* 2118074 */   // Label 28202: @2118074
     /* 2118074 */   GIM_Reject,
     /* 2118075 */ // Label 28200: @2118075
     /* 2118075 */ GIM_Reject,
     /* 2118076 */ // Label 28164: @2118076
     /* 2118076 */ GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2118190),
     /* 2118081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2118084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2118087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118099 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2118144), // Rule ID 47770 //
     /* 2118104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118107 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2118110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2118124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118143 */     // GIR_Coverage, 47770,
     /* 2118143 */     GIR_EraseRootFromParent_Done,
     /* 2118144 */   // Label 28204: @2118144
     /* 2118144 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2118189), // Rule ID 47771 //
     /* 2118149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118152 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2118155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2118169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118188 */     // GIR_Coverage, 47771,
     /* 2118188 */     GIR_EraseRootFromParent_Done,
     /* 2118189 */   // Label 28205: @2118189
     /* 2118189 */   GIM_Reject,
     /* 2118190 */ // Label 28203: @2118190
     /* 2118190 */ GIM_Reject,
     /* 2118191 */ // Label 28165: @2118191
     /* 2118191 */ GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2118305),
     /* 2118196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2118199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2118202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118214 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2118259), // Rule ID 47782 //
     /* 2118219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118222 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2118225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2118239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118258 */     // GIR_Coverage, 47782,
     /* 2118258 */     GIR_EraseRootFromParent_Done,
     /* 2118259 */   // Label 28207: @2118259
     /* 2118259 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2118304), // Rule ID 47783 //
     /* 2118264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118267 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2118270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2118284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118303 */     // GIR_Coverage, 47783,
     /* 2118303 */     GIR_EraseRootFromParent_Done,
     /* 2118304 */   // Label 28208: @2118304
     /* 2118304 */   GIM_Reject,
     /* 2118305 */ // Label 28206: @2118305
     /* 2118305 */ GIM_Reject,
     /* 2118306 */ // Label 28166: @2118306
     /* 2118306 */ GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2118420),
     /* 2118311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2118314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2118317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118329 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2118374), // Rule ID 47798 //
     /* 2118334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118337 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2118340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118373 */     // GIR_Coverage, 47798,
     /* 2118373 */     GIR_EraseRootFromParent_Done,
     /* 2118374 */   // Label 28210: @2118374
     /* 2118374 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2118419), // Rule ID 47799 //
     /* 2118379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118382 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2118385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118418 */     // GIR_Coverage, 47799,
     /* 2118418 */     GIR_EraseRootFromParent_Done,
     /* 2118419 */   // Label 28211: @2118419
     /* 2118419 */   GIM_Reject,
     /* 2118420 */ // Label 28209: @2118420
     /* 2118420 */ GIM_Reject,
     /* 2118421 */ // Label 28167: @2118421
     /* 2118421 */ GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2118535),
     /* 2118426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2118429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118444 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2118489), // Rule ID 47842 //
     /* 2118449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2118452 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2118455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2118469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118488 */     // GIR_Coverage, 47842,
     /* 2118488 */     GIR_EraseRootFromParent_Done,
     /* 2118489 */   // Label 28213: @2118489
     /* 2118489 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2118534), // Rule ID 47843 //
     /* 2118494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2118497 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2118500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2118514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118533 */     // GIR_Coverage, 47843,
     /* 2118533 */     GIR_EraseRootFromParent_Done,
     /* 2118534 */   // Label 28214: @2118534
     /* 2118534 */   GIM_Reject,
     /* 2118535 */ // Label 28212: @2118535
     /* 2118535 */ GIM_Reject,
     /* 2118536 */ // Label 28168: @2118536
     /* 2118536 */ GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2118650),
     /* 2118541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2118544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2118547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118559 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2118604), // Rule ID 47774 //
     /* 2118564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118567 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2118570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2118584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118603 */     // GIR_Coverage, 47774,
     /* 2118603 */     GIR_EraseRootFromParent_Done,
     /* 2118604 */   // Label 28216: @2118604
     /* 2118604 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2118649), // Rule ID 47775 //
     /* 2118609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118612 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2118615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2118629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118648 */     // GIR_Coverage, 47775,
     /* 2118648 */     GIR_EraseRootFromParent_Done,
     /* 2118649 */   // Label 28217: @2118649
     /* 2118649 */   GIM_Reject,
     /* 2118650 */ // Label 28215: @2118650
     /* 2118650 */ GIM_Reject,
     /* 2118651 */ // Label 28169: @2118651
     /* 2118651 */ GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2118765),
     /* 2118656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2118659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2118662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118674 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2118719), // Rule ID 47794 //
     /* 2118679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118682 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2118685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118718 */     // GIR_Coverage, 47794,
     /* 2118718 */     GIR_EraseRootFromParent_Done,
     /* 2118719 */   // Label 28219: @2118719
     /* 2118719 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2118764), // Rule ID 47795 //
     /* 2118724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118727 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2118730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2118744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118763 */     // GIR_Coverage, 47795,
     /* 2118763 */     GIR_EraseRootFromParent_Done,
     /* 2118764 */   // Label 28220: @2118764
     /* 2118764 */   GIM_Reject,
     /* 2118765 */ // Label 28218: @2118765
     /* 2118765 */ GIM_Reject,
     /* 2118766 */ // Label 28170: @2118766
     /* 2118766 */ GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2118880),
     /* 2118771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2118774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118789 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2118834), // Rule ID 47830 //
     /* 2118794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2118797 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2118800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2118814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118833 */     // GIR_Coverage, 47830,
     /* 2118833 */     GIR_EraseRootFromParent_Done,
     /* 2118834 */   // Label 28222: @2118834
     /* 2118834 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2118879), // Rule ID 47831 //
     /* 2118839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2118842 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2118845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2118859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118878 */     // GIR_Coverage, 47831,
     /* 2118878 */     GIR_EraseRootFromParent_Done,
     /* 2118879 */   // Label 28223: @2118879
     /* 2118879 */   GIM_Reject,
     /* 2118880 */ // Label 28221: @2118880
     /* 2118880 */ GIM_Reject,
     /* 2118881 */ // Label 28171: @2118881
     /* 2118881 */ GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2118995),
     /* 2118886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2118889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118904 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2118949), // Rule ID 47846 //
     /* 2118909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2118912 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2118912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2118915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2118929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118948 */     // GIR_Coverage, 47846,
     /* 2118948 */     GIR_EraseRootFromParent_Done,
     /* 2118949 */   // Label 28225: @2118949
     /* 2118949 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2118994), // Rule ID 47847 //
     /* 2118954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2118957 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2118957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2118960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2118964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2118969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2118971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2118974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2118979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2118981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2118983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2118986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2118992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118993 */     // GIR_Coverage, 47847,
     /* 2118993 */     GIR_EraseRootFromParent_Done,
     /* 2118994 */   // Label 28226: @2118994
     /* 2118994 */   GIM_Reject,
     /* 2118995 */ // Label 28224: @2118995
     /* 2118995 */ GIM_Reject,
     /* 2118996 */ // Label 28172: @2118996
     /* 2118996 */ GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2119110),
     /* 2119001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2119004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2119007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119019 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2119064), // Rule ID 47790 //
     /* 2119024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119027 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2119030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2119044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119063 */     // GIR_Coverage, 47790,
     /* 2119063 */     GIR_EraseRootFromParent_Done,
     /* 2119064 */   // Label 28228: @2119064
     /* 2119064 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2119109), // Rule ID 47791 //
     /* 2119069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119072 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2119075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2119089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119108 */     // GIR_Coverage, 47791,
     /* 2119108 */     GIR_EraseRootFromParent_Done,
     /* 2119109 */   // Label 28229: @2119109
     /* 2119109 */   GIM_Reject,
     /* 2119110 */ // Label 28227: @2119110
     /* 2119110 */ GIM_Reject,
     /* 2119111 */ // Label 28173: @2119111
     /* 2119111 */ GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2119225),
     /* 2119116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2119119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2119122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119134 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2119179), // Rule ID 47818 //
     /* 2119139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119142 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2119145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2119159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119178 */     // GIR_Coverage, 47818,
     /* 2119178 */     GIR_EraseRootFromParent_Done,
     /* 2119179 */   // Label 28231: @2119179
     /* 2119179 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2119224), // Rule ID 47819 //
     /* 2119184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119187 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2119190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2119204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119223 */     // GIR_Coverage, 47819,
     /* 2119223 */     GIR_EraseRootFromParent_Done,
     /* 2119224 */   // Label 28232: @2119224
     /* 2119224 */   GIM_Reject,
     /* 2119225 */ // Label 28230: @2119225
     /* 2119225 */ GIM_Reject,
     /* 2119226 */ // Label 28174: @2119226
     /* 2119226 */ GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2119340),
     /* 2119231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2119234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119249 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2119294), // Rule ID 47834 //
     /* 2119254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119257 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2119260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119293 */     // GIR_Coverage, 47834,
     /* 2119293 */     GIR_EraseRootFromParent_Done,
     /* 2119294 */   // Label 28234: @2119294
     /* 2119294 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2119339), // Rule ID 47835 //
     /* 2119299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119302 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2119305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119338 */     // GIR_Coverage, 47835,
     /* 2119338 */     GIR_EraseRootFromParent_Done,
     /* 2119339 */   // Label 28235: @2119339
     /* 2119339 */   GIM_Reject,
     /* 2119340 */ // Label 28233: @2119340
     /* 2119340 */ GIM_Reject,
     /* 2119341 */ // Label 28175: @2119341
     /* 2119341 */ GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2119455),
     /* 2119346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2119349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119364 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2119409), // Rule ID 47850 //
     /* 2119369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2119372 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2119375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2119389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119408 */     // GIR_Coverage, 47850,
     /* 2119408 */     GIR_EraseRootFromParent_Done,
     /* 2119409 */   // Label 28237: @2119409
     /* 2119409 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2119454), // Rule ID 47851 //
     /* 2119414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2119417 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2119420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2119434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119453 */     // GIR_Coverage, 47851,
     /* 2119453 */     GIR_EraseRootFromParent_Done,
     /* 2119454 */   // Label 28238: @2119454
     /* 2119454 */   GIM_Reject,
     /* 2119455 */ // Label 28236: @2119455
     /* 2119455 */ GIM_Reject,
     /* 2119456 */ // Label 28176: @2119456
     /* 2119456 */ GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2119570),
     /* 2119461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2119464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2119467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119479 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2119524), // Rule ID 47806 //
     /* 2119484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119487 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2119490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2119504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119523 */     // GIR_Coverage, 47806,
     /* 2119523 */     GIR_EraseRootFromParent_Done,
     /* 2119524 */   // Label 28240: @2119524
     /* 2119524 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2119569), // Rule ID 47807 //
     /* 2119529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119532 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2119535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2119549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119568 */     // GIR_Coverage, 47807,
     /* 2119568 */     GIR_EraseRootFromParent_Done,
     /* 2119569 */   // Label 28241: @2119569
     /* 2119569 */   GIM_Reject,
     /* 2119570 */ // Label 28239: @2119570
     /* 2119570 */ GIM_Reject,
     /* 2119571 */ // Label 28177: @2119571
     /* 2119571 */ GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2119685),
     /* 2119576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2119579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2119582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119594 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2119639), // Rule ID 47822 //
     /* 2119599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119602 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2119605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119638 */     // GIR_Coverage, 47822,
     /* 2119638 */     GIR_EraseRootFromParent_Done,
     /* 2119639 */   // Label 28243: @2119639
     /* 2119639 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2119684), // Rule ID 47823 //
     /* 2119644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119647 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2119650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119683 */     // GIR_Coverage, 47823,
     /* 2119683 */     GIR_EraseRootFromParent_Done,
     /* 2119684 */   // Label 28244: @2119684
     /* 2119684 */   GIM_Reject,
     /* 2119685 */ // Label 28242: @2119685
     /* 2119685 */ GIM_Reject,
     /* 2119686 */ // Label 28178: @2119686
     /* 2119686 */ GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2119800),
     /* 2119691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2119694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119709 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2119754), // Rule ID 47838 //
     /* 2119714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119717 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2119720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2119734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119753 */     // GIR_Coverage, 47838,
     /* 2119753 */     GIR_EraseRootFromParent_Done,
     /* 2119754 */   // Label 28246: @2119754
     /* 2119754 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2119799), // Rule ID 47839 //
     /* 2119759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119762 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2119765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2119779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119798 */     // GIR_Coverage, 47839,
     /* 2119798 */     GIR_EraseRootFromParent_Done,
     /* 2119799 */   // Label 28247: @2119799
     /* 2119799 */   GIM_Reject,
     /* 2119800 */ // Label 28245: @2119800
     /* 2119800 */ GIM_Reject,
     /* 2119801 */ // Label 28179: @2119801
     /* 2119801 */ GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2119915),
     /* 2119806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2119809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2119812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119824 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2119869), // Rule ID 47810 //
     /* 2119829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119832 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2119835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119868 */     // GIR_Coverage, 47810,
     /* 2119868 */     GIR_EraseRootFromParent_Done,
     /* 2119869 */   // Label 28249: @2119869
     /* 2119869 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2119914), // Rule ID 47811 //
     /* 2119874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119877 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2119880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2119894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119913 */     // GIR_Coverage, 47811,
     /* 2119913 */     GIR_EraseRootFromParent_Done,
     /* 2119914 */   // Label 28250: @2119914
     /* 2119914 */   GIM_Reject,
     /* 2119915 */ // Label 28248: @2119915
     /* 2119915 */ GIM_Reject,
     /* 2119916 */ // Label 28180: @2119916
     /* 2119916 */ GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2120030),
     /* 2119921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2119924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2119927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119939 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2119984), // Rule ID 47826 //
     /* 2119944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2119947 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2119947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2119950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2119959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2119961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2119964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2119969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2119971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2119973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2119976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2119982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119983 */     // GIR_Coverage, 47826,
     /* 2119983 */     GIR_EraseRootFromParent_Done,
     /* 2119984 */   // Label 28252: @2119984
     /* 2119984 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2120029), // Rule ID 47827 //
     /* 2119989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2119992 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2119992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2119995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2119999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2120009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120028 */     // GIR_Coverage, 47827,
     /* 2120028 */     GIR_EraseRootFromParent_Done,
     /* 2120029 */   // Label 28253: @2120029
     /* 2120029 */   GIM_Reject,
     /* 2120030 */ // Label 28251: @2120030
     /* 2120030 */ GIM_Reject,
     /* 2120031 */ // Label 28181: @2120031
     /* 2120031 */ GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2120145),
     /* 2120036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2120039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2120042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120054 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2120099), // Rule ID 47814 //
     /* 2120059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2120062 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2120062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2120065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2120079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120098 */     // GIR_Coverage, 47814,
     /* 2120098 */     GIR_EraseRootFromParent_Done,
     /* 2120099 */   // Label 28255: @2120099
     /* 2120099 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2120144), // Rule ID 47815 //
     /* 2120104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2120107 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2120107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2120110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2120124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120143 */     // GIR_Coverage, 47815,
     /* 2120143 */     GIR_EraseRootFromParent_Done,
     /* 2120144 */   // Label 28256: @2120144
     /* 2120144 */   GIM_Reject,
     /* 2120145 */ // Label 28254: @2120145
     /* 2120145 */ GIM_Reject,
     /* 2120146 */ // Label 28182: @2120146
     /* 2120146 */ GIM_Reject,
     /* 2120147 */ // Label 46: @2120147
     /* 2120147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28281*/ GIMT_Encode4(2123086),
     /* 2120158 */ /*GILLT_s32*//*Label 28257*/ GIMT_Encode4(2120282),
     /* 2120162 */ /*GILLT_s64*//*Label 28258*/ GIMT_Encode4(2120419), GIMT_Encode4(0),
     /* 2120170 */ /*GILLT_nxv1s8*//*Label 28259*/ GIMT_Encode4(2120556),
     /* 2120174 */ /*GILLT_nxv1s16*//*Label 28260*/ GIMT_Encode4(2120671),
     /* 2120178 */ /*GILLT_nxv1s32*//*Label 28261*/ GIMT_Encode4(2120786),
     /* 2120182 */ /*GILLT_nxv1s64*//*Label 28262*/ GIMT_Encode4(2120901), GIMT_Encode4(0),
     /* 2120190 */ /*GILLT_nxv2s8*//*Label 28263*/ GIMT_Encode4(2121016),
     /* 2120194 */ /*GILLT_nxv2s16*//*Label 28264*/ GIMT_Encode4(2121131),
     /* 2120198 */ /*GILLT_nxv2s32*//*Label 28265*/ GIMT_Encode4(2121246),
     /* 2120202 */ /*GILLT_nxv2s64*//*Label 28266*/ GIMT_Encode4(2121361), GIMT_Encode4(0),
     /* 2120210 */ /*GILLT_nxv4s8*//*Label 28267*/ GIMT_Encode4(2121476),
     /* 2120214 */ /*GILLT_nxv4s16*//*Label 28268*/ GIMT_Encode4(2121591),
     /* 2120218 */ /*GILLT_nxv4s32*//*Label 28269*/ GIMT_Encode4(2121706),
     /* 2120222 */ /*GILLT_nxv4s64*//*Label 28270*/ GIMT_Encode4(2121821), GIMT_Encode4(0),
     /* 2120230 */ /*GILLT_nxv8s8*//*Label 28271*/ GIMT_Encode4(2121936),
     /* 2120234 */ /*GILLT_nxv8s16*//*Label 28272*/ GIMT_Encode4(2122051),
     /* 2120238 */ /*GILLT_nxv8s32*//*Label 28273*/ GIMT_Encode4(2122166),
     /* 2120242 */ /*GILLT_nxv8s64*//*Label 28274*/ GIMT_Encode4(2122281), GIMT_Encode4(0),
     /* 2120250 */ /*GILLT_nxv16s8*//*Label 28275*/ GIMT_Encode4(2122396),
     /* 2120254 */ /*GILLT_nxv16s16*//*Label 28276*/ GIMT_Encode4(2122511),
     /* 2120258 */ /*GILLT_nxv16s32*//*Label 28277*/ GIMT_Encode4(2122626), GIMT_Encode4(0),
     /* 2120266 */ /*GILLT_nxv32s8*//*Label 28278*/ GIMT_Encode4(2122741),
     /* 2120270 */ /*GILLT_nxv32s16*//*Label 28279*/ GIMT_Encode4(2122856), GIMT_Encode4(0),
     /* 2120278 */ /*GILLT_nxv64s8*//*Label 28280*/ GIMT_Encode4(2122971),
     /* 2120282 */ // Label 28257: @2120282
     /* 2120282 */ GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2120418),
     /* 2120287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2120290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2120293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120301 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2120335), // Rule ID 2321 //
     /* 2120306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2120309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2120313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2120317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2120321 */     // MIs[1] Operand 1
     /* 2120321 */     // No operand predicates
     /* 2120321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2120323 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2120323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2120326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2120333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120334 */     // GIR_Coverage, 2321,
     /* 2120334 */     GIR_EraseRootFromParent_Done,
     /* 2120335 */   // Label 28283: @2120335
     /* 2120335 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2120369), // Rule ID 61861 //
     /* 2120340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2120343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2120347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2120351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2120355 */     // MIs[1] Operand 1
     /* 2120355 */     // No operand predicates
     /* 2120355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2120357 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2120357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2120360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2120367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120368 */     // GIR_Coverage, 61861,
     /* 2120368 */     GIR_EraseRootFromParent_Done,
     /* 2120369 */   // Label 28284: @2120369
     /* 2120369 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2120398), // Rule ID 2319 //
     /* 2120374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2120377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2120384 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2120384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2120387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2120396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120397 */     // GIR_Coverage, 2319,
     /* 2120397 */     GIR_EraseRootFromParent_Done,
     /* 2120398 */   // Label 28285: @2120398
     /* 2120398 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2120417), // Rule ID 63759 //
     /* 2120403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2120406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120410 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2120410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2120415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120416 */     // GIR_Coverage, 63759,
     /* 2120416 */     GIR_Done,
     /* 2120417 */   // Label 28286: @2120417
     /* 2120417 */   GIM_Reject,
     /* 2120418 */ // Label 28282: @2120418
     /* 2120418 */ GIM_Reject,
     /* 2120419 */ // Label 28258: @2120419
     /* 2120419 */ GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2120555),
     /* 2120424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2120427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2120430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120438 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2120472), // Rule ID 2320 //
     /* 2120443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2120446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2120450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2120454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2120458 */     // MIs[1] Operand 1
     /* 2120458 */     // No operand predicates
     /* 2120458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2120460 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2120460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2120463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2120470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120471 */     // GIR_Coverage, 2320,
     /* 2120471 */     GIR_EraseRootFromParent_Done,
     /* 2120472 */   // Label 28288: @2120472
     /* 2120472 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2120506), // Rule ID 61860 //
     /* 2120477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2120480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2120484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2120488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2120492 */     // MIs[1] Operand 1
     /* 2120492 */     // No operand predicates
     /* 2120492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2120494 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2120494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2120497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2120504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120505 */     // GIR_Coverage, 61860,
     /* 2120505 */     GIR_EraseRootFromParent_Done,
     /* 2120506 */   // Label 28289: @2120506
     /* 2120506 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2120535), // Rule ID 2318 //
     /* 2120511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2120514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2120521 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2120521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2120524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2120533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120534 */     // GIR_Coverage, 2318,
     /* 2120534 */     GIR_EraseRootFromParent_Done,
     /* 2120535 */   // Label 28290: @2120535
     /* 2120535 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2120554), // Rule ID 63758 //
     /* 2120540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2120543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2120547 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2120547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2120552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120553 */     // GIR_Coverage, 63758,
     /* 2120553 */     GIR_Done,
     /* 2120554 */   // Label 28291: @2120554
     /* 2120554 */   GIM_Reject,
     /* 2120555 */ // Label 28287: @2120555
     /* 2120555 */ GIM_Reject,
     /* 2120556 */ // Label 28259: @2120556
     /* 2120556 */ GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2120670),
     /* 2120561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2120564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2120567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120579 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2120624), // Rule ID 58678 //
     /* 2120584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2120587 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2120587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2120590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2120604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120623 */     // GIR_Coverage, 58678,
     /* 2120623 */     GIR_EraseRootFromParent_Done,
     /* 2120624 */   // Label 28293: @2120624
     /* 2120624 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2120669), // Rule ID 58679 //
     /* 2120629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2120632 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2120632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2120635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2120649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120668 */     // GIR_Coverage, 58679,
     /* 2120668 */     GIR_EraseRootFromParent_Done,
     /* 2120669 */   // Label 28294: @2120669
     /* 2120669 */   GIM_Reject,
     /* 2120670 */ // Label 28292: @2120670
     /* 2120670 */ GIM_Reject,
     /* 2120671 */ // Label 28260: @2120671
     /* 2120671 */ GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2120785),
     /* 2120676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2120679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2120682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120694 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2120739), // Rule ID 58690 //
     /* 2120699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2120702 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2120702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2120705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2120719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120738 */     // GIR_Coverage, 58690,
     /* 2120738 */     GIR_EraseRootFromParent_Done,
     /* 2120739 */   // Label 28296: @2120739
     /* 2120739 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2120784), // Rule ID 58691 //
     /* 2120744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2120747 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2120747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2120750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2120764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120783 */     // GIR_Coverage, 58691,
     /* 2120783 */     GIR_EraseRootFromParent_Done,
     /* 2120784 */   // Label 28297: @2120784
     /* 2120784 */   GIM_Reject,
     /* 2120785 */ // Label 28295: @2120785
     /* 2120785 */ GIM_Reject,
     /* 2120786 */ // Label 28261: @2120786
     /* 2120786 */ GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2120900),
     /* 2120791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2120794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120809 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2120854), // Rule ID 58698 //
     /* 2120814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2120817 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2120817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2120820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2120834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120853 */     // GIR_Coverage, 58698,
     /* 2120853 */     GIR_EraseRootFromParent_Done,
     /* 2120854 */   // Label 28299: @2120854
     /* 2120854 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2120899), // Rule ID 58699 //
     /* 2120859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2120862 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2120862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2120865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2120879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120898 */     // GIR_Coverage, 58699,
     /* 2120898 */     GIR_EraseRootFromParent_Done,
     /* 2120899 */   // Label 28300: @2120899
     /* 2120899 */   GIM_Reject,
     /* 2120900 */ // Label 28298: @2120900
     /* 2120900 */ GIM_Reject,
     /* 2120901 */ // Label 28262: @2120901
     /* 2120901 */ GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2121015),
     /* 2120906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2120909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120924 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2120969), // Rule ID 58714 //
     /* 2120929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2120932 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2120932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2120935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2120949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2120956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2120958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2120961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2120964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2120967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120968 */     // GIR_Coverage, 58714,
     /* 2120968 */     GIR_EraseRootFromParent_Done,
     /* 2120969 */   // Label 28302: @2120969
     /* 2120969 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2121014), // Rule ID 58715 //
     /* 2120974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2120977 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2120977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2120980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2120984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2120989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2120991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2120994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2120999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121013 */     // GIR_Coverage, 58715,
     /* 2121013 */     GIR_EraseRootFromParent_Done,
     /* 2121014 */   // Label 28303: @2121014
     /* 2121014 */   GIM_Reject,
     /* 2121015 */ // Label 28301: @2121015
     /* 2121015 */ GIM_Reject,
     /* 2121016 */ // Label 28263: @2121016
     /* 2121016 */ GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2121130),
     /* 2121021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2121024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2121027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121039 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2121084), // Rule ID 58682 //
     /* 2121044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121047 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2121050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2121064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121083 */     // GIR_Coverage, 58682,
     /* 2121083 */     GIR_EraseRootFromParent_Done,
     /* 2121084 */   // Label 28305: @2121084
     /* 2121084 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2121129), // Rule ID 58683 //
     /* 2121089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121092 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2121095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2121109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121128 */     // GIR_Coverage, 58683,
     /* 2121128 */     GIR_EraseRootFromParent_Done,
     /* 2121129 */   // Label 28306: @2121129
     /* 2121129 */   GIM_Reject,
     /* 2121130 */ // Label 28304: @2121130
     /* 2121130 */ GIM_Reject,
     /* 2121131 */ // Label 28264: @2121131
     /* 2121131 */ GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2121245),
     /* 2121136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2121139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2121142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121154 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2121199), // Rule ID 58694 //
     /* 2121159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121162 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2121165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2121179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121198 */     // GIR_Coverage, 58694,
     /* 2121198 */     GIR_EraseRootFromParent_Done,
     /* 2121199 */   // Label 28308: @2121199
     /* 2121199 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2121244), // Rule ID 58695 //
     /* 2121204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121207 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2121210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2121224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121243 */     // GIR_Coverage, 58695,
     /* 2121243 */     GIR_EraseRootFromParent_Done,
     /* 2121244 */   // Label 28309: @2121244
     /* 2121244 */   GIM_Reject,
     /* 2121245 */ // Label 28307: @2121245
     /* 2121245 */ GIM_Reject,
     /* 2121246 */ // Label 28265: @2121246
     /* 2121246 */ GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2121360),
     /* 2121251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2121254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121269 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2121314), // Rule ID 58710 //
     /* 2121274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121277 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2121280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2121294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121313 */     // GIR_Coverage, 58710,
     /* 2121313 */     GIR_EraseRootFromParent_Done,
     /* 2121314 */   // Label 28311: @2121314
     /* 2121314 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2121359), // Rule ID 58711 //
     /* 2121319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121322 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2121325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2121339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121358 */     // GIR_Coverage, 58711,
     /* 2121358 */     GIR_EraseRootFromParent_Done,
     /* 2121359 */   // Label 28312: @2121359
     /* 2121359 */   GIM_Reject,
     /* 2121360 */ // Label 28310: @2121360
     /* 2121360 */ GIM_Reject,
     /* 2121361 */ // Label 28266: @2121361
     /* 2121361 */ GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2121475),
     /* 2121366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2121369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121384 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2121429), // Rule ID 58754 //
     /* 2121389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2121392 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2121395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2121409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121428 */     // GIR_Coverage, 58754,
     /* 2121428 */     GIR_EraseRootFromParent_Done,
     /* 2121429 */   // Label 28314: @2121429
     /* 2121429 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2121474), // Rule ID 58755 //
     /* 2121434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2121437 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2121440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2121454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121473 */     // GIR_Coverage, 58755,
     /* 2121473 */     GIR_EraseRootFromParent_Done,
     /* 2121474 */   // Label 28315: @2121474
     /* 2121474 */   GIM_Reject,
     /* 2121475 */ // Label 28313: @2121475
     /* 2121475 */ GIM_Reject,
     /* 2121476 */ // Label 28267: @2121476
     /* 2121476 */ GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2121590),
     /* 2121481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2121484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2121487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121499 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2121544), // Rule ID 58686 //
     /* 2121504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121507 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2121510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2121524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121543 */     // GIR_Coverage, 58686,
     /* 2121543 */     GIR_EraseRootFromParent_Done,
     /* 2121544 */   // Label 28317: @2121544
     /* 2121544 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2121589), // Rule ID 58687 //
     /* 2121549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121552 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2121555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2121569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121588 */     // GIR_Coverage, 58687,
     /* 2121588 */     GIR_EraseRootFromParent_Done,
     /* 2121589 */   // Label 28318: @2121589
     /* 2121589 */   GIM_Reject,
     /* 2121590 */ // Label 28316: @2121590
     /* 2121590 */ GIM_Reject,
     /* 2121591 */ // Label 28268: @2121591
     /* 2121591 */ GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2121705),
     /* 2121596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2121599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2121602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121614 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2121659), // Rule ID 58706 //
     /* 2121619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121622 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2121625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2121639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121658 */     // GIR_Coverage, 58706,
     /* 2121658 */     GIR_EraseRootFromParent_Done,
     /* 2121659 */   // Label 28320: @2121659
     /* 2121659 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2121704), // Rule ID 58707 //
     /* 2121664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121667 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2121670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2121684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121703 */     // GIR_Coverage, 58707,
     /* 2121703 */     GIR_EraseRootFromParent_Done,
     /* 2121704 */   // Label 28321: @2121704
     /* 2121704 */   GIM_Reject,
     /* 2121705 */ // Label 28319: @2121705
     /* 2121705 */ GIM_Reject,
     /* 2121706 */ // Label 28269: @2121706
     /* 2121706 */ GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2121820),
     /* 2121711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2121714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121729 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2121774), // Rule ID 58742 //
     /* 2121734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121737 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2121740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2121754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121773 */     // GIR_Coverage, 58742,
     /* 2121773 */     GIR_EraseRootFromParent_Done,
     /* 2121774 */   // Label 28323: @2121774
     /* 2121774 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2121819), // Rule ID 58743 //
     /* 2121779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2121782 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2121785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2121799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121818 */     // GIR_Coverage, 58743,
     /* 2121818 */     GIR_EraseRootFromParent_Done,
     /* 2121819 */   // Label 28324: @2121819
     /* 2121819 */   GIM_Reject,
     /* 2121820 */ // Label 28322: @2121820
     /* 2121820 */ GIM_Reject,
     /* 2121821 */ // Label 28270: @2121821
     /* 2121821 */ GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2121935),
     /* 2121826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2121829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121844 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2121889), // Rule ID 58758 //
     /* 2121849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2121852 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2121855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2121869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121888 */     // GIR_Coverage, 58758,
     /* 2121888 */     GIR_EraseRootFromParent_Done,
     /* 2121889 */   // Label 28326: @2121889
     /* 2121889 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2121934), // Rule ID 58759 //
     /* 2121894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2121897 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2121897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2121900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2121914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121933 */     // GIR_Coverage, 58759,
     /* 2121933 */     GIR_EraseRootFromParent_Done,
     /* 2121934 */   // Label 28327: @2121934
     /* 2121934 */   GIM_Reject,
     /* 2121935 */ // Label 28325: @2121935
     /* 2121935 */ GIM_Reject,
     /* 2121936 */ // Label 28271: @2121936
     /* 2121936 */ GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2122050),
     /* 2121941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2121944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2121947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121959 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2122004), // Rule ID 58702 //
     /* 2121964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2121967 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2121967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2121970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2121974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2121979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2121981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2121984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2121989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2121991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2121993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2121996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2121999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122003 */     // GIR_Coverage, 58702,
     /* 2122003 */     GIR_EraseRootFromParent_Done,
     /* 2122004 */   // Label 28329: @2122004
     /* 2122004 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2122049), // Rule ID 58703 //
     /* 2122009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122012 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2122015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2122029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122048 */     // GIR_Coverage, 58703,
     /* 2122048 */     GIR_EraseRootFromParent_Done,
     /* 2122049 */   // Label 28330: @2122049
     /* 2122049 */   GIM_Reject,
     /* 2122050 */ // Label 28328: @2122050
     /* 2122050 */ GIM_Reject,
     /* 2122051 */ // Label 28272: @2122051
     /* 2122051 */ GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2122165),
     /* 2122056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2122059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2122062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122074 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2122119), // Rule ID 58730 //
     /* 2122079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122082 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2122085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2122099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122118 */     // GIR_Coverage, 58730,
     /* 2122118 */     GIR_EraseRootFromParent_Done,
     /* 2122119 */   // Label 28332: @2122119
     /* 2122119 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2122164), // Rule ID 58731 //
     /* 2122124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122127 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2122130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2122144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122163 */     // GIR_Coverage, 58731,
     /* 2122163 */     GIR_EraseRootFromParent_Done,
     /* 2122164 */   // Label 28333: @2122164
     /* 2122164 */   GIM_Reject,
     /* 2122165 */ // Label 28331: @2122165
     /* 2122165 */ GIM_Reject,
     /* 2122166 */ // Label 28273: @2122166
     /* 2122166 */ GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2122280),
     /* 2122171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2122174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122189 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2122234), // Rule ID 58746 //
     /* 2122194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122197 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2122200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122233 */     // GIR_Coverage, 58746,
     /* 2122233 */     GIR_EraseRootFromParent_Done,
     /* 2122234 */   // Label 28335: @2122234
     /* 2122234 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2122279), // Rule ID 58747 //
     /* 2122239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122242 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2122245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122278 */     // GIR_Coverage, 58747,
     /* 2122278 */     GIR_EraseRootFromParent_Done,
     /* 2122279 */   // Label 28336: @2122279
     /* 2122279 */   GIM_Reject,
     /* 2122280 */ // Label 28334: @2122280
     /* 2122280 */ GIM_Reject,
     /* 2122281 */ // Label 28274: @2122281
     /* 2122281 */ GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2122395),
     /* 2122286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2122289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122304 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2122349), // Rule ID 58762 //
     /* 2122309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2122312 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2122315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122348 */     // GIR_Coverage, 58762,
     /* 2122348 */     GIR_EraseRootFromParent_Done,
     /* 2122349 */   // Label 28338: @2122349
     /* 2122349 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2122394), // Rule ID 58763 //
     /* 2122354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2122357 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2122360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122393 */     // GIR_Coverage, 58763,
     /* 2122393 */     GIR_EraseRootFromParent_Done,
     /* 2122394 */   // Label 28339: @2122394
     /* 2122394 */   GIM_Reject,
     /* 2122395 */ // Label 28337: @2122395
     /* 2122395 */ GIM_Reject,
     /* 2122396 */ // Label 28275: @2122396
     /* 2122396 */ GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2122510),
     /* 2122401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2122404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2122407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122419 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2122464), // Rule ID 58718 //
     /* 2122424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122427 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2122430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2122444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122463 */     // GIR_Coverage, 58718,
     /* 2122463 */     GIR_EraseRootFromParent_Done,
     /* 2122464 */   // Label 28341: @2122464
     /* 2122464 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2122509), // Rule ID 58719 //
     /* 2122469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122472 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2122475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2122489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122508 */     // GIR_Coverage, 58719,
     /* 2122508 */     GIR_EraseRootFromParent_Done,
     /* 2122509 */   // Label 28342: @2122509
     /* 2122509 */   GIM_Reject,
     /* 2122510 */ // Label 28340: @2122510
     /* 2122510 */ GIM_Reject,
     /* 2122511 */ // Label 28276: @2122511
     /* 2122511 */ GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2122625),
     /* 2122516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2122519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2122522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122534 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2122579), // Rule ID 58734 //
     /* 2122539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122542 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2122545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122578 */     // GIR_Coverage, 58734,
     /* 2122578 */     GIR_EraseRootFromParent_Done,
     /* 2122579 */   // Label 28344: @2122579
     /* 2122579 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2122624), // Rule ID 58735 //
     /* 2122584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122587 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2122590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122623 */     // GIR_Coverage, 58735,
     /* 2122623 */     GIR_EraseRootFromParent_Done,
     /* 2122624 */   // Label 28345: @2122624
     /* 2122624 */   GIM_Reject,
     /* 2122625 */ // Label 28343: @2122625
     /* 2122625 */ GIM_Reject,
     /* 2122626 */ // Label 28277: @2122626
     /* 2122626 */ GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2122740),
     /* 2122631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2122634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122649 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2122694), // Rule ID 58750 //
     /* 2122654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122657 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2122660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122693 */     // GIR_Coverage, 58750,
     /* 2122693 */     GIR_EraseRootFromParent_Done,
     /* 2122694 */   // Label 28347: @2122694
     /* 2122694 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2122739), // Rule ID 58751 //
     /* 2122699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122702 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2122705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122738 */     // GIR_Coverage, 58751,
     /* 2122738 */     GIR_EraseRootFromParent_Done,
     /* 2122739 */   // Label 28348: @2122739
     /* 2122739 */   GIM_Reject,
     /* 2122740 */ // Label 28346: @2122740
     /* 2122740 */ GIM_Reject,
     /* 2122741 */ // Label 28278: @2122741
     /* 2122741 */ GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2122855),
     /* 2122746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2122749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2122752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122764 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2122809), // Rule ID 58722 //
     /* 2122769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122772 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2122775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122808 */     // GIR_Coverage, 58722,
     /* 2122808 */     GIR_EraseRootFromParent_Done,
     /* 2122809 */   // Label 28350: @2122809
     /* 2122809 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2122854), // Rule ID 58723 //
     /* 2122814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122817 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2122820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2122834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122853 */     // GIR_Coverage, 58723,
     /* 2122853 */     GIR_EraseRootFromParent_Done,
     /* 2122854 */   // Label 28351: @2122854
     /* 2122854 */   GIM_Reject,
     /* 2122855 */ // Label 28349: @2122855
     /* 2122855 */ GIM_Reject,
     /* 2122856 */ // Label 28279: @2122856
     /* 2122856 */ GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2122970),
     /* 2122861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2122864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2122867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122879 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2122924), // Rule ID 58738 //
     /* 2122884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2122887 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2122887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2122890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122923 */     // GIR_Coverage, 58738,
     /* 2122923 */     GIR_EraseRootFromParent_Done,
     /* 2122924 */   // Label 28353: @2122924
     /* 2122924 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2122969), // Rule ID 58739 //
     /* 2122929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2122932 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2122932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2122935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2122939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2122944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2122946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2122949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2122954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2122956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2122958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2122961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2122967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122968 */     // GIR_Coverage, 58739,
     /* 2122968 */     GIR_EraseRootFromParent_Done,
     /* 2122969 */   // Label 28354: @2122969
     /* 2122969 */   GIM_Reject,
     /* 2122970 */ // Label 28352: @2122970
     /* 2122970 */ GIM_Reject,
     /* 2122971 */ // Label 28280: @2122971
     /* 2122971 */ GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2123085),
     /* 2122976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2122979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2122982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122994 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2123039), // Rule ID 58726 //
     /* 2122999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2123002 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2123005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2123019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123038 */     // GIR_Coverage, 58726,
     /* 2123038 */     GIR_EraseRootFromParent_Done,
     /* 2123039 */   // Label 28356: @2123039
     /* 2123039 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2123084), // Rule ID 58727 //
     /* 2123044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2123047 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2123047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2123050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2123064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123083 */     // GIR_Coverage, 58727,
     /* 2123083 */     GIR_EraseRootFromParent_Done,
     /* 2123084 */   // Label 28357: @2123084
     /* 2123084 */   GIM_Reject,
     /* 2123085 */ // Label 28355: @2123085
     /* 2123085 */ GIM_Reject,
     /* 2123086 */ // Label 28281: @2123086
     /* 2123086 */ GIM_Reject,
     /* 2123087 */ // Label 47: @2123087
     /* 2123087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28382*/ GIMT_Encode4(2125996),
     /* 2123098 */ /*GILLT_s32*//*Label 28358*/ GIMT_Encode4(2123222),
     /* 2123102 */ /*GILLT_s64*//*Label 28359*/ GIMT_Encode4(2123344), GIMT_Encode4(0),
     /* 2123110 */ /*GILLT_nxv1s8*//*Label 28360*/ GIMT_Encode4(2123466),
     /* 2123114 */ /*GILLT_nxv1s16*//*Label 28361*/ GIMT_Encode4(2123581),
     /* 2123118 */ /*GILLT_nxv1s32*//*Label 28362*/ GIMT_Encode4(2123696),
     /* 2123122 */ /*GILLT_nxv1s64*//*Label 28363*/ GIMT_Encode4(2123811), GIMT_Encode4(0),
     /* 2123130 */ /*GILLT_nxv2s8*//*Label 28364*/ GIMT_Encode4(2123926),
     /* 2123134 */ /*GILLT_nxv2s16*//*Label 28365*/ GIMT_Encode4(2124041),
     /* 2123138 */ /*GILLT_nxv2s32*//*Label 28366*/ GIMT_Encode4(2124156),
     /* 2123142 */ /*GILLT_nxv2s64*//*Label 28367*/ GIMT_Encode4(2124271), GIMT_Encode4(0),
     /* 2123150 */ /*GILLT_nxv4s8*//*Label 28368*/ GIMT_Encode4(2124386),
     /* 2123154 */ /*GILLT_nxv4s16*//*Label 28369*/ GIMT_Encode4(2124501),
     /* 2123158 */ /*GILLT_nxv4s32*//*Label 28370*/ GIMT_Encode4(2124616),
     /* 2123162 */ /*GILLT_nxv4s64*//*Label 28371*/ GIMT_Encode4(2124731), GIMT_Encode4(0),
     /* 2123170 */ /*GILLT_nxv8s8*//*Label 28372*/ GIMT_Encode4(2124846),
     /* 2123174 */ /*GILLT_nxv8s16*//*Label 28373*/ GIMT_Encode4(2124961),
     /* 2123178 */ /*GILLT_nxv8s32*//*Label 28374*/ GIMT_Encode4(2125076),
     /* 2123182 */ /*GILLT_nxv8s64*//*Label 28375*/ GIMT_Encode4(2125191), GIMT_Encode4(0),
     /* 2123190 */ /*GILLT_nxv16s8*//*Label 28376*/ GIMT_Encode4(2125306),
     /* 2123194 */ /*GILLT_nxv16s16*//*Label 28377*/ GIMT_Encode4(2125421),
     /* 2123198 */ /*GILLT_nxv16s32*//*Label 28378*/ GIMT_Encode4(2125536), GIMT_Encode4(0),
     /* 2123206 */ /*GILLT_nxv32s8*//*Label 28379*/ GIMT_Encode4(2125651),
     /* 2123210 */ /*GILLT_nxv32s16*//*Label 28380*/ GIMT_Encode4(2125766), GIMT_Encode4(0),
     /* 2123218 */ /*GILLT_nxv64s8*//*Label 28381*/ GIMT_Encode4(2125881),
     /* 2123222 */ // Label 28358: @2123222
     /* 2123222 */ GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2123343),
     /* 2123227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2123230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2123233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2123237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2123241 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2123277), // Rule ID 2323 //
     /* 2123246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2123249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2123253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2123257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2123261 */     // MIs[1] Operand 1
     /* 2123261 */     // No operand predicates
     /* 2123261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2123263 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2123263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2123266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123270 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2123275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123276 */     // GIR_Coverage, 2323,
     /* 2123276 */     GIR_EraseRootFromParent_Done,
     /* 2123277 */   // Label 28384: @2123277
     /* 2123277 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2123313), // Rule ID 61863 //
     /* 2123282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2123285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2123289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2123293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2123297 */     // MIs[1] Operand 1
     /* 2123297 */     // No operand predicates
     /* 2123297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2123299 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2123299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2123302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123306 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2123311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123312 */     // GIR_Coverage, 61863,
     /* 2123312 */     GIR_EraseRootFromParent_Done,
     /* 2123313 */   // Label 28385: @2123313
     /* 2123313 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2123342), // Rule ID 2317 //
     /* 2123318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2123321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2123328 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2123328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2123331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2123340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123341 */     // GIR_Coverage, 2317,
     /* 2123341 */     GIR_EraseRootFromParent_Done,
     /* 2123342 */   // Label 28386: @2123342
     /* 2123342 */   GIM_Reject,
     /* 2123343 */ // Label 28383: @2123343
     /* 2123343 */ GIM_Reject,
     /* 2123344 */ // Label 28359: @2123344
     /* 2123344 */ GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2123465),
     /* 2123349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2123352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2123355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2123359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2123363 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2123399), // Rule ID 2322 //
     /* 2123368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2123371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2123375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2123379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2123383 */     // MIs[1] Operand 1
     /* 2123383 */     // No operand predicates
     /* 2123383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2123385 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2123385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2123388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123392 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2123397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123398 */     // GIR_Coverage, 2322,
     /* 2123398 */     GIR_EraseRootFromParent_Done,
     /* 2123399 */   // Label 28388: @2123399
     /* 2123399 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2123435), // Rule ID 61862 //
     /* 2123404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2123407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2123411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2123415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2123419 */     // MIs[1] Operand 1
     /* 2123419 */     // No operand predicates
     /* 2123419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2123421 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2123421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2123424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123428 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2123433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123434 */     // GIR_Coverage, 61862,
     /* 2123434 */     GIR_EraseRootFromParent_Done,
     /* 2123435 */   // Label 28389: @2123435
     /* 2123435 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2123464), // Rule ID 2316 //
     /* 2123440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2123443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2123450 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2123450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2123453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2123462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123463 */     // GIR_Coverage, 2316,
     /* 2123463 */     GIR_EraseRootFromParent_Done,
     /* 2123464 */   // Label 28390: @2123464
     /* 2123464 */   GIM_Reject,
     /* 2123465 */ // Label 28387: @2123465
     /* 2123465 */ GIM_Reject,
     /* 2123466 */ // Label 28360: @2123466
     /* 2123466 */ GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2123580),
     /* 2123471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2123474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2123477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123489 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2123534), // Rule ID 58546 //
     /* 2123494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2123497 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2123500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2123514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123533 */     // GIR_Coverage, 58546,
     /* 2123533 */     GIR_EraseRootFromParent_Done,
     /* 2123534 */   // Label 28392: @2123534
     /* 2123534 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2123579), // Rule ID 58547 //
     /* 2123539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2123542 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2123542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2123545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2123559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123578 */     // GIR_Coverage, 58547,
     /* 2123578 */     GIR_EraseRootFromParent_Done,
     /* 2123579 */   // Label 28393: @2123579
     /* 2123579 */   GIM_Reject,
     /* 2123580 */ // Label 28391: @2123580
     /* 2123580 */ GIM_Reject,
     /* 2123581 */ // Label 28361: @2123581
     /* 2123581 */ GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2123695),
     /* 2123586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2123589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2123592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123604 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2123649), // Rule ID 58558 //
     /* 2123609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2123612 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2123615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2123629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123648 */     // GIR_Coverage, 58558,
     /* 2123648 */     GIR_EraseRootFromParent_Done,
     /* 2123649 */   // Label 28395: @2123649
     /* 2123649 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2123694), // Rule ID 58559 //
     /* 2123654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2123657 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2123657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2123660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2123674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123693 */     // GIR_Coverage, 58559,
     /* 2123693 */     GIR_EraseRootFromParent_Done,
     /* 2123694 */   // Label 28396: @2123694
     /* 2123694 */   GIM_Reject,
     /* 2123695 */ // Label 28394: @2123695
     /* 2123695 */ GIM_Reject,
     /* 2123696 */ // Label 28362: @2123696
     /* 2123696 */ GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2123810),
     /* 2123701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2123704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123719 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2123764), // Rule ID 58566 //
     /* 2123724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2123727 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2123730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2123744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123763 */     // GIR_Coverage, 58566,
     /* 2123763 */     GIR_EraseRootFromParent_Done,
     /* 2123764 */   // Label 28398: @2123764
     /* 2123764 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2123809), // Rule ID 58567 //
     /* 2123769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2123772 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2123772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2123775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2123789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123808 */     // GIR_Coverage, 58567,
     /* 2123808 */     GIR_EraseRootFromParent_Done,
     /* 2123809 */   // Label 28399: @2123809
     /* 2123809 */   GIM_Reject,
     /* 2123810 */ // Label 28397: @2123810
     /* 2123810 */ GIM_Reject,
     /* 2123811 */ // Label 28363: @2123811
     /* 2123811 */ GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2123925),
     /* 2123816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2123819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123834 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2123879), // Rule ID 58582 //
     /* 2123839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2123842 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2123845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2123859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123878 */     // GIR_Coverage, 58582,
     /* 2123878 */     GIR_EraseRootFromParent_Done,
     /* 2123879 */   // Label 28401: @2123879
     /* 2123879 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2123924), // Rule ID 58583 //
     /* 2123884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2123887 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2123887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2123890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2123904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123923 */     // GIR_Coverage, 58583,
     /* 2123923 */     GIR_EraseRootFromParent_Done,
     /* 2123924 */   // Label 28402: @2123924
     /* 2123924 */   GIM_Reject,
     /* 2123925 */ // Label 28400: @2123925
     /* 2123925 */ GIM_Reject,
     /* 2123926 */ // Label 28364: @2123926
     /* 2123926 */ GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2124040),
     /* 2123931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2123934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2123937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123949 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2123994), // Rule ID 58550 //
     /* 2123954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2123957 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2123957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2123960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2123964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2123969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2123971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2123974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2123979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2123981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2123983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2123986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2123992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123993 */     // GIR_Coverage, 58550,
     /* 2123993 */     GIR_EraseRootFromParent_Done,
     /* 2123994 */   // Label 28404: @2123994
     /* 2123994 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2124039), // Rule ID 58551 //
     /* 2123999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124002 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2124005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2124019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124038 */     // GIR_Coverage, 58551,
     /* 2124038 */     GIR_EraseRootFromParent_Done,
     /* 2124039 */   // Label 28405: @2124039
     /* 2124039 */   GIM_Reject,
     /* 2124040 */ // Label 28403: @2124040
     /* 2124040 */ GIM_Reject,
     /* 2124041 */ // Label 28365: @2124041
     /* 2124041 */ GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2124155),
     /* 2124046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2124049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2124052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124064 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2124109), // Rule ID 58562 //
     /* 2124069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124072 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2124075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2124089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124108 */     // GIR_Coverage, 58562,
     /* 2124108 */     GIR_EraseRootFromParent_Done,
     /* 2124109 */   // Label 28407: @2124109
     /* 2124109 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2124154), // Rule ID 58563 //
     /* 2124114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124117 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2124120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2124134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124153 */     // GIR_Coverage, 58563,
     /* 2124153 */     GIR_EraseRootFromParent_Done,
     /* 2124154 */   // Label 28408: @2124154
     /* 2124154 */   GIM_Reject,
     /* 2124155 */ // Label 28406: @2124155
     /* 2124155 */ GIM_Reject,
     /* 2124156 */ // Label 28366: @2124156
     /* 2124156 */ GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2124270),
     /* 2124161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2124164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124179 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2124224), // Rule ID 58578 //
     /* 2124184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124187 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2124190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124223 */     // GIR_Coverage, 58578,
     /* 2124223 */     GIR_EraseRootFromParent_Done,
     /* 2124224 */   // Label 28410: @2124224
     /* 2124224 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2124269), // Rule ID 58579 //
     /* 2124229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124232 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2124235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124268 */     // GIR_Coverage, 58579,
     /* 2124268 */     GIR_EraseRootFromParent_Done,
     /* 2124269 */   // Label 28411: @2124269
     /* 2124269 */   GIM_Reject,
     /* 2124270 */ // Label 28409: @2124270
     /* 2124270 */ GIM_Reject,
     /* 2124271 */ // Label 28367: @2124271
     /* 2124271 */ GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2124385),
     /* 2124276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2124279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124294 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2124339), // Rule ID 58622 //
     /* 2124299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2124302 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2124305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2124319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124338 */     // GIR_Coverage, 58622,
     /* 2124338 */     GIR_EraseRootFromParent_Done,
     /* 2124339 */   // Label 28413: @2124339
     /* 2124339 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2124384), // Rule ID 58623 //
     /* 2124344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2124347 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2124350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2124364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124383 */     // GIR_Coverage, 58623,
     /* 2124383 */     GIR_EraseRootFromParent_Done,
     /* 2124384 */   // Label 28414: @2124384
     /* 2124384 */   GIM_Reject,
     /* 2124385 */ // Label 28412: @2124385
     /* 2124385 */ GIM_Reject,
     /* 2124386 */ // Label 28368: @2124386
     /* 2124386 */ GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2124500),
     /* 2124391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2124394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2124397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124409 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2124454), // Rule ID 58554 //
     /* 2124414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124417 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2124420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124453 */     // GIR_Coverage, 58554,
     /* 2124453 */     GIR_EraseRootFromParent_Done,
     /* 2124454 */   // Label 28416: @2124454
     /* 2124454 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2124499), // Rule ID 58555 //
     /* 2124459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124462 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2124465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2124479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124498 */     // GIR_Coverage, 58555,
     /* 2124498 */     GIR_EraseRootFromParent_Done,
     /* 2124499 */   // Label 28417: @2124499
     /* 2124499 */   GIM_Reject,
     /* 2124500 */ // Label 28415: @2124500
     /* 2124500 */ GIM_Reject,
     /* 2124501 */ // Label 28369: @2124501
     /* 2124501 */ GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2124615),
     /* 2124506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2124509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2124512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124524 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2124569), // Rule ID 58574 //
     /* 2124529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124532 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2124535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124568 */     // GIR_Coverage, 58574,
     /* 2124568 */     GIR_EraseRootFromParent_Done,
     /* 2124569 */   // Label 28419: @2124569
     /* 2124569 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2124614), // Rule ID 58575 //
     /* 2124574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124577 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2124580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124613 */     // GIR_Coverage, 58575,
     /* 2124613 */     GIR_EraseRootFromParent_Done,
     /* 2124614 */   // Label 28420: @2124614
     /* 2124614 */   GIM_Reject,
     /* 2124615 */ // Label 28418: @2124615
     /* 2124615 */ GIM_Reject,
     /* 2124616 */ // Label 28370: @2124616
     /* 2124616 */ GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2124730),
     /* 2124621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2124624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124639 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2124684), // Rule ID 58610 //
     /* 2124644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124647 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2124650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2124664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124683 */     // GIR_Coverage, 58610,
     /* 2124683 */     GIR_EraseRootFromParent_Done,
     /* 2124684 */   // Label 28422: @2124684
     /* 2124684 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2124729), // Rule ID 58611 //
     /* 2124689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124692 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2124695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2124709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124728 */     // GIR_Coverage, 58611,
     /* 2124728 */     GIR_EraseRootFromParent_Done,
     /* 2124729 */   // Label 28423: @2124729
     /* 2124729 */   GIM_Reject,
     /* 2124730 */ // Label 28421: @2124730
     /* 2124730 */ GIM_Reject,
     /* 2124731 */ // Label 28371: @2124731
     /* 2124731 */ GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2124845),
     /* 2124736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2124739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124754 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2124799), // Rule ID 58626 //
     /* 2124759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2124762 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2124765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2124779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124798 */     // GIR_Coverage, 58626,
     /* 2124798 */     GIR_EraseRootFromParent_Done,
     /* 2124799 */   // Label 28425: @2124799
     /* 2124799 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2124844), // Rule ID 58627 //
     /* 2124804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2124807 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2124810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2124824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124843 */     // GIR_Coverage, 58627,
     /* 2124843 */     GIR_EraseRootFromParent_Done,
     /* 2124844 */   // Label 28426: @2124844
     /* 2124844 */   GIM_Reject,
     /* 2124845 */ // Label 28424: @2124845
     /* 2124845 */ GIM_Reject,
     /* 2124846 */ // Label 28372: @2124846
     /* 2124846 */ GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2124960),
     /* 2124851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2124854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2124857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124869 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2124914), // Rule ID 58570 //
     /* 2124874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124877 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2124880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124913 */     // GIR_Coverage, 58570,
     /* 2124913 */     GIR_EraseRootFromParent_Done,
     /* 2124914 */   // Label 28428: @2124914
     /* 2124914 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2124959), // Rule ID 58571 //
     /* 2124919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2124922 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2124922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2124925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2124934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2124936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2124939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2124944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2124946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2124948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2124951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2124957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124958 */     // GIR_Coverage, 58571,
     /* 2124958 */     GIR_EraseRootFromParent_Done,
     /* 2124959 */   // Label 28429: @2124959
     /* 2124959 */   GIM_Reject,
     /* 2124960 */ // Label 28427: @2124960
     /* 2124960 */ GIM_Reject,
     /* 2124961 */ // Label 28373: @2124961
     /* 2124961 */ GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2125075),
     /* 2124966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2124969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2124972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124984 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2125029), // Rule ID 58598 //
     /* 2124989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2124992 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2124992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2124995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2124999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2125009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125028 */     // GIR_Coverage, 58598,
     /* 2125028 */     GIR_EraseRootFromParent_Done,
     /* 2125029 */   // Label 28431: @2125029
     /* 2125029 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2125074), // Rule ID 58599 //
     /* 2125034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125037 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2125040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2125054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125073 */     // GIR_Coverage, 58599,
     /* 2125073 */     GIR_EraseRootFromParent_Done,
     /* 2125074 */   // Label 28432: @2125074
     /* 2125074 */   GIM_Reject,
     /* 2125075 */ // Label 28430: @2125075
     /* 2125075 */ GIM_Reject,
     /* 2125076 */ // Label 28374: @2125076
     /* 2125076 */ GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2125190),
     /* 2125081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2125084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2125087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125099 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2125144), // Rule ID 58614 //
     /* 2125104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125107 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2125110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125143 */     // GIR_Coverage, 58614,
     /* 2125143 */     GIR_EraseRootFromParent_Done,
     /* 2125144 */   // Label 28434: @2125144
     /* 2125144 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2125189), // Rule ID 58615 //
     /* 2125149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125152 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2125155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125188 */     // GIR_Coverage, 58615,
     /* 2125188 */     GIR_EraseRootFromParent_Done,
     /* 2125189 */   // Label 28435: @2125189
     /* 2125189 */   GIM_Reject,
     /* 2125190 */ // Label 28433: @2125190
     /* 2125190 */ GIM_Reject,
     /* 2125191 */ // Label 28375: @2125191
     /* 2125191 */ GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2125305),
     /* 2125196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2125199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125214 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2125259), // Rule ID 58630 //
     /* 2125219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2125222 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2125225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125258 */     // GIR_Coverage, 58630,
     /* 2125258 */     GIR_EraseRootFromParent_Done,
     /* 2125259 */   // Label 28437: @2125259
     /* 2125259 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2125304), // Rule ID 58631 //
     /* 2125264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2125267 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2125270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125303 */     // GIR_Coverage, 58631,
     /* 2125303 */     GIR_EraseRootFromParent_Done,
     /* 2125304 */   // Label 28438: @2125304
     /* 2125304 */   GIM_Reject,
     /* 2125305 */ // Label 28436: @2125305
     /* 2125305 */ GIM_Reject,
     /* 2125306 */ // Label 28376: @2125306
     /* 2125306 */ GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2125420),
     /* 2125311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2125314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2125317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125329 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2125374), // Rule ID 58586 //
     /* 2125334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125337 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2125340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2125354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125373 */     // GIR_Coverage, 58586,
     /* 2125373 */     GIR_EraseRootFromParent_Done,
     /* 2125374 */   // Label 28440: @2125374
     /* 2125374 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2125419), // Rule ID 58587 //
     /* 2125379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125382 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2125385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2125399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125418 */     // GIR_Coverage, 58587,
     /* 2125418 */     GIR_EraseRootFromParent_Done,
     /* 2125419 */   // Label 28441: @2125419
     /* 2125419 */   GIM_Reject,
     /* 2125420 */ // Label 28439: @2125420
     /* 2125420 */ GIM_Reject,
     /* 2125421 */ // Label 28377: @2125421
     /* 2125421 */ GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2125535),
     /* 2125426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2125429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2125432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125444 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2125489), // Rule ID 58602 //
     /* 2125449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125452 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2125455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125488 */     // GIR_Coverage, 58602,
     /* 2125488 */     GIR_EraseRootFromParent_Done,
     /* 2125489 */   // Label 28443: @2125489
     /* 2125489 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2125534), // Rule ID 58603 //
     /* 2125494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125497 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2125500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125533 */     // GIR_Coverage, 58603,
     /* 2125533 */     GIR_EraseRootFromParent_Done,
     /* 2125534 */   // Label 28444: @2125534
     /* 2125534 */   GIM_Reject,
     /* 2125535 */ // Label 28442: @2125535
     /* 2125535 */ GIM_Reject,
     /* 2125536 */ // Label 28378: @2125536
     /* 2125536 */ GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2125650),
     /* 2125541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2125544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2125547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125559 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2125604), // Rule ID 58618 //
     /* 2125564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125567 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2125570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125603 */     // GIR_Coverage, 58618,
     /* 2125603 */     GIR_EraseRootFromParent_Done,
     /* 2125604 */   // Label 28446: @2125604
     /* 2125604 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2125649), // Rule ID 58619 //
     /* 2125609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125612 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2125615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125648 */     // GIR_Coverage, 58619,
     /* 2125648 */     GIR_EraseRootFromParent_Done,
     /* 2125649 */   // Label 28447: @2125649
     /* 2125649 */   GIM_Reject,
     /* 2125650 */ // Label 28445: @2125650
     /* 2125650 */ GIM_Reject,
     /* 2125651 */ // Label 28379: @2125651
     /* 2125651 */ GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2125765),
     /* 2125656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2125659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2125662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125674 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2125719), // Rule ID 58590 //
     /* 2125679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125682 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2125685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125718 */     // GIR_Coverage, 58590,
     /* 2125718 */     GIR_EraseRootFromParent_Done,
     /* 2125719 */   // Label 28449: @2125719
     /* 2125719 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2125764), // Rule ID 58591 //
     /* 2125724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125727 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2125730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2125744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125763 */     // GIR_Coverage, 58591,
     /* 2125763 */     GIR_EraseRootFromParent_Done,
     /* 2125764 */   // Label 28450: @2125764
     /* 2125764 */   GIM_Reject,
     /* 2125765 */ // Label 28448: @2125765
     /* 2125765 */ GIM_Reject,
     /* 2125766 */ // Label 28380: @2125766
     /* 2125766 */ GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2125880),
     /* 2125771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2125774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2125777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125789 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2125834), // Rule ID 58606 //
     /* 2125794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125797 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2125800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125833 */     // GIR_Coverage, 58606,
     /* 2125833 */     GIR_EraseRootFromParent_Done,
     /* 2125834 */   // Label 28452: @2125834
     /* 2125834 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2125879), // Rule ID 58607 //
     /* 2125839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125842 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2125845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125878 */     // GIR_Coverage, 58607,
     /* 2125878 */     GIR_EraseRootFromParent_Done,
     /* 2125879 */   // Label 28453: @2125879
     /* 2125879 */   GIM_Reject,
     /* 2125880 */ // Label 28451: @2125880
     /* 2125880 */ GIM_Reject,
     /* 2125881 */ // Label 28381: @2125881
     /* 2125881 */ GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2125995),
     /* 2125886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2125889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2125892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125904 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2125949), // Rule ID 58594 //
     /* 2125909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2125912 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2125912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2125915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125948 */     // GIR_Coverage, 58594,
     /* 2125948 */     GIR_EraseRootFromParent_Done,
     /* 2125949 */   // Label 28455: @2125949
     /* 2125949 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2125994), // Rule ID 58595 //
     /* 2125954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2125957 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2125957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2125960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2125964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2125969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2125971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2125974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2125979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2125981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2125983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2125986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2125992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125993 */     // GIR_Coverage, 58595,
     /* 2125993 */     GIR_EraseRootFromParent_Done,
     /* 2125994 */   // Label 28456: @2125994
     /* 2125994 */   GIM_Reject,
     /* 2125995 */ // Label 28454: @2125995
     /* 2125995 */ GIM_Reject,
     /* 2125996 */ // Label 28382: @2125996
     /* 2125996 */ GIM_Reject,
     /* 2125997 */ // Label 48: @2125997
     /* 2125997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 28466*/ GIMT_Encode4(2152659),
     /* 2126008 */ /*GILLT_s32*//*Label 28457*/ GIMT_Encode4(2126128),
     /* 2126012 */ /*GILLT_s64*//*Label 28458*/ GIMT_Encode4(2128922),
     /* 2126016 */ /*GILLT_nxv1s1*//*Label 28459*/ GIMT_Encode4(2131716), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126036 */ /*GILLT_nxv2s1*//*Label 28460*/ GIMT_Encode4(2135557), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126056 */ /*GILLT_nxv4s1*//*Label 28461*/ GIMT_Encode4(2139398), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126076 */ /*GILLT_nxv8s1*//*Label 28462*/ GIMT_Encode4(2143239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126096 */ /*GILLT_nxv16s1*//*Label 28463*/ GIMT_Encode4(2147080), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126112 */ /*GILLT_nxv32s1*//*Label 28464*/ GIMT_Encode4(2149961), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2126124 */ /*GILLT_nxv64s1*//*Label 28465*/ GIMT_Encode4(2151882),
     /* 2126128 */ // Label 28457: @2126128
     /* 2126128 */ GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2126171), // Rule ID 159 //
     /* 2126133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126146 */   // MIs[0] Operand 1
     /* 2126146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2126151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126155 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2126159 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2126159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2126169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126170 */   // GIR_Coverage, 159,
     /* 2126170 */   GIR_EraseRootFromParent_Done,
     /* 2126171 */ // Label 28467: @2126171
     /* 2126171 */ GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2126214), // Rule ID 63854 //
     /* 2126176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2126185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126189 */   // MIs[0] Operand 1
     /* 2126189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2126194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126198 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2126202 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2126202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126207 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126213 */   // GIR_Coverage, 63854,
     /* 2126213 */   GIR_EraseRootFromParent_Done,
     /* 2126214 */ // Label 28468: @2126214
     /* 2126214 */ GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2126260), // Rule ID 63860 //
     /* 2126219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2126228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126232 */   // MIs[0] Operand 1
     /* 2126232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2126237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126241 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2126245 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2126245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2126248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126250 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2126256 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126259 */   // GIR_Coverage, 63860,
     /* 2126259 */   GIR_EraseRootFromParent_Done,
     /* 2126260 */ // Label 28469: @2126260
     /* 2126260 */ GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2126303), // Rule ID 63890 //
     /* 2126265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126278 */   // MIs[0] Operand 1
     /* 2126278 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2126283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126287 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2126291 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2126291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126296 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126302 */   // GIR_Coverage, 63890,
     /* 2126302 */   GIR_EraseRootFromParent_Done,
     /* 2126303 */ // Label 28470: @2126303
     /* 2126303 */ GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2126349), // Rule ID 63896 //
     /* 2126308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126321 */   // MIs[0] Operand 1
     /* 2126321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2126326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126330 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2126334 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2126334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2126337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126339 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2126345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126348 */   // GIR_Coverage, 63896,
     /* 2126348 */   GIR_EraseRootFromParent_Done,
     /* 2126349 */ // Label 28471: @2126349
     /* 2126349 */ GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2126402), // Rule ID 149 //
     /* 2126354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126367 */   // MIs[0] Operand 1
     /* 2126367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2126372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126384 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126388 */   // MIs[1] Operand 1
     /* 2126388 */   // No operand predicates
     /* 2126388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126390 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2126390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2126393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126397 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2126400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126401 */   // GIR_Coverage, 149,
     /* 2126401 */   GIR_EraseRootFromParent_Done,
     /* 2126402 */ // Label 28472: @2126402
     /* 2126402 */ GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2126455), // Rule ID 153 //
     /* 2126407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126420 */   // MIs[0] Operand 1
     /* 2126420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2126425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126437 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126441 */   // MIs[1] Operand 1
     /* 2126441 */   // No operand predicates
     /* 2126441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126443 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2126443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126448 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126450 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2126453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126454 */   // GIR_Coverage, 153,
     /* 2126454 */   GIR_EraseRootFromParent_Done,
     /* 2126455 */ // Label 28473: @2126455
     /* 2126455 */ GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2126508), // Rule ID 63846 //
     /* 2126460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126473 */   // MIs[0] Operand 1
     /* 2126473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2126478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126490 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126494 */   // MIs[1] Operand 1
     /* 2126494 */   // No operand predicates
     /* 2126494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126496 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2126496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126503 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2126506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126507 */   // GIR_Coverage, 63846,
     /* 2126507 */   GIR_EraseRootFromParent_Done,
     /* 2126508 */ // Label 28474: @2126508
     /* 2126508 */ GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2126561), // Rule ID 63850 //
     /* 2126513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126526 */   // MIs[0] Operand 1
     /* 2126526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2126531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126543 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126547 */   // MIs[1] Operand 1
     /* 2126547 */   // No operand predicates
     /* 2126547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126549 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2126549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2126552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2126556 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2126559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126560 */   // GIR_Coverage, 63850,
     /* 2126560 */   GIR_EraseRootFromParent_Done,
     /* 2126561 */ // Label 28475: @2126561
     /* 2126561 */ GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2126638), // Rule ID 63856 //
     /* 2126566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126579 */   // MIs[0] Operand 1
     /* 2126579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2126584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126596 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2126600 */   // MIs[1] Operand 1
     /* 2126600 */   // No operand predicates
     /* 2126600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126602 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2126602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2126609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2126614 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2126618 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2126623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2126625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2126633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126637 */   // GIR_Coverage, 63856,
     /* 2126637 */   GIR_EraseRootFromParent_Done,
     /* 2126638 */ // Label 28476: @2126638
     /* 2126638 */ GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2126718), // Rule ID 63862 //
     /* 2126643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126656 */   // MIs[0] Operand 1
     /* 2126656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2126661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126673 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2126677 */   // MIs[1] Operand 1
     /* 2126677 */   // No operand predicates
     /* 2126677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126679 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2126679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2126686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2126691 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2126695 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2126700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2126702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2126705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126707 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2126713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2126716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126717 */   // GIR_Coverage, 63862,
     /* 2126717 */   GIR_EraseRootFromParent_Done,
     /* 2126718 */ // Label 28477: @2126718
     /* 2126718 */ GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2126795), // Rule ID 63866 //
     /* 2126723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126729 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126736 */   // MIs[0] Operand 1
     /* 2126736 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2126741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126753 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2126757 */   // MIs[1] Operand 1
     /* 2126757 */   // No operand predicates
     /* 2126757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126759 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2126759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2126771 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2126775 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2126780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2126782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2126785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2126790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126794 */   // GIR_Coverage, 63866,
     /* 2126794 */   GIR_EraseRootFromParent_Done,
     /* 2126795 */ // Label 28478: @2126795
     /* 2126795 */ GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2126872), // Rule ID 63870 //
     /* 2126800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126813 */   // MIs[0] Operand 1
     /* 2126813 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2126818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126830 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2126834 */   // MIs[1] Operand 1
     /* 2126834 */   // No operand predicates
     /* 2126834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126836 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2126836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2126843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2126848 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2126852 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2126857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2126859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2126862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2126867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126871 */   // GIR_Coverage, 63870,
     /* 2126871 */   GIR_EraseRootFromParent_Done,
     /* 2126872 */ // Label 28479: @2126872
     /* 2126872 */ GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2126947), // Rule ID 63874 //
     /* 2126877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2126883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126890 */   // MIs[0] Operand 1
     /* 2126890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2126895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126907 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126911 */   // MIs[1] Operand 1
     /* 2126911 */   // No operand predicates
     /* 2126911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126913 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2126913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2126920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2126925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2126929 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2126932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2126934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2126937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2126942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2126945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2126946 */   // GIR_Coverage, 63874,
     /* 2126946 */   GIR_EraseRootFromParent_Done,
     /* 2126947 */ // Label 28480: @2126947
     /* 2126947 */ GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2127022), // Rule ID 63878 //
     /* 2126952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2126955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2126958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2126961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126965 */   // MIs[0] Operand 1
     /* 2126965 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2126970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2126974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2126978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2126982 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2126986 */   // MIs[1] Operand 1
     /* 2126986 */   // No operand predicates
     /* 2126986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2126988 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2126988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2126991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2126995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127000 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127004 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2127007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2127012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127021 */   // GIR_Coverage, 63878,
     /* 2127021 */   GIR_EraseRootFromParent_Done,
     /* 2127022 */ // Label 28481: @2127022
     /* 2127022 */ GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2127077), // Rule ID 63882 //
     /* 2127027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2127033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127040 */   // MIs[0] Operand 1
     /* 2127040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2127045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127057 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2127061 */   // MIs[1] Operand 1
     /* 2127061 */   // No operand predicates
     /* 2127061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127063 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2127063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2127066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127068 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127070 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127076 */   // GIR_Coverage, 63882,
     /* 2127076 */   GIR_EraseRootFromParent_Done,
     /* 2127077 */ // Label 28482: @2127077
     /* 2127077 */ GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2127132), // Rule ID 63886 //
     /* 2127082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2127088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127095 */   // MIs[0] Operand 1
     /* 2127095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2127100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127112 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2127116 */   // MIs[1] Operand 1
     /* 2127116 */   // No operand predicates
     /* 2127116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127118 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2127118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2127121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127125 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127131 */   // GIR_Coverage, 63886,
     /* 2127131 */   GIR_EraseRootFromParent_Done,
     /* 2127132 */ // Label 28483: @2127132
     /* 2127132 */ GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2127209), // Rule ID 63892 //
     /* 2127137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127150 */   // MIs[0] Operand 1
     /* 2127150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2127155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127167 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2127171 */   // MIs[1] Operand 1
     /* 2127171 */   // No operand predicates
     /* 2127171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127173 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2127173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2127180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127185 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127189 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2127194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2127199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127208 */   // GIR_Coverage, 63892,
     /* 2127208 */   GIR_EraseRootFromParent_Done,
     /* 2127209 */ // Label 28484: @2127209
     /* 2127209 */ GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2127289), // Rule ID 63898 //
     /* 2127214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127227 */   // MIs[0] Operand 1
     /* 2127227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2127232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127236 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127244 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2127248 */   // MIs[1] Operand 1
     /* 2127248 */   // No operand predicates
     /* 2127248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127250 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2127250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2127257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127262 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127266 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2127271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2127276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127278 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2127284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127288 */   // GIR_Coverage, 63898,
     /* 2127288 */   GIR_EraseRootFromParent_Done,
     /* 2127289 */ // Label 28485: @2127289
     /* 2127289 */ GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2127366), // Rule ID 63902 //
     /* 2127294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127307 */   // MIs[0] Operand 1
     /* 2127307 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2127312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127324 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2127328 */   // MIs[1] Operand 1
     /* 2127328 */   // No operand predicates
     /* 2127328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127330 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2127330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2127337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127342 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127346 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2127356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127365 */   // GIR_Coverage, 63902,
     /* 2127365 */   GIR_EraseRootFromParent_Done,
     /* 2127366 */ // Label 28486: @2127366
     /* 2127366 */ GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2127443), // Rule ID 63906 //
     /* 2127371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127384 */   // MIs[0] Operand 1
     /* 2127384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2127389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127401 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2127405 */   // MIs[1] Operand 1
     /* 2127405 */   // No operand predicates
     /* 2127405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127407 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2127407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2127414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127423 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2127433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127442 */   // GIR_Coverage, 63906,
     /* 2127442 */   GIR_EraseRootFromParent_Done,
     /* 2127443 */ // Label 28487: @2127443
     /* 2127443 */ GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2127518), // Rule ID 63910 //
     /* 2127448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127461 */   // MIs[0] Operand 1
     /* 2127461 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2127466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127478 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2127482 */   // MIs[1] Operand 1
     /* 2127482 */   // No operand predicates
     /* 2127482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127484 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2127484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2127491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127496 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127500 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2127503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2127508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127517 */   // GIR_Coverage, 63910,
     /* 2127517 */   GIR_EraseRootFromParent_Done,
     /* 2127518 */ // Label 28488: @2127518
     /* 2127518 */ GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2127593), // Rule ID 63914 //
     /* 2127523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127536 */   // MIs[0] Operand 1
     /* 2127536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2127541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127553 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2127557 */   // MIs[1] Operand 1
     /* 2127557 */   // No operand predicates
     /* 2127557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127559 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2127559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2127566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2127575 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2127578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2127580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2127583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2127588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2127591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127592 */   // GIR_Coverage, 63914,
     /* 2127592 */   GIR_EraseRootFromParent_Done,
     /* 2127593 */ // Label 28489: @2127593
     /* 2127593 */ GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2127648), // Rule ID 63918 //
     /* 2127598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127611 */   // MIs[0] Operand 1
     /* 2127611 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2127616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127628 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2127632 */   // MIs[1] Operand 1
     /* 2127632 */   // No operand predicates
     /* 2127632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127634 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2127634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2127637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127641 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127647 */   // GIR_Coverage, 63918,
     /* 2127647 */   GIR_EraseRootFromParent_Done,
     /* 2127648 */ // Label 28490: @2127648
     /* 2127648 */ GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2127703), // Rule ID 63922 //
     /* 2127653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127666 */   // MIs[0] Operand 1
     /* 2127666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2127671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2127679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2127683 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2127687 */   // MIs[1] Operand 1
     /* 2127687 */   // No operand predicates
     /* 2127687 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2127689 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2127689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2127692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127694 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127696 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2127701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127702 */   // GIR_Coverage, 63922,
     /* 2127702 */   GIR_EraseRootFromParent_Done,
     /* 2127703 */ // Label 28491: @2127703
     /* 2127703 */ GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2127745), // Rule ID 63771 //
     /* 2127708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2127711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127721 */   // MIs[0] Operand 1
     /* 2127721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2127726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127734 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2127737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127744 */   // GIR_Coverage, 63771,
     /* 2127744 */   GIR_EraseRootFromParent_Done,
     /* 2127745 */ // Label 28492: @2127745
     /* 2127745 */ GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2127787), // Rule ID 63773 //
     /* 2127750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2127753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127763 */   // MIs[0] Operand 1
     /* 2127763 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2127768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127772 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127776 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2127779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127783 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127786 */   // GIR_Coverage, 63773,
     /* 2127786 */   GIR_EraseRootFromParent_Done,
     /* 2127787 */ // Label 28493: @2127787
     /* 2127787 */ GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2127829), // Rule ID 147 //
     /* 2127792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127805 */   // MIs[0] Operand 1
     /* 2127805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2127810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127814 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127818 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2127821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127825 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127828 */   // GIR_Coverage, 147,
     /* 2127828 */   GIR_EraseRootFromParent_Done,
     /* 2127829 */ // Label 28494: @2127829
     /* 2127829 */ GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2127871), // Rule ID 151 //
     /* 2127834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2127840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2127843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127847 */   // MIs[0] Operand 1
     /* 2127847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2127852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127860 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2127863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127870 */   // GIR_Coverage, 151,
     /* 2127870 */   GIR_EraseRootFromParent_Done,
     /* 2127871 */ // Label 28495: @2127871
     /* 2127871 */ GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2127913), // Rule ID 63848 //
     /* 2127876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2127882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2127885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127889 */   // MIs[0] Operand 1
     /* 2127889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2127894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127902 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2127905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127912 */   // GIR_Coverage, 63848,
     /* 2127912 */   GIR_EraseRootFromParent_Done,
     /* 2127913 */ // Label 28496: @2127913
     /* 2127913 */ GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2127955), // Rule ID 63852 //
     /* 2127918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2127924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2127927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127931 */   // MIs[0] Operand 1
     /* 2127931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2127936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127944 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2127944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2127947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2127951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2127953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2127954 */   // GIR_Coverage, 63852,
     /* 2127954 */   GIR_EraseRootFromParent_Done,
     /* 2127955 */ // Label 28497: @2127955
     /* 2127955 */ GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2128021), // Rule ID 63858 //
     /* 2127960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2127963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2127966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2127969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127973 */   // MIs[0] Operand 1
     /* 2127973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2127978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2127986 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2127986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2127989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2127993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2127998 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128002 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2128011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128020 */   // GIR_Coverage, 63858,
     /* 2128020 */   GIR_EraseRootFromParent_Done,
     /* 2128021 */ // Label 28498: @2128021
     /* 2128021 */ GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2128090), // Rule ID 63864 //
     /* 2128026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128039 */   // MIs[0] Operand 1
     /* 2128039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2128044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128052 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2128052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2128059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128068 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128079 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2128085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128089 */   // GIR_Coverage, 63864,
     /* 2128089 */   GIR_EraseRootFromParent_Done,
     /* 2128090 */ // Label 28499: @2128090
     /* 2128090 */ GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2128132), // Rule ID 63868 //
     /* 2128095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128108 */   // MIs[0] Operand 1
     /* 2128108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2128113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128121 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2128121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128126 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2128128 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2128130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128131 */   // GIR_Coverage, 63868,
     /* 2128131 */   GIR_EraseRootFromParent_Done,
     /* 2128132 */ // Label 28500: @2128132
     /* 2128132 */ GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2128174), // Rule ID 63872 //
     /* 2128137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128150 */   // MIs[0] Operand 1
     /* 2128150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2128155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128163 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2128163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128168 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2128170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2128172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128173 */   // GIR_Coverage, 63872,
     /* 2128173 */   GIR_EraseRootFromParent_Done,
     /* 2128174 */ // Label 28501: @2128174
     /* 2128174 */ GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2128240), // Rule ID 63876 //
     /* 2128179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128192 */   // MIs[0] Operand 1
     /* 2128192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2128197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128205 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2128205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128217 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128221 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128239 */   // GIR_Coverage, 63876,
     /* 2128239 */   GIR_EraseRootFromParent_Done,
     /* 2128240 */ // Label 28502: @2128240
     /* 2128240 */ GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2128306), // Rule ID 63880 //
     /* 2128245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128258 */   // MIs[0] Operand 1
     /* 2128258 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2128263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128271 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2128271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128283 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128287 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128305 */   // GIR_Coverage, 63880,
     /* 2128305 */   GIR_EraseRootFromParent_Done,
     /* 2128306 */ // Label 28503: @2128306
     /* 2128306 */ GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2128372), // Rule ID 63884 //
     /* 2128311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128324 */   // MIs[0] Operand 1
     /* 2128324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2128329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128337 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2128337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128349 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128353 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128371 */   // GIR_Coverage, 63884,
     /* 2128371 */   GIR_EraseRootFromParent_Done,
     /* 2128372 */ // Label 28504: @2128372
     /* 2128372 */ GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2128438), // Rule ID 63888 //
     /* 2128377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2128383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2128386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128390 */   // MIs[0] Operand 1
     /* 2128390 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2128395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128403 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2128403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128437 */   // GIR_Coverage, 63888,
     /* 2128437 */   GIR_EraseRootFromParent_Done,
     /* 2128438 */ // Label 28505: @2128438
     /* 2128438 */ GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2128504), // Rule ID 63894 //
     /* 2128443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128456 */   // MIs[0] Operand 1
     /* 2128456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2128461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128469 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2128469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2128476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2128494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128503 */   // GIR_Coverage, 63894,
     /* 2128503 */   GIR_EraseRootFromParent_Done,
     /* 2128504 */ // Label 28506: @2128504
     /* 2128504 */ GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2128573), // Rule ID 63900 //
     /* 2128509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128522 */   // MIs[0] Operand 1
     /* 2128522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2128527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128535 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2128535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2128542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128547 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128551 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128562 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2128568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128572 */   // GIR_Coverage, 63900,
     /* 2128572 */   GIR_EraseRootFromParent_Done,
     /* 2128573 */ // Label 28507: @2128573
     /* 2128573 */ GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2128615), // Rule ID 63904 //
     /* 2128578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128591 */   // MIs[0] Operand 1
     /* 2128591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2128596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128604 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2128604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128609 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2128611 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2128613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128614 */   // GIR_Coverage, 63904,
     /* 2128614 */   GIR_EraseRootFromParent_Done,
     /* 2128615 */ // Label 28508: @2128615
     /* 2128615 */ GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2128657), // Rule ID 63908 //
     /* 2128620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128633 */   // MIs[0] Operand 1
     /* 2128633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2128638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128646 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2128646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2128653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2128655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128656 */   // GIR_Coverage, 63908,
     /* 2128656 */   GIR_EraseRootFromParent_Done,
     /* 2128657 */ // Label 28509: @2128657
     /* 2128657 */ GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2128723), // Rule ID 63912 //
     /* 2128662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128675 */   // MIs[0] Operand 1
     /* 2128675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2128680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128688 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2128688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128704 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128722 */   // GIR_Coverage, 63912,
     /* 2128722 */   GIR_EraseRootFromParent_Done,
     /* 2128723 */ // Label 28510: @2128723
     /* 2128723 */ GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2128789), // Rule ID 63916 //
     /* 2128728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128741 */   // MIs[0] Operand 1
     /* 2128741 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2128746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128750 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128754 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2128754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128766 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128770 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128788 */   // GIR_Coverage, 63916,
     /* 2128788 */   GIR_EraseRootFromParent_Done,
     /* 2128789 */ // Label 28511: @2128789
     /* 2128789 */ GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2128855), // Rule ID 63920 //
     /* 2128794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128807 */   // MIs[0] Operand 1
     /* 2128807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2128812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128820 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2128820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2128827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128832 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128836 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128854 */   // GIR_Coverage, 63920,
     /* 2128854 */   GIR_EraseRootFromParent_Done,
     /* 2128855 */ // Label 28512: @2128855
     /* 2128855 */ GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2128921), // Rule ID 63924 //
     /* 2128860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2128863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2128866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2128869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128873 */   // MIs[0] Operand 1
     /* 2128873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2128878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128886 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2128886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2128889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2128893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2128898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2128902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2128906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2128908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2128911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2128916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2128919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128920 */   // GIR_Coverage, 63924,
     /* 2128920 */   GIR_EraseRootFromParent_Done,
     /* 2128921 */ // Label 28513: @2128921
     /* 2128921 */ GIM_Reject,
     /* 2128922 */ // Label 28458: @2128922
     /* 2128922 */ GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2128965), // Rule ID 158 //
     /* 2128927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2128930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2128933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2128936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128940 */   // MIs[0] Operand 1
     /* 2128940 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2128945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128949 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2128953 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2128953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2128956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2128960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2128963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2128964 */   // GIR_Coverage, 158,
     /* 2128964 */   GIR_EraseRootFromParent_Done,
     /* 2128965 */ // Label 28514: @2128965
     /* 2128965 */ GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2129008), // Rule ID 63853 //
     /* 2128970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2128973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2128976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2128979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128983 */   // MIs[0] Operand 1
     /* 2128983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2128988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2128992 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2128996 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2128996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2128999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129007 */   // GIR_Coverage, 63853,
     /* 2129007 */   GIR_EraseRootFromParent_Done,
     /* 2129008 */ // Label 28515: @2129008
     /* 2129008 */ GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2129054), // Rule ID 63859 //
     /* 2129013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2129022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129026 */   // MIs[0] Operand 1
     /* 2129026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2129031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129035 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2129039 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2129039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2129042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129044 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2129050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129053 */   // GIR_Coverage, 63859,
     /* 2129053 */   GIR_EraseRootFromParent_Done,
     /* 2129054 */ // Label 28516: @2129054
     /* 2129054 */ GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2129097), // Rule ID 63889 //
     /* 2129059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129072 */   // MIs[0] Operand 1
     /* 2129072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2129077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129081 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2129085 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2129085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129096 */   // GIR_Coverage, 63889,
     /* 2129096 */   GIR_EraseRootFromParent_Done,
     /* 2129097 */ // Label 28517: @2129097
     /* 2129097 */ GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2129143), // Rule ID 63895 //
     /* 2129102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129115 */   // MIs[0] Operand 1
     /* 2129115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2129120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129124 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2129128 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2129128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2129131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129133 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2129139 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129142 */   // GIR_Coverage, 63895,
     /* 2129142 */   GIR_EraseRootFromParent_Done,
     /* 2129143 */ // Label 28518: @2129143
     /* 2129143 */ GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2129196), // Rule ID 148 //
     /* 2129148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129161 */   // MIs[0] Operand 1
     /* 2129161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2129166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129178 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129182 */   // MIs[1] Operand 1
     /* 2129182 */   // No operand predicates
     /* 2129182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129184 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2129184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2129187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129191 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2129194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129195 */   // GIR_Coverage, 148,
     /* 2129195 */   GIR_EraseRootFromParent_Done,
     /* 2129196 */ // Label 28519: @2129196
     /* 2129196 */ GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2129249), // Rule ID 152 //
     /* 2129201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129214 */   // MIs[0] Operand 1
     /* 2129214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2129219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129231 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129235 */   // MIs[1] Operand 1
     /* 2129235 */   // No operand predicates
     /* 2129235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129237 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2129237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129244 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2129247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129248 */   // GIR_Coverage, 152,
     /* 2129248 */   GIR_EraseRootFromParent_Done,
     /* 2129249 */ // Label 28520: @2129249
     /* 2129249 */ GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2129302), // Rule ID 63845 //
     /* 2129254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129267 */   // MIs[0] Operand 1
     /* 2129267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2129272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129284 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129288 */   // MIs[1] Operand 1
     /* 2129288 */   // No operand predicates
     /* 2129288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129290 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2129290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129295 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129297 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2129300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129301 */   // GIR_Coverage, 63845,
     /* 2129301 */   GIR_EraseRootFromParent_Done,
     /* 2129302 */ // Label 28521: @2129302
     /* 2129302 */ GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2129355), // Rule ID 63849 //
     /* 2129307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129320 */   // MIs[0] Operand 1
     /* 2129320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2129325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129337 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129341 */   // MIs[1] Operand 1
     /* 2129341 */   // No operand predicates
     /* 2129341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129343 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2129343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2129346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129348 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129350 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2129353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129354 */   // GIR_Coverage, 63849,
     /* 2129354 */   GIR_EraseRootFromParent_Done,
     /* 2129355 */ // Label 28522: @2129355
     /* 2129355 */ GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2129432), // Rule ID 63855 //
     /* 2129360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129366 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129373 */   // MIs[0] Operand 1
     /* 2129373 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2129378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129390 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2129394 */   // MIs[1] Operand 1
     /* 2129394 */   // No operand predicates
     /* 2129394 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129396 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2129396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2129403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129408 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129412 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2129417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129431 */   // GIR_Coverage, 63855,
     /* 2129431 */   GIR_EraseRootFromParent_Done,
     /* 2129432 */ // Label 28523: @2129432
     /* 2129432 */ GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2129512), // Rule ID 63861 //
     /* 2129437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129450 */   // MIs[0] Operand 1
     /* 2129450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2129455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129467 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2129471 */   // MIs[1] Operand 1
     /* 2129471 */   // No operand predicates
     /* 2129471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129473 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2129473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2129480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129489 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2129494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2129499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2129507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129511 */   // GIR_Coverage, 63861,
     /* 2129511 */   GIR_EraseRootFromParent_Done,
     /* 2129512 */ // Label 28524: @2129512
     /* 2129512 */ GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2129589), // Rule ID 63865 //
     /* 2129517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129530 */   // MIs[0] Operand 1
     /* 2129530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2129535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129547 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2129551 */   // MIs[1] Operand 1
     /* 2129551 */   // No operand predicates
     /* 2129551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129553 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2129553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129565 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129569 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2129574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2129579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129588 */   // GIR_Coverage, 63865,
     /* 2129588 */   GIR_EraseRootFromParent_Done,
     /* 2129589 */ // Label 28525: @2129589
     /* 2129589 */ GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2129666), // Rule ID 63869 //
     /* 2129594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129607 */   // MIs[0] Operand 1
     /* 2129607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2129612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129624 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2129628 */   // MIs[1] Operand 1
     /* 2129628 */   // No operand predicates
     /* 2129628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129630 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2129630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2129637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129646 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2129651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2129656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129665 */   // GIR_Coverage, 63869,
     /* 2129665 */   GIR_EraseRootFromParent_Done,
     /* 2129666 */ // Label 28526: @2129666
     /* 2129666 */ GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2129741), // Rule ID 63873 //
     /* 2129671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129684 */   // MIs[0] Operand 1
     /* 2129684 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2129689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129701 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129705 */   // MIs[1] Operand 1
     /* 2129705 */   // No operand predicates
     /* 2129705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129707 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2129707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129723 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2129726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2129731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129740 */   // GIR_Coverage, 63873,
     /* 2129740 */   GIR_EraseRootFromParent_Done,
     /* 2129741 */ // Label 28527: @2129741
     /* 2129741 */ GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2129816), // Rule ID 63877 //
     /* 2129746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129759 */   // MIs[0] Operand 1
     /* 2129759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2129764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129776 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2129780 */   // MIs[1] Operand 1
     /* 2129780 */   // No operand predicates
     /* 2129780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129782 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2129782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2129789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129794 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129798 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2129801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2129806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2129814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129815 */   // GIR_Coverage, 63877,
     /* 2129815 */   GIR_EraseRootFromParent_Done,
     /* 2129816 */ // Label 28528: @2129816
     /* 2129816 */ GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2129871), // Rule ID 63881 //
     /* 2129821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129834 */   // MIs[0] Operand 1
     /* 2129834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2129839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129851 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2129855 */   // MIs[1] Operand 1
     /* 2129855 */   // No operand predicates
     /* 2129855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129857 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2129857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129862 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129864 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2129869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129870 */   // GIR_Coverage, 63881,
     /* 2129870 */   GIR_EraseRootFromParent_Done,
     /* 2129871 */ // Label 28529: @2129871
     /* 2129871 */ GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2129926), // Rule ID 63885 //
     /* 2129876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2129882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129889 */   // MIs[0] Operand 1
     /* 2129889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2129894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129906 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2129910 */   // MIs[1] Operand 1
     /* 2129910 */   // No operand predicates
     /* 2129910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129912 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2129912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2129915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129917 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2129919 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2129924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2129925 */   // GIR_Coverage, 63885,
     /* 2129925 */   GIR_EraseRootFromParent_Done,
     /* 2129926 */ // Label 28530: @2129926
     /* 2129926 */ GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2130003), // Rule ID 63891 //
     /* 2129931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2129934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2129937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2129940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129944 */   // MIs[0] Operand 1
     /* 2129944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2129949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2129953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2129957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2129961 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2129965 */   // MIs[1] Operand 1
     /* 2129965 */   // No operand predicates
     /* 2129965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2129967 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2129967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2129970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2129974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2129979 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2129983 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2129988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2129990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2129993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2129998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130002 */   // GIR_Coverage, 63891,
     /* 2130002 */   GIR_EraseRootFromParent_Done,
     /* 2130003 */ // Label 28531: @2130003
     /* 2130003 */ GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2130083), // Rule ID 63897 //
     /* 2130008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130021 */   // MIs[0] Operand 1
     /* 2130021 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2130026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130038 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2130042 */   // MIs[1] Operand 1
     /* 2130042 */   // No operand predicates
     /* 2130042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130044 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2130044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2130051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130056 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130060 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2130065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2130070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2130078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130082 */   // GIR_Coverage, 63897,
     /* 2130082 */   GIR_EraseRootFromParent_Done,
     /* 2130083 */ // Label 28532: @2130083
     /* 2130083 */ GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2130160), // Rule ID 63901 //
     /* 2130088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130094 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130101 */   // MIs[0] Operand 1
     /* 2130101 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2130106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130118 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2130122 */   // MIs[1] Operand 1
     /* 2130122 */   // No operand predicates
     /* 2130122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130124 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2130124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2130131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130136 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130140 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2130145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2130150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130159 */   // GIR_Coverage, 63901,
     /* 2130159 */   GIR_EraseRootFromParent_Done,
     /* 2130160 */ // Label 28533: @2130160
     /* 2130160 */ GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2130237), // Rule ID 63905 //
     /* 2130165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130178 */   // MIs[0] Operand 1
     /* 2130178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2130183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130195 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2130199 */   // MIs[1] Operand 1
     /* 2130199 */   // No operand predicates
     /* 2130199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130201 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2130201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2130208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130217 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2130222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2130227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130236 */   // GIR_Coverage, 63905,
     /* 2130236 */   GIR_EraseRootFromParent_Done,
     /* 2130237 */ // Label 28534: @2130237
     /* 2130237 */ GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2130312), // Rule ID 63909 //
     /* 2130242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130255 */   // MIs[0] Operand 1
     /* 2130255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2130260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130272 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2130276 */   // MIs[1] Operand 1
     /* 2130276 */   // No operand predicates
     /* 2130276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130278 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2130278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2130285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130290 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2130297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2130302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130311 */   // GIR_Coverage, 63909,
     /* 2130311 */   GIR_EraseRootFromParent_Done,
     /* 2130312 */ // Label 28535: @2130312
     /* 2130312 */ GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2130387), // Rule ID 63913 //
     /* 2130317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130330 */   // MIs[0] Operand 1
     /* 2130330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2130335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130347 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2130351 */   // MIs[1] Operand 1
     /* 2130351 */   // No operand predicates
     /* 2130351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130353 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2130353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2130360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130365 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130369 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2130372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2130377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130386 */   // GIR_Coverage, 63913,
     /* 2130386 */   GIR_EraseRootFromParent_Done,
     /* 2130387 */ // Label 28536: @2130387
     /* 2130387 */ GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2130442), // Rule ID 63917 //
     /* 2130392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130405 */   // MIs[0] Operand 1
     /* 2130405 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2130410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130422 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2130426 */   // MIs[1] Operand 1
     /* 2130426 */   // No operand predicates
     /* 2130426 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130428 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2130428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2130431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130435 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2130440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130441 */   // GIR_Coverage, 63917,
     /* 2130441 */   GIR_EraseRootFromParent_Done,
     /* 2130442 */ // Label 28537: @2130442
     /* 2130442 */ GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2130497), // Rule ID 63921 //
     /* 2130447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130460 */   // MIs[0] Operand 1
     /* 2130460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2130465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2130473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2130477 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2130481 */   // MIs[1] Operand 1
     /* 2130481 */   // No operand predicates
     /* 2130481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2130483 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2130483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2130486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130488 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130490 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2130495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130496 */   // GIR_Coverage, 63921,
     /* 2130496 */   GIR_EraseRootFromParent_Done,
     /* 2130497 */ // Label 28538: @2130497
     /* 2130497 */ GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2130539), // Rule ID 63770 //
     /* 2130502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2130505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130515 */   // MIs[0] Operand 1
     /* 2130515 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2130520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130524 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130528 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2130531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130535 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130538 */   // GIR_Coverage, 63770,
     /* 2130538 */   GIR_EraseRootFromParent_Done,
     /* 2130539 */ // Label 28539: @2130539
     /* 2130539 */ GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2130581), // Rule ID 63772 //
     /* 2130544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2130547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130557 */   // MIs[0] Operand 1
     /* 2130557 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2130562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130566 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130570 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2130573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130575 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130577 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130580 */   // GIR_Coverage, 63772,
     /* 2130580 */   GIR_EraseRootFromParent_Done,
     /* 2130581 */ // Label 28540: @2130581
     /* 2130581 */ GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2130623), // Rule ID 146 //
     /* 2130586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130599 */   // MIs[0] Operand 1
     /* 2130599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2130604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130612 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2130615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130622 */   // GIR_Coverage, 146,
     /* 2130622 */   GIR_EraseRootFromParent_Done,
     /* 2130623 */ // Label 28541: @2130623
     /* 2130623 */ GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2130665), // Rule ID 150 //
     /* 2130628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2130634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2130637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130641 */   // MIs[0] Operand 1
     /* 2130641 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2130646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130650 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130654 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2130657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130659 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130661 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130664 */   // GIR_Coverage, 150,
     /* 2130664 */   GIR_EraseRootFromParent_Done,
     /* 2130665 */ // Label 28542: @2130665
     /* 2130665 */ GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2130707), // Rule ID 63847 //
     /* 2130670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130683 */   // MIs[0] Operand 1
     /* 2130683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2130688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130696 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2130699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130706 */   // GIR_Coverage, 63847,
     /* 2130706 */   GIR_EraseRootFromParent_Done,
     /* 2130707 */ // Label 28543: @2130707
     /* 2130707 */ GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2130749), // Rule ID 63851 //
     /* 2130712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130725 */   // MIs[0] Operand 1
     /* 2130725 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2130730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130738 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2130738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2130741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130743 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130748 */   // GIR_Coverage, 63851,
     /* 2130748 */   GIR_EraseRootFromParent_Done,
     /* 2130749 */ // Label 28544: @2130749
     /* 2130749 */ GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2130815), // Rule ID 63857 //
     /* 2130754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130760 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130767 */   // MIs[0] Operand 1
     /* 2130767 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2130772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130776 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130780 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2130780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2130787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2130800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2130805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2130813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130814 */   // GIR_Coverage, 63857,
     /* 2130814 */   GIR_EraseRootFromParent_Done,
     /* 2130815 */ // Label 28545: @2130815
     /* 2130815 */ GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2130884), // Rule ID 63863 //
     /* 2130820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130833 */   // MIs[0] Operand 1
     /* 2130833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2130838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130846 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2130846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2130849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2130853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2130858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2130862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2130866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2130868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2130871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130873 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2130879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2130882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130883 */   // GIR_Coverage, 63863,
     /* 2130883 */   GIR_EraseRootFromParent_Done,
     /* 2130884 */ // Label 28546: @2130884
     /* 2130884 */ GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2130926), // Rule ID 63867 //
     /* 2130889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130902 */   // MIs[0] Operand 1
     /* 2130902 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2130907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130915 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2130915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2130918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130920 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130925 */   // GIR_Coverage, 63867,
     /* 2130925 */   GIR_EraseRootFromParent_Done,
     /* 2130926 */ // Label 28547: @2130926
     /* 2130926 */ GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2130968), // Rule ID 63871 //
     /* 2130931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130944 */   // MIs[0] Operand 1
     /* 2130944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2130949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130957 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2130957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2130960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130962 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2130964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2130966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2130967 */   // GIR_Coverage, 63871,
     /* 2130967 */   GIR_EraseRootFromParent_Done,
     /* 2130968 */ // Label 28548: @2130968
     /* 2130968 */ GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2131034), // Rule ID 63875 //
     /* 2130973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2130976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2130979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2130982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130986 */   // MIs[0] Operand 1
     /* 2130986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2130991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2130999 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2130999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131033 */   // GIR_Coverage, 63875,
     /* 2131033 */   GIR_EraseRootFromParent_Done,
     /* 2131034 */ // Label 28549: @2131034
     /* 2131034 */ GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2131100), // Rule ID 63879 //
     /* 2131039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2131045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2131048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131052 */   // MIs[0] Operand 1
     /* 2131052 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2131057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131061 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131065 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2131065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2131072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131099 */   // GIR_Coverage, 63879,
     /* 2131099 */   GIR_EraseRootFromParent_Done,
     /* 2131100 */ // Label 28550: @2131100
     /* 2131100 */ GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2131166), // Rule ID 63883 //
     /* 2131105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2131111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2131114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131118 */   // MIs[0] Operand 1
     /* 2131118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2131123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131131 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2131131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131143 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131147 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131165 */   // GIR_Coverage, 63883,
     /* 2131165 */   GIR_EraseRootFromParent_Done,
     /* 2131166 */ // Label 28551: @2131166
     /* 2131166 */ GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2131232), // Rule ID 63887 //
     /* 2131171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2131177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2131180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131184 */   // MIs[0] Operand 1
     /* 2131184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2131189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131197 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2131197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2131204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131209 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131231 */   // GIR_Coverage, 63887,
     /* 2131231 */   GIR_EraseRootFromParent_Done,
     /* 2131232 */ // Label 28552: @2131232
     /* 2131232 */ GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2131298), // Rule ID 63893 //
     /* 2131237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131250 */   // MIs[0] Operand 1
     /* 2131250 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2131255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131259 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131263 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2131263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2131270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2131288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131297 */   // GIR_Coverage, 63893,
     /* 2131297 */   GIR_EraseRootFromParent_Done,
     /* 2131298 */ // Label 28553: @2131298
     /* 2131298 */ GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2131367), // Rule ID 63899 //
     /* 2131303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131316 */   // MIs[0] Operand 1
     /* 2131316 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2131321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131325 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131329 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2131329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2131336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2131362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131366 */   // GIR_Coverage, 63899,
     /* 2131366 */   GIR_EraseRootFromParent_Done,
     /* 2131367 */ // Label 28554: @2131367
     /* 2131367 */ GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2131409), // Rule ID 63903 //
     /* 2131372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131385 */   // MIs[0] Operand 1
     /* 2131385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2131390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131398 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2131398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131408 */   // GIR_Coverage, 63903,
     /* 2131408 */   GIR_EraseRootFromParent_Done,
     /* 2131409 */ // Label 28555: @2131409
     /* 2131409 */ GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2131451), // Rule ID 63907 //
     /* 2131414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131427 */   // MIs[0] Operand 1
     /* 2131427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2131432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131440 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2131440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2131443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131447 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131450 */   // GIR_Coverage, 63907,
     /* 2131450 */   GIR_EraseRootFromParent_Done,
     /* 2131451 */ // Label 28556: @2131451
     /* 2131451 */ GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2131517), // Rule ID 63911 //
     /* 2131456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131469 */   // MIs[0] Operand 1
     /* 2131469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2131474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131482 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2131482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131516 */   // GIR_Coverage, 63911,
     /* 2131516 */   GIR_EraseRootFromParent_Done,
     /* 2131517 */ // Label 28557: @2131517
     /* 2131517 */ GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2131583), // Rule ID 63915 //
     /* 2131522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131535 */   // MIs[0] Operand 1
     /* 2131535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2131540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131548 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2131548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2131555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131582 */   // GIR_Coverage, 63915,
     /* 2131582 */   GIR_EraseRootFromParent_Done,
     /* 2131583 */ // Label 28558: @2131583
     /* 2131583 */ GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2131649), // Rule ID 63919 //
     /* 2131588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131601 */   // MIs[0] Operand 1
     /* 2131601 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2131606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131610 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131614 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2131614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2131621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131648 */   // GIR_Coverage, 63919,
     /* 2131648 */   GIR_EraseRootFromParent_Done,
     /* 2131649 */ // Label 28559: @2131649
     /* 2131649 */ GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2131715), // Rule ID 63923 //
     /* 2131654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2131657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2131660 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2131663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131667 */   // MIs[0] Operand 1
     /* 2131667 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2131672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131676 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2131680 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2131680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2131683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2131687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2131692 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2131696 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2131700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2131702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2131705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2131710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2131713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131714 */   // GIR_Coverage, 63923,
     /* 2131714 */   GIR_EraseRootFromParent_Done,
     /* 2131715 */ // Label 28560: @2131715
     /* 2131715 */ GIM_Reject,
     /* 2131716 */ // Label 28459: @2131716
     /* 2131716 */ GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2131764), // Rule ID 45460 //
     /* 2131721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2131724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2131727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2131730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131734 */   // MIs[0] Operand 1
     /* 2131734 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2131739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131743 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131747 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2131747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2131750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2131762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131763 */   // GIR_Coverage, 45460,
     /* 2131763 */   GIR_EraseRootFromParent_Done,
     /* 2131764 */ // Label 28561: @2131764
     /* 2131764 */ GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2131812), // Rule ID 45461 //
     /* 2131769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2131772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2131775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2131778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131782 */   // MIs[0] Operand 1
     /* 2131782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2131787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131795 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2131795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2131798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131800 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2131810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131811 */   // GIR_Coverage, 45461,
     /* 2131811 */   GIR_EraseRootFromParent_Done,
     /* 2131812 */ // Label 28562: @2131812
     /* 2131812 */ GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2131860), // Rule ID 45462 //
     /* 2131817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2131820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2131823 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2131826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131830 */   // MIs[0] Operand 1
     /* 2131830 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2131835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131839 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131843 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2131843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2131846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131848 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131850 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2131852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2131858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131859 */   // GIR_Coverage, 45462,
     /* 2131859 */   GIR_EraseRootFromParent_Done,
     /* 2131860 */ // Label 28563: @2131860
     /* 2131860 */ GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2131908), // Rule ID 45463 //
     /* 2131865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2131868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2131871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2131874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131878 */   // MIs[0] Operand 1
     /* 2131878 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2131883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131887 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131891 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2131891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2131894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131896 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2131900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2131906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131907 */   // GIR_Coverage, 45463,
     /* 2131907 */   GIR_EraseRootFromParent_Done,
     /* 2131908 */ // Label 28564: @2131908
     /* 2131908 */ GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2131956), // Rule ID 47946 //
     /* 2131913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2131916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131926 */   // MIs[0] Operand 1
     /* 2131926 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2131931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131935 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131939 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2131939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2131942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131944 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131946 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2131955 */   // GIR_Coverage, 47946,
     /* 2131955 */   GIR_EraseRootFromParent_Done,
     /* 2131956 */ // Label 28565: @2131956
     /* 2131956 */ GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2132004), // Rule ID 47947 //
     /* 2131961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2131964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131974 */   // MIs[0] Operand 1
     /* 2131974 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2131979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131987 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2131987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2131990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131992 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2131994 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2131996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2131999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132003 */   // GIR_Coverage, 47947,
     /* 2132003 */   GIR_EraseRootFromParent_Done,
     /* 2132004 */ // Label 28566: @2132004
     /* 2132004 */ GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2132052), // Rule ID 47950 //
     /* 2132009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132022 */   // MIs[0] Operand 1
     /* 2132022 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2132027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132031 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132035 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2132035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2132038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132040 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132042 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132051 */   // GIR_Coverage, 47950,
     /* 2132051 */   GIR_EraseRootFromParent_Done,
     /* 2132052 */ // Label 28567: @2132052
     /* 2132052 */ GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2132100), // Rule ID 47951 //
     /* 2132057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132070 */   // MIs[0] Operand 1
     /* 2132070 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2132075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132083 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2132083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2132086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132088 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132099 */   // GIR_Coverage, 47951,
     /* 2132099 */   GIR_EraseRootFromParent_Done,
     /* 2132100 */ // Label 28568: @2132100
     /* 2132100 */ GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2132148), // Rule ID 47958 //
     /* 2132105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2132108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132118 */   // MIs[0] Operand 1
     /* 2132118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2132123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132131 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2132131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2132134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132136 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132138 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132147 */   // GIR_Coverage, 47958,
     /* 2132147 */   GIR_EraseRootFromParent_Done,
     /* 2132148 */ // Label 28569: @2132148
     /* 2132148 */ GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2132196), // Rule ID 47959 //
     /* 2132153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2132156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132166 */   // MIs[0] Operand 1
     /* 2132166 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2132171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132175 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132179 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2132179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2132182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132184 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132186 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132195 */   // GIR_Coverage, 47959,
     /* 2132195 */   GIR_EraseRootFromParent_Done,
     /* 2132196 */ // Label 28570: @2132196
     /* 2132196 */ GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2132244), // Rule ID 47984 //
     /* 2132201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2132207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2132210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132214 */   // MIs[0] Operand 1
     /* 2132214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132223 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132227 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2132227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2132230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132232 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2132242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132243 */   // GIR_Coverage, 47984,
     /* 2132243 */   GIR_EraseRootFromParent_Done,
     /* 2132244 */ // Label 28571: @2132244
     /* 2132244 */ GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2132292), // Rule ID 47985 //
     /* 2132249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2132255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2132258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132262 */   // MIs[0] Operand 1
     /* 2132262 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132275 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2132275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2132278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132280 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2132290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132291 */   // GIR_Coverage, 47985,
     /* 2132291 */   GIR_EraseRootFromParent_Done,
     /* 2132292 */ // Label 28572: @2132292
     /* 2132292 */ GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2132340), // Rule ID 47990 //
     /* 2132297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132310 */   // MIs[0] Operand 1
     /* 2132310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132323 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2132323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2132326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132339 */   // GIR_Coverage, 47990,
     /* 2132339 */   GIR_EraseRootFromParent_Done,
     /* 2132340 */ // Label 28573: @2132340
     /* 2132340 */ GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2132388), // Rule ID 47991 //
     /* 2132345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132358 */   // MIs[0] Operand 1
     /* 2132358 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132367 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132371 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2132371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2132374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132376 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132387 */   // GIR_Coverage, 47991,
     /* 2132387 */   GIR_EraseRootFromParent_Done,
     /* 2132388 */ // Label 28574: @2132388
     /* 2132388 */ GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2132436), // Rule ID 47994 //
     /* 2132393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132406 */   // MIs[0] Operand 1
     /* 2132406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132419 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2132419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2132422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132435 */   // GIR_Coverage, 47994,
     /* 2132435 */   GIR_EraseRootFromParent_Done,
     /* 2132436 */ // Label 28575: @2132436
     /* 2132436 */ GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2132484), // Rule ID 47995 //
     /* 2132441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132454 */   // MIs[0] Operand 1
     /* 2132454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132467 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2132467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2132470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132483 */   // GIR_Coverage, 47995,
     /* 2132483 */   GIR_EraseRootFromParent_Done,
     /* 2132484 */ // Label 28576: @2132484
     /* 2132484 */ GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2132532), // Rule ID 48002 //
     /* 2132489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2132492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132502 */   // MIs[0] Operand 1
     /* 2132502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132515 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2132515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2132518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132531 */   // GIR_Coverage, 48002,
     /* 2132531 */   GIR_EraseRootFromParent_Done,
     /* 2132532 */ // Label 28577: @2132532
     /* 2132532 */ GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2132580), // Rule ID 48003 //
     /* 2132537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2132540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132550 */   // MIs[0] Operand 1
     /* 2132550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2132555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132563 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2132563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2132566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132579 */   // GIR_Coverage, 48003,
     /* 2132579 */   GIR_EraseRootFromParent_Done,
     /* 2132580 */ // Label 28578: @2132580
     /* 2132580 */ GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2132628), // Rule ID 48028 //
     /* 2132585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2132591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2132594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132598 */   // MIs[0] Operand 1
     /* 2132598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132611 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2132611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2132614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2132626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132627 */   // GIR_Coverage, 48028,
     /* 2132627 */   GIR_EraseRootFromParent_Done,
     /* 2132628 */ // Label 28579: @2132628
     /* 2132628 */ GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2132676), // Rule ID 48029 //
     /* 2132633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2132639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2132642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132646 */   // MIs[0] Operand 1
     /* 2132646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132659 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2132659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2132662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2132674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132675 */   // GIR_Coverage, 48029,
     /* 2132675 */   GIR_EraseRootFromParent_Done,
     /* 2132676 */ // Label 28580: @2132676
     /* 2132676 */ GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2132724), // Rule ID 48034 //
     /* 2132681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132694 */   // MIs[0] Operand 1
     /* 2132694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132707 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2132707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2132710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132723 */   // GIR_Coverage, 48034,
     /* 2132723 */   GIR_EraseRootFromParent_Done,
     /* 2132724 */ // Label 28581: @2132724
     /* 2132724 */ GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2132772), // Rule ID 48035 //
     /* 2132729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132742 */   // MIs[0] Operand 1
     /* 2132742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132755 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2132755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2132758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132771 */   // GIR_Coverage, 48035,
     /* 2132771 */   GIR_EraseRootFromParent_Done,
     /* 2132772 */ // Label 28582: @2132772
     /* 2132772 */ GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2132820), // Rule ID 48038 //
     /* 2132777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132790 */   // MIs[0] Operand 1
     /* 2132790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132803 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2132803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2132806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132819 */   // GIR_Coverage, 48038,
     /* 2132819 */   GIR_EraseRootFromParent_Done,
     /* 2132820 */ // Label 28583: @2132820
     /* 2132820 */ GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2132868), // Rule ID 48039 //
     /* 2132825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2132828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132838 */   // MIs[0] Operand 1
     /* 2132838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132851 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2132851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2132854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132867 */   // GIR_Coverage, 48039,
     /* 2132867 */   GIR_EraseRootFromParent_Done,
     /* 2132868 */ // Label 28584: @2132868
     /* 2132868 */ GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2132916), // Rule ID 48046 //
     /* 2132873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2132876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132886 */   // MIs[0] Operand 1
     /* 2132886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132899 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2132899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2132902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132915 */   // GIR_Coverage, 48046,
     /* 2132915 */   GIR_EraseRootFromParent_Done,
     /* 2132916 */ // Label 28585: @2132916
     /* 2132916 */ GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2132964), // Rule ID 48047 //
     /* 2132921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2132924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132934 */   // MIs[0] Operand 1
     /* 2132934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2132939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132943 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132947 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2132947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2132950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132952 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2132954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2132956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2132959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2132963 */   // GIR_Coverage, 48047,
     /* 2132963 */   GIR_EraseRootFromParent_Done,
     /* 2132964 */ // Label 28586: @2132964
     /* 2132964 */ GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2133012), // Rule ID 48076 //
     /* 2132969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2132972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132982 */   // MIs[0] Operand 1
     /* 2132982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2132987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132995 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2132995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2132998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133000 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133011 */   // GIR_Coverage, 48076,
     /* 2133011 */   GIR_EraseRootFromParent_Done,
     /* 2133012 */ // Label 28587: @2133012
     /* 2133012 */ GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2133060), // Rule ID 48077 //
     /* 2133017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133030 */   // MIs[0] Operand 1
     /* 2133030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2133035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133043 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2133043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2133046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133048 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133059 */   // GIR_Coverage, 48077,
     /* 2133059 */   GIR_EraseRootFromParent_Done,
     /* 2133060 */ // Label 28588: @2133060
     /* 2133060 */ GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2133108), // Rule ID 48080 //
     /* 2133065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133078 */   // MIs[0] Operand 1
     /* 2133078 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2133083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133091 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2133091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2133094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133096 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133098 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133107 */   // GIR_Coverage, 48080,
     /* 2133107 */   GIR_EraseRootFromParent_Done,
     /* 2133108 */ // Label 28589: @2133108
     /* 2133108 */ GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2133156), // Rule ID 48081 //
     /* 2133113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133119 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133126 */   // MIs[0] Operand 1
     /* 2133126 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2133131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133135 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133139 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2133139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2133142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133144 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133146 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133155 */   // GIR_Coverage, 48081,
     /* 2133155 */   GIR_EraseRootFromParent_Done,
     /* 2133156 */ // Label 28590: @2133156
     /* 2133156 */ GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2133204), // Rule ID 48088 //
     /* 2133161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2133164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133174 */   // MIs[0] Operand 1
     /* 2133174 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2133179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133183 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133187 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2133187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2133190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133192 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133203 */   // GIR_Coverage, 48088,
     /* 2133203 */   GIR_EraseRootFromParent_Done,
     /* 2133204 */ // Label 28591: @2133204
     /* 2133204 */ GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2133252), // Rule ID 48089 //
     /* 2133209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2133212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133222 */   // MIs[0] Operand 1
     /* 2133222 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2133227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133231 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133235 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2133235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2133238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133240 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133251 */   // GIR_Coverage, 48089,
     /* 2133251 */   GIR_EraseRootFromParent_Done,
     /* 2133252 */ // Label 28592: @2133252
     /* 2133252 */ GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2133300), // Rule ID 48114 //
     /* 2133257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2133263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2133266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133270 */   // MIs[0] Operand 1
     /* 2133270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133279 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133283 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2133283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2133286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2133298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133299 */   // GIR_Coverage, 48114,
     /* 2133299 */   GIR_EraseRootFromParent_Done,
     /* 2133300 */ // Label 28593: @2133300
     /* 2133300 */ GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2133348), // Rule ID 48115 //
     /* 2133305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2133311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2133314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133318 */   // MIs[0] Operand 1
     /* 2133318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133331 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2133331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2133334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133336 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2133346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133347 */   // GIR_Coverage, 48115,
     /* 2133347 */   GIR_EraseRootFromParent_Done,
     /* 2133348 */ // Label 28594: @2133348
     /* 2133348 */ GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2133396), // Rule ID 48120 //
     /* 2133353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133366 */   // MIs[0] Operand 1
     /* 2133366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133375 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133379 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2133379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2133382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133384 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133395 */   // GIR_Coverage, 48120,
     /* 2133395 */   GIR_EraseRootFromParent_Done,
     /* 2133396 */ // Label 28595: @2133396
     /* 2133396 */ GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2133444), // Rule ID 48121 //
     /* 2133401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133414 */   // MIs[0] Operand 1
     /* 2133414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133427 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2133427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2133430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133443 */   // GIR_Coverage, 48121,
     /* 2133443 */   GIR_EraseRootFromParent_Done,
     /* 2133444 */ // Label 28596: @2133444
     /* 2133444 */ GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2133492), // Rule ID 48124 //
     /* 2133449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133462 */   // MIs[0] Operand 1
     /* 2133462 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133475 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2133475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2133478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133482 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133491 */   // GIR_Coverage, 48124,
     /* 2133491 */   GIR_EraseRootFromParent_Done,
     /* 2133492 */ // Label 28597: @2133492
     /* 2133492 */ GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2133540), // Rule ID 48125 //
     /* 2133497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133510 */   // MIs[0] Operand 1
     /* 2133510 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133519 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133523 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2133523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2133526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133539 */   // GIR_Coverage, 48125,
     /* 2133539 */   GIR_EraseRootFromParent_Done,
     /* 2133540 */ // Label 28598: @2133540
     /* 2133540 */ GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2133588), // Rule ID 48132 //
     /* 2133545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2133548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133558 */   // MIs[0] Operand 1
     /* 2133558 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133567 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133571 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2133571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2133574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133576 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133578 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133587 */   // GIR_Coverage, 48132,
     /* 2133587 */   GIR_EraseRootFromParent_Done,
     /* 2133588 */ // Label 28599: @2133588
     /* 2133588 */ GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2133636), // Rule ID 48133 //
     /* 2133593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2133596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133606 */   // MIs[0] Operand 1
     /* 2133606 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2133611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133615 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133619 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2133619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2133622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133624 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2133626 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2133628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133635 */   // GIR_Coverage, 48133,
     /* 2133635 */   GIR_EraseRootFromParent_Done,
     /* 2133636 */ // Label 28600: @2133636
     /* 2133636 */ GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2133684), // Rule ID 48158 //
     /* 2133641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2133647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2133650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133654 */   // MIs[0] Operand 1
     /* 2133654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133667 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2133667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2133670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133672 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2133682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133683 */   // GIR_Coverage, 48158,
     /* 2133683 */   GIR_EraseRootFromParent_Done,
     /* 2133684 */ // Label 28601: @2133684
     /* 2133684 */ GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2133732), // Rule ID 48159 //
     /* 2133689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2133695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2133698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133702 */   // MIs[0] Operand 1
     /* 2133702 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133711 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133715 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2133715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2133718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133720 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2133730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133731 */   // GIR_Coverage, 48159,
     /* 2133731 */   GIR_EraseRootFromParent_Done,
     /* 2133732 */ // Label 28602: @2133732
     /* 2133732 */ GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2133780), // Rule ID 48164 //
     /* 2133737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133750 */   // MIs[0] Operand 1
     /* 2133750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133763 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2133763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2133766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133768 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133770 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133779 */   // GIR_Coverage, 48164,
     /* 2133779 */   GIR_EraseRootFromParent_Done,
     /* 2133780 */ // Label 28603: @2133780
     /* 2133780 */ GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2133828), // Rule ID 48165 //
     /* 2133785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133798 */   // MIs[0] Operand 1
     /* 2133798 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133807 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133811 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2133811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2133814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133816 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133818 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133827 */   // GIR_Coverage, 48165,
     /* 2133827 */   GIR_EraseRootFromParent_Done,
     /* 2133828 */ // Label 28604: @2133828
     /* 2133828 */ GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2133876), // Rule ID 48168 //
     /* 2133833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2133836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133839 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133846 */   // MIs[0] Operand 1
     /* 2133846 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133855 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133859 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2133859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2133862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133864 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133866 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133875 */   // GIR_Coverage, 48168,
     /* 2133875 */   GIR_EraseRootFromParent_Done,
     /* 2133876 */ // Label 28605: @2133876
     /* 2133876 */ GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2133924), // Rule ID 48169 //
     /* 2133881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2133884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2133887 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133894 */   // MIs[0] Operand 1
     /* 2133894 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133907 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2133907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2133910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133912 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133923 */   // GIR_Coverage, 48169,
     /* 2133923 */   GIR_EraseRootFromParent_Done,
     /* 2133924 */ // Label 28606: @2133924
     /* 2133924 */ GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2133972), // Rule ID 48176 //
     /* 2133929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2133932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133942 */   // MIs[0] Operand 1
     /* 2133942 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133951 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133955 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2133955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2133958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133960 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2133964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2133967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133971 */   // GIR_Coverage, 48176,
     /* 2133971 */   GIR_EraseRootFromParent_Done,
     /* 2133972 */ // Label 28607: @2133972
     /* 2133972 */ GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2134020), // Rule ID 48177 //
     /* 2133977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2133980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133990 */   // MIs[0] Operand 1
     /* 2133990 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2133995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133999 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134003 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2134003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2134006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134019 */   // GIR_Coverage, 48177,
     /* 2134019 */   GIR_EraseRootFromParent_Done,
     /* 2134020 */ // Label 28608: @2134020
     /* 2134020 */ GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2134068), // Rule ID 48202 //
     /* 2134025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134031 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134038 */   // MIs[0] Operand 1
     /* 2134038 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134047 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134051 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2134051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2134054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134056 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134058 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134067 */   // GIR_Coverage, 48202,
     /* 2134067 */   GIR_EraseRootFromParent_Done,
     /* 2134068 */ // Label 28609: @2134068
     /* 2134068 */ GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2134116), // Rule ID 48203 //
     /* 2134073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134086 */   // MIs[0] Operand 1
     /* 2134086 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134095 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134099 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2134099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2134102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134104 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134106 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134115 */   // GIR_Coverage, 48203,
     /* 2134115 */   GIR_EraseRootFromParent_Done,
     /* 2134116 */ // Label 28610: @2134116
     /* 2134116 */ GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2134164), // Rule ID 48208 //
     /* 2134121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134134 */   // MIs[0] Operand 1
     /* 2134134 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134143 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134147 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2134147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2134150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134152 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134154 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134163 */   // GIR_Coverage, 48208,
     /* 2134163 */   GIR_EraseRootFromParent_Done,
     /* 2134164 */ // Label 28611: @2134164
     /* 2134164 */ GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2134212), // Rule ID 48209 //
     /* 2134169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134182 */   // MIs[0] Operand 1
     /* 2134182 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134191 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134195 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2134195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2134198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134200 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134202 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134211 */   // GIR_Coverage, 48209,
     /* 2134211 */   GIR_EraseRootFromParent_Done,
     /* 2134212 */ // Label 28612: @2134212
     /* 2134212 */ GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2134260), // Rule ID 48212 //
     /* 2134217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134230 */   // MIs[0] Operand 1
     /* 2134230 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134239 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134243 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2134243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2134246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134248 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134250 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134259 */   // GIR_Coverage, 48212,
     /* 2134259 */   GIR_EraseRootFromParent_Done,
     /* 2134260 */ // Label 28613: @2134260
     /* 2134260 */ GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2134308), // Rule ID 48213 //
     /* 2134265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134278 */   // MIs[0] Operand 1
     /* 2134278 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134287 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134291 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2134291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2134294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134296 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134298 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134307 */   // GIR_Coverage, 48213,
     /* 2134307 */   GIR_EraseRootFromParent_Done,
     /* 2134308 */ // Label 28614: @2134308
     /* 2134308 */ GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2134356), // Rule ID 48220 //
     /* 2134313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2134316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134319 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134326 */   // MIs[0] Operand 1
     /* 2134326 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134335 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134339 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2134339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2134342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134344 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134346 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134355 */   // GIR_Coverage, 48220,
     /* 2134355 */   GIR_EraseRootFromParent_Done,
     /* 2134356 */ // Label 28615: @2134356
     /* 2134356 */ GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2134404), // Rule ID 48221 //
     /* 2134361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2134364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134367 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134374 */   // MIs[0] Operand 1
     /* 2134374 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2134379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134383 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134387 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2134387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2134390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134392 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134394 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134403 */   // GIR_Coverage, 48221,
     /* 2134403 */   GIR_EraseRootFromParent_Done,
     /* 2134404 */ // Label 28616: @2134404
     /* 2134404 */ GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2134452), // Rule ID 48246 //
     /* 2134409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134422 */   // MIs[0] Operand 1
     /* 2134422 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134431 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134435 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2134435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2134438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134451 */   // GIR_Coverage, 48246,
     /* 2134451 */   GIR_EraseRootFromParent_Done,
     /* 2134452 */ // Label 28617: @2134452
     /* 2134452 */ GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2134500), // Rule ID 48247 //
     /* 2134457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134470 */   // MIs[0] Operand 1
     /* 2134470 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134479 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134483 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2134483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2134486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134499 */   // GIR_Coverage, 48247,
     /* 2134499 */   GIR_EraseRootFromParent_Done,
     /* 2134500 */ // Label 28618: @2134500
     /* 2134500 */ GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2134548), // Rule ID 48252 //
     /* 2134505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134511 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134518 */   // MIs[0] Operand 1
     /* 2134518 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134527 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134531 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2134531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2134534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134536 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134547 */   // GIR_Coverage, 48252,
     /* 2134547 */   GIR_EraseRootFromParent_Done,
     /* 2134548 */ // Label 28619: @2134548
     /* 2134548 */ GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2134596), // Rule ID 48253 //
     /* 2134553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134566 */   // MIs[0] Operand 1
     /* 2134566 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134575 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134579 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2134579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2134582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134586 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134595 */   // GIR_Coverage, 48253,
     /* 2134595 */   GIR_EraseRootFromParent_Done,
     /* 2134596 */ // Label 28620: @2134596
     /* 2134596 */ GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2134644), // Rule ID 48256 //
     /* 2134601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134607 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134614 */   // MIs[0] Operand 1
     /* 2134614 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134623 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134627 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2134627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2134630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134634 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134643 */   // GIR_Coverage, 48256,
     /* 2134643 */   GIR_EraseRootFromParent_Done,
     /* 2134644 */ // Label 28621: @2134644
     /* 2134644 */ GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2134692), // Rule ID 48257 //
     /* 2134649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134662 */   // MIs[0] Operand 1
     /* 2134662 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134671 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134675 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2134675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2134678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134691 */   // GIR_Coverage, 48257,
     /* 2134691 */   GIR_EraseRootFromParent_Done,
     /* 2134692 */ // Label 28622: @2134692
     /* 2134692 */ GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2134740), // Rule ID 48264 //
     /* 2134697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2134700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134710 */   // MIs[0] Operand 1
     /* 2134710 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134719 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134723 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2134723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2134726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134739 */   // GIR_Coverage, 48264,
     /* 2134739 */   GIR_EraseRootFromParent_Done,
     /* 2134740 */ // Label 28623: @2134740
     /* 2134740 */ GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2134788), // Rule ID 48265 //
     /* 2134745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2134748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134758 */   // MIs[0] Operand 1
     /* 2134758 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2134763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134767 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134771 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2134771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2134774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134776 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2134780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134787 */   // GIR_Coverage, 48265,
     /* 2134787 */   GIR_EraseRootFromParent_Done,
     /* 2134788 */ // Label 28624: @2134788
     /* 2134788 */ GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2134836), // Rule ID 48290 //
     /* 2134793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134806 */   // MIs[0] Operand 1
     /* 2134806 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2134811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134815 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134819 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2134819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2134822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134824 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134835 */   // GIR_Coverage, 48290,
     /* 2134835 */   GIR_EraseRootFromParent_Done,
     /* 2134836 */ // Label 28625: @2134836
     /* 2134836 */ GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2134884), // Rule ID 48291 //
     /* 2134841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2134847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2134850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134854 */   // MIs[0] Operand 1
     /* 2134854 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2134859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134863 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134867 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2134867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2134870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134872 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2134882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134883 */   // GIR_Coverage, 48291,
     /* 2134883 */   GIR_EraseRootFromParent_Done,
     /* 2134884 */ // Label 28626: @2134884
     /* 2134884 */ GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2134932), // Rule ID 48296 //
     /* 2134889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134902 */   // MIs[0] Operand 1
     /* 2134902 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2134907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134915 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2134915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2134918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134931 */   // GIR_Coverage, 48296,
     /* 2134931 */   GIR_EraseRootFromParent_Done,
     /* 2134932 */ // Label 28627: @2134932
     /* 2134932 */ GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2134980), // Rule ID 48297 //
     /* 2134937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2134940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134950 */   // MIs[0] Operand 1
     /* 2134950 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2134955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134959 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134963 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2134963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2134966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134968 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2134970 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2134972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2134975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2134979 */   // GIR_Coverage, 48297,
     /* 2134979 */   GIR_EraseRootFromParent_Done,
     /* 2134980 */ // Label 28628: @2134980
     /* 2134980 */ GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2135028), // Rule ID 48300 //
     /* 2134985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2134988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134991 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134998 */   // MIs[0] Operand 1
     /* 2134998 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2135003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135007 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135011 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2135011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2135014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135016 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135018 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135027 */   // GIR_Coverage, 48300,
     /* 2135027 */   GIR_EraseRootFromParent_Done,
     /* 2135028 */ // Label 28629: @2135028
     /* 2135028 */ GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2135076), // Rule ID 48301 //
     /* 2135033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2135042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135046 */   // MIs[0] Operand 1
     /* 2135046 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2135051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135059 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2135059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2135062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135064 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135066 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135075 */   // GIR_Coverage, 48301,
     /* 2135075 */   GIR_EraseRootFromParent_Done,
     /* 2135076 */ // Label 28630: @2135076
     /* 2135076 */ GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2135124), // Rule ID 48308 //
     /* 2135081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2135084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135094 */   // MIs[0] Operand 1
     /* 2135094 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2135099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135103 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135107 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2135107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2135110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135112 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135114 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135123 */   // GIR_Coverage, 48308,
     /* 2135123 */   GIR_EraseRootFromParent_Done,
     /* 2135124 */ // Label 28631: @2135124
     /* 2135124 */ GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2135172), // Rule ID 48309 //
     /* 2135129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2135132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135142 */   // MIs[0] Operand 1
     /* 2135142 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2135147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135155 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2135155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2135158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135160 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135162 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135170 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135171 */   // GIR_Coverage, 48309,
     /* 2135171 */   GIR_EraseRootFromParent_Done,
     /* 2135172 */ // Label 28632: @2135172
     /* 2135172 */ GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2135220), // Rule ID 48334 //
     /* 2135177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2135183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2135186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135190 */   // MIs[0] Operand 1
     /* 2135190 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135199 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135203 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2135203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2135206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135208 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2135218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135219 */   // GIR_Coverage, 48334,
     /* 2135219 */   GIR_EraseRootFromParent_Done,
     /* 2135220 */ // Label 28633: @2135220
     /* 2135220 */ GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2135268), // Rule ID 48335 //
     /* 2135225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2135231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2135234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135238 */   // MIs[0] Operand 1
     /* 2135238 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135247 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135251 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2135251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2135254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135256 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2135266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135267 */   // GIR_Coverage, 48335,
     /* 2135267 */   GIR_EraseRootFromParent_Done,
     /* 2135268 */ // Label 28634: @2135268
     /* 2135268 */ GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2135316), // Rule ID 48340 //
     /* 2135273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2135279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135286 */   // MIs[0] Operand 1
     /* 2135286 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135299 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2135299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2135302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135304 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135315 */   // GIR_Coverage, 48340,
     /* 2135315 */   GIR_EraseRootFromParent_Done,
     /* 2135316 */ // Label 28635: @2135316
     /* 2135316 */ GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2135364), // Rule ID 48341 //
     /* 2135321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2135327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135334 */   // MIs[0] Operand 1
     /* 2135334 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135343 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135347 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2135347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2135350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135352 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135363 */   // GIR_Coverage, 48341,
     /* 2135363 */   GIR_EraseRootFromParent_Done,
     /* 2135364 */ // Label 28636: @2135364
     /* 2135364 */ GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2135412), // Rule ID 48344 //
     /* 2135369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2135378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135382 */   // MIs[0] Operand 1
     /* 2135382 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135391 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135395 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2135395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2135398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135400 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135411 */   // GIR_Coverage, 48344,
     /* 2135411 */   GIR_EraseRootFromParent_Done,
     /* 2135412 */ // Label 28637: @2135412
     /* 2135412 */ GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2135460), // Rule ID 48345 //
     /* 2135417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2135426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135430 */   // MIs[0] Operand 1
     /* 2135430 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135443 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2135443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2135446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135448 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135459 */   // GIR_Coverage, 48345,
     /* 2135459 */   GIR_EraseRootFromParent_Done,
     /* 2135460 */ // Label 28638: @2135460
     /* 2135460 */ GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2135508), // Rule ID 48352 //
     /* 2135465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2135468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135478 */   // MIs[0] Operand 1
     /* 2135478 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135491 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2135491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2135494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135496 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135498 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135507 */   // GIR_Coverage, 48352,
     /* 2135507 */   GIR_EraseRootFromParent_Done,
     /* 2135508 */ // Label 28639: @2135508
     /* 2135508 */ GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2135556), // Rule ID 48353 //
     /* 2135513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2135516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135526 */   // MIs[0] Operand 1
     /* 2135526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2135531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135535 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135539 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2135539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2135542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135544 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135546 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2135548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135555 */   // GIR_Coverage, 48353,
     /* 2135555 */   GIR_EraseRootFromParent_Done,
     /* 2135556 */ // Label 28640: @2135556
     /* 2135556 */ GIM_Reject,
     /* 2135557 */ // Label 28460: @2135557
     /* 2135557 */ GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2135605), // Rule ID 47942 //
     /* 2135562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2135568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2135571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135575 */   // MIs[0] Operand 1
     /* 2135575 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135588 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2135588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2135591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135593 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2135603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135604 */   // GIR_Coverage, 47942,
     /* 2135604 */   GIR_EraseRootFromParent_Done,
     /* 2135605 */ // Label 28641: @2135605
     /* 2135605 */ GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2135653), // Rule ID 47943 //
     /* 2135610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2135616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2135619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135623 */   // MIs[0] Operand 1
     /* 2135623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135632 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135636 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2135636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2135639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135641 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2135651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135652 */   // GIR_Coverage, 47943,
     /* 2135652 */   GIR_EraseRootFromParent_Done,
     /* 2135653 */ // Label 28642: @2135653
     /* 2135653 */ GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2135701), // Rule ID 47948 //
     /* 2135658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2135664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135671 */   // MIs[0] Operand 1
     /* 2135671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135684 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2135684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2135687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135689 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135700 */   // GIR_Coverage, 47948,
     /* 2135700 */   GIR_EraseRootFromParent_Done,
     /* 2135701 */ // Label 28643: @2135701
     /* 2135701 */ GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2135749), // Rule ID 47949 //
     /* 2135706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2135712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135719 */   // MIs[0] Operand 1
     /* 2135719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135732 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2135732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2135735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135737 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135748 */   // GIR_Coverage, 47949,
     /* 2135748 */   GIR_EraseRootFromParent_Done,
     /* 2135749 */ // Label 28644: @2135749
     /* 2135749 */ GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2135797), // Rule ID 47956 //
     /* 2135754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135760 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135767 */   // MIs[0] Operand 1
     /* 2135767 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135776 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135780 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2135780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2135783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135785 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135787 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135796 */   // GIR_Coverage, 47956,
     /* 2135796 */   GIR_EraseRootFromParent_Done,
     /* 2135797 */ // Label 28645: @2135797
     /* 2135797 */ GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2135845), // Rule ID 47957 //
     /* 2135802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135815 */   // MIs[0] Operand 1
     /* 2135815 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135828 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2135828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2135831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135833 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135835 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135844 */   // GIR_Coverage, 47957,
     /* 2135844 */   GIR_EraseRootFromParent_Done,
     /* 2135845 */ // Label 28646: @2135845
     /* 2135845 */ GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2135893), // Rule ID 47978 //
     /* 2135850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2135853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2135856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2135859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135863 */   // MIs[0] Operand 1
     /* 2135863 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135876 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2135876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2135879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135881 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135883 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135892 */   // GIR_Coverage, 47978,
     /* 2135892 */   GIR_EraseRootFromParent_Done,
     /* 2135893 */ // Label 28647: @2135893
     /* 2135893 */ GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2135941), // Rule ID 47979 //
     /* 2135898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2135901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2135904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2135907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135911 */   // MIs[0] Operand 1
     /* 2135911 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2135916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135920 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135924 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2135924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2135927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135929 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135931 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135940 */   // GIR_Coverage, 47979,
     /* 2135940 */   GIR_EraseRootFromParent_Done,
     /* 2135941 */ // Label 28648: @2135941
     /* 2135941 */ GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2135989), // Rule ID 47986 //
     /* 2135946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2135949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2135952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2135955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135959 */   // MIs[0] Operand 1
     /* 2135959 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2135964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135972 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2135972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2135975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135977 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2135979 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2135981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2135984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2135987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2135988 */   // GIR_Coverage, 47986,
     /* 2135988 */   GIR_EraseRootFromParent_Done,
     /* 2135989 */ // Label 28649: @2135989
     /* 2135989 */ GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2136037), // Rule ID 47987 //
     /* 2135994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2135997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2136000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2136003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136007 */   // MIs[0] Operand 1
     /* 2136007 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136016 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136020 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2136020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2136023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136025 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136027 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2136035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136036 */   // GIR_Coverage, 47987,
     /* 2136036 */   GIR_EraseRootFromParent_Done,
     /* 2136037 */ // Label 28650: @2136037
     /* 2136037 */ GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2136085), // Rule ID 47992 //
     /* 2136042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136055 */   // MIs[0] Operand 1
     /* 2136055 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136068 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2136068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2136071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136073 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136075 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136084 */   // GIR_Coverage, 47992,
     /* 2136084 */   GIR_EraseRootFromParent_Done,
     /* 2136085 */ // Label 28651: @2136085
     /* 2136085 */ GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2136133), // Rule ID 47993 //
     /* 2136090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136103 */   // MIs[0] Operand 1
     /* 2136103 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136116 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2136116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2136119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136121 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136123 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136132 */   // GIR_Coverage, 47993,
     /* 2136132 */   GIR_EraseRootFromParent_Done,
     /* 2136133 */ // Label 28652: @2136133
     /* 2136133 */ GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2136181), // Rule ID 48000 //
     /* 2136138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136151 */   // MIs[0] Operand 1
     /* 2136151 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136164 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2136164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2136167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136169 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136180 */   // GIR_Coverage, 48000,
     /* 2136180 */   GIR_EraseRootFromParent_Done,
     /* 2136181 */ // Label 28653: @2136181
     /* 2136181 */ GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2136229), // Rule ID 48001 //
     /* 2136186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136199 */   // MIs[0] Operand 1
     /* 2136199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136212 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2136212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2136215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136217 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136228 */   // GIR_Coverage, 48001,
     /* 2136228 */   GIR_EraseRootFromParent_Done,
     /* 2136229 */ // Label 28654: @2136229
     /* 2136229 */ GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2136277), // Rule ID 48022 //
     /* 2136234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2136237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136247 */   // MIs[0] Operand 1
     /* 2136247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136260 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2136260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2136263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136265 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136276 */   // GIR_Coverage, 48022,
     /* 2136276 */   GIR_EraseRootFromParent_Done,
     /* 2136277 */ // Label 28655: @2136277
     /* 2136277 */ GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2136325), // Rule ID 48023 //
     /* 2136282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2136285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136295 */   // MIs[0] Operand 1
     /* 2136295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2136300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136304 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136308 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2136308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2136311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136313 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136324 */   // GIR_Coverage, 48023,
     /* 2136324 */   GIR_EraseRootFromParent_Done,
     /* 2136325 */ // Label 28656: @2136325
     /* 2136325 */ GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2136373), // Rule ID 48030 //
     /* 2136330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2136336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2136339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136343 */   // MIs[0] Operand 1
     /* 2136343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136356 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2136356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2136359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2136371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136372 */   // GIR_Coverage, 48030,
     /* 2136372 */   GIR_EraseRootFromParent_Done,
     /* 2136373 */ // Label 28657: @2136373
     /* 2136373 */ GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2136421), // Rule ID 48031 //
     /* 2136378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2136384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2136387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136391 */   // MIs[0] Operand 1
     /* 2136391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136404 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2136404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2136407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136409 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2136419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136420 */   // GIR_Coverage, 48031,
     /* 2136420 */   GIR_EraseRootFromParent_Done,
     /* 2136421 */ // Label 28658: @2136421
     /* 2136421 */ GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2136469), // Rule ID 48036 //
     /* 2136426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136439 */   // MIs[0] Operand 1
     /* 2136439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136448 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136452 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2136452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2136455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136457 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136468 */   // GIR_Coverage, 48036,
     /* 2136468 */   GIR_EraseRootFromParent_Done,
     /* 2136469 */ // Label 28659: @2136469
     /* 2136469 */ GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2136517), // Rule ID 48037 //
     /* 2136474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136487 */   // MIs[0] Operand 1
     /* 2136487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136500 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2136500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2136503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136516 */   // GIR_Coverage, 48037,
     /* 2136516 */   GIR_EraseRootFromParent_Done,
     /* 2136517 */ // Label 28660: @2136517
     /* 2136517 */ GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2136565), // Rule ID 48044 //
     /* 2136522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136535 */   // MIs[0] Operand 1
     /* 2136535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136548 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2136548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2136551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136553 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136555 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136564 */   // GIR_Coverage, 48044,
     /* 2136564 */   GIR_EraseRootFromParent_Done,
     /* 2136565 */ // Label 28661: @2136565
     /* 2136565 */ GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2136613), // Rule ID 48045 //
     /* 2136570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136583 */   // MIs[0] Operand 1
     /* 2136583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136596 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2136596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2136599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136603 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136612 */   // GIR_Coverage, 48045,
     /* 2136612 */   GIR_EraseRootFromParent_Done,
     /* 2136613 */ // Label 28662: @2136613
     /* 2136613 */ GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2136661), // Rule ID 48066 //
     /* 2136618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2136621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136631 */   // MIs[0] Operand 1
     /* 2136631 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136644 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2136644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2136647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136649 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136660 */   // GIR_Coverage, 48066,
     /* 2136660 */   GIR_EraseRootFromParent_Done,
     /* 2136661 */ // Label 28663: @2136661
     /* 2136661 */ GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2136709), // Rule ID 48067 //
     /* 2136666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2136669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136679 */   // MIs[0] Operand 1
     /* 2136679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2136684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136692 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2136692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2136695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136697 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2136699 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2136701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136708 */   // GIR_Coverage, 48067,
     /* 2136708 */   GIR_EraseRootFromParent_Done,
     /* 2136709 */ // Label 28664: @2136709
     /* 2136709 */ GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2136757), // Rule ID 48072 //
     /* 2136714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2136720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2136723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136727 */   // MIs[0] Operand 1
     /* 2136727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136740 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2136740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2136743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2136755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136756 */   // GIR_Coverage, 48072,
     /* 2136756 */   GIR_EraseRootFromParent_Done,
     /* 2136757 */ // Label 28665: @2136757
     /* 2136757 */ GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2136805), // Rule ID 48073 //
     /* 2136762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2136768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2136771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136775 */   // MIs[0] Operand 1
     /* 2136775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136788 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2136788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2136791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136793 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2136803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136804 */   // GIR_Coverage, 48073,
     /* 2136804 */   GIR_EraseRootFromParent_Done,
     /* 2136805 */ // Label 28666: @2136805
     /* 2136805 */ GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2136853), // Rule ID 48078 //
     /* 2136810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136823 */   // MIs[0] Operand 1
     /* 2136823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136836 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2136836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2136839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136841 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136852 */   // GIR_Coverage, 48078,
     /* 2136852 */   GIR_EraseRootFromParent_Done,
     /* 2136853 */ // Label 28667: @2136853
     /* 2136853 */ GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2136901), // Rule ID 48079 //
     /* 2136858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136871 */   // MIs[0] Operand 1
     /* 2136871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136884 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2136884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2136887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136900 */   // GIR_Coverage, 48079,
     /* 2136900 */   GIR_EraseRootFromParent_Done,
     /* 2136901 */ // Label 28668: @2136901
     /* 2136901 */ GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2136949), // Rule ID 48086 //
     /* 2136906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2136909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136919 */   // MIs[0] Operand 1
     /* 2136919 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136928 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136932 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2136932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2136935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136937 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136939 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136948 */   // GIR_Coverage, 48086,
     /* 2136948 */   GIR_EraseRootFromParent_Done,
     /* 2136949 */ // Label 28669: @2136949
     /* 2136949 */ GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2136997), // Rule ID 48087 //
     /* 2136954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2136957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2136960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136967 */   // MIs[0] Operand 1
     /* 2136967 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2136972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136980 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2136980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2136983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136985 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136987 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2136989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2136992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2136996 */   // GIR_Coverage, 48087,
     /* 2136996 */   GIR_EraseRootFromParent_Done,
     /* 2136997 */ // Label 28670: @2136997
     /* 2136997 */ GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2137045), // Rule ID 48108 //
     /* 2137002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2137005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137015 */   // MIs[0] Operand 1
     /* 2137015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2137020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137028 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2137028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2137031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137033 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137035 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137044 */   // GIR_Coverage, 48108,
     /* 2137044 */   GIR_EraseRootFromParent_Done,
     /* 2137045 */ // Label 28671: @2137045
     /* 2137045 */ GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2137093), // Rule ID 48109 //
     /* 2137050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2137053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137056 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137063 */   // MIs[0] Operand 1
     /* 2137063 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2137068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137072 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137076 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2137076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2137079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137081 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137092 */   // GIR_Coverage, 48109,
     /* 2137092 */   GIR_EraseRootFromParent_Done,
     /* 2137093 */ // Label 28672: @2137093
     /* 2137093 */ GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2137141), // Rule ID 48116 //
     /* 2137098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137111 */   // MIs[0] Operand 1
     /* 2137111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137124 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2137124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2137127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137129 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137140 */   // GIR_Coverage, 48116,
     /* 2137140 */   GIR_EraseRootFromParent_Done,
     /* 2137141 */ // Label 28673: @2137141
     /* 2137141 */ GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2137189), // Rule ID 48117 //
     /* 2137146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137159 */   // MIs[0] Operand 1
     /* 2137159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137172 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2137172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2137175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137188 */   // GIR_Coverage, 48117,
     /* 2137188 */   GIR_EraseRootFromParent_Done,
     /* 2137189 */ // Label 28674: @2137189
     /* 2137189 */ GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2137237), // Rule ID 48122 //
     /* 2137194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137207 */   // MIs[0] Operand 1
     /* 2137207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137220 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2137220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2137223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137225 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137236 */   // GIR_Coverage, 48122,
     /* 2137236 */   GIR_EraseRootFromParent_Done,
     /* 2137237 */ // Label 28675: @2137237
     /* 2137237 */ GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2137285), // Rule ID 48123 //
     /* 2137242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137255 */   // MIs[0] Operand 1
     /* 2137255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137268 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2137268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2137271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137273 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137284 */   // GIR_Coverage, 48123,
     /* 2137284 */   GIR_EraseRootFromParent_Done,
     /* 2137285 */ // Label 28676: @2137285
     /* 2137285 */ GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2137333), // Rule ID 48130 //
     /* 2137290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137303 */   // MIs[0] Operand 1
     /* 2137303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137316 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2137316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2137319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137321 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137323 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137332 */   // GIR_Coverage, 48130,
     /* 2137332 */   GIR_EraseRootFromParent_Done,
     /* 2137333 */ // Label 28677: @2137333
     /* 2137333 */ GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2137381), // Rule ID 48131 //
     /* 2137338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137351 */   // MIs[0] Operand 1
     /* 2137351 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137364 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2137364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2137367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137369 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137380 */   // GIR_Coverage, 48131,
     /* 2137380 */   GIR_EraseRootFromParent_Done,
     /* 2137381 */ // Label 28678: @2137381
     /* 2137381 */ GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2137429), // Rule ID 48152 //
     /* 2137386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2137389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137399 */   // MIs[0] Operand 1
     /* 2137399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137412 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2137412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2137415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137428 */   // GIR_Coverage, 48152,
     /* 2137428 */   GIR_EraseRootFromParent_Done,
     /* 2137429 */ // Label 28679: @2137429
     /* 2137429 */ GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2137477), // Rule ID 48153 //
     /* 2137434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2137437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137447 */   // MIs[0] Operand 1
     /* 2137447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2137452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137460 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2137460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2137463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137476 */   // GIR_Coverage, 48153,
     /* 2137476 */   GIR_EraseRootFromParent_Done,
     /* 2137477 */ // Label 28680: @2137477
     /* 2137477 */ GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2137525), // Rule ID 48160 //
     /* 2137482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137495 */   // MIs[0] Operand 1
     /* 2137495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137508 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2137508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2137511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137513 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137515 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137524 */   // GIR_Coverage, 48160,
     /* 2137524 */   GIR_EraseRootFromParent_Done,
     /* 2137525 */ // Label 28681: @2137525
     /* 2137525 */ GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2137573), // Rule ID 48161 //
     /* 2137530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137543 */   // MIs[0] Operand 1
     /* 2137543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137556 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2137556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2137559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137561 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137563 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137572 */   // GIR_Coverage, 48161,
     /* 2137572 */   GIR_EraseRootFromParent_Done,
     /* 2137573 */ // Label 28682: @2137573
     /* 2137573 */ GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2137621), // Rule ID 48166 //
     /* 2137578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137591 */   // MIs[0] Operand 1
     /* 2137591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137604 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2137604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2137607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137609 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137611 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137620 */   // GIR_Coverage, 48166,
     /* 2137620 */   GIR_EraseRootFromParent_Done,
     /* 2137621 */ // Label 28683: @2137621
     /* 2137621 */ GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2137669), // Rule ID 48167 //
     /* 2137626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137639 */   // MIs[0] Operand 1
     /* 2137639 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137652 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2137652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2137655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137659 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137668 */   // GIR_Coverage, 48167,
     /* 2137668 */   GIR_EraseRootFromParent_Done,
     /* 2137669 */ // Label 28684: @2137669
     /* 2137669 */ GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2137717), // Rule ID 48174 //
     /* 2137674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137687 */   // MIs[0] Operand 1
     /* 2137687 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137696 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137700 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2137700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2137703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137707 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137716 */   // GIR_Coverage, 48174,
     /* 2137716 */   GIR_EraseRootFromParent_Done,
     /* 2137717 */ // Label 28685: @2137717
     /* 2137717 */ GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2137765), // Rule ID 48175 //
     /* 2137722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137735 */   // MIs[0] Operand 1
     /* 2137735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137748 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2137748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2137751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137755 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137764 */   // GIR_Coverage, 48175,
     /* 2137764 */   GIR_EraseRootFromParent_Done,
     /* 2137765 */ // Label 28686: @2137765
     /* 2137765 */ GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2137813), // Rule ID 48196 //
     /* 2137770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2137773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137783 */   // MIs[0] Operand 1
     /* 2137783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137796 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2137796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2137799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137803 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137812 */   // GIR_Coverage, 48196,
     /* 2137812 */   GIR_EraseRootFromParent_Done,
     /* 2137813 */ // Label 28687: @2137813
     /* 2137813 */ GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2137861), // Rule ID 48197 //
     /* 2137818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2137821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137831 */   // MIs[0] Operand 1
     /* 2137831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2137836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137844 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2137844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2137847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2137853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137860 */   // GIR_Coverage, 48197,
     /* 2137860 */   GIR_EraseRootFromParent_Done,
     /* 2137861 */ // Label 28688: @2137861
     /* 2137861 */ GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2137909), // Rule ID 48204 //
     /* 2137866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137879 */   // MIs[0] Operand 1
     /* 2137879 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2137884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137888 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137892 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2137892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2137895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137897 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137899 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137908 */   // GIR_Coverage, 48204,
     /* 2137908 */   GIR_EraseRootFromParent_Done,
     /* 2137909 */ // Label 28689: @2137909
     /* 2137909 */ GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2137957), // Rule ID 48205 //
     /* 2137914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2137917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2137920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2137923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137927 */   // MIs[0] Operand 1
     /* 2137927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2137932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137940 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2137940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2137943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137945 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137947 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2137952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2137955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2137956 */   // GIR_Coverage, 48205,
     /* 2137956 */   GIR_EraseRootFromParent_Done,
     /* 2137957 */ // Label 28690: @2137957
     /* 2137957 */ GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2138005), // Rule ID 48210 //
     /* 2137962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2137965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137975 */   // MIs[0] Operand 1
     /* 2137975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2137980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137984 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137988 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2137988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2137991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137993 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2137995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2137997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138004 */   // GIR_Coverage, 48210,
     /* 2138004 */   GIR_EraseRootFromParent_Done,
     /* 2138005 */ // Label 28691: @2138005
     /* 2138005 */ GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2138053), // Rule ID 48211 //
     /* 2138010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138023 */   // MIs[0] Operand 1
     /* 2138023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2138028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138036 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2138036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2138039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138043 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138052 */   // GIR_Coverage, 48211,
     /* 2138052 */   GIR_EraseRootFromParent_Done,
     /* 2138053 */ // Label 28692: @2138053
     /* 2138053 */ GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2138101), // Rule ID 48218 //
     /* 2138058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138071 */   // MIs[0] Operand 1
     /* 2138071 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2138076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138084 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2138084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2138087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138089 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138091 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138100 */   // GIR_Coverage, 48218,
     /* 2138100 */   GIR_EraseRootFromParent_Done,
     /* 2138101 */ // Label 28693: @2138101
     /* 2138101 */ GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2138149), // Rule ID 48219 //
     /* 2138106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138119 */   // MIs[0] Operand 1
     /* 2138119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2138124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138132 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2138132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2138135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138139 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138148 */   // GIR_Coverage, 48219,
     /* 2138148 */   GIR_EraseRootFromParent_Done,
     /* 2138149 */ // Label 28694: @2138149
     /* 2138149 */ GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2138197), // Rule ID 48240 //
     /* 2138154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2138157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138167 */   // MIs[0] Operand 1
     /* 2138167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2138172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138180 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2138180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2138183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138187 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138196 */   // GIR_Coverage, 48240,
     /* 2138196 */   GIR_EraseRootFromParent_Done,
     /* 2138197 */ // Label 28695: @2138197
     /* 2138197 */ GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2138245), // Rule ID 48241 //
     /* 2138202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2138205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138215 */   // MIs[0] Operand 1
     /* 2138215 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2138220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138228 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2138228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2138231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138233 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138235 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138244 */   // GIR_Coverage, 48241,
     /* 2138244 */   GIR_EraseRootFromParent_Done,
     /* 2138245 */ // Label 28696: @2138245
     /* 2138245 */ GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2138293), // Rule ID 48248 //
     /* 2138250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2138256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2138259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138263 */   // MIs[0] Operand 1
     /* 2138263 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138276 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2138276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2138279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2138291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138292 */   // GIR_Coverage, 48248,
     /* 2138292 */   GIR_EraseRootFromParent_Done,
     /* 2138293 */ // Label 28697: @2138293
     /* 2138293 */ GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2138341), // Rule ID 48249 //
     /* 2138298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2138304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2138307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138311 */   // MIs[0] Operand 1
     /* 2138311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138324 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2138324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2138327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2138339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138340 */   // GIR_Coverage, 48249,
     /* 2138340 */   GIR_EraseRootFromParent_Done,
     /* 2138341 */ // Label 28698: @2138341
     /* 2138341 */ GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2138389), // Rule ID 48254 //
     /* 2138346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138359 */   // MIs[0] Operand 1
     /* 2138359 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138372 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2138372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2138375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138388 */   // GIR_Coverage, 48254,
     /* 2138388 */   GIR_EraseRootFromParent_Done,
     /* 2138389 */ // Label 28699: @2138389
     /* 2138389 */ GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2138437), // Rule ID 48255 //
     /* 2138394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138407 */   // MIs[0] Operand 1
     /* 2138407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138420 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2138420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2138423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138427 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138436 */   // GIR_Coverage, 48255,
     /* 2138436 */   GIR_EraseRootFromParent_Done,
     /* 2138437 */ // Label 28700: @2138437
     /* 2138437 */ GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2138485), // Rule ID 48262 //
     /* 2138442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138455 */   // MIs[0] Operand 1
     /* 2138455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138468 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2138468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2138471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138475 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138484 */   // GIR_Coverage, 48262,
     /* 2138484 */   GIR_EraseRootFromParent_Done,
     /* 2138485 */ // Label 28701: @2138485
     /* 2138485 */ GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2138533), // Rule ID 48263 //
     /* 2138490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138503 */   // MIs[0] Operand 1
     /* 2138503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138516 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2138516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2138519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138521 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138523 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138532 */   // GIR_Coverage, 48263,
     /* 2138532 */   GIR_EraseRootFromParent_Done,
     /* 2138533 */ // Label 28702: @2138533
     /* 2138533 */ GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2138581), // Rule ID 48284 //
     /* 2138538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2138541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138551 */   // MIs[0] Operand 1
     /* 2138551 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138560 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138564 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2138564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2138567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138569 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138571 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138580 */   // GIR_Coverage, 48284,
     /* 2138580 */   GIR_EraseRootFromParent_Done,
     /* 2138581 */ // Label 28703: @2138581
     /* 2138581 */ GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2138629), // Rule ID 48285 //
     /* 2138586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2138589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138599 */   // MIs[0] Operand 1
     /* 2138599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2138604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138612 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2138612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2138615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138617 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138619 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2138621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138628 */   // GIR_Coverage, 48285,
     /* 2138628 */   GIR_EraseRootFromParent_Done,
     /* 2138629 */ // Label 28704: @2138629
     /* 2138629 */ GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2138677), // Rule ID 48292 //
     /* 2138634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2138640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2138643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138647 */   // MIs[0] Operand 1
     /* 2138647 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138660 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2138660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2138663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2138675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138676 */   // GIR_Coverage, 48292,
     /* 2138676 */   GIR_EraseRootFromParent_Done,
     /* 2138677 */ // Label 28705: @2138677
     /* 2138677 */ GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2138725), // Rule ID 48293 //
     /* 2138682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2138688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2138691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138695 */   // MIs[0] Operand 1
     /* 2138695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138708 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2138708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2138711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2138723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138724 */   // GIR_Coverage, 48293,
     /* 2138724 */   GIR_EraseRootFromParent_Done,
     /* 2138725 */ // Label 28706: @2138725
     /* 2138725 */ GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2138773), // Rule ID 48298 //
     /* 2138730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138743 */   // MIs[0] Operand 1
     /* 2138743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138756 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2138756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2138759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138772 */   // GIR_Coverage, 48298,
     /* 2138772 */   GIR_EraseRootFromParent_Done,
     /* 2138773 */ // Label 28707: @2138773
     /* 2138773 */ GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2138821), // Rule ID 48299 //
     /* 2138778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138791 */   // MIs[0] Operand 1
     /* 2138791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138804 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2138804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2138807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138820 */   // GIR_Coverage, 48299,
     /* 2138820 */   GIR_EraseRootFromParent_Done,
     /* 2138821 */ // Label 28708: @2138821
     /* 2138821 */ GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2138869), // Rule ID 48306 //
     /* 2138826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2138829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138839 */   // MIs[0] Operand 1
     /* 2138839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138852 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2138852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2138855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138859 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138868 */   // GIR_Coverage, 48306,
     /* 2138868 */   GIR_EraseRootFromParent_Done,
     /* 2138869 */ // Label 28709: @2138869
     /* 2138869 */ GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2138917), // Rule ID 48307 //
     /* 2138874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2138877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138887 */   // MIs[0] Operand 1
     /* 2138887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138900 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2138900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2138903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138907 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138916 */   // GIR_Coverage, 48307,
     /* 2138916 */   GIR_EraseRootFromParent_Done,
     /* 2138917 */ // Label 28710: @2138917
     /* 2138917 */ GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2138965), // Rule ID 48328 //
     /* 2138922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2138925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138935 */   // MIs[0] Operand 1
     /* 2138935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138948 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2138948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2138951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138953 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2138955 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2138957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2138960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2138964 */   // GIR_Coverage, 48328,
     /* 2138964 */   GIR_EraseRootFromParent_Done,
     /* 2138965 */ // Label 28711: @2138965
     /* 2138965 */ GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2139013), // Rule ID 48329 //
     /* 2138970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2138973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138983 */   // MIs[0] Operand 1
     /* 2138983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2138988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138996 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2138996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2138999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139003 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139012 */   // GIR_Coverage, 48329,
     /* 2139012 */   GIR_EraseRootFromParent_Done,
     /* 2139013 */ // Label 28712: @2139013
     /* 2139013 */ GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2139061), // Rule ID 48336 //
     /* 2139018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2139024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2139027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139031 */   // MIs[0] Operand 1
     /* 2139031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139044 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2139044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2139047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139049 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139060 */   // GIR_Coverage, 48336,
     /* 2139060 */   GIR_EraseRootFromParent_Done,
     /* 2139061 */ // Label 28713: @2139061
     /* 2139061 */ GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2139109), // Rule ID 48337 //
     /* 2139066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2139072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2139075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139079 */   // MIs[0] Operand 1
     /* 2139079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139092 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2139092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2139095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139097 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139108 */   // GIR_Coverage, 48337,
     /* 2139108 */   GIR_EraseRootFromParent_Done,
     /* 2139109 */ // Label 28714: @2139109
     /* 2139109 */ GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2139157), // Rule ID 48342 //
     /* 2139114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139127 */   // MIs[0] Operand 1
     /* 2139127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139140 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2139140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2139143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139156 */   // GIR_Coverage, 48342,
     /* 2139156 */   GIR_EraseRootFromParent_Done,
     /* 2139157 */ // Label 28715: @2139157
     /* 2139157 */ GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2139205), // Rule ID 48343 //
     /* 2139162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139175 */   // MIs[0] Operand 1
     /* 2139175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139188 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2139188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2139191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139204 */   // GIR_Coverage, 48343,
     /* 2139204 */   GIR_EraseRootFromParent_Done,
     /* 2139205 */ // Label 28716: @2139205
     /* 2139205 */ GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2139253), // Rule ID 48350 //
     /* 2139210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2139216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2139219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139223 */   // MIs[0] Operand 1
     /* 2139223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139236 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2139236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2139239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139241 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139252 */   // GIR_Coverage, 48350,
     /* 2139252 */   GIR_EraseRootFromParent_Done,
     /* 2139253 */ // Label 28717: @2139253
     /* 2139253 */ GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2139301), // Rule ID 48351 //
     /* 2139258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2139264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2139267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139271 */   // MIs[0] Operand 1
     /* 2139271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139284 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2139284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2139287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139289 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139291 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139300 */   // GIR_Coverage, 48351,
     /* 2139300 */   GIR_EraseRootFromParent_Done,
     /* 2139301 */ // Label 28718: @2139301
     /* 2139301 */ GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2139349), // Rule ID 48372 //
     /* 2139306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2139309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139319 */   // MIs[0] Operand 1
     /* 2139319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139332 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2139332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2139335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139337 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139348 */   // GIR_Coverage, 48372,
     /* 2139348 */   GIR_EraseRootFromParent_Done,
     /* 2139349 */ // Label 28719: @2139349
     /* 2139349 */ GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2139397), // Rule ID 48373 //
     /* 2139354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2139357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139367 */   // MIs[0] Operand 1
     /* 2139367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2139372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139380 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2139380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2139383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139385 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2139389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139396 */   // GIR_Coverage, 48373,
     /* 2139396 */   GIR_EraseRootFromParent_Done,
     /* 2139397 */ // Label 28720: @2139397
     /* 2139397 */ GIM_Reject,
     /* 2139398 */ // Label 28461: @2139398
     /* 2139398 */ GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2139446), // Rule ID 47944 //
     /* 2139403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2139409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2139412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139416 */   // MIs[0] Operand 1
     /* 2139416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139429 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2139429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2139432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139445 */   // GIR_Coverage, 47944,
     /* 2139445 */   GIR_EraseRootFromParent_Done,
     /* 2139446 */ // Label 28721: @2139446
     /* 2139446 */ GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2139494), // Rule ID 47945 //
     /* 2139451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2139457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2139460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139464 */   // MIs[0] Operand 1
     /* 2139464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139477 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2139477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2139480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139493 */   // GIR_Coverage, 47945,
     /* 2139493 */   GIR_EraseRootFromParent_Done,
     /* 2139494 */ // Label 28722: @2139494
     /* 2139494 */ GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2139542), // Rule ID 47954 //
     /* 2139499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139512 */   // MIs[0] Operand 1
     /* 2139512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139525 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2139525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2139528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139541 */   // GIR_Coverage, 47954,
     /* 2139541 */   GIR_EraseRootFromParent_Done,
     /* 2139542 */ // Label 28723: @2139542
     /* 2139542 */ GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2139590), // Rule ID 47955 //
     /* 2139547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139560 */   // MIs[0] Operand 1
     /* 2139560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139573 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2139573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2139576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139589 */   // GIR_Coverage, 47955,
     /* 2139589 */   GIR_EraseRootFromParent_Done,
     /* 2139590 */ // Label 28724: @2139590
     /* 2139590 */ GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2139638), // Rule ID 47972 //
     /* 2139595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139608 */   // MIs[0] Operand 1
     /* 2139608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139621 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2139621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2139624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139628 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139637 */   // GIR_Coverage, 47972,
     /* 2139637 */   GIR_EraseRootFromParent_Done,
     /* 2139638 */ // Label 28725: @2139638
     /* 2139638 */ GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2139686), // Rule ID 47973 //
     /* 2139643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139656 */   // MIs[0] Operand 1
     /* 2139656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139669 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2139669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2139672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139676 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139685 */   // GIR_Coverage, 47973,
     /* 2139685 */   GIR_EraseRootFromParent_Done,
     /* 2139686 */ // Label 28726: @2139686
     /* 2139686 */ GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2139734), // Rule ID 47980 //
     /* 2139691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2139694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139704 */   // MIs[0] Operand 1
     /* 2139704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139717 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2139717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2139720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139724 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139733 */   // GIR_Coverage, 47980,
     /* 2139733 */   GIR_EraseRootFromParent_Done,
     /* 2139734 */ // Label 28727: @2139734
     /* 2139734 */ GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2139782), // Rule ID 47981 //
     /* 2139739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2139742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139752 */   // MIs[0] Operand 1
     /* 2139752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2139757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139765 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2139765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2139768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139770 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139772 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139781 */   // GIR_Coverage, 47981,
     /* 2139781 */   GIR_EraseRootFromParent_Done,
     /* 2139782 */ // Label 28728: @2139782
     /* 2139782 */ GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2139830), // Rule ID 47988 //
     /* 2139787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2139793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2139796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139800 */   // MIs[0] Operand 1
     /* 2139800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2139805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139813 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2139813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2139816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139818 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139820 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139829 */   // GIR_Coverage, 47988,
     /* 2139829 */   GIR_EraseRootFromParent_Done,
     /* 2139830 */ // Label 28729: @2139830
     /* 2139830 */ GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2139878), // Rule ID 47989 //
     /* 2139835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2139841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2139844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139848 */   // MIs[0] Operand 1
     /* 2139848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2139853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139861 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2139861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2139864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139866 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139868 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2139876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139877 */   // GIR_Coverage, 47989,
     /* 2139877 */   GIR_EraseRootFromParent_Done,
     /* 2139878 */ // Label 28730: @2139878
     /* 2139878 */ GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2139926), // Rule ID 47998 //
     /* 2139883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139896 */   // MIs[0] Operand 1
     /* 2139896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2139901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139909 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2139909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2139912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139925 */   // GIR_Coverage, 47998,
     /* 2139925 */   GIR_EraseRootFromParent_Done,
     /* 2139926 */ // Label 28731: @2139926
     /* 2139926 */ GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2139974), // Rule ID 47999 //
     /* 2139931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2139934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139944 */   // MIs[0] Operand 1
     /* 2139944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2139949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139957 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2139957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2139960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2139964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2139966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2139969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2139973 */   // GIR_Coverage, 47999,
     /* 2139973 */   GIR_EraseRootFromParent_Done,
     /* 2139974 */ // Label 28732: @2139974
     /* 2139974 */ GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2140022), // Rule ID 48016 //
     /* 2139979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2139982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139992 */   // MIs[0] Operand 1
     /* 2139992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2139997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140005 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2140005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2140008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140021 */   // GIR_Coverage, 48016,
     /* 2140021 */   GIR_EraseRootFromParent_Done,
     /* 2140022 */ // Label 28733: @2140022
     /* 2140022 */ GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2140070), // Rule ID 48017 //
     /* 2140027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140040 */   // MIs[0] Operand 1
     /* 2140040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2140045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140053 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2140053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2140056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140069 */   // GIR_Coverage, 48017,
     /* 2140069 */   GIR_EraseRootFromParent_Done,
     /* 2140070 */ // Label 28734: @2140070
     /* 2140070 */ GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2140118), // Rule ID 48024 //
     /* 2140075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2140078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140088 */   // MIs[0] Operand 1
     /* 2140088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2140093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140101 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2140101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2140104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140117 */   // GIR_Coverage, 48024,
     /* 2140117 */   GIR_EraseRootFromParent_Done,
     /* 2140118 */ // Label 28735: @2140118
     /* 2140118 */ GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2140166), // Rule ID 48025 //
     /* 2140123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2140126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140136 */   // MIs[0] Operand 1
     /* 2140136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2140141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140149 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2140149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2140152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140154 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140165 */   // GIR_Coverage, 48025,
     /* 2140165 */   GIR_EraseRootFromParent_Done,
     /* 2140166 */ // Label 28736: @2140166
     /* 2140166 */ GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2140214), // Rule ID 48032 //
     /* 2140171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140184 */   // MIs[0] Operand 1
     /* 2140184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140197 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2140197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2140200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2140212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140213 */   // GIR_Coverage, 48032,
     /* 2140213 */   GIR_EraseRootFromParent_Done,
     /* 2140214 */ // Label 28737: @2140214
     /* 2140214 */ GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2140262), // Rule ID 48033 //
     /* 2140219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140232 */   // MIs[0] Operand 1
     /* 2140232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140245 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2140245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2140248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2140260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140261 */   // GIR_Coverage, 48033,
     /* 2140261 */   GIR_EraseRootFromParent_Done,
     /* 2140262 */ // Label 28738: @2140262
     /* 2140262 */ GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2140310), // Rule ID 48042 //
     /* 2140267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140280 */   // MIs[0] Operand 1
     /* 2140280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140293 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2140293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2140296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140309 */   // GIR_Coverage, 48042,
     /* 2140309 */   GIR_EraseRootFromParent_Done,
     /* 2140310 */ // Label 28739: @2140310
     /* 2140310 */ GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2140358), // Rule ID 48043 //
     /* 2140315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140328 */   // MIs[0] Operand 1
     /* 2140328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140341 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2140341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2140344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140357 */   // GIR_Coverage, 48043,
     /* 2140357 */   GIR_EraseRootFromParent_Done,
     /* 2140358 */ // Label 28740: @2140358
     /* 2140358 */ GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2140406), // Rule ID 48060 //
     /* 2140363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140376 */   // MIs[0] Operand 1
     /* 2140376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140389 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2140389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2140392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140405 */   // GIR_Coverage, 48060,
     /* 2140405 */   GIR_EraseRootFromParent_Done,
     /* 2140406 */ // Label 28741: @2140406
     /* 2140406 */ GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2140454), // Rule ID 48061 //
     /* 2140411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140424 */   // MIs[0] Operand 1
     /* 2140424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140437 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2140437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2140440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140453 */   // GIR_Coverage, 48061,
     /* 2140453 */   GIR_EraseRootFromParent_Done,
     /* 2140454 */ // Label 28742: @2140454
     /* 2140454 */ GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2140502), // Rule ID 48068 //
     /* 2140459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2140462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140472 */   // MIs[0] Operand 1
     /* 2140472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140485 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2140485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2140488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140492 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140501 */   // GIR_Coverage, 48068,
     /* 2140501 */   GIR_EraseRootFromParent_Done,
     /* 2140502 */ // Label 28743: @2140502
     /* 2140502 */ GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2140550), // Rule ID 48069 //
     /* 2140507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2140510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140520 */   // MIs[0] Operand 1
     /* 2140520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2140525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140533 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2140533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2140536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140549 */   // GIR_Coverage, 48069,
     /* 2140549 */   GIR_EraseRootFromParent_Done,
     /* 2140550 */ // Label 28744: @2140550
     /* 2140550 */ GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2140598), // Rule ID 48074 //
     /* 2140555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140568 */   // MIs[0] Operand 1
     /* 2140568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140581 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2140581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2140584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140586 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2140596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140597 */   // GIR_Coverage, 48074,
     /* 2140597 */   GIR_EraseRootFromParent_Done,
     /* 2140598 */ // Label 28745: @2140598
     /* 2140598 */ GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2140646), // Rule ID 48075 //
     /* 2140603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140616 */   // MIs[0] Operand 1
     /* 2140616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140629 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2140629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2140632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140634 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2140644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140645 */   // GIR_Coverage, 48075,
     /* 2140645 */   GIR_EraseRootFromParent_Done,
     /* 2140646 */ // Label 28746: @2140646
     /* 2140646 */ GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2140694), // Rule ID 48084 //
     /* 2140651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140664 */   // MIs[0] Operand 1
     /* 2140664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140677 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2140677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2140680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140682 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140693 */   // GIR_Coverage, 48084,
     /* 2140693 */   GIR_EraseRootFromParent_Done,
     /* 2140694 */ // Label 28747: @2140694
     /* 2140694 */ GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2140742), // Rule ID 48085 //
     /* 2140699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140712 */   // MIs[0] Operand 1
     /* 2140712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140725 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2140725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2140728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140741 */   // GIR_Coverage, 48085,
     /* 2140741 */   GIR_EraseRootFromParent_Done,
     /* 2140742 */ // Label 28748: @2140742
     /* 2140742 */ GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2140790), // Rule ID 48102 //
     /* 2140747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140760 */   // MIs[0] Operand 1
     /* 2140760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140773 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2140773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2140776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140778 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140789 */   // GIR_Coverage, 48102,
     /* 2140789 */   GIR_EraseRootFromParent_Done,
     /* 2140790 */ // Label 28749: @2140790
     /* 2140790 */ GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2140838), // Rule ID 48103 //
     /* 2140795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140808 */   // MIs[0] Operand 1
     /* 2140808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140821 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2140821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2140824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140828 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140837 */   // GIR_Coverage, 48103,
     /* 2140837 */   GIR_EraseRootFromParent_Done,
     /* 2140838 */ // Label 28750: @2140838
     /* 2140838 */ GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2140886), // Rule ID 48110 //
     /* 2140843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2140846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140856 */   // MIs[0] Operand 1
     /* 2140856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140869 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2140869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2140872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140885 */   // GIR_Coverage, 48110,
     /* 2140885 */   GIR_EraseRootFromParent_Done,
     /* 2140886 */ // Label 28751: @2140886
     /* 2140886 */ GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2140934), // Rule ID 48111 //
     /* 2140891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2140894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140904 */   // MIs[0] Operand 1
     /* 2140904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2140909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140917 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2140917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2140920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2140926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140933 */   // GIR_Coverage, 48111,
     /* 2140933 */   GIR_EraseRootFromParent_Done,
     /* 2140934 */ // Label 28752: @2140934
     /* 2140934 */ GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2140982), // Rule ID 48118 //
     /* 2140939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2140942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140952 */   // MIs[0] Operand 1
     /* 2140952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2140957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140965 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2140965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2140968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2140972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2140974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2140977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2140980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2140981 */   // GIR_Coverage, 48118,
     /* 2140981 */   GIR_EraseRootFromParent_Done,
     /* 2140982 */ // Label 28753: @2140982
     /* 2140982 */ GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2141030), // Rule ID 48119 //
     /* 2140987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2140990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2140993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2140996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141000 */   // MIs[0] Operand 1
     /* 2141000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141013 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2141013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2141016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2141028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141029 */   // GIR_Coverage, 48119,
     /* 2141029 */   GIR_EraseRootFromParent_Done,
     /* 2141030 */ // Label 28754: @2141030
     /* 2141030 */ GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2141078), // Rule ID 48128 //
     /* 2141035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141048 */   // MIs[0] Operand 1
     /* 2141048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141061 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2141061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2141064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141077 */   // GIR_Coverage, 48128,
     /* 2141077 */   GIR_EraseRootFromParent_Done,
     /* 2141078 */ // Label 28755: @2141078
     /* 2141078 */ GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2141126), // Rule ID 48129 //
     /* 2141083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141096 */   // MIs[0] Operand 1
     /* 2141096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141109 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2141109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2141112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141125 */   // GIR_Coverage, 48129,
     /* 2141125 */   GIR_EraseRootFromParent_Done,
     /* 2141126 */ // Label 28756: @2141126
     /* 2141126 */ GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2141174), // Rule ID 48146 //
     /* 2141131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141144 */   // MIs[0] Operand 1
     /* 2141144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141157 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2141157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2141160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141173 */   // GIR_Coverage, 48146,
     /* 2141173 */   GIR_EraseRootFromParent_Done,
     /* 2141174 */ // Label 28757: @2141174
     /* 2141174 */ GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2141222), // Rule ID 48147 //
     /* 2141179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141192 */   // MIs[0] Operand 1
     /* 2141192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141205 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2141205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2141208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141221 */   // GIR_Coverage, 48147,
     /* 2141221 */   GIR_EraseRootFromParent_Done,
     /* 2141222 */ // Label 28758: @2141222
     /* 2141222 */ GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2141270), // Rule ID 48154 //
     /* 2141227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2141230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141240 */   // MIs[0] Operand 1
     /* 2141240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141253 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2141253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2141256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141269 */   // GIR_Coverage, 48154,
     /* 2141269 */   GIR_EraseRootFromParent_Done,
     /* 2141270 */ // Label 28759: @2141270
     /* 2141270 */ GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2141318), // Rule ID 48155 //
     /* 2141275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2141278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141288 */   // MIs[0] Operand 1
     /* 2141288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2141293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141301 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2141301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2141304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141317 */   // GIR_Coverage, 48155,
     /* 2141317 */   GIR_EraseRootFromParent_Done,
     /* 2141318 */ // Label 28760: @2141318
     /* 2141318 */ GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2141366), // Rule ID 48162 //
     /* 2141323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2141329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2141332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141336 */   // MIs[0] Operand 1
     /* 2141336 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141349 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2141349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2141352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141354 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2141364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141365 */   // GIR_Coverage, 48162,
     /* 2141365 */   GIR_EraseRootFromParent_Done,
     /* 2141366 */ // Label 28761: @2141366
     /* 2141366 */ GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2141414), // Rule ID 48163 //
     /* 2141371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2141377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2141380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141384 */   // MIs[0] Operand 1
     /* 2141384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141397 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2141397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2141400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141402 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2141412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141413 */   // GIR_Coverage, 48163,
     /* 2141413 */   GIR_EraseRootFromParent_Done,
     /* 2141414 */ // Label 28762: @2141414
     /* 2141414 */ GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2141462), // Rule ID 48172 //
     /* 2141419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141432 */   // MIs[0] Operand 1
     /* 2141432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141445 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2141445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2141448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141450 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141461 */   // GIR_Coverage, 48172,
     /* 2141461 */   GIR_EraseRootFromParent_Done,
     /* 2141462 */ // Label 28763: @2141462
     /* 2141462 */ GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2141510), // Rule ID 48173 //
     /* 2141467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141480 */   // MIs[0] Operand 1
     /* 2141480 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141493 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2141493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2141496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141500 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141509 */   // GIR_Coverage, 48173,
     /* 2141509 */   GIR_EraseRootFromParent_Done,
     /* 2141510 */ // Label 28764: @2141510
     /* 2141510 */ GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2141558), // Rule ID 48190 //
     /* 2141515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141528 */   // MIs[0] Operand 1
     /* 2141528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141541 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2141541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2141544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141546 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141548 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141557 */   // GIR_Coverage, 48190,
     /* 2141557 */   GIR_EraseRootFromParent_Done,
     /* 2141558 */ // Label 28765: @2141558
     /* 2141558 */ GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2141606), // Rule ID 48191 //
     /* 2141563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141576 */   // MIs[0] Operand 1
     /* 2141576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141589 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2141589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2141592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141605 */   // GIR_Coverage, 48191,
     /* 2141605 */   GIR_EraseRootFromParent_Done,
     /* 2141606 */ // Label 28766: @2141606
     /* 2141606 */ GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2141654), // Rule ID 48198 //
     /* 2141611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2141614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141624 */   // MIs[0] Operand 1
     /* 2141624 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141633 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141637 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2141637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2141640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141644 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141653 */   // GIR_Coverage, 48198,
     /* 2141653 */   GIR_EraseRootFromParent_Done,
     /* 2141654 */ // Label 28767: @2141654
     /* 2141654 */ GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2141702), // Rule ID 48199 //
     /* 2141659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2141662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141672 */   // MIs[0] Operand 1
     /* 2141672 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2141677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141681 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141685 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2141685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2141688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141692 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2141694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141701 */   // GIR_Coverage, 48199,
     /* 2141701 */   GIR_EraseRootFromParent_Done,
     /* 2141702 */ // Label 28768: @2141702
     /* 2141702 */ GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2141750), // Rule ID 48206 //
     /* 2141707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2141713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2141716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141720 */   // MIs[0] Operand 1
     /* 2141720 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141729 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141733 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2141733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2141736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141738 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141740 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2141748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141749 */   // GIR_Coverage, 48206,
     /* 2141749 */   GIR_EraseRootFromParent_Done,
     /* 2141750 */ // Label 28769: @2141750
     /* 2141750 */ GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2141798), // Rule ID 48207 //
     /* 2141755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2141761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2141764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141768 */   // MIs[0] Operand 1
     /* 2141768 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141781 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2141781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2141784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141788 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2141796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141797 */   // GIR_Coverage, 48207,
     /* 2141797 */   GIR_EraseRootFromParent_Done,
     /* 2141798 */ // Label 28770: @2141798
     /* 2141798 */ GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2141846), // Rule ID 48216 //
     /* 2141803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141816 */   // MIs[0] Operand 1
     /* 2141816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141829 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2141829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2141832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141845 */   // GIR_Coverage, 48216,
     /* 2141845 */   GIR_EraseRootFromParent_Done,
     /* 2141846 */ // Label 28771: @2141846
     /* 2141846 */ GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2141894), // Rule ID 48217 //
     /* 2141851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141864 */   // MIs[0] Operand 1
     /* 2141864 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141877 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2141877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2141880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141884 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141893 */   // GIR_Coverage, 48217,
     /* 2141893 */   GIR_EraseRootFromParent_Done,
     /* 2141894 */ // Label 28772: @2141894
     /* 2141894 */ GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2141942), // Rule ID 48234 //
     /* 2141899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2141902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141912 */   // MIs[0] Operand 1
     /* 2141912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141921 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141925 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2141925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2141928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141930 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141932 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141941 */   // GIR_Coverage, 48234,
     /* 2141941 */   GIR_EraseRootFromParent_Done,
     /* 2141942 */ // Label 28773: @2141942
     /* 2141942 */ GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2141990), // Rule ID 48235 //
     /* 2141947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2141950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141960 */   // MIs[0] Operand 1
     /* 2141960 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2141965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141973 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2141973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2141976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141978 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2141980 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2141982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2141985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141989 */   // GIR_Coverage, 48235,
     /* 2141989 */   GIR_EraseRootFromParent_Done,
     /* 2141990 */ // Label 28774: @2141990
     /* 2141990 */ GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2142038), // Rule ID 48242 //
     /* 2141995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2141998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142008 */   // MIs[0] Operand 1
     /* 2142008 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2142013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142021 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2142021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2142024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142026 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142028 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142037 */   // GIR_Coverage, 48242,
     /* 2142037 */   GIR_EraseRootFromParent_Done,
     /* 2142038 */ // Label 28775: @2142038
     /* 2142038 */ GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2142086), // Rule ID 48243 //
     /* 2142043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2142046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142056 */   // MIs[0] Operand 1
     /* 2142056 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2142061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142065 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142069 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2142069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2142072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142074 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142076 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142085 */   // GIR_Coverage, 48243,
     /* 2142085 */   GIR_EraseRootFromParent_Done,
     /* 2142086 */ // Label 28776: @2142086
     /* 2142086 */ GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2142134), // Rule ID 48250 //
     /* 2142091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142104 */   // MIs[0] Operand 1
     /* 2142104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142113 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142117 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2142117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2142120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142122 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142124 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142133 */   // GIR_Coverage, 48250,
     /* 2142133 */   GIR_EraseRootFromParent_Done,
     /* 2142134 */ // Label 28777: @2142134
     /* 2142134 */ GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2142182), // Rule ID 48251 //
     /* 2142139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142152 */   // MIs[0] Operand 1
     /* 2142152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142165 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2142165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2142168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142172 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142181 */   // GIR_Coverage, 48251,
     /* 2142181 */   GIR_EraseRootFromParent_Done,
     /* 2142182 */ // Label 28778: @2142182
     /* 2142182 */ GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2142230), // Rule ID 48260 //
     /* 2142187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142200 */   // MIs[0] Operand 1
     /* 2142200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142213 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2142213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2142216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142220 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142229 */   // GIR_Coverage, 48260,
     /* 2142229 */   GIR_EraseRootFromParent_Done,
     /* 2142230 */ // Label 28779: @2142230
     /* 2142230 */ GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2142278), // Rule ID 48261 //
     /* 2142235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142248 */   // MIs[0] Operand 1
     /* 2142248 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142257 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142261 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2142261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2142264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142268 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142277 */   // GIR_Coverage, 48261,
     /* 2142277 */   GIR_EraseRootFromParent_Done,
     /* 2142278 */ // Label 28780: @2142278
     /* 2142278 */ GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2142326), // Rule ID 48278 //
     /* 2142283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142296 */   // MIs[0] Operand 1
     /* 2142296 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142305 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142309 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2142309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2142312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142316 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142325 */   // GIR_Coverage, 48278,
     /* 2142325 */   GIR_EraseRootFromParent_Done,
     /* 2142326 */ // Label 28781: @2142326
     /* 2142326 */ GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2142374), // Rule ID 48279 //
     /* 2142331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142344 */   // MIs[0] Operand 1
     /* 2142344 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142353 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142357 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2142357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2142360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142362 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142364 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142373 */   // GIR_Coverage, 48279,
     /* 2142373 */   GIR_EraseRootFromParent_Done,
     /* 2142374 */ // Label 28782: @2142374
     /* 2142374 */ GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2142422), // Rule ID 48286 //
     /* 2142379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2142382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142385 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142392 */   // MIs[0] Operand 1
     /* 2142392 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142405 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2142405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2142408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142410 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142412 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142421 */   // GIR_Coverage, 48286,
     /* 2142421 */   GIR_EraseRootFromParent_Done,
     /* 2142422 */ // Label 28783: @2142422
     /* 2142422 */ GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2142470), // Rule ID 48287 //
     /* 2142427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2142430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142440 */   // MIs[0] Operand 1
     /* 2142440 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2142445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142449 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142453 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2142453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2142456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142458 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142460 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142469 */   // GIR_Coverage, 48287,
     /* 2142469 */   GIR_EraseRootFromParent_Done,
     /* 2142470 */ // Label 28784: @2142470
     /* 2142470 */ GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2142518), // Rule ID 48294 //
     /* 2142475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142488 */   // MIs[0] Operand 1
     /* 2142488 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142497 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142501 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2142501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2142504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142506 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142508 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142517 */   // GIR_Coverage, 48294,
     /* 2142517 */   GIR_EraseRootFromParent_Done,
     /* 2142518 */ // Label 28785: @2142518
     /* 2142518 */ GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2142566), // Rule ID 48295 //
     /* 2142523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142536 */   // MIs[0] Operand 1
     /* 2142536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142545 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142549 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2142549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2142552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142565 */   // GIR_Coverage, 48295,
     /* 2142565 */   GIR_EraseRootFromParent_Done,
     /* 2142566 */ // Label 28786: @2142566
     /* 2142566 */ GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2142614), // Rule ID 48304 //
     /* 2142571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142577 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142584 */   // MIs[0] Operand 1
     /* 2142584 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142593 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142597 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2142597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2142600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142602 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142604 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142613 */   // GIR_Coverage, 48304,
     /* 2142613 */   GIR_EraseRootFromParent_Done,
     /* 2142614 */ // Label 28787: @2142614
     /* 2142614 */ GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2142662), // Rule ID 48305 //
     /* 2142619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142632 */   // MIs[0] Operand 1
     /* 2142632 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142641 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142645 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2142645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2142648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142652 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142661 */   // GIR_Coverage, 48305,
     /* 2142661 */   GIR_EraseRootFromParent_Done,
     /* 2142662 */ // Label 28788: @2142662
     /* 2142662 */ GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2142710), // Rule ID 48322 //
     /* 2142667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142680 */   // MIs[0] Operand 1
     /* 2142680 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142689 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142693 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2142693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2142696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142698 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142700 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142709 */   // GIR_Coverage, 48322,
     /* 2142709 */   GIR_EraseRootFromParent_Done,
     /* 2142710 */ // Label 28789: @2142710
     /* 2142710 */ GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2142758), // Rule ID 48323 //
     /* 2142715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142728 */   // MIs[0] Operand 1
     /* 2142728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142737 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142741 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2142741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2142744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142746 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142748 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142757 */   // GIR_Coverage, 48323,
     /* 2142757 */   GIR_EraseRootFromParent_Done,
     /* 2142758 */ // Label 28790: @2142758
     /* 2142758 */ GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2142806), // Rule ID 48330 //
     /* 2142763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2142766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142776 */   // MIs[0] Operand 1
     /* 2142776 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142789 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2142789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2142792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142794 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142796 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142805 */   // GIR_Coverage, 48330,
     /* 2142805 */   GIR_EraseRootFromParent_Done,
     /* 2142806 */ // Label 28791: @2142806
     /* 2142806 */ GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2142854), // Rule ID 48331 //
     /* 2142811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2142814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142817 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142824 */   // MIs[0] Operand 1
     /* 2142824 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2142829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142833 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142837 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2142837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2142840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142842 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2142844 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2142846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142853 */   // GIR_Coverage, 48331,
     /* 2142853 */   GIR_EraseRootFromParent_Done,
     /* 2142854 */ // Label 28792: @2142854
     /* 2142854 */ GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2142902), // Rule ID 48338 //
     /* 2142859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142872 */   // MIs[0] Operand 1
     /* 2142872 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2142877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142881 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142885 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2142885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2142888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142901 */   // GIR_Coverage, 48338,
     /* 2142901 */   GIR_EraseRootFromParent_Done,
     /* 2142902 */ // Label 28793: @2142902
     /* 2142902 */ GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2142950), // Rule ID 48339 //
     /* 2142907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2142910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2142913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2142916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142920 */   // MIs[0] Operand 1
     /* 2142920 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2142925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142933 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2142933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2142936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2142948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142949 */   // GIR_Coverage, 48339,
     /* 2142949 */   GIR_EraseRootFromParent_Done,
     /* 2142950 */ // Label 28794: @2142950
     /* 2142950 */ GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2142998), // Rule ID 48348 //
     /* 2142955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2142958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142968 */   // MIs[0] Operand 1
     /* 2142968 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2142973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142977 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142981 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2142981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2142984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142986 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2142990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2142993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2142997 */   // GIR_Coverage, 48348,
     /* 2142997 */   GIR_EraseRootFromParent_Done,
     /* 2142998 */ // Label 28795: @2142998
     /* 2142998 */ GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2143046), // Rule ID 48349 //
     /* 2143003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2143009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2143012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143016 */   // MIs[0] Operand 1
     /* 2143016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2143021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143029 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2143029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2143032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143034 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2143038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143045 */   // GIR_Coverage, 48349,
     /* 2143045 */   GIR_EraseRootFromParent_Done,
     /* 2143046 */ // Label 28796: @2143046
     /* 2143046 */ GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2143094), // Rule ID 48366 //
     /* 2143051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143064 */   // MIs[0] Operand 1
     /* 2143064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2143069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143073 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143077 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2143077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2143080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143082 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2143086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143093 */   // GIR_Coverage, 48366,
     /* 2143093 */   GIR_EraseRootFromParent_Done,
     /* 2143094 */ // Label 28797: @2143094
     /* 2143094 */ GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2143142), // Rule ID 48367 //
     /* 2143099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143112 */   // MIs[0] Operand 1
     /* 2143112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2143117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143125 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2143125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2143128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143130 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2143134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143141 */   // GIR_Coverage, 48367,
     /* 2143141 */   GIR_EraseRootFromParent_Done,
     /* 2143142 */ // Label 28798: @2143142
     /* 2143142 */ GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2143190), // Rule ID 48374 //
     /* 2143147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2143150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2143156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143160 */   // MIs[0] Operand 1
     /* 2143160 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2143165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143173 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2143173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2143176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143178 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143180 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2143182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143189 */   // GIR_Coverage, 48374,
     /* 2143189 */   GIR_EraseRootFromParent_Done,
     /* 2143190 */ // Label 28799: @2143190
     /* 2143190 */ GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2143238), // Rule ID 48375 //
     /* 2143195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2143198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2143204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143208 */   // MIs[0] Operand 1
     /* 2143208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2143213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143221 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2143221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2143224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143226 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143228 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2143230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143237 */   // GIR_Coverage, 48375,
     /* 2143237 */   GIR_EraseRootFromParent_Done,
     /* 2143238 */ // Label 28800: @2143238
     /* 2143238 */ GIM_Reject,
     /* 2143239 */ // Label 28462: @2143239
     /* 2143239 */ GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2143287), // Rule ID 47952 //
     /* 2143244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2143250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2143253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143257 */   // MIs[0] Operand 1
     /* 2143257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143270 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2143270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2143273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2143285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143286 */   // GIR_Coverage, 47952,
     /* 2143286 */   GIR_EraseRootFromParent_Done,
     /* 2143287 */ // Label 28801: @2143287
     /* 2143287 */ GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2143335), // Rule ID 47953 //
     /* 2143292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2143298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2143301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143305 */   // MIs[0] Operand 1
     /* 2143305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143318 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2143318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2143321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2143333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143334 */   // GIR_Coverage, 47953,
     /* 2143334 */   GIR_EraseRootFromParent_Done,
     /* 2143335 */ // Label 28802: @2143335
     /* 2143335 */ GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2143383), // Rule ID 47966 //
     /* 2143340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143353 */   // MIs[0] Operand 1
     /* 2143353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143366 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2143366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2143369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143371 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143382 */   // GIR_Coverage, 47966,
     /* 2143382 */   GIR_EraseRootFromParent_Done,
     /* 2143383 */ // Label 28803: @2143383
     /* 2143383 */ GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2143431), // Rule ID 47967 //
     /* 2143388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143401 */   // MIs[0] Operand 1
     /* 2143401 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143410 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143414 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2143414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2143417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143419 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143430 */   // GIR_Coverage, 47967,
     /* 2143430 */   GIR_EraseRootFromParent_Done,
     /* 2143431 */ // Label 28804: @2143431
     /* 2143431 */ GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2143479), // Rule ID 47974 //
     /* 2143436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143449 */   // MIs[0] Operand 1
     /* 2143449 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143462 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2143462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2143465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143467 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143469 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143478 */   // GIR_Coverage, 47974,
     /* 2143478 */   GIR_EraseRootFromParent_Done,
     /* 2143479 */ // Label 28805: @2143479
     /* 2143479 */ GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2143527), // Rule ID 47975 //
     /* 2143484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143497 */   // MIs[0] Operand 1
     /* 2143497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143510 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2143510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2143513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143515 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143517 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143526 */   // GIR_Coverage, 47975,
     /* 2143526 */   GIR_EraseRootFromParent_Done,
     /* 2143527 */ // Label 28806: @2143527
     /* 2143527 */ GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2143575), // Rule ID 47982 //
     /* 2143532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2143535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143545 */   // MIs[0] Operand 1
     /* 2143545 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143558 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2143558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2143561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143563 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143565 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143574 */   // GIR_Coverage, 47982,
     /* 2143574 */   GIR_EraseRootFromParent_Done,
     /* 2143575 */ // Label 28807: @2143575
     /* 2143575 */ GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2143623), // Rule ID 47983 //
     /* 2143580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2143583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143593 */   // MIs[0] Operand 1
     /* 2143593 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2143598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143602 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143606 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2143606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2143609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143611 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143613 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143622 */   // GIR_Coverage, 47983,
     /* 2143622 */   GIR_EraseRootFromParent_Done,
     /* 2143623 */ // Label 28808: @2143623
     /* 2143623 */ GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2143671), // Rule ID 47996 //
     /* 2143628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2143634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2143637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143641 */   // MIs[0] Operand 1
     /* 2143641 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143650 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143654 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2143654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2143657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143659 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143661 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2143669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143670 */   // GIR_Coverage, 47996,
     /* 2143670 */   GIR_EraseRootFromParent_Done,
     /* 2143671 */ // Label 28809: @2143671
     /* 2143671 */ GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2143719), // Rule ID 47997 //
     /* 2143676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2143682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2143685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143689 */   // MIs[0] Operand 1
     /* 2143689 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143698 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143702 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2143702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2143705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143707 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143709 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2143717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143718 */   // GIR_Coverage, 47997,
     /* 2143718 */   GIR_EraseRootFromParent_Done,
     /* 2143719 */ // Label 28810: @2143719
     /* 2143719 */ GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2143767), // Rule ID 48010 //
     /* 2143724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143737 */   // MIs[0] Operand 1
     /* 2143737 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143746 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143750 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2143750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2143753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143755 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143757 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143766 */   // GIR_Coverage, 48010,
     /* 2143766 */   GIR_EraseRootFromParent_Done,
     /* 2143767 */ // Label 28811: @2143767
     /* 2143767 */ GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2143815), // Rule ID 48011 //
     /* 2143772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143785 */   // MIs[0] Operand 1
     /* 2143785 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143794 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143798 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2143798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2143801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143803 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143805 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143814 */   // GIR_Coverage, 48011,
     /* 2143814 */   GIR_EraseRootFromParent_Done,
     /* 2143815 */ // Label 28812: @2143815
     /* 2143815 */ GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2143863), // Rule ID 48018 //
     /* 2143820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2143823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143833 */   // MIs[0] Operand 1
     /* 2143833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143846 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2143846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2143849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143853 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143862 */   // GIR_Coverage, 48018,
     /* 2143862 */   GIR_EraseRootFromParent_Done,
     /* 2143863 */ // Label 28813: @2143863
     /* 2143863 */ GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2143911), // Rule ID 48019 //
     /* 2143868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2143871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143881 */   // MIs[0] Operand 1
     /* 2143881 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143894 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2143894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2143897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143899 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143910 */   // GIR_Coverage, 48019,
     /* 2143910 */   GIR_EraseRootFromParent_Done,
     /* 2143911 */ // Label 28814: @2143911
     /* 2143911 */ GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2143959), // Rule ID 48026 //
     /* 2143916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2143919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143929 */   // MIs[0] Operand 1
     /* 2143929 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143938 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143942 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2143942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2143945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143947 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143949 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2143954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2143958 */   // GIR_Coverage, 48026,
     /* 2143958 */   GIR_EraseRootFromParent_Done,
     /* 2143959 */ // Label 28815: @2143959
     /* 2143959 */ GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2144007), // Rule ID 48027 //
     /* 2143964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2143967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143977 */   // MIs[0] Operand 1
     /* 2143977 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2143982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143986 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143990 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2143990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2143993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143995 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2143997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2143999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144006 */   // GIR_Coverage, 48027,
     /* 2144006 */   GIR_EraseRootFromParent_Done,
     /* 2144007 */ // Label 28816: @2144007
     /* 2144007 */ GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2144055), // Rule ID 48040 //
     /* 2144012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144025 */   // MIs[0] Operand 1
     /* 2144025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144034 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144038 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2144038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2144041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144043 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144054 */   // GIR_Coverage, 48040,
     /* 2144054 */   GIR_EraseRootFromParent_Done,
     /* 2144055 */ // Label 28817: @2144055
     /* 2144055 */ GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2144103), // Rule ID 48041 //
     /* 2144060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144073 */   // MIs[0] Operand 1
     /* 2144073 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144082 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144086 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2144086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2144089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144091 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144102 */   // GIR_Coverage, 48041,
     /* 2144102 */   GIR_EraseRootFromParent_Done,
     /* 2144103 */ // Label 28818: @2144103
     /* 2144103 */ GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2144151), // Rule ID 48054 //
     /* 2144108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144114 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144121 */   // MIs[0] Operand 1
     /* 2144121 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144130 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144134 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2144134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2144137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144139 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144149 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144150 */   // GIR_Coverage, 48054,
     /* 2144150 */   GIR_EraseRootFromParent_Done,
     /* 2144151 */ // Label 28819: @2144151
     /* 2144151 */ GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2144199), // Rule ID 48055 //
     /* 2144156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144169 */   // MIs[0] Operand 1
     /* 2144169 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144178 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144182 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2144182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2144185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144187 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144189 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144198 */   // GIR_Coverage, 48055,
     /* 2144198 */   GIR_EraseRootFromParent_Done,
     /* 2144199 */ // Label 28820: @2144199
     /* 2144199 */ GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2144247), // Rule ID 48062 //
     /* 2144204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144217 */   // MIs[0] Operand 1
     /* 2144217 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144230 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2144230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2144233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144237 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144246 */   // GIR_Coverage, 48062,
     /* 2144246 */   GIR_EraseRootFromParent_Done,
     /* 2144247 */ // Label 28821: @2144247
     /* 2144247 */ GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2144295), // Rule ID 48063 //
     /* 2144252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144265 */   // MIs[0] Operand 1
     /* 2144265 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144278 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2144278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2144281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144285 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144294 */   // GIR_Coverage, 48063,
     /* 2144294 */   GIR_EraseRootFromParent_Done,
     /* 2144295 */ // Label 28822: @2144295
     /* 2144295 */ GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2144343), // Rule ID 48070 //
     /* 2144300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2144303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2144309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144313 */   // MIs[0] Operand 1
     /* 2144313 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144322 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144326 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2144326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2144329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144333 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144341 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144342 */   // GIR_Coverage, 48070,
     /* 2144342 */   GIR_EraseRootFromParent_Done,
     /* 2144343 */ // Label 28823: @2144343
     /* 2144343 */ GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2144391), // Rule ID 48071 //
     /* 2144348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2144351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2144357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144361 */   // MIs[0] Operand 1
     /* 2144361 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2144366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144370 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144374 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2144374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2144377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144381 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144390 */   // GIR_Coverage, 48071,
     /* 2144390 */   GIR_EraseRootFromParent_Done,
     /* 2144391 */ // Label 28824: @2144391
     /* 2144391 */ GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2144439), // Rule ID 48082 //
     /* 2144396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144409 */   // MIs[0] Operand 1
     /* 2144409 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144418 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144422 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2144422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2144425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144427 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144437 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144438 */   // GIR_Coverage, 48082,
     /* 2144438 */   GIR_EraseRootFromParent_Done,
     /* 2144439 */ // Label 28825: @2144439
     /* 2144439 */ GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2144487), // Rule ID 48083 //
     /* 2144444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144457 */   // MIs[0] Operand 1
     /* 2144457 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144466 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144470 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2144470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2144473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144486 */   // GIR_Coverage, 48083,
     /* 2144486 */   GIR_EraseRootFromParent_Done,
     /* 2144487 */ // Label 28826: @2144487
     /* 2144487 */ GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2144535), // Rule ID 48096 //
     /* 2144492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144505 */   // MIs[0] Operand 1
     /* 2144505 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144514 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144518 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2144518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2144521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144534 */   // GIR_Coverage, 48096,
     /* 2144534 */   GIR_EraseRootFromParent_Done,
     /* 2144535 */ // Label 28827: @2144535
     /* 2144535 */ GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2144583), // Rule ID 48097 //
     /* 2144540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144553 */   // MIs[0] Operand 1
     /* 2144553 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144566 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2144566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2144569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144582 */   // GIR_Coverage, 48097,
     /* 2144582 */   GIR_EraseRootFromParent_Done,
     /* 2144583 */ // Label 28828: @2144583
     /* 2144583 */ GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2144631), // Rule ID 48104 //
     /* 2144588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144601 */   // MIs[0] Operand 1
     /* 2144601 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144610 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144614 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2144614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2144617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144630 */   // GIR_Coverage, 48104,
     /* 2144630 */   GIR_EraseRootFromParent_Done,
     /* 2144631 */ // Label 28829: @2144631
     /* 2144631 */ GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2144679), // Rule ID 48105 //
     /* 2144636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144649 */   // MIs[0] Operand 1
     /* 2144649 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144658 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144662 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2144662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2144665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144669 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144678 */   // GIR_Coverage, 48105,
     /* 2144678 */   GIR_EraseRootFromParent_Done,
     /* 2144679 */ // Label 28830: @2144679
     /* 2144679 */ GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2144727), // Rule ID 48112 //
     /* 2144684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2144687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2144693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144697 */   // MIs[0] Operand 1
     /* 2144697 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144706 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144710 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2144710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2144713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144726 */   // GIR_Coverage, 48112,
     /* 2144726 */   GIR_EraseRootFromParent_Done,
     /* 2144727 */ // Label 28831: @2144727
     /* 2144727 */ GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2144775), // Rule ID 48113 //
     /* 2144732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2144735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2144741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144745 */   // MIs[0] Operand 1
     /* 2144745 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2144750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144758 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2144758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2144761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2144767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144774 */   // GIR_Coverage, 48113,
     /* 2144774 */   GIR_EraseRootFromParent_Done,
     /* 2144775 */ // Label 28832: @2144775
     /* 2144775 */ GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2144823), // Rule ID 48126 //
     /* 2144780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144793 */   // MIs[0] Operand 1
     /* 2144793 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2144798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144806 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2144806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2144809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144811 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144813 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144822 */   // GIR_Coverage, 48126,
     /* 2144822 */   GIR_EraseRootFromParent_Done,
     /* 2144823 */ // Label 28833: @2144823
     /* 2144823 */ GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2144871), // Rule ID 48127 //
     /* 2144828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2144834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2144837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144841 */   // MIs[0] Operand 1
     /* 2144841 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2144846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144850 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144854 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2144854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2144857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144861 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2144869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144870 */   // GIR_Coverage, 48127,
     /* 2144870 */   GIR_EraseRootFromParent_Done,
     /* 2144871 */ // Label 28834: @2144871
     /* 2144871 */ GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2144919), // Rule ID 48140 //
     /* 2144876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144889 */   // MIs[0] Operand 1
     /* 2144889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2144894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144902 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2144902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2144905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144918 */   // GIR_Coverage, 48140,
     /* 2144918 */   GIR_EraseRootFromParent_Done,
     /* 2144919 */ // Label 28835: @2144919
     /* 2144919 */ GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2144967), // Rule ID 48141 //
     /* 2144924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2144927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144937 */   // MIs[0] Operand 1
     /* 2144937 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2144942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144946 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144950 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2144950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2144953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144955 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2144957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2144959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2144962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2144966 */   // GIR_Coverage, 48141,
     /* 2144966 */   GIR_EraseRootFromParent_Done,
     /* 2144967 */ // Label 28836: @2144967
     /* 2144967 */ GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2145015), // Rule ID 48148 //
     /* 2144972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2144975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144985 */   // MIs[0] Operand 1
     /* 2144985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2144990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144998 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2144998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2145001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145014 */   // GIR_Coverage, 48148,
     /* 2145014 */   GIR_EraseRootFromParent_Done,
     /* 2145015 */ // Label 28837: @2145015
     /* 2145015 */ GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2145063), // Rule ID 48149 //
     /* 2145020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145033 */   // MIs[0] Operand 1
     /* 2145033 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2145038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145042 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145046 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2145046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2145049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145062 */   // GIR_Coverage, 48149,
     /* 2145062 */   GIR_EraseRootFromParent_Done,
     /* 2145063 */ // Label 28838: @2145063
     /* 2145063 */ GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2145111), // Rule ID 48156 //
     /* 2145068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2145071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145081 */   // MIs[0] Operand 1
     /* 2145081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2145086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145090 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145094 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2145094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2145097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145110 */   // GIR_Coverage, 48156,
     /* 2145110 */   GIR_EraseRootFromParent_Done,
     /* 2145111 */ // Label 28839: @2145111
     /* 2145111 */ GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2145159), // Rule ID 48157 //
     /* 2145116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2145119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145129 */   // MIs[0] Operand 1
     /* 2145129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2145134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145142 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2145142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2145145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145158 */   // GIR_Coverage, 48157,
     /* 2145158 */   GIR_EraseRootFromParent_Done,
     /* 2145159 */ // Label 28840: @2145159
     /* 2145159 */ GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2145207), // Rule ID 48170 //
     /* 2145164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145177 */   // MIs[0] Operand 1
     /* 2145177 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145190 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2145190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2145193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145197 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2145205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145206 */   // GIR_Coverage, 48170,
     /* 2145206 */   GIR_EraseRootFromParent_Done,
     /* 2145207 */ // Label 28841: @2145207
     /* 2145207 */ GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2145255), // Rule ID 48171 //
     /* 2145212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145225 */   // MIs[0] Operand 1
     /* 2145225 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145234 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145238 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2145238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2145241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145245 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2145253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145254 */   // GIR_Coverage, 48171,
     /* 2145254 */   GIR_EraseRootFromParent_Done,
     /* 2145255 */ // Label 28842: @2145255
     /* 2145255 */ GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2145303), // Rule ID 48184 //
     /* 2145260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2145266 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2145269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145273 */   // MIs[0] Operand 1
     /* 2145273 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145282 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145286 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2145286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2145289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145293 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145302 */   // GIR_Coverage, 48184,
     /* 2145302 */   GIR_EraseRootFromParent_Done,
     /* 2145303 */ // Label 28843: @2145303
     /* 2145303 */ GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2145351), // Rule ID 48185 //
     /* 2145308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2145314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2145317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145321 */   // MIs[0] Operand 1
     /* 2145321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145334 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2145334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2145337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145341 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145350 */   // GIR_Coverage, 48185,
     /* 2145350 */   GIR_EraseRootFromParent_Done,
     /* 2145351 */ // Label 28844: @2145351
     /* 2145351 */ GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2145399), // Rule ID 48192 //
     /* 2145356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145369 */   // MIs[0] Operand 1
     /* 2145369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145382 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2145382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2145385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145389 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145398 */   // GIR_Coverage, 48192,
     /* 2145398 */   GIR_EraseRootFromParent_Done,
     /* 2145399 */ // Label 28845: @2145399
     /* 2145399 */ GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2145447), // Rule ID 48193 //
     /* 2145404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145417 */   // MIs[0] Operand 1
     /* 2145417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145430 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2145430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2145433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145437 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145446 */   // GIR_Coverage, 48193,
     /* 2145446 */   GIR_EraseRootFromParent_Done,
     /* 2145447 */ // Label 28846: @2145447
     /* 2145447 */ GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2145495), // Rule ID 48200 //
     /* 2145452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2145455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145465 */   // MIs[0] Operand 1
     /* 2145465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145478 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2145478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2145481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145485 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145494 */   // GIR_Coverage, 48200,
     /* 2145494 */   GIR_EraseRootFromParent_Done,
     /* 2145495 */ // Label 28847: @2145495
     /* 2145495 */ GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2145543), // Rule ID 48201 //
     /* 2145500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2145503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145513 */   // MIs[0] Operand 1
     /* 2145513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2145518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145526 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2145526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2145529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145542 */   // GIR_Coverage, 48201,
     /* 2145542 */   GIR_EraseRootFromParent_Done,
     /* 2145543 */ // Label 28848: @2145543
     /* 2145543 */ GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2145591), // Rule ID 48214 //
     /* 2145548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145561 */   // MIs[0] Operand 1
     /* 2145561 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145574 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2145574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2145577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145579 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145581 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2145589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145590 */   // GIR_Coverage, 48214,
     /* 2145590 */   GIR_EraseRootFromParent_Done,
     /* 2145591 */ // Label 28849: @2145591
     /* 2145591 */ GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2145639), // Rule ID 48215 //
     /* 2145596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145609 */   // MIs[0] Operand 1
     /* 2145609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145622 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2145622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2145625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2145637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145638 */   // GIR_Coverage, 48215,
     /* 2145638 */   GIR_EraseRootFromParent_Done,
     /* 2145639 */ // Label 28850: @2145639
     /* 2145639 */ GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2145687), // Rule ID 48228 //
     /* 2145644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2145650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2145653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145657 */   // MIs[0] Operand 1
     /* 2145657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145670 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2145670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2145673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145686 */   // GIR_Coverage, 48228,
     /* 2145686 */   GIR_EraseRootFromParent_Done,
     /* 2145687 */ // Label 28851: @2145687
     /* 2145687 */ GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2145735), // Rule ID 48229 //
     /* 2145692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2145698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2145701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145705 */   // MIs[0] Operand 1
     /* 2145705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145718 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2145718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2145721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145734 */   // GIR_Coverage, 48229,
     /* 2145734 */   GIR_EraseRootFromParent_Done,
     /* 2145735 */ // Label 28852: @2145735
     /* 2145735 */ GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2145783), // Rule ID 48236 //
     /* 2145740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145753 */   // MIs[0] Operand 1
     /* 2145753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145766 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2145766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2145769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145782 */   // GIR_Coverage, 48236,
     /* 2145782 */   GIR_EraseRootFromParent_Done,
     /* 2145783 */ // Label 28853: @2145783
     /* 2145783 */ GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2145831), // Rule ID 48237 //
     /* 2145788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145801 */   // MIs[0] Operand 1
     /* 2145801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145814 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2145814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2145817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145830 */   // GIR_Coverage, 48237,
     /* 2145830 */   GIR_EraseRootFromParent_Done,
     /* 2145831 */ // Label 28854: @2145831
     /* 2145831 */ GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2145879), // Rule ID 48244 //
     /* 2145836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2145839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145849 */   // MIs[0] Operand 1
     /* 2145849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145862 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2145862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2145865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145878 */   // GIR_Coverage, 48244,
     /* 2145878 */   GIR_EraseRootFromParent_Done,
     /* 2145879 */ // Label 28855: @2145879
     /* 2145879 */ GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2145927), // Rule ID 48245 //
     /* 2145884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2145887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145897 */   // MIs[0] Operand 1
     /* 2145897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2145902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145910 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2145910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2145913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2145917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2145919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145926 */   // GIR_Coverage, 48245,
     /* 2145926 */   GIR_EraseRootFromParent_Done,
     /* 2145927 */ // Label 28856: @2145927
     /* 2145927 */ GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2145975), // Rule ID 48258 //
     /* 2145932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2145935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145945 */   // MIs[0] Operand 1
     /* 2145945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2145950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145958 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2145958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2145961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145965 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2145967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2145970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2145973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2145974 */   // GIR_Coverage, 48258,
     /* 2145974 */   GIR_EraseRootFromParent_Done,
     /* 2145975 */ // Label 28857: @2145975
     /* 2145975 */ GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2146023), // Rule ID 48259 //
     /* 2145980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2145983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2145986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2145989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145993 */   // MIs[0] Operand 1
     /* 2145993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2145998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146006 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2146006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2146009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146013 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2146021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146022 */   // GIR_Coverage, 48259,
     /* 2146022 */   GIR_EraseRootFromParent_Done,
     /* 2146023 */ // Label 28858: @2146023
     /* 2146023 */ GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2146071), // Rule ID 48272 //
     /* 2146028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146041 */   // MIs[0] Operand 1
     /* 2146041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146054 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2146054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2146057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146061 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146070 */   // GIR_Coverage, 48272,
     /* 2146070 */   GIR_EraseRootFromParent_Done,
     /* 2146071 */ // Label 28859: @2146071
     /* 2146071 */ GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2146119), // Rule ID 48273 //
     /* 2146076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146089 */   // MIs[0] Operand 1
     /* 2146089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146102 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2146102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2146105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146109 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146118 */   // GIR_Coverage, 48273,
     /* 2146118 */   GIR_EraseRootFromParent_Done,
     /* 2146119 */ // Label 28860: @2146119
     /* 2146119 */ GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2146167), // Rule ID 48280 //
     /* 2146124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146137 */   // MIs[0] Operand 1
     /* 2146137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146150 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2146150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2146153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146157 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146166 */   // GIR_Coverage, 48280,
     /* 2146166 */   GIR_EraseRootFromParent_Done,
     /* 2146167 */ // Label 28861: @2146167
     /* 2146167 */ GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2146215), // Rule ID 48281 //
     /* 2146172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146185 */   // MIs[0] Operand 1
     /* 2146185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146198 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2146198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2146201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146205 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146214 */   // GIR_Coverage, 48281,
     /* 2146214 */   GIR_EraseRootFromParent_Done,
     /* 2146215 */ // Label 28862: @2146215
     /* 2146215 */ GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2146263), // Rule ID 48288 //
     /* 2146220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2146223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146233 */   // MIs[0] Operand 1
     /* 2146233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146246 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2146246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2146249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146253 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146262 */   // GIR_Coverage, 48288,
     /* 2146262 */   GIR_EraseRootFromParent_Done,
     /* 2146263 */ // Label 28863: @2146263
     /* 2146263 */ GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2146311), // Rule ID 48289 //
     /* 2146268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2146271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146281 */   // MIs[0] Operand 1
     /* 2146281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2146286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146294 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2146294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2146297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146301 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146310 */   // GIR_Coverage, 48289,
     /* 2146310 */   GIR_EraseRootFromParent_Done,
     /* 2146311 */ // Label 28864: @2146311
     /* 2146311 */ GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2146359), // Rule ID 48302 //
     /* 2146316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2146322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2146325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146329 */   // MIs[0] Operand 1
     /* 2146329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146342 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2146342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2146345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2146357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146358 */   // GIR_Coverage, 48302,
     /* 2146358 */   GIR_EraseRootFromParent_Done,
     /* 2146359 */ // Label 28865: @2146359
     /* 2146359 */ GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2146407), // Rule ID 48303 //
     /* 2146364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2146370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2146373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146377 */   // MIs[0] Operand 1
     /* 2146377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146390 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2146390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2146393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2146405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146406 */   // GIR_Coverage, 48303,
     /* 2146406 */   GIR_EraseRootFromParent_Done,
     /* 2146407 */ // Label 28866: @2146407
     /* 2146407 */ GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2146455), // Rule ID 48316 //
     /* 2146412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146425 */   // MIs[0] Operand 1
     /* 2146425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146438 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2146438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2146441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146454 */   // GIR_Coverage, 48316,
     /* 2146454 */   GIR_EraseRootFromParent_Done,
     /* 2146455 */ // Label 28867: @2146455
     /* 2146455 */ GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2146503), // Rule ID 48317 //
     /* 2146460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146473 */   // MIs[0] Operand 1
     /* 2146473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146486 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2146486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2146489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146502 */   // GIR_Coverage, 48317,
     /* 2146502 */   GIR_EraseRootFromParent_Done,
     /* 2146503 */ // Label 28868: @2146503
     /* 2146503 */ GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2146551), // Rule ID 48324 //
     /* 2146508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146521 */   // MIs[0] Operand 1
     /* 2146521 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146534 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2146534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2146537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146541 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146550 */   // GIR_Coverage, 48324,
     /* 2146550 */   GIR_EraseRootFromParent_Done,
     /* 2146551 */ // Label 28869: @2146551
     /* 2146551 */ GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2146599), // Rule ID 48325 //
     /* 2146556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146569 */   // MIs[0] Operand 1
     /* 2146569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146582 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2146582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2146585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146598 */   // GIR_Coverage, 48325,
     /* 2146598 */   GIR_EraseRootFromParent_Done,
     /* 2146599 */ // Label 28870: @2146599
     /* 2146599 */ GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2146647), // Rule ID 48332 //
     /* 2146604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2146607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146617 */   // MIs[0] Operand 1
     /* 2146617 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146626 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146630 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2146630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2146633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146646 */   // GIR_Coverage, 48332,
     /* 2146646 */   GIR_EraseRootFromParent_Done,
     /* 2146647 */ // Label 28871: @2146647
     /* 2146647 */ GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2146695), // Rule ID 48333 //
     /* 2146652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2146655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146665 */   // MIs[0] Operand 1
     /* 2146665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2146670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146674 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146678 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2146678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2146681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2146685 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2146687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146694 */   // GIR_Coverage, 48333,
     /* 2146694 */   GIR_EraseRootFromParent_Done,
     /* 2146695 */ // Label 28872: @2146695
     /* 2146695 */ GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2146743), // Rule ID 48346 //
     /* 2146700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2146706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2146709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146713 */   // MIs[0] Operand 1
     /* 2146713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146726 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2146726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2146729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146733 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2146741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146742 */   // GIR_Coverage, 48346,
     /* 2146742 */   GIR_EraseRootFromParent_Done,
     /* 2146743 */ // Label 28873: @2146743
     /* 2146743 */ GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2146791), // Rule ID 48347 //
     /* 2146748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2146754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2146757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146761 */   // MIs[0] Operand 1
     /* 2146761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146774 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2146774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2146777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2146789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146790 */   // GIR_Coverage, 48347,
     /* 2146790 */   GIR_EraseRootFromParent_Done,
     /* 2146791 */ // Label 28874: @2146791
     /* 2146791 */ GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2146839), // Rule ID 48360 //
     /* 2146796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146809 */   // MIs[0] Operand 1
     /* 2146809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146822 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2146822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2146825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146829 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146838 */   // GIR_Coverage, 48360,
     /* 2146838 */   GIR_EraseRootFromParent_Done,
     /* 2146839 */ // Label 28875: @2146839
     /* 2146839 */ GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2146887), // Rule ID 48361 //
     /* 2146844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146857 */   // MIs[0] Operand 1
     /* 2146857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146870 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2146870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2146873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146886 */   // GIR_Coverage, 48361,
     /* 2146886 */   GIR_EraseRootFromParent_Done,
     /* 2146887 */ // Label 28876: @2146887
     /* 2146887 */ GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2146935), // Rule ID 48368 //
     /* 2146892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2146895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146905 */   // MIs[0] Operand 1
     /* 2146905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146918 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2146918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2146921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146925 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146934 */   // GIR_Coverage, 48368,
     /* 2146934 */   GIR_EraseRootFromParent_Done,
     /* 2146935 */ // Label 28877: @2146935
     /* 2146935 */ GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2146983), // Rule ID 48369 //
     /* 2146940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2146943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146953 */   // MIs[0] Operand 1
     /* 2146953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2146958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146966 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2146966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2146969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2146975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2146978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2146982 */   // GIR_Coverage, 48369,
     /* 2146982 */   GIR_EraseRootFromParent_Done,
     /* 2146983 */ // Label 28878: @2146983
     /* 2146983 */ GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2147031), // Rule ID 48376 //
     /* 2146988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2146991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147001 */   // MIs[0] Operand 1
     /* 2147001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2147006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147014 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2147014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2147017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147021 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2147023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147030 */   // GIR_Coverage, 48376,
     /* 2147030 */   GIR_EraseRootFromParent_Done,
     /* 2147031 */ // Label 28879: @2147031
     /* 2147031 */ GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2147079), // Rule ID 48377 //
     /* 2147036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2147039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147049 */   // MIs[0] Operand 1
     /* 2147049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2147054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147062 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2147062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2147065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147067 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147069 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2147071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147078 */   // GIR_Coverage, 48377,
     /* 2147078 */   GIR_EraseRootFromParent_Done,
     /* 2147079 */ // Label 28880: @2147079
     /* 2147079 */ GIM_Reject,
     /* 2147080 */ // Label 28463: @2147080
     /* 2147080 */ GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2147128), // Rule ID 47960 //
     /* 2147085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147098 */   // MIs[0] Operand 1
     /* 2147098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147111 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2147111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2147114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147116 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147127 */   // GIR_Coverage, 47960,
     /* 2147127 */   GIR_EraseRootFromParent_Done,
     /* 2147128 */ // Label 28881: @2147128
     /* 2147128 */ GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2147176), // Rule ID 47961 //
     /* 2147133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147146 */   // MIs[0] Operand 1
     /* 2147146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147155 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147159 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2147159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2147162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147175 */   // GIR_Coverage, 47961,
     /* 2147175 */   GIR_EraseRootFromParent_Done,
     /* 2147176 */ // Label 28882: @2147176
     /* 2147176 */ GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2147224), // Rule ID 47968 //
     /* 2147181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147194 */   // MIs[0] Operand 1
     /* 2147194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147207 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2147207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2147210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147212 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147223 */   // GIR_Coverage, 47968,
     /* 2147223 */   GIR_EraseRootFromParent_Done,
     /* 2147224 */ // Label 28883: @2147224
     /* 2147224 */ GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2147272), // Rule ID 47969 //
     /* 2147229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147242 */   // MIs[0] Operand 1
     /* 2147242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147255 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2147255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2147258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147271 */   // GIR_Coverage, 47969,
     /* 2147271 */   GIR_EraseRootFromParent_Done,
     /* 2147272 */ // Label 28884: @2147272
     /* 2147272 */ GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2147320), // Rule ID 47976 //
     /* 2147277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147290 */   // MIs[0] Operand 1
     /* 2147290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147299 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147303 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2147303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2147306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147308 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147310 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147319 */   // GIR_Coverage, 47976,
     /* 2147319 */   GIR_EraseRootFromParent_Done,
     /* 2147320 */ // Label 28885: @2147320
     /* 2147320 */ GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2147368), // Rule ID 47977 //
     /* 2147325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147338 */   // MIs[0] Operand 1
     /* 2147338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2147343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147351 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2147351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2147354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147358 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147367 */   // GIR_Coverage, 47977,
     /* 2147367 */   GIR_EraseRootFromParent_Done,
     /* 2147368 */ // Label 28886: @2147368
     /* 2147368 */ GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2147416), // Rule ID 48004 //
     /* 2147373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147386 */   // MIs[0] Operand 1
     /* 2147386 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147399 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2147399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2147402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147406 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147415 */   // GIR_Coverage, 48004,
     /* 2147415 */   GIR_EraseRootFromParent_Done,
     /* 2147416 */ // Label 28887: @2147416
     /* 2147416 */ GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2147464), // Rule ID 48005 //
     /* 2147421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147434 */   // MIs[0] Operand 1
     /* 2147434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147447 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2147447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2147450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147454 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147463 */   // GIR_Coverage, 48005,
     /* 2147463 */   GIR_EraseRootFromParent_Done,
     /* 2147464 */ // Label 28888: @2147464
     /* 2147464 */ GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2147512), // Rule ID 48012 //
     /* 2147469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147482 */   // MIs[0] Operand 1
     /* 2147482 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147495 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2147495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2147498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147500 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147502 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147511 */   // GIR_Coverage, 48012,
     /* 2147511 */   GIR_EraseRootFromParent_Done,
     /* 2147512 */ // Label 28889: @2147512
     /* 2147512 */ GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2147560), // Rule ID 48013 //
     /* 2147517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147530 */   // MIs[0] Operand 1
     /* 2147530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147539 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147543 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2147543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2147546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147548 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147550 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147559 */   // GIR_Coverage, 48013,
     /* 2147559 */   GIR_EraseRootFromParent_Done,
     /* 2147560 */ // Label 28890: @2147560
     /* 2147560 */ GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2147608), // Rule ID 48020 //
     /* 2147565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147578 */   // MIs[0] Operand 1
     /* 2147578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147591 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2147591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2147594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147598 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147607 */   // GIR_Coverage, 48020,
     /* 2147607 */   GIR_EraseRootFromParent_Done,
     /* 2147608 */ // Label 28891: @2147608
     /* 2147608 */ GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2147656), // Rule ID 48021 //
     /* 2147613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147626 */   // MIs[0] Operand 1
     /* 2147626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2147631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147635 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147639 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2147639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2147642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147644 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147646 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147655 */   // GIR_Coverage, 48021,
     /* 2147655 */   GIR_EraseRootFromParent_Done,
     /* 2147656 */ // Label 28892: @2147656
     /* 2147656 */ GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2147704), // Rule ID 48048 //
     /* 2147661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147674 */   // MIs[0] Operand 1
     /* 2147674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147683 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147687 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2147687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2147690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147692 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147694 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147703 */   // GIR_Coverage, 48048,
     /* 2147703 */   GIR_EraseRootFromParent_Done,
     /* 2147704 */ // Label 28893: @2147704
     /* 2147704 */ GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2147752), // Rule ID 48049 //
     /* 2147709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147722 */   // MIs[0] Operand 1
     /* 2147722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147731 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147735 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2147735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2147738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147740 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147751 */   // GIR_Coverage, 48049,
     /* 2147751 */   GIR_EraseRootFromParent_Done,
     /* 2147752 */ // Label 28894: @2147752
     /* 2147752 */ GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2147800), // Rule ID 48056 //
     /* 2147757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147770 */   // MIs[0] Operand 1
     /* 2147770 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147783 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2147783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2147786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147788 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147799 */   // GIR_Coverage, 48056,
     /* 2147799 */   GIR_EraseRootFromParent_Done,
     /* 2147800 */ // Label 28895: @2147800
     /* 2147800 */ GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2147848), // Rule ID 48057 //
     /* 2147805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147818 */   // MIs[0] Operand 1
     /* 2147818 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147827 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147831 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2147831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2147834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147836 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147838 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147847 */   // GIR_Coverage, 48057,
     /* 2147847 */   GIR_EraseRootFromParent_Done,
     /* 2147848 */ // Label 28896: @2147848
     /* 2147848 */ GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2147896), // Rule ID 48064 //
     /* 2147853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147866 */   // MIs[0] Operand 1
     /* 2147866 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147879 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2147879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2147882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147884 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147895 */   // GIR_Coverage, 48064,
     /* 2147895 */   GIR_EraseRootFromParent_Done,
     /* 2147896 */ // Label 28897: @2147896
     /* 2147896 */ GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2147944), // Rule ID 48065 //
     /* 2147901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2147904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147914 */   // MIs[0] Operand 1
     /* 2147914 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2147919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147927 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2147927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2147930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147932 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2147934 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2147936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147943 */   // GIR_Coverage, 48065,
     /* 2147943 */   GIR_EraseRootFromParent_Done,
     /* 2147944 */ // Label 28898: @2147944
     /* 2147944 */ GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2147992), // Rule ID 48090 //
     /* 2147949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2147952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2147955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2147958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147962 */   // MIs[0] Operand 1
     /* 2147962 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2147967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147975 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2147975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2147978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147980 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147982 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2147984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2147987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2147990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2147991 */   // GIR_Coverage, 48090,
     /* 2147991 */   GIR_EraseRootFromParent_Done,
     /* 2147992 */ // Label 28899: @2147992
     /* 2147992 */ GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2148040), // Rule ID 48091 //
     /* 2147997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148010 */   // MIs[0] Operand 1
     /* 2148010 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2148015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148019 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148023 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2148023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2148026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148028 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148030 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148039 */   // GIR_Coverage, 48091,
     /* 2148039 */   GIR_EraseRootFromParent_Done,
     /* 2148040 */ // Label 28900: @2148040
     /* 2148040 */ GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2148088), // Rule ID 48098 //
     /* 2148045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148058 */   // MIs[0] Operand 1
     /* 2148058 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2148063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148071 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2148071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2148074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148076 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148087 */   // GIR_Coverage, 48098,
     /* 2148087 */   GIR_EraseRootFromParent_Done,
     /* 2148088 */ // Label 28901: @2148088
     /* 2148088 */ GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2148136), // Rule ID 48099 //
     /* 2148093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148106 */   // MIs[0] Operand 1
     /* 2148106 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2148111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148115 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148119 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2148119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2148122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148124 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148135 */   // GIR_Coverage, 48099,
     /* 2148135 */   GIR_EraseRootFromParent_Done,
     /* 2148136 */ // Label 28902: @2148136
     /* 2148136 */ GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2148184), // Rule ID 48106 //
     /* 2148141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148154 */   // MIs[0] Operand 1
     /* 2148154 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2148159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148163 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148167 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2148167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2148170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148172 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148183 */   // GIR_Coverage, 48106,
     /* 2148183 */   GIR_EraseRootFromParent_Done,
     /* 2148184 */ // Label 28903: @2148184
     /* 2148184 */ GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2148232), // Rule ID 48107 //
     /* 2148189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148202 */   // MIs[0] Operand 1
     /* 2148202 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2148207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148211 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148215 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2148215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2148218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148220 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148231 */   // GIR_Coverage, 48107,
     /* 2148231 */   GIR_EraseRootFromParent_Done,
     /* 2148232 */ // Label 28904: @2148232
     /* 2148232 */ GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2148280), // Rule ID 48134 //
     /* 2148237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148250 */   // MIs[0] Operand 1
     /* 2148250 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148259 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148263 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2148263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2148266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148268 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148270 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148279 */   // GIR_Coverage, 48134,
     /* 2148279 */   GIR_EraseRootFromParent_Done,
     /* 2148280 */ // Label 28905: @2148280
     /* 2148280 */ GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2148328), // Rule ID 48135 //
     /* 2148285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148298 */   // MIs[0] Operand 1
     /* 2148298 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148307 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148311 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2148311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2148314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148316 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148318 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148327 */   // GIR_Coverage, 48135,
     /* 2148327 */   GIR_EraseRootFromParent_Done,
     /* 2148328 */ // Label 28906: @2148328
     /* 2148328 */ GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2148376), // Rule ID 48142 //
     /* 2148333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148346 */   // MIs[0] Operand 1
     /* 2148346 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148355 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148359 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2148359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2148362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148364 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148366 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148375 */   // GIR_Coverage, 48142,
     /* 2148375 */   GIR_EraseRootFromParent_Done,
     /* 2148376 */ // Label 28907: @2148376
     /* 2148376 */ GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2148424), // Rule ID 48143 //
     /* 2148381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148394 */   // MIs[0] Operand 1
     /* 2148394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148407 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2148407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2148410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148412 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148414 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148423 */   // GIR_Coverage, 48143,
     /* 2148423 */   GIR_EraseRootFromParent_Done,
     /* 2148424 */ // Label 28908: @2148424
     /* 2148424 */ GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2148472), // Rule ID 48150 //
     /* 2148429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148442 */   // MIs[0] Operand 1
     /* 2148442 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148451 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148455 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2148455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2148458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148460 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148462 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148471 */   // GIR_Coverage, 48150,
     /* 2148471 */   GIR_EraseRootFromParent_Done,
     /* 2148472 */ // Label 28909: @2148472
     /* 2148472 */ GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2148520), // Rule ID 48151 //
     /* 2148477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148490 */   // MIs[0] Operand 1
     /* 2148490 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2148495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148503 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2148503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2148506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148508 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148510 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148519 */   // GIR_Coverage, 48151,
     /* 2148519 */   GIR_EraseRootFromParent_Done,
     /* 2148520 */ // Label 28910: @2148520
     /* 2148520 */ GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2148568), // Rule ID 48178 //
     /* 2148525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148538 */   // MIs[0] Operand 1
     /* 2148538 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148551 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2148551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2148554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148558 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148567 */   // GIR_Coverage, 48178,
     /* 2148567 */   GIR_EraseRootFromParent_Done,
     /* 2148568 */ // Label 28911: @2148568
     /* 2148568 */ GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2148616), // Rule ID 48179 //
     /* 2148573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148586 */   // MIs[0] Operand 1
     /* 2148586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148599 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2148599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2148602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148604 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148606 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148615 */   // GIR_Coverage, 48179,
     /* 2148615 */   GIR_EraseRootFromParent_Done,
     /* 2148616 */ // Label 28912: @2148616
     /* 2148616 */ GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2148664), // Rule ID 48186 //
     /* 2148621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148634 */   // MIs[0] Operand 1
     /* 2148634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148647 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2148647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2148650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148652 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148654 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148663 */   // GIR_Coverage, 48186,
     /* 2148663 */   GIR_EraseRootFromParent_Done,
     /* 2148664 */ // Label 28913: @2148664
     /* 2148664 */ GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2148712), // Rule ID 48187 //
     /* 2148669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148682 */   // MIs[0] Operand 1
     /* 2148682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148691 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148695 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2148695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2148698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148700 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148702 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148711 */   // GIR_Coverage, 48187,
     /* 2148711 */   GIR_EraseRootFromParent_Done,
     /* 2148712 */ // Label 28914: @2148712
     /* 2148712 */ GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2148760), // Rule ID 48194 //
     /* 2148717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148730 */   // MIs[0] Operand 1
     /* 2148730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148743 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2148743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2148746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148748 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148750 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148759 */   // GIR_Coverage, 48194,
     /* 2148759 */   GIR_EraseRootFromParent_Done,
     /* 2148760 */ // Label 28915: @2148760
     /* 2148760 */ GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2148808), // Rule ID 48195 //
     /* 2148765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2148774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148778 */   // MIs[0] Operand 1
     /* 2148778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2148783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148791 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2148791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2148794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148796 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148798 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2148800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148807 */   // GIR_Coverage, 48195,
     /* 2148807 */   GIR_EraseRootFromParent_Done,
     /* 2148808 */ // Label 28916: @2148808
     /* 2148808 */ GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2148856), // Rule ID 48222 //
     /* 2148813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148826 */   // MIs[0] Operand 1
     /* 2148826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2148831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148839 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2148839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2148842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148855 */   // GIR_Coverage, 48222,
     /* 2148855 */   GIR_EraseRootFromParent_Done,
     /* 2148856 */ // Label 28917: @2148856
     /* 2148856 */ GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2148904), // Rule ID 48223 //
     /* 2148861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2148867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2148870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148874 */   // MIs[0] Operand 1
     /* 2148874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2148879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148887 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2148887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2148890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2148902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148903 */   // GIR_Coverage, 48223,
     /* 2148903 */   GIR_EraseRootFromParent_Done,
     /* 2148904 */ // Label 28918: @2148904
     /* 2148904 */ GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2148952), // Rule ID 48230 //
     /* 2148909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2148912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148922 */   // MIs[0] Operand 1
     /* 2148922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2148927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148935 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2148935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2148938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148951 */   // GIR_Coverage, 48230,
     /* 2148951 */   GIR_EraseRootFromParent_Done,
     /* 2148952 */ // Label 28919: @2148952
     /* 2148952 */ GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2149000), // Rule ID 48231 //
     /* 2148957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2148960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148970 */   // MIs[0] Operand 1
     /* 2148970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2148975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148983 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2148983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2148986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2148990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2148992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2148995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2148999 */   // GIR_Coverage, 48231,
     /* 2148999 */   GIR_EraseRootFromParent_Done,
     /* 2149000 */ // Label 28920: @2149000
     /* 2149000 */ GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2149048), // Rule ID 48238 //
     /* 2149005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149018 */   // MIs[0] Operand 1
     /* 2149018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2149023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149031 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2149031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2149034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149038 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149047 */   // GIR_Coverage, 48238,
     /* 2149047 */   GIR_EraseRootFromParent_Done,
     /* 2149048 */ // Label 28921: @2149048
     /* 2149048 */ GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2149096), // Rule ID 48239 //
     /* 2149053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149066 */   // MIs[0] Operand 1
     /* 2149066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2149071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149079 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2149079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2149082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149095 */   // GIR_Coverage, 48239,
     /* 2149095 */   GIR_EraseRootFromParent_Done,
     /* 2149096 */ // Label 28922: @2149096
     /* 2149096 */ GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2149144), // Rule ID 48266 //
     /* 2149101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149114 */   // MIs[0] Operand 1
     /* 2149114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149127 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2149127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2149130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149132 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149134 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149143 */   // GIR_Coverage, 48266,
     /* 2149143 */   GIR_EraseRootFromParent_Done,
     /* 2149144 */ // Label 28923: @2149144
     /* 2149144 */ GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2149192), // Rule ID 48267 //
     /* 2149149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149162 */   // MIs[0] Operand 1
     /* 2149162 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149171 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149175 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2149175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2149178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149180 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149182 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149191 */   // GIR_Coverage, 48267,
     /* 2149191 */   GIR_EraseRootFromParent_Done,
     /* 2149192 */ // Label 28924: @2149192
     /* 2149192 */ GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2149240), // Rule ID 48274 //
     /* 2149197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149210 */   // MIs[0] Operand 1
     /* 2149210 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149219 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149223 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2149223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2149226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149228 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149230 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149239 */   // GIR_Coverage, 48274,
     /* 2149239 */   GIR_EraseRootFromParent_Done,
     /* 2149240 */ // Label 28925: @2149240
     /* 2149240 */ GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2149288), // Rule ID 48275 //
     /* 2149245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149258 */   // MIs[0] Operand 1
     /* 2149258 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149271 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2149271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2149274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149276 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149278 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149287 */   // GIR_Coverage, 48275,
     /* 2149287 */   GIR_EraseRootFromParent_Done,
     /* 2149288 */ // Label 28926: @2149288
     /* 2149288 */ GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2149336), // Rule ID 48282 //
     /* 2149293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149306 */   // MIs[0] Operand 1
     /* 2149306 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149319 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2149319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2149322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149326 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149335 */   // GIR_Coverage, 48282,
     /* 2149335 */   GIR_EraseRootFromParent_Done,
     /* 2149336 */ // Label 28927: @2149336
     /* 2149336 */ GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2149384), // Rule ID 48283 //
     /* 2149341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149354 */   // MIs[0] Operand 1
     /* 2149354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2149359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149367 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2149367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2149370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149383 */   // GIR_Coverage, 48283,
     /* 2149383 */   GIR_EraseRootFromParent_Done,
     /* 2149384 */ // Label 28928: @2149384
     /* 2149384 */ GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2149432), // Rule ID 48310 //
     /* 2149389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149402 */   // MIs[0] Operand 1
     /* 2149402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149415 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2149415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2149418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149431 */   // GIR_Coverage, 48310,
     /* 2149431 */   GIR_EraseRootFromParent_Done,
     /* 2149432 */ // Label 28929: @2149432
     /* 2149432 */ GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2149480), // Rule ID 48311 //
     /* 2149437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149450 */   // MIs[0] Operand 1
     /* 2149450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149463 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2149463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2149466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149479 */   // GIR_Coverage, 48311,
     /* 2149479 */   GIR_EraseRootFromParent_Done,
     /* 2149480 */ // Label 28930: @2149480
     /* 2149480 */ GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2149528), // Rule ID 48318 //
     /* 2149485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149498 */   // MIs[0] Operand 1
     /* 2149498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149511 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2149511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2149514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149527 */   // GIR_Coverage, 48318,
     /* 2149527 */   GIR_EraseRootFromParent_Done,
     /* 2149528 */ // Label 28931: @2149528
     /* 2149528 */ GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2149576), // Rule ID 48319 //
     /* 2149533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149546 */   // MIs[0] Operand 1
     /* 2149546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149559 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2149559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2149562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149575 */   // GIR_Coverage, 48319,
     /* 2149575 */   GIR_EraseRootFromParent_Done,
     /* 2149576 */ // Label 28932: @2149576
     /* 2149576 */ GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2149624), // Rule ID 48326 //
     /* 2149581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149594 */   // MIs[0] Operand 1
     /* 2149594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149607 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2149607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2149610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149623 */   // GIR_Coverage, 48326,
     /* 2149623 */   GIR_EraseRootFromParent_Done,
     /* 2149624 */ // Label 28933: @2149624
     /* 2149624 */ GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2149672), // Rule ID 48327 //
     /* 2149629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149642 */   // MIs[0] Operand 1
     /* 2149642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2149647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149655 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2149655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2149658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2149664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149671 */   // GIR_Coverage, 48327,
     /* 2149671 */   GIR_EraseRootFromParent_Done,
     /* 2149672 */ // Label 28934: @2149672
     /* 2149672 */ GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2149720), // Rule ID 48354 //
     /* 2149677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149690 */   // MIs[0] Operand 1
     /* 2149690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149703 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2149703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2149706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149710 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149719 */   // GIR_Coverage, 48354,
     /* 2149719 */   GIR_EraseRootFromParent_Done,
     /* 2149720 */ // Label 28935: @2149720
     /* 2149720 */ GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2149768), // Rule ID 48355 //
     /* 2149725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2149731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2149734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149738 */   // MIs[0] Operand 1
     /* 2149738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149751 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2149751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2149754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149756 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149758 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2149766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149767 */   // GIR_Coverage, 48355,
     /* 2149767 */   GIR_EraseRootFromParent_Done,
     /* 2149768 */ // Label 28936: @2149768
     /* 2149768 */ GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2149816), // Rule ID 48362 //
     /* 2149773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149786 */   // MIs[0] Operand 1
     /* 2149786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149799 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2149799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2149802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149804 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149806 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149815 */   // GIR_Coverage, 48362,
     /* 2149815 */   GIR_EraseRootFromParent_Done,
     /* 2149816 */ // Label 28937: @2149816
     /* 2149816 */ GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2149864), // Rule ID 48363 //
     /* 2149821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2149830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149834 */   // MIs[0] Operand 1
     /* 2149834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149847 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2149847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2149850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149854 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149863 */   // GIR_Coverage, 48363,
     /* 2149863 */   GIR_EraseRootFromParent_Done,
     /* 2149864 */ // Label 28938: @2149864
     /* 2149864 */ GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2149912), // Rule ID 48370 //
     /* 2149869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149882 */   // MIs[0] Operand 1
     /* 2149882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149895 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2149895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2149898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149902 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149911 */   // GIR_Coverage, 48370,
     /* 2149911 */   GIR_EraseRootFromParent_Done,
     /* 2149912 */ // Label 28939: @2149912
     /* 2149912 */ GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2149960), // Rule ID 48371 //
     /* 2149917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2149920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2149926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149930 */   // MIs[0] Operand 1
     /* 2149930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2149935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149943 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2149943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2149946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149950 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2149952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2149955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149959 */   // GIR_Coverage, 48371,
     /* 2149959 */   GIR_EraseRootFromParent_Done,
     /* 2149960 */ // Label 28940: @2149960
     /* 2149960 */ GIM_Reject,
     /* 2149961 */ // Label 28464: @2149961
     /* 2149961 */ GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2150009), // Rule ID 47962 //
     /* 2149966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2149969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2149972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2149975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149979 */   // MIs[0] Operand 1
     /* 2149979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2149984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149992 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2149992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2149995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149997 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2149999 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150008 */   // GIR_Coverage, 47962,
     /* 2150008 */   GIR_EraseRootFromParent_Done,
     /* 2150009 */ // Label 28941: @2150009
     /* 2150009 */ GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2150057), // Rule ID 47963 //
     /* 2150014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150027 */   // MIs[0] Operand 1
     /* 2150027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2150032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150040 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2150040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2150043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150045 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150047 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150056 */   // GIR_Coverage, 47963,
     /* 2150056 */   GIR_EraseRootFromParent_Done,
     /* 2150057 */ // Label 28942: @2150057
     /* 2150057 */ GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2150105), // Rule ID 47970 //
     /* 2150062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150075 */   // MIs[0] Operand 1
     /* 2150075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2150080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150088 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2150088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2150091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150093 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150095 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150104 */   // GIR_Coverage, 47970,
     /* 2150104 */   GIR_EraseRootFromParent_Done,
     /* 2150105 */ // Label 28943: @2150105
     /* 2150105 */ GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2150153), // Rule ID 47971 //
     /* 2150110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150123 */   // MIs[0] Operand 1
     /* 2150123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2150128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150136 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2150136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2150139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150141 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150143 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150152 */   // GIR_Coverage, 47971,
     /* 2150152 */   GIR_EraseRootFromParent_Done,
     /* 2150153 */ // Label 28944: @2150153
     /* 2150153 */ GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2150201), // Rule ID 48006 //
     /* 2150158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150171 */   // MIs[0] Operand 1
     /* 2150171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2150176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150184 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2150184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2150187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150191 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150200 */   // GIR_Coverage, 48006,
     /* 2150200 */   GIR_EraseRootFromParent_Done,
     /* 2150201 */ // Label 28945: @2150201
     /* 2150201 */ GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2150249), // Rule ID 48007 //
     /* 2150206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150219 */   // MIs[0] Operand 1
     /* 2150219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2150224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150232 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2150232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2150235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150248 */   // GIR_Coverage, 48007,
     /* 2150248 */   GIR_EraseRootFromParent_Done,
     /* 2150249 */ // Label 28946: @2150249
     /* 2150249 */ GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2150297), // Rule ID 48014 //
     /* 2150254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150267 */   // MIs[0] Operand 1
     /* 2150267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2150272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150280 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2150280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2150283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150296 */   // GIR_Coverage, 48014,
     /* 2150296 */   GIR_EraseRootFromParent_Done,
     /* 2150297 */ // Label 28947: @2150297
     /* 2150297 */ GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2150345), // Rule ID 48015 //
     /* 2150302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150315 */   // MIs[0] Operand 1
     /* 2150315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2150320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150328 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2150328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2150331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150344 */   // GIR_Coverage, 48015,
     /* 2150344 */   GIR_EraseRootFromParent_Done,
     /* 2150345 */ // Label 28948: @2150345
     /* 2150345 */ GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2150393), // Rule ID 48050 //
     /* 2150350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150363 */   // MIs[0] Operand 1
     /* 2150363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2150368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150376 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2150376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2150379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150392 */   // GIR_Coverage, 48050,
     /* 2150392 */   GIR_EraseRootFromParent_Done,
     /* 2150393 */ // Label 28949: @2150393
     /* 2150393 */ GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2150441), // Rule ID 48051 //
     /* 2150398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150411 */   // MIs[0] Operand 1
     /* 2150411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2150416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150424 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2150424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2150427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150440 */   // GIR_Coverage, 48051,
     /* 2150440 */   GIR_EraseRootFromParent_Done,
     /* 2150441 */ // Label 28950: @2150441
     /* 2150441 */ GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2150489), // Rule ID 48058 //
     /* 2150446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150459 */   // MIs[0] Operand 1
     /* 2150459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2150464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150472 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2150472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2150475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150488 */   // GIR_Coverage, 48058,
     /* 2150488 */   GIR_EraseRootFromParent_Done,
     /* 2150489 */ // Label 28951: @2150489
     /* 2150489 */ GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2150537), // Rule ID 48059 //
     /* 2150494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150507 */   // MIs[0] Operand 1
     /* 2150507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2150512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150520 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2150520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2150523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150536 */   // GIR_Coverage, 48059,
     /* 2150536 */   GIR_EraseRootFromParent_Done,
     /* 2150537 */ // Label 28952: @2150537
     /* 2150537 */ GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2150585), // Rule ID 48092 //
     /* 2150542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150555 */   // MIs[0] Operand 1
     /* 2150555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2150560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150568 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2150568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2150571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150573 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150575 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2150577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150584 */   // GIR_Coverage, 48092,
     /* 2150584 */   GIR_EraseRootFromParent_Done,
     /* 2150585 */ // Label 28953: @2150585
     /* 2150585 */ GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2150633), // Rule ID 48093 //
     /* 2150590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150603 */   // MIs[0] Operand 1
     /* 2150603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2150608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150616 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2150616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2150619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150621 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150623 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2150625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150632 */   // GIR_Coverage, 48093,
     /* 2150632 */   GIR_EraseRootFromParent_Done,
     /* 2150633 */ // Label 28954: @2150633
     /* 2150633 */ GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2150681), // Rule ID 48100 //
     /* 2150638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150651 */   // MIs[0] Operand 1
     /* 2150651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2150656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150664 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2150664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2150667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150669 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150671 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2150673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150680 */   // GIR_Coverage, 48100,
     /* 2150680 */   GIR_EraseRootFromParent_Done,
     /* 2150681 */ // Label 28955: @2150681
     /* 2150681 */ GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2150729), // Rule ID 48101 //
     /* 2150686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150699 */   // MIs[0] Operand 1
     /* 2150699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2150704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150712 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2150712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2150715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150717 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150719 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2150721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150728 */   // GIR_Coverage, 48101,
     /* 2150728 */   GIR_EraseRootFromParent_Done,
     /* 2150729 */ // Label 28956: @2150729
     /* 2150729 */ GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2150777), // Rule ID 48136 //
     /* 2150734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150747 */   // MIs[0] Operand 1
     /* 2150747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2150752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150760 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2150760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2150763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150776 */   // GIR_Coverage, 48136,
     /* 2150776 */   GIR_EraseRootFromParent_Done,
     /* 2150777 */ // Label 28957: @2150777
     /* 2150777 */ GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2150825), // Rule ID 48137 //
     /* 2150782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150795 */   // MIs[0] Operand 1
     /* 2150795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2150800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150808 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2150808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2150811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150815 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150824 */   // GIR_Coverage, 48137,
     /* 2150824 */   GIR_EraseRootFromParent_Done,
     /* 2150825 */ // Label 28958: @2150825
     /* 2150825 */ GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2150873), // Rule ID 48144 //
     /* 2150830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150843 */   // MIs[0] Operand 1
     /* 2150843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2150848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150856 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2150856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2150859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150861 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150863 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150872 */   // GIR_Coverage, 48144,
     /* 2150872 */   GIR_EraseRootFromParent_Done,
     /* 2150873 */ // Label 28959: @2150873
     /* 2150873 */ GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2150921), // Rule ID 48145 //
     /* 2150878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150891 */   // MIs[0] Operand 1
     /* 2150891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2150896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150904 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2150904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2150907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150909 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2150911 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2150913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150920 */   // GIR_Coverage, 48145,
     /* 2150920 */   GIR_EraseRootFromParent_Done,
     /* 2150921 */ // Label 28960: @2150921
     /* 2150921 */ GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2150969), // Rule ID 48180 //
     /* 2150926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2150929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150939 */   // MIs[0] Operand 1
     /* 2150939 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2150944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150952 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2150952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2150955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2150961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2150964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2150967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2150968 */   // GIR_Coverage, 48180,
     /* 2150968 */   GIR_EraseRootFromParent_Done,
     /* 2150969 */ // Label 28961: @2150969
     /* 2150969 */ GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2151017), // Rule ID 48181 //
     /* 2150974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2150977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2150980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2150983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150987 */   // MIs[0] Operand 1
     /* 2150987 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2150992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151000 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2151003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151007 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151016 */   // GIR_Coverage, 48181,
     /* 2151016 */   GIR_EraseRootFromParent_Done,
     /* 2151017 */ // Label 28962: @2151017
     /* 2151017 */ GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2151065), // Rule ID 48188 //
     /* 2151022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151035 */   // MIs[0] Operand 1
     /* 2151035 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2151040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151048 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2151048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2151051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151055 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151064 */   // GIR_Coverage, 48188,
     /* 2151064 */   GIR_EraseRootFromParent_Done,
     /* 2151065 */ // Label 28963: @2151065
     /* 2151065 */ GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2151113), // Rule ID 48189 //
     /* 2151070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151083 */   // MIs[0] Operand 1
     /* 2151083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2151088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151096 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2151096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2151099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151103 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151112 */   // GIR_Coverage, 48189,
     /* 2151112 */   GIR_EraseRootFromParent_Done,
     /* 2151113 */ // Label 28964: @2151113
     /* 2151113 */ GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2151161), // Rule ID 48224 //
     /* 2151118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151131 */   // MIs[0] Operand 1
     /* 2151131 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2151136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151140 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151144 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2151147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151149 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151151 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151160 */   // GIR_Coverage, 48224,
     /* 2151160 */   GIR_EraseRootFromParent_Done,
     /* 2151161 */ // Label 28965: @2151161
     /* 2151161 */ GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2151209), // Rule ID 48225 //
     /* 2151166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151179 */   // MIs[0] Operand 1
     /* 2151179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2151184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151192 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2151195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151197 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151199 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151208 */   // GIR_Coverage, 48225,
     /* 2151208 */   GIR_EraseRootFromParent_Done,
     /* 2151209 */ // Label 28966: @2151209
     /* 2151209 */ GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2151257), // Rule ID 48232 //
     /* 2151214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151227 */   // MIs[0] Operand 1
     /* 2151227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2151232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151240 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2151240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2151243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151245 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151247 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151256 */   // GIR_Coverage, 48232,
     /* 2151256 */   GIR_EraseRootFromParent_Done,
     /* 2151257 */ // Label 28967: @2151257
     /* 2151257 */ GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2151305), // Rule ID 48233 //
     /* 2151262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151275 */   // MIs[0] Operand 1
     /* 2151275 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2151280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151288 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2151288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2151291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151293 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151295 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151304 */   // GIR_Coverage, 48233,
     /* 2151304 */   GIR_EraseRootFromParent_Done,
     /* 2151305 */ // Label 28968: @2151305
     /* 2151305 */ GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2151353), // Rule ID 48268 //
     /* 2151310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151316 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151323 */   // MIs[0] Operand 1
     /* 2151323 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2151328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151332 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151336 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2151339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151343 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151352 */   // GIR_Coverage, 48268,
     /* 2151352 */   GIR_EraseRootFromParent_Done,
     /* 2151353 */ // Label 28969: @2151353
     /* 2151353 */ GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2151401), // Rule ID 48269 //
     /* 2151358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151371 */   // MIs[0] Operand 1
     /* 2151371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2151376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151380 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151384 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2151387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151391 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151400 */   // GIR_Coverage, 48269,
     /* 2151400 */   GIR_EraseRootFromParent_Done,
     /* 2151401 */ // Label 28970: @2151401
     /* 2151401 */ GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2151449), // Rule ID 48276 //
     /* 2151406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151419 */   // MIs[0] Operand 1
     /* 2151419 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2151424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151428 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151432 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2151432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2151435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151439 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151448 */   // GIR_Coverage, 48276,
     /* 2151448 */   GIR_EraseRootFromParent_Done,
     /* 2151449 */ // Label 28971: @2151449
     /* 2151449 */ GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2151497), // Rule ID 48277 //
     /* 2151454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151467 */   // MIs[0] Operand 1
     /* 2151467 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2151472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151476 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151480 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2151480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2151483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151496 */   // GIR_Coverage, 48277,
     /* 2151496 */   GIR_EraseRootFromParent_Done,
     /* 2151497 */ // Label 28972: @2151497
     /* 2151497 */ GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2151545), // Rule ID 48312 //
     /* 2151502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151515 */   // MIs[0] Operand 1
     /* 2151515 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2151520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151524 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151528 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2151531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151535 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151544 */   // GIR_Coverage, 48312,
     /* 2151544 */   GIR_EraseRootFromParent_Done,
     /* 2151545 */ // Label 28973: @2151545
     /* 2151545 */ GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2151593), // Rule ID 48313 //
     /* 2151550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151563 */   // MIs[0] Operand 1
     /* 2151563 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2151568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151576 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2151579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151581 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151583 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151592 */   // GIR_Coverage, 48313,
     /* 2151592 */   GIR_EraseRootFromParent_Done,
     /* 2151593 */ // Label 28974: @2151593
     /* 2151593 */ GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2151641), // Rule ID 48320 //
     /* 2151598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151611 */   // MIs[0] Operand 1
     /* 2151611 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2151616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151620 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151624 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2151624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2151627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151629 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151631 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151640 */   // GIR_Coverage, 48320,
     /* 2151640 */   GIR_EraseRootFromParent_Done,
     /* 2151641 */ // Label 28975: @2151641
     /* 2151641 */ GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2151689), // Rule ID 48321 //
     /* 2151646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151652 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151659 */   // MIs[0] Operand 1
     /* 2151659 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2151664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151672 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2151672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2151675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151677 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151679 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151688 */   // GIR_Coverage, 48321,
     /* 2151688 */   GIR_EraseRootFromParent_Done,
     /* 2151689 */ // Label 28976: @2151689
     /* 2151689 */ GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2151737), // Rule ID 48356 //
     /* 2151694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151707 */   // MIs[0] Operand 1
     /* 2151707 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2151712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151720 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2151723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151727 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151736 */   // GIR_Coverage, 48356,
     /* 2151736 */   GIR_EraseRootFromParent_Done,
     /* 2151737 */ // Label 28977: @2151737
     /* 2151737 */ GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2151785), // Rule ID 48357 //
     /* 2151742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2151748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2151751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151755 */   // MIs[0] Operand 1
     /* 2151755 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2151760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151764 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151768 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2151771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151775 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151784 */   // GIR_Coverage, 48357,
     /* 2151784 */   GIR_EraseRootFromParent_Done,
     /* 2151785 */ // Label 28978: @2151785
     /* 2151785 */ GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2151833), // Rule ID 48364 //
     /* 2151790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151803 */   // MIs[0] Operand 1
     /* 2151803 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2151808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151812 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151816 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2151816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2151819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151832 */   // GIR_Coverage, 48364,
     /* 2151832 */   GIR_EraseRootFromParent_Done,
     /* 2151833 */ // Label 28979: @2151833
     /* 2151833 */ GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2151881), // Rule ID 48365 //
     /* 2151838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151851 */   // MIs[0] Operand 1
     /* 2151851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2151856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151860 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151864 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2151864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2151867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151871 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2151873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2151880 */   // GIR_Coverage, 48365,
     /* 2151880 */   GIR_EraseRootFromParent_Done,
     /* 2151881 */ // Label 28980: @2151881
     /* 2151881 */ GIM_Reject,
     /* 2151882 */ // Label 28465: @2151882
     /* 2151882 */ GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2152658),
     /* 2151887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2151890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2151893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151897 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2151935), // Rule ID 47964 //
     /* 2151902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151905 */     // MIs[0] Operand 1
     /* 2151905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2151910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151918 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2151921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151934 */     // GIR_Coverage, 47964,
     /* 2151934 */     GIR_EraseRootFromParent_Done,
     /* 2151935 */   // Label 28982: @2151935
     /* 2151935 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2151973), // Rule ID 47965 //
     /* 2151940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2151943 */     // MIs[0] Operand 1
     /* 2151943 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2151948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151956 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2151956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2151959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2151963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2151965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2151968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2151971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151972 */     // GIR_Coverage, 47965,
     /* 2151972 */     GIR_EraseRootFromParent_Done,
     /* 2151973 */   // Label 28983: @2151973
     /* 2151973 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2152011), // Rule ID 48008 //
     /* 2151978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2151981 */     // MIs[0] Operand 1
     /* 2151981 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2151986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151994 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2151994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2151997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152010 */     // GIR_Coverage, 48008,
     /* 2152010 */     GIR_EraseRootFromParent_Done,
     /* 2152011 */   // Label 28984: @2152011
     /* 2152011 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2152049), // Rule ID 48009 //
     /* 2152016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152019 */     // MIs[0] Operand 1
     /* 2152019 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2152024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152032 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2152035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152048 */     // GIR_Coverage, 48009,
     /* 2152048 */     GIR_EraseRootFromParent_Done,
     /* 2152049 */   // Label 28985: @2152049
     /* 2152049 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2152087), // Rule ID 48052 //
     /* 2152054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152057 */     // MIs[0] Operand 1
     /* 2152057 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2152062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152070 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2152073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152086 */     // GIR_Coverage, 48052,
     /* 2152086 */     GIR_EraseRootFromParent_Done,
     /* 2152087 */   // Label 28986: @2152087
     /* 2152087 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2152125), // Rule ID 48053 //
     /* 2152092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152095 */     // MIs[0] Operand 1
     /* 2152095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2152100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152108 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2152111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152124 */     // GIR_Coverage, 48053,
     /* 2152124 */     GIR_EraseRootFromParent_Done,
     /* 2152125 */   // Label 28987: @2152125
     /* 2152125 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2152163), // Rule ID 48094 //
     /* 2152130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152133 */     // MIs[0] Operand 1
     /* 2152133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2152138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152146 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2152149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152162 */     // GIR_Coverage, 48094,
     /* 2152162 */     GIR_EraseRootFromParent_Done,
     /* 2152163 */   // Label 28988: @2152163
     /* 2152163 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2152201), // Rule ID 48095 //
     /* 2152168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152171 */     // MIs[0] Operand 1
     /* 2152171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2152176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152184 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2152187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152200 */     // GIR_Coverage, 48095,
     /* 2152200 */     GIR_EraseRootFromParent_Done,
     /* 2152201 */   // Label 28989: @2152201
     /* 2152201 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2152239), // Rule ID 48138 //
     /* 2152206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152209 */     // MIs[0] Operand 1
     /* 2152209 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2152214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152222 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2152225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152238 */     // GIR_Coverage, 48138,
     /* 2152238 */     GIR_EraseRootFromParent_Done,
     /* 2152239 */   // Label 28990: @2152239
     /* 2152239 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2152277), // Rule ID 48139 //
     /* 2152244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152247 */     // MIs[0] Operand 1
     /* 2152247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2152252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152260 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2152263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152276 */     // GIR_Coverage, 48139,
     /* 2152276 */     GIR_EraseRootFromParent_Done,
     /* 2152277 */   // Label 28991: @2152277
     /* 2152277 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2152315), // Rule ID 48182 //
     /* 2152282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152285 */     // MIs[0] Operand 1
     /* 2152285 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2152290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152298 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2152301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152314 */     // GIR_Coverage, 48182,
     /* 2152314 */     GIR_EraseRootFromParent_Done,
     /* 2152315 */   // Label 28992: @2152315
     /* 2152315 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2152353), // Rule ID 48183 //
     /* 2152320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152323 */     // MIs[0] Operand 1
     /* 2152323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2152328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152336 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2152339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152352 */     // GIR_Coverage, 48183,
     /* 2152352 */     GIR_EraseRootFromParent_Done,
     /* 2152353 */   // Label 28993: @2152353
     /* 2152353 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2152391), // Rule ID 48226 //
     /* 2152358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152361 */     // MIs[0] Operand 1
     /* 2152361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2152366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152374 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2152377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152390 */     // GIR_Coverage, 48226,
     /* 2152390 */     GIR_EraseRootFromParent_Done,
     /* 2152391 */   // Label 28994: @2152391
     /* 2152391 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2152429), // Rule ID 48227 //
     /* 2152396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152399 */     // MIs[0] Operand 1
     /* 2152399 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2152404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152412 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2152415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152428 */     // GIR_Coverage, 48227,
     /* 2152428 */     GIR_EraseRootFromParent_Done,
     /* 2152429 */   // Label 28995: @2152429
     /* 2152429 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2152467), // Rule ID 48270 //
     /* 2152434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152437 */     // MIs[0] Operand 1
     /* 2152437 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2152442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152450 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2152453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152466 */     // GIR_Coverage, 48270,
     /* 2152466 */     GIR_EraseRootFromParent_Done,
     /* 2152467 */   // Label 28996: @2152467
     /* 2152467 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2152505), // Rule ID 48271 //
     /* 2152472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152475 */     // MIs[0] Operand 1
     /* 2152475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2152480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152488 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2152491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152504 */     // GIR_Coverage, 48271,
     /* 2152504 */     GIR_EraseRootFromParent_Done,
     /* 2152505 */   // Label 28997: @2152505
     /* 2152505 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2152543), // Rule ID 48314 //
     /* 2152510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152513 */     // MIs[0] Operand 1
     /* 2152513 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2152518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152526 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2152529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152542 */     // GIR_Coverage, 48314,
     /* 2152542 */     GIR_EraseRootFromParent_Done,
     /* 2152543 */   // Label 28998: @2152543
     /* 2152543 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2152581), // Rule ID 48315 //
     /* 2152548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152551 */     // MIs[0] Operand 1
     /* 2152551 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2152556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152564 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2152567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152580 */     // GIR_Coverage, 48315,
     /* 2152580 */     GIR_EraseRootFromParent_Done,
     /* 2152581 */   // Label 28999: @2152581
     /* 2152581 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2152619), // Rule ID 48358 //
     /* 2152586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2152589 */     // MIs[0] Operand 1
     /* 2152589 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2152594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152602 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2152602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2152605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152618 */     // GIR_Coverage, 48358,
     /* 2152618 */     GIR_EraseRootFromParent_Done,
     /* 2152619 */   // Label 29000: @2152619
     /* 2152619 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2152657), // Rule ID 48359 //
     /* 2152624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2152627 */     // MIs[0] Operand 1
     /* 2152627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2152632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152640 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2152640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2152643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2152649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2152652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2152655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152656 */     // GIR_Coverage, 48359,
     /* 2152656 */     GIR_EraseRootFromParent_Done,
     /* 2152657 */   // Label 29001: @2152657
     /* 2152657 */   GIM_Reject,
     /* 2152658 */ // Label 28981: @2152658
     /* 2152658 */ GIM_Reject,
     /* 2152659 */ // Label 28466: @2152659
     /* 2152659 */ GIM_Reject,
     /* 2152660 */ // Label 49: @2152660
     /* 2152660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 29010*/ GIMT_Encode4(2160121),
     /* 2152671 */ /*GILLT_s32*//*Label 29002*/ GIMT_Encode4(2152779),
     /* 2152675 */ /*GILLT_s64*//*Label 29003*/ GIMT_Encode4(2153536),
     /* 2152679 */ /*GILLT_nxv1s1*//*Label 29004*/ GIMT_Encode4(2154419), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2152699 */ /*GILLT_nxv2s1*//*Label 29005*/ GIMT_Encode4(2155572), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2152719 */ /*GILLT_nxv4s1*//*Label 29006*/ GIMT_Encode4(2156725), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2152739 */ /*GILLT_nxv8s1*//*Label 29007*/ GIMT_Encode4(2157878), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2152759 */ /*GILLT_nxv16s1*//*Label 29008*/ GIMT_Encode4(2159031), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2152775 */ /*GILLT_nxv32s1*//*Label 29009*/ GIMT_Encode4(2159800),
     /* 2152779 */ // Label 29002: @2152779
     /* 2152779 */ GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2152821), // Rule ID 1224 //
     /* 2152784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2152787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2152790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2152797 */   // MIs[0] Operand 1
     /* 2152797 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2152802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152806 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152810 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2152810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2152813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152815 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152817 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2152820 */   // GIR_Coverage, 1224,
     /* 2152820 */   GIR_EraseRootFromParent_Done,
     /* 2152821 */ // Label 29011: @2152821
     /* 2152821 */ GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2152863), // Rule ID 1228 //
     /* 2152826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2152829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2152832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2152839 */   // MIs[0] Operand 1
     /* 2152839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2152844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2152848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2152852 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2152852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2152855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152859 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2152862 */   // GIR_Coverage, 1228,
     /* 2152862 */   GIR_EraseRootFromParent_Done,
     /* 2152863 */ // Label 29012: @2152863
     /* 2152863 */ GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2152905), // Rule ID 1272 //
     /* 2152868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2152871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2152874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2152881 */   // MIs[0] Operand 1
     /* 2152881 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2152886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152894 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2152894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2152897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152899 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2152904 */   // GIR_Coverage, 1272,
     /* 2152904 */   GIR_EraseRootFromParent_Done,
     /* 2152905 */ // Label 29013: @2152905
     /* 2152905 */ GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2152947), // Rule ID 1276 //
     /* 2152910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2152913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2152916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2152923 */   // MIs[0] Operand 1
     /* 2152923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2152928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2152932 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2152936 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2152936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2152939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152943 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2152946 */   // GIR_Coverage, 1276,
     /* 2152946 */   GIR_EraseRootFromParent_Done,
     /* 2152947 */ // Label 29014: @2152947
     /* 2152947 */ GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2152989), // Rule ID 1288 //
     /* 2152952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2152955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2152958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2152965 */   // MIs[0] Operand 1
     /* 2152965 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2152970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152974 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152978 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2152978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2152981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152983 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2152985 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2152987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2152988 */   // GIR_Coverage, 1288,
     /* 2152988 */   GIR_EraseRootFromParent_Done,
     /* 2152989 */ // Label 29015: @2152989
     /* 2152989 */ GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2153031), // Rule ID 1292 //
     /* 2152994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2152997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153007 */   // MIs[0] Operand 1
     /* 2153007 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153016 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153020 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2153023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153025 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153027 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153030 */   // GIR_Coverage, 1292,
     /* 2153030 */   GIR_EraseRootFromParent_Done,
     /* 2153031 */ // Label 29016: @2153031
     /* 2153031 */ GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2153073), // Rule ID 1604 //
     /* 2153036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2153039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153049 */   // MIs[0] Operand 1
     /* 2153049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153062 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2153065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153072 */   // GIR_Coverage, 1604,
     /* 2153072 */   GIR_EraseRootFromParent_Done,
     /* 2153073 */ // Label 29017: @2153073
     /* 2153073 */ GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2153115), // Rule ID 1608 //
     /* 2153078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2153081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153091 */   // MIs[0] Operand 1
     /* 2153091 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153100 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153104 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2153107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153109 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153111 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153114 */   // GIR_Coverage, 1608,
     /* 2153114 */   GIR_EraseRootFromParent_Done,
     /* 2153115 */ // Label 29018: @2153115
     /* 2153115 */ GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2153157), // Rule ID 1646 //
     /* 2153120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2153123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153133 */   // MIs[0] Operand 1
     /* 2153133 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153142 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153146 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2153149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153153 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153156 */   // GIR_Coverage, 1646,
     /* 2153156 */   GIR_EraseRootFromParent_Done,
     /* 2153157 */ // Label 29019: @2153157
     /* 2153157 */ GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2153199), // Rule ID 1654 //
     /* 2153162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2153165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153175 */   // MIs[0] Operand 1
     /* 2153175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153188 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2153191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153193 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153198 */   // GIR_Coverage, 1654,
     /* 2153198 */   GIR_EraseRootFromParent_Done,
     /* 2153199 */ // Label 29020: @2153199
     /* 2153199 */ GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2153241), // Rule ID 1682 //
     /* 2153204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2153207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153217 */   // MIs[0] Operand 1
     /* 2153217 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153230 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2153233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153237 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153240 */   // GIR_Coverage, 1682,
     /* 2153240 */   GIR_EraseRootFromParent_Done,
     /* 2153241 */ // Label 29021: @2153241
     /* 2153241 */ GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2153283), // Rule ID 1690 //
     /* 2153246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2153249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153259 */   // MIs[0] Operand 1
     /* 2153259 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153272 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2153275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153279 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153282 */   // GIR_Coverage, 1690,
     /* 2153282 */   GIR_EraseRootFromParent_Done,
     /* 2153283 */ // Label 29022: @2153283
     /* 2153283 */ GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2153325), // Rule ID 1937 //
     /* 2153288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2153291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153301 */   // MIs[0] Operand 1
     /* 2153301 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153314 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2153317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153324 */   // GIR_Coverage, 1937,
     /* 2153324 */   GIR_EraseRootFromParent_Done,
     /* 2153325 */ // Label 29023: @2153325
     /* 2153325 */ GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2153367), // Rule ID 1941 //
     /* 2153330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2153333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153343 */   // MIs[0] Operand 1
     /* 2153343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153356 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2153359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153366 */   // GIR_Coverage, 1941,
     /* 2153366 */   GIR_EraseRootFromParent_Done,
     /* 2153367 */ // Label 29024: @2153367
     /* 2153367 */ GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2153409), // Rule ID 1985 //
     /* 2153372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2153375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153385 */   // MIs[0] Operand 1
     /* 2153385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153398 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2153401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153408 */   // GIR_Coverage, 1985,
     /* 2153408 */   GIR_EraseRootFromParent_Done,
     /* 2153409 */ // Label 29025: @2153409
     /* 2153409 */ GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2153451), // Rule ID 1989 //
     /* 2153414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2153417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153427 */   // MIs[0] Operand 1
     /* 2153427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153440 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2153443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153445 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153447 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153450 */   // GIR_Coverage, 1989,
     /* 2153450 */   GIR_EraseRootFromParent_Done,
     /* 2153451 */ // Label 29026: @2153451
     /* 2153451 */ GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2153493), // Rule ID 2001 //
     /* 2153456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2153459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153469 */   // MIs[0] Operand 1
     /* 2153469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153482 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2153485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153492 */   // GIR_Coverage, 2001,
     /* 2153492 */   GIR_EraseRootFromParent_Done,
     /* 2153493 */ // Label 29027: @2153493
     /* 2153493 */ GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2153535), // Rule ID 2005 //
     /* 2153498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2153501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2153504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153511 */   // MIs[0] Operand 1
     /* 2153511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2153524 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2153524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2153527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153534 */   // GIR_Coverage, 2005,
     /* 2153534 */   GIR_EraseRootFromParent_Done,
     /* 2153535 */ // Label 29028: @2153535
     /* 2153535 */ GIM_Reject,
     /* 2153536 */ // Label 29003: @2153536
     /* 2153536 */ GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2153578), // Rule ID 1223 //
     /* 2153541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2153544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153554 */   // MIs[0] Operand 1
     /* 2153554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153563 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153567 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2153570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153572 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153574 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153577 */   // GIR_Coverage, 1223,
     /* 2153577 */   GIR_EraseRootFromParent_Done,
     /* 2153578 */ // Label 29029: @2153578
     /* 2153578 */ GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2153620), // Rule ID 1227 //
     /* 2153583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2153586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153596 */   // MIs[0] Operand 1
     /* 2153596 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153605 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153609 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2153612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153614 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153616 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153619 */   // GIR_Coverage, 1227,
     /* 2153619 */   GIR_EraseRootFromParent_Done,
     /* 2153620 */ // Label 29030: @2153620
     /* 2153620 */ GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2153662), // Rule ID 1271 //
     /* 2153625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2153628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153638 */   // MIs[0] Operand 1
     /* 2153638 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153647 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153651 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2153654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153656 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153658 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153661 */   // GIR_Coverage, 1271,
     /* 2153661 */   GIR_EraseRootFromParent_Done,
     /* 2153662 */ // Label 29031: @2153662
     /* 2153662 */ GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2153704), // Rule ID 1275 //
     /* 2153667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2153670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153680 */   // MIs[0] Operand 1
     /* 2153680 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153689 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153693 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2153696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153698 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153700 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153703 */   // GIR_Coverage, 1275,
     /* 2153703 */   GIR_EraseRootFromParent_Done,
     /* 2153704 */ // Label 29032: @2153704
     /* 2153704 */ GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2153746), // Rule ID 1287 //
     /* 2153709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2153712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153722 */   // MIs[0] Operand 1
     /* 2153722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153731 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153735 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2153738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153740 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153745 */   // GIR_Coverage, 1287,
     /* 2153745 */   GIR_EraseRootFromParent_Done,
     /* 2153746 */ // Label 29033: @2153746
     /* 2153746 */ GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2153788), // Rule ID 1291 //
     /* 2153751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2153754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2153757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153764 */   // MIs[0] Operand 1
     /* 2153764 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2153777 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2153777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2153780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153784 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153787 */   // GIR_Coverage, 1291,
     /* 2153787 */   GIR_EraseRootFromParent_Done,
     /* 2153788 */ // Label 29034: @2153788
     /* 2153788 */ GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2153830), // Rule ID 1603 //
     /* 2153793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2153796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153806 */   // MIs[0] Operand 1
     /* 2153806 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153815 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153819 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2153822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153824 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153829 */   // GIR_Coverage, 1603,
     /* 2153829 */   GIR_EraseRootFromParent_Done,
     /* 2153830 */ // Label 29035: @2153830
     /* 2153830 */ GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2153872), // Rule ID 1607 //
     /* 2153835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2153838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153848 */   // MIs[0] Operand 1
     /* 2153848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2153861 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2153864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153866 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153868 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153871 */   // GIR_Coverage, 1607,
     /* 2153871 */   GIR_EraseRootFromParent_Done,
     /* 2153872 */ // Label 29036: @2153872
     /* 2153872 */ GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2153914), // Rule ID 1610 //
     /* 2153877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2153880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153890 */   // MIs[0] Operand 1
     /* 2153890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2153895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153903 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2153906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153913 */   // GIR_Coverage, 1610,
     /* 2153913 */   GIR_EraseRootFromParent_Done,
     /* 2153914 */ // Label 29037: @2153914
     /* 2153914 */ GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2153956), // Rule ID 1645 //
     /* 2153919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2153922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153925 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153932 */   // MIs[0] Operand 1
     /* 2153932 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2153937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153945 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2153948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153950 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153952 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153955 */   // GIR_Coverage, 1645,
     /* 2153955 */   GIR_EraseRootFromParent_Done,
     /* 2153956 */ // Label 29038: @2153956
     /* 2153956 */ GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2153998), // Rule ID 1653 //
     /* 2153961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2153964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2153967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2153974 */   // MIs[0] Operand 1
     /* 2153974 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2153979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153987 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2153987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2153990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153992 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2153994 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2153996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2153997 */   // GIR_Coverage, 1653,
     /* 2153997 */   GIR_EraseRootFromParent_Done,
     /* 2153998 */ // Label 29039: @2153998
     /* 2153998 */ GIM_Try, /*On fail goto*//*Label 29040*/ GIMT_Encode4(2154040), // Rule ID 1662 //
     /* 2154003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2154006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2154009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154016 */   // MIs[0] Operand 1
     /* 2154016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2154021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154029 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2154029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2154032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154034 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154036 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154039 */   // GIR_Coverage, 1662,
     /* 2154039 */   GIR_EraseRootFromParent_Done,
     /* 2154040 */ // Label 29040: @2154040
     /* 2154040 */ GIM_Try, /*On fail goto*//*Label 29041*/ GIMT_Encode4(2154082), // Rule ID 1666 //
     /* 2154045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2154048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2154051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154058 */   // MIs[0] Operand 1
     /* 2154058 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2154063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154071 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2154071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2154074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154076 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154078 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154081 */   // GIR_Coverage, 1666,
     /* 2154081 */   GIR_EraseRootFromParent_Done,
     /* 2154082 */ // Label 29041: @2154082
     /* 2154082 */ GIM_Try, /*On fail goto*//*Label 29042*/ GIMT_Encode4(2154124), // Rule ID 1681 //
     /* 2154087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2154090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2154093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154100 */   // MIs[0] Operand 1
     /* 2154100 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2154105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2154109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2154113 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2154113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2154116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154118 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154120 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154123 */   // GIR_Coverage, 1681,
     /* 2154123 */   GIR_EraseRootFromParent_Done,
     /* 2154124 */ // Label 29042: @2154124
     /* 2154124 */ GIM_Try, /*On fail goto*//*Label 29043*/ GIMT_Encode4(2154166), // Rule ID 1689 //
     /* 2154129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2154132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2154135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154142 */   // MIs[0] Operand 1
     /* 2154142 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2154147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2154151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2154155 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2154155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2154158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154160 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154162 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154165 */   // GIR_Coverage, 1689,
     /* 2154165 */   GIR_EraseRootFromParent_Done,
     /* 2154166 */ // Label 29043: @2154166
     /* 2154166 */ GIM_Try, /*On fail goto*//*Label 29044*/ GIMT_Encode4(2154208), // Rule ID 1936 //
     /* 2154171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2154174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154184 */   // MIs[0] Operand 1
     /* 2154184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154197 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2154200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154207 */   // GIR_Coverage, 1936,
     /* 2154207 */   GIR_EraseRootFromParent_Done,
     /* 2154208 */ // Label 29044: @2154208
     /* 2154208 */ GIM_Try, /*On fail goto*//*Label 29045*/ GIMT_Encode4(2154250), // Rule ID 1940 //
     /* 2154213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2154216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154226 */   // MIs[0] Operand 1
     /* 2154226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154239 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2154242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154249 */   // GIR_Coverage, 1940,
     /* 2154249 */   GIR_EraseRootFromParent_Done,
     /* 2154250 */ // Label 29045: @2154250
     /* 2154250 */ GIM_Try, /*On fail goto*//*Label 29046*/ GIMT_Encode4(2154292), // Rule ID 1984 //
     /* 2154255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2154258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154268 */   // MIs[0] Operand 1
     /* 2154268 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2154273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154277 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154281 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2154284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154286 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154288 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154291 */   // GIR_Coverage, 1984,
     /* 2154291 */   GIR_EraseRootFromParent_Done,
     /* 2154292 */ // Label 29046: @2154292
     /* 2154292 */ GIM_Try, /*On fail goto*//*Label 29047*/ GIMT_Encode4(2154334), // Rule ID 1988 //
     /* 2154297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2154300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154310 */   // MIs[0] Operand 1
     /* 2154310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2154315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154323 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2154326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154333 */   // GIR_Coverage, 1988,
     /* 2154333 */   GIR_EraseRootFromParent_Done,
     /* 2154334 */ // Label 29047: @2154334
     /* 2154334 */ GIM_Try, /*On fail goto*//*Label 29048*/ GIMT_Encode4(2154376), // Rule ID 2000 //
     /* 2154339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2154342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154352 */   // MIs[0] Operand 1
     /* 2154352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2154357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154365 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2154368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154375 */   // GIR_Coverage, 2000,
     /* 2154375 */   GIR_EraseRootFromParent_Done,
     /* 2154376 */ // Label 29048: @2154376
     /* 2154376 */ GIM_Try, /*On fail goto*//*Label 29049*/ GIMT_Encode4(2154418), // Rule ID 2004 //
     /* 2154381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2154384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2154387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2154394 */   // MIs[0] Operand 1
     /* 2154394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2154399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2154407 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2154407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2154410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154412 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154414 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154417 */   // GIR_Coverage, 2004,
     /* 2154417 */   GIR_EraseRootFromParent_Done,
     /* 2154418 */ // Label 29049: @2154418
     /* 2154418 */ GIM_Reject,
     /* 2154419 */ // Label 29004: @2154419
     /* 2154419 */ GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2154467), // Rule ID 56304 //
     /* 2154424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154430 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154437 */   // MIs[0] Operand 1
     /* 2154437 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154446 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154450 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2154450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2154453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154455 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154457 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154466 */   // GIR_Coverage, 56304,
     /* 2154466 */   GIR_EraseRootFromParent_Done,
     /* 2154467 */ // Label 29050: @2154467
     /* 2154467 */ GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2154515), // Rule ID 56305 //
     /* 2154472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154478 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154485 */   // MIs[0] Operand 1
     /* 2154485 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154494 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154498 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2154498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2154501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154503 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154505 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154513 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154514 */   // GIR_Coverage, 56305,
     /* 2154514 */   GIR_EraseRootFromParent_Done,
     /* 2154515 */ // Label 29051: @2154515
     /* 2154515 */ GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2154563), // Rule ID 56324 //
     /* 2154520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154533 */   // MIs[0] Operand 1
     /* 2154533 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154542 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154546 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2154546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2154549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154551 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154553 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154561 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154562 */   // GIR_Coverage, 56324,
     /* 2154562 */   GIR_EraseRootFromParent_Done,
     /* 2154563 */ // Label 29052: @2154563
     /* 2154563 */ GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2154611), // Rule ID 56325 //
     /* 2154568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154574 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154581 */   // MIs[0] Operand 1
     /* 2154581 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154590 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154594 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2154594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2154597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154599 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154601 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154610 */   // GIR_Coverage, 56325,
     /* 2154610 */   GIR_EraseRootFromParent_Done,
     /* 2154611 */ // Label 29053: @2154611
     /* 2154611 */ GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2154659), // Rule ID 56354 //
     /* 2154616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154622 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2154625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154629 */   // MIs[0] Operand 1
     /* 2154629 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154638 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154642 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2154642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2154645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154647 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154649 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154658 */   // GIR_Coverage, 56354,
     /* 2154658 */   GIR_EraseRootFromParent_Done,
     /* 2154659 */ // Label 29054: @2154659
     /* 2154659 */ GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2154707), // Rule ID 56355 //
     /* 2154664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2154673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154677 */   // MIs[0] Operand 1
     /* 2154677 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2154682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154686 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154690 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2154690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2154693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154695 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154697 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154706 */   // GIR_Coverage, 56355,
     /* 2154706 */   GIR_EraseRootFromParent_Done,
     /* 2154707 */ // Label 29055: @2154707
     /* 2154707 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2154755), // Rule ID 56604 //
     /* 2154712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154725 */   // MIs[0] Operand 1
     /* 2154725 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154738 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2154738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2154741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154743 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154753 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154754 */   // GIR_Coverage, 56604,
     /* 2154754 */   GIR_EraseRootFromParent_Done,
     /* 2154755 */ // Label 29056: @2154755
     /* 2154755 */ GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2154803), // Rule ID 56605 //
     /* 2154760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154766 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154773 */   // MIs[0] Operand 1
     /* 2154773 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154782 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154786 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2154786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2154789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154791 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154793 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154802 */   // GIR_Coverage, 56605,
     /* 2154802 */   GIR_EraseRootFromParent_Done,
     /* 2154803 */ // Label 29057: @2154803
     /* 2154803 */ GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2154851), // Rule ID 56624 //
     /* 2154808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154814 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154821 */   // MIs[0] Operand 1
     /* 2154821 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154830 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154834 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2154834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2154837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154839 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154841 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154850 */   // GIR_Coverage, 56624,
     /* 2154850 */   GIR_EraseRootFromParent_Done,
     /* 2154851 */ // Label 29058: @2154851
     /* 2154851 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2154899), // Rule ID 56625 //
     /* 2154856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154862 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154869 */   // MIs[0] Operand 1
     /* 2154869 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154878 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154882 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2154882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2154885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154887 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154898 */   // GIR_Coverage, 56625,
     /* 2154898 */   GIR_EraseRootFromParent_Done,
     /* 2154899 */ // Label 29059: @2154899
     /* 2154899 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2154947), // Rule ID 56654 //
     /* 2154904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2154913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154917 */   // MIs[0] Operand 1
     /* 2154917 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154926 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154930 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2154930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2154933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154935 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154937 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154946 */   // GIR_Coverage, 56654,
     /* 2154946 */   GIR_EraseRootFromParent_Done,
     /* 2154947 */ // Label 29060: @2154947
     /* 2154947 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2154995), // Rule ID 56655 //
     /* 2154952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2154961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154965 */   // MIs[0] Operand 1
     /* 2154965 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2154970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154974 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154978 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2154978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2154981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154983 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2154985 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2154987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2154990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2154994 */   // GIR_Coverage, 56655,
     /* 2154994 */   GIR_EraseRootFromParent_Done,
     /* 2154995 */ // Label 29061: @2154995
     /* 2154995 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2155043), // Rule ID 56904 //
     /* 2155000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155013 */   // MIs[0] Operand 1
     /* 2155013 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155022 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155026 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2155026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2155029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155031 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155033 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155041 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155042 */   // GIR_Coverage, 56904,
     /* 2155042 */   GIR_EraseRootFromParent_Done,
     /* 2155043 */ // Label 29062: @2155043
     /* 2155043 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2155091), // Rule ID 56905 //
     /* 2155048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155061 */   // MIs[0] Operand 1
     /* 2155061 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155070 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155074 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2155074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2155077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155079 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155081 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155090 */   // GIR_Coverage, 56905,
     /* 2155090 */   GIR_EraseRootFromParent_Done,
     /* 2155091 */ // Label 29063: @2155091
     /* 2155091 */ GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2155139), // Rule ID 56924 //
     /* 2155096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155109 */   // MIs[0] Operand 1
     /* 2155109 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155118 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155122 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2155122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2155125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155127 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155129 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155138 */   // GIR_Coverage, 56924,
     /* 2155138 */   GIR_EraseRootFromParent_Done,
     /* 2155139 */ // Label 29064: @2155139
     /* 2155139 */ GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2155187), // Rule ID 56925 //
     /* 2155144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155150 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155157 */   // MIs[0] Operand 1
     /* 2155157 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155166 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155170 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2155170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2155173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155175 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155177 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155186 */   // GIR_Coverage, 56925,
     /* 2155186 */   GIR_EraseRootFromParent_Done,
     /* 2155187 */ // Label 29065: @2155187
     /* 2155187 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2155235), // Rule ID 56954 //
     /* 2155192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155205 */   // MIs[0] Operand 1
     /* 2155205 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155214 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155218 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2155218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2155221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155223 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155225 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155233 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155234 */   // GIR_Coverage, 56954,
     /* 2155234 */   GIR_EraseRootFromParent_Done,
     /* 2155235 */ // Label 29066: @2155235
     /* 2155235 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2155283), // Rule ID 56955 //
     /* 2155240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155246 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155253 */   // MIs[0] Operand 1
     /* 2155253 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2155258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155262 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155266 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2155266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2155269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155271 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155273 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155282 */   // GIR_Coverage, 56955,
     /* 2155282 */   GIR_EraseRootFromParent_Done,
     /* 2155283 */ // Label 29067: @2155283
     /* 2155283 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2155331), // Rule ID 57204 //
     /* 2155288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155301 */   // MIs[0] Operand 1
     /* 2155301 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155314 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2155314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2155317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155329 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155330 */   // GIR_Coverage, 57204,
     /* 2155330 */   GIR_EraseRootFromParent_Done,
     /* 2155331 */ // Label 29068: @2155331
     /* 2155331 */ GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2155379), // Rule ID 57205 //
     /* 2155336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155349 */   // MIs[0] Operand 1
     /* 2155349 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155358 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155362 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2155362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2155365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155367 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155369 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155378 */   // GIR_Coverage, 57205,
     /* 2155378 */   GIR_EraseRootFromParent_Done,
     /* 2155379 */ // Label 29069: @2155379
     /* 2155379 */ GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2155427), // Rule ID 57224 //
     /* 2155384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155397 */   // MIs[0] Operand 1
     /* 2155397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155410 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2155410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2155413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155417 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155426 */   // GIR_Coverage, 57224,
     /* 2155426 */   GIR_EraseRootFromParent_Done,
     /* 2155427 */ // Label 29070: @2155427
     /* 2155427 */ GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2155475), // Rule ID 57225 //
     /* 2155432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155445 */   // MIs[0] Operand 1
     /* 2155445 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155458 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2155458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2155461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155465 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155474 */   // GIR_Coverage, 57225,
     /* 2155474 */   GIR_EraseRootFromParent_Done,
     /* 2155475 */ // Label 29071: @2155475
     /* 2155475 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2155523), // Rule ID 57254 //
     /* 2155480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155493 */   // MIs[0] Operand 1
     /* 2155493 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155506 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2155506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2155509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155511 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155513 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155522 */   // GIR_Coverage, 57254,
     /* 2155522 */   GIR_EraseRootFromParent_Done,
     /* 2155523 */ // Label 29072: @2155523
     /* 2155523 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2155571), // Rule ID 57255 //
     /* 2155528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155541 */   // MIs[0] Operand 1
     /* 2155541 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2155546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155554 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2155554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2155557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155559 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155561 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155570 */   // GIR_Coverage, 57255,
     /* 2155570 */   GIR_EraseRootFromParent_Done,
     /* 2155571 */ // Label 29073: @2155571
     /* 2155571 */ GIM_Reject,
     /* 2155572 */ // Label 29005: @2155572
     /* 2155572 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2155620), // Rule ID 56314 //
     /* 2155577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2155583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2155586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155590 */   // MIs[0] Operand 1
     /* 2155590 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155599 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155603 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2155603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2155606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155608 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155610 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155619 */   // GIR_Coverage, 56314,
     /* 2155619 */   GIR_EraseRootFromParent_Done,
     /* 2155620 */ // Label 29074: @2155620
     /* 2155620 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2155668), // Rule ID 56315 //
     /* 2155625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2155631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2155634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155638 */   // MIs[0] Operand 1
     /* 2155638 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155647 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155651 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2155651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2155654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155656 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155658 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155667 */   // GIR_Coverage, 56315,
     /* 2155667 */   GIR_EraseRootFromParent_Done,
     /* 2155668 */ // Label 29075: @2155668
     /* 2155668 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2155716), // Rule ID 56344 //
     /* 2155673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155686 */   // MIs[0] Operand 1
     /* 2155686 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155699 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2155699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2155702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155704 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155706 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155715 */   // GIR_Coverage, 56344,
     /* 2155715 */   GIR_EraseRootFromParent_Done,
     /* 2155716 */ // Label 29076: @2155716
     /* 2155716 */ GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2155764), // Rule ID 56345 //
     /* 2155721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155734 */   // MIs[0] Operand 1
     /* 2155734 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155743 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155747 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2155747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2155750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155763 */   // GIR_Coverage, 56345,
     /* 2155763 */   GIR_EraseRootFromParent_Done,
     /* 2155764 */ // Label 29077: @2155764
     /* 2155764 */ GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2155812), // Rule ID 56424 //
     /* 2155769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2155778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155782 */   // MIs[0] Operand 1
     /* 2155782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155795 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2155795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2155798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155800 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155811 */   // GIR_Coverage, 56424,
     /* 2155811 */   GIR_EraseRootFromParent_Done,
     /* 2155812 */ // Label 29078: @2155812
     /* 2155812 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2155860), // Rule ID 56425 //
     /* 2155817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155823 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2155826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155830 */   // MIs[0] Operand 1
     /* 2155830 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2155835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155839 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155843 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2155843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2155846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155848 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155850 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155859 */   // GIR_Coverage, 56425,
     /* 2155859 */   GIR_EraseRootFromParent_Done,
     /* 2155860 */ // Label 29079: @2155860
     /* 2155860 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2155908), // Rule ID 56614 //
     /* 2155865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2155871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2155874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155878 */   // MIs[0] Operand 1
     /* 2155878 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2155883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155887 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155891 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2155891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2155894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155896 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155898 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155907 */   // GIR_Coverage, 56614,
     /* 2155907 */   GIR_EraseRootFromParent_Done,
     /* 2155908 */ // Label 29080: @2155908
     /* 2155908 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2155956), // Rule ID 56615 //
     /* 2155913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2155919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2155922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155926 */   // MIs[0] Operand 1
     /* 2155926 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2155931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155935 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155939 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2155939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2155942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155944 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155946 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2155955 */   // GIR_Coverage, 56615,
     /* 2155955 */   GIR_EraseRootFromParent_Done,
     /* 2155956 */ // Label 29081: @2155956
     /* 2155956 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2156004), // Rule ID 56644 //
     /* 2155961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155974 */   // MIs[0] Operand 1
     /* 2155974 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2155979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155987 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2155987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2155990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155992 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2155994 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2155996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2155999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156003 */   // GIR_Coverage, 56644,
     /* 2156003 */   GIR_EraseRootFromParent_Done,
     /* 2156004 */ // Label 29082: @2156004
     /* 2156004 */ GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2156052), // Rule ID 56645 //
     /* 2156009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156022 */   // MIs[0] Operand 1
     /* 2156022 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2156027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156031 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156035 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2156035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2156038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156040 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156042 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156051 */   // GIR_Coverage, 56645,
     /* 2156051 */   GIR_EraseRootFromParent_Done,
     /* 2156052 */ // Label 29083: @2156052
     /* 2156052 */ GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2156100), // Rule ID 56724 //
     /* 2156057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156070 */   // MIs[0] Operand 1
     /* 2156070 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2156075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156083 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2156083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2156086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156088 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156099 */   // GIR_Coverage, 56724,
     /* 2156099 */   GIR_EraseRootFromParent_Done,
     /* 2156100 */ // Label 29084: @2156100
     /* 2156100 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2156148), // Rule ID 56725 //
     /* 2156105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156118 */   // MIs[0] Operand 1
     /* 2156118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2156123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156131 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2156131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2156134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156136 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156138 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156147 */   // GIR_Coverage, 56725,
     /* 2156147 */   GIR_EraseRootFromParent_Done,
     /* 2156148 */ // Label 29085: @2156148
     /* 2156148 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2156196), // Rule ID 56914 //
     /* 2156153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156166 */   // MIs[0] Operand 1
     /* 2156166 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156175 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156179 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2156179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2156182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156184 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156186 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156195 */   // GIR_Coverage, 56914,
     /* 2156195 */   GIR_EraseRootFromParent_Done,
     /* 2156196 */ // Label 29086: @2156196
     /* 2156196 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2156244), // Rule ID 56915 //
     /* 2156201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156214 */   // MIs[0] Operand 1
     /* 2156214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156223 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156227 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2156227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2156230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156232 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156243 */   // GIR_Coverage, 56915,
     /* 2156243 */   GIR_EraseRootFromParent_Done,
     /* 2156244 */ // Label 29087: @2156244
     /* 2156244 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2156292), // Rule ID 56944 //
     /* 2156249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156262 */   // MIs[0] Operand 1
     /* 2156262 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156275 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2156275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2156278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156280 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156291 */   // GIR_Coverage, 56944,
     /* 2156291 */   GIR_EraseRootFromParent_Done,
     /* 2156292 */ // Label 29088: @2156292
     /* 2156292 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2156340), // Rule ID 56945 //
     /* 2156297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156310 */   // MIs[0] Operand 1
     /* 2156310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156323 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2156323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2156326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156339 */   // GIR_Coverage, 56945,
     /* 2156339 */   GIR_EraseRootFromParent_Done,
     /* 2156340 */ // Label 29089: @2156340
     /* 2156340 */ GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2156388), // Rule ID 57024 //
     /* 2156345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156358 */   // MIs[0] Operand 1
     /* 2156358 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156367 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156371 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2156371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2156374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156376 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156387 */   // GIR_Coverage, 57024,
     /* 2156387 */   GIR_EraseRootFromParent_Done,
     /* 2156388 */ // Label 29090: @2156388
     /* 2156388 */ GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2156436), // Rule ID 57025 //
     /* 2156393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156406 */   // MIs[0] Operand 1
     /* 2156406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2156411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156419 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2156419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2156422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156435 */   // GIR_Coverage, 57025,
     /* 2156435 */   GIR_EraseRootFromParent_Done,
     /* 2156436 */ // Label 29091: @2156436
     /* 2156436 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2156484), // Rule ID 57214 //
     /* 2156441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156454 */   // MIs[0] Operand 1
     /* 2156454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156467 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2156467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2156470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156483 */   // GIR_Coverage, 57214,
     /* 2156483 */   GIR_EraseRootFromParent_Done,
     /* 2156484 */ // Label 29092: @2156484
     /* 2156484 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2156532), // Rule ID 57215 //
     /* 2156489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156502 */   // MIs[0] Operand 1
     /* 2156502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156515 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2156515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2156518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156531 */   // GIR_Coverage, 57215,
     /* 2156531 */   GIR_EraseRootFromParent_Done,
     /* 2156532 */ // Label 29093: @2156532
     /* 2156532 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2156580), // Rule ID 57244 //
     /* 2156537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156550 */   // MIs[0] Operand 1
     /* 2156550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156563 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2156563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2156566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156579 */   // GIR_Coverage, 57244,
     /* 2156579 */   GIR_EraseRootFromParent_Done,
     /* 2156580 */ // Label 29094: @2156580
     /* 2156580 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2156628), // Rule ID 57245 //
     /* 2156585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156598 */   // MIs[0] Operand 1
     /* 2156598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156611 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2156611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2156614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156627 */   // GIR_Coverage, 57245,
     /* 2156627 */   GIR_EraseRootFromParent_Done,
     /* 2156628 */ // Label 29095: @2156628
     /* 2156628 */ GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2156676), // Rule ID 57324 //
     /* 2156633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156646 */   // MIs[0] Operand 1
     /* 2156646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156659 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2156659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2156662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156675 */   // GIR_Coverage, 57324,
     /* 2156675 */   GIR_EraseRootFromParent_Done,
     /* 2156676 */ // Label 29096: @2156676
     /* 2156676 */ GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2156724), // Rule ID 57325 //
     /* 2156681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156694 */   // MIs[0] Operand 1
     /* 2156694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2156699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156707 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2156707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2156710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156723 */   // GIR_Coverage, 57325,
     /* 2156723 */   GIR_EraseRootFromParent_Done,
     /* 2156724 */ // Label 29097: @2156724
     /* 2156724 */ GIM_Reject,
     /* 2156725 */ // Label 29006: @2156725
     /* 2156725 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2156773), // Rule ID 56334 //
     /* 2156730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156743 */   // MIs[0] Operand 1
     /* 2156743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156756 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2156756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2156759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156772 */   // GIR_Coverage, 56334,
     /* 2156772 */   GIR_EraseRootFromParent_Done,
     /* 2156773 */ // Label 29098: @2156773
     /* 2156773 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2156821), // Rule ID 56335 //
     /* 2156778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156791 */   // MIs[0] Operand 1
     /* 2156791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156804 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2156804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2156807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156820 */   // GIR_Coverage, 56335,
     /* 2156820 */   GIR_EraseRootFromParent_Done,
     /* 2156821 */ // Label 29099: @2156821
     /* 2156821 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2156869), // Rule ID 56394 //
     /* 2156826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156839 */   // MIs[0] Operand 1
     /* 2156839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156852 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2156852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2156855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156859 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156868 */   // GIR_Coverage, 56394,
     /* 2156868 */   GIR_EraseRootFromParent_Done,
     /* 2156869 */ // Label 29100: @2156869
     /* 2156869 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2156917), // Rule ID 56395 //
     /* 2156874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156887 */   // MIs[0] Operand 1
     /* 2156887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156900 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2156900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2156903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156907 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156916 */   // GIR_Coverage, 56395,
     /* 2156916 */   GIR_EraseRootFromParent_Done,
     /* 2156917 */ // Label 29101: @2156917
     /* 2156917 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2156965), // Rule ID 56434 //
     /* 2156922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2156931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156935 */   // MIs[0] Operand 1
     /* 2156935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156948 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2156948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2156951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156953 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2156955 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2156957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2156960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156964 */   // GIR_Coverage, 56434,
     /* 2156964 */   GIR_EraseRootFromParent_Done,
     /* 2156965 */ // Label 29102: @2156965
     /* 2156965 */ GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2157013), // Rule ID 56435 //
     /* 2156970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2156979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156983 */   // MIs[0] Operand 1
     /* 2156983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2156988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156996 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2156996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2156999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157003 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157012 */   // GIR_Coverage, 56435,
     /* 2157012 */   GIR_EraseRootFromParent_Done,
     /* 2157013 */ // Label 29103: @2157013
     /* 2157013 */ GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2157061), // Rule ID 56634 //
     /* 2157018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157031 */   // MIs[0] Operand 1
     /* 2157031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157044 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2157044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2157047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157049 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157051 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157060 */   // GIR_Coverage, 56634,
     /* 2157060 */   GIR_EraseRootFromParent_Done,
     /* 2157061 */ // Label 29104: @2157061
     /* 2157061 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2157109), // Rule ID 56635 //
     /* 2157066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157079 */   // MIs[0] Operand 1
     /* 2157079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157092 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2157092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2157095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157097 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157099 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157108 */   // GIR_Coverage, 56635,
     /* 2157108 */   GIR_EraseRootFromParent_Done,
     /* 2157109 */ // Label 29105: @2157109
     /* 2157109 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2157157), // Rule ID 56694 //
     /* 2157114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157127 */   // MIs[0] Operand 1
     /* 2157127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157140 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2157140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2157143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157145 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157156 */   // GIR_Coverage, 56694,
     /* 2157156 */   GIR_EraseRootFromParent_Done,
     /* 2157157 */ // Label 29106: @2157157
     /* 2157157 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2157205), // Rule ID 56695 //
     /* 2157162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157175 */   // MIs[0] Operand 1
     /* 2157175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157188 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2157188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2157191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157193 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157204 */   // GIR_Coverage, 56695,
     /* 2157204 */   GIR_EraseRootFromParent_Done,
     /* 2157205 */ // Label 29107: @2157205
     /* 2157205 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2157253), // Rule ID 56734 //
     /* 2157210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157223 */   // MIs[0] Operand 1
     /* 2157223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157236 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2157236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2157239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157241 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157252 */   // GIR_Coverage, 56734,
     /* 2157252 */   GIR_EraseRootFromParent_Done,
     /* 2157253 */ // Label 29108: @2157253
     /* 2157253 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2157301), // Rule ID 56735 //
     /* 2157258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157271 */   // MIs[0] Operand 1
     /* 2157271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2157276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157284 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2157284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2157287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157300 */   // GIR_Coverage, 56735,
     /* 2157300 */   GIR_EraseRootFromParent_Done,
     /* 2157301 */ // Label 29109: @2157301
     /* 2157301 */ GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2157349), // Rule ID 56934 //
     /* 2157306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157319 */   // MIs[0] Operand 1
     /* 2157319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157332 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2157332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2157335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157348 */   // GIR_Coverage, 56934,
     /* 2157348 */   GIR_EraseRootFromParent_Done,
     /* 2157349 */ // Label 29110: @2157349
     /* 2157349 */ GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2157397), // Rule ID 56935 //
     /* 2157354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157367 */   // MIs[0] Operand 1
     /* 2157367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157380 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2157380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2157383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157396 */   // GIR_Coverage, 56935,
     /* 2157396 */   GIR_EraseRootFromParent_Done,
     /* 2157397 */ // Label 29111: @2157397
     /* 2157397 */ GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2157445), // Rule ID 56994 //
     /* 2157402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157415 */   // MIs[0] Operand 1
     /* 2157415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157428 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2157428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2157431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157444 */   // GIR_Coverage, 56994,
     /* 2157444 */   GIR_EraseRootFromParent_Done,
     /* 2157445 */ // Label 29112: @2157445
     /* 2157445 */ GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2157493), // Rule ID 56995 //
     /* 2157450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157463 */   // MIs[0] Operand 1
     /* 2157463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157476 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2157476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2157479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157492 */   // GIR_Coverage, 56995,
     /* 2157492 */   GIR_EraseRootFromParent_Done,
     /* 2157493 */ // Label 29113: @2157493
     /* 2157493 */ GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2157541), // Rule ID 57034 //
     /* 2157498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157511 */   // MIs[0] Operand 1
     /* 2157511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157524 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2157524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2157527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157540 */   // GIR_Coverage, 57034,
     /* 2157540 */   GIR_EraseRootFromParent_Done,
     /* 2157541 */ // Label 29114: @2157541
     /* 2157541 */ GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2157589), // Rule ID 57035 //
     /* 2157546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157559 */   // MIs[0] Operand 1
     /* 2157559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2157564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157572 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2157572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2157575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157588 */   // GIR_Coverage, 57035,
     /* 2157588 */   GIR_EraseRootFromParent_Done,
     /* 2157589 */ // Label 29115: @2157589
     /* 2157589 */ GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2157637), // Rule ID 57234 //
     /* 2157594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157607 */   // MIs[0] Operand 1
     /* 2157607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157620 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2157620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2157623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157636 */   // GIR_Coverage, 57234,
     /* 2157636 */   GIR_EraseRootFromParent_Done,
     /* 2157637 */ // Label 29116: @2157637
     /* 2157637 */ GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2157685), // Rule ID 57235 //
     /* 2157642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157655 */   // MIs[0] Operand 1
     /* 2157655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157668 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2157668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2157671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157684 */   // GIR_Coverage, 57235,
     /* 2157684 */   GIR_EraseRootFromParent_Done,
     /* 2157685 */ // Label 29117: @2157685
     /* 2157685 */ GIM_Try, /*On fail goto*//*Label 29118*/ GIMT_Encode4(2157733), // Rule ID 57294 //
     /* 2157690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157703 */   // MIs[0] Operand 1
     /* 2157703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157716 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2157716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2157719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157732 */   // GIR_Coverage, 57294,
     /* 2157732 */   GIR_EraseRootFromParent_Done,
     /* 2157733 */ // Label 29118: @2157733
     /* 2157733 */ GIM_Try, /*On fail goto*//*Label 29119*/ GIMT_Encode4(2157781), // Rule ID 57295 //
     /* 2157738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157751 */   // MIs[0] Operand 1
     /* 2157751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157764 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2157764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2157767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157780 */   // GIR_Coverage, 57295,
     /* 2157780 */   GIR_EraseRootFromParent_Done,
     /* 2157781 */ // Label 29119: @2157781
     /* 2157781 */ GIM_Try, /*On fail goto*//*Label 29120*/ GIMT_Encode4(2157829), // Rule ID 57334 //
     /* 2157786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157799 */   // MIs[0] Operand 1
     /* 2157799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157812 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2157812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2157815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157828 */   // GIR_Coverage, 57334,
     /* 2157828 */   GIR_EraseRootFromParent_Done,
     /* 2157829 */ // Label 29120: @2157829
     /* 2157829 */ GIM_Try, /*On fail goto*//*Label 29121*/ GIMT_Encode4(2157877), // Rule ID 57335 //
     /* 2157834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157847 */   // MIs[0] Operand 1
     /* 2157847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2157852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157860 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2157860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2157863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157876 */   // GIR_Coverage, 57335,
     /* 2157876 */   GIR_EraseRootFromParent_Done,
     /* 2157877 */ // Label 29121: @2157877
     /* 2157877 */ GIM_Reject,
     /* 2157878 */ // Label 29007: @2157878
     /* 2157878 */ GIM_Try, /*On fail goto*//*Label 29122*/ GIMT_Encode4(2157926), // Rule ID 56364 //
     /* 2157883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157896 */   // MIs[0] Operand 1
     /* 2157896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2157901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157909 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2157909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2157912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157925 */   // GIR_Coverage, 56364,
     /* 2157925 */   GIR_EraseRootFromParent_Done,
     /* 2157926 */ // Label 29122: @2157926
     /* 2157926 */ GIM_Try, /*On fail goto*//*Label 29123*/ GIMT_Encode4(2157974), // Rule ID 56365 //
     /* 2157931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157944 */   // MIs[0] Operand 1
     /* 2157944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2157949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157957 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2157957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2157960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2157964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2157966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2157969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2157973 */   // GIR_Coverage, 56365,
     /* 2157973 */   GIR_EraseRootFromParent_Done,
     /* 2157974 */ // Label 29123: @2157974
     /* 2157974 */ GIM_Try, /*On fail goto*//*Label 29124*/ GIMT_Encode4(2158022), // Rule ID 56404 //
     /* 2157979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2157985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2157988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157992 */   // MIs[0] Operand 1
     /* 2157992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2157997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158005 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2158005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2158008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158021 */   // GIR_Coverage, 56404,
     /* 2158021 */   GIR_EraseRootFromParent_Done,
     /* 2158022 */ // Label 29124: @2158022
     /* 2158022 */ GIM_Try, /*On fail goto*//*Label 29125*/ GIMT_Encode4(2158070), // Rule ID 56405 //
     /* 2158027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158040 */   // MIs[0] Operand 1
     /* 2158040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2158045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158053 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2158053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2158056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158069 */   // GIR_Coverage, 56405,
     /* 2158069 */   GIR_EraseRootFromParent_Done,
     /* 2158070 */ // Label 29125: @2158070
     /* 2158070 */ GIM_Try, /*On fail goto*//*Label 29126*/ GIMT_Encode4(2158118), // Rule ID 56444 //
     /* 2158075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158088 */   // MIs[0] Operand 1
     /* 2158088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2158093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158101 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2158101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2158104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158117 */   // GIR_Coverage, 56444,
     /* 2158117 */   GIR_EraseRootFromParent_Done,
     /* 2158118 */ // Label 29126: @2158118
     /* 2158118 */ GIM_Try, /*On fail goto*//*Label 29127*/ GIMT_Encode4(2158166), // Rule ID 56445 //
     /* 2158123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158136 */   // MIs[0] Operand 1
     /* 2158136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2158141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158149 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2158149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2158152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158154 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158165 */   // GIR_Coverage, 56445,
     /* 2158165 */   GIR_EraseRootFromParent_Done,
     /* 2158166 */ // Label 29127: @2158166
     /* 2158166 */ GIM_Try, /*On fail goto*//*Label 29128*/ GIMT_Encode4(2158214), // Rule ID 56664 //
     /* 2158171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158184 */   // MIs[0] Operand 1
     /* 2158184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158197 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2158197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2158200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158213 */   // GIR_Coverage, 56664,
     /* 2158213 */   GIR_EraseRootFromParent_Done,
     /* 2158214 */ // Label 29128: @2158214
     /* 2158214 */ GIM_Try, /*On fail goto*//*Label 29129*/ GIMT_Encode4(2158262), // Rule ID 56665 //
     /* 2158219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158232 */   // MIs[0] Operand 1
     /* 2158232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158245 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2158245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2158248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158261 */   // GIR_Coverage, 56665,
     /* 2158261 */   GIR_EraseRootFromParent_Done,
     /* 2158262 */ // Label 29129: @2158262
     /* 2158262 */ GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2158310), // Rule ID 56704 //
     /* 2158267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158280 */   // MIs[0] Operand 1
     /* 2158280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158293 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2158293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2158296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158309 */   // GIR_Coverage, 56704,
     /* 2158309 */   GIR_EraseRootFromParent_Done,
     /* 2158310 */ // Label 29130: @2158310
     /* 2158310 */ GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2158358), // Rule ID 56705 //
     /* 2158315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158328 */   // MIs[0] Operand 1
     /* 2158328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158341 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2158341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2158344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158357 */   // GIR_Coverage, 56705,
     /* 2158357 */   GIR_EraseRootFromParent_Done,
     /* 2158358 */ // Label 29131: @2158358
     /* 2158358 */ GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2158406), // Rule ID 56744 //
     /* 2158363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158376 */   // MIs[0] Operand 1
     /* 2158376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158389 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2158389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2158392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158405 */   // GIR_Coverage, 56744,
     /* 2158405 */   GIR_EraseRootFromParent_Done,
     /* 2158406 */ // Label 29132: @2158406
     /* 2158406 */ GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2158454), // Rule ID 56745 //
     /* 2158411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158424 */   // MIs[0] Operand 1
     /* 2158424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2158429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158437 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2158437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2158440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158453 */   // GIR_Coverage, 56745,
     /* 2158453 */   GIR_EraseRootFromParent_Done,
     /* 2158454 */ // Label 29133: @2158454
     /* 2158454 */ GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2158502), // Rule ID 56964 //
     /* 2158459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158472 */   // MIs[0] Operand 1
     /* 2158472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158485 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2158485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2158488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158492 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158501 */   // GIR_Coverage, 56964,
     /* 2158501 */   GIR_EraseRootFromParent_Done,
     /* 2158502 */ // Label 29134: @2158502
     /* 2158502 */ GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2158550), // Rule ID 56965 //
     /* 2158507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158520 */   // MIs[0] Operand 1
     /* 2158520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158533 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2158533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2158536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158549 */   // GIR_Coverage, 56965,
     /* 2158549 */   GIR_EraseRootFromParent_Done,
     /* 2158550 */ // Label 29135: @2158550
     /* 2158550 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2158598), // Rule ID 57004 //
     /* 2158555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158568 */   // MIs[0] Operand 1
     /* 2158568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158581 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2158581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2158584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158586 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158588 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158597 */   // GIR_Coverage, 57004,
     /* 2158597 */   GIR_EraseRootFromParent_Done,
     /* 2158598 */ // Label 29136: @2158598
     /* 2158598 */ GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2158646), // Rule ID 57005 //
     /* 2158603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158616 */   // MIs[0] Operand 1
     /* 2158616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158629 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2158629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2158632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158634 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158636 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158645 */   // GIR_Coverage, 57005,
     /* 2158645 */   GIR_EraseRootFromParent_Done,
     /* 2158646 */ // Label 29137: @2158646
     /* 2158646 */ GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2158694), // Rule ID 57044 //
     /* 2158651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158664 */   // MIs[0] Operand 1
     /* 2158664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158677 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2158677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2158680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158684 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158693 */   // GIR_Coverage, 57044,
     /* 2158693 */   GIR_EraseRootFromParent_Done,
     /* 2158694 */ // Label 29138: @2158694
     /* 2158694 */ GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2158742), // Rule ID 57045 //
     /* 2158699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158712 */   // MIs[0] Operand 1
     /* 2158712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2158717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158725 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2158725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2158728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158741 */   // GIR_Coverage, 57045,
     /* 2158741 */   GIR_EraseRootFromParent_Done,
     /* 2158742 */ // Label 29139: @2158742
     /* 2158742 */ GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2158790), // Rule ID 57264 //
     /* 2158747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158760 */   // MIs[0] Operand 1
     /* 2158760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2158765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158773 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2158773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2158776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158789 */   // GIR_Coverage, 57264,
     /* 2158789 */   GIR_EraseRootFromParent_Done,
     /* 2158790 */ // Label 29140: @2158790
     /* 2158790 */ GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2158838), // Rule ID 57265 //
     /* 2158795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2158804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158808 */   // MIs[0] Operand 1
     /* 2158808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2158813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158821 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2158821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2158824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158826 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158837 */   // GIR_Coverage, 57265,
     /* 2158837 */   GIR_EraseRootFromParent_Done,
     /* 2158838 */ // Label 29141: @2158838
     /* 2158838 */ GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2158886), // Rule ID 57304 //
     /* 2158843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158856 */   // MIs[0] Operand 1
     /* 2158856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2158861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158869 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2158869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2158872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158874 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158885 */   // GIR_Coverage, 57304,
     /* 2158885 */   GIR_EraseRootFromParent_Done,
     /* 2158886 */ // Label 29142: @2158886
     /* 2158886 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2158934), // Rule ID 57305 //
     /* 2158891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158904 */   // MIs[0] Operand 1
     /* 2158904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2158909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158917 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2158917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2158920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158933 */   // GIR_Coverage, 57305,
     /* 2158933 */   GIR_EraseRootFromParent_Done,
     /* 2158934 */ // Label 29143: @2158934
     /* 2158934 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2158982), // Rule ID 57344 //
     /* 2158939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158952 */   // MIs[0] Operand 1
     /* 2158952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2158957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158965 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2158965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2158968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2158972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2158974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2158977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2158981 */   // GIR_Coverage, 57344,
     /* 2158981 */   GIR_EraseRootFromParent_Done,
     /* 2158982 */ // Label 29144: @2158982
     /* 2158982 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2159030), // Rule ID 57345 //
     /* 2158987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159000 */   // MIs[0] Operand 1
     /* 2159000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2159005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159013 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2159013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2159016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159029 */   // GIR_Coverage, 57345,
     /* 2159029 */   GIR_EraseRootFromParent_Done,
     /* 2159030 */ // Label 29145: @2159030
     /* 2159030 */ GIM_Reject,
     /* 2159031 */ // Label 29008: @2159031
     /* 2159031 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2159079), // Rule ID 56374 //
     /* 2159036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159049 */   // MIs[0] Operand 1
     /* 2159049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159062 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2159065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159078 */   // GIR_Coverage, 56374,
     /* 2159078 */   GIR_EraseRootFromParent_Done,
     /* 2159079 */ // Label 29146: @2159079
     /* 2159079 */ GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2159127), // Rule ID 56375 //
     /* 2159084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159097 */   // MIs[0] Operand 1
     /* 2159097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159110 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2159113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159126 */   // GIR_Coverage, 56375,
     /* 2159126 */   GIR_EraseRootFromParent_Done,
     /* 2159127 */ // Label 29147: @2159127
     /* 2159127 */ GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2159175), // Rule ID 56414 //
     /* 2159132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159145 */   // MIs[0] Operand 1
     /* 2159145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159158 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2159158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2159161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159174 */   // GIR_Coverage, 56414,
     /* 2159174 */   GIR_EraseRootFromParent_Done,
     /* 2159175 */ // Label 29148: @2159175
     /* 2159175 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2159223), // Rule ID 56415 //
     /* 2159180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159193 */   // MIs[0] Operand 1
     /* 2159193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159206 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2159206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2159209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159222 */   // GIR_Coverage, 56415,
     /* 2159222 */   GIR_EraseRootFromParent_Done,
     /* 2159223 */ // Label 29149: @2159223
     /* 2159223 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2159271), // Rule ID 56674 //
     /* 2159228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159241 */   // MIs[0] Operand 1
     /* 2159241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159254 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2159257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159270 */   // GIR_Coverage, 56674,
     /* 2159270 */   GIR_EraseRootFromParent_Done,
     /* 2159271 */ // Label 29150: @2159271
     /* 2159271 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2159319), // Rule ID 56675 //
     /* 2159276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159289 */   // MIs[0] Operand 1
     /* 2159289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159302 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2159305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159318 */   // GIR_Coverage, 56675,
     /* 2159318 */   GIR_EraseRootFromParent_Done,
     /* 2159319 */ // Label 29151: @2159319
     /* 2159319 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2159367), // Rule ID 56714 //
     /* 2159324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159337 */   // MIs[0] Operand 1
     /* 2159337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159350 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2159350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2159353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159366 */   // GIR_Coverage, 56714,
     /* 2159366 */   GIR_EraseRootFromParent_Done,
     /* 2159367 */ // Label 29152: @2159367
     /* 2159367 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2159415), // Rule ID 56715 //
     /* 2159372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159385 */   // MIs[0] Operand 1
     /* 2159385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159398 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2159398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2159401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159414 */   // GIR_Coverage, 56715,
     /* 2159414 */   GIR_EraseRootFromParent_Done,
     /* 2159415 */ // Label 29153: @2159415
     /* 2159415 */ GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2159463), // Rule ID 56974 //
     /* 2159420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159433 */   // MIs[0] Operand 1
     /* 2159433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2159438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159446 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2159449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159462 */   // GIR_Coverage, 56974,
     /* 2159462 */   GIR_EraseRootFromParent_Done,
     /* 2159463 */ // Label 29154: @2159463
     /* 2159463 */ GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2159511), // Rule ID 56975 //
     /* 2159468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159481 */   // MIs[0] Operand 1
     /* 2159481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2159486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159494 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2159497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159510 */   // GIR_Coverage, 56975,
     /* 2159510 */   GIR_EraseRootFromParent_Done,
     /* 2159511 */ // Label 29155: @2159511
     /* 2159511 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2159559), // Rule ID 57014 //
     /* 2159516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159529 */   // MIs[0] Operand 1
     /* 2159529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2159534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159542 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2159542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2159545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159558 */   // GIR_Coverage, 57014,
     /* 2159558 */   GIR_EraseRootFromParent_Done,
     /* 2159559 */ // Label 29156: @2159559
     /* 2159559 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2159607), // Rule ID 57015 //
     /* 2159564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159577 */   // MIs[0] Operand 1
     /* 2159577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2159582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159590 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2159590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2159593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159595 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159597 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159606 */   // GIR_Coverage, 57015,
     /* 2159606 */   GIR_EraseRootFromParent_Done,
     /* 2159607 */ // Label 29157: @2159607
     /* 2159607 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2159655), // Rule ID 57274 //
     /* 2159612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159625 */   // MIs[0] Operand 1
     /* 2159625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2159630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159638 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2159641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159643 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159645 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159654 */   // GIR_Coverage, 57274,
     /* 2159654 */   GIR_EraseRootFromParent_Done,
     /* 2159655 */ // Label 29158: @2159655
     /* 2159655 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2159703), // Rule ID 57275 //
     /* 2159660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2159669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159673 */   // MIs[0] Operand 1
     /* 2159673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2159678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159686 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2159689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159691 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159702 */   // GIR_Coverage, 57275,
     /* 2159702 */   GIR_EraseRootFromParent_Done,
     /* 2159703 */ // Label 29159: @2159703
     /* 2159703 */ GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2159751), // Rule ID 57314 //
     /* 2159708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159721 */   // MIs[0] Operand 1
     /* 2159721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2159726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159734 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2159734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2159737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159750 */   // GIR_Coverage, 57314,
     /* 2159750 */   GIR_EraseRootFromParent_Done,
     /* 2159751 */ // Label 29160: @2159751
     /* 2159751 */ GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2159799), // Rule ID 57315 //
     /* 2159756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2159765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159769 */   // MIs[0] Operand 1
     /* 2159769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2159774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159782 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2159782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2159785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2159798 */   // GIR_Coverage, 57315,
     /* 2159798 */   GIR_EraseRootFromParent_Done,
     /* 2159799 */ // Label 29161: @2159799
     /* 2159799 */ GIM_Reject,
     /* 2159800 */ // Label 29009: @2159800
     /* 2159800 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2160120),
     /* 2159805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2159808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2159811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159815 */   GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2159853), // Rule ID 56384 //
     /* 2159820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159823 */     // MIs[0] Operand 1
     /* 2159823 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159836 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2159839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159852 */     // GIR_Coverage, 56384,
     /* 2159852 */     GIR_EraseRootFromParent_Done,
     /* 2159853 */   // Label 29163: @2159853
     /* 2159853 */   GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2159891), // Rule ID 56385 //
     /* 2159858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159861 */     // MIs[0] Operand 1
     /* 2159861 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2159866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159874 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2159877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159890 */     // GIR_Coverage, 56385,
     /* 2159890 */     GIR_EraseRootFromParent_Done,
     /* 2159891 */   // Label 29164: @2159891
     /* 2159891 */   GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2159929), // Rule ID 56684 //
     /* 2159896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159899 */     // MIs[0] Operand 1
     /* 2159899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159912 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2159915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159928 */     // GIR_Coverage, 56684,
     /* 2159928 */     GIR_EraseRootFromParent_Done,
     /* 2159929 */   // Label 29165: @2159929
     /* 2159929 */   GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2159967), // Rule ID 56685 //
     /* 2159934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159937 */     // MIs[0] Operand 1
     /* 2159937 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2159942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159950 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2159950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2159953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2159962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159966 */     // GIR_Coverage, 56685,
     /* 2159966 */     GIR_EraseRootFromParent_Done,
     /* 2159967 */   // Label 29166: @2159967
     /* 2159967 */   GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2160005), // Rule ID 56984 //
     /* 2159972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159975 */     // MIs[0] Operand 1
     /* 2159975 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2159980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159988 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2159988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2159991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2159995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2159997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160004 */     // GIR_Coverage, 56984,
     /* 2160004 */     GIR_EraseRootFromParent_Done,
     /* 2160005 */   // Label 29167: @2160005
     /* 2160005 */   GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2160043), // Rule ID 56985 //
     /* 2160010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160013 */     // MIs[0] Operand 1
     /* 2160013 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2160018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160026 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2160026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2160029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160042 */     // GIR_Coverage, 56985,
     /* 2160042 */     GIR_EraseRootFromParent_Done,
     /* 2160043 */   // Label 29168: @2160043
     /* 2160043 */   GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2160081), // Rule ID 57284 //
     /* 2160048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160051 */     // MIs[0] Operand 1
     /* 2160051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2160056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160064 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2160064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2160067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160080 */     // GIR_Coverage, 57284,
     /* 2160080 */     GIR_EraseRootFromParent_Done,
     /* 2160081 */   // Label 29169: @2160081
     /* 2160081 */   GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2160119), // Rule ID 57285 //
     /* 2160086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160089 */     // MIs[0] Operand 1
     /* 2160089 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2160094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160102 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2160102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2160105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160118 */     // GIR_Coverage, 57285,
     /* 2160118 */     GIR_EraseRootFromParent_Done,
     /* 2160119 */   // Label 29170: @2160119
     /* 2160119 */   GIM_Reject,
     /* 2160120 */ // Label 29162: @2160120
     /* 2160120 */ GIM_Reject,
     /* 2160121 */ // Label 29010: @2160121
     /* 2160121 */ GIM_Reject,
     /* 2160122 */ // Label 50: @2160122
     /* 2160122 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29195*/ GIMT_Encode4(2164513),
     /* 2160133 */ /*GILLT_s32*//*Label 29171*/ GIMT_Encode4(2160257),
     /* 2160137 */ /*GILLT_s64*//*Label 29172*/ GIMT_Encode4(2160405), GIMT_Encode4(0),
     /* 2160145 */ /*GILLT_nxv1s8*//*Label 29173*/ GIMT_Encode4(2160553),
     /* 2160149 */ /*GILLT_nxv1s16*//*Label 29174*/ GIMT_Encode4(2160673),
     /* 2160153 */ /*GILLT_nxv1s32*//*Label 29175*/ GIMT_Encode4(2160881),
     /* 2160157 */ /*GILLT_nxv1s64*//*Label 29176*/ GIMT_Encode4(2161089), GIMT_Encode4(0),
     /* 2160165 */ /*GILLT_nxv2s8*//*Label 29177*/ GIMT_Encode4(2161297),
     /* 2160169 */ /*GILLT_nxv2s16*//*Label 29178*/ GIMT_Encode4(2161417),
     /* 2160173 */ /*GILLT_nxv2s32*//*Label 29179*/ GIMT_Encode4(2161625),
     /* 2160177 */ /*GILLT_nxv2s64*//*Label 29180*/ GIMT_Encode4(2161833), GIMT_Encode4(0),
     /* 2160185 */ /*GILLT_nxv4s8*//*Label 29181*/ GIMT_Encode4(2162041),
     /* 2160189 */ /*GILLT_nxv4s16*//*Label 29182*/ GIMT_Encode4(2162161),
     /* 2160193 */ /*GILLT_nxv4s32*//*Label 29183*/ GIMT_Encode4(2162369),
     /* 2160197 */ /*GILLT_nxv4s64*//*Label 29184*/ GIMT_Encode4(2162577), GIMT_Encode4(0),
     /* 2160205 */ /*GILLT_nxv8s8*//*Label 29185*/ GIMT_Encode4(2162785),
     /* 2160209 */ /*GILLT_nxv8s16*//*Label 29186*/ GIMT_Encode4(2162905),
     /* 2160213 */ /*GILLT_nxv8s32*//*Label 29187*/ GIMT_Encode4(2163113),
     /* 2160217 */ /*GILLT_nxv8s64*//*Label 29188*/ GIMT_Encode4(2163321), GIMT_Encode4(0),
     /* 2160225 */ /*GILLT_nxv16s8*//*Label 29189*/ GIMT_Encode4(2163529),
     /* 2160229 */ /*GILLT_nxv16s16*//*Label 29190*/ GIMT_Encode4(2163649),
     /* 2160233 */ /*GILLT_nxv16s32*//*Label 29191*/ GIMT_Encode4(2163857), GIMT_Encode4(0),
     /* 2160241 */ /*GILLT_nxv32s8*//*Label 29192*/ GIMT_Encode4(2164065),
     /* 2160245 */ /*GILLT_nxv32s16*//*Label 29193*/ GIMT_Encode4(2164185), GIMT_Encode4(0),
     /* 2160253 */ /*GILLT_nxv64s8*//*Label 29194*/ GIMT_Encode4(2164393),
     /* 2160257 */ // Label 29171: @2160257
     /* 2160257 */ GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2160404),
     /* 2160262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2160265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2160268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160279 */   GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2160312), // Rule ID 61891 //
     /* 2160284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2160287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2160291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160295 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2160295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2160298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160300 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2160302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2160308 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160311 */     // GIR_Coverage, 61891,
     /* 2160311 */     GIR_EraseRootFromParent_Done,
     /* 2160312 */   // Label 29197: @2160312
     /* 2160312 */   GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2160345), // Rule ID 61889 //
     /* 2160317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2160320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2160328 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2160328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2160331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160333 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2160335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2160341 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160344 */     // GIR_Coverage, 61889,
     /* 2160344 */     GIR_EraseRootFromParent_Done,
     /* 2160345 */   // Label 29198: @2160345
     /* 2160345 */   GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2160374), // Rule ID 61887 //
     /* 2160350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2160353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160361 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2160361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2160364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160366 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2160368 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2160370 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160373 */     // GIR_Coverage, 61887,
     /* 2160373 */     GIR_EraseRootFromParent_Done,
     /* 2160374 */   // Label 29199: @2160374
     /* 2160374 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2160403), // Rule ID 63844 //
     /* 2160379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2160382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160390 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2160390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2160393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2160399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2160401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160402 */     // GIR_Coverage, 63844,
     /* 2160402 */     GIR_EraseRootFromParent_Done,
     /* 2160403 */   // Label 29200: @2160403
     /* 2160403 */   GIM_Reject,
     /* 2160404 */ // Label 29196: @2160404
     /* 2160404 */ GIM_Reject,
     /* 2160405 */ // Label 29172: @2160405
     /* 2160405 */ GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2160552),
     /* 2160410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2160413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2160416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160427 */   GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2160460), // Rule ID 61890 //
     /* 2160432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2160435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2160439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160443 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2160443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2160446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160448 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2160450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2160456 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160459 */     // GIR_Coverage, 61890,
     /* 2160459 */     GIR_EraseRootFromParent_Done,
     /* 2160460 */   // Label 29202: @2160460
     /* 2160460 */   GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2160493), // Rule ID 61888 //
     /* 2160465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2160468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2160476 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2160476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2160479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160481 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2160483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2160489 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160492 */     // GIR_Coverage, 61888,
     /* 2160492 */     GIR_EraseRootFromParent_Done,
     /* 2160493 */   // Label 29203: @2160493
     /* 2160493 */   GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2160522), // Rule ID 61886 //
     /* 2160498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2160501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160509 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2160509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2160512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2160514 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2160516 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2160518 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2160520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160521 */     // GIR_Coverage, 61886,
     /* 2160521 */     GIR_EraseRootFromParent_Done,
     /* 2160522 */   // Label 29204: @2160522
     /* 2160522 */   GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2160551), // Rule ID 63843 //
     /* 2160527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2160530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2160538 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2160538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2160541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2160547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2160549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160550 */     // GIR_Coverage, 63843,
     /* 2160550 */     GIR_EraseRootFromParent_Done,
     /* 2160551 */   // Label 29205: @2160551
     /* 2160551 */   GIM_Reject,
     /* 2160552 */ // Label 29201: @2160552
     /* 2160552 */ GIM_Reject,
     /* 2160553 */ // Label 29173: @2160553
     /* 2160553 */ GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2160672),
     /* 2160558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2160561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2160564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2160567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160583 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2160627), // Rule ID 51694 //
     /* 2160588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2160591 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2160591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2160594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2160608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160617 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2160625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160626 */     // GIR_Coverage, 51694,
     /* 2160626 */     GIR_EraseRootFromParent_Done,
     /* 2160627 */   // Label 29207: @2160627
     /* 2160627 */   GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2160671), // Rule ID 51695 //
     /* 2160632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2160635 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2160635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2160638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2160652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160661 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2160669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160670 */     // GIR_Coverage, 51695,
     /* 2160670 */     GIR_EraseRootFromParent_Done,
     /* 2160671 */   // Label 29208: @2160671
     /* 2160671 */   GIM_Reject,
     /* 2160672 */ // Label 29206: @2160672
     /* 2160672 */ GIM_Reject,
     /* 2160673 */ // Label 29174: @2160673
     /* 2160673 */ GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2160880),
     /* 2160678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2160681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2160684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2160687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160703 */   GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2160747), // Rule ID 51712 //
     /* 2160708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2160711 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2160711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2160714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2160728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160737 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160746 */     // GIR_Coverage, 51712,
     /* 2160746 */     GIR_EraseRootFromParent_Done,
     /* 2160747 */   // Label 29210: @2160747
     /* 2160747 */   GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2160791), // Rule ID 51713 //
     /* 2160752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2160755 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2160755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2160758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2160772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160781 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160790 */     // GIR_Coverage, 51713,
     /* 2160790 */     GIR_EraseRootFromParent_Done,
     /* 2160791 */   // Label 29211: @2160791
     /* 2160791 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2160835), // Rule ID 57354 //
     /* 2160796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2160799 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2160799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2160802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2160816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160825 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160834 */     // GIR_Coverage, 57354,
     /* 2160834 */     GIR_EraseRootFromParent_Done,
     /* 2160835 */   // Label 29212: @2160835
     /* 2160835 */   GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2160879), // Rule ID 57355 //
     /* 2160840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2160843 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2160843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2160846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2160860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160869 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160878 */     // GIR_Coverage, 57355,
     /* 2160878 */     GIR_EraseRootFromParent_Done,
     /* 2160879 */   // Label 29213: @2160879
     /* 2160879 */   GIM_Reject,
     /* 2160880 */ // Label 29209: @2160880
     /* 2160880 */ GIM_Reject,
     /* 2160881 */ // Label 29175: @2160881
     /* 2160881 */ GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2161088),
     /* 2160886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2160889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2160892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2160895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160911 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2160955), // Rule ID 51724 //
     /* 2160916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2160919 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2160919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2160922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2160936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160945 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160954 */     // GIR_Coverage, 51724,
     /* 2160954 */     GIR_EraseRootFromParent_Done,
     /* 2160955 */   // Label 29215: @2160955
     /* 2160955 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2160999), // Rule ID 51725 //
     /* 2160960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2160963 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2160963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2160966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2160970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2160975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2160977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2160980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2160985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2160987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2160989 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2160991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2160994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160998 */     // GIR_Coverage, 51725,
     /* 2160998 */     GIR_EraseRootFromParent_Done,
     /* 2160999 */   // Label 29216: @2160999
     /* 2160999 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2161043), // Rule ID 57374 //
     /* 2161004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161007 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2161007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2161010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161033 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161042 */     // GIR_Coverage, 57374,
     /* 2161042 */     GIR_EraseRootFromParent_Done,
     /* 2161043 */   // Label 29217: @2161043
     /* 2161043 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2161087), // Rule ID 57375 //
     /* 2161048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161051 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2161051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2161054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161077 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161086 */     // GIR_Coverage, 57375,
     /* 2161086 */     GIR_EraseRootFromParent_Done,
     /* 2161087 */   // Label 29218: @2161087
     /* 2161087 */   GIM_Reject,
     /* 2161088 */ // Label 29214: @2161088
     /* 2161088 */ GIM_Reject,
     /* 2161089 */ // Label 29176: @2161089
     /* 2161089 */ GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2161296),
     /* 2161094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2161097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2161100 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2161103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161115 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161119 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2161163), // Rule ID 51748 //
     /* 2161124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2161127 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2161127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2161130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161153 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161162 */     // GIR_Coverage, 51748,
     /* 2161162 */     GIR_EraseRootFromParent_Done,
     /* 2161163 */   // Label 29220: @2161163
     /* 2161163 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2161207), // Rule ID 51749 //
     /* 2161168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2161171 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2161171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2161174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161197 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161206 */     // GIR_Coverage, 51749,
     /* 2161206 */     GIR_EraseRootFromParent_Done,
     /* 2161207 */   // Label 29221: @2161207
     /* 2161207 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2161251), // Rule ID 57404 //
     /* 2161212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2161215 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2161215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2161218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161241 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161250 */     // GIR_Coverage, 57404,
     /* 2161250 */     GIR_EraseRootFromParent_Done,
     /* 2161251 */   // Label 29222: @2161251
     /* 2161251 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2161295), // Rule ID 57405 //
     /* 2161256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2161259 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2161259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2161262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161285 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161294 */     // GIR_Coverage, 57405,
     /* 2161294 */     GIR_EraseRootFromParent_Done,
     /* 2161295 */   // Label 29223: @2161295
     /* 2161295 */   GIM_Reject,
     /* 2161296 */ // Label 29219: @2161296
     /* 2161296 */ GIM_Reject,
     /* 2161297 */ // Label 29177: @2161297
     /* 2161297 */ GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2161416),
     /* 2161302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2161305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2161308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2161311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161323 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161327 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2161371), // Rule ID 51700 //
     /* 2161332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161335 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2161335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2161338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2161352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161361 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2161369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161370 */     // GIR_Coverage, 51700,
     /* 2161370 */     GIR_EraseRootFromParent_Done,
     /* 2161371 */   // Label 29225: @2161371
     /* 2161371 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2161415), // Rule ID 51701 //
     /* 2161376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161379 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2161379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2161382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2161396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161405 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2161413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161414 */     // GIR_Coverage, 51701,
     /* 2161414 */     GIR_EraseRootFromParent_Done,
     /* 2161415 */   // Label 29226: @2161415
     /* 2161415 */   GIM_Reject,
     /* 2161416 */ // Label 29224: @2161416
     /* 2161416 */ GIM_Reject,
     /* 2161417 */ // Label 29178: @2161417
     /* 2161417 */ GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2161624),
     /* 2161422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2161425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161447 */   GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2161491), // Rule ID 51718 //
     /* 2161452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161455 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2161455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2161458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161481 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161490 */     // GIR_Coverage, 51718,
     /* 2161490 */     GIR_EraseRootFromParent_Done,
     /* 2161491 */   // Label 29228: @2161491
     /* 2161491 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2161535), // Rule ID 51719 //
     /* 2161496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161499 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2161499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2161502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161525 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161534 */     // GIR_Coverage, 51719,
     /* 2161534 */     GIR_EraseRootFromParent_Done,
     /* 2161535 */   // Label 29229: @2161535
     /* 2161535 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2161579), // Rule ID 57364 //
     /* 2161540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161543 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2161543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2161546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161569 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161578 */     // GIR_Coverage, 57364,
     /* 2161578 */     GIR_EraseRootFromParent_Done,
     /* 2161579 */   // Label 29230: @2161579
     /* 2161579 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2161623), // Rule ID 57365 //
     /* 2161584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161587 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2161587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2161590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2161604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161613 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161622 */     // GIR_Coverage, 57365,
     /* 2161622 */     GIR_EraseRootFromParent_Done,
     /* 2161623 */   // Label 29231: @2161623
     /* 2161623 */   GIM_Reject,
     /* 2161624 */ // Label 29227: @2161624
     /* 2161624 */ GIM_Reject,
     /* 2161625 */ // Label 29179: @2161625
     /* 2161625 */ GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2161832),
     /* 2161630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2161633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2161636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2161639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161655 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2161699), // Rule ID 51742 //
     /* 2161660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161663 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2161663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2161666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161689 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161698 */     // GIR_Coverage, 51742,
     /* 2161698 */     GIR_EraseRootFromParent_Done,
     /* 2161699 */   // Label 29233: @2161699
     /* 2161699 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2161743), // Rule ID 51743 //
     /* 2161704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161707 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2161707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2161710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161733 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161742 */     // GIR_Coverage, 51743,
     /* 2161742 */     GIR_EraseRootFromParent_Done,
     /* 2161743 */   // Label 29234: @2161743
     /* 2161743 */   GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2161787), // Rule ID 57394 //
     /* 2161748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2161751 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2161751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2161754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161777 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161786 */     // GIR_Coverage, 57394,
     /* 2161786 */     GIR_EraseRootFromParent_Done,
     /* 2161787 */   // Label 29235: @2161787
     /* 2161787 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2161831), // Rule ID 57395 //
     /* 2161792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2161795 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2161795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2161798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2161812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161821 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161830 */     // GIR_Coverage, 57395,
     /* 2161830 */     GIR_EraseRootFromParent_Done,
     /* 2161831 */   // Label 29236: @2161831
     /* 2161831 */   GIM_Reject,
     /* 2161832 */ // Label 29232: @2161832
     /* 2161832 */ GIM_Reject,
     /* 2161833 */ // Label 29180: @2161833
     /* 2161833 */ GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2162040),
     /* 2161838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2161841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2161847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161863 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2161907), // Rule ID 51808 //
     /* 2161868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2161871 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2161871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2161874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2161888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161897 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161906 */     // GIR_Coverage, 51808,
     /* 2161906 */     GIR_EraseRootFromParent_Done,
     /* 2161907 */   // Label 29238: @2161907
     /* 2161907 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2161951), // Rule ID 51809 //
     /* 2161912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2161915 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2161915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2161918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2161932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161941 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161950 */     // GIR_Coverage, 51809,
     /* 2161950 */     GIR_EraseRootFromParent_Done,
     /* 2161951 */   // Label 29239: @2161951
     /* 2161951 */   GIM_Try, /*On fail goto*//*Label 29240*/ GIMT_Encode4(2161995), // Rule ID 57474 //
     /* 2161956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2161959 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2161959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2161962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2161966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2161971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2161973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2161976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2161981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2161983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2161985 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2161987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2161990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161994 */     // GIR_Coverage, 57474,
     /* 2161994 */     GIR_EraseRootFromParent_Done,
     /* 2161995 */   // Label 29240: @2161995
     /* 2161995 */   GIM_Try, /*On fail goto*//*Label 29241*/ GIMT_Encode4(2162039), // Rule ID 57475 //
     /* 2162000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2162003 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2162003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2162006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162029 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162038 */     // GIR_Coverage, 57475,
     /* 2162038 */     GIR_EraseRootFromParent_Done,
     /* 2162039 */   // Label 29241: @2162039
     /* 2162039 */   GIM_Reject,
     /* 2162040 */ // Label 29237: @2162040
     /* 2162040 */ GIM_Reject,
     /* 2162041 */ // Label 29181: @2162041
     /* 2162041 */ GIM_Try, /*On fail goto*//*Label 29242*/ GIMT_Encode4(2162160),
     /* 2162046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2162049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2162052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2162055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162071 */   GIM_Try, /*On fail goto*//*Label 29243*/ GIMT_Encode4(2162115), // Rule ID 51706 //
     /* 2162076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162079 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2162079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2162082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2162096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162105 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2162113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162114 */     // GIR_Coverage, 51706,
     /* 2162114 */     GIR_EraseRootFromParent_Done,
     /* 2162115 */   // Label 29243: @2162115
     /* 2162115 */   GIM_Try, /*On fail goto*//*Label 29244*/ GIMT_Encode4(2162159), // Rule ID 51707 //
     /* 2162120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162123 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2162123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2162126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2162140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162149 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2162157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162158 */     // GIR_Coverage, 51707,
     /* 2162158 */     GIR_EraseRootFromParent_Done,
     /* 2162159 */   // Label 29244: @2162159
     /* 2162159 */   GIM_Reject,
     /* 2162160 */ // Label 29242: @2162160
     /* 2162160 */ GIM_Reject,
     /* 2162161 */ // Label 29182: @2162161
     /* 2162161 */ GIM_Try, /*On fail goto*//*Label 29245*/ GIMT_Encode4(2162368),
     /* 2162166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2162169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162191 */   GIM_Try, /*On fail goto*//*Label 29246*/ GIMT_Encode4(2162235), // Rule ID 51736 //
     /* 2162196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162199 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2162199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2162202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162225 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162234 */     // GIR_Coverage, 51736,
     /* 2162234 */     GIR_EraseRootFromParent_Done,
     /* 2162235 */   // Label 29246: @2162235
     /* 2162235 */   GIM_Try, /*On fail goto*//*Label 29247*/ GIMT_Encode4(2162279), // Rule ID 51737 //
     /* 2162240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162243 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2162243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2162246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162278 */     // GIR_Coverage, 51737,
     /* 2162278 */     GIR_EraseRootFromParent_Done,
     /* 2162279 */   // Label 29247: @2162279
     /* 2162279 */   GIM_Try, /*On fail goto*//*Label 29248*/ GIMT_Encode4(2162323), // Rule ID 57384 //
     /* 2162284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162287 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2162287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2162290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162313 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162322 */     // GIR_Coverage, 57384,
     /* 2162322 */     GIR_EraseRootFromParent_Done,
     /* 2162323 */   // Label 29248: @2162323
     /* 2162323 */   GIM_Try, /*On fail goto*//*Label 29249*/ GIMT_Encode4(2162367), // Rule ID 57385 //
     /* 2162328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162331 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2162331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2162334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162357 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162366 */     // GIR_Coverage, 57385,
     /* 2162366 */     GIR_EraseRootFromParent_Done,
     /* 2162367 */   // Label 29249: @2162367
     /* 2162367 */   GIM_Reject,
     /* 2162368 */ // Label 29245: @2162368
     /* 2162368 */ GIM_Reject,
     /* 2162369 */ // Label 29183: @2162369
     /* 2162369 */ GIM_Try, /*On fail goto*//*Label 29250*/ GIMT_Encode4(2162576),
     /* 2162374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2162377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2162380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2162383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162399 */   GIM_Try, /*On fail goto*//*Label 29251*/ GIMT_Encode4(2162443), // Rule ID 51790 //
     /* 2162404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162407 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2162407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2162410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162433 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162442 */     // GIR_Coverage, 51790,
     /* 2162442 */     GIR_EraseRootFromParent_Done,
     /* 2162443 */   // Label 29251: @2162443
     /* 2162443 */   GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2162487), // Rule ID 51791 //
     /* 2162448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162451 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2162451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2162454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162477 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162486 */     // GIR_Coverage, 51791,
     /* 2162486 */     GIR_EraseRootFromParent_Done,
     /* 2162487 */   // Label 29252: @2162487
     /* 2162487 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2162531), // Rule ID 57444 //
     /* 2162492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162495 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2162495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2162498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162521 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162530 */     // GIR_Coverage, 57444,
     /* 2162530 */     GIR_EraseRootFromParent_Done,
     /* 2162531 */   // Label 29253: @2162531
     /* 2162531 */   GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2162575), // Rule ID 57445 //
     /* 2162536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162539 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2162539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2162542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162565 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162574 */     // GIR_Coverage, 57445,
     /* 2162574 */     GIR_EraseRootFromParent_Done,
     /* 2162575 */   // Label 29254: @2162575
     /* 2162575 */   GIM_Reject,
     /* 2162576 */ // Label 29250: @2162576
     /* 2162576 */ GIM_Reject,
     /* 2162577 */ // Label 29184: @2162577
     /* 2162577 */ GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2162784),
     /* 2162582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2162585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2162588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2162591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162607 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2162651), // Rule ID 51814 //
     /* 2162612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2162615 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2162615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2162618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2162632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162641 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162650 */     // GIR_Coverage, 51814,
     /* 2162650 */     GIR_EraseRootFromParent_Done,
     /* 2162651 */   // Label 29256: @2162651
     /* 2162651 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2162695), // Rule ID 51815 //
     /* 2162656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2162659 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2162659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2162662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2162676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162685 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162694 */     // GIR_Coverage, 51815,
     /* 2162694 */     GIR_EraseRootFromParent_Done,
     /* 2162695 */   // Label 29257: @2162695
     /* 2162695 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2162739), // Rule ID 57484 //
     /* 2162700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2162703 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2162703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2162706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2162720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162729 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162738 */     // GIR_Coverage, 57484,
     /* 2162738 */     GIR_EraseRootFromParent_Done,
     /* 2162739 */   // Label 29258: @2162739
     /* 2162739 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2162783), // Rule ID 57485 //
     /* 2162744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2162747 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2162747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2162750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2162764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162773 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162782 */     // GIR_Coverage, 57485,
     /* 2162782 */     GIR_EraseRootFromParent_Done,
     /* 2162783 */   // Label 29259: @2162783
     /* 2162783 */   GIM_Reject,
     /* 2162784 */ // Label 29255: @2162784
     /* 2162784 */ GIM_Reject,
     /* 2162785 */ // Label 29185: @2162785
     /* 2162785 */ GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2162904),
     /* 2162790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2162793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2162796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2162799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162815 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2162859), // Rule ID 51730 //
     /* 2162820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162823 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2162823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2162826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162849 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2162857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162858 */     // GIR_Coverage, 51730,
     /* 2162858 */     GIR_EraseRootFromParent_Done,
     /* 2162859 */   // Label 29261: @2162859
     /* 2162859 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2162903), // Rule ID 51731 //
     /* 2162864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162867 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2162867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2162870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2162884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162893 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2162901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162902 */     // GIR_Coverage, 51731,
     /* 2162902 */     GIR_EraseRootFromParent_Done,
     /* 2162903 */   // Label 29262: @2162903
     /* 2162903 */   GIM_Reject,
     /* 2162904 */ // Label 29260: @2162904
     /* 2162904 */ GIM_Reject,
     /* 2162905 */ // Label 29186: @2162905
     /* 2162905 */ GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2163112),
     /* 2162910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2162913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162935 */   GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2162979), // Rule ID 51772 //
     /* 2162940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2162943 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2162943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2162946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2162957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2162960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2162965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2162967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2162969 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2162971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2162974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162978 */     // GIR_Coverage, 51772,
     /* 2162978 */     GIR_EraseRootFromParent_Done,
     /* 2162979 */   // Label 29264: @2162979
     /* 2162979 */   GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2163023), // Rule ID 51773 //
     /* 2162984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2162987 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2162987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2162990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2162994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2162999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2163004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163013 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163022 */     // GIR_Coverage, 51773,
     /* 2163022 */     GIR_EraseRootFromParent_Done,
     /* 2163023 */   // Label 29265: @2163023
     /* 2163023 */   GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2163067), // Rule ID 57414 //
     /* 2163028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163031 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2163031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2163034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2163048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163057 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163066 */     // GIR_Coverage, 57414,
     /* 2163066 */     GIR_EraseRootFromParent_Done,
     /* 2163067 */   // Label 29266: @2163067
     /* 2163067 */   GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2163111), // Rule ID 57415 //
     /* 2163072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163075 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2163075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2163078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2163092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163101 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163110 */     // GIR_Coverage, 57415,
     /* 2163110 */     GIR_EraseRootFromParent_Done,
     /* 2163111 */   // Label 29267: @2163111
     /* 2163111 */   GIM_Reject,
     /* 2163112 */ // Label 29263: @2163112
     /* 2163112 */ GIM_Reject,
     /* 2163113 */ // Label 29187: @2163113
     /* 2163113 */ GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2163320),
     /* 2163118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2163121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163143 */   GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2163187), // Rule ID 51796 //
     /* 2163148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163151 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2163151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2163154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163177 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163186 */     // GIR_Coverage, 51796,
     /* 2163186 */     GIR_EraseRootFromParent_Done,
     /* 2163187 */   // Label 29269: @2163187
     /* 2163187 */   GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2163231), // Rule ID 51797 //
     /* 2163192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163195 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2163195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2163198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163221 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163230 */     // GIR_Coverage, 51797,
     /* 2163230 */     GIR_EraseRootFromParent_Done,
     /* 2163231 */   // Label 29270: @2163231
     /* 2163231 */   GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2163275), // Rule ID 57454 //
     /* 2163236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163239 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2163239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2163242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163265 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163274 */     // GIR_Coverage, 57454,
     /* 2163274 */     GIR_EraseRootFromParent_Done,
     /* 2163275 */   // Label 29271: @2163275
     /* 2163275 */   GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2163319), // Rule ID 57455 //
     /* 2163280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163283 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2163283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2163286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163309 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163318 */     // GIR_Coverage, 57455,
     /* 2163318 */     GIR_EraseRootFromParent_Done,
     /* 2163319 */   // Label 29272: @2163319
     /* 2163319 */   GIM_Reject,
     /* 2163320 */ // Label 29268: @2163320
     /* 2163320 */ GIM_Reject,
     /* 2163321 */ // Label 29188: @2163321
     /* 2163321 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2163528),
     /* 2163326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2163329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2163332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2163335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163351 */   GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2163395), // Rule ID 51820 //
     /* 2163356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2163359 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2163359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2163362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163385 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163394 */     // GIR_Coverage, 51820,
     /* 2163394 */     GIR_EraseRootFromParent_Done,
     /* 2163395 */   // Label 29274: @2163395
     /* 2163395 */   GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2163439), // Rule ID 51821 //
     /* 2163400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2163403 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2163403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2163406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163429 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163438 */     // GIR_Coverage, 51821,
     /* 2163438 */     GIR_EraseRootFromParent_Done,
     /* 2163439 */   // Label 29275: @2163439
     /* 2163439 */   GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2163483), // Rule ID 57494 //
     /* 2163444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2163447 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2163447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2163450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163473 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163482 */     // GIR_Coverage, 57494,
     /* 2163482 */     GIR_EraseRootFromParent_Done,
     /* 2163483 */   // Label 29276: @2163483
     /* 2163483 */   GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2163527), // Rule ID 57495 //
     /* 2163488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2163491 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2163491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2163494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163517 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163526 */     // GIR_Coverage, 57495,
     /* 2163526 */     GIR_EraseRootFromParent_Done,
     /* 2163527 */   // Label 29277: @2163527
     /* 2163527 */   GIM_Reject,
     /* 2163528 */ // Label 29273: @2163528
     /* 2163528 */ GIM_Reject,
     /* 2163529 */ // Label 29189: @2163529
     /* 2163529 */ GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2163648),
     /* 2163534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2163537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2163540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2163543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163559 */   GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2163603), // Rule ID 51754 //
     /* 2163564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163567 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2163567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2163570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2163584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163593 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2163601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163602 */     // GIR_Coverage, 51754,
     /* 2163602 */     GIR_EraseRootFromParent_Done,
     /* 2163603 */   // Label 29279: @2163603
     /* 2163603 */   GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2163647), // Rule ID 51755 //
     /* 2163608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163611 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2163611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2163614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2163628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163637 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2163645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163646 */     // GIR_Coverage, 51755,
     /* 2163646 */     GIR_EraseRootFromParent_Done,
     /* 2163647 */   // Label 29280: @2163647
     /* 2163647 */   GIM_Reject,
     /* 2163648 */ // Label 29278: @2163648
     /* 2163648 */ GIM_Reject,
     /* 2163649 */ // Label 29190: @2163649
     /* 2163649 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2163856),
     /* 2163654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2163657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163660 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2163663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163679 */   GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2163723), // Rule ID 51778 //
     /* 2163684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163687 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2163687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2163690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163713 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163722 */     // GIR_Coverage, 51778,
     /* 2163722 */     GIR_EraseRootFromParent_Done,
     /* 2163723 */   // Label 29282: @2163723
     /* 2163723 */   GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2163767), // Rule ID 51779 //
     /* 2163728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163731 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2163731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2163734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163766 */     // GIR_Coverage, 51779,
     /* 2163766 */     GIR_EraseRootFromParent_Done,
     /* 2163767 */   // Label 29283: @2163767
     /* 2163767 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2163811), // Rule ID 57424 //
     /* 2163772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163775 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2163775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2163778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163801 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163810 */     // GIR_Coverage, 57424,
     /* 2163810 */     GIR_EraseRootFromParent_Done,
     /* 2163811 */   // Label 29284: @2163811
     /* 2163811 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2163855), // Rule ID 57425 //
     /* 2163816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163819 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2163819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2163822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2163836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163845 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163854 */     // GIR_Coverage, 57425,
     /* 2163854 */     GIR_EraseRootFromParent_Done,
     /* 2163855 */   // Label 29285: @2163855
     /* 2163855 */   GIM_Reject,
     /* 2163856 */ // Label 29281: @2163856
     /* 2163856 */ GIM_Reject,
     /* 2163857 */ // Label 29191: @2163857
     /* 2163857 */ GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2164064),
     /* 2163862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2163865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163887 */   GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2163931), // Rule ID 51802 //
     /* 2163892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163895 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2163895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2163898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163921 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163930 */     // GIR_Coverage, 51802,
     /* 2163930 */     GIR_EraseRootFromParent_Done,
     /* 2163931 */   // Label 29287: @2163931
     /* 2163931 */   GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2163975), // Rule ID 51803 //
     /* 2163936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2163939 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2163939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2163942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2163956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2163961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2163963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2163965 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2163967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2163970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163974 */     // GIR_Coverage, 51803,
     /* 2163974 */     GIR_EraseRootFromParent_Done,
     /* 2163975 */   // Label 29288: @2163975
     /* 2163975 */   GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2164019), // Rule ID 57464 //
     /* 2163980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2163983 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2163983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2163986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2163990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2163995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2163997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164009 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164018 */     // GIR_Coverage, 57464,
     /* 2164018 */     GIR_EraseRootFromParent_Done,
     /* 2164019 */   // Label 29289: @2164019
     /* 2164019 */   GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2164063), // Rule ID 57465 //
     /* 2164024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164027 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2164027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2164030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164053 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164062 */     // GIR_Coverage, 57465,
     /* 2164062 */     GIR_EraseRootFromParent_Done,
     /* 2164063 */   // Label 29290: @2164063
     /* 2164063 */   GIM_Reject,
     /* 2164064 */ // Label 29286: @2164064
     /* 2164064 */ GIM_Reject,
     /* 2164065 */ // Label 29192: @2164065
     /* 2164065 */ GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2164184),
     /* 2164070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2164073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2164076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2164079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164095 */   GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2164139), // Rule ID 51760 //
     /* 2164100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164103 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2164103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2164106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2164120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164129 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164138 */     // GIR_Coverage, 51760,
     /* 2164138 */     GIR_EraseRootFromParent_Done,
     /* 2164139 */   // Label 29292: @2164139
     /* 2164139 */   GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2164183), // Rule ID 51761 //
     /* 2164144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164147 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2164147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2164150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2164164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164173 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164182 */     // GIR_Coverage, 51761,
     /* 2164182 */     GIR_EraseRootFromParent_Done,
     /* 2164183 */   // Label 29293: @2164183
     /* 2164183 */   GIM_Reject,
     /* 2164184 */ // Label 29291: @2164184
     /* 2164184 */ GIM_Reject,
     /* 2164185 */ // Label 29193: @2164185
     /* 2164185 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2164392),
     /* 2164190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2164193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2164196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2164199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164211 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164215 */   GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2164259), // Rule ID 51784 //
     /* 2164220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164223 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2164223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2164226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164249 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164258 */     // GIR_Coverage, 51784,
     /* 2164258 */     GIR_EraseRootFromParent_Done,
     /* 2164259 */   // Label 29295: @2164259
     /* 2164259 */   GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2164303), // Rule ID 51785 //
     /* 2164264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164267 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2164267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2164270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164293 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164302 */     // GIR_Coverage, 51785,
     /* 2164302 */     GIR_EraseRootFromParent_Done,
     /* 2164303 */   // Label 29296: @2164303
     /* 2164303 */   GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2164347), // Rule ID 57434 //
     /* 2164308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164311 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2164311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2164314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164337 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164346 */     // GIR_Coverage, 57434,
     /* 2164346 */     GIR_EraseRootFromParent_Done,
     /* 2164347 */   // Label 29297: @2164347
     /* 2164347 */   GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2164391), // Rule ID 57435 //
     /* 2164352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164355 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2164355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2164358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164381 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164390 */     // GIR_Coverage, 57435,
     /* 2164390 */     GIR_EraseRootFromParent_Done,
     /* 2164391 */   // Label 29298: @2164391
     /* 2164391 */   GIM_Reject,
     /* 2164392 */ // Label 29294: @2164392
     /* 2164392 */ GIM_Reject,
     /* 2164393 */ // Label 29194: @2164393
     /* 2164393 */ GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2164512),
     /* 2164398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2164401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2164404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2164407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164423 */   GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2164467), // Rule ID 51766 //
     /* 2164428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164431 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2164431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2164434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164457 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164466 */     // GIR_Coverage, 51766,
     /* 2164466 */     GIR_EraseRootFromParent_Done,
     /* 2164467 */   // Label 29300: @2164467
     /* 2164467 */   GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2164511), // Rule ID 51767 //
     /* 2164472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164475 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2164475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2164478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2164492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2164499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2164501 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2164503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164510 */     // GIR_Coverage, 51767,
     /* 2164510 */     GIR_EraseRootFromParent_Done,
     /* 2164511 */   // Label 29301: @2164511
     /* 2164511 */   GIM_Reject,
     /* 2164512 */ // Label 29299: @2164512
     /* 2164512 */ GIM_Reject,
     /* 2164513 */ // Label 29195: @2164513
     /* 2164513 */ GIM_Reject,
     /* 2164514 */ // Label 51: @2164514
     /* 2164514 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29326*/ GIMT_Encode4(2167247),
     /* 2164525 */ /*GILLT_s32*//*Label 29302*/ GIMT_Encode4(2164649),
     /* 2164529 */ /*GILLT_s64*//*Label 29303*/ GIMT_Encode4(2164683), GIMT_Encode4(0),
     /* 2164537 */ /*GILLT_nxv1s8*//*Label 29304*/ GIMT_Encode4(2164717),
     /* 2164541 */ /*GILLT_nxv1s16*//*Label 29305*/ GIMT_Encode4(2164832),
     /* 2164545 */ /*GILLT_nxv1s32*//*Label 29306*/ GIMT_Encode4(2164947),
     /* 2164549 */ /*GILLT_nxv1s64*//*Label 29307*/ GIMT_Encode4(2165062), GIMT_Encode4(0),
     /* 2164557 */ /*GILLT_nxv2s8*//*Label 29308*/ GIMT_Encode4(2165177),
     /* 2164561 */ /*GILLT_nxv2s16*//*Label 29309*/ GIMT_Encode4(2165292),
     /* 2164565 */ /*GILLT_nxv2s32*//*Label 29310*/ GIMT_Encode4(2165407),
     /* 2164569 */ /*GILLT_nxv2s64*//*Label 29311*/ GIMT_Encode4(2165522), GIMT_Encode4(0),
     /* 2164577 */ /*GILLT_nxv4s8*//*Label 29312*/ GIMT_Encode4(2165637),
     /* 2164581 */ /*GILLT_nxv4s16*//*Label 29313*/ GIMT_Encode4(2165752),
     /* 2164585 */ /*GILLT_nxv4s32*//*Label 29314*/ GIMT_Encode4(2165867),
     /* 2164589 */ /*GILLT_nxv4s64*//*Label 29315*/ GIMT_Encode4(2165982), GIMT_Encode4(0),
     /* 2164597 */ /*GILLT_nxv8s8*//*Label 29316*/ GIMT_Encode4(2166097),
     /* 2164601 */ /*GILLT_nxv8s16*//*Label 29317*/ GIMT_Encode4(2166212),
     /* 2164605 */ /*GILLT_nxv8s32*//*Label 29318*/ GIMT_Encode4(2166327),
     /* 2164609 */ /*GILLT_nxv8s64*//*Label 29319*/ GIMT_Encode4(2166442), GIMT_Encode4(0),
     /* 2164617 */ /*GILLT_nxv16s8*//*Label 29320*/ GIMT_Encode4(2166557),
     /* 2164621 */ /*GILLT_nxv16s16*//*Label 29321*/ GIMT_Encode4(2166672),
     /* 2164625 */ /*GILLT_nxv16s32*//*Label 29322*/ GIMT_Encode4(2166787), GIMT_Encode4(0),
     /* 2164633 */ /*GILLT_nxv32s8*//*Label 29323*/ GIMT_Encode4(2166902),
     /* 2164637 */ /*GILLT_nxv32s16*//*Label 29324*/ GIMT_Encode4(2167017), GIMT_Encode4(0),
     /* 2164645 */ /*GILLT_nxv64s8*//*Label 29325*/ GIMT_Encode4(2167132),
     /* 2164649 */ // Label 29302: @2164649
     /* 2164649 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2164682), // Rule ID 292 //
     /* 2164654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2164657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2164660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2164663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164675 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2164675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2164680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2164681 */   // GIR_Coverage, 292,
     /* 2164681 */   GIR_Done,
     /* 2164682 */ // Label 29327: @2164682
     /* 2164682 */ GIM_Reject,
     /* 2164683 */ // Label 29303: @2164683
     /* 2164683 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2164716), // Rule ID 291 //
     /* 2164688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2164691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2164694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2164697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2164709 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2164709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2164714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2164715 */   // GIR_Coverage, 291,
     /* 2164715 */   GIR_Done,
     /* 2164716 */ // Label 29328: @2164716
     /* 2164716 */ GIM_Reject,
     /* 2164717 */ // Label 29304: @2164717
     /* 2164717 */ GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2164831),
     /* 2164722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2164725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2164728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164740 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2164785), // Rule ID 50470 //
     /* 2164745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164748 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2164748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2164751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2164765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2164772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2164774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164784 */     // GIR_Coverage, 50470,
     /* 2164784 */     GIR_EraseRootFromParent_Done,
     /* 2164785 */   // Label 29330: @2164785
     /* 2164785 */   GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2164830), // Rule ID 50471 //
     /* 2164790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164793 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2164793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2164796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2164810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2164817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2164819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164829 */     // GIR_Coverage, 50471,
     /* 2164829 */     GIR_EraseRootFromParent_Done,
     /* 2164830 */   // Label 29331: @2164830
     /* 2164830 */   GIM_Reject,
     /* 2164831 */ // Label 29329: @2164831
     /* 2164831 */ GIM_Reject,
     /* 2164832 */ // Label 29305: @2164832
     /* 2164832 */ GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2164946),
     /* 2164837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2164840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164855 */   GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2164900), // Rule ID 50482 //
     /* 2164860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164863 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2164863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2164866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2164880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2164887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2164889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164899 */     // GIR_Coverage, 50482,
     /* 2164899 */     GIR_EraseRootFromParent_Done,
     /* 2164900 */   // Label 29333: @2164900
     /* 2164900 */   GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2164945), // Rule ID 50483 //
     /* 2164905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2164908 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2164908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2164911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2164925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2164930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2164932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2164934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2164937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2164943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164944 */     // GIR_Coverage, 50483,
     /* 2164944 */     GIR_EraseRootFromParent_Done,
     /* 2164945 */   // Label 29334: @2164945
     /* 2164945 */   GIM_Reject,
     /* 2164946 */ // Label 29332: @2164946
     /* 2164946 */ GIM_Reject,
     /* 2164947 */ // Label 29306: @2164947
     /* 2164947 */ GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2165061),
     /* 2164952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2164955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164970 */   GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2165015), // Rule ID 50490 //
     /* 2164975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2164978 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2164978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2164981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2164985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2164990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2164992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2164995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165014 */     // GIR_Coverage, 50490,
     /* 2165014 */     GIR_EraseRootFromParent_Done,
     /* 2165015 */   // Label 29336: @2165015
     /* 2165015 */   GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2165060), // Rule ID 50491 //
     /* 2165020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165023 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2165026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2165040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165059 */     // GIR_Coverage, 50491,
     /* 2165059 */     GIR_EraseRootFromParent_Done,
     /* 2165060 */   // Label 29337: @2165060
     /* 2165060 */   GIM_Reject,
     /* 2165061 */ // Label 29335: @2165061
     /* 2165061 */ GIM_Reject,
     /* 2165062 */ // Label 29307: @2165062
     /* 2165062 */ GIM_Try, /*On fail goto*//*Label 29338*/ GIMT_Encode4(2165176),
     /* 2165067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2165070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165085 */   GIM_Try, /*On fail goto*//*Label 29339*/ GIMT_Encode4(2165130), // Rule ID 50558 //
     /* 2165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2165093 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2165096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165129 */     // GIR_Coverage, 50558,
     /* 2165129 */     GIR_EraseRootFromParent_Done,
     /* 2165130 */   // Label 29339: @2165130
     /* 2165130 */   GIM_Try, /*On fail goto*//*Label 29340*/ GIMT_Encode4(2165175), // Rule ID 50559 //
     /* 2165135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2165138 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2165141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165174 */     // GIR_Coverage, 50559,
     /* 2165174 */     GIR_EraseRootFromParent_Done,
     /* 2165175 */   // Label 29340: @2165175
     /* 2165175 */   GIM_Reject,
     /* 2165176 */ // Label 29338: @2165176
     /* 2165176 */ GIM_Reject,
     /* 2165177 */ // Label 29308: @2165177
     /* 2165177 */ GIM_Try, /*On fail goto*//*Label 29341*/ GIMT_Encode4(2165291),
     /* 2165182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2165185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2165188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165200 */   GIM_Try, /*On fail goto*//*Label 29342*/ GIMT_Encode4(2165245), // Rule ID 50474 //
     /* 2165205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165208 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2165211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2165225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165244 */     // GIR_Coverage, 50474,
     /* 2165244 */     GIR_EraseRootFromParent_Done,
     /* 2165245 */   // Label 29342: @2165245
     /* 2165245 */   GIM_Try, /*On fail goto*//*Label 29343*/ GIMT_Encode4(2165290), // Rule ID 50475 //
     /* 2165250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165253 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2165256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2165270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165289 */     // GIR_Coverage, 50475,
     /* 2165289 */     GIR_EraseRootFromParent_Done,
     /* 2165290 */   // Label 29343: @2165290
     /* 2165290 */   GIM_Reject,
     /* 2165291 */ // Label 29341: @2165291
     /* 2165291 */ GIM_Reject,
     /* 2165292 */ // Label 29309: @2165292
     /* 2165292 */ GIM_Try, /*On fail goto*//*Label 29344*/ GIMT_Encode4(2165406),
     /* 2165297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2165300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165315 */   GIM_Try, /*On fail goto*//*Label 29345*/ GIMT_Encode4(2165360), // Rule ID 50486 //
     /* 2165320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165323 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2165326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2165340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165359 */     // GIR_Coverage, 50486,
     /* 2165359 */     GIR_EraseRootFromParent_Done,
     /* 2165360 */   // Label 29345: @2165360
     /* 2165360 */   GIM_Try, /*On fail goto*//*Label 29346*/ GIMT_Encode4(2165405), // Rule ID 50487 //
     /* 2165365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165368 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2165371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2165385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165404 */     // GIR_Coverage, 50487,
     /* 2165404 */     GIR_EraseRootFromParent_Done,
     /* 2165405 */   // Label 29346: @2165405
     /* 2165405 */   GIM_Reject,
     /* 2165406 */ // Label 29344: @2165406
     /* 2165406 */ GIM_Reject,
     /* 2165407 */ // Label 29310: @2165407
     /* 2165407 */ GIM_Try, /*On fail goto*//*Label 29347*/ GIMT_Encode4(2165521),
     /* 2165412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2165415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165430 */   GIM_Try, /*On fail goto*//*Label 29348*/ GIMT_Encode4(2165475), // Rule ID 50502 //
     /* 2165435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165438 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2165441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165474 */     // GIR_Coverage, 50502,
     /* 2165474 */     GIR_EraseRootFromParent_Done,
     /* 2165475 */   // Label 29348: @2165475
     /* 2165475 */   GIM_Try, /*On fail goto*//*Label 29349*/ GIMT_Encode4(2165520), // Rule ID 50503 //
     /* 2165480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165483 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2165486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165519 */     // GIR_Coverage, 50503,
     /* 2165519 */     GIR_EraseRootFromParent_Done,
     /* 2165520 */   // Label 29349: @2165520
     /* 2165520 */   GIM_Reject,
     /* 2165521 */ // Label 29347: @2165521
     /* 2165521 */ GIM_Reject,
     /* 2165522 */ // Label 29311: @2165522
     /* 2165522 */ GIM_Try, /*On fail goto*//*Label 29350*/ GIMT_Encode4(2165636),
     /* 2165527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2165530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2165533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165545 */   GIM_Try, /*On fail goto*//*Label 29351*/ GIMT_Encode4(2165590), // Rule ID 50562 //
     /* 2165550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2165553 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2165556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2165570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165589 */     // GIR_Coverage, 50562,
     /* 2165589 */     GIR_EraseRootFromParent_Done,
     /* 2165590 */   // Label 29351: @2165590
     /* 2165590 */   GIM_Try, /*On fail goto*//*Label 29352*/ GIMT_Encode4(2165635), // Rule ID 50563 //
     /* 2165595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2165598 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2165601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2165615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165634 */     // GIR_Coverage, 50563,
     /* 2165634 */     GIR_EraseRootFromParent_Done,
     /* 2165635 */   // Label 29352: @2165635
     /* 2165635 */   GIM_Reject,
     /* 2165636 */ // Label 29350: @2165636
     /* 2165636 */ GIM_Reject,
     /* 2165637 */ // Label 29312: @2165637
     /* 2165637 */ GIM_Try, /*On fail goto*//*Label 29353*/ GIMT_Encode4(2165751),
     /* 2165642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2165645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2165648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165660 */   GIM_Try, /*On fail goto*//*Label 29354*/ GIMT_Encode4(2165705), // Rule ID 50478 //
     /* 2165665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165668 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2165671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2165685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165704 */     // GIR_Coverage, 50478,
     /* 2165704 */     GIR_EraseRootFromParent_Done,
     /* 2165705 */   // Label 29354: @2165705
     /* 2165705 */   GIM_Try, /*On fail goto*//*Label 29355*/ GIMT_Encode4(2165750), // Rule ID 50479 //
     /* 2165710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165713 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2165716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2165730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165749 */     // GIR_Coverage, 50479,
     /* 2165749 */     GIR_EraseRootFromParent_Done,
     /* 2165750 */   // Label 29355: @2165750
     /* 2165750 */   GIM_Reject,
     /* 2165751 */ // Label 29353: @2165751
     /* 2165751 */ GIM_Reject,
     /* 2165752 */ // Label 29313: @2165752
     /* 2165752 */ GIM_Try, /*On fail goto*//*Label 29356*/ GIMT_Encode4(2165866),
     /* 2165757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2165760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165775 */   GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2165820), // Rule ID 50498 //
     /* 2165780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165783 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2165786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165819 */     // GIR_Coverage, 50498,
     /* 2165819 */     GIR_EraseRootFromParent_Done,
     /* 2165820 */   // Label 29357: @2165820
     /* 2165820 */   GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2165865), // Rule ID 50499 //
     /* 2165825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165828 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2165831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2165845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165864 */     // GIR_Coverage, 50499,
     /* 2165864 */     GIR_EraseRootFromParent_Done,
     /* 2165865 */   // Label 29358: @2165865
     /* 2165865 */   GIM_Reject,
     /* 2165866 */ // Label 29356: @2165866
     /* 2165866 */ GIM_Reject,
     /* 2165867 */ // Label 29314: @2165867
     /* 2165867 */ GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2165981),
     /* 2165872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2165875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2165878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165890 */   GIM_Try, /*On fail goto*//*Label 29360*/ GIMT_Encode4(2165935), // Rule ID 50530 //
     /* 2165895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2165898 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2165898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2165901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2165915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165934 */     // GIR_Coverage, 50530,
     /* 2165934 */     GIR_EraseRootFromParent_Done,
     /* 2165935 */   // Label 29360: @2165935
     /* 2165935 */   GIM_Try, /*On fail goto*//*Label 29361*/ GIMT_Encode4(2165980), // Rule ID 50531 //
     /* 2165940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2165943 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2165943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2165946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2165950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2165955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2165957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2165960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2165965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2165967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2165969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2165972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2165978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165979 */     // GIR_Coverage, 50531,
     /* 2165979 */     GIR_EraseRootFromParent_Done,
     /* 2165980 */   // Label 29361: @2165980
     /* 2165980 */   GIM_Reject,
     /* 2165981 */ // Label 29359: @2165981
     /* 2165981 */ GIM_Reject,
     /* 2165982 */ // Label 29315: @2165982
     /* 2165982 */ GIM_Try, /*On fail goto*//*Label 29362*/ GIMT_Encode4(2166096),
     /* 2165987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2165990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2165993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166005 */   GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2166050), // Rule ID 50566 //
     /* 2166010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2166013 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2166016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166049 */     // GIR_Coverage, 50566,
     /* 2166049 */     GIR_EraseRootFromParent_Done,
     /* 2166050 */   // Label 29363: @2166050
     /* 2166050 */   GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2166095), // Rule ID 50567 //
     /* 2166055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2166058 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2166061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166094 */     // GIR_Coverage, 50567,
     /* 2166094 */     GIR_EraseRootFromParent_Done,
     /* 2166095 */   // Label 29364: @2166095
     /* 2166095 */   GIM_Reject,
     /* 2166096 */ // Label 29362: @2166096
     /* 2166096 */ GIM_Reject,
     /* 2166097 */ // Label 29316: @2166097
     /* 2166097 */ GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2166211),
     /* 2166102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2166105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2166108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166120 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2166165), // Rule ID 50494 //
     /* 2166125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166128 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2166131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2166145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166164 */     // GIR_Coverage, 50494,
     /* 2166164 */     GIR_EraseRootFromParent_Done,
     /* 2166165 */   // Label 29366: @2166165
     /* 2166165 */   GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2166210), // Rule ID 50495 //
     /* 2166170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166173 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2166176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2166190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166209 */     // GIR_Coverage, 50495,
     /* 2166209 */     GIR_EraseRootFromParent_Done,
     /* 2166210 */   // Label 29367: @2166210
     /* 2166210 */   GIM_Reject,
     /* 2166211 */ // Label 29365: @2166211
     /* 2166211 */ GIM_Reject,
     /* 2166212 */ // Label 29317: @2166212
     /* 2166212 */ GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2166326),
     /* 2166217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2166220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2166223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166235 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2166280), // Rule ID 50518 //
     /* 2166240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166243 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2166246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2166260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166279 */     // GIR_Coverage, 50518,
     /* 2166279 */     GIR_EraseRootFromParent_Done,
     /* 2166280 */   // Label 29369: @2166280
     /* 2166280 */   GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2166325), // Rule ID 50519 //
     /* 2166285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166288 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2166291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2166305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166324 */     // GIR_Coverage, 50519,
     /* 2166324 */     GIR_EraseRootFromParent_Done,
     /* 2166325 */   // Label 29370: @2166325
     /* 2166325 */   GIM_Reject,
     /* 2166326 */ // Label 29368: @2166326
     /* 2166326 */ GIM_Reject,
     /* 2166327 */ // Label 29318: @2166327
     /* 2166327 */ GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2166441),
     /* 2166332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2166335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166350 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2166395), // Rule ID 50534 //
     /* 2166355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166358 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2166361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166394 */     // GIR_Coverage, 50534,
     /* 2166394 */     GIR_EraseRootFromParent_Done,
     /* 2166395 */   // Label 29372: @2166395
     /* 2166395 */   GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2166440), // Rule ID 50535 //
     /* 2166400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166403 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2166406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166439 */     // GIR_Coverage, 50535,
     /* 2166439 */     GIR_EraseRootFromParent_Done,
     /* 2166440 */   // Label 29373: @2166440
     /* 2166440 */   GIM_Reject,
     /* 2166441 */ // Label 29371: @2166441
     /* 2166441 */ GIM_Reject,
     /* 2166442 */ // Label 29319: @2166442
     /* 2166442 */ GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2166556),
     /* 2166447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2166450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166465 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2166510), // Rule ID 50570 //
     /* 2166470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2166473 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2166476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2166490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166509 */     // GIR_Coverage, 50570,
     /* 2166509 */     GIR_EraseRootFromParent_Done,
     /* 2166510 */   // Label 29375: @2166510
     /* 2166510 */   GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2166555), // Rule ID 50571 //
     /* 2166515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2166518 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2166521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2166535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166554 */     // GIR_Coverage, 50571,
     /* 2166554 */     GIR_EraseRootFromParent_Done,
     /* 2166555 */   // Label 29376: @2166555
     /* 2166555 */   GIM_Reject,
     /* 2166556 */ // Label 29374: @2166556
     /* 2166556 */ GIM_Reject,
     /* 2166557 */ // Label 29320: @2166557
     /* 2166557 */ GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2166671),
     /* 2166562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2166565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2166568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166580 */   GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2166625), // Rule ID 50506 //
     /* 2166585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166588 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2166591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2166605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166624 */     // GIR_Coverage, 50506,
     /* 2166624 */     GIR_EraseRootFromParent_Done,
     /* 2166625 */   // Label 29378: @2166625
     /* 2166625 */   GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2166670), // Rule ID 50507 //
     /* 2166630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166633 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2166636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2166650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166669 */     // GIR_Coverage, 50507,
     /* 2166669 */     GIR_EraseRootFromParent_Done,
     /* 2166670 */   // Label 29379: @2166670
     /* 2166670 */   GIM_Reject,
     /* 2166671 */ // Label 29377: @2166671
     /* 2166671 */ GIM_Reject,
     /* 2166672 */ // Label 29321: @2166672
     /* 2166672 */ GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2166786),
     /* 2166677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2166680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166695 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2166740), // Rule ID 50522 //
     /* 2166700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166703 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2166706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166739 */     // GIR_Coverage, 50522,
     /* 2166739 */     GIR_EraseRootFromParent_Done,
     /* 2166740 */   // Label 29381: @2166740
     /* 2166740 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2166785), // Rule ID 50523 //
     /* 2166745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166748 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2166751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166784 */     // GIR_Coverage, 50523,
     /* 2166784 */     GIR_EraseRootFromParent_Done,
     /* 2166785 */   // Label 29382: @2166785
     /* 2166785 */   GIM_Reject,
     /* 2166786 */ // Label 29380: @2166786
     /* 2166786 */ GIM_Reject,
     /* 2166787 */ // Label 29322: @2166787
     /* 2166787 */ GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2166901),
     /* 2166792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2166795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166810 */   GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2166855), // Rule ID 50538 //
     /* 2166815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166818 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2166821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2166835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166854 */     // GIR_Coverage, 50538,
     /* 2166854 */     GIR_EraseRootFromParent_Done,
     /* 2166855 */   // Label 29384: @2166855
     /* 2166855 */   GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2166900), // Rule ID 50539 //
     /* 2166860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166863 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2166866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2166880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166899 */     // GIR_Coverage, 50539,
     /* 2166899 */     GIR_EraseRootFromParent_Done,
     /* 2166900 */   // Label 29385: @2166900
     /* 2166900 */   GIM_Reject,
     /* 2166901 */ // Label 29383: @2166901
     /* 2166901 */ GIM_Reject,
     /* 2166902 */ // Label 29323: @2166902
     /* 2166902 */ GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2167016),
     /* 2166907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2166910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2166913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166925 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2166970), // Rule ID 50510 //
     /* 2166930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2166933 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2166933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2166936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2166955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2166957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2166959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2166962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2166968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166969 */     // GIR_Coverage, 50510,
     /* 2166969 */     GIR_EraseRootFromParent_Done,
     /* 2166970 */   // Label 29387: @2166970
     /* 2166970 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2167015), // Rule ID 50511 //
     /* 2166975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2166978 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2166978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2166981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2166985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2166990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2166992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2166995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167014 */     // GIR_Coverage, 50511,
     /* 2167014 */     GIR_EraseRootFromParent_Done,
     /* 2167015 */   // Label 29388: @2167015
     /* 2167015 */   GIM_Reject,
     /* 2167016 */ // Label 29386: @2167016
     /* 2167016 */ GIM_Reject,
     /* 2167017 */ // Label 29324: @2167017
     /* 2167017 */ GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2167131),
     /* 2167022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2167025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2167028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167040 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2167085), // Rule ID 50526 //
     /* 2167045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167048 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2167051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2167065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167084 */     // GIR_Coverage, 50526,
     /* 2167084 */     GIR_EraseRootFromParent_Done,
     /* 2167085 */   // Label 29390: @2167085
     /* 2167085 */   GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2167130), // Rule ID 50527 //
     /* 2167090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167093 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2167096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2167110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167129 */     // GIR_Coverage, 50527,
     /* 2167129 */     GIR_EraseRootFromParent_Done,
     /* 2167130 */   // Label 29391: @2167130
     /* 2167130 */   GIM_Reject,
     /* 2167131 */ // Label 29389: @2167131
     /* 2167131 */ GIM_Reject,
     /* 2167132 */ // Label 29325: @2167132
     /* 2167132 */ GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2167246),
     /* 2167137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2167140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2167143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167155 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2167200), // Rule ID 50514 //
     /* 2167160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167163 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2167166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2167180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167199 */     // GIR_Coverage, 50514,
     /* 2167199 */     GIR_EraseRootFromParent_Done,
     /* 2167200 */   // Label 29393: @2167200
     /* 2167200 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2167245), // Rule ID 50515 //
     /* 2167205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167208 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2167211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2167225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167244 */     // GIR_Coverage, 50515,
     /* 2167244 */     GIR_EraseRootFromParent_Done,
     /* 2167245 */   // Label 29394: @2167245
     /* 2167245 */   GIM_Reject,
     /* 2167246 */ // Label 29392: @2167246
     /* 2167246 */ GIM_Reject,
     /* 2167247 */ // Label 29326: @2167247
     /* 2167247 */ GIM_Reject,
     /* 2167248 */ // Label 52: @2167248
     /* 2167248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29419*/ GIMT_Encode4(2169981),
     /* 2167259 */ /*GILLT_s32*//*Label 29395*/ GIMT_Encode4(2167383),
     /* 2167263 */ /*GILLT_s64*//*Label 29396*/ GIMT_Encode4(2167417), GIMT_Encode4(0),
     /* 2167271 */ /*GILLT_nxv1s8*//*Label 29397*/ GIMT_Encode4(2167451),
     /* 2167275 */ /*GILLT_nxv1s16*//*Label 29398*/ GIMT_Encode4(2167566),
     /* 2167279 */ /*GILLT_nxv1s32*//*Label 29399*/ GIMT_Encode4(2167681),
     /* 2167283 */ /*GILLT_nxv1s64*//*Label 29400*/ GIMT_Encode4(2167796), GIMT_Encode4(0),
     /* 2167291 */ /*GILLT_nxv2s8*//*Label 29401*/ GIMT_Encode4(2167911),
     /* 2167295 */ /*GILLT_nxv2s16*//*Label 29402*/ GIMT_Encode4(2168026),
     /* 2167299 */ /*GILLT_nxv2s32*//*Label 29403*/ GIMT_Encode4(2168141),
     /* 2167303 */ /*GILLT_nxv2s64*//*Label 29404*/ GIMT_Encode4(2168256), GIMT_Encode4(0),
     /* 2167311 */ /*GILLT_nxv4s8*//*Label 29405*/ GIMT_Encode4(2168371),
     /* 2167315 */ /*GILLT_nxv4s16*//*Label 29406*/ GIMT_Encode4(2168486),
     /* 2167319 */ /*GILLT_nxv4s32*//*Label 29407*/ GIMT_Encode4(2168601),
     /* 2167323 */ /*GILLT_nxv4s64*//*Label 29408*/ GIMT_Encode4(2168716), GIMT_Encode4(0),
     /* 2167331 */ /*GILLT_nxv8s8*//*Label 29409*/ GIMT_Encode4(2168831),
     /* 2167335 */ /*GILLT_nxv8s16*//*Label 29410*/ GIMT_Encode4(2168946),
     /* 2167339 */ /*GILLT_nxv8s32*//*Label 29411*/ GIMT_Encode4(2169061),
     /* 2167343 */ /*GILLT_nxv8s64*//*Label 29412*/ GIMT_Encode4(2169176), GIMT_Encode4(0),
     /* 2167351 */ /*GILLT_nxv16s8*//*Label 29413*/ GIMT_Encode4(2169291),
     /* 2167355 */ /*GILLT_nxv16s16*//*Label 29414*/ GIMT_Encode4(2169406),
     /* 2167359 */ /*GILLT_nxv16s32*//*Label 29415*/ GIMT_Encode4(2169521), GIMT_Encode4(0),
     /* 2167367 */ /*GILLT_nxv32s8*//*Label 29416*/ GIMT_Encode4(2169636),
     /* 2167371 */ /*GILLT_nxv32s16*//*Label 29417*/ GIMT_Encode4(2169751), GIMT_Encode4(0),
     /* 2167379 */ /*GILLT_nxv64s8*//*Label 29418*/ GIMT_Encode4(2169866),
     /* 2167383 */ // Label 29395: @2167383
     /* 2167383 */ GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2167416), // Rule ID 290 //
     /* 2167388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2167391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2167394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2167397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167409 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2167409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2167414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2167415 */   // GIR_Coverage, 290,
     /* 2167415 */   GIR_Done,
     /* 2167416 */ // Label 29420: @2167416
     /* 2167416 */ GIM_Reject,
     /* 2167417 */ // Label 29396: @2167417
     /* 2167417 */ GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2167450), // Rule ID 289 //
     /* 2167422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2167425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2167428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2167431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2167443 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2167443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2167448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2167449 */   // GIR_Coverage, 289,
     /* 2167449 */   GIR_Done,
     /* 2167450 */ // Label 29421: @2167450
     /* 2167450 */ GIM_Reject,
     /* 2167451 */ // Label 29397: @2167451
     /* 2167451 */ GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2167565),
     /* 2167456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2167459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2167462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167474 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2167519), // Rule ID 50398 //
     /* 2167479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167482 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2167485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2167499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167518 */     // GIR_Coverage, 50398,
     /* 2167518 */     GIR_EraseRootFromParent_Done,
     /* 2167519 */   // Label 29423: @2167519
     /* 2167519 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2167564), // Rule ID 50399 //
     /* 2167524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167527 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2167530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2167544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167563 */     // GIR_Coverage, 50399,
     /* 2167563 */     GIR_EraseRootFromParent_Done,
     /* 2167564 */   // Label 29424: @2167564
     /* 2167564 */   GIM_Reject,
     /* 2167565 */ // Label 29422: @2167565
     /* 2167565 */ GIM_Reject,
     /* 2167566 */ // Label 29398: @2167566
     /* 2167566 */ GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2167680),
     /* 2167571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2167574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167589 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2167634), // Rule ID 50410 //
     /* 2167594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167597 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2167600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2167614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167633 */     // GIR_Coverage, 50410,
     /* 2167633 */     GIR_EraseRootFromParent_Done,
     /* 2167634 */   // Label 29426: @2167634
     /* 2167634 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2167679), // Rule ID 50411 //
     /* 2167639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167642 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2167645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2167659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167678 */     // GIR_Coverage, 50411,
     /* 2167678 */     GIR_EraseRootFromParent_Done,
     /* 2167679 */   // Label 29427: @2167679
     /* 2167679 */   GIM_Reject,
     /* 2167680 */ // Label 29425: @2167680
     /* 2167680 */ GIM_Reject,
     /* 2167681 */ // Label 29399: @2167681
     /* 2167681 */ GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2167795),
     /* 2167686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2167689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167704 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2167749), // Rule ID 50418 //
     /* 2167709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167712 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2167715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2167729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167748 */     // GIR_Coverage, 50418,
     /* 2167748 */     GIR_EraseRootFromParent_Done,
     /* 2167749 */   // Label 29429: @2167749
     /* 2167749 */   GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2167794), // Rule ID 50419 //
     /* 2167754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167757 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2167760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2167774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167793 */     // GIR_Coverage, 50419,
     /* 2167793 */     GIR_EraseRootFromParent_Done,
     /* 2167794 */   // Label 29430: @2167794
     /* 2167794 */   GIM_Reject,
     /* 2167795 */ // Label 29428: @2167795
     /* 2167795 */ GIM_Reject,
     /* 2167796 */ // Label 29400: @2167796
     /* 2167796 */ GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2167910),
     /* 2167801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2167804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2167807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167819 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2167864), // Rule ID 50542 //
     /* 2167824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2167827 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2167830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2167844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167863 */     // GIR_Coverage, 50542,
     /* 2167863 */     GIR_EraseRootFromParent_Done,
     /* 2167864 */   // Label 29432: @2167864
     /* 2167864 */   GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2167909), // Rule ID 50543 //
     /* 2167869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2167872 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2167875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2167889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167908 */     // GIR_Coverage, 50543,
     /* 2167908 */     GIR_EraseRootFromParent_Done,
     /* 2167909 */   // Label 29433: @2167909
     /* 2167909 */   GIM_Reject,
     /* 2167910 */ // Label 29431: @2167910
     /* 2167910 */ GIM_Reject,
     /* 2167911 */ // Label 29401: @2167911
     /* 2167911 */ GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2168025),
     /* 2167916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2167919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2167922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167934 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2167979), // Rule ID 50402 //
     /* 2167939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2167942 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2167942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2167945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2167956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2167959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2167964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2167966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2167968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2167971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2167977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167978 */     // GIR_Coverage, 50402,
     /* 2167978 */     GIR_EraseRootFromParent_Done,
     /* 2167979 */   // Label 29435: @2167979
     /* 2167979 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2168024), // Rule ID 50403 //
     /* 2167984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2167987 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2167987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2167990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2167994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2167999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2168004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168023 */     // GIR_Coverage, 50403,
     /* 2168023 */     GIR_EraseRootFromParent_Done,
     /* 2168024 */   // Label 29436: @2168024
     /* 2168024 */   GIM_Reject,
     /* 2168025 */ // Label 29434: @2168025
     /* 2168025 */ GIM_Reject,
     /* 2168026 */ // Label 29402: @2168026
     /* 2168026 */ GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2168140),
     /* 2168031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2168034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2168037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168049 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2168094), // Rule ID 50414 //
     /* 2168054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168057 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2168060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2168074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168093 */     // GIR_Coverage, 50414,
     /* 2168093 */     GIR_EraseRootFromParent_Done,
     /* 2168094 */   // Label 29438: @2168094
     /* 2168094 */   GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2168139), // Rule ID 50415 //
     /* 2168099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168102 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2168105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2168119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168138 */     // GIR_Coverage, 50415,
     /* 2168138 */     GIR_EraseRootFromParent_Done,
     /* 2168139 */   // Label 29439: @2168139
     /* 2168139 */   GIM_Reject,
     /* 2168140 */ // Label 29437: @2168140
     /* 2168140 */ GIM_Reject,
     /* 2168141 */ // Label 29403: @2168141
     /* 2168141 */ GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2168255),
     /* 2168146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2168149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168164 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2168209), // Rule ID 50430 //
     /* 2168169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168172 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2168175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168208 */     // GIR_Coverage, 50430,
     /* 2168208 */     GIR_EraseRootFromParent_Done,
     /* 2168209 */   // Label 29441: @2168209
     /* 2168209 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2168254), // Rule ID 50431 //
     /* 2168214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168217 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2168220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168253 */     // GIR_Coverage, 50431,
     /* 2168253 */     GIR_EraseRootFromParent_Done,
     /* 2168254 */   // Label 29442: @2168254
     /* 2168254 */   GIM_Reject,
     /* 2168255 */ // Label 29440: @2168255
     /* 2168255 */ GIM_Reject,
     /* 2168256 */ // Label 29404: @2168256
     /* 2168256 */ GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2168370),
     /* 2168261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2168264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2168267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168279 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2168324), // Rule ID 50546 //
     /* 2168284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2168287 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2168290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2168304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168323 */     // GIR_Coverage, 50546,
     /* 2168323 */     GIR_EraseRootFromParent_Done,
     /* 2168324 */   // Label 29444: @2168324
     /* 2168324 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2168369), // Rule ID 50547 //
     /* 2168329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2168332 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2168335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2168349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168368 */     // GIR_Coverage, 50547,
     /* 2168368 */     GIR_EraseRootFromParent_Done,
     /* 2168369 */   // Label 29445: @2168369
     /* 2168369 */   GIM_Reject,
     /* 2168370 */ // Label 29443: @2168370
     /* 2168370 */ GIM_Reject,
     /* 2168371 */ // Label 29405: @2168371
     /* 2168371 */ GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2168485),
     /* 2168376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2168379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2168382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168394 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2168439), // Rule ID 50406 //
     /* 2168399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168402 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2168405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2168419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168438 */     // GIR_Coverage, 50406,
     /* 2168438 */     GIR_EraseRootFromParent_Done,
     /* 2168439 */   // Label 29447: @2168439
     /* 2168439 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2168484), // Rule ID 50407 //
     /* 2168444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168447 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2168450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2168464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168483 */     // GIR_Coverage, 50407,
     /* 2168483 */     GIR_EraseRootFromParent_Done,
     /* 2168484 */   // Label 29448: @2168484
     /* 2168484 */   GIM_Reject,
     /* 2168485 */ // Label 29446: @2168485
     /* 2168485 */ GIM_Reject,
     /* 2168486 */ // Label 29406: @2168486
     /* 2168486 */ GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2168600),
     /* 2168491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2168494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168509 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2168554), // Rule ID 50426 //
     /* 2168514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168517 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2168520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168553 */     // GIR_Coverage, 50426,
     /* 2168553 */     GIR_EraseRootFromParent_Done,
     /* 2168554 */   // Label 29450: @2168554
     /* 2168554 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2168599), // Rule ID 50427 //
     /* 2168559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168562 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2168565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168598 */     // GIR_Coverage, 50427,
     /* 2168598 */     GIR_EraseRootFromParent_Done,
     /* 2168599 */   // Label 29451: @2168599
     /* 2168599 */   GIM_Reject,
     /* 2168600 */ // Label 29449: @2168600
     /* 2168600 */ GIM_Reject,
     /* 2168601 */ // Label 29407: @2168601
     /* 2168601 */ GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2168715),
     /* 2168606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2168609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168624 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2168669), // Rule ID 50458 //
     /* 2168629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168632 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2168635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2168649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168668 */     // GIR_Coverage, 50458,
     /* 2168668 */     GIR_EraseRootFromParent_Done,
     /* 2168669 */   // Label 29453: @2168669
     /* 2168669 */   GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2168714), // Rule ID 50459 //
     /* 2168674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168677 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2168680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2168694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168713 */     // GIR_Coverage, 50459,
     /* 2168713 */     GIR_EraseRootFromParent_Done,
     /* 2168714 */   // Label 29454: @2168714
     /* 2168714 */   GIM_Reject,
     /* 2168715 */ // Label 29452: @2168715
     /* 2168715 */ GIM_Reject,
     /* 2168716 */ // Label 29408: @2168716
     /* 2168716 */ GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2168830),
     /* 2168721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2168724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2168727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168739 */   GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2168784), // Rule ID 50550 //
     /* 2168744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2168747 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2168750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2168764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168783 */     // GIR_Coverage, 50550,
     /* 2168783 */     GIR_EraseRootFromParent_Done,
     /* 2168784 */   // Label 29456: @2168784
     /* 2168784 */   GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2168829), // Rule ID 50551 //
     /* 2168789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2168792 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2168795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2168809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168828 */     // GIR_Coverage, 50551,
     /* 2168828 */     GIR_EraseRootFromParent_Done,
     /* 2168829 */   // Label 29457: @2168829
     /* 2168829 */   GIM_Reject,
     /* 2168830 */ // Label 29455: @2168830
     /* 2168830 */ GIM_Reject,
     /* 2168831 */ // Label 29409: @2168831
     /* 2168831 */ GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2168945),
     /* 2168836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2168839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2168842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168854 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2168899), // Rule ID 50422 //
     /* 2168859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168862 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2168865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168898 */     // GIR_Coverage, 50422,
     /* 2168898 */     GIR_EraseRootFromParent_Done,
     /* 2168899 */   // Label 29459: @2168899
     /* 2168899 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2168944), // Rule ID 50423 //
     /* 2168904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2168907 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2168907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2168910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2168924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2168931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2168933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2168936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2168942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168943 */     // GIR_Coverage, 50423,
     /* 2168943 */     GIR_EraseRootFromParent_Done,
     /* 2168944 */   // Label 29460: @2168944
     /* 2168944 */   GIM_Reject,
     /* 2168945 */ // Label 29458: @2168945
     /* 2168945 */ GIM_Reject,
     /* 2168946 */ // Label 29410: @2168946
     /* 2168946 */ GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2169060),
     /* 2168951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2168954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168969 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2169014), // Rule ID 50446 //
     /* 2168974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2168977 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2168977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2168980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2168984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2168989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2168991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2168994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2168999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169013 */     // GIR_Coverage, 50446,
     /* 2169013 */     GIR_EraseRootFromParent_Done,
     /* 2169014 */   // Label 29462: @2169014
     /* 2169014 */   GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2169059), // Rule ID 50447 //
     /* 2169019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169022 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2169025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2169039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169058 */     // GIR_Coverage, 50447,
     /* 2169058 */     GIR_EraseRootFromParent_Done,
     /* 2169059 */   // Label 29463: @2169059
     /* 2169059 */   GIM_Reject,
     /* 2169060 */ // Label 29461: @2169060
     /* 2169060 */ GIM_Reject,
     /* 2169061 */ // Label 29411: @2169061
     /* 2169061 */ GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2169175),
     /* 2169066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2169069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169084 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2169129), // Rule ID 50462 //
     /* 2169089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169092 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2169095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169128 */     // GIR_Coverage, 50462,
     /* 2169128 */     GIR_EraseRootFromParent_Done,
     /* 2169129 */   // Label 29465: @2169129
     /* 2169129 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2169174), // Rule ID 50463 //
     /* 2169134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169137 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2169140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169173 */     // GIR_Coverage, 50463,
     /* 2169173 */     GIR_EraseRootFromParent_Done,
     /* 2169174 */   // Label 29466: @2169174
     /* 2169174 */   GIM_Reject,
     /* 2169175 */ // Label 29464: @2169175
     /* 2169175 */ GIM_Reject,
     /* 2169176 */ // Label 29412: @2169176
     /* 2169176 */ GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2169290),
     /* 2169181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2169184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169199 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2169244), // Rule ID 50554 //
     /* 2169204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2169207 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2169210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169243 */     // GIR_Coverage, 50554,
     /* 2169243 */     GIR_EraseRootFromParent_Done,
     /* 2169244 */   // Label 29468: @2169244
     /* 2169244 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2169289), // Rule ID 50555 //
     /* 2169249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2169252 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2169255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169288 */     // GIR_Coverage, 50555,
     /* 2169288 */     GIR_EraseRootFromParent_Done,
     /* 2169289 */   // Label 29469: @2169289
     /* 2169289 */   GIM_Reject,
     /* 2169290 */ // Label 29467: @2169290
     /* 2169290 */ GIM_Reject,
     /* 2169291 */ // Label 29413: @2169291
     /* 2169291 */ GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2169405),
     /* 2169296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2169299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2169302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169314 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2169359), // Rule ID 50434 //
     /* 2169319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169322 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2169325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2169339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169358 */     // GIR_Coverage, 50434,
     /* 2169358 */     GIR_EraseRootFromParent_Done,
     /* 2169359 */   // Label 29471: @2169359
     /* 2169359 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2169404), // Rule ID 50435 //
     /* 2169364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169367 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2169370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2169384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169403 */     // GIR_Coverage, 50435,
     /* 2169403 */     GIR_EraseRootFromParent_Done,
     /* 2169404 */   // Label 29472: @2169404
     /* 2169404 */   GIM_Reject,
     /* 2169405 */ // Label 29470: @2169405
     /* 2169405 */ GIM_Reject,
     /* 2169406 */ // Label 29414: @2169406
     /* 2169406 */ GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2169520),
     /* 2169411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2169414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2169417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169429 */   GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2169474), // Rule ID 50450 //
     /* 2169434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169437 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2169440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169473 */     // GIR_Coverage, 50450,
     /* 2169473 */     GIR_EraseRootFromParent_Done,
     /* 2169474 */   // Label 29474: @2169474
     /* 2169474 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2169519), // Rule ID 50451 //
     /* 2169479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169482 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2169485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169518 */     // GIR_Coverage, 50451,
     /* 2169518 */     GIR_EraseRootFromParent_Done,
     /* 2169519 */   // Label 29475: @2169519
     /* 2169519 */   GIM_Reject,
     /* 2169520 */ // Label 29473: @2169520
     /* 2169520 */ GIM_Reject,
     /* 2169521 */ // Label 29415: @2169521
     /* 2169521 */ GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2169635),
     /* 2169526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2169529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169544 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2169589), // Rule ID 50466 //
     /* 2169549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169552 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2169555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169588 */     // GIR_Coverage, 50466,
     /* 2169588 */     GIR_EraseRootFromParent_Done,
     /* 2169589 */   // Label 29477: @2169589
     /* 2169589 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2169634), // Rule ID 50467 //
     /* 2169594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169597 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2169600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169633 */     // GIR_Coverage, 50467,
     /* 2169633 */     GIR_EraseRootFromParent_Done,
     /* 2169634 */   // Label 29478: @2169634
     /* 2169634 */   GIM_Reject,
     /* 2169635 */ // Label 29476: @2169635
     /* 2169635 */ GIM_Reject,
     /* 2169636 */ // Label 29416: @2169636
     /* 2169636 */ GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2169750),
     /* 2169641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2169644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2169647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169659 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2169704), // Rule ID 50438 //
     /* 2169664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169667 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2169670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169703 */     // GIR_Coverage, 50438,
     /* 2169703 */     GIR_EraseRootFromParent_Done,
     /* 2169704 */   // Label 29480: @2169704
     /* 2169704 */   GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2169749), // Rule ID 50439 //
     /* 2169709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169712 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2169715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2169729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169748 */     // GIR_Coverage, 50439,
     /* 2169748 */     GIR_EraseRootFromParent_Done,
     /* 2169749 */   // Label 29481: @2169749
     /* 2169749 */   GIM_Reject,
     /* 2169750 */ // Label 29479: @2169750
     /* 2169750 */ GIM_Reject,
     /* 2169751 */ // Label 29417: @2169751
     /* 2169751 */ GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2169865),
     /* 2169756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2169759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169774 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2169819), // Rule ID 50454 //
     /* 2169779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169782 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2169785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169818 */     // GIR_Coverage, 50454,
     /* 2169818 */     GIR_EraseRootFromParent_Done,
     /* 2169819 */   // Label 29483: @2169819
     /* 2169819 */   GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2169864), // Rule ID 50455 //
     /* 2169824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169827 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2169830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169863 */     // GIR_Coverage, 50455,
     /* 2169863 */     GIR_EraseRootFromParent_Done,
     /* 2169864 */   // Label 29484: @2169864
     /* 2169864 */   GIM_Reject,
     /* 2169865 */ // Label 29482: @2169865
     /* 2169865 */ GIM_Reject,
     /* 2169866 */ // Label 29418: @2169866
     /* 2169866 */ GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2169980),
     /* 2169871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2169874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2169877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169889 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2169934), // Rule ID 50442 //
     /* 2169894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2169897 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2169897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2169900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169933 */     // GIR_Coverage, 50442,
     /* 2169933 */     GIR_EraseRootFromParent_Done,
     /* 2169934 */   // Label 29486: @2169934
     /* 2169934 */   GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2169979), // Rule ID 50443 //
     /* 2169939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2169942 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2169942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2169945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2169949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2169954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2169956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2169959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2169964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2169966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2169968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2169971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2169977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169978 */     // GIR_Coverage, 50443,
     /* 2169978 */     GIR_EraseRootFromParent_Done,
     /* 2169979 */   // Label 29487: @2169979
     /* 2169979 */   GIM_Reject,
     /* 2169980 */ // Label 29485: @2169980
     /* 2169980 */ GIM_Reject,
     /* 2169981 */ // Label 29419: @2169981
     /* 2169981 */ GIM_Reject,
     /* 2169982 */ // Label 53: @2169982
     /* 2169982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29510*/ GIMT_Encode4(2172767),
     /* 2169993 */ /*GILLT_nxv1s8*//*Label 29488*/ GIMT_Encode4(2170105),
     /* 2169997 */ /*GILLT_nxv1s16*//*Label 29489*/ GIMT_Encode4(2170226),
     /* 2170001 */ /*GILLT_nxv1s32*//*Label 29490*/ GIMT_Encode4(2170347),
     /* 2170005 */ /*GILLT_nxv1s64*//*Label 29491*/ GIMT_Encode4(2170468), GIMT_Encode4(0),
     /* 2170013 */ /*GILLT_nxv2s8*//*Label 29492*/ GIMT_Encode4(2170589),
     /* 2170017 */ /*GILLT_nxv2s16*//*Label 29493*/ GIMT_Encode4(2170710),
     /* 2170021 */ /*GILLT_nxv2s32*//*Label 29494*/ GIMT_Encode4(2170831),
     /* 2170025 */ /*GILLT_nxv2s64*//*Label 29495*/ GIMT_Encode4(2170952), GIMT_Encode4(0),
     /* 2170033 */ /*GILLT_nxv4s8*//*Label 29496*/ GIMT_Encode4(2171073),
     /* 2170037 */ /*GILLT_nxv4s16*//*Label 29497*/ GIMT_Encode4(2171194),
     /* 2170041 */ /*GILLT_nxv4s32*//*Label 29498*/ GIMT_Encode4(2171315),
     /* 2170045 */ /*GILLT_nxv4s64*//*Label 29499*/ GIMT_Encode4(2171436), GIMT_Encode4(0),
     /* 2170053 */ /*GILLT_nxv8s8*//*Label 29500*/ GIMT_Encode4(2171557),
     /* 2170057 */ /*GILLT_nxv8s16*//*Label 29501*/ GIMT_Encode4(2171678),
     /* 2170061 */ /*GILLT_nxv8s32*//*Label 29502*/ GIMT_Encode4(2171799),
     /* 2170065 */ /*GILLT_nxv8s64*//*Label 29503*/ GIMT_Encode4(2171920), GIMT_Encode4(0),
     /* 2170073 */ /*GILLT_nxv16s8*//*Label 29504*/ GIMT_Encode4(2172041),
     /* 2170077 */ /*GILLT_nxv16s16*//*Label 29505*/ GIMT_Encode4(2172162),
     /* 2170081 */ /*GILLT_nxv16s32*//*Label 29506*/ GIMT_Encode4(2172283), GIMT_Encode4(0),
     /* 2170089 */ /*GILLT_nxv32s8*//*Label 29507*/ GIMT_Encode4(2172404),
     /* 2170093 */ /*GILLT_nxv32s16*//*Label 29508*/ GIMT_Encode4(2172525), GIMT_Encode4(0),
     /* 2170101 */ /*GILLT_nxv64s8*//*Label 29509*/ GIMT_Encode4(2172646),
     /* 2170105 */ // Label 29488: @2170105
     /* 2170105 */ GIM_Try, /*On fail goto*//*Label 29511*/ GIMT_Encode4(2170225),
     /* 2170110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2170113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2170116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170128 */   GIM_Try, /*On fail goto*//*Label 29512*/ GIMT_Encode4(2170176), // Rule ID 51958 //
     /* 2170133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170136 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2170139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2170153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170175 */     // GIR_Coverage, 51958,
     /* 2170175 */     GIR_EraseRootFromParent_Done,
     /* 2170176 */   // Label 29512: @2170176
     /* 2170176 */   GIM_Try, /*On fail goto*//*Label 29513*/ GIMT_Encode4(2170224), // Rule ID 51959 //
     /* 2170181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170184 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2170187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2170201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170223 */     // GIR_Coverage, 51959,
     /* 2170223 */     GIR_EraseRootFromParent_Done,
     /* 2170224 */   // Label 29513: @2170224
     /* 2170224 */   GIM_Reject,
     /* 2170225 */ // Label 29511: @2170225
     /* 2170225 */ GIM_Reject,
     /* 2170226 */ // Label 29489: @2170226
     /* 2170226 */ GIM_Try, /*On fail goto*//*Label 29514*/ GIMT_Encode4(2170346),
     /* 2170231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2170234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170249 */   GIM_Try, /*On fail goto*//*Label 29515*/ GIMT_Encode4(2170297), // Rule ID 51970 //
     /* 2170254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170257 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2170260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2170274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170296 */     // GIR_Coverage, 51970,
     /* 2170296 */     GIR_EraseRootFromParent_Done,
     /* 2170297 */   // Label 29515: @2170297
     /* 2170297 */   GIM_Try, /*On fail goto*//*Label 29516*/ GIMT_Encode4(2170345), // Rule ID 51971 //
     /* 2170302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170305 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2170308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2170322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170344 */     // GIR_Coverage, 51971,
     /* 2170344 */     GIR_EraseRootFromParent_Done,
     /* 2170345 */   // Label 29516: @2170345
     /* 2170345 */   GIM_Reject,
     /* 2170346 */ // Label 29514: @2170346
     /* 2170346 */ GIM_Reject,
     /* 2170347 */ // Label 29490: @2170347
     /* 2170347 */ GIM_Try, /*On fail goto*//*Label 29517*/ GIMT_Encode4(2170467),
     /* 2170352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2170355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170370 */   GIM_Try, /*On fail goto*//*Label 29518*/ GIMT_Encode4(2170418), // Rule ID 51978 //
     /* 2170375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170378 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2170381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2170395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170417 */     // GIR_Coverage, 51978,
     /* 2170417 */     GIR_EraseRootFromParent_Done,
     /* 2170418 */   // Label 29518: @2170418
     /* 2170418 */   GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2170466), // Rule ID 51979 //
     /* 2170423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170426 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2170429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2170443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170465 */     // GIR_Coverage, 51979,
     /* 2170465 */     GIR_EraseRootFromParent_Done,
     /* 2170466 */   // Label 29519: @2170466
     /* 2170466 */   GIM_Reject,
     /* 2170467 */ // Label 29517: @2170467
     /* 2170467 */ GIM_Reject,
     /* 2170468 */ // Label 29491: @2170468
     /* 2170468 */ GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2170588),
     /* 2170473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2170476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170491 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2170539), // Rule ID 51994 //
     /* 2170496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2170499 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2170502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2170516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170538 */     // GIR_Coverage, 51994,
     /* 2170538 */     GIR_EraseRootFromParent_Done,
     /* 2170539 */   // Label 29521: @2170539
     /* 2170539 */   GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2170587), // Rule ID 51995 //
     /* 2170544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2170547 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2170550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2170564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170586 */     // GIR_Coverage, 51995,
     /* 2170586 */     GIR_EraseRootFromParent_Done,
     /* 2170587 */   // Label 29522: @2170587
     /* 2170587 */   GIM_Reject,
     /* 2170588 */ // Label 29520: @2170588
     /* 2170588 */ GIM_Reject,
     /* 2170589 */ // Label 29492: @2170589
     /* 2170589 */ GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2170709),
     /* 2170594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2170597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2170600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170612 */   GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2170660), // Rule ID 51962 //
     /* 2170617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170620 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2170623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2170637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170659 */     // GIR_Coverage, 51962,
     /* 2170659 */     GIR_EraseRootFromParent_Done,
     /* 2170660 */   // Label 29524: @2170660
     /* 2170660 */   GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2170708), // Rule ID 51963 //
     /* 2170665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170668 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2170671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2170685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170707 */     // GIR_Coverage, 51963,
     /* 2170707 */     GIR_EraseRootFromParent_Done,
     /* 2170708 */   // Label 29525: @2170708
     /* 2170708 */   GIM_Reject,
     /* 2170709 */ // Label 29523: @2170709
     /* 2170709 */ GIM_Reject,
     /* 2170710 */ // Label 29493: @2170710
     /* 2170710 */ GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2170830),
     /* 2170715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2170718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170733 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2170781), // Rule ID 51974 //
     /* 2170738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170741 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2170744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2170758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170780 */     // GIR_Coverage, 51974,
     /* 2170780 */     GIR_EraseRootFromParent_Done,
     /* 2170781 */   // Label 29527: @2170781
     /* 2170781 */   GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2170829), // Rule ID 51975 //
     /* 2170786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170789 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2170792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2170806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170828 */     // GIR_Coverage, 51975,
     /* 2170828 */     GIR_EraseRootFromParent_Done,
     /* 2170829 */   // Label 29528: @2170829
     /* 2170829 */   GIM_Reject,
     /* 2170830 */ // Label 29526: @2170830
     /* 2170830 */ GIM_Reject,
     /* 2170831 */ // Label 29494: @2170831
     /* 2170831 */ GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2170951),
     /* 2170836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2170839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170854 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2170902), // Rule ID 51990 //
     /* 2170859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2170862 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2170865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2170879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170901 */     // GIR_Coverage, 51990,
     /* 2170901 */     GIR_EraseRootFromParent_Done,
     /* 2170902 */   // Label 29530: @2170902
     /* 2170902 */   GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2170950), // Rule ID 51991 //
     /* 2170907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2170910 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2170910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2170913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2170927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2170932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2170934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2170936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2170939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2170945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2170948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170949 */     // GIR_Coverage, 51991,
     /* 2170949 */     GIR_EraseRootFromParent_Done,
     /* 2170950 */   // Label 29531: @2170950
     /* 2170950 */   GIM_Reject,
     /* 2170951 */ // Label 29529: @2170951
     /* 2170951 */ GIM_Reject,
     /* 2170952 */ // Label 29495: @2170952
     /* 2170952 */ GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2171072),
     /* 2170957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2170960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2170963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170975 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2171023), // Rule ID 52034 //
     /* 2170980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2170983 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2170983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2170986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2170990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2170995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2170997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171022 */     // GIR_Coverage, 52034,
     /* 2171022 */     GIR_EraseRootFromParent_Done,
     /* 2171023 */   // Label 29533: @2171023
     /* 2171023 */   GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2171071), // Rule ID 52035 //
     /* 2171028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2171031 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2171034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171070 */     // GIR_Coverage, 52035,
     /* 2171070 */     GIR_EraseRootFromParent_Done,
     /* 2171071 */   // Label 29534: @2171071
     /* 2171071 */   GIM_Reject,
     /* 2171072 */ // Label 29532: @2171072
     /* 2171072 */ GIM_Reject,
     /* 2171073 */ // Label 29496: @2171073
     /* 2171073 */ GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2171193),
     /* 2171078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2171081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2171084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171096 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2171144), // Rule ID 51966 //
     /* 2171101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171104 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2171107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2171121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171143 */     // GIR_Coverage, 51966,
     /* 2171143 */     GIR_EraseRootFromParent_Done,
     /* 2171144 */   // Label 29536: @2171144
     /* 2171144 */   GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2171192), // Rule ID 51967 //
     /* 2171149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171152 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2171155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2171169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171191 */     // GIR_Coverage, 51967,
     /* 2171191 */     GIR_EraseRootFromParent_Done,
     /* 2171192 */   // Label 29537: @2171192
     /* 2171192 */   GIM_Reject,
     /* 2171193 */ // Label 29535: @2171193
     /* 2171193 */ GIM_Reject,
     /* 2171194 */ // Label 29497: @2171194
     /* 2171194 */ GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2171314),
     /* 2171199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2171202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2171205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171217 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2171265), // Rule ID 51986 //
     /* 2171222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171225 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2171228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2171242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171264 */     // GIR_Coverage, 51986,
     /* 2171264 */     GIR_EraseRootFromParent_Done,
     /* 2171265 */   // Label 29539: @2171265
     /* 2171265 */   GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2171313), // Rule ID 51987 //
     /* 2171270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171273 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2171276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2171290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171312 */     // GIR_Coverage, 51987,
     /* 2171312 */     GIR_EraseRootFromParent_Done,
     /* 2171313 */   // Label 29540: @2171313
     /* 2171313 */   GIM_Reject,
     /* 2171314 */ // Label 29538: @2171314
     /* 2171314 */ GIM_Reject,
     /* 2171315 */ // Label 29498: @2171315
     /* 2171315 */ GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2171435),
     /* 2171320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2171323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171338 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2171386), // Rule ID 52022 //
     /* 2171343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171346 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2171349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171385 */     // GIR_Coverage, 52022,
     /* 2171385 */     GIR_EraseRootFromParent_Done,
     /* 2171386 */   // Label 29542: @2171386
     /* 2171386 */   GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2171434), // Rule ID 52023 //
     /* 2171391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171394 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2171397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171433 */     // GIR_Coverage, 52023,
     /* 2171433 */     GIR_EraseRootFromParent_Done,
     /* 2171434 */   // Label 29543: @2171434
     /* 2171434 */   GIM_Reject,
     /* 2171435 */ // Label 29541: @2171435
     /* 2171435 */ GIM_Reject,
     /* 2171436 */ // Label 29499: @2171436
     /* 2171436 */ GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2171556),
     /* 2171441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2171444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2171447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171459 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2171507), // Rule ID 52038 //
     /* 2171464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2171467 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2171470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2171484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171506 */     // GIR_Coverage, 52038,
     /* 2171506 */     GIR_EraseRootFromParent_Done,
     /* 2171507 */   // Label 29545: @2171507
     /* 2171507 */   GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2171555), // Rule ID 52039 //
     /* 2171512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2171515 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2171518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2171532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171554 */     // GIR_Coverage, 52039,
     /* 2171554 */     GIR_EraseRootFromParent_Done,
     /* 2171555 */   // Label 29546: @2171555
     /* 2171555 */   GIM_Reject,
     /* 2171556 */ // Label 29544: @2171556
     /* 2171556 */ GIM_Reject,
     /* 2171557 */ // Label 29500: @2171557
     /* 2171557 */ GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2171677),
     /* 2171562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2171565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2171568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171580 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2171628), // Rule ID 51982 //
     /* 2171585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171588 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2171591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2171605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171627 */     // GIR_Coverage, 51982,
     /* 2171627 */     GIR_EraseRootFromParent_Done,
     /* 2171628 */   // Label 29548: @2171628
     /* 2171628 */   GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2171676), // Rule ID 51983 //
     /* 2171633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171636 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2171639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2171653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171675 */     // GIR_Coverage, 51983,
     /* 2171675 */     GIR_EraseRootFromParent_Done,
     /* 2171676 */   // Label 29549: @2171676
     /* 2171676 */   GIM_Reject,
     /* 2171677 */ // Label 29547: @2171677
     /* 2171677 */ GIM_Reject,
     /* 2171678 */ // Label 29501: @2171678
     /* 2171678 */ GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2171798),
     /* 2171683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2171686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171701 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2171749), // Rule ID 52010 //
     /* 2171706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171709 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2171712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171748 */     // GIR_Coverage, 52010,
     /* 2171748 */     GIR_EraseRootFromParent_Done,
     /* 2171749 */   // Label 29551: @2171749
     /* 2171749 */   GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2171797), // Rule ID 52011 //
     /* 2171754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171757 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2171760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2171774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171796 */     // GIR_Coverage, 52011,
     /* 2171796 */     GIR_EraseRootFromParent_Done,
     /* 2171797 */   // Label 29552: @2171797
     /* 2171797 */   GIM_Reject,
     /* 2171798 */ // Label 29550: @2171798
     /* 2171798 */ GIM_Reject,
     /* 2171799 */ // Label 29502: @2171799
     /* 2171799 */ GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2171919),
     /* 2171804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2171807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171822 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2171870), // Rule ID 52026 //
     /* 2171827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2171830 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2171833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2171847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171869 */     // GIR_Coverage, 52026,
     /* 2171869 */     GIR_EraseRootFromParent_Done,
     /* 2171870 */   // Label 29554: @2171870
     /* 2171870 */   GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2171918), // Rule ID 52027 //
     /* 2171875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2171878 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2171881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2171895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171917 */     // GIR_Coverage, 52027,
     /* 2171917 */     GIR_EraseRootFromParent_Done,
     /* 2171918 */   // Label 29555: @2171918
     /* 2171918 */   GIM_Reject,
     /* 2171919 */ // Label 29553: @2171919
     /* 2171919 */ GIM_Reject,
     /* 2171920 */ // Label 29503: @2171920
     /* 2171920 */ GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2172040),
     /* 2171925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2171928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2171931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171943 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2171991), // Rule ID 52042 //
     /* 2171948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2171951 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2171951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2171954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2171958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2171963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2171965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2171968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2171973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2171975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2171977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2171980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2171986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2171989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171990 */     // GIR_Coverage, 52042,
     /* 2171990 */     GIR_EraseRootFromParent_Done,
     /* 2171991 */   // Label 29557: @2171991
     /* 2171991 */   GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2172039), // Rule ID 52043 //
     /* 2171996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2171999 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2171999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2172002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172038 */     // GIR_Coverage, 52043,
     /* 2172038 */     GIR_EraseRootFromParent_Done,
     /* 2172039 */   // Label 29558: @2172039
     /* 2172039 */   GIM_Reject,
     /* 2172040 */ // Label 29556: @2172040
     /* 2172040 */ GIM_Reject,
     /* 2172041 */ // Label 29504: @2172041
     /* 2172041 */ GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2172161),
     /* 2172046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2172049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2172052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172064 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2172112), // Rule ID 51998 //
     /* 2172069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172072 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2172075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2172089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172111 */     // GIR_Coverage, 51998,
     /* 2172111 */     GIR_EraseRootFromParent_Done,
     /* 2172112 */   // Label 29560: @2172112
     /* 2172112 */   GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2172160), // Rule ID 51999 //
     /* 2172117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172120 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2172123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2172137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172159 */     // GIR_Coverage, 51999,
     /* 2172159 */     GIR_EraseRootFromParent_Done,
     /* 2172160 */   // Label 29561: @2172160
     /* 2172160 */   GIM_Reject,
     /* 2172161 */ // Label 29559: @2172161
     /* 2172161 */ GIM_Reject,
     /* 2172162 */ // Label 29505: @2172162
     /* 2172162 */ GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2172282),
     /* 2172167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2172170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2172173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172185 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2172233), // Rule ID 52014 //
     /* 2172190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172193 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2172196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172232 */     // GIR_Coverage, 52014,
     /* 2172232 */     GIR_EraseRootFromParent_Done,
     /* 2172233 */   // Label 29563: @2172233
     /* 2172233 */   GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2172281), // Rule ID 52015 //
     /* 2172238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172241 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2172244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2172258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172280 */     // GIR_Coverage, 52015,
     /* 2172280 */     GIR_EraseRootFromParent_Done,
     /* 2172281 */   // Label 29564: @2172281
     /* 2172281 */   GIM_Reject,
     /* 2172282 */ // Label 29562: @2172282
     /* 2172282 */ GIM_Reject,
     /* 2172283 */ // Label 29506: @2172283
     /* 2172283 */ GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2172403),
     /* 2172288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2172291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172306 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2172354), // Rule ID 52030 //
     /* 2172311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172314 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2172317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172353 */     // GIR_Coverage, 52030,
     /* 2172353 */     GIR_EraseRootFromParent_Done,
     /* 2172354 */   // Label 29566: @2172354
     /* 2172354 */   GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2172402), // Rule ID 52031 //
     /* 2172359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172362 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2172365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172401 */     // GIR_Coverage, 52031,
     /* 2172401 */     GIR_EraseRootFromParent_Done,
     /* 2172402 */   // Label 29567: @2172402
     /* 2172402 */   GIM_Reject,
     /* 2172403 */ // Label 29565: @2172403
     /* 2172403 */ GIM_Reject,
     /* 2172404 */ // Label 29507: @2172404
     /* 2172404 */ GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2172524),
     /* 2172409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2172412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2172415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172427 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2172475), // Rule ID 52002 //
     /* 2172432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172435 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2172438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2172452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172474 */     // GIR_Coverage, 52002,
     /* 2172474 */     GIR_EraseRootFromParent_Done,
     /* 2172475 */   // Label 29569: @2172475
     /* 2172475 */   GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2172523), // Rule ID 52003 //
     /* 2172480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172483 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2172486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2172500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172522 */     // GIR_Coverage, 52003,
     /* 2172522 */     GIR_EraseRootFromParent_Done,
     /* 2172523 */   // Label 29570: @2172523
     /* 2172523 */   GIM_Reject,
     /* 2172524 */ // Label 29568: @2172524
     /* 2172524 */ GIM_Reject,
     /* 2172525 */ // Label 29508: @2172525
     /* 2172525 */ GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2172645),
     /* 2172530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2172533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2172536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172548 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2172596), // Rule ID 52018 //
     /* 2172553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172556 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2172559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172595 */     // GIR_Coverage, 52018,
     /* 2172595 */     GIR_EraseRootFromParent_Done,
     /* 2172596 */   // Label 29572: @2172596
     /* 2172596 */   GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2172644), // Rule ID 52019 //
     /* 2172601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172604 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2172607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172643 */     // GIR_Coverage, 52019,
     /* 2172643 */     GIR_EraseRootFromParent_Done,
     /* 2172644 */   // Label 29573: @2172644
     /* 2172644 */   GIM_Reject,
     /* 2172645 */ // Label 29571: @2172645
     /* 2172645 */ GIM_Reject,
     /* 2172646 */ // Label 29509: @2172646
     /* 2172646 */ GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2172766),
     /* 2172651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2172654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2172657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172669 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2172717), // Rule ID 52006 //
     /* 2172674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172677 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2172680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172716 */     // GIR_Coverage, 52006,
     /* 2172716 */     GIR_EraseRootFromParent_Done,
     /* 2172717 */   // Label 29575: @2172717
     /* 2172717 */   GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2172765), // Rule ID 52007 //
     /* 2172722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172725 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2172728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2172742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172764 */     // GIR_Coverage, 52007,
     /* 2172764 */     GIR_EraseRootFromParent_Done,
     /* 2172765 */   // Label 29576: @2172765
     /* 2172765 */   GIM_Reject,
     /* 2172766 */ // Label 29574: @2172766
     /* 2172766 */ GIM_Reject,
     /* 2172767 */ // Label 29510: @2172767
     /* 2172767 */ GIM_Reject,
     /* 2172768 */ // Label 54: @2172768
     /* 2172768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29599*/ GIMT_Encode4(2175553),
     /* 2172779 */ /*GILLT_nxv1s8*//*Label 29577*/ GIMT_Encode4(2172891),
     /* 2172783 */ /*GILLT_nxv1s16*//*Label 29578*/ GIMT_Encode4(2173012),
     /* 2172787 */ /*GILLT_nxv1s32*//*Label 29579*/ GIMT_Encode4(2173133),
     /* 2172791 */ /*GILLT_nxv1s64*//*Label 29580*/ GIMT_Encode4(2173254), GIMT_Encode4(0),
     /* 2172799 */ /*GILLT_nxv2s8*//*Label 29581*/ GIMT_Encode4(2173375),
     /* 2172803 */ /*GILLT_nxv2s16*//*Label 29582*/ GIMT_Encode4(2173496),
     /* 2172807 */ /*GILLT_nxv2s32*//*Label 29583*/ GIMT_Encode4(2173617),
     /* 2172811 */ /*GILLT_nxv2s64*//*Label 29584*/ GIMT_Encode4(2173738), GIMT_Encode4(0),
     /* 2172819 */ /*GILLT_nxv4s8*//*Label 29585*/ GIMT_Encode4(2173859),
     /* 2172823 */ /*GILLT_nxv4s16*//*Label 29586*/ GIMT_Encode4(2173980),
     /* 2172827 */ /*GILLT_nxv4s32*//*Label 29587*/ GIMT_Encode4(2174101),
     /* 2172831 */ /*GILLT_nxv4s64*//*Label 29588*/ GIMT_Encode4(2174222), GIMT_Encode4(0),
     /* 2172839 */ /*GILLT_nxv8s8*//*Label 29589*/ GIMT_Encode4(2174343),
     /* 2172843 */ /*GILLT_nxv8s16*//*Label 29590*/ GIMT_Encode4(2174464),
     /* 2172847 */ /*GILLT_nxv8s32*//*Label 29591*/ GIMT_Encode4(2174585),
     /* 2172851 */ /*GILLT_nxv8s64*//*Label 29592*/ GIMT_Encode4(2174706), GIMT_Encode4(0),
     /* 2172859 */ /*GILLT_nxv16s8*//*Label 29593*/ GIMT_Encode4(2174827),
     /* 2172863 */ /*GILLT_nxv16s16*//*Label 29594*/ GIMT_Encode4(2174948),
     /* 2172867 */ /*GILLT_nxv16s32*//*Label 29595*/ GIMT_Encode4(2175069), GIMT_Encode4(0),
     /* 2172875 */ /*GILLT_nxv32s8*//*Label 29596*/ GIMT_Encode4(2175190),
     /* 2172879 */ /*GILLT_nxv32s16*//*Label 29597*/ GIMT_Encode4(2175311), GIMT_Encode4(0),
     /* 2172887 */ /*GILLT_nxv64s8*//*Label 29598*/ GIMT_Encode4(2175432),
     /* 2172891 */ // Label 29577: @2172891
     /* 2172891 */ GIM_Try, /*On fail goto*//*Label 29600*/ GIMT_Encode4(2173011),
     /* 2172896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2172899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2172902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172914 */   GIM_Try, /*On fail goto*//*Label 29601*/ GIMT_Encode4(2172962), // Rule ID 51826 //
     /* 2172919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2172922 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2172922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2172925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2172939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2172957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2172960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172961 */     // GIR_Coverage, 51826,
     /* 2172961 */     GIR_EraseRootFromParent_Done,
     /* 2172962 */   // Label 29601: @2172962
     /* 2172962 */   GIM_Try, /*On fail goto*//*Label 29602*/ GIMT_Encode4(2173010), // Rule ID 51827 //
     /* 2172967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2172970 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2172970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2172973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2172977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2172982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2172984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2172987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2172992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2172994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2172996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2172999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173009 */     // GIR_Coverage, 51827,
     /* 2173009 */     GIR_EraseRootFromParent_Done,
     /* 2173010 */   // Label 29602: @2173010
     /* 2173010 */   GIM_Reject,
     /* 2173011 */ // Label 29600: @2173011
     /* 2173011 */ GIM_Reject,
     /* 2173012 */ // Label 29578: @2173012
     /* 2173012 */ GIM_Try, /*On fail goto*//*Label 29603*/ GIMT_Encode4(2173132),
     /* 2173017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2173020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173035 */   GIM_Try, /*On fail goto*//*Label 29604*/ GIMT_Encode4(2173083), // Rule ID 51838 //
     /* 2173040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173043 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2173046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2173060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173082 */     // GIR_Coverage, 51838,
     /* 2173082 */     GIR_EraseRootFromParent_Done,
     /* 2173083 */   // Label 29604: @2173083
     /* 2173083 */   GIM_Try, /*On fail goto*//*Label 29605*/ GIMT_Encode4(2173131), // Rule ID 51839 //
     /* 2173088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173091 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2173094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2173108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173130 */     // GIR_Coverage, 51839,
     /* 2173130 */     GIR_EraseRootFromParent_Done,
     /* 2173131 */   // Label 29605: @2173131
     /* 2173131 */   GIM_Reject,
     /* 2173132 */ // Label 29603: @2173132
     /* 2173132 */ GIM_Reject,
     /* 2173133 */ // Label 29579: @2173133
     /* 2173133 */ GIM_Try, /*On fail goto*//*Label 29606*/ GIMT_Encode4(2173253),
     /* 2173138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2173141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173156 */   GIM_Try, /*On fail goto*//*Label 29607*/ GIMT_Encode4(2173204), // Rule ID 51846 //
     /* 2173161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173164 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2173167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173203 */     // GIR_Coverage, 51846,
     /* 2173203 */     GIR_EraseRootFromParent_Done,
     /* 2173204 */   // Label 29607: @2173204
     /* 2173204 */   GIM_Try, /*On fail goto*//*Label 29608*/ GIMT_Encode4(2173252), // Rule ID 51847 //
     /* 2173209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173212 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2173215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173251 */     // GIR_Coverage, 51847,
     /* 2173251 */     GIR_EraseRootFromParent_Done,
     /* 2173252 */   // Label 29608: @2173252
     /* 2173252 */   GIM_Reject,
     /* 2173253 */ // Label 29606: @2173253
     /* 2173253 */ GIM_Reject,
     /* 2173254 */ // Label 29580: @2173254
     /* 2173254 */ GIM_Try, /*On fail goto*//*Label 29609*/ GIMT_Encode4(2173374),
     /* 2173259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2173262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173277 */   GIM_Try, /*On fail goto*//*Label 29610*/ GIMT_Encode4(2173325), // Rule ID 51862 //
     /* 2173282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2173285 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2173288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2173302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173324 */     // GIR_Coverage, 51862,
     /* 2173324 */     GIR_EraseRootFromParent_Done,
     /* 2173325 */   // Label 29610: @2173325
     /* 2173325 */   GIM_Try, /*On fail goto*//*Label 29611*/ GIMT_Encode4(2173373), // Rule ID 51863 //
     /* 2173330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2173333 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2173336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2173350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173372 */     // GIR_Coverage, 51863,
     /* 2173372 */     GIR_EraseRootFromParent_Done,
     /* 2173373 */   // Label 29611: @2173373
     /* 2173373 */   GIM_Reject,
     /* 2173374 */ // Label 29609: @2173374
     /* 2173374 */ GIM_Reject,
     /* 2173375 */ // Label 29581: @2173375
     /* 2173375 */ GIM_Try, /*On fail goto*//*Label 29612*/ GIMT_Encode4(2173495),
     /* 2173380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2173383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2173386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173398 */   GIM_Try, /*On fail goto*//*Label 29613*/ GIMT_Encode4(2173446), // Rule ID 51830 //
     /* 2173403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173406 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2173409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2173423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173445 */     // GIR_Coverage, 51830,
     /* 2173445 */     GIR_EraseRootFromParent_Done,
     /* 2173446 */   // Label 29613: @2173446
     /* 2173446 */   GIM_Try, /*On fail goto*//*Label 29614*/ GIMT_Encode4(2173494), // Rule ID 51831 //
     /* 2173451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173454 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2173457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2173471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173493 */     // GIR_Coverage, 51831,
     /* 2173493 */     GIR_EraseRootFromParent_Done,
     /* 2173494 */   // Label 29614: @2173494
     /* 2173494 */   GIM_Reject,
     /* 2173495 */ // Label 29612: @2173495
     /* 2173495 */ GIM_Reject,
     /* 2173496 */ // Label 29582: @2173496
     /* 2173496 */ GIM_Try, /*On fail goto*//*Label 29615*/ GIMT_Encode4(2173616),
     /* 2173501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2173504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173519 */   GIM_Try, /*On fail goto*//*Label 29616*/ GIMT_Encode4(2173567), // Rule ID 51842 //
     /* 2173524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173527 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2173530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173566 */     // GIR_Coverage, 51842,
     /* 2173566 */     GIR_EraseRootFromParent_Done,
     /* 2173567 */   // Label 29616: @2173567
     /* 2173567 */   GIM_Try, /*On fail goto*//*Label 29617*/ GIMT_Encode4(2173615), // Rule ID 51843 //
     /* 2173572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173575 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2173578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173614 */     // GIR_Coverage, 51843,
     /* 2173614 */     GIR_EraseRootFromParent_Done,
     /* 2173615 */   // Label 29617: @2173615
     /* 2173615 */   GIM_Reject,
     /* 2173616 */ // Label 29615: @2173616
     /* 2173616 */ GIM_Reject,
     /* 2173617 */ // Label 29583: @2173617
     /* 2173617 */ GIM_Try, /*On fail goto*//*Label 29618*/ GIMT_Encode4(2173737),
     /* 2173622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2173625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173640 */   GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2173688), // Rule ID 51858 //
     /* 2173645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173648 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2173651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2173665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173687 */     // GIR_Coverage, 51858,
     /* 2173687 */     GIR_EraseRootFromParent_Done,
     /* 2173688 */   // Label 29619: @2173688
     /* 2173688 */   GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2173736), // Rule ID 51859 //
     /* 2173693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173696 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2173699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2173713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173735 */     // GIR_Coverage, 51859,
     /* 2173735 */     GIR_EraseRootFromParent_Done,
     /* 2173736 */   // Label 29620: @2173736
     /* 2173736 */   GIM_Reject,
     /* 2173737 */ // Label 29618: @2173737
     /* 2173737 */ GIM_Reject,
     /* 2173738 */ // Label 29584: @2173738
     /* 2173738 */ GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2173858),
     /* 2173743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2173746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2173749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173761 */   GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2173809), // Rule ID 51902 //
     /* 2173766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2173769 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2173772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2173786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173808 */     // GIR_Coverage, 51902,
     /* 2173808 */     GIR_EraseRootFromParent_Done,
     /* 2173809 */   // Label 29622: @2173809
     /* 2173809 */   GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2173857), // Rule ID 51903 //
     /* 2173814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2173817 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2173820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2173834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173856 */     // GIR_Coverage, 51903,
     /* 2173856 */     GIR_EraseRootFromParent_Done,
     /* 2173857 */   // Label 29623: @2173857
     /* 2173857 */   GIM_Reject,
     /* 2173858 */ // Label 29621: @2173858
     /* 2173858 */ GIM_Reject,
     /* 2173859 */ // Label 29585: @2173859
     /* 2173859 */ GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2173979),
     /* 2173864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2173867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2173870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173882 */   GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2173930), // Rule ID 51834 //
     /* 2173887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2173890 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2173890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2173893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173929 */     // GIR_Coverage, 51834,
     /* 2173929 */     GIR_EraseRootFromParent_Done,
     /* 2173930 */   // Label 29625: @2173930
     /* 2173930 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2173978), // Rule ID 51835 //
     /* 2173935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2173938 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2173938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2173941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2173945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2173950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2173952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2173955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2173960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2173962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2173964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2173967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2173973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2173976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173977 */     // GIR_Coverage, 51835,
     /* 2173977 */     GIR_EraseRootFromParent_Done,
     /* 2173978 */   // Label 29626: @2173978
     /* 2173978 */   GIM_Reject,
     /* 2173979 */ // Label 29624: @2173979
     /* 2173979 */ GIM_Reject,
     /* 2173980 */ // Label 29586: @2173980
     /* 2173980 */ GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2174100),
     /* 2173985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2173988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174003 */   GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2174051), // Rule ID 51854 //
     /* 2174008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174011 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2174014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2174028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174050 */     // GIR_Coverage, 51854,
     /* 2174050 */     GIR_EraseRootFromParent_Done,
     /* 2174051 */   // Label 29628: @2174051
     /* 2174051 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2174099), // Rule ID 51855 //
     /* 2174056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174059 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2174062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2174076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174098 */     // GIR_Coverage, 51855,
     /* 2174098 */     GIR_EraseRootFromParent_Done,
     /* 2174099 */   // Label 29629: @2174099
     /* 2174099 */   GIM_Reject,
     /* 2174100 */ // Label 29627: @2174100
     /* 2174100 */ GIM_Reject,
     /* 2174101 */ // Label 29587: @2174101
     /* 2174101 */ GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2174221),
     /* 2174106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2174109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174124 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2174172), // Rule ID 51890 //
     /* 2174129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174132 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2174135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174171 */     // GIR_Coverage, 51890,
     /* 2174171 */     GIR_EraseRootFromParent_Done,
     /* 2174172 */   // Label 29631: @2174172
     /* 2174172 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2174220), // Rule ID 51891 //
     /* 2174177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174180 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2174183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174219 */     // GIR_Coverage, 51891,
     /* 2174219 */     GIR_EraseRootFromParent_Done,
     /* 2174220 */   // Label 29632: @2174220
     /* 2174220 */   GIM_Reject,
     /* 2174221 */ // Label 29630: @2174221
     /* 2174221 */ GIM_Reject,
     /* 2174222 */ // Label 29588: @2174222
     /* 2174222 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2174342),
     /* 2174227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2174230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174245 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2174293), // Rule ID 51906 //
     /* 2174250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2174253 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2174256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2174270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174292 */     // GIR_Coverage, 51906,
     /* 2174292 */     GIR_EraseRootFromParent_Done,
     /* 2174293 */   // Label 29634: @2174293
     /* 2174293 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2174341), // Rule ID 51907 //
     /* 2174298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2174301 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2174304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2174318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174340 */     // GIR_Coverage, 51907,
     /* 2174340 */     GIR_EraseRootFromParent_Done,
     /* 2174341 */   // Label 29635: @2174341
     /* 2174341 */   GIM_Reject,
     /* 2174342 */ // Label 29633: @2174342
     /* 2174342 */ GIM_Reject,
     /* 2174343 */ // Label 29589: @2174343
     /* 2174343 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2174463),
     /* 2174348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2174351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2174354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174366 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2174414), // Rule ID 51850 //
     /* 2174371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174374 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2174377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2174391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174413 */     // GIR_Coverage, 51850,
     /* 2174413 */     GIR_EraseRootFromParent_Done,
     /* 2174414 */   // Label 29637: @2174414
     /* 2174414 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2174462), // Rule ID 51851 //
     /* 2174419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174422 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2174425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2174439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174461 */     // GIR_Coverage, 51851,
     /* 2174461 */     GIR_EraseRootFromParent_Done,
     /* 2174462 */   // Label 29638: @2174462
     /* 2174462 */   GIM_Reject,
     /* 2174463 */ // Label 29636: @2174463
     /* 2174463 */ GIM_Reject,
     /* 2174464 */ // Label 29590: @2174464
     /* 2174464 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2174584),
     /* 2174469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2174472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174487 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2174535), // Rule ID 51878 //
     /* 2174492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174495 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2174498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174534 */     // GIR_Coverage, 51878,
     /* 2174534 */     GIR_EraseRootFromParent_Done,
     /* 2174535 */   // Label 29640: @2174535
     /* 2174535 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2174583), // Rule ID 51879 //
     /* 2174540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174543 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2174546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174582 */     // GIR_Coverage, 51879,
     /* 2174582 */     GIR_EraseRootFromParent_Done,
     /* 2174583 */   // Label 29641: @2174583
     /* 2174583 */   GIM_Reject,
     /* 2174584 */ // Label 29639: @2174584
     /* 2174584 */ GIM_Reject,
     /* 2174585 */ // Label 29591: @2174585
     /* 2174585 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2174705),
     /* 2174590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2174593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174608 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2174656), // Rule ID 51894 //
     /* 2174613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174616 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2174619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2174633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174655 */     // GIR_Coverage, 51894,
     /* 2174655 */     GIR_EraseRootFromParent_Done,
     /* 2174656 */   // Label 29643: @2174656
     /* 2174656 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2174704), // Rule ID 51895 //
     /* 2174661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174664 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2174667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2174681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174703 */     // GIR_Coverage, 51895,
     /* 2174703 */     GIR_EraseRootFromParent_Done,
     /* 2174704 */   // Label 29644: @2174704
     /* 2174704 */   GIM_Reject,
     /* 2174705 */ // Label 29642: @2174705
     /* 2174705 */ GIM_Reject,
     /* 2174706 */ // Label 29592: @2174706
     /* 2174706 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2174826),
     /* 2174711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2174714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2174717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174729 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2174777), // Rule ID 51910 //
     /* 2174734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2174737 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2174740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2174754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174776 */     // GIR_Coverage, 51910,
     /* 2174776 */     GIR_EraseRootFromParent_Done,
     /* 2174777 */   // Label 29646: @2174777
     /* 2174777 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2174825), // Rule ID 51911 //
     /* 2174782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2174785 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2174788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2174802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174824 */     // GIR_Coverage, 51911,
     /* 2174824 */     GIR_EraseRootFromParent_Done,
     /* 2174825 */   // Label 29647: @2174825
     /* 2174825 */   GIM_Reject,
     /* 2174826 */ // Label 29645: @2174826
     /* 2174826 */ GIM_Reject,
     /* 2174827 */ // Label 29593: @2174827
     /* 2174827 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2174947),
     /* 2174832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2174835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2174838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174850 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2174898), // Rule ID 51866 //
     /* 2174855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174858 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2174861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174897 */     // GIR_Coverage, 51866,
     /* 2174897 */     GIR_EraseRootFromParent_Done,
     /* 2174898 */   // Label 29649: @2174898
     /* 2174898 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2174946), // Rule ID 51867 //
     /* 2174903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2174906 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2174906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2174909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2174923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2174928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2174930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2174932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2174935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2174941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2174944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174945 */     // GIR_Coverage, 51867,
     /* 2174945 */     GIR_EraseRootFromParent_Done,
     /* 2174946 */   // Label 29650: @2174946
     /* 2174946 */   GIM_Reject,
     /* 2174947 */ // Label 29648: @2174947
     /* 2174947 */ GIM_Reject,
     /* 2174948 */ // Label 29594: @2174948
     /* 2174948 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2175068),
     /* 2174953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2174956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174971 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2175019), // Rule ID 51882 //
     /* 2174976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2174979 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2174979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2174982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2174986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2174991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2174993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2174996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175018 */     // GIR_Coverage, 51882,
     /* 2175018 */     GIR_EraseRootFromParent_Done,
     /* 2175019 */   // Label 29652: @2175019
     /* 2175019 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2175067), // Rule ID 51883 //
     /* 2175024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175027 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2175030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2175044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175066 */     // GIR_Coverage, 51883,
     /* 2175066 */     GIR_EraseRootFromParent_Done,
     /* 2175067 */   // Label 29653: @2175067
     /* 2175067 */   GIM_Reject,
     /* 2175068 */ // Label 29651: @2175068
     /* 2175068 */ GIM_Reject,
     /* 2175069 */ // Label 29595: @2175069
     /* 2175069 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2175189),
     /* 2175074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2175077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175092 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2175140), // Rule ID 51898 //
     /* 2175097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175100 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2175103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175139 */     // GIR_Coverage, 51898,
     /* 2175139 */     GIR_EraseRootFromParent_Done,
     /* 2175140 */   // Label 29655: @2175140
     /* 2175140 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2175188), // Rule ID 51899 //
     /* 2175145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175148 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2175151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175187 */     // GIR_Coverage, 51899,
     /* 2175187 */     GIR_EraseRootFromParent_Done,
     /* 2175188 */   // Label 29656: @2175188
     /* 2175188 */   GIM_Reject,
     /* 2175189 */ // Label 29654: @2175189
     /* 2175189 */ GIM_Reject,
     /* 2175190 */ // Label 29596: @2175190
     /* 2175190 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2175310),
     /* 2175195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2175198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2175201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175213 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2175261), // Rule ID 51870 //
     /* 2175218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175221 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2175224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2175238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175260 */     // GIR_Coverage, 51870,
     /* 2175260 */     GIR_EraseRootFromParent_Done,
     /* 2175261 */   // Label 29658: @2175261
     /* 2175261 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2175309), // Rule ID 51871 //
     /* 2175266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175269 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2175272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2175286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175308 */     // GIR_Coverage, 51871,
     /* 2175308 */     GIR_EraseRootFromParent_Done,
     /* 2175309 */   // Label 29659: @2175309
     /* 2175309 */   GIM_Reject,
     /* 2175310 */ // Label 29657: @2175310
     /* 2175310 */ GIM_Reject,
     /* 2175311 */ // Label 29597: @2175311
     /* 2175311 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2175431),
     /* 2175316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2175319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2175322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175334 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2175382), // Rule ID 51886 //
     /* 2175339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175342 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2175345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175381 */     // GIR_Coverage, 51886,
     /* 2175381 */     GIR_EraseRootFromParent_Done,
     /* 2175382 */   // Label 29661: @2175382
     /* 2175382 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2175430), // Rule ID 51887 //
     /* 2175387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175390 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2175393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175429 */     // GIR_Coverage, 51887,
     /* 2175429 */     GIR_EraseRootFromParent_Done,
     /* 2175430 */   // Label 29662: @2175430
     /* 2175430 */   GIM_Reject,
     /* 2175431 */ // Label 29660: @2175431
     /* 2175431 */ GIM_Reject,
     /* 2175432 */ // Label 29598: @2175432
     /* 2175432 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2175552),
     /* 2175437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2175440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2175443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175455 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2175503), // Rule ID 51874 //
     /* 2175460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175463 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2175466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175502 */     // GIR_Coverage, 51874,
     /* 2175502 */     GIR_EraseRootFromParent_Done,
     /* 2175503 */   // Label 29664: @2175503
     /* 2175503 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2175551), // Rule ID 51875 //
     /* 2175508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175511 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2175514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2175528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175550 */     // GIR_Coverage, 51875,
     /* 2175550 */     GIR_EraseRootFromParent_Done,
     /* 2175551 */   // Label 29665: @2175551
     /* 2175551 */   GIM_Reject,
     /* 2175552 */ // Label 29663: @2175552
     /* 2175552 */ GIM_Reject,
     /* 2175553 */ // Label 29599: @2175553
     /* 2175553 */ GIM_Reject,
     /* 2175554 */ // Label 55: @2175554
     /* 2175554 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29688*/ GIMT_Encode4(2178339),
     /* 2175565 */ /*GILLT_nxv1s8*//*Label 29666*/ GIMT_Encode4(2175677),
     /* 2175569 */ /*GILLT_nxv1s16*//*Label 29667*/ GIMT_Encode4(2175798),
     /* 2175573 */ /*GILLT_nxv1s32*//*Label 29668*/ GIMT_Encode4(2175919),
     /* 2175577 */ /*GILLT_nxv1s64*//*Label 29669*/ GIMT_Encode4(2176040), GIMT_Encode4(0),
     /* 2175585 */ /*GILLT_nxv2s8*//*Label 29670*/ GIMT_Encode4(2176161),
     /* 2175589 */ /*GILLT_nxv2s16*//*Label 29671*/ GIMT_Encode4(2176282),
     /* 2175593 */ /*GILLT_nxv2s32*//*Label 29672*/ GIMT_Encode4(2176403),
     /* 2175597 */ /*GILLT_nxv2s64*//*Label 29673*/ GIMT_Encode4(2176524), GIMT_Encode4(0),
     /* 2175605 */ /*GILLT_nxv4s8*//*Label 29674*/ GIMT_Encode4(2176645),
     /* 2175609 */ /*GILLT_nxv4s16*//*Label 29675*/ GIMT_Encode4(2176766),
     /* 2175613 */ /*GILLT_nxv4s32*//*Label 29676*/ GIMT_Encode4(2176887),
     /* 2175617 */ /*GILLT_nxv4s64*//*Label 29677*/ GIMT_Encode4(2177008), GIMT_Encode4(0),
     /* 2175625 */ /*GILLT_nxv8s8*//*Label 29678*/ GIMT_Encode4(2177129),
     /* 2175629 */ /*GILLT_nxv8s16*//*Label 29679*/ GIMT_Encode4(2177250),
     /* 2175633 */ /*GILLT_nxv8s32*//*Label 29680*/ GIMT_Encode4(2177371),
     /* 2175637 */ /*GILLT_nxv8s64*//*Label 29681*/ GIMT_Encode4(2177492), GIMT_Encode4(0),
     /* 2175645 */ /*GILLT_nxv16s8*//*Label 29682*/ GIMT_Encode4(2177613),
     /* 2175649 */ /*GILLT_nxv16s16*//*Label 29683*/ GIMT_Encode4(2177734),
     /* 2175653 */ /*GILLT_nxv16s32*//*Label 29684*/ GIMT_Encode4(2177855), GIMT_Encode4(0),
     /* 2175661 */ /*GILLT_nxv32s8*//*Label 29685*/ GIMT_Encode4(2177976),
     /* 2175665 */ /*GILLT_nxv32s16*//*Label 29686*/ GIMT_Encode4(2178097), GIMT_Encode4(0),
     /* 2175673 */ /*GILLT_nxv64s8*//*Label 29687*/ GIMT_Encode4(2178218),
     /* 2175677 */ // Label 29666: @2175677
     /* 2175677 */ GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2175797),
     /* 2175682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2175685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2175688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175700 */   GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2175748), // Rule ID 52178 //
     /* 2175705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175708 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2175711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2175725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175747 */     // GIR_Coverage, 52178,
     /* 2175747 */     GIR_EraseRootFromParent_Done,
     /* 2175748 */   // Label 29690: @2175748
     /* 2175748 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2175796), // Rule ID 52179 //
     /* 2175753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175756 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2175759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2175773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175795 */     // GIR_Coverage, 52179,
     /* 2175795 */     GIR_EraseRootFromParent_Done,
     /* 2175796 */   // Label 29691: @2175796
     /* 2175796 */   GIM_Reject,
     /* 2175797 */ // Label 29689: @2175797
     /* 2175797 */ GIM_Reject,
     /* 2175798 */ // Label 29667: @2175798
     /* 2175798 */ GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2175918),
     /* 2175803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2175806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175821 */   GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2175869), // Rule ID 52190 //
     /* 2175826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175829 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2175832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2175846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175868 */     // GIR_Coverage, 52190,
     /* 2175868 */     GIR_EraseRootFromParent_Done,
     /* 2175869 */   // Label 29693: @2175869
     /* 2175869 */   GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2175917), // Rule ID 52191 //
     /* 2175874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175877 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2175880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2175894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175916 */     // GIR_Coverage, 52191,
     /* 2175916 */     GIR_EraseRootFromParent_Done,
     /* 2175917 */   // Label 29694: @2175917
     /* 2175917 */   GIM_Reject,
     /* 2175918 */ // Label 29692: @2175918
     /* 2175918 */ GIM_Reject,
     /* 2175919 */ // Label 29668: @2175919
     /* 2175919 */ GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2176039),
     /* 2175924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2175927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175942 */   GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2175990), // Rule ID 52198 //
     /* 2175947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2175950 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2175950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2175953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2175957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2175962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2175964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2175967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2175972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2175974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2175976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2175979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2175985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2175988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175989 */     // GIR_Coverage, 52198,
     /* 2175989 */     GIR_EraseRootFromParent_Done,
     /* 2175990 */   // Label 29696: @2175990
     /* 2175990 */   GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2176038), // Rule ID 52199 //
     /* 2175995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2175998 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2175998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2176001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2176015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176037 */     // GIR_Coverage, 52199,
     /* 2176037 */     GIR_EraseRootFromParent_Done,
     /* 2176038 */   // Label 29697: @2176038
     /* 2176038 */   GIM_Reject,
     /* 2176039 */ // Label 29695: @2176039
     /* 2176039 */ GIM_Reject,
     /* 2176040 */ // Label 29669: @2176040
     /* 2176040 */ GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2176160),
     /* 2176045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2176048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176063 */   GIM_Try, /*On fail goto*//*Label 29699*/ GIMT_Encode4(2176111), // Rule ID 52214 //
     /* 2176068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2176071 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2176074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176110 */     // GIR_Coverage, 52214,
     /* 2176110 */     GIR_EraseRootFromParent_Done,
     /* 2176111 */   // Label 29699: @2176111
     /* 2176111 */   GIM_Try, /*On fail goto*//*Label 29700*/ GIMT_Encode4(2176159), // Rule ID 52215 //
     /* 2176116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2176119 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2176122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176158 */     // GIR_Coverage, 52215,
     /* 2176158 */     GIR_EraseRootFromParent_Done,
     /* 2176159 */   // Label 29700: @2176159
     /* 2176159 */   GIM_Reject,
     /* 2176160 */ // Label 29698: @2176160
     /* 2176160 */ GIM_Reject,
     /* 2176161 */ // Label 29670: @2176161
     /* 2176161 */ GIM_Try, /*On fail goto*//*Label 29701*/ GIMT_Encode4(2176281),
     /* 2176166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2176169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2176172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176184 */   GIM_Try, /*On fail goto*//*Label 29702*/ GIMT_Encode4(2176232), // Rule ID 52182 //
     /* 2176189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176192 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2176195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2176209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176231 */     // GIR_Coverage, 52182,
     /* 2176231 */     GIR_EraseRootFromParent_Done,
     /* 2176232 */   // Label 29702: @2176232
     /* 2176232 */   GIM_Try, /*On fail goto*//*Label 29703*/ GIMT_Encode4(2176280), // Rule ID 52183 //
     /* 2176237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176240 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2176243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2176257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176279 */     // GIR_Coverage, 52183,
     /* 2176279 */     GIR_EraseRootFromParent_Done,
     /* 2176280 */   // Label 29703: @2176280
     /* 2176280 */   GIM_Reject,
     /* 2176281 */ // Label 29701: @2176281
     /* 2176281 */ GIM_Reject,
     /* 2176282 */ // Label 29671: @2176282
     /* 2176282 */ GIM_Try, /*On fail goto*//*Label 29704*/ GIMT_Encode4(2176402),
     /* 2176287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2176290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2176293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176305 */   GIM_Try, /*On fail goto*//*Label 29705*/ GIMT_Encode4(2176353), // Rule ID 52194 //
     /* 2176310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176313 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2176316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2176330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176352 */     // GIR_Coverage, 52194,
     /* 2176352 */     GIR_EraseRootFromParent_Done,
     /* 2176353 */   // Label 29705: @2176353
     /* 2176353 */   GIM_Try, /*On fail goto*//*Label 29706*/ GIMT_Encode4(2176401), // Rule ID 52195 //
     /* 2176358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176361 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2176364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2176378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176400 */     // GIR_Coverage, 52195,
     /* 2176400 */     GIR_EraseRootFromParent_Done,
     /* 2176401 */   // Label 29706: @2176401
     /* 2176401 */   GIM_Reject,
     /* 2176402 */ // Label 29704: @2176402
     /* 2176402 */ GIM_Reject,
     /* 2176403 */ // Label 29672: @2176403
     /* 2176403 */ GIM_Try, /*On fail goto*//*Label 29707*/ GIMT_Encode4(2176523),
     /* 2176408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2176411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176426 */   GIM_Try, /*On fail goto*//*Label 29708*/ GIMT_Encode4(2176474), // Rule ID 52210 //
     /* 2176431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176434 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2176437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176473 */     // GIR_Coverage, 52210,
     /* 2176473 */     GIR_EraseRootFromParent_Done,
     /* 2176474 */   // Label 29708: @2176474
     /* 2176474 */   GIM_Try, /*On fail goto*//*Label 29709*/ GIMT_Encode4(2176522), // Rule ID 52211 //
     /* 2176479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176482 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2176485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176521 */     // GIR_Coverage, 52211,
     /* 2176521 */     GIR_EraseRootFromParent_Done,
     /* 2176522 */   // Label 29709: @2176522
     /* 2176522 */   GIM_Reject,
     /* 2176523 */ // Label 29707: @2176523
     /* 2176523 */ GIM_Reject,
     /* 2176524 */ // Label 29673: @2176524
     /* 2176524 */ GIM_Try, /*On fail goto*//*Label 29710*/ GIMT_Encode4(2176644),
     /* 2176529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2176532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2176535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176547 */   GIM_Try, /*On fail goto*//*Label 29711*/ GIMT_Encode4(2176595), // Rule ID 52254 //
     /* 2176552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2176555 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2176558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2176572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176594 */     // GIR_Coverage, 52254,
     /* 2176594 */     GIR_EraseRootFromParent_Done,
     /* 2176595 */   // Label 29711: @2176595
     /* 2176595 */   GIM_Try, /*On fail goto*//*Label 29712*/ GIMT_Encode4(2176643), // Rule ID 52255 //
     /* 2176600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2176603 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2176606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2176620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176642 */     // GIR_Coverage, 52255,
     /* 2176642 */     GIR_EraseRootFromParent_Done,
     /* 2176643 */   // Label 29712: @2176643
     /* 2176643 */   GIM_Reject,
     /* 2176644 */ // Label 29710: @2176644
     /* 2176644 */ GIM_Reject,
     /* 2176645 */ // Label 29674: @2176645
     /* 2176645 */ GIM_Try, /*On fail goto*//*Label 29713*/ GIMT_Encode4(2176765),
     /* 2176650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2176653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2176656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176668 */   GIM_Try, /*On fail goto*//*Label 29714*/ GIMT_Encode4(2176716), // Rule ID 52186 //
     /* 2176673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176676 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2176679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2176693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176715 */     // GIR_Coverage, 52186,
     /* 2176715 */     GIR_EraseRootFromParent_Done,
     /* 2176716 */   // Label 29714: @2176716
     /* 2176716 */   GIM_Try, /*On fail goto*//*Label 29715*/ GIMT_Encode4(2176764), // Rule ID 52187 //
     /* 2176721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176724 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2176727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2176741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176763 */     // GIR_Coverage, 52187,
     /* 2176763 */     GIR_EraseRootFromParent_Done,
     /* 2176764 */   // Label 29715: @2176764
     /* 2176764 */   GIM_Reject,
     /* 2176765 */ // Label 29713: @2176765
     /* 2176765 */ GIM_Reject,
     /* 2176766 */ // Label 29675: @2176766
     /* 2176766 */ GIM_Try, /*On fail goto*//*Label 29716*/ GIMT_Encode4(2176886),
     /* 2176771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2176774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176789 */   GIM_Try, /*On fail goto*//*Label 29717*/ GIMT_Encode4(2176837), // Rule ID 52206 //
     /* 2176794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176797 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2176800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176836 */     // GIR_Coverage, 52206,
     /* 2176836 */     GIR_EraseRootFromParent_Done,
     /* 2176837 */   // Label 29717: @2176837
     /* 2176837 */   GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2176885), // Rule ID 52207 //
     /* 2176842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176845 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2176848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2176862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176884 */     // GIR_Coverage, 52207,
     /* 2176884 */     GIR_EraseRootFromParent_Done,
     /* 2176885 */   // Label 29718: @2176885
     /* 2176885 */   GIM_Reject,
     /* 2176886 */ // Label 29716: @2176886
     /* 2176886 */ GIM_Reject,
     /* 2176887 */ // Label 29676: @2176887
     /* 2176887 */ GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2177007),
     /* 2176892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2176895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176910 */   GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2176958), // Rule ID 52242 //
     /* 2176915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2176918 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2176918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2176921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2176935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2176953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2176956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176957 */     // GIR_Coverage, 52242,
     /* 2176957 */     GIR_EraseRootFromParent_Done,
     /* 2176958 */   // Label 29720: @2176958
     /* 2176958 */   GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2177006), // Rule ID 52243 //
     /* 2176963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2176966 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2176966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2176969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2176973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2176978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2176980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2176983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2176988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2176990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2176992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2176995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177005 */     // GIR_Coverage, 52243,
     /* 2177005 */     GIR_EraseRootFromParent_Done,
     /* 2177006 */   // Label 29721: @2177006
     /* 2177006 */   GIM_Reject,
     /* 2177007 */ // Label 29719: @2177007
     /* 2177007 */ GIM_Reject,
     /* 2177008 */ // Label 29677: @2177008
     /* 2177008 */ GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2177128),
     /* 2177013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2177016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177031 */   GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2177079), // Rule ID 52258 //
     /* 2177036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2177039 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2177042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177078 */     // GIR_Coverage, 52258,
     /* 2177078 */     GIR_EraseRootFromParent_Done,
     /* 2177079 */   // Label 29723: @2177079
     /* 2177079 */   GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2177127), // Rule ID 52259 //
     /* 2177084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2177087 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2177090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177126 */     // GIR_Coverage, 52259,
     /* 2177126 */     GIR_EraseRootFromParent_Done,
     /* 2177127 */   // Label 29724: @2177127
     /* 2177127 */   GIM_Reject,
     /* 2177128 */ // Label 29722: @2177128
     /* 2177128 */ GIM_Reject,
     /* 2177129 */ // Label 29678: @2177129
     /* 2177129 */ GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2177249),
     /* 2177134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2177137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2177140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177152 */   GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2177200), // Rule ID 52202 //
     /* 2177157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177160 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2177163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2177177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177199 */     // GIR_Coverage, 52202,
     /* 2177199 */     GIR_EraseRootFromParent_Done,
     /* 2177200 */   // Label 29726: @2177200
     /* 2177200 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2177248), // Rule ID 52203 //
     /* 2177205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177208 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2177211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2177225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177247 */     // GIR_Coverage, 52203,
     /* 2177247 */     GIR_EraseRootFromParent_Done,
     /* 2177248 */   // Label 29727: @2177248
     /* 2177248 */   GIM_Reject,
     /* 2177249 */ // Label 29725: @2177249
     /* 2177249 */ GIM_Reject,
     /* 2177250 */ // Label 29679: @2177250
     /* 2177250 */ GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2177370),
     /* 2177255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2177258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2177261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177273 */   GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2177321), // Rule ID 52230 //
     /* 2177278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177281 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2177284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2177298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177320 */     // GIR_Coverage, 52230,
     /* 2177320 */     GIR_EraseRootFromParent_Done,
     /* 2177321 */   // Label 29729: @2177321
     /* 2177321 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2177369), // Rule ID 52231 //
     /* 2177326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177329 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2177332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2177346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177368 */     // GIR_Coverage, 52231,
     /* 2177368 */     GIR_EraseRootFromParent_Done,
     /* 2177369 */   // Label 29730: @2177369
     /* 2177369 */   GIM_Reject,
     /* 2177370 */ // Label 29728: @2177370
     /* 2177370 */ GIM_Reject,
     /* 2177371 */ // Label 29680: @2177371
     /* 2177371 */ GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2177491),
     /* 2177376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2177379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177394 */   GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2177442), // Rule ID 52246 //
     /* 2177399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177402 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2177405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177441 */     // GIR_Coverage, 52246,
     /* 2177441 */     GIR_EraseRootFromParent_Done,
     /* 2177442 */   // Label 29732: @2177442
     /* 2177442 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2177490), // Rule ID 52247 //
     /* 2177447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177450 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2177453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177489 */     // GIR_Coverage, 52247,
     /* 2177489 */     GIR_EraseRootFromParent_Done,
     /* 2177490 */   // Label 29733: @2177490
     /* 2177490 */   GIM_Reject,
     /* 2177491 */ // Label 29731: @2177491
     /* 2177491 */ GIM_Reject,
     /* 2177492 */ // Label 29681: @2177492
     /* 2177492 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2177612),
     /* 2177497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2177500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177515 */   GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2177563), // Rule ID 52262 //
     /* 2177520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2177523 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2177526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2177540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177562 */     // GIR_Coverage, 52262,
     /* 2177562 */     GIR_EraseRootFromParent_Done,
     /* 2177563 */   // Label 29735: @2177563
     /* 2177563 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2177611), // Rule ID 52263 //
     /* 2177568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2177571 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2177574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2177588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177610 */     // GIR_Coverage, 52263,
     /* 2177610 */     GIR_EraseRootFromParent_Done,
     /* 2177611 */   // Label 29736: @2177611
     /* 2177611 */   GIM_Reject,
     /* 2177612 */ // Label 29734: @2177612
     /* 2177612 */ GIM_Reject,
     /* 2177613 */ // Label 29682: @2177613
     /* 2177613 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2177733),
     /* 2177618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2177621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2177624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177636 */   GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2177684), // Rule ID 52218 //
     /* 2177641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177644 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2177647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2177661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177683 */     // GIR_Coverage, 52218,
     /* 2177683 */     GIR_EraseRootFromParent_Done,
     /* 2177684 */   // Label 29738: @2177684
     /* 2177684 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2177732), // Rule ID 52219 //
     /* 2177689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177692 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2177695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2177709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177731 */     // GIR_Coverage, 52219,
     /* 2177731 */     GIR_EraseRootFromParent_Done,
     /* 2177732 */   // Label 29739: @2177732
     /* 2177732 */   GIM_Reject,
     /* 2177733 */ // Label 29737: @2177733
     /* 2177733 */ GIM_Reject,
     /* 2177734 */ // Label 29683: @2177734
     /* 2177734 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2177854),
     /* 2177739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2177742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177757 */   GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2177805), // Rule ID 52234 //
     /* 2177762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177765 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2177768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177804 */     // GIR_Coverage, 52234,
     /* 2177804 */     GIR_EraseRootFromParent_Done,
     /* 2177805 */   // Label 29741: @2177805
     /* 2177805 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2177853), // Rule ID 52235 //
     /* 2177810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177813 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2177816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2177830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177852 */     // GIR_Coverage, 52235,
     /* 2177852 */     GIR_EraseRootFromParent_Done,
     /* 2177853 */   // Label 29742: @2177853
     /* 2177853 */   GIM_Reject,
     /* 2177854 */ // Label 29740: @2177854
     /* 2177854 */ GIM_Reject,
     /* 2177855 */ // Label 29684: @2177855
     /* 2177855 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2177975),
     /* 2177860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2177863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177878 */   GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2177926), // Rule ID 52250 //
     /* 2177883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2177886 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2177886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2177889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2177903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177925 */     // GIR_Coverage, 52250,
     /* 2177925 */     GIR_EraseRootFromParent_Done,
     /* 2177926 */   // Label 29744: @2177926
     /* 2177926 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2177974), // Rule ID 52251 //
     /* 2177931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2177934 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2177934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2177937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2177941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2177946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2177948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2177951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2177956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2177958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2177960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2177963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2177969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2177972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177973 */     // GIR_Coverage, 52251,
     /* 2177973 */     GIR_EraseRootFromParent_Done,
     /* 2177974 */   // Label 29745: @2177974
     /* 2177974 */   GIM_Reject,
     /* 2177975 */ // Label 29743: @2177975
     /* 2177975 */ GIM_Reject,
     /* 2177976 */ // Label 29685: @2177976
     /* 2177976 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2178096),
     /* 2177981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2177984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2177987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177999 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2178047), // Rule ID 52222 //
     /* 2178004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178007 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2178010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2178024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178046 */     // GIR_Coverage, 52222,
     /* 2178046 */     GIR_EraseRootFromParent_Done,
     /* 2178047 */   // Label 29747: @2178047
     /* 2178047 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2178095), // Rule ID 52223 //
     /* 2178052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178055 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2178058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2178072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178094 */     // GIR_Coverage, 52223,
     /* 2178094 */     GIR_EraseRootFromParent_Done,
     /* 2178095 */   // Label 29748: @2178095
     /* 2178095 */   GIM_Reject,
     /* 2178096 */ // Label 29746: @2178096
     /* 2178096 */ GIM_Reject,
     /* 2178097 */ // Label 29686: @2178097
     /* 2178097 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2178217),
     /* 2178102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2178105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2178108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178120 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2178168), // Rule ID 52238 //
     /* 2178125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178128 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2178131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2178145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178167 */     // GIR_Coverage, 52238,
     /* 2178167 */     GIR_EraseRootFromParent_Done,
     /* 2178168 */   // Label 29750: @2178168
     /* 2178168 */   GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2178216), // Rule ID 52239 //
     /* 2178173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178176 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2178179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2178193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178215 */     // GIR_Coverage, 52239,
     /* 2178215 */     GIR_EraseRootFromParent_Done,
     /* 2178216 */   // Label 29751: @2178216
     /* 2178216 */   GIM_Reject,
     /* 2178217 */ // Label 29749: @2178217
     /* 2178217 */ GIM_Reject,
     /* 2178218 */ // Label 29687: @2178218
     /* 2178218 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2178338),
     /* 2178223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2178226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2178229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178241 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2178289), // Rule ID 52226 //
     /* 2178246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178249 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2178252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2178266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178288 */     // GIR_Coverage, 52226,
     /* 2178288 */     GIR_EraseRootFromParent_Done,
     /* 2178289 */   // Label 29753: @2178289
     /* 2178289 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2178337), // Rule ID 52227 //
     /* 2178294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178297 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2178300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2178314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178336 */     // GIR_Coverage, 52227,
     /* 2178336 */     GIR_EraseRootFromParent_Done,
     /* 2178337 */   // Label 29754: @2178337
     /* 2178337 */   GIM_Reject,
     /* 2178338 */ // Label 29752: @2178338
     /* 2178338 */ GIM_Reject,
     /* 2178339 */ // Label 29688: @2178339
     /* 2178339 */ GIM_Reject,
     /* 2178340 */ // Label 56: @2178340
     /* 2178340 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29777*/ GIMT_Encode4(2181125),
     /* 2178351 */ /*GILLT_nxv1s8*//*Label 29755*/ GIMT_Encode4(2178463),
     /* 2178355 */ /*GILLT_nxv1s16*//*Label 29756*/ GIMT_Encode4(2178584),
     /* 2178359 */ /*GILLT_nxv1s32*//*Label 29757*/ GIMT_Encode4(2178705),
     /* 2178363 */ /*GILLT_nxv1s64*//*Label 29758*/ GIMT_Encode4(2178826), GIMT_Encode4(0),
     /* 2178371 */ /*GILLT_nxv2s8*//*Label 29759*/ GIMT_Encode4(2178947),
     /* 2178375 */ /*GILLT_nxv2s16*//*Label 29760*/ GIMT_Encode4(2179068),
     /* 2178379 */ /*GILLT_nxv2s32*//*Label 29761*/ GIMT_Encode4(2179189),
     /* 2178383 */ /*GILLT_nxv2s64*//*Label 29762*/ GIMT_Encode4(2179310), GIMT_Encode4(0),
     /* 2178391 */ /*GILLT_nxv4s8*//*Label 29763*/ GIMT_Encode4(2179431),
     /* 2178395 */ /*GILLT_nxv4s16*//*Label 29764*/ GIMT_Encode4(2179552),
     /* 2178399 */ /*GILLT_nxv4s32*//*Label 29765*/ GIMT_Encode4(2179673),
     /* 2178403 */ /*GILLT_nxv4s64*//*Label 29766*/ GIMT_Encode4(2179794), GIMT_Encode4(0),
     /* 2178411 */ /*GILLT_nxv8s8*//*Label 29767*/ GIMT_Encode4(2179915),
     /* 2178415 */ /*GILLT_nxv8s16*//*Label 29768*/ GIMT_Encode4(2180036),
     /* 2178419 */ /*GILLT_nxv8s32*//*Label 29769*/ GIMT_Encode4(2180157),
     /* 2178423 */ /*GILLT_nxv8s64*//*Label 29770*/ GIMT_Encode4(2180278), GIMT_Encode4(0),
     /* 2178431 */ /*GILLT_nxv16s8*//*Label 29771*/ GIMT_Encode4(2180399),
     /* 2178435 */ /*GILLT_nxv16s16*//*Label 29772*/ GIMT_Encode4(2180520),
     /* 2178439 */ /*GILLT_nxv16s32*//*Label 29773*/ GIMT_Encode4(2180641), GIMT_Encode4(0),
     /* 2178447 */ /*GILLT_nxv32s8*//*Label 29774*/ GIMT_Encode4(2180762),
     /* 2178451 */ /*GILLT_nxv32s16*//*Label 29775*/ GIMT_Encode4(2180883), GIMT_Encode4(0),
     /* 2178459 */ /*GILLT_nxv64s8*//*Label 29776*/ GIMT_Encode4(2181004),
     /* 2178463 */ // Label 29755: @2178463
     /* 2178463 */ GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2178583),
     /* 2178468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2178471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2178474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178486 */   GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2178534), // Rule ID 52090 //
     /* 2178491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178494 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2178497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2178511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178533 */     // GIR_Coverage, 52090,
     /* 2178533 */     GIR_EraseRootFromParent_Done,
     /* 2178534 */   // Label 29779: @2178534
     /* 2178534 */   GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2178582), // Rule ID 52091 //
     /* 2178539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178542 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2178545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2178559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178581 */     // GIR_Coverage, 52091,
     /* 2178581 */     GIR_EraseRootFromParent_Done,
     /* 2178582 */   // Label 29780: @2178582
     /* 2178582 */   GIM_Reject,
     /* 2178583 */ // Label 29778: @2178583
     /* 2178583 */ GIM_Reject,
     /* 2178584 */ // Label 29756: @2178584
     /* 2178584 */ GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2178704),
     /* 2178589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2178592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178607 */   GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2178655), // Rule ID 52102 //
     /* 2178612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178615 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2178618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2178632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178654 */     // GIR_Coverage, 52102,
     /* 2178654 */     GIR_EraseRootFromParent_Done,
     /* 2178655 */   // Label 29782: @2178655
     /* 2178655 */   GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2178703), // Rule ID 52103 //
     /* 2178660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178663 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2178666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2178680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178702 */     // GIR_Coverage, 52103,
     /* 2178702 */     GIR_EraseRootFromParent_Done,
     /* 2178703 */   // Label 29783: @2178703
     /* 2178703 */   GIM_Reject,
     /* 2178704 */ // Label 29781: @2178704
     /* 2178704 */ GIM_Reject,
     /* 2178705 */ // Label 29757: @2178705
     /* 2178705 */ GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2178825),
     /* 2178710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2178713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178728 */   GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2178776), // Rule ID 52110 //
     /* 2178733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178736 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2178739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2178753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178775 */     // GIR_Coverage, 52110,
     /* 2178775 */     GIR_EraseRootFromParent_Done,
     /* 2178776 */   // Label 29785: @2178776
     /* 2178776 */   GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2178824), // Rule ID 52111 //
     /* 2178781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2178784 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2178787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2178801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178823 */     // GIR_Coverage, 52111,
     /* 2178823 */     GIR_EraseRootFromParent_Done,
     /* 2178824 */   // Label 29786: @2178824
     /* 2178824 */   GIM_Reject,
     /* 2178825 */ // Label 29784: @2178825
     /* 2178825 */ GIM_Reject,
     /* 2178826 */ // Label 29758: @2178826
     /* 2178826 */ GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2178946),
     /* 2178831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2178834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178849 */   GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2178897), // Rule ID 52126 //
     /* 2178854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2178857 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2178860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2178874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178896 */     // GIR_Coverage, 52126,
     /* 2178896 */     GIR_EraseRootFromParent_Done,
     /* 2178897 */   // Label 29788: @2178897
     /* 2178897 */   GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2178945), // Rule ID 52127 //
     /* 2178902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2178905 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2178905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2178908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2178922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2178927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2178929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2178931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2178934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2178940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2178943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178944 */     // GIR_Coverage, 52127,
     /* 2178944 */     GIR_EraseRootFromParent_Done,
     /* 2178945 */   // Label 29789: @2178945
     /* 2178945 */   GIM_Reject,
     /* 2178946 */ // Label 29787: @2178946
     /* 2178946 */ GIM_Reject,
     /* 2178947 */ // Label 29759: @2178947
     /* 2178947 */ GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2179067),
     /* 2178952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2178955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2178958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178970 */   GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2179018), // Rule ID 52094 //
     /* 2178975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2178978 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2178978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2178981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2178985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2178990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2178992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2178995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179017 */     // GIR_Coverage, 52094,
     /* 2179017 */     GIR_EraseRootFromParent_Done,
     /* 2179018 */   // Label 29791: @2179018
     /* 2179018 */   GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2179066), // Rule ID 52095 //
     /* 2179023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179026 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2179029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2179043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179065 */     // GIR_Coverage, 52095,
     /* 2179065 */     GIR_EraseRootFromParent_Done,
     /* 2179066 */   // Label 29792: @2179066
     /* 2179066 */   GIM_Reject,
     /* 2179067 */ // Label 29790: @2179067
     /* 2179067 */ GIM_Reject,
     /* 2179068 */ // Label 29760: @2179068
     /* 2179068 */ GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2179188),
     /* 2179073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2179076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2179079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179091 */   GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2179139), // Rule ID 52106 //
     /* 2179096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179099 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2179102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2179116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179138 */     // GIR_Coverage, 52106,
     /* 2179138 */     GIR_EraseRootFromParent_Done,
     /* 2179139 */   // Label 29794: @2179139
     /* 2179139 */   GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2179187), // Rule ID 52107 //
     /* 2179144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179147 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2179150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2179164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179186 */     // GIR_Coverage, 52107,
     /* 2179186 */     GIR_EraseRootFromParent_Done,
     /* 2179187 */   // Label 29795: @2179187
     /* 2179187 */   GIM_Reject,
     /* 2179188 */ // Label 29793: @2179188
     /* 2179188 */ GIM_Reject,
     /* 2179189 */ // Label 29761: @2179189
     /* 2179189 */ GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2179309),
     /* 2179194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2179197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179212 */   GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2179260), // Rule ID 52122 //
     /* 2179217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179220 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2179223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2179237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179259 */     // GIR_Coverage, 52122,
     /* 2179259 */     GIR_EraseRootFromParent_Done,
     /* 2179260 */   // Label 29797: @2179260
     /* 2179260 */   GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2179308), // Rule ID 52123 //
     /* 2179265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179268 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2179271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2179285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179307 */     // GIR_Coverage, 52123,
     /* 2179307 */     GIR_EraseRootFromParent_Done,
     /* 2179308 */   // Label 29798: @2179308
     /* 2179308 */   GIM_Reject,
     /* 2179309 */ // Label 29796: @2179309
     /* 2179309 */ GIM_Reject,
     /* 2179310 */ // Label 29762: @2179310
     /* 2179310 */ GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2179430),
     /* 2179315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2179318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2179321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179333 */   GIM_Try, /*On fail goto*//*Label 29800*/ GIMT_Encode4(2179381), // Rule ID 52166 //
     /* 2179338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2179341 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2179344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2179358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179380 */     // GIR_Coverage, 52166,
     /* 2179380 */     GIR_EraseRootFromParent_Done,
     /* 2179381 */   // Label 29800: @2179381
     /* 2179381 */   GIM_Try, /*On fail goto*//*Label 29801*/ GIMT_Encode4(2179429), // Rule ID 52167 //
     /* 2179386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2179389 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2179392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2179406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179428 */     // GIR_Coverage, 52167,
     /* 2179428 */     GIR_EraseRootFromParent_Done,
     /* 2179429 */   // Label 29801: @2179429
     /* 2179429 */   GIM_Reject,
     /* 2179430 */ // Label 29799: @2179430
     /* 2179430 */ GIM_Reject,
     /* 2179431 */ // Label 29763: @2179431
     /* 2179431 */ GIM_Try, /*On fail goto*//*Label 29802*/ GIMT_Encode4(2179551),
     /* 2179436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2179439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2179442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179454 */   GIM_Try, /*On fail goto*//*Label 29803*/ GIMT_Encode4(2179502), // Rule ID 52098 //
     /* 2179459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179462 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2179465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2179479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179501 */     // GIR_Coverage, 52098,
     /* 2179501 */     GIR_EraseRootFromParent_Done,
     /* 2179502 */   // Label 29803: @2179502
     /* 2179502 */   GIM_Try, /*On fail goto*//*Label 29804*/ GIMT_Encode4(2179550), // Rule ID 52099 //
     /* 2179507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179510 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2179513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2179527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179549 */     // GIR_Coverage, 52099,
     /* 2179549 */     GIR_EraseRootFromParent_Done,
     /* 2179550 */   // Label 29804: @2179550
     /* 2179550 */   GIM_Reject,
     /* 2179551 */ // Label 29802: @2179551
     /* 2179551 */ GIM_Reject,
     /* 2179552 */ // Label 29764: @2179552
     /* 2179552 */ GIM_Try, /*On fail goto*//*Label 29805*/ GIMT_Encode4(2179672),
     /* 2179557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2179560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179575 */   GIM_Try, /*On fail goto*//*Label 29806*/ GIMT_Encode4(2179623), // Rule ID 52118 //
     /* 2179580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179583 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2179586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2179600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179622 */     // GIR_Coverage, 52118,
     /* 2179622 */     GIR_EraseRootFromParent_Done,
     /* 2179623 */   // Label 29806: @2179623
     /* 2179623 */   GIM_Try, /*On fail goto*//*Label 29807*/ GIMT_Encode4(2179671), // Rule ID 52119 //
     /* 2179628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179631 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2179634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2179648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179670 */     // GIR_Coverage, 52119,
     /* 2179670 */     GIR_EraseRootFromParent_Done,
     /* 2179671 */   // Label 29807: @2179671
     /* 2179671 */   GIM_Reject,
     /* 2179672 */ // Label 29805: @2179672
     /* 2179672 */ GIM_Reject,
     /* 2179673 */ // Label 29765: @2179673
     /* 2179673 */ GIM_Try, /*On fail goto*//*Label 29808*/ GIMT_Encode4(2179793),
     /* 2179678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2179681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179696 */   GIM_Try, /*On fail goto*//*Label 29809*/ GIMT_Encode4(2179744), // Rule ID 52154 //
     /* 2179701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179704 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2179707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2179721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179743 */     // GIR_Coverage, 52154,
     /* 2179743 */     GIR_EraseRootFromParent_Done,
     /* 2179744 */   // Label 29809: @2179744
     /* 2179744 */   GIM_Try, /*On fail goto*//*Label 29810*/ GIMT_Encode4(2179792), // Rule ID 52155 //
     /* 2179749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179752 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2179755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2179769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179791 */     // GIR_Coverage, 52155,
     /* 2179791 */     GIR_EraseRootFromParent_Done,
     /* 2179792 */   // Label 29810: @2179792
     /* 2179792 */   GIM_Reject,
     /* 2179793 */ // Label 29808: @2179793
     /* 2179793 */ GIM_Reject,
     /* 2179794 */ // Label 29766: @2179794
     /* 2179794 */ GIM_Try, /*On fail goto*//*Label 29811*/ GIMT_Encode4(2179914),
     /* 2179799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2179802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2179805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179817 */   GIM_Try, /*On fail goto*//*Label 29812*/ GIMT_Encode4(2179865), // Rule ID 52170 //
     /* 2179822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2179825 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2179828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2179842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179864 */     // GIR_Coverage, 52170,
     /* 2179864 */     GIR_EraseRootFromParent_Done,
     /* 2179865 */   // Label 29812: @2179865
     /* 2179865 */   GIM_Try, /*On fail goto*//*Label 29813*/ GIMT_Encode4(2179913), // Rule ID 52171 //
     /* 2179870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2179873 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2179876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2179890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179912 */     // GIR_Coverage, 52171,
     /* 2179912 */     GIR_EraseRootFromParent_Done,
     /* 2179913 */   // Label 29813: @2179913
     /* 2179913 */   GIM_Reject,
     /* 2179914 */ // Label 29811: @2179914
     /* 2179914 */ GIM_Reject,
     /* 2179915 */ // Label 29767: @2179915
     /* 2179915 */ GIM_Try, /*On fail goto*//*Label 29814*/ GIMT_Encode4(2180035),
     /* 2179920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2179923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2179926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179938 */   GIM_Try, /*On fail goto*//*Label 29815*/ GIMT_Encode4(2179986), // Rule ID 52114 //
     /* 2179943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2179946 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2179946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2179949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2179953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2179958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2179960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2179963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2179968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2179970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2179972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2179975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2179981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2179984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179985 */     // GIR_Coverage, 52114,
     /* 2179985 */     GIR_EraseRootFromParent_Done,
     /* 2179986 */   // Label 29815: @2179986
     /* 2179986 */   GIM_Try, /*On fail goto*//*Label 29816*/ GIMT_Encode4(2180034), // Rule ID 52115 //
     /* 2179991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2179994 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2179994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2179997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2180011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180033 */     // GIR_Coverage, 52115,
     /* 2180033 */     GIR_EraseRootFromParent_Done,
     /* 2180034 */   // Label 29816: @2180034
     /* 2180034 */   GIM_Reject,
     /* 2180035 */ // Label 29814: @2180035
     /* 2180035 */ GIM_Reject,
     /* 2180036 */ // Label 29768: @2180036
     /* 2180036 */ GIM_Try, /*On fail goto*//*Label 29817*/ GIMT_Encode4(2180156),
     /* 2180041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2180044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2180047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180059 */   GIM_Try, /*On fail goto*//*Label 29818*/ GIMT_Encode4(2180107), // Rule ID 52142 //
     /* 2180064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180067 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2180070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2180084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180106 */     // GIR_Coverage, 52142,
     /* 2180106 */     GIR_EraseRootFromParent_Done,
     /* 2180107 */   // Label 29818: @2180107
     /* 2180107 */   GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2180155), // Rule ID 52143 //
     /* 2180112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180115 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2180118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2180132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180154 */     // GIR_Coverage, 52143,
     /* 2180154 */     GIR_EraseRootFromParent_Done,
     /* 2180155 */   // Label 29819: @2180155
     /* 2180155 */   GIM_Reject,
     /* 2180156 */ // Label 29817: @2180156
     /* 2180156 */ GIM_Reject,
     /* 2180157 */ // Label 29769: @2180157
     /* 2180157 */ GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2180277),
     /* 2180162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2180165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180180 */   GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2180228), // Rule ID 52158 //
     /* 2180185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180188 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2180191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180227 */     // GIR_Coverage, 52158,
     /* 2180227 */     GIR_EraseRootFromParent_Done,
     /* 2180228 */   // Label 29821: @2180228
     /* 2180228 */   GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2180276), // Rule ID 52159 //
     /* 2180233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180236 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2180239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180275 */     // GIR_Coverage, 52159,
     /* 2180275 */     GIR_EraseRootFromParent_Done,
     /* 2180276 */   // Label 29822: @2180276
     /* 2180276 */   GIM_Reject,
     /* 2180277 */ // Label 29820: @2180277
     /* 2180277 */ GIM_Reject,
     /* 2180278 */ // Label 29770: @2180278
     /* 2180278 */ GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2180398),
     /* 2180283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2180286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180301 */   GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2180349), // Rule ID 52174 //
     /* 2180306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2180309 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2180312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180348 */     // GIR_Coverage, 52174,
     /* 2180348 */     GIR_EraseRootFromParent_Done,
     /* 2180349 */   // Label 29824: @2180349
     /* 2180349 */   GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2180397), // Rule ID 52175 //
     /* 2180354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2180357 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2180360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180396 */     // GIR_Coverage, 52175,
     /* 2180396 */     GIR_EraseRootFromParent_Done,
     /* 2180397 */   // Label 29825: @2180397
     /* 2180397 */   GIM_Reject,
     /* 2180398 */ // Label 29823: @2180398
     /* 2180398 */ GIM_Reject,
     /* 2180399 */ // Label 29771: @2180399
     /* 2180399 */ GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2180519),
     /* 2180404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2180407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2180410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180422 */   GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2180470), // Rule ID 52130 //
     /* 2180427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180430 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2180433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2180447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180469 */     // GIR_Coverage, 52130,
     /* 2180469 */     GIR_EraseRootFromParent_Done,
     /* 2180470 */   // Label 29827: @2180470
     /* 2180470 */   GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2180518), // Rule ID 52131 //
     /* 2180475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180478 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2180481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2180495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180517 */     // GIR_Coverage, 52131,
     /* 2180517 */     GIR_EraseRootFromParent_Done,
     /* 2180518 */   // Label 29828: @2180518
     /* 2180518 */   GIM_Reject,
     /* 2180519 */ // Label 29826: @2180519
     /* 2180519 */ GIM_Reject,
     /* 2180520 */ // Label 29772: @2180520
     /* 2180520 */ GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2180640),
     /* 2180525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2180528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2180531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180543 */   GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2180591), // Rule ID 52146 //
     /* 2180548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180551 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2180554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180590 */     // GIR_Coverage, 52146,
     /* 2180590 */     GIR_EraseRootFromParent_Done,
     /* 2180591 */   // Label 29830: @2180591
     /* 2180591 */   GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2180639), // Rule ID 52147 //
     /* 2180596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180599 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2180602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180638 */     // GIR_Coverage, 52147,
     /* 2180638 */     GIR_EraseRootFromParent_Done,
     /* 2180639 */   // Label 29831: @2180639
     /* 2180639 */   GIM_Reject,
     /* 2180640 */ // Label 29829: @2180640
     /* 2180640 */ GIM_Reject,
     /* 2180641 */ // Label 29773: @2180641
     /* 2180641 */ GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2180761),
     /* 2180646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2180649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180664 */   GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2180712), // Rule ID 52162 //
     /* 2180669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180672 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2180675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180711 */     // GIR_Coverage, 52162,
     /* 2180711 */     GIR_EraseRootFromParent_Done,
     /* 2180712 */   // Label 29833: @2180712
     /* 2180712 */   GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2180760), // Rule ID 52163 //
     /* 2180717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180720 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2180723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180759 */     // GIR_Coverage, 52163,
     /* 2180759 */     GIR_EraseRootFromParent_Done,
     /* 2180760 */   // Label 29834: @2180760
     /* 2180760 */   GIM_Reject,
     /* 2180761 */ // Label 29832: @2180761
     /* 2180761 */ GIM_Reject,
     /* 2180762 */ // Label 29774: @2180762
     /* 2180762 */ GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2180882),
     /* 2180767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2180770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2180773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180785 */   GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2180833), // Rule ID 52134 //
     /* 2180790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180793 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2180796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180832 */     // GIR_Coverage, 52134,
     /* 2180832 */     GIR_EraseRootFromParent_Done,
     /* 2180833 */   // Label 29836: @2180833
     /* 2180833 */   GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2180881), // Rule ID 52135 //
     /* 2180838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180841 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2180844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2180858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180880 */     // GIR_Coverage, 52135,
     /* 2180880 */     GIR_EraseRootFromParent_Done,
     /* 2180881 */   // Label 29837: @2180881
     /* 2180881 */   GIM_Reject,
     /* 2180882 */ // Label 29835: @2180882
     /* 2180882 */ GIM_Reject,
     /* 2180883 */ // Label 29775: @2180883
     /* 2180883 */ GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2181003),
     /* 2180888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2180891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180906 */   GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2180954), // Rule ID 52150 //
     /* 2180911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2180914 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2180914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2180917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2180952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180953 */     // GIR_Coverage, 52150,
     /* 2180953 */     GIR_EraseRootFromParent_Done,
     /* 2180954 */   // Label 29839: @2180954
     /* 2180954 */   GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2181002), // Rule ID 52151 //
     /* 2180959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2180962 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2180962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2180965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2180969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2180974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2180976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2180979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2180984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2180986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2180988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2180991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2180997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2181000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181001 */     // GIR_Coverage, 52151,
     /* 2181001 */     GIR_EraseRootFromParent_Done,
     /* 2181002 */   // Label 29840: @2181002
     /* 2181002 */   GIM_Reject,
     /* 2181003 */ // Label 29838: @2181003
     /* 2181003 */ GIM_Reject,
     /* 2181004 */ // Label 29776: @2181004
     /* 2181004 */ GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2181124),
     /* 2181009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2181012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2181015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181027 */   GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2181075), // Rule ID 52138 //
     /* 2181032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2181035 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2181035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2181038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2181052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2181073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181074 */     // GIR_Coverage, 52138,
     /* 2181074 */     GIR_EraseRootFromParent_Done,
     /* 2181075 */   // Label 29842: @2181075
     /* 2181075 */   GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2181123), // Rule ID 52139 //
     /* 2181080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2181083 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2181083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2181086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2181100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2181121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181122 */     // GIR_Coverage, 52139,
     /* 2181122 */     GIR_EraseRootFromParent_Done,
     /* 2181123 */   // Label 29843: @2181123
     /* 2181123 */   GIM_Reject,
     /* 2181124 */ // Label 29841: @2181124
     /* 2181124 */ GIM_Reject,
     /* 2181125 */ // Label 29777: @2181125
     /* 2181125 */ GIM_Reject,
     /* 2181126 */ // Label 57: @2181126
     /* 2181126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 29862*/ GIMT_Encode4(2183553),
     /* 2181137 */ /*GILLT_s16*//*Label 29844*/ GIMT_Encode4(2181257),
     /* 2181141 */ /*GILLT_s32*//*Label 29845*/ GIMT_Encode4(2181406),
     /* 2181145 */ /*GILLT_s64*//*Label 29846*/ GIMT_Encode4(2181555), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181157 */ /*GILLT_nxv1s16*//*Label 29847*/ GIMT_Encode4(2181738),
     /* 2181161 */ /*GILLT_nxv1s32*//*Label 29848*/ GIMT_Encode4(2181859),
     /* 2181165 */ /*GILLT_nxv1s64*//*Label 29849*/ GIMT_Encode4(2181980), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181177 */ /*GILLT_nxv2s16*//*Label 29850*/ GIMT_Encode4(2182101),
     /* 2181181 */ /*GILLT_nxv2s32*//*Label 29851*/ GIMT_Encode4(2182222),
     /* 2181185 */ /*GILLT_nxv2s64*//*Label 29852*/ GIMT_Encode4(2182343), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181197 */ /*GILLT_nxv4s16*//*Label 29853*/ GIMT_Encode4(2182464),
     /* 2181201 */ /*GILLT_nxv4s32*//*Label 29854*/ GIMT_Encode4(2182585),
     /* 2181205 */ /*GILLT_nxv4s64*//*Label 29855*/ GIMT_Encode4(2182706), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181217 */ /*GILLT_nxv8s16*//*Label 29856*/ GIMT_Encode4(2182827),
     /* 2181221 */ /*GILLT_nxv8s32*//*Label 29857*/ GIMT_Encode4(2182948),
     /* 2181225 */ /*GILLT_nxv8s64*//*Label 29858*/ GIMT_Encode4(2183069), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181237 */ /*GILLT_nxv16s16*//*Label 29859*/ GIMT_Encode4(2183190),
     /* 2181241 */ /*GILLT_nxv16s32*//*Label 29860*/ GIMT_Encode4(2183311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2181253 */ /*GILLT_nxv32s16*//*Label 29861*/ GIMT_Encode4(2183432),
     /* 2181257 */ // Label 29844: @2181257
     /* 2181257 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2181405),
     /* 2181262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2181265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2181268 */   GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2181302), // Rule ID 1816 //
     /* 2181273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2181276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181288 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2181288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2181291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181301 */     // GIR_Coverage, 1816,
     /* 2181301 */     GIR_EraseRootFromParent_Done,
     /* 2181302 */   // Label 29864: @2181302
     /* 2181302 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2181336), // Rule ID 1817 //
     /* 2181307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2181310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181322 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2181322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2181325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181335 */     // GIR_Coverage, 1817,
     /* 2181335 */     GIR_EraseRootFromParent_Done,
     /* 2181336 */   // Label 29865: @2181336
     /* 2181336 */   GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2181370), // Rule ID 1820 //
     /* 2181341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2181344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181356 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2181356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2181359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181369 */     // GIR_Coverage, 1820,
     /* 2181369 */     GIR_EraseRootFromParent_Done,
     /* 2181370 */   // Label 29866: @2181370
     /* 2181370 */   GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2181404), // Rule ID 1821 //
     /* 2181375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2181378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2181390 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2181390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2181393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181403 */     // GIR_Coverage, 1821,
     /* 2181403 */     GIR_EraseRootFromParent_Done,
     /* 2181404 */   // Label 29867: @2181404
     /* 2181404 */   GIM_Reject,
     /* 2181405 */ // Label 29863: @2181405
     /* 2181405 */ GIM_Reject,
     /* 2181406 */ // Label 29845: @2181406
     /* 2181406 */ GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2181554),
     /* 2181411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2181414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2181417 */   GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2181451), // Rule ID 1107 //
     /* 2181422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2181425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181437 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2181437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2181440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181450 */     // GIR_Coverage, 1107,
     /* 2181450 */     GIR_EraseRootFromParent_Done,
     /* 2181451 */   // Label 29869: @2181451
     /* 2181451 */   GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2181485), // Rule ID 1108 //
     /* 2181456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2181459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181471 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2181471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2181474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181484 */     // GIR_Coverage, 1108,
     /* 2181484 */     GIR_EraseRootFromParent_Done,
     /* 2181485 */   // Label 29870: @2181485
     /* 2181485 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2181519), // Rule ID 1111 //
     /* 2181490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2181493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181505 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2181505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2181508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181518 */     // GIR_Coverage, 1111,
     /* 2181518 */     GIR_EraseRootFromParent_Done,
     /* 2181519 */   // Label 29871: @2181519
     /* 2181519 */   GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2181553), // Rule ID 1112 //
     /* 2181524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2181527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2181539 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2181539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2181542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181552 */     // GIR_Coverage, 1112,
     /* 2181552 */     GIR_EraseRootFromParent_Done,
     /* 2181553 */   // Label 29872: @2181553
     /* 2181553 */   GIM_Reject,
     /* 2181554 */ // Label 29868: @2181554
     /* 2181554 */ GIM_Reject,
     /* 2181555 */ // Label 29846: @2181555
     /* 2181555 */ GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2181737),
     /* 2181560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2181563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2181566 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2181600), // Rule ID 1442 //
     /* 2181571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2181574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181586 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2181586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2181589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181599 */     // GIR_Coverage, 1442,
     /* 2181599 */     GIR_EraseRootFromParent_Done,
     /* 2181600 */   // Label 29874: @2181600
     /* 2181600 */   GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2181634), // Rule ID 1443 //
     /* 2181605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2181608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181620 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2181620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2181623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181633 */     // GIR_Coverage, 1443,
     /* 2181633 */     GIR_EraseRootFromParent_Done,
     /* 2181634 */   // Label 29875: @2181634
     /* 2181634 */   GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2181668), // Rule ID 1446 //
     /* 2181639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2181642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181654 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2181654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2181657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181667 */     // GIR_Coverage, 1446,
     /* 2181667 */     GIR_EraseRootFromParent_Done,
     /* 2181668 */   // Label 29876: @2181668
     /* 2181668 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2181702), // Rule ID 1447 //
     /* 2181673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2181676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2181688 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2181688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2181691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181701 */     // GIR_Coverage, 1447,
     /* 2181701 */     GIR_EraseRootFromParent_Done,
     /* 2181702 */   // Label 29877: @2181702
     /* 2181702 */   GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2181736), // Rule ID 1449 //
     /* 2181707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2181710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2181714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2181718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2181722 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2181722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2181725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181735 */     // GIR_Coverage, 1449,
     /* 2181735 */     GIR_EraseRootFromParent_Done,
     /* 2181736 */   // Label 29878: @2181736
     /* 2181736 */   GIM_Reject,
     /* 2181737 */ // Label 29873: @2181737
     /* 2181737 */ GIM_Reject,
     /* 2181738 */ // Label 29847: @2181738
     /* 2181738 */ GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2181858),
     /* 2181743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2181746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181761 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2181809), // Rule ID 45442 //
     /* 2181766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181769 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2181769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2181772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2181786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181808 */     // GIR_Coverage, 45442,
     /* 2181808 */     GIR_EraseRootFromParent_Done,
     /* 2181809 */   // Label 29880: @2181809
     /* 2181809 */   GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2181857), // Rule ID 45443 //
     /* 2181814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181817 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2181817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2181820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2181834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181856 */     // GIR_Coverage, 45443,
     /* 2181856 */     GIR_EraseRootFromParent_Done,
     /* 2181857 */   // Label 29881: @2181857
     /* 2181857 */   GIM_Reject,
     /* 2181858 */ // Label 29879: @2181858
     /* 2181858 */ GIM_Reject,
     /* 2181859 */ // Label 29848: @2181859
     /* 2181859 */ GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2181979),
     /* 2181864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2181867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181882 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2181930), // Rule ID 52754 //
     /* 2181887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181890 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2181890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2181893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2181907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181929 */     // GIR_Coverage, 52754,
     /* 2181929 */     GIR_EraseRootFromParent_Done,
     /* 2181930 */   // Label 29883: @2181930
     /* 2181930 */   GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2181978), // Rule ID 52755 //
     /* 2181935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181938 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2181938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2181941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2181945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2181950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2181952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2181955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2181960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2181962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2181964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2181967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2181970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2181976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181977 */     // GIR_Coverage, 52755,
     /* 2181977 */     GIR_EraseRootFromParent_Done,
     /* 2181978 */   // Label 29884: @2181978
     /* 2181978 */   GIM_Reject,
     /* 2181979 */ // Label 29882: @2181979
     /* 2181979 */ GIM_Reject,
     /* 2181980 */ // Label 29849: @2181980
     /* 2181980 */ GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2182100),
     /* 2181985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2181988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182003 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2182051), // Rule ID 52790 //
     /* 2182008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182011 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2182014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2182028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182050 */     // GIR_Coverage, 52790,
     /* 2182050 */     GIR_EraseRootFromParent_Done,
     /* 2182051 */   // Label 29886: @2182051
     /* 2182051 */   GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2182099), // Rule ID 52791 //
     /* 2182056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182059 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2182062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2182076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182098 */     // GIR_Coverage, 52791,
     /* 2182098 */     GIR_EraseRootFromParent_Done,
     /* 2182099 */   // Label 29887: @2182099
     /* 2182099 */   GIM_Reject,
     /* 2182100 */ // Label 29885: @2182100
     /* 2182100 */ GIM_Reject,
     /* 2182101 */ // Label 29850: @2182101
     /* 2182101 */ GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2182221),
     /* 2182106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2182109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2182112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182124 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2182172), // Rule ID 52742 //
     /* 2182129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182132 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2182135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2182149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182171 */     // GIR_Coverage, 52742,
     /* 2182171 */     GIR_EraseRootFromParent_Done,
     /* 2182172 */   // Label 29889: @2182172
     /* 2182172 */   GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2182220), // Rule ID 52743 //
     /* 2182177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182180 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2182183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2182197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182219 */     // GIR_Coverage, 52743,
     /* 2182219 */     GIR_EraseRootFromParent_Done,
     /* 2182220 */   // Label 29890: @2182220
     /* 2182220 */   GIM_Reject,
     /* 2182221 */ // Label 29888: @2182221
     /* 2182221 */ GIM_Reject,
     /* 2182222 */ // Label 29851: @2182222
     /* 2182222 */ GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2182342),
     /* 2182227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2182230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182245 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2182293), // Rule ID 52778 //
     /* 2182250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182253 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2182256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2182270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182292 */     // GIR_Coverage, 52778,
     /* 2182292 */     GIR_EraseRootFromParent_Done,
     /* 2182293 */   // Label 29892: @2182293
     /* 2182293 */   GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2182341), // Rule ID 52779 //
     /* 2182298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182301 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2182304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2182318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182340 */     // GIR_Coverage, 52779,
     /* 2182340 */     GIR_EraseRootFromParent_Done,
     /* 2182341 */   // Label 29893: @2182341
     /* 2182341 */   GIM_Reject,
     /* 2182342 */ // Label 29891: @2182342
     /* 2182342 */ GIM_Reject,
     /* 2182343 */ // Label 29852: @2182343
     /* 2182343 */ GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2182463),
     /* 2182348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2182351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182366 */   GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2182414), // Rule ID 52874 //
     /* 2182371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182374 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2182377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2182391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182413 */     // GIR_Coverage, 52874,
     /* 2182413 */     GIR_EraseRootFromParent_Done,
     /* 2182414 */   // Label 29895: @2182414
     /* 2182414 */   GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2182462), // Rule ID 52875 //
     /* 2182419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182422 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2182425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2182439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182461 */     // GIR_Coverage, 52875,
     /* 2182461 */     GIR_EraseRootFromParent_Done,
     /* 2182462 */   // Label 29896: @2182462
     /* 2182462 */   GIM_Reject,
     /* 2182463 */ // Label 29894: @2182463
     /* 2182463 */ GIM_Reject,
     /* 2182464 */ // Label 29853: @2182464
     /* 2182464 */ GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2182584),
     /* 2182469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2182472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2182475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182487 */   GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2182535), // Rule ID 52766 //
     /* 2182492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182495 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2182498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2182512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182534 */     // GIR_Coverage, 52766,
     /* 2182534 */     GIR_EraseRootFromParent_Done,
     /* 2182535 */   // Label 29898: @2182535
     /* 2182535 */   GIM_Try, /*On fail goto*//*Label 29899*/ GIMT_Encode4(2182583), // Rule ID 52767 //
     /* 2182540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182543 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2182546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2182560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182582 */     // GIR_Coverage, 52767,
     /* 2182582 */     GIR_EraseRootFromParent_Done,
     /* 2182583 */   // Label 29899: @2182583
     /* 2182583 */   GIM_Reject,
     /* 2182584 */ // Label 29897: @2182584
     /* 2182584 */ GIM_Reject,
     /* 2182585 */ // Label 29854: @2182585
     /* 2182585 */ GIM_Try, /*On fail goto*//*Label 29900*/ GIMT_Encode4(2182705),
     /* 2182590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2182593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182608 */   GIM_Try, /*On fail goto*//*Label 29901*/ GIMT_Encode4(2182656), // Rule ID 52838 //
     /* 2182613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182616 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2182619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2182633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182655 */     // GIR_Coverage, 52838,
     /* 2182655 */     GIR_EraseRootFromParent_Done,
     /* 2182656 */   // Label 29901: @2182656
     /* 2182656 */   GIM_Try, /*On fail goto*//*Label 29902*/ GIMT_Encode4(2182704), // Rule ID 52839 //
     /* 2182661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182664 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2182667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2182681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182703 */     // GIR_Coverage, 52839,
     /* 2182703 */     GIR_EraseRootFromParent_Done,
     /* 2182704 */   // Label 29902: @2182704
     /* 2182704 */   GIM_Reject,
     /* 2182705 */ // Label 29900: @2182705
     /* 2182705 */ GIM_Reject,
     /* 2182706 */ // Label 29855: @2182706
     /* 2182706 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2182826),
     /* 2182711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2182714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2182717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182729 */   GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2182777), // Rule ID 52886 //
     /* 2182734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182737 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2182740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2182754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182776 */     // GIR_Coverage, 52886,
     /* 2182776 */     GIR_EraseRootFromParent_Done,
     /* 2182777 */   // Label 29904: @2182777
     /* 2182777 */   GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2182825), // Rule ID 52887 //
     /* 2182782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182785 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2182788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2182802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182824 */     // GIR_Coverage, 52887,
     /* 2182824 */     GIR_EraseRootFromParent_Done,
     /* 2182825 */   // Label 29905: @2182825
     /* 2182825 */   GIM_Reject,
     /* 2182826 */ // Label 29903: @2182826
     /* 2182826 */ GIM_Reject,
     /* 2182827 */ // Label 29856: @2182827
     /* 2182827 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2182947),
     /* 2182832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2182835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182850 */   GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2182898), // Rule ID 52802 //
     /* 2182855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182858 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2182861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2182875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182897 */     // GIR_Coverage, 52802,
     /* 2182897 */     GIR_EraseRootFromParent_Done,
     /* 2182898 */   // Label 29907: @2182898
     /* 2182898 */   GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2182946), // Rule ID 52803 //
     /* 2182903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182906 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2182906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2182909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2182923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2182928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2182930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2182932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2182935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2182938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2182944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182945 */     // GIR_Coverage, 52803,
     /* 2182945 */     GIR_EraseRootFromParent_Done,
     /* 2182946 */   // Label 29908: @2182946
     /* 2182946 */   GIM_Reject,
     /* 2182947 */ // Label 29906: @2182947
     /* 2182947 */ GIM_Reject,
     /* 2182948 */ // Label 29857: @2182948
     /* 2182948 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2183068),
     /* 2182953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2182956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182971 */   GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2183019), // Rule ID 52850 //
     /* 2182976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182979 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2182979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2182982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2182986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2182991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183018 */     // GIR_Coverage, 52850,
     /* 2183018 */     GIR_EraseRootFromParent_Done,
     /* 2183019 */   // Label 29910: @2183019
     /* 2183019 */   GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2183067), // Rule ID 52851 //
     /* 2183024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183027 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2183027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2183030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2183044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183066 */     // GIR_Coverage, 52851,
     /* 2183066 */     GIR_EraseRootFromParent_Done,
     /* 2183067 */   // Label 29911: @2183067
     /* 2183067 */   GIM_Reject,
     /* 2183068 */ // Label 29909: @2183068
     /* 2183068 */ GIM_Reject,
     /* 2183069 */ // Label 29858: @2183069
     /* 2183069 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2183189),
     /* 2183074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2183077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183092 */   GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2183140), // Rule ID 52898 //
     /* 2183097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183100 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2183100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2183103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2183117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183139 */     // GIR_Coverage, 52898,
     /* 2183139 */     GIR_EraseRootFromParent_Done,
     /* 2183140 */   // Label 29913: @2183140
     /* 2183140 */   GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2183188), // Rule ID 52899 //
     /* 2183145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183148 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2183148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2183151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2183165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183187 */     // GIR_Coverage, 52899,
     /* 2183187 */     GIR_EraseRootFromParent_Done,
     /* 2183188 */   // Label 29914: @2183188
     /* 2183188 */   GIM_Reject,
     /* 2183189 */ // Label 29912: @2183189
     /* 2183189 */ GIM_Reject,
     /* 2183190 */ // Label 29859: @2183190
     /* 2183190 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2183310),
     /* 2183195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2183198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2183201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183213 */   GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2183261), // Rule ID 52814 //
     /* 2183218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183221 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2183221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2183224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2183238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183260 */     // GIR_Coverage, 52814,
     /* 2183260 */     GIR_EraseRootFromParent_Done,
     /* 2183261 */   // Label 29916: @2183261
     /* 2183261 */   GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2183309), // Rule ID 52815 //
     /* 2183266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183269 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2183269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2183272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2183286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183308 */     // GIR_Coverage, 52815,
     /* 2183308 */     GIR_EraseRootFromParent_Done,
     /* 2183309 */   // Label 29917: @2183309
     /* 2183309 */   GIM_Reject,
     /* 2183310 */ // Label 29915: @2183310
     /* 2183310 */ GIM_Reject,
     /* 2183311 */ // Label 29860: @2183311
     /* 2183311 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2183431),
     /* 2183316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2183319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183334 */   GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2183382), // Rule ID 52862 //
     /* 2183339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183342 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2183342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2183345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2183359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183381 */     // GIR_Coverage, 52862,
     /* 2183381 */     GIR_EraseRootFromParent_Done,
     /* 2183382 */   // Label 29919: @2183382
     /* 2183382 */   GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2183430), // Rule ID 52863 //
     /* 2183387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183390 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2183390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2183393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2183407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183429 */     // GIR_Coverage, 52863,
     /* 2183429 */     GIR_EraseRootFromParent_Done,
     /* 2183430 */   // Label 29920: @2183430
     /* 2183430 */   GIM_Reject,
     /* 2183431 */ // Label 29918: @2183431
     /* 2183431 */ GIM_Reject,
     /* 2183432 */ // Label 29861: @2183432
     /* 2183432 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2183552),
     /* 2183437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2183440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2183443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183455 */   GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2183503), // Rule ID 52826 //
     /* 2183460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183463 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2183463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2183466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2183480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183502 */     // GIR_Coverage, 52826,
     /* 2183502 */     GIR_EraseRootFromParent_Done,
     /* 2183503 */   // Label 29922: @2183503
     /* 2183503 */   GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2183551), // Rule ID 52827 //
     /* 2183508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183511 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2183511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2183514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2183518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2183523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2183525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2183528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2183533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2183543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2183549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183550 */     // GIR_Coverage, 52827,
     /* 2183550 */     GIR_EraseRootFromParent_Done,
     /* 2183551 */   // Label 29923: @2183551
     /* 2183551 */   GIM_Reject,
     /* 2183552 */ // Label 29921: @2183552
     /* 2183552 */ GIM_Reject,
     /* 2183553 */ // Label 29862: @2183553
     /* 2183553 */ GIM_Reject,
     /* 2183554 */ // Label 58: @2183554
     /* 2183554 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 29942*/ GIMT_Encode4(2185981),
     /* 2183565 */ /*GILLT_s16*//*Label 29924*/ GIMT_Encode4(2183685),
     /* 2183569 */ /*GILLT_s32*//*Label 29925*/ GIMT_Encode4(2183834),
     /* 2183573 */ /*GILLT_s64*//*Label 29926*/ GIMT_Encode4(2183983), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183585 */ /*GILLT_nxv1s16*//*Label 29927*/ GIMT_Encode4(2184166),
     /* 2183589 */ /*GILLT_nxv1s32*//*Label 29928*/ GIMT_Encode4(2184287),
     /* 2183593 */ /*GILLT_nxv1s64*//*Label 29929*/ GIMT_Encode4(2184408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183605 */ /*GILLT_nxv2s16*//*Label 29930*/ GIMT_Encode4(2184529),
     /* 2183609 */ /*GILLT_nxv2s32*//*Label 29931*/ GIMT_Encode4(2184650),
     /* 2183613 */ /*GILLT_nxv2s64*//*Label 29932*/ GIMT_Encode4(2184771), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183625 */ /*GILLT_nxv4s16*//*Label 29933*/ GIMT_Encode4(2184892),
     /* 2183629 */ /*GILLT_nxv4s32*//*Label 29934*/ GIMT_Encode4(2185013),
     /* 2183633 */ /*GILLT_nxv4s64*//*Label 29935*/ GIMT_Encode4(2185134), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183645 */ /*GILLT_nxv8s16*//*Label 29936*/ GIMT_Encode4(2185255),
     /* 2183649 */ /*GILLT_nxv8s32*//*Label 29937*/ GIMT_Encode4(2185376),
     /* 2183653 */ /*GILLT_nxv8s64*//*Label 29938*/ GIMT_Encode4(2185497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183665 */ /*GILLT_nxv16s16*//*Label 29939*/ GIMT_Encode4(2185618),
     /* 2183669 */ /*GILLT_nxv16s32*//*Label 29940*/ GIMT_Encode4(2185739), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2183681 */ /*GILLT_nxv32s16*//*Label 29941*/ GIMT_Encode4(2185860),
     /* 2183685 */ // Label 29924: @2183685
     /* 2183685 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2183833),
     /* 2183690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2183693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2183696 */   GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2183730), // Rule ID 1824 //
     /* 2183701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2183704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183716 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2183716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2183719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183729 */     // GIR_Coverage, 1824,
     /* 2183729 */     GIR_EraseRootFromParent_Done,
     /* 2183730 */   // Label 29944: @2183730
     /* 2183730 */   GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2183764), // Rule ID 1825 //
     /* 2183735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2183738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183750 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2183750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2183753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183763 */     // GIR_Coverage, 1825,
     /* 2183763 */     GIR_EraseRootFromParent_Done,
     /* 2183764 */   // Label 29945: @2183764
     /* 2183764 */   GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2183798), // Rule ID 1828 //
     /* 2183769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2183772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183784 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2183784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2183787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183797 */     // GIR_Coverage, 1828,
     /* 2183797 */     GIR_EraseRootFromParent_Done,
     /* 2183798 */   // Label 29946: @2183798
     /* 2183798 */   GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2183832), // Rule ID 1829 //
     /* 2183803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2183806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2183818 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2183818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2183821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183831 */     // GIR_Coverage, 1829,
     /* 2183831 */     GIR_EraseRootFromParent_Done,
     /* 2183832 */   // Label 29947: @2183832
     /* 2183832 */   GIM_Reject,
     /* 2183833 */ // Label 29943: @2183833
     /* 2183833 */ GIM_Reject,
     /* 2183834 */ // Label 29925: @2183834
     /* 2183834 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2183982),
     /* 2183839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2183842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2183845 */   GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2183879), // Rule ID 1115 //
     /* 2183850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2183853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183865 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2183865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2183868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183878 */     // GIR_Coverage, 1115,
     /* 2183878 */     GIR_EraseRootFromParent_Done,
     /* 2183879 */   // Label 29949: @2183879
     /* 2183879 */   GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2183913), // Rule ID 1116 //
     /* 2183884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2183887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183899 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2183899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2183902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183912 */     // GIR_Coverage, 1116,
     /* 2183912 */     GIR_EraseRootFromParent_Done,
     /* 2183913 */   // Label 29950: @2183913
     /* 2183913 */   GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2183947), // Rule ID 1119 //
     /* 2183918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2183921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183933 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2183933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2183936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183946 */     // GIR_Coverage, 1119,
     /* 2183946 */     GIR_EraseRootFromParent_Done,
     /* 2183947 */   // Label 29951: @2183947
     /* 2183947 */   GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2183981), // Rule ID 1120 //
     /* 2183952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2183955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2183967 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2183967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2183970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2183974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2183976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2183979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183980 */     // GIR_Coverage, 1120,
     /* 2183980 */     GIR_EraseRootFromParent_Done,
     /* 2183981 */   // Label 29952: @2183981
     /* 2183981 */   GIM_Reject,
     /* 2183982 */ // Label 29948: @2183982
     /* 2183982 */ GIM_Reject,
     /* 2183983 */ // Label 29926: @2183983
     /* 2183983 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2184165),
     /* 2183988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2183991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2183994 */   GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2184028), // Rule ID 1452 //
     /* 2183999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2184002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184014 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2184014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2184017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184027 */     // GIR_Coverage, 1452,
     /* 2184027 */     GIR_EraseRootFromParent_Done,
     /* 2184028 */   // Label 29954: @2184028
     /* 2184028 */   GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2184062), // Rule ID 1453 //
     /* 2184033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2184036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2184048 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2184048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2184051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184061 */     // GIR_Coverage, 1453,
     /* 2184061 */     GIR_EraseRootFromParent_Done,
     /* 2184062 */   // Label 29955: @2184062
     /* 2184062 */   GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2184096), // Rule ID 1456 //
     /* 2184067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2184070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184082 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2184082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2184085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184095 */     // GIR_Coverage, 1456,
     /* 2184095 */     GIR_EraseRootFromParent_Done,
     /* 2184096 */   // Label 29956: @2184096
     /* 2184096 */   GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2184130), // Rule ID 1457 //
     /* 2184101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2184104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2184116 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2184116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2184119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184129 */     // GIR_Coverage, 1457,
     /* 2184129 */     GIR_EraseRootFromParent_Done,
     /* 2184130 */   // Label 29957: @2184130
     /* 2184130 */   GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2184164), // Rule ID 1459 //
     /* 2184135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2184138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2184142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2184146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2184150 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2184150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2184153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184163 */     // GIR_Coverage, 1459,
     /* 2184163 */     GIR_EraseRootFromParent_Done,
     /* 2184164 */   // Label 29958: @2184164
     /* 2184164 */   GIM_Reject,
     /* 2184165 */ // Label 29953: @2184165
     /* 2184165 */ GIM_Reject,
     /* 2184166 */ // Label 29927: @2184166
     /* 2184166 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2184286),
     /* 2184171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2184174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2184177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184189 */   GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2184237), // Rule ID 52910 //
     /* 2184194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184197 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2184200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2184214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184236 */     // GIR_Coverage, 52910,
     /* 2184236 */     GIR_EraseRootFromParent_Done,
     /* 2184237 */   // Label 29960: @2184237
     /* 2184237 */   GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2184285), // Rule ID 52911 //
     /* 2184242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184245 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2184248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2184262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184284 */     // GIR_Coverage, 52911,
     /* 2184284 */     GIR_EraseRootFromParent_Done,
     /* 2184285 */   // Label 29961: @2184285
     /* 2184285 */   GIM_Reject,
     /* 2184286 */ // Label 29959: @2184286
     /* 2184286 */ GIM_Reject,
     /* 2184287 */ // Label 29928: @2184287
     /* 2184287 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2184407),
     /* 2184292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2184295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184310 */   GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2184358), // Rule ID 52934 //
     /* 2184315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184318 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2184321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2184335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184357 */     // GIR_Coverage, 52934,
     /* 2184357 */     GIR_EraseRootFromParent_Done,
     /* 2184358 */   // Label 29963: @2184358
     /* 2184358 */   GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2184406), // Rule ID 52935 //
     /* 2184363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184366 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2184369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2184383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184405 */     // GIR_Coverage, 52935,
     /* 2184405 */     GIR_EraseRootFromParent_Done,
     /* 2184406 */   // Label 29964: @2184406
     /* 2184406 */   GIM_Reject,
     /* 2184407 */ // Label 29962: @2184407
     /* 2184407 */ GIM_Reject,
     /* 2184408 */ // Label 29929: @2184408
     /* 2184408 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2184528),
     /* 2184413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2184416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184431 */   GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2184479), // Rule ID 52970 //
     /* 2184436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184439 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2184442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2184456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184478 */     // GIR_Coverage, 52970,
     /* 2184478 */     GIR_EraseRootFromParent_Done,
     /* 2184479 */   // Label 29966: @2184479
     /* 2184479 */   GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2184527), // Rule ID 52971 //
     /* 2184484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184487 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2184490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2184504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184526 */     // GIR_Coverage, 52971,
     /* 2184526 */     GIR_EraseRootFromParent_Done,
     /* 2184527 */   // Label 29967: @2184527
     /* 2184527 */   GIM_Reject,
     /* 2184528 */ // Label 29965: @2184528
     /* 2184528 */ GIM_Reject,
     /* 2184529 */ // Label 29930: @2184529
     /* 2184529 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2184649),
     /* 2184534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2184537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184552 */   GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2184600), // Rule ID 52922 //
     /* 2184557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184560 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2184563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2184577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184599 */     // GIR_Coverage, 52922,
     /* 2184599 */     GIR_EraseRootFromParent_Done,
     /* 2184600 */   // Label 29969: @2184600
     /* 2184600 */   GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2184648), // Rule ID 52923 //
     /* 2184605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184608 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2184611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2184625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184647 */     // GIR_Coverage, 52923,
     /* 2184647 */     GIR_EraseRootFromParent_Done,
     /* 2184648 */   // Label 29970: @2184648
     /* 2184648 */   GIM_Reject,
     /* 2184649 */ // Label 29968: @2184649
     /* 2184649 */ GIM_Reject,
     /* 2184650 */ // Label 29931: @2184650
     /* 2184650 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2184770),
     /* 2184655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2184658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184673 */   GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2184721), // Rule ID 52958 //
     /* 2184678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184681 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2184684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2184698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184720 */     // GIR_Coverage, 52958,
     /* 2184720 */     GIR_EraseRootFromParent_Done,
     /* 2184721 */   // Label 29972: @2184721
     /* 2184721 */   GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2184769), // Rule ID 52959 //
     /* 2184726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184729 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2184732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2184746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184768 */     // GIR_Coverage, 52959,
     /* 2184768 */     GIR_EraseRootFromParent_Done,
     /* 2184769 */   // Label 29973: @2184769
     /* 2184769 */   GIM_Reject,
     /* 2184770 */ // Label 29971: @2184770
     /* 2184770 */ GIM_Reject,
     /* 2184771 */ // Label 29932: @2184771
     /* 2184771 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2184891),
     /* 2184776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2184779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2184782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184794 */   GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2184842), // Rule ID 53054 //
     /* 2184799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184802 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2184805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2184819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184841 */     // GIR_Coverage, 53054,
     /* 2184841 */     GIR_EraseRootFromParent_Done,
     /* 2184842 */   // Label 29975: @2184842
     /* 2184842 */   GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2184890), // Rule ID 53055 //
     /* 2184847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184850 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2184853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2184867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184889 */     // GIR_Coverage, 53055,
     /* 2184889 */     GIR_EraseRootFromParent_Done,
     /* 2184890 */   // Label 29976: @2184890
     /* 2184890 */   GIM_Reject,
     /* 2184891 */ // Label 29974: @2184891
     /* 2184891 */ GIM_Reject,
     /* 2184892 */ // Label 29933: @2184892
     /* 2184892 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2185012),
     /* 2184897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2184900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184915 */   GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2184963), // Rule ID 52946 //
     /* 2184920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184923 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2184923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2184926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2184940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2184952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2184955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2184961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184962 */     // GIR_Coverage, 52946,
     /* 2184962 */     GIR_EraseRootFromParent_Done,
     /* 2184963 */   // Label 29978: @2184963
     /* 2184963 */   GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2185011), // Rule ID 52947 //
     /* 2184968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184971 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2184971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2184974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2184978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2184983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2184985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2184988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2184993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2184995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2184997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185010 */     // GIR_Coverage, 52947,
     /* 2185010 */     GIR_EraseRootFromParent_Done,
     /* 2185011 */   // Label 29979: @2185011
     /* 2185011 */   GIM_Reject,
     /* 2185012 */ // Label 29977: @2185012
     /* 2185012 */ GIM_Reject,
     /* 2185013 */ // Label 29934: @2185013
     /* 2185013 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2185133),
     /* 2185018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2185021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185036 */   GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2185084), // Rule ID 53018 //
     /* 2185041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185044 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2185047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2185061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185083 */     // GIR_Coverage, 53018,
     /* 2185083 */     GIR_EraseRootFromParent_Done,
     /* 2185084 */   // Label 29981: @2185084
     /* 2185084 */   GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2185132), // Rule ID 53019 //
     /* 2185089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185092 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2185095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2185109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185131 */     // GIR_Coverage, 53019,
     /* 2185131 */     GIR_EraseRootFromParent_Done,
     /* 2185132 */   // Label 29982: @2185132
     /* 2185132 */   GIM_Reject,
     /* 2185133 */ // Label 29980: @2185133
     /* 2185133 */ GIM_Reject,
     /* 2185134 */ // Label 29935: @2185134
     /* 2185134 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2185254),
     /* 2185139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2185142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185157 */   GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2185205), // Rule ID 53066 //
     /* 2185162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185165 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2185168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2185182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185204 */     // GIR_Coverage, 53066,
     /* 2185204 */     GIR_EraseRootFromParent_Done,
     /* 2185205 */   // Label 29984: @2185205
     /* 2185205 */   GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2185253), // Rule ID 53067 //
     /* 2185210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185213 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2185216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2185230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185252 */     // GIR_Coverage, 53067,
     /* 2185252 */     GIR_EraseRootFromParent_Done,
     /* 2185253 */   // Label 29985: @2185253
     /* 2185253 */   GIM_Reject,
     /* 2185254 */ // Label 29983: @2185254
     /* 2185254 */ GIM_Reject,
     /* 2185255 */ // Label 29936: @2185255
     /* 2185255 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2185375),
     /* 2185260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2185263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185278 */   GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2185326), // Rule ID 52982 //
     /* 2185283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185286 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2185289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2185303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185325 */     // GIR_Coverage, 52982,
     /* 2185325 */     GIR_EraseRootFromParent_Done,
     /* 2185326 */   // Label 29987: @2185326
     /* 2185326 */   GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2185374), // Rule ID 52983 //
     /* 2185331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185334 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2185337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2185351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185373 */     // GIR_Coverage, 52983,
     /* 2185373 */     GIR_EraseRootFromParent_Done,
     /* 2185374 */   // Label 29988: @2185374
     /* 2185374 */   GIM_Reject,
     /* 2185375 */ // Label 29986: @2185375
     /* 2185375 */ GIM_Reject,
     /* 2185376 */ // Label 29937: @2185376
     /* 2185376 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2185496),
     /* 2185381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2185384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185399 */   GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2185447), // Rule ID 53030 //
     /* 2185404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185407 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2185410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2185424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185446 */     // GIR_Coverage, 53030,
     /* 2185446 */     GIR_EraseRootFromParent_Done,
     /* 2185447 */   // Label 29990: @2185447
     /* 2185447 */   GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2185495), // Rule ID 53031 //
     /* 2185452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185455 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2185458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2185472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185494 */     // GIR_Coverage, 53031,
     /* 2185494 */     GIR_EraseRootFromParent_Done,
     /* 2185495 */   // Label 29991: @2185495
     /* 2185495 */   GIM_Reject,
     /* 2185496 */ // Label 29989: @2185496
     /* 2185496 */ GIM_Reject,
     /* 2185497 */ // Label 29938: @2185497
     /* 2185497 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2185617),
     /* 2185502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2185505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185520 */   GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2185568), // Rule ID 53078 //
     /* 2185525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185528 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2185531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2185545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185567 */     // GIR_Coverage, 53078,
     /* 2185567 */     GIR_EraseRootFromParent_Done,
     /* 2185568 */   // Label 29993: @2185568
     /* 2185568 */   GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2185616), // Rule ID 53079 //
     /* 2185573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185576 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2185579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2185593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185615 */     // GIR_Coverage, 53079,
     /* 2185615 */     GIR_EraseRootFromParent_Done,
     /* 2185616 */   // Label 29994: @2185616
     /* 2185616 */   GIM_Reject,
     /* 2185617 */ // Label 29992: @2185617
     /* 2185617 */ GIM_Reject,
     /* 2185618 */ // Label 29939: @2185618
     /* 2185618 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2185738),
     /* 2185623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2185626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185641 */   GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2185689), // Rule ID 52994 //
     /* 2185646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185649 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2185652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2185666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185688 */     // GIR_Coverage, 52994,
     /* 2185688 */     GIR_EraseRootFromParent_Done,
     /* 2185689 */   // Label 29996: @2185689
     /* 2185689 */   GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2185737), // Rule ID 52995 //
     /* 2185694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185697 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2185700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2185714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185736 */     // GIR_Coverage, 52995,
     /* 2185736 */     GIR_EraseRootFromParent_Done,
     /* 2185737 */   // Label 29997: @2185737
     /* 2185737 */   GIM_Reject,
     /* 2185738 */ // Label 29995: @2185738
     /* 2185738 */ GIM_Reject,
     /* 2185739 */ // Label 29940: @2185739
     /* 2185739 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2185859),
     /* 2185744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2185747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185762 */   GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2185810), // Rule ID 53042 //
     /* 2185767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185770 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2185773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2185787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185809 */     // GIR_Coverage, 53042,
     /* 2185809 */     GIR_EraseRootFromParent_Done,
     /* 2185810 */   // Label 29999: @2185810
     /* 2185810 */   GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2185858), // Rule ID 53043 //
     /* 2185815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185818 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2185821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2185835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185857 */     // GIR_Coverage, 53043,
     /* 2185857 */     GIR_EraseRootFromParent_Done,
     /* 2185858 */   // Label 30000: @2185858
     /* 2185858 */   GIM_Reject,
     /* 2185859 */ // Label 29998: @2185859
     /* 2185859 */ GIM_Reject,
     /* 2185860 */ // Label 29941: @2185860
     /* 2185860 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2185980),
     /* 2185865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2185868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185883 */   GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2185931), // Rule ID 53006 //
     /* 2185888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185891 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2185891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2185894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2185908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185930 */     // GIR_Coverage, 53006,
     /* 2185930 */     GIR_EraseRootFromParent_Done,
     /* 2185931 */   // Label 30002: @2185931
     /* 2185931 */   GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2185979), // Rule ID 53007 //
     /* 2185936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185939 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2185939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2185942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2185946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2185951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2185953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2185956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2185961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2185963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2185965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2185968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2185971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2185977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185978 */     // GIR_Coverage, 53007,
     /* 2185978 */     GIR_EraseRootFromParent_Done,
     /* 2185979 */   // Label 30003: @2185979
     /* 2185979 */   GIM_Reject,
     /* 2185980 */ // Label 30001: @2185980
     /* 2185980 */ GIM_Reject,
     /* 2185981 */ // Label 29942: @2185981
     /* 2185981 */ GIM_Reject,
     /* 2185982 */ // Label 59: @2185982
     /* 2185982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30022*/ GIMT_Encode4(2188409),
     /* 2185993 */ /*GILLT_s16*//*Label 30004*/ GIMT_Encode4(2186113),
     /* 2185997 */ /*GILLT_s32*//*Label 30005*/ GIMT_Encode4(2186262),
     /* 2186001 */ /*GILLT_s64*//*Label 30006*/ GIMT_Encode4(2186411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186013 */ /*GILLT_nxv1s16*//*Label 30007*/ GIMT_Encode4(2186594),
     /* 2186017 */ /*GILLT_nxv1s32*//*Label 30008*/ GIMT_Encode4(2186715),
     /* 2186021 */ /*GILLT_nxv1s64*//*Label 30009*/ GIMT_Encode4(2186836), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186033 */ /*GILLT_nxv2s16*//*Label 30010*/ GIMT_Encode4(2186957),
     /* 2186037 */ /*GILLT_nxv2s32*//*Label 30011*/ GIMT_Encode4(2187078),
     /* 2186041 */ /*GILLT_nxv2s64*//*Label 30012*/ GIMT_Encode4(2187199), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186053 */ /*GILLT_nxv4s16*//*Label 30013*/ GIMT_Encode4(2187320),
     /* 2186057 */ /*GILLT_nxv4s32*//*Label 30014*/ GIMT_Encode4(2187441),
     /* 2186061 */ /*GILLT_nxv4s64*//*Label 30015*/ GIMT_Encode4(2187562), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186073 */ /*GILLT_nxv8s16*//*Label 30016*/ GIMT_Encode4(2187683),
     /* 2186077 */ /*GILLT_nxv8s32*//*Label 30017*/ GIMT_Encode4(2187804),
     /* 2186081 */ /*GILLT_nxv8s64*//*Label 30018*/ GIMT_Encode4(2187925), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186093 */ /*GILLT_nxv16s16*//*Label 30019*/ GIMT_Encode4(2188046),
     /* 2186097 */ /*GILLT_nxv16s32*//*Label 30020*/ GIMT_Encode4(2188167), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2186109 */ /*GILLT_nxv32s16*//*Label 30021*/ GIMT_Encode4(2188288),
     /* 2186113 */ // Label 30004: @2186113
     /* 2186113 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2186261),
     /* 2186118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2186121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2186124 */   GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2186158), // Rule ID 1832 //
     /* 2186129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2186132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186144 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2186144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2186147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186157 */     // GIR_Coverage, 1832,
     /* 2186157 */     GIR_EraseRootFromParent_Done,
     /* 2186158 */   // Label 30024: @2186158
     /* 2186158 */   GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2186192), // Rule ID 1833 //
     /* 2186163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2186166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186178 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2186178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2186181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186191 */     // GIR_Coverage, 1833,
     /* 2186191 */     GIR_EraseRootFromParent_Done,
     /* 2186192 */   // Label 30025: @2186192
     /* 2186192 */   GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2186226), // Rule ID 1836 //
     /* 2186197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2186200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186212 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2186212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2186215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186225 */     // GIR_Coverage, 1836,
     /* 2186225 */     GIR_EraseRootFromParent_Done,
     /* 2186226 */   // Label 30026: @2186226
     /* 2186226 */   GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2186260), // Rule ID 1837 //
     /* 2186231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2186234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2186246 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2186246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2186249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186259 */     // GIR_Coverage, 1837,
     /* 2186259 */     GIR_EraseRootFromParent_Done,
     /* 2186260 */   // Label 30027: @2186260
     /* 2186260 */   GIM_Reject,
     /* 2186261 */ // Label 30023: @2186261
     /* 2186261 */ GIM_Reject,
     /* 2186262 */ // Label 30005: @2186262
     /* 2186262 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2186410),
     /* 2186267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2186270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2186273 */   GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2186307), // Rule ID 1123 //
     /* 2186278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2186281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186293 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2186293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2186296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186306 */     // GIR_Coverage, 1123,
     /* 2186306 */     GIR_EraseRootFromParent_Done,
     /* 2186307 */   // Label 30029: @2186307
     /* 2186307 */   GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2186341), // Rule ID 1124 //
     /* 2186312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2186315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186327 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2186327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2186330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186340 */     // GIR_Coverage, 1124,
     /* 2186340 */     GIR_EraseRootFromParent_Done,
     /* 2186341 */   // Label 30030: @2186341
     /* 2186341 */   GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2186375), // Rule ID 1127 //
     /* 2186346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2186349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186361 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2186361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2186364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186374 */     // GIR_Coverage, 1127,
     /* 2186374 */     GIR_EraseRootFromParent_Done,
     /* 2186375 */   // Label 30031: @2186375
     /* 2186375 */   GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2186409), // Rule ID 1128 //
     /* 2186380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2186383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2186395 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2186395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2186398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186408 */     // GIR_Coverage, 1128,
     /* 2186408 */     GIR_EraseRootFromParent_Done,
     /* 2186409 */   // Label 30032: @2186409
     /* 2186409 */   GIM_Reject,
     /* 2186410 */ // Label 30028: @2186410
     /* 2186410 */ GIM_Reject,
     /* 2186411 */ // Label 30006: @2186411
     /* 2186411 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2186593),
     /* 2186416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2186419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2186422 */   GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2186456), // Rule ID 1462 //
     /* 2186427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2186430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186442 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2186442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2186445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186455 */     // GIR_Coverage, 1462,
     /* 2186455 */     GIR_EraseRootFromParent_Done,
     /* 2186456 */   // Label 30034: @2186456
     /* 2186456 */   GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2186490), // Rule ID 1463 //
     /* 2186461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2186464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186476 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2186476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2186479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186489 */     // GIR_Coverage, 1463,
     /* 2186489 */     GIR_EraseRootFromParent_Done,
     /* 2186490 */   // Label 30035: @2186490
     /* 2186490 */   GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2186524), // Rule ID 1466 //
     /* 2186495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2186498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186510 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2186510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2186513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186523 */     // GIR_Coverage, 1466,
     /* 2186523 */     GIR_EraseRootFromParent_Done,
     /* 2186524 */   // Label 30036: @2186524
     /* 2186524 */   GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2186558), // Rule ID 1467 //
     /* 2186529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2186532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2186544 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2186544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2186547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186557 */     // GIR_Coverage, 1467,
     /* 2186557 */     GIR_EraseRootFromParent_Done,
     /* 2186558 */   // Label 30037: @2186558
     /* 2186558 */   GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2186592), // Rule ID 1469 //
     /* 2186563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2186566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2186570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2186574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2186578 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2186578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2186581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186591 */     // GIR_Coverage, 1469,
     /* 2186591 */     GIR_EraseRootFromParent_Done,
     /* 2186592 */   // Label 30038: @2186592
     /* 2186592 */   GIM_Reject,
     /* 2186593 */ // Label 30033: @2186593
     /* 2186593 */ GIM_Reject,
     /* 2186594 */ // Label 30007: @2186594
     /* 2186594 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2186714),
     /* 2186599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2186602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186617 */   GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2186665), // Rule ID 53678 //
     /* 2186622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186625 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2186625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2186628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2186642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186664 */     // GIR_Coverage, 53678,
     /* 2186664 */     GIR_EraseRootFromParent_Done,
     /* 2186665 */   // Label 30040: @2186665
     /* 2186665 */   GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2186713), // Rule ID 53679 //
     /* 2186670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186673 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2186673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2186676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2186690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186712 */     // GIR_Coverage, 53679,
     /* 2186712 */     GIR_EraseRootFromParent_Done,
     /* 2186713 */   // Label 30041: @2186713
     /* 2186713 */   GIM_Reject,
     /* 2186714 */ // Label 30039: @2186714
     /* 2186714 */ GIM_Reject,
     /* 2186715 */ // Label 30008: @2186715
     /* 2186715 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2186835),
     /* 2186720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2186723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186738 */   GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2186786), // Rule ID 53702 //
     /* 2186743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186746 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2186746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2186749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2186763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186785 */     // GIR_Coverage, 53702,
     /* 2186785 */     GIR_EraseRootFromParent_Done,
     /* 2186786 */   // Label 30043: @2186786
     /* 2186786 */   GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2186834), // Rule ID 53703 //
     /* 2186791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186794 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2186794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2186797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2186811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186833 */     // GIR_Coverage, 53703,
     /* 2186833 */     GIR_EraseRootFromParent_Done,
     /* 2186834 */   // Label 30044: @2186834
     /* 2186834 */   GIM_Reject,
     /* 2186835 */ // Label 30042: @2186835
     /* 2186835 */ GIM_Reject,
     /* 2186836 */ // Label 30009: @2186836
     /* 2186836 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2186956),
     /* 2186841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2186844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2186847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186859 */   GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2186907), // Rule ID 53738 //
     /* 2186864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186867 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2186867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2186870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2186884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186906 */     // GIR_Coverage, 53738,
     /* 2186906 */     GIR_EraseRootFromParent_Done,
     /* 2186907 */   // Label 30046: @2186907
     /* 2186907 */   GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2186955), // Rule ID 53739 //
     /* 2186912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186915 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2186915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2186918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2186927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2186929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2186932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2186937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2186939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2186941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2186944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2186947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2186953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186954 */     // GIR_Coverage, 53739,
     /* 2186954 */     GIR_EraseRootFromParent_Done,
     /* 2186955 */   // Label 30047: @2186955
     /* 2186955 */   GIM_Reject,
     /* 2186956 */ // Label 30045: @2186956
     /* 2186956 */ GIM_Reject,
     /* 2186957 */ // Label 30010: @2186957
     /* 2186957 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2187077),
     /* 2186962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2186965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186980 */   GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2187028), // Rule ID 53690 //
     /* 2186985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186988 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2186988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2186991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2186995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2187005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187027 */     // GIR_Coverage, 53690,
     /* 2187027 */     GIR_EraseRootFromParent_Done,
     /* 2187028 */   // Label 30049: @2187028
     /* 2187028 */   GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2187076), // Rule ID 53691 //
     /* 2187033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187036 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2187039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2187053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187075 */     // GIR_Coverage, 53691,
     /* 2187075 */     GIR_EraseRootFromParent_Done,
     /* 2187076 */   // Label 30050: @2187076
     /* 2187076 */   GIM_Reject,
     /* 2187077 */ // Label 30048: @2187077
     /* 2187077 */ GIM_Reject,
     /* 2187078 */ // Label 30011: @2187078
     /* 2187078 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2187198),
     /* 2187083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2187086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187101 */   GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2187149), // Rule ID 53726 //
     /* 2187106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187109 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2187112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2187126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187148 */     // GIR_Coverage, 53726,
     /* 2187148 */     GIR_EraseRootFromParent_Done,
     /* 2187149 */   // Label 30052: @2187149
     /* 2187149 */   GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2187197), // Rule ID 53727 //
     /* 2187154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187157 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2187160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2187174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187196 */     // GIR_Coverage, 53727,
     /* 2187196 */     GIR_EraseRootFromParent_Done,
     /* 2187197 */   // Label 30053: @2187197
     /* 2187197 */   GIM_Reject,
     /* 2187198 */ // Label 30051: @2187198
     /* 2187198 */ GIM_Reject,
     /* 2187199 */ // Label 30012: @2187199
     /* 2187199 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2187319),
     /* 2187204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2187207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2187210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187222 */   GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2187270), // Rule ID 53822 //
     /* 2187227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187230 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2187233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2187247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187269 */     // GIR_Coverage, 53822,
     /* 2187269 */     GIR_EraseRootFromParent_Done,
     /* 2187270 */   // Label 30055: @2187270
     /* 2187270 */   GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2187318), // Rule ID 53823 //
     /* 2187275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187278 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2187281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2187295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187317 */     // GIR_Coverage, 53823,
     /* 2187317 */     GIR_EraseRootFromParent_Done,
     /* 2187318 */   // Label 30056: @2187318
     /* 2187318 */   GIM_Reject,
     /* 2187319 */ // Label 30054: @2187319
     /* 2187319 */ GIM_Reject,
     /* 2187320 */ // Label 30013: @2187320
     /* 2187320 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2187440),
     /* 2187325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2187328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187343 */   GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2187391), // Rule ID 53714 //
     /* 2187348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187351 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2187354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2187368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187390 */     // GIR_Coverage, 53714,
     /* 2187390 */     GIR_EraseRootFromParent_Done,
     /* 2187391 */   // Label 30058: @2187391
     /* 2187391 */   GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2187439), // Rule ID 53715 //
     /* 2187396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187399 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2187402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2187416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187438 */     // GIR_Coverage, 53715,
     /* 2187438 */     GIR_EraseRootFromParent_Done,
     /* 2187439 */   // Label 30059: @2187439
     /* 2187439 */   GIM_Reject,
     /* 2187440 */ // Label 30057: @2187440
     /* 2187440 */ GIM_Reject,
     /* 2187441 */ // Label 30014: @2187441
     /* 2187441 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2187561),
     /* 2187446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2187449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187464 */   GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2187512), // Rule ID 53786 //
     /* 2187469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187472 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2187475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2187489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187511 */     // GIR_Coverage, 53786,
     /* 2187511 */     GIR_EraseRootFromParent_Done,
     /* 2187512 */   // Label 30061: @2187512
     /* 2187512 */   GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2187560), // Rule ID 53787 //
     /* 2187517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187520 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2187523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2187537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187559 */     // GIR_Coverage, 53787,
     /* 2187559 */     GIR_EraseRootFromParent_Done,
     /* 2187560 */   // Label 30062: @2187560
     /* 2187560 */   GIM_Reject,
     /* 2187561 */ // Label 30060: @2187561
     /* 2187561 */ GIM_Reject,
     /* 2187562 */ // Label 30015: @2187562
     /* 2187562 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2187682),
     /* 2187567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2187570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2187573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187585 */   GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2187633), // Rule ID 53834 //
     /* 2187590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187593 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2187596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2187610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187632 */     // GIR_Coverage, 53834,
     /* 2187632 */     GIR_EraseRootFromParent_Done,
     /* 2187633 */   // Label 30064: @2187633
     /* 2187633 */   GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2187681), // Rule ID 53835 //
     /* 2187638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187641 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2187644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2187658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187680 */     // GIR_Coverage, 53835,
     /* 2187680 */     GIR_EraseRootFromParent_Done,
     /* 2187681 */   // Label 30065: @2187681
     /* 2187681 */   GIM_Reject,
     /* 2187682 */ // Label 30063: @2187682
     /* 2187682 */ GIM_Reject,
     /* 2187683 */ // Label 30016: @2187683
     /* 2187683 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2187803),
     /* 2187688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2187691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187706 */   GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2187754), // Rule ID 53750 //
     /* 2187711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187714 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2187717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2187731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187753 */     // GIR_Coverage, 53750,
     /* 2187753 */     GIR_EraseRootFromParent_Done,
     /* 2187754 */   // Label 30067: @2187754
     /* 2187754 */   GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2187802), // Rule ID 53751 //
     /* 2187759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187762 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2187765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2187779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187801 */     // GIR_Coverage, 53751,
     /* 2187801 */     GIR_EraseRootFromParent_Done,
     /* 2187802 */   // Label 30068: @2187802
     /* 2187802 */   GIM_Reject,
     /* 2187803 */ // Label 30066: @2187803
     /* 2187803 */ GIM_Reject,
     /* 2187804 */ // Label 30017: @2187804
     /* 2187804 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2187924),
     /* 2187809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2187812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2187815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187827 */   GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2187875), // Rule ID 53798 //
     /* 2187832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187835 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2187838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2187852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187874 */     // GIR_Coverage, 53798,
     /* 2187874 */     GIR_EraseRootFromParent_Done,
     /* 2187875 */   // Label 30070: @2187875
     /* 2187875 */   GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2187923), // Rule ID 53799 //
     /* 2187880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187883 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2187883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2187886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2187900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187922 */     // GIR_Coverage, 53799,
     /* 2187922 */     GIR_EraseRootFromParent_Done,
     /* 2187923 */   // Label 30071: @2187923
     /* 2187923 */   GIM_Reject,
     /* 2187924 */ // Label 30069: @2187924
     /* 2187924 */ GIM_Reject,
     /* 2187925 */ // Label 30018: @2187925
     /* 2187925 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2188045),
     /* 2187930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2187933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2187936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187948 */   GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2187996), // Rule ID 53846 //
     /* 2187953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187956 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2187956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2187959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2187963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2187968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2187970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2187973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2187980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2187982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2187985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2187988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2187994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187995 */     // GIR_Coverage, 53846,
     /* 2187995 */     GIR_EraseRootFromParent_Done,
     /* 2187996 */   // Label 30073: @2187996
     /* 2187996 */   GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2188044), // Rule ID 53847 //
     /* 2188001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188004 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2188004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2188007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2188021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188043 */     // GIR_Coverage, 53847,
     /* 2188043 */     GIR_EraseRootFromParent_Done,
     /* 2188044 */   // Label 30074: @2188044
     /* 2188044 */   GIM_Reject,
     /* 2188045 */ // Label 30072: @2188045
     /* 2188045 */ GIM_Reject,
     /* 2188046 */ // Label 30019: @2188046
     /* 2188046 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2188166),
     /* 2188051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2188054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2188057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188069 */   GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2188117), // Rule ID 53762 //
     /* 2188074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188077 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2188077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2188080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2188094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188116 */     // GIR_Coverage, 53762,
     /* 2188116 */     GIR_EraseRootFromParent_Done,
     /* 2188117 */   // Label 30076: @2188117
     /* 2188117 */   GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2188165), // Rule ID 53763 //
     /* 2188122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188125 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2188125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2188128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2188142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188164 */     // GIR_Coverage, 53763,
     /* 2188164 */     GIR_EraseRootFromParent_Done,
     /* 2188165 */   // Label 30077: @2188165
     /* 2188165 */   GIM_Reject,
     /* 2188166 */ // Label 30075: @2188166
     /* 2188166 */ GIM_Reject,
     /* 2188167 */ // Label 30020: @2188167
     /* 2188167 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2188287),
     /* 2188172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2188175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188190 */   GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2188238), // Rule ID 53810 //
     /* 2188195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188198 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2188198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2188201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2188215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188237 */     // GIR_Coverage, 53810,
     /* 2188237 */     GIR_EraseRootFromParent_Done,
     /* 2188238 */   // Label 30079: @2188238
     /* 2188238 */   GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2188286), // Rule ID 53811 //
     /* 2188243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188246 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2188246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2188249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2188263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188285 */     // GIR_Coverage, 53811,
     /* 2188285 */     GIR_EraseRootFromParent_Done,
     /* 2188286 */   // Label 30080: @2188286
     /* 2188286 */   GIM_Reject,
     /* 2188287 */ // Label 30078: @2188287
     /* 2188287 */ GIM_Reject,
     /* 2188288 */ // Label 30021: @2188288
     /* 2188288 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2188408),
     /* 2188293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2188296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188311 */   GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2188359), // Rule ID 53774 //
     /* 2188316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188319 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2188319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2188322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2188336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188358 */     // GIR_Coverage, 53774,
     /* 2188358 */     GIR_EraseRootFromParent_Done,
     /* 2188359 */   // Label 30082: @2188359
     /* 2188359 */   GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2188407), // Rule ID 53775 //
     /* 2188364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188367 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2188367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2188370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2188374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2188379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2188381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2188384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2188389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2188391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2188399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2188405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188406 */     // GIR_Coverage, 53775,
     /* 2188406 */     GIR_EraseRootFromParent_Done,
     /* 2188407 */   // Label 30083: @2188407
     /* 2188407 */   GIM_Reject,
     /* 2188408 */ // Label 30081: @2188408
     /* 2188408 */ GIM_Reject,
     /* 2188409 */ // Label 30022: @2188409
     /* 2188409 */ GIM_Reject,
     /* 2188410 */ // Label 60: @2188410
     /* 2188410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30102*/ GIMT_Encode4(2205054),
     /* 2188421 */ /*GILLT_s16*//*Label 30084*/ GIMT_Encode4(2188541),
     /* 2188425 */ /*GILLT_s32*//*Label 30085*/ GIMT_Encode4(2189977),
     /* 2188429 */ /*GILLT_s64*//*Label 30086*/ GIMT_Encode4(2191413), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188441 */ /*GILLT_nxv1s16*//*Label 30087*/ GIMT_Encode4(2193204),
     /* 2188445 */ /*GILLT_nxv1s32*//*Label 30088*/ GIMT_Encode4(2193994),
     /* 2188449 */ /*GILLT_nxv1s64*//*Label 30089*/ GIMT_Encode4(2194784), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188461 */ /*GILLT_nxv2s16*//*Label 30090*/ GIMT_Encode4(2195574),
     /* 2188465 */ /*GILLT_nxv2s32*//*Label 30091*/ GIMT_Encode4(2196364),
     /* 2188469 */ /*GILLT_nxv2s64*//*Label 30092*/ GIMT_Encode4(2197154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188481 */ /*GILLT_nxv4s16*//*Label 30093*/ GIMT_Encode4(2197944),
     /* 2188485 */ /*GILLT_nxv4s32*//*Label 30094*/ GIMT_Encode4(2198734),
     /* 2188489 */ /*GILLT_nxv4s64*//*Label 30095*/ GIMT_Encode4(2199524), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188501 */ /*GILLT_nxv8s16*//*Label 30096*/ GIMT_Encode4(2200314),
     /* 2188505 */ /*GILLT_nxv8s32*//*Label 30097*/ GIMT_Encode4(2201104),
     /* 2188509 */ /*GILLT_nxv8s64*//*Label 30098*/ GIMT_Encode4(2201894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188521 */ /*GILLT_nxv16s16*//*Label 30099*/ GIMT_Encode4(2202684),
     /* 2188525 */ /*GILLT_nxv16s32*//*Label 30100*/ GIMT_Encode4(2203474), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2188537 */ /*GILLT_nxv32s16*//*Label 30101*/ GIMT_Encode4(2204264),
     /* 2188541 */ // Label 30084: @2188541
     /* 2188541 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2189976),
     /* 2188546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2188552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188555 */   GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2188627), // Rule ID 1873 //
     /* 2188560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2188563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2188571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188607 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2188607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2188610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188626 */     // GIR_Coverage, 1873,
     /* 2188626 */     GIR_EraseRootFromParent_Done,
     /* 2188627 */   // Label 30104: @2188627
     /* 2188627 */   GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2188699), // Rule ID 1874 //
     /* 2188632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2188635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2188643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188679 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2188679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2188682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188698 */     // GIR_Coverage, 1874,
     /* 2188698 */     GIR_EraseRootFromParent_Done,
     /* 2188699 */   // Label 30105: @2188699
     /* 2188699 */   GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2188771), // Rule ID 1906 //
     /* 2188704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2188707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2188715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188751 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2188751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2188754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188770 */     // GIR_Coverage, 1906,
     /* 2188770 */     GIR_EraseRootFromParent_Done,
     /* 2188771 */   // Label 30106: @2188771
     /* 2188771 */   GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2188843), // Rule ID 1907 //
     /* 2188776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2188779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2188787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188823 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2188823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2188826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2188834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188842 */     // GIR_Coverage, 1907,
     /* 2188842 */     GIR_EraseRootFromParent_Done,
     /* 2188843 */   // Label 30107: @2188843
     /* 2188843 */   GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2188915), // Rule ID 64033 //
     /* 2188848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2188851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2188863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188895 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2188895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2188898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2188906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188914 */     // GIR_Coverage, 64033,
     /* 2188914 */     GIR_EraseRootFromParent_Done,
     /* 2188915 */   // Label 30108: @2188915
     /* 2188915 */   GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2188987), // Rule ID 64034 //
     /* 2188920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2188923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2188935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2188952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2188956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2188960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2188967 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2188967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2188970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2188976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2188978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2188982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2188985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188986 */     // GIR_Coverage, 64034,
     /* 2188986 */     GIR_EraseRootFromParent_Done,
     /* 2188987 */   // Label 30109: @2188987
     /* 2188987 */   GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2189059), // Rule ID 64041 //
     /* 2188992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2188995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2188999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2189024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2189039 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2189042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2189054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189058 */     // GIR_Coverage, 64041,
     /* 2189058 */     GIR_EraseRootFromParent_Done,
     /* 2189059 */   // Label 30110: @2189059
     /* 2189059 */   GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2189131), // Rule ID 64042 //
     /* 2189064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2189067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2189096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2189111 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2189114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2189126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189130 */     // GIR_Coverage, 64042,
     /* 2189130 */     GIR_EraseRootFromParent_Done,
     /* 2189131 */   // Label 30111: @2189131
     /* 2189131 */   GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2189188), // Rule ID 1869 //
     /* 2189136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2189139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2189147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189170 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2189173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189187 */     // GIR_Coverage, 1869,
     /* 2189187 */     GIR_EraseRootFromParent_Done,
     /* 2189188 */   // Label 30112: @2189188
     /* 2189188 */   GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2189245), // Rule ID 1870 //
     /* 2189193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2189196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2189204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189227 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2189230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189244 */     // GIR_Coverage, 1870,
     /* 2189244 */     GIR_EraseRootFromParent_Done,
     /* 2189245 */   // Label 30113: @2189245
     /* 2189245 */   GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2189302), // Rule ID 1902 //
     /* 2189250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2189253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2189261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189284 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2189287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189301 */     // GIR_Coverage, 1902,
     /* 2189301 */     GIR_EraseRootFromParent_Done,
     /* 2189302 */   // Label 30114: @2189302
     /* 2189302 */   GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2189359), // Rule ID 1903 //
     /* 2189307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2189310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2189318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189341 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2189344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189358 */     // GIR_Coverage, 1903,
     /* 2189358 */     GIR_EraseRootFromParent_Done,
     /* 2189359 */   // Label 30115: @2189359
     /* 2189359 */   GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2189416), // Rule ID 64029 //
     /* 2189364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2189367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189398 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2189401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189415 */     // GIR_Coverage, 64029,
     /* 2189415 */     GIR_EraseRootFromParent_Done,
     /* 2189416 */   // Label 30116: @2189416
     /* 2189416 */   GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2189473), // Rule ID 64030 //
     /* 2189421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2189424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189455 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2189458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189472 */     // GIR_Coverage, 64030,
     /* 2189472 */     GIR_EraseRootFromParent_Done,
     /* 2189473 */   // Label 30117: @2189473
     /* 2189473 */   GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2189530), // Rule ID 64037 //
     /* 2189478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2189481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189512 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2189515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189529 */     // GIR_Coverage, 64037,
     /* 2189529 */     GIR_EraseRootFromParent_Done,
     /* 2189530 */   // Label 30118: @2189530
     /* 2189530 */   GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2189587), // Rule ID 64038 //
     /* 2189535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2189538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2189550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189569 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2189572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2189578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2189580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189586 */     // GIR_Coverage, 64038,
     /* 2189586 */     GIR_EraseRootFromParent_Done,
     /* 2189587 */   // Label 30119: @2189587
     /* 2189587 */   GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2189644), // Rule ID 1865 //
     /* 2189592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2189595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2189611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189626 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2189629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2189639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189643 */     // GIR_Coverage, 1865,
     /* 2189643 */     GIR_EraseRootFromParent_Done,
     /* 2189644 */   // Label 30120: @2189644
     /* 2189644 */   GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2189701), // Rule ID 1866 //
     /* 2189649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2189652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2189668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189683 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2189686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2189696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189700 */     // GIR_Coverage, 1866,
     /* 2189700 */     GIR_EraseRootFromParent_Done,
     /* 2189701 */   // Label 30121: @2189701
     /* 2189701 */   GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2189758), // Rule ID 1898 //
     /* 2189706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2189709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2189725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189740 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2189743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2189753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189757 */     // GIR_Coverage, 1898,
     /* 2189757 */     GIR_EraseRootFromParent_Done,
     /* 2189758 */   // Label 30122: @2189758
     /* 2189758 */   GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2189815), // Rule ID 1899 //
     /* 2189763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2189766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2189782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2189786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2189790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2189797 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2189800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2189810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189814 */     // GIR_Coverage, 1899,
     /* 2189814 */     GIR_EraseRootFromParent_Done,
     /* 2189815 */   // Label 30123: @2189815
     /* 2189815 */   GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2189855), // Rule ID 1861 //
     /* 2189820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2189823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189839 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2189842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189854 */     // GIR_Coverage, 1861,
     /* 2189854 */     GIR_EraseRootFromParent_Done,
     /* 2189855 */   // Label 30124: @2189855
     /* 2189855 */   GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2189895), // Rule ID 1862 //
     /* 2189860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2189863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189879 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2189882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189894 */     // GIR_Coverage, 1862,
     /* 2189894 */     GIR_EraseRootFromParent_Done,
     /* 2189895 */   // Label 30125: @2189895
     /* 2189895 */   GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2189935), // Rule ID 1894 //
     /* 2189900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2189903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189919 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2189919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2189922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189934 */     // GIR_Coverage, 1894,
     /* 2189934 */     GIR_EraseRootFromParent_Done,
     /* 2189935 */   // Label 30126: @2189935
     /* 2189935 */   GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2189975), // Rule ID 1895 //
     /* 2189940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2189943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2189959 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2189959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2189962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2189966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2189968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2189970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2189973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189974 */     // GIR_Coverage, 1895,
     /* 2189974 */     GIR_EraseRootFromParent_Done,
     /* 2189975 */   // Label 30127: @2189975
     /* 2189975 */   GIM_Reject,
     /* 2189976 */ // Label 30103: @2189976
     /* 2189976 */ GIM_Reject,
     /* 2189977 */ // Label 30085: @2189977
     /* 2189977 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2191412),
     /* 2189982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2189985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2189988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2189991 */   GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2190063), // Rule ID 1172 //
     /* 2189996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2189999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190043 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2190046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190062 */     // GIR_Coverage, 1172,
     /* 2190062 */     GIR_EraseRootFromParent_Done,
     /* 2190063 */   // Label 30129: @2190063
     /* 2190063 */   GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2190135), // Rule ID 1173 //
     /* 2190068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2190071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190115 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2190118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190134 */     // GIR_Coverage, 1173,
     /* 2190134 */     GIR_EraseRootFromParent_Done,
     /* 2190135 */   // Label 30130: @2190135
     /* 2190135 */   GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2190207), // Rule ID 1193 //
     /* 2190140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2190143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190187 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2190190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190206 */     // GIR_Coverage, 1193,
     /* 2190206 */     GIR_EraseRootFromParent_Done,
     /* 2190207 */   // Label 30131: @2190207
     /* 2190207 */   GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2190279), // Rule ID 1194 //
     /* 2190212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2190215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190259 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2190262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190278 */     // GIR_Coverage, 1194,
     /* 2190278 */     GIR_EraseRootFromParent_Done,
     /* 2190279 */   // Label 30132: @2190279
     /* 2190279 */   GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2190351), // Rule ID 63997 //
     /* 2190284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2190287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190331 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2190334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190350 */     // GIR_Coverage, 63997,
     /* 2190350 */     GIR_EraseRootFromParent_Done,
     /* 2190351 */   // Label 30133: @2190351
     /* 2190351 */   GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2190423), // Rule ID 63998 //
     /* 2190356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2190359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190403 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2190406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190422 */     // GIR_Coverage, 63998,
     /* 2190422 */     GIR_EraseRootFromParent_Done,
     /* 2190423 */   // Label 30134: @2190423
     /* 2190423 */   GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2190495), // Rule ID 64005 //
     /* 2190428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2190431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190475 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2190478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190494 */     // GIR_Coverage, 64005,
     /* 2190494 */     GIR_EraseRootFromParent_Done,
     /* 2190495 */   // Label 30135: @2190495
     /* 2190495 */   GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2190567), // Rule ID 64006 //
     /* 2190500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2190503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2190532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2190547 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2190550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2190562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190566 */     // GIR_Coverage, 64006,
     /* 2190566 */     GIR_EraseRootFromParent_Done,
     /* 2190567 */   // Label 30136: @2190567
     /* 2190567 */   GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2190624), // Rule ID 1168 //
     /* 2190572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2190575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190606 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2190609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190623 */     // GIR_Coverage, 1168,
     /* 2190623 */     GIR_EraseRootFromParent_Done,
     /* 2190624 */   // Label 30137: @2190624
     /* 2190624 */   GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2190681), // Rule ID 1169 //
     /* 2190629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2190632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190663 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2190666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190680 */     // GIR_Coverage, 1169,
     /* 2190680 */     GIR_EraseRootFromParent_Done,
     /* 2190681 */   // Label 30138: @2190681
     /* 2190681 */   GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2190738), // Rule ID 1189 //
     /* 2190686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2190689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190720 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2190723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190737 */     // GIR_Coverage, 1189,
     /* 2190737 */     GIR_EraseRootFromParent_Done,
     /* 2190738 */   // Label 30139: @2190738
     /* 2190738 */   GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2190795), // Rule ID 1190 //
     /* 2190743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2190746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2190754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190777 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2190780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2190788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190794 */     // GIR_Coverage, 1190,
     /* 2190794 */     GIR_EraseRootFromParent_Done,
     /* 2190795 */   // Label 30140: @2190795
     /* 2190795 */   GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2190852), // Rule ID 63993 //
     /* 2190800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2190803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190834 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2190837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190851 */     // GIR_Coverage, 63993,
     /* 2190851 */     GIR_EraseRootFromParent_Done,
     /* 2190852 */   // Label 30141: @2190852
     /* 2190852 */   GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2190909), // Rule ID 63994 //
     /* 2190857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2190860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190891 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2190891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2190894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190908 */     // GIR_Coverage, 63994,
     /* 2190908 */     GIR_EraseRootFromParent_Done,
     /* 2190909 */   // Label 30142: @2190909
     /* 2190909 */   GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2190966), // Rule ID 64001 //
     /* 2190914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2190917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2190948 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2190948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2190951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2190957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2190959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2190961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2190964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190965 */     // GIR_Coverage, 64001,
     /* 2190965 */     GIR_EraseRootFromParent_Done,
     /* 2190966 */   // Label 30143: @2190966
     /* 2190966 */   GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2191023), // Rule ID 64002 //
     /* 2190971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2190974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2190986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2190990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2190994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2190999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2191005 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2191005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2191008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2191016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2191018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191022 */     // GIR_Coverage, 64002,
     /* 2191022 */     GIR_EraseRootFromParent_Done,
     /* 2191023 */   // Label 30144: @2191023
     /* 2191023 */   GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2191080), // Rule ID 1164 //
     /* 2191028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2191031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2191047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2191055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2191062 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2191062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2191065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2191075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191079 */     // GIR_Coverage, 1164,
     /* 2191079 */     GIR_EraseRootFromParent_Done,
     /* 2191080 */   // Label 30145: @2191080
     /* 2191080 */   GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2191137), // Rule ID 1165 //
     /* 2191085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2191088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2191104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2191112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2191119 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2191119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2191122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2191132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191136 */     // GIR_Coverage, 1165,
     /* 2191136 */     GIR_EraseRootFromParent_Done,
     /* 2191137 */   // Label 30146: @2191137
     /* 2191137 */   GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2191194), // Rule ID 1185 //
     /* 2191142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2191145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2191161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2191169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2191176 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2191176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2191179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2191189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191193 */     // GIR_Coverage, 1185,
     /* 2191193 */     GIR_EraseRootFromParent_Done,
     /* 2191194 */   // Label 30147: @2191194
     /* 2191194 */   GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2191251), // Rule ID 1186 //
     /* 2191199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2191202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2191218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2191226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2191233 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2191233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2191236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2191246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191250 */     // GIR_Coverage, 1186,
     /* 2191250 */     GIR_EraseRootFromParent_Done,
     /* 2191251 */   // Label 30148: @2191251
     /* 2191251 */   GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2191291), // Rule ID 1160 //
     /* 2191256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2191259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191275 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2191275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2191278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2191286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191290 */     // GIR_Coverage, 1160,
     /* 2191290 */     GIR_EraseRootFromParent_Done,
     /* 2191291 */   // Label 30149: @2191291
     /* 2191291 */   GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2191331), // Rule ID 1161 //
     /* 2191296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2191299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191315 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2191315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2191318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2191326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191330 */     // GIR_Coverage, 1161,
     /* 2191330 */     GIR_EraseRootFromParent_Done,
     /* 2191331 */   // Label 30150: @2191331
     /* 2191331 */   GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2191371), // Rule ID 1181 //
     /* 2191336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2191339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191355 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2191355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2191358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2191366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191370 */     // GIR_Coverage, 1181,
     /* 2191370 */     GIR_EraseRootFromParent_Done,
     /* 2191371 */   // Label 30151: @2191371
     /* 2191371 */   GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2191411), // Rule ID 1182 //
     /* 2191376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2191379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2191395 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2191395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2191398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2191402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2191406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191410 */     // GIR_Coverage, 1182,
     /* 2191410 */     GIR_EraseRootFromParent_Done,
     /* 2191411 */   // Label 30152: @2191411
     /* 2191411 */   GIM_Reject,
     /* 2191412 */ // Label 30128: @2191412
     /* 2191412 */ GIM_Reject,
     /* 2191413 */ // Label 30086: @2191413
     /* 2191413 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2193203),
     /* 2191418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2191424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2191427 */   GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2191499), // Rule ID 1509 //
     /* 2191432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2191435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191479 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2191479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2191482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191498 */     // GIR_Coverage, 1509,
     /* 2191498 */     GIR_EraseRootFromParent_Done,
     /* 2191499 */   // Label 30154: @2191499
     /* 2191499 */   GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2191571), // Rule ID 1510 //
     /* 2191504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2191507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191551 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2191551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2191554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191570 */     // GIR_Coverage, 1510,
     /* 2191570 */     GIR_EraseRootFromParent_Done,
     /* 2191571 */   // Label 30155: @2191571
     /* 2191571 */   GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2191643), // Rule ID 1532 //
     /* 2191576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2191579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191623 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2191623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2191626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191642 */     // GIR_Coverage, 1532,
     /* 2191642 */     GIR_EraseRootFromParent_Done,
     /* 2191643 */   // Label 30156: @2191643
     /* 2191643 */   GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2191715), // Rule ID 1564 //
     /* 2191648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2191651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191695 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2191695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2191698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191714 */     // GIR_Coverage, 1564,
     /* 2191714 */     GIR_EraseRootFromParent_Done,
     /* 2191715 */   // Label 30157: @2191715
     /* 2191715 */   GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2191787), // Rule ID 1565 //
     /* 2191720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2191723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2191765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191767 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2191767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2191770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2191778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191786 */     // GIR_Coverage, 1565,
     /* 2191786 */     GIR_EraseRootFromParent_Done,
     /* 2191787 */   // Label 30158: @2191787
     /* 2191787 */   GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2191859), // Rule ID 64013 //
     /* 2191792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2191795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2191807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191839 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2191839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2191842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2191850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191858 */     // GIR_Coverage, 64013,
     /* 2191858 */     GIR_EraseRootFromParent_Done,
     /* 2191859 */   // Label 30159: @2191859
     /* 2191859 */   GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2191931), // Rule ID 64014 //
     /* 2191864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2191867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2191879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191911 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2191911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2191914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2191922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2191929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191930 */     // GIR_Coverage, 64014,
     /* 2191930 */     GIR_EraseRootFromParent_Done,
     /* 2191931 */   // Label 30160: @2191931
     /* 2191931 */   GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2192003), // Rule ID 64018 //
     /* 2191936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2191939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2191951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2191968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2191972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2191976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2191981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2191983 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2191983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2191986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2191992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2191994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2191998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192002 */     // GIR_Coverage, 64018,
     /* 2192002 */     GIR_EraseRootFromParent_Done,
     /* 2192003 */   // Label 30161: @2192003
     /* 2192003 */   GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2192075), // Rule ID 64025 //
     /* 2192008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2192011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2192040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2192055 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2192058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2192070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192074 */     // GIR_Coverage, 64025,
     /* 2192074 */     GIR_EraseRootFromParent_Done,
     /* 2192075 */   // Label 30162: @2192075
     /* 2192075 */   GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2192147), // Rule ID 64026 //
     /* 2192080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2192083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2192112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2192127 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2192130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2192142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192146 */     // GIR_Coverage, 64026,
     /* 2192146 */     GIR_EraseRootFromParent_Done,
     /* 2192147 */   // Label 30163: @2192147
     /* 2192147 */   GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2192204), // Rule ID 1505 //
     /* 2192152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2192155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2192163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192186 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2192189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192203 */     // GIR_Coverage, 1505,
     /* 2192203 */     GIR_EraseRootFromParent_Done,
     /* 2192204 */   // Label 30164: @2192204
     /* 2192204 */   GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2192261), // Rule ID 1506 //
     /* 2192209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2192212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2192220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192243 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2192246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192260 */     // GIR_Coverage, 1506,
     /* 2192260 */     GIR_EraseRootFromParent_Done,
     /* 2192261 */   // Label 30165: @2192261
     /* 2192261 */   GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2192318), // Rule ID 1530 //
     /* 2192266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2192269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2192277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192300 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2192303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192317 */     // GIR_Coverage, 1530,
     /* 2192317 */     GIR_EraseRootFromParent_Done,
     /* 2192318 */   // Label 30166: @2192318
     /* 2192318 */   GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2192375), // Rule ID 1560 //
     /* 2192323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2192326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2192334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192357 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2192360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192374 */     // GIR_Coverage, 1560,
     /* 2192374 */     GIR_EraseRootFromParent_Done,
     /* 2192375 */   // Label 30167: @2192375
     /* 2192375 */   GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2192432), // Rule ID 1561 //
     /* 2192380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2192383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2192391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192414 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2192417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192431 */     // GIR_Coverage, 1561,
     /* 2192431 */     GIR_EraseRootFromParent_Done,
     /* 2192432 */   // Label 30168: @2192432
     /* 2192432 */   GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2192489), // Rule ID 64009 //
     /* 2192437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2192440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192471 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2192474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192488 */     // GIR_Coverage, 64009,
     /* 2192488 */     GIR_EraseRootFromParent_Done,
     /* 2192489 */   // Label 30169: @2192489
     /* 2192489 */   GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2192546), // Rule ID 64010 //
     /* 2192494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2192497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192528 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2192531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192545 */     // GIR_Coverage, 64010,
     /* 2192545 */     GIR_EraseRootFromParent_Done,
     /* 2192546 */   // Label 30170: @2192546
     /* 2192546 */   GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2192603), // Rule ID 64016 //
     /* 2192551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2192554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192585 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2192588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192602 */     // GIR_Coverage, 64016,
     /* 2192602 */     GIR_EraseRootFromParent_Done,
     /* 2192603 */   // Label 30171: @2192603
     /* 2192603 */   GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2192660), // Rule ID 64021 //
     /* 2192608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2192611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192642 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2192645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192659 */     // GIR_Coverage, 64021,
     /* 2192659 */     GIR_EraseRootFromParent_Done,
     /* 2192660 */   // Label 30172: @2192660
     /* 2192660 */   GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2192717), // Rule ID 64022 //
     /* 2192665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2192668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2192680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192699 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2192702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2192708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2192710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2192712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192716 */     // GIR_Coverage, 64022,
     /* 2192716 */     GIR_EraseRootFromParent_Done,
     /* 2192717 */   // Label 30173: @2192717
     /* 2192717 */   GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2192774), // Rule ID 1501 //
     /* 2192722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2192725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2192741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192756 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2192759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2192763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2192769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192773 */     // GIR_Coverage, 1501,
     /* 2192773 */     GIR_EraseRootFromParent_Done,
     /* 2192774 */   // Label 30174: @2192774
     /* 2192774 */   GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2192831), // Rule ID 1502 //
     /* 2192779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2192782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2192798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192813 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2192816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2192820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2192826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192830 */     // GIR_Coverage, 1502,
     /* 2192830 */     GIR_EraseRootFromParent_Done,
     /* 2192831 */   // Label 30175: @2192831
     /* 2192831 */   GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2192888), // Rule ID 1528 //
     /* 2192836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2192839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2192855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192870 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2192873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2192877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2192883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192887 */     // GIR_Coverage, 1528,
     /* 2192887 */     GIR_EraseRootFromParent_Done,
     /* 2192888 */   // Label 30176: @2192888
     /* 2192888 */   GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2192945), // Rule ID 1556 //
     /* 2192893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2192896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2192912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192927 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2192927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2192930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2192934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2192940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2192943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192944 */     // GIR_Coverage, 1556,
     /* 2192944 */     GIR_EraseRootFromParent_Done,
     /* 2192945 */   // Label 30177: @2192945
     /* 2192945 */   GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2193002), // Rule ID 1557 //
     /* 2192950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2192953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2192969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2192973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2192977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2192982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2192984 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2192984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2192987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2192991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2192993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2192997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193001 */     // GIR_Coverage, 1557,
     /* 2193001 */     GIR_EraseRootFromParent_Done,
     /* 2193002 */   // Label 30178: @2193002
     /* 2193002 */   GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2193042), // Rule ID 1497 //
     /* 2193007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2193010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193026 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2193026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2193029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2193035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2193037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193041 */     // GIR_Coverage, 1497,
     /* 2193041 */     GIR_EraseRootFromParent_Done,
     /* 2193042 */   // Label 30179: @2193042
     /* 2193042 */   GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2193082), // Rule ID 1498 //
     /* 2193047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2193050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2193066 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2193066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2193069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2193075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2193077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193081 */     // GIR_Coverage, 1498,
     /* 2193081 */     GIR_EraseRootFromParent_Done,
     /* 2193082 */   // Label 30180: @2193082
     /* 2193082 */   GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2193122), // Rule ID 1526 //
     /* 2193087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2193090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193106 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2193106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2193109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2193115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2193117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193121 */     // GIR_Coverage, 1526,
     /* 2193121 */     GIR_EraseRootFromParent_Done,
     /* 2193122 */   // Label 30181: @2193122
     /* 2193122 */   GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2193162), // Rule ID 1552 //
     /* 2193127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2193130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193146 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2193146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2193149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2193155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2193157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193161 */     // GIR_Coverage, 1552,
     /* 2193161 */     GIR_EraseRootFromParent_Done,
     /* 2193162 */   // Label 30182: @2193162
     /* 2193162 */   GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2193202), // Rule ID 1553 //
     /* 2193167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2193170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2193186 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2193186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2193189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2193195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2193197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193201 */     // GIR_Coverage, 1553,
     /* 2193201 */     GIR_EraseRootFromParent_Done,
     /* 2193202 */   // Label 30183: @2193202
     /* 2193202 */   GIM_Reject,
     /* 2193203 */ // Label 30153: @2193203
     /* 2193203 */ GIM_Reject,
     /* 2193204 */ // Label 30087: @2193204
     /* 2193204 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2193993),
     /* 2193209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2193215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2193218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193222 */   GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2193299), // Rule ID 54292 //
     /* 2193227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2193234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2193255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2193270 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2193273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2193285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193298 */     // GIR_Coverage, 54292,
     /* 2193298 */     GIR_EraseRootFromParent_Done,
     /* 2193299 */   // Label 30185: @2193299
     /* 2193299 */   GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2193376), // Rule ID 54293 //
     /* 2193304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2193311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2193332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2193347 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2193350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2193362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193375 */     // GIR_Coverage, 54293,
     /* 2193375 */     GIR_EraseRootFromParent_Done,
     /* 2193376 */   // Label 30186: @2193376
     /* 2193376 */   GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2193453), // Rule ID 70837 //
     /* 2193381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2193392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2193409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2193424 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2193427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2193431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2193439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193452 */     // GIR_Coverage, 70837,
     /* 2193452 */     GIR_EraseRootFromParent_Done,
     /* 2193453 */   // Label 30187: @2193453
     /* 2193453 */   GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2193530), // Rule ID 70838 //
     /* 2193458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2193469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2193486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2193501 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2193504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2193508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2193516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193529 */     // GIR_Coverage, 70838,
     /* 2193529 */     GIR_EraseRootFromParent_Done,
     /* 2193530 */   // Label 30188: @2193530
     /* 2193530 */   GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2193592), // Rule ID 54296 //
     /* 2193535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2193542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193565 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2193568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193591 */     // GIR_Coverage, 54296,
     /* 2193591 */     GIR_EraseRootFromParent_Done,
     /* 2193592 */   // Label 30189: @2193592
     /* 2193592 */   GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2193654), // Rule ID 54297 //
     /* 2193597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2193604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193627 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2193630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193653 */     // GIR_Coverage, 54297,
     /* 2193653 */     GIR_EraseRootFromParent_Done,
     /* 2193654 */   // Label 30190: @2193654
     /* 2193654 */   GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2193716), // Rule ID 70841 //
     /* 2193659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2193670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193689 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2193692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2193696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193715 */     // GIR_Coverage, 70841,
     /* 2193715 */     GIR_EraseRootFromParent_Done,
     /* 2193716 */   // Label 30191: @2193716
     /* 2193716 */   GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2193778), // Rule ID 70842 //
     /* 2193721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2193732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193751 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2193754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2193758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2193762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193777 */     // GIR_Coverage, 70842,
     /* 2193777 */     GIR_EraseRootFromParent_Done,
     /* 2193778 */   // Label 30192: @2193778
     /* 2193778 */   GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2193840), // Rule ID 54288 //
     /* 2193783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2193798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193813 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2193816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2193826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193839 */     // GIR_Coverage, 54288,
     /* 2193839 */     GIR_EraseRootFromParent_Done,
     /* 2193840 */   // Label 30193: @2193840
     /* 2193840 */   GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2193902), // Rule ID 54289 //
     /* 2193845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2193860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2193864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2193868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2193875 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2193878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2193888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193901 */     // GIR_Coverage, 54289,
     /* 2193901 */     GIR_EraseRootFromParent_Done,
     /* 2193902 */   // Label 30194: @2193902
     /* 2193902 */   GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2193947), // Rule ID 54284 //
     /* 2193907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2193910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193922 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2193922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2193925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193946 */     // GIR_Coverage, 54284,
     /* 2193946 */     GIR_EraseRootFromParent_Done,
     /* 2193947 */   // Label 30195: @2193947
     /* 2193947 */   GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2193992), // Rule ID 54285 //
     /* 2193952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2193955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193967 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2193967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2193970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2193974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2193976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2193978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2193981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2193984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2193990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193991 */     // GIR_Coverage, 54285,
     /* 2193991 */     GIR_EraseRootFromParent_Done,
     /* 2193992 */   // Label 30196: @2193992
     /* 2193992 */   GIM_Reject,
     /* 2193993 */ // Label 30184: @2193993
     /* 2193993 */ GIM_Reject,
     /* 2193994 */ // Label 30088: @2193994
     /* 2193994 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2194783),
     /* 2193999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2194008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194012 */   GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2194089), // Rule ID 54420 //
     /* 2194017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194060 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2194063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194088 */     // GIR_Coverage, 54420,
     /* 2194088 */     GIR_EraseRootFromParent_Done,
     /* 2194089 */   // Label 30198: @2194089
     /* 2194089 */   GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2194166), // Rule ID 54421 //
     /* 2194094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194137 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2194140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194165 */     // GIR_Coverage, 54421,
     /* 2194165 */     GIR_EraseRootFromParent_Done,
     /* 2194166 */   // Label 30199: @2194166
     /* 2194166 */   GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2194243), // Rule ID 70949 //
     /* 2194171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2194182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194214 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2194217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2194221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194242 */     // GIR_Coverage, 70949,
     /* 2194242 */     GIR_EraseRootFromParent_Done,
     /* 2194243 */   // Label 30200: @2194243
     /* 2194243 */   GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2194320), // Rule ID 70950 //
     /* 2194248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2194259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194291 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2194294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2194298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194319 */     // GIR_Coverage, 70950,
     /* 2194319 */     GIR_EraseRootFromParent_Done,
     /* 2194320 */   // Label 30201: @2194320
     /* 2194320 */   GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2194382), // Rule ID 54424 //
     /* 2194325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194355 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2194358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194381 */     // GIR_Coverage, 54424,
     /* 2194381 */     GIR_EraseRootFromParent_Done,
     /* 2194382 */   // Label 30202: @2194382
     /* 2194382 */   GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2194444), // Rule ID 54425 //
     /* 2194387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194417 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2194420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194443 */     // GIR_Coverage, 54425,
     /* 2194443 */     GIR_EraseRootFromParent_Done,
     /* 2194444 */   // Label 30203: @2194444
     /* 2194444 */   GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2194506), // Rule ID 70953 //
     /* 2194449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2194460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194479 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2194482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2194486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194505 */     // GIR_Coverage, 70953,
     /* 2194505 */     GIR_EraseRootFromParent_Done,
     /* 2194506 */   // Label 30204: @2194506
     /* 2194506 */   GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2194568), // Rule ID 70954 //
     /* 2194511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2194522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194541 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2194544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2194548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194567 */     // GIR_Coverage, 70954,
     /* 2194567 */     GIR_EraseRootFromParent_Done,
     /* 2194568 */   // Label 30205: @2194568
     /* 2194568 */   GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2194630), // Rule ID 54416 //
     /* 2194573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2194588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194603 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2194606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2194612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2194616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194629 */     // GIR_Coverage, 54416,
     /* 2194629 */     GIR_EraseRootFromParent_Done,
     /* 2194630 */   // Label 30206: @2194630
     /* 2194630 */   GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2194692), // Rule ID 54417 //
     /* 2194635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2194650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2194665 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2194668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2194674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2194678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194691 */     // GIR_Coverage, 54417,
     /* 2194691 */     GIR_EraseRootFromParent_Done,
     /* 2194692 */   // Label 30207: @2194692
     /* 2194692 */   GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2194737), // Rule ID 54412 //
     /* 2194697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2194700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194712 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2194715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2194721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194736 */     // GIR_Coverage, 54412,
     /* 2194736 */     GIR_EraseRootFromParent_Done,
     /* 2194737 */   // Label 30208: @2194737
     /* 2194737 */   GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2194782), // Rule ID 54413 //
     /* 2194742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2194745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194757 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2194760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2194766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2194768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194781 */     // GIR_Coverage, 54413,
     /* 2194781 */     GIR_EraseRootFromParent_Done,
     /* 2194782 */   // Label 30209: @2194782
     /* 2194782 */   GIM_Reject,
     /* 2194783 */ // Label 30197: @2194783
     /* 2194783 */ GIM_Reject,
     /* 2194784 */ // Label 30089: @2194784
     /* 2194784 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2195573),
     /* 2194789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2194798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194802 */   GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2194879), // Rule ID 54612 //
     /* 2194807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2194810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194850 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2194850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2194853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194878 */     // GIR_Coverage, 54612,
     /* 2194878 */     GIR_EraseRootFromParent_Done,
     /* 2194879 */   // Label 30211: @2194879
     /* 2194879 */   GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2194956), // Rule ID 54613 //
     /* 2194884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2194887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2194891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2194927 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2194927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2194930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2194934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2194938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2194942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2194945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2194954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194955 */     // GIR_Coverage, 54613,
     /* 2194955 */     GIR_EraseRootFromParent_Done,
     /* 2194956 */   // Label 30212: @2194956
     /* 2194956 */   GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2195033), // Rule ID 71117 //
     /* 2194961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2194964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2194972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2194989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2194993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2194997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195004 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2195007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195032 */     // GIR_Coverage, 71117,
     /* 2195032 */     GIR_EraseRootFromParent_Done,
     /* 2195033 */   // Label 30213: @2195033
     /* 2195033 */   GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2195110), // Rule ID 71118 //
     /* 2195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2195041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2195049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2195066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195081 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2195084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195109 */     // GIR_Coverage, 71118,
     /* 2195109 */     GIR_EraseRootFromParent_Done,
     /* 2195110 */   // Label 30214: @2195110
     /* 2195110 */   GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2195172), // Rule ID 54616 //
     /* 2195115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2195118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195145 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2195148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195171 */     // GIR_Coverage, 54616,
     /* 2195171 */     GIR_EraseRootFromParent_Done,
     /* 2195172 */   // Label 30215: @2195172
     /* 2195172 */   GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2195234), // Rule ID 54617 //
     /* 2195177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2195180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195207 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2195210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195233 */     // GIR_Coverage, 54617,
     /* 2195233 */     GIR_EraseRootFromParent_Done,
     /* 2195234 */   // Label 30216: @2195234
     /* 2195234 */   GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2195296), // Rule ID 71121 //
     /* 2195239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2195242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2195250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195269 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2195272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195295 */     // GIR_Coverage, 71121,
     /* 2195295 */     GIR_EraseRootFromParent_Done,
     /* 2195296 */   // Label 30217: @2195296
     /* 2195296 */   GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2195358), // Rule ID 71122 //
     /* 2195301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2195304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2195312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195331 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2195334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195357 */     // GIR_Coverage, 71122,
     /* 2195357 */     GIR_EraseRootFromParent_Done,
     /* 2195358 */   // Label 30218: @2195358
     /* 2195358 */   GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2195420), // Rule ID 54608 //
     /* 2195363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2195366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2195378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195393 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2195396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2195402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2195406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195419 */     // GIR_Coverage, 54608,
     /* 2195419 */     GIR_EraseRootFromParent_Done,
     /* 2195420 */   // Label 30219: @2195420
     /* 2195420 */   GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2195482), // Rule ID 54609 //
     /* 2195425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2195428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2195440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2195448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195455 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2195458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2195464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2195468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195481 */     // GIR_Coverage, 54609,
     /* 2195481 */     GIR_EraseRootFromParent_Done,
     /* 2195482 */   // Label 30220: @2195482
     /* 2195482 */   GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2195527), // Rule ID 54604 //
     /* 2195487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2195490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195502 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2195505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2195511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195526 */     // GIR_Coverage, 54604,
     /* 2195526 */     GIR_EraseRootFromParent_Done,
     /* 2195527 */   // Label 30221: @2195527
     /* 2195527 */   GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2195572), // Rule ID 54605 //
     /* 2195532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2195535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195547 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2195550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2195556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195571 */     // GIR_Coverage, 54605,
     /* 2195571 */     GIR_EraseRootFromParent_Done,
     /* 2195572 */   // Label 30222: @2195572
     /* 2195572 */   GIM_Reject,
     /* 2195573 */ // Label 30210: @2195573
     /* 2195573 */ GIM_Reject,
     /* 2195574 */ // Label 30090: @2195574
     /* 2195574 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2196363),
     /* 2195579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2195585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2195588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195592 */   GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2195669), // Rule ID 54356 //
     /* 2195597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2195600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2195625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195640 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2195643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195668 */     // GIR_Coverage, 54356,
     /* 2195668 */     GIR_EraseRootFromParent_Done,
     /* 2195669 */   // Label 30224: @2195669
     /* 2195669 */   GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2195746), // Rule ID 54357 //
     /* 2195674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2195677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2195702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195717 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2195720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195745 */     // GIR_Coverage, 54357,
     /* 2195745 */     GIR_EraseRootFromParent_Done,
     /* 2195746 */   // Label 30225: @2195746
     /* 2195746 */   GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2195823), // Rule ID 70893 //
     /* 2195751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2195754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2195762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2195779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195794 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2195797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195822 */     // GIR_Coverage, 70893,
     /* 2195822 */     GIR_EraseRootFromParent_Done,
     /* 2195823 */   // Label 30226: @2195823
     /* 2195823 */   GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2195900), // Rule ID 70894 //
     /* 2195828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2195831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2195839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2195856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2195871 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2195874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2195878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2195886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195899 */     // GIR_Coverage, 70894,
     /* 2195899 */     GIR_EraseRootFromParent_Done,
     /* 2195900 */   // Label 30227: @2195900
     /* 2195900 */   GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2195962), // Rule ID 54360 //
     /* 2195905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2195908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195935 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2195935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2195938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2195942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2195946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2195948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2195951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2195960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195961 */     // GIR_Coverage, 54360,
     /* 2195961 */     GIR_EraseRootFromParent_Done,
     /* 2195962 */   // Label 30228: @2195962
     /* 2195962 */   GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2196024), // Rule ID 54361 //
     /* 2195967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2195970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2195974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2195978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2195997 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2195997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2196000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196023 */     // GIR_Coverage, 54361,
     /* 2196023 */     GIR_EraseRootFromParent_Done,
     /* 2196024 */   // Label 30229: @2196024
     /* 2196024 */   GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2196086), // Rule ID 70897 //
     /* 2196029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2196032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2196048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196059 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2196062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196085 */     // GIR_Coverage, 70897,
     /* 2196085 */     GIR_EraseRootFromParent_Done,
     /* 2196086 */   // Label 30230: @2196086
     /* 2196086 */   GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2196148), // Rule ID 70898 //
     /* 2196091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2196094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2196110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196121 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2196124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196147 */     // GIR_Coverage, 70898,
     /* 2196147 */     GIR_EraseRootFromParent_Done,
     /* 2196148 */   // Label 30231: @2196148
     /* 2196148 */   GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2196210), // Rule ID 54352 //
     /* 2196153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2196156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2196168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2196176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196183 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2196186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2196192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2196196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196209 */     // GIR_Coverage, 54352,
     /* 2196209 */     GIR_EraseRootFromParent_Done,
     /* 2196210 */   // Label 30232: @2196210
     /* 2196210 */   GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2196272), // Rule ID 54353 //
     /* 2196215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2196218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2196230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2196238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196245 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2196248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2196254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2196258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196271 */     // GIR_Coverage, 54353,
     /* 2196271 */     GIR_EraseRootFromParent_Done,
     /* 2196272 */   // Label 30233: @2196272
     /* 2196272 */   GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2196317), // Rule ID 54348 //
     /* 2196277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2196280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196292 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2196295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2196301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196316 */     // GIR_Coverage, 54348,
     /* 2196316 */     GIR_EraseRootFromParent_Done,
     /* 2196317 */   // Label 30234: @2196317
     /* 2196317 */   GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2196362), // Rule ID 54349 //
     /* 2196322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2196325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196337 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2196340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2196346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196361 */     // GIR_Coverage, 54349,
     /* 2196361 */     GIR_EraseRootFromParent_Done,
     /* 2196362 */   // Label 30235: @2196362
     /* 2196362 */   GIM_Reject,
     /* 2196363 */ // Label 30223: @2196363
     /* 2196363 */ GIM_Reject,
     /* 2196364 */ // Label 30091: @2196364
     /* 2196364 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2197153),
     /* 2196369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196382 */   GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2196459), // Rule ID 54548 //
     /* 2196387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2196390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2196394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2196415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2196430 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2196433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2196445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196458 */     // GIR_Coverage, 54548,
     /* 2196458 */     GIR_EraseRootFromParent_Done,
     /* 2196459 */   // Label 30237: @2196459
     /* 2196459 */   GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2196536), // Rule ID 54549 //
     /* 2196464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2196467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2196471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2196492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2196507 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2196510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2196522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196535 */     // GIR_Coverage, 54549,
     /* 2196535 */     GIR_EraseRootFromParent_Done,
     /* 2196536 */   // Label 30238: @2196536
     /* 2196536 */   GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2196613), // Rule ID 71061 //
     /* 2196541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2196544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2196569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2196584 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2196587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2196599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196612 */     // GIR_Coverage, 71061,
     /* 2196612 */     GIR_EraseRootFromParent_Done,
     /* 2196613 */   // Label 30239: @2196613
     /* 2196613 */   GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2196690), // Rule ID 71062 //
     /* 2196618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2196621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2196646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2196661 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2196664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2196676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196689 */     // GIR_Coverage, 71062,
     /* 2196689 */     GIR_EraseRootFromParent_Done,
     /* 2196690 */   // Label 30240: @2196690
     /* 2196690 */   GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2196752), // Rule ID 54552 //
     /* 2196695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2196698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2196702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196725 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2196728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196751 */     // GIR_Coverage, 54552,
     /* 2196751 */     GIR_EraseRootFromParent_Done,
     /* 2196752 */   // Label 30241: @2196752
     /* 2196752 */   GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2196814), // Rule ID 54553 //
     /* 2196757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2196760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2196764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196787 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2196790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196813 */     // GIR_Coverage, 54553,
     /* 2196813 */     GIR_EraseRootFromParent_Done,
     /* 2196814 */   // Label 30242: @2196814
     /* 2196814 */   GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2196876), // Rule ID 71065 //
     /* 2196819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2196822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196849 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2196852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196875 */     // GIR_Coverage, 71065,
     /* 2196875 */     GIR_EraseRootFromParent_Done,
     /* 2196876 */   // Label 30243: @2196876
     /* 2196876 */   GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2196938), // Rule ID 71066 //
     /* 2196881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2196884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2196892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196911 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2196911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2196914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2196918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2196922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2196924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196937 */     // GIR_Coverage, 71066,
     /* 2196937 */     GIR_EraseRootFromParent_Done,
     /* 2196938 */   // Label 30244: @2196938
     /* 2196938 */   GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2197000), // Rule ID 54544 //
     /* 2196943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2196946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2196958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2196962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2196966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2196973 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2196973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2196976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2196980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2196982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2196986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2196989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2196998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196999 */     // GIR_Coverage, 54544,
     /* 2196999 */     GIR_EraseRootFromParent_Done,
     /* 2197000 */   // Label 30245: @2197000
     /* 2197000 */   GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2197062), // Rule ID 54545 //
     /* 2197005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2197008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2197020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2197028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197035 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2197038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2197048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197061 */     // GIR_Coverage, 54545,
     /* 2197061 */     GIR_EraseRootFromParent_Done,
     /* 2197062 */   // Label 30246: @2197062
     /* 2197062 */   GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2197107), // Rule ID 54540 //
     /* 2197067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2197070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197082 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2197085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197106 */     // GIR_Coverage, 54540,
     /* 2197106 */     GIR_EraseRootFromParent_Done,
     /* 2197107 */   // Label 30247: @2197107
     /* 2197107 */   GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2197152), // Rule ID 54541 //
     /* 2197112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2197115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197127 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2197130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197151 */     // GIR_Coverage, 54541,
     /* 2197151 */     GIR_EraseRootFromParent_Done,
     /* 2197152 */   // Label 30248: @2197152
     /* 2197152 */   GIM_Reject,
     /* 2197153 */ // Label 30236: @2197153
     /* 2197153 */ GIM_Reject,
     /* 2197154 */ // Label 30092: @2197154
     /* 2197154 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2197943),
     /* 2197159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2197168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197172 */   GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2197249), // Rule ID 55060 //
     /* 2197177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2197184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2197205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2197220 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2197223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2197235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197248 */     // GIR_Coverage, 55060,
     /* 2197248 */     GIR_EraseRootFromParent_Done,
     /* 2197249 */   // Label 30250: @2197249
     /* 2197249 */   GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2197326), // Rule ID 55061 //
     /* 2197254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2197261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2197282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2197297 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2197300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2197312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197325 */     // GIR_Coverage, 55061,
     /* 2197325 */     GIR_EraseRootFromParent_Done,
     /* 2197326 */   // Label 30251: @2197326
     /* 2197326 */   GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2197403), // Rule ID 71509 //
     /* 2197331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2197342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2197359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2197374 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2197377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2197381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2197389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197402 */     // GIR_Coverage, 71509,
     /* 2197402 */     GIR_EraseRootFromParent_Done,
     /* 2197403 */   // Label 30252: @2197403
     /* 2197403 */   GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2197480), // Rule ID 71510 //
     /* 2197408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2197419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2197436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2197451 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2197454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2197458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2197466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197479 */     // GIR_Coverage, 71510,
     /* 2197479 */     GIR_EraseRootFromParent_Done,
     /* 2197480 */   // Label 30253: @2197480
     /* 2197480 */   GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2197542), // Rule ID 55064 //
     /* 2197485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2197492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197515 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2197518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197541 */     // GIR_Coverage, 55064,
     /* 2197541 */     GIR_EraseRootFromParent_Done,
     /* 2197542 */   // Label 30254: @2197542
     /* 2197542 */   GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2197604), // Rule ID 55065 //
     /* 2197547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2197554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197577 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2197580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197603 */     // GIR_Coverage, 55065,
     /* 2197603 */     GIR_EraseRootFromParent_Done,
     /* 2197604 */   // Label 30255: @2197604
     /* 2197604 */   GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2197666), // Rule ID 71513 //
     /* 2197609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2197620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197639 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2197642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2197646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197665 */     // GIR_Coverage, 71513,
     /* 2197665 */     GIR_EraseRootFromParent_Done,
     /* 2197666 */   // Label 30256: @2197666
     /* 2197666 */   GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2197728), // Rule ID 71514 //
     /* 2197671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2197682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197701 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2197704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2197708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2197712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197727 */     // GIR_Coverage, 71514,
     /* 2197727 */     GIR_EraseRootFromParent_Done,
     /* 2197728 */   // Label 30257: @2197728
     /* 2197728 */   GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2197790), // Rule ID 55056 //
     /* 2197733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2197748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197763 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2197766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2197776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197789 */     // GIR_Coverage, 55056,
     /* 2197789 */     GIR_EraseRootFromParent_Done,
     /* 2197790 */   // Label 30258: @2197790
     /* 2197790 */   GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2197852), // Rule ID 55057 //
     /* 2197795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2197810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2197818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197825 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2197828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2197838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197851 */     // GIR_Coverage, 55057,
     /* 2197851 */     GIR_EraseRootFromParent_Done,
     /* 2197852 */   // Label 30259: @2197852
     /* 2197852 */   GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2197897), // Rule ID 55052 //
     /* 2197857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2197860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197872 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2197872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2197875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197896 */     // GIR_Coverage, 55052,
     /* 2197896 */     GIR_EraseRootFromParent_Done,
     /* 2197897 */   // Label 30260: @2197897
     /* 2197897 */   GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2197942), // Rule ID 55053 //
     /* 2197902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2197905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197917 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2197917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2197920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2197924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2197926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2197928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2197931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2197937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2197940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197941 */     // GIR_Coverage, 55053,
     /* 2197941 */     GIR_EraseRootFromParent_Done,
     /* 2197942 */   // Label 30261: @2197942
     /* 2197942 */   GIM_Reject,
     /* 2197943 */ // Label 30249: @2197943
     /* 2197943 */ GIM_Reject,
     /* 2197944 */ // Label 30093: @2197944
     /* 2197944 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2198733),
     /* 2197949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2197952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2197955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2197958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197962 */   GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2198039), // Rule ID 54484 //
     /* 2197967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2197970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2197974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2197982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2197995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2197999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198010 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2198013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198038 */     // GIR_Coverage, 54484,
     /* 2198038 */     GIR_EraseRootFromParent_Done,
     /* 2198039 */   // Label 30263: @2198039
     /* 2198039 */   GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2198116), // Rule ID 54485 //
     /* 2198044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2198051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198087 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2198090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198115 */     // GIR_Coverage, 54485,
     /* 2198115 */     GIR_EraseRootFromParent_Done,
     /* 2198116 */   // Label 30264: @2198116
     /* 2198116 */   GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2198193), // Rule ID 71005 //
     /* 2198121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2198124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198164 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2198167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2198171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198192 */     // GIR_Coverage, 71005,
     /* 2198192 */     GIR_EraseRootFromParent_Done,
     /* 2198193 */   // Label 30265: @2198193
     /* 2198193 */   GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2198270), // Rule ID 71006 //
     /* 2198198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198241 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2198244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2198248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198269 */     // GIR_Coverage, 71006,
     /* 2198269 */     GIR_EraseRootFromParent_Done,
     /* 2198270 */   // Label 30266: @2198270
     /* 2198270 */   GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2198332), // Rule ID 54488 //
     /* 2198275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2198278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2198282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198305 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2198308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198331 */     // GIR_Coverage, 54488,
     /* 2198331 */     GIR_EraseRootFromParent_Done,
     /* 2198332 */   // Label 30267: @2198332
     /* 2198332 */   GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2198394), // Rule ID 54489 //
     /* 2198337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2198344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198367 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2198370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198393 */     // GIR_Coverage, 54489,
     /* 2198393 */     GIR_EraseRootFromParent_Done,
     /* 2198394 */   // Label 30268: @2198394
     /* 2198394 */   GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2198456), // Rule ID 71009 //
     /* 2198399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2198402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198429 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2198432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2198436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198455 */     // GIR_Coverage, 71009,
     /* 2198455 */     GIR_EraseRootFromParent_Done,
     /* 2198456 */   // Label 30269: @2198456
     /* 2198456 */   GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2198518), // Rule ID 71010 //
     /* 2198461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198491 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2198494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2198498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198517 */     // GIR_Coverage, 71010,
     /* 2198517 */     GIR_EraseRootFromParent_Done,
     /* 2198518 */   // Label 30270: @2198518
     /* 2198518 */   GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2198580), // Rule ID 54480 //
     /* 2198523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2198526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2198538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198553 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2198556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2198562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2198566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198579 */     // GIR_Coverage, 54480,
     /* 2198579 */     GIR_EraseRootFromParent_Done,
     /* 2198580 */   // Label 30271: @2198580
     /* 2198580 */   GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2198642), // Rule ID 54481 //
     /* 2198585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2198600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2198608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2198615 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2198618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2198624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2198628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198641 */     // GIR_Coverage, 54481,
     /* 2198641 */     GIR_EraseRootFromParent_Done,
     /* 2198642 */   // Label 30272: @2198642
     /* 2198642 */   GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2198687), // Rule ID 54476 //
     /* 2198647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2198650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198662 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2198665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2198671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198686 */     // GIR_Coverage, 54476,
     /* 2198686 */     GIR_EraseRootFromParent_Done,
     /* 2198687 */   // Label 30273: @2198687
     /* 2198687 */   GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2198732), // Rule ID 54477 //
     /* 2198692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2198695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198707 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2198710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2198716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2198718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198731 */     // GIR_Coverage, 54477,
     /* 2198731 */     GIR_EraseRootFromParent_Done,
     /* 2198732 */   // Label 30274: @2198732
     /* 2198732 */   GIM_Reject,
     /* 2198733 */ // Label 30262: @2198733
     /* 2198733 */ GIM_Reject,
     /* 2198734 */ // Label 30094: @2198734
     /* 2198734 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2199523),
     /* 2198739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2198745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2198748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198752 */   GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2198829), // Rule ID 54868 //
     /* 2198757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2198760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2198764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198800 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2198803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198828 */     // GIR_Coverage, 54868,
     /* 2198828 */     GIR_EraseRootFromParent_Done,
     /* 2198829 */   // Label 30276: @2198829
     /* 2198829 */   GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2198906), // Rule ID 54869 //
     /* 2198834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2198837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2198841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198877 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2198877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2198880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2198884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198905 */     // GIR_Coverage, 54869,
     /* 2198905 */     GIR_EraseRootFromParent_Done,
     /* 2198906 */   // Label 30277: @2198906
     /* 2198906 */   GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2198983), // Rule ID 71341 //
     /* 2198911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2198914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2198939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2198943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2198947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2198954 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2198954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2198957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2198961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2198965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2198969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2198972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2198981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198982 */     // GIR_Coverage, 71341,
     /* 2198982 */     GIR_EraseRootFromParent_Done,
     /* 2198983 */   // Label 30278: @2198983
     /* 2198983 */   GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2199060), // Rule ID 71342 //
     /* 2198988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2198991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2198999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2199016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2199031 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2199034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2199038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2199046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199059 */     // GIR_Coverage, 71342,
     /* 2199059 */     GIR_EraseRootFromParent_Done,
     /* 2199060 */   // Label 30279: @2199060
     /* 2199060 */   GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2199122), // Rule ID 54872 //
     /* 2199065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2199068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199095 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2199098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199121 */     // GIR_Coverage, 54872,
     /* 2199121 */     GIR_EraseRootFromParent_Done,
     /* 2199122 */   // Label 30280: @2199122
     /* 2199122 */   GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2199184), // Rule ID 54873 //
     /* 2199127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2199130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199157 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2199160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199183 */     // GIR_Coverage, 54873,
     /* 2199183 */     GIR_EraseRootFromParent_Done,
     /* 2199184 */   // Label 30281: @2199184
     /* 2199184 */   GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2199246), // Rule ID 71345 //
     /* 2199189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2199192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2199200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199219 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2199222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2199226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199245 */     // GIR_Coverage, 71345,
     /* 2199245 */     GIR_EraseRootFromParent_Done,
     /* 2199246 */   // Label 30282: @2199246
     /* 2199246 */   GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2199308), // Rule ID 71346 //
     /* 2199251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2199254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2199262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199281 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2199284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2199288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199307 */     // GIR_Coverage, 71346,
     /* 2199307 */     GIR_EraseRootFromParent_Done,
     /* 2199308 */   // Label 30283: @2199308
     /* 2199308 */   GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2199370), // Rule ID 54864 //
     /* 2199313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2199316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2199328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199343 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2199346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2199352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2199356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199369 */     // GIR_Coverage, 54864,
     /* 2199369 */     GIR_EraseRootFromParent_Done,
     /* 2199370 */   // Label 30284: @2199370
     /* 2199370 */   GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2199432), // Rule ID 54865 //
     /* 2199375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2199378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2199390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199405 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2199408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2199414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2199418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199431 */     // GIR_Coverage, 54865,
     /* 2199431 */     GIR_EraseRootFromParent_Done,
     /* 2199432 */   // Label 30285: @2199432
     /* 2199432 */   GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2199477), // Rule ID 54860 //
     /* 2199437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2199440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199452 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2199455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2199461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199476 */     // GIR_Coverage, 54860,
     /* 2199476 */     GIR_EraseRootFromParent_Done,
     /* 2199477 */   // Label 30286: @2199477
     /* 2199477 */   GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2199522), // Rule ID 54861 //
     /* 2199482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2199485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199497 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2199500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2199506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199521 */     // GIR_Coverage, 54861,
     /* 2199521 */     GIR_EraseRootFromParent_Done,
     /* 2199522 */   // Label 30287: @2199522
     /* 2199522 */   GIM_Reject,
     /* 2199523 */ // Label 30275: @2199523
     /* 2199523 */ GIM_Reject,
     /* 2199524 */ // Label 30095: @2199524
     /* 2199524 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2200313),
     /* 2199529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2199535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2199538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199542 */   GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2199619), // Rule ID 55124 //
     /* 2199547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2199550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2199575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2199590 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2199593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2199605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199618 */     // GIR_Coverage, 55124,
     /* 2199618 */     GIR_EraseRootFromParent_Done,
     /* 2199619 */   // Label 30289: @2199619
     /* 2199619 */   GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2199696), // Rule ID 55125 //
     /* 2199624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2199627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2199652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2199667 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2199670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2199682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199695 */     // GIR_Coverage, 55125,
     /* 2199695 */     GIR_EraseRootFromParent_Done,
     /* 2199696 */   // Label 30290: @2199696
     /* 2199696 */   GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2199773), // Rule ID 71565 //
     /* 2199701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2199704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2199712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2199729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2199744 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2199747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2199751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2199759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199772 */     // GIR_Coverage, 71565,
     /* 2199772 */     GIR_EraseRootFromParent_Done,
     /* 2199773 */   // Label 30291: @2199773
     /* 2199773 */   GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2199850), // Rule ID 71566 //
     /* 2199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2199781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2199789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2199806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2199821 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2199824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2199828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2199836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199849 */     // GIR_Coverage, 71566,
     /* 2199849 */     GIR_EraseRootFromParent_Done,
     /* 2199850 */   // Label 30292: @2199850
     /* 2199850 */   GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2199912), // Rule ID 55128 //
     /* 2199855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2199858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199885 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2199885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2199888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199911 */     // GIR_Coverage, 55128,
     /* 2199911 */     GIR_EraseRootFromParent_Done,
     /* 2199912 */   // Label 30293: @2199912
     /* 2199912 */   GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2199974), // Rule ID 55129 //
     /* 2199917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2199920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2199924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2199947 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2199947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2199950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2199954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2199958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2199960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2199963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2199972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199973 */     // GIR_Coverage, 55129,
     /* 2199973 */     GIR_EraseRootFromParent_Done,
     /* 2199974 */   // Label 30294: @2199974
     /* 2199974 */   GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2200036), // Rule ID 71569 //
     /* 2199979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2199982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2199990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2199994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2199998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200009 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2200012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200035 */     // GIR_Coverage, 71569,
     /* 2200035 */     GIR_EraseRootFromParent_Done,
     /* 2200036 */   // Label 30295: @2200036
     /* 2200036 */   GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2200098), // Rule ID 71570 //
     /* 2200041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2200044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2200052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2200060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200071 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2200074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200097 */     // GIR_Coverage, 71570,
     /* 2200097 */     GIR_EraseRootFromParent_Done,
     /* 2200098 */   // Label 30296: @2200098
     /* 2200098 */   GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2200160), // Rule ID 55120 //
     /* 2200103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2200106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2200118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2200126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200133 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2200136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2200146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200159 */     // GIR_Coverage, 55120,
     /* 2200159 */     GIR_EraseRootFromParent_Done,
     /* 2200160 */   // Label 30297: @2200160
     /* 2200160 */   GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2200222), // Rule ID 55121 //
     /* 2200165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2200168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2200180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2200188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200195 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2200198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2200208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200221 */     // GIR_Coverage, 55121,
     /* 2200221 */     GIR_EraseRootFromParent_Done,
     /* 2200222 */   // Label 30298: @2200222
     /* 2200222 */   GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2200267), // Rule ID 55116 //
     /* 2200227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2200230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200242 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2200245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200266 */     // GIR_Coverage, 55116,
     /* 2200266 */     GIR_EraseRootFromParent_Done,
     /* 2200267 */   // Label 30299: @2200267
     /* 2200267 */   GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2200312), // Rule ID 55117 //
     /* 2200272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2200275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200287 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2200290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200311 */     // GIR_Coverage, 55117,
     /* 2200311 */     GIR_EraseRootFromParent_Done,
     /* 2200312 */   // Label 30300: @2200312
     /* 2200312 */   GIM_Reject,
     /* 2200313 */ // Label 30288: @2200313
     /* 2200313 */ GIM_Reject,
     /* 2200314 */ // Label 30096: @2200314
     /* 2200314 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2201103),
     /* 2200319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2200325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2200328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200332 */   GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2200409), // Rule ID 54676 //
     /* 2200337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2200340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2200344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2200365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2200380 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2200383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2200395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200408 */     // GIR_Coverage, 54676,
     /* 2200408 */     GIR_EraseRootFromParent_Done,
     /* 2200409 */   // Label 30302: @2200409
     /* 2200409 */   GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2200486), // Rule ID 54677 //
     /* 2200414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2200417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2200421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2200442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2200457 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2200460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2200472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200485 */     // GIR_Coverage, 54677,
     /* 2200485 */     GIR_EraseRootFromParent_Done,
     /* 2200486 */   // Label 30303: @2200486
     /* 2200486 */   GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2200563), // Rule ID 71173 //
     /* 2200491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2200494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2200502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2200519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2200534 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2200537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2200549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200562 */     // GIR_Coverage, 71173,
     /* 2200562 */     GIR_EraseRootFromParent_Done,
     /* 2200563 */   // Label 30304: @2200563
     /* 2200563 */   GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2200640), // Rule ID 71174 //
     /* 2200568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2200571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2200579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2200596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2200611 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2200614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2200626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200639 */     // GIR_Coverage, 71174,
     /* 2200639 */     GIR_EraseRootFromParent_Done,
     /* 2200640 */   // Label 30305: @2200640
     /* 2200640 */   GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2200702), // Rule ID 54680 //
     /* 2200645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2200648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2200652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200675 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2200678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200701 */     // GIR_Coverage, 54680,
     /* 2200701 */     GIR_EraseRootFromParent_Done,
     /* 2200702 */   // Label 30306: @2200702
     /* 2200702 */   GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2200764), // Rule ID 54681 //
     /* 2200707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2200710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2200714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200737 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2200740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200763 */     // GIR_Coverage, 54681,
     /* 2200763 */     GIR_EraseRootFromParent_Done,
     /* 2200764 */   // Label 30307: @2200764
     /* 2200764 */   GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2200826), // Rule ID 71177 //
     /* 2200769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2200772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2200780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200799 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2200802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200825 */     // GIR_Coverage, 71177,
     /* 2200825 */     GIR_EraseRootFromParent_Done,
     /* 2200826 */   // Label 30308: @2200826
     /* 2200826 */   GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2200888), // Rule ID 71178 //
     /* 2200831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2200834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2200842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200861 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2200864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2200868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2200872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2200874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200887 */     // GIR_Coverage, 71178,
     /* 2200887 */     GIR_EraseRootFromParent_Done,
     /* 2200888 */   // Label 30309: @2200888
     /* 2200888 */   GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2200950), // Rule ID 54672 //
     /* 2200893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2200896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2200908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200923 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2200923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2200926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2200936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2200948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200949 */     // GIR_Coverage, 54672,
     /* 2200949 */     GIR_EraseRootFromParent_Done,
     /* 2200950 */   // Label 30310: @2200950
     /* 2200950 */   GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2201012), // Rule ID 54673 //
     /* 2200955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2200958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2200970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2200974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2200985 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2200985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2200988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2200992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2200998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201011 */     // GIR_Coverage, 54673,
     /* 2201011 */     GIR_EraseRootFromParent_Done,
     /* 2201012 */   // Label 30311: @2201012
     /* 2201012 */   GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2201057), // Rule ID 54668 //
     /* 2201017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2201020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201032 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2201035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201056 */     // GIR_Coverage, 54668,
     /* 2201056 */     GIR_EraseRootFromParent_Done,
     /* 2201057 */   // Label 30312: @2201057
     /* 2201057 */   GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2201102), // Rule ID 54669 //
     /* 2201062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2201065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201077 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2201080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201101 */     // GIR_Coverage, 54669,
     /* 2201101 */     GIR_EraseRootFromParent_Done,
     /* 2201102 */   // Label 30313: @2201102
     /* 2201102 */   GIM_Reject,
     /* 2201103 */ // Label 30301: @2201103
     /* 2201103 */ GIM_Reject,
     /* 2201104 */ // Label 30097: @2201104
     /* 2201104 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2201893),
     /* 2201109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2201118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201122 */   GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2201199), // Rule ID 54932 //
     /* 2201127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2201134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2201155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2201170 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2201173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2201185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201198 */     // GIR_Coverage, 54932,
     /* 2201198 */     GIR_EraseRootFromParent_Done,
     /* 2201199 */   // Label 30315: @2201199
     /* 2201199 */   GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2201276), // Rule ID 54933 //
     /* 2201204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2201211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2201232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2201247 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2201250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2201262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201275 */     // GIR_Coverage, 54933,
     /* 2201275 */     GIR_EraseRootFromParent_Done,
     /* 2201276 */   // Label 30316: @2201276
     /* 2201276 */   GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2201353), // Rule ID 71397 //
     /* 2201281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2201292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2201309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2201324 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2201327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2201331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2201339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201352 */     // GIR_Coverage, 71397,
     /* 2201352 */     GIR_EraseRootFromParent_Done,
     /* 2201353 */   // Label 30317: @2201353
     /* 2201353 */   GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2201430), // Rule ID 71398 //
     /* 2201358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2201369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2201386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2201401 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2201404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2201408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2201416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201429 */     // GIR_Coverage, 71398,
     /* 2201429 */     GIR_EraseRootFromParent_Done,
     /* 2201430 */   // Label 30318: @2201430
     /* 2201430 */   GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2201492), // Rule ID 54936 //
     /* 2201435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2201442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201465 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2201468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201491 */     // GIR_Coverage, 54936,
     /* 2201491 */     GIR_EraseRootFromParent_Done,
     /* 2201492 */   // Label 30319: @2201492
     /* 2201492 */   GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2201554), // Rule ID 54937 //
     /* 2201497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2201504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201527 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2201530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201553 */     // GIR_Coverage, 54937,
     /* 2201553 */     GIR_EraseRootFromParent_Done,
     /* 2201554 */   // Label 30320: @2201554
     /* 2201554 */   GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2201616), // Rule ID 71401 //
     /* 2201559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2201570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201589 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2201592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2201596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201615 */     // GIR_Coverage, 71401,
     /* 2201615 */     GIR_EraseRootFromParent_Done,
     /* 2201616 */   // Label 30321: @2201616
     /* 2201616 */   GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2201678), // Rule ID 71402 //
     /* 2201621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2201632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201651 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2201654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2201658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201677 */     // GIR_Coverage, 71402,
     /* 2201677 */     GIR_EraseRootFromParent_Done,
     /* 2201678 */   // Label 30322: @2201678
     /* 2201678 */   GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2201740), // Rule ID 54928 //
     /* 2201683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2201698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201713 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2201716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2201726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201739 */     // GIR_Coverage, 54928,
     /* 2201739 */     GIR_EraseRootFromParent_Done,
     /* 2201740 */   // Label 30323: @2201740
     /* 2201740 */   GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2201802), // Rule ID 54929 //
     /* 2201745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2201760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2201768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2201775 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2201778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2201788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201801 */     // GIR_Coverage, 54929,
     /* 2201801 */     GIR_EraseRootFromParent_Done,
     /* 2201802 */   // Label 30324: @2201802
     /* 2201802 */   GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2201847), // Rule ID 54924 //
     /* 2201807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2201810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201822 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2201825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201846 */     // GIR_Coverage, 54924,
     /* 2201846 */     GIR_EraseRootFromParent_Done,
     /* 2201847 */   // Label 30325: @2201847
     /* 2201847 */   GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2201892), // Rule ID 54925 //
     /* 2201852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2201855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201867 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2201867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2201870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2201878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201891 */     // GIR_Coverage, 54925,
     /* 2201891 */     GIR_EraseRootFromParent_Done,
     /* 2201892 */   // Label 30326: @2201892
     /* 2201892 */   GIM_Reject,
     /* 2201893 */ // Label 30314: @2201893
     /* 2201893 */ GIM_Reject,
     /* 2201894 */ // Label 30098: @2201894
     /* 2201894 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2202683),
     /* 2201899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2201902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2201905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2201908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201912 */   GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2201989), // Rule ID 55188 //
     /* 2201917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2201920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2201924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2201932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2201945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2201949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2201953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2201960 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2201960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2201963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2201967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2201971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2201975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2201984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2201987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201988 */     // GIR_Coverage, 55188,
     /* 2201988 */     GIR_EraseRootFromParent_Done,
     /* 2201989 */   // Label 30328: @2201989
     /* 2201989 */   GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2202066), // Rule ID 55189 //
     /* 2201994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2201997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2202001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202037 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2202040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202065 */     // GIR_Coverage, 55189,
     /* 2202065 */     GIR_EraseRootFromParent_Done,
     /* 2202066 */   // Label 30329: @2202066
     /* 2202066 */   GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2202143), // Rule ID 71621 //
     /* 2202071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2202074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202114 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2202117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202142 */     // GIR_Coverage, 71621,
     /* 2202142 */     GIR_EraseRootFromParent_Done,
     /* 2202143 */   // Label 30330: @2202143
     /* 2202143 */   GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2202220), // Rule ID 71622 //
     /* 2202148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2202151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202191 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2202194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202219 */     // GIR_Coverage, 71622,
     /* 2202219 */     GIR_EraseRootFromParent_Done,
     /* 2202220 */   // Label 30331: @2202220
     /* 2202220 */   GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2202282), // Rule ID 55192 //
     /* 2202225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2202228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2202232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202255 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2202258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202281 */     // GIR_Coverage, 55192,
     /* 2202281 */     GIR_EraseRootFromParent_Done,
     /* 2202282 */   // Label 30332: @2202282
     /* 2202282 */   GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2202344), // Rule ID 55193 //
     /* 2202287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2202290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2202294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202317 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2202320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202343 */     // GIR_Coverage, 55193,
     /* 2202343 */     GIR_EraseRootFromParent_Done,
     /* 2202344 */   // Label 30333: @2202344
     /* 2202344 */   GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2202406), // Rule ID 71625 //
     /* 2202349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2202352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202379 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2202382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202405 */     // GIR_Coverage, 71625,
     /* 2202405 */     GIR_EraseRootFromParent_Done,
     /* 2202406 */   // Label 30334: @2202406
     /* 2202406 */   GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2202468), // Rule ID 71626 //
     /* 2202411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2202414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202441 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2202444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202467 */     // GIR_Coverage, 71626,
     /* 2202467 */     GIR_EraseRootFromParent_Done,
     /* 2202468 */   // Label 30335: @2202468
     /* 2202468 */   GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2202530), // Rule ID 55184 //
     /* 2202473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2202476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2202488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202503 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2202506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2202512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2202516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202529 */     // GIR_Coverage, 55184,
     /* 2202529 */     GIR_EraseRootFromParent_Done,
     /* 2202530 */   // Label 30336: @2202530
     /* 2202530 */   GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2202592), // Rule ID 55185 //
     /* 2202535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2202538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2202550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2202558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2202565 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2202568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2202574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2202578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202591 */     // GIR_Coverage, 55185,
     /* 2202591 */     GIR_EraseRootFromParent_Done,
     /* 2202592 */   // Label 30337: @2202592
     /* 2202592 */   GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2202637), // Rule ID 55180 //
     /* 2202597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2202600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202612 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2202615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2202621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202636 */     // GIR_Coverage, 55180,
     /* 2202636 */     GIR_EraseRootFromParent_Done,
     /* 2202637 */   // Label 30338: @2202637
     /* 2202637 */   GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2202682), // Rule ID 55181 //
     /* 2202642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2202645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202657 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2202660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2202666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2202668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202681 */     // GIR_Coverage, 55181,
     /* 2202681 */     GIR_EraseRootFromParent_Done,
     /* 2202682 */   // Label 30339: @2202682
     /* 2202682 */   GIM_Reject,
     /* 2202683 */ // Label 30327: @2202683
     /* 2202683 */ GIM_Reject,
     /* 2202684 */ // Label 30099: @2202684
     /* 2202684 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2203473),
     /* 2202689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2202695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2202698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202702 */   GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2202779), // Rule ID 54740 //
     /* 2202707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2202710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2202714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202750 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2202753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202778 */     // GIR_Coverage, 54740,
     /* 2202778 */     GIR_EraseRootFromParent_Done,
     /* 2202779 */   // Label 30341: @2202779
     /* 2202779 */   GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2202856), // Rule ID 54741 //
     /* 2202784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2202787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2202791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202827 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2202830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2202834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202855 */     // GIR_Coverage, 54741,
     /* 2202855 */     GIR_EraseRootFromParent_Done,
     /* 2202856 */   // Label 30342: @2202856
     /* 2202856 */   GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2202933), // Rule ID 71229 //
     /* 2202861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2202864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202904 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2202904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2202907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2202931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202932 */     // GIR_Coverage, 71229,
     /* 2202932 */     GIR_EraseRootFromParent_Done,
     /* 2202933 */   // Label 30343: @2202933
     /* 2202933 */   GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2203010), // Rule ID 71230 //
     /* 2202938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2202941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2202949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2202966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2202970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2202974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2202981 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2202981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2202984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2202988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2202992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2202996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2202999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203009 */     // GIR_Coverage, 71230,
     /* 2203009 */     GIR_EraseRootFromParent_Done,
     /* 2203010 */   // Label 30344: @2203010
     /* 2203010 */   GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2203072), // Rule ID 54744 //
     /* 2203015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2203018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203045 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2203048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203071 */     // GIR_Coverage, 54744,
     /* 2203071 */     GIR_EraseRootFromParent_Done,
     /* 2203072 */   // Label 30345: @2203072
     /* 2203072 */   GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2203134), // Rule ID 54745 //
     /* 2203077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2203080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203107 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2203110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203133 */     // GIR_Coverage, 54745,
     /* 2203133 */     GIR_EraseRootFromParent_Done,
     /* 2203134 */   // Label 30346: @2203134
     /* 2203134 */   GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2203196), // Rule ID 71233 //
     /* 2203139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2203142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2203150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203169 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2203172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2203176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203195 */     // GIR_Coverage, 71233,
     /* 2203195 */     GIR_EraseRootFromParent_Done,
     /* 2203196 */   // Label 30347: @2203196
     /* 2203196 */   GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2203258), // Rule ID 71234 //
     /* 2203201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2203204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2203212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203231 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2203234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2203238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203257 */     // GIR_Coverage, 71234,
     /* 2203257 */     GIR_EraseRootFromParent_Done,
     /* 2203258 */   // Label 30348: @2203258
     /* 2203258 */   GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2203320), // Rule ID 54736 //
     /* 2203263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2203266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2203278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203293 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2203296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2203302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2203306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203319 */     // GIR_Coverage, 54736,
     /* 2203319 */     GIR_EraseRootFromParent_Done,
     /* 2203320 */   // Label 30349: @2203320
     /* 2203320 */   GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2203382), // Rule ID 54737 //
     /* 2203325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2203328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2203340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2203348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203355 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2203358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2203364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2203368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203381 */     // GIR_Coverage, 54737,
     /* 2203381 */     GIR_EraseRootFromParent_Done,
     /* 2203382 */   // Label 30350: @2203382
     /* 2203382 */   GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2203427), // Rule ID 54732 //
     /* 2203387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2203390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203402 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2203405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2203411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203426 */     // GIR_Coverage, 54732,
     /* 2203426 */     GIR_EraseRootFromParent_Done,
     /* 2203427 */   // Label 30351: @2203427
     /* 2203427 */   GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2203472), // Rule ID 54733 //
     /* 2203432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2203435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203447 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2203450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2203456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203471 */     // GIR_Coverage, 54733,
     /* 2203471 */     GIR_EraseRootFromParent_Done,
     /* 2203472 */   // Label 30352: @2203472
     /* 2203472 */   GIM_Reject,
     /* 2203473 */ // Label 30340: @2203473
     /* 2203473 */ GIM_Reject,
     /* 2203474 */ // Label 30100: @2203474
     /* 2203474 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2204263),
     /* 2203479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2203485 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203492 */   GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2203569), // Rule ID 54996 //
     /* 2203497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2203500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2203525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2203540 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2203543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2203555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203568 */     // GIR_Coverage, 54996,
     /* 2203568 */     GIR_EraseRootFromParent_Done,
     /* 2203569 */   // Label 30354: @2203569
     /* 2203569 */   GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2203646), // Rule ID 54997 //
     /* 2203574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2203577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2203602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2203617 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2203620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2203632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203645 */     // GIR_Coverage, 54997,
     /* 2203645 */     GIR_EraseRootFromParent_Done,
     /* 2203646 */   // Label 30355: @2203646
     /* 2203646 */   GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2203723), // Rule ID 71453 //
     /* 2203651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2203654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2203662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2203679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2203694 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2203697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2203701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2203709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203722 */     // GIR_Coverage, 71453,
     /* 2203722 */     GIR_EraseRootFromParent_Done,
     /* 2203723 */   // Label 30356: @2203723
     /* 2203723 */   GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2203800), // Rule ID 71454 //
     /* 2203728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2203731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2203739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2203756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2203771 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2203774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2203778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2203786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203799 */     // GIR_Coverage, 71454,
     /* 2203799 */     GIR_EraseRootFromParent_Done,
     /* 2203800 */   // Label 30357: @2203800
     /* 2203800 */   GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2203862), // Rule ID 55000 //
     /* 2203805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2203808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203835 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2203838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203861 */     // GIR_Coverage, 55000,
     /* 2203861 */     GIR_EraseRootFromParent_Done,
     /* 2203862 */   // Label 30358: @2203862
     /* 2203862 */   GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2203924), // Rule ID 55001 //
     /* 2203867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2203870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203897 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2203897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2203900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2203904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203923 */     // GIR_Coverage, 55001,
     /* 2203923 */     GIR_EraseRootFromParent_Done,
     /* 2203924 */   // Label 30359: @2203924
     /* 2203924 */   GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2203986), // Rule ID 71457 //
     /* 2203929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2203932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2203940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2203944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2203948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2203959 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2203959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2203962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2203966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2203970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2203972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2203975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2203984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203985 */     // GIR_Coverage, 71457,
     /* 2203985 */     GIR_EraseRootFromParent_Done,
     /* 2203986 */   // Label 30360: @2203986
     /* 2203986 */   GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2204048), // Rule ID 71458 //
     /* 2203991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2203994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2204002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2204010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204021 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2204024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2204028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204047 */     // GIR_Coverage, 71458,
     /* 2204047 */     GIR_EraseRootFromParent_Done,
     /* 2204048 */   // Label 30361: @2204048
     /* 2204048 */   GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2204110), // Rule ID 54992 //
     /* 2204053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2204056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2204068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2204076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204083 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2204086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2204096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204109 */     // GIR_Coverage, 54992,
     /* 2204109 */     GIR_EraseRootFromParent_Done,
     /* 2204110 */   // Label 30362: @2204110
     /* 2204110 */   GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2204172), // Rule ID 54993 //
     /* 2204115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2204118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2204130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2204138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204145 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2204148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2204158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204171 */     // GIR_Coverage, 54993,
     /* 2204171 */     GIR_EraseRootFromParent_Done,
     /* 2204172 */   // Label 30363: @2204172
     /* 2204172 */   GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2204217), // Rule ID 54988 //
     /* 2204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2204180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204192 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2204195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204216 */     // GIR_Coverage, 54988,
     /* 2204216 */     GIR_EraseRootFromParent_Done,
     /* 2204217 */   // Label 30364: @2204217
     /* 2204217 */   GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2204262), // Rule ID 54989 //
     /* 2204222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2204225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204237 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2204240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204261 */     // GIR_Coverage, 54989,
     /* 2204261 */     GIR_EraseRootFromParent_Done,
     /* 2204262 */   // Label 30365: @2204262
     /* 2204262 */   GIM_Reject,
     /* 2204263 */ // Label 30353: @2204263
     /* 2204263 */ GIM_Reject,
     /* 2204264 */ // Label 30101: @2204264
     /* 2204264 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2205053),
     /* 2204269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2204275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2204278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204282 */   GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2204359), // Rule ID 54804 //
     /* 2204287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2204294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2204315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2204330 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2204333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2204345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204358 */     // GIR_Coverage, 54804,
     /* 2204358 */     GIR_EraseRootFromParent_Done,
     /* 2204359 */   // Label 30367: @2204359
     /* 2204359 */   GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2204436), // Rule ID 54805 //
     /* 2204364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2204367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2204371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2204392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2204407 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2204410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2204422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204435 */     // GIR_Coverage, 54805,
     /* 2204435 */     GIR_EraseRootFromParent_Done,
     /* 2204436 */   // Label 30368: @2204436
     /* 2204436 */   GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2204513), // Rule ID 71285 //
     /* 2204441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2204452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2204469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2204484 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2204487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2204491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2204499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204512 */     // GIR_Coverage, 71285,
     /* 2204512 */     GIR_EraseRootFromParent_Done,
     /* 2204513 */   // Label 30369: @2204513
     /* 2204513 */   GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2204590), // Rule ID 71286 //
     /* 2204518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2204521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2204529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2204546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2204561 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2204564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2204568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2204576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204589 */     // GIR_Coverage, 71286,
     /* 2204589 */     GIR_EraseRootFromParent_Done,
     /* 2204590 */   // Label 30370: @2204590
     /* 2204590 */   GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2204652), // Rule ID 54808 //
     /* 2204595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2204602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204625 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2204628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204651 */     // GIR_Coverage, 54808,
     /* 2204651 */     GIR_EraseRootFromParent_Done,
     /* 2204652 */   // Label 30371: @2204652
     /* 2204652 */   GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2204714), // Rule ID 54809 //
     /* 2204657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2204660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2204664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204687 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2204690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204713 */     // GIR_Coverage, 54809,
     /* 2204713 */     GIR_EraseRootFromParent_Done,
     /* 2204714 */   // Label 30372: @2204714
     /* 2204714 */   GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2204776), // Rule ID 71289 //
     /* 2204719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2204730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204749 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2204752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2204756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204775 */     // GIR_Coverage, 71289,
     /* 2204775 */     GIR_EraseRootFromParent_Done,
     /* 2204776 */   // Label 30373: @2204776
     /* 2204776 */   GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2204838), // Rule ID 71290 //
     /* 2204781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2204784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2204792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204811 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2204814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2204818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2204822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204837 */     // GIR_Coverage, 71290,
     /* 2204837 */     GIR_EraseRootFromParent_Done,
     /* 2204838 */   // Label 30374: @2204838
     /* 2204838 */   GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2204900), // Rule ID 54800 //
     /* 2204843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2204858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204873 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2204876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2204886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204899 */     // GIR_Coverage, 54800,
     /* 2204899 */     GIR_EraseRootFromParent_Done,
     /* 2204900 */   // Label 30375: @2204900
     /* 2204900 */   GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2204962), // Rule ID 54801 //
     /* 2204905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2204908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2204920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2204924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2204928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2204935 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2204935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2204938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2204948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2204960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204961 */     // GIR_Coverage, 54801,
     /* 2204961 */     GIR_EraseRootFromParent_Done,
     /* 2204962 */   // Label 30376: @2204962
     /* 2204962 */   GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2205007), // Rule ID 54796 //
     /* 2204967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2204970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204982 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2204982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2204985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2204989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2204991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2204993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2204996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2205005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205006 */     // GIR_Coverage, 54796,
     /* 2205006 */     GIR_EraseRootFromParent_Done,
     /* 2205007 */   // Label 30377: @2205007
     /* 2205007 */   GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2205052), // Rule ID 54797 //
     /* 2205012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2205015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205027 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2205027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2205030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2205034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2205038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2205050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205051 */     // GIR_Coverage, 54797,
     /* 2205051 */     GIR_EraseRootFromParent_Done,
     /* 2205052 */   // Label 30378: @2205052
     /* 2205052 */   GIM_Reject,
     /* 2205053 */ // Label 30366: @2205053
     /* 2205053 */ GIM_Reject,
     /* 2205054 */ // Label 30102: @2205054
     /* 2205054 */ GIM_Reject,
     /* 2205055 */ // Label 61: @2205055
     /* 2205055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30397*/ GIMT_Encode4(2207482),
     /* 2205066 */ /*GILLT_s16*//*Label 30379*/ GIMT_Encode4(2205186),
     /* 2205070 */ /*GILLT_s32*//*Label 30380*/ GIMT_Encode4(2205335),
     /* 2205074 */ /*GILLT_s64*//*Label 30381*/ GIMT_Encode4(2205484), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205086 */ /*GILLT_nxv1s16*//*Label 30382*/ GIMT_Encode4(2205667),
     /* 2205090 */ /*GILLT_nxv1s32*//*Label 30383*/ GIMT_Encode4(2205788),
     /* 2205094 */ /*GILLT_nxv1s64*//*Label 30384*/ GIMT_Encode4(2205909), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205106 */ /*GILLT_nxv2s16*//*Label 30385*/ GIMT_Encode4(2206030),
     /* 2205110 */ /*GILLT_nxv2s32*//*Label 30386*/ GIMT_Encode4(2206151),
     /* 2205114 */ /*GILLT_nxv2s64*//*Label 30387*/ GIMT_Encode4(2206272), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205126 */ /*GILLT_nxv4s16*//*Label 30388*/ GIMT_Encode4(2206393),
     /* 2205130 */ /*GILLT_nxv4s32*//*Label 30389*/ GIMT_Encode4(2206514),
     /* 2205134 */ /*GILLT_nxv4s64*//*Label 30390*/ GIMT_Encode4(2206635), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205146 */ /*GILLT_nxv8s16*//*Label 30391*/ GIMT_Encode4(2206756),
     /* 2205150 */ /*GILLT_nxv8s32*//*Label 30392*/ GIMT_Encode4(2206877),
     /* 2205154 */ /*GILLT_nxv8s64*//*Label 30393*/ GIMT_Encode4(2206998), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205166 */ /*GILLT_nxv16s16*//*Label 30394*/ GIMT_Encode4(2207119),
     /* 2205170 */ /*GILLT_nxv16s32*//*Label 30395*/ GIMT_Encode4(2207240), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205182 */ /*GILLT_nxv32s16*//*Label 30396*/ GIMT_Encode4(2207361),
     /* 2205186 */ // Label 30379: @2205186
     /* 2205186 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2205334),
     /* 2205191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2205194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2205197 */   GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2205231), // Rule ID 1840 //
     /* 2205202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2205205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205217 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2205217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2205220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205230 */     // GIR_Coverage, 1840,
     /* 2205230 */     GIR_EraseRootFromParent_Done,
     /* 2205231 */   // Label 30399: @2205231
     /* 2205231 */   GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2205265), // Rule ID 1841 //
     /* 2205236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2205239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205251 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2205251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2205254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205264 */     // GIR_Coverage, 1841,
     /* 2205264 */     GIR_EraseRootFromParent_Done,
     /* 2205265 */   // Label 30400: @2205265
     /* 2205265 */   GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2205299), // Rule ID 1844 //
     /* 2205270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2205273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205285 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2205285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2205288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205298 */     // GIR_Coverage, 1844,
     /* 2205298 */     GIR_EraseRootFromParent_Done,
     /* 2205299 */   // Label 30401: @2205299
     /* 2205299 */   GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2205333), // Rule ID 1845 //
     /* 2205304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2205307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2205319 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2205319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2205322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205332 */     // GIR_Coverage, 1845,
     /* 2205332 */     GIR_EraseRootFromParent_Done,
     /* 2205333 */   // Label 30402: @2205333
     /* 2205333 */   GIM_Reject,
     /* 2205334 */ // Label 30398: @2205334
     /* 2205334 */ GIM_Reject,
     /* 2205335 */ // Label 30380: @2205335
     /* 2205335 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2205483),
     /* 2205340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2205343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2205346 */   GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2205380), // Rule ID 1131 //
     /* 2205351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2205354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205366 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2205366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2205369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205379 */     // GIR_Coverage, 1131,
     /* 2205379 */     GIR_EraseRootFromParent_Done,
     /* 2205380 */   // Label 30404: @2205380
     /* 2205380 */   GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2205414), // Rule ID 1132 //
     /* 2205385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2205388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205400 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2205400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2205403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205413 */     // GIR_Coverage, 1132,
     /* 2205413 */     GIR_EraseRootFromParent_Done,
     /* 2205414 */   // Label 30405: @2205414
     /* 2205414 */   GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2205448), // Rule ID 1135 //
     /* 2205419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2205422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205434 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2205434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2205437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205447 */     // GIR_Coverage, 1135,
     /* 2205447 */     GIR_EraseRootFromParent_Done,
     /* 2205448 */   // Label 30406: @2205448
     /* 2205448 */   GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2205482), // Rule ID 1136 //
     /* 2205453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2205456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2205468 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2205468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2205471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205481 */     // GIR_Coverage, 1136,
     /* 2205481 */     GIR_EraseRootFromParent_Done,
     /* 2205482 */   // Label 30407: @2205482
     /* 2205482 */   GIM_Reject,
     /* 2205483 */ // Label 30403: @2205483
     /* 2205483 */ GIM_Reject,
     /* 2205484 */ // Label 30381: @2205484
     /* 2205484 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2205666),
     /* 2205489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2205492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2205495 */   GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2205529), // Rule ID 1472 //
     /* 2205500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2205503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205515 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2205515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2205518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205528 */     // GIR_Coverage, 1472,
     /* 2205528 */     GIR_EraseRootFromParent_Done,
     /* 2205529 */   // Label 30409: @2205529
     /* 2205529 */   GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2205563), // Rule ID 1473 //
     /* 2205534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2205537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2205549 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2205549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2205552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205562 */     // GIR_Coverage, 1473,
     /* 2205562 */     GIR_EraseRootFromParent_Done,
     /* 2205563 */   // Label 30410: @2205563
     /* 2205563 */   GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2205597), // Rule ID 1476 //
     /* 2205568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2205571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205583 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2205583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2205586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205596 */     // GIR_Coverage, 1476,
     /* 2205596 */     GIR_EraseRootFromParent_Done,
     /* 2205597 */   // Label 30411: @2205597
     /* 2205597 */   GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2205631), // Rule ID 1477 //
     /* 2205602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2205605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2205617 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2205617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2205620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205630 */     // GIR_Coverage, 1477,
     /* 2205630 */     GIR_EraseRootFromParent_Done,
     /* 2205631 */   // Label 30412: @2205631
     /* 2205631 */   GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2205665), // Rule ID 1479 //
     /* 2205636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2205639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205651 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2205651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2205654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205664 */     // GIR_Coverage, 1479,
     /* 2205664 */     GIR_EraseRootFromParent_Done,
     /* 2205665 */   // Label 30413: @2205665
     /* 2205665 */   GIM_Reject,
     /* 2205666 */ // Label 30408: @2205666
     /* 2205666 */ GIM_Reject,
     /* 2205667 */ // Label 30382: @2205667
     /* 2205667 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2205787),
     /* 2205672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2205675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205690 */   GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2205738), // Rule ID 53858 //
     /* 2205695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2205698 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2205715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205737 */     // GIR_Coverage, 53858,
     /* 2205737 */     GIR_EraseRootFromParent_Done,
     /* 2205738 */   // Label 30415: @2205738
     /* 2205738 */   GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2205786), // Rule ID 53859 //
     /* 2205743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2205746 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2205763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205785 */     // GIR_Coverage, 53859,
     /* 2205785 */     GIR_EraseRootFromParent_Done,
     /* 2205786 */   // Label 30416: @2205786
     /* 2205786 */   GIM_Reject,
     /* 2205787 */ // Label 30414: @2205787
     /* 2205787 */ GIM_Reject,
     /* 2205788 */ // Label 30383: @2205788
     /* 2205788 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2205908),
     /* 2205793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2205796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2205799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205811 */   GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2205859), // Rule ID 53882 //
     /* 2205816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2205819 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2205822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2205836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205858 */     // GIR_Coverage, 53882,
     /* 2205858 */     GIR_EraseRootFromParent_Done,
     /* 2205859 */   // Label 30418: @2205859
     /* 2205859 */   GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2205907), // Rule ID 53883 //
     /* 2205864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2205867 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2205870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2205884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205906 */     // GIR_Coverage, 53883,
     /* 2205906 */     GIR_EraseRootFromParent_Done,
     /* 2205907 */   // Label 30419: @2205907
     /* 2205907 */   GIM_Reject,
     /* 2205908 */ // Label 30417: @2205908
     /* 2205908 */ GIM_Reject,
     /* 2205909 */ // Label 30384: @2205909
     /* 2205909 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2206029),
     /* 2205914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2205917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2205920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205932 */   GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2205980), // Rule ID 53918 //
     /* 2205937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2205940 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2205943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2205957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2205975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205979 */     // GIR_Coverage, 53918,
     /* 2205979 */     GIR_EraseRootFromParent_Done,
     /* 2205980 */   // Label 30421: @2205980
     /* 2205980 */   GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2206028), // Rule ID 53919 //
     /* 2205985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2205988 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2205991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2206005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206027 */     // GIR_Coverage, 53919,
     /* 2206027 */     GIR_EraseRootFromParent_Done,
     /* 2206028 */   // Label 30422: @2206028
     /* 2206028 */   GIM_Reject,
     /* 2206029 */ // Label 30420: @2206029
     /* 2206029 */ GIM_Reject,
     /* 2206030 */ // Label 30385: @2206030
     /* 2206030 */ GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2206150),
     /* 2206035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2206038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2206041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206053 */   GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2206101), // Rule ID 53870 //
     /* 2206058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2206061 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2206064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2206078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206100 */     // GIR_Coverage, 53870,
     /* 2206100 */     GIR_EraseRootFromParent_Done,
     /* 2206101 */   // Label 30424: @2206101
     /* 2206101 */   GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2206149), // Rule ID 53871 //
     /* 2206106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2206109 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2206112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2206126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206148 */     // GIR_Coverage, 53871,
     /* 2206148 */     GIR_EraseRootFromParent_Done,
     /* 2206149 */   // Label 30425: @2206149
     /* 2206149 */   GIM_Reject,
     /* 2206150 */ // Label 30423: @2206150
     /* 2206150 */ GIM_Reject,
     /* 2206151 */ // Label 30386: @2206151
     /* 2206151 */ GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2206271),
     /* 2206156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2206159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2206162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206174 */   GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2206222), // Rule ID 53906 //
     /* 2206179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2206182 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2206185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2206199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206221 */     // GIR_Coverage, 53906,
     /* 2206221 */     GIR_EraseRootFromParent_Done,
     /* 2206222 */   // Label 30427: @2206222
     /* 2206222 */   GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2206270), // Rule ID 53907 //
     /* 2206227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2206230 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2206233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2206247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206269 */     // GIR_Coverage, 53907,
     /* 2206269 */     GIR_EraseRootFromParent_Done,
     /* 2206270 */   // Label 30428: @2206270
     /* 2206270 */   GIM_Reject,
     /* 2206271 */ // Label 30426: @2206271
     /* 2206271 */ GIM_Reject,
     /* 2206272 */ // Label 30387: @2206272
     /* 2206272 */ GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2206392),
     /* 2206277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2206280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2206283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206295 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2206343), // Rule ID 54002 //
     /* 2206300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2206303 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2206306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2206320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206342 */     // GIR_Coverage, 54002,
     /* 2206342 */     GIR_EraseRootFromParent_Done,
     /* 2206343 */   // Label 30430: @2206343
     /* 2206343 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2206391), // Rule ID 54003 //
     /* 2206348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2206351 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2206354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2206368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206390 */     // GIR_Coverage, 54003,
     /* 2206390 */     GIR_EraseRootFromParent_Done,
     /* 2206391 */   // Label 30431: @2206391
     /* 2206391 */   GIM_Reject,
     /* 2206392 */ // Label 30429: @2206392
     /* 2206392 */ GIM_Reject,
     /* 2206393 */ // Label 30388: @2206393
     /* 2206393 */ GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2206513),
     /* 2206398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2206401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2206404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206416 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2206464), // Rule ID 53894 //
     /* 2206421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2206424 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2206427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2206441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206463 */     // GIR_Coverage, 53894,
     /* 2206463 */     GIR_EraseRootFromParent_Done,
     /* 2206464 */   // Label 30433: @2206464
     /* 2206464 */   GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2206512), // Rule ID 53895 //
     /* 2206469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2206472 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2206475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2206489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206511 */     // GIR_Coverage, 53895,
     /* 2206511 */     GIR_EraseRootFromParent_Done,
     /* 2206512 */   // Label 30434: @2206512
     /* 2206512 */   GIM_Reject,
     /* 2206513 */ // Label 30432: @2206513
     /* 2206513 */ GIM_Reject,
     /* 2206514 */ // Label 30389: @2206514
     /* 2206514 */ GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2206634),
     /* 2206519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2206522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2206525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206537 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2206585), // Rule ID 53966 //
     /* 2206542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2206545 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2206548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2206562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206584 */     // GIR_Coverage, 53966,
     /* 2206584 */     GIR_EraseRootFromParent_Done,
     /* 2206585 */   // Label 30436: @2206585
     /* 2206585 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2206633), // Rule ID 53967 //
     /* 2206590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2206593 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2206596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2206610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206632 */     // GIR_Coverage, 53967,
     /* 2206632 */     GIR_EraseRootFromParent_Done,
     /* 2206633 */   // Label 30437: @2206633
     /* 2206633 */   GIM_Reject,
     /* 2206634 */ // Label 30435: @2206634
     /* 2206634 */ GIM_Reject,
     /* 2206635 */ // Label 30390: @2206635
     /* 2206635 */ GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2206755),
     /* 2206640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2206643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2206646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206658 */   GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2206706), // Rule ID 54014 //
     /* 2206663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2206666 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2206669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2206683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206705 */     // GIR_Coverage, 54014,
     /* 2206705 */     GIR_EraseRootFromParent_Done,
     /* 2206706 */   // Label 30439: @2206706
     /* 2206706 */   GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2206754), // Rule ID 54015 //
     /* 2206711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2206714 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2206717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2206731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206753 */     // GIR_Coverage, 54015,
     /* 2206753 */     GIR_EraseRootFromParent_Done,
     /* 2206754 */   // Label 30440: @2206754
     /* 2206754 */   GIM_Reject,
     /* 2206755 */ // Label 30438: @2206755
     /* 2206755 */ GIM_Reject,
     /* 2206756 */ // Label 30391: @2206756
     /* 2206756 */ GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2206876),
     /* 2206761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2206764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2206767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206779 */   GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2206827), // Rule ID 53930 //
     /* 2206784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2206787 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2206790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2206804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206826 */     // GIR_Coverage, 53930,
     /* 2206826 */     GIR_EraseRootFromParent_Done,
     /* 2206827 */   // Label 30442: @2206827
     /* 2206827 */   GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2206875), // Rule ID 53931 //
     /* 2206832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2206835 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2206838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2206852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206874 */     // GIR_Coverage, 53931,
     /* 2206874 */     GIR_EraseRootFromParent_Done,
     /* 2206875 */   // Label 30443: @2206875
     /* 2206875 */   GIM_Reject,
     /* 2206876 */ // Label 30441: @2206876
     /* 2206876 */ GIM_Reject,
     /* 2206877 */ // Label 30392: @2206877
     /* 2206877 */ GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2206997),
     /* 2206882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2206885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2206888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206900 */   GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2206948), // Rule ID 53978 //
     /* 2206905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2206908 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2206911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2206925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206947 */     // GIR_Coverage, 53978,
     /* 2206947 */     GIR_EraseRootFromParent_Done,
     /* 2206948 */   // Label 30445: @2206948
     /* 2206948 */   GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2206996), // Rule ID 53979 //
     /* 2206953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2206956 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2206959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2206973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2206985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206995 */     // GIR_Coverage, 53979,
     /* 2206995 */     GIR_EraseRootFromParent_Done,
     /* 2206996 */   // Label 30446: @2206996
     /* 2206996 */   GIM_Reject,
     /* 2206997 */ // Label 30444: @2206997
     /* 2206997 */ GIM_Reject,
     /* 2206998 */ // Label 30393: @2206998
     /* 2206998 */ GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2207118),
     /* 2207003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2207006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2207009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207021 */   GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2207069), // Rule ID 54026 //
     /* 2207026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2207029 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2207032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2207046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207068 */     // GIR_Coverage, 54026,
     /* 2207068 */     GIR_EraseRootFromParent_Done,
     /* 2207069 */   // Label 30448: @2207069
     /* 2207069 */   GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2207117), // Rule ID 54027 //
     /* 2207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2207077 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2207080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2207094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207116 */     // GIR_Coverage, 54027,
     /* 2207116 */     GIR_EraseRootFromParent_Done,
     /* 2207117 */   // Label 30449: @2207117
     /* 2207117 */   GIM_Reject,
     /* 2207118 */ // Label 30447: @2207118
     /* 2207118 */ GIM_Reject,
     /* 2207119 */ // Label 30394: @2207119
     /* 2207119 */ GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2207239),
     /* 2207124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2207127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2207130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207142 */   GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2207190), // Rule ID 53942 //
     /* 2207147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2207150 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2207153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2207167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207189 */     // GIR_Coverage, 53942,
     /* 2207189 */     GIR_EraseRootFromParent_Done,
     /* 2207190 */   // Label 30451: @2207190
     /* 2207190 */   GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2207238), // Rule ID 53943 //
     /* 2207195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2207198 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2207201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2207215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207237 */     // GIR_Coverage, 53943,
     /* 2207237 */     GIR_EraseRootFromParent_Done,
     /* 2207238 */   // Label 30452: @2207238
     /* 2207238 */   GIM_Reject,
     /* 2207239 */ // Label 30450: @2207239
     /* 2207239 */ GIM_Reject,
     /* 2207240 */ // Label 30395: @2207240
     /* 2207240 */ GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2207360),
     /* 2207245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2207248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2207251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207263 */   GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2207311), // Rule ID 53990 //
     /* 2207268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2207271 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2207274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2207288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207310 */     // GIR_Coverage, 53990,
     /* 2207310 */     GIR_EraseRootFromParent_Done,
     /* 2207311 */   // Label 30454: @2207311
     /* 2207311 */   GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2207359), // Rule ID 53991 //
     /* 2207316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2207319 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2207322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2207336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207358 */     // GIR_Coverage, 53991,
     /* 2207358 */     GIR_EraseRootFromParent_Done,
     /* 2207359 */   // Label 30455: @2207359
     /* 2207359 */   GIM_Reject,
     /* 2207360 */ // Label 30453: @2207360
     /* 2207360 */ GIM_Reject,
     /* 2207361 */ // Label 30396: @2207361
     /* 2207361 */ GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2207481),
     /* 2207366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2207369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2207372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207384 */   GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2207432), // Rule ID 53954 //
     /* 2207389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2207392 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2207395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2207409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207431 */     // GIR_Coverage, 53954,
     /* 2207431 */     GIR_EraseRootFromParent_Done,
     /* 2207432 */   // Label 30457: @2207432
     /* 2207432 */   GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2207480), // Rule ID 53955 //
     /* 2207437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2207440 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2207443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2207457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2207469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207479 */     // GIR_Coverage, 53955,
     /* 2207479 */     GIR_EraseRootFromParent_Done,
     /* 2207480 */   // Label 30458: @2207480
     /* 2207480 */   GIM_Reject,
     /* 2207481 */ // Label 30456: @2207481
     /* 2207481 */ GIM_Reject,
     /* 2207482 */ // Label 30397: @2207482
     /* 2207482 */ GIM_Reject,
     /* 2207483 */ // Label 62: @2207483
     /* 2207483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30477*/ GIMT_Encode4(2209453),
     /* 2207494 */ /*GILLT_s16*//*Label 30459*/ GIMT_Encode4(2207614),
     /* 2207498 */ /*GILLT_s32*//*Label 30460*/ GIMT_Encode4(2207678),
     /* 2207502 */ /*GILLT_s64*//*Label 30461*/ GIMT_Encode4(2207742), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207514 */ /*GILLT_nxv1s16*//*Label 30462*/ GIMT_Encode4(2207833),
     /* 2207518 */ /*GILLT_nxv1s32*//*Label 30463*/ GIMT_Encode4(2207941),
     /* 2207522 */ /*GILLT_nxv1s64*//*Label 30464*/ GIMT_Encode4(2208049), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207534 */ /*GILLT_nxv2s16*//*Label 30465*/ GIMT_Encode4(2208157),
     /* 2207538 */ /*GILLT_nxv2s32*//*Label 30466*/ GIMT_Encode4(2208265),
     /* 2207542 */ /*GILLT_nxv2s64*//*Label 30467*/ GIMT_Encode4(2208373), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207554 */ /*GILLT_nxv4s16*//*Label 30468*/ GIMT_Encode4(2208481),
     /* 2207558 */ /*GILLT_nxv4s32*//*Label 30469*/ GIMT_Encode4(2208589),
     /* 2207562 */ /*GILLT_nxv4s64*//*Label 30470*/ GIMT_Encode4(2208697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207574 */ /*GILLT_nxv8s16*//*Label 30471*/ GIMT_Encode4(2208805),
     /* 2207578 */ /*GILLT_nxv8s32*//*Label 30472*/ GIMT_Encode4(2208913),
     /* 2207582 */ /*GILLT_nxv8s64*//*Label 30473*/ GIMT_Encode4(2209021), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207594 */ /*GILLT_nxv16s16*//*Label 30474*/ GIMT_Encode4(2209129),
     /* 2207598 */ /*GILLT_nxv16s32*//*Label 30475*/ GIMT_Encode4(2209237), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207610 */ /*GILLT_nxv32s16*//*Label 30476*/ GIMT_Encode4(2209345),
     /* 2207614 */ // Label 30459: @2207614
     /* 2207614 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2207677),
     /* 2207619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2207622 */   GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2207649), // Rule ID 1850 //
     /* 2207627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2207630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2207634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2207638 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2207638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2207641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207648 */     // GIR_Coverage, 1850,
     /* 2207648 */     GIR_EraseRootFromParent_Done,
     /* 2207649 */   // Label 30479: @2207649
     /* 2207649 */   GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2207676), // Rule ID 1883 //
     /* 2207654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2207657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2207661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2207665 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2207665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2207668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207675 */     // GIR_Coverage, 1883,
     /* 2207675 */     GIR_EraseRootFromParent_Done,
     /* 2207676 */   // Label 30480: @2207676
     /* 2207676 */   GIM_Reject,
     /* 2207677 */ // Label 30478: @2207677
     /* 2207677 */ GIM_Reject,
     /* 2207678 */ // Label 30460: @2207678
     /* 2207678 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2207741),
     /* 2207683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2207686 */   GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2207713), // Rule ID 1141 //
     /* 2207691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2207694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207702 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2207702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2207705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207712 */     // GIR_Coverage, 1141,
     /* 2207712 */     GIR_EraseRootFromParent_Done,
     /* 2207713 */   // Label 30482: @2207713
     /* 2207713 */   GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2207740), // Rule ID 1149 //
     /* 2207718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2207721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2207725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2207729 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2207729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2207732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207739 */     // GIR_Coverage, 1149,
     /* 2207739 */     GIR_EraseRootFromParent_Done,
     /* 2207740 */   // Label 30483: @2207740
     /* 2207740 */   GIM_Reject,
     /* 2207741 */ // Label 30481: @2207741
     /* 2207741 */ GIM_Reject,
     /* 2207742 */ // Label 30461: @2207742
     /* 2207742 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2207832),
     /* 2207747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2207750 */   GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2207777), // Rule ID 1484 //
     /* 2207755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2207758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2207762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2207766 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2207766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2207769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207776 */     // GIR_Coverage, 1484,
     /* 2207776 */     GIR_EraseRootFromParent_Done,
     /* 2207777 */   // Label 30485: @2207777
     /* 2207777 */   GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2207804), // Rule ID 1517 //
     /* 2207782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2207785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207793 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2207793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2207796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207803 */     // GIR_Coverage, 1517,
     /* 2207803 */     GIR_EraseRootFromParent_Done,
     /* 2207804 */   // Label 30486: @2207804
     /* 2207804 */   GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2207831), // Rule ID 1539 //
     /* 2207809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2207812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2207816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2207820 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2207820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2207823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207830 */     // GIR_Coverage, 1539,
     /* 2207830 */     GIR_EraseRootFromParent_Done,
     /* 2207831 */   // Label 30487: @2207831
     /* 2207831 */   GIM_Reject,
     /* 2207832 */ // Label 30484: @2207832
     /* 2207832 */ GIM_Reject,
     /* 2207833 */ // Label 30462: @2207833
     /* 2207833 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2207940),
     /* 2207838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2207841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207849 */   GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2207894), // Rule ID 55696 //
     /* 2207854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2207857 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2207874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207893 */     // GIR_Coverage, 55696,
     /* 2207893 */     GIR_EraseRootFromParent_Done,
     /* 2207894 */   // Label 30489: @2207894
     /* 2207894 */   GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2207939), // Rule ID 55697 //
     /* 2207899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2207902 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2207919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207938 */     // GIR_Coverage, 55697,
     /* 2207938 */     GIR_EraseRootFromParent_Done,
     /* 2207939 */   // Label 30490: @2207939
     /* 2207939 */   GIM_Reject,
     /* 2207940 */ // Label 30488: @2207940
     /* 2207940 */ GIM_Reject,
     /* 2207941 */ // Label 30463: @2207941
     /* 2207941 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2208048),
     /* 2207946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2207949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207957 */   GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2208002), // Rule ID 55736 //
     /* 2207962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2207965 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2207982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2207991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208001 */     // GIR_Coverage, 55736,
     /* 2208001 */     GIR_EraseRootFromParent_Done,
     /* 2208002 */   // Label 30492: @2208002
     /* 2208002 */   GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2208047), // Rule ID 55737 //
     /* 2208007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2208010 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2208027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208046 */     // GIR_Coverage, 55737,
     /* 2208046 */     GIR_EraseRootFromParent_Done,
     /* 2208047 */   // Label 30493: @2208047
     /* 2208047 */   GIM_Reject,
     /* 2208048 */ // Label 30491: @2208048
     /* 2208048 */ GIM_Reject,
     /* 2208049 */ // Label 30464: @2208049
     /* 2208049 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2208156),
     /* 2208054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2208057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208065 */   GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2208110), // Rule ID 55796 //
     /* 2208070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2208073 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2208090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208109 */     // GIR_Coverage, 55796,
     /* 2208109 */     GIR_EraseRootFromParent_Done,
     /* 2208110 */   // Label 30495: @2208110
     /* 2208110 */   GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2208155), // Rule ID 55797 //
     /* 2208115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2208118 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2208135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208154 */     // GIR_Coverage, 55797,
     /* 2208154 */     GIR_EraseRootFromParent_Done,
     /* 2208155 */   // Label 30496: @2208155
     /* 2208155 */   GIM_Reject,
     /* 2208156 */ // Label 30494: @2208156
     /* 2208156 */ GIM_Reject,
     /* 2208157 */ // Label 30465: @2208157
     /* 2208157 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2208264),
     /* 2208162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208173 */   GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2208218), // Rule ID 55716 //
     /* 2208178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2208181 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2208198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208217 */     // GIR_Coverage, 55716,
     /* 2208217 */     GIR_EraseRootFromParent_Done,
     /* 2208218 */   // Label 30498: @2208218
     /* 2208218 */   GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2208263), // Rule ID 55717 //
     /* 2208223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2208226 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2208243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208262 */     // GIR_Coverage, 55717,
     /* 2208262 */     GIR_EraseRootFromParent_Done,
     /* 2208263 */   // Label 30499: @2208263
     /* 2208263 */   GIM_Reject,
     /* 2208264 */ // Label 30497: @2208264
     /* 2208264 */ GIM_Reject,
     /* 2208265 */ // Label 30466: @2208265
     /* 2208265 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2208372),
     /* 2208270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208281 */   GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2208326), // Rule ID 55776 //
     /* 2208286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2208289 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2208306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208325 */     // GIR_Coverage, 55776,
     /* 2208325 */     GIR_EraseRootFromParent_Done,
     /* 2208326 */   // Label 30501: @2208326
     /* 2208326 */   GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2208371), // Rule ID 55777 //
     /* 2208331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2208334 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2208351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208370 */     // GIR_Coverage, 55777,
     /* 2208370 */     GIR_EraseRootFromParent_Done,
     /* 2208371 */   // Label 30502: @2208371
     /* 2208371 */   GIM_Reject,
     /* 2208372 */ // Label 30500: @2208372
     /* 2208372 */ GIM_Reject,
     /* 2208373 */ // Label 30467: @2208373
     /* 2208373 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2208480),
     /* 2208378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2208381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208389 */   GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2208434), // Rule ID 55936 //
     /* 2208394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2208397 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2208414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208433 */     // GIR_Coverage, 55936,
     /* 2208433 */     GIR_EraseRootFromParent_Done,
     /* 2208434 */   // Label 30504: @2208434
     /* 2208434 */   GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2208479), // Rule ID 55937 //
     /* 2208439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2208442 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2208459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208478 */     // GIR_Coverage, 55937,
     /* 2208478 */     GIR_EraseRootFromParent_Done,
     /* 2208479 */   // Label 30505: @2208479
     /* 2208479 */   GIM_Reject,
     /* 2208480 */ // Label 30503: @2208480
     /* 2208480 */ GIM_Reject,
     /* 2208481 */ // Label 30468: @2208481
     /* 2208481 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2208588),
     /* 2208486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2208489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208497 */   GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2208542), // Rule ID 55756 //
     /* 2208502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2208505 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2208522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208541 */     // GIR_Coverage, 55756,
     /* 2208541 */     GIR_EraseRootFromParent_Done,
     /* 2208542 */   // Label 30507: @2208542
     /* 2208542 */   GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2208587), // Rule ID 55757 //
     /* 2208547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2208550 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2208567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208586 */     // GIR_Coverage, 55757,
     /* 2208586 */     GIR_EraseRootFromParent_Done,
     /* 2208587 */   // Label 30508: @2208587
     /* 2208587 */   GIM_Reject,
     /* 2208588 */ // Label 30506: @2208588
     /* 2208588 */ GIM_Reject,
     /* 2208589 */ // Label 30469: @2208589
     /* 2208589 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2208696),
     /* 2208594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2208597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208605 */   GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2208650), // Rule ID 55876 //
     /* 2208610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2208613 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2208616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2208630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208649 */     // GIR_Coverage, 55876,
     /* 2208649 */     GIR_EraseRootFromParent_Done,
     /* 2208650 */   // Label 30510: @2208650
     /* 2208650 */   GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2208695), // Rule ID 55877 //
     /* 2208655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2208658 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2208661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2208675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208694 */     // GIR_Coverage, 55877,
     /* 2208694 */     GIR_EraseRootFromParent_Done,
     /* 2208695 */   // Label 30511: @2208695
     /* 2208695 */   GIM_Reject,
     /* 2208696 */ // Label 30509: @2208696
     /* 2208696 */ GIM_Reject,
     /* 2208697 */ // Label 30470: @2208697
     /* 2208697 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2208804),
     /* 2208702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2208705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208713 */   GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2208758), // Rule ID 55956 //
     /* 2208718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2208721 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2208724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2208738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208757 */     // GIR_Coverage, 55956,
     /* 2208757 */     GIR_EraseRootFromParent_Done,
     /* 2208758 */   // Label 30513: @2208758
     /* 2208758 */   GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2208803), // Rule ID 55957 //
     /* 2208763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2208766 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2208769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2208783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208802 */     // GIR_Coverage, 55957,
     /* 2208802 */     GIR_EraseRootFromParent_Done,
     /* 2208803 */   // Label 30514: @2208803
     /* 2208803 */   GIM_Reject,
     /* 2208804 */ // Label 30512: @2208804
     /* 2208804 */ GIM_Reject,
     /* 2208805 */ // Label 30471: @2208805
     /* 2208805 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2208912),
     /* 2208810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2208813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208821 */   GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2208866), // Rule ID 55816 //
     /* 2208826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2208829 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2208832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2208846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208865 */     // GIR_Coverage, 55816,
     /* 2208865 */     GIR_EraseRootFromParent_Done,
     /* 2208866 */   // Label 30516: @2208866
     /* 2208866 */   GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2208911), // Rule ID 55817 //
     /* 2208871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2208874 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2208877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2208891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208910 */     // GIR_Coverage, 55817,
     /* 2208910 */     GIR_EraseRootFromParent_Done,
     /* 2208911 */   // Label 30517: @2208911
     /* 2208911 */   GIM_Reject,
     /* 2208912 */ // Label 30515: @2208912
     /* 2208912 */ GIM_Reject,
     /* 2208913 */ // Label 30472: @2208913
     /* 2208913 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2209020),
     /* 2208918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2208921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208929 */   GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2208974), // Rule ID 55896 //
     /* 2208934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2208937 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2208954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2208963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208973 */     // GIR_Coverage, 55896,
     /* 2208973 */     GIR_EraseRootFromParent_Done,
     /* 2208974 */   // Label 30519: @2208974
     /* 2208974 */   GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2209019), // Rule ID 55897 //
     /* 2208979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2208982 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2208999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209018 */     // GIR_Coverage, 55897,
     /* 2209018 */     GIR_EraseRootFromParent_Done,
     /* 2209019 */   // Label 30520: @2209019
     /* 2209019 */   GIM_Reject,
     /* 2209020 */ // Label 30518: @2209020
     /* 2209020 */ GIM_Reject,
     /* 2209021 */ // Label 30473: @2209021
     /* 2209021 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2209128),
     /* 2209026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2209029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209037 */   GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2209082), // Rule ID 55976 //
     /* 2209042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2209045 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2209048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2209062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209081 */     // GIR_Coverage, 55976,
     /* 2209081 */     GIR_EraseRootFromParent_Done,
     /* 2209082 */   // Label 30522: @2209082
     /* 2209082 */   GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2209127), // Rule ID 55977 //
     /* 2209087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2209090 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2209093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2209107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209126 */     // GIR_Coverage, 55977,
     /* 2209126 */     GIR_EraseRootFromParent_Done,
     /* 2209127 */   // Label 30523: @2209127
     /* 2209127 */   GIM_Reject,
     /* 2209128 */ // Label 30521: @2209128
     /* 2209128 */ GIM_Reject,
     /* 2209129 */ // Label 30474: @2209129
     /* 2209129 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2209236),
     /* 2209134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2209137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209145 */   GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2209190), // Rule ID 55836 //
     /* 2209150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2209153 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2209156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2209170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209189 */     // GIR_Coverage, 55836,
     /* 2209189 */     GIR_EraseRootFromParent_Done,
     /* 2209190 */   // Label 30525: @2209190
     /* 2209190 */   GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2209235), // Rule ID 55837 //
     /* 2209195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2209198 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2209201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2209215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209234 */     // GIR_Coverage, 55837,
     /* 2209234 */     GIR_EraseRootFromParent_Done,
     /* 2209235 */   // Label 30526: @2209235
     /* 2209235 */   GIM_Reject,
     /* 2209236 */ // Label 30524: @2209236
     /* 2209236 */ GIM_Reject,
     /* 2209237 */ // Label 30475: @2209237
     /* 2209237 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2209344),
     /* 2209242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2209245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209253 */   GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2209298), // Rule ID 55916 //
     /* 2209258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2209261 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2209264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2209278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209297 */     // GIR_Coverage, 55916,
     /* 2209297 */     GIR_EraseRootFromParent_Done,
     /* 2209298 */   // Label 30528: @2209298
     /* 2209298 */   GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2209343), // Rule ID 55917 //
     /* 2209303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2209306 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2209309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2209323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209342 */     // GIR_Coverage, 55917,
     /* 2209342 */     GIR_EraseRootFromParent_Done,
     /* 2209343 */   // Label 30529: @2209343
     /* 2209343 */   GIM_Reject,
     /* 2209344 */ // Label 30527: @2209344
     /* 2209344 */ GIM_Reject,
     /* 2209345 */ // Label 30476: @2209345
     /* 2209345 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2209452),
     /* 2209350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2209353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209361 */   GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2209406), // Rule ID 55856 //
     /* 2209366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2209369 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2209372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2209386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209405 */     // GIR_Coverage, 55856,
     /* 2209405 */     GIR_EraseRootFromParent_Done,
     /* 2209406 */   // Label 30531: @2209406
     /* 2209406 */   GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2209451), // Rule ID 55857 //
     /* 2209411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2209414 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2209417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2209431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2209440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209450 */     // GIR_Coverage, 55857,
     /* 2209450 */     GIR_EraseRootFromParent_Done,
     /* 2209451 */   // Label 30532: @2209451
     /* 2209451 */   GIM_Reject,
     /* 2209452 */ // Label 30530: @2209452
     /* 2209452 */ GIM_Reject,
     /* 2209453 */ // Label 30477: @2209453
     /* 2209453 */ GIM_Reject,
     /* 2209454 */ // Label 63: @2209454
     /* 2209454 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 30535*/ GIMT_Encode4(2209906),
     /* 2209465 */ /*GILLT_s32*//*Label 30533*/ GIMT_Encode4(2209473),
     /* 2209469 */ /*GILLT_s64*//*Label 30534*/ GIMT_Encode4(2209595),
     /* 2209473 */ // Label 30533: @2209473
     /* 2209473 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2209594),
     /* 2209478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209481 */   GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2209509), // Rule ID 2024 //
     /* 2209486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2209489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2209497 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2209497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2209500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209508 */     // GIR_Coverage, 2024,
     /* 2209508 */     GIR_EraseRootFromParent_Done,
     /* 2209509 */   // Label 30537: @2209509
     /* 2209509 */   GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2209537), // Rule ID 2025 //
     /* 2209514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2209517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2209525 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2209525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2209528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209536 */     // GIR_Coverage, 2025,
     /* 2209536 */     GIR_EraseRootFromParent_Done,
     /* 2209537 */   // Label 30538: @2209537
     /* 2209537 */   GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2209565), // Rule ID 2040 //
     /* 2209542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2209545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2209549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2209553 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2209553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2209556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209564 */     // GIR_Coverage, 2040,
     /* 2209564 */     GIR_EraseRootFromParent_Done,
     /* 2209565 */   // Label 30539: @2209565
     /* 2209565 */   GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2209593), // Rule ID 2041 //
     /* 2209570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2209573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2209577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2209581 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2209581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2209584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209592 */     // GIR_Coverage, 2041,
     /* 2209592 */     GIR_EraseRootFromParent_Done,
     /* 2209593 */   // Label 30540: @2209593
     /* 2209593 */   GIM_Reject,
     /* 2209594 */ // Label 30536: @2209594
     /* 2209594 */ GIM_Reject,
     /* 2209595 */ // Label 30534: @2209595
     /* 2209595 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2209626), // Rule ID 1426 //
     /* 2209600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2209603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2209610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209614 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2209614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2209617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209625 */   // GIR_Coverage, 1426,
     /* 2209625 */   GIR_EraseRootFromParent_Done,
     /* 2209626 */ // Label 30541: @2209626
     /* 2209626 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2209657), // Rule ID 1427 //
     /* 2209631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2209634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2209641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209645 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2209645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2209648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209656 */   // GIR_Coverage, 1427,
     /* 2209656 */   GIR_EraseRootFromParent_Done,
     /* 2209657 */ // Label 30542: @2209657
     /* 2209657 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2209688), // Rule ID 1431 //
     /* 2209662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2209665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2209676 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2209676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2209679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209681 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209687 */   // GIR_Coverage, 1431,
     /* 2209687 */   GIR_EraseRootFromParent_Done,
     /* 2209688 */ // Label 30543: @2209688
     /* 2209688 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2209719), // Rule ID 1438 //
     /* 2209693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2209696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2209703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2209707 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2209707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2209710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209712 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209718 */   // GIR_Coverage, 1438,
     /* 2209718 */   GIR_EraseRootFromParent_Done,
     /* 2209719 */ // Label 30544: @2209719
     /* 2209719 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2209750), // Rule ID 1439 //
     /* 2209724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2209727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2209734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2209738 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2209738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2209741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209743 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209749 */   // GIR_Coverage, 1439,
     /* 2209749 */   GIR_EraseRootFromParent_Done,
     /* 2209750 */ // Label 30545: @2209750
     /* 2209750 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2209781), // Rule ID 2158 //
     /* 2209755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2209758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2209765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2209769 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2209769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2209772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209780 */   // GIR_Coverage, 2158,
     /* 2209780 */   GIR_EraseRootFromParent_Done,
     /* 2209781 */ // Label 30546: @2209781
     /* 2209781 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2209812), // Rule ID 2159 //
     /* 2209786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2209789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2209796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2209800 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2209800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2209803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209805 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209811 */   // GIR_Coverage, 2159,
     /* 2209811 */   GIR_EraseRootFromParent_Done,
     /* 2209812 */ // Label 30547: @2209812
     /* 2209812 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2209843), // Rule ID 2170 //
     /* 2209817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2209820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2209827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2209831 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2209831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2209834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209842 */   // GIR_Coverage, 2170,
     /* 2209842 */   GIR_EraseRootFromParent_Done,
     /* 2209843 */ // Label 30548: @2209843
     /* 2209843 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2209874), // Rule ID 2171 //
     /* 2209848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2209851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2209858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2209862 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2209862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2209865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209873 */   // GIR_Coverage, 2171,
     /* 2209873 */   GIR_EraseRootFromParent_Done,
     /* 2209874 */ // Label 30549: @2209874
     /* 2209874 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2209905), // Rule ID 2179 //
     /* 2209879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2209882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2209885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2209893 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2209893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2209896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209904 */   // GIR_Coverage, 2179,
     /* 2209904 */   GIR_EraseRootFromParent_Done,
     /* 2209905 */ // Label 30550: @2209905
     /* 2209905 */ GIM_Reject,
     /* 2209906 */ // Label 30535: @2209906
     /* 2209906 */ GIM_Reject,
     /* 2209907 */ // Label 64: @2209907
     /* 2209907 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 30562*/ GIMT_Encode4(2211442),
     /* 2209918 */ /*GILLT_s16*//*Label 30551*/ GIMT_Encode4(2210022),
     /* 2209922 */ /*GILLT_s32*//*Label 30552*/ GIMT_Encode4(2210302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2209938 */ /*GILLT_nxv1s16*//*Label 30553*/ GIMT_Encode4(2210452),
     /* 2209942 */ /*GILLT_nxv1s32*//*Label 30554*/ GIMT_Encode4(2210562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2209958 */ /*GILLT_nxv2s16*//*Label 30555*/ GIMT_Encode4(2210672),
     /* 2209962 */ /*GILLT_nxv2s32*//*Label 30556*/ GIMT_Encode4(2210782), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2209978 */ /*GILLT_nxv4s16*//*Label 30557*/ GIMT_Encode4(2210892),
     /* 2209982 */ /*GILLT_nxv4s32*//*Label 30558*/ GIMT_Encode4(2211002), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2209998 */ /*GILLT_nxv8s16*//*Label 30559*/ GIMT_Encode4(2211112),
     /* 2210002 */ /*GILLT_nxv8s32*//*Label 30560*/ GIMT_Encode4(2211222), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210018 */ /*GILLT_nxv16s16*//*Label 30561*/ GIMT_Encode4(2211332),
     /* 2210022 */ // Label 30551: @2210022
     /* 2210022 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2210053), // Rule ID 2020 //
     /* 2210027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2210030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2210033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2210037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2210041 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2210041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2210044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210052 */   // GIR_Coverage, 2020,
     /* 2210052 */   GIR_EraseRootFromParent_Done,
     /* 2210053 */ // Label 30563: @2210053
     /* 2210053 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2210084), // Rule ID 2021 //
     /* 2210058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2210061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2210064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2210068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2210072 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2210072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2210075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210077 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210083 */   // GIR_Coverage, 2021,
     /* 2210083 */   GIR_EraseRootFromParent_Done,
     /* 2210084 */ // Label 30564: @2210084
     /* 2210084 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2210115), // Rule ID 2036 //
     /* 2210089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2210092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2210095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2210099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2210103 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2210103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2210106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210114 */   // GIR_Coverage, 2036,
     /* 2210114 */   GIR_EraseRootFromParent_Done,
     /* 2210115 */ // Label 30565: @2210115
     /* 2210115 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2210146), // Rule ID 2037 //
     /* 2210120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2210123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2210126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2210130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2210134 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2210134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2210137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210145 */   // GIR_Coverage, 2037,
     /* 2210145 */   GIR_EraseRootFromParent_Done,
     /* 2210146 */ // Label 30566: @2210146
     /* 2210146 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2210177), // Rule ID 2154 //
     /* 2210151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2210154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2210161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2210165 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2210168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210170 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210176 */   // GIR_Coverage, 2154,
     /* 2210176 */   GIR_EraseRootFromParent_Done,
     /* 2210177 */ // Label 30567: @2210177
     /* 2210177 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2210208), // Rule ID 2155 //
     /* 2210182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2210185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2210192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2210196 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2210196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2210199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210201 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210207 */   // GIR_Coverage, 2155,
     /* 2210207 */   GIR_EraseRootFromParent_Done,
     /* 2210208 */ // Label 30568: @2210208
     /* 2210208 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2210239), // Rule ID 2166 //
     /* 2210213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2210216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2210223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2210227 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2210230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210232 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210238 */   // GIR_Coverage, 2166,
     /* 2210238 */   GIR_EraseRootFromParent_Done,
     /* 2210239 */ // Label 30569: @2210239
     /* 2210239 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2210270), // Rule ID 2167 //
     /* 2210244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2210247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2210254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2210258 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2210258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2210261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210269 */   // GIR_Coverage, 2167,
     /* 2210269 */   GIR_EraseRootFromParent_Done,
     /* 2210270 */ // Label 30570: @2210270
     /* 2210270 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2210301), // Rule ID 2177 //
     /* 2210275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2210278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2210285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210289 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2210292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210300 */   // GIR_Coverage, 2177,
     /* 2210300 */   GIR_EraseRootFromParent_Done,
     /* 2210301 */ // Label 30571: @2210301
     /* 2210301 */ GIM_Reject,
     /* 2210302 */ // Label 30552: @2210302
     /* 2210302 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2210451),
     /* 2210307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2210310 */   GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2210338), // Rule ID 1422 //
     /* 2210315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2210318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2210322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2210326 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2210329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210337 */     // GIR_Coverage, 1422,
     /* 2210337 */     GIR_EraseRootFromParent_Done,
     /* 2210338 */   // Label 30573: @2210338
     /* 2210338 */   GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2210366), // Rule ID 1423 //
     /* 2210343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2210346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2210350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2210354 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2210354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2210357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210365 */     // GIR_Coverage, 1423,
     /* 2210365 */     GIR_EraseRootFromParent_Done,
     /* 2210366 */   // Label 30574: @2210366
     /* 2210366 */   GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2210394), // Rule ID 1429 //
     /* 2210371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2210374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2210378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210382 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2210385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210393 */     // GIR_Coverage, 1429,
     /* 2210393 */     GIR_EraseRootFromParent_Done,
     /* 2210394 */   // Label 30575: @2210394
     /* 2210394 */   GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2210422), // Rule ID 1434 //
     /* 2210399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2210402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2210406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2210410 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2210410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2210413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210421 */     // GIR_Coverage, 1434,
     /* 2210421 */     GIR_EraseRootFromParent_Done,
     /* 2210422 */   // Label 30576: @2210422
     /* 2210422 */   GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2210450), // Rule ID 1435 //
     /* 2210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2210430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2210434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2210438 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2210438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2210441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210449 */     // GIR_Coverage, 1435,
     /* 2210449 */     GIR_EraseRootFromParent_Done,
     /* 2210450 */   // Label 30577: @2210450
     /* 2210450 */   GIM_Reject,
     /* 2210451 */ // Label 30572: @2210451
     /* 2210451 */ GIM_Reject,
     /* 2210452 */ // Label 30553: @2210452
     /* 2210452 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2210561),
     /* 2210457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2210460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210468 */   GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2210514), // Rule ID 58164 //
     /* 2210473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2210476 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2210493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210513 */     // GIR_Coverage, 58164,
     /* 2210513 */     GIR_EraseRootFromParent_Done,
     /* 2210514 */   // Label 30579: @2210514
     /* 2210514 */   GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2210560), // Rule ID 58165 //
     /* 2210519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2210522 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2210539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210559 */     // GIR_Coverage, 58165,
     /* 2210559 */     GIR_EraseRootFromParent_Done,
     /* 2210560 */   // Label 30580: @2210560
     /* 2210560 */   GIM_Reject,
     /* 2210561 */ // Label 30578: @2210561
     /* 2210561 */ GIM_Reject,
     /* 2210562 */ // Label 30554: @2210562
     /* 2210562 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2210671),
     /* 2210567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2210570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210578 */   GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2210624), // Rule ID 58174 //
     /* 2210583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2210586 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2210603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210623 */     // GIR_Coverage, 58174,
     /* 2210623 */     GIR_EraseRootFromParent_Done,
     /* 2210624 */   // Label 30582: @2210624
     /* 2210624 */   GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2210670), // Rule ID 58175 //
     /* 2210629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2210632 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2210649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210669 */     // GIR_Coverage, 58175,
     /* 2210669 */     GIR_EraseRootFromParent_Done,
     /* 2210670 */   // Label 30583: @2210670
     /* 2210670 */   GIM_Reject,
     /* 2210671 */ // Label 30581: @2210671
     /* 2210671 */ GIM_Reject,
     /* 2210672 */ // Label 30555: @2210672
     /* 2210672 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2210781),
     /* 2210677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2210680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210688 */   GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2210734), // Rule ID 58166 //
     /* 2210693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2210696 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2210699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2210713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210733 */     // GIR_Coverage, 58166,
     /* 2210733 */     GIR_EraseRootFromParent_Done,
     /* 2210734 */   // Label 30585: @2210734
     /* 2210734 */   GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2210780), // Rule ID 58167 //
     /* 2210739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2210742 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2210745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2210759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210779 */     // GIR_Coverage, 58167,
     /* 2210779 */     GIR_EraseRootFromParent_Done,
     /* 2210780 */   // Label 30586: @2210780
     /* 2210780 */   GIM_Reject,
     /* 2210781 */ // Label 30584: @2210781
     /* 2210781 */ GIM_Reject,
     /* 2210782 */ // Label 30556: @2210782
     /* 2210782 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2210891),
     /* 2210787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2210790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210798 */   GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2210844), // Rule ID 58176 //
     /* 2210803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2210806 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2210809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2210823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210843 */     // GIR_Coverage, 58176,
     /* 2210843 */     GIR_EraseRootFromParent_Done,
     /* 2210844 */   // Label 30588: @2210844
     /* 2210844 */   GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2210890), // Rule ID 58177 //
     /* 2210849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2210852 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2210855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2210869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210889 */     // GIR_Coverage, 58177,
     /* 2210889 */     GIR_EraseRootFromParent_Done,
     /* 2210890 */   // Label 30589: @2210890
     /* 2210890 */   GIM_Reject,
     /* 2210891 */ // Label 30587: @2210891
     /* 2210891 */ GIM_Reject,
     /* 2210892 */ // Label 30557: @2210892
     /* 2210892 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2211001),
     /* 2210897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2210900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210908 */   GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2210954), // Rule ID 58168 //
     /* 2210913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2210916 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2210919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2210933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210953 */     // GIR_Coverage, 58168,
     /* 2210953 */     GIR_EraseRootFromParent_Done,
     /* 2210954 */   // Label 30591: @2210954
     /* 2210954 */   GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2211000), // Rule ID 58169 //
     /* 2210959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2210962 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2210965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2210979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2210989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210999 */     // GIR_Coverage, 58169,
     /* 2210999 */     GIR_EraseRootFromParent_Done,
     /* 2211000 */   // Label 30592: @2211000
     /* 2211000 */   GIM_Reject,
     /* 2211001 */ // Label 30590: @2211001
     /* 2211001 */ GIM_Reject,
     /* 2211002 */ // Label 30558: @2211002
     /* 2211002 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2211111),
     /* 2211007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2211010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211018 */   GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2211064), // Rule ID 58178 //
     /* 2211023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2211026 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2211029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2211043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211063 */     // GIR_Coverage, 58178,
     /* 2211063 */     GIR_EraseRootFromParent_Done,
     /* 2211064 */   // Label 30594: @2211064
     /* 2211064 */   GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2211110), // Rule ID 58179 //
     /* 2211069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2211072 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2211075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2211089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211109 */     // GIR_Coverage, 58179,
     /* 2211109 */     GIR_EraseRootFromParent_Done,
     /* 2211110 */   // Label 30595: @2211110
     /* 2211110 */   GIM_Reject,
     /* 2211111 */ // Label 30593: @2211111
     /* 2211111 */ GIM_Reject,
     /* 2211112 */ // Label 30559: @2211112
     /* 2211112 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2211221),
     /* 2211117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211128 */   GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2211174), // Rule ID 58170 //
     /* 2211133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2211136 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2211139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2211153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211173 */     // GIR_Coverage, 58170,
     /* 2211173 */     GIR_EraseRootFromParent_Done,
     /* 2211174 */   // Label 30597: @2211174
     /* 2211174 */   GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2211220), // Rule ID 58171 //
     /* 2211179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2211182 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2211185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2211199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211219 */     // GIR_Coverage, 58171,
     /* 2211219 */     GIR_EraseRootFromParent_Done,
     /* 2211220 */   // Label 30598: @2211220
     /* 2211220 */   GIM_Reject,
     /* 2211221 */ // Label 30596: @2211221
     /* 2211221 */ GIM_Reject,
     /* 2211222 */ // Label 30560: @2211222
     /* 2211222 */ GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2211331),
     /* 2211227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2211230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211238 */   GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2211284), // Rule ID 58180 //
     /* 2211243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2211246 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2211263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211283 */     // GIR_Coverage, 58180,
     /* 2211283 */     GIR_EraseRootFromParent_Done,
     /* 2211284 */   // Label 30600: @2211284
     /* 2211284 */   GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2211330), // Rule ID 58181 //
     /* 2211289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2211292 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2211309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211329 */     // GIR_Coverage, 58181,
     /* 2211329 */     GIR_EraseRootFromParent_Done,
     /* 2211330 */   // Label 30601: @2211330
     /* 2211330 */   GIM_Reject,
     /* 2211331 */ // Label 30599: @2211331
     /* 2211331 */ GIM_Reject,
     /* 2211332 */ // Label 30561: @2211332
     /* 2211332 */ GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2211441),
     /* 2211337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2211340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211348 */   GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2211394), // Rule ID 58172 //
     /* 2211353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2211356 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2211359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2211373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211393 */     // GIR_Coverage, 58172,
     /* 2211393 */     GIR_EraseRootFromParent_Done,
     /* 2211394 */   // Label 30603: @2211394
     /* 2211394 */   GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2211440), // Rule ID 58173 //
     /* 2211399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2211402 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2211405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2211419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2211429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211439 */     // GIR_Coverage, 58173,
     /* 2211439 */     GIR_EraseRootFromParent_Done,
     /* 2211440 */   // Label 30604: @2211440
     /* 2211440 */   GIM_Reject,
     /* 2211441 */ // Label 30602: @2211441
     /* 2211441 */ GIM_Reject,
     /* 2211442 */ // Label 30562: @2211442
     /* 2211442 */ GIM_Reject,
     /* 2211443 */ // Label 65: @2211443
     /* 2211443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 30628*/ GIMT_Encode4(2216328),
     /* 2211454 */ /*GILLT_s32*//*Label 30605*/ GIMT_Encode4(2211570),
     /* 2211458 */ /*GILLT_s64*//*Label 30606*/ GIMT_Encode4(2211943), GIMT_Encode4(0),
     /* 2211466 */ /*GILLT_nxv1s8*//*Label 30607*/ GIMT_Encode4(2212130),
     /* 2211470 */ /*GILLT_nxv1s16*//*Label 30608*/ GIMT_Encode4(2212234),
     /* 2211474 */ /*GILLT_nxv1s32*//*Label 30609*/ GIMT_Encode4(2212451),
     /* 2211478 */ /*GILLT_nxv1s64*//*Label 30610*/ GIMT_Encode4(2212776), GIMT_Encode4(0),
     /* 2211486 */ /*GILLT_nxv2s8*//*Label 30611*/ GIMT_Encode4(2212993),
     /* 2211490 */ /*GILLT_nxv2s16*//*Label 30612*/ GIMT_Encode4(2213097),
     /* 2211494 */ /*GILLT_nxv2s32*//*Label 30613*/ GIMT_Encode4(2213314),
     /* 2211498 */ /*GILLT_nxv2s64*//*Label 30614*/ GIMT_Encode4(2213639), GIMT_Encode4(0),
     /* 2211506 */ /*GILLT_nxv4s8*//*Label 30615*/ GIMT_Encode4(2213856),
     /* 2211510 */ /*GILLT_nxv4s16*//*Label 30616*/ GIMT_Encode4(2213960),
     /* 2211514 */ /*GILLT_nxv4s32*//*Label 30617*/ GIMT_Encode4(2214177),
     /* 2211518 */ /*GILLT_nxv4s64*//*Label 30618*/ GIMT_Encode4(2214502), GIMT_Encode4(0),
     /* 2211526 */ /*GILLT_nxv8s8*//*Label 30619*/ GIMT_Encode4(2214719),
     /* 2211530 */ /*GILLT_nxv8s16*//*Label 30620*/ GIMT_Encode4(2214823),
     /* 2211534 */ /*GILLT_nxv8s32*//*Label 30621*/ GIMT_Encode4(2215040),
     /* 2211538 */ /*GILLT_nxv8s64*//*Label 30622*/ GIMT_Encode4(2215365), GIMT_Encode4(0),
     /* 2211546 */ /*GILLT_nxv16s8*//*Label 30623*/ GIMT_Encode4(2215582),
     /* 2211550 */ /*GILLT_nxv16s16*//*Label 30624*/ GIMT_Encode4(2215686),
     /* 2211554 */ /*GILLT_nxv16s32*//*Label 30625*/ GIMT_Encode4(2215903), GIMT_Encode4(0),
     /* 2211562 */ /*GILLT_nxv32s8*//*Label 30626*/ GIMT_Encode4(2216120),
     /* 2211566 */ /*GILLT_nxv32s16*//*Label 30627*/ GIMT_Encode4(2216224),
     /* 2211570 */ // Label 30605: @2211570
     /* 2211570 */ GIM_Try, /*On fail goto*//*Label 30629*/ GIMT_Encode4(2211601), // Rule ID 1314 //
     /* 2211575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2211578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2211589 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2211589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2211592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211600 */   // GIR_Coverage, 1314,
     /* 2211600 */   GIR_EraseRootFromParent_Done,
     /* 2211601 */ // Label 30629: @2211601
     /* 2211601 */ GIM_Try, /*On fail goto*//*Label 30630*/ GIMT_Encode4(2211632), // Rule ID 1315 //
     /* 2211606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2211609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2211620 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2211620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2211623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211625 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211631 */   // GIR_Coverage, 1315,
     /* 2211631 */   GIR_EraseRootFromParent_Done,
     /* 2211632 */ // Label 30630: @2211632
     /* 2211632 */ GIM_Try, /*On fail goto*//*Label 30631*/ GIMT_Encode4(2211663), // Rule ID 1340 //
     /* 2211637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2211640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2211651 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2211651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2211654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211656 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211662 */   // GIR_Coverage, 1340,
     /* 2211662 */   GIR_EraseRootFromParent_Done,
     /* 2211663 */ // Label 30631: @2211663
     /* 2211663 */ GIM_Try, /*On fail goto*//*Label 30632*/ GIMT_Encode4(2211694), // Rule ID 1341 //
     /* 2211668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2211671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2211682 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2211682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2211685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211693 */   // GIR_Coverage, 1341,
     /* 2211693 */   GIR_EraseRootFromParent_Done,
     /* 2211694 */ // Label 30632: @2211694
     /* 2211694 */ GIM_Try, /*On fail goto*//*Label 30633*/ GIMT_Encode4(2211725), // Rule ID 1708 //
     /* 2211699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2211702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2211705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2211713 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2211713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2211716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211718 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211724 */   // GIR_Coverage, 1708,
     /* 2211724 */   GIR_EraseRootFromParent_Done,
     /* 2211725 */ // Label 30633: @2211725
     /* 2211725 */ GIM_Try, /*On fail goto*//*Label 30634*/ GIMT_Encode4(2211756), // Rule ID 1709 //
     /* 2211730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2211733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2211736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2211744 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2211744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2211747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211749 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211755 */   // GIR_Coverage, 1709,
     /* 2211755 */   GIR_EraseRootFromParent_Done,
     /* 2211756 */ // Label 30634: @2211756
     /* 2211756 */ GIM_Try, /*On fail goto*//*Label 30635*/ GIMT_Encode4(2211787), // Rule ID 1734 //
     /* 2211761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2211764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2211767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2211775 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2211775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2211778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211780 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211786 */   // GIR_Coverage, 1734,
     /* 2211786 */   GIR_EraseRootFromParent_Done,
     /* 2211787 */ // Label 30635: @2211787
     /* 2211787 */ GIM_Try, /*On fail goto*//*Label 30636*/ GIMT_Encode4(2211818), // Rule ID 1735 //
     /* 2211792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2211795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2211798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2211806 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2211806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2211809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211817 */   // GIR_Coverage, 1735,
     /* 2211817 */   GIR_EraseRootFromParent_Done,
     /* 2211818 */ // Label 30636: @2211818
     /* 2211818 */ GIM_Try, /*On fail goto*//*Label 30637*/ GIMT_Encode4(2211849), // Rule ID 2050 //
     /* 2211823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2211826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2211837 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2211837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2211840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211842 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211848 */   // GIR_Coverage, 2050,
     /* 2211848 */   GIR_EraseRootFromParent_Done,
     /* 2211849 */ // Label 30637: @2211849
     /* 2211849 */ GIM_Try, /*On fail goto*//*Label 30638*/ GIMT_Encode4(2211880), // Rule ID 2051 //
     /* 2211854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2211857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2211868 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2211868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2211871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211873 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211879 */   // GIR_Coverage, 2051,
     /* 2211879 */   GIR_EraseRootFromParent_Done,
     /* 2211880 */ // Label 30638: @2211880
     /* 2211880 */ GIM_Try, /*On fail goto*//*Label 30639*/ GIMT_Encode4(2211911), // Rule ID 2076 //
     /* 2211885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2211888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2211899 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2211899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2211902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211904 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211910 */   // GIR_Coverage, 2076,
     /* 2211910 */   GIR_EraseRootFromParent_Done,
     /* 2211911 */ // Label 30639: @2211911
     /* 2211911 */ GIM_Try, /*On fail goto*//*Label 30640*/ GIMT_Encode4(2211942), // Rule ID 2077 //
     /* 2211916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2211919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2211930 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2211930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2211933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211941 */   // GIR_Coverage, 2077,
     /* 2211941 */   GIR_EraseRootFromParent_Done,
     /* 2211942 */ // Label 30640: @2211942
     /* 2211942 */ GIM_Reject,
     /* 2211943 */ // Label 30606: @2211943
     /* 2211943 */ GIM_Try, /*On fail goto*//*Label 30641*/ GIMT_Encode4(2211974), // Rule ID 1371 //
     /* 2211948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2211951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2211962 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2211962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2211965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211967 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2211972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211973 */   // GIR_Coverage, 1371,
     /* 2211973 */   GIR_EraseRootFromParent_Done,
     /* 2211974 */ // Label 30641: @2211974
     /* 2211974 */ GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2212005), // Rule ID 1399 //
     /* 2211979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2211982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2211993 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2211993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2211996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2212003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212004 */   // GIR_Coverage, 1399,
     /* 2212004 */   GIR_EraseRootFromParent_Done,
     /* 2212005 */ // Label 30642: @2212005
     /* 2212005 */ GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2212036), // Rule ID 1771 //
     /* 2212010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2212013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2212016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2212020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2212024 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2212024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2212027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212029 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2212034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212035 */   // GIR_Coverage, 1771,
     /* 2212035 */   GIR_EraseRootFromParent_Done,
     /* 2212036 */ // Label 30643: @2212036
     /* 2212036 */ GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2212067), // Rule ID 1799 //
     /* 2212041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2212044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2212047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2212051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2212055 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2212055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2212058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212060 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2212065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212066 */   // GIR_Coverage, 1799,
     /* 2212066 */   GIR_EraseRootFromParent_Done,
     /* 2212067 */ // Label 30644: @2212067
     /* 2212067 */ GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2212098), // Rule ID 2105 //
     /* 2212072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2212075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2212078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2212082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2212086 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2212086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2212089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212091 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2212096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212097 */   // GIR_Coverage, 2105,
     /* 2212097 */   GIR_EraseRootFromParent_Done,
     /* 2212098 */ // Label 30645: @2212098
     /* 2212098 */ GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2212129), // Rule ID 2131 //
     /* 2212103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2212106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2212109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2212113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2212117 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2212117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2212120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212122 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2212127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212128 */   // GIR_Coverage, 2131,
     /* 2212128 */   GIR_EraseRootFromParent_Done,
     /* 2212129 */ // Label 30646: @2212129
     /* 2212129 */ GIM_Reject,
     /* 2212130 */ // Label 30607: @2212130
     /* 2212130 */ GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2212233),
     /* 2212135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212146 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2212189), // Rule ID 45502 //
     /* 2212151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2212154 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2212157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2212171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212188 */     // GIR_Coverage, 45502,
     /* 2212188 */     GIR_EraseRootFromParent_Done,
     /* 2212189 */   // Label 30648: @2212189
     /* 2212189 */   GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2212232), // Rule ID 45503 //
     /* 2212194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2212197 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2212200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2212214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212231 */     // GIR_Coverage, 45503,
     /* 2212231 */     GIR_EraseRootFromParent_Done,
     /* 2212232 */   // Label 30649: @2212232
     /* 2212232 */   GIM_Reject,
     /* 2212233 */ // Label 30647: @2212233
     /* 2212233 */ GIM_Reject,
     /* 2212234 */ // Label 30608: @2212234
     /* 2212234 */ GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2212288), // Rule ID 45486 //
     /* 2212239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2212242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212253 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2212256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2212270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212275 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212287 */   // GIR_Coverage, 45486,
     /* 2212287 */   GIR_EraseRootFromParent_Done,
     /* 2212288 */ // Label 30650: @2212288
     /* 2212288 */ GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2212342), // Rule ID 45487 //
     /* 2212293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2212296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212307 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2212310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2212324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212329 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212341 */   // GIR_Coverage, 45487,
     /* 2212341 */   GIR_EraseRootFromParent_Done,
     /* 2212342 */ // Label 30651: @2212342
     /* 2212342 */ GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2212396), // Rule ID 58002 //
     /* 2212347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2212350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212361 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2212364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2212378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212383 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212395 */   // GIR_Coverage, 58002,
     /* 2212395 */   GIR_EraseRootFromParent_Done,
     /* 2212396 */ // Label 30652: @2212396
     /* 2212396 */ GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2212450), // Rule ID 58003 //
     /* 2212401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2212404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212415 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2212418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2212432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212449 */   // GIR_Coverage, 58003,
     /* 2212449 */   GIR_EraseRootFromParent_Done,
     /* 2212450 */ // Label 30653: @2212450
     /* 2212450 */ GIM_Reject,
     /* 2212451 */ // Label 30609: @2212451
     /* 2212451 */ GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2212505), // Rule ID 45494 //
     /* 2212456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2212459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212470 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2212487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212504 */   // GIR_Coverage, 45494,
     /* 2212504 */   GIR_EraseRootFromParent_Done,
     /* 2212505 */ // Label 30654: @2212505
     /* 2212505 */ GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2212559), // Rule ID 45495 //
     /* 2212510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2212513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212524 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2212541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212546 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212558 */   // GIR_Coverage, 45495,
     /* 2212558 */   GIR_EraseRootFromParent_Done,
     /* 2212559 */ // Label 30655: @2212559
     /* 2212559 */ GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2212613), // Rule ID 57570 //
     /* 2212564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2212567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212578 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2212595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212600 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212612 */   // GIR_Coverage, 57570,
     /* 2212612 */   GIR_EraseRootFromParent_Done,
     /* 2212613 */ // Label 30656: @2212613
     /* 2212613 */ GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2212667), // Rule ID 57571 //
     /* 2212618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2212621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212632 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2212649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212654 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212666 */   // GIR_Coverage, 57571,
     /* 2212666 */   GIR_EraseRootFromParent_Done,
     /* 2212667 */ // Label 30657: @2212667
     /* 2212667 */ GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2212721), // Rule ID 58022 //
     /* 2212672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2212675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2212678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212686 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2212703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212708 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212720 */   // GIR_Coverage, 58022,
     /* 2212720 */   GIR_EraseRootFromParent_Done,
     /* 2212721 */ // Label 30658: @2212721
     /* 2212721 */ GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2212775), // Rule ID 58023 //
     /* 2212726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2212729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2212732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212740 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2212743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2212757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212762 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212774 */   // GIR_Coverage, 58023,
     /* 2212774 */   GIR_EraseRootFromParent_Done,
     /* 2212775 */ // Label 30659: @2212775
     /* 2212775 */ GIM_Reject,
     /* 2212776 */ // Label 30610: @2212776
     /* 2212776 */ GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2212830), // Rule ID 57582 //
     /* 2212781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2212784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2212787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212795 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2212812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212817 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212829 */   // GIR_Coverage, 57582,
     /* 2212829 */   GIR_EraseRootFromParent_Done,
     /* 2212830 */ // Label 30660: @2212830
     /* 2212830 */ GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2212884), // Rule ID 57583 //
     /* 2212835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2212838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2212841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212849 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2212866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212871 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212883 */   // GIR_Coverage, 57583,
     /* 2212883 */   GIR_EraseRootFromParent_Done,
     /* 2212884 */ // Label 30661: @2212884
     /* 2212884 */ GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2212938), // Rule ID 57814 //
     /* 2212889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2212892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212903 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2212920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212937 */   // GIR_Coverage, 57814,
     /* 2212937 */   GIR_EraseRootFromParent_Done,
     /* 2212938 */ // Label 30662: @2212938
     /* 2212938 */ GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2212992), // Rule ID 57815 //
     /* 2212943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2212946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212957 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2212974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212979 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212991 */   // GIR_Coverage, 57815,
     /* 2212991 */   GIR_EraseRootFromParent_Done,
     /* 2212992 */ // Label 30663: @2212992
     /* 2212992 */ GIM_Reject,
     /* 2212993 */ // Label 30611: @2212993
     /* 2212993 */ GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2213096),
     /* 2212998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2213001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213009 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2213052), // Rule ID 57982 //
     /* 2213014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2213017 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2213020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2213034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213051 */     // GIR_Coverage, 57982,
     /* 2213051 */     GIR_EraseRootFromParent_Done,
     /* 2213052 */   // Label 30665: @2213052
     /* 2213052 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2213095), // Rule ID 57983 //
     /* 2213057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2213060 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2213063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2213077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213094 */     // GIR_Coverage, 57983,
     /* 2213094 */     GIR_EraseRootFromParent_Done,
     /* 2213095 */   // Label 30666: @2213095
     /* 2213095 */   GIM_Reject,
     /* 2213096 */ // Label 30664: @2213096
     /* 2213096 */ GIM_Reject,
     /* 2213097 */ // Label 30612: @2213097
     /* 2213097 */ GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2213151), // Rule ID 57566 //
     /* 2213102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2213105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2213108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213116 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2213119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2213133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213138 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213149 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213150 */   // GIR_Coverage, 57566,
     /* 2213150 */   GIR_EraseRootFromParent_Done,
     /* 2213151 */ // Label 30667: @2213151
     /* 2213151 */ GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2213205), // Rule ID 57567 //
     /* 2213156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2213159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2213162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213170 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2213173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2213187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213192 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213204 */   // GIR_Coverage, 57567,
     /* 2213204 */   GIR_EraseRootFromParent_Done,
     /* 2213205 */ // Label 30668: @2213205
     /* 2213205 */ GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2213259), // Rule ID 58006 //
     /* 2213210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2213213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213224 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2213227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2213241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213246 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213258 */   // GIR_Coverage, 58006,
     /* 2213258 */   GIR_EraseRootFromParent_Done,
     /* 2213259 */ // Label 30669: @2213259
     /* 2213259 */ GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2213313), // Rule ID 58007 //
     /* 2213264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2213267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213278 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2213281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2213295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213312 */   // GIR_Coverage, 58007,
     /* 2213312 */   GIR_EraseRootFromParent_Done,
     /* 2213313 */ // Label 30670: @2213313
     /* 2213313 */ GIM_Reject,
     /* 2213314 */ // Label 30613: @2213314
     /* 2213314 */ GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2213368), // Rule ID 57578 //
     /* 2213319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2213322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213333 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2213350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213367 */   // GIR_Coverage, 57578,
     /* 2213367 */   GIR_EraseRootFromParent_Done,
     /* 2213368 */ // Label 30671: @2213368
     /* 2213368 */ GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2213422), // Rule ID 57579 //
     /* 2213373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2213376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213387 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2213404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213421 */   // GIR_Coverage, 57579,
     /* 2213421 */   GIR_EraseRootFromParent_Done,
     /* 2213422 */ // Label 30672: @2213422
     /* 2213422 */ GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2213476), // Rule ID 57798 //
     /* 2213427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2213430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2213433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213441 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2213458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213463 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213475 */   // GIR_Coverage, 57798,
     /* 2213475 */   GIR_EraseRootFromParent_Done,
     /* 2213476 */ // Label 30673: @2213476
     /* 2213476 */ GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2213530), // Rule ID 57799 //
     /* 2213481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2213484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2213487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213495 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2213512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213517 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213529 */   // GIR_Coverage, 57799,
     /* 2213529 */   GIR_EraseRootFromParent_Done,
     /* 2213530 */ // Label 30674: @2213530
     /* 2213530 */ GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2213584), // Rule ID 58026 //
     /* 2213535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2213538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2213541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213549 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2213566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213583 */   // GIR_Coverage, 58026,
     /* 2213583 */   GIR_EraseRootFromParent_Done,
     /* 2213584 */ // Label 30675: @2213584
     /* 2213584 */ GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2213638), // Rule ID 58027 //
     /* 2213589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2213592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2213595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213603 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2213606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2213620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213625 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213637 */   // GIR_Coverage, 58027,
     /* 2213637 */   GIR_EraseRootFromParent_Done,
     /* 2213638 */ // Label 30676: @2213638
     /* 2213638 */ GIM_Reject,
     /* 2213639 */ // Label 30614: @2213639
     /* 2213639 */ GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2213693), // Rule ID 57610 //
     /* 2213644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2213647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2213650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213658 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2213661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2213675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213680 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213692 */   // GIR_Coverage, 57610,
     /* 2213692 */   GIR_EraseRootFromParent_Done,
     /* 2213693 */ // Label 30677: @2213693
     /* 2213693 */ GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2213747), // Rule ID 57611 //
     /* 2213698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2213701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2213704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213712 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2213715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2213729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213734 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213746 */   // GIR_Coverage, 57611,
     /* 2213746 */   GIR_EraseRootFromParent_Done,
     /* 2213747 */ // Label 30678: @2213747
     /* 2213747 */ GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2213801), // Rule ID 57818 //
     /* 2213752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2213755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213766 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2213769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2213783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213800 */   // GIR_Coverage, 57818,
     /* 2213800 */   GIR_EraseRootFromParent_Done,
     /* 2213801 */ // Label 30679: @2213801
     /* 2213801 */ GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2213855), // Rule ID 57819 //
     /* 2213806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2213809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2213812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213820 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2213823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2213837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213842 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213854 */   // GIR_Coverage, 57819,
     /* 2213854 */   GIR_EraseRootFromParent_Done,
     /* 2213855 */ // Label 30680: @2213855
     /* 2213855 */ GIM_Reject,
     /* 2213856 */ // Label 30615: @2213856
     /* 2213856 */ GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2213959),
     /* 2213861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213872 */   GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2213915), // Rule ID 57986 //
     /* 2213877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2213880 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2213883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2213897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213914 */     // GIR_Coverage, 57986,
     /* 2213914 */     GIR_EraseRootFromParent_Done,
     /* 2213915 */   // Label 30682: @2213915
     /* 2213915 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2213958), // Rule ID 57987 //
     /* 2213920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2213923 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2213926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2213940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213957 */     // GIR_Coverage, 57987,
     /* 2213957 */     GIR_EraseRootFromParent_Done,
     /* 2213958 */   // Label 30683: @2213958
     /* 2213958 */   GIM_Reject,
     /* 2213959 */ // Label 30681: @2213959
     /* 2213959 */ GIM_Reject,
     /* 2213960 */ // Label 30616: @2213960
     /* 2213960 */ GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2214014), // Rule ID 57574 //
     /* 2213965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2213968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213979 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2213996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214001 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214013 */   // GIR_Coverage, 57574,
     /* 2214013 */   GIR_EraseRootFromParent_Done,
     /* 2214014 */ // Label 30684: @2214014
     /* 2214014 */ GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2214068), // Rule ID 57575 //
     /* 2214019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2214022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2214025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214033 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2214036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2214050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214055 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214067 */   // GIR_Coverage, 57575,
     /* 2214067 */   GIR_EraseRootFromParent_Done,
     /* 2214068 */ // Label 30685: @2214068
     /* 2214068 */ GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2214122), // Rule ID 58010 //
     /* 2214073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2214076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214087 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2214090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2214104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214109 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214121 */   // GIR_Coverage, 58010,
     /* 2214121 */   GIR_EraseRootFromParent_Done,
     /* 2214122 */ // Label 30686: @2214122
     /* 2214122 */ GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2214176), // Rule ID 58011 //
     /* 2214127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2214130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214141 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2214144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2214158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214163 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214175 */   // GIR_Coverage, 58011,
     /* 2214175 */   GIR_EraseRootFromParent_Done,
     /* 2214176 */ // Label 30687: @2214176
     /* 2214176 */ GIM_Reject,
     /* 2214177 */ // Label 30617: @2214177
     /* 2214177 */ GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2214231), // Rule ID 57598 //
     /* 2214182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2214185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214196 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2214213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214218 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214230 */   // GIR_Coverage, 57598,
     /* 2214230 */   GIR_EraseRootFromParent_Done,
     /* 2214231 */ // Label 30688: @2214231
     /* 2214231 */ GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2214285), // Rule ID 57599 //
     /* 2214236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2214239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214250 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2214267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214272 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214284 */   // GIR_Coverage, 57599,
     /* 2214284 */   GIR_EraseRootFromParent_Done,
     /* 2214285 */ // Label 30689: @2214285
     /* 2214285 */ GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2214339), // Rule ID 57802 //
     /* 2214290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2214293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2214296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214304 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2214321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214326 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214338 */   // GIR_Coverage, 57802,
     /* 2214338 */   GIR_EraseRootFromParent_Done,
     /* 2214339 */ // Label 30690: @2214339
     /* 2214339 */ GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2214393), // Rule ID 57803 //
     /* 2214344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2214347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2214350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214358 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2214375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214392 */   // GIR_Coverage, 57803,
     /* 2214392 */   GIR_EraseRootFromParent_Done,
     /* 2214393 */ // Label 30691: @2214393
     /* 2214393 */ GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2214447), // Rule ID 58030 //
     /* 2214398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2214401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2214404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214412 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2214429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214446 */   // GIR_Coverage, 58030,
     /* 2214446 */   GIR_EraseRootFromParent_Done,
     /* 2214447 */ // Label 30692: @2214447
     /* 2214447 */ GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2214501), // Rule ID 58031 //
     /* 2214452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2214455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2214458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214466 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2214469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2214483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214488 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214500 */   // GIR_Coverage, 58031,
     /* 2214500 */   GIR_EraseRootFromParent_Done,
     /* 2214501 */ // Label 30693: @2214501
     /* 2214501 */ GIM_Reject,
     /* 2214502 */ // Label 30618: @2214502
     /* 2214502 */ GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2214556), // Rule ID 57614 //
     /* 2214507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2214510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2214513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214521 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2214538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214543 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214555 */   // GIR_Coverage, 57614,
     /* 2214555 */   GIR_EraseRootFromParent_Done,
     /* 2214556 */ // Label 30694: @2214556
     /* 2214556 */ GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2214610), // Rule ID 57615 //
     /* 2214561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2214564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2214567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214575 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2214592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214597 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214609 */   // GIR_Coverage, 57615,
     /* 2214609 */   GIR_EraseRootFromParent_Done,
     /* 2214610 */ // Label 30695: @2214610
     /* 2214610 */ GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2214664), // Rule ID 57822 //
     /* 2214615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2214618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214629 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2214646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214651 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214663 */   // GIR_Coverage, 57822,
     /* 2214663 */   GIR_EraseRootFromParent_Done,
     /* 2214664 */ // Label 30696: @2214664
     /* 2214664 */ GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2214718), // Rule ID 57823 //
     /* 2214669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2214672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214683 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2214700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214705 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214717 */   // GIR_Coverage, 57823,
     /* 2214717 */   GIR_EraseRootFromParent_Done,
     /* 2214718 */ // Label 30697: @2214718
     /* 2214718 */ GIM_Reject,
     /* 2214719 */ // Label 30619: @2214719
     /* 2214719 */ GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2214822),
     /* 2214724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214735 */   GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2214778), // Rule ID 57990 //
     /* 2214740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2214743 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2214746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2214760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214777 */     // GIR_Coverage, 57990,
     /* 2214777 */     GIR_EraseRootFromParent_Done,
     /* 2214778 */   // Label 30699: @2214778
     /* 2214778 */   GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2214821), // Rule ID 57991 //
     /* 2214783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2214786 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2214789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2214803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214820 */     // GIR_Coverage, 57991,
     /* 2214820 */     GIR_EraseRootFromParent_Done,
     /* 2214821 */   // Label 30700: @2214821
     /* 2214821 */   GIM_Reject,
     /* 2214822 */ // Label 30698: @2214822
     /* 2214822 */ GIM_Reject,
     /* 2214823 */ // Label 30620: @2214823
     /* 2214823 */ GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2214877), // Rule ID 57586 //
     /* 2214828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2214831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214842 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2214859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214864 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214876 */   // GIR_Coverage, 57586,
     /* 2214876 */   GIR_EraseRootFromParent_Done,
     /* 2214877 */ // Label 30701: @2214877
     /* 2214877 */ GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2214931), // Rule ID 57587 //
     /* 2214882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2214885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214896 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2214913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214930 */   // GIR_Coverage, 57587,
     /* 2214930 */   GIR_EraseRootFromParent_Done,
     /* 2214931 */ // Label 30702: @2214931
     /* 2214931 */ GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2214985), // Rule ID 58014 //
     /* 2214936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2214939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2214942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214950 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2214967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214972 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214984 */   // GIR_Coverage, 58014,
     /* 2214984 */   GIR_EraseRootFromParent_Done,
     /* 2214985 */ // Label 30703: @2214985
     /* 2214985 */ GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2215039), // Rule ID 58015 //
     /* 2214990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2214993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2214996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215004 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2215007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2215021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215026 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215038 */   // GIR_Coverage, 58015,
     /* 2215038 */   GIR_EraseRootFromParent_Done,
     /* 2215039 */ // Label 30704: @2215039
     /* 2215039 */ GIM_Reject,
     /* 2215040 */ // Label 30621: @2215040
     /* 2215040 */ GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2215094), // Rule ID 57602 //
     /* 2215045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2215048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215059 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2215076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215081 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215093 */   // GIR_Coverage, 57602,
     /* 2215093 */   GIR_EraseRootFromParent_Done,
     /* 2215094 */ // Label 30705: @2215094
     /* 2215094 */ GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2215148), // Rule ID 57603 //
     /* 2215099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2215102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215113 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2215130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215135 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215147 */   // GIR_Coverage, 57603,
     /* 2215147 */   GIR_EraseRootFromParent_Done,
     /* 2215148 */ // Label 30706: @2215148
     /* 2215148 */ GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2215202), // Rule ID 57806 //
     /* 2215153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2215156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215167 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2215184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215201 */   // GIR_Coverage, 57806,
     /* 2215201 */   GIR_EraseRootFromParent_Done,
     /* 2215202 */ // Label 30707: @2215202
     /* 2215202 */ GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2215256), // Rule ID 57807 //
     /* 2215207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2215210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215221 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2215238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215255 */   // GIR_Coverage, 57807,
     /* 2215255 */   GIR_EraseRootFromParent_Done,
     /* 2215256 */ // Label 30708: @2215256
     /* 2215256 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2215310), // Rule ID 58034 //
     /* 2215261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2215264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215275 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2215292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215309 */   // GIR_Coverage, 58034,
     /* 2215309 */   GIR_EraseRootFromParent_Done,
     /* 2215310 */ // Label 30709: @2215310
     /* 2215310 */ GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2215364), // Rule ID 58035 //
     /* 2215315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2215318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215329 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2215346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215351 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215363 */   // GIR_Coverage, 58035,
     /* 2215363 */   GIR_EraseRootFromParent_Done,
     /* 2215364 */ // Label 30710: @2215364
     /* 2215364 */ GIM_Reject,
     /* 2215365 */ // Label 30622: @2215365
     /* 2215365 */ GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2215419), // Rule ID 57618 //
     /* 2215370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2215373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215384 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2215401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215418 */   // GIR_Coverage, 57618,
     /* 2215418 */   GIR_EraseRootFromParent_Done,
     /* 2215419 */ // Label 30711: @2215419
     /* 2215419 */ GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2215473), // Rule ID 57619 //
     /* 2215424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2215427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215438 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2215455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215460 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215472 */   // GIR_Coverage, 57619,
     /* 2215472 */   GIR_EraseRootFromParent_Done,
     /* 2215473 */ // Label 30712: @2215473
     /* 2215473 */ GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2215527), // Rule ID 57826 //
     /* 2215478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2215481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215492 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2215509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215514 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215526 */   // GIR_Coverage, 57826,
     /* 2215526 */   GIR_EraseRootFromParent_Done,
     /* 2215527 */ // Label 30713: @2215527
     /* 2215527 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2215581), // Rule ID 57827 //
     /* 2215532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2215535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215546 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2215563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215580 */   // GIR_Coverage, 57827,
     /* 2215580 */   GIR_EraseRootFromParent_Done,
     /* 2215581 */ // Label 30714: @2215581
     /* 2215581 */ GIM_Reject,
     /* 2215582 */ // Label 30623: @2215582
     /* 2215582 */ GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2215685),
     /* 2215587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2215590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215598 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2215641), // Rule ID 57994 //
     /* 2215603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2215606 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2215609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2215623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215640 */     // GIR_Coverage, 57994,
     /* 2215640 */     GIR_EraseRootFromParent_Done,
     /* 2215641 */   // Label 30716: @2215641
     /* 2215641 */   GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2215684), // Rule ID 57995 //
     /* 2215646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2215649 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2215652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2215666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215683 */     // GIR_Coverage, 57995,
     /* 2215683 */     GIR_EraseRootFromParent_Done,
     /* 2215684 */   // Label 30717: @2215684
     /* 2215684 */   GIM_Reject,
     /* 2215685 */ // Label 30715: @2215685
     /* 2215685 */ GIM_Reject,
     /* 2215686 */ // Label 30624: @2215686
     /* 2215686 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2215740), // Rule ID 57590 //
     /* 2215691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2215694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2215697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215705 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2215708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2215722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215739 */   // GIR_Coverage, 57590,
     /* 2215739 */   GIR_EraseRootFromParent_Done,
     /* 2215740 */ // Label 30718: @2215740
     /* 2215740 */ GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2215794), // Rule ID 57591 //
     /* 2215745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2215748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2215751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215759 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2215762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2215776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215793 */   // GIR_Coverage, 57591,
     /* 2215793 */   GIR_EraseRootFromParent_Done,
     /* 2215794 */ // Label 30719: @2215794
     /* 2215794 */ GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2215848), // Rule ID 58018 //
     /* 2215799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2215802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2215805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215813 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2215816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2215830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215847 */   // GIR_Coverage, 58018,
     /* 2215847 */   GIR_EraseRootFromParent_Done,
     /* 2215848 */ // Label 30720: @2215848
     /* 2215848 */ GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2215902), // Rule ID 58019 //
     /* 2215853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2215856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2215859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215867 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2215870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2215884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215901 */   // GIR_Coverage, 58019,
     /* 2215901 */   GIR_EraseRootFromParent_Done,
     /* 2215902 */ // Label 30721: @2215902
     /* 2215902 */ GIM_Reject,
     /* 2215903 */ // Label 30625: @2215903
     /* 2215903 */ GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2215957), // Rule ID 57606 //
     /* 2215908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2215911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2215914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215922 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2215925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2215939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215944 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215956 */   // GIR_Coverage, 57606,
     /* 2215956 */   GIR_EraseRootFromParent_Done,
     /* 2215957 */ // Label 30722: @2215957
     /* 2215957 */ GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2216011), // Rule ID 57607 //
     /* 2215962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2215965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2215968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215976 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2215979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2215993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216010 */   // GIR_Coverage, 57607,
     /* 2216010 */   GIR_EraseRootFromParent_Done,
     /* 2216011 */ // Label 30723: @2216011
     /* 2216011 */ GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2216065), // Rule ID 57810 //
     /* 2216016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2216019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216030 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2216047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216052 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216064 */   // GIR_Coverage, 57810,
     /* 2216064 */   GIR_EraseRootFromParent_Done,
     /* 2216065 */ // Label 30724: @2216065
     /* 2216065 */ GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2216119), // Rule ID 57811 //
     /* 2216070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2216073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216084 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2216101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216106 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216118 */   // GIR_Coverage, 57811,
     /* 2216118 */   GIR_EraseRootFromParent_Done,
     /* 2216119 */ // Label 30725: @2216119
     /* 2216119 */ GIM_Reject,
     /* 2216120 */ // Label 30626: @2216120
     /* 2216120 */ GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2216223),
     /* 2216125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2216128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216136 */   GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2216179), // Rule ID 57998 //
     /* 2216141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2216144 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2216147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2216161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216178 */     // GIR_Coverage, 57998,
     /* 2216178 */     GIR_EraseRootFromParent_Done,
     /* 2216179 */   // Label 30727: @2216179
     /* 2216179 */   GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2216222), // Rule ID 57999 //
     /* 2216184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2216187 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2216190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2216204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216221 */     // GIR_Coverage, 57999,
     /* 2216221 */     GIR_EraseRootFromParent_Done,
     /* 2216222 */   // Label 30728: @2216222
     /* 2216222 */   GIM_Reject,
     /* 2216223 */ // Label 30726: @2216223
     /* 2216223 */ GIM_Reject,
     /* 2216224 */ // Label 30627: @2216224
     /* 2216224 */ GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2216327),
     /* 2216229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2216232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216240 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2216283), // Rule ID 57594 //
     /* 2216245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2216248 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2216251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2216265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216282 */     // GIR_Coverage, 57594,
     /* 2216282 */     GIR_EraseRootFromParent_Done,
     /* 2216283 */   // Label 30730: @2216283
     /* 2216283 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2216326), // Rule ID 57595 //
     /* 2216288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2216291 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2216294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2216308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216325 */     // GIR_Coverage, 57595,
     /* 2216325 */     GIR_EraseRootFromParent_Done,
     /* 2216326 */   // Label 30731: @2216326
     /* 2216326 */   GIM_Reject,
     /* 2216327 */ // Label 30729: @2216327
     /* 2216327 */ GIM_Reject,
     /* 2216328 */ // Label 30628: @2216328
     /* 2216328 */ GIM_Reject,
     /* 2216329 */ // Label 66: @2216329
     /* 2216329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 30755*/ GIMT_Encode4(2221214),
     /* 2216340 */ /*GILLT_s32*//*Label 30732*/ GIMT_Encode4(2216456),
     /* 2216344 */ /*GILLT_s64*//*Label 30733*/ GIMT_Encode4(2216829), GIMT_Encode4(0),
     /* 2216352 */ /*GILLT_nxv1s8*//*Label 30734*/ GIMT_Encode4(2217016),
     /* 2216356 */ /*GILLT_nxv1s16*//*Label 30735*/ GIMT_Encode4(2217120),
     /* 2216360 */ /*GILLT_nxv1s32*//*Label 30736*/ GIMT_Encode4(2217337),
     /* 2216364 */ /*GILLT_nxv1s64*//*Label 30737*/ GIMT_Encode4(2217662), GIMT_Encode4(0),
     /* 2216372 */ /*GILLT_nxv2s8*//*Label 30738*/ GIMT_Encode4(2217879),
     /* 2216376 */ /*GILLT_nxv2s16*//*Label 30739*/ GIMT_Encode4(2217983),
     /* 2216380 */ /*GILLT_nxv2s32*//*Label 30740*/ GIMT_Encode4(2218200),
     /* 2216384 */ /*GILLT_nxv2s64*//*Label 30741*/ GIMT_Encode4(2218525), GIMT_Encode4(0),
     /* 2216392 */ /*GILLT_nxv4s8*//*Label 30742*/ GIMT_Encode4(2218742),
     /* 2216396 */ /*GILLT_nxv4s16*//*Label 30743*/ GIMT_Encode4(2218846),
     /* 2216400 */ /*GILLT_nxv4s32*//*Label 30744*/ GIMT_Encode4(2219063),
     /* 2216404 */ /*GILLT_nxv4s64*//*Label 30745*/ GIMT_Encode4(2219388), GIMT_Encode4(0),
     /* 2216412 */ /*GILLT_nxv8s8*//*Label 30746*/ GIMT_Encode4(2219605),
     /* 2216416 */ /*GILLT_nxv8s16*//*Label 30747*/ GIMT_Encode4(2219709),
     /* 2216420 */ /*GILLT_nxv8s32*//*Label 30748*/ GIMT_Encode4(2219926),
     /* 2216424 */ /*GILLT_nxv8s64*//*Label 30749*/ GIMT_Encode4(2220251), GIMT_Encode4(0),
     /* 2216432 */ /*GILLT_nxv16s8*//*Label 30750*/ GIMT_Encode4(2220468),
     /* 2216436 */ /*GILLT_nxv16s16*//*Label 30751*/ GIMT_Encode4(2220572),
     /* 2216440 */ /*GILLT_nxv16s32*//*Label 30752*/ GIMT_Encode4(2220789), GIMT_Encode4(0),
     /* 2216448 */ /*GILLT_nxv32s8*//*Label 30753*/ GIMT_Encode4(2221006),
     /* 2216452 */ /*GILLT_nxv32s16*//*Label 30754*/ GIMT_Encode4(2221110),
     /* 2216456 */ // Label 30732: @2216456
     /* 2216456 */ GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2216487), // Rule ID 1318 //
     /* 2216461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2216464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2216475 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2216475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2216478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216480 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216486 */   // GIR_Coverage, 1318,
     /* 2216486 */   GIR_EraseRootFromParent_Done,
     /* 2216487 */ // Label 30756: @2216487
     /* 2216487 */ GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2216518), // Rule ID 1319 //
     /* 2216492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2216495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2216506 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2216506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2216509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216517 */   // GIR_Coverage, 1319,
     /* 2216517 */   GIR_EraseRootFromParent_Done,
     /* 2216518 */ // Label 30757: @2216518
     /* 2216518 */ GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2216549), // Rule ID 1344 //
     /* 2216523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2216526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2216537 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2216537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2216540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216542 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216548 */   // GIR_Coverage, 1344,
     /* 2216548 */   GIR_EraseRootFromParent_Done,
     /* 2216549 */ // Label 30758: @2216549
     /* 2216549 */ GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2216580), // Rule ID 1345 //
     /* 2216554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2216557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2216568 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2216568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2216571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216579 */   // GIR_Coverage, 1345,
     /* 2216579 */   GIR_EraseRootFromParent_Done,
     /* 2216580 */ // Label 30759: @2216580
     /* 2216580 */ GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2216611), // Rule ID 1712 //
     /* 2216585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2216588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2216599 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2216599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2216602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216610 */   // GIR_Coverage, 1712,
     /* 2216610 */   GIR_EraseRootFromParent_Done,
     /* 2216611 */ // Label 30760: @2216611
     /* 2216611 */ GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2216642), // Rule ID 1713 //
     /* 2216616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2216619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2216630 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2216630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2216633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216635 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216641 */   // GIR_Coverage, 1713,
     /* 2216641 */   GIR_EraseRootFromParent_Done,
     /* 2216642 */ // Label 30761: @2216642
     /* 2216642 */ GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2216673), // Rule ID 1738 //
     /* 2216647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2216650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2216661 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2216661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2216664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216666 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216672 */   // GIR_Coverage, 1738,
     /* 2216672 */   GIR_EraseRootFromParent_Done,
     /* 2216673 */ // Label 30762: @2216673
     /* 2216673 */ GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2216704), // Rule ID 1739 //
     /* 2216678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2216681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2216692 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2216692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2216695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216697 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216703 */   // GIR_Coverage, 1739,
     /* 2216703 */   GIR_EraseRootFromParent_Done,
     /* 2216704 */ // Label 30763: @2216704
     /* 2216704 */ GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2216735), // Rule ID 2054 //
     /* 2216709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2216712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2216723 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2216723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2216726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216734 */   // GIR_Coverage, 2054,
     /* 2216734 */   GIR_EraseRootFromParent_Done,
     /* 2216735 */ // Label 30764: @2216735
     /* 2216735 */ GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2216766), // Rule ID 2055 //
     /* 2216740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2216743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2216754 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2216754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2216757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216759 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216765 */   // GIR_Coverage, 2055,
     /* 2216765 */   GIR_EraseRootFromParent_Done,
     /* 2216766 */ // Label 30765: @2216766
     /* 2216766 */ GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2216797), // Rule ID 2080 //
     /* 2216771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2216774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2216785 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2216785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2216788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216796 */   // GIR_Coverage, 2080,
     /* 2216796 */   GIR_EraseRootFromParent_Done,
     /* 2216797 */ // Label 30766: @2216797
     /* 2216797 */ GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2216828), // Rule ID 2081 //
     /* 2216802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2216805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2216816 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2216816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2216819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216827 */   // GIR_Coverage, 2081,
     /* 2216827 */   GIR_EraseRootFromParent_Done,
     /* 2216828 */ // Label 30767: @2216828
     /* 2216828 */ GIM_Reject,
     /* 2216829 */ // Label 30733: @2216829
     /* 2216829 */ GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2216860), // Rule ID 1373 //
     /* 2216834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2216837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2216848 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2216848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2216851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216859 */   // GIR_Coverage, 1373,
     /* 2216859 */   GIR_EraseRootFromParent_Done,
     /* 2216860 */ // Label 30768: @2216860
     /* 2216860 */ GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2216891), // Rule ID 1401 //
     /* 2216865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2216868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2216879 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2216879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2216882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216890 */   // GIR_Coverage, 1401,
     /* 2216890 */   GIR_EraseRootFromParent_Done,
     /* 2216891 */ // Label 30769: @2216891
     /* 2216891 */ GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2216922), // Rule ID 1773 //
     /* 2216896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2216899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2216910 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2216910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2216913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216921 */   // GIR_Coverage, 1773,
     /* 2216921 */   GIR_EraseRootFromParent_Done,
     /* 2216922 */ // Label 30770: @2216922
     /* 2216922 */ GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2216953), // Rule ID 1801 //
     /* 2216927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2216930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216941 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2216941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2216944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216946 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216952 */   // GIR_Coverage, 1801,
     /* 2216952 */   GIR_EraseRootFromParent_Done,
     /* 2216953 */ // Label 30771: @2216953
     /* 2216953 */ GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2216984), // Rule ID 2107 //
     /* 2216958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2216961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2216972 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2216972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2216975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216977 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2216982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216983 */   // GIR_Coverage, 2107,
     /* 2216983 */   GIR_EraseRootFromParent_Done,
     /* 2216984 */ // Label 30772: @2216984
     /* 2216984 */ GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2217015), // Rule ID 2133 //
     /* 2216989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2216992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2217003 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2217003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2217006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217008 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2217013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217014 */   // GIR_Coverage, 2133,
     /* 2217014 */   GIR_EraseRootFromParent_Done,
     /* 2217015 */ // Label 30773: @2217015
     /* 2217015 */ GIM_Reject,
     /* 2217016 */ // Label 30734: @2217016
     /* 2217016 */ GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2217119),
     /* 2217021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217032 */   GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2217075), // Rule ID 58038 //
     /* 2217037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2217040 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2217043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2217057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217074 */     // GIR_Coverage, 58038,
     /* 2217074 */     GIR_EraseRootFromParent_Done,
     /* 2217075 */   // Label 30775: @2217075
     /* 2217075 */   GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2217118), // Rule ID 58039 //
     /* 2217080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2217083 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2217086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2217100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217117 */     // GIR_Coverage, 58039,
     /* 2217117 */     GIR_EraseRootFromParent_Done,
     /* 2217118 */   // Label 30776: @2217118
     /* 2217118 */   GIM_Reject,
     /* 2217119 */ // Label 30774: @2217119
     /* 2217119 */ GIM_Reject,
     /* 2217120 */ // Label 30735: @2217120
     /* 2217120 */ GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2217174), // Rule ID 57622 //
     /* 2217125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2217128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217139 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2217156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217173 */   // GIR_Coverage, 57622,
     /* 2217173 */   GIR_EraseRootFromParent_Done,
     /* 2217174 */ // Label 30777: @2217174
     /* 2217174 */ GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2217228), // Rule ID 57623 //
     /* 2217179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2217182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217193 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2217210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217227 */   // GIR_Coverage, 57623,
     /* 2217227 */   GIR_EraseRootFromParent_Done,
     /* 2217228 */ // Label 30778: @2217228
     /* 2217228 */ GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2217282), // Rule ID 58062 //
     /* 2217233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2217236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217247 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2217264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217269 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217281 */   // GIR_Coverage, 58062,
     /* 2217281 */   GIR_EraseRootFromParent_Done,
     /* 2217282 */ // Label 30779: @2217282
     /* 2217282 */ GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2217336), // Rule ID 58063 //
     /* 2217287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2217290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217301 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2217318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217335 */   // GIR_Coverage, 58063,
     /* 2217335 */   GIR_EraseRootFromParent_Done,
     /* 2217336 */ // Label 30780: @2217336
     /* 2217336 */ GIM_Reject,
     /* 2217337 */ // Label 30736: @2217337
     /* 2217337 */ GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2217391), // Rule ID 57630 //
     /* 2217342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2217345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217356 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2217373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217378 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217390 */   // GIR_Coverage, 57630,
     /* 2217390 */   GIR_EraseRootFromParent_Done,
     /* 2217391 */ // Label 30781: @2217391
     /* 2217391 */ GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2217445), // Rule ID 57631 //
     /* 2217396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2217399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217410 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2217427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217444 */   // GIR_Coverage, 57631,
     /* 2217444 */   GIR_EraseRootFromParent_Done,
     /* 2217445 */ // Label 30782: @2217445
     /* 2217445 */ GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2217499), // Rule ID 57830 //
     /* 2217450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2217453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217464 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2217481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217486 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217498 */   // GIR_Coverage, 57830,
     /* 2217498 */   GIR_EraseRootFromParent_Done,
     /* 2217499 */ // Label 30783: @2217499
     /* 2217499 */ GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2217553), // Rule ID 57831 //
     /* 2217504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2217507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217518 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2217535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217540 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217552 */   // GIR_Coverage, 57831,
     /* 2217552 */   GIR_EraseRootFromParent_Done,
     /* 2217553 */ // Label 30784: @2217553
     /* 2217553 */ GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2217607), // Rule ID 58082 //
     /* 2217558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2217561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2217564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217572 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2217589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217606 */   // GIR_Coverage, 58082,
     /* 2217606 */   GIR_EraseRootFromParent_Done,
     /* 2217607 */ // Label 30785: @2217607
     /* 2217607 */ GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2217661), // Rule ID 58083 //
     /* 2217612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2217615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2217618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217626 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2217643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217648 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217660 */   // GIR_Coverage, 58083,
     /* 2217660 */   GIR_EraseRootFromParent_Done,
     /* 2217661 */ // Label 30786: @2217661
     /* 2217661 */ GIM_Reject,
     /* 2217662 */ // Label 30737: @2217662
     /* 2217662 */ GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2217716), // Rule ID 57642 //
     /* 2217667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2217670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2217673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217681 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2217698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217715 */   // GIR_Coverage, 57642,
     /* 2217715 */   GIR_EraseRootFromParent_Done,
     /* 2217716 */ // Label 30787: @2217716
     /* 2217716 */ GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2217770), // Rule ID 57643 //
     /* 2217721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2217724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2217727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217735 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2217752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217769 */   // GIR_Coverage, 57643,
     /* 2217769 */   GIR_EraseRootFromParent_Done,
     /* 2217770 */ // Label 30788: @2217770
     /* 2217770 */ GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2217824), // Rule ID 57850 //
     /* 2217775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2217778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217789 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2217806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217823 */   // GIR_Coverage, 57850,
     /* 2217823 */   GIR_EraseRootFromParent_Done,
     /* 2217824 */ // Label 30789: @2217824
     /* 2217824 */ GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2217878), // Rule ID 57851 //
     /* 2217829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2217832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217843 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2217860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217877 */   // GIR_Coverage, 57851,
     /* 2217877 */   GIR_EraseRootFromParent_Done,
     /* 2217878 */ // Label 30790: @2217878
     /* 2217878 */ GIM_Reject,
     /* 2217879 */ // Label 30738: @2217879
     /* 2217879 */ GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2217982),
     /* 2217884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217895 */   GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2217938), // Rule ID 58042 //
     /* 2217900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2217903 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2217906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2217920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217937 */     // GIR_Coverage, 58042,
     /* 2217937 */     GIR_EraseRootFromParent_Done,
     /* 2217938 */   // Label 30792: @2217938
     /* 2217938 */   GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2217981), // Rule ID 58043 //
     /* 2217943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2217946 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2217949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2217963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217980 */     // GIR_Coverage, 58043,
     /* 2217980 */     GIR_EraseRootFromParent_Done,
     /* 2217981 */   // Label 30793: @2217981
     /* 2217981 */   GIM_Reject,
     /* 2217982 */ // Label 30791: @2217982
     /* 2217982 */ GIM_Reject,
     /* 2217983 */ // Label 30739: @2217983
     /* 2217983 */ GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2218037), // Rule ID 57626 //
     /* 2217988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2217991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218002 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2218019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218024 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218036 */   // GIR_Coverage, 57626,
     /* 2218036 */   GIR_EraseRootFromParent_Done,
     /* 2218037 */ // Label 30794: @2218037
     /* 2218037 */ GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2218091), // Rule ID 57627 //
     /* 2218042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2218045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2218048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218056 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2218073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218090 */   // GIR_Coverage, 57627,
     /* 2218090 */   GIR_EraseRootFromParent_Done,
     /* 2218091 */ // Label 30795: @2218091
     /* 2218091 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2218145), // Rule ID 58066 //
     /* 2218096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2218099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218110 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2218127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218132 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218144 */   // GIR_Coverage, 58066,
     /* 2218144 */   GIR_EraseRootFromParent_Done,
     /* 2218145 */ // Label 30796: @2218145
     /* 2218145 */ GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2218199), // Rule ID 58067 //
     /* 2218150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2218153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218164 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2218181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218198 */   // GIR_Coverage, 58067,
     /* 2218198 */   GIR_EraseRootFromParent_Done,
     /* 2218199 */ // Label 30797: @2218199
     /* 2218199 */ GIM_Reject,
     /* 2218200 */ // Label 30740: @2218200
     /* 2218200 */ GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2218254), // Rule ID 57638 //
     /* 2218205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2218208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218219 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2218236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218253 */   // GIR_Coverage, 57638,
     /* 2218253 */   GIR_EraseRootFromParent_Done,
     /* 2218254 */ // Label 30798: @2218254
     /* 2218254 */ GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2218308), // Rule ID 57639 //
     /* 2218259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2218262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218273 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2218290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218307 */   // GIR_Coverage, 57639,
     /* 2218307 */   GIR_EraseRootFromParent_Done,
     /* 2218308 */ // Label 30799: @2218308
     /* 2218308 */ GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2218362), // Rule ID 57834 //
     /* 2218313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2218316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2218319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218327 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2218344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218361 */   // GIR_Coverage, 57834,
     /* 2218361 */   GIR_EraseRootFromParent_Done,
     /* 2218362 */ // Label 30800: @2218362
     /* 2218362 */ GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2218416), // Rule ID 57835 //
     /* 2218367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2218370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2218373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218381 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2218398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218415 */   // GIR_Coverage, 57835,
     /* 2218415 */   GIR_EraseRootFromParent_Done,
     /* 2218416 */ // Label 30801: @2218416
     /* 2218416 */ GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2218470), // Rule ID 58086 //
     /* 2218421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2218424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2218427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218435 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2218452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218469 */   // GIR_Coverage, 58086,
     /* 2218469 */   GIR_EraseRootFromParent_Done,
     /* 2218470 */ // Label 30802: @2218470
     /* 2218470 */ GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2218524), // Rule ID 58087 //
     /* 2218475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2218478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2218481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218489 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2218492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2218506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218523 */   // GIR_Coverage, 58087,
     /* 2218523 */   GIR_EraseRootFromParent_Done,
     /* 2218524 */ // Label 30803: @2218524
     /* 2218524 */ GIM_Reject,
     /* 2218525 */ // Label 30741: @2218525
     /* 2218525 */ GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2218579), // Rule ID 57670 //
     /* 2218530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2218533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2218536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218544 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2218547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2218561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218578 */   // GIR_Coverage, 57670,
     /* 2218578 */   GIR_EraseRootFromParent_Done,
     /* 2218579 */ // Label 30804: @2218579
     /* 2218579 */ GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2218633), // Rule ID 57671 //
     /* 2218584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2218587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2218590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218598 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2218601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2218615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218632 */   // GIR_Coverage, 57671,
     /* 2218632 */   GIR_EraseRootFromParent_Done,
     /* 2218633 */ // Label 30805: @2218633
     /* 2218633 */ GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2218687), // Rule ID 57854 //
     /* 2218638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2218641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218652 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2218655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2218669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218686 */   // GIR_Coverage, 57854,
     /* 2218686 */   GIR_EraseRootFromParent_Done,
     /* 2218687 */ // Label 30806: @2218687
     /* 2218687 */ GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2218741), // Rule ID 57855 //
     /* 2218692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2218695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2218698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218706 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2218709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2218723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218740 */   // GIR_Coverage, 57855,
     /* 2218740 */   GIR_EraseRootFromParent_Done,
     /* 2218741 */ // Label 30807: @2218741
     /* 2218741 */ GIM_Reject,
     /* 2218742 */ // Label 30742: @2218742
     /* 2218742 */ GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2218845),
     /* 2218747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218758 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2218801), // Rule ID 58046 //
     /* 2218763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2218766 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2218769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2218783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218800 */     // GIR_Coverage, 58046,
     /* 2218800 */     GIR_EraseRootFromParent_Done,
     /* 2218801 */   // Label 30809: @2218801
     /* 2218801 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2218844), // Rule ID 58047 //
     /* 2218806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2218809 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2218812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2218826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218843 */     // GIR_Coverage, 58047,
     /* 2218843 */     GIR_EraseRootFromParent_Done,
     /* 2218844 */   // Label 30810: @2218844
     /* 2218844 */   GIM_Reject,
     /* 2218845 */ // Label 30808: @2218845
     /* 2218845 */ GIM_Reject,
     /* 2218846 */ // Label 30743: @2218846
     /* 2218846 */ GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2218900), // Rule ID 57634 //
     /* 2218851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2218854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218865 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2218868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2218882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218899 */   // GIR_Coverage, 57634,
     /* 2218899 */   GIR_EraseRootFromParent_Done,
     /* 2218900 */ // Label 30811: @2218900
     /* 2218900 */ GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2218954), // Rule ID 57635 //
     /* 2218905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2218908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218919 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2218922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2218936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218953 */   // GIR_Coverage, 57635,
     /* 2218953 */   GIR_EraseRootFromParent_Done,
     /* 2218954 */ // Label 30812: @2218954
     /* 2218954 */ GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2219008), // Rule ID 58070 //
     /* 2218959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2218962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2218965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218973 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2218976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2218990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218995 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219007 */   // GIR_Coverage, 58070,
     /* 2219007 */   GIR_EraseRootFromParent_Done,
     /* 2219008 */ // Label 30813: @2219008
     /* 2219008 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2219062), // Rule ID 58071 //
     /* 2219013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2219016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219027 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2219030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2219044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219061 */   // GIR_Coverage, 58071,
     /* 2219061 */   GIR_EraseRootFromParent_Done,
     /* 2219062 */ // Label 30814: @2219062
     /* 2219062 */ GIM_Reject,
     /* 2219063 */ // Label 30744: @2219063
     /* 2219063 */ GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2219117), // Rule ID 57658 //
     /* 2219068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2219071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219082 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2219099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219116 */   // GIR_Coverage, 57658,
     /* 2219116 */   GIR_EraseRootFromParent_Done,
     /* 2219117 */ // Label 30815: @2219117
     /* 2219117 */ GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2219171), // Rule ID 57659 //
     /* 2219122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2219125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219136 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2219153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219170 */   // GIR_Coverage, 57659,
     /* 2219170 */   GIR_EraseRootFromParent_Done,
     /* 2219171 */ // Label 30816: @2219171
     /* 2219171 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2219225), // Rule ID 57838 //
     /* 2219176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2219179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2219182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219190 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2219207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219212 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219224 */   // GIR_Coverage, 57838,
     /* 2219224 */   GIR_EraseRootFromParent_Done,
     /* 2219225 */ // Label 30817: @2219225
     /* 2219225 */ GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2219279), // Rule ID 57839 //
     /* 2219230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2219233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2219236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219244 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2219261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219278 */   // GIR_Coverage, 57839,
     /* 2219278 */   GIR_EraseRootFromParent_Done,
     /* 2219279 */ // Label 30818: @2219279
     /* 2219279 */ GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2219333), // Rule ID 58090 //
     /* 2219284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2219287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2219290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219298 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2219315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219332 */   // GIR_Coverage, 58090,
     /* 2219332 */   GIR_EraseRootFromParent_Done,
     /* 2219333 */ // Label 30819: @2219333
     /* 2219333 */ GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2219387), // Rule ID 58091 //
     /* 2219338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2219341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2219344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219352 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2219369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219386 */   // GIR_Coverage, 58091,
     /* 2219386 */   GIR_EraseRootFromParent_Done,
     /* 2219387 */ // Label 30820: @2219387
     /* 2219387 */ GIM_Reject,
     /* 2219388 */ // Label 30745: @2219388
     /* 2219388 */ GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2219442), // Rule ID 57674 //
     /* 2219393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2219396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2219399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219407 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2219424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219429 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219441 */   // GIR_Coverage, 57674,
     /* 2219441 */   GIR_EraseRootFromParent_Done,
     /* 2219442 */ // Label 30821: @2219442
     /* 2219442 */ GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2219496), // Rule ID 57675 //
     /* 2219447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2219450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2219453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219461 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2219478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219483 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219495 */   // GIR_Coverage, 57675,
     /* 2219495 */   GIR_EraseRootFromParent_Done,
     /* 2219496 */ // Label 30822: @2219496
     /* 2219496 */ GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2219550), // Rule ID 57858 //
     /* 2219501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2219504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219515 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2219532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219537 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219549 */   // GIR_Coverage, 57858,
     /* 2219549 */   GIR_EraseRootFromParent_Done,
     /* 2219550 */ // Label 30823: @2219550
     /* 2219550 */ GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2219604), // Rule ID 57859 //
     /* 2219555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2219558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219569 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219569 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219576 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2219586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219591 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219603 */   // GIR_Coverage, 57859,
     /* 2219603 */   GIR_EraseRootFromParent_Done,
     /* 2219604 */ // Label 30824: @2219604
     /* 2219604 */ GIM_Reject,
     /* 2219605 */ // Label 30746: @2219605
     /* 2219605 */ GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2219708),
     /* 2219610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2219613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219621 */   GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2219664), // Rule ID 58050 //
     /* 2219626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2219629 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2219632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2219646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219663 */     // GIR_Coverage, 58050,
     /* 2219663 */     GIR_EraseRootFromParent_Done,
     /* 2219664 */   // Label 30826: @2219664
     /* 2219664 */   GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2219707), // Rule ID 58051 //
     /* 2219669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2219672 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2219675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2219689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219706 */     // GIR_Coverage, 58051,
     /* 2219706 */     GIR_EraseRootFromParent_Done,
     /* 2219707 */   // Label 30827: @2219707
     /* 2219707 */   GIM_Reject,
     /* 2219708 */ // Label 30825: @2219708
     /* 2219708 */ GIM_Reject,
     /* 2219709 */ // Label 30747: @2219709
     /* 2219709 */ GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2219763), // Rule ID 57646 //
     /* 2219714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2219717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2219720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219728 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2219745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219762 */   // GIR_Coverage, 57646,
     /* 2219762 */   GIR_EraseRootFromParent_Done,
     /* 2219763 */ // Label 30828: @2219763
     /* 2219763 */ GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2219817), // Rule ID 57647 //
     /* 2219768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2219771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2219774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219782 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2219799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219816 */   // GIR_Coverage, 57647,
     /* 2219816 */   GIR_EraseRootFromParent_Done,
     /* 2219817 */ // Label 30829: @2219817
     /* 2219817 */ GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2219871), // Rule ID 58074 //
     /* 2219822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2219825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2219828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219836 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2219853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219870 */   // GIR_Coverage, 58074,
     /* 2219870 */   GIR_EraseRootFromParent_Done,
     /* 2219871 */ // Label 30830: @2219871
     /* 2219871 */ GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2219925), // Rule ID 58075 //
     /* 2219876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2219879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2219882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219890 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2219907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219924 */   // GIR_Coverage, 58075,
     /* 2219924 */   GIR_EraseRootFromParent_Done,
     /* 2219925 */ // Label 30831: @2219925
     /* 2219925 */ GIM_Reject,
     /* 2219926 */ // Label 30748: @2219926
     /* 2219926 */ GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2219980), // Rule ID 57662 //
     /* 2219931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2219934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2219937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219945 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2219948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2219962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219967 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219979 */   // GIR_Coverage, 57662,
     /* 2219979 */   GIR_EraseRootFromParent_Done,
     /* 2219980 */ // Label 30832: @2219980
     /* 2219980 */ GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2220034), // Rule ID 57663 //
     /* 2219985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2219988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2219991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219999 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2220016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220033 */   // GIR_Coverage, 57663,
     /* 2220033 */   GIR_EraseRootFromParent_Done,
     /* 2220034 */ // Label 30833: @2220034
     /* 2220034 */ GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2220088), // Rule ID 57842 //
     /* 2220039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2220042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2220045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220053 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2220070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220087 */   // GIR_Coverage, 57842,
     /* 2220087 */   GIR_EraseRootFromParent_Done,
     /* 2220088 */ // Label 30834: @2220088
     /* 2220088 */ GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2220142), // Rule ID 57843 //
     /* 2220093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2220096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2220099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220107 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2220124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220141 */   // GIR_Coverage, 57843,
     /* 2220141 */   GIR_EraseRootFromParent_Done,
     /* 2220142 */ // Label 30835: @2220142
     /* 2220142 */ GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2220196), // Rule ID 58094 //
     /* 2220147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2220150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2220153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220161 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2220178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220195 */   // GIR_Coverage, 58094,
     /* 2220195 */   GIR_EraseRootFromParent_Done,
     /* 2220196 */ // Label 30836: @2220196
     /* 2220196 */ GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2220250), // Rule ID 58095 //
     /* 2220201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2220204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2220207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220215 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2220232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220237 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220249 */   // GIR_Coverage, 58095,
     /* 2220249 */   GIR_EraseRootFromParent_Done,
     /* 2220250 */ // Label 30837: @2220250
     /* 2220250 */ GIM_Reject,
     /* 2220251 */ // Label 30749: @2220251
     /* 2220251 */ GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2220305), // Rule ID 57678 //
     /* 2220256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2220259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2220262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220270 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2220287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220304 */   // GIR_Coverage, 57678,
     /* 2220304 */   GIR_EraseRootFromParent_Done,
     /* 2220305 */ // Label 30838: @2220305
     /* 2220305 */ GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2220359), // Rule ID 57679 //
     /* 2220310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2220313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2220316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220324 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2220341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220346 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220358 */   // GIR_Coverage, 57679,
     /* 2220358 */   GIR_EraseRootFromParent_Done,
     /* 2220359 */ // Label 30839: @2220359
     /* 2220359 */ GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2220413), // Rule ID 57862 //
     /* 2220364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2220367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2220370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220378 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2220395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220412 */   // GIR_Coverage, 57862,
     /* 2220412 */   GIR_EraseRootFromParent_Done,
     /* 2220413 */ // Label 30840: @2220413
     /* 2220413 */ GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2220467), // Rule ID 57863 //
     /* 2220418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2220421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2220424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220432 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2220449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220466 */   // GIR_Coverage, 57863,
     /* 2220466 */   GIR_EraseRootFromParent_Done,
     /* 2220467 */ // Label 30841: @2220467
     /* 2220467 */ GIM_Reject,
     /* 2220468 */ // Label 30750: @2220468
     /* 2220468 */ GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2220571),
     /* 2220473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220484 */   GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2220527), // Rule ID 58054 //
     /* 2220489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2220492 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2220495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2220509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220526 */     // GIR_Coverage, 58054,
     /* 2220526 */     GIR_EraseRootFromParent_Done,
     /* 2220527 */   // Label 30843: @2220527
     /* 2220527 */   GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2220570), // Rule ID 58055 //
     /* 2220532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2220535 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2220538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2220552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220569 */     // GIR_Coverage, 58055,
     /* 2220569 */     GIR_EraseRootFromParent_Done,
     /* 2220570 */   // Label 30844: @2220570
     /* 2220570 */   GIM_Reject,
     /* 2220571 */ // Label 30842: @2220571
     /* 2220571 */ GIM_Reject,
     /* 2220572 */ // Label 30751: @2220572
     /* 2220572 */ GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2220626), // Rule ID 57650 //
     /* 2220577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2220580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220591 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2220608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220625 */   // GIR_Coverage, 57650,
     /* 2220625 */   GIR_EraseRootFromParent_Done,
     /* 2220626 */ // Label 30845: @2220626
     /* 2220626 */ GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2220680), // Rule ID 57651 //
     /* 2220631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2220634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220645 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2220662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220679 */   // GIR_Coverage, 57651,
     /* 2220679 */   GIR_EraseRootFromParent_Done,
     /* 2220680 */ // Label 30846: @2220680
     /* 2220680 */ GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2220734), // Rule ID 58078 //
     /* 2220685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2220688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2220691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220699 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2220716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220721 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220733 */   // GIR_Coverage, 58078,
     /* 2220733 */   GIR_EraseRootFromParent_Done,
     /* 2220734 */ // Label 30847: @2220734
     /* 2220734 */ GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2220788), // Rule ID 58079 //
     /* 2220739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2220742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2220745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220753 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2220770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220787 */   // GIR_Coverage, 58079,
     /* 2220787 */   GIR_EraseRootFromParent_Done,
     /* 2220788 */ // Label 30848: @2220788
     /* 2220788 */ GIM_Reject,
     /* 2220789 */ // Label 30752: @2220789
     /* 2220789 */ GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2220843), // Rule ID 57666 //
     /* 2220794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2220797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2220800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220808 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2220825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220830 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220842 */   // GIR_Coverage, 57666,
     /* 2220842 */   GIR_EraseRootFromParent_Done,
     /* 2220843 */ // Label 30849: @2220843
     /* 2220843 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2220897), // Rule ID 57667 //
     /* 2220848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2220851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2220854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220862 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2220879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220896 */   // GIR_Coverage, 57667,
     /* 2220896 */   GIR_EraseRootFromParent_Done,
     /* 2220897 */ // Label 30850: @2220897
     /* 2220897 */ GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2220951), // Rule ID 57846 //
     /* 2220902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2220905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220916 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2220933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220938 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220950 */   // GIR_Coverage, 57846,
     /* 2220950 */   GIR_EraseRootFromParent_Done,
     /* 2220951 */ // Label 30851: @2220951
     /* 2220951 */ GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2221005), // Rule ID 57847 //
     /* 2220956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2220959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220970 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2220987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221004 */   // GIR_Coverage, 57847,
     /* 2221004 */   GIR_EraseRootFromParent_Done,
     /* 2221005 */ // Label 30852: @2221005
     /* 2221005 */ GIM_Reject,
     /* 2221006 */ // Label 30753: @2221006
     /* 2221006 */ GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2221109),
     /* 2221011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2221014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221022 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2221065), // Rule ID 58058 //
     /* 2221027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2221030 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2221033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2221047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221064 */     // GIR_Coverage, 58058,
     /* 2221064 */     GIR_EraseRootFromParent_Done,
     /* 2221065 */   // Label 30854: @2221065
     /* 2221065 */   GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2221108), // Rule ID 58059 //
     /* 2221070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2221073 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2221076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2221090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221107 */     // GIR_Coverage, 58059,
     /* 2221107 */     GIR_EraseRootFromParent_Done,
     /* 2221108 */   // Label 30855: @2221108
     /* 2221108 */   GIM_Reject,
     /* 2221109 */ // Label 30853: @2221109
     /* 2221109 */ GIM_Reject,
     /* 2221110 */ // Label 30754: @2221110
     /* 2221110 */ GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2221213),
     /* 2221115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2221118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221126 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2221169), // Rule ID 57654 //
     /* 2221131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2221134 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2221137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2221151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221168 */     // GIR_Coverage, 57654,
     /* 2221168 */     GIR_EraseRootFromParent_Done,
     /* 2221169 */   // Label 30857: @2221169
     /* 2221169 */   GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2221212), // Rule ID 57655 //
     /* 2221174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2221177 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2221180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2221194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221211 */     // GIR_Coverage, 57655,
     /* 2221211 */     GIR_EraseRootFromParent_Done,
     /* 2221212 */   // Label 30858: @2221212
     /* 2221212 */   GIM_Reject,
     /* 2221213 */ // Label 30856: @2221213
     /* 2221213 */ GIM_Reject,
     /* 2221214 */ // Label 30755: @2221214
     /* 2221214 */ GIM_Reject,
     /* 2221215 */ // Label 67: @2221215
     /* 2221215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30877*/ GIMT_Encode4(2226500),
     /* 2221226 */ /*GILLT_s16*//*Label 30859*/ GIMT_Encode4(2221346),
     /* 2221230 */ /*GILLT_s32*//*Label 30860*/ GIMT_Encode4(2221607),
     /* 2221234 */ /*GILLT_s64*//*Label 30861*/ GIMT_Encode4(2221868), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221246 */ /*GILLT_nxv1s16*//*Label 30862*/ GIMT_Encode4(2222129),
     /* 2221250 */ /*GILLT_nxv1s32*//*Label 30863*/ GIMT_Encode4(2222466),
     /* 2221254 */ /*GILLT_nxv1s64*//*Label 30864*/ GIMT_Encode4(2222803), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221266 */ /*GILLT_nxv2s16*//*Label 30865*/ GIMT_Encode4(2223026),
     /* 2221270 */ /*GILLT_nxv2s32*//*Label 30866*/ GIMT_Encode4(2223363),
     /* 2221274 */ /*GILLT_nxv2s64*//*Label 30867*/ GIMT_Encode4(2223700), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221286 */ /*GILLT_nxv4s16*//*Label 30868*/ GIMT_Encode4(2223923),
     /* 2221290 */ /*GILLT_nxv4s32*//*Label 30869*/ GIMT_Encode4(2224260),
     /* 2221294 */ /*GILLT_nxv4s64*//*Label 30870*/ GIMT_Encode4(2224597), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221306 */ /*GILLT_nxv8s16*//*Label 30871*/ GIMT_Encode4(2224820),
     /* 2221310 */ /*GILLT_nxv8s32*//*Label 30872*/ GIMT_Encode4(2225157),
     /* 2221314 */ /*GILLT_nxv8s64*//*Label 30873*/ GIMT_Encode4(2225494), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221326 */ /*GILLT_nxv16s16*//*Label 30874*/ GIMT_Encode4(2225717),
     /* 2221330 */ /*GILLT_nxv16s32*//*Label 30875*/ GIMT_Encode4(2226054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2221342 */ /*GILLT_nxv32s16*//*Label 30876*/ GIMT_Encode4(2226277),
     /* 2221346 */ // Label 30859: @2221346
     /* 2221346 */ GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2221383), // Rule ID 2119 //
     /* 2221351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2221354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2221361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221368 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2221371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221382 */   // GIR_Coverage, 2119,
     /* 2221382 */   GIR_EraseRootFromParent_Done,
     /* 2221383 */ // Label 30878: @2221383
     /* 2221383 */ GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2221420), // Rule ID 2145 //
     /* 2221388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2221391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2221398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221405 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2221408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221419 */   // GIR_Coverage, 2145,
     /* 2221419 */   GIR_EraseRootFromParent_Done,
     /* 2221420 */ // Label 30879: @2221420
     /* 2221420 */ GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2221451), // Rule ID 2068 //
     /* 2221425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2221428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2221435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221439 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2221439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2221442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221444 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221450 */   // GIR_Coverage, 2068,
     /* 2221450 */   GIR_EraseRootFromParent_Done,
     /* 2221451 */ // Label 30880: @2221451
     /* 2221451 */ GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2221482), // Rule ID 2069 //
     /* 2221456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2221459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2221466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221470 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2221470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2221473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221475 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221481 */   // GIR_Coverage, 2069,
     /* 2221481 */   GIR_EraseRootFromParent_Done,
     /* 2221482 */ // Label 30881: @2221482
     /* 2221482 */ GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2221513), // Rule ID 2094 //
     /* 2221487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2221490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2221497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221501 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2221501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2221504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221506 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221512 */   // GIR_Coverage, 2094,
     /* 2221512 */   GIR_EraseRootFromParent_Done,
     /* 2221513 */ // Label 30882: @2221513
     /* 2221513 */ GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2221544), // Rule ID 2095 //
     /* 2221518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2221521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2221528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221532 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2221532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2221535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221537 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221543 */   // GIR_Coverage, 2095,
     /* 2221543 */   GIR_EraseRootFromParent_Done,
     /* 2221544 */ // Label 30883: @2221544
     /* 2221544 */ GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2221575), // Rule ID 2123 //
     /* 2221549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2221552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2221559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221563 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2221566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221574 */   // GIR_Coverage, 2123,
     /* 2221574 */   GIR_EraseRootFromParent_Done,
     /* 2221575 */ // Label 30884: @2221575
     /* 2221575 */ GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2221606), // Rule ID 2149 //
     /* 2221580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2221583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2221590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221594 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2221597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221599 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221605 */   // GIR_Coverage, 2149,
     /* 2221605 */   GIR_EraseRootFromParent_Done,
     /* 2221606 */ // Label 30885: @2221606
     /* 2221606 */ GIM_Reject,
     /* 2221607 */ // Label 30860: @2221607
     /* 2221607 */ GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2221644), // Rule ID 1385 //
     /* 2221612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2221615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2221622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221629 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2221632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221643 */   // GIR_Coverage, 1385,
     /* 2221643 */   GIR_EraseRootFromParent_Done,
     /* 2221644 */ // Label 30886: @2221644
     /* 2221644 */ GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2221681), // Rule ID 1413 //
     /* 2221649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2221652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2221659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221666 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2221669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221680 */   // GIR_Coverage, 1413,
     /* 2221680 */   GIR_EraseRootFromParent_Done,
     /* 2221681 */ // Label 30887: @2221681
     /* 2221681 */ GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2221712), // Rule ID 1332 //
     /* 2221686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2221689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2221696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221700 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2221700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2221703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221705 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221711 */   // GIR_Coverage, 1332,
     /* 2221711 */   GIR_EraseRootFromParent_Done,
     /* 2221712 */ // Label 30888: @2221712
     /* 2221712 */ GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2221743), // Rule ID 1333 //
     /* 2221717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2221720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2221727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221731 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2221731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2221734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221742 */   // GIR_Coverage, 1333,
     /* 2221742 */   GIR_EraseRootFromParent_Done,
     /* 2221743 */ // Label 30889: @2221743
     /* 2221743 */ GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2221774), // Rule ID 1358 //
     /* 2221748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2221751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2221758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221762 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2221762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2221765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221767 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221773 */   // GIR_Coverage, 1358,
     /* 2221773 */   GIR_EraseRootFromParent_Done,
     /* 2221774 */ // Label 30890: @2221774
     /* 2221774 */ GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2221805), // Rule ID 1359 //
     /* 2221779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2221782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2221789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221793 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2221793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2221796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221798 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221804 */   // GIR_Coverage, 1359,
     /* 2221804 */   GIR_EraseRootFromParent_Done,
     /* 2221805 */ // Label 30891: @2221805
     /* 2221805 */ GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2221836), // Rule ID 1389 //
     /* 2221810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2221813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2221820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221824 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2221827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221829 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221835 */   // GIR_Coverage, 1389,
     /* 2221835 */   GIR_EraseRootFromParent_Done,
     /* 2221836 */ // Label 30892: @2221836
     /* 2221836 */ GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2221867), // Rule ID 1417 //
     /* 2221841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2221844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2221851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221855 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2221855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2221858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221860 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2221865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221866 */   // GIR_Coverage, 1417,
     /* 2221866 */   GIR_EraseRootFromParent_Done,
     /* 2221867 */ // Label 30893: @2221867
     /* 2221867 */ GIM_Reject,
     /* 2221868 */ // Label 30861: @2221868
     /* 2221868 */ GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2221905), // Rule ID 1765 //
     /* 2221873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2221876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2221883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221890 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2221890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2221893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2221903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221904 */   // GIR_Coverage, 1765,
     /* 2221904 */   GIR_EraseRootFromParent_Done,
     /* 2221905 */ // Label 30894: @2221905
     /* 2221905 */ GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2221942), // Rule ID 1793 //
     /* 2221910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2221913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2221927 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2221927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2221930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2221937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2221940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221941 */   // GIR_Coverage, 1793,
     /* 2221941 */   GIR_EraseRootFromParent_Done,
     /* 2221942 */ // Label 30895: @2221942
     /* 2221942 */ GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2221973), // Rule ID 1726 //
     /* 2221947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2221950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2221957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221961 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2221961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2221964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2221971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221972 */   // GIR_Coverage, 1726,
     /* 2221972 */   GIR_EraseRootFromParent_Done,
     /* 2221973 */ // Label 30896: @2221973
     /* 2221973 */ GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2222004), // Rule ID 1727 //
     /* 2221978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2221981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2221988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221992 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2221992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2221995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221997 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2222002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222003 */   // GIR_Coverage, 1727,
     /* 2222003 */   GIR_EraseRootFromParent_Done,
     /* 2222004 */ // Label 30897: @2222004
     /* 2222004 */ GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2222035), // Rule ID 1752 //
     /* 2222009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2222012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2222015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2222019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222023 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2222023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2222026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2222033 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222034 */   // GIR_Coverage, 1752,
     /* 2222034 */   GIR_EraseRootFromParent_Done,
     /* 2222035 */ // Label 30898: @2222035
     /* 2222035 */ GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2222066), // Rule ID 1753 //
     /* 2222040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2222043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2222046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2222050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222054 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2222054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2222057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222059 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2222064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222065 */   // GIR_Coverage, 1753,
     /* 2222065 */   GIR_EraseRootFromParent_Done,
     /* 2222066 */ // Label 30899: @2222066
     /* 2222066 */ GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2222097), // Rule ID 1783 //
     /* 2222071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2222074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2222077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2222081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222085 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2222085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2222088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222090 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222096 */   // GIR_Coverage, 1783,
     /* 2222096 */   GIR_EraseRootFromParent_Done,
     /* 2222097 */ // Label 30900: @2222097
     /* 2222097 */ GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2222128), // Rule ID 1811 //
     /* 2222102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2222105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2222108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222116 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2222116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2222119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222121 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222127 */   // GIR_Coverage, 1811,
     /* 2222127 */   GIR_EraseRootFromParent_Done,
     /* 2222128 */ // Label 30901: @2222128
     /* 2222128 */ GIM_Reject,
     /* 2222129 */ // Label 30862: @2222129
     /* 2222129 */ GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2222186), // Rule ID 45482 //
     /* 2222134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2222137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2222140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222148 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2222165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222170 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222185 */   // GIR_Coverage, 45482,
     /* 2222185 */   GIR_EraseRootFromParent_Done,
     /* 2222186 */ // Label 30902: @2222186
     /* 2222186 */ GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2222243), // Rule ID 45483 //
     /* 2222191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2222194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2222197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222205 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2222222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222227 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222242 */   // GIR_Coverage, 45483,
     /* 2222242 */   GIR_EraseRootFromParent_Done,
     /* 2222243 */ // Label 30903: @2222243
     /* 2222243 */ GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2222297), // Rule ID 45490 //
     /* 2222248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2222251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2222254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222262 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2222279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222284 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222296 */   // GIR_Coverage, 45490,
     /* 2222296 */   GIR_EraseRootFromParent_Done,
     /* 2222297 */ // Label 30904: @2222297
     /* 2222297 */ GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2222351), // Rule ID 45491 //
     /* 2222302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2222305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2222308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222316 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2222333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222338 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222350 */   // GIR_Coverage, 45491,
     /* 2222350 */   GIR_EraseRootFromParent_Done,
     /* 2222351 */ // Label 30905: @2222351
     /* 2222351 */ GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2222408), // Rule ID 45498 //
     /* 2222356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2222359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222370 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2222387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222392 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222407 */   // GIR_Coverage, 45498,
     /* 2222407 */   GIR_EraseRootFromParent_Done,
     /* 2222408 */ // Label 30906: @2222408
     /* 2222408 */ GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2222465), // Rule ID 45499 //
     /* 2222413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2222416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222427 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2222444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222464 */   // GIR_Coverage, 45499,
     /* 2222464 */   GIR_EraseRootFromParent_Done,
     /* 2222465 */ // Label 30907: @2222465
     /* 2222465 */ GIM_Reject,
     /* 2222466 */ // Label 30863: @2222466
     /* 2222466 */ GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2222523), // Rule ID 57686 //
     /* 2222471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2222474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222485 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2222502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222507 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222522 */   // GIR_Coverage, 57686,
     /* 2222522 */   GIR_EraseRootFromParent_Done,
     /* 2222523 */ // Label 30908: @2222523
     /* 2222523 */ GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2222580), // Rule ID 57687 //
     /* 2222528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2222531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222542 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2222559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222579 */   // GIR_Coverage, 57687,
     /* 2222579 */   GIR_EraseRootFromParent_Done,
     /* 2222580 */ // Label 30909: @2222580
     /* 2222580 */ GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2222634), // Rule ID 57886 //
     /* 2222585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2222588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2222591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222599 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2222616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222621 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222633 */   // GIR_Coverage, 57886,
     /* 2222633 */   GIR_EraseRootFromParent_Done,
     /* 2222634 */ // Label 30910: @2222634
     /* 2222634 */ GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2222688), // Rule ID 57887 //
     /* 2222639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2222642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2222645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222653 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2222670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222675 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222687 */   // GIR_Coverage, 57887,
     /* 2222687 */   GIR_EraseRootFromParent_Done,
     /* 2222688 */ // Label 30911: @2222688
     /* 2222688 */ GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2222745), // Rule ID 58114 //
     /* 2222693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2222696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2222699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222707 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2222724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222729 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222744 */   // GIR_Coverage, 58114,
     /* 2222744 */   GIR_EraseRootFromParent_Done,
     /* 2222745 */ // Label 30912: @2222745
     /* 2222745 */ GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2222802), // Rule ID 58115 //
     /* 2222750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2222753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2222756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222764 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2222767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2222781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222786 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222801 */   // GIR_Coverage, 58115,
     /* 2222801 */   GIR_EraseRootFromParent_Done,
     /* 2222802 */ // Label 30913: @2222802
     /* 2222802 */ GIM_Reject,
     /* 2222803 */ // Label 30864: @2222803
     /* 2222803 */ GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2222860), // Rule ID 57698 //
     /* 2222808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2222811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2222814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222822 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2222825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2222839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222859 */   // GIR_Coverage, 57698,
     /* 2222859 */   GIR_EraseRootFromParent_Done,
     /* 2222860 */ // Label 30914: @2222860
     /* 2222860 */ GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2222917), // Rule ID 57699 //
     /* 2222865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2222868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2222871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222879 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2222882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2222896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2222906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222916 */   // GIR_Coverage, 57699,
     /* 2222916 */   GIR_EraseRootFromParent_Done,
     /* 2222917 */ // Label 30915: @2222917
     /* 2222917 */ GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2222971), // Rule ID 57906 //
     /* 2222922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2222925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222936 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2222939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2222953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222958 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222970 */   // GIR_Coverage, 57906,
     /* 2222970 */   GIR_EraseRootFromParent_Done,
     /* 2222971 */ // Label 30916: @2222971
     /* 2222971 */ GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2223025), // Rule ID 57907 //
     /* 2222976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2222979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2222982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222990 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2222993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2223007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223024 */   // GIR_Coverage, 57907,
     /* 2223024 */   GIR_EraseRootFromParent_Done,
     /* 2223025 */ // Label 30917: @2223025
     /* 2223025 */ GIM_Reject,
     /* 2223026 */ // Label 30865: @2223026
     /* 2223026 */ GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2223083), // Rule ID 57682 //
     /* 2223031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2223034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2223037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223045 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2223062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223067 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223082 */   // GIR_Coverage, 57682,
     /* 2223082 */   GIR_EraseRootFromParent_Done,
     /* 2223083 */ // Label 30918: @2223083
     /* 2223083 */ GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2223140), // Rule ID 57683 //
     /* 2223088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2223091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2223094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223102 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2223119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223124 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223139 */   // GIR_Coverage, 57683,
     /* 2223139 */   GIR_EraseRootFromParent_Done,
     /* 2223140 */ // Label 30919: @2223140
     /* 2223140 */ GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2223194), // Rule ID 57866 //
     /* 2223145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2223148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2223151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223159 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2223176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223181 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223193 */   // GIR_Coverage, 57866,
     /* 2223193 */   GIR_EraseRootFromParent_Done,
     /* 2223194 */ // Label 30920: @2223194
     /* 2223194 */ GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2223248), // Rule ID 57867 //
     /* 2223199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2223202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2223205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223213 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2223230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223235 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223247 */   // GIR_Coverage, 57867,
     /* 2223247 */   GIR_EraseRootFromParent_Done,
     /* 2223248 */ // Label 30921: @2223248
     /* 2223248 */ GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2223305), // Rule ID 58098 //
     /* 2223253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2223256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223267 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2223284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223289 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223304 */   // GIR_Coverage, 58098,
     /* 2223304 */   GIR_EraseRootFromParent_Done,
     /* 2223305 */ // Label 30922: @2223305
     /* 2223305 */ GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2223362), // Rule ID 58099 //
     /* 2223310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2223313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223324 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2223341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223346 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223361 */   // GIR_Coverage, 58099,
     /* 2223361 */   GIR_EraseRootFromParent_Done,
     /* 2223362 */ // Label 30923: @2223362
     /* 2223362 */ GIM_Reject,
     /* 2223363 */ // Label 30866: @2223363
     /* 2223363 */ GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2223420), // Rule ID 57694 //
     /* 2223368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2223371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223382 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2223399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223419 */   // GIR_Coverage, 57694,
     /* 2223419 */   GIR_EraseRootFromParent_Done,
     /* 2223420 */ // Label 30924: @2223420
     /* 2223420 */ GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2223477), // Rule ID 57695 //
     /* 2223425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2223428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223439 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2223456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223461 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223476 */   // GIR_Coverage, 57695,
     /* 2223476 */   GIR_EraseRootFromParent_Done,
     /* 2223477 */ // Label 30925: @2223477
     /* 2223477 */ GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2223531), // Rule ID 57890 //
     /* 2223482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2223485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2223488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223496 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2223513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223518 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223530 */   // GIR_Coverage, 57890,
     /* 2223530 */   GIR_EraseRootFromParent_Done,
     /* 2223531 */ // Label 30926: @2223531
     /* 2223531 */ GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2223585), // Rule ID 57891 //
     /* 2223536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2223539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2223542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223550 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2223567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223572 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223584 */   // GIR_Coverage, 57891,
     /* 2223584 */   GIR_EraseRootFromParent_Done,
     /* 2223585 */ // Label 30927: @2223585
     /* 2223585 */ GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2223642), // Rule ID 58118 //
     /* 2223590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2223593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2223596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223604 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2223621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223641 */   // GIR_Coverage, 58118,
     /* 2223641 */   GIR_EraseRootFromParent_Done,
     /* 2223642 */ // Label 30928: @2223642
     /* 2223642 */ GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2223699), // Rule ID 58119 //
     /* 2223647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2223650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2223653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223661 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2223678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223683 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223698 */   // GIR_Coverage, 58119,
     /* 2223698 */   GIR_EraseRootFromParent_Done,
     /* 2223699 */ // Label 30929: @2223699
     /* 2223699 */ GIM_Reject,
     /* 2223700 */ // Label 30867: @2223700
     /* 2223700 */ GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2223757), // Rule ID 57726 //
     /* 2223705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2223708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2223711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223719 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2223736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223756 */   // GIR_Coverage, 57726,
     /* 2223756 */   GIR_EraseRootFromParent_Done,
     /* 2223757 */ // Label 30930: @2223757
     /* 2223757 */ GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2223814), // Rule ID 57727 //
     /* 2223762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2223765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2223768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223776 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2223793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223798 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223813 */   // GIR_Coverage, 57727,
     /* 2223813 */   GIR_EraseRootFromParent_Done,
     /* 2223814 */ // Label 30931: @2223814
     /* 2223814 */ GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2223868), // Rule ID 57910 //
     /* 2223819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2223822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223833 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2223850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223855 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223867 */   // GIR_Coverage, 57910,
     /* 2223867 */   GIR_EraseRootFromParent_Done,
     /* 2223868 */ // Label 30932: @2223868
     /* 2223868 */ GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2223922), // Rule ID 57911 //
     /* 2223873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2223876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223887 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2223904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223909 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223921 */   // GIR_Coverage, 57911,
     /* 2223921 */   GIR_EraseRootFromParent_Done,
     /* 2223922 */ // Label 30933: @2223922
     /* 2223922 */ GIM_Reject,
     /* 2223923 */ // Label 30868: @2223923
     /* 2223923 */ GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2223980), // Rule ID 57690 //
     /* 2223928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2223931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223942 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2223959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223964 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2223969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2223979 */   // GIR_Coverage, 57690,
     /* 2223979 */   GIR_EraseRootFromParent_Done,
     /* 2223980 */ // Label 30934: @2223980
     /* 2223980 */ GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2224037), // Rule ID 57691 //
     /* 2223985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2223988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223999 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2224002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2224016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224036 */   // GIR_Coverage, 57691,
     /* 2224036 */   GIR_EraseRootFromParent_Done,
     /* 2224037 */ // Label 30935: @2224037
     /* 2224037 */ GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2224091), // Rule ID 57870 //
     /* 2224042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2224045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2224048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224056 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2224059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2224073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224090 */   // GIR_Coverage, 57870,
     /* 2224090 */   GIR_EraseRootFromParent_Done,
     /* 2224091 */ // Label 30936: @2224091
     /* 2224091 */ GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2224145), // Rule ID 57871 //
     /* 2224096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2224099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2224102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224110 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2224113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2224127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224132 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224144 */   // GIR_Coverage, 57871,
     /* 2224144 */   GIR_EraseRootFromParent_Done,
     /* 2224145 */ // Label 30937: @2224145
     /* 2224145 */ GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2224202), // Rule ID 58102 //
     /* 2224150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2224153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224164 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2224167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2224181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224201 */   // GIR_Coverage, 58102,
     /* 2224201 */   GIR_EraseRootFromParent_Done,
     /* 2224202 */ // Label 30938: @2224202
     /* 2224202 */ GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2224259), // Rule ID 58103 //
     /* 2224207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2224210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224221 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2224224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2224238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224258 */   // GIR_Coverage, 58103,
     /* 2224258 */   GIR_EraseRootFromParent_Done,
     /* 2224259 */ // Label 30939: @2224259
     /* 2224259 */ GIM_Reject,
     /* 2224260 */ // Label 30869: @2224260
     /* 2224260 */ GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2224317), // Rule ID 57714 //
     /* 2224265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2224268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224279 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2224296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224316 */   // GIR_Coverage, 57714,
     /* 2224316 */   GIR_EraseRootFromParent_Done,
     /* 2224317 */ // Label 30940: @2224317
     /* 2224317 */ GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2224374), // Rule ID 57715 //
     /* 2224322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2224325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224336 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2224353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224373 */   // GIR_Coverage, 57715,
     /* 2224373 */   GIR_EraseRootFromParent_Done,
     /* 2224374 */ // Label 30941: @2224374
     /* 2224374 */ GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2224428), // Rule ID 57894 //
     /* 2224379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2224382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2224385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224393 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2224410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224415 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224427 */   // GIR_Coverage, 57894,
     /* 2224427 */   GIR_EraseRootFromParent_Done,
     /* 2224428 */ // Label 30942: @2224428
     /* 2224428 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2224482), // Rule ID 57895 //
     /* 2224433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2224436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2224439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224447 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2224464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224469 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224481 */   // GIR_Coverage, 57895,
     /* 2224481 */   GIR_EraseRootFromParent_Done,
     /* 2224482 */ // Label 30943: @2224482
     /* 2224482 */ GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2224539), // Rule ID 58122 //
     /* 2224487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2224490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224501 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2224518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224538 */   // GIR_Coverage, 58122,
     /* 2224538 */   GIR_EraseRootFromParent_Done,
     /* 2224539 */ // Label 30944: @2224539
     /* 2224539 */ GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2224596), // Rule ID 58123 //
     /* 2224544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2224547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224558 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2224575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224580 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224595 */   // GIR_Coverage, 58123,
     /* 2224595 */   GIR_EraseRootFromParent_Done,
     /* 2224596 */ // Label 30945: @2224596
     /* 2224596 */ GIM_Reject,
     /* 2224597 */ // Label 30870: @2224597
     /* 2224597 */ GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2224654), // Rule ID 57730 //
     /* 2224602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2224605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224616 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2224633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224653 */   // GIR_Coverage, 57730,
     /* 2224653 */   GIR_EraseRootFromParent_Done,
     /* 2224654 */ // Label 30946: @2224654
     /* 2224654 */ GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2224711), // Rule ID 57731 //
     /* 2224659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2224662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224673 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2224690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224710 */   // GIR_Coverage, 57731,
     /* 2224710 */   GIR_EraseRootFromParent_Done,
     /* 2224711 */ // Label 30947: @2224711
     /* 2224711 */ GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2224765), // Rule ID 57914 //
     /* 2224716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2224719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224730 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2224747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224752 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224764 */   // GIR_Coverage, 57914,
     /* 2224764 */   GIR_EraseRootFromParent_Done,
     /* 2224765 */ // Label 30948: @2224765
     /* 2224765 */ GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2224819), // Rule ID 57915 //
     /* 2224770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2224773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224784 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2224801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224806 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224818 */   // GIR_Coverage, 57915,
     /* 2224818 */   GIR_EraseRootFromParent_Done,
     /* 2224819 */ // Label 30949: @2224819
     /* 2224819 */ GIM_Reject,
     /* 2224820 */ // Label 30871: @2224820
     /* 2224820 */ GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2224877), // Rule ID 57702 //
     /* 2224825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2224828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224839 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2224856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224876 */   // GIR_Coverage, 57702,
     /* 2224876 */   GIR_EraseRootFromParent_Done,
     /* 2224877 */ // Label 30950: @2224877
     /* 2224877 */ GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2224934), // Rule ID 57703 //
     /* 2224882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2224885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224896 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2224913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2224923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224933 */   // GIR_Coverage, 57703,
     /* 2224933 */   GIR_EraseRootFromParent_Done,
     /* 2224934 */ // Label 30951: @2224934
     /* 2224934 */ GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2224988), // Rule ID 57874 //
     /* 2224939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2224942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224953 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2224970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224975 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2224987 */   // GIR_Coverage, 57874,
     /* 2224987 */   GIR_EraseRootFromParent_Done,
     /* 2224988 */ // Label 30952: @2224988
     /* 2224988 */ GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2225042), // Rule ID 57875 //
     /* 2224993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2224996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225007 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2225024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225029 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225041 */   // GIR_Coverage, 57875,
     /* 2225041 */   GIR_EraseRootFromParent_Done,
     /* 2225042 */ // Label 30953: @2225042
     /* 2225042 */ GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2225099), // Rule ID 58106 //
     /* 2225047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2225050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225061 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2225078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225083 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225098 */   // GIR_Coverage, 58106,
     /* 2225098 */   GIR_EraseRootFromParent_Done,
     /* 2225099 */ // Label 30954: @2225099
     /* 2225099 */ GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2225156), // Rule ID 58107 //
     /* 2225104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2225107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225118 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2225135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225155 */   // GIR_Coverage, 58107,
     /* 2225155 */   GIR_EraseRootFromParent_Done,
     /* 2225156 */ // Label 30955: @2225156
     /* 2225156 */ GIM_Reject,
     /* 2225157 */ // Label 30872: @2225157
     /* 2225157 */ GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2225214), // Rule ID 57718 //
     /* 2225162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2225165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225176 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2225193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225213 */   // GIR_Coverage, 57718,
     /* 2225213 */   GIR_EraseRootFromParent_Done,
     /* 2225214 */ // Label 30956: @2225214
     /* 2225214 */ GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2225271), // Rule ID 57719 //
     /* 2225219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2225222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225233 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2225250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225255 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225270 */   // GIR_Coverage, 57719,
     /* 2225270 */   GIR_EraseRootFromParent_Done,
     /* 2225271 */ // Label 30957: @2225271
     /* 2225271 */ GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2225325), // Rule ID 57898 //
     /* 2225276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2225279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225290 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2225307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225312 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225324 */   // GIR_Coverage, 57898,
     /* 2225324 */   GIR_EraseRootFromParent_Done,
     /* 2225325 */ // Label 30958: @2225325
     /* 2225325 */ GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2225379), // Rule ID 57899 //
     /* 2225330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2225333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225344 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2225361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225366 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225378 */   // GIR_Coverage, 57899,
     /* 2225378 */   GIR_EraseRootFromParent_Done,
     /* 2225379 */ // Label 30959: @2225379
     /* 2225379 */ GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2225436), // Rule ID 58126 //
     /* 2225384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2225387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225398 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2225415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225435 */   // GIR_Coverage, 58126,
     /* 2225435 */   GIR_EraseRootFromParent_Done,
     /* 2225436 */ // Label 30960: @2225436
     /* 2225436 */ GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2225493), // Rule ID 58127 //
     /* 2225441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2225444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225455 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2225472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225477 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225492 */   // GIR_Coverage, 58127,
     /* 2225492 */   GIR_EraseRootFromParent_Done,
     /* 2225493 */ // Label 30961: @2225493
     /* 2225493 */ GIM_Reject,
     /* 2225494 */ // Label 30873: @2225494
     /* 2225494 */ GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2225551), // Rule ID 57734 //
     /* 2225499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2225502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225513 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2225530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225550 */   // GIR_Coverage, 57734,
     /* 2225550 */   GIR_EraseRootFromParent_Done,
     /* 2225551 */ // Label 30962: @2225551
     /* 2225551 */ GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2225608), // Rule ID 57735 //
     /* 2225556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2225559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225570 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2225587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225592 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225607 */   // GIR_Coverage, 57735,
     /* 2225607 */   GIR_EraseRootFromParent_Done,
     /* 2225608 */ // Label 30963: @2225608
     /* 2225608 */ GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2225662), // Rule ID 57918 //
     /* 2225613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2225616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225627 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2225644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225649 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225661 */   // GIR_Coverage, 57918,
     /* 2225661 */   GIR_EraseRootFromParent_Done,
     /* 2225662 */ // Label 30964: @2225662
     /* 2225662 */ GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2225716), // Rule ID 57919 //
     /* 2225667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2225670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225681 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2225698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225715 */   // GIR_Coverage, 57919,
     /* 2225715 */   GIR_EraseRootFromParent_Done,
     /* 2225716 */ // Label 30965: @2225716
     /* 2225716 */ GIM_Reject,
     /* 2225717 */ // Label 30874: @2225717
     /* 2225717 */ GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2225774), // Rule ID 57706 //
     /* 2225722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2225725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2225728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225736 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2225753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225773 */   // GIR_Coverage, 57706,
     /* 2225773 */   GIR_EraseRootFromParent_Done,
     /* 2225774 */ // Label 30966: @2225774
     /* 2225774 */ GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2225831), // Rule ID 57707 //
     /* 2225779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2225782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2225785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225793 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2225810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225830 */   // GIR_Coverage, 57707,
     /* 2225830 */   GIR_EraseRootFromParent_Done,
     /* 2225831 */ // Label 30967: @2225831
     /* 2225831 */ GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2225885), // Rule ID 57878 //
     /* 2225836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2225839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225850 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2225867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225872 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225884 */   // GIR_Coverage, 57878,
     /* 2225884 */   GIR_EraseRootFromParent_Done,
     /* 2225885 */ // Label 30968: @2225885
     /* 2225885 */ GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2225939), // Rule ID 57879 //
     /* 2225890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2225893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225904 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2225921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225926 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225938 */   // GIR_Coverage, 57879,
     /* 2225938 */   GIR_EraseRootFromParent_Done,
     /* 2225939 */ // Label 30969: @2225939
     /* 2225939 */ GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2225996), // Rule ID 58110 //
     /* 2225944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2225947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2225950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225958 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2225975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225980 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2225985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225995 */   // GIR_Coverage, 58110,
     /* 2225995 */   GIR_EraseRootFromParent_Done,
     /* 2225996 */ // Label 30970: @2225996
     /* 2225996 */ GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2226053), // Rule ID 58111 //
     /* 2226001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2226004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226015 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2226032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226052 */   // GIR_Coverage, 58111,
     /* 2226052 */   GIR_EraseRootFromParent_Done,
     /* 2226053 */ // Label 30971: @2226053
     /* 2226053 */ GIM_Reject,
     /* 2226054 */ // Label 30875: @2226054
     /* 2226054 */ GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2226111), // Rule ID 57722 //
     /* 2226059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2226062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226073 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2226090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226110 */   // GIR_Coverage, 57722,
     /* 2226110 */   GIR_EraseRootFromParent_Done,
     /* 2226111 */ // Label 30972: @2226111
     /* 2226111 */ GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2226168), // Rule ID 57723 //
     /* 2226116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2226119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226130 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2226147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226152 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226167 */   // GIR_Coverage, 57723,
     /* 2226167 */   GIR_EraseRootFromParent_Done,
     /* 2226168 */ // Label 30973: @2226168
     /* 2226168 */ GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2226222), // Rule ID 57902 //
     /* 2226173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2226176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226187 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2226204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226209 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226221 */   // GIR_Coverage, 57902,
     /* 2226221 */   GIR_EraseRootFromParent_Done,
     /* 2226222 */ // Label 30974: @2226222
     /* 2226222 */ GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2226276), // Rule ID 57903 //
     /* 2226227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2226230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226241 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2226258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226275 */   // GIR_Coverage, 57903,
     /* 2226275 */   GIR_EraseRootFromParent_Done,
     /* 2226276 */ // Label 30975: @2226276
     /* 2226276 */ GIM_Reject,
     /* 2226277 */ // Label 30876: @2226277
     /* 2226277 */ GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2226334), // Rule ID 57710 //
     /* 2226282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2226285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2226288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226296 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226296 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226299 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226303 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2226313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226318 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226333 */   // GIR_Coverage, 57710,
     /* 2226333 */   GIR_EraseRootFromParent_Done,
     /* 2226334 */ // Label 30976: @2226334
     /* 2226334 */ GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2226391), // Rule ID 57711 //
     /* 2226339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2226342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2226345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226353 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2226370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226390 */   // GIR_Coverage, 57711,
     /* 2226390 */   GIR_EraseRootFromParent_Done,
     /* 2226391 */ // Label 30977: @2226391
     /* 2226391 */ GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2226445), // Rule ID 57882 //
     /* 2226396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2226399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226410 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2226427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226444 */   // GIR_Coverage, 57882,
     /* 2226444 */   GIR_EraseRootFromParent_Done,
     /* 2226445 */ // Label 30978: @2226445
     /* 2226445 */ GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2226499), // Rule ID 57883 //
     /* 2226450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2226453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226464 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2226481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226486 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226498 */   // GIR_Coverage, 57883,
     /* 2226498 */   GIR_EraseRootFromParent_Done,
     /* 2226499 */ // Label 30979: @2226499
     /* 2226499 */ GIM_Reject,
     /* 2226500 */ // Label 30877: @2226500
     /* 2226500 */ GIM_Reject,
     /* 2226501 */ // Label 68: @2226501
     /* 2226501 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30998*/ GIMT_Encode4(2231786),
     /* 2226512 */ /*GILLT_s16*//*Label 30980*/ GIMT_Encode4(2226632),
     /* 2226516 */ /*GILLT_s32*//*Label 30981*/ GIMT_Encode4(2226893),
     /* 2226520 */ /*GILLT_s64*//*Label 30982*/ GIMT_Encode4(2227154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226532 */ /*GILLT_nxv1s16*//*Label 30983*/ GIMT_Encode4(2227415),
     /* 2226536 */ /*GILLT_nxv1s32*//*Label 30984*/ GIMT_Encode4(2227752),
     /* 2226540 */ /*GILLT_nxv1s64*//*Label 30985*/ GIMT_Encode4(2228089), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226552 */ /*GILLT_nxv2s16*//*Label 30986*/ GIMT_Encode4(2228312),
     /* 2226556 */ /*GILLT_nxv2s32*//*Label 30987*/ GIMT_Encode4(2228649),
     /* 2226560 */ /*GILLT_nxv2s64*//*Label 30988*/ GIMT_Encode4(2228986), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226572 */ /*GILLT_nxv4s16*//*Label 30989*/ GIMT_Encode4(2229209),
     /* 2226576 */ /*GILLT_nxv4s32*//*Label 30990*/ GIMT_Encode4(2229546),
     /* 2226580 */ /*GILLT_nxv4s64*//*Label 30991*/ GIMT_Encode4(2229883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226592 */ /*GILLT_nxv8s16*//*Label 30992*/ GIMT_Encode4(2230106),
     /* 2226596 */ /*GILLT_nxv8s32*//*Label 30993*/ GIMT_Encode4(2230443),
     /* 2226600 */ /*GILLT_nxv8s64*//*Label 30994*/ GIMT_Encode4(2230780), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226612 */ /*GILLT_nxv16s16*//*Label 30995*/ GIMT_Encode4(2231003),
     /* 2226616 */ /*GILLT_nxv16s32*//*Label 30996*/ GIMT_Encode4(2231340), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2226628 */ /*GILLT_nxv32s16*//*Label 30997*/ GIMT_Encode4(2231563),
     /* 2226632 */ // Label 30980: @2226632
     /* 2226632 */ GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2226669), // Rule ID 2121 //
     /* 2226637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2226640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2226647 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2226654 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2226657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2226664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226668 */   // GIR_Coverage, 2121,
     /* 2226668 */   GIR_EraseRootFromParent_Done,
     /* 2226669 */ // Label 30999: @2226669
     /* 2226669 */ GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2226706), // Rule ID 2147 //
     /* 2226674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2226677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2226684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2226691 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2226694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2226701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226705 */   // GIR_Coverage, 2147,
     /* 2226705 */   GIR_EraseRootFromParent_Done,
     /* 2226706 */ // Label 31000: @2226706
     /* 2226706 */ GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2226737), // Rule ID 2072 //
     /* 2226711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2226714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2226721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226725 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2226725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2226728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226730 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226736 */   // GIR_Coverage, 2072,
     /* 2226736 */   GIR_EraseRootFromParent_Done,
     /* 2226737 */ // Label 31001: @2226737
     /* 2226737 */ GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2226768), // Rule ID 2073 //
     /* 2226742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2226745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2226752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226756 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2226756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2226759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226767 */   // GIR_Coverage, 2073,
     /* 2226767 */   GIR_EraseRootFromParent_Done,
     /* 2226768 */ // Label 31002: @2226768
     /* 2226768 */ GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2226799), // Rule ID 2098 //
     /* 2226773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2226776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2226783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226787 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2226787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2226790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226792 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226798 */   // GIR_Coverage, 2098,
     /* 2226798 */   GIR_EraseRootFromParent_Done,
     /* 2226799 */ // Label 31003: @2226799
     /* 2226799 */ GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2226830), // Rule ID 2099 //
     /* 2226804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2226807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2226814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226818 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2226818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2226821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226829 */   // GIR_Coverage, 2099,
     /* 2226829 */   GIR_EraseRootFromParent_Done,
     /* 2226830 */ // Label 31004: @2226830
     /* 2226830 */ GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2226861), // Rule ID 2125 //
     /* 2226835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2226838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2226845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226849 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2226852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226854 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226860 */   // GIR_Coverage, 2125,
     /* 2226860 */   GIR_EraseRootFromParent_Done,
     /* 2226861 */ // Label 31005: @2226861
     /* 2226861 */ GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2226892), // Rule ID 2151 //
     /* 2226866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2226869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2226876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226880 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2226883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226885 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226891 */   // GIR_Coverage, 2151,
     /* 2226891 */   GIR_EraseRootFromParent_Done,
     /* 2226892 */ // Label 31006: @2226892
     /* 2226892 */ GIM_Reject,
     /* 2226893 */ // Label 30981: @2226893
     /* 2226893 */ GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2226930), // Rule ID 1387 //
     /* 2226898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2226901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2226908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2226915 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2226918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2226925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226929 */   // GIR_Coverage, 1387,
     /* 2226929 */   GIR_EraseRootFromParent_Done,
     /* 2226930 */ // Label 31007: @2226930
     /* 2226930 */ GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2226967), // Rule ID 1415 //
     /* 2226935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2226938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2226941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2226945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2226952 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2226952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2226955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2226962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226966 */   // GIR_Coverage, 1415,
     /* 2226966 */   GIR_EraseRootFromParent_Done,
     /* 2226967 */ // Label 31008: @2226967
     /* 2226967 */ GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2226998), // Rule ID 1336 //
     /* 2226972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2226975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2226982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226986 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2226986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2226989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2226996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226997 */   // GIR_Coverage, 1336,
     /* 2226997 */   GIR_EraseRootFromParent_Done,
     /* 2226998 */ // Label 31009: @2226998
     /* 2226998 */ GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2227029), // Rule ID 1337 //
     /* 2227003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2227006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2227013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227017 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2227017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2227020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227022 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227028 */   // GIR_Coverage, 1337,
     /* 2227028 */   GIR_EraseRootFromParent_Done,
     /* 2227029 */ // Label 31010: @2227029
     /* 2227029 */ GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2227060), // Rule ID 1362 //
     /* 2227034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2227037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2227044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227048 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2227048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2227051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227053 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227059 */   // GIR_Coverage, 1362,
     /* 2227059 */   GIR_EraseRootFromParent_Done,
     /* 2227060 */ // Label 31011: @2227060
     /* 2227060 */ GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2227091), // Rule ID 1363 //
     /* 2227065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2227068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2227075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227079 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2227079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2227082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227084 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227090 */   // GIR_Coverage, 1363,
     /* 2227090 */   GIR_EraseRootFromParent_Done,
     /* 2227091 */ // Label 31012: @2227091
     /* 2227091 */ GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2227122), // Rule ID 1391 //
     /* 2227096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2227099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2227106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227110 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2227110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2227113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227115 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227121 */   // GIR_Coverage, 1391,
     /* 2227121 */   GIR_EraseRootFromParent_Done,
     /* 2227122 */ // Label 31013: @2227122
     /* 2227122 */ GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2227153), // Rule ID 1419 //
     /* 2227127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2227130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2227137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227141 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2227141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2227144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227146 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227152 */   // GIR_Coverage, 1419,
     /* 2227152 */   GIR_EraseRootFromParent_Done,
     /* 2227153 */ // Label 31014: @2227153
     /* 2227153 */ GIM_Reject,
     /* 2227154 */ // Label 30982: @2227154
     /* 2227154 */ GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2227191), // Rule ID 1767 //
     /* 2227159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2227162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2227169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2227176 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2227176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2227179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2227186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227190 */   // GIR_Coverage, 1767,
     /* 2227190 */   GIR_EraseRootFromParent_Done,
     /* 2227191 */ // Label 31015: @2227191
     /* 2227191 */ GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2227228), // Rule ID 1795 //
     /* 2227196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2227199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227206 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2227213 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2227213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2227216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2227223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227227 */   // GIR_Coverage, 1795,
     /* 2227227 */   GIR_EraseRootFromParent_Done,
     /* 2227228 */ // Label 31016: @2227228
     /* 2227228 */ GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2227259), // Rule ID 1730 //
     /* 2227233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2227236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2227243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227247 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2227247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2227250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227258 */   // GIR_Coverage, 1730,
     /* 2227258 */   GIR_EraseRootFromParent_Done,
     /* 2227259 */ // Label 31017: @2227259
     /* 2227259 */ GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2227290), // Rule ID 1731 //
     /* 2227264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2227267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2227274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227278 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2227278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2227281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227289 */   // GIR_Coverage, 1731,
     /* 2227289 */   GIR_EraseRootFromParent_Done,
     /* 2227290 */ // Label 31018: @2227290
     /* 2227290 */ GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2227321), // Rule ID 1756 //
     /* 2227295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2227298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2227305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227309 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2227309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2227312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227320 */   // GIR_Coverage, 1756,
     /* 2227320 */   GIR_EraseRootFromParent_Done,
     /* 2227321 */ // Label 31019: @2227321
     /* 2227321 */ GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2227352), // Rule ID 1757 //
     /* 2227326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2227329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2227336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227340 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2227340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2227343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227345 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2227350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227351 */   // GIR_Coverage, 1757,
     /* 2227351 */   GIR_EraseRootFromParent_Done,
     /* 2227352 */ // Label 31020: @2227352
     /* 2227352 */ GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2227383), // Rule ID 1785 //
     /* 2227357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2227360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2227367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227371 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2227371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2227374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227376 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227382 */   // GIR_Coverage, 1785,
     /* 2227382 */   GIR_EraseRootFromParent_Done,
     /* 2227383 */ // Label 31021: @2227383
     /* 2227383 */ GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2227414), // Rule ID 1813 //
     /* 2227388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2227391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227402 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2227402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2227405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227407 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227413 */   // GIR_Coverage, 1813,
     /* 2227413 */   GIR_EraseRootFromParent_Done,
     /* 2227414 */ // Label 31022: @2227414
     /* 2227414 */ GIM_Reject,
     /* 2227415 */ // Label 30983: @2227415
     /* 2227415 */ GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2227472), // Rule ID 57738 //
     /* 2227420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2227423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2227426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227434 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2227451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227456 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227471 */   // GIR_Coverage, 57738,
     /* 2227471 */   GIR_EraseRootFromParent_Done,
     /* 2227472 */ // Label 31023: @2227472
     /* 2227472 */ GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2227529), // Rule ID 57739 //
     /* 2227477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2227480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2227483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227491 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2227508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227513 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227528 */   // GIR_Coverage, 57739,
     /* 2227528 */   GIR_EraseRootFromParent_Done,
     /* 2227529 */ // Label 31024: @2227529
     /* 2227529 */ GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2227583), // Rule ID 57922 //
     /* 2227534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2227537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2227540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227548 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2227565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227582 */   // GIR_Coverage, 57922,
     /* 2227582 */   GIR_EraseRootFromParent_Done,
     /* 2227583 */ // Label 31025: @2227583
     /* 2227583 */ GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2227637), // Rule ID 57923 //
     /* 2227588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2227591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2227594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227602 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2227619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227636 */   // GIR_Coverage, 57923,
     /* 2227636 */   GIR_EraseRootFromParent_Done,
     /* 2227637 */ // Label 31026: @2227637
     /* 2227637 */ GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2227694), // Rule ID 58130 //
     /* 2227642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2227645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2227648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227656 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2227673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227693 */   // GIR_Coverage, 58130,
     /* 2227693 */   GIR_EraseRootFromParent_Done,
     /* 2227694 */ // Label 31027: @2227694
     /* 2227694 */ GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2227751), // Rule ID 58131 //
     /* 2227699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2227702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2227705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227713 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2227730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227735 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227750 */   // GIR_Coverage, 58131,
     /* 2227750 */   GIR_EraseRootFromParent_Done,
     /* 2227751 */ // Label 31028: @2227751
     /* 2227751 */ GIM_Reject,
     /* 2227752 */ // Label 30984: @2227752
     /* 2227752 */ GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2227809), // Rule ID 57746 //
     /* 2227757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2227760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2227763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227771 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2227788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227793 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227808 */   // GIR_Coverage, 57746,
     /* 2227808 */   GIR_EraseRootFromParent_Done,
     /* 2227809 */ // Label 31029: @2227809
     /* 2227809 */ GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2227866), // Rule ID 57747 //
     /* 2227814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2227817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2227820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227828 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2227845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227850 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2227855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227865 */   // GIR_Coverage, 57747,
     /* 2227865 */   GIR_EraseRootFromParent_Done,
     /* 2227866 */ // Label 31030: @2227866
     /* 2227866 */ GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2227920), // Rule ID 57946 //
     /* 2227871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2227874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2227877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227885 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2227902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227907 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227919 */   // GIR_Coverage, 57946,
     /* 2227919 */   GIR_EraseRootFromParent_Done,
     /* 2227920 */ // Label 31031: @2227920
     /* 2227920 */ GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2227974), // Rule ID 57947 //
     /* 2227925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2227928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2227931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227939 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2227956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227973 */   // GIR_Coverage, 57947,
     /* 2227973 */   GIR_EraseRootFromParent_Done,
     /* 2227974 */ // Label 31032: @2227974
     /* 2227974 */ GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2228031), // Rule ID 58150 //
     /* 2227979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2227982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2227985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227993 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2228010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228030 */   // GIR_Coverage, 58150,
     /* 2228030 */   GIR_EraseRootFromParent_Done,
     /* 2228031 */ // Label 31033: @2228031
     /* 2228031 */ GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2228088), // Rule ID 58151 //
     /* 2228036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2228039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228050 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2228067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228072 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228087 */   // GIR_Coverage, 58151,
     /* 2228087 */   GIR_EraseRootFromParent_Done,
     /* 2228088 */ // Label 31034: @2228088
     /* 2228088 */ GIM_Reject,
     /* 2228089 */ // Label 30985: @2228089
     /* 2228089 */ GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2228146), // Rule ID 57758 //
     /* 2228094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2228097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228108 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2228125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228130 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228145 */   // GIR_Coverage, 57758,
     /* 2228145 */   GIR_EraseRootFromParent_Done,
     /* 2228146 */ // Label 31035: @2228146
     /* 2228146 */ GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2228203), // Rule ID 57759 //
     /* 2228151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2228154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228165 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2228182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228202 */   // GIR_Coverage, 57759,
     /* 2228202 */   GIR_EraseRootFromParent_Done,
     /* 2228203 */ // Label 31036: @2228203
     /* 2228203 */ GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2228257), // Rule ID 57966 //
     /* 2228208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2228211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228222 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2228239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228256 */   // GIR_Coverage, 57966,
     /* 2228256 */   GIR_EraseRootFromParent_Done,
     /* 2228257 */ // Label 31037: @2228257
     /* 2228257 */ GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2228311), // Rule ID 57967 //
     /* 2228262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2228265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228276 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2228293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228298 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228310 */   // GIR_Coverage, 57967,
     /* 2228310 */   GIR_EraseRootFromParent_Done,
     /* 2228311 */ // Label 31038: @2228311
     /* 2228311 */ GIM_Reject,
     /* 2228312 */ // Label 30986: @2228312
     /* 2228312 */ GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2228369), // Rule ID 57742 //
     /* 2228317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2228320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228331 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2228348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228353 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228368 */   // GIR_Coverage, 57742,
     /* 2228368 */   GIR_EraseRootFromParent_Done,
     /* 2228369 */ // Label 31039: @2228369
     /* 2228369 */ GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2228426), // Rule ID 57743 //
     /* 2228374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2228377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228388 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2228405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228410 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228425 */   // GIR_Coverage, 57743,
     /* 2228425 */   GIR_EraseRootFromParent_Done,
     /* 2228426 */ // Label 31040: @2228426
     /* 2228426 */ GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2228480), // Rule ID 57926 //
     /* 2228431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2228434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228445 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2228462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228467 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228479 */   // GIR_Coverage, 57926,
     /* 2228479 */   GIR_EraseRootFromParent_Done,
     /* 2228480 */ // Label 31041: @2228480
     /* 2228480 */ GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2228534), // Rule ID 57927 //
     /* 2228485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2228488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228499 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2228516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228533 */   // GIR_Coverage, 57927,
     /* 2228533 */   GIR_EraseRootFromParent_Done,
     /* 2228534 */ // Label 31042: @2228534
     /* 2228534 */ GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2228591), // Rule ID 58134 //
     /* 2228539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2228542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228553 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2228570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228575 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228590 */   // GIR_Coverage, 58134,
     /* 2228590 */   GIR_EraseRootFromParent_Done,
     /* 2228591 */ // Label 31043: @2228591
     /* 2228591 */ GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2228648), // Rule ID 58135 //
     /* 2228596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2228599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228610 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2228627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228632 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228647 */   // GIR_Coverage, 58135,
     /* 2228647 */   GIR_EraseRootFromParent_Done,
     /* 2228648 */ // Label 31044: @2228648
     /* 2228648 */ GIM_Reject,
     /* 2228649 */ // Label 30987: @2228649
     /* 2228649 */ GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2228706), // Rule ID 57754 //
     /* 2228654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2228657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228668 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2228685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228690 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228705 */   // GIR_Coverage, 57754,
     /* 2228705 */   GIR_EraseRootFromParent_Done,
     /* 2228706 */ // Label 31045: @2228706
     /* 2228706 */ GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2228763), // Rule ID 57755 //
     /* 2228711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2228714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228725 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228725 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228732 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2228742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228747 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228762 */   // GIR_Coverage, 57755,
     /* 2228762 */   GIR_EraseRootFromParent_Done,
     /* 2228763 */ // Label 31046: @2228763
     /* 2228763 */ GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2228817), // Rule ID 57950 //
     /* 2228768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2228771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228782 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2228799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228816 */   // GIR_Coverage, 57950,
     /* 2228816 */   GIR_EraseRootFromParent_Done,
     /* 2228817 */ // Label 31047: @2228817
     /* 2228817 */ GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2228871), // Rule ID 57951 //
     /* 2228822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2228825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228836 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2228853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228870 */   // GIR_Coverage, 57951,
     /* 2228870 */   GIR_EraseRootFromParent_Done,
     /* 2228871 */ // Label 31048: @2228871
     /* 2228871 */ GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2228928), // Rule ID 58154 //
     /* 2228876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2228879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2228882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228890 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2228907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228927 */   // GIR_Coverage, 58154,
     /* 2228927 */   GIR_EraseRootFromParent_Done,
     /* 2228928 */ // Label 31049: @2228928
     /* 2228928 */ GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2228985), // Rule ID 58155 //
     /* 2228933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2228936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2228939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228947 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2228964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228969 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2228974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228984 */   // GIR_Coverage, 58155,
     /* 2228984 */   GIR_EraseRootFromParent_Done,
     /* 2228985 */ // Label 31050: @2228985
     /* 2228985 */ GIM_Reject,
     /* 2228986 */ // Label 30988: @2228986
     /* 2228986 */ GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2229043), // Rule ID 57786 //
     /* 2228991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2228994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2228997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229005 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2229022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229041 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229042 */   // GIR_Coverage, 57786,
     /* 2229042 */   GIR_EraseRootFromParent_Done,
     /* 2229043 */ // Label 31051: @2229043
     /* 2229043 */ GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2229100), // Rule ID 57787 //
     /* 2229048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2229051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2229054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229062 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2229079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229084 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229099 */   // GIR_Coverage, 57787,
     /* 2229099 */   GIR_EraseRootFromParent_Done,
     /* 2229100 */ // Label 31052: @2229100
     /* 2229100 */ GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2229154), // Rule ID 57970 //
     /* 2229105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2229108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2229111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229119 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2229136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229153 */   // GIR_Coverage, 57970,
     /* 2229153 */   GIR_EraseRootFromParent_Done,
     /* 2229154 */ // Label 31053: @2229154
     /* 2229154 */ GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2229208), // Rule ID 57971 //
     /* 2229159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2229162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2229165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229173 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2229190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229195 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229207 */   // GIR_Coverage, 57971,
     /* 2229207 */   GIR_EraseRootFromParent_Done,
     /* 2229208 */ // Label 31054: @2229208
     /* 2229208 */ GIM_Reject,
     /* 2229209 */ // Label 30989: @2229209
     /* 2229209 */ GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2229266), // Rule ID 57750 //
     /* 2229214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2229217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229228 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2229245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229250 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229265 */   // GIR_Coverage, 57750,
     /* 2229265 */   GIR_EraseRootFromParent_Done,
     /* 2229266 */ // Label 31055: @2229266
     /* 2229266 */ GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2229323), // Rule ID 57751 //
     /* 2229271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2229274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229285 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2229302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229307 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229322 */   // GIR_Coverage, 57751,
     /* 2229322 */   GIR_EraseRootFromParent_Done,
     /* 2229323 */ // Label 31056: @2229323
     /* 2229323 */ GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2229377), // Rule ID 57930 //
     /* 2229328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2229331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2229334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229342 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2229359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229364 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229376 */   // GIR_Coverage, 57930,
     /* 2229376 */   GIR_EraseRootFromParent_Done,
     /* 2229377 */ // Label 31057: @2229377
     /* 2229377 */ GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2229431), // Rule ID 57931 //
     /* 2229382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2229385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2229388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229396 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2229413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229418 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229430 */   // GIR_Coverage, 57931,
     /* 2229430 */   GIR_EraseRootFromParent_Done,
     /* 2229431 */ // Label 31058: @2229431
     /* 2229431 */ GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2229488), // Rule ID 58138 //
     /* 2229436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2229439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229450 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2229467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229487 */   // GIR_Coverage, 58138,
     /* 2229487 */   GIR_EraseRootFromParent_Done,
     /* 2229488 */ // Label 31059: @2229488
     /* 2229488 */ GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2229545), // Rule ID 58139 //
     /* 2229493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2229496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229507 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2229524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229529 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229544 */   // GIR_Coverage, 58139,
     /* 2229544 */   GIR_EraseRootFromParent_Done,
     /* 2229545 */ // Label 31060: @2229545
     /* 2229545 */ GIM_Reject,
     /* 2229546 */ // Label 30990: @2229546
     /* 2229546 */ GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2229603), // Rule ID 57774 //
     /* 2229551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2229554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229565 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2229582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229602 */   // GIR_Coverage, 57774,
     /* 2229602 */   GIR_EraseRootFromParent_Done,
     /* 2229603 */ // Label 31061: @2229603
     /* 2229603 */ GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2229660), // Rule ID 57775 //
     /* 2229608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2229611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229622 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2229639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229659 */   // GIR_Coverage, 57775,
     /* 2229659 */   GIR_EraseRootFromParent_Done,
     /* 2229660 */ // Label 31062: @2229660
     /* 2229660 */ GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2229714), // Rule ID 57954 //
     /* 2229665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2229668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229679 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2229696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229701 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229713 */   // GIR_Coverage, 57954,
     /* 2229713 */   GIR_EraseRootFromParent_Done,
     /* 2229714 */ // Label 31063: @2229714
     /* 2229714 */ GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2229768), // Rule ID 57955 //
     /* 2229719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2229722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229733 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2229750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229755 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229767 */   // GIR_Coverage, 57955,
     /* 2229767 */   GIR_EraseRootFromParent_Done,
     /* 2229768 */ // Label 31064: @2229768
     /* 2229768 */ GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2229825), // Rule ID 58158 //
     /* 2229773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2229776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229787 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2229804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229809 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229824 */   // GIR_Coverage, 58158,
     /* 2229824 */   GIR_EraseRootFromParent_Done,
     /* 2229825 */ // Label 31065: @2229825
     /* 2229825 */ GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2229882), // Rule ID 58159 //
     /* 2229830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2229833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229844 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2229861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229881 */   // GIR_Coverage, 58159,
     /* 2229881 */   GIR_EraseRootFromParent_Done,
     /* 2229882 */ // Label 31066: @2229882
     /* 2229882 */ GIM_Reject,
     /* 2229883 */ // Label 30991: @2229883
     /* 2229883 */ GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2229940), // Rule ID 57790 //
     /* 2229888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2229891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229902 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2229919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229939 */   // GIR_Coverage, 57790,
     /* 2229939 */   GIR_EraseRootFromParent_Done,
     /* 2229940 */ // Label 31067: @2229940
     /* 2229940 */ GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2229997), // Rule ID 57791 //
     /* 2229945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2229948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229959 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2229976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229981 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2229986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229996 */   // GIR_Coverage, 57791,
     /* 2229996 */   GIR_EraseRootFromParent_Done,
     /* 2229997 */ // Label 31068: @2229997
     /* 2229997 */ GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2230051), // Rule ID 57974 //
     /* 2230002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2230005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2230008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230016 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2230019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2230033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230038 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230050 */   // GIR_Coverage, 57974,
     /* 2230050 */   GIR_EraseRootFromParent_Done,
     /* 2230051 */ // Label 31069: @2230051
     /* 2230051 */ GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2230105), // Rule ID 57975 //
     /* 2230056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2230059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2230062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230070 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2230073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2230087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230092 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230104 */   // GIR_Coverage, 57975,
     /* 2230104 */   GIR_EraseRootFromParent_Done,
     /* 2230105 */ // Label 31070: @2230105
     /* 2230105 */ GIM_Reject,
     /* 2230106 */ // Label 30992: @2230106
     /* 2230106 */ GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2230163), // Rule ID 57762 //
     /* 2230111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2230114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2230117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230125 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2230142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230162 */   // GIR_Coverage, 57762,
     /* 2230162 */   GIR_EraseRootFromParent_Done,
     /* 2230163 */ // Label 31071: @2230163
     /* 2230163 */ GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2230220), // Rule ID 57763 //
     /* 2230168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2230171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2230174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230182 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2230199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230204 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230219 */   // GIR_Coverage, 57763,
     /* 2230219 */   GIR_EraseRootFromParent_Done,
     /* 2230220 */ // Label 31072: @2230220
     /* 2230220 */ GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2230274), // Rule ID 57934 //
     /* 2230225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2230228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2230231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230239 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2230256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230273 */   // GIR_Coverage, 57934,
     /* 2230273 */   GIR_EraseRootFromParent_Done,
     /* 2230274 */ // Label 31073: @2230274
     /* 2230274 */ GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2230328), // Rule ID 57935 //
     /* 2230279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2230282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2230285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230293 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2230310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230315 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230327 */   // GIR_Coverage, 57935,
     /* 2230327 */   GIR_EraseRootFromParent_Done,
     /* 2230328 */ // Label 31074: @2230328
     /* 2230328 */ GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2230385), // Rule ID 58142 //
     /* 2230333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2230336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230347 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2230364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230369 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230384 */   // GIR_Coverage, 58142,
     /* 2230384 */   GIR_EraseRootFromParent_Done,
     /* 2230385 */ // Label 31075: @2230385
     /* 2230385 */ GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2230442), // Rule ID 58143 //
     /* 2230390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2230393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230404 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2230421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230426 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230441 */   // GIR_Coverage, 58143,
     /* 2230441 */   GIR_EraseRootFromParent_Done,
     /* 2230442 */ // Label 31076: @2230442
     /* 2230442 */ GIM_Reject,
     /* 2230443 */ // Label 30993: @2230443
     /* 2230443 */ GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2230500), // Rule ID 57778 //
     /* 2230448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2230451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230462 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2230479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230484 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230499 */   // GIR_Coverage, 57778,
     /* 2230499 */   GIR_EraseRootFromParent_Done,
     /* 2230500 */ // Label 31077: @2230500
     /* 2230500 */ GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2230557), // Rule ID 57779 //
     /* 2230505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2230508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230519 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2230536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230556 */   // GIR_Coverage, 57779,
     /* 2230556 */   GIR_EraseRootFromParent_Done,
     /* 2230557 */ // Label 31078: @2230557
     /* 2230557 */ GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2230611), // Rule ID 57958 //
     /* 2230562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2230565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2230568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230576 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2230593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230598 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230610 */   // GIR_Coverage, 57958,
     /* 2230610 */   GIR_EraseRootFromParent_Done,
     /* 2230611 */ // Label 31079: @2230611
     /* 2230611 */ GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2230665), // Rule ID 57959 //
     /* 2230616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2230619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2230622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230630 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2230647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230652 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230664 */   // GIR_Coverage, 57959,
     /* 2230664 */   GIR_EraseRootFromParent_Done,
     /* 2230665 */ // Label 31080: @2230665
     /* 2230665 */ GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2230722), // Rule ID 58162 //
     /* 2230670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2230673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230684 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2230701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230706 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230720 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230721 */   // GIR_Coverage, 58162,
     /* 2230721 */   GIR_EraseRootFromParent_Done,
     /* 2230722 */ // Label 31081: @2230722
     /* 2230722 */ GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2230779), // Rule ID 58163 //
     /* 2230727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2230730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230741 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2230758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230763 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230778 */   // GIR_Coverage, 58163,
     /* 2230778 */   GIR_EraseRootFromParent_Done,
     /* 2230779 */ // Label 31082: @2230779
     /* 2230779 */ GIM_Reject,
     /* 2230780 */ // Label 30994: @2230780
     /* 2230780 */ GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2230837), // Rule ID 57794 //
     /* 2230785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2230788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230799 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2230816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230836 */   // GIR_Coverage, 57794,
     /* 2230836 */   GIR_EraseRootFromParent_Done,
     /* 2230837 */ // Label 31083: @2230837
     /* 2230837 */ GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2230894), // Rule ID 57795 //
     /* 2230842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2230845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230856 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2230873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2230883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230893 */   // GIR_Coverage, 57795,
     /* 2230893 */   GIR_EraseRootFromParent_Done,
     /* 2230894 */ // Label 31084: @2230894
     /* 2230894 */ GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2230948), // Rule ID 57978 //
     /* 2230899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2230902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230913 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2230930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230947 */   // GIR_Coverage, 57978,
     /* 2230947 */   GIR_EraseRootFromParent_Done,
     /* 2230948 */ // Label 31085: @2230948
     /* 2230948 */ GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2231002), // Rule ID 57979 //
     /* 2230953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2230956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230967 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2230984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230989 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231001 */   // GIR_Coverage, 57979,
     /* 2231001 */   GIR_EraseRootFromParent_Done,
     /* 2231002 */ // Label 31086: @2231002
     /* 2231002 */ GIM_Reject,
     /* 2231003 */ // Label 30995: @2231003
     /* 2231003 */ GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2231060), // Rule ID 57766 //
     /* 2231008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2231011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2231014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231022 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2231039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231059 */   // GIR_Coverage, 57766,
     /* 2231059 */   GIR_EraseRootFromParent_Done,
     /* 2231060 */ // Label 31087: @2231060
     /* 2231060 */ GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2231117), // Rule ID 57767 //
     /* 2231065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2231068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2231071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231079 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2231096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231101 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231116 */   // GIR_Coverage, 57767,
     /* 2231116 */   GIR_EraseRootFromParent_Done,
     /* 2231117 */ // Label 31088: @2231117
     /* 2231117 */ GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2231171), // Rule ID 57938 //
     /* 2231122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2231125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2231128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231136 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2231153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231170 */   // GIR_Coverage, 57938,
     /* 2231170 */   GIR_EraseRootFromParent_Done,
     /* 2231171 */ // Label 31089: @2231171
     /* 2231171 */ GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2231225), // Rule ID 57939 //
     /* 2231176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2231179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2231182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231190 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2231207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231212 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231224 */   // GIR_Coverage, 57939,
     /* 2231224 */   GIR_EraseRootFromParent_Done,
     /* 2231225 */ // Label 31090: @2231225
     /* 2231225 */ GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2231282), // Rule ID 58146 //
     /* 2231230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2231233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2231236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231244 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2231261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231281 */   // GIR_Coverage, 58146,
     /* 2231281 */   GIR_EraseRootFromParent_Done,
     /* 2231282 */ // Label 31091: @2231282
     /* 2231282 */ GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2231339), // Rule ID 58147 //
     /* 2231287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2231290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2231293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231301 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2231304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2231318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231338 */   // GIR_Coverage, 58147,
     /* 2231338 */   GIR_EraseRootFromParent_Done,
     /* 2231339 */ // Label 31092: @2231339
     /* 2231339 */ GIM_Reject,
     /* 2231340 */ // Label 30996: @2231340
     /* 2231340 */ GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2231397), // Rule ID 57782 //
     /* 2231345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2231348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2231351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231359 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2231362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2231376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231396 */   // GIR_Coverage, 57782,
     /* 2231396 */   GIR_EraseRootFromParent_Done,
     /* 2231397 */ // Label 31093: @2231397
     /* 2231397 */ GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2231454), // Rule ID 57783 //
     /* 2231402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2231405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2231408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231416 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2231419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2231433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231438 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231453 */   // GIR_Coverage, 57783,
     /* 2231453 */   GIR_EraseRootFromParent_Done,
     /* 2231454 */ // Label 31094: @2231454
     /* 2231454 */ GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2231508), // Rule ID 57962 //
     /* 2231459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2231462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2231465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231473 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2231476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2231490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231495 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231507 */   // GIR_Coverage, 57962,
     /* 2231507 */   GIR_EraseRootFromParent_Done,
     /* 2231508 */ // Label 31095: @2231508
     /* 2231508 */ GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2231562), // Rule ID 57963 //
     /* 2231513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2231516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2231519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231527 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2231530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2231544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231549 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231561 */   // GIR_Coverage, 57963,
     /* 2231561 */   GIR_EraseRootFromParent_Done,
     /* 2231562 */ // Label 31096: @2231562
     /* 2231562 */ GIM_Reject,
     /* 2231563 */ // Label 30997: @2231563
     /* 2231563 */ GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2231620), // Rule ID 57770 //
     /* 2231568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2231571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2231574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231582 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2231599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231619 */   // GIR_Coverage, 57770,
     /* 2231619 */   GIR_EraseRootFromParent_Done,
     /* 2231620 */ // Label 31097: @2231620
     /* 2231620 */ GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2231677), // Rule ID 57771 //
     /* 2231625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2231628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2231631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231639 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2231656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2231666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231676 */   // GIR_Coverage, 57771,
     /* 2231676 */   GIR_EraseRootFromParent_Done,
     /* 2231677 */ // Label 31098: @2231677
     /* 2231677 */ GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2231731), // Rule ID 57942 //
     /* 2231682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2231685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2231688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231696 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2231713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231718 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231730 */   // GIR_Coverage, 57942,
     /* 2231730 */   GIR_EraseRootFromParent_Done,
     /* 2231731 */ // Label 31099: @2231731
     /* 2231731 */ GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2231785), // Rule ID 57943 //
     /* 2231736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2231739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2231742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231750 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2231767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231772 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231784 */   // GIR_Coverage, 57943,
     /* 2231784 */   GIR_EraseRootFromParent_Done,
     /* 2231785 */ // Label 31100: @2231785
     /* 2231785 */ GIM_Reject,
     /* 2231786 */ // Label 30998: @2231786
     /* 2231786 */ GIM_Reject,
     /* 2231787 */ // Label 69: @2231787
     /* 2231787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31119*/ GIMT_Encode4(2233757),
     /* 2231798 */ /*GILLT_s16*//*Label 31101*/ GIMT_Encode4(2231918),
     /* 2231802 */ /*GILLT_s32*//*Label 31102*/ GIMT_Encode4(2231982),
     /* 2231806 */ /*GILLT_s64*//*Label 31103*/ GIMT_Encode4(2232046), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231818 */ /*GILLT_nxv1s16*//*Label 31104*/ GIMT_Encode4(2232137),
     /* 2231822 */ /*GILLT_nxv1s32*//*Label 31105*/ GIMT_Encode4(2232245),
     /* 2231826 */ /*GILLT_nxv1s64*//*Label 31106*/ GIMT_Encode4(2232353), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231838 */ /*GILLT_nxv2s16*//*Label 31107*/ GIMT_Encode4(2232461),
     /* 2231842 */ /*GILLT_nxv2s32*//*Label 31108*/ GIMT_Encode4(2232569),
     /* 2231846 */ /*GILLT_nxv2s64*//*Label 31109*/ GIMT_Encode4(2232677), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231858 */ /*GILLT_nxv4s16*//*Label 31110*/ GIMT_Encode4(2232785),
     /* 2231862 */ /*GILLT_nxv4s32*//*Label 31111*/ GIMT_Encode4(2232893),
     /* 2231866 */ /*GILLT_nxv4s64*//*Label 31112*/ GIMT_Encode4(2233001), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231878 */ /*GILLT_nxv8s16*//*Label 31113*/ GIMT_Encode4(2233109),
     /* 2231882 */ /*GILLT_nxv8s32*//*Label 31114*/ GIMT_Encode4(2233217),
     /* 2231886 */ /*GILLT_nxv8s64*//*Label 31115*/ GIMT_Encode4(2233325), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231898 */ /*GILLT_nxv16s16*//*Label 31116*/ GIMT_Encode4(2233433),
     /* 2231902 */ /*GILLT_nxv16s32*//*Label 31117*/ GIMT_Encode4(2233541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2231914 */ /*GILLT_nxv32s16*//*Label 31118*/ GIMT_Encode4(2233649),
     /* 2231918 */ // Label 31101: @2231918
     /* 2231918 */ GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2231981),
     /* 2231923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2231926 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2231953), // Rule ID 1851 //
     /* 2231931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2231934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2231938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2231942 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2231942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2231945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231952 */     // GIR_Coverage, 1851,
     /* 2231952 */     GIR_EraseRootFromParent_Done,
     /* 2231953 */   // Label 31121: @2231953
     /* 2231953 */   GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2231980), // Rule ID 1884 //
     /* 2231958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2231961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2231965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2231969 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2231969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2231972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231979 */     // GIR_Coverage, 1884,
     /* 2231979 */     GIR_EraseRootFromParent_Done,
     /* 2231980 */   // Label 31122: @2231980
     /* 2231980 */   GIM_Reject,
     /* 2231981 */ // Label 31120: @2231981
     /* 2231981 */ GIM_Reject,
     /* 2231982 */ // Label 31102: @2231982
     /* 2231982 */ GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2232045),
     /* 2231987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2231990 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2232017), // Rule ID 1142 //
     /* 2231995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2231998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2232002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2232006 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2232006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2232009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232016 */     // GIR_Coverage, 1142,
     /* 2232016 */     GIR_EraseRootFromParent_Done,
     /* 2232017 */   // Label 31124: @2232017
     /* 2232017 */   GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2232044), // Rule ID 1150 //
     /* 2232022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2232025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2232029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2232033 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2232033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2232036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232043 */     // GIR_Coverage, 1150,
     /* 2232043 */     GIR_EraseRootFromParent_Done,
     /* 2232044 */   // Label 31125: @2232044
     /* 2232044 */   GIM_Reject,
     /* 2232045 */ // Label 31123: @2232045
     /* 2232045 */ GIM_Reject,
     /* 2232046 */ // Label 31103: @2232046
     /* 2232046 */ GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2232136),
     /* 2232051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2232054 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2232081), // Rule ID 1485 //
     /* 2232059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2232062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2232066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2232070 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2232070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2232073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232080 */     // GIR_Coverage, 1485,
     /* 2232080 */     GIR_EraseRootFromParent_Done,
     /* 2232081 */   // Label 31127: @2232081
     /* 2232081 */   GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2232108), // Rule ID 1518 //
     /* 2232086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2232089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232097 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2232097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2232100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232107 */     // GIR_Coverage, 1518,
     /* 2232107 */     GIR_EraseRootFromParent_Done,
     /* 2232108 */   // Label 31128: @2232108
     /* 2232108 */   GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2232135), // Rule ID 1540 //
     /* 2232113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2232116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2232120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2232124 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2232124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2232127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232134 */     // GIR_Coverage, 1540,
     /* 2232134 */     GIR_EraseRootFromParent_Done,
     /* 2232135 */   // Label 31129: @2232135
     /* 2232135 */   GIM_Reject,
     /* 2232136 */ // Label 31126: @2232136
     /* 2232136 */ GIM_Reject,
     /* 2232137 */ // Label 31104: @2232137
     /* 2232137 */ GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2232244),
     /* 2232142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2232145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232153 */   GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2232198), // Rule ID 55694 //
     /* 2232158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2232161 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2232164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2232178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232197 */     // GIR_Coverage, 55694,
     /* 2232197 */     GIR_EraseRootFromParent_Done,
     /* 2232198 */   // Label 31131: @2232198
     /* 2232198 */   GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2232243), // Rule ID 55695 //
     /* 2232203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2232206 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2232209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2232223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232242 */     // GIR_Coverage, 55695,
     /* 2232242 */     GIR_EraseRootFromParent_Done,
     /* 2232243 */   // Label 31132: @2232243
     /* 2232243 */   GIM_Reject,
     /* 2232244 */ // Label 31130: @2232244
     /* 2232244 */ GIM_Reject,
     /* 2232245 */ // Label 31105: @2232245
     /* 2232245 */ GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2232352),
     /* 2232250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2232253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232261 */   GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2232306), // Rule ID 55734 //
     /* 2232266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2232269 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2232272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2232286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232305 */     // GIR_Coverage, 55734,
     /* 2232305 */     GIR_EraseRootFromParent_Done,
     /* 2232306 */   // Label 31134: @2232306
     /* 2232306 */   GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2232351), // Rule ID 55735 //
     /* 2232311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2232314 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2232317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2232331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232350 */     // GIR_Coverage, 55735,
     /* 2232350 */     GIR_EraseRootFromParent_Done,
     /* 2232351 */   // Label 31135: @2232351
     /* 2232351 */   GIM_Reject,
     /* 2232352 */ // Label 31133: @2232352
     /* 2232352 */ GIM_Reject,
     /* 2232353 */ // Label 31106: @2232353
     /* 2232353 */ GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2232460),
     /* 2232358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2232361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232369 */   GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2232414), // Rule ID 55794 //
     /* 2232374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2232377 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2232380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2232394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232413 */     // GIR_Coverage, 55794,
     /* 2232413 */     GIR_EraseRootFromParent_Done,
     /* 2232414 */   // Label 31137: @2232414
     /* 2232414 */   GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2232459), // Rule ID 55795 //
     /* 2232419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2232422 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2232425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2232439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232458 */     // GIR_Coverage, 55795,
     /* 2232458 */     GIR_EraseRootFromParent_Done,
     /* 2232459 */   // Label 31138: @2232459
     /* 2232459 */   GIM_Reject,
     /* 2232460 */ // Label 31136: @2232460
     /* 2232460 */ GIM_Reject,
     /* 2232461 */ // Label 31107: @2232461
     /* 2232461 */ GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2232568),
     /* 2232466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2232469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232477 */   GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2232522), // Rule ID 55714 //
     /* 2232482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2232485 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2232502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232521 */     // GIR_Coverage, 55714,
     /* 2232521 */     GIR_EraseRootFromParent_Done,
     /* 2232522 */   // Label 31140: @2232522
     /* 2232522 */   GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2232567), // Rule ID 55715 //
     /* 2232527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2232530 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2232547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232566 */     // GIR_Coverage, 55715,
     /* 2232566 */     GIR_EraseRootFromParent_Done,
     /* 2232567 */   // Label 31141: @2232567
     /* 2232567 */   GIM_Reject,
     /* 2232568 */ // Label 31139: @2232568
     /* 2232568 */ GIM_Reject,
     /* 2232569 */ // Label 31108: @2232569
     /* 2232569 */ GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2232676),
     /* 2232574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2232577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232585 */   GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2232630), // Rule ID 55774 //
     /* 2232590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2232593 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2232610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232629 */     // GIR_Coverage, 55774,
     /* 2232629 */     GIR_EraseRootFromParent_Done,
     /* 2232630 */   // Label 31143: @2232630
     /* 2232630 */   GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2232675), // Rule ID 55775 //
     /* 2232635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2232638 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2232655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232674 */     // GIR_Coverage, 55775,
     /* 2232674 */     GIR_EraseRootFromParent_Done,
     /* 2232675 */   // Label 31144: @2232675
     /* 2232675 */   GIM_Reject,
     /* 2232676 */ // Label 31142: @2232676
     /* 2232676 */ GIM_Reject,
     /* 2232677 */ // Label 31109: @2232677
     /* 2232677 */ GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2232784),
     /* 2232682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2232685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232693 */   GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2232738), // Rule ID 55934 //
     /* 2232698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2232701 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2232718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232737 */     // GIR_Coverage, 55934,
     /* 2232737 */     GIR_EraseRootFromParent_Done,
     /* 2232738 */   // Label 31146: @2232738
     /* 2232738 */   GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2232783), // Rule ID 55935 //
     /* 2232743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2232746 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2232763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232782 */     // GIR_Coverage, 55935,
     /* 2232782 */     GIR_EraseRootFromParent_Done,
     /* 2232783 */   // Label 31147: @2232783
     /* 2232783 */   GIM_Reject,
     /* 2232784 */ // Label 31145: @2232784
     /* 2232784 */ GIM_Reject,
     /* 2232785 */ // Label 31110: @2232785
     /* 2232785 */ GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2232892),
     /* 2232790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2232793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232801 */   GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2232846), // Rule ID 55754 //
     /* 2232806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2232809 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2232826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232845 */     // GIR_Coverage, 55754,
     /* 2232845 */     GIR_EraseRootFromParent_Done,
     /* 2232846 */   // Label 31149: @2232846
     /* 2232846 */   GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2232891), // Rule ID 55755 //
     /* 2232851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2232854 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2232871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232890 */     // GIR_Coverage, 55755,
     /* 2232890 */     GIR_EraseRootFromParent_Done,
     /* 2232891 */   // Label 31150: @2232891
     /* 2232891 */   GIM_Reject,
     /* 2232892 */ // Label 31148: @2232892
     /* 2232892 */ GIM_Reject,
     /* 2232893 */ // Label 31111: @2232893
     /* 2232893 */ GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2233000),
     /* 2232898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232909 */   GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2232954), // Rule ID 55874 //
     /* 2232914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2232917 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2232934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232953 */     // GIR_Coverage, 55874,
     /* 2232953 */     GIR_EraseRootFromParent_Done,
     /* 2232954 */   // Label 31152: @2232954
     /* 2232954 */   GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2232999), // Rule ID 55875 //
     /* 2232959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2232962 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2232979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2232988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232998 */     // GIR_Coverage, 55875,
     /* 2232998 */     GIR_EraseRootFromParent_Done,
     /* 2232999 */   // Label 31153: @2232999
     /* 2232999 */   GIM_Reject,
     /* 2233000 */ // Label 31151: @2233000
     /* 2233000 */ GIM_Reject,
     /* 2233001 */ // Label 31112: @2233001
     /* 2233001 */ GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2233108),
     /* 2233006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2233009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233017 */   GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2233062), // Rule ID 55954 //
     /* 2233022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2233025 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2233028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2233042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233061 */     // GIR_Coverage, 55954,
     /* 2233061 */     GIR_EraseRootFromParent_Done,
     /* 2233062 */   // Label 31155: @2233062
     /* 2233062 */   GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2233107), // Rule ID 55955 //
     /* 2233067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2233070 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2233073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2233087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233106 */     // GIR_Coverage, 55955,
     /* 2233106 */     GIR_EraseRootFromParent_Done,
     /* 2233107 */   // Label 31156: @2233107
     /* 2233107 */   GIM_Reject,
     /* 2233108 */ // Label 31154: @2233108
     /* 2233108 */ GIM_Reject,
     /* 2233109 */ // Label 31113: @2233109
     /* 2233109 */ GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2233216),
     /* 2233114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2233117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233125 */   GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2233170), // Rule ID 55814 //
     /* 2233130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2233133 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2233136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2233150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233169 */     // GIR_Coverage, 55814,
     /* 2233169 */     GIR_EraseRootFromParent_Done,
     /* 2233170 */   // Label 31158: @2233170
     /* 2233170 */   GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2233215), // Rule ID 55815 //
     /* 2233175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2233178 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2233181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2233195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233214 */     // GIR_Coverage, 55815,
     /* 2233214 */     GIR_EraseRootFromParent_Done,
     /* 2233215 */   // Label 31159: @2233215
     /* 2233215 */   GIM_Reject,
     /* 2233216 */ // Label 31157: @2233216
     /* 2233216 */ GIM_Reject,
     /* 2233217 */ // Label 31114: @2233217
     /* 2233217 */ GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2233324),
     /* 2233222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2233225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233233 */   GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2233278), // Rule ID 55894 //
     /* 2233238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2233241 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2233258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233277 */     // GIR_Coverage, 55894,
     /* 2233277 */     GIR_EraseRootFromParent_Done,
     /* 2233278 */   // Label 31161: @2233278
     /* 2233278 */   GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2233323), // Rule ID 55895 //
     /* 2233283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2233286 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2233303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233322 */     // GIR_Coverage, 55895,
     /* 2233322 */     GIR_EraseRootFromParent_Done,
     /* 2233323 */   // Label 31162: @2233323
     /* 2233323 */   GIM_Reject,
     /* 2233324 */ // Label 31160: @2233324
     /* 2233324 */ GIM_Reject,
     /* 2233325 */ // Label 31115: @2233325
     /* 2233325 */ GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2233432),
     /* 2233330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2233333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233341 */   GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2233386), // Rule ID 55974 //
     /* 2233346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2233349 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2233366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233385 */     // GIR_Coverage, 55974,
     /* 2233385 */     GIR_EraseRootFromParent_Done,
     /* 2233386 */   // Label 31164: @2233386
     /* 2233386 */   GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2233431), // Rule ID 55975 //
     /* 2233391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2233394 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2233411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233430 */     // GIR_Coverage, 55975,
     /* 2233430 */     GIR_EraseRootFromParent_Done,
     /* 2233431 */   // Label 31165: @2233431
     /* 2233431 */   GIM_Reject,
     /* 2233432 */ // Label 31163: @2233432
     /* 2233432 */ GIM_Reject,
     /* 2233433 */ // Label 31116: @2233433
     /* 2233433 */ GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2233540),
     /* 2233438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2233441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233449 */   GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2233494), // Rule ID 55834 //
     /* 2233454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2233457 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2233474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233493 */     // GIR_Coverage, 55834,
     /* 2233493 */     GIR_EraseRootFromParent_Done,
     /* 2233494 */   // Label 31167: @2233494
     /* 2233494 */   GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2233539), // Rule ID 55835 //
     /* 2233499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2233502 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2233519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233538 */     // GIR_Coverage, 55835,
     /* 2233538 */     GIR_EraseRootFromParent_Done,
     /* 2233539 */   // Label 31168: @2233539
     /* 2233539 */   GIM_Reject,
     /* 2233540 */ // Label 31166: @2233540
     /* 2233540 */ GIM_Reject,
     /* 2233541 */ // Label 31117: @2233541
     /* 2233541 */ GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2233648),
     /* 2233546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2233549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233557 */   GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2233602), // Rule ID 55914 //
     /* 2233562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2233565 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2233582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233601 */     // GIR_Coverage, 55914,
     /* 2233601 */     GIR_EraseRootFromParent_Done,
     /* 2233602 */   // Label 31170: @2233602
     /* 2233602 */   GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2233647), // Rule ID 55915 //
     /* 2233607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2233610 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2233627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233646 */     // GIR_Coverage, 55915,
     /* 2233646 */     GIR_EraseRootFromParent_Done,
     /* 2233647 */   // Label 31171: @2233647
     /* 2233647 */   GIM_Reject,
     /* 2233648 */ // Label 31169: @2233648
     /* 2233648 */ GIM_Reject,
     /* 2233649 */ // Label 31118: @2233649
     /* 2233649 */ GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2233756),
     /* 2233654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2233657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233665 */   GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2233710), // Rule ID 55854 //
     /* 2233670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2233673 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2233690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233709 */     // GIR_Coverage, 55854,
     /* 2233709 */     GIR_EraseRootFromParent_Done,
     /* 2233710 */   // Label 31173: @2233710
     /* 2233710 */   GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2233755), // Rule ID 55855 //
     /* 2233715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2233718 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2233735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2233744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233754 */     // GIR_Coverage, 55855,
     /* 2233754 */     GIR_EraseRootFromParent_Done,
     /* 2233755 */   // Label 31174: @2233755
     /* 2233755 */   GIM_Reject,
     /* 2233756 */ // Label 31172: @2233756
     /* 2233756 */ GIM_Reject,
     /* 2233757 */ // Label 31119: @2233757
     /* 2233757 */ GIM_Reject,
     /* 2233758 */ // Label 70: @2233758
     /* 2233758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31193*/ GIMT_Encode4(2239819),
     /* 2233769 */ /*GILLT_s16*//*Label 31175*/ GIMT_Encode4(2233889),
     /* 2233773 */ /*GILLT_s32*//*Label 31176*/ GIMT_Encode4(2234565),
     /* 2233777 */ /*GILLT_s64*//*Label 31177*/ GIMT_Encode4(2235241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233789 */ /*GILLT_nxv1s16*//*Label 31178*/ GIMT_Encode4(2236054),
     /* 2233793 */ /*GILLT_nxv1s32*//*Label 31179*/ GIMT_Encode4(2236305),
     /* 2233797 */ /*GILLT_nxv1s64*//*Label 31180*/ GIMT_Encode4(2236556), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233809 */ /*GILLT_nxv2s16*//*Label 31181*/ GIMT_Encode4(2236807),
     /* 2233813 */ /*GILLT_nxv2s32*//*Label 31182*/ GIMT_Encode4(2237058),
     /* 2233817 */ /*GILLT_nxv2s64*//*Label 31183*/ GIMT_Encode4(2237309), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233829 */ /*GILLT_nxv4s16*//*Label 31184*/ GIMT_Encode4(2237560),
     /* 2233833 */ /*GILLT_nxv4s32*//*Label 31185*/ GIMT_Encode4(2237811),
     /* 2233837 */ /*GILLT_nxv4s64*//*Label 31186*/ GIMT_Encode4(2238062), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233849 */ /*GILLT_nxv8s16*//*Label 31187*/ GIMT_Encode4(2238313),
     /* 2233853 */ /*GILLT_nxv8s32*//*Label 31188*/ GIMT_Encode4(2238564),
     /* 2233857 */ /*GILLT_nxv8s64*//*Label 31189*/ GIMT_Encode4(2238815), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233869 */ /*GILLT_nxv16s16*//*Label 31190*/ GIMT_Encode4(2239066),
     /* 2233873 */ /*GILLT_nxv16s32*//*Label 31191*/ GIMT_Encode4(2239317), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2233885 */ /*GILLT_nxv32s16*//*Label 31192*/ GIMT_Encode4(2239568),
     /* 2233889 */ // Label 31175: @2233889
     /* 2233889 */ GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2234564),
     /* 2233894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2233897 */   GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2233948), // Rule ID 1856 //
     /* 2233902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2233905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2233908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2233912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2233916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2233924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2233928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2233933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233935 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2233935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2233938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2233946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233947 */     // GIR_Coverage, 1856,
     /* 2233947 */     GIR_EraseRootFromParent_Done,
     /* 2233948 */   // Label 31195: @2233948
     /* 2233948 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2233999), // Rule ID 1889 //
     /* 2233953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2233956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2233959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2233963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2233967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2233975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2233979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2233984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233986 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2233986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2233989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2233997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233998 */     // GIR_Coverage, 1889,
     /* 2233998 */     GIR_EraseRootFromParent_Done,
     /* 2233999 */   // Label 31196: @2233999
     /* 2233999 */   GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2234029), // Rule ID 1854 //
     /* 2234004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2234007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2234010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234022 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2234022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2234027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234028 */     // GIR_Coverage, 1854,
     /* 2234028 */     GIR_Done,
     /* 2234029 */   // Label 31197: @2234029
     /* 2234029 */   GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2234085), // Rule ID 1857 //
     /* 2234034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2234037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234052 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2234052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2234059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234068 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2234076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234084 */     // GIR_Coverage, 1857,
     /* 2234084 */     GIR_EraseRootFromParent_Done,
     /* 2234085 */   // Label 31198: @2234085
     /* 2234085 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2234141), // Rule ID 1858 //
     /* 2234090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2234093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234108 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2234108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2234115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2234132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234140 */     // GIR_Coverage, 1858,
     /* 2234140 */     GIR_EraseRootFromParent_Done,
     /* 2234141 */   // Label 31199: @2234141
     /* 2234141 */   GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2234171), // Rule ID 1887 //
     /* 2234146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2234149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2234152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234164 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2234164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234170 */     // GIR_Coverage, 1887,
     /* 2234170 */     GIR_Done,
     /* 2234171 */   // Label 31200: @2234171
     /* 2234171 */   GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2234227), // Rule ID 1890 //
     /* 2234176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2234179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234194 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2234194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2234201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234226 */     // GIR_Coverage, 1890,
     /* 2234226 */     GIR_EraseRootFromParent_Done,
     /* 2234227 */   // Label 31201: @2234227
     /* 2234227 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2234283), // Rule ID 1891 //
     /* 2234232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2234235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234250 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2234250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2234257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234266 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234282 */     // GIR_Coverage, 1891,
     /* 2234282 */     GIR_EraseRootFromParent_Done,
     /* 2234283 */   // Label 31202: @2234283
     /* 2234283 */   GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2234339), // Rule ID 2160 //
     /* 2234288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2234291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2234306 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2234313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2234330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234338 */     // GIR_Coverage, 2160,
     /* 2234338 */     GIR_EraseRootFromParent_Done,
     /* 2234339 */   // Label 31203: @2234339
     /* 2234339 */   GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2234395), // Rule ID 2161 //
     /* 2234344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2234347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2234358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2234362 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2234362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2234369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2234386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234394 */     // GIR_Coverage, 2161,
     /* 2234394 */     GIR_EraseRootFromParent_Done,
     /* 2234395 */   // Label 31204: @2234395
     /* 2234395 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2234451), // Rule ID 2172 //
     /* 2234400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2234403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2234418 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2234425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234450 */     // GIR_Coverage, 2172,
     /* 2234450 */     GIR_EraseRootFromParent_Done,
     /* 2234451 */   // Label 31205: @2234451
     /* 2234451 */   GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2234507), // Rule ID 2173 //
     /* 2234456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2234459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2234474 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2234474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2234481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234490 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234506 */     // GIR_Coverage, 2173,
     /* 2234506 */     GIR_EraseRootFromParent_Done,
     /* 2234507 */   // Label 31206: @2234507
     /* 2234507 */   GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2234563), // Rule ID 2180 //
     /* 2234512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2234515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2234526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234530 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2234537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2234554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234562 */     // GIR_Coverage, 2180,
     /* 2234562 */     GIR_EraseRootFromParent_Done,
     /* 2234563 */   // Label 31207: @2234563
     /* 2234563 */   GIM_Reject,
     /* 2234564 */ // Label 31194: @2234564
     /* 2234564 */ GIM_Reject,
     /* 2234565 */ // Label 31176: @2234565
     /* 2234565 */ GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2235240),
     /* 2234570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234573 */   GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2234624), // Rule ID 1157 //
     /* 2234578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2234581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2234600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234611 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2234611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2234614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2234622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234623 */     // GIR_Coverage, 1157,
     /* 2234623 */     GIR_EraseRootFromParent_Done,
     /* 2234624 */   // Label 31209: @2234624
     /* 2234624 */   GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2234675), // Rule ID 1178 //
     /* 2234629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2234632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2234651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234662 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2234662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2234665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2234673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234674 */     // GIR_Coverage, 1178,
     /* 2234674 */     GIR_EraseRootFromParent_Done,
     /* 2234675 */   // Label 31210: @2234675
     /* 2234675 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2234705), // Rule ID 1153 //
     /* 2234680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2234683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234698 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2234698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2234703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234704 */     // GIR_Coverage, 1153,
     /* 2234704 */     GIR_Done,
     /* 2234705 */   // Label 31211: @2234705
     /* 2234705 */   GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2234735), // Rule ID 1154 //
     /* 2234710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2234713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234728 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2234728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2234733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234734 */     // GIR_Coverage, 1154,
     /* 2234734 */     GIR_Done,
     /* 2234735 */   // Label 31212: @2234735
     /* 2234735 */   GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2234791), // Rule ID 1493 //
     /* 2234740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2234743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2234758 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2234761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2234765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2234782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234790 */     // GIR_Coverage, 1493,
     /* 2234790 */     GIR_EraseRootFromParent_Done,
     /* 2234791 */   // Label 31213: @2234791
     /* 2234791 */   GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2234847), // Rule ID 1494 //
     /* 2234796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2234799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2234810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2234814 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2234814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2234817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2234821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2234838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234846 */     // GIR_Coverage, 1494,
     /* 2234846 */     GIR_EraseRootFromParent_Done,
     /* 2234847 */   // Label 31214: @2234847
     /* 2234847 */   GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2234903), // Rule ID 1524 //
     /* 2234852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2234855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234870 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2234873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2234877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2234894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234902 */     // GIR_Coverage, 1524,
     /* 2234902 */     GIR_EraseRootFromParent_Done,
     /* 2234903 */   // Label 31215: @2234903
     /* 2234903 */   GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2234959), // Rule ID 1548 //
     /* 2234908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2234911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2234926 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2234926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2234929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2234933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2234945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2234950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234958 */     // GIR_Coverage, 1548,
     /* 2234958 */     GIR_EraseRootFromParent_Done,
     /* 2234959 */   // Label 31216: @2234959
     /* 2234959 */   GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2235015), // Rule ID 1549 //
     /* 2234964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2234967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2234978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2234982 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2234982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2234985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2234989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2234998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2235001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2235006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235014 */     // GIR_Coverage, 1549,
     /* 2235014 */     GIR_EraseRootFromParent_Done,
     /* 2235015 */   // Label 31217: @2235015
     /* 2235015 */   GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2235071), // Rule ID 2032 //
     /* 2235020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2235023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2235038 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2235038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2235041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2235045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2235062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235070 */     // GIR_Coverage, 2032,
     /* 2235070 */     GIR_EraseRootFromParent_Done,
     /* 2235071 */   // Label 31218: @2235071
     /* 2235071 */   GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2235127), // Rule ID 2033 //
     /* 2235076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2235079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2235094 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2235094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2235097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2235101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2235118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235126 */     // GIR_Coverage, 2033,
     /* 2235126 */     GIR_EraseRootFromParent_Done,
     /* 2235127 */   // Label 31219: @2235127
     /* 2235127 */   GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2235183), // Rule ID 2046 //
     /* 2235132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2235135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2235150 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2235150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2235153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2235157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2235174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235182 */     // GIR_Coverage, 2046,
     /* 2235182 */     GIR_EraseRootFromParent_Done,
     /* 2235183 */   // Label 31220: @2235183
     /* 2235183 */   GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2235239), // Rule ID 2047 //
     /* 2235188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2235191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2235206 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2235206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2235209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2235213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2235230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235238 */     // GIR_Coverage, 2047,
     /* 2235238 */     GIR_EraseRootFromParent_Done,
     /* 2235239 */   // Label 31221: @2235239
     /* 2235239 */   GIM_Reject,
     /* 2235240 */ // Label 31208: @2235240
     /* 2235240 */ GIM_Reject,
     /* 2235241 */ // Label 31177: @2235241
     /* 2235241 */ GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2236053),
     /* 2235246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2235249 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2235300), // Rule ID 1490 //
     /* 2235254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2235257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2235272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2235276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2235280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2235287 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2235287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2235290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2235298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235299 */     // GIR_Coverage, 1490,
     /* 2235299 */     GIR_EraseRootFromParent_Done,
     /* 2235300 */   // Label 31223: @2235300
     /* 2235300 */   GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2235351), // Rule ID 1522 //
     /* 2235305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2235308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2235323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2235327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2235331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2235338 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2235338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2235341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2235349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235350 */     // GIR_Coverage, 1522,
     /* 2235350 */     GIR_EraseRootFromParent_Done,
     /* 2235351 */   // Label 31224: @2235351
     /* 2235351 */   GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2235402), // Rule ID 1545 //
     /* 2235356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2235359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2235374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2235378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2235382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2235389 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2235389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2235392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2235400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235401 */     // GIR_Coverage, 1545,
     /* 2235401 */     GIR_EraseRootFromParent_Done,
     /* 2235402 */   // Label 31225: @2235402
     /* 2235402 */   GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2235432), // Rule ID 1488 //
     /* 2235407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2235410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235425 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2235425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2235430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235431 */     // GIR_Coverage, 1488,
     /* 2235431 */     GIR_Done,
     /* 2235432 */   // Label 31226: @2235432
     /* 2235432 */   GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2235488), // Rule ID 1491 //
     /* 2235437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2235440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2235443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235455 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2235455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2235462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2235479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235487 */     // GIR_Coverage, 1491,
     /* 2235487 */     GIR_EraseRootFromParent_Done,
     /* 2235488 */   // Label 31227: @2235488
     /* 2235488 */   GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2235544), // Rule ID 1492 //
     /* 2235493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2235496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2235499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2235511 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2235511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2235518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2235535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235543 */     // GIR_Coverage, 1492,
     /* 2235543 */     GIR_EraseRootFromParent_Done,
     /* 2235544 */   // Label 31228: @2235544
     /* 2235544 */   GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2235574), // Rule ID 1520 //
     /* 2235549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2235552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235567 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2235567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2235572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235573 */     // GIR_Coverage, 1520,
     /* 2235573 */     GIR_Done,
     /* 2235574 */   // Label 31229: @2235574
     /* 2235574 */   GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2235630), // Rule ID 1523 //
     /* 2235579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2235582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2235585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235597 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2235597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2235604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2235621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235629 */     // GIR_Coverage, 1523,
     /* 2235629 */     GIR_EraseRootFromParent_Done,
     /* 2235630 */   // Label 31230: @2235630
     /* 2235630 */   GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2235660), // Rule ID 1543 //
     /* 2235635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2235638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235653 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2235653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2235658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235659 */     // GIR_Coverage, 1543,
     /* 2235659 */     GIR_Done,
     /* 2235660 */   // Label 31231: @2235660
     /* 2235660 */   GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2235716), // Rule ID 1546 //
     /* 2235665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2235668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2235671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235683 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2235683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2235690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2235707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235715 */     // GIR_Coverage, 1546,
     /* 2235715 */     GIR_EraseRootFromParent_Done,
     /* 2235716 */   // Label 31232: @2235716
     /* 2235716 */   GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2235772), // Rule ID 1547 //
     /* 2235721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2235724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2235727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2235739 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2235739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2235746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2235763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235771 */     // GIR_Coverage, 1547,
     /* 2235771 */     GIR_EraseRootFromParent_Done,
     /* 2235772 */   // Label 31233: @2235772
     /* 2235772 */   GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2235828), // Rule ID 2162 //
     /* 2235777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2235780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2235795 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2235795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2235802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2235819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235827 */     // GIR_Coverage, 2162,
     /* 2235827 */     GIR_EraseRootFromParent_Done,
     /* 2235828 */   // Label 31234: @2235828
     /* 2235828 */   GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2235884), // Rule ID 2163 //
     /* 2235833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2235836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2235847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2235851 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2235851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2235858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2235875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235883 */     // GIR_Coverage, 2163,
     /* 2235883 */     GIR_EraseRootFromParent_Done,
     /* 2235884 */   // Label 31235: @2235884
     /* 2235884 */   GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2235940), // Rule ID 2174 //
     /* 2235889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2235892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2235907 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2235907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2235914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2235931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235939 */     // GIR_Coverage, 2174,
     /* 2235939 */     GIR_EraseRootFromParent_Done,
     /* 2235940 */   // Label 31236: @2235940
     /* 2235940 */   GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2235996), // Rule ID 2175 //
     /* 2235945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2235948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2235951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2235959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2235963 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2235963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2235966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2235970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2235979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2235982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2235987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235995 */     // GIR_Coverage, 2175,
     /* 2235995 */     GIR_EraseRootFromParent_Done,
     /* 2235996 */   // Label 31237: @2235996
     /* 2235996 */   GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2236052), // Rule ID 2181 //
     /* 2236001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2236004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2236007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2236019 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2236019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2236022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2236026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2236035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2236038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2236043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236051 */     // GIR_Coverage, 2181,
     /* 2236051 */     GIR_EraseRootFromParent_Done,
     /* 2236052 */   // Label 31238: @2236052
     /* 2236052 */   GIM_Reject,
     /* 2236053 */ // Label 31222: @2236053
     /* 2236053 */ GIM_Reject,
     /* 2236054 */ // Label 31178: @2236054
     /* 2236054 */ GIM_Try, /*On fail goto*//*Label 31239*/ GIMT_Encode4(2236304),
     /* 2236059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2236062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236073 */   GIM_Try, /*On fail goto*//*Label 31240*/ GIMT_Encode4(2236139), // Rule ID 55704 //
     /* 2236078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2236081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2236093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236100 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2236117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236138 */     // GIR_Coverage, 55704,
     /* 2236138 */     GIR_EraseRootFromParent_Done,
     /* 2236139 */   // Label 31240: @2236139
     /* 2236139 */   GIM_Try, /*On fail goto*//*Label 31241*/ GIMT_Encode4(2236205), // Rule ID 55705 //
     /* 2236144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2236147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2236159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236166 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2236183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236204 */     // GIR_Coverage, 55705,
     /* 2236204 */     GIR_EraseRootFromParent_Done,
     /* 2236205 */   // Label 31241: @2236205
     /* 2236205 */   GIM_Try, /*On fail goto*//*Label 31242*/ GIMT_Encode4(2236254), // Rule ID 55698 //
     /* 2236210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2236213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236217 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2236234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236253 */     // GIR_Coverage, 55698,
     /* 2236253 */     GIR_EraseRootFromParent_Done,
     /* 2236254 */   // Label 31242: @2236254
     /* 2236254 */   GIM_Try, /*On fail goto*//*Label 31243*/ GIMT_Encode4(2236303), // Rule ID 55699 //
     /* 2236259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2236262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236266 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2236283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236302 */     // GIR_Coverage, 55699,
     /* 2236302 */     GIR_EraseRootFromParent_Done,
     /* 2236303 */   // Label 31243: @2236303
     /* 2236303 */   GIM_Reject,
     /* 2236304 */ // Label 31239: @2236304
     /* 2236304 */ GIM_Reject,
     /* 2236305 */ // Label 31179: @2236305
     /* 2236305 */ GIM_Try, /*On fail goto*//*Label 31244*/ GIMT_Encode4(2236555),
     /* 2236310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2236313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236324 */   GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2236390), // Rule ID 55744 //
     /* 2236329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2236332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2236344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236351 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2236354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2236368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236389 */     // GIR_Coverage, 55744,
     /* 2236389 */     GIR_EraseRootFromParent_Done,
     /* 2236390 */   // Label 31245: @2236390
     /* 2236390 */   GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2236456), // Rule ID 55745 //
     /* 2236395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2236398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2236410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236417 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2236420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2236434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236455 */     // GIR_Coverage, 55745,
     /* 2236455 */     GIR_EraseRootFromParent_Done,
     /* 2236456 */   // Label 31246: @2236456
     /* 2236456 */   GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2236505), // Rule ID 55738 //
     /* 2236461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2236464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236468 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2236471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2236485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236504 */     // GIR_Coverage, 55738,
     /* 2236504 */     GIR_EraseRootFromParent_Done,
     /* 2236505 */   // Label 31247: @2236505
     /* 2236505 */   GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2236554), // Rule ID 55739 //
     /* 2236510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2236513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236517 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2236520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2236534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236553 */     // GIR_Coverage, 55739,
     /* 2236553 */     GIR_EraseRootFromParent_Done,
     /* 2236554 */   // Label 31248: @2236554
     /* 2236554 */   GIM_Reject,
     /* 2236555 */ // Label 31244: @2236555
     /* 2236555 */ GIM_Reject,
     /* 2236556 */ // Label 31180: @2236556
     /* 2236556 */ GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2236806),
     /* 2236561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2236564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236575 */   GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2236641), // Rule ID 55804 //
     /* 2236580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2236583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2236595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236602 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2236605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2236619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236640 */     // GIR_Coverage, 55804,
     /* 2236640 */     GIR_EraseRootFromParent_Done,
     /* 2236641 */   // Label 31250: @2236641
     /* 2236641 */   GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2236707), // Rule ID 55805 //
     /* 2236646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2236649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2236661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236668 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2236671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2236685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236706 */     // GIR_Coverage, 55805,
     /* 2236706 */     GIR_EraseRootFromParent_Done,
     /* 2236707 */   // Label 31251: @2236707
     /* 2236707 */   GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2236756), // Rule ID 55798 //
     /* 2236712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2236715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236719 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2236722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2236736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236755 */     // GIR_Coverage, 55798,
     /* 2236755 */     GIR_EraseRootFromParent_Done,
     /* 2236756 */   // Label 31252: @2236756
     /* 2236756 */   GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2236805), // Rule ID 55799 //
     /* 2236761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2236764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236768 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2236771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2236785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236804 */     // GIR_Coverage, 55799,
     /* 2236804 */     GIR_EraseRootFromParent_Done,
     /* 2236805 */   // Label 31253: @2236805
     /* 2236805 */   GIM_Reject,
     /* 2236806 */ // Label 31249: @2236806
     /* 2236806 */ GIM_Reject,
     /* 2236807 */ // Label 31181: @2236807
     /* 2236807 */ GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2237057),
     /* 2236812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2236815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236826 */   GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2236892), // Rule ID 55724 //
     /* 2236831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2236834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2236846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236853 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2236856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2236870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236891 */     // GIR_Coverage, 55724,
     /* 2236891 */     GIR_EraseRootFromParent_Done,
     /* 2236892 */   // Label 31255: @2236892
     /* 2236892 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2236958), // Rule ID 55725 //
     /* 2236897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2236900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2236908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2236912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236919 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2236922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2236936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2236947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236957 */     // GIR_Coverage, 55725,
     /* 2236957 */     GIR_EraseRootFromParent_Done,
     /* 2236958 */   // Label 31256: @2236958
     /* 2236958 */   GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2237007), // Rule ID 55718 //
     /* 2236963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2236966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236970 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2236973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2236987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237006 */     // GIR_Coverage, 55718,
     /* 2237006 */     GIR_EraseRootFromParent_Done,
     /* 2237007 */   // Label 31257: @2237007
     /* 2237007 */   GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2237056), // Rule ID 55719 //
     /* 2237012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2237015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237019 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2237036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237055 */     // GIR_Coverage, 55719,
     /* 2237055 */     GIR_EraseRootFromParent_Done,
     /* 2237056 */   // Label 31258: @2237056
     /* 2237056 */   GIM_Reject,
     /* 2237057 */ // Label 31254: @2237057
     /* 2237057 */ GIM_Reject,
     /* 2237058 */ // Label 31182: @2237058
     /* 2237058 */ GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2237308),
     /* 2237063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237077 */   GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2237143), // Rule ID 55784 //
     /* 2237082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2237085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237104 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2237121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237142 */     // GIR_Coverage, 55784,
     /* 2237142 */     GIR_EraseRootFromParent_Done,
     /* 2237143 */   // Label 31260: @2237143
     /* 2237143 */   GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2237209), // Rule ID 55785 //
     /* 2237148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2237151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237170 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2237187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237208 */     // GIR_Coverage, 55785,
     /* 2237208 */     GIR_EraseRootFromParent_Done,
     /* 2237209 */   // Label 31261: @2237209
     /* 2237209 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2237258), // Rule ID 55778 //
     /* 2237214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2237217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237221 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2237238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237257 */     // GIR_Coverage, 55778,
     /* 2237257 */     GIR_EraseRootFromParent_Done,
     /* 2237258 */   // Label 31262: @2237258
     /* 2237258 */   GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2237307), // Rule ID 55779 //
     /* 2237263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2237266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237270 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2237287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237306 */     // GIR_Coverage, 55779,
     /* 2237306 */     GIR_EraseRootFromParent_Done,
     /* 2237307 */   // Label 31263: @2237307
     /* 2237307 */   GIM_Reject,
     /* 2237308 */ // Label 31259: @2237308
     /* 2237308 */ GIM_Reject,
     /* 2237309 */ // Label 31183: @2237309
     /* 2237309 */ GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2237559),
     /* 2237314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2237317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237328 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2237394), // Rule ID 55944 //
     /* 2237333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2237336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2237348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237355 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2237372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237393 */     // GIR_Coverage, 55944,
     /* 2237393 */     GIR_EraseRootFromParent_Done,
     /* 2237394 */   // Label 31265: @2237394
     /* 2237394 */   GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2237460), // Rule ID 55945 //
     /* 2237399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2237402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2237414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237421 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2237438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237459 */     // GIR_Coverage, 55945,
     /* 2237459 */     GIR_EraseRootFromParent_Done,
     /* 2237460 */   // Label 31266: @2237460
     /* 2237460 */   GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2237509), // Rule ID 55938 //
     /* 2237465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2237468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237472 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2237489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237508 */     // GIR_Coverage, 55938,
     /* 2237508 */     GIR_EraseRootFromParent_Done,
     /* 2237509 */   // Label 31267: @2237509
     /* 2237509 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2237558), // Rule ID 55939 //
     /* 2237514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2237517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237521 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2237538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237557 */     // GIR_Coverage, 55939,
     /* 2237557 */     GIR_EraseRootFromParent_Done,
     /* 2237558 */   // Label 31268: @2237558
     /* 2237558 */   GIM_Reject,
     /* 2237559 */ // Label 31264: @2237559
     /* 2237559 */ GIM_Reject,
     /* 2237560 */ // Label 31184: @2237560
     /* 2237560 */ GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2237810),
     /* 2237565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2237568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2237571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237579 */   GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2237645), // Rule ID 55764 //
     /* 2237584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2237587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2237599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237606 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2237623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237644 */     // GIR_Coverage, 55764,
     /* 2237644 */     GIR_EraseRootFromParent_Done,
     /* 2237645 */   // Label 31270: @2237645
     /* 2237645 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2237711), // Rule ID 55765 //
     /* 2237650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2237653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2237665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237672 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2237689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237710 */     // GIR_Coverage, 55765,
     /* 2237710 */     GIR_EraseRootFromParent_Done,
     /* 2237711 */   // Label 31271: @2237711
     /* 2237711 */   GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2237760), // Rule ID 55758 //
     /* 2237716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2237719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237723 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2237740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237759 */     // GIR_Coverage, 55758,
     /* 2237759 */     GIR_EraseRootFromParent_Done,
     /* 2237760 */   // Label 31272: @2237760
     /* 2237760 */   GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2237809), // Rule ID 55759 //
     /* 2237765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2237768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237772 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2237789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237808 */     // GIR_Coverage, 55759,
     /* 2237808 */     GIR_EraseRootFromParent_Done,
     /* 2237809 */   // Label 31273: @2237809
     /* 2237809 */   GIM_Reject,
     /* 2237810 */ // Label 31269: @2237810
     /* 2237810 */ GIM_Reject,
     /* 2237811 */ // Label 31185: @2237811
     /* 2237811 */ GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2238061),
     /* 2237816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2237819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2237822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237830 */   GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2237896), // Rule ID 55884 //
     /* 2237835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2237838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2237850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237857 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2237860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2237874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237895 */     // GIR_Coverage, 55884,
     /* 2237895 */     GIR_EraseRootFromParent_Done,
     /* 2237896 */   // Label 31275: @2237896
     /* 2237896 */   GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2237962), // Rule ID 55885 //
     /* 2237901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2237904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2237912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2237916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237923 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2237926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2237940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2237951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237961 */     // GIR_Coverage, 55885,
     /* 2237961 */     GIR_EraseRootFromParent_Done,
     /* 2237962 */   // Label 31276: @2237962
     /* 2237962 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2238011), // Rule ID 55878 //
     /* 2237967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2237970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237974 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2237977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2237991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238010 */     // GIR_Coverage, 55878,
     /* 2238010 */     GIR_EraseRootFromParent_Done,
     /* 2238011 */   // Label 31277: @2238011
     /* 2238011 */   GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2238060), // Rule ID 55879 //
     /* 2238016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2238019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238023 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2238040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238059 */     // GIR_Coverage, 55879,
     /* 2238059 */     GIR_EraseRootFromParent_Done,
     /* 2238060 */   // Label 31278: @2238060
     /* 2238060 */   GIM_Reject,
     /* 2238061 */ // Label 31274: @2238061
     /* 2238061 */ GIM_Reject,
     /* 2238062 */ // Label 31186: @2238062
     /* 2238062 */ GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2238312),
     /* 2238067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238081 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2238147), // Rule ID 55964 //
     /* 2238086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2238089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238108 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2238125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238146 */     // GIR_Coverage, 55964,
     /* 2238146 */     GIR_EraseRootFromParent_Done,
     /* 2238147 */   // Label 31280: @2238147
     /* 2238147 */   GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2238213), // Rule ID 55965 //
     /* 2238152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2238155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238174 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2238191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238212 */     // GIR_Coverage, 55965,
     /* 2238212 */     GIR_EraseRootFromParent_Done,
     /* 2238213 */   // Label 31281: @2238213
     /* 2238213 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2238262), // Rule ID 55958 //
     /* 2238218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2238221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238225 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2238242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238261 */     // GIR_Coverage, 55958,
     /* 2238261 */     GIR_EraseRootFromParent_Done,
     /* 2238262 */   // Label 31282: @2238262
     /* 2238262 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2238311), // Rule ID 55959 //
     /* 2238267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2238270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238274 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2238291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238310 */     // GIR_Coverage, 55959,
     /* 2238310 */     GIR_EraseRootFromParent_Done,
     /* 2238311 */   // Label 31283: @2238311
     /* 2238311 */   GIM_Reject,
     /* 2238312 */ // Label 31279: @2238312
     /* 2238312 */ GIM_Reject,
     /* 2238313 */ // Label 31187: @2238313
     /* 2238313 */ GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2238563),
     /* 2238318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2238324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238332 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2238398), // Rule ID 55824 //
     /* 2238337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2238340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238359 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2238376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238397 */     // GIR_Coverage, 55824,
     /* 2238397 */     GIR_EraseRootFromParent_Done,
     /* 2238398 */   // Label 31285: @2238398
     /* 2238398 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2238464), // Rule ID 55825 //
     /* 2238403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2238406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238425 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2238442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238463 */     // GIR_Coverage, 55825,
     /* 2238463 */     GIR_EraseRootFromParent_Done,
     /* 2238464 */   // Label 31286: @2238464
     /* 2238464 */   GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2238513), // Rule ID 55818 //
     /* 2238469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2238472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238476 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2238493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238512 */     // GIR_Coverage, 55818,
     /* 2238512 */     GIR_EraseRootFromParent_Done,
     /* 2238513 */   // Label 31287: @2238513
     /* 2238513 */   GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2238562), // Rule ID 55819 //
     /* 2238518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2238521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238525 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2238542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238561 */     // GIR_Coverage, 55819,
     /* 2238561 */     GIR_EraseRootFromParent_Done,
     /* 2238562 */   // Label 31288: @2238562
     /* 2238562 */   GIM_Reject,
     /* 2238563 */ // Label 31284: @2238563
     /* 2238563 */ GIM_Reject,
     /* 2238564 */ // Label 31188: @2238564
     /* 2238564 */ GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2238814),
     /* 2238569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2238575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238583 */   GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2238649), // Rule ID 55904 //
     /* 2238588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2238591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238610 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2238627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238648 */     // GIR_Coverage, 55904,
     /* 2238648 */     GIR_EraseRootFromParent_Done,
     /* 2238649 */   // Label 31290: @2238649
     /* 2238649 */   GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2238715), // Rule ID 55905 //
     /* 2238654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2238657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238676 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2238693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238714 */     // GIR_Coverage, 55905,
     /* 2238714 */     GIR_EraseRootFromParent_Done,
     /* 2238715 */   // Label 31291: @2238715
     /* 2238715 */   GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2238764), // Rule ID 55898 //
     /* 2238720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2238723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238727 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2238744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238763 */     // GIR_Coverage, 55898,
     /* 2238763 */     GIR_EraseRootFromParent_Done,
     /* 2238764 */   // Label 31292: @2238764
     /* 2238764 */   GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2238813), // Rule ID 55899 //
     /* 2238769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2238772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238776 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2238793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238812 */     // GIR_Coverage, 55899,
     /* 2238812 */     GIR_EraseRootFromParent_Done,
     /* 2238813 */   // Label 31293: @2238813
     /* 2238813 */   GIM_Reject,
     /* 2238814 */ // Label 31289: @2238814
     /* 2238814 */ GIM_Reject,
     /* 2238815 */ // Label 31189: @2238815
     /* 2238815 */ GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2239065),
     /* 2238820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2238826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238834 */   GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2238900), // Rule ID 55984 //
     /* 2238839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2238842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238861 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2238878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238899 */     // GIR_Coverage, 55984,
     /* 2238899 */     GIR_EraseRootFromParent_Done,
     /* 2238900 */   // Label 31295: @2238900
     /* 2238900 */   GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2238966), // Rule ID 55985 //
     /* 2238905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2238908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2238912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2238916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2238927 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2238944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2238955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238965 */     // GIR_Coverage, 55985,
     /* 2238965 */     GIR_EraseRootFromParent_Done,
     /* 2238966 */   // Label 31296: @2238966
     /* 2238966 */   GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2239015), // Rule ID 55978 //
     /* 2238971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2238974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238978 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2238995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239014 */     // GIR_Coverage, 55978,
     /* 2239014 */     GIR_EraseRootFromParent_Done,
     /* 2239015 */   // Label 31297: @2239015
     /* 2239015 */   GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2239064), // Rule ID 55979 //
     /* 2239020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2239023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239027 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2239044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239063 */     // GIR_Coverage, 55979,
     /* 2239063 */     GIR_EraseRootFromParent_Done,
     /* 2239064 */   // Label 31298: @2239064
     /* 2239064 */   GIM_Reject,
     /* 2239065 */ // Label 31294: @2239065
     /* 2239065 */ GIM_Reject,
     /* 2239066 */ // Label 31190: @2239066
     /* 2239066 */ GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2239316),
     /* 2239071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2239077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239085 */   GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2239151), // Rule ID 55844 //
     /* 2239090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2239093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239112 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2239129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239150 */     // GIR_Coverage, 55844,
     /* 2239150 */     GIR_EraseRootFromParent_Done,
     /* 2239151 */   // Label 31300: @2239151
     /* 2239151 */   GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2239217), // Rule ID 55845 //
     /* 2239156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2239159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239178 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2239195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239216 */     // GIR_Coverage, 55845,
     /* 2239216 */     GIR_EraseRootFromParent_Done,
     /* 2239217 */   // Label 31301: @2239217
     /* 2239217 */   GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2239266), // Rule ID 55838 //
     /* 2239222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2239225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239229 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2239246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239265 */     // GIR_Coverage, 55838,
     /* 2239265 */     GIR_EraseRootFromParent_Done,
     /* 2239266 */   // Label 31302: @2239266
     /* 2239266 */   GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2239315), // Rule ID 55839 //
     /* 2239271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2239274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239278 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2239295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239314 */     // GIR_Coverage, 55839,
     /* 2239314 */     GIR_EraseRootFromParent_Done,
     /* 2239315 */   // Label 31303: @2239315
     /* 2239315 */   GIM_Reject,
     /* 2239316 */ // Label 31299: @2239316
     /* 2239316 */ GIM_Reject,
     /* 2239317 */ // Label 31191: @2239317
     /* 2239317 */ GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2239567),
     /* 2239322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2239328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239336 */   GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2239402), // Rule ID 55924 //
     /* 2239341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2239344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239363 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2239380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239401 */     // GIR_Coverage, 55924,
     /* 2239401 */     GIR_EraseRootFromParent_Done,
     /* 2239402 */   // Label 31305: @2239402
     /* 2239402 */   GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2239468), // Rule ID 55925 //
     /* 2239407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2239410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239429 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2239446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239467 */     // GIR_Coverage, 55925,
     /* 2239467 */     GIR_EraseRootFromParent_Done,
     /* 2239468 */   // Label 31306: @2239468
     /* 2239468 */   GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2239517), // Rule ID 55918 //
     /* 2239473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2239476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239480 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2239497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239516 */     // GIR_Coverage, 55918,
     /* 2239516 */     GIR_EraseRootFromParent_Done,
     /* 2239517 */   // Label 31307: @2239517
     /* 2239517 */   GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2239566), // Rule ID 55919 //
     /* 2239522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2239525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239529 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2239546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239565 */     // GIR_Coverage, 55919,
     /* 2239565 */     GIR_EraseRootFromParent_Done,
     /* 2239566 */   // Label 31308: @2239566
     /* 2239566 */   GIM_Reject,
     /* 2239567 */ // Label 31304: @2239567
     /* 2239567 */ GIM_Reject,
     /* 2239568 */ // Label 31192: @2239568
     /* 2239568 */ GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2239818),
     /* 2239573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2239579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239587 */   GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2239653), // Rule ID 55864 //
     /* 2239592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2239595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239614 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2239631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239652 */     // GIR_Coverage, 55864,
     /* 2239652 */     GIR_EraseRootFromParent_Done,
     /* 2239653 */   // Label 31310: @2239653
     /* 2239653 */   GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2239719), // Rule ID 55865 //
     /* 2239658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2239661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2239669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239680 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2239697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2239708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239718 */     // GIR_Coverage, 55865,
     /* 2239718 */     GIR_EraseRootFromParent_Done,
     /* 2239719 */   // Label 31311: @2239719
     /* 2239719 */   GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2239768), // Rule ID 55858 //
     /* 2239724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2239727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239731 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2239748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239767 */     // GIR_Coverage, 55858,
     /* 2239767 */     GIR_EraseRootFromParent_Done,
     /* 2239768 */   // Label 31312: @2239768
     /* 2239768 */   GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2239817), // Rule ID 55859 //
     /* 2239773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2239776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239780 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2239797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239816 */     // GIR_Coverage, 55859,
     /* 2239816 */     GIR_EraseRootFromParent_Done,
     /* 2239817 */   // Label 31313: @2239817
     /* 2239817 */   GIM_Reject,
     /* 2239818 */ // Label 31309: @2239818
     /* 2239818 */ GIM_Reject,
     /* 2239819 */ // Label 31193: @2239819
     /* 2239819 */ GIM_Reject,
     /* 2239820 */ // Label 71: @2239820
     /* 2239820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31317*/ GIMT_Encode4(2240009),
     /* 2239831 */ /*GILLT_s16*//*Label 31314*/ GIMT_Encode4(2239843),
     /* 2239835 */ /*GILLT_s32*//*Label 31315*/ GIMT_Encode4(2239893),
     /* 2239839 */ /*GILLT_s64*//*Label 31316*/ GIMT_Encode4(2239943),
     /* 2239843 */ // Label 31314: @2239843
     /* 2239843 */ GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2239892),
     /* 2239848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2239851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2239855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2239859 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2239875), // Rule ID 1924 //
     /* 2239864 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2239864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2239867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239874 */     // GIR_Coverage, 1924,
     /* 2239874 */     GIR_EraseRootFromParent_Done,
     /* 2239875 */   // Label 31319: @2239875
     /* 2239875 */   GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2239891), // Rule ID 1925 //
     /* 2239880 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2239880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2239883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239890 */     // GIR_Coverage, 1925,
     /* 2239890 */     GIR_EraseRootFromParent_Done,
     /* 2239891 */   // Label 31320: @2239891
     /* 2239891 */   GIM_Reject,
     /* 2239892 */ // Label 31318: @2239892
     /* 2239892 */ GIM_Reject,
     /* 2239893 */ // Label 31315: @2239893
     /* 2239893 */ GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2239942),
     /* 2239898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2239901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2239905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2239909 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2239925), // Rule ID 1211 //
     /* 2239914 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2239914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2239917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239924 */     // GIR_Coverage, 1211,
     /* 2239924 */     GIR_EraseRootFromParent_Done,
     /* 2239925 */   // Label 31322: @2239925
     /* 2239925 */   GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2239941), // Rule ID 1212 //
     /* 2239930 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2239930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2239933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239940 */     // GIR_Coverage, 1212,
     /* 2239940 */     GIR_EraseRootFromParent_Done,
     /* 2239941 */   // Label 31323: @2239941
     /* 2239941 */   GIM_Reject,
     /* 2239942 */ // Label 31321: @2239942
     /* 2239942 */ GIM_Reject,
     /* 2239943 */ // Label 31316: @2239943
     /* 2239943 */ GIM_Try, /*On fail goto*//*Label 31324*/ GIMT_Encode4(2240008),
     /* 2239948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2239951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2239955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2239959 */   GIM_Try, /*On fail goto*//*Label 31325*/ GIMT_Encode4(2239975), // Rule ID 1588 //
     /* 2239964 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2239964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2239967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239974 */     // GIR_Coverage, 1588,
     /* 2239974 */     GIR_EraseRootFromParent_Done,
     /* 2239975 */   // Label 31325: @2239975
     /* 2239975 */   GIM_Try, /*On fail goto*//*Label 31326*/ GIMT_Encode4(2239991), // Rule ID 1589 //
     /* 2239980 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2239980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2239983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239990 */     // GIR_Coverage, 1589,
     /* 2239990 */     GIR_EraseRootFromParent_Done,
     /* 2239991 */   // Label 31326: @2239991
     /* 2239991 */   GIM_Try, /*On fail goto*//*Label 31327*/ GIMT_Encode4(2240007), // Rule ID 1590 //
     /* 2239996 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2239996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2239999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240006 */     // GIR_Coverage, 1590,
     /* 2240006 */     GIR_EraseRootFromParent_Done,
     /* 2240007 */   // Label 31327: @2240007
     /* 2240007 */   GIM_Reject,
     /* 2240008 */ // Label 31324: @2240008
     /* 2240008 */ GIM_Reject,
     /* 2240009 */ // Label 31317: @2240009
     /* 2240009 */ GIM_Reject,
     /* 2240010 */ // Label 72: @2240010
     /* 2240010 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31346*/ GIMT_Encode4(2242094),
     /* 2240021 */ /*GILLT_s16*//*Label 31328*/ GIMT_Encode4(2240141),
     /* 2240025 */ /*GILLT_s32*//*Label 31329*/ GIMT_Encode4(2240208),
     /* 2240029 */ /*GILLT_s64*//*Label 31330*/ GIMT_Encode4(2240275), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240041 */ /*GILLT_nxv1s16*//*Label 31331*/ GIMT_Encode4(2240369),
     /* 2240045 */ /*GILLT_nxv1s32*//*Label 31332*/ GIMT_Encode4(2240484),
     /* 2240049 */ /*GILLT_nxv1s64*//*Label 31333*/ GIMT_Encode4(2240599), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240061 */ /*GILLT_nxv2s16*//*Label 31334*/ GIMT_Encode4(2240714),
     /* 2240065 */ /*GILLT_nxv2s32*//*Label 31335*/ GIMT_Encode4(2240829),
     /* 2240069 */ /*GILLT_nxv2s64*//*Label 31336*/ GIMT_Encode4(2240944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240081 */ /*GILLT_nxv4s16*//*Label 31337*/ GIMT_Encode4(2241059),
     /* 2240085 */ /*GILLT_nxv4s32*//*Label 31338*/ GIMT_Encode4(2241174),
     /* 2240089 */ /*GILLT_nxv4s64*//*Label 31339*/ GIMT_Encode4(2241289), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240101 */ /*GILLT_nxv8s16*//*Label 31340*/ GIMT_Encode4(2241404),
     /* 2240105 */ /*GILLT_nxv8s32*//*Label 31341*/ GIMT_Encode4(2241519),
     /* 2240109 */ /*GILLT_nxv8s64*//*Label 31342*/ GIMT_Encode4(2241634), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240121 */ /*GILLT_nxv16s16*//*Label 31343*/ GIMT_Encode4(2241749),
     /* 2240125 */ /*GILLT_nxv16s32*//*Label 31344*/ GIMT_Encode4(2241864), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2240137 */ /*GILLT_nxv32s16*//*Label 31345*/ GIMT_Encode4(2241979),
     /* 2240141 */ // Label 31328: @2240141
     /* 2240141 */ GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2240207),
     /* 2240146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2240149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2240152 */   GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2240179), // Rule ID 1912 //
     /* 2240157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2240160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2240164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2240168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2240172 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2240172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2240177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240178 */     // GIR_Coverage, 1912,
     /* 2240178 */     GIR_Done,
     /* 2240179 */   // Label 31348: @2240179
     /* 2240179 */   GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2240206), // Rule ID 1913 //
     /* 2240184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2240187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2240191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2240195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2240199 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2240199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2240204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240205 */     // GIR_Coverage, 1913,
     /* 2240205 */     GIR_Done,
     /* 2240206 */   // Label 31349: @2240206
     /* 2240206 */   GIM_Reject,
     /* 2240207 */ // Label 31347: @2240207
     /* 2240207 */ GIM_Reject,
     /* 2240208 */ // Label 31329: @2240208
     /* 2240208 */ GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2240274),
     /* 2240213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2240216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240219 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2240246), // Rule ID 1199 //
     /* 2240224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2240227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2240231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2240235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2240239 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2240239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2240244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240245 */     // GIR_Coverage, 1199,
     /* 2240245 */     GIR_Done,
     /* 2240246 */   // Label 31351: @2240246
     /* 2240246 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2240273), // Rule ID 1200 //
     /* 2240251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2240254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2240258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2240262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2240266 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2240266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2240271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240272 */     // GIR_Coverage, 1200,
     /* 2240272 */     GIR_Done,
     /* 2240273 */   // Label 31352: @2240273
     /* 2240273 */   GIM_Reject,
     /* 2240274 */ // Label 31350: @2240274
     /* 2240274 */ GIM_Reject,
     /* 2240275 */ // Label 31330: @2240275
     /* 2240275 */ GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2240368),
     /* 2240280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2240283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2240286 */   GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2240313), // Rule ID 1570 //
     /* 2240291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2240294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2240298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2240302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2240306 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2240306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2240311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240312 */     // GIR_Coverage, 1570,
     /* 2240312 */     GIR_Done,
     /* 2240313 */   // Label 31354: @2240313
     /* 2240313 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2240340), // Rule ID 1571 //
     /* 2240318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2240321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2240325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2240329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2240333 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2240333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2240338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240339 */     // GIR_Coverage, 1571,
     /* 2240339 */     GIR_Done,
     /* 2240340 */   // Label 31355: @2240340
     /* 2240340 */   GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2240367), // Rule ID 1572 //
     /* 2240345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2240348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240360 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2240360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2240365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240366 */     // GIR_Coverage, 1572,
     /* 2240366 */     GIR_Done,
     /* 2240367 */   // Label 31356: @2240367
     /* 2240367 */   GIM_Reject,
     /* 2240368 */ // Label 31353: @2240368
     /* 2240368 */ GIM_Reject,
     /* 2240369 */ // Label 31331: @2240369
     /* 2240369 */ GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2240483),
     /* 2240374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2240377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2240380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240392 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2240437), // Rule ID 45434 //
     /* 2240397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2240400 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2240403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2240417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240436 */     // GIR_Coverage, 45434,
     /* 2240436 */     GIR_EraseRootFromParent_Done,
     /* 2240437 */   // Label 31358: @2240437
     /* 2240437 */   GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2240482), // Rule ID 45435 //
     /* 2240442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2240445 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2240448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2240462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240481 */     // GIR_Coverage, 45435,
     /* 2240481 */     GIR_EraseRootFromParent_Done,
     /* 2240482 */   // Label 31359: @2240482
     /* 2240482 */   GIM_Reject,
     /* 2240483 */ // Label 31357: @2240483
     /* 2240483 */ GIM_Reject,
     /* 2240484 */ // Label 31332: @2240484
     /* 2240484 */ GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2240598),
     /* 2240489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2240492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2240495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240507 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2240552), // Rule ID 55996 //
     /* 2240512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2240515 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2240518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2240532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240551 */     // GIR_Coverage, 55996,
     /* 2240551 */     GIR_EraseRootFromParent_Done,
     /* 2240552 */   // Label 31361: @2240552
     /* 2240552 */   GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2240597), // Rule ID 55997 //
     /* 2240557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2240560 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2240563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2240577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240596 */     // GIR_Coverage, 55997,
     /* 2240596 */     GIR_EraseRootFromParent_Done,
     /* 2240597 */   // Label 31362: @2240597
     /* 2240597 */   GIM_Reject,
     /* 2240598 */ // Label 31360: @2240598
     /* 2240598 */ GIM_Reject,
     /* 2240599 */ // Label 31333: @2240599
     /* 2240599 */ GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2240713),
     /* 2240604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2240607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2240610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240622 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2240667), // Rule ID 56014 //
     /* 2240627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2240630 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2240633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2240647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240666 */     // GIR_Coverage, 56014,
     /* 2240666 */     GIR_EraseRootFromParent_Done,
     /* 2240667 */   // Label 31364: @2240667
     /* 2240667 */   GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2240712), // Rule ID 56015 //
     /* 2240672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2240675 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2240678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2240692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240711 */     // GIR_Coverage, 56015,
     /* 2240711 */     GIR_EraseRootFromParent_Done,
     /* 2240712 */   // Label 31365: @2240712
     /* 2240712 */   GIM_Reject,
     /* 2240713 */ // Label 31363: @2240713
     /* 2240713 */ GIM_Reject,
     /* 2240714 */ // Label 31334: @2240714
     /* 2240714 */ GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2240828),
     /* 2240719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2240722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240737 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2240782), // Rule ID 55990 //
     /* 2240742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2240745 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2240748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2240762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240781 */     // GIR_Coverage, 55990,
     /* 2240781 */     GIR_EraseRootFromParent_Done,
     /* 2240782 */   // Label 31367: @2240782
     /* 2240782 */   GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2240827), // Rule ID 55991 //
     /* 2240787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2240790 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2240793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2240807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240826 */     // GIR_Coverage, 55991,
     /* 2240826 */     GIR_EraseRootFromParent_Done,
     /* 2240827 */   // Label 31368: @2240827
     /* 2240827 */   GIM_Reject,
     /* 2240828 */ // Label 31366: @2240828
     /* 2240828 */ GIM_Reject,
     /* 2240829 */ // Label 31335: @2240829
     /* 2240829 */ GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2240943),
     /* 2240834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2240837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240852 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2240897), // Rule ID 56008 //
     /* 2240857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2240860 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2240863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2240877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240896 */     // GIR_Coverage, 56008,
     /* 2240896 */     GIR_EraseRootFromParent_Done,
     /* 2240897 */   // Label 31370: @2240897
     /* 2240897 */   GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2240942), // Rule ID 56009 //
     /* 2240902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2240905 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2240908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2240922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240941 */     // GIR_Coverage, 56009,
     /* 2240941 */     GIR_EraseRootFromParent_Done,
     /* 2240942 */   // Label 31371: @2240942
     /* 2240942 */   GIM_Reject,
     /* 2240943 */ // Label 31369: @2240943
     /* 2240943 */ GIM_Reject,
     /* 2240944 */ // Label 31336: @2240944
     /* 2240944 */ GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2241058),
     /* 2240949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2240952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2240955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240967 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2241012), // Rule ID 56056 //
     /* 2240972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2240975 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2240978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2240992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241011 */     // GIR_Coverage, 56056,
     /* 2241011 */     GIR_EraseRootFromParent_Done,
     /* 2241012 */   // Label 31373: @2241012
     /* 2241012 */   GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2241057), // Rule ID 56057 //
     /* 2241017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2241020 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2241023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2241037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241056 */     // GIR_Coverage, 56057,
     /* 2241056 */     GIR_EraseRootFromParent_Done,
     /* 2241057 */   // Label 31374: @2241057
     /* 2241057 */   GIM_Reject,
     /* 2241058 */ // Label 31372: @2241058
     /* 2241058 */ GIM_Reject,
     /* 2241059 */ // Label 31337: @2241059
     /* 2241059 */ GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2241173),
     /* 2241064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2241067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241082 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2241127), // Rule ID 56002 //
     /* 2241087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2241090 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2241093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2241107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241126 */     // GIR_Coverage, 56002,
     /* 2241126 */     GIR_EraseRootFromParent_Done,
     /* 2241127 */   // Label 31376: @2241127
     /* 2241127 */   GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2241172), // Rule ID 56003 //
     /* 2241132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2241135 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2241138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2241152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241171 */     // GIR_Coverage, 56003,
     /* 2241171 */     GIR_EraseRootFromParent_Done,
     /* 2241172 */   // Label 31377: @2241172
     /* 2241172 */   GIM_Reject,
     /* 2241173 */ // Label 31375: @2241173
     /* 2241173 */ GIM_Reject,
     /* 2241174 */ // Label 31338: @2241174
     /* 2241174 */ GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2241288),
     /* 2241179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2241182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241197 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2241242), // Rule ID 56038 //
     /* 2241202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2241205 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2241208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2241222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241241 */     // GIR_Coverage, 56038,
     /* 2241241 */     GIR_EraseRootFromParent_Done,
     /* 2241242 */   // Label 31379: @2241242
     /* 2241242 */   GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2241287), // Rule ID 56039 //
     /* 2241247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2241250 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2241253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2241267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241286 */     // GIR_Coverage, 56039,
     /* 2241286 */     GIR_EraseRootFromParent_Done,
     /* 2241287 */   // Label 31380: @2241287
     /* 2241287 */   GIM_Reject,
     /* 2241288 */ // Label 31378: @2241288
     /* 2241288 */ GIM_Reject,
     /* 2241289 */ // Label 31339: @2241289
     /* 2241289 */ GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2241403),
     /* 2241294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2241297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241312 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2241357), // Rule ID 56062 //
     /* 2241317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2241320 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2241323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2241337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241356 */     // GIR_Coverage, 56062,
     /* 2241356 */     GIR_EraseRootFromParent_Done,
     /* 2241357 */   // Label 31382: @2241357
     /* 2241357 */   GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2241402), // Rule ID 56063 //
     /* 2241362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2241365 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2241368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2241382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241401 */     // GIR_Coverage, 56063,
     /* 2241401 */     GIR_EraseRootFromParent_Done,
     /* 2241402 */   // Label 31383: @2241402
     /* 2241402 */   GIM_Reject,
     /* 2241403 */ // Label 31381: @2241403
     /* 2241403 */ GIM_Reject,
     /* 2241404 */ // Label 31340: @2241404
     /* 2241404 */ GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2241518),
     /* 2241409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2241412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2241415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241427 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2241472), // Rule ID 56020 //
     /* 2241432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2241435 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2241438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2241452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241471 */     // GIR_Coverage, 56020,
     /* 2241471 */     GIR_EraseRootFromParent_Done,
     /* 2241472 */   // Label 31385: @2241472
     /* 2241472 */   GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2241517), // Rule ID 56021 //
     /* 2241477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2241480 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2241483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2241497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241516 */     // GIR_Coverage, 56021,
     /* 2241516 */     GIR_EraseRootFromParent_Done,
     /* 2241517 */   // Label 31386: @2241517
     /* 2241517 */   GIM_Reject,
     /* 2241518 */ // Label 31384: @2241518
     /* 2241518 */ GIM_Reject,
     /* 2241519 */ // Label 31341: @2241519
     /* 2241519 */ GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2241633),
     /* 2241524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2241527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2241530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241542 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2241587), // Rule ID 56044 //
     /* 2241547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2241550 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2241553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2241567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241586 */     // GIR_Coverage, 56044,
     /* 2241586 */     GIR_EraseRootFromParent_Done,
     /* 2241587 */   // Label 31388: @2241587
     /* 2241587 */   GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2241632), // Rule ID 56045 //
     /* 2241592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2241595 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2241598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2241612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241631 */     // GIR_Coverage, 56045,
     /* 2241631 */     GIR_EraseRootFromParent_Done,
     /* 2241632 */   // Label 31389: @2241632
     /* 2241632 */   GIM_Reject,
     /* 2241633 */ // Label 31387: @2241633
     /* 2241633 */ GIM_Reject,
     /* 2241634 */ // Label 31342: @2241634
     /* 2241634 */ GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2241748),
     /* 2241639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2241642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2241645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241657 */   GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2241702), // Rule ID 56068 //
     /* 2241662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2241665 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2241668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2241682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241701 */     // GIR_Coverage, 56068,
     /* 2241701 */     GIR_EraseRootFromParent_Done,
     /* 2241702 */   // Label 31391: @2241702
     /* 2241702 */   GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2241747), // Rule ID 56069 //
     /* 2241707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2241710 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2241713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2241727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241746 */     // GIR_Coverage, 56069,
     /* 2241746 */     GIR_EraseRootFromParent_Done,
     /* 2241747 */   // Label 31392: @2241747
     /* 2241747 */   GIM_Reject,
     /* 2241748 */ // Label 31390: @2241748
     /* 2241748 */ GIM_Reject,
     /* 2241749 */ // Label 31343: @2241749
     /* 2241749 */ GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2241863),
     /* 2241754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2241757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2241760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241772 */   GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2241817), // Rule ID 56026 //
     /* 2241777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2241780 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2241783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2241797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241816 */     // GIR_Coverage, 56026,
     /* 2241816 */     GIR_EraseRootFromParent_Done,
     /* 2241817 */   // Label 31394: @2241817
     /* 2241817 */   GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2241862), // Rule ID 56027 //
     /* 2241822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2241825 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2241828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2241842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241861 */     // GIR_Coverage, 56027,
     /* 2241861 */     GIR_EraseRootFromParent_Done,
     /* 2241862 */   // Label 31395: @2241862
     /* 2241862 */   GIM_Reject,
     /* 2241863 */ // Label 31393: @2241863
     /* 2241863 */ GIM_Reject,
     /* 2241864 */ // Label 31344: @2241864
     /* 2241864 */ GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2241978),
     /* 2241869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2241872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2241875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241887 */   GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2241932), // Rule ID 56050 //
     /* 2241892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2241895 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2241898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2241912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241931 */     // GIR_Coverage, 56050,
     /* 2241931 */     GIR_EraseRootFromParent_Done,
     /* 2241932 */   // Label 31397: @2241932
     /* 2241932 */   GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2241977), // Rule ID 56051 //
     /* 2241937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2241940 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2241943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2241957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241976 */     // GIR_Coverage, 56051,
     /* 2241976 */     GIR_EraseRootFromParent_Done,
     /* 2241977 */   // Label 31398: @2241977
     /* 2241977 */   GIM_Reject,
     /* 2241978 */ // Label 31396: @2241978
     /* 2241978 */ GIM_Reject,
     /* 2241979 */ // Label 31345: @2241979
     /* 2241979 */ GIM_Try, /*On fail goto*//*Label 31399*/ GIMT_Encode4(2242093),
     /* 2241984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2241987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2241990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2241998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242002 */   GIM_Try, /*On fail goto*//*Label 31400*/ GIMT_Encode4(2242047), // Rule ID 56032 //
     /* 2242007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2242010 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2242013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2242027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242046 */     // GIR_Coverage, 56032,
     /* 2242046 */     GIR_EraseRootFromParent_Done,
     /* 2242047 */   // Label 31400: @2242047
     /* 2242047 */   GIM_Try, /*On fail goto*//*Label 31401*/ GIMT_Encode4(2242092), // Rule ID 56033 //
     /* 2242052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2242055 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2242058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2242072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242091 */     // GIR_Coverage, 56033,
     /* 2242091 */     GIR_EraseRootFromParent_Done,
     /* 2242092 */   // Label 31401: @2242092
     /* 2242092 */   GIM_Reject,
     /* 2242093 */ // Label 31399: @2242093
     /* 2242093 */ GIM_Reject,
     /* 2242094 */ // Label 31346: @2242094
     /* 2242094 */ GIM_Reject,
     /* 2242095 */ // Label 73: @2242095
     /* 2242095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31420*/ GIMT_Encode4(2244179),
     /* 2242106 */ /*GILLT_s16*//*Label 31402*/ GIMT_Encode4(2242226),
     /* 2242110 */ /*GILLT_s32*//*Label 31403*/ GIMT_Encode4(2242293),
     /* 2242114 */ /*GILLT_s64*//*Label 31404*/ GIMT_Encode4(2242360), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242126 */ /*GILLT_nxv1s16*//*Label 31405*/ GIMT_Encode4(2242454),
     /* 2242130 */ /*GILLT_nxv1s32*//*Label 31406*/ GIMT_Encode4(2242569),
     /* 2242134 */ /*GILLT_nxv1s64*//*Label 31407*/ GIMT_Encode4(2242684), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242146 */ /*GILLT_nxv2s16*//*Label 31408*/ GIMT_Encode4(2242799),
     /* 2242150 */ /*GILLT_nxv2s32*//*Label 31409*/ GIMT_Encode4(2242914),
     /* 2242154 */ /*GILLT_nxv2s64*//*Label 31410*/ GIMT_Encode4(2243029), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242166 */ /*GILLT_nxv4s16*//*Label 31411*/ GIMT_Encode4(2243144),
     /* 2242170 */ /*GILLT_nxv4s32*//*Label 31412*/ GIMT_Encode4(2243259),
     /* 2242174 */ /*GILLT_nxv4s64*//*Label 31413*/ GIMT_Encode4(2243374), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242186 */ /*GILLT_nxv8s16*//*Label 31414*/ GIMT_Encode4(2243489),
     /* 2242190 */ /*GILLT_nxv8s32*//*Label 31415*/ GIMT_Encode4(2243604),
     /* 2242194 */ /*GILLT_nxv8s64*//*Label 31416*/ GIMT_Encode4(2243719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242206 */ /*GILLT_nxv16s16*//*Label 31417*/ GIMT_Encode4(2243834),
     /* 2242210 */ /*GILLT_nxv16s32*//*Label 31418*/ GIMT_Encode4(2243949), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2242222 */ /*GILLT_nxv32s16*//*Label 31419*/ GIMT_Encode4(2244064),
     /* 2242226 */ // Label 31402: @2242226
     /* 2242226 */ GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2242292),
     /* 2242231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2242234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2242237 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2242264), // Rule ID 1914 //
     /* 2242242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2242245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2242249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2242253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2242257 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2242257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2242262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242263 */     // GIR_Coverage, 1914,
     /* 2242263 */     GIR_Done,
     /* 2242264 */   // Label 31422: @2242264
     /* 2242264 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2242291), // Rule ID 1915 //
     /* 2242269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2242272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2242276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2242280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2242284 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2242284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2242289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242290 */     // GIR_Coverage, 1915,
     /* 2242290 */     GIR_Done,
     /* 2242291 */   // Label 31423: @2242291
     /* 2242291 */   GIM_Reject,
     /* 2242292 */ // Label 31421: @2242292
     /* 2242292 */ GIM_Reject,
     /* 2242293 */ // Label 31403: @2242293
     /* 2242293 */ GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2242359),
     /* 2242298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2242301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242304 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2242331), // Rule ID 1201 //
     /* 2242309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2242312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2242316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2242320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2242324 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2242324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2242329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242330 */     // GIR_Coverage, 1201,
     /* 2242330 */     GIR_Done,
     /* 2242331 */   // Label 31425: @2242331
     /* 2242331 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2242358), // Rule ID 1202 //
     /* 2242336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2242339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2242343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2242347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2242351 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2242351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2242356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242357 */     // GIR_Coverage, 1202,
     /* 2242357 */     GIR_Done,
     /* 2242358 */   // Label 31426: @2242358
     /* 2242358 */   GIM_Reject,
     /* 2242359 */ // Label 31424: @2242359
     /* 2242359 */ GIM_Reject,
     /* 2242360 */ // Label 31404: @2242360
     /* 2242360 */ GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2242453),
     /* 2242365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2242368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242371 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2242398), // Rule ID 1573 //
     /* 2242376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2242379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2242383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2242387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2242391 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2242391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2242396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242397 */     // GIR_Coverage, 1573,
     /* 2242397 */     GIR_Done,
     /* 2242398 */   // Label 31428: @2242398
     /* 2242398 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2242425), // Rule ID 1574 //
     /* 2242403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2242406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2242410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2242414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2242418 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2242418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2242423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242424 */     // GIR_Coverage, 1574,
     /* 2242424 */     GIR_Done,
     /* 2242425 */   // Label 31429: @2242425
     /* 2242425 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2242452), // Rule ID 1575 //
     /* 2242430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2242433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242445 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2242445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2242450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242451 */     // GIR_Coverage, 1575,
     /* 2242451 */     GIR_Done,
     /* 2242452 */   // Label 31430: @2242452
     /* 2242452 */   GIM_Reject,
     /* 2242453 */ // Label 31427: @2242453
     /* 2242453 */ GIM_Reject,
     /* 2242454 */ // Label 31405: @2242454
     /* 2242454 */ GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2242568),
     /* 2242459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2242462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2242465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242477 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2242522), // Rule ID 56074 //
     /* 2242482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2242485 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2242488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2242502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242521 */     // GIR_Coverage, 56074,
     /* 2242521 */     GIR_EraseRootFromParent_Done,
     /* 2242522 */   // Label 31432: @2242522
     /* 2242522 */   GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2242567), // Rule ID 56075 //
     /* 2242527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2242530 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2242533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2242547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242566 */     // GIR_Coverage, 56075,
     /* 2242566 */     GIR_EraseRootFromParent_Done,
     /* 2242567 */   // Label 31433: @2242567
     /* 2242567 */   GIM_Reject,
     /* 2242568 */ // Label 31431: @2242568
     /* 2242568 */ GIM_Reject,
     /* 2242569 */ // Label 31406: @2242569
     /* 2242569 */ GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2242683),
     /* 2242574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2242577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2242580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242592 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2242637), // Rule ID 56086 //
     /* 2242597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2242600 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2242603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2242617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242636 */     // GIR_Coverage, 56086,
     /* 2242636 */     GIR_EraseRootFromParent_Done,
     /* 2242637 */   // Label 31435: @2242637
     /* 2242637 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2242682), // Rule ID 56087 //
     /* 2242642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2242645 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2242648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2242662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242681 */     // GIR_Coverage, 56087,
     /* 2242681 */     GIR_EraseRootFromParent_Done,
     /* 2242682 */   // Label 31436: @2242682
     /* 2242682 */   GIM_Reject,
     /* 2242683 */ // Label 31434: @2242683
     /* 2242683 */ GIM_Reject,
     /* 2242684 */ // Label 31407: @2242684
     /* 2242684 */ GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2242798),
     /* 2242689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2242692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2242695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242707 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2242752), // Rule ID 56104 //
     /* 2242712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2242715 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2242718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2242732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242751 */     // GIR_Coverage, 56104,
     /* 2242751 */     GIR_EraseRootFromParent_Done,
     /* 2242752 */   // Label 31438: @2242752
     /* 2242752 */   GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2242797), // Rule ID 56105 //
     /* 2242757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2242760 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2242763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2242777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242796 */     // GIR_Coverage, 56105,
     /* 2242796 */     GIR_EraseRootFromParent_Done,
     /* 2242797 */   // Label 31439: @2242797
     /* 2242797 */   GIM_Reject,
     /* 2242798 */ // Label 31437: @2242798
     /* 2242798 */ GIM_Reject,
     /* 2242799 */ // Label 31408: @2242799
     /* 2242799 */ GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2242913),
     /* 2242804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2242807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242822 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2242867), // Rule ID 56080 //
     /* 2242827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2242830 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2242833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2242847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242866 */     // GIR_Coverage, 56080,
     /* 2242866 */     GIR_EraseRootFromParent_Done,
     /* 2242867 */   // Label 31441: @2242867
     /* 2242867 */   GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2242912), // Rule ID 56081 //
     /* 2242872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2242875 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2242878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2242892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242911 */     // GIR_Coverage, 56081,
     /* 2242911 */     GIR_EraseRootFromParent_Done,
     /* 2242912 */   // Label 31442: @2242912
     /* 2242912 */   GIM_Reject,
     /* 2242913 */ // Label 31440: @2242913
     /* 2242913 */ GIM_Reject,
     /* 2242914 */ // Label 31409: @2242914
     /* 2242914 */ GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2243028),
     /* 2242919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2242922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242937 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2242982), // Rule ID 56098 //
     /* 2242942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2242945 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2242948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2242962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242981 */     // GIR_Coverage, 56098,
     /* 2242981 */     GIR_EraseRootFromParent_Done,
     /* 2242982 */   // Label 31444: @2242982
     /* 2242982 */   GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2243027), // Rule ID 56099 //
     /* 2242987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2242990 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2242993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2243007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243026 */     // GIR_Coverage, 56099,
     /* 2243026 */     GIR_EraseRootFromParent_Done,
     /* 2243027 */   // Label 31445: @2243027
     /* 2243027 */   GIM_Reject,
     /* 2243028 */ // Label 31443: @2243028
     /* 2243028 */ GIM_Reject,
     /* 2243029 */ // Label 31410: @2243029
     /* 2243029 */ GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2243143),
     /* 2243034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2243037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2243040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243052 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2243097), // Rule ID 56146 //
     /* 2243057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2243060 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2243063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2243077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243096 */     // GIR_Coverage, 56146,
     /* 2243096 */     GIR_EraseRootFromParent_Done,
     /* 2243097 */   // Label 31447: @2243097
     /* 2243097 */   GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2243142), // Rule ID 56147 //
     /* 2243102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2243105 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2243108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2243122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243141 */     // GIR_Coverage, 56147,
     /* 2243141 */     GIR_EraseRootFromParent_Done,
     /* 2243142 */   // Label 31448: @2243142
     /* 2243142 */   GIM_Reject,
     /* 2243143 */ // Label 31446: @2243143
     /* 2243143 */ GIM_Reject,
     /* 2243144 */ // Label 31411: @2243144
     /* 2243144 */ GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2243258),
     /* 2243149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2243152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243167 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2243212), // Rule ID 56092 //
     /* 2243172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2243175 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2243178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2243192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243211 */     // GIR_Coverage, 56092,
     /* 2243211 */     GIR_EraseRootFromParent_Done,
     /* 2243212 */   // Label 31450: @2243212
     /* 2243212 */   GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2243257), // Rule ID 56093 //
     /* 2243217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2243220 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2243223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2243237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243256 */     // GIR_Coverage, 56093,
     /* 2243256 */     GIR_EraseRootFromParent_Done,
     /* 2243257 */   // Label 31451: @2243257
     /* 2243257 */   GIM_Reject,
     /* 2243258 */ // Label 31449: @2243258
     /* 2243258 */ GIM_Reject,
     /* 2243259 */ // Label 31412: @2243259
     /* 2243259 */ GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2243373),
     /* 2243264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2243267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2243270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243282 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2243327), // Rule ID 56128 //
     /* 2243287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2243290 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2243293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2243307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243326 */     // GIR_Coverage, 56128,
     /* 2243326 */     GIR_EraseRootFromParent_Done,
     /* 2243327 */   // Label 31453: @2243327
     /* 2243327 */   GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2243372), // Rule ID 56129 //
     /* 2243332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2243335 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2243338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2243352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243371 */     // GIR_Coverage, 56129,
     /* 2243371 */     GIR_EraseRootFromParent_Done,
     /* 2243372 */   // Label 31454: @2243372
     /* 2243372 */   GIM_Reject,
     /* 2243373 */ // Label 31452: @2243373
     /* 2243373 */ GIM_Reject,
     /* 2243374 */ // Label 31413: @2243374
     /* 2243374 */ GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2243488),
     /* 2243379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2243382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2243385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243397 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2243442), // Rule ID 56152 //
     /* 2243402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2243405 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2243408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2243422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243441 */     // GIR_Coverage, 56152,
     /* 2243441 */     GIR_EraseRootFromParent_Done,
     /* 2243442 */   // Label 31456: @2243442
     /* 2243442 */   GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2243487), // Rule ID 56153 //
     /* 2243447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2243450 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2243453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2243467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243486 */     // GIR_Coverage, 56153,
     /* 2243486 */     GIR_EraseRootFromParent_Done,
     /* 2243487 */   // Label 31457: @2243487
     /* 2243487 */   GIM_Reject,
     /* 2243488 */ // Label 31455: @2243488
     /* 2243488 */ GIM_Reject,
     /* 2243489 */ // Label 31414: @2243489
     /* 2243489 */ GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2243603),
     /* 2243494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2243497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243512 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2243557), // Rule ID 56110 //
     /* 2243517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2243520 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2243523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2243537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243556 */     // GIR_Coverage, 56110,
     /* 2243556 */     GIR_EraseRootFromParent_Done,
     /* 2243557 */   // Label 31459: @2243557
     /* 2243557 */   GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2243602), // Rule ID 56111 //
     /* 2243562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2243565 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2243568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2243582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243601 */     // GIR_Coverage, 56111,
     /* 2243601 */     GIR_EraseRootFromParent_Done,
     /* 2243602 */   // Label 31460: @2243602
     /* 2243602 */   GIM_Reject,
     /* 2243603 */ // Label 31458: @2243603
     /* 2243603 */ GIM_Reject,
     /* 2243604 */ // Label 31415: @2243604
     /* 2243604 */ GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2243718),
     /* 2243609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2243612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243627 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2243672), // Rule ID 56134 //
     /* 2243632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2243635 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2243638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2243652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243671 */     // GIR_Coverage, 56134,
     /* 2243671 */     GIR_EraseRootFromParent_Done,
     /* 2243672 */   // Label 31462: @2243672
     /* 2243672 */   GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2243717), // Rule ID 56135 //
     /* 2243677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2243680 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2243683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2243697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243716 */     // GIR_Coverage, 56135,
     /* 2243716 */     GIR_EraseRootFromParent_Done,
     /* 2243717 */   // Label 31463: @2243717
     /* 2243717 */   GIM_Reject,
     /* 2243718 */ // Label 31461: @2243718
     /* 2243718 */ GIM_Reject,
     /* 2243719 */ // Label 31416: @2243719
     /* 2243719 */ GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2243833),
     /* 2243724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2243727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2243730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243742 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2243787), // Rule ID 56158 //
     /* 2243747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2243750 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2243753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2243767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243786 */     // GIR_Coverage, 56158,
     /* 2243786 */     GIR_EraseRootFromParent_Done,
     /* 2243787 */   // Label 31465: @2243787
     /* 2243787 */   GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2243832), // Rule ID 56159 //
     /* 2243792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2243795 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2243798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2243812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243831 */     // GIR_Coverage, 56159,
     /* 2243831 */     GIR_EraseRootFromParent_Done,
     /* 2243832 */   // Label 31466: @2243832
     /* 2243832 */   GIM_Reject,
     /* 2243833 */ // Label 31464: @2243833
     /* 2243833 */ GIM_Reject,
     /* 2243834 */ // Label 31417: @2243834
     /* 2243834 */ GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2243948),
     /* 2243839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2243842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2243845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243857 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2243902), // Rule ID 56116 //
     /* 2243862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2243865 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2243868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2243882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243901 */     // GIR_Coverage, 56116,
     /* 2243901 */     GIR_EraseRootFromParent_Done,
     /* 2243902 */   // Label 31468: @2243902
     /* 2243902 */   GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2243947), // Rule ID 56117 //
     /* 2243907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2243910 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2243913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2243927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243946 */     // GIR_Coverage, 56117,
     /* 2243946 */     GIR_EraseRootFromParent_Done,
     /* 2243947 */   // Label 31469: @2243947
     /* 2243947 */   GIM_Reject,
     /* 2243948 */ // Label 31467: @2243948
     /* 2243948 */ GIM_Reject,
     /* 2243949 */ // Label 31418: @2243949
     /* 2243949 */ GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2244063),
     /* 2243954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2243957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2243960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243972 */   GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2244017), // Rule ID 56140 //
     /* 2243977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2243980 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2243983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2243997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244016 */     // GIR_Coverage, 56140,
     /* 2244016 */     GIR_EraseRootFromParent_Done,
     /* 2244017 */   // Label 31471: @2244017
     /* 2244017 */   GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2244062), // Rule ID 56141 //
     /* 2244022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2244025 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2244028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2244042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244061 */     // GIR_Coverage, 56141,
     /* 2244061 */     GIR_EraseRootFromParent_Done,
     /* 2244062 */   // Label 31472: @2244062
     /* 2244062 */   GIM_Reject,
     /* 2244063 */ // Label 31470: @2244063
     /* 2244063 */ GIM_Reject,
     /* 2244064 */ // Label 31419: @2244064
     /* 2244064 */ GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2244178),
     /* 2244069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2244072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2244075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244087 */   GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2244132), // Rule ID 56122 //
     /* 2244092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2244095 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2244098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2244112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244131 */     // GIR_Coverage, 56122,
     /* 2244131 */     GIR_EraseRootFromParent_Done,
     /* 2244132 */   // Label 31474: @2244132
     /* 2244132 */   GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2244177), // Rule ID 56123 //
     /* 2244137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2244140 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2244143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2244157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244176 */     // GIR_Coverage, 56123,
     /* 2244176 */     GIR_EraseRootFromParent_Done,
     /* 2244177 */   // Label 31475: @2244177
     /* 2244177 */   GIM_Reject,
     /* 2244178 */ // Label 31473: @2244178
     /* 2244178 */ GIM_Reject,
     /* 2244179 */ // Label 31420: @2244179
     /* 2244179 */ GIM_Reject,
     /* 2244180 */ // Label 74: @2244180
     /* 2244180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31479*/ GIMT_Encode4(2244305),
     /* 2244191 */ /*GILLT_s16*//*Label 31476*/ GIMT_Encode4(2244203),
     /* 2244195 */ /*GILLT_s32*//*Label 31477*/ GIMT_Encode4(2244237),
     /* 2244199 */ /*GILLT_s64*//*Label 31478*/ GIMT_Encode4(2244271),
     /* 2244203 */ // Label 31476: @2244203
     /* 2244203 */ GIM_Try, /*On fail goto*//*Label 31480*/ GIMT_Encode4(2244236), // Rule ID 2266 //
     /* 2244208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2244211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2244214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2244217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244229 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2244229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2244234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244235 */   // GIR_Coverage, 2266,
     /* 2244235 */   GIR_Done,
     /* 2244236 */ // Label 31480: @2244236
     /* 2244236 */ GIM_Reject,
     /* 2244237 */ // Label 31477: @2244237
     /* 2244237 */ GIM_Try, /*On fail goto*//*Label 31481*/ GIMT_Encode4(2244270), // Rule ID 2184 //
     /* 2244242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2244245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2244248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244263 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2244263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2244268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244269 */   // GIR_Coverage, 2184,
     /* 2244269 */   GIR_Done,
     /* 2244270 */ // Label 31481: @2244270
     /* 2244270 */ GIM_Reject,
     /* 2244271 */ // Label 31478: @2244271
     /* 2244271 */ GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2244304), // Rule ID 2224 //
     /* 2244276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2244279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2244282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244297 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2244297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2244302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244303 */   // GIR_Coverage, 2224,
     /* 2244303 */   GIR_Done,
     /* 2244304 */ // Label 31482: @2244304
     /* 2244304 */ GIM_Reject,
     /* 2244305 */ // Label 31479: @2244305
     /* 2244305 */ GIM_Reject,
     /* 2244306 */ // Label 75: @2244306
     /* 2244306 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31486*/ GIMT_Encode4(2244431),
     /* 2244317 */ /*GILLT_s16*//*Label 31483*/ GIMT_Encode4(2244329),
     /* 2244321 */ /*GILLT_s32*//*Label 31484*/ GIMT_Encode4(2244363),
     /* 2244325 */ /*GILLT_s64*//*Label 31485*/ GIMT_Encode4(2244397),
     /* 2244329 */ // Label 31483: @2244329
     /* 2244329 */ GIM_Try, /*On fail goto*//*Label 31487*/ GIMT_Encode4(2244362), // Rule ID 2267 //
     /* 2244334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2244337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2244340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2244343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2244355 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2244355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2244360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244361 */   // GIR_Coverage, 2267,
     /* 2244361 */   GIR_Done,
     /* 2244362 */ // Label 31487: @2244362
     /* 2244362 */ GIM_Reject,
     /* 2244363 */ // Label 31484: @2244363
     /* 2244363 */ GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2244396), // Rule ID 2185 //
     /* 2244368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2244371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2244374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2244389 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2244389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2244394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244395 */   // GIR_Coverage, 2185,
     /* 2244395 */   GIR_Done,
     /* 2244396 */ // Label 31488: @2244396
     /* 2244396 */ GIM_Reject,
     /* 2244397 */ // Label 31485: @2244397
     /* 2244397 */ GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2244430), // Rule ID 2225 //
     /* 2244402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2244405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2244408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2244423 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2244423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2244428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244429 */   // GIR_Coverage, 2225,
     /* 2244429 */   GIR_Done,
     /* 2244430 */ // Label 31489: @2244430
     /* 2244430 */ GIM_Reject,
     /* 2244431 */ // Label 31486: @2244431
     /* 2244431 */ GIM_Reject,
     /* 2244432 */ // Label 76: @2244432
     /* 2244432 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31514*/ GIMT_Encode4(2247207),
     /* 2244443 */ /*GILLT_s32*//*Label 31490*/ GIMT_Encode4(2244567),
     /* 2244447 */ /*GILLT_s64*//*Label 31491*/ GIMT_Encode4(2244622), GIMT_Encode4(0),
     /* 2244455 */ /*GILLT_nxv1s8*//*Label 31492*/ GIMT_Encode4(2244677),
     /* 2244459 */ /*GILLT_nxv1s16*//*Label 31493*/ GIMT_Encode4(2244792),
     /* 2244463 */ /*GILLT_nxv1s32*//*Label 31494*/ GIMT_Encode4(2244907),
     /* 2244467 */ /*GILLT_nxv1s64*//*Label 31495*/ GIMT_Encode4(2245022), GIMT_Encode4(0),
     /* 2244475 */ /*GILLT_nxv2s8*//*Label 31496*/ GIMT_Encode4(2245137),
     /* 2244479 */ /*GILLT_nxv2s16*//*Label 31497*/ GIMT_Encode4(2245252),
     /* 2244483 */ /*GILLT_nxv2s32*//*Label 31498*/ GIMT_Encode4(2245367),
     /* 2244487 */ /*GILLT_nxv2s64*//*Label 31499*/ GIMT_Encode4(2245482), GIMT_Encode4(0),
     /* 2244495 */ /*GILLT_nxv4s8*//*Label 31500*/ GIMT_Encode4(2245597),
     /* 2244499 */ /*GILLT_nxv4s16*//*Label 31501*/ GIMT_Encode4(2245712),
     /* 2244503 */ /*GILLT_nxv4s32*//*Label 31502*/ GIMT_Encode4(2245827),
     /* 2244507 */ /*GILLT_nxv4s64*//*Label 31503*/ GIMT_Encode4(2245942), GIMT_Encode4(0),
     /* 2244515 */ /*GILLT_nxv8s8*//*Label 31504*/ GIMT_Encode4(2246057),
     /* 2244519 */ /*GILLT_nxv8s16*//*Label 31505*/ GIMT_Encode4(2246172),
     /* 2244523 */ /*GILLT_nxv8s32*//*Label 31506*/ GIMT_Encode4(2246287),
     /* 2244527 */ /*GILLT_nxv8s64*//*Label 31507*/ GIMT_Encode4(2246402), GIMT_Encode4(0),
     /* 2244535 */ /*GILLT_nxv16s8*//*Label 31508*/ GIMT_Encode4(2246517),
     /* 2244539 */ /*GILLT_nxv16s16*//*Label 31509*/ GIMT_Encode4(2246632),
     /* 2244543 */ /*GILLT_nxv16s32*//*Label 31510*/ GIMT_Encode4(2246747), GIMT_Encode4(0),
     /* 2244551 */ /*GILLT_nxv32s8*//*Label 31511*/ GIMT_Encode4(2246862),
     /* 2244555 */ /*GILLT_nxv32s16*//*Label 31512*/ GIMT_Encode4(2246977), GIMT_Encode4(0),
     /* 2244563 */ /*GILLT_nxv64s8*//*Label 31513*/ GIMT_Encode4(2247092),
     /* 2244567 */ // Label 31490: @2244567
     /* 2244567 */ GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2244621),
     /* 2244572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2244575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244590 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2244605), // Rule ID 63775 //
     /* 2244595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2244598 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2244598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2244603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244604 */     // GIR_Coverage, 63775,
     /* 2244604 */     GIR_Done,
     /* 2244605 */   // Label 31516: @2244605
     /* 2244605 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2244620), // Rule ID 2387 //
     /* 2244610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2244613 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2244613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2244618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244619 */     // GIR_Coverage, 2387,
     /* 2244619 */     GIR_Done,
     /* 2244620 */   // Label 31517: @2244620
     /* 2244620 */   GIM_Reject,
     /* 2244621 */ // Label 31515: @2244621
     /* 2244621 */ GIM_Reject,
     /* 2244622 */ // Label 31491: @2244622
     /* 2244622 */ GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2244676),
     /* 2244627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2244630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244645 */   GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2244660), // Rule ID 63774 //
     /* 2244650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244653 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2244658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244659 */     // GIR_Coverage, 63774,
     /* 2244659 */     GIR_Done,
     /* 2244660 */   // Label 31519: @2244660
     /* 2244660 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2244675), // Rule ID 2386 //
     /* 2244665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2244668 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2244673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244674 */     // GIR_Coverage, 2386,
     /* 2244674 */     GIR_Done,
     /* 2244675 */   // Label 31520: @2244675
     /* 2244675 */   GIM_Reject,
     /* 2244676 */ // Label 31518: @2244676
     /* 2244676 */ GIM_Reject,
     /* 2244677 */ // Label 31492: @2244677
     /* 2244677 */ GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2244791),
     /* 2244682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2244685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2244688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244700 */   GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2244745), // Rule ID 50046 //
     /* 2244705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244708 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2244711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2244725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244744 */     // GIR_Coverage, 50046,
     /* 2244744 */     GIR_EraseRootFromParent_Done,
     /* 2244745 */   // Label 31522: @2244745
     /* 2244745 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2244790), // Rule ID 50047 //
     /* 2244750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244753 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2244756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2244770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244789 */     // GIR_Coverage, 50047,
     /* 2244789 */     GIR_EraseRootFromParent_Done,
     /* 2244790 */   // Label 31523: @2244790
     /* 2244790 */   GIM_Reject,
     /* 2244791 */ // Label 31521: @2244791
     /* 2244791 */ GIM_Reject,
     /* 2244792 */ // Label 31493: @2244792
     /* 2244792 */ GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2244906),
     /* 2244797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2244800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2244803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244815 */   GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2244860), // Rule ID 50058 //
     /* 2244820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244823 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2244826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2244840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244859 */     // GIR_Coverage, 50058,
     /* 2244859 */     GIR_EraseRootFromParent_Done,
     /* 2244860 */   // Label 31525: @2244860
     /* 2244860 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2244905), // Rule ID 50059 //
     /* 2244865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244868 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2244871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2244885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244904 */     // GIR_Coverage, 50059,
     /* 2244904 */     GIR_EraseRootFromParent_Done,
     /* 2244905 */   // Label 31526: @2244905
     /* 2244905 */   GIM_Reject,
     /* 2244906 */ // Label 31524: @2244906
     /* 2244906 */ GIM_Reject,
     /* 2244907 */ // Label 31494: @2244907
     /* 2244907 */ GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2245021),
     /* 2244912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2244915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2244918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244930 */   GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2244975), // Rule ID 50066 //
     /* 2244935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244938 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2244941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2244955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2244962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2244974 */     // GIR_Coverage, 50066,
     /* 2244974 */     GIR_EraseRootFromParent_Done,
     /* 2244975 */   // Label 31528: @2244975
     /* 2244975 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2245020), // Rule ID 50067 //
     /* 2244980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244983 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2244986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2244990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2245000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245019 */     // GIR_Coverage, 50067,
     /* 2245019 */     GIR_EraseRootFromParent_Done,
     /* 2245020 */   // Label 31529: @2245020
     /* 2245020 */   GIM_Reject,
     /* 2245021 */ // Label 31527: @2245021
     /* 2245021 */ GIM_Reject,
     /* 2245022 */ // Label 31495: @2245022
     /* 2245022 */ GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2245136),
     /* 2245027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2245030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245045 */   GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2245090), // Rule ID 50082 //
     /* 2245050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245053 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2245056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245089 */     // GIR_Coverage, 50082,
     /* 2245089 */     GIR_EraseRootFromParent_Done,
     /* 2245090 */   // Label 31531: @2245090
     /* 2245090 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2245135), // Rule ID 50083 //
     /* 2245095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245098 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2245101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245134 */     // GIR_Coverage, 50083,
     /* 2245134 */     GIR_EraseRootFromParent_Done,
     /* 2245135 */   // Label 31532: @2245135
     /* 2245135 */   GIM_Reject,
     /* 2245136 */ // Label 31530: @2245136
     /* 2245136 */ GIM_Reject,
     /* 2245137 */ // Label 31496: @2245137
     /* 2245137 */ GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2245251),
     /* 2245142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2245145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2245148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245160 */   GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2245205), // Rule ID 50050 //
     /* 2245165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245168 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2245171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2245185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245204 */     // GIR_Coverage, 50050,
     /* 2245204 */     GIR_EraseRootFromParent_Done,
     /* 2245205 */   // Label 31534: @2245205
     /* 2245205 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2245250), // Rule ID 50051 //
     /* 2245210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245213 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2245216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2245230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245249 */     // GIR_Coverage, 50051,
     /* 2245249 */     GIR_EraseRootFromParent_Done,
     /* 2245250 */   // Label 31535: @2245250
     /* 2245250 */   GIM_Reject,
     /* 2245251 */ // Label 31533: @2245251
     /* 2245251 */ GIM_Reject,
     /* 2245252 */ // Label 31497: @2245252
     /* 2245252 */ GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2245366),
     /* 2245257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2245260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2245263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245275 */   GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2245320), // Rule ID 50062 //
     /* 2245280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245283 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2245286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2245300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245319 */     // GIR_Coverage, 50062,
     /* 2245319 */     GIR_EraseRootFromParent_Done,
     /* 2245320 */   // Label 31537: @2245320
     /* 2245320 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2245365), // Rule ID 50063 //
     /* 2245325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245328 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2245331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2245345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245364 */     // GIR_Coverage, 50063,
     /* 2245364 */     GIR_EraseRootFromParent_Done,
     /* 2245365 */   // Label 31538: @2245365
     /* 2245365 */   GIM_Reject,
     /* 2245366 */ // Label 31536: @2245366
     /* 2245366 */ GIM_Reject,
     /* 2245367 */ // Label 31498: @2245367
     /* 2245367 */ GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2245481),
     /* 2245372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2245375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2245378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245390 */   GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2245435), // Rule ID 50078 //
     /* 2245395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245398 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2245401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245434 */     // GIR_Coverage, 50078,
     /* 2245434 */     GIR_EraseRootFromParent_Done,
     /* 2245435 */   // Label 31540: @2245435
     /* 2245435 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2245480), // Rule ID 50079 //
     /* 2245440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245443 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2245446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245479 */     // GIR_Coverage, 50079,
     /* 2245479 */     GIR_EraseRootFromParent_Done,
     /* 2245480 */   // Label 31541: @2245480
     /* 2245480 */   GIM_Reject,
     /* 2245481 */ // Label 31539: @2245481
     /* 2245481 */ GIM_Reject,
     /* 2245482 */ // Label 31499: @2245482
     /* 2245482 */ GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2245596),
     /* 2245487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2245490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2245493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245505 */   GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2245550), // Rule ID 50122 //
     /* 2245510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245513 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2245516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2245530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245549 */     // GIR_Coverage, 50122,
     /* 2245549 */     GIR_EraseRootFromParent_Done,
     /* 2245550 */   // Label 31543: @2245550
     /* 2245550 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2245595), // Rule ID 50123 //
     /* 2245555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245558 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2245561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2245575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245594 */     // GIR_Coverage, 50123,
     /* 2245594 */     GIR_EraseRootFromParent_Done,
     /* 2245595 */   // Label 31544: @2245595
     /* 2245595 */   GIM_Reject,
     /* 2245596 */ // Label 31542: @2245596
     /* 2245596 */ GIM_Reject,
     /* 2245597 */ // Label 31500: @2245597
     /* 2245597 */ GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2245711),
     /* 2245602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2245605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245620 */   GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2245665), // Rule ID 50054 //
     /* 2245625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245628 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2245631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2245645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245664 */     // GIR_Coverage, 50054,
     /* 2245664 */     GIR_EraseRootFromParent_Done,
     /* 2245665 */   // Label 31546: @2245665
     /* 2245665 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2245710), // Rule ID 50055 //
     /* 2245670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245673 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2245676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2245690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245709 */     // GIR_Coverage, 50055,
     /* 2245709 */     GIR_EraseRootFromParent_Done,
     /* 2245710 */   // Label 31547: @2245710
     /* 2245710 */   GIM_Reject,
     /* 2245711 */ // Label 31545: @2245711
     /* 2245711 */ GIM_Reject,
     /* 2245712 */ // Label 31501: @2245712
     /* 2245712 */ GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2245826),
     /* 2245717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2245720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245735 */   GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2245780), // Rule ID 50074 //
     /* 2245740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245743 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2245746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245779 */     // GIR_Coverage, 50074,
     /* 2245779 */     GIR_EraseRootFromParent_Done,
     /* 2245780 */   // Label 31549: @2245780
     /* 2245780 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2245825), // Rule ID 50075 //
     /* 2245785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245788 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2245791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2245805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245824 */     // GIR_Coverage, 50075,
     /* 2245824 */     GIR_EraseRootFromParent_Done,
     /* 2245825 */   // Label 31550: @2245825
     /* 2245825 */   GIM_Reject,
     /* 2245826 */ // Label 31548: @2245826
     /* 2245826 */ GIM_Reject,
     /* 2245827 */ // Label 31502: @2245827
     /* 2245827 */ GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2245941),
     /* 2245832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2245835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245850 */   GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2245895), // Rule ID 50110 //
     /* 2245855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245858 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2245861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2245875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245894 */     // GIR_Coverage, 50110,
     /* 2245894 */     GIR_EraseRootFromParent_Done,
     /* 2245895 */   // Label 31552: @2245895
     /* 2245895 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2245940), // Rule ID 50111 //
     /* 2245900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245903 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2245906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2245920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2245939 */     // GIR_Coverage, 50111,
     /* 2245939 */     GIR_EraseRootFromParent_Done,
     /* 2245940 */   // Label 31553: @2245940
     /* 2245940 */   GIM_Reject,
     /* 2245941 */ // Label 31551: @2245941
     /* 2245941 */ GIM_Reject,
     /* 2245942 */ // Label 31503: @2245942
     /* 2245942 */ GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2246056),
     /* 2245947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2245950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2245953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245965 */   GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2246010), // Rule ID 50126 //
     /* 2245970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245973 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2245976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2245980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2245990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2245997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246009 */     // GIR_Coverage, 50126,
     /* 2246009 */     GIR_EraseRootFromParent_Done,
     /* 2246010 */   // Label 31555: @2246010
     /* 2246010 */   GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2246055), // Rule ID 50127 //
     /* 2246015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246018 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2246021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246054 */     // GIR_Coverage, 50127,
     /* 2246054 */     GIR_EraseRootFromParent_Done,
     /* 2246055 */   // Label 31556: @2246055
     /* 2246055 */   GIM_Reject,
     /* 2246056 */ // Label 31554: @2246056
     /* 2246056 */ GIM_Reject,
     /* 2246057 */ // Label 31504: @2246057
     /* 2246057 */ GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2246171),
     /* 2246062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2246065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2246068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246080 */   GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2246125), // Rule ID 50070 //
     /* 2246085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246088 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2246091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2246105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246124 */     // GIR_Coverage, 50070,
     /* 2246124 */     GIR_EraseRootFromParent_Done,
     /* 2246125 */   // Label 31558: @2246125
     /* 2246125 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2246170), // Rule ID 50071 //
     /* 2246130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246133 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2246136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2246150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246169 */     // GIR_Coverage, 50071,
     /* 2246169 */     GIR_EraseRootFromParent_Done,
     /* 2246170 */   // Label 31559: @2246170
     /* 2246170 */   GIM_Reject,
     /* 2246171 */ // Label 31557: @2246171
     /* 2246171 */ GIM_Reject,
     /* 2246172 */ // Label 31505: @2246172
     /* 2246172 */ GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2246286),
     /* 2246177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2246180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2246183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246195 */   GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2246240), // Rule ID 50098 //
     /* 2246200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246203 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2246206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2246220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246239 */     // GIR_Coverage, 50098,
     /* 2246239 */     GIR_EraseRootFromParent_Done,
     /* 2246240 */   // Label 31561: @2246240
     /* 2246240 */   GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2246285), // Rule ID 50099 //
     /* 2246245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246248 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2246251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2246265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246284 */     // GIR_Coverage, 50099,
     /* 2246284 */     GIR_EraseRootFromParent_Done,
     /* 2246285 */   // Label 31562: @2246285
     /* 2246285 */   GIM_Reject,
     /* 2246286 */ // Label 31560: @2246286
     /* 2246286 */ GIM_Reject,
     /* 2246287 */ // Label 31506: @2246287
     /* 2246287 */ GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2246401),
     /* 2246292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2246295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2246298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246310 */   GIM_Try, /*On fail goto*//*Label 31564*/ GIMT_Encode4(2246355), // Rule ID 50114 //
     /* 2246315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246318 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2246321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246354 */     // GIR_Coverage, 50114,
     /* 2246354 */     GIR_EraseRootFromParent_Done,
     /* 2246355 */   // Label 31564: @2246355
     /* 2246355 */   GIM_Try, /*On fail goto*//*Label 31565*/ GIMT_Encode4(2246400), // Rule ID 50115 //
     /* 2246360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246363 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2246366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246399 */     // GIR_Coverage, 50115,
     /* 2246399 */     GIR_EraseRootFromParent_Done,
     /* 2246400 */   // Label 31565: @2246400
     /* 2246400 */   GIM_Reject,
     /* 2246401 */ // Label 31563: @2246401
     /* 2246401 */ GIM_Reject,
     /* 2246402 */ // Label 31507: @2246402
     /* 2246402 */ GIM_Try, /*On fail goto*//*Label 31566*/ GIMT_Encode4(2246516),
     /* 2246407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2246410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2246413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246425 */   GIM_Try, /*On fail goto*//*Label 31567*/ GIMT_Encode4(2246470), // Rule ID 50130 //
     /* 2246430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246433 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2246436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2246450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246469 */     // GIR_Coverage, 50130,
     /* 2246469 */     GIR_EraseRootFromParent_Done,
     /* 2246470 */   // Label 31567: @2246470
     /* 2246470 */   GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2246515), // Rule ID 50131 //
     /* 2246475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246478 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2246481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2246495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246514 */     // GIR_Coverage, 50131,
     /* 2246514 */     GIR_EraseRootFromParent_Done,
     /* 2246515 */   // Label 31568: @2246515
     /* 2246515 */   GIM_Reject,
     /* 2246516 */ // Label 31566: @2246516
     /* 2246516 */ GIM_Reject,
     /* 2246517 */ // Label 31508: @2246517
     /* 2246517 */ GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2246631),
     /* 2246522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2246525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2246528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246540 */   GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2246585), // Rule ID 50086 //
     /* 2246545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246548 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2246551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2246565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246584 */     // GIR_Coverage, 50086,
     /* 2246584 */     GIR_EraseRootFromParent_Done,
     /* 2246585 */   // Label 31570: @2246585
     /* 2246585 */   GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2246630), // Rule ID 50087 //
     /* 2246590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246593 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2246596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2246610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246629 */     // GIR_Coverage, 50087,
     /* 2246629 */     GIR_EraseRootFromParent_Done,
     /* 2246630 */   // Label 31571: @2246630
     /* 2246630 */   GIM_Reject,
     /* 2246631 */ // Label 31569: @2246631
     /* 2246631 */ GIM_Reject,
     /* 2246632 */ // Label 31509: @2246632
     /* 2246632 */ GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2246746),
     /* 2246637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2246640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2246643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246655 */   GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2246700), // Rule ID 50102 //
     /* 2246660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246663 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2246666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246699 */     // GIR_Coverage, 50102,
     /* 2246699 */     GIR_EraseRootFromParent_Done,
     /* 2246700 */   // Label 31573: @2246700
     /* 2246700 */   GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2246745), // Rule ID 50103 //
     /* 2246705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246708 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2246711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246744 */     // GIR_Coverage, 50103,
     /* 2246744 */     GIR_EraseRootFromParent_Done,
     /* 2246745 */   // Label 31574: @2246745
     /* 2246745 */   GIM_Reject,
     /* 2246746 */ // Label 31572: @2246746
     /* 2246746 */ GIM_Reject,
     /* 2246747 */ // Label 31510: @2246747
     /* 2246747 */ GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2246861),
     /* 2246752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2246755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2246758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246770 */   GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2246815), // Rule ID 50118 //
     /* 2246775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246778 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2246781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2246795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246814 */     // GIR_Coverage, 50118,
     /* 2246814 */     GIR_EraseRootFromParent_Done,
     /* 2246815 */   // Label 31576: @2246815
     /* 2246815 */   GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2246860), // Rule ID 50119 //
     /* 2246820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246823 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2246826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2246840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246859 */     // GIR_Coverage, 50119,
     /* 2246859 */     GIR_EraseRootFromParent_Done,
     /* 2246860 */   // Label 31577: @2246860
     /* 2246860 */   GIM_Reject,
     /* 2246861 */ // Label 31575: @2246861
     /* 2246861 */ GIM_Reject,
     /* 2246862 */ // Label 31511: @2246862
     /* 2246862 */ GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2246976),
     /* 2246867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2246870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2246873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246885 */   GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2246930), // Rule ID 50090 //
     /* 2246890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246893 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2246896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246929 */     // GIR_Coverage, 50090,
     /* 2246929 */     GIR_EraseRootFromParent_Done,
     /* 2246930 */   // Label 31579: @2246930
     /* 2246930 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2246975), // Rule ID 50091 //
     /* 2246935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246938 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2246941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2246945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2246955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2246962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2246974 */     // GIR_Coverage, 50091,
     /* 2246974 */     GIR_EraseRootFromParent_Done,
     /* 2246975 */   // Label 31580: @2246975
     /* 2246975 */   GIM_Reject,
     /* 2246976 */ // Label 31578: @2246976
     /* 2246976 */ GIM_Reject,
     /* 2246977 */ // Label 31512: @2246977
     /* 2246977 */ GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2247091),
     /* 2246982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2246985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2246988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247000 */   GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2247045), // Rule ID 50106 //
     /* 2247005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247008 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2247011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2247025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247044 */     // GIR_Coverage, 50106,
     /* 2247044 */     GIR_EraseRootFromParent_Done,
     /* 2247045 */   // Label 31582: @2247045
     /* 2247045 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2247090), // Rule ID 50107 //
     /* 2247050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247053 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2247056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2247070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247089 */     // GIR_Coverage, 50107,
     /* 2247089 */     GIR_EraseRootFromParent_Done,
     /* 2247090 */   // Label 31583: @2247090
     /* 2247090 */   GIM_Reject,
     /* 2247091 */ // Label 31581: @2247091
     /* 2247091 */ GIM_Reject,
     /* 2247092 */ // Label 31513: @2247092
     /* 2247092 */ GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2247206),
     /* 2247097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2247100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2247103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247115 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2247160), // Rule ID 50094 //
     /* 2247120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247123 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2247126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2247140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247159 */     // GIR_Coverage, 50094,
     /* 2247159 */     GIR_EraseRootFromParent_Done,
     /* 2247160 */   // Label 31585: @2247160
     /* 2247160 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2247205), // Rule ID 50095 //
     /* 2247165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247168 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2247171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2247185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247204 */     // GIR_Coverage, 50095,
     /* 2247204 */     GIR_EraseRootFromParent_Done,
     /* 2247205 */   // Label 31586: @2247205
     /* 2247205 */   GIM_Reject,
     /* 2247206 */ // Label 31584: @2247206
     /* 2247206 */ GIM_Reject,
     /* 2247207 */ // Label 31514: @2247207
     /* 2247207 */ GIM_Reject,
     /* 2247208 */ // Label 77: @2247208
     /* 2247208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31611*/ GIMT_Encode4(2249983),
     /* 2247219 */ /*GILLT_s32*//*Label 31587*/ GIMT_Encode4(2247343),
     /* 2247223 */ /*GILLT_s64*//*Label 31588*/ GIMT_Encode4(2247398), GIMT_Encode4(0),
     /* 2247231 */ /*GILLT_nxv1s8*//*Label 31589*/ GIMT_Encode4(2247453),
     /* 2247235 */ /*GILLT_nxv1s16*//*Label 31590*/ GIMT_Encode4(2247568),
     /* 2247239 */ /*GILLT_nxv1s32*//*Label 31591*/ GIMT_Encode4(2247683),
     /* 2247243 */ /*GILLT_nxv1s64*//*Label 31592*/ GIMT_Encode4(2247798), GIMT_Encode4(0),
     /* 2247251 */ /*GILLT_nxv2s8*//*Label 31593*/ GIMT_Encode4(2247913),
     /* 2247255 */ /*GILLT_nxv2s16*//*Label 31594*/ GIMT_Encode4(2248028),
     /* 2247259 */ /*GILLT_nxv2s32*//*Label 31595*/ GIMT_Encode4(2248143),
     /* 2247263 */ /*GILLT_nxv2s64*//*Label 31596*/ GIMT_Encode4(2248258), GIMT_Encode4(0),
     /* 2247271 */ /*GILLT_nxv4s8*//*Label 31597*/ GIMT_Encode4(2248373),
     /* 2247275 */ /*GILLT_nxv4s16*//*Label 31598*/ GIMT_Encode4(2248488),
     /* 2247279 */ /*GILLT_nxv4s32*//*Label 31599*/ GIMT_Encode4(2248603),
     /* 2247283 */ /*GILLT_nxv4s64*//*Label 31600*/ GIMT_Encode4(2248718), GIMT_Encode4(0),
     /* 2247291 */ /*GILLT_nxv8s8*//*Label 31601*/ GIMT_Encode4(2248833),
     /* 2247295 */ /*GILLT_nxv8s16*//*Label 31602*/ GIMT_Encode4(2248948),
     /* 2247299 */ /*GILLT_nxv8s32*//*Label 31603*/ GIMT_Encode4(2249063),
     /* 2247303 */ /*GILLT_nxv8s64*//*Label 31604*/ GIMT_Encode4(2249178), GIMT_Encode4(0),
     /* 2247311 */ /*GILLT_nxv16s8*//*Label 31605*/ GIMT_Encode4(2249293),
     /* 2247315 */ /*GILLT_nxv16s16*//*Label 31606*/ GIMT_Encode4(2249408),
     /* 2247319 */ /*GILLT_nxv16s32*//*Label 31607*/ GIMT_Encode4(2249523), GIMT_Encode4(0),
     /* 2247327 */ /*GILLT_nxv32s8*//*Label 31608*/ GIMT_Encode4(2249638),
     /* 2247331 */ /*GILLT_nxv32s16*//*Label 31609*/ GIMT_Encode4(2249753), GIMT_Encode4(0),
     /* 2247339 */ /*GILLT_nxv64s8*//*Label 31610*/ GIMT_Encode4(2249868),
     /* 2247343 */ // Label 31587: @2247343
     /* 2247343 */ GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2247397),
     /* 2247348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2247351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2247354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247366 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2247381), // Rule ID 63779 //
     /* 2247371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2247374 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2247374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2247379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247380 */     // GIR_Coverage, 63779,
     /* 2247380 */     GIR_Done,
     /* 2247381 */   // Label 31613: @2247381
     /* 2247381 */   GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2247396), // Rule ID 2389 //
     /* 2247386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2247389 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2247389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2247394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247395 */     // GIR_Coverage, 2389,
     /* 2247395 */     GIR_Done,
     /* 2247396 */   // Label 31614: @2247396
     /* 2247396 */   GIM_Reject,
     /* 2247397 */ // Label 31612: @2247397
     /* 2247397 */ GIM_Reject,
     /* 2247398 */ // Label 31588: @2247398
     /* 2247398 */ GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2247452),
     /* 2247403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2247406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247421 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2247436), // Rule ID 63778 //
     /* 2247426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2247429 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2247434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247435 */     // GIR_Coverage, 63778,
     /* 2247435 */     GIR_Done,
     /* 2247436 */   // Label 31616: @2247436
     /* 2247436 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2247451), // Rule ID 2388 //
     /* 2247441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2247444 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2247449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247450 */     // GIR_Coverage, 2388,
     /* 2247450 */     GIR_Done,
     /* 2247451 */   // Label 31617: @2247451
     /* 2247451 */   GIM_Reject,
     /* 2247452 */ // Label 31615: @2247452
     /* 2247452 */ GIM_Reject,
     /* 2247453 */ // Label 31589: @2247453
     /* 2247453 */ GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2247567),
     /* 2247458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2247461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247476 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2247521), // Rule ID 50222 //
     /* 2247481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247484 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2247487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2247501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247520 */     // GIR_Coverage, 50222,
     /* 2247520 */     GIR_EraseRootFromParent_Done,
     /* 2247521 */   // Label 31619: @2247521
     /* 2247521 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2247566), // Rule ID 50223 //
     /* 2247526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247529 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2247532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2247546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247565 */     // GIR_Coverage, 50223,
     /* 2247565 */     GIR_EraseRootFromParent_Done,
     /* 2247566 */   // Label 31620: @2247566
     /* 2247566 */   GIM_Reject,
     /* 2247567 */ // Label 31618: @2247567
     /* 2247567 */ GIM_Reject,
     /* 2247568 */ // Label 31590: @2247568
     /* 2247568 */ GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2247682),
     /* 2247573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2247576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247591 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2247636), // Rule ID 50234 //
     /* 2247596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247599 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2247602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2247616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247635 */     // GIR_Coverage, 50234,
     /* 2247635 */     GIR_EraseRootFromParent_Done,
     /* 2247636 */   // Label 31622: @2247636
     /* 2247636 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2247681), // Rule ID 50235 //
     /* 2247641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247644 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2247647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2247661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247680 */     // GIR_Coverage, 50235,
     /* 2247680 */     GIR_EraseRootFromParent_Done,
     /* 2247681 */   // Label 31623: @2247681
     /* 2247681 */   GIM_Reject,
     /* 2247682 */ // Label 31621: @2247682
     /* 2247682 */ GIM_Reject,
     /* 2247683 */ // Label 31591: @2247683
     /* 2247683 */ GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2247797),
     /* 2247688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2247691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247706 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2247751), // Rule ID 50242 //
     /* 2247711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247714 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2247717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2247731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247750 */     // GIR_Coverage, 50242,
     /* 2247750 */     GIR_EraseRootFromParent_Done,
     /* 2247751 */   // Label 31625: @2247751
     /* 2247751 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2247796), // Rule ID 50243 //
     /* 2247756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247759 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2247762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2247776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247795 */     // GIR_Coverage, 50243,
     /* 2247795 */     GIR_EraseRootFromParent_Done,
     /* 2247796 */   // Label 31626: @2247796
     /* 2247796 */   GIM_Reject,
     /* 2247797 */ // Label 31624: @2247797
     /* 2247797 */ GIM_Reject,
     /* 2247798 */ // Label 31592: @2247798
     /* 2247798 */ GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2247912),
     /* 2247803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2247806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247821 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2247866), // Rule ID 50258 //
     /* 2247826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247829 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2247832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2247846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247865 */     // GIR_Coverage, 50258,
     /* 2247865 */     GIR_EraseRootFromParent_Done,
     /* 2247866 */   // Label 31628: @2247866
     /* 2247866 */   GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2247911), // Rule ID 50259 //
     /* 2247871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247874 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2247877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2247891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247910 */     // GIR_Coverage, 50259,
     /* 2247910 */     GIR_EraseRootFromParent_Done,
     /* 2247911 */   // Label 31629: @2247911
     /* 2247911 */   GIM_Reject,
     /* 2247912 */ // Label 31627: @2247912
     /* 2247912 */ GIM_Reject,
     /* 2247913 */ // Label 31593: @2247913
     /* 2247913 */ GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2248027),
     /* 2247918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2247921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2247924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247936 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2247981), // Rule ID 50226 //
     /* 2247941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247944 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2247947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2247961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2247968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2247980 */     // GIR_Coverage, 50226,
     /* 2247980 */     GIR_EraseRootFromParent_Done,
     /* 2247981 */   // Label 31631: @2247981
     /* 2247981 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2248026), // Rule ID 50227 //
     /* 2247986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247989 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2247992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2247996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2248006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248025 */     // GIR_Coverage, 50227,
     /* 2248025 */     GIR_EraseRootFromParent_Done,
     /* 2248026 */   // Label 31632: @2248026
     /* 2248026 */   GIM_Reject,
     /* 2248027 */ // Label 31630: @2248027
     /* 2248027 */ GIM_Reject,
     /* 2248028 */ // Label 31594: @2248028
     /* 2248028 */ GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2248142),
     /* 2248033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2248036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2248039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248051 */   GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2248096), // Rule ID 50238 //
     /* 2248056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248059 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2248062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2248076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248095 */     // GIR_Coverage, 50238,
     /* 2248095 */     GIR_EraseRootFromParent_Done,
     /* 2248096 */   // Label 31634: @2248096
     /* 2248096 */   GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2248141), // Rule ID 50239 //
     /* 2248101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248104 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2248107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2248121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248140 */     // GIR_Coverage, 50239,
     /* 2248140 */     GIR_EraseRootFromParent_Done,
     /* 2248141 */   // Label 31635: @2248141
     /* 2248141 */   GIM_Reject,
     /* 2248142 */ // Label 31633: @2248142
     /* 2248142 */ GIM_Reject,
     /* 2248143 */ // Label 31595: @2248143
     /* 2248143 */ GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2248257),
     /* 2248148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2248151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2248154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248166 */   GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2248211), // Rule ID 50254 //
     /* 2248171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248174 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2248177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248210 */     // GIR_Coverage, 50254,
     /* 2248210 */     GIR_EraseRootFromParent_Done,
     /* 2248211 */   // Label 31637: @2248211
     /* 2248211 */   GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2248256), // Rule ID 50255 //
     /* 2248216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248219 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2248222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248255 */     // GIR_Coverage, 50255,
     /* 2248255 */     GIR_EraseRootFromParent_Done,
     /* 2248256 */   // Label 31638: @2248256
     /* 2248256 */   GIM_Reject,
     /* 2248257 */ // Label 31636: @2248257
     /* 2248257 */ GIM_Reject,
     /* 2248258 */ // Label 31596: @2248258
     /* 2248258 */ GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2248372),
     /* 2248263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2248266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2248269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248281 */   GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2248326), // Rule ID 50298 //
     /* 2248286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248289 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2248292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2248306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248325 */     // GIR_Coverage, 50298,
     /* 2248325 */     GIR_EraseRootFromParent_Done,
     /* 2248326 */   // Label 31640: @2248326
     /* 2248326 */   GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2248371), // Rule ID 50299 //
     /* 2248331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248334 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2248337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2248351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248370 */     // GIR_Coverage, 50299,
     /* 2248370 */     GIR_EraseRootFromParent_Done,
     /* 2248371 */   // Label 31641: @2248371
     /* 2248371 */   GIM_Reject,
     /* 2248372 */ // Label 31639: @2248372
     /* 2248372 */ GIM_Reject,
     /* 2248373 */ // Label 31597: @2248373
     /* 2248373 */ GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2248487),
     /* 2248378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2248381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2248384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248396 */   GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2248441), // Rule ID 50230 //
     /* 2248401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248404 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2248407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2248421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248440 */     // GIR_Coverage, 50230,
     /* 2248440 */     GIR_EraseRootFromParent_Done,
     /* 2248441 */   // Label 31643: @2248441
     /* 2248441 */   GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2248486), // Rule ID 50231 //
     /* 2248446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248449 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2248452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2248466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248485 */     // GIR_Coverage, 50231,
     /* 2248485 */     GIR_EraseRootFromParent_Done,
     /* 2248486 */   // Label 31644: @2248486
     /* 2248486 */   GIM_Reject,
     /* 2248487 */ // Label 31642: @2248487
     /* 2248487 */ GIM_Reject,
     /* 2248488 */ // Label 31598: @2248488
     /* 2248488 */ GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2248602),
     /* 2248493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2248496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2248499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248511 */   GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2248556), // Rule ID 50250 //
     /* 2248516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248519 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2248522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248555 */     // GIR_Coverage, 50250,
     /* 2248555 */     GIR_EraseRootFromParent_Done,
     /* 2248556 */   // Label 31646: @2248556
     /* 2248556 */   GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2248601), // Rule ID 50251 //
     /* 2248561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248564 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2248567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248600 */     // GIR_Coverage, 50251,
     /* 2248600 */     GIR_EraseRootFromParent_Done,
     /* 2248601 */   // Label 31647: @2248601
     /* 2248601 */   GIM_Reject,
     /* 2248602 */ // Label 31645: @2248602
     /* 2248602 */ GIM_Reject,
     /* 2248603 */ // Label 31599: @2248603
     /* 2248603 */ GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2248717),
     /* 2248608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2248611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2248614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248626 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2248671), // Rule ID 50286 //
     /* 2248631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248634 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2248637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2248651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248670 */     // GIR_Coverage, 50286,
     /* 2248670 */     GIR_EraseRootFromParent_Done,
     /* 2248671 */   // Label 31649: @2248671
     /* 2248671 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2248716), // Rule ID 50287 //
     /* 2248676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248679 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2248682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2248696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248715 */     // GIR_Coverage, 50287,
     /* 2248715 */     GIR_EraseRootFromParent_Done,
     /* 2248716 */   // Label 31650: @2248716
     /* 2248716 */   GIM_Reject,
     /* 2248717 */ // Label 31648: @2248717
     /* 2248717 */ GIM_Reject,
     /* 2248718 */ // Label 31600: @2248718
     /* 2248718 */ GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2248832),
     /* 2248723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2248726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2248729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248741 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2248786), // Rule ID 50302 //
     /* 2248746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248749 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2248752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2248766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248785 */     // GIR_Coverage, 50302,
     /* 2248785 */     GIR_EraseRootFromParent_Done,
     /* 2248786 */   // Label 31652: @2248786
     /* 2248786 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2248831), // Rule ID 50303 //
     /* 2248791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248794 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2248797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2248811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248830 */     // GIR_Coverage, 50303,
     /* 2248830 */     GIR_EraseRootFromParent_Done,
     /* 2248831 */   // Label 31653: @2248831
     /* 2248831 */   GIM_Reject,
     /* 2248832 */ // Label 31651: @2248832
     /* 2248832 */ GIM_Reject,
     /* 2248833 */ // Label 31601: @2248833
     /* 2248833 */ GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2248947),
     /* 2248838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2248841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248856 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2248901), // Rule ID 50246 //
     /* 2248861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248864 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2248867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248900 */     // GIR_Coverage, 50246,
     /* 2248900 */     GIR_EraseRootFromParent_Done,
     /* 2248901 */   // Label 31655: @2248901
     /* 2248901 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2248946), // Rule ID 50247 //
     /* 2248906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248909 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2248912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2248926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2248933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2248945 */     // GIR_Coverage, 50247,
     /* 2248945 */     GIR_EraseRootFromParent_Done,
     /* 2248946 */   // Label 31656: @2248946
     /* 2248946 */   GIM_Reject,
     /* 2248947 */ // Label 31654: @2248947
     /* 2248947 */ GIM_Reject,
     /* 2248948 */ // Label 31602: @2248948
     /* 2248948 */ GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2249062),
     /* 2248953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2248956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248971 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2249016), // Rule ID 50274 //
     /* 2248976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248979 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2248982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2248986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2248996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249015 */     // GIR_Coverage, 50274,
     /* 2249015 */     GIR_EraseRootFromParent_Done,
     /* 2249016 */   // Label 31658: @2249016
     /* 2249016 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2249061), // Rule ID 50275 //
     /* 2249021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249024 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2249027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2249041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249060 */     // GIR_Coverage, 50275,
     /* 2249060 */     GIR_EraseRootFromParent_Done,
     /* 2249061 */   // Label 31659: @2249061
     /* 2249061 */   GIM_Reject,
     /* 2249062 */ // Label 31657: @2249062
     /* 2249062 */ GIM_Reject,
     /* 2249063 */ // Label 31603: @2249063
     /* 2249063 */ GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2249177),
     /* 2249068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2249071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249086 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2249131), // Rule ID 50290 //
     /* 2249091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249094 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2249097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249130 */     // GIR_Coverage, 50290,
     /* 2249130 */     GIR_EraseRootFromParent_Done,
     /* 2249131 */   // Label 31661: @2249131
     /* 2249131 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2249176), // Rule ID 50291 //
     /* 2249136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249139 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2249142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249175 */     // GIR_Coverage, 50291,
     /* 2249175 */     GIR_EraseRootFromParent_Done,
     /* 2249176 */   // Label 31662: @2249176
     /* 2249176 */   GIM_Reject,
     /* 2249177 */ // Label 31660: @2249177
     /* 2249177 */ GIM_Reject,
     /* 2249178 */ // Label 31604: @2249178
     /* 2249178 */ GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2249292),
     /* 2249183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2249186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249201 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2249246), // Rule ID 50306 //
     /* 2249206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249209 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2249212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249245 */     // GIR_Coverage, 50306,
     /* 2249245 */     GIR_EraseRootFromParent_Done,
     /* 2249246 */   // Label 31664: @2249246
     /* 2249246 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2249291), // Rule ID 50307 //
     /* 2249251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249254 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2249257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249290 */     // GIR_Coverage, 50307,
     /* 2249290 */     GIR_EraseRootFromParent_Done,
     /* 2249291 */   // Label 31665: @2249291
     /* 2249291 */   GIM_Reject,
     /* 2249292 */ // Label 31663: @2249292
     /* 2249292 */ GIM_Reject,
     /* 2249293 */ // Label 31605: @2249293
     /* 2249293 */ GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2249407),
     /* 2249298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2249301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2249304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249316 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2249361), // Rule ID 50262 //
     /* 2249321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249324 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2249327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2249341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249360 */     // GIR_Coverage, 50262,
     /* 2249360 */     GIR_EraseRootFromParent_Done,
     /* 2249361 */   // Label 31667: @2249361
     /* 2249361 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2249406), // Rule ID 50263 //
     /* 2249366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249369 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2249372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2249386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249405 */     // GIR_Coverage, 50263,
     /* 2249405 */     GIR_EraseRootFromParent_Done,
     /* 2249406 */   // Label 31668: @2249406
     /* 2249406 */   GIM_Reject,
     /* 2249407 */ // Label 31666: @2249407
     /* 2249407 */ GIM_Reject,
     /* 2249408 */ // Label 31606: @2249408
     /* 2249408 */ GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2249522),
     /* 2249413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2249416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2249419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249431 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2249476), // Rule ID 50278 //
     /* 2249436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249439 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2249442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249475 */     // GIR_Coverage, 50278,
     /* 2249475 */     GIR_EraseRootFromParent_Done,
     /* 2249476 */   // Label 31670: @2249476
     /* 2249476 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2249521), // Rule ID 50279 //
     /* 2249481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249484 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2249487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249520 */     // GIR_Coverage, 50279,
     /* 2249520 */     GIR_EraseRootFromParent_Done,
     /* 2249521 */   // Label 31671: @2249521
     /* 2249521 */   GIM_Reject,
     /* 2249522 */ // Label 31669: @2249522
     /* 2249522 */ GIM_Reject,
     /* 2249523 */ // Label 31607: @2249523
     /* 2249523 */ GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2249637),
     /* 2249528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2249531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2249534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249546 */   GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2249591), // Rule ID 50294 //
     /* 2249551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249554 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2249557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249590 */     // GIR_Coverage, 50294,
     /* 2249590 */     GIR_EraseRootFromParent_Done,
     /* 2249591 */   // Label 31673: @2249591
     /* 2249591 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2249636), // Rule ID 50295 //
     /* 2249596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249599 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2249602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249635 */     // GIR_Coverage, 50295,
     /* 2249635 */     GIR_EraseRootFromParent_Done,
     /* 2249636 */   // Label 31674: @2249636
     /* 2249636 */   GIM_Reject,
     /* 2249637 */ // Label 31672: @2249637
     /* 2249637 */ GIM_Reject,
     /* 2249638 */ // Label 31608: @2249638
     /* 2249638 */ GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2249752),
     /* 2249643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2249646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249661 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2249706), // Rule ID 50266 //
     /* 2249666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249669 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2249672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249705 */     // GIR_Coverage, 50266,
     /* 2249705 */     GIR_EraseRootFromParent_Done,
     /* 2249706 */   // Label 31676: @2249706
     /* 2249706 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2249751), // Rule ID 50267 //
     /* 2249711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249714 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2249717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2249731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249750 */     // GIR_Coverage, 50267,
     /* 2249750 */     GIR_EraseRootFromParent_Done,
     /* 2249751 */   // Label 31677: @2249751
     /* 2249751 */   GIM_Reject,
     /* 2249752 */ // Label 31675: @2249752
     /* 2249752 */ GIM_Reject,
     /* 2249753 */ // Label 31609: @2249753
     /* 2249753 */ GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2249867),
     /* 2249758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2249761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249776 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2249821), // Rule ID 50282 //
     /* 2249781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249784 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2249787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249820 */     // GIR_Coverage, 50282,
     /* 2249820 */     GIR_EraseRootFromParent_Done,
     /* 2249821 */   // Label 31679: @2249821
     /* 2249821 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2249866), // Rule ID 50283 //
     /* 2249826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249829 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2249832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249865 */     // GIR_Coverage, 50283,
     /* 2249865 */     GIR_EraseRootFromParent_Done,
     /* 2249866 */   // Label 31680: @2249866
     /* 2249866 */   GIM_Reject,
     /* 2249867 */ // Label 31678: @2249867
     /* 2249867 */ GIM_Reject,
     /* 2249868 */ // Label 31610: @2249868
     /* 2249868 */ GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2249982),
     /* 2249873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2249876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2249879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249891 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2249936), // Rule ID 50270 //
     /* 2249896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249899 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2249902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249935 */     // GIR_Coverage, 50270,
     /* 2249935 */     GIR_EraseRootFromParent_Done,
     /* 2249936 */   // Label 31682: @2249936
     /* 2249936 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2249981), // Rule ID 50271 //
     /* 2249941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249944 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2249947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2249951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2249956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2249958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2249961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2249966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2249968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2249980 */     // GIR_Coverage, 50271,
     /* 2249980 */     GIR_EraseRootFromParent_Done,
     /* 2249981 */   // Label 31683: @2249981
     /* 2249981 */   GIM_Reject,
     /* 2249982 */ // Label 31681: @2249982
     /* 2249982 */ GIM_Reject,
     /* 2249983 */ // Label 31611: @2249983
     /* 2249983 */ GIM_Reject,
     /* 2249984 */ // Label 78: @2249984
     /* 2249984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31708*/ GIMT_Encode4(2252759),
     /* 2249995 */ /*GILLT_s32*//*Label 31684*/ GIMT_Encode4(2250119),
     /* 2249999 */ /*GILLT_s64*//*Label 31685*/ GIMT_Encode4(2250174), GIMT_Encode4(0),
     /* 2250007 */ /*GILLT_nxv1s8*//*Label 31686*/ GIMT_Encode4(2250229),
     /* 2250011 */ /*GILLT_nxv1s16*//*Label 31687*/ GIMT_Encode4(2250344),
     /* 2250015 */ /*GILLT_nxv1s32*//*Label 31688*/ GIMT_Encode4(2250459),
     /* 2250019 */ /*GILLT_nxv1s64*//*Label 31689*/ GIMT_Encode4(2250574), GIMT_Encode4(0),
     /* 2250027 */ /*GILLT_nxv2s8*//*Label 31690*/ GIMT_Encode4(2250689),
     /* 2250031 */ /*GILLT_nxv2s16*//*Label 31691*/ GIMT_Encode4(2250804),
     /* 2250035 */ /*GILLT_nxv2s32*//*Label 31692*/ GIMT_Encode4(2250919),
     /* 2250039 */ /*GILLT_nxv2s64*//*Label 31693*/ GIMT_Encode4(2251034), GIMT_Encode4(0),
     /* 2250047 */ /*GILLT_nxv4s8*//*Label 31694*/ GIMT_Encode4(2251149),
     /* 2250051 */ /*GILLT_nxv4s16*//*Label 31695*/ GIMT_Encode4(2251264),
     /* 2250055 */ /*GILLT_nxv4s32*//*Label 31696*/ GIMT_Encode4(2251379),
     /* 2250059 */ /*GILLT_nxv4s64*//*Label 31697*/ GIMT_Encode4(2251494), GIMT_Encode4(0),
     /* 2250067 */ /*GILLT_nxv8s8*//*Label 31698*/ GIMT_Encode4(2251609),
     /* 2250071 */ /*GILLT_nxv8s16*//*Label 31699*/ GIMT_Encode4(2251724),
     /* 2250075 */ /*GILLT_nxv8s32*//*Label 31700*/ GIMT_Encode4(2251839),
     /* 2250079 */ /*GILLT_nxv8s64*//*Label 31701*/ GIMT_Encode4(2251954), GIMT_Encode4(0),
     /* 2250087 */ /*GILLT_nxv16s8*//*Label 31702*/ GIMT_Encode4(2252069),
     /* 2250091 */ /*GILLT_nxv16s16*//*Label 31703*/ GIMT_Encode4(2252184),
     /* 2250095 */ /*GILLT_nxv16s32*//*Label 31704*/ GIMT_Encode4(2252299), GIMT_Encode4(0),
     /* 2250103 */ /*GILLT_nxv32s8*//*Label 31705*/ GIMT_Encode4(2252414),
     /* 2250107 */ /*GILLT_nxv32s16*//*Label 31706*/ GIMT_Encode4(2252529), GIMT_Encode4(0),
     /* 2250115 */ /*GILLT_nxv64s8*//*Label 31707*/ GIMT_Encode4(2252644),
     /* 2250119 */ // Label 31684: @2250119
     /* 2250119 */ GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2250173),
     /* 2250124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2250127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2250130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250142 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2250157), // Rule ID 63777 //
     /* 2250147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2250150 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2250150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2250155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250156 */     // GIR_Coverage, 63777,
     /* 2250156 */     GIR_Done,
     /* 2250157 */   // Label 31710: @2250157
     /* 2250157 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2250172), // Rule ID 2391 //
     /* 2250162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2250165 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2250165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2250170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250171 */     // GIR_Coverage, 2391,
     /* 2250171 */     GIR_Done,
     /* 2250172 */   // Label 31711: @2250172
     /* 2250172 */   GIM_Reject,
     /* 2250173 */ // Label 31709: @2250173
     /* 2250173 */ GIM_Reject,
     /* 2250174 */ // Label 31685: @2250174
     /* 2250174 */ GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2250228),
     /* 2250179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2250182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2250185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2250197 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2250212), // Rule ID 63776 //
     /* 2250202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2250205 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2250205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2250210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250211 */     // GIR_Coverage, 63776,
     /* 2250211 */     GIR_Done,
     /* 2250212 */   // Label 31713: @2250212
     /* 2250212 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2250227), // Rule ID 2390 //
     /* 2250217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2250220 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2250220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2250225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250226 */     // GIR_Coverage, 2390,
     /* 2250226 */     GIR_Done,
     /* 2250227 */   // Label 31714: @2250227
     /* 2250227 */   GIM_Reject,
     /* 2250228 */ // Label 31712: @2250228
     /* 2250228 */ GIM_Reject,
     /* 2250229 */ // Label 31686: @2250229
     /* 2250229 */ GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2250343),
     /* 2250234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2250237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2250240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250252 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2250297), // Rule ID 49958 //
     /* 2250257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250260 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2250263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2250277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250296 */     // GIR_Coverage, 49958,
     /* 2250296 */     GIR_EraseRootFromParent_Done,
     /* 2250297 */   // Label 31716: @2250297
     /* 2250297 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2250342), // Rule ID 49959 //
     /* 2250302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250305 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2250308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2250322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250341 */     // GIR_Coverage, 49959,
     /* 2250341 */     GIR_EraseRootFromParent_Done,
     /* 2250342 */   // Label 31717: @2250342
     /* 2250342 */   GIM_Reject,
     /* 2250343 */ // Label 31715: @2250343
     /* 2250343 */ GIM_Reject,
     /* 2250344 */ // Label 31687: @2250344
     /* 2250344 */ GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2250458),
     /* 2250349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2250352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250367 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2250412), // Rule ID 49970 //
     /* 2250372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250375 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2250378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2250392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250411 */     // GIR_Coverage, 49970,
     /* 2250411 */     GIR_EraseRootFromParent_Done,
     /* 2250412 */   // Label 31719: @2250412
     /* 2250412 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2250457), // Rule ID 49971 //
     /* 2250417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250420 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2250423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2250437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250456 */     // GIR_Coverage, 49971,
     /* 2250456 */     GIR_EraseRootFromParent_Done,
     /* 2250457 */   // Label 31720: @2250457
     /* 2250457 */   GIM_Reject,
     /* 2250458 */ // Label 31718: @2250458
     /* 2250458 */ GIM_Reject,
     /* 2250459 */ // Label 31688: @2250459
     /* 2250459 */ GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2250573),
     /* 2250464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2250467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250482 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2250527), // Rule ID 49978 //
     /* 2250487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250490 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2250493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2250507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250526 */     // GIR_Coverage, 49978,
     /* 2250526 */     GIR_EraseRootFromParent_Done,
     /* 2250527 */   // Label 31722: @2250527
     /* 2250527 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2250572), // Rule ID 49979 //
     /* 2250532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250535 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2250538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2250552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250571 */     // GIR_Coverage, 49979,
     /* 2250571 */     GIR_EraseRootFromParent_Done,
     /* 2250572 */   // Label 31723: @2250572
     /* 2250572 */   GIM_Reject,
     /* 2250573 */ // Label 31721: @2250573
     /* 2250573 */ GIM_Reject,
     /* 2250574 */ // Label 31689: @2250574
     /* 2250574 */ GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2250688),
     /* 2250579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2250582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250597 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2250642), // Rule ID 49994 //
     /* 2250602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250605 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2250608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2250622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250641 */     // GIR_Coverage, 49994,
     /* 2250641 */     GIR_EraseRootFromParent_Done,
     /* 2250642 */   // Label 31725: @2250642
     /* 2250642 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2250687), // Rule ID 49995 //
     /* 2250647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250650 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2250653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2250667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250686 */     // GIR_Coverage, 49995,
     /* 2250686 */     GIR_EraseRootFromParent_Done,
     /* 2250687 */   // Label 31726: @2250687
     /* 2250687 */   GIM_Reject,
     /* 2250688 */ // Label 31724: @2250688
     /* 2250688 */ GIM_Reject,
     /* 2250689 */ // Label 31690: @2250689
     /* 2250689 */ GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2250803),
     /* 2250694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2250697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250712 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2250757), // Rule ID 49962 //
     /* 2250717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250720 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2250723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2250737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250756 */     // GIR_Coverage, 49962,
     /* 2250756 */     GIR_EraseRootFromParent_Done,
     /* 2250757 */   // Label 31728: @2250757
     /* 2250757 */   GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2250802), // Rule ID 49963 //
     /* 2250762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250765 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2250768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2250782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250801 */     // GIR_Coverage, 49963,
     /* 2250801 */     GIR_EraseRootFromParent_Done,
     /* 2250802 */   // Label 31729: @2250802
     /* 2250802 */   GIM_Reject,
     /* 2250803 */ // Label 31727: @2250803
     /* 2250803 */ GIM_Reject,
     /* 2250804 */ // Label 31691: @2250804
     /* 2250804 */ GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2250918),
     /* 2250809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2250812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250827 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2250872), // Rule ID 49974 //
     /* 2250832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250835 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2250838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2250852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250871 */     // GIR_Coverage, 49974,
     /* 2250871 */     GIR_EraseRootFromParent_Done,
     /* 2250872 */   // Label 31731: @2250872
     /* 2250872 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2250917), // Rule ID 49975 //
     /* 2250877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250880 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2250883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2250897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250916 */     // GIR_Coverage, 49975,
     /* 2250916 */     GIR_EraseRootFromParent_Done,
     /* 2250917 */   // Label 31732: @2250917
     /* 2250917 */   GIM_Reject,
     /* 2250918 */ // Label 31730: @2250918
     /* 2250918 */ GIM_Reject,
     /* 2250919 */ // Label 31692: @2250919
     /* 2250919 */ GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2251033),
     /* 2250924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2250927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250942 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2250987), // Rule ID 49990 //
     /* 2250947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250950 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2250953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2250957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2250962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2250964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2250967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2250972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2250974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2250986 */     // GIR_Coverage, 49990,
     /* 2250986 */     GIR_EraseRootFromParent_Done,
     /* 2250987 */   // Label 31734: @2250987
     /* 2250987 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2251032), // Rule ID 49991 //
     /* 2250992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250995 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2250998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2251012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251031 */     // GIR_Coverage, 49991,
     /* 2251031 */     GIR_EraseRootFromParent_Done,
     /* 2251032 */   // Label 31735: @2251032
     /* 2251032 */   GIM_Reject,
     /* 2251033 */ // Label 31733: @2251033
     /* 2251033 */ GIM_Reject,
     /* 2251034 */ // Label 31693: @2251034
     /* 2251034 */ GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2251148),
     /* 2251039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2251042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251057 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2251102), // Rule ID 50034 //
     /* 2251062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251065 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2251068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251101 */     // GIR_Coverage, 50034,
     /* 2251101 */     GIR_EraseRootFromParent_Done,
     /* 2251102 */   // Label 31737: @2251102
     /* 2251102 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2251147), // Rule ID 50035 //
     /* 2251107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251110 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2251113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251146 */     // GIR_Coverage, 50035,
     /* 2251146 */     GIR_EraseRootFromParent_Done,
     /* 2251147 */   // Label 31738: @2251147
     /* 2251147 */   GIM_Reject,
     /* 2251148 */ // Label 31736: @2251148
     /* 2251148 */ GIM_Reject,
     /* 2251149 */ // Label 31694: @2251149
     /* 2251149 */ GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2251263),
     /* 2251154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2251157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2251160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251172 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2251217), // Rule ID 49966 //
     /* 2251177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251180 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2251183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2251197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251216 */     // GIR_Coverage, 49966,
     /* 2251216 */     GIR_EraseRootFromParent_Done,
     /* 2251217 */   // Label 31740: @2251217
     /* 2251217 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2251262), // Rule ID 49967 //
     /* 2251222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251225 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2251228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2251242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251261 */     // GIR_Coverage, 49967,
     /* 2251261 */     GIR_EraseRootFromParent_Done,
     /* 2251262 */   // Label 31741: @2251262
     /* 2251262 */   GIM_Reject,
     /* 2251263 */ // Label 31739: @2251263
     /* 2251263 */ GIM_Reject,
     /* 2251264 */ // Label 31695: @2251264
     /* 2251264 */ GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2251378),
     /* 2251269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2251272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2251275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251287 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2251332), // Rule ID 49986 //
     /* 2251292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251295 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2251298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2251312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251331 */     // GIR_Coverage, 49986,
     /* 2251331 */     GIR_EraseRootFromParent_Done,
     /* 2251332 */   // Label 31743: @2251332
     /* 2251332 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2251377), // Rule ID 49987 //
     /* 2251337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251340 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2251343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2251357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251376 */     // GIR_Coverage, 49987,
     /* 2251376 */     GIR_EraseRootFromParent_Done,
     /* 2251377 */   // Label 31744: @2251377
     /* 2251377 */   GIM_Reject,
     /* 2251378 */ // Label 31742: @2251378
     /* 2251378 */ GIM_Reject,
     /* 2251379 */ // Label 31696: @2251379
     /* 2251379 */ GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2251493),
     /* 2251384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2251387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2251390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251402 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2251447), // Rule ID 50022 //
     /* 2251407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251410 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2251413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251446 */     // GIR_Coverage, 50022,
     /* 2251446 */     GIR_EraseRootFromParent_Done,
     /* 2251447 */   // Label 31746: @2251447
     /* 2251447 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2251492), // Rule ID 50023 //
     /* 2251452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251455 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2251458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251491 */     // GIR_Coverage, 50023,
     /* 2251491 */     GIR_EraseRootFromParent_Done,
     /* 2251492 */   // Label 31747: @2251492
     /* 2251492 */   GIM_Reject,
     /* 2251493 */ // Label 31745: @2251493
     /* 2251493 */ GIM_Reject,
     /* 2251494 */ // Label 31697: @2251494
     /* 2251494 */ GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2251608),
     /* 2251499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2251502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2251505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251517 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2251562), // Rule ID 50038 //
     /* 2251522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251525 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2251528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2251542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251561 */     // GIR_Coverage, 50038,
     /* 2251561 */     GIR_EraseRootFromParent_Done,
     /* 2251562 */   // Label 31749: @2251562
     /* 2251562 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2251607), // Rule ID 50039 //
     /* 2251567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251570 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2251573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2251587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251606 */     // GIR_Coverage, 50039,
     /* 2251606 */     GIR_EraseRootFromParent_Done,
     /* 2251607 */   // Label 31750: @2251607
     /* 2251607 */   GIM_Reject,
     /* 2251608 */ // Label 31748: @2251608
     /* 2251608 */ GIM_Reject,
     /* 2251609 */ // Label 31698: @2251609
     /* 2251609 */ GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2251723),
     /* 2251614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2251617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2251620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251632 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2251677), // Rule ID 49982 //
     /* 2251637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251640 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2251643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2251657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251676 */     // GIR_Coverage, 49982,
     /* 2251676 */     GIR_EraseRootFromParent_Done,
     /* 2251677 */   // Label 31752: @2251677
     /* 2251677 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2251722), // Rule ID 49983 //
     /* 2251682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251685 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2251688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2251702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251721 */     // GIR_Coverage, 49983,
     /* 2251721 */     GIR_EraseRootFromParent_Done,
     /* 2251722 */   // Label 31753: @2251722
     /* 2251722 */   GIM_Reject,
     /* 2251723 */ // Label 31751: @2251723
     /* 2251723 */ GIM_Reject,
     /* 2251724 */ // Label 31699: @2251724
     /* 2251724 */ GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2251838),
     /* 2251729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2251732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2251735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251747 */   GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2251792), // Rule ID 50010 //
     /* 2251752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251755 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2251758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251791 */     // GIR_Coverage, 50010,
     /* 2251791 */     GIR_EraseRootFromParent_Done,
     /* 2251792 */   // Label 31755: @2251792
     /* 2251792 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2251837), // Rule ID 50011 //
     /* 2251797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251800 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2251803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2251817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251836 */     // GIR_Coverage, 50011,
     /* 2251836 */     GIR_EraseRootFromParent_Done,
     /* 2251837 */   // Label 31756: @2251837
     /* 2251837 */   GIM_Reject,
     /* 2251838 */ // Label 31754: @2251838
     /* 2251838 */ GIM_Reject,
     /* 2251839 */ // Label 31700: @2251839
     /* 2251839 */ GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2251953),
     /* 2251844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2251847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2251850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251862 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2251907), // Rule ID 50026 //
     /* 2251867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251870 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2251873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2251887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251906 */     // GIR_Coverage, 50026,
     /* 2251906 */     GIR_EraseRootFromParent_Done,
     /* 2251907 */   // Label 31758: @2251907
     /* 2251907 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2251952), // Rule ID 50027 //
     /* 2251912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251915 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2251918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2251932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2251937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2251939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251951 */     // GIR_Coverage, 50027,
     /* 2251951 */     GIR_EraseRootFromParent_Done,
     /* 2251952 */   // Label 31759: @2251952
     /* 2251952 */   GIM_Reject,
     /* 2251953 */ // Label 31757: @2251953
     /* 2251953 */ GIM_Reject,
     /* 2251954 */ // Label 31701: @2251954
     /* 2251954 */ GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2252068),
     /* 2251959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2251962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2251965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251977 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2252022), // Rule ID 50042 //
     /* 2251982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251985 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2251988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2251992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2251997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2251999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252021 */     // GIR_Coverage, 50042,
     /* 2252021 */     GIR_EraseRootFromParent_Done,
     /* 2252022 */   // Label 31761: @2252022
     /* 2252022 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2252067), // Rule ID 50043 //
     /* 2252027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252030 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2252033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252066 */     // GIR_Coverage, 50043,
     /* 2252066 */     GIR_EraseRootFromParent_Done,
     /* 2252067 */   // Label 31762: @2252067
     /* 2252067 */   GIM_Reject,
     /* 2252068 */ // Label 31760: @2252068
     /* 2252068 */ GIM_Reject,
     /* 2252069 */ // Label 31702: @2252069
     /* 2252069 */ GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2252183),
     /* 2252074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2252077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252092 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2252137), // Rule ID 49998 //
     /* 2252097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252100 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2252103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2252117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252136 */     // GIR_Coverage, 49998,
     /* 2252136 */     GIR_EraseRootFromParent_Done,
     /* 2252137 */   // Label 31764: @2252137
     /* 2252137 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2252182), // Rule ID 49999 //
     /* 2252142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252145 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2252148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2252162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252181 */     // GIR_Coverage, 49999,
     /* 2252181 */     GIR_EraseRootFromParent_Done,
     /* 2252182 */   // Label 31765: @2252182
     /* 2252182 */   GIM_Reject,
     /* 2252183 */ // Label 31763: @2252183
     /* 2252183 */ GIM_Reject,
     /* 2252184 */ // Label 31703: @2252184
     /* 2252184 */ GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2252298),
     /* 2252189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2252192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252207 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2252252), // Rule ID 50014 //
     /* 2252212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252215 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2252218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2252232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252251 */     // GIR_Coverage, 50014,
     /* 2252251 */     GIR_EraseRootFromParent_Done,
     /* 2252252 */   // Label 31767: @2252252
     /* 2252252 */   GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2252297), // Rule ID 50015 //
     /* 2252257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252260 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2252263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2252277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252296 */     // GIR_Coverage, 50015,
     /* 2252296 */     GIR_EraseRootFromParent_Done,
     /* 2252297 */   // Label 31768: @2252297
     /* 2252297 */   GIM_Reject,
     /* 2252298 */ // Label 31766: @2252298
     /* 2252298 */ GIM_Reject,
     /* 2252299 */ // Label 31704: @2252299
     /* 2252299 */ GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2252413),
     /* 2252304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2252307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252322 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2252367), // Rule ID 50030 //
     /* 2252327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252330 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2252333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252366 */     // GIR_Coverage, 50030,
     /* 2252366 */     GIR_EraseRootFromParent_Done,
     /* 2252367 */   // Label 31770: @2252367
     /* 2252367 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2252412), // Rule ID 50031 //
     /* 2252372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252375 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2252378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252411 */     // GIR_Coverage, 50031,
     /* 2252411 */     GIR_EraseRootFromParent_Done,
     /* 2252412 */   // Label 31771: @2252412
     /* 2252412 */   GIM_Reject,
     /* 2252413 */ // Label 31769: @2252413
     /* 2252413 */ GIM_Reject,
     /* 2252414 */ // Label 31705: @2252414
     /* 2252414 */ GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2252528),
     /* 2252419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2252422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2252425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252437 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2252482), // Rule ID 50002 //
     /* 2252442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252445 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2252448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2252462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252481 */     // GIR_Coverage, 50002,
     /* 2252481 */     GIR_EraseRootFromParent_Done,
     /* 2252482 */   // Label 31773: @2252482
     /* 2252482 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2252527), // Rule ID 50003 //
     /* 2252487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252490 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2252493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2252507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252526 */     // GIR_Coverage, 50003,
     /* 2252526 */     GIR_EraseRootFromParent_Done,
     /* 2252527 */   // Label 31774: @2252527
     /* 2252527 */   GIM_Reject,
     /* 2252528 */ // Label 31772: @2252528
     /* 2252528 */ GIM_Reject,
     /* 2252529 */ // Label 31706: @2252529
     /* 2252529 */ GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2252643),
     /* 2252534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2252537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2252540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252552 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2252597), // Rule ID 50018 //
     /* 2252557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252560 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2252563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252596 */     // GIR_Coverage, 50018,
     /* 2252596 */     GIR_EraseRootFromParent_Done,
     /* 2252597 */   // Label 31776: @2252597
     /* 2252597 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2252642), // Rule ID 50019 //
     /* 2252602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252605 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2252608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252641 */     // GIR_Coverage, 50019,
     /* 2252641 */     GIR_EraseRootFromParent_Done,
     /* 2252642 */   // Label 31777: @2252642
     /* 2252642 */   GIM_Reject,
     /* 2252643 */ // Label 31775: @2252643
     /* 2252643 */ GIM_Reject,
     /* 2252644 */ // Label 31707: @2252644
     /* 2252644 */ GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2252758),
     /* 2252649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2252652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2252655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252667 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2252712), // Rule ID 50006 //
     /* 2252672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252675 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2252678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252711 */     // GIR_Coverage, 50006,
     /* 2252711 */     GIR_EraseRootFromParent_Done,
     /* 2252712 */   // Label 31779: @2252712
     /* 2252712 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2252757), // Rule ID 50007 //
     /* 2252717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252720 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2252723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2252727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2252732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2252734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2252737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2252742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2252744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252756 */     // GIR_Coverage, 50007,
     /* 2252756 */     GIR_EraseRootFromParent_Done,
     /* 2252757 */   // Label 31780: @2252757
     /* 2252757 */   GIM_Reject,
     /* 2252758 */ // Label 31778: @2252758
     /* 2252758 */ GIM_Reject,
     /* 2252759 */ // Label 31708: @2252759
     /* 2252759 */ GIM_Reject,
     /* 2252760 */ // Label 79: @2252760
     /* 2252760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31805*/ GIMT_Encode4(2255535),
     /* 2252771 */ /*GILLT_s32*//*Label 31781*/ GIMT_Encode4(2252895),
     /* 2252775 */ /*GILLT_s64*//*Label 31782*/ GIMT_Encode4(2252950), GIMT_Encode4(0),
     /* 2252783 */ /*GILLT_nxv1s8*//*Label 31783*/ GIMT_Encode4(2253005),
     /* 2252787 */ /*GILLT_nxv1s16*//*Label 31784*/ GIMT_Encode4(2253120),
     /* 2252791 */ /*GILLT_nxv1s32*//*Label 31785*/ GIMT_Encode4(2253235),
     /* 2252795 */ /*GILLT_nxv1s64*//*Label 31786*/ GIMT_Encode4(2253350), GIMT_Encode4(0),
     /* 2252803 */ /*GILLT_nxv2s8*//*Label 31787*/ GIMT_Encode4(2253465),
     /* 2252807 */ /*GILLT_nxv2s16*//*Label 31788*/ GIMT_Encode4(2253580),
     /* 2252811 */ /*GILLT_nxv2s32*//*Label 31789*/ GIMT_Encode4(2253695),
     /* 2252815 */ /*GILLT_nxv2s64*//*Label 31790*/ GIMT_Encode4(2253810), GIMT_Encode4(0),
     /* 2252823 */ /*GILLT_nxv4s8*//*Label 31791*/ GIMT_Encode4(2253925),
     /* 2252827 */ /*GILLT_nxv4s16*//*Label 31792*/ GIMT_Encode4(2254040),
     /* 2252831 */ /*GILLT_nxv4s32*//*Label 31793*/ GIMT_Encode4(2254155),
     /* 2252835 */ /*GILLT_nxv4s64*//*Label 31794*/ GIMT_Encode4(2254270), GIMT_Encode4(0),
     /* 2252843 */ /*GILLT_nxv8s8*//*Label 31795*/ GIMT_Encode4(2254385),
     /* 2252847 */ /*GILLT_nxv8s16*//*Label 31796*/ GIMT_Encode4(2254500),
     /* 2252851 */ /*GILLT_nxv8s32*//*Label 31797*/ GIMT_Encode4(2254615),
     /* 2252855 */ /*GILLT_nxv8s64*//*Label 31798*/ GIMT_Encode4(2254730), GIMT_Encode4(0),
     /* 2252863 */ /*GILLT_nxv16s8*//*Label 31799*/ GIMT_Encode4(2254845),
     /* 2252867 */ /*GILLT_nxv16s16*//*Label 31800*/ GIMT_Encode4(2254960),
     /* 2252871 */ /*GILLT_nxv16s32*//*Label 31801*/ GIMT_Encode4(2255075), GIMT_Encode4(0),
     /* 2252879 */ /*GILLT_nxv32s8*//*Label 31802*/ GIMT_Encode4(2255190),
     /* 2252883 */ /*GILLT_nxv32s16*//*Label 31803*/ GIMT_Encode4(2255305), GIMT_Encode4(0),
     /* 2252891 */ /*GILLT_nxv64s8*//*Label 31804*/ GIMT_Encode4(2255420),
     /* 2252895 */ // Label 31781: @2252895
     /* 2252895 */ GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2252949),
     /* 2252900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2252903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252918 */   GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2252933), // Rule ID 63781 //
     /* 2252923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2252926 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2252926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2252931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252932 */     // GIR_Coverage, 63781,
     /* 2252932 */     GIR_Done,
     /* 2252933 */   // Label 31807: @2252933
     /* 2252933 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2252948), // Rule ID 2393 //
     /* 2252938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2252941 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2252941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2252946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252947 */     // GIR_Coverage, 2393,
     /* 2252947 */     GIR_Done,
     /* 2252948 */   // Label 31808: @2252948
     /* 2252948 */   GIM_Reject,
     /* 2252949 */ // Label 31806: @2252949
     /* 2252949 */ GIM_Reject,
     /* 2252950 */ // Label 31782: @2252950
     /* 2252950 */ GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2253004),
     /* 2252955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2252958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252973 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2252988), // Rule ID 63780 //
     /* 2252978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2252981 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2252981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2252986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252987 */     // GIR_Coverage, 63780,
     /* 2252987 */     GIR_Done,
     /* 2252988 */   // Label 31810: @2252988
     /* 2252988 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2253003), // Rule ID 2392 //
     /* 2252993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2252996 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2252996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2253001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253002 */     // GIR_Coverage, 2392,
     /* 2253002 */     GIR_Done,
     /* 2253003 */   // Label 31811: @2253003
     /* 2253003 */   GIM_Reject,
     /* 2253004 */ // Label 31809: @2253004
     /* 2253004 */ GIM_Reject,
     /* 2253005 */ // Label 31783: @2253005
     /* 2253005 */ GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2253119),
     /* 2253010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2253013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2253016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253028 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2253073), // Rule ID 50134 //
     /* 2253033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253036 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2253039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2253053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253072 */     // GIR_Coverage, 50134,
     /* 2253072 */     GIR_EraseRootFromParent_Done,
     /* 2253073 */   // Label 31813: @2253073
     /* 2253073 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2253118), // Rule ID 50135 //
     /* 2253078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253081 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2253084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2253098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253117 */     // GIR_Coverage, 50135,
     /* 2253117 */     GIR_EraseRootFromParent_Done,
     /* 2253118 */   // Label 31814: @2253118
     /* 2253118 */   GIM_Reject,
     /* 2253119 */ // Label 31812: @2253119
     /* 2253119 */ GIM_Reject,
     /* 2253120 */ // Label 31784: @2253120
     /* 2253120 */ GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2253234),
     /* 2253125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2253128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2253131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253143 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2253188), // Rule ID 50146 //
     /* 2253148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253151 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2253154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2253168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253187 */     // GIR_Coverage, 50146,
     /* 2253187 */     GIR_EraseRootFromParent_Done,
     /* 2253188 */   // Label 31816: @2253188
     /* 2253188 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2253233), // Rule ID 50147 //
     /* 2253193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253196 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2253199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2253213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253232 */     // GIR_Coverage, 50147,
     /* 2253232 */     GIR_EraseRootFromParent_Done,
     /* 2253233 */   // Label 31817: @2253233
     /* 2253233 */   GIM_Reject,
     /* 2253234 */ // Label 31815: @2253234
     /* 2253234 */ GIM_Reject,
     /* 2253235 */ // Label 31785: @2253235
     /* 2253235 */ GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2253349),
     /* 2253240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2253243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2253246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253258 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2253303), // Rule ID 50154 //
     /* 2253263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253266 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2253269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2253283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253302 */     // GIR_Coverage, 50154,
     /* 2253302 */     GIR_EraseRootFromParent_Done,
     /* 2253303 */   // Label 31819: @2253303
     /* 2253303 */   GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2253348), // Rule ID 50155 //
     /* 2253308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253311 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2253314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2253328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253347 */     // GIR_Coverage, 50155,
     /* 2253347 */     GIR_EraseRootFromParent_Done,
     /* 2253348 */   // Label 31820: @2253348
     /* 2253348 */   GIM_Reject,
     /* 2253349 */ // Label 31818: @2253349
     /* 2253349 */ GIM_Reject,
     /* 2253350 */ // Label 31786: @2253350
     /* 2253350 */ GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2253464),
     /* 2253355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2253358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2253361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253373 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2253418), // Rule ID 50170 //
     /* 2253378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253381 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2253384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2253398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253417 */     // GIR_Coverage, 50170,
     /* 2253417 */     GIR_EraseRootFromParent_Done,
     /* 2253418 */   // Label 31822: @2253418
     /* 2253418 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2253463), // Rule ID 50171 //
     /* 2253423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253426 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2253429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2253443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253462 */     // GIR_Coverage, 50171,
     /* 2253462 */     GIR_EraseRootFromParent_Done,
     /* 2253463 */   // Label 31823: @2253463
     /* 2253463 */   GIM_Reject,
     /* 2253464 */ // Label 31821: @2253464
     /* 2253464 */ GIM_Reject,
     /* 2253465 */ // Label 31787: @2253465
     /* 2253465 */ GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2253579),
     /* 2253470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2253473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253488 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2253533), // Rule ID 50138 //
     /* 2253493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253496 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2253499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2253513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253532 */     // GIR_Coverage, 50138,
     /* 2253532 */     GIR_EraseRootFromParent_Done,
     /* 2253533 */   // Label 31825: @2253533
     /* 2253533 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2253578), // Rule ID 50139 //
     /* 2253538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253541 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2253544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2253558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253577 */     // GIR_Coverage, 50139,
     /* 2253577 */     GIR_EraseRootFromParent_Done,
     /* 2253578 */   // Label 31826: @2253578
     /* 2253578 */   GIM_Reject,
     /* 2253579 */ // Label 31824: @2253579
     /* 2253579 */ GIM_Reject,
     /* 2253580 */ // Label 31788: @2253580
     /* 2253580 */ GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2253694),
     /* 2253585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2253588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253603 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2253648), // Rule ID 50150 //
     /* 2253608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253611 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2253614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2253628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253647 */     // GIR_Coverage, 50150,
     /* 2253647 */     GIR_EraseRootFromParent_Done,
     /* 2253648 */   // Label 31828: @2253648
     /* 2253648 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2253693), // Rule ID 50151 //
     /* 2253653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253656 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2253659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2253673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253692 */     // GIR_Coverage, 50151,
     /* 2253692 */     GIR_EraseRootFromParent_Done,
     /* 2253693 */   // Label 31829: @2253693
     /* 2253693 */   GIM_Reject,
     /* 2253694 */ // Label 31827: @2253694
     /* 2253694 */ GIM_Reject,
     /* 2253695 */ // Label 31789: @2253695
     /* 2253695 */ GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2253809),
     /* 2253700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2253703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253718 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2253763), // Rule ID 50166 //
     /* 2253723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253726 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2253729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2253743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253762 */     // GIR_Coverage, 50166,
     /* 2253762 */     GIR_EraseRootFromParent_Done,
     /* 2253763 */   // Label 31831: @2253763
     /* 2253763 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2253808), // Rule ID 50167 //
     /* 2253768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253771 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2253774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2253788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253807 */     // GIR_Coverage, 50167,
     /* 2253807 */     GIR_EraseRootFromParent_Done,
     /* 2253808 */   // Label 31832: @2253808
     /* 2253808 */   GIM_Reject,
     /* 2253809 */ // Label 31830: @2253809
     /* 2253809 */ GIM_Reject,
     /* 2253810 */ // Label 31790: @2253810
     /* 2253810 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2253924),
     /* 2253815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2253818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253833 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2253878), // Rule ID 50210 //
     /* 2253838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253841 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2253844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2253858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253877 */     // GIR_Coverage, 50210,
     /* 2253877 */     GIR_EraseRootFromParent_Done,
     /* 2253878 */   // Label 31834: @2253878
     /* 2253878 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2253923), // Rule ID 50211 //
     /* 2253883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253886 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2253889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2253903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253922 */     // GIR_Coverage, 50211,
     /* 2253922 */     GIR_EraseRootFromParent_Done,
     /* 2253923 */   // Label 31835: @2253923
     /* 2253923 */   GIM_Reject,
     /* 2253924 */ // Label 31833: @2253924
     /* 2253924 */ GIM_Reject,
     /* 2253925 */ // Label 31791: @2253925
     /* 2253925 */ GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2254039),
     /* 2253930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2253933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253948 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2253993), // Rule ID 50142 //
     /* 2253953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253956 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2253959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2253963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2253968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2253970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2253973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2253978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2253980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2253992 */     // GIR_Coverage, 50142,
     /* 2253992 */     GIR_EraseRootFromParent_Done,
     /* 2253993 */   // Label 31837: @2253993
     /* 2253993 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2254038), // Rule ID 50143 //
     /* 2253998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254001 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2254004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2254018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254037 */     // GIR_Coverage, 50143,
     /* 2254037 */     GIR_EraseRootFromParent_Done,
     /* 2254038 */   // Label 31838: @2254038
     /* 2254038 */   GIM_Reject,
     /* 2254039 */ // Label 31836: @2254039
     /* 2254039 */ GIM_Reject,
     /* 2254040 */ // Label 31792: @2254040
     /* 2254040 */ GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2254154),
     /* 2254045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2254048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254063 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2254108), // Rule ID 50162 //
     /* 2254068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254071 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2254074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2254088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254107 */     // GIR_Coverage, 50162,
     /* 2254107 */     GIR_EraseRootFromParent_Done,
     /* 2254108 */   // Label 31840: @2254108
     /* 2254108 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2254153), // Rule ID 50163 //
     /* 2254113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254116 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2254119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2254133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254152 */     // GIR_Coverage, 50163,
     /* 2254152 */     GIR_EraseRootFromParent_Done,
     /* 2254153 */   // Label 31841: @2254153
     /* 2254153 */   GIM_Reject,
     /* 2254154 */ // Label 31839: @2254154
     /* 2254154 */ GIM_Reject,
     /* 2254155 */ // Label 31793: @2254155
     /* 2254155 */ GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2254269),
     /* 2254160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2254163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254178 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2254223), // Rule ID 50198 //
     /* 2254183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254186 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2254189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254222 */     // GIR_Coverage, 50198,
     /* 2254222 */     GIR_EraseRootFromParent_Done,
     /* 2254223 */   // Label 31843: @2254223
     /* 2254223 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2254268), // Rule ID 50199 //
     /* 2254228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254231 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2254234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254267 */     // GIR_Coverage, 50199,
     /* 2254267 */     GIR_EraseRootFromParent_Done,
     /* 2254268 */   // Label 31844: @2254268
     /* 2254268 */   GIM_Reject,
     /* 2254269 */ // Label 31842: @2254269
     /* 2254269 */ GIM_Reject,
     /* 2254270 */ // Label 31794: @2254270
     /* 2254270 */ GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2254384),
     /* 2254275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2254278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254293 */   GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2254338), // Rule ID 50214 //
     /* 2254298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254301 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2254304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2254318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254337 */     // GIR_Coverage, 50214,
     /* 2254337 */     GIR_EraseRootFromParent_Done,
     /* 2254338 */   // Label 31846: @2254338
     /* 2254338 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2254383), // Rule ID 50215 //
     /* 2254343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254346 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2254349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2254363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254382 */     // GIR_Coverage, 50215,
     /* 2254382 */     GIR_EraseRootFromParent_Done,
     /* 2254383 */   // Label 31847: @2254383
     /* 2254383 */   GIM_Reject,
     /* 2254384 */ // Label 31845: @2254384
     /* 2254384 */ GIM_Reject,
     /* 2254385 */ // Label 31795: @2254385
     /* 2254385 */ GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2254499),
     /* 2254390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2254393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2254396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254408 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2254453), // Rule ID 50158 //
     /* 2254413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254416 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2254419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2254433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254452 */     // GIR_Coverage, 50158,
     /* 2254452 */     GIR_EraseRootFromParent_Done,
     /* 2254453 */   // Label 31849: @2254453
     /* 2254453 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2254498), // Rule ID 50159 //
     /* 2254458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254461 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2254464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2254478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254497 */     // GIR_Coverage, 50159,
     /* 2254497 */     GIR_EraseRootFromParent_Done,
     /* 2254498 */   // Label 31850: @2254498
     /* 2254498 */   GIM_Reject,
     /* 2254499 */ // Label 31848: @2254499
     /* 2254499 */ GIM_Reject,
     /* 2254500 */ // Label 31796: @2254500
     /* 2254500 */ GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2254614),
     /* 2254505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2254508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2254511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254523 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2254568), // Rule ID 50186 //
     /* 2254528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254531 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2254534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254567 */     // GIR_Coverage, 50186,
     /* 2254567 */     GIR_EraseRootFromParent_Done,
     /* 2254568 */   // Label 31852: @2254568
     /* 2254568 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2254613), // Rule ID 50187 //
     /* 2254573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254576 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2254579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254612 */     // GIR_Coverage, 50187,
     /* 2254612 */     GIR_EraseRootFromParent_Done,
     /* 2254613 */   // Label 31853: @2254613
     /* 2254613 */   GIM_Reject,
     /* 2254614 */ // Label 31851: @2254614
     /* 2254614 */ GIM_Reject,
     /* 2254615 */ // Label 31797: @2254615
     /* 2254615 */ GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2254729),
     /* 2254620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2254623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2254626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254638 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2254683), // Rule ID 50202 //
     /* 2254643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254646 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2254649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2254663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254682 */     // GIR_Coverage, 50202,
     /* 2254682 */     GIR_EraseRootFromParent_Done,
     /* 2254683 */   // Label 31855: @2254683
     /* 2254683 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2254728), // Rule ID 50203 //
     /* 2254688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254691 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2254694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2254708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254727 */     // GIR_Coverage, 50203,
     /* 2254727 */     GIR_EraseRootFromParent_Done,
     /* 2254728 */   // Label 31856: @2254728
     /* 2254728 */   GIM_Reject,
     /* 2254729 */ // Label 31854: @2254729
     /* 2254729 */ GIM_Reject,
     /* 2254730 */ // Label 31798: @2254730
     /* 2254730 */ GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2254844),
     /* 2254735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2254738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2254741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254753 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2254798), // Rule ID 50218 //
     /* 2254758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254761 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2254764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2254778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254797 */     // GIR_Coverage, 50218,
     /* 2254797 */     GIR_EraseRootFromParent_Done,
     /* 2254798 */   // Label 31858: @2254798
     /* 2254798 */   GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2254843), // Rule ID 50219 //
     /* 2254803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254806 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2254809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2254823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254842 */     // GIR_Coverage, 50219,
     /* 2254842 */     GIR_EraseRootFromParent_Done,
     /* 2254843 */   // Label 31859: @2254843
     /* 2254843 */   GIM_Reject,
     /* 2254844 */ // Label 31857: @2254844
     /* 2254844 */ GIM_Reject,
     /* 2254845 */ // Label 31799: @2254845
     /* 2254845 */ GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2254959),
     /* 2254850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2254853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2254856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254868 */   GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2254913), // Rule ID 50174 //
     /* 2254873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254876 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2254879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254912 */     // GIR_Coverage, 50174,
     /* 2254912 */     GIR_EraseRootFromParent_Done,
     /* 2254913 */   // Label 31861: @2254913
     /* 2254913 */   GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2254958), // Rule ID 50175 //
     /* 2254918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254921 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2254924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2254933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2254935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2254938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2254943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2254945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2254957 */     // GIR_Coverage, 50175,
     /* 2254957 */     GIR_EraseRootFromParent_Done,
     /* 2254958 */   // Label 31862: @2254958
     /* 2254958 */   GIM_Reject,
     /* 2254959 */ // Label 31860: @2254959
     /* 2254959 */ GIM_Reject,
     /* 2254960 */ // Label 31800: @2254960
     /* 2254960 */ GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2255074),
     /* 2254965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2254968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2254971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254983 */   GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2255028), // Rule ID 50190 //
     /* 2254988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254991 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2254994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2254998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2255008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255027 */     // GIR_Coverage, 50190,
     /* 2255027 */     GIR_EraseRootFromParent_Done,
     /* 2255028 */   // Label 31864: @2255028
     /* 2255028 */   GIM_Try, /*On fail goto*//*Label 31865*/ GIMT_Encode4(2255073), // Rule ID 50191 //
     /* 2255033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255036 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2255039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2255053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255072 */     // GIR_Coverage, 50191,
     /* 2255072 */     GIR_EraseRootFromParent_Done,
     /* 2255073 */   // Label 31865: @2255073
     /* 2255073 */   GIM_Reject,
     /* 2255074 */ // Label 31863: @2255074
     /* 2255074 */ GIM_Reject,
     /* 2255075 */ // Label 31801: @2255075
     /* 2255075 */ GIM_Try, /*On fail goto*//*Label 31866*/ GIMT_Encode4(2255189),
     /* 2255080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2255083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2255086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255098 */   GIM_Try, /*On fail goto*//*Label 31867*/ GIMT_Encode4(2255143), // Rule ID 50206 //
     /* 2255103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255106 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2255109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255142 */     // GIR_Coverage, 50206,
     /* 2255142 */     GIR_EraseRootFromParent_Done,
     /* 2255143 */   // Label 31867: @2255143
     /* 2255143 */   GIM_Try, /*On fail goto*//*Label 31868*/ GIMT_Encode4(2255188), // Rule ID 50207 //
     /* 2255148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255151 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2255154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255187 */     // GIR_Coverage, 50207,
     /* 2255187 */     GIR_EraseRootFromParent_Done,
     /* 2255188 */   // Label 31868: @2255188
     /* 2255188 */   GIM_Reject,
     /* 2255189 */ // Label 31866: @2255189
     /* 2255189 */ GIM_Reject,
     /* 2255190 */ // Label 31802: @2255190
     /* 2255190 */ GIM_Try, /*On fail goto*//*Label 31869*/ GIMT_Encode4(2255304),
     /* 2255195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2255198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255213 */   GIM_Try, /*On fail goto*//*Label 31870*/ GIMT_Encode4(2255258), // Rule ID 50178 //
     /* 2255218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255221 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2255224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2255238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255257 */     // GIR_Coverage, 50178,
     /* 2255257 */     GIR_EraseRootFromParent_Done,
     /* 2255258 */   // Label 31870: @2255258
     /* 2255258 */   GIM_Try, /*On fail goto*//*Label 31871*/ GIMT_Encode4(2255303), // Rule ID 50179 //
     /* 2255263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255266 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2255269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2255283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255302 */     // GIR_Coverage, 50179,
     /* 2255302 */     GIR_EraseRootFromParent_Done,
     /* 2255303 */   // Label 31871: @2255303
     /* 2255303 */   GIM_Reject,
     /* 2255304 */ // Label 31869: @2255304
     /* 2255304 */ GIM_Reject,
     /* 2255305 */ // Label 31803: @2255305
     /* 2255305 */ GIM_Try, /*On fail goto*//*Label 31872*/ GIMT_Encode4(2255419),
     /* 2255310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2255313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255328 */   GIM_Try, /*On fail goto*//*Label 31873*/ GIMT_Encode4(2255373), // Rule ID 50194 //
     /* 2255333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255336 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2255339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255372 */     // GIR_Coverage, 50194,
     /* 2255372 */     GIR_EraseRootFromParent_Done,
     /* 2255373 */   // Label 31873: @2255373
     /* 2255373 */   GIM_Try, /*On fail goto*//*Label 31874*/ GIMT_Encode4(2255418), // Rule ID 50195 //
     /* 2255378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255381 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2255384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255417 */     // GIR_Coverage, 50195,
     /* 2255417 */     GIR_EraseRootFromParent_Done,
     /* 2255418 */   // Label 31874: @2255418
     /* 2255418 */   GIM_Reject,
     /* 2255419 */ // Label 31872: @2255419
     /* 2255419 */ GIM_Reject,
     /* 2255420 */ // Label 31804: @2255420
     /* 2255420 */ GIM_Try, /*On fail goto*//*Label 31875*/ GIMT_Encode4(2255534),
     /* 2255425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2255428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2255431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255443 */   GIM_Try, /*On fail goto*//*Label 31876*/ GIMT_Encode4(2255488), // Rule ID 50182 //
     /* 2255448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255451 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2255454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255487 */     // GIR_Coverage, 50182,
     /* 2255487 */     GIR_EraseRootFromParent_Done,
     /* 2255488 */   // Label 31876: @2255488
     /* 2255488 */   GIM_Try, /*On fail goto*//*Label 31877*/ GIMT_Encode4(2255533), // Rule ID 50183 //
     /* 2255493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255496 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2255499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2255503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2255508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2255510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2255513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2255518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255532 */     // GIR_Coverage, 50183,
     /* 2255532 */     GIR_EraseRootFromParent_Done,
     /* 2255533 */   // Label 31877: @2255533
     /* 2255533 */   GIM_Reject,
     /* 2255534 */ // Label 31875: @2255534
     /* 2255534 */ GIM_Reject,
     /* 2255535 */ // Label 31805: @2255535
     /* 2255535 */ GIM_Reject,
     /* 2255536 */ // Label 80: @2255536
     /* 2255536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31880*/ GIMT_Encode4(2255693),
     /* 2255547 */ /*GILLT_s32*//*Label 31878*/ GIMT_Encode4(2255555),
     /* 2255551 */ /*GILLT_s64*//*Label 31879*/ GIMT_Encode4(2255624),
     /* 2255555 */ // Label 31878: @2255555
     /* 2255555 */ GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2255623),
     /* 2255560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2255563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255571 */   GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2255586), // Rule ID 63769 //
     /* 2255576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2255579 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2255579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2255584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255585 */     // GIR_Coverage, 63769,
     /* 2255585 */     GIR_Done,
     /* 2255586 */   // Label 31882: @2255586
     /* 2255586 */   GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2255622), // Rule ID 63706 //
     /* 2255591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2255594 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2255594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2255597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2255599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2255607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2255610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2255618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255621 */     // GIR_Coverage, 63706,
     /* 2255621 */     GIR_EraseRootFromParent_Done,
     /* 2255622 */   // Label 31883: @2255622
     /* 2255622 */   GIM_Reject,
     /* 2255623 */ // Label 31881: @2255623
     /* 2255623 */ GIM_Reject,
     /* 2255624 */ // Label 31879: @2255624
     /* 2255624 */ GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2255692),
     /* 2255629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2255632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255640 */   GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2255655), // Rule ID 63768 //
     /* 2255645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2255648 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2255648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2255653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255654 */     // GIR_Coverage, 63768,
     /* 2255654 */     GIR_Done,
     /* 2255655 */   // Label 31885: @2255655
     /* 2255655 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2255691), // Rule ID 63705 //
     /* 2255660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2255663 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2255663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2255666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2255668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2255676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2255679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2255687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255690 */     // GIR_Coverage, 63705,
     /* 2255690 */     GIR_EraseRootFromParent_Done,
     /* 2255691 */   // Label 31886: @2255691
     /* 2255691 */   GIM_Reject,
     /* 2255692 */ // Label 31884: @2255692
     /* 2255692 */ GIM_Reject,
     /* 2255693 */ // Label 31880: @2255693
     /* 2255693 */ GIM_Reject,
     /* 2255694 */ // Label 81: @2255694
     /* 2255694 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31889*/ GIMT_Encode4(2256273),
     /* 2255705 */ /*GILLT_s32*//*Label 31887*/ GIMT_Encode4(2255713),
     /* 2255709 */ /*GILLT_s64*//*Label 31888*/ GIMT_Encode4(2256086),
     /* 2255713 */ // Label 31887: @2255713
     /* 2255713 */ GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2255744), // Rule ID 1328 //
     /* 2255718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2255721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2255724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2255732 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2255732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2255735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255743 */   // GIR_Coverage, 1328,
     /* 2255743 */   GIR_EraseRootFromParent_Done,
     /* 2255744 */ // Label 31890: @2255744
     /* 2255744 */ GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2255775), // Rule ID 1329 //
     /* 2255749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2255752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2255755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2255763 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2255763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2255766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255768 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255774 */   // GIR_Coverage, 1329,
     /* 2255774 */   GIR_EraseRootFromParent_Done,
     /* 2255775 */ // Label 31891: @2255775
     /* 2255775 */ GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2255806), // Rule ID 1354 //
     /* 2255780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2255783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2255786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2255794 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2255794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2255797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255805 */   // GIR_Coverage, 1354,
     /* 2255805 */   GIR_EraseRootFromParent_Done,
     /* 2255806 */ // Label 31892: @2255806
     /* 2255806 */ GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2255837), // Rule ID 1355 //
     /* 2255811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2255814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2255817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2255825 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2255825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2255828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255830 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255836 */   // GIR_Coverage, 1355,
     /* 2255836 */   GIR_EraseRootFromParent_Done,
     /* 2255837 */ // Label 31893: @2255837
     /* 2255837 */ GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2255868), // Rule ID 1722 //
     /* 2255842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2255845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2255848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2255856 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2255856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2255859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255867 */   // GIR_Coverage, 1722,
     /* 2255867 */   GIR_EraseRootFromParent_Done,
     /* 2255868 */ // Label 31894: @2255868
     /* 2255868 */ GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2255899), // Rule ID 1723 //
     /* 2255873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2255876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2255879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2255887 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2255887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2255890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255892 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255898 */   // GIR_Coverage, 1723,
     /* 2255898 */   GIR_EraseRootFromParent_Done,
     /* 2255899 */ // Label 31895: @2255899
     /* 2255899 */ GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2255930), // Rule ID 1748 //
     /* 2255904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2255907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2255910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2255918 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2255918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2255921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255929 */   // GIR_Coverage, 1748,
     /* 2255929 */   GIR_EraseRootFromParent_Done,
     /* 2255930 */ // Label 31896: @2255930
     /* 2255930 */ GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2255961), // Rule ID 1749 //
     /* 2255935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2255938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2255941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2255949 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2255949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2255952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255960 */   // GIR_Coverage, 1749,
     /* 2255960 */   GIR_EraseRootFromParent_Done,
     /* 2255961 */ // Label 31897: @2255961
     /* 2255961 */ GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2255992), // Rule ID 2064 //
     /* 2255966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2255969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2255972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2255976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2255980 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2255980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2255983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2255987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255991 */   // GIR_Coverage, 2064,
     /* 2255991 */   GIR_EraseRootFromParent_Done,
     /* 2255992 */ // Label 31898: @2255992
     /* 2255992 */ GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2256023), // Rule ID 2065 //
     /* 2255997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2256000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2256003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2256011 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2256011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2256014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256022 */   // GIR_Coverage, 2065,
     /* 2256022 */   GIR_EraseRootFromParent_Done,
     /* 2256023 */ // Label 31899: @2256023
     /* 2256023 */ GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2256054), // Rule ID 2090 //
     /* 2256028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2256031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2256034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2256042 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2256042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2256045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256053 */   // GIR_Coverage, 2090,
     /* 2256053 */   GIR_EraseRootFromParent_Done,
     /* 2256054 */ // Label 31900: @2256054
     /* 2256054 */ GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2256085), // Rule ID 2091 //
     /* 2256059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2256062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2256065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2256073 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2256073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2256076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256084 */   // GIR_Coverage, 2091,
     /* 2256084 */   GIR_EraseRootFromParent_Done,
     /* 2256085 */ // Label 31901: @2256085
     /* 2256085 */ GIM_Reject,
     /* 2256086 */ // Label 31888: @2256086
     /* 2256086 */ GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2256117), // Rule ID 1381 //
     /* 2256091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2256094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2256097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256105 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2256105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2256108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256110 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256116 */   // GIR_Coverage, 1381,
     /* 2256116 */   GIR_EraseRootFromParent_Done,
     /* 2256117 */ // Label 31902: @2256117
     /* 2256117 */ GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2256148), // Rule ID 1409 //
     /* 2256122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2256125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2256128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256136 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2256136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2256139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256147 */   // GIR_Coverage, 1409,
     /* 2256147 */   GIR_EraseRootFromParent_Done,
     /* 2256148 */ // Label 31903: @2256148
     /* 2256148 */ GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2256179), // Rule ID 1779 //
     /* 2256153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2256156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2256159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256167 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2256167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2256170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256172 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256178 */   // GIR_Coverage, 1779,
     /* 2256178 */   GIR_EraseRootFromParent_Done,
     /* 2256179 */ // Label 31904: @2256179
     /* 2256179 */ GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2256210), // Rule ID 1807 //
     /* 2256184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2256187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2256190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256198 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2256198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2256201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256203 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256209 */   // GIR_Coverage, 1807,
     /* 2256209 */   GIR_EraseRootFromParent_Done,
     /* 2256210 */ // Label 31905: @2256210
     /* 2256210 */ GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2256241), // Rule ID 2115 //
     /* 2256215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2256218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2256221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2256229 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2256229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2256232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256234 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256240 */   // GIR_Coverage, 2115,
     /* 2256240 */   GIR_EraseRootFromParent_Done,
     /* 2256241 */ // Label 31906: @2256241
     /* 2256241 */ GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2256272), // Rule ID 2141 //
     /* 2256246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2256249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2256252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2256260 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2256260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2256263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256271 */   // GIR_Coverage, 2141,
     /* 2256271 */   GIR_EraseRootFromParent_Done,
     /* 2256272 */ // Label 31907: @2256272
     /* 2256272 */ GIM_Reject,
     /* 2256273 */ // Label 31889: @2256273
     /* 2256273 */ GIM_Reject,
     /* 2256274 */ // Label 82: @2256274
     /* 2256274 */ GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2256483),
     /* 2256279 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2256282 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31912*/ GIMT_Encode4(2256482),
     /* 2256293 */   /*GILLT_s16*//*Label 31909*/ GIMT_Encode4(2256305),
     /* 2256297 */   /*GILLT_s32*//*Label 31910*/ GIMT_Encode4(2256364),
     /* 2256301 */   /*GILLT_s64*//*Label 31911*/ GIMT_Encode4(2256423),
     /* 2256305 */   // Label 31909: @2256305
     /* 2256305 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2256363),
     /* 2256310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256314 */     GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2256338), // Rule ID 2117 //
     /* 2256319 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2256322 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2256326 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2256326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2256329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256331 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256336 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256337 */       // GIR_Coverage, 2117,
     /* 2256337 */       GIR_EraseRootFromParent_Done,
     /* 2256338 */     // Label 31914: @2256338
     /* 2256338 */     GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2256362), // Rule ID 2143 //
     /* 2256343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2256346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2256350 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2256350 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2256353 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256355 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256357 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256360 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256361 */       // GIR_Coverage, 2143,
     /* 2256361 */       GIR_EraseRootFromParent_Done,
     /* 2256362 */     // Label 31915: @2256362
     /* 2256362 */     GIM_Reject,
     /* 2256363 */   // Label 31913: @2256363
     /* 2256363 */   GIM_Reject,
     /* 2256364 */   // Label 31910: @2256364
     /* 2256364 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2256422),
     /* 2256369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256373 */     GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2256397), // Rule ID 1383 //
     /* 2256378 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2256381 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256385 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2256385 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2256388 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256390 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256392 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256395 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256396 */       // GIR_Coverage, 1383,
     /* 2256396 */       GIR_EraseRootFromParent_Done,
     /* 2256397 */     // Label 31917: @2256397
     /* 2256397 */     GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2256421), // Rule ID 1411 //
     /* 2256402 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2256405 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256409 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2256409 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2256412 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256414 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256416 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256419 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256420 */       // GIR_Coverage, 1411,
     /* 2256420 */       GIR_EraseRootFromParent_Done,
     /* 2256421 */     // Label 31918: @2256421
     /* 2256421 */     GIM_Reject,
     /* 2256422 */   // Label 31916: @2256422
     /* 2256422 */   GIM_Reject,
     /* 2256423 */   // Label 31911: @2256423
     /* 2256423 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2256481),
     /* 2256428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256432 */     GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2256456), // Rule ID 1781 //
     /* 2256437 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2256440 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256444 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2256444 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2256447 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256449 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256451 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256454 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256455 */       // GIR_Coverage, 1781,
     /* 2256455 */       GIR_EraseRootFromParent_Done,
     /* 2256456 */     // Label 31920: @2256456
     /* 2256456 */     GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2256480), // Rule ID 1809 //
     /* 2256461 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2256464 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256468 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2256468 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2256471 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256473 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256475 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256478 */       GIR_RootConstrainSelectedInstOperands,
     /* 2256479 */       // GIR_Coverage, 1809,
     /* 2256479 */       GIR_EraseRootFromParent_Done,
     /* 2256480 */     // Label 31921: @2256480
     /* 2256480 */     GIM_Reject,
     /* 2256481 */   // Label 31919: @2256481
     /* 2256481 */   GIM_Reject,
     /* 2256482 */   // Label 31912: @2256482
     /* 2256482 */   GIM_Reject,
     /* 2256483 */ // Label 31908: @2256483
     /* 2256483 */ GIM_Reject,
     /* 2256484 */ // Label 83: @2256484
     /* 2256484 */ GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2256499), // Rule ID 4 //
     /* 2256489 */   // MIs[0] imm20
     /* 2256489 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2256492 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2256492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2256497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256498 */   // GIR_Coverage, 4,
     /* 2256498 */   GIR_Done,
     /* 2256499 */ // Label 31922: @2256499
     /* 2256499 */ GIM_Reject,
     /* 2256500 */ // Label 84: @2256500
     /* 2256500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31947*/ GIMT_Encode4(2259019),
     /* 2256511 */ /*GILLT_s32*//*Label 31923*/ GIMT_Encode4(2256635),
     /* 2256515 */ /*GILLT_s64*//*Label 31924*/ GIMT_Encode4(2256683), GIMT_Encode4(0),
     /* 2256523 */ /*GILLT_nxv1s8*//*Label 31925*/ GIMT_Encode4(2256731),
     /* 2256527 */ /*GILLT_nxv1s16*//*Label 31926*/ GIMT_Encode4(2256835),
     /* 2256531 */ /*GILLT_nxv1s32*//*Label 31927*/ GIMT_Encode4(2256939),
     /* 2256535 */ /*GILLT_nxv1s64*//*Label 31928*/ GIMT_Encode4(2257043), GIMT_Encode4(0),
     /* 2256543 */ /*GILLT_nxv2s8*//*Label 31929*/ GIMT_Encode4(2257147),
     /* 2256547 */ /*GILLT_nxv2s16*//*Label 31930*/ GIMT_Encode4(2257251),
     /* 2256551 */ /*GILLT_nxv2s32*//*Label 31931*/ GIMT_Encode4(2257355),
     /* 2256555 */ /*GILLT_nxv2s64*//*Label 31932*/ GIMT_Encode4(2257459), GIMT_Encode4(0),
     /* 2256563 */ /*GILLT_nxv4s8*//*Label 31933*/ GIMT_Encode4(2257563),
     /* 2256567 */ /*GILLT_nxv4s16*//*Label 31934*/ GIMT_Encode4(2257667),
     /* 2256571 */ /*GILLT_nxv4s32*//*Label 31935*/ GIMT_Encode4(2257771),
     /* 2256575 */ /*GILLT_nxv4s64*//*Label 31936*/ GIMT_Encode4(2257875), GIMT_Encode4(0),
     /* 2256583 */ /*GILLT_nxv8s8*//*Label 31937*/ GIMT_Encode4(2257979),
     /* 2256587 */ /*GILLT_nxv8s16*//*Label 31938*/ GIMT_Encode4(2258083),
     /* 2256591 */ /*GILLT_nxv8s32*//*Label 31939*/ GIMT_Encode4(2258187),
     /* 2256595 */ /*GILLT_nxv8s64*//*Label 31940*/ GIMT_Encode4(2258291), GIMT_Encode4(0),
     /* 2256603 */ /*GILLT_nxv16s8*//*Label 31941*/ GIMT_Encode4(2258395),
     /* 2256607 */ /*GILLT_nxv16s16*//*Label 31942*/ GIMT_Encode4(2258499),
     /* 2256611 */ /*GILLT_nxv16s32*//*Label 31943*/ GIMT_Encode4(2258603), GIMT_Encode4(0),
     /* 2256619 */ /*GILLT_nxv32s8*//*Label 31944*/ GIMT_Encode4(2258707),
     /* 2256623 */ /*GILLT_nxv32s16*//*Label 31945*/ GIMT_Encode4(2258811), GIMT_Encode4(0),
     /* 2256631 */ /*GILLT_nxv64s8*//*Label 31946*/ GIMT_Encode4(2258915),
     /* 2256635 */ // Label 31923: @2256635
     /* 2256635 */ GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2256682),
     /* 2256640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2256643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256651 */   GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2256666), // Rule ID 2375 //
     /* 2256656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2256659 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2256659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2256664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256665 */     // GIR_Coverage, 2375,
     /* 2256665 */     GIR_Done,
     /* 2256666 */   // Label 31949: @2256666
     /* 2256666 */   GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2256681), // Rule ID 63752 //
     /* 2256671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2256674 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2256674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2256679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256680 */     // GIR_Coverage, 63752,
     /* 2256680 */     GIR_Done,
     /* 2256681 */   // Label 31950: @2256681
     /* 2256681 */   GIM_Reject,
     /* 2256682 */ // Label 31948: @2256682
     /* 2256682 */ GIM_Reject,
     /* 2256683 */ // Label 31924: @2256683
     /* 2256683 */ GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2256730),
     /* 2256688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2256691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256699 */   GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2256714), // Rule ID 2374 //
     /* 2256704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2256707 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2256707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2256712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256713 */     // GIR_Coverage, 2374,
     /* 2256713 */     GIR_Done,
     /* 2256714 */   // Label 31952: @2256714
     /* 2256714 */   GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2256729), // Rule ID 63751 //
     /* 2256719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2256722 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2256722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2256727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256728 */     // GIR_Coverage, 63751,
     /* 2256728 */     GIR_Done,
     /* 2256729 */   // Label 31953: @2256729
     /* 2256729 */   GIM_Reject,
     /* 2256730 */ // Label 31951: @2256730
     /* 2256730 */ GIM_Reject,
     /* 2256731 */ // Label 31925: @2256731
     /* 2256731 */ GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2256834),
     /* 2256736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2256739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256747 */   GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2256790), // Rule ID 58458 //
     /* 2256752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2256755 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2256758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2256762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2256767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2256769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2256772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2256777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256789 */     // GIR_Coverage, 58458,
     /* 2256789 */     GIR_EraseRootFromParent_Done,
     /* 2256790 */   // Label 31955: @2256790
     /* 2256790 */   GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2256833), // Rule ID 58459 //
     /* 2256795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2256798 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2256801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2256805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2256810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2256812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2256815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2256820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256832 */     // GIR_Coverage, 58459,
     /* 2256832 */     GIR_EraseRootFromParent_Done,
     /* 2256833 */   // Label 31956: @2256833
     /* 2256833 */   GIM_Reject,
     /* 2256834 */ // Label 31954: @2256834
     /* 2256834 */ GIM_Reject,
     /* 2256835 */ // Label 31926: @2256835
     /* 2256835 */ GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2256938),
     /* 2256840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2256843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256851 */   GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2256894), // Rule ID 58464 //
     /* 2256856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2256859 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2256862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2256866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2256871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2256873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2256876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2256881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256893 */     // GIR_Coverage, 58464,
     /* 2256893 */     GIR_EraseRootFromParent_Done,
     /* 2256894 */   // Label 31958: @2256894
     /* 2256894 */   GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2256937), // Rule ID 58465 //
     /* 2256899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2256902 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2256905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2256909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2256914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2256916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2256919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2256924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256936 */     // GIR_Coverage, 58465,
     /* 2256936 */     GIR_EraseRootFromParent_Done,
     /* 2256937 */   // Label 31959: @2256937
     /* 2256937 */   GIM_Reject,
     /* 2256938 */ // Label 31957: @2256938
     /* 2256938 */ GIM_Reject,
     /* 2256939 */ // Label 31927: @2256939
     /* 2256939 */ GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2257042),
     /* 2256944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2256947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256955 */   GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2256998), // Rule ID 58468 //
     /* 2256960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2256963 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2256966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2256970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2256975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2256977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2256980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2256985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2256987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256997 */     // GIR_Coverage, 58468,
     /* 2256997 */     GIR_EraseRootFromParent_Done,
     /* 2256998 */   // Label 31961: @2256998
     /* 2256998 */   GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2257041), // Rule ID 58469 //
     /* 2257003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257006 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2257009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2257023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257040 */     // GIR_Coverage, 58469,
     /* 2257040 */     GIR_EraseRootFromParent_Done,
     /* 2257041 */   // Label 31962: @2257041
     /* 2257041 */   GIM_Reject,
     /* 2257042 */ // Label 31960: @2257042
     /* 2257042 */ GIM_Reject,
     /* 2257043 */ // Label 31928: @2257043
     /* 2257043 */ GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2257146),
     /* 2257048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2257051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257059 */   GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2257102), // Rule ID 58476 //
     /* 2257064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2257067 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2257070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257101 */     // GIR_Coverage, 58476,
     /* 2257101 */     GIR_EraseRootFromParent_Done,
     /* 2257102 */   // Label 31964: @2257102
     /* 2257102 */   GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2257145), // Rule ID 58477 //
     /* 2257107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2257110 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2257113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257144 */     // GIR_Coverage, 58477,
     /* 2257144 */     GIR_EraseRootFromParent_Done,
     /* 2257145 */   // Label 31965: @2257145
     /* 2257145 */   GIM_Reject,
     /* 2257146 */ // Label 31963: @2257146
     /* 2257146 */ GIM_Reject,
     /* 2257147 */ // Label 31929: @2257147
     /* 2257147 */ GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2257250),
     /* 2257152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2257155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257163 */   GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2257206), // Rule ID 58460 //
     /* 2257168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257171 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2257174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2257188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257205 */     // GIR_Coverage, 58460,
     /* 2257205 */     GIR_EraseRootFromParent_Done,
     /* 2257206 */   // Label 31967: @2257206
     /* 2257206 */   GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2257249), // Rule ID 58461 //
     /* 2257211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257214 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2257217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2257231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257248 */     // GIR_Coverage, 58461,
     /* 2257248 */     GIR_EraseRootFromParent_Done,
     /* 2257249 */   // Label 31968: @2257249
     /* 2257249 */   GIM_Reject,
     /* 2257250 */ // Label 31966: @2257250
     /* 2257250 */ GIM_Reject,
     /* 2257251 */ // Label 31930: @2257251
     /* 2257251 */ GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2257354),
     /* 2257256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2257259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257267 */   GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2257310), // Rule ID 58466 //
     /* 2257272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257275 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2257278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2257292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257309 */     // GIR_Coverage, 58466,
     /* 2257309 */     GIR_EraseRootFromParent_Done,
     /* 2257310 */   // Label 31970: @2257310
     /* 2257310 */   GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2257353), // Rule ID 58467 //
     /* 2257315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257318 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2257321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2257335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257352 */     // GIR_Coverage, 58467,
     /* 2257352 */     GIR_EraseRootFromParent_Done,
     /* 2257353 */   // Label 31971: @2257353
     /* 2257353 */   GIM_Reject,
     /* 2257354 */ // Label 31969: @2257354
     /* 2257354 */ GIM_Reject,
     /* 2257355 */ // Label 31931: @2257355
     /* 2257355 */ GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2257458),
     /* 2257360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2257363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257371 */   GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2257414), // Rule ID 58474 //
     /* 2257376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257379 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2257382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257413 */     // GIR_Coverage, 58474,
     /* 2257413 */     GIR_EraseRootFromParent_Done,
     /* 2257414 */   // Label 31973: @2257414
     /* 2257414 */   GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2257457), // Rule ID 58475 //
     /* 2257419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257422 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2257425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257456 */     // GIR_Coverage, 58475,
     /* 2257456 */     GIR_EraseRootFromParent_Done,
     /* 2257457 */   // Label 31974: @2257457
     /* 2257457 */   GIM_Reject,
     /* 2257458 */ // Label 31972: @2257458
     /* 2257458 */ GIM_Reject,
     /* 2257459 */ // Label 31932: @2257459
     /* 2257459 */ GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2257562),
     /* 2257464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2257467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257475 */   GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2257518), // Rule ID 58496 //
     /* 2257480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2257483 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2257486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2257500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257517 */     // GIR_Coverage, 58496,
     /* 2257517 */     GIR_EraseRootFromParent_Done,
     /* 2257518 */   // Label 31976: @2257518
     /* 2257518 */   GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2257561), // Rule ID 58497 //
     /* 2257523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2257526 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2257529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2257543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257560 */     // GIR_Coverage, 58497,
     /* 2257560 */     GIR_EraseRootFromParent_Done,
     /* 2257561 */   // Label 31977: @2257561
     /* 2257561 */   GIM_Reject,
     /* 2257562 */ // Label 31975: @2257562
     /* 2257562 */ GIM_Reject,
     /* 2257563 */ // Label 31933: @2257563
     /* 2257563 */ GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2257666),
     /* 2257568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2257571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257579 */   GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2257622), // Rule ID 58462 //
     /* 2257584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257587 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2257590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2257604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257621 */     // GIR_Coverage, 58462,
     /* 2257621 */     GIR_EraseRootFromParent_Done,
     /* 2257622 */   // Label 31979: @2257622
     /* 2257622 */   GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2257665), // Rule ID 58463 //
     /* 2257627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257630 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2257633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2257647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257664 */     // GIR_Coverage, 58463,
     /* 2257664 */     GIR_EraseRootFromParent_Done,
     /* 2257665 */   // Label 31980: @2257665
     /* 2257665 */   GIM_Reject,
     /* 2257666 */ // Label 31978: @2257666
     /* 2257666 */ GIM_Reject,
     /* 2257667 */ // Label 31934: @2257667
     /* 2257667 */ GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2257770),
     /* 2257672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2257675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257683 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2257726), // Rule ID 58472 //
     /* 2257688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257691 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2257694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257725 */     // GIR_Coverage, 58472,
     /* 2257725 */     GIR_EraseRootFromParent_Done,
     /* 2257726 */   // Label 31982: @2257726
     /* 2257726 */   GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2257769), // Rule ID 58473 //
     /* 2257731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257734 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2257737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2257751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257768 */     // GIR_Coverage, 58473,
     /* 2257768 */     GIR_EraseRootFromParent_Done,
     /* 2257769 */   // Label 31983: @2257769
     /* 2257769 */   GIM_Reject,
     /* 2257770 */ // Label 31981: @2257770
     /* 2257770 */ GIM_Reject,
     /* 2257771 */ // Label 31935: @2257771
     /* 2257771 */ GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2257874),
     /* 2257776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2257779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257787 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2257830), // Rule ID 58490 //
     /* 2257792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2257795 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2257798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2257812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257829 */     // GIR_Coverage, 58490,
     /* 2257829 */     GIR_EraseRootFromParent_Done,
     /* 2257830 */   // Label 31985: @2257830
     /* 2257830 */   GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2257873), // Rule ID 58491 //
     /* 2257835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2257838 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2257841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2257855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257872 */     // GIR_Coverage, 58491,
     /* 2257872 */     GIR_EraseRootFromParent_Done,
     /* 2257873 */   // Label 31986: @2257873
     /* 2257873 */   GIM_Reject,
     /* 2257874 */ // Label 31984: @2257874
     /* 2257874 */ GIM_Reject,
     /* 2257875 */ // Label 31936: @2257875
     /* 2257875 */ GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2257978),
     /* 2257880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2257883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257891 */   GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2257934), // Rule ID 58498 //
     /* 2257896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2257899 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2257902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2257916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257933 */     // GIR_Coverage, 58498,
     /* 2257933 */     GIR_EraseRootFromParent_Done,
     /* 2257934 */   // Label 31988: @2257934
     /* 2257934 */   GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2257977), // Rule ID 58499 //
     /* 2257939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2257942 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2257945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2257949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2257954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2257956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2257959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2257964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2257966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257976 */     // GIR_Coverage, 58499,
     /* 2257976 */     GIR_EraseRootFromParent_Done,
     /* 2257977 */   // Label 31989: @2257977
     /* 2257977 */   GIM_Reject,
     /* 2257978 */ // Label 31987: @2257978
     /* 2257978 */ GIM_Reject,
     /* 2257979 */ // Label 31937: @2257979
     /* 2257979 */ GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2258082),
     /* 2257984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2257987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257995 */   GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2258038), // Rule ID 58470 //
     /* 2258000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258003 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2258006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2258020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258037 */     // GIR_Coverage, 58470,
     /* 2258037 */     GIR_EraseRootFromParent_Done,
     /* 2258038 */   // Label 31991: @2258038
     /* 2258038 */   GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2258081), // Rule ID 58471 //
     /* 2258043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258046 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2258049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2258063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258080 */     // GIR_Coverage, 58471,
     /* 2258080 */     GIR_EraseRootFromParent_Done,
     /* 2258081 */   // Label 31992: @2258081
     /* 2258081 */   GIM_Reject,
     /* 2258082 */ // Label 31990: @2258082
     /* 2258082 */ GIM_Reject,
     /* 2258083 */ // Label 31938: @2258083
     /* 2258083 */ GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2258186),
     /* 2258088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2258091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258099 */   GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2258142), // Rule ID 58484 //
     /* 2258104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258107 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2258110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2258124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258141 */     // GIR_Coverage, 58484,
     /* 2258141 */     GIR_EraseRootFromParent_Done,
     /* 2258142 */   // Label 31994: @2258142
     /* 2258142 */   GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2258185), // Rule ID 58485 //
     /* 2258147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258150 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2258153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2258167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258184 */     // GIR_Coverage, 58485,
     /* 2258184 */     GIR_EraseRootFromParent_Done,
     /* 2258185 */   // Label 31995: @2258185
     /* 2258185 */   GIM_Reject,
     /* 2258186 */ // Label 31993: @2258186
     /* 2258186 */ GIM_Reject,
     /* 2258187 */ // Label 31939: @2258187
     /* 2258187 */ GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2258290),
     /* 2258192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2258195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258203 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2258246), // Rule ID 58492 //
     /* 2258208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258211 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2258214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258245 */     // GIR_Coverage, 58492,
     /* 2258245 */     GIR_EraseRootFromParent_Done,
     /* 2258246 */   // Label 31997: @2258246
     /* 2258246 */   GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2258289), // Rule ID 58493 //
     /* 2258251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258254 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2258257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258288 */     // GIR_Coverage, 58493,
     /* 2258288 */     GIR_EraseRootFromParent_Done,
     /* 2258289 */   // Label 31998: @2258289
     /* 2258289 */   GIM_Reject,
     /* 2258290 */ // Label 31996: @2258290
     /* 2258290 */ GIM_Reject,
     /* 2258291 */ // Label 31940: @2258291
     /* 2258291 */ GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2258394),
     /* 2258296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2258299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258307 */   GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2258350), // Rule ID 58500 //
     /* 2258312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2258315 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2258318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258349 */     // GIR_Coverage, 58500,
     /* 2258349 */     GIR_EraseRootFromParent_Done,
     /* 2258350 */   // Label 32000: @2258350
     /* 2258350 */   GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2258393), // Rule ID 58501 //
     /* 2258355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2258358 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2258361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258392 */     // GIR_Coverage, 58501,
     /* 2258392 */     GIR_EraseRootFromParent_Done,
     /* 2258393 */   // Label 32001: @2258393
     /* 2258393 */   GIM_Reject,
     /* 2258394 */ // Label 31999: @2258394
     /* 2258394 */ GIM_Reject,
     /* 2258395 */ // Label 31941: @2258395
     /* 2258395 */ GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2258498),
     /* 2258400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2258403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258411 */   GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2258454), // Rule ID 58478 //
     /* 2258416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258419 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2258422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2258436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258453 */     // GIR_Coverage, 58478,
     /* 2258453 */     GIR_EraseRootFromParent_Done,
     /* 2258454 */   // Label 32003: @2258454
     /* 2258454 */   GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2258497), // Rule ID 58479 //
     /* 2258459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258462 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2258465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2258479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258496 */     // GIR_Coverage, 58479,
     /* 2258496 */     GIR_EraseRootFromParent_Done,
     /* 2258497 */   // Label 32004: @2258497
     /* 2258497 */   GIM_Reject,
     /* 2258498 */ // Label 32002: @2258498
     /* 2258498 */ GIM_Reject,
     /* 2258499 */ // Label 31942: @2258499
     /* 2258499 */ GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2258602),
     /* 2258504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2258507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258515 */   GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2258558), // Rule ID 58486 //
     /* 2258520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258523 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2258526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258557 */     // GIR_Coverage, 58486,
     /* 2258557 */     GIR_EraseRootFromParent_Done,
     /* 2258558 */   // Label 32006: @2258558
     /* 2258558 */   GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2258601), // Rule ID 58487 //
     /* 2258563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258566 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2258569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258600 */     // GIR_Coverage, 58487,
     /* 2258600 */     GIR_EraseRootFromParent_Done,
     /* 2258601 */   // Label 32007: @2258601
     /* 2258601 */   GIM_Reject,
     /* 2258602 */ // Label 32005: @2258602
     /* 2258602 */ GIM_Reject,
     /* 2258603 */ // Label 31943: @2258603
     /* 2258603 */ GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2258706),
     /* 2258608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2258611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258619 */   GIM_Try, /*On fail goto*//*Label 32009*/ GIMT_Encode4(2258662), // Rule ID 58494 //
     /* 2258624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258627 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2258630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258661 */     // GIR_Coverage, 58494,
     /* 2258661 */     GIR_EraseRootFromParent_Done,
     /* 2258662 */   // Label 32009: @2258662
     /* 2258662 */   GIM_Try, /*On fail goto*//*Label 32010*/ GIMT_Encode4(2258705), // Rule ID 58495 //
     /* 2258667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258670 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2258673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258704 */     // GIR_Coverage, 58495,
     /* 2258704 */     GIR_EraseRootFromParent_Done,
     /* 2258705 */   // Label 32010: @2258705
     /* 2258705 */   GIM_Reject,
     /* 2258706 */ // Label 32008: @2258706
     /* 2258706 */ GIM_Reject,
     /* 2258707 */ // Label 31944: @2258707
     /* 2258707 */ GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2258810),
     /* 2258712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2258715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258723 */   GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2258766), // Rule ID 58480 //
     /* 2258728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258731 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2258734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258765 */     // GIR_Coverage, 58480,
     /* 2258765 */     GIR_EraseRootFromParent_Done,
     /* 2258766 */   // Label 32012: @2258766
     /* 2258766 */   GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2258809), // Rule ID 58481 //
     /* 2258771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258774 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2258777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2258791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258808 */     // GIR_Coverage, 58481,
     /* 2258808 */     GIR_EraseRootFromParent_Done,
     /* 2258809 */   // Label 32013: @2258809
     /* 2258809 */   GIM_Reject,
     /* 2258810 */ // Label 32011: @2258810
     /* 2258810 */ GIM_Reject,
     /* 2258811 */ // Label 31945: @2258811
     /* 2258811 */ GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2258914),
     /* 2258816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2258819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258827 */   GIM_Try, /*On fail goto*//*Label 32015*/ GIMT_Encode4(2258870), // Rule ID 58488 //
     /* 2258832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258835 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2258838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258869 */     // GIR_Coverage, 58488,
     /* 2258869 */     GIR_EraseRootFromParent_Done,
     /* 2258870 */   // Label 32015: @2258870
     /* 2258870 */   GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2258913), // Rule ID 58489 //
     /* 2258875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258878 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2258881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258912 */     // GIR_Coverage, 58489,
     /* 2258912 */     GIR_EraseRootFromParent_Done,
     /* 2258913 */   // Label 32016: @2258913
     /* 2258913 */   GIM_Reject,
     /* 2258914 */ // Label 32014: @2258914
     /* 2258914 */ GIM_Reject,
     /* 2258915 */ // Label 31946: @2258915
     /* 2258915 */ GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2259018),
     /* 2258920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2258923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258931 */   GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2258974), // Rule ID 58482 //
     /* 2258936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2258939 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2258942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2258961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2258963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2258973 */     // GIR_Coverage, 58482,
     /* 2258973 */     GIR_EraseRootFromParent_Done,
     /* 2258974 */   // Label 32018: @2258974
     /* 2258974 */   GIM_Try, /*On fail goto*//*Label 32019*/ GIMT_Encode4(2259017), // Rule ID 58483 //
     /* 2258979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2258982 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2258985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2258989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2258994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2258996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2258999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259016 */     // GIR_Coverage, 58483,
     /* 2259016 */     GIR_EraseRootFromParent_Done,
     /* 2259017 */   // Label 32019: @2259017
     /* 2259017 */   GIM_Reject,
     /* 2259018 */ // Label 32017: @2259018
     /* 2259018 */ GIM_Reject,
     /* 2259019 */ // Label 31947: @2259019
     /* 2259019 */ GIM_Reject,
     /* 2259020 */ // Label 85: @2259020
     /* 2259020 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32044*/ GIMT_Encode4(2261677),
     /* 2259031 */ /*GILLT_s32*//*Label 32020*/ GIMT_Encode4(2259155),
     /* 2259035 */ /*GILLT_s64*//*Label 32021*/ GIMT_Encode4(2259272), GIMT_Encode4(0),
     /* 2259043 */ /*GILLT_nxv1s8*//*Label 32022*/ GIMT_Encode4(2259389),
     /* 2259047 */ /*GILLT_nxv1s16*//*Label 32023*/ GIMT_Encode4(2259493),
     /* 2259051 */ /*GILLT_nxv1s32*//*Label 32024*/ GIMT_Encode4(2259597),
     /* 2259055 */ /*GILLT_nxv1s64*//*Label 32025*/ GIMT_Encode4(2259701), GIMT_Encode4(0),
     /* 2259063 */ /*GILLT_nxv2s8*//*Label 32026*/ GIMT_Encode4(2259805),
     /* 2259067 */ /*GILLT_nxv2s16*//*Label 32027*/ GIMT_Encode4(2259909),
     /* 2259071 */ /*GILLT_nxv2s32*//*Label 32028*/ GIMT_Encode4(2260013),
     /* 2259075 */ /*GILLT_nxv2s64*//*Label 32029*/ GIMT_Encode4(2260117), GIMT_Encode4(0),
     /* 2259083 */ /*GILLT_nxv4s8*//*Label 32030*/ GIMT_Encode4(2260221),
     /* 2259087 */ /*GILLT_nxv4s16*//*Label 32031*/ GIMT_Encode4(2260325),
     /* 2259091 */ /*GILLT_nxv4s32*//*Label 32032*/ GIMT_Encode4(2260429),
     /* 2259095 */ /*GILLT_nxv4s64*//*Label 32033*/ GIMT_Encode4(2260533), GIMT_Encode4(0),
     /* 2259103 */ /*GILLT_nxv8s8*//*Label 32034*/ GIMT_Encode4(2260637),
     /* 2259107 */ /*GILLT_nxv8s16*//*Label 32035*/ GIMT_Encode4(2260741),
     /* 2259111 */ /*GILLT_nxv8s32*//*Label 32036*/ GIMT_Encode4(2260845),
     /* 2259115 */ /*GILLT_nxv8s64*//*Label 32037*/ GIMT_Encode4(2260949), GIMT_Encode4(0),
     /* 2259123 */ /*GILLT_nxv16s8*//*Label 32038*/ GIMT_Encode4(2261053),
     /* 2259127 */ /*GILLT_nxv16s16*//*Label 32039*/ GIMT_Encode4(2261157),
     /* 2259131 */ /*GILLT_nxv16s32*//*Label 32040*/ GIMT_Encode4(2261261), GIMT_Encode4(0),
     /* 2259139 */ /*GILLT_nxv32s8*//*Label 32041*/ GIMT_Encode4(2261365),
     /* 2259143 */ /*GILLT_nxv32s16*//*Label 32042*/ GIMT_Encode4(2261469), GIMT_Encode4(0),
     /* 2259151 */ /*GILLT_nxv64s8*//*Label 32043*/ GIMT_Encode4(2261573),
     /* 2259155 */ // Label 32020: @2259155
     /* 2259155 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2259271),
     /* 2259160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2259163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259167 */   GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2259213), // Rule ID 61874 //
     /* 2259172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2259175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2259179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2259183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2259187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2259191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2259200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2259202 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2259202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2259205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2259211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259212 */     // GIR_Coverage, 61874,
     /* 2259212 */     GIR_EraseRootFromParent_Done,
     /* 2259213 */   // Label 32046: @2259213
     /* 2259213 */   GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2259232), // Rule ID 2373 //
     /* 2259218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2259221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259225 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2259225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2259230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259231 */     // GIR_Coverage, 2373,
     /* 2259231 */     GIR_Done,
     /* 2259232 */   // Label 32047: @2259232
     /* 2259232 */   GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2259251), // Rule ID 61872 //
     /* 2259237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2259240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259244 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2259244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2259249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259250 */     // GIR_Coverage, 61872,
     /* 2259250 */     GIR_Done,
     /* 2259251 */   // Label 32048: @2259251
     /* 2259251 */   GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2259270), // Rule ID 63754 //
     /* 2259256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2259259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259263 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2259263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2259268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259269 */     // GIR_Coverage, 63754,
     /* 2259269 */     GIR_Done,
     /* 2259270 */   // Label 32049: @2259270
     /* 2259270 */   GIM_Reject,
     /* 2259271 */ // Label 32045: @2259271
     /* 2259271 */ GIM_Reject,
     /* 2259272 */ // Label 32021: @2259272
     /* 2259272 */ GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2259388),
     /* 2259277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2259280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259284 */   GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2259330), // Rule ID 61873 //
     /* 2259289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2259292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2259296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2259300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2259304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2259308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2259317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2259319 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2259319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2259322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2259328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259329 */     // GIR_Coverage, 61873,
     /* 2259329 */     GIR_EraseRootFromParent_Done,
     /* 2259330 */   // Label 32051: @2259330
     /* 2259330 */   GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2259349), // Rule ID 2372 //
     /* 2259335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2259338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259342 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2259342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2259347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259348 */     // GIR_Coverage, 2372,
     /* 2259348 */     GIR_Done,
     /* 2259349 */   // Label 32052: @2259349
     /* 2259349 */   GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2259368), // Rule ID 61871 //
     /* 2259354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2259357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259361 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2259361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2259366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259367 */     // GIR_Coverage, 61871,
     /* 2259367 */     GIR_Done,
     /* 2259368 */   // Label 32053: @2259368
     /* 2259368 */   GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2259387), // Rule ID 63753 //
     /* 2259373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2259376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259380 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2259380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2259385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259386 */     // GIR_Coverage, 63753,
     /* 2259386 */     GIR_Done,
     /* 2259387 */   // Label 32054: @2259387
     /* 2259387 */   GIM_Reject,
     /* 2259388 */ // Label 32050: @2259388
     /* 2259388 */ GIM_Reject,
     /* 2259389 */ // Label 32022: @2259389
     /* 2259389 */ GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2259492),
     /* 2259394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2259397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259405 */   GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2259448), // Rule ID 58414 //
     /* 2259410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2259413 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2259416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2259430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259447 */     // GIR_Coverage, 58414,
     /* 2259447 */     GIR_EraseRootFromParent_Done,
     /* 2259448 */   // Label 32056: @2259448
     /* 2259448 */   GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2259491), // Rule ID 58415 //
     /* 2259453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2259456 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2259459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2259473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259490 */     // GIR_Coverage, 58415,
     /* 2259490 */     GIR_EraseRootFromParent_Done,
     /* 2259491 */   // Label 32057: @2259491
     /* 2259491 */   GIM_Reject,
     /* 2259492 */ // Label 32055: @2259492
     /* 2259492 */ GIM_Reject,
     /* 2259493 */ // Label 32023: @2259493
     /* 2259493 */ GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2259596),
     /* 2259498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2259501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259509 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2259552), // Rule ID 58420 //
     /* 2259514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2259517 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2259520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2259534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259551 */     // GIR_Coverage, 58420,
     /* 2259551 */     GIR_EraseRootFromParent_Done,
     /* 2259552 */   // Label 32059: @2259552
     /* 2259552 */   GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2259595), // Rule ID 58421 //
     /* 2259557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2259560 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2259563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2259577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259594 */     // GIR_Coverage, 58421,
     /* 2259594 */     GIR_EraseRootFromParent_Done,
     /* 2259595 */   // Label 32060: @2259595
     /* 2259595 */   GIM_Reject,
     /* 2259596 */ // Label 32058: @2259596
     /* 2259596 */ GIM_Reject,
     /* 2259597 */ // Label 32024: @2259597
     /* 2259597 */ GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2259700),
     /* 2259602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2259605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259613 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2259656), // Rule ID 58424 //
     /* 2259618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2259621 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2259624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2259638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259655 */     // GIR_Coverage, 58424,
     /* 2259655 */     GIR_EraseRootFromParent_Done,
     /* 2259656 */   // Label 32062: @2259656
     /* 2259656 */   GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2259699), // Rule ID 58425 //
     /* 2259661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2259664 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2259667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2259681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259698 */     // GIR_Coverage, 58425,
     /* 2259698 */     GIR_EraseRootFromParent_Done,
     /* 2259699 */   // Label 32063: @2259699
     /* 2259699 */   GIM_Reject,
     /* 2259700 */ // Label 32061: @2259700
     /* 2259700 */ GIM_Reject,
     /* 2259701 */ // Label 32025: @2259701
     /* 2259701 */ GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2259804),
     /* 2259706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2259709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259717 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2259760), // Rule ID 58432 //
     /* 2259722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2259725 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2259728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2259742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259759 */     // GIR_Coverage, 58432,
     /* 2259759 */     GIR_EraseRootFromParent_Done,
     /* 2259760 */   // Label 32065: @2259760
     /* 2259760 */   GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2259803), // Rule ID 58433 //
     /* 2259765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2259768 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2259771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2259785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259802 */     // GIR_Coverage, 58433,
     /* 2259802 */     GIR_EraseRootFromParent_Done,
     /* 2259803 */   // Label 32066: @2259803
     /* 2259803 */   GIM_Reject,
     /* 2259804 */ // Label 32064: @2259804
     /* 2259804 */ GIM_Reject,
     /* 2259805 */ // Label 32026: @2259805
     /* 2259805 */ GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2259908),
     /* 2259810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2259813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259821 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2259864), // Rule ID 58416 //
     /* 2259826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2259829 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2259832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2259846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259863 */     // GIR_Coverage, 58416,
     /* 2259863 */     GIR_EraseRootFromParent_Done,
     /* 2259864 */   // Label 32068: @2259864
     /* 2259864 */   GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2259907), // Rule ID 58417 //
     /* 2259869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2259872 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2259875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2259889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259906 */     // GIR_Coverage, 58417,
     /* 2259906 */     GIR_EraseRootFromParent_Done,
     /* 2259907 */   // Label 32069: @2259907
     /* 2259907 */   GIM_Reject,
     /* 2259908 */ // Label 32067: @2259908
     /* 2259908 */ GIM_Reject,
     /* 2259909 */ // Label 32027: @2259909
     /* 2259909 */ GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2260012),
     /* 2259914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2259917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259925 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2259968), // Rule ID 58422 //
     /* 2259930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2259933 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2259936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2259950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2259957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259967 */     // GIR_Coverage, 58422,
     /* 2259967 */     GIR_EraseRootFromParent_Done,
     /* 2259968 */   // Label 32071: @2259968
     /* 2259968 */   GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2260011), // Rule ID 58423 //
     /* 2259973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2259976 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2259979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2259993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260010 */     // GIR_Coverage, 58423,
     /* 2260010 */     GIR_EraseRootFromParent_Done,
     /* 2260011 */   // Label 32072: @2260011
     /* 2260011 */   GIM_Reject,
     /* 2260012 */ // Label 32070: @2260012
     /* 2260012 */ GIM_Reject,
     /* 2260013 */ // Label 32028: @2260013
     /* 2260013 */ GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2260116),
     /* 2260018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2260021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260029 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2260072), // Rule ID 58430 //
     /* 2260034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260037 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2260040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260071 */     // GIR_Coverage, 58430,
     /* 2260071 */     GIR_EraseRootFromParent_Done,
     /* 2260072 */   // Label 32074: @2260072
     /* 2260072 */   GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2260115), // Rule ID 58431 //
     /* 2260077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260080 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2260083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260114 */     // GIR_Coverage, 58431,
     /* 2260114 */     GIR_EraseRootFromParent_Done,
     /* 2260115 */   // Label 32075: @2260115
     /* 2260115 */   GIM_Reject,
     /* 2260116 */ // Label 32073: @2260116
     /* 2260116 */ GIM_Reject,
     /* 2260117 */ // Label 32029: @2260117
     /* 2260117 */ GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2260220),
     /* 2260122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2260125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260133 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2260176), // Rule ID 58452 //
     /* 2260138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2260141 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2260144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260175 */     // GIR_Coverage, 58452,
     /* 2260175 */     GIR_EraseRootFromParent_Done,
     /* 2260176 */   // Label 32077: @2260176
     /* 2260176 */   GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2260219), // Rule ID 58453 //
     /* 2260181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2260184 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2260187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260218 */     // GIR_Coverage, 58453,
     /* 2260218 */     GIR_EraseRootFromParent_Done,
     /* 2260219 */   // Label 32078: @2260219
     /* 2260219 */   GIM_Reject,
     /* 2260220 */ // Label 32076: @2260220
     /* 2260220 */ GIM_Reject,
     /* 2260221 */ // Label 32030: @2260221
     /* 2260221 */ GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2260324),
     /* 2260226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2260229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260237 */   GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2260280), // Rule ID 58418 //
     /* 2260242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260245 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2260248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2260262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260279 */     // GIR_Coverage, 58418,
     /* 2260279 */     GIR_EraseRootFromParent_Done,
     /* 2260280 */   // Label 32080: @2260280
     /* 2260280 */   GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2260323), // Rule ID 58419 //
     /* 2260285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260288 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2260291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2260305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260322 */     // GIR_Coverage, 58419,
     /* 2260322 */     GIR_EraseRootFromParent_Done,
     /* 2260323 */   // Label 32081: @2260323
     /* 2260323 */   GIM_Reject,
     /* 2260324 */ // Label 32079: @2260324
     /* 2260324 */ GIM_Reject,
     /* 2260325 */ // Label 32031: @2260325
     /* 2260325 */ GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2260428),
     /* 2260330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2260333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260341 */   GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2260384), // Rule ID 58428 //
     /* 2260346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260349 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2260352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260383 */     // GIR_Coverage, 58428,
     /* 2260383 */     GIR_EraseRootFromParent_Done,
     /* 2260384 */   // Label 32083: @2260384
     /* 2260384 */   GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2260427), // Rule ID 58429 //
     /* 2260389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260392 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2260395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260426 */     // GIR_Coverage, 58429,
     /* 2260426 */     GIR_EraseRootFromParent_Done,
     /* 2260427 */   // Label 32084: @2260427
     /* 2260427 */   GIM_Reject,
     /* 2260428 */ // Label 32082: @2260428
     /* 2260428 */ GIM_Reject,
     /* 2260429 */ // Label 32032: @2260429
     /* 2260429 */ GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2260532),
     /* 2260434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2260437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260445 */   GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2260488), // Rule ID 58446 //
     /* 2260450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260453 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2260456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260487 */     // GIR_Coverage, 58446,
     /* 2260487 */     GIR_EraseRootFromParent_Done,
     /* 2260488 */   // Label 32086: @2260488
     /* 2260488 */   GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2260531), // Rule ID 58447 //
     /* 2260493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260496 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2260499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260530 */     // GIR_Coverage, 58447,
     /* 2260530 */     GIR_EraseRootFromParent_Done,
     /* 2260531 */   // Label 32087: @2260531
     /* 2260531 */   GIM_Reject,
     /* 2260532 */ // Label 32085: @2260532
     /* 2260532 */ GIM_Reject,
     /* 2260533 */ // Label 32033: @2260533
     /* 2260533 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2260636),
     /* 2260538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2260541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260549 */   GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2260592), // Rule ID 58454 //
     /* 2260554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2260557 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2260560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2260574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260591 */     // GIR_Coverage, 58454,
     /* 2260591 */     GIR_EraseRootFromParent_Done,
     /* 2260592 */   // Label 32089: @2260592
     /* 2260592 */   GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2260635), // Rule ID 58455 //
     /* 2260597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2260600 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2260603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2260617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260634 */     // GIR_Coverage, 58455,
     /* 2260634 */     GIR_EraseRootFromParent_Done,
     /* 2260635 */   // Label 32090: @2260635
     /* 2260635 */   GIM_Reject,
     /* 2260636 */ // Label 32088: @2260636
     /* 2260636 */ GIM_Reject,
     /* 2260637 */ // Label 32034: @2260637
     /* 2260637 */ GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2260740),
     /* 2260642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2260645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260653 */   GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2260696), // Rule ID 58426 //
     /* 2260658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260661 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2260664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260695 */     // GIR_Coverage, 58426,
     /* 2260695 */     GIR_EraseRootFromParent_Done,
     /* 2260696 */   // Label 32092: @2260696
     /* 2260696 */   GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2260739), // Rule ID 58427 //
     /* 2260701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260704 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2260707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2260721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260738 */     // GIR_Coverage, 58427,
     /* 2260738 */     GIR_EraseRootFromParent_Done,
     /* 2260739 */   // Label 32093: @2260739
     /* 2260739 */   GIM_Reject,
     /* 2260740 */ // Label 32091: @2260740
     /* 2260740 */ GIM_Reject,
     /* 2260741 */ // Label 32035: @2260741
     /* 2260741 */ GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2260844),
     /* 2260746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2260749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260757 */   GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2260800), // Rule ID 58440 //
     /* 2260762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260765 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2260768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260799 */     // GIR_Coverage, 58440,
     /* 2260799 */     GIR_EraseRootFromParent_Done,
     /* 2260800 */   // Label 32095: @2260800
     /* 2260800 */   GIM_Try, /*On fail goto*//*Label 32096*/ GIMT_Encode4(2260843), // Rule ID 58441 //
     /* 2260805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260808 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2260811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2260825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260842 */     // GIR_Coverage, 58441,
     /* 2260842 */     GIR_EraseRootFromParent_Done,
     /* 2260843 */   // Label 32096: @2260843
     /* 2260843 */   GIM_Reject,
     /* 2260844 */ // Label 32094: @2260844
     /* 2260844 */ GIM_Reject,
     /* 2260845 */ // Label 32036: @2260845
     /* 2260845 */ GIM_Try, /*On fail goto*//*Label 32097*/ GIMT_Encode4(2260948),
     /* 2260850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2260853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260861 */   GIM_Try, /*On fail goto*//*Label 32098*/ GIMT_Encode4(2260904), // Rule ID 58448 //
     /* 2260866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2260869 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2260872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2260886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260903 */     // GIR_Coverage, 58448,
     /* 2260903 */     GIR_EraseRootFromParent_Done,
     /* 2260904 */   // Label 32098: @2260904
     /* 2260904 */   GIM_Try, /*On fail goto*//*Label 32099*/ GIMT_Encode4(2260947), // Rule ID 58449 //
     /* 2260909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2260912 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2260915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2260929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260946 */     // GIR_Coverage, 58449,
     /* 2260946 */     GIR_EraseRootFromParent_Done,
     /* 2260947 */   // Label 32099: @2260947
     /* 2260947 */   GIM_Reject,
     /* 2260948 */ // Label 32097: @2260948
     /* 2260948 */ GIM_Reject,
     /* 2260949 */ // Label 32037: @2260949
     /* 2260949 */ GIM_Try, /*On fail goto*//*Label 32100*/ GIMT_Encode4(2261052),
     /* 2260954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2260957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260965 */   GIM_Try, /*On fail goto*//*Label 32101*/ GIMT_Encode4(2261008), // Rule ID 58456 //
     /* 2260970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2260973 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2260976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2260990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2260997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261007 */     // GIR_Coverage, 58456,
     /* 2261007 */     GIR_EraseRootFromParent_Done,
     /* 2261008 */   // Label 32101: @2261008
     /* 2261008 */   GIM_Try, /*On fail goto*//*Label 32102*/ GIMT_Encode4(2261051), // Rule ID 58457 //
     /* 2261013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2261016 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2261019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261050 */     // GIR_Coverage, 58457,
     /* 2261050 */     GIR_EraseRootFromParent_Done,
     /* 2261051 */   // Label 32102: @2261051
     /* 2261051 */   GIM_Reject,
     /* 2261052 */ // Label 32100: @2261052
     /* 2261052 */ GIM_Reject,
     /* 2261053 */ // Label 32038: @2261053
     /* 2261053 */ GIM_Try, /*On fail goto*//*Label 32103*/ GIMT_Encode4(2261156),
     /* 2261058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2261061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261069 */   GIM_Try, /*On fail goto*//*Label 32104*/ GIMT_Encode4(2261112), // Rule ID 58434 //
     /* 2261074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261077 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2261080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2261094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261111 */     // GIR_Coverage, 58434,
     /* 2261111 */     GIR_EraseRootFromParent_Done,
     /* 2261112 */   // Label 32104: @2261112
     /* 2261112 */   GIM_Try, /*On fail goto*//*Label 32105*/ GIMT_Encode4(2261155), // Rule ID 58435 //
     /* 2261117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261120 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2261123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2261137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261154 */     // GIR_Coverage, 58435,
     /* 2261154 */     GIR_EraseRootFromParent_Done,
     /* 2261155 */   // Label 32105: @2261155
     /* 2261155 */   GIM_Reject,
     /* 2261156 */ // Label 32103: @2261156
     /* 2261156 */ GIM_Reject,
     /* 2261157 */ // Label 32039: @2261157
     /* 2261157 */ GIM_Try, /*On fail goto*//*Label 32106*/ GIMT_Encode4(2261260),
     /* 2261162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2261165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261173 */   GIM_Try, /*On fail goto*//*Label 32107*/ GIMT_Encode4(2261216), // Rule ID 58442 //
     /* 2261178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261181 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2261184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2261198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261215 */     // GIR_Coverage, 58442,
     /* 2261215 */     GIR_EraseRootFromParent_Done,
     /* 2261216 */   // Label 32107: @2261216
     /* 2261216 */   GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2261259), // Rule ID 58443 //
     /* 2261221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261224 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2261227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2261241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261258 */     // GIR_Coverage, 58443,
     /* 2261258 */     GIR_EraseRootFromParent_Done,
     /* 2261259 */   // Label 32108: @2261259
     /* 2261259 */   GIM_Reject,
     /* 2261260 */ // Label 32106: @2261260
     /* 2261260 */ GIM_Reject,
     /* 2261261 */ // Label 32040: @2261261
     /* 2261261 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2261364),
     /* 2261266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2261269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261277 */   GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2261320), // Rule ID 58450 //
     /* 2261282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261285 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2261288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261319 */     // GIR_Coverage, 58450,
     /* 2261319 */     GIR_EraseRootFromParent_Done,
     /* 2261320 */   // Label 32110: @2261320
     /* 2261320 */   GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2261363), // Rule ID 58451 //
     /* 2261325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261328 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2261331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261362 */     // GIR_Coverage, 58451,
     /* 2261362 */     GIR_EraseRootFromParent_Done,
     /* 2261363 */   // Label 32111: @2261363
     /* 2261363 */   GIM_Reject,
     /* 2261364 */ // Label 32109: @2261364
     /* 2261364 */ GIM_Reject,
     /* 2261365 */ // Label 32041: @2261365
     /* 2261365 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2261468),
     /* 2261370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2261373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261381 */   GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2261424), // Rule ID 58436 //
     /* 2261386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261389 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2261392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2261406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261423 */     // GIR_Coverage, 58436,
     /* 2261423 */     GIR_EraseRootFromParent_Done,
     /* 2261424 */   // Label 32113: @2261424
     /* 2261424 */   GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2261467), // Rule ID 58437 //
     /* 2261429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261432 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2261435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2261449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261466 */     // GIR_Coverage, 58437,
     /* 2261466 */     GIR_EraseRootFromParent_Done,
     /* 2261467 */   // Label 32114: @2261467
     /* 2261467 */   GIM_Reject,
     /* 2261468 */ // Label 32112: @2261468
     /* 2261468 */ GIM_Reject,
     /* 2261469 */ // Label 32042: @2261469
     /* 2261469 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2261572),
     /* 2261474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2261477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261485 */   GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2261528), // Rule ID 58444 //
     /* 2261490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261493 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2261496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261527 */     // GIR_Coverage, 58444,
     /* 2261527 */     GIR_EraseRootFromParent_Done,
     /* 2261528 */   // Label 32116: @2261528
     /* 2261528 */   GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2261571), // Rule ID 58445 //
     /* 2261533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261536 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2261539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261570 */     // GIR_Coverage, 58445,
     /* 2261570 */     GIR_EraseRootFromParent_Done,
     /* 2261571 */   // Label 32117: @2261571
     /* 2261571 */   GIM_Reject,
     /* 2261572 */ // Label 32115: @2261572
     /* 2261572 */ GIM_Reject,
     /* 2261573 */ // Label 32043: @2261573
     /* 2261573 */ GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2261676),
     /* 2261578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2261581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261589 */   GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2261632), // Rule ID 58438 //
     /* 2261594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261597 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2261600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261631 */     // GIR_Coverage, 58438,
     /* 2261631 */     GIR_EraseRootFromParent_Done,
     /* 2261632 */   // Label 32119: @2261632
     /* 2261632 */   GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2261675), // Rule ID 58439 //
     /* 2261637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2261640 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2261643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2261657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261674 */     // GIR_Coverage, 58439,
     /* 2261674 */     GIR_EraseRootFromParent_Done,
     /* 2261675 */   // Label 32120: @2261675
     /* 2261675 */   GIM_Reject,
     /* 2261676 */ // Label 32118: @2261676
     /* 2261676 */ GIM_Reject,
     /* 2261677 */ // Label 32044: @2261677
     /* 2261677 */ GIM_Reject,
     /* 2261678 */ // Label 86: @2261678
     /* 2261678 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32145*/ GIMT_Encode4(2264228),
     /* 2261689 */ /*GILLT_s32*//*Label 32121*/ GIMT_Encode4(2261813),
     /* 2261693 */ /*GILLT_s64*//*Label 32122*/ GIMT_Encode4(2261861), GIMT_Encode4(0),
     /* 2261701 */ /*GILLT_nxv1s8*//*Label 32123*/ GIMT_Encode4(2261940),
     /* 2261705 */ /*GILLT_nxv1s16*//*Label 32124*/ GIMT_Encode4(2262044),
     /* 2261709 */ /*GILLT_nxv1s32*//*Label 32125*/ GIMT_Encode4(2262148),
     /* 2261713 */ /*GILLT_nxv1s64*//*Label 32126*/ GIMT_Encode4(2262252), GIMT_Encode4(0),
     /* 2261721 */ /*GILLT_nxv2s8*//*Label 32127*/ GIMT_Encode4(2262356),
     /* 2261725 */ /*GILLT_nxv2s16*//*Label 32128*/ GIMT_Encode4(2262460),
     /* 2261729 */ /*GILLT_nxv2s32*//*Label 32129*/ GIMT_Encode4(2262564),
     /* 2261733 */ /*GILLT_nxv2s64*//*Label 32130*/ GIMT_Encode4(2262668), GIMT_Encode4(0),
     /* 2261741 */ /*GILLT_nxv4s8*//*Label 32131*/ GIMT_Encode4(2262772),
     /* 2261745 */ /*GILLT_nxv4s16*//*Label 32132*/ GIMT_Encode4(2262876),
     /* 2261749 */ /*GILLT_nxv4s32*//*Label 32133*/ GIMT_Encode4(2262980),
     /* 2261753 */ /*GILLT_nxv4s64*//*Label 32134*/ GIMT_Encode4(2263084), GIMT_Encode4(0),
     /* 2261761 */ /*GILLT_nxv8s8*//*Label 32135*/ GIMT_Encode4(2263188),
     /* 2261765 */ /*GILLT_nxv8s16*//*Label 32136*/ GIMT_Encode4(2263292),
     /* 2261769 */ /*GILLT_nxv8s32*//*Label 32137*/ GIMT_Encode4(2263396),
     /* 2261773 */ /*GILLT_nxv8s64*//*Label 32138*/ GIMT_Encode4(2263500), GIMT_Encode4(0),
     /* 2261781 */ /*GILLT_nxv16s8*//*Label 32139*/ GIMT_Encode4(2263604),
     /* 2261785 */ /*GILLT_nxv16s16*//*Label 32140*/ GIMT_Encode4(2263708),
     /* 2261789 */ /*GILLT_nxv16s32*//*Label 32141*/ GIMT_Encode4(2263812), GIMT_Encode4(0),
     /* 2261797 */ /*GILLT_nxv32s8*//*Label 32142*/ GIMT_Encode4(2263916),
     /* 2261801 */ /*GILLT_nxv32s16*//*Label 32143*/ GIMT_Encode4(2264020), GIMT_Encode4(0),
     /* 2261809 */ /*GILLT_nxv64s8*//*Label 32144*/ GIMT_Encode4(2264124),
     /* 2261813 */ // Label 32121: @2261813
     /* 2261813 */ GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2261860),
     /* 2261818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2261821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2261825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2261829 */   GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2261844), // Rule ID 2377 //
     /* 2261834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2261837 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2261837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2261842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261843 */     // GIR_Coverage, 2377,
     /* 2261843 */     GIR_Done,
     /* 2261844 */   // Label 32147: @2261844
     /* 2261844 */   GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2261859), // Rule ID 63757 //
     /* 2261849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2261852 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2261852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2261857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261858 */     // GIR_Coverage, 63757,
     /* 2261858 */     GIR_Done,
     /* 2261859 */   // Label 32148: @2261859
     /* 2261859 */   GIM_Reject,
     /* 2261860 */ // Label 32146: @2261860
     /* 2261860 */ GIM_Reject,
     /* 2261861 */ // Label 32122: @2261861
     /* 2261861 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2261939),
     /* 2261866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2261869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2261873 */   GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2261900), // Rule ID 2380 //
     /* 2261878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2261881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2261888 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2261888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2261891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2261898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261899 */     // GIR_Coverage, 2380,
     /* 2261899 */     GIR_EraseRootFromParent_Done,
     /* 2261900 */   // Label 32150: @2261900
     /* 2261900 */   GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2261919), // Rule ID 2376 //
     /* 2261905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2261908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2261912 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2261912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2261917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261918 */     // GIR_Coverage, 2376,
     /* 2261918 */     GIR_Done,
     /* 2261919 */   // Label 32151: @2261919
     /* 2261919 */   GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2261938), // Rule ID 63756 //
     /* 2261924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2261927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2261931 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2261931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2261936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261937 */     // GIR_Coverage, 63756,
     /* 2261937 */     GIR_Done,
     /* 2261938 */   // Label 32152: @2261938
     /* 2261938 */   GIM_Reject,
     /* 2261939 */ // Label 32149: @2261939
     /* 2261939 */ GIM_Reject,
     /* 2261940 */ // Label 32123: @2261940
     /* 2261940 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2262043),
     /* 2261945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2261948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261956 */   GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2261999), // Rule ID 58502 //
     /* 2261961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2261964 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2261967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2261981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2261988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261998 */     // GIR_Coverage, 58502,
     /* 2261998 */     GIR_EraseRootFromParent_Done,
     /* 2261999 */   // Label 32154: @2261999
     /* 2261999 */   GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2262042), // Rule ID 58503 //
     /* 2262004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262007 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2262010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2262024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262041 */     // GIR_Coverage, 58503,
     /* 2262041 */     GIR_EraseRootFromParent_Done,
     /* 2262042 */   // Label 32155: @2262042
     /* 2262042 */   GIM_Reject,
     /* 2262043 */ // Label 32153: @2262043
     /* 2262043 */ GIM_Reject,
     /* 2262044 */ // Label 32124: @2262044
     /* 2262044 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2262147),
     /* 2262049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2262052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262060 */   GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2262103), // Rule ID 58508 //
     /* 2262065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262068 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2262071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2262085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262102 */     // GIR_Coverage, 58508,
     /* 2262102 */     GIR_EraseRootFromParent_Done,
     /* 2262103 */   // Label 32157: @2262103
     /* 2262103 */   GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2262146), // Rule ID 58509 //
     /* 2262108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262111 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2262114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2262128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262145 */     // GIR_Coverage, 58509,
     /* 2262145 */     GIR_EraseRootFromParent_Done,
     /* 2262146 */   // Label 32158: @2262146
     /* 2262146 */   GIM_Reject,
     /* 2262147 */ // Label 32156: @2262147
     /* 2262147 */ GIM_Reject,
     /* 2262148 */ // Label 32125: @2262148
     /* 2262148 */ GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2262251),
     /* 2262153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2262156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262164 */   GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2262207), // Rule ID 58512 //
     /* 2262169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262172 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2262175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262206 */     // GIR_Coverage, 58512,
     /* 2262206 */     GIR_EraseRootFromParent_Done,
     /* 2262207 */   // Label 32160: @2262207
     /* 2262207 */   GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2262250), // Rule ID 58513 //
     /* 2262212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262215 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2262218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262249 */     // GIR_Coverage, 58513,
     /* 2262249 */     GIR_EraseRootFromParent_Done,
     /* 2262250 */   // Label 32161: @2262250
     /* 2262250 */   GIM_Reject,
     /* 2262251 */ // Label 32159: @2262251
     /* 2262251 */ GIM_Reject,
     /* 2262252 */ // Label 32126: @2262252
     /* 2262252 */ GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2262355),
     /* 2262257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2262260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262268 */   GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2262311), // Rule ID 58520 //
     /* 2262273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2262276 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2262279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262310 */     // GIR_Coverage, 58520,
     /* 2262310 */     GIR_EraseRootFromParent_Done,
     /* 2262311 */   // Label 32163: @2262311
     /* 2262311 */   GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2262354), // Rule ID 58521 //
     /* 2262316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2262319 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2262322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262353 */     // GIR_Coverage, 58521,
     /* 2262353 */     GIR_EraseRootFromParent_Done,
     /* 2262354 */   // Label 32164: @2262354
     /* 2262354 */   GIM_Reject,
     /* 2262355 */ // Label 32162: @2262355
     /* 2262355 */ GIM_Reject,
     /* 2262356 */ // Label 32127: @2262356
     /* 2262356 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2262459),
     /* 2262361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2262364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262372 */   GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2262415), // Rule ID 58504 //
     /* 2262377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262380 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2262383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2262397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262414 */     // GIR_Coverage, 58504,
     /* 2262414 */     GIR_EraseRootFromParent_Done,
     /* 2262415 */   // Label 32166: @2262415
     /* 2262415 */   GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2262458), // Rule ID 58505 //
     /* 2262420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262423 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2262426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2262440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262457 */     // GIR_Coverage, 58505,
     /* 2262457 */     GIR_EraseRootFromParent_Done,
     /* 2262458 */   // Label 32167: @2262458
     /* 2262458 */   GIM_Reject,
     /* 2262459 */ // Label 32165: @2262459
     /* 2262459 */ GIM_Reject,
     /* 2262460 */ // Label 32128: @2262460
     /* 2262460 */ GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2262563),
     /* 2262465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2262468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262476 */   GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2262519), // Rule ID 58510 //
     /* 2262481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262484 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2262487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262518 */     // GIR_Coverage, 58510,
     /* 2262518 */     GIR_EraseRootFromParent_Done,
     /* 2262519 */   // Label 32169: @2262519
     /* 2262519 */   GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2262562), // Rule ID 58511 //
     /* 2262524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262527 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2262530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262561 */     // GIR_Coverage, 58511,
     /* 2262561 */     GIR_EraseRootFromParent_Done,
     /* 2262562 */   // Label 32170: @2262562
     /* 2262562 */   GIM_Reject,
     /* 2262563 */ // Label 32168: @2262563
     /* 2262563 */ GIM_Reject,
     /* 2262564 */ // Label 32129: @2262564
     /* 2262564 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2262667),
     /* 2262569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2262572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262580 */   GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2262623), // Rule ID 58518 //
     /* 2262585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262588 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2262591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262622 */     // GIR_Coverage, 58518,
     /* 2262622 */     GIR_EraseRootFromParent_Done,
     /* 2262623 */   // Label 32172: @2262623
     /* 2262623 */   GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2262666), // Rule ID 58519 //
     /* 2262628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262631 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2262634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262665 */     // GIR_Coverage, 58519,
     /* 2262665 */     GIR_EraseRootFromParent_Done,
     /* 2262666 */   // Label 32173: @2262666
     /* 2262666 */   GIM_Reject,
     /* 2262667 */ // Label 32171: @2262667
     /* 2262667 */ GIM_Reject,
     /* 2262668 */ // Label 32130: @2262668
     /* 2262668 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2262771),
     /* 2262673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2262676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262684 */   GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2262727), // Rule ID 58540 //
     /* 2262689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2262692 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2262695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2262709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262726 */     // GIR_Coverage, 58540,
     /* 2262726 */     GIR_EraseRootFromParent_Done,
     /* 2262727 */   // Label 32175: @2262727
     /* 2262727 */   GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2262770), // Rule ID 58541 //
     /* 2262732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2262735 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2262738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2262752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262769 */     // GIR_Coverage, 58541,
     /* 2262769 */     GIR_EraseRootFromParent_Done,
     /* 2262770 */   // Label 32176: @2262770
     /* 2262770 */   GIM_Reject,
     /* 2262771 */ // Label 32174: @2262771
     /* 2262771 */ GIM_Reject,
     /* 2262772 */ // Label 32131: @2262772
     /* 2262772 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2262875),
     /* 2262777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2262780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262788 */   GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2262831), // Rule ID 58506 //
     /* 2262793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262796 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2262799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262830 */     // GIR_Coverage, 58506,
     /* 2262830 */     GIR_EraseRootFromParent_Done,
     /* 2262831 */   // Label 32178: @2262831
     /* 2262831 */   GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2262874), // Rule ID 58507 //
     /* 2262836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262839 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2262842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2262856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262873 */     // GIR_Coverage, 58507,
     /* 2262873 */     GIR_EraseRootFromParent_Done,
     /* 2262874 */   // Label 32179: @2262874
     /* 2262874 */   GIM_Reject,
     /* 2262875 */ // Label 32177: @2262875
     /* 2262875 */ GIM_Reject,
     /* 2262876 */ // Label 32132: @2262876
     /* 2262876 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2262979),
     /* 2262881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2262884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262892 */   GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2262935), // Rule ID 58516 //
     /* 2262897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2262900 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2262903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262934 */     // GIR_Coverage, 58516,
     /* 2262934 */     GIR_EraseRootFromParent_Done,
     /* 2262935 */   // Label 32181: @2262935
     /* 2262935 */   GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2262978), // Rule ID 58517 //
     /* 2262940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2262943 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2262946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2262960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2262967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262977 */     // GIR_Coverage, 58517,
     /* 2262977 */     GIR_EraseRootFromParent_Done,
     /* 2262978 */   // Label 32182: @2262978
     /* 2262978 */   GIM_Reject,
     /* 2262979 */ // Label 32180: @2262979
     /* 2262979 */ GIM_Reject,
     /* 2262980 */ // Label 32133: @2262980
     /* 2262980 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2263083),
     /* 2262985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2262988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262996 */   GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2263039), // Rule ID 58534 //
     /* 2263001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263004 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2263007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263038 */     // GIR_Coverage, 58534,
     /* 2263038 */     GIR_EraseRootFromParent_Done,
     /* 2263039 */   // Label 32184: @2263039
     /* 2263039 */   GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2263082), // Rule ID 58535 //
     /* 2263044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263047 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2263050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263081 */     // GIR_Coverage, 58535,
     /* 2263081 */     GIR_EraseRootFromParent_Done,
     /* 2263082 */   // Label 32185: @2263082
     /* 2263082 */   GIM_Reject,
     /* 2263083 */ // Label 32183: @2263083
     /* 2263083 */ GIM_Reject,
     /* 2263084 */ // Label 32134: @2263084
     /* 2263084 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2263187),
     /* 2263089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2263092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263100 */   GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2263143), // Rule ID 58542 //
     /* 2263105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2263108 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2263111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263142 */     // GIR_Coverage, 58542,
     /* 2263142 */     GIR_EraseRootFromParent_Done,
     /* 2263143 */   // Label 32187: @2263143
     /* 2263143 */   GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2263186), // Rule ID 58543 //
     /* 2263148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2263151 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2263154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263185 */     // GIR_Coverage, 58543,
     /* 2263185 */     GIR_EraseRootFromParent_Done,
     /* 2263186 */   // Label 32188: @2263186
     /* 2263186 */   GIM_Reject,
     /* 2263187 */ // Label 32186: @2263187
     /* 2263187 */ GIM_Reject,
     /* 2263188 */ // Label 32135: @2263188
     /* 2263188 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2263291),
     /* 2263193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2263196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263204 */   GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2263247), // Rule ID 58514 //
     /* 2263209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263212 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2263215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2263229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263246 */     // GIR_Coverage, 58514,
     /* 2263246 */     GIR_EraseRootFromParent_Done,
     /* 2263247 */   // Label 32190: @2263247
     /* 2263247 */   GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2263290), // Rule ID 58515 //
     /* 2263252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263255 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2263258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2263272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263289 */     // GIR_Coverage, 58515,
     /* 2263289 */     GIR_EraseRootFromParent_Done,
     /* 2263290 */   // Label 32191: @2263290
     /* 2263290 */   GIM_Reject,
     /* 2263291 */ // Label 32189: @2263291
     /* 2263291 */ GIM_Reject,
     /* 2263292 */ // Label 32136: @2263292
     /* 2263292 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2263395),
     /* 2263297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2263300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263308 */   GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2263351), // Rule ID 58528 //
     /* 2263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263316 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2263319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263350 */     // GIR_Coverage, 58528,
     /* 2263350 */     GIR_EraseRootFromParent_Done,
     /* 2263351 */   // Label 32193: @2263351
     /* 2263351 */   GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2263394), // Rule ID 58529 //
     /* 2263356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263359 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2263362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263393 */     // GIR_Coverage, 58529,
     /* 2263393 */     GIR_EraseRootFromParent_Done,
     /* 2263394 */   // Label 32194: @2263394
     /* 2263394 */   GIM_Reject,
     /* 2263395 */ // Label 32192: @2263395
     /* 2263395 */ GIM_Reject,
     /* 2263396 */ // Label 32137: @2263396
     /* 2263396 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2263499),
     /* 2263401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2263404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263412 */   GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2263455), // Rule ID 58536 //
     /* 2263417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263420 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2263423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263454 */     // GIR_Coverage, 58536,
     /* 2263454 */     GIR_EraseRootFromParent_Done,
     /* 2263455 */   // Label 32196: @2263455
     /* 2263455 */   GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2263498), // Rule ID 58537 //
     /* 2263460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263463 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2263466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263497 */     // GIR_Coverage, 58537,
     /* 2263497 */     GIR_EraseRootFromParent_Done,
     /* 2263498 */   // Label 32197: @2263498
     /* 2263498 */   GIM_Reject,
     /* 2263499 */ // Label 32195: @2263499
     /* 2263499 */ GIM_Reject,
     /* 2263500 */ // Label 32138: @2263500
     /* 2263500 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2263603),
     /* 2263505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2263508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263516 */   GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2263559), // Rule ID 58544 //
     /* 2263521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2263524 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2263527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2263541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263558 */     // GIR_Coverage, 58544,
     /* 2263558 */     GIR_EraseRootFromParent_Done,
     /* 2263559 */   // Label 32199: @2263559
     /* 2263559 */   GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2263602), // Rule ID 58545 //
     /* 2263564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2263567 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2263570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2263584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263601 */     // GIR_Coverage, 58545,
     /* 2263601 */     GIR_EraseRootFromParent_Done,
     /* 2263602 */   // Label 32200: @2263602
     /* 2263602 */   GIM_Reject,
     /* 2263603 */ // Label 32198: @2263603
     /* 2263603 */ GIM_Reject,
     /* 2263604 */ // Label 32139: @2263604
     /* 2263604 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2263707),
     /* 2263609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2263612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263620 */   GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2263663), // Rule ID 58522 //
     /* 2263625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263628 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2263631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263662 */     // GIR_Coverage, 58522,
     /* 2263662 */     GIR_EraseRootFromParent_Done,
     /* 2263663 */   // Label 32202: @2263663
     /* 2263663 */   GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2263706), // Rule ID 58523 //
     /* 2263668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263671 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2263674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2263688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263705 */     // GIR_Coverage, 58523,
     /* 2263705 */     GIR_EraseRootFromParent_Done,
     /* 2263706 */   // Label 32203: @2263706
     /* 2263706 */   GIM_Reject,
     /* 2263707 */ // Label 32201: @2263707
     /* 2263707 */ GIM_Reject,
     /* 2263708 */ // Label 32140: @2263708
     /* 2263708 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2263811),
     /* 2263713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2263716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263724 */   GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2263767), // Rule ID 58530 //
     /* 2263729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263732 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263766 */     // GIR_Coverage, 58530,
     /* 2263766 */     GIR_EraseRootFromParent_Done,
     /* 2263767 */   // Label 32205: @2263767
     /* 2263767 */   GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2263810), // Rule ID 58531 //
     /* 2263772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263775 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263809 */     // GIR_Coverage, 58531,
     /* 2263809 */     GIR_EraseRootFromParent_Done,
     /* 2263810 */   // Label 32206: @2263810
     /* 2263810 */   GIM_Reject,
     /* 2263811 */ // Label 32204: @2263811
     /* 2263811 */ GIM_Reject,
     /* 2263812 */ // Label 32141: @2263812
     /* 2263812 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2263915),
     /* 2263817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2263820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263828 */   GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2263871), // Rule ID 58538 //
     /* 2263833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263836 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2263853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263870 */     // GIR_Coverage, 58538,
     /* 2263870 */     GIR_EraseRootFromParent_Done,
     /* 2263871 */   // Label 32208: @2263871
     /* 2263871 */   GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2263914), // Rule ID 58539 //
     /* 2263876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263879 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2263896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263913 */     // GIR_Coverage, 58539,
     /* 2263913 */     GIR_EraseRootFromParent_Done,
     /* 2263914 */   // Label 32209: @2263914
     /* 2263914 */   GIM_Reject,
     /* 2263915 */ // Label 32207: @2263915
     /* 2263915 */ GIM_Reject,
     /* 2263916 */ // Label 32142: @2263916
     /* 2263916 */ GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2264019),
     /* 2263921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2263924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263932 */   GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2263975), // Rule ID 58524 //
     /* 2263937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2263940 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2263943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2263957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2263964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263974 */     // GIR_Coverage, 58524,
     /* 2263974 */     GIR_EraseRootFromParent_Done,
     /* 2263975 */   // Label 32211: @2263975
     /* 2263975 */   GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2264018), // Rule ID 58525 //
     /* 2263980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2263983 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2263986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2264000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264017 */     // GIR_Coverage, 58525,
     /* 2264017 */     GIR_EraseRootFromParent_Done,
     /* 2264018 */   // Label 32212: @2264018
     /* 2264018 */   GIM_Reject,
     /* 2264019 */ // Label 32210: @2264019
     /* 2264019 */ GIM_Reject,
     /* 2264020 */ // Label 32143: @2264020
     /* 2264020 */ GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2264123),
     /* 2264025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2264028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264036 */   GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2264079), // Rule ID 58532 //
     /* 2264041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2264044 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2264047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2264061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264078 */     // GIR_Coverage, 58532,
     /* 2264078 */     GIR_EraseRootFromParent_Done,
     /* 2264079 */   // Label 32214: @2264079
     /* 2264079 */   GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2264122), // Rule ID 58533 //
     /* 2264084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2264087 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2264090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2264104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264121 */     // GIR_Coverage, 58533,
     /* 2264121 */     GIR_EraseRootFromParent_Done,
     /* 2264122 */   // Label 32215: @2264122
     /* 2264122 */   GIM_Reject,
     /* 2264123 */ // Label 32213: @2264123
     /* 2264123 */ GIM_Reject,
     /* 2264124 */ // Label 32144: @2264124
     /* 2264124 */ GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2264227),
     /* 2264129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2264132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264140 */   GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2264183), // Rule ID 58526 //
     /* 2264145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2264148 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2264151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2264165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264182 */     // GIR_Coverage, 58526,
     /* 2264182 */     GIR_EraseRootFromParent_Done,
     /* 2264183 */   // Label 32217: @2264183
     /* 2264183 */   GIM_Try, /*On fail goto*//*Label 32218*/ GIMT_Encode4(2264226), // Rule ID 58527 //
     /* 2264188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2264191 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2264194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2264208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264225 */     // GIR_Coverage, 58527,
     /* 2264225 */     GIR_EraseRootFromParent_Done,
     /* 2264226 */   // Label 32218: @2264226
     /* 2264226 */   GIM_Reject,
     /* 2264227 */ // Label 32216: @2264227
     /* 2264227 */ GIM_Reject,
     /* 2264228 */ // Label 32145: @2264228
     /* 2264228 */ GIM_Reject,
     /* 2264229 */ // Label 87: @2264229
     /* 2264229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32243*/ GIMT_Encode4(2266763),
     /* 2264240 */ /*GILLT_s32*//*Label 32219*/ GIMT_Encode4(2264364),
     /* 2264244 */ /*GILLT_s64*//*Label 32220*/ GIMT_Encode4(2264427), GIMT_Encode4(0),
     /* 2264252 */ /*GILLT_nxv1s8*//*Label 32221*/ GIMT_Encode4(2264475),
     /* 2264256 */ /*GILLT_nxv1s16*//*Label 32222*/ GIMT_Encode4(2264579),
     /* 2264260 */ /*GILLT_nxv1s32*//*Label 32223*/ GIMT_Encode4(2264683),
     /* 2264264 */ /*GILLT_nxv1s64*//*Label 32224*/ GIMT_Encode4(2264787), GIMT_Encode4(0),
     /* 2264272 */ /*GILLT_nxv2s8*//*Label 32225*/ GIMT_Encode4(2264891),
     /* 2264276 */ /*GILLT_nxv2s16*//*Label 32226*/ GIMT_Encode4(2264995),
     /* 2264280 */ /*GILLT_nxv2s32*//*Label 32227*/ GIMT_Encode4(2265099),
     /* 2264284 */ /*GILLT_nxv2s64*//*Label 32228*/ GIMT_Encode4(2265203), GIMT_Encode4(0),
     /* 2264292 */ /*GILLT_nxv4s8*//*Label 32229*/ GIMT_Encode4(2265307),
     /* 2264296 */ /*GILLT_nxv4s16*//*Label 32230*/ GIMT_Encode4(2265411),
     /* 2264300 */ /*GILLT_nxv4s32*//*Label 32231*/ GIMT_Encode4(2265515),
     /* 2264304 */ /*GILLT_nxv4s64*//*Label 32232*/ GIMT_Encode4(2265619), GIMT_Encode4(0),
     /* 2264312 */ /*GILLT_nxv8s8*//*Label 32233*/ GIMT_Encode4(2265723),
     /* 2264316 */ /*GILLT_nxv8s16*//*Label 32234*/ GIMT_Encode4(2265827),
     /* 2264320 */ /*GILLT_nxv8s32*//*Label 32235*/ GIMT_Encode4(2265931),
     /* 2264324 */ /*GILLT_nxv8s64*//*Label 32236*/ GIMT_Encode4(2266035), GIMT_Encode4(0),
     /* 2264332 */ /*GILLT_nxv16s8*//*Label 32237*/ GIMT_Encode4(2266139),
     /* 2264336 */ /*GILLT_nxv16s16*//*Label 32238*/ GIMT_Encode4(2266243),
     /* 2264340 */ /*GILLT_nxv16s32*//*Label 32239*/ GIMT_Encode4(2266347), GIMT_Encode4(0),
     /* 2264348 */ /*GILLT_nxv32s8*//*Label 32240*/ GIMT_Encode4(2266451),
     /* 2264352 */ /*GILLT_nxv32s16*//*Label 32241*/ GIMT_Encode4(2266555), GIMT_Encode4(0),
     /* 2264360 */ /*GILLT_nxv64s8*//*Label 32242*/ GIMT_Encode4(2266659),
     /* 2264364 */ // Label 32219: @2264364
     /* 2264364 */ GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2264426),
     /* 2264369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2264372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264380 */   GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2264395), // Rule ID 2394 //
     /* 2264385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2264388 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2264388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2264393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264394 */     // GIR_Coverage, 2394,
     /* 2264394 */     GIR_Done,
     /* 2264395 */   // Label 32245: @2264395
     /* 2264395 */   GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2264410), // Rule ID 2395 //
     /* 2264400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2264403 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2264403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2264408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264409 */     // GIR_Coverage, 2395,
     /* 2264409 */     GIR_Done,
     /* 2264410 */   // Label 32246: @2264410
     /* 2264410 */   GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2264425), // Rule ID 61876 //
     /* 2264415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2264418 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2264418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2264423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264424 */     // GIR_Coverage, 61876,
     /* 2264424 */     GIR_Done,
     /* 2264425 */   // Label 32247: @2264425
     /* 2264425 */   GIM_Reject,
     /* 2264426 */ // Label 32244: @2264426
     /* 2264426 */ GIM_Reject,
     /* 2264427 */ // Label 32220: @2264427
     /* 2264427 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2264474),
     /* 2264432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2264435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264443 */   GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2264458), // Rule ID 2396 //
     /* 2264448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2264451 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2264451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2264456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264457 */     // GIR_Coverage, 2396,
     /* 2264457 */     GIR_Done,
     /* 2264458 */   // Label 32249: @2264458
     /* 2264458 */   GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2264473), // Rule ID 61875 //
     /* 2264463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2264466 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2264466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2264471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264472 */     // GIR_Coverage, 61875,
     /* 2264472 */     GIR_Done,
     /* 2264473 */   // Label 32250: @2264473
     /* 2264473 */   GIM_Reject,
     /* 2264474 */ // Label 32248: @2264474
     /* 2264474 */ GIM_Reject,
     /* 2264475 */ // Label 32221: @2264475
     /* 2264475 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2264578),
     /* 2264480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2264483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264491 */   GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2264534), // Rule ID 58370 //
     /* 2264496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2264499 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2264516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264533 */     // GIR_Coverage, 58370,
     /* 2264533 */     GIR_EraseRootFromParent_Done,
     /* 2264534 */   // Label 32252: @2264534
     /* 2264534 */   GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2264577), // Rule ID 58371 //
     /* 2264539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2264542 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2264559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264576 */     // GIR_Coverage, 58371,
     /* 2264576 */     GIR_EraseRootFromParent_Done,
     /* 2264577 */   // Label 32253: @2264577
     /* 2264577 */   GIM_Reject,
     /* 2264578 */ // Label 32251: @2264578
     /* 2264578 */ GIM_Reject,
     /* 2264579 */ // Label 32222: @2264579
     /* 2264579 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2264682),
     /* 2264584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2264587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264595 */   GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2264638), // Rule ID 58376 //
     /* 2264600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2264603 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2264620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264637 */     // GIR_Coverage, 58376,
     /* 2264637 */     GIR_EraseRootFromParent_Done,
     /* 2264638 */   // Label 32255: @2264638
     /* 2264638 */   GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2264681), // Rule ID 58377 //
     /* 2264643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2264646 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2264663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264680 */     // GIR_Coverage, 58377,
     /* 2264680 */     GIR_EraseRootFromParent_Done,
     /* 2264681 */   // Label 32256: @2264681
     /* 2264681 */   GIM_Reject,
     /* 2264682 */ // Label 32254: @2264682
     /* 2264682 */ GIM_Reject,
     /* 2264683 */ // Label 32223: @2264683
     /* 2264683 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2264786),
     /* 2264688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2264691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264699 */   GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2264742), // Rule ID 58380 //
     /* 2264704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2264707 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2264724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264741 */     // GIR_Coverage, 58380,
     /* 2264741 */     GIR_EraseRootFromParent_Done,
     /* 2264742 */   // Label 32258: @2264742
     /* 2264742 */   GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2264785), // Rule ID 58381 //
     /* 2264747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2264750 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2264767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264784 */     // GIR_Coverage, 58381,
     /* 2264784 */     GIR_EraseRootFromParent_Done,
     /* 2264785 */   // Label 32259: @2264785
     /* 2264785 */   GIM_Reject,
     /* 2264786 */ // Label 32257: @2264786
     /* 2264786 */ GIM_Reject,
     /* 2264787 */ // Label 32224: @2264787
     /* 2264787 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2264890),
     /* 2264792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2264795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264803 */   GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2264846), // Rule ID 58388 //
     /* 2264808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2264811 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2264828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264845 */     // GIR_Coverage, 58388,
     /* 2264845 */     GIR_EraseRootFromParent_Done,
     /* 2264846 */   // Label 32261: @2264846
     /* 2264846 */   GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2264889), // Rule ID 58389 //
     /* 2264851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2264854 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2264871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264888 */     // GIR_Coverage, 58389,
     /* 2264888 */     GIR_EraseRootFromParent_Done,
     /* 2264889 */   // Label 32262: @2264889
     /* 2264889 */   GIM_Reject,
     /* 2264890 */ // Label 32260: @2264890
     /* 2264890 */ GIM_Reject,
     /* 2264891 */ // Label 32225: @2264891
     /* 2264891 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2264994),
     /* 2264896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2264899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264907 */   GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2264950), // Rule ID 58372 //
     /* 2264912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2264915 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2264918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2264932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264949 */     // GIR_Coverage, 58372,
     /* 2264949 */     GIR_EraseRootFromParent_Done,
     /* 2264950 */   // Label 32264: @2264950
     /* 2264950 */   GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2264993), // Rule ID 58373 //
     /* 2264955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2264958 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2264961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2264975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264992 */     // GIR_Coverage, 58373,
     /* 2264992 */     GIR_EraseRootFromParent_Done,
     /* 2264993 */   // Label 32265: @2264993
     /* 2264993 */   GIM_Reject,
     /* 2264994 */ // Label 32263: @2264994
     /* 2264994 */ GIM_Reject,
     /* 2264995 */ // Label 32226: @2264995
     /* 2264995 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2265098),
     /* 2265000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2265003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265011 */   GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2265054), // Rule ID 58378 //
     /* 2265016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265019 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2265036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265053 */     // GIR_Coverage, 58378,
     /* 2265053 */     GIR_EraseRootFromParent_Done,
     /* 2265054 */   // Label 32267: @2265054
     /* 2265054 */   GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2265097), // Rule ID 58379 //
     /* 2265059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265062 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2265079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265096 */     // GIR_Coverage, 58379,
     /* 2265096 */     GIR_EraseRootFromParent_Done,
     /* 2265097 */   // Label 32268: @2265097
     /* 2265097 */   GIM_Reject,
     /* 2265098 */ // Label 32266: @2265098
     /* 2265098 */ GIM_Reject,
     /* 2265099 */ // Label 32227: @2265099
     /* 2265099 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2265202),
     /* 2265104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2265107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265115 */   GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2265158), // Rule ID 58386 //
     /* 2265120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265123 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265157 */     // GIR_Coverage, 58386,
     /* 2265157 */     GIR_EraseRootFromParent_Done,
     /* 2265158 */   // Label 32270: @2265158
     /* 2265158 */   GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2265201), // Rule ID 58387 //
     /* 2265163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265166 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265200 */     // GIR_Coverage, 58387,
     /* 2265200 */     GIR_EraseRootFromParent_Done,
     /* 2265201 */   // Label 32271: @2265201
     /* 2265201 */   GIM_Reject,
     /* 2265202 */ // Label 32269: @2265202
     /* 2265202 */ GIM_Reject,
     /* 2265203 */ // Label 32228: @2265203
     /* 2265203 */ GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2265306),
     /* 2265208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2265211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265219 */   GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2265262), // Rule ID 58408 //
     /* 2265224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2265227 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265261 */     // GIR_Coverage, 58408,
     /* 2265261 */     GIR_EraseRootFromParent_Done,
     /* 2265262 */   // Label 32273: @2265262
     /* 2265262 */   GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2265305), // Rule ID 58409 //
     /* 2265267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2265270 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265304 */     // GIR_Coverage, 58409,
     /* 2265304 */     GIR_EraseRootFromParent_Done,
     /* 2265305 */   // Label 32274: @2265305
     /* 2265305 */   GIM_Reject,
     /* 2265306 */ // Label 32272: @2265306
     /* 2265306 */ GIM_Reject,
     /* 2265307 */ // Label 32229: @2265307
     /* 2265307 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2265410),
     /* 2265312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2265315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265323 */   GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2265366), // Rule ID 58374 //
     /* 2265328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265331 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2265348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265365 */     // GIR_Coverage, 58374,
     /* 2265365 */     GIR_EraseRootFromParent_Done,
     /* 2265366 */   // Label 32276: @2265366
     /* 2265366 */   GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2265409), // Rule ID 58375 //
     /* 2265371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265374 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2265391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265408 */     // GIR_Coverage, 58375,
     /* 2265408 */     GIR_EraseRootFromParent_Done,
     /* 2265409 */   // Label 32277: @2265409
     /* 2265409 */   GIM_Reject,
     /* 2265410 */ // Label 32275: @2265410
     /* 2265410 */ GIM_Reject,
     /* 2265411 */ // Label 32230: @2265411
     /* 2265411 */ GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2265514),
     /* 2265416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2265419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265427 */   GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2265470), // Rule ID 58384 //
     /* 2265432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265435 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265469 */     // GIR_Coverage, 58384,
     /* 2265469 */     GIR_EraseRootFromParent_Done,
     /* 2265470 */   // Label 32279: @2265470
     /* 2265470 */   GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2265513), // Rule ID 58385 //
     /* 2265475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265478 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265512 */     // GIR_Coverage, 58385,
     /* 2265512 */     GIR_EraseRootFromParent_Done,
     /* 2265513 */   // Label 32280: @2265513
     /* 2265513 */   GIM_Reject,
     /* 2265514 */ // Label 32278: @2265514
     /* 2265514 */ GIM_Reject,
     /* 2265515 */ // Label 32231: @2265515
     /* 2265515 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2265618),
     /* 2265520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2265523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265531 */   GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2265574), // Rule ID 58402 //
     /* 2265536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265539 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2265542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265573 */     // GIR_Coverage, 58402,
     /* 2265573 */     GIR_EraseRootFromParent_Done,
     /* 2265574 */   // Label 32282: @2265574
     /* 2265574 */   GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2265617), // Rule ID 58403 //
     /* 2265579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265582 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2265585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265616 */     // GIR_Coverage, 58403,
     /* 2265616 */     GIR_EraseRootFromParent_Done,
     /* 2265617 */   // Label 32283: @2265617
     /* 2265617 */   GIM_Reject,
     /* 2265618 */ // Label 32281: @2265618
     /* 2265618 */ GIM_Reject,
     /* 2265619 */ // Label 32232: @2265619
     /* 2265619 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2265722),
     /* 2265624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2265627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265635 */   GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2265678), // Rule ID 58410 //
     /* 2265640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2265643 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2265646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2265660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265677 */     // GIR_Coverage, 58410,
     /* 2265677 */     GIR_EraseRootFromParent_Done,
     /* 2265678 */   // Label 32285: @2265678
     /* 2265678 */   GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2265721), // Rule ID 58411 //
     /* 2265683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2265686 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2265689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2265703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265720 */     // GIR_Coverage, 58411,
     /* 2265720 */     GIR_EraseRootFromParent_Done,
     /* 2265721 */   // Label 32286: @2265721
     /* 2265721 */   GIM_Reject,
     /* 2265722 */ // Label 32284: @2265722
     /* 2265722 */ GIM_Reject,
     /* 2265723 */ // Label 32233: @2265723
     /* 2265723 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2265826),
     /* 2265728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2265731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265739 */   GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2265782), // Rule ID 58382 //
     /* 2265744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265747 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2265750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265781 */     // GIR_Coverage, 58382,
     /* 2265781 */     GIR_EraseRootFromParent_Done,
     /* 2265782 */   // Label 32288: @2265782
     /* 2265782 */   GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2265825), // Rule ID 58383 //
     /* 2265787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265790 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2265793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2265807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265824 */     // GIR_Coverage, 58383,
     /* 2265824 */     GIR_EraseRootFromParent_Done,
     /* 2265825 */   // Label 32289: @2265825
     /* 2265825 */   GIM_Reject,
     /* 2265826 */ // Label 32287: @2265826
     /* 2265826 */ GIM_Reject,
     /* 2265827 */ // Label 32234: @2265827
     /* 2265827 */ GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2265930),
     /* 2265832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2265835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265843 */   GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2265886), // Rule ID 58396 //
     /* 2265848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265851 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2265854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265885 */     // GIR_Coverage, 58396,
     /* 2265885 */     GIR_EraseRootFromParent_Done,
     /* 2265886 */   // Label 32291: @2265886
     /* 2265886 */   GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2265929), // Rule ID 58397 //
     /* 2265891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265894 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2265897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2265911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265928 */     // GIR_Coverage, 58397,
     /* 2265928 */     GIR_EraseRootFromParent_Done,
     /* 2265929 */   // Label 32292: @2265929
     /* 2265929 */   GIM_Reject,
     /* 2265930 */ // Label 32290: @2265930
     /* 2265930 */ GIM_Reject,
     /* 2265931 */ // Label 32235: @2265931
     /* 2265931 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2266034),
     /* 2265936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2265939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265947 */   GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2265990), // Rule ID 58404 //
     /* 2265952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2265955 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2265958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2265972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265989 */     // GIR_Coverage, 58404,
     /* 2265989 */     GIR_EraseRootFromParent_Done,
     /* 2265990 */   // Label 32294: @2265990
     /* 2265990 */   GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2266033), // Rule ID 58405 //
     /* 2265995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2265998 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2266001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2266015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266032 */     // GIR_Coverage, 58405,
     /* 2266032 */     GIR_EraseRootFromParent_Done,
     /* 2266033 */   // Label 32295: @2266033
     /* 2266033 */   GIM_Reject,
     /* 2266034 */ // Label 32293: @2266034
     /* 2266034 */ GIM_Reject,
     /* 2266035 */ // Label 32236: @2266035
     /* 2266035 */ GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2266138),
     /* 2266040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2266043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266051 */   GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2266094), // Rule ID 58412 //
     /* 2266056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2266059 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2266062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266093 */     // GIR_Coverage, 58412,
     /* 2266093 */     GIR_EraseRootFromParent_Done,
     /* 2266094 */   // Label 32297: @2266094
     /* 2266094 */   GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2266137), // Rule ID 58413 //
     /* 2266099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2266102 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2266105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266136 */     // GIR_Coverage, 58413,
     /* 2266136 */     GIR_EraseRootFromParent_Done,
     /* 2266137 */   // Label 32298: @2266137
     /* 2266137 */   GIM_Reject,
     /* 2266138 */ // Label 32296: @2266138
     /* 2266138 */ GIM_Reject,
     /* 2266139 */ // Label 32237: @2266139
     /* 2266139 */ GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2266242),
     /* 2266144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2266147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266155 */   GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2266198), // Rule ID 58390 //
     /* 2266160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266163 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2266166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2266180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266197 */     // GIR_Coverage, 58390,
     /* 2266197 */     GIR_EraseRootFromParent_Done,
     /* 2266198 */   // Label 32300: @2266198
     /* 2266198 */   GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2266241), // Rule ID 58391 //
     /* 2266203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266206 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2266209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2266223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266240 */     // GIR_Coverage, 58391,
     /* 2266240 */     GIR_EraseRootFromParent_Done,
     /* 2266241 */   // Label 32301: @2266241
     /* 2266241 */   GIM_Reject,
     /* 2266242 */ // Label 32299: @2266242
     /* 2266242 */ GIM_Reject,
     /* 2266243 */ // Label 32238: @2266243
     /* 2266243 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2266346),
     /* 2266248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2266251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266259 */   GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2266302), // Rule ID 58398 //
     /* 2266264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266267 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2266270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2266284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266301 */     // GIR_Coverage, 58398,
     /* 2266301 */     GIR_EraseRootFromParent_Done,
     /* 2266302 */   // Label 32303: @2266302
     /* 2266302 */   GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2266345), // Rule ID 58399 //
     /* 2266307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266310 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2266313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2266327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266344 */     // GIR_Coverage, 58399,
     /* 2266344 */     GIR_EraseRootFromParent_Done,
     /* 2266345 */   // Label 32304: @2266345
     /* 2266345 */   GIM_Reject,
     /* 2266346 */ // Label 32302: @2266346
     /* 2266346 */ GIM_Reject,
     /* 2266347 */ // Label 32239: @2266347
     /* 2266347 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2266450),
     /* 2266352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2266355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266363 */   GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2266406), // Rule ID 58406 //
     /* 2266368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266371 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2266374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266405 */     // GIR_Coverage, 58406,
     /* 2266405 */     GIR_EraseRootFromParent_Done,
     /* 2266406 */   // Label 32306: @2266406
     /* 2266406 */   GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2266449), // Rule ID 58407 //
     /* 2266411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266414 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2266417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266448 */     // GIR_Coverage, 58407,
     /* 2266448 */     GIR_EraseRootFromParent_Done,
     /* 2266449 */   // Label 32307: @2266449
     /* 2266449 */   GIM_Reject,
     /* 2266450 */ // Label 32305: @2266450
     /* 2266450 */ GIM_Reject,
     /* 2266451 */ // Label 32240: @2266451
     /* 2266451 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2266554),
     /* 2266456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2266459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266467 */   GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2266510), // Rule ID 58392 //
     /* 2266472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266475 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2266478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2266492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266509 */     // GIR_Coverage, 58392,
     /* 2266509 */     GIR_EraseRootFromParent_Done,
     /* 2266510 */   // Label 32309: @2266510
     /* 2266510 */   GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2266553), // Rule ID 58393 //
     /* 2266515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266518 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2266521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2266535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266552 */     // GIR_Coverage, 58393,
     /* 2266552 */     GIR_EraseRootFromParent_Done,
     /* 2266553 */   // Label 32310: @2266553
     /* 2266553 */   GIM_Reject,
     /* 2266554 */ // Label 32308: @2266554
     /* 2266554 */ GIM_Reject,
     /* 2266555 */ // Label 32241: @2266555
     /* 2266555 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2266658),
     /* 2266560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2266563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266571 */   GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2266614), // Rule ID 58400 //
     /* 2266576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266579 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2266582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266613 */     // GIR_Coverage, 58400,
     /* 2266613 */     GIR_EraseRootFromParent_Done,
     /* 2266614 */   // Label 32312: @2266614
     /* 2266614 */   GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2266657), // Rule ID 58401 //
     /* 2266619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266622 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2266625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266656 */     // GIR_Coverage, 58401,
     /* 2266656 */     GIR_EraseRootFromParent_Done,
     /* 2266657 */   // Label 32313: @2266657
     /* 2266657 */   GIM_Reject,
     /* 2266658 */ // Label 32311: @2266658
     /* 2266658 */ GIM_Reject,
     /* 2266659 */ // Label 32242: @2266659
     /* 2266659 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2266762),
     /* 2266664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2266667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266675 */   GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2266718), // Rule ID 58394 //
     /* 2266680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2266683 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2266686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266717 */     // GIR_Coverage, 58394,
     /* 2266717 */     GIR_EraseRootFromParent_Done,
     /* 2266718 */   // Label 32315: @2266718
     /* 2266718 */   GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2266761), // Rule ID 58395 //
     /* 2266723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2266726 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2266729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2266743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266760 */     // GIR_Coverage, 58395,
     /* 2266760 */     GIR_EraseRootFromParent_Done,
     /* 2266761 */   // Label 32316: @2266761
     /* 2266761 */   GIM_Reject,
     /* 2266762 */ // Label 32314: @2266762
     /* 2266762 */ GIM_Reject,
     /* 2266763 */ // Label 32243: @2266763
     /* 2266763 */ GIM_Reject,
     /* 2266764 */ // Label 88: @2266764
     /* 2266764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32341*/ GIMT_Encode4(2269257),
     /* 2266775 */ /*GILLT_s32*//*Label 32317*/ GIMT_Encode4(2266899),
     /* 2266779 */ /*GILLT_s64*//*Label 32318*/ GIMT_Encode4(2266934), GIMT_Encode4(0),
     /* 2266787 */ /*GILLT_nxv1s8*//*Label 32319*/ GIMT_Encode4(2266969),
     /* 2266791 */ /*GILLT_nxv1s16*//*Label 32320*/ GIMT_Encode4(2267073),
     /* 2266795 */ /*GILLT_nxv1s32*//*Label 32321*/ GIMT_Encode4(2267177),
     /* 2266799 */ /*GILLT_nxv1s64*//*Label 32322*/ GIMT_Encode4(2267281), GIMT_Encode4(0),
     /* 2266807 */ /*GILLT_nxv2s8*//*Label 32323*/ GIMT_Encode4(2267385),
     /* 2266811 */ /*GILLT_nxv2s16*//*Label 32324*/ GIMT_Encode4(2267489),
     /* 2266815 */ /*GILLT_nxv2s32*//*Label 32325*/ GIMT_Encode4(2267593),
     /* 2266819 */ /*GILLT_nxv2s64*//*Label 32326*/ GIMT_Encode4(2267697), GIMT_Encode4(0),
     /* 2266827 */ /*GILLT_nxv4s8*//*Label 32327*/ GIMT_Encode4(2267801),
     /* 2266831 */ /*GILLT_nxv4s16*//*Label 32328*/ GIMT_Encode4(2267905),
     /* 2266835 */ /*GILLT_nxv4s32*//*Label 32329*/ GIMT_Encode4(2268009),
     /* 2266839 */ /*GILLT_nxv4s64*//*Label 32330*/ GIMT_Encode4(2268113), GIMT_Encode4(0),
     /* 2266847 */ /*GILLT_nxv8s8*//*Label 32331*/ GIMT_Encode4(2268217),
     /* 2266851 */ /*GILLT_nxv8s16*//*Label 32332*/ GIMT_Encode4(2268321),
     /* 2266855 */ /*GILLT_nxv8s32*//*Label 32333*/ GIMT_Encode4(2268425),
     /* 2266859 */ /*GILLT_nxv8s64*//*Label 32334*/ GIMT_Encode4(2268529), GIMT_Encode4(0),
     /* 2266867 */ /*GILLT_nxv16s8*//*Label 32335*/ GIMT_Encode4(2268633),
     /* 2266871 */ /*GILLT_nxv16s16*//*Label 32336*/ GIMT_Encode4(2268737),
     /* 2266875 */ /*GILLT_nxv16s32*//*Label 32337*/ GIMT_Encode4(2268841), GIMT_Encode4(0),
     /* 2266883 */ /*GILLT_nxv32s8*//*Label 32338*/ GIMT_Encode4(2268945),
     /* 2266887 */ /*GILLT_nxv32s16*//*Label 32339*/ GIMT_Encode4(2269049), GIMT_Encode4(0),
     /* 2266895 */ /*GILLT_nxv64s8*//*Label 32340*/ GIMT_Encode4(2269153),
     /* 2266899 */ // Label 32317: @2266899
     /* 2266899 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2266933), // Rule ID 63762 //
     /* 2266904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2266907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2266910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266918 */   // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2266918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2266921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2266925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2266928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2266931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266932 */   // GIR_Coverage, 63762,
     /* 2266932 */   GIR_EraseRootFromParent_Done,
     /* 2266933 */ // Label 32342: @2266933
     /* 2266933 */ GIM_Reject,
     /* 2266934 */ // Label 32318: @2266934
     /* 2266934 */ GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2266968), // Rule ID 63761 //
     /* 2266939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2266942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2266945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266953 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2266953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2266956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266958 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2266960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2266963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2266966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266967 */   // GIR_Coverage, 63761,
     /* 2266967 */   GIR_EraseRootFromParent_Done,
     /* 2266968 */ // Label 32343: @2266968
     /* 2266968 */ GIM_Reject,
     /* 2266969 */ // Label 32319: @2266969
     /* 2266969 */ GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2267072),
     /* 2266974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2266977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266985 */   GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2267028), // Rule ID 58194 //
     /* 2266990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2266993 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2266996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2267010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267027 */     // GIR_Coverage, 58194,
     /* 2267027 */     GIR_EraseRootFromParent_Done,
     /* 2267028 */   // Label 32345: @2267028
     /* 2267028 */   GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2267071), // Rule ID 58195 //
     /* 2267033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267036 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2267039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2267053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267070 */     // GIR_Coverage, 58195,
     /* 2267070 */     GIR_EraseRootFromParent_Done,
     /* 2267071 */   // Label 32346: @2267071
     /* 2267071 */   GIM_Reject,
     /* 2267072 */ // Label 32344: @2267072
     /* 2267072 */ GIM_Reject,
     /* 2267073 */ // Label 32320: @2267073
     /* 2267073 */ GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2267176),
     /* 2267078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2267081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267089 */   GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2267132), // Rule ID 58332 //
     /* 2267094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267097 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2267100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2267114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267131 */     // GIR_Coverage, 58332,
     /* 2267131 */     GIR_EraseRootFromParent_Done,
     /* 2267132 */   // Label 32348: @2267132
     /* 2267132 */   GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2267175), // Rule ID 58333 //
     /* 2267137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267140 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2267143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2267157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267174 */     // GIR_Coverage, 58333,
     /* 2267174 */     GIR_EraseRootFromParent_Done,
     /* 2267175 */   // Label 32349: @2267175
     /* 2267175 */   GIM_Reject,
     /* 2267176 */ // Label 32347: @2267176
     /* 2267176 */ GIM_Reject,
     /* 2267177 */ // Label 32321: @2267177
     /* 2267177 */ GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2267280),
     /* 2267182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2267185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267193 */   GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2267236), // Rule ID 58336 //
     /* 2267198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267201 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2267204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267235 */     // GIR_Coverage, 58336,
     /* 2267235 */     GIR_EraseRootFromParent_Done,
     /* 2267236 */   // Label 32351: @2267236
     /* 2267236 */   GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2267279), // Rule ID 58337 //
     /* 2267241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267244 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2267247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267278 */     // GIR_Coverage, 58337,
     /* 2267278 */     GIR_EraseRootFromParent_Done,
     /* 2267279 */   // Label 32352: @2267279
     /* 2267279 */   GIM_Reject,
     /* 2267280 */ // Label 32350: @2267280
     /* 2267280 */ GIM_Reject,
     /* 2267281 */ // Label 32322: @2267281
     /* 2267281 */ GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2267384),
     /* 2267286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2267289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267297 */   GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2267340), // Rule ID 58344 //
     /* 2267302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2267305 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2267308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267339 */     // GIR_Coverage, 58344,
     /* 2267339 */     GIR_EraseRootFromParent_Done,
     /* 2267340 */   // Label 32354: @2267340
     /* 2267340 */   GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2267383), // Rule ID 58345 //
     /* 2267345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2267348 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2267351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267382 */     // GIR_Coverage, 58345,
     /* 2267382 */     GIR_EraseRootFromParent_Done,
     /* 2267383 */   // Label 32355: @2267383
     /* 2267383 */   GIM_Reject,
     /* 2267384 */ // Label 32353: @2267384
     /* 2267384 */ GIM_Reject,
     /* 2267385 */ // Label 32323: @2267385
     /* 2267385 */ GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2267488),
     /* 2267390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2267393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267401 */   GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2267444), // Rule ID 58328 //
     /* 2267406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267409 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2267412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2267426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267443 */     // GIR_Coverage, 58328,
     /* 2267443 */     GIR_EraseRootFromParent_Done,
     /* 2267444 */   // Label 32357: @2267444
     /* 2267444 */   GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2267487), // Rule ID 58329 //
     /* 2267449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267452 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2267455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2267469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267486 */     // GIR_Coverage, 58329,
     /* 2267486 */     GIR_EraseRootFromParent_Done,
     /* 2267487 */   // Label 32358: @2267487
     /* 2267487 */   GIM_Reject,
     /* 2267488 */ // Label 32356: @2267488
     /* 2267488 */ GIM_Reject,
     /* 2267489 */ // Label 32324: @2267489
     /* 2267489 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2267592),
     /* 2267494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2267497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267505 */   GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2267548), // Rule ID 58334 //
     /* 2267510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267513 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2267516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267547 */     // GIR_Coverage, 58334,
     /* 2267547 */     GIR_EraseRootFromParent_Done,
     /* 2267548 */   // Label 32360: @2267548
     /* 2267548 */   GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2267591), // Rule ID 58335 //
     /* 2267553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267556 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2267559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267590 */     // GIR_Coverage, 58335,
     /* 2267590 */     GIR_EraseRootFromParent_Done,
     /* 2267591 */   // Label 32361: @2267591
     /* 2267591 */   GIM_Reject,
     /* 2267592 */ // Label 32359: @2267592
     /* 2267592 */ GIM_Reject,
     /* 2267593 */ // Label 32325: @2267593
     /* 2267593 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2267696),
     /* 2267598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2267601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267609 */   GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2267652), // Rule ID 58342 //
     /* 2267614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267617 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2267620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267651 */     // GIR_Coverage, 58342,
     /* 2267651 */     GIR_EraseRootFromParent_Done,
     /* 2267652 */   // Label 32363: @2267652
     /* 2267652 */   GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2267695), // Rule ID 58343 //
     /* 2267657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267660 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2267663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267694 */     // GIR_Coverage, 58343,
     /* 2267694 */     GIR_EraseRootFromParent_Done,
     /* 2267695 */   // Label 32364: @2267695
     /* 2267695 */   GIM_Reject,
     /* 2267696 */ // Label 32362: @2267696
     /* 2267696 */ GIM_Reject,
     /* 2267697 */ // Label 32326: @2267697
     /* 2267697 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2267800),
     /* 2267702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2267705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267713 */   GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2267756), // Rule ID 58364 //
     /* 2267718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2267721 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2267724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2267738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267755 */     // GIR_Coverage, 58364,
     /* 2267755 */     GIR_EraseRootFromParent_Done,
     /* 2267756 */   // Label 32366: @2267756
     /* 2267756 */   GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2267799), // Rule ID 58365 //
     /* 2267761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2267764 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2267767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2267781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267798 */     // GIR_Coverage, 58365,
     /* 2267798 */     GIR_EraseRootFromParent_Done,
     /* 2267799 */   // Label 32367: @2267799
     /* 2267799 */   GIM_Reject,
     /* 2267800 */ // Label 32365: @2267800
     /* 2267800 */ GIM_Reject,
     /* 2267801 */ // Label 32327: @2267801
     /* 2267801 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2267904),
     /* 2267806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2267809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267817 */   GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2267860), // Rule ID 58330 //
     /* 2267822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267825 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2267828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267859 */     // GIR_Coverage, 58330,
     /* 2267859 */     GIR_EraseRootFromParent_Done,
     /* 2267860 */   // Label 32369: @2267860
     /* 2267860 */   GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2267903), // Rule ID 58331 //
     /* 2267865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267868 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2267871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2267885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267902 */     // GIR_Coverage, 58331,
     /* 2267902 */     GIR_EraseRootFromParent_Done,
     /* 2267903 */   // Label 32370: @2267903
     /* 2267903 */   GIM_Reject,
     /* 2267904 */ // Label 32368: @2267904
     /* 2267904 */ GIM_Reject,
     /* 2267905 */ // Label 32328: @2267905
     /* 2267905 */ GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2268008),
     /* 2267910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2267913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267921 */   GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2267964), // Rule ID 58340 //
     /* 2267926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2267929 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2267932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267963 */     // GIR_Coverage, 58340,
     /* 2267963 */     GIR_EraseRootFromParent_Done,
     /* 2267964 */   // Label 32372: @2267964
     /* 2267964 */   GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2268007), // Rule ID 58341 //
     /* 2267969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2267972 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2267975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2267989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268006 */     // GIR_Coverage, 58341,
     /* 2268006 */     GIR_EraseRootFromParent_Done,
     /* 2268007 */   // Label 32373: @2268007
     /* 2268007 */   GIM_Reject,
     /* 2268008 */ // Label 32371: @2268008
     /* 2268008 */ GIM_Reject,
     /* 2268009 */ // Label 32329: @2268009
     /* 2268009 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2268112),
     /* 2268014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2268017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268025 */   GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2268068), // Rule ID 58358 //
     /* 2268030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268033 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2268036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268067 */     // GIR_Coverage, 58358,
     /* 2268067 */     GIR_EraseRootFromParent_Done,
     /* 2268068 */   // Label 32375: @2268068
     /* 2268068 */   GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2268111), // Rule ID 58359 //
     /* 2268073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268076 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2268079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268110 */     // GIR_Coverage, 58359,
     /* 2268110 */     GIR_EraseRootFromParent_Done,
     /* 2268111 */   // Label 32376: @2268111
     /* 2268111 */   GIM_Reject,
     /* 2268112 */ // Label 32374: @2268112
     /* 2268112 */ GIM_Reject,
     /* 2268113 */ // Label 32330: @2268113
     /* 2268113 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2268216),
     /* 2268118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2268121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268129 */   GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2268172), // Rule ID 58366 //
     /* 2268134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2268137 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2268140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268171 */     // GIR_Coverage, 58366,
     /* 2268171 */     GIR_EraseRootFromParent_Done,
     /* 2268172 */   // Label 32378: @2268172
     /* 2268172 */   GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2268215), // Rule ID 58367 //
     /* 2268177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2268180 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2268183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268214 */     // GIR_Coverage, 58367,
     /* 2268214 */     GIR_EraseRootFromParent_Done,
     /* 2268215 */   // Label 32379: @2268215
     /* 2268215 */   GIM_Reject,
     /* 2268216 */ // Label 32377: @2268216
     /* 2268216 */ GIM_Reject,
     /* 2268217 */ // Label 32331: @2268217
     /* 2268217 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2268320),
     /* 2268222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2268225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268233 */   GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2268276), // Rule ID 58338 //
     /* 2268238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268241 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2268244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2268258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268275 */     // GIR_Coverage, 58338,
     /* 2268275 */     GIR_EraseRootFromParent_Done,
     /* 2268276 */   // Label 32381: @2268276
     /* 2268276 */   GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2268319), // Rule ID 58339 //
     /* 2268281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268284 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2268287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2268301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268318 */     // GIR_Coverage, 58339,
     /* 2268318 */     GIR_EraseRootFromParent_Done,
     /* 2268319 */   // Label 32382: @2268319
     /* 2268319 */   GIM_Reject,
     /* 2268320 */ // Label 32380: @2268320
     /* 2268320 */ GIM_Reject,
     /* 2268321 */ // Label 32332: @2268321
     /* 2268321 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2268424),
     /* 2268326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2268329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268337 */   GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2268380), // Rule ID 58352 //
     /* 2268342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268345 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2268348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268379 */     // GIR_Coverage, 58352,
     /* 2268379 */     GIR_EraseRootFromParent_Done,
     /* 2268380 */   // Label 32384: @2268380
     /* 2268380 */   GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2268423), // Rule ID 58353 //
     /* 2268385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268388 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2268391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268422 */     // GIR_Coverage, 58353,
     /* 2268422 */     GIR_EraseRootFromParent_Done,
     /* 2268423 */   // Label 32385: @2268423
     /* 2268423 */   GIM_Reject,
     /* 2268424 */ // Label 32383: @2268424
     /* 2268424 */ GIM_Reject,
     /* 2268425 */ // Label 32333: @2268425
     /* 2268425 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2268528),
     /* 2268430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2268433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268441 */   GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2268484), // Rule ID 58360 //
     /* 2268446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268449 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2268452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268483 */     // GIR_Coverage, 58360,
     /* 2268483 */     GIR_EraseRootFromParent_Done,
     /* 2268484 */   // Label 32387: @2268484
     /* 2268484 */   GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2268527), // Rule ID 58361 //
     /* 2268489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268492 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2268495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268526 */     // GIR_Coverage, 58361,
     /* 2268526 */     GIR_EraseRootFromParent_Done,
     /* 2268527 */   // Label 32388: @2268527
     /* 2268527 */   GIM_Reject,
     /* 2268528 */ // Label 32386: @2268528
     /* 2268528 */ GIM_Reject,
     /* 2268529 */ // Label 32334: @2268529
     /* 2268529 */ GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2268632),
     /* 2268534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2268537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268545 */   GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2268588), // Rule ID 58368 //
     /* 2268550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2268553 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2268556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2268570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268587 */     // GIR_Coverage, 58368,
     /* 2268587 */     GIR_EraseRootFromParent_Done,
     /* 2268588 */   // Label 32390: @2268588
     /* 2268588 */   GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2268631), // Rule ID 58369 //
     /* 2268593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2268596 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2268599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2268613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268630 */     // GIR_Coverage, 58369,
     /* 2268630 */     GIR_EraseRootFromParent_Done,
     /* 2268631 */   // Label 32391: @2268631
     /* 2268631 */   GIM_Reject,
     /* 2268632 */ // Label 32389: @2268632
     /* 2268632 */ GIM_Reject,
     /* 2268633 */ // Label 32335: @2268633
     /* 2268633 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2268736),
     /* 2268638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2268641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268649 */   GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2268692), // Rule ID 58346 //
     /* 2268654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268657 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2268660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268691 */     // GIR_Coverage, 58346,
     /* 2268691 */     GIR_EraseRootFromParent_Done,
     /* 2268692 */   // Label 32393: @2268692
     /* 2268692 */   GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2268735), // Rule ID 58347 //
     /* 2268697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268700 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2268703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2268717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268734 */     // GIR_Coverage, 58347,
     /* 2268734 */     GIR_EraseRootFromParent_Done,
     /* 2268735 */   // Label 32394: @2268735
     /* 2268735 */   GIM_Reject,
     /* 2268736 */ // Label 32392: @2268736
     /* 2268736 */ GIM_Reject,
     /* 2268737 */ // Label 32336: @2268737
     /* 2268737 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2268840),
     /* 2268742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2268745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268753 */   GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2268796), // Rule ID 58354 //
     /* 2268758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268761 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2268764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268795 */     // GIR_Coverage, 58354,
     /* 2268795 */     GIR_EraseRootFromParent_Done,
     /* 2268796 */   // Label 32396: @2268796
     /* 2268796 */   GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2268839), // Rule ID 58355 //
     /* 2268801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268804 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2268807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268838 */     // GIR_Coverage, 58355,
     /* 2268838 */     GIR_EraseRootFromParent_Done,
     /* 2268839 */   // Label 32397: @2268839
     /* 2268839 */   GIM_Reject,
     /* 2268840 */ // Label 32395: @2268840
     /* 2268840 */ GIM_Reject,
     /* 2268841 */ // Label 32337: @2268841
     /* 2268841 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2268944),
     /* 2268846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2268849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268857 */   GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2268900), // Rule ID 58362 //
     /* 2268862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268865 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2268868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2268882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268899 */     // GIR_Coverage, 58362,
     /* 2268899 */     GIR_EraseRootFromParent_Done,
     /* 2268900 */   // Label 32399: @2268900
     /* 2268900 */   GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2268943), // Rule ID 58363 //
     /* 2268905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2268908 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2268911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2268925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268942 */     // GIR_Coverage, 58363,
     /* 2268942 */     GIR_EraseRootFromParent_Done,
     /* 2268943 */   // Label 32400: @2268943
     /* 2268943 */   GIM_Reject,
     /* 2268944 */ // Label 32398: @2268944
     /* 2268944 */ GIM_Reject,
     /* 2268945 */ // Label 32338: @2268945
     /* 2268945 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2269048),
     /* 2268950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2268953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268961 */   GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2269004), // Rule ID 58348 //
     /* 2268966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2268969 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2268972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2268986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269003 */     // GIR_Coverage, 58348,
     /* 2269003 */     GIR_EraseRootFromParent_Done,
     /* 2269004 */   // Label 32402: @2269004
     /* 2269004 */   GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2269047), // Rule ID 58349 //
     /* 2269009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2269012 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2269015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2269029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269046 */     // GIR_Coverage, 58349,
     /* 2269046 */     GIR_EraseRootFromParent_Done,
     /* 2269047 */   // Label 32403: @2269047
     /* 2269047 */   GIM_Reject,
     /* 2269048 */ // Label 32401: @2269048
     /* 2269048 */ GIM_Reject,
     /* 2269049 */ // Label 32339: @2269049
     /* 2269049 */ GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2269152),
     /* 2269054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2269057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269065 */   GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2269108), // Rule ID 58356 //
     /* 2269070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2269073 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2269076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2269090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269107 */     // GIR_Coverage, 58356,
     /* 2269107 */     GIR_EraseRootFromParent_Done,
     /* 2269108 */   // Label 32405: @2269108
     /* 2269108 */   GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2269151), // Rule ID 58357 //
     /* 2269113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2269116 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2269119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2269133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269150 */     // GIR_Coverage, 58357,
     /* 2269150 */     GIR_EraseRootFromParent_Done,
     /* 2269151 */   // Label 32406: @2269151
     /* 2269151 */   GIM_Reject,
     /* 2269152 */ // Label 32404: @2269152
     /* 2269152 */ GIM_Reject,
     /* 2269153 */ // Label 32340: @2269153
     /* 2269153 */ GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2269256),
     /* 2269158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2269161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269169 */   GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2269212), // Rule ID 58350 //
     /* 2269174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2269177 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2269180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2269194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269211 */     // GIR_Coverage, 58350,
     /* 2269211 */     GIR_EraseRootFromParent_Done,
     /* 2269212 */   // Label 32408: @2269212
     /* 2269212 */   GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2269255), // Rule ID 58351 //
     /* 2269217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2269220 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2269223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2269237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269254 */     // GIR_Coverage, 58351,
     /* 2269254 */     GIR_EraseRootFromParent_Done,
     /* 2269255 */   // Label 32409: @2269255
     /* 2269255 */   GIM_Reject,
     /* 2269256 */ // Label 32407: @2269256
     /* 2269256 */ GIM_Reject,
     /* 2269257 */ // Label 32341: @2269257
     /* 2269257 */ GIM_Reject,
     /* 2269258 */ // Label 89: @2269258
     /* 2269258 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32413*/ GIMT_Encode4(2269455),
     /* 2269269 */ /*GILLT_s16*//*Label 32410*/ GIMT_Encode4(2269281),
     /* 2269273 */ /*GILLT_s32*//*Label 32411*/ GIMT_Encode4(2269339),
     /* 2269277 */ /*GILLT_s64*//*Label 32412*/ GIMT_Encode4(2269397),
     /* 2269281 */ // Label 32410: @2269281
     /* 2269281 */ GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2269338),
     /* 2269286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2269289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269297 */   GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2269317), // Rule ID 2290 //
     /* 2269302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2269305 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2269305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2269308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269316 */     // GIR_Coverage, 2290,
     /* 2269316 */     GIR_EraseRootFromParent_Done,
     /* 2269317 */   // Label 32415: @2269317
     /* 2269317 */   GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2269337), // Rule ID 2291 //
     /* 2269322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2269325 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2269325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2269328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269336 */     // GIR_Coverage, 2291,
     /* 2269336 */     GIR_EraseRootFromParent_Done,
     /* 2269337 */   // Label 32416: @2269337
     /* 2269337 */   GIM_Reject,
     /* 2269338 */ // Label 32414: @2269338
     /* 2269338 */ GIM_Reject,
     /* 2269339 */ // Label 32411: @2269339
     /* 2269339 */ GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2269396),
     /* 2269344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2269347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269355 */   GIM_Try, /*On fail goto*//*Label 32418*/ GIMT_Encode4(2269375), // Rule ID 2208 //
     /* 2269360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2269363 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2269363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2269366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269374 */     // GIR_Coverage, 2208,
     /* 2269374 */     GIR_EraseRootFromParent_Done,
     /* 2269375 */   // Label 32418: @2269375
     /* 2269375 */   GIM_Try, /*On fail goto*//*Label 32419*/ GIMT_Encode4(2269395), // Rule ID 2209 //
     /* 2269380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2269383 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2269383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2269386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269394 */     // GIR_Coverage, 2209,
     /* 2269394 */     GIR_EraseRootFromParent_Done,
     /* 2269395 */   // Label 32419: @2269395
     /* 2269395 */   GIM_Reject,
     /* 2269396 */ // Label 32417: @2269396
     /* 2269396 */ GIM_Reject,
     /* 2269397 */ // Label 32412: @2269397
     /* 2269397 */ GIM_Try, /*On fail goto*//*Label 32420*/ GIMT_Encode4(2269454),
     /* 2269402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2269405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269413 */   GIM_Try, /*On fail goto*//*Label 32421*/ GIMT_Encode4(2269433), // Rule ID 2248 //
     /* 2269418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2269421 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2269421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2269424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269432 */     // GIR_Coverage, 2248,
     /* 2269432 */     GIR_EraseRootFromParent_Done,
     /* 2269433 */   // Label 32421: @2269433
     /* 2269433 */   GIM_Try, /*On fail goto*//*Label 32422*/ GIMT_Encode4(2269453), // Rule ID 2249 //
     /* 2269438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2269441 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2269441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2269444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269452 */     // GIR_Coverage, 2249,
     /* 2269452 */     GIR_EraseRootFromParent_Done,
     /* 2269453 */   // Label 32422: @2269453
     /* 2269453 */   GIM_Reject,
     /* 2269454 */ // Label 32420: @2269454
     /* 2269454 */ GIM_Reject,
     /* 2269455 */ // Label 32413: @2269455
     /* 2269455 */ GIM_Reject,
     /* 2269456 */ // Label 90: @2269456
     /* 2269456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32441*/ GIMT_Encode4(2271631),
     /* 2269467 */ /*GILLT_s16*//*Label 32423*/ GIMT_Encode4(2269587),
     /* 2269471 */ /*GILLT_s32*//*Label 32424*/ GIMT_Encode4(2269709),
     /* 2269475 */ /*GILLT_s64*//*Label 32425*/ GIMT_Encode4(2269831), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269487 */ /*GILLT_nxv1s16*//*Label 32426*/ GIMT_Encode4(2269981),
     /* 2269491 */ /*GILLT_nxv1s32*//*Label 32427*/ GIMT_Encode4(2270091),
     /* 2269495 */ /*GILLT_nxv1s64*//*Label 32428*/ GIMT_Encode4(2270201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269507 */ /*GILLT_nxv2s16*//*Label 32429*/ GIMT_Encode4(2270311),
     /* 2269511 */ /*GILLT_nxv2s32*//*Label 32430*/ GIMT_Encode4(2270421),
     /* 2269515 */ /*GILLT_nxv2s64*//*Label 32431*/ GIMT_Encode4(2270531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269527 */ /*GILLT_nxv4s16*//*Label 32432*/ GIMT_Encode4(2270641),
     /* 2269531 */ /*GILLT_nxv4s32*//*Label 32433*/ GIMT_Encode4(2270751),
     /* 2269535 */ /*GILLT_nxv4s64*//*Label 32434*/ GIMT_Encode4(2270861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269547 */ /*GILLT_nxv8s16*//*Label 32435*/ GIMT_Encode4(2270971),
     /* 2269551 */ /*GILLT_nxv8s32*//*Label 32436*/ GIMT_Encode4(2271081),
     /* 2269555 */ /*GILLT_nxv8s64*//*Label 32437*/ GIMT_Encode4(2271191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269567 */ /*GILLT_nxv16s16*//*Label 32438*/ GIMT_Encode4(2271301),
     /* 2269571 */ /*GILLT_nxv16s32*//*Label 32439*/ GIMT_Encode4(2271411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269583 */ /*GILLT_nxv32s16*//*Label 32440*/ GIMT_Encode4(2271521),
     /* 2269587 */ // Label 32423: @2269587
     /* 2269587 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2269708),
     /* 2269592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2269595 */   GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2269623), // Rule ID 1848 //
     /* 2269600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2269603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269611 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2269611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2269614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269622 */     // GIR_Coverage, 1848,
     /* 2269622 */     GIR_EraseRootFromParent_Done,
     /* 2269623 */   // Label 32443: @2269623
     /* 2269623 */   GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2269651), // Rule ID 1849 //
     /* 2269628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2269631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2269639 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2269639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2269642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269650 */     // GIR_Coverage, 1849,
     /* 2269650 */     GIR_EraseRootFromParent_Done,
     /* 2269651 */   // Label 32444: @2269651
     /* 2269651 */   GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2269679), // Rule ID 1881 //
     /* 2269656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2269659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2269663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2269667 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2269667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2269670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269678 */     // GIR_Coverage, 1881,
     /* 2269678 */     GIR_EraseRootFromParent_Done,
     /* 2269679 */   // Label 32445: @2269679
     /* 2269679 */   GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2269707), // Rule ID 1882 //
     /* 2269684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2269687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2269691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2269695 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2269695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2269698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269706 */     // GIR_Coverage, 1882,
     /* 2269706 */     GIR_EraseRootFromParent_Done,
     /* 2269707 */   // Label 32446: @2269707
     /* 2269707 */   GIM_Reject,
     /* 2269708 */ // Label 32442: @2269708
     /* 2269708 */ GIM_Reject,
     /* 2269709 */ // Label 32424: @2269709
     /* 2269709 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2269830),
     /* 2269714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2269717 */   GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2269745), // Rule ID 1139 //
     /* 2269722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2269725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269733 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2269733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2269736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269744 */     // GIR_Coverage, 1139,
     /* 2269744 */     GIR_EraseRootFromParent_Done,
     /* 2269745 */   // Label 32448: @2269745
     /* 2269745 */   GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2269773), // Rule ID 1140 //
     /* 2269750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2269753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269761 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2269761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2269764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269772 */     // GIR_Coverage, 1140,
     /* 2269772 */     GIR_EraseRootFromParent_Done,
     /* 2269773 */   // Label 32449: @2269773
     /* 2269773 */   GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2269801), // Rule ID 1147 //
     /* 2269778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2269781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2269785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2269789 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2269789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2269792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269800 */     // GIR_Coverage, 1147,
     /* 2269800 */     GIR_EraseRootFromParent_Done,
     /* 2269801 */   // Label 32450: @2269801
     /* 2269801 */   GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2269829), // Rule ID 1148 //
     /* 2269806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2269809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2269813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2269817 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2269817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2269820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269828 */     // GIR_Coverage, 1148,
     /* 2269828 */     GIR_EraseRootFromParent_Done,
     /* 2269829 */   // Label 32451: @2269829
     /* 2269829 */   GIM_Reject,
     /* 2269830 */ // Label 32447: @2269830
     /* 2269830 */ GIM_Reject,
     /* 2269831 */ // Label 32425: @2269831
     /* 2269831 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2269980),
     /* 2269836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2269839 */   GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2269867), // Rule ID 1482 //
     /* 2269844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2269847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269855 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2269855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2269858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269866 */     // GIR_Coverage, 1482,
     /* 2269866 */     GIR_EraseRootFromParent_Done,
     /* 2269867 */   // Label 32453: @2269867
     /* 2269867 */   GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2269895), // Rule ID 1483 //
     /* 2269872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2269875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2269883 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2269883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2269886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269894 */     // GIR_Coverage, 1483,
     /* 2269894 */     GIR_EraseRootFromParent_Done,
     /* 2269895 */   // Label 32454: @2269895
     /* 2269895 */   GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2269923), // Rule ID 1516 //
     /* 2269900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2269903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2269907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2269911 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2269911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2269914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269922 */     // GIR_Coverage, 1516,
     /* 2269922 */     GIR_EraseRootFromParent_Done,
     /* 2269923 */   // Label 32455: @2269923
     /* 2269923 */   GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2269951), // Rule ID 1537 //
     /* 2269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2269931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2269935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2269939 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2269939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2269942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269950 */     // GIR_Coverage, 1537,
     /* 2269950 */     GIR_EraseRootFromParent_Done,
     /* 2269951 */   // Label 32456: @2269951
     /* 2269951 */   GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2269979), // Rule ID 1538 //
     /* 2269956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2269959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2269963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2269967 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2269967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2269970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2269977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269978 */     // GIR_Coverage, 1538,
     /* 2269978 */     GIR_EraseRootFromParent_Done,
     /* 2269979 */   // Label 32457: @2269979
     /* 2269979 */   GIM_Reject,
     /* 2269980 */ // Label 32452: @2269980
     /* 2269980 */ GIM_Reject,
     /* 2269981 */ // Label 32426: @2269981
     /* 2269981 */ GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2270090),
     /* 2269986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2269989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269997 */   GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2270043), // Rule ID 55692 //
     /* 2270002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270005 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2270008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2270022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270042 */     // GIR_Coverage, 55692,
     /* 2270042 */     GIR_EraseRootFromParent_Done,
     /* 2270043 */   // Label 32459: @2270043
     /* 2270043 */   GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2270089), // Rule ID 55693 //
     /* 2270048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270051 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2270054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2270068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270088 */     // GIR_Coverage, 55693,
     /* 2270088 */     GIR_EraseRootFromParent_Done,
     /* 2270089 */   // Label 32460: @2270089
     /* 2270089 */   GIM_Reject,
     /* 2270090 */ // Label 32458: @2270090
     /* 2270090 */ GIM_Reject,
     /* 2270091 */ // Label 32427: @2270091
     /* 2270091 */ GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2270200),
     /* 2270096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2270099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270107 */   GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2270153), // Rule ID 55732 //
     /* 2270112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270115 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2270118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2270132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270152 */     // GIR_Coverage, 55732,
     /* 2270152 */     GIR_EraseRootFromParent_Done,
     /* 2270153 */   // Label 32462: @2270153
     /* 2270153 */   GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2270199), // Rule ID 55733 //
     /* 2270158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270161 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2270164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2270178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270198 */     // GIR_Coverage, 55733,
     /* 2270198 */     GIR_EraseRootFromParent_Done,
     /* 2270199 */   // Label 32463: @2270199
     /* 2270199 */   GIM_Reject,
     /* 2270200 */ // Label 32461: @2270200
     /* 2270200 */ GIM_Reject,
     /* 2270201 */ // Label 32428: @2270201
     /* 2270201 */ GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2270310),
     /* 2270206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2270209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270217 */   GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2270263), // Rule ID 55792 //
     /* 2270222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270225 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2270228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2270242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270262 */     // GIR_Coverage, 55792,
     /* 2270262 */     GIR_EraseRootFromParent_Done,
     /* 2270263 */   // Label 32465: @2270263
     /* 2270263 */   GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2270309), // Rule ID 55793 //
     /* 2270268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270271 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2270274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2270288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270308 */     // GIR_Coverage, 55793,
     /* 2270308 */     GIR_EraseRootFromParent_Done,
     /* 2270309 */   // Label 32466: @2270309
     /* 2270309 */   GIM_Reject,
     /* 2270310 */ // Label 32464: @2270310
     /* 2270310 */ GIM_Reject,
     /* 2270311 */ // Label 32429: @2270311
     /* 2270311 */ GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2270420),
     /* 2270316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2270319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270327 */   GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2270373), // Rule ID 55712 //
     /* 2270332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270335 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2270338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2270352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270372 */     // GIR_Coverage, 55712,
     /* 2270372 */     GIR_EraseRootFromParent_Done,
     /* 2270373 */   // Label 32468: @2270373
     /* 2270373 */   GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2270419), // Rule ID 55713 //
     /* 2270378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270381 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2270384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2270398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270418 */     // GIR_Coverage, 55713,
     /* 2270418 */     GIR_EraseRootFromParent_Done,
     /* 2270419 */   // Label 32469: @2270419
     /* 2270419 */   GIM_Reject,
     /* 2270420 */ // Label 32467: @2270420
     /* 2270420 */ GIM_Reject,
     /* 2270421 */ // Label 32430: @2270421
     /* 2270421 */ GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2270530),
     /* 2270426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2270429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270437 */   GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2270483), // Rule ID 55772 //
     /* 2270442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270445 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2270448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2270462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270482 */     // GIR_Coverage, 55772,
     /* 2270482 */     GIR_EraseRootFromParent_Done,
     /* 2270483 */   // Label 32471: @2270483
     /* 2270483 */   GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2270529), // Rule ID 55773 //
     /* 2270488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270491 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2270494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2270508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270528 */     // GIR_Coverage, 55773,
     /* 2270528 */     GIR_EraseRootFromParent_Done,
     /* 2270529 */   // Label 32472: @2270529
     /* 2270529 */   GIM_Reject,
     /* 2270530 */ // Label 32470: @2270530
     /* 2270530 */ GIM_Reject,
     /* 2270531 */ // Label 32431: @2270531
     /* 2270531 */ GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2270640),
     /* 2270536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2270539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270547 */   GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2270593), // Rule ID 55932 //
     /* 2270552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270555 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2270558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2270572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270592 */     // GIR_Coverage, 55932,
     /* 2270592 */     GIR_EraseRootFromParent_Done,
     /* 2270593 */   // Label 32474: @2270593
     /* 2270593 */   GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2270639), // Rule ID 55933 //
     /* 2270598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270601 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2270604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2270618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270638 */     // GIR_Coverage, 55933,
     /* 2270638 */     GIR_EraseRootFromParent_Done,
     /* 2270639 */   // Label 32475: @2270639
     /* 2270639 */   GIM_Reject,
     /* 2270640 */ // Label 32473: @2270640
     /* 2270640 */ GIM_Reject,
     /* 2270641 */ // Label 32432: @2270641
     /* 2270641 */ GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2270750),
     /* 2270646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2270649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270657 */   GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2270703), // Rule ID 55752 //
     /* 2270662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270665 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2270668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2270682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270702 */     // GIR_Coverage, 55752,
     /* 2270702 */     GIR_EraseRootFromParent_Done,
     /* 2270703 */   // Label 32477: @2270703
     /* 2270703 */   GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2270749), // Rule ID 55753 //
     /* 2270708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270711 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2270714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2270728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270748 */     // GIR_Coverage, 55753,
     /* 2270748 */     GIR_EraseRootFromParent_Done,
     /* 2270749 */   // Label 32478: @2270749
     /* 2270749 */   GIM_Reject,
     /* 2270750 */ // Label 32476: @2270750
     /* 2270750 */ GIM_Reject,
     /* 2270751 */ // Label 32433: @2270751
     /* 2270751 */ GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2270860),
     /* 2270756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2270759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270767 */   GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2270813), // Rule ID 55872 //
     /* 2270772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270775 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2270778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2270792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270812 */     // GIR_Coverage, 55872,
     /* 2270812 */     GIR_EraseRootFromParent_Done,
     /* 2270813 */   // Label 32480: @2270813
     /* 2270813 */   GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2270859), // Rule ID 55873 //
     /* 2270818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270821 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2270824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2270838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270858 */     // GIR_Coverage, 55873,
     /* 2270858 */     GIR_EraseRootFromParent_Done,
     /* 2270859 */   // Label 32481: @2270859
     /* 2270859 */   GIM_Reject,
     /* 2270860 */ // Label 32479: @2270860
     /* 2270860 */ GIM_Reject,
     /* 2270861 */ // Label 32434: @2270861
     /* 2270861 */ GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2270970),
     /* 2270866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2270869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270877 */   GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2270923), // Rule ID 55952 //
     /* 2270882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270885 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2270888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2270902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270922 */     // GIR_Coverage, 55952,
     /* 2270922 */     GIR_EraseRootFromParent_Done,
     /* 2270923 */   // Label 32483: @2270923
     /* 2270923 */   GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2270969), // Rule ID 55953 //
     /* 2270928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270931 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2270934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2270948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2270955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2270958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270968 */     // GIR_Coverage, 55953,
     /* 2270968 */     GIR_EraseRootFromParent_Done,
     /* 2270969 */   // Label 32484: @2270969
     /* 2270969 */   GIM_Reject,
     /* 2270970 */ // Label 32482: @2270970
     /* 2270970 */ GIM_Reject,
     /* 2270971 */ // Label 32435: @2270971
     /* 2270971 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2271080),
     /* 2270976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2270979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270987 */   GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2271033), // Rule ID 55812 //
     /* 2270992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270995 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2270998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2271012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271032 */     // GIR_Coverage, 55812,
     /* 2271032 */     GIR_EraseRootFromParent_Done,
     /* 2271033 */   // Label 32486: @2271033
     /* 2271033 */   GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2271079), // Rule ID 55813 //
     /* 2271038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271041 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2271044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2271058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271078 */     // GIR_Coverage, 55813,
     /* 2271078 */     GIR_EraseRootFromParent_Done,
     /* 2271079 */   // Label 32487: @2271079
     /* 2271079 */   GIM_Reject,
     /* 2271080 */ // Label 32485: @2271080
     /* 2271080 */ GIM_Reject,
     /* 2271081 */ // Label 32436: @2271081
     /* 2271081 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2271190),
     /* 2271086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2271089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271097 */   GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2271143), // Rule ID 55892 //
     /* 2271102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271105 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2271108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2271122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271142 */     // GIR_Coverage, 55892,
     /* 2271142 */     GIR_EraseRootFromParent_Done,
     /* 2271143 */   // Label 32489: @2271143
     /* 2271143 */   GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2271189), // Rule ID 55893 //
     /* 2271148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271151 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2271154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2271168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271188 */     // GIR_Coverage, 55893,
     /* 2271188 */     GIR_EraseRootFromParent_Done,
     /* 2271189 */   // Label 32490: @2271189
     /* 2271189 */   GIM_Reject,
     /* 2271190 */ // Label 32488: @2271190
     /* 2271190 */ GIM_Reject,
     /* 2271191 */ // Label 32437: @2271191
     /* 2271191 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2271300),
     /* 2271196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2271199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271207 */   GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2271253), // Rule ID 55972 //
     /* 2271212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271215 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2271218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2271232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271252 */     // GIR_Coverage, 55972,
     /* 2271252 */     GIR_EraseRootFromParent_Done,
     /* 2271253 */   // Label 32492: @2271253
     /* 2271253 */   GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2271299), // Rule ID 55973 //
     /* 2271258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271261 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2271264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2271278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271298 */     // GIR_Coverage, 55973,
     /* 2271298 */     GIR_EraseRootFromParent_Done,
     /* 2271299 */   // Label 32493: @2271299
     /* 2271299 */   GIM_Reject,
     /* 2271300 */ // Label 32491: @2271300
     /* 2271300 */ GIM_Reject,
     /* 2271301 */ // Label 32438: @2271301
     /* 2271301 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2271410),
     /* 2271306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2271309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271317 */   GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2271363), // Rule ID 55832 //
     /* 2271322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271325 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2271328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2271342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271362 */     // GIR_Coverage, 55832,
     /* 2271362 */     GIR_EraseRootFromParent_Done,
     /* 2271363 */   // Label 32495: @2271363
     /* 2271363 */   GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2271409), // Rule ID 55833 //
     /* 2271368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271371 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2271374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2271388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271408 */     // GIR_Coverage, 55833,
     /* 2271408 */     GIR_EraseRootFromParent_Done,
     /* 2271409 */   // Label 32496: @2271409
     /* 2271409 */   GIM_Reject,
     /* 2271410 */ // Label 32494: @2271410
     /* 2271410 */ GIM_Reject,
     /* 2271411 */ // Label 32439: @2271411
     /* 2271411 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2271520),
     /* 2271416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2271419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271427 */   GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2271473), // Rule ID 55912 //
     /* 2271432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271435 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2271438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2271452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271472 */     // GIR_Coverage, 55912,
     /* 2271472 */     GIR_EraseRootFromParent_Done,
     /* 2271473 */   // Label 32498: @2271473
     /* 2271473 */   GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2271519), // Rule ID 55913 //
     /* 2271478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271481 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2271484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2271498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271518 */     // GIR_Coverage, 55913,
     /* 2271518 */     GIR_EraseRootFromParent_Done,
     /* 2271519 */   // Label 32499: @2271519
     /* 2271519 */   GIM_Reject,
     /* 2271520 */ // Label 32497: @2271520
     /* 2271520 */ GIM_Reject,
     /* 2271521 */ // Label 32440: @2271521
     /* 2271521 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2271630),
     /* 2271526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2271529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271537 */   GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2271583), // Rule ID 55852 //
     /* 2271542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271545 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2271548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2271562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271582 */     // GIR_Coverage, 55852,
     /* 2271582 */     GIR_EraseRootFromParent_Done,
     /* 2271583 */   // Label 32501: @2271583
     /* 2271583 */   GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2271629), // Rule ID 55853 //
     /* 2271588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271591 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2271594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2271608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2271615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271628 */     // GIR_Coverage, 55853,
     /* 2271628 */     GIR_EraseRootFromParent_Done,
     /* 2271629 */   // Label 32502: @2271629
     /* 2271629 */   GIM_Reject,
     /* 2271630 */ // Label 32500: @2271630
     /* 2271630 */ GIM_Reject,
     /* 2271631 */ // Label 32441: @2271631
     /* 2271631 */ GIM_Reject,
     /* 2271632 */ // Label 91: @2271632
     /* 2271632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32506*/ GIMT_Encode4(2271829),
     /* 2271643 */ /*GILLT_s16*//*Label 32503*/ GIMT_Encode4(2271655),
     /* 2271647 */ /*GILLT_s32*//*Label 32504*/ GIMT_Encode4(2271713),
     /* 2271651 */ /*GILLT_s64*//*Label 32505*/ GIMT_Encode4(2271771),
     /* 2271655 */ // Label 32503: @2271655
     /* 2271655 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2271712),
     /* 2271660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2271663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271671 */   GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2271691), // Rule ID 2286 //
     /* 2271676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2271679 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2271679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2271682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271690 */     // GIR_Coverage, 2286,
     /* 2271690 */     GIR_EraseRootFromParent_Done,
     /* 2271691 */   // Label 32508: @2271691
     /* 2271691 */   GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2271711), // Rule ID 2287 //
     /* 2271696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2271699 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2271699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2271702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271710 */     // GIR_Coverage, 2287,
     /* 2271710 */     GIR_EraseRootFromParent_Done,
     /* 2271711 */   // Label 32509: @2271711
     /* 2271711 */   GIM_Reject,
     /* 2271712 */ // Label 32507: @2271712
     /* 2271712 */ GIM_Reject,
     /* 2271713 */ // Label 32504: @2271713
     /* 2271713 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2271770),
     /* 2271718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2271721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2271725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2271729 */   GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2271749), // Rule ID 2204 //
     /* 2271734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2271737 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2271737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2271740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271748 */     // GIR_Coverage, 2204,
     /* 2271748 */     GIR_EraseRootFromParent_Done,
     /* 2271749 */   // Label 32511: @2271749
     /* 2271749 */   GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2271769), // Rule ID 2205 //
     /* 2271754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2271757 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2271757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2271760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271768 */     // GIR_Coverage, 2205,
     /* 2271768 */     GIR_EraseRootFromParent_Done,
     /* 2271769 */   // Label 32512: @2271769
     /* 2271769 */   GIM_Reject,
     /* 2271770 */ // Label 32510: @2271770
     /* 2271770 */ GIM_Reject,
     /* 2271771 */ // Label 32505: @2271771
     /* 2271771 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2271828),
     /* 2271776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2271779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271787 */   GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2271807), // Rule ID 2244 //
     /* 2271792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2271795 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2271795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2271798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271806 */     // GIR_Coverage, 2244,
     /* 2271806 */     GIR_EraseRootFromParent_Done,
     /* 2271807 */   // Label 32514: @2271807
     /* 2271807 */   GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2271827), // Rule ID 2245 //
     /* 2271812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2271815 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2271815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2271818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2271825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271826 */     // GIR_Coverage, 2245,
     /* 2271826 */     GIR_EraseRootFromParent_Done,
     /* 2271827 */   // Label 32515: @2271827
     /* 2271827 */   GIM_Reject,
     /* 2271828 */ // Label 32513: @2271828
     /* 2271828 */ GIM_Reject,
     /* 2271829 */ // Label 32506: @2271829
     /* 2271829 */ GIM_Reject,
     /* 2271830 */ // Label 92: @2271830
     /* 2271830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32519*/ GIMT_Encode4(2272027),
     /* 2271841 */ /*GILLT_s16*//*Label 32516*/ GIMT_Encode4(2271853),
     /* 2271845 */ /*GILLT_s32*//*Label 32517*/ GIMT_Encode4(2271911),
     /* 2271849 */ /*GILLT_s64*//*Label 32518*/ GIMT_Encode4(2271969),
     /* 2271853 */ // Label 32516: @2271853
     /* 2271853 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2271910),
     /* 2271858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2271861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271869 */   GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2271889), // Rule ID 2270 //
     /* 2271874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2271877 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2271877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2271880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271888 */     // GIR_Coverage, 2270,
     /* 2271888 */     GIR_EraseRootFromParent_Done,
     /* 2271889 */   // Label 32521: @2271889
     /* 2271889 */   GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2271909), // Rule ID 2271 //
     /* 2271894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2271897 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2271897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2271900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271908 */     // GIR_Coverage, 2271,
     /* 2271908 */     GIR_EraseRootFromParent_Done,
     /* 2271909 */   // Label 32522: @2271909
     /* 2271909 */   GIM_Reject,
     /* 2271910 */ // Label 32520: @2271910
     /* 2271910 */ GIM_Reject,
     /* 2271911 */ // Label 32517: @2271911
     /* 2271911 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2271968),
     /* 2271916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2271919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2271923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2271927 */   GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2271947), // Rule ID 2188 //
     /* 2271932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2271935 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2271935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2271938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271946 */     // GIR_Coverage, 2188,
     /* 2271946 */     GIR_EraseRootFromParent_Done,
     /* 2271947 */   // Label 32524: @2271947
     /* 2271947 */   GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2271967), // Rule ID 2189 //
     /* 2271952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2271955 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2271955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2271958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2271965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271966 */     // GIR_Coverage, 2189,
     /* 2271966 */     GIR_EraseRootFromParent_Done,
     /* 2271967 */   // Label 32525: @2271967
     /* 2271967 */   GIM_Reject,
     /* 2271968 */ // Label 32523: @2271968
     /* 2271968 */ GIM_Reject,
     /* 2271969 */ // Label 32518: @2271969
     /* 2271969 */ GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2272026),
     /* 2271974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2271977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271985 */   GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2272005), // Rule ID 2228 //
     /* 2271990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2271993 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2271993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2271996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272004 */     // GIR_Coverage, 2228,
     /* 2272004 */     GIR_EraseRootFromParent_Done,
     /* 2272005 */   // Label 32527: @2272005
     /* 2272005 */   GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2272025), // Rule ID 2229 //
     /* 2272010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2272013 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2272013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2272016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272024 */     // GIR_Coverage, 2229,
     /* 2272024 */     GIR_EraseRootFromParent_Done,
     /* 2272025 */   // Label 32528: @2272025
     /* 2272025 */   GIM_Reject,
     /* 2272026 */ // Label 32526: @2272026
     /* 2272026 */ GIM_Reject,
     /* 2272027 */ // Label 32519: @2272027
     /* 2272027 */ GIM_Reject,
     /* 2272028 */ // Label 93: @2272028
     /* 2272028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32532*/ GIMT_Encode4(2272225),
     /* 2272039 */ /*GILLT_s16*//*Label 32529*/ GIMT_Encode4(2272051),
     /* 2272043 */ /*GILLT_s32*//*Label 32530*/ GIMT_Encode4(2272109),
     /* 2272047 */ /*GILLT_s64*//*Label 32531*/ GIMT_Encode4(2272167),
     /* 2272051 */ // Label 32529: @2272051
     /* 2272051 */ GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2272108),
     /* 2272056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2272059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272067 */   GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2272087), // Rule ID 2274 //
     /* 2272072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2272075 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2272075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2272078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272086 */     // GIR_Coverage, 2274,
     /* 2272086 */     GIR_EraseRootFromParent_Done,
     /* 2272087 */   // Label 32534: @2272087
     /* 2272087 */   GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2272107), // Rule ID 2275 //
     /* 2272092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2272095 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2272095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2272098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272106 */     // GIR_Coverage, 2275,
     /* 2272106 */     GIR_EraseRootFromParent_Done,
     /* 2272107 */   // Label 32535: @2272107
     /* 2272107 */   GIM_Reject,
     /* 2272108 */ // Label 32533: @2272108
     /* 2272108 */ GIM_Reject,
     /* 2272109 */ // Label 32530: @2272109
     /* 2272109 */ GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2272166),
     /* 2272114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2272117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272125 */   GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2272145), // Rule ID 2192 //
     /* 2272130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2272133 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2272133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2272136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272144 */     // GIR_Coverage, 2192,
     /* 2272144 */     GIR_EraseRootFromParent_Done,
     /* 2272145 */   // Label 32537: @2272145
     /* 2272145 */   GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2272165), // Rule ID 2193 //
     /* 2272150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2272153 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2272153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2272156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272164 */     // GIR_Coverage, 2193,
     /* 2272164 */     GIR_EraseRootFromParent_Done,
     /* 2272165 */   // Label 32538: @2272165
     /* 2272165 */   GIM_Reject,
     /* 2272166 */ // Label 32536: @2272166
     /* 2272166 */ GIM_Reject,
     /* 2272167 */ // Label 32531: @2272167
     /* 2272167 */ GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2272224),
     /* 2272172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2272175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272183 */   GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2272203), // Rule ID 2232 //
     /* 2272188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2272191 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2272191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2272194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272202 */     // GIR_Coverage, 2232,
     /* 2272202 */     GIR_EraseRootFromParent_Done,
     /* 2272203 */   // Label 32540: @2272203
     /* 2272203 */   GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2272223), // Rule ID 2233 //
     /* 2272208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2272211 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2272211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2272214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272222 */     // GIR_Coverage, 2233,
     /* 2272222 */     GIR_EraseRootFromParent_Done,
     /* 2272223 */   // Label 32541: @2272223
     /* 2272223 */   GIM_Reject,
     /* 2272224 */ // Label 32539: @2272224
     /* 2272224 */ GIM_Reject,
     /* 2272225 */ // Label 32532: @2272225
     /* 2272225 */ GIM_Reject,
     /* 2272226 */ // Label 94: @2272226
     /* 2272226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32560*/ GIMT_Encode4(2274653),
     /* 2272237 */ /*GILLT_s16*//*Label 32542*/ GIMT_Encode4(2272357),
     /* 2272241 */ /*GILLT_s32*//*Label 32543*/ GIMT_Encode4(2272506),
     /* 2272245 */ /*GILLT_s64*//*Label 32544*/ GIMT_Encode4(2272655), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272257 */ /*GILLT_nxv1s16*//*Label 32545*/ GIMT_Encode4(2272838),
     /* 2272261 */ /*GILLT_nxv1s32*//*Label 32546*/ GIMT_Encode4(2272959),
     /* 2272265 */ /*GILLT_nxv1s64*//*Label 32547*/ GIMT_Encode4(2273080), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272277 */ /*GILLT_nxv2s16*//*Label 32548*/ GIMT_Encode4(2273201),
     /* 2272281 */ /*GILLT_nxv2s32*//*Label 32549*/ GIMT_Encode4(2273322),
     /* 2272285 */ /*GILLT_nxv2s64*//*Label 32550*/ GIMT_Encode4(2273443), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272297 */ /*GILLT_nxv4s16*//*Label 32551*/ GIMT_Encode4(2273564),
     /* 2272301 */ /*GILLT_nxv4s32*//*Label 32552*/ GIMT_Encode4(2273685),
     /* 2272305 */ /*GILLT_nxv4s64*//*Label 32553*/ GIMT_Encode4(2273806), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272317 */ /*GILLT_nxv8s16*//*Label 32554*/ GIMT_Encode4(2273927),
     /* 2272321 */ /*GILLT_nxv8s32*//*Label 32555*/ GIMT_Encode4(2274048),
     /* 2272325 */ /*GILLT_nxv8s64*//*Label 32556*/ GIMT_Encode4(2274169), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272337 */ /*GILLT_nxv16s16*//*Label 32557*/ GIMT_Encode4(2274290),
     /* 2272341 */ /*GILLT_nxv16s32*//*Label 32558*/ GIMT_Encode4(2274411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272353 */ /*GILLT_nxv32s16*//*Label 32559*/ GIMT_Encode4(2274532),
     /* 2272357 */ // Label 32542: @2272357
     /* 2272357 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2272505),
     /* 2272362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2272365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2272368 */   GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2272402), // Rule ID 1814 //
     /* 2272373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2272376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272388 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2272388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2272391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272401 */     // GIR_Coverage, 1814,
     /* 2272401 */     GIR_EraseRootFromParent_Done,
     /* 2272402 */   // Label 32562: @2272402
     /* 2272402 */   GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2272436), // Rule ID 1815 //
     /* 2272407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2272410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2272422 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2272422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2272425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272435 */     // GIR_Coverage, 1815,
     /* 2272435 */     GIR_EraseRootFromParent_Done,
     /* 2272436 */   // Label 32563: @2272436
     /* 2272436 */   GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2272470), // Rule ID 1818 //
     /* 2272441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2272444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272456 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2272456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2272459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272469 */     // GIR_Coverage, 1818,
     /* 2272469 */     GIR_EraseRootFromParent_Done,
     /* 2272470 */   // Label 32564: @2272470
     /* 2272470 */   GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2272504), // Rule ID 1819 //
     /* 2272475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2272478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2272490 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2272490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2272493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272503 */     // GIR_Coverage, 1819,
     /* 2272503 */     GIR_EraseRootFromParent_Done,
     /* 2272504 */   // Label 32565: @2272504
     /* 2272504 */   GIM_Reject,
     /* 2272505 */ // Label 32561: @2272505
     /* 2272505 */ GIM_Reject,
     /* 2272506 */ // Label 32543: @2272506
     /* 2272506 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2272654),
     /* 2272511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2272514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2272517 */   GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2272551), // Rule ID 1105 //
     /* 2272522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2272525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272537 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2272537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2272540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272550 */     // GIR_Coverage, 1105,
     /* 2272550 */     GIR_EraseRootFromParent_Done,
     /* 2272551 */   // Label 32567: @2272551
     /* 2272551 */   GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2272585), // Rule ID 1106 //
     /* 2272556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2272559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2272571 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2272571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2272574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272584 */     // GIR_Coverage, 1106,
     /* 2272584 */     GIR_EraseRootFromParent_Done,
     /* 2272585 */   // Label 32568: @2272585
     /* 2272585 */   GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2272619), // Rule ID 1109 //
     /* 2272590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2272593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272605 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2272605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2272608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272618 */     // GIR_Coverage, 1109,
     /* 2272618 */     GIR_EraseRootFromParent_Done,
     /* 2272619 */   // Label 32569: @2272619
     /* 2272619 */   GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2272653), // Rule ID 1110 //
     /* 2272624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2272627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2272639 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2272639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2272642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272652 */     // GIR_Coverage, 1110,
     /* 2272652 */     GIR_EraseRootFromParent_Done,
     /* 2272653 */   // Label 32570: @2272653
     /* 2272653 */   GIM_Reject,
     /* 2272654 */ // Label 32566: @2272654
     /* 2272654 */ GIM_Reject,
     /* 2272655 */ // Label 32544: @2272655
     /* 2272655 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2272837),
     /* 2272660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2272663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2272666 */   GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2272700), // Rule ID 1440 //
     /* 2272671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2272674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272686 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2272686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2272689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272699 */     // GIR_Coverage, 1440,
     /* 2272699 */     GIR_EraseRootFromParent_Done,
     /* 2272700 */   // Label 32572: @2272700
     /* 2272700 */   GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2272734), // Rule ID 1441 //
     /* 2272705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2272708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2272720 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2272720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2272723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272733 */     // GIR_Coverage, 1441,
     /* 2272733 */     GIR_EraseRootFromParent_Done,
     /* 2272734 */   // Label 32573: @2272734
     /* 2272734 */   GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2272768), // Rule ID 1444 //
     /* 2272739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2272742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272754 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2272754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2272757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272767 */     // GIR_Coverage, 1444,
     /* 2272767 */     GIR_EraseRootFromParent_Done,
     /* 2272768 */   // Label 32574: @2272768
     /* 2272768 */   GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2272802), // Rule ID 1445 //
     /* 2272773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2272776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2272788 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2272788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2272791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272801 */     // GIR_Coverage, 1445,
     /* 2272801 */     GIR_EraseRootFromParent_Done,
     /* 2272802 */   // Label 32575: @2272802
     /* 2272802 */   GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2272836), // Rule ID 1448 //
     /* 2272807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2272810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2272814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2272818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2272822 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2272822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2272825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272835 */     // GIR_Coverage, 1448,
     /* 2272835 */     GIR_EraseRootFromParent_Done,
     /* 2272836 */   // Label 32576: @2272836
     /* 2272836 */   GIM_Reject,
     /* 2272837 */ // Label 32571: @2272837
     /* 2272837 */ GIM_Reject,
     /* 2272838 */ // Label 32545: @2272838
     /* 2272838 */ GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2272958),
     /* 2272843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2272846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272861 */   GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2272909), // Rule ID 45440 //
     /* 2272866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272869 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2272872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2272886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272908 */     // GIR_Coverage, 45440,
     /* 2272908 */     GIR_EraseRootFromParent_Done,
     /* 2272909 */   // Label 32578: @2272909
     /* 2272909 */   GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2272957), // Rule ID 45441 //
     /* 2272914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272917 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2272920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2272934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2272946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272956 */     // GIR_Coverage, 45441,
     /* 2272956 */     GIR_EraseRootFromParent_Done,
     /* 2272957 */   // Label 32579: @2272957
     /* 2272957 */   GIM_Reject,
     /* 2272958 */ // Label 32577: @2272958
     /* 2272958 */ GIM_Reject,
     /* 2272959 */ // Label 32546: @2272959
     /* 2272959 */ GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2273079),
     /* 2272964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2272967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272982 */   GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2273030), // Rule ID 52752 //
     /* 2272987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272990 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2272993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2273007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273029 */     // GIR_Coverage, 52752,
     /* 2273029 */     GIR_EraseRootFromParent_Done,
     /* 2273030 */   // Label 32581: @2273030
     /* 2273030 */   GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2273078), // Rule ID 52753 //
     /* 2273035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273038 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2273041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2273055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273077 */     // GIR_Coverage, 52753,
     /* 2273077 */     GIR_EraseRootFromParent_Done,
     /* 2273078 */   // Label 32582: @2273078
     /* 2273078 */   GIM_Reject,
     /* 2273079 */ // Label 32580: @2273079
     /* 2273079 */ GIM_Reject,
     /* 2273080 */ // Label 32547: @2273080
     /* 2273080 */ GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2273200),
     /* 2273085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2273088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2273091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273103 */   GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2273151), // Rule ID 52788 //
     /* 2273108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273111 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2273114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2273128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273150 */     // GIR_Coverage, 52788,
     /* 2273150 */     GIR_EraseRootFromParent_Done,
     /* 2273151 */   // Label 32584: @2273151
     /* 2273151 */   GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2273199), // Rule ID 52789 //
     /* 2273156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273159 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2273162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2273176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273198 */     // GIR_Coverage, 52789,
     /* 2273198 */     GIR_EraseRootFromParent_Done,
     /* 2273199 */   // Label 32585: @2273199
     /* 2273199 */   GIM_Reject,
     /* 2273200 */ // Label 32583: @2273200
     /* 2273200 */ GIM_Reject,
     /* 2273201 */ // Label 32548: @2273201
     /* 2273201 */ GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2273321),
     /* 2273206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2273209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273224 */   GIM_Try, /*On fail goto*//*Label 32587*/ GIMT_Encode4(2273272), // Rule ID 52740 //
     /* 2273229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273232 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2273235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2273249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273271 */     // GIR_Coverage, 52740,
     /* 2273271 */     GIR_EraseRootFromParent_Done,
     /* 2273272 */   // Label 32587: @2273272
     /* 2273272 */   GIM_Try, /*On fail goto*//*Label 32588*/ GIMT_Encode4(2273320), // Rule ID 52741 //
     /* 2273277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273280 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2273283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2273297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273319 */     // GIR_Coverage, 52741,
     /* 2273319 */     GIR_EraseRootFromParent_Done,
     /* 2273320 */   // Label 32588: @2273320
     /* 2273320 */   GIM_Reject,
     /* 2273321 */ // Label 32586: @2273321
     /* 2273321 */ GIM_Reject,
     /* 2273322 */ // Label 32549: @2273322
     /* 2273322 */ GIM_Try, /*On fail goto*//*Label 32589*/ GIMT_Encode4(2273442),
     /* 2273327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2273330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273345 */   GIM_Try, /*On fail goto*//*Label 32590*/ GIMT_Encode4(2273393), // Rule ID 52776 //
     /* 2273350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273353 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2273356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2273370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273392 */     // GIR_Coverage, 52776,
     /* 2273392 */     GIR_EraseRootFromParent_Done,
     /* 2273393 */   // Label 32590: @2273393
     /* 2273393 */   GIM_Try, /*On fail goto*//*Label 32591*/ GIMT_Encode4(2273441), // Rule ID 52777 //
     /* 2273398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273401 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2273404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2273418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273440 */     // GIR_Coverage, 52777,
     /* 2273440 */     GIR_EraseRootFromParent_Done,
     /* 2273441 */   // Label 32591: @2273441
     /* 2273441 */   GIM_Reject,
     /* 2273442 */ // Label 32589: @2273442
     /* 2273442 */ GIM_Reject,
     /* 2273443 */ // Label 32550: @2273443
     /* 2273443 */ GIM_Try, /*On fail goto*//*Label 32592*/ GIMT_Encode4(2273563),
     /* 2273448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2273451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273466 */   GIM_Try, /*On fail goto*//*Label 32593*/ GIMT_Encode4(2273514), // Rule ID 52872 //
     /* 2273471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273474 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2273477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2273491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273513 */     // GIR_Coverage, 52872,
     /* 2273513 */     GIR_EraseRootFromParent_Done,
     /* 2273514 */   // Label 32593: @2273514
     /* 2273514 */   GIM_Try, /*On fail goto*//*Label 32594*/ GIMT_Encode4(2273562), // Rule ID 52873 //
     /* 2273519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273522 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2273525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2273539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273561 */     // GIR_Coverage, 52873,
     /* 2273561 */     GIR_EraseRootFromParent_Done,
     /* 2273562 */   // Label 32594: @2273562
     /* 2273562 */   GIM_Reject,
     /* 2273563 */ // Label 32592: @2273563
     /* 2273563 */ GIM_Reject,
     /* 2273564 */ // Label 32551: @2273564
     /* 2273564 */ GIM_Try, /*On fail goto*//*Label 32595*/ GIMT_Encode4(2273684),
     /* 2273569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2273572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2273575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273587 */   GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2273635), // Rule ID 52764 //
     /* 2273592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273595 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2273598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2273612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273634 */     // GIR_Coverage, 52764,
     /* 2273634 */     GIR_EraseRootFromParent_Done,
     /* 2273635 */   // Label 32596: @2273635
     /* 2273635 */   GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2273683), // Rule ID 52765 //
     /* 2273640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273643 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2273646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2273660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273682 */     // GIR_Coverage, 52765,
     /* 2273682 */     GIR_EraseRootFromParent_Done,
     /* 2273683 */   // Label 32597: @2273683
     /* 2273683 */   GIM_Reject,
     /* 2273684 */ // Label 32595: @2273684
     /* 2273684 */ GIM_Reject,
     /* 2273685 */ // Label 32552: @2273685
     /* 2273685 */ GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2273805),
     /* 2273690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2273693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2273696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273708 */   GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2273756), // Rule ID 52836 //
     /* 2273713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273716 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2273719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2273733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273755 */     // GIR_Coverage, 52836,
     /* 2273755 */     GIR_EraseRootFromParent_Done,
     /* 2273756 */   // Label 32599: @2273756
     /* 2273756 */   GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2273804), // Rule ID 52837 //
     /* 2273761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273764 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2273767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2273781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273803 */     // GIR_Coverage, 52837,
     /* 2273803 */     GIR_EraseRootFromParent_Done,
     /* 2273804 */   // Label 32600: @2273804
     /* 2273804 */   GIM_Reject,
     /* 2273805 */ // Label 32598: @2273805
     /* 2273805 */ GIM_Reject,
     /* 2273806 */ // Label 32553: @2273806
     /* 2273806 */ GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2273926),
     /* 2273811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2273814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2273817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273829 */   GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2273877), // Rule ID 52884 //
     /* 2273834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273837 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2273840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2273854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273876 */     // GIR_Coverage, 52884,
     /* 2273876 */     GIR_EraseRootFromParent_Done,
     /* 2273877 */   // Label 32602: @2273877
     /* 2273877 */   GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2273925), // Rule ID 52885 //
     /* 2273882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273885 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2273888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2273902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273924 */     // GIR_Coverage, 52885,
     /* 2273924 */     GIR_EraseRootFromParent_Done,
     /* 2273925 */   // Label 32603: @2273925
     /* 2273925 */   GIM_Reject,
     /* 2273926 */ // Label 32601: @2273926
     /* 2273926 */ GIM_Reject,
     /* 2273927 */ // Label 32554: @2273927
     /* 2273927 */ GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2274047),
     /* 2273932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2273935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2273938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273950 */   GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2273998), // Rule ID 52800 //
     /* 2273955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273958 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2273961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2273975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2273987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273997 */     // GIR_Coverage, 52800,
     /* 2273997 */     GIR_EraseRootFromParent_Done,
     /* 2273998 */   // Label 32605: @2273998
     /* 2273998 */   GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2274046), // Rule ID 52801 //
     /* 2274003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274006 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2274009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2274023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274045 */     // GIR_Coverage, 52801,
     /* 2274045 */     GIR_EraseRootFromParent_Done,
     /* 2274046 */   // Label 32606: @2274046
     /* 2274046 */   GIM_Reject,
     /* 2274047 */ // Label 32604: @2274047
     /* 2274047 */ GIM_Reject,
     /* 2274048 */ // Label 32555: @2274048
     /* 2274048 */ GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2274168),
     /* 2274053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2274056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2274059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274071 */   GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2274119), // Rule ID 52848 //
     /* 2274076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2274079 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2274082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2274096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274118 */     // GIR_Coverage, 52848,
     /* 2274118 */     GIR_EraseRootFromParent_Done,
     /* 2274119 */   // Label 32608: @2274119
     /* 2274119 */   GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2274167), // Rule ID 52849 //
     /* 2274124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274127 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2274130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2274144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274166 */     // GIR_Coverage, 52849,
     /* 2274166 */     GIR_EraseRootFromParent_Done,
     /* 2274167 */   // Label 32609: @2274167
     /* 2274167 */   GIM_Reject,
     /* 2274168 */ // Label 32607: @2274168
     /* 2274168 */ GIM_Reject,
     /* 2274169 */ // Label 32556: @2274169
     /* 2274169 */ GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2274289),
     /* 2274174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2274177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2274180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274192 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2274240), // Rule ID 52896 //
     /* 2274197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2274200 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2274203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2274217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274239 */     // GIR_Coverage, 52896,
     /* 2274239 */     GIR_EraseRootFromParent_Done,
     /* 2274240 */   // Label 32611: @2274240
     /* 2274240 */   GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2274288), // Rule ID 52897 //
     /* 2274245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2274248 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2274251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2274265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274287 */     // GIR_Coverage, 52897,
     /* 2274287 */     GIR_EraseRootFromParent_Done,
     /* 2274288 */   // Label 32612: @2274288
     /* 2274288 */   GIM_Reject,
     /* 2274289 */ // Label 32610: @2274289
     /* 2274289 */ GIM_Reject,
     /* 2274290 */ // Label 32557: @2274290
     /* 2274290 */ GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2274410),
     /* 2274295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2274298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2274301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274313 */   GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2274361), // Rule ID 52812 //
     /* 2274318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274321 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2274324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2274338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274360 */     // GIR_Coverage, 52812,
     /* 2274360 */     GIR_EraseRootFromParent_Done,
     /* 2274361 */   // Label 32614: @2274361
     /* 2274361 */   GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2274409), // Rule ID 52813 //
     /* 2274366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274369 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2274372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2274386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274408 */     // GIR_Coverage, 52813,
     /* 2274408 */     GIR_EraseRootFromParent_Done,
     /* 2274409 */   // Label 32615: @2274409
     /* 2274409 */   GIM_Reject,
     /* 2274410 */ // Label 32613: @2274410
     /* 2274410 */ GIM_Reject,
     /* 2274411 */ // Label 32558: @2274411
     /* 2274411 */ GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2274531),
     /* 2274416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2274419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2274422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274434 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2274482), // Rule ID 52860 //
     /* 2274439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2274442 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2274445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2274459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274481 */     // GIR_Coverage, 52860,
     /* 2274481 */     GIR_EraseRootFromParent_Done,
     /* 2274482 */   // Label 32617: @2274482
     /* 2274482 */   GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2274530), // Rule ID 52861 //
     /* 2274487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274490 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2274493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2274507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274529 */     // GIR_Coverage, 52861,
     /* 2274529 */     GIR_EraseRootFromParent_Done,
     /* 2274530 */   // Label 32618: @2274530
     /* 2274530 */   GIM_Reject,
     /* 2274531 */ // Label 32616: @2274531
     /* 2274531 */ GIM_Reject,
     /* 2274532 */ // Label 32559: @2274532
     /* 2274532 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2274652),
     /* 2274537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2274540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2274543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274555 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2274603), // Rule ID 52824 //
     /* 2274560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274563 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2274566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2274580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274602 */     // GIR_Coverage, 52824,
     /* 2274602 */     GIR_EraseRootFromParent_Done,
     /* 2274603 */   // Label 32620: @2274603
     /* 2274603 */   GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2274651), // Rule ID 52825 //
     /* 2274608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274611 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2274614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2274628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274650 */     // GIR_Coverage, 52825,
     /* 2274650 */     GIR_EraseRootFromParent_Done,
     /* 2274651 */   // Label 32621: @2274651
     /* 2274651 */   GIM_Reject,
     /* 2274652 */ // Label 32619: @2274652
     /* 2274652 */ GIM_Reject,
     /* 2274653 */ // Label 32560: @2274653
     /* 2274653 */ GIM_Reject,
     /* 2274654 */ // Label 95: @2274654
     /* 2274654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32640*/ GIMT_Encode4(2277081),
     /* 2274665 */ /*GILLT_s16*//*Label 32622*/ GIMT_Encode4(2274785),
     /* 2274669 */ /*GILLT_s32*//*Label 32623*/ GIMT_Encode4(2274934),
     /* 2274673 */ /*GILLT_s64*//*Label 32624*/ GIMT_Encode4(2275083), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274685 */ /*GILLT_nxv1s16*//*Label 32625*/ GIMT_Encode4(2275266),
     /* 2274689 */ /*GILLT_nxv1s32*//*Label 32626*/ GIMT_Encode4(2275387),
     /* 2274693 */ /*GILLT_nxv1s64*//*Label 32627*/ GIMT_Encode4(2275508), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274705 */ /*GILLT_nxv2s16*//*Label 32628*/ GIMT_Encode4(2275629),
     /* 2274709 */ /*GILLT_nxv2s32*//*Label 32629*/ GIMT_Encode4(2275750),
     /* 2274713 */ /*GILLT_nxv2s64*//*Label 32630*/ GIMT_Encode4(2275871), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274725 */ /*GILLT_nxv4s16*//*Label 32631*/ GIMT_Encode4(2275992),
     /* 2274729 */ /*GILLT_nxv4s32*//*Label 32632*/ GIMT_Encode4(2276113),
     /* 2274733 */ /*GILLT_nxv4s64*//*Label 32633*/ GIMT_Encode4(2276234), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274745 */ /*GILLT_nxv8s16*//*Label 32634*/ GIMT_Encode4(2276355),
     /* 2274749 */ /*GILLT_nxv8s32*//*Label 32635*/ GIMT_Encode4(2276476),
     /* 2274753 */ /*GILLT_nxv8s64*//*Label 32636*/ GIMT_Encode4(2276597), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274765 */ /*GILLT_nxv16s16*//*Label 32637*/ GIMT_Encode4(2276718),
     /* 2274769 */ /*GILLT_nxv16s32*//*Label 32638*/ GIMT_Encode4(2276839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2274781 */ /*GILLT_nxv32s16*//*Label 32639*/ GIMT_Encode4(2276960),
     /* 2274785 */ // Label 32622: @2274785
     /* 2274785 */ GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2274933),
     /* 2274790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2274793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2274796 */   GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2274830), // Rule ID 1822 //
     /* 2274801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2274804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274816 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2274816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2274819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274829 */     // GIR_Coverage, 1822,
     /* 2274829 */     GIR_EraseRootFromParent_Done,
     /* 2274830 */   // Label 32642: @2274830
     /* 2274830 */   GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2274864), // Rule ID 1823 //
     /* 2274835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2274838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2274850 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2274850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2274853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274863 */     // GIR_Coverage, 1823,
     /* 2274863 */     GIR_EraseRootFromParent_Done,
     /* 2274864 */   // Label 32643: @2274864
     /* 2274864 */   GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2274898), // Rule ID 1826 //
     /* 2274869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2274872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274884 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2274884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2274887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274897 */     // GIR_Coverage, 1826,
     /* 2274897 */     GIR_EraseRootFromParent_Done,
     /* 2274898 */   // Label 32644: @2274898
     /* 2274898 */   GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2274932), // Rule ID 1827 //
     /* 2274903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2274906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2274918 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2274918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2274921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274931 */     // GIR_Coverage, 1827,
     /* 2274931 */     GIR_EraseRootFromParent_Done,
     /* 2274932 */   // Label 32645: @2274932
     /* 2274932 */   GIM_Reject,
     /* 2274933 */ // Label 32641: @2274933
     /* 2274933 */ GIM_Reject,
     /* 2274934 */ // Label 32623: @2274934
     /* 2274934 */ GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2275082),
     /* 2274939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2274942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274945 */   GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2274979), // Rule ID 1113 //
     /* 2274950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2274953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274965 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2274965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2274968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2274977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274978 */     // GIR_Coverage, 1113,
     /* 2274978 */     GIR_EraseRootFromParent_Done,
     /* 2274979 */   // Label 32647: @2274979
     /* 2274979 */   GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2275013), // Rule ID 1114 //
     /* 2274984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2274987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2274999 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2274999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2275002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275012 */     // GIR_Coverage, 1114,
     /* 2275012 */     GIR_EraseRootFromParent_Done,
     /* 2275013 */   // Label 32648: @2275013
     /* 2275013 */   GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2275047), // Rule ID 1117 //
     /* 2275018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2275021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275033 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2275033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2275036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275046 */     // GIR_Coverage, 1117,
     /* 2275046 */     GIR_EraseRootFromParent_Done,
     /* 2275047 */   // Label 32649: @2275047
     /* 2275047 */   GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2275081), // Rule ID 1118 //
     /* 2275052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2275055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2275067 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2275067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2275070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275080 */     // GIR_Coverage, 1118,
     /* 2275080 */     GIR_EraseRootFromParent_Done,
     /* 2275081 */   // Label 32650: @2275081
     /* 2275081 */   GIM_Reject,
     /* 2275082 */ // Label 32646: @2275082
     /* 2275082 */ GIM_Reject,
     /* 2275083 */ // Label 32624: @2275083
     /* 2275083 */ GIM_Try, /*On fail goto*//*Label 32651*/ GIMT_Encode4(2275265),
     /* 2275088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2275091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275094 */   GIM_Try, /*On fail goto*//*Label 32652*/ GIMT_Encode4(2275128), // Rule ID 1450 //
     /* 2275099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2275102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275114 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2275114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2275117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275127 */     // GIR_Coverage, 1450,
     /* 2275127 */     GIR_EraseRootFromParent_Done,
     /* 2275128 */   // Label 32652: @2275128
     /* 2275128 */   GIM_Try, /*On fail goto*//*Label 32653*/ GIMT_Encode4(2275162), // Rule ID 1451 //
     /* 2275133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2275136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2275148 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2275148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2275151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275161 */     // GIR_Coverage, 1451,
     /* 2275161 */     GIR_EraseRootFromParent_Done,
     /* 2275162 */   // Label 32653: @2275162
     /* 2275162 */   GIM_Try, /*On fail goto*//*Label 32654*/ GIMT_Encode4(2275196), // Rule ID 1454 //
     /* 2275167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2275170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275182 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2275182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2275185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275195 */     // GIR_Coverage, 1454,
     /* 2275195 */     GIR_EraseRootFromParent_Done,
     /* 2275196 */   // Label 32654: @2275196
     /* 2275196 */   GIM_Try, /*On fail goto*//*Label 32655*/ GIMT_Encode4(2275230), // Rule ID 1455 //
     /* 2275201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2275204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2275216 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2275216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2275219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275229 */     // GIR_Coverage, 1455,
     /* 2275229 */     GIR_EraseRootFromParent_Done,
     /* 2275230 */   // Label 32655: @2275230
     /* 2275230 */   GIM_Try, /*On fail goto*//*Label 32656*/ GIMT_Encode4(2275264), // Rule ID 1458 //
     /* 2275235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2275238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275250 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2275250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2275253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275263 */     // GIR_Coverage, 1458,
     /* 2275263 */     GIR_EraseRootFromParent_Done,
     /* 2275264 */   // Label 32656: @2275264
     /* 2275264 */   GIM_Reject,
     /* 2275265 */ // Label 32651: @2275265
     /* 2275265 */ GIM_Reject,
     /* 2275266 */ // Label 32625: @2275266
     /* 2275266 */ GIM_Try, /*On fail goto*//*Label 32657*/ GIMT_Encode4(2275386),
     /* 2275271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2275274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2275277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275289 */   GIM_Try, /*On fail goto*//*Label 32658*/ GIMT_Encode4(2275337), // Rule ID 52908 //
     /* 2275294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275297 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2275314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275336 */     // GIR_Coverage, 52908,
     /* 2275336 */     GIR_EraseRootFromParent_Done,
     /* 2275337 */   // Label 32658: @2275337
     /* 2275337 */   GIM_Try, /*On fail goto*//*Label 32659*/ GIMT_Encode4(2275385), // Rule ID 52909 //
     /* 2275342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275345 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2275362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275384 */     // GIR_Coverage, 52909,
     /* 2275384 */     GIR_EraseRootFromParent_Done,
     /* 2275385 */   // Label 32659: @2275385
     /* 2275385 */   GIM_Reject,
     /* 2275386 */ // Label 32657: @2275386
     /* 2275386 */ GIM_Reject,
     /* 2275387 */ // Label 32626: @2275387
     /* 2275387 */ GIM_Try, /*On fail goto*//*Label 32660*/ GIMT_Encode4(2275507),
     /* 2275392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2275395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2275398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275410 */   GIM_Try, /*On fail goto*//*Label 32661*/ GIMT_Encode4(2275458), // Rule ID 52932 //
     /* 2275415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275418 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2275435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275457 */     // GIR_Coverage, 52932,
     /* 2275457 */     GIR_EraseRootFromParent_Done,
     /* 2275458 */   // Label 32661: @2275458
     /* 2275458 */   GIM_Try, /*On fail goto*//*Label 32662*/ GIMT_Encode4(2275506), // Rule ID 52933 //
     /* 2275463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2275466 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2275483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275505 */     // GIR_Coverage, 52933,
     /* 2275505 */     GIR_EraseRootFromParent_Done,
     /* 2275506 */   // Label 32662: @2275506
     /* 2275506 */   GIM_Reject,
     /* 2275507 */ // Label 32660: @2275507
     /* 2275507 */ GIM_Reject,
     /* 2275508 */ // Label 32627: @2275508
     /* 2275508 */ GIM_Try, /*On fail goto*//*Label 32663*/ GIMT_Encode4(2275628),
     /* 2275513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2275516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2275519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275531 */   GIM_Try, /*On fail goto*//*Label 32664*/ GIMT_Encode4(2275579), // Rule ID 52968 //
     /* 2275536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2275539 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2275556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275578 */     // GIR_Coverage, 52968,
     /* 2275578 */     GIR_EraseRootFromParent_Done,
     /* 2275579 */   // Label 32664: @2275579
     /* 2275579 */   GIM_Try, /*On fail goto*//*Label 32665*/ GIMT_Encode4(2275627), // Rule ID 52969 //
     /* 2275584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2275587 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2275604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275626 */     // GIR_Coverage, 52969,
     /* 2275626 */     GIR_EraseRootFromParent_Done,
     /* 2275627 */   // Label 32665: @2275627
     /* 2275627 */   GIM_Reject,
     /* 2275628 */ // Label 32663: @2275628
     /* 2275628 */ GIM_Reject,
     /* 2275629 */ // Label 32628: @2275629
     /* 2275629 */ GIM_Try, /*On fail goto*//*Label 32666*/ GIMT_Encode4(2275749),
     /* 2275634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2275637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2275640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275652 */   GIM_Try, /*On fail goto*//*Label 32667*/ GIMT_Encode4(2275700), // Rule ID 52920 //
     /* 2275657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275660 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2275663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2275677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275699 */     // GIR_Coverage, 52920,
     /* 2275699 */     GIR_EraseRootFromParent_Done,
     /* 2275700 */   // Label 32667: @2275700
     /* 2275700 */   GIM_Try, /*On fail goto*//*Label 32668*/ GIMT_Encode4(2275748), // Rule ID 52921 //
     /* 2275705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275708 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2275711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2275725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275747 */     // GIR_Coverage, 52921,
     /* 2275747 */     GIR_EraseRootFromParent_Done,
     /* 2275748 */   // Label 32668: @2275748
     /* 2275748 */   GIM_Reject,
     /* 2275749 */ // Label 32666: @2275749
     /* 2275749 */ GIM_Reject,
     /* 2275750 */ // Label 32629: @2275750
     /* 2275750 */ GIM_Try, /*On fail goto*//*Label 32669*/ GIMT_Encode4(2275870),
     /* 2275755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2275758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2275761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275773 */   GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2275821), // Rule ID 52956 //
     /* 2275778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275781 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2275784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2275798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275820 */     // GIR_Coverage, 52956,
     /* 2275820 */     GIR_EraseRootFromParent_Done,
     /* 2275821 */   // Label 32670: @2275821
     /* 2275821 */   GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2275869), // Rule ID 52957 //
     /* 2275826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2275829 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2275832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2275846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275868 */     // GIR_Coverage, 52957,
     /* 2275868 */     GIR_EraseRootFromParent_Done,
     /* 2275869 */   // Label 32671: @2275869
     /* 2275869 */   GIM_Reject,
     /* 2275870 */ // Label 32669: @2275870
     /* 2275870 */ GIM_Reject,
     /* 2275871 */ // Label 32630: @2275871
     /* 2275871 */ GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2275991),
     /* 2275876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2275879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2275882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275894 */   GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2275942), // Rule ID 53052 //
     /* 2275899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2275902 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2275905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2275919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275941 */     // GIR_Coverage, 53052,
     /* 2275941 */     GIR_EraseRootFromParent_Done,
     /* 2275942 */   // Label 32673: @2275942
     /* 2275942 */   GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2275990), // Rule ID 53053 //
     /* 2275947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2275950 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2275953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2275967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2275979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275989 */     // GIR_Coverage, 53053,
     /* 2275989 */     GIR_EraseRootFromParent_Done,
     /* 2275990 */   // Label 32674: @2275990
     /* 2275990 */   GIM_Reject,
     /* 2275991 */ // Label 32672: @2275991
     /* 2275991 */ GIM_Reject,
     /* 2275992 */ // Label 32631: @2275992
     /* 2275992 */ GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2276112),
     /* 2275997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2276000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2276003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276015 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2276063), // Rule ID 52944 //
     /* 2276020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276023 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2276040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276062 */     // GIR_Coverage, 52944,
     /* 2276062 */     GIR_EraseRootFromParent_Done,
     /* 2276063 */   // Label 32676: @2276063
     /* 2276063 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2276111), // Rule ID 52945 //
     /* 2276068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276071 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2276088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276110 */     // GIR_Coverage, 52945,
     /* 2276110 */     GIR_EraseRootFromParent_Done,
     /* 2276111 */   // Label 32677: @2276111
     /* 2276111 */   GIM_Reject,
     /* 2276112 */ // Label 32675: @2276112
     /* 2276112 */ GIM_Reject,
     /* 2276113 */ // Label 32632: @2276113
     /* 2276113 */ GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2276233),
     /* 2276118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2276121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2276124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276136 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2276184), // Rule ID 53016 //
     /* 2276141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276144 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2276147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2276161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276183 */     // GIR_Coverage, 53016,
     /* 2276183 */     GIR_EraseRootFromParent_Done,
     /* 2276184 */   // Label 32679: @2276184
     /* 2276184 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2276232), // Rule ID 53017 //
     /* 2276189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276192 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2276195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2276209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276231 */     // GIR_Coverage, 53017,
     /* 2276231 */     GIR_EraseRootFromParent_Done,
     /* 2276232 */   // Label 32680: @2276232
     /* 2276232 */   GIM_Reject,
     /* 2276233 */ // Label 32678: @2276233
     /* 2276233 */ GIM_Reject,
     /* 2276234 */ // Label 32633: @2276234
     /* 2276234 */ GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2276354),
     /* 2276239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2276242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2276245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276257 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2276305), // Rule ID 53064 //
     /* 2276262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2276265 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2276268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2276282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276304 */     // GIR_Coverage, 53064,
     /* 2276304 */     GIR_EraseRootFromParent_Done,
     /* 2276305 */   // Label 32682: @2276305
     /* 2276305 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2276353), // Rule ID 53065 //
     /* 2276310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2276313 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2276316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2276330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276352 */     // GIR_Coverage, 53065,
     /* 2276352 */     GIR_EraseRootFromParent_Done,
     /* 2276353 */   // Label 32683: @2276353
     /* 2276353 */   GIM_Reject,
     /* 2276354 */ // Label 32681: @2276354
     /* 2276354 */ GIM_Reject,
     /* 2276355 */ // Label 32634: @2276355
     /* 2276355 */ GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2276475),
     /* 2276360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2276363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2276366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276378 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2276426), // Rule ID 52980 //
     /* 2276383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276386 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2276389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2276403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276425 */     // GIR_Coverage, 52980,
     /* 2276425 */     GIR_EraseRootFromParent_Done,
     /* 2276426 */   // Label 32685: @2276426
     /* 2276426 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2276474), // Rule ID 52981 //
     /* 2276431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276434 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2276437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2276451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276473 */     // GIR_Coverage, 52981,
     /* 2276473 */     GIR_EraseRootFromParent_Done,
     /* 2276474 */   // Label 32686: @2276474
     /* 2276474 */   GIM_Reject,
     /* 2276475 */ // Label 32684: @2276475
     /* 2276475 */ GIM_Reject,
     /* 2276476 */ // Label 32635: @2276476
     /* 2276476 */ GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2276596),
     /* 2276481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2276484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2276487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276499 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2276547), // Rule ID 53028 //
     /* 2276504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276507 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2276510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2276524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276546 */     // GIR_Coverage, 53028,
     /* 2276546 */     GIR_EraseRootFromParent_Done,
     /* 2276547 */   // Label 32688: @2276547
     /* 2276547 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2276595), // Rule ID 53029 //
     /* 2276552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276555 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2276558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2276572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276594 */     // GIR_Coverage, 53029,
     /* 2276594 */     GIR_EraseRootFromParent_Done,
     /* 2276595 */   // Label 32689: @2276595
     /* 2276595 */   GIM_Reject,
     /* 2276596 */ // Label 32687: @2276596
     /* 2276596 */ GIM_Reject,
     /* 2276597 */ // Label 32636: @2276597
     /* 2276597 */ GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2276717),
     /* 2276602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2276605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2276608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276620 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2276668), // Rule ID 53076 //
     /* 2276625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2276628 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2276631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2276645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276667 */     // GIR_Coverage, 53076,
     /* 2276667 */     GIR_EraseRootFromParent_Done,
     /* 2276668 */   // Label 32691: @2276668
     /* 2276668 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2276716), // Rule ID 53077 //
     /* 2276673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2276676 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2276679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2276693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276715 */     // GIR_Coverage, 53077,
     /* 2276715 */     GIR_EraseRootFromParent_Done,
     /* 2276716 */   // Label 32692: @2276716
     /* 2276716 */   GIM_Reject,
     /* 2276717 */ // Label 32690: @2276717
     /* 2276717 */ GIM_Reject,
     /* 2276718 */ // Label 32637: @2276718
     /* 2276718 */ GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2276838),
     /* 2276723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2276726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276741 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2276789), // Rule ID 52992 //
     /* 2276746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276749 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2276752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2276766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276788 */     // GIR_Coverage, 52992,
     /* 2276788 */     GIR_EraseRootFromParent_Done,
     /* 2276789 */   // Label 32694: @2276789
     /* 2276789 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2276837), // Rule ID 52993 //
     /* 2276794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276797 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2276800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2276814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276836 */     // GIR_Coverage, 52993,
     /* 2276836 */     GIR_EraseRootFromParent_Done,
     /* 2276837 */   // Label 32695: @2276837
     /* 2276837 */   GIM_Reject,
     /* 2276838 */ // Label 32693: @2276838
     /* 2276838 */ GIM_Reject,
     /* 2276839 */ // Label 32638: @2276839
     /* 2276839 */ GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2276959),
     /* 2276844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2276847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276862 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2276910), // Rule ID 53040 //
     /* 2276867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276870 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2276873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2276887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276909 */     // GIR_Coverage, 53040,
     /* 2276909 */     GIR_EraseRootFromParent_Done,
     /* 2276910 */   // Label 32697: @2276910
     /* 2276910 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2276958), // Rule ID 53041 //
     /* 2276915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276918 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2276921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2276935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2276947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276957 */     // GIR_Coverage, 53041,
     /* 2276957 */     GIR_EraseRootFromParent_Done,
     /* 2276958 */   // Label 32698: @2276958
     /* 2276958 */   GIM_Reject,
     /* 2276959 */ // Label 32696: @2276959
     /* 2276959 */ GIM_Reject,
     /* 2276960 */ // Label 32639: @2276960
     /* 2276960 */ GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2277080),
     /* 2276965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2276968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2276971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276983 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2277031), // Rule ID 53004 //
     /* 2276988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276991 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2276994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2277008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277030 */     // GIR_Coverage, 53004,
     /* 2277030 */     GIR_EraseRootFromParent_Done,
     /* 2277031 */   // Label 32700: @2277031
     /* 2277031 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2277079), // Rule ID 53005 //
     /* 2277036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277039 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2277042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2277056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277078 */     // GIR_Coverage, 53005,
     /* 2277078 */     GIR_EraseRootFromParent_Done,
     /* 2277079 */   // Label 32701: @2277079
     /* 2277079 */   GIM_Reject,
     /* 2277080 */ // Label 32699: @2277080
     /* 2277080 */ GIM_Reject,
     /* 2277081 */ // Label 32640: @2277081
     /* 2277081 */ GIM_Reject,
     /* 2277082 */ // Label 96: @2277082
     /* 2277082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32720*/ GIMT_Encode4(2279509),
     /* 2277093 */ /*GILLT_s16*//*Label 32702*/ GIMT_Encode4(2277213),
     /* 2277097 */ /*GILLT_s32*//*Label 32703*/ GIMT_Encode4(2277362),
     /* 2277101 */ /*GILLT_s64*//*Label 32704*/ GIMT_Encode4(2277511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277113 */ /*GILLT_nxv1s16*//*Label 32705*/ GIMT_Encode4(2277694),
     /* 2277117 */ /*GILLT_nxv1s32*//*Label 32706*/ GIMT_Encode4(2277815),
     /* 2277121 */ /*GILLT_nxv1s64*//*Label 32707*/ GIMT_Encode4(2277936), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277133 */ /*GILLT_nxv2s16*//*Label 32708*/ GIMT_Encode4(2278057),
     /* 2277137 */ /*GILLT_nxv2s32*//*Label 32709*/ GIMT_Encode4(2278178),
     /* 2277141 */ /*GILLT_nxv2s64*//*Label 32710*/ GIMT_Encode4(2278299), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277153 */ /*GILLT_nxv4s16*//*Label 32711*/ GIMT_Encode4(2278420),
     /* 2277157 */ /*GILLT_nxv4s32*//*Label 32712*/ GIMT_Encode4(2278541),
     /* 2277161 */ /*GILLT_nxv4s64*//*Label 32713*/ GIMT_Encode4(2278662), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277173 */ /*GILLT_nxv8s16*//*Label 32714*/ GIMT_Encode4(2278783),
     /* 2277177 */ /*GILLT_nxv8s32*//*Label 32715*/ GIMT_Encode4(2278904),
     /* 2277181 */ /*GILLT_nxv8s64*//*Label 32716*/ GIMT_Encode4(2279025), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277193 */ /*GILLT_nxv16s16*//*Label 32717*/ GIMT_Encode4(2279146),
     /* 2277197 */ /*GILLT_nxv16s32*//*Label 32718*/ GIMT_Encode4(2279267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277209 */ /*GILLT_nxv32s16*//*Label 32719*/ GIMT_Encode4(2279388),
     /* 2277213 */ // Label 32702: @2277213
     /* 2277213 */ GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2277361),
     /* 2277218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2277221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2277224 */   GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2277258), // Rule ID 1830 //
     /* 2277229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2277232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277244 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2277244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2277247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277257 */     // GIR_Coverage, 1830,
     /* 2277257 */     GIR_EraseRootFromParent_Done,
     /* 2277258 */   // Label 32722: @2277258
     /* 2277258 */   GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2277292), // Rule ID 1831 //
     /* 2277263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2277266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2277278 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2277278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2277281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277291 */     // GIR_Coverage, 1831,
     /* 2277291 */     GIR_EraseRootFromParent_Done,
     /* 2277292 */   // Label 32723: @2277292
     /* 2277292 */   GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2277326), // Rule ID 1834 //
     /* 2277297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2277300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277312 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2277312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2277315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277325 */     // GIR_Coverage, 1834,
     /* 2277325 */     GIR_EraseRootFromParent_Done,
     /* 2277326 */   // Label 32724: @2277326
     /* 2277326 */   GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2277360), // Rule ID 1835 //
     /* 2277331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2277334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2277346 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2277346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2277349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277359 */     // GIR_Coverage, 1835,
     /* 2277359 */     GIR_EraseRootFromParent_Done,
     /* 2277360 */   // Label 32725: @2277360
     /* 2277360 */   GIM_Reject,
     /* 2277361 */ // Label 32721: @2277361
     /* 2277361 */ GIM_Reject,
     /* 2277362 */ // Label 32703: @2277362
     /* 2277362 */ GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2277510),
     /* 2277367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2277370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277373 */   GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2277407), // Rule ID 1121 //
     /* 2277378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2277381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277393 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2277393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2277396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277406 */     // GIR_Coverage, 1121,
     /* 2277406 */     GIR_EraseRootFromParent_Done,
     /* 2277407 */   // Label 32727: @2277407
     /* 2277407 */   GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2277441), // Rule ID 1122 //
     /* 2277412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2277415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2277427 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2277427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2277430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277440 */     // GIR_Coverage, 1122,
     /* 2277440 */     GIR_EraseRootFromParent_Done,
     /* 2277441 */   // Label 32728: @2277441
     /* 2277441 */   GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2277475), // Rule ID 1125 //
     /* 2277446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2277449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277461 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2277461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2277464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277474 */     // GIR_Coverage, 1125,
     /* 2277474 */     GIR_EraseRootFromParent_Done,
     /* 2277475 */   // Label 32729: @2277475
     /* 2277475 */   GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2277509), // Rule ID 1126 //
     /* 2277480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2277483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2277495 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2277495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2277498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277508 */     // GIR_Coverage, 1126,
     /* 2277508 */     GIR_EraseRootFromParent_Done,
     /* 2277509 */   // Label 32730: @2277509
     /* 2277509 */   GIM_Reject,
     /* 2277510 */ // Label 32726: @2277510
     /* 2277510 */ GIM_Reject,
     /* 2277511 */ // Label 32704: @2277511
     /* 2277511 */ GIM_Try, /*On fail goto*//*Label 32731*/ GIMT_Encode4(2277693),
     /* 2277516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2277519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2277522 */   GIM_Try, /*On fail goto*//*Label 32732*/ GIMT_Encode4(2277556), // Rule ID 1460 //
     /* 2277527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2277530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277542 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2277542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2277545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277555 */     // GIR_Coverage, 1460,
     /* 2277555 */     GIR_EraseRootFromParent_Done,
     /* 2277556 */   // Label 32732: @2277556
     /* 2277556 */   GIM_Try, /*On fail goto*//*Label 32733*/ GIMT_Encode4(2277590), // Rule ID 1461 //
     /* 2277561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2277564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2277576 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2277576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2277579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277589 */     // GIR_Coverage, 1461,
     /* 2277589 */     GIR_EraseRootFromParent_Done,
     /* 2277590 */   // Label 32733: @2277590
     /* 2277590 */   GIM_Try, /*On fail goto*//*Label 32734*/ GIMT_Encode4(2277624), // Rule ID 1464 //
     /* 2277595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2277598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277610 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2277610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2277613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277623 */     // GIR_Coverage, 1464,
     /* 2277623 */     GIR_EraseRootFromParent_Done,
     /* 2277624 */   // Label 32734: @2277624
     /* 2277624 */   GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2277658), // Rule ID 1465 //
     /* 2277629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2277632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2277644 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2277644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2277647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277657 */     // GIR_Coverage, 1465,
     /* 2277657 */     GIR_EraseRootFromParent_Done,
     /* 2277658 */   // Label 32735: @2277658
     /* 2277658 */   GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2277692), // Rule ID 1468 //
     /* 2277663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2277666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277678 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2277678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2277681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277691 */     // GIR_Coverage, 1468,
     /* 2277691 */     GIR_EraseRootFromParent_Done,
     /* 2277692 */   // Label 32736: @2277692
     /* 2277692 */   GIM_Reject,
     /* 2277693 */ // Label 32731: @2277693
     /* 2277693 */ GIM_Reject,
     /* 2277694 */ // Label 32705: @2277694
     /* 2277694 */ GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2277814),
     /* 2277699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2277702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2277705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277717 */   GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2277765), // Rule ID 53676 //
     /* 2277722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2277725 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2277742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277764 */     // GIR_Coverage, 53676,
     /* 2277764 */     GIR_EraseRootFromParent_Done,
     /* 2277765 */   // Label 32738: @2277765
     /* 2277765 */   GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2277813), // Rule ID 53677 //
     /* 2277770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277773 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2277790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277812 */     // GIR_Coverage, 53677,
     /* 2277812 */     GIR_EraseRootFromParent_Done,
     /* 2277813 */   // Label 32739: @2277813
     /* 2277813 */   GIM_Reject,
     /* 2277814 */ // Label 32737: @2277814
     /* 2277814 */ GIM_Reject,
     /* 2277815 */ // Label 32706: @2277815
     /* 2277815 */ GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2277935),
     /* 2277820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2277823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2277826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277838 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2277886), // Rule ID 53700 //
     /* 2277843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2277846 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2277849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2277863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277885 */     // GIR_Coverage, 53700,
     /* 2277885 */     GIR_EraseRootFromParent_Done,
     /* 2277886 */   // Label 32741: @2277886
     /* 2277886 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2277934), // Rule ID 53701 //
     /* 2277891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2277894 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2277897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2277911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277933 */     // GIR_Coverage, 53701,
     /* 2277933 */     GIR_EraseRootFromParent_Done,
     /* 2277934 */   // Label 32742: @2277934
     /* 2277934 */   GIM_Reject,
     /* 2277935 */ // Label 32740: @2277935
     /* 2277935 */ GIM_Reject,
     /* 2277936 */ // Label 32707: @2277936
     /* 2277936 */ GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2278056),
     /* 2277941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2277944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2277947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277959 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2278007), // Rule ID 53736 //
     /* 2277964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2277967 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2277970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2277984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2277996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278006 */     // GIR_Coverage, 53736,
     /* 2278006 */     GIR_EraseRootFromParent_Done,
     /* 2278007 */   // Label 32744: @2278007
     /* 2278007 */   GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2278055), // Rule ID 53737 //
     /* 2278012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2278015 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2278032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278054 */     // GIR_Coverage, 53737,
     /* 2278054 */     GIR_EraseRootFromParent_Done,
     /* 2278055 */   // Label 32745: @2278055
     /* 2278055 */   GIM_Reject,
     /* 2278056 */ // Label 32743: @2278056
     /* 2278056 */ GIM_Reject,
     /* 2278057 */ // Label 32708: @2278057
     /* 2278057 */ GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2278177),
     /* 2278062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2278065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2278068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278080 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2278128), // Rule ID 53688 //
     /* 2278085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2278088 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2278105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278127 */     // GIR_Coverage, 53688,
     /* 2278127 */     GIR_EraseRootFromParent_Done,
     /* 2278128 */   // Label 32747: @2278128
     /* 2278128 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2278176), // Rule ID 53689 //
     /* 2278133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2278136 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2278153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278175 */     // GIR_Coverage, 53689,
     /* 2278175 */     GIR_EraseRootFromParent_Done,
     /* 2278176 */   // Label 32748: @2278176
     /* 2278176 */   GIM_Reject,
     /* 2278177 */ // Label 32746: @2278177
     /* 2278177 */ GIM_Reject,
     /* 2278178 */ // Label 32709: @2278178
     /* 2278178 */ GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2278298),
     /* 2278183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2278186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2278189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278201 */   GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2278249), // Rule ID 53724 //
     /* 2278206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2278209 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2278226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278248 */     // GIR_Coverage, 53724,
     /* 2278248 */     GIR_EraseRootFromParent_Done,
     /* 2278249 */   // Label 32750: @2278249
     /* 2278249 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2278297), // Rule ID 53725 //
     /* 2278254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2278257 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2278274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278296 */     // GIR_Coverage, 53725,
     /* 2278296 */     GIR_EraseRootFromParent_Done,
     /* 2278297 */   // Label 32751: @2278297
     /* 2278297 */   GIM_Reject,
     /* 2278298 */ // Label 32749: @2278298
     /* 2278298 */ GIM_Reject,
     /* 2278299 */ // Label 32710: @2278299
     /* 2278299 */ GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2278419),
     /* 2278304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2278307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2278310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278322 */   GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2278370), // Rule ID 53820 //
     /* 2278327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2278330 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2278333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2278347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278369 */     // GIR_Coverage, 53820,
     /* 2278369 */     GIR_EraseRootFromParent_Done,
     /* 2278370 */   // Label 32753: @2278370
     /* 2278370 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2278418), // Rule ID 53821 //
     /* 2278375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2278378 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2278381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2278395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278417 */     // GIR_Coverage, 53821,
     /* 2278417 */     GIR_EraseRootFromParent_Done,
     /* 2278418 */   // Label 32754: @2278418
     /* 2278418 */   GIM_Reject,
     /* 2278419 */ // Label 32752: @2278419
     /* 2278419 */ GIM_Reject,
     /* 2278420 */ // Label 32711: @2278420
     /* 2278420 */ GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2278540),
     /* 2278425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2278428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2278431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278443 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2278491), // Rule ID 53712 //
     /* 2278448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2278451 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2278454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2278468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278490 */     // GIR_Coverage, 53712,
     /* 2278490 */     GIR_EraseRootFromParent_Done,
     /* 2278491 */   // Label 32756: @2278491
     /* 2278491 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2278539), // Rule ID 53713 //
     /* 2278496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2278499 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2278502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2278516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278538 */     // GIR_Coverage, 53713,
     /* 2278538 */     GIR_EraseRootFromParent_Done,
     /* 2278539 */   // Label 32757: @2278539
     /* 2278539 */   GIM_Reject,
     /* 2278540 */ // Label 32755: @2278540
     /* 2278540 */ GIM_Reject,
     /* 2278541 */ // Label 32712: @2278541
     /* 2278541 */ GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2278661),
     /* 2278546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2278549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2278552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278564 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2278612), // Rule ID 53784 //
     /* 2278569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2278572 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2278575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2278589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278611 */     // GIR_Coverage, 53784,
     /* 2278611 */     GIR_EraseRootFromParent_Done,
     /* 2278612 */   // Label 32759: @2278612
     /* 2278612 */   GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2278660), // Rule ID 53785 //
     /* 2278617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2278620 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2278623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2278637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278659 */     // GIR_Coverage, 53785,
     /* 2278659 */     GIR_EraseRootFromParent_Done,
     /* 2278660 */   // Label 32760: @2278660
     /* 2278660 */   GIM_Reject,
     /* 2278661 */ // Label 32758: @2278661
     /* 2278661 */ GIM_Reject,
     /* 2278662 */ // Label 32713: @2278662
     /* 2278662 */ GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2278782),
     /* 2278667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2278670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2278673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278685 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2278733), // Rule ID 53832 //
     /* 2278690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2278693 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2278696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2278710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278732 */     // GIR_Coverage, 53832,
     /* 2278732 */     GIR_EraseRootFromParent_Done,
     /* 2278733 */   // Label 32762: @2278733
     /* 2278733 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2278781), // Rule ID 53833 //
     /* 2278738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2278741 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2278744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2278758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278780 */     // GIR_Coverage, 53833,
     /* 2278780 */     GIR_EraseRootFromParent_Done,
     /* 2278781 */   // Label 32763: @2278781
     /* 2278781 */   GIM_Reject,
     /* 2278782 */ // Label 32761: @2278782
     /* 2278782 */ GIM_Reject,
     /* 2278783 */ // Label 32714: @2278783
     /* 2278783 */ GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2278903),
     /* 2278788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2278791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2278794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278806 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2278854), // Rule ID 53748 //
     /* 2278811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2278814 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2278831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278853 */     // GIR_Coverage, 53748,
     /* 2278853 */     GIR_EraseRootFromParent_Done,
     /* 2278854 */   // Label 32765: @2278854
     /* 2278854 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2278902), // Rule ID 53749 //
     /* 2278859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2278862 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2278879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278901 */     // GIR_Coverage, 53749,
     /* 2278901 */     GIR_EraseRootFromParent_Done,
     /* 2278902 */   // Label 32766: @2278902
     /* 2278902 */   GIM_Reject,
     /* 2278903 */ // Label 32764: @2278903
     /* 2278903 */ GIM_Reject,
     /* 2278904 */ // Label 32715: @2278904
     /* 2278904 */ GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2279024),
     /* 2278909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2278912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2278915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278927 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2278975), // Rule ID 53796 //
     /* 2278932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2278935 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2278952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2278964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278974 */     // GIR_Coverage, 53796,
     /* 2278974 */     GIR_EraseRootFromParent_Done,
     /* 2278975 */   // Label 32768: @2278975
     /* 2278975 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2279023), // Rule ID 53797 //
     /* 2278980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2278983 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2279000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279022 */     // GIR_Coverage, 53797,
     /* 2279022 */     GIR_EraseRootFromParent_Done,
     /* 2279023 */   // Label 32769: @2279023
     /* 2279023 */   GIM_Reject,
     /* 2279024 */ // Label 32767: @2279024
     /* 2279024 */ GIM_Reject,
     /* 2279025 */ // Label 32716: @2279025
     /* 2279025 */ GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2279145),
     /* 2279030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2279033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2279036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279048 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2279096), // Rule ID 53844 //
     /* 2279053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2279056 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2279059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2279073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279095 */     // GIR_Coverage, 53844,
     /* 2279095 */     GIR_EraseRootFromParent_Done,
     /* 2279096 */   // Label 32771: @2279096
     /* 2279096 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2279144), // Rule ID 53845 //
     /* 2279101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2279104 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2279107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2279121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279143 */     // GIR_Coverage, 53845,
     /* 2279143 */     GIR_EraseRootFromParent_Done,
     /* 2279144 */   // Label 32772: @2279144
     /* 2279144 */   GIM_Reject,
     /* 2279145 */ // Label 32770: @2279145
     /* 2279145 */ GIM_Reject,
     /* 2279146 */ // Label 32717: @2279146
     /* 2279146 */ GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2279266),
     /* 2279151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2279154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2279157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279169 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2279217), // Rule ID 53760 //
     /* 2279174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2279177 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2279180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2279194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279216 */     // GIR_Coverage, 53760,
     /* 2279216 */     GIR_EraseRootFromParent_Done,
     /* 2279217 */   // Label 32774: @2279217
     /* 2279217 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2279265), // Rule ID 53761 //
     /* 2279222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2279225 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2279228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2279242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279264 */     // GIR_Coverage, 53761,
     /* 2279264 */     GIR_EraseRootFromParent_Done,
     /* 2279265 */   // Label 32775: @2279265
     /* 2279265 */   GIM_Reject,
     /* 2279266 */ // Label 32773: @2279266
     /* 2279266 */ GIM_Reject,
     /* 2279267 */ // Label 32718: @2279267
     /* 2279267 */ GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2279387),
     /* 2279272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2279275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2279278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279290 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2279338), // Rule ID 53808 //
     /* 2279295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2279298 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2279301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2279315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279337 */     // GIR_Coverage, 53808,
     /* 2279337 */     GIR_EraseRootFromParent_Done,
     /* 2279338 */   // Label 32777: @2279338
     /* 2279338 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2279386), // Rule ID 53809 //
     /* 2279343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2279346 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2279349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2279363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279385 */     // GIR_Coverage, 53809,
     /* 2279385 */     GIR_EraseRootFromParent_Done,
     /* 2279386 */   // Label 32778: @2279386
     /* 2279386 */   GIM_Reject,
     /* 2279387 */ // Label 32776: @2279387
     /* 2279387 */ GIM_Reject,
     /* 2279388 */ // Label 32719: @2279388
     /* 2279388 */ GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2279508),
     /* 2279393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2279396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2279399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279411 */   GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2279459), // Rule ID 53772 //
     /* 2279416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2279419 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2279436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279458 */     // GIR_Coverage, 53772,
     /* 2279458 */     GIR_EraseRootFromParent_Done,
     /* 2279459 */   // Label 32780: @2279459
     /* 2279459 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2279507), // Rule ID 53773 //
     /* 2279464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2279467 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2279484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279506 */     // GIR_Coverage, 53773,
     /* 2279506 */     GIR_EraseRootFromParent_Done,
     /* 2279507 */   // Label 32781: @2279507
     /* 2279507 */   GIM_Reject,
     /* 2279508 */ // Label 32779: @2279508
     /* 2279508 */ GIM_Reject,
     /* 2279509 */ // Label 32720: @2279509
     /* 2279509 */ GIM_Reject,
     /* 2279510 */ // Label 97: @2279510
     /* 2279510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32800*/ GIMT_Encode4(2281937),
     /* 2279521 */ /*GILLT_s16*//*Label 32782*/ GIMT_Encode4(2279641),
     /* 2279525 */ /*GILLT_s32*//*Label 32783*/ GIMT_Encode4(2279790),
     /* 2279529 */ /*GILLT_s64*//*Label 32784*/ GIMT_Encode4(2279939), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279541 */ /*GILLT_nxv1s16*//*Label 32785*/ GIMT_Encode4(2280122),
     /* 2279545 */ /*GILLT_nxv1s32*//*Label 32786*/ GIMT_Encode4(2280243),
     /* 2279549 */ /*GILLT_nxv1s64*//*Label 32787*/ GIMT_Encode4(2280364), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279561 */ /*GILLT_nxv2s16*//*Label 32788*/ GIMT_Encode4(2280485),
     /* 2279565 */ /*GILLT_nxv2s32*//*Label 32789*/ GIMT_Encode4(2280606),
     /* 2279569 */ /*GILLT_nxv2s64*//*Label 32790*/ GIMT_Encode4(2280727), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279581 */ /*GILLT_nxv4s16*//*Label 32791*/ GIMT_Encode4(2280848),
     /* 2279585 */ /*GILLT_nxv4s32*//*Label 32792*/ GIMT_Encode4(2280969),
     /* 2279589 */ /*GILLT_nxv4s64*//*Label 32793*/ GIMT_Encode4(2281090), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279601 */ /*GILLT_nxv8s16*//*Label 32794*/ GIMT_Encode4(2281211),
     /* 2279605 */ /*GILLT_nxv8s32*//*Label 32795*/ GIMT_Encode4(2281332),
     /* 2279609 */ /*GILLT_nxv8s64*//*Label 32796*/ GIMT_Encode4(2281453), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279621 */ /*GILLT_nxv16s16*//*Label 32797*/ GIMT_Encode4(2281574),
     /* 2279625 */ /*GILLT_nxv16s32*//*Label 32798*/ GIMT_Encode4(2281695), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279637 */ /*GILLT_nxv32s16*//*Label 32799*/ GIMT_Encode4(2281816),
     /* 2279641 */ // Label 32782: @2279641
     /* 2279641 */ GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2279789),
     /* 2279646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2279649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2279652 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2279686), // Rule ID 1838 //
     /* 2279657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2279660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279672 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2279672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2279675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279685 */     // GIR_Coverage, 1838,
     /* 2279685 */     GIR_EraseRootFromParent_Done,
     /* 2279686 */   // Label 32802: @2279686
     /* 2279686 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2279720), // Rule ID 1839 //
     /* 2279691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2279694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2279706 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2279706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2279709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279719 */     // GIR_Coverage, 1839,
     /* 2279719 */     GIR_EraseRootFromParent_Done,
     /* 2279720 */   // Label 32803: @2279720
     /* 2279720 */   GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2279754), // Rule ID 1842 //
     /* 2279725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2279728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279740 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2279740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2279743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279753 */     // GIR_Coverage, 1842,
     /* 2279753 */     GIR_EraseRootFromParent_Done,
     /* 2279754 */   // Label 32804: @2279754
     /* 2279754 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2279788), // Rule ID 1843 //
     /* 2279759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2279762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2279774 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2279774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2279777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279787 */     // GIR_Coverage, 1843,
     /* 2279787 */     GIR_EraseRootFromParent_Done,
     /* 2279788 */   // Label 32805: @2279788
     /* 2279788 */   GIM_Reject,
     /* 2279789 */ // Label 32801: @2279789
     /* 2279789 */ GIM_Reject,
     /* 2279790 */ // Label 32783: @2279790
     /* 2279790 */ GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2279938),
     /* 2279795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279801 */   GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2279835), // Rule ID 1129 //
     /* 2279806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2279809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279821 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2279821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2279824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279834 */     // GIR_Coverage, 1129,
     /* 2279834 */     GIR_EraseRootFromParent_Done,
     /* 2279835 */   // Label 32807: @2279835
     /* 2279835 */   GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2279869), // Rule ID 1130 //
     /* 2279840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2279843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2279855 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2279855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2279858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279868 */     // GIR_Coverage, 1130,
     /* 2279868 */     GIR_EraseRootFromParent_Done,
     /* 2279869 */   // Label 32808: @2279869
     /* 2279869 */   GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2279903), // Rule ID 1133 //
     /* 2279874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2279877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279889 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2279889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2279892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279902 */     // GIR_Coverage, 1133,
     /* 2279902 */     GIR_EraseRootFromParent_Done,
     /* 2279903 */   // Label 32809: @2279903
     /* 2279903 */   GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2279937), // Rule ID 1134 //
     /* 2279908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2279911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2279923 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2279923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2279926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279936 */     // GIR_Coverage, 1134,
     /* 2279936 */     GIR_EraseRootFromParent_Done,
     /* 2279937 */   // Label 32810: @2279937
     /* 2279937 */   GIM_Reject,
     /* 2279938 */ // Label 32806: @2279938
     /* 2279938 */ GIM_Reject,
     /* 2279939 */ // Label 32784: @2279939
     /* 2279939 */ GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2280121),
     /* 2279944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279950 */   GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2279984), // Rule ID 1470 //
     /* 2279955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2279958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2279962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2279966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2279970 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2279970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2279973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2279982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279983 */     // GIR_Coverage, 1470,
     /* 2279983 */     GIR_EraseRootFromParent_Done,
     /* 2279984 */   // Label 32812: @2279984
     /* 2279984 */   GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2280018), // Rule ID 1471 //
     /* 2279989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2279992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2279996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2280000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2280004 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2280004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2280007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280017 */     // GIR_Coverage, 1471,
     /* 2280017 */     GIR_EraseRootFromParent_Done,
     /* 2280018 */   // Label 32813: @2280018
     /* 2280018 */   GIM_Try, /*On fail goto*//*Label 32814*/ GIMT_Encode4(2280052), // Rule ID 1474 //
     /* 2280023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2280026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280038 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2280038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2280041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280051 */     // GIR_Coverage, 1474,
     /* 2280051 */     GIR_EraseRootFromParent_Done,
     /* 2280052 */   // Label 32814: @2280052
     /* 2280052 */   GIM_Try, /*On fail goto*//*Label 32815*/ GIMT_Encode4(2280086), // Rule ID 1475 //
     /* 2280057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2280060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2280072 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2280072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2280075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280085 */     // GIR_Coverage, 1475,
     /* 2280085 */     GIR_EraseRootFromParent_Done,
     /* 2280086 */   // Label 32815: @2280086
     /* 2280086 */   GIM_Try, /*On fail goto*//*Label 32816*/ GIMT_Encode4(2280120), // Rule ID 1478 //
     /* 2280091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2280094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2280098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2280102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2280106 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2280106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2280109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280119 */     // GIR_Coverage, 1478,
     /* 2280119 */     GIR_EraseRootFromParent_Done,
     /* 2280120 */   // Label 32816: @2280120
     /* 2280120 */   GIM_Reject,
     /* 2280121 */ // Label 32811: @2280121
     /* 2280121 */ GIM_Reject,
     /* 2280122 */ // Label 32785: @2280122
     /* 2280122 */ GIM_Try, /*On fail goto*//*Label 32817*/ GIMT_Encode4(2280242),
     /* 2280127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2280130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2280133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280145 */   GIM_Try, /*On fail goto*//*Label 32818*/ GIMT_Encode4(2280193), // Rule ID 53856 //
     /* 2280150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2280153 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2280156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2280170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280192 */     // GIR_Coverage, 53856,
     /* 2280192 */     GIR_EraseRootFromParent_Done,
     /* 2280193 */   // Label 32818: @2280193
     /* 2280193 */   GIM_Try, /*On fail goto*//*Label 32819*/ GIMT_Encode4(2280241), // Rule ID 53857 //
     /* 2280198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2280201 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2280204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2280218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280240 */     // GIR_Coverage, 53857,
     /* 2280240 */     GIR_EraseRootFromParent_Done,
     /* 2280241 */   // Label 32819: @2280241
     /* 2280241 */   GIM_Reject,
     /* 2280242 */ // Label 32817: @2280242
     /* 2280242 */ GIM_Reject,
     /* 2280243 */ // Label 32786: @2280243
     /* 2280243 */ GIM_Try, /*On fail goto*//*Label 32820*/ GIMT_Encode4(2280363),
     /* 2280248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2280251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2280254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280266 */   GIM_Try, /*On fail goto*//*Label 32821*/ GIMT_Encode4(2280314), // Rule ID 53880 //
     /* 2280271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2280274 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2280277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2280291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280313 */     // GIR_Coverage, 53880,
     /* 2280313 */     GIR_EraseRootFromParent_Done,
     /* 2280314 */   // Label 32821: @2280314
     /* 2280314 */   GIM_Try, /*On fail goto*//*Label 32822*/ GIMT_Encode4(2280362), // Rule ID 53881 //
     /* 2280319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2280322 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2280325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2280339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280361 */     // GIR_Coverage, 53881,
     /* 2280361 */     GIR_EraseRootFromParent_Done,
     /* 2280362 */   // Label 32822: @2280362
     /* 2280362 */   GIM_Reject,
     /* 2280363 */ // Label 32820: @2280363
     /* 2280363 */ GIM_Reject,
     /* 2280364 */ // Label 32787: @2280364
     /* 2280364 */ GIM_Try, /*On fail goto*//*Label 32823*/ GIMT_Encode4(2280484),
     /* 2280369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2280372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2280375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280387 */   GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2280435), // Rule ID 53916 //
     /* 2280392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2280395 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2280398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2280412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280434 */     // GIR_Coverage, 53916,
     /* 2280434 */     GIR_EraseRootFromParent_Done,
     /* 2280435 */   // Label 32824: @2280435
     /* 2280435 */   GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2280483), // Rule ID 53917 //
     /* 2280440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2280443 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2280446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2280460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280482 */     // GIR_Coverage, 53917,
     /* 2280482 */     GIR_EraseRootFromParent_Done,
     /* 2280483 */   // Label 32825: @2280483
     /* 2280483 */   GIM_Reject,
     /* 2280484 */ // Label 32823: @2280484
     /* 2280484 */ GIM_Reject,
     /* 2280485 */ // Label 32788: @2280485
     /* 2280485 */ GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2280605),
     /* 2280490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2280493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2280496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280508 */   GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2280556), // Rule ID 53868 //
     /* 2280513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2280516 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2280533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280555 */     // GIR_Coverage, 53868,
     /* 2280555 */     GIR_EraseRootFromParent_Done,
     /* 2280556 */   // Label 32827: @2280556
     /* 2280556 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2280604), // Rule ID 53869 //
     /* 2280561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2280564 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2280581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280603 */     // GIR_Coverage, 53869,
     /* 2280603 */     GIR_EraseRootFromParent_Done,
     /* 2280604 */   // Label 32828: @2280604
     /* 2280604 */   GIM_Reject,
     /* 2280605 */ // Label 32826: @2280605
     /* 2280605 */ GIM_Reject,
     /* 2280606 */ // Label 32789: @2280606
     /* 2280606 */ GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2280726),
     /* 2280611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2280614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2280617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280629 */   GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2280677), // Rule ID 53904 //
     /* 2280634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2280637 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2280654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280676 */     // GIR_Coverage, 53904,
     /* 2280676 */     GIR_EraseRootFromParent_Done,
     /* 2280677 */   // Label 32830: @2280677
     /* 2280677 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2280725), // Rule ID 53905 //
     /* 2280682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2280685 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2280702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280724 */     // GIR_Coverage, 53905,
     /* 2280724 */     GIR_EraseRootFromParent_Done,
     /* 2280725 */   // Label 32831: @2280725
     /* 2280725 */   GIM_Reject,
     /* 2280726 */ // Label 32829: @2280726
     /* 2280726 */ GIM_Reject,
     /* 2280727 */ // Label 32790: @2280727
     /* 2280727 */ GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2280847),
     /* 2280732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2280735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2280738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280750 */   GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2280798), // Rule ID 54000 //
     /* 2280755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2280758 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2280775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280797 */     // GIR_Coverage, 54000,
     /* 2280797 */     GIR_EraseRootFromParent_Done,
     /* 2280798 */   // Label 32833: @2280798
     /* 2280798 */   GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2280846), // Rule ID 54001 //
     /* 2280803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2280806 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2280823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280845 */     // GIR_Coverage, 54001,
     /* 2280845 */     GIR_EraseRootFromParent_Done,
     /* 2280846 */   // Label 32834: @2280846
     /* 2280846 */   GIM_Reject,
     /* 2280847 */ // Label 32832: @2280847
     /* 2280847 */ GIM_Reject,
     /* 2280848 */ // Label 32791: @2280848
     /* 2280848 */ GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2280968),
     /* 2280853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2280856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2280859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280871 */   GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2280919), // Rule ID 53892 //
     /* 2280876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2280879 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2280896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280918 */     // GIR_Coverage, 53892,
     /* 2280918 */     GIR_EraseRootFromParent_Done,
     /* 2280919 */   // Label 32836: @2280919
     /* 2280919 */   GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2280967), // Rule ID 53893 //
     /* 2280924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2280927 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2280944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2280956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280966 */     // GIR_Coverage, 53893,
     /* 2280966 */     GIR_EraseRootFromParent_Done,
     /* 2280967 */   // Label 32837: @2280967
     /* 2280967 */   GIM_Reject,
     /* 2280968 */ // Label 32835: @2280968
     /* 2280968 */ GIM_Reject,
     /* 2280969 */ // Label 32792: @2280969
     /* 2280969 */ GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2281089),
     /* 2280974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2280977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2280980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280992 */   GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2281040), // Rule ID 53964 //
     /* 2280997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2281000 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2281003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2281017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281039 */     // GIR_Coverage, 53964,
     /* 2281039 */     GIR_EraseRootFromParent_Done,
     /* 2281040 */   // Label 32839: @2281040
     /* 2281040 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2281088), // Rule ID 53965 //
     /* 2281045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2281048 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2281051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2281065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281087 */     // GIR_Coverage, 53965,
     /* 2281087 */     GIR_EraseRootFromParent_Done,
     /* 2281088 */   // Label 32840: @2281088
     /* 2281088 */   GIM_Reject,
     /* 2281089 */ // Label 32838: @2281089
     /* 2281089 */ GIM_Reject,
     /* 2281090 */ // Label 32793: @2281090
     /* 2281090 */ GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2281210),
     /* 2281095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2281098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2281101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281113 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2281161), // Rule ID 54012 //
     /* 2281118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2281121 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2281124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2281138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281160 */     // GIR_Coverage, 54012,
     /* 2281160 */     GIR_EraseRootFromParent_Done,
     /* 2281161 */   // Label 32842: @2281161
     /* 2281161 */   GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2281209), // Rule ID 54013 //
     /* 2281166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2281169 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2281172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2281186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281208 */     // GIR_Coverage, 54013,
     /* 2281208 */     GIR_EraseRootFromParent_Done,
     /* 2281209 */   // Label 32843: @2281209
     /* 2281209 */   GIM_Reject,
     /* 2281210 */ // Label 32841: @2281210
     /* 2281210 */ GIM_Reject,
     /* 2281211 */ // Label 32794: @2281211
     /* 2281211 */ GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2281331),
     /* 2281216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2281219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2281222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281234 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2281282), // Rule ID 53928 //
     /* 2281239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2281242 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2281259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281281 */     // GIR_Coverage, 53928,
     /* 2281281 */     GIR_EraseRootFromParent_Done,
     /* 2281282 */   // Label 32845: @2281282
     /* 2281282 */   GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2281330), // Rule ID 53929 //
     /* 2281287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2281290 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2281307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281329 */     // GIR_Coverage, 53929,
     /* 2281329 */     GIR_EraseRootFromParent_Done,
     /* 2281330 */   // Label 32846: @2281330
     /* 2281330 */   GIM_Reject,
     /* 2281331 */ // Label 32844: @2281331
     /* 2281331 */ GIM_Reject,
     /* 2281332 */ // Label 32795: @2281332
     /* 2281332 */ GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2281452),
     /* 2281337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2281340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2281343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281355 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2281403), // Rule ID 53976 //
     /* 2281360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2281363 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2281380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281402 */     // GIR_Coverage, 53976,
     /* 2281402 */     GIR_EraseRootFromParent_Done,
     /* 2281403 */   // Label 32848: @2281403
     /* 2281403 */   GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2281451), // Rule ID 53977 //
     /* 2281408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2281411 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2281428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281450 */     // GIR_Coverage, 53977,
     /* 2281450 */     GIR_EraseRootFromParent_Done,
     /* 2281451 */   // Label 32849: @2281451
     /* 2281451 */   GIM_Reject,
     /* 2281452 */ // Label 32847: @2281452
     /* 2281452 */ GIM_Reject,
     /* 2281453 */ // Label 32796: @2281453
     /* 2281453 */ GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2281573),
     /* 2281458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2281461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2281464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281476 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2281524), // Rule ID 54024 //
     /* 2281481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2281484 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2281501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281523 */     // GIR_Coverage, 54024,
     /* 2281523 */     GIR_EraseRootFromParent_Done,
     /* 2281524 */   // Label 32851: @2281524
     /* 2281524 */   GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2281572), // Rule ID 54025 //
     /* 2281529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2281532 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2281549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281571 */     // GIR_Coverage, 54025,
     /* 2281571 */     GIR_EraseRootFromParent_Done,
     /* 2281572 */   // Label 32852: @2281572
     /* 2281572 */   GIM_Reject,
     /* 2281573 */ // Label 32850: @2281573
     /* 2281573 */ GIM_Reject,
     /* 2281574 */ // Label 32797: @2281574
     /* 2281574 */ GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2281694),
     /* 2281579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2281582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2281585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281597 */   GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2281645), // Rule ID 53940 //
     /* 2281602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2281605 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2281622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281644 */     // GIR_Coverage, 53940,
     /* 2281644 */     GIR_EraseRootFromParent_Done,
     /* 2281645 */   // Label 32854: @2281645
     /* 2281645 */   GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2281693), // Rule ID 53941 //
     /* 2281650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2281653 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2281670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281692 */     // GIR_Coverage, 53941,
     /* 2281692 */     GIR_EraseRootFromParent_Done,
     /* 2281693 */   // Label 32855: @2281693
     /* 2281693 */   GIM_Reject,
     /* 2281694 */ // Label 32853: @2281694
     /* 2281694 */ GIM_Reject,
     /* 2281695 */ // Label 32798: @2281695
     /* 2281695 */ GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2281815),
     /* 2281700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2281703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2281706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281718 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2281766), // Rule ID 53988 //
     /* 2281723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2281726 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2281743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281765 */     // GIR_Coverage, 53988,
     /* 2281765 */     GIR_EraseRootFromParent_Done,
     /* 2281766 */   // Label 32857: @2281766
     /* 2281766 */   GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2281814), // Rule ID 53989 //
     /* 2281771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2281774 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2281791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281813 */     // GIR_Coverage, 53989,
     /* 2281813 */     GIR_EraseRootFromParent_Done,
     /* 2281814 */   // Label 32858: @2281814
     /* 2281814 */   GIM_Reject,
     /* 2281815 */ // Label 32856: @2281815
     /* 2281815 */ GIM_Reject,
     /* 2281816 */ // Label 32799: @2281816
     /* 2281816 */ GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2281936),
     /* 2281821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2281824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2281827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281839 */   GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2281887), // Rule ID 53952 //
     /* 2281844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2281847 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2281864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281886 */     // GIR_Coverage, 53952,
     /* 2281886 */     GIR_EraseRootFromParent_Done,
     /* 2281887 */   // Label 32860: @2281887
     /* 2281887 */   GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2281935), // Rule ID 53953 //
     /* 2281892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2281895 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2281912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281934 */     // GIR_Coverage, 53953,
     /* 2281934 */     GIR_EraseRootFromParent_Done,
     /* 2281935 */   // Label 32861: @2281935
     /* 2281935 */   GIM_Reject,
     /* 2281936 */ // Label 32859: @2281936
     /* 2281936 */ GIM_Reject,
     /* 2281937 */ // Label 32800: @2281937
     /* 2281937 */ GIM_Reject,
     /* 2281938 */ // Label 98: @2281938
     /* 2281938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32880*/ GIMT_Encode4(2298582),
     /* 2281949 */ /*GILLT_s16*//*Label 32862*/ GIMT_Encode4(2282069),
     /* 2281953 */ /*GILLT_s32*//*Label 32863*/ GIMT_Encode4(2283505),
     /* 2281957 */ /*GILLT_s64*//*Label 32864*/ GIMT_Encode4(2284941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2281969 */ /*GILLT_nxv1s16*//*Label 32865*/ GIMT_Encode4(2286732),
     /* 2281973 */ /*GILLT_nxv1s32*//*Label 32866*/ GIMT_Encode4(2287522),
     /* 2281977 */ /*GILLT_nxv1s64*//*Label 32867*/ GIMT_Encode4(2288312), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2281989 */ /*GILLT_nxv2s16*//*Label 32868*/ GIMT_Encode4(2289102),
     /* 2281993 */ /*GILLT_nxv2s32*//*Label 32869*/ GIMT_Encode4(2289892),
     /* 2281997 */ /*GILLT_nxv2s64*//*Label 32870*/ GIMT_Encode4(2290682), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2282009 */ /*GILLT_nxv4s16*//*Label 32871*/ GIMT_Encode4(2291472),
     /* 2282013 */ /*GILLT_nxv4s32*//*Label 32872*/ GIMT_Encode4(2292262),
     /* 2282017 */ /*GILLT_nxv4s64*//*Label 32873*/ GIMT_Encode4(2293052), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2282029 */ /*GILLT_nxv8s16*//*Label 32874*/ GIMT_Encode4(2293842),
     /* 2282033 */ /*GILLT_nxv8s32*//*Label 32875*/ GIMT_Encode4(2294632),
     /* 2282037 */ /*GILLT_nxv8s64*//*Label 32876*/ GIMT_Encode4(2295422), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2282049 */ /*GILLT_nxv16s16*//*Label 32877*/ GIMT_Encode4(2296212),
     /* 2282053 */ /*GILLT_nxv16s32*//*Label 32878*/ GIMT_Encode4(2297002), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2282065 */ /*GILLT_nxv32s16*//*Label 32879*/ GIMT_Encode4(2297792),
     /* 2282069 */ // Label 32862: @2282069
     /* 2282069 */ GIM_Try, /*On fail goto*//*Label 32881*/ GIMT_Encode4(2283504),
     /* 2282074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2282080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2282083 */   GIM_Try, /*On fail goto*//*Label 32882*/ GIMT_Encode4(2282155), // Rule ID 1871 //
     /* 2282088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2282091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282135 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2282138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282154 */     // GIR_Coverage, 1871,
     /* 2282154 */     GIR_EraseRootFromParent_Done,
     /* 2282155 */   // Label 32882: @2282155
     /* 2282155 */   GIM_Try, /*On fail goto*//*Label 32883*/ GIMT_Encode4(2282227), // Rule ID 1872 //
     /* 2282160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2282163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282207 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2282210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282226 */     // GIR_Coverage, 1872,
     /* 2282226 */     GIR_EraseRootFromParent_Done,
     /* 2282227 */   // Label 32883: @2282227
     /* 2282227 */   GIM_Try, /*On fail goto*//*Label 32884*/ GIMT_Encode4(2282299), // Rule ID 1904 //
     /* 2282232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2282235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282279 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2282282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282298 */     // GIR_Coverage, 1904,
     /* 2282298 */     GIR_EraseRootFromParent_Done,
     /* 2282299 */   // Label 32884: @2282299
     /* 2282299 */   GIM_Try, /*On fail goto*//*Label 32885*/ GIMT_Encode4(2282371), // Rule ID 1905 //
     /* 2282304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2282307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282351 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2282354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282370 */     // GIR_Coverage, 1905,
     /* 2282370 */     GIR_EraseRootFromParent_Done,
     /* 2282371 */   // Label 32885: @2282371
     /* 2282371 */   GIM_Try, /*On fail goto*//*Label 32886*/ GIMT_Encode4(2282443), // Rule ID 64031 //
     /* 2282376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2282379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282423 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2282426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282442 */     // GIR_Coverage, 64031,
     /* 2282442 */     GIR_EraseRootFromParent_Done,
     /* 2282443 */   // Label 32886: @2282443
     /* 2282443 */   GIM_Try, /*On fail goto*//*Label 32887*/ GIMT_Encode4(2282515), // Rule ID 64032 //
     /* 2282448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2282451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282495 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2282498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282514 */     // GIR_Coverage, 64032,
     /* 2282514 */     GIR_EraseRootFromParent_Done,
     /* 2282515 */   // Label 32887: @2282515
     /* 2282515 */   GIM_Try, /*On fail goto*//*Label 32888*/ GIMT_Encode4(2282587), // Rule ID 64039 //
     /* 2282520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2282523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282567 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2282570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282586 */     // GIR_Coverage, 64039,
     /* 2282586 */     GIR_EraseRootFromParent_Done,
     /* 2282587 */   // Label 32888: @2282587
     /* 2282587 */   GIM_Try, /*On fail goto*//*Label 32889*/ GIMT_Encode4(2282659), // Rule ID 64040 //
     /* 2282592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2282595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2282624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2282639 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2282642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2282654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282658 */     // GIR_Coverage, 64040,
     /* 2282658 */     GIR_EraseRootFromParent_Done,
     /* 2282659 */   // Label 32889: @2282659
     /* 2282659 */   GIM_Try, /*On fail goto*//*Label 32890*/ GIMT_Encode4(2282716), // Rule ID 1867 //
     /* 2282664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2282667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282698 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2282701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282715 */     // GIR_Coverage, 1867,
     /* 2282715 */     GIR_EraseRootFromParent_Done,
     /* 2282716 */   // Label 32890: @2282716
     /* 2282716 */   GIM_Try, /*On fail goto*//*Label 32891*/ GIMT_Encode4(2282773), // Rule ID 1868 //
     /* 2282721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2282724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282755 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2282758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282772 */     // GIR_Coverage, 1868,
     /* 2282772 */     GIR_EraseRootFromParent_Done,
     /* 2282773 */   // Label 32891: @2282773
     /* 2282773 */   GIM_Try, /*On fail goto*//*Label 32892*/ GIMT_Encode4(2282830), // Rule ID 1900 //
     /* 2282778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2282781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282812 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2282815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282829 */     // GIR_Coverage, 1900,
     /* 2282829 */     GIR_EraseRootFromParent_Done,
     /* 2282830 */   // Label 32892: @2282830
     /* 2282830 */   GIM_Try, /*On fail goto*//*Label 32893*/ GIMT_Encode4(2282887), // Rule ID 1901 //
     /* 2282835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2282838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2282867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282869 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2282872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282886 */     // GIR_Coverage, 1901,
     /* 2282886 */     GIR_EraseRootFromParent_Done,
     /* 2282887 */   // Label 32893: @2282887
     /* 2282887 */   GIM_Try, /*On fail goto*//*Label 32894*/ GIMT_Encode4(2282944), // Rule ID 64027 //
     /* 2282892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2282895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282926 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2282926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2282929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282943 */     // GIR_Coverage, 64027,
     /* 2282943 */     GIR_EraseRootFromParent_Done,
     /* 2282944 */   // Label 32894: @2282944
     /* 2282944 */   GIM_Try, /*On fail goto*//*Label 32895*/ GIMT_Encode4(2283001), // Rule ID 64028 //
     /* 2282949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2282952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2282964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2282968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2282972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2282981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2282983 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2282983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2282986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2282992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2282994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2282996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283000 */     // GIR_Coverage, 64028,
     /* 2283000 */     GIR_EraseRootFromParent_Done,
     /* 2283001 */   // Label 32895: @2283001
     /* 2283001 */   GIM_Try, /*On fail goto*//*Label 32896*/ GIMT_Encode4(2283058), // Rule ID 64035 //
     /* 2283006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2283009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2283021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283040 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2283040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2283043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2283051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283057 */     // GIR_Coverage, 64035,
     /* 2283057 */     GIR_EraseRootFromParent_Done,
     /* 2283058 */   // Label 32896: @2283058
     /* 2283058 */   GIM_Try, /*On fail goto*//*Label 32897*/ GIMT_Encode4(2283115), // Rule ID 64036 //
     /* 2283063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2283066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2283078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283097 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2283097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2283100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2283108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283114 */     // GIR_Coverage, 64036,
     /* 2283114 */     GIR_EraseRootFromParent_Done,
     /* 2283115 */   // Label 32897: @2283115
     /* 2283115 */   GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2283172), // Rule ID 1863 //
     /* 2283120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2283123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2283139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283154 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2283154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2283157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2283167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283171 */     // GIR_Coverage, 1863,
     /* 2283171 */     GIR_EraseRootFromParent_Done,
     /* 2283172 */   // Label 32898: @2283172
     /* 2283172 */   GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2283229), // Rule ID 1864 //
     /* 2283177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2283180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2283196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283211 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2283211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2283214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2283224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283228 */     // GIR_Coverage, 1864,
     /* 2283228 */     GIR_EraseRootFromParent_Done,
     /* 2283229 */   // Label 32899: @2283229
     /* 2283229 */   GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2283286), // Rule ID 1896 //
     /* 2283234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2283237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2283253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283268 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2283268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2283271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2283281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283285 */     // GIR_Coverage, 1896,
     /* 2283285 */     GIR_EraseRootFromParent_Done,
     /* 2283286 */   // Label 32900: @2283286
     /* 2283286 */   GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2283343), // Rule ID 1897 //
     /* 2283291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2283294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2283310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283325 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2283325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2283328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2283338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283342 */     // GIR_Coverage, 1897,
     /* 2283342 */     GIR_EraseRootFromParent_Done,
     /* 2283343 */   // Label 32901: @2283343
     /* 2283343 */   GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2283383), // Rule ID 1859 //
     /* 2283348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2283351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283367 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2283367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2283370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283382 */     // GIR_Coverage, 1859,
     /* 2283382 */     GIR_EraseRootFromParent_Done,
     /* 2283383 */   // Label 32902: @2283383
     /* 2283383 */   GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2283423), // Rule ID 1860 //
     /* 2283388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2283391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283407 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2283407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2283410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283422 */     // GIR_Coverage, 1860,
     /* 2283422 */     GIR_EraseRootFromParent_Done,
     /* 2283423 */   // Label 32903: @2283423
     /* 2283423 */   GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2283463), // Rule ID 1892 //
     /* 2283428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2283431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283447 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2283447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2283450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283462 */     // GIR_Coverage, 1892,
     /* 2283462 */     GIR_EraseRootFromParent_Done,
     /* 2283463 */   // Label 32904: @2283463
     /* 2283463 */   GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2283503), // Rule ID 1893 //
     /* 2283468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2283471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283487 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2283487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2283490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2283498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283502 */     // GIR_Coverage, 1893,
     /* 2283502 */     GIR_EraseRootFromParent_Done,
     /* 2283503 */   // Label 32905: @2283503
     /* 2283503 */   GIM_Reject,
     /* 2283504 */ // Label 32881: @2283504
     /* 2283504 */ GIM_Reject,
     /* 2283505 */ // Label 32863: @2283505
     /* 2283505 */ GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2284940),
     /* 2283510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2283516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2283519 */   GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2283591), // Rule ID 1170 //
     /* 2283524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2283527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2283535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283571 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2283571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2283574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283590 */     // GIR_Coverage, 1170,
     /* 2283590 */     GIR_EraseRootFromParent_Done,
     /* 2283591 */   // Label 32907: @2283591
     /* 2283591 */   GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2283663), // Rule ID 1171 //
     /* 2283596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2283599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2283607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283643 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2283643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2283646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283662 */     // GIR_Coverage, 1171,
     /* 2283662 */     GIR_EraseRootFromParent_Done,
     /* 2283663 */   // Label 32908: @2283663
     /* 2283663 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2283735), // Rule ID 1191 //
     /* 2283668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2283671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2283679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283715 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2283715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2283718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283734 */     // GIR_Coverage, 1191,
     /* 2283734 */     GIR_EraseRootFromParent_Done,
     /* 2283735 */   // Label 32909: @2283735
     /* 2283735 */   GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2283807), // Rule ID 1192 //
     /* 2283740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2283743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2283751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283787 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2283787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2283790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283806 */     // GIR_Coverage, 1192,
     /* 2283806 */     GIR_EraseRootFromParent_Done,
     /* 2283807 */   // Label 32910: @2283807
     /* 2283807 */   GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2283879), // Rule ID 63995 //
     /* 2283812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2283815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2283827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283859 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2283859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2283862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2283870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283878 */     // GIR_Coverage, 63995,
     /* 2283878 */     GIR_EraseRootFromParent_Done,
     /* 2283879 */   // Label 32911: @2283879
     /* 2283879 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2283951), // Rule ID 63996 //
     /* 2283884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2283887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2283899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2283931 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2283931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2283934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2283940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2283942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2283946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283950 */     // GIR_Coverage, 63996,
     /* 2283950 */     GIR_EraseRootFromParent_Done,
     /* 2283951 */   // Label 32912: @2283951
     /* 2283951 */   GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2284023), // Rule ID 64003 //
     /* 2283956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2283959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2283971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2283988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2283992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2284003 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2284006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2284018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284022 */     // GIR_Coverage, 64003,
     /* 2284022 */     GIR_EraseRootFromParent_Done,
     /* 2284023 */   // Label 32913: @2284023
     /* 2284023 */   GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2284095), // Rule ID 64004 //
     /* 2284028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2284031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2284043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2284060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2284075 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2284078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2284090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284094 */     // GIR_Coverage, 64004,
     /* 2284094 */     GIR_EraseRootFromParent_Done,
     /* 2284095 */   // Label 32914: @2284095
     /* 2284095 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2284152), // Rule ID 1166 //
     /* 2284100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2284103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2284111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284134 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2284137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284151 */     // GIR_Coverage, 1166,
     /* 2284151 */     GIR_EraseRootFromParent_Done,
     /* 2284152 */   // Label 32915: @2284152
     /* 2284152 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2284209), // Rule ID 1167 //
     /* 2284157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2284160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2284168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284191 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2284194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284208 */     // GIR_Coverage, 1167,
     /* 2284208 */     GIR_EraseRootFromParent_Done,
     /* 2284209 */   // Label 32916: @2284209
     /* 2284209 */   GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2284266), // Rule ID 1187 //
     /* 2284214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2284217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2284225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284248 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2284251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284265 */     // GIR_Coverage, 1187,
     /* 2284265 */     GIR_EraseRootFromParent_Done,
     /* 2284266 */   // Label 32917: @2284266
     /* 2284266 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2284323), // Rule ID 1188 //
     /* 2284271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2284274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2284282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284305 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2284308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284322 */     // GIR_Coverage, 1188,
     /* 2284322 */     GIR_EraseRootFromParent_Done,
     /* 2284323 */   // Label 32918: @2284323
     /* 2284323 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2284380), // Rule ID 63991 //
     /* 2284328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2284331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2284343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284362 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2284365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284379 */     // GIR_Coverage, 63991,
     /* 2284379 */     GIR_EraseRootFromParent_Done,
     /* 2284380 */   // Label 32919: @2284380
     /* 2284380 */   GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2284437), // Rule ID 63992 //
     /* 2284385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2284388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2284400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284419 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2284422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284436 */     // GIR_Coverage, 63992,
     /* 2284436 */     GIR_EraseRootFromParent_Done,
     /* 2284437 */   // Label 32920: @2284437
     /* 2284437 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2284494), // Rule ID 63999 //
     /* 2284442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2284445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2284457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284476 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2284479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284493 */     // GIR_Coverage, 63999,
     /* 2284493 */     GIR_EraseRootFromParent_Done,
     /* 2284494 */   // Label 32921: @2284494
     /* 2284494 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2284551), // Rule ID 64000 //
     /* 2284499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2284502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2284514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284533 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2284536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2284542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2284544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284550 */     // GIR_Coverage, 64000,
     /* 2284550 */     GIR_EraseRootFromParent_Done,
     /* 2284551 */   // Label 32922: @2284551
     /* 2284551 */   GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2284608), // Rule ID 1162 //
     /* 2284556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2284559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2284575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284590 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2284593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2284603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284607 */     // GIR_Coverage, 1162,
     /* 2284607 */     GIR_EraseRootFromParent_Done,
     /* 2284608 */   // Label 32923: @2284608
     /* 2284608 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2284665), // Rule ID 1163 //
     /* 2284613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2284616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2284632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284647 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2284650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2284660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284664 */     // GIR_Coverage, 1163,
     /* 2284664 */     GIR_EraseRootFromParent_Done,
     /* 2284665 */   // Label 32924: @2284665
     /* 2284665 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2284722), // Rule ID 1183 //
     /* 2284670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2284673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2284689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284704 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2284707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2284717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284721 */     // GIR_Coverage, 1183,
     /* 2284721 */     GIR_EraseRootFromParent_Done,
     /* 2284722 */   // Label 32925: @2284722
     /* 2284722 */   GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2284779), // Rule ID 1184 //
     /* 2284727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2284730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2284746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2284761 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2284764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2284774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284778 */     // GIR_Coverage, 1184,
     /* 2284778 */     GIR_EraseRootFromParent_Done,
     /* 2284779 */   // Label 32926: @2284779
     /* 2284779 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2284819), // Rule ID 1158 //
     /* 2284784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2284787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284803 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2284806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284818 */     // GIR_Coverage, 1158,
     /* 2284818 */     GIR_EraseRootFromParent_Done,
     /* 2284819 */   // Label 32927: @2284819
     /* 2284819 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2284859), // Rule ID 1159 //
     /* 2284824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2284827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2284843 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2284846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284858 */     // GIR_Coverage, 1159,
     /* 2284858 */     GIR_EraseRootFromParent_Done,
     /* 2284859 */   // Label 32928: @2284859
     /* 2284859 */   GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2284899), // Rule ID 1179 //
     /* 2284864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2284867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284883 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2284883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2284886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284898 */     // GIR_Coverage, 1179,
     /* 2284898 */     GIR_EraseRootFromParent_Done,
     /* 2284899 */   // Label 32929: @2284899
     /* 2284899 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2284939), // Rule ID 1180 //
     /* 2284904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2284907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2284923 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2284923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2284926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2284934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284938 */     // GIR_Coverage, 1180,
     /* 2284938 */     GIR_EraseRootFromParent_Done,
     /* 2284939 */   // Label 32930: @2284939
     /* 2284939 */   GIM_Reject,
     /* 2284940 */ // Label 32906: @2284940
     /* 2284940 */ GIM_Reject,
     /* 2284941 */ // Label 32864: @2284941
     /* 2284941 */ GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2286731),
     /* 2284946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2284949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2284952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2284955 */   GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2285027), // Rule ID 1507 //
     /* 2284960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2284963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2284967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2284971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2284979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2284984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2284988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2284992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2284996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285007 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2285010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285026 */     // GIR_Coverage, 1507,
     /* 2285026 */     GIR_EraseRootFromParent_Done,
     /* 2285027 */   // Label 32932: @2285027
     /* 2285027 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2285099), // Rule ID 1508 //
     /* 2285032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2285035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285079 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2285082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285098 */     // GIR_Coverage, 1508,
     /* 2285098 */     GIR_EraseRootFromParent_Done,
     /* 2285099 */   // Label 32933: @2285099
     /* 2285099 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2285171), // Rule ID 1531 //
     /* 2285104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2285107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285151 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2285154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285170 */     // GIR_Coverage, 1531,
     /* 2285170 */     GIR_EraseRootFromParent_Done,
     /* 2285171 */   // Label 32934: @2285171
     /* 2285171 */   GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2285243), // Rule ID 1562 //
     /* 2285176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2285179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285223 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2285226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285242 */     // GIR_Coverage, 1562,
     /* 2285242 */     GIR_EraseRootFromParent_Done,
     /* 2285243 */   // Label 32935: @2285243
     /* 2285243 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2285315), // Rule ID 1563 //
     /* 2285248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2285251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285295 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2285298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285314 */     // GIR_Coverage, 1563,
     /* 2285314 */     GIR_EraseRootFromParent_Done,
     /* 2285315 */   // Label 32936: @2285315
     /* 2285315 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2285387), // Rule ID 64011 //
     /* 2285320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2285323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285367 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2285370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2285378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285386 */     // GIR_Coverage, 64011,
     /* 2285386 */     GIR_EraseRootFromParent_Done,
     /* 2285387 */   // Label 32937: @2285387
     /* 2285387 */   GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2285459), // Rule ID 64012 //
     /* 2285392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2285395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285439 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2285442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2285450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285458 */     // GIR_Coverage, 64012,
     /* 2285458 */     GIR_EraseRootFromParent_Done,
     /* 2285459 */   // Label 32938: @2285459
     /* 2285459 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2285531), // Rule ID 64017 //
     /* 2285464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2285467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285511 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2285514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2285522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285530 */     // GIR_Coverage, 64017,
     /* 2285530 */     GIR_EraseRootFromParent_Done,
     /* 2285531 */   // Label 32939: @2285531
     /* 2285531 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2285603), // Rule ID 64023 //
     /* 2285536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2285539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285583 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2285586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2285594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285602 */     // GIR_Coverage, 64023,
     /* 2285602 */     GIR_EraseRootFromParent_Done,
     /* 2285603 */   // Label 32940: @2285603
     /* 2285603 */   GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2285675), // Rule ID 64024 //
     /* 2285608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2285611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2285640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2285655 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2285658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2285666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2285670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285674 */     // GIR_Coverage, 64024,
     /* 2285674 */     GIR_EraseRootFromParent_Done,
     /* 2285675 */   // Label 32941: @2285675
     /* 2285675 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2285732), // Rule ID 1503 //
     /* 2285680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2285683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285714 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2285717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2285727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285731 */     // GIR_Coverage, 1503,
     /* 2285731 */     GIR_EraseRootFromParent_Done,
     /* 2285732 */   // Label 32942: @2285732
     /* 2285732 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2285789), // Rule ID 1504 //
     /* 2285737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2285740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285771 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2285774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2285784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285788 */     // GIR_Coverage, 1504,
     /* 2285788 */     GIR_EraseRootFromParent_Done,
     /* 2285789 */   // Label 32943: @2285789
     /* 2285789 */   GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2285846), // Rule ID 1529 //
     /* 2285794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2285797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285828 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2285831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2285841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285845 */     // GIR_Coverage, 1529,
     /* 2285845 */     GIR_EraseRootFromParent_Done,
     /* 2285846 */   // Label 32944: @2285846
     /* 2285846 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2285903), // Rule ID 1558 //
     /* 2285851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2285854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285885 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2285888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2285898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285902 */     // GIR_Coverage, 1558,
     /* 2285902 */     GIR_EraseRootFromParent_Done,
     /* 2285903 */   // Label 32945: @2285903
     /* 2285903 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2285960), // Rule ID 1559 //
     /* 2285908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2285911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2285919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285942 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2285942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2285945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2285951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2285955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285959 */     // GIR_Coverage, 1559,
     /* 2285959 */     GIR_EraseRootFromParent_Done,
     /* 2285960 */   // Label 32946: @2285960
     /* 2285960 */   GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2286017), // Rule ID 64007 //
     /* 2285965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2285968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2285980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2285984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2285999 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2285999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2286002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2286010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286016 */     // GIR_Coverage, 64007,
     /* 2286016 */     GIR_EraseRootFromParent_Done,
     /* 2286017 */   // Label 32947: @2286017
     /* 2286017 */   GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2286074), // Rule ID 64008 //
     /* 2286022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2286025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286056 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2286059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2286067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286073 */     // GIR_Coverage, 64008,
     /* 2286073 */     GIR_EraseRootFromParent_Done,
     /* 2286074 */   // Label 32948: @2286074
     /* 2286074 */   GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2286131), // Rule ID 64015 //
     /* 2286079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2286082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286113 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2286116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2286124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286130 */     // GIR_Coverage, 64015,
     /* 2286130 */     GIR_EraseRootFromParent_Done,
     /* 2286131 */   // Label 32949: @2286131
     /* 2286131 */   GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2286188), // Rule ID 64019 //
     /* 2286136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2286139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286170 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2286173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2286181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286187 */     // GIR_Coverage, 64019,
     /* 2286187 */     GIR_EraseRootFromParent_Done,
     /* 2286188 */   // Label 32950: @2286188
     /* 2286188 */   GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2286245), // Rule ID 64020 //
     /* 2286193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2286196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286227 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2286230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2286238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286244 */     // GIR_Coverage, 64020,
     /* 2286244 */     GIR_EraseRootFromParent_Done,
     /* 2286245 */   // Label 32951: @2286245
     /* 2286245 */   GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2286302), // Rule ID 1499 //
     /* 2286250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2286253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2286269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286284 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2286287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2286297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286301 */     // GIR_Coverage, 1499,
     /* 2286301 */     GIR_EraseRootFromParent_Done,
     /* 2286302 */   // Label 32952: @2286302
     /* 2286302 */   GIM_Try, /*On fail goto*//*Label 32953*/ GIMT_Encode4(2286359), // Rule ID 1500 //
     /* 2286307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2286310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2286326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286341 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2286344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2286354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286358 */     // GIR_Coverage, 1500,
     /* 2286358 */     GIR_EraseRootFromParent_Done,
     /* 2286359 */   // Label 32953: @2286359
     /* 2286359 */   GIM_Try, /*On fail goto*//*Label 32954*/ GIMT_Encode4(2286416), // Rule ID 1527 //
     /* 2286364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2286367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2286383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286398 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2286401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2286411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286415 */     // GIR_Coverage, 1527,
     /* 2286415 */     GIR_EraseRootFromParent_Done,
     /* 2286416 */   // Label 32954: @2286416
     /* 2286416 */   GIM_Try, /*On fail goto*//*Label 32955*/ GIMT_Encode4(2286473), // Rule ID 1554 //
     /* 2286421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2286424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2286440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286455 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2286458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2286468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286472 */     // GIR_Coverage, 1554,
     /* 2286472 */     GIR_EraseRootFromParent_Done,
     /* 2286473 */   // Label 32955: @2286473
     /* 2286473 */   GIM_Try, /*On fail goto*//*Label 32956*/ GIMT_Encode4(2286530), // Rule ID 1555 //
     /* 2286478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2286481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2286497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286512 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2286515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2286525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286529 */     // GIR_Coverage, 1555,
     /* 2286529 */     GIR_EraseRootFromParent_Done,
     /* 2286530 */   // Label 32956: @2286530
     /* 2286530 */   GIM_Try, /*On fail goto*//*Label 32957*/ GIMT_Encode4(2286570), // Rule ID 1495 //
     /* 2286535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2286538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286554 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2286557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286569 */     // GIR_Coverage, 1495,
     /* 2286569 */     GIR_EraseRootFromParent_Done,
     /* 2286570 */   // Label 32957: @2286570
     /* 2286570 */   GIM_Try, /*On fail goto*//*Label 32958*/ GIMT_Encode4(2286610), // Rule ID 1496 //
     /* 2286575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2286578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286594 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2286597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286609 */     // GIR_Coverage, 1496,
     /* 2286609 */     GIR_EraseRootFromParent_Done,
     /* 2286610 */   // Label 32958: @2286610
     /* 2286610 */   GIM_Try, /*On fail goto*//*Label 32959*/ GIMT_Encode4(2286650), // Rule ID 1525 //
     /* 2286615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2286618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286634 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2286637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286649 */     // GIR_Coverage, 1525,
     /* 2286649 */     GIR_EraseRootFromParent_Done,
     /* 2286650 */   // Label 32959: @2286650
     /* 2286650 */   GIM_Try, /*On fail goto*//*Label 32960*/ GIMT_Encode4(2286690), // Rule ID 1550 //
     /* 2286655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2286658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286674 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2286674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2286677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286689 */     // GIR_Coverage, 1550,
     /* 2286689 */     GIR_EraseRootFromParent_Done,
     /* 2286690 */   // Label 32960: @2286690
     /* 2286690 */   GIM_Try, /*On fail goto*//*Label 32961*/ GIMT_Encode4(2286730), // Rule ID 1551 //
     /* 2286695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2286698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286714 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2286714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2286717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2286725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286729 */     // GIR_Coverage, 1551,
     /* 2286729 */     GIR_EraseRootFromParent_Done,
     /* 2286730 */   // Label 32961: @2286730
     /* 2286730 */   GIM_Reject,
     /* 2286731 */ // Label 32931: @2286731
     /* 2286731 */ GIM_Reject,
     /* 2286732 */ // Label 32865: @2286732
     /* 2286732 */ GIM_Try, /*On fail goto*//*Label 32962*/ GIMT_Encode4(2287521),
     /* 2286737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2286743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2286746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286750 */   GIM_Try, /*On fail goto*//*Label 32963*/ GIMT_Encode4(2286827), // Rule ID 54290 //
     /* 2286755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2286762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2286783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2286798 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2286798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2286801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2286805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2286813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2286825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286826 */     // GIR_Coverage, 54290,
     /* 2286826 */     GIR_EraseRootFromParent_Done,
     /* 2286827 */   // Label 32963: @2286827
     /* 2286827 */   GIM_Try, /*On fail goto*//*Label 32964*/ GIMT_Encode4(2286904), // Rule ID 54291 //
     /* 2286832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2286839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2286860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2286875 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2286875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2286878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2286882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2286890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2286902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286903 */     // GIR_Coverage, 54291,
     /* 2286903 */     GIR_EraseRootFromParent_Done,
     /* 2286904 */   // Label 32964: @2286904
     /* 2286904 */   GIM_Try, /*On fail goto*//*Label 32965*/ GIMT_Encode4(2286981), // Rule ID 70835 //
     /* 2286909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2286937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2286941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2286952 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2286952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2286955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2286959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2286963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2286967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2286979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286980 */     // GIR_Coverage, 70835,
     /* 2286980 */     GIR_EraseRootFromParent_Done,
     /* 2286981 */   // Label 32965: @2286981
     /* 2286981 */   GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2287058), // Rule ID 70836 //
     /* 2286986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2286997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2287014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2287029 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2287032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2287036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2287044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287057 */     // GIR_Coverage, 70836,
     /* 2287057 */     GIR_EraseRootFromParent_Done,
     /* 2287058 */   // Label 32966: @2287058
     /* 2287058 */   GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2287120), // Rule ID 54294 //
     /* 2287063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287093 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2287096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287119 */     // GIR_Coverage, 54294,
     /* 2287119 */     GIR_EraseRootFromParent_Done,
     /* 2287120 */   // Label 32967: @2287120
     /* 2287120 */   GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2287182), // Rule ID 54295 //
     /* 2287125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287155 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2287158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287181 */     // GIR_Coverage, 54295,
     /* 2287181 */     GIR_EraseRootFromParent_Done,
     /* 2287182 */   // Label 32968: @2287182
     /* 2287182 */   GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2287244), // Rule ID 70839 //
     /* 2287187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2287198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287217 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2287220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2287224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287243 */     // GIR_Coverage, 70839,
     /* 2287243 */     GIR_EraseRootFromParent_Done,
     /* 2287244 */   // Label 32969: @2287244
     /* 2287244 */   GIM_Try, /*On fail goto*//*Label 32970*/ GIMT_Encode4(2287306), // Rule ID 70840 //
     /* 2287249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2287260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287279 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2287282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2287286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287305 */     // GIR_Coverage, 70840,
     /* 2287305 */     GIR_EraseRootFromParent_Done,
     /* 2287306 */   // Label 32970: @2287306
     /* 2287306 */   GIM_Try, /*On fail goto*//*Label 32971*/ GIMT_Encode4(2287368), // Rule ID 54286 //
     /* 2287311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2287326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287341 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2287344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2287354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287367 */     // GIR_Coverage, 54286,
     /* 2287367 */     GIR_EraseRootFromParent_Done,
     /* 2287368 */   // Label 32971: @2287368
     /* 2287368 */   GIM_Try, /*On fail goto*//*Label 32972*/ GIMT_Encode4(2287430), // Rule ID 54287 //
     /* 2287373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2287388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287403 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2287406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2287416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287429 */     // GIR_Coverage, 54287,
     /* 2287429 */     GIR_EraseRootFromParent_Done,
     /* 2287430 */   // Label 32972: @2287430
     /* 2287430 */   GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2287475), // Rule ID 54282 //
     /* 2287435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287450 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2287453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287474 */     // GIR_Coverage, 54282,
     /* 2287474 */     GIR_EraseRootFromParent_Done,
     /* 2287475 */   // Label 32973: @2287475
     /* 2287475 */   GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2287520), // Rule ID 54283 //
     /* 2287480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287495 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2287498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287519 */     // GIR_Coverage, 54283,
     /* 2287519 */     GIR_EraseRootFromParent_Done,
     /* 2287520 */   // Label 32974: @2287520
     /* 2287520 */   GIM_Reject,
     /* 2287521 */ // Label 32962: @2287521
     /* 2287521 */ GIM_Reject,
     /* 2287522 */ // Label 32866: @2287522
     /* 2287522 */ GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2288311),
     /* 2287527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2287533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2287536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287540 */   GIM_Try, /*On fail goto*//*Label 32976*/ GIMT_Encode4(2287617), // Rule ID 54418 //
     /* 2287545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2287573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2287588 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2287591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2287603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287616 */     // GIR_Coverage, 54418,
     /* 2287616 */     GIR_EraseRootFromParent_Done,
     /* 2287617 */   // Label 32976: @2287617
     /* 2287617 */   GIM_Try, /*On fail goto*//*Label 32977*/ GIMT_Encode4(2287694), // Rule ID 54419 //
     /* 2287622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2287650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2287665 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2287668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2287680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287693 */     // GIR_Coverage, 54419,
     /* 2287693 */     GIR_EraseRootFromParent_Done,
     /* 2287694 */   // Label 32977: @2287694
     /* 2287694 */   GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2287771), // Rule ID 70947 //
     /* 2287699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2287710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2287727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2287742 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2287745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2287749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2287757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287770 */     // GIR_Coverage, 70947,
     /* 2287770 */     GIR_EraseRootFromParent_Done,
     /* 2287771 */   // Label 32978: @2287771
     /* 2287771 */   GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2287848), // Rule ID 70948 //
     /* 2287776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2287787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2287804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2287819 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2287822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2287826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2287834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287847 */     // GIR_Coverage, 70948,
     /* 2287847 */     GIR_EraseRootFromParent_Done,
     /* 2287848 */   // Label 32979: @2287848
     /* 2287848 */   GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2287910), // Rule ID 54422 //
     /* 2287853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287883 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2287883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2287886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287909 */     // GIR_Coverage, 54422,
     /* 2287909 */     GIR_EraseRootFromParent_Done,
     /* 2287910 */   // Label 32980: @2287910
     /* 2287910 */   GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2287972), // Rule ID 54423 //
     /* 2287915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2287922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2287945 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2287945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2287948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2287952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2287956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2287958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2287970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287971 */     // GIR_Coverage, 54423,
     /* 2287971 */     GIR_EraseRootFromParent_Done,
     /* 2287972 */   // Label 32981: @2287972
     /* 2287972 */   GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2288034), // Rule ID 70951 //
     /* 2287977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2287988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2287992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288007 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2288010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288033 */     // GIR_Coverage, 70951,
     /* 2288033 */     GIR_EraseRootFromParent_Done,
     /* 2288034 */   // Label 32982: @2288034
     /* 2288034 */   GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2288096), // Rule ID 70952 //
     /* 2288039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2288042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288069 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2288072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288095 */     // GIR_Coverage, 70952,
     /* 2288095 */     GIR_EraseRootFromParent_Done,
     /* 2288096 */   // Label 32983: @2288096
     /* 2288096 */   GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2288158), // Rule ID 54414 //
     /* 2288101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2288104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2288116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288131 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2288134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2288144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288157 */     // GIR_Coverage, 54414,
     /* 2288157 */     GIR_EraseRootFromParent_Done,
     /* 2288158 */   // Label 32984: @2288158
     /* 2288158 */   GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2288220), // Rule ID 54415 //
     /* 2288163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2288166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2288178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288193 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2288196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2288206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288219 */     // GIR_Coverage, 54415,
     /* 2288219 */     GIR_EraseRootFromParent_Done,
     /* 2288220 */   // Label 32985: @2288220
     /* 2288220 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2288265), // Rule ID 54410 //
     /* 2288225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2288228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288240 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2288243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288264 */     // GIR_Coverage, 54410,
     /* 2288264 */     GIR_EraseRootFromParent_Done,
     /* 2288265 */   // Label 32986: @2288265
     /* 2288265 */   GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2288310), // Rule ID 54411 //
     /* 2288270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2288273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288285 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2288288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288309 */     // GIR_Coverage, 54411,
     /* 2288309 */     GIR_EraseRootFromParent_Done,
     /* 2288310 */   // Label 32987: @2288310
     /* 2288310 */   GIM_Reject,
     /* 2288311 */ // Label 32975: @2288311
     /* 2288311 */ GIM_Reject,
     /* 2288312 */ // Label 32867: @2288312
     /* 2288312 */ GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2289101),
     /* 2288317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2288326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288330 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2288407), // Rule ID 54610 //
     /* 2288335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288378 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2288381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2288393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288406 */     // GIR_Coverage, 54610,
     /* 2288406 */     GIR_EraseRootFromParent_Done,
     /* 2288407 */   // Label 32989: @2288407
     /* 2288407 */   GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2288484), // Rule ID 54611 //
     /* 2288412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288455 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2288458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2288470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288483 */     // GIR_Coverage, 54611,
     /* 2288483 */     GIR_EraseRootFromParent_Done,
     /* 2288484 */   // Label 32990: @2288484
     /* 2288484 */   GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2288561), // Rule ID 71115 //
     /* 2288489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288532 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2288535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2288547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288560 */     // GIR_Coverage, 71115,
     /* 2288560 */     GIR_EraseRootFromParent_Done,
     /* 2288561 */   // Label 32991: @2288561
     /* 2288561 */   GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2288638), // Rule ID 71116 //
     /* 2288566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288609 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2288612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2288624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288637 */     // GIR_Coverage, 71116,
     /* 2288637 */     GIR_EraseRootFromParent_Done,
     /* 2288638 */   // Label 32992: @2288638
     /* 2288638 */   GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2288700), // Rule ID 54614 //
     /* 2288643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288673 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2288676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288699 */     // GIR_Coverage, 54614,
     /* 2288699 */     GIR_EraseRootFromParent_Done,
     /* 2288700 */   // Label 32993: @2288700
     /* 2288700 */   GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2288762), // Rule ID 54615 //
     /* 2288705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288735 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2288738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288761 */     // GIR_Coverage, 54615,
     /* 2288761 */     GIR_EraseRootFromParent_Done,
     /* 2288762 */   // Label 32994: @2288762
     /* 2288762 */   GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2288824), // Rule ID 71119 //
     /* 2288767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288797 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2288800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288823 */     // GIR_Coverage, 71119,
     /* 2288823 */     GIR_EraseRootFromParent_Done,
     /* 2288824 */   // Label 32995: @2288824
     /* 2288824 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2288886), // Rule ID 71120 //
     /* 2288829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288859 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2288862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2288866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2288872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288885 */     // GIR_Coverage, 71120,
     /* 2288885 */     GIR_EraseRootFromParent_Done,
     /* 2288886 */   // Label 32996: @2288886
     /* 2288886 */   GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2288948), // Rule ID 54606 //
     /* 2288891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2288906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288921 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2288921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2288924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2288934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2288946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288947 */     // GIR_Coverage, 54606,
     /* 2288947 */     GIR_EraseRootFromParent_Done,
     /* 2288948 */   // Label 32997: @2288948
     /* 2288948 */   GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2289010), // Rule ID 54607 //
     /* 2288953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2288968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288983 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2288983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2288986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2288990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2288996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289009 */     // GIR_Coverage, 54607,
     /* 2289009 */     GIR_EraseRootFromParent_Done,
     /* 2289010 */   // Label 32998: @2289010
     /* 2289010 */   GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2289055), // Rule ID 54602 //
     /* 2289015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2289018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289030 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2289033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289054 */     // GIR_Coverage, 54602,
     /* 2289054 */     GIR_EraseRootFromParent_Done,
     /* 2289055 */   // Label 32999: @2289055
     /* 2289055 */   GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2289100), // Rule ID 54603 //
     /* 2289060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2289063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289075 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2289078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289099 */     // GIR_Coverage, 54603,
     /* 2289099 */     GIR_EraseRootFromParent_Done,
     /* 2289100 */   // Label 33000: @2289100
     /* 2289100 */   GIM_Reject,
     /* 2289101 */ // Label 32988: @2289101
     /* 2289101 */ GIM_Reject,
     /* 2289102 */ // Label 32868: @2289102
     /* 2289102 */ GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2289891),
     /* 2289107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2289113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2289116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289120 */   GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2289197), // Rule ID 54354 //
     /* 2289125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289168 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2289171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2289183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289196 */     // GIR_Coverage, 54354,
     /* 2289196 */     GIR_EraseRootFromParent_Done,
     /* 2289197 */   // Label 33002: @2289197
     /* 2289197 */   GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2289274), // Rule ID 54355 //
     /* 2289202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289245 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2289248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2289260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289273 */     // GIR_Coverage, 54355,
     /* 2289273 */     GIR_EraseRootFromParent_Done,
     /* 2289274 */   // Label 33003: @2289274
     /* 2289274 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2289351), // Rule ID 70891 //
     /* 2289279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289322 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2289325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2289329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2289337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289350 */     // GIR_Coverage, 70891,
     /* 2289350 */     GIR_EraseRootFromParent_Done,
     /* 2289351 */   // Label 33004: @2289351
     /* 2289351 */   GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2289428), // Rule ID 70892 //
     /* 2289356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289399 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2289402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2289406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2289414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289427 */     // GIR_Coverage, 70892,
     /* 2289427 */     GIR_EraseRootFromParent_Done,
     /* 2289428 */   // Label 33005: @2289428
     /* 2289428 */   GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2289490), // Rule ID 54358 //
     /* 2289433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289463 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2289466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289489 */     // GIR_Coverage, 54358,
     /* 2289489 */     GIR_EraseRootFromParent_Done,
     /* 2289490 */   // Label 33006: @2289490
     /* 2289490 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2289552), // Rule ID 54359 //
     /* 2289495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289525 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2289528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289551 */     // GIR_Coverage, 54359,
     /* 2289551 */     GIR_EraseRootFromParent_Done,
     /* 2289552 */   // Label 33007: @2289552
     /* 2289552 */   GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2289614), // Rule ID 70895 //
     /* 2289557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289587 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2289590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2289594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289613 */     // GIR_Coverage, 70895,
     /* 2289613 */     GIR_EraseRootFromParent_Done,
     /* 2289614 */   // Label 33008: @2289614
     /* 2289614 */   GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2289676), // Rule ID 70896 //
     /* 2289619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289649 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2289652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2289656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289675 */     // GIR_Coverage, 70896,
     /* 2289675 */     GIR_EraseRootFromParent_Done,
     /* 2289676 */   // Label 33009: @2289676
     /* 2289676 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2289738), // Rule ID 54350 //
     /* 2289681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289711 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2289714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2289724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289737 */     // GIR_Coverage, 54350,
     /* 2289737 */     GIR_EraseRootFromParent_Done,
     /* 2289738 */   // Label 33010: @2289738
     /* 2289738 */   GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2289800), // Rule ID 54351 //
     /* 2289743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2289766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289773 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2289776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2289786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289799 */     // GIR_Coverage, 54351,
     /* 2289799 */     GIR_EraseRootFromParent_Done,
     /* 2289800 */   // Label 33011: @2289800
     /* 2289800 */   GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2289845), // Rule ID 54346 //
     /* 2289805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289820 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2289823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289844 */     // GIR_Coverage, 54346,
     /* 2289844 */     GIR_EraseRootFromParent_Done,
     /* 2289845 */   // Label 33012: @2289845
     /* 2289845 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2289890), // Rule ID 54347 //
     /* 2289850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289865 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2289865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2289868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2289876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289889 */     // GIR_Coverage, 54347,
     /* 2289889 */     GIR_EraseRootFromParent_Done,
     /* 2289890 */   // Label 33013: @2289890
     /* 2289890 */   GIM_Reject,
     /* 2289891 */ // Label 33001: @2289891
     /* 2289891 */ GIM_Reject,
     /* 2289892 */ // Label 32869: @2289892
     /* 2289892 */ GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2290681),
     /* 2289897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2289900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2289903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2289906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289910 */   GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2289987), // Rule ID 54546 //
     /* 2289915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2289918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2289930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2289951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289958 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2289958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2289961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2289965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2289973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2289985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289986 */     // GIR_Coverage, 54546,
     /* 2289986 */     GIR_EraseRootFromParent_Done,
     /* 2289987 */   // Label 33015: @2289987
     /* 2289987 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2290064), // Rule ID 54547 //
     /* 2289992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2289995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290035 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2290038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290063 */     // GIR_Coverage, 54547,
     /* 2290063 */     GIR_EraseRootFromParent_Done,
     /* 2290064 */   // Label 33016: @2290064
     /* 2290064 */   GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2290141), // Rule ID 71059 //
     /* 2290069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290112 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2290115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290140 */     // GIR_Coverage, 71059,
     /* 2290140 */     GIR_EraseRootFromParent_Done,
     /* 2290141 */   // Label 33017: @2290141
     /* 2290141 */   GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2290218), // Rule ID 71060 //
     /* 2290146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290189 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2290192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290217 */     // GIR_Coverage, 71060,
     /* 2290217 */     GIR_EraseRootFromParent_Done,
     /* 2290218 */   // Label 33018: @2290218
     /* 2290218 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2290280), // Rule ID 54550 //
     /* 2290223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290253 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2290256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290279 */     // GIR_Coverage, 54550,
     /* 2290279 */     GIR_EraseRootFromParent_Done,
     /* 2290280 */   // Label 33019: @2290280
     /* 2290280 */   GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2290342), // Rule ID 54551 //
     /* 2290285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290315 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2290318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290341 */     // GIR_Coverage, 54551,
     /* 2290341 */     GIR_EraseRootFromParent_Done,
     /* 2290342 */   // Label 33020: @2290342
     /* 2290342 */   GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2290404), // Rule ID 71063 //
     /* 2290347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290377 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2290380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290403 */     // GIR_Coverage, 71063,
     /* 2290403 */     GIR_EraseRootFromParent_Done,
     /* 2290404 */   // Label 33021: @2290404
     /* 2290404 */   GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2290466), // Rule ID 71064 //
     /* 2290409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290439 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2290442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290465 */     // GIR_Coverage, 71064,
     /* 2290465 */     GIR_EraseRootFromParent_Done,
     /* 2290466 */   // Label 33022: @2290466
     /* 2290466 */   GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2290528), // Rule ID 54542 //
     /* 2290471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290501 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2290504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2290514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290527 */     // GIR_Coverage, 54542,
     /* 2290527 */     GIR_EraseRootFromParent_Done,
     /* 2290528 */   // Label 33023: @2290528
     /* 2290528 */   GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2290590), // Rule ID 54543 //
     /* 2290533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290563 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2290566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2290576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290589 */     // GIR_Coverage, 54543,
     /* 2290589 */     GIR_EraseRootFromParent_Done,
     /* 2290590 */   // Label 33024: @2290590
     /* 2290590 */   GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2290635), // Rule ID 54538 //
     /* 2290595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290610 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2290613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290634 */     // GIR_Coverage, 54538,
     /* 2290634 */     GIR_EraseRootFromParent_Done,
     /* 2290635 */   // Label 33025: @2290635
     /* 2290635 */   GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2290680), // Rule ID 54539 //
     /* 2290640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290655 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2290658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2290666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290679 */     // GIR_Coverage, 54539,
     /* 2290679 */     GIR_EraseRootFromParent_Done,
     /* 2290680 */   // Label 33026: @2290680
     /* 2290680 */   GIM_Reject,
     /* 2290681 */ // Label 33014: @2290681
     /* 2290681 */ GIM_Reject,
     /* 2290682 */ // Label 32870: @2290682
     /* 2290682 */ GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2291471),
     /* 2290687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2290693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2290696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290700 */   GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2290777), // Rule ID 55058 //
     /* 2290705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2290708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290748 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2290751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290776 */     // GIR_Coverage, 55058,
     /* 2290776 */     GIR_EraseRootFromParent_Done,
     /* 2290777 */   // Label 33028: @2290777
     /* 2290777 */   GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2290854), // Rule ID 55059 //
     /* 2290782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2290785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290825 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2290828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2290832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290853 */     // GIR_Coverage, 55059,
     /* 2290853 */     GIR_EraseRootFromParent_Done,
     /* 2290854 */   // Label 33029: @2290854
     /* 2290854 */   GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2290931), // Rule ID 71507 //
     /* 2290859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2290862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290902 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2290902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2290905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2290929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290930 */     // GIR_Coverage, 71507,
     /* 2290930 */     GIR_EraseRootFromParent_Done,
     /* 2290931 */   // Label 33030: @2290931
     /* 2290931 */   GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2291008), // Rule ID 71508 //
     /* 2290936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2290939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2290972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290979 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2290979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2290982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2290986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2290994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291007 */     // GIR_Coverage, 71508,
     /* 2291007 */     GIR_EraseRootFromParent_Done,
     /* 2291008 */   // Label 33031: @2291008
     /* 2291008 */   GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2291070), // Rule ID 55062 //
     /* 2291013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291043 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2291046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291069 */     // GIR_Coverage, 55062,
     /* 2291069 */     GIR_EraseRootFromParent_Done,
     /* 2291070 */   // Label 33032: @2291070
     /* 2291070 */   GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2291132), // Rule ID 55063 //
     /* 2291075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291105 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2291108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291131 */     // GIR_Coverage, 55063,
     /* 2291131 */     GIR_EraseRootFromParent_Done,
     /* 2291132 */   // Label 33033: @2291132
     /* 2291132 */   GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2291194), // Rule ID 71511 //
     /* 2291137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291167 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2291170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2291174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291193 */     // GIR_Coverage, 71511,
     /* 2291193 */     GIR_EraseRootFromParent_Done,
     /* 2291194 */   // Label 33034: @2291194
     /* 2291194 */   GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2291256), // Rule ID 71512 //
     /* 2291199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291229 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2291232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2291236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291255 */     // GIR_Coverage, 71512,
     /* 2291255 */     GIR_EraseRootFromParent_Done,
     /* 2291256 */   // Label 33035: @2291256
     /* 2291256 */   GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2291318), // Rule ID 55054 //
     /* 2291261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2291276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291291 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2291294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2291304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291317 */     // GIR_Coverage, 55054,
     /* 2291317 */     GIR_EraseRootFromParent_Done,
     /* 2291318 */   // Label 33036: @2291318
     /* 2291318 */   GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2291380), // Rule ID 55055 //
     /* 2291323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2291338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291353 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2291356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2291366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291379 */     // GIR_Coverage, 55055,
     /* 2291379 */     GIR_EraseRootFromParent_Done,
     /* 2291380 */   // Label 33037: @2291380
     /* 2291380 */   GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2291425), // Rule ID 55050 //
     /* 2291385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291400 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2291403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291424 */     // GIR_Coverage, 55050,
     /* 2291424 */     GIR_EraseRootFromParent_Done,
     /* 2291425 */   // Label 33038: @2291425
     /* 2291425 */   GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2291470), // Rule ID 55051 //
     /* 2291430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291445 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2291448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291469 */     // GIR_Coverage, 55051,
     /* 2291469 */     GIR_EraseRootFromParent_Done,
     /* 2291470 */   // Label 33039: @2291470
     /* 2291470 */   GIM_Reject,
     /* 2291471 */ // Label 33027: @2291471
     /* 2291471 */ GIM_Reject,
     /* 2291472 */ // Label 32871: @2291472
     /* 2291472 */ GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2292261),
     /* 2291477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2291483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2291486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291490 */   GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2291567), // Rule ID 54482 //
     /* 2291495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291538 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2291541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2291553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291566 */     // GIR_Coverage, 54482,
     /* 2291566 */     GIR_EraseRootFromParent_Done,
     /* 2291567 */   // Label 33041: @2291567
     /* 2291567 */   GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2291644), // Rule ID 54483 //
     /* 2291572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291615 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2291618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2291630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291643 */     // GIR_Coverage, 54483,
     /* 2291643 */     GIR_EraseRootFromParent_Done,
     /* 2291644 */   // Label 33042: @2291644
     /* 2291644 */   GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2291721), // Rule ID 71003 //
     /* 2291649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291692 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2291695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2291699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2291707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291720 */     // GIR_Coverage, 71003,
     /* 2291720 */     GIR_EraseRootFromParent_Done,
     /* 2291721 */   // Label 33043: @2291721
     /* 2291721 */   GIM_Try, /*On fail goto*//*Label 33044*/ GIMT_Encode4(2291798), // Rule ID 71004 //
     /* 2291726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291769 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2291776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2291784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291797 */     // GIR_Coverage, 71004,
     /* 2291797 */     GIR_EraseRootFromParent_Done,
     /* 2291798 */   // Label 33044: @2291798
     /* 2291798 */   GIM_Try, /*On fail goto*//*Label 33045*/ GIMT_Encode4(2291860), // Rule ID 54486 //
     /* 2291803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291833 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2291836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291859 */     // GIR_Coverage, 54486,
     /* 2291859 */     GIR_EraseRootFromParent_Done,
     /* 2291860 */   // Label 33045: @2291860
     /* 2291860 */   GIM_Try, /*On fail goto*//*Label 33046*/ GIMT_Encode4(2291922), // Rule ID 54487 //
     /* 2291865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291895 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2291895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2291898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2291902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291921 */     // GIR_Coverage, 54487,
     /* 2291921 */     GIR_EraseRootFromParent_Done,
     /* 2291922 */   // Label 33046: @2291922
     /* 2291922 */   GIM_Try, /*On fail goto*//*Label 33047*/ GIMT_Encode4(2291984), // Rule ID 71007 //
     /* 2291927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291957 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2291957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2291960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2291964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2291970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2291982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291983 */     // GIR_Coverage, 71007,
     /* 2291983 */     GIR_EraseRootFromParent_Done,
     /* 2291984 */   // Label 33047: @2291984
     /* 2291984 */   GIM_Try, /*On fail goto*//*Label 33048*/ GIMT_Encode4(2292046), // Rule ID 71008 //
     /* 2291989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292019 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2292022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2292026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292045 */     // GIR_Coverage, 71008,
     /* 2292045 */     GIR_EraseRootFromParent_Done,
     /* 2292046 */   // Label 33048: @2292046
     /* 2292046 */   GIM_Try, /*On fail goto*//*Label 33049*/ GIMT_Encode4(2292108), // Rule ID 54478 //
     /* 2292051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2292054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292081 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2292084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2292094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292107 */     // GIR_Coverage, 54478,
     /* 2292107 */     GIR_EraseRootFromParent_Done,
     /* 2292108 */   // Label 33049: @2292108
     /* 2292108 */   GIM_Try, /*On fail goto*//*Label 33050*/ GIMT_Encode4(2292170), // Rule ID 54479 //
     /* 2292113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2292116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292143 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2292146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2292156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292169 */     // GIR_Coverage, 54479,
     /* 2292169 */     GIR_EraseRootFromParent_Done,
     /* 2292170 */   // Label 33050: @2292170
     /* 2292170 */   GIM_Try, /*On fail goto*//*Label 33051*/ GIMT_Encode4(2292215), // Rule ID 54474 //
     /* 2292175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2292178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292190 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2292193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292214 */     // GIR_Coverage, 54474,
     /* 2292214 */     GIR_EraseRootFromParent_Done,
     /* 2292215 */   // Label 33051: @2292215
     /* 2292215 */   GIM_Try, /*On fail goto*//*Label 33052*/ GIMT_Encode4(2292260), // Rule ID 54475 //
     /* 2292220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2292223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292235 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2292238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292259 */     // GIR_Coverage, 54475,
     /* 2292259 */     GIR_EraseRootFromParent_Done,
     /* 2292260 */   // Label 33052: @2292260
     /* 2292260 */   GIM_Reject,
     /* 2292261 */ // Label 33040: @2292261
     /* 2292261 */ GIM_Reject,
     /* 2292262 */ // Label 32872: @2292262
     /* 2292262 */ GIM_Try, /*On fail goto*//*Label 33053*/ GIMT_Encode4(2293051),
     /* 2292267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2292273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2292276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292280 */   GIM_Try, /*On fail goto*//*Label 33054*/ GIMT_Encode4(2292357), // Rule ID 54866 //
     /* 2292285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292328 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2292331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2292343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292356 */     // GIR_Coverage, 54866,
     /* 2292356 */     GIR_EraseRootFromParent_Done,
     /* 2292357 */   // Label 33054: @2292357
     /* 2292357 */   GIM_Try, /*On fail goto*//*Label 33055*/ GIMT_Encode4(2292434), // Rule ID 54867 //
     /* 2292362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292405 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2292408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2292420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292433 */     // GIR_Coverage, 54867,
     /* 2292433 */     GIR_EraseRootFromParent_Done,
     /* 2292434 */   // Label 33055: @2292434
     /* 2292434 */   GIM_Try, /*On fail goto*//*Label 33056*/ GIMT_Encode4(2292511), // Rule ID 71339 //
     /* 2292439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292482 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2292485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2292489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2292497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292510 */     // GIR_Coverage, 71339,
     /* 2292510 */     GIR_EraseRootFromParent_Done,
     /* 2292511 */   // Label 33056: @2292511
     /* 2292511 */   GIM_Try, /*On fail goto*//*Label 33057*/ GIMT_Encode4(2292588), // Rule ID 71340 //
     /* 2292516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292559 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2292562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2292566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2292574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292587 */     // GIR_Coverage, 71340,
     /* 2292587 */     GIR_EraseRootFromParent_Done,
     /* 2292588 */   // Label 33057: @2292588
     /* 2292588 */   GIM_Try, /*On fail goto*//*Label 33058*/ GIMT_Encode4(2292650), // Rule ID 54870 //
     /* 2292593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292623 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2292626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292649 */     // GIR_Coverage, 54870,
     /* 2292649 */     GIR_EraseRootFromParent_Done,
     /* 2292650 */   // Label 33058: @2292650
     /* 2292650 */   GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2292712), // Rule ID 54871 //
     /* 2292655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292685 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2292688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292711 */     // GIR_Coverage, 54871,
     /* 2292711 */     GIR_EraseRootFromParent_Done,
     /* 2292712 */   // Label 33059: @2292712
     /* 2292712 */   GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2292774), // Rule ID 71343 //
     /* 2292717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292747 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2292750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2292754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292773 */     // GIR_Coverage, 71343,
     /* 2292773 */     GIR_EraseRootFromParent_Done,
     /* 2292774 */   // Label 33060: @2292774
     /* 2292774 */   GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2292836), // Rule ID 71344 //
     /* 2292779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292809 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2292812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2292816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292835 */     // GIR_Coverage, 71344,
     /* 2292835 */     GIR_EraseRootFromParent_Done,
     /* 2292836 */   // Label 33061: @2292836
     /* 2292836 */   GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2292898), // Rule ID 54862 //
     /* 2292841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292871 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2292874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2292884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292897 */     // GIR_Coverage, 54862,
     /* 2292897 */     GIR_EraseRootFromParent_Done,
     /* 2292898 */   // Label 33062: @2292898
     /* 2292898 */   GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2292960), // Rule ID 54863 //
     /* 2292903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292933 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2292933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2292936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2292946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2292958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292959 */     // GIR_Coverage, 54863,
     /* 2292959 */     GIR_EraseRootFromParent_Done,
     /* 2292960 */   // Label 33063: @2292960
     /* 2292960 */   GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2293005), // Rule ID 54858 //
     /* 2292965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292980 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2292983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2292987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2292991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293004 */     // GIR_Coverage, 54858,
     /* 2293004 */     GIR_EraseRootFromParent_Done,
     /* 2293005 */   // Label 33064: @2293005
     /* 2293005 */   GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2293050), // Rule ID 54859 //
     /* 2293010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2293013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293025 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2293028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293049 */     // GIR_Coverage, 54859,
     /* 2293049 */     GIR_EraseRootFromParent_Done,
     /* 2293050 */   // Label 33065: @2293050
     /* 2293050 */   GIM_Reject,
     /* 2293051 */ // Label 33053: @2293051
     /* 2293051 */ GIM_Reject,
     /* 2293052 */ // Label 32873: @2293052
     /* 2293052 */ GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2293841),
     /* 2293057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2293063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2293066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293070 */   GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2293147), // Rule ID 55122 //
     /* 2293075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293118 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2293121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293146 */     // GIR_Coverage, 55122,
     /* 2293146 */     GIR_EraseRootFromParent_Done,
     /* 2293147 */   // Label 33067: @2293147
     /* 2293147 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2293224), // Rule ID 55123 //
     /* 2293152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293195 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2293198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293223 */     // GIR_Coverage, 55123,
     /* 2293223 */     GIR_EraseRootFromParent_Done,
     /* 2293224 */   // Label 33068: @2293224
     /* 2293224 */   GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2293301), // Rule ID 71563 //
     /* 2293229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293272 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2293275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293300 */     // GIR_Coverage, 71563,
     /* 2293300 */     GIR_EraseRootFromParent_Done,
     /* 2293301 */   // Label 33069: @2293301
     /* 2293301 */   GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2293378), // Rule ID 71564 //
     /* 2293306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293349 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2293352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293377 */     // GIR_Coverage, 71564,
     /* 2293377 */     GIR_EraseRootFromParent_Done,
     /* 2293378 */   // Label 33070: @2293378
     /* 2293378 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2293440), // Rule ID 55126 //
     /* 2293383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293413 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2293416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293439 */     // GIR_Coverage, 55126,
     /* 2293439 */     GIR_EraseRootFromParent_Done,
     /* 2293440 */   // Label 33071: @2293440
     /* 2293440 */   GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2293502), // Rule ID 55127 //
     /* 2293445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293475 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2293478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293501 */     // GIR_Coverage, 55127,
     /* 2293501 */     GIR_EraseRootFromParent_Done,
     /* 2293502 */   // Label 33072: @2293502
     /* 2293502 */   GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2293564), // Rule ID 71567 //
     /* 2293507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293537 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2293540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293563 */     // GIR_Coverage, 71567,
     /* 2293563 */     GIR_EraseRootFromParent_Done,
     /* 2293564 */   // Label 33073: @2293564
     /* 2293564 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2293626), // Rule ID 71568 //
     /* 2293569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293599 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2293602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293625 */     // GIR_Coverage, 71568,
     /* 2293625 */     GIR_EraseRootFromParent_Done,
     /* 2293626 */   // Label 33074: @2293626
     /* 2293626 */   GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2293688), // Rule ID 55118 //
     /* 2293631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293661 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2293664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2293674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293687 */     // GIR_Coverage, 55118,
     /* 2293687 */     GIR_EraseRootFromParent_Done,
     /* 2293688 */   // Label 33075: @2293688
     /* 2293688 */   GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2293750), // Rule ID 55119 //
     /* 2293693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2293716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293723 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2293726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2293736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293749 */     // GIR_Coverage, 55119,
     /* 2293749 */     GIR_EraseRootFromParent_Done,
     /* 2293750 */   // Label 33076: @2293750
     /* 2293750 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2293795), // Rule ID 55114 //
     /* 2293755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2293758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293770 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2293773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293794 */     // GIR_Coverage, 55114,
     /* 2293794 */     GIR_EraseRootFromParent_Done,
     /* 2293795 */   // Label 33077: @2293795
     /* 2293795 */   GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2293840), // Rule ID 55115 //
     /* 2293800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2293803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293815 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2293818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293839 */     // GIR_Coverage, 55115,
     /* 2293839 */     GIR_EraseRootFromParent_Done,
     /* 2293840 */   // Label 33078: @2293840
     /* 2293840 */   GIM_Reject,
     /* 2293841 */ // Label 33066: @2293841
     /* 2293841 */ GIM_Reject,
     /* 2293842 */ // Label 32874: @2293842
     /* 2293842 */ GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2294631),
     /* 2293847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2293850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2293853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2293856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293860 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2293937), // Rule ID 54674 //
     /* 2293865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2293880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2293901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293908 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2293911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293936 */     // GIR_Coverage, 54674,
     /* 2293936 */     GIR_EraseRootFromParent_Done,
     /* 2293937 */   // Label 33080: @2293937
     /* 2293937 */   GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2294014), // Rule ID 54675 //
     /* 2293942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2293957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2293978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293985 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2293988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294013 */     // GIR_Coverage, 54675,
     /* 2294013 */     GIR_EraseRootFromParent_Done,
     /* 2294014 */   // Label 33081: @2294014
     /* 2294014 */   GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2294091), // Rule ID 71171 //
     /* 2294019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2294022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294062 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2294065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294090 */     // GIR_Coverage, 71171,
     /* 2294090 */     GIR_EraseRootFromParent_Done,
     /* 2294091 */   // Label 33082: @2294091
     /* 2294091 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2294168), // Rule ID 71172 //
     /* 2294096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2294099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294139 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2294142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294167 */     // GIR_Coverage, 71172,
     /* 2294167 */     GIR_EraseRootFromParent_Done,
     /* 2294168 */   // Label 33083: @2294168
     /* 2294168 */   GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2294230), // Rule ID 54678 //
     /* 2294173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2294176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294203 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2294206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294229 */     // GIR_Coverage, 54678,
     /* 2294229 */     GIR_EraseRootFromParent_Done,
     /* 2294230 */   // Label 33084: @2294230
     /* 2294230 */   GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2294292), // Rule ID 54679 //
     /* 2294235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2294238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294265 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2294268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294291 */     // GIR_Coverage, 54679,
     /* 2294291 */     GIR_EraseRootFromParent_Done,
     /* 2294292 */   // Label 33085: @2294292
     /* 2294292 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2294354), // Rule ID 71175 //
     /* 2294297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2294300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294327 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2294330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294353 */     // GIR_Coverage, 71175,
     /* 2294353 */     GIR_EraseRootFromParent_Done,
     /* 2294354 */   // Label 33086: @2294354
     /* 2294354 */   GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2294416), // Rule ID 71176 //
     /* 2294359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2294362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294389 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2294392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294415 */     // GIR_Coverage, 71176,
     /* 2294415 */     GIR_EraseRootFromParent_Done,
     /* 2294416 */   // Label 33087: @2294416
     /* 2294416 */   GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2294478), // Rule ID 54670 //
     /* 2294421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2294424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2294436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294451 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2294454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2294464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294477 */     // GIR_Coverage, 54670,
     /* 2294477 */     GIR_EraseRootFromParent_Done,
     /* 2294478 */   // Label 33088: @2294478
     /* 2294478 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2294540), // Rule ID 54671 //
     /* 2294483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2294486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2294498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294513 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2294516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2294526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294539 */     // GIR_Coverage, 54671,
     /* 2294539 */     GIR_EraseRootFromParent_Done,
     /* 2294540 */   // Label 33089: @2294540
     /* 2294540 */   GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2294585), // Rule ID 54666 //
     /* 2294545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2294548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294560 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2294563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294584 */     // GIR_Coverage, 54666,
     /* 2294584 */     GIR_EraseRootFromParent_Done,
     /* 2294585 */   // Label 33090: @2294585
     /* 2294585 */   GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2294630), // Rule ID 54667 //
     /* 2294590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2294593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294605 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2294608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294629 */     // GIR_Coverage, 54667,
     /* 2294629 */     GIR_EraseRootFromParent_Done,
     /* 2294630 */   // Label 33091: @2294630
     /* 2294630 */   GIM_Reject,
     /* 2294631 */ // Label 33079: @2294631
     /* 2294631 */ GIM_Reject,
     /* 2294632 */ // Label 32875: @2294632
     /* 2294632 */ GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2295421),
     /* 2294637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2294643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2294646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294650 */   GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2294727), // Rule ID 54930 //
     /* 2294655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294698 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2294701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294726 */     // GIR_Coverage, 54930,
     /* 2294726 */     GIR_EraseRootFromParent_Done,
     /* 2294727 */   // Label 33093: @2294727
     /* 2294727 */   GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2294804), // Rule ID 54931 //
     /* 2294732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294775 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2294778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294803 */     // GIR_Coverage, 54931,
     /* 2294803 */     GIR_EraseRootFromParent_Done,
     /* 2294804 */   // Label 33094: @2294804
     /* 2294804 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2294881), // Rule ID 71395 //
     /* 2294809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294852 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2294855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294880 */     // GIR_Coverage, 71395,
     /* 2294880 */     GIR_EraseRootFromParent_Done,
     /* 2294881 */   // Label 33095: @2294881
     /* 2294881 */   GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2294958), // Rule ID 71396 //
     /* 2294886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294929 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2294932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294957 */     // GIR_Coverage, 71396,
     /* 2294957 */     GIR_EraseRootFromParent_Done,
     /* 2294958 */   // Label 33096: @2294958
     /* 2294958 */   GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2295020), // Rule ID 54934 //
     /* 2294963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294993 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2294996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295019 */     // GIR_Coverage, 54934,
     /* 2295019 */     GIR_EraseRootFromParent_Done,
     /* 2295020 */   // Label 33097: @2295020
     /* 2295020 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2295082), // Rule ID 54935 //
     /* 2295025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2295028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295055 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2295058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295081 */     // GIR_Coverage, 54935,
     /* 2295081 */     GIR_EraseRootFromParent_Done,
     /* 2295082 */   // Label 33098: @2295082
     /* 2295082 */   GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2295144), // Rule ID 71399 //
     /* 2295087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2295090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295117 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2295120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295143 */     // GIR_Coverage, 71399,
     /* 2295143 */     GIR_EraseRootFromParent_Done,
     /* 2295144 */   // Label 33099: @2295144
     /* 2295144 */   GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2295206), // Rule ID 71400 //
     /* 2295149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2295152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295179 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2295182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295205 */     // GIR_Coverage, 71400,
     /* 2295205 */     GIR_EraseRootFromParent_Done,
     /* 2295206 */   // Label 33100: @2295206
     /* 2295206 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2295268), // Rule ID 54926 //
     /* 2295211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2295214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295241 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2295244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295267 */     // GIR_Coverage, 54926,
     /* 2295267 */     GIR_EraseRootFromParent_Done,
     /* 2295268 */   // Label 33101: @2295268
     /* 2295268 */   GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2295330), // Rule ID 54927 //
     /* 2295273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2295276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295303 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2295306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295329 */     // GIR_Coverage, 54927,
     /* 2295329 */     GIR_EraseRootFromParent_Done,
     /* 2295330 */   // Label 33102: @2295330
     /* 2295330 */   GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2295375), // Rule ID 54922 //
     /* 2295335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2295338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295350 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2295353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295374 */     // GIR_Coverage, 54922,
     /* 2295374 */     GIR_EraseRootFromParent_Done,
     /* 2295375 */   // Label 33103: @2295375
     /* 2295375 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2295420), // Rule ID 54923 //
     /* 2295380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2295383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295395 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2295398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295419 */     // GIR_Coverage, 54923,
     /* 2295419 */     GIR_EraseRootFromParent_Done,
     /* 2295420 */   // Label 33104: @2295420
     /* 2295420 */   GIM_Reject,
     /* 2295421 */ // Label 33092: @2295421
     /* 2295421 */ GIM_Reject,
     /* 2295422 */ // Label 32876: @2295422
     /* 2295422 */ GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2296211),
     /* 2295427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2295433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2295436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295440 */   GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2295517), // Rule ID 55186 //
     /* 2295445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295488 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2295491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295516 */     // GIR_Coverage, 55186,
     /* 2295516 */     GIR_EraseRootFromParent_Done,
     /* 2295517 */   // Label 33106: @2295517
     /* 2295517 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2295594), // Rule ID 55187 //
     /* 2295522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295565 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2295568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295593 */     // GIR_Coverage, 55187,
     /* 2295593 */     GIR_EraseRootFromParent_Done,
     /* 2295594 */   // Label 33107: @2295594
     /* 2295594 */   GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2295671), // Rule ID 71619 //
     /* 2295599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295642 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2295645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295670 */     // GIR_Coverage, 71619,
     /* 2295670 */     GIR_EraseRootFromParent_Done,
     /* 2295671 */   // Label 33108: @2295671
     /* 2295671 */   GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2295748), // Rule ID 71620 //
     /* 2295676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295719 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2295722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295747 */     // GIR_Coverage, 71620,
     /* 2295747 */     GIR_EraseRootFromParent_Done,
     /* 2295748 */   // Label 33109: @2295748
     /* 2295748 */   GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2295810), // Rule ID 55190 //
     /* 2295753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295783 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2295786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295809 */     // GIR_Coverage, 55190,
     /* 2295809 */     GIR_EraseRootFromParent_Done,
     /* 2295810 */   // Label 33110: @2295810
     /* 2295810 */   GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2295872), // Rule ID 55191 //
     /* 2295815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295845 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2295848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295871 */     // GIR_Coverage, 55191,
     /* 2295871 */     GIR_EraseRootFromParent_Done,
     /* 2295872 */   // Label 33111: @2295872
     /* 2295872 */   GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2295934), // Rule ID 71623 //
     /* 2295877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295907 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2295910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295933 */     // GIR_Coverage, 71623,
     /* 2295933 */     GIR_EraseRootFromParent_Done,
     /* 2295934 */   // Label 33112: @2295934
     /* 2295934 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2295996), // Rule ID 71624 //
     /* 2295939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295969 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2295972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295995 */     // GIR_Coverage, 71624,
     /* 2295995 */     GIR_EraseRootFromParent_Done,
     /* 2295996 */   // Label 33113: @2295996
     /* 2295996 */   GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2296058), // Rule ID 55182 //
     /* 2296001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2296004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2296024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296031 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2296034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296057 */     // GIR_Coverage, 55182,
     /* 2296057 */     GIR_EraseRootFromParent_Done,
     /* 2296058 */   // Label 33114: @2296058
     /* 2296058 */   GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2296120), // Rule ID 55183 //
     /* 2296063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2296066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2296086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296093 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2296096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296119 */     // GIR_Coverage, 55183,
     /* 2296119 */     GIR_EraseRootFromParent_Done,
     /* 2296120 */   // Label 33115: @2296120
     /* 2296120 */   GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2296165), // Rule ID 55178 //
     /* 2296125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2296128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296140 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2296143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296164 */     // GIR_Coverage, 55178,
     /* 2296164 */     GIR_EraseRootFromParent_Done,
     /* 2296165 */   // Label 33116: @2296165
     /* 2296165 */   GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2296210), // Rule ID 55179 //
     /* 2296170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2296173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296185 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2296188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296209 */     // GIR_Coverage, 55179,
     /* 2296209 */     GIR_EraseRootFromParent_Done,
     /* 2296210 */   // Label 33117: @2296210
     /* 2296210 */   GIM_Reject,
     /* 2296211 */ // Label 33105: @2296211
     /* 2296211 */ GIM_Reject,
     /* 2296212 */ // Label 32877: @2296212
     /* 2296212 */ GIM_Try, /*On fail goto*//*Label 33118*/ GIMT_Encode4(2297001),
     /* 2296217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2296223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2296226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296230 */   GIM_Try, /*On fail goto*//*Label 33119*/ GIMT_Encode4(2296307), // Rule ID 54738 //
     /* 2296235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296278 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2296281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296306 */     // GIR_Coverage, 54738,
     /* 2296306 */     GIR_EraseRootFromParent_Done,
     /* 2296307 */   // Label 33119: @2296307
     /* 2296307 */   GIM_Try, /*On fail goto*//*Label 33120*/ GIMT_Encode4(2296384), // Rule ID 54739 //
     /* 2296312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296355 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2296358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296383 */     // GIR_Coverage, 54739,
     /* 2296383 */     GIR_EraseRootFromParent_Done,
     /* 2296384 */   // Label 33120: @2296384
     /* 2296384 */   GIM_Try, /*On fail goto*//*Label 33121*/ GIMT_Encode4(2296461), // Rule ID 71227 //
     /* 2296389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296432 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2296435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296460 */     // GIR_Coverage, 71227,
     /* 2296460 */     GIR_EraseRootFromParent_Done,
     /* 2296461 */   // Label 33121: @2296461
     /* 2296461 */   GIM_Try, /*On fail goto*//*Label 33122*/ GIMT_Encode4(2296538), // Rule ID 71228 //
     /* 2296466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296509 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2296512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296537 */     // GIR_Coverage, 71228,
     /* 2296537 */     GIR_EraseRootFromParent_Done,
     /* 2296538 */   // Label 33122: @2296538
     /* 2296538 */   GIM_Try, /*On fail goto*//*Label 33123*/ GIMT_Encode4(2296600), // Rule ID 54742 //
     /* 2296543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296573 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2296576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296599 */     // GIR_Coverage, 54742,
     /* 2296599 */     GIR_EraseRootFromParent_Done,
     /* 2296600 */   // Label 33123: @2296600
     /* 2296600 */   GIM_Try, /*On fail goto*//*Label 33124*/ GIMT_Encode4(2296662), // Rule ID 54743 //
     /* 2296605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296635 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2296638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296661 */     // GIR_Coverage, 54743,
     /* 2296661 */     GIR_EraseRootFromParent_Done,
     /* 2296662 */   // Label 33124: @2296662
     /* 2296662 */   GIM_Try, /*On fail goto*//*Label 33125*/ GIMT_Encode4(2296724), // Rule ID 71231 //
     /* 2296667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296697 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2296700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296723 */     // GIR_Coverage, 71231,
     /* 2296723 */     GIR_EraseRootFromParent_Done,
     /* 2296724 */   // Label 33125: @2296724
     /* 2296724 */   GIM_Try, /*On fail goto*//*Label 33126*/ GIMT_Encode4(2296786), // Rule ID 71232 //
     /* 2296729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296759 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2296762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296785 */     // GIR_Coverage, 71232,
     /* 2296785 */     GIR_EraseRootFromParent_Done,
     /* 2296786 */   // Label 33126: @2296786
     /* 2296786 */   GIM_Try, /*On fail goto*//*Label 33127*/ GIMT_Encode4(2296848), // Rule ID 54734 //
     /* 2296791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296821 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2296824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296847 */     // GIR_Coverage, 54734,
     /* 2296847 */     GIR_EraseRootFromParent_Done,
     /* 2296848 */   // Label 33127: @2296848
     /* 2296848 */   GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2296910), // Rule ID 54735 //
     /* 2296853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2296876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296883 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2296886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296909 */     // GIR_Coverage, 54735,
     /* 2296909 */     GIR_EraseRootFromParent_Done,
     /* 2296910 */   // Label 33128: @2296910
     /* 2296910 */   GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2296955), // Rule ID 54730 //
     /* 2296915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296930 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2296933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296954 */     // GIR_Coverage, 54730,
     /* 2296954 */     GIR_EraseRootFromParent_Done,
     /* 2296955 */   // Label 33129: @2296955
     /* 2296955 */   GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2297000), // Rule ID 54731 //
     /* 2296960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296975 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2296978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296999 */     // GIR_Coverage, 54731,
     /* 2296999 */     GIR_EraseRootFromParent_Done,
     /* 2297000 */   // Label 33130: @2297000
     /* 2297000 */   GIM_Reject,
     /* 2297001 */ // Label 33118: @2297001
     /* 2297001 */ GIM_Reject,
     /* 2297002 */ // Label 32878: @2297002
     /* 2297002 */ GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2297791),
     /* 2297007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2297013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2297016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297020 */   GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2297097), // Rule ID 54994 //
     /* 2297025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297068 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2297071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297096 */     // GIR_Coverage, 54994,
     /* 2297096 */     GIR_EraseRootFromParent_Done,
     /* 2297097 */   // Label 33132: @2297097
     /* 2297097 */   GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2297174), // Rule ID 54995 //
     /* 2297102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297145 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2297148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297173 */     // GIR_Coverage, 54995,
     /* 2297173 */     GIR_EraseRootFromParent_Done,
     /* 2297174 */   // Label 33133: @2297174
     /* 2297174 */   GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2297251), // Rule ID 71451 //
     /* 2297179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297222 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2297225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297250 */     // GIR_Coverage, 71451,
     /* 2297250 */     GIR_EraseRootFromParent_Done,
     /* 2297251 */   // Label 33134: @2297251
     /* 2297251 */   GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2297328), // Rule ID 71452 //
     /* 2297256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297299 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2297302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297327 */     // GIR_Coverage, 71452,
     /* 2297327 */     GIR_EraseRootFromParent_Done,
     /* 2297328 */   // Label 33135: @2297328
     /* 2297328 */   GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2297390), // Rule ID 54998 //
     /* 2297333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297363 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2297366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297389 */     // GIR_Coverage, 54998,
     /* 2297389 */     GIR_EraseRootFromParent_Done,
     /* 2297390 */   // Label 33136: @2297390
     /* 2297390 */   GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2297452), // Rule ID 54999 //
     /* 2297395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297425 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2297428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297451 */     // GIR_Coverage, 54999,
     /* 2297451 */     GIR_EraseRootFromParent_Done,
     /* 2297452 */   // Label 33137: @2297452
     /* 2297452 */   GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2297514), // Rule ID 71455 //
     /* 2297457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297487 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2297490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297513 */     // GIR_Coverage, 71455,
     /* 2297513 */     GIR_EraseRootFromParent_Done,
     /* 2297514 */   // Label 33138: @2297514
     /* 2297514 */   GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2297576), // Rule ID 71456 //
     /* 2297519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297549 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2297552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297575 */     // GIR_Coverage, 71456,
     /* 2297575 */     GIR_EraseRootFromParent_Done,
     /* 2297576 */   // Label 33139: @2297576
     /* 2297576 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2297638), // Rule ID 54990 //
     /* 2297581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297611 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2297614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297637 */     // GIR_Coverage, 54990,
     /* 2297637 */     GIR_EraseRootFromParent_Done,
     /* 2297638 */   // Label 33140: @2297638
     /* 2297638 */   GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2297700), // Rule ID 54991 //
     /* 2297643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2297666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297673 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2297676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297699 */     // GIR_Coverage, 54991,
     /* 2297699 */     GIR_EraseRootFromParent_Done,
     /* 2297700 */   // Label 33141: @2297700
     /* 2297700 */   GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2297745), // Rule ID 54986 //
     /* 2297705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297720 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2297723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297744 */     // GIR_Coverage, 54986,
     /* 2297744 */     GIR_EraseRootFromParent_Done,
     /* 2297745 */   // Label 33142: @2297745
     /* 2297745 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2297790), // Rule ID 54987 //
     /* 2297750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297765 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2297768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297789 */     // GIR_Coverage, 54987,
     /* 2297789 */     GIR_EraseRootFromParent_Done,
     /* 2297790 */   // Label 33143: @2297790
     /* 2297790 */   GIM_Reject,
     /* 2297791 */ // Label 33131: @2297791
     /* 2297791 */ GIM_Reject,
     /* 2297792 */ // Label 32879: @2297792
     /* 2297792 */ GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2298581),
     /* 2297797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2297803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2297806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297810 */   GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2297887), // Rule ID 54802 //
     /* 2297815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297858 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2297861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297886 */     // GIR_Coverage, 54802,
     /* 2297886 */     GIR_EraseRootFromParent_Done,
     /* 2297887 */   // Label 33145: @2297887
     /* 2297887 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2297964), // Rule ID 54803 //
     /* 2297892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297935 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2297938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297963 */     // GIR_Coverage, 54803,
     /* 2297963 */     GIR_EraseRootFromParent_Done,
     /* 2297964 */   // Label 33146: @2297964
     /* 2297964 */   GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2298041), // Rule ID 71283 //
     /* 2297969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2297988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298012 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2298015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298040 */     // GIR_Coverage, 71283,
     /* 2298040 */     GIR_EraseRootFromParent_Done,
     /* 2298041 */   // Label 33147: @2298041
     /* 2298041 */   GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2298118), // Rule ID 71284 //
     /* 2298046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298089 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2298092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298117 */     // GIR_Coverage, 71284,
     /* 2298117 */     GIR_EraseRootFromParent_Done,
     /* 2298118 */   // Label 33148: @2298118
     /* 2298118 */   GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2298180), // Rule ID 54806 //
     /* 2298123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298153 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2298156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298179 */     // GIR_Coverage, 54806,
     /* 2298179 */     GIR_EraseRootFromParent_Done,
     /* 2298180 */   // Label 33149: @2298180
     /* 2298180 */   GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2298242), // Rule ID 54807 //
     /* 2298185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298215 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2298218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298241 */     // GIR_Coverage, 54807,
     /* 2298241 */     GIR_EraseRootFromParent_Done,
     /* 2298242 */   // Label 33150: @2298242
     /* 2298242 */   GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2298304), // Rule ID 71287 //
     /* 2298247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298277 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2298280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298303 */     // GIR_Coverage, 71287,
     /* 2298303 */     GIR_EraseRootFromParent_Done,
     /* 2298304 */   // Label 33151: @2298304
     /* 2298304 */   GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2298366), // Rule ID 71288 //
     /* 2298309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298339 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2298342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298365 */     // GIR_Coverage, 71288,
     /* 2298365 */     GIR_EraseRootFromParent_Done,
     /* 2298366 */   // Label 33152: @2298366
     /* 2298366 */   GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2298428), // Rule ID 54798 //
     /* 2298371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298401 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2298404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298427 */     // GIR_Coverage, 54798,
     /* 2298427 */     GIR_EraseRootFromParent_Done,
     /* 2298428 */   // Label 33153: @2298428
     /* 2298428 */   GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2298490), // Rule ID 54799 //
     /* 2298433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298463 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2298466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298489 */     // GIR_Coverage, 54799,
     /* 2298489 */     GIR_EraseRootFromParent_Done,
     /* 2298490 */   // Label 33154: @2298490
     /* 2298490 */   GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2298535), // Rule ID 54794 //
     /* 2298495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298510 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2298513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298534 */     // GIR_Coverage, 54794,
     /* 2298534 */     GIR_EraseRootFromParent_Done,
     /* 2298535 */   // Label 33155: @2298535
     /* 2298535 */   GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2298580), // Rule ID 54795 //
     /* 2298540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298555 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2298558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298579 */     // GIR_Coverage, 54795,
     /* 2298579 */     GIR_EraseRootFromParent_Done,
     /* 2298580 */   // Label 33156: @2298580
     /* 2298580 */   GIM_Reject,
     /* 2298581 */ // Label 33144: @2298581
     /* 2298581 */ GIM_Reject,
     /* 2298582 */ // Label 32880: @2298582
     /* 2298582 */ GIM_Reject,
     /* 2298583 */ // Label 99: @2298583
     /* 2298583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33175*/ GIMT_Encode4(2300758),
     /* 2298594 */ /*GILLT_s16*//*Label 33157*/ GIMT_Encode4(2298714),
     /* 2298598 */ /*GILLT_s32*//*Label 33158*/ GIMT_Encode4(2298836),
     /* 2298602 */ /*GILLT_s64*//*Label 33159*/ GIMT_Encode4(2298958), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298614 */ /*GILLT_nxv1s16*//*Label 33160*/ GIMT_Encode4(2299108),
     /* 2298618 */ /*GILLT_nxv1s32*//*Label 33161*/ GIMT_Encode4(2299218),
     /* 2298622 */ /*GILLT_nxv1s64*//*Label 33162*/ GIMT_Encode4(2299328), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298634 */ /*GILLT_nxv2s16*//*Label 33163*/ GIMT_Encode4(2299438),
     /* 2298638 */ /*GILLT_nxv2s32*//*Label 33164*/ GIMT_Encode4(2299548),
     /* 2298642 */ /*GILLT_nxv2s64*//*Label 33165*/ GIMT_Encode4(2299658), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298654 */ /*GILLT_nxv4s16*//*Label 33166*/ GIMT_Encode4(2299768),
     /* 2298658 */ /*GILLT_nxv4s32*//*Label 33167*/ GIMT_Encode4(2299878),
     /* 2298662 */ /*GILLT_nxv4s64*//*Label 33168*/ GIMT_Encode4(2299988), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298674 */ /*GILLT_nxv8s16*//*Label 33169*/ GIMT_Encode4(2300098),
     /* 2298678 */ /*GILLT_nxv8s32*//*Label 33170*/ GIMT_Encode4(2300208),
     /* 2298682 */ /*GILLT_nxv8s64*//*Label 33171*/ GIMT_Encode4(2300318), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298694 */ /*GILLT_nxv16s16*//*Label 33172*/ GIMT_Encode4(2300428),
     /* 2298698 */ /*GILLT_nxv16s32*//*Label 33173*/ GIMT_Encode4(2300538), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298710 */ /*GILLT_nxv32s16*//*Label 33174*/ GIMT_Encode4(2300648),
     /* 2298714 */ // Label 33157: @2298714
     /* 2298714 */ GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2298835),
     /* 2298719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2298722 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2298750), // Rule ID 1846 //
     /* 2298727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2298730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298738 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2298738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2298741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298749 */     // GIR_Coverage, 1846,
     /* 2298749 */     GIR_EraseRootFromParent_Done,
     /* 2298750 */   // Label 33177: @2298750
     /* 2298750 */   GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2298778), // Rule ID 1847 //
     /* 2298755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2298758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298766 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2298766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2298769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298777 */     // GIR_Coverage, 1847,
     /* 2298777 */     GIR_EraseRootFromParent_Done,
     /* 2298778 */   // Label 33178: @2298778
     /* 2298778 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2298806), // Rule ID 1879 //
     /* 2298783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2298786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298794 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2298794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2298797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298805 */     // GIR_Coverage, 1879,
     /* 2298805 */     GIR_EraseRootFromParent_Done,
     /* 2298806 */   // Label 33179: @2298806
     /* 2298806 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2298834), // Rule ID 1880 //
     /* 2298811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2298814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298822 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2298822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2298825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298833 */     // GIR_Coverage, 1880,
     /* 2298833 */     GIR_EraseRootFromParent_Done,
     /* 2298834 */   // Label 33180: @2298834
     /* 2298834 */   GIM_Reject,
     /* 2298835 */ // Label 33176: @2298835
     /* 2298835 */ GIM_Reject,
     /* 2298836 */ // Label 33158: @2298836
     /* 2298836 */ GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2298957),
     /* 2298841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2298844 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2298872), // Rule ID 1137 //
     /* 2298849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2298852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298860 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2298860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2298863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298871 */     // GIR_Coverage, 1137,
     /* 2298871 */     GIR_EraseRootFromParent_Done,
     /* 2298872 */   // Label 33182: @2298872
     /* 2298872 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2298900), // Rule ID 1138 //
     /* 2298877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2298880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298888 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2298888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2298891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298899 */     // GIR_Coverage, 1138,
     /* 2298899 */     GIR_EraseRootFromParent_Done,
     /* 2298900 */   // Label 33183: @2298900
     /* 2298900 */   GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2298928), // Rule ID 1145 //
     /* 2298905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2298908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298916 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2298916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2298919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298927 */     // GIR_Coverage, 1145,
     /* 2298927 */     GIR_EraseRootFromParent_Done,
     /* 2298928 */   // Label 33184: @2298928
     /* 2298928 */   GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2298956), // Rule ID 1146 //
     /* 2298933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2298936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298944 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2298944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2298947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298955 */     // GIR_Coverage, 1146,
     /* 2298955 */     GIR_EraseRootFromParent_Done,
     /* 2298956 */   // Label 33185: @2298956
     /* 2298956 */   GIM_Reject,
     /* 2298957 */ // Label 33181: @2298957
     /* 2298957 */ GIM_Reject,
     /* 2298958 */ // Label 33159: @2298958
     /* 2298958 */ GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2299107),
     /* 2298963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2298966 */   GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2298994), // Rule ID 1480 //
     /* 2298971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2298974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2298978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2298982 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2298982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2298985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298993 */     // GIR_Coverage, 1480,
     /* 2298993 */     GIR_EraseRootFromParent_Done,
     /* 2298994 */   // Label 33187: @2298994
     /* 2298994 */   GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2299022), // Rule ID 1481 //
     /* 2298999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2299002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299010 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2299010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2299013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299021 */     // GIR_Coverage, 1481,
     /* 2299021 */     GIR_EraseRootFromParent_Done,
     /* 2299022 */   // Label 33188: @2299022
     /* 2299022 */   GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2299050), // Rule ID 1515 //
     /* 2299027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2299030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299038 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2299038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2299041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299049 */     // GIR_Coverage, 1515,
     /* 2299049 */     GIR_EraseRootFromParent_Done,
     /* 2299050 */   // Label 33189: @2299050
     /* 2299050 */   GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2299078), // Rule ID 1535 //
     /* 2299055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2299058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299066 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2299066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2299069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299077 */     // GIR_Coverage, 1535,
     /* 2299077 */     GIR_EraseRootFromParent_Done,
     /* 2299078 */   // Label 33190: @2299078
     /* 2299078 */   GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2299106), // Rule ID 1536 //
     /* 2299083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2299086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299094 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2299094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2299097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299105 */     // GIR_Coverage, 1536,
     /* 2299105 */     GIR_EraseRootFromParent_Done,
     /* 2299106 */   // Label 33191: @2299106
     /* 2299106 */   GIM_Reject,
     /* 2299107 */ // Label 33186: @2299107
     /* 2299107 */ GIM_Reject,
     /* 2299108 */ // Label 33160: @2299108
     /* 2299108 */ GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2299217),
     /* 2299113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299124 */   GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2299170), // Rule ID 55690 //
     /* 2299129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299132 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2299149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299169 */     // GIR_Coverage, 55690,
     /* 2299169 */     GIR_EraseRootFromParent_Done,
     /* 2299170 */   // Label 33193: @2299170
     /* 2299170 */   GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2299216), // Rule ID 55691 //
     /* 2299175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299178 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2299195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299215 */     // GIR_Coverage, 55691,
     /* 2299215 */     GIR_EraseRootFromParent_Done,
     /* 2299216 */   // Label 33194: @2299216
     /* 2299216 */   GIM_Reject,
     /* 2299217 */ // Label 33192: @2299217
     /* 2299217 */ GIM_Reject,
     /* 2299218 */ // Label 33161: @2299218
     /* 2299218 */ GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2299327),
     /* 2299223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299234 */   GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2299280), // Rule ID 55730 //
     /* 2299239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299242 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2299259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299279 */     // GIR_Coverage, 55730,
     /* 2299279 */     GIR_EraseRootFromParent_Done,
     /* 2299280 */   // Label 33196: @2299280
     /* 2299280 */   GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2299326), // Rule ID 55731 //
     /* 2299285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299288 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2299305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299325 */     // GIR_Coverage, 55731,
     /* 2299325 */     GIR_EraseRootFromParent_Done,
     /* 2299326 */   // Label 33197: @2299326
     /* 2299326 */   GIM_Reject,
     /* 2299327 */ // Label 33195: @2299327
     /* 2299327 */ GIM_Reject,
     /* 2299328 */ // Label 33162: @2299328
     /* 2299328 */ GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2299437),
     /* 2299333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299344 */   GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2299390), // Rule ID 55790 //
     /* 2299349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299352 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2299369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299389 */     // GIR_Coverage, 55790,
     /* 2299389 */     GIR_EraseRootFromParent_Done,
     /* 2299390 */   // Label 33199: @2299390
     /* 2299390 */   GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2299436), // Rule ID 55791 //
     /* 2299395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299398 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2299415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299435 */     // GIR_Coverage, 55791,
     /* 2299435 */     GIR_EraseRootFromParent_Done,
     /* 2299436 */   // Label 33200: @2299436
     /* 2299436 */   GIM_Reject,
     /* 2299437 */ // Label 33198: @2299437
     /* 2299437 */ GIM_Reject,
     /* 2299438 */ // Label 33163: @2299438
     /* 2299438 */ GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2299547),
     /* 2299443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299454 */   GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2299500), // Rule ID 55710 //
     /* 2299459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299462 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2299479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299499 */     // GIR_Coverage, 55710,
     /* 2299499 */     GIR_EraseRootFromParent_Done,
     /* 2299500 */   // Label 33202: @2299500
     /* 2299500 */   GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2299546), // Rule ID 55711 //
     /* 2299505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299508 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2299525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299545 */     // GIR_Coverage, 55711,
     /* 2299545 */     GIR_EraseRootFromParent_Done,
     /* 2299546 */   // Label 33203: @2299546
     /* 2299546 */   GIM_Reject,
     /* 2299547 */ // Label 33201: @2299547
     /* 2299547 */ GIM_Reject,
     /* 2299548 */ // Label 33164: @2299548
     /* 2299548 */ GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2299657),
     /* 2299553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2299556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299564 */   GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2299610), // Rule ID 55770 //
     /* 2299569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299572 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2299589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299609 */     // GIR_Coverage, 55770,
     /* 2299609 */     GIR_EraseRootFromParent_Done,
     /* 2299610 */   // Label 33205: @2299610
     /* 2299610 */   GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2299656), // Rule ID 55771 //
     /* 2299615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299618 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2299635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299655 */     // GIR_Coverage, 55771,
     /* 2299655 */     GIR_EraseRootFromParent_Done,
     /* 2299656 */   // Label 33206: @2299656
     /* 2299656 */   GIM_Reject,
     /* 2299657 */ // Label 33204: @2299657
     /* 2299657 */ GIM_Reject,
     /* 2299658 */ // Label 33165: @2299658
     /* 2299658 */ GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2299767),
     /* 2299663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2299666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299674 */   GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2299720), // Rule ID 55930 //
     /* 2299679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299682 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2299699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299719 */     // GIR_Coverage, 55930,
     /* 2299719 */     GIR_EraseRootFromParent_Done,
     /* 2299720 */   // Label 33208: @2299720
     /* 2299720 */   GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2299766), // Rule ID 55931 //
     /* 2299725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299728 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2299745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299765 */     // GIR_Coverage, 55931,
     /* 2299765 */     GIR_EraseRootFromParent_Done,
     /* 2299766 */   // Label 33209: @2299766
     /* 2299766 */   GIM_Reject,
     /* 2299767 */ // Label 33207: @2299767
     /* 2299767 */ GIM_Reject,
     /* 2299768 */ // Label 33166: @2299768
     /* 2299768 */ GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2299877),
     /* 2299773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2299776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299784 */   GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2299830), // Rule ID 55750 //
     /* 2299789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299792 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2299795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2299809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299829 */     // GIR_Coverage, 55750,
     /* 2299829 */     GIR_EraseRootFromParent_Done,
     /* 2299830 */   // Label 33211: @2299830
     /* 2299830 */   GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2299876), // Rule ID 55751 //
     /* 2299835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299838 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2299841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2299855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299875 */     // GIR_Coverage, 55751,
     /* 2299875 */     GIR_EraseRootFromParent_Done,
     /* 2299876 */   // Label 33212: @2299876
     /* 2299876 */   GIM_Reject,
     /* 2299877 */ // Label 33210: @2299877
     /* 2299877 */ GIM_Reject,
     /* 2299878 */ // Label 33167: @2299878
     /* 2299878 */ GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2299987),
     /* 2299883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2299886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299894 */   GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2299940), // Rule ID 55870 //
     /* 2299899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299902 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2299905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2299919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299939 */     // GIR_Coverage, 55870,
     /* 2299939 */     GIR_EraseRootFromParent_Done,
     /* 2299940 */   // Label 33214: @2299940
     /* 2299940 */   GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2299986), // Rule ID 55871 //
     /* 2299945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299948 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2299951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2299965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2299972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299985 */     // GIR_Coverage, 55871,
     /* 2299985 */     GIR_EraseRootFromParent_Done,
     /* 2299986 */   // Label 33215: @2299986
     /* 2299986 */   GIM_Reject,
     /* 2299987 */ // Label 33213: @2299987
     /* 2299987 */ GIM_Reject,
     /* 2299988 */ // Label 33168: @2299988
     /* 2299988 */ GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2300097),
     /* 2299993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300004 */   GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2300050), // Rule ID 55950 //
     /* 2300009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300012 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2300029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300049 */     // GIR_Coverage, 55950,
     /* 2300049 */     GIR_EraseRootFromParent_Done,
     /* 2300050 */   // Label 33217: @2300050
     /* 2300050 */   GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2300096), // Rule ID 55951 //
     /* 2300055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300058 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2300075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300095 */     // GIR_Coverage, 55951,
     /* 2300095 */     GIR_EraseRootFromParent_Done,
     /* 2300096 */   // Label 33218: @2300096
     /* 2300096 */   GIM_Reject,
     /* 2300097 */ // Label 33216: @2300097
     /* 2300097 */ GIM_Reject,
     /* 2300098 */ // Label 33169: @2300098
     /* 2300098 */ GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2300207),
     /* 2300103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300114 */   GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2300160), // Rule ID 55810 //
     /* 2300119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300122 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2300139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300159 */     // GIR_Coverage, 55810,
     /* 2300159 */     GIR_EraseRootFromParent_Done,
     /* 2300160 */   // Label 33220: @2300160
     /* 2300160 */   GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2300206), // Rule ID 55811 //
     /* 2300165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300168 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2300185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300205 */     // GIR_Coverage, 55811,
     /* 2300205 */     GIR_EraseRootFromParent_Done,
     /* 2300206 */   // Label 33221: @2300206
     /* 2300206 */   GIM_Reject,
     /* 2300207 */ // Label 33219: @2300207
     /* 2300207 */ GIM_Reject,
     /* 2300208 */ // Label 33170: @2300208
     /* 2300208 */ GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2300317),
     /* 2300213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300224 */   GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2300270), // Rule ID 55890 //
     /* 2300229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300232 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2300249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300269 */     // GIR_Coverage, 55890,
     /* 2300269 */     GIR_EraseRootFromParent_Done,
     /* 2300270 */   // Label 33223: @2300270
     /* 2300270 */   GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2300316), // Rule ID 55891 //
     /* 2300275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300278 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2300295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300315 */     // GIR_Coverage, 55891,
     /* 2300315 */     GIR_EraseRootFromParent_Done,
     /* 2300316 */   // Label 33224: @2300316
     /* 2300316 */   GIM_Reject,
     /* 2300317 */ // Label 33222: @2300317
     /* 2300317 */ GIM_Reject,
     /* 2300318 */ // Label 33171: @2300318
     /* 2300318 */ GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2300427),
     /* 2300323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2300326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300334 */   GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2300380), // Rule ID 55970 //
     /* 2300339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300342 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2300359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300379 */     // GIR_Coverage, 55970,
     /* 2300379 */     GIR_EraseRootFromParent_Done,
     /* 2300380 */   // Label 33226: @2300380
     /* 2300380 */   GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2300426), // Rule ID 55971 //
     /* 2300385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300388 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2300405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300425 */     // GIR_Coverage, 55971,
     /* 2300425 */     GIR_EraseRootFromParent_Done,
     /* 2300426 */   // Label 33227: @2300426
     /* 2300426 */   GIM_Reject,
     /* 2300427 */ // Label 33225: @2300427
     /* 2300427 */ GIM_Reject,
     /* 2300428 */ // Label 33172: @2300428
     /* 2300428 */ GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2300537),
     /* 2300433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2300436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300444 */   GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2300490), // Rule ID 55830 //
     /* 2300449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300452 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2300469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300489 */     // GIR_Coverage, 55830,
     /* 2300489 */     GIR_EraseRootFromParent_Done,
     /* 2300490 */   // Label 33229: @2300490
     /* 2300490 */   GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2300536), // Rule ID 55831 //
     /* 2300495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300498 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2300515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300535 */     // GIR_Coverage, 55831,
     /* 2300535 */     GIR_EraseRootFromParent_Done,
     /* 2300536 */   // Label 33230: @2300536
     /* 2300536 */   GIM_Reject,
     /* 2300537 */ // Label 33228: @2300537
     /* 2300537 */ GIM_Reject,
     /* 2300538 */ // Label 33173: @2300538
     /* 2300538 */ GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2300647),
     /* 2300543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2300546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300554 */   GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2300600), // Rule ID 55910 //
     /* 2300559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300562 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2300579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300599 */     // GIR_Coverage, 55910,
     /* 2300599 */     GIR_EraseRootFromParent_Done,
     /* 2300600 */   // Label 33232: @2300600
     /* 2300600 */   GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2300646), // Rule ID 55911 //
     /* 2300605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300608 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2300625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300645 */     // GIR_Coverage, 55911,
     /* 2300645 */     GIR_EraseRootFromParent_Done,
     /* 2300646 */   // Label 33233: @2300646
     /* 2300646 */   GIM_Reject,
     /* 2300647 */ // Label 33231: @2300647
     /* 2300647 */ GIM_Reject,
     /* 2300648 */ // Label 33174: @2300648
     /* 2300648 */ GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2300757),
     /* 2300653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2300656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300664 */   GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2300710), // Rule ID 55850 //
     /* 2300669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300672 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2300675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2300689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300709 */     // GIR_Coverage, 55850,
     /* 2300709 */     GIR_EraseRootFromParent_Done,
     /* 2300710 */   // Label 33235: @2300710
     /* 2300710 */   GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2300756), // Rule ID 55851 //
     /* 2300715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300718 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2300721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2300735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2300742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300755 */     // GIR_Coverage, 55851,
     /* 2300755 */     GIR_EraseRootFromParent_Done,
     /* 2300756 */   // Label 33236: @2300756
     /* 2300756 */   GIM_Reject,
     /* 2300757 */ // Label 33234: @2300757
     /* 2300757 */ GIM_Reject,
     /* 2300758 */ // Label 33175: @2300758
     /* 2300758 */ GIM_Reject,
     /* 2300759 */ // Label 100: @2300759
     /* 2300759 */ GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2300771), // Rule ID 282 //
     /* 2300764 */   // (trap)  =>  (UNIMP)
     /* 2300764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2300769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2300770 */   // GIR_Coverage, 282,
     /* 2300770 */   GIR_Done,
     /* 2300771 */ // Label 33237: @2300771
     /* 2300771 */ GIM_Reject,
     /* 2300772 */ // Label 101: @2300772
     /* 2300772 */ GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2300784), // Rule ID 283 //
     /* 2300777 */   // (debugtrap)  =>  (EBREAK)
     /* 2300777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2300782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2300783 */   // GIR_Coverage, 283,
     /* 2300783 */   GIR_Done,
     /* 2300784 */ // Label 33238: @2300784
     /* 2300784 */ GIM_Reject,
     /* 2300785 */ // Label 102: @2300785
     /* 2300785 */ GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2300879),
     /* 2300790 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2300793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2300796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300800 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2300819), // Rule ID 2378 //
     /* 2300805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2300808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300812 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2300812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2300817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300818 */     // GIR_Coverage, 2378,
     /* 2300818 */     GIR_Done,
     /* 2300819 */   // Label 33240: @2300819
     /* 2300819 */   GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2300878), // Rule ID 61881 //
     /* 2300824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2300827 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2300827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2300830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2300834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2300843 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2300846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2300848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2300851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2300855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2300863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2300866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2300871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300877 */     // GIR_Coverage, 61881,
     /* 2300877 */     GIR_EraseRootFromParent_Done,
     /* 2300878 */   // Label 33241: @2300878
     /* 2300878 */   GIM_Reject,
     /* 2300879 */ // Label 33239: @2300879
     /* 2300879 */ GIM_Reject,
     /* 2300880 */ // Label 103: @2300880
     /* 2300880 */ GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2300909), // Rule ID 2379 //
     /* 2300885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2300888 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2300891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2300894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300902 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2300902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2300907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2300908 */   // GIR_Coverage, 2379,
     /* 2300908 */   GIR_Done,
     /* 2300909 */ // Label 33242: @2300909
     /* 2300909 */ GIM_Reject,
     /* 2300910 */ // Label 104: @2300910
     /* 2300910 */ GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2300946), // Rule ID 305 //
     /* 2300915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2300918 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2300921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2300924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2300927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300939 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2300939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2300944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2300945 */   // GIR_Coverage, 305,
     /* 2300945 */   GIR_Done,
     /* 2300946 */ // Label 33243: @2300946
     /* 2300946 */ GIM_Reject,
     /* 2300947 */ // Label 105: @2300947
     /* 2300947 */ GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2300983), // Rule ID 304 //
     /* 2300952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2300955 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2300958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2300961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2300964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2300976 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2300976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2300981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2300982 */   // GIR_Coverage, 304,
     /* 2300982 */   GIR_Done,
     /* 2300983 */ // Label 33244: @2300983
     /* 2300983 */ GIM_Reject,
     /* 2300984 */ // Label 106: @2300984
     /* 2300984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33247*/ GIMT_Encode4(2301343),
     /* 2300995 */ /*GILLT_s32*//*Label 33245*/ GIMT_Encode4(2301003),
     /* 2300999 */ /*GILLT_s64*//*Label 33246*/ GIMT_Encode4(2301160),
     /* 2301003 */ // Label 33245: @2301003
     /* 2301003 */ GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2301029), // Rule ID 1144 //
     /* 2301008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2301011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301022 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2301022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2301027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301028 */   // GIR_Coverage, 1144,
     /* 2301028 */   GIR_Done,
     /* 2301029 */ // Label 33248: @2301029
     /* 2301029 */ GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2301055), // Rule ID 1152 //
     /* 2301034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2301037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301048 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2301048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2301053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301054 */   // GIR_Coverage, 1152,
     /* 2301054 */   GIR_Done,
     /* 2301055 */ // Label 33249: @2301055
     /* 2301055 */ GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2301081), // Rule ID 1487 //
     /* 2301060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2301063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301074 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2301074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2301079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301080 */   // GIR_Coverage, 1487,
     /* 2301080 */   GIR_Done,
     /* 2301081 */ // Label 33250: @2301081
     /* 2301081 */ GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2301107), // Rule ID 1542 //
     /* 2301086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2301089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301100 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2301100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2301105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301106 */   // GIR_Coverage, 1542,
     /* 2301106 */   GIR_Done,
     /* 2301107 */ // Label 33251: @2301107
     /* 2301107 */ GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2301133), // Rule ID 1853 //
     /* 2301112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2301115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301126 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2301126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2301131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301132 */   // GIR_Coverage, 1853,
     /* 2301132 */   GIR_Done,
     /* 2301133 */ // Label 33252: @2301133
     /* 2301133 */ GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2301159), // Rule ID 1886 //
     /* 2301138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2301141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301152 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2301152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2301157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301158 */   // GIR_Coverage, 1886,
     /* 2301158 */   GIR_Done,
     /* 2301159 */ // Label 33253: @2301159
     /* 2301159 */ GIM_Reject,
     /* 2301160 */ // Label 33246: @2301160
     /* 2301160 */ GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2301186), // Rule ID 1143 //
     /* 2301165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2301168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301179 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2301179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2301184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301185 */   // GIR_Coverage, 1143,
     /* 2301185 */   GIR_Done,
     /* 2301186 */ // Label 33254: @2301186
     /* 2301186 */ GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2301212), // Rule ID 1151 //
     /* 2301191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2301194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301205 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2301205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2301210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301211 */   // GIR_Coverage, 1151,
     /* 2301211 */   GIR_Done,
     /* 2301212 */ // Label 33255: @2301212
     /* 2301212 */ GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2301238), // Rule ID 1486 //
     /* 2301217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2301220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301231 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2301231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2301236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301237 */   // GIR_Coverage, 1486,
     /* 2301237 */   GIR_Done,
     /* 2301238 */ // Label 33256: @2301238
     /* 2301238 */ GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2301264), // Rule ID 1519 //
     /* 2301243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2301246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301257 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2301257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2301262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301263 */   // GIR_Coverage, 1519,
     /* 2301263 */   GIR_Done,
     /* 2301264 */ // Label 33257: @2301264
     /* 2301264 */ GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2301290), // Rule ID 1541 //
     /* 2301269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2301272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301283 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2301283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2301288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301289 */   // GIR_Coverage, 1541,
     /* 2301289 */   GIR_Done,
     /* 2301290 */ // Label 33258: @2301290
     /* 2301290 */ GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2301316), // Rule ID 1852 //
     /* 2301295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2301298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301309 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2301309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2301314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301315 */   // GIR_Coverage, 1852,
     /* 2301315 */   GIR_Done,
     /* 2301316 */ // Label 33259: @2301316
     /* 2301316 */ GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2301342), // Rule ID 1885 //
     /* 2301321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2301324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301335 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2301335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2301340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301341 */   // GIR_Coverage, 1885,
     /* 2301341 */   GIR_Done,
     /* 2301342 */ // Label 33260: @2301342
     /* 2301342 */ GIM_Reject,
     /* 2301343 */ // Label 33247: @2301343
     /* 2301343 */ GIM_Reject,
     /* 2301344 */ // Label 107: @2301344
     /* 2301344 */ GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2301541),
     /* 2301349 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2301352 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33265*/ GIMT_Encode4(2301540),
     /* 2301363 */   /*GILLT_s16*//*Label 33262*/ GIMT_Encode4(2301375),
     /* 2301367 */   /*GILLT_s32*//*Label 33263*/ GIMT_Encode4(2301430),
     /* 2301371 */   /*GILLT_s64*//*Label 33264*/ GIMT_Encode4(2301485),
     /* 2301375 */   // Label 33262: @2301375
     /* 2301375 */   GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2301429),
     /* 2301380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301384 */     GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2301406), // Rule ID 2103 //
     /* 2301389 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2301392 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301396 */       // MIs[0] frm
     /* 2301396 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301399 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301399 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2301404 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301405 */       // GIR_Coverage, 2103,
     /* 2301405 */       GIR_Done,
     /* 2301406 */     // Label 33267: @2301406
     /* 2301406 */     GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2301428), // Rule ID 2129 //
     /* 2301411 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2301414 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301418 */       // MIs[0] frm
     /* 2301418 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301421 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301421 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2301426 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301427 */       // GIR_Coverage, 2129,
     /* 2301427 */       GIR_Done,
     /* 2301428 */     // Label 33268: @2301428
     /* 2301428 */     GIM_Reject,
     /* 2301429 */   // Label 33266: @2301429
     /* 2301429 */   GIM_Reject,
     /* 2301430 */   // Label 33263: @2301430
     /* 2301430 */   GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2301484),
     /* 2301435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301439 */     GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2301461), // Rule ID 1369 //
     /* 2301444 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2301447 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301451 */       // MIs[0] frm
     /* 2301451 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301454 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301454 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2301459 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301460 */       // GIR_Coverage, 1369,
     /* 2301460 */       GIR_Done,
     /* 2301461 */     // Label 33270: @2301461
     /* 2301461 */     GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2301483), // Rule ID 1397 //
     /* 2301466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2301469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301473 */       // MIs[0] frm
     /* 2301473 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301476 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301476 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2301481 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301482 */       // GIR_Coverage, 1397,
     /* 2301482 */       GIR_Done,
     /* 2301483 */     // Label 33271: @2301483
     /* 2301483 */     GIM_Reject,
     /* 2301484 */   // Label 33269: @2301484
     /* 2301484 */   GIM_Reject,
     /* 2301485 */   // Label 33264: @2301485
     /* 2301485 */   GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2301539),
     /* 2301490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301494 */     GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2301516), // Rule ID 1763 //
     /* 2301499 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2301502 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301506 */       // MIs[0] frm
     /* 2301506 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301509 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301509 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2301514 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301515 */       // GIR_Coverage, 1763,
     /* 2301515 */       GIR_Done,
     /* 2301516 */     // Label 33273: @2301516
     /* 2301516 */     GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2301538), // Rule ID 1791 //
     /* 2301521 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2301524 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301528 */       // MIs[0] frm
     /* 2301528 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301531 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301531 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2301536 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301537 */       // GIR_Coverage, 1791,
     /* 2301537 */       GIR_Done,
     /* 2301538 */     // Label 33274: @2301538
     /* 2301538 */     GIM_Reject,
     /* 2301539 */   // Label 33272: @2301539
     /* 2301539 */   GIM_Reject,
     /* 2301540 */   // Label 33265: @2301540
     /* 2301540 */   GIM_Reject,
     /* 2301541 */ // Label 33261: @2301541
     /* 2301541 */ GIM_Reject,
     /* 2301542 */ // Label 108: @2301542
     /* 2301542 */ GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2301739),
     /* 2301547 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2301550 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33279*/ GIMT_Encode4(2301738),
     /* 2301561 */   /*GILLT_s16*//*Label 33276*/ GIMT_Encode4(2301573),
     /* 2301565 */   /*GILLT_s32*//*Label 33277*/ GIMT_Encode4(2301628),
     /* 2301569 */   /*GILLT_s64*//*Label 33278*/ GIMT_Encode4(2301683),
     /* 2301573 */   // Label 33276: @2301573
     /* 2301573 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2301627),
     /* 2301578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301582 */     GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2301604), // Rule ID 2101 //
     /* 2301587 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2301590 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301594 */       // MIs[0] frm
     /* 2301594 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301597 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301597 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2301602 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301603 */       // GIR_Coverage, 2101,
     /* 2301603 */       GIR_Done,
     /* 2301604 */     // Label 33281: @2301604
     /* 2301604 */     GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2301626), // Rule ID 2127 //
     /* 2301609 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2301612 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301616 */       // MIs[0] frm
     /* 2301616 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301619 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301619 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2301624 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301625 */       // GIR_Coverage, 2127,
     /* 2301625 */       GIR_Done,
     /* 2301626 */     // Label 33282: @2301626
     /* 2301626 */     GIM_Reject,
     /* 2301627 */   // Label 33280: @2301627
     /* 2301627 */   GIM_Reject,
     /* 2301628 */   // Label 33277: @2301628
     /* 2301628 */   GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2301682),
     /* 2301633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301637 */     GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2301659), // Rule ID 1367 //
     /* 2301642 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2301645 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301649 */       // MIs[0] frm
     /* 2301649 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301652 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301652 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2301657 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301658 */       // GIR_Coverage, 1367,
     /* 2301658 */       GIR_Done,
     /* 2301659 */     // Label 33284: @2301659
     /* 2301659 */     GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2301681), // Rule ID 1395 //
     /* 2301664 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2301667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301671 */       // MIs[0] frm
     /* 2301671 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301674 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301674 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2301679 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301680 */       // GIR_Coverage, 1395,
     /* 2301680 */       GIR_Done,
     /* 2301681 */     // Label 33285: @2301681
     /* 2301681 */     GIM_Reject,
     /* 2301682 */   // Label 33283: @2301682
     /* 2301682 */   GIM_Reject,
     /* 2301683 */   // Label 33278: @2301683
     /* 2301683 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2301737),
     /* 2301688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301692 */     GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2301714), // Rule ID 1761 //
     /* 2301697 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2301700 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301704 */       // MIs[0] frm
     /* 2301704 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301707 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301707 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2301712 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301713 */       // GIR_Coverage, 1761,
     /* 2301713 */       GIR_Done,
     /* 2301714 */     // Label 33287: @2301714
     /* 2301714 */     GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2301736), // Rule ID 1789 //
     /* 2301719 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2301722 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301726 */       // MIs[0] frm
     /* 2301726 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2301729 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2301729 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2301734 */       GIR_RootConstrainSelectedInstOperands,
     /* 2301735 */       // GIR_Coverage, 1789,
     /* 2301735 */       GIR_Done,
     /* 2301736 */     // Label 33288: @2301736
     /* 2301736 */     GIM_Reject,
     /* 2301737 */   // Label 33286: @2301737
     /* 2301737 */   GIM_Reject,
     /* 2301738 */   // Label 33279: @2301738
     /* 2301738 */   GIM_Reject,
     /* 2301739 */ // Label 33275: @2301739
     /* 2301739 */ GIM_Reject,
     /* 2301740 */ // Label 109: @2301740
     /* 2301740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33291*/ GIMT_Encode4(2301799),
     /* 2301751 */ /*GILLT_s32*//*Label 33289*/ GIMT_Encode4(2301759),
     /* 2301755 */ /*GILLT_s64*//*Label 33290*/ GIMT_Encode4(2301779),
     /* 2301759 */ // Label 33289: @2301759
     /* 2301759 */ GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2301778), // Rule ID 67 //
     /* 2301764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301771 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2301771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2301776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301777 */   // GIR_Coverage, 67,
     /* 2301777 */   GIR_Done,
     /* 2301778 */ // Label 33292: @2301778
     /* 2301778 */ GIM_Reject,
     /* 2301779 */ // Label 33290: @2301779
     /* 2301779 */ GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2301798), // Rule ID 66 //
     /* 2301784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301791 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2301791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2301796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301797 */   // GIR_Coverage, 66,
     /* 2301797 */   GIR_Done,
     /* 2301798 */ // Label 33293: @2301798
     /* 2301798 */ GIM_Reject,
     /* 2301799 */ // Label 33291: @2301799
     /* 2301799 */ GIM_Reject,
     /* 2301800 */ // Label 110: @2301800
     /* 2301800 */ GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2301836), // Rule ID 306 //
     /* 2301805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2301808 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2301811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301829 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2301829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2301834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2301835 */   // GIR_Coverage, 306,
     /* 2301835 */   GIR_Done,
     /* 2301836 */ // Label 33294: @2301836
     /* 2301836 */ GIM_Reject,
     /* 2301837 */ // Label 111: @2301837
     /* 2301837 */ GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2301961),
     /* 2301842 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2301845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301859 */   GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2301895), // Rule ID 2327 //
     /* 2301864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2301867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2301875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2301879 */     // MIs[1] Operand 1
     /* 2301879 */     // No operand predicates
     /* 2301879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301881 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2301881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2301884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301888 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2301893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301894 */     // GIR_Coverage, 2327,
     /* 2301894 */     GIR_EraseRootFromParent_Done,
     /* 2301895 */   // Label 33296: @2301895
     /* 2301895 */   GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2301931), // Rule ID 61878 //
     /* 2301900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2301903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2301911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2301915 */     // MIs[1] Operand 1
     /* 2301915 */     // No operand predicates
     /* 2301915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301917 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2301917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2301920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301924 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2301929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301930 */     // GIR_Coverage, 61878,
     /* 2301930 */     GIR_EraseRootFromParent_Done,
     /* 2301931 */   // Label 33297: @2301931
     /* 2301931 */   GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2301960), // Rule ID 2324 //
     /* 2301936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2301939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2301946 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2301946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2301949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2301958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301959 */     // GIR_Coverage, 2324,
     /* 2301959 */     GIR_EraseRootFromParent_Done,
     /* 2301960 */   // Label 33298: @2301960
     /* 2301960 */   GIM_Reject,
     /* 2301961 */ // Label 33295: @2301961
     /* 2301961 */ GIM_Reject,
     /* 2301962 */ // Label 112: @2301962
     /* 2301962 */ GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2302082),
     /* 2301967 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2301970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301984 */   GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2302018), // Rule ID 2326 //
     /* 2301989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2301992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2302000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2302004 */     // MIs[1] Operand 1
     /* 2302004 */     // No operand predicates
     /* 2302004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302006 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2302006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2302009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2302016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302017 */     // GIR_Coverage, 2326,
     /* 2302017 */     GIR_EraseRootFromParent_Done,
     /* 2302018 */   // Label 33300: @2302018
     /* 2302018 */   GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2302052), // Rule ID 61877 //
     /* 2302023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2302026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2302034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2302038 */     // MIs[1] Operand 1
     /* 2302038 */     // No operand predicates
     /* 2302038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302040 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2302040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2302043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2302050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302051 */     // GIR_Coverage, 61877,
     /* 2302051 */     GIR_EraseRootFromParent_Done,
     /* 2302052 */   // Label 33301: @2302052
     /* 2302052 */   GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2302081), // Rule ID 2325 //
     /* 2302057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2302060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2302067 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2302067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2302070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2302079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302080 */     // GIR_Coverage, 2325,
     /* 2302080 */     GIR_EraseRootFromParent_Done,
     /* 2302081 */   // Label 33302: @2302081
     /* 2302081 */   GIM_Reject,
     /* 2302082 */ // Label 33299: @2302082
     /* 2302082 */ GIM_Reject,
     /* 2302083 */ // Label 113: @2302083
     /* 2302083 */ GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2302129), // Rule ID 261 //
     /* 2302088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2302091 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2302094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2302100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2302115 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2302115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2302118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302120 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2302127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302128 */   // GIR_Coverage, 261,
     /* 2302128 */   GIR_EraseRootFromParent_Done,
     /* 2302129 */ // Label 33303: @2302129
     /* 2302129 */ GIM_Reject,
     /* 2302130 */ // Label 114: @2302130
     /* 2302130 */ GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2302176), // Rule ID 263 //
     /* 2302135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2302138 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2302141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2302147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2302162 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2302162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2302165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302167 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2302174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302175 */   // GIR_Coverage, 263,
     /* 2302175 */   GIR_EraseRootFromParent_Done,
     /* 2302176 */ // Label 33304: @2302176
     /* 2302176 */ GIM_Reject,
     /* 2302177 */ // Label 115: @2302177
     /* 2302177 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2302223), // Rule ID 262 //
     /* 2302182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2302185 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2302188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2302194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302202 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2302209 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2302209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2302212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302214 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2302221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302222 */   // GIR_Coverage, 262,
     /* 2302222 */   GIR_EraseRootFromParent_Done,
     /* 2302223 */ // Label 33305: @2302223
     /* 2302223 */ GIM_Reject,
     /* 2302224 */ // Label 116: @2302224
     /* 2302224 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 33313*/ GIMT_Encode4(2302872),
     /* 2302235 */ /*GILLT_nxv1s1*//*Label 33306*/ GIMT_Encode4(2302347), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302255 */ /*GILLT_nxv2s1*//*Label 33307*/ GIMT_Encode4(2302422), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302275 */ /*GILLT_nxv4s1*//*Label 33308*/ GIMT_Encode4(2302497), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302295 */ /*GILLT_nxv8s1*//*Label 33309*/ GIMT_Encode4(2302572), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302315 */ /*GILLT_nxv16s1*//*Label 33310*/ GIMT_Encode4(2302647), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302331 */ /*GILLT_nxv32s1*//*Label 33311*/ GIMT_Encode4(2302722), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302343 */ /*GILLT_nxv64s1*//*Label 33312*/ GIMT_Encode4(2302797),
     /* 2302347 */ // Label 33306: @2302347
     /* 2302347 */ GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2302384), // Rule ID 44396 //
     /* 2302352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302369 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2302372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302383 */   // GIR_Coverage, 44396,
     /* 2302383 */   GIR_EraseRootFromParent_Done,
     /* 2302384 */ // Label 33314: @2302384
     /* 2302384 */ GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2302421), // Rule ID 44397 //
     /* 2302389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302399 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302406 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2302409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302420 */   // GIR_Coverage, 44397,
     /* 2302420 */   GIR_EraseRootFromParent_Done,
     /* 2302421 */ // Label 33315: @2302421
     /* 2302421 */ GIM_Reject,
     /* 2302422 */ // Label 33307: @2302422
     /* 2302422 */ GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2302459), // Rule ID 44424 //
     /* 2302427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302444 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2302447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302458 */   // GIR_Coverage, 44424,
     /* 2302458 */   GIR_EraseRootFromParent_Done,
     /* 2302459 */ // Label 33316: @2302459
     /* 2302459 */ GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2302496), // Rule ID 44425 //
     /* 2302464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302474 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302481 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2302484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302495 */   // GIR_Coverage, 44425,
     /* 2302495 */   GIR_EraseRootFromParent_Done,
     /* 2302496 */ // Label 33317: @2302496
     /* 2302496 */ GIM_Reject,
     /* 2302497 */ // Label 33308: @2302497
     /* 2302497 */ GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2302534), // Rule ID 44452 //
     /* 2302502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302519 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2302522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302533 */   // GIR_Coverage, 44452,
     /* 2302533 */   GIR_EraseRootFromParent_Done,
     /* 2302534 */ // Label 33318: @2302534
     /* 2302534 */ GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2302571), // Rule ID 44453 //
     /* 2302539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302556 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2302559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302570 */   // GIR_Coverage, 44453,
     /* 2302570 */   GIR_EraseRootFromParent_Done,
     /* 2302571 */ // Label 33319: @2302571
     /* 2302571 */ GIM_Reject,
     /* 2302572 */ // Label 33309: @2302572
     /* 2302572 */ GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2302609), // Rule ID 44480 //
     /* 2302577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302594 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2302597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302608 */   // GIR_Coverage, 44480,
     /* 2302608 */   GIR_EraseRootFromParent_Done,
     /* 2302609 */ // Label 33320: @2302609
     /* 2302609 */ GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2302646), // Rule ID 44481 //
     /* 2302614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302631 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2302634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302645 */   // GIR_Coverage, 44481,
     /* 2302645 */   GIR_EraseRootFromParent_Done,
     /* 2302646 */ // Label 33321: @2302646
     /* 2302646 */ GIM_Reject,
     /* 2302647 */ // Label 33310: @2302647
     /* 2302647 */ GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2302684), // Rule ID 44508 //
     /* 2302652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302669 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2302672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302683 */   // GIR_Coverage, 44508,
     /* 2302683 */   GIR_EraseRootFromParent_Done,
     /* 2302684 */ // Label 33322: @2302684
     /* 2302684 */ GIM_Try, /*On fail goto*//*Label 33323*/ GIMT_Encode4(2302721), // Rule ID 44509 //
     /* 2302689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302706 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2302709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302720 */   // GIR_Coverage, 44509,
     /* 2302720 */   GIR_EraseRootFromParent_Done,
     /* 2302721 */ // Label 33323: @2302721
     /* 2302721 */ GIM_Reject,
     /* 2302722 */ // Label 33311: @2302722
     /* 2302722 */ GIM_Try, /*On fail goto*//*Label 33324*/ GIMT_Encode4(2302759), // Rule ID 44536 //
     /* 2302727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302744 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2302747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302758 */   // GIR_Coverage, 44536,
     /* 2302758 */   GIR_EraseRootFromParent_Done,
     /* 2302759 */ // Label 33324: @2302759
     /* 2302759 */ GIM_Try, /*On fail goto*//*Label 33325*/ GIMT_Encode4(2302796), // Rule ID 44537 //
     /* 2302764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302781 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2302784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302795 */   // GIR_Coverage, 44537,
     /* 2302795 */   GIR_EraseRootFromParent_Done,
     /* 2302796 */ // Label 33325: @2302796
     /* 2302796 */ GIM_Reject,
     /* 2302797 */ // Label 33312: @2302797
     /* 2302797 */ GIM_Try, /*On fail goto*//*Label 33326*/ GIMT_Encode4(2302834), // Rule ID 44564 //
     /* 2302802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302812 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302819 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2302819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2302822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302833 */   // GIR_Coverage, 44564,
     /* 2302833 */   GIR_EraseRootFromParent_Done,
     /* 2302834 */ // Label 33326: @2302834
     /* 2302834 */ GIM_Try, /*On fail goto*//*Label 33327*/ GIMT_Encode4(2302871), // Rule ID 44565 //
     /* 2302839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302849 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2302856 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2302856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2302859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2302866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2302869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2302870 */   // GIR_Coverage, 44565,
     /* 2302870 */   GIR_EraseRootFromParent_Done,
     /* 2302871 */ // Label 33327: @2302871
     /* 2302871 */ GIM_Reject,
     /* 2302872 */ // Label 33313: @2302872
     /* 2302872 */ GIM_Reject,
     /* 2302873 */ // Label 117: @2302873
     /* 2302873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 33335*/ GIMT_Encode4(2303521),
     /* 2302884 */ /*GILLT_nxv1s1*//*Label 33328*/ GIMT_Encode4(2302996), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302904 */ /*GILLT_nxv2s1*//*Label 33329*/ GIMT_Encode4(2303071), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302924 */ /*GILLT_nxv4s1*//*Label 33330*/ GIMT_Encode4(2303146), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302944 */ /*GILLT_nxv8s1*//*Label 33331*/ GIMT_Encode4(2303221), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302964 */ /*GILLT_nxv16s1*//*Label 33332*/ GIMT_Encode4(2303296), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302980 */ /*GILLT_nxv32s1*//*Label 33333*/ GIMT_Encode4(2303371), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302992 */ /*GILLT_nxv64s1*//*Label 33334*/ GIMT_Encode4(2303446),
     /* 2302996 */ // Label 33328: @2302996
     /* 2302996 */ GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2303033), // Rule ID 44394 //
     /* 2303001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303018 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2303021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303032 */   // GIR_Coverage, 44394,
     /* 2303032 */   GIR_EraseRootFromParent_Done,
     /* 2303033 */ // Label 33336: @2303033
     /* 2303033 */ GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2303070), // Rule ID 44395 //
     /* 2303038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303055 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2303058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303069 */   // GIR_Coverage, 44395,
     /* 2303069 */   GIR_EraseRootFromParent_Done,
     /* 2303070 */ // Label 33337: @2303070
     /* 2303070 */ GIM_Reject,
     /* 2303071 */ // Label 33329: @2303071
     /* 2303071 */ GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2303108), // Rule ID 44422 //
     /* 2303076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303093 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2303096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303107 */   // GIR_Coverage, 44422,
     /* 2303107 */   GIR_EraseRootFromParent_Done,
     /* 2303108 */ // Label 33338: @2303108
     /* 2303108 */ GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2303145), // Rule ID 44423 //
     /* 2303113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303130 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2303133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303144 */   // GIR_Coverage, 44423,
     /* 2303144 */   GIR_EraseRootFromParent_Done,
     /* 2303145 */ // Label 33339: @2303145
     /* 2303145 */ GIM_Reject,
     /* 2303146 */ // Label 33330: @2303146
     /* 2303146 */ GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2303183), // Rule ID 44450 //
     /* 2303151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303168 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2303171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303182 */   // GIR_Coverage, 44450,
     /* 2303182 */   GIR_EraseRootFromParent_Done,
     /* 2303183 */ // Label 33340: @2303183
     /* 2303183 */ GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2303220), // Rule ID 44451 //
     /* 2303188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303205 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2303208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303219 */   // GIR_Coverage, 44451,
     /* 2303219 */   GIR_EraseRootFromParent_Done,
     /* 2303220 */ // Label 33341: @2303220
     /* 2303220 */ GIM_Reject,
     /* 2303221 */ // Label 33331: @2303221
     /* 2303221 */ GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2303258), // Rule ID 44478 //
     /* 2303226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303243 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2303246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303257 */   // GIR_Coverage, 44478,
     /* 2303257 */   GIR_EraseRootFromParent_Done,
     /* 2303258 */ // Label 33342: @2303258
     /* 2303258 */ GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2303295), // Rule ID 44479 //
     /* 2303263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303280 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2303283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303294 */   // GIR_Coverage, 44479,
     /* 2303294 */   GIR_EraseRootFromParent_Done,
     /* 2303295 */ // Label 33343: @2303295
     /* 2303295 */ GIM_Reject,
     /* 2303296 */ // Label 33332: @2303296
     /* 2303296 */ GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2303333), // Rule ID 44506 //
     /* 2303301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303318 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2303321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303332 */   // GIR_Coverage, 44506,
     /* 2303332 */   GIR_EraseRootFromParent_Done,
     /* 2303333 */ // Label 33344: @2303333
     /* 2303333 */ GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2303370), // Rule ID 44507 //
     /* 2303338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303355 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2303358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303369 */   // GIR_Coverage, 44507,
     /* 2303369 */   GIR_EraseRootFromParent_Done,
     /* 2303370 */ // Label 33345: @2303370
     /* 2303370 */ GIM_Reject,
     /* 2303371 */ // Label 33333: @2303371
     /* 2303371 */ GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2303408), // Rule ID 44534 //
     /* 2303376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303393 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2303396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303407 */   // GIR_Coverage, 44534,
     /* 2303407 */   GIR_EraseRootFromParent_Done,
     /* 2303408 */ // Label 33346: @2303408
     /* 2303408 */ GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2303445), // Rule ID 44535 //
     /* 2303413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303430 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2303433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303444 */   // GIR_Coverage, 44535,
     /* 2303444 */   GIR_EraseRootFromParent_Done,
     /* 2303445 */ // Label 33347: @2303445
     /* 2303445 */ GIM_Reject,
     /* 2303446 */ // Label 33334: @2303446
     /* 2303446 */ GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2303483), // Rule ID 44562 //
     /* 2303451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303468 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2303468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2303471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303482 */   // GIR_Coverage, 44562,
     /* 2303482 */   GIR_EraseRootFromParent_Done,
     /* 2303483 */ // Label 33348: @2303483
     /* 2303483 */ GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2303520), // Rule ID 44563 //
     /* 2303488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303505 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2303505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2303508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2303519 */   // GIR_Coverage, 44563,
     /* 2303519 */   GIR_EraseRootFromParent_Done,
     /* 2303520 */ // Label 33349: @2303520
     /* 2303520 */ GIM_Reject,
     /* 2303521 */ // Label 33335: @2303521
     /* 2303521 */ GIM_Reject,
     /* 2303522 */ // Label 118: @2303522
     /* 2303522 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33372*/ GIMT_Encode4(2307779),
     /* 2303533 */ /*GILLT_nxv1s8*//*Label 33350*/ GIMT_Encode4(2303645),
     /* 2303537 */ /*GILLT_nxv1s16*//*Label 33351*/ GIMT_Encode4(2303762),
     /* 2303541 */ /*GILLT_nxv1s32*//*Label 33352*/ GIMT_Encode4(2303983),
     /* 2303545 */ /*GILLT_nxv1s64*//*Label 33353*/ GIMT_Encode4(2304204), GIMT_Encode4(0),
     /* 2303553 */ /*GILLT_nxv2s8*//*Label 33354*/ GIMT_Encode4(2304425),
     /* 2303557 */ /*GILLT_nxv2s16*//*Label 33355*/ GIMT_Encode4(2304542),
     /* 2303561 */ /*GILLT_nxv2s32*//*Label 33356*/ GIMT_Encode4(2304763),
     /* 2303565 */ /*GILLT_nxv2s64*//*Label 33357*/ GIMT_Encode4(2304984), GIMT_Encode4(0),
     /* 2303573 */ /*GILLT_nxv4s8*//*Label 33358*/ GIMT_Encode4(2305205),
     /* 2303577 */ /*GILLT_nxv4s16*//*Label 33359*/ GIMT_Encode4(2305322),
     /* 2303581 */ /*GILLT_nxv4s32*//*Label 33360*/ GIMT_Encode4(2305543),
     /* 2303585 */ /*GILLT_nxv4s64*//*Label 33361*/ GIMT_Encode4(2305764), GIMT_Encode4(0),
     /* 2303593 */ /*GILLT_nxv8s8*//*Label 33362*/ GIMT_Encode4(2305985),
     /* 2303597 */ /*GILLT_nxv8s16*//*Label 33363*/ GIMT_Encode4(2306102),
     /* 2303601 */ /*GILLT_nxv8s32*//*Label 33364*/ GIMT_Encode4(2306323),
     /* 2303605 */ /*GILLT_nxv8s64*//*Label 33365*/ GIMT_Encode4(2306544), GIMT_Encode4(0),
     /* 2303613 */ /*GILLT_nxv16s8*//*Label 33366*/ GIMT_Encode4(2306765),
     /* 2303617 */ /*GILLT_nxv16s16*//*Label 33367*/ GIMT_Encode4(2306882),
     /* 2303621 */ /*GILLT_nxv16s32*//*Label 33368*/ GIMT_Encode4(2307103), GIMT_Encode4(0),
     /* 2303629 */ /*GILLT_nxv32s8*//*Label 33369*/ GIMT_Encode4(2307324),
     /* 2303633 */ /*GILLT_nxv32s16*//*Label 33370*/ GIMT_Encode4(2307441), GIMT_Encode4(0),
     /* 2303641 */ /*GILLT_nxv64s8*//*Label 33371*/ GIMT_Encode4(2307662),
     /* 2303645 */ // Label 33350: @2303645
     /* 2303645 */ GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2303761),
     /* 2303650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2303653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2303656 */   GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2303708), // Rule ID 31984 //
     /* 2303661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2303667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303686 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2303686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2303689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303691 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303707 */     // GIR_Coverage, 31984,
     /* 2303707 */     GIR_EraseRootFromParent_Done,
     /* 2303708 */   // Label 33374: @2303708
     /* 2303708 */   GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2303760), // Rule ID 31985 //
     /* 2303713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2303719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303738 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2303738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2303741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303743 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303759 */     // GIR_Coverage, 31985,
     /* 2303759 */     GIR_EraseRootFromParent_Done,
     /* 2303760 */   // Label 33375: @2303760
     /* 2303760 */   GIM_Reject,
     /* 2303761 */ // Label 33373: @2303761
     /* 2303761 */ GIM_Reject,
     /* 2303762 */ // Label 33351: @2303762
     /* 2303762 */ GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2303982),
     /* 2303767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2303770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2303773 */   GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2303825), // Rule ID 32254 //
     /* 2303778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2303784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303803 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2303803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2303806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303808 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303824 */     // GIR_Coverage, 32254,
     /* 2303824 */     GIR_EraseRootFromParent_Done,
     /* 2303825 */   // Label 33377: @2303825
     /* 2303825 */   GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2303877), // Rule ID 32255 //
     /* 2303830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2303836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303855 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2303855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2303858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303860 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303876 */     // GIR_Coverage, 32255,
     /* 2303876 */     GIR_EraseRootFromParent_Done,
     /* 2303877 */   // Label 33378: @2303877
     /* 2303877 */   GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2303929), // Rule ID 33964 //
     /* 2303882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2303885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2303888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303907 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2303907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2303910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303912 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303928 */     // GIR_Coverage, 33964,
     /* 2303928 */     GIR_EraseRootFromParent_Done,
     /* 2303929 */   // Label 33379: @2303929
     /* 2303929 */   GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2303981), // Rule ID 33965 //
     /* 2303934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2303937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2303940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2303959 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2303959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2303962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303964 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2303966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2303973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2303979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303980 */     // GIR_Coverage, 33965,
     /* 2303980 */     GIR_EraseRootFromParent_Done,
     /* 2303981 */   // Label 33380: @2303981
     /* 2303981 */   GIM_Reject,
     /* 2303982 */ // Label 33376: @2303982
     /* 2303982 */ GIM_Reject,
     /* 2303983 */ // Label 33352: @2303983
     /* 2303983 */ GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2304203),
     /* 2303988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2303991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2303994 */   GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2304046), // Rule ID 32434 //
     /* 2303999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304024 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304029 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304045 */     // GIR_Coverage, 32434,
     /* 2304045 */     GIR_EraseRootFromParent_Done,
     /* 2304046 */   // Label 33382: @2304046
     /* 2304046 */   GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2304098), // Rule ID 32435 //
     /* 2304051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304076 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304081 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304097 */     // GIR_Coverage, 32435,
     /* 2304097 */     GIR_EraseRootFromParent_Done,
     /* 2304098 */   // Label 33383: @2304098
     /* 2304098 */   GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2304150), // Rule ID 34144 //
     /* 2304103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304128 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304133 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304149 */     // GIR_Coverage, 34144,
     /* 2304149 */     GIR_EraseRootFromParent_Done,
     /* 2304150 */   // Label 33384: @2304150
     /* 2304150 */   GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2304202), // Rule ID 34145 //
     /* 2304155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304180 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304185 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304201 */     // GIR_Coverage, 34145,
     /* 2304201 */     GIR_EraseRootFromParent_Done,
     /* 2304202 */   // Label 33385: @2304202
     /* 2304202 */   GIM_Reject,
     /* 2304203 */ // Label 33381: @2304203
     /* 2304203 */ GIM_Reject,
     /* 2304204 */ // Label 33353: @2304204
     /* 2304204 */ GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2304424),
     /* 2304209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2304212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2304215 */   GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2304267), // Rule ID 32794 //
     /* 2304220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2304223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304245 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304250 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304266 */     // GIR_Coverage, 32794,
     /* 2304266 */     GIR_EraseRootFromParent_Done,
     /* 2304267 */   // Label 33387: @2304267
     /* 2304267 */   GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2304319), // Rule ID 32795 //
     /* 2304272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2304275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304297 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304302 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304318 */     // GIR_Coverage, 32795,
     /* 2304318 */     GIR_EraseRootFromParent_Done,
     /* 2304319 */   // Label 33388: @2304319
     /* 2304319 */   GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2304371), // Rule ID 34414 //
     /* 2304324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2304327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304349 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304354 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304370 */     // GIR_Coverage, 34414,
     /* 2304370 */     GIR_EraseRootFromParent_Done,
     /* 2304371 */   // Label 33389: @2304371
     /* 2304371 */   GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2304423), // Rule ID 34415 //
     /* 2304376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2304379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304401 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304406 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304422 */     // GIR_Coverage, 34415,
     /* 2304422 */     GIR_EraseRootFromParent_Done,
     /* 2304423 */   // Label 33390: @2304423
     /* 2304423 */   GIM_Reject,
     /* 2304424 */ // Label 33386: @2304424
     /* 2304424 */ GIM_Reject,
     /* 2304425 */ // Label 33354: @2304425
     /* 2304425 */ GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2304541),
     /* 2304430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2304433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2304436 */   GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2304488), // Rule ID 32074 //
     /* 2304441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304466 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2304469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304471 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304487 */     // GIR_Coverage, 32074,
     /* 2304487 */     GIR_EraseRootFromParent_Done,
     /* 2304488 */   // Label 33392: @2304488
     /* 2304488 */   GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2304540), // Rule ID 32075 //
     /* 2304493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304518 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2304521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304523 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304539 */     // GIR_Coverage, 32075,
     /* 2304539 */     GIR_EraseRootFromParent_Done,
     /* 2304540 */   // Label 33393: @2304540
     /* 2304540 */   GIM_Reject,
     /* 2304541 */ // Label 33391: @2304541
     /* 2304541 */ GIM_Reject,
     /* 2304542 */ // Label 33355: @2304542
     /* 2304542 */ GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2304762),
     /* 2304547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2304550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2304553 */   GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2304605), // Rule ID 32344 //
     /* 2304558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304583 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304588 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304604 */     // GIR_Coverage, 32344,
     /* 2304604 */     GIR_EraseRootFromParent_Done,
     /* 2304605 */   // Label 33395: @2304605
     /* 2304605 */   GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2304657), // Rule ID 32345 //
     /* 2304610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304635 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304640 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304656 */     // GIR_Coverage, 32345,
     /* 2304656 */     GIR_EraseRootFromParent_Done,
     /* 2304657 */   // Label 33396: @2304657
     /* 2304657 */   GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2304709), // Rule ID 34054 //
     /* 2304662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304687 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304692 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304708 */     // GIR_Coverage, 34054,
     /* 2304708 */     GIR_EraseRootFromParent_Done,
     /* 2304709 */   // Label 33397: @2304709
     /* 2304709 */   GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2304761), // Rule ID 34055 //
     /* 2304714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304739 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2304742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304744 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304760 */     // GIR_Coverage, 34055,
     /* 2304760 */     GIR_EraseRootFromParent_Done,
     /* 2304761 */   // Label 33398: @2304761
     /* 2304761 */   GIM_Reject,
     /* 2304762 */ // Label 33394: @2304762
     /* 2304762 */ GIM_Reject,
     /* 2304763 */ // Label 33356: @2304763
     /* 2304763 */ GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2304983),
     /* 2304768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2304771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2304774 */   GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2304826), // Rule ID 32704 //
     /* 2304779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304804 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304809 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304825 */     // GIR_Coverage, 32704,
     /* 2304825 */     GIR_EraseRootFromParent_Done,
     /* 2304826 */   // Label 33400: @2304826
     /* 2304826 */   GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2304878), // Rule ID 32705 //
     /* 2304831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304856 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304861 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304877 */     // GIR_Coverage, 32705,
     /* 2304877 */     GIR_EraseRootFromParent_Done,
     /* 2304878 */   // Label 33401: @2304878
     /* 2304878 */   GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2304930), // Rule ID 34324 //
     /* 2304883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2304886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2304889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304908 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2304908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304913 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304929 */     // GIR_Coverage, 34324,
     /* 2304929 */     GIR_EraseRootFromParent_Done,
     /* 2304930 */   // Label 33402: @2304930
     /* 2304930 */   GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2304982), // Rule ID 34325 //
     /* 2304935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2304938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2304941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2304960 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2304960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2304963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304965 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2304967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2304974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2304980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304981 */     // GIR_Coverage, 34325,
     /* 2304981 */     GIR_EraseRootFromParent_Done,
     /* 2304982 */   // Label 33403: @2304982
     /* 2304982 */   GIM_Reject,
     /* 2304983 */ // Label 33399: @2304983
     /* 2304983 */ GIM_Reject,
     /* 2304984 */ // Label 33357: @2304984
     /* 2304984 */ GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2305204),
     /* 2304989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2304992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2304995 */   GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2305047), // Rule ID 33694 //
     /* 2305000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2305003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305025 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305030 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305046 */     // GIR_Coverage, 33694,
     /* 2305046 */     GIR_EraseRootFromParent_Done,
     /* 2305047 */   // Label 33405: @2305047
     /* 2305047 */   GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2305099), // Rule ID 33695 //
     /* 2305052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2305055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305077 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305082 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305098 */     // GIR_Coverage, 33695,
     /* 2305098 */     GIR_EraseRootFromParent_Done,
     /* 2305099 */   // Label 33406: @2305099
     /* 2305099 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2305151), // Rule ID 35044 //
     /* 2305104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2305107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305129 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305134 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305150 */     // GIR_Coverage, 35044,
     /* 2305150 */     GIR_EraseRootFromParent_Done,
     /* 2305151 */   // Label 33407: @2305151
     /* 2305151 */   GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2305203), // Rule ID 35045 //
     /* 2305156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2305159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305181 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305186 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305202 */     // GIR_Coverage, 35045,
     /* 2305202 */     GIR_EraseRootFromParent_Done,
     /* 2305203 */   // Label 33408: @2305203
     /* 2305203 */   GIM_Reject,
     /* 2305204 */ // Label 33404: @2305204
     /* 2305204 */ GIM_Reject,
     /* 2305205 */ // Label 33358: @2305205
     /* 2305205 */ GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2305321),
     /* 2305210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2305213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2305216 */   GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2305268), // Rule ID 32164 //
     /* 2305221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2305224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305246 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2305249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305251 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305267 */     // GIR_Coverage, 32164,
     /* 2305267 */     GIR_EraseRootFromParent_Done,
     /* 2305268 */   // Label 33410: @2305268
     /* 2305268 */   GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2305320), // Rule ID 32165 //
     /* 2305273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2305276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305298 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2305301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305303 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305319 */     // GIR_Coverage, 32165,
     /* 2305319 */     GIR_EraseRootFromParent_Done,
     /* 2305320 */   // Label 33411: @2305320
     /* 2305320 */   GIM_Reject,
     /* 2305321 */ // Label 33409: @2305321
     /* 2305321 */ GIM_Reject,
     /* 2305322 */ // Label 33359: @2305322
     /* 2305322 */ GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2305542),
     /* 2305327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2305330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2305333 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2305385), // Rule ID 32614 //
     /* 2305338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2305341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305363 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2305366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305368 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305384 */     // GIR_Coverage, 32614,
     /* 2305384 */     GIR_EraseRootFromParent_Done,
     /* 2305385 */   // Label 33413: @2305385
     /* 2305385 */   GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2305437), // Rule ID 32615 //
     /* 2305390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2305393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305415 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2305418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305420 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305436 */     // GIR_Coverage, 32615,
     /* 2305436 */     GIR_EraseRootFromParent_Done,
     /* 2305437 */   // Label 33414: @2305437
     /* 2305437 */   GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2305489), // Rule ID 34234 //
     /* 2305442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2305445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305467 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2305470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305472 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305488 */     // GIR_Coverage, 34234,
     /* 2305488 */     GIR_EraseRootFromParent_Done,
     /* 2305489 */   // Label 33415: @2305489
     /* 2305489 */   GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2305541), // Rule ID 34235 //
     /* 2305494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2305497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305519 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2305522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305524 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305540 */     // GIR_Coverage, 34235,
     /* 2305540 */     GIR_EraseRootFromParent_Done,
     /* 2305541 */   // Label 33416: @2305541
     /* 2305541 */   GIM_Reject,
     /* 2305542 */ // Label 33412: @2305542
     /* 2305542 */ GIM_Reject,
     /* 2305543 */ // Label 33360: @2305543
     /* 2305543 */ GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2305763),
     /* 2305548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2305551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2305554 */   GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2305606), // Rule ID 33424 //
     /* 2305559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2305562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305584 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305589 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305605 */     // GIR_Coverage, 33424,
     /* 2305605 */     GIR_EraseRootFromParent_Done,
     /* 2305606 */   // Label 33418: @2305606
     /* 2305606 */   GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2305658), // Rule ID 33425 //
     /* 2305611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2305614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305636 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305641 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305657 */     // GIR_Coverage, 33425,
     /* 2305657 */     GIR_EraseRootFromParent_Done,
     /* 2305658 */   // Label 33419: @2305658
     /* 2305658 */   GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2305710), // Rule ID 34774 //
     /* 2305663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2305666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305688 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305693 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305709 */     // GIR_Coverage, 34774,
     /* 2305709 */     GIR_EraseRootFromParent_Done,
     /* 2305710 */   // Label 33420: @2305710
     /* 2305710 */   GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2305762), // Rule ID 34775 //
     /* 2305715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2305718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305740 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2305743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305745 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305761 */     // GIR_Coverage, 34775,
     /* 2305761 */     GIR_EraseRootFromParent_Done,
     /* 2305762 */   // Label 33421: @2305762
     /* 2305762 */   GIM_Reject,
     /* 2305763 */ // Label 33417: @2305763
     /* 2305763 */ GIM_Reject,
     /* 2305764 */ // Label 33361: @2305764
     /* 2305764 */ GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2305984),
     /* 2305769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2305772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2305775 */   GIM_Try, /*On fail goto*//*Label 33423*/ GIMT_Encode4(2305827), // Rule ID 33784 //
     /* 2305780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2305783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305805 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2305808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305810 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305826 */     // GIR_Coverage, 33784,
     /* 2305826 */     GIR_EraseRootFromParent_Done,
     /* 2305827 */   // Label 33423: @2305827
     /* 2305827 */   GIM_Try, /*On fail goto*//*Label 33424*/ GIMT_Encode4(2305879), // Rule ID 33785 //
     /* 2305832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2305835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305857 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2305860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305862 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305878 */     // GIR_Coverage, 33785,
     /* 2305878 */     GIR_EraseRootFromParent_Done,
     /* 2305879 */   // Label 33424: @2305879
     /* 2305879 */   GIM_Try, /*On fail goto*//*Label 33425*/ GIMT_Encode4(2305931), // Rule ID 35134 //
     /* 2305884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2305887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2305890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305909 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2305909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2305912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305914 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305930 */     // GIR_Coverage, 35134,
     /* 2305930 */     GIR_EraseRootFromParent_Done,
     /* 2305931 */   // Label 33425: @2305931
     /* 2305931 */   GIM_Try, /*On fail goto*//*Label 33426*/ GIMT_Encode4(2305983), // Rule ID 35135 //
     /* 2305936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2305939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2305961 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2305961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2305964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305966 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2305968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2305975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2305981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305982 */     // GIR_Coverage, 35135,
     /* 2305982 */     GIR_EraseRootFromParent_Done,
     /* 2305983 */   // Label 33426: @2305983
     /* 2305983 */   GIM_Reject,
     /* 2305984 */ // Label 33422: @2305984
     /* 2305984 */ GIM_Reject,
     /* 2305985 */ // Label 33362: @2305985
     /* 2305985 */ GIM_Try, /*On fail goto*//*Label 33427*/ GIMT_Encode4(2306101),
     /* 2305990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2305993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2305996 */   GIM_Try, /*On fail goto*//*Label 33428*/ GIMT_Encode4(2306048), // Rule ID 32524 //
     /* 2306001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306026 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2306029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306031 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306047 */     // GIR_Coverage, 32524,
     /* 2306047 */     GIR_EraseRootFromParent_Done,
     /* 2306048 */   // Label 33428: @2306048
     /* 2306048 */   GIM_Try, /*On fail goto*//*Label 33429*/ GIMT_Encode4(2306100), // Rule ID 32525 //
     /* 2306053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306078 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2306081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306083 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306099 */     // GIR_Coverage, 32525,
     /* 2306099 */     GIR_EraseRootFromParent_Done,
     /* 2306100 */   // Label 33429: @2306100
     /* 2306100 */   GIM_Reject,
     /* 2306101 */ // Label 33427: @2306101
     /* 2306101 */ GIM_Reject,
     /* 2306102 */ // Label 33363: @2306102
     /* 2306102 */ GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2306322),
     /* 2306107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2306110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2306113 */   GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2306165), // Rule ID 33154 //
     /* 2306118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306143 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306148 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306164 */     // GIR_Coverage, 33154,
     /* 2306164 */     GIR_EraseRootFromParent_Done,
     /* 2306165 */   // Label 33431: @2306165
     /* 2306165 */   GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2306217), // Rule ID 33155 //
     /* 2306170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306195 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306200 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306216 */     // GIR_Coverage, 33155,
     /* 2306216 */     GIR_EraseRootFromParent_Done,
     /* 2306217 */   // Label 33432: @2306217
     /* 2306217 */   GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2306269), // Rule ID 34504 //
     /* 2306222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306247 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306252 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306268 */     // GIR_Coverage, 34504,
     /* 2306268 */     GIR_EraseRootFromParent_Done,
     /* 2306269 */   // Label 33433: @2306269
     /* 2306269 */   GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2306321), // Rule ID 34505 //
     /* 2306274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306299 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306304 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306320 */     // GIR_Coverage, 34505,
     /* 2306320 */     GIR_EraseRootFromParent_Done,
     /* 2306321 */   // Label 33434: @2306321
     /* 2306321 */   GIM_Reject,
     /* 2306322 */ // Label 33430: @2306322
     /* 2306322 */ GIM_Reject,
     /* 2306323 */ // Label 33364: @2306323
     /* 2306323 */ GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2306543),
     /* 2306328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2306331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2306334 */   GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2306386), // Rule ID 33514 //
     /* 2306339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306364 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306369 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306385 */     // GIR_Coverage, 33514,
     /* 2306385 */     GIR_EraseRootFromParent_Done,
     /* 2306386 */   // Label 33436: @2306386
     /* 2306386 */   GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2306438), // Rule ID 33515 //
     /* 2306391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306416 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306421 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306437 */     // GIR_Coverage, 33515,
     /* 2306437 */     GIR_EraseRootFromParent_Done,
     /* 2306438 */   // Label 33437: @2306438
     /* 2306438 */   GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2306490), // Rule ID 34864 //
     /* 2306443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306468 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306473 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306489 */     // GIR_Coverage, 34864,
     /* 2306489 */     GIR_EraseRootFromParent_Done,
     /* 2306490 */   // Label 33438: @2306490
     /* 2306490 */   GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2306542), // Rule ID 34865 //
     /* 2306495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306520 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306525 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306541 */     // GIR_Coverage, 34865,
     /* 2306541 */     GIR_EraseRootFromParent_Done,
     /* 2306542 */   // Label 33439: @2306542
     /* 2306542 */   GIM_Reject,
     /* 2306543 */ // Label 33435: @2306543
     /* 2306543 */ GIM_Reject,
     /* 2306544 */ // Label 33365: @2306544
     /* 2306544 */ GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2306764),
     /* 2306549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2306555 */   GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2306607), // Rule ID 33874 //
     /* 2306560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2306563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306585 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2306588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306590 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306606 */     // GIR_Coverage, 33874,
     /* 2306606 */     GIR_EraseRootFromParent_Done,
     /* 2306607 */   // Label 33441: @2306607
     /* 2306607 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2306659), // Rule ID 33875 //
     /* 2306612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2306615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306637 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2306640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306642 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306658 */     // GIR_Coverage, 33875,
     /* 2306658 */     GIR_EraseRootFromParent_Done,
     /* 2306659 */   // Label 33442: @2306659
     /* 2306659 */   GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2306711), // Rule ID 35224 //
     /* 2306664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2306667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306689 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2306692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306694 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306710 */     // GIR_Coverage, 35224,
     /* 2306710 */     GIR_EraseRootFromParent_Done,
     /* 2306711 */   // Label 33443: @2306711
     /* 2306711 */   GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2306763), // Rule ID 35225 //
     /* 2306716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2306719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306741 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2306744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306746 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306762 */     // GIR_Coverage, 35225,
     /* 2306762 */     GIR_EraseRootFromParent_Done,
     /* 2306763 */   // Label 33444: @2306763
     /* 2306763 */   GIM_Reject,
     /* 2306764 */ // Label 33440: @2306764
     /* 2306764 */ GIM_Reject,
     /* 2306765 */ // Label 33366: @2306765
     /* 2306765 */ GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2306881),
     /* 2306770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2306773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2306776 */   GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2306828), // Rule ID 32884 //
     /* 2306781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306806 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306811 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306827 */     // GIR_Coverage, 32884,
     /* 2306827 */     GIR_EraseRootFromParent_Done,
     /* 2306828 */   // Label 33446: @2306828
     /* 2306828 */   GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2306880), // Rule ID 32885 //
     /* 2306833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306858 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2306861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306863 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306879 */     // GIR_Coverage, 32885,
     /* 2306879 */     GIR_EraseRootFromParent_Done,
     /* 2306880 */   // Label 33447: @2306880
     /* 2306880 */   GIM_Reject,
     /* 2306881 */ // Label 33445: @2306881
     /* 2306881 */ GIM_Reject,
     /* 2306882 */ // Label 33367: @2306882
     /* 2306882 */ GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2307102),
     /* 2306887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2306893 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2306945), // Rule ID 33244 //
     /* 2306898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2306901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306923 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2306923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306928 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306944 */     // GIR_Coverage, 33244,
     /* 2306944 */     GIR_EraseRootFromParent_Done,
     /* 2306945 */   // Label 33449: @2306945
     /* 2306945 */   GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2306997), // Rule ID 33245 //
     /* 2306950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2306953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2306956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2306975 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2306975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2306978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306980 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2306982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2306989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2306995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306996 */     // GIR_Coverage, 33245,
     /* 2306996 */     GIR_EraseRootFromParent_Done,
     /* 2306997 */   // Label 33450: @2306997
     /* 2306997 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2307049), // Rule ID 34594 //
     /* 2307002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307027 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2307030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307032 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307048 */     // GIR_Coverage, 34594,
     /* 2307048 */     GIR_EraseRootFromParent_Done,
     /* 2307049 */   // Label 33451: @2307049
     /* 2307049 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2307101), // Rule ID 34595 //
     /* 2307054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307079 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2307082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307084 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307100 */     // GIR_Coverage, 34595,
     /* 2307100 */     GIR_EraseRootFromParent_Done,
     /* 2307101 */   // Label 33452: @2307101
     /* 2307101 */   GIM_Reject,
     /* 2307102 */ // Label 33448: @2307102
     /* 2307102 */ GIM_Reject,
     /* 2307103 */ // Label 33368: @2307103
     /* 2307103 */ GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2307323),
     /* 2307108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2307114 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2307166), // Rule ID 33604 //
     /* 2307119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307144 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307149 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307165 */     // GIR_Coverage, 33604,
     /* 2307165 */     GIR_EraseRootFromParent_Done,
     /* 2307166 */   // Label 33454: @2307166
     /* 2307166 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2307218), // Rule ID 33605 //
     /* 2307171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307196 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307201 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307217 */     // GIR_Coverage, 33605,
     /* 2307217 */     GIR_EraseRootFromParent_Done,
     /* 2307218 */   // Label 33455: @2307218
     /* 2307218 */   GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2307270), // Rule ID 34954 //
     /* 2307223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307248 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307253 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307269 */     // GIR_Coverage, 34954,
     /* 2307269 */     GIR_EraseRootFromParent_Done,
     /* 2307270 */   // Label 33456: @2307270
     /* 2307270 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2307322), // Rule ID 34955 //
     /* 2307275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307300 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307305 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307321 */     // GIR_Coverage, 34955,
     /* 2307321 */     GIR_EraseRootFromParent_Done,
     /* 2307322 */   // Label 33457: @2307322
     /* 2307322 */   GIM_Reject,
     /* 2307323 */ // Label 33453: @2307323
     /* 2307323 */ GIM_Reject,
     /* 2307324 */ // Label 33369: @2307324
     /* 2307324 */ GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2307440),
     /* 2307329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2307332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2307335 */   GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2307387), // Rule ID 32974 //
     /* 2307340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307365 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2307368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307370 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307386 */     // GIR_Coverage, 32974,
     /* 2307386 */     GIR_EraseRootFromParent_Done,
     /* 2307387 */   // Label 33459: @2307387
     /* 2307387 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2307439), // Rule ID 32975 //
     /* 2307392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307417 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2307420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307422 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307438 */     // GIR_Coverage, 32975,
     /* 2307438 */     GIR_EraseRootFromParent_Done,
     /* 2307439 */   // Label 33460: @2307439
     /* 2307439 */   GIM_Reject,
     /* 2307440 */ // Label 33458: @2307440
     /* 2307440 */ GIM_Reject,
     /* 2307441 */ // Label 33370: @2307441
     /* 2307441 */ GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2307661),
     /* 2307446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2307449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2307452 */   GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2307504), // Rule ID 33334 //
     /* 2307457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307482 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307487 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307503 */     // GIR_Coverage, 33334,
     /* 2307503 */     GIR_EraseRootFromParent_Done,
     /* 2307504 */   // Label 33462: @2307504
     /* 2307504 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2307556), // Rule ID 33335 //
     /* 2307509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307534 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307539 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307555 */     // GIR_Coverage, 33335,
     /* 2307555 */     GIR_EraseRootFromParent_Done,
     /* 2307556 */   // Label 33463: @2307556
     /* 2307556 */   GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2307608), // Rule ID 34684 //
     /* 2307561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307586 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307591 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307607 */     // GIR_Coverage, 34684,
     /* 2307607 */     GIR_EraseRootFromParent_Done,
     /* 2307608 */   // Label 33464: @2307608
     /* 2307608 */   GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2307660), // Rule ID 34685 //
     /* 2307613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307638 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307643 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307659 */     // GIR_Coverage, 34685,
     /* 2307659 */     GIR_EraseRootFromParent_Done,
     /* 2307660 */   // Label 33465: @2307660
     /* 2307660 */   GIM_Reject,
     /* 2307661 */ // Label 33461: @2307661
     /* 2307661 */ GIM_Reject,
     /* 2307662 */ // Label 33371: @2307662
     /* 2307662 */ GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2307778),
     /* 2307667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2307670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2307673 */   GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2307725), // Rule ID 33064 //
     /* 2307678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307703 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2307703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307708 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307724 */     // GIR_Coverage, 33064,
     /* 2307724 */     GIR_EraseRootFromParent_Done,
     /* 2307725 */   // Label 33467: @2307725
     /* 2307725 */   GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2307777), // Rule ID 33065 //
     /* 2307730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2307733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307755 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2307755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2307758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307760 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2307762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2307775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307776 */     // GIR_Coverage, 33065,
     /* 2307776 */     GIR_EraseRootFromParent_Done,
     /* 2307777 */   // Label 33468: @2307777
     /* 2307777 */   GIM_Reject,
     /* 2307778 */ // Label 33466: @2307778
     /* 2307778 */ GIM_Reject,
     /* 2307779 */ // Label 33372: @2307779
     /* 2307779 */ GIM_Reject,
     /* 2307780 */ // Label 119: @2307780
     /* 2307780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33491*/ GIMT_Encode4(2319659),
     /* 2307791 */ /*GILLT_nxv1s8*//*Label 33469*/ GIMT_Encode4(2307903),
     /* 2307795 */ /*GILLT_nxv1s16*//*Label 33470*/ GIMT_Encode4(2308226),
     /* 2307799 */ /*GILLT_nxv1s32*//*Label 33471*/ GIMT_Encode4(2308859),
     /* 2307803 */ /*GILLT_nxv1s64*//*Label 33472*/ GIMT_Encode4(2309492), GIMT_Encode4(0),
     /* 2307811 */ /*GILLT_nxv2s8*//*Label 33473*/ GIMT_Encode4(2310125),
     /* 2307815 */ /*GILLT_nxv2s16*//*Label 33474*/ GIMT_Encode4(2310448),
     /* 2307819 */ /*GILLT_nxv2s32*//*Label 33475*/ GIMT_Encode4(2311081),
     /* 2307823 */ /*GILLT_nxv2s64*//*Label 33476*/ GIMT_Encode4(2311714), GIMT_Encode4(0),
     /* 2307831 */ /*GILLT_nxv4s8*//*Label 33477*/ GIMT_Encode4(2312347),
     /* 2307835 */ /*GILLT_nxv4s16*//*Label 33478*/ GIMT_Encode4(2312670),
     /* 2307839 */ /*GILLT_nxv4s32*//*Label 33479*/ GIMT_Encode4(2313303),
     /* 2307843 */ /*GILLT_nxv4s64*//*Label 33480*/ GIMT_Encode4(2313936), GIMT_Encode4(0),
     /* 2307851 */ /*GILLT_nxv8s8*//*Label 33481*/ GIMT_Encode4(2314569),
     /* 2307855 */ /*GILLT_nxv8s16*//*Label 33482*/ GIMT_Encode4(2314892),
     /* 2307859 */ /*GILLT_nxv8s32*//*Label 33483*/ GIMT_Encode4(2315525),
     /* 2307863 */ /*GILLT_nxv8s64*//*Label 33484*/ GIMT_Encode4(2316158), GIMT_Encode4(0),
     /* 2307871 */ /*GILLT_nxv16s8*//*Label 33485*/ GIMT_Encode4(2316791),
     /* 2307875 */ /*GILLT_nxv16s16*//*Label 33486*/ GIMT_Encode4(2317114),
     /* 2307879 */ /*GILLT_nxv16s32*//*Label 33487*/ GIMT_Encode4(2317747), GIMT_Encode4(0),
     /* 2307887 */ /*GILLT_nxv32s8*//*Label 33488*/ GIMT_Encode4(2318380),
     /* 2307891 */ /*GILLT_nxv32s16*//*Label 33489*/ GIMT_Encode4(2318703), GIMT_Encode4(0),
     /* 2307899 */ /*GILLT_nxv64s8*//*Label 33490*/ GIMT_Encode4(2319336),
     /* 2307903 */ // Label 33469: @2307903
     /* 2307903 */ GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2308225),
     /* 2307908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2307911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2307914 */   GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2307997), // Rule ID 45128 //
     /* 2307919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2307922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2307925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2307928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2307931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2307935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2307951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2307955 */     // MIs[1] Operand 1
     /* 2307955 */     // No operand predicates
     /* 2307955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2307959 */     // MIs[0] policy
     /* 2307959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2307962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2307971 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2307971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2307974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2307980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2307983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2307985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2307990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2307995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307996 */     // GIR_Coverage, 45128,
     /* 2307996 */     GIR_EraseRootFromParent_Done,
     /* 2307997 */   // Label 33493: @2307997
     /* 2307997 */   GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2308080), // Rule ID 45129 //
     /* 2308002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308038 */     // MIs[1] Operand 1
     /* 2308038 */     // No operand predicates
     /* 2308038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308042 */     // MIs[0] policy
     /* 2308042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308054 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2308057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308079 */     // GIR_Coverage, 45129,
     /* 2308079 */     GIR_EraseRootFromParent_Done,
     /* 2308080 */   // Label 33494: @2308080
     /* 2308080 */   GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2308152), // Rule ID 45130 //
     /* 2308085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308117 */     // MIs[0] policy
     /* 2308117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308127 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2308130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308151 */     // GIR_Coverage, 45130,
     /* 2308151 */     GIR_EraseRootFromParent_Done,
     /* 2308152 */   // Label 33495: @2308152
     /* 2308152 */   GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2308224), // Rule ID 45131 //
     /* 2308157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308189 */     // MIs[0] policy
     /* 2308189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308199 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2308202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308223 */     // GIR_Coverage, 45131,
     /* 2308223 */     GIR_EraseRootFromParent_Done,
     /* 2308224 */   // Label 33496: @2308224
     /* 2308224 */   GIM_Reject,
     /* 2308225 */ // Label 33492: @2308225
     /* 2308225 */ GIM_Reject,
     /* 2308226 */ // Label 33470: @2308226
     /* 2308226 */ GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2308858),
     /* 2308231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2308237 */   GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2308320), // Rule ID 45140 //
     /* 2308242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308278 */     // MIs[1] Operand 1
     /* 2308278 */     // No operand predicates
     /* 2308278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308282 */     // MIs[0] policy
     /* 2308282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308294 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2308297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308319 */     // GIR_Coverage, 45140,
     /* 2308319 */     GIR_EraseRootFromParent_Done,
     /* 2308320 */   // Label 33498: @2308320
     /* 2308320 */   GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2308403), // Rule ID 45141 //
     /* 2308325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308361 */     // MIs[1] Operand 1
     /* 2308361 */     // No operand predicates
     /* 2308361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308365 */     // MIs[0] policy
     /* 2308365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308377 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2308380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308402 */     // GIR_Coverage, 45141,
     /* 2308402 */     GIR_EraseRootFromParent_Done,
     /* 2308403 */   // Label 33499: @2308403
     /* 2308403 */   GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2308486), // Rule ID 45216 //
     /* 2308408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308444 */     // MIs[1] Operand 1
     /* 2308444 */     // No operand predicates
     /* 2308444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308448 */     // MIs[0] policy
     /* 2308448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308460 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2308463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308485 */     // GIR_Coverage, 45216,
     /* 2308485 */     GIR_EraseRootFromParent_Done,
     /* 2308486 */   // Label 33500: @2308486
     /* 2308486 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2308569), // Rule ID 45217 //
     /* 2308491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308527 */     // MIs[1] Operand 1
     /* 2308527 */     // No operand predicates
     /* 2308527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308531 */     // MIs[0] policy
     /* 2308531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308543 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2308546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308568 */     // GIR_Coverage, 45217,
     /* 2308568 */     GIR_EraseRootFromParent_Done,
     /* 2308569 */   // Label 33501: @2308569
     /* 2308569 */   GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2308641), // Rule ID 45142 //
     /* 2308574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308606 */     // MIs[0] policy
     /* 2308606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308616 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2308619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308640 */     // GIR_Coverage, 45142,
     /* 2308640 */     GIR_EraseRootFromParent_Done,
     /* 2308641 */   // Label 33502: @2308641
     /* 2308641 */   GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2308713), // Rule ID 45143 //
     /* 2308646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308678 */     // MIs[0] policy
     /* 2308678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308688 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2308691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308712 */     // GIR_Coverage, 45143,
     /* 2308712 */     GIR_EraseRootFromParent_Done,
     /* 2308713 */   // Label 33503: @2308713
     /* 2308713 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2308785), // Rule ID 45218 //
     /* 2308718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308750 */     // MIs[0] policy
     /* 2308750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308760 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2308763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308784 */     // GIR_Coverage, 45218,
     /* 2308784 */     GIR_EraseRootFromParent_Done,
     /* 2308785 */   // Label 33504: @2308785
     /* 2308785 */   GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2308857), // Rule ID 45219 //
     /* 2308790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308822 */     // MIs[0] policy
     /* 2308822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308832 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2308832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2308835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308856 */     // GIR_Coverage, 45219,
     /* 2308856 */     GIR_EraseRootFromParent_Done,
     /* 2308857 */   // Label 33505: @2308857
     /* 2308857 */   GIM_Reject,
     /* 2308858 */ // Label 33497: @2308858
     /* 2308858 */ GIM_Reject,
     /* 2308859 */ // Label 33471: @2308859
     /* 2308859 */ GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2309491),
     /* 2308864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2308867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2308870 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2308953), // Rule ID 45148 //
     /* 2308875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2308878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2308887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308911 */     // MIs[1] Operand 1
     /* 2308911 */     // No operand predicates
     /* 2308911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308915 */     // MIs[0] policy
     /* 2308915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2308918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2308927 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2308927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2308930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2308936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2308939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2308941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2308946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2308951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308952 */     // GIR_Coverage, 45148,
     /* 2308952 */     GIR_EraseRootFromParent_Done,
     /* 2308953 */   // Label 33507: @2308953
     /* 2308953 */   GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2309036), // Rule ID 45149 //
     /* 2308958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2308961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2308964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2308967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2308970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2308974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2308990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2308994 */     // MIs[1] Operand 1
     /* 2308994 */     // No operand predicates
     /* 2308994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2308998 */     // MIs[0] policy
     /* 2308998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309010 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2309013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309035 */     // GIR_Coverage, 45149,
     /* 2309035 */     GIR_EraseRootFromParent_Done,
     /* 2309036 */   // Label 33508: @2309036
     /* 2309036 */   GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2309119), // Rule ID 45224 //
     /* 2309041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2309044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309077 */     // MIs[1] Operand 1
     /* 2309077 */     // No operand predicates
     /* 2309077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309081 */     // MIs[0] policy
     /* 2309081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309093 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2309096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309118 */     // GIR_Coverage, 45224,
     /* 2309118 */     GIR_EraseRootFromParent_Done,
     /* 2309119 */   // Label 33509: @2309119
     /* 2309119 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2309202), // Rule ID 45225 //
     /* 2309124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2309127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309160 */     // MIs[1] Operand 1
     /* 2309160 */     // No operand predicates
     /* 2309160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309164 */     // MIs[0] policy
     /* 2309164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309176 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2309179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309201 */     // GIR_Coverage, 45225,
     /* 2309201 */     GIR_EraseRootFromParent_Done,
     /* 2309202 */   // Label 33510: @2309202
     /* 2309202 */   GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2309274), // Rule ID 45150 //
     /* 2309207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2309210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309239 */     // MIs[0] policy
     /* 2309239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309249 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2309252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309273 */     // GIR_Coverage, 45150,
     /* 2309273 */     GIR_EraseRootFromParent_Done,
     /* 2309274 */   // Label 33511: @2309274
     /* 2309274 */   GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2309346), // Rule ID 45151 //
     /* 2309279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2309282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309311 */     // MIs[0] policy
     /* 2309311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309321 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2309324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309345 */     // GIR_Coverage, 45151,
     /* 2309345 */     GIR_EraseRootFromParent_Done,
     /* 2309346 */   // Label 33512: @2309346
     /* 2309346 */   GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2309418), // Rule ID 45226 //
     /* 2309351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2309354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309383 */     // MIs[0] policy
     /* 2309383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309393 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2309396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309417 */     // GIR_Coverage, 45226,
     /* 2309417 */     GIR_EraseRootFromParent_Done,
     /* 2309418 */   // Label 33513: @2309418
     /* 2309418 */   GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2309490), // Rule ID 45227 //
     /* 2309423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2309426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309455 */     // MIs[0] policy
     /* 2309455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309465 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2309468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309489 */     // GIR_Coverage, 45227,
     /* 2309489 */     GIR_EraseRootFromParent_Done,
     /* 2309490 */   // Label 33514: @2309490
     /* 2309490 */   GIM_Reject,
     /* 2309491 */ // Label 33506: @2309491
     /* 2309491 */ GIM_Reject,
     /* 2309492 */ // Label 33472: @2309492
     /* 2309492 */ GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2310124),
     /* 2309497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2309503 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2309586), // Rule ID 45164 //
     /* 2309508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2309511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309544 */     // MIs[1] Operand 1
     /* 2309544 */     // No operand predicates
     /* 2309544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309548 */     // MIs[0] policy
     /* 2309548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309560 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2309563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309585 */     // GIR_Coverage, 45164,
     /* 2309585 */     GIR_EraseRootFromParent_Done,
     /* 2309586 */   // Label 33516: @2309586
     /* 2309586 */   GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2309669), // Rule ID 45165 //
     /* 2309591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2309594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309627 */     // MIs[1] Operand 1
     /* 2309627 */     // No operand predicates
     /* 2309627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309631 */     // MIs[0] policy
     /* 2309631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309643 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2309646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309668 */     // GIR_Coverage, 45165,
     /* 2309668 */     GIR_EraseRootFromParent_Done,
     /* 2309669 */   // Label 33517: @2309669
     /* 2309669 */   GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2309752), // Rule ID 45236 //
     /* 2309674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2309677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309710 */     // MIs[1] Operand 1
     /* 2309710 */     // No operand predicates
     /* 2309710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309714 */     // MIs[0] policy
     /* 2309714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309726 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2309729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309751 */     // GIR_Coverage, 45236,
     /* 2309751 */     GIR_EraseRootFromParent_Done,
     /* 2309752 */   // Label 33518: @2309752
     /* 2309752 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2309835), // Rule ID 45237 //
     /* 2309757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2309760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2309789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2309793 */     // MIs[1] Operand 1
     /* 2309793 */     // No operand predicates
     /* 2309793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309797 */     // MIs[0] policy
     /* 2309797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309809 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2309812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2309821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309834 */     // GIR_Coverage, 45237,
     /* 2309834 */     GIR_EraseRootFromParent_Done,
     /* 2309835 */   // Label 33519: @2309835
     /* 2309835 */   GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2309907), // Rule ID 45166 //
     /* 2309840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2309843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309872 */     // MIs[0] policy
     /* 2309872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309882 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2309882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2309885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309906 */     // GIR_Coverage, 45166,
     /* 2309906 */     GIR_EraseRootFromParent_Done,
     /* 2309907 */   // Label 33520: @2309907
     /* 2309907 */   GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2309979), // Rule ID 45167 //
     /* 2309912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2309915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2309918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2309924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2309928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2309944 */     // MIs[0] policy
     /* 2309944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2309947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2309954 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2309954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2309957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2309963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2309967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2309972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2309977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309978 */     // GIR_Coverage, 45167,
     /* 2309978 */     GIR_EraseRootFromParent_Done,
     /* 2309979 */   // Label 33521: @2309979
     /* 2309979 */   GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2310051), // Rule ID 45238 //
     /* 2309984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2309987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2309990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2309993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2309996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310016 */     // MIs[0] policy
     /* 2310016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310026 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2310029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310050 */     // GIR_Coverage, 45238,
     /* 2310050 */     GIR_EraseRootFromParent_Done,
     /* 2310051 */   // Label 33522: @2310051
     /* 2310051 */   GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2310123), // Rule ID 45239 //
     /* 2310056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2310059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2310065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310088 */     // MIs[0] policy
     /* 2310088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310098 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2310101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310122 */     // GIR_Coverage, 45239,
     /* 2310122 */     GIR_EraseRootFromParent_Done,
     /* 2310123 */   // Label 33523: @2310123
     /* 2310123 */   GIM_Reject,
     /* 2310124 */ // Label 33515: @2310124
     /* 2310124 */ GIM_Reject,
     /* 2310125 */ // Label 33473: @2310125
     /* 2310125 */ GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2310447),
     /* 2310130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2310133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2310136 */   GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2310219), // Rule ID 45132 //
     /* 2310141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310177 */     // MIs[1] Operand 1
     /* 2310177 */     // No operand predicates
     /* 2310177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310181 */     // MIs[0] policy
     /* 2310181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310193 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2310196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310218 */     // GIR_Coverage, 45132,
     /* 2310218 */     GIR_EraseRootFromParent_Done,
     /* 2310219 */   // Label 33525: @2310219
     /* 2310219 */   GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2310302), // Rule ID 45133 //
     /* 2310224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2310227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310260 */     // MIs[1] Operand 1
     /* 2310260 */     // No operand predicates
     /* 2310260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310264 */     // MIs[0] policy
     /* 2310264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310276 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2310279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310301 */     // GIR_Coverage, 45133,
     /* 2310301 */     GIR_EraseRootFromParent_Done,
     /* 2310302 */   // Label 33526: @2310302
     /* 2310302 */   GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2310374), // Rule ID 45134 //
     /* 2310307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310339 */     // MIs[0] policy
     /* 2310339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310349 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2310352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310373 */     // GIR_Coverage, 45134,
     /* 2310373 */     GIR_EraseRootFromParent_Done,
     /* 2310374 */   // Label 33527: @2310374
     /* 2310374 */   GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2310446), // Rule ID 45135 //
     /* 2310379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2310382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310411 */     // MIs[0] policy
     /* 2310411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310421 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2310424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310445 */     // GIR_Coverage, 45135,
     /* 2310445 */     GIR_EraseRootFromParent_Done,
     /* 2310446 */   // Label 33528: @2310446
     /* 2310446 */   GIM_Reject,
     /* 2310447 */ // Label 33524: @2310447
     /* 2310447 */ GIM_Reject,
     /* 2310448 */ // Label 33474: @2310448
     /* 2310448 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2311080),
     /* 2310453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2310459 */   GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2310542), // Rule ID 45144 //
     /* 2310464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310500 */     // MIs[1] Operand 1
     /* 2310500 */     // No operand predicates
     /* 2310500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310504 */     // MIs[0] policy
     /* 2310504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310516 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2310519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310541 */     // GIR_Coverage, 45144,
     /* 2310541 */     GIR_EraseRootFromParent_Done,
     /* 2310542 */   // Label 33530: @2310542
     /* 2310542 */   GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2310625), // Rule ID 45145 //
     /* 2310547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2310550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310583 */     // MIs[1] Operand 1
     /* 2310583 */     // No operand predicates
     /* 2310583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310587 */     // MIs[0] policy
     /* 2310587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310599 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2310602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310624 */     // GIR_Coverage, 45145,
     /* 2310624 */     GIR_EraseRootFromParent_Done,
     /* 2310625 */   // Label 33531: @2310625
     /* 2310625 */   GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2310708), // Rule ID 45220 //
     /* 2310630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310666 */     // MIs[1] Operand 1
     /* 2310666 */     // No operand predicates
     /* 2310666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310670 */     // MIs[0] policy
     /* 2310670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310682 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2310685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310707 */     // GIR_Coverage, 45220,
     /* 2310707 */     GIR_EraseRootFromParent_Done,
     /* 2310708 */   // Label 33532: @2310708
     /* 2310708 */   GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2310791), // Rule ID 45221 //
     /* 2310713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2310716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2310745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2310749 */     // MIs[1] Operand 1
     /* 2310749 */     // No operand predicates
     /* 2310749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310753 */     // MIs[0] policy
     /* 2310753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310765 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2310768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2310777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310790 */     // GIR_Coverage, 45221,
     /* 2310790 */     GIR_EraseRootFromParent_Done,
     /* 2310791 */   // Label 33533: @2310791
     /* 2310791 */   GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2310863), // Rule ID 45146 //
     /* 2310796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310828 */     // MIs[0] policy
     /* 2310828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310838 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2310841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310862 */     // GIR_Coverage, 45146,
     /* 2310862 */     GIR_EraseRootFromParent_Done,
     /* 2310863 */   // Label 33534: @2310863
     /* 2310863 */   GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2310935), // Rule ID 45147 //
     /* 2310868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2310871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2310874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2310880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310900 */     // MIs[0] policy
     /* 2310900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310910 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2310910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2310913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2310928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2310933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310934 */     // GIR_Coverage, 45147,
     /* 2310934 */     GIR_EraseRootFromParent_Done,
     /* 2310935 */   // Label 33535: @2310935
     /* 2310935 */   GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2311007), // Rule ID 45222 //
     /* 2310940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2310943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2310946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2310949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2310952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2310956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2310972 */     // MIs[0] policy
     /* 2310972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2310975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2310982 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2310982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2310985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2310991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2310995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311006 */     // GIR_Coverage, 45222,
     /* 2311006 */     GIR_EraseRootFromParent_Done,
     /* 2311007 */   // Label 33536: @2311007
     /* 2311007 */   GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2311079), // Rule ID 45223 //
     /* 2311012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2311015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311044 */     // MIs[0] policy
     /* 2311044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311054 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2311057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311078 */     // GIR_Coverage, 45223,
     /* 2311078 */     GIR_EraseRootFromParent_Done,
     /* 2311079 */   // Label 33537: @2311079
     /* 2311079 */   GIM_Reject,
     /* 2311080 */ // Label 33529: @2311080
     /* 2311080 */ GIM_Reject,
     /* 2311081 */ // Label 33475: @2311081
     /* 2311081 */ GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2311713),
     /* 2311086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2311092 */   GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2311175), // Rule ID 45160 //
     /* 2311097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2311100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311133 */     // MIs[1] Operand 1
     /* 2311133 */     // No operand predicates
     /* 2311133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311137 */     // MIs[0] policy
     /* 2311137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311149 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2311152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311174 */     // GIR_Coverage, 45160,
     /* 2311174 */     GIR_EraseRootFromParent_Done,
     /* 2311175 */   // Label 33539: @2311175
     /* 2311175 */   GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2311258), // Rule ID 45161 //
     /* 2311180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2311183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311216 */     // MIs[1] Operand 1
     /* 2311216 */     // No operand predicates
     /* 2311216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311220 */     // MIs[0] policy
     /* 2311220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311232 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2311235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311257 */     // GIR_Coverage, 45161,
     /* 2311257 */     GIR_EraseRootFromParent_Done,
     /* 2311258 */   // Label 33540: @2311258
     /* 2311258 */   GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2311341), // Rule ID 45232 //
     /* 2311263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2311266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311299 */     // MIs[1] Operand 1
     /* 2311299 */     // No operand predicates
     /* 2311299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311303 */     // MIs[0] policy
     /* 2311303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311315 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2311318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311340 */     // GIR_Coverage, 45232,
     /* 2311340 */     GIR_EraseRootFromParent_Done,
     /* 2311341 */   // Label 33541: @2311341
     /* 2311341 */   GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2311424), // Rule ID 45233 //
     /* 2311346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2311349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311382 */     // MIs[1] Operand 1
     /* 2311382 */     // No operand predicates
     /* 2311382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311386 */     // MIs[0] policy
     /* 2311386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311398 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2311401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311423 */     // GIR_Coverage, 45233,
     /* 2311423 */     GIR_EraseRootFromParent_Done,
     /* 2311424 */   // Label 33542: @2311424
     /* 2311424 */   GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2311496), // Rule ID 45162 //
     /* 2311429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2311432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311461 */     // MIs[0] policy
     /* 2311461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311471 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2311474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311495 */     // GIR_Coverage, 45162,
     /* 2311495 */     GIR_EraseRootFromParent_Done,
     /* 2311496 */   // Label 33543: @2311496
     /* 2311496 */   GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2311568), // Rule ID 45163 //
     /* 2311501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2311504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311533 */     // MIs[0] policy
     /* 2311533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311543 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2311546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311567 */     // GIR_Coverage, 45163,
     /* 2311567 */     GIR_EraseRootFromParent_Done,
     /* 2311568 */   // Label 33544: @2311568
     /* 2311568 */   GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2311640), // Rule ID 45234 //
     /* 2311573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2311576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311605 */     // MIs[0] policy
     /* 2311605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311615 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2311618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311639 */     // GIR_Coverage, 45234,
     /* 2311639 */     GIR_EraseRootFromParent_Done,
     /* 2311640 */   // Label 33545: @2311640
     /* 2311640 */   GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2311712), // Rule ID 45235 //
     /* 2311645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2311648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2311661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311677 */     // MIs[0] policy
     /* 2311677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311687 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2311690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311711 */     // GIR_Coverage, 45235,
     /* 2311711 */     GIR_EraseRootFromParent_Done,
     /* 2311712 */   // Label 33546: @2311712
     /* 2311712 */   GIM_Reject,
     /* 2311713 */ // Label 33538: @2311713
     /* 2311713 */ GIM_Reject,
     /* 2311714 */ // Label 33476: @2311714
     /* 2311714 */ GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2312346),
     /* 2311719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2311722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2311725 */   GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2311808), // Rule ID 45204 //
     /* 2311730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2311733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2311746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311766 */     // MIs[1] Operand 1
     /* 2311766 */     // No operand predicates
     /* 2311766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311770 */     // MIs[0] policy
     /* 2311770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311782 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2311785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311807 */     // GIR_Coverage, 45204,
     /* 2311807 */     GIR_EraseRootFromParent_Done,
     /* 2311808 */   // Label 33548: @2311808
     /* 2311808 */   GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2311891), // Rule ID 45205 //
     /* 2311813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2311816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2311829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311849 */     // MIs[1] Operand 1
     /* 2311849 */     // No operand predicates
     /* 2311849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311853 */     // MIs[0] policy
     /* 2311853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311865 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2311865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2311868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311890 */     // GIR_Coverage, 45205,
     /* 2311890 */     GIR_EraseRootFromParent_Done,
     /* 2311891 */   // Label 33549: @2311891
     /* 2311891 */   GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2311974), // Rule ID 45264 //
     /* 2311896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2311899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2311902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2311908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2311912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2311928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2311932 */     // MIs[1] Operand 1
     /* 2311932 */     // No operand predicates
     /* 2311932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2311936 */     // MIs[0] policy
     /* 2311936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2311939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2311948 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2311948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2311951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2311957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2311960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2311962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2311967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2311972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311973 */     // GIR_Coverage, 45264,
     /* 2311973 */     GIR_EraseRootFromParent_Done,
     /* 2311974 */   // Label 33550: @2311974
     /* 2311974 */   GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2312057), // Rule ID 45265 //
     /* 2311979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2311982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2311988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2311991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2311995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2311999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312015 */     // MIs[1] Operand 1
     /* 2312015 */     // No operand predicates
     /* 2312015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312019 */     // MIs[0] policy
     /* 2312019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312031 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2312034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312056 */     // GIR_Coverage, 45265,
     /* 2312056 */     GIR_EraseRootFromParent_Done,
     /* 2312057 */   // Label 33551: @2312057
     /* 2312057 */   GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2312129), // Rule ID 45206 //
     /* 2312062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2312065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2312071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2312078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312094 */     // MIs[0] policy
     /* 2312094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312104 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2312107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312128 */     // GIR_Coverage, 45206,
     /* 2312128 */     GIR_EraseRootFromParent_Done,
     /* 2312129 */   // Label 33552: @2312129
     /* 2312129 */   GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2312201), // Rule ID 45207 //
     /* 2312134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2312137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2312143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2312150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312166 */     // MIs[0] policy
     /* 2312166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312176 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2312179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312200 */     // GIR_Coverage, 45207,
     /* 2312200 */     GIR_EraseRootFromParent_Done,
     /* 2312201 */   // Label 33553: @2312201
     /* 2312201 */   GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2312273), // Rule ID 45266 //
     /* 2312206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2312209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2312215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2312222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312238 */     // MIs[0] policy
     /* 2312238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312248 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2312251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312272 */     // GIR_Coverage, 45266,
     /* 2312272 */     GIR_EraseRootFromParent_Done,
     /* 2312273 */   // Label 33554: @2312273
     /* 2312273 */   GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2312345), // Rule ID 45267 //
     /* 2312278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2312281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2312287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2312294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312310 */     // MIs[0] policy
     /* 2312310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312320 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2312323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312344 */     // GIR_Coverage, 45267,
     /* 2312344 */     GIR_EraseRootFromParent_Done,
     /* 2312345 */   // Label 33555: @2312345
     /* 2312345 */   GIM_Reject,
     /* 2312346 */ // Label 33547: @2312346
     /* 2312346 */ GIM_Reject,
     /* 2312347 */ // Label 33477: @2312347
     /* 2312347 */ GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2312669),
     /* 2312352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2312355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2312358 */   GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2312441), // Rule ID 45136 //
     /* 2312363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2312366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312399 */     // MIs[1] Operand 1
     /* 2312399 */     // No operand predicates
     /* 2312399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312403 */     // MIs[0] policy
     /* 2312403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312415 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2312418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312440 */     // GIR_Coverage, 45136,
     /* 2312440 */     GIR_EraseRootFromParent_Done,
     /* 2312441 */   // Label 33557: @2312441
     /* 2312441 */   GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2312524), // Rule ID 45137 //
     /* 2312446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2312449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312482 */     // MIs[1] Operand 1
     /* 2312482 */     // No operand predicates
     /* 2312482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312486 */     // MIs[0] policy
     /* 2312486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312498 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2312501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312523 */     // GIR_Coverage, 45137,
     /* 2312523 */     GIR_EraseRootFromParent_Done,
     /* 2312524 */   // Label 33558: @2312524
     /* 2312524 */   GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2312596), // Rule ID 45138 //
     /* 2312529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2312532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312561 */     // MIs[0] policy
     /* 2312561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312571 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2312574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312595 */     // GIR_Coverage, 45138,
     /* 2312595 */     GIR_EraseRootFromParent_Done,
     /* 2312596 */   // Label 33559: @2312596
     /* 2312596 */   GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2312668), // Rule ID 45139 //
     /* 2312601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2312604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312633 */     // MIs[0] policy
     /* 2312633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312643 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2312646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312667 */     // GIR_Coverage, 45139,
     /* 2312667 */     GIR_EraseRootFromParent_Done,
     /* 2312668 */   // Label 33560: @2312668
     /* 2312668 */   GIM_Reject,
     /* 2312669 */ // Label 33556: @2312669
     /* 2312669 */ GIM_Reject,
     /* 2312670 */ // Label 33478: @2312670
     /* 2312670 */ GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2313302),
     /* 2312675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2312678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2312681 */   GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2312764), // Rule ID 45156 //
     /* 2312686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2312689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312722 */     // MIs[1] Operand 1
     /* 2312722 */     // No operand predicates
     /* 2312722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312726 */     // MIs[0] policy
     /* 2312726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312738 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2312741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312763 */     // GIR_Coverage, 45156,
     /* 2312763 */     GIR_EraseRootFromParent_Done,
     /* 2312764 */   // Label 33562: @2312764
     /* 2312764 */   GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2312847), // Rule ID 45157 //
     /* 2312769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2312772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312805 */     // MIs[1] Operand 1
     /* 2312805 */     // No operand predicates
     /* 2312805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312809 */     // MIs[0] policy
     /* 2312809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312821 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2312824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312846 */     // GIR_Coverage, 45157,
     /* 2312846 */     GIR_EraseRootFromParent_Done,
     /* 2312847 */   // Label 33563: @2312847
     /* 2312847 */   GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2312930), // Rule ID 45228 //
     /* 2312852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2312855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2312864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312888 */     // MIs[1] Operand 1
     /* 2312888 */     // No operand predicates
     /* 2312888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312892 */     // MIs[0] policy
     /* 2312892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312904 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2312904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2312907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2312918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2312923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2312928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312929 */     // GIR_Coverage, 45228,
     /* 2312929 */     GIR_EraseRootFromParent_Done,
     /* 2312930 */   // Label 33564: @2312930
     /* 2312930 */   GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2313013), // Rule ID 45229 //
     /* 2312935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2312938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2312941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2312944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2312947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2312951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2312967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2312971 */     // MIs[1] Operand 1
     /* 2312971 */     // No operand predicates
     /* 2312971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2312975 */     // MIs[0] policy
     /* 2312975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2312978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2312987 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2312987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2312990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2312996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2312999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313012 */     // GIR_Coverage, 45229,
     /* 2313012 */     GIR_EraseRootFromParent_Done,
     /* 2313013 */   // Label 33565: @2313013
     /* 2313013 */   GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2313085), // Rule ID 45158 //
     /* 2313018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2313034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313050 */     // MIs[0] policy
     /* 2313050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313060 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2313063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313084 */     // GIR_Coverage, 45158,
     /* 2313084 */     GIR_EraseRootFromParent_Done,
     /* 2313085 */   // Label 33566: @2313085
     /* 2313085 */   GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2313157), // Rule ID 45159 //
     /* 2313090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2313106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313122 */     // MIs[0] policy
     /* 2313122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313132 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2313135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313156 */     // GIR_Coverage, 45159,
     /* 2313156 */     GIR_EraseRootFromParent_Done,
     /* 2313157 */   // Label 33567: @2313157
     /* 2313157 */   GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2313229), // Rule ID 45230 //
     /* 2313162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2313178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313194 */     // MIs[0] policy
     /* 2313194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313204 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2313207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313228 */     // GIR_Coverage, 45230,
     /* 2313228 */     GIR_EraseRootFromParent_Done,
     /* 2313229 */   // Label 33568: @2313229
     /* 2313229 */   GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2313301), // Rule ID 45231 //
     /* 2313234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2313250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313266 */     // MIs[0] policy
     /* 2313266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313276 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2313279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313300 */     // GIR_Coverage, 45231,
     /* 2313300 */     GIR_EraseRootFromParent_Done,
     /* 2313301 */   // Label 33569: @2313301
     /* 2313301 */   GIM_Reject,
     /* 2313302 */ // Label 33561: @2313302
     /* 2313302 */ GIM_Reject,
     /* 2313303 */ // Label 33479: @2313303
     /* 2313303 */ GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2313935),
     /* 2313308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2313314 */   GIM_Try, /*On fail goto*//*Label 33571*/ GIMT_Encode4(2313397), // Rule ID 45192 //
     /* 2313319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2313351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2313355 */     // MIs[1] Operand 1
     /* 2313355 */     // No operand predicates
     /* 2313355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313359 */     // MIs[0] policy
     /* 2313359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313371 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2313374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2313383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313396 */     // GIR_Coverage, 45192,
     /* 2313396 */     GIR_EraseRootFromParent_Done,
     /* 2313397 */   // Label 33571: @2313397
     /* 2313397 */   GIM_Try, /*On fail goto*//*Label 33572*/ GIMT_Encode4(2313480), // Rule ID 45193 //
     /* 2313402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2313434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2313438 */     // MIs[1] Operand 1
     /* 2313438 */     // No operand predicates
     /* 2313438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313442 */     // MIs[0] policy
     /* 2313442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313454 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2313457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2313466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313479 */     // GIR_Coverage, 45193,
     /* 2313479 */     GIR_EraseRootFromParent_Done,
     /* 2313480 */   // Label 33572: @2313480
     /* 2313480 */   GIM_Try, /*On fail goto*//*Label 33573*/ GIMT_Encode4(2313563), // Rule ID 45252 //
     /* 2313485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2313517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2313521 */     // MIs[1] Operand 1
     /* 2313521 */     // No operand predicates
     /* 2313521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313525 */     // MIs[0] policy
     /* 2313525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313537 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2313540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2313549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313562 */     // GIR_Coverage, 45252,
     /* 2313562 */     GIR_EraseRootFromParent_Done,
     /* 2313563 */   // Label 33573: @2313563
     /* 2313563 */   GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2313646), // Rule ID 45253 //
     /* 2313568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2313600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2313604 */     // MIs[1] Operand 1
     /* 2313604 */     // No operand predicates
     /* 2313604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313608 */     // MIs[0] policy
     /* 2313608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313620 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2313623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2313632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313645 */     // GIR_Coverage, 45253,
     /* 2313645 */     GIR_EraseRootFromParent_Done,
     /* 2313646 */   // Label 33574: @2313646
     /* 2313646 */   GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2313718), // Rule ID 45194 //
     /* 2313651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313683 */     // MIs[0] policy
     /* 2313683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313693 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2313696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313717 */     // GIR_Coverage, 45194,
     /* 2313717 */     GIR_EraseRootFromParent_Done,
     /* 2313718 */   // Label 33575: @2313718
     /* 2313718 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2313790), // Rule ID 45195 //
     /* 2313723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313755 */     // MIs[0] policy
     /* 2313755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313765 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2313768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313789 */     // GIR_Coverage, 45195,
     /* 2313789 */     GIR_EraseRootFromParent_Done,
     /* 2313790 */   // Label 33576: @2313790
     /* 2313790 */   GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2313862), // Rule ID 45254 //
     /* 2313795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2313798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313827 */     // MIs[0] policy
     /* 2313827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313837 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2313837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2313840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313861 */     // GIR_Coverage, 45254,
     /* 2313861 */     GIR_EraseRootFromParent_Done,
     /* 2313862 */   // Label 33577: @2313862
     /* 2313862 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2313934), // Rule ID 45255 //
     /* 2313867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2313870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2313873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2313879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2313883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313899 */     // MIs[0] policy
     /* 2313899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2313909 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2313909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2313912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2313918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2313922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2313927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2313932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313933 */     // GIR_Coverage, 45255,
     /* 2313933 */     GIR_EraseRootFromParent_Done,
     /* 2313934 */   // Label 33578: @2313934
     /* 2313934 */   GIM_Reject,
     /* 2313935 */ // Label 33570: @2313935
     /* 2313935 */ GIM_Reject,
     /* 2313936 */ // Label 33480: @2313936
     /* 2313936 */ GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2314568),
     /* 2313941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2313944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2313947 */   GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2314030), // Rule ID 45208 //
     /* 2313952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2313955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2313958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2313961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2313964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2313968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2313972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2313976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2313984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2313988 */     // MIs[1] Operand 1
     /* 2313988 */     // No operand predicates
     /* 2313988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2313992 */     // MIs[0] policy
     /* 2313992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2313995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314004 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2314007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314029 */     // GIR_Coverage, 45208,
     /* 2314029 */     GIR_EraseRootFromParent_Done,
     /* 2314030 */   // Label 33580: @2314030
     /* 2314030 */   GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2314113), // Rule ID 45209 //
     /* 2314035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2314038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314071 */     // MIs[1] Operand 1
     /* 2314071 */     // No operand predicates
     /* 2314071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314075 */     // MIs[0] policy
     /* 2314075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314087 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2314090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314112 */     // GIR_Coverage, 45209,
     /* 2314112 */     GIR_EraseRootFromParent_Done,
     /* 2314113 */   // Label 33581: @2314113
     /* 2314113 */   GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2314196), // Rule ID 45268 //
     /* 2314118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2314121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314154 */     // MIs[1] Operand 1
     /* 2314154 */     // No operand predicates
     /* 2314154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314158 */     // MIs[0] policy
     /* 2314158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314170 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2314173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314195 */     // GIR_Coverage, 45268,
     /* 2314195 */     GIR_EraseRootFromParent_Done,
     /* 2314196 */   // Label 33582: @2314196
     /* 2314196 */   GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2314279), // Rule ID 45269 //
     /* 2314201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2314204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314237 */     // MIs[1] Operand 1
     /* 2314237 */     // No operand predicates
     /* 2314237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314241 */     // MIs[0] policy
     /* 2314241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314253 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2314256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314278 */     // GIR_Coverage, 45269,
     /* 2314278 */     GIR_EraseRootFromParent_Done,
     /* 2314279 */   // Label 33583: @2314279
     /* 2314279 */   GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2314351), // Rule ID 45210 //
     /* 2314284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2314287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314316 */     // MIs[0] policy
     /* 2314316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314326 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2314329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314350 */     // GIR_Coverage, 45210,
     /* 2314350 */     GIR_EraseRootFromParent_Done,
     /* 2314351 */   // Label 33584: @2314351
     /* 2314351 */   GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2314423), // Rule ID 45211 //
     /* 2314356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2314359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314388 */     // MIs[0] policy
     /* 2314388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314398 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2314401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314422 */     // GIR_Coverage, 45211,
     /* 2314422 */     GIR_EraseRootFromParent_Done,
     /* 2314423 */   // Label 33585: @2314423
     /* 2314423 */   GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2314495), // Rule ID 45270 //
     /* 2314428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2314431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314460 */     // MIs[0] policy
     /* 2314460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314470 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2314473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314494 */     // GIR_Coverage, 45270,
     /* 2314494 */     GIR_EraseRootFromParent_Done,
     /* 2314495 */   // Label 33586: @2314495
     /* 2314495 */   GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2314567), // Rule ID 45271 //
     /* 2314500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2314503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2314509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2314516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314532 */     // MIs[0] policy
     /* 2314532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314542 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2314545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314566 */     // GIR_Coverage, 45271,
     /* 2314566 */     GIR_EraseRootFromParent_Done,
     /* 2314567 */   // Label 33587: @2314567
     /* 2314567 */   GIM_Reject,
     /* 2314568 */ // Label 33579: @2314568
     /* 2314568 */ GIM_Reject,
     /* 2314569 */ // Label 33481: @2314569
     /* 2314569 */ GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2314891),
     /* 2314574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2314577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2314580 */   GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2314663), // Rule ID 45152 //
     /* 2314585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2314588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2314594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2314601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314621 */     // MIs[1] Operand 1
     /* 2314621 */     // No operand predicates
     /* 2314621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314625 */     // MIs[0] policy
     /* 2314625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314637 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2314640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314662 */     // GIR_Coverage, 45152,
     /* 2314662 */     GIR_EraseRootFromParent_Done,
     /* 2314663 */   // Label 33589: @2314663
     /* 2314663 */   GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2314746), // Rule ID 45153 //
     /* 2314668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2314671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2314677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2314684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314704 */     // MIs[1] Operand 1
     /* 2314704 */     // No operand predicates
     /* 2314704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314708 */     // MIs[0] policy
     /* 2314708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314720 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2314723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314745 */     // GIR_Coverage, 45153,
     /* 2314745 */     GIR_EraseRootFromParent_Done,
     /* 2314746 */   // Label 33590: @2314746
     /* 2314746 */   GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2314818), // Rule ID 45154 //
     /* 2314751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2314754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2314760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2314767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314783 */     // MIs[0] policy
     /* 2314783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314793 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2314796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314817 */     // GIR_Coverage, 45154,
     /* 2314817 */     GIR_EraseRootFromParent_Done,
     /* 2314818 */   // Label 33591: @2314818
     /* 2314818 */   GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2314890), // Rule ID 45155 //
     /* 2314823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2314826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2314832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2314835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2314839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314855 */     // MIs[0] policy
     /* 2314855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314865 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2314865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2314868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314889 */     // GIR_Coverage, 45155,
     /* 2314889 */     GIR_EraseRootFromParent_Done,
     /* 2314890 */   // Label 33592: @2314890
     /* 2314890 */   GIM_Reject,
     /* 2314891 */ // Label 33588: @2314891
     /* 2314891 */ GIM_Reject,
     /* 2314892 */ // Label 33482: @2314892
     /* 2314892 */ GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2315524),
     /* 2314897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2314903 */   GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2314986), // Rule ID 45180 //
     /* 2314908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2314911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2314914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2314917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2314920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2314924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2314940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2314944 */     // MIs[1] Operand 1
     /* 2314944 */     // No operand predicates
     /* 2314944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2314948 */     // MIs[0] policy
     /* 2314948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2314951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2314960 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2314960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2314963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2314969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2314972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2314974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2314979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2314984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314985 */     // GIR_Coverage, 45180,
     /* 2314985 */     GIR_EraseRootFromParent_Done,
     /* 2314986 */   // Label 33594: @2314986
     /* 2314986 */   GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2315069), // Rule ID 45181 //
     /* 2314991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2314994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2314997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315027 */     // MIs[1] Operand 1
     /* 2315027 */     // No operand predicates
     /* 2315027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315031 */     // MIs[0] policy
     /* 2315031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315043 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2315046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315068 */     // GIR_Coverage, 45181,
     /* 2315068 */     GIR_EraseRootFromParent_Done,
     /* 2315069 */   // Label 33595: @2315069
     /* 2315069 */   GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2315152), // Rule ID 45240 //
     /* 2315074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315110 */     // MIs[1] Operand 1
     /* 2315110 */     // No operand predicates
     /* 2315110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315114 */     // MIs[0] policy
     /* 2315114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315126 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2315129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315151 */     // GIR_Coverage, 45240,
     /* 2315151 */     GIR_EraseRootFromParent_Done,
     /* 2315152 */   // Label 33596: @2315152
     /* 2315152 */   GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2315235), // Rule ID 45241 //
     /* 2315157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315193 */     // MIs[1] Operand 1
     /* 2315193 */     // No operand predicates
     /* 2315193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315197 */     // MIs[0] policy
     /* 2315197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315209 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2315212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315234 */     // GIR_Coverage, 45241,
     /* 2315234 */     GIR_EraseRootFromParent_Done,
     /* 2315235 */   // Label 33597: @2315235
     /* 2315235 */   GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2315307), // Rule ID 45182 //
     /* 2315240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315272 */     // MIs[0] policy
     /* 2315272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315282 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2315285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315306 */     // GIR_Coverage, 45182,
     /* 2315306 */     GIR_EraseRootFromParent_Done,
     /* 2315307 */   // Label 33598: @2315307
     /* 2315307 */   GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2315379), // Rule ID 45183 //
     /* 2315312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315344 */     // MIs[0] policy
     /* 2315344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315354 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2315357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315378 */     // GIR_Coverage, 45183,
     /* 2315378 */     GIR_EraseRootFromParent_Done,
     /* 2315379 */   // Label 33599: @2315379
     /* 2315379 */   GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2315451), // Rule ID 45242 //
     /* 2315384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315416 */     // MIs[0] policy
     /* 2315416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315426 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2315429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315450 */     // GIR_Coverage, 45242,
     /* 2315450 */     GIR_EraseRootFromParent_Done,
     /* 2315451 */   // Label 33600: @2315451
     /* 2315451 */   GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2315523), // Rule ID 45243 //
     /* 2315456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2315472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315488 */     // MIs[0] policy
     /* 2315488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315498 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2315501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315522 */     // GIR_Coverage, 45243,
     /* 2315522 */     GIR_EraseRootFromParent_Done,
     /* 2315523 */   // Label 33601: @2315523
     /* 2315523 */   GIM_Reject,
     /* 2315524 */ // Label 33593: @2315524
     /* 2315524 */ GIM_Reject,
     /* 2315525 */ // Label 33483: @2315525
     /* 2315525 */ GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2316157),
     /* 2315530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2315533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2315536 */   GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2315619), // Rule ID 45196 //
     /* 2315541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315577 */     // MIs[1] Operand 1
     /* 2315577 */     // No operand predicates
     /* 2315577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315581 */     // MIs[0] policy
     /* 2315581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315593 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2315596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315618 */     // GIR_Coverage, 45196,
     /* 2315618 */     GIR_EraseRootFromParent_Done,
     /* 2315619 */   // Label 33603: @2315619
     /* 2315619 */   GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2315702), // Rule ID 45197 //
     /* 2315624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315660 */     // MIs[1] Operand 1
     /* 2315660 */     // No operand predicates
     /* 2315660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315664 */     // MIs[0] policy
     /* 2315664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315676 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2315679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315701 */     // GIR_Coverage, 45197,
     /* 2315701 */     GIR_EraseRootFromParent_Done,
     /* 2315702 */   // Label 33604: @2315702
     /* 2315702 */   GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2315785), // Rule ID 45256 //
     /* 2315707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315743 */     // MIs[1] Operand 1
     /* 2315743 */     // No operand predicates
     /* 2315743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315747 */     // MIs[0] policy
     /* 2315747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315759 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2315762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315784 */     // GIR_Coverage, 45256,
     /* 2315784 */     GIR_EraseRootFromParent_Done,
     /* 2315785 */   // Label 33605: @2315785
     /* 2315785 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2315868), // Rule ID 45257 //
     /* 2315790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2315822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2315826 */     // MIs[1] Operand 1
     /* 2315826 */     // No operand predicates
     /* 2315826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315830 */     // MIs[0] policy
     /* 2315830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315842 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2315845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2315854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315867 */     // GIR_Coverage, 45257,
     /* 2315867 */     GIR_EraseRootFromParent_Done,
     /* 2315868 */   // Label 33606: @2315868
     /* 2315868 */   GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2315940), // Rule ID 45198 //
     /* 2315873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2315876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2315879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2315885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315905 */     // MIs[0] policy
     /* 2315905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315915 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2315915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2315918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2315928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2315933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2315938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315939 */     // GIR_Coverage, 45198,
     /* 2315939 */     GIR_EraseRootFromParent_Done,
     /* 2315940 */   // Label 33607: @2315940
     /* 2315940 */   GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2316012), // Rule ID 45199 //
     /* 2315945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2315948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2315951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2315954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2315957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2315961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2315977 */     // MIs[0] policy
     /* 2315977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2315980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2315987 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2315987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2315990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2315996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316011 */     // GIR_Coverage, 45199,
     /* 2316011 */     GIR_EraseRootFromParent_Done,
     /* 2316012 */   // Label 33608: @2316012
     /* 2316012 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2316084), // Rule ID 45258 //
     /* 2316017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2316020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2316033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316049 */     // MIs[0] policy
     /* 2316049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316059 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2316062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316083 */     // GIR_Coverage, 45258,
     /* 2316083 */     GIR_EraseRootFromParent_Done,
     /* 2316084 */   // Label 33609: @2316084
     /* 2316084 */   GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2316156), // Rule ID 45259 //
     /* 2316089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2316092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2316105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316121 */     // MIs[0] policy
     /* 2316121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316131 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2316134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316155 */     // GIR_Coverage, 45259,
     /* 2316155 */     GIR_EraseRootFromParent_Done,
     /* 2316156 */   // Label 33610: @2316156
     /* 2316156 */   GIM_Reject,
     /* 2316157 */ // Label 33602: @2316157
     /* 2316157 */ GIM_Reject,
     /* 2316158 */ // Label 33484: @2316158
     /* 2316158 */ GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2316790),
     /* 2316163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2316166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2316169 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2316252), // Rule ID 45212 //
     /* 2316174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2316177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316210 */     // MIs[1] Operand 1
     /* 2316210 */     // No operand predicates
     /* 2316210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316214 */     // MIs[0] policy
     /* 2316214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316226 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2316229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316251 */     // GIR_Coverage, 45212,
     /* 2316251 */     GIR_EraseRootFromParent_Done,
     /* 2316252 */   // Label 33612: @2316252
     /* 2316252 */   GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2316335), // Rule ID 45213 //
     /* 2316257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2316260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316293 */     // MIs[1] Operand 1
     /* 2316293 */     // No operand predicates
     /* 2316293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316297 */     // MIs[0] policy
     /* 2316297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316309 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2316312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316334 */     // GIR_Coverage, 45213,
     /* 2316334 */     GIR_EraseRootFromParent_Done,
     /* 2316335 */   // Label 33613: @2316335
     /* 2316335 */   GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2316418), // Rule ID 45272 //
     /* 2316340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2316343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316376 */     // MIs[1] Operand 1
     /* 2316376 */     // No operand predicates
     /* 2316376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316380 */     // MIs[0] policy
     /* 2316380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316392 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2316395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316417 */     // GIR_Coverage, 45272,
     /* 2316417 */     GIR_EraseRootFromParent_Done,
     /* 2316418 */   // Label 33614: @2316418
     /* 2316418 */   GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2316501), // Rule ID 45273 //
     /* 2316423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2316426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316459 */     // MIs[1] Operand 1
     /* 2316459 */     // No operand predicates
     /* 2316459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316463 */     // MIs[0] policy
     /* 2316463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316475 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2316478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316500 */     // GIR_Coverage, 45273,
     /* 2316500 */     GIR_EraseRootFromParent_Done,
     /* 2316501 */   // Label 33615: @2316501
     /* 2316501 */   GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2316573), // Rule ID 45214 //
     /* 2316506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2316509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316538 */     // MIs[0] policy
     /* 2316538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316548 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2316551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316572 */     // GIR_Coverage, 45214,
     /* 2316572 */     GIR_EraseRootFromParent_Done,
     /* 2316573 */   // Label 33616: @2316573
     /* 2316573 */   GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2316645), // Rule ID 45215 //
     /* 2316578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2316581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316610 */     // MIs[0] policy
     /* 2316610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316620 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2316623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316644 */     // GIR_Coverage, 45215,
     /* 2316644 */     GIR_EraseRootFromParent_Done,
     /* 2316645 */   // Label 33617: @2316645
     /* 2316645 */   GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2316717), // Rule ID 45274 //
     /* 2316650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2316653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316682 */     // MIs[0] policy
     /* 2316682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316692 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2316695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316716 */     // GIR_Coverage, 45274,
     /* 2316716 */     GIR_EraseRootFromParent_Done,
     /* 2316717 */   // Label 33618: @2316717
     /* 2316717 */   GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2316789), // Rule ID 45275 //
     /* 2316722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2316725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2316731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2316738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316754 */     // MIs[0] policy
     /* 2316754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316764 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2316767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316788 */     // GIR_Coverage, 45275,
     /* 2316788 */     GIR_EraseRootFromParent_Done,
     /* 2316789 */   // Label 33619: @2316789
     /* 2316789 */   GIM_Reject,
     /* 2316790 */ // Label 33611: @2316790
     /* 2316790 */ GIM_Reject,
     /* 2316791 */ // Label 33485: @2316791
     /* 2316791 */ GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2317113),
     /* 2316796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2316799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2316802 */   GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2316885), // Rule ID 45168 //
     /* 2316807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2316810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2316816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2316823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316843 */     // MIs[1] Operand 1
     /* 2316843 */     // No operand predicates
     /* 2316843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316847 */     // MIs[0] policy
     /* 2316847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316859 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2316859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2316862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316884 */     // GIR_Coverage, 45168,
     /* 2316884 */     GIR_EraseRootFromParent_Done,
     /* 2316885 */   // Label 33621: @2316885
     /* 2316885 */   GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2316968), // Rule ID 45169 //
     /* 2316890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2316893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2316896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2316899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2316902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2316906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2316922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2316926 */     // MIs[1] Operand 1
     /* 2316926 */     // No operand predicates
     /* 2316926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2316930 */     // MIs[0] policy
     /* 2316930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2316933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2316942 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2316942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2316945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2316951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2316954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2316956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2316961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2316966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316967 */     // GIR_Coverage, 45169,
     /* 2316967 */     GIR_EraseRootFromParent_Done,
     /* 2316968 */   // Label 33622: @2316968
     /* 2316968 */   GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2317040), // Rule ID 45170 //
     /* 2316973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2316976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2316979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2316982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2316985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2316989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317005 */     // MIs[0] policy
     /* 2317005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317015 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2317018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317039 */     // GIR_Coverage, 45170,
     /* 2317039 */     GIR_EraseRootFromParent_Done,
     /* 2317040 */   // Label 33623: @2317040
     /* 2317040 */   GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2317112), // Rule ID 45171 //
     /* 2317045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2317061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317077 */     // MIs[0] policy
     /* 2317077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317087 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2317090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317111 */     // GIR_Coverage, 45171,
     /* 2317111 */     GIR_EraseRootFromParent_Done,
     /* 2317112 */   // Label 33624: @2317112
     /* 2317112 */   GIM_Reject,
     /* 2317113 */ // Label 33620: @2317113
     /* 2317113 */ GIM_Reject,
     /* 2317114 */ // Label 33486: @2317114
     /* 2317114 */ GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2317746),
     /* 2317119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2317125 */   GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2317208), // Rule ID 45184 //
     /* 2317130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317166 */     // MIs[1] Operand 1
     /* 2317166 */     // No operand predicates
     /* 2317166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317170 */     // MIs[0] policy
     /* 2317170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317182 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2317185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317207 */     // GIR_Coverage, 45184,
     /* 2317207 */     GIR_EraseRootFromParent_Done,
     /* 2317208 */   // Label 33626: @2317208
     /* 2317208 */   GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2317291), // Rule ID 45185 //
     /* 2317213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317249 */     // MIs[1] Operand 1
     /* 2317249 */     // No operand predicates
     /* 2317249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317253 */     // MIs[0] policy
     /* 2317253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317265 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2317268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317290 */     // GIR_Coverage, 45185,
     /* 2317290 */     GIR_EraseRootFromParent_Done,
     /* 2317291 */   // Label 33627: @2317291
     /* 2317291 */   GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2317374), // Rule ID 45244 //
     /* 2317296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317332 */     // MIs[1] Operand 1
     /* 2317332 */     // No operand predicates
     /* 2317332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317336 */     // MIs[0] policy
     /* 2317336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317348 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2317351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317373 */     // GIR_Coverage, 45244,
     /* 2317373 */     GIR_EraseRootFromParent_Done,
     /* 2317374 */   // Label 33628: @2317374
     /* 2317374 */   GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2317457), // Rule ID 45245 //
     /* 2317379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317415 */     // MIs[1] Operand 1
     /* 2317415 */     // No operand predicates
     /* 2317415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317419 */     // MIs[0] policy
     /* 2317419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317431 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2317434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317456 */     // GIR_Coverage, 45245,
     /* 2317456 */     GIR_EraseRootFromParent_Done,
     /* 2317457 */   // Label 33629: @2317457
     /* 2317457 */   GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2317529), // Rule ID 45186 //
     /* 2317462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317494 */     // MIs[0] policy
     /* 2317494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317504 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2317507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317528 */     // GIR_Coverage, 45186,
     /* 2317528 */     GIR_EraseRootFromParent_Done,
     /* 2317529 */   // Label 33630: @2317529
     /* 2317529 */   GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2317601), // Rule ID 45187 //
     /* 2317534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317566 */     // MIs[0] policy
     /* 2317566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317576 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2317579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317600 */     // GIR_Coverage, 45187,
     /* 2317600 */     GIR_EraseRootFromParent_Done,
     /* 2317601 */   // Label 33631: @2317601
     /* 2317601 */   GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2317673), // Rule ID 45246 //
     /* 2317606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317638 */     // MIs[0] policy
     /* 2317638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317648 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2317651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317672 */     // GIR_Coverage, 45246,
     /* 2317672 */     GIR_EraseRootFromParent_Done,
     /* 2317673 */   // Label 33632: @2317673
     /* 2317673 */   GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2317745), // Rule ID 45247 //
     /* 2317678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2317694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2317706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317710 */     // MIs[0] policy
     /* 2317710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317720 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2317723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317744 */     // GIR_Coverage, 45247,
     /* 2317744 */     GIR_EraseRootFromParent_Done,
     /* 2317745 */   // Label 33633: @2317745
     /* 2317745 */   GIM_Reject,
     /* 2317746 */ // Label 33625: @2317746
     /* 2317746 */ GIM_Reject,
     /* 2317747 */ // Label 33487: @2317747
     /* 2317747 */ GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2318379),
     /* 2317752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2317755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2317758 */   GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2317841), // Rule ID 45200 //
     /* 2317763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2317779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317799 */     // MIs[1] Operand 1
     /* 2317799 */     // No operand predicates
     /* 2317799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317803 */     // MIs[0] policy
     /* 2317803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317815 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2317818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317840 */     // GIR_Coverage, 45200,
     /* 2317840 */     GIR_EraseRootFromParent_Done,
     /* 2317841 */   // Label 33635: @2317841
     /* 2317841 */   GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2317924), // Rule ID 45201 //
     /* 2317846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2317849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2317852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2317858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2317862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317882 */     // MIs[1] Operand 1
     /* 2317882 */     // No operand predicates
     /* 2317882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317886 */     // MIs[0] policy
     /* 2317886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317898 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2317898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2317901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2317917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2317922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317923 */     // GIR_Coverage, 45201,
     /* 2317923 */     GIR_EraseRootFromParent_Done,
     /* 2317924 */   // Label 33636: @2317924
     /* 2317924 */   GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2318007), // Rule ID 45260 //
     /* 2317929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2317932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2317935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2317938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2317941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2317945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2317961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2317965 */     // MIs[1] Operand 1
     /* 2317965 */     // No operand predicates
     /* 2317965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2317969 */     // MIs[0] policy
     /* 2317969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2317972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2317981 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2317981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2317984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2317990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2317993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2317995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318006 */     // GIR_Coverage, 45260,
     /* 2318006 */     GIR_EraseRootFromParent_Done,
     /* 2318007 */   // Label 33637: @2318007
     /* 2318007 */   GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2318090), // Rule ID 45261 //
     /* 2318012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2318021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318048 */     // MIs[1] Operand 1
     /* 2318048 */     // No operand predicates
     /* 2318048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318052 */     // MIs[0] policy
     /* 2318052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318064 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2318067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318089 */     // GIR_Coverage, 45261,
     /* 2318089 */     GIR_EraseRootFromParent_Done,
     /* 2318090 */   // Label 33638: @2318090
     /* 2318090 */   GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2318162), // Rule ID 45202 //
     /* 2318095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2318104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318127 */     // MIs[0] policy
     /* 2318127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318137 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2318140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318161 */     // GIR_Coverage, 45202,
     /* 2318161 */     GIR_EraseRootFromParent_Done,
     /* 2318162 */   // Label 33639: @2318162
     /* 2318162 */   GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2318234), // Rule ID 45203 //
     /* 2318167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2318176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318199 */     // MIs[0] policy
     /* 2318199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318209 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2318212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318233 */     // GIR_Coverage, 45203,
     /* 2318233 */     GIR_EraseRootFromParent_Done,
     /* 2318234 */   // Label 33640: @2318234
     /* 2318234 */   GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2318306), // Rule ID 45262 //
     /* 2318239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2318248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318271 */     // MIs[0] policy
     /* 2318271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318281 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2318284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318305 */     // GIR_Coverage, 45262,
     /* 2318305 */     GIR_EraseRootFromParent_Done,
     /* 2318306 */   // Label 33641: @2318306
     /* 2318306 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2318378), // Rule ID 45263 //
     /* 2318311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2318320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318343 */     // MIs[0] policy
     /* 2318343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318353 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2318356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318377 */     // GIR_Coverage, 45263,
     /* 2318377 */     GIR_EraseRootFromParent_Done,
     /* 2318378 */   // Label 33642: @2318378
     /* 2318378 */   GIM_Reject,
     /* 2318379 */ // Label 33634: @2318379
     /* 2318379 */ GIM_Reject,
     /* 2318380 */ // Label 33488: @2318380
     /* 2318380 */ GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2318702),
     /* 2318385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2318388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2318391 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2318474), // Rule ID 45172 //
     /* 2318396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2318412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318432 */     // MIs[1] Operand 1
     /* 2318432 */     // No operand predicates
     /* 2318432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318436 */     // MIs[0] policy
     /* 2318436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318448 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2318451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318473 */     // GIR_Coverage, 45172,
     /* 2318473 */     GIR_EraseRootFromParent_Done,
     /* 2318474 */   // Label 33644: @2318474
     /* 2318474 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2318557), // Rule ID 45173 //
     /* 2318479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2318495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318515 */     // MIs[1] Operand 1
     /* 2318515 */     // No operand predicates
     /* 2318515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318519 */     // MIs[0] policy
     /* 2318519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318531 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2318534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318556 */     // GIR_Coverage, 45173,
     /* 2318556 */     GIR_EraseRootFromParent_Done,
     /* 2318557 */   // Label 33645: @2318557
     /* 2318557 */   GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2318629), // Rule ID 45174 //
     /* 2318562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2318578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318594 */     // MIs[0] policy
     /* 2318594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318604 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2318607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318628 */     // GIR_Coverage, 45174,
     /* 2318628 */     GIR_EraseRootFromParent_Done,
     /* 2318629 */   // Label 33646: @2318629
     /* 2318629 */   GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2318701), // Rule ID 45175 //
     /* 2318634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2318650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2318662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318666 */     // MIs[0] policy
     /* 2318666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318676 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2318679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318700 */     // GIR_Coverage, 45175,
     /* 2318700 */     GIR_EraseRootFromParent_Done,
     /* 2318701 */   // Label 33647: @2318701
     /* 2318701 */   GIM_Reject,
     /* 2318702 */ // Label 33643: @2318702
     /* 2318702 */ GIM_Reject,
     /* 2318703 */ // Label 33489: @2318703
     /* 2318703 */ GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2319335),
     /* 2318708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2318711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2318714 */   GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2318797), // Rule ID 45188 //
     /* 2318719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318755 */     // MIs[1] Operand 1
     /* 2318755 */     // No operand predicates
     /* 2318755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318759 */     // MIs[0] policy
     /* 2318759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318771 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2318774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318796 */     // GIR_Coverage, 45188,
     /* 2318796 */     GIR_EraseRootFromParent_Done,
     /* 2318797 */   // Label 33649: @2318797
     /* 2318797 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2318880), // Rule ID 45189 //
     /* 2318802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318838 */     // MIs[1] Operand 1
     /* 2318838 */     // No operand predicates
     /* 2318838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318842 */     // MIs[0] policy
     /* 2318842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318854 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2318854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2318857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318879 */     // GIR_Coverage, 45189,
     /* 2318879 */     GIR_EraseRootFromParent_Done,
     /* 2318880 */   // Label 33650: @2318880
     /* 2318880 */   GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2318963), // Rule ID 45248 //
     /* 2318885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2318888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2318891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2318897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2318917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2318921 */     // MIs[1] Operand 1
     /* 2318921 */     // No operand predicates
     /* 2318921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2318925 */     // MIs[0] policy
     /* 2318925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2318928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2318937 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2318937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2318940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2318946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2318949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2318951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2318956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2318961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318962 */     // GIR_Coverage, 45248,
     /* 2318962 */     GIR_EraseRootFromParent_Done,
     /* 2318963 */   // Label 33651: @2318963
     /* 2318963 */   GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2319046), // Rule ID 45249 //
     /* 2318968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2318971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2318974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2318977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2318980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2318984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2319000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2319004 */     // MIs[1] Operand 1
     /* 2319004 */     // No operand predicates
     /* 2319004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319008 */     // MIs[0] policy
     /* 2319008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319020 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2319023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2319032 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319045 */     // GIR_Coverage, 45249,
     /* 2319045 */     GIR_EraseRootFromParent_Done,
     /* 2319046 */   // Label 33652: @2319046
     /* 2319046 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2319118), // Rule ID 45190 //
     /* 2319051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2319060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319083 */     // MIs[0] policy
     /* 2319083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319093 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2319093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319117 */     // GIR_Coverage, 45190,
     /* 2319117 */     GIR_EraseRootFromParent_Done,
     /* 2319118 */   // Label 33653: @2319118
     /* 2319118 */   GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2319190), // Rule ID 45191 //
     /* 2319123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2319126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2319129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2319132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2319135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319155 */     // MIs[0] policy
     /* 2319155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319165 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319189 */     // GIR_Coverage, 45191,
     /* 2319189 */     GIR_EraseRootFromParent_Done,
     /* 2319190 */   // Label 33654: @2319190
     /* 2319190 */   GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2319262), // Rule ID 45250 //
     /* 2319195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2319204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319227 */     // MIs[0] policy
     /* 2319227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319237 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2319237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319261 */     // GIR_Coverage, 45250,
     /* 2319261 */     GIR_EraseRootFromParent_Done,
     /* 2319262 */   // Label 33655: @2319262
     /* 2319262 */   GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2319334), // Rule ID 45251 //
     /* 2319267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2319270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2319273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2319276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2319279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319299 */     // MIs[0] policy
     /* 2319299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319309 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319333 */     // GIR_Coverage, 45251,
     /* 2319333 */     GIR_EraseRootFromParent_Done,
     /* 2319334 */   // Label 33656: @2319334
     /* 2319334 */   GIM_Reject,
     /* 2319335 */ // Label 33648: @2319335
     /* 2319335 */ GIM_Reject,
     /* 2319336 */ // Label 33490: @2319336
     /* 2319336 */ GIM_Try, /*On fail goto*//*Label 33657*/ GIMT_Encode4(2319658),
     /* 2319341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2319344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2319347 */   GIM_Try, /*On fail goto*//*Label 33658*/ GIMT_Encode4(2319430), // Rule ID 45176 //
     /* 2319352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2319361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2319384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2319388 */     // MIs[1] Operand 1
     /* 2319388 */     // No operand predicates
     /* 2319388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319392 */     // MIs[0] policy
     /* 2319392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319404 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2319404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2319407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2319416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319429 */     // GIR_Coverage, 45176,
     /* 2319429 */     GIR_EraseRootFromParent_Done,
     /* 2319430 */   // Label 33658: @2319430
     /* 2319430 */   GIM_Try, /*On fail goto*//*Label 33659*/ GIMT_Encode4(2319513), // Rule ID 45177 //
     /* 2319435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2319438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2319441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2319444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2319447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2319467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2319471 */     // MIs[1] Operand 1
     /* 2319471 */     // No operand predicates
     /* 2319471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319475 */     // MIs[0] policy
     /* 2319475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319487 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2319490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2319499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319512 */     // GIR_Coverage, 45177,
     /* 2319512 */     GIR_EraseRootFromParent_Done,
     /* 2319513 */   // Label 33659: @2319513
     /* 2319513 */   GIM_Try, /*On fail goto*//*Label 33660*/ GIMT_Encode4(2319585), // Rule ID 45178 //
     /* 2319518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2319527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319550 */     // MIs[0] policy
     /* 2319550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319560 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2319560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319584 */     // GIR_Coverage, 45178,
     /* 2319584 */     GIR_EraseRootFromParent_Done,
     /* 2319585 */   // Label 33660: @2319585
     /* 2319585 */   GIM_Try, /*On fail goto*//*Label 33661*/ GIMT_Encode4(2319657), // Rule ID 45179 //
     /* 2319590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2319593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2319596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2319599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2319602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2319606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319622 */     // MIs[0] policy
     /* 2319622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319632 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2319635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319656 */     // GIR_Coverage, 45179,
     /* 2319656 */     GIR_EraseRootFromParent_Done,
     /* 2319657 */   // Label 33661: @2319657
     /* 2319657 */   GIM_Reject,
     /* 2319658 */ // Label 33657: @2319658
     /* 2319658 */ GIM_Reject,
     /* 2319659 */ // Label 33491: @2319659
     /* 2319659 */ GIM_Reject,
     /* 2319660 */ // Label 120: @2319660
     /* 2319660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33684*/ GIMT_Encode4(2331539),
     /* 2319671 */ /*GILLT_nxv1s8*//*Label 33662*/ GIMT_Encode4(2319783),
     /* 2319675 */ /*GILLT_nxv1s16*//*Label 33663*/ GIMT_Encode4(2320106),
     /* 2319679 */ /*GILLT_nxv1s32*//*Label 33664*/ GIMT_Encode4(2320739),
     /* 2319683 */ /*GILLT_nxv1s64*//*Label 33665*/ GIMT_Encode4(2321372), GIMT_Encode4(0),
     /* 2319691 */ /*GILLT_nxv2s8*//*Label 33666*/ GIMT_Encode4(2322005),
     /* 2319695 */ /*GILLT_nxv2s16*//*Label 33667*/ GIMT_Encode4(2322328),
     /* 2319699 */ /*GILLT_nxv2s32*//*Label 33668*/ GIMT_Encode4(2322961),
     /* 2319703 */ /*GILLT_nxv2s64*//*Label 33669*/ GIMT_Encode4(2323594), GIMT_Encode4(0),
     /* 2319711 */ /*GILLT_nxv4s8*//*Label 33670*/ GIMT_Encode4(2324227),
     /* 2319715 */ /*GILLT_nxv4s16*//*Label 33671*/ GIMT_Encode4(2324550),
     /* 2319719 */ /*GILLT_nxv4s32*//*Label 33672*/ GIMT_Encode4(2325183),
     /* 2319723 */ /*GILLT_nxv4s64*//*Label 33673*/ GIMT_Encode4(2325816), GIMT_Encode4(0),
     /* 2319731 */ /*GILLT_nxv8s8*//*Label 33674*/ GIMT_Encode4(2326449),
     /* 2319735 */ /*GILLT_nxv8s16*//*Label 33675*/ GIMT_Encode4(2326772),
     /* 2319739 */ /*GILLT_nxv8s32*//*Label 33676*/ GIMT_Encode4(2327405),
     /* 2319743 */ /*GILLT_nxv8s64*//*Label 33677*/ GIMT_Encode4(2328038), GIMT_Encode4(0),
     /* 2319751 */ /*GILLT_nxv16s8*//*Label 33678*/ GIMT_Encode4(2328671),
     /* 2319755 */ /*GILLT_nxv16s16*//*Label 33679*/ GIMT_Encode4(2328994),
     /* 2319759 */ /*GILLT_nxv16s32*//*Label 33680*/ GIMT_Encode4(2329627), GIMT_Encode4(0),
     /* 2319767 */ /*GILLT_nxv32s8*//*Label 33681*/ GIMT_Encode4(2330260),
     /* 2319771 */ /*GILLT_nxv32s16*//*Label 33682*/ GIMT_Encode4(2330583), GIMT_Encode4(0),
     /* 2319779 */ /*GILLT_nxv64s8*//*Label 33683*/ GIMT_Encode4(2331216),
     /* 2319783 */ // Label 33662: @2319783
     /* 2319783 */ GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2320105),
     /* 2319788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2319791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2319794 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2319877), // Rule ID 25210 //
     /* 2319799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2319808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2319815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2319831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2319835 */     // MIs[1] Operand 1
     /* 2319835 */     // No operand predicates
     /* 2319835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319839 */     // MIs[0] policy
     /* 2319839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319851 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2319851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2319854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2319863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319876 */     // GIR_Coverage, 25210,
     /* 2319876 */     GIR_EraseRootFromParent_Done,
     /* 2319877 */   // Label 33686: @2319877
     /* 2319877 */   GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2319960), // Rule ID 25211 //
     /* 2319882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2319885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2319888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2319891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2319894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2319898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2319914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2319918 */     // MIs[1] Operand 1
     /* 2319918 */     // No operand predicates
     /* 2319918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319922 */     // MIs[0] policy
     /* 2319922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2319925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2319934 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2319934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2319937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2319943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2319946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2319948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2319953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2319958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319959 */     // GIR_Coverage, 25211,
     /* 2319959 */     GIR_EraseRootFromParent_Done,
     /* 2319960 */   // Label 33687: @2319960
     /* 2319960 */   GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2320032), // Rule ID 25212 //
     /* 2319965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2319968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2319971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2319974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2319977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2319981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2319993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2319997 */     // MIs[0] policy
     /* 2319997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320007 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2320010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320031 */     // GIR_Coverage, 25212,
     /* 2320031 */     GIR_EraseRootFromParent_Done,
     /* 2320032 */   // Label 33688: @2320032
     /* 2320032 */   GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2320104), // Rule ID 25213 //
     /* 2320037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320069 */     // MIs[0] policy
     /* 2320069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320079 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2320082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320103 */     // GIR_Coverage, 25213,
     /* 2320103 */     GIR_EraseRootFromParent_Done,
     /* 2320104 */   // Label 33689: @2320104
     /* 2320104 */   GIM_Reject,
     /* 2320105 */ // Label 33685: @2320105
     /* 2320105 */ GIM_Reject,
     /* 2320106 */ // Label 33663: @2320106
     /* 2320106 */ GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2320738),
     /* 2320111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2320114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2320117 */   GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2320200), // Rule ID 44992 //
     /* 2320122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320158 */     // MIs[1] Operand 1
     /* 2320158 */     // No operand predicates
     /* 2320158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320162 */     // MIs[0] policy
     /* 2320162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320174 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2320177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320199 */     // GIR_Coverage, 44992,
     /* 2320199 */     GIR_EraseRootFromParent_Done,
     /* 2320200 */   // Label 33691: @2320200
     /* 2320200 */   GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2320283), // Rule ID 44993 //
     /* 2320205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320241 */     // MIs[1] Operand 1
     /* 2320241 */     // No operand predicates
     /* 2320241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320245 */     // MIs[0] policy
     /* 2320245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320257 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2320260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320282 */     // GIR_Coverage, 44993,
     /* 2320282 */     GIR_EraseRootFromParent_Done,
     /* 2320283 */   // Label 33692: @2320283
     /* 2320283 */   GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2320366), // Rule ID 45068 //
     /* 2320288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320324 */     // MIs[1] Operand 1
     /* 2320324 */     // No operand predicates
     /* 2320324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320328 */     // MIs[0] policy
     /* 2320328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320340 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2320343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320365 */     // GIR_Coverage, 45068,
     /* 2320365 */     GIR_EraseRootFromParent_Done,
     /* 2320366 */   // Label 33693: @2320366
     /* 2320366 */   GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2320449), // Rule ID 45069 //
     /* 2320371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320407 */     // MIs[1] Operand 1
     /* 2320407 */     // No operand predicates
     /* 2320407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320411 */     // MIs[0] policy
     /* 2320411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320423 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2320426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320448 */     // GIR_Coverage, 45069,
     /* 2320448 */     GIR_EraseRootFromParent_Done,
     /* 2320449 */   // Label 33694: @2320449
     /* 2320449 */   GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2320521), // Rule ID 44994 //
     /* 2320454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320486 */     // MIs[0] policy
     /* 2320486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320496 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2320499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320520 */     // GIR_Coverage, 44994,
     /* 2320520 */     GIR_EraseRootFromParent_Done,
     /* 2320521 */   // Label 33695: @2320521
     /* 2320521 */   GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2320593), // Rule ID 44995 //
     /* 2320526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320558 */     // MIs[0] policy
     /* 2320558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320568 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2320571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320592 */     // GIR_Coverage, 44995,
     /* 2320592 */     GIR_EraseRootFromParent_Done,
     /* 2320593 */   // Label 33696: @2320593
     /* 2320593 */   GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2320665), // Rule ID 45070 //
     /* 2320598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320630 */     // MIs[0] policy
     /* 2320630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320640 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2320643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320664 */     // GIR_Coverage, 45070,
     /* 2320664 */     GIR_EraseRootFromParent_Done,
     /* 2320665 */   // Label 33697: @2320665
     /* 2320665 */   GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2320737), // Rule ID 45071 //
     /* 2320670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320702 */     // MIs[0] policy
     /* 2320702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320712 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2320715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320736 */     // GIR_Coverage, 45071,
     /* 2320736 */     GIR_EraseRootFromParent_Done,
     /* 2320737 */   // Label 33698: @2320737
     /* 2320737 */   GIM_Reject,
     /* 2320738 */ // Label 33690: @2320738
     /* 2320738 */ GIM_Reject,
     /* 2320739 */ // Label 33664: @2320739
     /* 2320739 */ GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2321371),
     /* 2320744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2320747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2320750 */   GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2320833), // Rule ID 45000 //
     /* 2320755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320791 */     // MIs[1] Operand 1
     /* 2320791 */     // No operand predicates
     /* 2320791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320795 */     // MIs[0] policy
     /* 2320795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320807 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2320810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320832 */     // GIR_Coverage, 45000,
     /* 2320832 */     GIR_EraseRootFromParent_Done,
     /* 2320833 */   // Label 33700: @2320833
     /* 2320833 */   GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2320916), // Rule ID 45001 //
     /* 2320838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2320841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2320844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2320850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320874 */     // MIs[1] Operand 1
     /* 2320874 */     // No operand predicates
     /* 2320874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320878 */     // MIs[0] policy
     /* 2320878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320890 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2320890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2320893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320915 */     // GIR_Coverage, 45001,
     /* 2320915 */     GIR_EraseRootFromParent_Done,
     /* 2320916 */   // Label 33701: @2320916
     /* 2320916 */   GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2320999), // Rule ID 45076 //
     /* 2320921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2320924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2320927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2320930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2320933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2320937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2320953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2320957 */     // MIs[1] Operand 1
     /* 2320957 */     // No operand predicates
     /* 2320957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2320961 */     // MIs[0] policy
     /* 2320961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2320964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2320973 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2320973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2320976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2320982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2320985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2320987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2320992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2320997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320998 */     // GIR_Coverage, 45076,
     /* 2320998 */     GIR_EraseRootFromParent_Done,
     /* 2320999 */   // Label 33702: @2320999
     /* 2320999 */   GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2321082), // Rule ID 45077 //
     /* 2321004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2321007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2321036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2321040 */     // MIs[1] Operand 1
     /* 2321040 */     // No operand predicates
     /* 2321040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321044 */     // MIs[0] policy
     /* 2321044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321056 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2321059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2321068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321081 */     // GIR_Coverage, 45077,
     /* 2321081 */     GIR_EraseRootFromParent_Done,
     /* 2321082 */   // Label 33703: @2321082
     /* 2321082 */   GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2321154), // Rule ID 45002 //
     /* 2321087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2321090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321119 */     // MIs[0] policy
     /* 2321119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321129 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2321132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321153 */     // GIR_Coverage, 45002,
     /* 2321153 */     GIR_EraseRootFromParent_Done,
     /* 2321154 */   // Label 33704: @2321154
     /* 2321154 */   GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2321226), // Rule ID 45003 //
     /* 2321159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2321162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321191 */     // MIs[0] policy
     /* 2321191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321201 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2321204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321225 */     // GIR_Coverage, 45003,
     /* 2321225 */     GIR_EraseRootFromParent_Done,
     /* 2321226 */   // Label 33705: @2321226
     /* 2321226 */   GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2321298), // Rule ID 45078 //
     /* 2321231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2321234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321263 */     // MIs[0] policy
     /* 2321263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321273 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2321276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321297 */     // GIR_Coverage, 45078,
     /* 2321297 */     GIR_EraseRootFromParent_Done,
     /* 2321298 */   // Label 33706: @2321298
     /* 2321298 */   GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2321370), // Rule ID 45079 //
     /* 2321303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2321306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321335 */     // MIs[0] policy
     /* 2321335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321345 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2321348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321369 */     // GIR_Coverage, 45079,
     /* 2321369 */     GIR_EraseRootFromParent_Done,
     /* 2321370 */   // Label 33707: @2321370
     /* 2321370 */   GIM_Reject,
     /* 2321371 */ // Label 33699: @2321371
     /* 2321371 */ GIM_Reject,
     /* 2321372 */ // Label 33665: @2321372
     /* 2321372 */ GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2322004),
     /* 2321377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2321383 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2321466), // Rule ID 45016 //
     /* 2321388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2321391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2321420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2321424 */     // MIs[1] Operand 1
     /* 2321424 */     // No operand predicates
     /* 2321424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321428 */     // MIs[0] policy
     /* 2321428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321440 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2321443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2321452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321465 */     // GIR_Coverage, 45016,
     /* 2321465 */     GIR_EraseRootFromParent_Done,
     /* 2321466 */   // Label 33709: @2321466
     /* 2321466 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2321549), // Rule ID 45017 //
     /* 2321471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2321474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2321503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2321507 */     // MIs[1] Operand 1
     /* 2321507 */     // No operand predicates
     /* 2321507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321511 */     // MIs[0] policy
     /* 2321511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321523 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2321526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2321535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321548 */     // GIR_Coverage, 45017,
     /* 2321548 */     GIR_EraseRootFromParent_Done,
     /* 2321549 */   // Label 33710: @2321549
     /* 2321549 */   GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2321632), // Rule ID 45088 //
     /* 2321554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2321557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2321586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2321590 */     // MIs[1] Operand 1
     /* 2321590 */     // No operand predicates
     /* 2321590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321594 */     // MIs[0] policy
     /* 2321594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321606 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2321609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2321618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321631 */     // GIR_Coverage, 45088,
     /* 2321631 */     GIR_EraseRootFromParent_Done,
     /* 2321632 */   // Label 33711: @2321632
     /* 2321632 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2321715), // Rule ID 45089 //
     /* 2321637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2321640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2321669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2321673 */     // MIs[1] Operand 1
     /* 2321673 */     // No operand predicates
     /* 2321673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321677 */     // MIs[0] policy
     /* 2321677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321689 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2321692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2321701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321714 */     // GIR_Coverage, 45089,
     /* 2321714 */     GIR_EraseRootFromParent_Done,
     /* 2321715 */   // Label 33712: @2321715
     /* 2321715 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2321787), // Rule ID 45018 //
     /* 2321720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2321723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321752 */     // MIs[0] policy
     /* 2321752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321762 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2321765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321786 */     // GIR_Coverage, 45018,
     /* 2321786 */     GIR_EraseRootFromParent_Done,
     /* 2321787 */   // Label 33713: @2321787
     /* 2321787 */   GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2321859), // Rule ID 45019 //
     /* 2321792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2321795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321824 */     // MIs[0] policy
     /* 2321824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321834 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2321837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321858 */     // GIR_Coverage, 45019,
     /* 2321858 */     GIR_EraseRootFromParent_Done,
     /* 2321859 */   // Label 33714: @2321859
     /* 2321859 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2321931), // Rule ID 45090 //
     /* 2321864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2321867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2321870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2321876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321896 */     // MIs[0] policy
     /* 2321896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321906 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2321906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2321909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2321929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321930 */     // GIR_Coverage, 45090,
     /* 2321930 */     GIR_EraseRootFromParent_Done,
     /* 2321931 */   // Label 33715: @2321931
     /* 2321931 */   GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2322003), // Rule ID 45091 //
     /* 2321936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2321939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2321942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2321945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2321948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2321952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2321968 */     // MIs[0] policy
     /* 2321968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2321971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2321978 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2321978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2321981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2321987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2321991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2321996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322002 */     // GIR_Coverage, 45091,
     /* 2322002 */     GIR_EraseRootFromParent_Done,
     /* 2322003 */   // Label 33716: @2322003
     /* 2322003 */   GIM_Reject,
     /* 2322004 */ // Label 33708: @2322004
     /* 2322004 */ GIM_Reject,
     /* 2322005 */ // Label 33666: @2322005
     /* 2322005 */ GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2322327),
     /* 2322010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2322013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2322016 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2322099), // Rule ID 44984 //
     /* 2322021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322057 */     // MIs[1] Operand 1
     /* 2322057 */     // No operand predicates
     /* 2322057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322061 */     // MIs[0] policy
     /* 2322061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322073 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2322076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322098 */     // GIR_Coverage, 44984,
     /* 2322098 */     GIR_EraseRootFromParent_Done,
     /* 2322099 */   // Label 33718: @2322099
     /* 2322099 */   GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2322182), // Rule ID 44985 //
     /* 2322104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322140 */     // MIs[1] Operand 1
     /* 2322140 */     // No operand predicates
     /* 2322140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322144 */     // MIs[0] policy
     /* 2322144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322156 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2322159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322181 */     // GIR_Coverage, 44985,
     /* 2322181 */     GIR_EraseRootFromParent_Done,
     /* 2322182 */   // Label 33719: @2322182
     /* 2322182 */   GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2322254), // Rule ID 44986 //
     /* 2322187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322219 */     // MIs[0] policy
     /* 2322219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322229 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2322232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322253 */     // GIR_Coverage, 44986,
     /* 2322253 */     GIR_EraseRootFromParent_Done,
     /* 2322254 */   // Label 33720: @2322254
     /* 2322254 */   GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2322326), // Rule ID 44987 //
     /* 2322259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322291 */     // MIs[0] policy
     /* 2322291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322301 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2322304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322325 */     // GIR_Coverage, 44987,
     /* 2322325 */     GIR_EraseRootFromParent_Done,
     /* 2322326 */   // Label 33721: @2322326
     /* 2322326 */   GIM_Reject,
     /* 2322327 */ // Label 33717: @2322327
     /* 2322327 */ GIM_Reject,
     /* 2322328 */ // Label 33667: @2322328
     /* 2322328 */ GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2322960),
     /* 2322333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2322339 */   GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2322422), // Rule ID 44996 //
     /* 2322344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322380 */     // MIs[1] Operand 1
     /* 2322380 */     // No operand predicates
     /* 2322380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322384 */     // MIs[0] policy
     /* 2322384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322396 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2322399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322421 */     // GIR_Coverage, 44996,
     /* 2322421 */     GIR_EraseRootFromParent_Done,
     /* 2322422 */   // Label 33723: @2322422
     /* 2322422 */   GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2322505), // Rule ID 44997 //
     /* 2322427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322463 */     // MIs[1] Operand 1
     /* 2322463 */     // No operand predicates
     /* 2322463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322467 */     // MIs[0] policy
     /* 2322467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322479 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2322482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322504 */     // GIR_Coverage, 44997,
     /* 2322504 */     GIR_EraseRootFromParent_Done,
     /* 2322505 */   // Label 33724: @2322505
     /* 2322505 */   GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2322588), // Rule ID 45072 //
     /* 2322510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322546 */     // MIs[1] Operand 1
     /* 2322546 */     // No operand predicates
     /* 2322546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322550 */     // MIs[0] policy
     /* 2322550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322562 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2322565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322587 */     // GIR_Coverage, 45072,
     /* 2322587 */     GIR_EraseRootFromParent_Done,
     /* 2322588 */   // Label 33725: @2322588
     /* 2322588 */   GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2322671), // Rule ID 45073 //
     /* 2322593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2322625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2322629 */     // MIs[1] Operand 1
     /* 2322629 */     // No operand predicates
     /* 2322629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322633 */     // MIs[0] policy
     /* 2322633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322645 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2322648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2322657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322670 */     // GIR_Coverage, 45073,
     /* 2322670 */     GIR_EraseRootFromParent_Done,
     /* 2322671 */   // Label 33726: @2322671
     /* 2322671 */   GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2322743), // Rule ID 44998 //
     /* 2322676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322708 */     // MIs[0] policy
     /* 2322708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322718 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2322721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322742 */     // GIR_Coverage, 44998,
     /* 2322742 */     GIR_EraseRootFromParent_Done,
     /* 2322743 */   // Label 33727: @2322743
     /* 2322743 */   GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2322815), // Rule ID 44999 //
     /* 2322748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322780 */     // MIs[0] policy
     /* 2322780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322790 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2322793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322814 */     // GIR_Coverage, 44999,
     /* 2322814 */     GIR_EraseRootFromParent_Done,
     /* 2322815 */   // Label 33728: @2322815
     /* 2322815 */   GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2322887), // Rule ID 45074 //
     /* 2322820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322852 */     // MIs[0] policy
     /* 2322852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322862 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2322862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2322865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322886 */     // GIR_Coverage, 45074,
     /* 2322886 */     GIR_EraseRootFromParent_Done,
     /* 2322887 */   // Label 33729: @2322887
     /* 2322887 */   GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2322959), // Rule ID 45075 //
     /* 2322892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2322895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2322898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2322904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2322924 */     // MIs[0] policy
     /* 2322924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2322927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2322934 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2322934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2322937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2322943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2322947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2322952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2322957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322958 */     // GIR_Coverage, 45075,
     /* 2322958 */     GIR_EraseRootFromParent_Done,
     /* 2322959 */   // Label 33730: @2322959
     /* 2322959 */   GIM_Reject,
     /* 2322960 */ // Label 33722: @2322960
     /* 2322960 */ GIM_Reject,
     /* 2322961 */ // Label 33668: @2322961
     /* 2322961 */ GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2323593),
     /* 2322966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2322972 */   GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2323055), // Rule ID 45012 //
     /* 2322977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2322980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2322983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2322986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2322989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2322993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323013 */     // MIs[1] Operand 1
     /* 2323013 */     // No operand predicates
     /* 2323013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323017 */     // MIs[0] policy
     /* 2323017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323029 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2323032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323054 */     // GIR_Coverage, 45012,
     /* 2323054 */     GIR_EraseRootFromParent_Done,
     /* 2323055 */   // Label 33732: @2323055
     /* 2323055 */   GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2323138), // Rule ID 45013 //
     /* 2323060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2323063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323096 */     // MIs[1] Operand 1
     /* 2323096 */     // No operand predicates
     /* 2323096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323100 */     // MIs[0] policy
     /* 2323100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323112 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2323115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323137 */     // GIR_Coverage, 45013,
     /* 2323137 */     GIR_EraseRootFromParent_Done,
     /* 2323138 */   // Label 33733: @2323138
     /* 2323138 */   GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2323221), // Rule ID 45084 //
     /* 2323143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2323146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323179 */     // MIs[1] Operand 1
     /* 2323179 */     // No operand predicates
     /* 2323179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323183 */     // MIs[0] policy
     /* 2323183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323195 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2323198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323220 */     // GIR_Coverage, 45084,
     /* 2323220 */     GIR_EraseRootFromParent_Done,
     /* 2323221 */   // Label 33734: @2323221
     /* 2323221 */   GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2323304), // Rule ID 45085 //
     /* 2323226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2323229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323262 */     // MIs[1] Operand 1
     /* 2323262 */     // No operand predicates
     /* 2323262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323266 */     // MIs[0] policy
     /* 2323266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323278 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2323281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323303 */     // GIR_Coverage, 45085,
     /* 2323303 */     GIR_EraseRootFromParent_Done,
     /* 2323304 */   // Label 33735: @2323304
     /* 2323304 */   GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2323376), // Rule ID 45014 //
     /* 2323309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2323312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323341 */     // MIs[0] policy
     /* 2323341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323351 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2323354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323375 */     // GIR_Coverage, 45014,
     /* 2323375 */     GIR_EraseRootFromParent_Done,
     /* 2323376 */   // Label 33736: @2323376
     /* 2323376 */   GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2323448), // Rule ID 45015 //
     /* 2323381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2323384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323413 */     // MIs[0] policy
     /* 2323413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323423 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2323426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323447 */     // GIR_Coverage, 45015,
     /* 2323447 */     GIR_EraseRootFromParent_Done,
     /* 2323448 */   // Label 33737: @2323448
     /* 2323448 */   GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2323520), // Rule ID 45086 //
     /* 2323453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2323456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323485 */     // MIs[0] policy
     /* 2323485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323495 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2323498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323519 */     // GIR_Coverage, 45086,
     /* 2323519 */     GIR_EraseRootFromParent_Done,
     /* 2323520 */   // Label 33738: @2323520
     /* 2323520 */   GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2323592), // Rule ID 45087 //
     /* 2323525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2323528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2323541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323557 */     // MIs[0] policy
     /* 2323557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323567 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2323570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323578 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323591 */     // GIR_Coverage, 45087,
     /* 2323591 */     GIR_EraseRootFromParent_Done,
     /* 2323592 */   // Label 33739: @2323592
     /* 2323592 */   GIM_Reject,
     /* 2323593 */ // Label 33731: @2323593
     /* 2323593 */ GIM_Reject,
     /* 2323594 */ // Label 33669: @2323594
     /* 2323594 */ GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2324226),
     /* 2323599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2323605 */   GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2323688), // Rule ID 45056 //
     /* 2323610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2323613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2323626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323646 */     // MIs[1] Operand 1
     /* 2323646 */     // No operand predicates
     /* 2323646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323650 */     // MIs[0] policy
     /* 2323650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323662 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2323665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323687 */     // GIR_Coverage, 45056,
     /* 2323687 */     GIR_EraseRootFromParent_Done,
     /* 2323688 */   // Label 33741: @2323688
     /* 2323688 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2323771), // Rule ID 45057 //
     /* 2323693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2323696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2323709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323729 */     // MIs[1] Operand 1
     /* 2323729 */     // No operand predicates
     /* 2323729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323733 */     // MIs[0] policy
     /* 2323733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323745 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2323748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323770 */     // GIR_Coverage, 45057,
     /* 2323770 */     GIR_EraseRootFromParent_Done,
     /* 2323771 */   // Label 33742: @2323771
     /* 2323771 */   GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2323854), // Rule ID 45116 //
     /* 2323776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2323779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2323792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323812 */     // MIs[1] Operand 1
     /* 2323812 */     // No operand predicates
     /* 2323812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323816 */     // MIs[0] policy
     /* 2323816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323828 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2323831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323853 */     // GIR_Coverage, 45116,
     /* 2323853 */     GIR_EraseRootFromParent_Done,
     /* 2323854 */   // Label 33743: @2323854
     /* 2323854 */   GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2323937), // Rule ID 45117 //
     /* 2323859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2323862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2323865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2323871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2323875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2323891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2323895 */     // MIs[1] Operand 1
     /* 2323895 */     // No operand predicates
     /* 2323895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323899 */     // MIs[0] policy
     /* 2323899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323911 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2323911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2323914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2323923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2323930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2323935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323936 */     // GIR_Coverage, 45117,
     /* 2323936 */     GIR_EraseRootFromParent_Done,
     /* 2323937 */   // Label 33744: @2323937
     /* 2323937 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2324009), // Rule ID 45058 //
     /* 2323942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2323945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2323948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2323951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2323954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2323958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2323974 */     // MIs[0] policy
     /* 2323974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2323977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2323984 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2323984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2323987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2323993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2323997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324008 */     // GIR_Coverage, 45058,
     /* 2324008 */     GIR_EraseRootFromParent_Done,
     /* 2324009 */   // Label 33745: @2324009
     /* 2324009 */   GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2324081), // Rule ID 45059 //
     /* 2324014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2324017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2324023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2324030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324046 */     // MIs[0] policy
     /* 2324046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324056 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2324059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324080 */     // GIR_Coverage, 45059,
     /* 2324080 */     GIR_EraseRootFromParent_Done,
     /* 2324081 */   // Label 33746: @2324081
     /* 2324081 */   GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2324153), // Rule ID 45118 //
     /* 2324086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2324089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2324095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2324102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324118 */     // MIs[0] policy
     /* 2324118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324128 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2324131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324152 */     // GIR_Coverage, 45118,
     /* 2324152 */     GIR_EraseRootFromParent_Done,
     /* 2324153 */   // Label 33747: @2324153
     /* 2324153 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2324225), // Rule ID 45119 //
     /* 2324158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2324161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2324167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2324174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324190 */     // MIs[0] policy
     /* 2324190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324200 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2324203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324224 */     // GIR_Coverage, 45119,
     /* 2324224 */     GIR_EraseRootFromParent_Done,
     /* 2324225 */   // Label 33748: @2324225
     /* 2324225 */   GIM_Reject,
     /* 2324226 */ // Label 33740: @2324226
     /* 2324226 */ GIM_Reject,
     /* 2324227 */ // Label 33670: @2324227
     /* 2324227 */ GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2324549),
     /* 2324232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2324235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2324238 */   GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2324321), // Rule ID 44988 //
     /* 2324243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2324246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324279 */     // MIs[1] Operand 1
     /* 2324279 */     // No operand predicates
     /* 2324279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324283 */     // MIs[0] policy
     /* 2324283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324295 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2324298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324320 */     // GIR_Coverage, 44988,
     /* 2324320 */     GIR_EraseRootFromParent_Done,
     /* 2324321 */   // Label 33750: @2324321
     /* 2324321 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2324404), // Rule ID 44989 //
     /* 2324326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2324329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324362 */     // MIs[1] Operand 1
     /* 2324362 */     // No operand predicates
     /* 2324362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324366 */     // MIs[0] policy
     /* 2324366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324378 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2324381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324403 */     // GIR_Coverage, 44989,
     /* 2324403 */     GIR_EraseRootFromParent_Done,
     /* 2324404 */   // Label 33751: @2324404
     /* 2324404 */   GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2324476), // Rule ID 44990 //
     /* 2324409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2324412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324441 */     // MIs[0] policy
     /* 2324441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324451 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2324454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324475 */     // GIR_Coverage, 44990,
     /* 2324475 */     GIR_EraseRootFromParent_Done,
     /* 2324476 */   // Label 33752: @2324476
     /* 2324476 */   GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2324548), // Rule ID 44991 //
     /* 2324481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2324484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324513 */     // MIs[0] policy
     /* 2324513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324523 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2324526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324547 */     // GIR_Coverage, 44991,
     /* 2324547 */     GIR_EraseRootFromParent_Done,
     /* 2324548 */   // Label 33753: @2324548
     /* 2324548 */   GIM_Reject,
     /* 2324549 */ // Label 33749: @2324549
     /* 2324549 */ GIM_Reject,
     /* 2324550 */ // Label 33671: @2324550
     /* 2324550 */ GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2325182),
     /* 2324555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2324558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2324561 */   GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2324644), // Rule ID 45008 //
     /* 2324566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2324569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324602 */     // MIs[1] Operand 1
     /* 2324602 */     // No operand predicates
     /* 2324602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324606 */     // MIs[0] policy
     /* 2324606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324618 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2324621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324643 */     // GIR_Coverage, 45008,
     /* 2324643 */     GIR_EraseRootFromParent_Done,
     /* 2324644 */   // Label 33755: @2324644
     /* 2324644 */   GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2324727), // Rule ID 45009 //
     /* 2324649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2324652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324685 */     // MIs[1] Operand 1
     /* 2324685 */     // No operand predicates
     /* 2324685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324689 */     // MIs[0] policy
     /* 2324689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324701 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2324704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324726 */     // GIR_Coverage, 45009,
     /* 2324726 */     GIR_EraseRootFromParent_Done,
     /* 2324727 */   // Label 33756: @2324727
     /* 2324727 */   GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2324810), // Rule ID 45080 //
     /* 2324732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2324735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324768 */     // MIs[1] Operand 1
     /* 2324768 */     // No operand predicates
     /* 2324768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324772 */     // MIs[0] policy
     /* 2324772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324784 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2324787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324809 */     // GIR_Coverage, 45080,
     /* 2324809 */     GIR_EraseRootFromParent_Done,
     /* 2324810 */   // Label 33757: @2324810
     /* 2324810 */   GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2324893), // Rule ID 45081 //
     /* 2324815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2324818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2324847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2324851 */     // MIs[1] Operand 1
     /* 2324851 */     // No operand predicates
     /* 2324851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324855 */     // MIs[0] policy
     /* 2324855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324867 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2324867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2324870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2324879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324892 */     // GIR_Coverage, 45081,
     /* 2324892 */     GIR_EraseRootFromParent_Done,
     /* 2324893 */   // Label 33758: @2324893
     /* 2324893 */   GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2324965), // Rule ID 45010 //
     /* 2324898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2324901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2324904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2324910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2324930 */     // MIs[0] policy
     /* 2324930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2324933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2324940 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2324940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2324943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2324949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2324953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2324958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2324963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324964 */     // GIR_Coverage, 45010,
     /* 2324964 */     GIR_EraseRootFromParent_Done,
     /* 2324965 */   // Label 33759: @2324965
     /* 2324965 */   GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2325037), // Rule ID 45011 //
     /* 2324970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2324973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2324976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2324979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2324982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2324986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325002 */     // MIs[0] policy
     /* 2325002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325012 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2325015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325036 */     // GIR_Coverage, 45011,
     /* 2325036 */     GIR_EraseRootFromParent_Done,
     /* 2325037 */   // Label 33760: @2325037
     /* 2325037 */   GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2325109), // Rule ID 45082 //
     /* 2325042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2325045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2325058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325074 */     // MIs[0] policy
     /* 2325074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325084 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2325087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325108 */     // GIR_Coverage, 45082,
     /* 2325108 */     GIR_EraseRootFromParent_Done,
     /* 2325109 */   // Label 33761: @2325109
     /* 2325109 */   GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2325181), // Rule ID 45083 //
     /* 2325114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2325117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2325130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325146 */     // MIs[0] policy
     /* 2325146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325156 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2325159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325180 */     // GIR_Coverage, 45083,
     /* 2325180 */     GIR_EraseRootFromParent_Done,
     /* 2325181 */   // Label 33762: @2325181
     /* 2325181 */   GIM_Reject,
     /* 2325182 */ // Label 33754: @2325182
     /* 2325182 */ GIM_Reject,
     /* 2325183 */ // Label 33672: @2325183
     /* 2325183 */ GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2325815),
     /* 2325188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2325191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2325194 */   GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2325277), // Rule ID 45044 //
     /* 2325199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2325202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325235 */     // MIs[1] Operand 1
     /* 2325235 */     // No operand predicates
     /* 2325235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325239 */     // MIs[0] policy
     /* 2325239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325251 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2325254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325276 */     // GIR_Coverage, 45044,
     /* 2325276 */     GIR_EraseRootFromParent_Done,
     /* 2325277 */   // Label 33764: @2325277
     /* 2325277 */   GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2325360), // Rule ID 45045 //
     /* 2325282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2325285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325318 */     // MIs[1] Operand 1
     /* 2325318 */     // No operand predicates
     /* 2325318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325322 */     // MIs[0] policy
     /* 2325322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325334 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2325337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325359 */     // GIR_Coverage, 45045,
     /* 2325359 */     GIR_EraseRootFromParent_Done,
     /* 2325360 */   // Label 33765: @2325360
     /* 2325360 */   GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2325443), // Rule ID 45104 //
     /* 2325365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2325368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325401 */     // MIs[1] Operand 1
     /* 2325401 */     // No operand predicates
     /* 2325401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325405 */     // MIs[0] policy
     /* 2325405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325417 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2325420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325442 */     // GIR_Coverage, 45104,
     /* 2325442 */     GIR_EraseRootFromParent_Done,
     /* 2325443 */   // Label 33766: @2325443
     /* 2325443 */   GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2325526), // Rule ID 45105 //
     /* 2325448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2325451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325484 */     // MIs[1] Operand 1
     /* 2325484 */     // No operand predicates
     /* 2325484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325488 */     // MIs[0] policy
     /* 2325488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325500 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2325503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325525 */     // GIR_Coverage, 45105,
     /* 2325525 */     GIR_EraseRootFromParent_Done,
     /* 2325526 */   // Label 33767: @2325526
     /* 2325526 */   GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2325598), // Rule ID 45046 //
     /* 2325531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2325534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325563 */     // MIs[0] policy
     /* 2325563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325573 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2325576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325597 */     // GIR_Coverage, 45046,
     /* 2325597 */     GIR_EraseRootFromParent_Done,
     /* 2325598 */   // Label 33768: @2325598
     /* 2325598 */   GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2325670), // Rule ID 45047 //
     /* 2325603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2325606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325635 */     // MIs[0] policy
     /* 2325635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325645 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2325648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325669 */     // GIR_Coverage, 45047,
     /* 2325669 */     GIR_EraseRootFromParent_Done,
     /* 2325670 */   // Label 33769: @2325670
     /* 2325670 */   GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2325742), // Rule ID 45106 //
     /* 2325675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2325678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325707 */     // MIs[0] policy
     /* 2325707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325717 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2325720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325741 */     // GIR_Coverage, 45106,
     /* 2325741 */     GIR_EraseRootFromParent_Done,
     /* 2325742 */   // Label 33770: @2325742
     /* 2325742 */   GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2325814), // Rule ID 45107 //
     /* 2325747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2325750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2325763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325779 */     // MIs[0] policy
     /* 2325779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325789 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2325792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325813 */     // GIR_Coverage, 45107,
     /* 2325813 */     GIR_EraseRootFromParent_Done,
     /* 2325814 */   // Label 33771: @2325814
     /* 2325814 */   GIM_Reject,
     /* 2325815 */ // Label 33763: @2325815
     /* 2325815 */ GIM_Reject,
     /* 2325816 */ // Label 33673: @2325816
     /* 2325816 */ GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2326448),
     /* 2325821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2325824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2325827 */   GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2325910), // Rule ID 45060 //
     /* 2325832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2325835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2325838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2325844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2325848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325868 */     // MIs[1] Operand 1
     /* 2325868 */     // No operand predicates
     /* 2325868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325872 */     // MIs[0] policy
     /* 2325872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325884 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2325884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2325887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325909 */     // GIR_Coverage, 45060,
     /* 2325909 */     GIR_EraseRootFromParent_Done,
     /* 2325910 */   // Label 33773: @2325910
     /* 2325910 */   GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2325993), // Rule ID 45061 //
     /* 2325915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2325918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2325921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2325924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2325927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2325931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2325947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2325951 */     // MIs[1] Operand 1
     /* 2325951 */     // No operand predicates
     /* 2325951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2325955 */     // MIs[0] policy
     /* 2325955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2325958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2325967 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2325967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2325970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2325976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2325979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2325981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2325986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2325991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325992 */     // GIR_Coverage, 45061,
     /* 2325992 */     GIR_EraseRootFromParent_Done,
     /* 2325993 */   // Label 33774: @2325993
     /* 2325993 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2326076), // Rule ID 45120 //
     /* 2325998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2326001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326034 */     // MIs[1] Operand 1
     /* 2326034 */     // No operand predicates
     /* 2326034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326038 */     // MIs[0] policy
     /* 2326038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326050 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2326053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326075 */     // GIR_Coverage, 45120,
     /* 2326075 */     GIR_EraseRootFromParent_Done,
     /* 2326076 */   // Label 33775: @2326076
     /* 2326076 */   GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2326159), // Rule ID 45121 //
     /* 2326081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2326084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326117 */     // MIs[1] Operand 1
     /* 2326117 */     // No operand predicates
     /* 2326117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326121 */     // MIs[0] policy
     /* 2326121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326133 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2326136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326158 */     // GIR_Coverage, 45121,
     /* 2326158 */     GIR_EraseRootFromParent_Done,
     /* 2326159 */   // Label 33776: @2326159
     /* 2326159 */   GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2326231), // Rule ID 45062 //
     /* 2326164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2326167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326196 */     // MIs[0] policy
     /* 2326196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326206 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2326209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326230 */     // GIR_Coverage, 45062,
     /* 2326230 */     GIR_EraseRootFromParent_Done,
     /* 2326231 */   // Label 33777: @2326231
     /* 2326231 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2326303), // Rule ID 45063 //
     /* 2326236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2326239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326268 */     // MIs[0] policy
     /* 2326268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326278 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2326281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326302 */     // GIR_Coverage, 45063,
     /* 2326302 */     GIR_EraseRootFromParent_Done,
     /* 2326303 */   // Label 33778: @2326303
     /* 2326303 */   GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2326375), // Rule ID 45122 //
     /* 2326308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2326311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326340 */     // MIs[0] policy
     /* 2326340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326350 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2326353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326374 */     // GIR_Coverage, 45122,
     /* 2326374 */     GIR_EraseRootFromParent_Done,
     /* 2326375 */   // Label 33779: @2326375
     /* 2326375 */   GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2326447), // Rule ID 45123 //
     /* 2326380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2326383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2326389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2326396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326412 */     // MIs[0] policy
     /* 2326412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326422 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2326425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326446 */     // GIR_Coverage, 45123,
     /* 2326446 */     GIR_EraseRootFromParent_Done,
     /* 2326447 */   // Label 33780: @2326447
     /* 2326447 */   GIM_Reject,
     /* 2326448 */ // Label 33772: @2326448
     /* 2326448 */ GIM_Reject,
     /* 2326449 */ // Label 33674: @2326449
     /* 2326449 */ GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2326771),
     /* 2326454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2326457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2326460 */   GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2326543), // Rule ID 45004 //
     /* 2326465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2326468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2326481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326501 */     // MIs[1] Operand 1
     /* 2326501 */     // No operand predicates
     /* 2326501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326505 */     // MIs[0] policy
     /* 2326505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326517 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2326520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326542 */     // GIR_Coverage, 45004,
     /* 2326542 */     GIR_EraseRootFromParent_Done,
     /* 2326543 */   // Label 33782: @2326543
     /* 2326543 */   GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2326626), // Rule ID 45005 //
     /* 2326548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2326551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2326564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326584 */     // MIs[1] Operand 1
     /* 2326584 */     // No operand predicates
     /* 2326584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326588 */     // MIs[0] policy
     /* 2326588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326600 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2326603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326625 */     // GIR_Coverage, 45005,
     /* 2326625 */     GIR_EraseRootFromParent_Done,
     /* 2326626 */   // Label 33783: @2326626
     /* 2326626 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2326698), // Rule ID 45006 //
     /* 2326631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2326634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2326647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326663 */     // MIs[0] policy
     /* 2326663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326673 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2326676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326697 */     // GIR_Coverage, 45006,
     /* 2326697 */     GIR_EraseRootFromParent_Done,
     /* 2326698 */   // Label 33784: @2326698
     /* 2326698 */   GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2326770), // Rule ID 45007 //
     /* 2326703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2326706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2326719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326735 */     // MIs[0] policy
     /* 2326735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326745 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2326748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326769 */     // GIR_Coverage, 45007,
     /* 2326769 */     GIR_EraseRootFromParent_Done,
     /* 2326770 */   // Label 33785: @2326770
     /* 2326770 */   GIM_Reject,
     /* 2326771 */ // Label 33781: @2326771
     /* 2326771 */ GIM_Reject,
     /* 2326772 */ // Label 33675: @2326772
     /* 2326772 */ GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2327404),
     /* 2326777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2326780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2326783 */   GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2326866), // Rule ID 45032 //
     /* 2326788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2326791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2326804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326824 */     // MIs[1] Operand 1
     /* 2326824 */     // No operand predicates
     /* 2326824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326828 */     // MIs[0] policy
     /* 2326828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326840 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2326840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2326843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326865 */     // GIR_Coverage, 45032,
     /* 2326865 */     GIR_EraseRootFromParent_Done,
     /* 2326866 */   // Label 33787: @2326866
     /* 2326866 */   GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2326949), // Rule ID 45033 //
     /* 2326871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2326874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2326877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2326883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2326887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326907 */     // MIs[1] Operand 1
     /* 2326907 */     // No operand predicates
     /* 2326907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326911 */     // MIs[0] policy
     /* 2326911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2326923 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2326923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2326926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2326930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2326932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2326935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2326937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2326942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2326947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326948 */     // GIR_Coverage, 45033,
     /* 2326948 */     GIR_EraseRootFromParent_Done,
     /* 2326949 */   // Label 33788: @2326949
     /* 2326949 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2327032), // Rule ID 45092 //
     /* 2326954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2326957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2326960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2326963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2326966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2326970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2326986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2326990 */     // MIs[1] Operand 1
     /* 2326990 */     // No operand predicates
     /* 2326990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2326994 */     // MIs[0] policy
     /* 2326994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2326997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327006 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2327009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327031 */     // GIR_Coverage, 45092,
     /* 2327031 */     GIR_EraseRootFromParent_Done,
     /* 2327032 */   // Label 33789: @2327032
     /* 2327032 */   GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2327115), // Rule ID 45093 //
     /* 2327037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2327053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2327065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2327069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2327073 */     // MIs[1] Operand 1
     /* 2327073 */     // No operand predicates
     /* 2327073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327077 */     // MIs[0] policy
     /* 2327077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2327082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327089 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2327092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327114 */     // GIR_Coverage, 45093,
     /* 2327114 */     GIR_EraseRootFromParent_Done,
     /* 2327115 */   // Label 33790: @2327115
     /* 2327115 */   GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2327187), // Rule ID 45034 //
     /* 2327120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2327136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327152 */     // MIs[0] policy
     /* 2327152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327162 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2327165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327186 */     // GIR_Coverage, 45034,
     /* 2327186 */     GIR_EraseRootFromParent_Done,
     /* 2327187 */   // Label 33791: @2327187
     /* 2327187 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2327259), // Rule ID 45035 //
     /* 2327192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2327208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327224 */     // MIs[0] policy
     /* 2327224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327234 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2327237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327258 */     // GIR_Coverage, 45035,
     /* 2327258 */     GIR_EraseRootFromParent_Done,
     /* 2327259 */   // Label 33792: @2327259
     /* 2327259 */   GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2327331), // Rule ID 45094 //
     /* 2327264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2327280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327296 */     // MIs[0] policy
     /* 2327296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327306 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2327309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327330 */     // GIR_Coverage, 45094,
     /* 2327330 */     GIR_EraseRootFromParent_Done,
     /* 2327331 */   // Label 33793: @2327331
     /* 2327331 */   GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2327403), // Rule ID 45095 //
     /* 2327336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2327352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327368 */     // MIs[0] policy
     /* 2327368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327378 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2327381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327402 */     // GIR_Coverage, 45095,
     /* 2327402 */     GIR_EraseRootFromParent_Done,
     /* 2327403 */   // Label 33794: @2327403
     /* 2327403 */   GIM_Reject,
     /* 2327404 */ // Label 33786: @2327404
     /* 2327404 */ GIM_Reject,
     /* 2327405 */ // Label 33676: @2327405
     /* 2327405 */ GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2328037),
     /* 2327410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2327413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2327416 */   GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2327499), // Rule ID 45048 //
     /* 2327421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2327449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2327453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2327457 */     // MIs[1] Operand 1
     /* 2327457 */     // No operand predicates
     /* 2327457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327461 */     // MIs[0] policy
     /* 2327461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2327466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327473 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2327476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327498 */     // GIR_Coverage, 45048,
     /* 2327498 */     GIR_EraseRootFromParent_Done,
     /* 2327499 */   // Label 33796: @2327499
     /* 2327499 */   GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2327582), // Rule ID 45049 //
     /* 2327504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2327532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2327536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2327540 */     // MIs[1] Operand 1
     /* 2327540 */     // No operand predicates
     /* 2327540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327544 */     // MIs[0] policy
     /* 2327544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2327549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327556 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2327559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327581 */     // GIR_Coverage, 45049,
     /* 2327581 */     GIR_EraseRootFromParent_Done,
     /* 2327582 */   // Label 33797: @2327582
     /* 2327582 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2327665), // Rule ID 45108 //
     /* 2327587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2327615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2327619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2327623 */     // MIs[1] Operand 1
     /* 2327623 */     // No operand predicates
     /* 2327623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327627 */     // MIs[0] policy
     /* 2327627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2327632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327639 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2327642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327664 */     // GIR_Coverage, 45108,
     /* 2327664 */     GIR_EraseRootFromParent_Done,
     /* 2327665 */   // Label 33798: @2327665
     /* 2327665 */   GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2327748), // Rule ID 45109 //
     /* 2327670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2327698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2327702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2327706 */     // MIs[1] Operand 1
     /* 2327706 */     // No operand predicates
     /* 2327706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327710 */     // MIs[0] policy
     /* 2327710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2327715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327722 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2327725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2327734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327747 */     // GIR_Coverage, 45109,
     /* 2327747 */     GIR_EraseRootFromParent_Done,
     /* 2327748 */   // Label 33799: @2327748
     /* 2327748 */   GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2327820), // Rule ID 45050 //
     /* 2327753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327785 */     // MIs[0] policy
     /* 2327785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327795 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2327798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327819 */     // GIR_Coverage, 45050,
     /* 2327819 */     GIR_EraseRootFromParent_Done,
     /* 2327820 */   // Label 33800: @2327820
     /* 2327820 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2327892), // Rule ID 45051 //
     /* 2327825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327857 */     // MIs[0] policy
     /* 2327857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327867 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2327867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2327870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327891 */     // GIR_Coverage, 45051,
     /* 2327891 */     GIR_EraseRootFromParent_Done,
     /* 2327892 */   // Label 33801: @2327892
     /* 2327892 */   GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2327964), // Rule ID 45110 //
     /* 2327897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2327900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2327903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2327909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2327929 */     // MIs[0] policy
     /* 2327929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2327932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2327939 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2327939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2327942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2327946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2327948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2327950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2327952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2327957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2327962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327963 */     // GIR_Coverage, 45110,
     /* 2327963 */     GIR_EraseRootFromParent_Done,
     /* 2327964 */   // Label 33802: @2327964
     /* 2327964 */   GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2328036), // Rule ID 45111 //
     /* 2327969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2327972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2327975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2327978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2327981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2327985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328001 */     // MIs[0] policy
     /* 2328001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328011 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2328014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328035 */     // GIR_Coverage, 45111,
     /* 2328035 */     GIR_EraseRootFromParent_Done,
     /* 2328036 */   // Label 33803: @2328036
     /* 2328036 */   GIM_Reject,
     /* 2328037 */ // Label 33795: @2328037
     /* 2328037 */ GIM_Reject,
     /* 2328038 */ // Label 33677: @2328038
     /* 2328038 */ GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2328670),
     /* 2328043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2328046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2328049 */   GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2328132), // Rule ID 45064 //
     /* 2328054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2328057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328090 */     // MIs[1] Operand 1
     /* 2328090 */     // No operand predicates
     /* 2328090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328094 */     // MIs[0] policy
     /* 2328094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328106 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2328109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328131 */     // GIR_Coverage, 45064,
     /* 2328131 */     GIR_EraseRootFromParent_Done,
     /* 2328132 */   // Label 33805: @2328132
     /* 2328132 */   GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2328215), // Rule ID 45065 //
     /* 2328137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2328140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328173 */     // MIs[1] Operand 1
     /* 2328173 */     // No operand predicates
     /* 2328173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328177 */     // MIs[0] policy
     /* 2328177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328189 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2328192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328214 */     // GIR_Coverage, 45065,
     /* 2328214 */     GIR_EraseRootFromParent_Done,
     /* 2328215 */   // Label 33806: @2328215
     /* 2328215 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2328298), // Rule ID 45124 //
     /* 2328220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2328223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328256 */     // MIs[1] Operand 1
     /* 2328256 */     // No operand predicates
     /* 2328256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328260 */     // MIs[0] policy
     /* 2328260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328272 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2328275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328297 */     // GIR_Coverage, 45124,
     /* 2328297 */     GIR_EraseRootFromParent_Done,
     /* 2328298 */   // Label 33807: @2328298
     /* 2328298 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2328381), // Rule ID 45125 //
     /* 2328303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2328306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328339 */     // MIs[1] Operand 1
     /* 2328339 */     // No operand predicates
     /* 2328339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328343 */     // MIs[0] policy
     /* 2328343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328355 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2328358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328380 */     // GIR_Coverage, 45125,
     /* 2328380 */     GIR_EraseRootFromParent_Done,
     /* 2328381 */   // Label 33808: @2328381
     /* 2328381 */   GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2328453), // Rule ID 45066 //
     /* 2328386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2328389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328418 */     // MIs[0] policy
     /* 2328418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328428 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2328431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328452 */     // GIR_Coverage, 45066,
     /* 2328452 */     GIR_EraseRootFromParent_Done,
     /* 2328453 */   // Label 33809: @2328453
     /* 2328453 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2328525), // Rule ID 45067 //
     /* 2328458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2328461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328490 */     // MIs[0] policy
     /* 2328490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328500 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2328503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328524 */     // GIR_Coverage, 45067,
     /* 2328524 */     GIR_EraseRootFromParent_Done,
     /* 2328525 */   // Label 33810: @2328525
     /* 2328525 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2328597), // Rule ID 45126 //
     /* 2328530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2328533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328562 */     // MIs[0] policy
     /* 2328562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328572 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2328575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328596 */     // GIR_Coverage, 45126,
     /* 2328596 */     GIR_EraseRootFromParent_Done,
     /* 2328597 */   // Label 33811: @2328597
     /* 2328597 */   GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2328669), // Rule ID 45127 //
     /* 2328602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2328605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2328611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2328618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328634 */     // MIs[0] policy
     /* 2328634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328644 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2328647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328668 */     // GIR_Coverage, 45127,
     /* 2328668 */     GIR_EraseRootFromParent_Done,
     /* 2328669 */   // Label 33812: @2328669
     /* 2328669 */   GIM_Reject,
     /* 2328670 */ // Label 33804: @2328670
     /* 2328670 */ GIM_Reject,
     /* 2328671 */ // Label 33678: @2328671
     /* 2328671 */ GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2328993),
     /* 2328676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2328679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2328682 */   GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2328765), // Rule ID 45020 //
     /* 2328687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2328690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2328696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2328703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328723 */     // MIs[1] Operand 1
     /* 2328723 */     // No operand predicates
     /* 2328723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328727 */     // MIs[0] policy
     /* 2328727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328739 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2328742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328764 */     // GIR_Coverage, 45020,
     /* 2328764 */     GIR_EraseRootFromParent_Done,
     /* 2328765 */   // Label 33814: @2328765
     /* 2328765 */   GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2328848), // Rule ID 45021 //
     /* 2328770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2328773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2328779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2328786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2328798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2328806 */     // MIs[1] Operand 1
     /* 2328806 */     // No operand predicates
     /* 2328806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328810 */     // MIs[0] policy
     /* 2328810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328822 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2328825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2328834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328847 */     // GIR_Coverage, 45021,
     /* 2328847 */     GIR_EraseRootFromParent_Done,
     /* 2328848 */   // Label 33815: @2328848
     /* 2328848 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2328920), // Rule ID 45022 //
     /* 2328853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2328856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2328859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2328862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2328865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2328869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328885 */     // MIs[0] policy
     /* 2328885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328895 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2328895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2328898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328919 */     // GIR_Coverage, 45022,
     /* 2328919 */     GIR_EraseRootFromParent_Done,
     /* 2328920 */   // Label 33816: @2328920
     /* 2328920 */   GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2328992), // Rule ID 45023 //
     /* 2328925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2328928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2328931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2328934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2328937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2328941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2328957 */     // MIs[0] policy
     /* 2328957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2328960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2328967 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2328967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2328970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2328974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2328976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2328978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2328980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2328985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2328990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328991 */     // GIR_Coverage, 45023,
     /* 2328991 */     GIR_EraseRootFromParent_Done,
     /* 2328992 */   // Label 33817: @2328992
     /* 2328992 */   GIM_Reject,
     /* 2328993 */ // Label 33813: @2328993
     /* 2328993 */ GIM_Reject,
     /* 2328994 */ // Label 33679: @2328994
     /* 2328994 */ GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2329626),
     /* 2328999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2329002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2329005 */   GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2329088), // Rule ID 45036 //
     /* 2329010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329046 */     // MIs[1] Operand 1
     /* 2329046 */     // No operand predicates
     /* 2329046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329050 */     // MIs[0] policy
     /* 2329050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329062 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2329065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329087 */     // GIR_Coverage, 45036,
     /* 2329087 */     GIR_EraseRootFromParent_Done,
     /* 2329088 */   // Label 33819: @2329088
     /* 2329088 */   GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2329171), // Rule ID 45037 //
     /* 2329093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329129 */     // MIs[1] Operand 1
     /* 2329129 */     // No operand predicates
     /* 2329129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329133 */     // MIs[0] policy
     /* 2329133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329145 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2329148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329170 */     // GIR_Coverage, 45037,
     /* 2329170 */     GIR_EraseRootFromParent_Done,
     /* 2329171 */   // Label 33820: @2329171
     /* 2329171 */   GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2329254), // Rule ID 45096 //
     /* 2329176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329212 */     // MIs[1] Operand 1
     /* 2329212 */     // No operand predicates
     /* 2329212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329216 */     // MIs[0] policy
     /* 2329216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329228 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2329231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329253 */     // GIR_Coverage, 45096,
     /* 2329253 */     GIR_EraseRootFromParent_Done,
     /* 2329254 */   // Label 33821: @2329254
     /* 2329254 */   GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2329337), // Rule ID 45097 //
     /* 2329259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329295 */     // MIs[1] Operand 1
     /* 2329295 */     // No operand predicates
     /* 2329295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329299 */     // MIs[0] policy
     /* 2329299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329311 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2329314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329336 */     // GIR_Coverage, 45097,
     /* 2329336 */     GIR_EraseRootFromParent_Done,
     /* 2329337 */   // Label 33822: @2329337
     /* 2329337 */   GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2329409), // Rule ID 45038 //
     /* 2329342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329374 */     // MIs[0] policy
     /* 2329374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329384 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2329387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2329395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329408 */     // GIR_Coverage, 45038,
     /* 2329408 */     GIR_EraseRootFromParent_Done,
     /* 2329409 */   // Label 33823: @2329409
     /* 2329409 */   GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2329481), // Rule ID 45039 //
     /* 2329414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329446 */     // MIs[0] policy
     /* 2329446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329456 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2329459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2329467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329480 */     // GIR_Coverage, 45039,
     /* 2329480 */     GIR_EraseRootFromParent_Done,
     /* 2329481 */   // Label 33824: @2329481
     /* 2329481 */   GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2329553), // Rule ID 45098 //
     /* 2329486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329518 */     // MIs[0] policy
     /* 2329518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329528 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2329531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2329539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329552 */     // GIR_Coverage, 45098,
     /* 2329552 */     GIR_EraseRootFromParent_Done,
     /* 2329553 */   // Label 33825: @2329553
     /* 2329553 */   GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2329625), // Rule ID 45099 //
     /* 2329558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2329574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329590 */     // MIs[0] policy
     /* 2329590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329600 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2329603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2329611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329624 */     // GIR_Coverage, 45099,
     /* 2329624 */     GIR_EraseRootFromParent_Done,
     /* 2329625 */   // Label 33826: @2329625
     /* 2329625 */   GIM_Reject,
     /* 2329626 */ // Label 33818: @2329626
     /* 2329626 */ GIM_Reject,
     /* 2329627 */ // Label 33680: @2329627
     /* 2329627 */ GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2330259),
     /* 2329632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2329635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2329638 */   GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2329721), // Rule ID 45052 //
     /* 2329643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2329659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329679 */     // MIs[1] Operand 1
     /* 2329679 */     // No operand predicates
     /* 2329679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329683 */     // MIs[0] policy
     /* 2329683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329695 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2329698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329720 */     // GIR_Coverage, 45052,
     /* 2329720 */     GIR_EraseRootFromParent_Done,
     /* 2329721 */   // Label 33828: @2329721
     /* 2329721 */   GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2329804), // Rule ID 45053 //
     /* 2329726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2329742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329762 */     // MIs[1] Operand 1
     /* 2329762 */     // No operand predicates
     /* 2329762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329766 */     // MIs[0] policy
     /* 2329766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329778 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2329781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329803 */     // GIR_Coverage, 45053,
     /* 2329803 */     GIR_EraseRootFromParent_Done,
     /* 2329804 */   // Label 33829: @2329804
     /* 2329804 */   GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2329887), // Rule ID 45112 //
     /* 2329809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2329825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329845 */     // MIs[1] Operand 1
     /* 2329845 */     // No operand predicates
     /* 2329845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329849 */     // MIs[0] policy
     /* 2329849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329861 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2329861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2329864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329886 */     // GIR_Coverage, 45112,
     /* 2329886 */     GIR_EraseRootFromParent_Done,
     /* 2329887 */   // Label 33830: @2329887
     /* 2329887 */   GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2329970), // Rule ID 45113 //
     /* 2329892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2329895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2329898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2329904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2329908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2329920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2329924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2329928 */     // MIs[1] Operand 1
     /* 2329928 */     // No operand predicates
     /* 2329928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2329932 */     // MIs[0] policy
     /* 2329932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2329935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2329937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2329944 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2329944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2329947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2329951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2329953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2329956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2329958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2329963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2329968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329969 */     // GIR_Coverage, 45113,
     /* 2329969 */     GIR_EraseRootFromParent_Done,
     /* 2329970 */   // Label 33831: @2329970
     /* 2329970 */   GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2330042), // Rule ID 45054 //
     /* 2329975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2329978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2329981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2329984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2329987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2329991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330007 */     // MIs[0] policy
     /* 2330007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330017 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2330020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330041 */     // GIR_Coverage, 45054,
     /* 2330041 */     GIR_EraseRootFromParent_Done,
     /* 2330042 */   // Label 33832: @2330042
     /* 2330042 */   GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2330114), // Rule ID 45055 //
     /* 2330047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2330056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330079 */     // MIs[0] policy
     /* 2330079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330089 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2330092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330113 */     // GIR_Coverage, 45055,
     /* 2330113 */     GIR_EraseRootFromParent_Done,
     /* 2330114 */   // Label 33833: @2330114
     /* 2330114 */   GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2330186), // Rule ID 45114 //
     /* 2330119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2330128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330151 */     // MIs[0] policy
     /* 2330151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330161 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2330164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330185 */     // GIR_Coverage, 45114,
     /* 2330185 */     GIR_EraseRootFromParent_Done,
     /* 2330186 */   // Label 33834: @2330186
     /* 2330186 */   GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2330258), // Rule ID 45115 //
     /* 2330191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2330200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330223 */     // MIs[0] policy
     /* 2330223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330233 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2330236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330257 */     // GIR_Coverage, 45115,
     /* 2330257 */     GIR_EraseRootFromParent_Done,
     /* 2330258 */   // Label 33835: @2330258
     /* 2330258 */   GIM_Reject,
     /* 2330259 */ // Label 33827: @2330259
     /* 2330259 */ GIM_Reject,
     /* 2330260 */ // Label 33681: @2330260
     /* 2330260 */ GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2330582),
     /* 2330265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2330268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2330271 */   GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2330354), // Rule ID 45024 //
     /* 2330276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2330292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330312 */     // MIs[1] Operand 1
     /* 2330312 */     // No operand predicates
     /* 2330312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330316 */     // MIs[0] policy
     /* 2330316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330328 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2330331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330353 */     // GIR_Coverage, 45024,
     /* 2330353 */     GIR_EraseRootFromParent_Done,
     /* 2330354 */   // Label 33837: @2330354
     /* 2330354 */   GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2330437), // Rule ID 45025 //
     /* 2330359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2330375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330395 */     // MIs[1] Operand 1
     /* 2330395 */     // No operand predicates
     /* 2330395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330399 */     // MIs[0] policy
     /* 2330399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330411 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2330414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330436 */     // GIR_Coverage, 45025,
     /* 2330436 */     GIR_EraseRootFromParent_Done,
     /* 2330437 */   // Label 33838: @2330437
     /* 2330437 */   GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2330509), // Rule ID 45026 //
     /* 2330442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2330458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330474 */     // MIs[0] policy
     /* 2330474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330484 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2330487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330508 */     // GIR_Coverage, 45026,
     /* 2330508 */     GIR_EraseRootFromParent_Done,
     /* 2330509 */   // Label 33839: @2330509
     /* 2330509 */   GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2330581), // Rule ID 45027 //
     /* 2330514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2330530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330546 */     // MIs[0] policy
     /* 2330546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330556 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2330559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330580 */     // GIR_Coverage, 45027,
     /* 2330580 */     GIR_EraseRootFromParent_Done,
     /* 2330581 */   // Label 33840: @2330581
     /* 2330581 */   GIM_Reject,
     /* 2330582 */ // Label 33836: @2330582
     /* 2330582 */ GIM_Reject,
     /* 2330583 */ // Label 33682: @2330583
     /* 2330583 */ GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2331215),
     /* 2330588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2330591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2330594 */   GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2330677), // Rule ID 45040 //
     /* 2330599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330635 */     // MIs[1] Operand 1
     /* 2330635 */     // No operand predicates
     /* 2330635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330639 */     // MIs[0] policy
     /* 2330639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330651 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2330654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330676 */     // GIR_Coverage, 45040,
     /* 2330676 */     GIR_EraseRootFromParent_Done,
     /* 2330677 */   // Label 33842: @2330677
     /* 2330677 */   GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2330760), // Rule ID 45041 //
     /* 2330682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330718 */     // MIs[1] Operand 1
     /* 2330718 */     // No operand predicates
     /* 2330718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330722 */     // MIs[0] policy
     /* 2330722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330734 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2330737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330759 */     // GIR_Coverage, 45041,
     /* 2330759 */     GIR_EraseRootFromParent_Done,
     /* 2330760 */   // Label 33843: @2330760
     /* 2330760 */   GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2330843), // Rule ID 45100 //
     /* 2330765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330801 */     // MIs[1] Operand 1
     /* 2330801 */     // No operand predicates
     /* 2330801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330805 */     // MIs[0] policy
     /* 2330805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330817 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2330820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330842 */     // GIR_Coverage, 45100,
     /* 2330842 */     GIR_EraseRootFromParent_Done,
     /* 2330843 */   // Label 33844: @2330843
     /* 2330843 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2330926), // Rule ID 45101 //
     /* 2330848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2330851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2330854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2330860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2330876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2330880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2330884 */     // MIs[1] Operand 1
     /* 2330884 */     // No operand predicates
     /* 2330884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330888 */     // MIs[0] policy
     /* 2330888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330900 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2330900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2330903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2330912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330925 */     // GIR_Coverage, 45101,
     /* 2330925 */     GIR_EraseRootFromParent_Done,
     /* 2330926 */   // Label 33845: @2330926
     /* 2330926 */   GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2330998), // Rule ID 45042 //
     /* 2330931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2330934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2330937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2330940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2330943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2330947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2330963 */     // MIs[0] policy
     /* 2330963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2330966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2330973 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2330973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2330976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2330980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2330982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2330984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2330986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2330991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2330996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330997 */     // GIR_Coverage, 45042,
     /* 2330997 */     GIR_EraseRootFromParent_Done,
     /* 2330998 */   // Label 33846: @2330998
     /* 2330998 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2331070), // Rule ID 45043 //
     /* 2331003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2331006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2331009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2331012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2331015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331035 */     // MIs[0] policy
     /* 2331035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331045 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2331045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2331048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2331056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331069 */     // GIR_Coverage, 45043,
     /* 2331069 */     GIR_EraseRootFromParent_Done,
     /* 2331070 */   // Label 33847: @2331070
     /* 2331070 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2331142), // Rule ID 45102 //
     /* 2331075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2331078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2331081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2331084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2331087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331107 */     // MIs[0] policy
     /* 2331107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331117 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2331117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2331120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2331128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331141 */     // GIR_Coverage, 45102,
     /* 2331141 */     GIR_EraseRootFromParent_Done,
     /* 2331142 */   // Label 33848: @2331142
     /* 2331142 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2331214), // Rule ID 45103 //
     /* 2331147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2331150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2331153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2331156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2331159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331179 */     // MIs[0] policy
     /* 2331179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331189 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2331189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2331192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2331200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331213 */     // GIR_Coverage, 45103,
     /* 2331213 */     GIR_EraseRootFromParent_Done,
     /* 2331214 */   // Label 33849: @2331214
     /* 2331214 */   GIM_Reject,
     /* 2331215 */ // Label 33841: @2331215
     /* 2331215 */ GIM_Reject,
     /* 2331216 */ // Label 33683: @2331216
     /* 2331216 */ GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2331538),
     /* 2331221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2331224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2331227 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2331310), // Rule ID 45028 //
     /* 2331232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2331235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2331238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2331241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2331244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2331260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2331264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2331268 */     // MIs[1] Operand 1
     /* 2331268 */     // No operand predicates
     /* 2331268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331272 */     // MIs[0] policy
     /* 2331272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2331277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331284 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2331284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2331287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2331296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331309 */     // GIR_Coverage, 45028,
     /* 2331309 */     GIR_EraseRootFromParent_Done,
     /* 2331310 */   // Label 33851: @2331310
     /* 2331310 */   GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2331393), // Rule ID 45029 //
     /* 2331315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2331318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2331321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2331324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2331327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2331343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2331347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2331351 */     // MIs[1] Operand 1
     /* 2331351 */     // No operand predicates
     /* 2331351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331355 */     // MIs[0] policy
     /* 2331355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2331360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331367 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2331367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2331370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2331379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331392 */     // GIR_Coverage, 45029,
     /* 2331392 */     GIR_EraseRootFromParent_Done,
     /* 2331393 */   // Label 33852: @2331393
     /* 2331393 */   GIM_Try, /*On fail goto*//*Label 33853*/ GIMT_Encode4(2331465), // Rule ID 45030 //
     /* 2331398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2331401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2331404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2331407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2331410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331430 */     // MIs[0] policy
     /* 2331430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331440 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2331440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2331443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2331451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331464 */     // GIR_Coverage, 45030,
     /* 2331464 */     GIR_EraseRootFromParent_Done,
     /* 2331465 */   // Label 33853: @2331465
     /* 2331465 */   GIM_Try, /*On fail goto*//*Label 33854*/ GIMT_Encode4(2331537), // Rule ID 45031 //
     /* 2331470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2331473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2331476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2331479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2331482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2331486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2331502 */     // MIs[0] policy
     /* 2331502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2331505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2331512 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2331512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2331515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2331519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2331521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2331523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2331525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2331530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2331535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331536 */     // GIR_Coverage, 45031,
     /* 2331536 */     GIR_EraseRootFromParent_Done,
     /* 2331537 */   // Label 33854: @2331537
     /* 2331537 */   GIM_Reject,
     /* 2331538 */ // Label 33850: @2331538
     /* 2331538 */ GIM_Reject,
     /* 2331539 */ // Label 33684: @2331539
     /* 2331539 */ GIM_Reject,
     /* 2331540 */ // Label 121: @2331540
     /* 2331540 */ GIM_Reject,
     /* 2331541 */ }; // Size: 2331541 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
